Module["preRun"].push((function() {
 window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
 if (!window.indexedDB) return;
 FS.mkdir("/idbfs");
 FS.mount(IDBFS, {}, "/idbfs");
 Module.addRunDependency("JS_FileSystem_Mount");
 FS.syncfs(true, (function(err) {
  Module.removeRunDependency("JS_FileSystem_Mount");
 }));
}));
function SendMessage(gameObject, func, param) {
 if (param === undefined) Module.cwrap("SendMessage", "void", [ "string", "string" ])(gameObject, func); else if (typeof param === "string") Module.cwrap("SendMessageString", "void", [ "string", "string", "string" ])(gameObject, func, param); else if (typeof param === "number") Module.cwrap("SendMessageFloat", "void", [ "string", "string", "number" ])(gameObject, func, param); else throw "" + param + " is does not have a type which is supported by SendMessage.";
}
var Module;
if (!Module) Module = (typeof Module !== "undefined" ? Module : null) || {};
var moduleOverrides = {};
for (var key in Module) {
 if (Module.hasOwnProperty(key)) {
  moduleOverrides[key] = Module[key];
 }
}
var ENVIRONMENT_IS_NODE = typeof process === "object" && typeof require === "function";
var ENVIRONMENT_IS_WEB = typeof window === "object";
var ENVIRONMENT_IS_WORKER = typeof importScripts === "function";
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
if (ENVIRONMENT_IS_NODE) {
 if (!Module["print"]) Module["print"] = function print(x) {
  process["stdout"].write(x + "\n");
 };
 if (!Module["printErr"]) Module["printErr"] = function printErr(x) {
  process["stderr"].write(x + "\n");
 };
 var nodeFS = require("fs");
 var nodePath = require("path");
 Module["read"] = function read(filename, binary) {
  filename = nodePath["normalize"](filename);
  var ret = nodeFS["readFileSync"](filename);
  if (!ret && filename != nodePath["resolve"](filename)) {
   filename = path.join(__dirname, "..", "src", filename);
   ret = nodeFS["readFileSync"](filename);
  }
  if (ret && !binary) ret = ret.toString();
  return ret;
 };
 Module["readBinary"] = function readBinary(filename) {
  return Module["read"](filename, true);
 };
 Module["load"] = function load(f) {
  globalEval(read(f));
 };
 if (process["argv"].length > 1) {
  Module["thisProgram"] = process["argv"][1].replace(/\\/g, "/");
 } else {
  Module["thisProgram"] = "unknown-program";
 }
 Module["arguments"] = process["argv"].slice(2);
 if (typeof module !== "undefined") {
  module["exports"] = Module;
 }
 process["on"]("uncaughtException", (function(ex) {
  if (!(ex instanceof ExitStatus)) {
   throw ex;
  }
 }));
} else if (ENVIRONMENT_IS_SHELL) {
 if (!Module["print"]) Module["print"] = print;
 if (typeof printErr != "undefined") Module["printErr"] = printErr;
 if (typeof read != "undefined") {
  Module["read"] = read;
 } else {
  Module["read"] = function read() {
   throw "no read() available (jsc?)";
  };
 }
 Module["readBinary"] = function readBinary(f) {
  if (typeof readbuffer === "function") {
   return new Uint8Array(readbuffer(f));
  }
  var data = read(f, "binary");
  assert(typeof data === "object");
  return data;
 };
 if (typeof scriptArgs != "undefined") {
  Module["arguments"] = scriptArgs;
 } else if (typeof arguments != "undefined") {
  Module["arguments"] = arguments;
 }
 this["Module"] = Module;
} else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
 Module["read"] = function read(url) {
  var xhr = new XMLHttpRequest;
  xhr.open("GET", url, false);
  xhr.send(null);
  return xhr.responseText;
 };
 if (typeof arguments != "undefined") {
  Module["arguments"] = arguments;
 }
 if (typeof console !== "undefined") {
  if (!Module["print"]) Module["print"] = function print(x) {
   console.log(x);
  };
  if (!Module["printErr"]) Module["printErr"] = function printErr(x) {
   console.log(x);
  };
 } else {
  var TRY_USE_DUMP = false;
  if (!Module["print"]) Module["print"] = TRY_USE_DUMP && typeof dump !== "undefined" ? (function(x) {
   dump(x);
  }) : (function(x) {});
 }
 if (ENVIRONMENT_IS_WEB) {
  window["Module"] = Module;
 } else {
  Module["load"] = importScripts;
 }
} else {
 throw "Unknown runtime environment. Where are we?";
}
function globalEval(x) {
 eval.call(null, x);
}
if (!Module["load"] && Module["read"]) {
 Module["load"] = function load(f) {
  globalEval(Module["read"](f));
 };
}
if (!Module["print"]) {
 Module["print"] = (function() {});
}
if (!Module["printErr"]) {
 Module["printErr"] = Module["print"];
}
if (!Module["arguments"]) {
 Module["arguments"] = [];
}
if (!Module["thisProgram"]) {
 Module["thisProgram"] = "./this.program";
}
Module.print = Module["print"];
Module.printErr = Module["printErr"];
Module["preRun"] = [];
Module["postRun"] = [];
for (var key in moduleOverrides) {
 if (moduleOverrides.hasOwnProperty(key)) {
  Module[key] = moduleOverrides[key];
 }
}
var Runtime = {
 setTempRet0: (function(value) {
  tempRet0 = value;
 }),
 getTempRet0: (function() {
  return tempRet0;
 }),
 stackSave: (function() {
  return STACKTOP;
 }),
 stackRestore: (function(stackTop) {
  STACKTOP = stackTop;
 }),
 getNativeTypeSize: (function(type) {
  switch (type) {
  case "i1":
  case "i8":
   return 1;
  case "i16":
   return 2;
  case "i32":
   return 4;
  case "i64":
   return 8;
  case "float":
   return 4;
  case "double":
   return 8;
  default:
   {
    if (type[type.length - 1] === "*") {
     return Runtime.QUANTUM_SIZE;
    } else if (type[0] === "i") {
     var bits = parseInt(type.substr(1));
     assert(bits % 8 === 0);
     return bits / 8;
    } else {
     return 0;
    }
   }
  }
 }),
 getNativeFieldSize: (function(type) {
  return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
 }),
 STACK_ALIGN: 16,
 getAlignSize: (function(type, size, vararg) {
  if (!vararg && (type == "i64" || type == "double")) return 8;
  if (!type) return Math.min(size, 8);
  return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
 }),
 dynCall: (function(sig, ptr, args) {
  if (args && args.length) {
   if (!args.splice) args = Array.prototype.slice.call(args);
   args.splice(0, 0, ptr);
   return Module["dynCall_" + sig].apply(null, args);
  } else {
   return Module["dynCall_" + sig].call(null, ptr);
  }
 }),
 functionPointers: [],
 addFunction: (function(func) {
  for (var i = 0; i < Runtime.functionPointers.length; i++) {
   if (!Runtime.functionPointers[i]) {
    Runtime.functionPointers[i] = func;
    return 2 * (1 + i);
   }
  }
  throw "Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.";
 }),
 removeFunction: (function(index) {
  Runtime.functionPointers[(index - 2) / 2] = null;
 }),
 getAsmConst: (function(code, numArgs) {
  if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
  var func = Runtime.asmConstCache[code];
  if (func) return func;
  var args = [];
  for (var i = 0; i < numArgs; i++) {
   args.push(String.fromCharCode(36) + i);
  }
  var source = Pointer_stringify(code);
  if (source[0] === '"') {
   if (source.indexOf('"', 1) === source.length - 1) {
    source = source.substr(1, source.length - 2);
   } else {
    abort("invalid EM_ASM input |" + source + "|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)");
   }
  }
  try {
   var evalled = eval("(function(Module, FS) { return function(" + args.join(",") + "){ " + source + " } })")(Module, typeof FS !== "undefined" ? FS : null);
  } catch (e) {
   Module.printErr("error in executing inline EM_ASM code: " + e + " on: \n\n" + source + "\n\nwith args |" + args + "| (make sure to use the right one out of EM_ASM, EM_ASM_ARGS, etc.)");
   throw e;
  }
  return Runtime.asmConstCache[code] = evalled;
 }),
 warnOnce: (function(text) {
  if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
  if (!Runtime.warnOnce.shown[text]) {
   Runtime.warnOnce.shown[text] = 1;
   Module.printErr(text);
  }
 }),
 funcWrappers: {},
 getFuncWrapper: (function(func, sig) {
  assert(sig);
  if (!Runtime.funcWrappers[sig]) {
   Runtime.funcWrappers[sig] = {};
  }
  var sigCache = Runtime.funcWrappers[sig];
  if (!sigCache[func]) {
   sigCache[func] = function dynCall_wrapper() {
    return Runtime.dynCall(sig, func, arguments);
   };
  }
  return sigCache[func];
 }),
 getCompilerSetting: (function(name) {
  throw "You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work";
 }),
 stackAlloc: (function(size) {
  var ret = STACKTOP;
  STACKTOP = STACKTOP + size | 0;
  STACKTOP = STACKTOP + 15 & -16;
  return ret;
 }),
 staticAlloc: (function(size) {
  var ret = STATICTOP;
  STATICTOP = STATICTOP + size | 0;
  STATICTOP = STATICTOP + 15 & -16;
  return ret;
 }),
 dynamicAlloc: (function(size) {
  var ret = DYNAMICTOP;
  DYNAMICTOP = DYNAMICTOP + size | 0;
  DYNAMICTOP = DYNAMICTOP + 15 & -16;
  if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();
  return ret;
 }),
 alignMemory: (function(size, quantum) {
  var ret = size = Math.ceil(size / (quantum ? quantum : 16)) * (quantum ? quantum : 16);
  return ret;
 }),
 makeBigInt: (function(low, high, unsigned) {
  var ret = unsigned ? +(low >>> 0) + +(high >>> 0) * +4294967296 : +(low >>> 0) + +(high | 0) * +4294967296;
  return ret;
 }),
 GLOBAL_BASE: 8,
 QUANTUM_SIZE: 4,
 __dummy__: 0
};
Module["Runtime"] = Runtime;
var __THREW__ = 0;
var ABORT = false;
var EXITSTATUS = 0;
var undef = 0;
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;
function assert(condition, text) {
 if (!condition) {
  abort("Assertion failed: " + text);
 }
}
var globalScope = this;
function getCFunc(ident) {
 var func = Module["_" + ident];
 if (!func) {
  try {
   func = eval("_" + ident);
  } catch (e) {}
 }
 assert(func, "Cannot call unknown function " + ident + " (perhaps LLVM optimizations or closure removed it?)");
 return func;
}
var cwrap, ccall;
((function() {
 var JSfuncs = {
  "stackSave": (function() {
   Runtime.stackSave();
  }),
  "stackRestore": (function() {
   Runtime.stackRestore();
  }),
  "arrayToC": (function(arr) {
   var ret = Runtime.stackAlloc(arr.length);
   writeArrayToMemory(arr, ret);
   return ret;
  }),
  "stringToC": (function(str) {
   var ret = 0;
   if (str !== null && str !== undefined && str !== 0) {
    ret = Runtime.stackAlloc((str.length << 2) + 1);
    writeStringToMemory(str, ret);
   }
   return ret;
  })
 };
 var toC = {
  "string": JSfuncs["stringToC"],
  "array": JSfuncs["arrayToC"]
 };
 ccall = function ccallFunc(ident, returnType, argTypes, args) {
  var func = getCFunc(ident);
  var cArgs = [];
  var stack = 0;
  if (args) {
   for (var i = 0; i < args.length; i++) {
    var converter = toC[argTypes[i]];
    if (converter) {
     if (stack === 0) stack = Runtime.stackSave();
     cArgs[i] = converter(args[i]);
    } else {
     cArgs[i] = args[i];
    }
   }
  }
  var ret = func.apply(null, cArgs);
  if (returnType === "string") ret = Pointer_stringify(ret);
  if (stack !== 0) Runtime.stackRestore(stack);
  return ret;
 };
 var sourceRegex = /^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;
 function parseJSFunc(jsfunc) {
  var parsed = jsfunc.toString().match(sourceRegex).slice(1);
  return {
   arguments: parsed[0],
   body: parsed[1],
   returnValue: parsed[2]
  };
 }
 var JSsource = {};
 for (var fun in JSfuncs) {
  if (JSfuncs.hasOwnProperty(fun)) {
   JSsource[fun] = parseJSFunc(JSfuncs[fun]);
  }
 }
 cwrap = function cwrap(ident, returnType, argTypes) {
  argTypes = argTypes || [];
  var cfunc = getCFunc(ident);
  var numericArgs = argTypes.every((function(type) {
   return type === "number";
  }));
  var numericRet = returnType !== "string";
  if (numericRet && numericArgs) {
   return cfunc;
  }
  var argNames = argTypes.map((function(x, i) {
   return "$" + i;
  }));
  var funcstr = "(function(" + argNames.join(",") + ") {";
  var nargs = argTypes.length;
  if (!numericArgs) {
   funcstr += "var stack = " + JSsource["stackSave"].body + ";";
   for (var i = 0; i < nargs; i++) {
    var arg = argNames[i], type = argTypes[i];
    if (type === "number") continue;
    var convertCode = JSsource[type + "ToC"];
    funcstr += "var " + convertCode.arguments + " = " + arg + ";";
    funcstr += convertCode.body + ";";
    funcstr += arg + "=" + convertCode.returnValue + ";";
   }
  }
  var cfuncname = parseJSFunc((function() {
   return cfunc;
  })).returnValue;
  funcstr += "var ret = " + cfuncname + "(" + argNames.join(",") + ");";
  if (!numericRet) {
   var strgfy = parseJSFunc((function() {
    return Pointer_stringify;
   })).returnValue;
   funcstr += "ret = " + strgfy + "(ret);";
  }
  if (!numericArgs) {
   funcstr += JSsource["stackRestore"].body.replace("()", "(stack)") + ";";
  }
  funcstr += "return ret})";
  return eval(funcstr);
 };
}))();
Module["cwrap"] = cwrap;
Module["ccall"] = ccall;
function setValue(ptr, value, type, noSafe) {
 type = type || "i8";
 if (type.charAt(type.length - 1) === "*") type = "i32";
 switch (type) {
 case "i1":
  HEAP8[ptr >> 0] = value;
  break;
 case "i8":
  HEAP8[ptr >> 0] = value;
  break;
 case "i16":
  HEAP16[ptr >> 1] = value;
  break;
 case "i32":
  HEAP32[ptr >> 2] = value;
  break;
 case "i64":
  tempI64 = [ value >>> 0, (tempDouble = value, +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0) ], HEAP32[ptr >> 2] = tempI64[0], HEAP32[ptr + 4 >> 2] = tempI64[1];
  break;
 case "float":
  HEAPF32[ptr >> 2] = value;
  break;
 case "double":
  HEAPF64[ptr >> 3] = value;
  break;
 default:
  abort("invalid type for setValue: " + type);
 }
}
Module["setValue"] = setValue;
function getValue(ptr, type, noSafe) {
 type = type || "i8";
 if (type.charAt(type.length - 1) === "*") type = "i32";
 switch (type) {
 case "i1":
  return HEAP8[ptr >> 0];
 case "i8":
  return HEAP8[ptr >> 0];
 case "i16":
  return HEAP16[ptr >> 1];
 case "i32":
  return HEAP32[ptr >> 2];
 case "i64":
  return HEAP32[ptr >> 2];
 case "float":
  return HEAPF32[ptr >> 2];
 case "double":
  return HEAPF64[ptr >> 3];
 default:
  abort("invalid type for setValue: " + type);
 }
 return null;
}
Module["getValue"] = getValue;
var ALLOC_NORMAL = 0;
var ALLOC_STACK = 1;
var ALLOC_STATIC = 2;
var ALLOC_DYNAMIC = 3;
var ALLOC_NONE = 4;
Module["ALLOC_NORMAL"] = ALLOC_NORMAL;
Module["ALLOC_STACK"] = ALLOC_STACK;
Module["ALLOC_STATIC"] = ALLOC_STATIC;
Module["ALLOC_DYNAMIC"] = ALLOC_DYNAMIC;
Module["ALLOC_NONE"] = ALLOC_NONE;
function allocate(slab, types, allocator, ptr) {
 var zeroinit, size;
 if (typeof slab === "number") {
  zeroinit = true;
  size = slab;
 } else {
  zeroinit = false;
  size = slab.length;
 }
 var singleType = typeof types === "string" ? types : null;
 var ret;
 if (allocator == ALLOC_NONE) {
  ret = ptr;
 } else {
  ret = [ _malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc ][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
 }
 if (zeroinit) {
  var ptr = ret, stop;
  assert((ret & 3) == 0);
  stop = ret + (size & ~3);
  for (; ptr < stop; ptr += 4) {
   HEAP32[ptr >> 2] = 0;
  }
  stop = ret + size;
  while (ptr < stop) {
   HEAP8[ptr++ >> 0] = 0;
  }
  return ret;
 }
 if (singleType === "i8") {
  if (slab.subarray || slab.slice) {
   HEAPU8.set(slab, ret);
  } else {
   HEAPU8.set(new Uint8Array(slab), ret);
  }
  return ret;
 }
 var i = 0, type, typeSize, previousType;
 while (i < size) {
  var curr = slab[i];
  if (typeof curr === "function") {
   curr = Runtime.getFunctionIndex(curr);
  }
  type = singleType || types[i];
  if (type === 0) {
   i++;
   continue;
  }
  if (type == "i64") type = "i32";
  setValue(ret + i, curr, type);
  if (previousType !== type) {
   typeSize = Runtime.getNativeTypeSize(type);
   previousType = type;
  }
  i += typeSize;
 }
 return ret;
}
Module["allocate"] = allocate;
function Pointer_stringify(ptr, length) {
 if (length === 0 || !ptr) return "";
 var hasUtf = 0;
 var t;
 var i = 0;
 while (1) {
  t = HEAPU8[ptr + i >> 0];
  hasUtf |= t;
  if (t == 0 && !length) break;
  i++;
  if (length && i == length) break;
 }
 if (!length) length = i;
 var ret = "";
 if (hasUtf < 128) {
  var MAX_CHUNK = 1024;
  var curr;
  while (length > 0) {
   curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
   ret = ret ? ret + curr : curr;
   ptr += MAX_CHUNK;
   length -= MAX_CHUNK;
  }
  return ret;
 }
 return Module["UTF8ToString"](ptr);
}
Module["Pointer_stringify"] = Pointer_stringify;
function AsciiToString(ptr) {
 var str = "";
 while (1) {
  var ch = HEAP8[ptr++ >> 0];
  if (!ch) return str;
  str += String.fromCharCode(ch);
 }
}
Module["AsciiToString"] = AsciiToString;
function stringToAscii(str, outPtr) {
 return writeAsciiToMemory(str, outPtr, false);
}
Module["stringToAscii"] = stringToAscii;
function UTF8ArrayToString(u8Array, idx) {
 var u0, u1, u2, u3, u4, u5;
 var str = "";
 while (1) {
  u0 = u8Array[idx++];
  if (!u0) return str;
  if (!(u0 & 128)) {
   str += String.fromCharCode(u0);
   continue;
  }
  u1 = u8Array[idx++] & 63;
  if ((u0 & 224) == 192) {
   str += String.fromCharCode((u0 & 31) << 6 | u1);
   continue;
  }
  u2 = u8Array[idx++] & 63;
  if ((u0 & 240) == 224) {
   u0 = (u0 & 15) << 12 | u1 << 6 | u2;
  } else {
   u3 = u8Array[idx++] & 63;
   if ((u0 & 248) == 240) {
    u0 = (u0 & 7) << 18 | u1 << 12 | u2 << 6 | u3;
   } else {
    u4 = u8Array[idx++] & 63;
    if ((u0 & 252) == 248) {
     u0 = (u0 & 3) << 24 | u1 << 18 | u2 << 12 | u3 << 6 | u4;
    } else {
     u5 = u8Array[idx++] & 63;
     u0 = (u0 & 1) << 30 | u1 << 24 | u2 << 18 | u3 << 12 | u4 << 6 | u5;
    }
   }
  }
  if (u0 < 65536) {
   str += String.fromCharCode(u0);
  } else {
   var ch = u0 - 65536;
   str += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023);
  }
 }
}
Module["UTF8ArrayToString"] = UTF8ArrayToString;
function UTF8ToString(ptr) {
 return UTF8ArrayToString(HEAPU8, ptr);
}
Module["UTF8ToString"] = UTF8ToString;
function stringToUTF8Array(str, outU8Array, outIdx, maxBytesToWrite) {
 if (!(maxBytesToWrite > 0)) return 0;
 var startIdx = outIdx;
 var endIdx = outIdx + maxBytesToWrite - 1;
 for (var i = 0; i < str.length; ++i) {
  var u = str.charCodeAt(i);
  if (u >= 55296 && u <= 57343) u = 65536 + ((u & 1023) << 10) | str.charCodeAt(++i) & 1023;
  if (u <= 127) {
   if (outIdx >= endIdx) break;
   outU8Array[outIdx++] = u;
  } else if (u <= 2047) {
   if (outIdx + 1 >= endIdx) break;
   outU8Array[outIdx++] = 192 | u >> 6;
   outU8Array[outIdx++] = 128 | u & 63;
  } else if (u <= 65535) {
   if (outIdx + 2 >= endIdx) break;
   outU8Array[outIdx++] = 224 | u >> 12;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  } else if (u <= 2097151) {
   if (outIdx + 3 >= endIdx) break;
   outU8Array[outIdx++] = 240 | u >> 18;
   outU8Array[outIdx++] = 128 | u >> 12 & 63;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  } else if (u <= 67108863) {
   if (outIdx + 4 >= endIdx) break;
   outU8Array[outIdx++] = 248 | u >> 24;
   outU8Array[outIdx++] = 128 | u >> 18 & 63;
   outU8Array[outIdx++] = 128 | u >> 12 & 63;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  } else {
   if (outIdx + 5 >= endIdx) break;
   outU8Array[outIdx++] = 252 | u >> 30;
   outU8Array[outIdx++] = 128 | u >> 24 & 63;
   outU8Array[outIdx++] = 128 | u >> 18 & 63;
   outU8Array[outIdx++] = 128 | u >> 12 & 63;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  }
 }
 outU8Array[outIdx] = 0;
 return outIdx - startIdx;
}
Module["stringToUTF8Array"] = stringToUTF8Array;
function stringToUTF8(str, outPtr, maxBytesToWrite) {
 return stringToUTF8Array(str, HEAPU8, outPtr, maxBytesToWrite);
}
Module["stringToUTF8"] = stringToUTF8;
function lengthBytesUTF8(str) {
 var len = 0;
 for (var i = 0; i < str.length; ++i) {
  var u = str.charCodeAt(i);
  if (u >= 55296 && u <= 57343) u = 65536 + ((u & 1023) << 10) | str.charCodeAt(++i) & 1023;
  if (u <= 127) {
   ++len;
  } else if (u <= 2047) {
   len += 2;
  } else if (u <= 65535) {
   len += 3;
  } else if (u <= 2097151) {
   len += 4;
  } else if (u <= 67108863) {
   len += 5;
  } else {
   len += 6;
  }
 }
 return len;
}
Module["lengthBytesUTF8"] = lengthBytesUTF8;
function UTF16ToString(ptr) {
 var i = 0;
 var str = "";
 while (1) {
  var codeUnit = HEAP16[ptr + i * 2 >> 1];
  if (codeUnit == 0) return str;
  ++i;
  str += String.fromCharCode(codeUnit);
 }
}
Module["UTF16ToString"] = UTF16ToString;
function stringToUTF16(str, outPtr, maxBytesToWrite) {
 if (maxBytesToWrite === undefined) {
  maxBytesToWrite = 2147483647;
 }
 if (maxBytesToWrite < 2) return 0;
 maxBytesToWrite -= 2;
 var startPtr = outPtr;
 var numCharsToWrite = maxBytesToWrite < str.length * 2 ? maxBytesToWrite / 2 : str.length;
 for (var i = 0; i < numCharsToWrite; ++i) {
  var codeUnit = str.charCodeAt(i);
  HEAP16[outPtr >> 1] = codeUnit;
  outPtr += 2;
 }
 HEAP16[outPtr >> 1] = 0;
 return outPtr - startPtr;
}
Module["stringToUTF16"] = stringToUTF16;
function lengthBytesUTF16(str) {
 return str.length * 2;
}
Module["lengthBytesUTF16"] = lengthBytesUTF16;
function UTF32ToString(ptr) {
 var i = 0;
 var str = "";
 while (1) {
  var utf32 = HEAP32[ptr + i * 4 >> 2];
  if (utf32 == 0) return str;
  ++i;
  if (utf32 >= 65536) {
   var ch = utf32 - 65536;
   str += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023);
  } else {
   str += String.fromCharCode(utf32);
  }
 }
}
Module["UTF32ToString"] = UTF32ToString;
function stringToUTF32(str, outPtr, maxBytesToWrite) {
 if (maxBytesToWrite === undefined) {
  maxBytesToWrite = 2147483647;
 }
 if (maxBytesToWrite < 4) return 0;
 var startPtr = outPtr;
 var endPtr = startPtr + maxBytesToWrite - 4;
 for (var i = 0; i < str.length; ++i) {
  var codeUnit = str.charCodeAt(i);
  if (codeUnit >= 55296 && codeUnit <= 57343) {
   var trailSurrogate = str.charCodeAt(++i);
   codeUnit = 65536 + ((codeUnit & 1023) << 10) | trailSurrogate & 1023;
  }
  HEAP32[outPtr >> 2] = codeUnit;
  outPtr += 4;
  if (outPtr + 4 > endPtr) break;
 }
 HEAP32[outPtr >> 2] = 0;
 return outPtr - startPtr;
}
Module["stringToUTF32"] = stringToUTF32;
function lengthBytesUTF32(str) {
 var len = 0;
 for (var i = 0; i < str.length; ++i) {
  var codeUnit = str.charCodeAt(i);
  if (codeUnit >= 55296 && codeUnit <= 57343) ++i;
  len += 4;
 }
 return len;
}
Module["lengthBytesUTF32"] = lengthBytesUTF32;
function demangle(func) {
 var hasLibcxxabi = !!Module["___cxa_demangle"];
 if (hasLibcxxabi) {
  try {
   var buf = _malloc(func.length);
   writeStringToMemory(func.substr(1), buf);
   var status = _malloc(4);
   var ret = Module["___cxa_demangle"](buf, 0, 0, status);
   if (getValue(status, "i32") === 0 && ret) {
    return Pointer_stringify(ret);
   }
  } catch (e) {} finally {
   if (buf) _free(buf);
   if (status) _free(status);
   if (ret) _free(ret);
  }
 }
 var i = 3;
 var basicTypes = {
  "v": "void",
  "b": "bool",
  "c": "char",
  "s": "short",
  "i": "int",
  "l": "long",
  "f": "float",
  "d": "double",
  "w": "wchar_t",
  "a": "signed char",
  "h": "unsigned char",
  "t": "unsigned short",
  "j": "unsigned int",
  "m": "unsigned long",
  "x": "long long",
  "y": "unsigned long long",
  "z": "..."
 };
 var subs = [];
 var first = true;
 function dump(x) {
  if (x) Module.print(x);
  Module.print(func);
  var pre = "";
  for (var a = 0; a < i; a++) pre += " ";
  Module.print(pre + "^");
 }
 function parseNested() {
  i++;
  if (func[i] === "K") i++;
  var parts = [];
  while (func[i] !== "E") {
   if (func[i] === "S") {
    i++;
    var next = func.indexOf("_", i);
    var num = func.substring(i, next) || 0;
    parts.push(subs[num] || "?");
    i = next + 1;
    continue;
   }
   if (func[i] === "C") {
    parts.push(parts[parts.length - 1]);
    i += 2;
    continue;
   }
   var size = parseInt(func.substr(i));
   var pre = size.toString().length;
   if (!size || !pre) {
    i--;
    break;
   }
   var curr = func.substr(i + pre, size);
   parts.push(curr);
   subs.push(curr);
   i += pre + size;
  }
  i++;
  return parts;
 }
 function parse(rawList, limit, allowVoid) {
  limit = limit || Infinity;
  var ret = "", list = [];
  function flushList() {
   return "(" + list.join(", ") + ")";
  }
  var name;
  if (func[i] === "N") {
   name = parseNested().join("::");
   limit--;
   if (limit === 0) return rawList ? [ name ] : name;
  } else {
   if (func[i] === "K" || first && func[i] === "L") i++;
   var size = parseInt(func.substr(i));
   if (size) {
    var pre = size.toString().length;
    name = func.substr(i + pre, size);
    i += pre + size;
   }
  }
  first = false;
  if (func[i] === "I") {
   i++;
   var iList = parse(true);
   var iRet = parse(true, 1, true);
   ret += iRet[0] + " " + name + "<" + iList.join(", ") + ">";
  } else {
   ret = name;
  }
  paramLoop : while (i < func.length && limit-- > 0) {
   var c = func[i++];
   if (c in basicTypes) {
    list.push(basicTypes[c]);
   } else {
    switch (c) {
    case "P":
     list.push(parse(true, 1, true)[0] + "*");
     break;
    case "R":
     list.push(parse(true, 1, true)[0] + "&");
     break;
    case "L":
     {
      i++;
      var end = func.indexOf("E", i);
      var size = end - i;
      list.push(func.substr(i, size));
      i += size + 2;
      break;
     }
    case "A":
     {
      var size = parseInt(func.substr(i));
      i += size.toString().length;
      if (func[i] !== "_") throw "?";
      i++;
      list.push(parse(true, 1, true)[0] + " [" + size + "]");
      break;
     }
    case "E":
     break paramLoop;
    default:
     ret += "?" + c;
     break paramLoop;
    }
   }
  }
  if (!allowVoid && list.length === 1 && list[0] === "void") list = [];
  if (rawList) {
   if (ret) {
    list.push(ret + "?");
   }
   return list;
  } else {
   return ret + flushList();
  }
 }
 var parsed = func;
 try {
  if (func == "Object._main" || func == "_main") {
   return "main()";
  }
  if (typeof func === "number") func = Pointer_stringify(func);
  if (func[0] !== "_") return func;
  if (func[1] !== "_") return func;
  if (func[2] !== "Z") return func;
  switch (func[3]) {
  case "n":
   return "operator new()";
  case "d":
   return "operator delete()";
  }
  parsed = parse();
 } catch (e) {
  parsed += "?";
 }
 if (parsed.indexOf("?") >= 0 && !hasLibcxxabi) {
  Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");
 }
 return parsed;
}
function demangleAll(text) {
 return text.replace(/__Z[\w\d_]+/g, (function(x) {
  var y = demangle(x);
  return x === y ? x : x + " [" + y + "]";
 }));
}
function jsStackTrace() {
 var err = new Error;
 if (!err.stack) {
  try {
   throw new Error(0);
  } catch (e) {
   err = e;
  }
  if (!err.stack) {
   return "(no stack trace available)";
  }
 }
 return err.stack.toString();
}
function stackTrace() {
 return demangleAll(jsStackTrace());
}
Module["stackTrace"] = stackTrace;
var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
 return x + 4095 & -4096;
}
var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false;
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0;
var DYNAMIC_BASE = 0, DYNAMICTOP = 0;
function enlargeMemory() {
 abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value " + TOTAL_MEMORY + ", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.");
}
var TOTAL_STACK = Module["TOTAL_STACK"] || 5242880;
var TOTAL_MEMORY = Module["TOTAL_MEMORY"] || 268435456;
var FAST_MEMORY = Module["FAST_MEMORY"] || 2097152;
var totalMemory = 64 * 1024;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2 * TOTAL_STACK) {
 if (totalMemory < 16 * 1024 * 1024) {
  totalMemory *= 2;
 } else {
  totalMemory += 16 * 1024 * 1024;
 }
}
if (totalMemory !== TOTAL_MEMORY) {
 Module.printErr("increasing TOTAL_MEMORY to " + totalMemory + " to be compliant with the asm.js spec");
 TOTAL_MEMORY = totalMemory;
}
assert(typeof Int32Array !== "undefined" && typeof Float64Array !== "undefined" && !!(new Int32Array(1))["subarray"] && !!(new Int32Array(1))["set"], "JS engine does not provide full typed array support");
var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, "Typed arrays 2 must be run on a little-endian system");
Module["HEAP"] = HEAP;
Module["buffer"] = buffer;
Module["HEAP8"] = HEAP8;
Module["HEAP16"] = HEAP16;
Module["HEAP32"] = HEAP32;
Module["HEAPU8"] = HEAPU8;
Module["HEAPU16"] = HEAPU16;
Module["HEAPU32"] = HEAPU32;
Module["HEAPF32"] = HEAPF32;
Module["HEAPF64"] = HEAPF64;
function callRuntimeCallbacks(callbacks) {
 while (callbacks.length > 0) {
  var callback = callbacks.shift();
  if (typeof callback == "function") {
   callback();
   continue;
  }
  var func = callback.func;
  if (typeof func === "number") {
   if (callback.arg === undefined) {
    Runtime.dynCall("v", func);
   } else {
    Runtime.dynCall("vi", func, [ callback.arg ]);
   }
  } else {
   func(callback.arg === undefined ? null : callback.arg);
  }
 }
}
var __ATPRERUN__ = [];
var __ATINIT__ = [];
var __ATMAIN__ = [];
var __ATEXIT__ = [];
var __ATPOSTRUN__ = [];
var runtimeInitialized = false;
var runtimeExited = false;
function preRun() {
 if (Module["preRun"]) {
  if (typeof Module["preRun"] == "function") Module["preRun"] = [ Module["preRun"] ];
  while (Module["preRun"].length) {
   addOnPreRun(Module["preRun"].shift());
  }
 }
 callRuntimeCallbacks(__ATPRERUN__);
}
function ensureInitRuntime() {
 if (runtimeInitialized) return;
 runtimeInitialized = true;
 callRuntimeCallbacks(__ATINIT__);
}
function preMain() {
 callRuntimeCallbacks(__ATMAIN__);
}
function exitRuntime() {
 callRuntimeCallbacks(__ATEXIT__);
 runtimeExited = true;
}
function postRun() {
 if (Module["postRun"]) {
  if (typeof Module["postRun"] == "function") Module["postRun"] = [ Module["postRun"] ];
  while (Module["postRun"].length) {
   addOnPostRun(Module["postRun"].shift());
  }
 }
 callRuntimeCallbacks(__ATPOSTRUN__);
}
function addOnPreRun(cb) {
 __ATPRERUN__.unshift(cb);
}
Module["addOnPreRun"] = Module.addOnPreRun = addOnPreRun;
function addOnInit(cb) {
 __ATINIT__.unshift(cb);
}
Module["addOnInit"] = Module.addOnInit = addOnInit;
function addOnPreMain(cb) {
 __ATMAIN__.unshift(cb);
}
Module["addOnPreMain"] = Module.addOnPreMain = addOnPreMain;
function addOnExit(cb) {
 __ATEXIT__.unshift(cb);
}
Module["addOnExit"] = Module.addOnExit = addOnExit;
function addOnPostRun(cb) {
 __ATPOSTRUN__.unshift(cb);
}
Module["addOnPostRun"] = Module.addOnPostRun = addOnPostRun;
function intArrayFromString(stringy, dontAddNull, length) {
 var len = length > 0 ? length : lengthBytesUTF8(stringy) + 1;
 var u8array = new Array(len);
 var numBytesWritten = stringToUTF8Array(stringy, u8array, 0, u8array.length);
 if (dontAddNull) u8array.length = numBytesWritten;
 return u8array;
}
Module["intArrayFromString"] = intArrayFromString;
function intArrayToString(array) {
 var ret = [];
 for (var i = 0; i < array.length; i++) {
  var chr = array[i];
  if (chr > 255) {
   chr &= 255;
  }
  ret.push(String.fromCharCode(chr));
 }
 return ret.join("");
}
Module["intArrayToString"] = intArrayToString;
function writeStringToMemory(string, buffer, dontAddNull) {
 var array = intArrayFromString(string, dontAddNull);
 var i = 0;
 while (i < array.length) {
  var chr = array[i];
  HEAP8[buffer + i >> 0] = chr;
  i = i + 1;
 }
}
Module["writeStringToMemory"] = writeStringToMemory;
function writeArrayToMemory(array, buffer) {
 for (var i = 0; i < array.length; i++) {
  HEAP8[buffer++ >> 0] = array[i];
 }
}
Module["writeArrayToMemory"] = writeArrayToMemory;
function writeAsciiToMemory(str, buffer, dontAddNull) {
 for (var i = 0; i < str.length; ++i) {
  HEAP8[buffer++ >> 0] = str.charCodeAt(i);
 }
 if (!dontAddNull) HEAP8[buffer >> 0] = 0;
}
Module["writeAsciiToMemory"] = writeAsciiToMemory;
function unSign(value, bits, ignore) {
 if (value >= 0) {
  return value;
 }
 return bits <= 32 ? 2 * Math.abs(1 << bits - 1) + value : Math.pow(2, bits) + value;
}
function reSign(value, bits, ignore) {
 if (value <= 0) {
  return value;
 }
 var half = bits <= 32 ? Math.abs(1 << bits - 1) : Math.pow(2, bits - 1);
 if (value >= half && (bits <= 32 || value > half)) {
  value = -2 * half + value;
 }
 return value;
}
if (!Math["imul"] || Math["imul"](4294967295, 5) !== -5) Math["imul"] = function imul(a, b) {
 var ah = a >>> 16;
 var al = a & 65535;
 var bh = b >>> 16;
 var bl = b & 65535;
 return al * bl + (ah * bl + al * bh << 16) | 0;
};
Math.imul = Math["imul"];
if (!Math["fround"]) Math["fround"] = (function(x) {
 return x;
});
Math.fround = Math["fround"];
var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null;
function addRunDependency(id) {
 runDependencies++;
 if (Module["monitorRunDependencies"]) {
  Module["monitorRunDependencies"](runDependencies);
 }
}
Module["addRunDependency"] = addRunDependency;
function removeRunDependency(id) {
 runDependencies--;
 if (Module["monitorRunDependencies"]) {
  Module["monitorRunDependencies"](runDependencies);
 }
 if (runDependencies == 0) {
  if (runDependencyWatcher !== null) {
   clearInterval(runDependencyWatcher);
   runDependencyWatcher = null;
  }
  if (dependenciesFulfilled) {
   var callback = dependenciesFulfilled;
   dependenciesFulfilled = null;
   callback();
  }
 }
}
Module["removeRunDependency"] = removeRunDependency;
Module["preloadedImages"] = {};
Module["preloadedAudios"] = {};
var memoryInitializer = null;
STATIC_BASE = 8;
STATICTOP = STATIC_BASE + 3672896;
__ATINIT__.push({
 func: (function() {
  __GLOBAL__sub_I_Monitor_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Error_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Thread_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_File_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_ThreadImpl_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Class_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Reflection_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Runtime_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_String_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Thread_cpp1784();
 })
}, {
 func: (function() {
  __GLOBAL__I_a();
 })
}, {
 func: (function() {
  __GLOBAL__I_a4175();
 })
}, {
 func: (function() {
  __GLOBAL__I_a4186();
 })
}, {
 func: (function() {
  __GLOBAL__I_a4190();
 })
}, {
 func: (function() {
  __GLOBAL__I_a4212();
 })
}, {
 func: (function() {
  __GLOBAL__I_a4563();
 })
}, {
 func: (function() {
  __GLOBAL__I_a6527();
 })
}, {
 func: (function() {
  ___cxx_global_var_init();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_MessageIdentifier_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_GUITexture_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_ForwardShaderRenderLoop_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_DeferredUtils_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_PrePassRenderLoop_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_DeferredRenderLoop_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Camera_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Flare_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_ImageFilters_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Light_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_CubemapGPUUtility_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_RenderSettings_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Shadows_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_SkyboxMeshGenerator_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_SpeedTreeWindManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Mesh_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_SpriteRenderer_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_BillboardBatchManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_AABB_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_GfxDevice_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_LODGroupManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_RendererAnimationBinding_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_ScreenManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_rand_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Player_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_GraphicsCaps_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_JobManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_ShaderPass_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_umbra_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_ParticleSystem_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_PhysicsManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Physics2DManager_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_clipmuscle_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_DetailDatabase_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_DetailRenderer_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_SplatMaterials_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Tree_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_TreeIntermediateRenderer_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_TreeRenderer_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_half_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_GpuProgramsGLES_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Assembly_CSharp_firstpass_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Assembly_CSharp_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_Mono_Security_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_System_Core_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_System_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_UnityEngine_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_mscorlib_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_replacements_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_iostream_cpp();
 })
});
var memoryInitializer = "bla2.html.mem";
var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
assert(tempDoublePtr % 8 == 0);
function copyTempFloat(ptr) {
 HEAP8[tempDoublePtr] = HEAP8[ptr];
 HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
 HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
 HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
}
function copyTempDouble(ptr) {
 HEAP8[tempDoublePtr] = HEAP8[ptr];
 HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
 HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
 HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
 HEAP8[tempDoublePtr + 4] = HEAP8[ptr + 4];
 HEAP8[tempDoublePtr + 5] = HEAP8[ptr + 5];
 HEAP8[tempDoublePtr + 6] = HEAP8[ptr + 6];
 HEAP8[tempDoublePtr + 7] = HEAP8[ptr + 7];
}
var _UItoF = true;
var _UItoD = true;
var GL = {
 counter: 1,
 lastError: 0,
 buffers: [],
 mappedBuffers: {},
 programs: [],
 framebuffers: [],
 renderbuffers: [],
 textures: [],
 uniforms: [],
 shaders: [],
 vaos: [],
 contexts: [],
 queries: [],
 samplers: [],
 transformFeedbacks: [],
 byteSizeByTypeRoot: 5120,
 byteSizeByType: [ 1, 1, 2, 2, 4, 4, 4, 2, 3, 4, 8 ],
 programInfos: {},
 stringCache: {},
 packAlignment: 4,
 unpackAlignment: 4,
 init: (function() {
  GL.miniTempBuffer = new Float32Array(GL.MINI_TEMP_BUFFER_SIZE);
  for (var i = 0; i < GL.MINI_TEMP_BUFFER_SIZE; i++) {
   GL.miniTempBufferViews[i] = GL.miniTempBuffer.subarray(0, i + 1);
  }
 }),
 recordError: function recordError(errorCode) {
  if (!GL.lastError) {
   GL.lastError = errorCode;
  }
 },
 getNewId: (function(table) {
  var ret = GL.counter++;
  for (var i = table.length; i < ret; i++) {
   table[i] = null;
  }
  return ret;
 }),
 MINI_TEMP_BUFFER_SIZE: 16,
 miniTempBuffer: null,
 miniTempBufferViews: [ 0 ],
 getSource: (function(shader, count, string, length) {
  var source = "";
  for (var i = 0; i < count; ++i) {
   var frag;
   if (length) {
    var len = HEAP32[length + i * 4 >> 2];
    if (len < 0) {
     frag = Pointer_stringify(HEAP32[string + i * 4 >> 2]);
    } else {
     frag = Pointer_stringify(HEAP32[string + i * 4 >> 2], len);
    }
   } else {
    frag = Pointer_stringify(HEAP32[string + i * 4 >> 2]);
   }
   source += frag;
  }
  return source;
 }),
 computeImageSize: (function(width, height, sizePerPixel, alignment) {
  function roundedToNextMultipleOf(x, y) {
   return Math.floor((x + y - 1) / y) * y;
  }
  var plainRowSize = width * sizePerPixel;
  var alignedRowSize = roundedToNextMultipleOf(plainRowSize, alignment);
  return height <= 0 ? 0 : (height - 1) * alignedRowSize + plainRowSize;
 }),
 get: (function(name_, p, type) {
  if (!p) {
   GL.recordError(1281);
   return;
  }
  var ret = undefined;
  switch (name_) {
  case 36346:
   ret = 1;
   break;
  case 36344:
   if (type !== "Integer") {
    GL.recordError(1280);
   }
   return;
  case 34814:
  case 36345:
   ret = 0;
   break;
  case 34466:
   var formats = GLctx.getParameter(34467);
   ret = formats.length;
   break;
  case 35738:
   ret = 5121;
   break;
  case 35739:
   ret = 6408;
   break;
  }
  if (ret === undefined) {
   var result = GLctx.getParameter(name_);
   switch (typeof result) {
   case "number":
    ret = result;
    break;
   case "boolean":
    ret = result ? 1 : 0;
    break;
   case "string":
    GL.recordError(1280);
    return;
   case "object":
    if (result === null) {
     switch (name_) {
     case 34964:
     case 35725:
     case 34965:
     case 36006:
     case 36007:
     case 32873:
     case 34068:
      {
       ret = 0;
       break;
      }
     default:
      {
       GL.recordError(1280);
       return;
      }
     }
    } else if (result instanceof Float32Array || result instanceof Uint32Array || result instanceof Int32Array || result instanceof Array) {
     for (var i = 0; i < result.length; ++i) {
      switch (type) {
      case "Integer":
       HEAP32[p + i * 4 >> 2] = result[i];
       break;
      case "Float":
       HEAPF32[p + i * 4 >> 2] = result[i];
       break;
      case "Boolean":
       HEAP8[p + i >> 0] = result[i] ? 1 : 0;
       break;
      default:
       throw "internal glGet error, bad type: " + type;
      }
     }
     return;
    } else if (result instanceof WebGLBuffer || result instanceof WebGLProgram || result instanceof WebGLFramebuffer || result instanceof WebGLRenderbuffer || result instanceof WebGLTexture) {
     ret = result.name | 0;
    } else {
     GL.recordError(1280);
     return;
    }
    break;
   default:
    GL.recordError(1280);
    return;
   }
  }
  switch (type) {
  case "Integer":
   HEAP32[p >> 2] = ret;
   break;
  case "Float":
   HEAPF32[p >> 2] = ret;
   break;
  case "Boolean":
   HEAP8[p >> 0] = ret ? 1 : 0;
   break;
  default:
   throw "internal glGet error, bad type: " + type;
  }
 }),
 getTexPixelData: (function(type, format, width, height, pixels, internalFormat) {
  var sizePerPixel;
  var numChannels;
  switch (format) {
  case 6406:
  case 6409:
  case 6402:
   numChannels = 1;
   break;
  case 6410:
  case 33319:
   numChannels = 2;
   break;
  case 6407:
   numChannels = 3;
   break;
  case 6408:
   numChannels = 4;
   break;
  default:
   GL.recordError(1280);
   return {
    pixels: null,
    internalFormat: 0
   };
  }
  switch (type) {
  case 5121:
   sizePerPixel = numChannels * 1;
   break;
  case 5123:
  case 36193:
   sizePerPixel = numChannels * 2;
   break;
  case 5125:
  case 5126:
   sizePerPixel = numChannels * 4;
   break;
  case 34042:
   sizePerPixel = 4;
   break;
  case 33635:
  case 32819:
  case 32820:
   sizePerPixel = 2;
   break;
  default:
   GL.recordError(1280);
   return {
    pixels: null,
    internalFormat: 0
   };
  }
  var bytes = GL.computeImageSize(width, height, sizePerPixel, GL.unpackAlignment);
  if (type == 5121) {
   pixels = HEAPU8.subarray(pixels, pixels + bytes);
  } else if (type == 5126) {
   pixels = HEAPF32.subarray(pixels >> 2, pixels + bytes >> 2);
  } else if (type == 5125 || type == 34042) {
   pixels = HEAPU32.subarray(pixels >> 2, pixels + bytes >> 2);
  } else {
   pixels = HEAPU16.subarray(pixels >> 1, pixels + bytes >> 1);
  }
  return {
   pixels: pixels,
   internalFormat: internalFormat
  };
 }),
 validateBufferTarget: (function(target) {
  switch (target) {
  case 34962:
  case 34963:
  case 36662:
  case 36663:
  case 35051:
  case 35052:
  case 35882:
  case 35982:
  case 35345:
   return true;
  default:
   return false;
  }
 }),
 createContext: (function(canvas, webGLContextAttributes) {
  if (typeof webGLContextAttributes.majorVersion === "undefined" && typeof webGLContextAttributes.minorVersion === "undefined") {
   webGLContextAttributes.majorVersion = 2;
   webGLContextAttributes.minorVersion = 0;
  }
  var ctx;
  var errorInfo = "?";
  function onContextCreationError(event) {
   errorInfo = event.statusMessage || errorInfo;
  }
  try {
   canvas.addEventListener("webglcontextcreationerror", onContextCreationError, false);
   try {
    if (webGLContextAttributes.majorVersion == 1 && webGLContextAttributes.minorVersion == 0) {
     ctx = canvas.getContext("webgl", webGLContextAttributes) || canvas.getContext("experimental-webgl", webGLContextAttributes);
    } else if (webGLContextAttributes.majorVersion == 2 && webGLContextAttributes.minorVersion == 0) {
     ctx = canvas.getContext("webgl2", webGLContextAttributes) || canvas.getContext("experimental-webgl2", webGLContextAttributes);
    } else {
     throw "Unsupported WebGL context version " + majorVersion + "." + minorVersion + "!";
    }
   } finally {
    canvas.removeEventListener("webglcontextcreationerror", onContextCreationError, false);
   }
   if (!ctx) throw ":(";
  } catch (e) {
   Module.print("Could not create canvas: " + [ errorInfo, e, JSON.stringify(webGLContextAttributes) ]);
   return 0;
  }
  if (!ctx) return 0;
  return GL.registerContext(ctx, webGLContextAttributes);
 }),
 registerContext: (function(ctx, webGLContextAttributes) {
  var handle = GL.getNewId(GL.contexts);
  var context = {
   handle: handle,
   version: webGLContextAttributes.majorVersion,
   GLctx: ctx
  };
  if (ctx.canvas) ctx.canvas.GLctxObject = context;
  GL.contexts[handle] = context;
  if (typeof webGLContextAttributes["enableExtensionsByDefault"] === "undefined" || webGLContextAttributes.enableExtensionsByDefault) {
   GL.initExtensions(context);
  }
  return handle;
 }),
 makeContextCurrent: (function(contextHandle) {
  var context = GL.contexts[contextHandle];
  if (!context) return false;
  GLctx = Module.ctx = context.GLctx;
  GL.currentContext = context;
  return true;
 }),
 getContext: (function(contextHandle) {
  return GL.contexts[contextHandle];
 }),
 deleteContext: (function(contextHandle) {
  if (GL.currentContext === GL.contexts[contextHandle]) GL.currentContext = 0;
  if (typeof JSEvents === "object") JSEvents.removeAllHandlersOnTarget(GL.contexts[contextHandle].canvas);
  if (GL.contexts[contextHandle] && GL.contexts[contextHandle].GLctx.canvas) GL.contexts[contextHandle].GLctx.canvas.GLctxObject = undefined;
  GL.contexts[contextHandle] = null;
 }),
 initExtensions: (function(context) {
  if (!context) context = GL.currentContext;
  if (context.initExtensionsDone) return;
  context.initExtensionsDone = true;
  var GLctx = context.GLctx;
  context.maxVertexAttribs = GLctx.getParameter(GLctx.MAX_VERTEX_ATTRIBS);
  context.compressionExt = GLctx.getExtension("WEBGL_compressed_texture_s3tc") || GLctx.getExtension("MOZ_WEBGL_compressed_texture_s3tc") || GLctx.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc");
  context.anisotropicExt = GLctx.getExtension("EXT_texture_filter_anisotropic") || GLctx.getExtension("MOZ_EXT_texture_filter_anisotropic") || GLctx.getExtension("WEBKIT_EXT_texture_filter_anisotropic");
  context.floatExt = GLctx.getExtension("OES_texture_float");
  context.instancedArraysExt = GLctx.getExtension("ANGLE_instanced_arrays");
  context.vaoExt = GLctx.getExtension("OES_vertex_array_object");
  if (context.version === 2) {
   context.drawBuffersExt = (function(n, bufs) {
    GLctx.drawBuffers(n, bufs);
   });
  } else {
   var ext = GLctx.getExtension("WEBGL_draw_buffers");
   if (ext) {
    context.drawBuffersExt = (function(n, bufs) {
     ext.drawBuffersWEBGL(n, bufs);
    });
   }
  }
  var automaticallyEnabledExtensions = [ "OES_texture_float", "OES_texture_half_float", "OES_standard_derivatives", "OES_vertex_array_object", "WEBGL_compressed_texture_s3tc", "WEBGL_depth_texture", "OES_element_index_uint", "EXT_texture_filter_anisotropic", "ANGLE_instanced_arrays", "OES_texture_float_linear", "OES_texture_half_float_linear", "WEBGL_compressed_texture_atc", "WEBGL_compressed_texture_pvrtc", "EXT_color_buffer_half_float", "WEBGL_color_buffer_float", "EXT_frag_depth", "EXT_sRGB", "WEBGL_draw_buffers", "WEBGL_shared_resources", "EXT_shader_texture_lod" ];
  function shouldEnableAutomatically(extension) {
   var ret = false;
   automaticallyEnabledExtensions.forEach((function(include) {
    if (ext.indexOf(include) != -1) {
     ret = true;
    }
   }));
   return ret;
  }
  GLctx.getSupportedExtensions().forEach((function(ext) {
   ext = ext.replace("MOZ_", "").replace("WEBKIT_", "");
   if (automaticallyEnabledExtensions.indexOf(ext) != -1) {
    GLctx.getExtension(ext);
   }
  }));
 }),
 populateUniformTable: (function(program) {
  var p = GL.programs[program];
  GL.programInfos[program] = {
   uniforms: {},
   maxUniformLength: 0,
   maxAttributeLength: -1
  };
  var ptable = GL.programInfos[program];
  var utable = ptable.uniforms;
  var numUniforms = GLctx.getProgramParameter(p, GLctx.ACTIVE_UNIFORMS);
  for (var i = 0; i < numUniforms; ++i) {
   var u = GLctx.getActiveUniform(p, i);
   var name = u.name;
   ptable.maxUniformLength = Math.max(ptable.maxUniformLength, name.length + 1);
   if (name.indexOf("]", name.length - 1) !== -1) {
    var ls = name.lastIndexOf("[");
    name = name.slice(0, ls);
   }
   var loc = GLctx.getUniformLocation(p, name);
   var id = GL.getNewId(GL.uniforms);
   utable[name] = [ u.size, id ];
   GL.uniforms[id] = loc;
   for (var j = 1; j < u.size; ++j) {
    var n = name + "[" + j + "]";
    loc = GLctx.getUniformLocation(p, n);
    id = GL.getNewId(GL.uniforms);
    GL.uniforms[id] = loc;
   }
  }
 })
};
function _emscripten_glStencilMaskSeparate(x0, x1) {
 GLctx.stencilMaskSeparate(x0, x1);
}
var ERRNO_CODES = {
 EPERM: 1,
 ENOENT: 2,
 ESRCH: 3,
 EINTR: 4,
 EIO: 5,
 ENXIO: 6,
 E2BIG: 7,
 ENOEXEC: 8,
 EBADF: 9,
 ECHILD: 10,
 EAGAIN: 11,
 EWOULDBLOCK: 11,
 ENOMEM: 12,
 EACCES: 13,
 EFAULT: 14,
 ENOTBLK: 15,
 EBUSY: 16,
 EEXIST: 17,
 EXDEV: 18,
 ENODEV: 19,
 ENOTDIR: 20,
 EISDIR: 21,
 EINVAL: 22,
 ENFILE: 23,
 EMFILE: 24,
 ENOTTY: 25,
 ETXTBSY: 26,
 EFBIG: 27,
 ENOSPC: 28,
 ESPIPE: 29,
 EROFS: 30,
 EMLINK: 31,
 EPIPE: 32,
 EDOM: 33,
 ERANGE: 34,
 ENOMSG: 42,
 EIDRM: 43,
 ECHRNG: 44,
 EL2NSYNC: 45,
 EL3HLT: 46,
 EL3RST: 47,
 ELNRNG: 48,
 EUNATCH: 49,
 ENOCSI: 50,
 EL2HLT: 51,
 EDEADLK: 35,
 ENOLCK: 37,
 EBADE: 52,
 EBADR: 53,
 EXFULL: 54,
 ENOANO: 55,
 EBADRQC: 56,
 EBADSLT: 57,
 EDEADLOCK: 35,
 EBFONT: 59,
 ENOSTR: 60,
 ENODATA: 61,
 ETIME: 62,
 ENOSR: 63,
 ENONET: 64,
 ENOPKG: 65,
 EREMOTE: 66,
 ENOLINK: 67,
 EADV: 68,
 ESRMNT: 69,
 ECOMM: 70,
 EPROTO: 71,
 EMULTIHOP: 72,
 EDOTDOT: 73,
 EBADMSG: 74,
 ENOTUNIQ: 76,
 EBADFD: 77,
 EREMCHG: 78,
 ELIBACC: 79,
 ELIBBAD: 80,
 ELIBSCN: 81,
 ELIBMAX: 82,
 ELIBEXEC: 83,
 ENOSYS: 38,
 ENOTEMPTY: 39,
 ENAMETOOLONG: 36,
 ELOOP: 40,
 EOPNOTSUPP: 95,
 EPFNOSUPPORT: 96,
 ECONNRESET: 104,
 ENOBUFS: 105,
 EAFNOSUPPORT: 97,
 EPROTOTYPE: 91,
 ENOTSOCK: 88,
 ENOPROTOOPT: 92,
 ESHUTDOWN: 108,
 ECONNREFUSED: 111,
 EADDRINUSE: 98,
 ECONNABORTED: 103,
 ENETUNREACH: 101,
 ENETDOWN: 100,
 ETIMEDOUT: 110,
 EHOSTDOWN: 112,
 EHOSTUNREACH: 113,
 EINPROGRESS: 115,
 EALREADY: 114,
 EDESTADDRREQ: 89,
 EMSGSIZE: 90,
 EPROTONOSUPPORT: 93,
 ESOCKTNOSUPPORT: 94,
 EADDRNOTAVAIL: 99,
 ENETRESET: 102,
 EISCONN: 106,
 ENOTCONN: 107,
 ETOOMANYREFS: 109,
 EUSERS: 87,
 EDQUOT: 122,
 ESTALE: 116,
 ENOTSUP: 95,
 ENOMEDIUM: 123,
 EILSEQ: 84,
 EOVERFLOW: 75,
 ECANCELED: 125,
 ENOTRECOVERABLE: 131,
 EOWNERDEAD: 130,
 ESTRPIPE: 86
};
var ERRNO_MESSAGES = {
 0: "Success",
 1: "Not super-user",
 2: "No such file or directory",
 3: "No such process",
 4: "Interrupted system call",
 5: "I/O error",
 6: "No such device or address",
 7: "Arg list too long",
 8: "Exec format error",
 9: "Bad file number",
 10: "No children",
 11: "No more processes",
 12: "Not enough core",
 13: "Permission denied",
 14: "Bad address",
 15: "Block device required",
 16: "Mount device busy",
 17: "File exists",
 18: "Cross-device link",
 19: "No such device",
 20: "Not a directory",
 21: "Is a directory",
 22: "Invalid argument",
 23: "Too many open files in system",
 24: "Too many open files",
 25: "Not a typewriter",
 26: "Text file busy",
 27: "File too large",
 28: "No space left on device",
 29: "Illegal seek",
 30: "Read only file system",
 31: "Too many links",
 32: "Broken pipe",
 33: "Math arg out of domain of func",
 34: "Math result not representable",
 35: "File locking deadlock error",
 36: "File or path name too long",
 37: "No record locks available",
 38: "Function not implemented",
 39: "Directory not empty",
 40: "Too many symbolic links",
 42: "No message of desired type",
 43: "Identifier removed",
 44: "Channel number out of range",
 45: "Level 2 not synchronized",
 46: "Level 3 halted",
 47: "Level 3 reset",
 48: "Link number out of range",
 49: "Protocol driver not attached",
 50: "No CSI structure available",
 51: "Level 2 halted",
 52: "Invalid exchange",
 53: "Invalid request descriptor",
 54: "Exchange full",
 55: "No anode",
 56: "Invalid request code",
 57: "Invalid slot",
 59: "Bad font file fmt",
 60: "Device not a stream",
 61: "No data (for no delay io)",
 62: "Timer expired",
 63: "Out of streams resources",
 64: "Machine is not on the network",
 65: "Package not installed",
 66: "The object is remote",
 67: "The link has been severed",
 68: "Advertise error",
 69: "Srmount error",
 70: "Communication error on send",
 71: "Protocol error",
 72: "Multihop attempted",
 73: "Cross mount point (not really error)",
 74: "Trying to read unreadable message",
 75: "Value too large for defined data type",
 76: "Given log. name not unique",
 77: "f.d. invalid for this operation",
 78: "Remote address changed",
 79: "Can   access a needed shared lib",
 80: "Accessing a corrupted shared lib",
 81: ".lib section in a.out corrupted",
 82: "Attempting to link in too many libs",
 83: "Attempting to exec a shared library",
 84: "Illegal byte sequence",
 86: "Streams pipe error",
 87: "Too many users",
 88: "Socket operation on non-socket",
 89: "Destination address required",
 90: "Message too long",
 91: "Protocol wrong type for socket",
 92: "Protocol not available",
 93: "Unknown protocol",
 94: "Socket type not supported",
 95: "Not supported",
 96: "Protocol family not supported",
 97: "Address family not supported by protocol family",
 98: "Address already in use",
 99: "Address not available",
 100: "Network interface is not configured",
 101: "Network is unreachable",
 102: "Connection reset by network",
 103: "Connection aborted",
 104: "Connection reset by peer",
 105: "No buffer space available",
 106: "Socket is already connected",
 107: "Socket is not connected",
 108: "Can't send after socket shutdown",
 109: "Too many references",
 110: "Connection timed out",
 111: "Connection refused",
 112: "Host is down",
 113: "Host is unreachable",
 114: "Socket already connected",
 115: "Connection already in progress",
 116: "Stale file handle",
 122: "Quota exceeded",
 123: "No medium (in tape drive)",
 125: "Operation canceled",
 130: "Previous owner died",
 131: "State not recoverable"
};
var ___errno_state = 0;
function ___setErrNo(value) {
 HEAP32[___errno_state >> 2] = value;
 return value;
}
var PATH = {
 splitPath: (function(filename) {
  var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  return splitPathRe.exec(filename).slice(1);
 }),
 normalizeArray: (function(parts, allowAboveRoot) {
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
   var last = parts[i];
   if (last === ".") {
    parts.splice(i, 1);
   } else if (last === "..") {
    parts.splice(i, 1);
    up++;
   } else if (up) {
    parts.splice(i, 1);
    up--;
   }
  }
  if (allowAboveRoot) {
   for (; up--; up) {
    parts.unshift("..");
   }
  }
  return parts;
 }),
 normalize: (function(path) {
  var isAbsolute = path.charAt(0) === "/", trailingSlash = path.substr(-1) === "/";
  path = PATH.normalizeArray(path.split("/").filter((function(p) {
   return !!p;
  })), !isAbsolute).join("/");
  if (!path && !isAbsolute) {
   path = ".";
  }
  if (path && trailingSlash) {
   path += "/";
  }
  return (isAbsolute ? "/" : "") + path;
 }),
 dirname: (function(path) {
  var result = PATH.splitPath(path), root = result[0], dir = result[1];
  if (!root && !dir) {
   return ".";
  }
  if (dir) {
   dir = dir.substr(0, dir.length - 1);
  }
  return root + dir;
 }),
 basename: (function(path) {
  if (path === "/") return "/";
  var lastSlash = path.lastIndexOf("/");
  if (lastSlash === -1) return path;
  return path.substr(lastSlash + 1);
 }),
 extname: (function(path) {
  return PATH.splitPath(path)[3];
 }),
 join: (function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return PATH.normalize(paths.join("/"));
 }),
 join2: (function(l, r) {
  return PATH.normalize(l + "/" + r);
 }),
 resolve: (function() {
  var resolvedPath = "", resolvedAbsolute = false;
  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
   var path = i >= 0 ? arguments[i] : FS.cwd();
   if (typeof path !== "string") {
    throw new TypeError("Arguments to path.resolve must be strings");
   } else if (!path) {
    return "";
   }
   resolvedPath = path + "/" + resolvedPath;
   resolvedAbsolute = path.charAt(0) === "/";
  }
  resolvedPath = PATH.normalizeArray(resolvedPath.split("/").filter((function(p) {
   return !!p;
  })), !resolvedAbsolute).join("/");
  return (resolvedAbsolute ? "/" : "") + resolvedPath || ".";
 }),
 relative: (function(from, to) {
  from = PATH.resolve(from).substr(1);
  to = PATH.resolve(to).substr(1);
  function trim(arr) {
   var start = 0;
   for (; start < arr.length; start++) {
    if (arr[start] !== "") break;
   }
   var end = arr.length - 1;
   for (; end >= 0; end--) {
    if (arr[end] !== "") break;
   }
   if (start > end) return [];
   return arr.slice(start, end - start + 1);
  }
  var fromParts = trim(from.split("/"));
  var toParts = trim(to.split("/"));
  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
   if (fromParts[i] !== toParts[i]) {
    samePartsLength = i;
    break;
   }
  }
  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
   outputParts.push("..");
  }
  outputParts = outputParts.concat(toParts.slice(samePartsLength));
  return outputParts.join("/");
 })
};
var TTY = {
 ttys: [],
 init: (function() {}),
 shutdown: (function() {}),
 register: (function(dev, ops) {
  TTY.ttys[dev] = {
   input: [],
   output: [],
   ops: ops
  };
  FS.registerDevice(dev, TTY.stream_ops);
 }),
 stream_ops: {
  open: (function(stream) {
   var tty = TTY.ttys[stream.node.rdev];
   if (!tty) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   stream.tty = tty;
   stream.seekable = false;
  }),
  close: (function(stream) {
   stream.tty.ops.flush(stream.tty);
  }),
  flush: (function(stream) {
   stream.tty.ops.flush(stream.tty);
  }),
  read: (function(stream, buffer, offset, length, pos) {
   if (!stream.tty || !stream.tty.ops.get_char) {
    throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
   }
   var bytesRead = 0;
   for (var i = 0; i < length; i++) {
    var result;
    try {
     result = stream.tty.ops.get_char(stream.tty);
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
    if (result === undefined && bytesRead === 0) {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
    if (result === null || result === undefined) break;
    bytesRead++;
    buffer[offset + i] = result;
   }
   if (bytesRead) {
    stream.node.timestamp = Date.now();
   }
   return bytesRead;
  }),
  write: (function(stream, buffer, offset, length, pos) {
   if (!stream.tty || !stream.tty.ops.put_char) {
    throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
   }
   for (var i = 0; i < length; i++) {
    try {
     stream.tty.ops.put_char(stream.tty, buffer[offset + i]);
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
   }
   if (length) {
    stream.node.timestamp = Date.now();
   }
   return i;
  })
 },
 default_tty_ops: {
  get_char: (function(tty) {
   if (!tty.input.length) {
    var result = null;
    if (ENVIRONMENT_IS_NODE) {
     result = process["stdin"]["read"]();
     if (!result) {
      if (process["stdin"]["_readableState"] && process["stdin"]["_readableState"]["ended"]) {
       return null;
      }
      return undefined;
     }
    } else if (typeof window != "undefined" && typeof window.prompt == "function") {
     result = window.prompt("Input: ");
     if (result !== null) {
      result += "\n";
     }
    } else if (typeof readline == "function") {
     result = readline();
     if (result !== null) {
      result += "\n";
     }
    }
    if (!result) {
     return null;
    }
    tty.input = intArrayFromString(result, true);
   }
   return tty.input.shift();
  }),
  put_char: (function(tty, val) {
   if (val === null || val === 10) {
    Module["print"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   } else {
    if (val != 0) tty.output.push(val);
   }
  }),
  flush: (function(tty) {
   if (tty.output && tty.output.length > 0) {
    Module["print"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   }
  })
 },
 default_tty1_ops: {
  put_char: (function(tty, val) {
   if (val === null || val === 10) {
    Module["printErr"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   } else {
    if (val != 0) tty.output.push(val);
   }
  }),
  flush: (function(tty) {
   if (tty.output && tty.output.length > 0) {
    Module["printErr"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   }
  })
 }
};
var MEMFS = {
 ops_table: null,
 mount: (function(mount) {
  return MEMFS.createNode(null, "/", 16384 | 511, 0);
 }),
 createNode: (function(parent, name, mode, dev) {
  if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (!MEMFS.ops_table) {
   MEMFS.ops_table = {
    dir: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr,
      lookup: MEMFS.node_ops.lookup,
      mknod: MEMFS.node_ops.mknod,
      rename: MEMFS.node_ops.rename,
      unlink: MEMFS.node_ops.unlink,
      rmdir: MEMFS.node_ops.rmdir,
      readdir: MEMFS.node_ops.readdir,
      symlink: MEMFS.node_ops.symlink
     },
     stream: {
      llseek: MEMFS.stream_ops.llseek
     }
    },
    file: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr
     },
     stream: {
      llseek: MEMFS.stream_ops.llseek,
      read: MEMFS.stream_ops.read,
      write: MEMFS.stream_ops.write,
      allocate: MEMFS.stream_ops.allocate,
      mmap: MEMFS.stream_ops.mmap
     }
    },
    link: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr,
      readlink: MEMFS.node_ops.readlink
     },
     stream: {}
    },
    chrdev: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr
     },
     stream: FS.chrdev_stream_ops
    }
   };
  }
  var node = FS.createNode(parent, name, mode, dev);
  if (FS.isDir(node.mode)) {
   node.node_ops = MEMFS.ops_table.dir.node;
   node.stream_ops = MEMFS.ops_table.dir.stream;
   node.contents = {};
  } else if (FS.isFile(node.mode)) {
   node.node_ops = MEMFS.ops_table.file.node;
   node.stream_ops = MEMFS.ops_table.file.stream;
   node.usedBytes = 0;
   node.contents = null;
  } else if (FS.isLink(node.mode)) {
   node.node_ops = MEMFS.ops_table.link.node;
   node.stream_ops = MEMFS.ops_table.link.stream;
  } else if (FS.isChrdev(node.mode)) {
   node.node_ops = MEMFS.ops_table.chrdev.node;
   node.stream_ops = MEMFS.ops_table.chrdev.stream;
  }
  node.timestamp = Date.now();
  if (parent) {
   parent.contents[name] = node;
  }
  return node;
 }),
 getFileDataAsRegularArray: (function(node) {
  if (node.contents && node.contents.subarray) {
   var arr = [];
   for (var i = 0; i < node.usedBytes; ++i) arr.push(node.contents[i]);
   return arr;
  }
  return node.contents;
 }),
 getFileDataAsTypedArray: (function(node) {
  if (!node.contents) return new Uint8Array;
  if (node.contents.subarray) return node.contents.subarray(0, node.usedBytes);
  return new Uint8Array(node.contents);
 }),
 expandFileStorage: (function(node, newCapacity) {
  if (node.contents && node.contents.subarray && newCapacity > node.contents.length) {
   node.contents = MEMFS.getFileDataAsRegularArray(node);
   node.usedBytes = node.contents.length;
  }
  if (!node.contents || node.contents.subarray) {
   var prevCapacity = node.contents ? node.contents.buffer.byteLength : 0;
   if (prevCapacity >= newCapacity) return;
   var CAPACITY_DOUBLING_MAX = 1024 * 1024;
   newCapacity = Math.max(newCapacity, prevCapacity * (prevCapacity < CAPACITY_DOUBLING_MAX ? 2 : 1.125) | 0);
   if (prevCapacity != 0) newCapacity = Math.max(newCapacity, 256);
   var oldContents = node.contents;
   node.contents = new Uint8Array(newCapacity);
   if (node.usedBytes > 0) node.contents.set(oldContents.subarray(0, node.usedBytes), 0);
   return;
  }
  if (!node.contents && newCapacity > 0) node.contents = [];
  while (node.contents.length < newCapacity) node.contents.push(0);
 }),
 resizeFileStorage: (function(node, newSize) {
  if (node.usedBytes == newSize) return;
  if (newSize == 0) {
   node.contents = null;
   node.usedBytes = 0;
   return;
  }
  if (!node.contents || node.contents.subarray) {
   var oldContents = node.contents;
   node.contents = new Uint8Array(new ArrayBuffer(newSize));
   if (oldContents) {
    node.contents.set(oldContents.subarray(0, Math.min(newSize, node.usedBytes)));
   }
   node.usedBytes = newSize;
   return;
  }
  if (!node.contents) node.contents = [];
  if (node.contents.length > newSize) node.contents.length = newSize; else while (node.contents.length < newSize) node.contents.push(0);
  node.usedBytes = newSize;
 }),
 node_ops: {
  getattr: (function(node) {
   var attr = {};
   attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
   attr.ino = node.id;
   attr.mode = node.mode;
   attr.nlink = 1;
   attr.uid = 0;
   attr.gid = 0;
   attr.rdev = node.rdev;
   if (FS.isDir(node.mode)) {
    attr.size = 4096;
   } else if (FS.isFile(node.mode)) {
    attr.size = node.usedBytes;
   } else if (FS.isLink(node.mode)) {
    attr.size = node.link.length;
   } else {
    attr.size = 0;
   }
   attr.atime = new Date(node.timestamp);
   attr.mtime = new Date(node.timestamp);
   attr.ctime = new Date(node.timestamp);
   attr.blksize = 4096;
   attr.blocks = Math.ceil(attr.size / attr.blksize);
   return attr;
  }),
  setattr: (function(node, attr) {
   if (attr.mode !== undefined) {
    node.mode = attr.mode;
   }
   if (attr.timestamp !== undefined) {
    node.timestamp = attr.timestamp;
   }
   if (attr.size !== undefined) {
    MEMFS.resizeFileStorage(node, attr.size);
   }
  }),
  lookup: (function(parent, name) {
   throw FS.genericErrors[ERRNO_CODES.ENOENT];
  }),
  mknod: (function(parent, name, mode, dev) {
   return MEMFS.createNode(parent, name, mode, dev);
  }),
  rename: (function(old_node, new_dir, new_name) {
   if (FS.isDir(old_node.mode)) {
    var new_node;
    try {
     new_node = FS.lookupNode(new_dir, new_name);
    } catch (e) {}
    if (new_node) {
     for (var i in new_node.contents) {
      throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
     }
    }
   }
   delete old_node.parent.contents[old_node.name];
   old_node.name = new_name;
   new_dir.contents[new_name] = old_node;
   old_node.parent = new_dir;
  }),
  unlink: (function(parent, name) {
   delete parent.contents[name];
  }),
  rmdir: (function(parent, name) {
   var node = FS.lookupNode(parent, name);
   for (var i in node.contents) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
   }
   delete parent.contents[name];
  }),
  readdir: (function(node) {
   var entries = [ ".", ".." ];
   for (var key in node.contents) {
    if (!node.contents.hasOwnProperty(key)) {
     continue;
    }
    entries.push(key);
   }
   return entries;
  }),
  symlink: (function(parent, newname, oldpath) {
   var node = MEMFS.createNode(parent, newname, 511 | 40960, 0);
   node.link = oldpath;
   return node;
  }),
  readlink: (function(node) {
   if (!FS.isLink(node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return node.link;
  })
 },
 stream_ops: {
  read: (function(stream, buffer, offset, length, position) {
   var contents = stream.node.contents;
   if (position >= stream.node.usedBytes) return 0;
   var size = Math.min(stream.node.usedBytes - position, length);
   assert(size >= 0);
   if (size > 8 && contents.subarray) {
    buffer.set(contents.subarray(position, position + size), offset);
   } else {
    for (var i = 0; i < size; i++) buffer[offset + i] = contents[position + i];
   }
   return size;
  }),
  write: (function(stream, buffer, offset, length, position, canOwn) {
   if (!length) return 0;
   var node = stream.node;
   node.timestamp = Date.now();
   if (buffer.subarray && (!node.contents || node.contents.subarray)) {
    if (canOwn) {
     node.contents = buffer.subarray(offset, offset + length);
     node.usedBytes = length;
     return length;
    } else if (node.usedBytes === 0 && position === 0) {
     node.contents = new Uint8Array(buffer.subarray(offset, offset + length));
     node.usedBytes = length;
     return length;
    } else if (position + length <= node.usedBytes) {
     node.contents.set(buffer.subarray(offset, offset + length), position);
     return length;
    }
   }
   MEMFS.expandFileStorage(node, position + length);
   if (node.contents.subarray && buffer.subarray) node.contents.set(buffer.subarray(offset, offset + length), position); else for (var i = 0; i < length; i++) {
    node.contents[position + i] = buffer[offset + i];
   }
   node.usedBytes = Math.max(node.usedBytes, position + length);
   return length;
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     position += stream.node.usedBytes;
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  }),
  allocate: (function(stream, offset, length) {
   MEMFS.expandFileStorage(stream.node, offset + length);
   stream.node.usedBytes = Math.max(stream.node.usedBytes, offset + length);
  }),
  mmap: (function(stream, buffer, offset, length, position, prot, flags) {
   if (!FS.isFile(stream.node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   var ptr;
   var allocated;
   var contents = stream.node.contents;
   if (!(flags & 2) && (contents.buffer === buffer || contents.buffer === buffer.buffer)) {
    allocated = false;
    ptr = contents.byteOffset;
   } else {
    if (position > 0 || position + length < stream.node.usedBytes) {
     if (contents.subarray) {
      contents = contents.subarray(position, position + length);
     } else {
      contents = Array.prototype.slice.call(contents, position, position + length);
     }
    }
    allocated = true;
    ptr = _malloc(length);
    if (!ptr) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
    }
    buffer.set(contents, ptr);
   }
   return {
    ptr: ptr,
    allocated: allocated
   };
  })
 }
};
var IDBFS = {
 dbs: {},
 indexedDB: (function() {
  if (typeof indexedDB !== "undefined") return indexedDB;
  var ret = null;
  if (typeof window === "object") ret = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
  assert(ret, "IDBFS used, but indexedDB not supported");
  return ret;
 }),
 DB_VERSION: 21,
 DB_STORE_NAME: "FILE_DATA",
 mount: (function(mount) {
  return MEMFS.mount.apply(null, arguments);
 }),
 syncfs: (function(mount, populate, callback) {
  IDBFS.getLocalSet(mount, (function(err, local) {
   if (err) return callback(err);
   IDBFS.getRemoteSet(mount, (function(err, remote) {
    if (err) return callback(err);
    var src = populate ? remote : local;
    var dst = populate ? local : remote;
    IDBFS.reconcile(src, dst, callback);
   }));
  }));
 }),
 getDB: (function(name, callback) {
  var db = IDBFS.dbs[name];
  if (db) {
   return callback(null, db);
  }
  var req;
  try {
   req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
  } catch (e) {
   return callback(e);
  }
  req.onupgradeneeded = (function(e) {
   var db = e.target.result;
   var transaction = e.target.transaction;
   var fileStore;
   if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
    fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
   } else {
    fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
   }
   fileStore.createIndex("timestamp", "timestamp", {
    unique: false
   });
  });
  req.onsuccess = (function() {
   db = req.result;
   IDBFS.dbs[name] = db;
   callback(null, db);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 getLocalSet: (function(mount, callback) {
  var entries = {};
  function isRealDir(p) {
   return p !== "." && p !== "..";
  }
  function toAbsolute(root) {
   return (function(p) {
    return PATH.join2(root, p);
   });
  }
  var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  while (check.length) {
   var path = check.pop();
   var stat;
   try {
    stat = FS.stat(path);
   } catch (e) {
    return callback(e);
   }
   if (FS.isDir(stat.mode)) {
    check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
   }
   entries[path] = {
    timestamp: stat.mtime
   };
  }
  return callback(null, {
   type: "local",
   entries: entries
  });
 }),
 getRemoteSet: (function(mount, callback) {
  var entries = {};
  IDBFS.getDB(mount.mountpoint, (function(err, db) {
   if (err) return callback(err);
   var transaction = db.transaction([ IDBFS.DB_STORE_NAME ], "readonly");
   transaction.onerror = (function() {
    callback(this.error);
   });
   var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
   var index = store.index("timestamp");
   index.openKeyCursor().onsuccess = (function(event) {
    var cursor = event.target.result;
    if (!cursor) {
     return callback(null, {
      type: "remote",
      db: db,
      entries: entries
     });
    }
    entries[cursor.primaryKey] = {
     timestamp: cursor.key
    };
    cursor.continue();
   });
  }));
 }),
 loadLocalEntry: (function(path, callback) {
  var stat, node;
  try {
   var lookup = FS.lookupPath(path);
   node = lookup.node;
   stat = FS.stat(path);
  } catch (e) {
   return callback(e);
  }
  if (FS.isDir(stat.mode)) {
   return callback(null, {
    timestamp: stat.mtime,
    mode: stat.mode
   });
  } else if (FS.isFile(stat.mode)) {
   node.contents = MEMFS.getFileDataAsTypedArray(node);
   return callback(null, {
    timestamp: stat.mtime,
    mode: stat.mode,
    contents: node.contents
   });
  } else {
   return callback(new Error("node type not supported"));
  }
 }),
 storeLocalEntry: (function(path, entry, callback) {
  try {
   if (FS.isDir(entry.mode)) {
    FS.mkdir(path, entry.mode);
   } else if (FS.isFile(entry.mode)) {
    FS.writeFile(path, entry.contents, {
     encoding: "binary",
     canOwn: true
    });
   } else {
    return callback(new Error("node type not supported"));
   }
   FS.chmod(path, entry.mode);
   FS.utime(path, entry.timestamp, entry.timestamp);
  } catch (e) {
   return callback(e);
  }
  callback(null);
 }),
 removeLocalEntry: (function(path, callback) {
  try {
   var lookup = FS.lookupPath(path);
   var stat = FS.stat(path);
   if (FS.isDir(stat.mode)) {
    FS.rmdir(path);
   } else if (FS.isFile(stat.mode)) {
    FS.unlink(path);
   }
  } catch (e) {
   return callback(e);
  }
  callback(null);
 }),
 loadRemoteEntry: (function(store, path, callback) {
  var req = store.get(path);
  req.onsuccess = (function(event) {
   callback(null, event.target.result);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 storeRemoteEntry: (function(store, path, entry, callback) {
  var req = store.put(entry, path);
  req.onsuccess = (function() {
   callback(null);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 removeRemoteEntry: (function(store, path, callback) {
  var req = store.delete(path);
  req.onsuccess = (function() {
   callback(null);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 reconcile: (function(src, dst, callback) {
  var total = 0;
  var create = [];
  Object.keys(src.entries).forEach((function(key) {
   var e = src.entries[key];
   var e2 = dst.entries[key];
   if (!e2 || e.timestamp > e2.timestamp) {
    create.push(key);
    total++;
   }
  }));
  var remove = [];
  Object.keys(dst.entries).forEach((function(key) {
   var e = dst.entries[key];
   var e2 = src.entries[key];
   if (!e2) {
    remove.push(key);
    total++;
   }
  }));
  if (!total) {
   return callback(null);
  }
  var errored = false;
  var completed = 0;
  var db = src.type === "remote" ? src.db : dst.db;
  var transaction = db.transaction([ IDBFS.DB_STORE_NAME ], "readwrite");
  var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  function done(err) {
   if (err) {
    if (!done.errored) {
     done.errored = true;
     return callback(err);
    }
    return;
   }
   if (++completed >= total) {
    return callback(null);
   }
  }
  transaction.onerror = (function() {
   done(this.error);
  });
  create.sort().forEach((function(path) {
   if (dst.type === "local") {
    IDBFS.loadRemoteEntry(store, path, (function(err, entry) {
     if (err) return done(err);
     IDBFS.storeLocalEntry(path, entry, done);
    }));
   } else {
    IDBFS.loadLocalEntry(path, (function(err, entry) {
     if (err) return done(err);
     IDBFS.storeRemoteEntry(store, path, entry, done);
    }));
   }
  }));
  remove.sort().reverse().forEach((function(path) {
   if (dst.type === "local") {
    IDBFS.removeLocalEntry(path, done);
   } else {
    IDBFS.removeRemoteEntry(store, path, done);
   }
  }));
 })
};
var NODEFS = {
 isWindows: false,
 staticInit: (function() {
  NODEFS.isWindows = !!process.platform.match(/^win/);
 }),
 mount: (function(mount) {
  assert(ENVIRONMENT_IS_NODE);
  return NODEFS.createNode(null, "/", NODEFS.getMode(mount.opts.root), 0);
 }),
 createNode: (function(parent, name, mode, dev) {
  if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node = FS.createNode(parent, name, mode);
  node.node_ops = NODEFS.node_ops;
  node.stream_ops = NODEFS.stream_ops;
  return node;
 }),
 getMode: (function(path) {
  var stat;
  try {
   stat = fs.lstatSync(path);
   if (NODEFS.isWindows) {
    stat.mode = stat.mode | (stat.mode & 146) >> 1;
   }
  } catch (e) {
   if (!e.code) throw e;
   throw new FS.ErrnoError(ERRNO_CODES[e.code]);
  }
  return stat.mode;
 }),
 realPath: (function(node) {
  var parts = [];
  while (node.parent !== node) {
   parts.push(node.name);
   node = node.parent;
  }
  parts.push(node.mount.opts.root);
  parts.reverse();
  return PATH.join.apply(null, parts);
 }),
 flagsToPermissionStringMap: {
  0: "r",
  1: "r+",
  2: "r+",
  64: "r",
  65: "r+",
  66: "r+",
  129: "rx+",
  193: "rx+",
  514: "w+",
  577: "w",
  578: "w+",
  705: "wx",
  706: "wx+",
  1024: "a",
  1025: "a",
  1026: "a+",
  1089: "a",
  1090: "a+",
  1153: "ax",
  1154: "ax+",
  1217: "ax",
  1218: "ax+",
  4096: "rs",
  4098: "rs+"
 },
 flagsToPermissionString: (function(flags) {
  if (flags in NODEFS.flagsToPermissionStringMap) {
   return NODEFS.flagsToPermissionStringMap[flags];
  } else {
   return flags;
  }
 }),
 node_ops: {
  getattr: (function(node) {
   var path = NODEFS.realPath(node);
   var stat;
   try {
    stat = fs.lstatSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   if (NODEFS.isWindows && !stat.blksize) {
    stat.blksize = 4096;
   }
   if (NODEFS.isWindows && !stat.blocks) {
    stat.blocks = (stat.size + stat.blksize - 1) / stat.blksize | 0;
   }
   return {
    dev: stat.dev,
    ino: stat.ino,
    mode: stat.mode,
    nlink: stat.nlink,
    uid: stat.uid,
    gid: stat.gid,
    rdev: stat.rdev,
    size: stat.size,
    atime: stat.atime,
    mtime: stat.mtime,
    ctime: stat.ctime,
    blksize: stat.blksize,
    blocks: stat.blocks
   };
  }),
  setattr: (function(node, attr) {
   var path = NODEFS.realPath(node);
   try {
    if (attr.mode !== undefined) {
     fs.chmodSync(path, attr.mode);
     node.mode = attr.mode;
    }
    if (attr.timestamp !== undefined) {
     var date = new Date(attr.timestamp);
     fs.utimesSync(path, date, date);
    }
    if (attr.size !== undefined) {
     fs.truncateSync(path, attr.size);
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  lookup: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   var mode = NODEFS.getMode(path);
   return NODEFS.createNode(parent, name, mode);
  }),
  mknod: (function(parent, name, mode, dev) {
   var node = NODEFS.createNode(parent, name, mode, dev);
   var path = NODEFS.realPath(node);
   try {
    if (FS.isDir(node.mode)) {
     fs.mkdirSync(path, node.mode);
    } else {
     fs.writeFileSync(path, "", {
      mode: node.mode
     });
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   return node;
  }),
  rename: (function(oldNode, newDir, newName) {
   var oldPath = NODEFS.realPath(oldNode);
   var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
   try {
    fs.renameSync(oldPath, newPath);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  unlink: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   try {
    fs.unlinkSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  rmdir: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   try {
    fs.rmdirSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  readdir: (function(node) {
   var path = NODEFS.realPath(node);
   try {
    return fs.readdirSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  symlink: (function(parent, newName, oldPath) {
   var newPath = PATH.join2(NODEFS.realPath(parent), newName);
   try {
    fs.symlinkSync(oldPath, newPath);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  readlink: (function(node) {
   var path = NODEFS.realPath(node);
   try {
    return fs.readlinkSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  })
 },
 stream_ops: {
  open: (function(stream) {
   var path = NODEFS.realPath(stream.node);
   try {
    if (FS.isFile(stream.node.mode)) {
     stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  close: (function(stream) {
   try {
    if (FS.isFile(stream.node.mode) && stream.nfd) {
     fs.closeSync(stream.nfd);
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  read: (function(stream, buffer, offset, length, position) {
   if (length === 0) return 0;
   var nbuffer = new Buffer(length);
   var res;
   try {
    res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   if (res > 0) {
    for (var i = 0; i < res; i++) {
     buffer[offset + i] = nbuffer[i];
    }
   }
   return res;
  }),
  write: (function(stream, buffer, offset, length, position) {
   var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
   var res;
   try {
    res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   return res;
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     try {
      var stat = fs.fstatSync(stream.nfd);
      position += stat.size;
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES[e.code]);
     }
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  })
 }
};
var _stdin = allocate(1, "i32*", ALLOC_STATIC);
var _stdout = allocate(1, "i32*", ALLOC_STATIC);
var _stderr = allocate(1, "i32*", ALLOC_STATIC);
function _fflush(stream) {}
var FS = {
 root: null,
 mounts: [],
 devices: [ null ],
 streams: [],
 nextInode: 1,
 nameTable: null,
 currentPath: "/",
 initialized: false,
 ignorePermissions: true,
 trackingDelegate: {},
 tracking: {
  openFlags: {
   READ: 1,
   WRITE: 2
  }
 },
 ErrnoError: null,
 genericErrors: {},
 handleFSError: (function(e) {
  if (!(e instanceof FS.ErrnoError)) throw e + " : " + stackTrace();
  return ___setErrNo(e.errno);
 }),
 lookupPath: (function(path, opts) {
  path = PATH.resolve(FS.cwd(), path);
  opts = opts || {};
  if (!path) return {
   path: "",
   node: null
  };
  var defaults = {
   follow_mount: true,
   recurse_count: 0
  };
  for (var key in defaults) {
   if (opts[key] === undefined) {
    opts[key] = defaults[key];
   }
  }
  if (opts.recurse_count > 8) {
   throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
  }
  var parts = PATH.normalizeArray(path.split("/").filter((function(p) {
   return !!p;
  })), false);
  var current = FS.root;
  var current_path = "/";
  for (var i = 0; i < parts.length; i++) {
   var islast = i === parts.length - 1;
   if (islast && opts.parent) {
    break;
   }
   current = FS.lookupNode(current, parts[i]);
   current_path = PATH.join2(current_path, parts[i]);
   if (FS.isMountpoint(current)) {
    if (!islast || islast && opts.follow_mount) {
     current = current.mounted.root;
    }
   }
   if (!islast || opts.follow) {
    var count = 0;
    while (FS.isLink(current.mode)) {
     var link = FS.readlink(current_path);
     current_path = PATH.resolve(PATH.dirname(current_path), link);
     var lookup = FS.lookupPath(current_path, {
      recurse_count: opts.recurse_count
     });
     current = lookup.node;
     if (count++ > 40) {
      throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
     }
    }
   }
  }
  return {
   path: current_path,
   node: current
  };
 }),
 getPath: (function(node) {
  var path;
  while (true) {
   if (FS.isRoot(node)) {
    var mount = node.mount.mountpoint;
    if (!path) return mount;
    return mount[mount.length - 1] !== "/" ? mount + "/" + path : mount + path;
   }
   path = path ? node.name + "/" + path : node.name;
   node = node.parent;
  }
 }),
 hashName: (function(parentid, name) {
  var hash = 0;
  for (var i = 0; i < name.length; i++) {
   hash = (hash << 5) - hash + name.charCodeAt(i) | 0;
  }
  return (parentid + hash >>> 0) % FS.nameTable.length;
 }),
 hashAddNode: (function(node) {
  var hash = FS.hashName(node.parent.id, node.name);
  node.name_next = FS.nameTable[hash];
  FS.nameTable[hash] = node;
 }),
 hashRemoveNode: (function(node) {
  var hash = FS.hashName(node.parent.id, node.name);
  if (FS.nameTable[hash] === node) {
   FS.nameTable[hash] = node.name_next;
  } else {
   var current = FS.nameTable[hash];
   while (current) {
    if (current.name_next === node) {
     current.name_next = node.name_next;
     break;
    }
    current = current.name_next;
   }
  }
 }),
 lookupNode: (function(parent, name) {
  var err = FS.mayLookup(parent);
  if (err) {
   throw new FS.ErrnoError(err, parent);
  }
  var hash = FS.hashName(parent.id, name);
  for (var node = FS.nameTable[hash]; node; node = node.name_next) {
   var nodeName = node.name;
   if (node.parent.id === parent.id && nodeName === name) {
    return node;
   }
  }
  return FS.lookup(parent, name);
 }),
 createNode: (function(parent, name, mode, rdev) {
  if (!FS.FSNode) {
   FS.FSNode = (function(parent, name, mode, rdev) {
    if (!parent) {
     parent = this;
    }
    this.parent = parent;
    this.mount = parent.mount;
    this.mounted = null;
    this.id = FS.nextInode++;
    this.name = name;
    this.mode = mode;
    this.node_ops = {};
    this.stream_ops = {};
    this.rdev = rdev;
   });
   FS.FSNode.prototype = {};
   var readMode = 292 | 73;
   var writeMode = 146;
   Object.defineProperties(FS.FSNode.prototype, {
    read: {
     get: (function() {
      return (this.mode & readMode) === readMode;
     }),
     set: (function(val) {
      val ? this.mode |= readMode : this.mode &= ~readMode;
     })
    },
    write: {
     get: (function() {
      return (this.mode & writeMode) === writeMode;
     }),
     set: (function(val) {
      val ? this.mode |= writeMode : this.mode &= ~writeMode;
     })
    },
    isFolder: {
     get: (function() {
      return FS.isDir(this.mode);
     })
    },
    isDevice: {
     get: (function() {
      return FS.isChrdev(this.mode);
     })
    }
   });
  }
  var node = new FS.FSNode(parent, name, mode, rdev);
  FS.hashAddNode(node);
  return node;
 }),
 destroyNode: (function(node) {
  FS.hashRemoveNode(node);
 }),
 isRoot: (function(node) {
  return node === node.parent;
 }),
 isMountpoint: (function(node) {
  return !!node.mounted;
 }),
 isFile: (function(mode) {
  return (mode & 61440) === 32768;
 }),
 isDir: (function(mode) {
  return (mode & 61440) === 16384;
 }),
 isLink: (function(mode) {
  return (mode & 61440) === 40960;
 }),
 isChrdev: (function(mode) {
  return (mode & 61440) === 8192;
 }),
 isBlkdev: (function(mode) {
  return (mode & 61440) === 24576;
 }),
 isFIFO: (function(mode) {
  return (mode & 61440) === 4096;
 }),
 isSocket: (function(mode) {
  return (mode & 49152) === 49152;
 }),
 flagModes: {
  "r": 0,
  "rs": 1052672,
  "r+": 2,
  "w": 577,
  "wx": 705,
  "xw": 705,
  "w+": 578,
  "wx+": 706,
  "xw+": 706,
  "a": 1089,
  "ax": 1217,
  "xa": 1217,
  "a+": 1090,
  "ax+": 1218,
  "xa+": 1218
 },
 modeStringToFlags: (function(str) {
  var flags = FS.flagModes[str];
  if (typeof flags === "undefined") {
   throw new Error("Unknown file open mode: " + str);
  }
  return flags;
 }),
 flagsToPermissionString: (function(flag) {
  var accmode = flag & 2097155;
  var perms = [ "r", "w", "rw" ][accmode];
  if (flag & 512) {
   perms += "w";
  }
  return perms;
 }),
 nodePermissions: (function(node, perms) {
  if (FS.ignorePermissions) {
   return 0;
  }
  if (perms.indexOf("r") !== -1 && !(node.mode & 292)) {
   return ERRNO_CODES.EACCES;
  } else if (perms.indexOf("w") !== -1 && !(node.mode & 146)) {
   return ERRNO_CODES.EACCES;
  } else if (perms.indexOf("x") !== -1 && !(node.mode & 73)) {
   return ERRNO_CODES.EACCES;
  }
  return 0;
 }),
 mayLookup: (function(dir) {
  var err = FS.nodePermissions(dir, "x");
  if (err) return err;
  if (!dir.node_ops.lookup) return ERRNO_CODES.EACCES;
  return 0;
 }),
 mayCreate: (function(dir, name) {
  try {
   var node = FS.lookupNode(dir, name);
   return ERRNO_CODES.EEXIST;
  } catch (e) {}
  return FS.nodePermissions(dir, "wx");
 }),
 mayDelete: (function(dir, name, isdir) {
  var node;
  try {
   node = FS.lookupNode(dir, name);
  } catch (e) {
   return e.errno;
  }
  var err = FS.nodePermissions(dir, "wx");
  if (err) {
   return err;
  }
  if (isdir) {
   if (!FS.isDir(node.mode)) {
    return ERRNO_CODES.ENOTDIR;
   }
   if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
    return ERRNO_CODES.EBUSY;
   }
  } else {
   if (FS.isDir(node.mode)) {
    return ERRNO_CODES.EISDIR;
   }
  }
  return 0;
 }),
 mayOpen: (function(node, flags) {
  if (!node) {
   return ERRNO_CODES.ENOENT;
  }
  if (FS.isLink(node.mode)) {
   return ERRNO_CODES.ELOOP;
  } else if (FS.isDir(node.mode)) {
   if ((flags & 2097155) !== 0 || flags & 512) {
    return ERRNO_CODES.EISDIR;
   }
  }
  return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
 }),
 MAX_OPEN_FDS: 4096,
 nextfd: (function(fd_start, fd_end) {
  fd_start = fd_start || 0;
  fd_end = fd_end || FS.MAX_OPEN_FDS;
  for (var fd = fd_start; fd <= fd_end; fd++) {
   if (!FS.streams[fd]) {
    return fd;
   }
  }
  throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
 }),
 getStream: (function(fd) {
  return FS.streams[fd];
 }),
 createStream: (function(stream, fd_start, fd_end) {
  if (!FS.FSStream) {
   FS.FSStream = (function() {});
   FS.FSStream.prototype = {};
   Object.defineProperties(FS.FSStream.prototype, {
    object: {
     get: (function() {
      return this.node;
     }),
     set: (function(val) {
      this.node = val;
     })
    },
    isRead: {
     get: (function() {
      return (this.flags & 2097155) !== 1;
     })
    },
    isWrite: {
     get: (function() {
      return (this.flags & 2097155) !== 0;
     })
    },
    isAppend: {
     get: (function() {
      return this.flags & 1024;
     })
    }
   });
  }
  var newStream = new FS.FSStream;
  for (var p in stream) {
   newStream[p] = stream[p];
  }
  stream = newStream;
  var fd = FS.nextfd(fd_start, fd_end);
  stream.fd = fd;
  FS.streams[fd] = stream;
  return stream;
 }),
 closeStream: (function(fd) {
  FS.streams[fd] = null;
 }),
 getStreamFromPtr: (function(ptr) {
  return FS.streams[ptr - 1];
 }),
 getPtrForStream: (function(stream) {
  return stream ? stream.fd + 1 : 0;
 }),
 chrdev_stream_ops: {
  open: (function(stream) {
   var device = FS.getDevice(stream.node.rdev);
   stream.stream_ops = device.stream_ops;
   if (stream.stream_ops.open) {
    stream.stream_ops.open(stream);
   }
  }),
  llseek: (function() {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  })
 },
 major: (function(dev) {
  return dev >> 8;
 }),
 minor: (function(dev) {
  return dev & 255;
 }),
 makedev: (function(ma, mi) {
  return ma << 8 | mi;
 }),
 registerDevice: (function(dev, ops) {
  FS.devices[dev] = {
   stream_ops: ops
  };
 }),
 getDevice: (function(dev) {
  return FS.devices[dev];
 }),
 getMounts: (function(mount) {
  var mounts = [];
  var check = [ mount ];
  while (check.length) {
   var m = check.pop();
   mounts.push(m);
   check.push.apply(check, m.mounts);
  }
  return mounts;
 }),
 syncfs: (function(populate, callback) {
  if (typeof populate === "function") {
   callback = populate;
   populate = false;
  }
  var mounts = FS.getMounts(FS.root.mount);
  var completed = 0;
  function done(err) {
   if (err) {
    if (!done.errored) {
     done.errored = true;
     return callback(err);
    }
    return;
   }
   if (++completed >= mounts.length) {
    callback(null);
   }
  }
  mounts.forEach((function(mount) {
   if (!mount.type.syncfs) {
    return done(null);
   }
   mount.type.syncfs(mount, populate, done);
  }));
 }),
 mount: (function(type, opts, mountpoint) {
  var root = mountpoint === "/";
  var pseudo = !mountpoint;
  var node;
  if (root && FS.root) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  } else if (!root && !pseudo) {
   var lookup = FS.lookupPath(mountpoint, {
    follow_mount: false
   });
   mountpoint = lookup.path;
   node = lookup.node;
   if (FS.isMountpoint(node)) {
    throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
   }
   if (!FS.isDir(node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
   }
  }
  var mount = {
   type: type,
   opts: opts,
   mountpoint: mountpoint,
   mounts: []
  };
  var mountRoot = type.mount(mount);
  mountRoot.mount = mount;
  mount.root = mountRoot;
  if (root) {
   FS.root = mountRoot;
  } else if (node) {
   node.mounted = mount;
   if (node.mount) {
    node.mount.mounts.push(mount);
   }
  }
  return mountRoot;
 }),
 unmount: (function(mountpoint) {
  var lookup = FS.lookupPath(mountpoint, {
   follow_mount: false
  });
  if (!FS.isMountpoint(lookup.node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node = lookup.node;
  var mount = node.mounted;
  var mounts = FS.getMounts(mount);
  Object.keys(FS.nameTable).forEach((function(hash) {
   var current = FS.nameTable[hash];
   while (current) {
    var next = current.name_next;
    if (mounts.indexOf(current.mount) !== -1) {
     FS.destroyNode(current);
    }
    current = next;
   }
  }));
  node.mounted = null;
  var idx = node.mount.mounts.indexOf(mount);
  assert(idx !== -1);
  node.mount.mounts.splice(idx, 1);
 }),
 lookup: (function(parent, name) {
  return parent.node_ops.lookup(parent, name);
 }),
 mknod: (function(path, mode, dev) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  if (!name || name === "." || name === "..") {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var err = FS.mayCreate(parent, name);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.mknod) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return parent.node_ops.mknod(parent, name, mode, dev);
 }),
 create: (function(path, mode) {
  mode = mode !== undefined ? mode : 438;
  mode &= 4095;
  mode |= 32768;
  return FS.mknod(path, mode, 0);
 }),
 mkdir: (function(path, mode) {
  mode = mode !== undefined ? mode : 511;
  mode &= 511 | 512;
  mode |= 16384;
  return FS.mknod(path, mode, 0);
 }),
 mkdev: (function(path, mode, dev) {
  if (typeof dev === "undefined") {
   dev = mode;
   mode = 438;
  }
  mode |= 8192;
  return FS.mknod(path, mode, dev);
 }),
 symlink: (function(oldpath, newpath) {
  if (!PATH.resolve(oldpath)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  var lookup = FS.lookupPath(newpath, {
   parent: true
  });
  var parent = lookup.node;
  if (!parent) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  var newname = PATH.basename(newpath);
  var err = FS.mayCreate(parent, newname);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.symlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return parent.node_ops.symlink(parent, newname, oldpath);
 }),
 rename: (function(old_path, new_path) {
  var old_dirname = PATH.dirname(old_path);
  var new_dirname = PATH.dirname(new_path);
  var old_name = PATH.basename(old_path);
  var new_name = PATH.basename(new_path);
  var lookup, old_dir, new_dir;
  try {
   lookup = FS.lookupPath(old_path, {
    parent: true
   });
   old_dir = lookup.node;
   lookup = FS.lookupPath(new_path, {
    parent: true
   });
   new_dir = lookup.node;
  } catch (e) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  if (!old_dir || !new_dir) throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  if (old_dir.mount !== new_dir.mount) {
   throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
  }
  var old_node = FS.lookupNode(old_dir, old_name);
  var relative = PATH.relative(old_path, new_dirname);
  if (relative.charAt(0) !== ".") {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  relative = PATH.relative(new_path, old_dirname);
  if (relative.charAt(0) !== ".") {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
  }
  var new_node;
  try {
   new_node = FS.lookupNode(new_dir, new_name);
  } catch (e) {}
  if (old_node === new_node) {
   return;
  }
  var isdir = FS.isDir(old_node.mode);
  var err = FS.mayDelete(old_dir, old_name, isdir);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  err = new_node ? FS.mayDelete(new_dir, new_name, isdir) : FS.mayCreate(new_dir, new_name);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!old_dir.node_ops.rename) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(old_node) || new_node && FS.isMountpoint(new_node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  if (new_dir !== old_dir) {
   err = FS.nodePermissions(old_dir, "w");
   if (err) {
    throw new FS.ErrnoError(err);
   }
  }
  try {
   if (FS.trackingDelegate["willMovePath"]) {
    FS.trackingDelegate["willMovePath"](old_path, new_path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message);
  }
  FS.hashRemoveNode(old_node);
  try {
   old_dir.node_ops.rename(old_node, new_dir, new_name);
  } catch (e) {
   throw e;
  } finally {
   FS.hashAddNode(old_node);
  }
  try {
   if (FS.trackingDelegate["onMovePath"]) FS.trackingDelegate["onMovePath"](old_path, new_path);
  } catch (e) {
   console.log("FS.trackingDelegate['onMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message);
  }
 }),
 rmdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  var node = FS.lookupNode(parent, name);
  var err = FS.mayDelete(parent, name, true);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.rmdir) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  try {
   if (FS.trackingDelegate["willDeletePath"]) {
    FS.trackingDelegate["willDeletePath"](path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message);
  }
  parent.node_ops.rmdir(parent, name);
  FS.destroyNode(node);
  try {
   if (FS.trackingDelegate["onDeletePath"]) FS.trackingDelegate["onDeletePath"](path);
  } catch (e) {
   console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message);
  }
 }),
 readdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  var node = lookup.node;
  if (!node.node_ops.readdir) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  return node.node_ops.readdir(node);
 }),
 unlink: (function(path) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  var node = FS.lookupNode(parent, name);
  var err = FS.mayDelete(parent, name, false);
  if (err) {
   if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.unlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  try {
   if (FS.trackingDelegate["willDeletePath"]) {
    FS.trackingDelegate["willDeletePath"](path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message);
  }
  parent.node_ops.unlink(parent, name);
  FS.destroyNode(node);
  try {
   if (FS.trackingDelegate["onDeletePath"]) FS.trackingDelegate["onDeletePath"](path);
  } catch (e) {
   console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message);
  }
 }),
 readlink: (function(path) {
  var lookup = FS.lookupPath(path);
  var link = lookup.node;
  if (!link) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (!link.node_ops.readlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  return link.node_ops.readlink(link);
 }),
 stat: (function(path, dontFollow) {
  var lookup = FS.lookupPath(path, {
   follow: !dontFollow
  });
  var node = lookup.node;
  if (!node) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (!node.node_ops.getattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return node.node_ops.getattr(node);
 }),
 lstat: (function(path) {
  return FS.stat(path, true);
 }),
 chmod: (function(path, mode, dontFollow) {
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: !dontFollow
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  node.node_ops.setattr(node, {
   mode: mode & 4095 | node.mode & ~4095,
   timestamp: Date.now()
  });
 }),
 lchmod: (function(path, mode) {
  FS.chmod(path, mode, true);
 }),
 fchmod: (function(fd, mode) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  FS.chmod(stream.node, mode);
 }),
 chown: (function(path, uid, gid, dontFollow) {
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: !dontFollow
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  node.node_ops.setattr(node, {
   timestamp: Date.now()
  });
 }),
 lchown: (function(path, uid, gid) {
  FS.chown(path, uid, gid, true);
 }),
 fchown: (function(fd, uid, gid) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  FS.chown(stream.node, uid, gid);
 }),
 truncate: (function(path, len) {
  if (len < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: true
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!FS.isFile(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var err = FS.nodePermissions(node, "w");
  if (err) {
   throw new FS.ErrnoError(err);
  }
  node.node_ops.setattr(node, {
   size: len,
   timestamp: Date.now()
  });
 }),
 ftruncate: (function(fd, len) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  FS.truncate(stream.node, len);
 }),
 utime: (function(path, atime, mtime) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  var node = lookup.node;
  node.node_ops.setattr(node, {
   timestamp: Math.max(atime, mtime)
  });
 }),
 open: (function(path, flags, mode, fd_start, fd_end) {
  if (path === "") {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  flags = typeof flags === "string" ? FS.modeStringToFlags(flags) : flags;
  mode = typeof mode === "undefined" ? 438 : mode;
  if (flags & 64) {
   mode = mode & 4095 | 32768;
  } else {
   mode = 0;
  }
  var node;
  if (typeof path === "object") {
   node = path;
  } else {
   path = PATH.normalize(path);
   try {
    var lookup = FS.lookupPath(path, {
     follow: !(flags & 131072)
    });
    node = lookup.node;
   } catch (e) {}
  }
  var created = false;
  if (flags & 64) {
   if (node) {
    if (flags & 128) {
     throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
    }
   } else {
    node = FS.mknod(path, mode, 0);
    created = true;
   }
  }
  if (!node) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (FS.isChrdev(node.mode)) {
   flags &= ~512;
  }
  if (!created) {
   var err = FS.mayOpen(node, flags);
   if (err) {
    throw new FS.ErrnoError(err);
   }
  }
  if (flags & 512) {
   FS.truncate(node, 0);
  }
  flags &= ~(128 | 512);
  var stream = FS.createStream({
   node: node,
   path: FS.getPath(node),
   flags: flags,
   seekable: true,
   position: 0,
   stream_ops: node.stream_ops,
   ungotten: [],
   error: false
  }, fd_start, fd_end);
  if (stream.stream_ops.open) {
   stream.stream_ops.open(stream);
  }
  if (Module["logReadFiles"] && !(flags & 1)) {
   if (!FS.readFiles) FS.readFiles = {};
   if (!(path in FS.readFiles)) {
    FS.readFiles[path] = 1;
    Module["printErr"]("read file: " + path);
   }
  }
  try {
   if (FS.trackingDelegate["onOpenFile"]) {
    var trackingFlags = 0;
    if ((flags & 2097155) !== 1) {
     trackingFlags |= FS.tracking.openFlags.READ;
    }
    if ((flags & 2097155) !== 0) {
     trackingFlags |= FS.tracking.openFlags.WRITE;
    }
    FS.trackingDelegate["onOpenFile"](path, trackingFlags);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['onOpenFile']('" + path + "', flags) threw an exception: " + e.message);
  }
  return stream;
 }),
 close: (function(stream) {
  try {
   if (stream.stream_ops.close) {
    stream.stream_ops.close(stream);
   }
  } catch (e) {
   throw e;
  } finally {
   FS.closeStream(stream.fd);
  }
 }),
 llseek: (function(stream, offset, whence) {
  if (!stream.seekable || !stream.stream_ops.llseek) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  stream.position = stream.stream_ops.llseek(stream, offset, whence);
  stream.ungotten = [];
  return stream.position;
 }),
 read: (function(stream, buffer, offset, length, position) {
  if (length < 0 || position < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 1) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (FS.isDir(stream.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!stream.stream_ops.read) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var seeking = true;
  if (typeof position === "undefined") {
   position = stream.position;
   seeking = false;
  } else if (!stream.seekable) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
  if (!seeking) stream.position += bytesRead;
  return bytesRead;
 }),
 write: (function(stream, buffer, offset, length, position, canOwn) {
  if (length < 0 || position < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (FS.isDir(stream.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!stream.stream_ops.write) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if (stream.flags & 1024) {
   FS.llseek(stream, 0, 2);
  }
  var seeking = true;
  if (typeof position === "undefined") {
   position = stream.position;
   seeking = false;
  } else if (!stream.seekable) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
  if (!seeking) stream.position += bytesWritten;
  try {
   if (stream.path && FS.trackingDelegate["onWriteToFile"]) FS.trackingDelegate["onWriteToFile"](stream.path);
  } catch (e) {
   console.log("FS.trackingDelegate['onWriteToFile']('" + path + "') threw an exception: " + e.message);
  }
  return bytesWritten;
 }),
 allocate: (function(stream, offset, length) {
  if (offset < 0 || length <= 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
  }
  if (!stream.stream_ops.allocate) {
   throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
  }
  stream.stream_ops.allocate(stream, offset, length);
 }),
 mmap: (function(stream, buffer, offset, length, position, prot, flags) {
  if ((stream.flags & 2097155) === 1) {
   throw new FS.ErrnoError(ERRNO_CODES.EACCES);
  }
  if (!stream.stream_ops.mmap) {
   throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
  }
  return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
 }),
 ioctl: (function(stream, cmd, arg) {
  if (!stream.stream_ops.ioctl) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
  }
  return stream.stream_ops.ioctl(stream, cmd, arg);
 }),
 readFile: (function(path, opts) {
  opts = opts || {};
  opts.flags = opts.flags || "r";
  opts.encoding = opts.encoding || "binary";
  if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
   throw new Error('Invalid encoding type "' + opts.encoding + '"');
  }
  var ret;
  var stream = FS.open(path, opts.flags);
  var stat = FS.stat(path);
  var length = stat.size;
  var buf = new Uint8Array(length);
  FS.read(stream, buf, 0, length, 0);
  if (opts.encoding === "utf8") {
   ret = UTF8ArrayToString(buf, 0);
  } else if (opts.encoding === "binary") {
   ret = buf;
  }
  FS.close(stream);
  return ret;
 }),
 writeFile: (function(path, data, opts) {
  opts = opts || {};
  opts.flags = opts.flags || "w";
  opts.encoding = opts.encoding || "utf8";
  if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
   throw new Error('Invalid encoding type "' + opts.encoding + '"');
  }
  var stream = FS.open(path, opts.flags, opts.mode);
  if (opts.encoding === "utf8") {
   var buf = new Uint8Array(lengthBytesUTF8(data) + 1);
   var actualNumBytes = stringToUTF8Array(data, buf, 0, buf.length);
   FS.write(stream, buf, 0, actualNumBytes, 0, opts.canOwn);
  } else if (opts.encoding === "binary") {
   FS.write(stream, data, 0, data.length, 0, opts.canOwn);
  }
  FS.close(stream);
 }),
 cwd: (function() {
  return FS.currentPath;
 }),
 chdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  if (!FS.isDir(lookup.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  var err = FS.nodePermissions(lookup.node, "x");
  if (err) {
   throw new FS.ErrnoError(err);
  }
  FS.currentPath = lookup.path;
 }),
 createDefaultDirectories: (function() {
  FS.mkdir("/tmp");
  FS.mkdir("/home");
  FS.mkdir("/home/web_user");
 }),
 createDefaultDevices: (function() {
  FS.mkdir("/dev");
  FS.registerDevice(FS.makedev(1, 3), {
   read: (function() {
    return 0;
   }),
   write: (function() {
    return 0;
   })
  });
  FS.mkdev("/dev/null", FS.makedev(1, 3));
  TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
  TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
  FS.mkdev("/dev/tty", FS.makedev(5, 0));
  FS.mkdev("/dev/tty1", FS.makedev(6, 0));
  var random_device;
  if (typeof crypto !== "undefined") {
   var randomBuffer = new Uint8Array(1);
   random_device = (function() {
    crypto.getRandomValues(randomBuffer);
    return randomBuffer[0];
   });
  } else if (ENVIRONMENT_IS_NODE) {
   random_device = (function() {
    return require("crypto").randomBytes(1)[0];
   });
  } else {
   random_device = (function() {
    return Math.random() * 256 | 0;
   });
  }
  FS.createDevice("/dev", "random", random_device);
  FS.createDevice("/dev", "urandom", random_device);
  FS.mkdir("/dev/shm");
  FS.mkdir("/dev/shm/tmp");
 }),
 createStandardStreams: (function() {
  if (Module["stdin"]) {
   FS.createDevice("/dev", "stdin", Module["stdin"]);
  } else {
   FS.symlink("/dev/tty", "/dev/stdin");
  }
  if (Module["stdout"]) {
   FS.createDevice("/dev", "stdout", null, Module["stdout"]);
  } else {
   FS.symlink("/dev/tty", "/dev/stdout");
  }
  if (Module["stderr"]) {
   FS.createDevice("/dev", "stderr", null, Module["stderr"]);
  } else {
   FS.symlink("/dev/tty1", "/dev/stderr");
  }
  var stdin = FS.open("/dev/stdin", "r");
  HEAP32[_stdin >> 2] = FS.getPtrForStream(stdin);
  assert(stdin.fd === 0, "invalid handle for stdin (" + stdin.fd + ")");
  var stdout = FS.open("/dev/stdout", "w");
  HEAP32[_stdout >> 2] = FS.getPtrForStream(stdout);
  assert(stdout.fd === 1, "invalid handle for stdout (" + stdout.fd + ")");
  var stderr = FS.open("/dev/stderr", "w");
  HEAP32[_stderr >> 2] = FS.getPtrForStream(stderr);
  assert(stderr.fd === 2, "invalid handle for stderr (" + stderr.fd + ")");
 }),
 ensureErrnoError: (function() {
  if (FS.ErrnoError) return;
  FS.ErrnoError = function ErrnoError(errno, node) {
   this.node = node;
   this.setErrno = (function(errno) {
    this.errno = errno;
    for (var key in ERRNO_CODES) {
     if (ERRNO_CODES[key] === errno) {
      this.code = key;
      break;
     }
    }
   });
   this.setErrno(errno);
   this.message = ERRNO_MESSAGES[errno];
  };
  FS.ErrnoError.prototype = new Error;
  FS.ErrnoError.prototype.constructor = FS.ErrnoError;
  [ ERRNO_CODES.ENOENT ].forEach((function(code) {
   FS.genericErrors[code] = new FS.ErrnoError(code);
   FS.genericErrors[code].stack = "<generic error, no stack>";
  }));
 }),
 staticInit: (function() {
  FS.ensureErrnoError();
  FS.nameTable = new Array(4096);
  FS.mount(MEMFS, {}, "/");
  FS.createDefaultDirectories();
  FS.createDefaultDevices();
 }),
 init: (function(input, output, error) {
  assert(!FS.init.initialized, "FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");
  FS.init.initialized = true;
  FS.ensureErrnoError();
  Module["stdin"] = input || Module["stdin"];
  Module["stdout"] = output || Module["stdout"];
  Module["stderr"] = error || Module["stderr"];
  FS.createStandardStreams();
 }),
 quit: (function() {
  FS.init.initialized = false;
  for (var i = 0; i < FS.streams.length; i++) {
   var stream = FS.streams[i];
   if (!stream) {
    continue;
   }
   FS.close(stream);
  }
 }),
 getMode: (function(canRead, canWrite) {
  var mode = 0;
  if (canRead) mode |= 292 | 73;
  if (canWrite) mode |= 146;
  return mode;
 }),
 joinPath: (function(parts, forceRelative) {
  var path = PATH.join.apply(null, parts);
  if (forceRelative && path[0] == "/") path = path.substr(1);
  return path;
 }),
 absolutePath: (function(relative, base) {
  return PATH.resolve(base, relative);
 }),
 standardizePath: (function(path) {
  return PATH.normalize(path);
 }),
 findObject: (function(path, dontResolveLastLink) {
  var ret = FS.analyzePath(path, dontResolveLastLink);
  if (ret.exists) {
   return ret.object;
  } else {
   ___setErrNo(ret.error);
   return null;
  }
 }),
 analyzePath: (function(path, dontResolveLastLink) {
  try {
   var lookup = FS.lookupPath(path, {
    follow: !dontResolveLastLink
   });
   path = lookup.path;
  } catch (e) {}
  var ret = {
   isRoot: false,
   exists: false,
   error: 0,
   name: null,
   path: null,
   object: null,
   parentExists: false,
   parentPath: null,
   parentObject: null
  };
  try {
   var lookup = FS.lookupPath(path, {
    parent: true
   });
   ret.parentExists = true;
   ret.parentPath = lookup.path;
   ret.parentObject = lookup.node;
   ret.name = PATH.basename(path);
   lookup = FS.lookupPath(path, {
    follow: !dontResolveLastLink
   });
   ret.exists = true;
   ret.path = lookup.path;
   ret.object = lookup.node;
   ret.name = lookup.node.name;
   ret.isRoot = lookup.path === "/";
  } catch (e) {
   ret.error = e.errno;
  }
  return ret;
 }),
 createFolder: (function(parent, name, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(canRead, canWrite);
  return FS.mkdir(path, mode);
 }),
 createPath: (function(parent, path, canRead, canWrite) {
  parent = typeof parent === "string" ? parent : FS.getPath(parent);
  var parts = path.split("/").reverse();
  while (parts.length) {
   var part = parts.pop();
   if (!part) continue;
   var current = PATH.join2(parent, part);
   try {
    FS.mkdir(current);
   } catch (e) {}
   parent = current;
  }
  return current;
 }),
 createFile: (function(parent, name, properties, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(canRead, canWrite);
  return FS.create(path, mode);
 }),
 createDataFile: (function(parent, name, data, canRead, canWrite, canOwn) {
  var path = name ? PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name) : parent;
  var mode = FS.getMode(canRead, canWrite);
  var node = FS.create(path, mode);
  if (data) {
   if (typeof data === "string") {
    var arr = new Array(data.length);
    for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
    data = arr;
   }
   FS.chmod(node, mode | 146);
   var stream = FS.open(node, "w");
   FS.write(stream, data, 0, data.length, 0, canOwn);
   FS.close(stream);
   FS.chmod(node, mode);
  }
  return node;
 }),
 createDevice: (function(parent, name, input, output) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(!!input, !!output);
  if (!FS.createDevice.major) FS.createDevice.major = 64;
  var dev = FS.makedev(FS.createDevice.major++, 0);
  FS.registerDevice(dev, {
   open: (function(stream) {
    stream.seekable = false;
   }),
   close: (function(stream) {
    if (output && output.buffer && output.buffer.length) {
     output(10);
    }
   }),
   read: (function(stream, buffer, offset, length, pos) {
    var bytesRead = 0;
    for (var i = 0; i < length; i++) {
     var result;
     try {
      result = input();
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES.EIO);
     }
     if (result === undefined && bytesRead === 0) {
      throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
     }
     if (result === null || result === undefined) break;
     bytesRead++;
     buffer[offset + i] = result;
    }
    if (bytesRead) {
     stream.node.timestamp = Date.now();
    }
    return bytesRead;
   }),
   write: (function(stream, buffer, offset, length, pos) {
    for (var i = 0; i < length; i++) {
     try {
      output(buffer[offset + i]);
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES.EIO);
     }
    }
    if (length) {
     stream.node.timestamp = Date.now();
    }
    return i;
   })
  });
  return FS.mkdev(path, mode, dev);
 }),
 createLink: (function(parent, name, target, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  return FS.symlink(target, path);
 }),
 forceLoadFile: (function(obj) {
  if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
  var success = true;
  if (typeof XMLHttpRequest !== "undefined") {
   throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
  } else if (Module["read"]) {
   try {
    obj.contents = intArrayFromString(Module["read"](obj.url), true);
    obj.usedBytes = obj.contents.length;
   } catch (e) {
    success = false;
   }
  } else {
   throw new Error("Cannot load without read() or XMLHttpRequest.");
  }
  if (!success) ___setErrNo(ERRNO_CODES.EIO);
  return success;
 }),
 createLazyFile: (function(parent, name, url, canRead, canWrite) {
  function LazyUint8Array() {
   this.lengthKnown = false;
   this.chunks = [];
  }
  LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
   if (idx > this.length - 1 || idx < 0) {
    return undefined;
   }
   var chunkOffset = idx % this.chunkSize;
   var chunkNum = idx / this.chunkSize | 0;
   return this.getter(chunkNum)[chunkOffset];
  };
  LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
   this.getter = getter;
  };
  LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
   var xhr = new XMLHttpRequest;
   xhr.open("HEAD", url, false);
   xhr.send(null);
   if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
   var datalength = Number(xhr.getResponseHeader("Content-length"));
   var header;
   var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
   var chunkSize = 1024 * 1024;
   if (!hasByteServing) chunkSize = datalength;
   var doXHR = (function(from, to) {
    if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
    if (to > datalength - 1) throw new Error("only " + datalength + " bytes available! programmer error!");
    var xhr = new XMLHttpRequest;
    xhr.open("GET", url, false);
    if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
    if (typeof Uint8Array != "undefined") xhr.responseType = "arraybuffer";
    if (xhr.overrideMimeType) {
     xhr.overrideMimeType("text/plain; charset=x-user-defined");
    }
    xhr.send(null);
    if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
    if (xhr.response !== undefined) {
     return new Uint8Array(xhr.response || []);
    } else {
     return intArrayFromString(xhr.responseText || "", true);
    }
   });
   var lazyArray = this;
   lazyArray.setDataGetter((function(chunkNum) {
    var start = chunkNum * chunkSize;
    var end = (chunkNum + 1) * chunkSize - 1;
    end = Math.min(end, datalength - 1);
    if (typeof lazyArray.chunks[chunkNum] === "undefined") {
     lazyArray.chunks[chunkNum] = doXHR(start, end);
    }
    if (typeof lazyArray.chunks[chunkNum] === "undefined") throw new Error("doXHR failed!");
    return lazyArray.chunks[chunkNum];
   }));
   this._length = datalength;
   this._chunkSize = chunkSize;
   this.lengthKnown = true;
  };
  if (typeof XMLHttpRequest !== "undefined") {
   if (!ENVIRONMENT_IS_WORKER) throw "Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";
   var lazyArray = new LazyUint8Array;
   Object.defineProperty(lazyArray, "length", {
    get: (function() {
     if (!this.lengthKnown) {
      this.cacheLength();
     }
     return this._length;
    })
   });
   Object.defineProperty(lazyArray, "chunkSize", {
    get: (function() {
     if (!this.lengthKnown) {
      this.cacheLength();
     }
     return this._chunkSize;
    })
   });
   var properties = {
    isDevice: false,
    contents: lazyArray
   };
  } else {
   var properties = {
    isDevice: false,
    url: url
   };
  }
  var node = FS.createFile(parent, name, properties, canRead, canWrite);
  if (properties.contents) {
   node.contents = properties.contents;
  } else if (properties.url) {
   node.contents = null;
   node.url = properties.url;
  }
  Object.defineProperty(node, "usedBytes", {
   get: (function() {
    return this.contents.length;
   })
  });
  var stream_ops = {};
  var keys = Object.keys(node.stream_ops);
  keys.forEach((function(key) {
   var fn = node.stream_ops[key];
   stream_ops[key] = function forceLoadLazyFile() {
    if (!FS.forceLoadFile(node)) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
    return fn.apply(null, arguments);
   };
  }));
  stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
   if (!FS.forceLoadFile(node)) {
    throw new FS.ErrnoError(ERRNO_CODES.EIO);
   }
   var contents = stream.node.contents;
   if (position >= contents.length) return 0;
   var size = Math.min(contents.length - position, length);
   assert(size >= 0);
   if (contents.slice) {
    for (var i = 0; i < size; i++) {
     buffer[offset + i] = contents[position + i];
    }
   } else {
    for (var i = 0; i < size; i++) {
     buffer[offset + i] = contents.get(position + i);
    }
   }
   return size;
  };
  node.stream_ops = stream_ops;
  return node;
 }),
 createPreloadedFile: (function(parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
  Browser.init();
  var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
  function processData(byteArray) {
   function finish(byteArray) {
    if (!dontCreateFile) {
     FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
    }
    if (onload) onload();
    removeRunDependency("cp " + fullname);
   }
   var handled = false;
   Module["preloadPlugins"].forEach((function(plugin) {
    if (handled) return;
    if (plugin["canHandle"](fullname)) {
     plugin["handle"](byteArray, fullname, finish, (function() {
      if (onerror) onerror();
      removeRunDependency("cp " + fullname);
     }));
     handled = true;
    }
   }));
   if (!handled) finish(byteArray);
  }
  addRunDependency("cp " + fullname);
  if (typeof url == "string") {
   Browser.asyncLoad(url, (function(byteArray) {
    processData(byteArray);
   }), onerror);
  } else {
   processData(url);
  }
 }),
 indexedDB: (function() {
  return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
 }),
 DB_NAME: (function() {
  return "EM_FS_" + window.location.pathname;
 }),
 DB_VERSION: 20,
 DB_STORE_NAME: "FILE_DATA",
 saveFilesToDB: (function(paths, onload, onerror) {
  onload = onload || (function() {});
  onerror = onerror || (function() {});
  var indexedDB = FS.indexedDB();
  try {
   var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
  } catch (e) {
   return onerror(e);
  }
  openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
   console.log("creating db");
   var db = openRequest.result;
   db.createObjectStore(FS.DB_STORE_NAME);
  };
  openRequest.onsuccess = function openRequest_onsuccess() {
   var db = openRequest.result;
   var transaction = db.transaction([ FS.DB_STORE_NAME ], "readwrite");
   var files = transaction.objectStore(FS.DB_STORE_NAME);
   var ok = 0, fail = 0, total = paths.length;
   function finish() {
    if (fail == 0) onload(); else onerror();
   }
   paths.forEach((function(path) {
    var putRequest = files.put(FS.analyzePath(path).object.contents, path);
    putRequest.onsuccess = function putRequest_onsuccess() {
     ok++;
     if (ok + fail == total) finish();
    };
    putRequest.onerror = function putRequest_onerror() {
     fail++;
     if (ok + fail == total) finish();
    };
   }));
   transaction.onerror = onerror;
  };
  openRequest.onerror = onerror;
 }),
 loadFilesFromDB: (function(paths, onload, onerror) {
  onload = onload || (function() {});
  onerror = onerror || (function() {});
  var indexedDB = FS.indexedDB();
  try {
   var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
  } catch (e) {
   return onerror(e);
  }
  openRequest.onupgradeneeded = onerror;
  openRequest.onsuccess = function openRequest_onsuccess() {
   var db = openRequest.result;
   try {
    var transaction = db.transaction([ FS.DB_STORE_NAME ], "readonly");
   } catch (e) {
    onerror(e);
    return;
   }
   var files = transaction.objectStore(FS.DB_STORE_NAME);
   var ok = 0, fail = 0, total = paths.length;
   function finish() {
    if (fail == 0) onload(); else onerror();
   }
   paths.forEach((function(path) {
    var getRequest = files.get(path);
    getRequest.onsuccess = function getRequest_onsuccess() {
     if (FS.analyzePath(path).exists) {
      FS.unlink(path);
     }
     FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
     ok++;
     if (ok + fail == total) finish();
    };
    getRequest.onerror = function getRequest_onerror() {
     fail++;
     if (ok + fail == total) finish();
    };
   }));
   transaction.onerror = onerror;
  };
  openRequest.onerror = onerror;
 })
};
function _close(fildes) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  FS.close(stream);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fsync(fildes) {
 var stream = FS.getStream(fildes);
 if (stream) {
  return 0;
 } else {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
}
function _fileno(stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) return -1;
 return stream.fd;
}
function _fclose(stream) {
 var fd = _fileno(stream);
 _fsync(fd);
 return _close(fd);
}
function _pthread_mutex_lock() {}
var _acosf = Math_acos;
function _emscripten_glStencilFunc(x0, x1, x2) {
 GLctx.stencilFunc(x0, x1, x2);
}
function _glFramebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer) {
 GLctx.framebufferRenderbuffer(target, attachment, renderbuffertarget, GL.renderbuffers[renderbuffer]);
}
function _emscripten_glVertexPointer() {
 throw "Legacy GL function (glVertexPointer) called. If you want legacy GL emulation, you need to compile with -s LEGACY_GL_EMULATION=1 to enable legacy GL emulation.";
}
function _emscripten_glUniform3iv(location, count, value) {
 location = GL.uniforms[location];
 count *= 3;
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform3iv(location, value);
}
var _llvm_pow_f32 = Math_pow;
var _tzname = allocate(8, "i32*", ALLOC_STATIC);
var _daylight = allocate(1, "i32*", ALLOC_STATIC);
var _timezone = allocate(1, "i32*", ALLOC_STATIC);
function _tzset() {
 if (_tzset.called) return;
 _tzset.called = true;
 HEAP32[_timezone >> 2] = -(new Date).getTimezoneOffset() * 60;
 var winter = new Date(2e3, 0, 1);
 var summer = new Date(2e3, 6, 1);
 HEAP32[_daylight >> 2] = Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
 function extractZone(date) {
  var match = date.toTimeString().match(/\(([A-Za-z ]+)\)$/);
  return match ? match[1] : "GMT";
 }
 var winterName = extractZone(winter);
 var summerName = extractZone(summer);
 var winterNamePtr = allocate(intArrayFromString(winterName), "i8", ALLOC_NORMAL);
 var summerNamePtr = allocate(intArrayFromString(summerName), "i8", ALLOC_NORMAL);
 if (summer.getTimezoneOffset() < winter.getTimezoneOffset()) {
  HEAP32[_tzname >> 2] = winterNamePtr;
  HEAP32[_tzname + 4 >> 2] = summerNamePtr;
 } else {
  HEAP32[_tzname >> 2] = summerNamePtr;
  HEAP32[_tzname + 4 >> 2] = winterNamePtr;
 }
}
function _mktime(tmPtr) {
 _tzset();
 var date = new Date(HEAP32[tmPtr + 20 >> 2] + 1900, HEAP32[tmPtr + 16 >> 2], HEAP32[tmPtr + 12 >> 2], HEAP32[tmPtr + 8 >> 2], HEAP32[tmPtr + 4 >> 2], HEAP32[tmPtr >> 2], 0);
 var dst = HEAP32[tmPtr + 32 >> 2];
 var guessedOffset = date.getTimezoneOffset();
 var start = new Date(date.getFullYear(), 0, 1);
 var summerOffset = (new Date(2e3, 6, 1)).getTimezoneOffset();
 var winterOffset = start.getTimezoneOffset();
 var dstOffset = Math.min(winterOffset, summerOffset);
 if (dst < 0) {
  HEAP32[tmPtr + 32 >> 2] = Number(winterOffset != guessedOffset);
 } else if (dst > 0 != (winterOffset != guessedOffset)) {
  var summerOffset = (new Date(date.getFullYear(), 6, 1)).getTimezoneOffset();
  var trueOffset = dst > 0 ? summerOffset : winterOffset;
  date.setTime(date.getTime() + (trueOffset - guessedOffset) * 6e4);
 }
 HEAP32[tmPtr + 24 >> 2] = date.getDay();
 var yday = (date.getTime() - start.getTime()) / (1e3 * 60 * 60 * 24) | 0;
 HEAP32[tmPtr + 28 >> 2] = yday;
 return date.getTime() / 1e3 | 0;
}
function _emscripten_glTexParameterf(x0, x1, x2) {
 GLctx.texParameterf(x0, x1, x2);
}
var JSEvents = {
 keyEvent: 0,
 mouseEvent: 0,
 wheelEvent: 0,
 uiEvent: 0,
 focusEvent: 0,
 deviceOrientationEvent: 0,
 deviceMotionEvent: 0,
 fullscreenChangeEvent: 0,
 pointerlockChangeEvent: 0,
 visibilityChangeEvent: 0,
 touchEvent: 0,
 previousFullscreenElement: null,
 previousScreenX: null,
 previousScreenY: null,
 removeEventListenersRegistered: false,
 registerRemoveEventListeners: (function() {
  if (!JSEvents.removeEventListenersRegistered) {
   __ATEXIT__.push({
    func: (function() {
     for (var i = JSEvents.eventHandlers.length - 1; i >= 0; --i) {
      JSEvents._removeHandler(i);
     }
    })
   });
   JSEvents.removeEventListenersRegistered = true;
  }
 }),
 findEventTarget: (function(target) {
  if (target) {
   if (typeof target == "number") {
    target = Pointer_stringify(target);
   }
   if (target == "#window") return window; else if (target == "#document") return document; else if (target == "#screen") return window.screen; else if (target == "#canvas") return Module["canvas"];
   if (typeof target == "string") return document.getElementById(target); else return target;
  } else {
   return window;
  }
 }),
 deferredCalls: [],
 deferCall: (function(targetFunction, precedence, argsList) {
  function arraysHaveEqualContent(arrA, arrB) {
   if (arrA.length != arrB.length) return false;
   for (var i in arrA) {
    if (arrA[i] != arrB[i]) return false;
   }
   return true;
  }
  for (var i in JSEvents.deferredCalls) {
   var call = JSEvents.deferredCalls[i];
   if (call.targetFunction == targetFunction && arraysHaveEqualContent(call.argsList, argsList)) {
    return;
   }
  }
  JSEvents.deferredCalls.push({
   targetFunction: targetFunction,
   precedence: precedence,
   argsList: argsList
  });
  JSEvents.deferredCalls.sort((function(x, y) {
   return x.precedence < y.precedence;
  }));
 }),
 removeDeferredCalls: (function(targetFunction) {
  for (var i = 0; i < JSEvents.deferredCalls.length; ++i) {
   if (JSEvents.deferredCalls[i].targetFunction == targetFunction) {
    JSEvents.deferredCalls.splice(i, 1);
    --i;
   }
  }
 }),
 canPerformEventHandlerRequests: (function() {
  return JSEvents.inEventHandler && JSEvents.currentEventHandler.allowsDeferredCalls;
 }),
 runDeferredCalls: (function() {
  if (!JSEvents.canPerformEventHandlerRequests()) {
   return;
  }
  for (var i = 0; i < JSEvents.deferredCalls.length; ++i) {
   var call = JSEvents.deferredCalls[i];
   JSEvents.deferredCalls.splice(i, 1);
   --i;
   call.targetFunction.apply(this, call.argsList);
  }
 }),
 inEventHandler: 0,
 currentEventHandler: null,
 eventHandlers: [],
 isInternetExplorer: (function() {
  return navigator.userAgent.indexOf("MSIE") !== -1 || navigator.appVersion.indexOf("Trident/") > 0;
 }),
 removeAllHandlersOnTarget: (function(target, eventTypeString) {
  for (var i = 0; i < JSEvents.eventHandlers.length; ++i) {
   if (JSEvents.eventHandlers[i].target == target && (!eventType || eventTypeString == JSEvents.eventHandlers[i].eventTypeString)) {
    JSEvents._removeHandler(i--);
   }
  }
 }),
 _removeHandler: (function(i) {
  var h = JSEvents.eventHandlers[i];
  h.target.removeEventListener(h.eventTypeString, h.eventListenerFunc, h.useCapture);
  JSEvents.eventHandlers.splice(i, 1);
 }),
 registerOrRemoveHandler: (function(eventHandler) {
  var jsEventHandler = function jsEventHandler(event) {
   ++JSEvents.inEventHandler;
   JSEvents.currentEventHandler = eventHandler;
   JSEvents.runDeferredCalls();
   eventHandler.handlerFunc(event);
   JSEvents.runDeferredCalls();
   --JSEvents.inEventHandler;
  };
  if (eventHandler.callbackfunc) {
   eventHandler.eventListenerFunc = jsEventHandler;
   eventHandler.target.addEventListener(eventHandler.eventTypeString, jsEventHandler, eventHandler.useCapture);
   JSEvents.eventHandlers.push(eventHandler);
   JSEvents.registerRemoveEventListeners();
  } else {
   for (var i = 0; i < JSEvents.eventHandlers.length; ++i) {
    if (JSEvents.eventHandlers[i].target == eventHandler.target && JSEvents.eventHandlers[i].eventTypeString == eventHandler.eventTypeString) {
     JSEvents._removeHandler(i--);
    }
   }
  }
 }),
 registerKeyEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.keyEvent) {
   JSEvents.keyEvent = _malloc(164);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   writeStringToMemory(e.key ? e.key : "", JSEvents.keyEvent + 0);
   writeStringToMemory(e.code ? e.code : "", JSEvents.keyEvent + 32);
   HEAP32[JSEvents.keyEvent + 64 >> 2] = e.location;
   HEAP32[JSEvents.keyEvent + 68 >> 2] = e.ctrlKey;
   HEAP32[JSEvents.keyEvent + 72 >> 2] = e.shiftKey;
   HEAP32[JSEvents.keyEvent + 76 >> 2] = e.altKey;
   HEAP32[JSEvents.keyEvent + 80 >> 2] = e.metaKey;
   HEAP32[JSEvents.keyEvent + 84 >> 2] = e.repeat;
   writeStringToMemory(e.locale ? e.locale : "", JSEvents.keyEvent + 88);
   writeStringToMemory(e.char ? e.char : "", JSEvents.keyEvent + 120);
   HEAP32[JSEvents.keyEvent + 152 >> 2] = e.charCode;
   HEAP32[JSEvents.keyEvent + 156 >> 2] = e.keyCode;
   HEAP32[JSEvents.keyEvent + 160 >> 2] = e.which;
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.keyEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: JSEvents.isInternetExplorer() ? false : true,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 getBoundingClientRectOrZeros: (function(target) {
  return target.getBoundingClientRect ? target.getBoundingClientRect() : {
   left: 0,
   top: 0
  };
 }),
 fillMouseEventData: (function(eventStruct, e, target) {
  HEAPF64[eventStruct >> 3] = JSEvents.tick();
  HEAP32[eventStruct + 8 >> 2] = e.screenX;
  HEAP32[eventStruct + 12 >> 2] = e.screenY;
  HEAP32[eventStruct + 16 >> 2] = e.clientX;
  HEAP32[eventStruct + 20 >> 2] = e.clientY;
  HEAP32[eventStruct + 24 >> 2] = e.ctrlKey;
  HEAP32[eventStruct + 28 >> 2] = e.shiftKey;
  HEAP32[eventStruct + 32 >> 2] = e.altKey;
  HEAP32[eventStruct + 36 >> 2] = e.metaKey;
  HEAP16[eventStruct + 40 >> 1] = e.button;
  HEAP16[eventStruct + 42 >> 1] = e.buttons;
  HEAP32[eventStruct + 44 >> 2] = e["movementX"] || e["mozMovementX"] || e["webkitMovementX"] || e.screenX - JSEvents.previousScreenX;
  HEAP32[eventStruct + 48 >> 2] = e["movementY"] || e["mozMovementY"] || e["webkitMovementY"] || e.screenY - JSEvents.previousScreenY;
  if (Module["canvas"]) {
   var rect = Module["canvas"].getBoundingClientRect();
   HEAP32[eventStruct + 60 >> 2] = e.clientX - rect.left;
   HEAP32[eventStruct + 64 >> 2] = e.clientY - rect.top;
  } else {
   HEAP32[eventStruct + 60 >> 2] = 0;
   HEAP32[eventStruct + 64 >> 2] = 0;
  }
  if (target) {
   var rect = JSEvents.getBoundingClientRectOrZeros(target);
   HEAP32[eventStruct + 52 >> 2] = e.clientX - rect.left;
   HEAP32[eventStruct + 56 >> 2] = e.clientY - rect.top;
  } else {
   HEAP32[eventStruct + 52 >> 2] = 0;
   HEAP32[eventStruct + 56 >> 2] = 0;
  }
  JSEvents.previousScreenX = e.screenX;
  JSEvents.previousScreenY = e.screenY;
 }),
 registerMouseEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.mouseEvent) {
   JSEvents.mouseEvent = _malloc(72);
  }
  target = JSEvents.findEventTarget(target);
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillMouseEventData(JSEvents.mouseEvent, e, target);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.mouseEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: eventTypeString != "mousemove",
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  if (JSEvents.isInternetExplorer() && eventTypeString == "mousedown") eventHandler.allowsDeferredCalls = false;
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 registerWheelEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.wheelEvent) {
   JSEvents.wheelEvent = _malloc(104);
  }
  target = JSEvents.findEventTarget(target);
  var wheelHandlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillMouseEventData(JSEvents.wheelEvent, e, target);
   HEAPF64[JSEvents.wheelEvent + 72 >> 3] = e["deltaX"];
   HEAPF64[JSEvents.wheelEvent + 80 >> 3] = e["deltaY"];
   HEAPF64[JSEvents.wheelEvent + 88 >> 3] = e["deltaZ"];
   HEAP32[JSEvents.wheelEvent + 96 >> 2] = e["deltaMode"];
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.wheelEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var mouseWheelHandlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillMouseEventData(JSEvents.wheelEvent, e, target);
   HEAPF64[JSEvents.wheelEvent + 72 >> 3] = e["wheelDeltaX"];
   HEAPF64[JSEvents.wheelEvent + 80 >> 3] = -e["wheelDeltaY"];
   HEAPF64[JSEvents.wheelEvent + 88 >> 3] = 0;
   HEAP32[JSEvents.wheelEvent + 96 >> 2] = 0;
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.wheelEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: true,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: eventTypeString == "wheel" ? wheelHandlerFunc : mouseWheelHandlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 pageScrollPos: (function() {
  if (window.pageXOffset > 0 || window.pageYOffset > 0) {
   return [ window.pageXOffset, window.pageYOffset ];
  }
  if (typeof document.documentElement.scrollLeft !== "undefined" || typeof document.documentElement.scrollTop !== "undefined") {
   return [ document.documentElement.scrollLeft, document.documentElement.scrollTop ];
  }
  return [ document.body.scrollLeft | 0, document.body.scrollTop | 0 ];
 }),
 registerUiEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.uiEvent) {
   JSEvents.uiEvent = _malloc(36);
  }
  if (eventTypeString == "scroll" && !target) {
   target = document;
  } else {
   target = JSEvents.findEventTarget(target);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   if (e.target != target) {
    return;
   }
   var scrollPos = JSEvents.pageScrollPos();
   HEAP32[JSEvents.uiEvent >> 2] = e.detail;
   HEAP32[JSEvents.uiEvent + 4 >> 2] = document.body.clientWidth;
   HEAP32[JSEvents.uiEvent + 8 >> 2] = document.body.clientHeight;
   HEAP32[JSEvents.uiEvent + 12 >> 2] = window.innerWidth;
   HEAP32[JSEvents.uiEvent + 16 >> 2] = window.innerHeight;
   HEAP32[JSEvents.uiEvent + 20 >> 2] = window.outerWidth;
   HEAP32[JSEvents.uiEvent + 24 >> 2] = window.outerHeight;
   HEAP32[JSEvents.uiEvent + 28 >> 2] = scrollPos[0];
   HEAP32[JSEvents.uiEvent + 32 >> 2] = scrollPos[1];
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.uiEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 getNodeNameForTarget: (function(target) {
  if (!target) return "";
  if (target == window) return "#window";
  if (target == window.screen) return "#screen";
  return target && target.nodeName ? target.nodeName : "";
 }),
 registerFocusEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.focusEvent) {
   JSEvents.focusEvent = _malloc(256);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   var nodeName = JSEvents.getNodeNameForTarget(e.target);
   var id = e.target.id ? e.target.id : "";
   writeStringToMemory(nodeName, JSEvents.focusEvent + 0);
   writeStringToMemory(id, JSEvents.focusEvent + 128);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.focusEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 tick: (function() {
  if (window["performance"] && window["performance"]["now"]) return window["performance"]["now"](); else return Date.now();
 }),
 registerDeviceOrientationEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.deviceOrientationEvent) {
   JSEvents.deviceOrientationEvent = _malloc(40);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   HEAPF64[JSEvents.deviceOrientationEvent >> 3] = JSEvents.tick();
   HEAPF64[JSEvents.deviceOrientationEvent + 8 >> 3] = e.alpha;
   HEAPF64[JSEvents.deviceOrientationEvent + 16 >> 3] = e.beta;
   HEAPF64[JSEvents.deviceOrientationEvent + 24 >> 3] = e.gamma;
   HEAP32[JSEvents.deviceOrientationEvent + 32 >> 2] = e.absolute;
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.deviceOrientationEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 registerDeviceMotionEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.deviceMotionEvent) {
   JSEvents.deviceMotionEvent = _malloc(80);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   HEAPF64[JSEvents.deviceOrientationEvent >> 3] = JSEvents.tick();
   HEAPF64[JSEvents.deviceMotionEvent + 8 >> 3] = e.acceleration.x;
   HEAPF64[JSEvents.deviceMotionEvent + 16 >> 3] = e.acceleration.y;
   HEAPF64[JSEvents.deviceMotionEvent + 24 >> 3] = e.acceleration.z;
   HEAPF64[JSEvents.deviceMotionEvent + 32 >> 3] = e.accelerationIncludingGravity.x;
   HEAPF64[JSEvents.deviceMotionEvent + 40 >> 3] = e.accelerationIncludingGravity.y;
   HEAPF64[JSEvents.deviceMotionEvent + 48 >> 3] = e.accelerationIncludingGravity.z;
   HEAPF64[JSEvents.deviceMotionEvent + 56 >> 3] = e.rotationRate.alpha;
   HEAPF64[JSEvents.deviceMotionEvent + 64 >> 3] = e.rotationRate.beta;
   HEAPF64[JSEvents.deviceMotionEvent + 72 >> 3] = e.rotationRate.gamma;
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.deviceMotionEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 screenOrientation: (function() {
  if (!window.screen) return undefined;
  return window.screen.orientation || window.screen.mozOrientation || window.screen.webkitOrientation || window.screen.msOrientation;
 }),
 fillOrientationChangeEventData: (function(eventStruct, e) {
  var orientations = [ "portrait-primary", "portrait-secondary", "landscape-primary", "landscape-secondary" ];
  var orientations2 = [ "portrait", "portrait", "landscape", "landscape" ];
  var orientationString = JSEvents.screenOrientation();
  var orientation = orientations.indexOf(orientationString);
  if (orientation == -1) {
   orientation = orientations2.indexOf(orientationString);
  }
  HEAP32[eventStruct >> 2] = 1 << orientation;
  HEAP32[eventStruct + 4 >> 2] = window.orientation;
 }),
 registerOrientationChangeEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.orientationChangeEvent) {
   JSEvents.orientationChangeEvent = _malloc(8);
  }
  if (!target) {
   target = window.screen;
  } else {
   target = JSEvents.findEventTarget(target);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillOrientationChangeEventData(JSEvents.orientationChangeEvent, e);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.orientationChangeEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  if (eventTypeString == "orientationchange" && window.screen.mozOrientation !== undefined) {
   eventTypeString = "mozorientationchange";
  }
  var eventHandler = {
   target: target,
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 fullscreenEnabled: (function() {
  return document.fullscreenEnabled || document.mozFullscreenEnabled || document.mozFullScreenEnabled || document.webkitFullscreenEnabled || document.msFullscreenEnabled;
 }),
 fillFullscreenChangeEventData: (function(eventStruct, e) {
  var fullscreenElement = document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || document.msFullscreenElement;
  var isFullscreen = !!fullscreenElement;
  HEAP32[eventStruct >> 2] = isFullscreen;
  HEAP32[eventStruct + 4 >> 2] = JSEvents.fullscreenEnabled();
  var reportedElement = isFullscreen ? fullscreenElement : JSEvents.previousFullscreenElement;
  var nodeName = JSEvents.getNodeNameForTarget(reportedElement);
  var id = reportedElement && reportedElement.id ? reportedElement.id : "";
  writeStringToMemory(nodeName, eventStruct + 8);
  writeStringToMemory(id, eventStruct + 136);
  HEAP32[eventStruct + 264 >> 2] = reportedElement ? reportedElement.clientWidth : 0;
  HEAP32[eventStruct + 268 >> 2] = reportedElement ? reportedElement.clientHeight : 0;
  HEAP32[eventStruct + 272 >> 2] = screen.width;
  HEAP32[eventStruct + 276 >> 2] = screen.height;
  if (isFullscreen) {
   JSEvents.previousFullscreenElement = fullscreenElement;
  }
 }),
 registerFullscreenChangeEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.fullscreenChangeEvent) {
   JSEvents.fullscreenChangeEvent = _malloc(280);
  }
  if (!target) {
   target = document;
  } else {
   target = JSEvents.findEventTarget(target);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillFullscreenChangeEventData(JSEvents.fullscreenChangeEvent, e);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.fullscreenChangeEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 resizeCanvasForFullscreen: (function(target, strategy) {
  var restoreOldStyle = __registerRestoreOldStyle(target);
  var cssWidth = strategy.softFullscreen ? window.innerWidth : screen.width;
  var cssHeight = strategy.softFullscreen ? window.innerHeight : screen.height;
  var rect = target.getBoundingClientRect();
  var windowedCssWidth = rect.right - rect.left;
  var windowedCssHeight = rect.bottom - rect.top;
  var windowedRttWidth = target.width;
  var windowedRttHeight = target.height;
  if (strategy.scaleMode == 3) {
   __setLetterbox(target, (cssHeight - windowedCssHeight) / 2, (cssWidth - windowedCssWidth) / 2);
   cssWidth = windowedCssWidth;
   cssHeight = windowedCssHeight;
  } else if (strategy.scaleMode == 2) {
   if (cssWidth * windowedRttHeight < windowedRttWidth * cssHeight) {
    var desiredCssHeight = windowedRttHeight * cssWidth / windowedRttWidth;
    __setLetterbox(target, (cssHeight - desiredCssHeight) / 2, 0);
    cssHeight = desiredCssHeight;
   } else {
    var desiredCssWidth = windowedRttWidth * cssHeight / windowedRttHeight;
    __setLetterbox(target, 0, (cssWidth - desiredCssWidth) / 2);
    cssWidth = desiredCssWidth;
   }
  }
  if (!target.style.backgroundColor) target.style.backgroundColor = "black";
  if (!document.body.style.backgroundColor) document.body.style.backgroundColor = "black";
  target.style.width = cssWidth + "px";
  target.style.height = cssHeight + "px";
  if (strategy.filteringMode == 1) {
   target.style.imageRendering = "-moz-crisp-edges";
   target.style["-ms-interpolation-mode"] = "nearest-neighbor";
  }
  var dpiScale = strategy.canvasResolutionScaleMode == 2 ? window.devicePixelRatio : 1;
  if (strategy.canvasResolutionScaleMode != 0) {
   target.width = cssWidth * dpiScale;
   target.height = cssHeight * dpiScale;
   if (target.GLctxObject) target.GLctxObject.GLctx.viewport(0, 0, target.width, target.height);
  }
  return restoreOldStyle;
 }),
 requestFullscreen: (function(target, strategy) {
  if (strategy.scaleMode != 0 || strategy.canvasResolutionScaleMode != 0) {
   JSEvents.resizeCanvasForFullscreen(target, strategy);
  }
  if (target.requestFullscreen) {
   target.requestFullscreen();
  } else if (target.msRequestFullscreen) {
   target.msRequestFullscreen();
  } else if (target.mozRequestFullScreen) {
   target.mozRequestFullScreen();
  } else if (target.mozRequestFullscreen) {
   target.mozRequestFullscreen();
  } else if (target.webkitRequestFullscreen) {
   target.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
  } else {
   if (typeof JSEvents.fullscreenEnabled() === "undefined") {
    return -1;
   } else {
    return -3;
   }
  }
  if (strategy.canvasResizedCallback) {
   Runtime.dynCall("iiii", strategy.canvasResizedCallback, [ 37, 0, strategy.canvasResizedCallbackUserData ]);
  }
  return 0;
 }),
 fillPointerlockChangeEventData: (function(eventStruct, e) {
  var pointerLockElement = document.pointerLockElement || document.mozPointerLockElement || document.webkitPointerLockElement || document.msPointerLockElement;
  var isPointerlocked = !!pointerLockElement;
  HEAP32[eventStruct >> 2] = isPointerlocked;
  var nodeName = JSEvents.getNodeNameForTarget(pointerLockElement);
  var id = pointerLockElement && pointerLockElement.id ? pointerLockElement.id : "";
  writeStringToMemory(nodeName, eventStruct + 4);
  writeStringToMemory(id, eventStruct + 132);
 }),
 registerPointerlockChangeEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.pointerlockChangeEvent) {
   JSEvents.pointerlockChangeEvent = _malloc(260);
  }
  if (!target) {
   target = document;
  } else {
   target = JSEvents.findEventTarget(target);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillPointerlockChangeEventData(JSEvents.pointerlockChangeEvent, e);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.pointerlockChangeEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 requestPointerLock: (function(target) {
  if (target.requestPointerLock) {
   target.requestPointerLock();
  } else if (target.mozRequestPointerLock) {
   target.mozRequestPointerLock();
  } else if (target.webkitRequestPointerLock) {
   target.webkitRequestPointerLock();
  } else if (target.msRequestPointerLock) {
   target.msRequestPointerLock();
  } else {
   if (document.body.requestPointerLock || document.body.mozRequestPointerLock || document.body.webkitRequestPointerLock || document.body.msRequestPointerLock) {
    return -3;
   } else {
    return -1;
   }
  }
  return 0;
 }),
 fillVisibilityChangeEventData: (function(eventStruct, e) {
  var visibilityStates = [ "hidden", "visible", "prerender", "unloaded" ];
  var visibilityState = visibilityStates.indexOf(document.visibilityState);
  HEAP32[eventStruct >> 2] = document.hidden;
  HEAP32[eventStruct + 4 >> 2] = visibilityState;
 }),
 registerVisibilityChangeEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.visibilityChangeEvent) {
   JSEvents.visibilityChangeEvent = _malloc(8);
  }
  if (!target) {
   target = document;
  } else {
   target = JSEvents.findEventTarget(target);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillVisibilityChangeEventData(JSEvents.visibilityChangeEvent, e);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.visibilityChangeEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 registerTouchEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.touchEvent) {
   JSEvents.touchEvent = _malloc(1684);
  }
  target = JSEvents.findEventTarget(target);
  var handlerFunc = (function(event) {
   var e = event || window.event;
   var touches = {};
   for (var i = 0; i < e.touches.length; ++i) {
    var touch = e.touches[i];
    touches[touch.identifier] = touch;
   }
   for (var i = 0; i < e.changedTouches.length; ++i) {
    var touch = e.changedTouches[i];
    touches[touch.identifier] = touch;
    touch.changed = true;
   }
   for (var i = 0; i < e.targetTouches.length; ++i) {
    var touch = e.targetTouches[i];
    touches[touch.identifier].onTarget = true;
   }
   var ptr = JSEvents.touchEvent;
   HEAP32[ptr + 4 >> 2] = e.ctrlKey;
   HEAP32[ptr + 8 >> 2] = e.shiftKey;
   HEAP32[ptr + 12 >> 2] = e.altKey;
   HEAP32[ptr + 16 >> 2] = e.metaKey;
   ptr += 20;
   var canvasRect = Module["canvas"] ? Module["canvas"].getBoundingClientRect() : undefined;
   var targetRect = JSEvents.getBoundingClientRectOrZeros(target);
   var numTouches = 0;
   for (var i in touches) {
    var t = touches[i];
    HEAP32[ptr >> 2] = t.identifier;
    HEAP32[ptr + 4 >> 2] = t.screenX;
    HEAP32[ptr + 8 >> 2] = t.screenY;
    HEAP32[ptr + 12 >> 2] = t.clientX;
    HEAP32[ptr + 16 >> 2] = t.clientY;
    HEAP32[ptr + 20 >> 2] = t.pageX;
    HEAP32[ptr + 24 >> 2] = t.pageY;
    HEAP32[ptr + 28 >> 2] = t.changed;
    HEAP32[ptr + 32 >> 2] = t.onTarget;
    if (canvasRect) {
     HEAP32[ptr + 44 >> 2] = t.clientX - canvasRect.left;
     HEAP32[ptr + 48 >> 2] = t.clientY - canvasRect.top;
    } else {
     HEAP32[ptr + 44 >> 2] = 0;
     HEAP32[ptr + 48 >> 2] = 0;
    }
    HEAP32[ptr + 36 >> 2] = t.clientX - targetRect.left;
    HEAP32[ptr + 40 >> 2] = t.clientY - targetRect.top;
    ptr += 52;
    if (++numTouches >= 32) {
     break;
    }
   }
   HEAP32[JSEvents.touchEvent >> 2] = numTouches;
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.touchEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: target,
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 fillGamepadEventData: (function(eventStruct, e) {
  HEAPF64[eventStruct >> 3] = e.timestamp;
  for (var i = 0; i < e.axes.length; ++i) {
   HEAPF64[eventStruct + i * 8 + 16 >> 3] = e.axes[i];
  }
  for (var i = 0; i < e.buttons.length; ++i) {
   if (typeof e.buttons[i] === "object") {
    HEAPF64[eventStruct + i * 8 + 528 >> 3] = e.buttons[i].value;
   } else {
    HEAPF64[eventStruct + i * 8 + 528 >> 3] = e.buttons[i];
   }
  }
  for (var i = 0; i < e.buttons.length; ++i) {
   if (typeof e.buttons[i] === "object") {
    HEAP32[eventStruct + i * 4 + 1040 >> 2] = e.buttons[i].pressed;
   } else {
    HEAP32[eventStruct + i * 4 + 1040 >> 2] = e.buttons[i] == 1;
   }
  }
  HEAP32[eventStruct + 1296 >> 2] = e.connected;
  HEAP32[eventStruct + 1300 >> 2] = e.index;
  HEAP32[eventStruct + 8 >> 2] = e.axes.length;
  HEAP32[eventStruct + 12 >> 2] = e.buttons.length;
  writeStringToMemory(e.id, eventStruct + 1304);
  writeStringToMemory(e.mapping, eventStruct + 1368);
 }),
 registerGamepadEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.gamepadEvent) {
   JSEvents.gamepadEvent = _malloc(1432);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillGamepadEventData(JSEvents.gamepadEvent, e.gamepad);
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.gamepadEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: true,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 registerBeforeUnloadEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  var handlerFunc = (function(event) {
   var e = event || window.event;
   var confirmationMessage = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, 0, userData ]);
   if (confirmationMessage) {
    confirmationMessage = Pointer_stringify(confirmationMessage);
   }
   if (confirmationMessage) {
    e.preventDefault();
    e.returnValue = confirmationMessage;
    return confirmationMessage;
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 battery: (function() {
  return navigator.battery || navigator.mozBattery || navigator.webkitBattery;
 }),
 fillBatteryEventData: (function(eventStruct, e) {
  HEAPF64[eventStruct >> 3] = e.chargingTime;
  HEAPF64[eventStruct + 8 >> 3] = e.dischargingTime;
  HEAPF64[eventStruct + 16 >> 3] = e.level;
  HEAP32[eventStruct + 24 >> 2] = e.charging;
 }),
 registerBatteryEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!JSEvents.batteryEvent) {
   JSEvents.batteryEvent = _malloc(32);
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   JSEvents.fillBatteryEventData(JSEvents.batteryEvent, JSEvents.battery());
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, JSEvents.batteryEvent, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 }),
 registerWebGlEventCallback: (function(target, userData, useCapture, callbackfunc, eventTypeId, eventTypeString) {
  if (!target) {
   target = Module["canvas"];
  }
  var handlerFunc = (function(event) {
   var e = event || window.event;
   var shouldCancel = Runtime.dynCall("iiii", callbackfunc, [ eventTypeId, 0, userData ]);
   if (shouldCancel) {
    e.preventDefault();
   }
  });
  var eventHandler = {
   target: JSEvents.findEventTarget(target),
   allowsDeferredCalls: false,
   eventTypeString: eventTypeString,
   callbackfunc: callbackfunc,
   handlerFunc: handlerFunc,
   useCapture: useCapture
  };
  JSEvents.registerOrRemoveHandler(eventHandler);
 })
};
function _emscripten_webgl_destroy_context(contextHandle) {
 GL.deleteContext(contextHandle);
}
function _emscripten_glTexParameteri(x0, x1, x2) {
 GLctx.texParameteri(x0, x1, x2);
}
function _glCompileShader(shader) {
 GLctx.compileShader(GL.shaders[shader]);
}
var ___tm_current = allocate(44, "i8", ALLOC_STATIC);
var ___tm_timezone = allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
function _localtime_r(time, tmPtr) {
 _tzset();
 var date = new Date(HEAP32[time >> 2] * 1e3);
 HEAP32[tmPtr >> 2] = date.getSeconds();
 HEAP32[tmPtr + 4 >> 2] = date.getMinutes();
 HEAP32[tmPtr + 8 >> 2] = date.getHours();
 HEAP32[tmPtr + 12 >> 2] = date.getDate();
 HEAP32[tmPtr + 16 >> 2] = date.getMonth();
 HEAP32[tmPtr + 20 >> 2] = date.getFullYear() - 1900;
 HEAP32[tmPtr + 24 >> 2] = date.getDay();
 var start = new Date(date.getFullYear(), 0, 1);
 var yday = (date.getTime() - start.getTime()) / (1e3 * 60 * 60 * 24) | 0;
 HEAP32[tmPtr + 28 >> 2] = yday;
 HEAP32[tmPtr + 36 >> 2] = -(date.getTimezoneOffset() * 60);
 var summerOffset = (new Date(2e3, 6, 1)).getTimezoneOffset();
 var winterOffset = start.getTimezoneOffset();
 var dst = date.getTimezoneOffset() == Math.min(winterOffset, summerOffset) | 0;
 HEAP32[tmPtr + 32 >> 2] = dst;
 var zonePtr = HEAP32[_tzname + (dst ? Runtime.QUANTUM_SIZE : 0) >> 2];
 HEAP32[tmPtr + 40 >> 2] = zonePtr;
 return tmPtr;
}
function _localtime(time) {
 return _localtime_r(time, ___tm_current);
}
function _emscripten_glFrustum() {
 Module["printErr"]("missing function: emscripten_glFrustum");
 abort(-1);
}
function _emscripten_glGetTexParameterfv(target, pname, params) {
 HEAPF32[params >> 2] = GLctx.getTexParameter(target, pname);
}
function _emscripten_glBindRenderbuffer(target, renderbuffer) {
 GLctx.bindRenderbuffer(target, renderbuffer ? GL.renderbuffers[renderbuffer] : null);
}
function _glVertexAttribIPointer(index, size, type, stride, ptr) {
 GLctx.vertexAttribIPointer(index, size, type, stride, ptr);
}
function _utime(path, times) {
 var time;
 if (times) {
  var offset = 4;
  time = HEAP32[times + offset >> 2];
  time *= 1e3;
 } else {
  time = Date.now();
 }
 path = Pointer_stringify(path);
 try {
  FS.utime(path, time, time);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _emscripten_glCopyTexImage2D(x0, x1, x2, x3, x4, x5, x6, x7) {
 GLctx.copyTexImage2D(x0, x1, x2, x3, x4, x5, x6, x7);
}
var systemInfo = {
 get: (function() {
  if (systemInfo.hasOwnProperty("hasWebGL")) return this;
  var unknown = "-";
  this.width = screen.width ? screen.width : 0;
  this.height = screen.height ? screen.height : 0;
  var nVer = navigator.appVersion;
  var nAgt = navigator.userAgent;
  var browser = navigator.appName;
  var version = "" + parseFloat(navigator.appVersion);
  var majorVersion = parseInt(navigator.appVersion, 10);
  var nameOffset, verOffset, ix;
  if ((verOffset = nAgt.indexOf("Opera")) != -1) {
   browser = "Opera";
   version = nAgt.substring(verOffset + 6);
   if ((verOffset = nAgt.indexOf("Version")) != -1) {
    version = nAgt.substring(verOffset + 8);
   }
  } else if ((verOffset = nAgt.indexOf("MSIE")) != -1) {
   browser = "Microsoft Internet Explorer";
   version = nAgt.substring(verOffset + 5);
  } else if ((verOffset = nAgt.indexOf("Chrome")) != -1) {
   browser = "Chrome";
   version = nAgt.substring(verOffset + 7);
  } else if ((verOffset = nAgt.indexOf("Safari")) != -1) {
   browser = "Safari";
   version = nAgt.substring(verOffset + 7);
   if ((verOffset = nAgt.indexOf("Version")) != -1) {
    version = nAgt.substring(verOffset + 8);
   }
  } else if ((verOffset = nAgt.indexOf("Firefox")) != -1) {
   browser = "Firefox";
   version = nAgt.substring(verOffset + 8);
  } else if (nAgt.indexOf("Trident/") != -1) {
   browser = "Microsoft Internet Explorer";
   version = nAgt.substring(nAgt.indexOf("rv:") + 3);
  } else if ((nameOffset = nAgt.lastIndexOf(" ") + 1) < (verOffset = nAgt.lastIndexOf("/"))) {
   browser = nAgt.substring(nameOffset, verOffset);
   version = nAgt.substring(verOffset + 1);
   if (browser.toLowerCase() == browser.toUpperCase()) {
    browser = navigator.appName;
   }
  }
  if ((ix = version.indexOf(";")) != -1) version = version.substring(0, ix);
  if ((ix = version.indexOf(" ")) != -1) version = version.substring(0, ix);
  if ((ix = version.indexOf(")")) != -1) version = version.substring(0, ix);
  majorVersion = parseInt("" + version, 10);
  if (isNaN(majorVersion)) {
   version = "" + parseFloat(navigator.appVersion);
   majorVersion = parseInt(navigator.appVersion, 10);
  }
  var mobile = /Mobile|mini|Fennec|Android|iP(ad|od|hone)/.test(nVer);
  var os = unknown;
  var clientStrings = [ {
   s: "Windows 3.11",
   r: /Win16/
  }, {
   s: "Windows 95",
   r: /(Windows 95|Win95|Windows_95)/
  }, {
   s: "Windows ME",
   r: /(Win 9x 4.90|Windows ME)/
  }, {
   s: "Windows 98",
   r: /(Windows 98|Win98)/
  }, {
   s: "Windows CE",
   r: /Windows CE/
  }, {
   s: "Windows 2000",
   r: /(Windows NT 5.0|Windows 2000)/
  }, {
   s: "Windows XP",
   r: /(Windows NT 5.1|Windows XP)/
  }, {
   s: "Windows Server 2003",
   r: /Windows NT 5.2/
  }, {
   s: "Windows Vista",
   r: /Windows NT 6.0/
  }, {
   s: "Windows 7",
   r: /(Windows 7|Windows NT 6.1)/
  }, {
   s: "Windows 8.1",
   r: /(Windows 8.1|Windows NT 6.3)/
  }, {
   s: "Windows 8",
   r: /(Windows 8|Windows NT 6.2)/
  }, {
   s: "Windows NT 4.0",
   r: /(Windows NT 4.0|WinNT4.0|WinNT|Windows NT)/
  }, {
   s: "Windows ME",
   r: /Windows ME/
  }, {
   s: "Android",
   r: /Android/
  }, {
   s: "Open BSD",
   r: /OpenBSD/
  }, {
   s: "Sun OS",
   r: /SunOS/
  }, {
   s: "Linux",
   r: /(Linux|X11)/
  }, {
   s: "iOS",
   r: /(iPhone|iPad|iPod)/
  }, {
   s: "Mac OS X",
   r: /Mac OS X/
  }, {
   s: "Mac OS",
   r: /(MacPPC|MacIntel|Mac_PowerPC|Macintosh)/
  }, {
   s: "QNX",
   r: /QNX/
  }, {
   s: "UNIX",
   r: /UNIX/
  }, {
   s: "BeOS",
   r: /BeOS/
  }, {
   s: "OS/2",
   r: /OS\/2/
  }, {
   s: "Search Bot",
   r: /(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\/Teoma|ia_archiver)/
  } ];
  for (var id in clientStrings) {
   var cs = clientStrings[id];
   if (cs.r.test(nAgt)) {
    os = cs.s;
    break;
   }
  }
  var osVersion = unknown;
  if (/Windows/.test(os)) {
   osVersion = /Windows (.*)/.exec(os)[1];
   os = "Windows";
  }
  switch (os) {
  case "Mac OS X":
   osVersion = /Mac OS X (10[\.\_\d]+)/.exec(nAgt)[1];
   break;
  case "Android":
   osVersion = /Android ([\.\_\d]+)/.exec(nAgt)[1];
   break;
  case "iOS":
   osVersion = /OS (\d+)_(\d+)_?(\d+)?/.exec(nVer);
   osVersion = osVersion[1] + "." + osVersion[2] + "." + (osVersion[3] | 0);
   break;
  }
  this.browser = browser;
  this.browserVersion = version;
  this.mobile = mobile;
  this.os = os;
  this.osVersion = osVersion;
  this.hasWebGL = (function() {
   if (!window.WebGLRenderingContext) {
    return 0;
   }
   var canvas = document.createElement("canvas");
   var gl = canvas.getContext("experimental-webgl2");
   if (!gl) {
    var gl = canvas.getContext("webgl");
    if (!gl) {
     gl = canvas.getContext("experimental-webgl");
     if (!gl) {
      return 0;
     }
    }
    return 1;
   }
   return 2;
  })();
  this.hasCursorLock = (function() {
   var e = document.createElement("canvas");
   if (e["requestPointerLock"] || e["mozRequestPointerLock"] || e["webkitRequestPointerLock"] || e["msRequestPointerLock"]) return 1; else return 0;
  })();
  this.hasFullscreen = (function() {
   var e = document.createElement("canvas");
   if (e["requestFullScreen"] || e["mozRequestFullScreen"] || e["msRequestFullscreen"] || e["webkitRequestFullScreen"]) {
    if (browser.indexOf("Safari") == -1) return 1;
   }
   return 0;
  })();
  this.language = window.navigator.userLanguage || window.navigator.language;
  return this;
 })
};
function _JS_SystemInfo_HasFullscreen() {
 return systemInfo.get().hasFullscreen;
}
function _emscripten_glTexParameterfv(target, pname, params) {
 var param = HEAPF32[params >> 2];
 GLctx.texParameterf(target, pname, param);
}
function _glFlushMappedBufferRange() {
 Module["printErr"]("missing function: glFlushMappedBufferRange");
 abort(-1);
}
function _emscripten_glDepthRangef(x0, x1) {
 GLctx.depthRange(x0, x1);
}
function _open(path, oflag, varargs) {
 var mode = HEAP32[varargs >> 2];
 path = Pointer_stringify(path);
 try {
  var stream = FS.open(path, oflag, mode);
  return stream.fd;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _opendir(dirname) {
 var path = Pointer_stringify(dirname);
 if (!path) {
  ___setErrNo(ERRNO_CODES.ENOENT);
  return 0;
 }
 var node;
 try {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  node = lookup.node;
 } catch (e) {
  FS.handleFSError(e);
  return 0;
 }
 if (!FS.isDir(node.mode)) {
  ___setErrNo(ERRNO_CODES.ENOTDIR);
  return 0;
 }
 var fd = _open(dirname, 0, allocate([ 0, 0, 0, 0 ], "i32", ALLOC_STACK));
 return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
}
function _emscripten_glGetObjectParameterivARB() {
 Module["printErr"]("missing function: emscripten_glGetObjectParameterivARB");
 abort(-1);
}
function _div(divt, numer, denom) {
 var quot = numer / denom | 0;
 var rem = numer - quot * denom;
 HEAP32[divt >> 2] = quot;
 HEAP32[divt + 4 >> 2] = rem;
 return divt;
}
function _glCreateShader(shaderType) {
 var id = GL.getNewId(GL.shaders);
 GL.shaders[id] = GLctx.createShader(shaderType);
 return id;
}
function _emscripten_glBindAttribLocation(program, index, name) {
 name = Pointer_stringify(name);
 GLctx.bindAttribLocation(GL.programs[program], index, name);
}
function _glGenRenderbuffers(n, renderbuffers) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.renderbuffers);
  var renderbuffer = GLctx.createRenderbuffer();
  renderbuffer.name = id;
  GL.renderbuffers[id] = renderbuffer;
  HEAP32[renderbuffers + i * 4 >> 2] = id;
 }
}
var _cosf = Math_cos;
function _glCompressedTexImage2D(target, level, internalFormat, width, height, border, imageSize, data) {
 if (data) {
  data = HEAPU8.subarray(data, data + imageSize);
 } else {
  data = null;
 }
 GLctx["compressedTexImage2D"](target, level, internalFormat, width, height, border, data);
}
function _glBlendFuncSeparate(x0, x1, x2, x3) {
 GLctx.blendFuncSeparate(x0, x1, x2, x3);
}
function ___errno_location() {
 return ___errno_state;
}
Module["_memset"] = _memset;
function _glDrawBuffers(n, bufs) {
 var bufArray = [];
 for (var i = 0; i < n; i++) bufArray.push(HEAP32[bufs + i * 4 >> 2]);
 GL.currentContext.drawBuffersExt(bufArray);
}
function _JS_SystemInfo_HasCursorLock() {
 return systemInfo.get().hasCursorLock;
}
var _asin = Math_asin;
function _emscripten_glVertexAttrib3f(x0, x1, x2, x3) {
 GLctx.vertexAttrib3f(x0, x1, x2, x3);
}
function _clock() {
 if (_clock.start === undefined) _clock.start = Date.now();
 return (Date.now() - _clock.start) * (1e6 / 1e3) | 0;
}
var ctlz_i8 = allocate([ 8, 7, 6, 6, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ], "i8", ALLOC_STATIC);
Module["_llvm_ctlz_i32"] = _llvm_ctlz_i32;
function _access(path, amode) {
 path = Pointer_stringify(path);
 if (amode & ~7) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 var node;
 try {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  node = lookup.node;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
 var perms = "";
 if (amode & 4) perms += "r";
 if (amode & 2) perms += "w";
 if (amode & 1) perms += "x";
 if (perms && FS.nodePermissions(node, perms)) {
  ___setErrNo(ERRNO_CODES.EACCES);
  return -1;
 }
 return 0;
}
function _glDeleteProgram(id) {
 if (!id) return;
 var program = GL.programs[id];
 if (!program) {
  GL.recordError(1281);
  return;
 }
 GLctx.deleteProgram(program);
 program.name = 0;
 GL.programs[id] = null;
 GL.programInfos[id] = null;
}
function _glRenderbufferStorage(x0, x1, x2, x3) {
 GLctx.renderbufferStorage(x0, x1, x2, x3);
}
var WEBAudio = {
 audioInstances: [],
 audioContext: {},
 audioWebEnabled: 0
};
function _JS_Sound_SetListenerPosition(x, y, z) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioContext.listener.setPosition(x, y, z);
}
function _emscripten_glDeleteShader(id) {
 if (!id) return;
 var shader = GL.shaders[id];
 if (!shader) {
  GL.recordError(1281);
  return;
 }
 GLctx.deleteShader(shader);
 GL.shaders[id] = null;
}
function ___cxa_guard_acquire(variable) {
 if (!HEAP8[variable >> 0]) {
  HEAP8[variable >> 0] = 1;
  return 1;
 }
 return 0;
}
function _pthread_attr_init(attr) {
 return 0;
}
function _emscripten_glDrawArraysInstanced(mode, first, count, primcount) {
 GL.currentContext.instancedArraysExt.drawArraysInstancedANGLE(mode, first, count, primcount);
}
function _emscripten_glDeleteBuffers(n, buffers) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[buffers + i * 4 >> 2];
  var buffer = GL.buffers[id];
  if (!buffer) continue;
  GLctx.deleteBuffer(buffer);
  buffer.name = 0;
  GL.buffers[id] = null;
  if (id == GL.currArrayBuffer) GL.currArrayBuffer = 0;
  if (id == GL.currElementArrayBuffer) GL.currElementArrayBuffer = 0;
 }
}
var _sinf = Math_sin;
function _emscripten_glUniformMatrix2fv(location, count, transpose, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[3];
  for (var i = 0; i < 4; i++) {
   view[i] = HEAPF32[value + i * 4 >> 2];
  }
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 16 >> 2);
 }
 GLctx.uniformMatrix2fv(location, transpose, view);
}
function _glGenVertexArrays(n, arrays) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.vaos);
  var vao = GL.currentContext.vaoExt.createVertexArrayOES();
  vao.name = id;
  GL.vaos[id] = vao;
  HEAP32[arrays + i * 4 >> 2] = id;
 }
}
function _glTexStorage3D(target, levels, internalformat, width, height, depth) {
 GLctx.texStorage3D(target, levels, internalformat, width, height, depth);
}
function _emscripten_glEnableClientState() {
 Module["printErr"]("missing function: emscripten_glEnableClientState");
 abort(-1);
}
function _emscripten_glStencilMask(x0) {
 GLctx.stencilMask(x0);
}
function _JS_Sound_SetListenerOrientation(x, y, z, xUp, yUp, zUp) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioContext.listener.setPosition(x, y, z, xUp, yUp, zUp);
}
function __ZSt18uncaught_exceptionv() {
 return !!__ZSt18uncaught_exceptionv.uncaught_exception;
}
var EXCEPTIONS = {
 last: 0,
 caught: [],
 infos: {},
 deAdjust: (function(adjusted) {
  if (!adjusted || EXCEPTIONS.infos[adjusted]) return adjusted;
  for (var ptr in EXCEPTIONS.infos) {
   var info = EXCEPTIONS.infos[ptr];
   if (info.adjusted === adjusted) {
    return ptr;
   }
  }
  return adjusted;
 }),
 addRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  info.refcount++;
 }),
 decRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  assert(info.refcount > 0);
  info.refcount--;
  if (info.refcount === 0) {
   if (info.destructor) {
    Runtime.dynCall("vi", info.destructor, [ ptr ]);
   }
   delete EXCEPTIONS.infos[ptr];
   ___cxa_free_exception(ptr);
  }
 }),
 clearRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  info.refcount = 0;
 })
};
function ___cxa_begin_catch(ptr) {
 __ZSt18uncaught_exceptionv.uncaught_exception--;
 EXCEPTIONS.caught.push(ptr);
 EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));
 return ptr;
}
function _emscripten_set_main_loop_timing(mode, value) {
 Browser.mainLoop.timingMode = mode;
 Browser.mainLoop.timingValue = value;
 if (!Browser.mainLoop.func) {
  return 1;
 }
 if (mode == 0) {
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
   setTimeout(Browser.mainLoop.runner, value);
  };
  Browser.mainLoop.method = "timeout";
 } else if (mode == 1) {
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
   Browser.requestAnimationFrame(Browser.mainLoop.runner);
  };
  Browser.mainLoop.method = "rAF";
 }
 return 0;
}
function _emscripten_set_main_loop(func, fps, simulateInfiniteLoop, arg) {
 Module["noExitRuntime"] = true;
 assert(!Browser.mainLoop.func, "emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");
 Browser.mainLoop.func = func;
 Browser.mainLoop.arg = arg;
 var thisMainLoopId = Browser.mainLoop.currentlyRunningMainloop;
 Browser.mainLoop.runner = function Browser_mainLoop_runner() {
  if (ABORT) return;
  if (Browser.mainLoop.queue.length > 0) {
   var start = Date.now();
   var blocker = Browser.mainLoop.queue.shift();
   blocker.func(blocker.arg);
   if (Browser.mainLoop.remainingBlockers) {
    var remaining = Browser.mainLoop.remainingBlockers;
    var next = remaining % 1 == 0 ? remaining - 1 : Math.floor(remaining);
    if (blocker.counted) {
     Browser.mainLoop.remainingBlockers = next;
    } else {
     next = next + .5;
     Browser.mainLoop.remainingBlockers = (8 * remaining + next) / 9;
    }
   }
   console.log('main loop blocker "' + blocker.name + '" took ' + (Date.now() - start) + " ms");
   Browser.mainLoop.updateStatus();
   setTimeout(Browser.mainLoop.runner, 0);
   return;
  }
  if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop) return;
  Browser.mainLoop.currentFrameNumber = Browser.mainLoop.currentFrameNumber + 1 | 0;
  if (Browser.mainLoop.timingMode == 1 && Browser.mainLoop.timingValue > 1 && Browser.mainLoop.currentFrameNumber % Browser.mainLoop.timingValue != 0) {
   Browser.mainLoop.scheduler();
   return;
  }
  if (Browser.mainLoop.method === "timeout" && Module.ctx) {
   Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");
   Browser.mainLoop.method = "";
  }
  Browser.mainLoop.runIter((function() {
   if (typeof arg !== "undefined") {
    Runtime.dynCall("vi", func, [ arg ]);
   } else {
    Runtime.dynCall("v", func);
   }
  }));
  if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop) return;
  if (typeof SDL === "object" && SDL.audio && SDL.audio.queueNewAudioData) SDL.audio.queueNewAudioData();
  Browser.mainLoop.scheduler();
 };
 if (fps && fps > 0) _emscripten_set_main_loop_timing(0, 1e3 / fps); else _emscripten_set_main_loop_timing(1, 1);
 Browser.mainLoop.scheduler();
 if (simulateInfiniteLoop) {
  throw "SimulateInfiniteLoop";
 }
}
var Browser = {
 mainLoop: {
  scheduler: null,
  method: "",
  currentlyRunningMainloop: 0,
  func: null,
  arg: 0,
  timingMode: 0,
  timingValue: 0,
  currentFrameNumber: 0,
  queue: [],
  pause: (function() {
   Browser.mainLoop.scheduler = null;
   Browser.mainLoop.currentlyRunningMainloop++;
  }),
  resume: (function() {
   Browser.mainLoop.currentlyRunningMainloop++;
   var timingMode = Browser.mainLoop.timingMode;
   var timingValue = Browser.mainLoop.timingValue;
   var func = Browser.mainLoop.func;
   Browser.mainLoop.func = null;
   _emscripten_set_main_loop(func, 0, false, Browser.mainLoop.arg);
   _emscripten_set_main_loop_timing(timingMode, timingValue);
  }),
  updateStatus: (function() {
   if (Module["setStatus"]) {
    var message = Module["statusMessage"] || "Please wait...";
    var remaining = Browser.mainLoop.remainingBlockers;
    var expected = Browser.mainLoop.expectedBlockers;
    if (remaining) {
     if (remaining < expected) {
      Module["setStatus"](message + " (" + (expected - remaining) + "/" + expected + ")");
     } else {
      Module["setStatus"](message);
     }
    } else {
     Module["setStatus"]("");
    }
   }
  }),
  runIter: (function(func) {
   if (ABORT) return;
   if (Module["preMainLoop"]) {
    var preRet = Module["preMainLoop"]();
    if (preRet === false) {
     return;
    }
   }
   try {
    func();
   } catch (e) {
    if (e instanceof ExitStatus) {
     return;
    } else {
     if (e && typeof e === "object" && e.stack) Module.printErr("exception thrown: " + [ e, e.stack ]);
     throw e;
    }
   }
   if (Module["postMainLoop"]) Module["postMainLoop"]();
  })
 },
 isFullScreen: false,
 pointerLock: false,
 moduleContextCreatedCallbacks: [],
 workers: [],
 init: (function() {
  if (!Module["preloadPlugins"]) Module["preloadPlugins"] = [];
  if (Browser.initted) return;
  Browser.initted = true;
  try {
   new Blob;
   Browser.hasBlobConstructor = true;
  } catch (e) {
   Browser.hasBlobConstructor = false;
   console.log("warning: no blob constructor, cannot create blobs with mimetypes");
  }
  Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : !Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null;
  Browser.URLObject = typeof window != "undefined" ? window.URL ? window.URL : window.webkitURL : undefined;
  if (!Module.noImageDecoding && typeof Browser.URLObject === "undefined") {
   console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
   Module.noImageDecoding = true;
  }
  var imagePlugin = {};
  imagePlugin["canHandle"] = function imagePlugin_canHandle(name) {
   return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
  };
  imagePlugin["handle"] = function imagePlugin_handle(byteArray, name, onload, onerror) {
   var b = null;
   if (Browser.hasBlobConstructor) {
    try {
     b = new Blob([ byteArray ], {
      type: Browser.getMimetype(name)
     });
     if (b.size !== byteArray.length) {
      b = new Blob([ (new Uint8Array(byteArray)).buffer ], {
       type: Browser.getMimetype(name)
      });
     }
    } catch (e) {
     Runtime.warnOnce("Blob constructor present but fails: " + e + "; falling back to blob builder");
    }
   }
   if (!b) {
    var bb = new Browser.BlobBuilder;
    bb.append((new Uint8Array(byteArray)).buffer);
    b = bb.getBlob();
   }
   var url = Browser.URLObject.createObjectURL(b);
   var img = new Image;
   img.onload = function img_onload() {
    assert(img.complete, "Image " + name + " could not be decoded");
    var canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0);
    Module["preloadedImages"][name] = canvas;
    Browser.URLObject.revokeObjectURL(url);
    if (onload) onload(byteArray);
   };
   img.onerror = function img_onerror(event) {
    console.log("Image " + url + " could not be decoded");
    if (onerror) onerror();
   };
   img.src = url;
  };
  Module["preloadPlugins"].push(imagePlugin);
  var audioPlugin = {};
  audioPlugin["canHandle"] = function audioPlugin_canHandle(name) {
   return !Module.noAudioDecoding && name.substr(-4) in {
    ".ogg": 1,
    ".wav": 1,
    ".mp3": 1
   };
  };
  audioPlugin["handle"] = function audioPlugin_handle(byteArray, name, onload, onerror) {
   var done = false;
   function finish(audio) {
    if (done) return;
    done = true;
    Module["preloadedAudios"][name] = audio;
    if (onload) onload(byteArray);
   }
   function fail() {
    if (done) return;
    done = true;
    Module["preloadedAudios"][name] = new Audio;
    if (onerror) onerror();
   }
   if (Browser.hasBlobConstructor) {
    try {
     var b = new Blob([ byteArray ], {
      type: Browser.getMimetype(name)
     });
    } catch (e) {
     return fail();
    }
    var url = Browser.URLObject.createObjectURL(b);
    var audio = new Audio;
    audio.addEventListener("canplaythrough", (function() {
     finish(audio);
    }), false);
    audio.onerror = function audio_onerror(event) {
     if (done) return;
     console.log("warning: browser could not fully decode audio " + name + ", trying slower base64 approach");
     function encode64(data) {
      var BASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
      var PAD = "=";
      var ret = "";
      var leftchar = 0;
      var leftbits = 0;
      for (var i = 0; i < data.length; i++) {
       leftchar = leftchar << 8 | data[i];
       leftbits += 8;
       while (leftbits >= 6) {
        var curr = leftchar >> leftbits - 6 & 63;
        leftbits -= 6;
        ret += BASE[curr];
       }
      }
      if (leftbits == 2) {
       ret += BASE[(leftchar & 3) << 4];
       ret += PAD + PAD;
      } else if (leftbits == 4) {
       ret += BASE[(leftchar & 15) << 2];
       ret += PAD;
      }
      return ret;
     }
     audio.src = "data:audio/x-" + name.substr(-3) + ";base64," + encode64(byteArray);
     finish(audio);
    };
    audio.src = url;
    Browser.safeSetTimeout((function() {
     finish(audio);
    }), 1e4);
   } else {
    return fail();
   }
  };
  Module["preloadPlugins"].push(audioPlugin);
  var canvas = Module["canvas"];
  function pointerLockChange() {
   Browser.pointerLock = document["pointerLockElement"] === canvas || document["mozPointerLockElement"] === canvas || document["webkitPointerLockElement"] === canvas || document["msPointerLockElement"] === canvas;
  }
  if (canvas) {
   canvas.requestPointerLock = canvas["requestPointerLock"] || canvas["mozRequestPointerLock"] || canvas["webkitRequestPointerLock"] || canvas["msRequestPointerLock"] || (function() {});
   canvas.exitPointerLock = document["exitPointerLock"] || document["mozExitPointerLock"] || document["webkitExitPointerLock"] || document["msExitPointerLock"] || (function() {});
   canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
   document.addEventListener("pointerlockchange", pointerLockChange, false);
   document.addEventListener("mozpointerlockchange", pointerLockChange, false);
   document.addEventListener("webkitpointerlockchange", pointerLockChange, false);
   document.addEventListener("mspointerlockchange", pointerLockChange, false);
   if (Module["elementPointerLock"]) {
    canvas.addEventListener("click", (function(ev) {
     if (!Browser.pointerLock && canvas.requestPointerLock) {
      canvas.requestPointerLock();
      ev.preventDefault();
     }
    }), false);
   }
  }
 }),
 createContext: (function(canvas, useWebGL, setInModule, webGLContextAttributes) {
  if (useWebGL && Module.ctx && canvas == Module.canvas) return Module.ctx;
  var ctx;
  var contextHandle;
  if (useWebGL) {
   var contextAttributes = {
    antialias: false,
    alpha: false
   };
   if (webGLContextAttributes) {
    for (var attribute in webGLContextAttributes) {
     contextAttributes[attribute] = webGLContextAttributes[attribute];
    }
   }
   contextHandle = GL.createContext(canvas, contextAttributes);
   if (contextHandle) {
    ctx = GL.getContext(contextHandle).GLctx;
   }
   canvas.style.backgroundColor = "black";
  } else {
   ctx = canvas.getContext("2d");
  }
  if (!ctx) return null;
  if (setInModule) {
   if (!useWebGL) assert(typeof GLctx === "undefined", "cannot set in module if GLctx is used, but we are a non-GL context that would replace it");
   Module.ctx = ctx;
   if (useWebGL) GL.makeContextCurrent(contextHandle);
   Module.useWebGL = useWebGL;
   Browser.moduleContextCreatedCallbacks.forEach((function(callback) {
    callback();
   }));
   Browser.init();
  }
  return ctx;
 }),
 destroyContext: (function(canvas, useWebGL, setInModule) {}),
 fullScreenHandlersInstalled: false,
 lockPointer: undefined,
 resizeCanvas: undefined,
 requestFullScreen: (function(lockPointer, resizeCanvas) {
  Browser.lockPointer = lockPointer;
  Browser.resizeCanvas = resizeCanvas;
  if (typeof Browser.lockPointer === "undefined") Browser.lockPointer = true;
  if (typeof Browser.resizeCanvas === "undefined") Browser.resizeCanvas = false;
  var canvas = Module["canvas"];
  function fullScreenChange() {
   Browser.isFullScreen = false;
   var canvasContainer = canvas.parentNode;
   if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvasContainer) {
    canvas.cancelFullScreen = document["cancelFullScreen"] || document["mozCancelFullScreen"] || document["webkitCancelFullScreen"] || document["msExitFullscreen"] || document["exitFullscreen"] || (function() {});
    canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
    if (Browser.lockPointer) canvas.requestPointerLock();
    Browser.isFullScreen = true;
    if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
   } else {
    canvasContainer.parentNode.insertBefore(canvas, canvasContainer);
    canvasContainer.parentNode.removeChild(canvasContainer);
    if (Browser.resizeCanvas) Browser.setWindowedCanvasSize();
   }
   if (Module["onFullScreen"]) Module["onFullScreen"](Browser.isFullScreen);
   Browser.updateCanvasDimensions(canvas);
  }
  if (!Browser.fullScreenHandlersInstalled) {
   Browser.fullScreenHandlersInstalled = true;
   document.addEventListener("fullscreenchange", fullScreenChange, false);
   document.addEventListener("mozfullscreenchange", fullScreenChange, false);
   document.addEventListener("webkitfullscreenchange", fullScreenChange, false);
   document.addEventListener("MSFullscreenChange", fullScreenChange, false);
  }
  var canvasContainer = document.createElement("div");
  canvas.parentNode.insertBefore(canvasContainer, canvas);
  canvasContainer.appendChild(canvas);
  canvasContainer.requestFullScreen = canvasContainer["requestFullScreen"] || canvasContainer["mozRequestFullScreen"] || canvasContainer["msRequestFullscreen"] || (canvasContainer["webkitRequestFullScreen"] ? (function() {
   canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
  }) : null);
  canvasContainer.requestFullScreen();
 }),
 nextRAF: 0,
 fakeRequestAnimationFrame: (function(func) {
  var now = Date.now();
  if (Browser.nextRAF === 0) {
   Browser.nextRAF = now + 1e3 / 60;
  } else {
   while (now + 2 >= Browser.nextRAF) {
    Browser.nextRAF += 1e3 / 60;
   }
  }
  var delay = Math.max(Browser.nextRAF - now, 0);
  setTimeout(func, delay);
 }),
 requestAnimationFrame: function requestAnimationFrame(func) {
  if (typeof window === "undefined") {
   Browser.fakeRequestAnimationFrame(func);
  } else {
   if (!window.requestAnimationFrame) {
    window.requestAnimationFrame = window["requestAnimationFrame"] || window["mozRequestAnimationFrame"] || window["webkitRequestAnimationFrame"] || window["msRequestAnimationFrame"] || window["oRequestAnimationFrame"] || Browser.fakeRequestAnimationFrame;
   }
   window.requestAnimationFrame(func);
  }
 },
 safeCallback: (function(func) {
  return (function() {
   if (!ABORT) return func.apply(null, arguments);
  });
 }),
 safeRequestAnimationFrame: (function(func) {
  return Browser.requestAnimationFrame((function() {
   if (!ABORT) func();
  }));
 }),
 safeSetTimeout: (function(func, timeout) {
  Module["noExitRuntime"] = true;
  return setTimeout((function() {
   if (!ABORT) func();
  }), timeout);
 }),
 safeSetInterval: (function(func, timeout) {
  Module["noExitRuntime"] = true;
  return setInterval((function() {
   if (!ABORT) func();
  }), timeout);
 }),
 getMimetype: (function(name) {
  return {
   "jpg": "image/jpeg",
   "jpeg": "image/jpeg",
   "png": "image/png",
   "bmp": "image/bmp",
   "ogg": "audio/ogg",
   "wav": "audio/wav",
   "mp3": "audio/mpeg"
  }[name.substr(name.lastIndexOf(".") + 1)];
 }),
 getUserMedia: (function(func) {
  if (!window.getUserMedia) {
   window.getUserMedia = navigator["getUserMedia"] || navigator["mozGetUserMedia"];
  }
  window.getUserMedia(func);
 }),
 getMovementX: (function(event) {
  return event["movementX"] || event["mozMovementX"] || event["webkitMovementX"] || 0;
 }),
 getMovementY: (function(event) {
  return event["movementY"] || event["mozMovementY"] || event["webkitMovementY"] || 0;
 }),
 getMouseWheelDelta: (function(event) {
  var delta = 0;
  switch (event.type) {
  case "DOMMouseScroll":
   delta = event.detail;
   break;
  case "mousewheel":
   delta = event.wheelDelta;
   break;
  case "wheel":
   delta = event["deltaY"];
   break;
  default:
   throw "unrecognized mouse wheel event: " + event.type;
  }
  return delta;
 }),
 mouseX: 0,
 mouseY: 0,
 mouseMovementX: 0,
 mouseMovementY: 0,
 touches: {},
 lastTouches: {},
 calculateMouseEvent: (function(event) {
  if (Browser.pointerLock) {
   if (event.type != "mousemove" && "mozMovementX" in event) {
    Browser.mouseMovementX = Browser.mouseMovementY = 0;
   } else {
    Browser.mouseMovementX = Browser.getMovementX(event);
    Browser.mouseMovementY = Browser.getMovementY(event);
   }
   if (typeof SDL != "undefined") {
    Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
    Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
   } else {
    Browser.mouseX += Browser.mouseMovementX;
    Browser.mouseY += Browser.mouseMovementY;
   }
  } else {
   var rect = Module["canvas"].getBoundingClientRect();
   var cw = Module["canvas"].width;
   var ch = Module["canvas"].height;
   var scrollX = typeof window.scrollX !== "undefined" ? window.scrollX : window.pageXOffset;
   var scrollY = typeof window.scrollY !== "undefined" ? window.scrollY : window.pageYOffset;
   if (event.type === "touchstart" || event.type === "touchend" || event.type === "touchmove") {
    var touch = event.touch;
    if (touch === undefined) {
     return;
    }
    var adjustedX = touch.pageX - (scrollX + rect.left);
    var adjustedY = touch.pageY - (scrollY + rect.top);
    adjustedX = adjustedX * (cw / rect.width);
    adjustedY = adjustedY * (ch / rect.height);
    var coords = {
     x: adjustedX,
     y: adjustedY
    };
    if (event.type === "touchstart") {
     Browser.lastTouches[touch.identifier] = coords;
     Browser.touches[touch.identifier] = coords;
    } else if (event.type === "touchend" || event.type === "touchmove") {
     Browser.lastTouches[touch.identifier] = Browser.touches[touch.identifier];
     Browser.touches[touch.identifier] = {
      x: adjustedX,
      y: adjustedY
     };
    }
    return;
   }
   var x = event.pageX - (scrollX + rect.left);
   var y = event.pageY - (scrollY + rect.top);
   x = x * (cw / rect.width);
   y = y * (ch / rect.height);
   Browser.mouseMovementX = x - Browser.mouseX;
   Browser.mouseMovementY = y - Browser.mouseY;
   Browser.mouseX = x;
   Browser.mouseY = y;
  }
 }),
 xhrLoad: (function(url, onload, onerror) {
  var xhr = new XMLHttpRequest;
  xhr.open("GET", url, true);
  xhr.responseType = "arraybuffer";
  xhr.onload = function xhr_onload() {
   if (xhr.status == 200 || xhr.status == 0 && xhr.response) {
    onload(xhr.response);
   } else {
    onerror();
   }
  };
  xhr.onerror = onerror;
  xhr.send(null);
 }),
 asyncLoad: (function(url, onload, onerror, noRunDep) {
  Browser.xhrLoad(url, (function(arrayBuffer) {
   assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
   onload(new Uint8Array(arrayBuffer));
   if (!noRunDep) removeRunDependency("al " + url);
  }), (function(event) {
   if (onerror) {
    onerror();
   } else {
    throw 'Loading data file "' + url + '" failed.';
   }
  }));
  if (!noRunDep) addRunDependency("al " + url);
 }),
 resizeListeners: [],
 updateResizeListeners: (function() {
  var canvas = Module["canvas"];
  Browser.resizeListeners.forEach((function(listener) {
   listener(canvas.width, canvas.height);
  }));
 }),
 setCanvasSize: (function(width, height, noUpdates) {
  var canvas = Module["canvas"];
  Browser.updateCanvasDimensions(canvas, width, height);
  if (!noUpdates) Browser.updateResizeListeners();
 }),
 windowedWidth: 0,
 windowedHeight: 0,
 setFullScreenCanvasSize: (function() {
  if (typeof SDL != "undefined") {
   var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
   flags = flags | 8388608;
   HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
  }
  Browser.updateResizeListeners();
 }),
 setWindowedCanvasSize: (function() {
  if (typeof SDL != "undefined") {
   var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
   flags = flags & ~8388608;
   HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
  }
  Browser.updateResizeListeners();
 }),
 updateCanvasDimensions: (function(canvas, wNative, hNative) {
  if (wNative && hNative) {
   canvas.widthNative = wNative;
   canvas.heightNative = hNative;
  } else {
   wNative = canvas.widthNative;
   hNative = canvas.heightNative;
  }
  var w = wNative;
  var h = hNative;
  if (Module["forcedAspectRatio"] && Module["forcedAspectRatio"] > 0) {
   if (w / h < Module["forcedAspectRatio"]) {
    w = Math.round(h * Module["forcedAspectRatio"]);
   } else {
    h = Math.round(w / Module["forcedAspectRatio"]);
   }
  }
  if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvas.parentNode && typeof screen != "undefined") {
   var factor = Math.min(screen.width / w, screen.height / h);
   w = Math.round(w * factor);
   h = Math.round(h * factor);
  }
  if (Browser.resizeCanvas) {
   if (canvas.width != w) canvas.width = w;
   if (canvas.height != h) canvas.height = h;
   if (typeof canvas.style != "undefined") {
    canvas.style.removeProperty("width");
    canvas.style.removeProperty("height");
   }
  } else {
   if (canvas.width != wNative) canvas.width = wNative;
   if (canvas.height != hNative) canvas.height = hNative;
   if (typeof canvas.style != "undefined") {
    if (w != wNative || h != hNative) {
     canvas.style.setProperty("width", w + "px", "important");
     canvas.style.setProperty("height", h + "px", "important");
    } else {
     canvas.style.removeProperty("width");
     canvas.style.removeProperty("height");
    }
   }
  }
 }),
 wgetRequests: {},
 nextWgetRequestHandle: 0,
 getNextWgetRequestHandle: (function() {
  var handle = Browser.nextWgetRequestHandle;
  Browser.nextWgetRequestHandle++;
  return handle;
 })
};
function _malloc(bytes) {
 var ptr = Runtime.dynamicAlloc(bytes + 8);
 return ptr + 8 & 4294967288;
}
Module["_malloc"] = _malloc;
function _free() {}
Module["_free"] = _free;
var _environ = allocate(1, "i32*", ALLOC_STATIC);
var ___environ = _environ;
function ___buildEnvironment(env) {
 var MAX_ENV_VALUES = 64;
 var TOTAL_ENV_SIZE = 1024;
 var poolPtr;
 var envPtr;
 if (!___buildEnvironment.called) {
  ___buildEnvironment.called = true;
  ENV["USER"] = "web_user";
  ENV["PATH"] = "/";
  ENV["PWD"] = "/";
  ENV["HOME"] = "/home/web_user";
  ENV["LANG"] = "C";
  ENV["_"] = Module["thisProgram"];
  poolPtr = allocate(TOTAL_ENV_SIZE, "i8", ALLOC_STATIC);
  envPtr = allocate(MAX_ENV_VALUES * 4, "i8*", ALLOC_STATIC);
  HEAP32[envPtr >> 2] = poolPtr;
  HEAP32[_environ >> 2] = envPtr;
 } else {
  envPtr = HEAP32[_environ >> 2];
  poolPtr = HEAP32[envPtr >> 2];
 }
 var strings = [];
 var totalSize = 0;
 for (var key in env) {
  if (typeof env[key] === "string") {
   var line = key + "=" + env[key];
   strings.push(line);
   totalSize += line.length;
  }
 }
 if (totalSize > TOTAL_ENV_SIZE) {
  throw new Error("Environment size exceeded TOTAL_ENV_SIZE!");
 }
 var ptrSize = 4;
 for (var i = 0; i < strings.length; i++) {
  var line = strings[i];
  writeAsciiToMemory(line, poolPtr);
  HEAP32[envPtr + i * ptrSize >> 2] = poolPtr;
  poolPtr += line.length + 1;
 }
 HEAP32[envPtr + strings.length * ptrSize >> 2] = 0;
}
var ENV = {};
function _getenv(name) {
 if (name === 0) return 0;
 name = Pointer_stringify(name);
 if (!ENV.hasOwnProperty(name)) return 0;
 if (_getenv.ret) _free(_getenv.ret);
 _getenv.ret = allocate(intArrayFromString(ENV[name]), "i8", ALLOC_NORMAL);
 return _getenv.ret;
}
function _putenv(string) {
 if (string === 0) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 string = Pointer_stringify(string);
 var splitPoint = string.indexOf("=");
 if (string === "" || string.indexOf("=") === -1) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 var name = string.slice(0, splitPoint);
 var value = string.slice(splitPoint + 1);
 if (!(name in ENV) || ENV[name] !== value) {
  ENV[name] = value;
  ___buildEnvironment(ENV);
 }
 return 0;
}
function _SDL_RWFromConstMem(mem, size) {
 var id = SDL.rwops.length;
 SDL.rwops.push({
  bytes: mem,
  count: size
 });
 return id;
}
function _TTF_FontHeight(font) {
 var fontData = SDL.fonts[font];
 return fontData.size;
}
function _TTF_SizeText(font, text, w, h) {
 var fontData = SDL.fonts[font];
 if (w) {
  HEAP32[w >> 2] = SDL.estimateTextWidth(fontData, Pointer_stringify(text));
 }
 if (h) {
  HEAP32[h >> 2] = fontData.size;
 }
 return 0;
}
function _TTF_RenderText_Solid(font, text, color) {
 text = Pointer_stringify(text) || " ";
 var fontData = SDL.fonts[font];
 var w = SDL.estimateTextWidth(fontData, text);
 var h = fontData.size;
 var color = SDL.loadColorToCSSRGB(color);
 var fontString = h + "px " + fontData.name;
 var surf = SDL.makeSurface(w, h, 0, false, "text:" + text);
 var surfData = SDL.surfaces[surf];
 surfData.ctx.save();
 surfData.ctx.fillStyle = color;
 surfData.ctx.font = fontString;
 surfData.ctx.textBaseline = "top";
 surfData.ctx.fillText(text, 0, 0);
 surfData.ctx.restore();
 return surf;
}
function _Mix_HaltMusic() {
 var audio = SDL.music.audio;
 if (audio) {
  audio.src = audio.src;
  audio.currentPosition = 0;
  audio.pause();
 }
 SDL.music.audio = null;
 if (SDL.hookMusicFinished) {
  Runtime.dynCall("v", SDL.hookMusicFinished);
 }
 return 0;
}
function _Mix_PlayMusic(id, loops) {
 if (SDL.music.audio) {
  if (!SDL.music.audio.paused) Module.printErr("Music is already playing. " + SDL.music.source);
  SDL.music.audio.pause();
 }
 var info = SDL.audios[id];
 var audio;
 if (info.webAudio) {
  audio = {};
  audio.resource = info;
  audio.paused = false;
  audio.currentPosition = 0;
  audio.play = (function() {
   SDL.playWebAudio(this);
  });
  audio.pause = (function() {
   SDL.pauseWebAudio(this);
  });
 } else if (info.audio) {
  audio = info.audio;
 }
 audio["onended"] = (function() {
  if (SDL.music.audio == this) _Mix_HaltMusic();
 });
 audio.loop = loops != 0;
 audio.volume = SDL.music.volume;
 SDL.music.audio = audio;
 audio.play();
 return 0;
}
function _Mix_FreeChunk(id) {
 SDL.audios[id] = null;
}
function _Mix_LoadWAV_RW(rwopsID, freesrc) {
 var rwops = SDL.rwops[rwopsID];
 if (rwops === undefined) return 0;
 var filename = "";
 var audio;
 var webAudio;
 var bytes;
 if (rwops.filename !== undefined) {
  filename = PATH.resolve(rwops.filename);
  var raw = Module["preloadedAudios"][filename];
  if (!raw) {
   if (raw === null) Module.printErr("Trying to reuse preloaded audio, but freePreloadedMediaOnUse is set!");
   if (!Module.noAudioDecoding) Runtime.warnOnce("Cannot find preloaded audio " + filename);
   try {
    bytes = FS.readFile(filename);
   } catch (e) {
    Module.printErr("Couldn't find file for: " + filename);
    return 0;
   }
  }
  if (Module["freePreloadedMediaOnUse"]) {
   Module["preloadedAudios"][filename] = null;
  }
  audio = raw;
 } else if (rwops.bytes !== undefined) {
  if (SDL.webAudioAvailable()) bytes = HEAPU8.buffer.slice(rwops.bytes, rwops.bytes + rwops.count); else bytes = HEAPU8.subarray(rwops.bytes, rwops.bytes + rwops.count);
 } else {
  return 0;
 }
 var arrayBuffer = bytes ? bytes.buffer || bytes : bytes;
 var canPlayWithWebAudio = Module["SDL_canPlayWithWebAudio"] === undefined || Module["SDL_canPlayWithWebAudio"](filename, arrayBuffer);
 if (bytes !== undefined && SDL.webAudioAvailable() && canPlayWithWebAudio) {
  audio = undefined;
  webAudio = {};
  webAudio.onDecodeComplete = [];
  function onDecodeComplete(data) {
   webAudio.decodedBuffer = data;
   webAudio.onDecodeComplete.forEach((function(e) {
    e();
   }));
   webAudio.onDecodeComplete = undefined;
  }
  SDL.audioContext["decodeAudioData"](arrayBuffer, onDecodeComplete);
 } else if (audio === undefined && bytes) {
  var blob = new Blob([ bytes ], {
   type: rwops.mimetype
  });
  var url = URL.createObjectURL(blob);
  audio = new Audio;
  audio.src = url;
  audio.mozAudioChannelType = "content";
 }
 var id = SDL.audios.length;
 SDL.audios.push({
  source: filename,
  audio: audio,
  webAudio: webAudio
 });
 return id;
}
function _Mix_PlayChannel(channel, id, loops) {
 var info = SDL.audios[id];
 if (!info) return -1;
 if (!info.audio && !info.webAudio) return -1;
 if (channel == -1) {
  for (var i = SDL.channelMinimumNumber; i < SDL.numChannels; i++) {
   if (!SDL.channels[i].audio) {
    channel = i;
    break;
   }
  }
  if (channel == -1) {
   Module.printErr("All " + SDL.numChannels + " channels in use!");
   return -1;
  }
 }
 var channelInfo = SDL.channels[channel];
 var audio;
 if (info.webAudio) {
  audio = {};
  audio.resource = info;
  audio.paused = false;
  audio.currentPosition = 0;
  audio.play = (function() {
   SDL.playWebAudio(this);
  });
  audio.pause = (function() {
   SDL.pauseWebAudio(this);
  });
 } else {
  audio = info.audio.cloneNode(true);
  audio.numChannels = info.audio.numChannels;
  audio.frequency = info.audio.frequency;
 }
 audio["onended"] = function SDL_audio_onended() {
  if (channelInfo.audio == this) {
   channelInfo.audio.paused = true;
   channelInfo.audio = null;
  }
  if (SDL.channelFinished) Runtime.getFuncWrapper(SDL.channelFinished, "vi")(channel);
 };
 channelInfo.audio = audio;
 audio.loop = loops != 0;
 audio.volume = channelInfo.volume;
 audio.play();
 return channel;
}
function _SDL_PauseAudio(pauseOn) {
 if (!SDL.audio) {
  return;
 }
 if (pauseOn) {
  if (SDL.audio.timer !== undefined) {
   clearTimeout(SDL.audio.timer);
   SDL.audio.numAudioTimersPending = 0;
   SDL.audio.timer = undefined;
  }
 } else if (!SDL.audio.timer) {
  SDL.audio.numAudioTimersPending = 1;
  SDL.audio.timer = Browser.safeSetTimeout(SDL.audio.caller, 1);
 }
 SDL.audio.paused = pauseOn;
}
function _SDL_CloseAudio() {
 if (SDL.audio) {
  _SDL_PauseAudio(1);
  _free(SDL.audio.buffer);
  SDL.audio = null;
  SDL.allocateChannels(0);
 }
}
function _SDL_LockSurface(surf) {
 var surfData = SDL.surfaces[surf];
 surfData.locked++;
 if (surfData.locked > 1) return 0;
 if (!surfData.buffer) {
  surfData.buffer = _malloc(surfData.width * surfData.height * 4);
  HEAP32[surf + 20 >> 2] = surfData.buffer;
 }
 HEAP32[surf + 20 >> 2] = surfData.buffer;
 if (surf == SDL.screen && Module.screenIsReadOnly && surfData.image) return 0;
 if (SDL.defaults.discardOnLock) {
  if (!surfData.image) {
   surfData.image = surfData.ctx.createImageData(surfData.width, surfData.height);
  }
  if (!SDL.defaults.opaqueFrontBuffer) return;
 } else {
  surfData.image = surfData.ctx.getImageData(0, 0, surfData.width, surfData.height);
 }
 if (surf == SDL.screen && SDL.defaults.opaqueFrontBuffer) {
  var data = surfData.image.data;
  var num = data.length;
  for (var i = 0; i < num / 4; i++) {
   data[i * 4 + 3] = 255;
  }
 }
 if (SDL.defaults.copyOnLock && !SDL.defaults.discardOnLock) {
  if (surfData.isFlagSet(2097152)) {
   throw "CopyOnLock is not supported for SDL_LockSurface with SDL_HWPALETTE flag set" + (new Error).stack;
  } else {
   HEAPU8.set(surfData.image.data, surfData.buffer);
  }
 }
 return 0;
}
function _SDL_FreeRW(rwopsID) {
 SDL.rwops[rwopsID] = null;
 while (SDL.rwops.length > 0 && SDL.rwops[SDL.rwops.length - 1] === null) {
  SDL.rwops.pop();
 }
}
function _IMG_Load_RW(rwopsID, freeSrc) {
 try {
  function cleanup() {
   if (rwops && freeSrc) _SDL_FreeRW(rwopsID);
  }
  function addCleanup(func) {
   var old = cleanup;
   cleanup = function added_cleanup() {
    old();
    func();
   };
  }
  function callStbImage(func, params) {
   var x = Module["_malloc"](4);
   var y = Module["_malloc"](4);
   var comp = Module["_malloc"](4);
   addCleanup((function() {
    Module["_free"](x);
    Module["_free"](y);
    Module["_free"](comp);
    if (data) Module["_stbi_image_free"](data);
   }));
   var data = Module["_" + func].apply(null, params.concat([ x, y, comp, 0 ]));
   if (!data) return null;
   return {
    rawData: true,
    data: data,
    width: HEAP32[x >> 2],
    height: HEAP32[y >> 2],
    size: HEAP32[x >> 2] * HEAP32[y >> 2] * HEAP32[comp >> 2],
    bpp: HEAP32[comp >> 2]
   };
  }
  var rwops = SDL.rwops[rwopsID];
  if (rwops === undefined) {
   return 0;
  }
  var filename = rwops.filename;
  if (filename === undefined) {
   Runtime.warnOnce("Only file names that have been preloaded are supported for IMG_Load_RW. Consider using STB_IMAGE=1 if you want synchronous image decoding (see settings.js)");
   return 0;
  }
  if (!raw) {
   filename = PATH.resolve(filename);
   var raw = Module["preloadedImages"][filename];
   if (!raw) {
    if (raw === null) Module.printErr("Trying to reuse preloaded image, but freePreloadedMediaOnUse is set!");
    Runtime.warnOnce("Cannot find preloaded image " + filename);
    Runtime.warnOnce("Cannot find preloaded image " + filename + ". Consider using STB_IMAGE=1 if you want synchronous image decoding (see settings.js)");
    return 0;
   } else if (Module["freePreloadedMediaOnUse"]) {
    Module["preloadedImages"][filename] = null;
   }
  }
  var surf = SDL.makeSurface(raw.width, raw.height, 0, false, "load:" + filename);
  var surfData = SDL.surfaces[surf];
  surfData.ctx.globalCompositeOperation = "copy";
  if (!raw.rawData) {
   surfData.ctx.drawImage(raw, 0, 0, raw.width, raw.height, 0, 0, raw.width, raw.height);
  } else {
   var imageData = surfData.ctx.getImageData(0, 0, surfData.width, surfData.height);
   if (raw.bpp == 4) {
    imageData.data.set(HEAPU8.subarray(raw.data, raw.data + raw.size));
   } else if (raw.bpp == 3) {
    var pixels = raw.size / 3;
    var data = imageData.data;
    var sourcePtr = raw.data;
    var destPtr = 0;
    for (var i = 0; i < pixels; i++) {
     data[destPtr++] = HEAPU8[sourcePtr++ >> 0];
     data[destPtr++] = HEAPU8[sourcePtr++ >> 0];
     data[destPtr++] = HEAPU8[sourcePtr++ >> 0];
     data[destPtr++] = 255;
    }
   } else if (raw.bpp == 1) {
    var pixels = raw.size;
    var data = imageData.data;
    var sourcePtr = raw.data;
    var destPtr = 0;
    for (var i = 0; i < pixels; i++) {
     var value = HEAPU8[sourcePtr++ >> 0];
     data[destPtr++] = value;
     data[destPtr++] = value;
     data[destPtr++] = value;
     data[destPtr++] = 255;
    }
   } else {
    Module.printErr("cannot handle bpp " + raw.bpp);
    return 0;
   }
   surfData.ctx.putImageData(imageData, 0, 0);
  }
  surfData.ctx.globalCompositeOperation = "source-over";
  _SDL_LockSurface(surf);
  surfData.locked--;
  if (SDL.GL) {
   surfData.canvas = surfData.ctx = null;
  }
  return surf;
 } finally {
  cleanup();
 }
}
function _SDL_RWFromFile(_name, mode) {
 var id = SDL.rwops.length;
 var name = Pointer_stringify(_name);
 SDL.rwops.push({
  filename: name,
  mimetype: Browser.getMimetype(name)
 });
 return id;
}
function _IMG_Load(filename) {
 var rwops = _SDL_RWFromFile(filename);
 var result = _IMG_Load_RW(rwops, 1);
 return result;
}
function _SDL_UpperBlitScaled(src, srcrect, dst, dstrect) {
 return SDL.blitSurface(src, srcrect, dst, dstrect, true);
}
function _SDL_UpperBlit(src, srcrect, dst, dstrect) {
 return SDL.blitSurface(src, srcrect, dst, dstrect, false);
}
function _SDL_GetTicks() {
 return Date.now() - SDL.startTime | 0;
}
var SDL = {
 defaults: {
  width: 320,
  height: 200,
  copyOnLock: true,
  discardOnLock: false,
  opaqueFrontBuffer: true
 },
 version: null,
 surfaces: {},
 canvasPool: [],
 events: [],
 fonts: [ null ],
 audios: [ null ],
 rwops: [ null ],
 music: {
  audio: null,
  volume: 1
 },
 mixerFrequency: 22050,
 mixerFormat: 32784,
 mixerNumChannels: 2,
 mixerChunkSize: 1024,
 channelMinimumNumber: 0,
 GL: false,
 glAttributes: {
  0: 3,
  1: 3,
  2: 2,
  3: 0,
  4: 0,
  5: 1,
  6: 16,
  7: 0,
  8: 0,
  9: 0,
  10: 0,
  11: 0,
  12: 0,
  13: 0,
  14: 0,
  15: 1,
  16: 0,
  17: 0,
  18: 0
 },
 keyboardState: null,
 keyboardMap: {},
 canRequestFullscreen: false,
 isRequestingFullscreen: false,
 textInput: false,
 startTime: null,
 initFlags: 0,
 buttonState: 0,
 modState: 0,
 DOMButtons: [ 0, 0, 0 ],
 DOMEventToSDLEvent: {},
 TOUCH_DEFAULT_ID: 0,
 eventHandler: null,
 eventHandlerContext: null,
 keyCodes: {
  16: 1249,
  17: 1248,
  18: 1250,
  20: 1081,
  33: 1099,
  34: 1102,
  35: 1101,
  36: 1098,
  37: 1104,
  38: 1106,
  39: 1103,
  40: 1105,
  44: 316,
  45: 1097,
  46: 127,
  91: 1251,
  93: 1125,
  96: 1122,
  97: 1113,
  98: 1114,
  99: 1115,
  100: 1116,
  101: 1117,
  102: 1118,
  103: 1119,
  104: 1120,
  105: 1121,
  106: 1109,
  107: 1111,
  109: 1110,
  110: 1123,
  111: 1108,
  112: 1082,
  113: 1083,
  114: 1084,
  115: 1085,
  116: 1086,
  117: 1087,
  118: 1088,
  119: 1089,
  120: 1090,
  121: 1091,
  122: 1092,
  123: 1093,
  124: 1128,
  125: 1129,
  126: 1130,
  127: 1131,
  128: 1132,
  129: 1133,
  130: 1134,
  131: 1135,
  132: 1136,
  133: 1137,
  134: 1138,
  135: 1139,
  144: 1107,
  160: 94,
  161: 33,
  162: 34,
  163: 35,
  164: 36,
  165: 37,
  166: 38,
  167: 95,
  168: 40,
  169: 41,
  170: 42,
  171: 43,
  172: 124,
  173: 45,
  174: 123,
  175: 125,
  176: 126,
  181: 127,
  182: 129,
  183: 128,
  188: 44,
  190: 46,
  191: 47,
  192: 96,
  219: 91,
  220: 92,
  221: 93,
  222: 39
 },
 scanCodes: {
  8: 42,
  9: 43,
  13: 40,
  27: 41,
  32: 44,
  35: 204,
  39: 53,
  44: 54,
  46: 55,
  47: 56,
  48: 39,
  49: 30,
  50: 31,
  51: 32,
  52: 33,
  53: 34,
  54: 35,
  55: 36,
  56: 37,
  57: 38,
  58: 203,
  59: 51,
  61: 46,
  91: 47,
  92: 49,
  93: 48,
  96: 52,
  97: 4,
  98: 5,
  99: 6,
  100: 7,
  101: 8,
  102: 9,
  103: 10,
  104: 11,
  105: 12,
  106: 13,
  107: 14,
  108: 15,
  109: 16,
  110: 17,
  111: 18,
  112: 19,
  113: 20,
  114: 21,
  115: 22,
  116: 23,
  117: 24,
  118: 25,
  119: 26,
  120: 27,
  121: 28,
  122: 29,
  127: 76,
  305: 224,
  308: 226,
  316: 70
 },
 loadRect: (function(rect) {
  return {
   x: HEAP32[rect + 0 >> 2],
   y: HEAP32[rect + 4 >> 2],
   w: HEAP32[rect + 8 >> 2],
   h: HEAP32[rect + 12 >> 2]
  };
 }),
 updateRect: (function(rect, r) {
  HEAP32[rect >> 2] = r.x;
  HEAP32[rect + 4 >> 2] = r.y;
  HEAP32[rect + 8 >> 2] = r.w;
  HEAP32[rect + 12 >> 2] = r.h;
 }),
 intersectionOfRects: (function(first, second) {
  var leftX = Math.max(first.x, second.x);
  var leftY = Math.max(first.y, second.y);
  var rightX = Math.min(first.x + first.w, second.x + second.w);
  var rightY = Math.min(first.y + first.h, second.y + second.h);
  return {
   x: leftX,
   y: leftY,
   w: Math.max(leftX, rightX) - leftX,
   h: Math.max(leftY, rightY) - leftY
  };
 }),
 checkPixelFormat: (function(fmt) {}),
 loadColorToCSSRGB: (function(color) {
  var rgba = HEAP32[color >> 2];
  return "rgb(" + (rgba & 255) + "," + (rgba >> 8 & 255) + "," + (rgba >> 16 & 255) + ")";
 }),
 loadColorToCSSRGBA: (function(color) {
  var rgba = HEAP32[color >> 2];
  return "rgba(" + (rgba & 255) + "," + (rgba >> 8 & 255) + "," + (rgba >> 16 & 255) + "," + (rgba >> 24 & 255) / 255 + ")";
 }),
 translateColorToCSSRGBA: (function(rgba) {
  return "rgba(" + (rgba & 255) + "," + (rgba >> 8 & 255) + "," + (rgba >> 16 & 255) + "," + (rgba >>> 24) / 255 + ")";
 }),
 translateRGBAToCSSRGBA: (function(r, g, b, a) {
  return "rgba(" + (r & 255) + "," + (g & 255) + "," + (b & 255) + "," + (a & 255) / 255 + ")";
 }),
 translateRGBAToColor: (function(r, g, b, a) {
  return r | g << 8 | b << 16 | a << 24;
 }),
 makeSurface: (function(width, height, flags, usePageCanvas, source, rmask, gmask, bmask, amask) {
  flags = flags || 0;
  var is_SDL_HWSURFACE = flags & 1;
  var is_SDL_HWPALETTE = flags & 2097152;
  var is_SDL_OPENGL = flags & 67108864;
  var surf = _malloc(60);
  var pixelFormat = _malloc(44);
  var bpp = is_SDL_HWPALETTE ? 1 : 4;
  var buffer = 0;
  if (!is_SDL_HWSURFACE && !is_SDL_OPENGL) {
   buffer = _malloc(width * height * 4);
  }
  HEAP32[surf >> 2] = flags;
  HEAP32[surf + 4 >> 2] = pixelFormat;
  HEAP32[surf + 8 >> 2] = width;
  HEAP32[surf + 12 >> 2] = height;
  HEAP32[surf + 16 >> 2] = width * bpp;
  HEAP32[surf + 20 >> 2] = buffer;
  HEAP32[surf + 36 >> 2] = 0;
  HEAP32[surf + 40 >> 2] = 0;
  HEAP32[surf + 44 >> 2] = Module["canvas"].width;
  HEAP32[surf + 48 >> 2] = Module["canvas"].height;
  HEAP32[surf + 56 >> 2] = 1;
  HEAP32[pixelFormat >> 2] = -2042224636;
  HEAP32[pixelFormat + 4 >> 2] = 0;
  HEAP8[pixelFormat + 8 >> 0] = bpp * 8;
  HEAP8[pixelFormat + 9 >> 0] = bpp;
  HEAP32[pixelFormat + 12 >> 2] = rmask || 255;
  HEAP32[pixelFormat + 16 >> 2] = gmask || 65280;
  HEAP32[pixelFormat + 20 >> 2] = bmask || 16711680;
  HEAP32[pixelFormat + 24 >> 2] = amask || 4278190080;
  SDL.GL = SDL.GL || is_SDL_OPENGL;
  var canvas;
  if (!usePageCanvas) {
   if (SDL.canvasPool.length > 0) {
    canvas = SDL.canvasPool.pop();
   } else {
    canvas = document.createElement("canvas");
   }
   canvas.width = width;
   canvas.height = height;
  } else {
   canvas = Module["canvas"];
  }
  var webGLContextAttributes = {
   antialias: SDL.glAttributes[13] != 0 && SDL.glAttributes[14] > 1,
   depth: SDL.glAttributes[6] > 0,
   stencil: SDL.glAttributes[7] > 0
  };
  var ctx = Browser.createContext(canvas, is_SDL_OPENGL, usePageCanvas, webGLContextAttributes);
  SDL.surfaces[surf] = {
   width: width,
   height: height,
   canvas: canvas,
   ctx: ctx,
   surf: surf,
   buffer: buffer,
   pixelFormat: pixelFormat,
   alpha: 255,
   flags: flags,
   locked: 0,
   usePageCanvas: usePageCanvas,
   source: source,
   isFlagSet: (function(flag) {
    return flags & flag;
   })
  };
  return surf;
 }),
 copyIndexedColorData: (function(surfData, rX, rY, rW, rH) {
  if (!surfData.colors) {
   return;
  }
  var fullWidth = Module["canvas"].width;
  var fullHeight = Module["canvas"].height;
  var startX = rX || 0;
  var startY = rY || 0;
  var endX = (rW || fullWidth - startX) + startX;
  var endY = (rH || fullHeight - startY) + startY;
  var buffer = surfData.buffer;
  if (!surfData.image.data32) {
   surfData.image.data32 = new Uint32Array(surfData.image.data.buffer);
  }
  var data32 = surfData.image.data32;
  var colors32 = surfData.colors32;
  for (var y = startY; y < endY; ++y) {
   var base = y * fullWidth;
   for (var x = startX; x < endX; ++x) {
    data32[base + x] = colors32[HEAPU8[buffer + base + x >> 0]];
   }
  }
 }),
 freeSurface: (function(surf) {
  var refcountPointer = surf + 56;
  var refcount = HEAP32[refcountPointer >> 2];
  if (refcount > 1) {
   HEAP32[refcountPointer >> 2] = refcount - 1;
   return;
  }
  var info = SDL.surfaces[surf];
  if (!info.usePageCanvas && info.canvas) SDL.canvasPool.push(info.canvas);
  if (info.buffer) _free(info.buffer);
  _free(info.pixelFormat);
  _free(surf);
  SDL.surfaces[surf] = null;
  if (surf === SDL.screen) {
   SDL.screen = null;
  }
 }),
 blitSurface__deps: [ "SDL_LockSurface" ],
 blitSurface: (function(src, srcrect, dst, dstrect, scale) {
  var srcData = SDL.surfaces[src];
  var dstData = SDL.surfaces[dst];
  var sr, dr;
  if (srcrect) {
   sr = SDL.loadRect(srcrect);
  } else {
   sr = {
    x: 0,
    y: 0,
    w: srcData.width,
    h: srcData.height
   };
  }
  if (dstrect) {
   dr = SDL.loadRect(dstrect);
  } else {
   dr = {
    x: 0,
    y: 0,
    w: srcData.width,
    h: srcData.height
   };
  }
  if (dstData.clipRect) {
   var widthScale = !scale || sr.w === 0 ? 1 : sr.w / dr.w;
   var heightScale = !scale || sr.h === 0 ? 1 : sr.h / dr.h;
   dr = SDL.intersectionOfRects(dstData.clipRect, dr);
   sr.w = dr.w * widthScale;
   sr.h = dr.h * heightScale;
   if (dstrect) {
    SDL.updateRect(dstrect, dr);
   }
  }
  var blitw, blith;
  if (scale) {
   blitw = dr.w;
   blith = dr.h;
  } else {
   blitw = sr.w;
   blith = sr.h;
  }
  if (sr.w === 0 || sr.h === 0 || blitw === 0 || blith === 0) {
   return 0;
  }
  var oldAlpha = dstData.ctx.globalAlpha;
  dstData.ctx.globalAlpha = srcData.alpha / 255;
  dstData.ctx.drawImage(srcData.canvas, sr.x, sr.y, sr.w, sr.h, dr.x, dr.y, blitw, blith);
  dstData.ctx.globalAlpha = oldAlpha;
  if (dst != SDL.screen) {
   Runtime.warnOnce("WARNING: copying canvas data to memory for compatibility");
   _SDL_LockSurface(dst);
   dstData.locked--;
  }
  return 0;
 }),
 downFingers: {},
 savedKeydown: null,
 receiveEvent: (function(event) {
  function unpressAllPressedKeys() {
   for (var code in SDL.keyboardMap) {
    SDL.events.push({
     type: "keyup",
     keyCode: SDL.keyboardMap[code]
    });
   }
  }
  switch (event.type) {
  case "touchstart":
  case "touchmove":
   {
    event.preventDefault();
    var touches = [];
    if (event.type === "touchstart") {
     for (var i = 0; i < event.touches.length; i++) {
      var touch = event.touches[i];
      if (SDL.downFingers[touch.identifier] != true) {
       SDL.downFingers[touch.identifier] = true;
       touches.push(touch);
      }
     }
    } else {
     touches = event.touches;
    }
    var firstTouch = touches[0];
    if (event.type == "touchstart") {
     SDL.DOMButtons[0] = 1;
    }
    var mouseEventType;
    switch (event.type) {
    case "touchstart":
     mouseEventType = "mousedown";
     break;
    case "touchmove":
     mouseEventType = "mousemove";
     break;
    }
    var mouseEvent = {
     type: mouseEventType,
     button: 0,
     pageX: firstTouch.clientX,
     pageY: firstTouch.clientY
    };
    SDL.events.push(mouseEvent);
    for (var i = 0; i < touches.length; i++) {
     var touch = touches[i];
     SDL.events.push({
      type: event.type,
      touch: touch
     });
    }
    break;
   }
  case "touchend":
   {
    event.preventDefault();
    for (var i = 0; i < event.changedTouches.length; i++) {
     var touch = event.changedTouches[i];
     if (SDL.downFingers[touch.identifier] === true) {
      delete SDL.downFingers[touch.identifier];
     }
    }
    var mouseEvent = {
     type: "mouseup",
     button: 0,
     pageX: event.changedTouches[0].clientX,
     pageY: event.changedTouches[0].clientY
    };
    SDL.DOMButtons[0] = 0;
    SDL.events.push(mouseEvent);
    for (var i = 0; i < event.changedTouches.length; i++) {
     var touch = event.changedTouches[i];
     SDL.events.push({
      type: "touchend",
      touch: touch
     });
    }
    break;
   }
  case "DOMMouseScroll":
  case "mousewheel":
  case "wheel":
   var delta = -Browser.getMouseWheelDelta(event);
   delta = delta == 0 ? 0 : delta > 0 ? Math.max(delta, 1) : Math.min(delta, -1);
   var button = delta > 0 ? 3 : 4;
   SDL.events.push({
    type: "mousedown",
    button: button,
    pageX: event.pageX,
    pageY: event.pageY
   });
   SDL.events.push({
    type: "mouseup",
    button: button,
    pageX: event.pageX,
    pageY: event.pageY
   });
   SDL.events.push({
    type: "wheel",
    deltaX: 0,
    deltaY: delta
   });
   event.preventDefault();
   break;
  case "mousemove":
   if (SDL.DOMButtons[0] === 1) {
    SDL.events.push({
     type: "touchmove",
     touch: {
      identifier: 0,
      deviceID: -1,
      pageX: event.pageX,
      pageY: event.pageY
     }
    });
   }
   if (Browser.pointerLock) {
    if ("mozMovementX" in event) {
     event["movementX"] = event["mozMovementX"];
     event["movementY"] = event["mozMovementY"];
    }
    if (event["movementX"] == 0 && event["movementY"] == 0) {
     event.preventDefault();
     return;
    }
   }
  case "keydown":
  case "keyup":
  case "keypress":
  case "mousedown":
  case "mouseup":
   if (event.type !== "keydown" || !SDL.unicode && !SDL.textInput || event.keyCode === 8 || event.keyCode === 9) {
    event.preventDefault();
   }
   if (event.type == "mousedown") {
    SDL.DOMButtons[event.button] = 1;
    SDL.events.push({
     type: "touchstart",
     touch: {
      identifier: 0,
      deviceID: -1,
      pageX: event.pageX,
      pageY: event.pageY
     }
    });
   } else if (event.type == "mouseup") {
    if (!SDL.DOMButtons[event.button]) {
     return;
    }
    SDL.events.push({
     type: "touchend",
     touch: {
      identifier: 0,
      deviceID: -1,
      pageX: event.pageX,
      pageY: event.pageY
     }
    });
    SDL.DOMButtons[event.button] = 0;
   }
   if (event.type === "keydown" || event.type === "mousedown") {
    SDL.canRequestFullscreen = true;
   } else if (event.type === "keyup" || event.type === "mouseup") {
    if (SDL.isRequestingFullscreen) {
     Module["requestFullScreen"](true, true);
     SDL.isRequestingFullscreen = false;
    }
    SDL.canRequestFullscreen = false;
   }
   if (event.type === "keypress" && SDL.savedKeydown) {
    SDL.savedKeydown.keypressCharCode = event.charCode;
    SDL.savedKeydown = null;
   } else if (event.type === "keydown") {
    SDL.savedKeydown = event;
   }
   if (event.type !== "keypress" || SDL.textInput) {
    SDL.events.push(event);
   }
   break;
  case "mouseout":
   for (var i = 0; i < 3; i++) {
    if (SDL.DOMButtons[i]) {
     SDL.events.push({
      type: "mouseup",
      button: i,
      pageX: event.pageX,
      pageY: event.pageY
     });
     SDL.DOMButtons[i] = 0;
    }
   }
   event.preventDefault();
   break;
  case "focus":
   SDL.events.push(event);
   event.preventDefault();
   break;
  case "blur":
   SDL.events.push(event);
   unpressAllPressedKeys();
   event.preventDefault();
   break;
  case "visibilitychange":
   SDL.events.push({
    type: "visibilitychange",
    visible: !document.hidden
   });
   unpressAllPressedKeys();
   event.preventDefault();
   break;
  case "unload":
   if (Browser.mainLoop.runner) {
    SDL.events.push(event);
    Browser.mainLoop.runner();
   }
   return;
  case "resize":
   SDL.events.push(event);
   if (event.preventDefault) {
    event.preventDefault();
   }
   break;
  }
  if (SDL.events.length >= 1e4) {
   Module.printErr("SDL event queue full, dropping events");
   SDL.events = SDL.events.slice(0, 1e4);
  }
  SDL.flushEventsToHandler();
  return;
 }),
 lookupKeyCodeForEvent: (function(event) {
  var code = event.keyCode;
  if (code >= 65 && code <= 90) {
   code += 32;
  } else {
   code = SDL.keyCodes[event.keyCode] || event.keyCode;
   if (event.location === KeyboardEvent.DOM_KEY_LOCATION_RIGHT && code >= (224 | 1 << 10) && code <= (227 | 1 << 10)) {
    code += 4;
   }
  }
  return code;
 }),
 handleEvent: (function(event) {
  if (event.handled) return;
  event.handled = true;
  switch (event.type) {
  case "touchstart":
  case "touchend":
  case "touchmove":
   {
    Browser.calculateMouseEvent(event);
    break;
   }
  case "keydown":
  case "keyup":
   {
    var down = event.type === "keydown";
    var code = SDL.lookupKeyCodeForEvent(event);
    HEAP8[SDL.keyboardState + code >> 0] = down;
    SDL.modState = (HEAP8[SDL.keyboardState + 1248 >> 0] ? 64 : 0) | (HEAP8[SDL.keyboardState + 1249 >> 0] ? 1 : 0) | (HEAP8[SDL.keyboardState + 1250 >> 0] ? 256 : 0) | (HEAP8[SDL.keyboardState + 1252 >> 0] ? 128 : 0) | (HEAP8[SDL.keyboardState + 1253 >> 0] ? 2 : 0) | (HEAP8[SDL.keyboardState + 1254 >> 0] ? 512 : 0);
    if (down) {
     SDL.keyboardMap[code] = event.keyCode;
    } else {
     delete SDL.keyboardMap[code];
    }
    break;
   }
  case "mousedown":
  case "mouseup":
   if (event.type == "mousedown") {
    SDL.buttonState |= 1 << event.button;
   } else if (event.type == "mouseup") {
    SDL.buttonState &= ~(1 << event.button);
   }
  case "mousemove":
   {
    Browser.calculateMouseEvent(event);
    break;
   }
  }
 }),
 flushEventsToHandler: (function() {
  if (!SDL.eventHandler) return;
  var sdlEventPtr = allocate(28, "i8", ALLOC_STACK);
  while (SDL.pollEvent(sdlEventPtr)) {
   Runtime.dynCall("iii", SDL.eventHandler, [ SDL.eventHandlerContext, sdlEventPtr ]);
  }
 }),
 pollEvent: (function(ptr) {
  if (SDL.initFlags & 512 && SDL.joystickEventState) {
   SDL.queryJoysticks();
  }
  if (ptr) {
   while (SDL.events.length > 0) {
    if (SDL.makeCEvent(SDL.events.shift(), ptr) !== false) return 1;
   }
   return 0;
  } else {
   return SDL.events.length > 0;
  }
 }),
 makeCEvent: (function(event, ptr) {
  if (typeof event === "number") {
   _memcpy(ptr, event, 28);
   _free(event);
   return;
  }
  SDL.handleEvent(event);
  switch (event.type) {
  case "keydown":
  case "keyup":
   {
    var down = event.type === "keydown";
    var key = SDL.lookupKeyCodeForEvent(event);
    var scan;
    if (key >= 1024) {
     scan = key - 1024;
    } else {
     scan = SDL.scanCodes[key] || key;
    }
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP8[ptr + 8 >> 0] = down ? 1 : 0;
    HEAP8[ptr + 9 >> 0] = 0;
    HEAP32[ptr + 12 >> 2] = scan;
    HEAP32[ptr + 16 >> 2] = key;
    HEAP16[ptr + 20 >> 1] = SDL.modState;
    HEAP32[ptr + 24 >> 2] = event.keypressCharCode || key;
    break;
   }
  case "keypress":
   {
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    var cStr = intArrayFromString(String.fromCharCode(event.charCode));
    for (var i = 0; i < cStr.length; ++i) {
     HEAP8[ptr + (8 + i) >> 0] = cStr[i];
    }
    break;
   }
  case "mousedown":
  case "mouseup":
  case "mousemove":
   {
    if (event.type != "mousemove") {
     var down = event.type === "mousedown";
     HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
     HEAP32[ptr + 4 >> 2] = 0;
     HEAP32[ptr + 8 >> 2] = 0;
     HEAP32[ptr + 12 >> 2] = 0;
     HEAP8[ptr + 16 >> 0] = event.button + 1;
     HEAP8[ptr + 17 >> 0] = down ? 1 : 0;
     HEAP32[ptr + 20 >> 2] = Browser.mouseX;
     HEAP32[ptr + 24 >> 2] = Browser.mouseY;
    } else {
     HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
     HEAP32[ptr + 4 >> 2] = 0;
     HEAP32[ptr + 8 >> 2] = 0;
     HEAP32[ptr + 12 >> 2] = 0;
     HEAP32[ptr + 16 >> 2] = SDL.buttonState;
     HEAP32[ptr + 20 >> 2] = Browser.mouseX;
     HEAP32[ptr + 24 >> 2] = Browser.mouseY;
     HEAP32[ptr + 28 >> 2] = Browser.mouseMovementX;
     HEAP32[ptr + 32 >> 2] = Browser.mouseMovementY;
    }
    break;
   }
  case "wheel":
   {
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP32[ptr + 16 >> 2] = event.deltaX;
    HEAP32[ptr + 20 >> 2] = event.deltaY;
    break;
   }
  case "touchstart":
  case "touchend":
  case "touchmove":
   {
    var touch = event.touch;
    if (!Browser.touches[touch.identifier]) break;
    var w = Module["canvas"].width;
    var h = Module["canvas"].height;
    var x = Browser.touches[touch.identifier].x / w;
    var y = Browser.touches[touch.identifier].y / h;
    var lx = Browser.lastTouches[touch.identifier].x / w;
    var ly = Browser.lastTouches[touch.identifier].y / h;
    var dx = x - lx;
    var dy = y - ly;
    if (touch["deviceID"] === undefined) touch.deviceID = SDL.TOUCH_DEFAULT_ID;
    if (dx === 0 && dy === 0 && event.type === "touchmove") return false;
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP32[ptr + 4 >> 2] = _SDL_GetTicks();
    tempI64 = [ touch.deviceID >>> 0, (tempDouble = touch.deviceID, +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0) ], HEAP32[ptr + 8 >> 2] = tempI64[0], HEAP32[ptr + 12 >> 2] = tempI64[1];
    tempI64 = [ touch.identifier >>> 0, (tempDouble = touch.identifier, +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0) ], HEAP32[ptr + 16 >> 2] = tempI64[0], HEAP32[ptr + 20 >> 2] = tempI64[1];
    HEAPF32[ptr + 24 >> 2] = x;
    HEAPF32[ptr + 28 >> 2] = y;
    HEAPF32[ptr + 32 >> 2] = dx;
    HEAPF32[ptr + 36 >> 2] = dy;
    if (touch.force !== undefined) {
     HEAPF32[ptr + 40 >> 2] = touch.force;
    } else {
     HEAPF32[ptr + 40 >> 2] = event.type == "touchend" ? 0 : 1;
    }
    break;
   }
  case "unload":
   {
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    break;
   }
  case "resize":
   {
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP32[ptr + 4 >> 2] = event.w;
    HEAP32[ptr + 8 >> 2] = event.h;
    break;
   }
  case "joystick_button_up":
  case "joystick_button_down":
   {
    var state = event.type === "joystick_button_up" ? 0 : 1;
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP8[ptr + 4 >> 0] = event.index;
    HEAP8[ptr + 5 >> 0] = event.button;
    HEAP8[ptr + 6 >> 0] = state;
    break;
   }
  case "joystick_axis_motion":
   {
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP8[ptr + 4 >> 0] = event.index;
    HEAP8[ptr + 5 >> 0] = event.axis;
    HEAP32[ptr + 8 >> 2] = SDL.joystickAxisValueConversion(event.value);
    break;
   }
  case "focus":
   {
    var SDL_WINDOWEVENT_FOCUS_GAINED = 12;
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP32[ptr + 4 >> 2] = 0;
    HEAP8[ptr + 8 >> 0] = SDL_WINDOWEVENT_FOCUS_GAINED;
    break;
   }
  case "blur":
   {
    var SDL_WINDOWEVENT_FOCUS_LOST = 13;
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP32[ptr + 4 >> 2] = 0;
    HEAP8[ptr + 8 >> 0] = SDL_WINDOWEVENT_FOCUS_LOST;
    break;
   }
  case "visibilitychange":
   {
    var SDL_WINDOWEVENT_SHOWN = 1;
    var SDL_WINDOWEVENT_HIDDEN = 2;
    var visibilityEventID = event.visible ? SDL_WINDOWEVENT_SHOWN : SDL_WINDOWEVENT_HIDDEN;
    HEAP32[ptr >> 2] = SDL.DOMEventToSDLEvent[event.type];
    HEAP32[ptr + 4 >> 2] = 0;
    HEAP8[ptr + 8 >> 0] = visibilityEventID;
    break;
   }
  default:
   throw "Unhandled SDL event: " + event.type;
  }
 }),
 estimateTextWidth: (function(fontData, text) {
  var h = fontData.size;
  var fontString = h + "px " + fontData.name;
  var tempCtx = SDL.ttfContext;
  tempCtx.save();
  tempCtx.font = fontString;
  var ret = tempCtx.measureText(text).width | 0;
  tempCtx.restore();
  return ret;
 }),
 allocateChannels: (function(num) {
  if (SDL.numChannels && SDL.numChannels >= num && num != 0) return;
  SDL.numChannels = num;
  SDL.channels = [];
  for (var i = 0; i < num; i++) {
   SDL.channels[i] = {
    audio: null,
    volume: 1
   };
  }
 }),
 setGetVolume: (function(info, volume) {
  if (!info) return 0;
  var ret = info.volume * 128;
  if (volume != -1) {
   info.volume = Math.min(Math.max(volume, 0), 128) / 128;
   if (info.audio) {
    try {
     info.audio.volume = info.volume;
     if (info.audio.webAudioGainNode) info.audio.webAudioGainNode["gain"]["value"] = info.volume;
    } catch (e) {
     Module.printErr("setGetVolume failed to set audio volume: " + e);
    }
   }
  }
  return ret;
 }),
 setPannerPosition: (function(info, x, y, z) {
  if (!info) return;
  if (info.audio) {
   if (info.audio.webAudioPannerNode) {
    info.audio.webAudioPannerNode["setPosition"](x, y, z);
   }
  }
 }),
 playWebAudio: (function(audio) {
  if (!audio) return;
  if (audio.webAudioNode) return;
  if (!SDL.webAudioAvailable()) return;
  try {
   var webAudio = audio.resource.webAudio;
   audio.paused = false;
   if (!webAudio.decodedBuffer) {
    if (webAudio.onDecodeComplete === undefined) abort("Cannot play back audio object that was not loaded");
    webAudio.onDecodeComplete.push((function() {
     if (!audio.paused) SDL.playWebAudio(audio);
    }));
    return;
   }
   audio.webAudioNode = SDL.audioContext["createBufferSource"]();
   audio.webAudioNode["buffer"] = webAudio.decodedBuffer;
   audio.webAudioNode["loop"] = audio.loop;
   audio.webAudioNode["onended"] = (function() {
    audio["onended"]();
   });
   audio.webAudioPannerNode = SDL.audioContext["createPanner"]();
   audio.webAudioPannerNode["panningModel"] = "equalpower";
   audio.webAudioGainNode = SDL.audioContext["createGain"]();
   audio.webAudioGainNode["gain"]["value"] = audio.volume;
   audio.webAudioNode["connect"](audio.webAudioPannerNode);
   audio.webAudioPannerNode["connect"](audio.webAudioGainNode);
   audio.webAudioGainNode["connect"](SDL.audioContext["destination"]);
   audio.webAudioNode["start"](0, audio.currentPosition);
   audio.startTime = SDL.audioContext["currentTime"] - audio.currentPosition;
  } catch (e) {
   Module.printErr("playWebAudio failed: " + e);
  }
 }),
 pauseWebAudio: (function(audio) {
  if (!audio) return;
  if (audio.webAudioNode) {
   try {
    audio.currentPosition = (SDL.audioContext["currentTime"] - audio.startTime) % audio.resource.webAudio.decodedBuffer.duration;
    audio.webAudioNode["onended"] = undefined;
    audio.webAudioNode.stop();
    audio.webAudioNode = undefined;
   } catch (e) {
    Module.printErr("pauseWebAudio failed: " + e);
   }
  }
  audio.paused = true;
 }),
 openAudioContext: (function() {
  if (!SDL.audioContext) {
   if (typeof AudioContext !== "undefined") SDL.audioContext = new AudioContext; else if (typeof webkitAudioContext !== "undefined") SDL.audioContext = new webkitAudioContext;
  }
 }),
 webAudioAvailable: (function() {
  return !!SDL.audioContext;
 }),
 fillWebAudioBufferFromHeap: (function(heapPtr, sizeSamplesPerChannel, dstAudioBuffer) {
  var numChannels = SDL.audio.channels;
  for (var c = 0; c < numChannels; ++c) {
   var channelData = dstAudioBuffer["getChannelData"](c);
   if (channelData.length != sizeSamplesPerChannel) {
    throw "Web Audio output buffer length mismatch! Destination size: " + channelData.length + " samples vs expected " + sizeSamplesPerChannel + " samples!";
   }
   if (SDL.audio.format == 32784) {
    for (var j = 0; j < sizeSamplesPerChannel; ++j) {
     channelData[j] = HEAP16[heapPtr + (j * numChannels + c) * 2 >> 1] / 32768;
    }
   } else if (SDL.audio.format == 8) {
    for (var j = 0; j < sizeSamplesPerChannel; ++j) {
     var v = HEAP8[heapPtr + (j * numChannels + c) >> 0];
     channelData[j] = (v >= 0 ? v - 128 : v + 128) / 128;
    }
   }
  }
 }),
 debugSurface: (function(surfData) {
  console.log("dumping surface " + [ surfData.surf, surfData.source, surfData.width, surfData.height ]);
  var image = surfData.ctx.getImageData(0, 0, surfData.width, surfData.height);
  var data = image.data;
  var num = Math.min(surfData.width, surfData.height);
  for (var i = 0; i < num; i++) {
   console.log("   diagonal " + i + ":" + [ data[i * surfData.width * 4 + i * 4 + 0], data[i * surfData.width * 4 + i * 4 + 1], data[i * surfData.width * 4 + i * 4 + 2], data[i * surfData.width * 4 + i * 4 + 3] ]);
  }
 }),
 joystickEventState: 1,
 lastJoystickState: {},
 joystickNamePool: {},
 recordJoystickState: (function(joystick, state) {
  var buttons = new Array(state.buttons.length);
  for (var i = 0; i < state.buttons.length; i++) {
   buttons[i] = SDL.getJoystickButtonState(state.buttons[i]);
  }
  SDL.lastJoystickState[joystick] = {
   buttons: buttons,
   axes: state.axes.slice(0),
   timestamp: state.timestamp,
   index: state.index,
   id: state.id
  };
 }),
 getJoystickButtonState: (function(button) {
  if (typeof button === "object") {
   return button.pressed;
  } else {
   return button > 0;
  }
 }),
 queryJoysticks: (function() {
  for (var joystick in SDL.lastJoystickState) {
   var state = SDL.getGamepad(joystick - 1);
   var prevState = SDL.lastJoystickState[joystick];
   if (typeof state.timestamp !== "number" || state.timestamp !== prevState.timestamp) {
    var i;
    for (i = 0; i < state.buttons.length; i++) {
     var buttonState = SDL.getJoystickButtonState(state.buttons[i]);
     if (buttonState !== prevState.buttons[i]) {
      SDL.events.push({
       type: buttonState ? "joystick_button_down" : "joystick_button_up",
       joystick: joystick,
       index: joystick - 1,
       button: i
      });
     }
    }
    for (i = 0; i < state.axes.length; i++) {
     if (state.axes[i] !== prevState.axes[i]) {
      SDL.events.push({
       type: "joystick_axis_motion",
       joystick: joystick,
       index: joystick - 1,
       axis: i,
       value: state.axes[i]
      });
     }
    }
    SDL.recordJoystickState(joystick, state);
   }
  }
 }),
 joystickAxisValueConversion: (function(value) {
  return Math.ceil((value + 1) * 32767.5 - 32768);
 }),
 getGamepads: (function() {
  var fcn = navigator.getGamepads || navigator.webkitGamepads || navigator.mozGamepads || navigator.gamepads || navigator.webkitGetGamepads;
  if (fcn !== undefined) {
   return fcn.apply(navigator);
  } else {
   return [];
  }
 }),
 getGamepad: (function(deviceIndex) {
  var gamepads = SDL.getGamepads();
  if (gamepads.length > deviceIndex && deviceIndex >= 0) {
   return gamepads[deviceIndex];
  }
  return null;
 })
};
function _SDL_StartTextInput() {
 SDL.textInput = true;
}
function _glDeleteFramebuffers(n, framebuffers) {
 for (var i = 0; i < n; ++i) {
  var id = HEAP32[framebuffers + i * 4 >> 2];
  var framebuffer = GL.framebuffers[id];
  if (!framebuffer) continue;
  GLctx.deleteFramebuffer(framebuffer);
  framebuffer.name = 0;
  GL.framebuffers[id] = null;
 }
}
function _glDrawArrays(mode, first, count) {
 GLctx.drawArrays(mode, first, count);
}
var ___DEFAULT_POLLMASK = 5;
function _select(nfds, readfds, writefds, exceptfds, timeout) {
 assert(nfds <= 64, "nfds must be less than or equal to 64");
 assert(!exceptfds, "exceptfds not supported");
 var total = 0;
 var srcReadLow = readfds ? HEAP32[readfds >> 2] : 0, srcReadHigh = readfds ? HEAP32[readfds + 4 >> 2] : 0;
 var srcWriteLow = writefds ? HEAP32[writefds >> 2] : 0, srcWriteHigh = writefds ? HEAP32[writefds + 4 >> 2] : 0;
 var srcExceptLow = exceptfds ? HEAP32[exceptfds >> 2] : 0, srcExceptHigh = exceptfds ? HEAP32[exceptfds + 4 >> 2] : 0;
 var dstReadLow = 0, dstReadHigh = 0;
 var dstWriteLow = 0, dstWriteHigh = 0;
 var dstExceptLow = 0, dstExceptHigh = 0;
 var allLow = (readfds ? HEAP32[readfds >> 2] : 0) | (writefds ? HEAP32[writefds >> 2] : 0) | (exceptfds ? HEAP32[exceptfds >> 2] : 0);
 var allHigh = (readfds ? HEAP32[readfds + 4 >> 2] : 0) | (writefds ? HEAP32[writefds + 4 >> 2] : 0) | (exceptfds ? HEAP32[exceptfds + 4 >> 2] : 0);
 function get(fd, low, high, val) {
  return fd < 32 ? low & val : high & val;
 }
 for (var fd = 0; fd < nfds; fd++) {
  var mask = 1 << fd % 32;
  if (!get(fd, allLow, allHigh, mask)) {
   continue;
  }
  var stream = FS.getStream(fd);
  if (!stream) {
   ___setErrNo(ERRNO_CODES.EBADF);
   return -1;
  }
  var flags = ___DEFAULT_POLLMASK;
  if (stream.stream_ops.poll) {
   flags = stream.stream_ops.poll(stream);
  }
  if (flags & 1 && get(fd, srcReadLow, srcReadHigh, mask)) {
   fd < 32 ? dstReadLow = dstReadLow | mask : dstReadHigh = dstReadHigh | mask;
   total++;
  }
  if (flags & 4 && get(fd, srcWriteLow, srcWriteHigh, mask)) {
   fd < 32 ? dstWriteLow = dstWriteLow | mask : dstWriteHigh = dstWriteHigh | mask;
   total++;
  }
  if (flags & 2 && get(fd, srcExceptLow, srcExceptHigh, mask)) {
   fd < 32 ? dstExceptLow = dstExceptLow | mask : dstExceptHigh = dstExceptHigh | mask;
   total++;
  }
 }
 if (readfds) {
  HEAP32[readfds >> 2] = dstReadLow;
  HEAP32[readfds + 4 >> 2] = dstReadHigh;
 }
 if (writefds) {
  HEAP32[writefds >> 2] = dstWriteLow;
  HEAP32[writefds + 4 >> 2] = dstWriteHigh;
 }
 if (exceptfds) {
  HEAP32[exceptfds >> 2] = dstExceptLow;
  HEAP32[exceptfds + 4 >> 2] = dstExceptHigh;
 }
 return total;
}
function _mkport() {
 throw "TODO";
}
var SOCKFS = {
 mount: (function(mount) {
  Module["websocket"] = Module["websocket"] && "object" === typeof Module["websocket"] ? Module["websocket"] : {};
  Module["websocket"]._callbacks = {};
  Module["websocket"]["on"] = (function(event, callback) {
   if ("function" === typeof callback) {
    this._callbacks[event] = callback;
   }
   return this;
  });
  Module["websocket"].emit = (function(event, param) {
   if ("function" === typeof this._callbacks[event]) {
    this._callbacks[event].call(this, param);
   }
  });
  return FS.createNode(null, "/", 16384 | 511, 0);
 }),
 createSocket: (function(family, type, protocol) {
  var streaming = type == 1;
  if (protocol) {
   assert(streaming == (protocol == 6));
  }
  var sock = {
   family: family,
   type: type,
   protocol: protocol,
   server: null,
   error: null,
   peers: {},
   pending: [],
   recv_queue: [],
   sock_ops: SOCKFS.websocket_sock_ops
  };
  var name = SOCKFS.nextname();
  var node = FS.createNode(SOCKFS.root, name, 49152, 0);
  node.sock = sock;
  var stream = FS.createStream({
   path: name,
   node: node,
   flags: FS.modeStringToFlags("r+"),
   seekable: false,
   stream_ops: SOCKFS.stream_ops
  });
  sock.stream = stream;
  return sock;
 }),
 getSocket: (function(fd) {
  var stream = FS.getStream(fd);
  if (!stream || !FS.isSocket(stream.node.mode)) {
   return null;
  }
  return stream.node.sock;
 }),
 stream_ops: {
  poll: (function(stream) {
   var sock = stream.node.sock;
   return sock.sock_ops.poll(sock);
  }),
  ioctl: (function(stream, request, varargs) {
   var sock = stream.node.sock;
   return sock.sock_ops.ioctl(sock, request, varargs);
  }),
  read: (function(stream, buffer, offset, length, position) {
   var sock = stream.node.sock;
   var msg = sock.sock_ops.recvmsg(sock, length);
   if (!msg) {
    return 0;
   }
   buffer.set(msg.buffer, offset);
   return msg.buffer.length;
  }),
  write: (function(stream, buffer, offset, length, position) {
   var sock = stream.node.sock;
   return sock.sock_ops.sendmsg(sock, buffer, offset, length);
  }),
  close: (function(stream) {
   var sock = stream.node.sock;
   sock.sock_ops.close(sock);
  })
 },
 nextname: (function() {
  if (!SOCKFS.nextname.current) {
   SOCKFS.nextname.current = 0;
  }
  return "socket[" + SOCKFS.nextname.current++ + "]";
 }),
 websocket_sock_ops: {
  createPeer: (function(sock, addr, port) {
   var ws;
   if (typeof addr === "object") {
    ws = addr;
    addr = null;
    port = null;
   }
   if (ws) {
    if (ws._socket) {
     addr = ws._socket.remoteAddress;
     port = ws._socket.remotePort;
    } else {
     var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
     if (!result) {
      throw new Error("WebSocket URL must be in the format ws(s)://address:port");
     }
     addr = result[1];
     port = parseInt(result[2], 10);
    }
   } else {
    try {
     var runtimeConfig = Module["websocket"] && "object" === typeof Module["websocket"];
     var url = "ws:#".replace("#", "//");
     if (runtimeConfig) {
      if ("string" === typeof Module["websocket"]["url"]) {
       url = Module["websocket"]["url"];
      }
     }
     if (url === "ws://" || url === "wss://") {
      var parts = addr.split("/");
      url = url + parts[0] + ":" + port + "/" + parts.slice(1).join("/");
     }
     var subProtocols = "binary";
     if (runtimeConfig) {
      if ("string" === typeof Module["websocket"]["subprotocol"]) {
       subProtocols = Module["websocket"]["subprotocol"];
      }
     }
     subProtocols = subProtocols.replace(/^ +| +$/g, "").split(/ *, */);
     var opts = ENVIRONMENT_IS_NODE ? {
      "protocol": subProtocols.toString()
     } : subProtocols;
     var WebSocket = ENVIRONMENT_IS_NODE ? require("ws") : window["WebSocket"];
     ws = new WebSocket(url, opts);
     ws.binaryType = "arraybuffer";
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
    }
   }
   var peer = {
    addr: addr,
    port: port,
    socket: ws,
    dgram_send_queue: []
   };
   SOCKFS.websocket_sock_ops.addPeer(sock, peer);
   SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
   if (sock.type === 2 && typeof sock.sport !== "undefined") {
    peer.dgram_send_queue.push(new Uint8Array([ 255, 255, 255, 255, "p".charCodeAt(0), "o".charCodeAt(0), "r".charCodeAt(0), "t".charCodeAt(0), (sock.sport & 65280) >> 8, sock.sport & 255 ]));
   }
   return peer;
  }),
  getPeer: (function(sock, addr, port) {
   return sock.peers[addr + ":" + port];
  }),
  addPeer: (function(sock, peer) {
   sock.peers[peer.addr + ":" + peer.port] = peer;
  }),
  removePeer: (function(sock, peer) {
   delete sock.peers[peer.addr + ":" + peer.port];
  }),
  handlePeerEvents: (function(sock, peer) {
   var first = true;
   var handleOpen = (function() {
    Module["websocket"].emit("open", sock.stream.fd);
    try {
     var queued = peer.dgram_send_queue.shift();
     while (queued) {
      peer.socket.send(queued);
      queued = peer.dgram_send_queue.shift();
     }
    } catch (e) {
     peer.socket.close();
    }
   });
   function handleMessage(data) {
    assert(typeof data !== "string" && data.byteLength !== undefined);
    data = new Uint8Array(data);
    var wasfirst = first;
    first = false;
    if (wasfirst && data.length === 10 && data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 && data[4] === "p".charCodeAt(0) && data[5] === "o".charCodeAt(0) && data[6] === "r".charCodeAt(0) && data[7] === "t".charCodeAt(0)) {
     var newport = data[8] << 8 | data[9];
     SOCKFS.websocket_sock_ops.removePeer(sock, peer);
     peer.port = newport;
     SOCKFS.websocket_sock_ops.addPeer(sock, peer);
     return;
    }
    sock.recv_queue.push({
     addr: peer.addr,
     port: peer.port,
     data: data
    });
    Module["websocket"].emit("message", sock.stream.fd);
   }
   if (ENVIRONMENT_IS_NODE) {
    peer.socket.on("open", handleOpen);
    peer.socket.on("message", (function(data, flags) {
     if (!flags.binary) {
      return;
     }
     handleMessage((new Uint8Array(data)).buffer);
    }));
    peer.socket.on("close", (function() {
     Module["websocket"].emit("close", sock.stream.fd);
    }));
    peer.socket.on("error", (function(error) {
     sock.error = ERRNO_CODES.ECONNREFUSED;
     Module["websocket"].emit("error", [ sock.stream.fd, sock.error, "ECONNREFUSED: Connection refused" ]);
    }));
   } else {
    peer.socket.onopen = handleOpen;
    peer.socket.onclose = (function() {
     Module["websocket"].emit("close", sock.stream.fd);
    });
    peer.socket.onmessage = function peer_socket_onmessage(event) {
     handleMessage(event.data);
    };
    peer.socket.onerror = (function(error) {
     sock.error = ERRNO_CODES.ECONNREFUSED;
     Module["websocket"].emit("error", [ sock.stream.fd, sock.error, "ECONNREFUSED: Connection refused" ]);
    });
   }
  }),
  poll: (function(sock) {
   if (sock.type === 1 && sock.server) {
    return sock.pending.length ? 64 | 1 : 0;
   }
   var mask = 0;
   var dest = sock.type === 1 ? SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) : null;
   if (sock.recv_queue.length || !dest || dest && dest.socket.readyState === dest.socket.CLOSING || dest && dest.socket.readyState === dest.socket.CLOSED) {
    mask |= 64 | 1;
   }
   if (!dest || dest && dest.socket.readyState === dest.socket.OPEN) {
    mask |= 4;
   }
   if (dest && dest.socket.readyState === dest.socket.CLOSING || dest && dest.socket.readyState === dest.socket.CLOSED) {
    mask |= 16;
   }
   return mask;
  }),
  ioctl: (function(sock, request, arg) {
   switch (request) {
   case 21531:
    var bytes = 0;
    if (sock.recv_queue.length) {
     bytes = sock.recv_queue[0].data.length;
    }
    HEAP32[arg >> 2] = bytes;
    return 0;
   default:
    return ERRNO_CODES.EINVAL;
   }
  }),
  close: (function(sock) {
   if (sock.server) {
    try {
     sock.server.close();
    } catch (e) {}
    sock.server = null;
   }
   var peers = Object.keys(sock.peers);
   for (var i = 0; i < peers.length; i++) {
    var peer = sock.peers[peers[i]];
    try {
     peer.socket.close();
    } catch (e) {}
    SOCKFS.websocket_sock_ops.removePeer(sock, peer);
   }
   return 0;
  }),
  bind: (function(sock, addr, port) {
   if (typeof sock.saddr !== "undefined" || typeof sock.sport !== "undefined") {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   sock.saddr = addr;
   sock.sport = port || _mkport();
   if (sock.type === 2) {
    if (sock.server) {
     sock.server.close();
     sock.server = null;
    }
    try {
     sock.sock_ops.listen(sock, 0);
    } catch (e) {
     if (!(e instanceof FS.ErrnoError)) throw e;
     if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
    }
   }
  }),
  connect: (function(sock, addr, port) {
   if (sock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
   }
   if (typeof sock.daddr !== "undefined" && typeof sock.dport !== "undefined") {
    var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
    if (dest) {
     if (dest.socket.readyState === dest.socket.CONNECTING) {
      throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
     } else {
      throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
     }
    }
   }
   var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
   sock.daddr = peer.addr;
   sock.dport = peer.port;
   throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
  }),
  listen: (function(sock, backlog) {
   if (!ENVIRONMENT_IS_NODE) {
    throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
   }
   if (sock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   var WebSocketServer = require("ws").Server;
   var host = sock.saddr;
   sock.server = new WebSocketServer({
    host: host,
    port: sock.sport
   });
   Module["websocket"].emit("listen", sock.stream.fd);
   sock.server.on("connection", (function(ws) {
    if (sock.type === 1) {
     var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
     var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
     newsock.daddr = peer.addr;
     newsock.dport = peer.port;
     sock.pending.push(newsock);
     Module["websocket"].emit("connection", newsock.stream.fd);
    } else {
     SOCKFS.websocket_sock_ops.createPeer(sock, ws);
     Module["websocket"].emit("connection", sock.stream.fd);
    }
   }));
   sock.server.on("closed", (function() {
    Module["websocket"].emit("close", sock.stream.fd);
    sock.server = null;
   }));
   sock.server.on("error", (function(error) {
    sock.error = ERRNO_CODES.EHOSTUNREACH;
    Module["websocket"].emit("error", [ sock.stream.fd, sock.error, "EHOSTUNREACH: Host is unreachable" ]);
   }));
  }),
  accept: (function(listensock) {
   if (!listensock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   var newsock = listensock.pending.shift();
   newsock.stream.flags = listensock.stream.flags;
   return newsock;
  }),
  getname: (function(sock, peer) {
   var addr, port;
   if (peer) {
    if (sock.daddr === undefined || sock.dport === undefined) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
    }
    addr = sock.daddr;
    port = sock.dport;
   } else {
    addr = sock.saddr || 0;
    port = sock.sport || 0;
   }
   return {
    addr: addr,
    port: port
   };
  }),
  sendmsg: (function(sock, buffer, offset, length, addr, port) {
   if (sock.type === 2) {
    if (addr === undefined || port === undefined) {
     addr = sock.daddr;
     port = sock.dport;
    }
    if (addr === undefined || port === undefined) {
     throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
    }
   } else {
    addr = sock.daddr;
    port = sock.dport;
   }
   var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
   if (sock.type === 1) {
    if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
    } else if (dest.socket.readyState === dest.socket.CONNECTING) {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
   }
   var data;
   if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
    data = buffer.slice(offset, offset + length);
   } else {
    data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
   }
   if (sock.type === 2) {
    if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
     if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
      dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
     }
     dest.dgram_send_queue.push(data);
     return length;
    }
   }
   try {
    dest.socket.send(data);
    return length;
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
  }),
  recvmsg: (function(sock, length) {
   if (sock.type === 1 && sock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
   }
   var queued = sock.recv_queue.shift();
   if (!queued) {
    if (sock.type === 1) {
     var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
     if (!dest) {
      throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
     } else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
      return null;
     } else {
      throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
     }
    } else {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
   }
   var queuedLength = queued.data.byteLength || queued.data.length;
   var queuedOffset = queued.data.byteOffset || 0;
   var queuedBuffer = queued.data.buffer || queued.data;
   var bytesRead = Math.min(length, queuedLength);
   var res = {
    buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
    addr: queued.addr,
    port: queued.port
   };
   if (sock.type === 1 && bytesRead < queuedLength) {
    var bytesRemaining = queuedLength - bytesRead;
    queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
    sock.recv_queue.unshift(queued);
   }
   return res;
  })
 }
};
function _send(fd, buf, len, flags) {
 var sock = SOCKFS.getSocket(fd);
 if (!sock) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 return _write(fd, buf, len);
}
function _pwrite(fildes, buf, nbyte, offset) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.write(stream, slab, buf, nbyte, offset);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _write(fildes, buf, nbyte) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.write(stream, slab, buf, nbyte);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fputc(c, stream) {
 var chr = unSign(c & 255);
 HEAP8[_fputc.ret >> 0] = chr;
 var fd = _fileno(stream);
 var ret = _write(fd, _fputc.ret, 1);
 if (ret == -1) {
  var streamObj = FS.getStreamFromPtr(stream);
  if (streamObj) streamObj.error = true;
  return -1;
 } else {
  return chr;
 }
}
function _putchar(c) {
 return _fputc(c, HEAP32[_stdout >> 2]);
}
Module["_saveSetjmp"] = _saveSetjmp;
function _glCopyTexSubImage2D(x0, x1, x2, x3, x4, x5, x6, x7) {
 GLctx.copyTexSubImage2D(x0, x1, x2, x3, x4, x5, x6, x7);
}
function _emscripten_set_blur_callback(target, userData, useCapture, callbackfunc) {
 JSEvents.registerFocusEventCallback(target, userData, useCapture, callbackfunc, 12, "blur");
 return 0;
}
function _emscripten_glReleaseShaderCompiler() {}
function _glClear(x0) {
 GLctx.clear(x0);
}
function _glUniform2iv(location, count, value) {
 location = GL.uniforms[location];
 count *= 2;
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform2iv(location, value);
}
function _glStencilOp(x0, x1, x2) {
 GLctx.stencilOp(x0, x1, x2);
}
function _SDL_GetError() {
 if (!SDL.errorMessage) {
  SDL.errorMessage = allocate(intArrayFromString("unknown SDL-emscripten error"), "i8", ALLOC_NORMAL);
 }
 return SDL.errorMessage;
}
function _glFramebufferTexture2D(target, attachment, textarget, texture, level) {
 GLctx.framebufferTexture2D(target, attachment, textarget, GL.textures[texture], level);
}
function _glGetFramebufferAttachmentParameteriv(target, attachment, pname, params) {
 var result = GLctx.getFramebufferAttachmentParameter(target, attachment, pname);
 HEAP32[params >> 2] = result;
}
function _emscripten_request_pointerlock(target, deferUntilInEventHandler) {
 if (!target) target = "#canvas";
 target = JSEvents.findEventTarget(target);
 if (!target) return -4;
 if (!target.requestPointerLock && !target.mozRequestPointerLock && !target.webkitRequestPointerLock && !target.msRequestPointerLock) {
  return -1;
 }
 var canPerformRequests = JSEvents.canPerformEventHandlerRequests();
 if (!canPerformRequests) {
  if (deferUntilInEventHandler) {
   JSEvents.deferCall(JSEvents.requestPointerLock, 2, [ target ]);
   return 1;
  } else {
   return -2;
  }
 }
 return JSEvents.requestPointerLock(target);
}
function _isatty(fildes) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return 0;
 }
 if (!stream.tty) {
  ___setErrNo(ERRNO_CODES.ENOTTY);
  return 0;
 }
 return 1;
}
function _glBindBufferBase(target, index, buffer) {
 var bufferObj = buffer ? GL.buffers[buffer] : null;
 GLctx.bindBufferBase(target, index, bufferObj);
}
function _pthread_cond_broadcast() {
 return 0;
}
function _gettimeofday(ptr) {
 var now = Date.now();
 HEAP32[ptr >> 2] = now / 1e3 | 0;
 HEAP32[ptr + 4 >> 2] = now % 1e3 * 1e3 | 0;
 return 0;
}
function _JS_Sound_SetVolume(channelInstance, v) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioInstances[channelInstance].gain.gain.value = v;
}
function _chdir(path) {
 if (typeof path !== "string") path = Pointer_stringify(path);
 try {
  FS.chdir(path);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _glGenFramebuffers(n, ids) {
 for (var i = 0; i < n; ++i) {
  var id = GL.getNewId(GL.framebuffers);
  var framebuffer = GLctx.createFramebuffer();
  framebuffer.name = id;
  GL.framebuffers[id] = framebuffer;
  HEAP32[ids + i * 4 >> 2] = id;
 }
}
function __isLeapYear(year) {
 return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
}
function __arraySum(array, index) {
 var sum = 0;
 for (var i = 0; i <= index; sum += array[i++]) ;
 return sum;
}
var __MONTH_DAYS_LEAP = [ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
var __MONTH_DAYS_REGULAR = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
function __addDays(date, days) {
 var newDate = new Date(date.getTime());
 while (days > 0) {
  var leap = __isLeapYear(newDate.getFullYear());
  var currentMonth = newDate.getMonth();
  var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  if (days > daysInCurrentMonth - newDate.getDate()) {
   days -= daysInCurrentMonth - newDate.getDate() + 1;
   newDate.setDate(1);
   if (currentMonth < 11) {
    newDate.setMonth(currentMonth + 1);
   } else {
    newDate.setMonth(0);
    newDate.setFullYear(newDate.getFullYear() + 1);
   }
  } else {
   newDate.setDate(newDate.getDate() + days);
   return newDate;
  }
 }
 return newDate;
}
function _strftime(s, maxsize, format, tm) {
 var tm_zone = HEAP32[tm + 40 >> 2];
 var date = {
  tm_sec: HEAP32[tm >> 2],
  tm_min: HEAP32[tm + 4 >> 2],
  tm_hour: HEAP32[tm + 8 >> 2],
  tm_mday: HEAP32[tm + 12 >> 2],
  tm_mon: HEAP32[tm + 16 >> 2],
  tm_year: HEAP32[tm + 20 >> 2],
  tm_wday: HEAP32[tm + 24 >> 2],
  tm_yday: HEAP32[tm + 28 >> 2],
  tm_isdst: HEAP32[tm + 32 >> 2],
  tm_gmtoff: HEAP32[tm + 36 >> 2],
  tm_zone: tm_zone ? Pointer_stringify(tm_zone) : ""
 };
 var pattern = Pointer_stringify(format);
 var EXPANSION_RULES_1 = {
  "%c": "%a %b %d %H:%M:%S %Y",
  "%D": "%m/%d/%y",
  "%F": "%Y-%m-%d",
  "%h": "%b",
  "%r": "%I:%M:%S %p",
  "%R": "%H:%M",
  "%T": "%H:%M:%S",
  "%x": "%m/%d/%y",
  "%X": "%H:%M:%S"
 };
 for (var rule in EXPANSION_RULES_1) {
  pattern = pattern.replace(new RegExp(rule, "g"), EXPANSION_RULES_1[rule]);
 }
 var WEEKDAYS = [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ];
 var MONTHS = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
 function leadingSomething(value, digits, character) {
  var str = typeof value === "number" ? value.toString() : value || "";
  while (str.length < digits) {
   str = character[0] + str;
  }
  return str;
 }
 function leadingNulls(value, digits) {
  return leadingSomething(value, digits, "0");
 }
 function compareByDay(date1, date2) {
  function sgn(value) {
   return value < 0 ? -1 : value > 0 ? 1 : 0;
  }
  var compare;
  if ((compare = sgn(date1.getFullYear() - date2.getFullYear())) === 0) {
   if ((compare = sgn(date1.getMonth() - date2.getMonth())) === 0) {
    compare = sgn(date1.getDate() - date2.getDate());
   }
  }
  return compare;
 }
 function getFirstWeekStartDate(janFourth) {
  switch (janFourth.getDay()) {
  case 0:
   return new Date(janFourth.getFullYear() - 1, 11, 29);
  case 1:
   return janFourth;
  case 2:
   return new Date(janFourth.getFullYear(), 0, 3);
  case 3:
   return new Date(janFourth.getFullYear(), 0, 2);
  case 4:
   return new Date(janFourth.getFullYear(), 0, 1);
  case 5:
   return new Date(janFourth.getFullYear() - 1, 11, 31);
  case 6:
   return new Date(janFourth.getFullYear() - 1, 11, 30);
  }
 }
 function getWeekBasedYear(date) {
  var thisDate = __addDays(new Date(date.tm_year + 1900, 0, 1), date.tm_yday);
  var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
  var janFourthNextYear = new Date(thisDate.getFullYear() + 1, 0, 4);
  var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
  var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
   if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
    return thisDate.getFullYear() + 1;
   } else {
    return thisDate.getFullYear();
   }
  } else {
   return thisDate.getFullYear() - 1;
  }
 }
 var EXPANSION_RULES_2 = {
  "%a": (function(date) {
   return WEEKDAYS[date.tm_wday].substring(0, 3);
  }),
  "%A": (function(date) {
   return WEEKDAYS[date.tm_wday];
  }),
  "%b": (function(date) {
   return MONTHS[date.tm_mon].substring(0, 3);
  }),
  "%B": (function(date) {
   return MONTHS[date.tm_mon];
  }),
  "%C": (function(date) {
   var year = date.tm_year + 1900;
   return leadingNulls(year / 100 | 0, 2);
  }),
  "%d": (function(date) {
   return leadingNulls(date.tm_mday, 2);
  }),
  "%e": (function(date) {
   return leadingSomething(date.tm_mday, 2, " ");
  }),
  "%g": (function(date) {
   return getWeekBasedYear(date).toString().substring(2);
  }),
  "%G": (function(date) {
   return getWeekBasedYear(date);
  }),
  "%H": (function(date) {
   return leadingNulls(date.tm_hour, 2);
  }),
  "%I": (function(date) {
   return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour - 12, 2);
  }),
  "%j": (function(date) {
   return leadingNulls(date.tm_mday + __arraySum(__isLeapYear(date.tm_year + 1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon - 1), 3);
  }),
  "%m": (function(date) {
   return leadingNulls(date.tm_mon + 1, 2);
  }),
  "%M": (function(date) {
   return leadingNulls(date.tm_min, 2);
  }),
  "%n": (function() {
   return "\n";
  }),
  "%p": (function(date) {
   if (date.tm_hour > 0 && date.tm_hour < 13) {
    return "AM";
   } else {
    return "PM";
   }
  }),
  "%S": (function(date) {
   return leadingNulls(date.tm_sec, 2);
  }),
  "%t": (function() {
   return "\t";
  }),
  "%u": (function(date) {
   var day = new Date(date.tm_year + 1900, date.tm_mon + 1, date.tm_mday, 0, 0, 0, 0);
   return day.getDay() || 7;
  }),
  "%U": (function(date) {
   var janFirst = new Date(date.tm_year + 1900, 0, 1);
   var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7 - janFirst.getDay());
   var endDate = new Date(date.tm_year + 1900, date.tm_mon, date.tm_mday);
   if (compareByDay(firstSunday, endDate) < 0) {
    var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth() - 1) - 31;
    var firstSundayUntilEndJanuary = 31 - firstSunday.getDate();
    var days = firstSundayUntilEndJanuary + februaryFirstUntilEndMonth + endDate.getDate();
    return leadingNulls(Math.ceil(days / 7), 2);
   }
   return compareByDay(firstSunday, janFirst) === 0 ? "01" : "00";
  }),
  "%V": (function(date) {
   var janFourthThisYear = new Date(date.tm_year + 1900, 0, 4);
   var janFourthNextYear = new Date(date.tm_year + 1901, 0, 4);
   var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
   var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
   var endDate = __addDays(new Date(date.tm_year + 1900, 0, 1), date.tm_yday);
   if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
    return "53";
   }
   if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
    return "01";
   }
   var daysDifference;
   if (firstWeekStartThisYear.getFullYear() < date.tm_year + 1900) {
    daysDifference = date.tm_yday + 32 - firstWeekStartThisYear.getDate();
   } else {
    daysDifference = date.tm_yday + 1 - firstWeekStartThisYear.getDate();
   }
   return leadingNulls(Math.ceil(daysDifference / 7), 2);
  }),
  "%w": (function(date) {
   var day = new Date(date.tm_year + 1900, date.tm_mon + 1, date.tm_mday, 0, 0, 0, 0);
   return day.getDay();
  }),
  "%W": (function(date) {
   var janFirst = new Date(date.tm_year, 0, 1);
   var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7 - janFirst.getDay() + 1);
   var endDate = new Date(date.tm_year + 1900, date.tm_mon, date.tm_mday);
   if (compareByDay(firstMonday, endDate) < 0) {
    var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth() - 1) - 31;
    var firstMondayUntilEndJanuary = 31 - firstMonday.getDate();
    var days = firstMondayUntilEndJanuary + februaryFirstUntilEndMonth + endDate.getDate();
    return leadingNulls(Math.ceil(days / 7), 2);
   }
   return compareByDay(firstMonday, janFirst) === 0 ? "01" : "00";
  }),
  "%y": (function(date) {
   return (date.tm_year + 1900).toString().substring(2);
  }),
  "%Y": (function(date) {
   return date.tm_year + 1900;
  }),
  "%z": (function(date) {
   var off = date.tm_gmtoff;
   var ahead = off >= 0;
   off = Math.abs(off) / 60;
   off = off / 60 * 100 + off % 60;
   return (ahead ? "+" : "-") + String("0000" + off).slice(-4);
  }),
  "%Z": (function(date) {
   return date.tm_zone;
  }),
  "%%": (function() {
   return "%";
  })
 };
 for (var rule in EXPANSION_RULES_2) {
  if (pattern.indexOf(rule) >= 0) {
   pattern = pattern.replace(new RegExp(rule, "g"), EXPANSION_RULES_2[rule](date));
  }
 }
 var bytes = intArrayFromString(pattern, false);
 if (bytes.length > maxsize) {
  return 0;
 }
 writeArrayToMemory(bytes, s);
 return bytes.length - 1;
}
function _strftime_l(s, maxsize, format, tm) {
 return _strftime(s, maxsize, format, tm);
}
var _ceil = Math_ceil;
function _JS_Sound_SetPaused(channelInstance, paused) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioInstances[channelInstance].source.playbackRate.value = paused ? 1e-7 : 1;
}
function _strerror_r(errnum, strerrbuf, buflen) {
 if (errnum in ERRNO_MESSAGES) {
  if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
   return ___setErrNo(ERRNO_CODES.ERANGE);
  } else {
   var msg = ERRNO_MESSAGES[errnum];
   writeAsciiToMemory(msg, strerrbuf);
   return 0;
  }
 } else {
  return ___setErrNo(ERRNO_CODES.EINVAL);
 }
}
function _strerror(errnum) {
 if (!_strerror.buffer) _strerror.buffer = _malloc(256);
 _strerror_r(errnum, _strerror.buffer, 256);
 return _strerror.buffer;
}
function _emscripten_glGetTexParameteriv(target, pname, params) {
 HEAP32[params >> 2] = GLctx.getTexParameter(target, pname);
}
function _catclose(catd) {
 return 0;
}
function _glDeleteVertexArrays(n, vaos) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[vaos + i * 4 >> 2];
  GL.currentContext.vaoExt.deleteVertexArrayOES(GL.vaos[id]);
  GL.vaos[id] = null;
 }
}
function _truncate(path, length) {
 if (typeof path !== "string") path = Pointer_stringify(path);
 try {
  FS.truncate(path, length);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _ftruncate(fildes, length) {
 try {
  FS.ftruncate(fildes, length);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _emscripten_glSampleCoverage(x0, x1) {
 GLctx.sampleCoverage(x0, x1);
}
function _glDeleteTextures(n, textures) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[textures + i * 4 >> 2];
  var texture = GL.textures[id];
  if (!texture) continue;
  GLctx.deleteTexture(texture);
  texture.name = 0;
  GL.textures[id] = null;
 }
}
function _glDisableVertexAttribArray(index) {
 GLctx.disableVertexAttribArray(index);
}
function _sysconf(name) {
 switch (name) {
 case 30:
  return PAGE_SIZE;
 case 132:
 case 133:
 case 12:
 case 137:
 case 138:
 case 15:
 case 235:
 case 16:
 case 17:
 case 18:
 case 19:
 case 20:
 case 149:
 case 13:
 case 10:
 case 236:
 case 153:
 case 9:
 case 21:
 case 22:
 case 159:
 case 154:
 case 14:
 case 77:
 case 78:
 case 139:
 case 80:
 case 81:
 case 79:
 case 82:
 case 68:
 case 67:
 case 164:
 case 11:
 case 29:
 case 47:
 case 48:
 case 95:
 case 52:
 case 51:
 case 46:
  return 200809;
 case 27:
 case 246:
 case 127:
 case 128:
 case 23:
 case 24:
 case 160:
 case 161:
 case 181:
 case 182:
 case 242:
 case 183:
 case 184:
 case 243:
 case 244:
 case 245:
 case 165:
 case 178:
 case 179:
 case 49:
 case 50:
 case 168:
 case 169:
 case 175:
 case 170:
 case 171:
 case 172:
 case 97:
 case 76:
 case 32:
 case 173:
 case 35:
  return -1;
 case 176:
 case 177:
 case 7:
 case 155:
 case 8:
 case 157:
 case 125:
 case 126:
 case 92:
 case 93:
 case 129:
 case 130:
 case 131:
 case 94:
 case 91:
  return 1;
 case 74:
 case 60:
 case 69:
 case 70:
 case 4:
  return 1024;
 case 31:
 case 42:
 case 72:
  return 32;
 case 87:
 case 26:
 case 33:
  return 2147483647;
 case 34:
 case 1:
  return 47839;
 case 38:
 case 36:
  return 99;
 case 43:
 case 37:
  return 2048;
 case 0:
  return 2097152;
 case 3:
  return 65536;
 case 28:
  return 32768;
 case 44:
  return 32767;
 case 75:
  return 16384;
 case 39:
  return 1e3;
 case 89:
  return 700;
 case 71:
  return 256;
 case 40:
  return 255;
 case 2:
  return 100;
 case 180:
  return 64;
 case 25:
  return 20;
 case 5:
  return 16;
 case 6:
  return 6;
 case 73:
  return 4;
 case 84:
  {
   if (typeof navigator === "object") return navigator["hardwareConcurrency"] || 1;
   return 1;
  }
 }
 ___setErrNo(ERRNO_CODES.EINVAL);
 return -1;
}
var _SItoD = true;
var _SItoF = true;
function _emscripten_glMatrixMode() {
 throw "Legacy GL function (glMatrixMode) called. If you want legacy GL emulation, you need to compile with -s LEGACY_GL_EMULATION=1 to enable legacy GL emulation.";
}
function _abort() {
 Module["abort"]();
}
function _fwrite(ptr, size, nitems, stream) {
 var bytesToWrite = nitems * size;
 if (bytesToWrite == 0) return 0;
 var fd = _fileno(stream);
 var bytesWritten = _write(fd, ptr, bytesToWrite);
 if (bytesWritten == -1) {
  var streamObj = FS.getStreamFromPtr(stream);
  if (streamObj) streamObj.error = true;
  return 0;
 } else {
  return bytesWritten / size | 0;
 }
}
Module["_strlen"] = _strlen;
function __reallyNegative(x) {
 return x < 0 || x === 0 && 1 / x === -Infinity;
}
function __formatString(format, varargs) {
 var textIndex = format;
 var argIndex = 0;
 function getNextArg(type) {
  var ret;
  if (type === "double") {
   ret = (HEAP32[tempDoublePtr >> 2] = HEAP32[varargs + argIndex >> 2], HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[varargs + (argIndex + 4) >> 2], +HEAPF64[tempDoublePtr >> 3]);
  } else if (type == "i64") {
   ret = [ HEAP32[varargs + argIndex >> 2], HEAP32[varargs + (argIndex + 4) >> 2] ];
  } else {
   type = "i32";
   ret = HEAP32[varargs + argIndex >> 2];
  }
  argIndex += Runtime.getNativeFieldSize(type);
  return ret;
 }
 var ret = [];
 var curr, next, currArg;
 while (1) {
  var startTextIndex = textIndex;
  curr = HEAP8[textIndex >> 0];
  if (curr === 0) break;
  next = HEAP8[textIndex + 1 >> 0];
  if (curr == 37) {
   var flagAlwaysSigned = false;
   var flagLeftAlign = false;
   var flagAlternative = false;
   var flagZeroPad = false;
   var flagPadSign = false;
   flagsLoop : while (1) {
    switch (next) {
    case 43:
     flagAlwaysSigned = true;
     break;
    case 45:
     flagLeftAlign = true;
     break;
    case 35:
     flagAlternative = true;
     break;
    case 48:
     if (flagZeroPad) {
      break flagsLoop;
     } else {
      flagZeroPad = true;
      break;
     }
    case 32:
     flagPadSign = true;
     break;
    default:
     break flagsLoop;
    }
    textIndex++;
    next = HEAP8[textIndex + 1 >> 0];
   }
   var width = 0;
   if (next == 42) {
    width = getNextArg("i32");
    textIndex++;
    next = HEAP8[textIndex + 1 >> 0];
   } else {
    while (next >= 48 && next <= 57) {
     width = width * 10 + (next - 48);
     textIndex++;
     next = HEAP8[textIndex + 1 >> 0];
    }
   }
   var precisionSet = false, precision = -1;
   if (next == 46) {
    precision = 0;
    precisionSet = true;
    textIndex++;
    next = HEAP8[textIndex + 1 >> 0];
    if (next == 42) {
     precision = getNextArg("i32");
     textIndex++;
    } else {
     while (1) {
      var precisionChr = HEAP8[textIndex + 1 >> 0];
      if (precisionChr < 48 || precisionChr > 57) break;
      precision = precision * 10 + (precisionChr - 48);
      textIndex++;
     }
    }
    next = HEAP8[textIndex + 1 >> 0];
   }
   if (precision < 0) {
    precision = 6;
    precisionSet = false;
   }
   var argSize;
   switch (String.fromCharCode(next)) {
   case "h":
    var nextNext = HEAP8[textIndex + 2 >> 0];
    if (nextNext == 104) {
     textIndex++;
     argSize = 1;
    } else {
     argSize = 2;
    }
    break;
   case "l":
    var nextNext = HEAP8[textIndex + 2 >> 0];
    if (nextNext == 108) {
     textIndex++;
     argSize = 8;
    } else {
     argSize = 4;
    }
    break;
   case "L":
   case "q":
   case "j":
    argSize = 8;
    break;
   case "z":
   case "t":
   case "I":
    argSize = 4;
    break;
   default:
    argSize = null;
   }
   if (argSize) textIndex++;
   next = HEAP8[textIndex + 1 >> 0];
   switch (String.fromCharCode(next)) {
   case "d":
   case "i":
   case "u":
   case "o":
   case "x":
   case "X":
   case "p":
    {
     var signed = next == 100 || next == 105;
     argSize = argSize || 4;
     var currArg = getNextArg("i" + argSize * 8);
     var origArg = currArg;
     var argText;
     if (argSize == 8) {
      currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
     }
     if (argSize <= 4) {
      var limit = Math.pow(256, argSize) - 1;
      currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
     }
     var currAbsArg = Math.abs(currArg);
     var prefix = "";
     if (next == 100 || next == 105) {
      if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else argText = reSign(currArg, 8 * argSize, 1).toString(10);
     } else if (next == 117) {
      if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else argText = unSign(currArg, 8 * argSize, 1).toString(10);
      currArg = Math.abs(currArg);
     } else if (next == 111) {
      argText = (flagAlternative ? "0" : "") + currAbsArg.toString(8);
     } else if (next == 120 || next == 88) {
      prefix = flagAlternative && currArg != 0 ? "0x" : "";
      if (argSize == 8 && i64Math) {
       if (origArg[1]) {
        argText = (origArg[1] >>> 0).toString(16);
        var lower = (origArg[0] >>> 0).toString(16);
        while (lower.length < 8) lower = "0" + lower;
        argText += lower;
       } else {
        argText = (origArg[0] >>> 0).toString(16);
       }
      } else if (currArg < 0) {
       currArg = -currArg;
       argText = (currAbsArg - 1).toString(16);
       var buffer = [];
       for (var i = 0; i < argText.length; i++) {
        buffer.push((15 - parseInt(argText[i], 16)).toString(16));
       }
       argText = buffer.join("");
       while (argText.length < argSize * 2) argText = "f" + argText;
      } else {
       argText = currAbsArg.toString(16);
      }
      if (next == 88) {
       prefix = prefix.toUpperCase();
       argText = argText.toUpperCase();
      }
     } else if (next == 112) {
      if (currAbsArg === 0) {
       argText = "(nil)";
      } else {
       prefix = "0x";
       argText = currAbsArg.toString(16);
      }
     }
     if (precisionSet) {
      while (argText.length < precision) {
       argText = "0" + argText;
      }
     }
     if (currArg >= 0) {
      if (flagAlwaysSigned) {
       prefix = "+" + prefix;
      } else if (flagPadSign) {
       prefix = " " + prefix;
      }
     }
     if (argText.charAt(0) == "-") {
      prefix = "-" + prefix;
      argText = argText.substr(1);
     }
     while (prefix.length + argText.length < width) {
      if (flagLeftAlign) {
       argText += " ";
      } else {
       if (flagZeroPad) {
        argText = "0" + argText;
       } else {
        prefix = " " + prefix;
       }
      }
     }
     argText = prefix + argText;
     argText.split("").forEach((function(chr) {
      ret.push(chr.charCodeAt(0));
     }));
     break;
    }
   case "f":
   case "F":
   case "e":
   case "E":
   case "g":
   case "G":
    {
     var currArg = getNextArg("double");
     var argText;
     if (isNaN(currArg)) {
      argText = "nan";
      flagZeroPad = false;
     } else if (!isFinite(currArg)) {
      argText = (currArg < 0 ? "-" : "") + "inf";
      flagZeroPad = false;
     } else {
      var isGeneral = false;
      var effectivePrecision = Math.min(precision, 20);
      if (next == 103 || next == 71) {
       isGeneral = true;
       precision = precision || 1;
       var exponent = parseInt(currArg.toExponential(effectivePrecision).split("e")[1], 10);
       if (precision > exponent && exponent >= -4) {
        next = (next == 103 ? "f" : "F").charCodeAt(0);
        precision -= exponent + 1;
       } else {
        next = (next == 103 ? "e" : "E").charCodeAt(0);
        precision--;
       }
       effectivePrecision = Math.min(precision, 20);
      }
      if (next == 101 || next == 69) {
       argText = currArg.toExponential(effectivePrecision);
       if (/[eE][-+]\d$/.test(argText)) {
        argText = argText.slice(0, -1) + "0" + argText.slice(-1);
       }
      } else if (next == 102 || next == 70) {
       argText = currArg.toFixed(effectivePrecision);
       if (currArg === 0 && __reallyNegative(currArg)) {
        argText = "-" + argText;
       }
      }
      var parts = argText.split("e");
      if (isGeneral && !flagAlternative) {
       while (parts[0].length > 1 && parts[0].indexOf(".") != -1 && (parts[0].slice(-1) == "0" || parts[0].slice(-1) == ".")) {
        parts[0] = parts[0].slice(0, -1);
       }
      } else {
       if (flagAlternative && argText.indexOf(".") == -1) parts[0] += ".";
       while (precision > effectivePrecision++) parts[0] += "0";
      }
      argText = parts[0] + (parts.length > 1 ? "e" + parts[1] : "");
      if (next == 69) argText = argText.toUpperCase();
      if (currArg >= 0) {
       if (flagAlwaysSigned) {
        argText = "+" + argText;
       } else if (flagPadSign) {
        argText = " " + argText;
       }
      }
     }
     while (argText.length < width) {
      if (flagLeftAlign) {
       argText += " ";
      } else {
       if (flagZeroPad && (argText[0] == "-" || argText[0] == "+")) {
        argText = argText[0] + "0" + argText.slice(1);
       } else {
        argText = (flagZeroPad ? "0" : " ") + argText;
       }
      }
     }
     if (next < 97) argText = argText.toUpperCase();
     argText.split("").forEach((function(chr) {
      ret.push(chr.charCodeAt(0));
     }));
     break;
    }
   case "s":
    {
     var arg = getNextArg("i8*");
     var argLength = arg ? _strlen(arg) : "(null)".length;
     if (precisionSet) argLength = Math.min(argLength, precision);
     if (!flagLeftAlign) {
      while (argLength < width--) {
       ret.push(32);
      }
     }
     if (arg) {
      for (var i = 0; i < argLength; i++) {
       ret.push(HEAPU8[arg++ >> 0]);
      }
     } else {
      ret = ret.concat(intArrayFromString("(null)".substr(0, argLength), true));
     }
     if (flagLeftAlign) {
      while (argLength < width--) {
       ret.push(32);
      }
     }
     break;
    }
   case "c":
    {
     if (flagLeftAlign) ret.push(getNextArg("i8"));
     while (--width > 0) {
      ret.push(32);
     }
     if (!flagLeftAlign) ret.push(getNextArg("i8"));
     break;
    }
   case "n":
    {
     var ptr = getNextArg("i32*");
     HEAP32[ptr >> 2] = ret.length;
     break;
    }
   case "%":
    {
     ret.push(curr);
     break;
    }
   default:
    {
     for (var i = startTextIndex; i < textIndex + 2; i++) {
      ret.push(HEAP8[i >> 0]);
     }
    }
   }
   textIndex += 2;
  } else {
   ret.push(curr);
   textIndex += 1;
  }
 }
 return ret;
}
function _fprintf(stream, format, varargs) {
 var result = __formatString(format, varargs);
 var stack = Runtime.stackSave();
 var ret = _fwrite(allocate(result, "i8", ALLOC_STACK), 1, result.length, stream);
 Runtime.stackRestore(stack);
 return ret;
}
function _JS_Log_Dump(ptr, type) {
 var str = Pointer_stringify(ptr);
 if (typeof dump == "function") dump(str);
 switch (type) {
 case 0:
 case 1:
 case 4:
  console.error(str);
  return;
 case 2:
  console.warn(str);
  return;
 case 3:
 case 5:
  console.log(str);
  return;
 default:
  console.error("Unknown console message type!");
  console.error(str);
 }
}
var _tan = Math_tan;
function _emscripten_glPolygonOffset(x0, x1) {
 GLctx.polygonOffset(x0, x1);
}
function _emscripten_glIsBuffer(buffer) {
 var b = GL.buffers[buffer];
 if (!b) return 0;
 return GLctx.isBuffer(b);
}
var PTHREAD_SPECIFIC = {};
function _pthread_getspecific(key) {
 return PTHREAD_SPECIFIC[key] || 0;
}
function _glEnable(x0) {
 GLctx.enable(x0);
}
var _atanf = Math_atan;
function _glGetActiveUniformsiv(program, uniformCount, uniformIndices, pname, params) {
 if (uniformCount > 0 && uniformIndices == 0) {
  GL.recordError(1281);
  return;
 }
 program = GL.programs[program];
 var ids = [];
 for (var i = 0; i < uniformCount; i++) {
  ids.push(HEAP32[uniformIndices + i * 4 >> 2]);
 }
 var result = GLctx.getActiveUniforms(program, ids, pname);
 if (!result) return;
 var len = result.length;
 for (var i = 0; i < len; i++) {
  HEAP32[params + i * 4 >> 2] = result[i];
 }
}
function _SDL_NumJoysticks() {
 var count = 0;
 var gamepads = SDL.getGamepads();
 for (var i = 0; i < gamepads.length; i++) {
  if (gamepads[i] !== undefined) count++;
 }
 return count;
}
function _emscripten_glTexSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels) {
 if (pixels) {
  var data = GL.getTexPixelData(type, format, width, height, pixels, -1);
  pixels = data.pixels;
 } else {
  pixels = null;
 }
 GLctx.texSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels);
}
function _emscripten_glUniform2f(location, v0, v1) {
 location = GL.uniforms[location];
 GLctx.uniform2f(location, v0, v1);
}
function _glGetAttribLocation(program, name) {
 program = GL.programs[program];
 name = Pointer_stringify(name);
 return GLctx.getAttribLocation(program, name);
}
var _sin = Math_sin;
function _emscripten_glDeleteRenderbuffers(n, renderbuffers) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[renderbuffers + i * 4 >> 2];
  var renderbuffer = GL.renderbuffers[id];
  if (!renderbuffer) continue;
  GLctx.deleteRenderbuffer(renderbuffer);
  renderbuffer.name = 0;
  GL.renderbuffers[id] = null;
 }
}
function ___cxa_pure_virtual() {
 ABORT = true;
 throw "Pure virtual function called!";
}
var _atan = Math_atan;
function _unsetenv(name) {
 if (name === 0) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 name = Pointer_stringify(name);
 if (name === "" || name.indexOf("=") !== -1) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 if (ENV.hasOwnProperty(name)) {
  delete ENV[name];
  ___buildEnvironment(ENV);
 }
 return 0;
}
function _emscripten_glDepthRange(x0, x1) {
 GLctx.depthRange(x0, x1);
}
function _emscripten_set_fullscreenchange_callback(target, userData, useCapture, callbackfunc) {
 if (typeof JSEvents.fullscreenEnabled() === "undefined") return -1;
 if (!target) target = document; else {
  target = JSEvents.findEventTarget(target);
  if (!target) return -4;
 }
 JSEvents.registerFullscreenChangeEventCallback(target, userData, useCapture, callbackfunc, 19, "fullscreenchange");
 JSEvents.registerFullscreenChangeEventCallback(target, userData, useCapture, callbackfunc, 19, "mozfullscreenchange");
 JSEvents.registerFullscreenChangeEventCallback(target, userData, useCapture, callbackfunc, 19, "webkitfullscreenchange");
 JSEvents.registerFullscreenChangeEventCallback(target, userData, useCapture, callbackfunc, 19, "msfullscreenchange");
 return 0;
}
function _ioctl(fd, request, varargs) {
 var stream = FS.getStream(fd);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 var arg = HEAP32[varargs >> 2];
 try {
  return FS.ioctl(stream, request, arg);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _glPolygonOffset(x0, x1) {
 GLctx.polygonOffset(x0, x1);
}
function _clearerr(stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) {
  return;
 }
 stream.eof = false;
 stream.error = false;
}
function _unlink(path) {
 path = Pointer_stringify(path);
 try {
  FS.unlink(path);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _emscripten_glGetShaderPrecisionFormat(shaderType, precisionType, range, precision) {
 var result = GLctx.getShaderPrecisionFormat(shaderType, precisionType);
 HEAP32[range >> 2] = result.rangeMin;
 HEAP32[range + 4 >> 2] = result.rangeMax;
 HEAP32[precision >> 2] = result.precision;
}
var _atan2 = Math_atan2;
function _emscripten_glBindProgramARB() {
 Module["printErr"]("missing function: emscripten_glBindProgramARB");
 abort(-1);
}
function _glGetUniformBlockIndex(program, uniformBlockName) {
 program = GL.programs[program];
 uniformBlockName = Pointer_stringify(uniformBlockName);
 return GLctx.getUniformBlockIndex(program, uniformBlockName);
}
function _emscripten_glVertexAttrib3fv(index, v) {
 v = HEAPF32.subarray(v >> 2, v + 12 >> 2);
 GLctx.vertexAttrib3fv(index, v);
}
function _glFlush() {
 GLctx.flush();
}
function _emscripten_glIsFramebuffer(framebuffer) {
 var fb = GL.framebuffers[framebuffer];
 if (!fb) return 0;
 return GLctx.isFramebuffer(fb);
}
function _JS_Sound_SetVelocity(channelInstance, x, y, z) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioInstances[channelInstance].panner.setVelocity(x, y, z);
}
function _glGetVertexAttribPointerv(index, pname, pointer) {
 HEAP32[pointer >> 2] = GLctx.getVertexAttribOffset(index, pname);
}
function _uname(name) {
 var layout = {
  "sysname": 0,
  "nodename": 65,
  "domainname": 325,
  "machine": 260,
  "version": 195,
  "release": 130,
  "__size__": 390
 };
 function copyString(element, value) {
  var offset = layout[element];
  writeAsciiToMemory(value, name + offset);
 }
 if (name === 0) {
  return -1;
 } else {
  copyString("sysname", "Emscripten");
  copyString("nodename", "emscripten");
  copyString("release", "1.0");
  copyString("version", "#1");
  copyString("machine", "x86-JS");
  return 0;
 }
}
function _SDL_JoystickOpen(deviceIndex) {
 var gamepad = SDL.getGamepad(deviceIndex);
 if (gamepad) {
  var joystick = deviceIndex + 1;
  SDL.recordJoystickState(joystick, gamepad);
  return joystick;
 }
 return 0;
}
function _emscripten_glRotatef() {
 Module["printErr"]("missing function: emscripten_glRotatef");
 abort(-1);
}
var _emscripten_check_longjmp = true;
function _emscripten_glGetFramebufferAttachmentParameteriv(target, attachment, pname, params) {
 var result = GLctx.getFramebufferAttachmentParameter(target, attachment, pname);
 HEAP32[params >> 2] = result;
}
function _glBlendEquationSeparate(x0, x1) {
 GLctx.blendEquationSeparate(x0, x1);
}
function _emscripten_set_focus_callback(target, userData, useCapture, callbackfunc) {
 JSEvents.registerFocusEventCallback(target, userData, useCapture, callbackfunc, 13, "focus");
 return 0;
}
function _tcflush() {
 Module["printErr"]("missing function: tcflush");
 abort(-1);
}
function _emscripten_glGetShaderInfoLog(shader, maxLength, length, infoLog) {
 var log = GLctx.getShaderInfoLog(GL.shaders[shader]);
 if (!log) log = "(unknown error)";
 log = log.substr(0, maxLength - 1);
 if (maxLength > 0 && infoLog) {
  writeStringToMemory(log, infoLog);
  if (length) HEAP32[length >> 2] = log.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
}
function _emscripten_set_mouseup_callback(target, userData, useCapture, callbackfunc) {
 JSEvents.registerMouseEventCallback(target, userData, useCapture, callbackfunc, 6, "mouseup");
 return 0;
}
function _emscripten_glStencilOpSeparate(x0, x1, x2, x3) {
 GLctx.stencilOpSeparate(x0, x1, x2, x3);
}
function _emscripten_glCompressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, imageSize, data) {
 if (data) {
  data = HEAPU8.subarray(data, data + imageSize);
 } else {
  data = null;
 }
 GLctx["compressedTexSubImage2D"](target, level, xoffset, yoffset, width, height, format, data);
}
Module["_bitshift64Ashr"] = _bitshift64Ashr;
function _glStencilFuncSeparate(x0, x1, x2, x3) {
 GLctx.stencilFuncSeparate(x0, x1, x2, x3);
}
function _emscripten_glIsEnabled(x0) {
 return GLctx.isEnabled(x0);
}
function _glUniform4iv(location, count, value) {
 location = GL.uniforms[location];
 count *= 4;
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform4iv(location, value);
}
function _JS_Sound_ReleaseInstance(instance) {
 WEBAudio.audioInstances[instance] = null;
}
function _glClearStencil(x0) {
 GLctx.clearStencil(x0);
}
function _JS_Sound_SetPosition(channelInstance, x, y, z) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioInstances[channelInstance].panner.setPosition(x, y, z);
}
function _glGenTextures(n, textures) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.textures);
  var texture = GLctx.createTexture();
  texture.name = id;
  GL.textures[id] = texture;
  HEAP32[textures + i * 4 >> 2] = id;
 }
}
function _emscripten_glVertexAttrib4f(x0, x1, x2, x3, x4) {
 GLctx.vertexAttrib4f(x0, x1, x2, x3, x4);
}
function _emscripten_glUniform2i(location, v0, v1) {
 location = GL.uniforms[location];
 GLctx.uniform2i(location, v0, v1);
}
function ___cxa_free_exception(ptr) {
 try {
  return _free(ptr);
 } catch (e) {}
}
function ___cxa_end_catch() {
 if (___cxa_end_catch.rethrown) {
  ___cxa_end_catch.rethrown = false;
  return;
 }
 asm["setThrew"](0);
 var ptr = EXCEPTIONS.caught.pop();
 if (ptr) {
  EXCEPTIONS.decRef(EXCEPTIONS.deAdjust(ptr));
  EXCEPTIONS.last = 0;
 }
}
function ___cxa_rethrow() {
 ___cxa_end_catch.rethrown = true;
 var ptr = EXCEPTIONS.caught.pop();
 EXCEPTIONS.last = ptr;
 throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
}
function _emscripten_glClear(x0) {
 GLctx.clear(x0);
}
function _emscripten_get_now() {
 if (!_emscripten_get_now.actual) {
  if (ENVIRONMENT_IS_NODE) {
   _emscripten_get_now.actual = function _emscripten_get_now_actual() {
    var t = process["hrtime"]();
    return t[0] * 1e3 + t[1] / 1e6;
   };
  } else if (typeof dateNow !== "undefined") {
   _emscripten_get_now.actual = dateNow;
  } else if (typeof self === "object" && self["performance"] && typeof self["performance"]["now"] === "function") {
   _emscripten_get_now.actual = function _emscripten_get_now_actual() {
    return self["performance"]["now"]();
   };
  } else if (typeof performance === "object" && typeof performance["now"] === "function") {
   _emscripten_get_now.actual = function _emscripten_get_now_actual() {
    return performance["now"]();
   };
  } else {
   _emscripten_get_now.actual = Date.now;
  }
 }
 return _emscripten_get_now.actual();
}
function _emscripten_get_now_is_monotonic() {
 return ENVIRONMENT_IS_NODE || typeof dateNow !== "undefined" || (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) && self["performance"] && self["performance"]["now"];
}
function _clock_gettime(clk_id, tp) {
 var now;
 if (clk_id === 0) {
  now = Date.now();
 } else if (clk_id === 1 && _emscripten_get_now_is_monotonic()) {
  now = _emscripten_get_now();
 } else {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 HEAP32[tp >> 2] = now / 1e3 | 0;
 HEAP32[tp + 4 >> 2] = now % 1e3 * 1e3 * 1e3 | 0;
 return 0;
}
function _glDeleteRenderbuffers(n, renderbuffers) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[renderbuffers + i * 4 >> 2];
  var renderbuffer = GL.renderbuffers[id];
  if (!renderbuffer) continue;
  GLctx.deleteRenderbuffer(renderbuffer);
  renderbuffer.name = 0;
  GL.renderbuffers[id] = null;
 }
}
var _ceilf = Math_ceil;
function _glGetProgramiv(program, pname, p) {
 if (pname == 35716) {
  HEAP32[p >> 2] = GLctx.getProgramInfoLog(GL.programs[program]).length + 1;
 } else if (pname == 35719) {
  var ptable = GL.programInfos[program];
  if (ptable) {
   HEAP32[p >> 2] = ptable.maxUniformLength;
   return;
  } else if (program < GL.counter) {
   GL.recordError(1282);
  } else {
   GL.recordError(1281);
  }
 } else if (pname == 35722) {
  var ptable = GL.programInfos[program];
  if (ptable) {
   if (ptable.maxAttributeLength == -1) {
    var program = GL.programs[program];
    var numAttribs = GLctx.getProgramParameter(program, GLctx.ACTIVE_ATTRIBUTES);
    ptable.maxAttributeLength = 0;
    for (var i = 0; i < numAttribs; ++i) {
     var activeAttrib = GLctx.getActiveAttrib(program, i);
     ptable.maxAttributeLength = Math.max(ptable.maxAttributeLength, activeAttrib.name.length + 1);
    }
   }
   HEAP32[p >> 2] = ptable.maxAttributeLength;
   return;
  } else if (program < GL.counter) {
   GL.recordError(1282);
  } else {
   GL.recordError(1281);
  }
 } else {
  HEAP32[p >> 2] = GLctx.getProgramParameter(GL.programs[program], pname);
 }
}
function _glVertexAttribPointer(index, size, type, normalized, stride, ptr) {
 GLctx.vertexAttribPointer(index, size, type, normalized, stride, ptr);
}
function _pthread_cond_signal() {
 throw "TODO: " + aborter;
}
function _pthread_create() {
 Module["printErr"]("missing function: pthread_create");
 abort(-1);
}
function _emscripten_glGetAttachedShaders(program, maxCount, count, shaders) {
 var result = GLctx.getAttachedShaders(GL.programs[program]);
 var len = result.length;
 if (len > maxCount) {
  len = maxCount;
 }
 HEAP32[count >> 2] = len;
 for (var i = 0; i < len; ++i) {
  var id = GL.shaders.indexOf(result[i]);
  HEAP32[shaders + i * 4 >> 2] = id;
 }
}
function _flock(fd, operation) {
 return 0;
}
function _emscripten_glFrontFace(x0) {
 GLctx.frontFace(x0);
}
function _emscripten_glLinkProgram(program) {
 GLctx.linkProgram(GL.programs[program]);
 GL.programInfos[program] = null;
 GL.populateUniformTable(program);
}
function _glTexStorage2D(target, levels, internalformat, width, height) {
 GLctx.texStorage2D(target, levels, internalformat, width, height);
}
function _emscripten_glGetInfoLogARB() {
 Module["printErr"]("missing function: emscripten_glGetInfoLogARB");
 abort(-1);
}
function _pthread_key_delete(key) {
 if (key in PTHREAD_SPECIFIC) {
  delete PTHREAD_SPECIFIC[key];
  return 0;
 }
 return ERRNO_CODES.EINVAL;
}
function _glGenQueries(n, ids) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.queries);
  var query = GLctx.createQuery();
  query.name = id;
  GL.queries[id] = query;
  HEAP32[ids + i * 4 >> 2] = id;
 }
}
function ___ctype_b_loc() {
 var me = ___ctype_b_loc;
 if (!me.ret) {
  var values = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 8195, 8194, 8194, 8194, 8194, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 24577, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 54536, 54536, 54536, 54536, 54536, 54536, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 49156, 49156, 49156, 49156, 49156, 49156, 54792, 54792, 54792, 54792, 54792, 54792, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 49156, 49156, 49156, 49156, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
  var i16size = 2;
  var arr = _malloc(values.length * i16size);
  for (var i = 0; i < values.length; i++) {
   HEAP16[arr + i * i16size >> 1] = values[i];
  }
  me.ret = allocate([ arr + 128 * i16size ], "i16*", ALLOC_NORMAL);
 }
 return me.ret;
}
var _atan2f = Math_atan2;
function _emscripten_glRenderbufferStorage(x0, x1, x2, x3) {
 GLctx.renderbufferStorage(x0, x1, x2, x3);
}
function _catgets(catd, set_id, msg_id, s) {
 return s;
}
function _glTexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, data) {
 GLctx.texSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, HEAPU8.subarray(data));
}
function _ferror(stream) {
 stream = FS.getStreamFromPtr(stream);
 return Number(stream && stream.error);
}
function _getcwd(buf, size) {
 if (size == 0) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return 0;
 }
 var cwd = FS.cwd();
 if (size < cwd.length + 1) {
  ___setErrNo(ERRNO_CODES.ERANGE);
  return 0;
 } else {
  writeAsciiToMemory(cwd, buf);
  return buf;
 }
}
function _emscripten_glTexParameteriv(target, pname, params) {
 var param = HEAP32[params >> 2];
 GLctx.texParameteri(target, pname, param);
}
function _glBlitFramebuffer(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter) {
 GLctx.blitFramebuffer(srcX0, srcY0, srxC1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}
function _llvm_trap() {
 abort("trap!");
}
function _emscripten_glIsProgram(program) {
 var program = GL.programs[program];
 if (!program) return 0;
 return GLctx.isProgram(program);
}
function _emscripten_webgl_init_context_attributes(attributes) {
 HEAP32[attributes >> 2] = 1;
 HEAP32[attributes + 4 >> 2] = 1;
 HEAP32[attributes + 8 >> 2] = 0;
 HEAP32[attributes + 12 >> 2] = 1;
 HEAP32[attributes + 16 >> 2] = 1;
 HEAP32[attributes + 20 >> 2] = 0;
 HEAP32[attributes + 24 >> 2] = 0;
 HEAP32[attributes + 28 >> 2] = 0;
 HEAP32[attributes + 32 >> 2] = 1;
 HEAP32[attributes + 36 >> 2] = 0;
 HEAP32[attributes + 40 >> 2] = 1;
}
function _emscripten_glGetShaderiv(shader, pname, p) {
 if (pname == 35716) {
  var log = GLctx.getShaderInfoLog(GL.shaders[shader]);
  if (!log) log = "(unknown error)";
  HEAP32[p >> 2] = log.length + 1;
 } else {
  HEAP32[p >> 2] = GLctx.getShaderParameter(GL.shaders[shader], pname);
 }
}
function _emscripten_glUniformMatrix3fv(location, count, transpose, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[8];
  for (var i = 0; i < 9; i++) {
   view[i] = HEAPF32[value + i * 4 >> 2];
  }
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 36 >> 2);
 }
 GLctx.uniformMatrix3fv(location, transpose, view);
}
function _JS_Sound_Load(ptr, length) {
 if (WEBAudio.audioWebEnabled == 0) return 0;
 var sound = {
  buffer: null,
  error: false
 };
 var instance = WEBAudio.audioInstances.push(sound) - 1;
 WEBAudio.audioContext.decodeAudioData(HEAPU8.buffer.slice(ptr, ptr + length), (function(buffer) {
  sound.buffer = buffer;
 }), (function() {
  sound.error = true;
  console.log("Decode error.");
 }));
 return instance;
}
function _emscripten_glGenFramebuffers(n, ids) {
 for (var i = 0; i < n; ++i) {
  var id = GL.getNewId(GL.framebuffers);
  var framebuffer = GLctx.createFramebuffer();
  framebuffer.name = id;
  GL.framebuffers[id] = framebuffer;
  HEAP32[ids + i * 4 >> 2] = id;
 }
}
function _JS_Sound_Play(bufferInstance, channelInstance) {
 _JS_Sound_Stop(channelInstance);
 if (WEBAudio.audioWebEnabled == 0) return;
 var sound = WEBAudio.audioInstances[bufferInstance];
 var channel = WEBAudio.audioInstances[channelInstance];
 if (sound.buffer) channel.playBuffer(sound.buffer); else console.log("Trying to play sound which is not loaded.");
}
function _glGetShaderiv(shader, pname, p) {
 if (pname == 35716) {
  var log = GLctx.getShaderInfoLog(GL.shaders[shader]);
  if (!log) log = "(unknown error)";
  HEAP32[p >> 2] = log.length + 1;
 } else {
  HEAP32[p >> 2] = GLctx.getShaderParameter(GL.shaders[shader], pname);
 }
}
function _emscripten_glBlendEquationSeparate(x0, x1) {
 GLctx.blendEquationSeparate(x0, x1);
}
function _emscripten_glDrawRangeElements() {
 Module["printErr"]("missing function: emscripten_glDrawRangeElements");
 abort(-1);
}
function _glInvalidateFramebuffer(target, numAttachments, attachments) {
 var list = [];
 for (var i = 0; i < numAttachments; i++) list.push(HEAP32[attachments + i * 4 >> 2]);
 GLctx.invalidateFramebuffer(target, list);
}
function _emscripten_glGenTextures(n, textures) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.textures);
  var texture = GLctx.createTexture();
  texture.name = id;
  GL.textures[id] = texture;
  HEAP32[textures + i * 4 >> 2] = id;
 }
}
var _floorf = Math_floor;
function _emscripten_glGetActiveUniform(program, index, bufSize, length, size, type, name) {
 program = GL.programs[program];
 var info = GLctx.getActiveUniform(program, index);
 if (!info) return;
 var infoname = info.name.slice(0, Math.max(0, bufSize - 1));
 if (bufSize > 0 && name) {
  writeStringToMemory(infoname, name);
  if (length) HEAP32[length >> 2] = infoname.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
 if (size) HEAP32[size >> 2] = info.size;
 if (type) HEAP32[type >> 2] = info.type;
}
var _FtoIHigh = true;
Module["_strncpy"] = _strncpy;
function _emscripten_glDrawArrays(mode, first, count) {
 GLctx.drawArrays(mode, first, count);
}
function _emscripten_glClearDepth(x0) {
 GLctx.clearDepth(x0);
}
function _mknod(path, mode, dev) {
 path = Pointer_stringify(path);
 switch (mode & 61440) {
 case 32768:
 case 8192:
 case 24576:
 case 4096:
 case 49152:
  break;
 default:
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 try {
  FS.mknod(path, mode, dev);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _mkdir(path, mode) {
 path = Pointer_stringify(path);
 path = PATH.normalize(path);
 if (path[path.length - 1] === "/") path = path.substr(0, path.length - 1);
 try {
  FS.mkdir(path, mode, 0);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _emscripten_glGetUniformLocation(program, name) {
 name = Pointer_stringify(name);
 var arrayOffset = 0;
 if (name.indexOf("]", name.length - 1) !== -1) {
  var ls = name.lastIndexOf("[");
  var arrayIndex = name.slice(ls + 1, -1);
  if (arrayIndex.length > 0) {
   arrayOffset = parseInt(arrayIndex);
   if (arrayOffset < 0) {
    return -1;
   }
  }
  name = name.slice(0, ls);
 }
 var ptable = GL.programInfos[program];
 if (!ptable) {
  return -1;
 }
 var utable = ptable.uniforms;
 var uniformInfo = utable[name];
 if (uniformInfo && arrayOffset < uniformInfo[0]) {
  return uniformInfo[1] + arrayOffset;
 } else {
  return -1;
 }
}
function _glUniform3fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[2];
  view[0] = HEAPF32[value >> 2];
  view[1] = HEAPF32[value + 4 >> 2];
  view[2] = HEAPF32[value + 8 >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 12 >> 2);
 }
 GLctx.uniform3fv(location, view);
}
function _emscripten_glVertexAttrib4fv(index, v) {
 v = HEAPF32.subarray(v >> 2, v + 16 >> 2);
 GLctx.vertexAttrib4fv(index, v);
}
function _emscripten_glScissor(x0, x1, x2, x3) {
 GLctx.scissor(x0, x1, x2, x3);
}
Module["_bitshift64Lshr"] = _bitshift64Lshr;
function _JS_Sound_Set3D(channelInstance, threeD) {
 var channel = WEBAudio.audioInstances[channelInstance];
 if (channel.threeD != threeD) {
  channel.threeD = threeD;
  channel.setupPanning();
 }
}
function _JS_SystemInfo_GetDocumentURL(buffer, bufferSize) {
 var result = document.URL;
 result = result.slice(0, Math.max(0, bufferSize - 1));
 if (buffer) writeStringToMemory(result, buffer);
 return document.URL.length + 1;
}
function _JS_SystemInfo_GetMemory() {
 return TOTAL_MEMORY / (1024 * 1024);
}
function _glGetUniformLocation(program, name) {
 name = Pointer_stringify(name);
 var arrayOffset = 0;
 if (name.indexOf("]", name.length - 1) !== -1) {
  var ls = name.lastIndexOf("[");
  var arrayIndex = name.slice(ls + 1, -1);
  if (arrayIndex.length > 0) {
   arrayOffset = parseInt(arrayIndex);
   if (arrayOffset < 0) {
    return -1;
   }
  }
  name = name.slice(0, ls);
 }
 var ptable = GL.programInfos[program];
 if (!ptable) {
  return -1;
 }
 var utable = ptable.uniforms;
 var uniformInfo = utable[name];
 if (uniformInfo && arrayOffset < uniformInfo[0]) {
  return uniformInfo[1] + arrayOffset;
 } else {
  return -1;
 }
}
function _pthread_mutexattr_destroy() {}
Module["_testSetjmp"] = _testSetjmp;
function _longjmp(env, value) {
 asm["setThrew"](env, value || 1);
 throw "longjmp";
}
function _emscripten_longjmp(env, value) {
 _longjmp(env, value);
}
function _glGetActiveUniformBlockName(program, uniformBlockIndex, bufSize, length, uniformBlockName) {
 program = GL.programs[program];
 var result = GLctx.getActiveUniformBlockName(program, uniformBlockIndex);
 if (!result) return;
 var name = result.slice(0, Math.max(0, bufSize - 1));
 if (uniformBlockName && bufSize > 0) {
  writeStringToMemory(name, uniformBlockName);
  if (length) HEAP32[length >> 2] = name.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
}
function _glGetVertexAttribiv(index, pname, params) {
 var data = GLctx.getVertexAttrib(index, pname);
 if (typeof data == "number" || typeof data == "boolean") {
  HEAP32[params >> 2] = data;
 } else {
  for (var i = 0; i < data.length; i++) {
   HEAP32[params + i >> 2] = data[i];
  }
 }
}
function _glUniform3iv(location, count, value) {
 location = GL.uniforms[location];
 count *= 3;
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform3iv(location, value);
}
function _emscripten_glEnable(x0) {
 GLctx.enable(x0);
}
var _llvm_pow_f64 = Math_pow;
function __getFloat(text) {
 return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
}
function __scanString(format, get, unget, varargs) {
 if (!__scanString.whiteSpace) {
  __scanString.whiteSpace = {};
  __scanString.whiteSpace[32] = 1;
  __scanString.whiteSpace[9] = 1;
  __scanString.whiteSpace[10] = 1;
  __scanString.whiteSpace[11] = 1;
  __scanString.whiteSpace[12] = 1;
  __scanString.whiteSpace[13] = 1;
 }
 format = Pointer_stringify(format);
 var soFar = 0;
 if (format.indexOf("%n") >= 0) {
  var _get = get;
  get = function get() {
   soFar++;
   return _get();
  };
  var _unget = unget;
  unget = function unget() {
   soFar--;
   return _unget();
  };
 }
 var formatIndex = 0;
 var argsi = 0;
 var fields = 0;
 var argIndex = 0;
 var next;
 mainLoop : for (var formatIndex = 0; formatIndex < format.length; ) {
  if (format[formatIndex] === "%" && format[formatIndex + 1] == "n") {
   var argPtr = HEAP32[varargs + argIndex >> 2];
   argIndex += Runtime.getAlignSize("void*", null, true);
   HEAP32[argPtr >> 2] = soFar;
   formatIndex += 2;
   continue;
  }
  if (format[formatIndex] === "%") {
   var nextC = format.indexOf("c", formatIndex + 1);
   if (nextC > 0) {
    var maxx = 1;
    if (nextC > formatIndex + 1) {
     var sub = format.substring(formatIndex + 1, nextC);
     maxx = parseInt(sub);
     if (maxx != sub) maxx = 0;
    }
    if (maxx) {
     var argPtr = HEAP32[varargs + argIndex >> 2];
     argIndex += Runtime.getAlignSize("void*", null, true);
     fields++;
     for (var i = 0; i < maxx; i++) {
      next = get();
      HEAP8[argPtr++ >> 0] = next;
      if (next === 0) return i > 0 ? fields : fields - 1;
     }
     formatIndex += nextC - formatIndex + 1;
     continue;
    }
   }
  }
  if (format[formatIndex] === "%" && format.indexOf("[", formatIndex + 1) > 0) {
   var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
   if (match) {
    var maxNumCharacters = parseInt(match[1]) || Infinity;
    var negateScanList = match[2] === "^";
    var scanList = match[3];
    var middleDashMatch;
    while (middleDashMatch = /([^\-])\-([^\-])/.exec(scanList)) {
     var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
     var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
     for (var expanded = ""; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++)) ;
     scanList = scanList.replace(middleDashMatch[1] + "-" + middleDashMatch[2], expanded);
    }
    var argPtr = HEAP32[varargs + argIndex >> 2];
    argIndex += Runtime.getAlignSize("void*", null, true);
    fields++;
    for (var i = 0; i < maxNumCharacters; i++) {
     next = get();
     if (negateScanList) {
      if (scanList.indexOf(String.fromCharCode(next)) < 0) {
       HEAP8[argPtr++ >> 0] = next;
      } else {
       unget();
       break;
      }
     } else {
      if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
       HEAP8[argPtr++ >> 0] = next;
      } else {
       unget();
       break;
      }
     }
    }
    HEAP8[argPtr++ >> 0] = 0;
    formatIndex += match[0].length;
    continue;
   }
  }
  while (1) {
   next = get();
   if (next == 0) return fields;
   if (!(next in __scanString.whiteSpace)) break;
  }
  unget();
  if (format[formatIndex] === "%") {
   formatIndex++;
   var suppressAssignment = false;
   if (format[formatIndex] == "*") {
    suppressAssignment = true;
    formatIndex++;
   }
   var maxSpecifierStart = formatIndex;
   while (format[formatIndex].charCodeAt(0) >= 48 && format[formatIndex].charCodeAt(0) <= 57) {
    formatIndex++;
   }
   var max_;
   if (formatIndex != maxSpecifierStart) {
    max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
   }
   var long_ = false;
   var half = false;
   var quarter = false;
   var longLong = false;
   if (format[formatIndex] == "l") {
    long_ = true;
    formatIndex++;
    if (format[formatIndex] == "l") {
     longLong = true;
     formatIndex++;
    }
   } else if (format[formatIndex] == "h") {
    half = true;
    formatIndex++;
    if (format[formatIndex] == "h") {
     quarter = true;
     formatIndex++;
    }
   }
   var type = format[formatIndex];
   formatIndex++;
   var curr = 0;
   var buffer = [];
   if (type == "f" || type == "e" || type == "g" || type == "F" || type == "E" || type == "G") {
    next = get();
    while (next > 0 && !(next in __scanString.whiteSpace)) {
     buffer.push(String.fromCharCode(next));
     next = get();
    }
    var m = __getFloat(buffer.join(""));
    var last = m ? m[0].length : 0;
    for (var i = 0; i < buffer.length - last + 1; i++) {
     unget();
    }
    buffer.length = last;
   } else {
    next = get();
    var first = true;
    if ((type == "x" || type == "X") && next == 48) {
     var peek = get();
     if (peek == 120 || peek == 88) {
      next = get();
     } else {
      unget();
     }
    }
    while ((curr < max_ || isNaN(max_)) && next > 0) {
     if (!(next in __scanString.whiteSpace) && (type == "s" || (type === "d" || type == "u" || type == "i") && (next >= 48 && next <= 57 || first && next == 45) || (type === "x" || type === "X") && (next >= 48 && next <= 57 || next >= 97 && next <= 102 || next >= 65 && next <= 70)) && (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) {
      buffer.push(String.fromCharCode(next));
      next = get();
      curr++;
      first = false;
     } else {
      break;
     }
    }
    unget();
   }
   if (buffer.length === 0) return fields;
   if (suppressAssignment) continue;
   var text = buffer.join("");
   var argPtr = HEAP32[varargs + argIndex >> 2];
   argIndex += Runtime.getAlignSize("void*", null, true);
   var base = 10;
   switch (type) {
   case "X":
   case "x":
    base = 16;
   case "d":
   case "u":
   case "i":
    if (quarter) {
     HEAP8[argPtr >> 0] = parseInt(text, base);
    } else if (half) {
     HEAP16[argPtr >> 1] = parseInt(text, base);
    } else if (longLong) {
     tempI64 = [ parseInt(text, base) >>> 0, (tempDouble = parseInt(text, base), +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0) ], HEAP32[argPtr >> 2] = tempI64[0], HEAP32[argPtr + 4 >> 2] = tempI64[1];
    } else {
     HEAP32[argPtr >> 2] = parseInt(text, base);
    }
    break;
   case "F":
   case "f":
   case "E":
   case "e":
   case "G":
   case "g":
   case "E":
    if (long_) {
     HEAPF64[argPtr >> 3] = parseFloat(text);
    } else {
     HEAPF32[argPtr >> 2] = parseFloat(text);
    }
    break;
   case "s":
    var array = intArrayFromString(text);
    for (var j = 0; j < array.length; j++) {
     HEAP8[argPtr + j >> 0] = array[j];
    }
    break;
   }
   fields++;
  } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
   next = get();
   while (next in __scanString.whiteSpace) {
    if (next <= 0) break mainLoop;
    next = get();
   }
   unget(next);
   formatIndex++;
  } else {
   next = get();
   if (format[formatIndex].charCodeAt(0) !== next) {
    unget(next);
    break mainLoop;
   }
   formatIndex++;
  }
 }
 return fields;
}
function _recv(fd, buf, len, flags) {
 var sock = SOCKFS.getSocket(fd);
 if (!sock) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 return _read(fd, buf, len);
}
function _pread(fildes, buf, nbyte, offset) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.read(stream, slab, buf, nbyte, offset);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _read(fildes, buf, nbyte) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.read(stream, slab, buf, nbyte);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fread(ptr, size, nitems, stream) {
 var bytesToRead = nitems * size;
 if (bytesToRead == 0) {
  return 0;
 }
 var bytesRead = 0;
 var streamObj = FS.getStreamFromPtr(stream);
 if (!streamObj) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return 0;
 }
 while (streamObj.ungotten.length && bytesToRead > 0) {
  HEAP8[ptr++ >> 0] = streamObj.ungotten.pop();
  bytesToRead--;
  bytesRead++;
 }
 var err = _read(streamObj.fd, ptr, bytesToRead);
 if (err == -1) {
  if (streamObj) streamObj.error = true;
  return 0;
 }
 bytesRead += err;
 if (bytesRead < bytesToRead) streamObj.eof = true;
 return bytesRead / size | 0;
}
function _fgetc(stream) {
 var streamObj = FS.getStreamFromPtr(stream);
 if (!streamObj) return -1;
 if (streamObj.eof || streamObj.error) return -1;
 var ret = _fread(_fgetc.ret, 1, 1, stream);
 if (ret == 0) {
  return -1;
 } else if (ret == -1) {
  streamObj.error = true;
  return -1;
 } else {
  return HEAPU8[_fgetc.ret >> 0];
 }
}
function _ungetc(c, stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) {
  return -1;
 }
 if (c === -1) {
  return c;
 }
 c = unSign(c & 255);
 stream.ungotten.push(c);
 stream.eof = false;
 return c;
}
function _fscanf(stream, format, varargs) {
 var streamObj = FS.getStreamFromPtr(stream);
 if (!streamObj) {
  return -1;
 }
 var buffer = [];
 function get() {
  var c = _fgetc(stream);
  buffer.push(c);
  return c;
 }
 function unget() {
  _ungetc(buffer.pop(), stream);
 }
 return __scanString(format, get, unget, varargs);
}
function _glGetActiveUniformBlockiv(program, uniformBlockIndex, pname, params) {
 program = GL.programs[program];
 var result = GLctx.getActiveUniformBlockParameter(program, uniformBlockIndex, pname);
 if (!result) return;
 if (typeof result == "number") {
  HEAP32[params >> 2] = result;
 } else {
  for (var i = 0; i < result.length; i++) {
   HEAP32[params + i * 4 >> 2] = result[i];
  }
 }
}
var _BItoD = true;
function _emscripten_glGetShaderSource(shader, bufSize, length, source) {
 var result = GLctx.getShaderSource(GL.shaders[shader]);
 if (!result) return;
 result = result.slice(0, Math.max(0, bufSize - 1));
 if (bufSize > 0 && source) {
  writeStringToMemory(result, source);
  if (length) HEAP32[length >> 2] = result.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
}
Module["_llvm_bswap_i32"] = _llvm_bswap_i32;
function ___cxa_guard_release() {}
function _JS_Sound_GetLoadState(bufferInstance) {
 if (WEBAudio.audioWebEnabled == 0) return 2;
 var sound = WEBAudio.audioInstances[bufferInstance];
 if (sound.error) return 2;
 if (sound.buffer) return 0;
 return 1;
}
function _JS_Sound_SetPitch(channelInstance, v) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioInstances[channelInstance].source.playbackRate.value = v;
}
var _expf = Math_exp;
function _glUseProgram(program) {
 GLctx.useProgram(program ? GL.programs[program] : null);
}
function _glGetProgramInfoLog(program, maxLength, length, infoLog) {
 var log = GLctx.getProgramInfoLog(GL.programs[program]);
 if (!log) log = "";
 log = log.substr(0, maxLength - 1);
 if (maxLength > 0 && infoLog) {
  writeStringToMemory(log, infoLog);
  if (length) HEAP32[length >> 2] = log.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
}
function _emscripten_glUniform3fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[2];
  view[0] = HEAPF32[value >> 2];
  view[1] = HEAPF32[value + 4 >> 2];
  view[2] = HEAPF32[value + 8 >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 12 >> 2);
 }
 GLctx.uniform3fv(location, view);
}
function _glBindTransformFeedback(target, id) {
 var transformFeedback = id ? GL.transformFeedbacks[id] : null;
 if (id && !transformFeedback) {
  GL.recordError(1282);
  return;
 }
 GLctx.bindTransformFeedback(target, transformFeedback);
}
function _emscripten_glDrawElements(mode, count, type, indices) {
 GLctx.drawElements(mode, count, type, indices);
}
function _glBindVertexArray(vao) {
 GL.currentContext.vaoExt.bindVertexArrayOES(GL.vaos[vao]);
}
function _emscripten_glCreateProgram() {
 var id = GL.getNewId(GL.programs);
 var program = GLctx.createProgram();
 program.name = id;
 GL.programs[id] = program;
 return id;
}
function _pthread_once(ptr, func) {
 if (!_pthread_once.seen) _pthread_once.seen = {};
 if (ptr in _pthread_once.seen) return;
 Runtime.dynCall("v", func);
 _pthread_once.seen[ptr] = 1;
}
function _emscripten_glCompressedTexImage2D(target, level, internalFormat, width, height, border, imageSize, data) {
 if (data) {
  data = HEAPU8.subarray(data, data + imageSize);
 } else {
  data = null;
 }
 GLctx["compressedTexImage2D"](target, level, internalFormat, width, height, border, data);
}
function _emscripten_glClearColor(x0, x1, x2, x3) {
 GLctx.clearColor(x0, x1, x2, x3);
}
function _lseek(fildes, offset, whence) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  return FS.llseek(stream, offset, whence);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fseek(stream, offset, whence) {
 var fd = _fileno(stream);
 var ret = _lseek(fd, offset, whence);
 if (ret == -1) {
  return -1;
 }
 stream = FS.getStreamFromPtr(stream);
 stream.eof = false;
 return 0;
}
function _pthread_attr_destroy(attr) {
 return 0;
}
function _JS_SystemInfo_HasWebGL() {
 return systemInfo.get().hasWebGL;
}
function _glFinish() {
 GLctx.finish();
}
function _emscripten_glLoadMatrixf() {
 Module["printErr"]("missing function: emscripten_glLoadMatrixf");
 abort(-1);
}
function _glDeleteShader(id) {
 if (!id) return;
 var shader = GL.shaders[id];
 if (!shader) {
  GL.recordError(1281);
  return;
 }
 GLctx.deleteShader(shader);
 GL.shaders[id] = null;
}
function _emscripten_glGetProgramInfoLog(program, maxLength, length, infoLog) {
 var log = GLctx.getProgramInfoLog(GL.programs[program]);
 if (!log) log = "";
 log = log.substr(0, maxLength - 1);
 if (maxLength > 0 && infoLog) {
  writeStringToMemory(log, infoLog);
  if (length) HEAP32[length >> 2] = log.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
}
function _tcgetattr(fildes, termios_p) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 if (!stream.tty) {
  ___setErrNo(ERRNO_CODES.ENOTTY);
  return -1;
 }
 return 0;
}
function _glViewport(x0, x1, x2, x3) {
 GLctx.viewport(x0, x1, x2, x3);
}
function _catopen(name, oflag) {
 return -1;
}
function _emscripten_glDepthMask(x0) {
 GLctx.depthMask(x0);
}
function _glTransformFeedbackVaryings(program, count, varyings, bufferMode) {
 program = GL.programs[program];
 var vars = [];
 for (var i = 0; i < count; i++) vars.push(Pointer_stringify(HEAP32[varyings + i * 4 >> 2]));
 GLctx.transformFeedbackVaryings(program, vars, bufferMode);
}
function _JS_Sound_Init() {
 try {
  window.AudioContext = window.AudioContext || window.webkitAudioContext;
  WEBAudio.audioContext = new AudioContext;
  WEBAudio.audioWebEnabled = 1;
 } catch (e) {
  alert("Web Audio API is not supported in this browser");
 }
}
function _emscripten_glFlush() {
 GLctx.flush();
}
function __ZN4FMOD13DSPConnection6setMixEf() {
 Module["printErr"]("missing function: _ZN4FMOD13DSPConnection6setMixEf");
 abort(-1);
}
function _emscripten_glCreateShader(shaderType) {
 var id = GL.getNewId(GL.shaders);
 GL.shaders[id] = GLctx.createShader(shaderType);
 return id;
}
function _pthread_cond_init() {}
function _emscripten_glIsShader(shader) {
 var s = GL.shaders[shader];
 if (!s) return 0;
 return GLctx.isShader(s);
}
function _JS_Cursor_SetCursorString(cursor) {
 if (document.styleSheets.length == 0) {
  console.log("can't set cursor because there is no style sheet.");
  return;
 }
 var styleSheet = document.styleSheets[0];
 var rule = "canvas.emscripten { border: 0px none; cursor: " + cursor + "; }";
 for (var i = 0; i < styleSheet.cssRules.length; i++) {
  if (styleSheet.cssRules[i].cssText.indexOf("canvas.emscripten") != -1) {
   styleSheet.deleteRule(i);
   styleSheet.insertRule(rule, 0);
   return;
  }
 }
 styleSheet.insertRule(rule, 0);
}
function _JS_Cursor_SetShow(show) {
 var cursor = show ? "default" : "none";
 _JS_Cursor_SetCursorString(cursor);
}
function _glTexParameteri(x0, x1, x2) {
 GLctx.texParameteri(x0, x1, x2);
}
function _emscripten_glColorMask(x0, x1, x2, x3) {
 GLctx.colorMask(x0, x1, x2, x3);
}
function _emscripten_set_canvas_size(width, height) {
 Browser.setCanvasSize(width, height);
}
var _exp = Math_exp;
var _llvm_nacl_atomic_cmpxchg_i32 = undefined;
function _emscripten_glIsRenderbuffer(renderbuffer) {
 var rb = GL.renderbuffers[renderbuffer];
 if (!rb) return 0;
 return GLctx.isRenderbuffer(rb);
}
var _DtoILow = true;
function _glLinkProgram(program) {
 GLctx.linkProgram(GL.programs[program]);
 GL.programInfos[program] = null;
 GL.populateUniformTable(program);
}
function _glBindTexture(target, texture) {
 GLctx.bindTexture(target, texture ? GL.textures[texture] : null);
}
function _JS_FileSystem_Sync() {
 if (!window.indexedDB) return;
 FS.syncfs(false, (function(err) {}));
}
function _emscripten_glShaderSource(shader, count, string, length) {
 var source = GL.getSource(shader, count, string, length);
 GLctx.shaderSource(GL.shaders[shader], source);
}
function _glEndQuery(target) {
 GLctx.endQuery(target);
}
function _pthread_mutex_init() {}
function _emscripten_glIsTexture(texture) {
 var texture = GL.textures[texture];
 if (!texture) return 0;
 return GLctx.isTexture(texture);
}
function _stat(path, buf, dontResolveLastLink) {
 path = typeof path !== "string" ? Pointer_stringify(path) : path;
 try {
  var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
  HEAP32[buf >> 2] = stat.dev;
  HEAP32[buf + 4 >> 2] = 0;
  HEAP32[buf + 8 >> 2] = stat.ino;
  HEAP32[buf + 12 >> 2] = stat.mode;
  HEAP32[buf + 16 >> 2] = stat.nlink;
  HEAP32[buf + 20 >> 2] = stat.uid;
  HEAP32[buf + 24 >> 2] = stat.gid;
  HEAP32[buf + 28 >> 2] = stat.rdev;
  HEAP32[buf + 32 >> 2] = 0;
  HEAP32[buf + 36 >> 2] = stat.size;
  HEAP32[buf + 40 >> 2] = 4096;
  HEAP32[buf + 44 >> 2] = stat.blocks;
  HEAP32[buf + 48 >> 2] = stat.atime.getTime() / 1e3 | 0;
  HEAP32[buf + 52 >> 2] = 0;
  HEAP32[buf + 56 >> 2] = stat.mtime.getTime() / 1e3 | 0;
  HEAP32[buf + 60 >> 2] = 0;
  HEAP32[buf + 64 >> 2] = stat.ctime.getTime() / 1e3 | 0;
  HEAP32[buf + 68 >> 2] = 0;
  HEAP32[buf + 72 >> 2] = stat.ino;
  return 0;
 } catch (e) {
  if (e.node && PATH.normalize(path) !== PATH.normalize(FS.getPath(e.node))) {
   e.setErrno(ERRNO_CODES.ENOTDIR);
  }
  FS.handleFSError(e);
  return -1;
 }
}
function _fstat(fildes, buf) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 return _stat(stream.path, buf);
}
function _emscripten_glUniform4f(location, v0, v1, v2, v3) {
 location = GL.uniforms[location];
 GLctx.uniform4f(location, v0, v1, v2, v3);
}
function _glStencilOpSeparate(x0, x1, x2, x3) {
 GLctx.stencilOpSeparate(x0, x1, x2, x3);
}
function _emscripten_glHint(x0, x1) {
 GLctx.hint(x0, x1);
}
function _glDeleteQueries(n, ids) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[ids + i * 4 >> 2];
  var query = GL.queries[id];
  if (!query) continue;
  GLctx.deleteQuery(query);
  query.name = 0;
  GL.queries[id] = null;
 }
}
function _glVertexAttrib4f(x0, x1, x2, x3, x4) {
 GLctx.vertexAttrib4f(x0, x1, x2, x3, x4);
}
function _emscripten_glUniform4i(location, v0, v1, v2, v3) {
 location = GL.uniforms[location];
 GLctx.uniform4i(location, v0, v1, v2, v3);
}
function _glGetTexParameteriv(target, pname, params) {
 HEAP32[params >> 2] = GLctx.getTexParameter(target, pname);
}
function _emscripten_glViewport(x0, x1, x2, x3) {
 GLctx.viewport(x0, x1, x2, x3);
}
function _emscripten_memcpy_big(dest, src, num) {
 HEAPU8.set(HEAPU8.subarray(src, src + num), dest);
 return dest;
}
Module["_memcpy"] = _memcpy;
function _emscripten_glBufferData(target, size, data, usage) {
 switch (usage) {
 case 35041:
 case 35042:
  usage = 35040;
  break;
 case 35045:
 case 35046:
  usage = 35044;
  break;
 case 35049:
 case 35050:
  usage = 35048;
  break;
 }
 if (!data) {
  GLctx.bufferData(target, size, usage);
 } else {
  GLctx.bufferData(target, HEAPU8.subarray(data, data + size), usage);
 }
}
var _emscripten_preinvoke = true;
function _pthread_mutexattr_init() {}
function _glGetVertexAttribfv(index, pname, params) {
 var data = GLctx.getVertexAttrib(index, pname);
 if (typeof data == "number") {
  HEAPF32[params >> 2] = data;
 } else {
  for (var i = 0; i < data.length; i++) {
   HEAPF32[params + i >> 2] = data[i];
  }
 }
}
function _emscripten_glUniform3f(location, v0, v1, v2) {
 location = GL.uniforms[location];
 GLctx.uniform3f(location, v0, v1, v2);
}
function _emscripten_glBlendFunc(x0, x1) {
 GLctx.blendFunc(x0, x1);
}
function _emscripten_glUniform3i(location, v0, v1, v2) {
 location = GL.uniforms[location];
 GLctx.uniform3i(location, v0, v1, v2);
}
function _emscripten_glStencilOp(x0, x1, x2) {
 GLctx.stencilOp(x0, x1, x2);
}
function _glUniform1i(location, v0) {
 location = GL.uniforms[location];
 GLctx.uniform1i(location, v0);
}
function _glGetActiveAttrib(program, index, bufSize, length, size, type, name) {
 program = GL.programs[program];
 var info = GLctx.getActiveAttrib(program, index);
 if (!info) return;
 var infoname = info.name.slice(0, Math.max(0, bufSize - 1));
 if (bufSize > 0 && name) {
  writeStringToMemory(infoname, name);
  if (length) HEAP32[length >> 2] = infoname.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
 if (size) HEAP32[size >> 2] = info.size;
 if (type) HEAP32[type >> 2] = info.type;
}
function _glTexSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels) {
 if (pixels) {
  var data = GL.getTexPixelData(type, format, width, height, pixels, -1);
  pixels = data.pixels;
 } else {
  pixels = null;
 }
 GLctx.texSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels);
}
function _glDisable(x0) {
 GLctx.disable(x0);
}
function _emscripten_glGetVertexAttribPointerv(index, pname, pointer) {
 HEAP32[pointer >> 2] = GLctx.getVertexAttribOffset(index, pname);
}
function _emscripten_glEnableVertexAttribArray(index) {
 GLctx.enableVertexAttribArray(index);
}
var _BDtoILow = true;
function _atexit(func, arg) {
 __ATEXIT__.unshift({
  func: func,
  arg: arg
 });
}
function _emscripten_glCopyTexSubImage2D(x0, x1, x2, x3, x4, x5, x6, x7) {
 GLctx.copyTexSubImage2D(x0, x1, x2, x3, x4, x5, x6, x7);
}
function _glBindFramebuffer(target, framebuffer) {
 GLctx.bindFramebuffer(target, framebuffer ? GL.framebuffers[framebuffer] : null);
}
function _emscripten_glBlendFuncSeparate(x0, x1, x2, x3) {
 GLctx.blendFuncSeparate(x0, x1, x2, x3);
}
function _glCullFace(x0) {
 GLctx.cullFace(x0);
}
function _emscripten_glColorPointer() {
 Module["printErr"]("missing function: emscripten_glColorPointer");
 abort(-1);
}
function _lstat(path, buf) {
 return _stat(path, buf, true);
}
function _emscripten_glNormalPointer() {
 Module["printErr"]("missing function: emscripten_glNormalPointer");
 abort(-1);
}
function _emscripten_webgl_make_context_current(contextHandle) {
 var success = GL.makeContextCurrent(contextHandle);
 return success ? 0 : -5;
}
var _emscripten_get_longjmp_result = true;
function _emscripten_get_pointerlock_status(pointerlockStatus) {
 if (pointerlockStatus) JSEvents.fillPointerlockChangeEventData(pointerlockStatus);
 if (!document.body.requestPointerLock && !document.body.mozRequestPointerLock && !document.body.webkitRequestPointerLock && !document.body.msRequestPointerLock) {
  return -1;
 }
 return 0;
}
var LOCALE = {
 curr: 0,
 check: (function(locale) {
  if (locale) locale = Pointer_stringify(locale);
  return locale === "C" || locale === "POSIX" || !locale;
 })
};
function _freelocale(locale) {
 _free(locale);
}
function _glAttachShader(program, shader) {
 GLctx.attachShader(GL.programs[program], GL.shaders[shader]);
}
function _fcntl(fildes, cmd, varargs, dup2) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 switch (cmd) {
 case 0:
  var arg = HEAP32[varargs >> 2];
  if (arg < 0) {
   ___setErrNo(ERRNO_CODES.EINVAL);
   return -1;
  }
  var newStream;
  try {
   newStream = FS.open(stream.path, stream.flags, 0, arg);
  } catch (e) {
   FS.handleFSError(e);
   return -1;
  }
  return newStream.fd;
 case 1:
 case 2:
  return 0;
 case 3:
  return stream.flags;
 case 4:
  var arg = HEAP32[varargs >> 2];
  stream.flags |= arg;
  return 0;
 case 12:
 case 12:
  var arg = HEAP32[varargs >> 2];
  var offset = 0;
  HEAP16[arg + offset >> 1] = 2;
  return 0;
 case 13:
 case 14:
 case 13:
 case 14:
  return 0;
 case 8:
 case 9:
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 default:
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 return -1;
}
function _emscripten_glGetVertexAttribfv(index, pname, params) {
 var data = GLctx.getVertexAttrib(index, pname);
 if (typeof data == "number") {
  HEAPF32[params >> 2] = data;
 } else {
  for (var i = 0; i < data.length; i++) {
   HEAPF32[params + i >> 2] = data[i];
  }
 }
}
function _emscripten_set_keyup_callback(target, userData, useCapture, callbackfunc) {
 JSEvents.registerKeyEventCallback(target, userData, useCapture, callbackfunc, 3, "keyup");
 return 0;
}
function _glDrawElements(mode, count, type, indices) {
 GLctx.drawElements(mode, count, type, indices);
}
function _sigaction(signum, act, oldact) {
 Module.printErr("Calling stub instead of sigaction()");
 return 0;
}
function _emscripten_get_fullscreen_status(fullscreenStatus) {
 if (typeof JSEvents.fullscreenEnabled() === "undefined") return -1;
 JSEvents.fillFullscreenChangeEventData(fullscreenStatus);
 return 0;
}
var _cos = Math_cos;
function _glUniform1iv(location, count, value) {
 location = GL.uniforms[location];
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform1iv(location, value);
}
function _emscripten_glGetVertexAttribiv(index, pname, params) {
 var data = GLctx.getVertexAttrib(index, pname);
 if (typeof data == "number" || typeof data == "boolean") {
  HEAP32[params >> 2] = data;
 } else {
  for (var i = 0; i < data.length; i++) {
   HEAP32[params + i >> 2] = data[i];
  }
 }
}
function _glReadBuffer(src) {
 GLctx.readBuffer(src);
}
function _glGenerateMipmap(x0) {
 GLctx.generateMipmap(x0);
}
function _emscripten_glGetPointerv() {
 Module["printErr"]("missing function: emscripten_glGetPointerv");
 abort(-1);
}
function _emscripten_glStencilFuncSeparate(x0, x1, x2, x3) {
 GLctx.stencilFuncSeparate(x0, x1, x2, x3);
}
Module["_i64Subtract"] = _i64Subtract;
var _fabsf = Math_abs;
Module["_i64Add"] = _i64Add;
function _glUnmapBuffer() {
 Module["printErr"]("missing function: glUnmapBuffer");
 abort(-1);
}
function ___resumeException(ptr) {
 if (!EXCEPTIONS.last) {
  EXCEPTIONS.last = ptr;
 }
 EXCEPTIONS.clearRef(EXCEPTIONS.deAdjust(ptr));
 throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
}
function ___cxa_find_matching_catch() {
 var thrown = EXCEPTIONS.last;
 if (!thrown) {
  return (asm["setTempRet0"](0), 0) | 0;
 }
 var info = EXCEPTIONS.infos[thrown];
 var throwntype = info.type;
 if (!throwntype) {
  return (asm["setTempRet0"](0), thrown) | 0;
 }
 var typeArray = Array.prototype.slice.call(arguments);
 var pointer = Module["___cxa_is_pointer_type"](throwntype);
 if (!___cxa_find_matching_catch.buffer) ___cxa_find_matching_catch.buffer = _malloc(4);
 HEAP32[___cxa_find_matching_catch.buffer >> 2] = thrown;
 thrown = ___cxa_find_matching_catch.buffer;
 for (var i = 0; i < typeArray.length; i++) {
  if (typeArray[i] && Module["___cxa_can_catch"](typeArray[i], throwntype, thrown)) {
   thrown = HEAP32[thrown >> 2];
   info.adjusted = thrown;
   return (asm["setTempRet0"](typeArray[i]), thrown) | 0;
  }
 }
 thrown = HEAP32[thrown >> 2];
 return (asm["setTempRet0"](throwntype), thrown) | 0;
}
function ___cxa_throw(ptr, type, destructor) {
 EXCEPTIONS.infos[ptr] = {
  ptr: ptr,
  adjusted: ptr,
  type: type,
  destructor: destructor,
  refcount: 0
 };
 EXCEPTIONS.last = ptr;
 if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
  __ZSt18uncaught_exceptionv.uncaught_exception = 1;
 } else {
  __ZSt18uncaught_exceptionv.uncaught_exception++;
 }
 throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
}
function _emscripten_glGetFloatv(name_, p) {
 return GL.get(name_, p, "Float");
}
function _chmod(path, mode, dontResolveLastLink) {
 path = typeof path !== "string" ? Pointer_stringify(path) : path;
 try {
  FS.chmod(path, mode);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _emscripten_glDisableVertexAttribArray(index) {
 GLctx.disableVertexAttribArray(index);
}
function _glBindRenderbuffer(target, renderbuffer) {
 GLctx.bindRenderbuffer(target, renderbuffer ? GL.renderbuffers[renderbuffer] : null);
}
function _emscripten_glGenRenderbuffers(n, renderbuffers) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.renderbuffers);
  var renderbuffer = GLctx.createRenderbuffer();
  renderbuffer.name = id;
  GL.renderbuffers[id] = renderbuffer;
  HEAP32[renderbuffers + i * 4 >> 2] = id;
 }
}
function _emscripten_glBlendEquation(x0) {
 GLctx.blendEquation(x0);
}
function _emscripten_glDepthFunc(x0) {
 GLctx.depthFunc(x0);
}
function _gethostname(name, namelen) {
 var host = "emscripten";
 if (typeof window !== "undefined" && window.location.host) {
  host = window.location.host;
 }
 var length = Math.min(namelen, host.length);
 for (var i = 0; i < length; i++) {
  HEAP8[name + i >> 0] = host.charCodeAt(i);
 }
 if (namelen > length) {
  HEAP8[name + i >> 0] = 0;
  return 0;
 } else {
  ___setErrNo(ERRNO_CODES.ENAMETOOLONG);
  return -1;
 }
}
function _fputs(s, stream) {
 var fd = _fileno(stream);
 return _write(fd, s, _strlen(s));
}
function _puts(s) {
 var stdout = HEAP32[_stdout >> 2];
 var ret = _fputs(s, stdout);
 if (ret < 0) {
  return ret;
 } else {
  var newlineRet = _fputc(10, stdout);
  return newlineRet < 0 ? -1 : ret + 1;
 }
}
function _emscripten_glUniform4iv(location, count, value) {
 location = GL.uniforms[location];
 count *= 4;
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform4iv(location, value);
}
function _emscripten_glLoadIdentity() {
 throw "Legacy GL function (glLoadIdentity) called. If you want legacy GL emulation, you need to compile with -s LEGACY_GL_EMULATION=1 to enable legacy GL emulation.";
}
function _emscripten_glVertexAttribDivisor(index, divisor) {
 GL.currentContext.instancedArraysExt.vertexAttribDivisorANGLE(index, divisor);
}
function _glActiveTexture(x0) {
 GLctx.activeTexture(x0);
}
function _glEnableVertexAttribArray(index) {
 GLctx.enableVertexAttribArray(index);
}
function _glReadPixels(x, y, width, height, format, type, pixels) {
 var data = GL.getTexPixelData(type, format, width, height, pixels, format);
 if (!data.pixels) {
  GL.recordError(1280);
  return;
 }
 GLctx.readPixels(x, y, width, height, format, type, data.pixels);
}
function _emscripten_glDrawElementsInstanced(mode, count, type, indices, primcount) {
 GL.currentContext.instancedArraysExt.drawElementsInstancedANGLE(mode, count, type, indices, primcount);
}
function _glRenderbufferStorageMultisample(target, samples, internalformat, width, height) {
 GLctx.renderbufferStorageMultisample(target, samples, internalformat, width, height);
}
var _emscripten_prep_setjmp = true;
function _glUniformMatrix3fv(location, count, transpose, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[8];
  for (var i = 0; i < 9; i++) {
   view[i] = HEAPF32[value + i * 4 >> 2];
  }
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 36 >> 2);
 }
 GLctx.uniformMatrix3fv(location, transpose, view);
}
var _asinf = Math_asin;
function _SDL_GL_SwapBuffers() {
 if (Browser.doSwapBuffers) Browser.doSwapBuffers();
}
function _emscripten_webgl_create_context(target, attributes) {
 var contextAttributes = {};
 contextAttributes.alpha = !!HEAP32[attributes >> 2];
 contextAttributes.depth = !!HEAP32[attributes + 4 >> 2];
 contextAttributes.stencil = !!HEAP32[attributes + 8 >> 2];
 contextAttributes.antialias = !!HEAP32[attributes + 12 >> 2];
 contextAttributes.premultipliedAlpha = !!HEAP32[attributes + 16 >> 2];
 contextAttributes.preserveDrawingBuffer = !!HEAP32[attributes + 20 >> 2];
 contextAttributes.preferLowPowerToHighPerformance = !!HEAP32[attributes + 24 >> 2];
 contextAttributes.failIfMajorPerformanceCaveat = !!HEAP32[attributes + 28 >> 2];
 contextAttributes.majorVersion = HEAP32[attributes + 32 >> 2];
 contextAttributes.minorVersion = HEAP32[attributes + 36 >> 2];
 var enableExtensionsByDefault = HEAP32[attributes + 40 >> 2];
 if (!target) {
  target = Module["canvas"];
 } else {
  target = JSEvents.findEventTarget(target);
 }
 var contextHandle = GL.createContext(target, contextAttributes);
 return contextHandle;
}
function _emscripten_glClearStencil(x0) {
 GLctx.clearStencil(x0);
}
function _emscripten_glDetachShader(program, shader) {
 GLctx.detachShader(GL.programs[program], GL.shaders[shader]);
}
function _JS_Sound_Stop(channelInstance) {
 if (WEBAudio.audioWebEnabled == 0) return;
 var channel = WEBAudio.audioInstances[channelInstance];
 if (channel.source.buffer) {
  channel.source.stop(0);
  channel.source.onended = (function() {});
  channel.setup();
 }
}
function _emscripten_glDeleteVertexArrays(n, vaos) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[vaos + i * 4 >> 2];
  GL.currentContext.vaoExt.deleteVertexArrayOES(GL.vaos[id]);
  GL.vaos[id] = null;
 }
}
var _tanf = Math_tan;
function _glStencilFunc(x0, x1, x2) {
 GLctx.stencilFunc(x0, x1, x2);
}
function _pthread_mutex_destroy() {}
function _glUniformBlockBinding(program, uniformBlockIndex, uniformBlockBinding) {
 program = GL.programs[program];
 GLctx.uniformBlockBinding(program, uniformBlockIndex, uniformBlockBinding);
}
function _glUniform1fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[0];
  view[0] = HEAPF32[value >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 4 >> 2);
 }
 GLctx.uniform1fv(location, view);
}
function _emscripten_glGenerateMipmap(x0) {
 GLctx.generateMipmap(x0);
}
function _emscripten_glCullFace(x0) {
 GLctx.cullFace(x0);
}
function _rename(old_path, new_path) {
 old_path = Pointer_stringify(old_path);
 new_path = Pointer_stringify(new_path);
 try {
  FS.rename(old_path, new_path);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _emscripten_glUseProgram(program) {
 GLctx.useProgram(program ? GL.programs[program] : null);
}
function _emscripten_glUniformMatrix4fv(location, count, transpose, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[15];
  for (var i = 0; i < 16; i++) {
   view[i] = HEAPF32[value + i * 4 >> 2];
  }
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 64 >> 2);
 }
 GLctx.uniformMatrix4fv(location, transpose, view);
}
function _emscripten_glUniform2fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[1];
  view[0] = HEAPF32[value >> 2];
  view[1] = HEAPF32[value + 4 >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 8 >> 2);
 }
 GLctx.uniform2fv(location, view);
}
function _glGetShaderInfoLog(shader, maxLength, length, infoLog) {
 var log = GLctx.getShaderInfoLog(GL.shaders[shader]);
 if (!log) log = "(unknown error)";
 log = log.substr(0, maxLength - 1);
 if (maxLength > 0 && infoLog) {
  writeStringToMemory(log, infoLog);
  if (length) HEAP32[length >> 2] = log.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
}
function _emscripten_glFramebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer) {
 GLctx.framebufferRenderbuffer(target, attachment, renderbuffertarget, GL.renderbuffers[renderbuffer]);
}
function _emscripten_glDeleteFramebuffers(n, framebuffers) {
 for (var i = 0; i < n; ++i) {
  var id = HEAP32[framebuffers + i * 4 >> 2];
  var framebuffer = GL.framebuffers[id];
  if (!framebuffer) continue;
  GLctx.deleteFramebuffer(framebuffer);
  framebuffer.name = 0;
  GL.framebuffers[id] = null;
 }
}
function _emscripten_glUniform2iv(location, count, value) {
 location = GL.uniforms[location];
 count *= 2;
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform2iv(location, value);
}
function _emscripten_asm_const(code) {
 Runtime.getAsmConst(code, 0)();
}
function _emscripten_glVertexAttrib1fv(index, v) {
 v = HEAPF32.subarray(v >> 2, v + 4 >> 2);
 GLctx.vertexAttrib1fv(index, v);
}
var _fabs = Math_abs;
function _getc() {
 return _fgetc.apply(null, arguments);
}
var _sqrt = Math_sqrt;
var cttz_i8 = allocate([ 8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0 ], "i8", ALLOC_STATIC);
Module["_llvm_cttz_i32"] = _llvm_cttz_i32;
function _emscripten_asm_const_int(code) {
 var args = Array.prototype.slice.call(arguments, 1);
 return Runtime.getAsmConst(code, args.length).apply(null, args) | 0;
}
function _glGenBuffers(n, buffers) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.buffers);
  var buffer = GLctx.createBuffer();
  buffer.name = id;
  GL.buffers[id] = buffer;
  HEAP32[buffers + i * 4 >> 2] = id;
 }
}
function _glCreateProgram() {
 var id = GL.getNewId(GL.programs);
 var program = GLctx.createProgram();
 program.name = id;
 GL.programs[id] = program;
 return id;
}
function _glTexImage3D(target, level, internalFormat, width, height, depth, border, format, type, data) {
 GLctx.texImage3D(target, level, internalFormat, width, height, depth, border, format, type, HEAPU8.subarray(data));
}
function _emscripten_glGetBufferParameteriv(target, value, data) {
 HEAP32[data >> 2] = GLctx.getBufferParameter(target, value);
}
function _emscripten_glGetUniformiv(program, location, params) {
 var data = GLctx.getUniform(GL.programs[program], GL.uniforms[location]);
 if (typeof data == "number" || typeof data == "boolean") {
  HEAP32[params >> 2] = data;
 } else {
  for (var i = 0; i < data.length; i++) {
   HEAP32[params + i >> 2] = data[i];
  }
 }
}
function _pthread_cond_wait() {
 return 0;
}
var __currentFullscreenStrategy = {};
function _emscripten_exit_fullscreen() {
 if (typeof JSEvents.fullscreenEnabled() === "undefined") return -1;
 JSEvents.removeDeferredCalls(JSEvents.requestFullscreen);
 if (document.exitFullscreen) {
  document.exitFullscreen();
 } else if (document.msExitFullscreen) {
  document.msExitFullscreen();
 } else if (document.mozCancelFullScreen) {
  document.mozCancelFullScreen();
 } else if (document.webkitExitFullscreen) {
  document.webkitExitFullscreen();
 } else {
  return -1;
 }
 if (__currentFullscreenStrategy.canvasResizedCallback) {
  Runtime.dynCall("iiii", __currentFullscreenStrategy.canvasResizedCallback, [ 37, 0, __currentFullscreenStrategy.canvasResizedCallbackUserData ]);
 }
 return 0;
}
function ___ctype_tolower_loc() {
 var me = ___ctype_tolower_loc;
 if (!me.ret) {
  var values = [ 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255 ];
  var i32size = 4;
  var arr = _malloc(values.length * i32size);
  for (var i = 0; i < values.length; i++) {
   HEAP32[arr + i * i32size >> 2] = values[i];
  }
  me.ret = allocate([ arr + 128 * i32size ], "i32*", ALLOC_NORMAL);
 }
 return me.ret;
}
var _emscripten_setjmp = true;
function _emscripten_glUniform1fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[0];
  view[0] = HEAPF32[value >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 4 >> 2);
 }
 GLctx.uniform1fv(location, view);
}
function _glDeleteBuffers(n, buffers) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[buffers + i * 4 >> 2];
  var buffer = GL.buffers[id];
  if (!buffer) continue;
  GLctx.deleteBuffer(buffer);
  buffer.name = 0;
  GL.buffers[id] = null;
  if (id == GL.currArrayBuffer) GL.currArrayBuffer = 0;
  if (id == GL.currElementArrayBuffer) GL.currElementArrayBuffer = 0;
 }
}
function _glScissor(x0, x1, x2, x3) {
 GLctx.scissor(x0, x1, x2, x3);
}
function _emscripten_glCheckFramebufferStatus(x0) {
 return GLctx.checkFramebufferStatus(x0);
}
function _emscripten_glDeleteProgram(id) {
 if (!id) return;
 var program = GL.programs[id];
 if (!program) {
  GL.recordError(1281);
  return;
 }
 GLctx.deleteProgram(program);
 program.name = 0;
 GL.programs[id] = null;
 GL.programInfos[id] = null;
}
function _emscripten_glDisable(x0) {
 GLctx.disable(x0);
}
function _glClearColor(x0, x1, x2, x3) {
 GLctx.clearColor(x0, x1, x2, x3);
}
function _emscripten_glGetActiveAttrib(program, index, bufSize, length, size, type, name) {
 program = GL.programs[program];
 var info = GLctx.getActiveAttrib(program, index);
 if (!info) return;
 var infoname = info.name.slice(0, Math.max(0, bufSize - 1));
 if (bufSize > 0 && name) {
  writeStringToMemory(infoname, name);
  if (length) HEAP32[length >> 2] = infoname.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
 if (size) HEAP32[size >> 2] = info.size;
 if (type) HEAP32[type >> 2] = info.type;
}
function _emscripten_glLineWidth(x0) {
 GLctx.lineWidth(x0);
}
function _emscripten_glGetString(name_) {
 if (GL.stringCache[name_]) return GL.stringCache[name_];
 var ret;
 switch (name_) {
 case 7936:
 case 7937:
 case 7938:
  ret = allocate(intArrayFromString(GLctx.getParameter(name_)), "i8", ALLOC_NORMAL);
  break;
 case 7939:
  var exts = GLctx.getSupportedExtensions();
  var gl_exts = [];
  for (i in exts) {
   gl_exts.push(exts[i]);
   gl_exts.push("GL_" + exts[i]);
  }
  ret = allocate(intArrayFromString(gl_exts.join(" ")), "i8", ALLOC_NORMAL);
  break;
 case 35724:
  ret = allocate(intArrayFromString("OpenGL ES GLSL 1.00 (WebGL)"), "i8", ALLOC_NORMAL);
  break;
 default:
  GL.recordError(1280);
  return 0;
 }
 GL.stringCache[name_] = ret;
 return ret;
}
function _emscripten_glGetAttribLocation(program, name) {
 program = GL.programs[program];
 name = Pointer_stringify(name);
 return GLctx.getAttribLocation(program, name);
}
function _emscripten_glGetIntegerv(name_, p) {
 return GL.get(name_, p, "Integer");
}
function _emscripten_get_now_res() {
 if (ENVIRONMENT_IS_NODE) {
  return 1;
 } else if (typeof dateNow !== "undefined" || (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) && self["performance"] && self["performance"]["now"]) {
  return 1e3;
 } else {
  return 1e3 * 1e3;
 }
}
function _clock_getres(clk_id, res) {
 var nsec;
 if (clk_id === 0) {
  nsec = 1e3 * 1e3;
 } else if (clk_id === 1 && _emscripten_get_now_is_monotonic()) {
  nsec = _emscripten_get_now_res();
 } else {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 HEAP32[res >> 2] = nsec / 1e9 | 0;
 HEAP32[res + 4 >> 2] = nsec;
 return 0;
}
function _JS_Sound_SetLoop(channelInstance, loop) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioInstances[channelInstance].source.loop = loop;
}
function _JS_Sound_Load_PCM(channels, length, sampleRate, ptr) {
 if (WEBAudio.audioWebEnabled == 0) return 0;
 var sound = {
  buffer: WEBAudio.audioContext.createBuffer(channels, length, sampleRate),
  error: false
 };
 for (var i = 0; i < channels; i++) {
  var offs = (ptr >> 2) + length * i;
  sound.buffer.copyToChannel(HEAPF32.subarray(offs, offs + length), i, 0);
 }
 var instance = WEBAudio.audioInstances.push(sound) - 1;
 return instance;
}
function _glUniform2fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[1];
  view[0] = HEAPF32[value >> 2];
  view[1] = HEAPF32[value + 4 >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 8 >> 2);
 }
 GLctx.uniform2fv(location, view);
}
function _emscripten_glReadPixels(x, y, width, height, format, type, pixels) {
 var data = GL.getTexPixelData(type, format, width, height, pixels, format);
 if (!data.pixels) {
  GL.recordError(1280);
  return;
 }
 GLctx.readPixels(x, y, width, height, format, type, data.pixels);
}
function __setLetterbox(element, topBottom, leftRight) {
 if (JSEvents.isInternetExplorer()) {
  element.style.marginLeft = element.style.marginRight = leftRight + "px";
  element.style.marginTop = element.style.marginBottom = topBottom + "px";
 } else {
  element.style.paddingLeft = element.style.paddingRight = leftRight + "px";
  element.style.paddingTop = element.style.paddingBottom = topBottom + "px";
 }
}
function _emscripten_do_request_fullscreen(target, strategy) {
 if (typeof JSEvents.fullscreenEnabled() === "undefined") return -1;
 if (!JSEvents.fullscreenEnabled()) return -3;
 if (!target) target = "#canvas";
 target = JSEvents.findEventTarget(target);
 if (!target) return -4;
 if (!target.requestFullscreen && !target.msRequestFullscreen && !target.mozRequestFullScreen && !target.mozRequestFullscreen && !target.webkitRequestFullscreen) {
  return -3;
 }
 var canPerformRequests = JSEvents.canPerformEventHandlerRequests();
 if (!canPerformRequests) {
  if (strategy.deferUntilInEventHandler) {
   JSEvents.deferCall(JSEvents.requestFullscreen, 1, [ target, strategy ]);
   return 1;
  } else {
   return -2;
  }
 }
 return JSEvents.requestFullscreen(target, strategy);
}
function _emscripten_request_fullscreen(target, deferUntilInEventHandler) {
 var strategy = {};
 strategy.scaleMode = 0;
 strategy.canvasResolutionScaleMode = 0;
 strategy.filteringMode = 0;
 strategy.deferUntilInEventHandler = deferUntilInEventHandler;
 return _emscripten_do_request_fullscreen(target, strategy);
}
function _emscripten_glGetError() {
 if (GL.lastError) {
  var error = GL.lastError;
  GL.lastError = 0;
  return error;
 } else {
  return GLctx.getError();
 }
}
function _emscripten_glFramebufferTexture2D(target, attachment, textarget, texture, level) {
 GLctx.framebufferTexture2D(target, attachment, textarget, GL.textures[texture], level);
}
function _glClearDepthf(x0) {
 GLctx.clearDepth(x0);
}
function _glGenTransformFeedbacks(n, ids) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.transformFeedbacks);
  var transformFeedback = GLctx.createTransformFeedback();
  transformFeedback.name = id;
  GL.transformFeedbacks[id] = transformFeedback;
  HEAP32[ids + i * 4 >> 2] = id;
 }
}
Module["_memmove"] = _memmove;
function _calloc(n, s) {
 var ret = _malloc(n * s);
 _memset(ret, 0, n * s);
 return ret;
}
Module["_calloc"] = _calloc;
function _newlocale(mask, locale, base) {
 if (!LOCALE.check(locale)) {
  ___setErrNo(ERRNO_CODES.ENOENT);
  return 0;
 }
 if (!base) base = _calloc(1, 4);
 return base;
}
function _glColorMask(x0, x1, x2, x3) {
 GLctx.colorMask(x0, x1, x2, x3);
}
function _glCompressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, imageSize, data) {
 if (data) {
  data = HEAPU8.subarray(data, data + imageSize);
 } else {
  data = null;
 }
 GLctx["compressedTexSubImage2D"](target, level, xoffset, yoffset, width, height, format, data);
}
function _emscripten_glClearDepthf(x0) {
 GLctx.clearDepth(x0);
}
function _glProgramBinary() {
 Module["printErr"]("missing function: glProgramBinary");
 abort(-1);
}
function _JS_SystemInfo_GetHeight() {
 return systemInfo.get().height;
}
function _JS_SystemInfo_GetWidth() {
 return systemInfo.get().width;
}
function _printf(format, varargs) {
 var stdout = HEAP32[_stdout >> 2];
 return _fprintf(stdout, format, varargs);
}
function _emscripten_glGetUniformfv(program, location, params) {
 var data = GLctx.getUniform(GL.programs[program], GL.uniforms[location]);
 if (typeof data == "number") {
  HEAPF32[params >> 2] = data;
 } else {
  for (var i = 0; i < data.length; i++) {
   HEAPF32[params + i >> 2] = data[i];
  }
 }
}
function _readdir_r(dirp, entry, result) {
 var stream = FS.getStreamFromPtr(dirp);
 if (!stream) {
  return ___setErrNo(ERRNO_CODES.EBADF);
 }
 if (!stream.currReading) {
  try {
   stream.currReading = FS.readdir(stream.path);
  } catch (e) {
   return FS.handleFSError(e);
  }
 }
 if (stream.position < 0 || stream.position >= stream.currReading.length) {
  HEAP32[result >> 2] = 0;
  return 0;
 }
 var id;
 var type;
 var name = stream.currReading[stream.position++];
 if (!name.indexOf(".")) {
  id = 1;
  type = 4;
 } else {
  try {
   var child = FS.lookupNode(stream.node, name);
  } catch (e) {
   return _readdir_r(dirp, entry, result);
  }
  id = child.id;
  type = FS.isChrdev(child.mode) ? 2 : FS.isDir(child.mode) ? 4 : FS.isLink(child.mode) ? 10 : 8;
 }
 HEAP32[entry >> 2] = id;
 HEAP32[entry + 4 >> 2] = stream.position;
 HEAP32[entry + 8 >> 2] = name.length + 1;
 for (var i = 0; i < name.length; i++) {
  HEAP8[entry + 11 + i >> 0] = name.charCodeAt(i);
 }
 HEAP8[entry + 11 + i >> 0] = 0;
 HEAP8[entry + 10 >> 0] = type;
 HEAP32[result >> 2] = entry;
 return 0;
}
function _readdir(dirp) {
 var stream = FS.getStreamFromPtr(dirp);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return 0;
 }
 if (!_readdir.entry) _readdir.entry = _malloc(268);
 if (!_readdir.result) _readdir.result = _malloc(4);
 var err = _readdir_r(dirp, _readdir.entry, _readdir.result);
 if (err) {
  ___setErrNo(err);
  return 0;
 }
 return HEAP32[_readdir.result >> 2];
}
function _glDepthFunc(x0) {
 GLctx.depthFunc(x0);
}
function _emscripten_exit_pointerlock() {
 JSEvents.removeDeferredCalls(JSEvents.requestPointerLock);
 if (document.exitPointerLock) {
  document.exitPointerLock();
 } else if (document.msExitPointerLock) {
  document.msExitPointerLock();
 } else if (document.mozExitPointerLock) {
  document.mozExitPointerLock();
 } else if (document.webkitExitPointerLock) {
  document.webkitExitPointerLock();
 } else {
  return -1;
 }
 return 0;
}
function _emscripten_glBindBuffer(target, buffer) {
 var bufferObj = buffer ? GL.buffers[buffer] : null;
 GLctx.bindBuffer(target, bufferObj);
}
function _SDL_JoystickNumAxes(joystick) {
 var gamepad = SDL.getGamepad(joystick - 1);
 if (gamepad) {
  return gamepad.axes.length;
 }
 return 0;
}
function _emscripten_glFinish() {
 GLctx.finish();
}
function _tcsetattr(fildes, optional_actions, termios_p) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 if (!stream.tty) {
  ___setErrNo(ERRNO_CODES.ENOTTY);
  return -1;
 }
 return 0;
}
function _emscripten_glUniform1iv(location, count, value) {
 location = GL.uniforms[location];
 value = HEAP32.subarray(value >> 2, value + count * 4 >> 2);
 GLctx.uniform1iv(location, value);
}
function _glUniform4fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[3];
  view[0] = HEAPF32[value >> 2];
  view[1] = HEAPF32[value + 4 >> 2];
  view[2] = HEAPF32[value + 8 >> 2];
  view[3] = HEAPF32[value + 12 >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 16 >> 2);
 }
 GLctx.uniform4fv(location, view);
}
function _emscripten_glTexCoordPointer() {
 Module["printErr"]("missing function: emscripten_glTexCoordPointer");
 abort(-1);
}
function _glBeginTransformFeedback(primitiveMode) {
 GLctx.beginTransformFeedback(primitiveMode);
}
function _ftell(stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 if (FS.isChrdev(stream.node.mode)) {
  ___setErrNo(ERRNO_CODES.ESPIPE);
  return -1;
 } else {
  return stream.position;
 }
}
function __exit(status) {
 Module["exit"](status);
}
function _exit(status) {
 __exit(status);
}
function _pthread_setspecific(key, value) {
 if (!(key in PTHREAD_SPECIFIC)) {
  return ERRNO_CODES.EINVAL;
 }
 PTHREAD_SPECIFIC[key] = value;
 return 0;
}
function _emscripten_glVertexAttrib1f(x0, x1) {
 GLctx.vertexAttrib1f(x0, x1);
}
function _glDeleteTransformFeedbacks(n, ids) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[ids + i * 4 >> 2];
  var transformFeedback = GL.transformFeedbacks[id];
  if (!transformFeedback) continue;
  GLctx.deleteTransformFeedback(transformFeedback);
  transformFeedback.name = 0;
  GL.transformFeedbacks[id] = null;
 }
}
function _glCheckFramebufferStatus(x0) {
 return GLctx.checkFramebufferStatus(x0);
}
function _gmtime_r(time, tmPtr) {
 var date = new Date(HEAP32[time >> 2] * 1e3);
 HEAP32[tmPtr >> 2] = date.getUTCSeconds();
 HEAP32[tmPtr + 4 >> 2] = date.getUTCMinutes();
 HEAP32[tmPtr + 8 >> 2] = date.getUTCHours();
 HEAP32[tmPtr + 12 >> 2] = date.getUTCDate();
 HEAP32[tmPtr + 16 >> 2] = date.getUTCMonth();
 HEAP32[tmPtr + 20 >> 2] = date.getUTCFullYear() - 1900;
 HEAP32[tmPtr + 24 >> 2] = date.getUTCDay();
 HEAP32[tmPtr + 36 >> 2] = 0;
 HEAP32[tmPtr + 32 >> 2] = 0;
 var start = Date.UTC(date.getUTCFullYear(), 0, 1, 0, 0, 0, 0);
 var yday = (date.getTime() - start) / (1e3 * 60 * 60 * 24) | 0;
 HEAP32[tmPtr + 28 >> 2] = yday;
 HEAP32[tmPtr + 40 >> 2] = ___tm_timezone;
 return tmPtr;
}
function _gmtime(time) {
 return _gmtime_r(time, ___tm_current);
}
function _glBindAttribLocation(program, index, name) {
 name = Pointer_stringify(name);
 GLctx.bindAttribLocation(GL.programs[program], index, name);
}
function _emscripten_glShaderBinary() {
 GL.recordError(1280);
}
function _emscripten_glBlendColor(x0, x1, x2, x3) {
 GLctx.blendColor(x0, x1, x2, x3);
}
function _glGetQueryObjectuiv(id, pname, params) {
 var query = GL.queries[id];
 var param = GLctx.getQueryParameter(query, pname);
 var ret;
 if (typeof param == "boolean") {
  ret = param ? 1 : 0;
 } else {
  ret = param;
 }
 HEAP32[params >> 2] = ret;
}
function _emscripten_glVertexAttrib2f(x0, x1, x2) {
 GLctx.vertexAttrib2f(x0, x1, x2);
}
function _emscripten_glUniform4fv(location, count, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[3];
  view[0] = HEAPF32[value >> 2];
  view[1] = HEAPF32[value + 4 >> 2];
  view[2] = HEAPF32[value + 8 >> 2];
  view[3] = HEAPF32[value + 12 >> 2];
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 16 >> 2);
 }
 GLctx.uniform4fv(location, view);
}
function _glBufferSubData(target, offset, size, data) {
 GLctx.bufferSubData(target, offset, HEAPU8.subarray(data, data + size));
}
var _emscripten_postinvoke = true;
function _SDL_Init(initFlags) {
 SDL.startTime = Date.now();
 SDL.initFlags = initFlags;
 if (!Module["doNotCaptureKeyboard"]) {
  var keyboardListeningElement = Module["keyboardListeningElement"] || document;
  keyboardListeningElement.addEventListener("keydown", SDL.receiveEvent);
  keyboardListeningElement.addEventListener("keyup", SDL.receiveEvent);
  keyboardListeningElement.addEventListener("keypress", SDL.receiveEvent);
  window.addEventListener("focus", SDL.receiveEvent);
  window.addEventListener("blur", SDL.receiveEvent);
  document.addEventListener("visibilitychange", SDL.receiveEvent);
 }
 if (initFlags & 512) {
  addEventListener("gamepadconnected", (function() {}));
 }
 window.addEventListener("unload", SDL.receiveEvent);
 SDL.keyboardState = _malloc(65536);
 _memset(SDL.keyboardState, 0, 65536);
 SDL.DOMEventToSDLEvent["keydown"] = 768;
 SDL.DOMEventToSDLEvent["keyup"] = 769;
 SDL.DOMEventToSDLEvent["keypress"] = 771;
 SDL.DOMEventToSDLEvent["mousedown"] = 1025;
 SDL.DOMEventToSDLEvent["mouseup"] = 1026;
 SDL.DOMEventToSDLEvent["mousemove"] = 1024;
 SDL.DOMEventToSDLEvent["wheel"] = 1027;
 SDL.DOMEventToSDLEvent["touchstart"] = 1792;
 SDL.DOMEventToSDLEvent["touchend"] = 1793;
 SDL.DOMEventToSDLEvent["touchmove"] = 1794;
 SDL.DOMEventToSDLEvent["unload"] = 256;
 SDL.DOMEventToSDLEvent["resize"] = 28673;
 SDL.DOMEventToSDLEvent["visibilitychange"] = 512;
 SDL.DOMEventToSDLEvent["focus"] = 512;
 SDL.DOMEventToSDLEvent["blur"] = 512;
 SDL.DOMEventToSDLEvent["joystick_axis_motion"] = 1536;
 SDL.DOMEventToSDLEvent["joystick_button_down"] = 1539;
 SDL.DOMEventToSDLEvent["joystick_button_up"] = 1540;
 return 0;
}
function _glMapBufferRange() {
 Module["printErr"]("missing function: glMapBufferRange");
 abort(-1);
}
Module["_strcpy"] = _strcpy;
function _emscripten_glGenVertexArrays(n, arrays) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.vaos);
  var vao = GL.currentContext.vaoExt.createVertexArrayOES();
  vao.name = id;
  GL.vaos[id] = vao;
  HEAP32[arrays + i * 4 >> 2] = id;
 }
}
var _acos = Math_acos;
function _JS_Sound_SetListenerVelocity(x, y, z) {
 if (WEBAudio.audioWebEnabled == 0) return;
 WEBAudio.audioContext.listener.setVelocity(x, y, z);
}
function _emscripten_glBindTexture(target, texture) {
 GLctx.bindTexture(target, texture ? GL.textures[texture] : null);
}
function _emscripten_glUniform1i(location, v0) {
 location = GL.uniforms[location];
 GLctx.uniform1i(location, v0);
}
function _emscripten_glVertexAttrib2fv(index, v) {
 v = HEAPF32.subarray(v >> 2, v + 8 >> 2);
 GLctx.vertexAttrib2fv(index, v);
}
function _setlocale(category, locale) {
 if (LOCALE.check(locale)) {
  if (!_setlocale.ret) _setlocale.ret = allocate(intArrayFromString("C"), "i8", ALLOC_NORMAL);
  return _setlocale.ret;
 }
 return 0;
}
function _emscripten_glDeleteObjectARB() {
 Module["printErr"]("missing function: emscripten_glDeleteObjectARB");
 abort(-1);
}
function _emscripten_glUniform1f(location, v0) {
 location = GL.uniforms[location];
 GLctx.uniform1f(location, v0);
}
function _emscripten_glVertexAttribPointer(index, size, type, normalized, stride, ptr) {
 GLctx.vertexAttribPointer(index, size, type, normalized, stride, ptr);
}
function _glShaderSource(shader, count, string, length) {
 var source = GL.getSource(shader, count, string, length);
 GLctx.shaderSource(GL.shaders[shader], source);
}
function _sigemptyset(set) {
 HEAP32[set >> 2] = 0;
 return 0;
}
function _fopen(filename, mode) {
 var flags;
 mode = Pointer_stringify(mode);
 if (mode[0] == "r") {
  if (mode.indexOf("+") != -1) {
   flags = 2;
  } else {
   flags = 0;
  }
 } else if (mode[0] == "w") {
  if (mode.indexOf("+") != -1) {
   flags = 2;
  } else {
   flags = 1;
  }
  flags |= 64;
  flags |= 512;
 } else if (mode[0] == "a") {
  if (mode.indexOf("+") != -1) {
   flags = 2;
  } else {
   flags = 1;
  }
  flags |= 64;
  flags |= 1024;
 } else {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return 0;
 }
 var fd = _open(filename, flags, allocate([ 511, 0, 0, 0 ], "i32", ALLOC_STACK));
 return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
}
var _sqrtf = Math_sqrt;
function _emscripten_glGenBuffers(n, buffers) {
 for (var i = 0; i < n; i++) {
  var id = GL.getNewId(GL.buffers);
  var buffer = GLctx.createBuffer();
  buffer.name = id;
  GL.buffers[id] = buffer;
  HEAP32[buffers + i * 4 >> 2] = id;
 }
}
var _log = Math_log;
function _SDL_PollEvent(ptr) {
 return SDL.pollEvent(ptr);
}
var PTHREAD_SPECIFIC_NEXT_KEY = 1;
function _pthread_key_create(key, destructor) {
 if (key == 0) {
  return ERRNO_CODES.EINVAL;
 }
 HEAP32[key >> 2] = PTHREAD_SPECIFIC_NEXT_KEY;
 PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
 PTHREAD_SPECIFIC_NEXT_KEY++;
 return 0;
}
function _glBeginQuery(target, id) {
 GLctx.beginQuery(target, id ? GL.queries[id] : null);
}
function _rmdir(path) {
 path = Pointer_stringify(path);
 try {
  FS.rmdir(path);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _glBindBuffer(target, buffer) {
 var bufferObj = buffer ? GL.buffers[buffer] : null;
 GLctx.bindBuffer(target, bufferObj);
}
function _JS_Sound_Create_Channel(callback, userData) {
 if (WEBAudio.audioWebEnabled == 0) return;
 var channel = {
  gain: WEBAudio.audioContext.createGain(),
  panner: WEBAudio.audioContext.createPanner(),
  threeD: false,
  playBuffer: (function(buffer) {
   this.source.buffer = buffer;
   var chan = this;
   this.source.onended = (function() {
    if (callback) Runtime.dynCall("vi", callback, [ userData ]);
    chan.setup();
   });
   this.source.start(0);
  }),
  setup: (function() {
   this.source = WEBAudio.audioContext.createBufferSource();
   this.setupPanning();
  }),
  setupPanning: (function() {
   if (this.threeD) {
    this.source.disconnect();
    this.source.connect(this.panner);
    this.panner.connect(this.gain);
   } else {
    this.panner.disconnect();
    this.source.connect(this.gain);
   }
  })
 };
 channel.panner.rolloffFactor = 0;
 channel.gain.connect(WEBAudio.audioContext.destination);
 channel.setup();
 return WEBAudio.audioInstances.push(channel) - 1;
}
function _SDL_InitSubSystem(flags) {
 return 0;
}
function _pthread_cond_timedwait() {
 return 0;
}
function _emscripten_glAttachShader(program, shader) {
 GLctx.attachShader(GL.programs[program], GL.shaders[shader]);
}
function _glGetProgramBinary() {
 Module["printErr"]("missing function: glGetProgramBinary");
 abort(-1);
}
function _glBufferData(target, size, data, usage) {
 switch (usage) {
 case 35041:
 case 35042:
  usage = 35040;
  break;
 case 35045:
 case 35046:
  usage = 35044;
  break;
 case 35049:
 case 35050:
  usage = 35048;
  break;
 }
 if (!data) {
  GLctx.bufferData(target, size, usage);
 } else {
  GLctx.bufferData(target, HEAPU8.subarray(data, data + size), usage);
 }
}
var _BDtoIHigh = true;
function _emscripten_glGetRenderbufferParameteriv(target, pname, params) {
 HEAP32[params >> 2] = GLctx.getRenderbufferParameter(target, pname);
}
function _glGetError() {
 if (GL.lastError) {
  var error = GL.lastError;
  GL.lastError = 0;
  return error;
 } else {
  return GLctx.getError();
 }
}
function _emscripten_glDrawBuffers(n, bufs) {
 var bufArray = [];
 for (var i = 0; i < n; i++) bufArray.push(HEAP32[bufs + i * 4 >> 2]);
 GL.currentContext.drawBuffersExt(bufArray);
}
function _vfprintf(s, f, va_arg) {
 return _fprintf(s, f, HEAP32[va_arg >> 2]);
}
function _pthread_mutex_unlock() {}
function _emscripten_glBindFramebuffer(target, framebuffer) {
 GLctx.bindFramebuffer(target, framebuffer ? GL.framebuffers[framebuffer] : null);
}
function _emscripten_glBufferSubData(target, offset, size, data) {
 GLctx.bufferSubData(target, offset, HEAPU8.subarray(data, data + size));
}
function _sbrk(bytes) {
 var self = _sbrk;
 if (!self.called) {
  DYNAMICTOP = alignMemoryPage(DYNAMICTOP);
  self.called = true;
  assert(Runtime.dynamicAlloc);
  self.alloc = Runtime.dynamicAlloc;
  Runtime.dynamicAlloc = (function() {
   abort("cannot dynamically allocate, sbrk now has control");
  });
 }
 var ret = DYNAMICTOP;
 if (bytes != 0) self.alloc(bytes);
 return ret;
}
Module["_bitshift64Shl"] = _bitshift64Shl;
function _glGetIntegerv(name_, p) {
 return GL.get(name_, p, "Integer");
}
function _glFrontFace(x0) {
 GLctx.frontFace(x0);
}
function _uselocale(locale) {
 var old = LOCALE.curr;
 if (locale) LOCALE.curr = locale;
 return old;
}
function _glTexImage2D(target, level, internalFormat, width, height, border, format, type, pixels) {
 if (pixels) {
  var data = GL.getTexPixelData(type, format, width, height, pixels, internalFormat);
  pixels = data.pixels;
  internalFormat = data.internalFormat;
 } else {
  pixels = null;
 }
 GLctx.texImage2D(target, level, internalFormat, width, height, border, format, type, pixels);
}
function _glStencilMask(x0) {
 GLctx.stencilMask(x0);
}
var _DtoIHigh = true;
function _pthread_mutexattr_settype() {}
function _pthread_cond_destroy() {}
function _JS_Cursor_SetImage(ptr, length) {
 var binary = "";
 for (var i = 0; i < length; i++) {
  binary += String.fromCharCode(HEAPU8[ptr + i]);
 }
 var base64 = btoa(binary);
 var cursor = "url(data:image/cur;base64," + base64 + "),default";
 _JS_Cursor_SetCursorString(cursor);
}
function _emscripten_glBindVertexArray(vao) {
 GL.currentContext.vaoExt.bindVertexArrayOES(GL.vaos[vao]);
}
function _pipe(fildes) {
 ___setErrNo(ERRNO_CODES.ENOSYS);
 return -1;
}
var _floor = Math_floor;
function _setenv(envname, envval, overwrite) {
 if (envname === 0) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 var name = Pointer_stringify(envname);
 var val = Pointer_stringify(envval);
 if (name === "" || name.indexOf("=") !== -1) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 if (ENV.hasOwnProperty(name) && !overwrite) return 0;
 ENV[name] = val;
 ___buildEnvironment(ENV);
 return 0;
}
function _glEndTransformFeedback() {
 GLctx.endTransformFeedback();
}
function ___cxa_allocate_exception(size) {
 return _malloc(size);
}
function _emscripten_glGetProgramiv(program, pname, p) {
 if (pname == 35716) {
  HEAP32[p >> 2] = GLctx.getProgramInfoLog(GL.programs[program]).length + 1;
 } else if (pname == 35719) {
  var ptable = GL.programInfos[program];
  if (ptable) {
   HEAP32[p >> 2] = ptable.maxUniformLength;
   return;
  } else if (program < GL.counter) {
   GL.recordError(1282);
  } else {
   GL.recordError(1281);
  }
 } else if (pname == 35722) {
  var ptable = GL.programInfos[program];
  if (ptable) {
   if (ptable.maxAttributeLength == -1) {
    var program = GL.programs[program];
    var numAttribs = GLctx.getProgramParameter(program, GLctx.ACTIVE_ATTRIBUTES);
    ptable.maxAttributeLength = 0;
    for (var i = 0; i < numAttribs; ++i) {
     var activeAttrib = GLctx.getActiveAttrib(program, i);
     ptable.maxAttributeLength = Math.max(ptable.maxAttributeLength, activeAttrib.name.length + 1);
    }
   }
   HEAP32[p >> 2] = ptable.maxAttributeLength;
   return;
  } else if (program < GL.counter) {
   GL.recordError(1282);
  } else {
   GL.recordError(1281);
  }
 } else {
  HEAP32[p >> 2] = GLctx.getProgramParameter(GL.programs[program], pname);
 }
}
function _emscripten_glTexImage2D(target, level, internalFormat, width, height, border, format, type, pixels) {
 if (pixels) {
  var data = GL.getTexPixelData(type, format, width, height, pixels, internalFormat);
  pixels = data.pixels;
  internalFormat = data.internalFormat;
 } else {
  pixels = null;
 }
 GLctx.texImage2D(target, level, internalFormat, width, height, border, format, type, pixels);
}
function _glPixelStorei(pname, param) {
 if (pname == 3333) {
  GL.packAlignment = param;
 } else if (pname == 3317) {
  GL.unpackAlignment = param;
 }
 GLctx.pixelStorei(pname, param);
}
function _emscripten_glActiveTexture(x0) {
 GLctx.activeTexture(x0);
}
function _time(ptr) {
 var ret = Date.now() / 1e3 | 0;
 if (ptr) {
  HEAP32[ptr >> 2] = ret;
 }
 return ret;
}
function ___ctype_toupper_loc() {
 var me = ___ctype_toupper_loc;
 if (!me.ret) {
  var values = [ 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255 ];
  var i32size = 4;
  var arr = _malloc(values.length * i32size);
  for (var i = 0; i < values.length; i++) {
   HEAP32[arr + i * i32size >> 2] = values[i];
  }
  me.ret = allocate([ arr + 128 * i32size ], "i32*", ALLOC_NORMAL);
 }
 return me.ret;
}
function _closedir(dirp) {
 var fd = _fileno(dirp);
 var stream = FS.getStream(fd);
 if (stream.currReading) stream.currReading = null;
 return _close(fd);
}
function _readlink(path, buf, bufsize) {
 path = Pointer_stringify(path);
 var str;
 try {
  str = FS.readlink(path);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
 str = str.slice(0, Math.max(0, bufsize - 1));
 writeStringToMemory(str, buf, true);
 return str.length;
}
function _glDepthMask(x0) {
 GLctx.depthMask(x0);
}
function _glUniformMatrix4fv(location, count, transpose, value) {
 location = GL.uniforms[location];
 var view;
 if (count === 1) {
  view = GL.miniTempBufferViews[15];
  for (var i = 0; i < 16; i++) {
   view[i] = HEAPF32[value + i * 4 >> 2];
  }
 } else {
  view = HEAPF32.subarray(value >> 2, value + count * 64 >> 2);
 }
 GLctx.uniformMatrix4fv(location, transpose, view);
}
function _emscripten_glClientActiveTexture() {
 Module["printErr"]("missing function: emscripten_glClientActiveTexture");
 abort(-1);
}
function _glGetActiveUniform(program, index, bufSize, length, size, type, name) {
 program = GL.programs[program];
 var info = GLctx.getActiveUniform(program, index);
 if (!info) return;
 var infoname = info.name.slice(0, Math.max(0, bufSize - 1));
 if (bufSize > 0 && name) {
  writeStringToMemory(infoname, name);
  if (length) HEAP32[length >> 2] = infoname.length;
 } else {
  if (length) HEAP32[length >> 2] = 0;
 }
 if (size) HEAP32[size >> 2] = info.size;
 if (type) HEAP32[type >> 2] = info.type;
}
function _emscripten_glValidateProgram(program) {
 GLctx.validateProgram(GL.programs[program]);
}
function _difftime(time1, time0) {
 return time1 - time0;
}
function _emscripten_webgl_get_current_context() {
 return GL.currentContext ? GL.currentContext.handle : 0;
}
function _emscripten_glPixelStorei(pname, param) {
 if (pname == 3333) {
  GL.packAlignment = param;
 } else if (pname == 3317) {
  GL.unpackAlignment = param;
 }
 GLctx.pixelStorei(pname, param);
}
function _emscripten_glDeleteTextures(n, textures) {
 for (var i = 0; i < n; i++) {
  var id = HEAP32[textures + i * 4 >> 2];
  var texture = GL.textures[id];
  if (!texture) continue;
  GLctx.deleteTexture(texture);
  texture.name = 0;
  GL.textures[id] = null;
 }
}
function _glGetString(name_) {
 if (GL.stringCache[name_]) return GL.stringCache[name_];
 var ret;
 switch (name_) {
 case 7936:
 case 7937:
 case 7938:
  ret = allocate(intArrayFromString(GLctx.getParameter(name_)), "i8", ALLOC_NORMAL);
  break;
 case 7939:
  var exts = GLctx.getSupportedExtensions();
  var gl_exts = [];
  for (i in exts) {
   gl_exts.push(exts[i]);
   gl_exts.push("GL_" + exts[i]);
  }
  ret = allocate(intArrayFromString(gl_exts.join(" ")), "i8", ALLOC_NORMAL);
  break;
 case 35724:
  ret = allocate(intArrayFromString("OpenGL ES GLSL 1.00 (WebGL)"), "i8", ALLOC_NORMAL);
  break;
 default:
  GL.recordError(1280);
  return 0;
 }
 GL.stringCache[name_] = ret;
 return ret;
}
var _FtoILow = true;
function _pthread_self() {
 return 0;
}
function _emscripten_glGetBooleanv(name_, p) {
 return GL.get(name_, p, "Boolean");
}
function _emscripten_glCompileShader(shader) {
 GLctx.compileShader(GL.shaders[shader]);
}
var GLctx;
GL.init();
FS.staticInit();
__ATINIT__.unshift({
 func: (function() {
  if (!Module["noFSInit"] && !FS.init.initialized) FS.init();
 })
});
__ATMAIN__.push({
 func: (function() {
  FS.ignorePermissions = false;
 })
});
__ATEXIT__.push({
 func: (function() {
  FS.quit();
 })
});
Module["FS_createFolder"] = FS.createFolder;
Module["FS_createPath"] = FS.createPath;
Module["FS_createDataFile"] = FS.createDataFile;
Module["FS_createPreloadedFile"] = FS.createPreloadedFile;
Module["FS_createLazyFile"] = FS.createLazyFile;
Module["FS_createLink"] = FS.createLink;
Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4);
HEAP32[___errno_state >> 2] = 0;
__ATINIT__.unshift({
 func: (function() {
  TTY.init();
 })
});
__ATEXIT__.push({
 func: (function() {
  TTY.shutdown();
 })
});
if (ENVIRONMENT_IS_NODE) {
 var fs = require("fs");
 NODEFS.staticInit();
}
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) {
 Browser.requestFullScreen(lockPointer, resizeCanvas);
};
Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) {
 Browser.requestAnimationFrame(func);
};
Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) {
 Browser.setCanvasSize(width, height, noUpdates);
};
Module["pauseMainLoop"] = function Module_pauseMainLoop() {
 Browser.mainLoop.pause();
};
Module["resumeMainLoop"] = function Module_resumeMainLoop() {
 Browser.mainLoop.resume();
};
Module["getUserMedia"] = function Module_getUserMedia() {
 Browser.getUserMedia();
};
___buildEnvironment(ENV);
_fputc.ret = allocate([ 0 ], "i8", ALLOC_STATIC);
__ATINIT__.push({
 func: (function() {
  SOCKFS.root = FS.mount(SOCKFS, {}, null);
 })
});
_fgetc.ret = allocate([ 0 ], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
staticSealed = true;
STACK_MAX = STACK_BASE + TOTAL_STACK;
DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");
function invoke_fiff(index, a1, a2, a3) {
 try {
  return Module["dynCall_fiff"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_iiiiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifiiiiiiiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21) {
 try {
  Module["dynCall_vifiiiiiiiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) {
 try {
  Module["dynCall_viiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iidi(index, a1, a2, a3) {
 try {
  return Module["dynCall_iidi"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fiiiiiifiiiiiif(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14) {
 try {
  return Module["dynCall_fiiiiiifiiiiiif"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiifiif(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  return Module["dynCall_iiiiifiif"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiffi(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  Module["dynCall_viiiiiffi"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) {
 try {
  return Module["dynCall_iiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fif(index, a1, a2) {
 try {
  return Module["dynCall_fif"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fid(index, a1, a2) {
 try {
  return Module["dynCall_fid"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fii(index, a1, a2) {
 try {
  return Module["dynCall_fii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_ddii(index, a1, a2, a3) {
 try {
  return Module["dynCall_ddii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_di(index, a1) {
 try {
  return Module["dynCall_di"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dd(index, a1) {
 try {
  return Module["dynCall_dd"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiifiiii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  return Module["dynCall_iiiifiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viffff(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viffff"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_didd(index, a1, a2, a3) {
 try {
  return Module["dynCall_didd"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dii(index, a1, a2) {
 try {
  return Module["dynCall_dii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_did(index, a1, a2) {
 try {
  return Module["dynCall_did"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dif(index, a1, a2) {
 try {
  return Module["dynCall_dif"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  return Module["dynCall_iiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vdddddd(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_vdddddd"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiiiiffffii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17) {
 try {
  return Module["dynCall_iiiiiiiiiiiiffffii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vdd(index, a1, a2) {
 try {
  Module["dynCall_vdd"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_iiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiifffiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13) {
 try {
  return Module["dynCall_iiiiiifffiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15) {
 try {
  Module["dynCall_vifiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiii(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iiiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiifii(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_iiifii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fifff(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_fifff"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiid(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viiiiid"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viff(index, a1, a2, a3) {
 try {
  Module["dynCall_viff"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifi(index, a1, a2, a3) {
 try {
  Module["dynCall_vifi"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifff(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_vifff"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viiiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_ddd(index, a1, a2) {
 try {
  return Module["dynCall_ddd"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fiii(index, a1, a2, a3) {
 try {
  return Module["dynCall_fiii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iifff(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iifff"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiifiiiiiiiiiffffi(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20) {
 try {
  return Module["dynCall_iiiiiifiiiiiiiiiffffi"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiifiiiif(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) {
 try {
  return Module["dynCall_iiiiifiiiif"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiffffff(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  Module["dynCall_viiffffff"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) {
 try {
  Module["dynCall_viiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diii(index, a1, a2, a3) {
 try {
  return Module["dynCall_diii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12) {
 try {
  Module["dynCall_viiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiii(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_iiiiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiifiif(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  return Module["dynCall_iiiiiifiif"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiii(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiii(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viiiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vif(index, a1, a2) {
 try {
  Module["dynCall_vif"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vid(index, a1, a2) {
 try {
  Module["dynCall_vid"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiidi(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iiidi"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vii(index, a1, a2) {
 try {
  Module["dynCall_vii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viifii(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viifii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fi(index, a1) {
 try {
  return Module["dynCall_fi"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viidi(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viidi"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fiiiiiiiifiiiif(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14) {
 try {
  return Module["dynCall_fiiiiiiiifiiiif"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  Module["dynCall_viiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifiii(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_vifiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiifiiiiiiiiiffffi(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21) {
 try {
  return Module["dynCall_iiiiiiifiiiiiiiiiffffi"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diiii(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_diiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13) {
 try {
  Module["dynCall_viiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiiffffii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15) {
 try {
  return Module["dynCall_iiiiiiiiiiffffii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iid(index, a1, a2) {
 try {
  return Module["dynCall_iid"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iif(index, a1, a2) {
 try {
  return Module["dynCall_iif"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_vifiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiiiii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifiiiiiiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20) {
 try {
  Module["dynCall_vifiiiiiiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  Module["dynCall_viiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiif(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiiiif"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iii(index, a1, a2) {
 try {
  return Module["dynCall_iii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiifii(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_iiiifii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vffff(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_vffff"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiifiiiiif(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) {
 try {
  Module["dynCall_viiiifiiiiif"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viii(index, a1, a2, a3) {
 try {
  Module["dynCall_viii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_v(index) {
 try {
  Module["dynCall_v"](index);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viid(index, a1, a2, a3) {
 try {
  Module["dynCall_viid"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viif(index, a1, a2, a3) {
 try {
  Module["dynCall_viif"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiifi(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_iiiifi"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vd(index, a1) {
 try {
  Module["dynCall_vd"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vf(index, a1) {
 try {
  Module["dynCall_vf"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vi(index, a1) {
 try {
  Module["dynCall_vi"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) {
 try {
  return Module["dynCall_iiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_ii(index, a1) {
 try {
  return Module["dynCall_ii"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiff(index, a1, a2, a3) {
 try {
  return Module["dynCall_iiff"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viifi(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viifi"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiifiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) {
 try {
  return Module["dynCall_iiiiifiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiifiiiiif(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) {
 try {
  return Module["dynCall_iiiiifiiiiif"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iifi(index, a1, a2, a3) {
 try {
  return Module["dynCall_iifi"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiif(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viiif"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiffii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiffii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vifiiiiiiiiiiiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25) {
 try {
  Module["dynCall_vifiiiiiiiiiiiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iifiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_iifiiiii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiifi(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iiifi"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiii(index, a1, a2, a3) {
 try {
  return Module["dynCall_iiii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viifff(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viifff"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiffi(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viiffi"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiif(index, a1, a2, a3) {
 try {
  return Module["dynCall_iiif"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiid(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiiiid"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiifi(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viiifi"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viffffff(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viffffff"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12) {
 try {
  return Module["dynCall_iiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiifiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  return Module["dynCall_iiiifiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiiiiiiiiiiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29) {
 try {
  Module["dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viffffffffffffiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17) {
 try {
  Module["dynCall_viffffffffffffiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vfi(index, a1, a2) {
 try {
  Module["dynCall_vfi"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_i(index) {
 try {
  return Module["dynCall_i"](index);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vff(index, a1, a2) {
 try {
  Module["dynCall_vff"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiifiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  Module["dynCall_viiifiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiifiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18) {
 try {
  return Module["dynCall_iiiiiifiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiffff(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viiffff"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  return Module["dynCall_iiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viffffi(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viffffi"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
Module.asmGlobalArg = {
 "Math": Math,
 "Int8Array": Int8Array,
 "Int16Array": Int16Array,
 "Int32Array": Int32Array,
 "Uint8Array": Uint8Array,
 "Uint16Array": Uint16Array,
 "Uint32Array": Uint32Array,
 "Float32Array": Float32Array,
 "Float64Array": Float64Array
};
Module.asmLibraryArg = {
 "abort": abort,
 "assert": assert,
 "min": Math_min,
 "invoke_fiff": invoke_fiff,
 "invoke_iiiiiii": invoke_iiiiiii,
 "invoke_vifiiiiiiiiiiiiiiiiiii": invoke_vifiiiiiiiiiiiiiiiiiii,
 "invoke_viiiiiiiiiii": invoke_viiiiiiiiiii,
 "invoke_iidi": invoke_iidi,
 "invoke_fiiiiiifiiiiiif": invoke_fiiiiiifiiiiiif,
 "invoke_iiiiifiif": invoke_iiiiifiif,
 "invoke_viiiiiffi": invoke_viiiiiffi,
 "invoke_iiiiiiiiiiii": invoke_iiiiiiiiiiii,
 "invoke_fif": invoke_fif,
 "invoke_fid": invoke_fid,
 "invoke_fii": invoke_fii,
 "invoke_ddii": invoke_ddii,
 "invoke_di": invoke_di,
 "invoke_dd": invoke_dd,
 "invoke_iiiifiiii": invoke_iiiifiiii,
 "invoke_viffff": invoke_viffff,
 "invoke_didd": invoke_didd,
 "invoke_dii": invoke_dii,
 "invoke_did": invoke_did,
 "invoke_dif": invoke_dif,
 "invoke_iiiiiiiiii": invoke_iiiiiiiiii,
 "invoke_vdddddd": invoke_vdddddd,
 "invoke_iiiiiiiiiiiiffffii": invoke_iiiiiiiiiiiiffffii,
 "invoke_vdd": invoke_vdd,
 "invoke_iiiiiiii": invoke_iiiiiiii,
 "invoke_iiiiiifffiiiii": invoke_iiiiiifffiiiii,
 "invoke_vifiiiiiiiiiiiii": invoke_vifiiiiiiiiiiiii,
 "invoke_iiiii": invoke_iiiii,
 "invoke_iiifii": invoke_iiifii,
 "invoke_fifff": invoke_fifff,
 "invoke_viiiiid": invoke_viiiiid,
 "invoke_viff": invoke_viff,
 "invoke_vifi": invoke_vifi,
 "invoke_vifff": invoke_vifff,
 "invoke_viiiiii": invoke_viiiiii,
 "invoke_ddd": invoke_ddd,
 "invoke_fiii": invoke_fiii,
 "invoke_iifff": invoke_iifff,
 "invoke_iiiiiifiiiiiiiiiffffi": invoke_iiiiiifiiiiiiiiiffffi,
 "invoke_iiiiifiiiif": invoke_iiiiifiiiif,
 "invoke_viiffffff": invoke_viiffffff,
 "invoke_viiiiiiiiii": invoke_viiiiiiiiii,
 "invoke_diii": invoke_diii,
 "invoke_viiiiiiiiiiii": invoke_viiiiiiiiiiii,
 "invoke_iiiiii": invoke_iiiiii,
 "invoke_iiiiiifiif": invoke_iiiiiifiif,
 "invoke_viiii": invoke_viiii,
 "invoke_viiiii": invoke_viiiii,
 "invoke_vif": invoke_vif,
 "invoke_vid": invoke_vid,
 "invoke_iiidi": invoke_iiidi,
 "invoke_vii": invoke_vii,
 "invoke_viifii": invoke_viifii,
 "invoke_fi": invoke_fi,
 "invoke_viidi": invoke_viidi,
 "invoke_fiiiiiiiifiiiif": invoke_fiiiiiiiifiiiif,
 "invoke_viiiiiiii": invoke_viiiiiiii,
 "invoke_vifiii": invoke_vifiii,
 "invoke_iiiiiiifiiiiiiiiiffffi": invoke_iiiiiiifiiiiiiiiiffffi,
 "invoke_diiii": invoke_diiii,
 "invoke_viiiiiiiiiiiii": invoke_viiiiiiiiiiiii,
 "invoke_iiiiiiiiiiffffii": invoke_iiiiiiiiiiffffii,
 "invoke_iid": invoke_iid,
 "invoke_iif": invoke_iif,
 "invoke_vifiiii": invoke_vifiiii,
 "invoke_viiiiiii": invoke_viiiiiii,
 "invoke_vifiiiiiiiiiiiiiiiiii": invoke_vifiiiiiiiiiiiiiiiiii,
 "invoke_viiiiiiiii": invoke_viiiiiiiii,
 "invoke_viiiiiif": invoke_viiiiiif,
 "invoke_iii": invoke_iii,
 "invoke_iiiifii": invoke_iiiifii,
 "invoke_vffff": invoke_vffff,
 "invoke_viiiifiiiiif": invoke_viiiifiiiiif,
 "invoke_viii": invoke_viii,
 "invoke_v": invoke_v,
 "invoke_viid": invoke_viid,
 "invoke_viif": invoke_viif,
 "invoke_iiiifi": invoke_iiiifi,
 "invoke_vd": invoke_vd,
 "invoke_vf": invoke_vf,
 "invoke_vi": invoke_vi,
 "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii,
 "invoke_ii": invoke_ii,
 "invoke_iiff": invoke_iiff,
 "invoke_viifi": invoke_viifi,
 "invoke_iiiiifiiiiii": invoke_iiiiifiiiiii,
 "invoke_iiiiifiiiiif": invoke_iiiiifiiiiif,
 "invoke_iifi": invoke_iifi,
 "invoke_viiif": invoke_viiif,
 "invoke_viiiffii": invoke_viiiffii,
 "invoke_vifiiiiiiiiiiiiiiiiiiiiiii": invoke_vifiiiiiiiiiiiiiiiiiiiiiii,
 "invoke_iifiiiii": invoke_iifiiiii,
 "invoke_iiifi": invoke_iiifi,
 "invoke_iiii": invoke_iiii,
 "invoke_viifff": invoke_viifff,
 "invoke_viiffi": invoke_viiffi,
 "invoke_iiif": invoke_iiif,
 "invoke_viiiiiid": invoke_viiiiiid,
 "invoke_viiifi": invoke_viiifi,
 "invoke_viffffff": invoke_viffffff,
 "invoke_iiiiiiiiiiiii": invoke_iiiiiiiiiiiii,
 "invoke_iiiifiiiii": invoke_iiiifiiiii,
 "invoke_viiiiiiiiiiiiiiiiiiiiiiiiiiiii": invoke_viiiiiiiiiiiiiiiiiiiiiiiiiiiii,
 "invoke_viffffffffffffiiii": invoke_viffffffffffffiiii,
 "invoke_vfi": invoke_vfi,
 "invoke_i": invoke_i,
 "invoke_vff": invoke_vff,
 "invoke_viiifiiiii": invoke_viiifiiiii,
 "invoke_iiiiiifiiiiiiiiiiii": invoke_iiiiiifiiiiiiiiiiii,
 "invoke_viiffff": invoke_viiffff,
 "invoke_iiiiiiiii": invoke_iiiiiiiii,
 "invoke_viffffi": invoke_viffffi,
 "_emscripten_glGetTexParameterfv": _emscripten_glGetTexParameterfv,
 "_glClearStencil": _glClearStencil,
 "_emscripten_glBlendFuncSeparate": _emscripten_glBlendFuncSeparate,
 "_emscripten_glGetIntegerv": _emscripten_glGetIntegerv,
 "_glUniformMatrix4fv": _glUniformMatrix4fv,
 "_glVertexAttrib4f": _glVertexAttrib4f,
 "_emscripten_glDepthFunc": _emscripten_glDepthFunc,
 "_emscripten_webgl_create_context": _emscripten_webgl_create_context,
 "_pthread_key_delete": _pthread_key_delete,
 "_glDisableVertexAttribArray": _glDisableVertexAttribArray,
 "_emscripten_memcpy_big": _emscripten_memcpy_big,
 "_pthread_attr_init": _pthread_attr_init,
 "_ceilf": _ceilf,
 "_glRenderbufferStorageMultisample": _glRenderbufferStorageMultisample,
 "_Mix_PlayMusic": _Mix_PlayMusic,
 "_glInvalidateFramebuffer": _glInvalidateFramebuffer,
 "_emscripten_glUniform1i": _emscripten_glUniform1i,
 "_puts": _puts,
 "_isatty": _isatty,
 "_glBindTransformFeedback": _glBindTransformFeedback,
 "_ftell": _ftell,
 "_glEndTransformFeedback": _glEndTransformFeedback,
 "_glFramebufferRenderbuffer": _glFramebufferRenderbuffer,
 "_gmtime_r": _gmtime_r,
 "___cxa_rethrow": ___cxa_rethrow,
 "_emscripten_glTexParameteriv": _emscripten_glTexParameteriv,
 "_catclose": _catclose,
 "_div": _div,
 "_emscripten_glAttachShader": _emscripten_glAttachShader,
 "_emscripten_get_now_is_monotonic": _emscripten_get_now_is_monotonic,
 "_pthread_cond_timedwait": _pthread_cond_timedwait,
 "_emscripten_glTexParameterfv": _emscripten_glTexParameterfv,
 "_pthread_attr_destroy": _pthread_attr_destroy,
 "_emscripten_glUniformMatrix2fv": _emscripten_glUniformMatrix2fv,
 "_SDL_GetTicks": _SDL_GetTicks,
 "_emscripten_glDrawArraysInstanced": _emscripten_glDrawArraysInstanced,
 "_JS_Sound_SetListenerVelocity": _JS_Sound_SetListenerVelocity,
 "_glDepthMask": _glDepthMask,
 "_strerror_r": _strerror_r,
 "_glViewport": _glViewport,
 "_fscanf": _fscanf,
 "_newlocale": _newlocale,
 "_emscripten_glFlush": _emscripten_glFlush,
 "_glReadBuffer": _glReadBuffer,
 "_pthread_once": _pthread_once,
 "_fopen": _fopen,
 "_JS_Sound_SetListenerOrientation": _JS_Sound_SetListenerOrientation,
 "_emscripten_glGetAttribLocation": _emscripten_glGetAttribLocation,
 "_glBeginQuery": _glBeginQuery,
 "_stat": _stat,
 "_glAttachShader": _glAttachShader,
 "_emscripten_glTexCoordPointer": _emscripten_glTexCoordPointer,
 "__addDays": __addDays,
 "_emscripten_glLoadMatrixf": _emscripten_glLoadMatrixf,
 "_emscripten_glStencilFuncSeparate": _emscripten_glStencilFuncSeparate,
 "_emscripten_glVertexAttrib3f": _emscripten_glVertexAttrib3f,
 "_pthread_mutex_lock": _pthread_mutex_lock,
 "_readdir_r": _readdir_r,
 "_glCullFace": _glCullFace,
 "_getcwd": _getcwd,
 "_pthread_cond_wait": _pthread_cond_wait,
 "_lseek": _lseek,
 "_glCompressedTexImage2D": _glCompressedTexImage2D,
 "_emscripten_glUniform1iv": _emscripten_glUniform1iv,
 "___errno_location": ___errno_location,
 "_cosf": _cosf,
 "_glClearColor": _glClearColor,
 "_glFinish": _glFinish,
 "_emscripten_glUniform3iv": _emscripten_glUniform3iv,
 "_emscripten_glGetBufferParameteriv": _emscripten_glGetBufferParameteriv,
 "_emscripten_glVertexAttrib4fv": _emscripten_glVertexAttrib4fv,
 "_glGetTexParameteriv": _glGetTexParameteriv,
 "_pthread_getspecific": _pthread_getspecific,
 "_glDrawArrays": _glDrawArrays,
 "_glCreateShader": _glCreateShader,
 "_pthread_cond_signal": _pthread_cond_signal,
 "_emscripten_glDepthRange": _emscripten_glDepthRange,
 "_floorf": _floorf,
 "_sqrtf": _sqrtf,
 "_glActiveTexture": _glActiveTexture,
 "_SDL_NumJoysticks": _SDL_NumJoysticks,
 "_emscripten_glCopyTexSubImage2D": _emscripten_glCopyTexSubImage2D,
 "_emscripten_glCopyTexImage2D": _emscripten_glCopyTexImage2D,
 "_emscripten_glFramebufferTexture2D": _emscripten_glFramebufferTexture2D,
 "_glEnableVertexAttribArray": _glEnableVertexAttribArray,
 "_emscripten_glStencilFunc": _emscripten_glStencilFunc,
 "_glBindVertexArray": _glBindVertexArray,
 "_glVertexAttribIPointer": _glVertexAttribIPointer,
 "_glDeleteBuffers": _glDeleteBuffers,
 "_localtime": _localtime,
 "_glGetUniformBlockIndex": _glGetUniformBlockIndex,
 "_glGetActiveUniformBlockName": _glGetActiveUniformBlockName,
 "_ferror": _ferror,
 "_sin": _sin,
 "_emscripten_glUniform1f": _emscripten_glUniform1f,
 "_glCompressedTexSubImage2D": _glCompressedTexSubImage2D,
 "_emscripten_glRenderbufferStorage": _emscripten_glRenderbufferStorage,
 "_tcflush": _tcflush,
 "_emscripten_glVertexPointer": _emscripten_glVertexPointer,
 "_JS_SystemInfo_GetHeight": _JS_SystemInfo_GetHeight,
 "_glGetVertexAttribPointerv": _glGetVertexAttribPointerv,
 "_emscripten_glBufferSubData": _emscripten_glBufferSubData,
 "_emscripten_glGetUniformfv": _emscripten_glGetUniformfv,
 "_SDL_FreeRW": _SDL_FreeRW,
 "_glDeleteQueries": _glDeleteQueries,
 "_fileno": _fileno,
 "_Mix_LoadWAV_RW": _Mix_LoadWAV_RW,
 "_emscripten_glStencilOp": _emscripten_glStencilOp,
 "_emscripten_glBlendEquation": _emscripten_glBlendEquation,
 "_glTexImage3D": _glTexImage3D,
 "_pthread_self": _pthread_self,
 "_emscripten_glVertexAttrib1fv": _emscripten_glVertexAttrib1fv,
 "_TTF_SizeText": _TTF_SizeText,
 "_glLinkProgram": _glLinkProgram,
 "_emscripten_glGetProgramInfoLog": _emscripten_glGetProgramInfoLog,
 "_emscripten_glUniform4fv": _emscripten_glUniform4fv,
 "_fgetc": _fgetc,
 "___cxa_throw": ___cxa_throw,
 "_glUniform1iv": _glUniform1iv,
 "_emscripten_glUniform2fv": _emscripten_glUniform2fv,
 "_emscripten_glBindBuffer": _emscripten_glBindBuffer,
 "_emscripten_glGetFloatv": _emscripten_glGetFloatv,
 "_pthread_mutex_init": _pthread_mutex_init,
 "_glBlendEquationSeparate": _glBlendEquationSeparate,
 "_glTexSubImage2D": _glTexSubImage2D,
 "_glUseProgram": _glUseProgram,
 "_glUniformMatrix3fv": _glUniformMatrix3fv,
 "_exp": _exp,
 "_SDL_StartTextInput": _SDL_StartTextInput,
 "_emscripten_glCullFace": _emscripten_glCullFace,
 "_emscripten_glIsProgram": _emscripten_glIsProgram,
 "_emscripten_glStencilMaskSeparate": _emscripten_glStencilMaskSeparate,
 "_fstat": _fstat,
 "_emscripten_glUniform3fv": _emscripten_glUniform3fv,
 "_glBindBuffer": _glBindBuffer,
 "_emscripten_request_fullscreen": _emscripten_request_fullscreen,
 "_emscripten_webgl_make_context_current": _emscripten_webgl_make_context_current,
 "_JS_Sound_Play": _JS_Sound_Play,
 "_rename": _rename,
 "_emscripten_glDisableVertexAttribArray": _emscripten_glDisableVertexAttribArray,
 "_TTF_RenderText_Solid": _TTF_RenderText_Solid,
 "_tcgetattr": _tcgetattr,
 "_glPolygonOffset": _glPolygonOffset,
 "_emscripten_webgl_get_current_context": _emscripten_webgl_get_current_context,
 "_clock": _clock,
 "_SDL_InitSubSystem": _SDL_InitSubSystem,
 "_JS_Sound_SetListenerPosition": _JS_Sound_SetListenerPosition,
 "_emscripten_glGetBooleanv": _emscripten_glGetBooleanv,
 "_glProgramBinary": _glProgramBinary,
 "_emscripten_glVertexAttribDivisor": _emscripten_glVertexAttribDivisor,
 "_readdir": _readdir,
 "_emscripten_glGenBuffers": _emscripten_glGenBuffers,
 "_emscripten_glDeleteObjectARB": _emscripten_glDeleteObjectARB,
 "_pipe": _pipe,
 "_emscripten_glGetShaderPrecisionFormat": _emscripten_glGetShaderPrecisionFormat,
 "_write": _write,
 "_fsync": _fsync,
 "_select": _select,
 "_emscripten_glIsEnabled": _emscripten_glIsEnabled,
 "_SDL_JoystickOpen": _SDL_JoystickOpen,
 "_JS_SystemInfo_HasFullscreen": _JS_SystemInfo_HasFullscreen,
 "_pthread_cond_destroy": _pthread_cond_destroy,
 "_JS_Sound_Set3D": _JS_Sound_Set3D,
 "_emscripten_glGetActiveAttrib": _emscripten_glGetActiveAttrib,
 "_glGenerateMipmap": _glGenerateMipmap,
 "_JS_Sound_SetPosition": _JS_Sound_SetPosition,
 "_uselocale": _uselocale,
 "_glGetQueryObjectuiv": _glGetQueryObjectuiv,
 "_setlocale": _setlocale,
 "_chmod": _chmod,
 "___cxa_free_exception": ___cxa_free_exception,
 "_atan2f": _atan2f,
 "___cxa_find_matching_catch": ___cxa_find_matching_catch,
 "_JS_SystemInfo_HasCursorLock": _JS_SystemInfo_HasCursorLock,
 "_emscripten_glClear": _emscripten_glClear,
 "_glDrawElements": _glDrawElements,
 "___cxa_guard_release": ___cxa_guard_release,
 "_glBufferSubData": _glBufferSubData,
 "_emscripten_glValidateProgram": _emscripten_glValidateProgram,
 "_emscripten_glUniform4iv": _emscripten_glUniform4iv,
 "___setErrNo": ___setErrNo,
 "___ctype_tolower_loc": ___ctype_tolower_loc,
 "_glStencilOpSeparate": _glStencilOpSeparate,
 "_emscripten_glVertexAttrib2f": _emscripten_glVertexAttrib2f,
 "___resumeException": ___resumeException,
 "_emscripten_glBlendFunc": _emscripten_glBlendFunc,
 "_mktime": _mktime,
 "_emscripten_glGetError": _emscripten_glGetError,
 "_putchar": _putchar,
 "_emscripten_glBufferData": _emscripten_glBufferData,
 "_glGetProgramBinary": _glGetProgramBinary,
 "_glGenTextures": _glGenTextures,
 "_glGetIntegerv": _glGetIntegerv,
 "_glUniform3iv": _glUniform3iv,
 "_emscripten_glClearStencil": _emscripten_glClearStencil,
 "_JS_Sound_Stop": _JS_Sound_Stop,
 "_emscripten_set_mouseup_callback": _emscripten_set_mouseup_callback,
 "_emscripten_glFinish": _emscripten_glFinish,
 "_emscripten_glClearDepth": _emscripten_glClearDepth,
 "_emscripten_glUniform1fv": _emscripten_glUniform1fv,
 "_fwrite": _fwrite,
 "_glBindFramebuffer": _glBindFramebuffer,
 "_emscripten_glStencilOpSeparate": _emscripten_glStencilOpSeparate,
 "_glGenFramebuffers": _glGenFramebuffers,
 "_chdir": _chdir,
 "_SDL_UpperBlitScaled": _SDL_UpperBlitScaled,
 "_emscripten_glUniform4i": _emscripten_glUniform4i,
 "_glUniform1fv": _glUniform1fv,
 "_llvm_pow_f64": _llvm_pow_f64,
 "_glDeleteFramebuffers": _glDeleteFramebuffers,
 "_JS_FileSystem_Sync": _JS_FileSystem_Sync,
 "_IMG_Load": _IMG_Load,
 "_glCheckFramebufferStatus": _glCheckFramebufferStatus,
 "_vfprintf": _vfprintf,
 "_asin": _asin,
 "_floor": _floor,
 "_emscripten_glStencilMask": _emscripten_glStencilMask,
 "_emscripten_glGetActiveUniform": _emscripten_glGetActiveUniform,
 "_localtime_r": _localtime_r,
 "_glBindTexture": _glBindTexture,
 "_fabsf": _fabsf,
 "_readlink": _readlink,
 "_sigemptyset": _sigemptyset,
 "_strftime": _strftime,
 "_emscripten_glGetVertexAttribiv": _emscripten_glGetVertexAttribiv,
 "_glReadPixels": _glReadPixels,
 "_fseek": _fseek,
 "_glGetActiveAttrib": _glGetActiveAttrib,
 "_emscripten_glUniformMatrix3fv": _emscripten_glUniformMatrix3fv,
 "_glUniform2iv": _glUniform2iv,
 "_pthread_key_create": _pthread_key_create,
 "_emscripten_glDeleteFramebuffers": _emscripten_glDeleteFramebuffers,
 "__setLetterbox": __setLetterbox,
 "_recv": _recv,
 "_glFrontFace": _glFrontFace,
 "_emscripten_glGetObjectParameterivARB": _emscripten_glGetObjectParameterivARB,
 "_JS_SystemInfo_HasWebGL": _JS_SystemInfo_HasWebGL,
 "_emscripten_glGetUniformiv": _emscripten_glGetUniformiv,
 "_glGetActiveUniformBlockiv": _glGetActiveUniformBlockiv,
 "_ceil": _ceil,
 "_emscripten_glVertexAttrib2fv": _emscripten_glVertexAttrib2fv,
 "_glGetProgramiv": _glGetProgramiv,
 "_glScissor": _glScissor,
 "_fabs": _fabs,
 "_sigaction": _sigaction,
 "_ftruncate": _ftruncate,
 "_difftime": _difftime,
 "_emscripten_glTexSubImage2D": _emscripten_glTexSubImage2D,
 "_glBlitFramebuffer": _glBlitFramebuffer,
 "_emscripten_glDeleteTextures": _emscripten_glDeleteTextures,
 "_fflush": _fflush,
 "_emscripten_exit_fullscreen": _emscripten_exit_fullscreen,
 "_strftime_l": _strftime_l,
 "_glGetShaderiv": _glGetShaderiv,
 "_SDL_PollEvent": _SDL_PollEvent,
 "_catgets": _catgets,
 "_glBindBufferBase": _glBindBufferBase,
 "_glUniform4fv": _glUniform4fv,
 "_glRenderbufferStorage": _glRenderbufferStorage,
 "__exit": __exit,
 "_IMG_Load_RW": _IMG_Load_RW,
 "_glBindAttribLocation": _glBindAttribLocation,
 "_emscripten_glColorMask": _emscripten_glColorMask,
 "_emscripten_webgl_destroy_context": _emscripten_webgl_destroy_context,
 "_pthread_mutex_unlock": _pthread_mutex_unlock,
 "_emscripten_glBindTexture": _emscripten_glBindTexture,
 "_glFramebufferTexture2D": _glFramebufferTexture2D,
 "_glUniform4iv": _glUniform4iv,
 "_emscripten_set_main_loop": _emscripten_set_main_loop,
 "__scanString": __scanString,
 "_emscripten_glIsShader": _emscripten_glIsShader,
 "_clearerr": _clearerr,
 "_fputc": _fputc,
 "_emscripten_glCompressedTexImage2D": _emscripten_glCompressedTexImage2D,
 "_glDisable": _glDisable,
 "_emscripten_glGetInfoLogARB": _emscripten_glGetInfoLogARB,
 "_emscripten_longjmp": _emscripten_longjmp,
 "__formatString": __formatString,
 "_atexit": _atexit,
 "_glStencilFuncSeparate": _glStencilFuncSeparate,
 "_JS_Sound_ReleaseInstance": _JS_Sound_ReleaseInstance,
 "_emscripten_glGenRenderbuffers": _emscripten_glGenRenderbuffers,
 "_emscripten_glReleaseShaderCompiler": _emscripten_glReleaseShaderCompiler,
 "_glStencilFunc": _glStencilFunc,
 "__ZN4FMOD13DSPConnection6setMixEf": __ZN4FMOD13DSPConnection6setMixEf,
 "_flock": _flock,
 "___cxa_guard_acquire": ___cxa_guard_acquire,
 "_SDL_RWFromFile": _SDL_RWFromFile,
 "_glUniform2fv": _glUniform2fv,
 "_emscripten_glFrontFace": _emscripten_glFrontFace,
 "_truncate": _truncate,
 "_glDeleteProgram": _glDeleteProgram,
 "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv,
 "_emscripten_glUseProgram": _emscripten_glUseProgram,
 "___ctype_toupper_loc": ___ctype_toupper_loc,
 "_glCreateProgram": _glCreateProgram,
 "_clock_gettime": _clock_gettime,
 "_SDL_GetError": _SDL_GetError,
 "_uname": _uname,
 "_glGetAttribLocation": _glGetAttribLocation,
 "_Mix_PlayChannel": _Mix_PlayChannel,
 "_sinf": _sinf,
 "_emscripten_glReadPixels": _emscripten_glReadPixels,
 "_ioctl": _ioctl,
 "_sysconf": _sysconf,
 "_utime": _utime,
 "_glEndQuery": _glEndQuery,
 "_emscripten_glLineWidth": _emscripten_glLineWidth,
 "_pthread_mutexattr_settype": _pthread_mutexattr_settype,
 "_tan": _tan,
 "_glTexStorage2D": _glTexStorage2D,
 "_glGenBuffers": _glGenBuffers,
 "_glShaderSource": _glShaderSource,
 "_emscripten_glScissor": _emscripten_glScissor,
 "_glGetVertexAttribfv": _glGetVertexAttribfv,
 "_mkdir": _mkdir,
 "_closedir": _closedir,
 "_llvm_trap": _llvm_trap,
 "_JS_Sound_SetVolume": _JS_Sound_SetVolume,
 "_JS_Cursor_SetShow": _JS_Cursor_SetShow,
 "_emscripten_glIsBuffer": _emscripten_glIsBuffer,
 "_emscripten_glVertexAttrib1f": _emscripten_glVertexAttrib1f,
 "_glVertexAttribPointer": _glVertexAttribPointer,
 "_emscripten_glCompressedTexSubImage2D": _emscripten_glCompressedTexSubImage2D,
 "_glGetVertexAttribiv": _glGetVertexAttribiv,
 "_JS_Log_Dump": _JS_Log_Dump,
 "_emscripten_glGetAttachedShaders": _emscripten_glGetAttachedShaders,
 "_emscripten_glGenTextures": _emscripten_glGenTextures,
 "_JS_Cursor_SetCursorString": _JS_Cursor_SetCursorString,
 "_glBindRenderbuffer": _glBindRenderbuffer,
 "_pthread_cond_init": _pthread_cond_init,
 "_SDL_LockSurface": _SDL_LockSurface,
 "_emscripten_glUniform3f": _emscripten_glUniform3f,
 "_emscripten_glGetTexParameteriv": _emscripten_glGetTexParameteriv,
 "_glDeleteTextures": _glDeleteTextures,
 "_emscripten_glClientActiveTexture": _emscripten_glClientActiveTexture,
 "_emscripten_glCheckFramebufferStatus": _emscripten_glCheckFramebufferStatus,
 "_gmtime": _gmtime,
 "_emscripten_glUniform3i": _emscripten_glUniform3i,
 "_glDrawBuffers": _glDrawBuffers,
 "_emscripten_glDeleteShader": _emscripten_glDeleteShader,
 "_glGetFramebufferAttachmentParameteriv": _glGetFramebufferAttachmentParameteriv,
 "_glUnmapBuffer": _glUnmapBuffer,
 "_glEnable": _glEnable,
 "_emscripten_glGetUniformLocation": _emscripten_glGetUniformLocation,
 "_emscripten_glEnableVertexAttribArray": _emscripten_glEnableVertexAttribArray,
 "_emscripten_get_now": _emscripten_get_now,
 "_fprintf": _fprintf,
 "_gettimeofday": _gettimeofday,
 "_catopen": _catopen,
 "_emscripten_glEnableClientState": _emscripten_glEnableClientState,
 "_JS_Sound_Init": _JS_Sound_Init,
 "_TTF_FontHeight": _TTF_FontHeight,
 "_emscripten_glDrawElements": _emscripten_glDrawElements,
 "___buildEnvironment": ___buildEnvironment,
 "_glClearDepthf": _glClearDepthf,
 "_tzset": _tzset,
 "_emscripten_asm_const": _emscripten_asm_const,
 "_SDL_Init": _SDL_Init,
 "_emscripten_glDisable": _emscripten_glDisable,
 "___cxa_end_catch": ___cxa_end_catch,
 "_emscripten_glDeleteRenderbuffers": _emscripten_glDeleteRenderbuffers,
 "_emscripten_glDrawElementsInstanced": _emscripten_glDrawElementsInstanced,
 "_emscripten_glVertexAttrib4f": _emscripten_glVertexAttrib4f,
 "_JS_Sound_Create_Channel": _JS_Sound_Create_Channel,
 "_emscripten_glPixelStorei": _emscripten_glPixelStorei,
 "_getenv": _getenv,
 "_fclose": _fclose,
 "_log": _log,
 "_emscripten_glFramebufferRenderbuffer": _emscripten_glFramebufferRenderbuffer,
 "__getFloat": __getFloat,
 "_glBufferData": _glBufferData,
 "_JS_Sound_SetPaused": _JS_Sound_SetPaused,
 "_emscripten_glRotatef": _emscripten_glRotatef,
 "_emscripten_glGetShaderiv": _emscripten_glGetShaderiv,
 "___cxa_pure_virtual": ___cxa_pure_virtual,
 "_emscripten_glUniformMatrix4fv": _emscripten_glUniformMatrix4fv,
 "_emscripten_glGetPointerv": _emscripten_glGetPointerv,
 "___ctype_b_loc": ___ctype_b_loc,
 "_emscripten_set_blur_callback": _emscripten_set_blur_callback,
 "_acosf": _acosf,
 "_acos": _acos,
 "_emscripten_glIsRenderbuffer": _emscripten_glIsRenderbuffer,
 "_emscripten_request_pointerlock": _emscripten_request_pointerlock,
 "_tanf": _tanf,
 "_glDeleteRenderbuffers": _glDeleteRenderbuffers,
 "_ungetc": _ungetc,
 "_JS_SystemInfo_GetMemory": _JS_SystemInfo_GetMemory,
 "_JS_Sound_SetLoop": _JS_Sound_SetLoop,
 "_emscripten_set_focus_callback": _emscripten_set_focus_callback,
 "_pthread_mutexattr_destroy": _pthread_mutexattr_destroy,
 "_emscripten_glGetVertexAttribfv": _emscripten_glGetVertexAttribfv,
 "_SDL_PauseAudio": _SDL_PauseAudio,
 "_emscripten_glVertexAttrib3fv": _emscripten_glVertexAttrib3fv,
 "_glGetUniformLocation": _glGetUniformLocation,
 "_emscripten_glCompileShader": _emscripten_glCompileShader,
 "_glClear": _glClear,
 "_glBeginTransformFeedback": _glBeginTransformFeedback,
 "_tcsetattr": _tcsetattr,
 "__arraySum": __arraySum,
 "_emscripten_glLinkProgram": _emscripten_glLinkProgram,
 "_atan": _atan,
 "_pread": _pread,
 "_mkport": _mkport,
 "_emscripten_get_pointerlock_status": _emscripten_get_pointerlock_status,
 "_emscripten_glDrawRangeElements": _emscripten_glDrawRangeElements,
 "_getc": _getc,
 "_pthread_create": _pthread_create,
 "_glGetActiveUniformsiv": _glGetActiveUniformsiv,
 "_pthread_setspecific": _pthread_setspecific,
 "_rmdir": _rmdir,
 "_glColorMask": _glColorMask,
 "_emscripten_glClearColor": _emscripten_glClearColor,
 "_glCopyTexSubImage2D": _glCopyTexSubImage2D,
 "_emscripten_glCreateProgram": _emscripten_glCreateProgram,
 "_glTexParameteri": _glTexParameteri,
 "_emscripten_glDetachShader": _emscripten_glDetachShader,
 "_SDL_RWFromConstMem": _SDL_RWFromConstMem,
 "_setenv": _setenv,
 "_emscripten_do_request_fullscreen": _emscripten_do_request_fullscreen,
 "_glGenQueries": _glGenQueries,
 "_emscripten_glGetRenderbufferParameteriv": _emscripten_glGetRenderbufferParameteriv,
 "_emscripten_set_fullscreenchange_callback": _emscripten_set_fullscreenchange_callback,
 "_emscripten_glVertexAttribPointer": _emscripten_glVertexAttribPointer,
 "_glTexStorage3D": _glTexStorage3D,
 "_asinf": _asinf,
 "_fread": _fread,
 "_emscripten_glDrawArrays": _emscripten_glDrawArrays,
 "_emscripten_glPolygonOffset": _emscripten_glPolygonOffset,
 "_longjmp": _longjmp,
 "_emscripten_glBlendColor": _emscripten_glBlendColor,
 "_emscripten_get_now_res": _emscripten_get_now_res,
 "_glGetShaderInfoLog": _glGetShaderInfoLog,
 "_clock_getres": _clock_getres,
 "_emscripten_set_main_loop_timing": _emscripten_set_main_loop_timing,
 "_sbrk": _sbrk,
 "___cxa_begin_catch": ___cxa_begin_catch,
 "_emscripten_glGetProgramiv": _emscripten_glGetProgramiv,
 "_close": _close,
 "_emscripten_glUniform4f": _emscripten_glUniform4f,
 "_glStencilOp": _glStencilOp,
 "_emscripten_glGetShaderSource": _emscripten_glGetShaderSource,
 "_cos": _cos,
 "_expf": _expf,
 "_emscripten_glTexImage2D": _emscripten_glTexImage2D,
 "_glTexSubImage3D": _glTexSubImage3D,
 "__isLeapYear": __isLeapYear,
 "_emscripten_glBlendEquationSeparate": _emscripten_glBlendEquationSeparate,
 "_emscripten_glGetString": _emscripten_glGetString,
 "_emscripten_glIsFramebuffer": _emscripten_glIsFramebuffer,
 "_gethostname": _gethostname,
 "_unsetenv": _unsetenv,
 "_emscripten_glBindProgramARB": _emscripten_glBindProgramARB,
 "_mknod": _mknod,
 "_emscripten_glUniform2i": _emscripten_glUniform2i,
 "_send": _send,
 "_glGenTransformFeedbacks": _glGenTransformFeedbacks,
 "_JS_SystemInfo_GetWidth": _JS_SystemInfo_GetWidth,
 "_atan2": _atan2,
 "_glGetProgramInfoLog": _glGetProgramInfoLog,
 "_emscripten_glTexParameterf": _emscripten_glTexParameterf,
 "_emscripten_glTexParameteri": _emscripten_glTexParameteri,
 "_fcntl": _fcntl,
 "_JS_Sound_Load": _JS_Sound_Load,
 "_JS_Sound_Load_PCM": _JS_Sound_Load_PCM,
 "_emscripten_glGenVertexArrays": _emscripten_glGenVertexArrays,
 "_JS_SystemInfo_GetDocumentURL": _JS_SystemInfo_GetDocumentURL,
 "_Mix_HaltMusic": _Mix_HaltMusic,
 "_glDeleteVertexArrays": _glDeleteVertexArrays,
 "_emscripten_glBindAttribLocation": _emscripten_glBindAttribLocation,
 "_llvm_pow_f32": _llvm_pow_f32,
 "_glDepthFunc": _glDepthFunc,
 "___cxa_allocate_exception": ___cxa_allocate_exception,
 "_emscripten_set_canvas_size": _emscripten_set_canvas_size,
 "_unlink": _unlink,
 "_freelocale": _freelocale,
 "_emscripten_glClearDepthf": _emscripten_glClearDepthf,
 "_atanf": _atanf,
 "_printf": _printf,
 "_emscripten_glMatrixMode": _emscripten_glMatrixMode,
 "_glBlendFuncSeparate": _glBlendFuncSeparate,
 "_emscripten_glNormalPointer": _emscripten_glNormalPointer,
 "_emscripten_glHint": _emscripten_glHint,
 "_emscripten_glEnable": _emscripten_glEnable,
 "_read": _read,
 "_emscripten_glBindFramebuffer": _emscripten_glBindFramebuffer,
 "_emscripten_glBindRenderbuffer": _emscripten_glBindRenderbuffer,
 "_time": _time,
 "_emscripten_glGetFramebufferAttachmentParameteriv": _emscripten_glGetFramebufferAttachmentParameteriv,
 "_exit": _exit,
 "_putenv": _putenv,
 "_emscripten_glDeleteBuffers": _emscripten_glDeleteBuffers,
 "_glMapBufferRange": _glMapBufferRange,
 "_access": _access,
 "_JS_Cursor_SetImage": _JS_Cursor_SetImage,
 "_emscripten_glShaderBinary": _emscripten_glShaderBinary,
 "_emscripten_glGetShaderInfoLog": _emscripten_glGetShaderInfoLog,
 "_glUniform3fv": _glUniform3fv,
 "_emscripten_glGetVertexAttribPointerv": _emscripten_glGetVertexAttribPointerv,
 "_pwrite": _pwrite,
 "_open": _open,
 "_emscripten_glUniform2f": _emscripten_glUniform2f,
 "_glUniformBlockBinding": _glUniformBlockBinding,
 "_emscripten_glDeleteProgram": _emscripten_glDeleteProgram,
 "_glUniform1i": _glUniform1i,
 "_glFlushMappedBufferRange": _glFlushMappedBufferRange,
 "_emscripten_glCreateShader": _emscripten_glCreateShader,
 "_pthread_mutex_destroy": _pthread_mutex_destroy,
 "_emscripten_glColorPointer": _emscripten_glColorPointer,
 "_glTransformFeedbackVaryings": _glTransformFeedbackVaryings,
 "_SDL_UpperBlit": _SDL_UpperBlit,
 "_glGetString": _glGetString,
 "_emscripten_glViewport": _emscripten_glViewport,
 "_pthread_cond_broadcast": _pthread_cond_broadcast,
 "_emscripten_glDepthMask": _emscripten_glDepthMask,
 "_emscripten_glDrawBuffers": _emscripten_glDrawBuffers,
 "_SDL_JoystickNumAxes": _SDL_JoystickNumAxes,
 "_glCompileShader": _glCompileShader,
 "_emscripten_exit_pointerlock": _emscripten_exit_pointerlock,
 "_abort": _abort,
 "_emscripten_glGenerateMipmap": _emscripten_glGenerateMipmap,
 "_JS_Sound_GetLoadState": _JS_Sound_GetLoadState,
 "_glTexImage2D": _glTexImage2D,
 "_emscripten_glGenFramebuffers": _emscripten_glGenFramebuffers,
 "_glFlush": _glFlush,
 "_emscripten_glLoadIdentity": _emscripten_glLoadIdentity,
 "_glDeleteShader": _glDeleteShader,
 "_emscripten_glShaderSource": _emscripten_glShaderSource,
 "_glGenVertexArrays": _glGenVertexArrays,
 "_SDL_CloseAudio": _SDL_CloseAudio,
 "_emscripten_asm_const_int": _emscripten_asm_const_int,
 "_emscripten_get_fullscreen_status": _emscripten_get_fullscreen_status,
 "_JS_Sound_SetVelocity": _JS_Sound_SetVelocity,
 "_glGetError": _glGetError,
 "_glGenRenderbuffers": _glGenRenderbuffers,
 "_strerror": _strerror,
 "_emscripten_glSampleCoverage": _emscripten_glSampleCoverage,
 "_emscripten_glFrustum": _emscripten_glFrustum,
 "_Mix_FreeChunk": _Mix_FreeChunk,
 "_emscripten_glDepthRangef": _emscripten_glDepthRangef,
 "_JS_Sound_SetPitch": _JS_Sound_SetPitch,
 "_glPixelStorei": _glPixelStorei,
 "_emscripten_glIsTexture": _emscripten_glIsTexture,
 "_fputs": _fputs,
 "_emscripten_glBindVertexArray": _emscripten_glBindVertexArray,
 "_glStencilMask": _glStencilMask,
 "_emscripten_glActiveTexture": _emscripten_glActiveTexture,
 "_emscripten_set_keyup_callback": _emscripten_set_keyup_callback,
 "_emscripten_glDeleteVertexArrays": _emscripten_glDeleteVertexArrays,
 "_glDeleteTransformFeedbacks": _glDeleteTransformFeedbacks,
 "_emscripten_glUniform2iv": _emscripten_glUniform2iv,
 "_lstat": _lstat,
 "_pthread_mutexattr_init": _pthread_mutexattr_init,
 "_emscripten_webgl_init_context_attributes": _emscripten_webgl_init_context_attributes,
 "_SDL_GL_SwapBuffers": _SDL_GL_SwapBuffers,
 "_opendir": _opendir,
 "__reallyNegative": __reallyNegative,
 "_glGetActiveUniform": _glGetActiveUniform,
 "_sqrt": _sqrt,
 "STACKTOP": STACKTOP,
 "STACK_MAX": STACK_MAX,
 "tempDoublePtr": tempDoublePtr,
 "ABORT": ABORT,
 "cttz_i8": cttz_i8,
 "ctlz_i8": ctlz_i8,
 "NaN": NaN,
 "Infinity": Infinity,
 "_environ": _environ,
 "_stderr": _stderr,
 "_stdin": _stdin,
 "_stdout": _stdout
};
// EMSCRIPTEN_START_ASM

var asm = (function(global,env,buffer) {

 "use asm";
 var a = new global.Int8Array(buffer);
 var b = new global.Int16Array(buffer);
 var c = new global.Int32Array(buffer);
 var d = new global.Uint8Array(buffer);
 var e = new global.Uint16Array(buffer);
 var f = new global.Uint32Array(buffer);
 var g = new global.Float32Array(buffer);
 var h = new global.Float64Array(buffer);
 var i = env.STACKTOP | 0;
 var j = env.STACK_MAX | 0;
 var k = env.tempDoublePtr | 0;
 var l = env.ABORT | 0;
 var m = env.cttz_i8 | 0;
 var n = env.ctlz_i8 | 0;
 var o = env._environ | 0;
 var p = env._stderr | 0;
 var q = env._stdin | 0;
 var r = env._stdout | 0;
 var s = 0;
 var t = 0;
 var u = 0;
 var v = 0;
 var w = +env.NaN, x = +env.Infinity;
 var y = 0, z = 0, A = 0, B = 0, C = 0.0, D = 0, E = 0, F = 0, G = 0.0;
 var H = 0;
 var I = 0;
 var J = 0;
 var K = 0;
 var L = 0;
 var M = 0;
 var N = 0;
 var O = 0;
 var P = 0;
 var Q = 0;
 var R = global.Math.floor;
 var S = global.Math.abs;
 var T = global.Math.sqrt;
 var U = global.Math.pow;
 var V = global.Math.cos;
 var W = global.Math.sin;
 var X = global.Math.tan;
 var Y = global.Math.acos;
 var Z = global.Math.asin;
 var _ = global.Math.atan;
 var $ = global.Math.atan2;
 var aa = global.Math.exp;
 var ba = global.Math.log;
 var ca = global.Math.ceil;
 var da = global.Math.imul;
 var ea = global.Math.fround;
 var fa = env.abort;
 var ga = env.assert;
 var ha = env.min;
 var ia = env.invoke_fiff;
 var ja = env.invoke_iiiiiii;
 var ka = env.invoke_vifiiiiiiiiiiiiiiiiiii;
 var la = env.invoke_viiiiiiiiiii;
 var ma = env.invoke_iidi;
 var na = env.invoke_fiiiiiifiiiiiif;
 var oa = env.invoke_iiiiifiif;
 var pa = env.invoke_viiiiiffi;
 var qa = env.invoke_iiiiiiiiiiii;
 var ra = env.invoke_fif;
 var sa = env.invoke_fid;
 var ta = env.invoke_fii;
 var ua = env.invoke_ddii;
 var va = env.invoke_di;
 var wa = env.invoke_dd;
 var xa = env.invoke_iiiifiiii;
 var ya = env.invoke_viffff;
 var za = env.invoke_didd;
 var Aa = env.invoke_dii;
 var Ba = env.invoke_did;
 var Ca = env.invoke_dif;
 var Da = env.invoke_iiiiiiiiii;
 var Ea = env.invoke_vdddddd;
 var Fa = env.invoke_iiiiiiiiiiiiffffii;
 var Ga = env.invoke_vdd;
 var Ha = env.invoke_iiiiiiii;
 var Ia = env.invoke_iiiiiifffiiiii;
 var Ja = env.invoke_vifiiiiiiiiiiiii;
 var Ka = env.invoke_iiiii;
 var La = env.invoke_iiifii;
 var Ma = env.invoke_fifff;
 var Na = env.invoke_viiiiid;
 var Oa = env.invoke_viff;
 var Pa = env.invoke_vifi;
 var Qa = env.invoke_vifff;
 var Ra = env.invoke_viiiiii;
 var Sa = env.invoke_ddd;
 var Ta = env.invoke_fiii;
 var Ua = env.invoke_iifff;
 var Va = env.invoke_iiiiiifiiiiiiiiiffffi;
 var Wa = env.invoke_iiiiifiiiif;
 var Xa = env.invoke_viiffffff;
 var Ya = env.invoke_viiiiiiiiii;
 var Za = env.invoke_diii;
 var _a = env.invoke_viiiiiiiiiiii;
 var $a = env.invoke_iiiiii;
 var ab = env.invoke_iiiiiifiif;
 var bb = env.invoke_viiii;
 var cb = env.invoke_viiiii;
 var db = env.invoke_vif;
 var eb = env.invoke_vid;
 var fb = env.invoke_iiidi;
 var gb = env.invoke_vii;
 var hb = env.invoke_viifii;
 var ib = env.invoke_fi;
 var jb = env.invoke_viidi;
 var kb = env.invoke_fiiiiiiiifiiiif;
 var lb = env.invoke_viiiiiiii;
 var mb = env.invoke_vifiii;
 var nb = env.invoke_iiiiiiifiiiiiiiiiffffi;
 var ob = env.invoke_diiii;
 var pb = env.invoke_viiiiiiiiiiiii;
 var qb = env.invoke_iiiiiiiiiiffffii;
 var rb = env.invoke_iid;
 var sb = env.invoke_iif;
 var tb = env.invoke_vifiiii;
 var ub = env.invoke_viiiiiii;
 var vb = env.invoke_vifiiiiiiiiiiiiiiiiii;
 var wb = env.invoke_viiiiiiiii;
 var xb = env.invoke_viiiiiif;
 var yb = env.invoke_iii;
 var zb = env.invoke_iiiifii;
 var Ab = env.invoke_vffff;
 var Bb = env.invoke_viiiifiiiiif;
 var Cb = env.invoke_viii;
 var Db = env.invoke_v;
 var Eb = env.invoke_viid;
 var Fb = env.invoke_viif;
 var Gb = env.invoke_iiiifi;
 var Hb = env.invoke_vd;
 var Ib = env.invoke_vf;
 var Jb = env.invoke_vi;
 var Kb = env.invoke_iiiiiiiiiii;
 var Lb = env.invoke_ii;
 var Mb = env.invoke_iiff;
 var Nb = env.invoke_viifi;
 var Ob = env.invoke_iiiiifiiiiii;
 var Pb = env.invoke_iiiiifiiiiif;
 var Qb = env.invoke_iifi;
 var Rb = env.invoke_viiif;
 var Sb = env.invoke_viiiffii;
 var Tb = env.invoke_vifiiiiiiiiiiiiiiiiiiiiiii;
 var Ub = env.invoke_iifiiiii;
 var Vb = env.invoke_iiifi;
 var Wb = env.invoke_iiii;
 var Xb = env.invoke_viifff;
 var Yb = env.invoke_viiffi;
 var Zb = env.invoke_iiif;
 var _b = env.invoke_viiiiiid;
 var $b = env.invoke_viiifi;
 var ac = env.invoke_viffffff;
 var bc = env.invoke_iiiiiiiiiiiii;
 var cc = env.invoke_iiiifiiiii;
 var dc = env.invoke_viiiiiiiiiiiiiiiiiiiiiiiiiiiii;
 var ec = env.invoke_viffffffffffffiiii;
 var fc = env.invoke_vfi;
 var gc = env.invoke_i;
 var hc = env.invoke_vff;
 var ic = env.invoke_viiifiiiii;
 var jc = env.invoke_iiiiiifiiiiiiiiiiii;
 var kc = env.invoke_viiffff;
 var lc = env.invoke_iiiiiiiii;
 var mc = env.invoke_viffffi;
 var nc = env._emscripten_glGetTexParameterfv;
 var oc = env._glClearStencil;
 var pc = env._emscripten_glBlendFuncSeparate;
 var qc = env._emscripten_glGetIntegerv;
 var rc = env._glUniformMatrix4fv;
 var sc = env._glVertexAttrib4f;
 var tc = env._emscripten_glDepthFunc;
 var uc = env._emscripten_webgl_create_context;
 var vc = env._pthread_key_delete;
 var wc = env._glDisableVertexAttribArray;
 var xc = env._emscripten_memcpy_big;
 var yc = env._pthread_attr_init;
 var zc = env._ceilf;
 var Ac = env._glRenderbufferStorageMultisample;
 var Bc = env._Mix_PlayMusic;
 var Cc = env._glInvalidateFramebuffer;
 var Dc = env._emscripten_glUniform1i;
 var Ec = env._puts;
 var Fc = env._isatty;
 var Gc = env._glBindTransformFeedback;
 var Hc = env._ftell;
 var Ic = env._glEndTransformFeedback;
 var Jc = env._glFramebufferRenderbuffer;
 var Kc = env._gmtime_r;
 var Lc = env.___cxa_rethrow;
 var Mc = env._emscripten_glTexParameteriv;
 var Nc = env._catclose;
 var Oc = env._div;
 var Pc = env._emscripten_glAttachShader;
 var Qc = env._emscripten_get_now_is_monotonic;
 var Rc = env._pthread_cond_timedwait;
 var Sc = env._emscripten_glTexParameterfv;
 var Tc = env._pthread_attr_destroy;
 var Uc = env._emscripten_glUniformMatrix2fv;
 var Vc = env._SDL_GetTicks;
 var Wc = env._emscripten_glDrawArraysInstanced;
 var Xc = env._JS_Sound_SetListenerVelocity;
 var Yc = env._glDepthMask;
 var Zc = env._strerror_r;
 var _c = env._glViewport;
 var $c = env._fscanf;
 var ad = env._newlocale;
 var bd = env._emscripten_glFlush;
 var cd = env._glReadBuffer;
 var dd = env._pthread_once;
 var ed = env._fopen;
 var fd = env._JS_Sound_SetListenerOrientation;
 var gd = env._emscripten_glGetAttribLocation;
 var hd = env._glBeginQuery;
 var id = env._stat;
 var jd = env._glAttachShader;
 var kd = env._emscripten_glTexCoordPointer;
 var ld = env.__addDays;
 var md = env._emscripten_glLoadMatrixf;
 var nd = env._emscripten_glStencilFuncSeparate;
 var od = env._emscripten_glVertexAttrib3f;
 var pd = env._pthread_mutex_lock;
 var qd = env._readdir_r;
 var rd = env._glCullFace;
 var sd = env._getcwd;
 var td = env._pthread_cond_wait;
 var ud = env._lseek;
 var vd = env._glCompressedTexImage2D;
 var wd = env._emscripten_glUniform1iv;
 var xd = env.___errno_location;
 var yd = env._cosf;
 var zd = env._glClearColor;
 var Ad = env._glFinish;
 var Bd = env._emscripten_glUniform3iv;
 var Cd = env._emscripten_glGetBufferParameteriv;
 var Dd = env._emscripten_glVertexAttrib4fv;
 var Ed = env._glGetTexParameteriv;
 var Fd = env._pthread_getspecific;
 var Gd = env._glDrawArrays;
 var Hd = env._glCreateShader;
 var Id = env._pthread_cond_signal;
 var Jd = env._emscripten_glDepthRange;
 var Kd = env._floorf;
 var Ld = env._sqrtf;
 var Md = env._glActiveTexture;
 var Nd = env._SDL_NumJoysticks;
 var Od = env._emscripten_glCopyTexSubImage2D;
 var Pd = env._emscripten_glCopyTexImage2D;
 var Qd = env._emscripten_glFramebufferTexture2D;
 var Rd = env._glEnableVertexAttribArray;
 var Sd = env._emscripten_glStencilFunc;
 var Td = env._glBindVertexArray;
 var Ud = env._glVertexAttribIPointer;
 var Vd = env._glDeleteBuffers;
 var Wd = env._localtime;
 var Xd = env._glGetUniformBlockIndex;
 var Yd = env._glGetActiveUniformBlockName;
 var Zd = env._ferror;
 var _d = env._sin;
 var $d = env._emscripten_glUniform1f;
 var ae = env._glCompressedTexSubImage2D;
 var be = env._emscripten_glRenderbufferStorage;
 var ce = env._tcflush;
 var de = env._emscripten_glVertexPointer;
 var ee = env._JS_SystemInfo_GetHeight;
 var fe = env._glGetVertexAttribPointerv;
 var ge = env._emscripten_glBufferSubData;
 var he = env._emscripten_glGetUniformfv;
 var ie = env._SDL_FreeRW;
 var je = env._glDeleteQueries;
 var ke = env._fileno;
 var le = env._Mix_LoadWAV_RW;
 var me = env._emscripten_glStencilOp;
 var ne = env._emscripten_glBlendEquation;
 var oe = env._glTexImage3D;
 var pe = env._pthread_self;
 var qe = env._emscripten_glVertexAttrib1fv;
 var re = env._TTF_SizeText;
 var se = env._glLinkProgram;
 var te = env._emscripten_glGetProgramInfoLog;
 var ue = env._emscripten_glUniform4fv;
 var ve = env._fgetc;
 var we = env.___cxa_throw;
 var xe = env._glUniform1iv;
 var ye = env._emscripten_glUniform2fv;
 var ze = env._emscripten_glBindBuffer;
 var Ae = env._emscripten_glGetFloatv;
 var Be = env._pthread_mutex_init;
 var Ce = env._glBlendEquationSeparate;
 var De = env._glTexSubImage2D;
 var Ee = env._glUseProgram;
 var Fe = env._glUniformMatrix3fv;
 var Ge = env._exp;
 var He = env._SDL_StartTextInput;
 var Ie = env._emscripten_glCullFace;
 var Je = env._emscripten_glIsProgram;
 var Ke = env._emscripten_glStencilMaskSeparate;
 var Le = env._fstat;
 var Me = env._emscripten_glUniform3fv;
 var Ne = env._glBindBuffer;
 var Oe = env._emscripten_request_fullscreen;
 var Pe = env._emscripten_webgl_make_context_current;
 var Qe = env._JS_Sound_Play;
 var Re = env._rename;
 var Se = env._emscripten_glDisableVertexAttribArray;
 var Te = env._TTF_RenderText_Solid;
 var Ue = env._tcgetattr;
 var Ve = env._glPolygonOffset;
 var We = env._emscripten_webgl_get_current_context;
 var Xe = env._clock;
 var Ye = env._SDL_InitSubSystem;
 var Ze = env._JS_Sound_SetListenerPosition;
 var _e = env._emscripten_glGetBooleanv;
 var $e = env._glProgramBinary;
 var af = env._emscripten_glVertexAttribDivisor;
 var bf = env._readdir;
 var cf = env._emscripten_glGenBuffers;
 var df = env._emscripten_glDeleteObjectARB;
 var ef = env._pipe;
 var ff = env._emscripten_glGetShaderPrecisionFormat;
 var gf = env._write;
 var hf = env._fsync;
 var jf = env._select;
 var kf = env._emscripten_glIsEnabled;
 var lf = env._SDL_JoystickOpen;
 var mf = env._JS_SystemInfo_HasFullscreen;
 var nf = env._pthread_cond_destroy;
 var of = env._JS_Sound_Set3D;
 var pf = env._emscripten_glGetActiveAttrib;
 var qf = env._glGenerateMipmap;
 var rf = env._JS_Sound_SetPosition;
 var sf = env._uselocale;
 var tf = env._glGetQueryObjectuiv;
 var uf = env._setlocale;
 var vf = env._chmod;
 var wf = env.___cxa_free_exception;
 var xf = env._atan2f;
 var yf = env.___cxa_find_matching_catch;
 var zf = env._JS_SystemInfo_HasCursorLock;
 var Af = env._emscripten_glClear;
 var Bf = env._glDrawElements;
 var Cf = env.___cxa_guard_release;
 var Df = env._glBufferSubData;
 var Ef = env._emscripten_glValidateProgram;
 var Ff = env._emscripten_glUniform4iv;
 var Gf = env.___setErrNo;
 var Hf = env.___ctype_tolower_loc;
 var If = env._glStencilOpSeparate;
 var Jf = env._emscripten_glVertexAttrib2f;
 var Kf = env.___resumeException;
 var Lf = env._emscripten_glBlendFunc;
 var Mf = env._mktime;
 var Nf = env._emscripten_glGetError;
 var Of = env._putchar;
 var Pf = env._emscripten_glBufferData;
 var Qf = env._glGetProgramBinary;
 var Rf = env._glGenTextures;
 var Sf = env._glGetIntegerv;
 var Tf = env._glUniform3iv;
 var Uf = env._emscripten_glClearStencil;
 var Vf = env._JS_Sound_Stop;
 var Wf = env._emscripten_set_mouseup_callback;
 var Xf = env._emscripten_glFinish;
 var Yf = env._emscripten_glClearDepth;
 var Zf = env._emscripten_glUniform1fv;
 var _f = env._fwrite;
 var $f = env._glBindFramebuffer;
 var ag = env._emscripten_glStencilOpSeparate;
 var bg = env._glGenFramebuffers;
 var cg = env._chdir;
 var dg = env._SDL_UpperBlitScaled;
 var eg = env._emscripten_glUniform4i;
 var fg = env._glUniform1fv;
 var gg = env._llvm_pow_f64;
 var hg = env._glDeleteFramebuffers;
 var ig = env._JS_FileSystem_Sync;
 var jg = env._IMG_Load;
 var kg = env._glCheckFramebufferStatus;
 var lg = env._vfprintf;
 var mg = env._asin;
 var ng = env._floor;
 var og = env._emscripten_glStencilMask;
 var pg = env._emscripten_glGetActiveUniform;
 var qg = env._localtime_r;
 var rg = env._glBindTexture;
 var sg = env._fabsf;
 var tg = env._readlink;
 var ug = env._sigemptyset;
 var vg = env._strftime;
 var wg = env._emscripten_glGetVertexAttribiv;
 var xg = env._glReadPixels;
 var yg = env._fseek;
 var zg = env._glGetActiveAttrib;
 var Ag = env._emscripten_glUniformMatrix3fv;
 var Bg = env._glUniform2iv;
 var Cg = env._pthread_key_create;
 var Dg = env._emscripten_glDeleteFramebuffers;
 var Eg = env.__setLetterbox;
 var Fg = env._recv;
 var Gg = env._glFrontFace;
 var Hg = env._emscripten_glGetObjectParameterivARB;
 var Ig = env._JS_SystemInfo_HasWebGL;
 var Jg = env._emscripten_glGetUniformiv;
 var Kg = env._glGetActiveUniformBlockiv;
 var Lg = env._ceil;
 var Mg = env._emscripten_glVertexAttrib2fv;
 var Ng = env._glGetProgramiv;
 var Og = env._glScissor;
 var Pg = env._fabs;
 var Qg = env._sigaction;
 var Rg = env._ftruncate;
 var Sg = env._difftime;
 var Tg = env._emscripten_glTexSubImage2D;
 var Ug = env._glBlitFramebuffer;
 var Vg = env._emscripten_glDeleteTextures;
 var Wg = env._fflush;
 var Xg = env._emscripten_exit_fullscreen;
 var Yg = env._strftime_l;
 var Zg = env._glGetShaderiv;
 var _g = env._SDL_PollEvent;
 var $g = env._catgets;
 var ah = env._glBindBufferBase;
 var bh = env._glUniform4fv;
 var ch = env._glRenderbufferStorage;
 var dh = env.__exit;
 var eh = env._IMG_Load_RW;
 var fh = env._glBindAttribLocation;
 var gh = env._emscripten_glColorMask;
 var hh = env._emscripten_webgl_destroy_context;
 var ih = env._pthread_mutex_unlock;
 var jh = env._emscripten_glBindTexture;
 var kh = env._glFramebufferTexture2D;
 var lh = env._glUniform4iv;
 var mh = env._emscripten_set_main_loop;
 var nh = env.__scanString;
 var oh = env._emscripten_glIsShader;
 var ph = env._clearerr;
 var qh = env._fputc;
 var rh = env._emscripten_glCompressedTexImage2D;
 var sh = env._glDisable;
 var th = env._emscripten_glGetInfoLogARB;
 var uh = env._emscripten_longjmp;
 var vh = env.__formatString;
 var wh = env._atexit;
 var xh = env._glStencilFuncSeparate;
 var yh = env._JS_Sound_ReleaseInstance;
 var zh = env._emscripten_glGenRenderbuffers;
 var Ah = env._emscripten_glReleaseShaderCompiler;
 var Bh = env._glStencilFunc;
 var Ch = env.__ZN4FMOD13DSPConnection6setMixEf;
 var Dh = env._flock;
 var Eh = env.___cxa_guard_acquire;
 var Fh = env._SDL_RWFromFile;
 var Gh = env._glUniform2fv;
 var Hh = env._emscripten_glFrontFace;
 var Ih = env._truncate;
 var Jh = env._glDeleteProgram;
 var Kh = env.__ZSt18uncaught_exceptionv;
 var Lh = env._emscripten_glUseProgram;
 var Mh = env.___ctype_toupper_loc;
 var Nh = env._glCreateProgram;
 var Oh = env._clock_gettime;
 var Ph = env._SDL_GetError;
 var Qh = env._uname;
 var Rh = env._glGetAttribLocation;
 var Sh = env._Mix_PlayChannel;
 var Th = env._sinf;
 var Uh = env._emscripten_glReadPixels;
 var Vh = env._ioctl;
 var Wh = env._sysconf;
 var Xh = env._utime;
 var Yh = env._glEndQuery;
 var Zh = env._emscripten_glLineWidth;
 var _h = env._pthread_mutexattr_settype;
 var $h = env._tan;
 var ai = env._glTexStorage2D;
 var bi = env._glGenBuffers;
 var ci = env._glShaderSource;
 var di = env._emscripten_glScissor;
 var ei = env._glGetVertexAttribfv;
 var fi = env._mkdir;
 var gi = env._closedir;
 var hi = env._llvm_trap;
 var ii = env._JS_Sound_SetVolume;
 var ji = env._JS_Cursor_SetShow;
 var ki = env._emscripten_glIsBuffer;
 var li = env._emscripten_glVertexAttrib1f;
 var mi = env._glVertexAttribPointer;
 var ni = env._emscripten_glCompressedTexSubImage2D;
 var oi = env._glGetVertexAttribiv;
 var pi = env._JS_Log_Dump;
 var qi = env._emscripten_glGetAttachedShaders;
 var ri = env._emscripten_glGenTextures;
 var si = env._JS_Cursor_SetCursorString;
 var ti = env._glBindRenderbuffer;
 var ui = env._pthread_cond_init;
 var vi = env._SDL_LockSurface;
 var wi = env._emscripten_glUniform3f;
 var xi = env._emscripten_glGetTexParameteriv;
 var yi = env._glDeleteTextures;
 var zi = env._emscripten_glClientActiveTexture;
 var Ai = env._emscripten_glCheckFramebufferStatus;
 var Bi = env._gmtime;
 var Ci = env._emscripten_glUniform3i;
 var Di = env._glDrawBuffers;
 var Ei = env._emscripten_glDeleteShader;
 var Fi = env._glGetFramebufferAttachmentParameteriv;
 var Gi = env._glUnmapBuffer;
 var Hi = env._glEnable;
 var Ii = env._emscripten_glGetUniformLocation;
 var Ji = env._emscripten_glEnableVertexAttribArray;
 var Ki = env._emscripten_get_now;
 var Li = env._fprintf;
 var Mi = env._gettimeofday;
 var Ni = env._catopen;
 var Oi = env._emscripten_glEnableClientState;
 var Pi = env._JS_Sound_Init;
 var Qi = env._TTF_FontHeight;
 var Ri = env._emscripten_glDrawElements;
 var Si = env.___buildEnvironment;
 var Ti = env._glClearDepthf;
 var Ui = env._tzset;
 var Vi = env._emscripten_asm_const;
 var Wi = env._SDL_Init;
 var Xi = env._emscripten_glDisable;
 var Yi = env.___cxa_end_catch;
 var Zi = env._emscripten_glDeleteRenderbuffers;
 var _i = env._emscripten_glDrawElementsInstanced;
 var $i = env._emscripten_glVertexAttrib4f;
 var aj = env._JS_Sound_Create_Channel;
 var bj = env._emscripten_glPixelStorei;
 var cj = env._getenv;
 var dj = env._fclose;
 var ej = env._log;
 var fj = env._emscripten_glFramebufferRenderbuffer;
 var gj = env.__getFloat;
 var hj = env._glBufferData;
 var ij = env._JS_Sound_SetPaused;
 var jj = env._emscripten_glRotatef;
 var kj = env._emscripten_glGetShaderiv;
 var lj = env.___cxa_pure_virtual;
 var mj = env._emscripten_glUniformMatrix4fv;
 var nj = env._emscripten_glGetPointerv;
 var oj = env.___ctype_b_loc;
 var pj = env._emscripten_set_blur_callback;
 var qj = env._acosf;
 var rj = env._acos;
 var sj = env._emscripten_glIsRenderbuffer;
 var tj = env._emscripten_request_pointerlock;
 var uj = env._tanf;
 var vj = env._glDeleteRenderbuffers;
 var wj = env._ungetc;
 var xj = env._JS_SystemInfo_GetMemory;
 var yj = env._JS_Sound_SetLoop;
 var zj = env._emscripten_set_focus_callback;
 var Aj = env._pthread_mutexattr_destroy;
 var Bj = env._emscripten_glGetVertexAttribfv;
 var Cj = env._SDL_PauseAudio;
 var Dj = env._emscripten_glVertexAttrib3fv;
 var Ej = env._glGetUniformLocation;
 var Fj = env._emscripten_glCompileShader;
 var Gj = env._glClear;
 var Hj = env._glBeginTransformFeedback;
 var Ij = env._tcsetattr;
 var Jj = env.__arraySum;
 var Kj = env._emscripten_glLinkProgram;
 var Lj = env._atan;
 var Mj = env._pread;
 var Nj = env._mkport;
 var Oj = env._emscripten_get_pointerlock_status;
 var Pj = env._emscripten_glDrawRangeElements;
 var Qj = env._getc;
 var Rj = env._pthread_create;
 var Sj = env._glGetActiveUniformsiv;
 var Tj = env._pthread_setspecific;
 var Uj = env._rmdir;
 var Vj = env._glColorMask;
 var Wj = env._emscripten_glClearColor;
 var Xj = env._glCopyTexSubImage2D;
 var Yj = env._emscripten_glCreateProgram;
 var Zj = env._glTexParameteri;
 var _j = env._emscripten_glDetachShader;
 var $j = env._SDL_RWFromConstMem;
 var ak = env._setenv;
 var bk = env._emscripten_do_request_fullscreen;
 var ck = env._glGenQueries;
 var dk = env._emscripten_glGetRenderbufferParameteriv;
 var ek = env._emscripten_set_fullscreenchange_callback;
 var fk = env._emscripten_glVertexAttribPointer;
 var gk = env._glTexStorage3D;
 var hk = env._asinf;
 var ik = env._fread;
 var jk = env._emscripten_glDrawArrays;
 var kk = env._emscripten_glPolygonOffset;
 var lk = env._longjmp;
 var mk = env._emscripten_glBlendColor;
 var nk = env._emscripten_get_now_res;
 var ok = env._glGetShaderInfoLog;
 var pk = env._clock_getres;
 var qk = env._emscripten_set_main_loop_timing;
 var rk = env._sbrk;
 var sk = env.___cxa_begin_catch;
 var tk = env._emscripten_glGetProgramiv;
 var uk = env._close;
 var vk = env._emscripten_glUniform4f;
 var wk = env._glStencilOp;
 var xk = env._emscripten_glGetShaderSource;
 var yk = env._cos;
 var zk = env._expf;
 var Ak = env._emscripten_glTexImage2D;
 var Bk = env._glTexSubImage3D;
 var Ck = env.__isLeapYear;
 var Dk = env._emscripten_glBlendEquationSeparate;
 var Ek = env._emscripten_glGetString;
 var Fk = env._emscripten_glIsFramebuffer;
 var Gk = env._gethostname;
 var Hk = env._unsetenv;
 var Ik = env._emscripten_glBindProgramARB;
 var Jk = env._mknod;
 var Kk = env._emscripten_glUniform2i;
 var Lk = env._send;
 var Mk = env._glGenTransformFeedbacks;
 var Nk = env._JS_SystemInfo_GetWidth;
 var Ok = env._atan2;
 var Pk = env._glGetProgramInfoLog;
 var Qk = env._emscripten_glTexParameterf;
 var Rk = env._emscripten_glTexParameteri;
 var Sk = env._fcntl;
 var Tk = env._JS_Sound_Load;
 var Uk = env._JS_Sound_Load_PCM;
 var Vk = env._emscripten_glGenVertexArrays;
 var Wk = env._JS_SystemInfo_GetDocumentURL;
 var Xk = env._Mix_HaltMusic;
 var Yk = env._glDeleteVertexArrays;
 var Zk = env._emscripten_glBindAttribLocation;
 var _k = env._llvm_pow_f32;
 var $k = env._glDepthFunc;
 var al = env.___cxa_allocate_exception;
 var bl = env._emscripten_set_canvas_size;
 var cl = env._unlink;
 var dl = env._freelocale;
 var el = env._emscripten_glClearDepthf;
 var fl = env._atanf;
 var gl = env._printf;
 var hl = env._emscripten_glMatrixMode;
 var il = env._glBlendFuncSeparate;
 var jl = env._emscripten_glNormalPointer;
 var kl = env._emscripten_glHint;
 var ll = env._emscripten_glEnable;
 var ml = env._read;
 var nl = env._emscripten_glBindFramebuffer;
 var ol = env._emscripten_glBindRenderbuffer;
 var pl = env._time;
 var ql = env._emscripten_glGetFramebufferAttachmentParameteriv;
 var rl = env._exit;
 var sl = env._putenv;
 var tl = env._emscripten_glDeleteBuffers;
 var ul = env._glMapBufferRange;
 var vl = env._access;
 var wl = env._JS_Cursor_SetImage;
 var xl = env._emscripten_glShaderBinary;
 var yl = env._emscripten_glGetShaderInfoLog;
 var zl = env._glUniform3fv;
 var Al = env._emscripten_glGetVertexAttribPointerv;
 var Bl = env._pwrite;
 var Cl = env._open;
 var Dl = env._emscripten_glUniform2f;
 var El = env._glUniformBlockBinding;
 var Fl = env._emscripten_glDeleteProgram;
 var Gl = env._glUniform1i;
 var Hl = env._glFlushMappedBufferRange;
 var Il = env._emscripten_glCreateShader;
 var Jl = env._pthread_mutex_destroy;
 var Kl = env._emscripten_glColorPointer;
 var Ll = env._glTransformFeedbackVaryings;
 var Ml = env._SDL_UpperBlit;
 var Nl = env._glGetString;
 var Ol = env._emscripten_glViewport;
 var Pl = env._pthread_cond_broadcast;
 var Ql = env._emscripten_glDepthMask;
 var Rl = env._emscripten_glDrawBuffers;
 var Sl = env._SDL_JoystickNumAxes;
 var Tl = env._glCompileShader;
 var Ul = env._emscripten_exit_pointerlock;
 var Vl = env._abort;
 var Wl = env._emscripten_glGenerateMipmap;
 var Xl = env._JS_Sound_GetLoadState;
 var Yl = env._glTexImage2D;
 var Zl = env._emscripten_glGenFramebuffers;
 var _l = env._glFlush;
 var $l = env._emscripten_glLoadIdentity;
 var am = env._glDeleteShader;
 var bm = env._emscripten_glShaderSource;
 var cm = env._glGenVertexArrays;
 var dm = env._SDL_CloseAudio;
 var em = env._emscripten_asm_const_int;
 var fm = env._emscripten_get_fullscreen_status;
 var gm = env._JS_Sound_SetVelocity;
 var hm = env._glGetError;
 var im = env._glGenRenderbuffers;
 var jm = env._strerror;
 var km = env._emscripten_glSampleCoverage;
 var lm = env._emscripten_glFrustum;
 var mm = env._Mix_FreeChunk;
 var nm = env._emscripten_glDepthRangef;
 var om = env._JS_Sound_SetPitch;
 var pm = env._glPixelStorei;
 var qm = env._emscripten_glIsTexture;
 var rm = env._fputs;
 var sm = env._emscripten_glBindVertexArray;
 var tm = env._glStencilMask;
 var um = env._emscripten_glActiveTexture;
 var vm = env._emscripten_set_keyup_callback;
 var wm = env._emscripten_glDeleteVertexArrays;
 var xm = env._glDeleteTransformFeedbacks;
 var ym = env._emscripten_glUniform2iv;
 var zm = env._lstat;
 var Am = env._pthread_mutexattr_init;
 var Bm = env._emscripten_webgl_init_context_attributes;
 var Cm = env._SDL_GL_SwapBuffers;
 var Dm = env._opendir;
 var Em = env.__reallyNegative;
 var Fm = env._glGetActiveUniform;
 var Gm = env._sqrt;
 var Hm = ea(0);
 const Im = ea(0);
 
// EMSCRIPTEN_START_FUNCS
function Qo(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function Ro(){return i|0}function So(a){a=a|0;i=a}function To(a,b){a=a|0;b=b|0;if(!s){s=a;t=b}}function Uo(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0]}function Vo(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0];a[k+4>>0]=a[b+4>>0];a[k+5>>0]=a[b+5>>0];a[k+6>>0]=a[b+6>>0];a[k+7>>0]=a[b+7>>0]}function Wo(a){a=a|0;H=a}function Xo(){return H|0}function Yo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d;if((c[15652]|0)!=0?(f=b,g=f&-4096,h=c[(c[58020+(f>>>22<<2)>>2]|0)+((f>>>12&1023)<<2)>>2]|0,(h|0)!=0):0){if(h>>>0<4096>>>0){f=h;j=g;while(1){k=j+(0-f<<12)|0;l=k;m=c[(c[58020+(l>>>22<<2)>>2]|0)+((l>>>12&1023)<<2)>>2]|0;if(m>>>0<4096>>>0){f=m;j=k}else{n=k;o=m;break}}p=o;q=n;r=n}else{p=h;q=g;r=b}if((a[p+13>>0]&4)==0?(g=r,r=g&-4,h=c[p+16>>2]|0,p=((g&4092)>>>0)%(h>>>0)|0,g=r+(h-p)|0,!(g>>>0>(q+4096|0)>>>0&h>>>0<4097)):0)s=g>>>0>b>>>0?r+(0-p)|0:0;else s=0}else s=0;p=s;r=c[(c[58020+(p>>>22<<2)>>2]|0)+((p>>>12&1023)<<2)>>2]|0;p=a[r+12>>0]|0;b=c[r+16>>2]|0;if(!(p<<24>>24)){t=62160;c[e>>2]=s;u=e+4|0;c[u>>2]=b;v=e+8|0;c[v>>2]=t;_o(62120,e);i=d;return}t=p<<24>>24==2?62168:62184;c[e>>2]=s;u=e+4|0;c[u>>2]=b;v=e+8|0;c[v>>2]=t;_o(62120,e);i=d;return}function Zo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;if(!(c[15652]|0)){e=0;i=d;return e|0}f=b;g=f&-4096;h=c[(c[58020+(f>>>22<<2)>>2]|0)+((f>>>12&1023)<<2)>>2]|0;if(!h){e=0;i=d;return e|0}if(h>>>0<4096>>>0){f=h;j=g;while(1){k=j+(0-f<<12)|0;l=k;m=c[(c[58020+(l>>>22<<2)>>2]|0)+((l>>>12&1023)<<2)>>2]|0;if(m>>>0<4096>>>0){f=m;j=k}else{n=k;o=m;break}}p=o;q=n;r=n}else{p=h;q=g;r=b}if(a[p+13>>0]&4){e=0;i=d;return e|0}g=r;r=g&-4;h=c[p+16>>2]|0;p=((g&4092)>>>0)%(h>>>0)|0;g=r+(h-p)|0;if(g>>>0>(q+4096|0)>>>0&h>>>0<4097){e=0;i=d;return e|0}e=g>>>0>b>>>0?r+(0-p)|0:0;i=d;return e|0}function _o(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+1056|0;f=e+16|0;g=e;c[g>>2]=d;d=f+1024|0;a[d>>0]=21;uEi(f,1024,b,g)|0;if((a[d>>0]|0)!=21){Nq(67824);Vl()}d=SEi(f|0)|0;if(!d){i=e;return}else h=0;do{g=gf(2,f+h|0,d-h|0)|0;h=g+h|0}while((g|0)!=-1&h>>>0<d>>>0);i=e;return}function $o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=c[15626]|0;e=a+7&-8;a=d+e|0;c[15626]=a;if(a>>>0<=(c[27]|0)>>>0){f=d;i=b;return f|0}while(1){d=rk(0)|0;a=c[16302]|0;g=a+-1&d;if(e>>>0>65535){h=a;j=g;k=3;break}if((g|0)!=0?(rk(a-g|0)|0)==(-1|0):0){k=11;break}g=rk(65536)|0;a=g;if((a|0)==0|(a|0)==-1){k=11;break}a=g+65536|0;c[27]=a;c[28]=a;c[15626]=g+e;if((e|0)<=65536){f=g;k=16;break}}if((k|0)==3){do if((e|0)<0)l=0;else{if((j|0)!=0?(rk(h-j|0)|0)==(-1|0):0){l=0;break}g=rk(e|0)|0;l=(g|0)==(-1|0)?0:g}while(0);c[15626]=(c[15626]|0)+(0-e);c[28]=l+e;f=l;i=b;return f|0}else if((k|0)==11){Mq(62512,0);c[15626]=(c[15626]|0)+(0-e);l=rk(0)|0;j=c[16302]|0;h=j+-1&l;if((e|0)<0){f=0;i=b;return f|0}if((h|0)!=0?(rk(j-h|0)|0)==(-1|0):0){f=0;i=b;return f|0}h=rk(e|0)|0;f=(h|0)==(-1|0)?0:h;i=b;return f|0}else if((k|0)==16){i=b;return f|0}return 0}function ap(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;do if(1==0&(c[4]|0)==0){c[2]=$o(32768)|0;d=$o(32768)|0;c[4]=d;e=c[2]|0;if((e|0)==0|(d|0)==0){_o(62200,b);Nq(0);rl(1)}else{PEi(e|0,0,32768)|0;PEi(d|0,0,32768)|0;break}}while(0);c[6]=$o(32768)|0;d=$o(32768)|0;c[8]=d;e=c[6]|0;if((e|0)==0|(d|0)==0){_o(62200,b);Nq(0);rl(1)}else{PEi(e|0,0,32768)|0;PEi(d|0,0,32768)|0;i=a;return}}function bp(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;i=i+16|0;b=a;d=c[2]|0;e=c[6]|0;c[2]=c[4];f=c[8]|0;c[6]=f;if(!1)PEi(d|0,0,32768)|0;PEi(e|0,0,32768)|0;c[4]=d;c[8]=e;e=c[15926]|0;if(!e)g=0;else{d=0;h=0;while(1){j=c[16800+(d<<3)>>2]|0;k=j+((c[16804+(d<<3)>>2]|0)>>>12<<12)|0;if(j>>>0<k>>>0){l=j;j=0;while(1){m=l;n=((1<<(m>>>12&31)&c[f+((m>>>17&8191)<<2)>>2]|0)!=0&1)+j|0;l=l+4096|0;if(l>>>0>=k>>>0){o=n;break}else j=n}}else o=0;j=o+h|0;d=d+1|0;if((d|0)==(e|0)){p=j;break}else h=j}g=p<<12}c[10]=g;if((c[15560]|0)==2){c[b>>2]=g;cp(62248,b);q=c[10]|0}else q=g;if(!q)r=c[12]|0;else{g=(((c[14]|0)>>>0)/(q>>>0)|0)<<12;c[12]=g;r=g}if(r>>>0<12288){c[12]=12288;i=a;return}if(r>>>0<=8388608){i=a;return}c[12]=8388608;i=a;return}function cp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1056|0;f=e+16|0;g=e;c[g>>2]=d;d=f+1024|0;a[d>>0]=21;uEi(f,1024,b,g)|0;if((a[d>>0]|0)!=21){Nq(67824);Vl()}d=SEi(f|0)|0;if(!d){i=e;return}else h=0;while(1){g=gf(2,f+h|0,d-h|0)|0;b=g+h|0;if((g|0)==-1){j=7;break}if(b>>>0<d>>>0)h=b;else{k=b;break}}if((j|0)==7){Nq(67880);Vl()}if((k|0)<0){Nq(67880);Vl()}else{i=e;return}}function dp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(2555==(-1|0))return b|0;else{Nq(62336);Vl()}return 0}function ep(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;fp();if(c[15576]|0){i=d;return}c[15576]=1;e=(cj(62376)|0)!=0;if(!((c[15560]|0)==0|e^1))cp(62400,d);c[128+(a<<2)>>2]=(b|0)==0?221:b;if((c[15612]|0)>>>0<=a>>>0){Nq(62456);Vl()}b=hp(1028,0)|0;if(!b){Nq(67928);Vl()}PEi(b|0,0,1028)|0;c[15580]=b;f=c[16182]|0;g=f+1|0;c[16182]=g;h=g>>>0>16;do if(e)if(h){Nq(67976);Vl()}else{c[62632+(f*20|0)>>2]=b;c[62636+(f*20|0)>>2]=0;c[62640+(f*20|0)>>2]=0;c[62644+(f*20|0)>>2]=1;c[62648+(f*20|0)>>2]=1;break}else if(h){Nq(67976);Vl()}else{c[62632+(f*20|0)>>2]=b;c[62636+(f*20|0)>>2]=0;c[62640+(f*20|0)>>2]=-17;c[62644+(f*20|0)>>2]=0;c[62648+(f*20|0)>>2]=1;break}while(0);c[15578]=f;if(e){c[15582]=b;i=d;return}b=hp(1028,0)|0;if(!b){Nq(67928);Vl()}PEi(b|0,0,1028)|0;c[15582]=b;e=c[16182]|0;f=e+1|0;c[16182]=f;if(f>>>0>16){Nq(67976);Vl()}c[62632+(e*20|0)>>2]=b;c[62636+(e*20|0)>>2]=0;c[62640+(e*20|0)>>2]=a<<2|258;c[62644+(e*20|0)>>2]=0;c[62648+(e*20|0)>>2]=1;i=d;return}function fp(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b;e=b+4|0;if(c[15652]|0){i=b;return}c[16302]=4096;if(!(cj(67032)|0)){if(cj(67056)|0)c[15560]=1}else c[15560]=2;if(cj(67072)|0)c[16180]=1;if(cj(67096)|0)c[15976]=1;if(cj(67112)|0)c[16372]=1;if(cj(67168)|0)c[15656]=1;if(cj(67184)|0)c[16184]=1;if(cj(67208)|0)c[15944]=2147483647;if(cj(67232)|0)Mq(67248,0);f=cj(67312)|0;do if(f){g=xEi(f)|0;if((g|0)<5){Mq(67336,0);break}else{c[16030]=g;break}}while(0);f=cj(67432)|0;if((f|0)!=0?(g=wEi(f)|0,(g|0)>0):0)c[16022]=g;g=cj(67456)|0;do if(g){f=xEi(g)|0;if((f|0)<1){Mq(67488,0);break}else{c[15944]=f;break}}while(0);g=cj(67576)|0;if((g|0)!=0?(f=wEi(g)|0,(f|0)>0):0)c[16028]=f;if(1)c[15665]=-4;vq(56,62116);vq(62632,62952);if(!(c[15756]|0))c[15756]=-4;if(!((c[15654]|0)==0?(cj(67600)|0)==0:0)){if((c[15560]|0)==2)cp(68120,d);c[16522]=1;c[15654]=1}f=$o(4108)|0;c[14504]=f;if(!f){_o(62568,d);Nq(0);rl(1)}PEi(f|0,0,4108)|0;f=0;do{c[58020+(f<<2)>>2]=c[14504];f=f+1|0}while((f|0)!=1024);ap();nq(4096);f=cj(67624)|0;if(!f)h=16;else{a:do if(a[f>>0]|0){g=CEi(f,e,10)|0;j=c[e>>2]|0;k=a[j>>0]|0;l=k<<24>>24;b:do if(!(k<<24>>24))m=g;else{if(a[j+1>>0]|0){n=0;o=56;break a}switch(l|0){case 107:case 75:{m=g<<10;break b;break}case 109:case 77:{m=g<<20;break b;break}case 103:case 71:{m=g<<30;break b;break}default:{n=0;o=56;break a}}}while(0);if(m>>>0<65537){n=m;o=56}else p=m}else{n=0;o=56}while(0);if((o|0)==56){Mq(67648,f);p=n}h=p>>>12}p=cj(67704)|0;if(p){c:do if(!(a[p>>0]|0))q=0;else{n=CEi(p,d,10)|0;f=c[d>>2]|0;o=a[f>>0]|0;if(!(o<<24>>24)){q=n;break}if(a[f+1>>0]|0){q=0;break}switch(o<<24>>24|0){case 107:case 75:{q=n<<10;break c;break}case 109:case 77:{q=n<<20;break c;break}case 103:case 71:{q=n<<30;break c;break}default:{q=0;break c}}}while(0);if(q>>>0<h<<12>>>0)Mq(67728,p);if(!(c[16300]|0))c[16300]=2;c[16298]=q}if(!(Tp(h)|0)){_o(67784,d);Nq(0);rl(1)}c[15]=(c[15]|0)+h;do if(!1){if(a[12700]|0)break;a[12700]=1;a[16796]=1}else PEi(12700,1,4096)|0;while(0);c[869]=1;if((256-1|0)>=1){h=8;q=257-1|0;p=1;do{c[3476+(p<<2)>>2]=h+p>>3;p=p+1|0}while((p|0)!=(q|0))}c[15652]=1;if(c[16180]|0){zp(68024,d);uq();zp(68048,d);Sp();zp(68072,d);yp();zp(68096,d);zq()}if(0==0|(c[15654]|0)!=0)Hp(1)|0;if(!(c[15976]|0)){i=b;return}wh(69)|0;i=b;return}function gp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;if(b>>>0>=2048&(2048-1|0)>>>0<b>>>0){f=c[16020]|0;if(!((f|0)==(c[17070]|0)|(c[15652]|0)==0)){g=c[16406]|0;do if(g){if(0){if((c[16476]|0)==(f|0))break;c[16476]=f;if(!0)break;fa();break}h=a[65832]|0;j=h&255;if(h<<24>>24){h=(c[16460]|0)+1|0;c[16460]=h;if(h>>>0<1<<j>>>0)break;c[16460]=0}a[65832]=j+1;j=1;h=g;k=0;while(1){l=j?c[25]|0:k;m=h+4|0;c[16406]=c[m>>2];c[m>>2]=0;m=h+12|0;In[c[h+8>>2]&4095](c[h>>2]|0,c[m>>2]|0);c[m>>2]=0;h=c[16406]|0;if(!h){n=l;break}else{j=0;k=l}}k=c[25]|0;if((k|0)!=(n|0))c[26]=k-n+(c[26]|0);a[65832]=0}while(0);c[17070]=c[16020]}n=hp(b,c[15578]|0)|0;if(!n){o=Iq(b)|0;i=e;return o|0}else{c[n>>2]=d;o=n;i=e;return o|0}}n=c[3476+(b<<2)>>2]|0;g=(c[15580]|0)+(n<<2)|0;f=c[g>>2]|0;if(!f){k=c[16020]|0;if(!((k|0)==(c[17070]|0)|(c[15652]|0)==0)){j=c[16406]|0;do if(j){if(0){if((c[16476]|0)==(k|0))break;c[16476]=k;if(!0)break;fa();break}h=a[65832]|0;l=h&255;if(h<<24>>24){h=(c[16460]|0)+1|0;c[16460]=h;if(h>>>0<1<<l>>>0)break;c[16460]=0}a[65832]=l+1;l=1;h=j;m=0;while(1){p=l?c[25]|0:m;q=h+4|0;c[16406]=c[q>>2];c[q>>2]=0;q=h+12|0;In[c[h+8>>2]&4095](c[h>>2]|0,c[q>>2]|0);c[q>>2]=0;h=c[16406]|0;if(!h){r=p;break}else{l=0;m=p}}m=c[25]|0;if((m|0)!=(r|0))c[26]=m-r+(c[26]|0);a[65832]=0}while(0);c[17070]=c[16020]}r=hp(b,c[15578]|0)|0;if(!r){o=Iq(b)|0;i=e;return o|0}else s=r}else{c[g>>2]=c[f>>2];c[22]=(c[22]|0)+(n<<3);s=f}c[s>>2]=d;o=s;i=e;return o|0}function hp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;if(a>>>0>=2048&(2048-1|0)>>>0<a>>>0){e=1+a|0;f=kp(e,b,0)|0;g=e+4095&-4096;do if(!f)h=0;else{if(0==0?(c[62648+(b*20|0)>>2]|0)==0:0){h=f;break}PEi(f|0,0,g|0)|0;h=f}while(0);j=h;k=(c[22]|0)+a|0}else{h=3476+(a<<2)|0;f=c[h>>2]|0;g=62632+(b*20|0)|0;e=(c[g>>2]|0)+(f<<2)|0;l=c[e>>2]|0;do if(!l){if(!f){if((c[15652]|0)==0?(fp(),m=c[h>>2]|0,(m|0)!=0):0)n=m;else{m=(a+8|0)>>>3;o=m*7|0;if(!(c[3476+(o<<2)>>2]|0)){p=m*6|0;while(1)if(!(c[3476+(p<<2)>>2]|0)){q=m;r=p;break}else p=p+1|0}else{p=o;while(1){s=p+1|0;if(!(c[3476+(s<<2)>>2]|0)){t=s;u=p;break}else p=s}p=9+u|0;o=(p>>>3)+(p>>>6)|0;q=o>>>0<m>>>0?m:o;r=t}o=q+1&-2;p=(512/((512/((o>>>0>256?256:o)>>>0)|0)>>>0)|0)&1022;o=(p<<3)-1|0;if(r>>>0>o>>>0)n=0;else{s=r;do{c[3476+(s<<2)>>2]=p;s=s+1|0}while(s>>>0<=o>>>0);n=c[h>>2]|0}}o=(c[g>>2]|0)+(n<<2)|0;s=c[o>>2]|0;if(!s){v=n;w=o}else{x=n;y=s;z=o;break}}else{v=f;w=e}o=62636+(b*20|0)|0;do if(!(c[o>>2]|0)){s=$o(1028)|0;if(!s){A=0;i=d;return A|0}else{PEi(s|0,0,1028)|0;c[o>>2]=s;break}}while(0);o=op(v,b)|0;if(!o){A=0;i=d;return A|0}else{x=v;y=o;z=w}}else{x=f;y=l;z=e}while(0);c[z>>2]=c[y>>2];c[y>>2]=0;j=y;k=(c[22]|0)+(x<<3)|0}c[22]=k;A=j;i=d;return A|0}function ip(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=b;b=g>>>12;h=c[(c[58020+(g>>>22<<2)>>2]|0)+((b&1023)<<2)>>2]|0;if(h>>>0>=4096>>>0){if(!(a[h+13>>0]&4)){c[e>>2]=b;c[e+4>>2]=h;j=h;i=f;return j|0}if(1){e=b&262143;if(h){k=e>>>5;l=1<<(b&31);if(!(c[(c[6]|0)+(k<<2)>>2]&l)){j=0;i=f;return j|0}else{m=l;n=k}}else{m=1<<(b&31);n=e>>>5}e=(c[8]|0)+(n<<2)|0;c[e>>2]=c[e>>2]|m;j=0;i=f;return j|0}if(!(a[16796+(g&3)>>0]|0)){j=0;i=f;return j|0}m=b&262143;if(h){e=m>>>5;n=1<<(b&31);if(!(c[(c[2]|0)+(e<<2)>>2]&n)){j=0;i=f;return j|0}else{o=n;p=e}}else{o=1<<(b&31);p=m>>>5}m=(c[4]|0)+(p<<2)|0;c[m>>2]=c[m>>2]|o;j=0;i=f;return j|0}o=(h|0)==0;if(!1){if(!o){j=0;i=f;return j|0}if(!(a[16796+(g&3)>>0]|0)){j=0;i=f;return j|0}m=(c[4]|0)+((g>>>17&8191)<<2)|0;c[m>>2]=c[m>>2]|1<<(b&31);j=0;i=f;return j|0}if(o){o=(c[8]|0)+((g>>>17&8191)<<2)|0;c[o>>2]=c[o>>2]|1<<(b&31);j=0;i=f;return j|0}o=g&-4096;m=h;while(1){o=o+(0-(m<<12))|0;h=o;p=c[(c[58020+(h>>>22<<2)>>2]|0)+((h>>>12&1023)<<2)>>2]|0;if(p>>>0>=4096>>>0){q=h;r=p;break}else m=p}m=d[r+13>>0]|0;if(m&1){j=0;i=f;return j|0}if((m&4|0)==0?(g-q|0)<(c[r+16>>2]|0):0){j=r;i=f;return j|0}r=g>>>17&8191;g=1<<(b&31);if(!(c[(c[6]|0)+(r<<2)>>2]&g)){j=0;i=f;return j|0}b=(c[8]|0)+(r<<2)|0;c[b>>2]=c[b>>2]|g;j=0;i=f;return j|0}function jp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;e=a;f=e+b|0;a:do if(e>>>0<f>>>0){b=e;g=a;while(1){h=b>>>22;j=58020+(h<<2)|0;if((c[j>>2]|0)==(c[14504]|0)){k=$o(4108)|0;if(!k){l=0;break}c[j>>2]=k;PEi(k|0,0,4104)|0;c[k+4104>>2]=h;j=c[15622]|0;b:do if(!j){m=0;n=62488;o=7}else{p=j;q=0;r=62488;while(1){s=p+4096|0;if((c[p+4104>>2]|0)>>>0>=h>>>0){t=p;u=q;v=r;break}w=c[s>>2]|0;if(!w){m=p;n=s;o=7;break b}else{x=p;p=w;r=s;q=x}}c[k+4100>>2]=u;c[t+4100>>2]=k;y=t;z=v}while(0);if((o|0)==7){o=0;c[k+4100>>2]=m;c[15624]=k;y=0;z=n}c[k+4096>>2]=y;c[z>>2]=k}g=g+4194304|0;b=g;if(b>>>0>=f>>>0)break a}i=d;return l|0}while(0);z=(f+-1|0)>>>22;y=58020+(z<<2)|0;if((c[y>>2]|0)==(c[14504]|0)){n=$o(4108)|0;if(!n){l=0;i=d;return l|0}c[y>>2]=n;PEi(n|0,0,4104)|0;c[n+4104>>2]=z;y=c[15622]|0;c:do if(!y){A=0;B=62488;o=16}else{m=y;v=0;t=62488;while(1){u=m+4096|0;if((c[m+4104>>2]|0)>>>0>=z>>>0){C=m;D=v;E=t;break}b=c[u>>2]|0;if(!b){A=m;B=u;o=16;break c}else{g=m;m=b;t=u;v=g}}c[n+4100>>2]=D;c[C+4100>>2]=n;F=C;G=E}while(0);if((o|0)==16){c[n+4100>>2]=A;c[15624]=n;F=0;G=B}c[n+4096>>2]=F;c[G>>2]=n}n=a+4096|0;G=n;if(G>>>0<f>>>0){H=G;I=a;J=n}else{l=1;i=d;return l|0}while(1){n=H-e>>12;c[(c[58020+(H>>>22<<2)>>2]|0)+((H>>>12&1023)<<2)>>2]=n>>>0>4095?4095:n;n=I+8192|0;H=n;if(H>>>0>=f>>>0){l=1;break}else{a=J;J=n;I=a}}i=d;return l|0}function kp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+7&-8;a=f+4095|0;g=a>>>12;if(!(c[15652]|0))fp();if(!((c[15654]|0)==0|(c[15656]|0)!=0))lp(g);h=mp(f,b,d)|0;a:do if(!h){j=(d|0)!=0&1;k=0;while(1){if(!(np(g,j,k)|0)){l=0;break}m=mp(f,b,d)|0;if(!m)k=1;else{n=m;break a}}i=e;return l|0}else n=h;while(0);if(a>>>0>8191?(a=(c[19]|0)+(g<<12)|0,c[19]=a,a>>>0>(c[20]|0)>>>0):0)c[20]=a;l=n;i=e;return l|0}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;if(c[15656]|0){i=b;return}if((c[15654]|0)==0|(c[16462]|0)==0){Gp();i=b;return}d=c[16118]|0;e=a*10|0;if((d|0)<(e|0)){a=d;do{a=a+1|0;if(Lp(0)|0){f=6;break}}while((a|0)<(e|0));do if((f|0)==6){if((c[16034]|0)<1&(c[16030]|0)!=999999){c[16032]=Xe()|0;if(!(Jp(2)|0)){c[16034]=(c[16034]|0)+1;break}}else Jp(1)|0;Kp()}while(0);g=c[16118]|0}else g=d;if((g|0)>0){d=g-e|0;c[16118]=d;h=d}else h=g;if((h|0)>=0){i=b;return}c[16118]=0;i=b;return}function mp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=a+4095|0;if((f|0)<0){g=0;i=e;return g|0}h=f>>>12;if(f>>>0>=135168)if(f>>>0>1048575)j=60;else j=((h+-32|0)/8|0)+32|0;else j=h;h=Dp(a,b,d,j,0)|0;if(h){g=h;i=e;return g|0}a:do if((c[15656]|0)==0?(h=c[14]|0,!((c[15654]|0)!=0?1:(h-(c[18]|0)|0)>>>0<(c[15]|0)>>>0)):0){f=c[16020]|0;if((c[16060]|0)==(f|0))k=c[16058]|0;else{c[16060]=f;f=(((c[867]<<1)+0+((c[868]|0)>>>2)|0)>>>0)/((c[16028]|0)>>>0)|0;l=(f|0)!=0?f:1;c[16058]=l;k=l}l=c[22]|0;f=c[26]|0;m=(c[16054]|0)-(c[15740]|0)+l+(c[23]|0)-(c[25]|0)+f|0;n=((m|0)>(l|0)?l:m)+(c[24]|0)|0;m=l>>>3;if(!(h>>>0<(c[16056]|0)>>>0?((n|0)<(m|0)?m:n)>>>0<k>>>0:0))if(f>>>0>h>>>4>>>0)o=0;else{h=c[20]|0;f=c[19]|0;n=60;while(1){f=(c[63280+(n<<2)>>2]|0)+f|0;if(f>>>0>=h>>>0){o=n;break a}if((n|0)<=0){o=0;break}else n=n+-1|0}}else o=60}else o=60;while(0);k=((j|0)<32&1)+j|0;if((k|0)>(o|0)){g=0;i=e;return g|0}else p=k;while(1){k=Dp(a,b,d,p,1)|0;if(k){g=k;q=19;break}if((p|0)<(o|0))p=p+1|0;else{g=0;q=19;break}}if((q|0)==19){i=e;return g|0}return 0}function np(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=c[15654]|0;a:do if(!(c[15656]|g)){h=0!=0;j=c[22]|0;do if(!(h&(j|0)!=0)){if((c[16328]|0)>>>0>((c[16330]|0)+500|0)>>>0?(c[24]|c[16332]|0)!=0:0)break;k=c[16020]|0;if((c[16060]|0)==(k|0))l=c[16058]|0;else{c[16060]=k;k=((((c[867]<<1)+0+((c[868]|0)>>>2)|0)>>>0)/((c[16028]|0)>>>0)|0)>>>((g|0)!=0&1);m=(k|0)!=0?k:1;c[16058]=m;l=m}m=(c[16054]|0)-(c[15740]|0)+j+(c[23]|0)-(c[25]|0)+(c[26]|0)|0;k=((m|0)>(j|0)?j:m)+(c[24]|0)|0;m=j>>>3;if(((k|0)<(m|0)?m:k)>>>0<l>>>0?(c[14]|0)>>>0<(c[16056]|0)>>>0:0){n=1;break a}}while(0);if(!j)o=1;else o=h&(d|0)!=0?1:1;k=Hp(o)|0;if((k|0)!=1&(d|0)!=0)n=k;else{c[16330]=c[16328];c[16332]=c[24];p=1;i=e;return p|0}}else n=1;while(0);d=(((c[14]|0)>>>0)/(c[16028]<<12>>>0)|0)+a|0;if(d>>>0>2048){if(!b){b=(c[12]|0)>>>12<<1;q=b>>>0>a>>>0?a:b}else q=4;b=q+a|0;r=b>>>0>2048?b:2048}else r=d;if((Tp(r)|0)==0?(Tp(a)|0)==0:0){if(!n){Hp(1)|0;p=1;i=e;return p|0}n=c[15980]|0;c[15980]=n+1;if(n>>>0<(c[16300]|0)>>>0){Mq(65336,0);Hp(1)|0;p=1;i=e;return p|0}else{Mq(65392,(c[14]|0)>>>20);p=0;i=e;return p|0}}if((c[15980]|0)==0|(c[15560]|0)==0){p=1;i=e;return p|0}cp(65456,f);p=1;i=e;return p|0}function op(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=62632+(e*20|0)|0;h=(c[g>>2]|0)+(a<<2)|0;if(!a){j=0;i=f;return j|0}k=62636+(e*20|0)|0;l=0;m=0;a:while(1){n=l;while(1){o=c[h>>2]|0;if(o){p=o;break a}if((c[15654]|0)!=0&(c[16030]|0)!=999999)lp(1);o=c[k>>2]|0;q=(c[g>>2]|0)+(a<<2)|0;b:do if(o){r=o+(a<<2)|0;do{s=c[r>>2]|0;if(!s)break b;t=s;u=t>>>12&1023;v=58020+(t>>>22<<2)|0;c[r>>2]=c[c[(c[v>>2]|0)+(u<<2)>>2]>>2];t=c[(c[v>>2]|0)+(u<<2)>>2]|0;u=c[t+16>>2]|0;v=d[t+12>>0]|0;w=(c[62632+(v*20|0)>>2]|0)+(u>>>3<<2)|0;b[t+14>>1]=c[16020];c[w>>2]=iq(s,t,u,c[62648+(v*20|0)>>2]|0,c[w>>2]|0,64632)|0}while((c[q>>2]|0)==0)}while(0);q=c[h>>2]|0;if(q){p=q;break a}xp(a,e);q=c[h>>2]|0;if(q){p=q;break a}if(!((c[16030]|0)!=999999|(c[15654]|0)==0|m)){x=n;break}if(!(np(1,0,n)|0)){j=0;y=17;break a}else n=1}lp(1);l=x;m=1}if((y|0)==17){i=f;return j|0}c[15980]=0;j=p;i=f;return j|0}function pp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(c[15738]|0)qp();f=c[16406]|0;do if(f){if(0){g=c[16020]|0;if((c[16476]|0)==(g|0))break;c[16476]=g;if(!0)break;fa();break}g=a[65832]|0;h=g&255;if(g<<24>>24){g=(c[16460]|0)+1|0;c[16460]=g;if(g>>>0<1<<h>>>0)break;c[16460]=0}a[65832]=h+1;h=1;g=f;j=0;while(1){k=h?c[25]|0:j;l=g+4|0;c[16406]=c[l>>2];c[l>>2]=0;l=g+12|0;In[c[g+8>>2]&4095](c[g>>2]|0,c[l>>2]|0);c[l>>2]=0;g=c[16406]|0;if(!g){m=k;break}else{h=0;j=k}}j=c[25]|0;if((j|0)!=(m|0))c[26]=j-m+(c[26]|0);a[65832]=0}while(0);if(b>>>0>=2048&(2048-1|0)>>>0<b>>>0){m=b+8&-8;if(m>>>0<b>>>0){n=Iq(b)|0;i=e;return n|0}f=(m+4095|0)>>>12;j=c[62648+(d*20|0)>>2]|0;h=kp(m,d,0)|0;g=(h|0)!=0;if(g&0!=0)PEi(h|0,0,f<<12|0)|0;c[22]=(c[22]|0)+m;if(0==0&(j|0)!=0&g){PEi(h|0,0,f<<12|0)|0;o=h}else o=h}else o=hp(b,d)|0;if(o){n=o;i=e;return n|0}n=Iq(b)|0;i=e;return n|0}function qp(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+176|0;b=a;d=a+8|0;if(c[16668]|0){i=a;return}e=c[15738]|0;c[16668]=1;f=c[16666]|0;g=f<<2;YEi(d|0,66504,g|0)|0;c[16666]=0;PEi(66504,0,g|0)|0;if(!0)h=0;else{fa();h=e}if(!f){if(h)j=8}else{c[b>>2]=f;_o(66680,b);b=0;do{h=c[d+(b<<2)>>2]|0;Yo(h);up(h);b=b+1|0}while((b|0)!=(f|0));j=8}if((j|0)==8?(cj(66712)|0)!=0:0){Nq(66736);Vl()}c[16668]=0;i=a;return}function rp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;if(a>>>0>=2048&(2048-1|0)>>>0<a>>>0){d=pp(a,0)|0;i=b;return d|0}e=c[3476+(a<<2)>>2]|0;f=1412+(e<<2)|0;g=c[f>>2]|0;if(!g){d=pp(a,0)|0;i=b;return d|0}else{c[f>>2]=c[g>>2];c[22]=(c[22]|0)+(e<<3);d=g;i=b;return d|0}return 0}function sp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;if(a>>>0>=2048&(2048-1|0)>>>0<a>>>0){d=pp(a,1)|0;i=b;return d|0}e=c[3476+(a<<2)>>2]|0;f=384+(e<<2)|0;g=c[f>>2]|0;if(!g){d=pp(a,1)|0;i=b;return d|0}else{c[f>>2]=c[g>>2];c[g>>2]=0;c[22]=(c[22]|0)+(e<<3);d=g;i=b;return d|0}return 0}function tp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;if(a>>>0>2047&(2048-1|0)>>>0<a>>>0){d=pp(a,2)|0;if(!d){e=0;i=b;return e|0}f=d;g=c[(c[58020+(f>>>22<<2)>>2]|0)+((f>>>12&1023)<<2)>>2]|0;f=g+36|0;c[f>>2]=c[f>>2]|1;c[g+32>>2]=1;e=d;i=b;return e|0}d=((1!=0&(a|0)!=0)<<31>>31)+a|0;a=c[3476+(d<<2)>>2]|0;g=2440+(a<<2)|0;f=c[g>>2]|0;if(!f){e=pp(d,2)|0;i=b;return e|0}else{c[g>>2]=c[f>>2];c[f>>2]=0;g=a<<3;c[22]=(c[22]|0)+g;c[15740]=(c[15740]|0)+g;e=f;i=b;return e|0}return 0}function up(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if(!b){i=d;return}e=b;f=e&-4096;g=c[(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)>>2]|0;e=c[g+16>>2]|0;h=e>>>3;j=a[g+12>>0]|0;g=j&255;if(e>>>0<2056){c[25]=(c[25]|0)+e;if(j<<24>>24==2)c[15740]=(c[15740]|0)-e;if(c[62648+(g*20|0)>>2]|0)PEi(b+4|0,0,e+-4|0)|0;k=(c[62632+(g*20|0)>>2]|0)+(h<<2)|0;c[b>>2]=c[k>>2];c[k>>2]=b;i=d;return}else{b=e+4095|0;c[25]=(c[25]|0)+e;if(j<<24>>24==2)c[15740]=(c[15740]|0)-e;if(b>>>0>8191)c[19]=(c[19]|0)-(b&-4096);vp(f);i=d;return}}function vp(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+16|0;f=e;g=b;h=g>>>12&1023;j=58020+(g>>>22<<2)|0;k=c[(c[j>>2]|0)+(h<<2)>>2]|0;l=k+16|0;m=(c[l>>2]|0)+4095&-4096;if((m|0)<1){Nq(63928);Vl()}n=b+4096|0;o=n;p=m+g|0;if(o>>>0<p>>>0){g=o;o=b;q=n;while(1){c[(c[58020+(g>>>22<<2)>>2]|0)+((g>>>12&1023)<<2)>>2]=0;n=o+8192|0;g=n;if(g>>>0>=p>>>0)break;else{r=q;q=n;o=r}}}c[l>>2]=m;o=k+13|0;q=d[o>>0]|0;if(q&4){if(!(c[15560]|0)){Nq(64040);Vl()}c[f>>2]=b;cp(63992,f);Nq(64040);Vl()}a[o>>0]=q|4;q=b+m|0;o=q>>>12&1023;f=58020+(q>>>22<<2)|0;q=c[(c[f>>2]|0)+(o<<2)>>2]|0;p=Ap(b)|0;if(((q|0)!=0?(a[q+13>>0]&4)!=0:0)?(g=c[q+16>>2]|0,r=g+m|0,(r|0)>0):0){n=g>>>12;if(g>>>0>=135168)if(g>>>0>1048575)s=60;else s=((n+-32|0)/8|0)+32|0;else s=n;n=q+4|0;t=c[n>>2]|0;u=c[q>>2]|0;if(!t)c[63032+(s<<2)>>2]=u;else{v=t;c[c[(c[58020+(v>>>22<<2)>>2]|0)+((v>>>12&1023)<<2)>>2]>>2]=u}u=63280+(s<<2)|0;c[u>>2]=(c[u>>2]|0)-g;g=c[q>>2]|0;if(g){q=g;c[(c[(c[58020+(q>>>22<<2)>>2]|0)+((q>>>12&1023)<<2)>>2]|0)+4>>2]=c[n>>2]}c[l>>2]=r;l=(c[f>>2]|0)+(o<<2)|0;o=c[l>>2]|0;c[o>>2]=c[17068];c[17068]=o;c[l>>2]=0;w=r}else w=m;if((p|0)!=0?(r=p,l=c[(c[58020+(r>>>22<<2)>>2]|0)+((r>>>12&1023)<<2)>>2]|0,r=l+16|0,o=c[r>>2]|0,f=o+w|0,(f|0)>0):0){n=o>>>12;if(o>>>0>=135168)if(o>>>0>1048575)x=60;else x=((n+-32|0)/8|0)+32|0;else x=n;n=l+4|0;q=c[n>>2]|0;g=c[l>>2]|0;if(!q)c[63032+(x<<2)>>2]=g;else{u=q;c[c[(c[58020+(u>>>22<<2)>>2]|0)+((u>>>12&1023)<<2)>>2]>>2]=g}g=63280+(x<<2)|0;c[g>>2]=(c[g>>2]|0)-o;o=c[l>>2]|0;if(o){g=o;c[(c[(c[58020+(g>>>22<<2)>>2]|0)+((g>>>12&1023)<<2)>>2]|0)+4>>2]=c[n>>2]}c[r>>2]=f;r=(c[j>>2]|0)+(h<<2)|0;h=c[r>>2]|0;c[h>>2]=c[17068];c[17068]=h;c[r>>2]=0;y=p;z=f;A=l}else{y=b;z=w;A=k}c[18]=(c[18]|0)+m;m=z>>>12;if(z>>>0>=135168)if(z>>>0>1048575)B=60;else B=((m+-32|0)/8|0)+32|0;else B=m;m=63032+(B<<2)|0;k=c[m>>2]|0;c[m>>2]=y;m=63280+(B<<2)|0;c[m>>2]=(c[m>>2]|0)+z;c[A>>2]=k;c[A+4>>2]=0;if(!k){C=A+13|0;D=a[C>>0]|0;E=D&255;F=E|4;G=F&255;a[C>>0]=G;i=e;return}z=k;c[(c[(c[58020+(z>>>22<<2)>>2]|0)+((z>>>12&1023)<<2)>>2]|0)+4>>2]=y;C=A+13|0;D=a[C>>0]|0;E=D&255;F=E|4;G=F&255;a[C>>0]=G;i=e;return}function wp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((b|0)==2){g=a;h=a+4096|0;c[a>>2]=e;if(!d){j=a+8|0;c[j>>2]=g;k=a+32|0;l=((h>>>0>k>>>0?h:k)+(-17-g)&-16)+24|0;k=j;j=a+16|0;do{c[j>>2]=k;k=j+8|0;c[k>>2]=j;j=j+16|0}while(j>>>0<h>>>0);m=a+l|0;i=f;return m|0}else{c[a+4>>2]=0;l=a+8|0;c[l>>2]=g;c[a+12>>2]=0;j=a+32|0;k=((h>>>0>j>>>0?h:j)+(-17-g)&-16)+24|0;g=l;l=a+16|0;do{c[l>>2]=g;c[l+4>>2]=0;g=l+8|0;c[g>>2]=l;c[l+12>>2]=0;l=l+16|0}while(l>>>0<h>>>0);m=a+k|0;i=f;return m|0}}else if((b|0)==4)if(!d){k=a;h=a+4096|0;c[a>>2]=e;c[a+16>>2]=k;l=a+64|0;g=(h>>>0>l>>>0?h:l)+(-33-k)+64|0;k=a+32|0;while(1){c[k>>2]=k+-16;c[k+16>>2]=k;l=k+32|0;if(l>>>0<h>>>0)k=l;else break}m=a+((g&-32)+-16)|0;i=f;return m|0}else{g=a+4096|0;c[a>>2]=e;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;k=a+32|0;h=(g>>>0>k>>>0?g:k)+(-17-a)|0;k=a+16|0;while(1){c[k>>2]=k+-16;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;l=k+16|0;if(l>>>0<g>>>0)k=l;else break}m=a+(h+16&-16)|0;i=f;return m|0}else{if(d)PEi(a|0,0,4096)|0;d=a+4096+(0-b<<2)|0;h=a+(b<<2)|0;if(h>>>0>d>>>0)n=a;else{k=a;g=h;while(1){c[g>>2]=k;h=k+(b<<1<<2)|0;if(h>>>0>d>>>0){n=g;break}else{l=g;g=h;k=l}}}c[a>>2]=e;m=n;i=f;return m|0}return 0}function xp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=0!=0?1:c[62648+(b*20|0)>>2]|0;f=mp(a<<3,b,0)|0;if(!f){i=d;return}if((b|0)==2){g=f;h=c[(c[58020+(g>>>22<<2)>>2]|0)+((g>>>12&1023)<<2)>>2]|0;g=c[h+16>>2]|0;if(g>>>0<=2048){j=(((4096-(4096%(g>>>0)|0)|0)>>>3)+32|0)>>>5;if(j){k=j;l=5}}else{k=17;l=5}if((l|0)==5)PEi(h+36|0,-1,k<<2|0)|0;c[h+32>>2]=4096/(g>>>0)|0}g=62632+(b*20|0)|0;b=wp(f,a<<1,e,c[(c[g>>2]|0)+(a<<2)>>2]|0)|0;c[(c[g>>2]|0)+(a<<2)>>2]=b;i=d;return}function yp(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;a=i;i=i+16|0;b=a;d=0;do{e=c[63032+(d<<2)>>2]|0;if(e){f=c[63280+(d<<2)>>2]|0;c[b>>2]=d;c[b+4>>2]=f;zp(63528,b);f=e;do{e=f;g=e>>>12;h=c[(c[58020+(e>>>22<<2)>>2]|0)+((g&1023)<<2)>>2]|0;e=c[h+16>>2]|0;j=g&262143;k=1==0;if(k){l=j>>>5;m=1<<(g&31);if((c[(c[2]|0)+(l<<2)>>2]&m|0)==0?(c[(c[4]|0)+(l<<2)>>2]&m|0)==0:0)n=7;else o=3143896}else n=7;do if((n|0)==7){n=0;m=c[6]|0;l=c[8]|0;p=j>>>5;q=c[m+(p<<2)>>2]|0;if(!((q|0)==0?(c[l+(p<<2)>>2]|0)==0:0)){r=1<<(g&31);if(r&q){o=3143896;break}if(c[l+(p<<2)>>2]&r){o=3143896;break}}do if(k){r=1<<(g&31);if((c[(c[2]|0)+(p<<2)>>2]&r|0)==0?(c[(c[4]|0)+(p<<2)>>2]&r|0)==0:0){n=15;break}s=f+4096|0}else n=15;while(0);a:do if((n|0)==15){n=0;p=e>>>12;r=0;q=j;while(1){t=q>>>5;u=c[m+(t<<2)>>2]|0;if((u|0)==0?(c[l+(t<<2)>>2]|0)==0:0)v=32-(q&31)|0;else{w=1<<(q&31);if(u&w){x=r;break}if(!(c[l+(t<<2)>>2]&w))v=1;else{x=r;break}}w=v+r|0;if(w>>>0>=p>>>0){s=0;break a}r=w;q=(f+(w<<12)|0)>>>12&262143}s=f+(x+1<<12)|0}while(0);o=(s|0)!=0?63592:63608}while(0);c[b>>2]=f;c[b+4>>2]=e;c[b+8>>2]=o;zp(63560,b);f=c[h>>2]|0}while((f|0)!=0)}d=d+1|0}while((d|0)!=61);c[b>>2]=c[18];zp(63616,b);d=0;o=0;while(1){s=c[63032+(d<<2)>>2]|0;if(!s)y=o;else{x=s;s=o;while(1){v=x;n=c[(c[58020+(v>>>22<<2)>>2]|0)+((v>>>12&1023)<<2)>>2]|0;v=(c[n+16>>2]|0)+s|0;x=c[n>>2]|0;if(!x){y=v;break}else s=v}}d=d+1|0;if((d|0)==61){z=y;break}else o=y}if((z|0)==(c[18]|0)){i=a;return}c[b>>2]=z;_o(63648,b);i=a;return}function zp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1056|0;f=e+16|0;g=e;if(0){i=e;return}c[g>>2]=d;d=f+1024|0;a[d>>0]=21;uEi(f,1024,b,g)|0;if((a[d>>0]|0)!=21){Nq(67824);Vl()}d=SEi(f|0)|0;if(!d){i=e;return}else h=0;while(1){g=gf(1,f+h|0,d-h|0)|0;b=g+h|0;if((g|0)==-1){j=8;break}if(b>>>0<d>>>0)h=b;else{k=b;break}}if((j|0)==8){Nq(67856);Vl()}if((k|0)<0){Nq(67856);Vl()}else{i=e;return}}function Ap(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+-4096|0;f=e;g=f>>>12&1023;h=f>>>22;f=c[58020+(h<<2)>>2]|0;j=c[f+(g<<2)>>2]|0;k=(j|0)!=0;if(k&j>>>0<4096>>>0){l=e;m=j;while(1){n=l+(0-m<<12)|0;o=n;p=c[(c[58020+(o>>>22<<2)>>2]|0)+((o>>>12&1023)<<2)>>2]|0;o=(p|0)!=0;if(o&p>>>0<4096>>>0){l=n;m=p}else{q=o;r=n;s=p;break}}}else{q=k;r=e;s=j}if(q){t=(a[s+13>>0]&4)==0?0:r;i=d;return t|0}a:do if((f|0)==(c[14504]|0)){r=c[15624]|0;if(r){s=r;do{if((c[s+4104>>2]|0)>>>0<=h>>>0){u=s;v=1023;w=10;break a}s=c[s+4100>>2]|0}while((s|0)!=0)}}else if(f){u=f;v=g;w=10}while(0);b:do if((w|0)==10){c:while(1){w=0;g=v;while(1){f=c[u+(g<<2)>>2]|0;if(!f)x=g+-1|0;else{if(f>>>0>=4096>>>0){y=u;z=g;break c}x=g-f|0}if((x|0)>-1)g=x;else break}u=c[u+4100>>2]|0;if(!u)break b;else{v=1023;w=10}}g=(c[y+4104>>2]<<10)+z|0;f=g<<12;h=f;if(((f|0)!=0?(f=c[(c[58020+((g>>>10&1023)<<2)>>2]|0)+((g&1023)<<2)>>2]|0,(a[f+13>>0]&4)!=0):0)?(h+(c[f+16>>2]|0)|0)==(b|0):0){t=h;i=d;return t|0}}while(0);t=0;i=d;return t|0}function Bp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=i;h=c[d+16>>2]|0;j=d+4|0;k=c[j>>2]|0;l=c[d>>2]|0;if(!k)c[63032+(f<<2)>>2]=l;else{m=k;c[c[(c[58020+(m>>>22<<2)>>2]|0)+((m>>>12&1023)<<2)>>2]>>2]=l}l=63280+(f<<2)|0;c[l>>2]=(c[l>>2]|0)-h;l=c[d>>2]|0;if(l){d=l;c[(c[(c[58020+(d>>>22<<2)>>2]|0)+((d>>>12&1023)<<2)>>2]|0)+4>>2]=c[j>>2]}if((h|0)==(e|0)){n=b;i=g;return n|0}j=b+e|0;d=j;l=j>>>22;f=58020+(l<<2)|0;if((c[f>>2]|0)==(c[14504]|0)){m=$o(4108)|0;if(m){c[f>>2]=m;PEi(m|0,0,4104)|0;c[m+4104>>2]=l;k=c[15622]|0;a:do if(!k){o=0;p=62488;q=12}else{r=k;s=0;t=62488;while(1){u=r+4096|0;if((c[r+4104>>2]|0)>>>0>=l>>>0){v=r;w=s;x=t;break}y=c[u>>2]|0;if(!y){o=r;p=u;q=12;break a}else{z=r;r=y;t=u;s=z}}c[m+4100>>2]=w;c[v+4100>>2]=m;A=v;B=x}while(0);if((q|0)==12){c[m+4100>>2]=o;c[15624]=m;A=0;B=p}c[m+4096>>2]=A;c[B>>2]=m;q=15}}else q=15;do if((q|0)==15){m=c[17068]|0;if(!m){B=$o(104)|0;if(!B)break;c[(c[f>>2]|0)+((j>>>12&1023)<<2)>>2]=B;C=B}else{c[17068]=c[m>>2];c[(c[f>>2]|0)+((j>>>12&1023)<<2)>>2]=m;C=m}m=h-e|0;c[C+16>>2]=m;B=C+13|0;a[B>>0]=0;A=m>>>12;if(m>>>0>=135168)if(m>>>0>1048575)D=60;else D=((A+-32|0)/8|0)+32|0;else D=A;A=63032+(D<<2)|0;p=c[A>>2]|0;c[A>>2]=d;A=63280+(D<<2)|0;c[A>>2]=(c[A>>2]|0)+m;c[C>>2]=p;c[C+4>>2]=0;if(p){m=p;c[(c[(c[58020+(m>>>22<<2)>>2]|0)+((m>>>12&1023)<<2)>>2]|0)+4>>2]=d}a[B>>0]=4;n=b;i=g;return n|0}while(0);Mq(63712,0);n=0;i=g;return n|0}function Cp(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;j=d+16|0;k=c[j>>2]|0;l=e-b|0;m=d+4|0;n=c[m>>2]|0;o=c[d>>2]|0;c[f+4>>2]=n;c[f>>2]=o;c[f+16>>2]=k-l;k=f+13|0;a[k>>0]=0;if(!n)c[63032+(g<<2)>>2]=e;else{f=n;c[c[(c[58020+(f>>>22<<2)>>2]|0)+((f>>>12&1023)<<2)>>2]>>2]=e}if(o){f=o;c[(c[(c[58020+(f>>>22<<2)>>2]|0)+((f>>>12&1023)<<2)>>2]|0)+4>>2]=e}e=63280+(g<<2)|0;c[e>>2]=(c[e>>2]|0)-l;c[j>>2]=l;j=l>>>12;if(l>>>0>=135168)if(l>>>0>1048575)p=60;else p=((j+-32|0)/8|0)+32|0;else p=j;j=63032+(p<<2)|0;e=c[j>>2]|0;c[j>>2]=b;j=63280+(p<<2)|0;c[j>>2]=(c[j>>2]|0)+l;c[d>>2]=e;c[m>>2]=0;if(!e){q=d+13|0;r=a[q>>0]|0;s=r&255;t=s|4;u=t&255;a[q>>0]=u;v=a[k>>0]|0;w=v&255;x=w|4;y=x&255;a[k>>0]=y;i=h;return}m=e;c[(c[(c[58020+(m>>>22<<2)>>2]|0)+((m>>>12&1023)<<2)>>2]|0)+4>>2]=b;q=d+13|0;r=a[q>>0]|0;s=r&255;t=s|4;u=t&255;a[q>>0]=u;v=a[k>>0]|0;w=v&255;x=w|4;y=x&255;a[k>>0]=y;i=h;return}function Dp(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;j=i;i=i+16|0;k=j;l=d+4095|0;m=l&-4096;n=63032+(g<<2)|0;o=c[n>>2]|0;if(!o){p=0;i=j;return p|0}q=(e|0)==2;r=(m|0)!=4096;s=63280+(g<<2)|0;t=l>>>12;l=(f&1|0)!=0?1:t;u=(h|0)==0;h=o;a:while(1){o=h;v=c[(c[58020+(o>>>22<<2)>>2]|0)+((o>>>12&1023)<<2)>>2]|0;w=v+16|0;x=c[w>>2]|0;b:do if((x|0)>=(m|0)){do if((x|0)!=(m|0)){if(u){y=v;break b}z=c[v>>2]|0;if((z|0)!=0?(A=z,B=A>>>12,C=c[(c[(c[58020+(A>>>22<<2)>>2]|0)+((B&1023)<<2)>>2]|0)+16>>2]|0,!((C|0)>=(x|0)|(C|0)<(m|0))):0){C=B&262143;if(!1){A=C>>>5;D=1<<(B&31);if(c[(c[2]|0)+(A<<2)>>2]&D)break;if(c[(c[4]|0)+(A<<2)>>2]&D)break}D=c[6]|0;A=c[8]|0;B=0;E=C;while(1){C=E>>>5;F=c[D+(C<<2)>>2]|0;if((F|0)==0?(c[A+(C<<2)>>2]|0)==0:0)G=32-(E&31)|0;else{H=1<<(E&31);if(F&H){I=B;break}if(!(c[A+(C<<2)>>2]&H))G=1;else{I=B;break}}H=G+B|0;if(H>>>0>=t>>>0){y=v;break b}B=H;E=(z+(H<<12)|0)>>>12&262143}if(!(z+(I+1<<12)|0)){y=v;break b}}}while(0);do if(!(q|(m|0)<8193&(e|0)==0)){E=x-m|0;B=h+E|0;c:do if(h>>>0>B>>>0)J=h;else{A=1==0;D=c[2]|0;H=c[4]|0;C=c[6]|0;F=c[8]|0;K=h;while(1){L=K>>>12;M=L&262143;do if(A){N=M>>>5;O=1<<(L&31);if((c[D+(N<<2)>>2]&O|0)==0?(c[H+(N<<2)>>2]&O|0)==0:0){P=0;Q=M;R=28;break}S=K+4096|0}else{P=0;Q=M;R=28}while(0);if((R|0)==28){while(1){R=0;M=Q>>>5;L=c[C+(M<<2)>>2]|0;if((L|0)==0?(c[F+(M<<2)>>2]|0)==0:0)T=32-(Q&31)|0;else{O=1<<(Q&31);if(L&O){U=P;break}if(!(c[F+(M<<2)>>2]&O))T=1;else{U=P;break}}O=T+P|0;if(O>>>0>=l>>>0){J=K;break c}P=O;Q=(K+(O<<12)|0)>>>12&262143;R=28}O=K+(U+1<<12)|0;if(!O){J=K;break c}else S=O}if(S>>>0>B>>>0){J=S;break}else K=S}}while(0);B=J;z=o-B+x|0;if((z|0)>=(m|0)){if((J|0)==(h|0)){V=h;W=v;X=z;break}K=B>>>22;F=58020+(K<<2)|0;if((c[F>>2]|0)==(c[14504]|0)){C=$o(4108)|0;if(!C){V=h;W=v;X=z;break}c[F>>2]=C;PEi(C|0,0,4104)|0;c[C+4104>>2]=K;H=c[15622]|0;d:do if(!H){Y=0;Z=62488;R=44}else{D=H;A=0;O=62488;while(1){M=D+4096|0;if((c[D+4104>>2]|0)>>>0>=K>>>0){_=D;$=A;aa=O;break}L=c[M>>2]|0;if(!L){Y=D;Z=M;R=44;break d}else{N=D;D=L;O=M;A=N}}c[C+4100>>2]=$;c[_+4100>>2]=C;ba=_;ca=aa}while(0);if((R|0)==44){R=0;c[C+4100>>2]=Y;c[15624]=C;ba=0;ca=Z}c[C+4096>>2]=ba;c[ca>>2]=C}K=c[17068]|0;if(!K){H=$o(104)|0;if(!H){V=h;W=v;X=z;break}c[(c[F>>2]|0)+((B>>>12&1023)<<2)>>2]=H;da=H}else{c[17068]=c[K>>2];c[(c[F>>2]|0)+((B>>>12&1023)<<2)>>2]=K;da=K}Cp(h,v,J,da,g);V=J;W=da;X=z;break}K=c[12]|0;if((m|0)>(K|0)&(E|0)>(K|0)){K=(c[15942]|0)+1|0;c[15942]=K;if((K|0)<(c[15944]|0)){V=h;W=v;X=x;break}Mq(63784,m);c[15942]=0;V=h;W=v;X=x;break}if(!(r|(z|0)!=0|(c[15976]|0)!=0)){K=(c[15978]|0)+1|0;c[15978]=K;if(!(K&3)){K=c[w>>2]|0;H=K>>>12;A=h+(H<<12)|0;O=v+4|0;D=c[O>>2]|0;c[18]=(c[18]|0)-K;c[23]=(c[23]|0)+K;N=(D|0)==0;M=c[v>>2]|0;if(N)c[n>>2]=M;else{L=D;c[c[(c[58020+(L>>>22<<2)>>2]|0)+((L>>>12&1023)<<2)>>2]>>2]=M}c[s>>2]=(c[s>>2]|0)-K;K=c[v>>2]|0;if(K){M=K;c[(c[(c[58020+(M>>>22<<2)>>2]|0)+((M>>>12&1023)<<2)>>2]|0)+4>>2]=c[O>>2]}if(H){H=h;O=v;while(1){do if((H|0)==(h|0)){ea=O;R=76}else{M=H;K=M>>>22;L=58020+(K<<2)|0;if((c[L>>2]|0)==(c[14504]|0)){fa=$o(4108)|0;if(!fa){ga=0;break}c[L>>2]=fa;PEi(fa|0,0,4104)|0;c[fa+4104>>2]=K;ha=c[15622]|0;e:do if(!ha){ia=0;ja=62488;R=69}else{ka=ha;la=0;ma=62488;while(1){na=ka+4096|0;if((c[ka+4104>>2]|0)>>>0>=K>>>0){oa=ka;pa=la;qa=ma;break}ra=c[na>>2]|0;if(!ra){ia=ka;ja=na;R=69;break e}else{sa=ka;ka=ra;ma=na;la=sa}}c[fa+4100>>2]=pa;c[oa+4100>>2]=fa;ta=oa;ua=qa}while(0);if((R|0)==69){R=0;c[fa+4100>>2]=ia;c[15624]=fa;ta=0;ua=ja}c[fa+4096>>2]=ta;c[ua>>2]=fa}K=c[17068]|0;if(!K){ha=$o(104)|0;if(!ha){ga=0;break}else va=ha}else{c[17068]=c[K>>2];va=K}c[(c[L>>2]|0)+((M>>>12&1023)<<2)>>2]=va;ea=va;R=76}while(0);do if((R|0)==76){R=0;if(!ea)ga=0;else{K=ea+16|0;c[K>>2]=4096;a[ea+12>>0]=0;a[ea+13>>0]=0;c[ea+8>>2]=H;ha=ea+20|0;c[ha>>2]=((c[15661]|0)==0?0:4096)+(c[15660]|0);la=ea+24|0;a[la>>0]=1;do if(!(c[2918]|0)){ma=$o(1024)|0;if(!ma){c[K>>2]=4096;c[ha>>2]=0;a[la>>0]=1;c[ea+28>>2]=0;break}if(!(c[15560]|0))wa=0;else{c[k>>2]=0;c[k+4>>2]=0;cp(62968,k);wa=0}do{b[ma+(wa<<1)>>1]=1;wa=wa+1|0}while((wa|0)!=512);c[2918]=ma;ka=c[K>>2]|0;c[ea+28>>2]=c[11672+(((a[la>>0]|0)!=0?0:512)<<2)>>2];if(ka>>>0>2048){xa=512;R=86;break}xa=(4096-(4096%(ka>>>0)|0)|0)>>>3;R=86}else{c[ea+28>>2]=c[2918];xa=512;R=86}while(0);if((R|0)==86){R=0;ya=ea+36|0;za=ya+68|0;do{c[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));la=ea+(xa>>>5<<2)+36|0;c[la>>2]=c[la>>2]|1<<(xa&31);c[ea+32>>2]=0;b[ea+14>>1]=c[16020]}if(!0){ga=ea;break}PEi(H|0,0,4096)|0;ga=ea}}while(0);H=H+4096|0;if(H>>>0>=A>>>0)break;else O=ga}}if(N){O=c[n>>2]|0;if(!O){p=0;R=109;break a}else{h=O;continue a}}else{O=D;V=D;W=c[(c[58020+(O>>>22<<2)>>2]|0)+((O>>>12&1023)<<2)>>2]|0;X=0;break}}else{V=h;W=v;X=0}}else{V=h;W=v;X=z}}else{V=h;W=v;X=x}while(0);if((X|0)<(m|0))y=W;else{Aa=V;Ba=W;R=93;break a}}else y=v;while(0);h=c[y>>2]|0;if(!h){p=0;R=109;break}}if((R|0)==93){h=Bp(Aa,Ba,m,g)|0;if(!h){p=0;i=j;return p|0}if(!(jp(h,m)|0)){p=0;i=j;return p|0}g=Ba+16|0;c[g>>2]=d;a[Ba+12>>0]=e;a[Ba+13>>0]=f;c[Ba+8>>2]=h;f=Ba+20|0;c[f>>2]=((c[62644+(e*20|0)>>2]|0)==0?0:d)+(c[62640+(e*20|0)>>2]|0);e=d>>>0>2048&1;Aa=Ba+24|0;a[Aa>>0]=e;y=d>>>3;W=d>>>0>2055?0:y;V=11672+(W<<2)|0;if(!(c[V>>2]|0)){X=$o(1024)|0;if(!X){c[g>>2]=4096;c[f>>2]=0;a[Aa>>0]=1;c[Ba+28>>2]=0;f=h+4096|0;n=f;ga=h+m|0;if(n>>>0<ga>>>0){Ca=n;Da=h;Ea=f}else{p=0;i=j;return p|0}while(1){c[(c[58020+(Ca>>>22<<2)>>2]|0)+((Ca>>>12&1023)<<2)>>2]=0;f=Da+8192|0;Ca=f;if(Ca>>>0>=ga>>>0){p=0;break}else{n=Ea;Ea=f;Da=n}}i=j;return p|0}if(c[15560]|0){c[k>>2]=W;c[k+4>>2]=W<<3;cp(62968,k)}if(!W){W=0;do{b[X+(W<<1)>>1]=1;W=W+1|0}while((W|0)!=512)}else{W=0;do{b[X+(W<<1)>>1]=(W>>>0)%(y>>>0)|0;W=W+1|0}while((W|0)!=512)}c[V>>2]=X;Fa=a[Aa>>0]|0;Ga=c[g>>2]|0}else{Fa=e;Ga=d}c[Ba+28>>2]=c[11672+((Fa<<24>>24!=0?0:y)<<2)>>2];if(Ga>>>0>2048)Ha=512;else Ha=(4096-(4096%(Ga>>>0)|0)|0)>>>3;ya=Ba+36|0;za=ya+68|0;do{c[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));ya=Ba+(Ha>>>5<<2)+36|0;c[ya>>2]=c[ya>>2]|1<<(Ha&31);c[Ba+32>>2]=0;b[Ba+14>>1]=c[16020];c[15980]=0;c[18]=(c[18]|0)-m;p=h;i=j;return p|0}else if((R|0)==109){i=j;return p|0}return 0}function Ep(){return 0}function Fp(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a;if(!(Ep()|0)){d=c[16036]|0;c[16036]=d+1;if((d&3|0)==0?(d=Xe()|0,e=((d-(c[16032]|0)|0)>>>0)/1e3|0,e>>>0>=(c[16030]|0)>>>0):0)if(!(c[15560]|0))f=1;else{d=c[16034]|0;c[b>>2]=e;c[b+4>>2]=d;cp(64152,b);f=1}else f=0}else f=1;i=a;return f|0}function Gp(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=c[16020]|0;if((c[16060]|0)==(e|0))f=c[16058]|0;else{c[16060]=e;g=((((c[867]<<1)+0+((c[868]|0)>>>2)|0)>>>0)/((c[16028]|0)>>>0)|0)>>>((c[15654]|0)!=0&1);h=(g|0)!=0?g:1;c[16058]=h;f=h}h=c[22]|0;g=(c[16054]|0)-(c[15740]|0)+h+(c[23]|0)-(c[25]|0)+(c[26]|0)|0;j=((g|0)>(h|0)?h:g)+(c[24]|0)|0;g=h>>>3;if(((j|0)<(g|0)?g:j)>>>0<f>>>0?(c[14]|0)>>>0<(c[16056]|0)>>>0:0){i=b;return}if(!(c[15654]|0)){Hp(1)|0;c[16064]=0;i=b;return}if((c[16024]|0)==0?(f=c[16064]|0,(f|0)<(c[16022]|0)):0)c[16064]=f+1;else{if(c[15560]|0){c[d>>2]=e+1;c[d+4>>2]=h;cp(64264,d)}bp();Ip(0,1)|0;if(0)fa();d=c[15622]|0;if(d){h=d;do{d=h+4104|0;e=1023;while(1){f=c[h+(e<<2)>>2]|0;j=f;do if(f>>>0<4096>>>0)if(!f){k=e+-1|0;break}else{k=e-j|0;break}else{if((a[f+13>>0]&4)==0?(g=(c[d>>2]<<10)+e|0,l=c[(c[58020+((g>>>10&1023)<<2)>>2]|0)+((g&1023)<<2)>>2]|0,(a[l+12>>0]|0)!=2):0){g=c[l+16>>2]|0;if(g>>>0>2048)m=512;else m=(4096-(4096%(g>>>0)|0)|0)>>>3;g=l+36|0;n=g+68|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(n|0));g=l+(m>>>5<<2)+36|0;c[g>>2]=c[g>>2]|1<<(m&31);c[l+32>>2]=0}k=e+-1|0}while(0);if((k|0)>-1)e=k;else break}h=c[h+4096>>2]|0}while((h|0)!=0)}c[16518]=0;c[16462]=5;c[16520]=0;c[16064]=0;c[16062]=1}if((c[16030]|0)==999999)o=1;else{c[16032]=Xe()|0;o=(c[16030]|0)==999999?1:2}if(Jp(o)|0){Kp();i=b;return}if(c[16062]|0){i=b;return}c[16034]=(c[16034]|0)+1;i=b;return}function Hp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;if(c[15656]|0){f=0;i=d;return f|0}if(Jo[b&127]()|0){f=0;i=d;return f|0}g=c[16462]|0;a:do if(!((c[15654]|0)==0|(g|0)==0)){if(!(c[15560]|0))h=g;else{cp(64328,e);h=c[16462]|0}if(h){while(1){if(Jo[b&127]()|0){f=0;break}lp(1);if(!(c[16462]|0))break a}i=d;return f|0}}while(0);if(0)fa();if(!(c[15560]|0))j=0;else{h=Xe()|0;cp(64392,e);j=h}bp();if((c[15976]|0)!=0|(b|0)!=1?(Ip(b,0)|0)==0:0){f=0;i=d;return f|0}c[16462]=5;c[31]=(c[29]|0)+-8;h=c[15622]|0;if(h){g=h;do{h=g+4104|0;k=1023;while(1){l=c[g+(k<<2)>>2]|0;m=l;do if(l>>>0<4096>>>0)if(!l){n=k+-1|0;break}else{n=k-m|0;break}else{if((a[l+13>>0]&4)==0?(o=(c[h>>2]<<10)+k|0,p=c[(c[58020+((o>>>10&1023)<<2)>>2]|0)+((o&1023)<<2)>>2]|0,(a[p+12>>0]|0)!=2):0){o=c[p+16>>2]|0;if(o>>>0>2048)q=512;else q=(4096-(4096%(o>>>0)|0)|0)>>>3;o=p+36|0;r=o+68|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(r|0));o=p+(q>>>5<<2)+36|0;c[o>>2]=c[o>>2]|1<<(q&31);c[p+32>>2]=0}n=k+-1|0}while(0);if((n|0)>-1)k=n;else break}g=c[g+4096>>2]|0}while((g|0)!=0)}c[16518]=0;c[16462]=5;c[16520]=0;c[16062]=1;if(Jp(b)|0){Kp();if(!(c[15560]|0)){f=1;i=d;return f|0}c[e>>2]=(((Xe()|0)-j|0)>>>0)/1e3|0;cp(64432,e);f=1;i=d;return f|0}if(c[15654]|0){f=0;i=d;return f|0}c[16462]=5;c[31]=(c[29]|0)+-8;if(!1)YEi(c[4]|0,c[2]|0,32768)|0;YEi(c[8]|0,c[6]|0,32768)|0;f=0;i=d;return f|0}function Ip(a,f){a=a|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+16|0;h=g;if((c[15560]|0)==2)j=Xe()|0;else j=0;k=c[16182]|0;a:do if(k){l=(a|0)==0;m=(f|0)==0;n=k;o=0;b:while(1){p=c[62636+(o*20|0)>>2]|0;if(!p)q=n;else{r=1;do{s=p+(r<<2)|0;t=c[s>>2]|0;if(t){u=t;while(1){if(!l?(Jo[a&127]()|0)!=0:0){v=0;break b}t=u;w=t>>>12&1023;x=58020+(t>>>22<<2)|0;t=c[(c[x>>2]|0)+(w<<2)>>2]|0;y=c[t>>2]|0;c[s>>2]=y;if(!m){z=c[16020]|0;if((e[t+14>>1]|0|0)==(z+-1|0)){A=z;B=12}else C=y}else{A=c[16020]|0;B=12}if((B|0)==12){B=0;y=c[(c[x>>2]|0)+(w<<2)>>2]|0;w=c[y+16>>2]|0;x=d[y+12>>0]|0;z=(c[62632+(x*20|0)>>2]|0)+(w>>>3<<2)|0;b[y+14>>1]=A;c[z>>2]=iq(u,y,w,c[62648+(x*20|0)>>2]|0,c[z>>2]|0,64632)|0;C=c[s>>2]|0}if(!C)break;else u=C}}r=r+1|0}while(r>>>0<257);q=c[16182]|0}o=o+1|0;if(o>>>0>=q>>>0)break a;else n=q}i=g;return v|0}while(0);if((c[15560]|0)!=2){v=1;i=g;return v|0}c[h>>2]=(((Xe()|0)-j|0)>>>0)/1e3|0;cp(66904,h);v=1;i=g;return v|0}function Jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b;if(c[15560]|0){e=Xe()|0;if(!(c[15560]|0))f=e;else{g=c[22]|0;c[d>>2]=(c[16020]|0)+1;c[d+4>>2]=g;cp(64480,d);f=e}}else f=0;c[16514]=0;e=c[16462]|0;if(!e)c[16462]=1;else if((e|0)!=5){Nq(66096);Vl()}c[16520]=0;a:do if(!(Jo[a&127]()|0)){e=d;g=0;while(1){c[d>>2]=e;h=g+1|0;if(Lp(c[d>>2]|0)|0)break;if(!(Jo[a&127]()|0))g=h;else{j=h;break a}}g=(c[16020]|0)+1|0;c[16020]=g;if(c[15560]|0){e=c[16158]|0;h=((c[14]|0)+511|0)>>>10;c[d>>2]=g;c[d+4>>2]=e;c[d+8>>2]=h;cp(64592,d)}if(0)fa();if(!(c[15560]|0)){k=1;i=b;return k|0}h=(((Xe()|0)-f|0)>>>0)/1e3|0;e=c[16160]|0;g=c[16162]|0;if((e|0)<0|g>>>0>999){l=g>>>1;m=e>>>1}else{l=g;m=e}e=m+h|0;c[16160]=e;g=l+1|0;c[16162]=g;c[d>>2]=h;c[d+4>>2]=(e>>>0)/(g>>>0)|0;cp(64656,d);k=1;i=b;return k|0}else j=0;while(0);if(c[15560]|0){c[d>>2]=j;cp(64544,d)}c[16118]=j;k=0;i=b;return k|0}function Kp(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=i;i=i+16|0;d=b;if(!(c[15560]|0))e=0;else e=Xe()|0;f=c[16158]|0;if((f|0)>0)c[16178]=(c[16178]|0)+f;c[16158]=0;if(c[16180]|0){zp(68024,d);uq();zp(68048,d);Sp();zp(68072,d);yp();zp(68096,d);zq()}if(c[15976]|0){if(c[16182]|0){f=0;while(1){g=c[62632+(f*20|0)>>2]|0;h=1;do{j=c[g+(h<<2)>>2]|0;a:do if(j){k=j;l=j;m=k&-4096;n=(c[58020+(k>>>22<<2)>>2]|0)+((k>>>12&1023)<<2)|0;while(1){k=c[n>>2]|0;o=k+32|0;p=m;q=l;while(1){r=q-p|0;s=k+(r>>>8<<2)+36|0;t=c[s>>2]|0;u=1<<(r>>>3&31);if(!(u&t)){c[s>>2]=u|t;c[o>>2]=(c[o>>2]|0)+1}t=c[q>>2]|0;if(!t)break a;u=t;s=u&-4096;if((s|0)==(m|0))q=t;else{v=t;w=u;x=s;break}}l=v;m=x;n=(c[58020+(w>>>22<<2)>>2]|0)+((w>>>12&1023)<<2)|0}}while(0);h=h+1|0}while((h|0)!=257);f=f+1|0;h=c[16182]|0;if(f>>>0>=h>>>0){y=h;break}}c[867]=0;c[868]=0;if(y){f=0;do{w=c[62636+(f*20|0)>>2]|0;if(w)PEi(w|0,0,1028)|0;f=f+1|0}while((f|0)!=(y|0))}}else{c[867]=0;c[868]=0}y=c[15622]|0;if(y){f=y;do{y=f+4104|0;w=1023;while(1){x=c[f+(w<<2)>>2]|0;v=x;do if(x>>>0<4096>>>0)if(!x){z=w+-1|0;break}else{z=w-v|0;break}else{if(!(a[x+13>>0]&4))yq((c[y>>2]<<10)+w<<12,1);z=w+-1|0}while(0);if((z|0)>-1)w=z;else break}f=c[f+4096>>2]|0}while((f|0)!=0)}}Op();if(!(c[15560]|0))A=0;else A=Xe()|0;if(c[16184]|0)_o(64744,d);if(c[16182]|0){f=0;do{z=c[62632+(f*20|0)>>2]|0;w=1;do{y=c[z+(w<<2)>>2]|0;b:do if(y){x=y;v=y;h=(c[58020+(x>>>22<<2)>>2]|0)+((x>>>12&1023)<<2)|0;g=x&-4096;while(1){x=c[h>>2]|0;j=c[x+16>>2]|0;n=x+32|0;m=g;l=v;while(1){q=l-m|0;o=x+(q>>>8<<2)+36|0;k=c[o>>2]|0;p=1<<(q>>>3&31);if(p&k){q=(c[n>>2]|0)+-1|0;c[o>>2]=k&~p;c[n>>2]=q}c[16158]=(c[16158]|0)-j;q=c[l>>2]|0;if(!q)break b;p=q;k=p&-4096;if((k|0)==(g|0))l=q;else{B=q;C=p;D=k;break}}v=B;h=(c[58020+(C>>>22<<2)>>2]|0)+((C>>>12&1023)<<2)|0;g=D}}while(0);w=w+1|0}while((w|0)!=257);f=f+1|0}while(f>>>0<(c[16182]|0)>>>0)}if((c[15560]|0)==2){c[d>>2]=c[16158];cp(64816,d)}Np(0);if(c[15560]|0){f=c[867]|0;D=c[868]|0;C=D+f|0;B=c[14]|0;do if(C>>>0<B>>>0)if(C>>>0<42949672){E=((C*100|0)>>>0)/(B>>>0)|0;break}else{E=(C>>>0)/(((B>>>0)/100|0)>>>0)|0;break}else E=0;while(0);c[d>>2]=E;c[d+4>>2]=(f+511|0)>>>10;c[d+8>>2]=(D+511|0)>>>10;cp(64872,d)}D=c[14]|0;f=D-(c[18]|0)|0;if(!(c[16062]|0)){E=((((c[867]<<1)+0+((c[868]|0)>>>2)|0)>>>0)/((c[16028]|0)>>>0)|0)>>>((c[15654]|0)!=0&1);F=(f-(c[16026]|0)|0)>>>0>((E|0)!=0?E:1)>>>0&1}else{c[16026]=f;F=0}c[16024]=F;F=c[15560]|0;if((F|0)==2){c[d>>2]=c[16158];c[d+4>>2]=D;cp(64928,d);G=c[15560]|0}else G=F;c[16034]=0;c[16062]=0;c[21]=(c[21]|0)+(c[22]|0);c[16054]=c[15740];c[22]=0;c[23]=0;c[25]=0;c[26]=0;if(!G){i=b;return}G=Xe()|0;F=c[16398]|0;D=c[16402]|0;c[d>>2]=c[16328];c[d+4>>2]=F;c[d+8>>2]=D;cp(65912,d);D=c[16406]|0;if(!D)H=0;else{F=D;D=0;while(1){f=D+1|0;F=c[F+4>>2]|0;if(!F){H=f;break}else D=f}}D=(c[16454]|0)-(c[16398]|0)|0;F=(c[16456]|0)-(c[16402]|0)|0;c[d>>2]=H;c[d+4>>2]=D;c[d+8>>2]=F;cp(65984,d);c[d>>2]=((A-e|0)>>>0)/1e3|0;c[d+4>>2]=((G-A|0)>>>0)/1e3|0;cp(64984,d);i=b;return}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a;d=c[16462]|0;switch(d|0){case 4:case 5:{if(!(c[16518]|0)){c[16462]=2;e=0;i=a;return e|0}f=c[31]|0;g=c[29]|0;if(f>>>0>=g>>>0){c[31]=eq(f,g,g+(c[16442]<<3)|0)|0;e=0;i=a;return e|0}g=c[16520]|0;if((g|0)==0&(d|0)==5){if(!(c[16516]|0))h=0;else{nq(c[16442]<<1);h=c[16520]|0}c[16462]=4;j=h}else j=g;g=oq(j)|0;c[16520]=g;if(!((g|0)==0&(c[16462]|0)==4)){e=0;i=a;return e|0}lq(1,0);c[16518]=1;if((c[16462]|0)==5){e=0;i=a;return e|0}c[16462]=3;e=0;i=a;return e|0}case 1:{g=c[31]|0;if(g>>>0>=((c[30]|0)+-16384|0)>>>0){c[16516]=1;j=c[29]|0;c[31]=eq(g,j,j+(c[16442]<<3)|0)|0;e=0;i=a;return e|0}j=kq(c[16520]|0)|0;c[16520]=j;if(j){e=0;i=a;return e|0}if(c[15560]|0){c[b>>2]=c[16514];cp(66120,b)}lq(0,0);c[16518]=1;if((c[16462]|0)==5){e=0;i=a;return e|0}c[16462]=3;e=0;i=a;return e|0}case 3:{b=c[31]|0;j=c[29]|0;if(b>>>0>=j>>>0){c[31]=eq(b,j,j+(c[16442]<<3)|0)|0;e=0;i=a;return e|0}c[16462]=0;if(!(c[16516]|0)){e=1;i=a;return e|0}nq(c[16442]<<1);e=1;i=a;return e|0}case 2:{j=c[31]|0;b=c[29]|0;g=c[16442]|0;if(j>>>0>=(b+(g>>>2<<3)|0)>>>0){c[31]=eq(j,b,b+(g<<3)|0)|0;e=0;i=a;return e|0}g=mq(c[16520]|0)|0;c[16520]=g;if(g){e=0;i=a;return e|0}lq(1,0);c[16518]=1;if((c[16462]|0)==5){e=0;i=a;return e|0}c[16462]=3;e=0;i=a;return e|0}case 0:{e=0;i=a;return e|0}default:{Nq(66152);Vl()}}return 0}function Mp(){var a=0,b=0,d=0;a=i;lp(1);b=(c[16462]|0)!=0;d=b&1;if(!(0!=0&(b^1))){i=a;return d|0}fa();i=a;return d|0}function Np(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;c[867]=0;c[868]=0;e=c[16182]|0;if(e){f=(b|0)==0;g=0;do{h=c[62636+(g*20|0)>>2]|0;j=(c[62640+(g*20|0)>>2]|0)==0;if(h){if(f){k=c[62632+(g*20|0)>>2]|0;l=k+1028|0;if(j){j=k;do{if(c[j>>2]|0)c[j>>2]=0;j=j+4|0}while(j>>>0<l>>>0)}else{j=k;do{m=c[j>>2]|0;if(m){n=j;o=m;while(1){c[n>>2]=0;m=c[o>>2]|0;if(!m)break;else{p=o;o=m;n=p}}}j=j+4|0}while(j>>>0<l>>>0)}}PEi(h|0,0,1028)|0}g=g+1|0}while(g>>>0<e>>>0)}e=c[15622]|0;if(!e){i=d;return}else q=e;do{e=q+4104|0;g=1023;while(1){f=c[q+(g<<2)>>2]|0;l=f;do if(f>>>0<4096>>>0)if(!f){r=g+-1|0;break}else{r=g-l|0;break}else{if(!(a[f+13>>0]&4))yq((c[e>>2]<<10)+g<<12,b);r=g+-1|0}while(0);if((r|0)>-1)g=r;else break}q=c[q+4096>>2]|0}while((q|0)!=0);i=d;return}function Op(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;a=i;i=i+16|0;b=a;d=c[16444]|0;e=(d|0)==-1;f=e?0:1<<d;c[16454]=c[16398];c[16456]=c[16402];dq(65584);if(!e){d=0;do{g=c[(c[16404]|0)+(d<<2)>>2]|0;if(g){h=g;do{g=~c[h>>2];j=g>>>12&1023;k=58020+(g>>>22<<2)|0;l=g>>>8&15;m=1<<(g>>>3&31);if(!(c[(c[(c[k>>2]|0)+(j<<2)>>2]|0)+(l<<2)+36>>2]&m)){ko[c[h+20>>2]&4095](g);n=c[31]|0;o=c[29]|0;if(n>>>0>=o>>>0){p=o;o=n;do{o=eq(o,p,p+(c[16442]<<3)|0)|0;c[31]=o;p=c[29]|0}while(o>>>0>=p>>>0)}if(c[16462]|0){p=c[(c[k>>2]|0)+(j<<2)>>2]|0;o=p+(l<<2)+36|0;n=c[o>>2]|0;if(!(n&m)){c[o>>2]=n|m;n=p+32|0;c[n>>2]=(c[n>>2]|0)+1}do{}while((Lp(0)|0)==0)}if(c[(c[(c[k>>2]|0)+(j<<2)>>2]|0)+(l<<2)+36>>2]&m)Mq(65856,g)}h=c[h+4>>2]|0}while((h|0)!=0)}d=d+1|0}while(d>>>0<f>>>0);c[24]=0;if(!e){e=0;do{d=c[(c[16404]|0)+(e<<2)>>2]|0;a:do if(d){h=d;n=0;while(1){p=(n|0)==0;o=n+4|0;q=h;while(1){r=~c[q>>2];s=c[(c[58020+(r>>>22<<2)>>2]|0)+((r>>>12&1023)<<2)>>2]|0;t=s+((r>>>8&15)<<2)+36|0;u=c[t>>2]|0;v=1<<(r>>>3&31);if(u&v){w=q;break}if(!1){c[t>>2]=u|v;v=s+32|0;c[v>>2]=(c[v>>2]|0)+1}v=q+4|0;s=q;q=c[v>>2]|0;if(p)c[(c[16404]|0)+(e<<2)>>2]=q;else c[o>>2]=q;c[16328]=(c[16328]|0)+-1;c[v>>2]=c[16406];c[16406]=s;c[s>>2]=~c[s>>2];c[24]=(c[s+16>>2]|0)+24+(c[24]|0);if(!q)break a}q=c[w+4>>2]|0;if(!q)break;else{h=q;n=w}}}while(0);e=e+1|0}while(e>>>0<f>>>0)}}else c[24]=0;b:do if(1){f=c[16406]|0;if(f){e=f;do{f=c[e>>2]|0;w=f;d=f>>>12&1023;n=58020+(f>>>22<<2)|0;h=c[(c[n>>2]|0)+(d<<2)>>2]|0;g=f>>>8&15;m=1<<(f>>>3&31);if(!(c[h+(g<<2)+36>>2]&m)){f=e+20|0;l=c[f>>2]|0;if((l|0)==3442){j=c[h+20>>2]|0;h=c[31]|0;if(!j)x=h;else{k=h+8|0;c[31]=k;q=c[16442]|0;if(k>>>0<((c[29]|0)+(q<<3)|0)>>>0){y=1;z=k}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[b>>2]=q;cp(66176,b)}q=h+-4088|0;c[31]=q;y=-511;z=q}c[h+(y<<3)>>2]=w;c[h+(y<<3)+4>>2]=j;x=z}j=c[29]|0;if(x>>>0>=j>>>0){h=j;j=x;do{j=eq(j,h,h+(c[16442]<<3)|0)|0;c[31]=j;h=c[29]|0}while(j>>>0>=h>>>0)}if(c[16462]|0){h=c[(c[n>>2]|0)+(d<<2)>>2]|0;j=h+(g<<2)+36|0;w=c[j>>2]|0;if(!(w&m)){c[j>>2]=w|m;w=h+32|0;c[w>>2]=(c[w>>2]|0)+1}do{}while((Lp(0)|0)==0)}A=c[f>>2]|0}else A=l;if((A|0)!=3443?(w=c[(c[n>>2]|0)+(d<<2)>>2]|0,h=w+(g<<2)+36|0,j=c[h>>2]|0,(j&m|0)==0):0){c[h>>2]=j|m;j=w+32|0;c[j>>2]=(c[j>>2]|0)+1}}e=c[e+4>>2]|0}while((e|0)!=0)}if(0!=0?(e=c[16406]|0,(e|0)!=0):0){j=e;e=0;while(1){w=(e|0)==0;h=e+4|0;q=j;while(1){k=q+4|0;o=q;q=c[k>>2]|0;if((c[o+20>>2]|0)!=3443){B=q;C=q;D=o;break}p=c[o>>2]|0;s=c[(c[58020+(p>>>22<<2)>>2]|0)+((p>>>12&1023)<<2)>>2]|0;v=p>>>3;u=s+((p>>>8&15)<<2)+36|0;t=c[u>>2]|0;r=1<<(v&31);if(!(t&r)){E=q;F=q;G=s;H=u;I=t;J=r;K=o;L=54;break}if(w)c[16406]=q;else c[h>>2]=q;c[o>>2]=~p;c[24]=-24-(c[o+16>>2]|0)+(c[24]|0);r=c[16444]|0;t=(p>>>(r+3|0)^v)&(1<<r)+-1;c[k>>2]=c[(c[16404]|0)+(t<<2)>>2];c[16328]=(c[16328]|0)+1;c[(c[16404]|0)+(t<<2)>>2]=o;if(!q)break b}if((L|0)==54){L=0;c[H>>2]=I|J;q=G+32|0;c[q>>2]=(c[q>>2]|0)+1;B=E;C=F;D=K}if(!B)break;else{j=C;e=D}}}}while(0);fq(65584);dq(65600);fq(65600);if(!(c[15980]|0)){i=a;return}c[16458]=0;i=a;return}function Pp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;if(!(c[15652]|0))fp();if(0)fa();e=c[16406]|0;do if(e){if(0){f=c[16020]|0;if((c[16476]|0)==(f|0))break;c[16476]=f;if(!0)break;fa();break}f=a[65832]|0;g=f&255;if(f<<24>>24){f=(c[16460]|0)+1|0;c[16460]=f;if(f>>>0<1<<g>>>0)break;c[16460]=0}a[65832]=g+1;g=1;f=e;h=0;while(1){j=g?c[25]|0:h;k=f+4|0;c[16406]=c[k>>2];c[k>>2]=0;k=f+12|0;In[c[f+8>>2]&4095](c[f>>2]|0,c[k>>2]|0);c[k>>2]=0;f=c[16406]|0;if(!f){l=j;break}else{g=0;h=j}}h=c[25]|0;if((h|0)!=(l|0))c[26]=h-l+(c[26]|0);a[65832]=0}while(0);l=Hp((b|0)!=0?b:1)|0;if(!l){i=d;return l|0}if(0)fa();b=c[16406]|0;if(!b){i=d;return l|0}if(0){e=c[16020]|0;if((c[16476]|0)==(e|0)){i=d;return l|0}c[16476]=e;if(!0){i=d;return l|0}fa();i=d;return l|0}e=a[65832]|0;h=e&255;do if(e<<24>>24){g=(c[16460]|0)+1|0;c[16460]=g;if(g>>>0<1<<h>>>0){i=d;return l|0}else{c[16460]=0;break}}while(0);a[65832]=h+1;h=1;e=b;b=0;while(1){g=h?c[25]|0:b;f=e+4|0;c[16406]=c[f>>2];c[f>>2]=0;f=e+12|0;In[c[e+8>>2]&4095](c[e>>2]|0,c[f>>2]|0);c[f>>2]=0;e=c[16406]|0;if(!e){m=g;break}else{h=0;b=g}}b=c[25]|0;if((b|0)!=(m|0))c[26]=b-m+(c[26]|0);a[65832]=0;i=d;return l|0}function Qp(){var a=0;a=i;Pp(0,0)|0;if(!(c[15738]|0)){i=a;return}qp();i=a;return}function Rp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;if((c[15926]|0)>>>0>511){Nq(65040);Vl()}else{f=b;g=d}while(1){if(f>>>0>=4097>>>0){h=f;j=g;break}g=g+-4096|0;if(!g){k=24;break}else f=f+4096|0}if((k|0)==24){i=e;return}f=h;g=f+j|0;do if(g>>>0<=f>>>0){d=j+-4096|0;if(!d){i=e;return}else{l=d;m=g+-4096|0;break}}else{l=j;m=g}while(0);g=f>>>22;j=58020+(g<<2)|0;if((c[j>>2]|0)==(c[14504]|0)){d=$o(4108)|0;if(!d){i=e;return}c[j>>2]=d;PEi(d|0,0,4104)|0;c[d+4104>>2]=g;b=c[15622]|0;a:do if(!b){n=0;o=62488;k=13}else{p=b;q=0;r=62488;while(1){s=p+4096|0;if((c[p+4104>>2]|0)>>>0>=g>>>0){t=p;u=q;v=r;break}w=c[s>>2]|0;if(!w){n=p;o=s;k=13;break a}else{x=p;p=w;r=s;q=x}}c[d+4100>>2]=u;c[t+4100>>2]=d;y=t;z=v}while(0);if((k|0)==13){c[d+4100>>2]=n;c[15624]=d;y=0;z=o}c[d+4096>>2]=y;c[z>>2]=d}d=c[17068]|0;do if(!d){z=$o(104)|0;if(!z){i=e;return}else{c[(c[j>>2]|0)+((f>>>12&1023)<<2)>>2]=z;A=z;break}}else{c[17068]=c[d>>2];c[(c[j>>2]|0)+((f>>>12&1023)<<2)>>2]=d;A=d}while(0);d=c[15926]|0;c[16800+(d<<3)>>2]=h;c[16804+(d<<3)>>2]=l;c[15926]=d+1;c[A+16>>2]=l;a[A+13>>0]=0;vp(h);c[14]=(c[14]|0)+l;A=c[16276]|0;if(h>>>0<=A>>>0|(A|0)==0)c[16276]=h+-4;if((l+f|0)>>>0<(c[16278]|0)>>>0){i=e;return}c[16278]=m;i=e;return}function Sp(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;a=i;i=i+32|0;b=a;c[b>>2]=c[14];zp(65120,b);if(!(c[15926]|0)){i=a;return}else d=0;do{e=c[16800+(d<<3)>>2]|0;f=c[16804+(d<<3)>>2]|0;g=e+f|0;a:do if((f|0)>0){h=c[2]|0;j=c[4]|0;k=c[6]|0;l=c[8]|0;if(!1){m=e;n=0}else{o=e;p=0;while(1){q=o;r=q>>>12;s=q>>>17&8191;q=c[k+(s<<2)>>2]|0;if((q|0)==0?(c[l+(s<<2)>>2]|0)==0:0)t=18;else{u=1<<(r&31);if((u&q|0)==0?(c[l+(s<<2)>>2]&u|0)==0:0)t=18;else v=1}if((t|0)==18){t=0;v=0}u=v+p|0;o=o+4096|0;if(o>>>0>=g>>>0){w=u;break a}else p=u}}while(1){p=m>>>12;o=p&262143;u=o>>>5;s=1<<(p&31);b:do if((c[h+(u<<2)>>2]&s|0)==0?(c[j+(u<<2)>>2]&s|0)==0:0){q=o>>>5;r=c[k+(q<<2)>>2]|0;if(!((r|0)==0?(c[l+(q<<2)>>2]|0)==0:0))t=9;do if((t|0)==9){t=0;x=1<<(p&31);if((x&r|0)==0?(c[l+(q<<2)>>2]&x|0)==0:0)break;x=m+4096|0;y=x;z=x;break b}while(0);y=0;z=m+4096|0}else t=6;while(0);if((t|0)==6){t=0;p=m+4096|0;y=p;z=p}p=((y|0)!=0&1)+n|0;if(z>>>0<g>>>0){m=z;n=p}else{w=p;break}}}else w=0;while(0);c[b>>2]=d;c[b+4>>2]=e;c[b+8>>2]=g;c[b+12>>2]=w;c[b+16>>2]=f>>>12;zp(65144,b);d=d+1|0}while(d>>>0<(c[15926]|0)>>>0);i=a;return}function Tp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=c[16302]|0;f=(a>>>0<16?65535:(a<<12)+-1|0)+e&0-e;e=c[16298]|0;if((e|0)!=0?((c[14]|0)+f|0)>>>0>e>>>0:0){g=0;i=b;return g|0}e=rk(0)|0;a=c[16302]|0;h=a+-1&e;do if((f|0)>=0){if((h|0)!=0?(rk(a-h|0)|0)==(-1|0):0)break;e=rk(f|0)|0;if((e|0)!=(-1|0)?(e|0)!=0:0){if(c[15560]|0){j=c[22]|0;c[d>>2]=(f+511+(c[14]|0)|0)>>>10;c[d+4>>2]=j;cp(65264,d)}j=((((c[867]<<1)+0+((c[868]|0)>>>2)|0)>>>0)/((c[16028]|0)>>>0)|0)>>>((c[15654]|0)!=0&1);k=(j|0)!=0?j+33554432|0:33554433;j=c[16]|0;l=(j|0)!=0;m=e;if(l&j>>>0<e>>>0|(l|(e|0)<0)^1){l=m+f+k|0;if(l>>>0>m>>>0){n=c[16278]|0;c[16278]=n>>>0>l>>>0?n:l}}else{l=m-k|0;if(l>>>0<m>>>0){m=c[16276]|0;c[16276]=m>>>0<l>>>0?m:l}}c[17]=j;c[16]=e;Rp(e,f);e=c[14]|0;j=k+-16777216|0;k=j+e|0;c[16056]=k>>>0<j>>>0?-1:k;if(!0){g=1;i=b;return g|0}fa(e|0);g=1;i=b;return g|0}}while(0);Mq(65216,f);g=0;i=b;return g|0}function Up(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+16|0;e=a;f=c[(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)>>2]|0;g=c[f+16>>2]|0;h=d;if((e&-4096|0)!=(h&-4096|0)|g>>>0<20){j=1;i=b;return j|0}if((c[a+12>>2]|0)!=(h^-19075637|0)?(c[a+((g>>>2)+-1<<2)>>2]|0)!=(h^-1126248977|0):0){j=1;i=b;return j|0}if((c[a+8>>2]|0)!=(g|0)){j=1;i=b;return j|0}a=(g+-16|0)>>>2;if(!a){j=0;i=b;return j|0}else k=0;while(1){g=d+(k<<2)|0;k=k+1|0;if((c[g>>2]|0)!=-559038737){l=g;break}if(k>>>0>=a>>>0){j=0;m=13;break}}if((m|0)==13){i=b;return j|0}m=f+((e>>>8&15)<<2)+36|0;a=c[m>>2]|0;k=1<<(e>>>3&31);if(!(a&k)){c[m>>2]=a|k;k=f+32|0;c[k>>2]=(c[k>>2]|0)+1}k=c[16394]|0;c[65496+(k<<2)>>2]=l;if(k>>>0<19)c[16394]=k+1;c[15738]=1;j=0;i=b;return j|0}function Vp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;cq(a,b,c,d,e,3442);i=f;return}function Wp(){var a=0,b=0,d=0;a=i;do if((65604|0)>>>0>(65603&-4)>>>0){b=c[31]|0;d=b+8|0;c[31]=d;if(d>>>0<(c[30]|0)>>>0){c[d>>2]=65603&-4;c[b+12>>2]=65604-(65603&-4);break}else{Nq(66256);Vl()}}while(0);do if((65588|0)>>>0>(65587&-4)>>>0){b=c[31]|0;d=b+8|0;c[31]=d;if(d>>>0<(c[30]|0)>>>0){c[d>>2]=65587&-4;c[b+12>>2]=65588-(65587&-4);break}else{Nq(66256);Vl()}}while(0);do if((65620|0)>>>0>(65619&-4)>>>0){b=c[31]|0;d=b+8|0;c[31]=d;if(d>>>0<(c[30]|0)>>>0){c[d>>2]=65619&-4;c[b+12>>2]=65620-(65619&-4);break}else{Nq(66256);Vl()}}while(0);if((65628|0)>>>0<=(65627&-4)>>>0){i=a;return}b=c[31]|0;d=b+8|0;c[31]=d;if(d>>>0>=(c[30]|0)>>>0){Nq(66256);Vl()}c[d>>2]=65627&-4;c[b+12>>2]=65628-(65627&-4);i=a;return}function Xp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[b>>2]|0;f=e+1|0;g=(e|0)==-1;h=g?0:1<<e;j=1<<f;k=j<<2;if(k>>>0<4097)l=hp(k,1)|0;else{m=1+k|0;k=kp(m,1,1)|0;n=m+4095&-4096;if(k)if(!(c[15667]|0))o=k;else{PEi(k|0,0,n|0)|0;o=k}else o=0;c[22]=(c[22]|0)+m;l=o}if(!l)if(!(c[a>>2]|0)){Nq(65632);Vl()}else{i=d;return}if(!g){g=e+4|0;e=j+-1|0;j=0;do{o=c[(c[a>>2]|0)+(j<<2)>>2]|0;if(o){m=o;do{o=~c[m>>2];k=m+4|0;n=m;m=c[k>>2]|0;p=l+(((o>>>3^o>>>g)&e)<<2)|0;c[k>>2]=c[p>>2];c[p>>2]=n}while((m|0)!=0)}j=j+1|0}while(j>>>0<h>>>0)}c[b>>2]=f;c[a>>2]=l;i=d;return}function Yp(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((a&3|0)!=0|(a|0)==0){Nq(65712);Vl()}else{d=Zp(65584,a,b)|0;i=c;return d|0}return 0}function Zp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;g=a+4|0;h=c[g>>2]|0;if(!((h|0)!=-1?(c[a+8>>2]|0)>>>0<=1<<h>>>0:0))j=3;if((j|0)==3?(Xp(a,g),(c[15560]|0)!=0):0){c[f>>2]=1<<c[g>>2];cp(65680,f)}f=b;b=f>>>3;j=c[g>>2]|0;h=(f>>>(j+3|0)^b)&(1<<j)+-1;j=c[(c[a>>2]|0)+(h<<2)>>2]|0;a:do if(j){k=~f;l=j;while(1){if((c[l>>2]|0)==(k|0)){m=l;break}l=c[l+4>>2]|0;if(!l)break a}c[m+8>>2]=~d;n=1;i=e;return n|0}while(0);m=hp(12,1)|0;b:do if(!m){j=Iq(12)|0;if(!j){n=2;i=e;return n|0}l=c[g>>2]|0;k=(f>>>(l+3|0)^b)&(1<<l)+-1;l=c[a>>2]|0;o=c[l+(k<<2)>>2]|0;if(!o){p=l;q=0;r=k;s=j}else{t=~f;u=o;while(1){if((c[u>>2]|0)==(t|0)){v=u;break}u=c[u+4>>2]|0;if(!u){p=l;q=o;r=k;s=j;break b}}c[v+8>>2]=~d;up(j);n=1;i=e;return n|0}}else{k=c[a>>2]|0;p=k;q=c[k+(h<<2)>>2]|0;r=h;s=m}while(0);c[s+8>>2]=~d;c[s>>2]=~f;c[s+4>>2]=q;c[p+(r<<2)>>2]=s;s=a+8|0;c[s>>2]=(c[s>>2]|0)+1;n=0;i=e;return n|0}function _p(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=a;if(d&3){e=0;i=b;return e|0}a=c[16397]|0;f=(c[16396]|0)+(((d>>>(a+3|0)^d>>>3)&(1<<a)+-1)<<2)|0;a=c[f>>2]|0;if(!a){e=0;i=b;return e|0}g=~d;d=a;a=0;while(1){if((c[d>>2]|0)==(g|0)){h=d;j=a;k=5;break}l=c[d+4>>2]|0;if(!l){m=l;break}else{n=d;d=l;a=n}}if((k|0)==5){k=c[h+4>>2]|0;if(!j)c[f>>2]=k;else c[j+4>>2]=k;c[16398]=(c[16398]|0)+-1;m=h}if(!m){e=0;i=b;return e|0}up(m);e=1;i=b;return e|0}function $p(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=i;i=i+16|0;h=g;j=d;k=j>>>12;l=c[(c[58020+(j>>>22<<2)>>2]|0)+((k&1023)<<2)>>2]|0;if(l>>>0<4096>>>0){if(1){if((c[15652]|0)!=0?(l|0)!=0:0){m=l;n=j&-4096;while(1){o=m;p=n+(0-o<<12)|0;q=p;r=c[(c[58020+(q>>>22<<2)>>2]|0)+((q>>>12&1023)<<2)>>2]|0;if(r>>>0<4096>>>0){m=r;n=p}else{s=o;t=p;u=r;v=n;break}}n=t;if((a[u+13>>0]&4)==0?(t=n&-4,m=c[u+16>>2]|0,u=((n&4092)>>>0)%(m>>>0)|0,n=t+(m-u)|0,!(m>>>0<4097?n>>>0>(v+(1-s<<12)|0)>>>0:0)):0)w=n>>>0>d>>>0?t+(0-u)|0:0;else w=0}else w=0;u=c[(c[58020+(w>>>22<<2)>>2]|0)+((w>>>12&1023)<<2)>>2]|0;if(!u){x=1;y=11}else{z=u;y=10}}}else{z=l;y=10}if((y|0)==10)if(!(a[z+13>>0]&4)){u=j&4095;w=u>>>3;t=b[(c[z+28>>2]|0)+(w<<1)>>1]|0;n=j&7;do if(t|n)if(!(a[z+24>>0]|0)){s=t<<3|n;if(a[12700+s>>0]|0){A=d+(0-s)|0;B=w-t|0;break}if(1){s=k&262143;if(l){v=s>>>5;m=1<<(k&31);if(!(c[(c[6]|0)+(v<<2)>>2]&m)){C=e;i=g;return C|0}else{D=m;E=v}}else{D=1<<(k&31);E=s>>>5}s=(c[8]|0)+(E<<2)|0;c[s>>2]=c[s>>2]|D;C=e;i=g;return C|0}if(!(a[16796+(j&3)>>0]|0)){C=e;i=g;return C|0}s=k&262143;if(l){v=s>>>5;m=1<<(k&31);if(!(c[(c[2]|0)+(v<<2)>>2]&m)){C=e;i=g;return C|0}else{F=m;G=v}}else{F=1<<(k&31);G=s>>>5}s=(c[4]|0)+(G<<2)|0;c[s>>2]=c[s>>2]|F;C=e;i=g;return C|0}else{s=c[z+8>>2]|0;if((j-s|0)!=(u|0)){A=s;B=0;break}if(a[12700+u>>0]|0){A=s;B=0;break}if(1){s=k&262143;if(l){v=s>>>5;m=1<<(k&31);if(!(c[(c[6]|0)+(v<<2)>>2]&m)){C=e;i=g;return C|0}else{H=m;I=v}}else{H=1<<(k&31);I=s>>>5}s=(c[8]|0)+(I<<2)|0;c[s>>2]=c[s>>2]|H;C=e;i=g;return C|0}if(!(a[16796+(j&3)>>0]|0)){C=e;i=g;return C|0}s=k&262143;if(l){v=s>>>5;m=1<<(k&31);if(!(c[(c[2]|0)+(v<<2)>>2]&m)){C=e;i=g;return C|0}else{J=m;K=v}}else{J=1<<(k&31);K=s>>>5}s=(c[4]|0)+(K<<2)|0;c[s>>2]=c[s>>2]|J;C=e;i=g;return C|0}else{A=d;B=w}while(0);w=z+(B>>>5<<2)+36|0;d=c[w>>2]|0;J=1<<(B&31);if(J&d){C=e;i=g;return C|0}c[w>>2]=J|d;d=z+32|0;c[d>>2]=(c[d>>2]|0)+1;d=c[z+20>>2]|0;if(!d){C=e;i=g;return C|0}z=e+8|0;if(z>>>0<f>>>0){L=z;M=1}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[h>>2]=c[16442];cp(66176,h)}L=e+-4088|0;M=-511}c[e+(M<<3)>>2]=A;c[e+(M<<3)+4>>2]=d;C=L;i=g;return C|0}else{x=1;y=11}if((y|0)==11?(x|0)!=0:0){x=k&262143;if(l){y=x>>>5;L=1<<(k&31);if(!(c[(c[6]|0)+(y<<2)>>2]&L)){C=e;i=g;return C|0}else{N=L;O=y}}else{N=1<<(k&31);O=x>>>5}x=(c[8]|0)+(O<<2)|0;c[x>>2]=c[x>>2]|N;C=e;i=g;return C|0}if(!(a[16796+(j&3)>>0]|0)){C=e;i=g;return C|0}j=k&262143;if(l){l=j>>>5;N=1<<(k&31);if(!(c[(c[2]|0)+(l<<2)>>2]&N)){C=e;i=g;return C|0}else{P=N;Q=l}}else{P=1<<(k&31);Q=j>>>5}j=(c[4]|0)+(Q<<2)|0;c[j>>2]=c[j>>2]|P;C=e;i=g;return C|0}function aq(a){a=a|0;return}function bq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;e=a;f=c[(c[(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)>>2]|0)+20>>2]|0;if(!f){i=b;return}e=c[31]|0;g=e+8|0;c[31]=g;h=c[16442]|0;if(g>>>0<((c[29]|0)+(h<<3)|0)>>>0)j=1;else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[d>>2]=h;cp(66176,d)}c[31]=e+-4088;j=-511}c[e+(j<<3)>>2]=a;c[e+(j<<3)+4>>2]=f;i=b;return}function cq(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+16|0;j=h;k=c[16444]|0;if(!((k|0)!=-1?(c[16328]|0)>>>0<=1<<k>>>0:0))l=3;if((l|0)==3?(Xp(65616,65776),(c[15560]|0)!=0):0){c[j>>2]=1<<c[16444];cp(65784,j)}j=a;a=j>>>3;k=(b|0)==0;m=j>>>12&1023;n=58020+(j>>>22<<2)|0;o=~j;p=0;q=0;a:while(1){r=c[16444]|0;s=(j>>>(r+3|0)^a)&(1<<r)+-1;r=c[(c[16404]|0)+(s<<2)>>2]|0;if(r){t=r;r=0;while(1){if((c[t>>2]|0)==(o|0)){u=s;v=t;w=q;x=r;l=8;break a}y=c[t+4>>2]|0;if(!y)break;else{z=t;t=y;r=z}}}if(q){A=s;B=p;C=q;l=36;break}if(k){l=25;break}p=c[(c[n>>2]|0)+(m<<2)>>2]|0;if(!p){l=30;break}r=hp(24,1)|0;if(r){A=s;B=p;C=r;l=36;break}q=Iq(24)|0;if(!q){l=41;break}}if((l|0)==8){if(f)c[f>>2]=c[v+12>>2];if(e)c[e>>2]=c[v+8>>2];q=(x|0)==0;p=c[v+4>>2]|0;if(q)c[(c[16404]|0)+(u<<2)>>2]=p;else c[x+4>>2]=p;do if(!k){c[v+8>>2]=b;c[v+12>>2]=d;c[v+20>>2]=g;if(q){c[(c[16404]|0)+(u<<2)>>2]=v;break}else{c[x+4>>2]=v;break}}else{c[16328]=(c[16328]|0)+-1;up(v)}while(0);if(!w){i=h;return}up(w);i=h;return}else if((l|0)==25){if(f)c[f>>2]=0;if(!e){i=h;return}c[e>>2]=0;i=h;return}else if((l|0)==30){if(f)c[f>>2]=0;if(!e){i=h;return}c[e>>2]=0;i=h;return}else if((l|0)==36){if(f)c[f>>2]=0;if(e)c[e>>2]=0;c[C>>2]=o;c[C+8>>2]=b;c[C+12>>2]=d;c[C+16>>2]=c[B+16>>2];c[C+20>>2]=g;c[C+4>>2]=c[(c[16404]|0)+(A<<2)>>2];c[16328]=(c[16328]|0)+1;c[(c[16404]|0)+(A<<2)>>2]=C;i=h;return}else if((l|0)==41){i=h;return}}function dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=c[a+4>>2]|0;e=(d|0)==-1;f=e?0:1<<d;if(e){i=b;return}e=a+8|0;d=0;do{g=c[(c[a>>2]|0)+(d<<2)>>2]|0;a:do if(g){h=g;j=0;while(1){k=j+4|0;b:do if(!j){l=h;while(1){m=~c[l+8>>2];if(c[(c[(c[58020+(m>>>22<<2)>>2]|0)+((m>>>12&1023)<<2)>>2]|0)+((m>>>8&15)<<2)+36>>2]&1<<(m>>>3&31)){n=l;break b}c[~c[l>>2]>>2]=0;jq(l);m=l;l=c[l+4>>2]|0;c[(c[a>>2]|0)+(d<<2)>>2]=l;jq(m);c[e>>2]=(c[e>>2]|0)+-1;if(!l)break a}}else{l=h;while(1){m=~c[l+8>>2];if(c[(c[(c[58020+(m>>>22<<2)>>2]|0)+((m>>>12&1023)<<2)>>2]|0)+((m>>>8&15)<<2)+36>>2]&1<<(m>>>3&31)){n=l;break b}c[~c[l>>2]>>2]=0;jq(l);m=l;l=c[l+4>>2]|0;c[k>>2]=l;jq(m);c[e>>2]=(c[e>>2]|0)+-1;if(!l)break a}}while(0);h=c[n+4>>2]|0;if(!h)break;else j=n}}while(0);d=d+1|0}while(d>>>0<f>>>0);i=b;return}function eq(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;g=i;i=i+80|0;h=g;j=g+8|0;k=c[16278]|0;l=c[16276]|0;c[16518]=1;m=j+0|0;n=m+64|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));m=e;if((d-m|0)<=-1){o=d;i=g;return o|0}e=l;l=k;k=d;d=4096;while(1){n=c[k>>2]|0;p=k+4|0;q=c[p>>2]|0;while(1){if(!(q&-509)){r=q;s=58;break}t=q&3;if((t|0)==1){u=q;s=7;break}else if(!t){v=q;s=6;break}else if((t|0)==2){w=q;s=47;break}else if((t|0)!=3){s=56;break}if((q|0)>-1)x=n+(q+-3)|0;else{t=c[n>>2]|0;if(!t){s=52;break}x=t+(-13-q)|0}q=c[x>>2]|0;if(!q){s=55;break}}if((s|0)==6){s=0;q=n+508|0;c[k>>2]=q;c[p>>2]=v+-508;y=k;z=q;s=60}else if((s|0)==7){s=0;q=k+-8|0;t=u&-4;A=d+-64|0;if(!t){B=q;C=A}else{D=q;q=n;E=t;while(1){a:do if((E|0)<0?(t=c[q>>2]|0,t>>>0>=e>>>0&t>>>0<l>>>0):0){F=t;G=t>>>12;H=G&7;I=j+(H<<3)|0;if((c[I>>2]|0)!=(G|0)){J=ip(F,I)|0;if(!J){K=D;break}else L=J}else L=c[j+(H<<3)+4>>2]|0;H=t&4095;J=H>>>3;I=b[(c[L+28>>2]|0)+(J<<1)>>1]|0;M=t&7;do if(I|M)if(!(a[L+24>>0]|0)){N=I<<3|M;if(a[12700+N>>0]|0){O=F+(0-N)|0;P=J-I|0;break}if(1){N=G&262143;if(c[(c[58020+(t>>>22<<2)>>2]|0)+((G&1023)<<2)>>2]|0){Q=N>>>5;R=1<<(G&31);if(!(c[(c[6]|0)+(Q<<2)>>2]&R)){K=D;break a}else{S=R;T=Q}}else{S=1<<(G&31);T=N>>>5}N=(c[8]|0)+(T<<2)|0;c[N>>2]=c[N>>2]|S;K=D;break a}if(!(a[16796+(t&3)>>0]|0)){K=D;break a}N=G&262143;if(c[(c[58020+(t>>>22<<2)>>2]|0)+((G&1023)<<2)>>2]|0){Q=N>>>5;R=1<<(G&31);if(!(c[(c[2]|0)+(Q<<2)>>2]&R)){K=D;break a}else{U=R;V=Q}}else{U=1<<(G&31);V=N>>>5}N=(c[4]|0)+(V<<2)|0;c[N>>2]=c[N>>2]|U;K=D;break a}else{N=c[L+8>>2]|0;if((t-N|0)!=(H|0)){O=N;P=0;break}if(a[12700+H>>0]|0){O=N;P=0;break}if(1){N=G&262143;if(c[(c[58020+(t>>>22<<2)>>2]|0)+((G&1023)<<2)>>2]|0){Q=N>>>5;R=1<<(G&31);if(!(c[(c[6]|0)+(Q<<2)>>2]&R)){K=D;break a}else{W=R;X=Q}}else{W=1<<(G&31);X=N>>>5}N=(c[8]|0)+(X<<2)|0;c[N>>2]=c[N>>2]|W;K=D;break a}if(!(a[16796+(t&3)>>0]|0)){K=D;break a}N=G&262143;if(c[(c[58020+(t>>>22<<2)>>2]|0)+((G&1023)<<2)>>2]|0){Q=N>>>5;R=1<<(G&31);if(!(c[(c[2]|0)+(Q<<2)>>2]&R)){K=D;break a}else{Y=R;Z=Q}}else{Y=1<<(G&31);Z=N>>>5}N=(c[4]|0)+(Z<<2)|0;c[N>>2]=c[N>>2]|Y;K=D;break a}else{O=F;P=J}while(0);J=L+(P>>>5<<2)+36|0;F=c[J>>2]|0;G=1<<(P&31);if((G&F|0)==0?(c[J>>2]=G|F,F=L+32|0,c[F>>2]=(c[F>>2]|0)+1,F=c[L+20>>2]|0,(F|0)!=0):0){G=D+8|0;if(G>>>0<f>>>0){_=G;$=1}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[h>>2]=c[16442];cp(66176,h)}_=D+-4088|0;$=-511}c[D+($<<3)>>2]=O;c[D+($<<3)+4>>2]=F;K=_}else K=D}else K=D;while(0);E=E<<1;if(!E){B=K;C=A;break}else{D=K;q=q+4|0}}}}else if((s|0)==47){s=0;B=kn[c[56+((w>>>2&63)<<2)+72>>2]&511](n,k+-8|0,f,w>>>8)|0;C=d+-100|0}else if((s|0)==52){s=0;B=k+-8|0;C=d}else if((s|0)==55){s=0;B=k+-8|0;C=d}else if((s|0)==56){s=0;if(2555==(-1|0)){y=k;z=0;s=60}else{s=57;break}}else if((s|0)==58){s=0;q=k+-8|0;if(r>>>0<4){B=q;C=d}else{y=q;z=n+r|0;s=60}}b:do if((s|0)==60){s=0;q=n-z+d|0;D=z;A=z+-4|0;while(1){E=c[A>>2]|0;p=D+-8|0;if(E>>>0>=e>>>0&E>>>0<l>>>0){aa=E;ba=p;s=62;break}if(n>>>0>p>>>0){B=y;C=q;break b}E=c[p>>2]|0;A=D+-12|0;if(E>>>0>=e>>>0&E>>>0<l>>>0){ca=E;da=A;s=66;break}if(n>>>0>A>>>0){B=y;C=q;break b}else D=p}if((s|0)==62){s=0;ea=aa;fa=ba}else if((s|0)==66){s=0;ea=ca;fa=da}if(n>>>0>fa>>>0)ga=y;else{D=y;A=n;while(1){p=c[A>>2]|0;c:do if(p>>>0>=e>>>0&p>>>0<l>>>0){E=p;F=p>>>12;G=F&7;J=j+(G<<3)|0;if((c[J>>2]|0)!=(F|0)){t=ip(E,J)|0;if(!t){ha=D;break}else ia=t}else ia=c[j+(G<<3)+4>>2]|0;G=p&4095;t=G>>>3;J=b[(c[ia+28>>2]|0)+(t<<1)>>1]|0;H=p&7;do if(J|H)if(!(a[ia+24>>0]|0)){I=J<<3|H;if(a[12700+I>>0]|0){ja=E+(0-I)|0;ka=t-J|0;break}if(1){I=F&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((F&1023)<<2)>>2]|0){M=I>>>5;N=1<<(F&31);if(!(c[(c[6]|0)+(M<<2)>>2]&N)){ha=D;break c}else{la=N;ma=M}}else{la=1<<(F&31);ma=I>>>5}I=(c[8]|0)+(ma<<2)|0;c[I>>2]=c[I>>2]|la;ha=D;break c}if(!(a[16796+(p&3)>>0]|0)){ha=D;break c}I=F&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((F&1023)<<2)>>2]|0){M=I>>>5;N=1<<(F&31);if(!(c[(c[2]|0)+(M<<2)>>2]&N)){ha=D;break c}else{na=N;oa=M}}else{na=1<<(F&31);oa=I>>>5}I=(c[4]|0)+(oa<<2)|0;c[I>>2]=c[I>>2]|na;ha=D;break c}else{I=c[ia+8>>2]|0;if((p-I|0)!=(G|0)){ja=I;ka=0;break}if(a[12700+G>>0]|0){ja=I;ka=0;break}if(1){I=F&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((F&1023)<<2)>>2]|0){M=I>>>5;N=1<<(F&31);if(!(c[(c[6]|0)+(M<<2)>>2]&N)){ha=D;break c}else{pa=N;qa=M}}else{pa=1<<(F&31);qa=I>>>5}I=(c[8]|0)+(qa<<2)|0;c[I>>2]=c[I>>2]|pa;ha=D;break c}if(!(a[16796+(p&3)>>0]|0)){ha=D;break c}I=F&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((F&1023)<<2)>>2]|0){M=I>>>5;N=1<<(F&31);if(!(c[(c[2]|0)+(M<<2)>>2]&N)){ha=D;break c}else{ra=N;sa=M}}else{ra=1<<(F&31);sa=I>>>5}I=(c[4]|0)+(sa<<2)|0;c[I>>2]=c[I>>2]|ra;ha=D;break c}else{ja=E;ka=t}while(0);t=ia+(ka>>>5<<2)+36|0;E=c[t>>2]|0;F=1<<(ka&31);if((F&E|0)==0?(c[t>>2]=F|E,E=ia+32|0,c[E>>2]=(c[E>>2]|0)+1,E=c[ia+20>>2]|0,(E|0)!=0):0){F=D+8|0;if(F>>>0<f>>>0){ta=F;ua=1}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[h>>2]=c[16442];cp(66176,h)}ta=D+-4088|0;ua=-511}c[D+(ua<<3)>>2]=ja;c[D+(ua<<3)+4>>2]=E;ha=ta}else ha=D}else ha=D;while(0);p=A+4|0;if(p>>>0>fa>>>0){ga=ha;break}else{D=ha;A=p}}}A=ea;D=ea>>>12;p=D&7;E=j+(p<<3)|0;if((c[E>>2]|0)!=(D|0)){F=ip(A,E)|0;if(!F){B=ga;C=q;break}else va=F}else va=c[j+(p<<3)+4>>2]|0;p=ea&4095;F=p>>>3;E=b[(c[va+28>>2]|0)+(F<<1)>>1]|0;t=ea&7;do if(E|t)if(!(a[va+24>>0]|0)){G=E<<3|t;if(a[12700+G>>0]|0){wa=A+(0-G)|0;xa=F-E|0;break}if(1){G=D&262143;if(c[(c[58020+(ea>>>22<<2)>>2]|0)+((D&1023)<<2)>>2]|0){J=G>>>5;H=1<<(D&31);if(!(c[(c[6]|0)+(J<<2)>>2]&H)){B=ga;C=q;break b}else{ya=H;za=J}}else{ya=1<<(D&31);za=G>>>5}G=(c[8]|0)+(za<<2)|0;c[G>>2]=c[G>>2]|ya;B=ga;C=q;break b}if(!(a[16796+(ea&3)>>0]|0)){B=ga;C=q;break b}G=D&262143;if(c[(c[58020+(ea>>>22<<2)>>2]|0)+((D&1023)<<2)>>2]|0){J=G>>>5;H=1<<(D&31);if(!(c[(c[2]|0)+(J<<2)>>2]&H)){B=ga;C=q;break b}else{Aa=H;Ba=J}}else{Aa=1<<(D&31);Ba=G>>>5}G=(c[4]|0)+(Ba<<2)|0;c[G>>2]=c[G>>2]|Aa;B=ga;C=q;break b}else{G=c[va+8>>2]|0;if((ea-G|0)!=(p|0)){wa=G;xa=0;break}if(a[12700+p>>0]|0){wa=G;xa=0;break}if(1){G=D&262143;if(c[(c[58020+(ea>>>22<<2)>>2]|0)+((D&1023)<<2)>>2]|0){J=G>>>5;H=1<<(D&31);if(!(c[(c[6]|0)+(J<<2)>>2]&H)){B=ga;C=q;break b}else{Ca=H;Da=J}}else{Ca=1<<(D&31);Da=G>>>5}G=(c[8]|0)+(Da<<2)|0;c[G>>2]=c[G>>2]|Ca;B=ga;C=q;break b}if(!(a[16796+(ea&3)>>0]|0)){B=ga;C=q;break b}G=D&262143;if(c[(c[58020+(ea>>>22<<2)>>2]|0)+((D&1023)<<2)>>2]|0){J=G>>>5;H=1<<(D&31);if(!(c[(c[2]|0)+(J<<2)>>2]&H)){B=ga;C=q;break b}else{Ea=H;Fa=J}}else{Ea=1<<(D&31);Fa=G>>>5}G=(c[4]|0)+(Fa<<2)|0;c[G>>2]=c[G>>2]|Ea;B=ga;C=q;break b}else{wa=A;xa=F}while(0);F=va+(xa>>>5<<2)+36|0;A=c[F>>2]|0;D=1<<(xa&31);if((A&D|0)==0?(c[F>>2]=A|D,D=va+32|0,c[D>>2]=(c[D>>2]|0)+1,D=c[va+20>>2]|0,(D|0)!=0):0){A=ga+8|0;if(A>>>0<f>>>0){Ga=A;Ha=1}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[h>>2]=c[16442];cp(66176,h)}Ga=ga+-4088|0;Ha=-511}c[ga+(Ha<<3)>>2]=wa;c[ga+(Ha<<3)+4>>2]=D;B=Ga;C=q}else{B=ga;C=q}}while(0);if((B-m|C|0)>-1){k=B;d=C}else{o=B;s=142;break}}if((s|0)==57){Nq(66232);Vl()}else if((s|0)==142){i=g;return o|0}return 0}function fq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=c[a+4>>2]|0;e=(d|0)==-1;f=e?0:1<<d;if(e){i=b;return}e=a+8|0;d=0;do{g=c[(c[a>>2]|0)+(d<<2)>>2]|0;a:do if(g){h=g;j=0;while(1){k=(j|0)==0;l=j+4|0;m=h;while(1){n=Zo(~c[m>>2])|0;if(!n){o=m;break}p=n;if(c[(c[(c[58020+(p>>>22<<2)>>2]|0)+((p>>>12&1023)<<2)>>2]|0)+((p>>>8&15)<<2)+36>>2]&1<<(p>>>3&31)){o=m;break}jq(m);p=m;m=c[m+4>>2]|0;if(k)c[(c[a>>2]|0)+(d<<2)>>2]=m;else c[l>>2]=m;jq(p);c[e>>2]=(c[e>>2]|0)+-1;if(!m)break a}h=c[o+4>>2]|0;if(!h)break;else j=o}}while(0);d=d+1|0}while(d>>>0<f>>>0);i=b;return}function gq(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;b=c[16406]|0;if(!b){d=0;i=a;return d|0}else{e=1;f=b;g=0;h=0}while(1){b=e?c[25]|0:g;j=f+4|0;c[16406]=c[j>>2];c[j>>2]=0;j=f+12|0;In[c[f+8>>2]&4095](c[f>>2]|0,c[j>>2]|0);c[j>>2]=0;j=h+1|0;f=c[16406]|0;if(!f){k=b;l=j;break}else{e=0;g=b;h=j}}h=c[25]|0;if((h|0)==(k|0)){d=l;i=a;return d|0}c[26]=h-k+(c[26]|0);d=l;i=a;return d|0}function hq(){return (c[16406]|0)!=0|0}function iq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;j=i;k=b+(4096-e)|0;if(!f){if(k>>>0<b>>>0){l=g;m=0}else{f=e>>>3;n=g;o=0;p=0;q=b;while(1){if(!(1<<(o&31)&c[d+(o>>>5<<2)+36>>2])){c[q>>2]=n;r=q;s=q;t=p+e|0}else{r=n;s=q;t=p}q=s+e|0;if(q>>>0>k>>>0){l=r;m=t;break}else{n=r;o=o+f|0;p=t}}}u=l;v=(c[h>>2]|0)+m|0}else{if(k>>>0<b>>>0){w=g;x=0}else{m=e>>>3;l=(e|0)>4;t=g;g=0;p=0;f=b;while(1){if(!(c[d+(g>>>5<<2)+36>>2]&1<<(g&31))){b=p+e|0;c[f>>2]=t;o=f+e|0;r=f+4|0;if(l){n=f;q=r;while(1){c[q>>2]=0;s=n+8|0;if(s>>>0<o>>>0){y=q;q=s;n=y}else{z=f;A=b;B=s;break}}}else{z=f;A=b;B=r}}else{z=t;A=p;B=f+e|0}if(B>>>0>k>>>0){w=z;x=A;break}else{t=z;g=g+m|0;p=A;f=B}}}u=w;v=(c[h>>2]|0)+x|0}c[h>>2]=v;if((a[d+12>>0]|0)!=2){i=j;return u|0}v=c[d+16>>2]|0;if(v>>>0<=2048){h=(((4096-(4096%(v>>>0)|0)|0)>>>3)+32|0)>>>5;if(h){C=h;D=20}}else{C=17;D=20}if((D|0)==20)PEi(d+36|0,-1,C<<2|0)|0;c[d+32>>2]=4096/(v>>>0)|0;i=j;return u|0}function jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a;a=c[(c[58020+(d>>>22<<2)>>2]|0)+((d>>>12&1023)<<2)>>2]|0;e=a+((d>>>8&15)<<2)+36|0;f=c[e>>2]|0;g=1<<(d>>>3&31);if(!(f&g)){i=b;return}c[e>>2]=f&~g;g=a+32|0;c[g>>2]=(c[g>>2]|0)+-1;i=b;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b;if(!(c[16522]|0)){Nq(66288);Vl()}f=c[14504]|0;g=c[15622]|0;h=(g|0)==0;j=b;b=(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)|0;a:while(1){e=c[b>>2]|0;if(e>>>0>=4096>>>0?(a[e+13>>0]&4)==0:0){k=j;l=e}else{e=j;m=e>>>22;n=c[58020+(m<<2)>>2]|0;b:do if((n|0)!=(f|0))if(!n){o=0;p=24;break a}else{q=n;r=e>>>12&1023}else{if(h){o=0;p=24;break a}else s=g;while(1){if((c[s+4104>>2]|0)>>>0>=m>>>0){q=s;r=0;break b}s=c[s+4096>>2]|0;if(!s){o=0;p=24;break a}}}while(0);c:while(1){m=r;while(1){e=c[q+(m<<2)>>2]|0;if(e>>>0<4096>>>0)t=m+1|0;else{if(!(a[e+13>>0]&4)){u=q;v=m;break c}t=((c[e+16>>2]|0)>>>12)+m|0}if(t>>>0<1024)m=t;else break}q=c[q+4096>>2]|0;if(!q){o=0;p=24;break a}else r=0}m=(c[u+4104>>2]<<10)+v|0;e=m<<12;if(!e){o=0;p=24;break}k=e;l=c[(c[58020+((m>>>10&1023)<<2)>>2]|0)+((m&1023)<<2)>>2]|0}m=l+16|0;e=c[m>>2]|0;if(e>>>0<2049){w=k;x=m;y=l;p=23;break}n=k;if(n>>>0<(e+n|0)>>>0){w=k;x=m;y=l;p=23;break}m=k+((e+4095|0)>>>12<<12)|0;e=m;j=m;b=(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)|0}if((p|0)==23){tq(w,y);o=w+(((c[x>>2]|0)+4095|0)>>>12<<12)|0;i=d;return o|0}else if((p|0)==24){i=d;return o|0}return 0}function lq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;c[16578]=1;if(0>0){e=0;do{wq(c[20896+(e<<4)>>2]|0,c[20900+(e<<4)>>2]|0,b);e=e+1|0}while((e|0)<0)}e=c[16182]|0;if(e){b=e;e=0;while(1){f=c[62632+(e*20|0)>>2]|0;if((c[15652]|0)!=0?(g=f,h=g&-4096,j=c[(c[58020+(g>>>22<<2)>>2]|0)+((g>>>12&1023)<<2)>>2]|0,(j|0)!=0):0){if(j>>>0<4096>>>0){g=j;k=h;while(1){l=k+(0-g<<12)|0;m=l;n=c[(c[58020+(m>>>22<<2)>>2]|0)+((m>>>12&1023)<<2)>>2]|0;if(n>>>0<4096>>>0){g=n;k=l}else{o=l;p=n;break}}q=p;r=o;s=o}else{q=j;r=h;s=f}if((((a[q+13>>0]&4)==0?(k=s,g=k&-4,n=c[q+16>>2]|0,l=((k&4092)>>>0)%(n>>>0)|0,k=g+(n-l)|0,!(k>>>0>(r+4096|0)>>>0&n>>>0<4097)):0)?(n=g+(0-l)|0,!(k>>>0<=f>>>0|(n|0)==0)):0)?(k=n,n=c[(c[58020+(k>>>22<<2)>>2]|0)+((k>>>12&1023)<<2)>>2]|0,l=n+((k>>>8&15)<<2)+36|0,g=c[l>>2]|0,m=1<<(k>>>3&31),(g&m|0)==0):0){c[l>>2]=g|m;m=n+32|0;c[m>>2]=(c[m>>2]|0)+1;t=c[16182]|0}else t=b}else t=b;e=e+1|0;if(e>>>0>=t>>>0)break;else b=t}}if((c[16578]|0)!=0?(Wp(),(c[16624]|0)!=0):0)Aq();if(!0){i=d;return}fa();i=d;return}function mq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=b;f=c[14504]|0;g=c[15622]|0;h=(g|0)==0;j=b;b=(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)|0;a:while(1){e=c[b>>2]|0;if(e>>>0>=4096>>>0?(a[e+13>>0]&4)==0:0){k=j;l=e}else{e=j;m=e>>>22;n=c[58020+(m<<2)>>2]|0;b:do if((n|0)!=(f|0))if(!n){o=0;p=21;break a}else{q=n;r=e>>>12&1023}else{if(h){o=0;p=21;break a}else s=g;while(1){if((c[s+4104>>2]|0)>>>0>=m>>>0){q=s;r=0;break b}s=c[s+4096>>2]|0;if(!s){o=0;p=21;break a}}}while(0);c:while(1){m=r;while(1){e=c[q+(m<<2)>>2]|0;if(e>>>0<4096>>>0)t=m+1|0;else{if(!(a[e+13>>0]&4)){u=q;v=m;break c}t=((c[e+16>>2]|0)>>>12)+m|0}if(t>>>0<1024)m=t;else break}q=c[q+4096>>2]|0;if(!q){o=0;p=21;break a}else r=0}m=(c[u+4104>>2]<<10)+v|0;e=m<<12;if(!e){o=0;p=21;break}k=e;l=c[(c[58020+((m>>>10&1023)<<2)>>2]|0)+((m&1023)<<2)>>2]|0}if((a[l+12>>0]|0)==2){w=k;x=l;p=19;break}m=k+(((c[l+16>>2]|0)+4095|0)>>>12<<12)|0;e=m;j=m;b=(c[58020+(e>>>22<<2)>>2]|0)+((e>>>12&1023)<<2)|0}if((p|0)==19){tq(w,x);o=w+(((c[x+16>>2]|0)+4095|0)>>>12<<12)|0;i=d;return o|0}else if((p|0)==21){i=d;return o|0}return 0}function nq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;e=$o(a<<3)|0;c[16516]=0;f=c[16442]|0;g=(e|0)==0;do if(!f)if(g){_o(68240,d);Nq(0);rl(1)}else{c[29]=e;c[16442]=a;c[30]=e+(a<<3);break}else{if(g){Mq(68184,a);break}h=c[29]|0;j=c[16302]|0;k=j+-1&h;l=(k|0)==0?0:j-k|0;k=(f<<3)-l&0-j;if(k)Rp(l+h|0,k);c[29]=e;c[16442]=a;c[30]=e+(a<<3);if(c[15560]|0){c[d>>2]=a;cp(68152,d)}}while(0);c[31]=(c[29]|0)+-8;i=b;return}function oq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=b;f=e>>>12&1023;g=e>>>22;e=c[58020+(g<<2)>>2]|0;h=c[e+(f<<2)>>2]|0;if(h>>>0>=4096>>>0?(a[h+13>>0]&4)==0:0){j=b;k=h}else l=3;do if((l|0)==3){a:do if((e|0)!=(c[14504]|0))if(!e){m=0;i=d;return m|0}else{n=e;o=f}else{h=c[15622]|0;if(!h){m=0;i=d;return m|0}else p=h;while(1){if((c[p+4104>>2]|0)>>>0>=g>>>0){n=p;o=0;break a}p=c[p+4096>>2]|0;if(!p){m=0;break}}i=d;return m|0}while(0);b:while(1){h=o;while(1){b=c[n+(h<<2)>>2]|0;if(b>>>0<4096>>>0)q=h+1|0;else{if(!(a[b+13>>0]&4)){r=n;s=h;break b}q=((c[b+16>>2]|0)>>>12)+h|0}if(q>>>0<1024)h=q;else break}n=c[n+4096>>2]|0;if(!n){m=0;l=18;break}else o=0}if((l|0)==18){i=d;return m|0}h=(c[r+4104>>2]<<10)+s|0;b=h<<12;if(!b){m=0;i=d;return m|0}else{j=b;k=c[(c[58020+((h>>>10&1023)<<2)>>2]|0)+((h&1023)<<2)>>2]|0;break}}while(0);tq(j,k);m=j+(((c[k+16>>2]|0)+4095|0)>>>12<<12)|0;i=d;return m|0}function pq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=a+3&-4;a=b&-4;b=a;if(a>>>0<=f>>>0){i=e;return}g=f;h=g+4096&-4096;j=h;k=(mo[d&4095](j+-4096|0)|0)!=0;if(a>>>0<=h>>>0){if(!k){i=e;return}l=c[31]|0;m=l+8|0;c[31]=m;if(m>>>0>=(c[30]|0)>>>0){Nq(66256);Vl()}c[m>>2]=g;c[l+12>>2]=a-f;i=e;return}do if(k&h>>>0>f>>>0){l=c[31]|0;m=l+8|0;c[31]=m;if(m>>>0<(c[30]|0)>>>0){c[m>>2]=g;c[l+12>>2]=h-f;break}else{Nq(66256);Vl()}}while(0);f=j+4096|0;a:do if(f>>>0>a>>>0)n=j;else{h=j;g=f;while(1){if(mo[d&4095](h)|0){k=c[31]|0;l=h+3&-4;m=l;if(k-(c[29]|0)>>3>>>0>((c[16442]|0)*3|0)>>>2>>>0){o=k;p=l;q=m;break}r=g&-4;if(r>>>0>l>>>0){s=k+8|0;c[31]=s;if(s>>>0>=(c[30]|0)>>>0){t=21;break}c[s>>2]=m;c[k+12>>2]=r-l}}l=h+8192|0;if(l>>>0>a>>>0){n=g;break a}else{r=g;g=l;h=r}}if((t|0)==21){Nq(66256);Vl()}if(a>>>0<=p>>>0){i=e;return}h=o+8|0;c[31]=h;if(h>>>0>=(c[30]|0)>>>0){Nq(66256);Vl()}c[h>>2]=q;c[o+12>>2]=a-p;i=e;return}while(0);do if(((n|0)!=(b|0)?(mo[d&4095](n)|0)!=0:0)?(p=n+3&-4,o=p,a>>>0>p>>>0):0){q=c[31]|0;t=q+8|0;c[31]=t;if(t>>>0<(c[30]|0)>>>0){c[t>>2]=o;c[q+12>>2]=a-p;break}else{Nq(66256);Vl()}}while(0);if((c[31]|0)>>>0<(c[30]|0)>>>0){i=e;return}else{Nq(66256);Vl()}}function qq(a){a=a|0;return 1}function rq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[31]|0;f=c[30]|0;g=a+4096|0;if(a>>>0>=-4096>>>0){h=e;c[31]=h;i=d;return}j=c[16276]|0;k=c[16278]|0;l=e;e=b+36|0;b=a;while(1){a=c[e>>2]|0;e=e+4|0;if(!a)m=l;else{n=l;o=a;a=b;while(1){if(o&1){p=c[a>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)q=$p(p,n,f,0)|0;else q=n;p=c[a+4>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)r=$p(p,q,f,0)|0;else r=q;p=c[a+8>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)s=$p(p,r,f,0)|0;else s=r;p=c[a+12>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)t=$p(p,s,f,0)|0;else t=s}else t=n;o=o>>>2;if(!o){m=t;break}else{n=t;a=a+16|0}}}b=b+256|0;if(b>>>0>=g>>>0){h=m;break}else l=m}c[31]=h;i=d;return}function sq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=c[31]|0;f=c[30]|0;g=a+4096|0;if(a>>>0>=-4096>>>0){h=e;c[31]=h;i=d;return}j=c[16276]|0;k=c[16278]|0;l=e;e=b+36|0;b=a;while(1){a=c[e>>2]|0;e=e+4|0;if(!a)m=l;else{n=l;o=a;a=b;while(1){if(o&1){p=c[a>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)q=$p(p,n,f,0)|0;else q=n;p=c[a+4>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)r=$p(p,q,f,0)|0;else r=q;p=c[a+8>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)s=$p(p,r,f,0)|0;else s=r;p=c[a+12>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)t=$p(p,s,f,0)|0;else t=s;p=c[a+16>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)u=$p(p,t,f,0)|0;else u=t;p=c[a+20>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)v=$p(p,u,f,0)|0;else v=u;p=c[a+24>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)w=$p(p,v,f,0)|0;else w=v;p=c[a+28>>2]|0;if(p>>>0>=j>>>0&p>>>0<k>>>0)x=$p(p,w,f,0)|0;else x=w}else x=n;o=o>>>4;if(!o){m=x;break}else{n=x;a=a+32|0}}}b=b+256|0;if(b>>>0>=g>>>0){h=m;break}else l=m}c[31]=h;i=d;return}function tq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+16|0;e=d;f=c[b+16>>2]|0;g=b+20|0;h=c[30]|0;if(!(c[g>>2]|0)){i=d;return}if(!(c[b+32>>2]|0)){i=d;return}c[16514]=(c[16514]|0)+1;c[16518]=1;if(f>>>0>2048)j=a;else j=a+(0-f)+4096|0;k=f>>>3;if((k|0)==1){l=c[31]|0;m=a+4096|0;if(a>>>0<-4096>>>0){n=c[16276]|0;o=c[16278]|0;p=l;q=b+36|0;r=a;while(1){s=c[q>>2]|0;q=q+4|0;if(!s)t=p;else{u=p;v=s;s=r;while(1){if(v&1){w=c[s>>2]|0;if(w>>>0>=n>>>0&w>>>0<o>>>0)x=$p(w,u,h,0)|0;else x=u;w=c[s+4>>2]|0;if(w>>>0>=n>>>0&w>>>0<o>>>0)y=$p(w,x,h,0)|0;else y=x}else y=u;v=v>>>1;if(!v){t=y;break}else{u=y;s=s+8|0}}}r=r+256|0;if(r>>>0>=m>>>0){z=t;break}else p=t}}else z=l;c[31]=z;i=d;return}else if((k|0)==2){rq(a,b);i=d;return}else if((k|0)==4){sq(a,b);i=d;return}else{z=c[31]|0;if(a>>>0>j>>>0)A=z;else{l=z;z=0;t=a;while(1){if((c[b+(z>>>5<<2)+36>>2]&1<<(z&31)|0)!=0?(a=c[g>>2]|0,(a|0)!=0):0){p=l+8|0;if(p>>>0<h>>>0){B=1;C=p}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[e>>2]=c[16442];cp(66176,e)}B=-511;C=l+-4088|0}c[l+(B<<3)>>2]=t;c[l+(B<<3)+4>>2]=a;D=C}else D=l;t=t+f|0;if(t>>>0>j>>>0){A=D;break}else{l=D;z=z+k|0}}}c[31]=A;i=d;return}}function uq(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a;if(0>0){d=0;do{e=c[20900+(d<<4)>>2]|0;f=(c[20908+(d<<4)>>2]|0)!=0?66344:3653512;c[b>>2]=c[20896+(d<<4)>>2];c[b+4>>2]=e;c[b+8>>2]=f;zp(66320,b);d=d+1|0}while((d|0)<0)}c[b>>2]=0;zp(66360,b);if(0>0){d=0;f=0;while(1){e=(c[20900+(d<<4)>>2]|0)+f-(c[20896+(d<<4)>>2]|0)|0;d=d+1|0;if(!d){g=e;break}else f=e}}else g=0;if(!g){i=a;return}c[b>>2]=g;_o(66384,b);i=a;return}function vq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=c[16608]|0;if(e){f=e+-1|0;if(!f)g=0;else{h=f;f=0;while(1){j=(f+h|0)>>>1;k=(c[53924+(j<<3)>>2]|0)>>>0>a>>>0;l=k?f:j+1|0;h=k?j:h;if(h>>>0<=l>>>0){g=l;break}else f=l}}do if((c[53924+(g<<3)>>2]|0)>>>0>a>>>0){f=53920+(g<<3)|0;h=c[f>>2]|0;if(h>>>0<b>>>0){Nq(66440);Vl()}if((h|0)==(b|0)){c[f>>2]=a;i=d;return}else{h=f-53920>>3;if(e>>>0>h>>>0)m=e;else{n=h;break}do{f=m;m=m+-1|0;l=53920+(m<<3)|0;j=c[l+4>>2]|0;k=53920+(f<<3)|0;c[k>>2]=c[l>>2];c[k+4>>2]=j}while(m>>>0>h>>>0);n=h}}else n=e;while(0);if((e|0)==512){Nq(66472);Vl()}else o=n}else o=0;c[53920+(o<<3)>>2]=a;c[53924+(o<<3)>>2]=b;c[16608]=e+1;i=d;return}function wq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;if(a>>>0>=b>>>0){i=e;return}f=(d|0)==0;d=a;a:while(1){a=(c[16608]|0)+-1|0;if(!a)g=0;else{h=a;a=0;while(1){j=(a+h|0)>>>1;k=(c[53924+(j<<3)>>2]|0)>>>0>d>>>0;l=k?a:j+1|0;h=k?j:h;if(h>>>0<=l>>>0){g=l;break}else a=l}}a=53924+(g<<3)|0;if((c[a>>2]|0)>>>0<=d>>>0){m=d;n=7;break}h=c[53920+(g<<3)>>2]|0;if(h>>>0>=b>>>0){m=d;n=7;break}do if(h>>>0>d>>>0){if(f){pq(d,h,3329);break}l=d+3&-4;j=l;k=h&-4;if(k>>>0>l>>>0){o=c[31]|0;p=o+8|0;c[31]=p;if(p>>>0>=(c[30]|0)>>>0){n=18;break a}c[p>>2]=j;c[o+12>>2]=k-l}}while(0);d=c[a>>2]|0;if(d>>>0>=b>>>0){n=21;break}}if((n|0)==7){if(f){pq(m,b,3329);i=e;return}f=m+3&-4;m=b&-4;if(m>>>0<=f>>>0){i=e;return}b=c[31]|0;d=b+8|0;c[31]=d;if(d>>>0>=(c[30]|0)>>>0){Nq(66256);Vl()}c[d>>2]=f;c[b+12>>2]=m-f;i=e;return}else if((n|0)==18){Nq(66256);Vl()}else if((n|0)==21){i=e;return}}function xq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=4096-d|0;g=a+f|0;if((f|0)<0){i=e;return}f=d>>>3;h=0;j=a;while(1){do if(!(c[b+(h>>>5<<2)+36>>2]&1<<(h&31))){if((c[16372]|0)!=0?(Up(j)|0)==0:0)break;c[15738]=1;a=c[16666]|0;if(a>>>0<40?(c[16666]=a+1,c[66504+(a<<2)>>2]=j,a=j,k=c[(c[58020+(a>>>22<<2)>>2]|0)+((a>>>12&1023)<<2)>>2]|0,l=k+((a>>>8&15)<<2)+36|0,m=c[l>>2]|0,n=1<<(a>>>3&31),(m&n|0)==0):0){c[l>>2]=m|n;n=k+32|0;c[n>>2]=(c[n>>2]|0)+1}}while(0);j=j+d|0;if(j>>>0>g>>>0)break;else h=h+f|0}i=e;return}function yq(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=a;h=g>>>12&1023;j=58020+(g>>>22<<2)|0;k=c[(c[j>>2]|0)+(h<<2)>>2]|0;l=c[k+16>>2]|0;m=d[k+12>>0]|0;if(l>>>0<=2048){n=k+32|0;o=c[n>>2]|0;do if(!e){if(!o){c[16158]=(c[16158]|0)+4096;vp(a);break}if((c[15976]|0)==0?o>>>0>((4096/(l>>>0)|0)*7|0)>>>3>>>0:0)break;p=(c[62636+(m*20|0)>>2]|0)+(l>>>3<<2)|0;c[k>>2]=c[p>>2];c[p>>2]=a}else{b[k+14>>1]=c[16020];xq(a,k,l)}while(0);m=da(c[n>>2]|0,l)|0;if(!(c[k+20>>2]|0)){c[868]=(c[868]|0)+m;i=f;return}else{c[867]=(c[867]|0)+m;i=f;return}}if(c[k+36>>2]&1)if(!(c[k+20>>2]|0)){c[868]=(c[868]|0)+l;i=f;return}else{c[867]=(c[867]|0)+l;i=f;return}if(!e){e=l+4095|0;if(e>>>0>8191)c[19]=(c[19]|0)-(e&-4096);c[16158]=(c[16158]|0)+l;vp(a);i=f;return}if((c[16372]|0)!=0?(Up(a)|0)==0:0){i=f;return}c[15738]=1;l=c[16666]|0;if(l>>>0>=40){i=f;return}c[16666]=l+1;c[66504+(l<<2)>>2]=a;a=c[(c[j>>2]|0)+(h<<2)>>2]|0;h=a+((g>>>8&15)<<2)+36|0;j=c[h>>2]|0;l=1<<(g>>>3&31);if(j&l){i=f;return}c[h>>2]=j|l;l=a+32|0;c[l>>2]=(c[l>>2]|0)+1;i=f;return}function zq(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;b=i;i=i+16|0;e=b;zp(66808,e);f=c[15622]|0;if(!f){g=0;h=0;c[e>>2]=g;j=e+4|0;c[j>>2]=h;zp(66872,e);i=b;return}else{k=0;l=0;m=f}while(1){f=m+4104|0;n=k;o=l;p=1023;while(1){q=c[m+(p<<2)>>2]|0;r=q;do if(q>>>0<4096>>>0)if(!q){s=n;t=o;u=p+-1|0;break}else{s=n;t=o;u=p-r|0;break}else{if(!(a[q+13>>0]&4)){v=(c[f>>2]<<10)+p|0;w=c[(c[58020+((v>>>10&1023)<<2)>>2]|0)+((v&1023)<<2)>>2]|0;v=c[w+16>>2]|0;x=0;y=0;while(1){z=c[w+(x<<2)+36>>2]|0;if(!z)A=0;else{B=z;z=0;while(1){C=z+(B&1)|0;B=B>>>1;if(!B){A=C;break}else z=C}}z=A+y|0;x=x+1|0;if((x|0)==16){D=z;break}else y=z}y=c[w+100>>2]|0;if(!y)E=0;else{x=y;y=0;while(1){z=y+(x&1)|0;x=x>>>1;if(!x){E=z;break}else y=z}}y=D+-1+E|0;x=c[w+32>>2]|0;z=d[w+12>>0]|0;if((x|0)==(y|0)){c[e>>2]=z;c[e+4>>2]=v;c[e+8>>2]=y;zp(66792,e)}else{c[e>>2]=z;c[e+4>>2]=v;c[e+8>>2]=x;c[e+12>>2]=y;zp(66776,e)}F=n+(v+4095&-4096)|0;G=o+1|0}else{F=n;G=o}s=F;t=G;u=p+-1|0}while(0);if((u|0)>-1){n=s;o=t;p=u}else{H=s;I=t;break}}m=c[m+4096>>2]|0;if(!m){g=I;h=H;break}else{k=H;l=I}}c[e>>2]=g;j=e+4|0;c[j>>2]=h;zp(66872,e);i=b;return}function Aq(){var a=0,b=0,d=0;a=i;if((66964|0)>>>0<=(66963&-4)>>>0){i=a;return}b=c[31]|0;d=b+8|0;c[31]=d;if(d>>>0>=(c[30]|0)>>>0){Nq(66256);Vl()}c[d>>2]=66963&-4;c[b+12>>2]=66964-(66963&-4);i=a;return}function Bq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=(b+31|0)>>>5;f=c[16742]|0;g=c[16744]|0;a:do if((g+e|0)>>>0>=f>>>0){h=f;while(1){if(h){j=h<<1;if(j>>>0>16777215){k=-1;l=20;break}m=h<<4;if(m>>>0>=2048&(2048-1|0)>>>0<m>>>0){n=pp(m,0)|0;o=j;l=11}else{p=m;q=j;l=7}}else{c[16624]=70;p=800;q=100;l=7}do if((l|0)==7){l=0;j=c[3476+(p<<2)>>2]|0;m=1412+(j<<2)|0;r=c[m>>2]|0;if(!r){n=pp(p,0)|0;o=q;l=11;break}else{c[m>>2]=c[r>>2];c[22]=(c[22]|0)+(j<<3);s=r;t=h;u=q;break}}while(0);if((l|0)==11){l=0;if(!n){k=-1;l=20;break}s=n;t=c[16742]|0;u=o}if((h|0)==(t|0)){r=c[16744]|0;if(r)YEi(s|0,c[16740]|0,r<<3|0)|0;c[16742]=u;c[16740]=s;v=u}else v=t;r=c[16744]|0;if((r+e|0)>>>0<v>>>0){w=r;break a}else h=v}if((l|0)==20){i=d;return k|0}}else w=g;while(0);g=e+-1|0;l=c[a>>2]|0;v=c[16740]|0;if(!g){x=l;y=0}else{t=l;l=0;while(1){u=l+w|0;c[v+(u<<3)>>2]=t;c[v+(u<<3)+4>>2]=1;l=l+1|0;u=c[a+(l<<2)>>2]|0;if(l>>>0>=g>>>0){x=u;y=g;break}else t=u}}t=(e<<5)-b|0;b=y+w|0;c[v+(b<<3)>>2]=x<<t>>>t;c[v+(b<<3)+4>>2]=0;c[16744]=(c[16744]|0)+e;k=w;i=d;return k|0}function Cq(){var a=0,b=0,d=0,e=0,f=0;a=i;if(c[16738]|0){i=a;return}c[16738]=1;b=hp(1028,0)|0;if(!b){Nq(67928);Vl()}PEi(b|0,0,1028)|0;c[16748]=b;d=c[16182]|0;e=d+1|0;c[16182]=e;if(e>>>0>16){Nq(67976);Vl()}c[62632+(d*20|0)>>2]=b;c[62636+(d*20|0)>>2]=0;c[62640+(d*20|0)>>2]=-1;c[62644+(d*20|0)>>2]=1;c[62648+(d*20|0)>>2]=1;d=c[15612]|0;b=d+1|0;c[15612]=b;if(b>>>0>64){Nq(67992);Vl()}c[128+(d<<2)>>2]=222;c[16746]=d;d=hp(1028,0)|0;if(!d){Nq(67928);Vl()}PEi(d|0,0,1028)|0;c[16750]=d;b=c[15612]|0;e=b+1|0;c[15612]=e;if(e>>>0>64){Nq(67992);Vl()}c[128+(b<<2)>>2]=223;e=c[16182]|0;f=e+1|0;c[16182]=f;if(f>>>0>16){Nq(67976);Vl()}c[62632+(e*20|0)>>2]=d;c[62636+(e*20|0)>>2]=0;c[62640+(e*20|0)>>2]=b<<2|2;c[62644+(e*20|0)>>2]=0;c[62648+(e*20|0)>>2]=1;i=a;return}function Dq(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=i;i=i+80|0;j=h;k=h+8|0;l=c[16740]|0;m=c[l+(g<<3)>>2]|0;n=c[16278]|0;o=c[16276]|0;p=k+0|0;q=p+64|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));if(!m){r=e;s=l}else{l=o;o=n;n=e;e=m;m=d;while(1){a:do if((e&1|0)!=0?(p=c[m>>2]|0,!(p>>>0<l>>>0|p>>>0>o>>>0)):0){q=p;t=p>>>12;u=t&7;v=k+(u<<3)|0;if((c[v>>2]|0)!=(t|0)){w=ip(q,v)|0;if(!w){x=n;break}else y=w}else y=c[k+(u<<3)+4>>2]|0;u=p&4095;w=u>>>3;v=b[(c[y+28>>2]|0)+(w<<1)>>1]|0;z=p&7;do if(v|z)if(!(a[y+24>>0]|0)){A=v<<3|z;if(a[12700+A>>0]|0){B=q+(0-A)|0;C=w-v|0;break}if(1){A=t&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((t&1023)<<2)>>2]|0){D=A>>>5;E=1<<(t&31);if(!(c[(c[6]|0)+(D<<2)>>2]&E)){x=n;break a}else{F=E;G=D}}else{F=1<<(t&31);G=A>>>5}A=(c[8]|0)+(G<<2)|0;c[A>>2]=c[A>>2]|F;x=n;break a}if(!(a[16796+(p&3)>>0]|0)){x=n;break a}A=t&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((t&1023)<<2)>>2]|0){D=A>>>5;E=1<<(t&31);if(!(c[(c[2]|0)+(D<<2)>>2]&E)){x=n;break a}else{H=E;I=D}}else{H=1<<(t&31);I=A>>>5}A=(c[4]|0)+(I<<2)|0;c[A>>2]=c[A>>2]|H;x=n;break a}else{A=c[y+8>>2]|0;if((p-A|0)!=(u|0)){B=A;C=0;break}if(a[12700+u>>0]|0){B=A;C=0;break}if(1){A=t&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((t&1023)<<2)>>2]|0){D=A>>>5;E=1<<(t&31);if(!(c[(c[6]|0)+(D<<2)>>2]&E)){x=n;break a}else{J=E;K=D}}else{J=1<<(t&31);K=A>>>5}A=(c[8]|0)+(K<<2)|0;c[A>>2]=c[A>>2]|J;x=n;break a}if(!(a[16796+(p&3)>>0]|0)){x=n;break a}A=t&262143;if(c[(c[58020+(p>>>22<<2)>>2]|0)+((t&1023)<<2)>>2]|0){D=A>>>5;E=1<<(t&31);if(!(c[(c[2]|0)+(D<<2)>>2]&E)){x=n;break a}else{L=E;M=D}}else{L=1<<(t&31);M=A>>>5}A=(c[4]|0)+(M<<2)|0;c[A>>2]=c[A>>2]|L;x=n;break a}else{B=q;C=w}while(0);w=y+(C>>>5<<2)+36|0;q=c[w>>2]|0;t=1<<(C&31);if((t&q|0)==0?(c[w>>2]=t|q,q=y+32|0,c[q>>2]=(c[q>>2]|0)+1,q=c[y+20>>2]|0,(q|0)!=0):0){t=n+8|0;if(t>>>0<f>>>0){N=t;O=1}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[j>>2]=c[16442];cp(66176,j)}N=n+-4088|0;O=-511}c[n+(O<<3)>>2]=B;c[n+(O<<3)+4>>2]=q;x=N}else x=n}else x=n;while(0);e=e>>>1;if(!e){P=x;break}else{n=x;m=m+4|0}}r=P;s=c[16740]|0}if(!(c[s+(g<<3)+4>>2]|0)){Q=r;i=h;return Q|0}s=r+8|0;if(s>>>0<f>>>0){R=s;S=1}else{c[16462]=5;c[16516]=1;if(c[15560]|0){c[j>>2]=c[16442];cp(66176,j)}R=r+-4088|0;S=-511}c[r+(S<<3)>>2]=d+128;c[r+(S<<3)+4>>2]=(c[16746]|(g<<6)+64)<<2|2;Q=R;i=h;return Q|0}function Eq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;f=a;g=c[(c[(c[58020+(f>>>22<<2)>>2]|0)+((f>>>12&1023)<<2)>>2]|0)+16>>2]|0;f=a+((g>>>2)+-1<<2)|0;h=c[f>>2]|0;if(!h){j=b;i=e;return j|0}k=Gq(a,h,b,d+-8|0)|0;if(!k){c[16516]=1;d=b+8|0;c[d>>2]=a;c[b+12>>2]=g;j=d;i=e;return j|0}else{d=k+8|0;c[d>>2]=f;c[k+12>>2]=4;j=d;i=e;return j|0}return 0}function Fq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a>>2]|0;if((d|0)==2){e=c[a+4>>2]|0;f=da(Fq(c[a+8>>2]|0)|0,e)|0;i=b;return f|0}else if((d|0)==3){f=Fq(c[a+4>>2]|0)|0;e=(Fq(c[a+8>>2]|0)|0)+f|0;i=b;return e|0}else if((d|0)!=1)if(2555==(-1|0)){g=0;i=b;return g|0}else{Nq(67008);Vl()}else{g=da(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return g|0}return 0}function Gq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=a;a=b;b=d;while(1){d=c[a>>2]|0;if((d|0)==1){h=g;j=a;k=b;l=3;break}else if((d|0)==2){m=g;n=a;o=b;l=6;break}else if((d|0)!=3){l=11;break}d=a+4|0;p=Fq(c[d>>2]|0)|0;q=Gq(g,c[d>>2]|0,b,e)|0;if(!q){r=0;l=14;break}g=g+p|0;a=c[a+8>>2]|0;b=q}if((l|0)==3){b=c[j+12>>2]|0;a=c[j+8>>2]|0;if((e-k>>3|0)<=(a|0)){r=0;i=f;return r|0}g=c[j+4>>2]|0;if(!a){r=k;i=f;return r|0}else{s=k;t=h;u=0}while(1){h=s;s=s+8|0;c[s>>2]=t;c[h+12>>2]=b;u=u+1|0;if((u|0)==(a|0))break;else t=t+g|0}r=k+(a<<3)|0;i=f;return r|0}else if((l|0)==6){a=c[n+8>>2]|0;k=c[n+4>>2]|0;n=Fq(a)|0;if(!k){r=o;i=f;return r|0}else{v=o;w=m;x=0}while(1){m=Gq(w,a,v,e)|0;if(!m){r=0;l=14;break}x=x+1|0;if(x>>>0>=k>>>0){r=m;l=14;break}else{v=m;w=w+n|0}}if((l|0)==14){i=f;return r|0}}else if((l|0)==11)if(2555==(-1|0)){r=0;i=f;return r|0}else{Nq(67008);Vl()}else if((l|0)==14){i=f;return r|0}return 0}function Hq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+-1|0;if(!(c[16738]|0))Cq();if((e|0)>-1)f=e;else{g=0;i=d;return g|0}while(1){if(c[a+(f>>>5<<2)>>2]&1<<(f&31)){h=f;break}if((f|0)>0)f=f+-1|0;else{g=0;j=16;break}}if((j|0)==16){i=d;return g|0}a:do if((h|0)>0){j=0;while(1){if(!(c[a+(j>>>5<<2)>>2]&1<<(j&31)))break;j=j+1|0;if((j|0)>=(h|0)){k=h;break a}}if(h>>>0<30){j=h;f=-2147483648;while(1){j=j+-1|0;e=f>>>1;b=(c[a+(j>>>5<<2)>>2]&1<<(j&31)|0)==0?e:e|-2147483648;if((j|0)<=0){l=b;break}else f=b}g=l|1;i=d;return g|0}f=Bq(a,h+1|0)|0;if((f|0)==-1){g=(h<<2)+4|0;i=d;return g|0}else{g=(c[16746]|f<<6)<<2|2;i=d;return g|0}}else k=h;while(0);g=(k<<2)+4|0;i=d;return g|0}function Iq(a){a=a|0;return 0}function Jq(){return c[14]|0}function Kq(){return c[18]|0}function Lq(){var a=0;a=i;if((c[15976]|0)!=0?(Pp(0,0)|0,(c[15738]|0)!=0):0)qp();i=a;return}function Mq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;_o(a,e);i=d;return}function Nq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[15976]=0;a:do if(a){d=SEi(a|0)|0;if(d){e=0;while(1){f=gf(2,a+e|0,d-e|0)|0;g=f+e|0;if((f|0)==-1)break a;if(g>>>0<d>>>0)e=g;else{h=g;break}}if((h|0)<=-1)break;else j=2}else j=2;do{}while((gf(j|0,1072968,1)|0)==0)}while(0);if(!(cj(67904)|0)){i=b;return}else while(1){}}function Oq(){c[15656]=(c[15656]|0)+-1;return}function Pq(){c[15656]=(c[15656]|0)+1;return}function Qq(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=mo[a&4095](b)|0;i=c;return d|0}function Rq(){return c[16020]|0}function Sq(a){a=a|0;c[16578]=a;return}function Tq(){return}function Uq(){return}function Vq(a){a=a|0;var b=0;b=i;uf(6,3653512)|0;ZL(a);i=b;return}function Wq(){var a=0;a=i;_L();i=a;return}function Xq(a,b,c){a=a|0;b=b|0;c=c|0;c=i;CJ(b,a);i=c;return}function Yq(){var a=0,b=0;a=i;b=sK()|0;i=a;return b|0}function Zq(a,b){a=a|0;b=b|0;var c=0;c=i;KK(a,b);i=c;return}function _q(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=JI(a,b)|0;i=c;return d|0}function $q(a){a=a|0;var b=0,c=0;b=i;c=sI(a)|0;i=b;return c|0}function ar(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=uI(a,b)|0;i=c;return d|0}function br(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=vI(a,b)|0;i=c;return d|0}function cr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=HI(a,b,c)|0;i=d;return e|0}function dr(a){a=a|0;var b=0,c=0;b=i;c=rI(a)|0;i=b;return c|0}function er(a){a=a|0;var b=0,c=0;b=i;c=BI(a)|0;i=b;return c|0}function fr(a){a=a|0;var b=0,c=0;b=i;c=NI(a)|0;i=b;return c|0}function gr(a){a=a|0;var b=0,c=0;b=i;c=LI(a)|0;i=b;return c|0}function hr(a){a=a|0;var b=0,c=0;b=i;c=cJ(a)|0;i=b;return c|0}function ir(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=dJ(a,b,c)|0;i=d;return e|0}function jr(a){a=a|0;var b=0,c=0;b=i;c=GI(a)|0;i=b;return c|0}function kr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=iJ(a,b,c)|0;i=d;return e|0}function lr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=OI(a,b)|0;i=c;return d|0}function mr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=PI(a,b)|0;i=c;return d|0}function nr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=TI(a,b)|0;i=c;return d|0}function or(a){a=a|0;var b=0,c=0;b=i;c=WI(a)|0;i=b;return c|0}function pr(a){a=a|0;var b=0,c=0;b=i;c=XI(a)|0;i=b;return c|0}function qr(a){a=a|0;var b=0,c=0;b=i;c=_I(a)|0;i=b;return c|0}function rr(a){a=a|0;var b=0,c=0;b=i;c=SI(a)|0;i=b;return c|0}function sr(a){a=a|0;var b=0,c=0;b=i;c=eJ(a)|0;i=b;return c|0}function tr(a){a=a|0;var b=0,c=0;b=i;c=kJ(a)|0;i=b;return c|0}function ur(a){a=a|0;var b=0,c=0;b=i;c=lJ(a)|0;i=b;return c|0}function vr(a){a=a|0;var b=0,c=0;b=i;c=mJ(a)|0;i=b;return c|0}function wr(a){a=a|0;var b=0,c=0;b=i;c=oJ(a)|0;i=b;return c|0}function xr(a){a=a|0;var b=0,c=0;b=i;c=GI(a)|0;i=b;return c|0}function yr(a){a=a|0;var b=0,c=0;b=i;c=pJ(a)|0;i=b;return c|0}function zr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=sJ(a,b)|0;i=c;return d|0}function Ar(a){a=a|0;var b=0,c=0;b=i;c=tJ(a)|0;i=b;return c|0}function Br(a){a=a|0;var b=0,c=0;b=i;c=uJ(a)|0;i=b;return c|0}function Cr(a){a=a|0;var b=0,c=0;b=i;c=yJ(a)|0;i=b;return c|0}function Dr(){var a=0,b=0;a=i;b=AJ()|0;i=a;return b|0}function Er(a,b){a=a|0;b=b|0;var c=0;a=i;c=CI(b)|0;i=a;return c|0}function Fr(a){a=a|0;FJ(a)}function Gr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=IJ(a,b,c,d)|0;i=e;return f|0}function Hr(a){a=a|0;var b=0,c=0;b=i;c=$J(a)|0;i=b;return c|0}function Ir(a){a=a|0;var b=0,c=0;b=i;c=bK(a)|0;i=b;return c|0}function Jr(a){a=a|0;var b=0,c=0;b=i;c=aK(a)|0;i=b;return c|0}function Kr(a){a=a|0;var b=0,c=0;b=i;c=cK(a)|0;i=b;return c|0}function Lr(a){a=a|0;var b=0,c=0;b=i;c=gK(a)|0;i=b;return c|0}function Mr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=hK(a,b)|0;i=c;return d|0}function Nr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Ys(a,b)|0;i=c;return d|0}function Or(a){a=a|0;var b=0,c=0;b=i;c=_s(a)|0;i=b;return c|0}function Pr(a){a=a|0;var b=0;b=i;$s(a);i=b;return}function Qr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=VK(a,b,c,d)|0;i=e;return f|0}function Rr(a){a=a|0;var b=0;b=i;WK(a);i=b;return}function Sr(a,b){a=a|0;b=b|0;var c=0;c=i;XK(a,b);i=c;return}function Tr(a){a=a|0;var b=0;b=i;YK(a);i=b;return}function Ur(a){a=a|0;var b=0,c=0;b=i;c=dL(a)|0;i=b;return c|0}function Vr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=NL(a,b)|0;i=c;return d|0}function Wr(a){a=a|0;var b=0,c=0;b=i;c=eL(a)|0;i=b;return c|0}function Xr(a){a=a|0;var b=0,c=0;b=i;c=fL(a)|0;i=b;return c|0}function Yr(a){a=a|0;var b=0,c=0;b=i;c=gL(a)|0;i=b;return c|0}function Zr(a){a=a|0;var b=0,c=0;b=i;c=hL(a)|0;i=b;return c|0}function _r(a){a=a|0;var b=0,c=0;b=i;c=iL(a)|0;i=b;return c|0}function $r(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=jL(a,b)|0;i=c;return d|0}function as(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=kL(a,b)|0;i=c;return d|0}function bs(a){a=a|0;var b=0,c=0;b=i;c=sL(a)|0;i=b;return c|0}function cs(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=uL(a,b)|0;i=c;return d|0}function ds(a){a=a|0;var b=0,c=0;b=i;c=qL(a)|0;i=b;return c|0}function es(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=cM(a,b,c,d,e)|0;i=f;return g|0}function fs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=aM(a,b,c,d)|0;i=e;return f|0}function gs(a,b){a=a|0;b=b|0;var c=0;c=i;eM(a,b);i=c;return}function hs(a){a=a|0;var b=0;b=i;fM(a);i=b;return}function is(a){a=a|0;var b=0,c=0;b=i;c=nM(a)|0;i=b;return c|0}function js(a){a=a|0;var b=0,c=0;b=i;c=oM(a)|0;i=b;return c|0}function ks(a){a=a|0;var b=0,c=0;b=i;c=qM(a)|0;i=b;return c|0}function ls(a){a=a|0;var b=0,c=0;b=i;c=sM(a)|0;i=b;return c|0}function ms(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rM(a,b)|0;i=c;return d|0}function ns(a){a=a|0;var b=0,c=0;b=i;c=wM(a)|0;i=b;return c|0}function os(a){a=a|0;var b=0,c=0;b=i;c=xM(a)|0;i=b;return c|0}function ps(){var a=0,b=0;a=i;b=zM()|0;i=a;return b|0}function qs(a){a=a|0;var b=0,c=0;b=i;c=ML(a)|0;i=b;return c|0}function rs(a){a=a|0;var b=0,c=0;b=i;c=_M(a)|0;i=b;return c|0}function ss(a){a=a|0;var b=0,c=0;b=i;c=bN(a)|0;i=b;return c|0}function ts(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;aN(e,b,0);b=a[e>>0]|0;if(!(b&1)){f=(b&255)>>>1;g=ADi(((b&255)>>>1)+1|0)|0;h=e+1|0}else{b=ADi((c[e+4>>2]|0)+1|0)|0;f=c[e+4>>2]|0;g=b;h=c[e+8>>2]|0}YEi(g|0,h|0,f+1|0)|0;xri(e);i=d;return g|0}function us(){var b=0;b=i;if(a[68368]|0){i=b;return}Sq(1);fp();ep(0,0);a[68368]=1;i=b;return}function vs(a){a=a|0;a=i;Qp();i=a;return}function ws(){return 0}function xs(a){a=a|0;var b=0;a=i;b=Rq()|0;i=a;return b|0}function ys(a,b){a=a|0;b=b|0;return}function zs(){var a=0,b=0,c=0;a=i;b=Jq()|0;c=b-(Kq()|0)|0;H=0;i=a;return c|0}function As(){var a=0;a=i;Pq();i=a;return}function Bs(){var a=0;a=i;Oq();i=a;return}function Cs(a){a=a|0;return 1}function Ds(){return 1}function Es(a,b,d){a=a|0;b=b|0;d=d|0;d=i;c[a>>2]=~b;Yp(a,b)|0;i=d;return}function Fs(a){a=a|0;var b=0;b=i;_p(a)|0;c[a>>2]=0;i=b;return}function Gs(a){a=a|0;var b=0,c=0;b=i;c=Qq(3330,a)|0;i=b;return ((c|0)==(-1|0)?0:c)|0}function Hs(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)>29)d=0;else d=Hq(a,b)|0;i=c;return d|0}function Is(){return}function Js(){return}function Ks(a,b){a=a|0;b=b|0;var c=0;b=i;c=tp(a)|0;i=b;return c|0}function Ls(a){a=a|0;var b=0;b=i;up(a);i=b;return}function Ms(){var a=0,b=0;a=i;b=gq()|0;i=a;return b|0}function Ns(){var a=0,b=0;a=i;b=(hq()|0)!=0;i=a;return b|0}function Os(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=68376;gl(406304,a|0)|0;i=b;return}function Ps(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=68408;gl(406304,b|0)|0;i=a;return}function Qs(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=68448;gl(406304,b|0)|0;i=d;return}function Rs(a){a=a|0;return 0}function Ss(){var a=0;a=i;us();i=a;return}function Ts(){return}function Us(a,b){a=a|0;b=b|0;var d=0;b=i;i=i+16|0;d=b;c[d>>2]=0;aM(QI(c[a>>2]|0)|0,a,0,d)|0;i=b;return}function Vs(a){a=a|0;var b=0;b=i;if(!a)FJ(KJ(3142024)|0);else{Vp(a,2556,0,0,0);i=b;return}}function Ws(a){a=a|0;var b=0;b=i;if(!a)FJ(KJ(3142024)|0);else{Vp(a,0,0,0,0);i=b;return}}function Xs(){var a=0;a=i;if(!(Ns()|0)){i=a;return}Ms()|0;i=a;return}function Ys(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=wN(68488+((b?3:2)*20|0)|0,a,0)|0;i=c;return d|0}function Zs(a){a=a|0;return (a&7)+-1|0}function _s(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a>>>3;f=(a&7)+-1|0;if(f>>>0>3){g=0;i=b;return g|0}if(e>>>0>=(c[68496+(f*20|0)>>2]|0)>>>0){g=0;i=b;return g|0}if(!(c[(c[68488+(f*20|0)>>2]|0)+(a>>>8<<2)>>2]&1<<(e&31))){g=0;i=b;return g|0}a=(c[68492+(f*20|0)>>2]|0)+(e<<2)|0;if((d[68500+(f*20|0)>>0]|0)<2){g=Gs(a)|0;i=b;return g|0}else{g=c[a>>2]|0;i=b;return g|0}return 0}function $s(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;e=a>>>3;f=(a&7)+-1|0;if(f>>>0>3){i=b;return}if((f|0)==1)Ps(a);if(e>>>0>=(c[68496+(f*20|0)>>2]|0)>>>0){i=b;return}g=a>>>8;a=68488+(f*20|0)|0;h=1<<(e&31);if(!(c[(c[a>>2]|0)+(g<<2)>>2]&h)){i=b;return}j=(c[68492+(f*20|0)>>2]|0)+(e<<2)|0;if((d[68500+(f*20|0)>>0]|0)<2){if(c[j>>2]|0)Fs(j)}else c[j>>2]=0;j=(c[a>>2]|0)+(g<<2)|0;c[j>>2]=c[j>>2]&~h;i=b;return}function at(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;switch(f|0){case -1:{f=e>>>3;h=(e&7)+-1|0;if(h>>>0>3){j=e;i=g;return j|0}do if(f>>>0<(c[68496+(h*20|0)>>2]|0)>>>0?(c[(c[68488+(h*20|0)>>2]|0)+(e>>>8<<2)>>2]&1<<(f&31)|0)!=0:0){k=68500+(h*20|0)|0;if((d[k>>0]|0)>=2){c[(c[68492+(h*20|0)>>2]|0)+(f<<2)>>2]=b;l=0;break}m=68492+(h*20|0)|0;n=(c[m>>2]|0)+(f<<2)|0;o=c[n>>2]|0;if(o)Fs(n);if(!b)l=o;else{Es((c[m>>2]|0)+(f<<2)|0,b,(a[k>>0]|0)==1);l=o}}else l=0;while(0);if((h|0)!=1){j=e;i=g;return j|0}Qs(l,b,e);j=e;i=g;return j|0}case 0:{j=wN(68488,b,0)|0;i=g;return j|0}case 2:{j=wN(68528,b,0)|0;i=g;return j|0}case 1:{e=wN(68508,b,1)|0;Os(b,e);j=e;i=g;return j|0}case 3:{j=wN(68548,b,0)|0;i=g;return j|0}default:{j=0;i=g;return j|0}}return 0}function bt(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function ct(){var a=0,b=0;a=i;b=qM(68568)|0;i=a;return b|0}function dt(){FJ(SJ(68608)|0)}function et(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;FJ(SJ(68800)|0)}function ft(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=69024;gl(345824,a|0)|0;i=b;return}function gt(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69056;gl(345824,b|0)|0;i=a;return 0}function ht(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69088;gl(345824,b|0)|0;i=a;return 0}function it(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69120;gl(345824,b|0)|0;i=a;return 0}function jt(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69160;gl(345824,b|0)|0;i=a;return 0}function kt(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69200;gl(345824,b|0)|0;i=a;return 0}function lt(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69240;gl(345824,b|0)|0;i=a;return 0}function mt(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69280;gl(345824,b|0)|0;i=a;return 0}function nt(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=69304;gl(345824,b|0)|0;i=a;return}function ot(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=69336;gl(345824,b|0)|0;i=d;return 0}function pt(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[c[a+8>>2]>>2]|0;a=yK(c[d>>2]|0,c[d+12>>2]|0,c[d+8>>2]|0,c[d+40>>2]|0)|0;if(!a){e=0;i=b;return e|0}e=ds(a)|0;i=b;return e|0}function qt(){var a=0,b=0,d=0,e=0;a=i;b=AJ()|0;d=c[b>>2]|0;if(d){e=d;i=a;return e|0}d=qL(c[101554]|0)|0;c[b>>2]=d;e=d;i=a;return e|0}function rt(){var a=0,b=0;a=i;b=c[(BJ()|0)>>2]|0;i=a;return b|0}function st(a,b){a=a|0;b=b|0;FJ(SJ(69376)|0);return 0}function tt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;if(!(c[17396]|0))c[17396]=iJ(c[101522]|0,3131888,3144808)|0;a=zI()|0;d=a+4|0;e=uI(c[17396]|0,(c[d>>2]|0)-(c[a>>2]|0)>>2)|0;f=c[a>>2]|0;if((f|0)==(c[d>>2]|0)){i=b;return e|0}else{g=f;h=0}while(1){f=yI(e,4,h)|0;c[f>>2]=KL(c[g>>2]|0)|0;g=g+4|0;if((g|0)==(c[d>>2]|0))break;else h=h+1|0}i=b;return e|0}function ut(a){a=a|0;var b=0,d=0;b=i;d=ks(c[(c[a+12>>2]|0)+8>>2]|0)|0;i=b;return d|0}function vt(a){a=a|0;return c[(c[a+12>>2]|0)+4>>2]|0}function wt(){FJ(SJ(69592)|0);return 0}function xt(){FJ(SJ(69816)|0);return 0}function yt(a){a=a|0;FJ(SJ(70088)|0);return 0}function zt(){FJ(SJ(70328)|0)}function At(a){a=a|0;FJ(SJ(70544)|0)}function Bt(a){a=a|0;FJ(SJ(70760)|0)}function Ct(a){a=a|0;FJ(SJ(70984)|0);return 0}function Dt(a){a=a|0;FJ(SJ(71200)|0);return 0}function Et(a){a=a|0;FJ(SJ(71416)|0);return 0}function Ft(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+16|0;e=f;kI(e,d+12|0);if(!(a[e>>0]&1))g=e+1|0;else g=c[e+8>>2]|0;d=AI(g)|0;xri(e);if(!d){h=0;i=f;return h|0}h=KL(d)|0;i=f;return h|0}function Gt(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(71632)|0);return 0}function Ht(a,b){a=a|0;b=b|0;FJ(SJ(71816)|0);return 0}function It(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(SJ(71992)|0);return 0}function Jt(a){a=a|0;FJ(SJ(72176)|0);return 0}function Kt(a){a=a|0;FJ(SJ(72376)|0)}function Lt(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(72560)|0)}function Mt(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(72736)|0)}function Nt(a,b){a=a|0;b=b|0;FJ(SJ(72944)|0)}function Ot(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(73152)|0)}function Pt(a){a=a|0;FJ(SJ(73360)|0);return 0}function Qt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xI(c[a>>2]|0)|0;PEi(yI(a,f,b)|0,0,da(f,d)|0)|0;i=e;return}function Rt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d;f=c[b>>2]|0;g=rI(f)|0;h=c[b+8>>2]|0;if(!h){c[e>>2]=sI(b)|0;j=wI(f,e,0)|0;YEi(j+16|0,b+16|0,da(c[e>>2]|0,g)|0)|0;k=j;i=d;return k|0}j=f+144|0;e=a[j>>0]|0;l=e&255;if(e<<24>>24){e=xCi(l<<2)|0;PEi(e|0,0,l<<2|0)|0;l=a[j>>0]|0;m=l&255;if(l<<24>>24){l=xCi(m<<2)|0;PEi(l|0,0,m<<2|0)|0;m=a[j>>0]|0;if(!(m<<24>>24)){n=e;o=l;p=g}else{j=m&255;m=0;q=g;while(1){r=h+(m<<3)|0;c[e+(m<<2)>>2]=c[r>>2];s=da(c[r>>2]|0,q)|0;c[l+(m<<2)>>2]=c[h+(m<<3)+4>>2];m=m+1|0;if((m|0)>=(j|0)){n=e;o=l;p=s;break}else q=s}}}else{n=e;o=0;p=g}}else{n=0;o=0;p=g}g=wI(f,n,o)|0;YEi(g+16|0,b+16|0,p|0)|0;if(o)ACi(o);if(!n){k=g;i=d;return k|0}ACi(n);k=g;i=d;return k|0}function St(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+192|0;g=f+172|0;h=f+160|0;j=f+16|0;k=f;if(!d)l=0;else l=yI(d,xI(c[d>>2]|0)|0,0)|0;if(!e)m=0;else m=yI(e,xI(c[e>>2]|0)|0,0)|0;e=b+8|0;b=GI(c[e>>2]|0)|0;n=JI(b,sI(d)|0)|0;if(n){d=wI(n,l,m)|0;i=f;return d|0}aN(h,c[e>>2]|0,0);e=j+64|0;d=j+8|0;c[d>>2]=73864;f=j+12|0;c[j>>2]=74012;c[e>>2]=74032;c[j+4>>2]=0;esi(j+64|0,f);c[j+136>>2]=0;c[j+140>>2]=-1;c[j>>2]=73844;c[e>>2]=73884;c[d>>2]=73864;jsi(f);c[f>>2]=74048;d=j+44|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[j+60>>2]=24;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;yN(f,g);xri(g);g=uN(j+8|0,73576,35)|0;d=a[h>>0]|0;if(!(d&1)){o=h+1|0;p=(d&255)>>>1}else{o=c[h+8>>2]|0;p=c[h+4>>2]|0}d=uN(uN(g,o,p)|0,73616,129)|0;p=a[h>>0]|0;if(!(p&1)){q=h+1|0;r=(p&255)>>>1}else{q=c[h+8>>2]|0;r=c[h+4>>2]|0}uN(uN(d,q,r)|0,73752,75)|0;zN(k,f);AN(j,73896);bsi(e);xri(h);if(!(a[k>>0]&1)){s=k+1|0;t=VJ(s)|0;FJ(t)}else{s=c[k+8>>2]|0;t=VJ(s)|0;FJ(t)}return 0}function Tt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;if((a[(c[b>>2]|0)+144>>0]|0)!=(a[(c[e>>2]|0)+144>>0]|0)){j=0;i=h;return j|0}if(c[b+8>>2]|0){j=0;i=h;return j|0}if(c[e+8>>2]|0){j=0;i=h;return j|0}if((g+f|0)>>>0>(sI(e)|0)>>>0){j=0;i=h;return j|0}k=g+d|0;if(k>>>0>(sI(b)|0)>>>0){j=0;i=h;return j|0}l=c[e>>2]|0;if((c[(c[b>>2]|0)+44>>2]|0)==(c[101523]|0)?(a[(c[l+44>>2]|0)+145>>0]|0)!=0:0){m=(g|0)>0;if(m){n=d;do n=n+1|0;while((n|0)<(k|0));o=c[e>>2]|0}else o=l;k=xI(o)|0;PEi(yI(e,k,f)|0,0,da(k,g)|0)|0;if(m)p=0;else{j=1;i=h;return j|0}do{m=c[(yI(b,4,p+d|0)|0)>>2]|0;o=yI(e,k,p+f|0)|0;if(m)YEi(o|0,m+8|0,k|0)|0;p=p+1|0}while((p|0)!=(g|0));j=1;i=h;return j|0}p=e+16+(da(xI(l)|0,f)|0)|0;f=b+16+(da(xI(c[b>>2]|0)|0,d)|0)|0;aFi(p|0,f|0,da(xI(c[e>>2]|0)|0,g)|0)|0;j=1;i=h;return j|0}function Ut(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;if((b|0)>=0?(d[(c[a>>2]|0)+144>>0]|0|0)>(b|0):0){f=c[a+8>>2]|0;if(!f){g=a+12|0;h=c[g>>2]|0;i=e;return h|0}else{g=f+(b<<3)|0;h=c[g>>2]|0;i=e;return h|0}}FJ(NJ()|0);return 0}function Vt(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;if((b|0)>=0?(d[(c[a>>2]|0)+144>>0]|0|0)>(b|0):0){f=c[a+8>>2]|0;if(!f){g=0;i=e;return g|0}g=c[f+(b<<3)+4>>2]|0;i=e;return g|0}FJ(NJ()|0);return 0}function Wt(a){a=a|0;return d[(c[a>>2]|0)+144>>0]|0|0}function Xt(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;if(!e)FJ(KJ(2684312)|0);g=c[b>>2]|0;if(c[e+8>>2]|0){h=JJ(0,0)|0;FJ(h)}if((c[e+12>>2]|0)!=(d[g+144>>0]|0)){h=JJ(0,0)|0;FJ(h)}h=e+16|0;e=b+8|0;j=c[e>>2]|0;if(!j){k=c[h>>2]|0;if((k|0)<0){l=NJ()|0;FJ(l)}if((k|0)>=(c[b+12>>2]|0)){l=NJ()|0;FJ(l)}l=c[b>>2]|0;m=b+16+(da(c[l+120>>2]|0,k)|0)|0;k=c[l+44>>2]|0;if(!(a[k+145>>0]|0)){n=c[m>>2]|0;i=f;return n|0}else{n=pL(k,m)|0;i=f;return n|0}}m=a[g+144>>0]|0;do if(m<<24>>24){g=j;k=m;l=0;while(1){o=c[h+(l<<2)>>2]|0;p=c[g+(l<<3)+4>>2]|0;if((o|0)<(p|0)){q=17;break}if((o|0)>=((c[g+(l<<3)>>2]|0)+p|0)){q=17;break}l=l+1|0;p=c[e>>2]|0;if((l|0)>=(k&255|0)){r=k;s=p;q=19;break}else g=p}if((q|0)==17)FJ(NJ()|0);else if((q|0)==19){g=(c[h>>2]|0)-(c[s+4>>2]|0)|0;if((r&255)<=1){t=g;break}k=r&255;l=1;p=g;while(1){g=da(c[s+(l<<3)>>2]|0,p)|0;o=g+(c[h+(l<<2)>>2]|0)-(c[s+(l<<3)+4>>2]|0)|0;l=l+1|0;if((l|0)>=(k|0)){t=o;break}else p=o}}}else t=(c[h>>2]|0)-(c[j+4>>2]|0)|0;while(0);j=c[b>>2]|0;h=b+16+(da(c[j+120>>2]|0,t)|0)|0;t=c[j+44>>2]|0;if(!(a[t+145>>0]|0)){n=c[h>>2]|0;i=f;return n|0}else{n=pL(t,h)|0;i=f;return n|0}return 0}function Yt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b>>2]|0;g=b+16+(da(c[f+120>>2]|0,d)|0)|0;d=c[f+44>>2]|0;if(!(a[d+145>>0]|0)){h=c[g>>2]|0;i=e;return h|0}else{h=pL(d,g)|0;i=e;return h|0}return 0}function Zt(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;if(!f)FJ(KJ(73568)|0);h=c[b>>2]|0;if(c[f+8>>2]|0){j=JJ(0,0)|0;FJ(j)}if((c[f+12>>2]|0)!=(d[h+144>>0]|0|0)){j=JJ(0,0)|0;FJ(j)}j=f+16|0;f=b+8|0;k=c[f>>2]|0;if(!k){l=c[j>>2]|0;if((l|0)<0){m=NJ()|0;FJ(m)}if((l|0)>=(c[b+12>>2]|0)){m=NJ()|0;FJ(m)}_t(b,e,l);i=g;return}l=a[h+144>>0]|0;do if(l<<24>>24){h=k;m=l;n=0;while(1){o=c[j+(n<<2)>>2]|0;p=c[h+(n<<3)+4>>2]|0;if((o|0)<(p|0)){q=15;break}if((o|0)>=((c[h+(n<<3)>>2]|0)+p|0)){q=15;break}n=n+1|0;p=c[f>>2]|0;if((n|0)>=(m&255|0)){r=m;s=p;q=17;break}else h=p}if((q|0)==15)FJ(NJ()|0);else if((q|0)==17){h=(c[j>>2]|0)-(c[s+4>>2]|0)|0;if((r&255)<=1){t=h;break}m=r&255;n=1;p=h;while(1){h=da(c[s+(n<<3)>>2]|0,p)|0;o=h+(c[j+(n<<2)>>2]|0)-(c[s+(n<<3)+4>>2]|0)|0;n=n+1|0;if((n|0)>=(m|0)){t=o;break}else p=o}}}else t=(c[j>>2]|0)-(c[k+4>>2]|0)|0;while(0);_t(b,e,t);i=g;return}function _t(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;if(!d){c[(yI(b,4,e)|0)>>2]=0;i=f;return}h=c[b>>2]|0;j=h+44|0;if(bJ(c[j>>2]|0,c[d>>2]|0)|0)if(!(a[(c[j>>2]|0)+145>>0]|0)){c[(yI(b,4,e)|0)>>2]=d;i=f;return}else{j=yL(d)|0;k=yI(b,xI(h)|0,e)|0;YEi(k|0,j|0,xI(h)|0)|0;i=f;return}else{_J(g,c[(c[b>>2]|0)+44>>2]|0,c[d>>2]|0);if(!(a[g>>0]&1)){l=g+1|0;m=MJ(l)|0;FJ(m)}else{l=c[g+8>>2]|0;m=MJ(l)|0;FJ(m)}}}function $t(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;if(!a)FJ(KJ(3069168)|0);if(!d)FJ(KJ(3069192)|0);if(((tI(a)|0)-f|0)>>>0<b>>>0){h=0;i=g;return h|0}if(((tI(d)|0)-f|0)>>>0<e>>>0){h=0;i=g;return h|0}j=(yI(a,c[(c[(c[a>>2]|0)+44>>2]|0)+116>>2]|0,0)|0)+b|0;b=(yI(d,c[(c[(c[d>>2]|0)+44>>2]|0)+116>>2]|0,0)|0)+e|0;if((a|0)==(d|0)){aFi(b|0,j|0,f|0)|0;h=1;i=g;return h|0}else{YEi(b|0,j|0,f|0)|0;h=1;i=g;return h|0}return 0}function au(a){a=a|0;var b=0,c=0;b=i;c=tI(a)|0;i=b;return c|0}function bu(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=a[(yI(b,1,c)|0)>>0]|0;i=d;return e|0}function cu(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=i;a[(yI(b,1,c)|0)>>0]=d;i=e;return}function du(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c[a>>2]=74104;c[b>>2]=145784;c[d>>2]=158728;c[e>>2]=159192;c[f>>2]=178040;c[g>>2]=178488;c[h>>2]=197392;return}function eu(a){a=a|0;var b=0,d=0;b=i;d=YG(c[a>>2]|0)|0;i=b;return d|0}function fu(a){a=a|0;var b=0,c=0;b=i;c=vG(a)|0;i=b;return c|0}function gu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+12|0;j=g;k=g+24|0;if(!b)rri(h,3653512,0);else kI(h,b+12|0);if(!d)rri(j,3653512,0);else kI(j,d+12|0);d=yG(h,j,k,f)|0;f=uI(c[101524]|0,17)|0;c[e>>2]=f;if(!d){xri(j);xri(h);i=g;return 1}d=(yI(f,1,0)|0)+0|0;f=k+0|0;k=d+17|0;do{a[d>>0]=a[f>>0]|0;d=d+1|0;f=f+1|0}while((d|0)<(k|0));xri(j);xri(h);i=g;return 1}function hu(a){a=a|0;var b=0,c=0;b=i;c=xG(a)|0;i=b;return c|0}function iu(a){a=a|0;var b=0,c=0;b=i;c=wG(a)|0;i=b;return c|0}function ju(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ku(a+12|0,c[a+8>>2]|0,b)|0;i=d;return e|0}function ku(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=i;i=i+32|0;k=j+16|0;l=j;m=(g|0)>0;if(m){n=0;o=0;p=0;q=0;r=0;while(1){s=b[f+(n<<1)>>1]|0;if((s&65535)>122){Fr(QJ(197968)|0);t=o;u=p;v=q;w=r}else{x=(FDi(s&65535)|0)==0;t=(x&1^1)+o|0;u=x?s:p;v=x?r:q;w=x?p:r}n=n+1|0;if((n|0)==(g|0)){y=t;z=u;A=v;B=w;break}else{o=t;p=u;q=v;r=w}}}else{y=0;z=0;A=0;B=0}w=g-y|0;if((y|0)==(g|0)&h){C=uI(c[101524]|0,0)|0;i=j;return C|0}if((w&3|0)!=0|(w|0)<1)Fr(QJ(198e3)|0);if(A<<16>>16==61)Fr(QJ(198016)|0);A=uI(c[101524]|0,((B<<16>>16==61)<<31>>31)+((z<<16>>16==61)<<31>>31)+((w*3|0)/4|0)|0)|0;w=yI(A,1,0)|0;if(!m){C=A;i=j;return C|0}m=l+4|0;z=k+8|0;B=k+12|0;h=l+8|0;y=l+12|0;r=0;v=w;while(1){w=r;q=0;a:while(1){if((q|0)<4)D=w;else{E=w;break}while(1){if((D|0)>=(g|0)){E=D;break a}u=D+1|0;p=e[f+(D<<1)>>1]|0;if(!(FDi(p)|0)){F=u;G=p;break}else D=u}c[k+(q<<2)>>2]=G&255;u=d[197840+G>>0]|0;c[l+(q<<2)>>2]=u;if(u&128)Fr(QJ(197968)|0);w=F;q=q+1|0}q=v+1|0;a[v>>0]=(c[m>>2]|0)>>>4|c[l>>2]<<2;if((c[z>>2]|0)==61){H=v;I=q}else{a[q>>0]=(c[h>>2]|0)>>>2|c[m>>2]<<4;H=q;I=v+2|0}if((c[B>>2]|0)==61)J=I;else{a[I>>0]=c[h>>2]<<6|c[y>>2];J=H+2|0}b:do if((E|0)<(g|0)){q=E;while(1){w=q+1|0;if(!(FDi(e[f+(q<<1)>>1]|0)|0)){K=q;break b}if((w|0)<(g|0))q=w;else{K=w;break}}}else K=E;while(0);if((K|0)<(g|0)){r=K;v=J}else{C=A;break}}i=j;return C|0}function lu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=ku(yI(a,2,b)|0,c,0)|0;i=d;return e|0}function mu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f;h=f+32|0;j=h+24|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;if(!d)FJ(KJ(3142592)|0);if(!e)FJ(KJ(3075952)|0);c[d>>2]=uI(c[101534]|0,4)|0;c[e>>2]=uI(c[101539]|0,2)|0;if(dI(b,g,h)|0){b=0;do{k=yI(c[d>>2]|0,8,b)|0;l=g+(b<<3)|0;m=c[l+4>>2]|0;n=k;c[n>>2]=c[l>>2];c[n+4>>2]=m;b=b+1|0}while((b|0)<4);o=0;do{b=yI(c[e>>2]|0,4,o)|0;g=h+(o*12|0)|0;if(!(a[g>>0]&1))p=g+1|0;else p=c[h+(o*12|0)+8>>2]|0;c[b>>2]=qM(p)|0;o=o+1|0}while((o|0)<2);q=1}else q=0;o=j;do{o=o+-12|0;xri(o)}while((o|0)!=(h|0));i=f;return q|0}function nu(){var a=0,b=0;a=i;b=cI()|0;i=a;return b|0}function ou(){var a=0,b=0;a=i;b=bI()|0;i=a;return b|0}function pu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d;h=c[a>>2]|0;j=h>>>16;k=(j&255)-b|0;c[e>>2]=k;if(k>>>0<=28){c[a>>2]=h&-16711681|j-b<<16&16711680;l=0;i=d;return l|0}b=a+12|0;j=c[b>>2]|0;h=a+8|0;k=f;c[k>>2]=c[h>>2];c[k+4>>2]=j;j=a+4|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=0;k=BN(f,g,e,0,28,1)|0;if(k){l=k;i=d;return l|0}k=f;f=c[k+4>>2]|0;m=g;g=c[m>>2]|0;n=c[m+4>>2]|0;m=c[e>>2]|0;if(m>>>0>28|(n>>>0>0|(n|0)==0&g>>>0>4294967295)){l=2;i=d;return l|0}n=c[a>>2]|0;c[h>>2]=c[k>>2];c[b>>2]=f;c[j>>2]=g;c[a>>2]=n&-2147483648|m<<16&16711680|n&2130771967;l=0;i=d;return l|0}function qu(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;h=i;j=oM(d)|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;d=b[j>>1]|0;k=d<<16>>16==0;if(!k){l=0;m=j;while(1){n=l+1|0;m=m+2|0;if(!(b[m>>1]|0)){o=n;p=l;break}else l=n}a:do if(!k){l=0;m=0;n=0;q=0;r=d;s=0;t=j;u=-1;while(1){v=(r&65535)+-48|0;if(v>>>0>9){w=2;x=42;break}if(v){if((u|0)<0){y=(o-s|0)>29?s+29|0:o;if((y+1|0)>>>0<f>>>0){w=2;x=42;break}else z=y}else z=u;if((s|0)>=(z|0)){A=n;B=q;C=l;D=m;E=s;F=z;break a}y=z+~s|0;G=198056+(y<<4)|0;I=c[G>>2]|0;J=c[G+4>>2]|0;G=198064+(y<<4)|0;y=c[G>>2]|0;K=c[G+4>>2]|0;if((v|0)!=1){G=gFi(I|0,0,v|0,0)|0;L=H;M=gFi(J|0,0,v|0,0)|0;N=_Ei(L|0,0,M|0,H|0)|0;M=H;L=gFi(y|0,K|0,v|0,0)|0;v=_Ei(M|0,0,L|0,H|0)|0;L=H;if(K>>>0>L>>>0|(K|0)==(L|0)&y>>>0>v>>>0){w=2;x=42;break}else{O=G;P=N;Q=v;R=L}}else{O=I;P=J;Q=y;R=K}K=_Ei(l|0,m|0,O|0,P|0)|0;y=H;J=_Ei(Q|0,R|0,n|0,q|0)|0;I=_Ei(J|0,H|0,(y>>>0<m>>>0|(y|0)==(m|0)&K>>>0<l>>>0)&1|0,0)|0;J=H;if(q>>>0>J>>>0|(q|0)==(J|0)&n>>>0>I>>>0){w=2;x=42;break}else{S=K;T=y;U=I;V=J;W=z}}else{S=l;T=m;U=n;V=q;W=u}J=s+1|0;t=t+2|0;r=b[t>>1]|0;if(!(r<<16>>16)){A=U;B=V;C=S;D=T;E=J;F=W;break a}else{l=S;m=T;n=U;q=V;s=J;u=W}}if((x|0)==42){i=h;return w|0}}else{A=0;B=0;C=0;D=0;E=0;F=-1}while(0);W=F-f|0;do if((p|0)>=(E|0)){F=(e[j+(E<<1)>>1]|0)+-48|0;if(F>>>0>9){w=2;i=h;return w|0}if((F|0)<=5)if((F|0)==5){F=(e[j+(E+-1<<1)>>1]|0)+-48|0;V=E;do{V=V+1|0;if((V|0)>=(o|0)){x=21;break}}while((b[j+(V<<1)>>1]|0)==48);if((x|0)==21?((F|0)%2|0|0)!=1:0){X=0;break}X=1}else X=0;else X=1}else X=0;while(0);if(!((A|0)==0&(B|0)==0)){b:do if(!B){Y=X;Z=C;_=D;$=A;aa=B}else{j=B;o=A;E=D;p=C;V=B;U=W;while(1){T=1;while(1){S=T+1|0;if(V>>>0<(c[726896+(T<<2)>>2]|0)>>>0){ba=T;break}if((S|0)<9)T=S;else{ba=S;break}}T=U;U=U-ba|0;if((U|0)<0){w=2;break}T=c[726896+(ba<<2)>>2]|0;S=hFi(j|0,0,T|0,0)|0;z=gFi(S|0,H|0,T|0,0)|0;R=ZEi(j|0,0,z|0,H|0)|0;z=hFi(o|0,R|0,T|0,0)|0;R=gFi(z|0,H|0,T|0,0)|0;Q=ZEi(o|0,j|0,R|0,H|0)|0;R=hFi(E|0,Q|0,T|0,0)|0;Q=gFi(R|0,H|0,T|0,0)|0;P=ZEi(E|0,0,Q|0,H|0)|0;Q=hFi(p|0,P|0,T|0,0)|0;O=gFi(Q|0,H|0,T|0,0)|0;d=ZEi(p|0,P|0,O|0,H|0)|0;O=cFi(d|0,H|0,1)|0;d=H;do if(d>>>0<0|(d|0)==0&O>>>0<T>>>0)if((O|0)==(T|0)&(d|0)==0?!((Q&1|0)==0&0==0):0){ca=S;x=34;break}else{da=S;ea=0;break}else{ca=S;x=34}while(0);if((x|0)==34){x=0;if((Q|0)==-1&(R|0)==-1&(z|0)==-1){j=S;o=z;E=R;p=Q;V=1;U=U;continue}else{da=ca;ea=1}}if(!da){Y=ea;Z=Q;_=R;$=z;aa=S;break b}else{j=S;o=z;E=R;p=Q;V=da}}i=h;return w|0}while(0);if(!Y){fa=$;ga=Z;ha=aa;ia=_;ja=W}else{Y=_Ei(Z|0,_|0,1,0)|0;_=H;Z=_Ei((Y|0)==0&(_|0)==0&1|0,0,$|0,aa|0)|0;fa=Z;ga=Y;ha=H;ia=_;ja=W}}else{fa=0;ga=C;ha=0;ia=D;ja=W}}else{fa=0;ga=0;ha=0;ia=0;ja=~f}if((fa|ga|0)==0&(ha|ia|0)==0){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;w=0;i=h;return w|0}if(ja>>>0>28|(ha>>>0>0|(ha|0)==0&fa>>>0>4294967295)){w=2;i=h;return w|0}c[a+8>>2]=ga;c[a+12>>2]=ia;c[a+4>>2]=fa;c[a>>2]=ja<<16&16711680|g<<31;w=0;i=h;return w|0}function ru(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=f>>31|1;h=c[b>>2]|0;if((h^f|0)<0){if((((((c[a+8>>2]|0)==0?(c[a+12>>2]|0)==0:0)?(c[a+4>>2]|0)==0:0)?(c[b+8>>2]|0)==0:0)?(c[b+12>>2]|0)==0:0)?(c[b+4>>2]|0)==0:0){j=0;i=d;return j|0}j=g;i=d;return j|0}k=f>>>16&255;f=c[a+4>>2]|0;do if(!f){l=c[a+12>>2]|0;if(l){m=32;while(1){if((m|0)<=0){n=-1;break}o=m+-1|0;if(!(1<<o&l))m=o;else{n=o;break}}p=n+33|0;q=21;break}m=c[a+8>>2]|0;if(!m)r=-1e3;else{l=32;while(1){if((l|0)<=0){s=-1;break}o=l+-1|0;if(!(1<<o&m))l=o;else{s=o;break}}p=s+1|0;q=21}}else{l=32;while(1){if((l|0)<=0){t=-1;break}m=l+-1|0;if(!(1<<m&f))l=m;else{t=m;break}}p=t+65|0;q=21}while(0);if((q|0)==21)if((p|0)==-1e3)r=-1e3;else r=p-(((k*33219|0)>>>0)/1e4|0)|0;k=h>>>16&255;h=c[b+4>>2]|0;do if(!h){p=c[b+12>>2]|0;if(p){t=32;while(1){if((t|0)<=0){u=-1;break}f=t+-1|0;if(!(1<<f&p))t=f;else{u=f;break}}v=u+33|0;q=35;break}t=c[b+8>>2]|0;if(!t)w=-1e3;else{p=32;while(1){if((p|0)<=0){x=-1;break}f=p+-1|0;if(!(1<<f&t))p=f;else{x=f;break}}v=x+1|0;q=35}}else{p=32;while(1){if((p|0)<=0){y=-1;break}t=p+-1|0;if(!(1<<t&h))p=t;else{y=t;break}}v=y+65|0;q=35}while(0);if((q|0)==35)if((v|0)==-1e3)w=-1e3;else w=v-(((k*33219|0)>>>0)/1e4|0)|0;k=r-w|0;if((k|0)<-1){j=0-g|0;i=d;return j|0}if((k|0)>1){j=g;i=d;return j|0};c[e+0>>2]=c[a+0>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[e>>2]=c[e>>2]^-2147483648;su(e,b)|0;if(((c[e+8>>2]|0)==0?(c[e+12>>2]|0)==0:0)?(c[e+4>>2]|0)==0:0){j=0;i=d;return j|0}j=(c[e>>2]>>31&2)+-1|0;i=d;return j|0}function su(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=i;i=i+48|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=d+32|0;k=a+12|0;l=c[k>>2]|0;m=a+8|0;n=c[m>>2]|0;o=e;c[o>>2]=n;c[o+4>>2]=l;o=a+4|0;p=c[o>>2]|0;q=f;c[q>>2]=p;c[q+4>>2]=0;q=c[b+12>>2]|0;r=c[b+8>>2]|0;s=g;c[s>>2]=r;c[s+4>>2]=q;s=c[b+4>>2]|0;t=h;c[t>>2]=s;c[t+4>>2]=0;t=c[a>>2]|0;u=t>>>31;v=c[b>>2]|0;b=v>>>31;w=t>>>16&255;c[j>>2]=w;t=v>>>16&255;do if((w|0)==(t|0)){if((u|0)!=(b|0)){v=ZEi(n|0,l|0,r|0,q|0)|0;x=H;y=ZEi(p|0,0,s|0,0)|0;z=(l>>>0<q>>>0|(l|0)==(q|0)&n>>>0<r>>>0)<<31>>31;A=_Ei(y|0,H|0,z|0,((z|0)<0)<<31>>31|0)|0;z=H;y=e;c[y>>2]=v;c[y+4>>2]=x;y=f;c[y>>2]=A;c[y+4>>2]=z;if((z|0)<0){y=ZEi(0,0,v|0,x|0)|0;B=H;C=e;c[C>>2]=y;c[C+4>>2]=B;if((n|0)==(r|0)&(l|0)==(q|0)){C=_Ei(A|0,z|0,-1,-1)|0;D=H;E=f;c[E>>2]=C;c[E+4>>2]=D;F=C;G=D}else{F=A;G=z}D=~F;C=~G;E=f;c[E>>2]=D;c[E+4>>2]=C;I=C;J=y;K=B;L=D;M=u^1}else{I=z;J=v;K=x;L=A;M=u}}else{A=_Ei(n|0,l|0,r|0,q|0)|0;x=H;v=_Ei(s|0,0,p|0,0)|0;z=_Ei(v|0,H|0,(x>>>0<l>>>0|(x|0)==(l|0)&A>>>0<n>>>0)&1|0,0)|0;v=H;D=e;c[D>>2]=A;c[D+4>>2]=x;D=f;c[D>>2]=z;c[D+4>>2]=v;I=v;J=A;K=x;L=z;M=u}if(!I){c[j>>2]=w;N=J;O=K;P=w;Q=I;R=L;S=M;break}else{T=I;U=L;V=K;W=J;X=I;Y=w}while(1){z=1;while(1){x=z+1|0;if(X>>>0<(c[726896+(z<<2)>>2]|0)>>>0){Z=z;break}if((x|0)<9)z=x;else{Z=x;break}}z=Y;Y=Y-Z|0;if((Y|0)<0){_=2;$=64;break}z=c[726896+(Z<<2)>>2]|0;x=T;T=hFi(T|0,0,z|0,0)|0;A=gFi(T|0,H|0,z|0,0)|0;v=ZEi(x|0,0,A|0,H|0)|0;A=U;U=hFi(U|0,v|0,z|0,0)|0;v=gFi(U|0,H|0,z|0,0)|0;D=ZEi(A|0,x|0,v|0,H|0)|0;v=f;c[v>>2]=U;c[v+4>>2]=T;v=V;V=hFi(V|0,D|0,z|0,0)|0;D=gFi(V|0,H|0,z|0,0)|0;x=ZEi(v|0,0,D|0,H|0)|0;D=W;W=hFi(W|0,x|0,z|0,0)|0;v=gFi(W|0,H|0,z|0,0)|0;A=ZEi(D|0,x|0,v|0,H|0)|0;v=e;c[v>>2]=W;c[v+4>>2]=V;v=cFi(A|0,H|0,1)|0;A=H;do if(A>>>0<0|(A|0)==0&v>>>0<z>>>0)if((v|0)==(z|0)&(A|0)==0?!((W&1|0)==0&0==0):0){aa=T;$=19;break}else{ba=T;ca=0;break}else{aa=T;$=19}while(0);if(($|0)==19){$=0;if((W|0)==-1&(V|0)==-1&(U|0)==-1){T=T;U=U;V=-1;W=-1;X=1;Y=Y;continue}else{ba=aa;ca=1}}if(!ba)break;else X=ba}if(($|0)==64){i=d;return _|0}c[j>>2]=Y;if(ca){A=_Ei(W|0,V|0,1,0)|0;z=H;v=e;c[v>>2]=A;c[v+4>>2]=z;if((A|0)==0&(z|0)==0){v=_Ei(U|0,T|0,1,0)|0;x=H;D=f;c[D>>2]=v;c[D+4>>2]=x;N=0;O=0;P=Y;Q=x;R=v;S=M}else{N=A;O=z;P=Y;Q=T;R=U;S=M}}else{N=W;O=V;P=Y;Q=T;R=U;S=M}}else{do if(!p)if(!((n|0)==0&(l|0)==0))if(!l){z=32;while(1){if((z|0)<=0){da=-1;break}A=z+-1|0;if(!(1<<A&n))z=A;else{da=A;break}}ea=da+1|0;break}else{z=32;while(1){if((z|0)<=0){fa=-1;break}A=z+-1|0;if(!(1<<A&l))z=A;else{fa=A;break}}ea=fa+33|0;break}else ea=-1e3;else{z=32;while(1){if((z|0)<=0){ga=-1;break}A=z+-1|0;if(!(1<<A&p))z=A;else{ga=A;break}}ea=ga+65|0}while(0);z=((ea|0)<0?0:ea)-(((w*33219|0)>>>0)/1e4|0)|0;do if(!s)if(!((r|0)==0&(q|0)==0))if(!q){A=32;while(1){if((A|0)<=0){ha=-1;break}v=A+-1|0;if(!(1<<v&r))A=v;else{ha=v;break}}ia=ha+1|0;break}else{A=32;while(1){if((A|0)<=0){ja=-1;break}v=A+-1|0;if(!(1<<v&q))A=v;else{ja=v;break}}ia=ja+33|0;break}else ia=-1e3;else{A=32;while(1){if((A|0)<=0){ka=-1;break}v=A+-1|0;if(!(1<<v&s))A=v;else{ka=v;break}}ia=ka+65|0}while(0);A=((ia|0)<0?0:ia)-(((t*33219|0)>>>0)/1e4|0)|0;v=u^1;x=((((z|0)>(A|0)?z:A)+(v^b)|0)*1e3|0)/3322|0;if(t>>>0>w>>>0){c[j>>2]=t;la=t}else la=w;if((x+1+la|0)>35){A=34-x|0;c[j>>2]=A;ma=A}else ma=la;A=CN(e,f,ma-w|0)|0;if(A){_=A;i=d;return _|0}A=CN(g,h,ma-t|0)|0;if(A){_=A;i=d;return _|0}A=e;x=c[A>>2]|0;D=c[A+4>>2]|0;A=f;B=c[A>>2]|0;y=c[A+4>>2]|0;A=g;C=c[A>>2]|0;E=c[A+4>>2]|0;A=h;na=c[A>>2]|0;oa=c[A+4>>2]|0;if((u|0)!=(b|0)){A=ZEi(x|0,D|0,C|0,E|0)|0;pa=H;qa=ZEi(B|0,y|0,na|0,oa|0)|0;ra=(D>>>0<E>>>0|(D|0)==(E|0)&x>>>0<C>>>0)<<31>>31;sa=_Ei(qa|0,H|0,ra|0,((ra|0)<0)<<31>>31|0)|0;ra=H;qa=e;c[qa>>2]=A;c[qa+4>>2]=pa;qa=f;c[qa>>2]=sa;c[qa+4>>2]=ra;if((ra|0)<0){qa=ZEi(0,0,A|0,pa|0)|0;pa=e;c[pa>>2]=qa;c[pa+4>>2]=H;if((x|0)==(C|0)&(D|0)==(E|0)){pa=_Ei(sa|0,ra|0,-1,-1)|0;qa=H;A=f;c[A>>2]=pa;c[A+4>>2]=qa;ta=pa;ua=qa}else{ta=sa;ua=ra}ra=f;c[ra>>2]=~ta;c[ra+4>>2]=~ua;va=v}else va=u}else{v=_Ei(x|0,D|0,C|0,E|0)|0;E=H;C=_Ei(na|0,oa|0,B|0,y|0)|0;y=_Ei(C|0,H|0,(E>>>0<D>>>0|(E|0)==(D|0)&v>>>0<x>>>0)&1|0,0)|0;x=e;c[x>>2]=v;c[x+4>>2]=E;E=f;c[E>>2]=y;c[E+4>>2]=H;va=u}E=BN(e,f,j,0,28,1)|0;if(!E){y=e;x=f;N=c[y>>2]|0;O=c[y+4>>2]|0;P=c[j>>2]|0;Q=c[x+4>>2]|0;R=c[x>>2]|0;S=va;break}else{_=E;i=d;return _|0}}while(0);if(P>>>0>28|(Q>>>0>0|(Q|0)==0&R>>>0>4294967295)){_=2;i=d;return _|0}c[m>>2]=N;c[k>>2]=O;c[o>>2]=R;c[a>>2]=P<<16&16711680|S<<31|c[a>>2]&2130771967;_=0;i=d;return _|0}function tu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;e=c[a>>2]|0;f=e>>>16&255;if(!f){i=d;return}g=a+12|0;h=a+8|0;j=a+4|0;k=e>>>31;l=0;m=c[j>>2]|0;n=c[g>>2]|0;o=c[h>>2]|0;p=0;q=f;while(1){f=(q|0)>9?9:q;r=c[726896+(f<<2)>>2]|0;q=q-f|0;f=hFi(l|0,0,r|0,0)|0;s=gFi(f|0,H|0,r|0,0)|0;t=ZEi(l|0,0,s|0,H|0)|0;s=hFi(m|0,t|0,r|0,0)|0;t=gFi(s|0,H|0,r|0,0)|0;u=ZEi(m|0,l|0,t|0,H|0)|0;t=hFi(n|0,u|0,r|0,0)|0;u=gFi(t|0,H|0,r|0,0)|0;v=ZEi(n|0,0,u|0,H|0)|0;u=hFi(o|0,v|0,r|0,0)|0;v=gFi(u|0,H|0,r|0,0)|0;r=ZEi(o|0,n|0,v|0,H|0)|0;v=(r|p|0)!=0;if((q|0)<=0){w=v;x=u;y=t;z=s;A=f;B=u;C=t;break}else{l=f;m=s;n=t;o=u;p=v&1}}if((b|0)!=0&w&(k|0)!=0){w=_Ei(x|0,y|0,1,0)|0;y=H;x=_Ei((w|0)==0&(y|0)==0&1|0,0,z|0,A|0)|0;D=w;E=y;F=H;G=x}else{D=B;E=C;F=A;G=z}if(F>>>0>0|(F|0)==0&G>>>0>4294967295){i=d;return}c[h>>2]=D;c[g>>2]=E;c[j>>2]=G;c[a>>2]=e&2130771967|k<<31;i=d;return}function uu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=c[a+12>>2]|0;f=c[a+8>>2]|0;g=c[a+4>>2]|0;h=c[a>>2]|0;a=h>>>16&255;if(a){j=a;a=0;k=g;l=e;m=f;do{n=(j|0)>9?9:j;j=j-n|0;o=c[726896+(n<<2)>>2]|0;n=a;a=hFi(a|0,0,o|0,0)|0;p=gFi(a|0,H|0,o|0,0)|0;q=ZEi(n|0,0,p|0,H|0)|0;p=k;k=hFi(k|0,q|0,o|0,0)|0;q=gFi(k|0,H|0,o|0,0)|0;r=ZEi(p|0,n|0,q|0,H|0)|0;q=l;l=hFi(l|0,r|0,o|0,0)|0;r=gFi(l|0,H|0,o|0,0)|0;n=ZEi(q|0,0,r|0,H|0)|0;r=m;m=hFi(m|0,n|0,o|0,0)|0;q=gFi(m|0,H|0,o|0,0)|0;p=ZEi(r|0,n|0,q|0,H|0)|0;q=cFi(p|0,H|0,1)|0;p=H;if(p>>>0<0|(p|0)==0&q>>>0<o>>>0)if((q|0)==(o|0)&(p|0)==0)s=(m&1|0)!=0|0!=0;else s=0;else s=1}while((j|0)>0);if(s){s=_Ei(m|0,l|0,1,0)|0;j=H;p=_Ei((s|0)==0&(j|0)==0&1|0,0,k|0,a|0)|0;t=p;u=H;v=s;w=j}else{t=k;u=a;v=m;w=l}}else{t=g;u=0;v=f;w=e}if(!((t|0)==0&(u|0)==0)){x=2;i=d;return x|0}if(((v|0)!=0|(w|0)!=0)&(h|0)<0){x=2;i=d;return x|0}h=b;c[h>>2]=v;c[h+4>>2]=w;x=0;i=d;return x|0}function vu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=c[a+12>>2]|0;f=c[a+8>>2]|0;g=c[a+4>>2]|0;h=c[a>>2]|0;a=h>>>16&255;if(a){j=a;a=0;k=g;l=e;m=f;do{n=(j|0)>9?9:j;j=j-n|0;o=c[726896+(n<<2)>>2]|0;n=a;a=hFi(a|0,0,o|0,0)|0;p=gFi(a|0,H|0,o|0,0)|0;q=ZEi(n|0,0,p|0,H|0)|0;p=k;k=hFi(k|0,q|0,o|0,0)|0;q=gFi(k|0,H|0,o|0,0)|0;r=ZEi(p|0,n|0,q|0,H|0)|0;q=l;l=hFi(l|0,r|0,o|0,0)|0;r=gFi(l|0,H|0,o|0,0)|0;n=ZEi(q|0,0,r|0,H|0)|0;r=m;m=hFi(m|0,n|0,o|0,0)|0;q=gFi(m|0,H|0,o|0,0)|0;p=ZEi(r|0,n|0,q|0,H|0)|0;q=cFi(p|0,H|0,1)|0;p=H;if(p>>>0<0|(p|0)==0&q>>>0<o>>>0)if((q|0)==(o|0)&(p|0)==0)s=(m&1|0)!=0|0!=0;else s=0;else s=1}while((j|0)>0);if(s){s=_Ei(m|0,l|0,1,0)|0;j=H;p=_Ei((s|0)==0&(j|0)==0&1|0,0,k|0,a|0)|0;t=p;u=H;v=s;w=j}else{t=k;u=a;v=m;w=l}}else{t=g;u=0;v=f;w=e}if(!((t|0)==0&(u|0)==0)){x=2;i=d;return x|0}do if((h|0)<0&((v|0)!=0|(w|0)!=0))if(w>>>0>2147483648|(w|0)==-2147483648&v>>>0>0){x=2;i=d;return x|0}else{u=ZEi(0,0,v|0,w|0)|0;y=u;z=H;break}else if((w|0)<0){x=2;i=d;return x|0}else{y=v;z=w}while(0);w=b;c[w>>2]=y;c[w+4>>2]=z;x=0;i=d;return x|0}function wu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+16|0;h=a+8|0;j=c[h>>2]|0;k=a+12|0;l=c[k>>2]|0;m=a+4|0;n=c[m>>2]|0;o=c[b+8>>2]|0;p=c[b+12>>2]|0;q=c[b+4>>2]|0;r=gFi(o|0,0,j|0,0)|0;s=H;t=gFi(p|0,0,j|0,0)|0;u=H;v=gFi(o|0,0,l|0,0)|0;w=H;x=_Ei(s|0,0,t|0,u|0)|0;u=H;t=u>>>0<0|(u|0)==0&x>>>0<s>>>0;s=_Ei(x|0,u|0,v|0,w|0)|0;w=H;v=gFi(q|0,0,j|0,0)|0;j=H;y=gFi(p|0,0,l|0,0)|0;z=H;A=gFi(o|0,0,n|0,0)|0;o=H;B=_Ei(w|0,0,v|0,j|0)|0;j=H;v=j>>>0<0|(j|0)==0&B>>>0<w>>>0;C=_Ei(B|0,j|0,y|0,z|0)|0;z=H;y=_Ei(C|0,z|0,A|0,o|0)|0;o=H;A=((o>>>0<z>>>0|(o|0)==(z|0)&y>>>0<C>>>0)&1)+(z>>>0<j>>>0|(z|0)==(j|0)&C>>>0<B>>>0?(v?2:1):v&1)|0;v=_Ei(o|0,0,(w>>>0<u>>>0|(w|0)==(u|0)&s>>>0<x>>>0?(t?2:1):t&1)|0,0)|0;t=H;x=gFi(q|0,0,l|0,0)|0;l=H;u=gFi(p|0,0,n|0,0)|0;p=H;w=_Ei(v|0,t|0,x|0,l|0)|0;l=H;x=l>>>0<t>>>0|(l|0)==(t|0)&w>>>0<v>>>0;v=_Ei(w|0,l|0,u|0,p|0)|0;p=H;u=gFi(q|0,0,n|0,0)|0;n=e;c[n>>2]=r;c[n+4>>2]=s;n=f;c[n>>2]=y;c[n+4>>2]=v;n=_Ei(A|0,((A|0)<0)<<31>>31|0,u|0,H|0)|0;u=_Ei(n|0,H|0,p|0,0)|0;n=_Ei(u|0,H|0,0,(p>>>0<l>>>0|(p|0)==(l|0)&v>>>0<w>>>0?(x?2:1):x&1)|0)|0;x=c[a>>2]|0;w=c[b>>2]|0;b=(w>>>16&255)+(x>>>16&255)|0;c[g>>2]=b;l=w^x;x=n;n=H;w=0;p=v;v=1e9;u=b;b=y;y=s;s=r;while(1){if((x|0)==0&(n|0)==0)if(0<w>>>0|0==(w|0)&p>>>0<v>>>0)break;else D=5;else if(n>>>0<0|(n|0)==0&x>>>0<100)D=5;else{E=v;F=w;G=u+-9|0}if((D|0)==5){D=0;r=hFi(v|0,w|0,1e3,0)|0;E=r;F=H;G=u+-6|0}c[g>>2]=G;r=hFi(n|0,0,E|0,0)|0;A=gFi(r|0,H|0,E|0,0)|0;q=ZEi(n|0,0,A|0,H|0)|0;A=hFi(x|0,q|0,E|0,0)|0;q=gFi(A|0,H|0,E|0,0)|0;t=ZEi(x|0,n|0,q|0,H|0)|0;q=hFi(p|0,t|0,E|0,0)|0;t=gFi(q|0,H|0,E|0,0)|0;o=ZEi(p|0,0,t|0,H|0)|0;t=hFi(b|0,o|0,E|0,0)|0;o=gFi(t|0,H|0,E|0,0)|0;B=ZEi(b|0,p|0,o|0,H|0)|0;o=f;c[o>>2]=t;c[o+4>>2]=q;o=hFi(y|0,B|0,E|0,0)|0;B=gFi(o|0,H|0,E|0,0)|0;C=ZEi(y|0,0,B|0,H|0)|0;B=hFi(s|0,C|0,E|0,0)|0;C=e;c[C>>2]=B;c[C+4>>2]=o;x=A;n=r;w=F;p=q;v=E;u=G;b=t;y=o;s=B}s=BN(e,f,g,0,28,1)|0;if(s){I=s;i=d;return I|0}s=e;e=c[s+4>>2]|0;y=f;f=c[y>>2]|0;b=c[y+4>>2]|0;y=c[g>>2]|0;if(y>>>0>28|(b>>>0>0|(b|0)==0&f>>>0>4294967295)){I=2;i=d;return I|0}c[h>>2]=c[s>>2];c[k>>2]=e;c[m>>2]=f;c[a>>2]=y<<16&16711680|l&-2147483648|c[a>>2]&2130771967;I=0;i=d;return I|0}function xu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+8|0;g=e;h=e+20|0;j=e+16|0;if(!(ru(b,d)|0)){c[a+8>>2]=1;c[a+12>>2]=0;c[a+4>>2]=0;c[a>>2]=c[a>>2]&2130771967;k=0;i=e;return k|0}c[b>>2]=c[b>>2]^-2147483648;if(!(ru(b,d)|0)){c[a+8>>2]=1;c[a+12>>2]=0;c[a+4>>2]=0;c[a>>2]=c[a>>2]&2130771967|-2147483648;k=0;i=e;return k|0}c[b>>2]=c[b>>2]^-2147483648;l=DN(c[b+4>>2]|0,c[b+8>>2]|0,c[b+12>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,f,g,j)|0;if((l|0)==1){k=0;i=e;return k|0}else if(!l){c[h>>2]=((c[b>>2]|0)>>>16&255)-((c[d>>2]|0)>>>16&255);m=BN(f,g,h,c[j>>2]|0,28,1)|0;if(m){k=m;i=e;return k|0}m=f;f=c[m+4>>2]|0;j=g;g=c[j>>2]|0;n=c[j+4>>2]|0;j=c[h>>2]|0;if(j>>>0>28|(n>>>0>0|(n|0)==0&g>>>0>4294967295)){k=2;i=e;return k|0}n=(c[d>>2]^c[b>>2])&-2147483648;c[a+8>>2]=c[m>>2];c[a+12>>2]=f;c[a+4>>2]=g;c[a>>2]=n|j<<16&16711680|c[a>>2]&2130771967;k=0;i=e;return k|0}else{k=l;i=e;return k|0}return 0}function yu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;b=i;d=c[a+4>>2]|0;e=c[a+12>>2]|0;f=c[a+8>>2]|0;if((e|0)==0&(d|0)==0&(f|0)==0){g=0.0;i=b;return +g}j=c[a>>2]|0;a=0;l=f;f=e;e=d;d=j>>>16&255;m=0;while(1){if((d|0)>0){n=a;o=l;p=e;q=f;r=m}else{s=a;t=l;u=e;v=f;w=m;break}while(1){if((p|0)>-1|(p|0)==-1&q>>>0>4294967295){x=q;y=p;z=n;A=o;B=r;while(1){C=cFi(x|0,y|0,1)|0;D=H;E=VEi(z|0,A|0,63)|0;F=C|E;E=D|H;D=cFi(z|0,A|0,1)|0;C=H;G=B+1|0;if((E|0)>-1|(E|0)==-1&F>>>0>4294967295){x=F;y=E;z=D;A=C;B=G}else{I=E;J=D;K=C;L=F;M=G;break}}}else{I=p;J=n;K=o;L=q;M=r}if(I>>>0>4){N=I;O=I;P=0;Q=L;R=I;S=K;T=J;U=M;break}else{n=J;o=K;p=I;q=L;r=M}}B=32;while(1){if((B|0)<=0){V=0;W=12;break}A=B+-1|0;if(!(1<<A&N))B=A;else{X=B;W=11;break}}if((W|0)==11){W=0;B=X*1e3|0;if((B|0)<20898){V=(B|0)/2322|0;W=12}else Y=9}if((W|0)==12){W=0;Y=((N>>>0)/((c[726896+(V<<2)>>2]|0)>>>V>>>0)|0)+V|0}B=(Y|0)>(d|0)?d:Y;A=(c[726896+(B<<2)>>2]|0)>>>B;z=hFi(O|0,P|0,A|0,0)|0;y=gFi(A|0,0,z|0,H|0)|0;x=ZEi(O|0,P|0,y|0,H|0)|0;y=hFi(Q|0,x|0,A|0,0)|0;x=gFi(A|0,0,y|0,H|0)|0;G=ZEi(Q|0,R|0,x|0,H|0)|0;x=hFi(S|0,G|0,A|0,0)|0;G=gFi(x|0,H|0,A|0,0)|0;F=ZEi(S|0,0,G|0,H|0)|0;G=hFi(T|0,F|0,A|0,0)|0;a=G;l=x;f=y;e=z;d=d-B|0;m=B+U|0}if((u|0)>-1|(u|0)==-1&v>>>0>4294967295){U=v;m=u;d=s;s=t;t=w;while(1){e=cFi(U|0,m|0,1)|0;f=H;l=VEi(d|0,s|0,63)|0;a=e|l;l=f|H;d=cFi(d|0,s|0,1)|0;f=t+1|0;if(!((l|0)>-1|(l|0)==-1&a>>>0>4294967295)){Z=a;_=l;$=f;break}else{U=a;m=l;s=H;t=f}}}else{Z=v;_=u;$=w}w=_Ei(Z|0,_|0,1024,0)|0;_=H;if((_|0)>-1|(_|0)==-1&w>>>0>4294967295){u=VEi(w|0,_|0,1)|0;aa=u;ba=H;ca=$+-1|0}else{u=(Z&1024|0)==0&0==0;aa=u?w&-2:w;ba=u?_:_;ca=$}$=VEi(aa|0,ba|0,11)|0;ba=H&1048575;aa=cFi(j>>>31|0,0,63)|0;j=H;_=cFi(1118-ca&2047|0,0,52)|0;ca=j|ba|H;c[k>>2]=aa|$|_;c[k+4>>2]=ca;g=+h[k>>3];i=b;return +g}function zu(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;i=i+16|0;g=h;c[g>>2]=198032;gl(345824,g|0)|0;i=h;return 0}function Au(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+8|0;g=e;h=e+20|0;j=e+16|0;k=DN(c[b+4>>2]|0,c[b+8>>2]|0,c[b+12>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,f,g,j)|0;if((k|0)==1){l=0;i=e;return l|0}else if(!k){c[h>>2]=((c[b>>2]|0)>>>16&255)-((c[d>>2]|0)>>>16&255);d=BN(f,g,h,c[j>>2]|0,0,0)|0;if(d){l=d;i=e;return l|0}d=f;f=c[d+4>>2]|0;j=g;g=c[j>>2]|0;m=c[j+4>>2]|0;j=c[h>>2]|0;if(j>>>0>28|(m>>>0>0|(m|0)==0&g>>>0>4294967295)){l=2;i=e;return l|0}m=c[b>>2]&-2147483648;c[a+8>>2]=c[d>>2];c[a+12>>2]=f;c[a+4>>2]=g;c[a>>2]=m|j<<16&16711680|c[a>>2]&2130771967;l=0;i=e;return l|0}else{l=k;i=e;return l|0}return 0}function Bu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;e=i;f=GI(c[a+8>>2]|0)|0;a=c[d+8>>2]|0;d=qL(f)|0;hN(d,b,c[a+4>>2]|0,a);i=e;return d|0}function Cu(a){a=a|0;var b=0;b=i;c[a+12>>2]=c[(UI(c[a>>2]|0,3131560,-1)|0)+16>>2];i=b;return}function Du(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e;c[f>>2]=0;h[d>>3]=0.0;do if((a[b>>0]|0)!=0?(h[d>>3]=+yEi(b,f),(a[b>>0]|0)!=0):0){g=c[f>>2]|0;if((g|0)!=0?(a[g>>0]|0)!=0:0){j=0;break}j=1}else j=0;while(0);i=e;return j|0}function Eu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if(!a){d=0;i=b;return d|0}e=GI(NI(c[a>>2]|0)|0)|0;f=qL(e)|0;YEi(f+8|0,a+8|0,$I(e,0)|0)|0;d=f;i=b;return d|0}function Fu(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=d+8|0;h=e+8|0;switch((c[(NI(sL(d)|0)|0)+4>>2]|0)>>>16&255|0){case 5:{d=a[g>>0]|0;e=a[h>>0]|0;if(d<<24>>24==e<<24>>24)j=0;else j=(d&255)>(e&255)?1:-1;break}case 8:{e=c[g>>2]|0;d=c[h>>2]|0;if((e|0)==(d|0))j=0;else j=(e|0)>(d|0)?1:-1;break}case 11:{d=g;e=c[d>>2]|0;k=c[d+4>>2]|0;d=h;l=c[d>>2]|0;m=c[d+4>>2]|0;if((e|0)==(l|0)&(k|0)==(m|0))j=0;else j=k>>>0>m>>>0|(k|0)==(m|0)&e>>>0>l>>>0?1:-1;break}case 7:case 3:{l=b[g>>1]|0;e=b[h>>1]|0;if(l<<16>>16==e<<16>>16)j=0;else j=(l&65535)-(e&65535)|0;break}case 10:{e=g;l=c[e>>2]|0;m=c[e+4>>2]|0;e=h;k=c[e>>2]|0;d=c[e+4>>2]|0;if((l|0)==(k|0)&(m|0)==(d|0))j=0;else j=(m|0)>(d|0)|(m|0)==(d|0)&l>>>0>k>>>0?1:-1;break}case 9:{k=c[g>>2]|0;l=c[h>>2]|0;if((k|0)==(l|0))j=0;else j=k>>>0>l>>>0?1:-1;break}case 4:{l=a[g>>0]|0;k=a[h>>0]|0;if(l<<24>>24==k<<24>>24)j=0;else j=l<<24>>24>k<<24>>24?1:-1;break}case 6:{k=b[g>>1]|0;g=b[h>>1]|0;if(k<<16>>16==g<<16>>16)j=0;else j=k<<16>>16>g<<16>>16?1:-1;break}default:j=0}i=f;return j|0}function Gu(b){b=b|0;var f=0,g=0,h=0,j=0;f=i;g=b+8|0;h=c[(c[b>>2]|0)+44>>2]|0;do if((h|0)!=(c[101527]|0)){if((h|0)==(c[101524]|0)){j=d[g>>0]|0;break}if((h|0)==(c[101538]|0)|(h|0)==(c[101529]|0)){j=e[g>>1]|0;break}if((h|0)==(c[101528]|0)){j=e[g>>1]|0;break}if((h|0)==(c[101531]|0)){j=c[g>>2]|0;break}if((h|0)==(c[101530]|0)){j=c[g>>2]|0;break}else{b=g;j=c[b+4>>2]^c[b>>2];break}}else j=a[g>>0]|0;while(0);i=f;return j|0}function Hu(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;if(!f)FJ(KJ(3145808)|0);if(!g)FJ(KJ(3116392)|0);j=GI(c[f+8>>2]|0)|0;f=sL(g)|0;k=MI(j)|0;if(!k)FJ(JJ(198520,3145808)|0);l=qL(j)|0;j=g+8|0;if(!(a[f+149>>0]|0))m=f;else m=c[f+44>>2]|0;f=c[101524]|0;do if((f|0)!=(m|0)){g=c[101527]|0;if((g|0)==(m|0)){n=m;o=d[j>>0]|0;p=0;break}if((c[101529]|0)==(m|0)){n=g;o=e[j>>1]|0;p=0;break}if((c[101528]|0)==(m|0)){q=b[j>>1]|0;n=g;o=q;p=((q|0)<0)<<31>>31;break}if((c[101531]|0)==(m|0)){n=g;o=c[j>>2]|0;p=0;break}if((c[101530]|0)==(m|0)){q=c[j>>2]|0;n=g;o=q;p=((q|0)<0)<<31>>31;break}if((c[101535]|0)==(m|0)){q=j;n=g;o=c[q>>2]|0;p=c[q+4>>2]|0;break}if((c[101534]|0)==(m|0)){q=j;n=g;o=c[q>>2]|0;p=c[q+4>>2]|0}else{n=g;o=0;p=0}}else{g=a[j>>0]|0;n=c[101527]|0;o=g;p=((g|0)<0)<<31>>31}while(0);j=l+8|0;if((f|0)==(k|0)|(n|0)==(k|0)){a[j>>0]=o;i=h;return l|0}if((c[101529]|0)==(k|0)|(c[101528]|0)==(k|0)){b[j>>1]=o;i=h;return l|0}if((c[101531]|0)==(k|0)|(c[101530]|0)==(k|0)){c[j>>2]=o;i=h;return l|0}if(!((c[101535]|0)==(k|0)|(c[101534]|0)==(k|0))){i=h;return l|0}k=j;c[k>>2]=o;c[k+4>>2]=p;i=h;return l|0}function Iu(a){a=a|0;var b=0,d=0;b=i;d=NI(GI(c[a+8>>2]|0)|0)|0;if(!d)FJ(JJ(198520,3145808)|0);else{a=ML(d)|0;i=b;return a|0}return 0}function Ju(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;JG(d);if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;f=qM(e)|0;xri(d);i=b;return f|0}function Ku(){var a=0,b=0;a=i;b=sM(1072968)|0;i=a;return b|0}function Lu(){return 0}function Mu(){var a=0,b=0;a=i;b=aI()|0;i=a;return b|0}function Nu(){var a=0,b=0;a=i;b=KG()|0;i=a;return b|0}function Ou(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;b=EJ()|0;d=DJ()|0;if(!d){e=0;i=a;return e|0}f=vI(JI(c[101539]|0,1)|0,b)|0;if((b|0)>0)g=0;else{e=f;i=a;return e|0}do{h=yI(f,4,g)|0;c[h>>2]=qM(c[d+(g<<2)>>2]|0)|0;g=g+1|0}while((g|0)!=(b|0));e=f;i=a;return e|0}function Pu(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;PG(d);e=JI(c[101539]|0,1)|0;f=d+4|0;g=vI(e,((c[f>>2]|0)-(c[d>>2]|0)|0)/12|0)|0;e=c[f>>2]|0;h=c[d>>2]|0;j=(e-h|0)/12|0;if((e|0)==(h|0))k=e;else{e=0;do{h=yI(g,4,e)|0;l=c[d>>2]|0;m=l+(e*12|0)|0;if(!(a[m>>0]&1))n=m+1|0;else n=c[l+(e*12|0)+8>>2]|0;c[h>>2]=qM(n)|0;e=e+1|0}while(e>>>0<j>>>0);k=c[d>>2]|0}if(!k){i=b;return g|0}while(1){j=c[f>>2]|0;if((j|0)==(k|0))break;e=j+-12|0;c[f>>2]=e;xri(e)}ACi(c[d>>2]|0);i=b;return g|0}function Qu(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=198568;gl(345824,b|0)|0;i=a;return 0}function Ru(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;QG(d);if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;f=qM(e)|0;xri(d);i=b;return f|0}function Su(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;RG(d);e=JI(c[101539]|0,1)|0;f=d+4|0;g=vI(e,((c[f>>2]|0)-(c[d>>2]|0)|0)/12|0)|0;e=c[f>>2]|0;h=c[d>>2]|0;j=(e-h|0)/12|0;if((e|0)==(h|0))k=e;else{e=0;do{h=yI(g,4,e)|0;l=c[d>>2]|0;m=l+(e*12|0)|0;if(!(a[m>>0]&1))n=m+1|0;else n=c[l+(e*12|0)+8>>2]|0;c[h>>2]=qM(n)|0;e=e+1|0}while(e>>>0<j>>>0);k=c[d>>2]|0}if(!k){i=b;return g|0}while(1){j=c[f>>2]|0;if((j|0)==(k|0))break;e=j+-12|0;c[f>>2]=e;xri(e)}ACi(c[d>>2]|0);i=b;return g|0}function Tu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;kI(e,oM(a)|0);if(((b|0)!=0?(nM(b)|0)!=0:0)?(oM(0)|0)!=0:0)kI(f,oM(b)|0);else{c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0}OG(e,f);xri(f);xri(e);i=d;return}function Uu(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=198608;gl(345824,b|0)|0;i=a;return}function Vu(){var a=0,b=0;a=i;b=qM(3653512)|0;i=a;return b|0}function Wu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+12|0;f=d;kI(e,oM(b)|0);NG(f,e);b=a[f>>0]|0;g=(b&1)==0;if(g)h=(b&255)>>>1;else h=c[f+4>>2]|0;if(!h)j=0;else{if(g)k=f+1|0;else k=c[f+8>>2]|0;j=qM(k)|0}xri(f);xri(e);i=d;return j|0}function Xu(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;LG(d);if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;f=qM(e)|0;xri(d);i=b;return f|0}function Yu(){return 4}function Zu(){return c[49664]|0}function _u(a){a=a|0;c[49664]=a;return}function $u(){FJ(SJ(198664)|0);return 0}function av(){var a=0,b=0;a=i;b=qM(198856)|0;i=a;return b|0}function bv(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;MG(d);if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;f=qM(e)|0;xri(d);i=b;return f|0}function cv(a){a=a|0;SG(a)}function dv(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=198864;gl(345824,b|0)|0;i=a;return 0}function ev(a){a=a|0;var b=0;b=i;Ws(a);i=b;return}function fv(a){a=a|0;var b=0,c=0;b=i;c=Rs(a)|0;i=b;return c|0}function gv(a){a=a|0;return}function hv(a){a=a|0;var b=0;b=i;vs(a);i=b;return}function iv(){var a=0,b=0;a=i;b=ws()|0;i=a;return b|0}function jv(a,b){a=a|0;b=b|0;return}function kv(){var a=0;a=i;Xs();i=a;return}function lv(a){a=a|0;var b=0;b=i;if(a)vs(ws()|0);a=zs()|0;i=b;return a|0}function mv(a){a=a|0;var b=0;b=i;Vs(a);i=b;return}function nv(a){a=a|0;var b=0,c=0;b=i;c=xs(a)|0;i=b;return c|0}function ov(a){a=+a;var b=0.0;b=+Y(+a);return +b}function pv(a){a=+a;var b=0.0;b=+Z(+a);return +b}function qv(a){a=+a;var b=0.0;b=+_(+a);return +b}function rv(a,b){a=+a;b=+b;var c=0.0;c=+$(+a,+b);return +c}function sv(a){a=+a;var b=0.0;b=+V(+a);return +b}function tv(a){a=+a;var b=0,c=0.0;b=i;c=+RDi(a);i=b;return +c}function uv(a){a=+a;var b=0.0;b=+aa(+a);return +b}function vv(a){a=+a;var b=0.0;b=+R(+a);return +b}function wv(a){a=+a;var b=0,c=0.0;b=i;if(!(a==0.0))if(a<0.0)c=w;else c=+ba(+a);else c=-x;i=b;return +c}function xv(a){a=+a;var b=0,c=0.0;b=i;c=+$Di(a);i=b;return +c}function yv(a,b){a=+a;b=+b;var d=0,e=0.0,f=0,g=0.0;d=i;e=+U(+a,+b);h[k>>3]=e;f=c[k+4>>2]&2147483647;if(f>>>0>2146435072|(f|0)==2146435072&(c[k>>2]|0)>>>0>0){g=1.0;i=d;return +g}g=e==-0.0?0.0:e;i=d;return +g}function zv(a){a=+a;var b=0,c=0.0,d=0.0,e=0,f=0.0;b=i;c=+R(+a);d=a-c;if(d==.5){a=c*.5;if((a-+R(+a))*2.0!=0.0|d>.5)e=4;else f=c}else if(d>.5)e=4;else f=c;if((e|0)==4)f=c+1.0;i=b;return +f}function Av(a){a=+a;var b=0.0;b=+W(+a);return +b}function Bv(a){a=+a;var b=0,c=0.0;b=i;c=+hEi(a);i=b;return +c}function Cv(a){a=+a;var b=0.0;b=+T(+a);return +b}function Dv(a){a=+a;var b=0.0;b=+X(+a);return +b}function Ev(a){a=+a;var b=0,c=0.0;b=i;c=+iEi(a);i=b;return +c}function Fv(a,b,c){a=+a;b=b|0;c=c|0;var d=0,e=0.0,f=0.0,g=0.0,h=0.0,j=0,k=0.0,l=0.0;d=i;do if(!(a==x))if(!(a==-x)){if(!((b|0)!=0|c)){e=+R(+a);f=a-e;if(f==.5){g=e*.5;if(!((g-+R(+g))*2.0!=0.0|f>.5)){h=e;break}}else if(!(f>.5)){h=e;break}h=e+1.0;break}e=+U(10.0,+(+(b|0)));j=a>=0.0;f=e*a;if(c){if(j)k=+R(+(f+.5));else k=+ca(+(f+-.5));h=k/e;break}else{if(j)l=+ca(+(f+-.5));else l=+R(+(f+.5));h=l/e;break}}else h=-x;else h=x;while(0);i=d;return +h}function Gv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=SL(a)|0;if(!b){a=uI(c[101523]|0,c[e>>2]|0)|0;f=yI(a,4,0)|0;YEi(f|0,c[e+4>>2]|0,c[e>>2]<<2|0)|0;g=a;i=d;return g|0}a=GI(c[b+8>>2]|0)|0;if((c[e>>2]|0)>0){b=e+4|0;f=0;h=0;while(1){j=((bJ(a,c[c[(c[b>>2]|0)+(h<<2)>>2]>>2]|0)|0)&1)+f|0;h=h+1|0;if((h|0)>=(c[e>>2]|0)){k=j;break}else f=j}}else k=0;f=uI(c[101523]|0,k)|0;if((c[e>>2]|0)<=0){g=f;i=d;return g|0}k=e+4|0;h=0;b=0;while(1){if(bJ(a,c[c[(c[k>>2]|0)+(h<<2)>>2]>>2]|0)|0){j=yI(f,4,b)|0;c[j>>2]=c[(c[k>>2]|0)+(h<<2)>>2];l=b+1|0}else l=b;h=h+1|0;if((h|0)>=(c[e>>2]|0)){g=f;break}else b=l}i=d;return g|0}function Hv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=SL(a)|0;if(!e){f=0;i=d;return f|0}f=UL(e,GI(c[b+8>>2]|0)|0)|0;i=d;return f|0}function Iv(a){a=a|0;FJ(SJ(198896)|0);return 0}function Jv(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f+4|0;h=f;j=GI(c[d+8>>2]|0)|0;if(!(ZI(j)|0))k=0;else k=(ZI(j)|0)+-1|0;d=e+8|0;c[d>>2]=uI(c[101539]|0,k)|0;l=e+4|0;c[l>>2]=uI(j,k)|0;c[g>>2]=0;k=OI(j,g)|0;if(!k){i=f;return}else{m=k;n=0}a:while(1){k=m;while(1){if((HEi(3085552,c[k>>2]|0)|0)!=0?!(iK(k)|0):0){o=k;break}k=OI(j,g)|0;if(!k){p=14;break a}}k=yI(c[d>>2]|0,4,n)|0;c[k>>2]=qM($J(o)|0)|0;k=wJ(o,h)|0;switch((c[(NI(j)|0)+4>>2]|0)>>>16&255|0){case 4:case 5:{a[(yI(c[l>>2]|0,1,n)|0)>>0]=a[k>>0]|0;break}case 10:case 11:{e=yI(c[l>>2]|0,8,n)|0;q=k;r=c[q+4>>2]|0;s=e;c[s>>2]=c[q>>2];c[s+4>>2]=r;break}case 6:case 7:case 3:{b[(yI(c[l>>2]|0,2,n)|0)>>1]=b[k>>1]|0;break}case 8:case 9:{c[(yI(c[l>>2]|0,4,n)|0)>>2]=c[k>>2];break}default:{}}m=OI(j,g)|0;if(!m){p=14;break}else n=n+1|0}if((p|0)==14){i=f;return}}function Kv(a){a=a|0;var b=0,d=0;b=i;d=GI(c[a+8>>2]|0)|0;RI(d)|0;a=KL(c[(c[d>>2]|0)+24>>2]|0)|0;i=b;return a|0}function Lv(a){a=a|0;var b=0,d=0;b=i;d=c[(LI(a)|0)+140>>2]|0;i=b;return d|0}function Mv(a){a=a|0;return d[(c[c[a+8>>2]>>2]|0)+4>>0]|0|0}function Nv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+8>>2]|0;a=c[d+4>>2]|0;if(a&1073741824){e=0;i=b;return e|0}f=a>>>16&255;if((f|0)==19)g=(c[c[d>>2]>>2]|0)+12|0;else if((f|0)==30)g=(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+8|0;else g=(GI(d)|0)+40|0;d=c[g>>2]|0;if(!d){e=0;i=b;return e|0}e=ML(c[d+64>>2]|0)|0;i=b;return e|0}function Ov(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[(c[a+8>>2]|0)+4>>2]|0;if(d&1073741824){e=0;i=b;return e|0}a=d>>>16&255;e=(a|0)==19|(a|0)==30;i=b;return e|0}function Pv(a){a=a|0;var b=0,d=0;b=i;d=OL(c[(GI(c[a+8>>2]|0)|0)>>2]|0)|0;i=b;return d|0}function Qv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+4|0;g=b+8|0;b=GI(c[g>>2]|0)|0;h=c[b+8>>2]|0;if(!(c[(c[g>>2]|0)+4>>2]&1073741824)){j=sM(h)|0;i=d;return j|0}c[e>>2]=h;jI(f,199104,e);if(!(a[f>>0]&1))k=f+1|0;else k=c[f+8>>2]|0;e=qM(k)|0;xri(f);j=e;i=d;return j|0}function Rv(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=GI(c[b+8>>2]|0)|0;while(1){b=c[e+40>>2]|0;if(!b){f=e;break}else e=b}e=c[f+12>>2]|0;if(!(a[e>>0]|0)){g=0;i=d;return g|0}g=sM(e)|0;i=d;return g|0}function Sv(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[(GI(c[a+8>>2]|0)|0)+32>>2]|0;if(!d){e=0;i=b;return e|0}e=ML(c[d+64>>2]|0)|0;i=b;return e|0}function Tv(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f;c[h>>2]=0;c[j>>2]=0;k=j+4|0;c[k>>2]=0;l=j+8|0;c[l>>2]=0;m=c[a+8>>2]|0;if(!(c[m+4>>2]&1073741824)){a=GI(m)|0;m=GI(c[e+8>>2]|0)|0;if(!(c[49778]|0))c[49778]=iJ(c[101522]|0,3131888,2855368)|0;c[h>>2]=0;e=(d&4|0)==0;a:do if(d&8)if(e)while(1){n=TI(a,h)|0;if(!n)break a;o=c[n>>2]|0;if((HEi(o,3072840)|0)!=0?(HEi(o,3076392)|0)!=0:0)continue;o=b[n+28>>1]|0;if((((o&7)==6?16:32)&d|0)==0|(o&16)==0)continue;o=NL(n,m)|0;c[g>>2]=o;n=c[k>>2]|0;if((n|0)==(c[l>>2]|0)){EN(j,g);continue}if(!n)p=0;else{c[n>>2]=o;p=c[k>>2]|0}c[k>>2]=p+4}else while(1){o=TI(a,h)|0;if(!o)break a;n=c[o>>2]|0;if((HEi(n,3072840)|0)!=0?(HEi(n,3076392)|0)!=0:0)continue;if(!(((b[o+28>>1]&7)==6?16:32)&d))continue;n=NL(o,m)|0;c[g>>2]=n;o=c[k>>2]|0;if((o|0)==(c[l>>2]|0)){EN(j,g);continue}if(!o)q=0;else{c[o>>2]=n;q=c[k>>2]|0}c[k>>2]=q+4}else while(1){n=TI(a,h)|0;if(!n)break a;o=c[n>>2]|0;if((HEi(o,3072840)|0)!=0?(HEi(o,3076392)|0)!=0:0)continue;o=b[n+28>>1]|0;if((o&16)!=0|(((o&7)==6?16:32)&d|0)==0|e)continue;o=NL(n,m)|0;c[g>>2]=o;n=c[k>>2]|0;if((n|0)==(c[l>>2]|0)){EN(j,g);continue}if(!n)r=0;else{c[n>>2]=o;r=c[k>>2]|0}c[k>>2]=r+4}while(0);r=uI(c[49778]|0,(c[k>>2]|0)-(c[j>>2]|0)>>2)|0;g=c[k>>2]|0;if((g|0)==(c[j>>2]|0)){s=r;t=g}else{g=0;do{l=yI(r,4,g)|0;c[l>>2]=c[(c[j>>2]|0)+(g<<2)>>2];g=g+1|0;l=c[j>>2]|0}while(g>>>0<(c[k>>2]|0)-l>>2>>>0);s=r;t=l}}else{r=uI(c[101557]|0,0)|0;s=r;t=c[j>>2]|0}if(!t){i=f;return s|0}j=c[k>>2]|0;if((j|0)!=(t|0))c[k>>2]=j+(~((j+-4-t|0)>>>2)<<2);Ls(t);i=f;return s|0}function Uv(a,b){a=a|0;b=b|0;FJ(SJ(199120)|0);return 0}function Vv(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;b=c[e>>2]|0;if((c[b+4>>2]&1090453504|0)==1900544){f=ML(c[(c[b>>2]|0)+64>>2]|0)|0;i=d;return f|0}g=GI(b)|0;b=c[(c[e>>2]|0)+4>>2]|0;if(b&1073741824){f=ML(c[g+64>>2]|0)|0;i=d;return f|0}e=c[g+44>>2]|0;if(!e){f=0;i=d;return f|0}if(a[g+144>>0]|0){f=ML(c[e+64>>2]|0)|0;i=d;return f|0}if((b&16711680|0)!=983040){f=0;i=d;return f|0}f=ML(c[e+64>>2]|0)|0;i=d;return f|0}function Wv(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+64|0;g=f+48|0;h=f+32|0;j=f+16|0;k=f;l=c[a+8>>2]|0;if(c[l+4>>2]&1073741824){m=0;i=f;return m|0}a=GI(l)|0;RI(a)|0;l=d+12|0;if(!(e&1)){kI(k,l);sri(j,k);d=a+162|0;n=b[d>>1]|0;a:do if(!(n<<16>>16))o=0;else{p=a+24|0;q=(e&4|0)==0;r=j+12|0;s=(e&8|0)==0;t=n;u=0;b:while(1){v=c[(c[p>>2]|0)+((u&65535)<<2)>>2]|0;w=c[(c[v+4>>2]|0)+4>>2]|0;do if(!(((w&7|0)==6?16:32)&e))x=t;else{if(!(w&16)){if(q){x=t;break}}else if(s){x=t;break}if(nI(r,j,c[v>>2]|0)|0){y=v;break b}x=b[d>>1]|0}while(0);u=u+1<<16>>16;if((u&65535)>=(x&65535)){o=0;break a}else t=x}o=LL(a,y)|0}while(0);if((o|0)==0&(e&2|0)==0){y=c[a+32>>2]|0;if(!y)z=0;else{x=(e&4|0)==0;d=j+12|0;n=(e&8|0)==0;t=(e&64|0)==0;u=y;while(1){y=u+162|0;r=b[y>>1]|0;c:do if(!(r<<16>>16))A=0;else{s=u+24|0;q=(u|0)!=(a|0);p=n|q&t;v=r;w=0;d:while(1){B=c[(c[s>>2]|0)+((w&65535)<<2)>>2]|0;C=c[(c[B+4>>2]|0)+4>>2]|0;D=C&7;do if((((D|0)==6?16:32)&e|0)==0|q&(D|0)==1)E=v;else{if(!(C&16)){if(x){E=v;break}}else if(p){E=v;break}if(nI(d,j,c[B>>2]|0)|0){F=B;break d}E=b[y>>1]|0}while(0);w=w+1<<16>>16;if((w&65535)>=(E&65535)){A=0;break c}else v=E}A=LL(a,F)|0}while(0);u=c[u+32>>2]|0;if(!((A|0)==0&(u|0)!=0)){z=A;break}}}}else z=o;xri(j);xri(k);m=z;i=f;return m|0}else{kI(h,l);sri(g,h);l=a+162|0;z=b[l>>1]|0;e:do if(!(z<<16>>16))G=0;else{k=a+24|0;j=(e&4|0)==0;o=g+12|0;A=(e&8|0)==0;u=z;F=0;f:while(1){E=c[(c[k>>2]|0)+((F&65535)<<2)>>2]|0;d=c[(c[E+4>>2]|0)+4>>2]|0;do if(!(((d&7|0)==6?16:32)&e))H=u;else{if(!(d&16)){if(j){H=u;break}}else if(A){H=u;break}if(pI(o,g,c[E>>2]|0)|0){I=E;break f}H=b[l>>1]|0}while(0);F=F+1<<16>>16;if((F&65535)>=(H&65535)){G=0;break e}else u=H}G=LL(a,I)|0}while(0);if((G|0)==0&(e&2|0)==0){I=c[a+32>>2]|0;if(!I)J=0;else{H=(e&4|0)==0;l=g+12|0;z=(e&8|0)==0;u=(e&64|0)==0;F=I;while(1){I=F+162|0;o=b[I>>1]|0;g:do if(!(o<<16>>16))K=0;else{A=F+24|0;j=(F|0)!=(a|0);k=z|j&u;E=o;d=0;h:while(1){x=c[(c[A>>2]|0)+((d&65535)<<2)>>2]|0;t=c[(c[x+4>>2]|0)+4>>2]|0;n=t&7;do if((((n|0)==6?16:32)&e|0)==0|j&(n|0)==1)L=E;else{if(!(t&16)){if(H){L=E;break}}else if(k){L=E;break}if(pI(l,g,c[x>>2]|0)|0){M=x;break h}L=b[I>>1]|0}while(0);d=d+1<<16>>16;if((d&65535)>=(L&65535)){K=0;break g}else E=L}K=LL(a,M)|0}while(0);F=c[F+32>>2]|0;if(!((K|0)==0&(F|0)!=0)){J=K;break}}}}else J=G;xri(g);xri(h);m=J;i=f;return m|0}return 0}function Xv(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;a=i;i=i+16|0;f=a+12|0;g=a;h=c[e+8>>2]|0;if((c[h+4>>2]&1073741824|0)==0?(e=(d&8|0)==0,j=d&4,(j|0)!=0|e^1):0){c[g>>2]=0;k=g+4|0;c[k>>2]=0;l=g+8|0;c[l>>2]=0;m=GI(h)|0;h=m+162|0;n=b[h>>1]|0;if(n<<16>>16){o=m+24|0;p=(j|0)==0;q=n;n=0;while(1){r=c[(c[o>>2]|0)+((n&65535)<<2)>>2]|0;c[f>>2]=r;s=c[(c[r+4>>2]|0)+4>>2]|0;do if(!(((s&7|0)==6?16:32)&d))t=q;else{if(!(s&16)){if(p){t=q;break}}else if(e){t=q;break}u=c[k>>2]|0;if((u|0)==(c[l>>2]|0)){FN(g,f);t=b[h>>1]|0;break}if(!u)v=0;else{c[u>>2]=r;v=c[k>>2]|0}c[k>>2]=v+4;t=q}while(0);n=n+1<<16>>16;if((n&65535)>=(t&65535))break;else q=t}}if((d&2|0)==0?(t=c[m+32>>2]|0,(t|0)!=0):0){q=(j|0)==0;j=(d&64|0)==0;n=t;do{t=n+162|0;v=b[t>>1]|0;if(v<<16>>16){h=n+24|0;p=(n|0)!=(m|0);o=e|p&j;r=v;v=0;while(1){s=c[(c[h>>2]|0)+((v&65535)<<2)>>2]|0;c[f>>2]=s;u=c[(c[s+4>>2]|0)+4>>2]|0;w=u&7;do if((((w|0)==6?16:32)&d|0)==0|p&(w|0)==1)x=r;else{if(!(u&16)){if(q){x=r;break}}else if(o){x=r;break}y=c[k>>2]|0;if((y|0)==(c[l>>2]|0)){FN(g,f);x=b[t>>1]|0;break}if(!y)z=0;else{c[y>>2]=s;z=c[k>>2]|0}c[k>>2]=z+4;x=r}while(0);v=v+1<<16>>16;if((v&65535)>=(x&65535))break;else r=x}}n=c[n+32>>2]|0}while((n|0)!=0)}n=(c[k>>2]|0)-(c[g>>2]|0)>>2;x=uI(c[101556]|0,n)|0;if(n){z=0;do{f=yI(x,4,z)|0;c[f>>2]=LL(m,c[(c[g>>2]|0)+(z<<2)>>2]|0)|0;z=z+1|0}while(z>>>0<n>>>0)}n=c[g>>2]|0;if(!n){A=x;i=a;return A|0}g=c[k>>2]|0;if((g|0)!=(n|0))c[k>>2]=g+(~((g+-4-n|0)>>>2)<<2);ACi(n);A=x;i=a;return A|0}A=uI(c[101556]|0,0)|0;i=a;return A|0}function Yv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(d)h=e?3:2;else h=1;e=b+8|0;aN(g,c[e>>2]|0,h);h=a[g>>0]|0;b=(h&1)==0;if(b)j=(h&255)>>>1;else j=c[g+4>>2]|0;do if(!j)k=0;else{if(d?(h=(c[(c[e>>2]|0)+4>>2]|0)>>>16&255,(h|0)==30|(h|0)==19):0){k=0;break}if(b)l=g+1|0;else l=c[g+8>>2]|0;k=sM(l)|0}while(0);xri(g);i=f;return k|0}function Zv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=GI(c[a+8>>2]|0)|0;a=c[d+84>>2]|0;if(a){e=a+16|0;f=uI(c[101549]|0,c[e>>2]&2147483647)|0;if(!(c[e>>2]&2147483647)){g=f;i=b;return g|0}h=a+20|0;a=0;do{j=KI(c[(c[h>>2]|0)+(a<<2)>>2]|0)|0;k=yI(f,4,a)|0;c[k>>2]=ML(c[j+64>>2]|0)|0;a=a+1|0}while((a|0)<(c[e>>2]&2147483647|0));g=f;i=b;return g|0}f=c[d+80>>2]|0;if(!f){g=uI(c[101549]|0,0)|0;i=b;return g|0}d=c[f+4>>2]|0;f=uI(c[101549]|0,c[d>>2]|0)|0;if(!(c[d>>2]|0)){g=f;i=b;return g|0}e=d+4|0;a=0;do{h=yI(f,4,a)|0;c[h>>2]=ML(c[(c[e>>2]|0)+(a<<2)>>2]|0)|0;a=a+1|0}while(a>>>0<(c[d>>2]|0)>>>0);g=f;i=b;return g|0}function _v(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=i;i=i+16|0;d=b+12|0;e=b;f=GI(c[a+8>>2]|0)|0;a=e+4|0;c[a>>2]=0;g=e+8|0;c[g>>2]=0;h=e+4|0;c[e>>2]=h;if(!f)j=0;else{k=0;l=f;while(1){f=c[l+48>>2]|0;a:do if(!f)m=k;else{n=k;o=f;while(1){p=c[o>>2]|0;if(!p){m=n;break a}q=c[a>>2]|0;do if(q){r=q;while(1){s=c[r+16>>2]|0;if(p>>>0<s>>>0){t=c[r>>2]|0;if(!t){u=r;v=r;w=8;break}else{r=t;continue}}if(s>>>0>=p>>>0){x=r;w=12;break}s=r+4|0;t=c[s>>2]|0;if(!t){y=s;z=r;w=11;break}else r=t}if((w|0)==8){w=0;c[d>>2]=v;A=u;B=v;break}else if((w|0)==11){w=0;c[d>>2]=z;A=y;B=z;break}else if((w|0)==12){w=0;c[d>>2]=x;A=d;B=x;break}}else{c[d>>2]=h;A=h;B=h}while(0);if(!(c[A>>2]|0)){p=xCi(20)|0;c[p+16>>2]=c[o>>2];c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=B;c[A>>2]=p;q=c[c[e>>2]>>2]|0;if(!q)C=p;else{c[e>>2]=q;C=c[A>>2]|0}GN(c[a>>2]|0,C);q=(c[g>>2]|0)+1|0;c[g>>2]=q;D=q}else D=n;n=D;o=o+4|0}}while(0);l=c[l+32>>2]|0;if(!l){j=m;break}else k=m}}m=uI(c[101549]|0,j)|0;j=c[e>>2]|0;if((j|0)==(h|0)){E=c[a>>2]|0;HN(e,E);i=b;return m|0}else{F=j;G=0}while(1){j=yI(m,4,G)|0;c[j>>2]=ML(c[(c[F+16>>2]|0)+64>>2]|0)|0;j=c[F+4>>2]|0;if(!j){k=F;while(1){l=c[k+8>>2]|0;if((c[l>>2]|0)==(k|0)){H=l;break}else k=l}}else{k=j;while(1){l=c[k>>2]|0;if(!l){H=k;break}else k=l}}if((H|0)==(h|0))break;else{F=H;G=G+1|0}}E=c[a>>2]|0;HN(e,E);i=b;return m|0}function $v(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;i=i+65616|0;g=a;h=a+77|0;j=a+16|0;k=a+64|0;l=a+48|0;m=a+32|0;n=a+76|0;o=c[f+8>>2]|0;if((d&12|0)==0?1:(c[o+4>>2]&1073741824|0)!=0){p=uI(c[101558]|0,0)|0;i=a;return p|0}if(!b){c[g>>2]=0;f=g+4|0;c[f>>2]=0;c[g+8>>2]=0;PEi(h|0,0,65535)|0;q=GI(o)|0;RI(q)|0;KN(q,q,d,n,g,h);a:do if(!(d&2)){r=q;while(1){s=c[r+32>>2]|0;if(!s)break a;RI(s)|0;KN(s,q,d,n,g,h);r=s}}while(0);n=(c[f>>2]|0)-(c[g>>2]|0)>>2;r=uI(c[101557]|0,n)|0;if(n){s=0;do{t=NL(c[(c[g>>2]|0)+(s<<2)>>2]|0,q)|0;c[(yI(r,4,s)|0)>>2]=t;s=s+1|0}while(s>>>0<n>>>0)}n=c[g>>2]|0;if(!n){p=r;i=a;return p|0}s=c[f>>2]|0;if((s|0)!=(n|0))c[f>>2]=s+(~((s+-4-n|0)>>>2)<<2);ACi(n);p=r;i=a;return p|0}r=b+12|0;if(e){kI(k,r);sri(j,k);c[g>>2]=0;e=g+4|0;c[e>>2]=0;c[g+8>>2]=0;PEi(h|0,0,65535)|0;b=GI(o)|0;RI(b)|0;IN(b,b,d,j,g,h);b:do if(!(d&2)){n=b;while(1){s=c[n+32>>2]|0;if(!s)break b;RI(s)|0;IN(s,b,d,j,g,h);n=s}}while(0);n=(c[e>>2]|0)-(c[g>>2]|0)>>2;s=uI(c[101557]|0,n)|0;if(n){f=0;do{q=NL(c[(c[g>>2]|0)+(f<<2)>>2]|0,b)|0;c[(yI(s,4,f)|0)>>2]=q;f=f+1|0}while(f>>>0<n>>>0)}n=c[g>>2]|0;if(n){f=c[e>>2]|0;if((f|0)!=(n|0))c[e>>2]=f+(~((f+-4-n|0)>>>2)<<2);ACi(n)}xri(j);xri(k);p=s;i=a;return p|0}else{kI(m,r);sri(l,m);c[g>>2]=0;r=g+4|0;c[r>>2]=0;c[g+8>>2]=0;PEi(h|0,0,65535)|0;s=GI(o)|0;RI(s)|0;JN(s,s,d,l,g,h);c:do if(!(d&2)){o=s;while(1){k=c[o+32>>2]|0;if(!k)break c;RI(k)|0;JN(k,s,d,l,g,h);o=k}}while(0);h=(c[r>>2]|0)-(c[g>>2]|0)>>2;d=uI(c[101557]|0,h)|0;if(h){o=0;do{k=NL(c[(c[g>>2]|0)+(o<<2)>>2]|0,s)|0;c[(yI(d,4,o)|0)>>2]=k;o=o+1|0}while(o>>>0<h>>>0)}h=c[g>>2]|0;if(h){g=c[r>>2]|0;if((g|0)!=(h|0))c[r>>2]=g+(~((g+-4-h|0)>>>2)<<2);ACi(h)}xri(l);xri(m);p=d;i=a;return p|0}return 0}function aw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a=i;i=i+96|0;h=a+64|0;j=a+48|0;k=a+32|0;l=a+16|0;m=a;n=c[f+8>>2]|0;if((d&12|0)==0?1:(c[n+4>>2]&1073741824|0)!=0){o=uI(c[101558]|0,0)|0;i=a;return o|0}if(!b){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[h+16>>2]=ea(1.0);f=GI(n)|0;RI(f)|0;NN(f,d,f,h);a:do if(!(d&2)){p=f;while(1){q=c[p+32>>2]|0;if(!q)break a;RI(q)|0;NN(q,d,f,h);p=q}}while(0);f=uI(c[101558]|0,c[h+12>>2]|0)|0;p=h+8|0;q=c[p>>2]|0;if(!q)r=0;else{s=q;q=0;while(1){t=yI(f,4,q)|0;c[t>>2]=c[s+12>>2];s=c[s>>2]|0;if(!s)break;else q=q+1|0}r=c[p>>2]|0}while(1){if(!r)break;p=c[r>>2]|0;Ls(r);r=p}r=c[h>>2]|0;c[h>>2]=0;if(!r){o=f;i=a;return o|0}Ls(r);o=f;i=a;return o|0}f=b+12|0;if(e){kI(k,f);sri(j,k);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[h+16>>2]=ea(1.0);e=GI(n)|0;RI(e)|0;LN(e,d,j,e,h);b:do if(!(d&2)){b=e;while(1){r=c[b+32>>2]|0;if(!r)break b;RI(r)|0;LN(r,d,j,e,h);b=r}}while(0);e=uI(c[101558]|0,c[h+12>>2]|0)|0;b=h+8|0;r=c[b>>2]|0;if(!r)u=0;else{p=r;r=0;while(1){q=yI(e,4,r)|0;c[q>>2]=c[p+12>>2];p=c[p>>2]|0;if(!p)break;else r=r+1|0}u=c[b>>2]|0}while(1){if(!u)break;b=c[u>>2]|0;Ls(u);u=b}u=c[h>>2]|0;c[h>>2]=0;if(u)Ls(u);xri(j);xri(k);o=e;i=a;return o|0}else{kI(m,f);sri(l,m);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[h+16>>2]=ea(1.0);f=GI(n)|0;RI(f)|0;MN(f,d,l,f,h);c:do if(!(d&2)){n=f;while(1){e=c[n+32>>2]|0;if(!e)break c;RI(e)|0;MN(e,d,l,f,h);n=e}}while(0);f=uI(c[101558]|0,c[h+12>>2]|0)|0;d=h+8|0;n=c[d>>2]|0;if(!n)v=0;else{e=n;n=0;while(1){k=yI(f,4,n)|0;c[k>>2]=c[e+12>>2];e=c[e>>2]|0;if(!e)break;else n=n+1|0}v=c[d>>2]|0}while(1){if(!v)break;d=c[v>>2]|0;Ls(v);v=d}v=c[h>>2]|0;c[h>>2]=0;if(v)Ls(v);xri(l);xri(m);o=f;i=a;return o|0}return 0}function bw(a){a=a|0;return (c[(c[a+8>>2]|0)+4>>2]&1073741824|0)!=0|0}function cw(a){a=a|0;return 0}function dw(a){a=a|0;return (c[(c[a+8>>2]|0)+4>>2]&16711680|0)==983040|0}function ew(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[(c[a+8>>2]|0)+4>>2]|0;if(d&1073741824){e=0;i=b;return e|0}a=d>>>16;if(((a&255)+-2|0)>>>0<12){e=1;i=b;return e|0}else{i=b;return (a&254|0)==24|0}return 0}function fw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;k=c[a+8>>2]|0;if(c[k+4>>2]&1073741824){l=0;i=e;return l|0}a=GI(k)|0;k=b+12|0;if(!(d&1)){kI(j,k);sri(h,j);b=PN(a,a,d,h)|0;if((b|0)==0&(d&2|0)==0){m=c[a+32>>2]|0;if(!m)n=0;else{o=m;do{m=PN(o,a,d,h)|0;o=c[o+32>>2]|0}while((m|0)==0&(o|0)!=0);n=m}}else n=b;xri(h);xri(j);l=n;i=e;return l|0}else{kI(g,k);sri(f,g);k=ON(a,a,d,f)|0;if((k|0)==0&(d&2|0)==0){n=c[a+32>>2]|0;if(!n)p=0;else{j=n;do{n=ON(j,a,d,f)|0;j=c[j+32>>2]|0}while((n|0)==0&(j|0)!=0);p=n}}else p=k;xri(f);xri(g);l=p;i=e;return l|0}return 0}function gw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;a=i;i=i+32|0;e=a;f=c[d+8>>2]|0;if((b&12|0)==0?1:(c[f+4>>2]&1073741824|0)!=0){h=uI(c[101559]|0,0)|0;i=a;return h|0}c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[e+16>>2]=ea(1.0);d=GI(f)|0;RI(d)|0;QN(d,d,b,e);a:do if(!(b&2)){f=d;while(1){j=c[f+32>>2]|0;if(!j)break a;QN(j,d,b,e);f=j}}while(0);b=uI(c[101559]|0,c[e+12>>2]|0)|0;d=e+8|0;f=c[d>>2]|0;if(!f)k=0;else{j=f;f=0;while(1){l=yI(b,4,f)|0;c[l>>2]=c[j+12>>2];j=c[j>>2]|0;if(!j)break;else f=f+1|0}k=c[d>>2]|0}while(1){if(!k)break;d=c[k>>2]|0;Ls(k);k=d}k=c[e>>2]|0;c[e>>2]=0;if(!k){h=b;i=a;return h|0}Ls(k);h=b;i=a;return h|0}function hw(a,b){a=a|0;b=b|0;FJ(SJ(199344)|0)}function iw(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+64|0;g=f+48|0;h=f+32|0;j=f+16|0;k=f;if(!(e&32))l=(e&16|0)==0;else l=0;m=c[a+8>>2]|0;if((c[m+4>>2]&1073741824|0)!=0|l){n=0;i=f;return n|0}l=GI(m)|0;m=d+12|0;if(!(e&1)){kI(k,m);sri(j,k);d=l+166|0;a=b[d>>1]|0;a:do if(!(a<<16>>16))o=0;else{p=l+36|0;q=j+12|0;r=a;s=0;while(1){t=c[(c[p>>2]|0)+((s&65535)<<2)>>2]|0;if(!(((c[t+140>>2]&7|0)==2?16:32)&e))u=r;else{if(nI(q,j,c[t+8>>2]|0)|0){v=t;break}u=b[d>>1]|0}s=s+1<<16>>16;if((s&65535)>=(u&65535)){o=0;break a}else r=u}o=ML(c[v+64>>2]|0)|0}while(0);xri(j);xri(k);n=o;i=f;return n|0}else{kI(h,m);sri(g,h);m=l+166|0;o=b[m>>1]|0;b:do if(!(o<<16>>16))w=0;else{k=l+36|0;j=g+12|0;v=o;u=0;while(1){d=c[(c[k>>2]|0)+((u&65535)<<2)>>2]|0;if(!(((c[d+140>>2]&7|0)==2?16:32)&e))x=v;else{if(pI(j,g,c[d+8>>2]|0)|0){y=d;break}x=b[m>>1]|0}u=u+1<<16>>16;if((u&65535)>=(x&65535)){w=0;break b}else v=x}w=ML(c[y+64>>2]|0)|0}while(0);xri(g);xri(h);n=w;i=f;return n|0}return 0}function jw(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(d&32))h=(d&16|0)==0;else h=0;j=c[a+8>>2]|0;if((c[j+4>>2]&1073741824|0)!=0|h){k=uI(c[101550]|0,0)|0;i=e;return k|0}h=GI(j)|0;c[f>>2]=0;j=f+4|0;c[j>>2]=0;a=f+8|0;c[a>>2]=0;l=h+166|0;m=b[l>>1]|0;if(!(m<<16>>16)){n=0;o=0}else{p=h+36|0;h=m;m=0;while(1){q=c[(c[p>>2]|0)+((m&65535)<<2)>>2]|0;c[g>>2]=q;do if(!(((c[q+140>>2]&7|0)==2?16:32)&d))r=h;else{s=c[j>>2]|0;if((s|0)==(c[a>>2]|0)){RN(f,g);r=b[l>>1]|0;break}if(!s)t=0;else{c[s>>2]=q;t=c[j>>2]|0}c[j>>2]=t+4;r=h}while(0);m=m+1<<16>>16;if((m&65535)>=(r&65535))break;else h=r}n=c[j>>2]|0;o=c[f>>2]|0}r=n-o>>2;o=uI(c[101550]|0,r)|0;if(r){n=0;do{h=yI(o,4,n)|0;c[h>>2]=ML(c[(c[(c[f>>2]|0)+(n<<2)>>2]|0)+64>>2]|0)|0;n=n+1|0}while(n>>>0<r>>>0)}r=c[f>>2]|0;if(!r){k=o;i=e;return k|0}f=c[j>>2]|0;if((f|0)!=(r|0))c[j>>2]=f+(~((f+-4-r|0)>>>2)<<2);ACi(r);k=o;i=e;return k|0}function kw(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=199600;gl(345824,b|0)|0;i=a;return 0}function lw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a>>2]=199632;c[b>>2]=216016;c[d>>2]=224208;c[e>>2]=224240;c[f>>2]=224272;c[g>>2]=224424;return}function mw(a){a=a|0;var b=0,c=0;b=i;c=tL(a)|0;i=b;return c|0}function nw(a){a=a|0;var b=0,d=0;b=i;d=ML(c[(c[a>>2]|0)+64>>2]|0)|0;i=b;return d|0}function ow(a){a=a|0;var b=0,c=0;b=i;c=rL(a)|0;i=b;return c|0}function pw(a){a=a|0;return a|0}function qw(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=224824;gl(345824,b|0)|0;i=a;return 0}function rw(){FJ(SJ(224864)|0)}function sw(a){a=a|0;var b=0,c=0;b=i;c=uM(a)|0;i=b;return c|0}function tw(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=i;h=oM(a)|0;j=nM(a)|0;k=sI(d)|0;if(!(c[56270]|0))c[56270]=JI(c[101539]|0,1)|0;l=(f&1|0)==0;do if(l){if((j|0)!=0&(e|0)>1){f=(k|0)==0;m=0;n=1;while(1){o=b[h+(m<<1)>>1]|0;a:do if(f)p=0;else{q=0;while(1){if((b[(yI(d,2,q)|0)>>1]|0)==o<<16>>16){p=1;break a}q=q+1|0;if((q|0)==(k|0)){p=0;break}}}while(0);o=p+n|0;m=m+1|0;if(!((m|0)!=(j|0)&(o|0)<(e|0))){r=o;s=21;break}else n=o}}}else if((e|0)>1){if(j){n=(k|0)==0;m=0;f=0;o=0;q=1;while(1){t=b[h+(f<<1)>>1]|0;b:do if(n)s=16;else{u=0;while(1){if((b[(yI(d,2,u)|0)>>1]|0)==t<<16>>16){v=0;w=o;x=q;break b}u=u+1|0;if((u|0)==(k|0)){s=16;break}}}while(0);if((s|0)==16){s=0;if(!m){v=1;w=1;x=((o|0)==1&1)+q|0}else{v=m;w=o;x=q}}f=f+1|0;if(!((f|0)!=(j|0)&(x|0)<(e|0))){y=w;z=x;break}else{m=v;o=w;q=x}}if(y){r=z;s=21;break}}A=vI(c[56270]|0,0)|0;i=g;return A|0}else s=22;while(0);if((s|0)==21)if((r|0)==1)s=22;else{z=vI(c[56270]|0,r)|0;if((j|0)==0|(r|0)==0){A=z;i=g;return A|0}y=(k|0)==0;x=r+-1|0;w=0;v=0;p=0;c:while(1){q=b[h+(v<<1)>>1]|0;d:do if(y){B=w;C=p}else{o=0;while(1){if((b[(yI(d,2,o)|0)>>1]|0)==q<<16>>16)break;o=o+1|0;if((o|0)==(k|0)){B=w;C=p;break d}}if((v|0)!=(p|0)|l){o=v-p|0;m=uM(o)|0;YEi(oM(m)|0,h+(p<<1)|0,o<<1|0)|0;c[(yI(z,4,w)|0)>>2]=m;m=w+1|0;if((m|0)==(x|0)){D=v;break c}else E=m}else E=w;B=E;C=v+1|0}while(0);v=v+1|0;if((v|0)==(j|0)|(B|0)==(r|0)){A=z;s=59;break}else{w=B;p=C}}if((s|0)==59){i=g;return A|0}C=D+1|0;e:do if(!l){f:do if((C|0)==(j|0))F=j;else{D=C;while(1){p=b[h+(D<<1)>>1]|0;B=0;while(1){if((b[(yI(d,2,B)|0)>>1]|0)==p<<16>>16)break;B=B+1|0;if((B|0)==(k|0)){F=D;break f}}D=D+1|0;if((D|0)==(j|0)){F=j;break}}}while(0);if((r|0)<(e|0)?(D=F+1|0,(j|0)!=(D|0)):0){B=j;while(1){p=B;B=B+-1|0;w=b[h+(B<<1)>>1]|0;v=0;while(1){if((b[(yI(d,2,v)|0)>>1]|0)==w<<16>>16)break;v=v+1|0;if((v|0)==(k|0)){G=F;H=p;break e}}if((B|0)==(D|0)){G=F;H=D;break}}}else{G=F;H=j}}else{G=C;H=j}while(0);C=H-G|0;H=uM(C)|0;YEi(oM(H)|0,h+(G<<1)|0,C<<1|0)|0;c[(yI(z,4,x)|0)>>2]=H;A=z;i=g;return A|0}if((s|0)==22?!(l|(e|0)==1):0){g:do if(j){h:do if(!k){I=h;J=j}else{e=h;l=j;while(1){s=b[e>>1]|0;z=0;while(1){if((b[(yI(d,2,z)|0)>>1]|0)==s<<16>>16)break;z=z+1|0;if((z|0)==(k|0)){I=e;J=l;break h}}l=l+-1|0;z=e+2|0;if(!l){K=z;L=0;break g}else e=z}}while(0);if(J)if(!k){K=I;L=J}else{e=J;while(1){l=e;e=e+-1|0;z=b[I+(e<<1)>>1]|0;s=0;while(1){if((b[(yI(d,2,s)|0)>>1]|0)==z<<16>>16)break;s=s+1|0;if((s|0)==(k|0)){K=I;L=l;break g}}if(!e){K=I;L=0;break}}}else{K=I;L=0}}else{K=h;L=0}while(0);h=uM(L)|0;YEi(oM(h)|0,K|0,L<<1|0)|0;L=vI(c[56270]|0,1)|0;c[(yI(L,4,0)|0)>>2]=h;A=L;i=g;return A|0}L=vI(c[56270]|0,1)|0;c[(yI(L,4,0)|0)>>2]=a;A=L;i=g;return A|0}function uw(a){a=a|0;var b=0,c=0;b=i;c=ns(a)|0;i=b;return c|0}function vw(a){a=a|0;var b=0,c=0;b=i;c=os(a)|0;i=b;return c|0}function ww(a,b){a=a|0;b=b|0;return (c[a+8>>2]|0)==(c[b+8>>2]|0)|0}function xw(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(c[d+4>>2]&1073741824){e=0;i=b;return e|0}a=GI(d)|0;if(c[a+80>>2]|0){e=1;i=b;return e|0}e=(c[a+84>>2]|0)!=0;i=b;return e|0}function yw(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(c[d+4>>2]&1073741824){e=0;i=b;return e|0}e=(c[(GI(d)|0)+84>>2]|0)!=0;i=b;return e|0}function zw(a){a=a|0;var b=0,d=0;b=i;if(!(Ov(a)|0)){d=-1;i=b;return d|0}d=e[(c[c[a+8>>2]>>2]|0)+4>>1]|0;i=b;return d|0}function Aw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+8>>2]|0;if(c[d+4>>2]&1073741824){e=0;i=b;return e|0}f=GI(d)|0;if(c[f+84>>2]|0){e=a;i=b;return e|0}a=c[f+80>>2]|0;if(!a){e=0;i=b;return e|0}e=ML(c[(c[a>>2]|0)+64>>2]|0)|0;i=b;return e|0}function Bw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+8|0;b=c[(c[e>>2]|0)+4>>2]|0;a:do if(!(b&1073741824)){f=b;b:while(1){switch(f>>>16&255|0){case 13:{g=12;break b;break}case 17:break;case 4:{g=3;break b;break}case 10:{g=10;break b;break}case 6:{g=5;break b;break}case 7:{g=4;break b;break}case 9:{g=7;break b;break}case 21:case 22:case 30:case 19:case 28:case 20:case 29:case 24:case 25:case 15:case 1:{g=24;break b;break}case 2:{g=25;break b;break}case 5:{h=6;break a;break}case 18:{g=20;break b;break}case 3:{g=6;break b;break}case 14:{g=19;break b;break}case 11:{g=9;break b;break}case 12:{g=11;break b;break}case 8:{g=8;break b;break}default:{g=23;break b}}j=c[c[e>>2]>>2]|0;if(!(a[j+149>>0]|0)){k=j;g=15;break}f=c[(NI(j)|0)+4>>2]|0}switch(g|0){case 3:{h=5;break a;break}case 4:{h=8;break a;break}case 5:{h=7;break a;break}case 6:{h=4;break a;break}case 7:{h=10;break a;break}case 8:{h=9;break a;break}case 9:{h=12;break a;break}case 10:{h=11;break a;break}case 11:{h=13;break a;break}case 12:{h=14;break a;break}case 15:{if(!(HEi(c[k+12>>2]|0,3496376)|0)){f=c[k+8>>2]|0;if(!(HEi(f,3126856)|0)){h=15;break a}if(!(HEi(f,3126888)|0)){h=16;break a}}h=1;break a;break}case 19:{h=18;break a;break}case 20:{f=c[c[e>>2]>>2]|0;if((HEi(c[f+12>>2]|0,3496376)|0)==0?(HEi(c[f+8>>2]|0,3126440)|0)==0:0){h=2;break a}h=1;break a;break}case 23:{Vl();break}case 24:{h=1;break a;break}case 25:{h=3;break a;break}}}else h=1;while(0);i=d;return h|0}function Cw(a){a=a|0;var b=0,d=0;b=i;d=GI(c[a>>2]|0)|0;RI(d)|0;a=ML(c[d+64>>2]|0)|0;i=b;return a|0}function Dw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+176|0;e=d+164|0;f=d+16|0;g=d;kI(e,oM(a)|0);YM(f);OM(g,e,f,0);if(PM(g,1)|0){g=zJ(f,b,c)|0;c=(g|0)==0;if(c&b)FJ(OJ()|0);if(c)h=0;else h=ML(g)|0}else if(b)FJ(OJ()|0);else h=0;ZM(f);xri(e);i=d;return h|0}function Ew(b){b=b|0;var c=0,d=0;c=i;d=(a[(LI(b)|0)+144>>0]|0)!=0;i=c;return d|0}function Fw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(vL(b,GI(c[a+8>>2]|0)|0)|0)!=0;i=d;return e|0}function Gw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+208|0;f=e+184|0;g=e+40|0;h=e+24|0;j=e+12|0;k=e;if((d|0)>32){l=g+64|0;m=g+8|0;c[m>>2]=73864;n=g+12|0;c[g>>2]=74012;c[l>>2]=74032;c[g+4>>2]=0;esi(g+64|0,n);c[g+136>>2]=0;c[g+140>>2]=-1;c[g>>2]=73844;c[l>>2]=73884;c[m>>2]=73864;jsi(n);c[n>>2]=74048;m=g+44|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[g+60>>2]=24;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(n,f);xri(f);m=b+8|0;o=c[(c[c[m>>2]>>2]|0)+12>>2]|0;p=uN(uN(g+8|0,o,SEi(o|0)|0)|0,3672776,1)|0;o=c[(c[c[m>>2]>>2]|0)+8>>2]|0;uN(eti(uN(uN(p,o,SEi(o|0)|0)|0,225088,11)|0,d)|0,225104,25)|0;zN(h,n);if(!(a[h>>0]&1))q=h+1|0;else q=c[h+8>>2]|0;Fr(UJ(q)|0);xri(h);AN(g,73896);bsi(l);r=m}else r=b+8|0;b=c[r>>2]|0;if(!(c[b+4>>2]&1073741824))s=b;else{b=g+64|0;m=g+8|0;c[m>>2]=73864;l=g+12|0;c[g>>2]=74012;c[b>>2]=74032;c[g+4>>2]=0;esi(g+64|0,l);c[g+136>>2]=0;c[g+140>>2]=-1;c[g>>2]=73844;c[b>>2]=73884;c[m>>2]=73864;jsi(l);c[l>>2]=74048;m=g+44|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[g+60>>2]=24;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(l,f);xri(f);m=uN(g+8|0,225136,29)|0;h=c[(c[c[r>>2]>>2]|0)+12>>2]|0;q=uN(uN(m,h,SEi(h|0)|0)|0,3672776,1)|0;h=c[(c[c[r>>2]>>2]|0)+8>>2]|0;uN(uN(q,h,SEi(h|0)|0)|0,225168,3)|0;zN(j,l);if(!(a[j>>0]&1))t=j+1|0;else t=c[j+8>>2]|0;Fr(UJ(t)|0);xri(j);AN(g,73896);bsi(b);s=c[r>>2]|0}b=c[s>>2]|0;if(HEi(c[b+12>>2]|0,3496376)|0){i=e;return}if(HEi(c[b+8>>2]|0,2670272)|0){i=e;return}b=g+64|0;s=g+8|0;c[s>>2]=73864;j=g+12|0;c[g>>2]=74012;c[b>>2]=74032;c[g+4>>2]=0;esi(g+64|0,j);c[g+136>>2]=0;c[g+140>>2]=-1;c[g>>2]=73844;c[b>>2]=73884;c[s>>2]=73864;jsi(j);c[j>>2]=74048;s=g+44|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[g+60>>2]=24;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(j,f);xri(f);f=uN(g+8|0,225136,29)|0;s=c[(c[c[r>>2]>>2]|0)+12>>2]|0;t=uN(uN(f,s,SEi(s|0)|0)|0,3672776,1)|0;s=c[(c[c[r>>2]>>2]|0)+8>>2]|0;uN(uN(t,s,SEi(s|0)|0)|0,225176,4)|0;zN(k,j);if(!(a[k>>0]&1))u=k+1|0;else u=c[k+8>>2]|0;Fr(UJ(u)|0);xri(k);AN(g,73896);bsi(b);i=e;return}function Hw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Gw(a,b);e=jr(c[a+8>>2]|0)|0;if(!b)f=_q(e,1)|0;else f=cr(e,b,1)|0;if(!f){g=0;i=d;return g|0}g=ML(c[f+64>>2]|0)|0;i=d;return g|0}function Iw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=GI(c[a+8>>2]|0)|0;a=sI(b)|0;c[e>>2]=0;g=e+4|0;c[g>>2]=0;h=e+8|0;c[h>>2]=0;if(a){j=xCi(a<<2)|0;c[e>>2]=j;c[g>>2]=j;c[h>>2]=j+(a<<2);j=0;do{k=(c[(yI(b,4,j)|0)>>2]|0)+8|0;l=c[g>>2]|0;if((l|0)==(c[h>>2]|0))SN(e,k);else{if(!l)m=0;else{c[l>>2]=c[k>>2];m=c[g>>2]|0}c[g>>2]=m+4}j=j+1|0}while(j>>>0<a>>>0)}a=BK(f,e)|0;if(!a)n=0;else n=ML(c[a+64>>2]|0)|0;a=c[e>>2]|0;if(!a){i=d;return n|0}e=c[g>>2]|0;if((e|0)!=(a|0))c[g>>2]=e+(~((e+-4-a|0)>>>2)<<2);ACi(a);i=d;return n|0}function Jw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+8|0;a=GI(c[e>>2]|0)|0;f=b+8|0;b=GI(c[f>>2]|0)|0;if((c[(c[e>>2]|0)+4>>2]&1073741824|0)!=0?(c[(c[f>>2]|0)+4>>2]&1073741824|0)==0:0){g=0;i=d;return g|0}g=bJ(a,b)|0;i=d;return g|0}function Kw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!b){e=0;i=d;return e|0}f=LI(a)|0;e=dJ(f,LI(b)|0,c)|0;i=d;return e|0}function Lw(a){a=a|0;var b=0,d=0;b=i;d=ML(c[(GI(c[a+8>>2]|0)|0)+68>>2]|0)|0;i=b;return d|0}function Mw(a){a=a|0;var b=0,d=0;b=i;d=ML(c[(II(c[a+8>>2]|0)|0)+64>>2]|0)|0;i=b;return d|0}function Nw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;h=jr(c[a+8>>2]|0)|0;a=jr(c[b+8>>2]|0)|0;b=YI(a)|0;c[d>>2]=ar(c[101557]|0,b)|0;c[e>>2]=ar(c[101557]|0,b)|0;c[g>>2]=0;j=fJ(h,a)|0;if((b|0)<=0){i=f;return}k=h+52|0;l=0;do{m=Vr(nr(a,g)|0,a)|0;c[(yI(c[e>>2]|0,4,l)|0)>>2]=m;m=Vr(c[(c[k>>2]|0)+(l+j<<2)>>2]|0,h)|0;c[(yI(c[d>>2]|0,4,l)|0)>>2]=m;l=l+1|0}while((l|0)!=(b|0));i=f;return}function Ow(a){a=a|0;var b=0,d=0,f=0;b=i;d=c[c[a+8>>2]>>2]|0;if(!(c[d>>2]|0)){f=0;i=b;return f|0}f=e[d+16>>1]|0;i=b;return f|0}function Pw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[c[a+8>>2]>>2]|0;if(!(c[d>>2]|0)){e=0;i=b;return e|0}a=d+24|0;d=c[a>>2]|0;if(!d){e=ar(c[101550]|0,0)|0;i=b;return e|0}else{f=0;g=d}while(1){if(!(c[g>>2]|0)){h=f;break}f=f+1|0;g=g+4|0}g=ar(c[101550]|0,h)|0;if((h|0)>0)j=0;else{e=g;i=b;return e|0}do{f=yI(g,4,j)|0;c[f>>2]=qs(c[(c[(c[a>>2]|0)+(j<<2)>>2]|0)+64>>2]|0)|0;j=j+1|0}while((j|0)!=(h|0));e=g;i=b;return e|0}function Qw(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(225184)|0)}function Rw(a){a=a|0;FJ(SJ(225376)|0);return 0}function Sw(d,e,f){d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;j=i;i=i+16|0;k=j;if(!e)FJ(KJ(225560)|0);if((c[d>>2]|0)!=(c[e>>2]|0)){l=0;i=j;return l|0}m=sL(d)|0;n=m+149|0;if(((a[n>>0]|0)!=0?(NI(m)|0)!=0:0)?(c[(NI(m)|0)+4>>2]&16711680|0)==524288:0){l=(c[d+8>>2]|0)==(c[e+8>>2]|0);i=j;return l|0}c[f>>2]=0;c[k>>2]=0;o=0;p=0;a:while(1){q=OI(m,k)|0;if(!q){r=o;s=p;t=28;break}else u=q;while(1){q=u+4|0;if((c[(c[q>>2]|0)+4>>2]&16|0)==0?!(iK(u)|0):0){v=u;w=q;break}u=OI(m,k)|0;if(!u){r=o;s=p;t=28;break a}}switch((c[(c[w>>2]|0)+4>>2]|0)>>>16&255|0){case 2:case 5:case 4:{q=c[v+12>>2]|0;if((a[d+q>>0]|0)==(a[e+q>>0]|0)){x=o;y=p}else{l=0;t=31;break a}break}case 11:case 10:{q=c[v+12>>2]|0;z=d+q|0;A=e+q|0;if((c[z>>2]|0)==(c[A>>2]|0)?(c[z+4>>2]|0)==(c[A+4>>2]|0):0){x=o;y=p}else{l=0;t=31;break a}break}case 13:{A=c[v+12>>2]|0;if(+h[d+A>>3]!=+h[e+A>>3]){l=0;t=31;break a}else{x=o;y=p}break}case 9:case 8:{A=c[v+12>>2]|0;if((c[d+A>>2]|0)==(c[e+A>>2]|0)){x=o;y=p}else{l=0;t=31;break a}break}case 12:{A=c[v+12>>2]|0;if(ea(g[d+A>>2])!=ea(g[e+A>>2])){l=0;t=31;break a}else{x=o;y=p}break}case 3:case 7:case 6:{A=c[v+12>>2]|0;if((b[d+A>>1]|0)==(b[e+A>>1]|0)){x=o;y=p}else{l=0;t=31;break a}break}case 14:{A=c[v+12>>2]|0;z=c[d+A>>2]|0;q=c[e+A>>2]|0;if((z|0)!=(q|0)){if((z|0)==0|(q|0)==0){l=0;t=31;break a}A=nM(z)|0;if((A|0)!=(nM(q)|0)){l=0;t=31;break a}B=oM(z)|0;if(FEi(B,oM(q)|0,A<<1)|0){l=0;t=31;break a}else{x=o;y=p}}else{x=o;y=p}break}default:{if(!p){A=(ZI(m)|0)<<3;q=i;i=i+((1*A|0)+15&-16)|0;C=q}else C=p;c[C+(o<<2)>>2]=eK(v,d)|0;c[C+(o+1<<2)>>2]=eK(v,e)|0;x=o+2|0;y=C}}if(!(a[n>>0]|0)){o=x;p=y}else{r=x;s=y;t=28;break}}if((t|0)==28){if(!s){l=1;i=j;return l|0}bt(f,uI(c[101523]|0,r)|0);if((r|0)>0)D=0;else{l=0;i=j;return l|0}do{y=yI(c[f>>2]|0,4,D)|0;c[y>>2]=c[s+(D<<2)>>2];D=D+1|0}while((D|0)!=(r|0));l=0;i=j;return l|0}else if((t|0)==31){i=j;return l|0}return 0}function Tw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;e=d;c[e>>2]=0;f=sL(a)|0;if(!(ZI(f)|0)){g=tL(a)|0;i=d;return g|0}c[e>>2]=0;h=OI(f,e)|0;if(h){j=h;h=0;k=0;l=0;a:while(1){m=j;n=h;o=l;b:while(1){p=m;while(1){q=p+4|0;if((c[(c[q>>2]|0)+4>>2]&16|0)==0?!(iK(p)|0):0){r=(c[(c[q>>2]|0)+4>>2]|0)>>>16&255;if((r|0)==8){s=p;t=n;u=o;v=11;break b}else if((r|0)!=14){w=p;break}r=c[a+(c[p+12>>2]|0)>>2]|0;if(r){x=r;y=n;z=o;v=13;break b}}p=OI(f,e)|0;if(!p){A=n;B=k;C=o;break a}}if(!o){p=(ZI(f)|0)<<2;r=i;i=i+((1*p|0)+15&-16)|0;D=r}else D=o;r=n+1|0;c[D+(n<<2)>>2]=eK(w,a)|0;m=OI(f,e)|0;if(!m){A=r;B=k;C=D;break a}else{n=r;o=D}}if((v|0)==11){v=0;E=c[a+(c[s+12>>2]|0)>>2]|0;F=t;G=u}else if((v|0)==13){v=0;E=pM(x)|0;F=y;G=z}o=E^k;j=OI(f,e)|0;if(!j){A=F;B=o;C=G;break}else{h=F;k=o;l=G}}if(!C)H=B;else{bt(b,uI(c[101523]|0,A)|0);if((A|0)>0)I=0;else{g=B;i=d;return g|0}do{G=yI(c[b>>2]|0,4,I)|0;c[G>>2]=c[C+(I<<2)>>2];I=I+1|0}while((I|0)!=(A|0));g=B;i=d;return g|0}}else H=0;c[b>>2]=0;g=H;i=d;return g|0}function Uw(){FJ(SJ(225568)|0);return 0}function Vw(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;j=i;i=i+16|0;h=j;MM(h);g=h+4|0;f=c[h>>2]|0;e=(c[g>>2]|0)-f>>2;b=e-a+-1|0;if(b>>>0>=e>>>0|(b|0)<0){k=0;l=f}else{e=c[f+(b<<2)>>2]|0;c[d>>2]=NL(e,c[e+8>>2]|0)|0;k=1;l=c[h>>2]|0}if(!l){i=j;return k|0}h=c[g>>2]|0;if((h|0)!=(l|0))c[g>>2]=h+(~((h+-4-l|0)>>>2)<<2);ACi(l);i=j;return k|0}function Ww(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;e=c[a+8>>2]|0;if(!e){f=uI(c[101560]|0,0)|0;i=d;return f|0}a=sI(e)|0;g=(a|0)>(b|0);h=uI(c[101560]|0,g?a-b|0:0)|0;if(g)j=b;else{f=h;i=d;return f|0}do{b=qL(c[101560]|0)|0;c[b+16>>2]=NL(c[(yI(e,4,j)|0)>>2]|0,0)|0;c[(yI(h,4,j)|0)>>2]=b;j=j+1|0}while((j|0)!=(a|0));f=h;i=d;return f|0}function Xw(a){a=a|0;return}function Yw(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;g=i;a=nM(f)|0;j=oM(c)|0;c=oM(f)|0;if(!h){h=d+1-a|0;f=d-e|0;if((h|0)<=(f|0)){k=-1;i=g;return k|0}l=a<<1;m=h;while(1){if(!(FEi(j+(m<<1)|0,c,l)|0)){k=m;n=11;break}m=m+-1|0;if((m|0)<=(f|0)){k=-1;n=11;break}}if((n|0)==11){i=g;return k|0}}f=e+d-a|0;if((f|0)<(d|0)){k=-1;i=g;return k|0}else o=d;a:while(1){d=0;while(1){if((b[j+(d+o<<1)>>1]|0)!=(b[c+(d<<1)>>1]|0))break;d=d+1|0;if((d|0)==(a|0)){k=o;n=11;break a}}if((o|0)<(f|0))o=o+1|0;else{k=-1;n=11;break}}if((n|0)==11){i=g;return k|0}return 0}function Zw(a,c,d,f,g,h,j,k){a=a|0;c=c|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=i;l=(f|0)<(j|0)?j:f;m=oM(c)|0;c=oM(g)|0;g=(f|0)>0;a:do if((l|0)!=0&g&(j|0)>0){n=(k&1|0)==0;if(!(k&1073741824)){o=0;while(1){p=b[c+(o+h<<1)>>1]|0;q=e[m+(o+d<<1)>>1]|0;if(n)r=q-(p&65535)|0;else{s=QBi(q)|0;r=s-(QBi(p&65535)|0)|0}if((r|0)<0){t=-1;u=34;break}p=(r|0)>0;s=o+1|0;if(p){t=p&1;u=34;break}p=(s|0)<(f|0);if((s|0)!=(l|0)&p&(s|0)<(j|0))o=s;else{v=p;w=s;break a}}if((u|0)==34){i=a;return t|0}}if(n){o=0;while(1){s=b[c+(o+h<<1)>>1]|0;p=b[m+(o+d<<1)>>1]|0;q=o+1|0;if(p<<16>>16!=s<<16>>16){x=s;y=p;break}p=(q|0)<(f|0);if((q|0)!=(l|0)&p&(q|0)<(j|0))o=q;else{v=p;w=q;break a}}t=(y&65535)-(x&65535)|0;i=a;return t|0}else{o=0;while(1){n=b[c+(o+h<<1)>>1]|0;q=b[m+(o+d<<1)>>1]|0;p=o+1|0;if(q<<16>>16!=n<<16>>16){z=n;A=q;break}q=(p|0)<(f|0);if((p|0)!=(l|0)&q&(p|0)<(j|0))o=p;else{v=q;w=p;break a}}t=(A&65535)-(z&65535)|0;i=a;return t|0}}else{v=g;w=0}while(0);if((w|0)==(l|0)){g=l+-1|0;l=b[m+(g+d<<1)>>1]|0;z=b[c+(g+h<<1)>>1]|0;if(k&1073741824){t=(l&65535)-(z&65535)|0;i=a;return t|0}g=l&65535;if(!(k&1))B=g-(z&65535)|0;else{l=QBi(g)|0;B=l-(QBi(z&65535)|0)|0}if((B|0)<0){t=-1;i=a;return t|0}t=(B|0)>0&1;i=a;return t|0}B=(w|0)>=(j|0);if(!v){t=(B^1)<<31>>31;i=a;return t|0}if(B){t=1;i=a;return t|0}B=b[m+(w+d<<1)>>1]|0;d=b[c+(w+h<<1)>>1]|0;if(k&1073741824){t=(B&65535)-(d&65535)|0;i=a;return t|0}h=B&65535;if(!(k&1))C=h-(d&65535)|0;else{k=QBi(h)|0;C=k-(QBi(d&65535)|0)|0}if((C|0)<0){t=-1;i=a;return t|0}t=(C|0)>0&1;i=a;return t|0}function _w(a,b){a=a|0;b=b|0;return}function $w(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;d=c[f+8>>2]|0;h=uI(c[101524]|0,d)|0;j=yI(h,1,0)|0;if((d|0)>0){k=0;l=j}else{m=e+16|0;c[m>>2]=h;i=g;return}while(1){a[l>>0]=b[f+(k<<1)+12>>1];k=k+1|0;if((k|0)==(d|0))break;else l=l+1|0}m=e+16|0;c[m>>2]=h;i=g;return}function ax(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=c[d+40>>2]|0;h=c[d+24>>2]|0;a[g+8>>0]=a[d+8>>0]|0;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+32>>1]|0)){j=d;break}k=d+1|0;if((k|0)<7)d=k;else{j=k;break}}d=br(_q(c[101539]|0,1)|0,j)|0;if((j|0)>0){k=0;do{l=yI(d,4,k)|0;c[l>>2]=ks(257504+(e[225768+(h*190|0)+(k<<1)+32>>1]|0)|0)|0;k=k+1|0}while((k|0)!=(j|0))}c[g+80>>2]=d;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+72>>1]|0)){m=d;break}j=d+1|0;if((j|0)<13)d=j;else{m=j;break}}d=br(_q(c[101539]|0,1)|0,m)|0;if((m|0)>0){j=0;do{k=yI(d,4,j)|0;c[k>>2]=ks(257504+(e[225768+(h*190|0)+(j<<1)+72>>1]|0)|0)|0;j=j+1|0}while((j|0)!=(m|0))}c[g+92>>2]=d;c[g+12>>2]=ks(257504+(e[225782+(h*190|0)>>1]|0)|0)|0;c[g+76>>2]=a[225866+(h*190|0)>>0];c[g+20>>2]=ks(257504+(e[225868+(h*190|0)>>1]|0)|0)|0;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+18>>1]|0)){n=d;break}m=d+1|0;if((m|0)<7)d=m;else{n=m;break}}d=br(_q(c[101539]|0,1)|0,n)|0;if((n|0)>0){m=0;do{j=yI(d,4,m)|0;c[j>>2]=ks(257504+(e[225768+(h*190|0)+(m<<1)+18>>1]|0)|0)|0;m=m+1|0}while((m|0)!=(n|0))}c[g+84>>2]=d;c[g+68>>2]=a[225867+(h*190|0)>>0];c[g+52>>2]=ks(257504+(e[225768+(h*190|0)>>1]|0)|0)|0;c[g+32>>2]=ks(257504+(e[225770+(h*190|0)>>1]|0)|0)|0;c[g+40>>2]=ks(257504+(e[225774+(h*190|0)>>1]|0)|0)|0;c[g+44>>2]=ks(257504+(e[225780+(h*190|0)>>1]|0)|0)|0;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+46>>1]|0)){o=d;break}n=d+1|0;if((n|0)<13)d=n;else{o=n;break}}d=br(_q(c[101539]|0,1)|0,o)|0;if((o|0)>0){n=0;do{m=yI(d,4,n)|0;c[m>>2]=ks(257504+(e[225768+(h*190|0)+(n<<1)+46>>1]|0)|0)|0;n=n+1|0}while((n|0)!=(o|0))}c[g+88>>2]=d;c[g+16>>2]=ks(257504+(e[225784+(h*190|0)>>1]|0)|0)|0;c[g+28>>2]=ks(257504+(e[225772+(h*190|0)>>1]|0)|0)|0;c[g+36>>2]=ks(257504+(e[225776+(h*190|0)>>1]|0)|0)|0;c[g+24>>2]=ks(257504+(e[225870+(h*190|0)>>1]|0)|0)|0;c[g+48>>2]=ks(257504+(e[225778+(h*190|0)>>1]|0)|0)|0;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+104>>1]|0)){p=d;break}o=d+1|0;if((o|0)<14)d=o;else{p=o;break}}d=br(_q(c[101539]|0,1)|0,p)|0;if((p|0)>0){o=0;do{n=yI(d,4,o)|0;c[n>>2]=ks(257504+(e[225768+(h*190|0)+(o<<1)+104>>1]|0)|0)|0;o=o+1|0}while((o|0)!=(p|0))}c[g+96>>2]=d;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+132>>1]|0)){q=d;break}p=d+1|0;if((p|0)<8)d=p;else{q=p;break}}d=br(_q(c[101539]|0,1)|0,q)|0;if((q|0)>0){p=0;do{o=yI(d,4,p)|0;c[o>>2]=ks(257504+(e[225768+(h*190|0)+(p<<1)+132>>1]|0)|0)|0;p=p+1|0}while((p|0)!=(q|0))}c[g+100>>2]=d;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+148>>1]|0)){r=d;break}q=d+1|0;if((q|0)<11)d=q;else{r=q;break}}d=br(_q(c[101539]|0,1)|0,r)|0;if((r|0)>0){q=0;do{p=yI(d,4,q)|0;c[p>>2]=ks(257504+(e[225768+(h*190|0)+(q<<1)+148>>1]|0)|0)|0;q=q+1|0}while((q|0)!=(r|0))}c[g+104>>2]=d;d=0;while(1){if(!(b[225768+(h*190|0)+(d<<1)+170>>1]|0)){s=d;break}r=d+1|0;if((r|0)<10)d=r;else{s=r;break}}d=br(_q(c[101539]|0,1)|0,s)|0;if((s|0)>0)t=0;else{u=g+108|0;c[u>>2]=d;i=f;return}do{r=yI(d,4,t)|0;c[r>>2]=ks(257504+(e[225768+(h*190|0)+(t<<1)+170>>1]|0)|0)|0;t=t+1|0}while((t|0)!=(s|0));u=g+108|0;c[u>>2]=d;i=f;return}function bx(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+96|0;f=e+24|0;g=e+12|0;h=e;vH(f);j=a[f>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[f+4>>2]|0;if(!l){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;m=h}else{if(k)n=f+1|0;else n=c[f+8>>2]|0;k=jCi(n)|0;n=hCi(k,46)|0;if(n){l=ADi(SEi(k|0)|0)|0;j=n-k|0;UEi(l|0,k|0,j|0)|0;a[l+j>>0]=0;j=hCi(l,64)|0;if(!j)o=l;else{a[l+(j-l)>>0]=0;o=l}}else o=0;l=lCi(k,64)|0;if((l|0)!=0&(o|0)==0){j=ADi(SEi(k|0)|0)|0;n=l-k|0;UEi(j|0,k|0,n|0)|0;a[j+n>>0]=0;p=j}else p=o;if(!p)q=k;else{BDi(k);q=p}p=hCi(q,95)|0;if(p)a[p>>0]=45;rri(g,q,SEi(q|0)|0);BDi(q);q=a[g>>0]|0;if(!(q&1)){r=g+1|0;s=g+((q&255)>>>1)+1|0}else{q=c[g+8>>2]|0;r=q;s=q+(c[g+4>>2]|0)|0}if((r|0)!=(s|0)){q=r;do{a[q>>0]=IDi(a[q>>0]|0)|0;q=q+1|0}while((q|0)!=(s|0))}sri(h,g);xri(g);m=h}xri(f);g=a[m>>0]|0;m=(g&1)==0;if(m)t=(g&255)>>>1;else t=c[h+4>>2]|0;if(!t){u=0;xri(h);i=e;return u|0}if(m)v=h+1|0;else v=c[h+8>>2]|0;m=eCi(v,290112,167,4,2483)|0;if(m){v=b[m+2>>1]|0;m=307256+(v*72|0)|0;t=b[307260+(v*72|0)>>1]|0;if((b[m>>1]|0)==t<<16>>16)w=m;else{b[f>>1]=t;w=eCi(f,307256,167,72,2484)|0}if(w){VN(d,w);x=1}else x=0}else x=0;a[d+8>>0]=1;a[d+32>>0]=1;u=x;xri(h);i=e;return u|0}function cx(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;b[e>>1]=c;c=eCi(e,307256,167,72,2484)|0;if(!c){f=0;i=d;return f|0}VN(a,c);f=1;i=d;return f|0}function dx(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;kI(g,e+12|0);if(!(a[g>>0]&1))h=g+1|0;else h=c[g+8>>2]|0;e=eCi(h,290112,167,4,2483)|0;if(!e){j=0;xri(g);i=f;return j|0}VN(d,307256+((b[e+2>>1]|0)*72|0)|0);j=1;xri(g);i=f;return j|0}function ex(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[b+28>>2]|0;if((f|0)<0){i=d;return}g=c[b+36>>2]|0;a[g+8>>0]=a[b+8>>0]|0;c[g+32>>2]=a[290817+(f*96|0)>>0];c[g+36>>2]=ks(257504+(e[290784+(f*96|0)>>1]|0)|0)|0;c[g+40>>2]=ks(257504+(e[290786+(f*96|0)>>1]|0)|0)|0;b=0;while(1){if((c[290784+(f*96|0)+(b<<2)+36>>2]|0)==-1){h=b;break}j=b+1|0;if((j|0)<5)b=j;else{h=j;break}}b=br(_q(c[101530]|0,1)|0,h)|0;if((h|0)>0){j=0;do{k=yI(b,4,j)|0;c[k>>2]=c[290784+(f*96|0)+(j<<2)+36>>2];j=j+1|0}while((j|0)!=(h|0))}c[g+44>>2]=b;c[g+48>>2]=a[290812+(f*96|0)>>0];c[g+52>>2]=a[290813+(f*96|0)>>0];c[g+56>>2]=ks(257504+(e[290796+(f*96|0)>>1]|0)|0)|0;c[g+60>>2]=ks(257504+(e[290800+(f*96|0)>>1]|0)|0)|0;c[g+64>>2]=ks(257504+(e[290804+(f*96|0)>>1]|0)|0)|0;c[g+68>>2]=ks(257504+(e[290808+(f*96|0)>>1]|0)|0)|0;c[g+72>>2]=a[290819+(f*96|0)>>0];c[g+76>>2]=ks(257504+(e[290792+(f*96|0)>>1]|0)|0)|0;c[g+80>>2]=ks(257504+(e[290794+(f*96|0)>>1]|0)|0)|0;b=0;while(1){if((c[290784+(f*96|0)+(b<<2)+76>>2]|0)==-1){l=b;break}h=b+1|0;if((h|0)<5)b=h;else{l=h;break}}b=br(_q(c[101530]|0,1)|0,l)|0;if((l|0)>0){h=0;do{j=yI(b,4,h)|0;c[j>>2]=c[290784+(f*96|0)+(h<<2)+76>>2];h=h+1|0}while((h|0)!=(l|0))}c[g+84>>2]=b;c[g+88>>2]=a[290816+(f*96|0)>>0];c[g+92>>2]=a[290818+(f*96|0)>>0];c[g+96>>2]=ks(257504+(e[290788+(f*96|0)>>1]|0)|0)|0;c[g+100>>2]=ks(257504+(e[290790+(f*96|0)>>1]|0)|0)|0;b=0;while(1){if((c[290784+(f*96|0)+(b<<2)+56>>2]|0)==-1){m=b;break}l=b+1|0;if((l|0)<5)b=l;else{m=l;break}}b=br(_q(c[101530]|0,1)|0,m)|0;if((m|0)>0){l=0;do{h=yI(b,4,l)|0;c[h>>2]=c[290784+(f*96|0)+(l<<2)+56>>2];l=l+1|0}while((l|0)!=(m|0))}c[g+104>>2]=b;c[g+108>>2]=a[290814+(f*96|0)>>0];c[g+112>>2]=a[290815+(f*96|0)>>0];c[g+116>>2]=ks(257504+(e[290798+(f*96|0)>>1]|0)|0)|0;c[g+120>>2]=ks(257504+(e[290802+(f*96|0)>>1]|0)|0)|0;c[g+124>>2]=ks(257504+(e[290806+(f*96|0)>>1]|0)|0)|0;c[g+128>>2]=ks(257504+(e[290810+(f*96|0)>>1]|0)|0)|0;i=d;return}function fx(a,b){a=a|0;b=b|0;FJ(SJ(306816)|0);return 0}function gx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;b=c[101565]|0;a=ar(b,167)|0;e=0;do{f=ds(b)|0;VN(f,307256+(e*72|0)|0);c[(yI(a,4,e)|0)>>2]=f;e=e+1|0}while((e|0)<167);i=d;return a|0}function hx(a,b){a=a|0;b=b|0;FJ(SJ(307048)|0);return 0}function ix(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=319280;gl(345824,a|0)|0;i=b;return 0}function jx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(SJ(319328)|0);return 0}function kx(a){a=a|0;FJ(SJ(319520)|0);return 0}function lx(){return 47}function mx(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=kH(c[a>>2]|0,b)|0;i=d;return e|0}function nx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+12|0;g=e;kI(f,a+12|0);kI(g,b+12|0);b=gH(f,g,c,d)|0;xri(g);xri(f);i=e;return b|0}function ox(){var a=0,b=0;a=i;b=ZG()|0;i=a;return b|0}function px(){var a=0,b=0;a=i;b=_G()|0;i=a;return b|0}function qx(){var a=0,b=0;a=i;b=$G()|0;i=a;return b|0}function rx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;kI(d,a+12|0);a=FG(d,b)|0;xri(d);i=c;return a|0}function sx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;kI(d,a+12|0);a=fH(d,b)|0;xri(d);i=c;return a|0}function tx(){return 47}function ux(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;DG(e,b);if(!(a[e>>0]&1))f=e+1|0;else f=c[e+8>>2]|0;b=qM(f)|0;xri(e);i=d;return b|0}function vx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;kI(d,a+12|0);a=bH(d,b)|0;xri(d);i=c;return a|0}function wx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+64|0;g=f;h=f+48|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;kI(h,b+12|0);b=dH(h,g,e)|0;xri(h);if(!b){xri(g);i=f;return b|0}if(!(a[g>>0]&1))j=g+1|0;else j=c[g+8>>2]|0;c[d>>2]=qM(j)|0;c[d+4>>2]=c[g+12>>2];j=g+16|0;h=c[j+4>>2]|0;e=d+8|0;c[e>>2]=c[j>>2];c[e+4>>2]=h;h=g+24|0;e=c[h+4>>2]|0;j=d+16|0;c[j>>2]=c[h>>2];c[j+4>>2]=e;e=g+32|0;j=c[e+4>>2]|0;h=d+24|0;c[h>>2]=c[e>>2];c[h+4>>2]=j;j=g+40|0;h=c[j+4>>2]|0;e=d+32|0;c[e>>2]=c[j>>2];c[e+4>>2]=h;xri(g);i=f;return b|0}function xx(a,b){a=a|0;b=b|0;var d=0;b=i;d=eH(c[a>>2]|0)|0;i=b;return d|0}function yx(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=mH(c[a>>2]|0,b)|0;i=d;return e|0}function zx(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;kI(h,a+12|0);a=jH(h,b,c,d,e,f)|0;xri(h);i=g;return a|0}function Ax(){return 58}function Bx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;c[f>>2]=0;if((e+d|0)>>>0>(sI(b)|0)>>>0){h=0;i=g;return h|0}j=c[a>>2]|0;h=pH(j,yI(b,1,d)|0,e,f)|0;i=g;return h|0}function Cx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;kI(d,a+12|0);a=EG(d,b)|0;xri(d);i=c;return a|0}function Dx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=nH(c[a>>2]|0,b,d,e)|0;i=f;return g|0}function Ex(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=oH(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function Fx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;c[f>>2]=0;if((e+d|0)>>>0>(sI(b)|0)>>>0){h=0;i=g;return h|0}j=c[a>>2]|0;h=qH(j,yI(b,1,d)|0,e,f)|0;i=g;return h|0}function Gx(){return 47}function Hx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;kI(d,a+12|0);a=GG(d,b)|0;xri(d);i=c;return a|0}function Ix(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+48|0;j=h+24|0;k=h+12|0;l=h;kI(j,b+12|0);kI(k,d+12|0);HG(l,j,k,e,f,g);g=JI(c[101539]|0,1)|0;f=vI(g,c[l+8>>2]|0)|0;g=c[l>>2]|0;e=l+4|0;if((g|0)!=(e|0)){d=g;g=0;while(1){b=yI(f,4,g)|0;g=g+1|0;m=d+16|0;if(!(a[m>>0]&1))n=m+1|0;else n=c[d+24>>2]|0;c[b>>2]=qM(n)|0;b=c[d+4>>2]|0;if(!b){m=d;while(1){o=c[m+8>>2]|0;if((c[o>>2]|0)==(m|0)){p=o;break}else m=o}}else{m=b;while(1){o=c[m>>2]|0;if(!o){p=m;break}else m=o}}if((p|0)==(e|0))break;else d=p}}WN(l,c[l+4>>2]|0);xri(k);xri(j);i=h;return f|0}function Jx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;kI(e,a+12|0);kI(f,b+12|0);b=hH(e,f,c)|0;xri(f);xri(e);i=d;return b|0}function Kx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=f+24|0;h=f+12|0;j=f;kI(g,a+12|0);kI(h,b+12|0);kI(j,c+12|0);c=iH(g,h,j,d,e)|0;xri(j);xri(h);xri(g);i=f;return c|0}function Lx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=d;kI(e,a+12|0);a=cH(e,b,c)|0;xri(e);i=d;return a|0}function Mx(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=rH(c[a>>2]|0,b)|0;i=d;return e|0}function Nx(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=lH(c[a>>2]|0,b,d,e,f,g,h,j)|0;i=k;return l|0}function Ox(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;sH(c[a>>2]|0,b,d,e,f,g);i=h;return}function Px(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;tH(c[a>>2]|0,b,d,e,f,g);i=h;return}function Qx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=c[a>>2];c[f>>2]=c[b>>2];b=aH(e,f)|0;i=d;return b|0}function Rx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;i=i+16|0;g=h;c[g>>2]=319712;gl(345824,g|0)|0;i=h;return 0}function Sx(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;DH(e);if(!(a[e>>0]&1))f=e+1|0;else f=c[e+8>>2]|0;g=qM(f)|0;c[b>>2]=g;b=nM(g)|0;xri(e);i=d;return b|0}function Tx(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;DH(d);if(!(a[d>>0]&1))e=d+1|0;else e=c[d+8>>2]|0;f=qM(e)|0;xri(d);i=b;return f|0}function Ux(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;FI(e,c[b+8>>2]|0);if(!(a[e>>0]&1))f=e+1|0;else f=c[e+8>>2]|0;b=qM(f)|0;xri(e);i=d;return b|0}function Vx(a){a=a|0;var b=0;a=i;b=qM(3653512)|0;i=a;return b|0}function Wx(){return 0}function Xx(){var a=0,b=0;a=i;b=KL(c[(rK()|0)+24>>2]|0)|0;i=a;return b|0}function Yx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Zx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;f=i;i=i+176|0;b=f+164|0;g=f+16|0;h=f;kI(b,oM(d)|0);YM(g);OM(h,b,g,0);if(PM(h,1)|0){h=(a|0)==0;d=e^1;if(!(h^1|d))FJ(OJ()|0);if(!h){h=BI(c[a+8>>2]|0)|0;a=(h|0)==0;if(!(a^1|d))FJ(OJ()|0);if(!a){a=zK(h,g)|0;h=(a|0)==0;if(!(h^1|d))FJ(OJ()|0);if(!h){RI(a)|0;h=qJ(a,g)|0;a=(h|0)==0;if(!(a^1|d))FJ(OJ()|0);if(!a)j=ML(h)|0;else j=0}else j=0}else j=0}else j=0}else if(e)FJ(OJ()|0);else j=0;ZM(g);xri(b);i=f;return j|0}function _x(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;d=i;i=i+16|0;e=d;kI(e,b+12|0);if(!(a[e>>0]&1))f=e+1|0;else f=c[e+8>>2]|0;b=AI(f)|0;xri(e);if(!b){g=0;i=d;return g|0}g=KL(b)|0;i=d;return g|0}function $x(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=319736;gl(345824,a|0)|0;i=b;return}function ay(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=319760;gl(345824,b|0)|0;i=a;return 0}function by(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;i=i+16|0;g=h;c[g>>2]=319792;gl(345824,g|0)|0;i=h;return 0}function cy(){var a=0,b=0;a=i;b=KL(c[(tK()|0)+24>>2]|0)|0;i=a;return b|0}function dy(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=319824;gl(345824,a|0)|0;i=b;return 0}function ey(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=c[(c[a+8>>2]|0)+56>>2]|0;a=xK(d)|0;e=wK(d)|0;d=uI(c[101550]|0,e+-1|0)|0;if(!e){i=b;return d|0}else{f=0;g=0}while(1){h=c[a+(g<<2)>>2]|0;if(!(HEi(c[h+8>>2]|0,3145848)|0))j=f;else{k=ML(c[h+64>>2]|0)|0;c[(yI(d,4,f)|0)>>2]=k;j=f+1|0}g=g+1|0;if((g|0)==(e|0))break;else f=j}i=b;return d|0}function fy(a){a=a|0;FJ(SJ(319848)|0);return 0}function gy(a){a=a|0;FJ(SJ(320056)|0);return 0}function hy(a){a=a|0;FJ(SJ(320248)|0);return 0}function iy(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(320448)|0);return 0}function jy(a,b){a=a|0;b=b|0;FJ(SJ(320640)|0)}function ky(a,b){a=a|0;b=b|0;FJ(SJ(320840)|0);return 0}function ly(a){a=a|0;FJ(SJ(321024)|0);return 0}function my(a){a=a|0;FJ(SJ(321216)|0);return 0}function ny(a){a=a|0;FJ(SJ(321416)|0);return 0}function oy(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(321616)|0);return 0}function py(a){a=a|0;FJ(SJ(321824)|0);return 0}function qy(a){a=a|0;FJ(SJ(322032)|0);return 0}function ry(a){a=a|0;FJ(SJ(322232)|0);return 0}function sy(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+224|0;h=g+216|0;j=g+184|0;k=g+32|0;l=g+192|0;m=g+16|0;n=g;o=g+36|0;p=g+200|0;q=g+220|0;kI(n,oM(f)|0);YM(o);OM(p,n,o,0);if(!(UM(p)|0)){r=0;ZM(o);xri(n);i=g;return r|0}p=o+24|0;if(!(a[p>>0]&1))s=p+1|0;else s=c[o+32>>2]|0;c[e+8>>2]=qM(s)|0;s=c[o+104>>2]|0;p=s&65535;c[e+16>>2]=p;f=s>>>16;c[e+20>>2]=f;s=c[o+108>>2]|0;t=s&65535;c[e+24>>2]=t;u=s>>>16;c[e+28>>2]=u;c[e+36>>2]=c[o+100>>2];c[e+40>>2]=c[o+92>>2];c[h>>2]=p;c[j>>2]=f;c[k>>2]=t;c[l>>2]=u;if(!(c[80610]|0))c[80610]=UI(c[101564]|0,3072840,4)|0;u=qL(c[101564]|0)|0;c[m>>2]=h;c[m+4>>2]=j;c[m+8>>2]=k;c[m+12>>2]=l;aM(c[80610]|0,u,m,0)|0;c[e+60>>2]=u;u=o+36|0;m=a[u>>0]|0;l=(m&1)==0;if(l)v=(m&255)>>>1;else v=c[o+40>>2]|0;if(v){if(l)w=u+1|0;else w=c[o+44>>2]|0;if(!(c[80608]|0))c[80608]=UI(c[101565]|0,2760552,2)|0;a[h>>0]=0;c[j>>2]=qM(w)|0;c[j+4>>2]=h;c[e+32>>2]=aM(c[80608]|0,0,j,0)|0}if(!(a[o+72>>0]|0)){r=1;ZM(o);xri(n);i=g;return r|0}j=uI(c[101524]|0,8)|0;c[e+52>>2]=j;e=yI(j,1,0)|0;b[q>>1]=0;j=0;h=0;w=e;while(1){a[q>>0]=a[o+h+72>>0]|0;a[w>>0]=(DEi(q,0,16)|0)<<4;a[q>>0]=a[o+(h|1)+72>>0]|0;e=DEi(q,0,16)|0;a[w>>0]=d[w>>0]|e;j=j+1|0;if((j|0)==8){r=1;break}else{h=h+2|0;w=w+1|0}}ZM(o);xri(n);i=g;return r|0}function ty(a,b){a=a|0;b=b|0;FJ(SJ(322448)|0);return 0}function uy(a){a=a|0;return 0}function vy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a>>2]|0;a=c[b>>2]|0;if(!a){f=LL(c[e+8>>2]|0,e)|0;i=d;return f|0}b=GI(a)|0;if(!b){f=0;i=d;return f|0}a=c[e+8>>2]|0;g=b;while(1){if((g|0)==(a|0))break;g=c[g+32>>2]|0;if(!g){f=0;h=8;break}}if((h|0)==8){i=d;return f|0}f=LL(a,e)|0;i=d;return f|0}function wy(a){a=a|0;FJ(SJ(322680)|0);return 0}function xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!(c[b>>2]|0)){b=c[a>>2]|0;f=b;g=c[b+8>>2]|0}else{c[e>>2]=322880;gl(345824,e|0)|0;f=c[a>>2]|0;g=0}a=NL(f,g)|0;i=d;return a|0}function yy(){FJ(SJ(322928)|0);return 0}function zy(a){a=a|0;FJ(SJ(323128)|0);return 0}function Ay(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=323328;gl(345824,b|0)|0;i=a;return 0}function By(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=323360;gl(345824,b|0)|0;i=a;return 0}function Cy(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=323384;gl(345824,b|0)|0;i=a;return 0}function Dy(a){a=a|0;FJ(SJ(323408)|0);return 0}function Ey(a){a=a|0;FJ(SJ(323600)|0);return 0}function Fy(a){a=a|0;FJ(SJ(323792)|0);return 0}function Gy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(SJ(323976)|0);return 0}function Hy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(SJ(324168)|0);return 0}function Iy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(SJ(324360)|0);return 0}function Jy(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(324552)|0);return 0}function Ky(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(SJ(324744)|0);return 0}function Ly(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(324936)|0);return 0}function My(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(325128)|0)}function Ny(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+16|0;c[b>>2]=ML(c[(c[(c[e>>2]|0)+8>>2]|0)+64>>2]|0)|0;f=a+12|0;c[b+4>>2]=c[f>>2];c[b+8>>2]=qM(c[c[e>>2]>>2]|0)|0;a=GI(c[(c[f>>2]|0)+8>>2]|0)|0;f=c[e>>2]|0;g=c[f+12>>2]|0;if(!g){h=0;j=f}else{f=NL(g,a)|0;h=f;j=c[e>>2]|0}c[b+12>>2]=h;h=c[j+16>>2]|0;if(!h){k=0;l=j}else{j=NL(h,a)|0;k=j;l=c[e>>2]|0}c[b+16>>2]=k;k=c[l+20>>2]|0;if(!k){m=0;n=l}else{l=NL(k,a)|0;m=l;n=c[e>>2]|0}c[b+20>>2]=m;c[b+24>>2]=c[(c[n+4>>2]|0)+4>>2]&65535;c[b+28>>2]=uI(c[101557]|0,0)|0;i=d;return}function Oy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(b)e=(c[a+12>>2]|0)+8|0;else e=a+8|0;a=ML(c[(c[e>>2]|0)+64>>2]|0)|0;i=d;return a|0}function Py(a){a=a|0;return (c[(c[a+12>>2]|0)+12>>2]|0)+-8|0}function Qy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;g=e+4|0;h=c[b+12>>2]|0;RI(c[b+8>>2]|0)|0;b=h+4|0;j=c[b>>2]|0;k=(c[j+4>>2]&16|0)!=0;a:do if(!((d|0)==0|k)?(l=c[d>>2]|0,(l|0)!=0):0){m=c[h+8>>2]|0;n=l;do{if((n|0)==(m|0))break a;n=c[n+32>>2]|0}while((n|0)!=0)}while(0);n=cN(j)|0;j=n+4|0;m=c[j>>2]|0;switch(m>>>16&255|0){case 21:{if(fN(n)|0)o=(c[j>>2]&1073741824|0)!=0;else o=1;break}case 17:case 13:case 10:case 11:case 12:case 8:case 9:case 24:case 25:case 3:case 6:case 7:case 2:case 4:case 5:{o=(m&1073741824|0)!=0;break}case 29:case 20:case 18:case 28:case 14:{o=1;break}default:{p=0;i=e;return p|0}}if(k?(m=c[h+8>>2]|0,(a[m+148>>0]|0)==0):0)lM(m);if(o){if(k)fK(h,g);else dK(d,h,g);p=c[g>>2]|0;i=e;return p|0}if(nJ(GI(c[b>>2]|0)|0)|0){c[f>>2]=325312;gl(406304,f|0)|0}f=qL(GI(c[b>>2]|0)|0)|0;c[g>>2]=f;g=f+8|0;if(k){fK(h,g);p=f;i=e;return p|0}else{dK(d,h,g);p=f;i=e;return p|0}return 0}function Ry(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;h=c[b+12>>2]|0;b=h+4|0;j=c[b>>2]|0;k=c[j+4>>2]|0;a:do if(!(k&1073741824))switch(k>>>16&255|0){case 21:{l=c[j>>2]|0;if(nJ(GI(j)|0)|0){GI(c[b>>2]|0)|0;c[g>>2]=325344;gl(406304,g|0)|0;m=e;break a}if(!((e|0)!=0?(a[(c[l>>2]|0)+145>>0]|0)!=0:0)){m=e;break a}m=e+8|0;break a;break}case 29:case 20:case 18:case 28:case 14:{m=e;break a;break}case 17:case 13:case 10:case 11:case 12:case 8:case 9:case 24:case 25:case 3:case 6:case 7:case 2:case 4:case 5:{if(!e){m=e;break a}m=e+8|0;break a;break}default:{i=f;return}}else m=e;while(0);if(!(c[(c[b>>2]|0)+4>>2]&16)){jK(d,h,m);i=f;return}d=c[h+8>>2]|0;if(!(a[d+148>>0]|0))lM(d);kK(h,m);i=f;return}function Sy(a){a=a|0;FJ(SJ(325376)|0);return 0}function Ty(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=i;i=i+16|0;f=g;c[f>>2]=325576;gl(345824,f|0)|0;i=g;return}function Uy(a){a=a|0;FJ(SJ(325608)|0);return 0}function Vy(a){a=a|0;FJ(SJ(325824)|0);return 0}function Wy(a){a=a|0;return a|0}function Xy(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+8>>2]|0;if(a[e+35>>0]|0){f=1;i=d;return f|0}f=(a[e+36>>0]|0)!=0;i=d;return f|0}function Yy(a){a=a|0;var b=0,d=0;b=i;d=qM(c[c[a+8>>2]>>2]|0)|0;c[a+12>>2]=d;i=b;return d|0}function Zy(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=326040;gl(345824,b|0)|0;i=a;return 0}function _y(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=b+8|0;b=c[e>>2]|0;do if(!(a[b+36>>0]|0))f=b;else{g=c[(DK(b)|0)+4>>2]|0;if(!g){f=c[e>>2]|0;break}h=c[g>>2]|0;j=uI(c[101549]|0,h)|0;if(!h){k=j;i=d;return k|0}l=g+4|0;g=0;do{m=yI(j,4,g)|0;c[m>>2]=ML(c[(c[l>>2]|0)+(g<<2)>>2]|0)|0;g=g+1|0}while((g|0)!=(h|0));k=j;i=d;return k|0}while(0);e=EK(f)|0;f=c[e+16>>2]|0;b=f&2147483647;j=uI(c[101549]|0,b)|0;if(!b){k=j;i=d;return k|0}b=e+20|0;e=f&2147483647;f=0;do{h=KI(c[(c[b>>2]|0)+(f<<2)>>2]|0)|0;g=yI(j,4,f)|0;c[g>>2]=ML(c[h+64>>2]|0)|0;f=f+1|0}while((f|0)!=(e|0));k=j;i=d;return k|0}function $y(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;k=c[e+8>>2]|0;c[h>>2]=0;do if(!(b[k+28>>1]&16)){if(!f){if(!(HEi(c[k>>2]|0,3072840)|0)){l=k;m=f;break}else n=0;i=j;return n|0}if(!(vL(f,c[k+8>>2]|0)|0)){n=0;i=j;return n|0}h=uL(f,k)|0;if(!(a[(c[h+8>>2]|0)+145>>0]|0)){l=h;m=f}else{l=h;m=yL(f)|0}}else{l=k;m=f}while(0);if(!g)o=0;else o=sI(g)|0;if((o|0)!=(d[l+34>>0]|0)){n=0;i=j;return n|0}o=l+8|0;if((a[(c[o>>2]|0)+144>>0]|0)!=0?(HEi(c[l>>2]|0,3072840)|0)==0:0){f=sI(g)|0;k=i;i=i+((1*(f<<2)|0)+15&-16)|0;if((f|0)>0){h=0;do{c[k+(h<<2)>>2]=c[(c[(yI(g,4,h)|0)>>2]|0)+8>>2];h=h+1|0}while((h|0)!=(f|0))}h=c[o>>2]|0;o=d[h+144>>0]|0;if((o|0)==(f|0)){p=k;q=0}else{p=k+(o<<2)|0;q=k}n=wI(h,p,q)|0;i=j;return n|0}n=bM(l,m,g,0)|0;i=j;return n|0}function az(b){b=b|0;return (a[(c[b+8>>2]|0)+35>>0]|0)!=0|0}function bz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+192|0;f=e+168|0;g=e+24|0;h=e+12|0;j=e;k=c[b+8>>2]|0;if(!(a[k+35>>0]|0)){b=g+64|0;l=g+8|0;c[l>>2]=73864;m=g+12|0;c[g>>2]=74012;c[b>>2]=74032;c[g+4>>2]=0;esi(g+64|0,m);c[g+136>>2]=0;c[g+140>>2]=-1;c[g>>2]=73844;c[b>>2]=73884;c[l>>2]=73864;jsi(m);c[m>>2]=74048;l=g+44|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[g+60>>2]=24;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(m,f);xri(f);zN(h,m);if(!(a[h>>0]&1)){n=h+1|0;o=VJ(n)|0;FJ(o)}else{n=c[h+8>>2]|0;o=VJ(n)|0;FJ(o)}}o=sI(d)|0;c[j>>2]=0;n=j+4|0;c[n>>2]=0;h=j+8|0;c[h>>2]=0;if(o){m=xCi(o<<2)|0;c[j>>2]=m;c[n>>2]=m;c[h>>2]=m+(o<<2);m=0;do{f=(c[(yI(d,4,m)|0)>>2]|0)+8|0;g=c[n>>2]|0;if((g|0)==(c[h>>2]|0))SN(j,f);else{if(!g)p=0;else{c[g>>2]=c[f>>2];p=c[n>>2]|0}c[n>>2]=p+4}m=m+1|0}while(m>>>0<o>>>0)}o=CK(k,j)|0;if(!o)q=0;else q=NL(o,0)|0;o=c[j>>2]|0;if(!o){i=e;return q|0}j=c[n>>2]|0;if((j|0)!=(o|0))c[n>>2]=j+(~((j+-4-o|0)>>>2)<<2);ACi(o);i=e;return q|0}function cz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=b+8|0;g=c[f>>2]|0;if(a[g+35>>0]|0){h=b;i=d;return h|0}if(!(a[g+36>>0]|0)){h=0;i=d;return h|0}b=FK(g)|0;if(!(a[b+35>>0]|0)){h=0;i=d;return h|0}if(c[(DK(c[f>>2]|0)|0)>>2]|0){c[e>>2]=326080;gl(345824,e|0)|0}h=NL(b,0)|0;i=d;return h|0}function dz(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;f=c[a>>2]|0;c[b>>2]=ML(c[(c[f+8>>2]|0)+64>>2]|0)|0;a=c[f+12>>2]|0;if(a)c[b+4>>2]=ML(a)|0;c[b+8>>2]=e[f+28>>1];c[b+12>>2]=e[f+30>>1];i=d;return}function ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;a=c[b+16>>2]|0;if(!a)f=0;else f=GI(c[a+8>>2]|0)|0;a=RL(e,f)|0;i=d;return a|0}function fz(a){a=a|0;FJ(SJ(326128)|0);return 0}function gz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(d&8)){if(d&16)c[b>>2]=ML(c[(c[c[a+12>>2]>>2]|0)+64>>2]|0)|0}else c[b>>2]=ML(c[(c[a+8>>2]|0)+64>>2]|0)|0;if(d&32)c[b+4>>2]=qM(c[(c[a+12>>2]|0)+4>>2]|0)|0;if(d&1)c[b+16>>2]=c[(c[a+12>>2]|0)+16>>2];if(d&2){f=c[(c[a+12>>2]|0)+8>>2]|0;if(!f)g=0;else g=NL(f,c[a+8>>2]|0)|0;c[b+8>>2]=g}if(!(d&4)){i=e;return}d=c[(c[a+12>>2]|0)+12>>2]|0;if(!d)h=0;else h=NL(d,c[a+8>>2]|0)|0;c[b+12>>2]=h;i=e;return}function hz(a,b){a=a|0;b=b|0;FJ(SJ(326336)|0);return 0}function iz(a){a=a|0;FJ(SJ(326544)|0);return 0}function jz(a,b){a=a|0;b=b|0;FJ(SJ(326744)|0);return 0}function kz(a){a=a|0;FJ(SJ(326944)|0)}function lz(a,b){a=a|0;b=b|0;FJ(SJ(327152)|0);return 0}function mz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;FJ(SJ(327368)|0);return 0}function nz(a){a=a|0;FJ(SJ(327584)|0)}function oz(a,b){a=a|0;b=b|0;FJ(SJ(327792)|0)}function pz(a,b){a=a|0;b=b|0;FJ(SJ(328008)|0)}function qz(a,b){a=a|0;b=b|0;FJ(SJ(328224)|0)}function rz(a){a=a|0;FJ(SJ(328424)|0)}function sz(a,b){a=a|0;b=b|0;FJ(SJ(328656)|0);return 0}function tz(a){a=a|0;FJ(SJ(328864)|0)}function uz(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(329064)|0)}function vz(a,b){a=a|0;b=b|0;FJ(SJ(329272)|0)}function wz(a,b){a=a|0;b=b|0;FJ(SJ(329480)|0);return 0}function xz(a,b){a=a|0;b=b|0;FJ(SJ(329696)|0);return 0}function yz(a,b){a=a|0;b=b|0;FJ(SJ(329896)|0);return 0}function zz(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(330096)|0);return 0}function Az(a){a=a|0;FJ(SJ(330304)|0)}function Bz(a,b){a=a|0;b=b|0;FJ(SJ(330512)|0)}function Cz(a){a=a|0;FJ(SJ(330712)|0);return 0}function Dz(a){a=a|0;FJ(SJ(330928)|0);return 0}function Ez(a){a=a|0;FJ(SJ(331144)|0)}function Fz(a,b){a=a|0;b=b|0;FJ(SJ(331352)|0);return 0}function Gz(a,b){a=a|0;b=b|0;FJ(SJ(331560)|0);return 0}function Hz(a){a=a|0;FJ(SJ(331760)|0);return 0}function Iz(a,b){a=a|0;b=b|0;FJ(SJ(331968)|0)}function Jz(a){a=a|0;FJ(SJ(332176)|0)}function Kz(a){a=a|0;FJ(SJ(332384)|0)}function Lz(){return 12}function Mz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[d>>2]|0;d=c[b>>2]|0;g=rI(d)|0;h=cN(c[(c[d+44>>2]|0)+64>>2]|0)|0;do if(!(dN(h)|0)){if((c[h+4>>2]&16711680|0)==1114112){if(!(gN(h)|0))break;if(a[(gN(h)|0)+151>>0]|0)break}if(!(c[(c[f+4>>2]|0)+4>>2]&256))FJ(JJ(2905280,332640)|0);else{d=da(c[b+12>>2]|0,g)|0;j=lK(f)|0;YEi(yI(b,1,0)|0,j|0,d|0)|0;i=e;return}}while(0);FJ(JJ(3069216,332592)|0)}function Nz(a){a=a|0;FJ(SJ(332672)|0);return 0}function Oz(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(!d)FJ(KJ(332888)|0);else{lM(GI(d)|0);i=b;return}}function Pz(a){a=a|0;FJ(SJ(332904)|0)}function Qz(a){a=a|0;return 1}function Rz(a){a=a|0;var b=0;b=i;$s(a);i=b;return}function Sz(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;if((Zs(b)|0)!=3){e=-2;i=d;return e|0}f=_s(b)|0;b=c[f>>2]|0;if(!(a[b+144>>0]|0))g=(c[(c[b+64>>2]|0)+4>>2]&16711680|0)==917504?12:8;else g=16;e=f+g|0;i=d;return e|0}function Tz(a){a=a|0;var b=0,c=0;b=i;c=_s(a)|0;i=b;return c|0}function Uz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if((e|0)==3?(a[(c[b>>2]|0)+157>>0]|0)==0:0)FJ(JJ(0,333128)|0);g=at(b,d,e)|0;i=f;return g|0}function Vz(a){a=a|0;FJ(SJ(333184)|0);return 0}function Wz(a){a=a|0;var b=0,c=0;b=i;c=ZK(a)|0;i=b;return c|0}function Xz(a){a=a|0;var b=0,d=0;b=i;d=aL(c[a>>2]|0)|0;i=b;return d|0}function Yz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=xI(c[d>>2]|0)|0;h=yI(d,g,b)|0;YEi(h|0,c[a>>2]|0,da(g,e)|0)|0;i=f;return}function Zz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=xI(c[a>>2]|0)|0;h=c[d>>2]|0;YEi(h|0,yI(a,g,b)|0,da(g,e)|0)|0;i=f;return}function _z(a){a=a|0;FJ(SJ(333376)|0)}function $z(a){a=a|0;var b=0;b=i;$K(c[a>>2]|0);i=b;return}function aA(a){a=a|0;var b=0;b=i;cL(c[a>>2]|0);i=b;return}function bA(a){a=a|0;FJ(SJ(333568)|0);return 0}function cA(a,b){a=a|0;b=b|0;FJ(SJ(333760)|0);return 0}function dA(a){a=a|0;FJ(SJ(333944)|0);return 0}function eA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=GI(c[b+8>>2]|0)|0;b=FL(c[a>>2]|0,e)|0;i=d;return b|0}function fA(a){a=a|0;var b=0,c=0;b=i;c=EL(a)|0;i=b;return c|0}function gA(a){a=a|0;FJ(SJ(334152)|0);return 0}function hA(a){a=a|0;FJ(SJ(334360)|0);return 0}function iA(a){a=a|0;FJ(SJ(334568)|0);return 0}function jA(a){a=a|0;FJ(SJ(334760)|0);return 0}function kA(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a>>2]|0;if(!d)e=0;else e=qM(d)|0;i=b;return e|0}function lA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;if(!e)FJ(KJ(3069296)|0);else{a=rM(e,b)|0;i=d;return a|0}return 0}function mA(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a>>2]|0;if(!e){f=0;i=d;return f|0}if(!(b[e>>1]|0))g=0;else{a=0;h=e;while(1){h=h+2|0;j=a+1|0;if(!(b[h>>1]|0)){g=j;break}else a=j}}f=tM(e,g)|0;i=d;return f|0}function nA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;if(!e)FJ(KJ(3069296)|0);else{a=tM(e,b)|0;i=d;return a|0}return 0}function oA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b>>2]|0;if(!f){g=0;i=e;return g|0}if(!d)FJ(KJ(334952)|0);b=d+8|0;d=GI(c[b>>2]|0)|0;h=(c[(c[b>>2]|0)+4>>2]|0)>>>16&255;if((h|0)==14|(h|0)==29){j=ZJ(334968)|0;FJ(j)}else if((h|0)==18)k=5;if((k|0)==5?!(jJ(d)|0):0){j=ZJ(334968)|0;FJ(j)}if(c[d+108>>2]|0){j=qL(d)|0;if((h|0)==18){ko[c[(UI(d,3072840,0)|0)+4>>2]&4095](j);HL(f,j,d);g=j;i=e;return g|0}else{HL(f,yL(j)|0,d);g=j;i=e;return g|0}}j=d+124|0;if((c[j>>2]|0)!=-1){if((c[(c[b>>2]|0)+4>>2]&16711680|0)==65536)FJ(SJ(335024)|0);if(!(a[d+149>>0]|0)){b=qL(d)|0;h=yL(b)|0;YEi(h|0,f|0,c[j>>2]|0)|0;g=b;i=e;return g|0}}if(!(a[d+150>>0]|0))FJ(JJ(335080,335160)|0);else FJ(JJ(335080,335096)|0);return 0}function pA(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(335232)|0);return 0}function qA(b,d){b=b|0;d=d|0;return a[(c[b>>2]|0)+d>>0]|0}function rA(a,d){a=a|0;d=d|0;return b[(c[a>>2]|0)+d>>1]|0}function sA(a,b){a=a|0;b=b|0;return c[(c[a>>2]|0)+b>>2]|0}function tA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(c[a>>2]|0)+b|0;H=c[e+4>>2]|0;i=d;return c[e>>2]|0}function uA(a,b){a=a|0;b=b|0;return c[(c[a>>2]|0)+b>>2]|0}function vA(a){a=a|0;FJ(SJ(335432)|0);return 0}function wA(a){a=a|0;FJ(SJ(335624)|0);return 0}function xA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+4|0;if(!b)FJ(KJ(3068392)|0);h=b+8|0;b=GI(c[h>>2]|0)|0;j=c[b+124>>2]|0;if(((j|0)!=-1?(a[b+149>>0]|0)==0:0)?(c[(c[h>>2]|0)+4>>2]&16711680|0)!=917504:0){i=d;return j|0}if(a[b+150>>0]|0)FJ(JJ(3068392,335832)|0);aN(g,c[h>>2]|0,2);if(!(a[g>>0]&1))k=g+1|0;else k=c[g+8>>2]|0;c[e>>2]=k;jI(f,335872,e);xri(g);if(!(a[f>>0]&1)){l=f+1|0;m=JJ(0,l)|0;FJ(m)}else{l=c[f+8>>2]|0;m=JJ(0,l)|0;FJ(m)}return 0}function yA(a){a=a|0;FJ(SJ(335976)|0);return 0}function zA(a){a=a|0;var b=0,c=0,d=0,e=0;b=i;if(!a){c=0;i=b;return c|0}d=nM(a)|0;e=oM(a)|0;a=aL((d<<1)+2|0)|0;nCi(a,e)|0;c=a;i=b;return c|0}function AA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;if(!b){f=0;i=d;return f|0}kI(e,oM(b)|0);b=a[e>>0]|0;if(!(b&1))g=(b&255)>>>1;else g=c[e+4>>2]|0;b=aL(g+1|0)|0;if(!(a[e>>0]&1))h=e+1|0;else h=c[e+8>>2]|0;bFi(b|0,h|0)|0;xri(e);f=b;i=d;return f|0}function BA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(!b)FJ(KJ(335080)|0);g=c[d>>2]|0;if(!g)FJ(KJ(3069296)|0);d=c[b>>2]|0;if(c[d+104>>2]|0){if(e)IL(g,d)|0;if((c[(c[d+64>>2]|0)+4>>2]&16711680|0)==1179648)h=b;else h=yL(b)|0;GL(h,g,d);i=f;return}h=d+124|0;if(((c[h>>2]|0)!=-1?(a[d+149>>0]|0)==0:0)?(c[(c[d+64>>2]|0)+4>>2]&16711680|0)!=917504:0){e=yL(b)|0;YEi(g|0,e|0,c[h>>2]|0)|0;i=f;return}if(!(a[d+150>>0]|0)){j=JJ(335080,335160)|0;FJ(j)}else{j=JJ(335080,335096)|0;FJ(j)}}function CA(b,d,e){b=b|0;d=d|0;e=e|0;a[(c[b>>2]|0)+d>>0]=e;return}function DA(a,d,e){a=a|0;d=d|0;e=e|0;b[(c[a>>2]|0)+d>>1]=e;return}function EA(a,b,d){a=a|0;b=b|0;d=d|0;c[(c[a>>2]|0)+b>>2]=d;return}function FA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=(c[a>>2]|0)+b|0;c[f>>2]=d;c[f+4>>2]=e;return}function GA(a,b,d){a=a|0;b=b|0;d=d|0;c[(c[a>>2]|0)+b>>2]=c[d>>2];return}function HA(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b>>2]|0;if(!f)FJ(KJ(3069296)|0);if(!d)FJ(KJ(334952)|0);b=d+8|0;d=GI(c[b>>2]|0)|0;if(IL(f,d)|0){i=e;return}if(a[d+150>>0]|0)FJ(JJ(334952,336168)|0);if(a[d+156>>0]|0){i=e;return}if((c[(c[b>>2]|0)+4>>2]&16646144|0)==131072){i=e;return}else FJ(JJ(334952,336232)|0)}function IA(){var a=0,b=0;a=i;b=NK()|0;i=a;return b|0}function JA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=i;i=i+224|0;f=e+204|0;g=e+192|0;h=e+48|0;j=e+32|0;k=e+8|0;l=e;kI(g,d+12|0);d=GI(c[b+8>>2]|0)|0;if(!(a[g>>0]&1))m=g+1|0;else m=c[g+8>>2]|0;b=PI(d,m)|0;if((b|0)!=0?((bK(b)|0)&16|0)==0:0){c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;if(d){b=k+16|0;m=k+4|0;n=k+8|0;o=k+20|0;p=0;q=d;while(1){if(!p){XN(k);r=c[b>>2]|0}else r=p;s=c[m>>2]|0;t=r>>>10;u=c[s+(t<<2)>>2]|0;if((c[n>>2]|0)==(s|0))v=0;else v=u+((r&1023)<<2)|0;if((v|0)==(u|0))w=(c[s+(t+-1<<2)>>2]|0)+4096|0;else w=v;c[w+-4>>2]=q;t=r+-1|0;c[b>>2]=t;c[o>>2]=(c[o>>2]|0)+1;q=c[q+32>>2]|0;if(!q){x=t;break}else p=t}p=c[m>>2]|0;q=p+(x>>>10<<2)|0;if((c[n>>2]|0)==(p|0)){y=0;z=b;A=n;B=m;C=q}else{y=(c[q>>2]|0)+((x&1023)<<2)|0;z=b;A=n;B=m;C=q}}else{y=0;z=k+16|0;A=k+8|0;B=k+4|0;C=0}q=k+20|0;m=y;y=C;C=0;n=0;a:while(1){b=m;x=C;p=n;while(1){o=(c[z>>2]|0)+(c[q>>2]|0)|0;r=c[B>>2]|0;w=r+(o>>>10<<2)|0;if((c[A>>2]|0)==(r|0))D=0;else D=(c[w>>2]|0)+((o&1023)<<2)|0;if(y>>>0>=w>>>0?!((y|0)==(w|0)&b>>>0<D>>>0):0){E=x;F=42;break a}w=c[b>>2]|0;c[l>>2]=0;o=x;r=p;b:while(1){while(1){v=OI(w,l)|0;if(!v){G=o;H=r;break b}if(!((bK(v)|0)&16)){I=v;break}}do if(r){v=c[r+4>>2]|0;if((c[v+4>>2]&16711680|0)==1114112){J=(c[(GI(v)|0)+124>>2]|0)+o|0;break}else{J=(c[I+12>>2]|0)+o-(c[r+12>>2]|0)|0;break}}else J=o;while(0);if(!(Ori(g,$J(I)|0)|0)){E=J;F=42;break a}else{o=J;r=I}}b=b+4|0;if((b-(c[y>>2]|0)|0)==4096){K=G;L=H;break}else{x=G;p=H}}p=y+4|0;m=c[p>>2]|0;y=p;C=K;n=L}if((F|0)==42){YN(k);xri(g);i=e;return E|0}}E=h+64|0;e=h+8|0;c[e>>2]=73864;k=h+12|0;c[h>>2]=74012;c[E>>2]=74032;c[h+4>>2]=0;esi(h+64|0,k);c[h+136>>2]=0;c[h+140>>2]=-1;c[h>>2]=73844;c[E>>2]=73884;c[e>>2]=73864;jsi(k);c[k>>2]=74048;e=h+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[h+60>>2]=24;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(k,f);xri(f);f=uN(h+8|0,336304,7)|0;h=a[g>>0]|0;if(!(h&1)){M=g+1|0;N=(h&255)>>>1}else{M=c[g+8>>2]|0;N=c[g+4>>2]|0}g=uN(uN(f,M,N)|0,336312,41)|0;N=c[d+8>>2]|0;uN(uN(g,N,SEi(N|0)|0)|0,659600,1)|0;zN(j,k);if(!(a[j>>0]&1)){O=j+1|0;P=JJ(336360,O)|0;FJ(P)}else{O=c[j+8>>2]|0;P=JJ(336360,O)|0;FJ(P)}return 0}function KA(a){a=a|0;FJ(SJ(336376)|0)}function LA(a){a=a|0;FJ(SJ(336576)|0)}function MA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_K(c[a>>2]|0,b)|0;i=d;return e|0}function NA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;if(!e)GJ();else{a=bL(e,c[b>>2]|0)|0;i=d;return a|0}return 0}function OA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=yI(a,xI(c[a>>2]|0)|0,b)|0;i=d;return e|0}function PA(a,b){a=a|0;b=b|0;FJ(SJ(336776)|0);return 0}function QA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;FJ(SJ(336992)|0);return 0}function RA(a){a=a|0;FJ(SJ(337208)|0);return 0}function SA(a,b){a=a|0;b=b|0;FJ(SJ(337424)|0)}function TA(a){a=a|0;FJ(SJ(337664)|0);return 0}function UA(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(337912)|0)}function VA(a,b){a=a|0;b=b|0;FJ(SJ(338136)|0);return 0}function WA(a){a=a|0;FJ(SJ(338360)|0);return 0}function XA(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=338776;gl(345824,b|0)|0;i=a;return 0}function YA(a){a=a|0;FJ(SJ(338576)|0);return 0}function ZA(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=338776;gl(345824,b|0)|0;i=a;return 0}function _A(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=338824;gl(345824,b|0)|0;i=d;return 0}function $A(){return 0}function aB(a){a=a|0;FJ(SJ(338864)|0)}function bB(a){a=a|0;FJ(SJ(339080)|0)}function cB(a){a=a|0;return}function dB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=$q(b)|0;f=yI(b,1,0)|0;b=c[a>>2]|0;if(CG(b,e,f)|0){g=b;i=d;return g|0}b=zG()|0;c[a>>2]=b;if(CG(b,e,f)|0){g=b;i=d;return g|0}g=0;i=d;return g|0}function eB(a){a=a|0;var b=0,c=0,d=0,e=0;b=i;c=zG()|0;if(!((c|0)!=0&(a|0)!=0)){i=b;return c|0}d=$q(a)|0;e=yI(a,1,0)|0;a=ADi(d)|0;if(!a){i=b;return c|0}YEi(a|0,e|0,d|0)|0;CG(c,d,a)|0;BDi(a);i=b;return c|0}function fB(){var a=0,b=0;a=i;b=AG()|0;i=a;return b|0}function gB(a){a=a|0;FJ(SJ(339288)|0);return 0}function hB(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=339488;gl(345824,b|0)|0;i=a;return 0}function iB(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=339520;gl(345824,b|0)|0;i=a;return 0}function jB(a){a=a|0;FJ(SJ(339560)|0);return 0}function kB(a){a=a|0;FJ(SJ(339768)|0);return 0}function lB(a){a=a|0;FJ(SJ(339976)|0);return 0}function mB(a){a=a|0;FJ(SJ(340208)|0);return 0}function nB(a){a=a|0;FJ(SJ(340448)|0);return 0}function oB(){FJ(SJ(340688)|0);return 0}function pB(a,b){a=a|0;b=b|0;FJ(SJ(340920)|0);return 0}function qB(a,b){a=a|0;b=b|0;FJ(SJ(341136)|0);return 0}function rB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+32|0;e=d+12|0;f=d;g=c[b>>2]|0;c[b>>2]=-1;IG(e);sri(f,e);h=a[f>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[f+4>>2]|0;a:do if(!j){k=0;l=0;m=1}else{n=f+1|0;o=f+8|0;p=h;q=0;while(1){r=((p&1)==0?n:c[o>>2]|0)+q|0;if((OBi(a[r>>0]|0)|0)!=0?(NBi(a[r>>0]|0)|0)!=0:0){s=(IDi(a[r>>0]|0)|0)&255;a[r>>0]=s;t=s}else t=a[r>>0]|0;if(t<<24>>24==45)a[r>>0]=95;r=q+1|0;if(r>>>0>=j>>>0){k=0;l=0;m=1;break a}p=a[f>>0]|0;q=r}}while(0);b:while(1){j=l;t=m;while(1){if(t>>>0<7>>>0){u=j;v=t;break}if(!(Ori(f,t)|0)){w=k;x=18;break b}h=j+1|0;if((h|0)==36)break b;else{j=h;t=c[341360+(h<<2)>>2]|0}}t=u+1|0;if((t|0)==36)break;else{k=v;l=t;m=c[341360+(t<<2)>>2]|0}}if((x|0)==18)c[b>>2]=w;w=a[f>>0]|0;if(!(w&1)){y=(w&255)>>>1;z=f+1|0}else{y=c[f+4>>2]|0;z=c[f+8>>2]|0}c:do if((y>>>0>=5?(w=z+y|0,x=z,(y|0)>=5):0)?(m=y+-4|0,l=z+m|0,(m|0)!=0):0){m=z;d:while(1){if((a[m>>0]|0)==117){v=m;k=341512;do{k=k+1|0;if((k|0)==341517){A=m;break d}v=v+1|0}while((a[v>>0]|0)==(a[k>>0]|0))}m=m+1|0;if((m|0)==(l|0))break c}if((A|0)!=(w|0)?(A-x|0)!=-1:0)c[b>>2]=c[b>>2]|268435456}while(0);if(!g){B=0;xri(f);xri(e);i=d;return B|0}if((c[b>>2]|0)!=-1){B=0;xri(f);xri(e);i=d;return B|0}if(!(a[e>>0]&1))C=e+1|0;else C=c[e+8>>2]|0;B=sM(C)|0;xri(f);xri(e);i=d;return B|0}function sB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a>>2]|0;if((c[a>>2]|0)!=(d|0)){i=e;return f|0}c[a>>2]=b;i=e;return f|0}function tB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a>>2]|0;if((c[a>>2]|0)!=(c[d>>2]|0)){i=e;return f|0}c[a>>2]=c[b>>2];i=e;return f|0}function uB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a>>2]|0;if((c[a>>2]|0)!=(d|0)){i=e;return f|0}c[a>>2]=b;i=e;return f|0}function vB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=a;j=c[h>>2]|0;k=c[h+4>>2]|0;h=a;if(!((c[h>>2]|0)==(e|0)?(c[h+4>>2]|0)==(f|0):0)){H=k;i=g;return j|0}f=a;c[f>>2]=b;c[f+4>>2]=d;H=k;i=g;return j|0}function wB(a,b){a=a|0;b=b|0;c[a>>2]=(c[a>>2]|0)+b;return c[a>>2]|0}function xB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a;g=_Ei(c[f>>2]|0,c[f+4>>2]|0,b|0,d|0)|0;d=a;c[d>>2]=g;c[d+4>>2]=H;d=a;H=c[d+4>>2]|0;i=e;return c[d>>2]|0}function yB(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,l=0.0,m=0;e=i;h[k>>3]=d;f=a;g=c[f>>2]|0;j=c[f+4>>2]|0;f=a;if(!((c[f>>2]|0)==(c[k>>2]|0)?(c[f+4>>2]|0)==(c[k+4>>2]|0):0)){c[k>>2]=g;c[k+4>>2]=j;l=+h[k>>3];i=e;return +l}h[k>>3]=b;f=c[k+4>>2]|0;m=a;c[m>>2]=c[k>>2];c[m+4>>2]=f;c[k>>2]=g;c[k+4>>2]=j;l=+h[k>>3];i=e;return +l}function zB(a,b,d){a=a|0;b=ea(b);d=ea(d);var e=0,f=0;e=i;f=c[a>>2]|0;if((c[a>>2]|0)==((g[k>>2]=d,c[k>>2]|0)|0))g[a>>2]=b;b=(c[k>>2]=f,ea(g[k>>2]));i=e;return ea(b)}function AB(a){a=a|0;var b=0;b=(c[a>>2]|0)+1|0;c[a>>2]=b;return b|0}function BB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a;e=_Ei(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;d=H;f=a;c[f>>2]=e;c[f+4>>2]=d;H=d;i=b;return e|0}function CB(a){a=a|0;var b=0;b=(c[a>>2]|0)+-1|0;c[a>>2]=b;return b|0}function DB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a;e=_Ei(c[d>>2]|0,c[d+4>>2]|0,-1,-1)|0;d=H;f=a;c[f>>2]=e;c[f+4>>2]=d;H=d;i=b;return e|0}function EB(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;h[k>>3]=b;e=c[k+4>>2]|0;f=a;g=c[f>>2]|0;j=c[f+4>>2]|0;f=a;c[f>>2]=c[k>>2];c[f+4>>2]=e;c[k>>2]=g;c[k+4>>2]=j;b=+h[k>>3];i=d;return +b}function FB(a,b){a=a|0;b=b|0;var d=0;d=c[a>>2]|0;c[a>>2]=b;return d|0}function GB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a;g=c[f>>2]|0;h=c[f+4>>2]|0;f=a;c[f>>2]=b;c[f+4>>2]=d;H=h;i=e;return g|0}function HB(a,b){a=a|0;b=b|0;var d=0;d=c[a>>2]|0;c[a>>2]=b;return d|0}function IB(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a>>2]|0;g[a>>2]=b;b=(c[k>>2]=e,ea(g[k>>2]));i=d;return ea(b)}function JB(a){a=a|0;var b=0,d=0;b=i;d=a;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function KB(a){a=a|0;var b=0;b=i;if(!a)FJ(KJ(3142024)|0);else{ZN(a,-1)|0;i=b;return}}function LB(a){a=a|0;var b=0;b=i;if(!a)FJ(KJ(3142024)|0);else{_N(a);i=b;return}}function MB(a){a=a|0;var b=0,d=0,e=0;b=i;if(!a)FJ(KJ(3142024)|0);d=c[a+4>>2]|0;if(!d){e=0;i=b;return e|0}a=d+8|0;e=(c[a>>2]|0)!=0|(c[a+4>>2]|0)!=0;i=b;return e|0}function NB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if(!a)FJ(KJ(3142024)|0);d=a+4|0;c[d>>2]=c[d>>2];a=c[d>>2]|0;d=a;if(!a)FJ(YJ(342040)|0);a=FF()|0;e=d+8|0;if(!((c[e>>2]|0)==(a|0)?(c[e+4>>2]|0)==(H|0):0))FJ(YJ(342064)|0);e=d+32|0;d=c[e>>2]|0;if(!d){i=b;return}a=d+4|0;f=c[e>>2]|0;if((c[e>>2]|0)==(d|0))c[e>>2]=c[a>>2];if((f|0)==(d|0))c[a>>2]=0;vE(d+8|0)|0;i=b;return}function OB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if(!a)FJ(KJ(3142024)|0);d=a+4|0;c[d>>2]=c[d>>2];a=c[d>>2]|0;d=a;if(!a)FJ(YJ(342040)|0);a=FF()|0;e=d+8|0;if(!((c[e>>2]|0)==(a|0)?(c[e+4>>2]|0)==(H|0):0))FJ(YJ(342064)|0);e=d+32|0;d=c[e>>2]|0;if(!d){i=b;return}else f=d;do{d=f+4|0;a=c[e>>2]|0;if((c[e>>2]|0)==(f|0))c[e>>2]=c[d>>2];if((a|0)==(f|0))c[d>>2]=0;vE(f+8|0)|0;f=c[e>>2]|0}while((f|0)!=0);i=b;return}function PB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;if(!a)FJ(KJ(3142024)|0);e=a+4|0;c[e>>2]=c[e>>2];f=c[e>>2]|0;g=f;if(!f)FJ(YJ(342040)|0);f=FF()|0;h=g+8|0;if(!((c[h>>2]|0)==(f|0)?(c[h+4>>2]|0)==(H|0):0))FJ(YJ(342064)|0);h=g+16|0;f=c[h>>2]|0;c[h>>2]=1;if(!b){_N(a);j=0;k=0}else{h=0;while(1){l=c[85498]|0;if(!l){m=15;break}n=c[85498]|0;if((c[85498]|0)==(l|0))c[85498]=c[l>>2];h=h+1|0;if((n|0)==(l|0)){o=l;m=14;break}if((h|0)>=5){m=15;break}}if((m|0)==14)p=o;else if((m|0)==15){o=xCi(16)|0;c[o>>2]=0;c[o+4>>2]=0;tE(o+8|0,0,0);c[o+12>>2]=0;p=o}c[p+12>>2]=1;o=g+32|0;g=p+4|0;h=c[o>>2]|0;while(1){c[g>>2]=h;l=c[o>>2]|0;n=c[o>>2]|0;if((n|0)==(h|0)){c[o>>2]=p;q=p}else q=n;if((l|0)==(h|0))break;else h=q}_N(a);q=zM()|0;HM(q,32);h=yE(p+8|0,b,1)|0;JM(q,32);j=h;k=p}ZN(a,-1)|0;a=c[e>>2]|0;c[a+16>>2]=f;if(k){f=a+32|0;a=k+4|0;e=c[f>>2]|0;a:while(1){if(!e)break;else{r=e;s=0}while(1){if((r|0)==(k|0)){t=s;break}p=c[r+4>>2]|0;if(!p)break a;else{h=r;r=p;s=h}}h=c[a>>2]|0;if(t){u=h;v=t;m=27;break}p=c[f>>2]|0;q=c[f>>2]|0;if((q|0)==(k|0)){c[f>>2]=h;w=h}else w=q;if((p|0)==(k|0)){m=31;break}else e=w}if((m|0)==27){c[v+4>>2]=u;m=31}if((m|0)==31)c[a>>2]=0;c[k+12>>2]=0;wE(k+8|0)|0;do{a=c[85498]|0;c[k>>2]=a;m=c[85498]|0;if((c[85498]|0)==(a|0))c[85498]=k}while((m|0)!=(a|0))}if(!0){i=d;return (j|0)!=2|0}else FJ(0);return 0}function QB(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(!a)FJ(KJ(3142024)|0);else{d=ZN(a,b)|0;i=c;return d|0}return 0}function RB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;a[e>>0]=1;if(d)FJ(SJ(342112)|0);d=xCi(4)|0;AE(d,0);if(b)BE(d,0);b=xCi(8)|0;c[b>>2]=342336;c[b+4>>2]=d;i=f;return b|0}function SB(a){a=a|0;var b=0;b=i;EE(c[(c[a>>2]|0)+4>>2]|0);i=b;return 1}function TB(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=342296;gl(345824,b|0)|0;i=d;return 0}function UB(a){a=a|0;var b=0,d=0;b=i;d=(wE(c[(c[a>>2]|0)+4>>2]|0)|0)==0;i=b;return d|0}function VB(a){a=a|0;var b=0,d=0;b=i;d=(vE(c[(c[a>>2]|0)+4>>2]|0)|0)==0;i=b;return d|0}function WB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;a[f>>0]=1;if(!e){e=xCi(4)|0;tE(e,b,d);d=xCi(8)|0;c[d>>2]=342616;c[d+4>>2]=e;i=g;return d|0}else FJ(SJ(342360)|0);return 0}function XB(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}ko[c[(c[d>>2]|0)+4>>2]&4095](d);i=b;return}function YB(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=342568;gl(345824,b|0)|0;i=d;return 0}function ZB(a,b){a=a|0;b=b|0;var c=0;c=i;JM(a,b);i=c;return}function _B(){var a=0,b=0;a=i;b=zM()|0;i=a;return b|0}function $B(){var a=0,b=0;a=i;b=c[(AJ()|0)+12>>2]|0;i=a;return b|0}function aC(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+108>>2]|0;BE(d,0);e=c[a+36>>2]|0;EE(d);i=b;return e|0}function bC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;if(!((IM(a)|0)&8)){e=zM()|0;f=c[e+108>>2]|0;BE(f,0);HM(e,32);EE(f);f=CF(c[a+12>>2]|0,b)|0;JM(e,32);i=d;return (f|0)==0|0}else FJ(XJ()|0);return 0}function cC(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+108>>2]|0;BE(e,0);HM(a,b);EE(e);i=d;return}function dC(){FJ(SJ(342640)|0)}function eC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+108>>2]|0;BE(d,0);e=c[a+32>>2]|0;if(!e)f=0;else f=tM(c[a+28>>2]|0,e)|0;EE(d);i=b;return f|0}function fC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[a+108>>2]|0;BE(f,0);g=a+32|0;if(c[g>>2]|0)FJ(VJ(342912)|0);c[g>>2]=nM(b)|0;h=oM(b)|0;b=mI(h,c[g>>2]|0)|0;c[a+28>>2]=b;g=a+12|0;if(!(c[g>>2]|0)){EE(f);i=d;return}kI(e,b);zF(c[g>>2]|0,e);xri(e);EE(f);i=d;return}function gC(a){a=a|0;var b=0,d=0,e=0;b=i;d=zM()|0;e=c[d+108>>2]|0;BE(e,0);HM(d,32);EE(e);EF(a);JM(d,32);i=b;return}function hC(a){a=a|0;var b=0;b=i;AM(a);i=b;return}function iC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+108>>2]|0;BE(e,0);f=Ks(20,0)|0;c[f>>2]=a;c[f+4>>2]=AJ()|0;c[f+8>>2]=b;c[f+12>>2]=c[a+84>>2];b=xCi(4)|0;FE(b,0,1);g=f+16|0;c[g>>2]=b;b=xCi(8)|0;vF(b);BF(b,3444,f)|0;f=a+12|0;c[f>>2]=b;b=a+36|0;c[b>>2]=c[b>>2]&-9;HE(c[g>>2]|0,1,0)|0;g=c[f>>2]|0;EE(e);i=d;return g|0}function jC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+108|0;f=c[e>>2]|0;if(f){CE(f);ACi(f)}c[e>>2]=0;BDi(c[a+28>>2]|0);a=c[b>>2]|0;if(!a){i=d;return}wF(a);ACi(a);i=d;return}function kC(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=342952;gl(345824,a|0)|0;i=b;return}function lC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+16|0;a=c[d>>2]|0;a:do if(a){e=c[(yI(a,4,0)|0)>>2]|0;if(!e){f=0;while(1){if((f|0)>=3){g=0;break a}f=f+1|0;h=c[(yI(c[d>>2]|0,4,f)|0)>>2]|0;if(h){g=h;break}}}else g=e}else g=0;while(0);i=b;return g|0}function mC(a,b){a=a|0;b=b|0;var c=0;c=i;aO(a,b,0);i=c;return}function nC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+16|0;a=c[d>>2]|0;a:do if(a){e=c[(yI(a,4,4)|0)>>2]|0;if(!e){f=4;while(1){if((f|0)>=7){g=0;break a}f=f+1|0;h=c[(yI(c[d>>2]|0,4,f)|0)>>2]|0;if(h){g=h;break}}}else g=e}else g=0;while(0);i=b;return g|0}function oC(a,b){a=a|0;b=b|0;var c=0;c=i;aO(a,b,4);i=c;return}function pC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+108>>2]|0;BE(d,0);e=a+112|0;f=a+116|0;if(!(c[e>>2]|0)){g=0;EE(d);i=b;return g|0}a=uI(c[101524]|0,c[f>>2]|0)|0;h=yI(a,1,0)|0;YEi(h|0,c[e>>2]|0,c[f>>2]|0)|0;g=a;EE(d);i=b;return g|0}function qC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+108>>2]|0;BE(e,0);f=a+112|0;g=c[f>>2]|0;if(g)ACi(g);g=tI(b)|0;h=zCi((g|0)>-1?g:-1)|0;c[f>>2]=h;c[a+116>>2]=g;YEi(h|0,yI(b,1,0)|0,g|0)|0;EE(e);i=d;return}function rC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+108>>2]|0;BE(d,0);e=a+120|0;f=a+124|0;if(!(c[e>>2]|0)){g=0;EE(d);i=b;return g|0}a=uI(c[101524]|0,c[f>>2]|0)|0;h=yI(a,1,0)|0;YEi(h|0,c[e>>2]|0,c[f>>2]|0)|0;g=a;EE(d);i=b;return g|0}function sC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+108>>2]|0;BE(e,0);f=a+120|0;g=c[f>>2]|0;if(g)ACi(g);g=tI(b)|0;h=zCi((g|0)>-1?g:-1)|0;c[f>>2]=h;c[a+124>>2]=g;YEi(h|0,yI(b,1,0)|0,g|0)|0;EE(e);i=d;return}function tC(){var a=0;a=(c[85746]|0)+1|0;c[85746]=a;return a|0}function uC(a,b){a=a|0;b=b|0;FJ(SJ(342992)|0)}function vC(a){a=a|0;FJ(SJ(343264)|0);return 0}function wC(a){a=a|0;var b=0;b=i;DM(a);i=b;return}function xC(){return}function yC(a){a=a|0;FJ(SJ(343544)|0)}function zC(){return}function AC(a){a=a|0;FJ(SJ(343752)|0)}function BC(b){b=b|0;return a[b>>0]|0}function CC(a){a=a|0;return b[a>>1]|0}function DC(a){a=a|0;return c[a>>2]|0}function EC(a){a=a|0;var b=0,d=0;b=i;d=a;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function FC(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function GC(a){a=a|0;return +(+h[a>>3])}function HC(a){a=a|0;return c[a>>2]|0}function IC(b,c){b=b|0;c=c|0;a[b>>0]=c;return}function JC(a,c){a=a|0;c=c|0;b[a>>1]=c;return}function KC(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function LC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=b;c[e+4>>2]=d;return}function MC(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function NC(a,b){a=a|0;b=+b;h[a>>3]=b;return}function OC(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function PC(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=343960;gl(345824,a|0)|0;i=b;return}function QC(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=343992;gl(345824,a|0)|0;i=b;return}function RC(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344024;gl(345824,a|0)|0;i=b;return 0}function SC(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344056;gl(345824,a|0)|0;i=b;return 0}function TC(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344088;gl(345824,a|0)|0;i=b;return}function UC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;g=sI(b)|0;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=(g|0)==0;if(k){i=d;return}if(g>>>0>1073741823)vxi(a);l=xCi(g<<2)|0;c[h>>2]=l;c[a>>2]=l;c[j>>2]=l+(g<<2);j=g;m=l;do{c[m>>2]=0;m=(c[h>>2]|0)+4|0;c[h>>2]=m;j=j+-1|0}while((j|0)!=0);if(k){i=d;return}k=0;do{j=c[(yI(b,4,k)|0)>>2]|0;m=c[86030]|0;h=c[86032]|0;if((m|0)!=0|(h|0)!=0){n=m;o=h}else{c[86030]=PI(c[101545]|0,344136)|0;h=PI(c[101545]|0,3019352)|0;c[86032]=h;n=c[86030]|0;o=h}if(!n){dK(j,o,f);h=c[(c[f>>2]|0)+8>>2]|0;c[e>>2]=h;p=h}else{dK(j,n,e);p=c[e>>2]|0}c[(c[a>>2]|0)+(k<<2)>>2]=p;k=k+1|0}while(k>>>0<g>>>0);i=d;return}function VC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;UC(e,a);a=zM()|0;HM(a,32);a:do if((b|0)>=-1){f=e+4|0;if((b|0)==-1)while(1){g=c[e>>2]|0;h=(c[f>>2]|0)-g>>2;b:do if(h){j=g;k=0;while(1){l=c[j+(k<<2)>>2]|0;m=k+1|0;if(_n[c[(c[l>>2]|0)+12>>2]&4095](l,0)|0){n=k;break a}if(m>>>0>=h>>>0)break b;j=c[e>>2]|0;k=m}}while(0);EF(10)}else{h=0;while(1){g=c[e>>2]|0;k=(c[f>>2]|0)-g>>2;c:do if(k){j=g;m=0;while(1){l=c[j+(m<<2)>>2]|0;o=m+1|0;if(_n[c[(c[l>>2]|0)+12>>2]&4095](l,0)|0){n=m;break a}if(o>>>0>=k>>>0)break c;j=c[e>>2]|0;m=o}}while(0);EF(10);h=h+10|0;if((h|0)>(b|0)){n=258;break}}}}else n=258;while(0);JM(a,32);a=c[e>>2]|0;if(!a){i=d;return n|0}b=e+4|0;e=c[b>>2]|0;if((e|0)!=(a|0))c[b>>2]=e+(~((e+-4-a|0)>>>2)<<2);ACi(a);i=d;return n|0}function WC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;e=i;a=c[b>>2]|0;b=zM()|0;HM(b,32);NM();if((d|0)==-1){f=mo[c[(c[a>>2]|0)+8>>2]&4095](a)|0;JM(b,32);i=e;return f|0}else{f=_n[c[(c[a>>2]|0)+12>>2]&4095](a,d)|0;JM(b,32);i=e;return f|0}return 0}function XC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;i=i+32|0;e=d+12|0;f=d;UC(e,a);a=zM()|0;HM(a,32);g=(b|0)!=-1;h=e+4|0;j=f+4|0;k=f+8|0;l=0;while(1){if(g&(l|0)>(b|0)){m=0;break}n=c[e>>2]|0;o=(c[h>>2]|0)-n>>2;c[f>>2]=0;c[j>>2]=0;c[k>>2]=0;if(!o){p=0;q=0}else{r=n;n=0;while(1){s=c[r+(n<<2)>>2]|0;do if(_n[c[(c[s>>2]|0)+12>>2]&4095](s,0)|0){t=(c[e>>2]|0)+(n<<2)|0;u=c[j>>2]|0;if((u|0)==(c[k>>2]|0)){bO(f,t);break}if(!u)v=0;else{c[u>>2]=c[t>>2];v=c[j>>2]|0}c[j>>2]=v+4}while(0);s=n+1|0;if(s>>>0>=o>>>0)break;r=c[e>>2]|0;n=s}p=c[j>>2]|0;q=c[f>>2]|0}if((p-q>>2|0)==(o|0)){w=1;x=q;y=l}else{if((p|0)!=(q|0)){n=q;r=c[h>>2]|0;s=0;while(1){t=c[e>>2]|0;u=n+(s<<2)|0;a:do if((t|0)!=(r|0)){z=c[u>>2]|0;A=t;while(1){if((c[A>>2]|0)==(z|0)){B=A;break}A=A+4|0;if((A|0)==(r|0)){C=r;break a}}if((B|0)!=(r|0)){A=B+4|0;if((A|0)==(r|0)){D=B;E=t;F=r}else{z=A;A=B;G=B;while(1){H=c[z>>2]|0;if((H|0)==(c[u>>2]|0))I=A;else{c[A>>2]=H;I=A+4|0}H=G+8|0;if((H|0)==(r|0)){J=I;break}else{K=z;z=H;A=I;G=K}}D=J;E=c[e>>2]|0;F=c[h>>2]|0}G=D;A=G-E>>2;if((D|0)!=(F|0)){z=F;K=E+(A+(z-G>>2)<<2)|0;G=z-K|0;aFi(E+(A<<2)|0,K|0,G|0)|0;K=E+((G>>2)+A<<2)|0;A=c[h>>2]|0;if((A|0)==(K|0))C=K;else{G=A+(~((A+-4-K|0)>>>2)<<2)|0;c[h>>2]=G;C=G}}else C=F}else C=r}else C=r;while(0);s=s+1|0;n=c[f>>2]|0;if(s>>>0>=(c[j>>2]|0)-n>>2>>>0)break;else r=C}}EF(10);w=0;x=c[f>>2]|0;y=l+10|0}if(x){r=c[j>>2]|0;if((r|0)!=(x|0))c[j>>2]=r+(~((r+-4-x|0)>>>2)<<2);ACi(x)}if(!w)l=y;else{m=1;break}}JM(a,32);a=c[e>>2]|0;if(!a){i=d;return m|0}e=c[h>>2]|0;if((e|0)!=(a|0))c[h>>2]=e+(~((e+-4-a|0)>>>2)<<2);ACi(a);i=d;return m|0}function YC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=c[a>>2]|0;ko[c[(c[f>>2]|0)+16>>2]&4095](f);f=c[b>>2]|0;b=zM()|0;HM(b,32);NM();if((d|0)==-1){g=mo[c[(c[f>>2]|0)+8>>2]&4095](f)|0;JM(b,32);i=e;return g|0}else{g=_n[c[(c[f>>2]|0)+12>>2]&4095](f,d)|0;JM(b,32);i=e;return g|0}return 0}function ZC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+4|0;zE(f,b);h=a[f>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[f+4>>2]|0;if(!j){c[e>>2]=b;jI(g,344152,e);yri(f,g)|0;xri(g);k=a[f>>0]|0}else k=h;if(!(k&1)){l=f+1|0;m=qM(l)|0;xri(f);i=d;return m|0}else{l=c[f+8>>2]|0;m=qM(l)|0;xri(f);i=d;return m|0}return 0}function _C(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=344224;gl(345824,b|0)|0;i=a;return 0}function $C(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=344272;gl(345824,b|0)|0;i=a;return 0}function aD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=344312;gl(345824,b|0)|0;i=a;return}function bD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344360;gl(345824,a|0)|0;i=b;return}function cD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=i;i=i+16|0;f=g;c[f>>2]=344408;gl(345824,f|0)|0;i=g;return 0}function dD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=344440;gl(345824,b|0)|0;i=d;return 0}function eD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[d>>2]=344472;gl(345824,d|0)|0;H=0;i=e;return 0}function fD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=344504;gl(345824,b|0)|0;i=a;return}function gD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=344536;gl(345824,b|0)|0;i=a;return 0}function hD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344584;gl(345824,a|0)|0;i=b;return 0}function iD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=344640;gl(345824,b|0)|0;i=d;return 0}function jD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[d>>2]=344696;gl(345824,d|0)|0;i=e;return 0}function kD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=344736;gl(345824,b|0)|0;i=d;return 0}function lD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=344792;gl(345824,b|0)|0;i=a;return 0}function mD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344840;gl(345824,a|0)|0;i=b;return 0}function nD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=344888;gl(345824,a|0)|0;i=b;return 0}function oD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=344936;gl(345824,b|0)|0;i=a;return 0}function pD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=344968;gl(345824,b|0)|0;H=0;i=a;return 0}function qD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=345e3;gl(345824,b|0)|0;i=d;return 0}function rD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[d>>2]=345032;gl(345824,d|0)|0;i=e;return 0}function sD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345064;gl(345824,a|0)|0;i=b;return 0}function tD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=345096;gl(345824,b|0)|0;H=0;i=d;return 0}function uD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345120;gl(345824,a|0)|0;i=b;return 0}function vD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=345152;gl(345824,b|0)|0;i=d;return 0}function wD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345184;gl(345824,a|0)|0;H=0;i=b;return 0}function xD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=345200;gl(345824,b|0)|0;i=a;return 0}function yD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=345232;gl(345824,b|0)|0;H=0;i=a;return 0}function zD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345264;gl(345824,a|0)|0;i=b;return 0}function AD(a){a=a|0;var b=0;a=i;i=i+16|0;b=a;c[b>>2]=345288;gl(345824,b|0)|0;i=a;return 0}function BD(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=345320;gl(345824,b|0)|0;i=a;return 0}function CD(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=345352;gl(345824,b|0)|0;i=a;return 0}function DD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345384;gl(345824,a|0)|0;i=b;return 0}function ED(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;f=i;i=i+16|0;e=f;c[e>>2]=345424;gl(345824,e|0)|0;i=f;return 0}function FD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=345456;gl(345824,b|0)|0;i=d;return 0}function GD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=345488;gl(345824,b|0)|0;i=d;return 0}function HD(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345528;gl(345824,a|0)|0;i=b;return}function ID(){var a=0,b=0;a=i;b=bI()|0;i=a;return b|0}function JD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[d>>2]=345560;gl(345824,d|0)|0;i=e;return 0}function KD(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=345600;gl(345824,b|0)|0;i=a;return 0}function LD(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=345640;gl(345824,b|0)|0;i=a;return 0}function MD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=345680;gl(345824,b|0)|0;i=d;return 0}function ND(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=345712;gl(345824,a|0)|0;i=b;return 0}function OD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+36|0;j=g+24|0;k=g+12|0;l=g;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[j>>2]=0;m=j+4|0;c[m>>2]=0;c[j+8>>2]=0;c[k>>2]=0;n=k+4|0;c[n>>2]=0;c[k+8>>2]=0;kI(l,b+12|0);b=NE(l,h,j,k)|0;if(!(a[h>>0]&1))o=h+1|0;else o=c[h+8>>2]|0;c[d>>2]=qM(o)|0;c[e>>2]=uI(c[101539]|0,((c[m>>2]|0)-(c[j>>2]|0)|0)/12|0)|0;c[f>>2]=uI(c[101539]|0,((c[n>>2]|0)-(c[k>>2]|0)|0)/12|0)|0;o=c[j>>2]|0;if((o|0)!=(c[m>>2]|0)){d=o;o=0;while(1){p=yI(c[e>>2]|0,4,o)|0;if(!(a[d>>0]&1))q=d+1|0;else q=c[d+8>>2]|0;c[p>>2]=qM(q)|0;d=d+12|0;if((d|0)==(c[m>>2]|0))break;else o=o+1|0}}o=c[k>>2]|0;if((o|0)!=(c[n>>2]|0)){d=o;o=0;while(1){q=yI(c[f>>2]|0,4,o)|0;if(!(a[d>>0]&1))r=d+1|0;else r=c[d+8>>2]|0;c[q>>2]=qM(r)|0;d=d+12|0;if((d|0)==(c[n>>2]|0))break;else o=o+1|0}}o=(b|0)!=1;xri(l);l=c[k>>2]|0;if(l){while(1){b=c[n>>2]|0;if((b|0)==(l|0))break;d=b+-12|0;c[n>>2]=d;xri(d)}ACi(c[k>>2]|0)}k=c[j>>2]|0;if(!k){xri(h);i=g;return o|0}while(1){n=c[m>>2]|0;if((n|0)==(k|0))break;l=n+-12|0;c[m>>2]=l;xri(l)}ACi(c[j>>2]|0);xri(h);i=g;return o|0}function PD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+36|0;j=g+24|0;k=g+12|0;l=g;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[j>>2]=0;m=j+4|0;c[m>>2]=0;c[j+8>>2]=0;c[k>>2]=0;n=k+4|0;c[n>>2]=0;c[k+8>>2]=0;kI(l,b+12|0);b=OE(l,h,j,k)|0;if(!(a[h>>0]&1))o=h+1|0;else o=c[h+8>>2]|0;c[d>>2]=qM(o)|0;c[e>>2]=uI(c[101539]|0,((c[m>>2]|0)-(c[j>>2]|0)|0)/12|0)|0;c[f>>2]=uI(c[101539]|0,((c[n>>2]|0)-(c[k>>2]|0)|0)/12|0)|0;o=c[j>>2]|0;if((o|0)!=(c[m>>2]|0)){d=o;o=0;while(1){p=yI(c[e>>2]|0,4,o)|0;if(!(a[d>>0]&1))q=d+1|0;else q=c[d+8>>2]|0;c[p>>2]=qM(q)|0;d=d+12|0;if((d|0)==(c[m>>2]|0))break;else o=o+1|0}}o=c[k>>2]|0;if((o|0)!=(c[n>>2]|0)){d=o;o=0;while(1){q=yI(c[f>>2]|0,4,o)|0;if(!(a[d>>0]&1))r=d+1|0;else r=c[d+8>>2]|0;c[q>>2]=qM(r)|0;d=d+12|0;if((d|0)==(c[n>>2]|0))break;else o=o+1|0}}o=(b|0)!=1;xri(l);l=c[k>>2]|0;if(l){while(1){b=c[n>>2]|0;if((b|0)==(l|0))break;d=b+-12|0;c[n>>2]=d;xri(d)}ACi(c[k>>2]|0)}k=c[j>>2]|0;if(!k){xri(h);i=g;return o|0}while(1){n=c[m>>2]|0;if((n|0)==(k|0))break;l=n+-12|0;c[m>>2]=l;xri(l)}ACi(c[j>>2]|0);xri(h);i=g;return o|0}function QD(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;if((ME(e)|0)==1)f=0;else{if(!(a[e>>0]&1))g=e+1|0;else g=c[e+8>>2]|0;f=qM(g)|0}c[b>>2]=f;xri(e);i=d;return (f|0)!=0|0}function RD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[b>>2]=0;c[e>>2]=0;f=c[a>>2]|0;if((cF(f,e)|0)!=1){g=c[e>>2]|0;i=d;return g|0}c[b>>2]=TE(f)|0;g=c[e>>2]|0;i=d;return g|0}function SD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[b>>2]=0;c[e>>2]=0;f=c[a>>2]|0;if((lF(f,e)|0)==1){c[b>>2]=TE(f)|0;g=0;i=d;return g|0}else{g=c[e>>2]|0;i=d;return g|0}return 0}function TD(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+256|0;h=g;c[f>>2]=0;j=c[e+8>>2]|0;e=c[j+12>>2]|0;k=j+16|0;if((e|0)<2)FJ(RJ()|0);j=(d[k+1>>0]|0)<<8|(d[k>>0]|0);if((j|0)==1){l=c[b>>2]|0;m=e+-2|0;if((m|0)>254)FJ(RJ()|0);PEi(h|0,0,255)|0;if((m|0)>0){n=0;do{a[h+n>>0]=a[k+(n+2)>>0]|0;n=n+1|0}while((n|0)!=(m|0))}if((VE(l,h)|0)!=1){i=g;return}c[f>>2]=TE(l)|0;i=g;return}else if((j|0)==2){j=c[b>>2]|0;if((e|0)<8)FJ(RJ()|0);if((WE(j,(d[k+5>>0]|0)<<16|(d[k+4>>0]|0)<<24|(d[k+6>>0]|0)<<8|(d[k+7>>0]|0),((d[k+2>>0]|0)<<8|(d[k+3>>0]|0))&65535)|0)!=1){i=g;return}c[f>>2]=TE(j)|0;i=g;return}else{c[f>>2]=10047;i=g;return}}function UD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[d>>2]=0;f=c[a>>2]|0;if((UE(f,b)|0)!=1){i=e;return}c[d>>2]=TE(f)|0;i=e;return}function VD(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=0;b=c[a>>2]|0;if(!b){i=d;return}c[a>>2]=0;SE(b)|0;QE(b);ACi(b);i=d;return}function WD(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+256|0;h=g;c[f>>2]=0;j=c[e+8>>2]|0;e=c[j+12>>2]|0;k=j+16|0;if((e|0)<2)FJ(RJ()|0);j=(d[k+1>>0]|0)<<8|(d[k>>0]|0);if((j|0)==1){l=c[b>>2]|0;m=e+-2|0;if((m|0)>254)FJ(RJ()|0);PEi(h|0,0,255)|0;if((m|0)>0){n=0;do{a[h+n>>0]=a[k+(n+2)>>0]|0;n=n+1|0}while((n|0)!=(m|0))}if((XE(l,h)|0)!=1){i=g;return}c[f>>2]=TE(l)|0;i=g;return}else if((j|0)==2){j=c[b>>2]|0;if((e|0)<8)FJ(RJ()|0);if((YE(j,(d[k+5>>0]|0)<<16|(d[k+4>>0]|0)<<24|(d[k+6>>0]|0)<<8|(d[k+7>>0]|0),((d[k+2>>0]|0)<<8|(d[k+3>>0]|0))&65535)|0)!=1){i=g;return}c[f>>2]=TE(j)|0;i=g;return}else{c[f>>2]=10047;i=g;return}}function XD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[d>>2]=0;f=c[a>>2]|0;if((ZE(f,b)|0)!=1){i=e;return}c[d>>2]=TE(f)|0;i=e;return}function YD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g;c[f>>2]=0;j=c[e>>2]|0;c[h>>2]=c[j+12>>2];e=c[a>>2]|0;if((nF(e,b,d,j+16|0,h)|0)!=1){i=g;return}c[f>>2]=TE(e)|0;i=g;return}function ZD(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h+4|0;k=h;c[g>>2]=0;l=c[b>>2]|0;c[j>>2]=0;c[k>>2]=0;if((oF(l,d,e,j,k)|0)==1){c[g>>2]=TE(l)|0;i=h;return}if((e|0)!=128){c[f>>2]=pL(c[101530]|0,j)|0;i=h;return}e=c[86436]|0;if(!e){l=iJ(BI(CI(3496656)|0)|0,2257416,345752)|0;c[86436]=l;m=l}else m=e;c[f>>2]=qL(m)|0;m=PI(c[86436]|0,2473048)|0;e=PI(c[86436]|0,3143160)|0;l=c[f>>2]|0;a[l+(c[m+12>>2]|0)>>0]=(c[j>>2]|0)!=0&1;c[l+(c[e+12>>2]|0)>>2]=c[k>>2];i=h;return}function _D(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[d>>2]=0;f=c[a>>2]|0;if((bF(f,b)|0)!=1){i=e;return}c[d>>2]=TE(f)|0;i=e;return}function $D(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+12|0;h=f;c[e>>2]=0;c[g>>2]=c[a>>2];if((b|0)==2)j=8;else if(!b)j=1;else if((b|0)==1)j=4;else{c[g+4>>2]=0;c[g+8>>2]=0;c[e>>2]=10014;k=0;i=f;return k|0}c[g+4>>2]=j;c[g+8>>2]=0;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;cO(h,g);if((pF(h,d,e)|0)!=1){e=c[j>>2]|0;d=c[h>>2]|0;if((e|0)==(d|0)){l=0;m=e}else{l=(c[d+8>>2]|0)!=0;m=d}}else{l=0;m=c[h>>2]|0}if(!m){k=l;i=f;return k|0}h=c[j>>2]|0;if((h|0)!=(m|0))c[j>>2]=h+(~(((h+-12-m|0)>>>0)/12|0)*12|0);ACi(m);k=l;i=f;return k|0}function aE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;c[e>>2]=0;h=c[b+12>>2]|0;j=yI(b,8,0)|0;c[g>>2]=0;b=c[a>>2]|0;if((eF(b,j,h,g,d)|0)==1){c[e>>2]=TE(b)|0;k=0;i=f;return k|0}else{k=c[g>>2]|0;i=f;return k|0}return 0}function bE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;c[g>>2]=0;if(((c[b+12>>2]|0)-e|0)<(d|0)){k=0;i=h;return k|0}l=yI(b,1,d)|0;c[j>>2]=0;d=c[a>>2]|0;if((dF(d,l,e,f,j)|0)==1)c[g>>2]=TE(d)|0;k=c[j>>2]|0;i=h;return k|0}function cE(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;l=i;i=i+528|0;m=l+260|0;n=l;o=l+264|0;c[k>>2]=0;if(((c[e+12>>2]|0)-g|0)<(f|0)){p=0;i=l;return p|0}q=yI(e,1,f)|0;c[m>>2]=0;f=c[(c[j>>2]|0)+8>>2]|0;e=c[f+12>>2]|0;r=f+16|0;if((e|0)<2)FJ(RJ()|0);f=(d[r+1>>0]|0)<<8|(d[r>>0]|0);if((f|0)==2){s=c[b>>2]|0;c[n>>2]=-1;if((e|0)<8)FJ(RJ()|0);if((jF(s,(d[r+5>>0]|0)<<16|(d[r+4>>0]|0)<<24|(d[r+6>>0]|0)<<8|(d[r+7>>0]|0),((d[r+2>>0]|0)<<8|(d[r+3>>0]|0))&65535,q,g,h,m,n)|0)==1){c[k>>2]=TE(s)|0;t=n}else t=n}else if((f|0)==1){f=c[b>>2]|0;c[n>>2]=-1;b=e+-2|0;if((b|0)>254)FJ(RJ()|0);PEi(o|0,0,255)|0;if((b|0)>0){e=0;do{a[o+e>>0]=a[r+(e+2)>>0]|0;e=e+1|0}while((e|0)!=(b|0))}if((kF(f,o,q,g,h,m,n)|0)==1){c[k>>2]=TE(f)|0;t=n}else t=n}else{c[n>>2]=-1;c[k>>2]=10047;p=0;i=l;return p|0}if((c[t>>2]|0)==-1)u=0;else u=dO(n)|0;c[j>>2]=u;p=c[m>>2]|0;i=l;return p|0}function dE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+272|0;e=d;f=c[a>>2]|0;PEi(e|0,0,260)|0;if(($E(f,e)|0)==1){c[b>>2]=TE(f)|0;g=0;i=d;return g|0}f=dO(e)|0;if(f){g=f;i=d;return g|0}c[b>>2]=10047;g=0;i=d;return g|0}function eE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+272|0;e=d;f=c[a>>2]|0;PEi(e|0,0,260)|0;if((aF(f,e)|0)==1){c[b>>2]=TE(f)|0;g=0;i=d;return g|0}f=dO(e)|0;if(f){g=f;i=d;return g|0}c[b>>2]=10047;g=0;i=d;return g|0}function fE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+32|0;f=e+12|0;g=e;c[d>>2]=0;h=c[a>>2]|0;j=c[h+12>>2]|0;c[f>>2]=0;k=f+4|0;c[k>>2]=0;l=f+8|0;c[l>>2]=0;m=j+-3|0;if(m){n=xCi(m*12|0)|0;c[f>>2]=n;c[k>>2]=n;c[l>>2]=n+(m*12|0)}do if((j|0)>0){m=g+4|0;n=g+8|0;o=h;p=0;q=0;a:while(1){r=c[(yI(o,4,p)|0)>>2]|0;do if(!r)if((q|0)>2){s=7;break a}else t=q+1|0;else{c[g>>2]=c[r+(c[(PI(c[r>>2]|0,345768)|0)+12>>2]|0)>>2];if(!q)u=1;else u=(q|0)==1?4:8;c[m>>2]=u;c[n>>2]=0;v=c[k>>2]|0;if((v|0)==(c[l>>2]|0)){cO(f,g);t=q;break}if(!v)w=0;else{c[v+0>>2]=c[g+0>>2];c[v+4>>2]=c[g+4>>2];c[v+8>>2]=c[g+8>>2];w=c[k>>2]|0}c[k>>2]=w+12;t=q}while(0);r=p+1|0;if((r|0)>=(j|0))break;o=c[a>>2]|0;p=r;q=t}if((s|0)==7){c[d>>2]=10014;s=33;break}q=c[f>>2]|0;if((c[k>>2]|0)==(q|0))x=q;else{if((pF(f,b,d)|0)==1){c[a>>2]=0;s=33;break}q=uI(c[(c[c[a>>2]>>2]|0)+44>>2]|0,(((c[k>>2]|0)-(c[f>>2]|0)|0)/12|0)+3|0)|0;if((c[k>>2]|0)!=(c[f>>2]|0)){p=0;o=0;while(1){n=o+p|0;m=c[(yI(c[a>>2]|0,4,n)|0)>>2]|0;do if(m){r=c[(c[f>>2]|0)+(p*12|0)+8>>2]|0;if(r)if((o|0)==1){if(!(r&12)){y=1;break}c[(yI(q,4,n)|0)>>2]=m;y=1;break}else if(!o){if(!(r&9)){y=0;break}c[(yI(q,4,n)|0)>>2]=m;y=0;break}else{if(!(r&8)){y=o;break}c[(yI(q,4,n)|0)>>2]=m;y=o;break}else y=o}else y=o+1|0;while(0);p=p+1|0;if(p>>>0>=(((c[k>>2]|0)-(c[f>>2]|0)|0)/12|0)>>>0)break;else o=y}}c[a>>2]=q;s=33}}else s=33;while(0);if((s|0)==33)x=c[f>>2]|0;if(!x){i=e;return}f=c[k>>2]|0;if((f|0)!=(x|0))c[k>>2]=f+(~(((f+-12-x|0)>>>0)/12|0)*12|0);ACi(x);i=e;return}function gE(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+32|0;j=h+16|0;k=h;if(!d){l=0;i=h;return l|0};c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;if(e){c[j>>2]=yI(e,1,0)|0;c[j+4>>2]=c[e+12>>2]}if(f){c[j+8>>2]=yI(f,1,0)|0;c[j+12>>2]=c[f+12>>2]}f=c[b>>2]|0;kI(k,oM(d)|0);if(!(a[k>>0]&1))m=k+1|0;else m=c[k+8>>2]|0;if((uF(f,m,j,g)|0)!=1)if((g&1|0)!=0?(c[b>>2]=0,SE(f)|0,(f|0)!=0):0){QE(f);ACi(f);n=1}else n=1;else n=0;xri(k);l=n;i=h;return l|0}function hE(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;i=i+272|0;m=l;n=l+4|0;c[k>>2]=0;if(((c[e+12>>2]|0)-g|0)<(f|0)){o=0;i=l;return o|0}p=yI(e,1,f)|0;c[m>>2]=0;f=c[j+8>>2]|0;j=c[f+12>>2]|0;e=f+16|0;if((j|0)<2)FJ(RJ()|0);f=(d[e+1>>0]|0)<<8|(d[e>>0]|0);if((f|0)==2){q=c[b>>2]|0;if((j|0)<8)FJ(RJ()|0);if((hF(q,(d[e+5>>0]|0)<<16|(d[e+4>>0]|0)<<24|(d[e+6>>0]|0)<<8|(d[e+7>>0]|0),((d[e+2>>0]|0)<<8|(d[e+3>>0]|0))&65535,p,g,h,m)|0)==1)c[k>>2]=TE(q)|0}else if((f|0)==1){f=c[b>>2]|0;b=j+-2|0;if((b|0)>254)FJ(RJ()|0);PEi(n|0,0,255)|0;if((b|0)>0){j=0;do{a[n+j>>0]=a[e+(j+2)>>0]|0;j=j+1|0}while((j|0)!=(b|0))}if((iF(f,n,p,g,h,m)|0)==1)c[k>>2]=TE(f)|0}else{c[k>>2]=10047;o=0;i=l;return o|0}o=c[m>>2]|0;i=l;return o|0}function iE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;c[e>>2]=0;h=c[b+12>>2]|0;j=yI(b,8,0)|0;b=c[a>>2]|0;c[g>>2]=0;if((gF(b,j,h,g,d)|0)==1){c[e>>2]=TE(b)|0;k=0;i=f;return k|0}else{k=c[g>>2]|0;i=f;return k|0}return 0}function jE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;c[g>>2]=0;if(((c[b+12>>2]|0)-e|0)<(d|0)){k=0;i=h;return k|0}l=yI(b,1,d)|0;c[j>>2]=0;d=c[a>>2]|0;if((fF(d,l,e,f,j)|0)==1)c[g>>2]=TE(d)|0;k=c[j>>2]|0;i=h;return k|0}function kE(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;c[j>>2]=0;l=c[b>>2]|0;do if(!g){if(!f){m=qF(l,d,e,h)|0;break}if((e|0)==13|(e|0)==12){b=PI(c[f>>2]|0,2317840)|0;n=PI(c[f>>2]|0,345776)|0;o=c[b+12>>2]|0;b=c[n+12>>2]|0;n=PI(c[f+o>>2]|0,2264696)|0;p=PI(c[f+b>>2]|0,2264696)|0;m=tF(l,d,e,c[f+((c[n+12>>2]|0)+o)>>2]|0,c[f+((c[p+12>>2]|0)+b)>>2]|0)|0;break}else if((e|0)==128){b=PI(c[f>>2]|0,2473048)|0;p=PI(c[f>>2]|0,3143160)|0;m=rF(l,d,128,(a[f+(c[b+12>>2]|0)>>0]|0)!=0,c[f+(c[p+12>>2]|0)>>2]|0)|0;break}else{c[j>>2]=10022;i=k;return}}else m=sF(l,d,e,g+16|0,c[g+12>>2]|0)|0;while(0);if((m|0)!=1){i=k;return}c[j>>2]=TE(l)|0;i=k;return}function lE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[d>>2]=0;f=c[a>>2]|0;if((_E(f,b)|0)!=1){i=e;return}c[d>>2]=TE(f)|0;i=e;return}function mE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;a=i;c[f>>2]=0;switch(b|0){case 1:{g=b;break}case 6:{g=3;break}case 0:{g=b;break}case 26:{g=8;break}case 16:{g=6;break}case 2:{g=b;break}case 11:{g=4;break}case 12:{g=5;break}case 23:{g=7;break}default:g=-1}switch(d|0){case 3:{h=2;break}case 2:{h=1;break}case 4:{h=3;break}case 5:{h=4;break}case 1:{h=0;break}default:h=-1}switch(e|0){case -1:case 1257:case 1256:case 1e3:case 255:case 77:{j=-1;break}case 22:case 17:case 12:case 6:case 3:case 2:case 1:case 41:case 0:{j=e;break}default:j=-1}do if((g|0)==-1){c[f>>2]=10047;k=0}else{if((h|0)==-1){c[f>>2]=10044;k=0;break}if((j|0)==-1){c[f>>2]=10043;k=0;break}e=xCi(4)|0;PE(e,3);if((RE(e,g,h,j)|0)==1){c[f>>2]=TE(e)|0;QE(e);ACi(e);l=0}else l=e;k=l}while(0);i=a;return k|0}function nE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;c[f>>2]=0;if((b|0)==21537){j=-1;i=g;return j|0}if(!d){k=0;l=0}else{k=d+16|0;l=c[d+12>>2]|0}if(!e){m=0;n=0}else{m=e+16|0;n=c[e+12>>2]|0}e=c[a>>2]|0;c[h>>2]=0;if((mF(e,b,k,l,m,n,h)|0)==1){c[f>>2]=TE(e)|0;j=-1;i=g;return j|0}else{j=c[h>>2]|0;i=g;return j|0}return 0}function oE(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=345856;gl(345824,b|0)|0;b=sE()|0;i=a;return b|0}function pE(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;a[f>>0]=1;if(!e){e=xCi(4)|0;FE(e,b,d);d=xCi(8)|0;c[d>>2]=346296;c[d+4>>2]=e;i=g;return d|0}else FJ(SJ(345896)|0);return 0}function qE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[b>>2]|0;c[g>>2]=0;a[e>>0]=(HE(c[h+4>>2]|0,d,g)|0)&1^1;i=f;return c[g>>2]|0}function rE(a,b,c){a=a|0;b=b|0;c=c|0;FJ(SJ(346096)|0);return 0}function sE(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=0;JF(346320,b)|0;i=a;return c[b>>2]|0}function tE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xCi(84)|0;VG(f,b,d);c[a>>2]=f;i=e;return}function uE(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}FH(d);ACi(d);i=b;return}function vE(a){a=a|0;var b=0,d=0;b=i;d=WG(c[a>>2]|0)|0;i=b;return d|0}function wE(a){a=a|0;var b=0,d=0;b=i;d=XG(c[a>>2]|0)|0;i=b;return d|0}function xE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=IH(c[a>>2]|0,b)|0;i=d;return e|0}function yE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=JH(c[a>>2]|0,b,d)|0;i=e;return f|0}function zE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;c[e>>2]=b;c[e+4>>2]=3653512;f=eCi(e,346328,70,8,2485)|0;if((f|0)!=0?(e=c[f+4>>2]|0,(e|0)!=0):0){rri(a,e,SEi(e|0)|0);i=d;return}else g=0;do{if((c[346328+(g<<3)>>2]|0)==(b|0)){h=g;j=6;break}g=g+1|0}while((g|0)<70);if((j|0)==6?(j=c[346332+(h<<3)>>2]|0,(j|0)!=0):0){rri(a,j,SEi(j|0)|0);i=d;return}rri(a,0,SEi(0)|0);i=d;return}function AE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=xCi(92)|0;zH(e);c[a>>2]=e;if(!b){i=d;return}AH(e,0);i=d;return}function BE(a,b){a=a|0;b=b|0;var d=0;d=i;AH(c[a>>2]|0,b);i=d;return}function CE(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}FH(d);ACi(d);i=b;return}function DE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=BH(c[a>>2]|0,b,d)|0;i=e;return f|0}function EE(a){a=a|0;var b=0;b=i;CH(c[a>>2]|0);i=b;return}function FE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xCi(88)|0;LH(f,b,d);c[a>>2]=f;i=e;return}function GE(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}FH(d);ACi(d);i=b;return}function HE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=MH(c[a>>2]|0,b,d)|0;i=e;return f|0}function IE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=IH(c[a>>2]|0,b)|0;i=d;return e|0}function JE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=JH(c[a>>2]|0,b,d)|0;i=e;return f|0}function KE(){return}function LE(){return}function ME(a){a=a|0;var b=0,c=0;b=i;c=MF(a)|0;i=b;return c|0}function NE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=NF(a,b,c,d)|0;i=e;return f|0}function OE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=OF(a,b,c,d)|0;i=e;return f|0}function PE(a,b){a=a|0;b=b|0;b=i;c[a>>2]=xCi(1)|0;i=b;return}function QE(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(d)ACi(d);i=b;return}function RE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=RF(c[a>>2]|0,b,d,e)|0;i=f;return g|0}function SE(a){a=a|0;var b=0,d=0;b=i;d=SF(c[a>>2]|0)|0;i=b;return d|0}function TE(a){a=a|0;var b=0,d=0;b=i;d=UF(c[a>>2]|0)|0;i=b;return d|0}function UE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=TF(c[a>>2]|0,b)|0;i=d;return e|0}function VE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=VF(c[a>>2]|0,b)|0;i=d;return e|0}function WE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=WF(c[a>>2]|0,b,d)|0;i=e;return f|0}function XE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=XF(c[a>>2]|0,b)|0;i=d;return e|0}function YE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_F(c[a>>2]|0,b,d)|0;i=e;return f|0}function ZE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ZF(c[a>>2]|0,b)|0;i=d;return e|0}function _E(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=YF(c[a>>2]|0,b)|0;i=d;return e|0}function $E(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=$F(c[a>>2]|0,b)|0;i=d;return e|0}function aF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=aG(c[a>>2]|0,b)|0;i=d;return e|0}function bF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=bG(c[a>>2]|0,b)|0;i=d;return e|0}function cF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=cG(c[a>>2]|0,b)|0;i=d;return e|0}function dF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=dG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function eF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=gG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function fF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=eG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function gF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=fG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function hF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=hG(c[a>>2]|0,b,d,e,f,g,h)|0;i=j;return k|0}function iF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=iG(c[a>>2]|0,b,d,e,f,g)|0;i=h;return j|0}function jF(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=jG(c[a>>2]|0,b,d,e,f,g,h,j)|0;i=k;return l|0}function kF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=kG(c[a>>2]|0,b,d,e,f,g,h)|0;i=j;return k|0}function lF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=lG(c[a>>2]|0,b)|0;i=d;return e|0}function mF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=mG(c[a>>2]|0,b,d,e,f,g,h)|0;i=j;return k|0}function nF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=nG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function oF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=oG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function pF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=pG(a,b,c)|0;i=d;return e|0}function qF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=qG(c[a>>2]|0,b,d,e)|0;i=f;return g|0}function rF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=rG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function sF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=sG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function tF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=tG(c[a>>2]|0,b,d,e,f)|0;i=g;return h|0}function uF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=uG(c[a>>2]|0,b,d,e)|0;i=f;return g|0}function vF(a){a=a|0;var b=0,d=0;b=i;d=xCi(56)|0;NH(d);c[a>>2]=d;tE(a+4|0,1,0);i=b;return}function wF(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(d){OH(d);ACi(d)}uE(a+4|0);i=b;return}function xF(){var a=0;a=i;yF()|0;i=a;return}function yF(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;c[b>>2]=0;JF(348664,b)|0;d=c[b>>2]|0;if(d){e=d;i=a;return e|0}d=xCi(8)|0;c[d>>2]=YH()|0;tE(d+4|0,0,0);c[b>>2]=d;IF(348664,d)|0;e=c[b>>2]|0;i=a;return e|0}function zF(a,b){a=a|0;b=b|0;return}function AF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;IF(348664,d)|0;e=c[a+4>>2]|0;f=c[a+8>>2]|0;if(a)ACi(a);a=d+4|0;wE(a)|0;ko[e&4095](f);vE(a)|0;i=b;return}function BF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xCi(12)|0;c[f+4>>2]=b;c[f+8>>2]=d;c[f>>2]=a;d=PH(c[a>>2]|0,3445,f)|0;i=e;return d|0}function CF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(yE(a+4|0,b,1)|0)!=0&1;i=c;return d|0}function DF(a,b){a=a|0;b=b|0;var d=0;d=i;SH(c[a>>2]|0,b);i=d;return}function EF(a){a=a|0;var b=0;b=i;VH(a);i=b;return}function FF(){var a=0,b=0;a=i;b=WH()|0;i=a;return b|0}function GF(){var a=0,b=0;a=i;i=i+16|0;b=a;JF(348664,b)|0;i=a;return c[b>>2]|0}function HF(a){a=a|0;var b=0,d=0;b=i;d=xCi(4)|0;ZH(d);c[a>>2]=d;i=b;return}function IF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_H(c[a>>2]|0,b)|0;i=d;return e|0}function JF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=$H(c[a>>2]|0,b)|0;i=d;return e|0}function KF(){return}function LF(){return}function MF(a){a=a|0;return 1}function NF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function OF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function PF(a,b){a=a|0;b=b|0;return}function QF(a){a=a|0;return}function RF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function SF(a){a=a|0;return 1}function TF(a,b){a=a|0;b=b|0;return 1}function UF(a){a=a|0;return -1}function VF(a,b){a=a|0;b=b|0;return 1}function WF(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function XF(a,b){a=a|0;b=b|0;return 1}function YF(a,b){a=a|0;b=b|0;return 1}function ZF(a,b){a=a|0;b=b|0;return 1}function _F(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function $F(a,b){a=a|0;b=b|0;return 1}function aG(a,b){a=a|0;b=b|0;return 1}function bG(a,b){a=a|0;b=b|0;return 1}function cG(a,b){a=a|0;b=b|0;return 1}function dG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function eG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function fG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function gG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function hG(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 1}function iG(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 1}function jG(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return 1}function kG(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 1}function lG(a,b){a=a|0;b=b|0;return 1}function mG(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 1}function nG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function oG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function pG(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function qG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function rG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function sG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function tG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 1}function uG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function vG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+160|0;d=b;e=b+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=h+4|0;k=f+4|0;a:do if((a|0)>-1)while(1){l=e+0|0;m=l+128|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));c[e>>2]=1;Oc(h|0,a|0,1e3);n=c[j>>2]|0;c[f>>2]=c[h>>2];c[k>>2]=n;n=jf(1,e|0,0,0,f|0)|0;if((n|0)!=-1){o=n;p=6;break a}if((c[(xd()|0)>>2]|0)!=4){q=-1;break}}else while(1){l=e+0|0;m=l+128|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));c[e>>2]=1;n=jf(1,e|0,0,0,0)|0;if((n|0)!=-1){o=n;p=6;break a}if((c[(xd()|0)>>2]|0)!=4){q=-1;break}}while(0);if((p|0)==6)if((o|0)>0){c[g>>2]=0;c[d>>2]=g;p=Vh(0,21531,d|0)|0;q=(p|0)>-1?c[g>>2]|0:p}else q=o;i=b;return ((q|0)>0?q:0)|0}function wG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+64|0;d=b;if((Ue(0,d|0)|0)==-1){e=0;i=b;return e|0}f=d+12|0;g=c[f>>2]|0;if((g&1|0)!=0^a){e=1;i=b;return e|0}c[f>>2]=a?g&-2:g|1;if((Ij(0,0,d|0)|0)==-1){e=1;i=b;return e|0}g=348792|0;a=d+0|0;d=g+60|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(d|0));e=1;i=b;return e|0}function xG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+64|0;d=b;if((Ue(0,d|0)|0)==-1){e=0;i=b;return e|0}f=d+12|0;g=c[f>>2]|0;h=(g&8|0)!=0;if(h&a|(h|a)^1){e=1;i=b;return e|0}c[f>>2]=a?g|8:g&-9;if((Ij(0,0,d|0)|0)==-1){e=1;i=b;return e|0}g=348792|0;a=d+0|0;d=g+60|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(d|0));e=1;i=b;return e|0}function yG(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+432|0;j=h;k=h+280|0;l=h+140|0;c[j>>2]=k;if(!(Vh(0,21523,j|0)|0)){m=e[k+2>>1]<<16|e[k>>1];c[87176]=m;if((m|0)==-1)n=4}else{c[87176]=-1;n=4}do if((n|0)==4){m=cj(348712)|0;if(!m)o=0;else o=wEi(m)|0;m=cj(348720)|0;if((m|0)!=0?(p=wEi(m)|0,(o|0)!=0&(p|0)!=0):0){c[87176]=p|o<<16;break}c[87176]=-1}while(0);c[g>>2]=348704;if((Ue(0,348728)|0)==-1){q=0;i=h;return q|0}g=348792;o=348728;n=g+60|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(n|0));c[87201]=c[87201]&-3;c[87198]=c[87198]&-5121;a[348815]=1;a[348814]=0;if((Ij(0,0,348792)|0)==-1){q=0;i=h;return q|0}yri(348672,b)|0;a[f>>0]=a[348809]|0;a[f+1>>0]=a[348810]|0;a[f+2>>0]=a[348811]|0;a[f+3>>0]=a[348812]|0;a[f+4>>0]=a[348813]|0;a[f+5>>0]=a[348814]|0;a[f+6>>0]=a[348815]|0;a[f+7>>0]=a[348816]|0;a[f+8>>0]=a[348817]|0;a[f+9>>0]=a[348818]|0;a[f+10>>0]=a[348819]|0;a[f+11>>0]=a[348820]|0;a[f+12>>0]=a[348821]|0;a[f+13>>0]=a[348822]|0;a[f+14>>0]=a[348823]|0;a[f+15>>0]=a[348824]|0;a[f+16>>0]=a[348825]|0;if(a[348856]|0){q=1;i=h;return q|0}PEi(j|0,0,140)|0;PEi(k|0,0,140)|0;PEi(l|0,0,140)|0;c[j>>2]=1754;c[j+132>>2]=4;ug(j+4|0)|0;Qg(18,j|0,348864)|0;c[k>>2]=3446;c[k+132>>2]=0;ug(k+4|0)|0;Qg(2,k|0,349008)|0;c[l>>2]=1755;c[l+132>>2]=4;ug(l+4|0)|0;Qg(28,l|0,349152)|0;a[348856]=1;yri(348688,d)|0;wh(71)|0;q=1;i=h;return q|0}function zG(){var a=0,b=0,d=0;a=i;b=349296;if((c[b+4>>2]|0)<0){d=0;i=a;return d|0}d=c[b>>2]|0;i=a;return d|0}function AG(){var a=0,b=0,d=0;a=i;i=i+16|0;b=Cl(349304,0,a|0)|0;d=349296;c[d>>2]=b;c[d+4>>2]=((b|0)<0)<<31>>31;i=a;return 1}function BG(a){a=a|0;return}function CG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a;a=349296;if((f|0)==(c[a>>2]|0)?0==(c[a+4>>2]|0):0)g=0;else{h=0;i=e;return h|0}while(1){a=ml(f|0,d+g|0,b-g|0)|0;if((a|0)<0)if((c[(xd()|0)>>2]|0)==4)j=g;else{k=a;break}else j=a+g|0;if(j>>>0<b>>>0)g=j;else{k=a;break}}h=(k|0)>-1;i=e;return h|0}function DG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=sd(0,0)|0;if(!f){c[b>>2]=TG(c[(xd()|0)>>2]|0)|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}else{rri(e,f,SEi(f|0)|0);BDi(f);c[b>>2]=0;sri(a,e);xri(e);i=d;return}}function EG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;if((cg(f|0)|0)!=-1){g=1;h=0;c[d>>2]=h;i=e;return g|0}g=0;h=TG(c[(xd()|0)>>2]|0)|0;c[d>>2]=h;i=e;return g|0}function FG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;if((fi(f|0,511)|0)!=-1){g=1;h=0;c[d>>2]=h;i=e;return g|0}g=0;h=UG(b,c[(xd()|0)>>2]|0)|0;c[d>>2]=h;i=e;return g|0}function GG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;if((Uj(f|0)|0)!=-1){g=1;h=0;c[d>>2]=h;i=e;return g|0}g=0;h=UG(b,c[(xd()|0)>>2]|0)|0;c[d>>2]=h;i=e;return g|0}function HG(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+128|0;j=d+108|0;k=d+88|0;l=d+44|0;m=d+40|0;n=d+72|0;o=d+96|0;p=d+112|0;q=d+16|0;r=d+4|0;s=d+48|0;t=d+28|0;u=d+60|0;v=d;fI(n,e);eI(o,e);e=p+4|0;c[e>>2]=0;c[p+8>>2]=0;w=p+4|0;c[p>>2]=w;if(!(kO(n,o,p,h)|0)){c[b+4>>2]=0;c[b+8>>2]=0;c[b>>2]=b+4;x=c[e>>2]|0;WN(p,x);xri(o);xri(n);i=d;return}rri(q,349320,2);y=qI(o,q)|0;xri(q);if(y){y=a[o>>0]|0;if(!(y&1))z=(y&255)>>>1;else z=c[o+4>>2]|0;vri(r,o,0,z+-2|0,o);z=kO(n,r,p,h)|0;xri(r);if(!z){c[b+4>>2]=0;c[b+8>>2]=0;c[b>>2]=b+4;x=c[e>>2]|0;WN(p,x);xri(o);xri(n);i=d;return}}z=s+4|0;c[z>>2]=0;c[s+8>>2]=0;r=s+4|0;c[s>>2]=r;y=c[p>>2]|0;if((y|0)==(w|0))A=r;else{q=n+1|0;B=u+1|0;C=u+8|0;D=u+4|0;E=n+4|0;F=n+8|0;G=y;while(1){y=G+16|0;if((Ori(y,3672776)|0)!=0?(Ori(y,630008)|0)!=0:0){c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;H=a[n>>0]|0;if(!(H&1)){I=(H&255)>>>1;J=q}else{I=c[E>>2]|0;J=c[F>>2]|0}Pri(u,J,I,I+1|0);Fri(u,47);c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;H=a[u>>0]|0;K=(H&1)==0;if(K)L=(H&255)>>>1;else L=c[D>>2]|0;H=a[y>>0]|0;if(!(H&1))M=(H&255)>>>1;else M=c[G+20>>2]|0;Pri(t,K?B:c[C>>2]|0,L,M+L|0);if(!(a[y>>0]&1))N=y+1|0;else N=c[G+24>>2]|0;Gri(t,N,M)|0;xri(u);y=bH(t,v)|0;if((c[v>>2]|0)==0&(y&g|0)==(f|0))lO(k,s,t);xri(t)}y=c[G+4>>2]|0;if(!y){K=G;while(1){H=c[K+8>>2]|0;if((c[H>>2]|0)==(K|0)){O=H;break}else K=H}}else{K=y;while(1){H=c[K>>2]|0;if(!H){O=K;break}else K=H}}if((O|0)==(w|0))break;else G=O}A=c[s>>2]|0}c[h>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=b+4|0;c[b>>2]=h;if((A|0)!=(r|0)){O=A;while(1){c[l>>2]=h;c[j+0>>2]=c[l+0>>2];mO(m,b,j,O+16|0);A=c[O+4>>2]|0;if(!A){G=O;while(1){w=c[G+8>>2]|0;if((c[w>>2]|0)==(G|0)){P=w;break}else G=w}}else{G=A;while(1){w=c[G>>2]|0;if(!w){P=G;break}else G=w}}if((P|0)==(r|0))break;else O=P}}WN(s,c[z>>2]|0);x=c[e>>2]|0;WN(p,x);xri(o);xri(n);i=d;return}function IG(a){a=a|0;var b=0;b=i;rri(a,349328,5);i=b;return}function JG(a){a=a|0;var b=0,c=0;b=i;i=i+256|0;c=b;if(!(Gk(c|0,256)|0)){rri(a,c,SEi(c|0)|0);i=b;return}else{rri(a,0,SEi(0)|0);i=b;return}}function KG(){var a=0,b=0;a=i;b=Wh(84)|0;i=a;return b|0}function LG(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+400|0;c=b;if((Qh(c|0)|0)>-1){d=c+130|0;rri(a,d,SEi(d|0)|0);i=b;return}else{rri(a,349336,7);i=b;return}}function MG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+12|0;f=d;rri(f,349344,4);if(!(a[f>>0]&1))g=f+1|0;else g=c[f+8>>2]|0;h=cj(g|0)|0;if(!h){c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;j=e}else{rri(e,h,SEi(h|0)|0);j=e}xri(f);f=a[j>>0]|0;if(!(f&1))k=(f&255)>>>1;else k=c[e+4>>2]|0;if(!k){rri(b,2789600,7);xri(e);i=d;return}else{sri(b,e);xri(e);i=d;return}}function NG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;d=cj(f|0)|0;if(!d){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}else{rri(b,d,SEi(d|0)|0);i=e;return}}function OG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a[d>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[d+4>>2]|0;if(!(a[b>>0]&1))j=b+1|0;else j=c[b+8>>2]|0;if(!h){Hk(j|0)|0;i=e;return}if(g)k=d+1|0;else k=c[d+8>>2]|0;ak(j|0,k|0,1)|0;i=e;return}function PG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=c[o>>2]|0;h=c[g>>2]|0;if(!h){i=b;return}else{j=h;k=g}do{g=hCi(j,61)|0;if(g){rri(d,j,g-j|0);g=c[e>>2]|0;if((g|0)==(c[f>>2]|0))nO(a,d);else{if(!g)l=0;else{sri(g,d);l=c[e>>2]|0}c[e>>2]=l+12}xri(d)}k=k+4|0;j=c[k>>2]|0}while((j|0)!=0);i=b;return}function QG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+12|0;f=d;if(!(a[349368]|0)){c[87338]=0;c[87339]=0;c[87340]=0;a[349368]=1}g=a[349352]|0;if(!(g&1))h=(g&255)>>>1;else h=c[87339]|0;if(h){sri(b,349352);i=d;return}rri(f,630032,4);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;h=cj(j|0)|0;if(!h){c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0}else rri(e,h,SEi(h|0)|0);yri(349352,e)|0;xri(e);xri(f);f=a[349352]|0;if(!(f&1))k=(f&255)>>>1;else k=c[87339]|0;if(!k){rri(b,63e4,1);i=d;return}else{sri(b,349352);i=d;return}}function RG(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;rri(d,63e4,1);nO(a,d);xri(d);i=b;return}function SG(a){a=a|0;Wq();rl(a|0)}function TG(a){a=a|0;var b=0,c=0;b=i;do switch(a|0){case 24:case 23:{c=4;break}case 11:{c=32;break}case 16:{c=33;break}case 21:{c=82;break}case 17:{c=80;break}case 28:{c=39;break}case 20:case 2:{c=2;break}case 29:case 22:{c=25;break}case 39:{c=145;break}case 8:{c=11;break}case 36:{c=206;break}case 115:{c=997;break}case 38:{c=50;break}case 9:{c=6;break}case 5:{c=6;break}case 4:{c=997;break}case 32:{c=29;break}case 30:case 1:case 13:{c=5;break}default:c=31}while(0);i=b;return c|0}function UG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;do switch(d|0){case 11:{g=32;break}case 2:{fI(f,b);if(!(a[f>>0]&1))h=f+1|0;else h=c[f+8>>2]|0;j=(vl(h|0,0)|0)==0;xri(f);g=j?2:3;break}case 16:{g=33;break}case 17:{g=80;break}case 29:case 22:{g=25;break}case 21:{g=82;break}case 24:case 23:{g=4;break}case 20:{g=2;break}case 28:{g=39;break}case 39:{g=145;break}case 8:{g=11;break}case 36:{g=206;break}case 115:{g=997;break}case 38:{g=50;break}case 9:{g=6;break}case 5:{g=6;break}case 4:{g=997;break}case 32:{g=29;break}case 30:case 1:case 13:{g=5;break}default:g=31}while(0);i=e;return g|0}function VG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;EH(a,b?1:2);if(!d){i=e;return}c[a+76>>2]=1;i=e;return}function WG(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;pd(d|0)|0;c[a+76>>2]=1;if(c[a+80>>2]|0)Pl(a+28|0)|0;ih(d|0)|0;i=b;return 0}function XG(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;pd(d|0)|0;c[a+76>>2]=0;ih(d|0)|0;i=b;return 0}function YG(a){a=a|0;var b=0,d=0;b=i;d=(Fc(c[a>>2]|0)|0)==1;i=b;return d|0}function ZG(){var a=0,b=0,d=0,e=0;a=i;b=c[87346]|0;if(b){d=b;i=a;return d|0}b=xCi(48)|0;e=b+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[87346]=b;c[b>>2]=2;c[b+4>>2]=2;c[b+20>>2]=0;c[b+28>>2]=3;c[b+24>>2]=-1;d=b;i=a;return d|0}function _G(){var a=0,b=0,d=0,e=0;a=i;b=c[87348]|0;if(b){d=b;i=a;return d|0}b=xCi(48)|0;e=b+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[87348]=b;c[b>>2]=0;c[b+4>>2]=2;c[b+20>>2]=0;c[b+28>>2]=1;c[b+24>>2]=-1;d=b;i=a;return d|0}function $G(){var a=0,b=0,d=0,e=0;a=i;b=c[87350]|0;if(b){d=b;i=a;return d|0}b=xCi(48)|0;e=b+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[87350]=b;c[b>>2]=1;c[b+4>>2]=2;c[b+20>>2]=0;c[b+28>>2]=3;c[b+24>>2]=-1;d=b;i=a;return d|0}function aH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;if((ef(e|0)|0)==-1){f=0;i=d;return f|0}g=xCi(48)|0;h=g+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[g+40>>2]=0;c[g+44>>2]=0;c[g>>2]=c[e>>2];c[g+4>>2]=3;c[g+20>>2]=0;c[g+28>>2]=1;c[g+24>>2]=-1;h=xCi(48)|0;j=h+8|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[h+40>>2]=0;c[h+44>>2]=0;c[h>>2]=c[e+4>>2];c[h+4>>2]=3;c[h+20>>2]=0;c[h+28>>2]=3;c[h+24>>2]=-1;c[a>>2]=g;c[b>>2]=h;f=1;i=d;return f|0}function bH(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+176|0;g=f+152|0;h=f+76|0;j=f;k=oO(d,h,j)|0;c[e>>2]=k;if(k){l=-1;i=f;return l|0}k=h+12|0;h=c[k>>2]|0;if((h&61440|0)==49152){e=h&-49153;c[k>>2]=e;m=e}else m=h;eI(g,d);d=(m&146|0)==0;do if((m&61440|0)!=16384){h=b[g>>1]|0;if(!(h&1))n=(h&65535)>>>8&255;else n=a[c[g+8>>2]>>0]|0;h=n<<24>>24==46;if(d){o=h?3:1;break}else{o=h?2:128;break}}else{h=d?17:16;e=b[g>>1]|0;if(!(e&1))p=(e&65535)>>>8&255;else p=a[c[g+8>>2]>>0]|0;o=p<<24>>24==46?h|2:h}while(0);p=(c[j+12>>2]&61440|0)==40960?o|1024:o;xri(g);l=p;i=f;return l|0}function cH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+80|0;g=f;if(!(a[b>>0]&1))h=b+1|0;else h=c[b+8>>2]|0;if(id(h|0,g|0)|0){c[e>>2]=UG(b,c[(xd()|0)>>2]|0)|0;j=0;i=f;return j|0}if(!(a[b>>0]&1))k=b+1|0;else k=c[b+8>>2]|0;h=c[g+12>>2]|0;if(!(d&1))l=vf(k|0,h|128|0)|0;else l=vf(k|0,h&-147|0)|0;if(l){c[e>>2]=UG(b,c[(xd()|0)>>2]|0)|0;j=0;i=f;return j|0}if((d|0)>=0){j=1;i=f;return j|0}if(!(a[b>>0]&1))m=b+1|0;else m=c[b+8>>2]|0;if(!(vf(m|0,h>>>2&73|h|0)|0)){j=1;i=f;return j|0}c[e>>2]=UG(b,c[(xd()|0)>>2]|0)|0;j=0;i=f;return j|0}function dH(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+176|0;h=g+164|0;j=g+88|0;k=g+12|0;l=g;m=oO(d,j,k)|0;c[f>>2]=m;if(m){n=0;i=g;return n|0}eI(l,d);m=c[j+56>>2]|0;f=c[j+64>>2]|0;o=(m|0)<(f|0)?m:f;yri(e,l)|0;f=j+12|0;p=c[f>>2]|0;if((p&61440|0)==49152){q=p&-49153;c[f>>2]=q;r=q}else r=p;eI(h,d);d=(r&146|0)==0;do if((r&61440|0)!=16384){p=b[h>>1]|0;if(!(p&1))s=(p&65535)>>>8&255;else s=a[c[h+8>>2]>>0]|0;p=s<<24>>24==46;if(d){t=p?3:1;break}else{t=p?2:128;break}}else{p=d?17:16;q=b[h>>1]|0;if(!(q&1))u=(q&65535)>>>8&255;else u=a[c[h+8>>2]>>0]|0;t=u<<24>>24==46?p|2:p}while(0);u=(c[k+12>>2]&61440|0)==40960?t|1024:t;xri(h);c[e+12>>2]=u;if(!(u&16)){u=c[j+36>>2]|0;v=u;w=((u|0)<0)<<31>>31}else{v=0;w=0}u=e+16|0;c[u>>2]=v;c[u+4>>2]=w;w=gFi(o|0,((o|0)<0)<<31>>31|0,1e7,0)|0;o=_Ei(w|0,H|0,-717324288,27111902)|0;w=e+24|0;c[w>>2]=o;c[w+4>>2]=H;w=c[j+48>>2]|0;j=gFi(w|0,((w|0)<0)<<31>>31|0,1e7,0)|0;w=_Ei(j|0,H|0,-717324288,27111902)|0;j=e+32|0;c[j>>2]=w;c[j+4>>2]=H;j=gFi(m|0,((m|0)<0)<<31>>31|0,1e7,0)|0;m=_Ei(j|0,H|0,-717324288,27111902)|0;j=e+40|0;c[j>>2]=m;c[j+4>>2]=H;xri(l);n=1;i=g;return n|0}function eH(a){a=a|0;return c[a+4>>2]|0}function fH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=bH(b,d)|0;if(c[d>>2]|0){g=0;i=e;return g|0}if(f&1){c[d>>2]=5;g=0;i=e;return g|0}if(!(a[b>>0]&1))h=b+1|0;else h=c[b+8>>2]|0;if((cl(h|0)|0)==-1){c[d>>2]=UG(b,c[(xd()|0)>>2]|0)|0;g=0;i=e;return g|0}else{c[d>>2]=0;g=1;i=e;return g|0}return 0}function gH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=g;j=g+4|0;if(!(a[b>>0]&1))k=b+1|0;else k=c[b+8>>2]|0;c[h>>2]=0;l=Cl(k|0,0,h|0)|0;if((l|0)<0){c[f>>2]=UG(b,c[(xd()|0)>>2]|0)|0;m=0;i=g;return m|0}if((Le(l|0,j|0)|0)<0){c[f>>2]=TG(c[(xd()|0)>>2]|0)|0;uk(l|0)|0;m=0;i=g;return m|0}if(!(a[d>>0]&1))n=d+1|0;else n=c[d+8>>2]|0;b=c[j+12>>2]|0;do if(e){c[h>>2]=b;k=Cl(n|0,513,h|0)|0;if((k|0)>=0){c[f>>2]=183;o=k;break}if(!(a[d>>0]&1))p=d+1|0;else p=c[d+8>>2]|0;c[h>>2]=b;q=Cl(p|0,577,h|0)|0;r=19}else{c[h>>2]=b;q=Cl(n|0,193,h|0)|0;r=19}while(0);if((r|0)==19)if((q|0)<0){c[f>>2]=TG(c[(xd()|0)>>2]|0)|0;uk(l|0)|0;m=0;i=g;return m|0}else o=q;q=pO(l,o,c[j+40>>2]|0,f)|0;uk(l|0)|0;uk(o|0)|0;m=q;i=g;return m|0}function hH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+176|0;g=f+100|0;h=f+24|0;j=f+12|0;k=f;if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;if((id(l|0,g|0)|0)<0){if(!(a[b>>0]&1))m=b+1|0;else m=c[b+8>>2]|0;rri(j,m,SEi(m|0)|0);c[e>>2]=UG(j,c[(xd()|0)>>2]|0)|0;xri(j);n=0;i=f;return n|0}if(!(a[d>>0]&1))o=d+1|0;else o=c[d+8>>2]|0;do if(!(id(o|0,h|0)|0)){j=c[h>>2]|0;if((j|0)==(c[g>>2]|0)?(m=c[h+72>>2]|0,(m|0)==(c[g+72>>2]|0)):0){p=j;q=m;break}c[e>>2]=183;n=0;i=f;return n|0}else{p=c[g>>2]|0;q=c[g+72>>2]|0}while(0);BE(349376,0);h=c[87352]|0;a:do if(h){o=h;while(1){if((c[o+32>>2]|0)==(p|0)?(c[o+36>>2]|0)==(q|0):0){r=o;break}o=c[o+44>>2]|0;if(!o){s=21;break a}}EE(349376);if(r){if((c[r+24>>2]|0)>>>0>=2?(c[r+28>>2]&3|0)==0:0)break;c[e>>2]=32;n=0;i=f;return n|0}}else s=21;while(0);if((s|0)==21)EE(349376);if(!(a[b>>0]&1))t=b+1|0;else t=c[b+8>>2]|0;if(!(a[d>>0]&1))u=d+1|0;else u=c[d+8>>2]|0;if((Re(t|0,u|0)|0)!=-1){c[e>>2]=0;n=1;i=f;return n|0}u=xd()|0;t=c[u>>2]|0;if((t|0)==17){c[e>>2]=183;n=0;i=f;return n|0}else if((t|0)==18){if((c[g+12>>2]&61440|0)==16384){c[e>>2]=17;n=0;i=f;return n|0}if(!(gH(b,d,1,e)|0)){n=0;i=f;return n|0}d=bH(b,e)|0;if(c[e>>2]|0){n=0;i=f;return n|0}if(d&1){c[e>>2]=5;n=0;i=f;return n|0}if(!(a[b>>0]&1))v=b+1|0;else v=c[b+8>>2]|0;if((cl(v|0)|0)==-1){c[e>>2]=UG(b,c[u>>2]|0)|0;n=0;i=f;return n|0}else{c[e>>2]=0;n=1;i=f;return n|0}}else{if(!(a[b>>0]&1))w=b+1|0;else w=c[b+8>>2]|0;rri(k,w,SEi(w|0)|0);c[e>>2]=UG(k,c[u>>2]|0)|0;xri(k);n=0;i=f;return n|0}return 0}function iH(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+112|0;h=f;j=f+96|0;k=f+20|0;l=f+16|0;m=f+4|0;if(!(a[e>>0]&1))n=e+1|0;else n=c[e+8>>2]|0;c[h>>2]=0;o=Cl(n|0,0,h|0)|0;if(!(a[d>>0]&1))p=d+1|0;else p=c[d+8>>2]|0;if(!(a[e>>0]&1))q=e+1|0;else q=c[e+8>>2]|0;if((Re(p|0,q|0)|0)==-1){if((o|0)!=-1)uk(o|0)|0;if(!(a[d>>0]&1))r=d+1|0;else r=c[d+8>>2]|0;rri(j,r,SEi(r|0)|0);c[g>>2]=UG(j,c[(xd()|0)>>2]|0)|0;xri(j);s=0;i=f;return s|0}if(!(a[b>>0]&1))t=b+1|0;else t=c[b+8>>2]|0;if(!(a[d>>0]&1))u=d+1|0;else u=c[d+8>>2]|0;if((Re(t|0,u|0)|0)!=-1){if((o|0)!=-1)uk(o|0)|0;c[g>>2]=0;s=1;i=f;return s|0}if(!(a[e>>0]&1))v=e+1|0;else v=c[e+8>>2]|0;if(!(a[d>>0]&1))w=d+1|0;else w=c[d+8>>2]|0;Re(v|0,w|0)|0;if((o|0)!=-1){if(!(Le(o|0,k|0)|0)){if(!(a[e>>0]&1))x=e+1|0;else x=c[e+8>>2]|0;c[h>>2]=c[k+12>>2];e=Cl(x|0,577,h|0)|0;if((e|0)!=-1){pO(o,e,c[k+40>>2]|0,l)|0;uk(e|0)|0}}uk(o|0)|0}if(!(a[b>>0]&1))y=b+1|0;else y=c[b+8>>2]|0;rri(m,y,SEi(y|0)|0);c[g>>2]=UG(m,c[(xd()|0)>>2]|0)|0;xri(m);s=0;i=f;return s|0}function jH(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+80|0;k=j;if((e|0)==2)l=1;else if((e|0)==3)l=2;else l=0;switch(d|0){case 2:{m=l|576;break}case 5:{m=l|512;break}case 6:case 4:{m=l|64;break}case 1:{m=l|192;break}default:m=l}l=(g&1|0)!=0?384:438;if(!(a[b>>0]&1))n=b+1|0;else n=c[b+8>>2]|0;c[k>>2]=l;d=Cl(n|0,m|0,k|0)|0;if((d|0)==-1){n=xd()|0;o=c[n>>2]|0;if((o|0)!=21){c[h>>2]=UG(b,o)|0;p=-1;i=j;return p|0}if(!(a[b>>0]&1))q=b+1|0;else q=c[b+8>>2]|0;c[k>>2]=l;l=Cl(q|0,m&-4|0,k|0)|0;if((l|0)==-1){c[h>>2]=UG(b,c[n>>2]|0)|0;p=-1;i=j;return p|0}else r=l}else r=d;if((Le(r|0,k|0)|0)==-1){c[h>>2]=TG(c[(xd()|0)>>2]|0)|0;uk(r|0)|0;p=-1;i=j;return p|0}BE(349376,0);d=c[k>>2]|0;l=c[k+72>>2]|0;n=c[87352]|0;a:do if(n){m=n;while(1){if((c[m+32>>2]|0)==(d|0)?(c[m+36>>2]|0)==(l|0):0){s=m;break}m=c[m+44>>2]|0;if(!m){t=26;break a}}EE(349376);if(s){m=c[s+24>>2]|0;if(((((m|0)!=0?!((m|0)==1&(e|0)!=1):0)?!((m|0)==2&(e|0)!=2):0)?(m=c[s+28>>2]|0,!((m&1|0)!=0&(f&1|0)==0)):0)?(f&2|0)!=0|(m&2|0)==0:0)break;c[h>>2]=32;uk(r|0)|0;p=-1;i=j;return p|0}}else t=26;while(0);if((t|0)==26)EE(349376);t=xCi(48)|0;s=t+8|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;n=t+40|0;c[n>>2]=0;c[t+44>>2]=0;c[t>>2]=r;yri(s,b)|0;c[t+20>>2]=g;c[t+28>>2]=e;c[t+24>>2]=f;c[t+32>>2]=d;c[t+36>>2]=l;BE(349376,0);if(!(c[87352]|0))c[87352]=t;else{c[(c[87354]|0)+44>>2]=t;c[n>>2]=c[87354]}c[87354]=t;EE(349376);n=c[k+12>>2]&61440;do if((n|0)!=4096){k=t+4|0;if((n|0)==8192){c[k>>2]=2;break}else{c[k>>2]=1;break}}else c[t+4>>2]=3;while(0);c[h>>2]=0;p=t;i=j;return p|0}function kH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((c[b+4>>2]|0)==1?(c[b+20>>2]&67108864|0)!=0:0){f=b+8|0;if(!(a[f>>0]&1))g=f+1|0;else g=c[b+16>>2]|0;cl(g|0)|0}uk(c[b>>2]|0)|0;BE(349376,0);if((c[87352]|0)==(b|0))c[87352]=c[b+44>>2];g=b+40|0;if((c[87354]|0)==(b|0))c[87354]=c[g>>2];f=c[g>>2]|0;g=b+44|0;if(f)c[f+44>>2]=c[g>>2];h=c[g>>2]|0;if(h)c[h+40>>2]=f;EE(349376);if(!b){c[d>>2]=0;i=e;return 1}xri(b+8|0);ACi(b);c[d>>2]=0;i=e;return 1}function lH(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;e=i;i=i+96|0;d=e+8|0;l=e;if(!(c[b+28>>2]&2)){c[k>>2]=5;m=0;i=e;return m|0}if((Le(c[b>>2]|0,d|0)|0)==-1){c[k>>2]=87;m=0;i=e;return m|0}do if((g|0)>-1|(g|0)==-1&f>>>0>4294967295){if(!(g>>>0<27111902|(g|0)==27111902&f>>>0<3577643008)){n=_Ei(f|0,g|0,717324288,-27111903)|0;o=hFi(n|0,H|0,1e7,0)|0;c[l>>2]=o;break}c[k>>2]=87;m=0;i=e;return m|0}else c[l>>2]=c[d+48>>2];while(0);do if((j|0)>-1|(j|0)==-1&h>>>0>4294967295){if(!(j>>>0<27111902|(j|0)==27111902&h>>>0<3577643008)){g=_Ei(h|0,j|0,717324288,-27111903)|0;f=hFi(g|0,H|0,1e7,0)|0;c[l+4>>2]=f;break}c[k>>2]=87;m=0;i=e;return m|0}else c[l+4>>2]=c[d+56>>2];while(0);d=b+8|0;if(!(a[d>>0]&1))p=d+1|0;else p=c[b+16>>2]|0;if((Xh(p|0,l|0)|0)==-1){c[k>>2]=87;m=0;i=e;return m|0}else{c[k>>2]=0;m=1;i=e;return m|0}return 0}function mH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+80|0;e=d;if((c[a+4>>2]|0)!=1){c[b>>2]=6;f=0;g=0;H=f;i=d;return g|0}if((Le(c[a>>2]|0,e|0)|0)==-1){c[b>>2]=TG(c[(xd()|0)>>2]|0)|0;f=-1;g=-1;H=f;i=d;return g|0}else{c[b>>2]=0;b=c[e+36>>2]|0;f=((b|0)<0)<<31>>31;g=b;H=f;i=d;return g|0}return 0}function nH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;d=i;if((c[a+4>>2]|0)!=1){c[e>>2]=6;f=0;i=d;return f|0}g=ud(c[a>>2]|0,0,1)|0;if((g|0)==-1){c[e>>2]=TG(c[(xd()|0)>>2]|0)|0;f=0;i=d;return f|0}if((ud(c[a>>2]|0,b|0,0)|0)==-1){c[e>>2]=TG(c[(xd()|0)>>2]|0)|0;f=0;i=d;return f|0}while(1){if((Rg(c[a>>2]|0,b|0)|0)!=-1)break;h=c[(xd()|0)>>2]|0;if((h|0)!=4){j=h;k=9;break}}if((k|0)==9){c[e>>2]=TG(j)|0;f=0;i=d;return f|0}if((ud(c[a>>2]|0,g|0,0)|0)==-1){c[e>>2]=TG(c[(xd()|0)>>2]|0)|0;f=0;i=d;return f|0}else{c[e>>2]=0;f=1;i=d;return f|0}return 0}function oH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;d=i;do if((c[a+4>>2]|0)==1){if(e>>>0>=3){c[f>>2]=87;g=-1;h=-1;break}j=ud(c[a>>2]|0,b|0,e|0)|0;if((j|0)==-1){c[f>>2]=TG(c[(xd()|0)>>2]|0)|0;g=-1;h=-1;break}else{c[f>>2]=0;g=((j|0)<0)<<31>>31;h=j;break}}else{c[f>>2]=6;g=0;h=0}while(0);H=g;i=d;return h|0}function pH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(!(c[a+28>>2]&1)){c[e>>2]=5;g=0;i=f;return g|0}while(1){h=ml(c[a>>2]|0,b|0,d|0)|0;if((h|0)!=-1){g=h;j=7;break}h=c[(xd()|0)>>2]|0;if((h|0)!=4){k=h;break}}if((j|0)==7){i=f;return g|0}c[e>>2]=TG(k)|0;g=0;i=f;return g|0}function qH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(!(c[a+28>>2]&2)){c[e>>2]=5;g=0;i=f;return g|0}while(1){h=gf(c[a>>2]|0,b|0,d|0)|0;if((h|0)!=-1){g=h;j=7;break}h=c[(xd()|0)>>2]|0;if((h|0)!=4){k=h;break}}if((j|0)==7){i=f;return g|0}c[e>>2]=TG(k)|0;g=0;i=f;return g|0}function rH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a+4>>2]|0)!=1){c[b>>2]=6;e=0;i=d;return e|0}if((hf(c[a>>2]|0)|0)==-1){c[b>>2]=TG(c[(xd()|0)>>2]|0)|0;e=0;i=d;return e|0}else{c[b>>2]=0;e=1;i=d;return e|0}return 0}function sH(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;g=i;i=i+32|0;e=g;j=g+8|0;b[j>>1]=1;b[j+2>>1]=0;c[j+4>>2]=d;c[j+8>>2]=f;while(1){f=c[a>>2]|0;c[e>>2]=j;if((Sk(f|0,13,e|0)|0)!=-1){k=6;break}f=c[(xd()|0)>>2]|0;if((f|0)==95|(f|0)==37){k=4;break}else if((f|0)!=4){l=f;k=5;break}}if((k|0)==4){c[h>>2]=0;i=g;return}else if((k|0)==5){c[h>>2]=TG(l)|0;i=g;return}else if((k|0)==6){c[h>>2]=0;i=g;return}}function tH(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;g=i;i=i+32|0;e=g;j=g+8|0;b[j>>1]=2;b[j+2>>1]=0;c[j+4>>2]=d;c[j+8>>2]=f;while(1){f=c[a>>2]|0;c[e>>2]=j;if((Sk(f|0,13,e|0)|0)!=-1){k=6;break}f=c[(xd()|0)>>2]|0;if((f|0)==95|(f|0)==37){k=4;break}else if((f|0)!=4){l=f;k=5;break}}if((k|0)==4){c[h>>2]=0;i=g;return}else if((k|0)==5){c[h>>2]=TG(l)|0;i=g;return}else if((k|0)==6){c[h>>2]=0;i=g;return}}function uH(){return}function vH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=cj(349424)|0;if(!d){e=cj(349432)|0;if(!e){f=uf(6,0)|0;if(!f){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=b;return}else g=f}else g=e}else g=d;if(((HEi(3654704,g)|0)!=0?(hCi(g,32)|0)==0:0)?(hCi(g,47)|0)==0:0){rri(a,g,SEi(g|0)|0);i=b;return};c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=b;return}function wH(a){a=a|0;var b=0,c=0;b=i;c=ADi(a)|0;i=b;return c|0}function xH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=DDi(a,b)|0;i=c;return d|0}function yH(a){a=a|0;var b=0;b=i;BDi(a);i=b;return}function zH(a){a=a|0;var b=0;b=i;EH(a,0);c[a+84>>2]=0;c[a+88>>2]=0;c[a+76>>2]=1;i=b;return}function AH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=GF()|0;f=a+84|0;if((c[f>>2]|0)==(e|0)){g=a+88|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}if(JH(a,-1,b)|0){i=d;return}c[f>>2]=e;c[a+88>>2]=1;i=d;return}function BH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=GF()|0;g=a+84|0;if((c[g>>2]|0)==(f|0)){h=a+88|0;c[h>>2]=(c[h>>2]|0)+1;j=1;i=e;return j|0}if(JH(a,b,d)|0){j=0;i=e;return j|0}c[g>>2]=f;c[a+88>>2]=1;j=1;i=e;return j|0}function CH(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+88|0;e=(c[d>>2]|0)+-1|0;c[d>>2]=e;if(e){i=b;return}e=a+4|0;pd(e|0)|0;c[a+76>>2]=1;c[a+84>>2]=0;if(c[a+80>>2]|0)Id(a+28|0)|0;ih(e|0)|0;i=b;return}function DH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=b+4|0;g=0;do{h=c[349440+(g<<2)>>2]|0;rri(e,h,SEi(h|0)|0);NG(b,e);xri(e);h=a[b>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[f>>2]|0;if(j){k=8;break}xri(b);g=g+1|0}while((g|0)!=3);if((k|0)==8){i=d;return}rri(b,349480,4);i=d;return}function EH(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=b;c[a+76>>2]=0;c[a+80>>2]=0;Be(a+4|0,0)|0;ui(a+28|0,0)|0;i=d;return}function FH(a){a=a|0;var b=0;b=i;pd(349488)|0;Jl(a+4|0)|0;nf(a+28|0)|0;ih(349488)|0;i=b;return}function GH(){var a=0;a=i;pd(349488)|0;i=a;return}function HH(){var a=0;a=i;ih(349488)|0;i=a;return}function IH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=JH(a,-1,b)|0;i=c;return d|0}function JH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=XH()|0;if((b|0)!=0&d)TH(g);h=a+4|0;pd(h|0)|0;j=a+76|0;a:do if(!(c[j>>2]|0))if(b){if(!(d?(UH(g,a),TH(g),(c[j>>2]|0)!=0):0))k=7;b:do if((k|0)==7){l=a+80|0;m=a+28|0;n=f+4|0;if((b|0)==-1)while(1){c[l>>2]=(c[l>>2]|0)+1;o=td(m|0,h|0)|0;c[l>>2]=(c[l>>2]|0)+-1;if(o){p=1;break a}if(d)TH(g);if(c[j>>2]|0)break b}if(d){o=b;while(1){q=aI()|0;c[f>>2]=(o>>>0)/1e3|0;c[n>>2]=((o>>>0)%1e3|0)*1e6;c[l>>2]=(c[l>>2]|0)+1;r=Rc(m|0,h|0,f|0)|0;c[l>>2]=(c[l>>2]|0)+-1;if((r|0)==110){p=2;break a}else if(r)break;r=q-(aI()|0)|0;TH(g);if(!(c[j>>2]|0))o=o>>>0<r>>>0?0:o-r|0;else break b}p=1;break a}else{o=b;while(1){r=aI()|0;c[f>>2]=(o>>>0)/1e3|0;c[n>>2]=((o>>>0)%1e3|0)*1e6;c[l>>2]=(c[l>>2]|0)+1;q=Rc(m|0,h|0,f|0)|0;c[l>>2]=(c[l>>2]|0)+-1;if((q|0)==110){p=2;break a}else if(q)break;q=r-(aI()|0)|0;if(!(c[j>>2]|0))o=o>>>0<q>>>0?0:o-q|0;else break b}p=1;break a}}while(0);if(d){UH(g,0);k=19}else k=19}else p=2;else k=19;while(0);do if((k|0)==19){g=c[a>>2]|0;if((g|0)==2|(g|0)==0){c[j>>2]=0;p=0;break}else if((g|0)!=3){p=0;break}g=c[j>>2]|0;if(((g|0)!=0?(d=g+-1|0,c[j>>2]=d,(d|0)!=0):0)?(c[a+80>>2]|0)!=0:0){Id(a+28|0)|0;p=0}else p=0}while(0);ih(h|0)|0;i=e;return p|0}function KH(a){a=a|0;var b=0;b=i;Id(a+28|0)|0;i=b;return}function LH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;EH(a,3);c[a+84>>2]=d;c[a+76>>2]=b;i=e;return}function MH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+4|0;pd(f|0)|0;g=a+76|0;h=c[g>>2]|0;j=_Ei(h|0,0,b|0,((b|0)<0)<<31>>31|0)|0;k=H;if(k>>>0>0|((k|0)==0?j>>>0>(c[a+84>>2]|0)>>>0:0)){ih(f|0)|0;l=0;i=e;return l|0}c[g>>2]=h+b;Id(a+28|0)|0;ih(f|0)|0;if(!d){l=1;i=e;return l|0}c[d>>2]=h;l=1;i=e;return l|0}function NH(a){a=a|0;var b=0;b=i;c[a+44>>2]=0;c[a+48>>2]=0;c[a+52>>2]=0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;Be(a+20|0,0)|0;i=b;return}function OH(a){a=a|0;var b=0,d=0,e=0;b=i;Jl(a+20|0)|0;d=c[a+44>>2]|0;if(!d){i=b;return}e=a+48|0;a=c[e>>2]|0;if((a|0)!=(d|0))c[e>>2]=a+(~((a+-4-d|0)>>>2)<<2);ACi(d);i=b;return}function PH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+48|0;f=e+4|0;g=e;c[a+12>>2]=b;c[a+16>>2]=d;if(((yc(f|0)|0)==0?(Rj(g|0,f|0,3331,a|0)|0)==0:0)?(Tc(f|0)|0)==0:0){c[a>>2]=c[g>>2];h=0}else h=31;i=e;return h|0}function QH(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=1;ko[c[a+12>>2]&4095](c[a+16>>2]|0);c[d>>2]=3;i=b;return 0}function RH(a,b){a=a|0;b=b|0;return}function SH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=a+20|0;pd(f|0)|0;g=a+48|0;h=c[g>>2]|0;if((h|0)==(c[a+52>>2]|0))qO(a+44|0,e);else{if(!h)j=0;else{c[h>>2]=b;j=c[g>>2]|0}c[g>>2]=j+4}ih(f|0)|0;GH();f=c[a+8>>2]|0;if(!f){HH();i=d;return}KH(f);HH();i=d;return}function TH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;pd(d|0)|0;e=a+44|0;f=c[e>>2]|0;g=a+48|0;a=c[g>>2]|0;if((f|0)==(a|0)){ih(d|0)|0;i=b;return}else{h=a;j=f}do{f=c[j>>2]|0;a=j+4|0;k=h-a|0;aFi(j|0,a|0,k|0)|0;a=j+(k>>2<<2)|0;k=c[g>>2]|0;if((k|0)!=(a|0))c[g>>2]=k+(~((k+-4-a|0)>>>2)<<2);ih(d|0)|0;eo[f&511]();pd(d|0)|0;j=c[e>>2]|0;h=c[g>>2]|0}while((j|0)!=(h|0));ih(d|0)|0;i=b;return}function UH(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function VH(a){a=a|0;var b=0;b=i;yE(349512,a,1)|0;i=b;return}function WH(){var a=0,b=0;a=i;b=pe()|0;H=0;i=a;return b|0}function XH(){var a=0,b=0;a=i;b=c[(GF()|0)>>2]|0;i=a;return b|0}function YH(){var a=0,b=0;a=i;b=xCi(56)|0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+52>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;Be(b+20|0,0)|0;c[b>>2]=pe()|0;i=a;return b|0}function ZH(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;Cg(d|0,0)|0;c[a>>2]=c[d>>2];i=b;return}function _H(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(Tj(c[a>>2]|0,b|0)|0)==0;i=d;return (e?0:31)|0}function $H(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=Fd(c[a>>2]|0)|0;i=d;return 0}function aI(){var a=0,b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=i;i=i+32|0;b=a+8|0;d=a+16|0;e=a;f=349520;if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0){f=ed(349544,2417856)|0;do if(!f){g=-1294967296;j=0}else{c[b>>2]=e;if(($c(f|0,349560,b|0)|0)!=1){dj(f|0)|0;g=-1294967296;j=0;break}if(!(c[87383]|0)){k=(pk(1,349528)|0)==0&1;c[87384]=k;l=k}else l=c[87384]|0;if((l|0)!=0?(Oh(1,d|0)|0)==0:0){k=c[d>>2]|0;m=gFi(k|0,((k|0)<0)<<31>>31|0,1e7,0)|0;k=(c[d+4>>2]|0)/100|0;n=_Ei(k|0,((k|0)<0)<<31>>31|0,m|0,H|0)|0;o=n;p=H}else if(!(Mi(b|0,0)|0)){n=c[b>>2]|0;m=gFi(n|0,((n|0)<0)<<31>>31|0,1e6,0)|0;n=c[b+4>>2]|0;k=_Ei(m|0,H|0,n|0,((n|0)<0)<<31>>31|0)|0;n=gFi(k|0,H|0,10,0)|0;o=n;p=H}else{o=0;p=0}dj(f|0)|0;q=+h[e>>3]*1.0e7;n=ZEi(o|0,p|0,~~q>>>0|0,(+S(q)>=1.0?(q>0.0?(ha(+R(q/4294967296.0),4294967295.0)|0)>>>0:~~+ca((q-+(~~q>>>0))/4294967296.0)>>>0):0)|0)|0;g=n;j=H}while(0);p=349520;c[p>>2]=g;c[p+4>>2]=j}if(!(c[87383]|0)){j=(pk(1,349528)|0)==0&1;c[87384]=j;r=j}else r=c[87384]|0;if((r|0)!=0?(Oh(1,d|0)|0)==0:0){r=c[d>>2]|0;j=gFi(r|0,((r|0)<0)<<31>>31|0,1e7,0)|0;r=(c[d+4>>2]|0)/100|0;d=_Ei(r|0,((r|0)<0)<<31>>31|0,j|0,H|0)|0;s=d;t=H;u=349520;v=u;w=c[v>>2]|0;x=u+4|0;y=x;z=c[y>>2]|0;A=ZEi(s|0,t|0,w|0,z|0)|0;B=H;C=eFi(A|0,B|0,1e4,0)|0;D=H;i=a;return C|0}if(Mi(b|0,0)|0){s=0;t=0;u=349520;v=u;w=c[v>>2]|0;x=u+4|0;y=x;z=c[y>>2]|0;A=ZEi(s|0,t|0,w|0,z|0)|0;B=H;C=eFi(A|0,B|0,1e4,0)|0;D=H;i=a;return C|0}d=c[b>>2]|0;j=gFi(d|0,((d|0)<0)<<31>>31|0,1e6,0)|0;d=c[b+4>>2]|0;b=_Ei(j|0,H|0,d|0,((d|0)<0)<<31>>31|0)|0;d=gFi(b|0,H|0,10,0)|0;s=d;t=H;u=349520;v=u;w=c[v>>2]|0;x=u+4|0;y=x;z=c[y>>2]|0;A=ZEi(s|0,t|0,w|0,z|0)|0;B=H;C=eFi(A|0,B|0,1e4,0)|0;D=H;i=a;return C|0}function bI(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;b=a+8|0;d=a;if(!(c[87383]|0)){e=(pk(1,349528)|0)==0&1;c[87384]=e;f=e}else f=c[87384]|0;if((f|0)!=0?(Oh(1,d|0)|0)==0:0){f=c[d>>2]|0;e=gFi(f|0,((f|0)<0)<<31>>31|0,1e7,0)|0;f=(c[d+4>>2]|0)/100|0;d=_Ei(f|0,((f|0)<0)<<31>>31|0,e|0,H|0)|0;g=H;h=d;H=g;i=a;return h|0}if(Mi(b|0,0)|0){g=0;h=0;H=g;i=a;return h|0}d=c[b>>2]|0;e=gFi(d|0,((d|0)<0)<<31>>31|0,1e6,0)|0;d=c[b+4>>2]|0;b=_Ei(e|0,H|0,d|0,((d|0)<0)<<31>>31|0)|0;d=gFi(b|0,H|0,10,0)|0;g=H;h=d;H=g;i=a;return h|0}function cI(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a;if(Mi(b|0,0)|0){d=0;e=0;H=d;i=a;return e|0}f=c[b>>2]|0;g=gFi(f|0,((f|0)<0)<<31>>31|0,1e6,0)|0;f=_Ei(g|0,H|0,-13910016,14467070)|0;g=c[b+4>>2]|0;b=_Ei(f|0,H|0,g|0,((g|0)<0)<<31>>31|0)|0;g=gFi(b|0,H|0,10,0)|0;d=H;e=g;H=d;i=a;return e|0}function dI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0;e=i;i=i+208|0;f=e+4|0;g=e+52|0;h=e+8|0;j=e+100|0;k=e;l=e+144|0;m=e+96|0;n=h+0|0;o=n+44|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));c[h+12>>2]=1;c[h+20>>2]=a+-1900;p=Mf(h|0)|0;c[k>>2]=p;if((a+-1970|0)>>>0>67|(p|0)==-1){c[k>>2]=pl(0)|0;n=j+0|0;q=(Wd(k|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));vg(l|0,64,349568,j|0)|0;zri(d,l)|0;zri(d+12|0,l)|0;i=e;return 1}c[f>>2]=p;n=g+0|0;q=(Bi(f|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[g+32>>2]=c[h+32>>2];h=Mf(g|0)|0;p=j+32|0;a=g+32|0;r=g+32|0;s=g+32|0;t=d+12|0;u=b+16|0;v=g+32|0;w=b+24|0;x=g+32|0;y=0;z=~~+Sg(c[f>>2]|0,h|0);h=0;while(1){c[k>>2]=(c[k>>2]|0)+86400;n=j+0|0;q=(Wd(k|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[f>>2]=c[k>>2];n=g+0|0;q=(Bi(f|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[a>>2]=c[p>>2];A=Mf(g|0)|0;if((~~+Sg(c[f>>2]|0,A|0)|0)==(z|0)){B=z;C=h}else{A=c[k>>2]|0;c[m>>2]=A;D=A;while(1){c[m>>2]=D+-3600;A=c[(Wd(m|0)|0)+32>>2]|0;c[f>>2]=c[m>>2];n=g+0|0;q=(Bi(f|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[r>>2]=A;E=Mf(g|0)|0;if((~~+Sg(c[f>>2]|0,E|0)|0)==(z|0))break;D=c[m>>2]|0}do{c[m>>2]=(c[m>>2]|0)+60;D=c[(Wd(m|0)|0)+32>>2]|0;c[f>>2]=c[m>>2];n=g+0|0;q=(Bi(f|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[s>>2]=D;A=Mf(g|0)|0}while((~~+Sg(c[f>>2]|0,A|0)|0)==(z|0));c[m>>2]=(c[m>>2]|0)+z;vg(l|0,64,349568,j|0)|0;if(h){F=11;break}zri(t,l)|0;A=c[m>>2]|0;E=gFi(A|0,((A|0)<0)<<31>>31|0,1e7,0)|0;A=_Ei(E|0,H|0,-139100160,144670709)|0;E=b;c[E>>2]=A;c[E+4>>2]=H;E=gFi(z|0,((z|0)<0)<<31>>31|0,1e7,0)|0;A=u;c[A>>2]=E;c[A+4>>2]=H;c[f>>2]=c[k>>2];n=g+0|0;q=(Bi(f|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[v>>2]=c[p>>2];A=Mf(g|0)|0;E=~~+Sg(c[f>>2]|0,A|0)-z|0;A=gFi(E|0,((E|0)<0)<<31>>31|0,1e7,0)|0;E=w;c[E>>2]=A;c[E+4>>2]=H;c[f>>2]=c[k>>2];n=g+0|0;q=(Bi(f|0)|0)+0|0;o=n+44|0;do{c[n>>2]=c[q>>2];n=n+4|0;q=q+4|0}while((n|0)<(o|0));c[x>>2]=c[p>>2];E=Mf(g|0)|0;B=~~+Sg(c[f>>2]|0,E|0);C=1}y=y+1|0;if((y|0)>=365){G=B;I=C;break}else{z=B;h=C}}if((F|0)==11){zri(d,l)|0;F=c[m>>2]|0;m=gFi(F|0,((F|0)<0)<<31>>31|0,1e7,0)|0;F=_Ei(m|0,H|0,-139100160,144670709)|0;m=b+8|0;c[m>>2]=F;c[m+4>>2]=H;i=e;return 1}if(I){i=e;return 1}vg(l|0,64,349568,j|0)|0;zri(d,l)|0;zri(t,l)|0;l=gFi(G|0,((G|0)<0)<<31>>31|0,1e7,0)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;b=u;c[b>>2]=l;c[b+4>>2]=H;b=w;c[b>>2]=0;c[b+4>>2]=0;i=e;return 1}function eI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a[d>>0]|0;if(!(f&1))g=(f&255)>>>1;else g=c[d+4>>2]|0;if(!g){rri(b,3672776,1);i=e;return}g=Mri(d,47,-1)|0;if((g|0)==-1){sri(b,d);i=e;return}else{vri(b,d,g+1|0,-1,d);i=e;return}}function fI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a[d>>0]|0;if(!(f&1))g=(f&255)>>>1;else g=c[d+4>>2]|0;if(!g){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}g=Mri(d,47,-1)|0;if((g|0)==-1){rri(b,3672776,1);i=e;return}else if(!g){rri(b,63e4,1);i=e;return}else{vri(b,d,0,g,d);i=e;return}}function gI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;d=e;a=c[87394]|0;if(!a){f=xCi(12)|0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;c[f>>2]=g;c[87394]=f;h=f}else h=a;a=h+4|0;f=c[a>>2]|0;do if(f){g=f;while(1){j=c[g+16>>2]|0;if(j>>>0>b>>>0){k=c[g>>2]|0;if(!k){l=g;m=g;n=6;break}else{g=k;continue}}if(j>>>0>=b>>>0){o=g;n=10;break}j=g+4|0;k=c[j>>2]|0;if(!k){p=j;q=g;n=9;break}else g=k}if((n|0)==6){c[d>>2]=m;r=l;s=m;break}else if((n|0)==9){c[d>>2]=q;r=p;s=q;break}else if((n|0)==10){c[d>>2]=o;r=d;s=o;break}}else{g=h+4|0;c[d>>2]=g;r=g;s=g}while(0);if(c[r>>2]|0){i=e;return}d=xCi(20)|0;c[d+16>>2]=b;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=s;c[r>>2]=d;s=c[c[h>>2]>>2]|0;if(!s)t=d;else{c[h>>2]=s;t=c[r>>2]|0}GN(c[a>>2]|0,t);t=h+8|0;c[t>>2]=(c[t>>2]|0)+1;i=e;return}function hI(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;b=c[87394]|0;d=c[b>>2]|0;if((d|0)==(b+4|0)){i=a;return}else e=d;while(1){eo[c[e+16>>2]&511]();d=c[e+4>>2]|0;if(!d){b=e;while(1){f=c[b+8>>2]|0;if((c[f>>2]|0)==(b|0)){g=f;break}else b=f}}else{b=d;while(1){f=c[b>>2]|0;if(!f){g=b;break}else b=f}}if((g|0)==((c[87394]|0)+4|0))break;else e=g}i=a;return}function iI(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;d=a[b>>0]|0;if(!(d<<24>>24)){e=5381;i=c;return e|0}else{f=d;g=5381;h=b}while(1){h=h+1|0;b=(f&255)+(g*33|0)|0;f=a[h>>0]|0;if(!(f<<24>>24)){e=b;break}else g=b}i=c;return e|0}function jI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[g>>2]=e;k=uEi(f+48|0,0,d,g)|0;if((k|0)==-1){rri(b,0,SEi(0)|0);xri(h);i=f;return}Bri(h,k+1|0,0);c[j>>2]=e;e=a[h>>0]|0;if(!(e&1)){l=h+1|0;m=(e&255)>>>1}else{l=c[h+8>>2]|0;m=c[h+4>>2]|0}if((uEi(l,m,d,j)|0)==-1){rri(b,0,SEi(0)|0);xri(h);i=f;return}else{sri(b,h);xri(h);i=f;return}}function kI(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;if(!(b[d>>1]|0)){k=0;l=d}else{m=0;n=d;while(1){o=n+2|0;p=m+1|0;if(!(b[o>>1]|0)){k=p;l=o;break}else{m=p;n=o}}};c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Dri(a,k);if((l|0)==(d|0)){i=f;return}k=d;d=a;while(1){a=k+2|0;n=e[k>>1]|0;if((n&64512|0)==55296){q=k+4|0;r=(n<<10)+-56613888+(e[a>>1]|0)|0}else{q=a;r=n}c[j>>2]=d;c[g+0>>2]=c[j+0>>2];rO(h,r,g);if((q|0)==(l|0))break;else{k=q;d=c[h>>2]|0}}i=f;return}function lI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;sO(a,d);c[g>>2]=a;c[f+0>>2]=c[g+0>>2];tO(e,b,b+d|0,f);i=e;return}function mI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(b<<1)+2|0;b=ADi(d)|0;YEi(b|0,a|0,d|0)|0;i=c;return b|0}function nI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=(Ori(b,c)|0)==0;i=a;return d|0}function oI(c,e,f){c=c|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=i;g=e;e=f;while(1){f=a[g>>0]|0;h=a[e>>0]|0;if(f<<24>>24==0|h<<24>>24==0){j=(f|h)<<24>>24==0;k=41;break}l=f&255;a:do if(f<<24>>24<=-1){do if((l&224|0)==192){m=g+1|0;n=m;o=(d[m>>0]|0)&63|l<<6&1984}else{if((l&240|0)==224){m=g+2|0;n=m;o=(d[g+1>>0]|0)<<6&4032|l<<12&61440|(d[m>>0]|0)&63;break}if((l&248|0)!=240){k=10;break a}m=g+3|0;n=m;o=(d[g+1>>0]|0)<<12&258048|l<<18&1835008|(d[g+2>>0]|0)<<6&4032|(d[m>>0]|0)&63}while(0);m=n+1|0;if(o>>>0>65535){p=(o&1023|56320)&65535;q=(o>>>10)+55232|0;r=m}else{p=0;q=o;r=m}}else k=10;while(0);if((k|0)==10){k=0;p=0;q=l;r=g+1|0}f=q&65535;m=h&255;b:do if(h<<24>>24<=-1){do if((m&224|0)==192){s=e+1|0;t=s;u=(d[s>>0]|0)&63|m<<6&1984}else{if((m&240|0)==224){s=e+2|0;t=s;u=(d[e+1>>0]|0)<<6&4032|m<<12&61440|(d[s>>0]|0)&63;break}if((m&248|0)!=240){k=20;break b}s=e+3|0;t=s;u=(d[e+1>>0]|0)<<12&258048|m<<18&1835008|(d[e+2>>0]|0)<<6&4032|(d[s>>0]|0)&63}while(0);s=t+1|0;if(u>>>0>65535){v=(u&1023|56320)&65535;w=(u>>>10)+55232|0;x=s}else{v=0;w=u;x=s}}else k=20;while(0);if((k|0)==20){k=0;v=0;w=m;x=e+1|0}h=w&65535;l=q&65535;if((f&65535)>=9424)if((f&65535)>65312)y=b[368432+(l+-65313<<1)>>1]|0;else y=f;else y=b[349584+(l<<1)>>1]|0;l=w&65535;if((h&65535)>=9424)if((h&65535)>65312)z=b[368432+(l+-65313<<1)>>1]|0;else z=h;else z=b[349584+(l<<1)>>1]|0;if(y<<16>>16!=z<<16>>16){j=0;k=41;break}l=p&65535;if((p&65535)>=9424)if((p&65535)>65312)A=b[368432+(l+-65313<<1)>>1]|0;else A=p;else A=b[349584+(l<<1)>>1]|0;l=v&65535;if((v&65535)>=9424)if((v&65535)>65312)B=b[368432+(l+-65313<<1)>>1]|0;else B=v;else B=b[349584+(l<<1)>>1]|0;if(A<<16>>16==B<<16>>16){g=r;e=x}else{j=0;k=41;break}}if((k|0)==41){i=c;return j|0}return 0}function pI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;b=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;d=oI(0,f,e)|0;i=b;return d|0}function qI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a[b>>0]|0;if(!(f&1))g=(f&255)>>>1;else g=c[b+4>>2]|0;f=a[d>>0]|0;h=(f&1)==0;if(h)j=(f&255)>>>1;else j=c[d+4>>2]|0;if(g>>>0<j>>>0){k=0;i=e;return k|0}if(h)l=d+1|0;else l=c[d+8>>2]|0;k=(Lri(b,l,g-j|0,j)|0)!=-1;i=e;return k|0}function rI(a){a=a|0;return c[a+120>>2]|0}function sI(a){a=a|0;return c[a+12>>2]|0}function tI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b>>2]|0;f=c[b+8>>2]|0;if(f){g=a[e+144>>0]|0;if(!(g<<24>>24))h=1;else{j=g&255;g=0;k=1;while(1){l=da(c[f+(g<<3)>>2]|0,k)|0;g=g+1|0;if((g|0)>=(j|0)){h=l;break}else k=l}}}else h=c[b+12>>2]|0;b=da(c[e+120>>2]|0,h)|0;i=d;return b|0}function uI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=vI(JI(a,1)|0,b)|0;i=c;return d|0}function vI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((d|0)<0)FJ(PJ(3068960)|0);f=da(c[b+120>>2]|0,d)|0;g=f+16|0;do if(a[b+151>>0]|0)if(!(c[b+4>>2]|0)){h=mL(g,b)|0;break}else{h=oL(g,b)|0;break}else{j=nL(g,b)|0;c[j+8>>2]=0;PEi(j+8|0,0,f+8|0)|0;h=j}while(0);c[h+12>>2]=d;if(!0){i=e;return h|0}JL(h,b);i=e;return h|0}function wI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=b+144|0;h=a[g>>0]|0;if(h<<24>>24){j=h;k=0;while(1){if((c[d+(k<<2)>>2]|0)<0){l=4;break}k=k+1|0;m=j&255;if((k|0)>=(m|0)){n=j;o=m;break}}if((l|0)==4)FJ(PJ(3068960)|0);l=c[b+120>>2]|0;j=o<<3;if(!(n<<24>>24)){p=0;q=1}else{o=n&255;k=0;m=1;while(1){r=da(c[d+(k<<2)>>2]|0,m)|0;k=k+1|0;if((k|0)>=(o|0)){p=n;q=r;break}else m=r}}m=da(q,l)|0;if(!(p<<24>>24)){s=j;t=0;u=m+16|0;v=q}else{s=j;t=1;u=(m+19&-4)+j|0;v=q}}else{s=(h&255)<<3;t=0;u=(c[b+120>>2]|0)+16|0;v=1}do if(a[b+151>>0]|0)if(!(c[b+4>>2]|0)){mL(u,b)|0;break}else{oL(u,b)|0;break}else PEi((nL(u,b)|0)+8|0,0,u+-8|0)|0;while(0);h=mL(u,b)|0;c[h+12>>2]=v;if(t?(t=h+(u-s)|0,c[h+8>>2]=t,s=a[g>>0]|0,s<<24>>24!=0):0){g=s&255;if(!e){s=0;do{c[t+(s<<3)>>2]=c[d+(s<<2)>>2];s=s+1|0}while((s|0)<(g|0))}else{s=0;do{c[t+(s<<3)>>2]=c[d+(s<<2)>>2];c[t+(s<<3)+4>>2]=c[e+(s<<2)>>2];s=s+1|0}while((s|0)<(g|0))}}if(!0){i=f;return h|0}JL(h,b);i=f;return h|0}function xI(a){a=a|0;return c[a+120>>2]|0}function yI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=a+16+(da(c,b)|0)|0;return d|0}function zI(){return 368880}function AI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[92220]|0;e=c[92221]|0;a:do if((d|0)==(e|0))f=0;else{g=d;while(1){h=c[g>>2]|0;g=g+4|0;if(!(HEi(c[h>>2]|0,a)|0)){f=h;break a}if((g|0)==(e|0)){f=0;break}}}while(0);i=b;return f|0}function BI(a){a=a|0;return c[a+56>>2]|0}function CI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=SEi(b|0)|0;f=c[92220]|0;g=c[92221]|0;a:do if((f|0)==(g|0))h=f;else{j=f;while(1){k=c[j>>2]|0;j=j+4|0;if(!(HEi(b,c[k>>2]|0)|0)){l=k;break}if((j|0)==(g|0)){h=g;break a}}i=d;return l|0}while(0);do if((b|0)!=0?(g=SEi(b|0)|0,g>>>0>=4):0){if((IEi(b+(g+-4)|0,616280,4)|0)!=0?(IEi(b+(g+-4)|0,368896,4)|0)!=0:0)break;if((f|0)==(h|0)){l=0;i=d;return l|0}else m=f;while(1){g=c[m>>2]|0;m=m+4|0;if(!(HEi(b,c[c[g+56>>2]>>2]|0)|0)){l=g;n=14;break}if((m|0)==(h|0)){l=0;n=14;break}}if((n|0)==14){i=d;return l|0}}while(0);n=e+5|0;h=zCi(n)|0;PEi(h|0,0,n|0)|0;YEi(h|0,b|0,e|0)|0;b=h+e|0;a[b>>0]=46;a[b+1>>0]=100;a[b+2>>0]=108;a[b+3>>0]=108;e=CI(h)|0;if(!e){a[b>>0]=46;a[b+1>>0]=101;a[b+2>>0]=120;a[b+3>>0]=101;o=CI(h)|0}else o=e;BCi(h);l=o;i=d;return l|0}function DI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;qK(c[a+56>>2]|0);e=c[92221]|0;if((e|0)==(c[92222]|0)){uO(368880,d);i=b;return}if(!e)f=0;else{c[e>>2]=a;f=c[92221]|0}c[92221]=f+4;i=b;return}function EI(){var a=0,b=0,d=0;a=i;b=c[92220]|0;if((b|0)==(c[92221]|0)){i=a;return}else d=b;do{uK(c[(c[d>>2]|0)+56>>2]|0);d=d+4|0}while((d|0)!=(c[92221]|0));i=a;return}function FI(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+336|0;g=f+316|0;h=f+304|0;j=f+160|0;k=f+16|0;l=f;m=k+64|0;n=k+8|0;c[n>>2]=73864;o=k+12|0;c[k>>2]=74012;c[m>>2]=74032;c[k+4>>2]=0;esi(k+64|0,o);c[k+136>>2]=0;c[k+140>>2]=-1;c[k>>2]=73844;c[m>>2]=73884;c[n>>2]=73864;jsi(o);c[o>>2]=74048;n=k+44|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[k+60>>2]=24;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;yN(o,g);xri(g);n=c[e>>2]|0;p=uN(uN(k+8|0,n,SEi(n|0)|0)|0,368904,10)|0;n=uN(dti(p,b[e+48>>1]|0)|0,3672776,1)|0;p=uN(dti(n,b[e+50>>1]|0)|0,3672776,1)|0;n=uN(dti(p,b[e+52>>1]|0)|0,3672776,1)|0;p=uN(dti(n,b[e+54>>1]|0)|0,368920,10)|0;n=c[e+4>>2]|0;if(!n)q=368936;else q=(a[n>>0]|0)==0?368936:n;n=uN(uN(p,q,SEi(q|0)|0)|0,368944,17)|0;q=e+16|0;if(!(a[q>>0]|0)){p=uN(n,603880,SEi(603880)|0)|0;r=(c[e+44>>2]&256|0)!=0;uN(p,r?368968:3653512,r?18:0)|0;zN(d,o);AN(k,73896);bsi(m);i=f;return}r=j+64|0;p=j+8|0;c[p>>2]=73864;s=j+12|0;c[j>>2]=74012;c[r>>2]=74032;c[j+4>>2]=0;esi(j+64|0,s);c[j+136>>2]=0;c[j+140>>2]=-1;c[j>>2]=73844;c[r>>2]=73884;c[p>>2]=73864;jsi(s);c[s>>2]=74048;p=j+44|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[j+60>>2]=24;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;yN(s,h);xri(h);h=a[q>>0]|0;if(h<<24>>24){q=j+8|0;p=h;t=h&255;h=0;while(1){a[g>>0]=((p&255)<160?48:87)+((p&255)>>>4&255);uN(q,g,1)|0;u=t&15;a[g>>0]=((u&255)<10?48:87)+u;uN(q,g,1)|0;h=h+1|0;u=a[e+h+16>>0]|0;if(!(u<<24>>24))break;else{p=u;t=u&255}}}zN(l,s);AN(j,73896);bsi(r);if(!(a[l>>0]&1))v=l+1|0;else v=c[l+8>>2]|0;r=uN(n,v,SEi(v|0)|0)|0;v=(c[e+44>>2]&256|0)!=0;uN(r,v?368968:3653512,v?18:0)|0;xri(l);zN(d,o);AN(k,73896);bsi(m);i=f;return}function GI(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b;do switch((c[a+4>>2]|0)>>>16&255|0){case 17:case 18:{f=c[a>>2]|0;break}case 12:{g=c[a>>2]|0;f=(g|0)==0?c[101536]|0:g;break}case 19:{f=c[(c[a>>2]|0)+8>>2]|0;break}case 15:{g=rJ(GI(c[a>>2]|0)|0)|0;i=b;return g|0}case 29:{f=AK(c[a>>2]|0,1,0)|0;break}case 21:{f=mK(c[a>>2]|0)|0;break}case 22:{c[e>>2]=369008;gl(406304,e|0)|0;f=0;break}case 27:{c[e>>2]=369008;gl(406304,e|0)|0;f=0;break}case 25:{g=c[a>>2]|0;f=(g|0)==0?c[101533]|0:g;break}case 30:{f=c[(c[a>>2]|0)+8>>2]|0;break}case 9:{g=c[a>>2]|0;f=(g|0)==0?c[101531]|0:g;break}case 14:{g=c[a>>2]|0;f=(g|0)==0?c[101539]|0:g;break}case 4:{g=c[a>>2]|0;f=(g|0)==0?c[101527]|0:g;break}case 10:{g=c[a>>2]|0;f=(g|0)==0?c[101534]|0:g;break}case 28:{g=c[a>>2]|0;f=(g|0)==0?c[101523]|0:g;break}case 3:{g=c[a>>2]|0;f=(g|0)==0?c[101538]|0:g;break}case 13:{g=c[a>>2]|0;f=(g|0)==0?c[101537]|0:g;break}case 2:{g=c[a>>2]|0;f=(g|0)==0?c[101526]|0:g;break}case 1:{g=c[a>>2]|0;f=(g|0)==0?c[101525]|0:g;break}case 5:{g=c[a>>2]|0;f=(g|0)==0?c[101524]|0:g;break}case 11:{g=c[a>>2]|0;f=(g|0)==0?c[101535]|0:g;break}case 24:{g=c[a>>2]|0;f=(g|0)==0?c[101532]|0:g;break}case 8:{g=c[a>>2]|0;f=(g|0)==0?c[101530]|0:g;break}case 20:{g=c[a>>2]|0;f=AK(c[g>>2]|0,d[g+4>>0]|0,1)|0;break}case 7:{g=c[a>>2]|0;f=(g|0)==0?c[101529]|0:g;break}case 6:{g=c[a>>2]|0;f=(g|0)==0?c[101528]|0:g;break}default:{c[e>>2]=369008;gl(406304,e|0)|0;f=0}}while(0);i=b;return f|0}function HI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=AK(a,b,c)|0;i=d;return e|0}function II(a){a=a|0;var b=0,c=0;b=i;c=rJ(GI(a)|0)|0;i=b;return c|0}function JI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=AK(a,b,0)|0;i=c;return d|0}function KI(a){a=a|0;return c[a+8>>2]|0}function LI(a){a=a|0;var b=0,d=0;b=i;d=GI(c[a+8>>2]|0)|0;i=b;return d|0}function MI(a){a=a|0;return c[a+44>>2]|0}function NI(a){a=a|0;var b=0,d=0;b=c[a+44>>2]|0;if((b|0)==(a|0))d=0;else d=c[b+64>>2]|0;return d|0}function OI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;do if(b){e=c[b>>2]|0;if(!e){f=a+24|0;g=c[f>>2]|0;if(!g){h=0;break}c[b>>2]=g;h=c[c[f>>2]>>2]|0;break}else{f=e+4|0;if(!(c[f>>2]|0)){h=0;break}c[b>>2]=f;h=c[f>>2]|0;break}}else h=0;while(0);i=d;return h|0}function PI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;if(!a){e=0;i=d;return e|0}else f=a;a:while(1){a=f+24|0;g=0;while(1){if(!g){h=c[a>>2]|0;if(!h)break;j=c[h>>2]|0;if(!j)break;else{k=j;l=h}}else{h=g+4|0;j=c[h>>2]|0;if(!j)break;else{k=j;l=h}}if(!(HEi(b,$J(k)|0)|0)){e=k;m=9;break a}else g=l}f=c[f+32>>2]|0;if(!f){e=0;m=9;break}}if((m|0)==9){i=d;return e|0}return 0}function QI(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+147>>0]|0))RI(b)|0;if(!(a[b+154>>0]|0)){e=0;i=d;return e|0}e=c[(c[b+52>>2]|0)+(c[92258]<<2)>>2]|0;i=d;return e|0}function RI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+147|0;if(a[e>>0]|0){i=d;return 1}BE(369056,0);if(a[e>>0]|0){EE(369056);i=d;return 1}f=b+152|0;a[f>>0]=1;g=(c[(c[b+64>>2]|0)+4>>2]|0)>>>16&255;if((g|0)==29|(g|0)==20?(g=c[b+44>>2]|0,(a[g+147>>0]|0)==0):0)RI(g)|0;g=406072;h=_Ei(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;g=406072;c[g>>2]=h;c[g+4>>2]=H;g=c[b+32>>2]|0;if((g|0)!=0?(a[g+147>>0]|0)==0:0)RI(g)|0;g=b+153|0;if(!(a[g>>0]|0)){gJ(b);a[g>>0]=1}if(a[b+144>>0]|0)hJ(b);if((c[101523]|0)==(b|0)?(g=c[b+52>>2]|0,h=c[g>>2]|0,(h|0)!=0):0){j=h;h=0;k=g;while(1){g=c[j>>2]|0;if((HEi(g,3082280)|0)!=0?(HEi(g,2967640)|0)==0:0)c[92258]=h;k=k+4|0;j=c[k>>2]|0;if(!j)break;else h=h+1|0}}vO(b);a[e>>0]=1;a[f>>0]=0;EE(369056);i=d;return 1}function SI(a){a=a|0;return c[a+116>>2]|0}function TI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;do if(b){e=c[b>>2]|0;if(!e){f=a+16|0;g=c[f>>2]|0;if(!g){h=0;break}c[b>>2]=g;h=c[c[f>>2]>>2]|0;break}else{f=e+4|0;if(!(c[f>>2]|0)){h=0;break}c[b>>2]=f;h=c[f>>2]|0;break}}else h=0;while(0);i=d;return h|0}function UI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=VI(a,b,c,0)|0;i=d;return e|0}function VI(b,f,g,h){b=b|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;RI(b)|0;if(!b){k=0;i=j;return k|0}l=(g|0)==-1;m=b;while(1){b=c[m+16>>2]|0;a:do if(!b)n=0;else{if(l){o=0;while(1){if(!o){p=c[b>>2]|0;if(!p){n=0;break a}else{q=p;r=b}}else{p=o+4|0;s=c[p>>2]|0;if(!s){n=0;break a}else{q=s;r=p}}p=c[q>>2]|0;if((a[p>>0]|0)!=(a[f>>0]|0)){o=r;continue}if(HEi(f,p)|0){o=r;continue}if((e[q+28>>1]&h|0)==(h|0)){n=q;break a}else o=r}}else t=0;while(1){if(!t){o=c[b>>2]|0;if(!o){n=0;break a}else{u=o;v=b}}else{o=t+4|0;p=c[o>>2]|0;if(!p){n=0;break a}else{u=p;v=o}}o=c[u>>2]|0;if((a[o>>0]|0)!=(a[f>>0]|0)){t=v;continue}if(HEi(f,o)|0){t=v;continue}if((d[u+34>>0]|0)!=(g|0)){t=v;continue}if((e[u+28>>1]&h|0)==(h|0)){n=u;break}else t=v}}while(0);m=c[m+32>>2]|0;if(!((m|0)!=0&(n|0)==0)){k=n;break}}i=j;return k|0}function WI(a){a=a|0;return c[a+8>>2]|0}function XI(a){a=a|0;return c[a+12>>2]|0}function YI(a){a=a|0;return e[a+158>>1]|0|0}function ZI(a){a=a|0;return e[a+162>>1]|0|0}function _I(a){a=a|0;return c[a+32>>2]|0}function $I(a,b){a=a|0;b=b|0;return (c[a+116>>2]|0)+-8|0}function aJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;a:do if(!a)e=0;else{f=a;while(1){if((f|0)==(b|0)){e=1;break a}f=c[f+32>>2]|0;if(!f){e=0;break}}}while(0);i=d;return e|0}function bJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b;b=d;while(1){if(a[f+146>>0]|0){g=f;h=b;break}d=a[f+144>>0]|0;if(!(d<<24>>24)){j=f;k=b;l=19;break}if((a[b+144>>0]|0)!=d<<24>>24){m=0;l=27;break}d=c[b+60>>2]|0;n=c[f+60>>2]|0;if(!(a[d+145>>0]|0)){f=n;b=d}else{o=d;p=n;l=6;break}}if((l|0)==6){switch((c[(c[p+64>>2]|0)+4>>2]|0)>>>16&255|0){case 25:case 24:{q=c[101532]|0;break}case 5:case 4:{q=c[101527]|0;break}case 11:case 10:{q=c[101534]|0;break}case 7:case 6:{q=c[101528]|0;break}case 9:case 8:{q=c[101530]|0;break}default:q=p}switch((c[(c[o+64>>2]|0)+4>>2]|0)>>>16&255|0){case 5:case 4:{r=c[101527]|0;break}case 9:case 8:{r=c[101530]|0;break}case 11:case 10:{r=c[101534]|0;break}case 7:case 6:{r=c[101528]|0;break}case 25:case 24:{r=c[101532]|0;break}default:r=o}m=(q|0)==(r|0);i=e;return m|0}else if((l|0)==19)if((c[101523]|0)==(j|0)){m=1;i=e;return m|0}else{g=j;h=k}else if((l|0)==27){i=e;return m|0}if(!h){m=0;i=e;return m|0}else s=h;a:while(1){if((s|0)==(g|0)){m=1;l=27;break}h=c[s+48>>2]|0;if((h|0)!=0?(k=c[h>>2]|0,(k|0)!=0):0){j=k;k=h;do{k=k+4|0;if((j|0)==(g|0)){m=1;l=27;break a}j=c[k>>2]|0}while((j|0)!=0)}s=c[s+32>>2]|0;if(!s){m=0;l=27;break}}if((l|0)==27){i=e;return m|0}return 0}function cJ(b){b=b|0;return (a[b+150>>0]|0)!=0|0}function dJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;a:do if(e?(a[d+146>>0]|0)!=0:0){if(a[b+146>>0]|0){g=c[b+48>>2]|0;if(!g)break;else h=g;while(1){g=c[h>>2]|0;if(!g)break a;if((g|0)==(d|0)){j=1;break}h=h+4|0}i=f;return j|0}if(b){g=b;b:while(1){k=c[g+48>>2]|0;c:do if(k){l=k;while(1){m=c[l>>2]|0;if(!m)break c;if((m|0)==(d|0)){j=1;break b}l=l+4|0}}while(0);g=c[g+32>>2]|0;if(!g)break a}i=f;return j|0}}else n=14;while(0);d:do if((n|0)==14?!((a[b+146>>0]|0)!=0|(b|0)==0):0){h=b;while(1){if((h|0)==(d|0)){j=1;break}h=c[h+32>>2]|0;if(!h)break d}i=f;return j|0}while(0);j=(c[101523]|0)==(d|0);i=f;return j|0}function eJ(b){b=b|0;return (a[b+145>>0]|0)!=0|0}function fJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[a+76>>2]|0;if(!e){f=-1;i=d;return f|0}else{g=0;h=e}while(1){e=c[h>>2]|0;if(!e){f=-1;j=6;break}if((e|0)==(b|0)){k=g;break}g=g+1|0;h=h+4|0}if((j|0)==6){i=d;return f|0}f=c[(c[a+72>>2]|0)+(k<<2)>>2]|0;i=d;return f|0}function gJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=c[b+32>>2]|0;if(f){g=b+151|0;a[g>>0]=a[g>>0]|a[f+151>>0]}f=c[b+24>>2]|0;a:do if(f){g=f;while(1){h=c[g>>2]|0;if(!h)break a;j=c[h+4>>2]|0;do if(!(c[j+4>>2]&16)){h=cN(j)|0;if(!(dN(h)|0)){if(!(eN(h)|0))break;k=GI(h)|0;if((a[k+152>>0]|0)==0?(RI(k)|0,(a[k+151>>0]|0)==0):0)break}a[b+151>>0]=1}while(0);g=g+4|0}}while(0);f=c[b+128>>2]|0;do if(f){c[b+92>>2]=Ks(f,0)|0;g=c[92249]|0;if((g|0)==(c[92250]|0)){RN(368992,e);break}if(!g)l=0;else{c[g>>2]=b;l=c[92249]|0}c[92249]=l+4}while(0);l=c[b+132>>2]|0;if(!l){i=d;return}c[b+136>>2]=KM(l)|0;i=d;return}function hJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+44>>2]|0;f=e+8|0;g=SEi(c[f>>2]|0)|0;h=a[b+144>>0]|0;j=h&255;k=ADi(g+3+j|0)|0;YEi(k|0,c[f>>2]|0,g|0)|0;a[k+g>>0]=91;if((h&255)>1)PEi(k+(g+1)|0,44,j+-1|0)|0;h=j+g|0;a[k+h>>0]=93;a[k+(h+1)>>0]=0;c[b+8>>2]=k;k=e+149|0;if(!(a[k>>0]|0))l=e;else l=c[e+44>>2]|0;h=b+60|0;c[h>>2]=l;do if((l|0)==(c[101527]|0))c[h>>2]=c[101524];else{if((l|0)==(c[101529]|0)){c[h>>2]=c[101528];break}if((l|0)==(c[101531]|0)){c[h>>2]=c[101530];break}if((l|0)==(c[101535]|0)){c[h>>2]=c[101534];break}if((l|0)!=(c[101532]|0)?!(hM(l)|0):0)break;c[h>>2]=c[101530]}while(0);if((a[k>>0]|0)!=0?(a[e+144>>0]|0)==0:0)c[b+120>>2]=c[e+120>>2];RI(e)|0;if(dN(c[e+64>>2]|0)|0){m=1;n=b+151|0;a[n>>0]=m;i=d;return}m=a[e+151>>0]|0;n=b+151|0;a[n>>0]=m;i=d;return}function iJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=vK(a,b,c)|0;i=d;return e|0}function jJ(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b[d+158>>1]|0;if(!(f<<16>>16)){g=0;i=e;return g|0}h=c[d+16>>2]|0;d=0;while(1){j=c[h+(d<<2)>>2]|0;if((IEi(c[j>>2]|0,3072840,6)|0)==0?(a[j+34>>0]|0)==0:0){g=1;k=6;break}d=d+1|0;if((d|0)>=(f&65535|0)){g=0;k=6;break}}if((k|0)==6){i=e;return g|0}return 0}function kJ(a){a=a|0;return c[a+140>>2]|0}function lJ(a){a=a|0;return (c[a+140>>2]&128|0)!=0|0}function mJ(b){b=b|0;return (a[b+146>>0]|0)!=0|0}function nJ(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+80>>2]|0;if(!d){e=0;i=b;return e|0}e=(c[d>>2]|0)==(c[101563]|0);i=b;return e|0}function oJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=b;f=c[b+64>>2]|0;a:while(1){b=f;b:while(1){switch((c[b+4>>2]|0)>>>16&255|0){case 3:case 7:case 6:{g=14;break a;break}case 30:case 19:case 20:case 29:case 28:case 14:case 18:case 15:case 25:case 24:case 12:case 9:case 8:{h=4;break a;break}case 2:case 5:case 4:{g=13;break a;break}case 17:{j=b;break b;break}case 13:case 11:case 10:{g=4;break a;break}case 1:{g=11;break a;break}case 21:break;default:{g=12;break a}}b=c[(c[c[b>>2]>>2]|0)+64>>2]|0}b=c[j>>2]|0;if(!(a[b+149>>0]|0)){k=e;g=9;break}l=c[b+44>>2]|0;if((l|0)==(b|0))m=0;else m=c[l+64>>2]|0;e=c[e+44>>2]|0;f=m}if((g|0)==4)h=8;else if((g|0)==9)h=(c[k+116>>2]|0)+-8|0;else if((g|0)==11)h=0;else if((g|0)==12)h=-1;else if((g|0)==13)h=1;else if((g|0)==14)h=2;i=d;return h|0}function pJ(a){a=a|0;return c[a+64>>2]|0}function qJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;if(!(c[a+84>>2]|0))e=a;else e=wO(a,b,0,0)|0;a=c[b+112>>2]|0;f=b+116|0;a:do if((a|0)==(c[f>>2]|0))g=e;else{b=e;h=a;j=0;while(1){k=c[h>>2]|0;if((k|0)==-2){l=b;m=1}else if((k|0)==-1){l=rJ(b)|0;m=j}else if(!k){n=b;break}else{l=AK(b,k,j)|0;m=j}h=h+4|0;if((h|0)==(c[f>>2]|0)){g=l;break a}else{b=l;j=m}}o=c[n+68>>2]|0;i=d;return o|0}while(0);if(!g){o=0;i=d;return o|0}o=c[g+64>>2]|0;i=d;return o|0}function rJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+4|0;g=c[b>>2]|0;BE(406264,0);h=IK(g,b)|0;if(h){j=h;EE(406264);i=d;return j|0}h=CDi(1,168)|0;c[h+32>>2]=0;c[h+12>>2]=c[b+12>>2];c[e>>2]=c[b+8>>2];jI(f,369064,e);if(!(a[f>>0]&1))k=f+1|0;else k=c[f+8>>2]|0;c[h+8>>2]=jCi(k)|0;xri(f);c[h>>2]=c[b>>2];a[h+147>>0]=1;c[h+140>>2]=c[b+140>>2]&7;c[h+116>>2]=4;c[h+44>>2]=b;c[h+60>>2]=b;f=CDi(1,8)|0;k=CDi(1,8)|0;c[k+4>>2]=983040;e=c[b+64>>2]|0;c[k>>2]=e;c[f>>2]=e;c[f+4>>2]=1074724864;c[h+68>>2]=f;c[h+64>>2]=k;JK(g,b,h);j=h;EE(406264);i=d;return j|0}function sJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=XL(a)|0;a=e+4|0;if((c[e>>2]|0)>0)f=0;else{g=0;i=d;return g|0}while(1){if((sL(c[(c[a>>2]|0)+(f<<2)>>2]|0)|0)==(b|0)){g=1;h=4;break}f=f+1|0;if((f|0)>=(c[e>>2]|0)){g=0;h=4;break}}if((h|0)==4){i=d;return g|0}return 0}function tJ(b){b=b|0;return (a[b+149>>0]|0)!=0|0}function uJ(a){a=a|0;return c[a>>2]|0}function vJ(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!(a[d+155>>0]|0)){f=0;i=e;return f|0}RI(d)|0;g=d;while(1){d=c[g+16>>2]|0;a:do if(!d)h=0;else{j=0;while(1){if(!j){k=c[d>>2]|0;if(!k){h=0;break a}else{l=k;m=d}}else{k=j+4|0;n=c[k>>2]|0;if(!n){h=0;break a}else{l=n;m=k}}k=c[l>>2]|0;if((a[k>>0]|0)!=46){j=m;continue}if(HEi(3076392,k)|0){j=m;continue}if(!(b[l+28>>1]&2048))j=m;else{h=l;break}}}while(0);g=c[g+32>>2]|0;if(!((g|0)!=0&(h|0)==0)){f=h;break}}i=e;return f|0}function wJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[(c[a+8>>2]|0)+88>>2]|0;f=c[e>>2]|0;if(!f){g=0;i=d;return g|0}else{h=f;j=e}while(1){j=j+4|0;if((c[h>>2]|0)==(a|0)){k=h;break}h=c[j>>2]|0;if(!h){g=0;l=5;break}}if((l|0)==5){i=d;return g|0}c[b>>2]=c[k+8>>2];g=c[k+4>>2]|0;i=d;return g|0}function xJ(){return 368992}function yJ(a){a=a|0;return c[c[a>>2]>>2]|0}function zJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=b+24|0;h=a[g>>0]|0;j=(h&1)==0;if(j)k=(h&255)>>>1;else k=c[b+28>>2]|0;do if(!k){h=rK()|0;l=zK(h,b)|0;if(l){m=l;n=d^1;break}if((h|0)==(sK()|0)){o=0;p=19}else{o=zK(sK()|0,b)|0;p=19}}else{if(j)q=g+1|0;else q=c[b+32>>2]|0;h=CI(q)|0;l=(h|0)==0;r=d^1;if(!(l^1|r))FJ(OJ()|0);if(!l){l=BI(h)|0;h=(l|0)==0;if(!(h^1|r))FJ(OJ()|0);if(!h){o=zK(l,b)|0;p=19}else{o=0;p=19}}else{o=0;p=19}}while(0);if((p|0)==19){p=(o|0)==0;q=d^1;if(!(p^1|q))FJ(OJ()|0);if(p){s=0;i=f;return s|0}else{m=o;n=q}}q=qJ(wO(m,b,d,e)|0,b)|0;if(n|(q|0)!=0){s=q;i=f;return s|0}else FJ(OJ()|0);return 0}function AJ(){var a=0,b=0,d=0,e=0;a=i;b=c[92300]|0;if(!b){d=Ks(16,0)|0;c[92300]=d;e=d}else e=b;i=a;return e|0}function BJ(){var a=0,b=0,d=0,e=0;a=i;b=c[92300]|0;if(!b){d=Ks(16,0)|0;c[92300]=d;e=d}else e=b;i=a;return e|0}function CJ(a,b){a=a|0;b=b|0;c[92304]=a;c[92302]=b;return}function DJ(){return c[92304]|0}function EJ(){return c[92302]|0}function FJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;MM(d);b=d+4|0;e=(c[b>>2]|0)-(c[d>>2]|0)>>2;f=uI(c[101532]|0,e)|0;g=c[d>>2]|0;if((g|0)!=(c[b>>2]|0)){d=g;g=e;do{g=g+-1|0;e=yI(f,4,g)|0;c[e>>2]=c[d>>2];d=d+4|0}while((d|0)!=(c[b>>2]|0))}c[a+8>>2]=f;f=al(4)|0;c[f>>2]=a;we(f|0,342032,0)}function GJ(){var a=0;a=qL(iJ(sK()|0,3496376,3114576)|0)|0;dM(a);FJ(a)}function HJ(){var a=0;a=qL(iJ(sK()|0,3496376,3101296)|0)|0;dM(a);FJ(a)}function IJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=qL(iJ(a,b,d)|0)|0;dM(g);if(!e){i=f;return g|0}c[g+16>>2]=qM(e)|0;i=f;return g|0}function JJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=qL(iJ(sK()|0,3496376,3026840)|0)|0;dM(e);if(b)c[e+16>>2]=qM(b)|0;if(!a){i=d;return e|0}c[e+52>>2]=qM(a)|0;i=d;return e|0}function KJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3027280)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+52>>2]=qM(a)|0;i=b;return d|0}function LJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=qL(iJ(sK()|0,3496376,3127592)|0)|0;dM(e);if(a)c[e+16>>2]=qM(a)|0;if(!b){i=d;return e|0}c[e+12>>2]=b;i=d;return e|0}function MJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3084824)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function NJ(){var a=0,b=0;a=i;b=qL(iJ(sK()|0,3496376,3084336)|0)|0;dM(b);i=a;return b|0}function OJ(){var a=0,b=0;a=i;b=qL(iJ(sK()|0,3496376,3128128)|0)|0;dM(b);i=a;return b|0}function PJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3114888)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function QJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3079816)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function RJ(){var a=0,b=0;a=i;b=qL(iJ(sK()|0,3496376,3119840)|0)|0;dM(b);i=a;return b|0}function SJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3100808)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function TJ(){var a=0,b=0;a=i;b=qL(iJ(sK()|0,3496376,3028840)|0)|0;dM(b);i=a;return b|0}function UJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3128128)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function VJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3085392)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function WJ(){var a=0,b=0;a=i;b=qL(iJ(sK()|0,3009648,3017896)|0)|0;dM(b);i=a;return b|0}function XJ(){var a=0,b=0;a=i;b=qL(iJ(sK()|0,3009648,3019120)|0)|0;dM(b);i=a;return b|0}function YJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3009648,3013352)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function ZJ(a){a=a|0;var b=0,d=0;b=i;d=qL(iJ(sK()|0,3496376,3090080)|0)|0;dM(d);if(!a){i=b;return d|0}c[d+16>>2]=qM(a)|0;i=b;return d|0}function _J(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+160|0;f=e+144|0;g=e;h=g+64|0;j=g+8|0;c[j>>2]=73864;k=g+12|0;c[g>>2]=74012;c[h>>2]=74032;c[g+4>>2]=0;esi(g+64|0,k);c[g+136>>2]=0;c[g+140>>2]=-1;c[g>>2]=73844;c[h>>2]=73884;c[j>>2]=73864;jsi(k);c[k>>2]=74048;j=g+44|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[g+60>>2]=24;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(k,f);xri(f);if(!((b|0)!=0&(d|0)!=0)){zN(a,k);AN(g,73896);bsi(h);i=e;return}f=uN(g+8|0,369224,31)|0;j=c[b+8>>2]|0;b=uN(uN(f,j,SEi(j|0)|0)|0,369256,11)|0;j=c[d+8>>2]|0;uN(uN(b,j,SEi(j|0)|0)|0,369272,2)|0;zN(a,k);AN(g,73896);bsi(h);i=e;return}function $J(a){a=a|0;return c[a>>2]|0}function aK(a){a=a|0;return c[a+8>>2]|0}function bK(a){a=a|0;return c[(c[a+4>>2]|0)+4>>2]&65535|0}function cK(a){a=a|0;return c[a+12>>2]|0}function dK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;zO(c[b+4>>2]|0,d,a+(c[b+12>>2]|0)|0,1);i=e;return}function eK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=e+4|0;h=b+4|0;j=c[h>>2]|0;k=c[j+4>>2]|0;switch(k>>>16&255|0){case 29:case 20:case 18:case 28:case 14:{l=1;break}case 21:{l=(a[(c[c[j>>2]>>2]|0)+145>>0]|0)!=1;break}case 17:case 13:case 10:case 11:case 12:case 8:case 9:case 24:case 25:case 3:case 6:case 7:case 2:case 4:case 5:{l=(k&1073741824|0)!=0;break}default:{m=0;i=e;return m|0}}if(k&16){k=c[b+8>>2]|0;if(!(a[k+148>>0]|0)){lM(k);n=1}else n=1}else n=0;if(l){if(n)fK(b,g);else zO(c[h>>2]|0,g,d+(c[b+12>>2]|0)|0,1);m=c[g>>2]|0;i=e;return m|0}l=GI(c[h>>2]|0)|0;if(nJ(l)|0){c[f>>2]=369280;gl(406304,f|0)|0}f=qL(l)|0;c[g>>2]=f;g=f+8|0;if(n){fK(b,g);m=f;i=e;return m|0}else{zO(c[h>>2]|0,g,d+(c[b+12>>2]|0)|0,1);m=f;i=e;return m|0}return 0}function fK(d,e){d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;j=f;k=f+4|0;l=d+4|0;if(!(c[(c[l>>2]|0)+4>>2]&64)){m=d+8|0;RI(c[m>>2]|0)|0;n=c[d+12>>2]|0;if((n|0)==-1){c[j>>2]=369336;gl(406304,j|0)|0;o=0}else o=(c[(c[m>>2]|0)+92>>2]|0)+n|0;zO(c[l>>2]|0,e,o,1);i=f;return}o=wJ(d,k)|0;switch(c[k>>2]|0){case 13:{h[e>>3]=+h[o>>3];i=f;return}case 4:case 5:case 2:{a[e>>0]=a[o>>0]|0;i=f;return}case 12:{g[e>>2]=ea(g[o>>2]);i=f;return}case 18:{c[e>>2]=0;c[j>>2]=369304;gl(406304,j|0)|0;i=f;return}case 14:{c[j>>2]=369304;gl(406304,j|0)|0;i=f;return}case 6:case 7:case 3:{b[e>>1]=b[o>>1]|0;i=f;return}case 8:case 9:{c[e>>2]=c[o>>2];i=f;return}case 10:case 11:{j=o;o=c[j+4>>2]|0;k=e;c[k>>2]=c[j>>2];c[k+4>>2]=o;i=f;return}default:{i=f;return}}}function gK(a){a=a|0;return c[a+4>>2]|0}function hK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=VL(a)|0;a=e+4|0;if((c[e>>2]|0)>0)f=0;else{g=0;i=d;return g|0}while(1){if((sL(c[(c[a>>2]|0)+(f<<2)>>2]|0)|0)==(b|0)){g=1;h=4;break}f=f+1|0;if((f|0)>=(c[e>>2]|0)){g=0;h=4;break}}if((h|0)==4){i=d;return g|0}return 0}function iK(a){a=a|0;return 0}function jK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;zO(c[b+4>>2]|0,a+(c[b+12>>2]|0)|0,d,0);i=e;return}function kK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=a+8|0;RI(c[f>>2]|0)|0;g=c[a+12>>2]|0;if((g|0)==-1){c[e>>2]=369360;gl(406304,e|0)|0;h=0}else h=(c[(c[f>>2]|0)+92>>2]|0)+g|0;zO(c[a+4>>2]|0,h,b,0);i=d;return}function lK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=c[(c[a+4>>2]|0)+4>>2]|0;if(d&32768){e=wJ(a,b+4|0)|0;i=b;return e|0}if(!(d&256)){e=0;i=b;return e|0}e=wJ(a,b)|0;i=b;return e|0}function mK(a){a=a|0;return c[a+12>>2]|0}function nK(b){b=b|0;return (a[(c[b>>2]|0)+145>>0]|0)!=0|0}function oK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pK(b,c)|0;i=a;return d|0}function pK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e;g=c[b+4>>2]|0;h=g>>>16&255;j=c[d+4>>2]|0;a:do if((h|0)==(j>>>16&255|0)){k=j;l=g;m=h;n=b;o=d;b:while(1){if((k^l)&1073741824){p=0;break a}switch(m|0){case 22:case 28:case 25:case 24:case 14:case 13:case 12:case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:case 3:case 2:case 1:{p=1;break a;break}case 29:case 18:case 17:{q=n;r=o;s=4;break b;break}case 20:{t=n;u=o;s=6;break b;break}case 21:{v=n;w=o;s=8;break b;break}case 15:break;case 30:case 19:{x=n;y=o;s=14;break b;break}default:{s=15;break b}}n=c[n>>2]|0;o=c[o>>2]|0;l=c[n+4>>2]|0;m=l>>>16&255;k=c[o+4>>2]|0;if((m|0)!=(k>>>16&255|0)){p=0;break a}}if((s|0)==4){p=(c[q>>2]|0)==(c[r>>2]|0);break}else if((s|0)==6){k=c[t>>2]|0;m=c[u>>2]|0;if((a[k+4>>0]|0)!=(a[m+4>>0]|0)){p=0;break}p=(c[k>>2]|0)==(c[m>>2]|0);break}else if((s|0)==8){m=c[v>>2]|0;k=c[m+4>>2]|0;o=c[w>>2]|0;l=c[o+4>>2]|0;if((c[k>>2]|0)!=(c[l>>2]|0)){p=0;break}if(!(pK(c[(c[m>>2]|0)+64>>2]|0,c[(c[o>>2]|0)+64>>2]|0)|0)){p=0;break}if(!(c[k>>2]|0)){p=1;break}o=k+4|0;m=l+4|0;l=0;while(1){if(!(pK(c[(c[o>>2]|0)+(l<<2)>>2]|0,c[(c[m>>2]|0)+(l<<2)>>2]|0)|0)){p=0;break a}l=l+1|0;if(l>>>0>=(c[k>>2]|0)>>>0){p=1;break}}}else if((s|0)==14){p=(c[x>>2]|0)==(c[y>>2]|0);break}else if((s|0)==15){c[f>>2]=369384;gl(406304,f|0)|0;p=0;break}}else p=0;while(0);i=e;return p|0}function qK(a){a=a|0;var b=0,d=0,e=0;b=i;d=xCi(144)|0;PEi(d|0,0,140)|0;c[d+12>>2]=d+16;e=d+28|0;c[e>>2]=0;c[d+32>>2]=0;c[d+24>>2]=e;e=d+40|0;c[e>>2]=0;c[d+44>>2]=0;c[d+36>>2]=e;e=d+52|0;c[e>>2]=0;c[d+56>>2]=0;c[d+48>>2]=e;e=d+64|0;c[e>>2]=0;c[d+68>>2]=0;c[d+60>>2]=e;e=d+76|0;c[e>>2]=0;c[d+80>>2]=0;c[d+72>>2]=e;e=d+88|0;c[e>>2]=0;c[d+92>>2]=0;c[d+84>>2]=e;e=d+100|0;c[e>>2]=0;c[d+104>>2]=0;c[d+96>>2]=e;e=d+112|0;c[e>>2]=0;c[d+116>>2]=0;c[d+108>>2]=e;e=d+124|0;c[e>>2]=0;c[d+128>>2]=0;c[d+120>>2]=e;e=d+136|0;c[e>>2]=0;c[d+140>>2]=0;c[d+132>>2]=e;c[a+4>>2]=d;i=b;return}function rK(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;b=a;MM(b);d=b+4|0;e=c[d>>2]|0;f=c[b>>2]|0;b=(e|0)==(f|0);a:do if(b){g=e;h=5}else{j=c[101522]|0;k=e;while(1){l=c[c[(c[k+-4>>2]|0)+8>>2]>>2]|0;if(!((l|0)==0|(l|0)==(j|0))){g=k;h=5;break a}k=k+-4|0;if((k|0)==(f|0)){m=406088;break}}}while(0);if((h|0)==5)if((g|0)==(f|0))m=406088;else m=c[(c[g+-4>>2]|0)+8>>2]|0;g=c[m>>2]|0;if(!f){i=a;return g|0}if(!b)c[d>>2]=e+(~((e+-4-f|0)>>>2)<<2);ACi(f);i=a;return g|0}function sK(){return c[101522]|0}function tK(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+16|0;b=a;MM(b);d=b+4|0;e=c[d>>2]|0;f=c[b>>2]|0;b=(e|0)==(f|0);a:do if(b){g=e;h=5}else{j=c[101522]|0;k=e;while(1){l=c[c[(c[k+-4>>2]|0)+8>>2]>>2]|0;if(!((l|0)==0|(l|0)==(j|0))){g=k;h=5;break a}k=k+-4|0;if((k|0)==(f|0)){m=406088;break}}}while(0);b:do if((h|0)==5)if((g|0)!=(f|0)?(k=g+-4|0,(k|0)!=(f|0)):0){j=c[101522]|0;l=g;n=k;while(1){k=c[c[(c[l+-8>>2]|0)+8>>2]>>2]|0;if(!((k|0)==0|(k|0)==(j|0))){o=n;break}k=l+-8|0;if((k|0)==(f|0)){m=406088;break b}else{p=n;n=k;l=p}}if((o|0)!=(f|0))m=c[(c[o+-4>>2]|0)+8>>2]|0;else m=406088}else m=406088;while(0);o=c[m>>2]|0;if(!f){i=a;return o|0}if(!b)c[d>>2]=e+(~((e+-4-f|0)>>>2)<<2);ACi(f);i=a;return o|0}function uK(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=i;i=i+16|0;f=d+4|0;g=d;h=c[a+8>>2]|0;j=c[h>>2]|0;if(j){k=a+4|0;l=j;j=h;do{h=c[k>>2]|0;m=h+16|0;n=c[m>>2]|0;do if(n){o=n;while(1){p=c[o+16>>2]|0;if(l>>>0<p>>>0){q=c[o>>2]|0;if(!q){r=o;s=o;t=6;break}else{o=q;continue}}if(p>>>0>=l>>>0){u=o;t=10;break}p=o+4|0;q=c[p>>2]|0;if(!q){v=p;w=o;t=9;break}else o=q}if((t|0)==6){t=0;c[g>>2]=s;x=r;y=s;break}else if((t|0)==9){t=0;c[g>>2]=w;x=v;y=w;break}else if((t|0)==10){t=0;c[g>>2]=u;x=g;y=u;break}}else{o=h+16|0;c[g>>2]=o;x=o;y=o}while(0);if(!(c[x>>2]|0)){n=xCi(20)|0;c[n+16>>2]=c[j>>2];c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=y;c[x>>2]=n;o=h+12|0;q=c[c[o>>2]>>2]|0;if(!q)z=n;else{c[o>>2]=q;z=c[x>>2]|0}GN(c[m>>2]|0,z);q=h+20|0;c[q>>2]=(c[q>>2]|0)+1}q=c[j>>2]|0;if(b[q+158>>1]|0){o=q;q=0;do{mM(c[(c[o+16>>2]|0)+(q<<2)>>2]|0);q=q+1|0;o=c[j>>2]|0}while(q>>>0<(e[o+158>>1]|0)>>>0)}j=j+4|0;l=c[j>>2]|0}while((l|0)!=0)}l=c[a+16>>2]|0;j=c[l>>2]|0;if(j){z=j;j=l;do{c[z>>2]=c[c[z+44>>2]>>2];j=j+4|0;z=c[j>>2]|0}while((z|0)!=0)}z=a+20|0;j=c[z>>2]|0;x=c[j>>2]|0;if(x){y=x;x=j;do{c[y>>2]=c[c[y+44>>2]>>2];x=x+4|0;y=c[x>>2]|0}while((y|0)!=0)}y=c[l>>2]|0;if(!y)A=j;else{j=y;y=l;do{l=c[j+44>>2]|0;x=c[(c[l>>2]|0)+4>>2]|0;g=x+28|0;u=c[g>>2]|0;do if(u){w=u;while(1){v=c[w+16>>2]|0;if(l>>>0<v>>>0){s=c[w>>2]|0;if(!s){B=w;C=w;t=28;break}else{w=s;continue}}if(v>>>0>=l>>>0){D=w;t=32;break}v=w+4|0;s=c[v>>2]|0;if(!s){E=v;F=w;t=31;break}else w=s}if((t|0)==28){t=0;c[f>>2]=C;G=B;H=C;break}else if((t|0)==31){t=0;c[f>>2]=F;G=E;H=F;break}else if((t|0)==32){t=0;c[f>>2]=D;G=f;H=D;break}}else{w=x+28|0;c[f>>2]=w;G=w;H=w}while(0);u=c[G>>2]|0;if(!u){w=xCi(24)|0;c[w+16>>2]=l;c[w+20>>2]=0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=H;c[G>>2]=w;s=x+24|0;v=c[c[s>>2]>>2]|0;if(!v)I=w;else{c[s>>2]=v;I=c[G>>2]|0}GN(c[g>>2]|0,I);v=x+32|0;c[v>>2]=(c[v>>2]|0)+1;J=w}else J=u;c[J+20>>2]=j;y=y+4|0;j=c[y>>2]|0}while((j|0)!=0);A=c[z>>2]|0}z=c[A>>2]|0;if(z){j=z;z=A;do{A=c[j+44>>2]|0;y=c[(c[A>>2]|0)+4>>2]|0;J=A;I=j;G=y+40|0;H=c[G>>2]|0;if(!H){D=y+40|0;K=D;L=D}else{D=H;while(1)if(A>>>0<(c[D+16>>2]|0)>>>0){H=c[D>>2]|0;if(!H){K=D;L=D;break}else{D=H;continue}}else{H=D+4|0;F=c[H>>2]|0;if(!F){K=H;L=D;break}else{D=F;continue}}}D=xCi(24)|0;A=D+16|0;c[A>>2]=J;c[A+4>>2]=I;c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=L;c[K>>2]=D;A=y+36|0;x=c[c[A>>2]>>2]|0;if(!x)M=D;else{c[A>>2]=x;M=c[K>>2]|0}GN(c[G>>2]|0,M);x=y+44|0;c[x>>2]=(c[x>>2]|0)+1;z=z+4|0;j=c[z>>2]|0}while((j|0)!=0)}j=c[a+12>>2]|0;z=c[j>>2]|0;if(z){M=z;z=j;do{j=c[c[M+80>>2]>>2]|0;K=c[(c[M>>2]|0)+4>>2]|0;L=j;x=M;A=K+52|0;D=c[A>>2]|0;if(!D){g=K+52|0;N=g;O=g}else{g=D;while(1)if(j>>>0<(c[g+16>>2]|0)>>>0){D=c[g>>2]|0;if(!D){N=g;O=g;break}else{g=D;continue}}else{D=g+4|0;l=c[D>>2]|0;if(!l){N=D;O=g;break}else{g=l;continue}}}g=xCi(24)|0;j=g+16|0;c[j>>2]=L;c[j+4>>2]=x;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=O;c[N>>2]=g;j=K+48|0;y=c[c[j>>2]>>2]|0;if(!y)P=g;else{c[j>>2]=y;P=c[N>>2]|0}GN(c[A>>2]|0,P);y=K+56|0;c[y>>2]=(c[y>>2]|0)+1;z=z+4|0;M=c[z>>2]|0}while((M|0)!=0)}M=c[a+28>>2]|0;z=c[M>>2]|0;if(z){P=M;N=z;z=M;while(1){M=P+4|0;O=c[M>>2]|0;y=c[(c[c[O+8>>2]>>2]|0)+4>>2]|0;if(!(b[O+28>>1]&64))Q=N;else{j=O;g=N;G=y+76|0;I=c[G>>2]|0;if(!I){J=y+76|0;R=J;S=J}else{J=I;while(1)if(O>>>0<(c[J+16>>2]|0)>>>0){I=c[J>>2]|0;if(!I){R=J;S=J;break}else{J=I;continue}}else{I=J+4|0;l=c[I>>2]|0;if(!l){R=I;S=J;break}else{J=l;continue}}}J=xCi(24)|0;O=J+16|0;c[O>>2]=j;c[O+4>>2]=g;c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=S;c[R>>2]=J;O=y+72|0;K=c[c[O>>2]>>2]|0;if(!K)T=J;else{c[O>>2]=K;T=c[R>>2]|0}GN(c[G>>2]|0,T);K=y+80|0;c[K>>2]=(c[K>>2]|0)+1;Q=c[z>>2]|0}mM(Q);K=c[M>>2]|0;O=K;J=c[z>>2]|0;A=y+64|0;x=c[A>>2]|0;if(!x){L=y+64|0;U=L;V=L}else{L=x;while(1)if(K>>>0<(c[L+16>>2]|0)>>>0){x=c[L>>2]|0;if(!x){U=L;V=L;break}else{L=x;continue}}else{x=L+4|0;l=c[x>>2]|0;if(!l){U=x;V=L;break}else{L=l;continue}}}L=xCi(24)|0;K=L+16|0;c[K>>2]=O;c[K+4>>2]=J;c[L>>2]=0;c[L+4>>2]=0;c[L+8>>2]=V;c[U>>2]=L;K=y+60|0;G=c[c[K>>2]>>2]|0;if(!G)W=L;else{c[K>>2]=G;W=c[U>>2]|0}GN(c[A>>2]|0,W);G=y+68|0;c[G>>2]=(c[G>>2]|0)+1;G=c[P+8>>2]|0;K=c[z>>2]|0;L=y+88|0;g=c[L>>2]|0;do if(g){j=g;while(1){l=c[j+16>>2]|0;if(K>>>0<l>>>0){x=c[j>>2]|0;if(!x){X=j;Y=j;t=79;break}else{j=x;continue}}if(l>>>0>=K>>>0){Z=j;t=83;break}l=j+4|0;x=c[l>>2]|0;if(!x){_=l;$=j;t=82;break}else j=x}if((t|0)==79){t=0;c[f>>2]=Y;aa=X;ba=Y;break}else if((t|0)==82){t=0;c[f>>2]=$;aa=_;ba=$;break}else if((t|0)==83){t=0;c[f>>2]=Z;aa=f;ba=Z;break}}else{j=y+88|0;c[f>>2]=j;aa=j;ba=j}while(0);g=c[aa>>2]|0;if(!g){A=xCi(24)|0;c[A+16>>2]=K;c[A+20>>2]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=ba;c[aa>>2]=A;J=y+84|0;O=c[c[J>>2]>>2]|0;if(!O)ca=A;else{c[J>>2]=O;ca=c[aa>>2]|0}GN(c[L>>2]|0,ca);O=y+92|0;c[O>>2]=(c[O>>2]|0)+1;da=A}else da=g;c[da+20>>2]=G;g=c[z>>2]|0;A=c[M>>2]|0;O=y+136|0;J=c[O>>2]|0;do if(J){j=J;while(1){x=c[j+16>>2]|0;if(A>>>0<x>>>0){l=c[j>>2]|0;if(!l){ea=j;fa=j;t=92;break}else{j=l;continue}}if(x>>>0>=A>>>0){ga=j;t=96;break}x=j+4|0;l=c[x>>2]|0;if(!l){ha=x;ia=j;t=95;break}else j=l}if((t|0)==92){t=0;c[f>>2]=fa;ja=ea;ka=fa;break}else if((t|0)==95){t=0;c[f>>2]=ia;ja=ha;ka=ia;break}else if((t|0)==96){t=0;c[f>>2]=ga;ja=f;ka=ga;break}}else{j=y+136|0;c[f>>2]=j;ja=j;ka=j}while(0);J=c[ja>>2]|0;if(!J){M=xCi(24)|0;c[M+16>>2]=A;c[M+20>>2]=0;c[M>>2]=0;c[M+4>>2]=0;c[M+8>>2]=ka;c[ja>>2]=M;G=y+132|0;L=c[c[G>>2]>>2]|0;if(!L)la=M;else{c[G>>2]=L;la=c[ja>>2]|0}GN(c[O>>2]|0,la);L=y+140|0;c[L>>2]=(c[L>>2]|0)+1;ma=M}else ma=J;c[ma+20>>2]=g;J=P+12|0;M=c[J>>2]|0;if(!M)break;else{P=J;N=M;z=J}}}z=c[a+32>>2]|0;a=c[z>>2]|0;if(!a){i=d;return}N=a;a=z;do{z=c[a+4>>2]|0;P=c[(c[c[N+8>>2]>>2]|0)+4>>2]|0;ma=P+124|0;la=c[ma>>2]|0;do if(la){ja=la;while(1){ka=c[ja+16>>2]|0;if(N>>>0<ka>>>0){ga=c[ja>>2]|0;if(!ga){na=ja;oa=ja;t=108;break}else{ja=ga;continue}}if(ka>>>0>=N>>>0){pa=ja;t=112;break}ka=ja+4|0;ga=c[ka>>2]|0;if(!ga){qa=ka;ra=ja;t=111;break}else ja=ga}if((t|0)==108){t=0;c[f>>2]=oa;sa=na;ta=oa;break}else if((t|0)==111){t=0;c[f>>2]=ra;sa=qa;ta=ra;break}else if((t|0)==112){t=0;c[f>>2]=pa;sa=f;ta=pa;break}}else{ja=P+124|0;c[f>>2]=ja;sa=ja;ta=ja}while(0);la=c[sa>>2]|0;if(!la){g=xCi(24)|0;c[g+16>>2]=N;c[g+20>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=ta;c[sa>>2]=g;y=P+120|0;O=c[c[y>>2]>>2]|0;if(!O)ua=g;else{c[y>>2]=O;ua=c[sa>>2]|0}GN(c[ma>>2]|0,ua);O=P+128|0;c[O>>2]=(c[O>>2]|0)+1;va=g}else va=la;c[va+20>>2]=z;a=a+8|0;N=c[a>>2]|0}while((N|0)!=0);i=d;return}function vK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[a+4>>2]|0;a=c[f+12>>2]|0;g=f+16|0;if((a|0)==(g|0)){h=0;i=e;return h|0}else j=a;while(1){a=c[j+16>>2]|0;if(((HEi(b,c[a+12>>2]|0)|0)==0?(HEi(d,c[a+8>>2]|0)|0)==0:0)?(c[a+40>>2]|0)==0:0){h=a;k=10;break}a=c[j+4>>2]|0;if(!a){f=j;while(1){l=c[f+8>>2]|0;if((c[l>>2]|0)==(f|0)){m=l;break}else f=l}}else{f=a;while(1){l=c[f>>2]|0;if(!l){m=f;break}else f=l}}if((m|0)==(g|0)){h=0;k=10;break}else j=m}if((k|0)==10){i=e;return h|0}return 0}function wK(a){a=a|0;return c[(c[a+4>>2]|0)+20>>2]|0}function xK(a){a=a|0;return c[a+8>>2]|0}function yK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[a+4>>2]|0;a=c[g+12>>2]|0;h=g+16|0;if((a|0)==(h|0)){j=0;i=f;return j|0}else k=a;while(1){a=c[k+16>>2]|0;if(((HEi(b,c[a+12>>2]|0)|0)==0?(HEi(d,c[a+8>>2]|0)|0)==0:0)?(c[a+40>>2]|0)==(e|0):0){j=a;l=10;break}a=c[k+4>>2]|0;if(!a){g=k;while(1){m=c[g+8>>2]|0;if((c[m>>2]|0)==(g|0)){n=m;break}else g=m}}else{g=a;while(1){m=c[g>>2]|0;if(!m){n=g;break}else g=m}}if((n|0)==(h|0)){j=0;l=10;break}else k=n}if((l|0)==10){i=f;return j|0}return 0}function zK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;g=d+12|0;if(!(a[g>>0]&1))h=g+1|0;else h=c[d+20>>2]|0;g=c[b+4>>2]|0;b=c[g+12>>2]|0;j=g+16|0;if((b|0)==(j|0)){k=0;i=e;return k|0}g=b;while(1){l=c[g+16>>2]|0;if(((HEi(f,c[l+12>>2]|0)|0)==0?(HEi(h,c[l+8>>2]|0)|0)==0:0)?(c[l+40>>2]|0)==0:0){m=l;break}l=c[g+4>>2]|0;if(!l){n=g;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){o=c[n>>2]|0;if(!o){p=n;break}else n=o}}if((p|0)==(j|0)){k=0;q=33;break}else g=p}if((q|0)==33){i=e;return k|0}if(!m){k=0;i=e;return k|0}p=c[d+136>>2]|0;g=c[d+140>>2]|0;if((p|0)==(g|0)){k=m;i=e;return k|0}else{r=p;s=m}a:while(1){if(!(a[r>>0]&1))t=r+1|0;else t=c[r+8>>2]|0;m=b;while(1){p=c[m+16>>2]|0;if(((a[c[p+12>>2]>>0]|0)==0?(HEi(t,c[p+8>>2]|0)|0)==0:0)?(c[p+40>>2]|0)==(s|0):0){u=p;break}p=c[m+4>>2]|0;if(!p){d=m;while(1){h=c[d+8>>2]|0;if((c[h>>2]|0)==(d|0)){v=h;break}else d=h}}else{d=p;while(1){h=c[d>>2]|0;if(!h){v=d;break}else d=h}}if((v|0)==(j|0)){k=0;q=33;break a}else m=v}r=r+12|0;if(!u){k=0;q=33;break}if((r|0)==(g|0)){k=u;q=33;break}else s=u}if((q|0)==33){i=e;return k|0}return 0}function AK(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[(c[a>>2]|0)+4>>2]|0;if(!((b|0)!=1|b>>>0<2&e)){e=c[g+28>>2]|0;h=g+28|0;if(!e){j=0;i=f;return j|0}else{k=h;l=e}a:while(1){e=l;while(1){if((c[e+16>>2]|0)>>>0>=a>>>0){m=e;break}e=c[e+4>>2]|0;if(!e){n=k;break a}}l=c[m>>2]|0;if(!l){n=m;break}else k=m}if((n|0)==(h|0)){j=0;i=f;return j|0}if((n|0)==(h|0)?1:(c[n+16>>2]|0)>>>0>a>>>0){j=0;i=f;return j|0}h=n+20|0;RI(c[h>>2]|0)|0;j=c[h>>2]|0;i=f;return j|0}h=c[g+40>>2]|0;if(!h){j=0;i=f;return j|0}else{o=g+40|0;p=h}b:while(1){h=p;while(1){g=c[h+16>>2]|0;if(g>>>0>a>>>0){q=h;break}if(g>>>0>=a>>>0){r=o;s=h;t=16;break b}h=c[h+4>>2]|0;if(!h){j=0;t=34;break b}}h=c[q>>2]|0;if(!h){j=0;t=34;break}else{o=q;p=h}}if((t|0)==16){p=c[s>>2]|0;c:do if(!p)u=s;else{q=s;o=p;while(1){h=o;while(1){if((c[h+16>>2]|0)>>>0>=a>>>0){v=h;break}h=c[h+4>>2]|0;if(!h){u=q;break c}}o=c[v>>2]|0;if(!o){u=v;break}else q=v}}while(0);v=c[s+4>>2]|0;d:do if(!v)w=r;else{s=r;p=v;while(1){q=p;while(1){if((c[q+16>>2]|0)>>>0>a>>>0){x=q;break}q=c[q+4>>2]|0;if(!q){w=s;break d}}p=c[x>>2]|0;if(!p){w=x;break}else s=x}}while(0);if((u|0)==(w|0)){j=0;i=f;return j|0}else y=u;while(1){u=y+20|0;x=c[u>>2]|0;if((d[x+144>>0]|0|0)==(b|0)){z=u;A=x;break}x=c[y+4>>2]|0;if(!x){u=y;while(1){a=c[u+8>>2]|0;if((c[a>>2]|0)==(u|0)){B=a;break}else u=a}}else{u=x;while(1){a=c[u>>2]|0;if(!a){B=u;break}else u=a}}if((B|0)==(w|0)){j=0;t=34;break}else y=B}if((t|0)==34){i=f;return j|0}RI(A)|0;j=c[z>>2]|0;i=f;return j|0}else if((t|0)==34){i=f;return j|0}return 0}function BK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=c[(c[a>>2]|0)+4>>2]|0;f=c[e+52>>2]|0;if(!f){g=0;i=d;return g|0}else{h=e+52|0;j=f}a:while(1){f=j;while(1){e=c[f+16>>2]|0;if(e>>>0>a>>>0){k=f;break}if(e>>>0>=a>>>0){l=h;m=f;n=7;break a}f=c[f+4>>2]|0;if(!f){g=0;n=28;break a}}f=c[k>>2]|0;if(!f){g=0;n=28;break}else{h=k;j=f}}if((n|0)==7){j=c[m>>2]|0;b:do if(!j)o=m;else{k=m;h=j;while(1){f=h;while(1){if((c[f+16>>2]|0)>>>0>=a>>>0){p=f;break}f=c[f+4>>2]|0;if(!f){o=k;break b}}h=c[p>>2]|0;if(!h){o=p;break}else k=p}}while(0);p=c[m+4>>2]|0;c:do if(!p)q=l;else{m=l;j=p;while(1){k=j;while(1){if((c[k+16>>2]|0)>>>0>a>>>0){r=k;break}k=c[k+4>>2]|0;if(!k){q=m;break c}}j=c[r>>2]|0;if(!j){q=r;break}else m=r}}while(0);if((o|0)==(q|0)){g=0;i=d;return g|0}r=o;d:while(1){o=c[r+20>>2]|0;a=c[(c[o+80>>2]|0)+4>>2]|0;if(!(c[a>>2]|0)){g=o;n=28;break}p=a+4|0;l=0;while(1){if(!(pK(c[(c[p>>2]|0)+(l<<2)>>2]|0,c[(c[b>>2]|0)+(l<<2)>>2]|0)|0))break;l=l+1|0;if(l>>>0>=(c[a>>2]|0)>>>0){g=o;n=28;break d}}o=c[r+4>>2]|0;if(!o){a=r;while(1){l=c[a+8>>2]|0;if((c[l>>2]|0)==(a|0)){s=l;break}else a=l}}else{a=o;while(1){l=c[a>>2]|0;if(!l){s=a;break}else a=l}}if((s|0)==(q|0)){g=0;n=28;break}else r=s}if((n|0)==28){i=d;return g|0}}else if((n|0)==28){i=d;return g|0}return 0}function CK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=c[(c[c[a+8>>2]>>2]|0)+4>>2]|0;f=c[e+64>>2]|0;if(!f){g=0;i=d;return g|0}else{h=e+64|0;j=f}a:while(1){f=j;while(1){e=c[f+16>>2]|0;if(e>>>0>a>>>0){k=f;break}if(e>>>0>=a>>>0){l=h;m=f;n=7;break a}f=c[f+4>>2]|0;if(!f){g=0;n=28;break a}}f=c[k>>2]|0;if(!f){g=0;n=28;break}else{h=k;j=f}}if((n|0)==7){j=c[m>>2]|0;b:do if(!j)o=m;else{k=m;h=j;while(1){f=h;while(1){if((c[f+16>>2]|0)>>>0>=a>>>0){p=f;break}f=c[f+4>>2]|0;if(!f){o=k;break b}}h=c[p>>2]|0;if(!h){o=p;break}else k=p}}while(0);p=c[m+4>>2]|0;c:do if(!p)q=l;else{m=l;j=p;while(1){k=j;while(1){if((c[k+16>>2]|0)>>>0>a>>>0){r=k;break}k=c[k+4>>2]|0;if(!k){q=m;break c}}j=c[r>>2]|0;if(!j){q=r;break}else m=r}}while(0);if((o|0)==(q|0)){g=0;i=d;return g|0}r=o;d:while(1){o=c[r+20>>2]|0;a=c[(DK(o)|0)+4>>2]|0;if(!(c[a>>2]|0)){g=o;n=28;break}p=a+4|0;l=0;while(1){if(!(pK(c[(c[p>>2]|0)+(l<<2)>>2]|0,c[(c[b>>2]|0)+(l<<2)>>2]|0)|0))break;l=l+1|0;if(l>>>0>=(c[a>>2]|0)>>>0){g=o;n=28;break d}}o=c[r+4>>2]|0;if(!o){a=r;while(1){l=c[a+8>>2]|0;if((c[l>>2]|0)==(a|0)){s=l;break}else a=l}}else{a=o;while(1){l=c[a>>2]|0;if(!l){s=a;break}else a=l}}if((s|0)==(q|0)){g=0;n=28;break}else r=s}if((n|0)==28){i=d;return g|0}}else if((n|0)==28){i=d;return g|0}return 0}function DK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d;if(!(a[b+36>>0]|0)){c[e>>2]=369416;gl(406304,e|0)|0}f=c[(c[c[b+8>>2]>>2]|0)+4>>2]|0;g=f+88|0;h=c[g>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if(k>>>0>b>>>0){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if(k>>>0>=b>>>0){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=f+88|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+20|0;w=c[v>>2]|0;i=d;return w|0}e=xCi(24)|0;c[e+16>>2]=b;c[e+20>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=f+84|0;b=c[c[t>>2]>>2]|0;if(!b)x=e;else{c[t>>2]=b;x=c[s>>2]|0}GN(c[g>>2]|0,x);x=f+92|0;c[x>>2]=(c[x>>2]|0)+1;u=e;v=u+20|0;w=c[v>>2]|0;i=d;return w|0}function EK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d;if(!(a[b+35>>0]|0)){c[e>>2]=369448;gl(406304,e|0)|0}f=c[(c[c[b+8>>2]>>2]|0)+4>>2]|0;g=f+124|0;h=c[g>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if(k>>>0>b>>>0){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if(k>>>0>=b>>>0){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=f+124|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+20|0;w=c[v>>2]|0;i=d;return w|0}e=xCi(24)|0;c[e+16>>2]=b;c[e+20>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=f+120|0;b=c[c[t>>2]>>2]|0;if(!b)x=e;else{c[t>>2]=b;x=c[s>>2]|0}GN(c[g>>2]|0,x);x=f+128|0;c[x>>2]=(c[x>>2]|0)+1;u=e;v=u+20|0;w=c[v>>2]|0;i=d;return w|0}function FK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=c[(c[c[a+8>>2]>>2]|0)+4>>2]|0;e=c[d+136>>2]|0;f=d+136|0;if(!e){g=0;i=b;return g|0}else{h=f;j=e}a:while(1){e=j;while(1){if((c[e+16>>2]|0)>>>0>=a>>>0){k=e;break}e=c[e+4>>2]|0;if(!e){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)==(f|0)){g=0;i=b;return g|0}if((l|0)==(f|0)?1:(c[l+16>>2]|0)>>>0>a>>>0){g=0;i=b;return g|0}g=c[l+20>>2]|0;i=b;return g|0}function GK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+4>>2]|0;a=c[e+100>>2]|0;f=e+100|0;if(!a){g=0;i=d;return g|0}else{h=f;j=a}a:while(1){a=j;while(1){if((c[a+16>>2]|0)>>>0>=b>>>0){k=a;break}a=c[a+4>>2]|0;if(!a){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)==(f|0)){g=0;i=d;return g|0}if((l|0)==(f|0)?1:(c[l+16>>2]|0)>>>0>b>>>0){g=0;i=d;return g|0}g=c[l+20>>2]|0;i=d;return g|0}function HK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=g+100|0;h=c[a>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if(k>>>0>b>>>0){l=c[j>>2]|0;if(!l){m=j;n=j;o=4;break}else{j=l;continue}}if(k>>>0>=b>>>0){p=j;o=8;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=7;break}else j=l}if((o|0)==4){c[f>>2]=n;s=m;t=n;break}else if((o|0)==7){c[f>>2]=r;s=q;t=r;break}else if((o|0)==8){c[f>>2]=p;s=f;t=p;break}}else{j=g+100|0;c[f>>2]=j;s=j;t=j}while(0);f=c[s>>2]|0;if(f){u=f;v=u+20|0;c[v>>2]=d;i=e;return}f=xCi(24)|0;c[f+16>>2]=b;c[f+20>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=t;c[s>>2]=f;t=g+96|0;b=c[c[t>>2]>>2]|0;if(!b)w=f;else{c[t>>2]=b;w=c[s>>2]|0}GN(c[a>>2]|0,w);w=g+104|0;c[w>>2]=(c[w>>2]|0)+1;u=f;v=u+20|0;c[v>>2]=d;i=e;return}function IK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+4>>2]|0;a=c[e+112>>2]|0;f=e+112|0;if(!a){g=0;i=d;return g|0}else{h=f;j=a}a:while(1){a=j;while(1){if((c[a+16>>2]|0)>>>0>=b>>>0){k=a;break}a=c[a+4>>2]|0;if(!a){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)==(f|0)){g=0;i=d;return g|0}if((l|0)==(f|0)?1:(c[l+16>>2]|0)>>>0>b>>>0){g=0;i=d;return g|0}g=c[l+20>>2]|0;i=d;return g|0}function JK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=g+112|0;h=c[a>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if(k>>>0>b>>>0){l=c[j>>2]|0;if(!l){m=j;n=j;o=4;break}else{j=l;continue}}if(k>>>0>=b>>>0){p=j;o=8;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=7;break}else j=l}if((o|0)==4){c[f>>2]=n;s=m;t=n;break}else if((o|0)==7){c[f>>2]=r;s=q;t=r;break}else if((o|0)==8){c[f>>2]=p;s=f;t=p;break}}else{j=g+112|0;c[f>>2]=j;s=j;t=j}while(0);f=c[s>>2]|0;if(f){u=f;v=u+20|0;c[v>>2]=d;i=e;return}f=xCi(24)|0;c[f+16>>2]=b;c[f+20>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=t;c[s>>2]=f;t=g+108|0;b=c[c[t>>2]>>2]|0;if(!b)w=f;else{c[t>>2]=b;w=c[s>>2]|0}GN(c[a>>2]|0,w);w=g+116|0;c[w>>2]=(c[w>>2]|0)+1;u=f;v=u+20|0;c[v>>2]=d;i=e;return}function KK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;rri(e,a,SEi(a|0)|0);AO(d+24|0,369488,e,c[92373]|0,369492|0);xri(e);rri(f,a,SEi(a|0)|0);c[(BO(369488,f)|0)>>2]=b;xri(f);i=d;return}function LK(){var a=0;a=i;KK(369504,90);KK(369672,2557);KK(369760,3332);KK(2700504,4);KK(369816,72);KK(369864,3333);KK(369944,3334);KK(370032,3335);KK(370112,3336);KK(370192,3337);KK(370272,3338);KK(370320,1671);KK(370392,3447);KK(3021072,3339);KK(370432,2486);KK(370504,1672);KK(370584,2487);KK(370632,5);KK(370672,2488);KK(3022176,3340);KK(370720,6);KK(370760,3341);KK(3022224,7);KK(3022272,8);KK(3022328,3342);KK(370792,3343);KK(370856,73);KK(370904,3448);KK(370968,3449);KK(371032,3344);KK(371112,3345);KK(371168,3346);KK(371224,3450);KK(371272,224);KK(371368,175);KK(371480,1756);KK(371536,2558);KK(371576,1757);KK(371632,3347);KK(371672,1758);KK(2619616,1759);KK(2619696,3348);KK(2619360,1673);KK(2619256,176);KK(2618920,2489);KK(2618968,2490);KK(2618888,3349);KK(2619024,2491);KK(2619136,2492);KK(2619072,1760);KK(2619192,1761);KK(3031224,177);KK(3031168,3350);KK(371728,2493);KK(371792,1762);KK(2569336,60);KK(371864,9);KK(371936,10);KK(372e3,3351);KK(372064,3352);KK(372112,3353);KK(372160,3354);KK(372208,225);KK(372304,1674);KK(372392,2494);KK(3125056,1675);KK(372464,3355);KK(3054160,11);KK(372536,12);KK(2593448,7);KK(2593120,2495);KK(372576,99);KK(2593048,2496);KK(2593744,2497);KK(2593656,1676);KK(2593504,2559);KK(2593192,2498);KK(372712,1677);KK(2593584,2499);KK(2593368,2500);KK(2593264,226);KK(372792,227);KK(2609448,3451);KK(372904,13);KK(372960,3452);KK(373040,2560);KK(373120,3453);KK(373184,105);KK(373352,1678);KK(373472,228);KK(373568,3356);KK(373648,2501);KK(373752,1679);KK(373864,229);KK(374040,3357);KK(374120,2502);KK(374216,2503);KK(374312,1680);KK(374432,178);KK(374600,3358);KK(374664,3359);KK(374728,2504);KK(374792,14);KK(374840,2505);KK(374920,3360);KK(374984,1681);KK(375072,15);KK(375128,1682);KK(375224,2506);KK(375296,2561);KK(375368,3361);KK(375432,1683);KK(375520,230);KK(375632,2507);KK(375760,3362);KK(375824,2508);KK(375888,1684);KK(375968,1685);KK(2744936,34);KK(2746648,1686);KK(376056,16);KK(2589488,2509);KK(2611288,2510);KK(2611464,3363);KK(2611176,3364);KK(2611080,3365);KK(2611400,2511);KK(376104,3454);KK(376144,17);KK(376192,18);KK(376232,19);KK(376280,20);KK(3077032,21);KK(3077080,22);KK(376320,23);KK(376368,24);KK(376416,25);KK(376456,26);KK(376496,27);KK(376544,28);KK(376600,29);KK(376648,30);KK(3077128,31);KK(376696,3366);KK(376752,74);KK(3077520,3367);KK(376808,32);KK(376856,33);KK(376896,2562);KK(376976,3455);KK(377024,3368);KK(377072,34);KK(377104,3369);KK(377144,3370);KK(377192,3456);KK(377240,3457);KK(377280,2563);KK(377320,3458);KK(3080136,3459);KK(377368,75);KK(2751760,328);KK(2751432,2564);KK(2751512,3460);KK(2751584,35);KK(377408,100);KK(2751888,100);KK(2756536,3461);KK(377568,3371);KK(2756344,2512);KK(2756440,2513);KK(377688,2514);KK(2756608,3462);KK(377816,1687);KK(377920,2515);KK(378016,2516);KK(378104,179);KK(378240,3372);KK(378304,231);KK(378416,35);KK(378472,1688);KK(378560,36);KK(378608,2517);KK(2790456,2518);KK(378680,232);KK(378776,2519);KK(378848,2520);KK(378912,2521);KK(378984,101);KK(379120,2522);KK(2791080,37);KK(2790920,38);KK(2790872,39);KK(2790824,40);KK(2791024,41);KK(2791144,42);KK(2790968,43);KK(2790304,3373);KK(379184,2523);KK(379264,1689);KK(379360,180);KK(2790376,2524);KK(2790744,2525);KK(379480,3374);KK(379528,91);KK(379616,1690);KK(379696,106);KK(379840,181);KK(379944,2526);KK(380016,182);KK(2790640,183);KK(380128,2527);KK(380208,1691);KK(380312,36);KK(380424,233);KK(380504,92);KK(2790528,184);KK(380600,44);KK(380632,1);KK(380672,2);KK(380712,3);KK(380752,1);KK(380800,4);KK(380832,5);KK(380872,6);KK(3086448,7);KK(380904,8);KK(380936,9);KK(3086544,2);KK(3086496,10);KK(380976,1);KK(381040,11);KK(381072,12);KK(3086600,13);KK(381112,14);KK(381144,15);KK(381184,3375);KK(3091160,1692);KK(3091296,2528);KK(3075816,2565);KK(3094536,3376);KK(3093496,3377);KK(3094648,3378);KK(381288,3379);KK(3094928,3380);KK(3095136,3381);KK(3094888,3382);KK(3094800,3383);KK(3094840,3384);KK(381328,3385);KK(3093608,1693);KK(381360,2529);KK(381448,2529);KK(3094488,3386);KK(381528,1694);KK(3093704,1695);KK(381608,1696);KK(3094576,1697);KK(3094976,3387);KK(3093784,3388);KK(3093832,185);KK(381688,1698);KK(381768,2530);KK(3093952,186);KK(381832,1699);KK(3094240,3389);KK(381912,3390);KK(3094280,3391);KK(3094328,3392);KK(381952,2566);KK(3102984,93);KK(382016,234);KK(382120,235);KK(382224,3393);KK(382280,1700);KK(382368,2531);KK(382448,1763);KK(382544,1764);KK(382640,2567);KK(382712,1765);KK(382816,1766);KK(382912,96);KK(383088,97);KK(383264,1767);KK(383352,2532);KK(383432,236);KK(383480,237);KK(383624,107);KK(383768,102);KK(383944,2533);KK(384024,1768);KK(384128,187);KK(384264,103);KK(384440,238);KK(384576,108);KK(384720,61);KK(384920,1769);KK(385032,188);KK(385192,189);KK(385304,45);KK(2536112,3394);KK(2536256,3395);KK(2536152,3396);KK(385368,3397);KK(2842256,2568);KK(385400,2534);KK(385464,3398);KK(2841840,3399);KK(385512,3400);KK(385568,3401);KK(385616,3402);KK(385672,46);KK(385728,47);KK(2842528,48);KK(385776,1701);KK(385856,3403);KK(385912,1702);KK(2841952,239);KK(386032,3404);KK(386088,3405);KK(386144,3406);KK(386192,3407);KK(386248,2535);KK(386304,2569);KK(2842128,190);KK(386408,3408);KK(386472,2536);KK(386576,2537);KK(386648,104);KK(386808,3409);KK(386896,2538);KK(386984,3463);KK(387080,2539);KK(387160,105);KK(387392,3464);KK(387464,2570);KK(387568,2571);KK(387672,2572);KK(387744,3465);KK(2832560,2540);KK(387816,3466);KK(387904,3467);KK(388e3,2541);KK(388112,1703);KK(388248,2542);KK(388352,2543);KK(388456,1770);KK(388536,2573);KK(388648,2574);KK(388720,3410);KK(388784,3411);KK(388848,3468);KK(388912,3469);KK(389008,2544);KK(389104,2545);KK(2836968,3412);KK(389192,3470);KK(389256,2575);KK(389352,2546);KK(2859024,3413);KK(2858928,2547);KK(389416,3414);KK(389472,49);KK(389528,3415);KK(2862992,2548);KK(389600,3416);KK(389648,3417);KK(389696,3418);KK(389744,3419);KK(389792,3420);KK(389856,1771);KK(389992,3421);KK(390040,191);KK(390184,192);KK(390328,193);KK(390472,1704);KK(390584,1705);KK(390696,194);KK(2879416,240);KK(2868944,2576);KK(2870984,3422);KK(2870912,2549);KK(390840,3423);KK(2871040,2550);KK(2871280,1772);KK(390896,94);KK(2873928,3424);KK(2873200,3425);KK(2876192,3426);KK(2877408,3427);KK(2877336,3428);KK(2876112,3429);KK(2876608,3430);KK(2877272,3431);KK(391104,3432);KK(2876280,240);KK(2877192,2551);KK(2874648,2577);KK(2874760,2552);KK(391168,3433);KK(2881088,1773);KK(391240,2553);KK(391344,3434);KK(391400,2554);KK(2671736,50);KK(391472,3435);KK(2671632,2578);KK(391552,3471);KK(391640,3472);KK(391728,3436);KK(391808,3473);KK(391880,3437);KK(391960,3438);KK(392032,1706);KK(392168,3439);KK(392240,3440);KK(392312,3441);KK(2899152,329);KK(392384,330);KK(392496,2579);KK(392584,3474);KK(392648,3475);KK(392720,3476);KK(392792,2555);KK(392872,3442);KK(392976,2556);KK(393088,3443);KK(393184,3444);KK(393272,3445);KK(393360,51);KK(393424,3446);KK(393496,3447);KK(393568,2557);KK(393648,3477);KK(393728,3478);KK(393792,3448);KK(393864,2558);KK(393952,3449);KK(394024,3450);KK(394096,2559);KK(394184,2560);KK(394272,2560);KK(394360,1707);KK(394472,2561);KK(394552,2562);KK(394632,2563);KK(394712,2564);KK(394792,2565);KK(394872,2566);KK(394960,2567);KK(395048,3451);KK(395128,3452);KK(395200,3453);KK(395264,3454);KK(395336,3455);KK(395416,3456);KK(395496,1774);KK(395600,2568);KK(395704,1775);KK(395800,1776);KK(395896,1776);KK(395992,1777);KK(396088,331);KK(396184,1778);KK(396280,3457);KK(396384,2580);KK(396496,1779);KK(2939304,3458);KK(2939392,2569);KK(2946944,2570);KK(396608,241);KK(396744,3459);KK(396824,3460);KK(2966896,3479);KK(2966792,2571);KK(2966696,3461);KK(2966616,52);KK(396888,3462);KK(396976,3463);KK(397048,53);KK(397112,3464);KK(397184,3465);KK(397256,3466);KK(397344,3467);KK(397432,54);KK(397504,3468);KK(397592,2572);KK(397688,2573);KK(397784,3469);KK(397848,3470);KK(397912,55);KK(397976,56);KK(398032,1708);KK(398208,3480);KK(398288,3481);KK(398360,76);KK(2573128,76);KK(2573320,76);KK(2573272,76);KK(2573200,76);KK(398400,76);KK(398440,76);KK(398504,76);KK(2573456,3471);KK(398592,3472);KK(398640,3473);KK(2573376,242);KK(2991088,3474);KK(398696,2574);KK(398760,1709);KK(398824,2);KK(3010976,1710);KK(398920,195);KK(399008,1711);KK(399104,1712);KK(399200,4);KK(399296,1712);KK(399352,3475);KK(399408,3476);KK(399464,2575);KK(399512,5);KK(399584,2576);KK(399656,1713);KK(399728,2575);KK(399800,2575);KK(399872,6);KK(399944,3477);KK(4e5,3478);KK(400056,3479);KK(3011760,3482);KK(3011816,3483);KK(400112,3484);KK(400168,3485);KK(400232,3480);KK(400304,2577);KK(400376,2578);KK(400448,1714);KK(400544,1715);KK(400672,3481);KK(3012488,3486);KK(3012280,243);KK(400736,1716);KK(400880,3482);KK(3012408,3483);KK(400952,244);KK(401064,1717);KK(401200,1718);KK(401304,2581);KK(401360,2582);KK(3013672,57);KK(401424,2583);KK(401504,3484);KK(401560,3485);KK(401616,3486);KK(3013736,58);KK(401672,3487);KK(3013856,59);KK(401720,3488);KK(401776,3489);KK(401840,3490);KK(401880,3487);KK(401928,1719);KK(402e3,77);KK(402048,78);KK(402096,3488);KK(402144,2584);KK(402232,2585);KK(402320,2586);KK(402384,2587);KK(402456,2588);KK(402528,2589);KK(402592,3489);KK(402648,79);KK(402688,3490);KK(3013784,2590);KK(402736,3491);KK(402776,2579);KK(402848,3491);KK(402904,8);KK(402960,3492);KK(403016,3493);KK(403072,3494);KK(403128,3495);KK(403184,3495);KK(403240,3491);KK(403296,151);KK(403352,3492);KK(403408,3493);KK(403464,3494);KK(403520,3495);KK(403576,2591);KK(403648,3);KK(403720,2592);KK(403792,2593);KK(403864,1780);KK(403936,2594);KK(404008,2594);KK(404080,2591);KK(404152,126);KK(404224,2592);KK(404296,2593);KK(404368,1780);KK(404440,2594);KK(404512,2595);KK(404592,2596);KK(404664,2597);KK(404736,2580);KK(404808,2581);KK(404880,245);KK(404992,1720);KK(405104,1721);KK(405216,246);KK(2650712,2582);KK(2651904,3496);KK(2651792,3497);KK(405312,3498);KK(405360,3499);KK(405416,3500);KK(2651848,3501);KK(405464,332);KK(405592,1781);KK(2650920,3502);KK(2650768,3503);KK(2650832,1722);KK(2651632,3504);KK(2651296,2583);KK(405648,2584);KK(405696,3505);KK(2651952,2585);KK(405728,3506);KK(2651112,2586);KK(2651032,1723);KK(405760,3507);KK(2537432,1724);KK(2537520,2587);i=a;return}function MK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;rri(f,b,SEi(b|0)|0);AO(e,369488,f,c[92373]|0,369492|0);j=c[e>>2]|0;do if((j|0)!=(369492|0)){k=j+16|0;l=a[f>>0]|0;m=(l&1)==0;if(m)n=(l&255)>>>1;else n=c[f+4>>2]|0;l=a[k>>0]|0;o=(l&1)==0;if(o)p=(l&255)>>>1;else p=c[j+20>>2]|0;if(m)q=f+1|0;else q=c[f+8>>2]|0;if(o)r=k+1|0;else r=c[j+24>>2]|0;k=FEi(q,r,p>>>0<n>>>0?p:n)|0;if(!k)if(n>>>0<p>>>0){s=17;break}else{t=j;break}else if((k|0)<0){s=17;break}else{t=j;break}}else s=17;while(0);if((s|0)==17)t=369492|0;xri(f);if((t|0)!=(369492|0)){u=c[t+28>>2]|0;i=d;return u|0}rri(g,b,SEi(b|0)|0);b=Kri(g,40,0)|0;do if((b|0)!=-1?(vri(h,g,0,b,g),yri(g,h)|0,xri(h),AO(e,369488,g,c[92373]|0,369492|0),t=c[e>>2]|0,(t|0)!=(369492|0)):0){f=t+16|0;s=a[g>>0]|0;j=(s&1)==0;if(j)v=(s&255)>>>1;else v=c[g+4>>2]|0;s=a[f>>0]|0;p=(s&1)==0;if(p)w=(s&255)>>>1;else w=c[t+20>>2]|0;if(j)x=g+1|0;else x=c[g+8>>2]|0;if(p)y=f+1|0;else y=c[t+24>>2]|0;f=FEi(x,y,w>>>0<v>>>0?w:v)|0;if(!f){if(v>>>0<w>>>0){z=0;break}}else if((f|0)<0){z=0;break}z=c[t+28>>2]|0}else z=0;while(0);xri(g);u=z;i=d;return u|0}function NK(){var a=0,b=0,d=0;a=i;b=c[101454]|0;if((b|0)==-1){d=0;i=a;return d|0}d=c[(LM(b)|0)>>2]|0;i=a;return d|0}function OK(){var a=0;a=i;if((c[101454]|0)!=-1){i=a;return}c[101454]=KM(4)|0;i=a;return}function PK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+4>>2]|0;if(d){e=c[d>>2]|0;if(e){f=d+4|0;g=c[f>>2]|0;if((g|0)!=(e|0))c[f>>2]=g+(~((g+-4-e|0)>>>2)<<2);ACi(e)}ACi(d)}d=c[a+12>>2]|0;if(!d){i=b;return}a=c[d>>2]|0;if(a){e=d+4|0;g=c[e>>2]|0;if((g|0)!=(a|0))c[e>>2]=g+(~((g+-4-a|0)>>>2)<<2);ACi(a)}ACi(d);i=b;return}function QK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=c[g>>2]|0;if((h|0)==(c[f>>2]|0)){i=d;return}else{j=h;k=g}do{g=j+-4|0;h=c[g>>2]|0;c[k>>2]=g;g=c[h>>2]&-2;f=c[g+4>>2]|0;do if(!(f&1))if(!(a[g+144>>0]|0)){SK(h,0,g,b);break}else{RK(h,b);break}else{l=0;do{if(1<<31-l&f)TK(c[h+(l<<2)>>2]|0,b);l=l+1|0}while((l|0)!=30)}while(0);h=c[e>>2]|0;k=h+4|0;j=c[k>>2]|0}while((j|0)!=(c[h>>2]|0));i=d;return}function RK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=c[(c[b>>2]&-2)+44>>2]|0;h=(eJ(g)|0)^1;c[f>>2]=0;j=h;while(1){h=OI(g,f)|0;if(!h){k=7;break}l=h+4|0;if(eN(c[l>>2]|0)|0)break;h=c[l>>2]|0;l=c[h+4>>2]|0;if((l&64|0)!=0|(l&16711680|0)==917504)m=0;else m=dN(h)|0;if(j|m)break;else j=0}if((k|0)==7?!j:0){i=e;return}j=sI(b)|0;if(a[g+145>>0]|0){k=oJ(g)|0;if(!j){i=e;return}else n=0;do{SK(yI(b,k,n)|0,1,g,d);n=n+1|0;if(!(n&63))QK(d)}while((n|0)!=(j|0));i=e;return}if(!j){i=e;return}n=d+12|0;g=0;do{TK(c[(yI(b,4,g)|0)>>2]|0,d);g=g+1|0;if((g&63|0)==0?(k=c[n>>2]|0,m=k+4|0,f=c[m>>2]|0,(f|0)!=(c[k>>2]|0)):0){k=f;f=m;do{m=k+-4|0;h=c[m>>2]|0;c[f>>2]=m;m=c[h>>2]&-2;l=c[m+4>>2]|0;do if(!(l&1))if(!(a[m+144>>0]|0)){SK(h,0,m,d);break}else{RK(h,d);break}else{o=0;do{if(1<<31-o&l)TK(c[h+(o<<2)>>2]|0,d);o=o+1|0}while((o|0)!=30)}while(0);h=c[n>>2]|0;f=h+4|0;k=c[f>>2]|0}while((k|0)!=(c[h>>2]|0))}}while((g|0)!=(j|0));i=e;return}function SK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g+4|0;j=g;k=d?b+-8|0:b;if(!e){i=g;return}b=e;do{if((a[b+153>>0]|0)!=0?(c[h>>2]=0,e=OI(b,h)|0,(e|0)!=0):0){d=e;do{e=d+4|0;l=c[e>>2]|0;do if(!(c[l+4>>2]&16)){if(!(eN(l)|0)){m=c[e>>2]|0;n=c[m+4>>2]|0;if((n&64|0)!=0|(n&16711680|0)==917504)break;if(!(dN(m)|0))break}m=eN(c[e>>2]|0)|0;n=c[d+12>>2]|0;if(!m){if((n|0)==-1)break;c[j>>2]=0;dK(k,d,j);TK(c[j>>2]|0,f);break}m=k+n|0;n=c[e>>2]|0;if((c[n+4>>2]&16711680|0)==1376256){SK(m,1,c[(c[n>>2]|0)+12>>2]|0,f);break}else{SK(m,1,c[n>>2]|0,f);break}}while(0);d=OI(b,h)|0}while((d|0)!=0)}b=c[b+32>>2]|0}while((b|0)!=0);i=g;return}function TK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;c[f>>2]=b;if(!b){i=e;return}g=c[b>>2]|0;if(g&1){i=e;return}h=g&-2;g=(a[h+151>>0]|0)!=0;if(!((!g?(j=c[d+8>>2]|0,(j|0)!=0):0)?!(aJ(h,j)|0):0)){j=d+4|0;h=c[j>>2]|0;k=c[h+4>>2]|0;l=c[h+8>>2]|0;if((k|0)==(l|0)){UK(d,h);m=c[j>>2]|0;n=m;o=c[m+4>>2]|0;p=c[m+8>>2]|0}else{n=h;o=k;p=l}l=n+4|0;if((o|0)==(p|0))CO(n,f);else{if(!o)q=0;else{c[o>>2]=b;q=c[l>>2]|0}c[l>>2]=q+4}c[b>>2]=c[b>>2]|1}if(!g){i=e;return}g=d+12|0;b=c[g>>2]|0;q=c[b+4>>2]|0;l=c[b+8>>2]|0;if((q|0)==(l|0)){UK(d,b);d=c[g>>2]|0;r=d;s=c[d+4>>2]|0;t=c[d+8>>2]|0}else{r=b;s=q;t=l}l=r+4|0;if((s|0)==(t|0)){CO(r,f);i=e;return}if(!s)u=0;else{c[s>>2]=c[f>>2];u=c[l>>2]|0}c[l>>2]=u+4;i=e;return}function UK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+4|0;a=c[e>>2]|0;f=c[a+4>>2]|0;g=c[a>>2]|0;if((f|0)!=(g|0)){a=0;do{h=c[g+(a<<2)>>2]|0;c[h>>2]=c[h>>2]&-2;a=a+1|0}while(a>>>0<f-g>>2>>>0)}Js();g=b+8|0;f=c[b>>2]|0;a=f;h=(c[g>>2]|0)-a|0;j=h>>1;if(h>>2>>>0<j>>>0){k=b+4|0;l=(c[k>>2]|0)-a|0;if(!j)m=0;else m=xCi(h<<1)|0;YEi(m|0,f|0,l|0)|0;c[b>>2]=m;c[k>>2]=m+(l>>2<<2);c[g>>2]=m+(j<<2);if(f)ACi(f)}Is();f=c[e>>2]|0;e=c[f+4>>2]|0;j=c[f>>2]|0;if((e|0)==(j|0)){i=d;return}else n=0;do{f=c[j+(n<<2)>>2]|0;c[f>>2]=c[f>>2]|1;n=n+1|0}while(n>>>0<e-j>>2>>>0);i=d;return}function VK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=xCi(28)|0;h=g+8|0;j=g+20|0;k=g+24|0;l=b>>>0<1e3?1e3:b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;b=xCi(12)|0;c[b>>2]=0;m=b+4|0;c[m>>2]=0;n=b+8|0;c[n>>2]=0;c[g+4>>2]=b;o=l<<2;if(o){p=xCi(l<<4)|0;c[b>>2]=p;c[m>>2]=p;c[n>>2]=p+(o<<2)}p=xCi(12)|0;c[p>>2]=0;n=p+4|0;c[n>>2]=0;m=p+8|0;c[m>>2]=0;c[g+12>>2]=p;if(!l){c[g>>2]=0;c[h>>2]=a;c[j>>2]=e;c[k>>2]=d;Is();i=f;return g|0}b=xCi(o)|0;c[p>>2]=b;c[n>>2]=b;c[m>>2]=b+(l<<2);c[g>>2]=0;c[h>>2]=a;c[j>>2]=e;c[k>>2]=d;Is();i=f;return g|0}function WK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+4>>2]|0;e=c[d+4>>2]|0;f=c[d>>2]|0;if((e|0)!=(f|0)){d=e-f>>2;e=0;do{g=c[f+(e<<2)>>2]|0;c[g>>2]=c[g>>2]&-2;e=e+1|0}while(e>>>0<d>>>0);if(!a){Js();i=b;return}}PK(a);ACi(a);Js();i=b;return}function XK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+272|0;e=d+8|0;f=d;c[f>>2]=a;g=b+4|0;h=c[g>>2]|0;c[b>>2]=(c[h+4>>2]|0)-(c[h>>2]|0)>>2;h=c[b+12>>2]|0;j=c[h>>2]|0;k=h+4|0;l=c[k>>2]|0;if((l|0)==(j|0))m=j;else{n=l+(~((l+-4-j|0)>>>2)<<2)|0;c[k>>2]=n;m=n}if((m|0)==(c[h+8>>2]|0))CO(h,f);else{if(!m)o=0;else{c[m>>2]=a;o=c[k>>2]|0}c[k>>2]=o+4}QK(b);o=c[b>>2]|0;k=c[g>>2]|0;a=c[k>>2]|0;if(o>>>0>=(c[k+4>>2]|0)-a>>2>>>0){i=d;return}k=b+8|0;m=b+24|0;f=b+20|0;b=a;a=o;o=0;while(1){h=c[b+(a<<2)>>2]|0;n=c[k>>2]|0;if((n|0)!=0?!(aJ(c[h>>2]&-2,n)|0):0)p=o;else{c[e+(o<<2)>>2]=h;p=o+1|0}if((p|0)==64){co[c[m>>2]&2047](e,64,c[f>>2]|0);q=0}else q=p;a=a+1|0;h=c[g>>2]|0;b=c[h>>2]|0;if(a>>>0>=(c[h+4>>2]|0)-b>>2>>>0){r=q;break}else o=q}if(!r){i=d;return}co[c[m>>2]&2047](e,r,c[f>>2]|0);i=d;return}function YK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+272|0;e=d+8|0;f=d+4|0;g=d;h=xJ()|0;j=b+4|0;k=c[j>>2]|0;c[b>>2]=(c[k+4>>2]|0)-(c[k>>2]|0)>>2;k=c[b+12>>2]|0;l=c[k>>2]|0;m=k+4|0;k=c[m>>2]|0;if((k|0)!=(l|0))c[m>>2]=k+(~((k+-4-l|0)>>>2)<<2);l=c[h>>2]|0;k=h+4|0;h=c[k>>2]|0;if((l|0)!=(h|0)){m=h;h=l;while(1){l=c[h>>2]|0;if(((l|0)!=0?(c[l>>2]|0)!=(c[101522]|0):0)?(a[l+153>>0]|0)!=0:0){c[f>>2]=0;n=OI(l,f)|0;if(n){o=l+92|0;p=n;do{n=p+4|0;q=c[n>>2]|0;do if(c[q+4>>2]&16){if(!(eN(q)|0)){r=c[n>>2]|0;s=c[r+4>>2]|0;if((s&64|0)!=0|(s&16711680|0)==917504)break;if(!(dN(r)|0))break}r=p+12|0;if((c[r>>2]|0)!=-1){if(!(eN(c[n>>2]|0)|0)){c[g>>2]=0;fK(p,g);s=c[g>>2]|0;if(!s)break;TK(s,b);break}s=(c[o>>2]|0)+(c[r>>2]|0)|0;r=c[n>>2]|0;if((c[r+4>>2]&16711680|0)==1376256){SK(s,1,c[(c[r>>2]|0)+12>>2]|0,b);break}else{SK(s,1,c[r>>2]|0,b);break}}}while(0);p=OI(l,f)|0}while((p|0)!=0)}t=c[k>>2]|0}else t=m;h=h+4|0;if((h|0)==(t|0))break;else m=t}}QK(b);t=c[b>>2]|0;m=c[j>>2]|0;h=c[m>>2]|0;if(t>>>0>=(c[m+4>>2]|0)-h>>2>>>0){i=d;return}m=b+8|0;k=b+24|0;f=b+20|0;b=h;h=t;t=0;while(1){g=c[b+(h<<2)>>2]|0;p=c[m>>2]|0;if((p|0)!=0?!(aJ(c[g>>2]&-2,p)|0):0)u=t;else{c[e+(t<<2)>>2]=g;u=t+1|0}if((u|0)==64){co[c[k>>2]&2047](e,64,c[f>>2]|0);v=0}else v=u;h=h+1|0;g=c[j>>2]|0;b=c[g>>2]|0;if(h>>>0>=(c[g+4>>2]|0)-b>>2>>>0){w=v;break}else t=v}if(!w){i=d;return}co[c[k>>2]&2047](e,w,c[f>>2]|0);i=d;return}function ZK(a){a=a|0;var b=0,c=0;b=i;c=wH(a)|0;i=b;return c|0}function _K(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xH(a,b)|0;i=c;return d|0}function $K(a){a=a|0;var b=0;b=i;yH(a);i=b;return}function aL(a){a=a|0;var b=0,c=0;b=i;c=ADi(a)|0;i=b;return c|0}function bL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=DDi(a,b)|0;i=c;return d|0}function cL(a){a=a|0;var b=0;b=i;BDi(a);i=b;return}function dL(a){a=a|0;return c[a+12>>2]|0}function eL(a){a=a|0;return c[a>>2]|0}function fL(b){b=b|0;return (a[b+35>>0]|0)!=0|0}function gL(b){b=b|0;return (a[b+36>>0]|0)!=0|0}function hL(a){a=a|0;return (b[a+28>>1]&16)==0|0}function iL(a){a=a|0;return d[a+34>>0]|0|0}function jL(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;if((d[a+34>>0]|0)>>>0<=b>>>0){f=0;i=e;return f|0}f=c[(c[a+20>>2]|0)+(b*12|0)+8>>2]|0;i=e;return f|0}function kL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=WL(a)|0;a=e+4|0;if((c[e>>2]|0)>0)f=0;else{g=0;i=d;return g|0}while(1){if((sL(c[(c[a>>2]|0)+(f<<2)>>2]|0)|0)==(b|0)){g=1;h=4;break}f=f+1|0;if((f|0)>=(c[e>>2]|0)){g=0;h=4;break}}if((h|0)==4){i=d;return g|0}return 0}function lL(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=c[b+8>>2]|0;if(!g){h=c[b+12>>2]|0;j=h;k=(d[h+34>>0]|0)+255&255}else{j=g;k=a[g+34>>0]|0}g=c[j+20>>2]|0;j=c[e+8>>2]|0;if(!j){h=c[e+12>>2]|0;l=h;m=(d[h+34>>0]|0)+255&255}else{l=j;m=a[j+34>>0]|0}if(k<<24>>24!=m<<24>>24){n=0;i=f;return n|0}m=k&255;j=c[l+20>>2]|0;if(!(k<<24>>24)){n=1;i=f;return n|0}else o=0;while(1){k=c[g+(o*12|0)+8>>2]|0;l=c[j+(o*12|0)+8>>2]|0;if((c[l+4>>2]^c[k+4>>2])&1073741824){n=0;p=12;break}h=GI(k)|0;o=o+1|0;if((h|0)!=(GI(l)|0)){n=0;p=12;break}if((o|0)>=(m|0)){n=1;p=12;break}}if((p|0)==12){i=f;return n|0}return 0}function mL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=406064;f=_Ei(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;e=406064;c[e>>2]=f;c[e+4>>2]=H;e=sp(a)|0;c[e>>2]=b;i=d;return e|0}function nL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=406064;f=_Ei(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;e=406064;c[e>>2]=f;c[e+4>>2]=H;e=rp(a)|0;c[e>>2]=b;c[e+4>>2]=0;i=d;return e|0}function oL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=406064;f=_Ei(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;e=406064;c[e>>2]=f;c[e+4>>2]=H;e=gp(a,b)|0;i=d;return e|0}function pL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(a[b+145>>0]|0)){f=c[d>>2]|0;i=e;return f|0}else{g=SI(b)|0;h=wL(b)|0;YEi(h+8|0,d|0,g+-8|0)|0;f=h;i=e;return f|0}return 0}function qL(a){a=a|0;var b=0,c=0;b=i;c=wL(a)|0;i=b;return c|0}function rL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b>>2]|0;f=c[e+116>>2]|0;g=406064;h=_Ei(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;g=406064;c[g>>2]=h;c[g+4>>2]=H;g=sp(f)|0;c[g>>2]=e;YEi(g+8|0,b+8|0,f+-8|0)|0;if(a[(c[b>>2]|0)+154>>0]|0)Vs(g);if(!0){i=d;return g|0}JL(g,c[b>>2]|0);i=d;return g|0}function sL(a){a=a|0;return c[a>>2]|0}function tL(a){a=a|0;var b=0;b=da(a>>>2,-1640531535)|0;return b|0}function uL(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=c[d>>2]|0;d=c[h+52>>2]|0;if((b[f+28>>1]&96)!=64){j=f;i=g;return j|0}k=c[f+8>>2]|0;if(!(a[k+146>>0]|0))l=e[f+32>>1]|0;else{m=fJ(h,k)|0;l=(e[f+32>>1]|0)+m|0}j=c[d+(l<<2)>>2]|0;i=g;return j|0}function vL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!a){e=0;i=d;return e|0}f=bJ(b,c[a>>2]|0)|0;e=f?a:0;i=d;return e|0}function wL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;RI(b)|0;do if(!(a[b+151>>0]|0)){e=b+116|0;f=rp(c[e>>2]|0)|0;c[f>>2]=b;c[f+4>>2]=0;g=c[e>>2]|0;if(g>>>0>=128){PEi(f+8|0,0,g+-8|0)|0;h=f;break}e=f+g|0;if((g|0)>8){g=f+12|0;PEi(f+8|0,0,(e>>>0>g>>>0?e:g)+(-9-f)+4&-4|0)|0;h=f}else h=f}else{f=(c[b+4>>2]|0)==0;g=c[b+116>>2]|0;e=406064;j=_Ei(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;e=406064;c[e>>2]=j;c[e+4>>2]=H;if(f){f=sp(g)|0;c[f>>2]=b;h=f;break}else{h=gp(g,b)|0;break}}while(0);if(a[b+154>>0]|0)Vs(h);if(!0){i=d;return h|0}JL(h,b);i=d;return h|0}function xL(a){a=a|0;var b=0,c=0;b=i;c=wL(a)|0;i=b;return c|0}function yL(a){a=a|0;return a+8|0}function zL(a){a=a|0;var b=0;b=i;if(a)$K(a);i=b;return}function AL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;if(!b){f=0;i=d;return f|0}kI(e,b+12|0);b=a[e>>0]|0;if(!(b&1))g=(b&255)>>>1;else g=c[e+4>>2]|0;b=ZK(g+1|0)|0;if(!(a[e>>0]&1))h=e+1|0;else h=c[e+8>>2]|0;bFi(b|0,h|0)|0;xri(e);f=b;i=d;return f|0}function BL(a){a=a|0;var b=0,c=0;b=i;if(!a)c=0;else c=qM(a)|0;i=b;return c|0}function CL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=sI(a)|0;if(!e){i=d;return}else f=0;do{c[b+(f<<2)>>2]=AL(c[(yI(a,4,f)|0)>>2]|0)|0;f=f+1|0}while((f|0)!=(e|0));i=d;return}function DL(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(b){e=0;do{$K(c[a+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(b|0))}$K(a);i=d;return}function EL(a){a=a|0;var b=0,d=0,e=0;b=i;if(!a){d=0;i=b;return d|0}e=c[(c[a+20>>2]|0)+48>>2]|0;if(!e)FJ(SJ(405824)|0);d=e;i=b;return d|0}function FL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=qL(b)|0;f=GK(c[b>>2]|0,a)|0;if(!f){g=xCi(52)|0;c[g+4>>2]=a;c[g+16>>2]=0;HK(c[b>>2]|0,a,g);h=g}else h=f;hN(e,e,c[b+100>>2]|0,h);i=d;return e|0}function GL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[d+104>>2]&4095](a,b);i=e;return}function HL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[d+108>>2]&4095](a,b);i=e;return}function IL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+112>>2]|0;if(!e){f=0;i=d;return f|0}ko[e&4095](a);f=1;i=d;return f|0}function JL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(!0){i=d;return}else{e=0;f=0}while(1){g=c[f>>2]|0;if((c[g+4>>2]&128|0)!=0?(h=c[g+20>>2]|0,(h|0)!=0):0){co[h&2047](c[g>>2]|0,a,b);j=0}else j=e;f=f+4|0;if((f|0)==(j|0))break;else e=j}i=d;return}function KL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+16|0;d=b;BE(405936,0);e=c[101488]|0;f=a>>>3;g=c[e+4>>2]|0;a:do if(g){h=g+-1|0;j=(h&g|0)==0;if(j)k=h&f;else k=(f>>>0)%(g>>>0)|0;l=c[(c[e>>2]|0)+(k<<2)>>2]|0;if((l|0)!=0?(m=c[l>>2]|0,(m|0)!=0):0){b:do if(j){l=m;while(1){if((c[l+4>>2]&h|0)!=(k|0))break a;n=c[l+8>>2]|0;if((c[n>>2]|0)==(a|0)?(c[n+4>>2]|0)==0:0){o=l;break b}l=c[l>>2]|0;if(!l)break a}}else{l=m;while(1){if((((c[l+4>>2]|0)>>>0)%(g>>>0)|0|0)!=(k|0))break a;n=c[l+8>>2]|0;if((c[n>>2]|0)==(a|0)?(c[n+4>>2]|0)==0:0){o=l;break b}l=c[l>>2]|0;if(!l)break a}}while(0);if(o){p=c[o+12>>2]|0;EE(405936);i=b;return p|0}}}while(0);o=c[101486]|0;if(!o){k=iJ(c[101522]|0,3131888,3144808)|0;c[101486]=k;q=k}else q=o;o=qL(q)|0;c[o+8>>2]=a;q=c[101488]|0;k=c[q+4>>2]|0;c:do if(k){g=k+-1|0;e=(g&k|0)==0;if(e)r=g&f;else r=(f>>>0)%(k>>>0)|0;m=c[(c[q>>2]|0)+(r<<2)>>2]|0;if((m|0)!=0?(h=c[m>>2]|0,(h|0)!=0):0){d:do if(e){m=h;while(1){if((c[m+4>>2]&g|0)!=(r|0))break c;j=c[m+8>>2]|0;if((c[j>>2]|0)==(a|0)?(c[j+4>>2]|0)==0:0){s=m;break d}m=c[m>>2]|0;if(!m)break c}}else{m=h;while(1){if((((c[m+4>>2]|0)>>>0)%(k>>>0)|0|0)!=(r|0))break c;j=c[m+8>>2]|0;if((c[j>>2]|0)==(a|0)?(c[j+4>>2]|0)==0:0){s=m;break d}m=c[m>>2]|0;if(!m)break c}}while(0);if(s){p=0;EE(405936);i=b;return p|0}}}while(0);s=ADi(8)|0;c[d>>2]=s;c[s>>2]=a;c[s+4>>2]=0;c[(DO(q,d)|0)>>2]=o;p=o;EE(405936);i=b;return p|0}function LL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;BE(405936,0);f=c[101488]|0;g=b>>>3;h=c[f+4>>2]|0;a:do if(h){j=h+-1|0;k=(j&h|0)==0;if(k)l=j&g;else l=(g>>>0)%(h>>>0)|0;m=c[(c[f>>2]|0)+(l<<2)>>2]|0;if((m|0)!=0?(n=c[m>>2]|0,(n|0)!=0):0){b:do if(k){m=n;while(1){if((c[m+4>>2]&j|0)!=(l|0))break a;o=c[m+8>>2]|0;if((c[o>>2]|0)==(b|0)?(c[o+4>>2]|0)==(a|0):0){p=m;break b}m=c[m>>2]|0;if(!m)break a}}else{m=n;while(1){if((((c[m+4>>2]|0)>>>0)%(h>>>0)|0|0)!=(l|0))break a;o=c[m+8>>2]|0;if((c[o>>2]|0)==(b|0)?(c[o+4>>2]|0)==(a|0):0){p=m;break b}m=c[m>>2]|0;if(!m)break a}}while(0);if(p){q=c[p+12>>2]|0;EE(405936);i=d;return q|0}}}while(0);p=c[101490]|0;if(!p){l=iJ(c[101522]|0,3131888,2872896)|0;c[101490]=l;r=l}else r=p;p=qL(r)|0;c[p+8>>2]=a;c[p+12>>2]=b;c[p+16>>2]=qM($J(b)|0)|0;r=c[b+4>>2]|0;c[p+24>>2]=c[r+4>>2]&65535;c[p+20>>2]=ML(r)|0;r=c[101488]|0;l=c[r+4>>2]|0;c:do if(l){h=l+-1|0;f=(h&l|0)==0;if(f)s=h&g;else s=(g>>>0)%(l>>>0)|0;n=c[(c[r>>2]|0)+(s<<2)>>2]|0;if((n|0)!=0?(j=c[n>>2]|0,(j|0)!=0):0){d:do if(f){n=j;while(1){if((c[n+4>>2]&h|0)!=(s|0))break c;k=c[n+8>>2]|0;if((c[k>>2]|0)==(b|0)?(c[k+4>>2]|0)==(a|0):0){t=n;break d}n=c[n>>2]|0;if(!n)break c}}else{n=j;while(1){if((((c[n+4>>2]|0)>>>0)%(l>>>0)|0|0)!=(s|0))break c;k=c[n+8>>2]|0;if((c[k>>2]|0)==(b|0)?(c[k+4>>2]|0)==(a|0):0){t=n;break d}n=c[n>>2]|0;if(!n)break c}}while(0);if(t){q=0;EE(405936);i=d;return q|0}}}while(0);t=ADi(8)|0;c[e>>2]=t;c[t>>2]=b;c[t+4>>2]=a;c[(DO(r,e)|0)>>2]=p;q=p;EE(405936);i=d;return q|0}function ML(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(!(a[406040]|0)){c[101504]=0;c[101505]=0;c[101506]=0;c[101507]=0;g[101508]=ea(1.0);a[406040]=1}BE(405936,0);f=EO(406028,b)|0;h=c[101505]|0;a:do if(h){j=h+-1|0;k=(j&h|0)==0;if(k)l=j&f;else l=(f>>>0)%(h>>>0)|0;m=c[(c[101504]|0)+(l<<2)>>2]|0;if(m){n=m;while(1){m=c[n>>2]|0;if(!m)break a;o=c[m+4>>2]|0;if(k)p=o&j;else p=(o>>>0)%(h>>>0)|0;if((p|0)!=(l|0))break a;if(oK(406032,c[m+8>>2]|0,b)|0){q=m;break}else n=m}r=c[q+12>>2]|0;EE(405936);i=d;return r|0}}while(0);q=qL(c[101550]|0)|0;c[q+8>>2]=b;Ys(q,1)|0;c[(FO(406016,e)|0)>>2]=q;r=q;EE(405936);i=d;return r|0}function NL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;if(!d)g=c[b+8>>2]|0;else g=d;BE(405936,0);d=c[101488]|0;h=b>>>3;j=c[d+4>>2]|0;a:do if(j){k=j+-1|0;l=(k&j|0)==0;if(l)m=k&h;else m=(h>>>0)%(j>>>0)|0;n=c[(c[d>>2]|0)+(m<<2)>>2]|0;if((n|0)!=0?(o=c[n>>2]|0,(o|0)!=0):0){b:do if(l){n=o;while(1){if((c[n+4>>2]&k|0)!=(m|0))break a;p=c[n+8>>2]|0;if((c[p>>2]|0)==(b|0)?(c[p+4>>2]|0)==(g|0):0){q=n;break b}n=c[n>>2]|0;if(!n)break a}}else{n=o;while(1){if((((c[n+4>>2]|0)>>>0)%(j>>>0)|0|0)!=(m|0))break a;p=c[n+8>>2]|0;if((c[p>>2]|0)==(b|0)?(c[p+4>>2]|0)==(g|0):0){q=n;break b}n=c[n>>2]|0;if(!n)break a}}while(0);if(q){r=c[q+12>>2]|0;EE(405936);i=e;return r|0}}}while(0);q=c[b>>2]|0;do if((a[q>>0]|0)==46){if((HEi(q,3072840)|0)!=0?(HEi(q,3076392)|0)!=0:0){s=25;break}m=c[101494]|0;if(!m){j=iJ(c[101522]|0,3131888,2880720)|0;c[101494]=j;t=j}else t=m}else s=25;while(0);if((s|0)==25){s=c[101492]|0;if(!s){q=iJ(c[101522]|0,3131888,2878976)|0;c[101492]=q;t=q}else t=s}s=qL(t)|0;c[s+8>>2]=b;c[s+16>>2]=ML(c[g+64>>2]|0)|0;t=c[101488]|0;q=c[t+4>>2]|0;c:do if(q){m=q+-1|0;j=(m&q|0)==0;if(j)u=m&h;else u=(h>>>0)%(q>>>0)|0;d=c[(c[t>>2]|0)+(u<<2)>>2]|0;if((d|0)!=0?(o=c[d>>2]|0,(o|0)!=0):0){d:do if(j){d=o;while(1){if((c[d+4>>2]&m|0)!=(u|0))break c;k=c[d+8>>2]|0;if((c[k>>2]|0)==(b|0)?(c[k+4>>2]|0)==(g|0):0){v=d;break d}d=c[d>>2]|0;if(!d)break c}}else{d=o;while(1){if((((c[d+4>>2]|0)>>>0)%(q>>>0)|0|0)!=(u|0))break c;k=c[d+8>>2]|0;if((c[k>>2]|0)==(b|0)?(c[k+4>>2]|0)==(g|0):0){v=d;break d}d=c[d>>2]|0;if(!d)break c}}while(0);if(v){r=0;EE(405936);i=e;return r|0}}}while(0);v=ADi(8)|0;c[f>>2]=v;c[v>>2]=b;c[v+4>>2]=g;c[(DO(t,f)|0)>>2]=s;r=s;EE(405936);i=e;return r|0}function OL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+16|0;d=b;BE(405936,0);e=c[101488]|0;f=a>>>3;g=c[e+4>>2]|0;a:do if(g){h=g+-1|0;j=(h&g|0)==0;if(j)k=h&f;else k=(f>>>0)%(g>>>0)|0;l=c[(c[e>>2]|0)+(k<<2)>>2]|0;if((l|0)!=0?(m=c[l>>2]|0,(m|0)!=0):0){b:do if(j){l=m;while(1){if((c[l+4>>2]&h|0)!=(k|0))break a;n=c[l+8>>2]|0;if((c[n>>2]|0)==(a|0)?(c[n+4>>2]|0)==0:0){o=l;break b}l=c[l>>2]|0;if(!l)break a}}else{l=m;while(1){if((((c[l+4>>2]|0)>>>0)%(g>>>0)|0|0)!=(k|0))break a;n=c[l+8>>2]|0;if((c[n>>2]|0)==(a|0)?(c[n+4>>2]|0)==0:0){o=l;break b}l=c[l>>2]|0;if(!l)break a}}while(0);if(o){p=c[o+12>>2]|0;EE(405936);i=b;return p|0}}}while(0);o=c[101496]|0;if(!o){k=iJ(c[101522]|0,3131888,3144704)|0;c[101496]=k;q=k}else q=o;o=qL(q)|0;c[o+8>>2]=a;c[o+12>>2]=KL(c[a+24>>2]|0)|0;c[o+16>>2]=qM(c[a>>2]|0)|0;c[o+20>>2]=qM(c[a>>2]|0)|0;q=c[101488]|0;k=c[q+4>>2]|0;c:do if(k){g=k+-1|0;e=(g&k|0)==0;if(e)r=g&f;else r=(f>>>0)%(k>>>0)|0;m=c[(c[q>>2]|0)+(r<<2)>>2]|0;if((m|0)!=0?(h=c[m>>2]|0,(h|0)!=0):0){d:do if(e){m=h;while(1){if((c[m+4>>2]&g|0)!=(r|0))break c;j=c[m+8>>2]|0;if((c[j>>2]|0)==(a|0)?(c[j+4>>2]|0)==0:0){s=m;break d}m=c[m>>2]|0;if(!m)break c}}else{m=h;while(1){if((((c[m+4>>2]|0)>>>0)%(k>>>0)|0|0)!=(r|0))break c;j=c[m+8>>2]|0;if((c[j>>2]|0)==(a|0)?(c[j+4>>2]|0)==0:0){s=m;break d}m=c[m>>2]|0;if(!m)break c}}while(0);if(s){p=0;EE(405936);i=b;return p|0}}}while(0);s=ADi(8)|0;c[d>>2]=s;c[s>>2]=a;c[s+4>>2]=0;c[(DO(q,d)|0)>>2]=o;p=o;EE(405936);i=b;return p|0}function PL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;BE(405936,0);f=c[101488]|0;g=b>>>3;h=c[f+4>>2]|0;a:do if(h){j=h+-1|0;k=(j&h|0)==0;if(k)l=j&g;else l=(g>>>0)%(h>>>0)|0;m=c[(c[f>>2]|0)+(l<<2)>>2]|0;if((m|0)!=0?(n=c[m>>2]|0,(n|0)!=0):0){b:do if(k){m=n;while(1){if((c[m+4>>2]&j|0)!=(l|0))break a;o=c[m+8>>2]|0;if((c[o>>2]|0)==(b|0)?(c[o+4>>2]|0)==(a|0):0){p=m;break b}m=c[m>>2]|0;if(!m)break a}}else{m=n;while(1){if((((c[m+4>>2]|0)>>>0)%(h>>>0)|0|0)!=(l|0))break a;o=c[m+8>>2]|0;if((c[o>>2]|0)==(b|0)?(c[o+4>>2]|0)==(a|0):0){p=m;break b}m=c[m>>2]|0;if(!m)break a}}while(0);if(p){q=c[p+12>>2]|0;EE(405936);i=d;return q|0}}}while(0);p=c[101498]|0;if(!p){l=iJ(c[101522]|0,3131888,2884328)|0;c[101498]=l;r=l}else r=p;p=qL(r)|0;c[p+8>>2]=a;c[p+12>>2]=b;r=c[101488]|0;l=c[r+4>>2]|0;c:do if(l){h=l+-1|0;f=(h&l|0)==0;if(f)s=h&g;else s=(g>>>0)%(l>>>0)|0;n=c[(c[r>>2]|0)+(s<<2)>>2]|0;if((n|0)!=0?(j=c[n>>2]|0,(j|0)!=0):0){d:do if(f){n=j;while(1){if((c[n+4>>2]&h|0)!=(s|0))break c;k=c[n+8>>2]|0;if((c[k>>2]|0)==(b|0)?(c[k+4>>2]|0)==(a|0):0){t=n;break d}n=c[n>>2]|0;if(!n)break c}}else{n=j;while(1){if((((c[n+4>>2]|0)>>>0)%(l>>>0)|0|0)!=(s|0))break c;k=c[n+8>>2]|0;if((c[k>>2]|0)==(b|0)?(c[k+4>>2]|0)==(a|0):0){t=n;break d}n=c[n>>2]|0;if(!n)break c}}while(0);if(t){q=0;EE(405936);i=d;return q|0}}}while(0);t=ADi(8)|0;c[e>>2]=t;c[t>>2]=b;c[t+4>>2]=a;c[(DO(r,e)|0)>>2]=p;q=p;EE(405936);i=d;return q|0}function QL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;if(!(a[406008]|0)){c[101500]=iJ(c[101522]|0,3131888,2870664)|0;a[406008]=1}BE(405936,0);g=c[101488]|0;h=d>>>3;j=c[g+4>>2]|0;a:do if(j){k=j+-1|0;l=(k&j|0)==0;if(l)m=k&h;else m=(h>>>0)%(j>>>0)|0;n=c[(c[g>>2]|0)+(m<<2)>>2]|0;if((n|0)!=0?(o=c[n>>2]|0,(o|0)!=0):0){b:do if(l){n=o;while(1){if((c[n+4>>2]&k|0)!=(m|0))break a;p=c[n+8>>2]|0;if((c[p>>2]|0)==(d|0)?(c[p+4>>2]|0)==(b|0):0){q=n;break b}n=c[n>>2]|0;if(!n)break a}}else{n=o;while(1){if((((c[n+4>>2]|0)>>>0)%(j>>>0)|0|0)!=(m|0))break a;p=c[n+8>>2]|0;if((c[p>>2]|0)==(d|0)?(c[p+4>>2]|0)==(b|0):0){q=n;break b}n=c[n>>2]|0;if(!n)break a}}while(0);if(q){r=c[q+12>>2]|0;EE(405936);i=e;return r|0}}}while(0);q=qL(c[101500]|0)|0;c[q+16>>2]=d;c[q+12>>2]=ML(c[b+64>>2]|0)|0;m=c[101488]|0;j=c[m+4>>2]|0;c:do if(j){g=j+-1|0;o=(g&j|0)==0;if(o)s=g&h;else s=(h>>>0)%(j>>>0)|0;k=c[(c[m>>2]|0)+(s<<2)>>2]|0;if((k|0)!=0?(l=c[k>>2]|0,(l|0)!=0):0){d:do if(o){k=l;while(1){if((c[k+4>>2]&g|0)!=(s|0))break c;n=c[k+8>>2]|0;if((c[n>>2]|0)==(d|0)?(c[n+4>>2]|0)==(b|0):0){t=k;break d}k=c[k>>2]|0;if(!k)break c}}else{k=l;while(1){if((((c[k+4>>2]|0)>>>0)%(j>>>0)|0|0)!=(s|0))break c;n=c[k+8>>2]|0;if((c[n>>2]|0)==(d|0)?(c[n+4>>2]|0)==(b|0):0){t=k;break d}k=c[k>>2]|0;if(!k)break c}}while(0);if(t){r=0;EE(405936);i=e;return r|0}}}while(0);t=ADi(8)|0;c[f>>2]=t;c[t>>2]=d;c[t+4>>2]=b;c[(DO(m,f)|0)>>2]=q;r=q;EE(405936);i=e;return r|0}function RL(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;BE(405936,0);g=c[101514]|0;if(!g){h=iJ(c[101522]|0,3131888,2886832)|0;c[101512]=h;j=JI(h,1)|0;c[101514]=j;k=j}else k=g;g=b+34|0;if(!(a[g>>0]|0)){l=vI(k,0)|0;EE(405936);i=f;return l|0}k=b+4|0;j=c[101488]|0;h=k>>>3;m=c[j+4>>2]|0;a:do if(m){n=m+-1|0;o=(n&m|0)==0;if(o)p=n&h;else p=(h>>>0)%(m>>>0)|0;q=c[(c[j>>2]|0)+(p<<2)>>2]|0;if((q|0)!=0?(r=c[q>>2]|0,(r|0)!=0):0){b:do if(o){q=r;while(1){if((c[q+4>>2]&n|0)!=(p|0))break a;s=c[q+8>>2]|0;if((c[s>>2]|0)==(k|0)?(c[s+4>>2]|0)==(e|0):0){t=q;break b}q=c[q>>2]|0;if(!q)break a}}else{q=r;while(1){if((((c[q+4>>2]|0)>>>0)%(m>>>0)|0|0)!=(p|0))break a;s=c[q+8>>2]|0;if((c[s>>2]|0)==(k|0)?(c[s+4>>2]|0)==(e|0):0){t=q;break b}q=c[q>>2]|0;if(!q)break a}}while(0);if(t){l=c[t+12>>2]|0;EE(405936);i=f;return l|0}}}while(0);t=NL(b,e)|0;e=vI(c[101514]|0,d[g>>0]|0)|0;if(!(a[g>>0]|0)){l=e;EE(405936);i=f;return l|0}k=b+20|0;b=0;do{p=qL(c[101512]|0)|0;c[p+8>>2]=ML(c[(c[k>>2]|0)+(b*12|0)+8>>2]|0)|0;c[p+16>>2]=t;c[p+20>>2]=qM(c[(c[k>>2]|0)+(b*12|0)>>2]|0)|0;c[p+24>>2]=b;c[p+28>>2]=c[(c[(c[k>>2]|0)+(b*12|0)+8>>2]|0)+4>>2]&65535;c[(yI(e,4,b)|0)>>2]=p;b=b+1|0}while((b|0)<(d[g>>0]|0));l=e;EE(405936);i=f;return l|0}function SL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=c[d+8>>2]|0;if((HEi(e,2878976)|0)==0?(HEi(c[d+12>>2]|0,3131888)|0)==0:0){f=c[(c[a+8>>2]|0)+24>>2]|0;if(c[f+4>>2]|0){g=f;i=b;return g|0}if(!(c[f>>2]|0)){g=f;i=b;return g|0}ko[c[f+8>>2]&4095](f);g=f;i=b;return g|0}if((HEi(e,2884328)|0)==0?(HEi(c[d+12>>2]|0,3131888)|0)==0:0){f=c[(c[a+12>>2]|0)+20>>2]|0;if(c[f+4>>2]|0){g=f;i=b;return g|0}if(!(c[f>>2]|0)){g=f;i=b;return g|0}ko[c[f+8>>2]&4095](f);g=f;i=b;return g|0}if((HEi(e,2872896)|0)==0?(HEi(c[d+12>>2]|0,3131888)|0)==0:0){f=c[(c[a+12>>2]|0)+16>>2]|0;if(c[f+4>>2]|0){g=f;i=b;return g|0}if(!(c[f>>2]|0)){g=f;i=b;return g|0}ko[c[f+8>>2]&4095](f);g=f;i=b;return g|0}if((HEi(e,2870664)|0)==0?(HEi(c[d+12>>2]|0,3131888)|0)==0:0){f=c[(c[a+16>>2]|0)+24>>2]|0;if(c[f+4>>2]|0){g=f;i=b;return g|0}if(!(c[f>>2]|0)){g=f;i=b;return g|0}ko[c[f+8>>2]&4095](f);g=f;i=b;return g|0}if((HEi(e,3098672)|0)==0?(HEi(c[d+12>>2]|0,3496376)|0)==0:0)h=LI(a)|0;else h=d;d=c[h+56>>2]|0;if(c[d+4>>2]|0){g=d;i=b;return g|0}if(!(c[d>>2]|0)){g=d;i=b;return g|0}ko[c[d+8>>2]&4095](d);g=d;i=b;return g|0}function TL(){var a=0,b=0;a=i;b=xCi(20)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[b+16>>2]=ea(1.0);c[101488]=b;i=a;return}function UL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((c[b>>2]|0)<=0){f=0;i=e;return f|0}g=b+4|0;h=d+146|0;j=0;while(1){k=c[c[(c[g>>2]|0)+(j<<2)>>2]>>2]|0;if(aJ(k,d)|0){f=1;l=7;break}if((a[h>>0]|0)!=0?bJ(d,k)|0:0){f=1;l=7;break}j=j+1|0;if((j|0)>=(c[b>>2]|0)){f=0;l=7;break}}if((l|0)==7){i=e;return f|0}return 0}function VL(a){a=a|0;var b=0,d=0;b=i;d=c[a+16>>2]|0;if((c[d+4>>2]|0)==0?(c[d>>2]|0)!=0:0)ko[c[d+8>>2]&4095](d);i=b;return d|0}function WL(a){a=a|0;var b=0,d=0;b=i;d=c[a+24>>2]|0;if((c[d+4>>2]|0)==0?(c[d>>2]|0)!=0:0)ko[c[d+8>>2]&4095](d);i=b;return d|0}function XL(a){a=a|0;var b=0,d=0;b=i;d=c[a+56>>2]|0;if((c[d+4>>2]|0)==0?(c[d>>2]|0)!=0:0)ko[c[d+8>>2]&4095](d);i=b;return d|0}function YL(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+12|0;f=d;rri(e,b,SEi(b|0)|0);vri(f,e,(Mri(e,47,-1)|0)+1|0,-1,e);if(!(a[f>>0]&1))g=f+1|0;else g=c[f+8>>2]|0;b=jCi(g)|0;xri(f);xri(e);i=d;return b|0}function ZL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+12|0;e=b;xF();hI();EI();us();TL();LK();PEi(406088,0,176)|0;f=BI(CI(3649424)|0)|0;c[101522]=f;c[101523]=iJ(f,3496376,3126408)|0;c[101525]=iJ(c[101522]|0,3496376,2649376)|0;c[101526]=iJ(c[101522]|0,3496376,3126472)|0;c[101524]=iJ(c[101522]|0,3496376,3126568)|0;c[101527]=iJ(c[101522]|0,3496376,3126536)|0;c[101528]=iJ(c[101522]|0,3496376,3126600)|0;c[101529]=iJ(c[101522]|0,3496376,3126632)|0;c[101530]=iJ(c[101522]|0,3496376,3126664)|0;c[101531]=iJ(c[101522]|0,3496376,3126696)|0;c[101533]=iJ(c[101522]|0,3496376,2607976)|0;c[101532]=iJ(c[101522]|0,3496376,2605856)|0;c[101534]=iJ(c[101522]|0,3496376,3126728)|0;c[101535]=iJ(c[101522]|0,3496376,3126760)|0;c[101536]=iJ(c[101522]|0,3496376,3126792)|0;c[101537]=iJ(c[101522]|0,3496376,3126824)|0;c[101538]=iJ(c[101522]|0,3496376,3126504)|0;c[101539]=iJ(c[101522]|0,3496376,3126928)|0;c[101540]=iJ(c[101522]|0,3496376,3029544)|0;c[101541]=iJ(c[101522]|0,3496376,2646336)|0;c[101542]=iJ(c[101522]|0,3496376,3029832)|0;c[101543]=iJ(c[101522]|0,3496376,2609112)|0;c[101545]=iJ(c[101522]|0,3009648,3011664)|0;c[101549]=iJ(c[101522]|0,3496376,2657584)|0;c[101550]=iJ(c[101522]|0,3496376,3098672)|0;c[101553]=iJ(c[101522]|0,3009648,3146304)|0;c[101554]=iJ(c[101522]|0,3496376,3023992)|0;c[101555]=iJ(c[101522]|0,3496376,3025608)|0;c[101556]=iJ(c[101522]|0,3131888,2860064)|0;c[101557]=iJ(c[101522]|0,3131888,2866856)|0;c[101558]=iJ(c[101522]|0,3131888,2888304)|0;c[101559]=iJ(c[101522]|0,3131888,2857512)|0;c[101560]=iJ(c[101522]|0,2743936,2746496)|0;c[101561]=iJ(c[101522]|0,2743936,2747864)|0;c[101562]=iJ(c[101522]|0,2701248,2648920)|0;c[101563]=iJ(c[101522]|0,3496376,2671608)|0;c[101564]=iJ(c[101522]|0,3496376,3131024)|0;c[101565]=iJ(c[101522]|0,2695624,2760664)|0;RI(c[101539]|0)|0;f=AJ()|0;yM(f)|0;g=xL(c[101554]|0)|0;h=xL(c[101554]|0)|0;c[h+12>>2]=f;c[f>>2]=h;c[f+4>>2]=g;c[f+12>>2]=1;c[f+8>>2]=YL(a)|0;OK();Ss();KE();rri(d,406272,26);rri(e,2337392,3);OG(d,e);xri(e);xri(d);i=b;return}function _L(){var a=0;a=i;LE();i=a;return}function $L(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=UI(c[a>>2]|0,3131560,-1)|0;if(d)c[d>>2]=0;d=xo[c[f+16>>2]&2047](f,a,b)|0;i=e;return d|0}function aM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;if(e)c[e>>2]=0;e=xo[c[a+16>>2]&2047](a,b,d)|0;i=f;return e|0}function bM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(d){g=sI(d)|0;h=i;i=i+((1*(g<<2)|0)+15&-16)|0;if((g|0)>0){j=0;do{c[h+(j<<2)>>2]=c[(yI(d,4,j)|0)>>2];j=j+1|0}while((j|0)!=(g|0));k=h;l=g}else{k=h;l=g}}else{k=0;l=0}g=cM(a,b,k,l,e)|0;i=f;return g|0}function cM(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+16|0;j=h;if(e){k=i;i=i+((1*(f<<2)|0)+15&-16)|0;if((f|0)>0){l=b+20|0;m=0;while(1){n=(c[l>>2]|0)+(m*12|0)+8|0;o=n;a:while(1){p=c[o>>2]|0;q=p+4|0;r=c[q>>2]|0;switch(r>>>16&255|0){case 21:break;case 15:{s=15;break a;break}case 17:case 13:case 12:case 10:case 11:case 8:case 9:case 24:case 25:case 3:case 6:case 7:case 2:case 4:case 5:{t=q;u=r;s=6;break a;break}case 29:case 20:case 18:case 28:case 14:{v=r;s=11;break a;break}default:break a}q=c[c[p>>2]>>2]|0;o=(r&1073741824|0)==0?q+64|0:q+68|0}do if((s|0)==6){s=0;o=e+(m<<2)|0;q=c[o>>2]|0;if(!q){r=qL(GI(c[n>>2]|0)|0)|0;c[o>>2]=r;w=c[t>>2]|0;x=r}else{w=u;x=q}if(!(w&1073741824))y=x;else{q=c[x>>2]|0;r=pL(q,yL(x)|0)|0;c[o>>2]=r;y=r}c[k+(m<<2)>>2]=yL(y)|0}else if((s|0)==11){s=0;r=e+(m<<2)|0;if(!(v&1073741824)){c[k+(m<<2)>>2]=c[r>>2];break}else{c[k+(m<<2)>>2]=r;break}}else if((s|0)==15){s=0;r=c[e+(m<<2)>>2]|0;if(!r){c[k+(m<<2)>>2]=0;break}else{c[k+(m<<2)>>2]=c[r>>2];break}}while(0);m=m+1|0;if((m|0)==(f|0)){z=k;break}}}else z=k}else z=0;if((HEi(c[b>>2]|0,3072840)|0)==0?(k=b+8|0,f=c[k>>2]|0,(f|0)!=(c[101539]|0)):0){if(!d){m=qL(f)|0;if(!(a[(c[k>>2]|0)+145>>0]|0)){A=m;B=m}else{A=m;B=yL(m)|0}}else if(!(a[f+145>>0]|0)){A=d;B=d}else{A=pL(f,d)|0;B=d}if(g)c[g>>2]=0;xo[c[b+16>>2]&2047](b,B,z)|0;C=A;i=h;return C|0}if(g)c[g>>2]=0;g=xo[c[b+16>>2]&2047](b,d,z)|0;if((c[(c[b+12>>2]|0)+4>>2]&16711680|0)!=983040){C=g;i=h;return C|0}c[j>>2]=406328;gl(406304,j|0)|0;C=g;i=h;return C|0}function dM(b){b=b|0;var d=0,e=0,f=0;d=i;e=UI(c[b>>2]|0,3072840,0)|0;if(!(a[(c[e+8>>2]|0)+145>>0]|0))f=b;else f=yL(b)|0;xo[c[e+16>>2]&2047](e,f,0)|0;i=d;return}function eM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=UI(c[b>>2]|0,3072840,0)|0;if(!(a[(c[f+8>>2]|0)+145>>0]|0))g=b;else g=yL(b)|0;if(d)c[d>>2]=0;xo[c[f+16>>2]&2047](f,g,0)|0;i=e;return}function fM(a){a=a|0;return}function gM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b;AJ()|0;f=BJ()|0;c[e>>2]=0;g=PI(c[101554]|0,3023408)|0;if((c[a>>2]|0)==(c[101552]|0)){i=b;return}zM()|0;dK(c[f>>2]|0,g,e);g=c[e>>2]|0;if(!g){i=b;return}c[d>>2]=c[f>>2];c[d+4>>2]=kM(a)|0;a=UI(c[g>>2]|0,3131560,-1)|0;xo[c[a+16>>2]&2047](a,g,d)|0;i=b;return}function hM(a){a=a|0;var b=0;b=c[101533]|0;return (b|0)==(a|0)&(b|0)!=0|0}function iM(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,h=0;g=i;h=c[(c[(c[f>>2]|0)+52>>2]|0)+(e[d+32>>1]<<2)>>2]|0;c[b>>2]=f;c[b+4>>2]=h;d=c[h+8>>2]|0;if(!(a[d+145>>0]|0)){i=g;return}if(a[d+149>>0]|0){i=g;return}c[b>>2]=yL(f)|0;i=g;return}function jM(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=c[f>>2]|0;j=b[e+32>>1]|0;k=(fJ(h,c[e+8>>2]|0)|0)+(j&65535)&65535;j=c[(c[h+52>>2]|0)+(k<<2)>>2]|0;c[d>>2]=f;c[d+4>>2]=j;k=c[j+8>>2]|0;if(!(a[k+145>>0]|0)){i=g;return}if(a[k+149>>0]|0){i=g;return}c[d>>2]=yL(f)|0;i=g;return}function kM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+8|0;a[f>>0]=1;g=iJ(c[101522]|0,3496376,3128720)|0;RI(g)|0;h=VI(g,3072840,2,6)|0;c[e>>2]=b;c[e+4>>2]=f;f=qL(g)|0;xo[c[h+16>>2]&2047](h,f,e)|0;i=d;return f|0}function lM(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+148|0;if(a[e>>0]|0){i=d;return}if(!(a[b+155>>0]|0)){a[e>>0]=1;i=d;return}BE(406360,0);if((a[e>>0]|0)==0?(f=vJ(b)|0,(f|0)!=0):0){a[e>>0]=1;xo[c[f+16>>2]&2047](f,0,0)|0}EE(406360);i=d;return}function mM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=c[a+4>>2]|0;if(!e){i=b;return}f=c[101593]|0;do if(f){g=f;while(1){h=c[g+16>>2]|0;if(e>>>0<h>>>0){j=c[g>>2]|0;if(!j){k=g;l=g;m=5;break}else{g=j;continue}}if(h>>>0>=e>>>0){n=g;m=9;break}h=g+4|0;j=c[h>>2]|0;if(!j){o=h;p=g;m=8;break}else g=j}if((m|0)==5){c[d>>2]=l;q=k;r=l;break}else if((m|0)==8){c[d>>2]=p;q=o;r=p;break}else if((m|0)==9){c[d>>2]=n;q=d;r=n;break}}else{c[d>>2]=406372;q=406372|0;r=406372|0}while(0);d=c[q>>2]|0;if(!d){n=xCi(24)|0;c[n+16>>2]=e;c[n+20>>2]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=r;c[q>>2]=n;r=c[c[101592]>>2]|0;if(!r)s=n;else{c[101592]=r;s=c[q>>2]|0}GN(c[101593]|0,s);c[101594]=(c[101594]|0)+1;t=n}else t=d;c[t+20>>2]=a;i=b;return}function nM(a){a=a|0;return c[a+8>>2]|0}function oM(a){a=a|0;return a+12|0}function pM(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0;b=i;d=c[a+8>>2]|0;if((d|0)<=0){f=0;i=b;return f|0}g=0;h=0;j=a+12|0;while(1){a=(e[j>>1]|0)+(g*31|0)|0;h=h+1|0;if((h|0)==(d|0)){f=a;break}else{g=a;j=j+2|0}}i=b;return f|0}function qM(a){a=a|0;var b=0,c=0;b=i;c=rM(a,SEi(a|0)|0)|0;i=b;return c|0}function rM(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;lI(g,d,e);e=a[g>>0]|0;if(!(e&1)){h=(e&255)>>>1;j=g+2|0}else{h=c[g+4>>2]|0;j=c[g+8>>2]|0}e=h<<1;d=e+14|0;if(d>>>0<h>>>0)GJ();k=nL(d,c[101539]|0)|0;c[k+8>>2]=h;d=k+12|0;b[d+(h<<1)>>1]=0;if(0)JL(k,c[101539]|0);YEi(d|0,j|0,e|0)|0;if(!(a[g>>0]&1)){i=f;return k|0}ACi(c[g+8>>2]|0);i=f;return k|0}function sM(a){a=a|0;var b=0,c=0;b=i;c=rM(a,SEi(a|0)|0)|0;i=b;return c|0}function tM(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d<<1;g=f+14|0;if(g>>>0<d>>>0)GJ();h=nL(g,c[101539]|0)|0;c[h+8>>2]=d;g=h+12|0;b[g+(d<<1)>>1]=0;if(!0){YEi(g|0,a|0,f|0)|0;i=e;return h|0}JL(h,c[101539]|0);YEi(g|0,a|0,f|0)|0;i=e;return h|0}function uM(a){a=a|0;var d=0,e=0,f=0;d=i;e=(a<<1)+14|0;if(e>>>0<a>>>0)GJ();f=nL(e,c[101539]|0)|0;c[f+8>>2]=a;b[f+12+(a<<1)>>1]=0;if(!0){i=d;return f|0}JL(f,c[101539]|0);i=d;return f|0}function vM(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e;j=e+8|0;BE(406384,0);c[h>>2]=d;c[h+4>>2]=a;GO(j,406392,h);k=c[j>>2]|0;if(k){l=c[k+16>>2]|0;EE(406384);i=e;return l|0}k=d<<1;j=k+14|0;if(j>>>0<d>>>0)GJ();m=nL(j,c[101539]|0)|0;c[m+8>>2]=d;j=m+12|0;b[j+(d<<1)>>1]=0;if(0)JL(m,c[101539]|0);YEi(j|0,a|0,k|0)|0;Ys(m,1)|0;GO(f,406392,h);k=c[f>>2]|0;if(!k){f=xCi(20)|0;a=h;h=c[a+4>>2]|0;j=f+8|0;c[j>>2]=c[a>>2];c[j+4>>2]=h;c[f+16>>2]=0;HO(g,406392,f);n=c[g>>2]|0}else n=k;c[n+16>>2]=m;l=m;EE(406384);i=e;return l|0}function wM(a){a=a|0;var b=0,d=0;b=i;d=vM(a+12|0,c[a+8>>2]|0)|0;i=b;return d|0}function xM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;c[d>>2]=c[a+8>>2];c[d+4>>2]=a+12;GO(e,406392,d);d=c[e>>2]|0;if(!d){f=0;i=b;return f|0}f=c[d+16>>2]|0;i=b;return f|0}function yM(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;c[b>>2]=0;JF(406456,b)|0;d=c[b>>2]|0;if(d){e=d;i=a;return e|0}c[a>>2]=0;d=yF()|0;b=qL(c[101553]|0)|0;c[b+12>>2]=d;d=xCi(4)|0;AE(d,0);c[b+108>>2]=d;Ys(b,1)|0;BM(b);e=b;i=a;return e|0}function zM(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=0;JF(406456,b)|0;i=a;return c[b>>2]|0}function AM(a){a=a|0;var b=0,d=0;b=i;d=xCi(4)|0;AE(d,0);c[a+108>>2]=d;i=b;return}function BM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+12|0;e=b;IF(406456,a)|0;f=xCi(12)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[a+176>>2]=f;c[d>>2]=0;JF(406456,d)|0;f=c[(c[d>>2]|0)+176>>2]|0;g=f+8|0;h=c[f>>2]|0;j=h;if((c[g>>2]|0)-j>>2>>>0<1024?(k=f+4|0,l=(c[k>>2]|0)-j|0,j=xCi(4096)|0,YEi(j|0,h|0,l|0)|0,c[f>>2]=j,c[k>>2]=j+(l>>2<<2),c[g>>2]=j+4096,(h|0)!=0):0)ACi(h);c[d>>2]=a;BE(406432,0);h=c[101605]|0;if((h|0)==(c[101606]|0))IO(406416,d);else{if(!h)m=0;else{c[h>>2]=a;m=c[101605]|0}c[101605]=m+4}EE(406432);CM();m=c[a+28>>2]|0;if(m){kI(e,m);zF(c[a+12>>2]|0,e);xri(e)}e=a+92|0;if(!(c[e>>2]|0)){i=b;return}m=c[a+108>>2]|0;BE(m,0);c[e>>2]=1;e=c[a+12>>2]|0;if(e)DF(e,80);EE(m);i=b;return}function CM(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a;BE(406432,0);c[b>>2]=0;JF(406456,b)|0;d=(c[b>>2]|0)+64|0;b=c[d>>2]|0;if(!b){e=CDi(2048,4)|0;c[d>>2]=e;f=e}else f=b;b=c[101610]|0;e=c[101611]|0;if((b|0)==(e|0)){EE(406432);i=a;return}else{g=b;h=e;j=f;k=0}while(1){if(!(c[j+(k<<2)>>2]|0)){f=Ks(c[g>>2]|0,0)|0;c[(c[d>>2]|0)+(k<<2)>>2]=f;l=c[101611]|0}else l=h;f=g+4|0;if((f|0)==(l|0))break;g=f;h=l;j=c[d>>2]|0;k=k+1|0}EE(406432);i=a;return}function DM(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+108>>2]|0;BE(d,0);c[a+92>>2]=1;e=c[a+12>>2]|0;if(!e){EE(d);i=b;return}DF(e,80);EE(d);i=b;return}function EM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;BE(406432,0);d=c[101604]|0;e=c[101605]|0;a:do if((d|0)==(e|0))f=d;else{g=d;while(1){if((c[g>>2]|0)==(a|0)){f=g;break a}g=g+4|0;if((g|0)==(e|0)){f=e;break}}}while(0);g=f-d>>2;f=d+(g+1<<2)|0;h=e-f|0;aFi(d+(g<<2)|0,f|0,h|0)|0;f=d+((h>>2)+g<<2)|0;g=c[101605]|0;if((g|0)!=(f|0))c[101605]=g+(~((g+-4-f|0)>>>2)<<2);EE(406432);FM(a);f=c[a+176>>2]|0;if(f)ACi(f);f=c[a+112>>2]|0;if(!f){IF(406456,0)|0;i=b;return}BCi(f);IF(406456,0)|0;i=b;return}function FM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;BE(406432,0);d=c[101610]|0;e=c[101611]|0;f=a+64|0;a=c[f>>2]|0;if((d|0)==(e|0)){g=a;BDi(g);c[f>>2]=0;EE(406432);i=b;return}else{h=d;j=e;k=a;l=0}while(1){a=c[k+(l<<2)>>2]|0;if(!a){m=j;n=k}else{Ls(a);m=c[101611]|0;n=c[f>>2]|0}h=h+4|0;if((h|0)==(m|0)){g=n;break}else{j=m;k=n;l=l+1|0}}BDi(g);c[f>>2]=0;EE(406432);i=b;return}function GM(){return 0}function HM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+108>>2]|0;BE(e,0);f=a+36|0;c[f>>2]=c[f>>2]|b;EE(e);i=d;return}function IM(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+108>>2]|0;BE(d,0);e=c[a+36>>2]|0;EE(d);i=b;return e|0}function JM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+108>>2]|0;BE(e,0);f=a+36|0;c[f>>2]=c[f>>2]&~b;EE(e);i=d;return}function KM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;c[d>>2]=a;BE(406432,0);e=c[101611]|0;f=e-(c[101610]|0)>>2;if((e|0)==(c[101612]|0))JO(406440,d);else{if(e)c[e>>2]=a;c[101611]=e+4}e=c[101604]|0;if((e|0)==(c[101605]|0)){EE(406432);i=b;return f|0}else g=e;do{e=(c[g>>2]|0)+64|0;if(!(c[e>>2]|0))c[e>>2]=CDi(2048,4)|0;d=Ks(a,0)|0;c[(c[e>>2]|0)+(f<<2)>>2]=d;g=g+4|0}while((g|0)!=(c[101605]|0));EE(406432);i=b;return f|0}function LM(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=0;JF(406456,d)|0;i=b;return c[(c[(c[d>>2]|0)+64>>2]|0)+(a<<2)>>2]|0}function MM(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=0;JF(406456,d)|0;KO(a,c[(c[d>>2]|0)+176>>2]|0);i=b;return}function NM(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;b=a;c[b>>2]=0;JF(406456,b)|0;d=c[b>>2]|0;if(!d){i=a;return}b=d+108|0;e=c[b>>2]|0;BE(e,0);f=d+92|0;if((c[f>>2]|0)!=0?(g=c[b>>2]|0,BE(g,0),h=d+36|0,d=c[h>>2]|0,EE(g),(d&32|0)!=0):0){c[f>>2]=0;f=c[b>>2]|0;BE(f,0);c[h>>2]=c[h>>2]&-33;EE(f);FJ(WJ()|0)}EE(e);i=a;return}function OM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;c[b>>2]=e;a[b+4>>0]=f&1;a[b+5>>0]=1;if(!(a[d>>0]&1))h=d+1|0;else h=c[d+8>>2]|0;c[b+8>>2]=h;h=a[d>>0]|0;if(!(h&1)){j=d+1|0;k=(h&255)>>>1;l=j+k|0;m=b+12|0;c[m>>2]=l;i=g;return}else{j=c[d+8>>2]|0;k=c[d+4>>2]|0;l=j+k|0;m=b+12|0;c[m>>2]=l;i=g;return}}function PM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+5|0;a[h>>0]=d&1;c[g>>2]=0;d=b+8|0;j=b+12|0;k=c[d>>2]|0;l=c[j>>2]|0;a:do if(k>>>0<l>>>0){m=k;while(1){n=a[m>>0]|0;if(!(n<<24>>24==9|n<<24>>24==32)){o=m;break a}n=m+1|0;c[d>>2]=n;if(n>>>0<l>>>0)m=n;else{o=n;break}}}else o=k;while(0);if(o>>>0>=l>>>0){p=0;i=e;return p|0}if(!(QM(b,g)|0)){p=0;i=e;return p|0}if(!(RM(b,g)|0)){p=0;i=e;return p|0}if(!(SM(b,g)|0)){p=0;i=e;return p|0}g=c[d>>2]|0;l=c[j>>2]|0;b:do if(g>>>0<l>>>0){o=g;k=l;while(1){if(o>>>0>=k>>>0)break b;if((a[o>>0]|0)!=42)break b;m=c[b>>2]|0;c[f>>2]=-1;n=m+116|0;q=c[n>>2]|0;if((q|0)==(c[m+120>>2]|0)){JO(m+112|0,f);r=c[j>>2]|0;s=c[d>>2]|0}else{if(q)c[q>>2]=-1;c[n>>2]=q+4;r=k;s=o}q=s+1|0;c[d>>2]=q;c:do if(q>>>0<r>>>0){n=q;m=s;while(1){t=a[n>>0]|0;if(!(t<<24>>24==9|t<<24>>24==32)){u=n;break c}t=m+2|0;c[d>>2]=t;if(t>>>0<r>>>0){v=n;n=t;m=v}else{u=t;break}}}else u=q;while(0);if(u>>>0<r>>>0){o=u;k=r}else break}}while(0);if(!(TM(b)|0)){p=0;i=e;return p|0}r=c[d>>2]|0;u=c[j>>2]|0;d:do if(r>>>0<u>>>0?(a[r>>0]|0)==38:0){s=c[b>>2]|0;l=c[s+112>>2]|0;g=s+116|0;k=c[g>>2]|0;e:do if((l|0)==(k|0)){w=l;x=27}else{o=l;do{if(!(c[o>>2]|0)){w=o;x=27;break e}o=o+4|0}while((o|0)!=(k|0))}while(0);if((x|0)==27?(w|0)!=(k|0):0){p=0;i=e;return p|0}c[f>>2]=0;if((k|0)==(c[s+120>>2]|0)){JO(s+112|0,f);y=c[j>>2]|0;z=c[d>>2]|0}else{if(k)c[k>>2]=0;c[g>>2]=k+4;y=u;z=r}l=z+1|0;c[d>>2]=l;if(l>>>0<y>>>0){o=l;q=z;while(1){m=a[o>>0]|0;if(!(m<<24>>24==9|m<<24>>24==32)){A=o;B=y;break d}m=q+2|0;c[d>>2]=m;if(m>>>0<y>>>0){n=o;o=m;q=n}else{A=m;B=y;break}}}else{A=l;B=y}}else{A=r;B=u}while(0);if((a[h>>0]|0)!=0&A>>>0<B>>>0?(a[A>>0]|0)==44:0){h=A+1|0;c[d>>2]=h;if(h>>>0<B>>>0){C=h;D=A}else{p=0;i=e;return p|0}while(1){h=a[C>>0]|0;if(!(h<<24>>24==9|h<<24>>24==32))break;h=D+2|0;c[d>>2]=h;if(h>>>0<B>>>0){u=C;C=h;D=u}else break}VM(b)|0;E=c[d>>2]|0;F=c[j>>2]|0}else{E=A;F=B}if((E|0)==(F|0)){p=1;i=e;return p|0}p=(a[b+4>>0]|0)!=0;i=e;return p|0}function QM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;f=b+8|0;g=c[f>>2]|0;h=g;j=b+12|0;k=c[j>>2]|0;l=g;m=k;while(1){n=l;a:while(1){switch(a[n>>0]|0){case 96:case 34:case 61:case 46:case 93:case 91:case 42:case 38:case 43:case 44:{o=n;break a;break}case 92:{p=n+1|0;c[f>>2]=p;q=p;break}default:q=n}p=q+1|0;c[f>>2]=p;if(p>>>0<k>>>0)n=p;else{o=p;break}}if(o>>>0>=k>>>0){r=m;s=k;break}if((a[o>>0]|0)!=46){t=m;u=o;v=9;break}l=o+1|0;c[f>>2]=l;if(l>>>0>=k>>>0){w=0;v=63;break}else m=o}if((v|0)==63){i=e;return w|0}if((v|0)==9)if((a[u>>0]|0)==96){v=u+1|0;c[f>>2]=v;if(v>>>0>=k>>>0){w=0;i=e;return w|0}if(((a[v>>0]|0)+-48|0)>>>0<10){x=v;y=u}else{w=0;i=e;return w|0}while(1){u=y+2|0;c[f>>2]=u;if(u>>>0>=k>>>0)break;if(((a[u>>0]|0)+-48|0)>>>0<10){o=x;x=u;y=o}else break}c[d>>2]=DEi(v,0,10)|0;r=t;s=c[j>>2]|0}else{r=t;s=k}k=c[b>>2]|0;if((r|0)==(s|0)){s=k+12|0;t=c[f>>2]|0;j=t-h|0;v=a[s>>0]|0;if(!(v&1)){z=10;A=v}else{v=c[s>>2]|0;z=(v&-2)+-1|0;A=v&255}if(j>>>0>z>>>0){if(!(A&1))B=(A&255)>>>1;else B=c[k+16>>2]|0;Iri(s,z,j-z|0,B,0,B,0);C=a[s>>0]|0}else C=A;if(!(C&1))D=s+1|0;else D=c[k+20>>2]|0;if((g|0)==(t|0))E=D;else{C=t-h|0;A=g;B=D;while(1){a[B>>0]=a[A>>0]|0;A=A+1|0;if((A|0)==(t|0))break;else B=B+1|0}E=D+C|0}a[E>>0]=0;if(!(a[s>>0]&1)){a[s>>0]=j<<1;w=1;i=e;return w|0}else{c[k+16>>2]=j;w=1;i=e;return w|0}}j=r-h|0;h=a[k>>0]|0;if(!(h&1)){F=10;G=h}else{h=c[k>>2]|0;F=(h&-2)+-1|0;G=h&255}if(j>>>0>F>>>0){if(!(G&1))H=(G&255)>>>1;else H=c[k+4>>2]|0;Iri(k,F,j-F|0,H,0,H,0);I=a[k>>0]|0}else I=G;if(!(I&1))J=k+1|0;else J=c[k+8>>2]|0;if((g|0)==(r|0))K=J;else{I=g;g=J;while(1){a[g>>0]=a[I>>0]|0;I=I+1|0;J=g+1|0;if((I|0)==(r|0)){K=J;break}else g=J}}a[K>>0]=0;if(!(a[k>>0]&1))a[k>>0]=j<<1;else c[k+4>>2]=j;j=c[b>>2]|0;b=j+12|0;k=r+1|0;K=c[f>>2]|0;f=K-k|0;g=a[b>>0]|0;if(!(g&1)){L=10;M=g}else{g=c[b>>2]|0;L=(g&-2)+-1|0;M=g&255}if(f>>>0>L>>>0){if(!(M&1))N=(M&255)>>>1;else N=c[j+16>>2]|0;Iri(b,L,f-L|0,N,0,N,0);O=a[b>>0]|0}else O=M;if(!(O&1))P=b+1|0;else P=c[j+20>>2]|0;if((k|0)==(K|0))Q=P;else{O=k;k=r;r=P;while(1){a[r>>0]=a[O>>0]|0;P=k+2|0;M=r+1|0;if((P|0)==(K|0)){Q=M;break}else{N=O;O=P;r=M;k=N}}}a[Q>>0]=0;if(!(a[b>>0]&1)){a[b>>0]=f<<1;w=1;i=e;return w|0}else{c[j+16>>2]=f;w=1;i=e;return w|0}return 0}function RM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+16|0;f=e;g=b+8|0;h=c[g>>2]|0;j=b+12|0;k=c[j>>2]|0;if(h>>>0>=k>>>0){l=1;i=e;return l|0}m=f+1|0;n=f+8|0;o=f+4|0;p=k;k=h;while(1){if((a[k>>0]|0)!=43){l=1;q=29;break}h=k+1|0;c[g>>2]=h;if(h>>>0<p>>>0){r=h;s=k}else{l=0;q=29;break}a:while(1){switch(a[r>>0]|0){case 96:case 34:case 61:case 46:case 93:case 91:case 42:case 38:case 43:case 44:{t=r;break a;break}case 92:{u=s+2|0;c[g>>2]=u;v=u;break}default:v=r}u=v+1|0;c[g>>2]=u;if(u>>>0<p>>>0){r=u;s=v}else{t=u;break}}if(t>>>0<p>>>0?(a[t>>0]|0)==96:0){u=t+1|0;c[g>>2]=u;if(u>>>0>=p>>>0){l=0;q=29;break}if(((a[u>>0]|0)+-48|0)>>>0<10){w=t;x=u}else{l=0;q=29;break}while(1){y=w+2|0;c[g>>2]=y;if(y>>>0>=p>>>0)break;if(((a[y>>0]|0)+-48|0)>>>0<10){z=x;x=y;w=z}else break}z=DEi(u,0,10)|0;c[d>>2]=(c[d>>2]|0)+z;A=c[g>>2]|0}else A=t;z=c[b>>2]|0;y=z+136|0;B=A-h|0;if(B>>>0>4294967279){q=16;break}if(B>>>0<11){a[f>>0]=B<<1;C=m}else{D=B+16&-16;E=xCi(D)|0;c[n>>2]=E;c[f>>2]=D|1;c[o>>2]=B;C=E}if((h|0)==(A|0))F=C;else{E=h;D=k;G=C;while(1){a[G>>0]=a[E>>0]|0;H=D+2|0;if((H|0)==(A|0))break;else{I=E;E=H;G=G+1|0;D=I}}F=C+B|0}a[F>>0]=0;D=z+140|0;G=c[D>>2]|0;if((G|0)==(c[z+144>>2]|0))nO(y,f);else{if(!G)J=0;else{sri(G,f);J=c[D>>2]|0}c[D>>2]=J+12}xri(f);k=c[g>>2]|0;p=c[j>>2]|0;if(k>>>0>=p>>>0){l=1;q=29;break}}if((q|0)==16)ori(f);else if((q|0)==29){i=e;return l|0}return 0}function SM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+176|0;f=e+16|0;g=e;h=b+8|0;j=b+12|0;k=c[h>>2]|0;l=c[j>>2]|0;a:do if(k>>>0<l>>>0){m=k;while(1){n=a[m>>0]|0;if(!(n<<24>>24==9|n<<24>>24==32)){o=m;break a}n=m+1|0;c[h>>2]=n;if(n>>>0<l>>>0)m=n;else{o=n;break}}}else o=k;while(0);if(o>>>0>=l>>>0){p=1;i=e;return p|0}if((a[o>>0]|0)!=91){p=1;i=e;return p|0}k=a[o+1>>0]|0;if(k<<24>>24==9|k<<24>>24==32)q=2;else q=1;k=o+q|0;if(k>>>0<l>>>0?(a[k>>0]|0)==93:0){p=1;i=e;return p|0}k=a[o+1>>0]|0;if(k<<24>>24==9|k<<24>>24==32)r=2;else r=1;k=o+r|0;if(k>>>0<l>>>0?(a[k>>0]|0)==44:0){p=1;i=e;return p|0}k=o+1|0;r=a[k>>0]|0;if(r<<24>>24==9|r<<24>>24==32)s=2;else s=1;r=o+s|0;if(r>>>0<l>>>0?(a[r>>0]|0)==42:0){p=1;i=e;return p|0}c[h>>2]=k;b:do if(k>>>0<l>>>0){r=k;s=o;while(1){q=a[r>>0]|0;if(!(q<<24>>24==9|q<<24>>24==32)){t=r;break b}q=s+2|0;c[h>>2]=q;if(q>>>0<l>>>0){m=r;r=q;s=m}else{t=q;break}}}else t=k;while(0);if(t>>>0>=l>>>0){p=0;i=e;return p|0}LO((c[b>>2]|0)+124|0,c[d>>2]|0);d=f+92|0;l=g+4|0;t=g+5|0;k=g+8|0;o=g+12|0;while(1){s=c[h>>2]|0;r=c[j>>2]|0;if(s>>>0<r>>>0?(a[s>>0]|0)==91:0){q=s+1|0;c[h>>2]=q;c:do if(q>>>0<r>>>0){m=q;n=s;while(1){u=a[m>>0]|0;if(!(u<<24>>24==9|u<<24>>24==32)){v=m;break c}u=n+2|0;c[h>>2]=u;if(u>>>0<r>>>0){w=m;m=u;n=w}else{v=u;break}}}else v=q;while(0);if(v>>>0<r>>>0){x=v;y=1}else{p=0;z=56;break}}else{x=s;y=0}q=f+0|0;n=q+88|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(n|0));a[f+88>>0]=0;q=d+0|0;n=q+56|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(n|0));c[g>>2]=f;a[l>>0]=1;a[t>>0]=1;c[k>>2]=x;c[o>>2]=r;if(!(PM(g,y)|0)){z=52;break}c[h>>2]=c[k>>2];q=c[b>>2]|0;n=q+128|0;s=c[n>>2]|0;if((s|0)==(c[q+132>>2]|0))NO(q+124|0,f);else{if(!s)A=0;else{MO(s,f);A=c[n>>2]|0}c[n>>2]=A+148}n=c[h>>2]|0;s=c[j>>2]|0;d:do if(n>>>0<s>>>0){q=n;while(1){m=a[q>>0]|0;if(!(m<<24>>24==9|m<<24>>24==32)){B=q;break d}m=q+1|0;c[h>>2]=m;if(m>>>0<s>>>0)q=m;else{B=m;break}}}else B=n;while(0);if(B>>>0>=s>>>0){z=52;break}if(y){if((a[B>>0]|0)!=93){z=52;break}n=B+1|0;c[h>>2]=n;e:do if(n>>>0<s>>>0){r=n;q=B;while(1){m=a[r>>0]|0;if(!(m<<24>>24==9|m<<24>>24==32)){C=r;break e}m=q+2|0;c[h>>2]=m;if(m>>>0<s>>>0){u=r;r=m;q=u}else{C=m;break}}}else C=n;while(0);if(C>>>0<s>>>0)D=C;else{z=52;break}}else D=B;if(D>>>0>=s>>>0){z=52;break}if((a[D>>0]|0)==93){z=47;break}if((a[D>>0]|0)!=44){z=52;break}n=D+1|0;c[h>>2]=n;f:do if(n>>>0<s>>>0){q=n;r=D;while(1){m=a[q>>0]|0;if(!(m<<24>>24==9|m<<24>>24==32)){E=q;break f}m=r+2|0;c[h>>2]=m;if(m>>>0<s>>>0){u=q;q=m;r=u}else{E=m;break}}}else E=n;while(0);ZM(f);if(E>>>0>=s>>>0){p=0;z=56;break}}if((z|0)==47){ZM(f);E=c[h>>2]|0;D=E+1|0;c[h>>2]=D;B=c[j>>2]|0;if(D>>>0<B>>>0){F=D;G=E}else{p=1;i=e;return p|0}while(1){E=a[F>>0]|0;if(!(E<<24>>24==9|E<<24>>24==32)){p=1;z=56;break}E=G+2|0;c[h>>2]=E;if(E>>>0<B>>>0){D=F;F=E;G=D}else{p=1;z=56;break}}if((z|0)==56){i=e;return p|0}}else if((z|0)==52){ZM(f);p=0;i=e;return p|0}else if((z|0)==56){i=e;return p|0}return 0}function TM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+8|0;h=b+12|0;j=c[g>>2]|0;k=c[h>>2]|0;a:do if(j>>>0<k>>>0){l=j;while(1){m=a[l>>0]|0;if(!(m<<24>>24==9|m<<24>>24==32)){n=l;break a}m=l+1|0;c[g>>2]=m;if(m>>>0<k>>>0)l=m;else{n=m;break}}}else n=j;while(0);if(n>>>0>=k>>>0){o=1;i=d;return o|0}if((a[n>>0]|0)!=91){o=1;i=d;return o|0}j=a[n+1>>0]|0;if(j<<24>>24==9|j<<24>>24==32)p=2;else p=1;j=n+p|0;if(!(j>>>0<k>>>0?(a[j>>0]|0)==93:0))q=10;do if((q|0)==10){j=a[n+1>>0]|0;if(j<<24>>24==9|j<<24>>24==32)r=2;else r=1;j=n+r|0;if(j>>>0<k>>>0?(a[j>>0]|0)==44:0)break;j=a[n+1>>0]|0;if(j<<24>>24==9|j<<24>>24==32)s=2;else s=1;j=n+s|0;if(j>>>0>=k>>>0){o=1;i=d;return o|0}if((a[j>>0]|0)!=42){o=1;i=d;return o|0}}while(0);s=n+1|0;c[g>>2]=s;b:do if(s>>>0<k>>>0){r=s;j=n;while(1){p=a[r>>0]|0;if(!(p<<24>>24==9|p<<24>>24==32)){t=r;break b}p=j+2|0;c[g>>2]=p;if(p>>>0<k>>>0){l=r;r=p;j=l}else{t=p;break}}}else t=s;while(0);if(t>>>0>=k>>>0){o=0;i=d;return o|0}c[e>>2]=1;s=1;n=k;k=t;c:while(1){t=k;j=n;while(1){if(t>>>0>=j>>>0){o=0;q=50;break c}if((a[t>>0]|0)==93){u=j;v=t;w=s;q=26;break c}if((a[t>>0]|0)==44){x=j;y=t;break}if((a[t>>0]|0)!=42){o=0;q=50;break c}r=c[b>>2]|0;c[f>>2]=-2;p=r+116|0;l=c[p>>2]|0;if((l|0)==(c[r+120>>2]|0)){JO(r+112|0,f);z=c[h>>2]|0;A=c[g>>2]|0}else{if(l)c[l>>2]=-2;c[p>>2]=l+4;z=j;A=t}l=A+1|0;c[g>>2]=l;d:do if(l>>>0<z>>>0){p=l;r=A;while(1){m=a[p>>0]|0;if(!(m<<24>>24==9|m<<24>>24==32)){B=p;break d}m=r+2|0;c[g>>2]=m;if(m>>>0<z>>>0){C=p;p=m;r=C}else{B=m;break}}}else B=l;while(0);if(B>>>0<z>>>0){t=B;j=z}else{o=0;q=50;break c}}j=s+1|0;c[e>>2]=j;t=y+1|0;c[g>>2]=t;e:do if(t>>>0<x>>>0){l=t;r=y;while(1){p=a[l>>0]|0;if(!(p<<24>>24==9|p<<24>>24==32)){D=l;break e}p=r+2|0;c[g>>2]=p;if(p>>>0<x>>>0){m=l;l=p;r=m}else{D=p;break}}}else D=t;while(0);if(D>>>0<x>>>0){s=j;n=x;k=D}else{o=0;q=50;break}}if((q|0)==26){D=v+1|0;c[g>>2]=D;f:do if(D>>>0<u>>>0){k=D;x=v;while(1){n=a[k>>0]|0;if(!(n<<24>>24==9|n<<24>>24==32))break f;n=x+2|0;c[g>>2]=n;if(n>>>0<u>>>0){s=k;k=n;x=s}else break}}while(0);u=c[b>>2]|0;g=u+116|0;v=c[g>>2]|0;if((v|0)==(c[u+120>>2]|0))JO(u+112|0,e);else{if(v)c[v>>2]=w;c[g>>2]=v+4}o=TM(b)|0;i=d;return o|0}else if((q|0)==50){i=d;return o|0}return 0}function UM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+8|0;f=c[e>>2]|0;g=c[b+12>>2]|0;a:do if(f>>>0<g>>>0){h=f;while(1){j=a[h>>0]|0;if(!(j<<24>>24==9|j<<24>>24==32)){k=h;break a}j=h+1|0;c[e>>2]=j;if(j>>>0<g>>>0)h=j;else{k=j;break}}}else k=f;while(0);if(k>>>0>=g>>>0){l=0;i=d;return l|0}VM(b)|0;l=1;i=d;return l|0}function VM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+8|0;f=c[e>>2]|0;g=f;h=b+12|0;j=f;a:while(1){switch(a[j>>0]|0){case 92:{k=j+1|0;c[e>>2]=k;l=k;break}case 96:case 34:case 61:case 93:case 91:case 42:case 38:case 43:case 44:{m=j;break a;break}default:l=j}k=l+1|0;c[e>>2]=k;if(k>>>0<(c[h>>2]|0)>>>0)j=k;else{m=k;break}}j=c[b>>2]|0;l=j+24|0;k=m-g|0;n=a[l>>0]|0;if(!(n&1)){o=10;p=n}else{n=c[l>>2]|0;o=(n&-2)+-1|0;p=n&255}if(k>>>0>o>>>0){if(!(p&1))q=(p&255)>>>1;else q=c[j+28>>2]|0;Iri(l,o,k-o|0,q,0,q,0);r=a[l>>0]|0}else r=p;if(!(r&1))s=l+1|0;else s=c[j+32>>2]|0;if((f|0)==(m|0))t=s;else{r=m+(0-g)|0;g=f;f=s;while(1){a[f>>0]=a[g>>0]|0;g=g+1|0;if((g|0)==(m|0))break;else f=f+1|0}t=s+r|0}a[t>>0]=0;if(!(a[l>>0]&1))a[l>>0]=k<<1;else c[j+28>>2]=k;k=c[e>>2]|0;j=c[h>>2]|0;if(k>>>0<j>>>0)u=k;else{WM(b)|0;i=d;return 1}while(1){k=a[u>>0]|0;if(!(k<<24>>24==9|k<<24>>24==32)){v=25;break}u=u+1|0;c[e>>2]=u;if(u>>>0>=j>>>0){v=25;break}}if((v|0)==25){WM(b)|0;i=d;return 1}return 0}function WM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;i=i+32|0;e=d+12|0;f=d;g=b+8|0;h=b+12|0;j=e+1|0;k=f+1|0;l=f+8|0;m=f+4|0;n=e+8|0;o=e+4|0;while(1){p=c[g>>2]|0;q=c[h>>2]|0;if(p>>>0>=q>>>0){r=1;s=48;break}if((a[p>>0]|0)!=44){r=1;s=48;break}t=p+1|0;c[g>>2]=t;a:do if(t>>>0<q>>>0){u=t;v=p;while(1){w=a[u>>0]|0;if(!(w<<24>>24==9|w<<24>>24==32)){x=u;break a}w=v+2|0;c[g>>2]=w;if(w>>>0<q>>>0){y=u;u=w;v=y}else{x=w;break}}}else x=t;while(0);if(x>>>0<q>>>0)z=x;else{r=0;s=48;break}while(1){if((a[z>>0]|0)==61){A=z;break}t=z+1|0;c[g>>2]=t;if(t>>>0<q>>>0)z=t;else{A=t;break}}q=A-x|0;if(q>>>0>4294967279){s=11;break}if(q>>>0<11){a[e>>0]=q<<1;B=j}else{t=q+16&-16;p=xCi(t)|0;c[n>>2]=p;c[e>>2]=t|1;c[o>>2]=q;B=p}if((x|0)==(A|0))C=B;else{p=x;t=B;while(1){a[t>>0]=a[p>>0]|0;p=p+1|0;if((p|0)==(A|0))break;else t=t+1|0}C=B+q|0}a[C>>0]=0;t=c[g>>2]|0;p=c[h>>2]|0;if(t>>>0>=p>>>0){s=47;break}if((a[t>>0]|0)!=61){s=47;break}v=t+1|0;c[g>>2]=v;if(v>>>0<p>>>0){D=v;E=t}else{s=47;break}while(1){if((a[D>>0]|0)==44){F=D;break}u=E+2|0;c[g>>2]=u;if(u>>>0<p>>>0){w=D;D=u;E=w}else{F=u;break}}p=F-v|0;if(p>>>0>4294967279){s=24;break}if(p>>>0<11){a[f>>0]=p<<1;G=k}else{q=p+16&-16;u=xCi(q)|0;c[l>>2]=u;c[f>>2]=q|1;c[m>>2]=p;G=u}if((v|0)==(F|0))H=G;else{u=v;q=t;w=G;while(1){a[w>>0]=a[u>>0]|0;y=q+2|0;if((y|0)==(F|0))break;else{I=u;u=y;w=w+1|0;q=I}}H=G+p|0}a[H>>0]=0;do if(!(Ori(e,3131024)|0)){q=c[b>>2]|0;if(XM(f,q+104|0,q+106|0,q+108|0,q+110|0)|0)s=45;else J=1}else{if(!(Ori(e,2848232)|0)){if(!(Ori(f,603880)|0)){s=45;break}yri((c[b>>2]|0)+60|0,f)|0;s=45;break}if(Ori(e,2805096)|0){if(Ori(e,406464)|0){J=1;break}yri((c[b>>2]|0)+36|0,f)|0;s=45;break}if(!(Ori(f,603880)|0))s=45;else{q=a[f>>0]|0;w=(q&1)==0;if(w)K=(q&255)>>>1;else K=c[m>>2]|0;if((K|0)!=16){J=1;break}UEi((c[b>>2]|0)+72|0,(w?k:c[l>>2]|0)|0,17)|0;s=45}}while(0);if((s|0)==45){s=0;J=0}xri(f);xri(e);if((J|0)==1){r=0;s=48;break}}if((s|0)==11)ori(e);else if((s|0)==24)ori(f);else if((s|0)==47){xri(e);r=0;i=d;return r|0}else if((s|0)==48){i=d;return r|0}return 0}function XM(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j+36|0;l=j+24|0;m=j+12|0;n=j;o=Kri(d,46,0)|0;if((o|0)==-1){p=0;i=j;return p|0}vri(k,d,0,o,d);if(!(a[k>>0]&1))q=k+1|0;else q=c[k+8>>2]|0;b[e>>1]=wEi(q)|0;q=o+1|0;o=Kri(d,46,q)|0;if((o|0)!=-1){vri(l,d,q,o-q|0,d);yri(k,l)|0;xri(l);if(!(a[k>>0]&1))r=k+1|0;else r=c[k+8>>2]|0;b[f>>1]=wEi(r)|0;r=o+1|0;o=Kri(d,46,r)|0;if((o|0)!=-1){vri(m,d,r,o-r|0,d);yri(k,m)|0;xri(m);if(!(a[k>>0]&1))s=k+1|0;else s=c[k+8>>2]|0;b[g>>1]=wEi(s)|0;s=o+1|0;o=a[d>>0]|0;if(!(o&1))t=(o&255)>>>1;else t=c[d+4>>2]|0;vri(n,d,s,t-s|0,d);yri(k,n)|0;xri(n);if(!(a[k>>0]&1))u=k+1|0;else u=c[k+8>>2]|0;b[h>>1]=wEi(u)|0;v=1}else v=0}else v=0;xri(k);p=v;i=j;return p|0}function YM(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+92|0;f=b+0|0;g=f+88|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));a[b+88>>0]=0;f=e+0|0;g=f+56|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));i=d;return}function ZM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a+124|0;e=c[d>>2]|0;f=a+128|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-148|0;c[f>>2]=h;ZM(h)}e=a+112|0;h=c[e>>2]|0;g=a+116|0;j=c[g>>2]|0;if((j|0)!=(h|0))c[g>>2]=j+(~((j+-4-h|0)>>>2)<<2);h=a+136|0;j=c[h>>2]|0;k=a+140|0;while(1){l=c[k>>2]|0;if((l|0)==(j|0))break;m=l+-12|0;c[k>>2]=m;xri(m)}m=c[h>>2]|0;if(m){l=j;while(1){if((l|0)==(m|0))break;j=l+-12|0;c[k>>2]=j;xri(j);l=c[k>>2]|0}ACi(c[h>>2]|0)}h=c[d>>2]|0;if(h){while(1){k=c[f>>2]|0;if((k|0)==(h|0))break;l=k+-148|0;c[f>>2]=l;ZM(l)}ACi(c[d>>2]|0)}d=c[e>>2]|0;if(!d){n=a+24|0;OO(n);o=a+12|0;xri(o);xri(a);i=b;return}e=c[g>>2]|0;if((e|0)!=(d|0))c[g>>2]=e+(~((e+-4-d|0)>>>2)<<2);ACi(d);n=a+24|0;OO(n);o=a+12|0;xri(o);xri(a);i=b;return}function _M(a){a=a|0;return (c[a+4>>2]|0)>>>16&255|0}function $M(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+64|0;j=h+60|0;k=h+48|0;l=h+36|0;m=h+24|0;n=h+12|0;o=h;p=e+4|0;q=c[p>>2]|0;switch(q>>>16&255|0){case 29:{r=(f|0)==3;$M(b,c[(c[e>>2]|0)+64>>2]|0,r?2:f,0);uN(b,406472,2)|0;if(c[p>>2]&1073741824){a[j>>0]=38;uN(b,j,1)|0}if(!r){i=h;return}r=c[(c[c[e>>2]>>2]|0)+24>>2]|0;s=uN(b,1081768,2)|0;FI(l,r);r=a[l>>0]|0;if(!(r&1)){t=l+1|0;u=(r&255)>>>1}else{t=c[l+8>>2]|0;u=c[l+4>>2]|0}uN(s,t,u)|0;xri(l);i=h;return}case 20:{l=(f|0)==3;$M(b,c[(c[c[e>>2]>>2]|0)+64>>2]|0,l?2:f,0);a[j>>0]=91;uN(b,j,1)|0;u=a[(c[e>>2]|0)+4>>0]|0;if(u<<24>>24==1){a[j>>0]=42;uN(b,j,1)|0;v=a[(c[e>>2]|0)+4>>0]|0}else v=u;if((v&255)>1){v=1;do{a[j>>0]=44;uN(b,j,1)|0;v=v+1|0}while((v|0)<(d[(c[e>>2]|0)+4>>0]|0))}a[j>>0]=93;uN(b,j,1)|0;if(c[p>>2]&1073741824){a[j>>0]=38;uN(b,j,1)|0}if(!l){i=h;return}l=c[(c[c[c[e>>2]>>2]>>2]|0)+24>>2]|0;v=uN(b,1081768,2)|0;FI(k,l);l=a[k>>0]|0;if(!(l&1)){w=k+1|0;x=(l&255)>>>1}else{w=c[k+8>>2]|0;x=c[k+4>>2]|0}uN(v,w,x)|0;xri(k);i=h;return}case 15:{k=(f|0)==3;$M(b,c[e>>2]|0,k?2:f,0);a[j>>0]=42;uN(b,j,1)|0;if(c[p>>2]&1073741824){a[j>>0]=38;uN(b,j,1)|0}if(!k){i=h;return}k=c[(c[(GI(c[e>>2]|0)|0)>>2]|0)+24>>2]|0;x=uN(b,1081768,2)|0;FI(m,k);k=a[m>>0]|0;if(!(k&1)){y=m+1|0;z=(k&255)>>>1}else{y=c[m+8>>2]|0;z=c[m+4>>2]|0}uN(x,y,z)|0;xri(m);i=h;return}case 30:case 19:{if(!(q&1073741824)){i=h;return}a[j>>0]=38;uN(b,j,1)|0;i=h;return}default:{q=GI(e)|0;e=c[q+40>>2]|0;if(!e){m=c[q+12>>2]|0;if(a[m>>0]|0){z=uN(b,m,SEi(m|0)|0)|0;a[j>>0]=46;uN(z,j,1)|0}}else{$M(b,c[e+64>>2]|0,f,1);a[j>>0]=(f|0)==0?46:43;uN(b,j,1)|0}e=(f|0)==0;if(e){z=c[q+8>>2]|0;m=hCi(z,96)|0;if(!m)rri(n,z,SEi(z|0)|0);else{y=m-z|0;if(y>>>0>4294967279)ori(n);if(y>>>0<11){a[n>>0]=y<<1;A=n+1|0}else{x=y+16&-16;k=xCi(x)|0;c[n+8>>2]=k;c[n>>2]=x|1;c[n+4>>2]=y;A=k}if((z|0)==(m|0))B=A;else{k=z;z=A;while(1){a[z>>0]=a[k>>0]|0;k=k+1|0;if((k|0)==(m|0))break;else z=z+1|0}B=A+y|0}a[B>>0]=0}B=a[n>>0]|0;if(!(B&1)){C=n+1|0;D=(B&255)>>>1}else{C=c[n+8>>2]|0;D=c[n+4>>2]|0}uN(b,C,D)|0;xri(n)}else{n=c[q+8>>2]|0;uN(b,n,SEi(n|0)|0)|0}if(g){i=h;return}g=c[q+80>>2]|0;if(!g){n=q+84|0;if((c[n>>2]|0)!=0&(f|0)!=2&(f|0)!=3){a[j>>0]=e?60:91;uN(b,j,1)|0;D=c[n>>2]|0;if(c[D+16>>2]&2147483647){C=D;D=0;do{if(!D)E=C;else{a[j>>0]=44;uN(b,j,1)|0;E=c[n>>2]|0}B=c[(c[c[E+20>>2]>>2]|0)+(D*28|0)+12>>2]|0;uN(b,B,SEi(B|0)|0)|0;D=D+1|0;C=c[n>>2]|0}while((D|0)<(c[C+16>>2]&2147483647|0))}a[j>>0]=e?62:93;uN(b,j,1)|0}}else{C=c[g+4>>2]|0;g=(f|0)==2?3:f;a[j>>0]=e?60:91;uN(b,j,1)|0;a:do if(c[C>>2]|0){D=C+4|0;if((g|0)==3)F=0;else{n=0;while(1){if(n){a[j>>0]=44;uN(b,j,1)|0}$M(b,c[(c[D>>2]|0)+(n<<2)>>2]|0,g,0);n=n+1|0;if(n>>>0>=(c[C>>2]|0)>>>0)break a}}do{n=c[(c[D>>2]|0)+(F<<2)>>2]|0;if(F){a[j>>0]=44;uN(b,j,1)|0}E=n+4|0;if((c[E>>2]&16711680|0)!=1245184?(c[p>>2]&16711680|0)!=1966080:0){a[j>>0]=91;uN(b,j,1)|0}$M(b,c[(c[D>>2]|0)+(F<<2)>>2]|0,3,0);if((c[E>>2]&16711680|0)!=1245184?(c[p>>2]&16711680|0)!=1966080:0){a[j>>0]=93;uN(b,j,1)|0}F=F+1|0}while(F>>>0<(c[C>>2]|0)>>>0)}while(0);a[j>>0]=e?62:93;uN(b,j,1)|0}if(c[p>>2]&1073741824){a[j>>0]=38;uN(b,j,1)|0}if((f|0)!=3){i=h;return}f=(c[p>>2]|0)>>>16&255;if((f|0)==30|(f|0)==19){i=h;return}f=c[(c[q>>2]|0)+24>>2]|0;q=uN(b,1081768,2)|0;FI(o,f);f=a[o>>0]|0;if(!(f&1)){G=o+1|0;H=(f&255)>>>1}else{G=c[o+8>>2]|0;H=c[o+4>>2]|0}uN(q,G,H)|0;xri(o);i=h;return}}}function aN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+160|0;f=e+136|0;g=e;h=g+4|0;c[g>>2]=406548;c[g+56>>2]=406568;esi(g+56|0,h);c[g+128>>2]=0;c[g+132>>2]=-1;c[g>>2]=406492;c[g+56>>2]=406512;jsi(h);c[h>>2]=74048;j=g+36|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[g+52>>2]=16;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yN(h,f);xri(f);$M(g,b,d,0);zN(a,h);PO(g);i=e;return}function bN(a){a=a|0;var b=0;if((c[a+4>>2]&16711680|0)==1310720)b=c[a>>2]|0;else b=a;return c[b>>2]|0}function cN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b+4>>2]|0;f=e&16711680;if((f|0)==1376256){g=c[c[b>>2]>>2]|0;if((a[g+149>>0]|0)!=0&(e&1073741824|0)==0)h=NI(g)|0;else h=b}else if((f|0)==1114112?(f=c[b>>2]|0,(a[f+149>>0]|0)!=0&(e&1073741824|0)==0):0)h=NI(f)|0;else h=b;i=d;return h|0}function dN(a){a=a|0;var b=0,d=0;b=i;a:do if(!a)d=0;else{switch((c[a+4>>2]|0)>>>16&255|0){case 21:{if(!(nK(c[a>>2]|0)|0)){d=1;break a}break}case 20:case 28:case 18:case 29:case 14:{d=1;break a;break}default:{}}d=0}while(0);i=b;return d|0}function eN(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+4>>2]|0;do if(!(e&1073741824)){if((e&16711680|0)==1114112?(a[(c[b>>2]|0)+149>>0]|0)==0:0){f=1;break}g=e>>>16&255;if((g|0)==22){f=1;break}else if(((g|0)==21?nK(c[b>>2]|0)|0:0)?(a[(c[c[b>>2]>>2]|0)+149>>0]|0)==0:0){f=1;break}f=0}else f=0;while(0);i=d;return f|0}function fN(b){b=b|0;return (a[(c[c[b>>2]>>2]|0)+145>>0]|0)!=0|0}function gN(a){a=a|0;return c[a>>2]|0}function hN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if(e)c[a+20>>2]=e;g=406080;h=_Ei(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;g=406080;c[g>>2]=h;c[g+4>>2]=H;c[a+8>>2]=d;if(b)c[a+16>>2]=b;c[a+12>>2]=c[e+16>>2];i=f;return}function iN(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;f=a>>>16;g=a&65535;if((c|0)==1){a=(d[b>>0]|0)+g|0;h=a>>>0>65520?a+-65521|0:a;a=h+f|0;j=(a>>>0>65520?a+15|0:a)<<16|h;i=e;return j|0}if(!b){j=1;i=e;return j|0}if(c>>>0<16){if(!c){k=g;l=f}else{h=b;a=c;m=g;n=f;while(1){a=a+-1|0;o=(d[h>>0]|0)+m|0;p=o+n|0;if(!a){k=o;l=p;break}else{h=h+1|0;m=o;n=p}}}j=((l>>>0)%65521|0)<<16|(k>>>0>65520?k+-65521|0:k);i=e;return j|0}if(c>>>0>5551){k=c+-5552|0;l=(k>>>0)%5552|0;n=b+(k-l+5552)|0;k=b;m=c;h=g;a=f;while(1){m=m+-5552|0;p=k;o=h;q=347;r=a;while(1){s=(d[p>>0]|0)+o|0;t=s+(d[p+1>>0]|0)|0;u=t+(d[p+2>>0]|0)|0;v=u+(d[p+3>>0]|0)|0;w=v+(d[p+4>>0]|0)|0;x=w+(d[p+5>>0]|0)|0;y=x+(d[p+6>>0]|0)|0;z=y+(d[p+7>>0]|0)|0;A=z+(d[p+8>>0]|0)|0;B=A+(d[p+9>>0]|0)|0;C=B+(d[p+10>>0]|0)|0;D=C+(d[p+11>>0]|0)|0;E=D+(d[p+12>>0]|0)|0;F=E+(d[p+13>>0]|0)|0;G=F+(d[p+14>>0]|0)|0;H=G+(d[p+15>>0]|0)|0;I=s+r+t+u+v+w+x+y+z+A+B+C+D+E+F+G+H|0;q=q+-1|0;if(!q){J=H;K=I;break}else{p=p+16|0;o=H;r=I}}r=(J>>>0)%65521|0;o=(K>>>0)%65521|0;if(m>>>0<=5551){L=r;M=o;break}else{k=k+5552|0;h=r;a=o}}if(l)if(l>>>0>15){N=l;O=n;P=L;Q=M;R=15}else{S=l;T=n;U=L;V=M;R=18}else{W=L;X=M}}else{N=c;O=b;P=g;Q=f;R=15}if((R|0)==15){f=N+-16|0;g=f&-16;b=O+(g+16)|0;c=N;N=O;O=P;P=Q;while(1){c=c+-16|0;Q=(d[N>>0]|0)+O|0;M=Q+(d[N+1>>0]|0)|0;L=M+(d[N+2>>0]|0)|0;n=L+(d[N+3>>0]|0)|0;l=n+(d[N+4>>0]|0)|0;a=l+(d[N+5>>0]|0)|0;h=a+(d[N+6>>0]|0)|0;k=h+(d[N+7>>0]|0)|0;m=k+(d[N+8>>0]|0)|0;K=m+(d[N+9>>0]|0)|0;J=K+(d[N+10>>0]|0)|0;o=J+(d[N+11>>0]|0)|0;r=o+(d[N+12>>0]|0)|0;p=r+(d[N+13>>0]|0)|0;q=p+(d[N+14>>0]|0)|0;I=q+(d[N+15>>0]|0)|0;H=Q+P+M+L+n+l+a+h+k+m+K+J+o+r+p+q+I|0;if(c>>>0<=15){Y=I;Z=H;break}else{N=N+16|0;O=I;P=H}}if((f|0)==(g|0)){_=Y;$=Z;R=19}else{S=f-g|0;T=b;U=Y;V=Z;R=18}}if((R|0)==18)while(1){R=0;S=S+-1|0;Z=(d[T>>0]|0)+U|0;Y=Z+V|0;if(!S){_=Z;$=Y;R=19;break}else{T=T+1|0;U=Z;V=Y;R=18}}if((R|0)==19){W=(_>>>0)%65521|0;X=($>>>0)%65521|0}j=X<<16|W;i=e;return j|0}function jN(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;if(!b){g=0;i=f;return g|0}h=~a;a:do if(e){a=b;j=e;k=h;while(1){if(!(a&3)){l=a;m=j;n=k;break}o=c[406576+(((d[a>>0]|0)^k&255)<<2)>>2]^k>>>8;j=j+-1|0;if(!j){p=o;break a}else{a=a+1|0;k=o}}if(m>>>0>31){k=m+-32|0;a=k&-32;j=a+32|0;o=m;q=l;r=n;while(1){s=c[q>>2]^r;t=c[408624+((s>>>8&255)<<2)>>2]^c[409648+((s&255)<<2)>>2]^c[407600+((s>>>16&255)<<2)>>2]^c[406576+(s>>>24<<2)>>2]^c[q+4>>2];s=c[408624+((t>>>8&255)<<2)>>2]^c[409648+((t&255)<<2)>>2]^c[407600+((t>>>16&255)<<2)>>2]^c[406576+(t>>>24<<2)>>2]^c[q+8>>2];t=c[408624+((s>>>8&255)<<2)>>2]^c[409648+((s&255)<<2)>>2]^c[407600+((s>>>16&255)<<2)>>2]^c[406576+(s>>>24<<2)>>2]^c[q+12>>2];s=c[408624+((t>>>8&255)<<2)>>2]^c[409648+((t&255)<<2)>>2]^c[407600+((t>>>16&255)<<2)>>2]^c[406576+(t>>>24<<2)>>2]^c[q+16>>2];t=c[408624+((s>>>8&255)<<2)>>2]^c[409648+((s&255)<<2)>>2]^c[407600+((s>>>16&255)<<2)>>2]^c[406576+(s>>>24<<2)>>2]^c[q+20>>2];s=c[408624+((t>>>8&255)<<2)>>2]^c[409648+((t&255)<<2)>>2]^c[407600+((t>>>16&255)<<2)>>2]^c[406576+(t>>>24<<2)>>2]^c[q+24>>2];t=c[408624+((s>>>8&255)<<2)>>2]^c[409648+((s&255)<<2)>>2]^c[407600+((s>>>16&255)<<2)>>2]^c[406576+(s>>>24<<2)>>2]^c[q+28>>2];s=c[408624+((t>>>8&255)<<2)>>2]^c[409648+((t&255)<<2)>>2]^c[407600+((t>>>16&255)<<2)>>2]^c[406576+(t>>>24<<2)>>2];o=o+-32|0;if(o>>>0<=31){u=s;break}else{q=q+32|0;r=s}}v=k-a|0;w=l+j|0;x=u}else{v=m;w=l;x=n}if(v>>>0>3){r=v+-4|0;q=r>>>2;o=q<<2;s=v;t=w;y=x;while(1){z=c[t>>2]^y;A=c[408624+((z>>>8&255)<<2)>>2]^c[409648+((z&255)<<2)>>2]^c[407600+((z>>>16&255)<<2)>>2]^c[406576+(z>>>24<<2)>>2];s=s+-4|0;if(s>>>0<=3){B=A;break}else{t=t+4|0;y=A}}C=r-o|0;D=w+(q+1<<2)|0;E=B}else{C=v;D=w;E=x}if(!C)p=E;else{y=D;t=C;s=E;while(1){j=c[406576+(((d[y>>0]|0)^s&255)<<2)>>2]^s>>>8;t=t+-1|0;if(!t){p=j;break}else{y=y+1|0;s=j}}}}else p=h;while(0);g=~p;i=f;return g|0}function kN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;l=i;if(!j){m=-6;i=l;return m|0}if((a[j>>0]|0)!=49|(k|0)!=56){m=-6;i=l;return m|0}if(!b){m=-2;i=l;return m|0}k=b+24|0;c[k>>2]=0;j=b+32|0;n=c[j>>2]|0;if(!n){c[j>>2]=1725;c[b+40>>2]=0;o=1725}else o=n;n=b+36|0;if(!(c[n>>2]|0))c[n>>2]=2598;p=(d|0)==-1?6:d;if((f|0)<0){q=0-f|0;r=0}else{d=(f|0)>15;q=d?f+-16|0:f;r=d?2:1}if((g+-1|0)>>>0>8|(e|0)!=8|(q|0)<8|(q|0)>15|(p|0)<0|(p|0)>9|(h|0)<0|(h|0)>4){m=-2;i=l;return m|0}e=(q|0)==8?9:q;q=b+40|0;d=xo[o&2047](c[q>>2]|0,1,5824)|0;if(!d){m=-4;i=l;return m|0}o=b+28|0;c[o>>2]=d;c[d>>2]=b;c[d+24>>2]=r;c[d+28>>2]=0;c[d+48>>2]=e;r=1<<e;e=d+44|0;c[e>>2]=r;c[d+52>>2]=r+-1;f=g+7|0;c[d+80>>2]=f;s=1<<f;f=d+76|0;c[f>>2]=s;c[d+84>>2]=s+-1;c[d+88>>2]=((g+9|0)>>>0)/3|0;s=d+56|0;c[s>>2]=xo[c[j>>2]&2047](c[q>>2]|0,r,2)|0;r=d+64|0;c[r>>2]=xo[c[j>>2]&2047](c[q>>2]|0,c[e>>2]|0,2)|0;e=d+68|0;c[e>>2]=xo[c[j>>2]&2047](c[q>>2]|0,c[f>>2]|0,2)|0;f=1<<g+6;g=d+5788|0;c[g>>2]=f;t=xo[c[j>>2]&2047](c[q>>2]|0,f,4)|0;c[d+8>>2]=t;f=c[g>>2]|0;c[d+12>>2]=f<<2;if(((c[s>>2]|0)!=0?(c[r>>2]|0)!=0:0)?!((c[e>>2]|0)==0|(t|0)==0):0){c[d+5796>>2]=t+(f>>>1<<1);c[d+5784>>2]=t+(f*3|0);c[d+132>>2]=p;c[d+136>>2]=h;a[d+36>>0]=8;m=mN(b)|0;i=l;return m|0}c[d+4>>2]=666;c[k>>2]=c[104432];k=c[o>>2]|0;if(!k){m=-4;i=l;return m|0}switch(c[k+4>>2]|0){case 42:case 69:case 73:case 91:case 103:case 113:case 666:break;default:{m=-4;i=l;return m|0}}d=c[k+8>>2]|0;if(!d)u=k;else{In[c[n>>2]&4095](c[q>>2]|0,d);u=c[o>>2]|0}d=c[u+68>>2]|0;if(!d)v=u;else{In[c[n>>2]&4095](c[q>>2]|0,d);v=c[o>>2]|0}d=c[v+64>>2]|0;if(!d)w=v;else{In[c[n>>2]&4095](c[q>>2]|0,d);w=c[o>>2]|0}d=c[w+56>>2]|0;if(!d)x=w;else{In[c[n>>2]&4095](c[q>>2]|0,d);x=c[o>>2]|0}In[c[n>>2]&4095](c[q>>2]|0,x);c[o>>2]=0;m=-4;i=l;return m|0}function lN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;if(!a){d=-2;i=b;return d|0}e=a+28|0;f=c[e>>2]|0;if(!f){d=-2;i=b;return d|0}g=c[f+4>>2]|0;switch(g|0){case 42:case 69:case 73:case 91:case 103:case 113:case 666:break;default:{d=-2;i=b;return d|0}}h=c[f+8>>2]|0;if(!h)j=f;else{In[c[a+36>>2]&4095](c[a+40>>2]|0,h);j=c[e>>2]|0}h=c[j+68>>2]|0;if(!h)k=j;else{In[c[a+36>>2]&4095](c[a+40>>2]|0,h);k=c[e>>2]|0}h=c[k+64>>2]|0;if(!h)l=k;else{In[c[a+36>>2]&4095](c[a+40>>2]|0,h);l=c[e>>2]|0}h=c[l+56>>2]|0;k=a+36|0;if(!h){m=a+40|0;n=l}else{l=a+40|0;In[c[k>>2]&4095](c[l>>2]|0,h);m=l;n=c[e>>2]|0}In[c[k>>2]&4095](c[m>>2]|0,n);c[e>>2]=0;d=(g|0)==113?-3:0;i=b;return d|0}function mN(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;if(!a){f=-2;i=d;return f|0}g=c[a+28>>2]|0;if(!g){f=-2;i=d;return f|0}if(!(c[a+32>>2]|0)){f=-2;i=d;return f|0}if(!(c[a+36>>2]|0)){f=-2;i=d;return f|0}c[a+20>>2]=0;c[a+8>>2]=0;c[a+24>>2]=0;c[a+44>>2]=2;c[g+20>>2]=0;c[g+16>>2]=c[g+8>>2];h=g+24|0;j=c[h>>2]|0;if((j|0)<0){k=0-j|0;c[h>>2]=k;l=k}else l=j;c[g+4>>2]=(l|0)!=0?42:113;if((l|0)==2)m=jN(0,0,0)|0;else m=iN(0,0,0)|0;c[a+48>>2]=m;c[g+40>>2]=0;oN(g);c[g+60>>2]=c[g+44>>2]<<1;m=c[g+76>>2]|0;a=c[g+68>>2]|0;b[a+(m+-1<<1)>>1]=0;PEi(a|0,0,(m<<1)+-2|0)|0;m=c[g+132>>2]|0;c[g+128>>2]=e[414770+(m*12|0)>>1];c[g+140>>2]=e[414768+(m*12|0)>>1];c[g+144>>2]=e[414772+(m*12|0)>>1];c[g+124>>2]=e[414774+(m*12|0)>>1];c[g+108>>2]=0;c[g+92>>2]=0;c[g+116>>2]=0;c[g+120>>2]=2;c[g+96>>2]=2;c[g+104>>2]=0;c[g+72>>2]=0;f=0;i=d;return f|0}function nN(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;f=i;if(!d){g=-2;i=f;return g|0}h=d+28|0;j=c[h>>2]|0;if((j|0)==0|(e|0)>4|(e|0)<0){g=-2;i=f;return g|0}k=d+12|0;do if(c[k>>2]|0){if((c[d>>2]|0)==0?(c[d+4>>2]|0)!=0:0)break;l=j+4|0;m=c[l>>2]|0;n=(e|0)!=4;if(!((m|0)==666&n)){o=d+16|0;if(!(c[o>>2]|0)){c[d+24>>2]=c[104433];g=-5;i=f;return g|0}c[j>>2]=d;p=j+40|0;q=c[p>>2]|0;c[p>>2]=e;do if((m|0)==42){if((c[j+24>>2]|0)!=2){r=(c[j+48>>2]<<12)+-30720|0;if((c[j+136>>2]|0)<=1?(s=c[j+132>>2]|0,(s|0)>=2):0)if((s|0)<6)t=64;else t=(s|0)==6?128:192;else t=0;s=t|r;r=j+108|0;u=(c[r>>2]|0)==0?s:s|32;c[l>>2]=113;s=j+20|0;v=c[s>>2]|0;c[s>>2]=v+1;w=j+8|0;a[(c[w>>2]|0)+v>>0]=u>>>8;v=c[s>>2]|0;c[s>>2]=v+1;a[(c[w>>2]|0)+v>>0]=(u|((u>>>0)%31|0))^31;u=d+48|0;if(c[r>>2]|0){r=c[u>>2]|0;v=c[s>>2]|0;c[s>>2]=v+1;a[(c[w>>2]|0)+v>>0]=r>>>24;v=c[s>>2]|0;c[s>>2]=v+1;a[(c[w>>2]|0)+v>>0]=r>>>16;r=c[u>>2]|0;v=c[s>>2]|0;c[s>>2]=v+1;a[(c[w>>2]|0)+v>>0]=r>>>8;v=c[s>>2]|0;c[s>>2]=v+1;a[(c[w>>2]|0)+v>>0]=r}c[u>>2]=iN(0,0,0)|0;x=c[l>>2]|0;y=32;break}u=d+48|0;c[u>>2]=jN(0,0,0)|0;r=j+20|0;v=c[r>>2]|0;c[r>>2]=v+1;w=j+8|0;a[(c[w>>2]|0)+v>>0]=31;v=c[r>>2]|0;c[r>>2]=v+1;a[(c[w>>2]|0)+v>>0]=-117;v=c[r>>2]|0;c[r>>2]=v+1;a[(c[w>>2]|0)+v>>0]=8;v=j+28|0;s=c[v>>2]|0;if(!s){z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=0;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=0;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=0;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=0;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=0;z=c[j+132>>2]|0;if((z|0)!=9)if((c[j+136>>2]|0)>1)A=4;else A=(z|0)<2?4:0;else A=2;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=A;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=3;c[l>>2]=113;break}z=(((c[s+44>>2]|0)!=0?2:0)|(c[s>>2]|0)!=0|((c[s+16>>2]|0)==0?0:4)|((c[s+28>>2]|0)==0?0:8)|((c[s+36>>2]|0)==0?0:16))&255;s=c[r>>2]|0;c[r>>2]=s+1;a[(c[w>>2]|0)+s>>0]=z;z=c[(c[v>>2]|0)+4>>2]&255;s=c[r>>2]|0;c[r>>2]=s+1;a[(c[w>>2]|0)+s>>0]=z;z=(c[(c[v>>2]|0)+4>>2]|0)>>>8&255;s=c[r>>2]|0;c[r>>2]=s+1;a[(c[w>>2]|0)+s>>0]=z;z=(c[(c[v>>2]|0)+4>>2]|0)>>>16&255;s=c[r>>2]|0;c[r>>2]=s+1;a[(c[w>>2]|0)+s>>0]=z;z=(c[(c[v>>2]|0)+4>>2]|0)>>>24&255;s=c[r>>2]|0;c[r>>2]=s+1;a[(c[w>>2]|0)+s>>0]=z;z=c[j+132>>2]|0;if((z|0)!=9)if((c[j+136>>2]|0)>1)B=4;else B=(z|0)<2?4:0;else B=2;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=B;z=c[(c[v>>2]|0)+12>>2]&255;s=c[r>>2]|0;c[r>>2]=s+1;a[(c[w>>2]|0)+s>>0]=z;z=c[v>>2]|0;if(!(c[z+16>>2]|0))C=z;else{s=c[z+20>>2]&255;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=s;s=(c[(c[v>>2]|0)+20>>2]|0)>>>8&255;z=c[r>>2]|0;c[r>>2]=z+1;a[(c[w>>2]|0)+z>>0]=s;C=c[v>>2]|0}if(c[C+44>>2]|0)c[u>>2]=jN(c[u>>2]|0,c[w>>2]|0,c[r>>2]|0)|0;c[j+32>>2]=0;c[l>>2]=69;D=v;y=34}else{x=m;y=32}while(0);if((y|0)==32)if((x|0)==69){D=j+28|0;y=34}else{E=x;y=55}do if((y|0)==34){m=c[D>>2]|0;if(!(c[m+16>>2]|0)){c[l>>2]=73;F=m;y=57;break}v=j+20|0;r=c[v>>2]|0;w=j+32|0;u=c[w>>2]|0;a:do if(u>>>0<(c[m+20>>2]&65535)>>>0){s=j+12|0;z=d+48|0;G=j+8|0;H=d+20|0;I=r;J=m;K=u;L=r;while(1){if((I|0)==(c[s>>2]|0)){if((c[J+44>>2]|0)!=0&I>>>0>L>>>0)c[z>>2]=jN(c[z>>2]|0,(c[G>>2]|0)+L|0,I-L|0)|0;M=c[h>>2]|0;N=c[M+20>>2]|0;O=c[o>>2]|0;P=N>>>0>O>>>0?O:N;if((P|0)!=0?(YEi(c[k>>2]|0,c[M+16>>2]|0,P|0)|0,c[k>>2]=(c[k>>2]|0)+P,M=c[h>>2]|0,N=M+16|0,c[N>>2]=(c[N>>2]|0)+P,c[H>>2]=(c[H>>2]|0)+P,c[o>>2]=(c[o>>2]|0)-P,O=M+20|0,Q=c[O>>2]|0,c[O>>2]=Q-P,(Q|0)==(P|0)):0)c[N>>2]=c[M+8>>2];M=c[v>>2]|0;if((M|0)==(c[s>>2]|0)){R=M;break}S=c[D>>2]|0;T=c[w>>2]|0;U=M;V=M}else{S=J;T=K;U=I;V=L}M=a[(c[S+16>>2]|0)+T>>0]|0;c[v>>2]=U+1;a[(c[G>>2]|0)+U>>0]=M;M=(c[w>>2]|0)+1|0;c[w>>2]=M;N=c[D>>2]|0;if(M>>>0>=(c[N+20>>2]&65535)>>>0){W=N;X=V;break a}I=c[v>>2]|0;J=N;K=M;L=V}W=c[D>>2]|0;X=R}else{W=m;X=r}while(0);if((c[W+44>>2]|0)!=0?(r=c[v>>2]|0,r>>>0>X>>>0):0){m=d+48|0;c[m>>2]=jN(c[m>>2]|0,(c[j+8>>2]|0)+X|0,r-X|0)|0;Y=c[D>>2]|0}else Y=W;if((c[w>>2]|0)==(c[Y+20>>2]|0)){c[w>>2]=0;c[l>>2]=73;F=Y;y=57;break}else{E=c[l>>2]|0;y=55;break}}while(0);if((y|0)==55)if((E|0)==73){F=c[j+28>>2]|0;y=57}else{Z=E;y=75}do if((y|0)==57){r=j+28|0;if(!(c[F+28>>2]|0)){c[l>>2]=91;_=r;y=77;break}m=j+20|0;u=c[m>>2]|0;L=j+12|0;K=d+48|0;J=j+8|0;I=d+20|0;G=j+32|0;s=u;H=u;while(1){if((s|0)==(c[L>>2]|0)){if(s>>>0>H>>>0?(c[(c[r>>2]|0)+44>>2]|0)!=0:0)c[K>>2]=jN(c[K>>2]|0,(c[J>>2]|0)+H|0,s-H|0)|0;u=c[h>>2]|0;z=c[u+20>>2]|0;M=c[o>>2]|0;N=z>>>0>M>>>0?M:z;if((N|0)!=0?(YEi(c[k>>2]|0,c[u+16>>2]|0,N|0)|0,c[k>>2]=(c[k>>2]|0)+N,u=c[h>>2]|0,z=u+16|0,c[z>>2]=(c[z>>2]|0)+N,c[I>>2]=(c[I>>2]|0)+N,c[o>>2]=(c[o>>2]|0)-N,M=u+20|0,P=c[M>>2]|0,c[M>>2]=P-N,(P|0)==(N|0)):0)c[z>>2]=c[u+8>>2];u=c[m>>2]|0;if((u|0)==(c[L>>2]|0)){$=u;aa=1;break}else{ba=u;ca=u}}else{ba=s;ca=H}u=c[G>>2]|0;c[G>>2]=u+1;z=a[(c[(c[r>>2]|0)+28>>2]|0)+u>>0]|0;c[m>>2]=ba+1;a[(c[J>>2]|0)+ba>>0]=z;if(!(z<<24>>24)){$=ca;aa=z&255;break}s=c[m>>2]|0;H=ca}if((c[(c[r>>2]|0)+44>>2]|0)!=0?(H=c[m>>2]|0,H>>>0>$>>>0):0)c[K>>2]=jN(c[K>>2]|0,(c[J>>2]|0)+$|0,H-$|0)|0;if(!aa){c[G>>2]=0;c[l>>2]=91;_=r;y=77;break}else{Z=c[l>>2]|0;y=75;break}}while(0);if((y|0)==75)if((Z|0)==91){_=j+28|0;y=77}else{da=Z;y=95}do if((y|0)==77){if(!(c[(c[_>>2]|0)+36>>2]|0)){c[l>>2]=103;ea=_;y=97;break}H=j+20|0;s=c[H>>2]|0;L=j+12|0;I=d+48|0;w=j+8|0;v=d+20|0;z=j+32|0;u=s;N=s;while(1){if((u|0)==(c[L>>2]|0)){if(u>>>0>N>>>0?(c[(c[_>>2]|0)+44>>2]|0)!=0:0)c[I>>2]=jN(c[I>>2]|0,(c[w>>2]|0)+N|0,u-N|0)|0;s=c[h>>2]|0;P=c[s+20>>2]|0;M=c[o>>2]|0;Q=P>>>0>M>>>0?M:P;if((Q|0)!=0?(YEi(c[k>>2]|0,c[s+16>>2]|0,Q|0)|0,c[k>>2]=(c[k>>2]|0)+Q,s=c[h>>2]|0,P=s+16|0,c[P>>2]=(c[P>>2]|0)+Q,c[v>>2]=(c[v>>2]|0)+Q,c[o>>2]=(c[o>>2]|0)-Q,M=s+20|0,O=c[M>>2]|0,c[M>>2]=O-Q,(O|0)==(Q|0)):0)c[P>>2]=c[s+8>>2];s=c[H>>2]|0;if((s|0)==(c[L>>2]|0)){fa=s;ga=1;break}else{ha=s;ia=s}}else{ha=u;ia=N}s=c[z>>2]|0;c[z>>2]=s+1;P=a[(c[(c[_>>2]|0)+36>>2]|0)+s>>0]|0;c[H>>2]=ha+1;a[(c[w>>2]|0)+ha>>0]=P;if(!(P<<24>>24)){fa=ia;ga=P&255;break}u=c[H>>2]|0;N=ia}if((c[(c[_>>2]|0)+44>>2]|0)!=0?(N=c[H>>2]|0,N>>>0>fa>>>0):0)c[I>>2]=jN(c[I>>2]|0,(c[w>>2]|0)+fa|0,N-fa|0)|0;if(!ga){c[l>>2]=103;ea=_;y=97;break}else{da=c[l>>2]|0;y=95;break}}while(0);if((y|0)==95?(da|0)==103:0){ea=j+28|0;y=97}do if((y|0)==97){if(!(c[(c[ea>>2]|0)+44>>2]|0)){c[l>>2]=113;break}N=j+20|0;u=j+12|0;if((((c[N>>2]|0)+2|0)>>>0>(c[u>>2]|0)>>>0?(z=c[h>>2]|0,L=c[z+20>>2]|0,v=c[o>>2]|0,r=L>>>0>v>>>0?v:L,(r|0)!=0):0)?(YEi(c[k>>2]|0,c[z+16>>2]|0,r|0)|0,c[k>>2]=(c[k>>2]|0)+r,z=c[h>>2]|0,L=z+16|0,c[L>>2]=(c[L>>2]|0)+r,v=d+20|0,c[v>>2]=(c[v>>2]|0)+r,c[o>>2]=(c[o>>2]|0)-r,v=z+20|0,G=c[v>>2]|0,c[v>>2]=G-r,(G|0)==(r|0)):0)c[L>>2]=c[z+8>>2];z=c[N>>2]|0;if((z+2|0)>>>0<=(c[u>>2]|0)>>>0){u=d+48|0;L=c[u>>2]&255;c[N>>2]=z+1;r=j+8|0;a[(c[r>>2]|0)+z>>0]=L;L=(c[u>>2]|0)>>>8&255;z=c[N>>2]|0;c[N>>2]=z+1;a[(c[r>>2]|0)+z>>0]=L;c[u>>2]=jN(0,0,0)|0;c[l>>2]=113}}while(0);u=j+20|0;if(!(c[u>>2]|0)){if((c[d+4>>2]|0)==0&((q|0)>=(e|0)&n)){c[d+24>>2]=c[104433];g=-5;i=f;return g|0}}else{L=c[h>>2]|0;z=c[L+20>>2]|0;r=c[o>>2]|0;N=z>>>0>r>>>0?r:z;if(N){YEi(c[k>>2]|0,c[L+16>>2]|0,N|0)|0;c[k>>2]=(c[k>>2]|0)+N;L=c[h>>2]|0;z=L+16|0;c[z>>2]=(c[z>>2]|0)+N;G=d+20|0;c[G>>2]=(c[G>>2]|0)+N;G=(c[o>>2]|0)-N|0;c[o>>2]=G;v=L+20|0;J=c[v>>2]|0;c[v>>2]=J-N;if((J|0)==(N|0)){c[z>>2]=c[L+8>>2];ja=G}else ja=G}else ja=r;if(!ja){c[p>>2]=-1;g=0;i=f;return g|0}}r=(c[l>>2]|0)==666;G=(c[d+4>>2]|0)==0;if(r)if(G)y=117;else{c[d+24>>2]=c[104433];g=-5;i=f;return g|0}else if(G)y=117;else y=118;if((y|0)==117?!((c[j+116>>2]|0)==0&((e|0)==0|r)):0)y=118;if((y|0)==118){r=_n[c[414768+((c[j+132>>2]|0)*12|0)+8>>2]&4095](j,e)|0;if((r&-2|0)==2)c[l>>2]=666;if(!(r&-3)){if(c[o>>2]|0){g=0;i=f;return g|0}c[p>>2]=-1;g=0;i=f;return g|0}if((r|0)==1){if((e|0)!=1){pN(j,0,0,0);if((e|0)==3){r=c[j+76>>2]|0;G=c[j+68>>2]|0;b[G+(r+-1<<1)>>1]=0;PEi(G|0,0,(r<<1)+-2|0)|0}}else qN(j);r=c[h>>2]|0;G=c[r+20>>2]|0;L=c[o>>2]|0;z=G>>>0>L>>>0?L:G;if(z){YEi(c[k>>2]|0,c[r+16>>2]|0,z|0)|0;c[k>>2]=(c[k>>2]|0)+z;r=c[h>>2]|0;G=r+16|0;c[G>>2]=(c[G>>2]|0)+z;N=d+20|0;c[N>>2]=(c[N>>2]|0)+z;N=(c[o>>2]|0)-z|0;c[o>>2]=N;J=r+20|0;v=c[J>>2]|0;c[J>>2]=v-z;if((v|0)==(z|0)){c[G>>2]=c[r+8>>2];ka=N}else ka=N}else ka=L;if(!ka){c[p>>2]=-1;g=0;i=f;return g|0}}}if(n){g=0;i=f;return g|0}L=j+24|0;N=c[L>>2]|0;if((N|0)<1){g=1;i=f;return g|0}r=d+48|0;G=c[r>>2]|0;if((N|0)==2){N=c[u>>2]|0;c[u>>2]=N+1;z=j+8|0;a[(c[z>>2]|0)+N>>0]=G;N=(c[r>>2]|0)>>>8&255;v=c[u>>2]|0;c[u>>2]=v+1;a[(c[z>>2]|0)+v>>0]=N;N=(c[r>>2]|0)>>>16&255;v=c[u>>2]|0;c[u>>2]=v+1;a[(c[z>>2]|0)+v>>0]=N;N=(c[r>>2]|0)>>>24&255;v=c[u>>2]|0;c[u>>2]=v+1;a[(c[z>>2]|0)+v>>0]=N;N=d+8|0;v=c[N>>2]&255;J=c[u>>2]|0;c[u>>2]=J+1;a[(c[z>>2]|0)+J>>0]=v;v=(c[N>>2]|0)>>>8&255;J=c[u>>2]|0;c[u>>2]=J+1;a[(c[z>>2]|0)+J>>0]=v;v=(c[N>>2]|0)>>>16&255;J=c[u>>2]|0;c[u>>2]=J+1;a[(c[z>>2]|0)+J>>0]=v;v=(c[N>>2]|0)>>>24&255;N=c[u>>2]|0;c[u>>2]=N+1;a[(c[z>>2]|0)+N>>0]=v}else{v=c[u>>2]|0;c[u>>2]=v+1;N=j+8|0;a[(c[N>>2]|0)+v>>0]=G>>>24;v=c[u>>2]|0;c[u>>2]=v+1;a[(c[N>>2]|0)+v>>0]=G>>>16;G=c[r>>2]|0;r=c[u>>2]|0;c[u>>2]=r+1;a[(c[N>>2]|0)+r>>0]=G>>>8;r=c[u>>2]|0;c[u>>2]=r+1;a[(c[N>>2]|0)+r>>0]=G}G=c[h>>2]|0;r=c[G+20>>2]|0;N=c[o>>2]|0;v=r>>>0>N>>>0?N:r;if((v|0)!=0?(YEi(c[k>>2]|0,c[G+16>>2]|0,v|0)|0,c[k>>2]=(c[k>>2]|0)+v,G=c[h>>2]|0,r=G+16|0,c[r>>2]=(c[r>>2]|0)+v,N=d+20|0,c[N>>2]=(c[N>>2]|0)+v,c[o>>2]=(c[o>>2]|0)-v,N=G+20|0,z=c[N>>2]|0,c[N>>2]=z-v,(z|0)==(v|0)):0)c[r>>2]=c[G+8>>2];G=c[L>>2]|0;if((G|0)>0)c[L>>2]=0-G;g=(c[u>>2]|0)==0&1;i=f;return g|0}}while(0);c[d+24>>2]=c[104430];g=-2;i=f;return g|0}function oN(a){a=a|0;var d=0;d=i;c[a+2840>>2]=a+148;c[a+2848>>2]=415656;c[a+2852>>2]=a+2440;c[a+2860>>2]=415680;c[a+2864>>2]=a+2684;c[a+2872>>2]=415704;b[a+5816>>1]=0;c[a+5820>>2]=0;c[a+5812>>2]=8;QO(a);i=d;return}function pN(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;k=d+5820|0;l=c[k>>2]|0;m=d+5816|0;n=e[m>>1]|0|h<<l;b[m>>1]=n;if((l|0)>13){o=d+20|0;p=c[o>>2]|0;c[o>>2]=p+1;q=d+8|0;a[(c[q>>2]|0)+p>>0]=n;p=(e[m>>1]|0)>>>8&255;r=c[o>>2]|0;c[o>>2]=r+1;a[(c[q>>2]|0)+r>>0]=p;p=c[k>>2]|0;r=(h&65535)>>>(16-p|0);b[m>>1]=r;s=r;t=p+-13|0}else{s=n;t=l+3|0}l=s&255;c[k>>2]=t;do if((t|0)<=8){s=d+20|0;if((t|0)>0){n=c[s>>2]|0;c[s>>2]=n+1;p=d+8|0;a[(c[p>>2]|0)+n>>0]=l;u=s;v=p;break}else{u=s;v=d+8|0;break}}else{s=d+20|0;p=c[s>>2]|0;c[s>>2]=p+1;n=d+8|0;a[(c[n>>2]|0)+p>>0]=l;p=(e[m>>1]|0)>>>8&255;r=c[s>>2]|0;c[s>>2]=r+1;a[(c[n>>2]|0)+r>>0]=p;u=s;v=n}while(0);b[m>>1]=0;c[k>>2]=0;c[d+5812>>2]=8;d=c[u>>2]|0;c[u>>2]=d+1;a[(c[v>>2]|0)+d>>0]=g;d=c[u>>2]|0;c[u>>2]=d+1;a[(c[v>>2]|0)+d>>0]=g>>>8;d=g&65535^65535;k=c[u>>2]|0;c[u>>2]=k+1;a[(c[v>>2]|0)+k>>0]=d;k=c[u>>2]|0;c[u>>2]=k+1;a[(c[v>>2]|0)+k>>0]=d>>>8;if(!g){i=j;return}else{w=g;x=f}while(1){w=w+-1|0;f=a[x>>0]|0;g=c[u>>2]|0;c[u>>2]=g+1;a[(c[v>>2]|0)+g>>0]=f;if(!w)break;else x=x+1|0}i=j;return}function qN(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=d+5820|0;h=c[g>>2]|0;j=d+5816|0;k=e[j>>1]|0|2<<h;l=k&65535;b[j>>1]=l;if((h|0)>13){m=d+20|0;n=c[m>>2]|0;c[m>>2]=n+1;o=d+8|0;a[(c[o>>2]|0)+n>>0]=k;k=(e[j>>1]|0)>>>8&255;n=c[m>>2]|0;c[m>>2]=n+1;a[(c[o>>2]|0)+n>>0]=k;k=c[g>>2]|0;n=2>>>(16-k|0)&65535;b[j>>1]=n;p=n;q=k+-13|0}else{p=l;q=h+3|0}c[g>>2]=q;if((q|0)>9){h=d+20|0;l=c[h>>2]|0;c[h>>2]=l+1;k=d+8|0;a[(c[k>>2]|0)+l>>0]=p;l=(e[j>>1]|0)>>>8&255;n=c[h>>2]|0;c[h>>2]=n+1;a[(c[k>>2]|0)+n>>0]=l;b[j>>1]=0;r=(c[g>>2]|0)+-9|0;s=0}else{r=q+7|0;s=p}c[g>>2]=r;if((r|0)!=16)if((r|0)>7){p=d+20|0;q=c[p>>2]|0;c[p>>2]=q+1;a[(c[d+8>>2]|0)+q>>0]=s;q=(e[j>>1]|0)>>>8;b[j>>1]=q;p=(c[g>>2]|0)+-8|0;c[g>>2]=p;t=p;u=q}else{t=r;u=s}else{r=d+20|0;q=c[r>>2]|0;c[r>>2]=q+1;p=d+8|0;a[(c[p>>2]|0)+q>>0]=s;s=(e[j>>1]|0)>>>8&255;q=c[r>>2]|0;c[r>>2]=q+1;a[(c[p>>2]|0)+q>>0]=s;b[j>>1]=0;c[g>>2]=0;t=0;u=0}s=d+5812|0;if((11-t+(c[s>>2]|0)|0)>=9){c[s>>2]=7;i=f;return}q=u&65535|2<<t;b[j>>1]=q;if((t|0)>13){u=d+20|0;p=c[u>>2]|0;c[u>>2]=p+1;r=d+8|0;a[(c[r>>2]|0)+p>>0]=q;p=(e[j>>1]|0)>>>8&255;l=c[u>>2]|0;c[u>>2]=l+1;a[(c[r>>2]|0)+l>>0]=p;p=c[g>>2]|0;l=2>>>(16-p|0);b[j>>1]=l;v=l;w=p+-13|0}else{v=q;w=t+3|0}t=v&255;c[g>>2]=w;if((w|0)>9){v=d+20|0;q=c[v>>2]|0;c[v>>2]=q+1;p=d+8|0;a[(c[p>>2]|0)+q>>0]=t;q=(e[j>>1]|0)>>>8&255;l=c[v>>2]|0;c[v>>2]=l+1;a[(c[p>>2]|0)+l>>0]=q;b[j>>1]=0;x=0;y=(c[g>>2]|0)+-9|0}else{x=t;y=w+7|0}c[g>>2]=y;if((y|0)==16){w=d+20|0;t=c[w>>2]|0;c[w>>2]=t+1;q=d+8|0;a[(c[q>>2]|0)+t>>0]=x;t=(e[j>>1]|0)>>>8&255;l=c[w>>2]|0;c[w>>2]=l+1;a[(c[q>>2]|0)+l>>0]=t;b[j>>1]=0;c[g>>2]=0;c[s>>2]=7;i=f;return}if((y|0)<=7){c[s>>2]=7;i=f;return}y=d+20|0;t=c[y>>2]|0;c[y>>2]=t+1;a[(c[d+8>>2]|0)+t>>0]=x;b[j>>1]=(e[j>>1]|0)>>>8;c[g>>2]=(c[g>>2]|0)+-8;c[s>>2]=7;i=f;return}function rN(f,g,h,j){f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;if((c[f+132>>2]|0)>0){l=(c[f>>2]|0)+44|0;if((c[l>>2]|0)==2){m=-201342849;n=0;while(1){if((m&1|0)!=0?(b[f+(n<<2)+148>>1]|0)!=0:0){o=0;break}n=n+1|0;if((n|0)>=32){p=6;break}else m=m>>>1}a:do if((p|0)==6)if(((b[f+184>>1]|0)==0?(b[f+188>>1]|0)==0:0)?(b[f+200>>1]|0)==0:0){m=32;while(1){if(b[f+(m<<2)+148>>1]|0){o=1;break a}m=m+1|0;if((m|0)>=256){o=0;break}}}else o=1;while(0);c[l>>2]=o}RO(f,f+2840|0);RO(f,f+2852|0);o=c[f+2844>>2]|0;l=b[f+150>>1]|0;p=l<<16>>16==0;b[f+(o+1<<2)+150>>1]=-1;m=f+2752|0;n=f+2756|0;q=f+2748|0;r=p?138:7;s=p?3:4;p=0;t=l&65535;l=-1;b:while(1){u=0;v=p;while(1){if((v|0)>(o|0))break b;w=v+1|0;x=b[f+(w<<2)+150>>1]|0;y=x&65535;z=u+1|0;A=(t|0)==(y|0);if((z|0)<(r|0)&A){u=z;v=w}else{B=w;C=x;D=y;E=z;F=A;break}}do if((E|0)>=(s|0))if(!t)if((E|0)<11){b[m>>1]=(b[m>>1]|0)+1<<16>>16;break}else{b[n>>1]=(b[n>>1]|0)+1<<16>>16;break}else{if((t|0)!=(l|0)){v=f+(t<<2)+2684|0;b[v>>1]=(b[v>>1]|0)+1<<16>>16}b[q>>1]=(b[q>>1]|0)+1<<16>>16;break}else{v=f+(t<<2)+2684|0;b[v>>1]=(e[v>>1]|0)+E}while(0);if(!(C<<16>>16)){G=t;r=138;s=3;p=B;t=D;l=G;continue}G=t;r=F?6:7;s=F?3:4;p=B;t=D;l=G}G=c[f+2856>>2]|0;l=b[f+2442>>1]|0;D=l<<16>>16==0;b[f+(G+1<<2)+2442>>1]=-1;t=D?138:7;B=D?3:4;D=0;p=l&65535;l=-1;c:while(1){F=0;s=D;while(1){if((s|0)>(G|0))break c;r=s+1|0;C=b[f+(r<<2)+2442>>1]|0;E=C&65535;o=F+1|0;v=(p|0)==(E|0);if((o|0)<(t|0)&v){F=o;s=r}else{H=r;I=C;J=E;K=o;L=v;break}}do if((K|0)>=(B|0))if(!p)if((K|0)<11){b[m>>1]=(b[m>>1]|0)+1<<16>>16;break}else{b[n>>1]=(b[n>>1]|0)+1<<16>>16;break}else{if((p|0)!=(l|0)){s=f+(p<<2)+2684|0;b[s>>1]=(b[s>>1]|0)+1<<16>>16}b[q>>1]=(b[q>>1]|0)+1<<16>>16;break}else{s=f+(p<<2)+2684|0;b[s>>1]=(e[s>>1]|0)+K}while(0);if(!(I<<16>>16)){M=p;t=138;B=3;D=H;p=J;l=M;continue}M=p;t=L?6:7;B=L?3:4;D=H;p=J;l=M}RO(f,f+2864|0);M=18;while(1){l=M+-1|0;if(b[f+(d[417480+M>>0]<<2)+2686>>1]|0){N=M;break}if((l|0)>2)M=l;else{N=l;break}}M=f+5800|0;l=(N*3|0)+17+(c[M>>2]|0)|0;c[M>>2]=l;M=(l+10|0)>>>3;l=((c[f+5804>>2]|0)+10|0)>>>3;O=N;P=l>>>0>M>>>0?M:l;Q=l}else{l=h+5|0;O=0;P=l;Q=l}do if((h+4|0)>>>0<=P>>>0&(g|0)!=0)pN(f,g,h,j);else{l=f+5820|0;M=c[l>>2]|0;N=(M|0)>13;if((Q|0)==(P|0)?1:(c[f+136>>2]|0)==4){J=j+2|0;p=f+5816|0;H=e[p>>1]|J<<M;b[p>>1]=H;if(N){D=f+20|0;L=c[D>>2]|0;c[D>>2]=L+1;B=f+8|0;a[(c[B>>2]|0)+L>>0]=H;H=(e[p>>1]|0)>>>8&255;L=c[D>>2]|0;c[D>>2]=L+1;a[(c[B>>2]|0)+L>>0]=H;H=c[l>>2]|0;b[p>>1]=(J&65535)>>>(16-H|0);R=H+-13|0}else R=M+3|0;c[l>>2]=R;SO(f,415728,416880);break}H=j+4|0;J=f+5816|0;p=e[J>>1]|H<<M;b[J>>1]=p;if(N){N=f+20|0;L=c[N>>2]|0;c[N>>2]=L+1;B=f+8|0;a[(c[B>>2]|0)+L>>0]=p;L=(e[J>>1]|0)>>>8&255;D=c[N>>2]|0;c[N>>2]=D+1;a[(c[B>>2]|0)+D>>0]=L;L=c[l>>2]|0;D=(H&65535)>>>(16-L|0);b[J>>1]=D;S=D;T=L+-13|0}else{S=p;T=M+3|0}c[l>>2]=T;M=c[f+2844>>2]|0;p=c[f+2856>>2]|0;L=M+-256|0;D=S&65535|L<<T;b[J>>1]=D;if((T|0)>11){H=f+20|0;B=c[H>>2]|0;c[H>>2]=B+1;N=f+8|0;a[(c[N>>2]|0)+B>>0]=D;B=(e[J>>1]|0)>>>8&255;t=c[H>>2]|0;c[H>>2]=t+1;a[(c[N>>2]|0)+t>>0]=B;B=c[l>>2]|0;t=(L&65535)>>>(16-B|0);b[J>>1]=t;U=B+-11|0;V=t}else{U=T+5|0;V=D}c[l>>2]=U;D=p<<U|V&65535;b[J>>1]=D;if((U|0)>11){t=f+20|0;B=c[t>>2]|0;c[t>>2]=B+1;L=f+8|0;a[(c[L>>2]|0)+B>>0]=D;B=(e[J>>1]|0)>>>8&255;N=c[t>>2]|0;c[t>>2]=N+1;a[(c[L>>2]|0)+N>>0]=B;B=c[l>>2]|0;N=(p&65535)>>>(16-B|0);b[J>>1]=N;W=B+-11|0;X=N}else{W=U+5|0;X=D}c[l>>2]=W;D=O+-3|0;N=D<<W|X&65535;b[J>>1]=N;if((W|0)>12){B=f+20|0;L=c[B>>2]|0;c[B>>2]=L+1;t=f+8|0;a[(c[t>>2]|0)+L>>0]=N;L=(e[J>>1]|0)>>>8&255;H=c[B>>2]|0;c[B>>2]=H+1;a[(c[t>>2]|0)+H>>0]=L;L=c[l>>2]|0;H=(D&65535)>>>(16-L|0);b[J>>1]=H;Y=H;Z=L+-12|0}else{Y=N;Z=W+4|0}c[l>>2]=Z;if((O|0)>-1){N=f+20|0;L=f+8|0;H=Z;D=Y;t=0;while(1){B=e[f+(d[417480+t>>0]<<2)+2686>>1]|0;I=B<<H|D&65535;b[J>>1]=I;if((H|0)>13){K=c[N>>2]|0;c[N>>2]=K+1;a[(c[L>>2]|0)+K>>0]=I;K=(e[J>>1]|0)>>>8&255;q=c[N>>2]|0;c[N>>2]=q+1;a[(c[L>>2]|0)+q>>0]=K;K=c[l>>2]|0;q=B>>>(16-K|0);b[J>>1]=q;_=q;$=K+-13|0}else{_=I;$=H+3|0}c[l>>2]=$;if((t|0)==(O|0))break;else{H=$;D=_;t=t+1|0}}}t=f+148|0;TO(f,t,M);D=f+2440|0;TO(f,D,p);SO(f,t,D)}while(0);QO(f);if(!j){i=k;return}j=f+5820|0;_=c[j>>2]|0;if((_|0)<=8){$=f+5816|0;if((_|0)>0){_=b[$>>1]&255;O=f+20|0;Y=c[O>>2]|0;c[O>>2]=Y+1;a[(c[f+8>>2]|0)+Y>>0]=_;aa=$}else aa=$}else{$=f+5816|0;_=b[$>>1]&255;Y=f+20|0;O=c[Y>>2]|0;c[Y>>2]=O+1;Z=f+8|0;a[(c[Z>>2]|0)+O>>0]=_;_=(e[$>>1]|0)>>>8&255;O=c[Y>>2]|0;c[Y>>2]=O+1;a[(c[Z>>2]|0)+O>>0]=_;aa=$}b[aa>>1]=0;c[j>>2]=0;i=k;return}function sN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=ADi(da(c,b)|0)|0;i=a;return d|0}function tN(a,b){a=a|0;b=b|0;a=i;BDi(b);i=a;return}function uN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;k=f;ati(h,b);if(!(a[h>>0]|0)){cti(h);i=f;return b|0}l=c[(c[b>>2]|0)+-12>>2]|0;c[j>>2]=c[b+(l+24)>>2];if((c[b+(l+4)>>2]&176|0)==32)m=d+e|0;else m=d;n=b+l|0;o=b+(l+76)|0;l=c[o>>2]|0;if((l|0)==-1){dsi(g,n);p=Kxi(g,3654800)|0;q=_n[c[(c[p>>2]|0)+28>>2]&4095](p,32)|0;Ixi(g);p=q<<24>>24;c[o>>2]=p;r=n;s=p}else{r=n;s=l}c[g+0>>2]=c[j+0>>2];KP(k,g,d,m,d+e|0,r,s&255);if(c[k>>2]|0){cti(h);i=f;return b|0}k=c[(c[b>>2]|0)+-12>>2]|0;$ri(b+k|0,c[b+(k+16)>>2]|5);cti(h);i=f;return b|0}function vN(a){a=a|0;return ~c[a>>2]|0}function wN(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=b+8|0;j=c[h>>2]|0;if(!j){c[h>>2]=32;if((d[b+12>>0]|0)>1){c[b+4>>2]=Ks(128,0)|0;k=c[h>>2]|0}else{c[b+4>>2]=CDi(1,128)|0;c[b+16>>2]=CDi(1,64)|0;k=32}c[b>>2]=CDi(1,k>>>3)|0;l=k}else l=j;j=b+13|0;k=(d[j>>0]|d[j+1>>0]<<8)&65535|(d[j+2>>0]|0)<<16;m=k&16777215;n=l>>>5;a:do if(m>>>0<n>>>0){o=c[b>>2]|0;p=m;while(1){q=c[o+(p<<2)>>2]|0;if((q|0)!=-1){r=q;s=p;break}p=p+1|0;if(p>>>0>=n>>>0){t=k;u=15;break a}}p=0;while(1){if(!(1<<p&r)){v=p;u=14;break}p=p+1|0;if((p|0)>=32){u=12;break}}if((u|0)==12){p=s&65535;a[j>>0]=p;a[j+1>>0]=p>>8;a[j+2>>0]=s>>>16;t=s;u=15;break}else if((u|0)==14){p=s&65535;a[j>>0]=p;a[j+1>>0]=p>>8;a[j+2>>0]=s>>>16;if((v|0)==-1){t=s;u=15;break}else{w=b;x=v;y=s;break}}}else{t=k;u=15}while(0);b:do if((u|0)==15){c:do if(t&16777215){k=c[b>>2]|0;s=0;while(1){v=c[k+(s<<2)>>2]|0;if((v|0)!=-1){z=v;A=s;break}s=s+1|0;if((s|0)>=(t&16777215|0))break c}s=0;while(1){if(!(1<<s&z)){B=s;break}s=s+1|0;if((s|0)>=32){u=21;break}}if((u|0)==21){s=A&65535;a[j>>0]=s;a[j+1>>0]=s>>8;a[j+2>>0]=A>>>16;break}s=A&65535;a[j>>0]=s;a[j+1>>0]=s>>8;a[j+2>>0]=A>>>16;if((B|0)!=-1){w=b;x=B;y=A;break b}}while(0);s=l<<1;k=CDi(1,l>>>2&536870911)|0;v=c[b>>2]|0;YEi(k|0,v|0,l>>>3|0)|0;BDi(v);c[b>>2]=k;if((d[b+12>>0]|0)>1){k=Ks(l<<3,0)|0;v=b+4|0;YEi(k|0,c[v>>2]|0,c[h>>2]<<2|0)|0;c[v>>2]=k}else{k=CDi(1,l<<2)|0;v=ADi(l<<3)|0;As();r=b+4|0;n=c[r>>2]|0;m=c[h>>2]|0;p=m<<2;YEi(v|0,n|0,p|0)|0;PEi(v+(m<<2)|0,0,p|0)|0;p=b+16|0;YEi(k|0,c[p>>2]|0,m<<1|0)|0;if(!m)C=n;else{m=n;n=0;while(1){o=Gs(m+(n<<2)|0)|0;q=(c[r>>2]|0)+(n<<2)|0;if(c[q>>2]|0)Fs(q);if(o)Es(v+(n<<2)|0,o,f);n=n+1|0;o=c[r>>2]|0;if(n>>>0>=(c[h>>2]|0)>>>0){C=o;break}else m=o}}BDi(C);BDi(c[p>>2]|0);c[r>>2]=v;c[p>>2]=k;Bs()}m=(c[h>>2]|0)+1|0;n=m&65535;a[j>>0]=n;a[j+1>>0]=n>>8;a[j+2>>0]=m>>>16;c[h>>2]=s;w=b;x=0;y=m>>>5}while(0);h=(c[w>>2]|0)+(y<<2)|0;c[h>>2]=c[h>>2]|1<<x;h=(y<<5)+x|0;x=b+4|0;c[(c[x>>2]|0)+(h<<2)>>2]=e;y=b+12|0;b=a[y>>0]|0;if(!((b&255)<2&(e|0)!=0)){D=b;E=h<<3;F=D&255;G=F+1|0;H=G|E;i=g;return H|0}Es((c[x>>2]|0)+(h<<2)|0,e,f);D=a[y>>0]|0;E=h<<3;F=D&255;G=F+1|0;H=G|E;i=g;return H|0}function xN(a){a=a|0;sk(a|0)|0;HCi()}function yN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b+32|0;yri(f,d)|0;d=b+44|0;c[d>>2]=0;g=b+48|0;h=c[g>>2]|0;if(h&8){j=a[f>>0]|0;if(!(j&1)){k=f+((j&255)>>>1)+1|0;c[d>>2]=k;l=f+1|0;m=f+1|0;n=k}else{k=(c[b+40>>2]|0)+(c[b+36>>2]|0)|0;c[d>>2]=k;j=c[b+40>>2]|0;l=j;m=j;n=k}c[b+8>>2]=l;c[b+12>>2]=m;c[b+16>>2]=n}if(!(h&16)){i=e;return}h=a[f>>0]|0;if(!(h&1)){n=(h&255)>>>1;c[d>>2]=f+n+1;o=10;p=n}else{n=c[b+36>>2]|0;c[d>>2]=(c[b+40>>2]|0)+n;o=(c[f>>2]&-2)+-1|0;p=n}Bri(f,o,0);o=a[f>>0]|0;if(!(o&1)){q=f+1|0;r=(o&255)>>>1;s=f+1|0}else{f=c[b+40>>2]|0;q=f;r=c[b+36>>2]|0;s=f}f=b+24|0;c[f>>2]=s;c[b+20>>2]=s;c[b+28>>2]=q+r;if(!(c[g>>2]&3)){i=e;return}c[f>>2]=s+p;i=e;return}function zN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[d+48>>2]|0;if(f&16){g=d+44|0;h=c[g>>2]|0;j=c[d+24>>2]|0;if(h>>>0<j>>>0){c[g>>2]=j;k=j}else k=h;h=c[d+20>>2]|0;j=k-h|0;if(j>>>0>4294967279)ori(b);if(j>>>0<11){a[b>>0]=j<<1;l=b+1|0}else{g=j+16&-16;m=xCi(g)|0;c[b+8>>2]=m;c[b>>2]=g|1;c[b+4>>2]=j;l=m}if((h|0)==(k|0))n=l;else{m=h;h=l;while(1){a[h>>0]=a[m>>0]|0;m=m+1|0;if((m|0)==(k|0))break;else h=h+1|0}n=l+j|0}a[n>>0]=0;i=e;return}if(!(f&8)){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}f=c[d+8>>2]|0;n=c[d+16>>2]|0;d=n-f|0;if(d>>>0>4294967279)ori(b);if(d>>>0<11){a[b>>0]=d<<1;o=b+1|0}else{j=d+16&-16;l=xCi(j)|0;c[b+8>>2]=l;c[b>>2]=j|1;c[b+4>>2]=d;o=l}if((f|0)==(n|0))p=o;else{l=f;f=o;while(1){a[f>>0]=a[l>>0]|0;l=l+1|0;if((l|0)==(n|0))break;else f=f+1|0}p=o+d|0}a[p>>0]=0;i=e;return}function AN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+-12>>2]|0)>>2]=c[b+32>>2];c[a+8>>2]=c[b+36>>2];b=a+12|0;c[b>>2]=74048;xri(a+44|0);gsi(b);i=d;return}function BN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;h=i;j=c[d>>2]|0;do if((e|0)>0){if((j|0)<=(f|0)){k=b;l=e;m=c[k+4>>2]|0;n=c[k>>2]|0;k=0;o=j;while(1){if(m){p=32;while(1){if((p|0)<=0){q=-1;break}r=p+-1|0;if(!(1<<r&m))p=r;else{q=r;break}}p=q+-11|0;r=(p|0)<(l|0)?p:l+-1|0;if((r|0)>0){p=a;s=VEi(c[p>>2]|0,c[p+4>>2]|0,r|0)|0;p=H;t=(1<<r)+-1|0;u=cFi(n&t|0,m&((t|0)<0)<<31>>31|0,64-r|0)|0;t=a;c[t>>2]=u|s;c[t+4>>2]=H|p;p=b;t=VEi(c[p>>2]|0,c[p+4>>2]|0,r|0)|0;p=b;c[p>>2]=t;c[p+4>>2]=H;v=l-r|0;w=m>>>r}else{v=l;w=m}}else{v=l;w=0}a:do if((v|0)>0){r=v;p=w;t=k;while(1){if(p>>>0<=1024?!((c[a>>2]&1|0)==0&0==0):0){x=r;y=t;break a}s=r+-1|0;u=a;z=c[u>>2]|0;if(!s)A=z&1;else A=t;B=VEi(z|0,c[u+4>>2]|0,1)|0;u=H;z=a;c[z>>2]=B;c[z+4>>2]=u;z=b;C=cFi(c[z>>2]|0,c[z+4>>2]|0,63)|0;z=a;c[z>>2]=C|B;c[z+4>>2]=H|u;u=b;z=VEi(c[u>>2]|0,c[u+4>>2]|0,1)|0;u=b;c[u>>2]=z;c[u+4>>2]=H;if((s|0)>0){r=s;p=p>>>1;t=A}else{x=s;y=A;break}}}else{x=v;y=k}while(0);t=(x|0)>9?9:x;p=(t+o|0)>(f|0)?f-o|0:t;if(!p){D=x;E=y;F=o;break}t=x-p|0;r=p+o|0;s=(c[726896+(p<<2)>>2]|0)>>>p;p=a;u=c[p+4>>2]|0;z=gFi(c[p>>2]|0,0,s|0,0)|0;p=H;B=gFi(u|0,0,s|0,0)|0;u=_Ei(p|0,0,B|0,H|0)|0;B=H;p=a;c[p>>2]=z;c[p+4>>2]=u;u=b;p=gFi(c[u>>2]|0,c[u+4>>2]|0,s|0,0)|0;n=_Ei(p|0,H|0,B|0,0)|0;m=H;B=b;c[B>>2]=n;c[B+4>>2]=m;if((t|0)<1|(r|0)>(f|0)){D=t;E=y;F=r;break}else{l=t;k=y;o=r}}if((D|0)>0){G=D;I=E;J=F}else{K=E;L=F;break}}else{G=e;I=0;J=j}o=G;k=I;while(1){o=o+-1|0;l=a;m=c[l>>2]|0;if(!o)M=m&1;else M=k;n=VEi(m|0,c[l+4>>2]|0,1)|0;l=H;m=a;c[m>>2]=n;c[m+4>>2]=l;m=b;r=cFi(c[m>>2]|0,c[m+4>>2]|0,63)|0;m=a;c[m>>2]=r|n;c[m+4>>2]=H|l;l=b;m=VEi(c[l>>2]|0,c[l+4>>2]|0,1)|0;l=b;c[l>>2]=m;c[l+4>>2]=H;if((o|0)<=0){K=M;L=J;break}else k=M}}else{K=0;L=j}while(0);if((L|0)>(f|0)){j=L;while(1){M=j-f|0;J=(M|0)>9?9:M;M=j-J|0;I=c[726896+(J<<2)>>2]|0;J=b;G=c[J>>2]|0;e=c[J+4>>2]|0;J=hFi(e|0,0,I|0,0)|0;F=gFi(J|0,H|0,I|0,0)|0;E=ZEi(e|0,0,F|0,H|0)|0;F=hFi(G|0,E|0,I|0,0)|0;E=gFi(F|0,H|0,I|0,0)|0;D=ZEi(G|0,e|0,E|0,H|0)|0;E=b;c[E>>2]=F;c[E+4>>2]=J;J=a;E=c[J>>2]|0;F=c[J+4>>2]|0;J=hFi(F|0,D|0,I|0,0)|0;D=gFi(J|0,H|0,I|0,0)|0;e=ZEi(F|0,0,D|0,H|0)|0;D=hFi(E|0,e|0,I|0,0)|0;F=gFi(D|0,H|0,I|0,0)|0;G=ZEi(E|0,e|0,F|0,H|0)|0;F=a;c[F>>2]=D;c[F+4>>2]=J;J=cFi(G|0,H|0,1)|0;G=H;if(G>>>0<0|(G|0)==0&J>>>0<I>>>0)if((J|0)==(I|0)&(G|0)==0)N=(D&1|0)!=0|0!=0;else N=0;else N=1;if((M|0)>(f|0))j=M;else{O=M;P=N;break}}Q=P&1;R=O}else{Q=K;R=L}b:do if((R|0)<0){if(!g){L=R;while(1){K=0-L|0;O=(K|0)>9?9:K;K=c[726896+(O<<2)>>2]|0;P=a;N=c[P+4>>2]|0;j=gFi(c[P>>2]|0,0,K|0,0)|0;P=H;f=gFi(N|0,0,K|0,0)|0;N=_Ei(P|0,0,f|0,H|0)|0;f=H;P=a;c[P>>2]=j;c[P+4>>2]=N;N=b;P=c[N+4>>2]|0;j=gFi(c[N>>2]|0,0,K|0,0)|0;N=_Ei(f|0,0,j|0,H|0)|0;j=H;f=gFi(P|0,0,K|0,0)|0;K=_Ei(j|0,0,f|0,H|0)|0;f=H;j=b;c[j>>2]=N;c[j+4>>2]=K;j=O+L|0;if(!(f>>>0<1|(f|0)==1&K>>>0<0)){S=2;break}if((j|0)<0)L=j;else{T=0;U=j;break b}}i=h;return S|0}else{V=Q;W=R}while(1){L=0-W|0;j=(L|0)>9?9:L;L=c[726896+(j<<2)>>2]|0;K=a;f=c[K+4>>2]|0;O=gFi(c[K>>2]|0,0,L|0,0)|0;K=H;if(!V){X=K;Y=O}else{N=_Ei(O|0,K|0,L>>>1|0,0)|0;X=H;Y=N}N=gFi(f|0,0,L|0,0)|0;f=_Ei(X|0,0,N|0,H|0)|0;N=H;K=a;c[K>>2]=Y;c[K+4>>2]=f;f=b;K=c[f+4>>2]|0;O=gFi(c[f>>2]|0,0,L|0,0)|0;f=_Ei(N|0,0,O|0,H|0)|0;O=H;N=gFi(K|0,0,L|0,0)|0;L=_Ei(O|0,0,N|0,H|0)|0;N=H;O=b;c[O>>2]=f;c[O+4>>2]=L;O=j+W|0;if(!(N>>>0<1|(N|0)==1&L>>>0<0)){S=2;break}if((O|0)<0){V=0;W=O}else{T=0;U=O;break b}}i=h;return S|0}else{T=Q;U=R}while(0);c[d>>2]=U;S=LP(a,b,d,g,T)|0;i=h;return S|0}function CN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if((d|0)<0){f=0-d|0;if((f|0)>28){g=3;i=e;return g|0}if((f|0)>0)h=f;else{g=0;i=e;return g|0}do{f=(h|0)>9?9:h;h=h-f|0;j=c[726896+(f<<2)>>2]|0;f=b;k=c[f>>2]|0;l=c[f+4>>2]|0;f=hFi(l|0,0,j|0,0)|0;m=gFi(f|0,H|0,j|0,0)|0;n=ZEi(l|0,0,m|0,H|0)|0;m=hFi(k|0,n|0,j|0,0)|0;n=gFi(m|0,H|0,j|0,0)|0;o=ZEi(k|0,l|0,n|0,H|0)|0;n=b;c[n>>2]=m;c[n+4>>2]=f;f=a;n=c[f>>2]|0;m=c[f+4>>2]|0;f=hFi(m|0,o|0,j|0,0)|0;o=gFi(f|0,H|0,j|0,0)|0;l=ZEi(m|0,0,o|0,H|0)|0;o=hFi(n|0,l|0,j|0,0)|0;j=a;c[j>>2]=o;c[j+4>>2]=f}while((h|0)>0);g=0;i=e;return g|0}if((d|0)<=0){g=0;i=e;return g|0}if((d|0)>28){g=3;i=e;return g|0}else p=d;while(1){if((p|0)<=0){g=0;q=9;break}d=(p|0)>9?9:p;h=c[726896+(d<<2)>>2]|0;f=a;j=c[f+4>>2]|0;o=gFi(c[f>>2]|0,0,h|0,0)|0;f=H;l=gFi(j|0,0,h|0,0)|0;j=_Ei(f|0,0,l|0,H|0)|0;l=H;f=a;c[f>>2]=o;c[f+4>>2]=j;j=b;f=c[j+4>>2]|0;o=gFi(c[j>>2]|0,0,h|0,0)|0;j=_Ei(l|0,0,o|0,H|0)|0;o=H;l=gFi(f|0,0,h|0,0)|0;h=_Ei(o|0,0,l|0,H|0)|0;l=H;o=b;c[o>>2]=j;c[o+4>>2]=h;o=l>>>0<1|(l|0)==1&h>>>0<0;if(o)p=p-d|0;else{g=o?0:2;q=9;break}}if((q|0)==9){i=e;return g|0}return 0}function DN(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;l=i;m=(g|0)==0;n=(e|0)==0;if(!(f|e|g)){o=5;i=l;return o|0}if((d|0)==0&(a|b|0)==0){p=j;c[p>>2]=0;c[p+4>>2]=0;p=h;c[p>>2]=0;c[p+4>>2]=0;o=1;i=l;return o|0}if((d|0)==0&(a|0)==0)if((b|0)>-1|(b|0)==-1&0>4294967295){p=0;q=b;r=64;while(1){s=cFi(p|0,q|0,1)|0;t=H;u=r+1|0;if((t|0)>-1|(t|0)==-1&s>>>0>4294967295){p=s;q=t;r=u}else{v=t;w=s;x=0;y=0;z=u;break}}}else{v=b;w=0;x=0;y=0;z=64}else if((a|0)>-1|(a|0)==-1&d>>>0>4294967295){r=d;q=a;p=0;u=b;s=0;while(1){t=cFi(r|0,q|0,1)|0;A=H;B=VEi(p|0,u|0,63)|0;C=t|B;B=A|H;A=cFi(p|0,u|0,1)|0;t=H;D=s+1|0;if((B|0)>-1|(B|0)==-1&C>>>0>4294967295){r=C;q=B;p=A;u=t;s=D}else{v=B;w=C;x=t;y=A;z=D;break}}}else{v=a;w=d;x=b;y=0;z=0}a:do if(!n)if((e|0)>-1){b=e;d=f;a=g;s=0;while(1){u=b<<1|a>>>31;p=a<<1|d>>>31;q=d<<1;r=s+1|0;if((u|0)>-1){b=u;d=q;a=p;s=r}else{E=u;F=q;G=p;I=r;break}}}else{E=e;F=f;G=g;I=0}else{if(m)J=32;else{if((g|0)>-1){K=g;L=f;M=32}else{E=g;F=0;G=f;I=32;break}while(1){s=K<<1|L>>>31;a=L<<1;d=M+1|0;if((s|0)>-1){K=s;L=a;M=d}else{E=s;F=0;G=a;I=d;break a}}}while(1){if((J|0)<=0){N=-1;break}d=J+-1|0;if(!(1<<d&f))J=d;else{N=d;break}}d=31-N|0;E=f<<d;F=0;G=0;I=d+64|0}while(0);if(!(v>>>0>E>>>0|(v|0)==(E|0)&w>>>0>G>>>0)?(w|0)!=(G|0)|(v|0)!=(E|0)|(x>>>0<F>>>0|(x|0)==(F|0)&y>>>0<0):0){O=v;P=w;Q=y;R=x;S=0}else{f=ZEi(y|0,x|0,0,F|0)|0;N=H;J=(x>>>0<F>>>0|(x|0)==(F|0)&y>>>0<0)<<31>>31;y=_Ei(J|0,((J|0)<0)<<31>>31|0,w|0,v|0)|0;v=ZEi(y|0,H|0,G|0,E|0)|0;O=H;P=v;Q=f;R=N;S=1}if(E>>>0>O>>>0|(E|0)==(O|0)&0>P>>>0){N=hFi(P|0,O|0,E|0,0)|0;T=N}else T=-1;N=gFi(T|0,0,F|0,0)|0;f=H;v=gFi(T|0,0,G|0,0)|0;y=_Ei(f|0,0,v|0,H|0)|0;v=H;f=gFi(T|0,0,E|0,0)|0;w=H;J=ZEi(Q|0,R|0,N|0,y|0)|0;x=H;M=(R>>>0<y>>>0|(R|0)==(y|0)&Q>>>0<N>>>0)<<31>>31;N=ZEi(P|0,O|0,f|0,w|0)|0;w=ZEi(N|0,H|0,v|0,0)|0;v=_Ei(w|0,H|0,M|0,((M|0)<0)<<31>>31|0)|0;M=H;if((M|0)<0){w=J;N=x;f=v;O=M;P=T;while(1){Q=P+-1|0;y=_Ei(w|0,N|0,F|0,G|0)|0;R=H;L=_Ei(f|0,O|0,E|0,0)|0;K=_Ei(L|0,H|0,(R>>>0<N>>>0|(R|0)==(N|0)&y>>>0<w>>>0)&1|0,0)|0;L=H;if((L|0)<0){w=y;N=R;f=K;O=L;P=Q}else{U=K;V=R;W=y;X=L;Y=Q;break}}}else{U=v;V=x;W=J;X=M;Y=T}if(U>>>0<E>>>0|(U|0)==(E|0)&V>>>0<0){T=hFi(V|0,U|0,E|0,0)|0;Z=T}else Z=-1;T=gFi(Z|0,0,F|0,0)|0;M=H;X=gFi(Z|0,0,G|0,0)|0;J=_Ei(M|0,0,X|0,H|0)|0;X=H;M=gFi(Z|0,0,E|0,0)|0;x=H;v=ZEi(0,W|0,T|0,J|0)|0;P=H;O=(W>>>0<J>>>0|(W|0)==(J|0)&0<T>>>0)<<31>>31;T=ZEi(V|0,U|0,M|0,x|0)|0;x=ZEi(T|0,H|0,X|0,0)|0;X=_Ei(x|0,H|0,O|0,((O|0)<0)<<31>>31|0)|0;O=H;if((O|0)<0){x=v;T=P;M=X;U=O;V=Z;while(1){J=V+-1|0;W=_Ei(x|0,T|0,F|0,G|0)|0;f=H;N=_Ei(M|0,U|0,E|0,0)|0;w=_Ei(N|0,H|0,(f>>>0<T>>>0|(f|0)==(T|0)&W>>>0<x>>>0)&1|0,0)|0;N=H;if((N|0)<0){x=W;T=f;M=w;U=N;V=J}else{_=w;$=f;aa=W;ba=N;ca=J;break}}}else{_=X;$=P;aa=v;ba=O;ca=Z}Z=j;c[Z>>2]=ca;c[Z+4>>2]=Y;if(_>>>0<E>>>0|(_|0)==(E|0)&$>>>0<0){Y=hFi($|0,_|0,E|0,0)|0;da=Y}else da=-1;Y=gFi(da|0,0,F|0,0)|0;Z=H;ca=gFi(da|0,0,G|0,0)|0;O=_Ei(Z|0,0,ca|0,H|0)|0;ca=H;Z=gFi(da|0,0,E|0,0)|0;ba=(aa>>>0<O>>>0|(aa|0)==(O|0)&0<Y>>>0)<<31>>31;v=ZEi($|0,_|0,Z|0,H|0)|0;Z=ZEi(v|0,H|0,ca|0,0)|0;ca=_Ei(Z|0,H|0,ba|0,((ba|0)<0)<<31>>31|0)|0;ba=H;if((ba|0)<0){Z=ZEi(0,aa|0,Y|0,O|0)|0;O=Z;Z=H;Y=ca;aa=ba;v=da;while(1){_=v+-1|0;$=O;O=_Ei(O|0,Z|0,F|0,G|0)|0;P=Z;Z=H;X=_Ei(Y|0,aa|0,E|0,0)|0;V=_Ei(X|0,H|0,(Z>>>0<P>>>0|(Z|0)==(P|0)&O>>>0<$>>>0)&1|0,0)|0;$=H;if(($|0)>=0){ea=$;fa=V;ga=_;break}else{Y=V;aa=$;v=_}}}else{ea=ba;fa=ca;ga=da}if(ea>>>0<0|(ea|0)==0&fa>>>0<E>>>0){ea=hFi(0,fa|0,E|0,0)|0;ha=0;ia=ea}else{ha=0;ia=-1}ea=ha|ga;ga=h;c[ga>>2]=ia;c[ga+4>>2]=ea;ga=z+128-I|0;if(S){S=VEi(ia|0,ea|0,1)|0;ea=H;ia=h;c[ia>>2]=S;c[ia+4>>2]=ea;ia=j;I=cFi(c[ia>>2]|0,c[ia+4>>2]|0,63)|0;ia=h;c[ia>>2]=I|S;c[ia+4>>2]=H|ea;ea=j;ia=VEi(c[ea>>2]|0,c[ea+4>>2]|0,1)|0;ea=j;c[ea>>2]=ia;c[ea+4>>2]=H|-2147483648;ja=ga+-1|0}else ja=ga;b:do if((ja|0)>0){ga=ja;while(1){ea=h;ia=c[ea>>2]|0;if(!((ia&1|0)==0&0==0)){ka=ga;break b}S=VEi(ia|0,c[ea+4>>2]|0,1)|0;ea=H;ia=h;c[ia>>2]=S;c[ia+4>>2]=ea;ia=j;I=cFi(c[ia>>2]|0,c[ia+4>>2]|0,63)|0;ia=h;c[ia>>2]=I|S;c[ia+4>>2]=H|ea;ea=j;ia=VEi(c[ea>>2]|0,c[ea+4>>2]|0,1)|0;ea=j;c[ea>>2]=ia;c[ea+4>>2]=H;ea=ga+-1|0;if((ea|0)>0)ga=ea;else{ka=ea;break}}}else ka=ja;while(0);c[k>>2]=ka;o=0;i=l;return o|0}function EN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if((g|0)<0)vxi(a);h=a+8|0;j=f;f=(c[h>>2]|0)-j|0;if(f>>2>>>0<1073741823){k=f>>1;f=k>>>0<g>>>0?g:k;k=(c[e>>2]|0)-j>>2;if(!f){l=0;m=0;n=k}else{o=f;p=k;q=6}}else{o=2147483647;p=(c[e>>2]|0)-j>>2;q=6}if((q|0)==6){l=o;m=Ks(o<<2,0)|0;n=p}p=m+(n<<2)|0;if(p)c[p>>2]=c[b>>2];b=c[a>>2]|0;p=(c[e>>2]|0)-b|0;o=m+(n-(p>>2)<<2)|0;YEi(o|0,b|0,p|0)|0;p=c[a>>2]|0;c[a>>2]=o;c[e>>2]=m+(n+1<<2);c[h>>2]=m+(l<<2);if(!p){i=d;return}Ls(p);i=d;return}function FN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function GN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;f=(d|0)==(b|0);a[d+12>>0]=f&1;if(f){i=e;return}else g=d;while(1){d=g+8|0;f=c[d>>2]|0;h=f+12|0;if(a[h>>0]|0){j=37;break}k=f+8|0;l=g;g=c[k>>2]|0;m=c[g>>2]|0;if((m|0)==(f|0)){n=c[g+4>>2]|0;if(!n){o=l;p=f;q=k;r=g;j=7;break}s=n+12|0;if(a[s>>0]|0){o=l;p=f;q=k;r=g;j=7;break}a[h>>0]=1;a[g+12>>0]=(g|0)==(b|0)&1;a[s>>0]=1}else{if(!m){t=l;u=k;v=d;w=f;x=g;j=24;break}s=m+12|0;if(a[s>>0]|0){t=l;u=k;v=d;w=f;x=g;j=24;break}a[h>>0]=1;a[g+12>>0]=(g|0)==(b|0)&1;a[s>>0]=1}if((g|0)==(b|0)){j=37;break}}if((j|0)==7){if((c[p>>2]|0)==(o|0)){y=p;z=r;A=p}else{o=p+4|0;b=c[o>>2]|0;g=c[b>>2]|0;c[o>>2]=g;if(!g)B=r;else{c[g+8>>2]=p;B=c[q>>2]|0}g=b+8|0;c[g>>2]=B;B=c[q>>2]|0;if((c[B>>2]|0)==(p|0))c[B>>2]=b;else c[B+4>>2]=b;c[b>>2]=p;c[q>>2]=b;q=c[g>>2]|0;y=b;z=q;A=c[q>>2]|0}a[y+12>>0]=1;a[z+12>>0]=0;y=A+4|0;q=c[y>>2]|0;c[z>>2]=q;if(q)c[q+8>>2]=z;q=z+8|0;c[A+8>>2]=c[q>>2];b=c[q>>2]|0;if((c[b>>2]|0)==(z|0))c[b>>2]=A;else c[b+4>>2]=A;c[y>>2]=z;c[q>>2]=A;i=e;return}else if((j|0)==24){if((c[w>>2]|0)==(t|0)){A=t+4|0;q=c[A>>2]|0;c[w>>2]=q;if(!q)C=x;else{c[q+8>>2]=w;C=c[u>>2]|0}c[v>>2]=C;C=c[u>>2]|0;if((c[C>>2]|0)==(w|0))c[C>>2]=t;else c[C+4>>2]=t;c[A>>2]=w;c[u>>2]=t;D=t;E=c[v>>2]|0}else{D=w;E=x}a[D+12>>0]=1;a[E+12>>0]=0;D=E+4|0;x=c[D>>2]|0;w=c[x>>2]|0;c[D>>2]=w;if(w)c[w+8>>2]=E;w=E+8|0;c[x+8>>2]=c[w>>2];D=c[w>>2]|0;if((c[D>>2]|0)==(E|0))c[D>>2]=x;else c[D+4>>2]=x;c[x>>2]=E;c[w>>2]=x;i=e;return}else if((j|0)==37){i=e;return}}function HN(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{HN(a,c[b>>2]|0);HN(a,c[b+4>>2]|0);ACi(b);i=d;return}}function IN(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=i;i=i+16|0;m=l;n=d+158|0;if(!(b[n>>1]|0)){i=l;return}o=d+16|0;p=(d|0)!=(f|0);f=(g&4|0)==0;d=h+12|0;q=j+4|0;r=j+8|0;s=(g&8|0)==0;t=g&64;u=0;do{v=c[(c[o>>2]|0)+((u&65535)<<2)>>2]|0;c[m>>2]=v;w=v+28|0;x=b[w>>1]|0;if(x&4096){y=c[v>>2]|0;if((HEi(y,3072840)|0)!=0?(HEi(y,3076392)|0)!=0:0)z=6}else z=6;do if((z|0)==6?(z=0,y=x&7,!(((y<<16>>16==6?16:32)&g|0)==0|p&y<<16>>16==1)):0){if(!(x&16)){if(f)break}else if(s|p&(t|0)==0)break;if(pI(d,h,c[v>>2]|0)|0){if(b[w>>1]&64){y=k+(e[v+32>>1]|0)|0;if(a[y>>0]|0)break;a[y>>0]=1}y=c[q>>2]|0;if((y|0)==(c[r>>2]|0)){MP(j,m);break}if(!y)A=0;else{c[y>>2]=v;A=c[q>>2]|0}c[q>>2]=A+4}}while(0);u=u+1<<16>>16}while((u&65535)<(e[n>>1]|0));i=l;return}function JN(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=i;i=i+16|0;m=l;n=d+158|0;if(!(b[n>>1]|0)){i=l;return}o=d+16|0;p=(d|0)!=(f|0);f=(g&4|0)==0;d=h+12|0;q=j+4|0;r=j+8|0;s=(g&8|0)==0;t=g&64;u=0;do{v=c[(c[o>>2]|0)+((u&65535)<<2)>>2]|0;c[m>>2]=v;w=v+28|0;x=b[w>>1]|0;if(x&4096){y=c[v>>2]|0;if((HEi(y,3072840)|0)!=0?(HEi(y,3076392)|0)!=0:0)z=6}else z=6;do if((z|0)==6?(z=0,y=x&7,!(((y<<16>>16==6?16:32)&g|0)==0|p&y<<16>>16==1)):0){if(!(x&16)){if(f)break}else if(s|p&(t|0)==0)break;if(nI(d,h,c[v>>2]|0)|0){if(b[w>>1]&64){y=k+(e[v+32>>1]|0)|0;if(a[y>>0]|0)break;a[y>>0]=1}y=c[q>>2]|0;if((y|0)==(c[r>>2]|0)){MP(j,m);break}if(!y)A=0;else{c[y>>2]=v;A=c[q>>2]|0}c[q>>2]=A+4}}while(0);u=u+1<<16>>16}while((u&65535)<(e[n>>1]|0));i=l;return}function KN(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+16|0;l=h;m=d+158|0;n=b[m>>1]|0;if(!(n<<16>>16)){i=h;return}o=d+16|0;p=(d|0)!=(f|0);f=(g&4|0)==0;d=j+4|0;q=j+8|0;r=(g&8|0)==0;s=g&64;t=n;n=0;while(1){u=c[(c[o>>2]|0)+((n&65535)<<2)>>2]|0;c[l>>2]=u;v=b[u+28>>1]|0;if(v&4096){w=c[u>>2]|0;if((HEi(w,3072840)|0)!=0?(HEi(w,3076392)|0)!=0:0)x=6;else y=t}else x=6;do if((x|0)==6){x=0;w=v&7;if(((w<<16>>16==6?16:32)&g|0)==0|p&w<<16>>16==1)y=t;else{if(!(v&16)){if(f){y=t;break}}else if(r|p&(s|0)==0){y=t;break}if(v&64){w=k+(e[u+32>>1]|0)|0;if(a[w>>0]|0){y=t;break}a[w>>0]=1}w=c[d>>2]|0;if((w|0)==(c[q>>2]|0)){MP(j,l);y=b[m>>1]|0;break}if(!w)z=0;else{c[w>>2]=u;z=c[d>>2]|0}c[d>>2]=z+4;y=t}}while(0);n=n+1<<16>>16;if((n&65535)>=(y&65535))break;else t=y}i=h;return}function LN(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+32|0;k=j+24|0;l=j+16|0;m=j+8|0;n=j+4|0;o=j;p=a+160|0;if(!(b[p>>1]|0)){i=j;return}q=a+20|0;r=(a|0)!=(g|0);a=(d&4|0)==0;s=f+12|0;t=(d&8|0)==0;u=d&64;v=0;do{w=c[(c[q>>2]|0)+((v&65535)<<2)>>2]|0;x=c[w+8>>2]|0;y=(x|0)==0;if(!y?(b[x+28>>1]&7)==6:0)z=16;else A=5;do if((A|0)==5){A=0;B=c[w+12>>2]|0;if((B|0)!=0?(b[B+28>>1]&7)==6:0){z=16;break}z=32}while(0);a:do if(z&d){do if(r){if(!y?(B=b[x+28>>1]|0,(B&7)!=1):0){C=B;A=16;break}B=c[w+12>>2]|0;if(!B)break a;if((b[B+28>>1]&7)==1)break a;else A=14}else A=14;while(0);do if((A|0)==14){A=0;if(!y){C=b[x+28>>1]|0;A=16;break}B=c[w+12>>2]|0;if((B|0)!=0?(b[B+28>>1]&16)!=0:0)A=19;else A=20}while(0);if((A|0)==16){A=0;if(!(C&16))A=20;else A=19}if((A|0)==19){A=0;if(t|r&(u|0)==0)break}else if((A|0)==20?(A=0,a):0)break;if(pI(s,f,c[w+4>>2]|0)|0?(c[n>>2]=w,NP(m,h,n),(c[m>>2]|0)==0):0){B=PL(g,w)|0;c[o>>2]=w;NP(k,h,o);D=c[k>>2]|0;if(!D){E=Ks(16,0)|0;c[E+8>>2]=w;c[E+12>>2]=0;OP(l,h,E);F=c[l>>2]|0}else F=D;c[F+12>>2]=B}}while(0);v=v+1<<16>>16}while((v&65535)<(e[p>>1]|0));i=j;return}function MN(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+32|0;k=j+24|0;l=j+16|0;m=j+8|0;n=j+4|0;o=j;p=a+160|0;if(!(b[p>>1]|0)){i=j;return}q=a+20|0;r=(a|0)!=(g|0);a=(d&4|0)==0;s=f+12|0;t=(d&8|0)==0;u=d&64;v=0;do{w=c[(c[q>>2]|0)+((v&65535)<<2)>>2]|0;x=c[w+8>>2]|0;y=(x|0)==0;if(!y?(b[x+28>>1]&7)==6:0)z=16;else A=5;do if((A|0)==5){A=0;B=c[w+12>>2]|0;if((B|0)!=0?(b[B+28>>1]&7)==6:0){z=16;break}z=32}while(0);a:do if(z&d){do if(r){if(!y?(B=b[x+28>>1]|0,(B&7)!=1):0){C=B;A=16;break}B=c[w+12>>2]|0;if(!B)break a;if((b[B+28>>1]&7)==1)break a;else A=14}else A=14;while(0);do if((A|0)==14){A=0;if(!y){C=b[x+28>>1]|0;A=16;break}B=c[w+12>>2]|0;if((B|0)!=0?(b[B+28>>1]&16)!=0:0)A=19;else A=20}while(0);if((A|0)==16){A=0;if(!(C&16))A=20;else A=19}if((A|0)==19){A=0;if(t|r&(u|0)==0)break}else if((A|0)==20?(A=0,a):0)break;if(nI(s,f,c[w+4>>2]|0)|0?(c[n>>2]=w,NP(m,h,n),(c[m>>2]|0)==0):0){B=PL(g,w)|0;c[o>>2]=w;NP(k,h,o);D=c[k>>2]|0;if(!D){E=Ks(16,0)|0;c[E+8>>2]=w;c[E+12>>2]=0;OP(l,h,E);F=c[l>>2]|0}else F=D;c[F+12>>2]=B}}while(0);v=v+1<<16>>16}while((v&65535)<(e[p>>1]|0));i=j;return}function NN(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=i;i=i+32|0;j=h+24|0;k=h+16|0;l=h+8|0;m=h+4|0;n=h;o=a+160|0;if(!(b[o>>1]|0)){i=h;return}p=a+20|0;q=(a|0)!=(f|0);a=(d&4|0)==0;r=(d&8|0)==0;s=d&64;t=0;do{u=c[(c[p>>2]|0)+((t&65535)<<2)>>2]|0;v=c[u+8>>2]|0;w=(v|0)==0;if(!w?(b[v+28>>1]&7)==6:0)x=16;else y=5;do if((y|0)==5){y=0;z=c[u+12>>2]|0;if((z|0)!=0?(b[z+28>>1]&7)==6:0){x=16;break}x=32}while(0);a:do if(x&d){do if(q){if(!w?(z=b[v+28>>1]|0,(z&7)!=1):0){A=z;y=16;break}z=c[u+12>>2]|0;if(!z)break a;if((b[z+28>>1]&7)==1)break a;else y=14}else y=14;while(0);do if((y|0)==14){y=0;if(!w){A=b[v+28>>1]|0;y=16;break}z=c[u+12>>2]|0;if((z|0)!=0?(b[z+28>>1]&16)!=0:0)y=19;else y=20}while(0);if((y|0)==16){y=0;if(!(A&16))y=20;else y=19}if((y|0)==19){y=0;if(r|q&(s|0)==0)break}else if((y|0)==20?(y=0,a):0)break;c[m>>2]=u;NP(l,g,m);if(!(c[l>>2]|0)){z=PL(f,u)|0;c[n>>2]=u;NP(j,g,n);B=c[j>>2]|0;if(!B){C=Ks(16,0)|0;c[C+8>>2]=u;c[C+12>>2]=0;OP(k,g,C);D=c[k>>2]|0}else D=B;c[D+12>>2]=z}}while(0);t=t+1<<16>>16}while((t&65535)<(e[o>>1]|0));i=h;return}function ON(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;h=a+164|0;j=b[h>>1]|0;if(!(j<<16>>16)){k=0;i=g;return k|0}l=a+28|0;m=(a|0)!=(d|0);a=(e&4|0)==0;n=f+12|0;o=(e&8|0)==0;p=e&64;q=j;j=0;a:while(1){r=c[(c[l>>2]|0)+((j&65535)<<2)>>2]|0;s=c[r+12>>2]|0;t=(s|0)==0;if(!t?(b[s+28>>1]&7)==6:0)u=16;else v=5;do if((v|0)==5){v=0;w=c[r+16>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)==6:0){u=16;break}w=c[r+20>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)==6:0){u=16;break}u=32}while(0);b:do if(!(u&e))x=q;else{do if(m){if(!t?(w=b[s+28>>1]|0,(w&7)!=1):0){y=w;v=20;break}w=c[r+16>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)!=1:0){v=18;break}w=c[r+20>>2]|0;if(!w){x=q;break b}if((b[w+28>>1]&7)==1){x=q;break b}else v=18}else v=18;while(0);do if((v|0)==18){v=0;if(!t){y=b[s+28>>1]|0;v=20;break}w=c[r+16>>2]|0;if(w)if(!(b[w+28>>1]&16)){v=26;break}else{v=25;break}w=c[r+20>>2]|0;if((w|0)!=0?(b[w+28>>1]&16)!=0:0)v=25;else v=26}while(0);if((v|0)==20){v=0;if(!(y&16))v=26;else v=25}if((v|0)==25){v=0;if(o|m&(p|0)==0){x=q;break}}else if((v|0)==26?(v=0,a):0){x=q;break}if(pI(n,f,c[r>>2]|0)|0){z=r;break a}x=b[h>>1]|0}while(0);j=j+1<<16>>16;if((j&65535)>=(x&65535)){k=0;v=31;break}else q=x}if((v|0)==31){i=g;return k|0}k=QL(d,z)|0;i=g;return k|0}function PN(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;h=a+164|0;j=b[h>>1]|0;if(!(j<<16>>16)){k=0;i=g;return k|0}l=a+28|0;m=(a|0)!=(d|0);a=(e&4|0)==0;n=f+12|0;o=(e&8|0)==0;p=e&64;q=j;j=0;a:while(1){r=c[(c[l>>2]|0)+((j&65535)<<2)>>2]|0;s=c[r+12>>2]|0;t=(s|0)==0;if(!t?(b[s+28>>1]&7)==6:0)u=16;else v=5;do if((v|0)==5){v=0;w=c[r+16>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)==6:0){u=16;break}w=c[r+20>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)==6:0){u=16;break}u=32}while(0);b:do if(!(u&e))x=q;else{do if(m){if(!t?(w=b[s+28>>1]|0,(w&7)!=1):0){y=w;v=20;break}w=c[r+16>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)!=1:0){v=18;break}w=c[r+20>>2]|0;if(!w){x=q;break b}if((b[w+28>>1]&7)==1){x=q;break b}else v=18}else v=18;while(0);do if((v|0)==18){v=0;if(!t){y=b[s+28>>1]|0;v=20;break}w=c[r+16>>2]|0;if(w)if(!(b[w+28>>1]&16)){v=26;break}else{v=25;break}w=c[r+20>>2]|0;if((w|0)!=0?(b[w+28>>1]&16)!=0:0)v=25;else v=26}while(0);if((v|0)==20){v=0;if(!(y&16))v=26;else v=25}if((v|0)==25){v=0;if(o|m&(p|0)==0){x=q;break}}else if((v|0)==26?(v=0,a):0){x=q;break}if(nI(n,f,c[r>>2]|0)|0){z=r;break a}x=b[h>>1]|0}while(0);j=j+1<<16>>16;if((j&65535)>=(x&65535)){k=0;v=31;break}else q=x}if((v|0)==31){i=g;return k|0}k=QL(d,z)|0;i=g;return k|0}function QN(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;i=i+16|0;j=h;k=a+164|0;if(!(b[k>>1]|0)){i=h;return}l=a+28|0;m=(a|0)!=(d|0);a=(f&4|0)==0;n=g+4|0;o=(f&8|0)==0;p=f&64;q=0;do{r=c[(c[l>>2]|0)+((q&65535)<<2)>>2]|0;s=c[r+12>>2]|0;t=(s|0)==0;if(!t?(b[s+28>>1]&7)==6:0)u=16;else v=5;do if((v|0)==5){v=0;w=c[r+16>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)==6:0){u=16;break}w=c[r+20>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)==6:0){u=16;break}u=32}while(0);a:do if(u&f){do if(m){if(!t?(w=b[s+28>>1]|0,(w&7)!=1):0){x=w;v=20;break}w=c[r+16>>2]|0;if((w|0)!=0?(b[w+28>>1]&7)!=1:0){v=18;break}w=c[r+20>>2]|0;if(!w)break a;if((b[w+28>>1]&7)==1)break a;else v=18}else v=18;while(0);do if((v|0)==18){v=0;if(!t){x=b[s+28>>1]|0;v=20;break}w=c[r+16>>2]|0;if(w)if(!(b[w+28>>1]&16)){v=26;break}else{v=25;break}w=c[r+20>>2]|0;if((w|0)!=0?(b[w+28>>1]&16)!=0:0)v=25;else v=26}while(0);if((v|0)==20){v=0;if(!(x&16))v=26;else v=25}if((v|0)==25){v=0;if(o|m&(p|0)==0)break}else if((v|0)==26?(v=0,a):0)break;w=iI(c[r>>2]|0)|0;y=c[n>>2]|0;b:do if(y){z=y+-1|0;A=(z&y|0)==0;if(A)B=z&w;else B=(w>>>0)%(y>>>0)|0;C=c[(c[g>>2]|0)+(B<<2)>>2]|0;if(C){D=C;while(1){D=c[D>>2]|0;if(!D)break b;C=c[D+4>>2]|0;if(A)E=C&z;else E=(C>>>0)%(y>>>0)|0;if((E|0)!=(B|0))break b;if(!(HEi(c[c[D+8>>2]>>2]|0,c[r>>2]|0)|0))break a}}}while(0);y=QL(d,r)|0;c[j>>2]=r;c[(PP(g,j)|0)>>2]=y}while(0);q=q+1<<16>>16}while((q&65535)<(e[k>>1]|0));i=h;return}function RN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function SN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function TN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=HEi(a,257504+(e[b>>1]|0)|0)|0;i=c;return d|0}function UN(a,c){a=a|0;c=c|0;return (b[a>>1]|0)-(b[c>>1]|0)|0}function VN(a,d){a=a|0;d=d|0;var f=0;f=i;c[a+12>>2]=b[d>>1];c[a+48>>2]=ks(257504+(e[d+8>>1]|0)|0)|0;c[a+72>>2]=ks(257504+(e[d+10>>1]|0)|0)|0;c[a+52>>2]=ks(257504+(e[d+14>>1]|0)|0)|0;c[a+56>>2]=ks(257504+(e[d+12>>1]|0)|0)|0;c[a+60>>2]=ks(257504+(e[d+16>>1]|0)|0)|0;c[a+76>>2]=ks(257504+(e[d+18>>1]|0)|0)|0;c[a+64>>2]=ks(257504+(e[d+20>>1]|0)|0)|0;c[a+68>>2]=ks(257504+(e[d+22>>1]|0)|0)|0;c[a+80>>2]=ks(257504+(e[d+24>>1]|0)|0)|0;c[a+16>>2]=b[d+2>>1];c[a+20>>2]=b[d+4>>1];c[a+24>>2]=b[d+48>>1];c[a+28>>2]=b[d+50>>1];c[a+88>>2]=d+28;c[a+92>>2]=d+52;i=f;return}function WN(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}WN(a,c[b>>2]|0);WN(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function XN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=(h|0)==(k|0);if(l)m=0;else m=(h-k<<8)+-1|0;n=a+16|0;o=c[n>>2]|0;if((m-o-(c[a+20>>2]|0)|0)>>>0>1023){c[n>>2]=o+1024;o=h+-4|0;c[d>>2]=c[o>>2];c[g>>2]=o;QP(a,d);i=b;return}d=h;o=a+12|0;m=c[o>>2]|0;p=c[a>>2]|0;q=p;r=m-q|0;if((d-k|0)>>>0<r>>>0){s=xCi(4096)|0;if((k|0)==(p|0)){if((h|0)==(m|0)){m=d-q>>1;q=(m|0)==0?1:m;m=xCi(q<<2)|0;d=m+(q>>>2<<2)|0;t=m+(q<<2)|0;if(l){u=d;v=h}else{q=d;w=k;while(1){if(!q)x=0;else{c[q>>2]=c[w>>2];x=q}y=x+4|0;w=w+4|0;if((w|0)==(h|0)){z=y;break}else q=y}u=z;v=c[a>>2]|0}c[a>>2]=m;c[j>>2]=d;c[g>>2]=u;c[o>>2]=t;if(!v)A=u;else{ACi(v);A=c[g>>2]|0}}else A=h;if(!A)B=0;else{c[A>>2]=s;B=c[g>>2]|0}c[g>>2]=B+4;c[f>>2]=c[B>>2];c[g>>2]=B;QP(a,f)}else{c[e>>2]=s;QP(a,e)}if(((c[g>>2]|0)-(c[j>>2]|0)|0)==4)C=512;else C=(c[n>>2]|0)+1024|0;c[n>>2]=C;i=b;return}C=r>>1;r=(C|0)==0?1:C;C=xCi(r<<2)|0;e=C+(r<<2)|0;c[C>>2]=xCi(4096)|0;r=C+4|0;if(l){D=e;E=C;F=C;G=p;H=r}else{p=C;l=e;e=C;s=C;C=k;k=r;while(1){if((k|0)==(l|0)){if(e>>>0<=s>>>0){r=k-s>>1;f=(r|0)==0?1:r;r=xCi(f<<2)|0;B=r+(f>>>2<<2)|0;A=r+(f<<2)|0;if((e|0)==(k|0))I=B;else{f=B;h=e;while(1){if(!f)J=0;else{c[f>>2]=c[h>>2];J=f}v=J+4|0;if((h|0)==(p|0)){I=v;break}else{f=v;h=h+4|0}}}if(!s){K=A;L=B;M=r;N=I}else{ACi(s);K=A;L=B;M=r;N=I}}else{h=e;f=((h-s>>2)+1|0)/-2|0;v=e+(f<<2)|0;u=k-h|0;aFi(v|0,e|0,u|0)|0;K=k;L=v;M=s;N=e+(f+(u>>2)<<2)|0}if(!N){O=0;P=M;Q=L;R=K}else{S=N;T=M;U=L;V=K;W=33}}else{S=k;T=s;U=e;V=l;W=33}if((W|0)==33){W=0;c[S>>2]=c[C>>2];O=S;P=T;Q=U;R=V}C=C+4|0;u=O+4|0;if((C|0)==(c[g>>2]|0)){X=P;Y=Q;Z=R;_=u;break}else{p=O;l=R;e=Q;s=P;k=u}}D=Z;E=Y;F=X;G=c[a>>2]|0;H=_}c[a>>2]=F;c[j>>2]=E;c[g>>2]=H;c[o>>2]=D;if((H-E|0)==4)$=512;else $=(c[n>>2]|0)+1024|0;c[n>>2]=$;if(!G){i=b;return}ACi(G);i=b;return}function YN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+16|0;g=c[f>>2]|0;h=e+(g>>>10<<2)|0;j=a+8|0;k=c[j>>2]|0;if((k|0)==(e|0)){l=0;m=a+20|0;n=0}else{o=a+20|0;p=(c[o>>2]|0)+g|0;l=(c[e+(p>>>10<<2)>>2]|0)+((p&1023)<<2)|0;m=o;n=(c[h>>2]|0)+((g&1023)<<2)|0}g=n;n=h;a:while(1){h=g;do{if((h|0)==(l|0))break a;h=h+4|0}while((h-(c[n>>2]|0)|0)!=4096);h=n+4|0;g=c[h>>2]|0;n=h}c[m>>2]=0;m=k-e>>2;if(m>>>0>2){k=e;do{ACi(c[k>>2]|0);k=(c[d>>2]|0)+4|0;c[d>>2]=k;e=(c[j>>2]|0)-k>>2}while(e>>>0>2);q=e}else q=m;if((q|0)==1)c[f>>2]=512;else if((q|0)==2)c[f>>2]=1024;f=c[d>>2]|0;q=c[j>>2]|0;if((f|0)!=(q|0)){m=f;do{ACi(c[m>>2]|0);m=m+4|0}while((m|0)!=(q|0));q=c[d>>2]|0;d=c[j>>2]|0;if((d|0)!=(q|0))c[j>>2]=d+(~((d+-4-q|0)>>>2)<<2)}q=c[a>>2]|0;if(!q){i=b;return}ACi(q);i=b;return}function ZN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=FF()|0;f=H;g=a+4|0;a=(b|0)==0;h=(b|0)>0;a:while(1){j=c[g>>2]|0;if(!j){k=0;while(1){l=c[85496]|0;if(!l){m=9;break}n=c[85496]|0;if((c[85496]|0)==(l|0))c[85496]=c[l>>2];k=k+1|0;if((n|0)==(l|0)){o=l;m=8;break}if((k|0)>=5){m=9;break}}if((m|0)==8){m=0;p=o}else if((m|0)==9){m=0;k=xCi(40)|0;c[k>>2]=0;l=k+8|0;c[l>>2]=0;c[l+4>>2]=0;c[k+16>>2]=1;FE(k+20|0,0,1);c[k+24>>2]=0;tE(k+28|0,0,0);c[k+32>>2]=0;p=k}k=p+8|0;l=k;c[l>>2]=e;c[l+4>>2]=f;if(!(c[g>>2]|0)){l=c[g>>2]|0;if(!(c[g>>2]|0))c[g>>2]=p;if(!l){q=1;m=46;break}}l=k;c[l>>2]=0;c[l+4>>2]=0;while(1){l=c[85496]|0;c[p>>2]=l;k=c[85496]|0;if((c[85496]|0)==(l|0))c[85496]=p;if((k|0)==(l|0))continue a}}l=j+8|0;k=l;if((c[k>>2]|0)==(e|0)?(c[k+4>>2]|0)==(f|0):0){r=j;m=19;break}if(a){q=0;m=46;break}k=j+24|0;c[k>>2]=(c[k>>2]|0)+1;HM(zM()|0,32);if((c[g>>2]|0)!=(j|0)){c[k>>2]=(c[k>>2]|0)+-1;JM(zM()|0,32);continue}n=j+20|0;b:do if(h){s=j;while(1){if((s|0)!=(j|0))break b;t=l;if((c[t>>2]|0)==0&(c[t+4>>2]|0)==0){t=l;u=c[t>>2]|0;v=c[t+4>>2]|0;t=l;if((c[t>>2]|0)==0&(c[t+4>>2]|0)==0){t=l;c[t>>2]=e;c[t+4>>2]=f}if((u|0)==0&(v|0)==0){w=k;m=36;break a}}if((JE(n,b,1)|0)==2){x=k;y=l;m=39;break a}s=c[g>>2]|0}}else{s=j;while(1){if((s|0)!=(j|0))break b;v=l;if((c[v>>2]|0)==0&(c[v+4>>2]|0)==0){v=l;u=c[v>>2]|0;t=c[v+4>>2]|0;v=l;if((c[v>>2]|0)==0&(c[v+4>>2]|0)==0){v=l;c[v>>2]=e;c[v+4>>2]=f}if((u|0)==0&(t|0)==0){w=k;m=36;break a}}if((IE(n,1)|0)==2){x=k;y=l;m=39;break a}s=c[g>>2]|0}}while(0);c[k>>2]=(c[k>>2]|0)+-1;JM(zM()|0,32);vE(j+28|0)|0}if((m|0)==19){g=r+16|0;c[g>>2]=(c[g>>2]|0)+1;q=1;i=d;return q|0}else if((m|0)==36){c[w>>2]=(c[w>>2]|0)+-1;JM(zM()|0,32);q=1;i=d;return q|0}else if((m|0)==39){w=(c[x>>2]|0)+-1|0;c[x>>2]=w;JM(zM()|0,32);if((w|0)==0?(w=y,(c[w>>2]|0)==0&(c[w+4>>2]|0)==0):0){w=y;x=c[w>>2]|0;g=c[w+4>>2]|0;w=y;if((c[w>>2]|0)==0&(c[w+4>>2]|0)==0){w=y;c[w>>2]=e;c[w+4>>2]=f}if((x|0)==0&(g|0)==0){q=1;i=d;return q|0}}q=0;i=d;return q|0}else if((m|0)==46){i=d;return q|0}return 0}function _N(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;c[d>>2]=c[d>>2];a=c[d>>2]|0;e=a;if(!a)FJ(YJ(342040)|0);f=FF()|0;g=e+8|0;h=g;if(!((c[h>>2]|0)==(f|0)?(c[h+4>>2]|0)==(H|0):0))FJ(YJ(342064)|0);h=e+16|0;f=(c[h>>2]|0)+-1|0;if((f|0)>0){c[h>>2]=f;i=b;return}f=e+24|0;if(c[f>>2]|0){h=g;c[h>>2]=0;c[h+4>>2]=0;HE(e+20|0,1,0)|0;i=b;return}if(c[e+32>>2]|0){h=g;c[h>>2]=0;c[h+4>>2]=0;i=b;return}c[d>>2]=0;if(c[f>>2]|0){d=e+20|0;h=e+28|0;do{HE(d,c[f>>2]|0,0)|0;xE(h,0)|0}while((c[f>>2]|0)!=0)}f=g;c[f>>2]=0;c[f+4>>2]=0;f=a;do{a=c[85496]|0;c[e>>2]=a;g=c[85496]|0;if((c[85496]|0)==(a|0))c[85496]=f}while((g|0)!=(a|0));i=b;return}function $N(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+16|0;IE(c[f>>2]|0,0)|0;c[b+8>>2]=0;BM(c[a>>2]|0);c[d>>2]=0;c[e>>2]=c[a+12>>2];$L(c[a+8>>2]|0,e,d)|0;e=c[d>>2]|0;if(e)gM(e);EM(c[a>>2]|0);e=c[f>>2]|0;if(!e){Ls(a);i=b;return}GE(e);ACi(e);Ls(a);i=b;return}function aO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[a+108>>2]|0;BE(f,0);g=a+16|0;a=c[g>>2]|0;if(!a){h=uI(c[101523]|0,8)|0;c[g>>2]=h;j=h;k=-1;l=d}else{j=a;k=-1;l=d}while(1){if(c[(yI(j,4,l)|0)>>2]|0){m=k;n=l;o=6;break}if((l|0)>=(d+3|0)){p=l;break}a=l;j=c[g>>2]|0;l=l+1|0;k=a}if((o|0)==6)if((n|0)>-1){c[(yI(c[g>>2]|0,4,n)|0)>>2]=b;EE(f);i=e;return}else p=m;if((p|0)<=-1){EE(f);i=e;return}c[(yI(c[g>>2]|0,4,p)|0)>>2]=b;EE(f);i=e;return}function bO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function cO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=357913941;r=(l|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2]}b=n+((((p|0)/-12|0)+o|0)*12|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*12|0);c[h>>2]=n+(m*12|0);if(!f){i=d;return}ACi(f);i=d;return}function dO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[86450]|0;if(!e){f=iJ(BI(CI(3496656)|0)|0,2258096,345808)|0;c[86450]=f;g=f}else g=e;e=qL(g)|0;g=c[b>>2]|0;switch(g|0){case 5:{h=12;j=10;break}case 6:{h=16;j=10;break}case 7:{h=23;j=10;break}case 4:{h=11;j=10;break}case 3:{h=6;j=10;break}case 2:case 1:case 0:{k=g;break}case 8:{h=26;j=10;break}default:{h=-1;j=10}}if((j|0)==10)k=h;if((g|0)==2){h=uI(c[101524]|0,8)|0;j=e+8|0;c[j>>2]=h;f=c[b+4>>2]|0;l=c[b+8>>2]|0;a[(yI(h,1,0)|0)>>0]=k;a[(yI(c[j>>2]|0,1,1)|0)>>0]=k>>>8;a[(yI(c[j>>2]|0,1,2)|0)>>0]=f>>>8;a[(yI(c[j>>2]|0,1,3)|0)>>0]=f;a[(yI(c[j>>2]|0,1,4)|0)>>0]=l>>>24;a[(yI(c[j>>2]|0,1,5)|0)>>0]=l>>>16;a[(yI(c[j>>2]|0,1,6)|0)>>0]=l>>>8;a[(yI(c[j>>2]|0,1,7)|0)>>0]=l;m=e;i=d;return m|0}else if((g|0)==1){g=b+4|0;b=SEi(g|0)|0;l=uI(c[101524]|0,b+3|0)|0;j=e+8|0;c[j>>2]=l;a[(yI(l,1,0)|0)>>0]=k;a[(yI(c[j>>2]|0,1,1)|0)>>0]=k>>>8;k=c[j>>2]|0;if((b|0)<0)n=k;else{l=k;k=0;while(1){f=yI(l,1,k+2|0)|0;a[f>>0]=a[g+k>>0]|0;f=c[j>>2]|0;if((k|0)==(b|0)){n=f;break}else{l=f;k=k+1|0}}}a[(yI(n,1,b+2|0)|0)>>0]=0;m=e;i=d;return m|0}else{m=0;i=d;return m|0}return 0}function eO(){var b=0,d=0,e=0,f=0;b=i;if(!(a[345792]|0)){AE(345784,0);a[345792]=1}BE(345784,0);d=zM()|0;e=IM(d)|0;if(!(e&128))if(!(e&2))if(!(e&1))f=(c[d+92>>2]|0)==0;else f=0;else f=1;else f=0;EE(345784);i=b;return f|0}function fO(a,b){a=a|0;b=b|0;return (c[a>>2]|0)-(c[b>>2]|0)|0}function gO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;Ij(0,0,348792)|0;g=a[348672]|0;h=(g&1)==0;if(h)j=(g&255)>>>1;else j=c[87169]|0;if(j){if(h)k=(g&255)>>>1;else k=c[87169]|0;gf(1,(h?348673|0:c[87170]|0)|0,k|0)|0}k=c[87216]|0;if(k>>>0<2>>>0){i=f;return}co[k&2047](b,d,e);i=f;return}function hO(a){a=a|0;return}function iO(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=h;if((Vh(0,21523,g|0)|0)==0?(g=(e[h+2>>1]|0)<<16|(e[h>>1]|0),(g|0)!=-1):0)c[87176]=g;g=c[87288]|0;if(g>>>0<2>>>0){i=f;return}co[g&2047](a,b,d);i=f;return}function jO(){var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+64|0;d=b;if(!(a[348856]|0)){i=b;return}e=a[348688]|0;f=(e&1)==0;if(f)g=(e&255)>>>1;else g=c[87173]|0;if(g){if(f)h=(e&255)>>>1;else h=c[87173]|0;gf(1,(f?348689:c[87174]|0)|0,h|0)|0}ce(0,0)|0;Ij(0,0,348728)|0;if(((Ue(0,d|0)|0)!=-1?(h=d+12|0,f=c[h>>2]|0,(f&8|0)==0):0)?(c[h>>2]=f|8,(Ij(0,0,d|0)|0)!=-1):0){f=348792;h=d+0|0;d=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(d|0))}a[348856]=0;i=b;return}function kO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+64|0;h=g+48|0;j=g+40|0;k=g+24|0;l=g+12|0;m=g;if(!(a[b>>0]&1))n=b+1|0;else n=c[b+8>>2]|0;o=Dm(n|0)|0;if(!o){c[f>>2]=UG(b,c[(xd()|0)>>2]|0)|0;p=0;i=g;return p|0}b=a[d>>0]|0;f=(b&1)==0;if(f)q=(b&255)>>>1;else q=c[d+4>>2]|0;if(q){c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;if(f)r=(b&255)>>>1;else r=c[d+4>>2]|0;Dri(k,r);r=a[d>>0]|0;if(!(r&1))s=(r&255)>>>1;else s=c[d+4>>2]|0;a:do if(s){b=d+1|0;f=d+8|0;q=r;n=0;while(1){if(n){t=q&1;u=c[f>>2]|0;v=t<<24>>24==0?b:u;if(!((a[v+n>>0]|0)==42?(a[v+(n+-1)>>0]|0)==42:0)){w=t;x=u;y=23}}else{w=q&1;x=c[f>>2]|0;y=23}if((y|0)==23){y=0;Cri(k,1,a[(w<<24>>24==0?b:x)+n>>0]|0)|0}u=n+1|0;if(u>>>0>=s>>>0)break a;q=a[d>>0]|0;n=u}}while(0);while(1){d=bf(o|0)|0;if(!d)break;s=d+11|0;rri(l,s,SEi(s|0)|0);sri(m,l);sri(h,m);s=RP(h,0,k,0)|0;xri(h);xri(m);if(s)lO(j,e,l);xri(l)}xri(k)}gi(o|0)|0;p=1;i=g;return p|0}function lO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=SP(d,g,e)|0;j=c[h>>2]|0;if(j){k=0;l=j;c[b>>2]=l;m=b+4|0;a[m>>0]=k;i=f;return}j=xCi(28)|0;sri(j+16|0,e);e=c[g>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=e;c[h>>2]=j;e=c[c[d>>2]>>2]|0;if(!e)n=j;else{c[d>>2]=e;n=c[h>>2]|0}GN(c[d+4>>2]|0,n);n=d+8|0;c[n>>2]=(c[n>>2]|0)+1;k=1;l=j;c[b>>2]=l;m=b+4|0;a[m>>0]=k;i=f;return}function mO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[j>>2]=c[d>>2];c[g+0>>2]=c[j+0>>2];j=TP(b,g,h,e)|0;g=c[j>>2]|0;if(g){k=g;c[a>>2]=k;i=f;return}g=xCi(28)|0;sri(g+16|0,e);e=c[h>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=e;c[j>>2]=g;e=c[c[b>>2]>>2]|0;if(!e)l=g;else{c[b>>2]=e;l=c[j>>2]|0}GN(c[b+4>>2]|0,l);l=b+8|0;c[l>>2]=(c[l>>2]|0)+1;k=g;c[a>>2]=k;i=f;return}function nO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=357913941;r=(l-j|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;r=n+(m*12|0)|0;if(!s){u=p;v=f}else{sri(s,b);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*12|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=u+-12|0;o=o+-12|0;sri(s,o);if((o|0)==(v|0)){z=s;break}else u=s}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-12|0;xri(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function oO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(!(a[b>>0]&1))g=b+1|0;else g=c[b+8>>2]|0;if((id(g|0,d|0)|0)==-1?(g=xd()|0,(c[g>>2]|0)==2):0){if(!(a[b>>0]&1))h=b+1|0;else h=c[b+8>>2]|0;if(zm(h|0,d|0)|0){j=UG(b,c[g>>2]|0)|0;i=f;return j|0}}if(!(a[b>>0]&1))k=b+1|0;else k=c[b+8>>2]|0;if(!(zm(k|0,e|0)|0)){j=0;i=f;return j|0}j=UG(b,c[(xd()|0)>>2]|0)|0;i=f;return j|0}function pO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;if((d|0)<8192)g=8192;else g=(d|0)>65536?65536:d;d=zCi((g|0)>-1?g:-1)|0;h=ml(a|0,d|0,g|0)|0;a:do if((h|0)>0){j=h;b:while(1){if((j|0)>0){k=d;l=j;while(1){while(1){m=gf(b|0,k|0,l|0)|0;if((m|0)>=0){n=m;break}m=xd()|0;if((c[m>>2]|0)!=4){o=m;break b}}l=l-n|0;if((l|0)<=0)break;else k=k+n|0}}k=ml(a|0,d|0,g|0)|0;if((k|0)>0)j=k;else{p=k;break a}}ACi(d);c[e>>2]=TG(c[o>>2]|0)|0;q=0;i=f;return q|0}else p=h;while(0);ACi(d);if((p|0)>=0){q=1;i=f;return q|0}c[e>>2]=TG(c[(xd()|0)>>2]|0)|0;q=0;i=f;return q|0}function qO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function rO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(b>>>0<128){f=c[d>>2]|0;Fri(f,b&255);g=f;c[a>>2]=g;i=e;return}if(b>>>0<2048){f=c[d>>2]|0;Fri(f,(b>>>6|192)&255);Fri(f,(b&63|128)&255);g=f;c[a>>2]=g;i=e;return}f=c[d>>2]|0;if(b>>>0<65536){Fri(f,(b>>>12|224)&255);Fri(f,(b>>>6&63|128)&255);Fri(f,(b&63|128)&255);g=f;c[a>>2]=g;i=e;return}else{Fri(f,(b>>>18|240)&255);Fri(f,(b>>>12&63|128)&255);Fri(f,(b>>>6&63|128)&255);Fri(f,(b&63|128)&255);g=f;c[a>>2]=g;i=e;return}}function sO(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;if(e>>>0>2147483631)ori(d);g=a[d>>0]|0;if(!(g&1)){h=4;j=g}else{g=c[d>>2]|0;h=(g&-2)+-1|0;j=g&255}if(!(j&1))k=(j&255)>>>1;else k=c[d+4>>2]|0;g=k>>>0>e>>>0?k:e;if(g>>>0<5)l=4;else l=(g+8&-8)+-1|0;if((l|0)==(h|0)){i=f;return}do if((l|0)!=4){g=(l<<1)+2|0;if(l>>>0>h>>>0)m=xCi(g)|0;else m=xCi(g)|0;if(!(j&1)){n=m;o=1;p=d+2|0;q=0;break}else{n=m;o=1;p=c[d+8>>2]|0;q=1;break}}else{n=d+2|0;o=0;p=c[d+8>>2]|0;q=1}while(0);if(!(j&1))r=(j&255)>>>1;else r=c[d+4>>2]|0;j=r+1|0;if(j){r=j;j=p;m=n;while(1){b[m>>1]=b[j>>1]|0;r=r+-1|0;if(!r)break;else{j=j+2|0;m=m+2|0}}}if(q)ACi(p);if(o){c[d>>2]=l+1|1;c[d+4>>2]=k;c[d+8>>2]=n;i=f;return}else{a[d>>0]=k<<1;i=f;return}}function tO(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=i;if(f>>>0<g>>>0)k=f;else{l=c[h>>2]|0;c[e>>2]=l;i=j;return}while(1){f=a[k>>0]|0;m=f&255;a:do if(f<<24>>24<=-1){do if((m&224|0)==192){n=k+1|0;o=n;p=(d[n>>0]|0)&63|m<<6&1984}else{if((m&240|0)==224){n=k+2|0;o=n;p=(d[k+1>>0]|0)<<6&4032|m<<12&61440|(d[n>>0]|0)&63;break}if((m&248|0)!=240){q=10;break a}n=k+3|0;o=n;p=(d[k+1>>0]|0)<<12&258048|m<<18&1835008|(d[k+2>>0]|0)<<6&4032|(d[n>>0]|0)&63}while(0);n=o+1|0;if(p>>>0>65535){r=c[h>>2]|0;s=(p>>>10)+55232&65535;t=a[r>>0]|0;u=(t&1)!=0;if(u){v=(c[r>>2]&-2)+-1|0;w=c[r+4>>2]|0}else{v=4;w=(t&255)>>>1}if((w|0)==(v|0)){UP(r,v,1,v,v,0,0);if(!(a[r>>0]&1))q=18;else q=19}else if(u)q=19;else q=18;if((q|0)==18){q=0;a[r>>0]=(w<<1)+2;x=r+2|0;y=w+1|0}else if((q|0)==19){q=0;u=c[r+8>>2]|0;t=w+1|0;c[r+4>>2]=t;x=u;y=t}b[x+(w<<1)>>1]=s;b[x+(y<<1)>>1]=0;s=(p&1023|56320)&65535;t=a[r>>0]|0;u=(t&1)!=0;if(u){z=(c[r>>2]&-2)+-1|0;A=c[r+4>>2]|0}else{z=4;A=(t&255)>>>1}if((A|0)==(z|0)){UP(r,z,1,z,z,0,0);if(!(a[r>>0]&1))q=26;else q=27}else if(u)q=27;else q=26;if((q|0)==26){q=0;a[r>>0]=(A<<1)+2;B=r+2|0;C=A+1|0}else if((q|0)==27){q=0;u=c[r+8>>2]|0;t=A+1|0;c[r+4>>2]=t;B=u;C=t}b[B+(A<<1)>>1]=s;b[B+(C<<1)>>1]=0;D=r;E=n}else{F=n;G=p;q=29}}else q=10;while(0);if((q|0)==10){q=0;F=k+1|0;G=m;q=29}if((q|0)==29){q=0;f=c[h>>2]|0;n=G&65535;r=a[f>>0]|0;s=(r&1)!=0;if(s){H=(c[f>>2]&-2)+-1|0;I=c[f+4>>2]|0}else{H=4;I=(r&255)>>>1}if((I|0)==(H|0)){UP(f,H,1,H,H,0,0);if(!(a[f>>0]&1))q=35;else q=36}else if(s)q=36;else q=35;if((q|0)==35){q=0;a[f>>0]=(I<<1)+2;J=f+2|0;K=I+1|0}else if((q|0)==36){q=0;s=c[f+8>>2]|0;r=I+1|0;c[f+4>>2]=r;J=s;K=r}b[J+(I<<1)>>1]=n;b[J+(K<<1)>>1]=0;D=f;E=F}if(E>>>0<g>>>0)k=E;else{l=D;break}}c[e>>2]=l;i=j;return}function uO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function vO(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=(c[b+116>>2]|0)>>>4;g=i;i=i+((4*(f+1|0)|0)+15&-16)|0;PEi(g|0,0,(f<<2)+4|0)|0;c[e>>2]=0;xO(b,g,e,0);if((c[101539]|0)==(b|0)){c[b+4>>2]=0;i=d;return}if(!(a[b+144>>0]|0)){c[b+4>>2]=Hs(g,(c[e>>2]|0)+1|0)|0;i=d;return}else{c[b+4>>2]=0;i=d;return}}function wO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;h=g+4|0;j=g;k=d+128|0;l=c[k>>2]|0;m=c[d+124>>2]|0;if((l|0)!=(m|0)){c[h>>2]=0;n=h+4|0;c[n>>2]=0;o=h+8|0;c[o>>2]=0;p=(l-m|0)/148|0;if((l|0)!=(m|0)){l=xCi(p<<2)|0;c[h>>2]=l;c[n>>2]=l;c[o>>2]=l+(p<<2)}a:do if(e){p=m;while(1){l=zJ(p,1,f)|0;c[j>>2]=l;if(!l)break;q=c[n>>2]|0;if((q|0)==(c[o>>2]|0))SN(h,j);else{if(!q)r=0;else{c[q>>2]=l;r=c[n>>2]|0}c[n>>2]=r+4}p=p+148|0;if((p|0)==(c[k>>2]|0)){s=20;break a}}FJ(OJ()|0)}else{p=m;while(1){l=zJ(p,0,f)|0;c[j>>2]=l;if(!l){t=1;u=b;break a}q=c[n>>2]|0;if((q|0)==(c[o>>2]|0))SN(h,j);else{if(!q)v=0;else{c[q>>2]=l;v=c[n>>2]|0}c[n>>2]=v+4}p=p+148|0;if((p|0)==(c[k>>2]|0)){s=20;break}}}while(0);do if((s|0)==20){if((c[(c[b+84>>2]|0)+16>>2]&2147483647|0)!=((c[n>>2]|0)-(c[h>>2]|0)>>2|0))FJ(JJ(3147344,369072)|0);k=d+24|0;v=a[k>>0]|0;j=(v&1)==0;if(j)w=(v&255)>>>1;else w=c[d+28>>2]|0;if(!w){v=rK()|0;o=BK(b,h)|0;if(o){t=0;u=o;break}if((v|0)==(sK()|0))x=0;else x=BK(b,h)|0}else{if(j)y=k+1|0;else y=c[d+32>>2]|0;k=CI(y)|0;j=(k|0)==0;v=e^1;if(!(j^1|v))FJ(OJ()|0);if(!j){j=(BI(k)|0)==0;if(!(j^1|v))FJ(OJ()|0);if(!j)x=BK(b,h)|0;else x=0}else x=0}j=(x|0)==0;if(j&e)FJ(OJ()|0);else{t=j;u=x}}while(0);x=c[h>>2]|0;if(x){h=c[n>>2]|0;if((h|0)!=(x|0))c[n>>2]=h+(~((h+-4-x|0)>>>2)<<2);ACi(x)}if(t){z=0;i=g;return z|0}else A=u}else A=b;if(!A){z=0;i=g;return z|0}RI(A)|0;z=A;i=g;return z|0}function xO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;h=g;if(!b){i=g;return}else j=b;while(1){b=j+24|0;k=0;a:while(1){if(!k){l=c[b>>2]|0;if(!l)break;m=c[l>>2]|0;if(!m)break;else{n=m;o=l}}else{l=k+4|0;m=c[l>>2]|0;if(!m)break;else{n=m;o=l}}l=n+4|0;m=c[l>>2]|0;if(c[m+4>>2]&272){k=o;continue}p=(c[n+12>>2]|0)+f|0;q=cN(m)|0;switch((c[q+4>>2]|0)>>>16&255|0){case 17:break;case 20:case 28:case 18:case 29:case 14:{m=p>>>2;r=d+(p>>>7<<2)|0;c[r>>2]=c[r>>2]|1<<(m&31);r=c[e>>2]|0;c[e>>2]=r>>>0<m>>>0?m:r;k=o;continue a;break}case 21:{if(!(fN(q)|0)){q=p>>>2;r=d+(p>>>7<<2)|0;c[r>>2]=c[r>>2]|1<<(q&31);r=c[e>>2]|0;c[e>>2]=r>>>0<q>>>0?q:r;k=o;continue a}break}case 27:case 15:case 13:case 12:case 25:case 24:case 11:case 10:case 9:case 8:case 3:case 7:case 6:case 2:case 5:case 4:{k=o;continue a;break}default:{c[h>>2]=369176;gl(406304,h|0)|0;k=o;continue a}}r=GI(c[l>>2]|0)|0;RI(r)|0;if(!(a[r+151>>0]|0)){k=o;continue}xO(r,d,e,p+-8|0);k=o}j=c[j+32>>2]|0;if(!j)break}i=g;return}function yO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=a[d>>0]|0;if(!(g&1)){h=SEi(e|0)|0;j=(g&255)>>>1;k=d+1|0}else{g=c[d+4>>2]|0;l=SEi(e|0)|0;h=l;j=g;k=c[d+8>>2]|0}Pri(b,k,j,h+j|0);Gri(b,e,h)|0;i=f;return}function zO(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0.0,x=0,y=0;k=i;l=d+4|0;m=c[l>>2]|0;if(m&1073741824){c[e>>2]=f;i=k;return}n=m;a:while(1){switch(n>>>16&255|0){case 11:case 10:{o=14;break a;break}case 13:{o=20;break a;break}case 17:{if((c[l>>2]&16711680|0)!=1114112){o=33;break a}m=c[d>>2]|0;if(!(a[m+149>>0]|0)){o=33;break a}p=NI(m)|0;break}case 5:case 4:case 2:{o=5;break a;break}case 12:{o=17;break a;break}case 15:case 27:{o=26;break a;break}case 3:case 7:case 6:{o=8;break a;break}case 9:case 8:{o=11;break a;break}case 20:case 28:case 18:case 29:case 14:{o=23;break a;break}case 21:{p=c[(c[c[d>>2]>>2]|0)+64>>2]|0;break}default:{o=37;break a}}n=c[p+4>>2]|0}switch(o|0){case 5:{if(!f)q=0;else q=a[f>>0]|0;a[e>>0]=q;i=k;return}case 8:{if(!f)r=0;else r=b[f>>1]|0;b[e>>1]=r;i=k;return}case 11:{if(!f)s=0;else s=c[f>>2]|0;c[e>>2]=s;i=k;return}case 14:{if(!f){t=0;u=0}else{s=f;t=c[s>>2]|0;u=c[s+4>>2]|0}s=e;c[s>>2]=t;c[s+4>>2]=u;i=k;return}case 17:{if(!f)v=ea(0.0);else v=ea(g[f>>2]);g[e>>2]=v;i=k;return}case 20:{if(!f)w=0.0;else w=+h[f>>3];h[e>>3]=w;i=k;return}case 23:{if(j)x=c[f>>2]|0;else x=f;c[e>>2]=x;i=k;return}case 26:{if(j)y=c[f>>2]|0;else y=f;c[e>>2]=y;i=k;return}case 33:{y=$I(GI(d)|0,0)|0;if(!f){PEi(e|0,0,y|0)|0;i=k;return}else{YEi(e|0,f|0,y|0)|0;i=k;return}break}case 37:{i=k;return}}}function AO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=a[e>>0]|0;k=(j&1)==0;l=(j&255)>>>1;j=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(k){f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=o+1|0}else{q=c[f+20>>2]|0;r=c[f+24>>2]|0}o=FEi(r,j,l>>>0<q>>>0?l:q)|0;if(!o){if(q>>>0>=l>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}else{f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){u=(p&255)>>>1;v=o+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}o=FEi(v,m,n>>>0<u>>>0?n:u)|0;if(!o){if(u>>>0>=n>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}while(0);g=c[s>>2]|0;if(!g){h=s;t=19;break}else e=s}if((t|0)==19){c[b>>2]=h;i=d;return}}function BO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=VP(a,e,b)|0;g=c[f>>2]|0;if(g){h=g;j=h+28|0;i=d;return j|0}g=xCi(32)|0;sri(g+16|0,b);c[g+28>>2]=0;b=c[e>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=b;c[f>>2]=g;b=c[c[a>>2]>>2]|0;if(!b)k=g;else{c[a>>2]=b;k=c[f>>2]|0}GN(c[a+4>>2]|0,k);k=a+8|0;c[k>>2]=(c[k>>2]|0)+1;h=g;j=h+28|0;i=d;return j|0}function CO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function DO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;f=c[b>>2]|0;g=c[f>>2]|0;h=g>>>3;j=c[a+4>>2]|0;a:do if(j){k=j+-1|0;l=(k&j|0)==0;if(l)m=k&h;else m=(h>>>0)%(j>>>0)|0;n=c[(c[a>>2]|0)+(m<<2)>>2]|0;if((n|0)!=0?(o=c[n>>2]|0,(o|0)!=0):0){n=f+4|0;b:do if(l){p=o;while(1){if((c[p+4>>2]&k|0)!=(m|0))break a;q=c[p+8>>2]|0;if((c[q>>2]|0)==(g|0)?(c[q+4>>2]|0)==(c[n>>2]|0):0){r=p;break b}p=c[p>>2]|0;if(!p)break a}}else{p=o;while(1){if((((c[p+4>>2]|0)>>>0)%(j>>>0)|0|0)!=(m|0))break a;q=c[p+8>>2]|0;if((c[q>>2]|0)==(g|0)?(c[q+4>>2]|0)==(c[n>>2]|0):0){r=p;break b}p=c[p>>2]|0;if(!p)break a}}while(0);if(r){s=r;t=s+12|0;i=d;return t|0}}}while(0);r=Ks(16,0)|0;c[r+8>>2]=c[b>>2];c[r+12>>2]=0;WP(e,a,r);s=c[e>>2]|0;t=s+12|0;i=d;return t|0}function EO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b+4>>2]|0;f=e>>>16&255;g=f|e>>>24&64;switch(f|0){case 21:{f=c[b>>2]|0;e=c[f+4>>2]|0;h=((iI(c[(c[f>>2]|0)+8>>2]|0)|0)+g|0)*13|0;if(!(c[e>>2]|0)){j=h;i=d;return j|0}f=e+4|0;k=h;h=0;while(1){l=((EO(a,c[(c[f>>2]|0)+(h<<2)>>2]|0)|0)+k|0)*13|0;h=h+1|0;if(h>>>0>=(c[e>>2]|0)>>>0){j=l;break}else k=l}i=d;return j|0}case 15:{k=(EO(a,c[b>>2]|0)|0)^g*31;i=d;return k|0}case 29:case 18:case 17:{j=(iI(c[(c[b>>2]|0)+8>>2]|0)|0)^g*31;i=d;return j|0}default:{j=g;i=d;return j|0}}return 0}function FO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=EO(a+12|0,c[b>>2]|0)|0;g=c[a+4>>2]|0;a:do if(g){h=g+-1|0;j=(h&g|0)==0;if(j)k=h&f;else k=(f>>>0)%(g>>>0)|0;l=c[(c[a>>2]|0)+(k<<2)>>2]|0;if(l){m=a+16|0;n=l;while(1){l=c[n>>2]|0;if(!l)break a;o=c[l+4>>2]|0;if(j)p=o&h;else p=(o>>>0)%(g>>>0)|0;if((p|0)!=(k|0))break a;if(oK(m,c[l+8>>2]|0,c[b>>2]|0)|0){q=l;break}else n=l}r=q+12|0;i=d;return r|0}}while(0);k=xCi(16)|0;c[k+8>>2]=c[b>>2];c[k+12>>2]=0;XP(e,a,k);q=c[e>>2]|0;r=q+12|0;i=d;return r|0}function GO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[d>>2]|0;g=c[b+4>>2]|0;a:do if(g){h=g+-1|0;j=(h&g|0)==0;if(j)k=h&f;else k=(f>>>0)%(g>>>0)|0;l=c[(c[b>>2]|0)+(k<<2)>>2]|0;if((l|0)!=0?(m=c[l>>2]|0,(m|0)!=0):0){l=c[d+4>>2]|0;b:do if(j){n=m;while(1){if((c[n+4>>2]&h|0)!=(k|0))break a;if((c[n+8>>2]|0)==(f|0)?(FEi(c[n+12>>2]|0,l,f<<1)|0)==0:0){o=n;break b}n=c[n>>2]|0;if(!n)break a}}else{n=m;while(1){if((((c[n+4>>2]|0)>>>0)%(g>>>0)|0|0)!=(k|0))break a;if((c[n+8>>2]|0)==(f|0)?(FEi(c[n+12>>2]|0,l,f<<1)|0)==0:0){o=n;break b}n=c[n>>2]|0;if(!n)break a}}while(0);c[a>>2]=o;i=e;return}}while(0);c[a>>2]=0;i=e;return}function HO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0;f=i;h=c[e+8>>2]|0;j=e+4|0;c[j>>2]=h;k=d+4|0;l=c[k>>2]|0;m=(l|0)==0;a:do if(!m){n=l+-1|0;o=(n&l|0)==0;if(o)p=n&h;else p=(h>>>0)%(l>>>0)|0;q=c[(c[d>>2]|0)+(p<<2)>>2]|0;if((q|0)!=0?(r=c[q>>2]|0,(r|0)!=0):0){q=e+12|0;if(o){o=r;while(1){if((c[o+4>>2]&n|0)!=(p|0)){s=p;break a}if((c[o+8>>2]|0)==(h|0)?(FEi(c[o+12>>2]|0,c[q>>2]|0,h<<1)|0)==0:0){t=0;u=o;break}o=c[o>>2]|0;if(!o){s=p;break a}}c[b>>2]=u;v=b+4|0;a[v>>0]=t;i=f;return}else{o=r;while(1){if((((c[o+4>>2]|0)>>>0)%(l>>>0)|0|0)!=(p|0)){s=p;break a}if((c[o+8>>2]|0)==(h|0)?(FEi(c[o+12>>2]|0,c[q>>2]|0,h<<1)|0)==0:0){t=0;u=o;break}o=c[o>>2]|0;if(!o){s=p;break a}}c[b>>2]=u;v=b+4|0;a[v>>0]=t;i=f;return}}else s=p}else s=0;while(0);p=d+12|0;w=ea(((c[p>>2]|0)+1|0)>>>0);x=ea(l>>>0);y=ea(g[d+16>>2]);do if(w>ea(x*y)|m){if(l>>>0>2)z=(l+-1&l|0)==0;else z=0;h=(z&1|l<<1)^1;o=~~ea(ca(ea(w/y)))>>>0;YP(d,h>>>0<o>>>0?o:h);h=c[k>>2]|0;o=c[j>>2]|0;q=h+-1|0;if(!(q&h)){A=h;B=q&o;break}else{A=h;B=(o>>>0)%(h>>>0)|0;break}}else{A=l;B=s}while(0);s=c[(c[d>>2]|0)+(B<<2)>>2]|0;if(!s){l=d+8|0;c[e>>2]=c[l>>2];c[l>>2]=e;c[(c[d>>2]|0)+(B<<2)>>2]=l;l=c[e>>2]|0;if(l){B=c[l+4>>2]|0;l=A+-1|0;if(!(l&A))C=B&l;else C=(B>>>0)%(A>>>0)|0;c[(c[d>>2]|0)+(C<<2)>>2]=e}}else{c[e>>2]=c[s>>2];c[s>>2]=e}c[p>>2]=(c[p>>2]|0)+1;t=1;u=e;c[b>>2]=u;v=b+4|0;a[v>>0]=t;i=f;return}function IO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function JO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function KO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=(c[g>>2]|0)-(c[b>>2]|0)|0;j=h>>2;if(!j){i=d;return}if(j>>>0>1073741823)vxi(a);k=xCi(h)|0;c[e>>2]=k;c[a>>2]=k;c[f>>2]=k+(j<<2);j=c[b>>2]|0;b=c[g>>2]|0;if((j|0)==(b|0)){i=d;return}else{l=j;m=k}do{c[m>>2]=c[l>>2];m=(c[e>>2]|0)+4|0;c[e>>2]=m;l=l+4|0}while((l|0)!=(b|0));i=d;return}function LO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((((c[e>>2]|0)-g|0)/148|0)>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b*148|0)|0;l=k+(((j-g|0)/148|0)*148|0)|0;g=k+(b*148|0)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=j+-148|0;b=b+-148|0;MO(k,b);if((b|0)==(f|0)){p=k;break}else j=k}m=p;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-148|0;ZM(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function MO(a,b){a=a|0;b=b|0;var c=0;c=i;sri(a,b);sri(a+12|0,b+12|0);ZP(a+24|0,b+24|0);_P(a+112|0,b+112|0);$P(a+124|0,b+124|0);aQ(a+136|0,b+136|0);i=c;return}function NO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/148|0)+1|0;if(g>>>0>29020049)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/148|0;if(k>>>0<14510024){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/148|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=29020049;r=(l-j|0)/148|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*148|0)|0;o=r;p=s}s=n+(o*148|0)|0;r=n+(m*148|0)|0;if(!s){u=p;v=f}else{MO(s,b);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*148|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=u+-148|0;o=o+-148|0;MO(s,o);if((o|0)==(v|0)){z=s;break}else u=s}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-148|0;ZM(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function OO(a){a=a|0;var b=0;b=i;xri(a+36|0);xri(a+24|0);xri(a+12|0);xri(a);i=b;return}function PO(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=406492;c[a+56>>2]=406512;d=a+4|0;c[d>>2]=74048;xri(a+36|0);gsi(d);bsi(a+56|0);i=b;return}function QO(a){a=a|0;var d=0,e=0;d=i;e=0;do{b[a+(e<<2)+148>>1]=0;e=e+1|0}while((e|0)!=286);b[a+2440>>1]=0;b[a+2444>>1]=0;b[a+2448>>1]=0;b[a+2452>>1]=0;b[a+2456>>1]=0;b[a+2460>>1]=0;b[a+2464>>1]=0;b[a+2468>>1]=0;b[a+2472>>1]=0;b[a+2476>>1]=0;b[a+2480>>1]=0;b[a+2484>>1]=0;b[a+2488>>1]=0;b[a+2492>>1]=0;b[a+2496>>1]=0;b[a+2500>>1]=0;b[a+2504>>1]=0;b[a+2508>>1]=0;b[a+2512>>1]=0;b[a+2516>>1]=0;b[a+2520>>1]=0;b[a+2524>>1]=0;b[a+2528>>1]=0;b[a+2532>>1]=0;b[a+2536>>1]=0;b[a+2540>>1]=0;b[a+2544>>1]=0;b[a+2548>>1]=0;b[a+2552>>1]=0;b[a+2556>>1]=0;b[a+2684>>1]=0;b[a+2688>>1]=0;b[a+2692>>1]=0;b[a+2696>>1]=0;b[a+2700>>1]=0;b[a+2704>>1]=0;b[a+2708>>1]=0;b[a+2712>>1]=0;b[a+2716>>1]=0;b[a+2720>>1]=0;b[a+2724>>1]=0;b[a+2728>>1]=0;b[a+2732>>1]=0;b[a+2736>>1]=0;b[a+2740>>1]=0;b[a+2744>>1]=0;b[a+2748>>1]=0;b[a+2752>>1]=0;b[a+2756>>1]=0;b[a+1172>>1]=1;c[a+5804>>2]=0;c[a+5800>>2]=0;c[a+5808>>2]=0;c[a+5792>>2]=0;i=d;return}function RO(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;h=i;i=i+32|0;j=h;k=c[g>>2]|0;l=g+8|0;m=c[l>>2]|0;n=c[m>>2]|0;o=c[m+12>>2]|0;m=f+5200|0;c[m>>2]=0;p=f+5204|0;c[p>>2]=573;if((o|0)>0){q=-1;r=0;while(1){if(!(b[k+(r<<2)>>1]|0)){b[k+(r<<2)+2>>1]=0;s=q}else{t=(c[m>>2]|0)+1|0;c[m>>2]=t;c[f+(t<<2)+2908>>2]=r;a[f+r+5208>>0]=0;s=r}r=r+1|0;if((r|0)==(o|0)){u=s;break}else q=s}s=c[m>>2]|0;if((s|0)<2){v=s;w=u;x=3}else{y=s;z=u}}else{v=0;w=-1;x=3}if((x|0)==3){x=f+5800|0;u=f+5804|0;if(!n){s=v;q=w;while(1){r=(q|0)<2;t=q+1|0;A=r?t:q;B=r?t:0;t=s+1|0;c[m>>2]=t;c[f+(t<<2)+2908>>2]=B;b[k+(B<<2)>>1]=1;a[f+B+5208>>0]=0;c[x>>2]=(c[x>>2]|0)+-1;B=c[m>>2]|0;if((B|0)<2){s=B;q=A}else{y=B;z=A;break}}}else{q=v;v=w;while(1){w=(v|0)<2;s=v+1|0;A=w?s:v;B=w?s:0;s=q+1|0;c[m>>2]=s;c[f+(s<<2)+2908>>2]=B;b[k+(B<<2)>>1]=1;a[f+B+5208>>0]=0;c[x>>2]=(c[x>>2]|0)+-1;c[u>>2]=(c[u>>2]|0)-(e[n+(B<<2)+2>>1]|0);B=c[m>>2]|0;if((B|0)<2){q=B;v=A}else{y=B;z=A;break}}}}v=g+4|0;c[v>>2]=z;q=y;n=(y|0)/2|0;while(1){y=c[f+(n<<2)+2908>>2]|0;u=f+y+5208|0;x=n<<1;a:do if((x|0)>(q|0))C=n;else{A=k+(y<<2)|0;B=n;s=q;w=x;while(1){do if((w|0)<(s|0)){t=w|1;r=c[f+(t<<2)+2908>>2]|0;D=b[k+(r<<2)>>1]|0;E=c[f+(w<<2)+2908>>2]|0;F=b[k+(E<<2)>>1]|0;if((D&65535)>=(F&65535)){if(D<<16>>16!=F<<16>>16){G=w;break}if((d[f+r+5208>>0]|0)>(d[f+E+5208>>0]|0)){G=w;break}}G=t}else G=w;while(0);t=b[A>>1]|0;E=c[f+(G<<2)+2908>>2]|0;r=b[k+(E<<2)>>1]|0;if((t&65535)<(r&65535)){C=B;break a}if(t<<16>>16==r<<16>>16?(d[u>>0]|0)<=(d[f+E+5208>>0]|0):0){C=B;break a}c[f+(B<<2)+2908>>2]=E;w=G<<1;s=c[m>>2]|0;if((w|0)>(s|0)){C=G;break}else B=G}}while(0);c[f+(C<<2)+2908>>2]=y;n=n+-1|0;u=c[m>>2]|0;if((n|0)<=0){H=u;break}else q=u}q=f+2912|0;n=H;H=o;do{o=c[q>>2]|0;C=n+-1|0;c[m>>2]=C;G=c[f+(n<<2)+2908>>2]|0;c[q>>2]=G;u=f+G+5208|0;b:do if((n|0)<3)I=1;else{x=k+(G<<2)|0;B=1;s=C;w=2;while(1){do if((w|0)<(s|0)){A=w|1;E=c[f+(A<<2)+2908>>2]|0;r=b[k+(E<<2)>>1]|0;t=c[f+(w<<2)+2908>>2]|0;F=b[k+(t<<2)>>1]|0;if((r&65535)>=(F&65535)){if(r<<16>>16!=F<<16>>16){J=w;break}if((d[f+E+5208>>0]|0)>(d[f+t+5208>>0]|0)){J=w;break}}J=A}else J=w;while(0);A=b[x>>1]|0;t=c[f+(J<<2)+2908>>2]|0;E=b[k+(t<<2)>>1]|0;if((A&65535)<(E&65535)){I=B;break b}if(A<<16>>16==E<<16>>16?(d[u>>0]|0)<=(d[f+t+5208>>0]|0):0){I=B;break b}c[f+(B<<2)+2908>>2]=t;w=J<<1;s=c[m>>2]|0;if((w|0)>(s|0)){I=J;break}else B=J}}while(0);c[f+(I<<2)+2908>>2]=G;u=c[q>>2]|0;C=(c[p>>2]|0)+-1|0;c[p>>2]=C;c[f+(C<<2)+2908>>2]=o;C=(c[p>>2]|0)+-1|0;c[p>>2]=C;c[f+(C<<2)+2908>>2]=u;C=k+(H<<2)|0;b[C>>1]=(e[k+(u<<2)>>1]|0)+(e[k+(o<<2)>>1]|0);y=a[f+o+5208>>0]|0;B=a[f+u+5208>>0]|0;s=f+H+5208|0;a[s>>0]=(((y&255)<(B&255)?B:y)&255)+1;y=H&65535;b[k+(u<<2)+2>>1]=y;b[k+(o<<2)+2>>1]=y;c[q>>2]=H;y=c[m>>2]|0;c:do if((y|0)<2)K=1;else{u=1;B=y;w=2;while(1){do if((w|0)<(B|0)){x=w|1;t=c[f+(x<<2)+2908>>2]|0;E=b[k+(t<<2)>>1]|0;A=c[f+(w<<2)+2908>>2]|0;F=b[k+(A<<2)>>1]|0;if((E&65535)>=(F&65535)){if(E<<16>>16!=F<<16>>16){L=w;break}if((d[f+t+5208>>0]|0)>(d[f+A+5208>>0]|0)){L=w;break}}L=x}else L=w;while(0);x=b[C>>1]|0;A=c[f+(L<<2)+2908>>2]|0;t=b[k+(A<<2)>>1]|0;if((x&65535)<(t&65535)){K=u;break c}if(x<<16>>16==t<<16>>16?(d[s>>0]|0)<=(d[f+A+5208>>0]|0):0){K=u;break c}c[f+(u<<2)+2908>>2]=A;w=L<<1;B=c[m>>2]|0;if((w|0)>(B|0)){K=L;break}else u=L}}while(0);c[f+(K<<2)+2908>>2]=H;H=H+1|0;n=c[m>>2]|0}while((n|0)>1);n=c[q>>2]|0;q=(c[p>>2]|0)+-1|0;c[p>>2]=q;c[f+(q<<2)+2908>>2]=n;n=c[g>>2]|0;g=c[v>>2]|0;v=c[l>>2]|0;l=c[v>>2]|0;q=c[v+4>>2]|0;m=c[v+8>>2]|0;H=c[v+16>>2]|0;v=f+2876|0;K=v+32|0;do{b[v>>1]=0;v=v+2|0}while((v|0)<(K|0));v=c[p>>2]|0;b[n+(c[f+(v<<2)+2908>>2]<<2)+2>>1]=0;p=v+1|0;d:do if((p|0)<573){v=f+5800|0;K=f+5804|0;if(!l){L=p;I=0;while(1){J=c[f+(L<<2)+2908>>2]|0;s=n+(J<<2)+2|0;C=e[n+(e[s>>1]<<2)+2>>1]|0;y=(C|0)<(H|0);o=y?C+1|0:H;C=(y&1^1)+I|0;b[s>>1]=o;if((J|0)<=(g|0)){s=f+(o<<1)+2876|0;b[s>>1]=(b[s>>1]|0)+1<<16>>16;if((J|0)<(m|0))M=0;else M=c[q+(J-m<<2)>>2]|0;s=da(e[n+(J<<2)>>1]|0,M+o|0)|0;c[v>>2]=s+(c[v>>2]|0)}L=L+1|0;if((L|0)==573){N=C;break}else I=C}}else{I=p;L=0;while(1){C=c[f+(I<<2)+2908>>2]|0;s=n+(C<<2)+2|0;o=e[n+(e[s>>1]<<2)+2>>1]|0;J=(o|0)<(H|0);y=J?o+1|0:H;o=(J&1^1)+L|0;b[s>>1]=y;if((C|0)<=(g|0)){s=f+(y<<1)+2876|0;b[s>>1]=(b[s>>1]|0)+1<<16>>16;if((C|0)<(m|0))O=0;else O=c[q+(C-m<<2)>>2]|0;s=e[n+(C<<2)>>1]|0;J=da(s,O+y|0)|0;c[v>>2]=J+(c[v>>2]|0);J=da((e[l+(C<<2)+2>>1]|0)+O|0,s)|0;c[K>>2]=J+(c[K>>2]|0)}I=I+1|0;if((I|0)==573){N=o;break}else L=o}}if(N){L=f+(H<<1)+2876|0;I=N;do{K=H;while(1){o=K+-1|0;J=f+(o<<1)+2876|0;s=b[J>>1]|0;if(!(s<<16>>16))K=o;else{P=J;Q=s;R=K;break}}b[P>>1]=Q+-1<<16>>16;K=f+(R<<1)+2876|0;b[K>>1]=(e[K>>1]|0)+2;K=(b[L>>1]|0)+-1<<16>>16;b[L>>1]=K;I=I+-2|0}while((I|0)>0);S=K;if(H){I=S;L=H;K=573;while(1){s=L&65535;if(!(I<<16>>16))T=K;else{J=K;o=I&65535;while(1){C=J;while(1){y=C+-1|0;G=c[f+(y<<2)+2908>>2]|0;if((G|0)>(g|0))C=y;else{U=y;V=G;break}}C=n+(V<<2)+2|0;G=e[C>>1]|0;if((L|0)!=(G|0)){y=da(e[n+(V<<2)>>1]|0,L-G|0)|0;c[v>>2]=y+(c[v>>2]|0);b[C>>1]=s}o=o+-1|0;if(!o){T=U;break}else J=U}}J=L+-1|0;if(!J)break d;I=b[f+(J<<1)+2876>>1]|0;L=J;K=T}}}}while(0);T=1;U=0;do{U=(e[f+(T+-1<<1)+2876>>1]|0)+(U&65534)<<1;b[j+(T<<1)>>1]=U;T=T+1|0}while((T|0)!=16);if((z|0)<0){i=h;return}else W=0;while(1){T=b[k+(W<<2)+2>>1]|0;U=T&65535;if(T<<16>>16){T=j+(U<<1)|0;f=b[T>>1]|0;b[T>>1]=f+1<<16>>16;T=U;U=f&65535;f=0;while(1){V=f|U&1;T=T+-1|0;if((T|0)<=0){X=V;break}else{U=U>>>1;f=V<<1}}b[k+(W<<2)>>1]=X}if((W|0)==(z|0))break;else W=W+1|0}i=h;return}function SO(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;j=i;k=f+5792|0;if(!(c[k>>2]|0)){l=c[f+5820>>2]|0;m=b[f+5816>>1]|0}else{n=f+5796|0;o=f+5784|0;p=f+5820|0;q=f+5816|0;r=f+20|0;s=f+8|0;t=0;do{u=b[(c[n>>2]|0)+(t<<1)>>1]|0;v=u&65535;w=d[(c[o>>2]|0)+t>>0]|0;t=t+1|0;do if(!(u<<16>>16)){x=e[g+(w<<2)+2>>1]|0;y=c[p>>2]|0;z=e[g+(w<<2)>>1]|0;A=e[q>>1]|0|z<<y;B=A&65535;b[q>>1]=B;if((y|0)>(16-x|0)){C=c[r>>2]|0;c[r>>2]=C+1;a[(c[s>>2]|0)+C>>0]=A;A=(e[q>>1]|0)>>>8&255;C=c[r>>2]|0;c[r>>2]=C+1;a[(c[s>>2]|0)+C>>0]=A;A=c[p>>2]|0;C=z>>>(16-A|0)&65535;b[q>>1]=C;z=x+-16+A|0;c[p>>2]=z;D=C;E=z;break}else{z=y+x|0;c[p>>2]=z;D=B;E=z;break}}else{z=d[415400+w>>0]|0;B=(z|256)+1|0;x=e[g+(B<<2)+2>>1]|0;y=c[p>>2]|0;C=e[g+(B<<2)>>1]|0;B=e[q>>1]|0|C<<y;A=B&65535;b[q>>1]=A;if((y|0)>(16-x|0)){F=c[r>>2]|0;c[r>>2]=F+1;a[(c[s>>2]|0)+F>>0]=B;B=(e[q>>1]|0)>>>8&255;F=c[r>>2]|0;c[r>>2]=F+1;a[(c[s>>2]|0)+F>>0]=B;B=c[p>>2]|0;F=C>>>(16-B|0)&65535;b[q>>1]=F;G=F;H=x+-16+B|0}else{G=A;H=y+x|0}c[p>>2]=H;x=c[417e3+(z<<2)>>2]|0;do if((z+-8|0)>>>0<20){y=w-(c[417120+(z<<2)>>2]|0)|0;A=G&65535|y<<H;B=A&65535;b[q>>1]=B;if((H|0)>(16-x|0)){F=c[r>>2]|0;c[r>>2]=F+1;a[(c[s>>2]|0)+F>>0]=A;A=(e[q>>1]|0)>>>8&255;F=c[r>>2]|0;c[r>>2]=F+1;a[(c[s>>2]|0)+F>>0]=A;A=c[p>>2]|0;F=(y&65535)>>>(16-A|0)&65535;b[q>>1]=F;y=x+-16+A|0;c[p>>2]=y;I=y;J=F;break}else{F=H+x|0;c[p>>2]=F;I=F;J=B;break}}else{I=H;J=G}while(0);x=v+-1|0;if(x>>>0<256)K=x;else K=(x>>>7)+256|0;z=d[414888+K>>0]|0;B=e[h+(z<<2)+2>>1]|0;F=e[h+(z<<2)>>1]|0;y=J&65535|F<<I;A=y&65535;b[q>>1]=A;if((I|0)>(16-B|0)){C=c[r>>2]|0;c[r>>2]=C+1;a[(c[s>>2]|0)+C>>0]=y;y=(e[q>>1]|0)>>>8&255;C=c[r>>2]|0;c[r>>2]=C+1;a[(c[s>>2]|0)+C>>0]=y;y=c[p>>2]|0;C=F>>>(16-y|0)&65535;b[q>>1]=C;L=B+-16+y|0;M=C}else{L=I+B|0;M=A}c[p>>2]=L;A=c[417240+(z<<2)>>2]|0;if((z+-4|0)>>>0<26){B=x-(c[417360+(z<<2)>>2]|0)|0;z=M&65535|B<<L;x=z&65535;b[q>>1]=x;if((L|0)>(16-A|0)){C=c[r>>2]|0;c[r>>2]=C+1;a[(c[s>>2]|0)+C>>0]=z;z=(e[q>>1]|0)>>>8&255;C=c[r>>2]|0;c[r>>2]=C+1;a[(c[s>>2]|0)+C>>0]=z;z=c[p>>2]|0;C=(B&65535)>>>(16-z|0)&65535;b[q>>1]=C;B=A+-16+z|0;c[p>>2]=B;D=C;E=B;break}else{B=L+A|0;c[p>>2]=B;D=x;E=B;break}}else{D=M;E=L}}while(0)}while(t>>>0<(c[k>>2]|0)>>>0);l=E;m=D}D=g+1026|0;E=e[D>>1]|0;k=f+5820|0;t=e[g+1024>>1]|0;g=f+5816|0;L=m&65535|t<<l;b[g>>1]=L;if((l|0)>(16-E|0)){m=f+20|0;M=c[m>>2]|0;c[m>>2]=M+1;p=f+8|0;a[(c[p>>2]|0)+M>>0]=L;L=(e[g>>1]|0)>>>8&255;M=c[m>>2]|0;c[m>>2]=M+1;a[(c[p>>2]|0)+M>>0]=L;L=c[k>>2]|0;b[g>>1]=t>>>(16-L|0);N=E+-16+L|0;c[k>>2]=N;O=b[D>>1]|0;P=O&65535;Q=f+5812|0;c[Q>>2]=P;i=j;return}else{N=l+E|0;c[k>>2]=N;O=b[D>>1]|0;P=O&65535;Q=f+5812|0;c[Q>>2]=P;i=j;return}}function TO(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;h=i;j=b[f+2>>1]|0;k=j<<16>>16==0;l=d+2754|0;m=d+5820|0;n=d+2752|0;o=d+5816|0;p=d+20|0;q=d+8|0;r=d+2758|0;s=d+2756|0;t=d+2750|0;u=d+2748|0;v=k?138:7;w=k?3:4;k=0;x=j&65535;j=-1;a:while(1){y=0;z=k;while(1){if((z|0)>(g|0))break a;A=z+1|0;B=b[f+(A<<2)+2>>1]|0;C=B&65535;D=y+1|0;E=(x|0)==(C|0);if((D|0)<(v|0)&E){y=D;z=A}else{F=A;G=B;H=C;I=D;J=E;K=y;break}}do if((I|0)>=(w|0)){if(x){if((x|0)==(j|0)){L=b[o>>1]|0;M=c[m>>2]|0;N=I}else{y=e[d+(x<<2)+2686>>1]|0;z=c[m>>2]|0;E=e[d+(x<<2)+2684>>1]|0;D=e[o>>1]|0|E<<z;C=D&65535;b[o>>1]=C;if((z|0)>(16-y|0)){B=c[p>>2]|0;c[p>>2]=B+1;a[(c[q>>2]|0)+B>>0]=D;D=(e[o>>1]|0)>>>8&255;B=c[p>>2]|0;c[p>>2]=B+1;a[(c[q>>2]|0)+B>>0]=D;D=c[m>>2]|0;B=E>>>(16-D|0)&65535;b[o>>1]=B;O=B;P=y+-16+D|0}else{O=C;P=z+y|0}c[m>>2]=P;L=O;M=P;N=K}y=e[t>>1]|0;z=e[u>>1]|0;C=L&65535|z<<M;b[o>>1]=C;if((M|0)>(16-y|0)){D=c[p>>2]|0;c[p>>2]=D+1;a[(c[q>>2]|0)+D>>0]=C;D=(e[o>>1]|0)>>>8&255;B=c[p>>2]|0;c[p>>2]=B+1;a[(c[q>>2]|0)+B>>0]=D;D=c[m>>2]|0;B=z>>>(16-D|0);b[o>>1]=B;Q=y+-16+D|0;R=B}else{Q=M+y|0;R=C}c[m>>2]=Q;C=N+-3|0;y=R&65535|C<<Q;b[o>>1]=y;if((Q|0)>14){B=c[p>>2]|0;c[p>>2]=B+1;a[(c[q>>2]|0)+B>>0]=y;y=(e[o>>1]|0)>>>8&255;B=c[p>>2]|0;c[p>>2]=B+1;a[(c[q>>2]|0)+B>>0]=y;y=c[m>>2]|0;b[o>>1]=(C&65535)>>>(16-y|0);c[m>>2]=y+-14;break}else{c[m>>2]=Q+2;break}}if((I|0)<11){y=e[l>>1]|0;C=c[m>>2]|0;B=e[n>>1]|0;D=e[o>>1]|0|B<<C;b[o>>1]=D;if((C|0)>(16-y|0)){z=c[p>>2]|0;c[p>>2]=z+1;a[(c[q>>2]|0)+z>>0]=D;z=(e[o>>1]|0)>>>8&255;E=c[p>>2]|0;c[p>>2]=E+1;a[(c[q>>2]|0)+E>>0]=z;z=c[m>>2]|0;E=B>>>(16-z|0);b[o>>1]=E;S=y+-16+z|0;T=E}else{S=C+y|0;T=D}c[m>>2]=S;D=K+-2|0;y=T&65535|D<<S;b[o>>1]=y;if((S|0)>13){C=c[p>>2]|0;c[p>>2]=C+1;a[(c[q>>2]|0)+C>>0]=y;y=(e[o>>1]|0)>>>8&255;C=c[p>>2]|0;c[p>>2]=C+1;a[(c[q>>2]|0)+C>>0]=y;y=c[m>>2]|0;b[o>>1]=(D&65535)>>>(16-y|0);c[m>>2]=y+-13;break}else{c[m>>2]=S+3;break}}else{y=e[r>>1]|0;D=c[m>>2]|0;C=e[s>>1]|0;E=e[o>>1]|0|C<<D;b[o>>1]=E;if((D|0)>(16-y|0)){z=c[p>>2]|0;c[p>>2]=z+1;a[(c[q>>2]|0)+z>>0]=E;z=(e[o>>1]|0)>>>8&255;B=c[p>>2]|0;c[p>>2]=B+1;a[(c[q>>2]|0)+B>>0]=z;z=c[m>>2]|0;B=C>>>(16-z|0);b[o>>1]=B;U=y+-16+z|0;V=B}else{U=D+y|0;V=E}c[m>>2]=U;E=K+-10|0;y=V&65535|E<<U;b[o>>1]=y;if((U|0)>9){D=c[p>>2]|0;c[p>>2]=D+1;a[(c[q>>2]|0)+D>>0]=y;y=(e[o>>1]|0)>>>8&255;D=c[p>>2]|0;c[p>>2]=D+1;a[(c[q>>2]|0)+D>>0]=y;y=c[m>>2]|0;b[o>>1]=(E&65535)>>>(16-y|0);c[m>>2]=y+-9;break}else{c[m>>2]=U+7;break}}}else{y=d+(x<<2)+2686|0;E=d+(x<<2)+2684|0;D=c[m>>2]|0;B=b[o>>1]|0;z=I;while(1){C=e[y>>1]|0;A=e[E>>1]|0;W=B&65535|A<<D;X=W&65535;b[o>>1]=X;if((D|0)>(16-C|0)){Y=c[p>>2]|0;c[p>>2]=Y+1;a[(c[q>>2]|0)+Y>>0]=W;W=(e[o>>1]|0)>>>8&255;Y=c[p>>2]|0;c[p>>2]=Y+1;a[(c[q>>2]|0)+Y>>0]=W;W=c[m>>2]|0;Y=A>>>(16-W|0)&65535;b[o>>1]=Y;Z=Y;_=C+-16+W|0}else{Z=X;_=D+C|0}c[m>>2]=_;z=z+-1|0;if(!z)break;else{D=_;B=Z}}}while(0);if(!(G<<16>>16)){$=x;v=138;w=3;k=F;x=H;j=$;continue}$=x;v=J?6:7;w=J?3:4;k=F;x=H;j=$}i=h;return}function UO(a){a=a|0;var b=0;b=i;AN(a,73896);bsi(a+64|0);i=b;return}function VO(a){a=a|0;var b=0;b=i;AN(a,73896);bsi(a+64|0);ACi(a);i=b;return}function WO(a){a=a|0;var b=0,c=0;b=i;c=a+-8|0;AN(c,73896);bsi(c+64|0);i=b;return}function XO(a){a=a|0;var b=0,c=0;b=i;c=a+-8|0;AN(c,73896);bsi(c+64|0);ACi(c);i=b;return}function YO(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+-12>>2]|0;AN(a+d|0,73896);bsi(a+(d+64)|0);i=b;return}function ZO(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[(c[a>>2]|0)+-12>>2]|0;e=a+d|0;AN(e,73896);bsi(a+(d+64)|0);ACi(e);i=b;return}function _O(a){a=a|0;var b=0;b=i;c[a>>2]=74048;xri(a+32|0);gsi(a);i=b;return}function $O(a){a=a|0;var b=0;b=i;c[a>>2]=74048;xri(a+32|0);gsi(a);ACi(a);i=b;return}function aP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;k=d+44|0;l=c[k>>2]|0;m=d+24|0;n=c[m>>2]|0;if(l>>>0<n>>>0){c[k>>2]=n;o=n}else o=l;l=h&24;if(!l){k=b;c[k>>2]=0;c[k+4>>2]=0;k=b+8|0;c[k>>2]=-1;c[k+4>>2]=-1;i=j;return}if((l|0)==24&(g|0)==1){l=b;c[l>>2]=0;c[l+4>>2]=0;l=b+8|0;c[l>>2]=-1;c[l+4>>2]=-1;i=j;return}do if(!g){p=0;q=0}else if((g|0)==2){l=d+32|0;if(!(a[l>>0]&1))r=l+1|0;else r=c[d+40>>2]|0;l=o-r|0;p=l;q=((l|0)<0)<<31>>31}else if((g|0)==1)if(!(h&8)){l=n-(c[d+20>>2]|0)|0;p=l;q=((l|0)<0)<<31>>31;break}else{l=(c[d+12>>2]|0)-(c[d+8>>2]|0)|0;p=l;q=((l|0)<0)<<31>>31;break}else{l=b;c[l>>2]=0;c[l+4>>2]=0;l=b+8|0;c[l>>2]=-1;c[l+4>>2]=-1;i=j;return}while(0);g=_Ei(p|0,q|0,e|0,f|0)|0;f=H;if((f|0)>=0){e=d+32|0;if(!(a[e>>0]&1))s=e+1|0;else s=c[d+40>>2]|0;e=o-s|0;s=((e|0)<0)<<31>>31;if(!((s|0)<(f|0)|(s|0)==(f|0)&e>>>0<g>>>0)){e=h&8;if(!((g|0)==0&(f|0)==0)){if((e|0)!=0?(c[d+12>>2]|0)==0:0){s=b;c[s>>2]=0;c[s+4>>2]=0;s=b+8|0;c[s>>2]=-1;c[s+4>>2]=-1;i=j;return}if((h&16|0)!=0&(n|0)==0){n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;i=j;return}}if(e){c[d+12>>2]=(c[d+8>>2]|0)+g;c[d+16>>2]=o}if(h&16)c[m>>2]=(c[d+20>>2]|0)+g;d=b;c[d>>2]=0;c[d+4>>2]=0;d=b+8|0;c[d>>2]=g;c[d+4>>2]=f;i=j;return}}f=b;c[f>>2]=0;c[f+4>>2]=0;f=b+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=j;return}function bP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=d+8|0;rn[c[(c[b>>2]|0)+16>>2]&127](a,b,c[g>>2]|0,c[g+4>>2]|0,0,e);i=f;return}function cP(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;e=a+44|0;f=c[e>>2]|0;g=c[a+24>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;h=g}else h=f;if(!(c[a+48>>2]&8)){j=-1;i=b;return j|0}f=a+16|0;g=c[f>>2]|0;e=c[a+12>>2]|0;if(g>>>0<h>>>0){c[f>>2]=h;k=h}else k=g;if(e>>>0>=k>>>0){j=-1;i=b;return j|0}j=d[e>>0]|0;i=b;return j|0}function dP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+44|0;g=c[f>>2]|0;h=c[b+24>>2]|0;if(g>>>0<h>>>0){c[f>>2]=h;j=h}else j=g;g=b+8|0;h=c[g>>2]|0;f=b+12|0;k=c[f>>2]|0;if(h>>>0>=k>>>0){l=-1;i=e;return l|0}if((d|0)==-1){c[g>>2]=h;c[f>>2]=k+-1;c[b+16>>2]=j;l=0;i=e;return l|0}if(!(c[b+48>>2]&16)){m=d&255;n=k+-1|0;if(m<<24>>24==(a[n>>0]|0)){o=m;p=n}else{l=-1;i=e;return l|0}}else{o=d&255;p=k+-1|0}c[g>>2]=h;c[f>>2]=p;c[b+16>>2]=j;a[p>>0]=o;l=d;i=e;return l|0}function eP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;if((d|0)==-1){f=0;i=e;return f|0}g=b+12|0;h=b+8|0;j=(c[g>>2]|0)-(c[h>>2]|0)|0;k=b+24|0;l=c[k>>2]|0;m=b+28|0;n=c[m>>2]|0;if((l|0)==(n|0)){o=b+48|0;if(!(c[o>>2]&16)){f=-1;i=e;return f|0}p=b+20|0;q=c[p>>2]|0;r=b+44|0;s=(c[r>>2]|0)-q|0;t=b+32|0;Fri(t,0);if(!(a[t>>0]&1))u=10;else u=(c[t>>2]&-2)+-1|0;Bri(t,u,0);u=a[t>>0]|0;if(!(u&1)){v=t+1|0;w=(u&255)>>>1}else{v=c[b+40>>2]|0;w=c[b+36>>2]|0}u=v+w|0;c[p>>2]=v;c[m>>2]=u;m=v+(l-q)|0;c[k>>2]=m;q=v+s|0;c[r>>2]=q;x=o;y=m;z=q;A=u}else{x=b+48|0;y=l;z=c[b+44>>2]|0;A=n}n=y+1|0;l=n>>>0<z>>>0?z:n;c[b+44>>2]=l;if(c[x>>2]&8){x=b+32|0;if(!(a[x>>0]&1))B=x+1|0;else B=c[b+40>>2]|0;c[h>>2]=B;c[g>>2]=B+j;c[b+16>>2]=l}if((y|0)==(A|0)){f=_n[c[(c[b>>2]|0)+52>>2]&4095](b,d&255)|0;i=e;return f|0}else{c[k>>2]=n;a[y>>0]=d;f=d&255;i=e;return f|0}return 0}function fP(){c[85496]=0;c[85498]=0;return}function gP(){var a=0;a=i;HF(346320);i=a;return}function hP(){var a=0;a=i;HF(348664);i=a;return}function iP(){var a=0;a=i;AE(349376,0);i=a;return}function jP(){var a=0;a=i;tE(349512,0,0);i=a;return}function kP(){var a=0;a=i;c[92248]=0;c[92249]=0;c[92250]=0;c[92260]=0;c[92261]=0;c[92262]=0;AE(369056,0);i=a;return}function lP(){var a=0;a=i;AE(405936,0);i=a;return}function mP(){var a=0;a=i;AE(406264,0);AE(406360,0);c[101593]=0;c[101594]=0;c[101592]=406372;i=a;return}function nP(){var a=0;a=i;AE(406384,0);c[101598]=0;c[101599]=0;c[101600]=0;c[101601]=0;g[101602]=ea(1.0);i=a;return}function oP(){var a=0;a=i;c[101604]=0;c[101605]=0;c[101606]=0;AE(406432,0);c[101610]=0;c[101611]=0;c[101612]=0;HF(406456);i=a;return}function pP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=342336;d=c[a+4>>2]|0;if(!d){i=b;return}CE(d);ACi(d);i=b;return}function qP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=342336;d=c[a+4>>2]|0;if(d){CE(d);ACi(d)}ACi(a);i=b;return}function rP(a){a=a|0;var b=0;b=i;BE(c[a+4>>2]|0,1);i=b;return 1}function sP(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=DE(c[a+4>>2]|0,b,1)|0;i=d;return e|0}function tP(a){a=a|0;var b=0;b=i;EE(c[a+4>>2]|0);i=b;return}function uP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=342616;d=c[a+4>>2]|0;if(!d){i=b;return}uE(d);ACi(d);i=b;return}function vP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=342616;d=c[a+4>>2]|0;if(d){uE(d);ACi(d)}ACi(a);i=b;return}function wP(a){a=a|0;var b=0;b=i;xE(c[a+4>>2]|0,1)|0;i=b;return 1}function xP(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(yE(c[a+4>>2]|0,b,1)|0)!=2;i=d;return e|0}function yP(a){a=a|0;var b=0;b=i;vE(c[a+4>>2]|0)|0;i=b;return}function zP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=346296;d=c[a+4>>2]|0;if(!d){i=b;return}GE(d);ACi(d);i=b;return}function AP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=346296;d=c[a+4>>2]|0;if(d){GE(d);ACi(d)}ACi(a);i=b;return}function BP(a){a=a|0;var b=0;b=i;IE(c[a+4>>2]|0,1)|0;i=b;return 1}function CP(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(JE(c[a+4>>2]|0,b,1)|0)!=2;i=d;return e|0}function DP(a){a=a|0;var b=0;b=i;HE(c[a+4>>2]|0,1,0)|0;i=b;return}function EP(a){a=a|0;var b=0;b=i;PO(a);ACi(a);i=b;return}function FP(a){a=a|0;var b=0;b=i;PO(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);i=b;return}function GP(a){a=a|0;var b=0,d=0;b=i;d=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;PO(d);ACi(d);i=b;return}function HP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=(c[a+12>>2]|0)+-5|0;f=e>>>0<65535?e:65535;e=a+116|0;g=a+108|0;h=a+92|0;j=a+44|0;k=a+56|0;while(1){l=c[e>>2]|0;if(l>>>0<2){bQ(a);m=c[e>>2]|0;if(!(m|b)){n=0;o=28;break}if(!m){o=20;break}else p=m}else p=l;l=(c[g>>2]|0)+p|0;c[g>>2]=l;c[e>>2]=0;m=c[h>>2]|0;q=m+f|0;if((l|0)!=0&l>>>0<q>>>0){r=l;s=m}else{c[e>>2]=l-q;c[g>>2]=q;if((m|0)>-1)t=(c[k>>2]|0)+m|0;else t=0;rN(a,t,f,0);c[h>>2]=c[g>>2];m=c[a>>2]|0;q=m+28|0;l=c[q>>2]|0;u=c[l+20>>2]|0;v=m+16|0;w=c[v>>2]|0;x=u>>>0>w>>>0?w:u;if((x|0)!=0?(u=m+12|0,YEi(c[u>>2]|0,c[l+16>>2]|0,x|0)|0,c[u>>2]=(c[u>>2]|0)+x,u=c[q>>2]|0,q=u+16|0,c[q>>2]=(c[q>>2]|0)+x,l=m+20|0,c[l>>2]=(c[l>>2]|0)+x,c[v>>2]=(c[v>>2]|0)-x,v=u+20|0,l=c[v>>2]|0,c[v>>2]=l-x,(l|0)==(x|0)):0)c[q>>2]=c[u+8>>2];if(!(c[(c[a>>2]|0)+16>>2]|0)){n=0;o=28;break}r=c[g>>2]|0;s=c[h>>2]|0}u=r-s|0;if(u>>>0<((c[j>>2]|0)+-262|0)>>>0)continue;if((s|0)>-1)y=(c[k>>2]|0)+s|0;else y=0;rN(a,y,u,0);c[h>>2]=c[g>>2];u=c[a>>2]|0;q=u+28|0;x=c[q>>2]|0;l=c[x+20>>2]|0;v=u+16|0;m=c[v>>2]|0;w=l>>>0>m>>>0?m:l;if((w|0)!=0?(l=u+12|0,YEi(c[l>>2]|0,c[x+16>>2]|0,w|0)|0,c[l>>2]=(c[l>>2]|0)+w,l=c[q>>2]|0,q=l+16|0,c[q>>2]=(c[q>>2]|0)+w,x=u+20|0,c[x>>2]=(c[x>>2]|0)+w,c[v>>2]=(c[v>>2]|0)-w,v=l+20|0,x=c[v>>2]|0,c[v>>2]=x-w,(x|0)==(w|0)):0)c[q>>2]=c[l+8>>2];if(!(c[(c[a>>2]|0)+16>>2]|0)){n=0;o=28;break}}if((o|0)==20){y=c[h>>2]|0;if((y|0)>-1)z=(c[k>>2]|0)+y|0;else z=0;k=(b|0)==4;rN(a,z,(c[g>>2]|0)-y|0,k&1);c[h>>2]=c[g>>2];g=c[a>>2]|0;h=g+28|0;y=c[h>>2]|0;z=c[y+20>>2]|0;b=g+16|0;s=c[b>>2]|0;j=z>>>0>s>>>0?s:z;if((j|0)!=0?(z=g+12|0,YEi(c[z>>2]|0,c[y+16>>2]|0,j|0)|0,c[z>>2]=(c[z>>2]|0)+j,z=c[h>>2]|0,h=z+16|0,c[h>>2]=(c[h>>2]|0)+j,y=g+20|0,c[y>>2]=(c[y>>2]|0)+j,c[b>>2]=(c[b>>2]|0)-j,b=z+20|0,y=c[b>>2]|0,c[b>>2]=y-j,(y|0)==(j|0)):0)c[h>>2]=c[z+8>>2];if(!(c[(c[a>>2]|0)+16>>2]|0)){n=k?2:0;i=d;return n|0}else{n=k?3:1;i=d;return n|0}}else if((o|0)==28){i=d;return n|0}return 0}function IP(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;g=i;h=e+116|0;j=(f|0)==0;k=e+72|0;l=e+88|0;m=e+108|0;n=e+56|0;o=e+84|0;p=e+68|0;q=e+52|0;r=e+64|0;s=e+96|0;t=e+112|0;u=e+5792|0;v=e+5796|0;w=e+5784|0;x=e+5788|0;y=e+128|0;z=e+92|0;A=e+44|0;B=e+136|0;C=0;while(1){if((c[h>>2]|0)>>>0<262){bQ(e);D=c[h>>2]|0;if(D>>>0<262&j){E=0;F=38;break}if(!D){F=30;break}if(D>>>0<=2)G=C;else F=6}else F=6;if((F|0)==6){F=0;D=c[m>>2]|0;H=((d[(c[n>>2]|0)+(D+2)>>0]|0)^c[k>>2]<<c[l>>2])&c[o>>2];c[k>>2]=H;I=(c[p>>2]|0)+(H<<1)|0;H=b[I>>1]|0;b[(c[r>>2]|0)+((c[q>>2]&D)<<1)>>1]=H;b[I>>1]=D;G=H&65535}do if((G|0)!=0?(H=(c[m>>2]|0)-G|0,H>>>0<=((c[A>>2]|0)+-262|0)>>>0):0){D=c[B>>2]|0;if((D&-2|0)!=2){I=cQ(e,G)|0;c[s>>2]=I;J=I;break}if((D|0)==3&(H|0)==1){H=dQ(e,G)|0;c[s>>2]=H;J=H}else F=13}else F=13;while(0);if((F|0)==13){F=0;J=c[s>>2]|0}do if(J>>>0>2){H=J+253|0;D=(c[m>>2]|0)-(c[t>>2]|0)|0;I=c[u>>2]|0;b[(c[v>>2]|0)+(I<<1)>>1]=D;c[u>>2]=I+1;a[(c[w>>2]|0)+I>>0]=H;I=e+((d[415400+(H&255)>>0]|0|256)+1<<2)+148|0;b[I>>1]=(b[I>>1]|0)+1<<16>>16;I=D+65535&65535;if(I>>>0<256)K=I;else K=(I>>>7)+256|0;I=e+((d[414888+K>>0]|0)<<2)+2440|0;b[I>>1]=(b[I>>1]|0)+1<<16>>16;I=(c[u>>2]|0)==((c[x>>2]|0)+-1|0)&1;D=c[s>>2]|0;H=(c[h>>2]|0)-D|0;c[h>>2]=H;if(!(H>>>0>2?D>>>0<=(c[y>>2]|0)>>>0:0)){H=(c[m>>2]|0)+D|0;c[m>>2]=H;c[s>>2]=0;L=c[n>>2]|0;M=d[L+H>>0]|0;c[k>>2]=M;c[k>>2]=((d[L+(H+1)>>0]|0)^M<<c[l>>2])&c[o>>2];N=H;O=I;P=G;break}H=D+-1|0;c[s>>2]=H;D=c[l>>2]|0;M=c[n>>2]|0;L=c[o>>2]|0;Q=c[p>>2]|0;R=c[q>>2]|0;S=c[r>>2]|0;T=c[m>>2]|0;U=c[k>>2]|0;V=H;while(1){H=T+1|0;c[m>>2]=H;U=((d[M+(T+3)>>0]|0)^U<<D)&L;c[k>>2]=U;W=Q+(U<<1)|0;X=b[W>>1]|0;b[S+((R&H)<<1)>>1]=X;b[W>>1]=H;V=V+-1|0;c[s>>2]=V;if(!V){Y=T;Z=X;break}else T=H}T=Y+2|0;c[m>>2]=T;N=T;O=I;P=Z&65535}else{T=a[(c[n>>2]|0)+(c[m>>2]|0)>>0]|0;V=c[u>>2]|0;b[(c[v>>2]|0)+(V<<1)>>1]=0;c[u>>2]=V+1;a[(c[w>>2]|0)+V>>0]=T;V=e+((T&255)<<2)+148|0;b[V>>1]=(b[V>>1]|0)+1<<16>>16;V=(c[u>>2]|0)==((c[x>>2]|0)+-1|0)&1;c[h>>2]=(c[h>>2]|0)+-1;T=(c[m>>2]|0)+1|0;c[m>>2]=T;N=T;O=V;P=G}while(0);if(!O){C=P;continue}V=c[z>>2]|0;if((V|0)>-1)_=(c[n>>2]|0)+V|0;else _=0;rN(e,_,N-V|0,0);c[z>>2]=c[m>>2];V=c[e>>2]|0;T=V+28|0;R=c[T>>2]|0;S=c[R+20>>2]|0;U=V+16|0;Q=c[U>>2]|0;L=S>>>0>Q>>>0?Q:S;if((L|0)!=0?(S=V+12|0,YEi(c[S>>2]|0,c[R+16>>2]|0,L|0)|0,c[S>>2]=(c[S>>2]|0)+L,S=c[T>>2]|0,T=S+16|0,c[T>>2]=(c[T>>2]|0)+L,R=V+20|0,c[R>>2]=(c[R>>2]|0)+L,c[U>>2]=(c[U>>2]|0)-L,U=S+20|0,R=c[U>>2]|0,c[U>>2]=R-L,(R|0)==(L|0)):0)c[T>>2]=c[S+8>>2];if(!(c[(c[e>>2]|0)+16>>2]|0)){E=0;F=38;break}else C=P}if((F|0)==30){P=c[z>>2]|0;if((P|0)>-1)$=(c[n>>2]|0)+P|0;else $=0;n=(f|0)==4;rN(e,$,(c[m>>2]|0)-P|0,n&1);c[z>>2]=c[m>>2];m=c[e>>2]|0;z=m+28|0;P=c[z>>2]|0;$=c[P+20>>2]|0;f=m+16|0;C=c[f>>2]|0;N=$>>>0>C>>>0?C:$;if((N|0)!=0?($=m+12|0,YEi(c[$>>2]|0,c[P+16>>2]|0,N|0)|0,c[$>>2]=(c[$>>2]|0)+N,$=c[z>>2]|0,z=$+16|0,c[z>>2]=(c[z>>2]|0)+N,P=m+20|0,c[P>>2]=(c[P>>2]|0)+N,c[f>>2]=(c[f>>2]|0)-N,f=$+20|0,P=c[f>>2]|0,c[f>>2]=P-N,(P|0)==(N|0)):0)c[z>>2]=c[$+8>>2];if(!(c[(c[e>>2]|0)+16>>2]|0)){E=n?2:0;i=g;return E|0}else{E=n?3:1;i=g;return E|0}}else if((F|0)==38){i=g;return E|0}return 0}function JP(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;g=i;h=e+116|0;j=(f|0)==0;k=e+72|0;l=e+88|0;m=e+108|0;n=e+56|0;o=e+84|0;p=e+68|0;q=e+52|0;r=e+64|0;s=e+96|0;t=e+120|0;u=e+112|0;v=e+100|0;w=e+5792|0;x=e+5796|0;y=e+5784|0;z=e+5788|0;A=e+104|0;B=e+92|0;C=e+128|0;D=e+44|0;E=e+136|0;F=0;a:while(1){G=c[h>>2]|0;H=F;while(1){if(G>>>0<262){bQ(e);I=c[h>>2]|0;if(I>>>0<262&j){J=0;K=54;break a}if(!I){K=44;break a}if(I>>>0<=2)L=H;else K=7}else K=7;if((K|0)==7){K=0;I=c[m>>2]|0;M=((d[(c[n>>2]|0)+(I+2)>>0]|0)^c[k>>2]<<c[l>>2])&c[o>>2];c[k>>2]=M;N=(c[p>>2]|0)+(M<<1)|0;M=b[N>>1]|0;b[(c[r>>2]|0)+((c[q>>2]&I)<<1)>>1]=M;b[N>>1]=I;L=M&65535}M=c[s>>2]|0;c[t>>2]=M;c[v>>2]=c[u>>2];c[s>>2]=2;do if(L)if(M>>>0<(c[C>>2]|0)>>>0){I=(c[m>>2]|0)-L|0;if(I>>>0>((c[D>>2]|0)+-262|0)>>>0){O=2;K=20}else{N=c[E>>2]|0;if((N&-2|0)==2)if((N|0)==3&(I|0)==1){P=dQ(e,L)|0;K=15}else Q=2;else{P=cQ(e,L)|0;K=15}if((K|0)==15){K=0;c[s>>2]=P;if(P>>>0<6)Q=P;else{O=P;K=20;break}}if((c[E>>2]|0)!=1){if((Q|0)!=3){O=Q;K=20;break}if(((c[m>>2]|0)-(c[u>>2]|0)|0)>>>0<=4096){O=3;K=20;break}}c[s>>2]=2;O=2;K=20}}else{R=M;S=2}else{O=2;K=20}while(0);if((K|0)==20){K=0;R=c[t>>2]|0;S=O}if(!(R>>>0<3|S>>>0>R>>>0)){T=R;U=L;break}if(!(c[A>>2]|0)){c[A>>2]=1;c[m>>2]=(c[m>>2]|0)+1;M=(c[h>>2]|0)+-1|0;c[h>>2]=M;G=M;H=L;continue}M=a[(c[n>>2]|0)+((c[m>>2]|0)+-1)>>0]|0;I=c[w>>2]|0;b[(c[x>>2]|0)+(I<<1)>>1]=0;c[w>>2]=I+1;a[(c[y>>2]|0)+I>>0]=M;I=e+((M&255)<<2)+148|0;b[I>>1]=(b[I>>1]|0)+1<<16>>16;if((c[w>>2]|0)==((c[z>>2]|0)+-1|0)){I=c[B>>2]|0;if((I|0)>-1)V=(c[n>>2]|0)+I|0;else V=0;rN(e,V,(c[m>>2]|0)-I|0,0);c[B>>2]=c[m>>2];I=c[e>>2]|0;M=I+28|0;N=c[M>>2]|0;W=c[N+20>>2]|0;X=I+16|0;Y=c[X>>2]|0;Z=W>>>0>Y>>>0?Y:W;if((Z|0)!=0?(W=I+12|0,YEi(c[W>>2]|0,c[N+16>>2]|0,Z|0)|0,c[W>>2]=(c[W>>2]|0)+Z,W=c[M>>2]|0,M=W+16|0,c[M>>2]=(c[M>>2]|0)+Z,N=I+20|0,c[N>>2]=(c[N>>2]|0)+Z,c[X>>2]=(c[X>>2]|0)-Z,X=W+20|0,N=c[X>>2]|0,c[X>>2]=N-Z,(N|0)==(Z|0)):0)c[M>>2]=c[W+8>>2]}c[m>>2]=(c[m>>2]|0)+1;G=(c[h>>2]|0)+-1|0;c[h>>2]=G;if(!(c[(c[e>>2]|0)+16>>2]|0)){J=0;K=54;break a}else H=L}H=c[m>>2]|0;G=H+-3+(c[h>>2]|0)|0;W=T+253|0;M=H+65535-(c[v>>2]|0)|0;H=c[w>>2]|0;b[(c[x>>2]|0)+(H<<1)>>1]=M;c[w>>2]=H+1;a[(c[y>>2]|0)+H>>0]=W;H=e+((d[415400+(W&255)>>0]|0|256)+1<<2)+148|0;b[H>>1]=(b[H>>1]|0)+1<<16>>16;H=M+65535&65535;if(H>>>0<256)_=H;else _=(H>>>7)+256|0;H=e+((d[414888+_>>0]|0)<<2)+2440|0;b[H>>1]=(b[H>>1]|0)+1<<16>>16;H=c[w>>2]|0;M=(c[z>>2]|0)+-1|0;W=c[t>>2]|0;c[h>>2]=1-W+(c[h>>2]|0);Z=W+-2|0;c[t>>2]=Z;W=c[m>>2]|0;N=Z;Z=U;while(1){X=W+1|0;c[m>>2]=X;if(X>>>0>G>>>0)$=Z;else{I=((d[(c[n>>2]|0)+(W+3)>>0]|0)^c[k>>2]<<c[l>>2])&c[o>>2];c[k>>2]=I;Y=(c[p>>2]|0)+(I<<1)|0;I=b[Y>>1]|0;b[(c[r>>2]|0)+((c[q>>2]&X)<<1)>>1]=I;b[Y>>1]=X;$=I&65535}N=N+-1|0;c[t>>2]=N;if(!N){aa=W;ba=$;break}else{W=X;Z=$}}c[A>>2]=0;c[s>>2]=2;Z=aa+2|0;c[m>>2]=Z;if((H|0)!=(M|0)){F=ba;continue}W=c[B>>2]|0;if((W|0)>-1)ca=(c[n>>2]|0)+W|0;else ca=0;rN(e,ca,Z-W|0,0);c[B>>2]=c[m>>2];W=c[e>>2]|0;Z=W+28|0;N=c[Z>>2]|0;G=c[N+20>>2]|0;X=W+16|0;I=c[X>>2]|0;Y=G>>>0>I>>>0?I:G;if((Y|0)!=0?(G=W+12|0,YEi(c[G>>2]|0,c[N+16>>2]|0,Y|0)|0,c[G>>2]=(c[G>>2]|0)+Y,G=c[Z>>2]|0,Z=G+16|0,c[Z>>2]=(c[Z>>2]|0)+Y,N=W+20|0,c[N>>2]=(c[N>>2]|0)+Y,c[X>>2]=(c[X>>2]|0)-Y,X=G+20|0,N=c[X>>2]|0,c[X>>2]=N-Y,(N|0)==(Y|0)):0)c[Z>>2]=c[G+8>>2];if(!(c[(c[e>>2]|0)+16>>2]|0)){J=0;K=54;break}else F=ba}if((K|0)==44){if(c[A>>2]|0){ba=a[(c[n>>2]|0)+((c[m>>2]|0)+-1)>>0]|0;F=c[w>>2]|0;b[(c[x>>2]|0)+(F<<1)>>1]=0;c[w>>2]=F+1;a[(c[y>>2]|0)+F>>0]=ba;F=e+((ba&255)<<2)+148|0;b[F>>1]=(b[F>>1]|0)+1<<16>>16;c[A>>2]=0}A=c[B>>2]|0;if((A|0)>-1)da=(c[n>>2]|0)+A|0;else da=0;n=(f|0)==4;rN(e,da,(c[m>>2]|0)-A|0,n&1);c[B>>2]=c[m>>2];m=c[e>>2]|0;B=m+28|0;A=c[B>>2]|0;da=c[A+20>>2]|0;f=m+16|0;F=c[f>>2]|0;ba=da>>>0>F>>>0?F:da;if((ba|0)!=0?(da=m+12|0,YEi(c[da>>2]|0,c[A+16>>2]|0,ba|0)|0,c[da>>2]=(c[da>>2]|0)+ba,da=c[B>>2]|0,B=da+16|0,c[B>>2]=(c[B>>2]|0)+ba,A=m+20|0,c[A>>2]=(c[A>>2]|0)+ba,c[f>>2]=(c[f>>2]|0)-ba,f=da+20|0,A=c[f>>2]|0,c[f>>2]=A-ba,(A|0)==(ba|0)):0)c[B>>2]=c[da+8>>2];if(!(c[(c[e>>2]|0)+16>>2]|0)){J=n?2:0;i=g;return J|0}else{J=n?3:1;i=g;return J|0}}else if((K|0)==54){i=g;return J|0}return 0}function KP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=c[d>>2]|0;if(!m){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g|0;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;if((h|0)>0?(xo[c[(c[m>>2]|0)+48>>2]&2047](m,e,h)|0)!=(h|0):0){c[d>>2]=0;c[b>>2]=0;i=k;return}do if((q|0)>0){tri(l,q,j);if(!(a[l>>0]&1))r=l+1|0;else r=c[l+8>>2]|0;if((xo[c[(c[m>>2]|0)+48>>2]&2047](m,r,q)|0)==(q|0)){xri(l);break}c[d>>2]=0;c[b>>2]=0;xri(l);i=k;return}while(0);l=n-o|0;if((l|0)>0?(xo[c[(c[m>>2]|0)+48>>2]&2047](m,f,l)|0)!=(l|0):0){c[d>>2]=0;c[b>>2]=0;i=k;return}c[p>>2]=0;c[b>>2]=m;i=k;return}function LP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;h=c[b+4>>2]|0;j=c[d>>2]|0;a:do if(!h){k=f;l=j}else{if(!e){m=h;n=j;while(1){o=1;while(1){p=o+1|0;if(m>>>0<(c[726896+(o<<2)>>2]|0)>>>0){q=o;break}if((p|0)<9)o=p;else{q=p;break}}o=n-q|0;if((o|0)<0){r=2;break}p=eQ(a,b,c[726896+(q<<2)>>2]|0,0)|0;m=c[b+4>>2]|0;if(!m){k=p;l=o;break a}else n=o}i=g;return r|0}else{s=h;t=j}while(1){n=1;while(1){m=n+1|0;if(s>>>0<(c[726896+(n<<2)>>2]|0)>>>0){u=n;break}if((m|0)<9)n=m;else{u=m;break}}n=t-u|0;if((n|0)<0){r=2;break}m=eQ(a,b,c[726896+(u<<2)>>2]|0,0)|0;o=b;p=s;s=c[o+4>>2]|0;if((m|0)!=0?(p=a,((c[p>>2]|0)==-1?(c[p+4>>2]|0)==-1:0)&(c[o>>2]|0)==-1):0){s=1;t=n;continue}if(!s){k=m;l=n;break a}else t=n}i=g;return r|0}while(0);c[d>>2]=l;if(!((e|0)!=0&(k|0)!=0)){r=0;i=g;return r|0}k=a;e=_Ei(c[k>>2]|0,c[k+4>>2]|0,1,0)|0;k=H;l=a;c[l>>2]=e;c[l+4>>2]=k;if(!((e|0)==0&(k|0)==0)){r=0;i=g;return r|0}k=b;e=_Ei(c[k>>2]|0,c[k+4>>2]|0,1,0)|0;k=b;c[k>>2]=e;c[k+4>>2]=H;r=0;i=g;return r|0}function MP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function NP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=iI(c[(c[d>>2]|0)+4>>2]|0)|0;g=c[b+4>>2]|0;a:do if(g){h=g+-1|0;j=(h&g|0)==0;if(j)k=h&f;else k=(f>>>0)%(g>>>0)|0;l=c[(c[b>>2]|0)+(k<<2)>>2]|0;if((l|0)!=0?(m=c[l>>2]|0,(m|0)!=0):0){l=m;while(1){m=c[l+4>>2]|0;if(j)n=m&h;else n=(m>>>0)%(g>>>0)|0;if((n|0)!=(k|0))break a;m=c[l+8>>2]|0;o=c[d>>2]|0;if((HEi(c[m+4>>2]|0,c[o+4>>2]|0)|0)==0?lL(m,o)|0:0){p=l;break}l=c[l>>2]|0;if(!l)break a}c[a>>2]=p;i=e;return}}while(0);c[a>>2]=0;i=e;return}function OP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0;f=i;h=e+8|0;j=iI(c[(c[h>>2]|0)+4>>2]|0)|0;k=e+4|0;c[k>>2]=j;l=d+4|0;m=c[l>>2]|0;n=(m|0)==0;a:do if(!n){o=m+-1|0;p=(o&m|0)==0;if(p)q=o&j;else q=(j>>>0)%(m>>>0)|0;r=c[(c[d>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=c[r>>2]|0,(s|0)!=0):0){r=s;while(1){s=c[r+4>>2]|0;if(p)t=s&o;else t=(s>>>0)%(m>>>0)|0;if((t|0)!=(q|0)){u=q;break a}s=c[r+8>>2]|0;v=c[h>>2]|0;if((HEi(c[s+4>>2]|0,c[v+4>>2]|0)|0)==0?lL(s,v)|0:0){w=0;x=r;break}r=c[r>>2]|0;if(!r){u=q;break a}}c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}else u=q}else u=0;while(0);q=d+12|0;z=ea(((c[q>>2]|0)+1|0)>>>0);A=ea(m>>>0);B=ea(g[d+16>>2]);do if(z>ea(A*B)|n){if(m>>>0>2)C=(m+-1&m|0)==0;else C=0;h=(C&1|m<<1)^1;t=~~ea(ca(ea(z/B)))>>>0;fQ(d,h>>>0<t>>>0?t:h);h=c[l>>2]|0;t=c[k>>2]|0;j=h+-1|0;if(!(j&h)){D=h;E=j&t;break}else{D=h;E=(t>>>0)%(h>>>0)|0;break}}else{D=m;E=u}while(0);u=c[(c[d>>2]|0)+(E<<2)>>2]|0;if(!u){m=d+8|0;c[e>>2]=c[m>>2];c[m>>2]=e;c[(c[d>>2]|0)+(E<<2)>>2]=m;m=c[e>>2]|0;if(m){E=c[m+4>>2]|0;m=D+-1|0;if(!(m&D))F=E&m;else F=(E>>>0)%(D>>>0)|0;c[(c[d>>2]|0)+(F<<2)>>2]=e}}else{c[e>>2]=c[u>>2];c[u>>2]=e}c[q>>2]=(c[q>>2]|0)+1;w=1;x=e;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function PP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=iI(c[c[b>>2]>>2]|0)|0;g=c[a+4>>2]|0;a:do if(g){h=g+-1|0;j=(h&g|0)==0;if(j)k=h&f;else k=(f>>>0)%(g>>>0)|0;l=c[(c[a>>2]|0)+(k<<2)>>2]|0;if(l){m=c[b>>2]|0;n=l;while(1){l=c[n>>2]|0;if(!l)break a;o=c[l+4>>2]|0;if(j)p=o&h;else p=(o>>>0)%(g>>>0)|0;if((p|0)!=(k|0))break a;if(!(HEi(c[c[l+8>>2]>>2]|0,c[m>>2]|0)|0)){q=l;break}else n=l}r=q+12|0;i=d;return r|0}}while(0);k=Ks(16,0)|0;c[k+8>>2]=c[b>>2];c[k+12>>2]=0;gQ(e,a,k);q=c[e>>2]|0;r=q+12|0;i=d;return r|0}function QP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function RP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;h=g;j=a[b>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[b+4>>2]|0;j=a[e>>0]|0;m=(j&1)==0;if(m)n=(j&255)>>>1;else n=c[e+4>>2]|0;a:do if(n>>>0>f>>>0){j=b+1|0;o=b+8|0;p=c[e+8>>2]|0;b:do if(m){q=d;r=f;while(1){s=a[e+r+1>>0]|0;if(s<<24>>24==42){t=q;u=r;break b}v=(q|0)==(l|0);if(s<<24>>24==63){if(v){w=0;x=30;break}}else{if(v){w=0;x=30;break}if(k)y=j;else y=c[o>>2]|0;if((a[y+q>>0]|0)!=s<<24>>24){w=0;x=30;break}}s=q+1|0;r=r+1|0;if(r>>>0>=n>>>0){z=s;break a}else q=s}if((x|0)==30){i=g;return w|0}}else{q=d;r=f;while(1){s=a[p+r>>0]|0;if(s<<24>>24==42){t=q;u=r;break b}v=(q|0)==(l|0);if(s<<24>>24==63){if(v){w=0;x=30;break}}else{if(v){w=0;x=30;break}if(k)A=j;else A=c[o>>2]|0;if((a[A+q>>0]|0)!=s<<24>>24){w=0;x=30;break}}s=q+1|0;r=r+1|0;if(r>>>0>=n>>>0){z=s;break a}else q=s}if((x|0)==30){i=g;return w|0}}while(0);if((u+1|0)==(n|0)){w=1;i=g;return w|0}o=f+1|0;j=t;while(1){sri(h,b);p=RP(h,j,e,o)|0;xri(h);if(p){w=1;x=30;break}if(j>>>0<l>>>0)j=j+1|0;else{w=0;x=30;break}}if((x|0)==30){i=g;return w|0}}else z=d;while(0);w=(z|0)==(l|0);i=g;return w|0}function SP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;a:do if(!(h&1)){e=g;while(1){n=e+16|0;o=a[n>>0]|0;p=(o&1)==0;if(p){q=(o&255)>>>1;r=n+1|0}else{q=c[e+20>>2]|0;r=c[e+24>>2]|0}s=FEi(k,r,q>>>0<b>>>0?q:b)|0;if(!s){if(b>>>0<q>>>0)t=16}else if((s|0)<0)t=16;if((t|0)==16){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){w=(o&255)>>>1;x=n+1|0}else{w=c[e+20>>2]|0;x=c[e+24>>2]|0}n=FEi(x,k,b>>>0<w>>>0?b:w)|0;if(!n){if(w>>>0>=b>>>0){y=e;t=33;break a}}else if((n|0)>=0){y=e;t=33;break a}n=e+4|0;o=c[n>>2]|0;if(!o){z=n;A=e;t=32;break}else e=o}}else{e=g;while(1){o=e+16|0;n=a[o>>0]|0;p=(n&1)==0;if(p){B=(n&255)>>>1;C=o+1|0}else{B=c[e+20>>2]|0;C=c[e+24>>2]|0}s=FEi(l,C,B>>>0<m>>>0?B:m)|0;if(!s){if(m>>>0<B>>>0)t=23}else if((s|0)<0)t=23;if((t|0)==23){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){D=(n&255)>>>1;E=o+1|0}else{D=c[e+20>>2]|0;E=c[e+24>>2]|0}o=FEi(E,l,m>>>0<D>>>0?m:D)|0;if(!o){if(D>>>0>=m>>>0){y=e;t=33;break a}}else if((o|0)>=0){y=e;t=33;break a}o=e+4|0;n=c[o>>2]|0;if(!n){z=o;A=e;t=32;break}else e=n}}while(0);if((t|0)==24){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==32){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==33){c[d>>2]=y;j=d;i=f;return j|0}return 0}function TP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;h=b+4|0;j=c[d>>2]|0;do if((j|0)!=(h|0)){d=j+16|0;k=a[f>>0]|0;l=(k&1)==0;if(l)m=(k&255)>>>1;else m=c[f+4>>2]|0;n=a[d>>0]|0;o=(n&1)==0;if(o)p=(n&255)>>>1;else p=c[j+20>>2]|0;if(l)q=f+1|0;else q=c[f+8>>2]|0;if(o)r=d+1|0;else r=c[j+24>>2]|0;s=FEi(q,r,p>>>0<m>>>0?p:m)|0;if(!s){if(m>>>0<p>>>0)break}else if((s|0)<0)break;if(o)t=(n&255)>>>1;else t=c[j+20>>2]|0;if(l)u=(k&255)>>>1;else u=c[f+4>>2]|0;if(o)v=d+1|0;else v=c[j+24>>2]|0;if(l)w=f+1|0;else w=c[f+8>>2]|0;d=FEi(v,w,u>>>0<t>>>0?u:t)|0;if(!d){if(t>>>0>=u>>>0)x=80}else if((d|0)>=0)x=80;if((x|0)==80){c[e>>2]=j;y=e;i=g;return y|0}d=j+4|0;o=c[d>>2]|0;n=(o|0)==0;if(n){s=j;while(1){z=c[s+8>>2]|0;if((c[z>>2]|0)==(s|0)){A=z;break}else s=z}}else{s=o;while(1){z=c[s>>2]|0;if(!z){A=s;break}else s=z}}do if((A|0)!=(h|0)){s=A+16|0;if(l)B=(k&255)>>>1;else B=c[f+4>>2]|0;o=a[s>>0]|0;z=(o&1)==0;if(z)C=(o&255)>>>1;else C=c[A+20>>2]|0;if(l)D=f+1|0;else D=c[f+8>>2]|0;if(z)E=s+1|0;else E=c[A+24>>2]|0;s=FEi(D,E,C>>>0<B>>>0?C:B)|0;if(!s){if(B>>>0<C>>>0)break}else if((s|0)<0)break;y=SP(b,e,f)|0;i=g;return y|0}while(0);if(n){c[e>>2]=j;y=d;i=g;return y|0}else{c[e>>2]=A;y=A;i=g;return y|0}}while(0);A=c[j>>2]|0;do if((j|0)==(c[b>>2]|0))F=j;else{if(!A){C=j;while(1){B=c[C+8>>2]|0;if((c[B>>2]|0)==(C|0))C=B;else{G=B;break}}}else{C=A;while(1){d=c[C+4>>2]|0;if(!d){G=C;break}else C=d}}C=G+16|0;d=a[C>>0]|0;n=(d&1)==0;if(n)H=(d&255)>>>1;else H=c[G+20>>2]|0;d=a[f>>0]|0;B=(d&1)==0;if(B)I=(d&255)>>>1;else I=c[f+4>>2]|0;if(n)J=C+1|0;else J=c[G+24>>2]|0;if(B)K=f+1|0;else K=c[f+8>>2]|0;B=FEi(J,K,I>>>0<H>>>0?I:H)|0;if(!B){if(H>>>0<I>>>0){F=G;break}}else if((B|0)<0){F=G;break}y=SP(b,e,f)|0;i=g;return y|0}while(0);if(!A){c[e>>2]=j;y=j;i=g;return y|0}else{c[e>>2]=F;y=F+4|0;i=g;return y|0}return 0}function UP(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=i;if((2147483631-e|0)>>>0<f>>>0)ori(d);if(!(a[d>>0]&1))m=d+2|0;else m=c[d+8>>2]|0;if(e>>>0<1073741799){n=f+e|0;f=e<<1;o=n>>>0<f>>>0?f:n;if(o>>>0<5)p=5;else p=o+8&-8}else p=2147483631;o=xCi(p<<1)|0;if(h){n=h;f=m;q=o;while(1){b[q>>1]=b[f>>1]|0;n=n+-1|0;if(!n)break;else{f=f+2|0;q=q+2|0}}}q=g-j|0;if((q|0)!=(h|0)){g=q-h|0;q=m+(j+h<<1)|0;j=o+(k+h<<1)|0;while(1){b[j>>1]=b[q>>1]|0;g=g+-1|0;if(!g)break;else{q=q+2|0;j=j+2|0}}}if((e|0)==4){r=d+8|0;c[r>>2]=o;s=p|1;c[d>>2]=s;i=l;return}ACi(m);r=d+8|0;c[r>>2]=o;s=p|1;c[d>>2]=s;i=l;return}function VP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&1)==0;k=(h&255)>>>1;h=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;e=g;while(1){g=e+16|0;n=b?k:m;o=a[g>>0]|0;p=(o&1)==0;if(p)q=(o&255)>>>1;else q=c[e+20>>2]|0;if(p)r=g+1|0;else r=c[e+24>>2]|0;s=FEi(b?h:l,r,q>>>0<n>>>0?q:n)|0;if(!s){if(n>>>0<q>>>0)t=12}else if((s|0)<0)t=12;if((t|0)==12){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=13;break}else{e=s;continue}}if(p)w=(o&255)>>>1;else w=c[e+20>>2]|0;o=b?k:m;if(p)x=g+1|0;else x=c[e+24>>2]|0;g=FEi(x,b?h:l,o>>>0<w>>>0?o:w)|0;if(!g){if(w>>>0>=o>>>0){y=e;t=25;break}}else if((g|0)>=0){y=e;t=25;break}g=e+4|0;o=c[g>>2]|0;if(!o){z=g;A=e;t=24;break}else e=o}if((t|0)==13){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==24){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==25){c[d>>2]=y;j=d;i=f;return j|0}return 0}function WP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0;f=i;h=c[e+8>>2]|0;j=c[h>>2]|0;k=j>>>3;l=e+4|0;c[l>>2]=k;m=d+4|0;n=c[m>>2]|0;o=(n|0)==0;a:do if(!o){p=n+-1|0;q=(p&n|0)==0;if(q)r=p&k;else r=(k>>>0)%(n>>>0)|0;s=c[(c[d>>2]|0)+(r<<2)>>2]|0;if((s|0)!=0?(t=c[s>>2]|0,(t|0)!=0):0)if(q){q=t;while(1){if((c[q+4>>2]&p|0)!=(r|0)){u=r;break a}s=c[q+8>>2]|0;if((c[s>>2]|0)==(j|0)?(c[s+4>>2]|0)==(c[h+4>>2]|0):0){v=0;w=q;break}q=c[q>>2]|0;if(!q){u=r;break a}}c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}else{q=t;while(1){if((((c[q+4>>2]|0)>>>0)%(n>>>0)|0|0)!=(r|0)){u=r;break a}p=c[q+8>>2]|0;if((c[p>>2]|0)==(j|0)?(c[p+4>>2]|0)==(c[h+4>>2]|0):0){v=0;w=q;break}q=c[q>>2]|0;if(!q){u=r;break a}}c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}else u=r}else u=0;while(0);r=d+12|0;y=ea(((c[r>>2]|0)+1|0)>>>0);z=ea(n>>>0);A=ea(g[d+16>>2]);do if(y>ea(z*A)|o){if(n>>>0>2)B=(n+-1&n|0)==0;else B=0;h=(B&1|n<<1)^1;j=~~ea(ca(ea(y/A)))>>>0;hQ(d,h>>>0<j>>>0?j:h);h=c[m>>2]|0;j=c[l>>2]|0;k=h+-1|0;if(!(k&h)){C=h;D=k&j;break}else{C=h;D=(j>>>0)%(h>>>0)|0;break}}else{C=n;D=u}while(0);u=c[(c[d>>2]|0)+(D<<2)>>2]|0;if(!u){n=d+8|0;c[e>>2]=c[n>>2];c[n>>2]=e;c[(c[d>>2]|0)+(D<<2)>>2]=n;n=c[e>>2]|0;if(n){D=c[n+4>>2]|0;n=C+-1|0;if(!(n&C))E=D&n;else E=(D>>>0)%(C>>>0)|0;c[(c[d>>2]|0)+(E<<2)>>2]=e}}else{c[e>>2]=c[u>>2];c[u>>2]=e}c[r>>2]=(c[r>>2]|0)+1;v=1;w=e;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}function XP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0;f=i;h=e+8|0;j=EO(d+12|0,c[h>>2]|0)|0;k=e+4|0;c[k>>2]=j;l=d+4|0;m=c[l>>2]|0;n=(m|0)==0;a:do if(!n){o=m+-1|0;p=(o&m|0)==0;if(p)q=o&j;else q=(j>>>0)%(m>>>0)|0;r=c[(c[d>>2]|0)+(q<<2)>>2]|0;if(!r)s=q;else{t=d+16|0;u=r;while(1){r=c[u>>2]|0;if(!r){s=q;break a}v=c[r+4>>2]|0;if(p)w=v&o;else w=(v>>>0)%(m>>>0)|0;if((w|0)!=(q|0)){s=q;break a}if(oK(t,c[r+8>>2]|0,c[h>>2]|0)|0){x=0;y=r;break}else u=r}c[b>>2]=y;z=b+4|0;a[z>>0]=x;i=f;return}}else s=0;while(0);h=d+12|0;A=ea(((c[h>>2]|0)+1|0)>>>0);B=ea(m>>>0);C=ea(g[d+16>>2]);do if(A>ea(B*C)|n){if(m>>>0>2)D=(m+-1&m|0)==0;else D=0;q=(D&1|m<<1)^1;w=~~ea(ca(ea(A/C)))>>>0;iQ(d,q>>>0<w>>>0?w:q);q=c[l>>2]|0;w=c[k>>2]|0;j=q+-1|0;if(!(j&q)){E=q;F=j&w;break}else{E=q;F=(w>>>0)%(q>>>0)|0;break}}else{E=m;F=s}while(0);s=c[(c[d>>2]|0)+(F<<2)>>2]|0;if(!s){m=d+8|0;c[e>>2]=c[m>>2];c[m>>2]=e;c[(c[d>>2]|0)+(F<<2)>>2]=m;m=c[e>>2]|0;if(m){F=c[m+4>>2]|0;m=E+-1|0;if(!(m&E))G=F&m;else G=(F>>>0)%(E>>>0)|0;c[(c[d>>2]|0)+(G<<2)>>2]=e}}else{c[e>>2]=c[s>>2];c[s>>2]=e}c[h>>2]=(c[h>>2]|0)+1;x=1;y=e;c[b>>2]=y;z=b+4|0;a[z>>0]=x;i=f;return}function YP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0;d=i;if((b|0)!=1)if(!(b+-1&b))e=b;else e=mri(b)|0;else e=2;b=c[a+4>>2]|0;if(e>>>0>b>>>0){jQ(a,e);i=d;return}if(e>>>0>=b>>>0){i=d;return}if(b>>>0>2)f=(b+-1&b|0)==0;else f=0;h=ea((c[a+12>>2]|0)>>>0);j=~~ea(ca(ea(h/ea(g[a+16>>2]))))>>>0;if(f)k=1<<32-(QEi(j+-1|0)|0);else k=mri(j)|0;j=e>>>0<k>>>0?k:e;if(j>>>0>=b>>>0){i=d;return}jQ(a,j);i=d;return}function ZP(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;sri(b,c);sri(b+12|0,c+12|0);sri(b+24|0,c+24|0);sri(b+36|0,c+36|0);e=b+48|0;b=c+48|0;c=e+40|0;do{a[e>>0]=a[b>>0]|0;e=e+1|0;b=b+1|0}while((e|0)<(c|0));i=d;return}function _P(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=(c[g>>2]|0)-(c[b>>2]|0)|0;j=h>>2;if(!j){i=d;return}if(j>>>0>1073741823)vxi(a);k=xCi(h)|0;c[e>>2]=k;c[a>>2]=k;c[f>>2]=k+(j<<2);j=c[b>>2]|0;b=c[g>>2]|0;if((j|0)==(b|0)){i=d;return}g=(b+-4-j|0)>>>2;f=j;j=k;while(1){c[j>>2]=c[f>>2];f=f+4|0;if((f|0)==(b|0))break;else j=j+4|0}c[e>>2]=k+(g+1<<2);i=d;return}function $P(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=c[g>>2]|0;j=c[b>>2]|0;k=h-j|0;l=(k|0)/148|0;if((h|0)==(j|0)){i=d;return}if(l>>>0>29020049)vxi(a);j=xCi(k)|0;c[e>>2]=j;c[a>>2]=j;c[f>>2]=j+(l*148|0);l=c[b>>2]|0;b=c[g>>2]|0;if((l|0)==(b|0)){i=d;return}else{m=l;n=j}do{MO(n,m);n=(c[e>>2]|0)+148|0;c[e>>2]=n;m=m+148|0}while((m|0)!=(b|0));i=d;return}function aQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=c[g>>2]|0;j=c[b>>2]|0;k=h-j|0;l=(k|0)/12|0;if((h|0)==(j|0)){i=d;return}if(l>>>0>357913941)vxi(a);j=xCi(k)|0;c[e>>2]=j;c[a>>2]=j;c[f>>2]=j+(l*12|0);l=c[b>>2]|0;b=c[g>>2]|0;if((l|0)==(b|0)){i=d;return}else{m=l;n=j}do{sri(n,m);n=(c[e>>2]|0)+12|0;c[e>>2]=n;m=m+12|0}while((m|0)!=(b|0));i=d;return}function bQ(a){a=a|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f=i;g=a+44|0;h=c[g>>2]|0;j=a+60|0;k=a+116|0;l=a+108|0;m=h+-262|0;n=a+56|0;o=a+72|0;p=a+88|0;q=a+84|0;r=a+112|0;s=a+92|0;t=a+76|0;u=a+68|0;v=a+64|0;w=c[k>>2]|0;x=h;while(1){y=c[l>>2]|0;z=(c[j>>2]|0)-w-y|0;if(y>>>0<(m+x|0)>>>0){A=y;B=z}else{y=c[n>>2]|0;YEi(y|0,y+h|0,h|0)|0;c[r>>2]=(c[r>>2]|0)-h;y=(c[l>>2]|0)-h|0;c[l>>2]=y;c[s>>2]=(c[s>>2]|0)-h;C=c[t>>2]|0;D=C;E=(c[u>>2]|0)+(C<<1)|0;do{E=E+-2|0;C=e[E>>1]|0;if(C>>>0<h>>>0)F=0;else F=C-h&65535;b[E>>1]=F;D=D+-1|0}while((D|0)!=0);D=h;E=(c[v>>2]|0)+(h<<1)|0;do{E=E+-2|0;C=e[E>>1]|0;if(C>>>0<h>>>0)G=0;else G=C-h&65535;b[E>>1]=G;D=D+-1|0}while((D|0)!=0);A=y;B=z+h|0}D=c[a>>2]|0;E=D+4|0;C=c[E>>2]|0;if(!C){H=23;break}I=c[k>>2]|0;J=(c[n>>2]|0)+(I+A)|0;K=C>>>0>B>>>0?B:C;if(!K){L=0;M=I}else{c[E>>2]=C-K;C=c[(c[D+28>>2]|0)+24>>2]|0;if((C|0)==1){E=D+48|0;c[E>>2]=iN(c[E>>2]|0,c[D>>2]|0,K)|0;N=D}else if((C|0)==2){C=D+48|0;c[C>>2]=jN(c[C>>2]|0,c[D>>2]|0,K)|0;N=D}else N=D;YEi(J|0,c[N>>2]|0,K|0)|0;c[N>>2]=(c[N>>2]|0)+K;J=D+8|0;c[J>>2]=(c[J>>2]|0)+K;L=K;M=c[k>>2]|0}K=M+L|0;c[k>>2]=K;if(K>>>0>2?(J=c[l>>2]|0,D=c[n>>2]|0,C=d[D+J>>0]|0,c[o>>2]=C,c[o>>2]=((d[D+(J+1)>>0]|0)^C<<c[p>>2])&c[q>>2],K>>>0>=262):0){H=23;break}if(!(c[(c[a>>2]|0)+4>>2]|0)){H=23;break}w=K;x=c[g>>2]|0}if((H|0)==23){i=f;return}}function cQ(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;g=c[b+124>>2]|0;h=c[b+56>>2]|0;j=c[b+108>>2]|0;k=h+j|0;l=c[b+120>>2]|0;m=c[b+144>>2]|0;n=(c[b+44>>2]|0)+-262|0;o=j>>>0>n>>>0?j-n|0:0;n=c[b+64>>2]|0;p=c[b+52>>2]|0;q=h+(j+258)|0;r=c[b+116>>2]|0;s=m>>>0>r>>>0?r:m;m=b+112|0;t=h+(j+1)|0;u=h+(j+2)|0;v=q;w=j+257|0;x=d;d=l;y=l>>>0<(c[b+140>>2]|0)>>>0?g:g>>>2;g=a[h+(l+j)>>0]|0;b=a[h+(j+-1+l)>>0]|0;while(1){l=h+x|0;if((((a[h+(x+d)>>0]|0)==g<<24>>24?(a[h+(d+-1+x)>>0]|0)==b<<24>>24:0)?(a[l>>0]|0)==(a[k>>0]|0):0)?(a[h+(x+1)>>0]|0)==(a[t>>0]|0):0){l=h+(x+2)|0;z=u;while(1){A=z+1|0;if((a[A>>0]|0)!=(a[l+1>>0]|0)){B=A;break}A=z+2|0;if((a[A>>0]|0)!=(a[l+2>>0]|0)){B=A;break}A=z+3|0;if((a[A>>0]|0)!=(a[l+3>>0]|0)){B=A;break}A=z+4|0;if((a[A>>0]|0)!=(a[l+4>>0]|0)){B=A;break}A=z+5|0;if((a[A>>0]|0)!=(a[l+5>>0]|0)){B=A;break}A=z+6|0;if((a[A>>0]|0)!=(a[l+6>>0]|0)){B=A;break}A=z+7|0;if((a[A>>0]|0)!=(a[l+7>>0]|0)){B=A;break}A=z+8|0;l=l+8|0;if(!(A>>>0<q>>>0?(a[A>>0]|0)==(a[l>>0]|0):0)){B=A;break}else z=A}z=B-v|0;l=z+258|0;if((l|0)>(d|0)){c[m>>2]=x;if((l|0)>=(s|0)){C=l;D=20;break}E=l;F=a[h+(l+j)>>0]|0;G=a[h+(w+z)>>0]|0}else{E=d;F=g;G=b}}else{E=d;F=g;G=b}x=e[n+((x&p)<<1)>>1]|0;if(x>>>0<=o>>>0){C=E;D=20;break}y=y+-1|0;if(!y){C=E;D=20;break}else{d=E;g=F;b=G}}if((D|0)==20){i=f;return (C>>>0>r>>>0?r:C)|0}return 0}function dQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[b+56>>2]|0;g=c[b+108>>2]|0;h=f+(g+258)|0;if((a[f+d>>0]|0)!=(a[f+g>>0]|0)){j=2;i=e;return j|0}if((a[f+(d+1)>>0]|0)!=(a[f+(g+1)>>0]|0)){j=2;i=e;return j|0}k=f+(d+2)|0;l=f+(g+2)|0;while(1){g=l+1|0;if((a[g>>0]|0)!=(a[k+1>>0]|0)){m=g;break}g=l+2|0;if((a[g>>0]|0)!=(a[k+2>>0]|0)){m=g;break}g=l+3|0;if((a[g>>0]|0)!=(a[k+3>>0]|0)){m=g;break}g=l+4|0;if((a[g>>0]|0)!=(a[k+4>>0]|0)){m=g;break}g=l+5|0;if((a[g>>0]|0)!=(a[k+5>>0]|0)){m=g;break}g=l+6|0;if((a[g>>0]|0)!=(a[k+6>>0]|0)){m=g;break}g=l+7|0;if((a[g>>0]|0)!=(a[k+7>>0]|0)){m=g;break}g=l+8|0;k=k+8|0;if(!(g>>>0<h>>>0?(a[g>>0]|0)==(a[k>>0]|0):0)){m=g;break}else l=g}l=m-h+258|0;if((l|0)<3){j=2;i=e;return j|0}c[b+112>>2]=d;d=c[b+116>>2]|0;j=l>>>0>d>>>0?d:l;i=e;return j|0}function eQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;h=c[g>>2]|0;j=c[g+4>>2]|0;g=hFi(j|0,0,d|0,0)|0;k=gFi(g|0,H|0,d|0,0)|0;l=ZEi(j|0,0,k|0,H|0)|0;k=hFi(h|0,l|0,d|0,0)|0;l=gFi(k|0,H|0,d|0,0)|0;m=ZEi(h|0,j|0,l|0,H|0)|0;l=b;c[l>>2]=k;c[l+4>>2]=g;g=a;l=c[g>>2]|0;k=c[g+4>>2]|0;g=hFi(k|0,m|0,d|0,0)|0;m=gFi(g|0,H|0,d|0,0)|0;b=ZEi(k|0,0,m|0,H|0)|0;m=hFi(l|0,b|0,d|0,0)|0;k=gFi(m|0,H|0,d|0,0)|0;j=ZEi(l|0,b|0,k|0,H|0)|0;k=a;c[k>>2]=m;c[k+4>>2]=g;if(e)c[e>>2]=j;e=cFi(j|0,H|0,1)|0;j=H;if(!(j>>>0<0|(j|0)==0&e>>>0<d>>>0)){n=1;o=n&1;i=f;return o|0}if(!((e|0)==(d|0)&(j|0)==0)){n=0;o=n&1;i=f;return o|0}n=(m&1|0)!=0|0!=0;o=n&1;i=f;return o|0}function fQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0;d=i;if((b|0)!=1)if(!(b+-1&b))e=b;else e=mri(b)|0;else e=2;b=c[a+4>>2]|0;if(e>>>0>b>>>0){kQ(a,e);i=d;return}if(e>>>0>=b>>>0){i=d;return}if(b>>>0>2)f=(b+-1&b|0)==0;else f=0;h=ea((c[a+12>>2]|0)>>>0);j=~~ea(ca(ea(h/ea(g[a+16>>2]))))>>>0;if(f)k=1<<32-(QEi(j+-1|0)|0);else k=mri(j)|0;j=e>>>0<k>>>0?k:e;if(j>>>0>=b>>>0){i=d;return}kQ(a,j);i=d;return}function gQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0;f=i;h=e+8|0;j=iI(c[c[h>>2]>>2]|0)|0;k=e+4|0;c[k>>2]=j;l=d+4|0;m=c[l>>2]|0;n=(m|0)==0;a:do if(!n){o=m+-1|0;p=(o&m|0)==0;if(p)q=o&j;else q=(j>>>0)%(m>>>0)|0;r=c[(c[d>>2]|0)+(q<<2)>>2]|0;if(!r)s=q;else{t=r;while(1){r=c[t>>2]|0;if(!r){s=q;break a}u=c[r+4>>2]|0;if(p)v=u&o;else v=(u>>>0)%(m>>>0)|0;if((v|0)!=(q|0)){s=q;break a}if(!(HEi(c[c[r+8>>2]>>2]|0,c[c[h>>2]>>2]|0)|0)){w=0;x=r;break}else t=r}c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}}else s=0;while(0);h=d+12|0;z=ea(((c[h>>2]|0)+1|0)>>>0);A=ea(m>>>0);B=ea(g[d+16>>2]);do if(z>ea(A*B)|n){if(m>>>0>2)C=(m+-1&m|0)==0;else C=0;q=(C&1|m<<1)^1;v=~~ea(ca(ea(z/B)))>>>0;lQ(d,q>>>0<v>>>0?v:q);q=c[l>>2]|0;v=c[k>>2]|0;j=q+-1|0;if(!(j&q)){D=q;E=j&v;break}else{D=q;E=(v>>>0)%(q>>>0)|0;break}}else{D=m;E=s}while(0);s=c[(c[d>>2]|0)+(E<<2)>>2]|0;if(!s){m=d+8|0;c[e>>2]=c[m>>2];c[m>>2]=e;c[(c[d>>2]|0)+(E<<2)>>2]=m;m=c[e>>2]|0;if(m){E=c[m+4>>2]|0;m=D+-1|0;if(!(m&D))F=E&m;else F=(E>>>0)%(D>>>0)|0;c[(c[d>>2]|0)+(F<<2)>>2]=e}}else{c[e>>2]=c[s>>2];c[s>>2]=e}c[h>>2]=(c[h>>2]|0)+1;w=1;x=e;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function hQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0;d=i;if((b|0)!=1)if(!(b+-1&b))e=b;else e=mri(b)|0;else e=2;b=c[a+4>>2]|0;if(e>>>0>b>>>0){mQ(a,e);i=d;return}if(e>>>0>=b>>>0){i=d;return}if(b>>>0>2)f=(b+-1&b|0)==0;else f=0;h=ea((c[a+12>>2]|0)>>>0);j=~~ea(ca(ea(h/ea(g[a+16>>2]))))>>>0;if(f)k=1<<32-(QEi(j+-1|0)|0);else k=mri(j)|0;j=e>>>0<k>>>0?k:e;if(j>>>0>=b>>>0){i=d;return}mQ(a,j);i=d;return}function iQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0;d=i;if((b|0)!=1)if(!(b+-1&b))e=b;else e=mri(b)|0;else e=2;b=c[a+4>>2]|0;if(e>>>0>b>>>0){nQ(a,e);i=d;return}if(e>>>0>=b>>>0){i=d;return}if(b>>>0>2)f=(b+-1&b|0)==0;else f=0;h=ea((c[a+12>>2]|0)>>>0);j=~~ea(ca(ea(h/ea(g[a+16>>2]))))>>>0;if(f)k=1<<32-(QEi(j+-1|0)|0);else k=mri(j)|0;j=e>>>0<k>>>0?k:e;if(j>>>0>=b>>>0){i=d;return}nQ(a,j);i=d;return}function jQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;e=(b|0)!=0;if(e)f=xCi(b<<2)|0;else f=0;g=c[a>>2]|0;c[a>>2]=f;if(g)ACi(g);c[a+4>>2]=b;if(e)h=0;else{i=d;return}do{c[(c[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(b|0));h=a+8|0;e=c[h>>2]|0;if(!e){i=d;return}g=c[e+4>>2]|0;f=b+-1|0;j=(f&b|0)==0;if(j)k=g&f;else k=(g>>>0)%(b>>>0)|0;c[(c[a>>2]|0)+(k<<2)>>2]=h;h=c[e>>2]|0;if(!h){i=d;return}else{l=e;m=h;n=k;o=e}a:while(1){e=l;k=m;h=o;b:while(1){c:do if(j){g=k;while(1){p=c[g+4>>2]&f;if((p|0)==(n|0)){q=g;break c}r=(c[a>>2]|0)+(p<<2)|0;if(!(c[r>>2]|0)){s=p;t=r;u=g;v=h;break b}r=g+12|0;w=c[g>>2]|0;d:do if(!w){x=g;y=0}else{z=c[g+8>>2]|0;A=z<<1;B=w;C=g;while(1){if((z|0)!=(c[B+8>>2]|0)){x=C;y=B;break d}if(FEi(c[r>>2]|0,c[B+12>>2]|0,A)|0){x=C;y=B;break d}D=c[B>>2]|0;if(!D){x=B;y=0;break}else{E=B;B=D;C=E}}}while(0);c[e>>2]=y;c[x>>2]=c[c[(c[a>>2]|0)+(p<<2)>>2]>>2];c[c[(c[a>>2]|0)+(p<<2)>>2]>>2]=g;g=c[e>>2]|0;if(!g){F=32;break a}}}else{g=k;while(1){r=((c[g+4>>2]|0)>>>0)%(b>>>0)|0;if((r|0)==(n|0)){q=g;break c}w=(c[a>>2]|0)+(r<<2)|0;if(!(c[w>>2]|0)){s=r;t=w;u=g;v=h;break b}w=g+12|0;C=c[g>>2]|0;e:do if(!C){G=g;H=0}else{B=c[g+8>>2]|0;A=B<<1;z=C;E=g;while(1){if((B|0)!=(c[z+8>>2]|0)){G=E;H=z;break e}if(FEi(c[w>>2]|0,c[z+12>>2]|0,A)|0){G=E;H=z;break e}D=c[z>>2]|0;if(!D){G=z;H=0;break}else{I=z;z=D;E=I}}}while(0);c[e>>2]=H;c[G>>2]=c[c[(c[a>>2]|0)+(r<<2)>>2]>>2];c[c[(c[a>>2]|0)+(r<<2)>>2]>>2]=g;g=c[e>>2]|0;if(!g){F=32;break a}}}while(0);k=c[q>>2]|0;if(!k){F=32;break a}else{e=q;h=q}}c[t>>2]=v;m=c[u>>2]|0;if(!m){F=32;break}else{l=u;n=s;o=u}}if((F|0)==32){i=d;return}}function kQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;e=(b|0)!=0;if(e)f=Ks(b<<2,0)|0;else f=0;g=c[a>>2]|0;c[a>>2]=f;if(g)Ls(g);c[a+4>>2]=b;if(e)h=0;else{i=d;return}do{c[(c[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(b|0));h=a+8|0;e=c[h>>2]|0;if(!e){i=d;return}g=c[e+4>>2]|0;f=b+-1|0;j=(f&b|0)==0;if(j)k=g&f;else k=(g>>>0)%(b>>>0)|0;c[(c[a>>2]|0)+(k<<2)>>2]=h;h=c[e>>2]|0;if(!h){i=d;return}else{l=e;m=h;n=k;o=e}a:while(1){e=l;k=m;h=o;b:while(1){g=k;while(1){p=c[g+4>>2]|0;if(j)q=p&f;else q=(p>>>0)%(b>>>0)|0;if((q|0)==(n|0)){r=g;break}p=(c[a>>2]|0)+(q<<2)|0;if(!(c[p>>2]|0)){s=q;t=p;u=g;v=h;break b}p=g+8|0;w=c[g>>2]|0;c:do if(!w){x=g;y=0}else{z=w;A=g;while(1){B=c[p>>2]|0;C=c[z+8>>2]|0;if(HEi(c[B+4>>2]|0,c[C+4>>2]|0)|0){x=A;y=z;break c}D=lL(B,C)|0;C=c[A>>2]|0;if(!D){x=A;y=C;break c}z=c[C>>2]|0;if(!z){x=C;y=0;break}else A=C}}while(0);c[e>>2]=y;c[x>>2]=c[c[(c[a>>2]|0)+(q<<2)>>2]>>2];c[c[(c[a>>2]|0)+(q<<2)>>2]>>2]=g;g=c[e>>2]|0;if(!g){E=26;break a}}g=c[r>>2]|0;if(!g){E=26;break a}else{e=r;k=g;h=r}}c[t>>2]=v;h=c[u>>2]|0;if(!h){E=26;break}else{l=u;m=h;n=s;o=u}}if((E|0)==26){i=d;return}}function lQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0;d=i;if((b|0)!=1)if(!(b+-1&b))e=b;else e=mri(b)|0;else e=2;b=c[a+4>>2]|0;if(e>>>0>b>>>0){oQ(a,e);i=d;return}if(e>>>0>=b>>>0){i=d;return}if(b>>>0>2)f=(b+-1&b|0)==0;else f=0;h=ea((c[a+12>>2]|0)>>>0);j=~~ea(ca(ea(h/ea(g[a+16>>2]))))>>>0;if(f)k=1<<32-(QEi(j+-1|0)|0);else k=mri(j)|0;j=e>>>0<k>>>0?k:e;if(j>>>0>=b>>>0){i=d;return}oQ(a,j);i=d;return}function mQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;e=(b|0)!=0;if(e)f=Ks(b<<2,0)|0;else f=0;g=c[a>>2]|0;c[a>>2]=f;if(g)Ls(g);c[a+4>>2]=b;if(e)h=0;else{i=d;return}do{c[(c[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(b|0));h=a+8|0;e=c[h>>2]|0;if(!e){i=d;return}g=c[e+4>>2]|0;f=b+-1|0;j=(f&b|0)==0;if(j)k=g&f;else k=(g>>>0)%(b>>>0)|0;c[(c[a>>2]|0)+(k<<2)>>2]=h;h=c[e>>2]|0;if(!h){i=d;return}else{l=e;m=h;n=k;o=e}a:while(1){e=l;k=m;h=o;b:while(1){c:do if(j){g=k;while(1){p=c[g+4>>2]&f;if((p|0)==(n|0)){q=g;break c}r=(c[a>>2]|0)+(p<<2)|0;if(!(c[r>>2]|0)){s=p;t=r;u=g;v=h;break b}r=c[g>>2]|0;d:do if(!r){w=g;x=0}else{y=c[g+8>>2]|0;z=c[y>>2]|0;A=y+4|0;y=r;B=g;while(1){C=c[y+8>>2]|0;if((z|0)!=(c[C>>2]|0)){w=B;x=y;break d}if((c[A>>2]|0)!=(c[C+4>>2]|0)){w=B;x=y;break d}C=c[y>>2]|0;if(!C){w=y;x=0;break}else{D=y;y=C;B=D}}}while(0);c[e>>2]=x;c[w>>2]=c[c[(c[a>>2]|0)+(p<<2)>>2]>>2];c[c[(c[a>>2]|0)+(p<<2)>>2]>>2]=g;g=c[e>>2]|0;if(!g){E=32;break a}}}else{g=k;while(1){r=((c[g+4>>2]|0)>>>0)%(b>>>0)|0;if((r|0)==(n|0)){q=g;break c}B=(c[a>>2]|0)+(r<<2)|0;if(!(c[B>>2]|0)){s=r;t=B;u=g;v=h;break b}B=c[g>>2]|0;e:do if(!B){F=g;G=0}else{y=c[g+8>>2]|0;A=c[y>>2]|0;z=y+4|0;y=B;D=g;while(1){C=c[y+8>>2]|0;if((A|0)!=(c[C>>2]|0)){F=D;G=y;break e}if((c[z>>2]|0)!=(c[C+4>>2]|0)){F=D;G=y;break e}C=c[y>>2]|0;if(!C){F=y;G=0;break}else{H=y;y=C;D=H}}}while(0);c[e>>2]=G;c[F>>2]=c[c[(c[a>>2]|0)+(r<<2)>>2]>>2];c[c[(c[a>>2]|0)+(r<<2)>>2]>>2]=g;g=c[e>>2]|0;if(!g){E=32;break a}}}while(0);k=c[q>>2]|0;if(!k){E=32;break a}else{e=q;h=q}}c[t>>2]=v;m=c[u>>2]|0;if(!m){E=32;break}else{l=u;n=s;o=u}}if((E|0)==32){i=d;return}}function nQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;e=(b|0)!=0;if(e)f=xCi(b<<2)|0;else f=0;g=c[a>>2]|0;c[a>>2]=f;if(g)ACi(g);c[a+4>>2]=b;if(e)h=0;else{i=d;return}do{c[(c[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(b|0));h=a+8|0;e=c[h>>2]|0;if(!e){i=d;return}g=c[e+4>>2]|0;f=b+-1|0;j=(f&b|0)==0;if(j)k=g&f;else k=(g>>>0)%(b>>>0)|0;c[(c[a>>2]|0)+(k<<2)>>2]=h;h=c[e>>2]|0;if(!h){i=d;return}g=a+16|0;l=e;m=h;h=k;k=e;a:while(1){e=l;n=m;o=k;b:while(1){p=n;while(1){q=c[p+4>>2]|0;if(j)r=q&f;else r=(q>>>0)%(b>>>0)|0;if((r|0)==(h|0)){s=p;break}q=(c[a>>2]|0)+(r<<2)|0;if(!(c[q>>2]|0)){t=r;u=q;v=p;w=o;break b}q=c[p>>2]|0;c:do if(!q){x=p;y=0}else{z=p+8|0;A=q;B=p;while(1){C=oK(g,c[z>>2]|0,c[A+8>>2]|0)|0;D=c[B>>2]|0;if(!C){x=B;y=D;break c}A=c[D>>2]|0;if(!A){x=D;y=0;break}else B=D}}while(0);c[e>>2]=y;c[x>>2]=c[c[(c[a>>2]|0)+(r<<2)>>2]>>2];c[c[(c[a>>2]|0)+(r<<2)>>2]>>2]=p;p=c[e>>2]|0;if(!p){E=27;break a}}p=c[s>>2]|0;if(!p){E=27;break a}else{e=s;n=p;o=s}}c[u>>2]=w;o=c[v>>2]|0;if(!o){E=27;break}else{l=v;m=o;h=t;k=v}}if((E|0)==27){i=d;return}}function oQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=(b|0)!=0;if(e)f=Ks(b<<2,0)|0;else f=0;g=c[a>>2]|0;c[a>>2]=f;if(g)Ls(g);c[a+4>>2]=b;if(e)h=0;else{i=d;return}do{c[(c[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(b|0));h=a+8|0;e=c[h>>2]|0;if(!e){i=d;return}g=c[e+4>>2]|0;f=b+-1|0;j=(f&b|0)==0;if(j)k=g&f;else k=(g>>>0)%(b>>>0)|0;c[(c[a>>2]|0)+(k<<2)>>2]=h;h=c[e>>2]|0;if(!h){i=d;return}else{l=e;m=h;n=k;o=e}a:while(1){e=l;k=m;h=o;b:while(1){g=k;while(1){p=c[g+4>>2]|0;if(j)q=p&f;else q=(p>>>0)%(b>>>0)|0;if((q|0)==(n|0)){r=g;break}p=(c[a>>2]|0)+(q<<2)|0;if(!(c[p>>2]|0)){s=q;t=p;u=g;v=h;break b}p=g+8|0;w=g;while(1){x=c[w>>2]|0;if(!x){y=w;z=x;break}if(!(HEi(c[c[p>>2]>>2]|0,c[c[x+8>>2]>>2]|0)|0))w=x;else{y=w;z=x;break}}c[e>>2]=z;c[y>>2]=c[c[(c[a>>2]|0)+(q<<2)>>2]>>2];c[c[(c[a>>2]|0)+(q<<2)>>2]>>2]=g;g=c[e>>2]|0;if(!g){A=25;break a}}g=c[r>>2]|0;if(!g){A=25;break a}else{e=r;k=g;h=r}}c[t>>2]=v;h=c[u>>2]|0;if(!h){A=25;break}else{l=u;m=h;n=s;o=u}}if((A|0)==25){i=d;return}}function pQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if((a|0)!=0?(4294967295/(c>>>0)|0)>>>0>b>>>0:0)e=PQ(a,da(c,b)|0)|0;else e=0;i=d;return e|0}function qQ(a,b){a=a|0;b=b|0;var c=0;c=i;LQ(a,b);i=c;return}function rQ(a){a=a|0;var b=0;b=i;c[a+408>>2]=jN(0,0,0)|0;i=b;return}function sQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a+208>>2]|0;if(!(c[a+372>>2]&536870912))g=(f&2048|0)==0;else g=(f&768|0)!=768;if(!(g&(d|0)!=0)){i=e;return}g=a+408|0;a=b;b=d;d=c[g>>2]|0;while(1){f=(b|0)==0?-1:b;h=jN(d,a,f)|0;if((b|0)==(f|0)){j=h;break}else{a=a+f|0;b=b-f|0;d=h}}c[g>>2]=j;i=e;return}function tQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;k=i;i=i+912|0;l=i;i=i+168|0;c[l>>2]=0;m=k+156|0;n=k;PEi(m|0,0,756)|0;c[m+624>>2]=2147483647;c[m+628>>2]=2147483647;c[m+632>>2]=0;c[m+636>>2]=0;s=0;bb(333,m|0,g|0,h|0,j|0);j=s;s=0;if((j|0)!=0&(t|0)!=0){o=WEi(c[j>>2]|0,l)|0;if(!o)lk(j|0,t|0);H=t}else o=-1;if((o|0)!=1){s=0;bb(334,m|0,d|0,e|0,f|0);f=s;s=0;if((f|0)!=0&(t|0)!=0){p=WEi(c[f>>2]|0,l)|0;if(!p)lk(f|0,t|0);H=t}else p=-1;if((p|0)!=1){REi(n,1,l|0)|0;s=0;p=s;s=0;if((p|0)!=0&(t|0)!=0){q=WEi(c[p>>2]|0,l)|0;if(!q)lk(p|0,t|0);H=t}else q=-1;if((q|0)!=1)r=0;else r=H}else r=H}else r=H;while(1){if(r){u=0;v=30;break}w=m+160|0;c[w>>2]=n;x=m+164|0;c[x>>2]=0;y=m+156|0;c[y>>2]=2599;q=(b|0)==0;p=m+208|0;if(!q){if((a[b>>0]|0)!=49)c[p>>2]=c[p>>2]|131072;if((a[b+1>>0]|0)!=46)c[p>>2]=c[p>>2]|131072;if((a[b+2>>0]|0)!=54)c[p>>2]=c[p>>2]|131072;if((a[b+3>>0]|0)!=46)c[p>>2]=c[p>>2]|131072;if((a[b+4>>0]|0)!=49)c[p>>2]=c[p>>2]|131072;f=c[p>>2]|0;if((a[b+5>>0]|0)==48)z=f;else{e=f|131072;c[p>>2]=e;z=e}if(!(a[b+6>>0]|0))A=z;else{e=z|131072;c[p>>2]=e;A=e}}else{e=c[p>>2]|131072;c[p>>2]=e;A=e}if(A&131072){if(q){u=0;v=30;break}if((a[b>>0]|0)!=49){u=0;v=30;break}if((a[b+2>>0]|0)!=54){u=0;v=30;break}if((a[b+3>>0]|0)!=46){u=0;v=30;break}}s=0;B=yb(2588,m|0,756)|0;q=s;s=0;if((q|0)!=0&(t|0)!=0){C=WEi(c[q>>2]|0,l)|0;if(!C)lk(q|0,t|0);H=t}else C=-1;if((C|0)==1)r=H;else{v=28;break}}if((v|0)==28){if(!B){u=0;i=k;return u|0}c[m+252>>2]=1726;c[m+256>>2]=2600;c[m+260>>2]=B;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;YEi(B|0,m|0,756)|0;u=B;i=k;return u|0}else if((v|0)==30){i=k;return u|0}return 0}function uQ(a){a=a|0;var b=0,c=0,d=0;b=i;if(a){c=OQ(a,244)|0;if(!c)d=c;else{PEi(c|0,0,244)|0;d=c}}else d=0;i=b;return d|0}function vQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((a|0)==0|(b|0)==0){i=d;return}e=c[b>>2]|0;if(!e){i=d;return}c[b>>2]=0;wQ(a,e,32767,-1);PEi(e|0,0,244)|0;LQ(a,e);i=d;return}function wQ(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;if((e|0)==0|(f|0)==0){i=j;return}k=f+220|0;do if(g&16384&c[k>>2])if((h|0)==-1){l=f+128|0;if((c[l>>2]|0)>0){m=0;do{wQ(e,f,16384,m);m=m+1|0}while((m|0)<(c[l>>2]|0))}m=f+136|0;LQ(e,c[m>>2]|0);c[m>>2]=0;c[l>>2]=0;break}else{m=f+136|0;n=c[m>>2]|0;if(!n)break;o=c[n+(h*28|0)+4>>2]|0;if(!o)break;LQ(e,o);c[(c[m>>2]|0)+(h*28|0)+4>>2]=0;break}while(0);m=c[k>>2]|0;if(!(g&8192&m))p=m;else{m=f+148|0;LQ(e,c[m>>2]|0);c[m>>2]=0;m=f+8|0;c[m>>2]=c[m>>2]&-17;p=c[k>>2]|0}if(!(g&256&p))q=p;else{p=f+236|0;LQ(e,c[p>>2]|0);m=f+240|0;LQ(e,c[m>>2]|0);c[p>>2]=0;c[m>>2]=0;m=f+8|0;c[m>>2]=c[m>>2]&-16385;q=c[k>>2]|0}if(!(g&128&q))r=q;else{q=f+196|0;LQ(e,c[q>>2]|0);m=f+208|0;LQ(e,c[m>>2]|0);c[q>>2]=0;c[m>>2]=0;m=f+212|0;q=c[m>>2]|0;if(q){p=f+217|0;if(!(a[p>>0]|0))s=q;else{o=q;q=0;while(1){LQ(e,c[o+(q<<2)>>2]|0);c[(c[m>>2]|0)+(q<<2)>>2]=0;q=q+1|0;n=c[m>>2]|0;if(q>>>0>=(d[p>>0]|0)>>>0){s=n;break}else o=n}}LQ(e,s);c[m>>2]=0}m=f+8|0;c[m>>2]=c[m>>2]&-1025;r=c[k>>2]|0}if(!(g&16&r))t=r;else{r=f+116|0;LQ(e,c[r>>2]|0);m=f+120|0;LQ(e,c[m>>2]|0);c[r>>2]=0;c[m>>2]=0;m=f+8|0;c[m>>2]=c[m>>2]&-4097;t=c[k>>2]|0}do if(g&32&t){if((h|0)!=-1){m=f+224|0;r=c[m>>2]|0;if(!r)break;LQ(e,c[r+(h<<4)>>2]|0);LQ(e,c[(c[m>>2]|0)+(h<<4)+8>>2]|0);r=c[m>>2]|0;c[r+(h<<4)>>2]=0;c[r+(h<<4)+8>>2]=0;break}r=f+228|0;m=c[r>>2]|0;if(m){if((m|0)>0){m=0;do{wQ(e,f,32,m);m=m+1|0}while((m|0)<(c[r>>2]|0))}m=f+224|0;LQ(e,c[m>>2]|0);c[m>>2]=0;c[r>>2]=0}m=f+8|0;c[m>>2]=c[m>>2]&-8193}while(0);t=c[k>>2]|0;if(!(g&4096&t))u=t;else{t=f+16|0;LQ(e,c[t>>2]|0);c[t>>2]=0;t=f+8|0;c[t>>2]=c[t>>2]&-9;b[f+20>>1]=0;u=c[k>>2]|0}c[k>>2]=u&~((h|0)==-1?g:g&-16929);i=j;return}function xQ(a){a=a|0;var b=0;if(!a)b=0;else b=c[a+184>>2]|0;return b|0}function yQ(b,c){b=b|0;c=c|0;a[b>>0]=c>>>24;a[b+1>>0]=c>>>16;a[b+2>>0]=c>>>8;a[b+3>>0]=c;return}function zQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+244|0;a:do if(!(c[e>>2]|0))do switch(b|0){case -7:{c[e>>2]=417968;break a;break}case -3:{c[e>>2]=417872;break a;break}case 1:{c[e>>2]=417776;break a;break}case -1:{c[e>>2]=417832;break a;break}case -4:{c[e>>2]=417896;break a;break}case -5:{c[e>>2]=417920;break a;break}case -2:{c[e>>2]=417848;break a;break}case -6:{c[e>>2]=417936;break a;break}case 2:{c[e>>2]=417808;break a;break}default:{c[e>>2]=417744;break a}}while(0);while(0);i=d;return}function AQ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;switch(e|0){case 1:case 2:case 4:case 8:case 16:{l=(d|0)<0?1:(b|0)<0?1:(c[a+628>>2]|0)>>>0<d>>>0?1:(c[a+624>>2]|0)>>>0<b>>>0?1:(d|0)==0?1:(b|0)==0&1;break}default:l=1}if(!((f|0)==3&(e|0)>8)?!(((f|0)==2|(f|0)==4|(f|0)==6)&(e|0)<8):0)m=(f|0)<0|(f|0)==1|(f|0)==5|(f|0)>6?1:l;else m=1;l=(h|0)==0?((g|0)>1?1:m):1;m=c[a+204>>2]&4096;if(j){if(((j|0)==64?(c[a+596>>2]&4|0)!=0:0)?(m|0)==0&(f&-5|0)==2:0)n=l;else n=1;if(!m)o=n;else BQ(a,417992)}else o=l;if((o|0)==1)BQ(a,417992);else{i=k;return}}function BQ(a,b){a=a|0;b=b|0;var d=0;if((a|0)!=0?(d=c[a+168>>2]|0,(d|0)!=0):0)In[d&4095](a,b);IQ(a,1)}function CQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!((b|0)!=0&d>>>0<c>>>0)){g=d;i=f;return g|0}if((e|0)!=0?(h=a[e>>0]|0,j=c+-1|0,h<<24>>24!=0&j>>>0>d>>>0):0){c=d;k=e;e=h;while(1){k=k+1|0;h=c+1|0;a[b+c>>0]=e;e=a[k>>0]|0;if(!(e<<24>>24!=0&h>>>0<j>>>0)){l=h;break}else c=h}}else l=d;a[b+l>>0]=0;g=l;i=f;return g|0}function DQ(a,b){a=a|0;b=b|0;if(c[a+208>>2]&1048576)return;if(!(c[a+204>>2]&32768))BQ(a,b);if(!(c[a+372>>2]|0))BQ(a,b);else EQ(a,b)}function EQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+224|0;f=e;if(!b)BQ(0,d);e=c[b+372>>2]|0;g=e>>>24;if((g+-65|0)>>>0>57|(g+-91|0)>>>0<6){a[f>>0]=91;a[f+1>>0]=a[3672760+(e>>>28)>>0]|0;a[f+2>>0]=a[3672760+(g&15)>>0]|0;a[f+3>>0]=93;h=4}else{a[f>>0]=g;h=1}g=e>>>16;j=g&255;if((j+-65|0)>>>0>57|(j+-91|0)>>>0<6){a[f+h>>0]=91;a[f+(h+1)>>0]=a[3672760+(e>>>20&15)>>0]|0;a[f+(h|2)>>0]=a[3672760+(g&15)>>0]|0;a[f+(h+3)>>0]=93;k=h+4|0}else{a[f+h>>0]=g;k=h+1|0}h=e>>>8;g=h&255;if((g+-65|0)>>>0>57|(g+-91|0)>>>0<6){a[f+k>>0]=91;a[f+(k+1)>>0]=a[3672760+(e>>>12&15)>>0]|0;a[f+(k+2)>>0]=a[3672760+(h&15)>>0]|0;a[f+(k+3)>>0]=93;l=k+4|0}else{a[f+k>>0]=h;l=k+1|0}k=e&255;if((k+-65|0)>>>0>57|(k+-91|0)>>>0<6){a[f+l>>0]=91;a[f+(l+1)>>0]=a[3672760+(e>>>4&15)>>0]|0;a[f+(l+2)>>0]=a[3672760+(e&15)>>0]|0;a[f+(l+3)>>0]=93;m=l+4|0}else{a[f+l>>0]=e;m=l+1|0}if(!d){a[f+m>>0]=0;BQ(b,f)}a[f+m>>0]=58;a[f+(m+1)>>0]=32;l=0;e=m+2|0;while(1){m=a[d+l>>0]|0;if(!(m<<24>>24)){n=e;break}l=l+1|0;k=e+1|0;a[f+e>>0]=m;if((l|0)>=195){n=k;break}else e=k}a[f+n>>0]=0;BQ(b,f)}function FQ(a,b){a=a|0;b=b|0;var d=0;d=i;if(!(c[a+208>>2]&2097152))BQ(a,b);else{i=d;return}}function GQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if(!a){f=0;i=e;return f|0}g=a+160|0;h=c[g>>2]|0;j=a+164|0;do if(!h){c[j>>2]=0;if(d>>>0<157){c[g>>2]=a;k=a;break}l=PQ(a,d)|0;c[g>>2]=l;if(!l){f=0;i=e;return f|0}else{c[j>>2]=d;k=l;break}}else{l=c[j>>2]|0;if(!l)if((h|0)==(a|0))m=156;else BQ(a,418016);else m=l;if((m|0)==(d|0))k=h;else{f=0;i=e;return f|0}}while(0);c[a+156>>2]=b;f=k;i=e;return f|0}function HQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+160|0;d=i;i=i+168|0;c[d>>2]=0;e=b;if(!a){i=b;return}f=a+160|0;g=c[f>>2]|0;h=a+164|0;a:do if((g|0)!=0?!((c[h>>2]|0)==0|(g|0)==(a|0)):0){REi(e,1,d|0)|0;s=0;j=s;s=0;if((j|0)!=0&(t|0)!=0){k=WEi(c[j>>2]|0,d)|0;if(!k)lk(j|0,t|0);H=t}else k=-1;if((k|0)==1)l=H;else l=0;while(1){if(l)break a;c[f>>2]=e;c[h>>2]=0;c[a+156>>2]=2599;s=0;gb(2601,a|0,g|0);j=s;s=0;if((j|0)!=0&(t|0)!=0){m=WEi(c[j>>2]|0,d)|0;if(!m)lk(j|0,t|0);H=t}else m=-1;if((m|0)==1)l=H;else break}}while(0);c[h>>2]=0;c[f>>2]=0;c[a+156>>2]=0;i=b;return}function IQ(a,b){a=a|0;b=b|0;var d=0,e=0;if(((a|0)!=0?(d=c[a+156>>2]|0,(d|0)!=0):0)?(e=c[a+160>>2]|0,(e|0)!=0):0)In[d&4095](e,b);Vl()}function JQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;if(!a){i=e;return}c[a+172>>2]=b;c[a+168>>2]=d;i=e;return}function KQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+768|0;d=b;if(!a){i=b;return}YEi(d|0,a|0,756)|0;PEi(a|0,0,756)|0;e=c[d+612>>2]|0;if(!e)BDi(a);else In[e&4095](d,a);HQ(d);i=b;return}function LQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((a|0)==0|(b|0)==0){i=d;return}e=c[a+612>>2]|0;if(!e){BDi(b);i=d;return}else{In[e&4095](a,b);i=d;return}}function MQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(!a){e=0;i=d;return e|0}if(!b)BQ(a,418048);f=c[a+608>>2]|0;if(!f)g=ADi(b)|0;else g=_n[f&4095](a,b)|0;if(!g)BQ(a,418048);PEi(g|0,0,b|0)|0;e=g;i=d;return e|0}function NQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(!a){e=0;i=d;return e|0}if(!b)BQ(a,418048);f=c[a+608>>2]|0;if(!f)g=ADi(b)|0;else g=_n[f&4095](a,b)|0;if(!g)BQ(a,418048);else{e=g;i=d;return e|0}return 0}function OQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do if(!b)e=0;else{if((a|0)!=0?(f=c[a+608>>2]|0,(f|0)!=0):0){e=_n[f&4095](a,b)|0;break}e=ADi(b)|0}while(0);i=d;return e|0}function PQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(!((a|0)==0|(b|0)==0)){e=c[a+608>>2]|0;if(!e)f=ADi(b)|0;else f=_n[e&4095](a,b)|0;if(f){g=f;i=d;return g|0}}g=0;i=d;return g|0}function QQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;if(!a){i=f;return}c[a+604>>2]=b;c[a+608>>2]=d;c[a+612>>2]=e;i=f;return}function RQ(b,e,f,g,h,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;n=i;if((b|0)==0|(e|0)==0){i=n;return}c[e>>2]=f;c[e+4>>2]=g;o=e+24|0;a[o>>0]=h;p=e+25|0;a[p>>0]=j;a[e+26>>0]=l;a[e+27>>0]=m;a[e+28>>0]=k;AQ(b,f,g,h&255,j&255,k&255,l&255,m&255);m=a[p>>0]|0;if(m<<24>>24!=3){p=(m&2)==0?1:3;a[e+29>>0]=p;if(!(m&4))q=p;else{m=p+1<<24>>24;a[e+29>>0]=m;q=m}}else{a[e+29>>0]=1;q=1}m=da(d[o>>0]|0,q&255)|0;a[e+30>>0]=m;q=m&255;if(q>>>0>7)r=da(q>>>3,f)|0;else r=((da(q,f)|0)+7|0)>>>3;c[e+12>>2]=r;i=n;return}function SQ(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if((a[b+9>>0]|0)!=16){i=f;return}g=da(d[b+10>>0]|0,c[b>>2]|0)|0;if(!g){i=f;return}else{h=0;j=e}while(1){e=a[j>>0]|0;b=j+1|0;a[j>>0]=a[b>>0]|0;a[b>>0]=e;h=h+1|0;if((h|0)==(g|0))break;else j=j+2|0}i=f;return}function TQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=b+4|0;h=c[g>>2]|0;j=d+h|0;k=b+10|0;l=a[k>>0]|0;if(l<<24>>24==2){m=a[b+9>>0]|0;if(m<<24>>24==16){if(!e){n=d+2|0;o=d+4|0}else{n=d;o=d+2|0}if(o>>>0<j>>>0){p=((d+(h+-1-o)|0)>>>2<<1)+2|0;q=n;r=o;while(1){a[q>>0]=a[r>>0]|0;a[q+1>>0]=a[r+1>>0]|0;r=r+4|0;if(r>>>0>=j>>>0)break;else q=q+2|0}s=n+p|0}else s=n;a[b+11>>0]=16;t=s}else if(m<<24>>24==8){if(!e){u=d+1|0;v=d+2|0}else{u=d;v=d+1|0}if(v>>>0<j>>>0){m=((d+(h+-1-v)|0)>>>1)+1|0;s=u;n=v;while(1){a[s>>0]=a[n>>0]|0;n=n+2|0;if(n>>>0>=j>>>0)break;else s=s+1|0}w=u+m|0}else w=u;a[b+11>>0]=8;t=w}else{i=f;return}a[k>>0]=1;w=b+8|0;if((a[w>>0]|0)==4){a[w>>0]=0;x=t}else x=t}else if(l<<24>>24==4){l=a[b+9>>0]|0;if(l<<24>>24==8){if(!e){y=d+3|0;z=d+4|0}else{y=d;z=d+1|0}if(z>>>0<j>>>0){t=(((d+(h+-1-z)|0)>>>2)*3|0)+3|0;w=y;u=z;while(1){a[w>>0]=a[u>>0]|0;a[w+1>>0]=a[u+1>>0]|0;a[w+2>>0]=a[u+2>>0]|0;u=u+4|0;if(u>>>0>=j>>>0)break;else w=w+3|0}A=y+t|0}else A=y;a[b+11>>0]=24;B=A}else if(l<<24>>24==16){if(!e){C=d+6|0;D=d+8|0}else{C=d;D=d+2|0}if(D>>>0<j>>>0){e=(((d+(h+-1-D)|0)>>>3)*6|0)+6|0;h=C;l=D;while(1){a[h>>0]=a[l>>0]|0;a[h+1>>0]=a[l+1>>0]|0;a[h+2>>0]=a[l+2>>0]|0;a[h+3>>0]=a[l+3>>0]|0;a[h+4>>0]=a[l+4>>0]|0;a[h+5>>0]=a[l+5>>0]|0;l=l+8|0;if(l>>>0>=j>>>0)break;else h=h+6|0}E=C+e|0}else E=C;a[b+11>>0]=48;B=E}else{i=f;return}a[k>>0]=3;k=b+8|0;if((a[k>>0]|0)==6){a[k>>0]=2;x=B}else x=B}else{i=f;return}c[g>>2]=x-d;i=f;return}function UQ(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=b[e+416>>1]|0;j=d[f+9>>0]|0;if((h&65535|0)>=(1<<j|0)|h<<16>>16==0){i=g;return}h=(da(c[f>>2]|0,0-(d[f+11>>0]|0)|0)|0)&7;k=c[e+380>>2]|0;l=c[f+4>>2]|0;f=k+l|0;if((j|0)==2){if((l|0)<=0){i=g;return}m=e+420|0;n=c[m>>2]|0;o=h;p=f;while(1){q=a[p>>0]|0;r=(q&255)>>>o&3;if((r|0)>(n|0)){c[m>>2]=r;s=a[p>>0]|0;t=r}else{s=q;t=n}q=(s&255)>>>o>>>2&3;if((q|0)>(t|0)){c[m>>2]=q;u=a[p>>0]|0;v=q}else{u=s;v=t}q=(u&255)>>>o>>>4&3;if((q|0)>(v|0)){c[m>>2]=q;w=a[p>>0]|0;x=q}else{w=u;x=v}q=(w&255)>>>o>>>6&3;if((q|0)>(x|0)){c[m>>2]=q;y=q}else y=x;p=p+-1|0;if(p>>>0<=k>>>0)break;else{n=y;o=0}}i=g;return}else if((j|0)==1){if((l|0)<=0){i=g;return}o=e+420|0;y=h;n=f;while(1){if((d[n>>0]|0)>>>y)c[o>>2]=1;n=n+-1|0;if(n>>>0<=k>>>0)break;else y=0}i=g;return}else if((j|0)==8){if((l|0)<=0){i=g;return}y=e+420|0;n=c[y>>2]|0;o=f;while(1){p=d[o>>0]|0;if((p|0)>(n|0)){c[y>>2]=p;z=p}else z=n;o=o+-1|0;if(o>>>0<=k>>>0)break;else n=z}i=g;return}else if((j|0)==4){if((l|0)<=0){i=g;return}l=e+420|0;e=c[l>>2]|0;j=h;h=f;while(1){f=a[h>>0]|0;z=(f&255)>>>j&15;if((z|0)>(e|0)){c[l>>2]=z;A=a[h>>0]|0;B=z}else{A=f;B=e}f=(A&255)>>>j>>>4&15;if((f|0)>(B|0)){c[l>>2]=f;C=f}else C=B;h=h+-1|0;if(h>>>0<=k>>>0)break;else{e=C;j=0}}i=g;return}else{i=g;return}}function VQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+176>>2]|0;if(!f)BQ(a,418064);else{co[f&2047](a,b,d);i=e;return}}function WQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(!a){i=e;return}if((_f(b|0,1,d|0,c[a+184>>2]|0)|0)==(d|0)){i=e;return}else BQ(a,418096)}function XQ(a){a=a|0;var b=0,d=0;b=i;d=c[a+468>>2]|0;if(!d){i=b;return}ko[d&4095](a);i=b;return}function YQ(a){a=a|0;var b=0;b=i;if(!a){i=b;return}Wg(c[a+184>>2]|0)|0;i=b;return}function ZQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;if(!a){i=f;return}c[a+184>>2]=b;c[a+176>>2]=(d|0)==0?1782:d;c[a+468>>2]=(e|0)==0?3492:e;e=a+180|0;if(!(c[e>>2]|0)){i=f;return}c[e>>2]=0;i=f;return}function _Q(a,f){a=a|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((a|0)==0|(f|0)==0){i=g;return}h=a+204|0;if(c[h>>2]&1024){i=g;return}hR(a);if((c[h>>2]&4096|0)!=0?(j=a+596|0,(c[j>>2]|0)!=0):0)c[j>>2]=0;j=f+25|0;jR(a,c[f>>2]|0,c[f+4>>2]|0,d[f+24>>0]|0,d[j>>0]|0,d[f+26>>0]|0,d[f+27>>0]|0,0);k=f+114|0;l=b[k>>1]|0;if((l&-32760)<<16>>16==8?(c[f+8>>2]&1|0)!=0:0){nR(a,c[f+40>>2]|0);m=b[k>>1]|0}else m=l;l=f+8|0;do if(m<<16>>16>=0){n=c[l>>2]|0;o=(n&2048|0)==0;if(!(n&4096)){if(o)break;oR(a,e[f+112>>1]|0);break}if(!o)FQ(a,418112);pR(a,c[f+116>>2]|0,c[f+120>>2]|0)}while(0);if(c[l>>2]&2)rR(a,f+140|0,d[j>>0]|0);if((b[k>>1]&-32752)<<16>>16==16?(c[l>>2]&4|0)!=0:0)sR(a,f+44|0);c[h>>2]=c[h>>2]|1024;i=g;return}function $Q(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;if((f|0)==0|(g|0)==0){i=h;return}_Q(f,g);j=g+8|0;k=c[j>>2]|0;if(!(k&8))if((a[g+25>>0]|0)==3)BQ(f,418160);else l=k;else{kR(f,c[g+16>>2]|0,e[g+20>>1]|0);l=c[j>>2]|0}if(!(l&16))m=l;else{l=g+25|0;if(((c[f+212>>2]&524288|0)!=0?(a[l>>0]|0)==3:0)?(k=g+22|0,(b[k>>1]|0)!=0):0){n=g+148|0;o=0;do{p=(c[n>>2]|0)+o|0;a[p>>0]=d[p>>0]^255;o=o+1|0}while((o|0)<(e[k>>1]|0))}tR(f,c[g+148>>2]|0,g+152|0,e[g+22>>1]|0,d[l>>0]|0);m=c[j>>2]|0}if(!(m&32))q=m;else{uR(f,g+162|0,d[g+25>>0]|0);q=c[j>>2]|0}if(!(q&256))r=q;else{yR(f,c[g+172>>2]|0,c[g+176>>2]|0,d[g+180>>0]|0);r=c[j>>2]|0}if(!(r&1024))s=r;else{zR(f,c[g+196>>2]|0,c[g+200>>2]|0,c[g+204>>2]|0,d[g+216>>0]|0,d[g+217>>0]|0,c[g+208>>2]|0,c[g+212>>2]|0);s=c[j>>2]|0}if(!(s&16384))t=s;else{AR(f,d[g+232>>0]|0,c[g+236>>2]|0,c[g+240>>2]|0);t=c[j>>2]|0}if(!(t&128))u=t;else{BR(f,c[g+184>>2]|0,c[g+188>>2]|0,d[g+192>>0]|0);u=c[j>>2]|0}if((u&8192|0)!=0?(u=g+228|0,(c[u>>2]|0)>0):0){j=g+224|0;t=0;do{qR(f,(c[j>>2]|0)+(t<<4)|0);t=t+1|0}while((t|0)<(c[u>>2]|0))}u=g+128|0;if((c[u>>2]|0)<=0){i=h;return}t=g+136|0;g=c[t>>2]|0;j=0;while(1){s=c[g+(j*28|0)>>2]|0;do if((s|0)<=0)if((s|0)==-1){vR(f,c[g+(j*28|0)+4>>2]|0,c[g+(j*28|0)+8>>2]|0,0);r=c[t>>2]|0;c[r+(j*28|0)>>2]=-3;v=r;break}else if(!s){wR(f,c[g+(j*28|0)+4>>2]|0,c[g+(j*28|0)+8>>2]|0,0,0);r=c[t>>2]|0;c[r+(j*28|0)>>2]=-2;v=r;break}else{v=g;break}else{xR(f,s,c[g+(j*28|0)+4>>2]|0,c[g+(j*28|0)+20>>2]|0,c[g+(j*28|0)+24>>2]|0,c[g+(j*28|0)+8>>2]|0);r=c[t>>2]|0;c[r+(j*28|0)>>2]=-3;v=r}while(0);j=j+1|0;if((j|0)>=(c[u>>2]|0))break;else g=v}i=h;return}function aR(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;if(!a){i=d;return}f=a+204|0;if(!(c[f>>2]&4))BQ(a,418208);if((c[a+420>>2]|0)>(e[a+416>>1]|0|0))DQ(a,418240);if((b|0)!=0?(g=b+128|0,(c[g>>2]|0)>0):0){h=b+136|0;b=c[h>>2]|0;j=0;while(1){k=c[b+(j*28|0)>>2]|0;do if((k|0)<=0){if((k|0)>-1){wR(a,c[b+(j*28|0)+4>>2]|0,c[b+(j*28|0)+8>>2]|0,0,k);l=c[h>>2]|0;c[l+(j*28|0)>>2]=-2;m=l;break}if((k|0)==-1){vR(a,c[b+(j*28|0)+4>>2]|0,c[b+(j*28|0)+8>>2]|0,0);l=c[h>>2]|0;c[l+(j*28|0)>>2]=-3;m=l}else m=b}else{xR(a,k,c[b+(j*28|0)+4>>2]|0,c[b+(j*28|0)+20>>2]|0,c[b+(j*28|0)+24>>2]|0,c[b+(j*28|0)+8>>2]|0);l=c[h>>2]|0;c[l+(j*28|0)>>2]=-3;m=l}while(0);j=j+1|0;if((j|0)>=(c[g>>2]|0))break;else b=m}}c[f>>2]=c[f>>2]|8;mR(a);i=d;return}function bR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=tQ(a,b,d,e,0,0,0)|0;if(!g){i=f;return g|0}c[g+280>>2]=8192;c[g+300>>2]=1;c[g+284>>2]=-1;c[g+296>>2]=8;c[g+292>>2]=15;c[g+288>>2]=8;c[g+320>>2]=0;c[g+304>>2]=-1;c[g+316>>2]=8;c[g+312>>2]=15;c[g+308>>2]=8;e=g+208|0;c[e>>2]=c[e>>2]|2097152;ZQ(g,0,0,0);i=f;return g|0}function cR(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;if(!e){i=g;return}j=e+368|0;do if((c[j>>2]|0)==0?(a[e+429>>0]|0)==0:0)if(!(c[e+204>>2]&1024))BQ(e,418288);else{CR(e);break}while(0);k=h+8|0;a[k>>0]=a[e+431>>0]|0;l=c[e+356>>2]|0;c[h>>2]=l;m=a[e+436>>0]|0;a[h+10>>0]=m;n=a[e+433>>0]|0;a[h+9>>0]=n;o=da(m&255,n&255)|0;n=o&255;m=h+11|0;a[m>>0]=n;p=o&255;if(p>>>0>7)q=da(p>>>3,l)|0;else q=((da(p,l)|0)+7|0)>>>3;c[h+4>>2]=q;l=e+380|0;YEi((c[l>>2]|0)+1|0,f|0,q|0)|0;if(!(c[e+212>>2]|0))r=n;else{gR(e,h);r=a[m>>0]|0}if(r<<24>>24!=(a[e+434>>0]|0))BQ(e,418344);if(r<<24>>24!=(a[e+439>>0]|0))BQ(e,418344);do if(((c[e+596>>2]&4|0)!=0?(a[e+600>>0]|0)==64:0)?(r=(c[l>>2]|0)+1|0,m=c[h>>2]|0,n=b[k>>1]|0,q=n&255,(q&2)!=0&(n&-256)<<16>>16==2048):0){if(q<<24>>24==6)s=4;else if(q<<24>>24==2)s=3;else break;if(m){q=0;n=r;while(1){r=d[n+1>>0]|0;a[n>>0]=(d[n>>0]|0)-r;f=n+2|0;a[f>>0]=(d[f>>0]|0)-r;q=q+1|0;if((q|0)==(m|0))break;else n=n+s|0}}}while(0);if((a[k>>0]|0)==3?(c[e+420>>2]|0)>-1:0)UQ(e,h);DR(e,h);h=c[e+544>>2]|0;if(!h){i=g;return}co[h&2047](e,c[j>>2]|0,d[e+429>>0]|0);i=g;return}function dR(a){a=a|0;var b=0;b=i;if(!a){i=b;return}if((c[a+368>>2]|0)>>>0>=(c[a+352>>2]|0)>>>0){i=b;return}lR(a,0,0,2);c[a+476>>2]=0;XQ(a);i=b;return}function eR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!a){i=d;return}e=c[a>>2]|0;if(!e){i=d;return}vQ(e,b);c[a>>2]=0;if(c[e+208>>2]&2)lN(e+220|0)|0;iR(e,e+276|0);LQ(e,c[e+380>>2]|0);LQ(e,c[e+376>>2]|0);LQ(e,c[e+384>>2]|0);LQ(e,c[e+388>>2]|0);LQ(e,c[e+392>>2]|0);LQ(e,c[e+396>>2]|0);LQ(e,c[e+592>>2]|0);KQ(e);i=d;return}function fR(a,b){a=a|0;b=b|0;if(a)c[a+284>>2]=b;return}function gR(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;if(!b){i=f;return}g=b+212|0;h=c[g>>2]|0;if((h&1048576|0)!=0?(j=c[b+192>>2]|0,(j|0)!=0):0){co[j&2047](b,e,(c[b+380>>2]|0)+1|0);k=c[g>>2]|0}else k=h;if(!(k&32768))l=k;else{TQ(e,(c[b+380>>2]|0)+1|0,(c[b+208>>2]|0)>>>7&1^1);l=c[g>>2]|0}if(!(l&16))m=l;else{SQ(e,(c[b+380>>2]|0)+1|0);m=c[g>>2]|0}do if(m&131072){l=(c[b+380>>2]|0)+1|0;k=a[e+8>>0]|0;if(k<<24>>24==6){if((a[e+9>>0]|0)!=8)break;h=c[e>>2]|0;if(!h)break;else{n=0;o=l}while(1){j=o+1|0;p=a[o>>0]|0;q=o+2|0;a[o>>0]=a[j>>0]|0;r=o+3|0;a[j>>0]=a[q>>0]|0;a[q>>0]=a[r>>0]|0;a[r>>0]=p;n=n+1|0;if((n|0)==(h|0))break;else o=o+4|0}}else if(k<<24>>24==4){if((a[e+9>>0]|0)!=8)break;h=c[e>>2]|0;if(!h)break;else{s=l;t=0}while(1){p=s+1|0;r=a[s>>0]|0;a[s>>0]=a[p>>0]|0;a[p>>0]=r;t=t+1|0;if((t|0)==(h|0))break;else s=s+2|0}}else break}while(0);if(!(c[g>>2]&524288)){i=f;return}g=(c[b+380>>2]|0)+1|0;b=a[e+8>>0]|0;if(b<<24>>24==4){if((a[e+9>>0]|0)!=8){i=f;return}s=c[e>>2]|0;if(!s){i=f;return}else{u=g;v=0}while(1){t=u+1|0;a[t>>0]=d[t>>0]^255;v=v+1|0;if((v|0)==(s|0))break;else u=u+2|0}i=f;return}else if(b<<24>>24==6){if((a[e+9>>0]|0)!=8){i=f;return}b=c[e>>2]|0;if(!b){i=f;return}else{w=0;x=g}while(1){g=x+3|0;a[g>>0]=d[g>>0]^255;w=w+1|0;if((w|0)==(b|0))break;else x=x+4|0}i=f;return}else{i=f;return}}function hR(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b;f=e;c[f>>2]=1196314761;c[f+4>>2]=169478669;c[a+656>>2]=18;f=a+437|0;g=d[f>>0]|0;VQ(a,e+g|0,8-g|0);if((d[f>>0]|0)>=3){i=b;return}f=a+204|0;c[f>>2]=c[f>>2]|4096;i=b;return}function iR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;if(!e){i=d;return}c[b>>2]=0;b=e;do{e=b;b=c[b>>2]|0;LQ(a,e)}while((b|0)!=0);i=d;return}function jR(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=i;i=i+32|0;j=l+16|0;m=l;a:do switch(h|0){case 3:{if((g|0)==8|(g|0)==4|(g|0)==2|(g|0)==1){a[b+435>>0]=1;n=1;break a}else BQ(b,418456);break}case 0:{if((g|0)==8|(g|0)==4|(g|0)==2|(g|0)==1){a[b+435>>0]=1;n=1;break a}else BQ(b,418384);break}case 2:{if((g|0)==8){a[b+435>>0]=3;n=3;break a}else BQ(b,418424);break}case 4:{if((g|0)==8|(g|0)==16){a[b+435>>0]=2;n=2;break a}else BQ(b,418496);break}case 6:{if((g|0)==8){a[b+435>>0]=4;n=4;break a}else BQ(b,418544);break}default:BQ(b,418584)}while(0);if((c[b+596>>2]&4|0)!=0?(c[b+204>>2]&4096|0)==0:0)if(((k|0)!=64|(h&-5|0)!=2)&(k|0)!=0)o=22;else p=k;else if(!k)p=0;else o=22;if((o|0)==22)p=0;o=g&255;k=b+432|0;a[k>>0]=o;q=h&255;h=b+431|0;a[h>>0]=q;a[b+428>>0]=0;r=p&255;a[b+600>>0]=r;a[b+620>>0]=0;c[b+344>>2]=e;c[b+348>>2]=f;p=da(n&255,g)|0;a[b+434>>0]=p;g=p&255;if(g>>>0>7)s=da(g>>>3,e)|0;else s=((da(g,e)|0)+7|0)>>>3;c[b+360>>2]=s;c[b+356>>2]=e;a[b+433>>0]=o;a[b+436>>0]=n;a[m>>0]=e>>>24;a[m+1>>0]=e>>>16;a[m+2>>0]=e>>>8;a[m+3>>0]=e;a[m+4>>0]=f>>>24;a[m+5>>0]=f>>>16;a[m+6>>0]=f>>>8;a[m+7>>0]=f;a[m+8>>0]=o;a[m+9>>0]=q;a[m+10>>0]=0;a[m+11>>0]=r;a[m+12>>0]=0;if(b){r=b+656|0;c[r>>2]=34;a[j>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=13;q=j+4|0;a[q>>0]=73;a[j+5>>0]=72;a[j+6>>0]=68;a[j+7>>0]=82;VQ(b,j,8);c[b+372>>2]=1229472850;rQ(b);sQ(b,q,4);c[r>>2]=66;VQ(b,m,13);sQ(b,m,13);c[r>>2]=130;r=c[b+408>>2]|0;a[j>>0]=r>>>24;a[j+1>>0]=r>>>16;a[j+2>>0]=r>>>8;a[j+3>>0]=r;VQ(b,j,4)}j=b+430|0;if(a[j>>0]|0){t=b+204|0;c[t>>2]=1;i=l;return}if((a[h>>0]|0)!=3?(d[k>>0]|0)>=8:0){a[j>>0]=-8;t=b+204|0;c[t>>2]=1;i=l;return}a[j>>0]=8;t=b+204|0;c[t>>2]=1;i=l;return}function kR(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+16|0;j=g+8|0;k=g;l=a[d+431>>0]|0;if(f>>>0>256?1:(c[d+596>>2]&1|f|0)==0)if(l<<24>>24==3)BQ(d,418624);else{i=g;return}if(!(l&2)){i=g;return}b[d+416>>1]=f;l=f*3|0;m=(d|0)==0;if(!m){n=d+656|0;c[n>>2]=34;a[j>>0]=l>>>24;a[j+1>>0]=l>>>16;a[j+2>>0]=l>>>8;a[j+3>>0]=l;l=j+4|0;a[l>>0]=80;a[j+5>>0]=76;a[j+6>>0]=84;a[j+7>>0]=69;VQ(d,j,8);c[d+372>>2]=1347179589;rQ(d);sQ(d,l,4);c[n>>2]=66}if(f){n=k+1|0;l=k+2|0;if(m){j=0;o=e;while(1){a[k>>0]=a[o>>0]|0;a[n>>0]=a[o+1>>0]|0;a[l>>0]=a[o+2>>0]|0;j=j+1|0;if((j|0)==(f|0))break;else o=o+3|0}}else{o=0;j=e;while(1){a[k>>0]=a[j>>0]|0;a[n>>0]=a[j+1>>0]|0;a[l>>0]=a[j+2>>0]|0;VQ(d,k,3);sQ(d,k,3);o=o+1|0;if((o|0)==(f|0))break;else j=j+3|0}}}if(!m){c[d+656>>2]=130;m=c[d+408>>2]|0;a[h>>0]=m>>>24;a[h+1>>0]=m>>>16;a[h+2>>0]=m>>>8;a[h+3>>0]=m;VQ(d,h,4)}h=d+204|0;c[h>>2]=c[h>>2]|2;i=g;return}function lR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;h=i;i=i+16|0;j=h+8|0;k=h;l=b+216|0;do if((c[l>>2]|0)!=1229209940){m=b+276|0;n=c[m>>2]|0;if(n){o=c[n>>2]|0;if(o){c[n>>2]=0;n=o;do{o=n;n=c[n>>2]|0;LQ(b,o)}while((n|0)!=0)}}else{n=NQ(b,(c[b+280>>2]|0)+4|0)|0;c[m>>2]=n;c[n>>2]=0}if(!(FR(b,1229209940,ER(b)|0)|0)){n=b+232|0;c[n>>2]=(c[m>>2]|0)+4;o=b+280|0;p=b+236|0;c[p>>2]=c[o>>2];q=m;r=o;s=n;t=p;break}else BQ(b,c[b+244>>2]|0)}else{q=b+276|0;r=b+280|0;s=b+232|0;t=b+236|0}while(0);p=b+220|0;c[p>>2]=e;e=b+224|0;c[e>>2]=0;n=b+204|0;o=b+620|0;u=(b|0)==0;v=(g|0)!=0;w=b+656|0;x=j+1|0;y=j+2|0;z=j+3|0;A=j+4|0;B=j+5|0;C=j+6|0;D=j+7|0;E=b+372|0;F=b+408|0;G=k+1|0;H=k+2|0;I=k+3|0;J=f;while(1){c[e>>2]=J;f=nN(p,g)|0;K=J;J=c[e>>2]|0;c[e>>2]=0;K=c[t>>2]|0;if(!K){L=c[q>>2]|0;M=L+4|0;N=c[r>>2]|0;if(((((c[n>>2]&4|0)==0?(a[o>>0]|0)==0:0)?(O=ER(b)|0,O>>>0<16385):0)?(P=d[M>>0]|0,(P&15|0)==8&(P&240)>>>0<113):0)?(Q=P>>>4,P=1<<Q+7,P>>>0>=O>>>0):0){R=P;P=Q;while(1){R=R>>>1;Q=P+-1|0;if((Q|0)==0|R>>>0<O>>>0){S=Q;break}else P=Q}P=S<<4|8;a[M>>0]=P;O=L+5|0;R=d[O>>0]&224;a[O>>0]=(R|(((R|P<<8)>>>0)%31|0))^31}if(!u){if((N|0)<0){T=22;break}c[w>>2]=34;a[j>>0]=N>>>24;a[x>>0]=N>>>16;a[y>>0]=N>>>8;a[z>>0]=N;a[A>>0]=73;a[B>>0]=68;a[C>>0]=65;a[D>>0]=84;VQ(b,j,8);c[E>>2]=1229209940;rQ(b);sQ(b,A,4);c[w>>2]=66;if(N){VQ(b,M,N);sQ(b,M,N)}c[w>>2]=130;P=c[F>>2]|0;a[k>>0]=P>>>24;a[G>>0]=P>>>16;a[H>>0]=P>>>8;a[I>>0]=P;VQ(b,k,4)}c[n>>2]=c[n>>2]|4;c[s>>2]=M;c[t>>2]=N;if((f|0)==0&v){J=J;continue}else U=N}else U=K;if(f){V=f;W=U;T=31;break}if(!J){T=29;break}}if((T|0)==22)BQ(b,419472);else if((T|0)==29)if((g|0)==4)BQ(b,418664);else{i=h;return}else if((T|0)==31){if(!((V|0)==1&(g|0)==4)){zQ(b,V);BQ(b,c[b+244>>2]|0)}V=c[q>>2]|0;q=V+4|0;g=c[r>>2]|0;r=g-W|0;if(((((c[n>>2]&4|0)==0?(a[o>>0]|0)==0:0)?(o=ER(b)|0,o>>>0<16385):0)?(T=d[q>>0]|0,(T&15|0)==8&(T&240)>>>0<113):0)?(J=T>>>4,T=1<<J+7,T>>>0>=o>>>0):0){U=T;T=J;while(1){U=U>>>1;J=T+-1|0;if((J|0)==0|U>>>0<o>>>0){X=J;break}else T=J}T=X<<4|8;a[q>>0]=T;X=V+5|0;V=d[X>>0]&224;a[X>>0]=(V|(((V|T<<8)>>>0)%31|0))^31}if(!u){if((r|0)<0)BQ(b,419472);c[w>>2]=34;a[j>>0]=r>>>24;a[j+1>>0]=r>>>16;a[j+2>>0]=r>>>8;a[j+3>>0]=r;u=j+4|0;a[u>>0]=73;a[j+5>>0]=68;a[j+6>>0]=65;a[j+7>>0]=84;VQ(b,j,8);c[E>>2]=1229209940;rQ(b);sQ(b,u,4);c[w>>2]=66;if((g|0)!=(W|0)){VQ(b,q,r);sQ(b,q,r)}c[w>>2]=130;w=c[F>>2]|0;a[j>>0]=w>>>24;a[j+1>>0]=w>>>16;a[j+2>>0]=w>>>8;a[j+3>>0]=w;VQ(b,j,4)}c[t>>2]=0;c[s>>2]=0;c[n>>2]=c[n>>2]|12;c[l>>2]=0;i=h;return}}function mR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;if(!b){f=b+204|0;g=c[f>>2]|0;h=g|16;c[f>>2]=h;i=d;return}j=b+656|0;c[j>>2]=34;k=e+4|0;c[e>>2]=0;a[k>>0]=73;a[e+5>>0]=69;a[e+6>>0]=78;a[e+7>>0]=68;VQ(b,e,8);c[b+372>>2]=1229278788;rQ(b);sQ(b,k,4);c[j>>2]=130;j=c[b+408>>2]|0;a[e>>0]=j>>>24;a[e+1>>0]=j>>>16;a[e+2>>0]=j>>>8;a[e+3>>0]=j;VQ(b,e,4);f=b+204|0;g=c[f>>2]|0;h=g|16;c[f>>2]=h;i=d;return}function nR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e;a[g>>0]=d>>>24;a[g+1>>0]=d>>>16;a[g+2>>0]=d>>>8;a[g+3>>0]=d;if(!b){i=e;return}d=b+656|0;c[d>>2]=34;a[f>>0]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=4;h=f+4|0;a[h>>0]=103;a[f+5>>0]=65;a[f+6>>0]=77;a[f+7>>0]=65;VQ(b,f,8);c[b+372>>2]=1732332865;rQ(b);sQ(b,h,4);c[d>>2]=66;VQ(b,g,4);sQ(b,g,4);c[d>>2]=130;d=c[b+408>>2]|0;a[f>>0]=d>>>24;a[f+1>>0]=d>>>16;a[f+2>>0]=d>>>8;a[f+3>>0]=d;VQ(b,f,4);i=e;return}function oR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e;a[g>>0]=d;if(!b){i=e;return}d=b+656|0;c[d>>2]=34;a[f>>0]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=1;h=f+4|0;a[h>>0]=115;a[f+5>>0]=82;a[f+6>>0]=71;a[f+7>>0]=66;VQ(b,f,8);c[b+372>>2]=1934772034;rQ(b);sQ(b,h,4);c[d>>2]=66;VQ(b,g,1);sQ(b,g,1);c[d>>2]=130;d=c[b+408>>2]|0;a[f>>0]=d>>>24;a[f+1>>0]=d>>>16;a[f+2>>0]=d>>>8;a[f+3>>0]=d;VQ(b,f,4);i=e;return}function pR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+1136|0;h=g+1128|0;j=g+1120|0;k=g+1036|0;l=g;if(!f)BQ(b,418704);m=d[f+3>>0]|0;n=(d[f+1>>0]|0)<<16|(d[f>>0]|0)<<24|(d[f+2>>0]|0)<<8|m;if(n>>>0<132)BQ(b,418736);if(m&3)BQ(b,418760);if(!e){a[k>>0]=0;BQ(b,418816)}m=a[e>>0]|0;if(!(m<<24>>24)){a[k>>0]=0;BQ(b,418816)}else{o=k;p=e;q=m;r=0;s=1}a:while(1){b:do if(!s){m=(q+-33<<24>>24&255)<94|(q&255)>160;t=p+1|0;u=m&1^1;v=m?q:32}else{m=p;e=q;while(1){m=m+1|0;if((e+-33<<24>>24&255)<94|(e&255)>160){t=m;u=0;v=e;break b}e=a[m>>0]|0;if(!(e<<24>>24)){w=o;x=r;y=s;break a}}}while(0);a[o>>0]=v;e=r+1|0;m=o+1|0;q=a[t>>0]|0;if(!(q<<24>>24!=0&e>>>0<79)){w=m;x=e;y=u;break}else{o=m;p=t;r=e;s=u}}if((x|0)!=0&(y|0)!=0){z=w+-1|0;A=x+-1|0}else{z=w;A=x}a[z>>0]=0;if(!A)BQ(b,418816);a[k+(A+1)>>0]=0;z=A+2|0;c[l>>2]=f;c[l+4>>2]=n;n=l+8|0;c[n>>2]=0;if(GR(b,1766015824,l,z)|0)BQ(b,c[b+244>>2]|0);f=(c[n>>2]|0)+z|0;A=(b|0)==0;if(!A){x=b+656|0;c[x>>2]=34;a[h>>0]=f>>>24;a[h+1>>0]=f>>>16;a[h+2>>0]=f>>>8;a[h+3>>0]=f;f=h+4|0;a[f>>0]=105;a[h+5>>0]=67;a[h+6>>0]=67;a[h+7>>0]=80;VQ(b,h,8);c[b+372>>2]=1766015824;rQ(b);sQ(b,f,4);c[x>>2]=66;if(!z)B=1;else{VQ(b,k,z);sQ(b,k,z);B=1}}else B=0;z=b+280|0;k=1024;x=b+276|0;f=l+12|0;l=c[n>>2]|0;while(1){n=c[x>>2]|0;h=k>>>0>l>>>0?l:k;if(B&(h|0)!=0){VQ(b,f,h);sQ(b,f,h)}C=(l|0)==(h|0);if(C|(n|0)==0)break;k=c[z>>2]|0;x=n;f=n+4|0;l=l-h|0}if(!C)BQ(b,419352);if(A){i=g;return}c[b+656>>2]=130;A=c[b+408>>2]|0;a[j>>0]=A>>>24;a[j+1>>0]=A>>>16;a[j+2>>0]=A>>>8;a[j+3>>0]=A;VQ(b,j,4);i=g;return}function qR(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+112|0;g=f+104|0;h=f+96|0;j=f+16|0;k=f;l=e+4|0;m=(a[l>>0]|0)==8?6:10;n=e+12|0;o=c[n>>2]|0;p=c[e>>2]|0;if(!p){a[j>>0]=0;BQ(d,418840)}q=a[p>>0]|0;if(!(q<<24>>24)){a[j>>0]=0;BQ(d,418840)}else{r=j;s=p;t=q;u=0;v=1}a:while(1){b:do if(!v){q=(t+-33<<24>>24&255)<94|(t&255)>160;w=s+1|0;x=q&1^1;y=q?t:32}else{q=s;p=t;while(1){q=q+1|0;if((p+-33<<24>>24&255)<94|(p&255)>160){w=q;x=0;y=p;break b}p=a[q>>0]|0;if(!(p<<24>>24)){z=r;A=u;B=v;break a}}}while(0);a[r>>0]=y;p=u+1|0;q=r+1|0;t=a[w>>0]|0;if(!(t<<24>>24!=0&p>>>0<79)){z=q;A=p;B=x;break}else{r=q;s=w;u=p;v=x}}if((A|0)!=0&(B|0)!=0){C=z+-1|0;D=A+-1|0}else{C=z;D=A}a[C>>0]=0;if(!D)BQ(d,418840);C=(da(m,o)|0)+2+D|0;o=(d|0)==0;if(o)E=0;else{A=d+656|0;c[A>>2]=34;a[g>>0]=C>>>24;a[g+1>>0]=C>>>16;a[g+2>>0]=C>>>8;a[g+3>>0]=C;C=g+4|0;a[C>>0]=115;a[g+5>>0]=80;a[g+6>>0]=76;a[g+7>>0]=84;VQ(d,g,8);c[d+372>>2]=1934642260;rQ(d);sQ(d,C,4);c[A>>2]=66;A=D+1|0;if(A){VQ(d,j,A);sQ(d,j,A)}VQ(d,l,1);sQ(d,l,1);E=1}A=e+8|0;e=c[n>>2]|0;if((e|0)>0){j=c[A>>2]|0;D=k+1|0;C=k+2|0;g=k+3|0;z=k+4|0;B=k+5|0;x=k+6|0;v=k+7|0;u=k+8|0;w=k+9|0;s=e;e=j;r=j;while(1){j=b[r>>1]|0;if((a[l>>0]|0)==8){a[k>>0]=j;a[D>>0]=b[r+2>>1];a[C>>0]=b[r+4>>1];a[g>>0]=b[r+6>>1];t=b[r+8>>1]|0;a[z>>0]=(t&65535)>>>8;a[B>>0]=t}else{a[k>>0]=(j&65535)>>>8;a[D>>0]=j;j=b[r+2>>1]|0;a[C>>0]=(j&65535)>>>8;a[g>>0]=j;j=b[r+4>>1]|0;a[z>>0]=(j&65535)>>>8;a[B>>0]=j;j=b[r+6>>1]|0;a[x>>0]=(j&65535)>>>8;a[v>>0]=j;j=b[r+8>>1]|0;a[u>>0]=(j&65535)>>>8;a[w>>0]=j}if(E){VQ(d,k,m);sQ(d,k,m);F=c[A>>2]|0;G=c[n>>2]|0}else{F=e;G=s}r=r+10|0;if(r>>>0>=(F+(G*10|0)|0)>>>0)break;else{s=G;e=F}}}if(o){i=f;return}c[d+656>>2]=130;o=c[d+408>>2]|0;a[h>>0]=o>>>24;a[h+1>>0]=o>>>16;a[h+2>>0]=o>>>8;a[h+3>>0]=o;VQ(d,h,4);i=f;return}function rR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+8|0;j=g;do if(!(f&2)){k=a[e+3>>0]|0;if(!(k<<24>>24)){i=g;return}if((k&255)>(d[b+433>>0]|0)){i=g;return}else{a[j>>0]=k;l=1;break}}else{if((f|0)==3)m=8;else m=a[b+433>>0]|0;k=a[e>>0]|0;if((k+-1<<24>>24&255)>=(m&255)){i=g;return}n=a[e+1>>0]|0;if((n+-1<<24>>24&255)>=(m&255)){i=g;return}o=a[e+2>>0]|0;if((o+-1<<24>>24&255)<(m&255)){a[j>>0]=k;a[j+1>>0]=n;a[j+2>>0]=o;l=3;break}else{i=g;return}}while(0);do if(f&4){m=a[e+4>>0]|0;if(!(m<<24>>24)){i=g;return}if((m&255)>(d[b+433>>0]|0)){i=g;return}else{a[j+l>>0]=m;p=l+1|0;break}}else p=l;while(0);if(!b){i=g;return}l=b+656|0;c[l>>2]=34;a[h>>0]=p>>>24;a[h+1>>0]=p>>>16;a[h+2>>0]=p>>>8;a[h+3>>0]=p;e=h+4|0;a[e>>0]=115;a[h+5>>0]=66;a[h+6>>0]=73;a[h+7>>0]=84;VQ(b,h,8);c[b+372>>2]=1933723988;rQ(b);sQ(b,e,4);c[l>>2]=66;VQ(b,j,p);sQ(b,j,p);c[l>>2]=130;l=c[b+408>>2]|0;a[h>>0]=l>>>24;a[h+1>>0]=l>>>16;a[h+2>>0]=l>>>8;a[h+3>>0]=l;VQ(b,h,4);i=g;return}function sR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+48|0;f=e+32|0;g=e;yQ(g,c[d+24>>2]|0);yQ(g+4|0,c[d+28>>2]|0);yQ(g+8|0,c[d>>2]|0);yQ(g+12|0,c[d+4>>2]|0);yQ(g+16|0,c[d+8>>2]|0);yQ(g+20|0,c[d+12>>2]|0);yQ(g+24|0,c[d+16>>2]|0);yQ(g+28|0,c[d+20>>2]|0);if(!b){i=e;return}d=b+656|0;c[d>>2]=34;a[f>>0]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=32;h=f+4|0;a[h>>0]=99;a[f+5>>0]=72;a[f+6>>0]=82;a[f+7>>0]=77;VQ(b,f,8);c[b+372>>2]=1665684045;rQ(b);sQ(b,h,4);c[d>>2]=66;VQ(b,g,32);sQ(b,g,32);c[d>>2]=130;d=c[b+408>>2]|0;a[f>>0]=d>>>24;a[f+1>>0]=d>>>16;a[f+2>>0]=d>>>8;a[f+3>>0]=d;VQ(b,f,4);i=e;return}function tR(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+16|0;m=l+8|0;n=l;if((k|0)==2){o=b[h+2>>1]|0;p=(o&65535)>>>8;a[n>>0]=p;a[n+1>>0]=o;o=b[h+4>>1]|0;q=(o&65535)>>>8;a[n+2>>0]=q;a[n+3>>0]=o;o=b[h+6>>1]|0;r=(o&65535)>>>8;a[n+4>>0]=r;a[n+5>>0]=o;if((q|p|r)<<16>>16){FQ(f,418976);i=l;return}if(!f){i=l;return}r=f+656|0;c[r>>2]=34;a[m>>0]=0;a[m+1>>0]=0;a[m+2>>0]=0;a[m+3>>0]=6;p=m+4|0;a[p>>0]=116;a[m+5>>0]=82;a[m+6>>0]=78;a[m+7>>0]=83;VQ(f,m,8);c[f+372>>2]=1951551059;rQ(f);sQ(f,p,4);c[r>>2]=66;VQ(f,n,6);sQ(f,n,6);c[r>>2]=130;r=c[f+408>>2]|0;a[m>>0]=r>>>24;a[m+1>>0]=r>>>16;a[m+2>>0]=r>>>8;a[m+3>>0]=r;VQ(f,m,4);i=l;return}else if(!k){r=b[h+8>>1]|0;if((r&65535|0)<(1<<(d[f+432>>0]|0)|0)){a[n>>0]=(r&65535)>>>8;a[n+1>>0]=r;r=f+656|0;c[r>>2]=34;a[m>>0]=0;a[m+1>>0]=0;a[m+2>>0]=0;a[m+3>>0]=2;h=m+4|0;a[h>>0]=116;a[m+5>>0]=82;a[m+6>>0]=78;a[m+7>>0]=83;VQ(f,m,8);c[f+372>>2]=1951551059;rQ(f);sQ(f,h,4);c[r>>2]=66;VQ(f,n,2);sQ(f,n,2);c[r>>2]=130;r=c[f+408>>2]|0;a[m>>0]=r>>>24;a[m+1>>0]=r>>>16;a[m+2>>0]=r>>>8;a[m+3>>0]=r;VQ(f,m,4);i=l;return}else{FQ(f,418912);i=l;return}}else if((k|0)==3){if((j|0)>=1?(e[f+416>>1]|0|0)>=(j|0):0){if(!f){i=l;return}if((j|0)<0)BQ(f,419472);k=f+656|0;c[k>>2]=34;a[m>>0]=j>>>24;a[m+1>>0]=j>>>16;a[m+2>>0]=j>>>8;a[m+3>>0]=j;r=m+4|0;a[r>>0]=116;a[m+5>>0]=82;a[m+6>>0]=78;a[m+7>>0]=83;VQ(f,m,8);c[f+372>>2]=1951551059;rQ(f);sQ(f,r,4);c[k>>2]=66;if((g|0)!=0&(j|0)!=0){VQ(f,g,j);sQ(f,g,j)}c[k>>2]=130;k=c[f+408>>2]|0;a[m>>0]=k>>>24;a[m+1>>0]=k>>>16;a[m+2>>0]=k>>>8;a[m+3>>0]=k;VQ(f,m,4);i=l;return}FQ(f,418864);i=l;return}else{FQ(f,419040);i=l;return}}function uR(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+8|0;l=h;if((g|0)!=3)if(!(g&2)){g=b[f+8>>1]|0;if((g&65535|0)>=(1<<(d[e+432>>0]|0)|0)){i=h;return}a[l>>0]=(g&65535)>>>8;a[l+1>>0]=g;g=e+656|0;c[g>>2]=34;a[j>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=2;m=j+4|0;a[m>>0]=98;a[j+5>>0]=75;a[j+6>>0]=71;a[j+7>>0]=68;VQ(e,j,8);c[e+372>>2]=1649100612;rQ(e);sQ(e,m,4);c[g>>2]=66;VQ(e,l,2);sQ(e,l,2);c[g>>2]=130;g=c[e+408>>2]|0;a[j>>0]=g>>>24;a[j+1>>0]=g>>>16;a[j+2>>0]=g>>>8;a[j+3>>0]=g;VQ(e,j,4);i=h;return}else{g=b[f+2>>1]|0;m=(g&65535)>>>8;a[l>>0]=m;a[l+1>>0]=g;g=b[f+4>>1]|0;n=(g&65535)>>>8;a[l+2>>0]=n;a[l+3>>0]=g;g=b[f+6>>1]|0;o=(g&65535)>>>8;a[l+4>>0]=o;a[l+5>>0]=g;if((e|0)==0?1:(n|m|o)<<16>>16!=0){i=h;return}o=e+656|0;c[o>>2]=34;a[j>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=6;m=j+4|0;a[m>>0]=98;a[j+5>>0]=75;a[j+6>>0]=71;a[j+7>>0]=68;VQ(e,j,8);c[e+372>>2]=1649100612;rQ(e);sQ(e,m,4);c[o>>2]=66;VQ(e,l,6);sQ(e,l,6);c[o>>2]=130;o=c[e+408>>2]|0;a[j>>0]=o>>>24;a[j+1>>0]=o>>>16;a[j+2>>0]=o>>>8;a[j+3>>0]=o;VQ(e,j,4);i=h;return}o=b[e+416>>1]|0;if(o<<16>>16==0?(c[e+596>>2]&1|0)!=0:0){a[l>>0]=a[f>>0]|0;p=j;q=l}else r=4;do if((r|0)==4){m=a[f>>0]|0;if((m&255)>>>0>=(o&65535)>>>0){i=h;return}a[l>>0]=m;if(!e){i=h;return}else{p=j;q=l;break}}while(0);l=e+656|0;c[l>>2]=34;a[j>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=1;p=j+4|0;a[p>>0]=98;a[j+5>>0]=75;a[j+6>>0]=71;a[j+7>>0]=68;VQ(e,j,8);c[e+372>>2]=1649100612;rQ(e);sQ(e,p,4);c[l>>2]=66;VQ(e,q,1);sQ(e,q,1);c[l>>2]=130;l=c[e+408>>2]|0;a[k>>0]=l>>>24;a[k+1>>0]=l>>>16;a[k+2>>0]=l>>>8;a[k+3>>0]=l;VQ(e,k,4);i=h;return}function vR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+96|0;g=f+88|0;h=f+80|0;j=f;if(!d){a[j>>0]=0;BQ(b,419080)}k=a[d>>0]|0;if(!(k<<24>>24)){a[j>>0]=0;BQ(b,419080)}else{l=j;m=d;n=k;o=0;p=1}a:while(1){b:do if(!p){k=(n+-33<<24>>24&255)<94|(n&255)>160;q=m+1|0;r=k&1^1;s=k?n:32}else{k=m;d=n;while(1){k=k+1|0;if((d+-33<<24>>24&255)<94|(d&255)>160){q=k;r=0;s=d;break b}d=a[k>>0]|0;if(!(d<<24>>24)){t=l;u=o;v=p;break a}}}while(0);a[l>>0]=s;d=o+1|0;k=l+1|0;n=a[q>>0]|0;if(!(n<<24>>24!=0&d>>>0<79)){t=k;u=d;v=r;break}else{l=k;m=q;o=d;p=r}}if((u|0)!=0&(v|0)!=0){w=t+-1|0;x=u+-1|0}else{w=t;x=u}a[w>>0]=0;if(!x)BQ(b,419080);if((e|0)!=0?(a[e>>0]|0)!=0:0){w=SEi(e|0)|0;if(w>>>0>(2147483646-x|0)>>>0)BQ(b,419104);else y=w}else y=0;w=x+1|0;x=w+y|0;u=(b|0)==0;if(u){z=h;i=f;return}t=b+656|0;c[t>>2]=34;a[g>>0]=x>>>24;a[g+1>>0]=x>>>16;a[g+2>>0]=x>>>8;a[g+3>>0]=x;x=g+4|0;a[x>>0]=116;a[g+5>>0]=69;a[g+6>>0]=88;a[g+7>>0]=116;VQ(b,g,8);c[b+372>>2]=1950701684;rQ(b);sQ(b,x,4);c[t>>2]=66;if(w){VQ(b,j,w);sQ(b,j,w)}if((y|0)!=0&(e|0)!=0){VQ(b,e,y);sQ(b,e,y)}if(u){z=h;i=f;return}c[b+656>>2]=130;u=c[b+408>>2]|0;a[h>>0]=u>>>24;a[h+1>>0]=u>>>16;a[h+2>>0]=u>>>8;a[h+3>>0]=u;VQ(b,h,4);z=h;i=f;return}function wR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+1136|0;h=f+1128|0;j=f+1120|0;k=f+1036|0;l=f;if(!g){if(!d){a[k>>0]=0;BQ(b,419160)}m=a[d>>0]|0;if(!(m<<24>>24)){a[k>>0]=0;BQ(b,419160)}else{n=k;o=d;p=m;q=0;r=1}a:while(1){b:do if(!r){m=(p+-33<<24>>24&255)<94|(p&255)>160;s=o+1|0;t=m&1^1;u=m?p:32}else{m=o;v=p;while(1){m=m+1|0;if((v+-33<<24>>24&255)<94|(v&255)>160){s=m;t=0;u=v;break b}v=a[m>>0]|0;if(!(v<<24>>24)){w=n;x=q;y=r;break a}}}while(0);a[n>>0]=u;v=q+1|0;m=n+1|0;p=a[s>>0]|0;if(!(p<<24>>24!=0&v>>>0<79)){w=m;x=v;y=t;break}else{n=m;o=s;q=v;r=t}}if((x|0)!=0&(y|0)!=0){z=w+-1|0;A=x+-1|0}else{z=w;A=x}a[z>>0]=0;if(!A)BQ(b,419160);a[k+(A+1)>>0]=0;z=A+2|0;if(!e)B=0;else B=SEi(e|0)|0;c[l>>2]=e;c[l+4>>2]=B;B=l+8|0;c[B>>2]=0;if(GR(b,2052348020,l,z)|0)BQ(b,c[b+244>>2]|0);A=(c[B>>2]|0)+z|0;x=(b|0)==0;if(!x){w=b+656|0;c[w>>2]=34;a[h>>0]=A>>>24;a[h+1>>0]=A>>>16;a[h+2>>0]=A>>>8;a[h+3>>0]=A;A=h+4|0;a[A>>0]=122;a[h+5>>0]=84;a[h+6>>0]=88;a[h+7>>0]=116;VQ(b,h,8);c[b+372>>2]=2052348020;rQ(b);sQ(b,A,4);c[w>>2]=66;if(!z)C=1;else{VQ(b,k,z);sQ(b,k,z);C=1}}else C=0;z=b+280|0;k=1024;w=b+276|0;A=l+12|0;l=c[B>>2]|0;while(1){B=c[w>>2]|0;h=k>>>0>l>>>0?l:k;if(C&(h|0)!=0){VQ(b,A,h);sQ(b,A,h)}D=(l|0)==(h|0);if(D|(B|0)==0)break;k=c[z>>2]|0;w=B;A=B+4|0;l=l-h|0}if(!D)BQ(b,419352);if(x){i=f;return}c[b+656>>2]=130;x=c[b+408>>2]|0;a[j>>0]=x>>>24;a[j+1>>0]=x>>>16;a[j+2>>0]=x>>>8;a[j+3>>0]=x;VQ(b,j,4);i=f;return}else if((g|0)==-1){vR(b,d,e,0);i=f;return}else BQ(b,419128)}function xR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+1136|0;k=j+1128|0;l=j+1120|0;m=j+1036|0;n=j;if(!e){a[m>>0]=0;BQ(b,419184)}o=a[e>>0]|0;if(!(o<<24>>24)){a[m>>0]=0;BQ(b,419184)}else{p=m;q=e;r=o;s=0;t=1}a:while(1){b:do if(!t){o=(r+-33<<24>>24&255)<94|(r&255)>160;u=q+1|0;v=o&1^1;w=o?r:32}else{o=q;e=r;while(1){o=o+1|0;if((e+-33<<24>>24&255)<94|(e&255)>160){u=o;v=0;w=e;break b}e=a[o>>0]|0;if(!(e<<24>>24)){x=p;y=s;z=t;break a}}}while(0);a[p>>0]=w;e=s+1|0;o=p+1|0;r=a[u>>0]|0;if(!(r<<24>>24!=0&e>>>0<79)){x=o;y=e;z=v;break}else{p=o;q=u;s=e;t=v}}if((y|0)!=0&(z|0)!=0){A=x+-1|0;B=y+-1|0}else{A=x;B=y}a[A>>0]=0;if(!B)BQ(b,419184);if((d|0)==2|(d|0)==0){A=B+1|0;a[m+A>>0]=1;C=1;D=A}else if((d|0)==-1|(d|0)==1){d=B+1|0;a[m+d>>0]=0;C=0;D=d}else BQ(b,419208);a[m+(D+1)>>0]=0;d=D+2|0;B=(f|0)==0?3653512:f;f=(SEi(B|0)|0)+1|0;A=(g|0)==0?3653512:g;g=(SEi(A|0)|0)+1|0;y=(h|0)==0?3653512:h;h=f>>>0>(2147483645-D|0)>>>0?2147483647:f+d|0;D=g>>>0>(2147483647-h|0)>>>0?2147483647:h+g|0;h=SEi(y|0)|0;c[n>>2]=y;x=n+4|0;c[x>>2]=h;z=n+8|0;c[z>>2]=0;do if(C)if(!(GR(b,1767135348,n,D)|0)){E=c[z>>2]|0;break}else BQ(b,c[b+244>>2]|0);else if(h>>>0>(2147483647-D|0)>>>0)BQ(b,419240);else{c[z>>2]=h;E=h;break}while(0);h=E+D|0;D=(b|0)==0;if(!D){E=b+656|0;c[E>>2]=34;a[k>>0]=h>>>24;a[k+1>>0]=h>>>16;a[k+2>>0]=h>>>8;a[k+3>>0]=h;h=k+4|0;a[h>>0]=105;a[k+5>>0]=84;a[k+6>>0]=88;a[k+7>>0]=116;VQ(b,k,8);c[b+372>>2]=1767135348;rQ(b);sQ(b,h,4);c[E>>2]=66;if(d){VQ(b,m,d);sQ(b,m,d)}if((B|0)!=0&(f|0)!=0){VQ(b,B,f);sQ(b,B,f)}if((A|0)!=0&(g|0)!=0){VQ(b,A,g);sQ(b,A,g);F=1}else F=1}else F=0;if(C){C=b+280|0;g=1024;A=b+276|0;f=n+12|0;n=c[z>>2]|0;while(1){z=c[A>>2]|0;B=g>>>0>n>>>0?n:g;if(F&(B|0)!=0){VQ(b,f,B);sQ(b,f,B)}G=(n|0)==(B|0);if(G|(z|0)==0)break;g=c[C>>2]|0;A=z;f=z+4|0;n=n-B|0}if(!G)BQ(b,419352)}else{G=c[x>>2]|0;if(F&(y|0)!=0&(G|0)!=0){VQ(b,y,G);sQ(b,y,G)}}if(D){i=j;return}c[b+656>>2]=130;D=c[b+408>>2]|0;a[l>>0]=D>>>24;a[l+1>>0]=D>>>16;a[l+2>>0]=D>>>8;a[l+3>>0]=D;VQ(b,l,4);i=j;return}function yR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+32|0;h=g+16|0;j=g;yQ(j,d);yQ(j+4|0,e);a[j+8>>0]=f;if(!b){i=g;return}f=b+656|0;c[f>>2]=34;a[h>>0]=0;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=9;e=h+4|0;a[e>>0]=111;a[h+5>>0]=70;a[h+6>>0]=70;a[h+7>>0]=115;VQ(b,h,8);c[b+372>>2]=1866876531;rQ(b);sQ(b,e,4);c[f>>2]=66;VQ(b,j,9);sQ(b,j,9);c[f>>2]=130;f=c[b+408>>2]|0;a[h>>0]=f>>>24;a[h+1>>0]=f>>>16;a[h+2>>0]=f>>>8;a[h+3>>0]=f;VQ(b,h,4);i=g;return}function zR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;l=i;i=i+112|0;m=l+96|0;n=l+92|0;o=l+80|0;p=l;if((g|0)>3)BQ(b,419280);if(!d){a[p>>0]=0;BQ(b,419328)}q=a[d>>0]|0;if(!(q<<24>>24)){a[p>>0]=0;BQ(b,419328)}else{r=p;s=d;t=q;u=0;v=1}a:while(1){b:do if(!v){q=(t+-33<<24>>24&255)<94|(t&255)>160;w=s+1|0;x=q&1^1;y=q?t:32}else{q=s;d=t;while(1){q=q+1|0;if((d+-33<<24>>24&255)<94|(d&255)>160){w=q;x=0;y=d;break b}d=a[q>>0]|0;if(!(d<<24>>24)){z=r;A=u;B=v;break a}}}while(0);a[r>>0]=y;d=u+1|0;q=r+1|0;t=a[w>>0]|0;if(!(t<<24>>24!=0&d>>>0<79)){z=q;A=d;B=x;break}else{r=q;s=w;u=d;v=x}}if((A|0)!=0&(B|0)!=0){C=z+-1|0;D=A+-1|0}else{C=z;D=A}a[C>>0]=0;if(!D)BQ(b,419328);C=D+1|0;A=(SEi(j|0)|0)+((h|0)!=0&1)|0;z=D+11+A|0;D=NQ(b,h<<2)|0;B=(h|0)>0;if(B){x=h+-1|0;v=0;u=z;while(1){w=(SEi(c[k+(v<<2)>>2]|0)|0)+((v|0)!=(x|0)&1)|0;c[D+(v<<2)>>2]=w;s=w+u|0;v=v+1|0;if((v|0)==(h|0)){E=s;break}else u=s}}else E=z;z=(b|0)==0;if(!z){u=b+656|0;c[u>>2]=34;a[m>>0]=E>>>24;a[m+1>>0]=E>>>16;a[m+2>>0]=E>>>8;a[m+3>>0]=E;E=m+4|0;a[E>>0]=112;a[m+5>>0]=67;a[m+6>>0]=65;a[m+7>>0]=76;VQ(b,m,8);c[b+372>>2]=1883455820;rQ(b);sQ(b,E,4);c[u>>2]=66;if(!C)F=1;else{VQ(b,p,C);sQ(b,p,C);F=1}}else F=0;yQ(o,e);yQ(o+4|0,f);a[o+8>>0]=g;a[o+9>>0]=h;if(F?(VQ(b,o,10),sQ(b,o,10),(j|0)!=0&(A|0)!=0):0){VQ(b,j,A);sQ(b,j,A)}if(B){B=0;do{A=c[k+(B<<2)>>2]|0;j=c[D+(B<<2)>>2]|0;if(F&(A|0)!=0&(j|0)!=0){VQ(b,A,j);sQ(b,A,j)}B=B+1|0}while((B|0)!=(h|0))}LQ(b,D);if(z){i=l;return}c[b+656>>2]=130;z=c[b+408>>2]|0;a[n>>0]=z>>>24;a[n+1>>0]=z>>>16;a[n+2>>0]=z>>>8;a[n+3>>0]=z;VQ(b,n,4);i=l;return}function AR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+80|0;h=g+64|0;j=g;k=SEi(e|0)|0;l=SEi(f|0)|0;m=k+2|0;n=m+l|0;if(n>>>0>64){i=g;return}a[j>>0]=d;YEi(j+1|0,e|0,k+1|0)|0;YEi(j+m|0,f|0,l|0)|0;if(!b){i=g;return}if((n|0)<0)BQ(b,419472);l=b+656|0;c[l>>2]=34;a[h>>0]=n>>>24;a[h+1>>0]=n>>>16;a[h+2>>0]=n>>>8;a[h+3>>0]=n;f=h+4|0;a[f>>0]=115;a[h+5>>0]=67;a[h+6>>0]=65;a[h+7>>0]=76;VQ(b,h,8);c[b+372>>2]=1933787468;rQ(b);sQ(b,f,4);c[l>>2]=66;if(n){VQ(b,j,n);sQ(b,j,n)}c[l>>2]=130;l=c[b+408>>2]|0;a[h>>0]=l>>>24;a[h+1>>0]=l>>>16;a[h+2>>0]=l>>>8;a[h+3>>0]=l;VQ(b,h,4);i=g;return}function BR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+32|0;h=g+16|0;j=g;a[j>>0]=d>>>24;a[j+1>>0]=d>>>16;a[j+2>>0]=d>>>8;a[j+3>>0]=d;a[j+4>>0]=e>>>24;a[j+5>>0]=e>>>16;a[j+6>>0]=e>>>8;a[j+7>>0]=e;a[j+8>>0]=f;if(!b){i=g;return}f=b+656|0;c[f>>2]=34;a[h>>0]=0;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=9;e=h+4|0;a[e>>0]=112;a[h+5>>0]=72;a[h+6>>0]=89;a[h+7>>0]=115;VQ(b,h,8);c[b+372>>2]=1883789683;rQ(b);sQ(b,e,4);c[f>>2]=66;VQ(b,j,9);sQ(b,j,9);c[f>>2]=130;f=c[b+408>>2]|0;a[h>>0]=f>>>24;a[h+1>>0]=f>>>16;a[h+2>>0]=f>>>8;a[h+3>>0]=f;VQ(b,h,4);i=g;return}function CR(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=da(d[b+433>>0]|0,d[b+436>>0]|0)|0;g=b+344|0;h=c[g>>2]|0;if(f>>>0>7)j=da(f>>>3,h)|0;else j=((da(f,h)|0)+7|0)>>>3;h=j+1|0;a[b+439>>0]=a[b+434>>0]|0;a[b+438>>0]=f;f=NQ(b,h)|0;c[b+380>>2]=f;a[f>>0]=0;f=b+430|0;j=a[f>>0]|0;if(!(j&16))k=j;else{j=NQ(b,(c[b+360>>2]|0)+1|0)|0;c[b+384>>2]=j;a[j>>0]=1;k=a[f>>0]|0}if((k&255)>31){c[b+376>>2]=MQ(b,h)|0;h=a[f>>0]|0;if(!(h&32))l=h;else{h=NQ(b,(c[b+360>>2]|0)+1|0)|0;c[b+388>>2]=h;a[h>>0]=2;l=a[f>>0]|0}if(!(l&64))m=l;else{l=NQ(b,(c[b+360>>2]|0)+1|0)|0;c[b+392>>2]=l;a[l>>0]=3;m=a[f>>0]|0}if(m<<24>>24<0){m=NQ(b,(c[b+360>>2]|0)+1|0)|0;c[b+396>>2]=m;a[m>>0]=4}}c[b+352>>2]=c[b+348>>2];c[b+356>>2]=c[g>>2];i=e;return}function DR(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;f=i;g=a[b+430>>0]|0;h=e+4|0;j=c[h>>2]|0;k=b+368|0;l=(c[k>>2]|0)==0&g<<24>>24==-8?88:g;g=((d[e+11>>0]|0)+7|0)>>>3;e=b+376|0;m=c[e>>2]|0;n=b+380|0;o=c[n>>2]|0;p=l&255;if(!((p&8|0)==0|l<<24>>24==8))if(!j)q=0;else{r=o;s=0;t=0;while(1){r=r+1|0;u=a[r>>0]|0;v=u&255;w=(u<<24>>24>-1?v:256-v|0)+t|0;s=s+1|0;if((s|0)==(j|0)){q=w;break}else t=w}}else q=2147483647;if(l<<24>>24!=16)if(p&16){t=o+1|0;s=b+384|0;r=c[s>>2]|0;w=r+1|0;if(!g){x=r;y=w;z=0;A=t;B=0}else{v=o;u=r;r=w;w=0;C=t;D=0;while(1){E=a[C>>0]|0;a[r>>0]=E;F=E&255;G=(E<<24>>24>-1?F:256-F|0)+D|0;w=w+1|0;F=v+2|0;E=u+2|0;if(w>>>0>=g>>>0){x=r;y=E;z=g;A=F;B=G;break}else{H=r;I=C;r=E;C=F;D=G;u=H;v=I}}}a:do if(z>>>0<j>>>0){v=o;u=x;D=y;C=z;r=t;w=A;I=B;while(1){H=(d[w>>0]|0)-(d[r>>0]|0)|0;a[D>>0]=H;G=H&255;H=(G>>>0<128?G:256-G|0)+I|0;if(H>>>0>q>>>0){J=H;break a}C=C+1|0;if(C>>>0>=j>>>0){J=H;break}else{G=D;F=r;D=u+2|0;r=v+2|0;w=w+1|0;I=H;u=G;v=F}}}else J=B;while(0);if(J>>>0<q>>>0){K=c[s>>2]|0;L=J}else{K=o;L=q}}else{K=o;L=q}else{J=o+1|0;s=b+384|0;B=c[s>>2]|0;A=B+1|0;if(!g){M=B;N=A;O=0;P=J}else{t=o;z=B;B=A;A=0;y=J;while(1){a[B>>0]=a[y>>0]|0;A=A+1|0;x=t+2|0;v=z+2|0;if(A>>>0>=g>>>0){M=B;N=v;O=g;P=x;break}else{u=B;I=y;B=v;y=x;z=u;t=I}}}if(O>>>0<j>>>0){t=o;z=M;M=N;N=O;O=J;J=P;while(1){a[M>>0]=(d[J>>0]|0)-(d[O>>0]|0);N=N+1|0;if((N|0)==(j|0))break;else{P=M;y=O;M=z+2|0;O=t+2|0;J=J+1|0;z=P;t=y}}}K=c[s>>2]|0;L=q}if(l<<24>>24!=32)if(p&32){q=b+388|0;if(!j)Q=0;else{s=o;t=c[q>>2]|0;z=m;J=0;O=0;while(1){z=z+1|0;t=t+1|0;s=s+1|0;M=(d[s>>0]|0)-(d[z>>0]|0)|0;a[t>>0]=M;N=M&255;M=(N>>>0<128?N:256-N|0)+O|0;J=J+1|0;if(!(M>>>0<=L>>>0&J>>>0<j>>>0)){Q=M;break}else O=M}}if(Q>>>0<L>>>0){R=c[q>>2]|0;S=Q}else{R=K;S=L}}else{R=K;S=L}else{K=b+388|0;if(j){Q=o;q=c[K>>2]|0;O=m;J=0;do{O=O+1|0;q=q+1|0;Q=Q+1|0;a[q>>0]=(d[Q>>0]|0)-(d[O>>0]|0);J=J+1|0}while((J|0)!=(j|0))}R=c[K>>2]|0;S=L}if(l<<24>>24!=64)if(p&64){L=o+1|0;K=b+392|0;J=c[K>>2]|0;O=m+1|0;Q=J+1|0;if(!g){T=J;U=m;V=Q;W=0;X=O;Y=L;Z=0}else{q=o;t=m;z=J;J=Q;Q=0;s=O;O=L;M=0;while(1){N=q+2|0;y=(d[O>>0]|0)-((d[s>>0]|0)>>>1&255)|0;a[J>>0]=y;P=y&255;y=(P>>>0<128?P:256-P|0)+M|0;Q=Q+1|0;P=t+2|0;B=z+2|0;if(Q>>>0>=g>>>0){T=J;U=s;V=B;W=g;X=P;Y=N;Z=y;break}else{A=J;I=s;u=O;J=B;s=P;O=N;M=y;z=A;t=I;q=u}}}b:do if(W>>>0<j>>>0){q=T;t=o;z=U;M=V;O=W;s=L;J=X;Q=Y;u=Z;while(1){I=(d[Q>>0]|0)-(((d[s>>0]|0)+(d[J>>0]|0)|0)>>>1)|0;a[M>>0]=I;A=I&255;I=(A>>>0<128?A:256-A|0)+u|0;if(I>>>0>S>>>0){_=I;break b}O=O+1|0;if(O>>>0>=j>>>0){_=I;break}else{A=J;y=s;N=M;M=q+2|0;s=t+2|0;J=z+2|0;Q=Q+1|0;u=I;z=A;t=y;q=N}}}else _=Z;while(0);if(_>>>0<S>>>0){$=c[K>>2]|0;aa=_}else{$=R;aa=S}}else{$=R;aa=S}else{R=o+1|0;_=b+392|0;K=c[_>>2]|0;Z=m+1|0;Y=K+1|0;if(!g){ba=K;ca=m;da=Y;ea=0;fa=Z;ga=R}else{X=o;L=m;W=K;K=Y;Y=0;V=Z;Z=R;while(1){U=X+2|0;a[K>>0]=(d[Z>>0]|0)-((d[V>>0]|0)>>>1&255);Y=Y+1|0;T=L+2|0;q=W+2|0;if(Y>>>0>=g>>>0){ba=K;ca=V;da=q;ea=g;fa=T;ga=U;break}else{t=K;z=V;u=Z;K=q;V=T;Z=U;W=t;L=z;X=u}}}if(ea>>>0<j>>>0){X=ca;ca=o;L=ba;ba=da;da=ea;ea=R;R=fa;fa=ga;while(1){a[ba>>0]=(d[fa>>0]|0)-(((d[ea>>0]|0)+(d[R>>0]|0)|0)>>>1);da=da+1|0;if((da|0)==(j|0))break;else{ga=ba;W=ea;Z=R;ba=L+2|0;ea=ca+2|0;R=X+2|0;fa=fa+1|0;L=ga;ca=W;X=Z}}}$=c[_>>2]|0;aa=S}if(l<<24>>24!=-128)if(p&128){p=o+1|0;l=b+396|0;S=c[l>>2]|0;_=m+1|0;X=S+1|0;if(!g){ha=S;ia=X;ja=0;ka=_;la=p;ma=0}else{ca=o;L=m;fa=S;S=X;X=0;R=_;ea=p;ba=0;while(1){da=ca+2|0;Z=L+2|0;W=(d[ea>>0]|0)-(d[R>>0]|0)|0;a[S>>0]=W;ga=W&255;W=(ga>>>0<128?ga:256-ga|0)+ba|0;X=X+1|0;ga=fa+2|0;if(X>>>0>=g>>>0){ha=S;ia=ga;ja=g;ka=Z;la=da;ma=W;break}else{V=S;K=R;Y=ea;S=ga;R=Z;ea=da;ba=W;fa=V;L=K;ca=Y}}}c:do if(ja>>>0<j>>>0){ca=m;L=o;fa=ha;ba=_;ea=ia;R=ja;S=p;X=ka;Y=la;K=ma;while(1){V=d[X>>0]|0;W=d[ba>>0]|0;da=d[S>>0]|0;Z=V-W|0;ga=da-W|0;u=(Z|0)<0?0-Z|0:Z;z=(ga|0)<0?0-ga|0:ga;t=ga+Z|0;Z=(t|0)<0?0-t|0:t;if((u|0)>(z|0)|(u|0)>(Z|0))na=(z|0)<=(Z|0)?V:W;else na=da;da=(d[Y>>0]|0)-na|0;a[ea>>0]=da;W=da&255;da=(W>>>0<128?W:256-W|0)+K|0;if(da>>>0>aa>>>0){oa=da;break c}R=R+1|0;if(R>>>0>=j>>>0){oa=da;break}else{W=ea;V=S;Z=ba;ba=ca+2|0;ea=fa+2|0;S=L+2|0;X=X+1|0;Y=Y+1|0;K=da;fa=W;L=V;ca=Z}}}else oa=ma;while(0);if(oa>>>0<aa>>>0)pa=c[l>>2]|0;else pa=$}else pa=$;else{$=o+1|0;l=b+396|0;aa=c[l>>2]|0;oa=m+1|0;ma=aa+1|0;if(!g){qa=aa;ra=ma;sa=0;ta=oa;ua=$}else{na=o;la=m;ka=aa;aa=ma;ma=0;p=oa;ja=$;while(1){ia=na+2|0;_=la+2|0;a[aa>>0]=(d[ja>>0]|0)-(d[p>>0]|0);ma=ma+1|0;ha=ka+2|0;if(ma>>>0>=g>>>0){qa=aa;ra=ha;sa=g;ta=_;ua=ia;break}else{ca=aa;L=p;fa=ja;aa=ha;p=_;ja=ia;ka=ca;la=L;na=fa}}}if(sa>>>0<j>>>0){na=m;m=o;o=qa;qa=oa;oa=ra;ra=sa;sa=$;$=ta;ta=ua;while(1){ua=d[$>>0]|0;la=d[qa>>0]|0;ka=d[sa>>0]|0;ja=ua-la|0;p=ka-la|0;aa=(ja|0)<0?0-ja|0:ja;g=(p|0)<0?0-p|0:p;ma=p+ja|0;ja=(ma|0)<0?0-ma|0:ma;if((aa|0)>(g|0)|(aa|0)>(ja|0))va=(g|0)<=(ja|0)?ua:la;else va=ka;a[oa>>0]=(d[ta>>0]|0)-va;ra=ra+1|0;if((ra|0)==(j|0))break;else{ka=oa;la=sa;ua=qa;qa=na+2|0;oa=o+2|0;sa=m+2|0;$=$+1|0;ta=ta+1|0;o=ka;m=la;na=ua}}}pa=c[l>>2]|0}lR(b,pa,(c[h>>2]|0)+1|0,0);h=c[e>>2]|0;if(h){c[e>>2]=c[n>>2];c[n>>2]=h}h=(c[k>>2]|0)+1|0;c[k>>2]=h;if(h>>>0>=(c[b+352>>2]|0)>>>0)lR(b,0,0,4);h=b+476|0;k=(c[h>>2]|0)+1|0;c[h>>2]=k;if(((c[b+472>>2]|0)+-1|0)>>>0>=k>>>0){i=f;return}dR(b);i=f;return}function ER(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;e=c[b+348>>2]|0;f=c[b+360>>2]|0;if((f|e)>>>0>=32768){g=-1;i=d;return g|0}if(!(a[b+428>>0]|0)){g=da(f+1|0,e)|0;i=d;return g|0}f=a[b+434>>0]|0;h=f&255;j=(c[b+344>>2]|0)+-1|0;b=h>>>3;k=e+-1|0;if((f&255)>7){f=0;e=0;a:while(1){l=e;while(1){if((l|0)>=7){g=f;break a}m=(l|0)>1;if(m)n=7-l>>1;else n=3;o=l&1;p=l+1|0;if(m)q=7-l>>1;else q=3;m=(j-(o<<3-(p>>1)&7)+(1<<n)|0)>>>q;if(!m)l=p;else{r=o;s=p;t=m;u=l;break}}l=(da(t,b)|0)+1|0;m=(u|0)>2;if(m)v=8-u>>1;else v=3;if(m)w=8-u>>1;else w=3;f=(da((k-((r^1)<<3-(u>>1)&7)+(1<<v)|0)>>>w,l)|0)+f|0;e=s}i=d;return g|0}else{s=0;e=0;b:while(1){f=e;while(1){if((f|0)>=7){g=s;break b}w=(f|0)>1;if(w)x=7-f>>1;else x=3;v=f&1;u=f+1|0;if(w)y=7-f>>1;else y=3;w=(j-(v<<3-(u>>1)&7)+(1<<x)|0)>>>y;if(!w)f=u;else{z=v;A=u;B=w;C=f;break}}f=(((da(B,h)|0)+7|0)>>>3)+1|0;w=(C|0)>2;if(w)D=8-C>>1;else D=3;if(w)E=8-C>>1;else E=3;s=(da((k-((z^1)<<3-(C>>1)&7)+(1<<D)|0)>>>E,f)|0)+s|0;e=A}i=d;return g|0}return 0}function FR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+64|0;g=f;h=b+216|0;j=c[h>>2]|0;do if(j){a[g>>0]=d>>>24;a[g+1>>0]=d>>>16;a[g+2>>0]=d>>>8;a[g+3>>0]=d;a[g+4>>0]=58;a[g+5>>0]=32;a[g+6>>0]=j>>>24;a[g+7>>0]=j>>>16;a[g+8>>0]=j>>>8;a[g+9>>0]=j;CQ(g,64,10,419432)|0;if((c[h>>2]|0)!=1229209940){c[h>>2]=0;break}c[b+244>>2]=419448;k=-2;i=f;return k|0}while(0);g=c[b+284>>2]|0;j=c[b+288>>2]|0;l=c[b+292>>2]|0;m=c[b+296>>2]|0;do if((d|0)==1229209940)if(!(c[b+208>>2]&1)){n=g;o=m;p=j;q=(a[b+430>>0]|0)!=8&1;r=l;break}else{n=g;o=m;p=j;q=c[b+300>>2]|0;r=l;break}else{n=c[b+304>>2]|0;o=c[b+316>>2]|0;p=c[b+308>>2]|0;q=c[b+320>>2]|0;r=c[b+312>>2]|0}while(0);if(e>>>0<16385?(l=1<<r+-1,j=e+262|0,j>>>0<=l>>>0):0){e=l;l=r;while(1){e=e>>>1;m=l+-1|0;if(j>>>0>e>>>0){s=m;break}else l=m}}else s=r;r=b+208|0;l=c[r>>2]|0;do if(!(l&2))t=l;else{if(((((c[b+324>>2]|0)==(n|0)?(c[b+328>>2]|0)==(p|0):0)?(c[b+332>>2]|0)==(s|0):0)?(c[b+336>>2]|0)==(o|0):0)?(c[b+340>>2]|0)==(q|0):0){t=l;break}lN(b+220|0)|0;e=c[r>>2]&-3;c[r>>2]=e;t=e}while(0);l=b+220|0;c[l>>2]=0;c[b+224>>2]=0;c[b+232>>2]=0;c[b+236>>2]=0;if(!(t&2)){t=kN(l,n,p,s,o,q,419464,56)|0;if(!t){c[r>>2]=c[r>>2]|2;u=24}else{v=t;u=25}}else{t=mN(l)|0;if(!t)u=24;else{v=t;u=25}}if((u|0)==24){c[h>>2]=d;k=0;i=f;return k|0}else if((u|0)==25){zQ(b,v);k=v;i=f;return k|0}return 0}function GR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;j=f+4|0;k=FR(b,e,c[j>>2]|0)|0;if(k){l=k;i=h;return l|0}k=c[j>>2]|0;e=b+220|0;c[e>>2]=c[f>>2];m=b+224|0;c[m>>2]=0;n=f+12|0;o=b+232|0;c[o>>2]=n;p=b+236|0;c[p>>2]=1024;q=b+280|0;r=0;s=b+276|0;t=k;k=1024;while(1){c[m>>2]=t;if(r){if((k+g|0)<0){u=0;v=k;w=-4;break}x=c[s>>2]|0;if(!x){y=OQ(b,(c[q>>2]|0)+4|0)|0;if(!y){u=0;v=k;w=-4;break}c[y>>2]=0;c[s>>2]=y;z=y}else z=x;c[o>>2]=z+4;x=c[q>>2]|0;c[p>>2]=x;A=z;B=x+k|0}else{A=s;B=k}x=nN(e,4)|0;y=c[m>>2]|0;c[m>>2]=0;if(x){u=y;v=B;w=x;break}r=(c[p>>2]|0)==0;s=A;t=y;k=B}B=v-(c[p>>2]|0)|0;c[p>>2]=0;c[f+8>>2]=B;if((B+g|0)>>>0>2147483646){c[b+244>>2]=419400;c[b+216>>2]=0;l=-4;i=h;return l|0}zQ(b,w);c[b+216>>2]=0;if(!((w|0)==1&(u|0)==0)){l=w;i=h;return l|0}w=c[j>>2]|0;if(w>>>0>=16385){l=0;i=h;return l|0}j=d[n>>0]|0;if(!((j&15|0)==8&(j&240)>>>0<113)){l=0;i=h;return l|0}u=j>>>4;j=1<<u+7;if(j>>>0<w>>>0){l=0;i=h;return l|0}else{C=j;D=u}while(1){C=C>>>1;u=D+-1|0;if((u|0)==0|C>>>0<w>>>0){E=u;break}else D=u}D=E<<4|8;a[n>>0]=D;n=f+13|0;f=(d[n>>0]|0)&224;a[n>>0]=(f|(((f|D<<8)>>>0)%31|0))^31;l=0;i=h;return l|0}function HR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im;f=i;i=i+16|0;h=f;c[a>>2]=419696;j=a+8|0;iT(j,b,e);c[a>>2]=419512;c[j>>2]=419664;c[a+12>>2]=0;e=b+100|0;g[a+496>>2]=ea(g[e>>2]);k=b+104|0;g[a+500>>2]=ea(g[k>>2]);l=b+108|0;g[a+504>>2]=ea(g[l>>2]);c[h>>2]=3;m=ea(g[e>>2]);n=ea(g[k>>2]);o=ea(g[l>>2]);p=ea(g[a+488>>2]);q=ea(n*p);n=ea(o*p);g[h+4>>2]=ea(m*p);g[h+8>>2]=q;g[h+12>>2]=n;sT(j,d,h,c[b+92>>2]|0)|0;i=f;return}function IR(a){a=a|0;var b=0;b=i;i=i+16|0;lT(a+8|0);VJa(b,a);i=b;return}function JR(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=a+-8|0;lT(c+8|0);VJa(b,c);i=b;return}function KR(a){a=a|0;var b=0;b=i;lT(a+8|0);i=b;return}function LR(a){a=a|0;var b=0;b=i;lT(a+-8+8|0);i=b;return}function MR(a){a=a|0;var b=0;b=i;qS(a+96|0);i=b;return}function NR(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,i=Im,j=0.0,k=0.0,l=0.0;d=a+416|0;e=ea(g[a+496>>2]);f=ea(g[a+500>>2]);i=ea(g[a+504>>2]);c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];j=+e;h[b>>3]=+h[b>>3]-j;k=+f;a=b+8|0;h[a>>3]=+h[a>>3]-k;l=+i;a=b+16|0;h[a>>3]=+h[a>>3]-l;a=b+24|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];h[a>>3]=j+ +h[a>>3];a=b+32|0;h[a>>3]=k+ +h[a>>3];a=b+40|0;h[a>>3]=l+ +h[a>>3];return 1}function OR(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,i=Im,j=0.0,k=0.0,l=0.0;d=a+-8|0;a=d+416|0;e=ea(g[d+496>>2]);f=ea(g[d+500>>2]);i=ea(g[d+504>>2]);c[b+0>>2]=c[a+0>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];c[b+20>>2]=c[a+20>>2];j=+e;h[b>>3]=+h[b>>3]-j;k=+f;d=b+8|0;h[d>>3]=+h[d>>3]-k;l=+i;d=b+16|0;h[d>>3]=+h[d>>3]-l;d=b+24|0;c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];c[d+16>>2]=c[a+16>>2];c[d+20>>2]=c[a+20>>2];h[d>>3]=j+ +h[d>>3];d=b+32|0;h[d>>3]=k+ +h[d>>3];d=b+40|0;h[d>>3]=l+ +h[d>>3];return 1}function PR(a){a=a|0;var b=Im;b=ea(g[a+496>>2]);return ea(b)}function QR(a){a=a|0;var b=Im;b=ea(g[a+500>>2]);return ea(b)}function RR(a){a=a|0;var b=Im;b=ea(g[a+504>>2]);return ea(b)}function SR(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;d=i;i=i+16|0;e=d;if(b<=ea(0.0)){f=0;i=d;return f|0}h=a+496|0;g[h>>2]=b;if(!(c[a+408>>2]|0)){f=1;i=d;return f|0}j=tT(a+8|0)|0;c[e>>2]=3;k=e+4|0;g[k>>2]=ea(0.0);l=e+8|0;g[l>>2]=ea(0.0);m=e+12|0;g[m>>2]=ea(0.0);_n[c[(c[j>>2]|0)+36>>2]&4095](j,e)|0;b=ea(g[h>>2]);n=ea(g[a+500>>2]);o=ea(g[a+504>>2]);p=ea(g[a+488>>2]);q=ea(n*p);n=ea(o*p);g[k>>2]=ea(b*p);g[l>>2]=q;g[m>>2]=n;In[c[(c[j>>2]|0)+28>>2]&4095](j,e);f=1;i=d;return f|0}function TR(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;d=i;i=i+16|0;e=d;if(b<=ea(0.0)){f=0;i=d;return f|0}h=a+500|0;g[h>>2]=b;if(!(c[a+408>>2]|0)){f=1;i=d;return f|0}j=tT(a+8|0)|0;c[e>>2]=3;k=e+4|0;g[k>>2]=ea(0.0);l=e+8|0;g[l>>2]=ea(0.0);m=e+12|0;g[m>>2]=ea(0.0);_n[c[(c[j>>2]|0)+36>>2]&4095](j,e)|0;b=ea(g[a+496>>2]);n=ea(g[h>>2]);o=ea(g[a+504>>2]);p=ea(g[a+488>>2]);q=ea(n*p);n=ea(o*p);g[k>>2]=ea(b*p);g[l>>2]=q;g[m>>2]=n;In[c[(c[j>>2]|0)+28>>2]&4095](j,e);f=1;i=d;return f|0}function UR(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;d=i;i=i+16|0;e=d;if(b<=ea(0.0)){f=0;i=d;return f|0}h=a+504|0;g[h>>2]=b;if(!(c[a+408>>2]|0)){f=1;i=d;return f|0}j=tT(a+8|0)|0;c[e>>2]=3;k=e+4|0;g[k>>2]=ea(0.0);l=e+8|0;g[l>>2]=ea(0.0);m=e+12|0;g[m>>2]=ea(0.0);_n[c[(c[j>>2]|0)+36>>2]&4095](j,e)|0;b=ea(g[a+496>>2]);n=ea(g[a+500>>2]);o=ea(g[h>>2]);p=ea(g[a+488>>2]);q=ea(n*p);n=ea(o*p);g[k>>2]=ea(b*p);g[l>>2]=q;g[m>>2]=n;In[c[(c[j>>2]|0)+28>>2]&4095](j,e);f=1;i=d;return f|0}function VR(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,i=Im,j=Im;d=b+416|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];e=ea(g[b+496>>2]);f=ea(e+ea(g[b+52>>2]));e=ea(ea(g[b+36>>2])*f);i=ea(f*ea(g[b+40>>2]));j=ea(f*ea(g[b+44>>2]));h[a>>3]=+h[a>>3]-+e;b=a+8|0;h[b>>3]=+h[b>>3]-+i;b=a+16|0;h[b>>3]=+h[b>>3]-+j;return}function WR(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,j=Im,k=Im,l=Im;d=i;i=i+32|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];f=ea(g[a+496>>2]);j=ea(f+ea(g[a+52>>2]));f=ea(ea(g[a+36>>2])*j);k=ea(j*ea(g[a+40>>2]));l=ea(j*ea(g[a+44>>2]));h[e>>3]=+f+ +h[e>>3];b=e+8|0;h[b>>3]=+k+ +h[b>>3];b=e+16|0;h[b>>3]=+l+ +h[b>>3];b=_n[c[(c[a>>2]|0)+20>>2]&4095](a,e)|0;i=d;return b|0}function XR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=Im,p=Im;d=i;i=i+48|0;e=d;_n[c[(c[a>>2]|0)+136>>2]&4095](a,e)|0;f=+h[e>>3];j=+h[e+24>>3];k=+h[e+8>>3];l=+h[e+32>>3];m=+h[e+16>>3];n=+h[e+40>>3];h[b>>3]=(f+j)*.5;h[b+8>>3]=(k+l)*.5;h[b+16>>3]=(m+n)*.5;o=ea(l-k);p=ea(n-m);g[b+24>>2]=ea(ea(j-f)*ea(.5));g[b+28>>2]=ea(o*ea(.5));g[b+32>>2]=ea(p*ea(.5));g[b+36>>2]=ea(g[a+20>>2]);g[b+40>>2]=ea(g[a+24>>2]);g[b+44>>2]=ea(g[a+28>>2]);g[b+48>>2]=ea(g[a+32>>2]);i=d;return}function YR(a,b){a=a|0;b=ea(b);var d=0,e=0,f=Im,j=Im,k=0,l=Im;d=i;i=i+32|0;e=d;f=ea(Kn[c[(c[a>>2]|0)+108>>2]&255](a));Un[c[(c[a>>2]|0)+120>>2]&31](a,b)|0;j=ea(b-f);k=mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[e+16>>2]=c[k+16>>2];c[e+20>>2]=c[k+20>>2];f=ea(j*ea(g[a+36>>2]));b=ea(j*ea(g[a+40>>2]));l=ea(j*ea(g[a+44>>2]));h[e>>3]=+f+ +h[e>>3];k=e+8|0;h[k>>3]=+b+ +h[k>>3];k=e+16|0;h[k>>3]=+l+ +h[k>>3];_n[c[(c[a>>2]|0)+20>>2]&4095](a,e)|0;i=d;return}function ZR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im;f=i;i=i+16|0;h=f;c[a>>2]=420024;j=a+8|0;iT(j,b,e);c[a>>2]=419840;c[j>>2]=419992;c[a+12>>2]=1;e=b+100|0;g[a+496>>2]=ea(g[e>>2]);k=b+104|0;g[a+500>>2]=ea(g[k>>2]);c[a+504>>2]=c[b+108>>2];c[h>>2]=2;l=ea(g[e>>2]);m=ea(g[a+488>>2]);g[h+4>>2]=ea(l*m);g[h+8>>2]=ea(ea(ea(g[k>>2])*ea(.5))*m);sT(j,d,h,c[b+92>>2]|0)|0;i=f;return}function _R(a){a=a|0;var b=0;b=i;i=i+16|0;lT(a+8|0);VJa(b,a);i=b;return}function $R(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=a+-8|0;lT(c+8|0);VJa(b,c);i=b;return}function aS(a){a=a|0;var b=0;b=i;lT(a+8|0);i=b;return}function bS(a){a=a|0;var b=0;b=i;lT(a+-8+8|0);i=b;return}function cS(a){a=a|0;var b=0;b=i;qS(a+96|0);i=b;return}function dS(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,i=0.0,j=0.0;d=a+416|0;e=ea(g[a+496>>2]);f=ea(e+ea(ea(g[a+500>>2])*ea(.5)));c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];i=+e;h[b>>3]=+h[b>>3]-i;j=+f;a=b+8|0;h[a>>3]=+h[a>>3]-j;a=b+16|0;h[a>>3]=+h[a>>3]-i;a=b+24|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];h[a>>3]=i+ +h[a>>3];a=b+32|0;h[a>>3]=j+ +h[a>>3];a=b+40|0;h[a>>3]=i+ +h[a>>3];return 1}function eS(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,i=0.0,j=0.0;d=a+-8|0;a=d+416|0;e=ea(g[d+496>>2]);f=ea(e+ea(ea(g[d+500>>2])*ea(.5)));c[b+0>>2]=c[a+0>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];c[b+20>>2]=c[a+20>>2];i=+e;h[b>>3]=+h[b>>3]-i;j=+f;d=b+8|0;h[d>>3]=+h[d>>3]-j;d=b+16|0;h[d>>3]=+h[d>>3]-i;d=b+24|0;c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];c[d+16>>2]=c[a+16>>2];c[d+20>>2]=c[a+20>>2];h[d>>3]=i+ +h[d>>3];d=b+32|0;h[d>>3]=j+ +h[d>>3];d=b+40|0;h[d>>3]=i+ +h[d>>3];return 1}function fS(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0;d=i;i=i+16|0;e=d;g[a+496>>2]=b;if(!(c[a+408>>2]|0)){i=d;return 1}f=tT(a+8|0)|0;c[e>>2]=2;h=e+4|0;g[h>>2]=ea(0.0);g[e+8>>2]=ea(0.0);_n[c[(c[f>>2]|0)+44>>2]&4095](f,e)|0;g[h>>2]=ea(ea(g[a+488>>2])*b);In[c[(c[f>>2]|0)+28>>2]&4095](f,e);i=d;return 1}function gS(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0;d=i;i=i+16|0;e=d;g[a+500>>2]=b;if(!(c[a+408>>2]|0)){i=d;return 1}f=tT(a+8|0)|0;c[e>>2]=2;g[e+4>>2]=ea(0.0);h=e+8|0;g[h>>2]=ea(0.0);_n[c[(c[f>>2]|0)+44>>2]&4095](f,e)|0;g[h>>2]=ea(ea(b*ea(.5))*ea(g[a+488>>2]));In[c[(c[f>>2]|0)+28>>2]&4095](f,e);i=d;return 1}function hS(a){a=a|0;return c[a+504>>2]|0}function iS(a,b){a=a|0;b=b|0;var d=0;if((b|0)>1)d=0;else{c[a+504>>2]=b;d=1}return d|0}function jS(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,i=Im,j=Im;d=b+416|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];e=ea(g[b+52>>2]);f=ea(e+ea(g[b+496>>2]));e=ea(f+ea(ea(g[b+500>>2])*ea(.5)));f=ea(ea(g[b+36>>2])*e);i=ea(ea(g[b+40>>2])*e);j=ea(e*ea(g[b+44>>2]));h[a>>3]=+h[a>>3]-+f;b=a+8|0;h[b>>3]=+h[b>>3]-+i;b=a+16|0;h[b>>3]=+h[b>>3]-+j;return}function kS(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,j=Im,k=Im,l=Im;d=i;i=i+32|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];f=ea(g[a+52>>2]);j=ea(f+ea(g[a+496>>2]));f=ea(j+ea(ea(g[a+500>>2])*ea(.5)));j=ea(ea(g[a+36>>2])*f);k=ea(ea(g[a+40>>2])*f);l=ea(f*ea(g[a+44>>2]));h[e>>3]=+h[e>>3]+ +j;b=e+8|0;h[b>>3]=+k+ +h[b>>3];b=e+16|0;h[b>>3]=+l+ +h[b>>3];b=_n[c[(c[a>>2]|0)+20>>2]&4095](a,e)|0;i=d;return b|0}function lS(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=Im,i=Im,j=Im,k=0.0,l=0.0,m=0.0;c=+h[a+416>>3];d=+h[a+424>>3];e=+h[a+432>>3];f=ea(g[a+500>>2]);i=ea(f*ea(g[a+36>>2]));j=ea(f*ea(g[a+40>>2]));k=+ea(i*ea(.5));l=+ea(j*ea(.5));m=+ea(ea(f*ea(g[a+44>>2]))*ea(.5));h[b>>3]=c-k;h[b+8>>3]=d-l;h[b+16>>3]=e-m;h[b+24>>3]=c+k;h[b+32>>3]=d+l;h[b+40>>3]=e+m;g[b+48>>2]=ea(g[a+496>>2]);return}function mS(a,b){a=a|0;b=ea(b);var d=0,e=0,f=Im,j=Im,k=0,l=Im,m=0.0;d=i;i=i+32|0;e=d;f=ea(Kn[c[(c[a>>2]|0)+116>>2]&255](a));Un[c[(c[a>>2]|0)+120>>2]&31](a,b)|0;j=ea(b-f);k=mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[e+16>>2]=c[k+16>>2];c[e+20>>2]=c[k+20>>2];f=ea(j*ea(g[a+36>>2]));b=ea(j*ea(g[a+40>>2]));l=ea(b*ea(.5));b=ea(ea(j*ea(g[a+44>>2]))*ea(.5));m=+ea(f*ea(.5));h[e>>3]=+h[e>>3]+m;k=e+8|0;h[k>>3]=+h[k>>3]+ +l;k=e+16|0;h[k>>3]=+h[k>>3]+ +b;_n[c[(c[a>>2]|0)+20>>2]&4095](a,e)|0;i=d;return}function nS(d){d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;g[d+16>>2]=ea(1.0);f=d+20|0;h=d+59|0;j=f+0|0;k=j+36|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b[f+36>>1]=0;a[f+38>>0]=0;a[h>>0]=1;a[d+60>>0]=0;i=e;return}function oS(d){d=d|0;var e=0,f=0,j=0,k=0,l=0;e=i;f=d+224|0;j=d+240|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;f=d+0|0;k=f+44|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(k|0));g[j>>2]=ea(1.0);j=d+244|0;l=d+283|0;f=j+0|0;k=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(k|0));b[j+36>>1]=0;a[j+38>>0]=0;a[l>>0]=1;a[d+284>>0]=0;c[d+296>>2]=-1;l=d+300|0;b[l+0>>1]=0;b[l+2>>1]=0;b[l+4>>1]=0;b[l+6>>1]=0;b[l+8>>1]=0;b[l+10>>1]=0;h[d+48>>3]=1797693134862315708145274.0e284;h[d+56>>3]=1797693134862315708145274.0e284;h[d+64>>3]=1797693134862315708145274.0e284;h[d+72>>3]=-1797693134862315708145274.0e284;h[d+80>>3]=-1797693134862315708145274.0e284;h[d+88>>3]=-1797693134862315708145274.0e284;l=d+96|0;c[d+156>>2]=0;c[d+160>>2]=0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[d+152>>2]=-1;l=d+288|0;f=d+164|0;k=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(k|0));g[l>>2]=ea(1.5);l=d+120|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0;i=e;return}function pS(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+40>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+32>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+28>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+20>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+16>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+8>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function qS(a){a=a|0;h[a+48>>3]=1797693134862315708145274.0e284;h[a+56>>3]=1797693134862315708145274.0e284;h[a+64>>3]=1797693134862315708145274.0e284;h[a+72>>3]=-1797693134862315708145274.0e284;h[a+80>>3]=-1797693134862315708145274.0e284;h[a+88>>3]=-1797693134862315708145274.0e284;c[a+156>>2]=0;c[a+160>>2]=0;c[a+152>>2]=-1;return}function rS(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;f=b[d+4>>1]|0;if((f+-5<<16>>16&65535)<2){g=a+160|0;if((c[g>>2]|0)!=(d|0)){i=e;return}c[a+156>>2]=0;c[g>>2]=0;i=e;return}if(f<<16>>16!=7){i=e;return}f=c[a+32>>2]|0;g=c[a+36>>2]|0;j=f+(g<<2)|0;a:do if(g){k=f;while(1){if((c[k+4>>2]|0)==(d|0))break;k=k+(c[420160+(c[k>>2]<<2)>>2]|0)|0;if((k|0)==(j|0))break a}h[a+48>>3]=1797693134862315708145274.0e284;h[a+56>>3]=1797693134862315708145274.0e284;h[a+64>>3]=1797693134862315708145274.0e284;h[a+72>>3]=-1797693134862315708145274.0e284;h[a+80>>3]=-1797693134862315708145274.0e284;h[a+88>>3]=-1797693134862315708145274.0e284}while(0);j=a+156|0;if((c[j>>2]|0)!=(d|0)){i=e;return}c[j>>2]=0;i=e;return}function sS(a,d,e,f,j,k){a=a|0;d=d|0;e=e|0;f=f|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;l=i;i=i+80|0;m=l+64|0;n=l;c[m>>2]=d;d=a+152|0;if((c[d>>2]|0)==-1){i=l;return}c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;o=n+16|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;g[n+40>>2]=ea(3402823469999999843913219.0e14);g[n+44>>2]=ea(0.0);g[n+48>>2]=ea(0.0);p=HT(e,n,m,f,j,k)|0;if(!p){i=l;return}k=ea(g[o>>2]);q=ea(g[j>>2]);r=ea(k*q);s=ea(g[n+20>>2]);t=ea(g[j+4>>2]);u=ea(r+ea(s*t));r=ea(g[n+24>>2]);v=ea(g[j+8>>2]);w=ea(u+ea(r*v));j=a+212|0;u=ea(q*ea(g[j>>2]));n=a+216|0;q=ea(u+ea(t*ea(g[n>>2])));o=a+220|0;if(!(w<ea(q+ea(v*ea(g[o>>2]))))){i=l;return}c[d>>2]=c[m>>2];g[j>>2]=k;g[n>>2]=s;g[o>>2]=r;v=ea(+h[p+8>>3]);q=ea(+h[p+16>>3]);w=ea(+h[p+24>>3]);t=ea(g[p+32>>2]);u=ea(g[p+36>>2]);x=ea(g[p+40>>2]);y=ea(g[p+44>>2]);z=ea(ea(k-v)*ea(2.0));v=ea(ea(s-q)*ea(2.0));q=ea(ea(r-w)*ea(2.0));w=ea(ea(y*y)+ea(-.5));r=ea(ea(ea(z*t)+ea(v*u))+ea(q*x));s=ea(ea(u*r)+ea(ea(v*w)-ea(y*ea(ea(z*x)-ea(t*q)))));k=ea(ea(x*r)+ea(ea(q*w)-ea(y*ea(ea(t*v)-ea(z*u)))));g[a+200>>2]=ea(ea(t*r)+ea(ea(z*w)-ea(y*ea(ea(u*q)-ea(v*x)))));g[a+204>>2]=s;g[a+208>>2]=k;i=l;return}function tS(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+152|0;if((c[e>>2]|0)!=(b|0)){i=d;return}c[e>>2]=-1;i=d;return}function uS(a,d,e,f,j,k){a=a|0;d=d|0;e=e|0;f=f|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;l=i;i=i+80|0;m=l+8|0;n=l;o=a+152|0;if((c[o>>2]|0)!=(d|0)){i=l;return}c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=-1;b[m+12>>1]=0;d=m+16|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;g[m+40>>2]=ea(3402823469999999843913219.0e14);g[m+44>>2]=ea(0.0);g[m+48>>2]=ea(0.0);c[n>>2]=-1;p=GT(e,m,f,j,k,n)|0;j=c[n>>2]|0;if((p|0)==0?1:(c[o>>2]|0)==(j|0)){i=l;return}c[o>>2]=j;k=ea(g[d>>2]);g[a+212>>2]=k;q=ea(g[m+20>>2]);g[a+216>>2]=q;r=ea(g[m+24>>2]);g[a+220>>2]=r;s=ea(+h[p+8>>3]);t=ea(+h[p+16>>3]);u=ea(+h[p+24>>3]);v=ea(g[p+32>>2]);w=ea(g[p+36>>2]);x=ea(g[p+40>>2]);y=ea(g[p+44>>2]);z=ea(ea(k-s)*ea(2.0));s=ea(ea(q-t)*ea(2.0));t=ea(ea(r-u)*ea(2.0));u=ea(ea(y*y)+ea(-.5));r=ea(ea(ea(z*v)+ea(s*w))+ea(t*x));q=ea(ea(w*r)+ea(ea(s*u)-ea(y*ea(ea(z*x)-ea(v*t)))));k=ea(ea(x*r)+ea(ea(t*u)-ea(y*ea(ea(v*s)-ea(z*w)))));g[a+200>>2]=ea(ea(v*r)+ea(ea(z*u)-ea(y*ea(ea(w*t)-ea(s*x)))));g[a+204>>2]=q;g[a+208>>2]=k;i=l;return}function vS(a,d){a=a|0;d=d|0;var e=0,f=Im,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=Im,q=0;e=i;f=ea(g[d>>2]);j=+f;k=a+48|0;h[k>>3]=+h[k>>3]-j;k=d+4|0;l=+ea(g[k>>2]);m=a+56|0;h[m>>3]=+h[m>>3]-l;m=d+8|0;n=+ea(g[m>>2]);o=a+64|0;h[o>>3]=+h[o>>3]-n;o=a+72|0;h[o>>3]=+h[o>>3]-j;o=a+80|0;h[o>>3]=+h[o>>3]-l;o=a+88|0;h[o>>3]=+h[o>>3]-n;if(!(c[a+156>>2]|0)){if((c[a+152>>2]|0)!=-1){o=a+212|0;g[o>>2]=ea(ea(g[o>>2])-f);p=ea(g[k>>2]);o=a+216|0;g[o>>2]=ea(ea(g[o>>2])-p);p=ea(g[m>>2]);o=a+220|0;g[o>>2]=ea(ea(g[o>>2])-p)}}else if((b[(c[a+160>>2]|0)+4>>1]|0)!=6){o=a+188|0;g[o>>2]=ea(ea(g[o>>2])-f);f=ea(g[k>>2]);o=a+192|0;g[o>>2]=ea(ea(g[o>>2])-f);f=ea(g[m>>2]);o=a+196|0;g[o>>2]=ea(ea(g[o>>2])-f)}o=c[a+32>>2]|0;q=c[a+36>>2]|0;a=o+(q<<2)|0;if(!q){i=e;return}n=+ea(g[d>>2]);l=+ea(g[k>>2]);j=+ea(g[m>>2]);m=o;do{o=m+16|0;h[o>>3]=+h[o>>3]-n;o=m+24|0;h[o>>3]=+h[o>>3]-l;o=m+32|0;h[o>>3]=+h[o>>3]-j;m=m+(c[420160+(c[m>>2]<<2)>>2]|0)|0}while((m|0)!=(a|0));i=e;return}function wS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=0,la=0,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=Im,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;e=i;i=i+208|0;f=e+180|0;j=e+120|0;k=e+12|0;l=e+48|0;m=e+192|0;n=e;o=e+108|0;p=e+168|0;q=e+132|0;r=+h[d>>3];s=d+24|0;t=+h[s>>3];u=d+8|0;v=+h[u>>3];w=d+32|0;x=+h[w>>3];y=d+16|0;z=+h[y>>3];A=d+40|0;B=+h[A>>3];C=(r+t)*.5;D=(v+x)*.5;E=(z+B)*.5;F=c[b>>2]|0;G=c[b+4>>2]|0;H=c[b+8>>2]|0;I=ea(r);J=ea(v);K=ea(z);L=ea(t);M=ea(x);N=ea(B);if(!F){O=t;P=r;Q=x;R=v;S=B;T=z}else{U=l+4|0;V=l+8|0;W=l+12|0;X=l+16|0;Y=l+20|0;Z=l+24|0;_=l+28|0;$=l+32|0;aa=l+36|0;ba=l+40|0;ca=l+44|0;da=l+48|0;fa=l+52|0;ga=l+56|0;ha=ea(ea(I+L)*ea(.5));ia=ea(ea(J+M)*ea(.5));ja=ea(ea(K+N)*ea(.5));ka=f+4|0;la=f+8|0;ma=ea(ea(L-I)*ea(.5));I=ea(ea(M-J)*ea(.5));J=ea(ea(N-K)*ea(.5));na=j+4|0;oa=j+8|0;pa=l+48|0;qa=l+36|0;ra=k+4|0;sa=k+8|0;ta=k+12|0;ua=k+16|0;va=k+20|0;wa=k+24|0;xa=k+28|0;ya=k+32|0;za=a+32|0;Aa=a+36|0;Ba=0;do{Ca=G+(Ba*56|0)|0;K=ea(+h[Ca>>3]);N=ea(+h[G+(Ba*56|0)+8>>3]);M=ea(+h[G+(Ba*56|0)+16>>3]);Da=G+(Ba*56|0)+36|0;L=ea(g[Da>>2]);Ea=G+(Ba*56|0)+40|0;Fa=ea(g[Ea>>2]);Ga=G+(Ba*56|0)+44|0;Ha=ea(g[Ga>>2]);Ia=G+(Ba*56|0)+48|0;Ja=ea(g[Ia>>2]);Ka=ea(L+L);La=ea(Fa+Fa);Ma=ea(Ha+Ha);Na=ea(Fa*La);Oa=ea(Ha*Ma);Pa=ea(Ka*Fa);Fa=ea(Ka*Ha);Qa=ea(Ka*Ja);Ra=ea(La*Ha);Ha=ea(La*Ja);La=ea(Ma*Ja);Ja=ea(Pa+La);Ma=ea(Fa-Ha);Sa=ea(Pa-La);La=ea(ea(1.0)-ea(L*Ka));Ka=ea(La-Oa);L=ea(Ra+Qa);Pa=ea(Fa+Ha);Ha=ea(Ra-Qa);Qa=ea(La-Na);g[l>>2]=ea(ea(ea(1.0)-Na)-Oa);g[U>>2]=Ja;g[V>>2]=Ma;g[W>>2]=Sa;g[X>>2]=Ka;g[Y>>2]=L;g[Z>>2]=Pa;g[_>>2]=Ha;g[$>>2]=Qa;g[aa>>2]=K;g[ba>>2]=N;g[ca>>2]=M;Ta=G+(Ba*56|0)+24|0;g[da>>2]=ea(g[Ta>>2]);Ua=G+(Ba*56|0)+28|0;g[fa>>2]=ea(g[Ua>>2]);Va=G+(Ba*56|0)+32|0;g[ga>>2]=ea(g[Va>>2]);g[f>>2]=ha;g[ka>>2]=ia;g[la>>2]=ja;g[j>>2]=ma;g[na>>2]=I;g[oa>>2]=J;g[k>>2]=ea(1.0);g[ra>>2]=ea(0.0);g[sa>>2]=ea(0.0);g[ta>>2]=ea(0.0);g[ua>>2]=ea(1.0);g[va>>2]=ea(0.0);g[wa>>2]=ea(0.0);g[xa>>2]=ea(0.0);g[ya>>2]=ea(1.0);if(NPa(pa,qa,l,j,f,k,1)|0){Wa=c[Aa>>2]|0;YTa(za,Wa+24|0);Xa=c[za>>2]|0;c[Xa+(Wa<<2)>>2]=0;c[Xa+(Wa+1<<2)>>2]=c[H+(Ba<<2)>>2];c[Xa+(Wa+2<<2)>>2]=0;h[Xa+(Wa+4<<2)>>3]=C;h[Xa+(Wa+6<<2)>>3]=D;h[Xa+(Wa+8<<2)>>3]=E;Ya=Xa+(Wa+10<<2)|0;c[Ya+0>>2]=c[Ca+0>>2];c[Ya+4>>2]=c[Ca+4>>2];c[Ya+8>>2]=c[Ca+8>>2];c[Ya+12>>2]=c[Ca+12>>2];c[Ya+16>>2]=c[Ca+16>>2];c[Ya+20>>2]=c[Ca+20>>2];g[Xa+(Wa+16<<2)>>2]=ea(g[Ta>>2]);g[Xa+(Wa+17<<2)>>2]=ea(g[Ua>>2]);g[Xa+(Wa+18<<2)>>2]=ea(g[Va>>2]);g[Xa+(Wa+19<<2)>>2]=ea(g[Da>>2]);g[Xa+(Wa+20<<2)>>2]=ea(g[Ea>>2]);g[Xa+(Wa+21<<2)>>2]=ea(g[Ga>>2]);g[Xa+(Wa+22<<2)>>2]=ea(g[Ia>>2])}Ba=Ba+1|0}while((Ba|0)!=(F|0));O=+h[s>>3];P=+h[d>>3];Q=+h[w>>3];R=+h[u>>3];S=+h[A>>3];T=+h[y>>3]}F=c[b+12>>2]|0;Ba=c[b+16>>2]|0;H=c[b+20>>2]|0;J=ea(Q-R);I=ea(S-T);g[m>>2]=ea(ea(O-P)*ea(.5));g[m+4>>2]=ea(J*ea(.5));g[m+8>>2]=ea(I*ea(.5));if(!F){i=e;return}b=n+4|0;za=n+8|0;Aa=o+4|0;k=o+8|0;I=ea((P+O)*.5);J=ea((R+Q)*.5);ma=ea((T+S)*.5);f=p+4|0;j=p+8|0;l=q+4|0;qa=q+8|0;pa=q+12|0;ya=q+16|0;xa=q+20|0;wa=q+24|0;va=q+28|0;ua=q+32|0;ta=a+32|0;sa=a+36|0;S=O;a=0;while(1){ra=Ba+(a*56|0)|0;ja=ea(g[Ba+(a*56|0)+48>>2]);O=+h[ra>>3];T=+h[Ba+(a*56|0)+24>>3];oa=O<T;if((((((!(+ea(ea(oa?O:T)-ja)>S)?(ia=ea(oa?T:O),!(+h[d>>3]>+ea(ja+ia))):0)?(Q=+h[Ba+(a*56|0)+8>>3],R=+h[Ba+(a*56|0)+32>>3],oa=Q<R,P=+ea(ea(oa?Q:R)-ja),!(P>+h[w>>3])):0)?(ia=ea(oa?R:Q),!(+h[u>>3]>+ea(ja+ia))):0)?(P=+h[Ba+(a*56|0)+16>>3],z=+h[Ba+(a*56|0)+40>>3],oa=P<z,B=+ea(ea(oa?P:z)-ja),!(B>+h[A>>3])):0)?(ia=ea(oa?z:P),!(+h[y>>3]>+ea(ja+ia))):0)?(ia=ea(Q),ha=ea(P),g[n>>2]=ea(O),g[b>>2]=ia,g[za>>2]=ha,ha=ea(R),ia=ea(z),g[o>>2]=ea(T),g[Aa>>2]=ha,g[k>>2]=ia,g[p>>2]=I,g[f>>2]=J,g[j>>2]=ma,g[q>>2]=ea(1.0),g[l>>2]=ea(0.0),g[qa>>2]=ea(0.0),g[pa>>2]=ea(0.0),g[ya>>2]=ea(1.0),g[xa>>2]=ea(0.0),g[wa>>2]=ea(0.0),g[va>>2]=ea(0.0),g[ua>>2]=ea(1.0),!(ea(LOa(n,o,p,m,q,0,0))>ea(ja*ja))):0){oa=c[sa>>2]|0;YTa(ta,oa+24|0);na=c[ta>>2]|0;c[na+(oa<<2)>>2]=1;c[na+(oa+1<<2)>>2]=c[H+(a<<2)>>2];c[na+(oa+2<<2)>>2]=0;h[na+(oa+4<<2)>>3]=C;h[na+(oa+6<<2)>>3]=D;h[na+(oa+8<<2)>>3]=E;la=na+(oa+10<<2)+0|0;oa=ra+0|0;ra=la+52|0;do{c[la>>2]=c[oa>>2];la=la+4|0;oa=oa+4|0}while((la|0)<(ra|0))}oa=a+1|0;if((oa|0)==(F|0))break;S=+h[s>>3];a=oa}i=e;return}function xS(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=Im,N=Im,O=0.0,P=Im,Q=Im,R=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0;m=i;i=i+176|0;n=m+160|0;o=m+56|0;p=m+28|0;q=m;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];r=k+8|0;k=b[r>>1]|0;a[n+10>>0]=(k&65535)>>>2&1;a[n+11>>0]=(k&65535)>>>3&1;k=FS(e)|0;s=d+296|0;if((k|0)==(c[s>>2]|0)){t=d+48|0;if(((((!(+h[t>>3]>+h[j>>3])?!(+h[d+56>>3]>+h[j+8>>3]):0)?!(+h[d+64>>3]>+h[j+16>>3]):0)?!(+h[d+72>>3]<+h[j+24>>3]):0)?!(+h[d+80>>3]<+h[j+32>>3]):0)?!(+h[d+88>>3]<+h[j+40>>3]):0){u=d+308|0;v=c[u>>2]|0;if(!(v&128))w=0;else{c[u>>2]=v&-129;c[d+36>>2]=c[d+112>>2];v=c[d+116>>2]|0;c[d+12>>2]=v;c[d+24>>2]=v;a[n+8>>0]=0;if(b[r>>1]&2)a[n+9>>0]=1;GS(e,t,d+8|0,d+20|0,d+32|0,n,d+224|0,d+304|0);wS(d,f,t);v=d+302|0;b[v>>1]=(b[v>>1]|0)+1<<16>>16;w=0}}else{x=t;y=t;z=13}}else{c[s>>2]=k;k=d+48|0;x=k;y=k;z=13}if((z|0)==13){A=y+0|0;z=j+0|0;B=A+48|0;do{c[A>>2]=c[z>>2];A=A+4|0;z=z+4|0}while((A|0)<(B|0));C=ea(g[d+288>>2]);D=+h[x>>3];z=d+72|0;E=+h[z>>3];k=d+56|0;F=+h[k>>3];s=d+80|0;G=+h[s>>3];t=d+64|0;H=+h[t>>3];v=d+88|0;I=+h[v>>3];J=(D+E)*.5;K=(F+G)*.5;L=(H+I)*.5;M=ea(C*ea(ea(G-F)*ea(.5)));N=ea(C*ea(ea(I-H)*ea(.5)));H=+ea(C*ea(ea(E-D)*ea(.5)));D=J-H;h[x>>3]=D;E=+M;I=K-E;h[k>>3]=I;F=+N;G=L-F;h[t>>3]=G;O=J+H;h[z>>3]=O;H=K+E;h[s>>3]=H;E=L+F;h[v>>3]=E;N=ea(g[l>>2]);u=N==ea(0.0);M=ea(g[l+4>>2]);if(!(u&M==ea(0.0)?ea(g[l+8>>2])==ea(0.0):0)){C=ea(ea(N*N)+ea(M*M));P=ea(g[l+8>>2]);Q=ea(C+ea(P*P));if(Q>ea(0.0)){C=ea(ea(1.0)/ea(T(ea(Q))));R=ea(N*C);U=ea(M*C);V=ea(P*C)}else{R=ea(0.0);U=ea(0.0);V=ea(0.0)}l=j+24|0;C=ea(+h[l>>3]-+h[j>>3]);u=j+32|0;W=j+8|0;P=ea(+h[u>>3]-+h[W>>3]);X=j+40|0;Y=j+16|0;M=ea(ea(ea(S(ea(ea(ea(R*ea(O-D))+ea(U*ea(H-I)))+ea(V*ea(E-G)))))-ea(S(ea(ea(ea(R*C)+ea(U*P))+ea(V*ea(+h[X>>3]-+h[Y>>3]))))))*ea(.449999988));P=ea(U*M);U=ea(V*M);F=+ea(R*M);L=D+F;h[x>>3]=L;D=+P;K=I+D;h[k>>3]=K;I=+U;J=G+I;h[t>>3]=J;G=O+F;h[z>>3]=G;F=H+D;h[s>>3]=F;D=I+E;h[v>>3]=D;E=+h[j>>3];if(L>E)h[x>>3]=E;E=+h[W>>3];if(K>E)h[k>>3]=E;E=+h[Y>>3];if(J>E)h[t>>3]=E;E=+h[l>>3];if(G<E)h[z>>3]=E;E=+h[u>>3];if(F<E)h[s>>3]=E;E=+h[X>>3];if(D<E)h[v>>3]=E}v=d+8|0;X=d+12|0;c[X>>2]=0;s=d+20|0;c[d+24>>2]=0;u=d+32|0;z=d+36|0;c[z>>2]=0;l=d+96|0;t=d+300|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;b[t>>1]=(b[t>>1]|0)+1<<16>>16;t=n+8|0;if(b[r>>1]&1)a[t>>0]=1;l=n+9|0;a[l>>0]=0;Y=d+224|0;k=d+304|0;GS(e,y,v,s,u,n,Y,k);c[d+112>>2]=c[z>>2];c[d+116>>2]=c[X>>2];a[t>>0]=0;if(b[r>>1]&2)a[l>>0]=1;GS(e,y,v,s,u,n,Y,k);wS(d,f,y);y=d+308|0;c[y>>2]=c[y>>2]&-129;w=1}y=c[d>>2]|0;if(!y){i=m;return}f=o+36|0;A=o+0|0;B=A+36|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));g[f>>2]=ea(1.0);f=o+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;g[o+56>>2]=ea(1.0);f=o+60|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;g[o+76>>2]=ea(1.0);f=o+80|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;g[o+96>>2]=ea(1.0);c[o+100>>2]=y;y=d+4|0;f=c[y>>2]|0;if(!(f&1))Z=f;else{DKa(o,-65281)|0;U=ea(+h[j>>3]);P=ea(+h[j+8>>3]);M=ea(+h[j+16>>3]);R=ea(+h[j+24>>3]);V=ea(+h[j+32>>3]);C=ea(+h[j+40>>3]);g[p>>2]=U;g[p+4>>2]=P;g[p+8>>2]=M;g[p+12>>2]=R;g[p+16>>2]=V;g[p+20>>2]=C;a[p+24>>0]=1;HKa(o,p)|0;Z=c[y>>2]|0}if(!(Z&2)){i=m;return}if(w)DKa(o,-65536)|0;else DKa(o,-16711936)|0;C=ea(+h[d+48>>3]);V=ea(+h[d+56>>3]);R=ea(+h[d+64>>3]);M=ea(+h[d+72>>3]);P=ea(+h[d+80>>3]);U=ea(+h[d+88>>3]);g[q>>2]=C;g[q+4>>2]=V;g[q+8>>2]=R;g[q+12>>2]=M;g[q+16>>2]=P;g[q+20>>2]=U;a[q+24>>0]=1;HKa(o,q)|0;i=m;return}function yS(d,e,f,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=0,zc=0,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=0,Kc=0;s=i;i=i+368|0;t=s+136|0;u=s+300|0;v=s+256|0;w=s+184|0;x=s+340|0;y=s+296|0;z=s+212|0;A=s+240|0;B=s+352|0;C=s+80|0;D=s;E=s+328|0;F=s+24|0;G=ea(g[l>>2]);H=l+4|0;if((G==ea(0.0)?ea(g[H>>2])==ea(0.0):0)?ea(g[l+8>>2])==ea(0.0):0){I=0;i=s;return I|0}J=d+308|0;c[J>>2]=c[J>>2]&-53;K=d+156|0;c[K>>2]=0;L=d+160|0;c[L>>2]=0;M=d+152|0;c[M>>2]=-1;N=k+8|0;c[D+0>>2]=c[N+0>>2];c[D+4>>2]=c[N+4>>2];c[D+8>>2]=c[N+8>>2];c[D+12>>2]=c[N+12>>2];c[D+16>>2]=c[N+16>>2];c[D+20>>2]=c[N+20>>2];O=k+16|0;P=k+24|0;Q=l+8|0;a:do if(!n){R=0;S=0}else{U=ea(g[Q>>2]);V=+ea(g[H>>2]);W=d+306|0;X=D+8|0;Y=D+16|0;Z=E+4|0;_=E+8|0;$=d+260|0;aa=F+36|0;ba=d+282|0;ca=F+40|0;da=F+44|0;fa=F+48|0;ga=d+32|0;ha=d+36|0;ia=k+36|0;ja=C+36|0;ka=C+40|0;la=C+44|0;ma=C+24|0;na=F+24|0;oa=C+28|0;pa=F+28|0;qa=C+32|0;ra=F+32|0;sa=(r|0)==3;ta=f+8|0;ua=f+12|0;va=(r|0)==2;wa=F+8|0;xa=F+16|0;ya=d+212|0;za=d+216|0;Aa=d+220|0;Ba=d+200|0;Ca=d+204|0;Da=d+208|0;Ea=(r|0)!=2;Fa=d+244|0;Ga=d+248|0;Ha=d+252|0;Ia=d+292|0;Ja=d+224|0;Ka=d+8|0;La=d+48|0;Ma=d+72|0;Na=d+56|0;Oa=d+80|0;Pa=d+64|0;Qa=d+88|0;Ra=d+144|0;Sa=d+148|0;Ta=d+120|0;Ua=d+124|0;Va=d+128|0;Wa=u+16|0;Xa=u+20|0;Ya=u+24|0;Za=t+12|0;_a=t+4|0;$a=t+8|0;ab=t+16|0;bb=t+20|0;cb=t+24|0;db=u+12|0;eb=u+8|0;fb=u+4|0;gb=d+188|0;hb=d+192|0;ib=d+196|0;jb=d+176|0;kb=d+180|0;lb=d+184|0;mb=(r&-3|0)==1;nb=d+132|0;ob=d+136|0;pb=d+140|0;qb=d+284|0;rb=n;sb=+h[k+8>>3]+ +G;tb=+h[D>>3];ub=+h[O>>3]+V;V=+h[X>>3];vb=+h[P>>3]+ +U;wb=+h[Y>>3];xb=0;yb=0;while(1){b[W>>1]=(b[W>>1]|0)+1<<16>>16;U=ea(ub-V);zb=ea(vb-wb);g[E>>2]=ea(sb-tb);g[Z>>2]=U;g[_>>2]=zb;En[c[(c[k>>2]|0)+8>>2]&127](k,d,t,D,E);xS(d,e,j,t,q,m);zb=ea(g[E>>2]);U=ea(zb*zb);Ab=ea(g[Z>>2]);Bb=ea(U+ea(Ab*Ab));U=ea(g[_>>2]);Cb=ea(T(ea(Bb+ea(U*U))));if(Cb<=p){R=xb;S=yb;break a}Bb=ea(ea(1.0)/Cb);Db=ea(zb*Bb);g[E>>2]=Db;zb=ea(Bb*Ab);g[Z>>2]=zb;Ab=ea(Bb*U);g[_>>2]=Ab;U=ea(Db*ea(g[l>>2]));Db=ea(U+ea(zb*ea(g[H>>2])));if(ea(Db+ea(Ab*ea(g[Q>>2])))<=ea(0.0)){R=xb;S=yb;break a}g[aa>>2]=ea(Cb+ea(g[$>>2]));Eb=a[ba>>0]|0;c[ca>>2]=-1;c[da>>2]=-1;c[fa>>2]=0;Fb=c[ga>>2]|0;Gb=c[ha>>2]|0;Hb=Fb+(Gb<<2)|0;if(!Gb){Ib=75;break}b:do if(!(Eb<<24>>24)){Gb=Fb;while(1){Jb=c[420232+((c[ia>>2]|0)*24|0)+(c[Gb>>2]<<2)>>2]|0;if((((Jb|0)!=0?(g[ja>>2]=ea(g[aa>>2]),c[ka>>2]=-1,c[la>>2]=-1,Km[Jb&127](d,k,Gb,D,E,C)|0):0)?(Ab=ea(g[ja>>2]),Jb=Ab!=ea(0.0),Jb&Ab<ea(g[aa>>2])):0)?(c[F+0>>2]=c[C+0>>2],c[F+4>>2]=c[C+4>>2],c[F+8>>2]=c[C+8>>2],c[F+12>>2]=c[C+12>>2],c[F+16>>2]=c[C+16>>2],c[F+20>>2]=c[C+20>>2],g[na>>2]=ea(g[ma>>2]),g[pa>>2]=ea(g[oa>>2]),g[ra>>2]=ea(g[qa>>2]),c[aa+0>>2]=c[ja+0>>2],c[aa+4>>2]=c[ja+4>>2],c[aa+8>>2]=c[ja+8>>2],c[fa>>2]=Gb,Ab<=ea(0.0)):0){Kb=Gb;break b}Gb=Gb+((c[420160+(c[Gb>>2]<<2)>>2]|0)+7&-8)|0;if((Gb|0)==(Hb|0)){Ib=24;break}}}else{Gb=Fb;c:while(1){Jb=c[420232+((c[ia>>2]|0)*24|0)+(c[Gb>>2]<<2)>>2]|0;do if((Jb|0)!=0?(g[ja>>2]=ea(g[aa>>2]),c[ka>>2]=-1,c[la>>2]=-1,Km[Jb&127](d,k,Gb,D,E,C)|0):0){Ab=ea(g[ja>>2]);if(Ab==ea(0.0)){if((c[Gb>>2]|0)>>>0<2)break;if((b[(c[Gb+8>>2]|0)+4>>1]|0)==6)break c;else break}else{if(!(Ab<ea(g[aa>>2])))break;c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[F+16>>2]=c[C+16>>2];c[F+20>>2]=c[C+20>>2];g[na>>2]=ea(g[ma>>2]);g[pa>>2]=ea(g[oa>>2]);g[ra>>2]=ea(g[qa>>2]);c[aa+0>>2]=c[ja+0>>2];c[aa+4>>2]=c[ja+4>>2];c[aa+8>>2]=c[ja+8>>2];c[fa>>2]=Gb;if(!(Ab<=ea(0.0)))break;else{Kb=Gb;break b}}}while(0);Jb=Gb+((c[420160+(c[Gb>>2]<<2)>>2]|0)+7&-8)|0;if((Jb|0)==(Hb|0)){Ib=24;break b}else Gb=Jb}c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[F+16>>2]=c[C+16>>2];c[F+20>>2]=c[C+20>>2];g[na>>2]=ea(g[ma>>2]);g[pa>>2]=ea(g[oa>>2]);g[ra>>2]=ea(g[qa>>2]);c[aa+0>>2]=c[ja+0>>2];c[aa+4>>2]=c[ja+4>>2];c[aa+8>>2]=c[ja+8>>2];c[fa>>2]=Gb;Kb=Gb}while(0);if((Ib|0)==24){Ib=0;Kb=c[fa>>2]|0}if(!Kb){Ib=75;break}if((a[ba>>0]|0)!=0?ea(g[aa>>2])==ea(0.0):0)break;do if((c[Kb>>2]|0)>>>0<2)if(!sa){c[ta>>2]=0;c[ua>>2]=-1;Hb=((IS(f,F,E,Cb)|0)&2|0)==0;Fb=c[ta>>2]|0;Eb=c[ua>>2]|0;if(va){Jb=c[J>>2]|0;if(!Fb){c[J>>2]=Jb|16;Lb=0;Mb=Hb;break}else{c[J>>2]=Jb|32;c[M>>2]=Eb;Ab=ea(+h[F>>3]);Db=ea(+h[wa>>3]);zb=ea(+h[xa>>3]);g[ya>>2]=Ab;g[za>>2]=Db;g[Aa>>2]=zb;U=ea(+h[Fb+8>>3]);Bb=ea(+h[Fb+16>>3]);Nb=ea(+h[Fb+24>>3]);Ob=ea(g[Fb+32>>2]);Pb=ea(g[Fb+36>>2]);Qb=ea(g[Fb+40>>2]);Rb=ea(g[Fb+44>>2]);Sb=ea(ea(Ab-U)*ea(2.0));U=ea(ea(Db-Bb)*ea(2.0));Bb=ea(ea(zb-Nb)*ea(2.0));Nb=ea(ea(Rb*Rb)+ea(-.5));zb=ea(ea(ea(Sb*Ob)+ea(U*Pb))+ea(Bb*Qb));Db=ea(ea(Pb*zb)+ea(ea(U*Nb)-ea(Rb*ea(ea(Sb*Qb)-ea(Ob*Bb)))));Ab=ea(ea(Qb*zb)+ea(ea(Bb*Nb)-ea(Rb*ea(ea(Ob*U)-ea(Sb*Pb)))));g[Ba>>2]=ea(ea(Ob*zb)+ea(ea(Sb*Nb)-ea(Rb*ea(ea(Pb*Bb)-ea(U*Qb)))));g[Ca>>2]=Db;g[Da>>2]=Ab;Lb=0;Mb=Hb;break}}else{Lb=0;Mb=Hb}}else{Lb=0;Mb=1}else{Hb=c[Kb+4>>2]|0;Fb=c[Kb+8>>2]|0;if(!va)if((mb?(b[Fb+4>>1]|0)==6:0)?(Eb=c[ca>>2]|0,(Eb|0)!=-1):0){c[J>>2]=c[J>>2]|8;Jb=c[Ka>>2]|0;Ab=ea(g[Jb+(Eb*36|0)+12>>2]);Db=ea(g[Jb+(Eb*36|0)>>2]);Qb=ea(Ab-Db);Ab=ea(g[Jb+(Eb*36|0)+16>>2]);U=ea(g[Jb+(Eb*36|0)+4>>2]);Bb=ea(Ab-U);Ab=ea(g[Jb+(Eb*36|0)+20>>2]);Pb=ea(g[Jb+(Eb*36|0)+8>>2]);Rb=ea(Ab-Pb);Ab=ea(ea(g[Jb+(Eb*36|0)+24>>2])-Db);Db=ea(ea(g[Jb+(Eb*36|0)+28>>2])-U);U=ea(ea(g[Jb+(Eb*36|0)+32>>2])-Pb);Pb=ea(ea(Bb*U)-ea(Rb*Db));Nb=ea(ea(Rb*Ab)-ea(Qb*U));U=ea(ea(Qb*Db)-ea(Bb*Ab));g[nb>>2]=Pb;g[ob>>2]=Nb;g[pb>>2]=U;Ab=ea(T(ea(ea(U*U)+ea(ea(Pb*Pb)+ea(Nb*Nb)))));if(Ab>ea(0.0)){Bb=ea(ea(1.0)/Ab);Ab=ea(Pb*Bb);g[nb>>2]=Ab;Db=ea(Nb*Bb);g[ob>>2]=Db;Qb=ea(U*Bb);g[pb>>2]=Qb;Tb=Ab;Ub=Db;Vb=Qb}else{Tb=Pb;Ub=Nb;Vb=U}if((a[qb>>0]|0)!=0?(U=ea(Tb*ea(g[Fa>>2])),Nb=ea(U+ea(Ub*ea(g[Ga>>2]))),ea(Nb+ea(Vb*ea(g[Ha>>2])))<ea(0.0)):0)Wb=1;else Wb=0}else Wb=0;else{Eb=c[J>>2]&-49;c[J>>2]=Eb;if(((b[Fb+4>>1]|0)==6?(Jb=c[ca>>2]|0,(Jb|0)!=-1):0)?(c[J>>2]=Eb|4,Eb=c[Ka>>2]|0,Xb=Eb+(Jb*36|0)|0,Nb=ea(g[Xb>>2]),U=ea(g[Fa>>2]),Pb=ea(Nb*U),Yb=Eb+(Jb*36|0)+4|0,Nb=ea(g[Yb>>2]),Qb=ea(g[Ga>>2]),Db=ea(Pb+ea(Nb*Qb)),Zb=Eb+(Jb*36|0)+8|0,Nb=ea(g[Zb>>2]),Pb=ea(g[Ha>>2]),Ab=ea(Db+ea(Nb*Pb)),_b=Eb+(Jb*36|0)+12|0,Nb=ea(U*ea(g[_b>>2])),$b=Eb+(Jb*36|0)+16|0,Db=ea(Nb+ea(Qb*ea(g[$b>>2]))),ac=Eb+(Jb*36|0)+20|0,Nb=ea(Db+ea(Pb*ea(g[ac>>2]))),bc=Eb+(Jb*36|0)+24|0,Db=ea(U*ea(g[bc>>2])),cc=Eb+(Jb*36|0)+28|0,Bb=ea(Db+ea(Qb*ea(g[cc>>2]))),dc=Eb+(Jb*36|0)+32|0,Db=ea(Bb+ea(Pb*ea(g[dc>>2]))),Bb=Ab<Nb?Ab:Nb,Rb=Ab>Nb?Ab:Nb,Nb=ea(ea(ea(U*ea((+h[La>>3]+ +h[Ma>>3])*.5))+ea(Qb*ea((+h[Na>>3]+ +h[Oa>>3])*.5)))+ea(Pb*ea((+h[Pa>>3]+ +h[Qa>>3])*.5))),g[Ra>>2]=ea((Bb<Db?Bb:Db)+Nb),g[Sa>>2]=ea((Rb>Db?Rb:Db)+Nb),Nb=ea(g[_b>>2]),Db=ea(g[Xb>>2]),Rb=ea(Nb-Db),Nb=ea(g[$b>>2]),Bb=ea(g[Yb>>2]),Pb=ea(Nb-Bb),Nb=ea(g[ac>>2]),Qb=ea(g[Zb>>2]),U=ea(Nb-Qb),Nb=ea(ea(g[bc>>2])-Db),Db=ea(ea(g[cc>>2])-Bb),Bb=ea(ea(g[dc>>2])-Qb),Qb=ea(ea(Pb*Bb)-ea(U*Db)),Ab=ea(ea(U*Nb)-ea(Rb*Bb)),Bb=ea(ea(Rb*Db)-ea(Pb*Nb)),g[Ta>>2]=Qb,g[Ua>>2]=Ab,g[Va>>2]=Bb,Nb=ea(T(ea(ea(Bb*Bb)+ea(ea(Qb*Qb)+ea(Ab*Ab))))),Nb>ea(0.0)):0){Pb=ea(ea(1.0)/Nb);g[Ta>>2]=ea(Qb*Pb);g[Ua>>2]=ea(Ab*Pb);g[Va>>2]=ea(Bb*Pb)}c[K>>2]=Hb;c[L>>2]=Fb;In[c[(c[Fb>>2]|0)+84>>2]&4095](t,Fb);In[c[(c[Hb>>2]|0)+72>>2]&4095](u,Hb);Pb=ea(ea(g[Wa>>2])*ea(2.0));Bb=ea(ea(g[Xa>>2])*ea(2.0));Ab=ea(ea(g[Ya>>2])*ea(2.0));Qb=ea(g[Za>>2]);Nb=ea(ea(Qb*Qb)+ea(-.5));Db=ea(g[t>>2]);Rb=ea(Pb*Db);U=ea(g[_a>>2]);Sb=ea(Rb+ea(Bb*U));Rb=ea(g[$a>>2]);zb=ea(Sb+ea(Ab*Rb));Sb=ea(ea(Db*zb)+ea(ea(Pb*Nb)+ea(Qb*ea(ea(Ab*U)-ea(Bb*Rb)))));Ob=ea(ea(U*zb)+ea(ea(Bb*Nb)+ea(Qb*ea(ea(Pb*Rb)-ea(Ab*Db)))));ec=ea(ea(ea(Ab*Nb)+ea(Qb*ea(ea(Bb*Db)-ea(Pb*U))))+ea(Rb*zb));zb=ea(ea(g[ab>>2])+Sb);Sb=ea(ea(g[bb>>2])+Ob);Ob=ea(ea(g[cb>>2])+ec);ec=ea(g[u>>2]);Pb=ea(Qb*ec);Bb=ea(g[db>>2]);Nb=ea(Pb+ea(Db*Bb));Pb=ea(g[eb>>2]);Ab=ea(Nb+ea(U*Pb));Nb=ea(g[fb>>2]);fc=ea(Ab-ea(Rb*Nb));Ab=ea(ea(ea(Rb*ec)+ea(ea(U*Bb)+ea(Qb*Nb)))-ea(Db*Pb));gc=ea(ea(ea(Db*Nb)+ea(ea(Rb*Bb)+ea(Qb*Pb)))-ea(U*ec));hc=ea(ea(ea(ea(Qb*Bb)-ea(Db*ec))-ea(U*Nb))-ea(Rb*Pb));Pb=ea(+h[F>>3]);Rb=ea(+h[wa>>3]);Nb=ea(+h[xa>>3]);g[gb>>2]=Pb;g[hb>>2]=Rb;g[ib>>2]=Nb;U=ea(ea(Pb-zb)*ea(2.0));zb=ea(ea(Rb-Sb)*ea(2.0));Sb=ea(ea(Nb-Ob)*ea(2.0));Ob=ea(ea(hc*hc)+ea(-.5));Nb=ea(ea(ea(fc*U)+ea(Ab*zb))+ea(gc*Sb));Rb=ea(ea(Ab*Nb)+ea(ea(Ob*zb)-ea(hc*ea(ea(gc*U)-ea(fc*Sb)))));Pb=ea(ea(ea(Ob*Sb)-ea(hc*ea(ea(fc*zb)-ea(Ab*U))))+ea(gc*Nb));g[jb>>2]=ea(ea(fc*Nb)+ea(ea(Ob*U)-ea(hc*ea(ea(Ab*Sb)-ea(gc*zb)))));g[kb>>2]=Rb;g[lb>>2]=Pb;Wb=0}if(sa){Lb=Wb;Mb=1}else{Lb=Wb;Mb=((HS(f,F,E,Cb)|0)&2|0)==0}}while(0);rb=((xb|0)==0&((Ea|Mb)^1)?8:-1)+rb|0;Hb=xb+1|0;Cb=ea(+h[F>>3]);Pb=ea(+h[wa>>3]);Rb=ea(+h[xa>>3]);zb=ea(g[Fa>>2]);gc=ea(Cb*zb);Cb=ea(g[Ga>>2]);Sb=ea(gc+ea(Pb*Cb));Pb=ea(g[Ha>>2]);g[Ia>>2]=ea(Sb+ea(Rb*Pb));Rb=ea(g[$>>2]);Sb=ea(g[aa>>2]);if(Sb>Rb){gc=ea(Sb-Rb);Rb=ea(gc*ea(g[E>>2]));Sb=ea(gc*ea(g[Z>>2]));Ab=ea(gc*ea(g[_>>2]));h[D>>3]=+Rb+ +h[D>>3];h[X>>3]=+Sb+ +h[X>>3];h[Y>>3]=+Ab+ +h[Y>>3]}Ab=ea(g[na>>2]);Sb=ea(g[pa>>2]);Rb=ea(g[ra>>2]);if(!Lb)if((c[J>>2]&2|0)!=0?(c[Ja>>2]|0)!=1:0)Ib=67;else{ic=Ab;jc=Sb;kc=Rb}else Ib=67;if((Ib|0)==67){Ib=0;gc=ea(ea(ea(Ab*zb)+ea(Sb*Cb))+ea(Rb*Pb));hc=ea(Ab-ea(zb*gc));zb=ea(Sb-ea(Cb*gc));Cb=ea(Rb-ea(Pb*gc));gc=ea(T(ea(ea(Cb*Cb)+ea(ea(hc*hc)+ea(zb*zb)))));if(gc>ea(0.0)){Pb=ea(ea(1.0)/gc);ic=ea(hc*Pb);jc=ea(zb*Pb);kc=ea(Cb*Pb)}else{ic=hc;jc=zb;kc=Cb}}Cb=ea(g[E>>2]);zb=ea(g[Z>>2]);hc=ea(g[_>>2]);Pb=ea(ea(ea(ic*Cb)+ea(jc*zb))+ea(kc*hc));gc=ea(Cb-ea(ea(ic*ea(2.0))*Pb));Cb=ea(zb-ea(ea(jc*ea(2.0))*Pb));zb=ea(hc-ea(ea(kc*ea(2.0))*Pb));Pb=ea(T(ea(ea(zb*zb)+ea(ea(gc*gc)+ea(Cb*Cb)))));if(Pb>ea(0.0)){hc=ea(ea(1.0)/Pb);lc=ea(gc*hc);mc=ea(Cb*hc);nc=ea(zb*hc)}else{lc=gc;mc=Cb;nc=zb}zb=ea(ea(kc*nc)+ea(ea(jc*mc)+ea(ic*lc)));Cb=ea(lc-ea(ic*zb));gc=ea(mc-ea(jc*zb));hc=ea(nc-ea(kc*zb));tb=+h[D>>3];oc=sb-tb;V=+h[X>>3];pc=ub-V;wb=+h[Y>>3];qc=vb-wb;rc=+T(+(oc*oc+pc*pc+qc*qc));if((c[J>>2]&64|0)!=0?(zb=ea(T(ea(ea(hc*hc)+ea(ea(Cb*Cb)+ea(gc*gc))))),zb>ea(0.0)):0){Pb=ea(ea(1.0)/zb);sc=ea(Cb*Pb);tc=ea(gc*Pb);uc=ea(hc*Pb)}else{sc=Cb;tc=gc;uc=hc}hc=ea(rc);rc=tb+ +ea(hc*sc);qc=V+ +ea(hc*tc);pc=wb+ +ea(hc*uc);if(!rb){R=Hb;S=1;break a}else{sb=rc;ub=qc;vb=pc;xb=Hb;yb=1}}if((Ib|0)==75){h[D>>3]=sb;h[X>>3]=ub;h[Y>>3]=vb;R=xb;S=1;break}hc=ea(g[$>>2]);yb=u+16|0;rb=u+20|0;_=u+24|0;Z=t+12|0;Ja=t+4|0;ra=t+8|0;pa=t+16|0;na=t+20|0;aa=t+24|0;Ia=u+12|0;Ha=u+8|0;Ga=u+4|0;Fa=w+4|0;xa=w+8|0;wa=w+12|0;Ea=w+16|0;sa=w+20|0;lb=w+24|0;kb=d+228|0;jb=z+4|0;ib=d+232|0;hb=z+8|0;gb=d+236|0;fb=z+12|0;eb=d+240|0;db=z+16|0;cb=z+20|0;bb=z+24|0;ab=k+40|0;$a=k+44|0;_a=A+4|0;Za=A+8|0;Ya=x+4|0;Xa=x+8|0;Wa=ab+4|0;Va=k+48|0;Ua=B+4|0;Ta=B+8|0;Sa=B+12|0;gc=ea(+h[Y>>3]);Cb=ea(+h[X>>3]);Pb=ea(+h[D>>3]);Ra=0;while(1){Qa=c[ga>>2]|0;Pa=c[ha>>2]|0;Oa=Qa+(Pa<<2)|0;if(!Pa){vc=Pb;wc=Cb;xc=gc;yc=1;zc=Ra}else{zb=Pb;Rb=Cb;Sb=gc;Pa=Qa;Qa=1;Na=Ra;while(1){do if((c[Pa>>2]|0)>>>0>=2?(Ma=c[Pa+8>>2]|0,(b[Ma+4>>1]|0)==6):0){La=c[Pa+4>>2]|0;In[c[(c[La>>2]|0)+32>>2]&4095](v,La);In[c[(c[Ma>>2]|0)+84>>2]&4095](t,Ma);In[c[(c[La>>2]|0)+72>>2]&4095](u,La);Ab=ea(ea(g[yb>>2])*ea(2.0));U=ea(ea(g[rb>>2])*ea(2.0));Ob=ea(ea(g[_>>2])*ea(2.0));Nb=ea(g[Z>>2]);fc=ea(ea(Nb*Nb)+ea(-.5));ec=ea(g[t>>2]);Db=ea(Ab*ec);Bb=ea(g[Ja>>2]);Qb=ea(Db+ea(U*Bb));Db=ea(g[ra>>2]);Ac=ea(Qb+ea(Ob*Db));Qb=ea(ea(ec*Ac)+ea(ea(Ab*fc)+ea(Nb*ea(ea(Ob*Bb)-ea(U*Db)))));Bc=ea(ea(Bb*Ac)+ea(ea(U*fc)+ea(Nb*ea(ea(Ab*Db)-ea(Ob*ec)))));Cc=ea(ea(ea(Ob*fc)+ea(Nb*ea(ea(U*ec)-ea(Ab*Bb))))+ea(Db*Ac));Ac=ea(ea(g[pa>>2])+Qb);Qb=ea(ea(g[na>>2])+Bc);Bc=ea(ea(g[aa>>2])+Cc);Cc=ea(g[u>>2]);Ab=ea(Nb*Cc);U=ea(g[Ia>>2]);fc=ea(Ab+ea(ec*U));Ab=ea(g[Ha>>2]);Ob=ea(fc+ea(Bb*Ab));fc=ea(g[Ga>>2]);Dc=ea(ea(ea(Db*Cc)+ea(ea(Bb*U)+ea(Nb*fc)))-ea(ec*Ab));Ec=ea(ea(ea(ec*fc)+ea(ea(Db*U)+ea(Nb*Ab)))-ea(Bb*Cc));Fc=ea(ea(ea(ea(Nb*U)-ea(ec*Cc))-ea(Bb*fc))-ea(Db*Ab));g[w>>2]=ea(Ob-ea(Db*fc));g[Fa>>2]=Dc;g[xa>>2]=Ec;g[wa>>2]=Fc;g[Ea>>2]=Ac;g[sa>>2]=Qb;g[lb>>2]=Bc;g[z>>2]=ea(g[kb>>2]);g[jb>>2]=ea(g[ib>>2]);g[hb>>2]=ea(g[gb>>2]);g[fb>>2]=ea(g[eb>>2]);g[db>>2]=zb;g[cb>>2]=Rb;g[bb>>2]=Sb;Bc=ea(hc+ea(g[ab>>2]));if((c[ia>>2]|0)==1){Qb=ea(ea(g[$a>>2])*ea(.5));c[A>>2]=2;g[_a>>2]=Bc;g[Za>>2]=Qb;if(!(BLa(x,y,A,z,v,w)|0)){Gc=Sb;Hc=Rb;Ic=zb;Jc=0;Kc=Na;break}}else{Qb=ea(hc+ea(g[Wa>>2]));Ac=ea(hc+ea(g[Va>>2]));c[B>>2]=3;g[Ua>>2]=Bc;g[Ta>>2]=Qb;g[Sa>>2]=Ac;if(!(BLa(x,y,B,z,v,w)|0)){Gc=Sb;Hc=Rb;Ic=zb;Jc=0;Kc=Na;break}}Ac=ea(g[y>>2]);Qb=ea(Ac*ea(g[x>>2]));Bc=ea(Ac*ea(g[Ya>>2]));Gc=ea(Sb+ea(Ac*ea(g[Xa>>2])));Hc=ea(Rb+Bc);Ic=ea(zb+Qb);Jc=1;Kc=Na+1|0}else{Gc=Sb;Hc=Rb;Ic=zb;Jc=Qa;Kc=Na}while(0);Pa=Pa+(c[420160+(c[Pa>>2]<<2)>>2]|0)|0;if((Pa|0)==(Oa|0)){vc=Ic;wc=Hc;xc=Gc;yc=Jc;zc=Kc;break}else{zb=Ic;Rb=Hc;Sb=Gc;Qa=Jc;Na=Kc}}}if(yc&zc>>>0<4){gc=xc;Cb=wc;Pb=vc;Ra=zc}else break}if(o)c[o>>2]=xb;h[N>>3]=+vc;h[O>>3]=+wc;h[P>>3]=+xc;I=1;i=s;return I|0}while(0);if(o)c[o>>2]=R;c[N+0>>2]=c[D+0>>2];c[N+4>>2]=c[D+4>>2];c[N+8>>2]=c[D+8>>2];c[N+12>>2]=c[D+12>>2];c[N+16>>2]=c[D+16>>2];c[N+20>>2]=c[D+20>>2];I=S;i=s;return I|0}function zS(b,d,e,f,j,k,l,m,n,o,p){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=Im,N=Im,O=0,P=Im,Q=0,R=0.0,U=0.0,V=0,W=Im,X=Im,Y=0,Z=Im,_=Im,$=0,aa=0,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0.0,za=0.0;q=i;i=i+144|0;r=q+84|0;s=q+96|0;t=q+108|0;u=q+24|0;v=q+132|0;w=q+72|0;x=q;y=q+120|0;z=d+308|0;A=c[z>>2]|0;B=A&-2;c[z>>2]=B;a[b>>0]=0;if(!(A&2))C=1;else C=(c[d+224>>2]|0)==1?10:1;D=d+264|0;E=ea(g[D>>2]);F=j+8|0;G=ea(+h[F>>3]);H=j+16|0;I=ea(+h[H>>3]);J=j+24|0;K=ea(+h[J>>3]);L=d+244|0;M=ea(g[L>>2]);N=ea(G*M);O=d+248|0;G=ea(g[O>>2]);P=ea(N+ea(I*G));Q=d+252|0;I=ea(g[Q>>2]);N=ea(P+ea(K*I));R=+N;U=R-+ea(g[j+32>>2]);K=ea(g[k>>2]);P=ea(M*K);V=k+4|0;W=ea(g[V>>2]);X=ea(P+ea(G*W));Y=k+8|0;P=ea(g[Y>>2]);Z=ea(X+ea(I*P));if(Z>ea(0.0)){c[z>>2]=B|256;_=p?E:ea(0.0)}else{c[z>>2]=A&-258;_=E}g[r>>2]=ea(0.0);A=r+4|0;g[A>>2]=ea(0.0);B=r+8|0;g[B>>2]=ea(0.0);g[s>>2]=ea(0.0);$=s+4|0;g[$>>2]=ea(0.0);aa=s+8|0;g[aa>>2]=ea(0.0);E=ea(M*Z);X=ea(G*Z);ba=ea(I*Z);ca=ea(K-E);K=ea(W-X);W=ea(P-ba);da=Z<=ea(0.0);if(da){g[s>>2]=E;g[$>>2]=X;g[aa>>2]=ba;fa=E;ga=X;ha=ba;ia=ea(0.0);ja=ea(0.0);ka=ea(0.0)}else{g[r>>2]=E;g[A>>2]=X;g[B>>2]=ba;fa=ea(0.0);ga=ea(0.0);ha=ea(0.0);ia=E;ja=X;ka=ba}g[t>>2]=ca;la=t+4|0;g[la>>2]=K;ma=t+8|0;g[ma>>2]=W;if(((!p?!(+ea(S(ea(ca)))>1.0e-06):0)?!(+ea(S(ea(K)))>1.0e-06):0)?!(+ea(S(ea(W)))>1.0e-06):0)na=1;else{W=ea(_*G);G=ea(_*I);g[r>>2]=ea(ea(_*M)+ia);g[A>>2]=ea(W+ja);g[B>>2]=ea(G+ka);na=0}En[c[(c[j>>2]|0)+8>>2]&127](j,d,u,F,k);xS(d,e,l,u,n,t);u=d+96|0;c[u>>2]=0;c[v>>2]=0;if((((a[d+284>>0]|0)==0?!(+ea(S(ea(g[t>>2])))>1.0e-06):0)?!(+ea(S(ea(g[la>>2])))>1.0e-06):0)?!(+ea(S(ea(g[ma>>2])))>1.0e-06):0)oa=10;else oa=1;if((c[z>>2]&2|0)==0?(B=yS(d,e,f,l,j,r,t,oa,v,m,n,0)|0,B&(c[v>>2]|0)!=0):0){a[b>>0]=2;ka=ea(+h[F>>3]);G=ea(+h[H>>3]);ja=ea(+h[J>>3]);W=ea(ka*ea(g[L>>2]));ka=ea(W+ea(G*ea(g[O>>2])));pa=+ea(ka+ea(ja*ea(g[Q>>2])))-R;if(pa<+_){qa=2;ra=ea(pa)}else{qa=2;ra=_}}else{qa=0;ra=_}c[u>>2]=1;c[z>>2]=c[z>>2]&-9;c[v>>2]=0;B=yS(d,e,f,l,j,t,t,10,v,m,n,1)|0;if(B&(c[v>>2]|0)!=0){B=(qa&255|1)&255;a[b>>0]=B;sa=B}else sa=qa;if(((o?(c[j+36>>2]|0)==1:0)?(qa=c[z>>2]|0,(qa&8|0)==0):0)?(_=ea(g[j+40>>2]),ja=ea(g[t>>2]),ka=ea(ja*ja),G=ea(g[la>>2]),W=ea(ka+ea(G*G)),ka=ea(g[ma>>2]),ia=ea(W+ea(ka*ka)),W=ea(T(ea(ia))),W<_):0){if(ia>ea(0.0)){ia=ea(ea(1.0)/W);ta=ea(ja*ia);ua=ea(G*ia);va=ea(ka*ia)}else{ta=ea(0.0);ua=ea(0.0);va=ea(0.0)}ia=ea(_*ua);ua=ea(_*va);g[w>>2]=ea(_*ta);g[w+4>>2]=ia;g[w+8>>2]=ua;c[z>>2]=qa&-9;c[v>>2]=0;c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[x+16>>2]=c[F+16>>2];c[x+20>>2]=c[F+20>>2];yS(d,e,f,l,j,w,t,1,v,m,n,3)|0;c[F+0>>2]=c[x+0>>2];c[F+4>>2]=c[x+4>>2];c[F+8>>2]=c[x+8>>2];c[F+12>>2]=c[x+12>>2];c[F+16>>2]=c[x+16>>2];c[F+20>>2]=c[x+20>>2]}c[u>>2]=2;c[v>>2]=0;if(!na){ua=ea(ra*ea(g[L>>2]));ia=ea(ra*ea(g[O>>2]));ta=ea(ra*ea(g[Q>>2]));g[s>>2]=ea(fa-ua);g[$>>2]=ea(ga-ia);g[aa>>2]=ea(ha-ta)}c[z>>2]=c[z>>2]&-5;c[d+156>>2]=0;c[d+160>>2]=0;c[d+152>>2]=-1;aa=yS(d,e,f,l,j,s,t,C,v,m,n,2)|0;if(aa&(c[v>>2]|0)!=0){if(da)a[b>>0]=sa&255|4;sa=a[d+281>>0]|0;if(!(sa<<24>>24)){i=q;return}b=c[z>>2]|0;if((((b&56|0)==8?(ta=ea(g[d+132>>2]),ha=ea(ta*ea(g[L>>2])),ta=ea(g[d+136>>2]),ia=ea(ha+ea(ta*ea(g[O>>2]))),ta=ea(g[d+140>>2]),ha=ea(ia+ea(ta*ea(g[Q>>2]))),ha>=ea(0.0)):0)?!(!(ha<ea(g[d+256>>2]))|o^1):0)?+ea(g[d+292>>2])>U+ +ra:0){c[z>>2]=b|1;if(!(b&2)){i=q;return}else{wa=sa;xa=44}}}else{wa=a[d+281>>0]|0;xa=44}if((xa|0)==44?wa<<24>>24==0:0){i=q;return}wa=c[z>>2]|0;if((wa&52|0)!=4|da^1){i=q;return}ra=ea(+ea(g[d+148>>2])-U);if(!(ra>ea(g[D>>2]))){i=q;return}ra=ea(g[d+128>>2]);ha=ea(g[d+124>>2]);ta=ea(g[d+120>>2]);ia=ea(g[d+256>>2]);ga=ea(g[L>>2]);ua=ea(ta*ga);ta=ea(g[O>>2]);fa=ea(ua+ea(ha*ta));ha=ea(g[Q>>2]);ua=ea(fa+ea(ra*ha));if(!(ua>=ea(0.0)&ua<ia)){i=q;return}c[z>>2]=wa|1;if(!(wa&2)){i=q;return}c[z>>2]=wa|65;ia=ea(+h[F>>3]);ua=ea(+h[H>>3]);ra=ea(ea(ea(ia*ga)+ea(ua*ta))+ea(ea(+h[J>>3])*ha));if(ra>N)ya=+ra-R;else ya=0.0;ra=ea(ea(g[k>>2])*ga);N=ea(ra+ea(ea(g[V>>2])*ta));R=ya+ +ea(S(ea(N+ea(ea(g[Y>>2])*ha))));c[v>>2]=0;ya=+m;if(R<ya)za=R/10.0;else za=ya;m=ea(R);N=ea(-ea(m*ta));ta=ea(-ea(m*ha));g[y>>2]=ea(-ea(m*ga));g[y+4>>2]=N;g[y+8>>2]=ta;yS(d,e,f,l,j,y,t,10,v,ea(za),n,0)|0;c[z>>2]=c[z>>2]&-65;i=q;return}function AS(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im;k=i;i=i+272|0;l=k;m=k+184|0;n=k+64|0;o=k+80|0;p=k+240|0;q=k+256|0;r=k+100|0;s=k+224|0;t=k+268|0;u=k+236|0;v=k+212|0;w=b[e+8>>1]|0;if(!(w&2)){i=k;return}c[n>>2]=420216;c[n+4>>2]=(c[d+464>>2]|0)+76;c[n+8>>2]=c[e+4>>2];b[n+12>>1]=w;x=c[e>>2]|0;if(!x){c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0}else{c[p+0>>2]=c[x+0>>2];c[p+4>>2]=c[x+4>>2];c[p+8>>2]=c[x+8>>2];c[p+12>>2]=c[x+12>>2]};c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];b[o+16>>1]=w&8|6;a[o+18>>0]=0;y=ea(Kn[c[(c[d>>2]|0)+12>>2]&255](d));z=ea(+h[d+408>>3]);A=ea(+h[d+416>>3]);B=ea(+h[d+424>>3]);g[q>>2]=z;g[q+4>>2]=A;g[q+8>>2]=B;c[r+4>>2]=0;w=r+8|0;c[w>>2]=0;c[r+12>>2]=-1;p=r+16|0;b[p>>1]=0;x=r+20|0;e=r+44|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[x+16>>2]=0;c[x+20>>2]=0;C=r+48|0;g[C>>2]=ea(0.0);g[r+52>>2]=ea(0.0);a[r+68>>0]=0;D=r+72|0;c[D>>2]=0;c[r+76>>2]=0;E=r+80|0;c[E>>2]=0;c[r>>2]=420192;F=r+4|0;g[e>>2]=ea(3402823469999999843913219.0e14);G=d+456|0;H=c[G>>2]|0;I=c[(c[H>>2]|0)+348>>2]|0;B=ea(-ea(g[j>>2]));J=j+4|0;A=ea(-ea(g[J>>2]));K=j+8|0;z=ea(-ea(g[K>>2]));g[s>>2]=B;g[s+4>>2]=A;g[s+8>>2]=z;z=ea(y+ea(0.0));b[t>>1]=4;if(Fo[I&1](H,q,s,z,r,t,o,n,0)|0){n=(c[E>>2]|0)!=0?c[D>>2]|0:F;c[F+0>>2]=c[n+0>>2];c[F+4>>2]=c[n+4>>2];c[F+8>>2]=c[n+8>>2];b[p>>1]=b[n+12>>1]|0;g[x>>2]=ea(g[n+16>>2]);g[r+24>>2]=ea(g[n+20>>2]);g[r+28>>2]=ea(g[n+24>>2]);g[r+32>>2]=ea(g[n+28>>2]);g[r+36>>2]=ea(g[n+32>>2]);g[r+40>>2]=ea(g[n+36>>2]);g[e>>2]=ea(g[n+40>>2]);r=n+44|0;c[C+0>>2]=c[r+0>>2];c[C+4>>2]=c[r+4>>2];c[C+8>>2]=c[r+8>>2];c[C+12>>2]=c[r+12>>2];c[C+16>>2]=c[r+16>>2];r=c[w>>2]|0;c[d+244>>2]=r;w=c[F>>2]|0;c[d+248>>2]=w;In[c[(c[w>>2]|0)+84>>2]&4095](l,w);In[c[(c[r>>2]|0)+72>>2]&4095](m,r);A=ea(ea(g[m+16>>2])*ea(2.0));B=ea(ea(g[m+20>>2])*ea(2.0));L=ea(ea(g[m+24>>2])*ea(2.0));M=ea(g[l+12>>2]);N=ea(ea(M*M)+ea(-.5));O=ea(g[l>>2]);P=ea(A*O);Q=ea(g[l+4>>2]);R=ea(P+ea(B*Q));P=ea(g[l+8>>2]);S=ea(R+ea(L*P));R=ea(ea(O*S)+ea(ea(A*N)+ea(M*ea(ea(L*Q)-ea(B*P)))));T=ea(ea(Q*S)+ea(ea(B*N)+ea(M*ea(ea(A*P)-ea(L*O)))));U=ea(ea(ea(L*N)+ea(M*ea(ea(B*O)-ea(A*Q))))+ea(P*S));S=ea(ea(g[l+16>>2])+R);R=ea(ea(g[l+20>>2])+T);T=ea(ea(g[l+24>>2])+U);U=ea(g[m>>2]);A=ea(M*U);B=ea(g[m+12>>2]);N=ea(A+ea(O*B));A=ea(g[m+8>>2]);L=ea(N+ea(Q*A));N=ea(g[m+4>>2]);V=ea(L-ea(P*N));L=ea(ea(ea(P*U)+ea(ea(Q*B)+ea(M*N)))-ea(O*A));W=ea(ea(ea(O*N)+ea(ea(P*B)+ea(M*A)))-ea(Q*U));X=ea(ea(ea(ea(M*B)-ea(O*U))-ea(Q*N))-ea(P*A));A=ea(y-ea(g[e>>2]));P=ea(ea(g[j>>2])*A);N=ea(A*ea(g[J>>2]));Q=ea(ea(0.0)-N);N=ea(ea(0.0)-ea(A*ea(g[K>>2])));g[d+276>>2]=ea(ea(0.0)-P);g[d+280>>2]=Q;g[d+284>>2]=N;N=ea(ea(ea(0.0)-S)*ea(2.0));S=ea(ea(ea(0.0)-R)*ea(2.0));R=ea(ea(ea(0.0)-T)*ea(2.0));T=ea(ea(X*X)+ea(-.5));Q=ea(ea(R*W)+ea(ea(N*V)+ea(S*L)));P=ea(ea(ea(S*T)-ea(X*ea(ea(N*W)-ea(R*V))))+ea(L*Q));A=ea(ea(ea(R*T)-ea(X*ea(ea(S*V)-ea(N*L))))+ea(W*Q));g[d+264>>2]=ea(ea(V*Q)+ea(ea(N*T)-ea(X*ea(ea(R*L)-ea(S*W)))));g[d+268>>2]=P;g[d+272>>2]=A;m=c[G>>2]|0;c[d+460>>2]=(mo[c[(c[m>>2]|0)+32>>2]&4095](m)|0)+-1}if(!f){i=k;return}c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=-1;b[l+12>>1]=0;m=l+16|0;G=l+40|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;g[G>>2]=ea(3402823469999999843913219.0e14);g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);A=ea(-ea(g[j>>2]));P=ea(-ea(g[J>>2]));W=ea(-ea(g[K>>2]));g[v>>2]=A;g[v+4>>2]=P;g[v+8>>2]=W;m=GT(f,l,q,v,z,u)|0;if(!m){i=k;return}z=ea(g[G>>2]);if(!(z<ea(g[e>>2]))){i=k;return}c[d+240>>2]=c[u>>2];W=ea(y-z);z=ea(ea(g[j>>2])*W);y=ea(W*ea(g[J>>2]));P=ea(ea(0.0)-y);y=ea(ea(0.0)-ea(W*ea(g[K>>2])));g[d+300>>2]=ea(ea(0.0)-z);g[d+304>>2]=P;g[d+308>>2]=y;y=ea(+h[m+8>>3]);P=ea(+h[m+16>>3]);z=ea(+h[m+24>>3]);W=ea(g[m+32>>2]);A=ea(g[m+36>>2]);S=ea(g[m+40>>2]);L=ea(g[m+44>>2]);R=ea(ea(ea(0.0)-y)*ea(2.0));y=ea(ea(ea(0.0)-P)*ea(2.0));P=ea(ea(ea(0.0)-z)*ea(2.0));z=ea(ea(L*L)+ea(-.5));X=ea(ea(ea(R*W)+ea(y*A))+ea(P*S));T=ea(ea(A*X)+ea(ea(y*z)-ea(L*ea(ea(R*S)-ea(W*P)))));N=ea(ea(S*X)+ea(ea(P*z)-ea(L*ea(ea(W*y)-ea(R*A)))));g[d+288>>2]=ea(ea(W*X)+ea(ea(R*z)-ea(L*ea(ea(A*P)-ea(y*S)))));g[d+292>>2]=T;g[d+296>>2]=N;i=k;return}function BS(e,f,j,k,l){e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=0,U=Im,V=Im,W=Im,X=0,Y=Im,Z=0,_=0,$=0;m=i;i=i+64|0;n=m+28|0;o=m;p=m+57|0;q=m+56|0;r=e+244|0;if(c[r>>2]|0){s=e+248|0;t=c[s>>2]|0;if((b[t+4>>1]|0)!=6){u=c[e+456>>2]|0;v=mo[c[(c[u>>2]|0)+32>>2]&4095](u)|0;u=e+460|0;if((v|0)==(c[u>>2]|0))w=21;else{c[u>>2]=v;x=ea(g[e+468>>2]);v=e+472|0;y=ea(x-ea(g[v>>2]));g[v>>2]=x;v=c[e+76>>2]|0;if(!v)z=0;else{Dn[c[c[v>>2]>>2]&511](p,v,c[r>>2]|0,c[s>>2]|0);z=d[p>>0]|0}p=c[r>>2]|0;In[c[(c[t>>2]|0)+84>>2]&4095](n,t);In[c[(c[p>>2]|0)+72>>2]&4095](o,p);x=ea(ea(g[o+16>>2])*ea(2.0));A=ea(ea(g[o+20>>2])*ea(2.0));B=ea(ea(g[o+24>>2])*ea(2.0));C=ea(g[n+12>>2]);D=ea(ea(C*C)+ea(-.5));E=ea(g[n>>2]);F=ea(x*E);G=ea(g[n+4>>2]);H=ea(F+ea(A*G));F=ea(g[n+8>>2]);I=ea(H+ea(B*F));H=ea(ea(E*I)+ea(ea(x*D)+ea(C*ea(ea(B*G)-ea(A*F)))));J=ea(ea(G*I)+ea(ea(A*D)+ea(C*ea(ea(x*F)-ea(B*E)))));K=ea(ea(ea(B*D)+ea(C*ea(ea(A*E)-ea(x*G))))+ea(F*I));I=ea(ea(g[n+16>>2])+H);H=ea(ea(g[n+20>>2])+J);J=ea(ea(g[n+24>>2])+K);K=ea(g[o>>2]);x=ea(C*K);A=ea(g[o+12>>2]);D=ea(x+ea(E*A));x=ea(g[o+8>>2]);B=ea(D+ea(G*x));D=ea(g[o+4>>2]);L=ea(B-ea(F*D));B=ea(ea(ea(F*K)+ea(ea(G*A)+ea(C*D)))-ea(E*x));M=ea(ea(ea(E*D)+ea(ea(F*A)+ea(C*x)))-ea(G*K));N=ea(ea(ea(ea(C*A)-ea(E*K))-ea(G*D))-ea(F*x));x=ea(g[e+276>>2]);F=ea(g[e+280>>2]);D=ea(g[e+284>>2]);G=ea(ea(g[e+264>>2])*ea(2.0));K=ea(ea(g[e+268>>2])*ea(2.0));E=ea(ea(g[e+272>>2])*ea(2.0));A=ea(ea(N*N)+ea(-.5));C=ea(ea(ea(L*G)+ea(B*K))+ea(M*E));O=y;P=ea(ea(I+ea(ea(L*C)+ea(ea(A*G)+ea(N*ea(ea(B*E)-ea(M*K))))))-x);Q=ea(ea(H+ea(ea(B*C)+ea(ea(A*K)+ea(N*ea(ea(M*G)-ea(L*E))))))-F);R=ea(ea(J+ea(ea(ea(A*E)+ea(N*ea(ea(L*K)-ea(B*G))))+ea(M*C)))-D);T=z;w=10}}else{U=ea(0.0);V=ea(0.0);W=ea(0.0);X=0;Y=ea(1.0)}}else{D=ea(g[e+468>>2]);z=e+472|0;C=ea(D-ea(g[z>>2]));g[z>>2]=D;z=_n[c[(c[l>>2]|0)+36>>2]&4095](l,c[e+240>>2]|0)|0;l=c[e+76>>2]|0;if(!l)Z=1;else{co[c[(c[l>>2]|0)+8>>2]&2047](q,l,z);Z=d[q>>0]|0}D=ea(g[e+300>>2]);M=ea(g[e+304>>2]);G=ea(g[e+308>>2]);B=ea(g[e+288>>2]);K=ea(g[e+292>>2]);L=ea(g[e+296>>2]);N=ea(+h[z+8>>3]);E=ea(+h[z+16>>3]);A=ea(+h[z+24>>3]);J=ea(g[z+32>>2]);F=ea(g[z+36>>2]);H=ea(g[z+40>>2]);x=ea(g[z+44>>2]);I=ea(B*ea(2.0));B=ea(K*ea(2.0));K=ea(L*ea(2.0));L=ea(ea(x*x)+ea(-.5));y=ea(ea(ea(I*J)+ea(B*F))+ea(K*H));O=C;P=ea(ea(N+ea(ea(J*y)+ea(ea(x*ea(ea(K*F)-ea(B*H)))+ea(I*L))))-D);Q=ea(ea(E+ea(ea(F*y)+ea(ea(x*ea(ea(I*H)-ea(K*J)))+ea(B*L))))-M);R=ea(ea(A+ea(ea(H*y)+ea(ea(x*ea(ea(B*J)-ea(I*F)))+ea(K*L))))-G);T=Z;w=10}if((w|0)==10){G=ea(ea(1.0)/O);if(!(T&4)){U=P;V=Q;W=R;X=T;Y=G}else w=21}if((w|0)==21){_=(a[e+485>>0]|0)!=0;i=m;return _|0}if((!(+ea(S(ea(U)))>1.0e-06)?!(+ea(S(ea(V)))>1.0e-06):0)?!(+ea(S(ea(W)))>1.0e-06):0){a[e+485>>0]=0;$=0}else{a[e+485>>0]=1;G=ea(g[j>>2]);R=ea(U*G);Q=ea(g[j+4>>2]);P=ea(R+ea(V*Q));R=ea(g[j+8>>2]);O=ea(P+ea(W*R));P=ea(G*O);G=ea(Q*O);Q=ea(R*O);R=ea(U-P);L=ea(V-G);K=ea(W-Q);if(O>ea(0.0)){j=f+8|0;h[j>>3]=+P+ +h[j>>3];j=f+16|0;h[j>>3]=+G+ +h[j>>3];j=f+24|0;h[j>>3]=+Q+ +h[j>>3]}else{g[k>>2]=ea(P+ea(g[k>>2]));j=k+4|0;g[j>>2]=ea(G+ea(g[j>>2]));j=k+8|0;g[j>>2]=ea(Q+ea(g[j>>2]))}if(!(X&1))$=1;else{g[k>>2]=ea(R+ea(g[k>>2]));X=k+4|0;g[X>>2]=ea(L+ea(g[X>>2]));X=k+8|0;g[X>>2]=ea(K+ea(g[X>>2]));$=1}}K=ea(V*Y);V=ea(W*Y);g[e+432>>2]=ea(U*Y);g[e+436>>2]=K;g[e+440>>2]=V;_=$;i=m;return _|0}function CS(d,e,f,j,k,l,m,n,o){d=d|0;e=e|0;f=f|0;j=j|0;k=ea(k);l=ea(l);m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=0,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=0,Ya=Im,Za=0,_a=Im,$a=0,ab=0,bb=0,cb=0,db=0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0,lb=0,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=0,tb=0,ub=0,vb=0;p=i;i=i+560|0;q=p+328|0;r=p+240|0;s=p+544|0;t=p+256|0;u=p+208|0;v=p+547|0;w=p;x=p+368|0;y=p+112|0;z=p+436|0;A=p+56|0;B=p+296|0;C=p+440|0;D=p+268|0;E=p+168|0;F=p+372|0;G=p+376|0;H=p+304|0;I=p+352|0;J=p+424|0;K=p+548|0;L=p+196|0;M=p+546|0;N=p+212|0;O=e+468|0;g[O>>2]=ea(ea(g[O>>2])+l);O=e+464|0;P=c[O>>2]|0;Q=c[P+8>>2]|0;R=c[P+12>>2]|0;S=e+88|0;c[S>>2]=Q;c[e+92>>2]=R;T=e+8|0;c[e+312>>2]=c[T>>2];U=e+12|0;g[e+316>>2]=ea(g[U>>2]);V=e+16|0;g[e+320>>2]=ea(g[V>>2]);W=e+20|0;g[e+324>>2]=ea(g[W>>2]);X=e+24|0;g[e+328>>2]=ea(g[X>>2]);g[e+332>>2]=ea(g[e+28>>2]);Y=e+32|0;g[e+336>>2]=ea(g[Y>>2]);Z=e+36|0;g[e+340>>2]=ea(g[Z>>2]);_=e+344|0;$=e+40|0;c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];c[_+16>>2]=c[$+16>>2];c[_+20>>2]=c[$+20>>2];c[_+24>>2]=c[$+24>>2];a[_+28>>0]=a[$+28>>0]|0;$=e+396|0;c[$>>2]=c[$>>2]|128;l=ea(g[P+128>>2]);g[e+364>>2]=ea(l*l);a[e+368>>0]=a[P+132>>0]|0;a[e+370>>0]=a[P+133>>0]|0;a[e+371>>0]=a[P+134>>0]|0;a[e+372>>0]=a[P+135>>0]|0;P=e+388|0;_=P;b[_>>1]=0;b[_+2>>1]=0>>>16;_=P+4|0;b[_>>1]=0;b[_+2>>1]=0>>>16;_=e+28|0;l=ea(g[j>>2]);P=e+444|0;aa=ea(l+ea(g[P>>2]));l=ea(g[j+4>>2]);ba=e+448|0;ca=ea(l+ea(g[ba>>2]));l=ea(g[j+8>>2]);j=e+452|0;da=ea(l+ea(g[j>>2]));g[t>>2]=aa;fa=t+4|0;g[fa>>2]=ca;ga=t+8|0;g[ga>>2]=da;g[P>>2]=ea(0.0);g[ba>>2]=ea(0.0);g[j>>2]=ea(0.0);j=e+248|0;ba=c[j>>2]|0;P=e+244|0;a:do if((ba|0)!=0?(c[P>>2]|0)!=0:0){ha=mo[c[(c[ba>>2]|0)+104>>2]&4095](ba)|0;b:do if(ha){ia=0;while(1){c[u>>2]=0;ja=c[j>>2]|0;kn[c[(c[ja>>2]|0)+108>>2]&511](ja,u,1,ia)|0;ia=ia+1|0;if((c[u>>2]|0)==(c[P>>2]|0))break;if(ia>>>0>=ha>>>0)break b}ia=c[j>>2]|0;ja=mo[c[(c[ia>>2]|0)+28>>2]&4095](ia)|0;if((ja|0)!=(c[e+456>>2]|0)){c[P>>2]=0;c[j>>2]=0;break a}ja=c[P>>2]|0;In[c[(c[ja>>2]|0)+136>>2]&4095](v,ja);if(!(a[v>>0]&2)){c[P>>2]=0;c[j>>2]=0;break a}ja=c[m>>2]|0;if(!ja){c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0}else{c[r+0>>2]=c[ja+0>>2];c[r+4>>2]=c[ja+4>>2];c[r+8>>2]=c[ja+8>>2];c[r+12>>2]=c[ja+12>>2]};c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];b[q+16>>1]=6;a[q+18>>0]=0;b[s>>1]=4;ja=c[m+4>>2]|0;if(!ja)break a;if(Bn[c[c[ja>>2]>>2]&255](ja,q,c[P>>2]|0,c[j>>2]|0,s)|0)break a;c[P>>2]=0;c[j>>2]=0;break a}while(0);c[j>>2]=0;c[P>>2]=0}while(0);if((((c[P>>2]|0)==0?(j=e+240|0,(c[j>>2]|0)==-1):0)?(AS(e,m,n,_),(c[P>>2]|0)==0):0)?(c[j>>2]|0)==-1:0){a[e+485>>0]=0;g[e+432>>2]=ea(0.0);g[e+436>>2]=ea(0.0);g[e+440>>2]=ea(0.0);ka=0}else ka=BS(e,f,_,t,n)|0;j=c[O>>2]|0;P=j+16|0;s=j+28|0;q=j+40|0;r=j+52|0;v=mo[c[(c[j>>2]|0)+8>>2]&4095](j)|0;u=RS(c[O>>2]|0)|0;if(v){ba=m+12|0;ha=j+36|0;ja=j+32|0;ia=w+24|0;la=w+28|0;ma=w+32|0;na=w+36|0;oa=w+40|0;pa=w+44|0;qa=w+48|0;ra=j+24|0;sa=j+20|0;ta=j+60|0;ua=j+56|0;va=j+48|0;wa=j+44|0;xa=0;do{ya=c[u+(xa<<2)>>2]|0;do if((ya|0)!=(e|0)){za=c[ba>>2]|0;if((za|0)!=0?(Aa=c[(c[za>>2]|0)+8>>2]|0,Ba=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0,Ca=mo[c[(c[ya>>2]|0)+20>>2]&4095](ya)|0,!(xo[Aa&2047](za,Ba,Ca)|0)):0)break;Ca=c[ya+4>>2]|0;if((Ca|0)==1){if(!ya)Da=0;else Da=ya+-8|0;lS(Da,y);Ba=c[ua>>2]|0;if((c[ta>>2]&2147483647)>>>0>Ba>>>0){za=(c[r>>2]|0)+(Ba*56|0)|0;if(!za)Ea=Ba;else{Fa=za+0|0;Ga=y+0|0;Ha=Fa+56|0;do{c[Fa>>2]=c[Ga>>2];Fa=Fa+4|0;Ga=Ga+4|0}while((Fa|0)<(Ha|0));Ea=c[ua>>2]|0}c[ua>>2]=Ea+1}else $Ta(r,y)|0;za=xa<<16;c[z>>2]=za;Ba=c[wa>>2]|0;if((c[va>>2]&2147483647)>>>0<=Ba>>>0){_Ta(q,z)|0;break}Aa=(c[q>>2]|0)+(Ba<<2)|0;if(Aa)c[Aa>>2]=za;c[wa>>2]=Ba+1;break}else if(!Ca){if(!ya)Ia=0;else Ia=ya+-8|0;XR(Ia,w);Ba=c[ja>>2]|0;if((c[ha>>2]&2147483647)>>>0>Ba>>>0){za=c[s>>2]|0;Aa=za+(Ba*56|0)|0;if(!Aa)Ja=Ba;else{c[Aa+0>>2]=c[w+0>>2];c[Aa+4>>2]=c[w+4>>2];c[Aa+8>>2]=c[w+8>>2];c[Aa+12>>2]=c[w+12>>2];c[Aa+16>>2]=c[w+16>>2];c[Aa+20>>2]=c[w+20>>2];g[za+(Ba*56|0)+24>>2]=ea(g[ia>>2]);g[za+(Ba*56|0)+28>>2]=ea(g[la>>2]);g[za+(Ba*56|0)+32>>2]=ea(g[ma>>2]);c[Aa+0>>2]=c[w+0>>2];c[Aa+4>>2]=c[w+4>>2];c[Aa+8>>2]=c[w+8>>2];c[Aa+12>>2]=c[w+12>>2];c[Aa+16>>2]=c[w+16>>2];c[Aa+20>>2]=c[w+20>>2];g[za+(Ba*56|0)+36>>2]=ea(g[na>>2]);g[za+(Ba*56|0)+40>>2]=ea(g[oa>>2]);g[za+(Ba*56|0)+44>>2]=ea(g[pa>>2]);g[za+(Ba*56|0)+48>>2]=ea(g[qa>>2]);c[Aa+0>>2]=c[w+0>>2];c[Aa+4>>2]=c[w+4>>2];c[Aa+8>>2]=c[w+8>>2];c[Aa+12>>2]=c[w+12>>2];c[Aa+16>>2]=c[w+16>>2];c[Aa+20>>2]=c[w+20>>2];Ja=c[ja>>2]|0}c[ja>>2]=Ja+1}else ZTa(s,w)|0;Aa=xa<<16;c[x>>2]=Aa;Ba=c[sa>>2]|0;if((c[ra>>2]&2147483647)>>>0<=Ba>>>0){_Ta(P,x)|0;break}za=(c[P>>2]|0)+(Ba<<2)|0;if(za)c[za>>2]=Aa;c[sa>>2]=Ba+1;break}else break}while(0);xa=xa+1|0}while((xa|0)!=(v|0))}if(n){v=c[n+8>>2]|0;if(v){xa=n+4|0;sa=A+24|0;x=A+28|0;ra=A+32|0;w=A+36|0;Ja=A+40|0;ja=A+44|0;qa=A+48|0;pa=j+36|0;oa=j+32|0;na=j+24|0;ma=j+20|0;la=(Q|0)==0;ia=(R&4|0)==0;ha=C+36|0;Ia=C+40|0;wa=C+56|0;z=C+60|0;va=C+76|0;y=C+80|0;Ea=C+96|0;ua=C+100|0;ta=D+4|0;Da=D+8|0;ba=D+12|0;u=D+16|0;ya=D+20|0;Ba=D+24|0;Aa=E+4|0;za=E+8|0;Ka=E+12|0;La=E+16|0;Ma=E+20|0;Na=E+24|0;Oa=0;do{Pa=c[xa>>2]|0;Qa=Pa+(Oa*72|0)+16|0;c[A+0>>2]=c[Qa+0>>2];c[A+4>>2]=c[Qa+4>>2];c[A+8>>2]=c[Qa+8>>2];c[A+12>>2]=c[Qa+12>>2];c[A+16>>2]=c[Qa+16>>2];c[A+20>>2]=c[Qa+20>>2];Ra=Pa+(Oa*72|0)+56|0;da=ea(g[Ra>>2]);g[sa>>2]=da;Sa=Pa+(Oa*72|0)+60|0;ca=ea(g[Sa>>2]);g[x>>2]=ca;Ta=Pa+(Oa*72|0)+64|0;aa=ea(g[Ta>>2]);g[ra>>2]=aa;Ua=Pa+(Oa*72|0)+40|0;l=ea(g[Ua>>2]);g[w>>2]=l;Va=Pa+(Oa*72|0)+44|0;Wa=ea(g[Va>>2]);g[Ja>>2]=Wa;Xa=Pa+(Oa*72|0)+48|0;Ya=ea(g[Xa>>2]);g[ja>>2]=Ya;Za=Pa+(Oa*72|0)+52|0;_a=ea(g[Za>>2]);g[qa>>2]=_a;$a=c[oa>>2]|0;if((c[pa>>2]&2147483647)>>>0>$a>>>0){ab=c[s>>2]|0;bb=ab+($a*56|0)|0;if(!bb)cb=$a;else{g[ab+($a*56|0)+24>>2]=da;g[ab+($a*56|0)+28>>2]=ca;g[ab+($a*56|0)+32>>2]=aa;g[ab+($a*56|0)+36>>2]=l;g[ab+($a*56|0)+40>>2]=Wa;g[ab+($a*56|0)+44>>2]=Ya;g[ab+($a*56|0)+48>>2]=_a;c[bb+0>>2]=c[A+0>>2];c[bb+4>>2]=c[A+4>>2];c[bb+8>>2]=c[A+8>>2];c[bb+12>>2]=c[A+12>>2];c[bb+16>>2]=c[A+16>>2];c[bb+20>>2]=c[A+20>>2];cb=c[oa>>2]|0}c[oa>>2]=cb+1}else ZTa(s,A)|0;bb=Oa<<16|1;c[B>>2]=bb;$a=c[ma>>2]|0;if((c[na>>2]&2147483647)>>>0>$a>>>0){ab=(c[P>>2]|0)+($a<<2)|0;if(ab)c[ab>>2]=bb;c[ma>>2]=$a+1}else _Ta(P,B)|0;if(!(la|ia)){Fa=C+0|0;Ha=Fa+36|0;do{c[Fa>>2]=0;Fa=Fa+4|0}while((Fa|0)<(Ha|0));g[ha>>2]=ea(1.0);c[Ia+0>>2]=0;c[Ia+4>>2]=0;c[Ia+8>>2]=0;c[Ia+12>>2]=0;g[wa>>2]=ea(1.0);c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;g[va>>2]=ea(1.0);c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[Ea>>2]=ea(1.0);c[ua>>2]=Q;DKa(C,-16711681)|0;_a=ea(+h[Qa>>3]);Ya=ea(+h[Pa+(Oa*72|0)+24>>3]);Wa=ea(+h[Pa+(Oa*72|0)+32>>3]);g[D>>2]=ea(g[Ua>>2]);g[ta>>2]=ea(g[Va>>2]);g[Da>>2]=ea(g[Xa>>2]);g[ba>>2]=ea(g[Za>>2]);g[u>>2]=_a;g[ya>>2]=Ya;g[Ba>>2]=Wa;FKa(C,D)|0;Wa=ea(-ea(g[Ra>>2]));Ya=ea(-ea(g[Sa>>2]));_a=ea(-ea(g[Ta>>2]));g[E>>2]=Wa;g[Aa>>2]=Ya;g[za>>2]=_a;g[Ka>>2]=ea(g[Ra>>2]);g[La>>2]=ea(g[Sa>>2]);g[Ma>>2]=ea(g[Ta>>2]);a[Na>>0]=1;HKa(C,E)|0}Oa=Oa+1|0}while((Oa|0)!=(v|0))}v=c[n+20>>2]|0;if(!v)db=n;else{Oa=n+16|0;E=A+8|0;Na=A+16|0;Ma=A+24|0;La=A+32|0;Ka=A+40|0;za=A+48|0;Aa=j+60|0;D=j+56|0;Ba=j+48|0;ya=j+44|0;u=(Q|0)==0;ba=(R&4|0)==0;R=C+36|0;Da=C+40|0;ta=C+56|0;ua=C+60|0;Ea=C+76|0;y=C+80|0;va=C+96|0;z=C+100|0;wa=G+4|0;Ia=G+8|0;ha=G+12|0;ia=G+16|0;la=G+20|0;B=G+24|0;ma=G+28|0;na=G+32|0;cb=G+36|0;oa=G+40|0;pa=G+44|0;qa=0;do{ja=c[Oa>>2]|0;Ja=ja+(qa<<6)+40|0;_a=ea(g[Ja>>2]);Ya=ea(_a*ea(2.0));w=ja+(qa<<6)+52|0;Wa=ea(g[w>>2]);l=ea(Wa*ea(2.0));aa=ea(ea(_a*Ya)+ea(ea(Wa*l)+ea(-1.0)));ra=ja+(qa<<6)+48|0;Wa=ea(g[ra>>2]);_a=ea(Wa*l);x=ja+(qa<<6)+44|0;ca=ea(g[x>>2]);da=ea(_a+ea(Ya*ca));_a=ea(ea(Ya*Wa)-ea(l*ca));sa=ja+(qa<<6)+56|0;ca=ea(g[sa>>2]);l=ea(ca*aa);aa=ea(ca*da);da=ea(ca*_a);xa=ja+(qa<<6)+16|0;eb=+h[xa>>3];fb=+l;$a=ja+(qa<<6)+24|0;gb=+h[$a>>3];hb=+aa;bb=ja+(qa<<6)+32|0;ib=+h[bb>>3];jb=+da;h[A>>3]=eb-fb;h[E>>3]=gb-hb;h[Na>>3]=ib-jb;h[Ma>>3]=fb+eb;h[La>>3]=hb+gb;h[Ka>>3]=jb+ib;ab=ja+(qa<<6)+60|0;g[za>>2]=ea(g[ab>>2]);ja=c[D>>2]|0;if((c[Aa>>2]&2147483647)>>>0>ja>>>0){kb=(c[r>>2]|0)+(ja*56|0)|0;if(!kb)lb=ja;else{Fa=kb+0|0;Ga=A+0|0;Ha=Fa+56|0;do{c[Fa>>2]=c[Ga>>2];Fa=Fa+4|0;Ga=Ga+4|0}while((Fa|0)<(Ha|0));lb=c[D>>2]|0}c[D>>2]=lb+1}else $Ta(r,A)|0;Ta=qa<<16|2;c[F>>2]=Ta;Sa=c[ya>>2]|0;if((c[Ba>>2]&2147483647)>>>0>Sa>>>0){Ra=(c[q>>2]|0)+(Sa<<2)|0;if(Ra)c[Ra>>2]=Ta;c[ya>>2]=Sa+1}else _Ta(q,F)|0;if(!(u|ba)){Fa=C+0|0;Ha=Fa+36|0;do{c[Fa>>2]=0;Fa=Fa+4|0}while((Fa|0)<(Ha|0));g[R>>2]=ea(1.0);c[Da+0>>2]=0;c[Da+4>>2]=0;c[Da+8>>2]=0;c[Da+12>>2]=0;g[ta>>2]=ea(1.0);c[ua+0>>2]=0;c[ua+4>>2]=0;c[ua+8>>2]=0;c[ua+12>>2]=0;g[Ea>>2]=ea(1.0);c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[va>>2]=ea(1.0);c[z>>2]=Q;DKa(C,-16711681)|0;da=ea(g[Ja>>2]);aa=ea(g[x>>2]);l=ea(g[ra>>2]);_a=ea(g[w>>2]);ca=ea(da+da);Wa=ea(aa+aa);Ya=ea(l+l);mb=ea(aa*Wa);nb=ea(l*Ya);ob=ea(ca*aa);aa=ea(ca*l);pb=ea(ca*_a);qb=ea(Wa*l);l=ea(Wa*_a);Wa=ea(Ya*_a);_a=ea(ob+Wa);Ya=ea(aa-l);rb=ea(ob-Wa);Wa=ea(ea(1.0)-ea(da*ca));ca=ea(Wa-nb);da=ea(qb+pb);ob=ea(aa+l);l=ea(qb-pb);pb=ea(Wa-mb);g[G>>2]=ea(ea(ea(1.0)-mb)-nb);g[wa>>2]=_a;g[Ia>>2]=Ya;g[ha>>2]=rb;g[ia>>2]=ca;g[la>>2]=da;g[B>>2]=ob;g[ma>>2]=l;g[na>>2]=pb;pb=ea(+h[xa>>3]);l=ea(+h[$a>>3]);ob=ea(+h[bb>>3]);g[cb>>2]=pb;g[oa>>2]=l;g[pa>>2]=ob;ob=ea(g[ab>>2]);LKa(C,ob,ea(g[sa>>2]),G)|0}qa=qa+1|0}while((qa|0)!=(v|0));db=n}}else db=0;n=c[j+32>>2]|0;c[H>>2]=n;if(!n){c[H+4>>2]=0;sb=0}else{c[H+4>>2]=c[s>>2];sb=c[P>>2]|0}c[H+8>>2]=sb;sb=c[j+56>>2]|0;c[H+12>>2]=sb;if(!sb){c[H+16>>2]=0;tb=0}else{c[H+16>>2]=c[r>>2];tb=c[q>>2]|0}c[H+20>>2]=tb;c[I>>2]=e;c[I+4>>2]=db;c[J>>2]=c[e+456>>2];c[J+4>>2]=Q;c[J+8>>2]=(c[O>>2]|0)+76;c[$>>2]=c[$>>2]&-3;Q=f+8|0;db=f+8|0;ib=+h[db>>3];tb=f+16|0;jb=+h[tb>>3];q=f+24|0;gb=+h[q>>3];zS(K,S,J,I,f,t,H,k,m,o,ka);r=a[K>>0]|0;a[d>>0]=r;K=c[$>>2]|0;if(!(K&1))ub=r;else{c[$>>2]=K|2;h[db>>3]=ib;h[tb>>3]=jb;h[q>>3]=gb;ob=ea(g[t>>2]);if((c[T>>2]|0)==1){l=ea(g[_>>2]);pb=ea(ob*l);da=ea(g[fa>>2]);ca=ea(g[Y>>2]);rb=ea(pb+ea(da*ca));da=ea(g[ga>>2]);pb=ea(g[Z>>2]);Ya=ea(rb+ea(da*pb));da=ea(ca*Ya);ca=ea(pb*Ya);g[L>>2]=ea(l*Ya);g[L+4>>2]=da;g[L+8>>2]=ca}else{g[L>>2]=ob;g[L+4>>2]=ea(g[fa>>2]);g[L+8>>2]=ea(g[ga>>2])}zS(M,S,J,I,f,L,H,k,m,o,ka);ka=a[M>>0]|0;a[d>>0]=ka;c[$>>2]=c[$>>2]&-3;ub=ka}a[e+484>>0]=ub;ub=e+408|0;c[ub+0>>2]=c[Q+0>>2];c[ub+4>>2]=c[Q+4>>2];c[ub+8>>2]=c[Q+8>>2];c[ub+12>>2]=c[Q+12>>2];c[ub+16>>2]=c[Q+16>>2];c[ub+20>>2]=c[Q+20>>2];ka=e+400|0;$=c[ka>>2]|0;if(!$){vb=c[O>>2]|0;aT(vb);i=p;return}k=ea(ib-+h[Q>>3]);ob=ea(jb-+h[tb>>3]);ca=ea(gb-+h[q>>3]);if(!(ea(ea(ea(k*k)+ea(ob*ob))+ea(ca*ca))!=ea(0.0))){vb=c[O>>2]|0;aT(vb);i=p;return}In[c[(c[$>>2]|0)+84>>2]&4095](N,$);ca=ea(+h[ub>>3]);ob=ea(+h[e+416>>3]);k=ea(+h[e+424>>3]);g[N+16>>2]=ca;g[N+20>>2]=ob;g[N+24>>2]=k;g[N>>2]=ea(g[U>>2]);g[N+4>>2]=ea(g[V>>2]);g[N+8>>2]=ea(g[W>>2]);g[N+12>>2]=ea(g[X>>2]);X=c[ka>>2]|0;In[c[(c[X>>2]|0)+224>>2]&4095](X,N);vb=c[O>>2]|0;aT(vb);i=p;return}function DS(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im;k=i;i=i+64|0;l=k;JT(l);m=l+8|0;n=b+416|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];o=ea(g[b+496>>2]);p=ea(g[b+500>>2]);q=ea(g[b+504>>2]);g[l+40>>2]=o;g[l+44>>2]=p;g[l+48>>2]=q;g[l+32>>2]=o;CS(a,b+8|0,l,d,e,f,h,j,0);LT(l);i=k;return}function ES(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=Im,p=Im;k=i;i=i+48|0;l=k;NT(l);m=l+8|0;n=b+416|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];o=ea(g[b+496>>2]);g[l+40>>2]=o;p=ea(g[b+500>>2]);g[l+44>>2]=p;g[l+32>>2]=ea(ea(p*ea(.5))+o);CS(a,b+8|0,l,d,e,f,h,j,(c[b+504>>2]|0)==1);PT(l);i=k;return}function FS(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+360>>2]&4095](d)|0;i=b;return a|0}function GS(f,j,k,l,m,n,o,p){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=Im,ce=Im,de=Im,ee=Im,fe=Im,ge=Im,he=Im,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=Im,ye=Im,ze=Im,Ae=Im,Be=Im,Ce=Im,De=Im,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=Im,Oe=Im,Pe=Im,Qe=0,Re=0,Se=0;q=i;i=i+2352|0;r=q+2056|0;s=q+296|0;t=q+2128|0;u=q+2204|0;v=q+24|0;w=q+1936|0;x=q+2144|0;y=q+2200|0;z=q+2232|0;A=q+2248|0;B=q+2344|0;C=q;D=q+2104|0;E=q+336|0;F=q+1976|0;G=q+1940|0;H=q+2184|0;I=q+1996|0;J=q+2348|0;K=q+2024|0;L=c[f>>2]|0;M=c[f+4>>2]|0;N=+h[j>>3];O=+h[j+24>>3];P=+h[j+8>>3];Q=+h[j+32>>3];R=+h[j+16>>3];U=+h[j+40>>3];j=C+8|0;V=C+16|0;h[C>>3]=(N+O)*.5;h[j>>3]=(P+Q)*.5;h[V>>3]=(R+U)*.5;W=a[n+8>>0]|0;if(!(a[n+9>>0]|0))X=W&255;else X=(W&255|2)&65535;W=n+4|0;if(c[W>>2]|0){if(!(a[n+10>>0]|0))Y=X;else Y=(X&65535|4)&65535;if(!(a[n+11>>0]|0))Z=Y;else Z=(Y&65535|8)&65535}else Z=X;_=ea(N);$=ea(P);aa=ea(R);ba=ea(O);ca=ea(Q);da=ea(U);g[D>>2]=_;X=D+4|0;g[X>>2]=$;Y=D+8|0;g[Y>>2]=aa;fa=D+12|0;g[fa>>2]=ba;ga=D+16|0;g[ga>>2]=ca;ha=D+20|0;g[ha>>2]=da;ia=ea(ea(_+ba)*ea(.5));ja=ea(ea(da+aa)*ea(.5));ka=ea(da-aa);aa=ea(ea(ca-$)*ea(.5));la=E+1600|0;ma=E;do{c[ma>>2]=0;c[ma+4>>2]=0;c[ma+8>>2]=-1;ma=ma+16|0}while((ma|0)!=(la|0));da=ea(ea($+ca)*ea(.5));ca=ea(ea(ba-_)*ea(.5));_=ea(ka*ea(.5));la=c[n>>2]|0;if(!la){c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;b[F+16>>1]=Z;a[F+18>>0]=0}else{c[F+0>>2]=c[la+0>>2];c[F+4>>2]=c[la+4>>2];c[F+8>>2]=c[la+8>>2];c[F+12>>2]=c[la+12>>2];b[F+16>>1]=Z;a[F+18>>0]=0}c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=-1;la=G+20|0;a[la>>0]=0;n=G+24|0;c[n>>2]=E;c[G+28>>2]=100;E=G+32|0;c[E>>2]=0;c[G>>2]=420288;b[F+16>>1]=Z&65535|32;Z=c[(c[L>>2]|0)+356>>2]|0;c[H>>2]=3;g[H+4>>2]=ca;g[H+8>>2]=aa;g[H+12>>2]=_;g[I>>2]=ea(0.0);g[I+4>>2]=ea(0.0);g[I+8>>2]=ea(0.0);g[I+12>>2]=ea(1.0);g[I+16>>2]=ia;g[I+20>>2]=da;g[I+24>>2]=ja;Km[Z&127](L,H,I,G,F,c[W>>2]|0)|0;W=(d[la>>0]|0)+(c[E>>2]|0)|0;if(!W){i=q;return}la=f+8|0;f=s+16|0;F=s+20|0;I=s+24|0;H=r+12|0;L=r+4|0;Z=r+8|0;ma=r+16|0;na=r+20|0;oa=r+24|0;pa=s+12|0;qa=s+8|0;ra=s+4|0;sa=K+4|0;ta=K+8|0;ua=K+12|0;va=K+16|0;wa=K+20|0;xa=K+24|0;ya=r+4|0;za=m+4|0;Aa=r+4|0;Ba=r+8|0;Ca=z+4|0;Da=z+8|0;Ea=z+12|0;Fa=A+4|0;Ga=A+8|0;Ha=A+12|0;Ia=A+16|0;Ja=A+20|0;Ka=A+24|0;La=A+28|0;Ma=A+32|0;Na=A+36|0;Oa=A+40|0;Pa=A+44|0;Qa=A+48|0;Ra=A+52|0;Sa=A+56|0;Ta=A+60|0;Ua=A+64|0;Va=A+68|0;Wa=A+72|0;Xa=A+76|0;Ya=A+80|0;Za=A+84|0;_a=A+88|0;$a=A+92|0;ab=k+4|0;bb=o+56|0;cb=l+8|0;db=l+4|0;eb=s+4|0;fb=s+8|0;gb=s+12|0;hb=s+16|0;ib=s+20|0;jb=s+24|0;kb=s+28|0;lb=s+32|0;mb=o+52|0;nb=r+4|0;ob=r+8|0;pb=r+12|0;qb=r+16|0;rb=r+20|0;sb=r+24|0;tb=r+28|0;ub=r+32|0;vb=r+36|0;wb=r+40|0;xb=r+44|0;yb=s+12|0;zb=s+24|0;Ab=s+4|0;Bb=s+8|0;Cb=s+12|0;Db=s+16|0;Eb=s+20|0;Fb=s+24|0;Gb=s+28|0;Hb=s+32|0;Ib=t+4|0;Jb=t+8|0;Kb=t+12|0;Lb=u+4|0;Mb=u+8|0;Nb=u+12|0;Ob=u+16|0;Pb=u+20|0;Qb=u+24|0;Rb=o+32|0;Sb=x+4|0;Tb=x+8|0;Ub=x+12|0;Vb=x+16|0;Wb=x+20|0;Xb=x+24|0;Yb=x+28|0;Zb=x+32|0;_b=r+4|0;$b=r+8|0;ac=r+12|0;bc=r+16|0;cc=r+20|0;dc=r+24|0;ec=r+28|0;fc=r+32|0;gc=r+36|0;hc=r+40|0;ic=r+44|0;jc=r+4|0;kc=r+8|0;lc=r+12|0;mc=r+16|0;nc=r+20|0;oc=r+24|0;pc=r+28|0;qc=r+32|0;rc=k+8|0;sc=o+20|0;tc=x+4|0;uc=x+8|0;vc=x+12|0;wc=x+16|0;xc=x+20|0;yc=x+24|0;zc=x+28|0;Ac=x+32|0;Bc=r+4|0;Cc=r+8|0;Dc=r+12|0;Ec=r+16|0;Fc=r+20|0;Gc=r+24|0;Hc=r+28|0;Ic=r+32|0;Jc=r+36|0;Kc=r+40|0;Lc=r+44|0;Mc=s+4|0;Nc=s+8|0;Oc=s+12|0;Pc=s+16|0;Qc=s+20|0;Rc=t+4|0;Sc=t+8|0;Tc=t+12|0;Uc=u+4|0;Vc=u+8|0;Wc=u+12|0;Xc=u+16|0;Yc=u+20|0;Zc=u+24|0;_c=x+4|0;$c=x+8|0;ad=x+12|0;bd=x+16|0;cd=x+20|0;dd=x+24|0;ed=x+28|0;fd=x+32|0;gd=r+4|0;hd=r+8|0;id=r+12|0;jd=r+16|0;kd=r+20|0;ld=r+24|0;md=r+28|0;nd=r+32|0;od=r+36|0;pd=r+40|0;qd=r+44|0;rd=r+4|0;sd=r+8|0;td=r+12|0;ud=r+16|0;vd=r+20|0;wd=r+24|0;xd=r+28|0;yd=r+32|0;zd=x+4|0;Ad=x+8|0;Bd=x+12|0;Cd=x+16|0;Dd=x+20|0;Ed=x+24|0;Fd=x+28|0;Gd=x+32|0;Hd=r+4|0;Id=r+8|0;Jd=r+12|0;Kd=r+16|0;Ld=r+20|0;Md=r+24|0;Nd=r+28|0;Od=r+32|0;Pd=r+36|0;Qd=r+40|0;Rd=r+44|0;Sd=G+4|0;G=0;do{if((c[E>>2]|0)>>>0>G>>>0)Td=(c[n>>2]|0)+(G<<4)|0;else Td=Sd;Ud=c[Td+4>>2]|0;Vd=c[Td>>2]|0;a:do if(!((Ud|0)==0|(Vd|0)==0)){Wd=c[la>>2]|0;Xd=c[Wd+20>>2]|0;b:do if((Xd|0)!=0?(Yd=Ud,Zd=Yd+~(Yd<<15)|0,Yd=(Zd>>>10^Zd)*9|0,Zd=Yd>>>6^Yd,Yd=Zd+~(Zd<<11)|0,Zd=c[(c[Wd+12>>2]|0)+((Xd+-1&(Yd>>>16^Yd))<<2)>>2]|0,(Zd|0)!=-1):0){Yd=c[Wd+4>>2]|0;_d=Wd+8|0;$d=Zd;while(1){ae=Yd+($d<<2)|0;if((c[ae>>2]|0)==(Ud|0))break;$d=c[(c[_d>>2]|0)+($d<<2)>>2]|0;if(($d|0)==-1)break b}if(ae)break a}while(0);In[c[(c[Ud>>2]|0)+136>>2]&4095](J,Ud);if(!(a[J>>0]&4)){In[c[(c[Vd>>2]|0)+84>>2]&4095](r,Vd);In[c[(c[Ud>>2]|0)+72>>2]&4095](s,Ud);ja=ea(ea(g[f>>2])*ea(2.0));da=ea(ea(g[F>>2])*ea(2.0));ia=ea(ea(g[I>>2])*ea(2.0));_=ea(g[H>>2]);aa=ea(ea(_*_)+ea(-.5));ca=ea(g[r>>2]);ka=ea(ja*ca);ba=ea(g[L>>2]);$=ea(ka+ea(da*ba));ka=ea(g[Z>>2]);be=ea($+ea(ia*ka));$=ea(ea(ca*be)+ea(ea(ja*aa)+ea(_*ea(ea(ia*ba)-ea(da*ka)))));ce=ea(ea(ba*be)+ea(ea(da*aa)+ea(_*ea(ea(ja*ka)-ea(ia*ca)))));de=ea(ea(ea(ia*aa)+ea(_*ea(ea(da*ca)-ea(ja*ba))))+ea(ka*be));be=ea(ea(g[ma>>2])+$);$=ea(ea(g[na>>2])+ce);ce=ea(ea(g[oa>>2])+de);de=ea(g[s>>2]);ja=ea(_*de);da=ea(g[pa>>2]);aa=ea(ja+ea(ca*da));ja=ea(g[qa>>2]);ia=ea(aa+ea(ba*ja));aa=ea(g[ra>>2]);ee=ea(ea(ea(ka*de)+ea(ea(ba*da)+ea(_*aa)))-ea(ca*ja));fe=ea(ea(ea(ca*aa)+ea(ea(ka*da)+ea(_*ja)))-ea(ba*de));ge=ea(ea(ea(ea(_*da)-ea(ca*de))-ea(ba*aa))-ea(ka*ja));g[K>>2]=ea(ia-ea(ka*aa));g[sa>>2]=ee;g[ta>>2]=fe;g[ua>>2]=ge;g[va>>2]=be;g[wa>>2]=$;g[xa>>2]=ce;switch(mo[c[(c[Ud>>2]|0)+24>>2]&4095](Ud)|0){case 5:{c[s>>2]=5;g[Ab>>2]=ea(1.0);g[Bb>>2]=ea(1.0);g[Cb>>2]=ea(1.0);g[Db>>2]=ea(0.0);g[Eb>>2]=ea(0.0);g[Fb>>2]=ea(0.0);g[Gb>>2]=ea(1.0);Wd=Hb;c[Wd>>2]=0;c[Wd+4>>2]=0;_n[c[(c[Ud>>2]|0)+56>>2]&4095](Ud,s)|0;ce=ea(g[fa>>2]);$=ea(g[D>>2]);be=ea(ce-$);ge=ea(g[ga>>2]);fe=ea(g[X>>2]);ee=ea(ge-fe);aa=ea(g[ha>>2]);ka=ea(g[Y>>2]);ia=ea(be*ea(.5));be=ea(ee*ea(.5));ee=ea(ea(aa-ka)*ea(.5));c[t>>2]=3;g[Ib>>2]=ia;g[Jb>>2]=be;g[Kb>>2]=ee;ee=ea(ea(ce+$)*ea(.5));$=ea(ea(ge+fe)*ea(.5));fe=ea(ea(aa+ka)*ea(.5));g[u>>2]=ea(0.0);g[Lb>>2]=ea(0.0);g[Mb>>2]=ea(0.0);g[Nb>>2]=ea(1.0);g[Ob>>2]=ee;g[Pb>>2]=$;g[Qb>>2]=fe;qU(v);Wd=sU(v,t,u,s,K)|0;fe=ea(+h[C>>3]);$=ea(-fe);ee=ea(+h[j>>3]);ka=ea(-ee);aa=ea(+h[V>>3]);ge=ea(-aa);Xd=c[za>>2]|0;YTa(m,Xd+12|0);$d=c[m>>2]|0;c[$d+(Xd<<2)>>2]=2;c[$d+(Xd+1<<2)>>2]=Ud;c[$d+(Xd+2<<2)>>2]=Vd;_d=$d+(Xd+4<<2)|0;c[_d+0>>2]=c[C+0>>2];c[_d+4>>2]=c[C+4>>2];c[_d+8>>2]=c[C+8>>2];c[_d+12>>2]=c[C+12>>2];c[_d+16>>2]=c[C+16>>2];c[_d+20>>2]=c[C+20>>2];_d=$d+(Xd+10<<2)|0;c[_d>>2]=Wd;Yd=$d+(Xd+11<<2)|0;c[Yd>>2]=c[ab>>2];Xd=c[v>>2]|0;$d=ea(g[Rb>>2])!=ea(0.0);Zd=(a[bb>>0]|0)!=0;do if($d){if(Zd){ce=ea(ea(g[Ob>>2])-fe);be=ea(ea(g[Pb>>2])-ee);ia=ea(ea(g[Qb>>2])-aa);ja=ea(g[Ib>>2]);ba=ea(ce-ja);de=ea(g[Jb>>2]);ca=ea(be-de);da=ea(g[Kb>>2]);_=ea(ia-da);he=ea(ce+ja);ja=ea(be+de);de=ea(ia+da);if(!Wd)ie=0;else{da=ea(ea(ba+he)*ea(.5));ia=ea(ea(ca+ja)*ea(.5));be=ea(ea(_+de)*ea(.5));ce=ea(ea(he-ba)*ea(.5));ba=ea(ea(ja-ca)*ea(.5));ca=ea(ea(de-_)*ea(.5));je=0;ke=0;while(1){le=c[Xd+(je<<2)>>2]|0;qQa(s,K,le,x,0,0);g[x>>2]=ea(ea(g[x>>2])-fe);g[Sb>>2]=ea(ea(g[Sb>>2])-ee);g[Tb>>2]=ea(ea(g[Tb>>2])-aa);g[Ub>>2]=ea(ea(g[Ub>>2])-fe);g[Vb>>2]=ea(ea(g[Vb>>2])-ee);g[Wb>>2]=ea(ea(g[Wb>>2])-aa);g[Xb>>2]=ea(ea(g[Xb>>2])-fe);g[Yb>>2]=ea(ea(g[Yb>>2])-ee);g[Zb>>2]=ea(ea(g[Zb>>2])-aa);me=dUa(o,x,k,l)|0;ne=me+ke|0;if(!me){_=ea(g[mb>>2]);c[r>>2]=0;c[_b>>2]=le;c[$b>>2]=k;c[ac>>2]=l;g[bc>>2]=da;g[cc>>2]=ia;g[dc>>2]=be;g[ec>>2]=ce;g[fc>>2]=ba;g[gc>>2]=ca;g[hc>>2]=_;b[ic>>1]=0;aUa(r,x,Ub,Xb);le=c[r>>2]|0;b[p>>1]=(e[p>>1]|0)+(e[ic>>1]|0);oe=le+ne|0}else oe=ne;je=je+1|0;if((je|0)==(Wd|0)){ie=oe;break}else ke=oe}}c[_d>>2]=ie;pe=ie;break}if(!Wd)qe=0;else{ke=0;je=0;while(1){ne=c[Xd+(ke<<2)>>2]|0;c[w>>2]=ne;qQa(s,K,ne,r,0,0);g[r>>2]=ea(ea(g[r>>2])-fe);g[jc>>2]=ea(ea(g[jc>>2])-ee);g[kc>>2]=ea(ea(g[kc>>2])-aa);g[lc>>2]=ea(ea(g[lc>>2])-fe);g[mc>>2]=ea(ea(g[mc>>2])-ee);g[nc>>2]=ea(ea(g[nc>>2])-aa);g[oc>>2]=ea(ea(g[oc>>2])-fe);g[pc>>2]=ea(ea(g[pc>>2])-ee);g[qc>>2]=ea(ea(g[qc>>2])-aa);le=dUa(o,r,k,l)|0;me=le+je|0;if(!le){le=c[ab>>2]|0;if((c[rc>>2]&2147483647)>>>0>le>>>0){re=c[k>>2]|0;se=re+(le*36|0)|0;if(se){g[se>>2]=ea(g[r>>2]);g[re+(le*36|0)+4>>2]=ea(g[jc>>2]);g[re+(le*36|0)+8>>2]=ea(g[kc>>2]);g[re+(le*36|0)+12>>2]=ea(g[lc>>2]);g[re+(le*36|0)+16>>2]=ea(g[mc>>2]);g[re+(le*36|0)+20>>2]=ea(g[nc>>2]);g[re+(le*36|0)+24>>2]=ea(g[oc>>2]);g[re+(le*36|0)+28>>2]=ea(g[pc>>2]);g[re+(le*36|0)+32>>2]=ea(g[qc>>2])}c[ab>>2]=le+1}else eUa(k,r)|0;le=c[db>>2]|0;if((c[cb>>2]&2147483647)>>>0>le>>>0){re=(c[l>>2]|0)+(le<<2)|0;if(!re)te=le;else{c[re>>2]=ne;te=c[db>>2]|0}c[db>>2]=te+1}else cUa(l,w)|0;ue=me+1|0}else ue=me;ke=ke+1|0;if((ke|0)==(Wd|0)){qe=ue;break}else je=ue}}c[_d>>2]=qe;pe=qe}else{if(Zd){ca=ea(ea(g[Ob>>2])-fe);ba=ea(ea(g[Pb>>2])-ee);ce=ea(ea(g[Qb>>2])-aa);be=ea(g[Ib>>2]);ia=ea(ca-be);da=ea(g[Jb>>2]);_=ea(ba-da);de=ea(g[Kb>>2]);ja=ea(ce-de);he=ea(ca+be);be=ea(ba+da);da=ea(ce+de);if(!Wd)ve=0;else{de=ea(ea(ia+he)*ea(.5));ce=ea(ea(_+be)*ea(.5));ba=ea(ea(ja+da)*ea(.5));ca=ea(ea(he-ia)*ea(.5));ia=ea(ea(be-_)*ea(.5));_=ea(ea(da-ja)*ea(.5));je=0;ke=0;while(1){me=c[Xd+(je<<2)>>2]|0;qQa(s,K,me,x,0,0);g[x>>2]=ea(ea(g[x>>2])-fe);g[tc>>2]=ea(ea(g[tc>>2])-ee);g[uc>>2]=ea(ea(g[uc>>2])-aa);g[vc>>2]=ea(ea(g[vc>>2])-fe);g[wc>>2]=ea(ea(g[wc>>2])-ee);g[xc>>2]=ea(ea(g[xc>>2])-aa);g[yc>>2]=ea(ea(g[yc>>2])-fe);g[zc>>2]=ea(ea(g[zc>>2])-ee);g[Ac>>2]=ea(ea(g[Ac>>2])-aa);ja=ea(g[mb>>2]);c[r>>2]=0;c[Bc>>2]=me;c[Cc>>2]=k;c[Dc>>2]=l;g[Ec>>2]=de;g[Fc>>2]=ce;g[Gc>>2]=ba;g[Hc>>2]=ca;g[Ic>>2]=ia;g[Jc>>2]=_;g[Kc>>2]=ja;b[Lc>>1]=0;aUa(r,x,vc,yc);me=c[r>>2]|0;b[p>>1]=(e[p>>1]|0)+(e[Lc>>1]|0);ne=me+ke|0;je=je+1|0;if((je|0)==(Wd|0)){ve=ne;break}else ke=ne}}c[_d>>2]=ve;pe=ve;break}ke=c[ab>>2]|0;bUa(k,ke+Wd|0);if(Wd){je=(c[k>>2]|0)+(ke*36|0)|0;ke=0;do{ne=c[Xd+(ke<<2)>>2]|0;c[y>>2]=ne;qQa(s,K,ne,je,0,0);g[je>>2]=ea(ea(g[je>>2])-fe);me=je+4|0;g[me>>2]=ea(ea(g[me>>2])-ee);me=je+8|0;g[me>>2]=ea(ea(g[me>>2])-aa);me=je+12|0;g[me>>2]=ea(ea(g[me>>2])-fe);me=je+16|0;g[me>>2]=ea(ea(g[me>>2])-ee);me=je+20|0;g[me>>2]=ea(ea(g[me>>2])-aa);me=je+24|0;g[me>>2]=ea(ea(g[me>>2])-fe);me=je+28|0;g[me>>2]=ea(ea(g[me>>2])-ee);me=je+32|0;je=je+36|0;g[me>>2]=ea(ea(g[me>>2])-aa);me=c[db>>2]|0;if((c[cb>>2]&2147483647)>>>0>me>>>0){re=(c[l>>2]|0)+(me<<2)|0;if(!re)we=me;else{c[re>>2]=ne;we=c[db>>2]|0}c[db>>2]=we+1}else cUa(l,y)|0;ke=ke+1|0}while((ke|0)!=(Wd|0))}pe=c[_d>>2]|0}while(0);fUa(pe,c[Yd>>2]|0,c[k>>2]|0,M,$,ka,ge,sc);rU(v);break a;break}case 2:{c[r>>2]=2;g[Aa>>2]=ea(0.0);g[Ba>>2]=ea(0.0);_n[c[(c[Ud>>2]|0)+44>>2]&4095](Ud,r)|0;aa=ea(g[Ba>>2]);ee=ea(g[K>>2]);fe=ea(ee*ea(2.0));_=ea(g[ua>>2]);ia=ea(_*ea(2.0));ca=ea(ea(ee*fe)+ea(ea(_*ia)+ea(-1.0)));_=ea(g[ta>>2]);ee=ea(_*ia);ba=ea(g[sa>>2]);ce=ea(aa*ca);ca=ea(aa*ea(ee+ea(fe*ba)));ee=ea(aa*ea(ea(fe*_)-ea(ia*ba)));ba=ea(g[va>>2]);ia=ea(ba+ce);_=ea(g[wa>>2]);fe=ea(_+ca);aa=ea(g[xa>>2]);de=ea(aa+ee);ja=ea(ba-ce);ce=ea(_-ca);ca=ea(aa-ee);ee=ea(g[Aa>>2]);_d=c[za>>2]|0;YTa(m,_d+18|0);Wd=c[m>>2]|0;c[Wd+(_d<<2)>>2]=5;c[Wd+(_d+1<<2)>>2]=Ud;c[Wd+(_d+2<<2)>>2]=Vd;Xd=Wd+(_d+4<<2)|0;c[Xd+0>>2]=c[C+0>>2];c[Xd+4>>2]=c[C+4>>2];c[Xd+8>>2]=c[C+8>>2];c[Xd+12>>2]=c[C+12>>2];c[Xd+16>>2]=c[C+16>>2];c[Xd+20>>2]=c[C+20>>2];g[Wd+(_d+16<<2)>>2]=ee;U=+h[C>>3];g[Wd+(_d+10<<2)>>2]=ea(+ia-U);Q=+h[j>>3];g[Wd+(_d+11<<2)>>2]=ea(+fe-Q);O=+h[V>>3];g[Wd+(_d+12<<2)>>2]=ea(+de-O);g[Wd+(_d+13<<2)>>2]=ea(+ja-U);g[Wd+(_d+14<<2)>>2]=ea(+ce-Q);g[Wd+(_d+15<<2)>>2]=ea(+ca-O);break a;break}case 0:{c[r>>2]=0;g[ya>>2]=ea(0.0);_n[c[(c[Ud>>2]|0)+40>>2]&4095](Ud,r)|0;ca=ea(g[ya>>2]);O=+ea(g[va>>2]);Q=+ea(g[wa>>2]);U=+ea(g[xa>>2]);_d=c[za>>2]|0;YTa(m,_d+14|0);Wd=c[m>>2]|0;c[Wd+(_d<<2)>>2]=4;c[Wd+(_d+1<<2)>>2]=Ud;c[Wd+(_d+2<<2)>>2]=Vd;Xd=Wd+(_d+4<<2)|0;c[Xd+0>>2]=c[C+0>>2];c[Xd+4>>2]=c[C+4>>2];c[Xd+8>>2]=c[C+8>>2];c[Xd+12>>2]=c[C+12>>2];c[Xd+16>>2]=c[C+16>>2];c[Xd+20>>2]=c[C+20>>2];g[Wd+(_d+13<<2)>>2]=ca;g[Wd+(_d+10<<2)>>2]=ea(O-+h[C>>3]);g[Wd+(_d+11<<2)>>2]=ea(Q-+h[j>>3]);g[Wd+(_d+12<<2)>>2]=ea(U-+h[V>>3]);break a;break}case 3:{c[z>>2]=3;g[Ca>>2]=ea(0.0);g[Da>>2]=ea(0.0);g[Ea>>2]=ea(0.0);_n[c[(c[Ud>>2]|0)+36>>2]&4095](Ud,z)|0;ca=ea(g[Ca>>2]);ce=ea(g[Da>>2]);ja=ea(g[Ea>>2]);de=ea(-ca);fe=ea(-ce);ia=ea(-ja);g[A>>2]=de;g[Fa>>2]=fe;g[Ga>>2]=ia;g[Ha>>2]=ca;g[Ia>>2]=fe;g[Ja>>2]=ia;g[Ka>>2]=ca;g[La>>2]=ce;g[Ma>>2]=ia;g[Na>>2]=de;g[Oa>>2]=ce;g[Pa>>2]=ia;g[Qa>>2]=de;g[Ra>>2]=fe;g[Sa>>2]=ja;g[Ta>>2]=ca;g[Ua>>2]=fe;g[Va>>2]=ja;g[Wa>>2]=ca;g[Xa>>2]=ce;g[Ya>>2]=ja;g[Za>>2]=de;g[_a>>2]=ce;g[$a>>2]=ja;ja=ea(+h[C>>3]);ce=ea(+h[j>>3]);ca=ea(+h[V>>3]);ee=ea(g[ua>>2]);aa=ea(ea(ee*ee)+ea(-.5));_=ea(g[K>>2]);ba=ea(g[sa>>2]);da=ea(g[ta>>2]);be=ea(g[va>>2]);he=ea(g[wa>>2]);xe=ea(g[xa>>2]);ye=de;de=fe;fe=ia;_d=0;while(1){ia=ea(ye*ea(2.0));ze=ea(de*ea(2.0));Ae=ea(fe*ea(2.0));Be=ea(ea(da*Ae)+ea(ea(ba*ze)+ea(_*ia)));Ce=ea(ea(he+ea(ea(ba*Be)+ea(ea(aa*ze)+ea(ee*ea(ea(da*ia)-ea(_*Ae))))))-ce);De=ea(ea(xe+ea(ea(ea(aa*Ae)+ea(ee*ea(ea(_*ze)-ea(ba*ia))))+ea(da*Be)))-ca);g[A+(_d*12|0)>>2]=ea(ea(be+ea(ea(ea(aa*ia)+ea(ee*ea(ea(ba*Ae)-ea(da*ze))))+ea(_*Be)))-ja);g[A+(_d*12|0)+4>>2]=Ce;g[A+(_d*12|0)+8>>2]=De;Wd=_d+1|0;if((Wd|0)==8)break;De=ea(g[A+(Wd*12|0)>>2]);Ce=ea(g[A+(Wd*12|0)+4>>2]);ye=De;de=Ce;fe=ea(g[A+(Wd*12|0)+8>>2]);_d=Wd}_d=c[za>>2]|0;YTa(m,_d+12|0);Yd=c[m>>2]|0;c[Yd+(_d<<2)>>2]=2;c[Yd+(_d+1<<2)>>2]=Ud;c[Yd+(_d+2<<2)>>2]=Vd;Wd=Yd+(_d+4<<2)|0;c[Wd+0>>2]=c[C+0>>2];c[Wd+4>>2]=c[C+4>>2];c[Wd+8>>2]=c[C+8>>2];c[Wd+12>>2]=c[C+12>>2];c[Wd+16>>2]=c[C+16>>2];c[Wd+20>>2]=c[C+20>>2];c[Yd+(_d+11<<2)>>2]=c[ab>>2];if(a[bb>>0]|0){fe=ea(g[fa>>2]);de=ea(g[D>>2]);ye=ea(fe-de);_=ea(g[ga>>2]);da=ea(g[X>>2]);ba=ea(_-da);ee=ea(g[ha>>2]);aa=ea(g[Y>>2]);be=ea(ye*ea(.5));ye=ea(ba*ea(.5));ba=ea(ea(ee-aa)*ea(.5));xe=ea(ea(ea(fe+de)*ea(.5))-ja);de=ea(ea(ea(_+da)*ea(.5))-ce);da=ea(ea(ea(ee+aa)*ea(.5))-ca);aa=ea(xe-be);ee=ea(de-ye);_=ea(da-ba);fe=ea(be+xe);xe=ea(ye+de);de=ea(ba+da);da=ea(ea(aa+fe)*ea(.5));ba=ea(ea(ee+xe)*ea(.5));ye=ea(ea(_+de)*ea(.5));be=ea(ea(fe-aa)*ea(.5));aa=ea(ea(xe-ee)*ea(.5));ee=ea(ea(de-_)*ea(.5));Wd=0;Xd=0;do{Zd=c[420416+(Wd*12|0)>>2]|0;$d=c[420420+(Wd*12|0)>>2]|0;ke=c[420424+(Wd*12|0)>>2]|0;g[s>>2]=ea(g[A+(Zd*12|0)>>2]);g[eb>>2]=ea(g[A+(Zd*12|0)+4>>2]);g[fb>>2]=ea(g[A+(Zd*12|0)+8>>2]);g[gb>>2]=ea(g[A+($d*12|0)>>2]);g[hb>>2]=ea(g[A+($d*12|0)+4>>2]);g[ib>>2]=ea(g[A+($d*12|0)+8>>2]);g[jb>>2]=ea(g[A+(ke*12|0)>>2]);g[kb>>2]=ea(g[A+(ke*12|0)+4>>2]);g[lb>>2]=ea(g[A+(ke*12|0)+8>>2]);_=ea(g[mb>>2]);c[r>>2]=0;c[nb>>2]=-1;c[ob>>2]=k;c[pb>>2]=l;g[qb>>2]=da;g[rb>>2]=ba;g[sb>>2]=ye;g[tb>>2]=be;g[ub>>2]=aa;g[vb>>2]=ee;g[wb>>2]=_;b[xb>>1]=0;aUa(r,s,yb,zb);ke=c[r>>2]|0;b[p>>1]=(e[p>>1]|0)+(e[xb>>1]|0);Xd=ke+Xd|0;Wd=Wd+1|0}while((Wd|0)!=12);c[Yd+(_d+10<<2)>>2]=Xd;break a}c[Yd+(_d+10<<2)>>2]=12;Wd=c[ab>>2]|0;bUa(k,Wd+12|0);ke=c[k>>2]|0;$d=0;do{Zd=$d+Wd|0;je=c[420416+($d*12|0)>>2]|0;g[ke+(Zd*36|0)>>2]=ea(g[A+(je*12|0)>>2]);g[ke+(Zd*36|0)+4>>2]=ea(g[A+(je*12|0)+4>>2]);g[ke+(Zd*36|0)+8>>2]=ea(g[A+(je*12|0)+8>>2]);je=c[420420+($d*12|0)>>2]|0;g[ke+(Zd*36|0)+12>>2]=ea(g[A+(je*12|0)>>2]);g[ke+(Zd*36|0)+16>>2]=ea(g[A+(je*12|0)+4>>2]);g[ke+(Zd*36|0)+20>>2]=ea(g[A+(je*12|0)+8>>2]);je=c[420424+($d*12|0)>>2]|0;g[ke+(Zd*36|0)+24>>2]=ea(g[A+(je*12|0)>>2]);g[ke+(Zd*36|0)+28>>2]=ea(g[A+(je*12|0)+4>>2]);g[ke+(Zd*36|0)+32>>2]=ea(g[A+(je*12|0)+8>>2]);c[B>>2]=-1;je=c[db>>2]|0;if((c[cb>>2]&2147483647)>>>0>je>>>0){Zd=(c[l>>2]|0)+(je<<2)|0;if(!Zd)Ee=je;else{c[Zd>>2]=-1;Ee=c[db>>2]|0}c[db>>2]=Ee+1}else cUa(l,B)|0;$d=$d+1|0}while(($d|0)!=12);break}case 6:{c[s>>2]=6;c[Mc>>2]=0;g[Nc>>2]=ea(1.0);g[Oc>>2]=ea(1.0);g[Pc>>2]=ea(1.0);c[Qc>>2]=0;_n[c[(c[Ud>>2]|0)+60>>2]&4095](Ud,s)|0;ee=ea(g[fa>>2]);aa=ea(g[D>>2]);be=ea(ee-aa);ye=ea(g[ga>>2]);ba=ea(g[X>>2]);da=ea(ye-ba);ca=ea(g[ha>>2]);ce=ea(g[Y>>2]);ja=ea(be*ea(.5));be=ea(da*ea(.5));da=ea(ea(ca-ce)*ea(.5));c[t>>2]=3;g[Rc>>2]=ja;g[Sc>>2]=be;g[Tc>>2]=da;da=ea(ea(ee+aa)*ea(.5));aa=ea(ea(ye+ba)*ea(.5));ba=ea(ea(ca+ce)*ea(.5));g[u>>2]=ea(0.0);g[Uc>>2]=ea(0.0);g[Vc>>2]=ea(0.0);g[Wc>>2]=ea(1.0);g[Xc>>2]=da;g[Yc>>2]=aa;g[Zc>>2]=ba;qU(v);$d=tU(v,t,u,s,K)|0;ba=ea(+h[C>>3]);aa=ea(-ba);da=ea(+h[j>>3]);ce=ea(-da);ca=ea(+h[V>>3]);ye=ea(-ca);ke=c[za>>2]|0;YTa(m,ke+12|0);Wd=c[m>>2]|0;c[Wd+(ke<<2)>>2]=2;c[Wd+(ke+1<<2)>>2]=Ud;c[Wd+(ke+2<<2)>>2]=Vd;_d=Wd+(ke+4<<2)|0;c[_d+0>>2]=c[C+0>>2];c[_d+4>>2]=c[C+4>>2];c[_d+8>>2]=c[C+8>>2];c[_d+12>>2]=c[C+12>>2];c[_d+16>>2]=c[C+16>>2];c[_d+20>>2]=c[C+20>>2];_d=Wd+(ke+10<<2)|0;c[_d>>2]=$d;Yd=Wd+(ke+11<<2)|0;c[Yd>>2]=c[ab>>2];ke=c[v>>2]|0;Wd=ea(g[Rb>>2])!=ea(0.0);Xd=(a[bb>>0]|0)!=0;do if(Wd){if(Xd){ee=ea(ea(g[Xc>>2])-ba);be=ea(ea(g[Yc>>2])-da);ja=ea(ea(g[Zc>>2])-ca);_=ea(g[Rc>>2]);de=ea(ee-_);xe=ea(g[Sc>>2]);fe=ea(be-xe);he=ea(g[Tc>>2]);ge=ea(ja-he);ka=ea(ee+_);_=ea(be+xe);xe=ea(ja+he);if(!$d)Fe=0;else{he=ea(ea(de+ka)*ea(.5));ja=ea(ea(fe+_)*ea(.5));be=ea(ea(ge+xe)*ea(.5));ee=ea(ea(ka-de)*ea(.5));de=ea(ea(_-fe)*ea(.5));fe=ea(ea(xe-ge)*ea(.5));Zd=0;je=0;while(1){ne=c[ke+(Zd<<2)>>2]|0;rQa(s,K,ne,x,0,0);g[x>>2]=ea(ea(g[x>>2])-ba);g[_c>>2]=ea(ea(g[_c>>2])-da);g[$c>>2]=ea(ea(g[$c>>2])-ca);g[ad>>2]=ea(ea(g[ad>>2])-ba);g[bd>>2]=ea(ea(g[bd>>2])-da);g[cd>>2]=ea(ea(g[cd>>2])-ca);g[dd>>2]=ea(ea(g[dd>>2])-ba);g[ed>>2]=ea(ea(g[ed>>2])-da);g[fd>>2]=ea(ea(g[fd>>2])-ca);re=dUa(o,x,k,l)|0;me=re+je|0;if(!re){ge=ea(g[mb>>2]);c[r>>2]=0;c[gd>>2]=ne;c[hd>>2]=k;c[id>>2]=l;g[jd>>2]=he;g[kd>>2]=ja;g[ld>>2]=be;g[md>>2]=ee;g[nd>>2]=de;g[od>>2]=fe;g[pd>>2]=ge;b[qd>>1]=0;aUa(r,x,ad,dd);ne=c[r>>2]|0;b[p>>1]=(e[p>>1]|0)+(e[qd>>1]|0);Ge=ne+me|0}else Ge=me;Zd=Zd+1|0;if((Zd|0)==($d|0)){Fe=Ge;break}else je=Ge}}c[_d>>2]=Fe;He=Fe;break}if(!$d)Ie=0;else{je=0;Zd=0;while(1){me=c[ke+(je<<2)>>2]|0;c[w>>2]=me;rQa(s,K,me,r,0,0);g[r>>2]=ea(ea(g[r>>2])-ba);g[rd>>2]=ea(ea(g[rd>>2])-da);g[sd>>2]=ea(ea(g[sd>>2])-ca);g[td>>2]=ea(ea(g[td>>2])-ba);g[ud>>2]=ea(ea(g[ud>>2])-da);g[vd>>2]=ea(ea(g[vd>>2])-ca);g[wd>>2]=ea(ea(g[wd>>2])-ba);g[xd>>2]=ea(ea(g[xd>>2])-da);g[yd>>2]=ea(ea(g[yd>>2])-ca);ne=dUa(o,r,k,l)|0;re=ne+Zd|0;if(!ne){ne=c[ab>>2]|0;if((c[rc>>2]&2147483647)>>>0>ne>>>0){le=c[k>>2]|0;se=le+(ne*36|0)|0;if(se){g[se>>2]=ea(g[r>>2]);g[le+(ne*36|0)+4>>2]=ea(g[rd>>2]);g[le+(ne*36|0)+8>>2]=ea(g[sd>>2]);g[le+(ne*36|0)+12>>2]=ea(g[td>>2]);g[le+(ne*36|0)+16>>2]=ea(g[ud>>2]);g[le+(ne*36|0)+20>>2]=ea(g[vd>>2]);g[le+(ne*36|0)+24>>2]=ea(g[wd>>2]);g[le+(ne*36|0)+28>>2]=ea(g[xd>>2]);g[le+(ne*36|0)+32>>2]=ea(g[yd>>2])}c[ab>>2]=ne+1}else eUa(k,r)|0;ne=c[db>>2]|0;if((c[cb>>2]&2147483647)>>>0>ne>>>0){le=(c[l>>2]|0)+(ne<<2)|0;if(!le)Je=ne;else{c[le>>2]=me;Je=c[db>>2]|0}c[db>>2]=Je+1}else cUa(l,w)|0;Ke=re+1|0}else Ke=re;je=je+1|0;if((je|0)==($d|0)){Ie=Ke;break}else Zd=Ke}}c[_d>>2]=Ie;He=Ie}else{if(Xd){fe=ea(ea(g[Xc>>2])-ba);de=ea(ea(g[Yc>>2])-da);ee=ea(ea(g[Zc>>2])-ca);be=ea(g[Rc>>2]);ja=ea(fe-be);he=ea(g[Sc>>2]);ge=ea(de-he);xe=ea(g[Tc>>2]);_=ea(ee-xe);ka=ea(fe+be);be=ea(de+he);he=ea(ee+xe);if(!$d)Le=0;else{xe=ea(ea(ja+ka)*ea(.5));ee=ea(ea(ge+be)*ea(.5));de=ea(ea(_+he)*ea(.5));fe=ea(ea(ka-ja)*ea(.5));ja=ea(ea(be-ge)*ea(.5));ge=ea(ea(he-_)*ea(.5));Zd=0;je=0;while(1){re=c[ke+(Zd<<2)>>2]|0;rQa(s,K,re,x,0,0);g[x>>2]=ea(ea(g[x>>2])-ba);g[zd>>2]=ea(ea(g[zd>>2])-da);g[Ad>>2]=ea(ea(g[Ad>>2])-ca);g[Bd>>2]=ea(ea(g[Bd>>2])-ba);g[Cd>>2]=ea(ea(g[Cd>>2])-da);g[Dd>>2]=ea(ea(g[Dd>>2])-ca);g[Ed>>2]=ea(ea(g[Ed>>2])-ba);g[Fd>>2]=ea(ea(g[Fd>>2])-da);g[Gd>>2]=ea(ea(g[Gd>>2])-ca);_=ea(g[mb>>2]);c[r>>2]=0;c[Hd>>2]=re;c[Id>>2]=k;c[Jd>>2]=l;g[Kd>>2]=xe;g[Ld>>2]=ee;g[Md>>2]=de;g[Nd>>2]=fe;g[Od>>2]=ja;g[Pd>>2]=ge;g[Qd>>2]=_;b[Rd>>1]=0;aUa(r,x,Bd,Ed);re=c[r>>2]|0;b[p>>1]=(e[p>>1]|0)+(e[Rd>>1]|0);me=re+je|0;Zd=Zd+1|0;if((Zd|0)==($d|0)){Le=me;break}else je=me}}c[_d>>2]=Le;He=Le;break}je=c[ab>>2]|0;bUa(k,je+$d|0);if($d){Zd=(c[k>>2]|0)+(je*36|0)|0;je=0;do{me=c[ke+(je<<2)>>2]|0;c[y>>2]=me;rQa(s,K,me,Zd,0,0);g[Zd>>2]=ea(ea(g[Zd>>2])-ba);re=Zd+4|0;g[re>>2]=ea(ea(g[re>>2])-da);re=Zd+8|0;g[re>>2]=ea(ea(g[re>>2])-ca);re=Zd+12|0;g[re>>2]=ea(ea(g[re>>2])-ba);re=Zd+16|0;g[re>>2]=ea(ea(g[re>>2])-da);re=Zd+20|0;g[re>>2]=ea(ea(g[re>>2])-ca);re=Zd+24|0;g[re>>2]=ea(ea(g[re>>2])-ba);re=Zd+28|0;g[re>>2]=ea(ea(g[re>>2])-da);re=Zd+32|0;Zd=Zd+36|0;g[re>>2]=ea(ea(g[re>>2])-ca);re=c[db>>2]|0;if((c[cb>>2]&2147483647)>>>0>re>>>0){le=(c[l>>2]|0)+(re<<2)|0;if(!le)Me=re;else{c[le>>2]=me;Me=c[db>>2]|0}c[db>>2]=Me+1}else cUa(l,y)|0;je=je+1|0}while((je|0)!=($d|0))}He=c[_d>>2]|0}while(0);fUa(He,c[Yd>>2]|0,c[k>>2]|0,M,aa,ce,ye,sc);rU(v);break a;break}case 1:{ca=ea(g[fa>>2]);da=ea(ca-ea(g[D>>2]));ca=ea(g[ga>>2]);ba=ea(ca-ea(g[X>>2]));ca=ea(g[ha>>2]);ge=ea(ca-ea(g[Y>>2]));ca=ea(T(ea(ea(ea(da*da)+ea(ba*ba))+ea(ge*ge))));ge=ea(+h[C>>3]);ba=ea(+h[j>>3]);da=ea(+h[V>>3]);ja=ea(g[ua>>2]);fe=ea(ea(ja*ja)+ea(-.5));de=ea(g[K>>2]);ee=ea(de*ea(2.0));xe=ea(g[sa>>2]);_=ea(xe*ea(0.0));he=ea(ee+_);ee=ea(g[ta>>2]);be=ea(ee*ea(0.0));ka=ea(he+be);he=ea(ea(de*ka)+ea(ea(fe*ea(2.0))+ea(ja*ea(_-be))));be=ea(fe*ea(0.0));fe=ea(de*ea(0.0));de=ea(ea(xe*ka)+ea(be+ea(ja*ea(ea(ee*ea(2.0))-fe))));_=ea(ea(be+ea(ja*ea(fe-ea(xe*ea(2.0)))))+ea(ee*ka));ka=ea(ea(g[va>>2])*he);ee=ea(ka+ea(ea(g[wa>>2])*de));ka=ea(ea(0.0)-ea(ea(ea(g[xa>>2])*_)+ee));if(!(ea(S(ea(de)))>ea(.999899983))){ee=ea(de*ea(0.0));xe=ea(_-ee);fe=ea(ea(he*ea(0.0))-ea(_*ea(0.0)));ja=ea(ee-he);ee=ea(T(ea(ea(ja*ja)+ea(ea(xe*xe)+ea(fe*fe)))));if(ee>ea(0.0)){be=ea(ea(1.0)/ee);Ne=ea(ja*be);Oe=ea(fe*be);Pe=ea(xe*be)}else{Ne=ja;Oe=fe;Pe=xe}}else{Ne=ea(0.0);Oe=ea(0.0);Pe=ea(1.0)}xe=ea(ca*Pe);fe=ea(ca*Oe);ja=ea(ca*Ne);be=ea(ca*ea(ea(de*Ne)-ea(_*Oe)));ee=ea(ca*ea(ea(_*Pe)-ea(he*Ne)));$=ea(ca*ea(ea(he*Oe)-ea(de*Pe)));ca=ea(ea(ea(da*_)+ea(ea(ge*he)+ea(ba*de)))+ka);ka=ea(ge-ea(he*ca));he=ea(ba-ea(de*ca));de=ea(da-ea(_*ca));ca=ea(ka-xe);_=ea(he-fe);Ce=ea(de-ja);De=ea(ca+be);Be=ea(_+ee);ze=ea(Ce+$);Ae=ea(ca-be);ca=ea(_-ee);_=ea(Ce-$);Ce=ea(ka+xe);xe=ea(he+fe);fe=ea(de+ja);ja=ea(Ce-be);de=ea(xe-ee);he=ea(fe-$);ka=ea(Ce+be);be=ea(xe+ee);ee=ea(fe+$);$=ea(-ge);fe=ea(-ba);xe=ea(-da);_d=c[za>>2]|0;YTa(m,_d+12|0);$d=c[m>>2]|0;c[$d+(_d<<2)>>2]=2;c[$d+(_d+1<<2)>>2]=Ud;c[$d+(_d+2<<2)>>2]=Vd;ke=$d+(_d+4<<2)|0;c[ke+0>>2]=c[C+0>>2];c[ke+4>>2]=c[C+4>>2];c[ke+8>>2]=c[C+8>>2];c[ke+12>>2]=c[C+12>>2];c[ke+16>>2]=c[C+16>>2];c[ke+20>>2]=c[C+20>>2];ke=$d+(_d+10<<2)|0;c[ke>>2]=2;Xd=$d+(_d+11<<2)|0;c[Xd>>2]=c[ab>>2];_d=c[ab>>2]|0;bUa(k,_d+2|0);$d=c[k>>2]|0;c[r>>2]=0;Wd=c[db>>2]|0;if((c[cb>>2]&2147483647)>>>0>Wd>>>0){je=(c[l>>2]|0)+(Wd<<2)|0;if(!je)Qe=Wd;else{c[je>>2]=0;Qe=c[db>>2]|0}je=Qe+1|0;c[db>>2]=je;Re=je}else{cUa(l,r)|0;Re=c[db>>2]|0}c[s>>2]=1;if((c[cb>>2]&2147483647)>>>0>Re>>>0){je=(c[l>>2]|0)+(Re<<2)|0;if(!je)Se=Re;else{c[je>>2]=1;Se=c[db>>2]|0}c[db>>2]=Se+1}else cUa(l,s)|0;Ce=ea(De-ge);De=ea(Be-ba);Be=ea(ze-da);g[$d+(_d*36|0)>>2]=Ce;g[$d+(_d*36|0)+4>>2]=De;g[$d+(_d*36|0)+8>>2]=Be;ze=ea(ca-ba);ca=ea(_-da);g[$d+(_d*36|0)+12>>2]=ea(Ae-ge);g[$d+(_d*36|0)+16>>2]=ze;g[$d+(_d*36|0)+20>>2]=ca;ca=ea(ja-ge);ja=ea(de-ba);de=ea(he-da);g[$d+(_d*36|0)+24>>2]=ca;g[$d+(_d*36|0)+28>>2]=ja;g[$d+(_d*36|0)+32>>2]=de;je=_d+1|0;g[$d+(je*36|0)>>2]=Ce;g[$d+(je*36|0)+4>>2]=De;g[$d+(je*36|0)+8>>2]=Be;g[$d+(je*36|0)+12>>2]=ca;g[$d+(je*36|0)+16>>2]=ja;g[$d+(je*36|0)+20>>2]=de;de=ea(be-ba);ba=ea(ee-da);g[$d+(je*36|0)+24>>2]=ea(ka-ge);g[$d+(je*36|0)+28>>2]=de;g[$d+(je*36|0)+32>>2]=ba;fUa(c[ke>>2]|0,c[Xd>>2]|0,c[k>>2]|0,M,$,fe,xe,sc);break a;break}case 4:{gUa(Ud,Vd,K,m,k,l,C,D,o,M,p);break a;break}default:break a}}}while(0);G=G+1|0}while((G|0)!=(W|0));i=q;return}function HS(a,b,e,f){a=a|0;b=b|0;e=e|0;f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+80|0;j=h;k=h+72|0;l=c[a>>2]|0;c[j>>2]=mo[c[(c[l>>2]|0)+20>>2]&4095](l)|0;a=j+8|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];g[j+32>>2]=ea(g[b+24>>2]);g[j+36>>2]=ea(g[b+28>>2]);g[j+40>>2]=ea(g[b+32>>2]);g[j+44>>2]=ea(g[e>>2]);g[j+48>>2]=ea(g[e+4>>2]);g[j+52>>2]=ea(g[e+8>>2]);g[j+56>>2]=f;e=c[b+48>>2]|0;a=j+60|0;c[a>>2]=c[e+4>>2];m=j+64|0;c[m>>2]=c[e+8>>2];c[j+68>>2]=c[b+44>>2];b=c[l+72>>2]|0;if(b)In[c[c[b>>2]>>2]&4095](b,j);j=c[l+76>>2]|0;if(!j){n=0;i=h;return n|0}Dn[c[c[j>>2]>>2]&511](k,j,c[a>>2]|0,c[m>>2]|0);n=d[k>>0]|0;i=h;return n|0}function IS(a,b,e,f){a=a|0;b=b|0;e=e|0;f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+208|0;j=h+194|0;k=h+193|0;l=h+128|0;m=h+192|0;n=h+64|0;o=h;p=c[a>>2]|0;q=c[(c[b+48>>2]|0)+4>>2]|0;r=q&65535;s=q>>>16;if((r|0)==2){c[o>>2]=mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0;q=o+8|0;c[q+0>>2]=c[b+0>>2];c[q+4>>2]=c[b+4>>2];c[q+8>>2]=c[b+8>>2];c[q+12>>2]=c[b+12>>2];c[q+16>>2]=c[b+16>>2];c[q+20>>2]=c[b+20>>2];g[o+32>>2]=ea(g[b+24>>2]);g[o+36>>2]=ea(g[b+28>>2]);g[o+40>>2]=ea(g[b+32>>2]);g[o+44>>2]=ea(g[e>>2]);g[o+48>>2]=ea(g[e+4>>2]);g[o+52>>2]=ea(g[e+8>>2]);g[o+56>>2]=f;q=c[(c[a+4>>2]|0)+16>>2]|0;t=q+(s<<6)+8|0;u=c[q+(s<<6)>>2]|0;c[o+60>>2]=c[q+(s<<6)+12>>2];c[a+8>>2]=t;c[a+12>>2]=u;u=c[p+72>>2]|0;if(u)In[c[(c[u>>2]|0)+8>>2]&4095](u,o);o=c[p+76>>2]|0;if(!o){v=0;i=h;return v|0}co[c[(c[o>>2]|0)+8>>2]&2047](k,o,t);v=d[k>>0]|0;i=h;return v|0}else if(!r){k=c[(RS(c[p+464>>2]|0)|0)+(s<<2)>>2]|0;c[l>>2]=mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0;t=l+8|0;c[t+0>>2]=c[b+0>>2];c[t+4>>2]=c[b+4>>2];c[t+8>>2]=c[b+8>>2];c[t+12>>2]=c[b+12>>2];c[t+16>>2]=c[b+16>>2];c[t+20>>2]=c[b+20>>2];g[l+32>>2]=ea(g[b+24>>2]);g[l+36>>2]=ea(g[b+28>>2]);g[l+40>>2]=ea(g[b+32>>2]);g[l+44>>2]=ea(g[e>>2]);g[l+48>>2]=ea(g[e+4>>2]);g[l+52>>2]=ea(g[e+8>>2]);g[l+56>>2]=f;t=l+60|0;c[t>>2]=mo[c[(c[k>>2]|0)+20>>2]&4095](k)|0;k=c[p+72>>2]|0;if(k)In[c[(c[k>>2]|0)+4>>2]&4095](k,l);l=c[p+76>>2]|0;if(!l){v=0;i=h;return v|0}co[c[(c[l>>2]|0)+4>>2]&2047](m,l,c[t>>2]|0);v=d[m>>0]|0;i=h;return v|0}else if((r|0)==1){c[n>>2]=mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0;r=n+8|0;c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];c[r+16>>2]=c[b+16>>2];c[r+20>>2]=c[b+20>>2];g[n+32>>2]=ea(g[b+24>>2]);g[n+36>>2]=ea(g[b+28>>2]);g[n+40>>2]=ea(g[b+32>>2]);g[n+44>>2]=ea(g[e>>2]);g[n+48>>2]=ea(g[e+4>>2]);g[n+52>>2]=ea(g[e+8>>2]);g[n+56>>2]=f;e=c[(c[a+4>>2]|0)+4>>2]|0;b=e+(s*72|0)+8|0;r=c[e+(s*72|0)>>2]|0;c[n+60>>2]=c[e+(s*72|0)+12>>2];c[a+8>>2]=b;c[a+12>>2]=r;r=c[p+72>>2]|0;if(r)In[c[(c[r>>2]|0)+8>>2]&4095](r,n);n=c[p+76>>2]|0;if(!n){v=0;i=h;return v|0}co[c[(c[n>>2]|0)+8>>2]&2047](j,n,b);v=d[j>>0]|0;i=h;return v|0}else{v=0;i=h;return v|0}return 0}function JS(a){a=a|0;var b=0;b=i;i=i+16|0;KS(a);VJa(b,a);i=b;return}function KS(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=420568;d=a+8|0;e=c[d>>2]|0;if(e){ko[c[(c[e>>2]|0)+4>>2]&4095](e);c[d>>2]=0}d=c[a+124>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+116>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+76|0;e=c[d>>2]|0;if(e)VJa(d,e);e=c[a+72>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+64>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+60>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+52>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+48>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+40>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+36>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+28>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+24>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=b;return}e=c[a+16>>2]|0;if(!e){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,e);i=b;return}function LS(a){a=a|0;var b=0,d=0,e=0;b=i;if(mo[c[(c[a>>2]|0)+8>>2]&4095](a)|0)do MS(a,_n[c[(c[a>>2]|0)+12>>2]&4095](a,0)|0);while((mo[c[(c[a>>2]|0)+8>>2]&4095](a)|0)!=0);if(mo[c[(c[a>>2]|0)+36>>2]&4095](a)|0){d=a+116|0;do{e=c[c[d>>2]>>2]|0;ko[c[(c[e>>2]|0)+8>>2]&4095](e)}while((mo[c[(c[a>>2]|0)+36>>2]&4095](a)|0)!=0)}if(!a){hKa();i=b;return}ko[c[(c[a>>2]|0)+76>>2]&4095](a);hKa();i=b;return}function MS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=a+68|0;a:do if(c[f>>2]|0){g=a+64|0;h=0;while(1){j=c[(c[g>>2]|0)+(h<<2)>>2]|0;k=(mo[c[(c[j>>2]|0)+20>>2]&4095](j)|0)==(b|0);j=h+1|0;l=c[f>>2]|0;if(k)break;if(j>>>0<l>>>0)h=j;else break a}j=l+-1|0;c[f>>2]=j;k=c[g>>2]|0;c[k+(h<<2)>>2]=c[k+(j<<2)>>2]}while(0);c[e>>2]=0;f=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;kn[c[(c[f>>2]|0)+108>>2]&511](f,e,1,0)|0;f=c[a+96>>2]|0;b:do if((f|0)!=0?(l=c[e>>2]|0,j=l,k=j+~(j<<15)|0,j=(k>>>10^k)*9|0,k=j>>>6^j,j=k+~(k<<11)|0,k=(c[a+88>>2]|0)+(((j>>>16^j)&f+-1)<<2)|0,j=c[k>>2]|0,(j|0)!=-1):0){m=c[a+80>>2]|0;n=a+84|0;o=j;j=k;while(1){if((c[m+(o<<2)>>2]|0)==(l|0))break;k=(c[n>>2]|0)+(o<<2)|0;p=c[k>>2]|0;if((p|0)==-1)break b;else{o=p;j=k}}if((o|0)!=-1){l=(c[n>>2]|0)+(o<<2)|0;c[j>>2]=c[l>>2];m=a+112|0;c[m>>2]=(c[m>>2]|0)+-1;m=a+108|0;c[m>>2]=(c[m>>2]|0)+1;m=a+104|0;c[l>>2]=c[m>>2];c[m>>2]=o}}while(0);if((mo[c[(c[b>>2]|0)+8>>2]&4095](b)|0)==1){if(!b){i=d;return}ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=d;return}else{if((mo[c[(c[b>>2]|0)+8>>2]&4095](b)|0)!=0|(b|0)==0){i=d;return}ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=d;return}}function NS(a){a=a|0;return c[a+4>>2]|0}function OS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+8|0;a=c[d>>2]|0;if(a){e=a;i=b;return e|0}a=mKa()|0;f=c[(c[a>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](a,64,h?422048:544544,420648,92)|0;c[g>>2]=422368;h=g+4|0;a=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(a|0));c[d>>2]=g;e=g;i=b;return e|0}function PS(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+12>>2]=c[b>>2];if(c[b>>2]|0){i=d;return}b=a+8|0;a=c[b>>2]|0;if(!a){i=d;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);c[b>>2]=0;i=d;return}function QS(a){a=a|0;return c[a+68>>2]|0}function RS(a){a=a|0;return c[a+64>>2]|0}function SS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;if((c[a+68>>2]|0)>>>0>b>>>0){e=c[(c[a+64>>2]|0)+(b<<2)>>2]|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;i=d;return f|0}else{dKa(bKa()|0,4,420648,125,420760,d);f=0;i=d;return f|0}return 0}function TS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;if(!(mo[c[(c[d>>2]|0)+8>>2]&4095](d)|0)){j=0;i=e;return j|0}c[g>>2]=0;k=c[d+4>>2]|0;if((k|0)==1){l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,512,o?421784:544544,420648,149)|0;o=b+4|0;l=c[o>>2]|0;m=mo[c[(c[l>>2]|0)+28>>2]&4095](l)|0;ZR(n,d,m,c[o>>2]|0);if(!n){p=n;q=0}else{p=n;q=n+8|0}}else if(!k){k=mKa()|0;n=c[(c[k>>2]|0)+8>>2]|0;o=pKa()|0;m=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;o=Bn[n&255](k,512,m?421920:544544,420648,143)|0;m=b+4|0;k=c[m>>2]|0;n=mo[c[(c[k>>2]|0)+28>>2]&4095](k)|0;HR(o,d,n,c[m>>2]|0);if(!o){p=o;q=0}else{p=o;q=o+8|0}}else{j=0;i=e;return j|0}c[g>>2]=q;if(!q){j=p;i=e;return j|0}o=b+64|0;m=b+68|0;n=c[m>>2]|0;if((c[b+72>>2]&2147483647)>>>0>n>>>0){d=(c[o>>2]|0)+(n<<2)|0;if(d)c[d>>2]=q;c[m>>2]=n+1;r=q}else{iUa(o,g)|0;r=c[g>>2]|0}c[r+464>>2]=b;c[h>>2]=0;r=mo[c[(c[p>>2]|0)+36>>2]&4095](p)|0;kn[c[(c[r>>2]|0)+108>>2]&511](r,h,1,0)|0;r=jUa(b+76|0,h,f)|0;if((a[f>>0]|0)!=0|(r|0)==0){j=p;i=e;return j|0}c[r>>2]=c[h>>2];j=p;i=e;return j|0}function US(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+68|0;if(!(c[d>>2]|0)){i=b;return}e=a+64|0;do{f=c[c[e>>2]>>2]|0;MS(a,mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0)}while((c[d>>2]|0)!=0);i=b;return}function VS(a){a=a|0;return c[a+120>>2]|0}function WS(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;if((c[a+120>>2]|0)>>>0>b>>>0){e=c[(c[a+116>>2]|0)+(b<<2)>>2]|0;i=d;return e|0}else{dKa(bKa()|0,4,420648,215,420824,d);e=0;i=d;return e|0}return 0}function XS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,60,h?421528:544544,420648,225)|0;vT(g,a);c[d>>2]=g;h=a+116|0;e=a+120|0;f=c[e>>2]|0;if((c[a+124>>2]&2147483647)>>>0<=f>>>0){kUa(h,d)|0;j=c[d>>2]|0;i=b;return j|0}d=(c[h>>2]|0)+(f<<2)|0;if(d)c[d>>2]=g;c[e>>2]=f+1;j=g;i=b;return j|0}function YS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+120|0;f=c[e>>2]|0;if(f){g=c[a+116>>2]|0;a=0;while(1){h=a+1|0;if((c[g+(a<<2)>>2]|0)==(b|0)){j=a;break}if(h>>>0<f>>>0)a=h;else{j=h;break}}if((j|0)!=(f|0)){a=f+-1|0;c[e>>2]=a;c[g+(j<<2)>>2]=c[g+(a<<2)>>2]}}if(!b){i=d;return}ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=d;return}function ZS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+68|0;if(!(c[e>>2]|0)){i=d;return}f=a+64|0;a=0;do{tS((c[(c[f>>2]|0)+(a<<2)>>2]|0)+88|0,b);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=d;return}function _S(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im;e=i;i=i+32|0;f=e+12|0;j=e;k=a+68|0;if(!(c[k>>2]|0)){i=e;return}l=a+64|0;a=f+4|0;m=f+8|0;n=j+4|0;o=j+8|0;p=0;do{q=c[(c[l>>2]|0)+(p<<2)>>2]|0;r=ea(+h[q+408>>3]);s=ea(+h[q+416>>3]);t=ea(+h[q+424>>3]);g[f>>2]=r;g[a>>2]=s;g[m>>2]=t;t=ea(-ea(g[q+28>>2]));s=ea(-ea(g[q+32>>2]));r=ea(-ea(g[q+36>>2]));g[j>>2]=t;g[n>>2]=s;g[o>>2]=r;uS(q+88|0,b,d,f,j,ea(Kn[c[(c[q>>2]|0)+12>>2]&255](q)));p=p+1|0}while(p>>>0<(c[k>>2]|0)>>>0);i=e;return}function $S(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im;e=i;i=i+32|0;f=e+12|0;j=e;k=a+68|0;if(!(c[k>>2]|0)){i=e;return}l=a+64|0;a=f+4|0;m=f+8|0;n=j+4|0;o=j+8|0;p=0;do{q=c[(c[l>>2]|0)+(p<<2)>>2]|0;r=ea(+h[q+408>>3]);s=ea(+h[q+416>>3]);t=ea(+h[q+424>>3]);g[f>>2]=r;g[a>>2]=s;g[m>>2]=t;t=ea(-ea(g[q+28>>2]));s=ea(-ea(g[q+32>>2]));r=ea(-ea(g[q+36>>2]));g[j>>2]=t;g[n>>2]=s;g[o>>2]=r;sS(q+88|0,b,d,f,j,ea(Kn[c[(c[q>>2]|0)+12>>2]&255](q)));p=p+1|0}while(p>>>0<(c[k>>2]|0)>>>0);i=e;return}function aT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+64|0;d=b;e=a+16|0;f=c[a+24>>2]&2147483647;do if(f){g=a+20|0;if((c[g>>2]|0)>>>0>f>>>1>>>0){c[g>>2]=0;break}else{c[d>>2]=0;lUa(e,0,d);mUa(e,c[g>>2]|0);break}}while(0);e=a+28|0;f=c[a+36>>2]&2147483647;do if(f){g=a+32|0;if((c[g>>2]|0)>>>0>f>>>1>>>0){c[g>>2]=0;break}else{nUa(e,0,d);oUa(e,c[g>>2]|0);break}}while(0);e=a+40|0;f=c[a+48>>2]&2147483647;do if(f){g=a+44|0;if((c[g>>2]|0)>>>0>f>>>1>>>0){c[g>>2]=0;break}else{c[d>>2]=0;lUa(e,0,d);mUa(e,c[g>>2]|0);break}}while(0);e=a+52|0;f=c[a+60>>2]&2147483647;if(!f){i=b;return}g=a+56|0;if((c[g>>2]|0)>>>0>f>>>1>>>0){c[g>>2]=0;i=b;return}else{f=d+0|0;a=f+56|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(a|0));pUa(e,0,d);qUa(e,c[g>>2]|0);i=b;return}}function bT(b,c,d){b=b|0;c=c|0;d=ea(d);a[b+132>>0]=c&1;g[b+128>>2]=d;return}function cT(b,c){b=b|0;c=c|0;a[b+133>>0]=c&1;return}function dT(b,c){b=b|0;c=c|0;a[b+134>>0]=c&1;return}function eT(b,c){b=b|0;c=c|0;a[b+135>>0]=c&1;return}function fT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im;d=i;i=i+16|0;e=d;f=a+68|0;if(c[f>>2]|0){h=a+64|0;j=0;do{nT(c[(c[h>>2]|0)+(j<<2)>>2]|0,b);j=j+1|0}while(j>>>0<(c[f>>2]|0)>>>0)}f=a+120|0;if(c[f>>2]|0){j=a+116|0;h=0;do{IT(c[(c[j>>2]|0)+(h<<2)>>2]|0,b);h=h+1|0}while(h>>>0<(c[f>>2]|0)>>>0)}f=c[a+8>>2]|0;if(!f){i=d;return}k=ea(-ea(g[b>>2]));l=ea(-ea(g[b+4>>2]));m=ea(-ea(g[b+8>>2]));g[e>>2]=k;g[e+4>>2]=l;g[e+8>>2]=m;rUa(f,e);i=d;return}function gT(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=0,Wb=0,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=0,bc=0,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=0,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=0,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=0,Qc=0,Rc=0,Sc=Im,Tc=Im,Uc=Im;e=i;i=i+688|0;f=e+336|0;j=e+456|0;k=e+524|0;l=e+576|0;m=e+56|0;n=e;o=e+560|0;p=e+672|0;q=e+504|0;r=e+572|0;s=e+636|0;t=e+444|0;u=e+280|0;v=e+112|0;w=e+648|0;x=e+660|0;y=e+520|0;z=e+432|0;A=e+396|0;B=e+384|0;C=e+168|0;D=e+224|0;E=e+508|0;F=e+492|0;G=e+684|0;H=c[a+68>>2]|0;I=a+64|0;a=c[I>>2]|0;J=H*24|0;K=UJa(e+685|0,J,420648,640)|0;if(!H)L=K;else{M=f+8|0;N=f+16|0;O=f+24|0;P=f+32|0;Q=f+40|0;R=K+J|0;J=a;a=H;H=K;while(1){a=a+-1|0;U=c[J>>2]|0;_n[c[(c[U>>2]|0)+16>>2]&4095](U,f)|0;V=ea(+h[f>>3]);W=ea(+h[M>>3]);X=ea(+h[N>>3]);Y=ea(+h[O>>3]);Z=ea(+h[P>>3]);_=ea(+h[Q>>3]);g[H>>2]=V;g[H+4>>2]=W;g[H+8>>2]=X;g[H+12>>2]=Y;g[H+16>>2]=Z;g[H+20>>2]=_;if(!a)break;else{J=J+4|0;H=H+24|0}}L=R}c[E>>2]=0;R=E+4|0;c[R>>2]=0;H=E+8|0;c[H>>2]=0;c[F>>2]=0;c[F+4>>2]=2;c[F+8>>2]=1;UKa(K,(L-K|0)/24|0,E,F)|0;F=(c[R>>2]|0)>>>1;if(F){R=(d|0)==0;L=C+8|0;J=C+16|0;a=C+36|0;Q=C+40|0;P=C+44|0;O=C+48|0;N=D+8|0;M=D+16|0;U=D+36|0;$=D+40|0;aa=D+44|0;ba=D+48|0;ca=f+4|0;da=f+8|0;fa=j+4|0;ga=k+4|0;ha=j+8|0;ia=k+8|0;ja=j+12|0;ka=k+12|0;la=j+16|0;ma=k+16|0;na=j+20|0;oa=k+20|0;pa=j+24|0;qa=k+24|0;ra=j+28|0;sa=k+28|0;ta=j+32|0;ua=k+32|0;va=C+24|0;wa=D+24|0;xa=wa+4|0;ya=wa+8|0;za=va+4|0;Aa=va+8|0;Ba=l+4|0;Ca=l+8|0;Da=l+12|0;Ea=l+16|0;Fa=l+20|0;_=ea(b*ea(4.0));Ga=m+48|0;Ha=n+48|0;Ia=m+8|0;Ja=m+16|0;Ka=o+4|0;La=o+8|0;Ma=m+24|0;Na=m+32|0;Oa=m+40|0;Pa=n+8|0;Qa=n+16|0;Ra=p+4|0;Sa=p+8|0;Ta=n+24|0;Ua=n+32|0;Va=n+40|0;Wa=s+4|0;Xa=s+8|0;Ya=t+4|0;Za=t+8|0;_a=v+8|0;$a=v+16|0;ab=w+4|0;bb=w+8|0;cb=v+24|0;db=v+32|0;eb=v+40|0;fb=x+4|0;gb=x+8|0;hb=u+36|0;ib=u+40|0;jb=u+44|0;kb=u+48|0;lb=A+4|0;mb=A+8|0;nb=A+12|0;ob=A+16|0;pb=A+20|0;qb=A+24|0;rb=A+28|0;sb=A+32|0;tb=u+8|0;ub=u+16|0;vb=B+4|0;wb=B+8|0;xb=u+24|0;yb=v+48|0;zb=F;F=c[E>>2]|0;do{zb=zb+-1|0;Ab=c[I>>2]|0;Bb=c[Ab+(c[F>>2]<<2)>>2]|0;Cb=c[Ab+(c[F+4>>2]<<2)>>2]|0;F=F+8|0;if(!(!R?(Ab=c[(c[d>>2]|0)+8>>2]|0,Db=mo[c[(c[Bb>>2]|0)+20>>2]&4095](Bb)|0,Eb=mo[c[(c[Cb>>2]|0)+20>>2]&4095](Cb)|0,!(xo[Ab&2047](d,Db,Eb)|0)):0))Fb=10;do if((Fb|0)==10){Fb=0;Eb=(c[Bb+4>>2]|0)>(c[Cb+4>>2]|0);Db=Eb?Cb:Bb;Ab=Eb?Bb:Cb;Eb=c[Db+4>>2]|0;if(!Eb)if((c[Ab+4>>2]|0)==1){if(!Db)Gb=0;else Gb=Db+-8|0;if(!Ab)Hb=0;else Hb=Ab+-8|0;XR(Gb,u);lS(Hb,v);b=ea(+h[v>>3]);Z=ea(+h[_a>>3]);Y=ea(+h[$a>>3]);g[w>>2]=b;g[ab>>2]=Z;g[bb>>2]=Y;Y=ea(+h[cb>>3]);Z=ea(+h[db>>3]);b=ea(+h[eb>>3]);g[x>>2]=Y;g[fb>>2]=Z;g[gb>>2]=b;b=ea(g[hb>>2]);Z=ea(g[ib>>2]);Y=ea(g[jb>>2]);X=ea(g[kb>>2]);W=ea(b+b);V=ea(Z+Z);Ib=ea(Y+Y);Jb=ea(b*W);b=ea(Z*V);Kb=ea(Y*Ib);Lb=ea(W*Z);Z=ea(W*Y);Mb=ea(W*X);W=ea(V*Y);Y=ea(V*X);V=ea(Ib*X);X=ea(Lb+V);Ib=ea(Z-Y);g[A>>2]=ea(ea(ea(1.0)-b)-Kb);g[lb>>2]=X;g[mb>>2]=Ib;Ib=ea(ea(1.0)-Jb);Jb=ea(Ib-Kb);Kb=ea(W+Mb);g[nb>>2]=ea(Lb-V);g[ob>>2]=Jb;g[pb>>2]=Kb;Kb=ea(W-Mb);Mb=ea(Ib-b);g[qb>>2]=ea(Z+Y);g[rb>>2]=Kb;g[sb>>2]=Mb;Mb=ea(+h[u>>3]);Kb=ea(+h[tb>>3]);Y=ea(+h[ub>>3]);g[B>>2]=Mb;g[vb>>2]=Kb;g[wb>>2]=Y;Y=ea(T(ea(LOa(w,x,B,xb,A,y,z))));Kb=ea(g[yb>>2]);if(!(Y<Kb))break;Mb=ea(g[B>>2]);Z=ea(g[vb>>2]);b=ea(g[wb>>2]);Ib=ea(g[w>>2]);W=ea(Ib+ea(g[x>>2]));Ib=ea(g[ab>>2]);Jb=ea(Ib+ea(g[fb>>2]));Ib=ea(g[bb>>2]);V=ea(W*ea(.5));W=ea(Jb*ea(.5));Jb=ea(ea(Ib+ea(g[gb>>2]))*ea(.5));Ib=ea(g[Db+332>>2]);Lb=ea(g[Db+336>>2]);X=ea(g[Db+340>>2]);Nb=ea(Mb-V);V=ea(Z-W);W=ea(b-Jb);Jb=ea(ea(ea(Nb*Ib)+ea(V*Lb))+ea(W*X));b=ea(Nb-ea(Ib*Jb));Ib=ea(V-ea(Lb*Jb));Lb=ea(W-ea(X*Jb));Jb=ea(ea(Lb*Lb)+ea(ea(b*b)+ea(Ib*Ib)));if(Jb>ea(0.0)){X=ea(ea(1.0)/ea(T(ea(Jb))));Ob=ea(Lb*X);Pb=ea(Ib*X);Qb=ea(b*X)}else{Ob=ea(0.0);Pb=ea(0.0);Qb=ea(0.0)}Rb=Qb;Sb=Pb;Tb=Ob;Ub=ea(Kb-Y)}else Fb=29;else if((Eb|0)==1?(c[Ab+4>>2]|0)==1:0){if(!Db)Vb=0;else Vb=Db+-8|0;if(!Ab)Wb=0;else Wb=Ab+-8|0;lS(Vb,m);lS(Wb,n);Y=ea(g[Ga>>2]);Kb=ea(Y+ea(g[Ha>>2]));Y=ea(+h[m>>3]);X=ea(+h[Ia>>3]);b=ea(+h[Ja>>3]);g[o>>2]=Y;g[Ka>>2]=X;g[La>>2]=b;Ib=ea(+h[Ma>>3]);Lb=ea(+h[Na>>3]);Jb=ea(+h[Oa>>3]);W=ea(+h[n>>3]);V=ea(+h[Pa>>3]);Nb=ea(+h[Qa>>3]);g[p>>2]=W;g[Ra>>2]=V;g[Sa>>2]=Nb;Z=ea(+h[Ta>>3]);Mb=ea(+h[Ua>>3]);Xb=ea(+h[Va>>3]);Yb=ea(Lb-X);X=ea(Jb-b);g[s>>2]=ea(Ib-Y);g[Wa>>2]=Yb;g[Xa>>2]=X;X=ea(Mb-V);V=ea(Xb-Nb);g[t>>2]=ea(Z-W);g[Ya>>2]=X;g[Za>>2]=V;V=ea(T(ea(MOa(o,s,p,t,q,r))));if(!(V<Kb))break;X=ea(g[q>>2]);W=ea(g[o>>2]);Nb=ea(g[Ka>>2]);Yb=ea(ea(1.0)-X);Y=ea(ea(X*W)+ea(Ib*Yb));Ib=ea(ea(Lb*Yb)+ea(X*Nb));Nb=ea(ea(Jb*Yb)+ea(X*ea(g[La>>2])));X=ea(g[r>>2]);Yb=ea(g[p>>2]);Jb=ea(g[Ra>>2]);Lb=ea(ea(1.0)-X);W=ea(ea(X*Yb)+ea(Z*Lb));Z=ea(ea(Mb*Lb)+ea(X*Jb));Jb=ea(ea(Xb*Lb)+ea(X*ea(g[Sa>>2])));X=ea(g[Db+332>>2]);Lb=ea(g[Db+336>>2]);Xb=ea(g[Db+340>>2]);Mb=ea(Y-W);W=ea(Ib-Z);Z=ea(Nb-Jb);Jb=ea(ea(ea(Mb*X)+ea(W*Lb))+ea(Z*Xb));Nb=ea(Mb-ea(X*Jb));X=ea(W-ea(Lb*Jb));Lb=ea(Z-ea(Xb*Jb));Jb=ea(ea(Lb*Lb)+ea(ea(Nb*Nb)+ea(X*X)));if(Jb>ea(0.0)){Xb=ea(ea(1.0)/ea(T(ea(Jb))));Zb=ea(Lb*Xb);_b=ea(X*Xb);$b=ea(Nb*Xb)}else{Zb=ea(0.0);_b=ea(0.0);$b=ea(0.0)}Rb=$b;Sb=_b;Tb=Zb;Ub=ea(Kb-V)}else Fb=29;if((Fb|0)==29){Fb=0;if(!Db)ac=0;else ac=Db+-8|0;if(!Ab)bc=0;else bc=Ab+-8|0;XR(ac,C);XR(bc,D);V=ea(+h[C>>3]);Kb=ea(+h[L>>3]);Xb=ea(+h[J>>3]);Nb=ea(g[a>>2]);X=ea(g[Q>>2]);Lb=ea(g[P>>2]);Jb=ea(g[O>>2]);Z=ea(Nb+Nb);W=ea(X+X);Mb=ea(Lb+Lb);Ib=ea(X*W);Y=ea(Lb*Mb);Yb=ea(Z*X);X=ea(Z*Lb);b=ea(Z*Jb);cc=ea(W*Lb);Lb=ea(W*Jb);W=ea(Mb*Jb);Jb=ea(ea(ea(1.0)-Ib)-Y);Mb=ea(Yb+W);dc=ea(X-Lb);ec=ea(Yb-W);W=ea(ea(1.0)-ea(Nb*Z));Z=ea(W-Y);Y=ea(cc+b);Nb=ea(X+Lb);Lb=ea(cc-b);b=ea(W-Ib);Ib=ea(+h[D>>3]);W=ea(+h[N>>3]);cc=ea(+h[M>>3]);X=ea(g[U>>2]);Yb=ea(g[$>>2]);fc=ea(g[aa>>2]);gc=ea(g[ba>>2]);hc=ea(X+X);ic=ea(Yb+Yb);jc=ea(fc+fc);kc=ea(Yb*ic);lc=ea(fc*jc);mc=ea(hc*Yb);Yb=ea(hc*fc);nc=ea(hc*gc);oc=ea(ic*fc);fc=ea(ic*gc);ic=ea(jc*gc);gc=ea(ea(ea(1.0)-kc)-lc);jc=ea(mc+ic);pc=ea(Yb-fc);qc=ea(mc-ic);ic=ea(ea(1.0)-ea(X*hc));hc=ea(ic-lc);lc=ea(oc+nc);X=ea(Yb+fc);fc=ea(oc-nc);nc=ea(ic-kc);kc=ea(Ib-V);V=ea(W-Kb);Kb=ea(cc-Xb);Xb=ea(ea(ea(Jb*kc)+ea(Mb*V))+ea(dc*Kb));cc=ea(ea(ea(ec*kc)+ea(Z*V))+ea(Y*Kb));W=ea(ea(ea(Nb*kc)+ea(Lb*V))+ea(b*Kb));g[f>>2]=Xb;g[ca>>2]=cc;g[da>>2]=W;Kb=ea(ea(dc*pc)+ea(ea(Jb*gc)+ea(Mb*jc)));g[j>>2]=Kb;V=ea(ea(S(ea(Kb)))+ea(9.99999997e-07));g[k>>2]=V;kc=ea(ea(dc*lc)+ea(ea(Jb*qc)+ea(Mb*hc)));g[fa>>2]=kc;Ib=ea(ea(S(ea(kc)))+ea(9.99999997e-07));g[ga>>2]=Ib;kc=ea(ea(dc*nc)+ea(ea(Jb*X)+ea(Mb*fc)));g[ha>>2]=kc;ic=ea(ea(S(ea(kc)))+ea(9.99999997e-07));g[ia>>2]=ic;kc=ea(ea(Y*pc)+ea(ea(ec*gc)+ea(Z*jc)));g[ja>>2]=kc;oc=ea(ea(S(ea(kc)))+ea(9.99999997e-07));g[ka>>2]=oc;Yb=ea(ea(Y*lc)+ea(ea(ec*qc)+ea(Z*hc)));g[la>>2]=Yb;g[ma>>2]=ea(ea(S(ea(Yb)))+ea(9.99999997e-07));Yb=ea(ea(Y*nc)+ea(ea(ec*X)+ea(Z*fc)));g[na>>2]=Yb;g[oa>>2]=ea(ea(S(ea(Yb)))+ea(9.99999997e-07));Yb=ea(ea(b*pc)+ea(ea(Nb*gc)+ea(Lb*jc)));g[pa>>2]=Yb;mc=ea(ea(S(ea(Yb)))+ea(9.99999997e-07));g[qa>>2]=mc;rc=ea(ea(b*lc)+ea(ea(Nb*qc)+ea(Lb*hc)));g[ra>>2]=rc;g[sa>>2]=ea(ea(S(ea(rc)))+ea(9.99999997e-07));rc=ea(ea(b*nc)+ea(ea(Nb*X)+ea(Lb*fc)));g[ta>>2]=rc;g[ua>>2]=ea(ea(S(ea(rc)))+ea(9.99999997e-07));rc=ea(g[wa>>2]);sc=ea(g[xa>>2]);tc=ea(g[ya>>2]);uc=ea(g[va>>2]);vc=ea(ea(uc+ea(ea(tc*ic)+ea(ea(sc*Ib)+ea(rc*V))))-ea(S(ea(Xb))));a:do if(vc<ea(0.0)){wc=0;xc=ea(0.0);yc=ea(0.0);zc=ea(0.0);Ac=ea(0.0)}else{Ib=vc;Eb=0;while(1){g[l+(Eb<<2)>>2]=Ib;Eb=Eb+1|0;if(Eb>>>0>=3)break;ic=ea(g[f+(Eb<<2)>>2]);Bc=ea(g[k+(Eb*12|0)+4>>2]);Cc=ea(g[k+(Eb*12|0)+8>>2]);Dc=ea(g[va+(Eb<<2)>>2]);Ib=ea(ea(Dc+ea(ea(tc*Cc)+ea(ea(sc*Bc)+ea(rc*ea(g[k+(Eb*12|0)>>2])))))-ea(S(ea(ic))));if(Ib<ea(0.0)){wc=0;xc=ea(0.0);yc=ea(0.0);zc=ea(0.0);Ac=ea(0.0);break a}}Ib=ea(g[za>>2]);ic=ea(g[Aa>>2]);Bc=V;Cc=oc;Dc=mc;Ec=Kb;Fc=kc;Gc=Yb;Hc=rc;Eb=0;while(1){Ic=ea(ea(Hc+ea(ea(ic*Dc)+ea(ea(Ib*Cc)+ea(uc*Bc))))-ea(S(ea(ea(W*Gc)+ea(ea(cc*Fc)+ea(Xb*Ec))))));if(Ic<ea(0.0)){wc=0;xc=ea(0.0);yc=ea(0.0);zc=ea(0.0);Ac=ea(0.0);break a}g[l+(Eb+3<<2)>>2]=Ic;Jc=Eb+1|0;if(Jc>>>0>=3)break;Ic=ea(g[wa+(Jc<<2)>>2]);Kc=ea(g[k+(Jc<<2)+12>>2]);Lc=ea(g[k+(Jc<<2)+24>>2]);Mc=ea(g[j+(Jc<<2)+12>>2]);Nc=ea(g[j+(Jc<<2)+24>>2]);Oc=ea(g[k+(Jc<<2)>>2]);Bc=Oc;Cc=Kc;Dc=Lc;Ec=ea(g[j+(Jc<<2)>>2]);Fc=Mc;Gc=Nc;Hc=Ic;Eb=Jc}Hc=ea(g[l>>2]);Gc=ea(g[Ba>>2]);Eb=Gc<Hc;Fc=Eb?Gc:Hc;Hc=ea(g[Ca>>2]);Jc=Hc<Fc;Gc=Jc?Hc:Fc;Fc=ea(g[Da>>2]);Pc=Fc<Gc;Hc=Pc?Fc:Gc;Gc=ea(g[Ea>>2]);Qc=Gc<Hc;Fc=Qc?Gc:Hc;Hc=ea(g[Fa>>2]);Rc=Hc<Fc;Gc=Rc?Hc:Fc;switch((Rc?5:Qc?4:Pc?3:Jc?2:Eb&1)|0){case 1:{wc=1;xc=ec;yc=Z;zc=Y;Ac=Gc;break a;break}case 2:{wc=1;xc=Nb;yc=Lb;zc=b;Ac=Gc;break a;break}case 3:{wc=1;xc=gc;yc=jc;zc=pc;Ac=Gc;break a;break}case 4:{wc=1;xc=qc;yc=hc;zc=lc;Ac=Gc;break a;break}case 5:{wc=1;xc=X;yc=fc;zc=nc;Ac=Gc;break a;break}default:{wc=1;xc=Jb;yc=Mb;zc=dc;Ac=Gc;break a}}}while(0);if(!wc)break;dc=ea(+h[C>>3]);Mb=ea(+h[L>>3]);Jb=ea(+h[J>>3]);nc=ea(+h[D>>3]);fc=ea(+h[N>>3]);if(ea(ea(ea(xc*ea(dc-nc))+ea(yc*ea(Mb-fc)))+ea(zc*ea(Jb-ea(+h[M>>3]))))<ea(0.0)){Sc=ea(-xc);Tc=ea(-yc);Uc=ea(-zc)}else{Sc=xc;Tc=yc;Uc=zc}Jb=ea(g[Db+332>>2]);fc=ea(g[Db+336>>2]);Mb=ea(g[Db+340>>2]);nc=ea(ea(ea(Sc*Jb)+ea(Tc*fc))+ea(Uc*Mb));dc=ea(Sc-ea(Jb*nc));Jb=ea(Tc-ea(fc*nc));fc=ea(Uc-ea(Mb*nc));nc=ea(ea(fc*fc)+ea(ea(dc*dc)+ea(Jb*Jb)));if(nc>ea(0.0)){Mb=ea(ea(1.0)/ea(T(ea(nc))));Rb=ea(dc*Mb);Sb=ea(Jb*Mb);Tb=ea(fc*Mb);Ub=Ac}else{Rb=ea(0.0);Sb=ea(0.0);Tb=ea(0.0);Ub=Ac}}if(Ub!=ea(0.0)){Mb=Ub>_?_:Ub;fc=ea(ea(Rb*Mb)*ea(.5));Jb=ea(ea(Sb*Mb)*ea(.5));dc=ea(ea(Tb*Mb)*ea(.5));Eb=Db+444|0;g[Eb>>2]=ea(fc+ea(g[Eb>>2]));Eb=Db+448|0;g[Eb>>2]=ea(Jb+ea(g[Eb>>2]));Eb=Db+452|0;g[Eb>>2]=ea(dc+ea(g[Eb>>2]));Eb=Ab+444|0;g[Eb>>2]=ea(ea(g[Eb>>2])-fc);Eb=Ab+448|0;g[Eb>>2]=ea(ea(g[Eb>>2])-Jb);Eb=Ab+452|0;g[Eb>>2]=ea(ea(g[Eb>>2])-dc)}}while(0)}while((zb|0)!=0)}VJa(G,K);K=c[H>>2]|0;if(!((K&2147483647|0)!=0&(K|0)>-1)){i=e;return}K=c[E>>2]|0;if(!K){i=e;return}E=mKa()|0;In[c[(c[E>>2]|0)+12>>2]&4095](E,K);i=e;return}function hT(b){b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;gKa();e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[f&255](e,136,j?420888:544544,420648,686)|0;c[h>>2]=420568;c[h+4>>2]=b;b=h+100|0;j=h+8|0;e=j+92|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(e|0));g[b>>2]=ea(.75);c[h+104>>2]=-1;c[h+108>>2]=0;c[h+112>>2]=0;hUa(h+76|0,64);c[h+116>>2]=0;c[h+120>>2]=0;c[h+124>>2]=0;g[h+128>>2]=ea(1.0);a[h+132>>0]=0;a[h+133>>0]=1;a[h+134>>0]=1;a[h+135>>0]=0;i=d;return h|0}function iT(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+48|0;j=h+16|0;k=h;l=h+32|0;c[d>>2]=422880;m=d+8|0;nS(m);oS(d+88|0);n=d+408|0;c[d+456>>2]=f;c[d+460>>2]=-1;o=d+464|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;b[o+20>>1]=0;c[d+4>>2]=2147483647;c[m>>2]=c[e+88>>2];m=e+44|0;g[d+40>>2]=ea(g[m>>2]);g[d+44>>2]=ea(g[e+56>>2]);g[d+48>>2]=ea(g[e+60>>2]);g[d+52>>2]=ea(g[e+48>>2]);g[d+56>>2]=ea(g[e+52>>2]);a[d+65>>0]=ea(g[m>>2])!=ea(0.0)&1;c[d+72>>2]=c[e+76>>2];c[d+76>>2]=c[e+84>>2];c[d+80>>2]=c[e+96>>2];c[d+400>>2]=0;m=e+8|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[n+16>>2]=c[m+16>>2];c[n+20>>2]=c[m+20>>2];g[d+476>>2]=ea(g[e+64>>2]);g[d+480>>2]=ea(g[e+68>>2]);g[d+376>>2]=ea(g[e+72>>2]);m=d+432|0;n=d+28|0;g[n>>2]=ea(0.0);o=d+32|0;g[o>>2]=ea(0.0);p=d+36|0;g[p>>2]=ea(0.0);q=e+32|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;m=e+36|0;if((ea(g[q>>2])==ea(0.0)?ea(g[m>>2])==ea(0.0):0)?ea(g[e+40>>2])==ea(0.0):0){r=c[f>>2]|0;s=r+28|0;t=c[s>>2]|0;u=mo[t&4095](f)|0;v=c[u>>2]|0;w=v+156|0;x=c[w>>2]|0;a[l>>0]=1;Dn[x&511](u,d,l,0);i=h;return}g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);sUa(j,k,q);g[d+12>>2]=ea(g[j>>2]);g[d+16>>2]=ea(g[j+4>>2]);g[d+20>>2]=ea(g[j+8>>2]);g[d+24>>2]=ea(g[j+12>>2]);g[n>>2]=ea(g[q>>2]);g[o>>2]=ea(g[m>>2]);g[p>>2]=ea(g[e+40>>2]);r=c[f>>2]|0;s=r+28|0;t=c[s>>2]|0;u=mo[t&4095](f)|0;v=c[u>>2]|0;w=v+156|0;x=c[w>>2]|0;a[l>>0]=1;Dn[x&511](u,d,l,0);i=h;return}function jT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0;c=i;i=i+32|0;d=c+16|0;e=c;f=a+28|0;h=ea(g[f>>2]);if(h==ea(g[b>>2])){j=a+32|0;h=ea(g[j>>2]);k=b+4|0;if(h==ea(g[k>>2])?(h=ea(g[a+36>>2]),h==ea(g[b+8>>2])):0){i=c;return}else{l=j;m=k}}else{l=a+32|0;m=b+4|0}g[e>>2]=ea(1.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);sUa(d,e,b);g[a+12>>2]=ea(g[d>>2]);g[a+16>>2]=ea(g[d+4>>2]);g[a+20>>2]=ea(g[d+8>>2]);g[a+24>>2]=ea(g[d+12>>2]);g[f>>2]=ea(g[b>>2]);g[l>>2]=ea(g[m>>2]);g[a+36>>2]=ea(g[b+8>>2]);i=c;return}function kT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[a>>2]=422880;e=c[a+456>>2]|0;if((e|0)!=0?(f=mo[c[(c[e>>2]|0)+28>>2]&4095](e)|0,In[c[(c[f>>2]|0)+160>>2]&4095](f,a),f=c[a+400>>2]|0,(f|0)!=0):0)ko[c[c[f>>2]>>2]&4095](f);pS(a+88|0);VJa(d,a);i=b;return}function lT(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=422880;d=c[a+456>>2]|0;if((d|0)!=0?(e=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0,In[c[(c[e>>2]|0)+160>>2]&4095](e,a),e=c[a+400>>2]|0,(e|0)!=0):0)ko[c[c[e>>2]>>2]&4095](e);pS(a+88|0);i=b;return}function mT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;rS(a+88|0,b);i=d;return}function nT(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0;c=i;d=+ea(g[b>>2]);e=a+408|0;h[e>>3]=+h[e>>3]-d;d=+ea(g[b+4>>2]);e=a+416|0;h[e>>3]=+h[e>>3]-d;d=+ea(g[b+8>>2]);e=a+424|0;h[e>>3]=+h[e>>3]-d;vS(a+88|0,b);i=c;return}function oT(a){a=a|0;var b=0,d=0;b=i;d=c[a+464>>2]|0;MS(d,mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0);i=b;return}function pT(b,e){b=b|0;e=e|0;var f=0;g[e>>2]=ea(g[b+432>>2]);g[e+4>>2]=ea(g[b+436>>2]);g[e+8>>2]=ea(g[b+440>>2]);c[e+12>>2]=c[b+244>>2];c[e+16>>2]=c[b+248>>2];c[e+20>>2]=c[b+240>>2];f=c[b+396>>2]|0;a[e+28>>0]=f>>>4&1;a[e+29>>0]=f>>>5&1;a[e+30>>0]=f>>>8&1;c[e+24>>2]=d[b+484>>0];return}function qT(a,c){a=a|0;c=c|0;b[c+2>>1]=b[a+388>>1]|0;b[c+4>>1]=b[a+390>>1]|0;b[c>>1]=b[a+394>>1]|0;b[c+6>>1]=b[a+392>>1]|0;return}function rT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=Im,l=Im,m=Im;d=i;i=i+32|0;e=d;f=a+408|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];b=a+400|0;j=c[b>>2]|0;if(!j){i=d;return 1}In[c[(c[j>>2]|0)+84>>2]&4095](e,j);k=ea(+h[f>>3]);l=ea(+h[a+416>>3]);m=ea(+h[a+424>>3]);g[e+16>>2]=k;g[e+20>>2]=l;g[e+24>>2]=m;g[e>>2]=ea(g[a+12>>2]);g[e+4>>2]=ea(g[a+16>>2]);g[e+8>>2]=ea(g[a+20>>2]);g[e+12>>2]=ea(g[a+24>>2]);a=c[b>>2]|0;In[c[(c[a>>2]|0)+224>>2]&4095](a,e);i=d;return 1}function sT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0;j=i;i=i+48|0;k=j+28|0;l=j+32|0;m=j;n=ea(+h[b+408>>3]);o=ea(+h[b+416>>3]);p=ea(+h[b+424>>3]);g[m+16>>2]=n;g[m+20>>2]=o;g[m+24>>2]=p;g[m>>2]=ea(g[b+12>>2]);g[m+4>>2]=ea(g[b+16>>2]);g[m+8>>2]=ea(g[b+20>>2]);g[m+12>>2]=ea(g[b+24>>2]);q=_n[c[(c[d>>2]|0)+108>>2]&4095](d,m)|0;m=b+400|0;c[m>>2]=q;if(!q){r=0;i=j;return r|0}c[k>>2]=f;f=c[(c[q>>2]|0)+92>>2]|0;a[l>>0]=11;Bn[f&255](q,e,k,1,l)|0;l=c[m>>2]|0;co[c[(c[l>>2]|0)+192>>2]&2047](l,1,1);mU(c[m>>2]|0,ea(g[b+476>>2]),0,0)|0;l=c[b+456>>2]|0;In[c[(c[l>>2]|0)+44>>2]&4095](l,c[m>>2]|0);r=1;i=j;return r|0}function tT(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=c[a+400>>2]|0;kn[c[(c[e>>2]|0)+108>>2]&511](e,d,1,0)|0;i=b;return c[d>>2]|0}function uT(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=a+24|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;if(h){l=b[(c[a+16>>2]|0)+(k<<1)>>1]|0;c[(c[a>>2]|0)+(k<<2)>>2]=d;c[j>>2]=k+1;m=l&65535;b[(c[a+12>>2]|0)+(m<<1)>>1]=k;c[g>>2]=h+-1;n=(e[(c[a+20>>2]|0)+(m<<1)>>1]|0)<<16|m;i=f;return n|0}m=a+8|0;if((k|0)==(c[m>>2]|0)){h=k<<1;g=h>>>0>65535?65535:h;c[m>>2]=g;h=UJa(f+7|0,g<<2,422904,92)|0;g=UJa(f,c[m>>2]<<1,422904,93)|0;l=UJa(f+3|0,c[m>>2]<<1,422904,94)|0;o=UJa(f+6|0,c[m>>2]<<1,422904,95)|0;YEi(h|0,c[a>>2]|0,c[j>>2]<<2|0)|0;p=a+12|0;YEi(g|0,c[p>>2]|0,c[j>>2]<<1|0)|0;q=a+16|0;YEi(l|0,c[q>>2]|0,c[j>>2]<<1|0)|0;r=a+20|0;YEi(o|0,c[r>>2]|0,c[j>>2]<<1|0)|0;s=c[j>>2]|0;PEi(g+(s<<1)|0,-1,(c[m>>2]|0)-s<<1|0)|0;s=c[j>>2]|0;PEi(l+(s<<1)|0,-1,(c[m>>2]|0)-s<<1|0)|0;s=c[j>>2]|0;PEi(o+(s<<1)|0,0,(c[m>>2]|0)-s<<1|0)|0;VJa(f+1|0,c[r>>2]|0);c[r>>2]=0;VJa(f+4|0,c[q>>2]|0);c[q>>2]=0;VJa(f+2|0,c[p>>2]|0);c[p>>2]=0;VJa(f+5|0,c[a>>2]|0);c[a>>2]=h;c[p>>2]=g;c[q>>2]=l;c[r>>2]=o;t=q;u=r;v=p;w=h;x=c[j>>2]|0}else{t=a+16|0;u=a+20|0;v=a+12|0;w=c[a>>2]|0;x=k}c[w+(x<<2)>>2]=d;d=x&65535;b[(c[v>>2]|0)+(x<<1)>>1]=d;b[(c[t>>2]|0)+(x<<1)>>1]=d;c[j>>2]=x+1;n=(e[(c[u>>2]|0)+(x<<1)>>1]|0)<<16|x;i=f;return n|0}function vT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;c[a>>2]=423016;e=a+4|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[a+32>>2]=0;c[a+52>>2]=0;e=a+36|0;c[e>>2]=2;c[a+28>>2]=UJa(d+3|0,8,422904,42)|0;f=a+40|0;c[f>>2]=UJa(d+2|0,c[e>>2]<<1,422904,43)|0;g=a+44|0;c[g>>2]=UJa(d+1|0,c[e>>2]<<1,422904,44)|0;h=a+48|0;c[h>>2]=UJa(d,c[e>>2]<<1,422904,45)|0;PEi(c[f>>2]|0,-1,c[e>>2]<<1|0)|0;PEi(c[g>>2]|0,-1,c[e>>2]<<1|0)|0;PEi(c[h>>2]|0,0,c[e>>2]<<1|0)|0;c[a+56>>2]=b;i=d;return}function wT(a){a=a|0;var b=0;b=i;i=i+16|0;xT(a);VJa(b,a);i=b;return}function xT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;c[a>>2]=423016;d=a+48|0;VJa(b+3|0,c[d>>2]|0);c[d>>2]=0;e=a+44|0;VJa(b+2|0,c[e>>2]|0);c[e>>2]=0;f=a+40|0;VJa(b+1|0,c[f>>2]|0);c[f>>2]=0;g=a+28|0;VJa(b,c[g>>2]|0);c[g>>2]=0;c[f>>2]=0;c[e>>2]=0;c[d>>2]=0;d=c[a+24>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+16>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+12>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+4>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function yT(a){a=a|0;var b=0;b=i;YS(c[a+56>>2]|0,a);i=b;return}function zT(a){a=a|0;return c[a+56>>2]|0}function AT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=0;d=i;i=i+144|0;e=d+64|0;f=d;h=c[b>>2]|0;if((h|0)==2){j=a+16|0;k=a+20|0;l=uT(a+28|0,c[k>>2]<<16|3)|0;c[f>>2]=l;m=f+8|0;c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];c[m+24>>2]=c[b+24>>2];c[m+28>>2]=c[b+28>>2];n=ea(g[b+32>>2]);g[f+40>>2]=n;o=ea(g[b+36>>2]);g[f+44>>2]=o;p=ea(g[b+40>>2]);g[f+48>>2]=p;q=ea(g[b+44>>2]);g[f+52>>2]=q;r=b+48|0;s=c[r>>2]|0;t=c[r+4>>2]|0;r=f+56|0;c[r>>2]=s;c[r+4>>2]=t;r=c[k>>2]|0;if((c[a+24>>2]&2147483647)>>>0>r>>>0){u=c[j>>2]|0;v=u+(r<<6)|0;if(!v)w=r;else{x=u+(r<<6)+8|0;c[x+0>>2]=c[m+0>>2];c[x+4>>2]=c[m+4>>2];c[x+8>>2]=c[m+8>>2];c[x+12>>2]=c[m+12>>2];c[x+16>>2]=c[m+16>>2];c[x+20>>2]=c[m+20>>2];c[x+24>>2]=c[m+24>>2];c[x+28>>2]=c[m+28>>2];g[u+(r<<6)+40>>2]=n;g[u+(r<<6)+44>>2]=o;g[u+(r<<6)+48>>2]=p;g[u+(r<<6)+52>>2]=q;m=u+(r<<6)+56|0;c[m>>2]=s;c[m+4>>2]=t;c[v>>2]=l;w=c[k>>2]|0}c[k>>2]=w+1}else uUa(j,f)|0;$S(c[a+56>>2]|0,l,a);y=l;i=d;return y|0}else if((h|0)==3){h=a+4|0;l=a+8|0;f=uT(a+28|0,c[l>>2]<<16|4)|0;c[e>>2]=f;j=e+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2];c[j+20>>2]=c[b+20>>2];c[j+24>>2]=c[b+24>>2];c[j+28>>2]=c[b+28>>2];q=ea(g[b+32>>2]);g[e+40>>2]=q;p=ea(g[b+36>>2]);g[e+44>>2]=p;o=ea(g[b+40>>2]);g[e+48>>2]=o;n=ea(g[b+44>>2]);g[e+52>>2]=n;z=ea(g[b+48>>2]);g[e+56>>2]=z;A=ea(g[b+52>>2]);g[e+60>>2]=A;B=ea(g[b+56>>2]);g[e+64>>2]=B;b=c[l>>2]|0;if((c[a+12>>2]&2147483647)>>>0>b>>>0){w=c[h>>2]|0;k=w+(b*72|0)|0;if(!k)C=b;else{v=w+(b*72|0)+8|0;c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];c[v+16>>2]=c[j+16>>2];c[v+20>>2]=c[j+20>>2];c[v+24>>2]=c[j+24>>2];c[v+28>>2]=c[j+28>>2];g[w+(b*72|0)+40>>2]=q;g[w+(b*72|0)+44>>2]=p;g[w+(b*72|0)+48>>2]=o;g[w+(b*72|0)+52>>2]=n;g[w+(b*72|0)+56>>2]=z;g[w+(b*72|0)+60>>2]=A;g[w+(b*72|0)+64>>2]=B;c[k>>2]=f;C=c[l>>2]|0}c[l>>2]=C+1}else tUa(h,e)|0;$S(c[a+56>>2]|0,f,a);y=f;i=d;return y|0}else{y=-1;i=d;return y|0}return 0}
function BT(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;h=d&65535;j=c[a+36>>2]|0;if(h>>>0>=j>>>0){k=0;i=f;return k|0}l=a+40|0;m=c[l>>2]|0;n=b[m+(h<<1)>>1]|0;o=n&65535;if(!(n<<16>>16!=-1&o>>>0<j>>>0)){k=0;i=f;return k|0}p=a+48|0;q=c[p>>2]|0;if((e[q+(h<<1)>>1]|0|0)!=(d>>>16|0)){k=0;i=f;return k|0}r=a+28|0;s=c[r>>2]|0;t=s+(o<<2)|0;u=c[t>>2]|0;if(!u){k=0;i=f;return k|0}v=u;w=v&65535;x=v>>>16;if((w|0)==4){v=a+8|0;y=c[v>>2]|0;if(x>>>0>=y>>>0){k=0;i=f;return k|0}z=a+32|0;A=c[z>>2]|0;if(!A){B=m;C=q}else{D=A+-1|0;c[z>>2]=D;c[t>>2]=c[s+(D<<2)>>2];z=c[a+44>>2]|0;A=z+(D<<1)|0;D=c[l>>2]|0;b[D+((e[A>>1]|0)<<1)>>1]=n;b[z+(o<<1)>>1]=b[A>>1]|0;b[A>>1]=d;b[D+(h<<1)>>1]=-1;A=a+52|0;c[A>>2]=(c[A>>2]|0)+1;A=c[p>>2]|0;z=A+(h<<1)|0;b[z>>1]=(b[z>>1]|0)+1<<16>>16;B=D;C=A}A=y+-1|0;y=a+4|0;if((((A|0)!=(x|0)?(D=c[(c[y>>2]|0)+(A*72|0)>>2]|0,z=D&65535,z>>>0<j>>>0):0)?(E=b[B+(z<<1)>>1]|0,B=E&65535,E<<16>>16!=-1&B>>>0<j>>>0):0)?(e[C+(z<<1)>>1]|0|0)==(D>>>16|0):0)c[(c[r>>2]|0)+(B<<2)>>2]=u;B=c[y>>2]|0;c[v>>2]=A;c[B+(x*72|0)>>2]=c[B+(A*72|0)>>2];v=B+(x*72|0)+8|0;y=B+(A*72|0)+8|0;c[v+0>>2]=c[y+0>>2];c[v+4>>2]=c[y+4>>2];c[v+8>>2]=c[y+8>>2];c[v+12>>2]=c[y+12>>2];c[v+16>>2]=c[y+16>>2];c[v+20>>2]=c[y+20>>2];c[v+24>>2]=c[y+24>>2];c[v+28>>2]=c[y+28>>2];g[B+(x*72|0)+40>>2]=ea(g[B+(A*72|0)+40>>2]);g[B+(x*72|0)+44>>2]=ea(g[B+(A*72|0)+44>>2]);g[B+(x*72|0)+48>>2]=ea(g[B+(A*72|0)+48>>2]);g[B+(x*72|0)+52>>2]=ea(g[B+(A*72|0)+52>>2]);g[B+(x*72|0)+56>>2]=ea(g[B+(A*72|0)+56>>2]);g[B+(x*72|0)+60>>2]=ea(g[B+(A*72|0)+60>>2]);g[B+(x*72|0)+64>>2]=ea(g[B+(A*72|0)+64>>2]);ZS(c[a+56>>2]|0,d);k=1;i=f;return k|0}else if((w|0)==3){w=a+20|0;A=c[w>>2]|0;if(x>>>0>=A>>>0){k=0;i=f;return k|0}B=a+32|0;y=c[B>>2]|0;if(!y){F=m;G=q}else{q=y+-1|0;c[B>>2]=q;c[t>>2]=c[s+(q<<2)>>2];s=c[a+44>>2]|0;t=s+(q<<1)|0;q=c[l>>2]|0;b[q+((e[t>>1]|0)<<1)>>1]=n;b[s+(o<<1)>>1]=b[t>>1]|0;b[t>>1]=d;b[q+(h<<1)>>1]=-1;t=a+52|0;c[t>>2]=(c[t>>2]|0)+1;t=c[p>>2]|0;p=t+(h<<1)|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;F=q;G=t}t=A+-1|0;A=a+16|0;if((((t|0)!=(x|0)?(q=c[(c[A>>2]|0)+(t<<6)>>2]|0,p=q&65535,p>>>0<j>>>0):0)?(h=b[F+(p<<1)>>1]|0,F=h&65535,h<<16>>16!=-1&F>>>0<j>>>0):0)?(e[G+(p<<1)>>1]|0|0)==(q>>>16|0):0)c[(c[r>>2]|0)+(F<<2)>>2]=u;u=c[A>>2]|0;c[w>>2]=t;c[u+(x<<6)>>2]=c[u+(t<<6)>>2];w=u+(x<<6)+8|0;A=u+(t<<6)+8|0;c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[w+16>>2]=c[A+16>>2];c[w+20>>2]=c[A+20>>2];c[w+24>>2]=c[A+24>>2];c[w+28>>2]=c[A+28>>2];g[u+(x<<6)+40>>2]=ea(g[u+(t<<6)+40>>2]);g[u+(x<<6)+44>>2]=ea(g[u+(t<<6)+44>>2]);g[u+(x<<6)+48>>2]=ea(g[u+(t<<6)+48>>2]);g[u+(x<<6)+52>>2]=ea(g[u+(t<<6)+52>>2]);A=u+(t<<6)+56|0;t=c[A+4>>2]|0;w=u+(x<<6)+56|0;c[w>>2]=c[A>>2];c[w+4>>2]=t;ZS(c[a+56>>2]|0,d);k=1;i=f;return k|0}else{k=0;i=f;return k|0}return 0}function CT(a,d,f){a=a|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=d&65535;k=c[a+36>>2]|0;if(j>>>0>=k>>>0){l=0;i=h;return l|0}m=b[(c[a+40>>2]|0)+(j<<1)>>1]|0;n=m&65535;if(!(m<<16>>16!=-1&n>>>0<k>>>0)){l=0;i=h;return l|0}if((e[(c[a+48>>2]|0)+(j<<1)>>1]|0|0)!=(d>>>16|0)){l=0;i=h;return l|0}j=c[(c[a+28>>2]|0)+(n<<2)>>2]|0;if(!j){l=0;i=h;return l|0}n=j;j=n&65535;if((j+-1|0)!=(c[f>>2]|0)){l=0;i=h;return l|0}k=n>>>16;if((j|0)==3){if(k>>>0>=(c[a+20>>2]|0)>>>0){l=0;i=h;return l|0}n=c[a+16>>2]|0;m=n+(k<<6)+8|0;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];c[m+16>>2]=c[f+16>>2];c[m+20>>2]=c[f+20>>2];c[m+24>>2]=c[f+24>>2];c[m+28>>2]=c[f+28>>2];g[n+(k<<6)+40>>2]=ea(g[f+32>>2]);g[n+(k<<6)+44>>2]=ea(g[f+36>>2]);g[n+(k<<6)+48>>2]=ea(g[f+40>>2]);g[n+(k<<6)+52>>2]=ea(g[f+44>>2]);m=f+48|0;o=c[m+4>>2]|0;p=n+(k<<6)+56|0;c[p>>2]=c[m>>2];c[p+4>>2]=o;_S(c[a+56>>2]|0,d,a);l=1;i=h;return l|0}else if((j|0)==4){if(k>>>0>=(c[a+8>>2]|0)>>>0){l=0;i=h;return l|0}j=c[a+4>>2]|0;o=j+(k*72|0)+8|0;c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];c[o+16>>2]=c[f+16>>2];c[o+20>>2]=c[f+20>>2];c[o+24>>2]=c[f+24>>2];c[o+28>>2]=c[f+28>>2];g[j+(k*72|0)+40>>2]=ea(g[f+32>>2]);g[j+(k*72|0)+44>>2]=ea(g[f+36>>2]);g[j+(k*72|0)+48>>2]=ea(g[f+40>>2]);g[j+(k*72|0)+52>>2]=ea(g[f+44>>2]);g[j+(k*72|0)+56>>2]=ea(g[f+48>>2]);g[j+(k*72|0)+60>>2]=ea(g[f+52>>2]);g[j+(k*72|0)+64>>2]=ea(g[f+56>>2]);_S(c[a+56>>2]|0,d,a);l=1;i=h;return l|0}else{l=0;i=h;return l|0}return 0}function DT(a){a=a|0;return (c[a+20>>2]|0)+(c[a+8>>2]|0)|0}function ET(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+8>>2]|0;if(e>>>0>b>>>0){f=(c[a+4>>2]|0)+(b*72|0)+8|0;i=d;return f|0}g=b-e|0;if(g>>>0>=(c[a+20>>2]|0)>>>0){f=0;i=d;return f|0}f=(c[a+16>>2]|0)+(g<<6)+8|0;i=d;return f|0}function FT(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=d&65535;h=c[a+36>>2]|0;do if(((g>>>0<h>>>0?(j=b[(c[a+40>>2]|0)+(g<<1)>>1]|0,k=j&65535,j<<16>>16!=-1&k>>>0<h>>>0):0)?(e[(c[a+48>>2]|0)+(g<<1)>>1]|0|0)==(d>>>16|0):0)?(j=c[(c[a+28>>2]|0)+(k<<2)>>2]|0,(j|0)!=0):0){k=j;j=k&65535;l=k>>>16;if((j|0)==3){if(l>>>0>=(c[a+20>>2]|0)>>>0){m=0;break}m=(c[a+16>>2]|0)+(l<<6)+8|0;break}else if((j|0)==4){if(l>>>0>=(c[a+8>>2]|0)>>>0){m=0;break}m=(c[a+4>>2]|0)+(l*72|0)+8|0;break}else{m=0;break}}else m=0;while(0);i=f;return m|0}function GT(a,d,e,f,j,k){a=a|0;d=d|0;e=e|0;f=f|0;j=ea(j);k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=0,ga=Im,ha=0,ia=0,ja=Im,ka=0;l=i;i=i+160|0;m=l+40|0;n=l+104|0;o=l+120|0;p=l+150|0;q=l+28|0;r=l;s=l+148|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=-1;t=m+12|0;b[t>>1]=0;u=m+16|0;v=m+40|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;g[v>>2]=ea(3402823469999999843913219.0e14);w=m+44|0;g[w>>2]=ea(0.0);g[m+48>>2]=ea(0.0);x=c[a+8>>2]|0;if(!x){y=ea(3402823469999999843913219.0e14);z=0}else{A=a+4|0;B=n+4|0;C=n+8|0;D=n+12|0;E=o+4|0;F=o+8|0;G=o+12|0;H=o+16|0;I=o+20|0;J=o+24|0;K=d+12|0;L=d+16|0;M=m+20|0;N=d+20|0;O=m+24|0;P=d+24|0;Q=m+28|0;R=d+28|0;S=m+32|0;T=d+32|0;U=m+36|0;V=d+36|0;W=d+40|0;X=d+44|0;Y=0;Z=ea(3402823469999999843913219.0e14);_=0;while(1){$=c[A>>2]|0;aa=c[(DMa()|0)+12>>2]|0;ba=ea(g[$+(Y*72|0)+56>>2]);ca=ea(g[$+(Y*72|0)+60>>2]);da=ea(g[$+(Y*72|0)+64>>2]);c[n>>2]=3;g[B>>2]=ba;g[C>>2]=ca;g[D>>2]=da;fa=$+(Y*72|0)+8|0;da=ea(+h[$+(Y*72|0)+16>>3]);ca=ea(+h[$+(Y*72|0)+24>>3]);ba=ea(+h[$+(Y*72|0)+32>>3]);g[o>>2]=ea(g[$+(Y*72|0)+40>>2]);g[E>>2]=ea(g[$+(Y*72|0)+44>>2]);g[F>>2]=ea(g[$+(Y*72|0)+48>>2]);g[G>>2]=ea(g[$+(Y*72|0)+52>>2]);g[H>>2]=da;g[I>>2]=ca;g[J>>2]=ba;b[p>>1]=4;if((po[aa&7](n,o,e,f,j,p,1,m,0,0,0)|0)!=0?(ba=ea(g[v>>2]),ba<Z):0){c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];b[K>>1]=b[t>>1]|0;g[L>>2]=ea(g[u>>2]);g[N>>2]=ea(g[M>>2]);g[P>>2]=ea(g[O>>2]);g[R>>2]=ea(g[Q>>2]);g[T>>2]=ea(g[S>>2]);g[V>>2]=ea(g[U>>2]);g[W>>2]=ba;c[X+0>>2]=c[w+0>>2];c[X+4>>2]=c[w+4>>2];c[X+8>>2]=c[w+8>>2];c[X+12>>2]=c[w+12>>2];c[X+16>>2]=c[w+16>>2];c[k>>2]=c[(c[A>>2]|0)+(Y*72|0)>>2];ga=ba;ha=fa}else{ga=Z;ha=_}Y=Y+1|0;if((Y|0)==(x|0)){y=ga;z=ha;break}else{Z=ga;_=ha}}}ha=c[a+20>>2]|0;if(!ha){ia=z;i=l;return ia|0}_=a+16|0;a=q+4|0;x=q+8|0;Y=r+4|0;A=r+8|0;X=r+12|0;W=r+16|0;U=r+20|0;V=r+24|0;S=d+12|0;T=d+16|0;Q=m+20|0;R=d+20|0;O=m+24|0;P=d+24|0;M=m+28|0;N=d+28|0;L=m+32|0;K=d+32|0;p=m+36|0;o=d+36|0;n=d+40|0;J=d+44|0;I=0;ga=y;H=z;while(1){z=c[_>>2]|0;G=c[(DMa()|0)+8>>2]|0;y=ea(g[z+(I<<6)+60>>2]);Z=ea(g[z+(I<<6)+56>>2]);c[q>>2]=2;g[a>>2]=y;g[x>>2]=Z;F=z+(I<<6)+8|0;Z=ea(+h[z+(I<<6)+16>>3]);y=ea(+h[z+(I<<6)+24>>3]);ba=ea(+h[z+(I<<6)+32>>3]);g[r>>2]=ea(g[z+(I<<6)+40>>2]);g[Y>>2]=ea(g[z+(I<<6)+44>>2]);g[A>>2]=ea(g[z+(I<<6)+48>>2]);g[X>>2]=ea(g[z+(I<<6)+52>>2]);g[W>>2]=Z;g[U>>2]=y;g[V>>2]=ba;b[s>>1]=4;if((po[G&7](q,r,e,f,j,s,1,m,0,0,0)|0)!=0?(ba=ea(g[v>>2]),ba<ga):0){c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];b[S>>1]=b[t>>1]|0;g[T>>2]=ea(g[u>>2]);g[R>>2]=ea(g[Q>>2]);g[P>>2]=ea(g[O>>2]);g[N>>2]=ea(g[M>>2]);g[K>>2]=ea(g[L>>2]);g[o>>2]=ea(g[p>>2]);g[n>>2]=ba;c[J+0>>2]=c[w+0>>2];c[J+4>>2]=c[w+4>>2];c[J+8>>2]=c[w+8>>2];c[J+12>>2]=c[w+12>>2];c[J+16>>2]=c[w+16>>2];c[k>>2]=c[(c[_>>2]|0)+(I<<6)>>2];ja=ba;ka=F}else{ja=ga;ka=H}I=I+1|0;if((I|0)==(ha|0)){ia=ka;break}else{ga=ja;H=ka}}i=l;return ia|0}function HT(a,d,f,j,k,l){a=a|0;d=d|0;f=f|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im;m=i;i=i+96|0;n=m+72|0;o=m+40|0;p=m+90|0;q=m+28|0;r=m;s=m+88|0;t=c[f>>2]|0;f=t&65535;u=c[a+36>>2]|0;if(f>>>0>=u>>>0){v=0;i=m;return v|0}w=b[(c[a+40>>2]|0)+(f<<1)>>1]|0;x=w&65535;if(!(w<<16>>16!=-1&x>>>0<u>>>0)){v=0;i=m;return v|0}if((e[(c[a+48>>2]|0)+(f<<1)>>1]|0|0)!=(t>>>16|0)){v=0;i=m;return v|0}t=c[(c[a+28>>2]|0)+(x<<2)>>2]|0;if(!t){v=0;i=m;return v|0}x=t;t=x>>>16;if((x&65535|0)==4){x=c[a+4>>2]|0;f=c[(DMa()|0)+12>>2]|0;y=ea(g[x+(t*72|0)+56>>2]);z=ea(g[x+(t*72|0)+60>>2]);A=ea(g[x+(t*72|0)+64>>2]);c[n>>2]=3;g[n+4>>2]=y;g[n+8>>2]=z;g[n+12>>2]=A;A=ea(+h[x+(t*72|0)+16>>3]);z=ea(+h[x+(t*72|0)+24>>3]);y=ea(+h[x+(t*72|0)+32>>3]);g[o>>2]=ea(g[x+(t*72|0)+40>>2]);g[o+4>>2]=ea(g[x+(t*72|0)+44>>2]);g[o+8>>2]=ea(g[x+(t*72|0)+48>>2]);g[o+12>>2]=ea(g[x+(t*72|0)+52>>2]);g[o+16>>2]=A;g[o+20>>2]=z;g[o+24>>2]=y;b[p>>1]=4;u=(po[f&7](n,o,j,k,l,p,1,d,0,0,0)|0)==0;i=m;return (u?0:x+(t*72|0)+8|0)|0}x=c[a+16>>2]|0;a=c[(DMa()|0)+8>>2]|0;y=ea(g[x+(t<<6)+60>>2]);z=ea(g[x+(t<<6)+56>>2]);c[q>>2]=2;g[q+4>>2]=y;g[q+8>>2]=z;z=ea(+h[x+(t<<6)+16>>3]);y=ea(+h[x+(t<<6)+24>>3]);A=ea(+h[x+(t<<6)+32>>3]);g[r>>2]=ea(g[x+(t<<6)+40>>2]);g[r+4>>2]=ea(g[x+(t<<6)+44>>2]);g[r+8>>2]=ea(g[x+(t<<6)+48>>2]);g[r+12>>2]=ea(g[x+(t<<6)+52>>2]);g[r+16>>2]=z;g[r+20>>2]=y;g[r+24>>2]=A;b[s>>1]=4;u=(po[a&7](q,r,j,k,l,s,1,d,0,0,0)|0)==0;v=u?0:x+(t<<6)+8|0;i=m;return v|0}function IT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0.0,k=0.0,l=0.0,m=0,n=0;d=i;e=c[a+8>>2]|0;if(e){f=c[a+4>>2]|0;j=+ea(g[b>>2]);k=+ea(g[b+4>>2]);l=+ea(g[b+8>>2]);m=0;do{n=f+(m*72|0)+16|0;h[n>>3]=+h[n>>3]-j;n=f+(m*72|0)+24|0;h[n>>3]=+h[n>>3]-k;n=f+(m*72|0)+32|0;h[n>>3]=+h[n>>3]-l;m=m+1|0}while(m>>>0<e>>>0)}e=c[a+20>>2]|0;if(!e){i=d;return}m=c[a+16>>2]|0;l=+ea(g[b>>2]);k=+ea(g[b+4>>2]);j=+ea(g[b+8>>2]);b=0;do{a=m+(b<<6)+16|0;h[a>>3]=+h[a>>3]-l;a=m+(b<<6)+24|0;h[a>>3]=+h[a>>3]-k;a=m+(b<<6)+32|0;h[a>>3]=+h[a>>3]-j;b=b+1|0}while(b>>>0<e>>>0);i=d;return}function JT(a){a=a|0;var b=0;b=i;RT(a);c[a>>2]=423424;c[a+36>>2]=0;i=b;return}function KT(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function LT(a){a=a|0;return}function MT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im;f=i;h=ea(g[a+44>>2]);j=ea(g[a+48>>2]);k=ea(ea(g[a+40>>2])*ea(2.0));l=ea(g[b+260>>2]);UT(c,h>j?h:j,k,l,ea(g[b+272>>2]),b+244|0,d,e);i=f;return}function NT(a){a=a|0;var b=0;b=i;RT(a);c[a>>2]=423448;c[a+36>>2]=1;i=b;return}function OT(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function PT(a){a=a|0;return}function QT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im;f=i;h=ea(g[a+40>>2]);j=ea(g[a+44>>2]);k=ea(g[b+260>>2]);UT(c,h,j,k,ea(g[b+272>>2]),b+244|0,d,e);i=f;return}function RT(a){a=a|0;c[a>>2]=423472;c[a+36>>2]=2;return}function ST(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function TT(a){a=a|0;return}function UT(a,b,c,d,e,f,j,k){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=f|0;j=j|0;k=k|0;var l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;l=i;m=ea(b+d);d=ea(c*ea(.5));c=ea(g[f>>2]);b=ea(m+ea(d*ea(S(ea(c)))));n=ea(g[f+4>>2]);o=ea(m+ea(d*ea(S(ea(n)))));p=ea(g[f+8>>2]);q=ea(m+ea(d*ea(S(ea(p)))));r=+h[j>>3];s=+h[j+8>>3];t=+h[j+16>>3];u=+b;v=r-u;w=+o;x=s-w;y=+q;z=t-y;A=u+r;B=w+s;C=t+y;D=r+ +ea(g[k>>2]);E=s+ +ea(g[k+4>>2]);F=t+ +ea(g[k+8>>2]);G=D-u;H=E-w;I=F-y;J=u+D;D=w+E;E=y+F;F=v>G?G:v;v=x>H?H:x;x=z>I?I:z;z=A<J?J:A;A=B<D?D:B;B=C<E?E:C;if(e!=ea(0.0)){C=r-+ea(c*e);r=s-+ea(n*e);s=t-+ea(p*e);t=C-u;E=r-w;D=s-y;J=u+C;C=w+r;r=y+s;s=F>t?t:F;t=v>E?E:v;E=x>D?D:x;D=z<J?J:z;J=A<C?C:A;if(B<r){K=s;L=t;M=E;N=D;O=J;P=r}else{K=s;L=t;M=E;N=D;O=J;P=B}}else{K=F;L=v;M=x;N=z;O=A;P=B}h[a>>3]=K;h[a+8>>3]=L;h[a+16>>3]=M;h[a+24>>3]=N;h[a+32>>3]=O;h[a+40>>3]=P;i=l;return}function VT(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=Im,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=0,tb=0,ub=0,vb=0,wb=0,xb=Im,yb=Im,zb=Im,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0;k=i;i=i+496|0;l=k;m=k+192|0;n=k+188|0;o=k+436|0;p=k+468|0;q=k+448|0;r=k+44|0;s=k+360|0;t=k+148|0;u=k+60|0;v=k+76|0;w=k+80|0;x=k+92|0;y=k+96|0;z=k+136|0;A=k+320|0;B=k+160|0;C=k+144|0;D=k+172|0;E=k+416|0;F=k+432|0;G=k+440|0;H=k+464|0;I=k+480|0;J=k+492|0;K=k+328|0;L=k+332|0;M=k+344|0;N=k+348|0;O=k+8|0;P=k+16|0;Q=k+24|0;R=k+380|0;U=k+384|0;V=k+388|0;W=k+392|0;X=k+396|0;Y=k+408|0;Z=k+32|0;_=k+72|0;$=k+368|0;aa=k+364|0;ba=k+412|0;ca=k+176|0;fa=k+56|0;ga=k+180|0;ha=k+428|0;ia=k+184|0;ja=c[f+8>>2]|0;do if(ja>>>0>=3){if(ja>>>0>65535?(b[f+48>>1]&2)!=0:0)break;ka=f+4|0;if((c[ka>>2]|0)!=0?(c[f>>2]|0)>>>0>=12:0){la=f+16|0;if(c[la>>2]|0){if((c[f+12>>2]|0)>>>0<4)break;if((c[f+20>>2]|0)!=(ja|0))break}ma=f+32|0;na=(c[ma>>2]|0)==0;if(na)if(!(c[f+44>>2]|0))break;else oa=13;else{if(!(c[f+28>>2]|0))break;if(!(c[f+44>>2]|0))pa=1;else oa=13}if((oa|0)==13)if(!(c[f+40>>2]|0))break;else pa=0;qa=f+48|0;ra=(b[qa>>1]&2)!=0?2:4;if(!na?(c[f+24>>2]|0)>>>0<(ra*3|0)>>>0:0)break;if(!pa?(c[f+36>>2]|0)>>>0<ra<<2>>>0:0)break;sa=ea(g[h>>2]);ta=ea(sa*sa);ra=h+4|0;ua=ea(g[ra>>2]);va=ea(ta+ea(ua*ua));na=h+8|0;ta=ea(g[na>>2]);wa=ea(va+ea(ta*ta));if(wa>ea(0.0)){va=ea(ea(1.0)/ea(T(ea(wa))));xa=ea(sa*va);ya=ea(ua*va);za=ea(ta*va)}else{xa=ea(0.0);ya=ea(0.0);za=ea(0.0)}g[h>>2]=xa;g[ra>>2]=ya;g[na>>2]=za;c[d>>2]=ja;c[p>>2]=0;Aa=p+4|0;c[Aa>>2]=0;Ba=p+8|0;c[Ba>>2]=0;if((ja|0)!=0?(vUa(p,ja),Ca=c[d>>2]|0,Da=c[f>>2]|0,Ea=c[f+12>>2]|0,(Ca|0)!=0):0){Fa=q+4|0;Ga=q+8|0;Ha=q+12|0;Ia=c[ka>>2]|0;ka=c[la>>2]|0;la=Ca;Ca=0;while(1){if(!ka){Ja=ea(1.0);Ka=0}else{Ja=ea(g[ka>>2]);Ka=ka+Ea|0}va=ea(g[Ia>>2]);g[q>>2]=va;ta=ea(g[Ia+4>>2]);g[Fa>>2]=ta;ua=ea(g[Ia+8>>2]);Ia=Ia+Da|0;g[Ga>>2]=ua;g[Ha>>2]=Ja;La=c[Aa>>2]|0;if((c[Ba>>2]&2147483647)>>>0>La>>>0){Ma=c[p>>2]|0;Na=Ma+(La<<4)|0;if(Na){g[Na>>2]=va;g[Ma+(La<<4)+4>>2]=ta;g[Ma+(La<<4)+8>>2]=ua;g[Ma+(La<<4)+12>>2]=Ja}c[Aa>>2]=La+1;Oa=la}else{wUa(p,q)|0;Oa=c[d>>2]|0}Ca=Ca+1|0;if(Ca>>>0>=Oa>>>0){Pa=Oa;break}else{ka=Ka;la=Oa}}}else Pa=0;c[s>>2]=0;c[r>>2]=0;la=r+4|0;c[la>>2]=0;ka=r+8|0;c[ka>>2]=0;xUa(r,Pa+1|0,s);c[t>>2]=0;Ca=t+4|0;c[Ca>>2]=0;Aa=t+8|0;c[Aa>>2]=0;Ha=f+24|0;Ga=f+36|0;if(!(b[qa>>1]&2)){Da=f+28|0;Ia=c[Ha>>2]|0;if(c[ma>>2]|0){Fa=c[r>>2]|0;Ea=c[Da>>2]|0;La=0;while(1){Ma=Fa+(c[Ea>>2]<<2)|0;c[Ma>>2]=(c[Ma>>2]|0)+2;Ma=Fa+(c[Ea+4>>2]<<2)|0;c[Ma>>2]=(c[Ma>>2]|0)+2;Ma=Fa+(c[Ea+8>>2]<<2)|0;c[Ma>>2]=(c[Ma>>2]|0)+2;La=La+1|0;if(La>>>0>=(c[ma>>2]|0)>>>0)break;else Ea=Ea+Ia|0}}Ia=f+40|0;Ea=c[Ga>>2]|0;La=f+44|0;if(!(c[La>>2]|0))Qa=c[r>>2]|0;else{Fa=c[r>>2]|0;qa=c[Ia>>2]|0;Ma=0;while(1){Na=Fa+(c[qa>>2]<<2)|0;c[Na>>2]=(c[Na>>2]|0)+2;Na=Fa+(c[qa+4>>2]<<2)|0;c[Na>>2]=(c[Na>>2]|0)+2;Na=Fa+(c[qa+8>>2]<<2)|0;c[Na>>2]=(c[Na>>2]|0)+2;Na=Fa+(c[qa+12>>2]<<2)|0;c[Na>>2]=(c[Na>>2]|0)+2;Ma=Ma+1|0;if(Ma>>>0>=(c[La>>2]|0)>>>0){Qa=Fa;break}else qa=qa+Ea|0}}Ea=c[la>>2]|0;qa=Qa+(Ea<<2)|0;if(Ea)if((Ea|0)==1){Ra=1;Sa=0}else{Ea=Qa+4|0;Fa=c[Qa>>2]|0;Ma=Qa;do{Ma=Ma+4|0;Fa=(c[Ea>>2]|0)+Fa|0;c[Ma>>2]=Fa;Ea=Ea+4|0}while((Ea|0)!=(qa|0));qa=c[la>>2]|0;Ra=qa;Sa=qa+-1|0}else{Ra=0;Sa=-1}qa=c[Qa+(Sa<<2)>>2]|0;c[n>>2]=0;xUa(t,qa,n);qa=c[Ha>>2]|0;if(c[ma>>2]|0){Ea=c[t>>2]|0;Fa=c[Da>>2]|0;Ma=0;while(1){Na=Fa+4|0;Ta=c[Na>>2]|0;Ua=Qa+(c[Fa>>2]<<2)|0;Va=(c[Ua>>2]|0)+-1|0;c[Ua>>2]=Va;c[Ea+(Va<<2)>>2]=Ta;Ta=Fa+8|0;Va=c[Ta>>2]|0;Ua=Qa+(c[Fa>>2]<<2)|0;Wa=(c[Ua>>2]|0)+-1|0;c[Ua>>2]=Wa;c[Ea+(Wa<<2)>>2]=Va;Va=c[Ta>>2]|0;Wa=Qa+(c[Na>>2]<<2)|0;Ua=(c[Wa>>2]|0)+-1|0;c[Wa>>2]=Ua;c[Ea+(Ua<<2)>>2]=Va;Va=c[Fa>>2]|0;Ua=Qa+(c[Na>>2]<<2)|0;Wa=(c[Ua>>2]|0)+-1|0;c[Ua>>2]=Wa;c[Ea+(Wa<<2)>>2]=Va;Va=c[Fa>>2]|0;Wa=Qa+(c[Ta>>2]<<2)|0;Ua=(c[Wa>>2]|0)+-1|0;c[Wa>>2]=Ua;c[Ea+(Ua<<2)>>2]=Va;Va=c[Na>>2]|0;Na=Qa+(c[Ta>>2]<<2)|0;Ta=(c[Na>>2]|0)+-1|0;c[Na>>2]=Ta;c[Ea+(Ta<<2)>>2]=Va;Ma=Ma+1|0;if(Ma>>>0>=(c[ma>>2]|0)>>>0)break;else Fa=Fa+qa|0}}qa=c[Ga>>2]|0;if(!(c[La>>2]|0)){Xa=Ra;Ya=Qa}else{Fa=c[t>>2]|0;Ma=c[Ia>>2]|0;Ea=0;while(1){Da=Ma+4|0;Va=c[Da>>2]|0;Ta=Qa+(c[Ma>>2]<<2)|0;Na=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Na;c[Fa+(Na<<2)>>2]=Va;Va=Ma+12|0;Na=c[Va>>2]|0;Ta=Qa+(c[Ma>>2]<<2)|0;Ua=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Ua;c[Fa+(Ua<<2)>>2]=Na;Na=Ma+8|0;Ua=c[Na>>2]|0;Ta=Qa+(c[Da>>2]<<2)|0;Wa=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Wa;c[Fa+(Wa<<2)>>2]=Ua;Ua=c[Ma>>2]|0;Wa=Qa+(c[Da>>2]<<2)|0;Ta=(c[Wa>>2]|0)+-1|0;c[Wa>>2]=Ta;c[Fa+(Ta<<2)>>2]=Ua;Ua=c[Va>>2]|0;Ta=Qa+(c[Na>>2]<<2)|0;Wa=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Wa;c[Fa+(Wa<<2)>>2]=Ua;Ua=c[Da>>2]|0;Da=Qa+(c[Na>>2]<<2)|0;Wa=(c[Da>>2]|0)+-1|0;c[Da>>2]=Wa;c[Fa+(Wa<<2)>>2]=Ua;Ua=c[Ma>>2]|0;Wa=Qa+(c[Va>>2]<<2)|0;Da=(c[Wa>>2]|0)+-1|0;c[Wa>>2]=Da;c[Fa+(Da<<2)>>2]=Ua;Ua=c[Na>>2]|0;Na=Qa+(c[Va>>2]<<2)|0;Va=(c[Na>>2]|0)+-1|0;c[Na>>2]=Va;c[Fa+(Va<<2)>>2]=Ua;Ea=Ea+1|0;if(Ea>>>0>=(c[La>>2]|0)>>>0){Xa=Ra;Ya=Qa;break}else Ma=Ma+qa|0}}}else{qa=f+28|0;Ma=c[Ha>>2]|0;if(c[ma>>2]|0){La=c[r>>2]|0;Ea=c[qa>>2]|0;Fa=0;while(1){Ia=La+(e[Ea>>1]<<2)|0;c[Ia>>2]=(c[Ia>>2]|0)+2;Ia=La+(e[Ea+2>>1]<<2)|0;c[Ia>>2]=(c[Ia>>2]|0)+2;Ia=La+(e[Ea+4>>1]<<2)|0;c[Ia>>2]=(c[Ia>>2]|0)+2;Fa=Fa+1|0;if(Fa>>>0>=(c[ma>>2]|0)>>>0)break;else Ea=Ea+Ma|0}}Ma=f+40|0;Ea=c[Ga>>2]|0;Fa=f+44|0;if(!(c[Fa>>2]|0))Za=c[r>>2]|0;else{La=c[r>>2]|0;Ia=c[Ma>>2]|0;Ua=0;while(1){Va=La+(e[Ia>>1]<<2)|0;c[Va>>2]=(c[Va>>2]|0)+2;Va=La+(e[Ia+2>>1]<<2)|0;c[Va>>2]=(c[Va>>2]|0)+2;Va=La+(e[Ia+4>>1]<<2)|0;c[Va>>2]=(c[Va>>2]|0)+2;Va=La+(e[Ia+6>>1]<<2)|0;c[Va>>2]=(c[Va>>2]|0)+2;Ua=Ua+1|0;if(Ua>>>0>=(c[Fa>>2]|0)>>>0){Za=La;break}else Ia=Ia+Ea|0}}Ea=c[la>>2]|0;Ia=Za+(Ea<<2)|0;if(Ea)if((Ea|0)==1){_a=1;$a=0}else{Ea=Za+4|0;La=c[Za>>2]|0;Ua=Za;do{Ua=Ua+4|0;La=(c[Ea>>2]|0)+La|0;c[Ua>>2]=La;Ea=Ea+4|0}while((Ea|0)!=(Ia|0));Ia=c[la>>2]|0;_a=Ia;$a=Ia+-1|0}else{_a=0;$a=-1}Ia=c[Za+($a<<2)>>2]|0;c[o>>2]=0;xUa(t,Ia,o);Ia=c[Ha>>2]|0;if(c[ma>>2]|0){Ea=c[t>>2]|0;La=c[qa>>2]|0;Ua=0;while(1){Va=e[La+2>>1]|0;Na=e[La>>1]|0;Da=Za+(Na<<2)|0;Wa=(c[Da>>2]|0)+-1|0;c[Da>>2]=Wa;c[Ea+(Wa<<2)>>2]=Va;Wa=e[La+4>>1]|0;Ta=(c[Da>>2]|0)+-1|0;c[Da>>2]=Ta;c[Ea+(Ta<<2)>>2]=Wa;Ta=Za+(Va<<2)|0;Da=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Da;c[Ea+(Da<<2)>>2]=Wa;Da=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Da;c[Ea+(Da<<2)>>2]=Na;Da=Za+(Wa<<2)|0;Wa=(c[Da>>2]|0)+-1|0;c[Da>>2]=Wa;c[Ea+(Wa<<2)>>2]=Na;Na=(c[Da>>2]|0)+-1|0;c[Da>>2]=Na;c[Ea+(Na<<2)>>2]=Va;Ua=Ua+1|0;if(Ua>>>0>=(c[ma>>2]|0)>>>0)break;else La=La+Ia|0}}Ia=c[Ga>>2]|0;if(!(c[Fa>>2]|0)){Xa=_a;Ya=Za}else{La=c[t>>2]|0;ma=c[Ma>>2]|0;Ua=0;while(1){Ea=e[ma+2>>1]|0;qa=e[ma>>1]|0;Ha=Za+(qa<<2)|0;Va=(c[Ha>>2]|0)+-1|0;c[Ha>>2]=Va;c[La+(Va<<2)>>2]=Ea;Va=e[ma+6>>1]|0;Na=(c[Ha>>2]|0)+-1|0;c[Ha>>2]=Na;c[La+(Na<<2)>>2]=Va;Na=e[ma+4>>1]|0;Ha=Za+(Ea<<2)|0;Da=(c[Ha>>2]|0)+-1|0;c[Ha>>2]=Da;c[La+(Da<<2)>>2]=Na;Da=(c[Ha>>2]|0)+-1|0;c[Ha>>2]=Da;c[La+(Da<<2)>>2]=qa;Da=Za+(Na<<2)|0;Ha=(c[Da>>2]|0)+-1|0;c[Da>>2]=Ha;c[La+(Ha<<2)>>2]=Va;Ha=(c[Da>>2]|0)+-1|0;c[Da>>2]=Ha;c[La+(Ha<<2)>>2]=Ea;Ea=Za+(Va<<2)|0;Va=(c[Ea>>2]|0)+-1|0;c[Ea>>2]=Va;c[La+(Va<<2)>>2]=qa;qa=(c[Ea>>2]|0)+-1|0;c[Ea>>2]=qa;c[La+(qa<<2)>>2]=Na;Ua=Ua+1|0;if(Ua>>>0>=(c[Fa>>2]|0)>>>0){Xa=_a;Ya=Za;break}else ma=ma+Ia|0}}}c[v>>2]=0;c[u>>2]=0;c[u+4>>2]=0;Ia=u+8|0;c[Ia>>2]=0;xUa(u,Xa,v);c[w>>2]=0;ma=w+4|0;c[ma>>2]=0;Fa=w+8|0;c[Fa>>2]=0;Ua=c[Ca>>2]|0;if(Ua)yUa(w,Ua);if(Xa>>>0>1){Ua=c[t>>2]|0;La=c[u>>2]|0;Ma=1;Ga=0;while(1){Na=Ya+(Ma<<2)|0;if(Ga>>>0<(c[Na>>2]|0)>>>0){qa=Ga;while(1){Ea=c[Ua+(qa<<2)>>2]|0;c[x>>2]=Ea;Va=La+(Ea<<2)|0;do if((c[Va>>2]|0)!=(Ma|0)){c[Va>>2]=Ma;Ha=c[ma>>2]|0;if((c[Fa>>2]&2147483647)>>>0<=Ha>>>0){cUa(w,x)|0;break}Da=(c[w>>2]|0)+(Ha<<2)|0;if(Da)c[Da>>2]=Ea;c[ma>>2]=Ha+1}while(0);Ea=qa+1|0;if(Ea>>>0<(c[Na>>2]|0)>>>0)qa=Ea;else{ab=Ea;break}}}else ab=Ga;c[Na>>2]=c[ma>>2];Ma=Ma+1|0;if(Ma>>>0>=(c[la>>2]|0)>>>0)break;else Ga=ab}}c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;c[y+20>>2]=0;g[y+24>>2]=ea(.75);c[y+28>>2]=-1;c[y+32>>2]=0;Ga=y+36|0;c[Ga>>2]=0;zUa(y,64);Ma=c[d>>2]|0;if(Ma){ma=c[p>>2]|0;La=c[w>>2]|0;Ua=z+4|0;Ca=A+4|0;qa=Ma;Ma=0;while(1){ua=ea(g[ma+(Ma<<4)+12>>2]);Ea=Ma;Ma=Ma+1|0;Va=c[Ya+(Ma<<2)>>2]|0;Ha=c[Ya+(Ea<<2)>>2]|0;if(Ha>>>0<Va>>>0){Da=ma+(Ea<<4)|0;Wa=ma+(Ea<<4)+4|0;Ta=ma+(Ea<<4)+8|0;bb=Ha;do{Ha=c[La+(bb<<2)>>2]|0;if(ea(ua+ea(g[ma+(Ha<<4)+12>>2]))>ea(0.0)){cb=Ea>>>0<Ha>>>0;c[z>>2]=cb?Ea:Ha;c[Ua>>2]=cb?Ha:Ea;cb=AUa(y,z)|0;g[cb>>2]=ea(ea(g[cb>>2])+ea(.100000001))}cb=c[Ya+(Ha+1<<2)>>2]|0;db=c[Ya+(Ha<<2)>>2]|0;if(db>>>0<cb>>>0){eb=ma+(Ha<<4)|0;fb=ma+(Ha<<4)+4|0;gb=ma+(Ha<<4)+8|0;Ha=db;do{db=c[La+(Ha<<2)>>2]|0;do if((db|0)!=(Ea|0)){if(!(ea(ua+ea(g[ma+(db<<4)+12>>2]))>ea(0.0)))break;hb=Ea>>>0<db>>>0;c[A>>2]=hb?Ea:db;c[Ca>>2]=hb?db:Ea;hb=AUa(y,A)|0;ta=ea(g[eb>>2]);va=ea(g[Da>>2]);sa=ea(ta-va);wa=ea(g[fb>>2]);ib=ea(g[Wa>>2]);jb=ea(wa-ib);kb=ea(g[gb>>2]);lb=ea(g[Ta>>2]);mb=ea(kb-lb);nb=ea(g[ma+(db<<4)>>2]);ob=ea(nb-ta);ta=ea(g[ma+(db<<4)+4>>2]);pb=ea(ta-wa);wa=ea(g[ma+(db<<4)+8>>2]);qb=ea(wa-kb);kb=ea(ea(jb*qb)-ea(mb*pb));rb=ea(ea(mb*ob)-ea(sa*qb));qb=ea(ea(sa*pb)-ea(jb*ob));ob=ea(nb-va);va=ea(ta-ib);ib=ea(wa-lb);lb=ea(ea(T(ea(ea(qb*qb)+ea(ea(kb*kb)+ea(rb*rb)))))/ea(ea(ea(ob*ob)+ea(va*va))+ea(ib*ib)));ib=ea(ea(.150000006)-ea(S(ea(ea(.449999988)-lb))));sb=ib<ea(0.0);va=sb?ea(0.0):ib;sb=hb+8|0;g[sb>>2]=ea(ea(g[sb>>2])+va);va=ea(ea(.100000001)-lb);sb=va<ea(0.0);lb=ea(va*ea(3.0));va=sb?ea(0.0):lb;sb=hb+4|0;g[sb>>2]=ea(ea(g[sb>>2])+va)}while(0);Ha=Ha+1|0}while((Ha|0)!=(cb|0))}bb=bb+1|0}while((bb|0)!=(Va|0));tb=c[d>>2]|0}else tb=qa;if(Ma>>>0>=tb>>>0)break;else qa=tb}}c[B>>2]=0;qa=B+4|0;c[qa>>2]=0;Ma=B+8|0;c[Ma>>2]=0;ma=c[Ga>>2]|0;if(ma)BUa(B,ma);c[C>>2]=0;xUa(r,0,C);ma=(c[d>>2]|0)+1|0;c[D>>2]=0;xUa(r,ma,D);ma=y+12|0;a:do if(c[y+16>>2]|0){Ca=c[ma>>2]|0;La=c[Ca>>2]|0;if((La|0)==-1){Ua=c[y+20>>2]|0;Va=0;while(1){bb=Va+1|0;if((bb|0)==(Ua|0)){ub=-1;vb=Ua;break a}Ta=c[Ca+(bb<<2)>>2]|0;if((Ta|0)==-1)Va=bb;else{ub=Ta;vb=bb;break}}}else{ub=La;vb=0}}else{ub=-1;vb=0}while(0);Ga=y+4|0;Va=c[r>>2]|0;Ca=E+4|0;Ua=E+8|0;bb=c[p>>2]|0;Ta=y+8|0;Wa=y+20|0;Da=ub;Ea=vb;b:while(1){Na=Da;do{if((Na|0)==-1)break b;cb=c[Ga>>2]|0;Ha=cb+(Na*20|0)|0;ua=ea(g[cb+(Na*20|0)+8>>2]);va=ea(g[cb+(Na*20|0)+12>>2]);lb=ea(ua+va);ib=ea(g[cb+(Na*20|0)+16>>2]);do if(ea(lb+ib)>ea(0.0)){do if(va>(ua>ib?ua:ib))wb=3;else{if(ib>(ua>va?ua:va)){wb=4;break}gb=c[Ha>>2]|0;fb=c[cb+(Na*20|0)+4>>2]|0;ob=ea(g[bb+(gb<<4)>>2]);rb=ea(ob-ea(g[bb+(fb<<4)>>2]));ob=ea(g[bb+(gb<<4)+4>>2]);kb=ea(ob-ea(g[bb+(fb<<4)+4>>2]));ob=ea(g[bb+(gb<<4)+8>>2]);qb=ea(ob-ea(g[bb+(fb<<4)+8>>2]));ob=ea(ea(ea(rb*rb)+ea(kb*kb))+ea(qb*qb));if(ob>ea(0.0)){wa=ea(ea(1.0)/ea(T(ea(ob))));xb=ea(rb*wa);yb=ea(kb*wa);zb=ea(qb*wa)}else{xb=ea(0.0);yb=ea(0.0);zb=ea(0.0)}wa=ea(xb*ea(g[h>>2]));qb=ea(wa+ea(yb*ea(g[ra>>2])));fb=ea(S(ea(qb+ea(zb*ea(g[na>>2])))))<ea(.632455527);wb=fb?2:1}while(0);fb=Va+(c[Ha>>2]<<2)|0;c[fb>>2]=(c[fb>>2]|0)+1;fb=cb+(Na*20|0)+4|0;gb=Va+(c[fb>>2]<<2)|0;c[gb>>2]=(c[gb>>2]|0)+1;gb=c[Ha>>2]|0;c[E>>2]=gb;eb=c[fb>>2]|0;c[Ca>>2]=eb;c[Ua>>2]=wb;fb=c[qa>>2]|0;if((c[Ma>>2]&2147483647)>>>0<=fb>>>0){CUa(B,E)|0;break}db=c[B>>2]|0;sb=db+(fb*12|0)|0;if(sb){c[sb>>2]=gb;c[db+(fb*12|0)+4>>2]=eb;c[db+(fb*12|0)+8>>2]=wb}c[qa>>2]=fb+1}while(0);Na=c[(c[Ta>>2]|0)+(Na<<2)>>2]|0}while((Na|0)!=-1);Na=c[Wa>>2]|0;La=c[ma>>2]|0;Ha=Ea;while(1){cb=Ha+1|0;if((cb|0)==(Na|0)){Da=-1;Ea=Na;continue b}fb=c[La+(cb<<2)>>2]|0;if((fb|0)==-1)Ha=cb;else{Da=fb;Ea=cb;continue b}}}Ea=c[la>>2]|0;Da=Va+(Ea<<2)|0;if(Ea)if((Ea|0)==1)Ab=0;else{Ea=Va+4|0;ma=c[Va>>2]|0;Wa=Va;do{Wa=Wa+4|0;ma=(c[Ea>>2]|0)+ma|0;c[Wa>>2]=ma;Ea=Ea+4|0}while((Ea|0)!=(Da|0));Ab=(c[la>>2]|0)+-1|0}else Ab=-1;Da=c[qa>>2]|0;c[F>>2]=Da;c[G>>2]=0;xUa(t,0,G);Ea=c[Va+(Ab<<2)>>2]|0;c[H>>2]=0;xUa(t,Ea,H);if(!Da){Bb=0;Cb=c[t>>2]|0}else{Ea=c[B>>2]|0;ma=c[t>>2]|0;Wa=0;do{Ta=Va+(c[Ea+(Wa*12|0)>>2]<<2)|0;Ua=(c[Ta>>2]|0)+-1|0;c[Ta>>2]=Ua;c[ma+(Ua<<2)>>2]=Wa;Ua=Va+(c[Ea+(Wa*12|0)+4>>2]<<2)|0;Ta=(c[Ua>>2]|0)+-1|0;c[Ua>>2]=Ta;c[ma+(Ta<<2)>>2]=Wa;Wa=Wa+1|0}while(Wa>>>0<Da>>>0);Bb=Da;Cb=ma}c[I>>2]=0;c[I+4>>2]=0;ma=I+8|0;c[ma>>2]=0;xUa(I,Bb,F);c[J>>2]=0;xUa(u,0,J);Da=c[F>>2]|0;c[K>>2]=-1;xUa(u,Da+1|0,K);c[M>>2]=0;c[L>>2]=0;c[L+4>>2]=0;Wa=L+8|0;c[Wa>>2]=0;xUa(L,Da,M);c[N>>2]=0;Ea=N+4|0;c[Ea>>2]=0;qa=N+8|0;c[qa>>2]=0;if(Da)DUa(N,Da);la=c[I>>2]|0;Ta=c[L>>2]|0;Ua=O+4|0;Ca=c[B>>2]|0;na=c[u>>2]|0;ra=P+4|0;Ga=d+4|0;Ha=d+8|0;La=Q+4|0;Na=d+12|0;cb=d+16|0;fb=d+24|0;db=d+20|0;eb=d+16|0;gb=0;c:while(1){if(gb>>>0>=Da>>>0)break;if((c[la+(gb<<2)>>2]|0)!=(Da|0)){gb=gb+1|0;continue}c[Ea>>2]=0;sb=c[Ta+(gb<<2)>>2]|0;c[O>>2]=gb;c[Ua>>2]=sb;d:do if(!(c[qa>>2]&2147483647)){EUa(N,O)|0;sb=c[Ea>>2]|0;hb=c[N>>2]|0;e:do if((sb|0)>0){Db=(sb<<3>>3)+-1|0;if(!Db){Eb=sb;Fb=hb;break d}else Gb=Db;do{Db=Gb;Gb=(Gb+-1|0)>>>1;if((c[hb+(Gb<<3)+4>>2]|0)>>>0>=(c[hb+(Db<<3)+4>>2]|0)>>>0)break e;Hb=hb+(Db<<3)|0;Db=hb+(Gb<<3)|0;Ib=Db;Jb=c[Ib>>2]|0;Kb=c[Ib+4>>2]|0;Ib=Hb;Lb=c[Ib+4>>2]|0;Mb=Db;c[Mb>>2]=c[Ib>>2];c[Mb+4>>2]=Lb;Lb=Hb;c[Lb>>2]=Jb;c[Lb+4>>2]=Kb}while((Gb|0)!=0)}while(0);if(!sb){gb=0;continue c}else{Eb=sb;Fb=hb}}else{Kb=c[N>>2]|0;if(Kb){Lb=O;Jb=c[Lb+4>>2]|0;Hb=Kb;c[Hb>>2]=c[Lb>>2];c[Hb+4>>2]=Jb}c[Ea>>2]=1;Eb=1;Fb=Kb}while(0);Kb=c[Ca+(gb*12|0)+8>>2]|0;Jb=Fb;Hb=Eb;while(1){Lb=Hb+-1|0;Mb=Jb+(Lb<<3)|0;Ib=Jb;Db=c[Ib>>2]|0;Nb=c[Ib+4>>2]|0;Ib=Mb;Ob=c[Ib+4>>2]|0;Pb=Jb;c[Pb>>2]=c[Ib>>2];c[Pb+4>>2]=Ob;Ob=Mb;c[Ob>>2]=Db;c[Ob+4>>2]=Nb;f:do if((Lb|0)>1){Nb=1;Ob=0;while(1){Db=Nb+1|0;if((Db|0)<(Lb|0))Qb=(c[Jb+(Nb<<3)+4>>2]|0)>>>0<(c[Jb+(Db<<3)+4>>2]|0)>>>0?Db:Nb;else Qb=Nb;if((c[Jb+(Ob<<3)+4>>2]|0)>>>0>=(c[Jb+(Qb<<3)+4>>2]|0)>>>0)break f;Db=Jb+(Qb<<3)|0;Mb=Jb+(Ob<<3)|0;Pb=Mb;Ib=c[Pb>>2]|0;Rb=c[Pb+4>>2]|0;Pb=Db;Sb=c[Pb+4>>2]|0;Tb=Mb;c[Tb>>2]=c[Pb>>2];c[Tb+4>>2]=Sb;Sb=Db;c[Sb>>2]=Ib;c[Sb+4>>2]=Rb;Nb=Qb<<1|1;if((Nb|0)>=(Lb|0))break;else Ob=Qb}}while(0);Lb=(c[Ea>>2]|0)+-1|0;hb=c[N>>2]|0;sb=c[hb+(Lb<<3)>>2]|0;c[Ea>>2]=Lb;Ob=la+(sb<<2)|0;if((c[Ob>>2]|0)==(Da|0)){Nb=Ca+(sb*12|0)|0;Rb=Ca+(sb*12|0)+4|0;Sb=Lb;Ib=hb;Db=0;while(1){Tb=c[((Db|0)==0?Rb:Nb)>>2]|0;do if(ea(g[bb+(Tb<<4)+12>>2])==ea(0.0)){Ub=Sb;Vb=Ib}else{Pb=c[Va+(Tb<<2)>>2]|0;Mb=c[Va+(Tb+1<<2)>>2]|0;Wb=Cb+(Mb<<2)|0;if((Pb|0)==(Mb|0)){Ub=Sb;Vb=Ib;break}Mb=Sb;Xb=Ib;Yb=Cb+(Pb<<2)|0;while(1){Pb=c[Yb>>2]|0;g:do if((Pb|0)==(sb|0)?1:(c[Ca+(Pb*12|0)+8>>2]|0)!=(Kb|0)){Zb=Mb;_b=Xb}else{c[na+(c[la+(Pb<<2)>>2]<<2)>>2]=sb;$b=Ta+(Pb<<2)|0;ac=(c[$b>>2]|0)+1|0;c[$b>>2]=ac;c[P>>2]=Pb;c[ra>>2]=ac;if((c[qa>>2]&2147483647)>>>0>Mb>>>0){ac=Xb+(Mb<<3)|0;if(!ac)bc=Mb;else{$b=P;cc=c[$b+4>>2]|0;dc=ac;c[dc>>2]=c[$b>>2];c[dc+4>>2]=cc;bc=c[Ea>>2]|0}cc=bc+1|0;c[Ea>>2]=cc;ec=cc}else{EUa(N,P)|0;ec=c[Ea>>2]|0}cc=c[N>>2]|0;if((ec|0)<=0){Zb=ec;_b=cc;break}dc=(ec<<3>>3)+-1|0;if(!dc){Zb=ec;_b=cc;break}else fc=dc;while(1){dc=fc;fc=(fc+-1|0)>>>1;if((c[cc+(fc<<3)+4>>2]|0)>>>0>=(c[cc+(dc<<3)+4>>2]|0)>>>0){Zb=ec;_b=cc;break g}$b=cc+(dc<<3)|0;dc=cc+(fc<<3)|0;ac=dc;gc=c[ac>>2]|0;hc=c[ac+4>>2]|0;ac=$b;ic=c[ac+4>>2]|0;jc=dc;c[jc>>2]=c[ac>>2];c[jc+4>>2]=ic;ic=$b;c[ic>>2]=gc;c[ic+4>>2]=hc;if(!fc){Zb=ec;_b=cc;break}}}while(0);Yb=Yb+4|0;if((Yb|0)==(Wb|0)){Ub=Zb;Vb=_b;break}else{Mb=Zb;Xb=_b}}}while(0);Db=Db+1|0;if((Db|0)==2)break;else{Sb=Ub;Ib=Vb}}Ib=c[Ha>>2]|0;Sb=0;while(1){if(!(Sb>>>0<Ib>>>0?(c[(c[Ga>>2]|0)+(Sb<<3)>>2]|0)!=(Kb|0):0))oa=172;if((oa|0)==172?(oa=0,(c[na+(Sb<<2)>>2]|0)!=(sb|0)):0)break;Sb=Sb+1|0}do if((Sb|0)==(Ib|0)){c[Q>>2]=Kb;c[La>>2]=Ib;if((c[Na>>2]&2147483647)>>>0>Ib>>>0){sb=(c[Ga>>2]|0)+(Ib<<3)|0;if(!sb)kc=Ib;else{Db=Q;Nb=c[Db+4>>2]|0;Rb=sb;c[Rb>>2]=c[Db>>2];c[Rb+4>>2]=Nb;kc=c[Ha>>2]|0}c[Ha>>2]=kc+1}else FUa(Ga,Q)|0;c[R>>2]=0;Nb=c[db>>2]|0;if((c[fb>>2]&2147483647)>>>0<=Nb>>>0){cUa(cb,R)|0;break}Rb=(c[cb>>2]|0)+(Nb<<2)|0;if(!Rb)lc=Nb;else{c[Rb>>2]=0;lc=c[db>>2]|0}c[db>>2]=lc+1}while(0);c[Ob>>2]=Sb;Ib=(c[eb>>2]|0)+(Sb<<2)|0;c[Ib>>2]=(c[Ib>>2]|0)+1;mc=Ub;nc=Vb}else{mc=Lb;nc=hb}if(!mc){gb=0;continue c}else{Jb=nc;Hb=mc}}}gb=c[cb>>2]|0;eb=c[db>>2]|0;Ga=gb+(eb<<2)|0;do if(!eb)oc=0;else{if((eb|0)==1){oc=1;break}Ha=gb+4|0;Na=c[gb>>2]|0;La=gb;do{La=La+4|0;Na=(c[Ha>>2]|0)+Na|0;c[La>>2]=Na;Ha=Ha+4|0}while((Ha|0)!=(Ga|0));oc=c[db>>2]|0}while(0);Ga=c[gb+(oc+-1<<2)>>2]|0;c[U>>2]=Ga;if((c[fb>>2]&2147483647)>>>0>oc>>>0){eb=gb+(oc<<2)|0;if(!eb)pc=oc;else{c[eb>>2]=Ga;pc=c[db>>2]|0}c[db>>2]=pc+1}else cUa(cb,U)|0;Ga=d+40|0;eb=c[F>>2]|0;c[V>>2]=0;xUa(Ga,eb<<1,V);Ha=d+28|0;g[W>>2]=ea(0.0);GUa(Ha,eb,W);if(eb){Na=c[B>>2]|0;La=c[I>>2]|0;na=c[cb>>2]|0;Ea=c[Ga>>2]|0;ra=c[p>>2]|0;Ta=c[Ha>>2]|0;la=0;do{Ca=c[Na+(la*12|0)>>2]|0;Va=c[Na+(la*12|0)+4>>2]|0;bb=na+(c[La+(la<<2)>>2]<<2)|0;Da=(c[bb>>2]|0)+-1|0;c[bb>>2]=Da;bb=Da<<1;c[Ea+(bb<<2)>>2]=Ca;c[Ea+((bb|1)<<2)>>2]=Va;va=ea(g[ra+(Va<<4)>>2]);ua=ea(va-ea(g[ra+(Ca<<4)>>2]));va=ea(g[ra+(Va<<4)+4>>2]);ib=ea(va-ea(g[ra+(Ca<<4)+4>>2]));va=ea(g[ra+(Va<<4)+8>>2]);lb=ea(va-ea(g[ra+(Ca<<4)+8>>2]));g[Ta+(Da<<2)>>2]=ea(T(ea(ea(ea(ua*ua)+ea(ib*ib))+ea(lb*lb))));la=la+1|0}while(la>>>0<eb>>>0)}eb=d+44|0;la=c[eb>>2]|0;c[Y>>2]=0;c[X>>2]=0;Ta=X+4|0;c[Ta>>2]=0;ra=X+8|0;c[ra>>2]=0;xUa(X,la,Y);la=d+32|0;Ea=c[la>>2]|0;g[_>>2]=ea(0.0);c[Z>>2]=0;La=Z+4|0;c[La>>2]=0;na=Z+8|0;c[na>>2]=0;GUa(Z,Ea,_);if((c[db>>2]|0)!=1){Ea=$+4|0;Na=$+8|0;gb=l+4|0;fb=0;do{Da=fb;fb=fb+1|0;Ca=c[cb>>2]|0;Va=(c[Ca+(fb<<2)>>2]|0)-(c[Ca+(Da<<2)>>2]|0)|0;c[aa>>2]=0;c[$>>2]=0;c[Ea>>2]=0;c[Na>>2]=0;xUa($,Va,aa);Va=c[Ea>>2]|0;Ca=c[$>>2]|0;if(!Va)qc=-1;else{bb=0;do{c[Ca+(bb<<2)>>2]=bb;bb=bb+1|0}while(bb>>>0<Va>>>0);qc=Va+-1|0}bb=c[(c[cb>>2]|0)+(Da<<2)>>2]|0;Ua=bb<<1;Hb=c[Ga>>2]|0;Jb=l;c[Jb>>2]=0;c[Jb+4>>2]=0;a[gb>>0]=0;c[l>>2]=m;do if((qc|0)>0){Jb=0;Kb=32;Ib=0;Rb=0;Nb=qc;Db=m;h:while(1){sb=Nb;Tb=Rb;Xb=Ib;while(1){if((sb|0)>(Tb|0)){if((sb-Tb|0)>>>0<5)rc=Tb;else break;do{Mb=rc;rc=rc+1|0;Wb=rc;Yb=Mb;while(1){Pb=c[Ca+(Wb<<2)>>2]<<1;cc=c[Ca+(Yb<<2)>>2]<<1;hc=c[Hb+(Pb+Ua<<2)>>2]|0;ic=c[Hb+(cc+Ua<<2)>>2]|0;if((hc|0)==(ic|0))sc=(c[Hb+((Pb|1)+Ua<<2)>>2]|0)>>>0<(c[Hb+((cc|1)+Ua<<2)>>2]|0)>>>0;else sc=hc>>>0<ic>>>0;Yb=sc?Wb:Yb;if((Wb|0)>=(sb|0))break;else Wb=Wb+1|0}Wb=Ca+(Yb<<2)|0;ic=Ca+(Mb<<2)|0;hc=c[Wb>>2]|0;c[Wb>>2]=c[ic>>2];c[ic>>2]=hc}while((rc|0)!=(sb|0))}if(!Xb)break h;hc=Xb+-2|0;sb=c[Db+(Xb+-1<<2)>>2]|0;Tb=c[Db+(hc<<2)>>2]|0;Xb=hc}hc=Ca+(((sb+Tb|0)/2|0)<<2)|0;ic=c[hc>>2]|0;Wb=Ca+(Tb<<2)|0;cc=c[Wb>>2]|0;Pb=ic<<1;gc=cc<<1;$b=c[Hb+(Pb+Ua<<2)>>2]|0;jc=c[Hb+(gc+Ua<<2)>>2]|0;if(($b|0)==(jc|0))if((c[Hb+((Pb|1)+Ua<<2)>>2]|0)>>>0<(c[Hb+((gc|1)+Ua<<2)>>2]|0)>>>0)oa=218;else{tc=cc;uc=ic}else if($b>>>0<jc>>>0)oa=218;else{tc=cc;uc=ic}if((oa|0)==218){oa=0;c[Wb>>2]=ic;c[hc>>2]=cc;tc=c[Wb>>2]|0;uc=cc}cc=Ca+(sb<<2)|0;ic=c[cc>>2]|0;jc=ic<<1;$b=tc<<1;gc=c[Hb+(jc+Ua<<2)>>2]|0;Pb=c[Hb+($b+Ua<<2)>>2]|0;if((gc|0)==(Pb|0))if((c[Hb+((jc|1)+Ua<<2)>>2]|0)>>>0<(c[Hb+(($b|1)+Ua<<2)>>2]|0)>>>0)oa=222;else{vc=ic;wc=uc}else if(gc>>>0<Pb>>>0)oa=222;else{vc=ic;wc=uc}if((oa|0)==222){oa=0;c[Wb>>2]=ic;c[cc>>2]=tc;vc=tc;wc=c[hc>>2]|0}ic=vc<<1;Wb=wc<<1;Pb=c[Hb+(ic+Ua<<2)>>2]|0;gc=c[Hb+(Wb+Ua<<2)>>2]|0;if((Pb|0)==(gc|0))if((c[Hb+((ic|1)+Ua<<2)>>2]|0)>>>0<(c[Hb+((Wb|1)+Ua<<2)>>2]|0)>>>0)oa=226;else xc=wc;else if(Pb>>>0<gc>>>0)oa=226;else xc=wc;if((oa|0)==226){oa=0;c[hc>>2]=vc;c[cc>>2]=wc;xc=c[hc>>2]|0}cc=sb+-1|0;gc=Ca+(cc<<2)|0;c[hc>>2]=c[gc>>2];c[gc>>2]=xc;hc=xc;Pb=Tb;Wb=cc;while(1){cc=hc<<1;ic=c[Hb+(cc+Ua<<2)>>2]|0;$b=Hb+((cc|1)+Ua<<2)|0;yc=Pb;while(1){zc=yc+1|0;Ac=Ca+(zc<<2)|0;Bc=c[Ac>>2]|0;cc=Bc<<1;jc=c[Hb+(cc+Ua<<2)>>2]|0;if((jc|0)==(ic|0))if((c[Hb+((cc|1)+Ua<<2)>>2]|0)>>>0<(c[$b>>2]|0)>>>0){yc=zc;continue}else{Cc=Wb;break}else if(jc>>>0<ic>>>0){yc=zc;continue}else{Cc=Wb;break}}while(1){Dc=Cc+-1|0;Ec=Ca+(Dc<<2)|0;Fc=c[Ec>>2]|0;jc=Fc<<1;cc=c[Hb+(jc+Ua<<2)>>2]|0;if((ic|0)==(cc|0))if((c[$b>>2]|0)>>>0<(c[Hb+((jc|1)+Ua<<2)>>2]|0)>>>0){Cc=Dc;continue}else break;else if(ic>>>0<cc>>>0){Cc=Dc;continue}else break}if((zc|0)>=(Dc|0))break;c[Ac>>2]=Fc;c[Ec>>2]=Bc;hc=c[gc>>2]|0;Pb=zc;Wb=Dc}c[Ac>>2]=hc;c[gc>>2]=Bc;if((zc-Tb|0)<(sb-zc|0)){do if(Xb>>>0<(Kb+-1|0)>>>0){Gc=Db;Hc=Jb;Ic=Kb}else{Wb=Kb<<1;Pb=Kb<<3;if(!Pb)Jc=0;else{ic=mKa()|0;$b=c[(c[ic>>2]|0)+8>>2]|0;cc=pKa()|0;jc=mo[c[(c[cc>>2]|0)+24>>2]&4095](cc)|0;Jc=Bn[$b&255](ic,Pb,jc?541832:544544,523928,148)|0}YEi(Jc|0,Db|0,Xb<<2|0)|0;if(Jb<<24>>24==0|(Db|0)==0){Gc=Jc;Hc=1;Ic=Wb;break}jc=mKa()|0;In[c[(c[jc>>2]|0)+12>>2]&4095](jc,Db);Gc=Jc;Hc=1;Ic=Wb}while(0);c[Gc+(Xb<<2)>>2]=Tb;c[Gc+(Xb+1<<2)>>2]=yc;Kc=Hc;Lc=Ic;Mc=yc+2|0;Nc=sb;Oc=Gc}else{gc=yc+2|0;do if(Xb>>>0<(Kb+-1|0)>>>0){Pc=Db;Qc=Jb;Rc=Kb}else{hc=Kb<<1;Wb=Kb<<3;if(!Wb)Sc=0;else{jc=mKa()|0;Pb=c[(c[jc>>2]|0)+8>>2]|0;ic=pKa()|0;$b=mo[c[(c[ic>>2]|0)+24>>2]&4095](ic)|0;Sc=Bn[Pb&255](jc,Wb,$b?541832:544544,523928,148)|0}YEi(Sc|0,Db|0,Xb<<2|0)|0;if(Jb<<24>>24==0|(Db|0)==0){Pc=Sc;Qc=1;Rc=hc;break}$b=mKa()|0;In[c[(c[$b>>2]|0)+12>>2]&4095]($b,Db);Pc=Sc;Qc=1;Rc=hc}while(0);c[Pc+(Xb<<2)>>2]=gc;c[Pc+(Xb+1<<2)>>2]=sb;Kc=Qc;Lc=Rc;Mc=Tb;Nc=yc;Oc=Pc}Jb=Kc;Kb=Lc;Ib=Xb+2|0;Rb=Mc;Nb=Nc;Db=Oc}if(Jb<<24>>24==0|(Db|0)==0)break;Nb=mKa()|0;In[c[(c[Nb>>2]|0)+12>>2]&4095](Nb,Db)}while(0);if(a[gb>>0]|0)tKa(l,c[l>>2]|0);Hb=c[Ea>>2]|0;if(Hb){Da=c[Ga>>2]|0;Va=c[X>>2]|0;Nb=c[Ha>>2]|0;Rb=c[Z>>2]|0;Ib=0;do{Kb=Ca+(Ib<<2)|0;hb=(Ib<<1)+Ua|0;c[Va+(hb<<2)>>2]=c[Da+((c[Kb>>2]<<1)+Ua<<2)>>2];c[Va+((hb|1)<<2)>>2]=c[Da+(((c[Kb>>2]<<1)+Ua|1)<<2)>>2];g[Rb+(Ib+bb<<2)>>2]=ea(g[Nb+((c[Kb>>2]|0)+bb<<2)>>2]);Ib=Ib+1|0}while(Ib>>>0<Hb>>>0)}Hb=c[Na>>2]|0;if(!((Hb|0)<0|(Hb&2147483647|0)==0|(Ca|0)==0)){Hb=mKa()|0;In[c[(c[Hb>>2]|0)+12>>2]&4095](Hb,Ca)}}while(fb>>>0<((c[db>>2]|0)+-1|0)>>>0)}if((X|0)!=(Ga|0)){c[eb>>2]=0;db=c[Ta>>2]|0;if((c[d+48>>2]&2147483647)>>>0<db>>>0){yUa(Ga,db);Tc=c[Ta>>2]|0}else Tc=db;db=c[Ga>>2]|0;fb=db+(Tc<<2)|0;if((Tc|0)>0){Na=db;db=c[X>>2]|0;while(1){if(Na)c[Na>>2]=c[db>>2];Na=Na+4|0;if(Na>>>0>=fb>>>0)break;else db=db+4|0}Uc=c[Ta>>2]|0}else Uc=Tc;c[eb>>2]=Uc}if((Z|0)!=(Ha|0)){c[la>>2]=0;db=c[La>>2]|0;if((c[d+36>>2]&2147483647)>>>0<db>>>0){HUa(Ha,db);Vc=c[La>>2]|0}else Vc=db;db=c[Ha>>2]|0;fb=db+(Vc<<2)|0;if((Vc|0)>0){Na=db;db=c[Z>>2]|0;while(1){if(Na)g[Na>>2]=ea(g[db>>2]);Na=Na+4|0;if(Na>>>0>=fb>>>0)break;else db=db+4|0}}c[la>>2]=Vc}do if(j){XT(ba,f);if(!(ZT(ba)|0)){db=_T(ba)|0;fb=da(c[d>>2]|0,db)|0;db=d+52|0;c[ca>>2]=0;xUa(db,fb,ca);Na=d+64|0;g[fa>>2]=ea(0.0);GUa(Na,fb,fa);$T(ba,c[db>>2]|0,c[Na>>2]|0);YT(ba);break}else{YT(ba);oa=286;break}}else oa=286;while(0);if((oa|0)==286){eU(ga,f);la=d+52|0;Na=c[d>>2]|0;c[ha>>2]=0;xUa(la,Na,ha);Na=d+64|0;db=c[d>>2]|0;g[ia>>2]=ea(0.0);GUa(Na,db,ia);gU(ga,c[la>>2]|0,c[Na>>2]|0);fU(ga)}Na=c[na>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){la=c[Z>>2]|0;if(!la)break;db=mKa()|0;In[c[(c[db>>2]|0)+12>>2]&4095](db,la)}while(0);Na=c[ra>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){na=c[X>>2]|0;if(!na)break;la=mKa()|0;In[c[(c[la>>2]|0)+12>>2]&4095](la,na)}while(0);Na=c[N>>2]|0;ra=c[qa>>2]|0;if(!((ra|0)<0|(ra&2147483647|0)==0|(Na|0)==0)){ra=mKa()|0;In[c[(c[ra>>2]|0)+12>>2]&4095](ra,Na)}Na=c[Wa>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){ra=c[L>>2]|0;if(!ra)break;na=mKa()|0;In[c[(c[na>>2]|0)+12>>2]&4095](na,ra)}while(0);Na=c[ma>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){Wa=c[I>>2]|0;if(!Wa)break;qa=mKa()|0;In[c[(c[qa>>2]|0)+12>>2]&4095](qa,Wa)}while(0);Na=c[Ma>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){ma=c[B>>2]|0;if(!ma)break;Wa=mKa()|0;In[c[(c[Wa>>2]|0)+12>>2]&4095](Wa,ma)}while(0);Na=c[y>>2]|0;if(Na)VJa(y,Na);Na=c[Fa>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){Ma=c[w>>2]|0;if(!Ma)break;ma=mKa()|0;In[c[(c[ma>>2]|0)+12>>2]&4095](ma,Ma)}while(0);Na=c[Ia>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){Fa=c[u>>2]|0;if(!Fa)break;Ma=mKa()|0;In[c[(c[Ma>>2]|0)+12>>2]&4095](Ma,Fa)}while(0);Na=c[Aa>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){Ia=c[t>>2]|0;if(!Ia)break;Fa=mKa()|0;In[c[(c[Fa>>2]|0)+12>>2]&4095](Fa,Ia)}while(0);Na=c[ka>>2]|0;do if((Na&2147483647|0)!=0&(Na|0)>-1){Aa=c[r>>2]|0;if(!Aa)break;Ia=mKa()|0;In[c[(c[Ia>>2]|0)+12>>2]&4095](Ia,Aa)}while(0);Na=c[Ba>>2]|0;if(!((Na&2147483647|0)!=0&(Na|0)>-1)){Wc=1;i=k;return Wc|0}Na=c[p>>2]|0;if(!Na){Wc=1;i=k;return Wc|0}ka=mKa()|0;In[c[(c[ka>>2]|0)+12>>2]&4095](ka,Na);Wc=1;i=k;return Wc|0}}while(0);dKa(bKa()|0,4,423488,284,423584,l);Wc=0;i=k;return Wc|0}function WT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+128|0;h=f+52|0;j=f+40|0;k=f;l=h+4|0;m=l+0|0;n=m+72|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));g[j>>2]=ea(g[d>>2]);g[j+4>>2]=ea(g[d+4>>2]);g[j+8>>2]=ea(g[d+8>>2]);if(!(VT(h,b,j,e)|0)){o=0;IUa(h);i=f;return o|0}e=c[(c[a>>2]|0)+80>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;c[k>>2]=c[h>>2];c[k+4>>2]=c[h+8>>2];c[k+8>>2]=c[l>>2];c[k+12>>2]=(c[h+20>>2]|0)+-1;c[k+16>>2]=(c[h+16>>2]|0)+4;c[k+24>>2]=c[h+28>>2];c[k+20>>2]=c[h+40>>2];c[k+28>>2]=c[h+56>>2];c[k+32>>2]=c[h+52>>2];c[k+36>>2]=c[h+64>>2];o=_n[e&4095](a,k)|0;IUa(h);i=f;return o|0}function XT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=xCi(108)|0;c[e>>2]=b;f=e+8|0;g=f+100|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));aU(e,b);c[a>>2]=e;i=d;return}function YT(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}JUa(d);ACi(d);i=b;return}function ZT(a){a=a|0;return c[(c[a>>2]|0)+80>>2]|0}function _T(a){a=a|0;var b=0;b=c[a>>2]|0;return ((c[b+88>>2]|0)>>>0)/((c[b+4>>2]|0)>>>0)|0|0}function $T(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a>>2]|0;YEi(b|0,c[f+84>>2]|0,c[f+88>>2]<<2|0)|0;YEi(d|0,c[f+96>>2]|0,c[f+100>>2]<<2|0)|0;i=e;return}function aU(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=Im,gb=0,hb=0,ib=Im,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=Im,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=Im,zb=Im,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=Im;h=i;i=i+320|0;j=h+128|0;k=h+268|0;l=h+4|0;m=h+120|0;n=h+124|0;o=h+8|0;p=h+28|0;q=h+32|0;r=h+36|0;s=h+40|0;t=h+44|0;u=h+48|0;v=h+312|0;w=h+68|0;x=h+80|0;y=h+224|0;z=h+248|0;A=h+264|0;B=h+272|0;C=h+296|0;D=h+300|0;E=h+140|0;F=h+144|0;G=h+156|0;H=h+168|0;I=h+180|0;J=h+192|0;K=h+196|0;L=h+200|0;M=h+204|0;N=h+208|0;O=h+12|0;P=h+220|0;Q=h+84|0;R=h+24|0;S=h+96|0;U=h+236|0;V=h+108|0;W=h+260|0;X=h;Y=h+284|0;Z=h+64|0;_=c[f+8>>2]|0;$=d+4|0;c[$>>2]=_;aa=f+16|0;if(!(c[aa>>2]|0)){i=h;return}ba=d+8|0;KUa(ba,_,h+52|0);_=d+32|0;ca=c[$>>2]|0;a[v>>0]=0;LUa(_,ca,v);v=c[f>>2]|0;ca=c[f+12>>2]|0;if(c[$>>2]|0){fa=c[f+4>>2]|0;ga=c[aa>>2]|0;aa=0;while(1){ha=c[ba>>2]|0;g[ha+(aa*12|0)>>2]=ea(g[fa>>2]);g[ha+(aa*12|0)+4>>2]=ea(g[fa+4>>2]);g[ha+(aa*12|0)+8>>2]=ea(g[fa+8>>2]);if(!ga){ia=0;ja=0}else{ia=ga+ca|0;ja=ea(g[ga>>2])==ea(0.0)&1}a[(c[_>>2]|0)+aa>>0]=ja;aa=aa+1|0;if(aa>>>0>=(c[$>>2]|0)>>>0)break;else{fa=fa+v|0;ga=ia}}}ia=f+48|0;ga=d+20|0;v=f+24|0;fa=f+36|0;a:do if(!(b[ia>>1]&2)){aa=f+32|0;ja=c[aa>>2]|0;ca=f+44|0;ha=((c[ca>>2]|0)*6|0)+(ja*3|0)|0;ka=d+28|0;if((c[ka>>2]&2147483647)>>>0<ha>>>0){yUa(ga,ha);la=c[aa>>2]|0}else la=ja;ja=c[v>>2]|0;b:do if(la){ha=d+24|0;ma=c[f+28>>2]|0;na=1;while(1){oa=c[ha>>2]|0;if((c[ka>>2]&2147483647)>>>0>oa>>>0){pa=(c[ga>>2]|0)+(oa<<2)|0;if(!pa)qa=oa;else{c[pa>>2]=c[ma>>2];qa=c[ha>>2]|0}pa=qa+1|0;c[ha>>2]=pa;ra=pa}else{cUa(ga,ma)|0;ra=c[ha>>2]|0}pa=ma+4|0;if((c[ka>>2]&2147483647)>>>0>ra>>>0){oa=(c[ga>>2]|0)+(ra<<2)|0;if(!oa)sa=ra;else{c[oa>>2]=c[pa>>2];sa=c[ha>>2]|0}oa=sa+1|0;c[ha>>2]=oa;ta=oa}else{cUa(ga,pa)|0;ta=c[ha>>2]|0}pa=ma+8|0;if((c[ka>>2]&2147483647)>>>0>ta>>>0){oa=(c[ga>>2]|0)+(ta<<2)|0;if(!oa)ua=ta;else{c[oa>>2]=c[pa>>2];ua=c[ha>>2]|0}c[ha>>2]=ua+1}else cUa(ga,pa)|0;if(na>>>0>=(c[aa>>2]|0)>>>0)break b;ma=ma+ja|0;na=na+1|0}}while(0);ja=c[fa>>2]|0;if(c[ca>>2]|0){aa=d+24|0;na=c[f+40>>2]|0;ma=1;while(1){ha=c[aa>>2]|0;if((c[ka>>2]&2147483647)>>>0>ha>>>0){pa=(c[ga>>2]|0)+(ha<<2)|0;if(!pa)va=ha;else{c[pa>>2]=c[na>>2];va=c[aa>>2]|0}pa=va+1|0;c[aa>>2]=pa;wa=pa}else{cUa(ga,na)|0;wa=c[aa>>2]|0}pa=na+4|0;if((c[ka>>2]&2147483647)>>>0>wa>>>0){ha=(c[ga>>2]|0)+(wa<<2)|0;if(!ha)xa=wa;else{c[ha>>2]=c[pa>>2];xa=c[aa>>2]|0}ha=xa+1|0;c[aa>>2]=ha;ya=ha}else{cUa(ga,pa)|0;ya=c[aa>>2]|0}pa=na+8|0;if((c[ka>>2]&2147483647)>>>0>ya>>>0){ha=(c[ga>>2]|0)+(ya<<2)|0;if(!ha)za=ya;else{c[ha>>2]=c[pa>>2];za=c[aa>>2]|0}ha=za+1|0;c[aa>>2]=ha;Aa=ha}else{cUa(ga,pa)|0;Aa=c[aa>>2]|0}if((c[ka>>2]&2147483647)>>>0>Aa>>>0){ha=(c[ga>>2]|0)+(Aa<<2)|0;if(!ha)Ba=Aa;else{c[ha>>2]=c[na>>2];Ba=c[aa>>2]|0}ha=Ba+1|0;c[aa>>2]=ha;Ca=ha}else{cUa(ga,na)|0;Ca=c[aa>>2]|0}if((c[ka>>2]&2147483647)>>>0>Ca>>>0){ha=(c[ga>>2]|0)+(Ca<<2)|0;if(!ha)Da=Ca;else{c[ha>>2]=c[pa>>2];Da=c[aa>>2]|0}ha=Da+1|0;c[aa>>2]=ha;Ea=ha}else{cUa(ga,pa)|0;Ea=c[aa>>2]|0}pa=na+12|0;if((c[ka>>2]&2147483647)>>>0>Ea>>>0){ha=(c[ga>>2]|0)+(Ea<<2)|0;if(!ha)Fa=Ea;else{c[ha>>2]=c[pa>>2];Fa=c[aa>>2]|0}c[aa>>2]=Fa+1}else cUa(ga,pa)|0;if(ma>>>0>=(c[ca>>2]|0)>>>0)break a;na=na+ja|0;ma=ma+1|0}}}else{ma=f+32|0;ja=c[ma>>2]|0;na=f+44|0;ca=((c[na>>2]|0)*6|0)+(ja*3|0)|0;aa=d+28|0;if((c[aa>>2]&2147483647)>>>0<ca>>>0){yUa(ga,ca);Ga=c[ma>>2]|0}else Ga=ja;ja=c[v>>2]|0;c:do if(Ga){ca=d+24|0;ka=c[f+28>>2]|0;pa=1;while(1){ha=e[ka>>1]|0;c[m>>2]=ha;oa=c[ca>>2]|0;if((c[aa>>2]&2147483647)>>>0>oa>>>0){Ha=(c[ga>>2]|0)+(oa<<2)|0;if(!Ha)Ia=oa;else{c[Ha>>2]=ha;Ia=c[ca>>2]|0}ha=Ia+1|0;c[ca>>2]=ha;Ja=ha}else{cUa(ga,m)|0;Ja=c[ca>>2]|0}ha=e[ka+2>>1]|0;c[n>>2]=ha;if((c[aa>>2]&2147483647)>>>0>Ja>>>0){Ha=(c[ga>>2]|0)+(Ja<<2)|0;if(!Ha)Ka=Ja;else{c[Ha>>2]=ha;Ka=c[ca>>2]|0}ha=Ka+1|0;c[ca>>2]=ha;La=ha}else{cUa(ga,n)|0;La=c[ca>>2]|0}ha=e[ka+4>>1]|0;c[o>>2]=ha;if((c[aa>>2]&2147483647)>>>0>La>>>0){Ha=(c[ga>>2]|0)+(La<<2)|0;if(!Ha)Ma=La;else{c[Ha>>2]=ha;Ma=c[ca>>2]|0}c[ca>>2]=Ma+1}else cUa(ga,o)|0;if(pa>>>0>=(c[ma>>2]|0)>>>0)break c;ka=ka+ja|0;pa=pa+1|0}}while(0);ja=c[fa>>2]|0;if(c[na>>2]|0){ma=d+24|0;pa=c[f+40>>2]|0;ka=1;while(1){ca=e[pa>>1]|0;c[p>>2]=ca;ha=c[ma>>2]|0;if((c[aa>>2]&2147483647)>>>0>ha>>>0){Ha=(c[ga>>2]|0)+(ha<<2)|0;if(!Ha)Na=ha;else{c[Ha>>2]=ca;Na=c[ma>>2]|0}ca=Na+1|0;c[ma>>2]=ca;Oa=ca}else{cUa(ga,p)|0;Oa=c[ma>>2]|0}ca=e[pa+2>>1]|0;c[q>>2]=ca;if((c[aa>>2]&2147483647)>>>0>Oa>>>0){Ha=(c[ga>>2]|0)+(Oa<<2)|0;if(!Ha)Pa=Oa;else{c[Ha>>2]=ca;Pa=c[ma>>2]|0}ca=Pa+1|0;c[ma>>2]=ca;Qa=ca}else{cUa(ga,q)|0;Qa=c[ma>>2]|0}ca=pa+4|0;Ha=e[ca>>1]|0;c[r>>2]=Ha;if((c[aa>>2]&2147483647)>>>0>Qa>>>0){ha=(c[ga>>2]|0)+(Qa<<2)|0;if(!ha)Ra=Qa;else{c[ha>>2]=Ha;Ra=c[ma>>2]|0}Ha=Ra+1|0;c[ma>>2]=Ha;Sa=Ha}else{cUa(ga,r)|0;Sa=c[ma>>2]|0}Ha=e[pa>>1]|0;c[s>>2]=Ha;if((c[aa>>2]&2147483647)>>>0>Sa>>>0){ha=(c[ga>>2]|0)+(Sa<<2)|0;if(!ha)Ta=Sa;else{c[ha>>2]=Ha;Ta=c[ma>>2]|0}Ha=Ta+1|0;c[ma>>2]=Ha;Ua=Ha}else{cUa(ga,s)|0;Ua=c[ma>>2]|0}Ha=e[ca>>1]|0;c[t>>2]=Ha;if((c[aa>>2]&2147483647)>>>0>Ua>>>0){ca=(c[ga>>2]|0)+(Ua<<2)|0;if(!ca)Va=Ua;else{c[ca>>2]=Ha;Va=c[ma>>2]|0}Ha=Va+1|0;c[ma>>2]=Ha;Wa=Ha}else{cUa(ga,t)|0;Wa=c[ma>>2]|0}Ha=e[pa+6>>1]|0;c[u>>2]=Ha;if((c[aa>>2]&2147483647)>>>0>Wa>>>0){ca=(c[ga>>2]|0)+(Wa<<2)|0;if(!ca)Xa=Wa;else{c[ca>>2]=Ha;Xa=c[ma>>2]|0}c[ma>>2]=Xa+1}else cUa(ga,u)|0;if(ka>>>0>=(c[na>>2]|0)>>>0)break a;pa=pa+ja|0;ka=ka+1|0}}}while(0);bU(d);u=cU(d)|0;c[d+80>>2]=u;if(u){i=h;return}u=(c[$>>2]|0)+1|0;c[x>>2]=0;c[w>>2]=0;ga=w+4|0;c[ga>>2]=0;Xa=w+8|0;c[Xa>>2]=0;xUa(w,u,x);c[y>>2]=0;x=y+4|0;c[x>>2]=0;u=y+8|0;c[u>>2]=0;if(!(b[ia>>1]&2)){ia=f+28|0;Wa=c[v>>2]|0;t=f+32|0;if(c[t>>2]|0){Va=c[w>>2]|0;Ua=c[ia>>2]|0;s=0;while(1){Ta=Va+(c[Ua>>2]<<2)|0;c[Ta>>2]=(c[Ta>>2]|0)+2;Ta=Va+(c[Ua+4>>2]<<2)|0;c[Ta>>2]=(c[Ta>>2]|0)+2;Ta=Va+(c[Ua+8>>2]<<2)|0;c[Ta>>2]=(c[Ta>>2]|0)+2;s=s+1|0;if(s>>>0>=(c[t>>2]|0)>>>0)break;else Ua=Ua+Wa|0}}Wa=f+40|0;Ua=c[fa>>2]|0;s=f+44|0;if(!(c[s>>2]|0))Ya=c[w>>2]|0;else{Va=c[w>>2]|0;Ta=c[Wa>>2]|0;Sa=0;while(1){r=Va+(c[Ta>>2]<<2)|0;c[r>>2]=(c[r>>2]|0)+2;r=Va+(c[Ta+4>>2]<<2)|0;c[r>>2]=(c[r>>2]|0)+2;r=Va+(c[Ta+8>>2]<<2)|0;c[r>>2]=(c[r>>2]|0)+2;r=Va+(c[Ta+12>>2]<<2)|0;c[r>>2]=(c[r>>2]|0)+2;Sa=Sa+1|0;if(Sa>>>0>=(c[s>>2]|0)>>>0){Ya=Va;break}else Ta=Ta+Ua|0}}Ua=c[ga>>2]|0;Ta=Ya+(Ua<<2)|0;if(Ua)if((Ua|0)==1){Za=1;_a=0}else{Ua=Ya+4|0;Va=c[Ya>>2]|0;Sa=Ya;do{Sa=Sa+4|0;Va=(c[Ua>>2]|0)+Va|0;c[Sa>>2]=Va;Ua=Ua+4|0}while((Ua|0)!=(Ta|0));Ta=c[ga>>2]|0;Za=Ta;_a=Ta+-1|0}else{Za=0;_a=-1}Ta=c[Ya+(_a<<2)>>2]|0;c[k>>2]=0;xUa(y,Ta,k);k=c[v>>2]|0;if(c[t>>2]|0){Ta=c[y>>2]|0;_a=c[ia>>2]|0;ia=0;while(1){Ua=_a+4|0;Va=c[Ua>>2]|0;Sa=Ya+(c[_a>>2]<<2)|0;r=(c[Sa>>2]|0)+-1|0;c[Sa>>2]=r;c[Ta+(r<<2)>>2]=Va;Va=_a+8|0;r=c[Va>>2]|0;Sa=Ya+(c[_a>>2]<<2)|0;Ra=(c[Sa>>2]|0)+-1|0;c[Sa>>2]=Ra;c[Ta+(Ra<<2)>>2]=r;r=c[Va>>2]|0;Ra=Ya+(c[Ua>>2]<<2)|0;Sa=(c[Ra>>2]|0)+-1|0;c[Ra>>2]=Sa;c[Ta+(Sa<<2)>>2]=r;r=c[_a>>2]|0;Sa=Ya+(c[Ua>>2]<<2)|0;Ra=(c[Sa>>2]|0)+-1|0;c[Sa>>2]=Ra;c[Ta+(Ra<<2)>>2]=r;r=c[_a>>2]|0;Ra=Ya+(c[Va>>2]<<2)|0;Sa=(c[Ra>>2]|0)+-1|0;c[Ra>>2]=Sa;c[Ta+(Sa<<2)>>2]=r;r=c[Ua>>2]|0;Ua=Ya+(c[Va>>2]<<2)|0;Va=(c[Ua>>2]|0)+-1|0;c[Ua>>2]=Va;c[Ta+(Va<<2)>>2]=r;ia=ia+1|0;if(ia>>>0>=(c[t>>2]|0)>>>0)break;else _a=_a+k|0}}k=c[fa>>2]|0;if(!(c[s>>2]|0)){$a=Za;ab=Ya}else{_a=c[y>>2]|0;t=c[Wa>>2]|0;Wa=0;while(1){ia=t+4|0;Ta=c[ia>>2]|0;r=Ya+(c[t>>2]<<2)|0;Va=(c[r>>2]|0)+-1|0;c[r>>2]=Va;c[_a+(Va<<2)>>2]=Ta;Ta=t+12|0;Va=c[Ta>>2]|0;r=Ya+(c[t>>2]<<2)|0;Ua=(c[r>>2]|0)+-1|0;c[r>>2]=Ua;c[_a+(Ua<<2)>>2]=Va;Va=t+8|0;Ua=c[Va>>2]|0;r=Ya+(c[ia>>2]<<2)|0;Sa=(c[r>>2]|0)+-1|0;c[r>>2]=Sa;c[_a+(Sa<<2)>>2]=Ua;Ua=c[t>>2]|0;Sa=Ya+(c[ia>>2]<<2)|0;r=(c[Sa>>2]|0)+-1|0;c[Sa>>2]=r;c[_a+(r<<2)>>2]=Ua;Ua=c[Ta>>2]|0;r=Ya+(c[Va>>2]<<2)|0;Sa=(c[r>>2]|0)+-1|0;c[r>>2]=Sa;c[_a+(Sa<<2)>>2]=Ua;Ua=c[ia>>2]|0;ia=Ya+(c[Va>>2]<<2)|0;Sa=(c[ia>>2]|0)+-1|0;c[ia>>2]=Sa;c[_a+(Sa<<2)>>2]=Ua;Ua=c[t>>2]|0;Sa=Ya+(c[Ta>>2]<<2)|0;ia=(c[Sa>>2]|0)+-1|0;c[Sa>>2]=ia;c[_a+(ia<<2)>>2]=Ua;Ua=c[Va>>2]|0;Va=Ya+(c[Ta>>2]<<2)|0;Ta=(c[Va>>2]|0)+-1|0;c[Va>>2]=Ta;c[_a+(Ta<<2)>>2]=Ua;Wa=Wa+1|0;if(Wa>>>0>=(c[s>>2]|0)>>>0){$a=Za;ab=Ya;break}else t=t+k|0}}}else{k=f+28|0;t=c[v>>2]|0;Ya=f+32|0;if(c[Ya>>2]|0){Za=c[w>>2]|0;s=c[k>>2]|0;Wa=0;while(1){_a=Za+(e[s>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;_a=Za+(e[s+2>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;_a=Za+(e[s+4>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;Wa=Wa+1|0;if(Wa>>>0>=(c[Ya>>2]|0)>>>0)break;else s=s+t|0}}t=f+40|0;s=c[fa>>2]|0;Wa=f+44|0;if(!(c[Wa>>2]|0))bb=c[w>>2]|0;else{f=c[w>>2]|0;w=c[t>>2]|0;Za=0;while(1){_a=f+(e[w>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;_a=f+(e[w+2>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;_a=f+(e[w+4>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;_a=f+(e[w+6>>1]<<2)|0;c[_a>>2]=(c[_a>>2]|0)+2;Za=Za+1|0;if(Za>>>0>=(c[Wa>>2]|0)>>>0){bb=f;break}else w=w+s|0}}s=c[ga>>2]|0;w=bb+(s<<2)|0;if(s)if((s|0)==1){cb=1;db=0}else{s=bb+4|0;f=c[bb>>2]|0;Za=bb;do{Za=Za+4|0;f=(c[s>>2]|0)+f|0;c[Za>>2]=f;s=s+4|0}while((s|0)!=(w|0));w=c[ga>>2]|0;cb=w;db=w+-1|0}else{cb=0;db=-1}w=c[bb+(db<<2)>>2]|0;c[l>>2]=0;xUa(y,w,l);l=c[v>>2]|0;if(c[Ya>>2]|0){v=c[y>>2]|0;w=c[k>>2]|0;k=0;while(1){db=e[w+2>>1]|0;s=e[w>>1]|0;f=bb+(s<<2)|0;Za=(c[f>>2]|0)+-1|0;c[f>>2]=Za;c[v+(Za<<2)>>2]=db;Za=e[w+4>>1]|0;_a=(c[f>>2]|0)+-1|0;c[f>>2]=_a;c[v+(_a<<2)>>2]=Za;_a=bb+(db<<2)|0;f=(c[_a>>2]|0)+-1|0;c[_a>>2]=f;c[v+(f<<2)>>2]=Za;f=(c[_a>>2]|0)+-1|0;c[_a>>2]=f;c[v+(f<<2)>>2]=s;f=bb+(Za<<2)|0;Za=(c[f>>2]|0)+-1|0;c[f>>2]=Za;c[v+(Za<<2)>>2]=s;s=(c[f>>2]|0)+-1|0;c[f>>2]=s;c[v+(s<<2)>>2]=db;k=k+1|0;if(k>>>0>=(c[Ya>>2]|0)>>>0)break;else w=w+l|0}}l=c[fa>>2]|0;if(!(c[Wa>>2]|0)){$a=cb;ab=bb}else{fa=c[y>>2]|0;w=c[t>>2]|0;t=0;while(1){Ya=e[w+2>>1]|0;k=e[w>>1]|0;v=bb+(k<<2)|0;db=(c[v>>2]|0)+-1|0;c[v>>2]=db;c[fa+(db<<2)>>2]=Ya;db=e[w+6>>1]|0;s=(c[v>>2]|0)+-1|0;c[v>>2]=s;c[fa+(s<<2)>>2]=db;s=e[w+4>>1]|0;v=bb+(Ya<<2)|0;f=(c[v>>2]|0)+-1|0;c[v>>2]=f;c[fa+(f<<2)>>2]=s;f=(c[v>>2]|0)+-1|0;c[v>>2]=f;c[fa+(f<<2)>>2]=k;f=bb+(s<<2)|0;v=(c[f>>2]|0)+-1|0;c[f>>2]=v;c[fa+(v<<2)>>2]=db;v=(c[f>>2]|0)+-1|0;c[f>>2]=v;c[fa+(v<<2)>>2]=Ya;Ya=bb+(db<<2)|0;db=(c[Ya>>2]|0)+-1|0;c[Ya>>2]=db;c[fa+(db<<2)>>2]=k;k=(c[Ya>>2]|0)+-1|0;c[Ya>>2]=k;c[fa+(k<<2)>>2]=s;t=t+1|0;if(t>>>0>=(c[Wa>>2]|0)>>>0){$a=cb;ab=bb;break}else w=w+l|0}}}c[A>>2]=0;c[z>>2]=0;c[z+4>>2]=0;l=z+8|0;c[l>>2]=0;xUa(z,$a,A);c[B>>2]=0;A=B+4|0;c[A>>2]=0;w=B+8|0;c[w>>2]=0;bb=c[x>>2]|0;if(bb)yUa(B,bb);if($a>>>0>1){$a=c[y>>2]|0;bb=c[z>>2]|0;x=1;cb=0;while(1){Wa=ab+(x<<2)|0;if(cb>>>0<(c[Wa>>2]|0)>>>0){t=cb;while(1){fa=c[$a+(t<<2)>>2]|0;c[C>>2]=fa;s=bb+(fa<<2)|0;do if((c[s>>2]|0)!=(x|0)){c[s>>2]=x;k=c[A>>2]|0;if((c[w>>2]&2147483647)>>>0<=k>>>0){cUa(B,C)|0;break}Ya=(c[B>>2]|0)+(k<<2)|0;if(Ya)c[Ya>>2]=fa;c[A>>2]=k+1}while(0);fa=t+1|0;if(fa>>>0<(c[Wa>>2]|0)>>>0)t=fa;else{eb=fa;break}}}else eb=cb;c[Wa>>2]=c[A>>2];x=x+1|0;if(x>>>0>=(c[ga>>2]|0)>>>0)break;else cb=eb}}eb=c[$>>2]|0;c[E>>2]=0;c[D>>2]=0;c[D+4>>2]=0;cb=D+8|0;c[cb>>2]=0;xUa(D,eb,E);c[F>>2]=0;E=F+4|0;c[E>>2]=0;eb=F+8|0;c[eb>>2]=0;if(c[$>>2]|0){ga=c[D>>2]|0;x=G+4|0;A=G+8|0;C=0;do{c[ga+(C<<2)>>2]=-1;do if(a[(c[_>>2]|0)+C>>0]|0){c[G>>2]=C;g[x>>2]=ea(3402823469999999843913219.0e14);c[A>>2]=0;bb=c[E>>2]|0;if((c[eb>>2]&2147483647)>>>0<=bb>>>0){MUa(F,G)|0;break}$a=(c[F>>2]|0)+(bb*12|0)|0;if($a){c[$a+0>>2]=c[G+0>>2];c[$a+4>>2]=c[G+4>>2];c[$a+8>>2]=c[G+8>>2]}c[E>>2]=bb+1}while(0);C=C+1|0}while(C>>>0<(c[$>>2]|0)>>>0);C=c[E>>2]|0;if(C){c[H>>2]=0;G=H+4|0;c[G>>2]=0;A=H+8|0;c[A>>2]=0;c[I>>2]=0;x=I+4|0;c[x>>2]=0;ga=I+8|0;c[ga>>2]=0;c[J>>2]=0;yUa(H,C);Wa=C+1|0;if(Wa)yUa(I,Wa);Wa=c[D>>2]|0;bb=c[B>>2]|0;$a=N+4|0;t=N+8|0;fa=0;s=c[F>>2]|0;k=C;C=0;while(1){Ya=k+-1|0;db=s+(Ya*12|0)|0;c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[s+0>>2]=c[db+0>>2];c[s+4>>2]=c[db+4>>2];c[s+8>>2]=c[db+8>>2];c[db+0>>2]=c[j+0>>2];c[db+4>>2]=c[j+4>>2];c[db+8>>2]=c[j+8>>2];d:do if((Ya|0)>1){db=1;v=0;while(1){f=db+1|0;if((f|0)<(Ya|0)){fb=ea(g[s+(db*12|0)+4>>2]);Za=ea(g[s+(f*12|0)+4>>2])<fb;gb=Za?f:db}else gb=db;fb=ea(g[s+(v*12|0)+4>>2]);if(!(ea(g[s+(gb*12|0)+4>>2])<fb))break d;f=s+(gb*12|0)|0;Za=s+(v*12|0)|0;c[j+0>>2]=c[Za+0>>2];c[j+4>>2]=c[Za+4>>2];c[j+8>>2]=c[Za+8>>2];c[Za+0>>2]=c[f+0>>2];c[Za+4>>2]=c[f+4>>2];c[Za+8>>2]=c[f+8>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];db=gb<<1|1;if((db|0)>=(Ya|0))break;else v=gb}}while(0);Ya=(c[E>>2]|0)+-1|0;v=c[F>>2]|0;db=c[v+(Ya*12|0)>>2]|0;fb=ea(g[v+(Ya*12|0)+4>>2]);c[E>>2]=Ya;f=Wa+(db<<2)|0;do if((c[f>>2]|0)==-1){Za=fa+1|0;c[J>>2]=Za;c[K>>2]=fa;_a=c[x>>2]|0;if((c[ga>>2]&2147483647)>>>0>_a>>>0){Ua=(c[I>>2]|0)+(_a<<2)|0;if(Ua)c[Ua>>2]=fa;c[x>>2]=_a+1}else cUa(I,K)|0;_a=C+1|0;c[f>>2]=C;c[L>>2]=db;Ua=c[G>>2]|0;if((c[A>>2]&2147483647)>>>0<=Ua>>>0){cUa(H,L)|0;hb=Za;ib=ea(0.0);jb=_a;break}Ta=(c[H>>2]|0)+(Ua<<2)|0;if(Ta)c[Ta>>2]=db;c[G>>2]=Ua+1;hb=Za;ib=ea(0.0);jb=_a}else{hb=fa;ib=fb;jb=C}while(0);_a=c[ab+(db<<2)>>2]|0;Za=c[ab+(db+1<<2)>>2]|0;if(_a>>>0<Za>>>0){fb=ea(ib+ea(1.0));Ua=hb;Ta=Ya;Va=v;ia=_a;while(1){_a=c[bb+(ia<<2)>>2]|0;c[M>>2]=_a;e:do if((a[(c[_>>2]|0)+_a>>0]|0)!=0?(c[Wa+(_a<<2)>>2]|0)==-1:0){Sa=c[G>>2]|0;if((c[A>>2]&2147483647)>>>0>Sa>>>0){r=(c[H>>2]|0)+(Sa<<2)|0;if(r)c[r>>2]=_a;c[G>>2]=Sa+1;kb=_a}else{cUa(H,M)|0;kb=c[M>>2]|0}Sa=Ua+1|0;c[J>>2]=Sa;c[Wa+(kb<<2)>>2]=c[f>>2];c[N>>2]=kb;g[$a>>2]=fb;c[t>>2]=0;if((c[eb>>2]&2147483647)>>>0>Ta>>>0){r=Va+(Ta*12|0)|0;if(!r)lb=Ta;else{c[r+0>>2]=c[N+0>>2];c[r+4>>2]=c[N+4>>2];c[r+8>>2]=c[N+8>>2];lb=c[E>>2]|0}r=lb+1|0;c[E>>2]=r;mb=r}else{MUa(F,N)|0;mb=c[E>>2]|0}r=c[F>>2]|0;if((mb|0)<=0){nb=Sa;ob=r;pb=mb;break}Ra=((mb*12|0)/12|0)+-1|0;if(!Ra){nb=Sa;ob=r;pb=mb;break}else qb=Ra;while(1){Ra=qb;qb=(qb+-1|0)>>>1;rb=ea(g[r+(qb*12|0)+4>>2]);if(!(ea(g[r+(Ra*12|0)+4>>2])<rb)){nb=Sa;ob=r;pb=mb;break e}Qa=r+(Ra*12|0)|0;Ra=r+(qb*12|0)|0;c[j+0>>2]=c[Ra+0>>2];c[j+4>>2]=c[Ra+4>>2];c[j+8>>2]=c[Ra+8>>2];c[Ra+0>>2]=c[Qa+0>>2];c[Ra+4>>2]=c[Qa+4>>2];c[Ra+8>>2]=c[Qa+8>>2];c[Qa+0>>2]=c[j+0>>2];c[Qa+4>>2]=c[j+4>>2];c[Qa+8>>2]=c[j+8>>2];if(!qb){nb=Sa;ob=r;pb=mb;break}}}else{nb=Ua;ob=Va;pb=Ta}while(0);ia=ia+1|0;if((ia|0)==(Za|0)){sb=nb;tb=ob;ub=pb;break}else{Ua=nb;Ta=pb;Va=ob}}}else{sb=hb;tb=v;ub=Ya}if(!ub)break;else{fa=sb;s=tb;k=ub;C=jb}}C=c[x>>2]|0;if((c[ga>>2]&2147483647)>>>0>C>>>0){ub=(c[I>>2]|0)+(C<<2)|0;if(ub)c[ub>>2]=sb;c[x>>2]=C+1}else cUa(I,J)|0;J=da(c[$>>2]|0,jb)|0;g[P>>2]=ea(3402823469999999843913219.0e14);c[O>>2]=0;c[O+4>>2]=0;C=O+8|0;c[C>>2]=0;GUa(O,J,P);c[R>>2]=0;c[Q>>2]=0;c[Q+4>>2]=0;P=Q+8|0;c[P>>2]=0;xUa(Q,J,R);c[S>>2]=0;R=S+4|0;c[R>>2]=0;J=S+8|0;c[J>>2]=0;x=(jb|0)==0;if(!x){sb=c[O>>2]|0;ub=c[Q>>2]|0;k=c[I>>2]|0;tb=c[B>>2]|0;s=V+4|0;fa=V+8|0;hb=c[H>>2]|0;ob=U+4|0;pb=U+8|0;nb=0;do{c[R>>2]=0;mb=c[$>>2]|0;qb=da(mb,nb)|0;if(mb){mb=0;do{E=mb+qb|0;c[ub+(E<<2)>>2]=mb;g[sb+(E<<2)>>2]=ea(3402823469999999843913219.0e14);mb=mb+1|0}while(mb>>>0<(c[$>>2]|0)>>>0)}mb=c[k+(nb<<2)>>2]|0;nb=nb+1|0;Ya=c[k+(nb<<2)>>2]|0;if(mb>>>0<Ya>>>0){v=0;E=mb;do{mb=c[hb+(E<<2)>>2]|0;g[sb+(mb+qb<<2)>>2]=ea(0.0);c[U>>2]=mb;g[ob>>2]=ea(0.0);c[pb>>2]=0;if((c[J>>2]&2147483647)>>>0>v>>>0){mb=(c[S>>2]|0)+(v*12|0)|0;if(mb){c[mb+0>>2]=c[U+0>>2];c[mb+4>>2]=c[U+4>>2];c[mb+8>>2]=c[U+8>>2]}c[R>>2]=v+1}else MUa(S,U)|0;E=E+1|0;v=c[R>>2]|0}while((E|0)!=(Ya|0));if(v){Ya=c[S>>2]|0;E=v;while(1){mb=E+-1|0;N=Ya+(mb*12|0)|0;c[j+0>>2]=c[Ya+0>>2];c[j+4>>2]=c[Ya+4>>2];c[j+8>>2]=c[Ya+8>>2];c[Ya+0>>2]=c[N+0>>2];c[Ya+4>>2]=c[N+4>>2];c[Ya+8>>2]=c[N+8>>2];c[N+0>>2]=c[j+0>>2];c[N+4>>2]=c[j+4>>2];c[N+8>>2]=c[j+8>>2];f:do if((mb|0)>1){N=1;lb=0;while(1){t=N+1|0;if((t|0)<(mb|0)){ib=ea(g[Ya+(N*12|0)+4>>2]);$a=ea(g[Ya+(t*12|0)+4>>2])<ib;vb=$a?t:N}else vb=N;ib=ea(g[Ya+(lb*12|0)+4>>2]);if(!(ea(g[Ya+(vb*12|0)+4>>2])<ib))break f;t=Ya+(vb*12|0)|0;$a=Ya+(lb*12|0)|0;c[j+0>>2]=c[$a+0>>2];c[j+4>>2]=c[$a+4>>2];c[j+8>>2]=c[$a+8>>2];c[$a+0>>2]=c[t+0>>2];c[$a+4>>2]=c[t+4>>2];c[$a+8>>2]=c[t+8>>2];c[t+0>>2]=c[j+0>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];N=vb<<1|1;if((N|0)>=(mb|0))break;else lb=vb}}while(0);mb=(c[R>>2]|0)+-1|0;lb=c[S>>2]|0;N=c[lb+(mb*12|0)>>2]|0;ib=ea(g[lb+(mb*12|0)+4>>2]);c[R>>2]=mb;t=N+qb|0;do if(ib>ea(g[sb+(t<<2)>>2])){wb=lb;xb=mb}else{$a=c[ab+(N<<2)>>2]|0;kb=c[ab+(N+1<<2)>>2]|0;if(($a|0)>=(kb|0)){wb=lb;xb=mb;break}Wa=ub+(t<<2)|0;M=mb;G=lb;_=$a;while(1){$a=c[tb+(_<<2)>>2]|0;bb=c[ba>>2]|0;fb=ea(g[bb+($a*12|0)>>2]);rb=ea(fb-ea(g[bb+(N*12|0)>>2]));fb=ea(g[bb+($a*12|0)+4>>2]);yb=ea(fb-ea(g[bb+(N*12|0)+4>>2]));fb=ea(g[bb+($a*12|0)+8>>2]);zb=ea(fb-ea(g[bb+(N*12|0)+8>>2]));fb=ea(ib+ea(T(ea(ea(ea(rb*rb)+ea(yb*yb))+ea(zb*zb)))));bb=$a+qb|0;L=sb+(bb<<2)|0;g:do if(fb<ea(g[L>>2])){g[L>>2]=fb;c[ub+(bb<<2)>>2]=c[Wa>>2];c[V>>2]=$a;g[s>>2]=fb;c[fa>>2]=0;if((c[J>>2]&2147483647)>>>0>M>>>0){K=G+(M*12|0)|0;if(!K)Ab=M;else{c[K+0>>2]=c[V+0>>2];c[K+4>>2]=c[V+4>>2];c[K+8>>2]=c[V+8>>2];Ab=c[R>>2]|0}K=Ab+1|0;c[R>>2]=K;Bb=K}else{MUa(S,V)|0;Bb=c[R>>2]|0}K=c[S>>2]|0;if((Bb|0)<=0){Cb=K;Db=Bb;break}gb=((Bb*12|0)/12|0)+-1|0;if(!gb){Cb=K;Db=Bb;break}else Eb=gb;while(1){gb=Eb;Eb=(Eb+-1|0)>>>1;zb=ea(g[K+(Eb*12|0)+4>>2]);if(!(ea(g[K+(gb*12|0)+4>>2])<zb)){Cb=K;Db=Bb;break g}Va=K+(gb*12|0)|0;gb=K+(Eb*12|0)|0;c[j+0>>2]=c[gb+0>>2];c[j+4>>2]=c[gb+4>>2];c[j+8>>2]=c[gb+8>>2];c[gb+0>>2]=c[Va+0>>2];c[gb+4>>2]=c[Va+4>>2];c[gb+8>>2]=c[Va+8>>2];c[Va+0>>2]=c[j+0>>2];c[Va+4>>2]=c[j+4>>2];c[Va+8>>2]=c[j+8>>2];if(!Eb){Cb=K;Db=Bb;break}}}else{Cb=G;Db=M}while(0);_=_+1|0;if((_|0)==(kb|0)){wb=Cb;xb=Db;break}else{M=Db;G=Cb}}}while(0);if(!xb)break;else{Ya=wb;E=xb}}}}}while((nb|0)!=(jb|0))}nb=jb>>>0>4?4:jb;xb=da(c[$>>2]|0,nb)|0;wb=d+84|0;c[W>>2]=0;xUa(wb,xb,W);W=d+96|0;g[X>>2]=ea(0.0);GUa(W,xb,X);X=c[$>>2]|0;if(X){xb=(nb|0)==0;nb=c[Q>>2]|0;Cb=c[O>>2]|0;Db=Y+4|0;Bb=Y+8|0;Eb=~jb;V=Eb>>>0>4294967291?Eb:-5;Eb=V+1|0;Ab=~V;V=X;X=0;do{c[R>>2]=0;h:do if(x)Fb=0;else{fa=0;s=V;ub=0;while(1){sb=(da(s,ub)|0)+X|0;ib=ea(g[Cb+(sb<<2)>>2]);c[Y>>2]=c[nb+(sb<<2)>>2];g[Db>>2]=ib;c[Bb>>2]=0;if((c[J>>2]&2147483647)>>>0>fa>>>0){sb=c[S>>2]|0;tb=sb+(fa*12|0)|0;if(tb){c[tb+0>>2]=c[Y+0>>2];c[tb+4>>2]=c[Y+4>>2];c[tb+8>>2]=c[Y+8>>2]}tb=fa+1|0;c[R>>2]=tb;Gb=sb;Hb=tb}else{MUa(S,Y)|0;Gb=c[S>>2]|0;Hb=c[R>>2]|0}i:do if((Hb|0)>0){tb=((Hb*12|0)/12|0)+-1|0;if(!tb)break;else Ib=tb;do{tb=Ib;Ib=(Ib+-1|0)>>>1;ib=ea(g[Gb+(Ib*12|0)+4>>2]);if(!(ea(g[Gb+(tb*12|0)+4>>2])<ib))break i;sb=Gb+(tb*12|0)|0;tb=Gb+(Ib*12|0)|0;c[j+0>>2]=c[tb+0>>2];c[j+4>>2]=c[tb+4>>2];c[j+8>>2]=c[tb+8>>2];c[tb+0>>2]=c[sb+0>>2];c[tb+4>>2]=c[sb+4>>2];c[tb+8>>2]=c[sb+8>>2];c[sb+0>>2]=c[j+0>>2];c[sb+4>>2]=c[j+4>>2];c[sb+8>>2]=c[j+8>>2]}while((Ib|0)!=0)}while(0);sb=ub+1|0;if((sb|0)==(jb|0)){Fb=Hb;break h}fa=Hb;s=c[$>>2]|0;ub=sb}}while(0);if(!xb){ub=c[S>>2]|0;s=Fb;fa=0;do{s=s+-1|0;sb=ub+(s*12|0)|0;c[j+0>>2]=c[ub+0>>2];c[j+4>>2]=c[ub+4>>2];c[j+8>>2]=c[ub+8>>2];c[ub+0>>2]=c[sb+0>>2];c[ub+4>>2]=c[sb+4>>2];c[ub+8>>2]=c[sb+8>>2];c[sb+0>>2]=c[j+0>>2];c[sb+4>>2]=c[j+4>>2];c[sb+8>>2]=c[j+8>>2];j:do if((s|0)>1){sb=1;tb=0;while(1){vb=sb+1|0;if((vb|0)<(s|0)){ib=ea(g[ub+(sb*12|0)+4>>2]);U=ea(g[ub+(vb*12|0)+4>>2])<ib;Jb=U?vb:sb}else Jb=sb;ib=ea(g[ub+(tb*12|0)+4>>2]);if(!(ea(g[ub+(Jb*12|0)+4>>2])<ib))break j;vb=ub+(Jb*12|0)|0;U=ub+(tb*12|0)|0;c[j+0>>2]=c[U+0>>2];c[j+4>>2]=c[U+4>>2];c[j+8>>2]=c[U+8>>2];c[U+0>>2]=c[vb+0>>2];c[U+4>>2]=c[vb+4>>2];c[U+8>>2]=c[vb+8>>2];c[vb+0>>2]=c[j+0>>2];c[vb+4>>2]=c[j+4>>2];c[vb+8>>2]=c[j+8>>2];sb=Jb<<1|1;if((sb|0)>=(s|0))break;else tb=Jb}}while(0);tb=c[ub+(s*12|0)>>2]|0;if((tb|0)==(X|0))Kb=ea(0.0);else{ib=ea(g[ub+(s*12|0)+4>>2]);sb=c[ba>>2]|0;fb=ea(g[sb+(X*12|0)>>2]);zb=ea(fb-ea(g[sb+(tb*12|0)>>2]));fb=ea(g[sb+(X*12|0)+4>>2]);yb=ea(fb-ea(g[sb+(tb*12|0)+4>>2]));fb=ea(g[sb+(X*12|0)+8>>2]);rb=ea(fb-ea(g[sb+(tb*12|0)+8>>2]));fb=ea(T(ea(ea(ea(zb*zb)+ea(yb*yb))+ea(rb*rb))));c[Z>>2]=0;rb=ea(dU(d,X,tb,Z));yb=(c[Z>>2]|0)<0?ib:rb;Kb=fb>yb?fb:yb}sb=(da(c[$>>2]|0,fa)|0)+X|0;c[(c[wb>>2]|0)+(sb<<2)>>2]=tb;g[(c[W>>2]|0)+(sb<<2)>>2]=Kb;fa=fa+1|0}while((fa|0)!=(Ab|0));c[R>>2]=Eb+Fb}X=X+1|0;V=c[$>>2]|0}while(X>>>0<V>>>0)}V=c[S>>2]|0;S=c[J>>2]|0;if(!((S|0)<0|(S&2147483647|0)==0|(V|0)==0)){S=mKa()|0;In[c[(c[S>>2]|0)+12>>2]&4095](S,V)}V=c[P>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[Q>>2]|0,(V|0)!=0):0){Q=mKa()|0;In[c[(c[Q>>2]|0)+12>>2]&4095](Q,V)}V=c[C>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[O>>2]|0,(V|0)!=0):0){O=mKa()|0;In[c[(c[O>>2]|0)+12>>2]&4095](O,V)}V=c[ga>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[I>>2]|0,(V|0)!=0):0){I=mKa()|0;In[c[(c[I>>2]|0)+12>>2]&4095](I,V)}V=c[A>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[H>>2]|0,(V|0)!=0):0){H=mKa()|0;In[c[(c[H>>2]|0)+12>>2]&4095](H,V)}}}V=c[F>>2]|0;F=c[eb>>2]|0;if(!((F|0)<0|(F&2147483647|0)==0|(V|0)==0)){F=mKa()|0;In[c[(c[F>>2]|0)+12>>2]&4095](F,V)}V=c[cb>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[D>>2]|0,(V|0)!=0):0){D=mKa()|0;In[c[(c[D>>2]|0)+12>>2]&4095](D,V)}V=c[w>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[B>>2]|0,(V|0)!=0):0){B=mKa()|0;In[c[(c[B>>2]|0)+12>>2]&4095](B,V)}V=c[l>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[z>>2]|0,(V|0)!=0):0){z=mKa()|0;In[c[(c[z>>2]|0)+12>>2]&4095](z,V)}V=c[u>>2]|0;if((V&2147483647|0)!=0&(V|0)>-1?(V=c[y>>2]|0,(V|0)!=0):0){y=mKa()|0;In[c[(c[y>>2]|0)+12>>2]&4095](y,V)}V=c[Xa>>2]|0;if((V|0)<0|(V&2147483647|0)==0|(ab|0)==0){i=h;return}V=mKa()|0;In[c[(c[V>>2]|0)+12>>2]&4095](V,ab);i=h;return}function bU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;d=i;i=i+192|0;e=d+24|0;f=d+40|0;g=d+168|0;h=d+16|0;j=d;k=d+8|0;l=d+36|0;m=d+32|0;c[g>>2]=0;n=g+4|0;c[n>>2]=0;o=g+8|0;c[o>>2]=0;p=b+24|0;q=c[p>>2]|0;if((q|0)!=0?(NUa(g,q),q=c[p>>2]|0,r=(q|0)/3|0,(q|0)>2):0){q=b+20|0;s=h+4|0;t=j+4|0;u=k+4|0;v=0;do{w=v*3|0;c[h>>2]=c[(c[q>>2]|0)+(w<<2)>>2];c[s>>2]=v;x=c[o>>2]|0;y=c[n>>2]|0;if((x&2147483647)>>>0>y>>>0){z=(c[g>>2]|0)+(y<<3)|0;if(z){A=h;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B}B=y+1|0;c[n>>2]=B;D=B;E=x}else{OUa(g,h)|0;D=c[n>>2]|0;E=c[o>>2]|0}c[j>>2]=c[(c[q>>2]|0)+(w+1<<2)>>2];c[t>>2]=v;if((E&2147483647)>>>0>D>>>0){x=(c[g>>2]|0)+(D<<3)|0;if(x){B=j;y=c[B+4>>2]|0;C=x;c[C>>2]=c[B>>2];c[C+4>>2]=y}y=D+1|0;c[n>>2]=y;F=y;G=E}else{OUa(g,j)|0;F=c[n>>2]|0;G=c[o>>2]|0}c[k>>2]=c[(c[q>>2]|0)+(w+2<<2)>>2];c[u>>2]=v;if((G&2147483647)>>>0>F>>>0){w=(c[g>>2]|0)+(F<<3)|0;if(w){y=k;C=c[y+4>>2]|0;B=w;c[B>>2]=c[y>>2];c[B+4>>2]=C}c[n>>2]=F+1}else OUa(g,k)|0;v=v+1|0}while((v|0)<(r|0))}r=c[g>>2]|0;g=c[n>>2]|0;v=e;c[v>>2]=0;c[v+4>>2]=0;v=e+4|0;a[v>>0]=0;c[e>>2]=f;k=g+-1|0;if((k|0)>0){g=0;F=f;f=32;G=0;u=0;q=k;a:while(1){k=G;j=q;E=u;while(1){if((j|0)>(E|0)){if((j-E|0)>>>0<5)H=E;else break;do{D=H;H=H+1|0;t=H;h=D;while(1){s=c[r+(t<<3)>>2]|0;C=c[r+(h<<3)>>2]|0;if((s|0)==(C|0))I=(c[r+(t<<3)+4>>2]|0)<(c[r+(h<<3)+4>>2]|0);else I=(s|0)<(C|0);h=I?t:h;if((t|0)>=(j|0))break;else t=t+1|0}t=r+(h<<3)|0;C=r+(D<<3)|0;s=t;B=c[s>>2]|0;y=c[s+4>>2]|0;s=C;w=c[s+4>>2]|0;x=t;c[x>>2]=c[s>>2];c[x+4>>2]=w;w=C;c[w>>2]=B;c[w+4>>2]=y}while((H|0)!=(j|0))}if(!k)break a;y=c[F+(k+-1<<2)>>2]|0;w=k+-2|0;k=w;j=y;E=c[F+(w<<2)>>2]|0}w=(j+E|0)/2|0;y=r+(w<<3)|0;B=r+(E<<3)|0;C=c[y>>2]|0;x=c[B>>2]|0;if((C|0)==(x|0))if((c[r+(w<<3)+4>>2]|0)<(c[r+(E<<3)+4>>2]|0))J=33;else{K=C;L=C}else if((C|0)<(x|0))J=33;else{K=x;L=C}if((J|0)==33){J=0;C=B;x=c[C>>2]|0;s=c[C+4>>2]|0;C=y;t=c[C+4>>2]|0;A=B;c[A>>2]=c[C>>2];c[A+4>>2]=t;t=y;c[t>>2]=x;c[t+4>>2]=s;K=c[B>>2]|0;L=x}x=r+(j<<3)|0;s=c[x>>2]|0;if((s|0)==(K|0))if((c[r+(j<<3)+4>>2]|0)<(c[r+(E<<3)+4>>2]|0))J=37;else{M=K;N=L}else if((s|0)<(K|0))J=37;else{M=s;N=L}if((J|0)==37){J=0;s=B;t=c[s>>2]|0;A=c[s+4>>2]|0;s=x;C=c[s+4>>2]|0;z=B;c[z>>2]=c[s>>2];c[z+4>>2]=C;C=x;c[C>>2]=t;c[C+4>>2]=A;M=t;N=c[y>>2]|0}if((M|0)==(N|0)){if((c[r+(j<<3)+4>>2]|0)<(c[r+(w<<3)+4>>2]|0))J=41}else if((M|0)<(N|0))J=41;if((J|0)==41){J=0;w=y;t=c[w>>2]|0;A=c[w+4>>2]|0;w=x;C=c[w+4>>2]|0;z=y;c[z>>2]=c[w>>2];c[z+4>>2]=C;C=x;c[C>>2]=t;c[C+4>>2]=A}A=j+-1|0;C=r+(A<<3)|0;t=y;x=c[t>>2]|0;z=c[t+4>>2]|0;t=C;w=c[t+4>>2]|0;s=y;c[s>>2]=c[t>>2];c[s+4>>2]=w;w=C;c[w>>2]=x;c[w+4>>2]=z;z=r+(A<<3)+4|0;w=x;x=E;s=A;while(1){O=x;while(1){P=O+1|0;Q=r+(P<<3)|0;A=c[Q>>2]|0;if((A|0)==(w|0))if((c[r+(P<<3)+4>>2]|0)<(c[z>>2]|0)){O=P;continue}else{R=s;break}else if((A|0)<(w|0)){O=P;continue}else{R=s;break}}while(1){S=R+-1|0;T=r+(S<<3)|0;A=c[T>>2]|0;if((w|0)==(A|0))if((c[z>>2]|0)<(c[r+(S<<3)+4>>2]|0)){R=S;continue}else break;else if((w|0)<(A|0)){R=S;continue}else break}A=Q;U=c[A>>2]|0;V=c[A+4>>2]|0;if((P|0)>=(S|0))break;A=T;t=c[A+4>>2]|0;y=Q;c[y>>2]=c[A>>2];c[y+4>>2]=t;t=T;c[t>>2]=U;c[t+4>>2]=V;w=c[C>>2]|0;x=P;s=S}s=C;x=c[s+4>>2]|0;w=Q;c[w>>2]=c[s>>2];c[w+4>>2]=x;x=C;c[x>>2]=U;c[x+4>>2]=V;if((P-E|0)<(j-P|0)){if(k>>>0>=(f+-1|0)>>>0){x=f<<1;w=f<<3;if(!w)W=0;else{s=mKa()|0;z=c[(c[s>>2]|0)+8>>2]|0;t=pKa()|0;y=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;W=Bn[z&255](s,w,y?424184:544544,523928,148)|0}YEi(W|0,F|0,k<<2|0)|0;if(g<<24>>24==0|(F|0)==0){X=W;Y=1;Z=x}else{y=mKa()|0;In[c[(c[y>>2]|0)+12>>2]&4095](y,F);X=W;Y=1;Z=x}}else{X=F;Y=g;Z=f}c[X+(k<<2)>>2]=E;c[X+(k+1<<2)>>2]=O;_=Y;$=X;aa=Z;ba=O+2|0;ca=j}else{x=O+2|0;if(k>>>0>=(f+-1|0)>>>0){y=f<<1;w=f<<3;if(!w)da=0;else{s=mKa()|0;z=c[(c[s>>2]|0)+8>>2]|0;t=pKa()|0;A=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;da=Bn[z&255](s,w,A?424184:544544,523928,148)|0}YEi(da|0,F|0,k<<2|0)|0;if(g<<24>>24==0|(F|0)==0){ea=da;fa=1;ga=y}else{A=mKa()|0;In[c[(c[A>>2]|0)+12>>2]&4095](A,F);ea=da;fa=1;ga=y}}else{ea=F;fa=g;ga=f}c[ea+(k<<2)>>2]=x;c[ea+(k+1<<2)>>2]=j;_=fa;$=ea;aa=ga;ba=E;ca=O}g=_;F=$;f=aa;G=k+2|0;u=ba;q=ca}if(!(g<<24>>24==0|(F|0)==0)){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,F)}}if(a[v>>0]|0)tKa(e,c[e>>2]|0);e=b+44|0;v=c[b+4>>2]|0;c[l>>2]=0;xUa(e,v,l);l=b+56|0;v=c[p>>2]|0;F=b+64|0;if((c[F>>2]&2147483647)>>>0<v>>>0)yUa(l,v);v=c[n>>2]|0;if(v){n=b+60|0;b=0;while(1){g=c[r+(b<<3)>>2]|0;c[(c[e>>2]|0)+(g<<2)>>2]=b;b:do if(b>>>0<(c[p>>2]|0)>>>0){ca=b;while(1){if((c[r+(ca<<3)>>2]|0)!=(g|0)){ha=ca;break b}q=c[r+(ca<<3)+4>>2]|0;c[m>>2]=q;ba=c[n>>2]|0;if((c[F>>2]&2147483647)>>>0>ba>>>0){u=(c[l>>2]|0)+(ba<<2)|0;if(!u)ia=ba;else{c[u>>2]=q;ia=c[n>>2]|0}c[n>>2]=ia+1}else cUa(l,m)|0;q=ca+1|0;if(q>>>0<(c[p>>2]|0)>>>0)ca=q;else{ha=q;break}}}else ha=b;while(0);if(ha>>>0<v>>>0)b=ha;else break}}ha=c[o>>2]|0;if((ha|0)<0|(ha&2147483647|0)==0|(r|0)==0){i=d;return}ha=mKa()|0;In[c[(c[ha>>2]|0)+12>>2]&4095](ha,r);i=d;return}function cU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;d=i;i=i+208|0;e=d+20|0;f=d;g=d+56|0;h=d+44|0;j=d+196|0;k=d+8|0;l=d+32|0;m=d+184|0;c[h>>2]=0;n=h+4|0;c[n>>2]=0;o=h+8|0;c[o>>2]=0;p=b+68|0;q=b+20|0;r=b+24|0;b=c[r>>2]|0;c[j>>2]=-1;xUa(p,b,j);j=c[r>>2]|0;r=(j>>>0)/3|0;if(j>>>0>2){j=k+4|0;b=k+8|0;s=l+4|0;t=l+8|0;u=m+4|0;v=m+8|0;w=0;do{x=w*3|0;y=c[q>>2]|0;z=c[y+(x<<2)>>2]|0;A=x+1|0;B=c[y+(A<<2)>>2]|0;C=x+2|0;D=c[y+(C<<2)>>2]|0;c[k>>2]=z;c[j>>2]=B;c[b>>2]=x;if((z|0)>(B|0)){c[k>>2]=B;c[j>>2]=z}x=c[n>>2]|0;if((c[o>>2]&2147483647)>>>0>x>>>0){y=(c[h>>2]|0)+(x*12|0)|0;if(y){c[y+0>>2]=c[k+0>>2];c[y+4>>2]=c[k+4>>2];c[y+8>>2]=c[k+8>>2]}c[n>>2]=x+1}else PUa(h,k)|0;c[l>>2]=B;c[s>>2]=D;c[t>>2]=A;if((B|0)>(D|0)){c[l>>2]=D;c[s>>2]=B}B=c[n>>2]|0;if((c[o>>2]&2147483647)>>>0>B>>>0){A=(c[h>>2]|0)+(B*12|0)|0;if(A){c[A+0>>2]=c[l+0>>2];c[A+4>>2]=c[l+4>>2];c[A+8>>2]=c[l+8>>2]}c[n>>2]=B+1}else PUa(h,l)|0;c[m>>2]=D;c[u>>2]=z;c[v>>2]=C;if((D|0)>(z|0)){c[m>>2]=z;c[u>>2]=D}D=c[n>>2]|0;if((c[o>>2]&2147483647)>>>0>D>>>0){z=(c[h>>2]|0)+(D*12|0)|0;if(z){c[z+0>>2]=c[m+0>>2];c[z+4>>2]=c[m+4>>2];c[z+8>>2]=c[m+8>>2]}c[n>>2]=D+1}else PUa(h,m)|0;w=w+1|0}while(w>>>0<r>>>0);E=(c[n>>2]|0)+-1|0;F=c[h>>2]|0}else{E=-1;F=0}h=f;c[h>>2]=0;c[h+4>>2]=0;h=f+4|0;a[h>>0]=0;c[f>>2]=g;if((E|0)>0){r=0;w=g;g=32;m=0;u=0;v=E;a:while(1){E=m;l=v;s=u;while(1){if((l|0)>(s|0)){if((l-s|0)>>>0<5)G=s;else break;do{t=G;G=G+1|0;k=G;j=t;while(1){b=c[F+(k*12|0)>>2]|0;D=c[F+(j*12|0)>>2]|0;if((b|0)==(D|0))H=(c[F+(k*12|0)+4>>2]|0)<(c[F+(j*12|0)+4>>2]|0);else H=(b|0)<(D|0);j=H?k:j;if((k|0)>=(l|0))break;else k=k+1|0}k=F+(j*12|0)|0;D=F+(t*12|0)|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[D+0>>2]=c[e+0>>2];c[D+4>>2]=c[e+4>>2];c[D+8>>2]=c[e+8>>2]}while((G|0)!=(l|0))}if(!E)break a;D=c[w+(E+-1<<2)>>2]|0;k=E+-2|0;E=k;l=D;s=c[w+(k<<2)>>2]|0}k=(l+s|0)/2|0;D=F+(k*12|0)|0;b=F+(s*12|0)|0;z=c[D>>2]|0;C=c[b>>2]|0;if((z|0)==(C|0))if((c[F+(k*12|0)+4>>2]|0)<(c[F+(s*12|0)+4>>2]|0))I=40;else J=z;else if((z|0)<(C|0))I=40;else J=C;if((I|0)==40){I=0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[b+0>>2]=c[D+0>>2];c[b+4>>2]=c[D+4>>2];c[b+8>>2]=c[D+8>>2];c[D+0>>2]=c[e+0>>2];c[D+4>>2]=c[e+4>>2];c[D+8>>2]=c[e+8>>2];J=c[b>>2]|0}C=F+(l*12|0)|0;z=c[C>>2]|0;if((z|0)==(J|0))if((c[F+(l*12|0)+4>>2]|0)<(c[F+(s*12|0)+4>>2]|0))I=44;else K=J;else if((z|0)<(J|0))I=44;else K=z;if((I|0)==44){I=0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[b+0>>2]=c[C+0>>2];c[b+4>>2]=c[C+4>>2];c[b+8>>2]=c[C+8>>2];c[C+0>>2]=c[e+0>>2];c[C+4>>2]=c[e+4>>2];c[C+8>>2]=c[e+8>>2];K=c[C>>2]|0}b=c[D>>2]|0;if((K|0)==(b|0)){if((c[F+(l*12|0)+4>>2]|0)<(c[F+(k*12|0)+4>>2]|0))I=48}else if((K|0)<(b|0))I=48;if((I|0)==48){I=0;c[e+0>>2]=c[D+0>>2];c[e+4>>2]=c[D+4>>2];c[e+8>>2]=c[D+8>>2];c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[C+0>>2]=c[e+0>>2];c[C+4>>2]=c[e+4>>2];c[C+8>>2]=c[e+8>>2]}C=l+-1|0;b=F+(C*12|0)|0;c[e+0>>2]=c[D+0>>2];c[e+4>>2]=c[D+4>>2];c[e+8>>2]=c[D+8>>2];c[D+0>>2]=c[b+0>>2];c[D+4>>2]=c[b+4>>2];c[D+8>>2]=c[b+8>>2];c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];D=F+(C*12|0)+4|0;k=s;z=C;while(1){C=c[b>>2]|0;L=k;while(1){M=L+1|0;N=F+(M*12|0)|0;B=c[N>>2]|0;if((B|0)==(C|0))if((c[F+(M*12|0)+4>>2]|0)<(c[D>>2]|0)){L=M;continue}else{O=z;break}else if((B|0)<(C|0)){L=M;continue}else{O=z;break}}while(1){P=O+-1|0;Q=F+(P*12|0)|0;B=c[Q>>2]|0;if((C|0)==(B|0))if((c[D>>2]|0)<(c[F+(P*12|0)+4>>2]|0)){O=P;continue}else break;else if((C|0)<(B|0)){O=P;continue}else break}if((M|0)>=(P|0))break;c[e+0>>2]=c[N+0>>2];c[e+4>>2]=c[N+4>>2];c[e+8>>2]=c[N+8>>2];c[N+0>>2]=c[Q+0>>2];c[N+4>>2]=c[Q+4>>2];c[N+8>>2]=c[Q+8>>2];c[Q+0>>2]=c[e+0>>2];c[Q+4>>2]=c[e+4>>2];c[Q+8>>2]=c[e+8>>2];k=M;z=P}c[e+0>>2]=c[N+0>>2];c[e+4>>2]=c[N+4>>2];c[e+8>>2]=c[N+8>>2];c[N+0>>2]=c[b+0>>2];c[N+4>>2]=c[b+4>>2];c[N+8>>2]=c[b+8>>2];c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];if((M-s|0)<(l-M|0)){if(E>>>0>=(g+-1|0)>>>0){z=g<<1;k=g<<3;if(!k)R=0;else{D=mKa()|0;C=c[(c[D>>2]|0)+8>>2]|0;B=pKa()|0;A=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;R=Bn[C&255](D,k,A?424312:544544,523928,148)|0}YEi(R|0,w|0,E<<2|0)|0;if(r<<24>>24==0|(w|0)==0){S=R;T=1;U=z}else{A=mKa()|0;In[c[(c[A>>2]|0)+12>>2]&4095](A,w);S=R;T=1;U=z}}else{S=w;T=r;U=g}c[S+(E<<2)>>2]=s;c[S+(E+1<<2)>>2]=L;V=T;W=S;X=U;Y=L+2|0;Z=l}else{z=L+2|0;if(E>>>0>=(g+-1|0)>>>0){A=g<<1;k=g<<3;if(!k)_=0;else{D=mKa()|0;C=c[(c[D>>2]|0)+8>>2]|0;B=pKa()|0;x=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;_=Bn[C&255](D,k,x?424312:544544,523928,148)|0}YEi(_|0,w|0,E<<2|0)|0;if(r<<24>>24==0|(w|0)==0){$=_;aa=1;ba=A}else{x=mKa()|0;In[c[(c[x>>2]|0)+12>>2]&4095](x,w);$=_;aa=1;ba=A}}else{$=w;aa=r;ba=g}c[$+(E<<2)>>2]=z;c[$+(E+1<<2)>>2]=l;V=aa;W=$;X=ba;Y=s;Z=L}r=V;w=W;g=X;m=E+2|0;u=Y;v=Z}if(!(r<<24>>24==0|(w|0)==0)){r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,w)}}if(a[h>>0]|0)tKa(f,c[f>>2]|0);f=c[n>>2]|0;b:do if((f|0)>0){n=c[q>>2]|0;h=0;while(1){w=F+(h*12|0)+8|0;r=c[w>>2]|0;Z=c[F+(h*12|0)>>2]|0;if((Z|0)==(c[n+(r<<2)>>2]|0)){v=F+(h*12|0)+4|0;if((c[v>>2]|0)==(c[n+((((r|0)%3|0|0)<2?1:-2)+r<<2)>>2]|0)){ca=1;da=v}else{ea=v;I=85}}else{ea=F+(h*12|0)+4|0;I=85}if((I|0)==85){I=0;ca=0;da=ea}v=h;do{v=v+1|0;fa=(v|0)<(f|0);if(!fa)break;if((c[F+(v*12|0)>>2]|0)!=(Z|0))break}while((c[F+(v*12|0)+4>>2]|0)==(c[da>>2]|0));if((v-h|0)>2){ga=1;break b}else ha=h;while(1){ha=ha+1|0;if((ha|0)>=(v|0))break;Z=F+(ha*12|0)+8|0;r=c[Z>>2]|0;if((c[F+(ha*12|0)>>2]|0)==(c[n+(r<<2)>>2]|0)?(c[F+(ha*12|0)+4>>2]|0)==(c[n+((((r|0)%3|0|0)<2?1:-2)+r<<2)>>2]|0):0)ia=1;else ia=0;Y=c[p>>2]|0;c[Y+(c[w>>2]<<2)>>2]=(r>>>0)/3|0;c[Y+(c[Z>>2]<<2)>>2]=((c[w>>2]|0)>>>0)/3|0;if(!(ca^ia)){ga=2;break b}}if(fa)h=v;else{ga=0;break}}}else ga=0;while(0);fa=c[o>>2]|0;if((fa|0)<0|(fa&2147483647|0)==0|(F|0)==0){i=d;return ga|0}fa=mKa()|0;In[c[(c[fa>>2]|0)+12>>2]&4095](fa,F);i=d;return ga|0}function dU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im;f=i;i=i+16|0;h=f;if((b|0)==(d|0)){j=ea(0.0);i=f;return ea(j)}c[e>>2]=0;k=QUa(a,d,b,h)|0;if((k|0)<0){c[e>>2]=-1;j=ea(0.0);i=f;return ea(j)}if((k|0)<=0){j=ea(0.0);i=f;return ea(j)}k=h+12|0;b=h+4|0;l=h+8|0;m=a+20|0;n=a+8|0;o=a+68|0;p=ea(0.0);q=0;a:while(1){r=ea(p+ea(g[k>>2]));s=c[b>>2]|0;do if(c[h>>2]|0){t=QUa(a,d,s,h)|0;if((t|0)<0){u=33;break a}else v=t}else{w=ea(g[l>>2]);t=(s|0)%3|0;x=c[m>>2]|0;y=c[x+(s<<2)>>2]|0;z=c[x+(s-t+((t+1|0)%3|0)<<2)>>2]|0;A=c[n>>2]|0;B=ea(g[A+(y*12|0)>>2]);C=ea(g[A+(y*12|0)+4>>2]);D=ea(g[A+(y*12|0)+8>>2]);E=ea(g[A+(z*12|0)>>2]);F=ea(g[A+(z*12|0)+4>>2]);G=ea(E-B);E=ea(F-C);F=ea(ea(g[A+(z*12|0)+8>>2])-D);H=ea(B+ea(w*G));B=ea(C+ea(w*E));C=ea(D+ea(w*F));w=ea(ea(g[A+(d*12|0)>>2])-H);D=ea(ea(g[A+(d*12|0)+4>>2])-B);I=ea(ea(g[A+(d*12|0)+8>>2])-C);J=c[(c[o>>2]|0)+(s<<2)>>2]|0;if((J|0)==-1){K=ea(ea(ea(G*w)+ea(E*D))+ea(F*I))>ea(0.0);L=K?z:y;M=ea(ea(g[A+(L*12|0)>>2])-H);N=ea(ea(g[A+(L*12|0)+4>>2])-B);O=ea(ea(g[A+(L*12|0)+8>>2])-C);P=ea(T(ea(ea(ea(M*M)+ea(N*N))+ea(O*O))));c[h>>2]=1;c[b>>2]=L;g[l>>2]=ea(0.0);g[k>>2]=P;v=1;break}L=J*3|0;J=c[x+(L<<2)>>2]|0;K=c[x+(L+1<<2)>>2]|0;Q=c[x+(L+2<<2)>>2]|0;x=(J|0)==(y|0);R=(K|0)==(z|0);if(!(x&R)){U=(J|0)==(z|0);V=(K|0)==(y|0);if(!(U&V)){W=(Q|0)==(z|0);X=(Q|0)==(y|0);if(V&W|R&X){Y=1;Z=K;_=Q;$=J}else{R=X&U|W&x;Y=R?2:t;Z=R?Q:J;_=R?J:K;$=R?K:Q}}else{Y=0;Z=z;_=y;$=Q}}else{Y=0;Z=y;_=z;$=Q}if(($|0)==(d|0)){P=ea(T(ea(ea(ea(w*w)+ea(D*D))+ea(I*I))));c[h>>2]=1;c[b>>2]=d;g[l>>2]=ea(0.0);g[k>>2]=P;v=1;break}P=ea(g[A+(Z*12|0)>>2]);O=ea(g[A+(Z*12|0)+4>>2]);N=ea(g[A+(Z*12|0)+8>>2]);M=ea(g[A+(_*12|0)>>2]);aa=ea(g[A+(_*12|0)+4>>2]);ba=ea(g[A+(_*12|0)+8>>2]);ca=ea(g[A+($*12|0)>>2]);da=ea(g[A+($*12|0)+4>>2]);fa=ea(g[A+($*12|0)+8>>2]);ga=ea(P-ca);P=ea(O-da);O=ea(N-fa);N=ea(M-ca);ha=ea(aa-da);ia=ea(ba-fa);ja=ea(ea(P*ia)-ea(ha*O));ka=ea(ea(N*O)-ea(ga*ia));ia=ea(ea(ga*ha)-ea(N*P));N=ea(ea(ia*ia)+ea(ea(ja*ja)+ea(ka*ka)));if(N>ea(0.0)){ha=ea(ea(1.0)/ea(T(ea(N))));la=ea(ja*ha);ma=ea(ka*ha);na=ea(ia*ha)}else{la=ea(0.0);ma=ea(0.0);na=ea(0.0)}ha=ea(ea(I*na)+ea(ea(D*ma)+ea(w*la)));ia=ea(w-ea(la*ha));w=ea(D-ea(ma*ha));D=ea(I-ea(na*ha));ha=ea(ea(D*D)+ea(ea(ia*ia)+ea(w*w)));if(ha>ea(0.0)){I=ea(ea(1.0)/ea(T(ea(ha))));oa=ea(ia*I);pa=ea(w*I);qa=ea(D*I)}else{oa=ea(0.0);pa=ea(0.0);qa=ea(0.0)}I=ea(H-ca);D=ea(B-da);w=ea(C-fa);ia=ea(ea(ea(ga*ga)+ea(P*P))+ea(O*O));ha=ea(ea(O*qa)+ea(ea(P*pa)+ea(ga*oa)));ka=ea(ea(qa*qa)+ea(ea(pa*pa)+ea(oa*oa)));ja=ea(ea(ea(I*ga)+ea(D*P))+ea(w*O));N=ea(-ea(ea(w*qa)+ea(ea(D*pa)+ea(I*oa))));I=ea(ea(ia*ka)-ea(ha*ha));if(!(ea(S(ea(I)))<ea(.0000999999974))?(D=ea(ea(1.0)/I),I=ea(ha*D),ha=ea(ea(ja*ea(ka*D))+ea(I*N)),ha>=ea(-9.99999974e-06)&ha<=ea(1.00001001)&ea(ea(ja*I)+ea(ea(ia*D)*N))>ea(-9.99999974e-06)):0){Q=ha<ea(9.99999974e-06);if(Q|ha>ea(.999989986)){c[h>>2]=1;K=Q?$:Z;c[b>>2]=K;N=ea(ea(g[A+(K*12|0)>>2])-H);D=ea(ea(g[A+(K*12|0)+4>>2])-B);ia=ea(ea(g[A+(K*12|0)+8>>2])-C);g[k>>2]=ea(T(ea(ea(ea(N*N)+ea(D*D))+ea(ia*ia))));v=1;break}else{ia=ea(ea(ca+ea(ga*ha))-H);ga=ea(ea(da+ea(P*ha))-B);P=ea(ea(fa+ea(O*ha))-C);O=ea(T(ea(ea(P*P)+ea(ea(ia*ia)+ea(ga*ga)))));c[h>>2]=0;c[b>>2]=((Y+2|0)%3|0)+L;g[l>>2]=ha;g[k>>2]=O;v=1;break}}O=ea(H-M);ha=ea(B-aa);ga=ea(C-ba);ia=ea(ca-M);ca=ea(da-aa);da=ea(fa-ba);fa=ea(ea(ea(ia*ia)+ea(ca*ca))+ea(da*da));P=ea(ea(da*qa)+ea(ea(ca*pa)+ea(ia*oa)));D=ea(ea(ea(O*ia)+ea(ha*ca))+ea(ga*da));N=ea(-ea(ea(ga*qa)+ea(ea(ha*pa)+ea(O*oa))));O=ea(ea(fa*ka)-ea(P*P));if(!(ea(S(ea(O)))<ea(.0000999999974))?(ha=ea(ea(1.0)/O),O=ea(P*ha),P=ea(ea(D*ea(ka*ha))+ea(O*N)),P>=ea(-9.99999974e-06)&P<=ea(1.00001001)&ea(ea(D*O)+ea(ea(fa*ha)*N))>ea(-9.99999974e-06)):0){K=P<ea(9.99999974e-06);if(K|P>ea(.999989986)){c[h>>2]=1;Q=K?_:$;c[b>>2]=Q;N=ea(ea(g[A+(Q*12|0)>>2])-H);ha=ea(ea(g[A+(Q*12|0)+4>>2])-B);fa=ea(ea(g[A+(Q*12|0)+8>>2])-C);g[k>>2]=ea(T(ea(ea(ea(N*N)+ea(ha*ha))+ea(fa*fa))));v=1;break}else{fa=ea(ea(M+ea(ia*P))-H);ia=ea(ea(aa+ea(ca*P))-B);ca=ea(ea(ba+ea(da*P))-C);da=ea(T(ea(ea(ca*ca)+ea(ea(fa*fa)+ea(ia*ia)))));c[h>>2]=0;c[b>>2]=((Y+1|0)%3|0)+L;g[l>>2]=P;g[k>>2]=da;v=1;break}}da=ea(ea(F*qa)+ea(ea(E*pa)+ea(G*oa)));c[h>>2]=1;L=da>ea(0.0);Q=L?z:y;c[b>>2]=Q;da=ea(ea(g[A+(Q*12|0)>>2])-H);H=ea(ea(g[A+(Q*12|0)+4>>2])-B);B=ea(ea(g[A+(Q*12|0)+8>>2])-C);g[k>>2]=ea(T(ea(ea(ea(da*da)+ea(H*H))+ea(B*B))));v=1}while(0);if((q|0)>1e3){u=35;break}if((v|0)<=0){j=r;u=36;break}p=r;q=q+1|0}if((u|0)==33){c[e>>2]=-2;j=ea(0.0);i=f;return ea(j)}else if((u|0)==35){c[e>>2]=-3;j=ea(0.0);i=f;return ea(j)}else if((u|0)==36){i=f;return ea(j)}return ea(0.0)}function eU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=xCi(24)|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;hU(e,b);c[a>>2]=e;i=d;return}function fU(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}a=c[d+20>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[d+12>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[d+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[d>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}ACi(d);i=b;return}function gU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a>>2]|0;YEi(b|0,c[f>>2]|0,c[f+4>>2]<<2|0)|0;YEi(d|0,c[f+12>>2]|0,c[f+16>>2]<<2|0)|0;i=e;return}function hU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=Im,O=0;d=i;i=i+64|0;e=d+40|0;f=d+24|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;m=c[b+8>>2]|0;n=b+16|0;if(!(c[n>>2]|0)){i=d;return}c[e>>2]=0;o=e+4|0;c[o>>2]=0;p=e+8|0;c[p>>2]=0;q=(m|0)==0;if(!q){vUa(e,m);r=c[b>>2]|0;s=c[b+12>>2]|0;t=f+4|0;u=f+8|0;v=f+12|0;w=c[b+4>>2]|0;b=c[n>>2]|0;n=0;while(1){if(!b){x=0;y=ea(1.0)}else{x=b+s|0;y=ea(g[b>>2])}z=ea(g[w>>2]);g[f>>2]=z;A=ea(g[w+4>>2]);g[t>>2]=A;B=ea(g[w+8>>2]);w=w+r|0;g[u>>2]=B;g[v>>2]=y;C=c[o>>2]|0;if((c[p>>2]&2147483647)>>>0>C>>>0){D=c[e>>2]|0;E=D+(C<<4)|0;if(E){g[E>>2]=z;g[D+(C<<4)+4>>2]=A;g[D+(C<<4)+8>>2]=B;g[D+(C<<4)+12>>2]=y}c[o>>2]=C+1}else wUa(e,f)|0;n=n+1|0;if((n|0)==(m|0))break;else b=x}}c[h>>2]=0;x=h+4|0;c[x>>2]=0;b=h+8|0;c[b>>2]=0;c[j>>2]=0;if(!q){q=c[e>>2]|0;n=0;do{do if(ea(g[q+(n<<4)+12>>2])==ea(0.0)){f=c[x>>2]|0;if((c[b>>2]&2147483647)>>>0<=f>>>0){cUa(h,j)|0;F=c[j>>2]|0;break}o=(c[h>>2]|0)+(f<<2)|0;if(o)c[o>>2]=n;c[x>>2]=f+1;F=n}else F=n;while(0);n=F+1|0;c[j>>2]=n}while(n>>>0<m>>>0);n=c[x>>2]|0;x=(n|0)==0;j=x?0:m;if(j){F=a+8|0;q=a+12|0;f=a+20|0;o=c[e>>2]|0;v=c[h>>2]|0;u=a+4|0;r=a+16|0;w=0;do{if((c[F>>2]&2147483647)>>>0<m>>>0)yUa(a,m);if((c[f>>2]&2147483647)>>>0<m>>>0)HUa(q,m);y=ea(g[o+(w<<4)>>2]);B=ea(g[o+(w<<4)+4>>2]);A=ea(g[o+(w<<4)+8>>2]);c[k>>2]=m;t=v+(n<<2)|0;if(x){G=m;H=ea(3402823469999999843913219.0e14)}else{s=m;C=v;z=ea(3402823469999999843913219.0e14);while(1){D=c[C>>2]|0;I=ea(ea(g[o+(D<<4)>>2])-y);J=ea(ea(g[o+(D<<4)+4>>2])-B);K=ea(ea(g[o+(D<<4)+8>>2])-A);L=ea(ea(ea(I*I)+ea(J*J))+ea(K*K));if(z>L){c[k>>2]=D;M=D;N=L}else{M=s;N=z}C=C+4|0;if((C|0)==(t|0)){G=M;H=N;break}else{s=M;z=N}}}s=c[u>>2]|0;if((c[F>>2]&2147483647)>>>0>s>>>0){t=(c[a>>2]|0)+(s<<2)|0;if(!t)O=s;else{c[t>>2]=G;O=c[u>>2]|0}c[u>>2]=O+1}else cUa(a,k)|0;z=ea(T(ea(H)));g[l>>2]=z;t=c[r>>2]|0;if((c[f>>2]&2147483647)>>>0>t>>>0){s=(c[q>>2]|0)+(t<<2)|0;if(s)g[s>>2]=z;c[r>>2]=t+1}else RUa(q,l)|0;w=w+1|0}while((w|0)!=(j|0))}}j=c[b>>2]|0;if((j&2147483647|0)!=0&(j|0)>-1?(j=c[h>>2]|0,(j|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,j)}j=c[p>>2]|0;if(!((j&2147483647|0)!=0&(j|0)>-1)){i=d;return}j=c[e>>2]|0;if(!j){i=d;return}e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,j);i=d;return}function iU(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0;l=i;i=i+48|0;k=l+32|0;m=l+24|0;n=l+16|0;o=l+8|0;p=l;if(!((e&32|0)==0&(g&32|0)==0)){b[j>>1]=20;b[d>>1]=0;i=l;return}if(!(a[(c[h>>2]|0)+(424576+(c[f>>2]<<5))>>0]|0)){b[d>>1]=2;i=l;return}g=c[f+8>>2]|0;e=c[f+12>>2]|0;f=k;c[f>>2]=0;c[f+4>>2]=0;b[k>>1]=g;b[k+2>>1]=g>>>16;b[k+4>>1]=e;b[k+6>>1]=e>>>16;e=c[h+8>>2]|0;g=c[h+12>>2]|0;h=m;c[h>>2]=0;c[h+4>>2]=0;b[m>>1]=e;b[m+2>>1]=e>>>16;b[m+4>>1]=g;b[m+6>>1]=g>>>16;g=n;c[g>>2]=0;c[g+4>>2]=0;co[c[425616>>2]&2047](n,k,425600);k=o;c[k>>2]=0;c[k+4>>2]=0;co[c[425616>>2]&2047](o,m,425608);m=p;c[m>>2]=0;c[m+4>>2]=0;co[c[425616>>2]&2047](p,n,o);o=c[p>>2]|0;if((o&65535)<<16>>16==0&o>>>0<65536){o=c[p+4>>2]|0;q=o>>>0>65535|(o&65535)<<16>>16!=0}else q=1;if(!(q&1)){b[j>>1]=1025;b[d>>1]=0;i=l;return}else{b[d>>1]=2;i=l;return}}function jU(a){a=a|0;a=i;gKa();i=a;return 1}function kU(){var a=0;a=i;hKa();i=a;return}function lU(a,b){a=a|0;b=b|0;var c=0,d=Im,e=0,f=Im,h=Im,j=0,k=Im,l=0,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0;c=i;d=ea(g[b>>2]);e=d==ea(0.0);f=ea(g[b+4>>2]);if(e&f==ea(0.0)?ea(g[b+8>>2])==ea(0.0):0){i=c;return}e=a+44|0;h=ea(g[e>>2]);j=a+40|0;k=ea(g[j>>2]);l=a+36|0;m=ea(g[l>>2]);n=ea(m+d);d=ea(k+f);o=b+8|0;f=ea(h+ea(g[o>>2]));p=ea(h*ea(0.0));q=ea(k*ea(-0.0));r=ea(h*m);s=ea(ea(0.0)-ea(h*h));t=ea(k*k);u=ea(k*m);v=ea(s-t);w=ea(ea(p+p)+u);p=ea(q+ea(q+r));q=ea(h*ea(-0.0));x=ea(h*k);y=ea(m*ea(0.0));z=ea(m*m);A=ea(ea(q+q)+u);u=ea(s-z);s=ea(y+ea(x+y));y=ea(k*ea(0.0));q=ea(m*ea(-0.0));B=ea(y+ea(y+r));r=ea(q+ea(x+q));q=ea(ea(ea(-z)-t)+ea(0.0));if(n==ea(0.0)&d==ea(0.0)&f==ea(0.0)){t=ea(g[a+48>>2]);z=ea(v*t);x=ea(w*t);y=ea(p*t);C=ea(A*t);D=ea(u*t);E=ea(s*t);F=ea(B*t);G=ea(r*t);H=ea(q*t);g[a>>2]=ea(z+ea(g[a>>2]));I=a+4|0;g[I>>2]=ea(x+ea(g[I>>2]));I=a+8|0;g[I>>2]=ea(y+ea(g[I>>2]));I=a+12|0;g[I>>2]=ea(C+ea(g[I>>2]));I=a+16|0;g[I>>2]=ea(D+ea(g[I>>2]));I=a+20|0;g[I>>2]=ea(E+ea(g[I>>2]));I=a+24|0;g[I>>2]=ea(F+ea(g[I>>2]));I=a+28|0;g[I>>2]=ea(G+ea(g[I>>2]));I=a+32|0;g[I>>2]=ea(H+ea(g[I>>2]))}else{H=ea(f*ea(0.0));G=ea(d*ea(-0.0));F=ea(n*f);E=ea(ea(0.0)-ea(f*f));D=ea(d*d);C=ea(n*d);y=ea(f*ea(-0.0));x=ea(d*f);f=ea(n*ea(0.0));z=ea(n*n);t=ea(d*ea(0.0));d=ea(n*ea(-0.0));n=ea(v-ea(E-D));v=ea(w-ea(C+ea(H+H)));H=ea(p-ea(G+ea(G+F)));G=ea(A-ea(C+ea(y+y)));y=ea(u-ea(E-z));E=ea(s-ea(f+ea(f+x)));f=ea(B-ea(t+ea(t+F)));F=ea(r-ea(d+ea(d+x)));x=ea(q-ea(ea(ea(-z)-D)+ea(0.0)));D=ea(g[a+48>>2]);z=ea(n*D);n=ea(v*D);v=ea(H*D);H=ea(G*D);G=ea(y*D);y=ea(E*D);E=ea(f*D);f=ea(F*D);F=ea(x*D);g[a>>2]=ea(z+ea(g[a>>2]));I=a+4|0;g[I>>2]=ea(n+ea(g[I>>2]));I=a+8|0;g[I>>2]=ea(v+ea(g[I>>2]));I=a+12|0;g[I>>2]=ea(H+ea(g[I>>2]));I=a+16|0;g[I>>2]=ea(G+ea(g[I>>2]));I=a+20|0;g[I>>2]=ea(y+ea(g[I>>2]));I=a+24|0;g[I>>2]=ea(E+ea(g[I>>2]));I=a+28|0;g[I>>2]=ea(f+ea(g[I>>2]));I=a+32|0;g[I>>2]=ea(F+ea(g[I>>2]))}g[l>>2]=ea(ea(g[b>>2])+m);g[j>>2]=ea(ea(g[b+4>>2])+k);g[e>>2]=ea(ea(g[o>>2])+h);i=c;return}function mU(a,b,c,d){a=a|0;b=ea(b);c=c|0;d=d|0;var e=0,f=0,h=0;e=i;i=i+16|0;f=e;g[f>>2]=b;h=WUa(0,a,f,1,c,d)|0;i=e;return h|0}function nU(a,b,c,d){a=a|0;b=ea(b);c=c|0;d=d|0;var e=0,f=0,h=0;e=i;i=i+16|0;f=e;g[f>>2]=b;h=XUa(0,a,f,1,c,d)|0;i=e;return h|0}function oU(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;YUa(a,b,c,d,e);i=f;return}function pU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;e=i;i=i+80|0;f=e+56|0;h=e+28|0;j=e;In[c[(c[b>>2]|0)+84>>2]&4095](h,b);In[c[(c[b>>2]|0)+124>>2]&4095](j,b);k=ea(ea(g[j+16>>2])*ea(2.0));l=ea(ea(g[j+20>>2])*ea(2.0));m=ea(ea(g[j+24>>2])*ea(2.0));n=ea(g[h+12>>2]);o=ea(ea(n*n)+ea(-.5));p=ea(g[h>>2]);q=ea(k*p);r=ea(g[h+4>>2]);s=ea(q+ea(l*r));q=ea(g[h+8>>2]);t=ea(s+ea(m*q));s=ea(ea(p*t)+ea(ea(k*o)+ea(n*ea(ea(m*r)-ea(l*q)))));u=ea(ea(r*t)+ea(ea(l*o)+ea(n*ea(ea(k*q)-ea(m*p)))));v=ea(ea(ea(m*o)+ea(n*ea(ea(l*p)-ea(k*r))))+ea(q*t));t=ea(ea(g[h+16>>2])+s);s=ea(ea(g[h+20>>2])+u);u=ea(ea(g[h+24>>2])+v);v=ea(ea(g[d>>2])-t);t=ea(ea(g[d+4>>2])-s);s=ea(ea(g[d+8>>2])-u);In[c[(c[b>>2]|0)+152>>2]&4095](a,b);In[c[(c[b>>2]|0)+160>>2]&4095](f,b);u=ea(g[f+4>>2]);q=ea(s*u);r=ea(g[f+8>>2]);k=ea(q-ea(t*r));q=ea(v*r);r=ea(g[f>>2]);p=ea(q-ea(s*r));s=ea(ea(t*r)-ea(v*u));g[a>>2]=ea(k+ea(g[a>>2]));f=a+4|0;g[f>>2]=ea(p+ea(g[f>>2]));f=a+8|0;g[f>>2]=ea(s+ea(g[f>>2]));i=e;return}function qU(a){a=a|0;c[a>>2]=a+4;c[a+260>>2]=0;c[a+264>>2]=64;return}function rU(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=c[a>>2]|0;if((d|0)==(a+4|0)){i=b;return}VJa(b,d);i=b;return}function sU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h+2|0;k=h+1|0;l=h;m=b+264|0;n=sQa(d,e,f,g,c[b>>2]|0,c[m>>2]|0,0,j)|0;if(!(a[j>>0]|0))o=n;else{n=c[f+36>>2]|0;p=mo[c[(c[n>>2]|0)+32>>2]&4095](n)|0;if(!p){c[b+260>>2]=0;q=0;i=h;return q|0}n=c[m>>2]|0;r=c[b>>2]|0;if(n>>>0<p>>>0){if((r|0)!=(b+4|0))VJa(k,r);k=UJa(l,p<<2,426768,70)|0;c[b>>2]=k;c[m>>2]=p;s=k;t=p}else{s=r;t=n}o=sQa(d,e,f,g,s,t,0,j)|0}c[b+260>>2]=o;q=o;i=h;return q|0}function tU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h+2|0;k=h+1|0;l=h;a[j>>0]=1;m=b+264|0;n=b+4|0;o=c[b>>2]|0;p=c[m>>2]|0;while(1){q=tQa(d,e,f,g,o,p,0,j)|0;if(!(a[j>>0]|0)){r=6;break}s=c[m>>2]|0;p=s<<1;t=c[b>>2]|0;if((t|0)!=(n|0))VJa(k,t);o=UJa(l,s<<3,426768,95)|0;c[b>>2]=o;c[m>>2]=p;if(!(a[j>>0]|0)){r=6;break}}if((r|0)==6){c[b+260>>2]=q;i=h;return q|0}return 0}function uU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!a){i=f;return a|0}g=(bKa()|0)+116|0;YJa(g,8,c[426864+(a<<2)>>2]|0,d,e);if(!b){i=f;return a|0}YJa(g,1,b,d,e);i=f;return a|0}function vU(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=0;return}function wU(a){a=a|0;return}function xU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;f=mo[c[(c[d>>2]|0)+4>>2]&4095](d)|0;g=b+4|0;h=c[g>>2]|0;if(!h){j=c[d>>2]|0;k=j+16|0;l=c[k>>2]|0;m=c[b>>2]|0;In[l&4095](d,m);i=e;return}n=c[h+40>>2]|0;o=(n|0)==0;if(!o){p=h;q=0;r=0;do{r=((_n[c[(c[f>>2]|0)+8>>2]&4095](f,c[(c[p+36>>2]|0)+(q<<3)+4>>2]|0)|0)&1^1)+r|0;q=q+1|0;p=c[g>>2]|0}while((q|0)!=(n|0));q=(r|0)!=0;if(q){s=pY(c[107930]|0)|0;if(r>>>0<n>>>0){t=n-r|0;r=s+44|0;if((c[r>>2]&2147483647)>>>0<t>>>0)$Ua(s,t);if(o){u=q;v=s}else{o=s+40|0;t=s+36|0;w=0;do{x=c[(c[g>>2]|0)+36>>2]|0;y=x+(w<<3)|0;z=x+(w<<3)+4|0;do if(_n[c[(c[f>>2]|0)+8>>2]&4095](f,c[z>>2]|0)|0){x=c[o>>2]|0;if((c[r>>2]&2147483647)>>>0<=x>>>0){aVa(s,y)|0;break}A=(c[t>>2]|0)+(x<<3)|0;if(!A)B=x;else{a[A>>0]=a[y>>0]|0;c[A+4>>2]=c[z>>2];B=c[o>>2]|0}c[o>>2]=B+1}while(0);w=w+1|0}while((w|0)!=(n|0));u=q;v=s}}else{u=1;v=s}}else{u=0;v=p}}else{u=0;v=h}In[c[(c[d>>2]|0)+12>>2]&4095](d,16);co[c[(c[d>>2]|0)+8>>2]&2047](d,v,48);if(((a[v+32>>0]|0)==0?(h=c[v+36>>2]|0,(h|0)!=0):0)?(p=c[v+44>>2]|0,!((c[v+40>>2]|0)==0&(p&2147483647|0)==0)):0)co[c[(c[d>>2]|0)+8>>2]&2047](d,h,p<<3);if(!u){j=c[d>>2]|0;k=j+16|0;l=c[k>>2]|0;m=c[b>>2]|0;In[l&4095](d,m);i=e;return}qY(c[107930]|0,v);j=c[d>>2]|0;k=j+16|0;l=c[k>>2]|0;m=c[b>>2]|0;In[l&4095](d,m);i=e;return}function yU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+4|0;a=c[e>>2]|0;if(!a){i=d;return}f=c[a+40>>2]|0;if(!f){i=d;return}g=a;a=0;while(1){h=(c[g+36>>2]|0)+(a<<3)+4|0;j=c[h>>2]|0;if(j)c[h>>2]=xo[c[c[b>>2]>>2]&2047](b,-2147483648,j)|0;j=a+1|0;if((j|0)==(f|0))break;g=c[e>>2]|0;a=j}i=d;return}function zU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=b+4|0;b=c[f>>2]|0;if(!b){i=e;return}g=c[b+40>>2]|0;if(!g){i=e;return}else{h=g;j=b;k=0}a:while(1){b=h;g=j;while(1){b=b+-1|0;l=c[g+36>>2]|0;if(a[l+(k<<3)>>0]|0)break;m=c[l+(k<<3)+4>>2]|0;NX(m,d);l=rX(m)|0;if((l|0)!=0?(X3(l+16|0,m+16|0),n=l+3528|0,o=c[n>>2]|0,(o|0)!=0):0){p=c[l+3524>>2]|0;l=0;while(1){q=l+1|0;if((c[p+(l<<2)>>2]|0)==(m|0)){r=l;break}if(q>>>0<o>>>0)l=q;else{r=q;break}}if((r|0)!=(o|0)){l=o+-1|0;c[n>>2]=l;c[p+(r<<2)>>2]=c[p+(l<<2)>>2]}}l=c[f>>2]|0;m=c[l+36>>2]|0;q=l+40|0;l=(c[q>>2]|0)+-1|0;c[q>>2]=l;q=m+(l<<3)|0;l=c[q+4>>2]|0;s=m+(k<<3)|0;c[s>>2]=c[q>>2];c[s+4>>2]=l;l=c[f>>2]|0;if(!(c[l+40>>2]|0)){if((c[l+44>>2]|0)>-1)qY(c[107930]|0,l);c[f>>2]=0;t=0}else t=l;if(!b){u=18;break a}else g=t}if(!b){u=18;break}else{h=b;j=g;k=k+1|0}}if((u|0)==18){i=e;return}}function AU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+4>>2]|0;if(!e){i=d;return}TU(c[(c[e+36>>2]|0)+4>>2]|0,b,0)|0;i=d;return}function BU(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[a+4>>2]|0;if(!g){h=-1;i=f;return h|0}a=c[g+40>>2]|0;if(!a){h=-1;i=f;return h|0}j=c[g+36>>2]|0;g=0;while(1){if((d[j+(g<<3)>>0]|0|0)==(b|0)?(c[j+(g<<3)+4>>2]|0)==(e|0):0){h=g;k=7;break}g=g+1|0;if(g>>>0>=a>>>0){h=-1;k=7;break}}if((k|0)==7){i=f;return h|0}return 0}function CU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=b+4|0;b=c[h>>2]|0;if(!b){j=pY(c[107930]|0)|0;c[h>>2]=j;k=j}else k=b;b=c[k+44>>2]|0;if((b|0)<=-1?(c[k+40>>2]|0)==(b&2147483647|0):0){b=pY(c[107930]|0)|0;j=c[h>>2]|0;l=c[j+36>>2]|0;bVa(b,c[j+40>>2]<<3>>3);j=c[b+36>>2]|0;m=c[b+40>>2]|0;n=j+(m<<3)|0;if((m|0)>0){m=j;j=l;while(1){if(m){a[m>>0]=a[j>>0]|0;c[m+4>>2]=c[j+4>>2]}m=m+8|0;if(m>>>0>=n>>>0)break;else j=j+8|0}}j=c[h>>2]|0;n=c[j+44>>2]|0;do if((n&2147483647|0)!=0&(n|0)>-1){m=c[j+36>>2]|0;if((j|0)==(m|0)){a[j+32>>0]=0;break}if(m){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,m)}}while(0);c[h>>2]=b;o=b}else o=k;k=d&255;a[g>>0]=k;c[g+4>>2]=e;d=o+40|0;b=c[d>>2]|0;if((c[o+44>>2]&2147483647)>>>0<=b>>>0){aVa(o,g)|0;i=f;return}g=(c[o+36>>2]|0)+(b<<3)|0;if(!g)p=b;else{a[g>>0]=k;c[g+4>>2]=e;p=c[d>>2]|0}c[d>>2]=p+1;i=f;return}function DU(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;g=i;b=a+4|0;a=c[b>>2]|0;if(!a){i=g;return}h=a+40|0;j=c[h>>2]|0;k=c[a+36>>2]|0;a:do if(!j)l=-1;else{a=0;while(1){if((d[k+(a<<3)>>0]|0|0)==(e|0)?(c[k+(a<<3)+4>>2]|0)==(f|0):0){l=a;break a}a=a+1|0;if(a>>>0>=j>>>0){l=-1;break}}}while(0);f=j+-1|0;c[h>>2]=f;h=k+(f<<3)|0;f=c[h+4>>2]|0;j=k+(l<<3)|0;c[j>>2]=c[h>>2];c[j+4>>2]=f;f=c[b>>2]|0;if(c[f+40>>2]|0){i=g;return}if((c[f+44>>2]|0)>-1)qY(c[107930]|0,f);c[b>>2]=0;i=g;return}function EU(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[a+4>>2]|0;if(!f){g=0;i=e;return g|0}a=c[f+40>>2]|0;if(!a){g=0;i=e;return g|0}h=c[f+36>>2]|0;f=0;j=0;while(1){k=((d[h+(f<<3)>>0]|0|0)==(b|0)&1)+j|0;f=f+1|0;if(f>>>0>=a>>>0){g=k;break}else j=k}i=e;return g|0}function FU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+4|0;g=c[f>>2]|0;a:do if((g|0)!=0?(h=g+40|0,j=c[h>>2]|0,(j|0)!=0):0){k=c[g+36>>2]|0;l=0;while(1){m=k+(l<<3)|0;n=l+1|0;if((a[m>>0]|0)==1)break;if(n>>>0<j>>>0)l=n;else break a}n=k+(l<<3)+4|0;if(c[n>>2]|0){if(d){c[n>>2]=d;i=e;return}n=j+-1|0;c[h>>2]=n;o=k+(n<<3)|0;n=c[o+4>>2]|0;p=m;c[p>>2]=c[o>>2];c[p+4>>2]=n;n=c[f>>2]|0;if(c[n+40>>2]|0){i=e;return}if((c[n+44>>2]|0)>-1)qY(c[107930]|0,n);c[f>>2]=0;i=e;return}}while(0);CU(b,1,d,426944);i=e;return}function GU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[b+4>>2]|0;a:do if((e|0)!=0?(b=c[e+40>>2]|0,(b|0)!=0):0){f=c[e+36>>2]|0;g=0;while(1){h=g+1|0;if((a[f+(g<<3)>>0]|0)==1)break;if(h>>>0<b>>>0)g=h;else{j=0;break a}}j=c[f+(g<<3)+4>>2]|0}else j=0;while(0);i=d;return j|0}function HU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[b+4>>2]|0;if(!e){i=d;return}b=c[e+36>>2]|0;f=c[e+40>>2]|0;if(!f){i=d;return}else g=0;while(1){if(!(a[b+(g<<3)>>0]|0)){e=c[b+(g<<3)+4>>2]|0;if(!e){h=14;break}j=rX(e)|0;if(j){k=j+3528|0;l=c[k>>2]|0;if(l){m=c[j+3524>>2]|0;n=0;while(1){o=n+1|0;if((c[m+(n<<2)>>2]|0)==(e|0)){p=n;break}if(o>>>0<l>>>0)n=o;else{p=o;break}}if((p|0)!=(l|0)){n=l+-1|0;c[k>>2]=n;c[m+(p<<2)>>2]=c[m+(n<<2)>>2]}}X3(j+16|0,e+16|0)}}g=g+1|0;if(g>>>0>=f>>>0){h=14;break}}if((h|0)==14){i=d;return}}function IU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=c[b+4>>2]|0;if(!f){i=d;return}b=c[f+36>>2]|0;g=c[f+40>>2]|0;if(!g){i=d;return}f=0;while(1){if(!(a[b+(f<<3)>>0]|0)){h=c[b+(f<<3)+4>>2]|0;if(!h){j=14;break}ko[c[(c[h>>2]|0)+36>>2]&4095](h);k=qX(h)|0;if(k){l=k+3524|0;c[e>>2]=h;m=k+3528|0;n=c[m>>2]|0;if((c[k+3532>>2]&2147483647)>>>0>n>>>0){o=(c[l>>2]|0)+(n<<2)|0;if(o)c[o>>2]=h;c[m>>2]=n+1}else cVa(l,e)|0;W3(k+16|0,h+16|0)}}f=f+1|0;if(f>>>0>=g>>>0){j=14;break}}if((j|0)==14){i=d;return}}function JU(a){a=a|0;var c=0,d=0,e=0;c=i;d=b[a+4>>1]|0;if(d<<16>>16==15)e=a+20|0;else if(d<<16>>16==6)e=a+20|0;else if(d<<16>>16==5)e=a+20|0;else e=1;i=c;return e|0}function KU(a){a=a|0;var b=0,d=0,f=0;b=i;d=c[a+(c[427044+((e[a+4>>1]|0)<<2)>>2]|0)>>2]|0;if(!d){f=0;i=b;return f|0}f=P3(d)|0;i=b;return f|0}function LU(a){a=a|0;var b=0,d=0,f=0,g=0;b=i;d=c[427044+((e[a+4>>1]|0)<<2)>>2]|0;if((((c[a+(d+4)>>2]|0)>>>30)+-1|0)>>>0>=2){f=0;i=b;return f|0}g=c[a+d>>2]|0;if(!g){f=0;i=b;return f|0}f=P3(g)|0;i=b;return f|0}function MU(a){a=a|0;var b=0;b=i;eY(c[107930]|0,a);i=b;return}function NU(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;i=i+16|0;b[d+4>>1]=13;b[d+6>>1]=3;c[d>>2]=427352;c[d+8>>2]=0;c[d+16>>2]=0;c[d+20>>2]=d;c[d+24>>2]=-1;c[d+28>>2]=e;a[d+32>>0]=f&1;c[d+12>>2]=167772160;c[d+36>>2]=0;c[d+40>>2]=UJa(g,e<<2,427424,58)|0;i=g;return}function OU(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[a>>2]=427352;nY(c[107930]|0,a);if(!(b[a+6>>1]&1)){VJa(e,a);i=d;return}VJa(e,c[a+40>>2]|0);VJa(e,a);i=d;return}function PU(a){a=a|0;var d=0;d=i;i=i+16|0;c[a>>2]=427352;nY(c[107930]|0,a);if(!(b[a+6>>1]&1)){i=d;return}VJa(d,c[a+40>>2]|0);i=d;return}function QU(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(d=c[a+8>>2]|0,(d|0)!=0):0)f=P3(d)|0;else f=0;KZ(c[108764]|0,a,0,1);d=a+36|0;if(c[d>>2]|0){g=a+40|0;h=a+8|0;j=0;do{k=c[(c[g>>2]|0)+(j<<2)>>2]|0;if((mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0)==4)c[(c[(c[(c[g>>2]|0)+(j<<2)>>2]|0)+288>>2]|0)+100>>2]=0;k=c[(c[g>>2]|0)+(j<<2)>>2]|0;l=e[k+4>>1]|0;m=k+(c[427044+(l<<2)>>2]|0)|0;FU(k+(c[426976+(l<<2)>>2]|0)|0,0,k);u3(h,m,1);j=j+1|0}while(j>>>0<(c[d>>2]|0)>>>0)}if(!f){n=a+8|0;v3(n);i=b;return}b4(f+16|0,a+8|0);d=f+3564|0;j=c[d>>2]|0;if(!j){n=a+8|0;v3(n);i=b;return}h=c[f+3560>>2]|0;f=0;while(1){g=f+1|0;if((c[h+(f<<2)>>2]|0)==(a|0)){o=f;break}if(g>>>0<j>>>0)f=g;else{o=g;break}}if((o|0)==(j|0)){n=a+8|0;v3(n);i=b;return}f=j+-1|0;c[d>>2]=f;c[h+(o<<2)>>2]=c[h+(f<<2)>>2];n=a+8|0;v3(n);i=b;return}function RU(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0;f=i;if((mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0)!=4){t3(a+8|0,b+(c[427044+((e[b+4>>1]|0)<<2)>>2]|0)|0);l$(d,b);i=f;return}if(mo[c[(c[b>>2]|0)+28>>2]&4095](b)|0){i=f;return}g=c[b+288>>2]|0;b=c[g+88>>2]|0;if(mo[c[(c[g>>2]|0)+108>>2]&4095](g)|0){h=a+8|0;a=0;do{t3(h,(c[b+(a<<2)>>2]|0)+48|0);a=a+1|0}while(a>>>0<(mo[c[(c[g>>2]|0)+108>>2]&4095](g)|0)>>>0)}y$(d,g);i=f;return}function SU(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;f=d;if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(g=c[a+8>>2]|0,(g|0)!=0):0)h=P3(g)|0;else h=0;g=a+36|0;if((c[g>>2]|0)==(c[a+28>>2]|0)){dKa(bKa()|0,2,427424,145,427504,f);j=0;i=d;return j|0}if(mo[c[(c[b>>2]|0)+80>>2]&4095](b)|0){dKa(bKa()|0,2,427424,151,427576,f);j=0;i=d;return j|0}if(mo[c[(c[b>>2]|0)+28>>2]&4095](b)|0){dKa(bKa()|0,2,427424,157,427664,f);j=0;i=d;return j|0}if((mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0)==4){dKa(bKa()|0,2,427424,163,427744,f);j=0;i=d;return j|0}FU(b+(c[426976+((e[b+4>>1]|0)<<2)>>2]|0)|0,a,b);f=c[g>>2]|0;c[g>>2]=f+1;c[(c[a+40>>2]|0)+(f<<2)>>2]=b;if(!h){j=1;i=d;return j|0}RU(a,b,h);j=1;i=d;return j|0}function TU(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=a+36|0;j=c[h>>2]|0;a:do if(j){k=c[a+40>>2]|0;l=0;while(1){m=k+(l<<2)|0;l=l+1|0;if((c[m>>2]|0)==(b|0))break;if(l>>>0>=j>>>0)break a}l=j+-1|0;c[h>>2]=l;c[m>>2]=c[k+(l<<2)>>2];if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(l=c[a+8>>2]|0,(l|0)!=0):0)P3(l)|0;l=e[b+4>>1]|0;n=b+(c[427044+(l<<2)>>2]|0)|0;FU(b+(c[426976+(l<<2)>>2]|0)|0,0,b);u3(a+8|0,n,d);o=1;i=f;return o|0}while(0);dKa(bKa()|0,2,427424,194,427840,g);o=0;i=f;return o|0}function UU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(f=c[a+8>>2]|0,(f|0)!=0):0)P3(f)|0;if((mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0)==4){dKa(bKa()|0,2,427424,206,427912,e);g=0;i=d;return g|0}else{g=TU(a,b,1)|0;i=d;return g|0}return 0}function VU(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;f=d;if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(g=c[a+8>>2]|0,(g|0)!=0):0)h=P3(g)|0;else h=0;g=a+36|0;j=c[g>>2]|0;k=(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0)+j|0;j=a+8|0;if(k>>>0>(c[a+28>>2]|0)>>>0){dKa(bKa()|0,2,427424,227,428e3,f);l=0;i=d;return l|0}if(mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0){dKa(bKa()|0,2,427424,233,428072,f);l=0;i=d;return l|0}if(mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0){dKa(bKa()|0,2,427424,239,428168,f);l=0;i=d;return l|0}c[b+100>>2]=a;f=c[b+88>>2]|0;if(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0){k=a+40|0;m=0;do{n=c[f+(m<<2)>>2]|0;FU(n+(c[426976+((e[n+4>>1]|0)<<2)>>2]|0)|0,a,n);o=c[g>>2]|0;c[g>>2]=o+1;c[(c[k>>2]|0)+(o<<2)>>2]=n;t3(j,n+48|0);m=m+1|0}while(m>>>0<(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0)>>>0)}if(!h){l=1;i=d;return l|0}y$(h,b);l=1;i=d;return l|0}function WU(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f;h=a+36|0;do if(c[h>>2]|0){j=a+40|0;k=a+12|0;l=a+8|0;m=a+8|0;n=0;o=0;a:while(1){p=n;while(1){q=c[(c[j>>2]|0)+(o<<2)>>2]|0;if((mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0)!=4)break;q=c[j>>2]|0;r=q+(o<<2)|0;s=c[r>>2]|0;if((c[s+288>>2]|0)!=(b|0))break;t=(c[h>>2]|0)+-1|0;c[h>>2]=t;c[r>>2]=c[q+(t<<2)>>2];if((((c[k>>2]|0)>>>30)+-1|0)>>>0<2?(t=c[l>>2]|0,(t|0)!=0):0)P3(t)|0;t=e[s+4>>1]|0;q=s+(c[427044+(t<<2)>>2]|0)|0;FU(s+(c[426976+(t<<2)>>2]|0)|0,0,s);u3(m,q,d);if(o>>>0<(c[h>>2]|0)>>>0)p=1;else{u=11;break a}}o=o+1|0;if(o>>>0>=(c[h>>2]|0)>>>0){u=13;break}else n=p}if((u|0)==11){c[b+100>>2]=0;v=1;i=f;return v|0}else if((u|0)==13){c[b+100>>2]=0;if(p)v=1;else break;i=f;return v|0}}else c[b+100>>2]=0;while(0);dKa(bKa()|0,2,427424,289,428264,g);v=0;i=f;return v|0}function XU(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=WU(a,b,1)|0;i=c;return d|0}function YU(a){a=a|0;return c[a+36>>2]|0}function ZU(a){a=a|0;return c[a+28>>2]|0}function _U(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=(c[a+36>>2]|0)-e|0;h=(g|0)<0?0:g;g=h>>>0<d>>>0?h:d;YEi(b|0,(c[a+40>>2]|0)+(e<<2)|0,g<<2|0)|0;i=f;return g|0}function $U(a){a=a|0;var b=0,d=0,e=0;b=i;if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(d=c[a+8>>2]|0,(d|0)!=0):0)e=P3(d)|0;else e=0;i=b;return e|0}function aV(b){b=b|0;return (a[b+32>>0]|0)!=0|0}function bV(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+40|0;if(!(c[e>>2]|0)){i=d;return}In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[e>>2]|0,c[a+36>>2]<<2);i=d;return}function cV(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+36|0;if(!(c[f>>2]|0)){i=e;return}g=a+40|0;a=0;do{h=c[(c[g>>2]|0)+(a<<2)>>2]|0;if((h|0)==0?1:(b[h+4>>1]|0)!=15)In[c[(c[d>>2]|0)+8>>2]&4095](d,h);else{j=mo[c[(c[h>>2]|0)+224>>2]&4095](h)|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,j)}a=a+1|0}while(a>>>0<(c[f>>2]|0)>>>0);i=e;return}function dV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+92>>2]|0;if(!e){i=d;return}f=a+88|0;a=0;do{In[c[(c[b>>2]|0)+8>>2]&4095](b,c[(c[f>>2]|0)+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(e|0));i=d;return}function eV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(((a[b+84>>0]|0)==0?(f=c[b+88>>2]|0,(f|0)!=0):0)?(g=c[b+96>>2]|0,!((c[b+92>>2]|0)==0&(g&2147483647|0)==0)):0)co[c[(c[d>>2]|0)+8>>2]&2047](d,f,g<<2);In[c[(c[d>>2]|0)+16>>2]&4095](d,c[b+104>>2]|0);i=e;return}function fV(d){d=d|0;var e=0,f=0,h=0;e=i;b[d+4>>1]=14;b[d+6>>1]=3;c[d>>2]=428376;c[d+12>>2]=0;c[d+20>>2]=0;f=d+16|0;c[f>>2]=0;h=d+24|0;t7(h);c[f>>2]=c[f>>2]&-251658241|134217728;g[d+60>>2]=ea(D7(h));a[d+64>>0]=1;c[d+92>>2]=0;a[d+84>>0]=1;c[d+88>>2]=d+68;c[d+96>>2]=4;c[d+100>>2]=0;c[d+104>>2]=0;c[d+8>>2]=0;i=e;return}function gV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[b>>2]=428376;iY(c[107930]|0,b);f=c[b+96>>2]|0;do if((f&2147483647|0)!=0&(f|0)>-1){g=c[b+88>>2]|0;if((b+68|0)==(g|0)){a[b+84>>0]=0;break}if(g){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,g)}}while(0);VJa(e,b);i=d;return}function hV(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=428376;iY(c[107930]|0,b);e=c[b+96>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=d;return}e=c[b+88>>2]|0;if((b+68|0)==(e|0)){a[b+84>>0]=0;i=d;return}if(!e){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,e);i=d;return}function iV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);d=a+92|0;e=c[d>>2]|0;if(e){f=a+88|0;g=e;e=0;while(1){h=(e>>>0)%(g>>>0)|0;j=c[(c[f>>2]|0)+(h<<2)>>2]|0;if(!(mo[c[(c[j>>2]|0)+232>>2]&4095](j)|0)){JW(c[(c[f>>2]|0)+(h<<2)>>2]|0);k=h}else k=h+1|0;g=c[d>>2]|0;if(!g)break;else e=k}}if((((((c[a+16>>2]|0)>>>30)+-1|0)>>>0<2?(k=c[a+12>>2]|0,(k|0)!=0):0)?(e=P3(k)|0,(e|0)!=0):0)?(Z3(e+16|0,a+12|0),k=e+3552|0,g=c[k>>2]|0,(g|0)!=0):0){f=c[e+3548>>2]|0;e=0;while(1){h=e+1|0;if((c[f+(e<<2)>>2]|0)==(a|0)){l=e;break}if(h>>>0<g>>>0)e=h;else{l=h;break}}if((l|0)!=(g|0)){e=g+-1|0;c[k>>2]=e;c[f+(l<<2)>>2]=c[f+(e<<2)>>2]}}c[d>>2]=0;v3(a+12|0);i=b;return}function jV(a){a=a|0;var b=0,d=0,e=0;b=i;if((((c[a+16>>2]|0)>>>30)+-1|0)>>>0<2?(d=c[a+12>>2]|0,(d|0)!=0):0)e=P3(d)|0;else e=0;i=b;return e|0}function kV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+16>>2]|0;if(!(d&1)){e=v7(a+24|0)|0;i=b;return e|0}f=a+20|0;g=c[f>>2]|0;if(!g){h=s4(c[a+12>>2]|0,d>>>24&15)|0;c[f>>2]=h;j=h}else j=g;e=c[j>>2]|0;i=b;return e|0}function lV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+12|0;g=b+24|0;h=b+16|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))l=4;else m=f;else if((k|0)==3)m=f;else l=4;if((l|0)==4){w7(g,d);i=e;return}g=b+20|0;b=c[g>>2]|0;if(!b){l=s4(c[m>>2]|0,j>>>24&15)|0;c[g>>2]=l;n=l}else n=b;c[n>>2]=d;r4(c[m>>2]|0,f);c[h>>2]=c[h>>2]|1;i=e;return}function mV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+16>>2]|0;if(!(d&2)){e=x7(a+24|0)|0;i=b;return e|0}f=a+20|0;g=c[f>>2]|0;if(!g){h=s4(c[a+12>>2]|0,d>>>24&15)|0;c[f>>2]=h;j=h}else j=g;e=c[j+4>>2]|0;i=b;return e|0}function nV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+12|0;g=b+24|0;h=b+16|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){y7(g,d);i=e;return}g=b+20|0;b=c[g>>2]|0;if(!b){m=s4(c[l>>2]|0,j>>>24&15)|0;c[g>>2]=m;n=m}else n=b;c[n+4>>2]=d;r4(c[l>>2]|0,f);c[h>>2]=c[h>>2]|2;i=e;return}function oV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+16>>2]|0;if(!(d&4)){e=z7(a+24|0)|0;i=b;return e|0}f=a+20|0;g=c[f>>2]|0;if(!g){h=s4(c[a+12>>2]|0,d>>>24&15)|0;c[f>>2]=h;j=h}else j=g;e=c[j+8>>2]|0;i=b;return e|0}function pV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+12|0;g=b+24|0;h=b+16|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){A7(g,d);i=e;return}g=b+20|0;b=c[g>>2]|0;if(!b){m=s4(c[l>>2]|0,j>>>24&15)|0;c[g>>2]=m;n=m}else n=b;c[n+8>>2]=d;r4(c[l>>2]|0,f);c[h>>2]=c[h>>2]|4;i=e;return}function qV(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+16>>2]|0;if(!(d&8)){e=ea(B7(a+24|0));i=b;return ea(e)}f=a+20|0;h=c[f>>2]|0;if(!h){j=s4(c[a+12>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+12>>2]);i=b;return ea(e)}function rV(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+12|0;h=b+24|0;j=b+16|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){C7(h,d);i=e;return}h=b+20|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+12>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|8;i=e;return}function sV(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=d+12|0;j=(f<<8|e&255)&65535;e=d+24|0;f=d+16|0;k=c[f>>2]|0;l=k>>>30;if((l|0)==3)m=h;else if((l|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)m=h;else n=4;if((n|0)==4){N7(e,j);i=g;return}e=d+20|0;d=c[e>>2]|0;if(!d){n=s4(c[m>>2]|0,k>>>24&15)|0;c[e>>2]=n;o=n}else o=d;b[o+20>>1]=j;r4(c[m>>2]|0,h);c[f>>2]=c[f>>2]|32;i=g;return}function tV(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=c[a+16>>2]|0;if(!(g&32))h=M7(a+24|0)|0;else{j=a+20|0;k=c[j>>2]|0;if(!k){l=s4(c[a+12>>2]|0,g>>>24&15)|0;c[j>>2]=l;m=l}else m=k;h=b[m+20>>1]|0}m=h&65535;c[e>>2]=m>>>8;c[d>>2]=m&255;i=f;return}function uV(b){b=b|0;var d=0,e=0;d=i;if((((c[b+16>>2]|0)>>>30)+-1|0)>>>0<2?(e=c[b+12>>2]|0,(e|0)!=0):0)P3(e)|0;i=d;return (a[b+64>>0]|0)!=0|0}function vV(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+12|0;h=b+24|0;j=b+16|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){K7(h,d);i=e;return}h=b+20|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+16>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|16;i=e;return}function wV(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+16>>2]|0;if(!(d&16)){e=ea(J7(a+24|0));i=b;return ea(e)}f=a+20|0;h=c[f>>2]|0;if(!h){j=s4(c[a+12>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+16>>2]);i=b;return ea(e)}function xV(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+12|0;h=b+24|0;j=b+16|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){K7(h,d);i=e;return}h=b+20|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+16>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|16;i=e;return}function yV(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+16>>2]|0;if(!(d&16)){e=ea(J7(a+24|0));i=b;return ea(e)}f=a+20|0;h=c[f>>2]|0;if(!h){j=s4(c[a+12>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+16>>2]);i=b;return ea(e)}function zV(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;f=b+92|0;if(c[f>>2]|0){h=b+88|0;j=0;do{dVa((c[(c[h>>2]|0)+(j<<2)>>2]|0)+48|0,d);j=j+1|0}while(j>>>0<(c[f>>2]|0)>>>0)}f=b+12|0;g[b+60>>2]=d;j=b+16|0;h=(c[j>>2]|0)>>>30;if((h|0)==2){k=c[f>>2]|0;if(!(a[k+2416>>0]|0)){l=k;m=7}}else if((h|0)!=3){l=c[f>>2]|0;m=7}if((m|0)==7){if((l|0)!=0&d>ea(0.0))a[b+64>>0]=0;F7(b+24|0,d);i=e;return}if(d>ea(0.0)){a[b+64>>0]=0;r4(c[f>>2]|0,f);c[j>>2]=c[j>>2]&-897|640;i=e;return}else{r4(c[f>>2]|0,f);c[j>>2]=c[j>>2]|128;i=e;return}}function AV(a){a=a|0;var b=Im;b=ea(g[a+60>>2]);return ea(b)}function BV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=Im,j=0,k=0,l=Im,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0;f=i;h=ea(g[(P3(c[b+12>>2]|0)|0)+2860>>2]);j=b+12|0;k=b+60|0;l=ea(g[k>>2]);m=(mo[c[(c[b>>2]|0)+68>>2]&4095](b)|0)&(e|d);d=l<h&e;n=d?h:l;if(!(d|m)){i=f;return}m=b+92|0;if(c[m>>2]|0){d=b+88|0;e=0;do{o=c[(c[d>>2]|0)+(e<<2)>>2]|0;p=o+48|0;q=(c[o+52>>2]|0)>>>30;if((q|0)==3){r=c[p>>2]|0;s=8}else if((q|0)==2?(q=c[p>>2]|0,(a[q+2416>>0]|0)!=0):0){r=q;s=8}else s=7;if((s|0)==7){s=0;c[o+280>>2]=0;g[o+276>>2]=n;e9(o+64|0,n,1)}else if((s|0)==8){s=0;c[o+280>>2]=0;g[o+276>>2]=n;r4(r,p);p=o+284|0;c[p>>2]=c[p>>2]&-7340033|5242880}e=e+1|0}while(e>>>0<(c[m>>2]|0)>>>0)}g[k>>2]=n;a[b+64>>0]=0;k=b+16|0;m=(c[k>>2]|0)>>>30;if((m|0)==3){t=c[j>>2]|0;s=14}else if((m|0)==2?(m=c[j>>2]|0,(a[m+2416>>0]|0)!=0):0){t=m;s=14}else s=13;if((s|0)==13){H7(b+24|0,n);i=f;return}else if((s|0)==14){r4(t,j);c[k>>2]=c[k>>2]&-897|640;i=f;return}}function CV(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0;d=i;e=b+16|0;if((((c[e>>2]|0)>>>30)+-1|0)>>>0<2?(f=c[b+12>>2]|0,(f|0)!=0):0)h=P3(f)|0;else h=0;f=b+92|0;if(c[f>>2]|0){j=b+88|0;k=h+2860|0;h=0;do{l=c[(c[j>>2]|0)+(h<<2)>>2]|0;m=l+48|0;n=ea(g[k>>2]);o=(c[l+52>>2]|0)>>>30;if((o|0)==3){p=c[m>>2]|0;q=10}else if((o|0)==2?(o=c[m>>2]|0,(a[o+2416>>0]|0)!=0):0){p=o;q=10}else q=9;if((q|0)==9){q=0;c[l+280>>2]=0;g[l+276>>2]=n;e9(l+64|0,n,1)}else if((q|0)==10){q=0;c[l+280>>2]=0;g[l+276>>2]=n;r4(p,m);m=l+284|0;c[m>>2]=c[m>>2]&-7340033|5242880}h=h+1|0}while(h>>>0<(c[f>>2]|0)>>>0)}f=b+12|0;h=c[f>>2]|0;n=ea(g[h+2844>>2]);g[b+60>>2]=n;a[b+64>>0]=0;p=(c[e>>2]|0)>>>30;if((p|0)==3)q=15;else if((p|0)==2?(a[h+2416>>0]|0)!=0:0)q=15;else q=14;if((q|0)==14){H7(b+24|0,n);i=d;return}else if((q|0)==15){r4(h,f);c[e>>2]=c[e>>2]&-897|640;i=d;return}}function DV(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=b+16|0;if((((c[e>>2]|0)>>>30)+-1|0)>>>0<2?(f=c[b+12>>2]|0,(f|0)!=0):0)P3(f)|0;f=b+92|0;if(c[f>>2]|0){h=b+88|0;j=0;do{eVa((c[(c[h>>2]|0)+(j<<2)>>2]|0)+48|0);j=j+1|0}while(j>>>0<(c[f>>2]|0)>>>0)}f=b+12|0;g[b+60>>2]=ea(0.0);a[b+64>>0]=1;j=(c[e>>2]|0)>>>30;if((j|0)==3){k=c[f>>2]|0;l=11}else if((j|0)==2?(j=c[f>>2]|0,(a[j+2416>>0]|0)!=0):0){k=j;l=11}else l=10;if((l|0)==10){I7(b+24|0);i=d;return}else if((l|0)==11){r4(k,f);c[e>>2]=c[e>>2]&-897|384;i=d;return}}function EV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0;e=i;i=i+32|0;f=e;h=e+4|0;j=(c[a+92>>2]|0)==0;if(!b){if(!j){dKa(bKa()|0,8,428536,348,428672,f);k=0;i=e;return k|0}}else if(j){dKa(bKa()|0,8,428536,342,428616,f);k=0;i=e;return k|0}f=c[107930]|0;l=ea(g[d>>2]);m=ea(l*l);n=ea(g[d+4>>2]);o=ea(m+ea(n*n));m=ea(g[d+8>>2]);p=ea(o+ea(m*m));o=ea(g[d+12>>2]);q=ea(ea(1.0)/ea(T(ea(p+ea(o*o)))));p=ea(n*q);n=ea(m*q);m=ea(o*q);g[h>>2]=ea(l*q);g[h+4>>2]=p;g[h+8>>2]=n;g[h+12>>2]=m;g[h+16>>2]=ea(g[d+16>>2]);g[h+20>>2]=ea(g[d+20>>2]);g[h+24>>2]=ea(g[d+24>>2]);d=jY(f,a,b,h)|0;if(!d){k=0;i=e;return k|0}h=a+16|0;if((((c[h>>2]|0)>>>30)+-1|0)>>>0>=2){k=d;i=e;return k|0}b=a+12|0;a=c[b>>2]|0;if(!a){k=d;i=e;return k|0}if(!(P3(a)|0)){k=d;i=e;return k|0}if((((c[h>>2]|0)>>>30)+-1|0)>>>0<2?(h=c[b>>2]|0,(h|0)!=0):0)r=P3(h)|0;else r=0;z$(r,d);k=d;i=e;return k|0}function FV(a){a=a|0;return c[a+92>>2]|0}function GV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[a+92>>2]|0;g=f>>>0<d>>>0?f:d;if(!g){i=e;return g|0}h=a+88|0;a=~f;f=~d;d=~(a>>>0>f>>>0?a:f);f=0;do{c[b+(f<<2)>>2]=c[(c[h>>2]|0)+(f<<2)>>2];f=f+1|0}while((f|0)!=(d|0));i=e;return g|0}function HV(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;e=i;i=i+32|0;f=e;h=b+92|0;if(!(c[h>>2]|0)){j=ea(-8507058669999999534545717.0e13);k=ea(-8507058669999999534545717.0e13);l=ea(-8507058669999999534545717.0e13);m=ea(8507058669999999534545717.0e13);n=ea(8507058669999999534545717.0e13);o=ea(8507058669999999534545717.0e13)}else{p=b+88|0;b=f+4|0;q=f+8|0;r=f+12|0;s=f+16|0;t=f+20|0;u=ea(8507058669999999534545717.0e13);v=ea(8507058669999999534545717.0e13);w=ea(8507058669999999534545717.0e13);x=ea(-8507058669999999534545717.0e13);y=ea(-8507058669999999534545717.0e13);z=ea(-8507058669999999534545717.0e13);A=0;while(1){B=c[(c[p>>2]|0)+(A<<2)>>2]|0;go[c[(c[B>>2]|0)+40>>2]&63](f,B,ea(1.00999999));C=ea(g[f>>2]);D=u<C?u:C;C=ea(g[b>>2]);E=v<C?v:C;C=ea(g[q>>2]);F=w<C?w:C;C=ea(g[r>>2]);G=x>C?x:C;C=ea(g[s>>2]);H=y>C?y:C;C=ea(g[t>>2]);I=z>C?z:C;A=A+1|0;if(A>>>0>=(c[h>>2]|0)>>>0){j=I;k=H;l=G;m=F;n=E;o=D;break}else{u=D;v=E;w=F;x=G;y=H;z=I}}}z=ea(ea(l+o)*ea(.5));y=ea(ea(k+n)*ea(.5));x=ea(ea(j+m)*ea(.5));w=ea(ea(ea(l-o)*ea(.5))*d);o=ea(ea(ea(k-n)*ea(.5))*d);n=ea(ea(ea(j-m)*ea(.5))*d);d=ea(y-o);m=ea(x-n);j=ea(z+w);k=ea(y+o);o=ea(x+n);g[a>>2]=ea(z-w);g[a+4>>2]=d;g[a+8>>2]=m;g[a+12>>2]=j;g[a+16>>2]=k;g[a+20>>2]=o;i=e;return}function IV(a){a=a|0;return c[a+100>>2]|0}function JV(a,b){a=a|0;b=b|0;c[a+104>>2]=b;return}function KV(a){a=a|0;return c[a+104>>2]|0}function LV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+92|0;if(!(c[f>>2]|0)){i=e;return}g=a+88|0;a=0;do{ZW(c[(c[g>>2]|0)+(a<<2)>>2]|0,b,d);a=a+1|0}while(a>>>0<(c[f>>2]|0)>>>0);i=e;return}function MV(a,b,c){a=a|0;b=ea(b);c=c|0;var d=0,e=0;d=i;e=O7(a+24|0,b,c)|0;i=d;return e|0}function NV(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;var e=0;e=i;P7(a+24|0,b,c,d);i=e;return}function OV(a,b){a=a|0;b=b|0;var c=0;c=i;Q7(a+24|0,b);i=c;return}function PV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+32|0;j=h+12|0;k=h;if(mo[c[(c[a>>2]|0)+68>>2]&4095](a)|0)ko[c[(c[a>>2]|0)+96>>2]&4095](a);R7(a+24|0,b+64|0,d,e,f);f=a+92|0;if(!(c[f>>2]|0)){i=h;return}e=a+88|0;a=j+4|0;d=j+8|0;b=k+4|0;l=k+8|0;m=0;do{n=c[(c[e>>2]|0)+(m<<2)>>2]|0;g[j>>2]=ea(g[n+144>>2]);g[a>>2]=ea(g[n+148>>2]);g[d>>2]=ea(g[n+152>>2]);g[k>>2]=ea(g[n+160>>2]);g[b>>2]=ea(g[n+164>>2]);g[l>>2]=ea(g[n+168>>2]);co[c[(c[n>>2]|0)+156>>2]&2047](n,j,1);n=c[(c[e>>2]|0)+(m<<2)>>2]|0;co[c[(c[n>>2]|0)+164>>2]&2047](n,k,1);m=m+1|0}while(m>>>0<(c[f>>2]|0)>>>0);i=h;return}function QV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;S7(a+24|0,b+64|0,c,d,e,f,g);i=h;return}function RV(a){a=a|0;var b=0,d=0;b=i;d=a+-12|0;if(!(c[d+92>>2]|0)){i=b;return 0}else{a=c[c[d+88>>2]>>2]|0;i=b;return ((a|0)==0?0:a+48|0)|0}return 0}function SV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+196|0;f=c[e>>2]|0;if(f)c[e>>2]=xo[c[c[b>>2]>>2]&2047](b,-2147483648,f)|0;f=a+200|0;a=c[f>>2]|0;if(!a){i=d;return}c[f>>2]=xo[c[c[b>>2]>>2]&2047](b,-2147483648,a)|0;i=d;return}function TV(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;b[a+4>>1]=16;b[a+6>>1]=1;c[a>>2]=428760;c[a+8>>2]=0;c[a+16>>2]=0;j=a+12|0;c[j>>2]=0;T7(a+20|0,e,g);c[j>>2]=c[j>>2]&-251658241|150994944;c[a+196>>2]=d;c[a+200>>2]=f;i=h;return}function UV(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=428760;VJa(b,a);i=b;return}function VV(a){a=a|0;c[a>>2]=428760;return}function WV(a){a=a|0;var b=0,d=0;b=i;KZ(c[108764]|0,a,0,1);d=a+8|0;if((((c[a+12>>2]|0)>>>30)+-1|0)>>>0<2?(a=c[d>>2]|0,(a|0)!=0):0)$3(a,d);v3(d);i=b;return}function XV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;i=i+32|0;e=d;f=c[b+196>>2]|0;In[c[(c[f>>2]|0)+124>>2]&4095](e,f);f=c[b+12>>2]|0;if(!(f&1))h=b+24|0;else{j=b+16|0;k=c[j>>2]|0;if(!k){l=s4(c[b+8>>2]|0,f>>>24&15)|0;c[j>>2]=l;m=l}else m=k;h=m}n=ea(g[h>>2]);o=ea(g[h+4>>2]);p=ea(g[h+8>>2]);q=ea(g[h+12>>2]);r=ea(g[h+16>>2]);s=ea(g[h+20>>2]);t=ea(r*ea(2.0));r=ea(s*ea(2.0));s=ea(ea(g[h+24>>2])*ea(2.0));u=ea(g[e+12>>2]);v=ea(ea(u*u)+ea(-.5));w=ea(g[e>>2]);x=ea(t*w);y=ea(g[e+4>>2]);z=ea(x+ea(r*y));x=ea(g[e+8>>2]);A=ea(z+ea(s*x));z=ea(ea(w*A)+ea(ea(t*v)+ea(u*ea(ea(s*y)-ea(r*x)))));B=ea(ea(y*A)+ea(ea(r*v)+ea(u*ea(ea(t*x)-ea(s*w)))));C=ea(ea(ea(s*v)+ea(u*ea(ea(r*w)-ea(t*y))))+ea(x*A));A=ea(ea(g[e+16>>2])+z);z=ea(ea(g[e+20>>2])+B);B=ea(ea(g[e+24>>2])+C);C=ea(ea(ea(n*x)+ea(ea(o*u)+ea(q*y)))-ea(p*w));t=ea(ea(ea(o*w)+ea(ea(p*u)+ea(q*x)))-ea(n*y));r=ea(ea(ea(ea(q*u)-ea(n*w))-ea(o*y))-ea(p*x));g[a>>2]=ea(ea(ea(ea(n*u)+ea(q*w))+ea(p*y))-ea(o*x));g[a+4>>2]=C;g[a+8>>2]=t;g[a+12>>2]=r;g[a+16>>2]=A;g[a+20>>2]=z;g[a+24>>2]=B;i=d;return}function YV(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0;e=i;i=i+64|0;f=e+28|0;h=e;j=c[b+196>>2]|0;if(!j){i=e;return}k=b+8|0;In[c[(c[j>>2]|0)+124>>2]&4095](h,j);l=ea(g[d>>2]);m=ea(l*l);n=ea(g[d+4>>2]);o=ea(m+ea(n*n));m=ea(g[d+8>>2]);p=ea(o+ea(m*m));o=ea(g[d+12>>2]);q=ea(ea(1.0)/ea(T(ea(p+ea(o*o)))));p=ea(l*q);l=ea(n*q);n=ea(m*q);m=ea(o*q);q=ea(g[d+16>>2]);o=ea(g[d+20>>2]);r=ea(g[d+24>>2]);s=ea(-ea(g[h>>2]));t=ea(-ea(g[h+4>>2]));u=ea(-ea(g[h+8>>2]));v=ea(g[h+12>>2]);w=ea(q-ea(g[h+16>>2]));q=ea(o-ea(g[h+20>>2]));o=ea(w*ea(2.0));w=ea(q*ea(2.0));q=ea(ea(r-ea(g[h+24>>2]))*ea(2.0));r=ea(ea(v*v)+ea(-.5));x=ea(ea(ea(o*s)+ea(w*t))+ea(q*u));y=ea(ea(x*s)+ea(ea(r*o)+ea(v*ea(ea(q*t)-ea(w*u)))));z=ea(ea(x*t)+ea(ea(r*w)+ea(v*ea(ea(o*u)-ea(q*s)))));A=ea(ea(ea(r*q)+ea(v*ea(ea(w*s)-ea(o*t))))+ea(x*u));x=ea(ea(ea(n*t)+ea(ea(m*s)+ea(p*v)))-ea(l*u));o=ea(ea(ea(p*u)+ea(ea(m*t)+ea(l*v)))-ea(n*s));w=ea(ea(ea(l*s)+ea(ea(m*u)+ea(n*v)))-ea(p*t));q=ea(ea(ea(ea(m*v)-ea(p*s))-ea(l*t))-ea(n*u));g[f>>2]=x;h=f+4|0;g[h>>2]=o;d=f+8|0;g[d>>2]=w;j=f+12|0;g[j>>2]=q;B=f+16|0;g[B>>2]=y;C=f+20|0;g[C>>2]=z;D=f+24|0;g[D>>2]=A;E=b+20|0;F=b+12|0;G=c[F>>2]|0;H=G>>>30;if((H|0)==3)I=k;else if((H|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)I=k;else J=5;if((J|0)==5){V7(E,f);i=e;return}E=b+16|0;b=c[E>>2]|0;if(!b){J=s4(c[I>>2]|0,G>>>24&15)|0;c[E>>2]=J;K=ea(g[f>>2]);L=J}else{K=x;L=b}g[L>>2]=K;g[L+4>>2]=ea(g[h>>2]);g[L+8>>2]=ea(g[d>>2]);g[L+12>>2]=ea(g[j>>2]);g[L+16>>2]=ea(g[B>>2]);g[L+20>>2]=ea(g[C>>2]);g[L+24>>2]=ea(g[D>>2]);r4(c[I>>2]|0,k);c[F>>2]=c[F>>2]|1;i=e;return}function ZV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;i=i+32|0;e=d;f=c[b+200>>2]|0;In[c[(c[f>>2]|0)+124>>2]&4095](e,f);f=c[b+12>>2]|0;if(!(f&2))h=b+52|0;else{j=b+16|0;k=c[j>>2]|0;if(!k){l=s4(c[b+8>>2]|0,f>>>24&15)|0;c[j>>2]=l;m=l}else m=k;h=m+28|0}n=ea(g[h>>2]);o=ea(g[h+4>>2]);p=ea(g[h+8>>2]);q=ea(g[h+12>>2]);r=ea(g[h+16>>2]);s=ea(g[h+20>>2]);t=ea(r*ea(2.0));r=ea(s*ea(2.0));s=ea(ea(g[h+24>>2])*ea(2.0));u=ea(g[e+12>>2]);v=ea(ea(u*u)+ea(-.5));w=ea(g[e>>2]);x=ea(t*w);y=ea(g[e+4>>2]);z=ea(x+ea(r*y));x=ea(g[e+8>>2]);A=ea(z+ea(s*x));z=ea(ea(w*A)+ea(ea(t*v)+ea(u*ea(ea(s*y)-ea(r*x)))));B=ea(ea(y*A)+ea(ea(r*v)+ea(u*ea(ea(t*x)-ea(s*w)))));C=ea(ea(ea(s*v)+ea(u*ea(ea(r*w)-ea(t*y))))+ea(x*A));A=ea(ea(g[e+16>>2])+z);z=ea(ea(g[e+20>>2])+B);B=ea(ea(g[e+24>>2])+C);C=ea(ea(ea(n*x)+ea(ea(o*u)+ea(q*y)))-ea(p*w));t=ea(ea(ea(o*w)+ea(ea(p*u)+ea(q*x)))-ea(n*y));r=ea(ea(ea(ea(q*u)-ea(n*w))-ea(o*y))-ea(p*x));g[a>>2]=ea(ea(ea(ea(n*u)+ea(q*w))+ea(p*y))-ea(o*x));g[a+4>>2]=C;g[a+8>>2]=t;g[a+12>>2]=r;g[a+16>>2]=A;g[a+20>>2]=z;g[a+24>>2]=B;i=d;return}function _V(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im;e=i;i=i+64|0;f=e+28|0;h=e;j=b+8|0;k=c[b+200>>2]|0;In[c[(c[k>>2]|0)+124>>2]&4095](h,k);l=ea(g[d>>2]);m=ea(l*l);n=ea(g[d+4>>2]);o=ea(m+ea(n*n));m=ea(g[d+8>>2]);p=ea(o+ea(m*m));o=ea(g[d+12>>2]);q=ea(ea(1.0)/ea(T(ea(p+ea(o*o)))));p=ea(l*q);l=ea(n*q);n=ea(m*q);m=ea(o*q);q=ea(g[d+16>>2]);o=ea(g[d+20>>2]);r=ea(g[d+24>>2]);s=ea(-ea(g[h>>2]));t=ea(-ea(g[h+4>>2]));u=ea(-ea(g[h+8>>2]));v=ea(g[h+12>>2]);w=ea(q-ea(g[h+16>>2]));q=ea(o-ea(g[h+20>>2]));o=ea(w*ea(2.0));w=ea(q*ea(2.0));q=ea(ea(r-ea(g[h+24>>2]))*ea(2.0));r=ea(ea(v*v)+ea(-.5));x=ea(ea(ea(o*s)+ea(w*t))+ea(q*u));y=ea(ea(x*s)+ea(ea(r*o)+ea(v*ea(ea(q*t)-ea(w*u)))));z=ea(ea(x*t)+ea(ea(r*w)+ea(v*ea(ea(o*u)-ea(q*s)))));A=ea(ea(ea(r*q)+ea(v*ea(ea(w*s)-ea(o*t))))+ea(x*u));x=ea(ea(ea(n*t)+ea(ea(m*s)+ea(p*v)))-ea(l*u));o=ea(ea(ea(p*u)+ea(ea(m*t)+ea(l*v)))-ea(n*s));w=ea(ea(ea(l*s)+ea(ea(m*u)+ea(n*v)))-ea(p*t));q=ea(ea(ea(ea(m*v)-ea(p*s))-ea(l*t))-ea(n*u));g[f>>2]=x;h=f+4|0;g[h>>2]=o;d=f+8|0;g[d>>2]=w;k=f+12|0;g[k>>2]=q;B=f+16|0;g[B>>2]=y;C=f+20|0;g[C>>2]=z;D=f+24|0;g[D>>2]=A;E=b+20|0;F=b+12|0;G=c[F>>2]|0;H=G>>>30;if((H|0)==3)I=j;else if((H|0)==2?(a[(c[j>>2]|0)+2417>>0]|0)!=0:0)I=j;else J=4;if((J|0)==4){W7(E,f);i=e;return}E=b+16|0;b=c[E>>2]|0;if(!b){J=s4(c[I>>2]|0,G>>>24&15)|0;c[E>>2]=J;K=J;L=ea(g[f>>2])}else{K=b;L=x}g[K+28>>2]=L;g[K+32>>2]=ea(g[h>>2]);g[K+36>>2]=ea(g[d>>2]);g[K+40>>2]=ea(g[k>>2]);g[K+44>>2]=ea(g[B>>2]);g[K+48>>2]=ea(g[C>>2]);g[K+52>>2]=ea(g[D>>2]);r4(c[I>>2]|0,j);c[F>>2]=c[F>>2]|2;i=e;return}function $V(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){X7(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+56>>2]=ea(g[d>>2]);g[o+60>>2]=ea(g[d+4>>2]);g[o+64>>2]=ea(g[d+8>>2]);g[o+68>>2]=ea(g[d+12>>2]);r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|4;i=e;return}function aW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b+12>>2]|0;if(!(e&4))f=b+80|0;else{h=b+16|0;j=c[h>>2]|0;if(!j){k=s4(c[b+8>>2]|0,e>>>24&15)|0;c[h>>2]=k;l=k}else l=j;f=l+56|0}g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);g[a+12>>2]=ea(g[f+12>>2]);i=d;return}function bW(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){Y7(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+72>>2]=ea(g[d>>2]);g[o+76>>2]=ea(g[d+4>>2]);g[o+80>>2]=ea(g[d+8>>2]);r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|8;i=e;return}function cW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b+12>>2]|0;if(!(e&8))f=b+96|0;else{h=b+16|0;j=c[h>>2]|0;if(!j){k=s4(c[b+8>>2]|0,e>>>24&15)|0;c[h>>2]=k;l=k}else l=j;f=l+72|0}g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);i=d;return}function dW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){Z7(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+84>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|16;i=e;return}function eW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&16)){e=a+108|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+84|0;f=ea(g[e>>2]);i=b;return ea(f)}function fW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){_7(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+88>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|32;i=e;return}function gW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&32)){e=a+112|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+88|0;f=ea(g[e>>2]);i=b;return ea(f)}function hW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){f8(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+100>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|256;i=e;return}function iW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&256)){e=a+140|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+100|0;f=ea(g[e>>2]);i=b;return ea(f)}function jW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){i8(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+116>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|4096;i=e;return}function kW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&4096)){e=a+164|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+116|0;f=ea(g[e>>2]);i=b;return ea(f)}function lW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){$7(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+92>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|64;i=e;return}function mW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&64)){e=a+124|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+92|0;f=ea(g[e>>2]);i=b;return ea(f)}function nW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){a8(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+96>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|128;i=e;return}function oW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&128)){e=a+128|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+96|0;f=ea(g[e>>2]);i=b;return ea(f)}function pW(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;h=b+8|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2){if(!(a[(c[h>>2]|0)+2417>>0]|0))m=3}else if((l|0)!=3)m=3;if((m|0)==3){b8(b+20|0,d,e);i=f;return}m=b+16|0;b=c[m>>2]|0;if(!b){l=s4(c[h>>2]|0,k>>>24&15)|0;c[m>>2]=l;g[l+124>>2]=d;if(!l){k=s4(c[h>>2]|0,(c[j>>2]|0)>>>24&15)|0;c[m>>2]=k;n=h;o=k}else{n=h;o=l}}else{g[b+124>>2]=d;n=h;o=b}g[o+128>>2]=e;r4(c[n>>2]|0,h);c[j>>2]=c[j>>2]|16384;i=f;return}function qW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0;e=i;f=a+12|0;h=c[f>>2]|0;if(!(h&16384)){g[b>>2]=ea(g[a+132>>2]);j=a+136|0;k=ea(g[j>>2]);g[d>>2]=k;i=e;return}l=a+16|0;m=c[l>>2]|0;if(!m){n=a+8|0;a=s4(c[n>>2]|0,h>>>24&15)|0;c[l>>2]=a;g[b>>2]=ea(g[a+124>>2]);if(!a){h=s4(c[n>>2]|0,(c[f>>2]|0)>>>24&15)|0;c[l>>2]=h;o=h}else o=a}else{g[b>>2]=ea(g[m+124>>2]);o=m}j=o+128|0;k=ea(g[j>>2]);g[d>>2]=k;i=e;return}function rW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){c8(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+108>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|1024;i=e;return}function sW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&1024)){e=a+148|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+108|0;f=ea(g[e>>2]);i=b;return ea(f)}function tW(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;h=b+20|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){d8(h,d);i=e;return}h=b+16|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+112>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|2048;i=e;return}function uW(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+12>>2]|0;if(!(d&2048)){e=a+152|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+16|0;j=c[h>>2]|0;if(!j){k=s4(c[a+8>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+112|0;f=ea(g[e>>2]);i=b;return ea(f)}function vW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+8|0;g=b+20|0;h=b+12|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){e8(g,d);i=e;return}g=b+16|0;b=c[g>>2]|0;if(!b){m=s4(c[l>>2]|0,j>>>24&15)|0;c[g>>2]=m;n=m}else n=b;a[n+104>>0]=d&1;r4(c[l>>2]|0,f);c[h>>2]=c[h>>2]|512;i=e;return}function wW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+12>>2]|0;if(!(e&512))f=b+144|0;else{g=b+16|0;h=c[g>>2]|0;if(!h){j=s4(c[b+8>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=k+104|0}i=d;return (a[f>>0]|0)!=0|0}function xW(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;h=b+8|0;j=b+12|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2){if(!(a[(c[h>>2]|0)+2417>>0]|0))m=3}else if((l|0)!=3)m=3;if((m|0)==3){g8(b+20|0,d,e);i=f;return}m=b+16|0;b=c[m>>2]|0;if(!b){l=s4(c[h>>2]|0,k>>>24&15)|0;c[m>>2]=l;g[l+132>>2]=d;if(!l){k=s4(c[h>>2]|0,(c[j>>2]|0)>>>24&15)|0;c[m>>2]=k;n=h;o=k}else{n=h;o=l}}else{g[b+132>>2]=d;n=h;o=b}g[o+136>>2]=e;r4(c[n>>2]|0,h);c[j>>2]=c[j>>2]|32768;i=f;return}function yW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0;e=i;f=a+12|0;h=c[f>>2]|0;if(!(h&32768)){g[b>>2]=ea(g[a+160>>2]);j=a+156|0;k=ea(g[j>>2]);g[d>>2]=k;i=e;return}l=a+16|0;m=c[l>>2]|0;if(!m){n=a+8|0;a=s4(c[n>>2]|0,h>>>24&15)|0;c[l>>2]=a;g[b>>2]=ea(g[a+132>>2]);if(!a){h=s4(c[n>>2]|0,(c[f>>2]|0)>>>24&15)|0;c[l>>2]=h;o=h}else o=a}else{g[b>>2]=ea(g[m+132>>2]);o=m}j=o+136|0;k=ea(g[j>>2]);g[d>>2]=k;i=e;return}function zW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+8|0;g=b+20|0;h=b+12|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){h8(g,d);i=e;return}g=b+16|0;b=c[g>>2]|0;if(!b){m=s4(c[l>>2]|0,j>>>24&15)|0;c[g>>2]=m;n=m}else n=b;a[n+120>>0]=d&1;r4(c[l>>2]|0,f);c[h>>2]=c[h>>2]|8192;i=e;return}function AW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+12>>2]|0;if(!(e&8192))f=b+168|0;else{g=b+16|0;h=c[g>>2]|0;if(!h){j=s4(c[b+8>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=k+120|0}i=d;return (a[f>>0]|0)!=0|0}function BW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+-8|0;a=c[e+200>>2]|0;c[b>>2]=(c[e+196>>2]|0)+48;c[d>>2]=a+48;return}function CW(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+20|0;g=a+24|0;h=b[g>>1]|0;a:do if(h<<16>>16){j=h&65535;k=h;l=0;while(1){if(k<<16>>16==1)m=f;else m=c[f>>2]|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,c[m+(l<<2)>>2]|0);n=l+1|0;if((n|0)==(j|0))break a;k=b[g>>1]|0;l=n}}while(0);g=c[a+292>>2]|0;if(!g){i=e;return}In[c[(c[d>>2]|0)+8>>2]&4095](d,g);i=e;return}function DW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;v2(b+20|0,d);xU(b+12|0,d);if(a[b+316>>0]|0){i=e;return}f=c[b+320>>2]|0;if(!f){i=e;return}g=c[b+328>>2]|0;if((c[b+324>>2]|0)==0&(g&2147483647|0)==0){i=e;return}co[c[(c[d>>2]|0)+8>>2]&2047](d,f,g<<2);i=e;return}function EW(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+288|0;g=c[f>>2]|0;if(g)c[f>>2]=xo[c[c[d>>2]>>2]&2047](d,-2147483648,g)|0;g=a+292|0;f=c[g>>2]|0;if(f)c[g>>2]=xo[c[c[d>>2]>>2]&2047](d,-2147483648,f)|0;f=a+296|0;g=c[f>>2]|0;if(g)c[f>>2]=xo[c[c[d>>2]>>2]&2047](d,-2147483648,g)|0;g=a+20|0;f=b[a+24>>1]|0;if(f<<16>>16!=1){if(f<<16>>16){h=c[g>>2]|0;j=10}}else{h=g;j=10}if((j|0)==10){j=f&65535;f=0;do{g=h+(f<<2)|0;k=c[g>>2]|0;if(!k)l=0;else{m=xo[c[c[d>>2]>>2]&2047](d,-2147483648,k)|0;c[g>>2]=m;l=m}fTa(l+16|0)|0;f=f+1|0}while((f|0)!=(j|0))}yU(a+12|0,d);j=c[a+324>>2]|0;if(!j){i=e;return}f=a+320|0;a=0;do{l=(c[f>>2]|0)+(a<<2)|0;h=c[l>>2]|0;if(h)c[l>>2]=xo[c[c[d>>2]>>2]&2047](d,-2147483648,h)|0;a=a+1|0}while((a|0)!=(j|0));i=e;return}function FW(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j;b[d+4>>1]=15;b[d+6>>1]=1;l=d+8|0;c[l>>2]=0;c[d>>2]=430224;vU(d+12|0,0);c[l>>2]=0;c[d>>2]=429696;u2(d+20|0);c[d>>2]=429424;c[d+48>>2]=0;c[d+56>>2]=0;l=d+52|0;c[l>>2]=0;m=d+64|0;I8(m,4,e);c[l>>2]=c[l>>2]&-251658241|50331648;g[d+224>>2]=ea(g[d+80>>2]);g[d+228>>2]=ea(g[d+84>>2]);g[d+232>>2]=ea(g[d+88>>2]);g[d+236>>2]=ea(g[d+92>>2]);g[d+240>>2]=ea(g[d+96>>2]);g[d+244>>2]=ea(g[d+100>>2]);g[d+248>>2]=ea(g[d+104>>2]);g[d+252>>2]=ea(g[d+144>>2]);g[d+256>>2]=ea(g[d+148>>2]);g[d+260>>2]=ea(g[d+152>>2]);g[d+264>>2]=ea(g[d+160>>2]);g[d+268>>2]=ea(g[d+164>>2]);g[d+272>>2]=ea(g[d+168>>2]);g[d+276>>2]=ea(d9(m));c[d+280>>2]=1;c[d+284>>2]=0;c[d>>2]=428960;c[d+288>>2]=f;c[d+292>>2]=0;c[d+296>>2]=h;c[d+324>>2]=0;a[d+316>>0]=1;c[d+320>>2]=d+300;c[d+328>>2]=4;c[l>>2]=c[l>>2]&-251658241|67108864;c[k>>2]=d;l=f+92|0;m=c[l>>2]|0;if((c[f+96>>2]&2147483647)>>>0>m>>>0){e=(c[f+88>>2]|0)+(m<<2)|0;if(e)c[e>>2]=d;c[l>>2]=m+1}else fVa(f+68|0,k)|0;if(!h){i=j;return}c[k>>2]=d;f=h+324|0;m=c[f>>2]|0;if((c[h+328>>2]&2147483647)>>>0<=m>>>0){fVa(h+300|0,k)|0;i=j;return}k=(c[h+320>>2]|0)+(m<<2)|0;if(k)c[k>>2]=d;c[f>>2]=m+1;i=j;return}function GW(a){a=a|0;var b=0;b=i;i=i+16|0;HW(a);VJa(b,a);i=b;return}function HW(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;c[b>>2]=428960;e=c[b+328>>2]|0;do if((e&2147483647|0)!=0&(e|0)>-1){f=c[b+320>>2]|0;if((b+300|0)==(f|0)){a[b+316>>0]=0;break}if(f){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}}while(0);c[b>>2]=429424;J8(b+64|0);c[b>>2]=429696;xKa(b+28|0);xKa(b+20|0);c[b>>2]=429968;MU(b);i=d;return}function IW(a){a=a|0;return a+-64|0}function JW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);d=a+12|0;zU(d,a);y2(a+20|0,LU(a)|0);AU(d,a);d=c[a+288>>2]|0;e=d+92|0;f=c[e>>2]|0;if(f){g=c[d+88>>2]|0;d=0;while(1){h=d+1|0;if((c[g+(d<<2)>>2]|0)==(a|0)){j=d;break}if(h>>>0<f>>>0)d=h;else{j=h;break}}if((j|0)!=(f|0)){d=f+-1|0;c[e>>2]=d;c[g+(j<<2)>>2]=c[g+(d<<2)>>2]}}d=c[a+296>>2]|0;if((d|0)!=0?(g=d+324|0,j=c[g>>2]|0,(j|0)!=0):0){e=c[d+320>>2]|0;d=0;while(1){f=d+1|0;if((c[e+(d<<2)>>2]|0)==(a|0)){k=d;break}if(f>>>0<j>>>0)d=f;else{k=f;break}}if((k|0)!=(j|0)){d=j+-1|0;c[g>>2]=d;c[e+(k<<2)>>2]=c[e+(d<<2)>>2]}}d=c[a+292>>2]|0;if(d)ko[c[c[d>>2]>>2]&4095](d);d=LU(a)|0;if(!d){l=a+48|0;v3(l);i=b;return}V3(d+16|0,a+48|0,1,0);l=a+48|0;v3(l);i=b;return}function KW(a){a=a|0;var b=0;b=i;i=i+16|0;if(!(c[a+324>>2]|0)){JW(a);i=b;return}else{dKa(bKa()|0,8,429232,151,429312,b);i=b;return}}function LW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=i;if(!(c[b+284>>2]&512))e=b+112|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+144|0}l=ea(g[e+16>>2]);m=ea(g[e+20>>2]);n=ea(l*ea(-2.0));l=ea(m*ea(-2.0));m=ea(ea(g[e+24>>2])*ea(-2.0));o=ea(g[e+12>>2]);p=ea(ea(o*o)+ea(-.5));q=ea(g[e>>2]);r=ea(n*q);s=ea(g[e+4>>2]);t=ea(r+ea(l*s));r=ea(g[e+8>>2]);u=ea(t+ea(m*r));t=ea(-q);v=ea(-s);w=ea(-r);x=ea(ea(ea(q*u)+ea(ea(n*p)-ea(o*ea(ea(m*s)-ea(l*r)))))*ea(2.0));y=ea(ea(ea(s*u)+ea(ea(l*p)-ea(o*ea(ea(n*r)-ea(m*q)))))*ea(2.0));z=ea(ea(ea(ea(m*p)-ea(o*ea(ea(l*q)-ea(n*s))))+ea(r*u))*ea(2.0));u=ea(g[b+236>>2]);r=ea(ea(u*u)+ea(-.5));s=ea(g[b+224>>2]);n=ea(s*x);q=ea(g[b+228>>2]);l=ea(n+ea(q*y));n=ea(g[b+232>>2]);p=ea(ea(n*z)+l);l=ea(ea(s*p)+ea(ea(r*x)+ea(u*ea(ea(q*z)-ea(n*y)))));m=ea(ea(q*p)+ea(ea(r*y)+ea(u*ea(ea(n*x)-ea(s*z)))));A=ea(ea(ea(r*z)+ea(u*ea(ea(s*y)-ea(q*x))))+ea(n*p));p=ea(ea(g[b+240>>2])+l);l=ea(ea(g[b+244>>2])+m);m=ea(ea(g[b+248>>2])+A);A=ea(ea(ea(n*t)+ea(ea(u*v)+ea(o*q)))-ea(s*w));x=ea(ea(ea(s*v)+ea(ea(u*w)+ea(o*n)))-ea(q*t));y=ea(ea(ea(ea(o*u)-ea(s*t))-ea(q*v))-ea(n*w));g[a>>2]=ea(ea(ea(ea(u*t)+ea(o*s))+ea(q*w))-ea(n*v));g[a+4>>2]=A;g[a+8>>2]=x;g[a+12>>2]=y;g[a+16>>2]=p;g[a+20>>2]=l;g[a+24>>2]=m;i=d;return}function MW(a){a=a|0;return c[a+288>>2]|0}function NW(a){a=a|0;return c[a+292>>2]|0}function OW(a){a=a|0;return c[a+324>>2]|0}function PW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[a+324>>2]|0;g=f>>>0<d>>>0?f:d;if(!g){i=e;return g|0}h=a+320|0;a=~f;f=~d;d=~(a>>>0>f>>>0?a:f);f=0;do{c[b+(f<<2)>>2]=c[(c[h>>2]|0)+(f<<2)>>2];f=f+1|0}while((f|0)!=(d|0));i=e;return g|0}function QW(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,da=0,fa=0,ga=0,ha=0,ia=Im,ja=0;e=i;i=i+96|0;f=e+56|0;h=e+28|0;j=e;k=ea(g[d>>2]);l=ea(k*k);m=ea(g[d+4>>2]);n=ea(l+ea(m*m));l=ea(g[d+8>>2]);o=ea(n+ea(l*l));n=ea(g[d+12>>2]);p=ea(ea(1.0)/ea(T(ea(o+ea(n*n)))));o=ea(k*p);k=ea(m*p);m=ea(l*p);l=ea(n*p);g[f>>2]=o;q=f+4|0;g[q>>2]=k;r=f+8|0;g[r>>2]=m;s=f+12|0;g[s>>2]=l;t=f+16|0;p=ea(g[d+16>>2]);g[t>>2]=p;u=f+20|0;n=ea(g[d+20>>2]);g[u>>2]=n;v=f+24|0;w=ea(g[d+24>>2]);g[v>>2]=w;if(!(c[b+284>>2]&512)){x=b+112|0;y=o;z=k;A=m;B=p;C=n;D=w;E=l}else{d=b+56|0;F=c[d>>2]|0;if(!F){G=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[d>>2]=G;H=ea(g[f>>2]);I=ea(g[q>>2]);J=ea(g[r>>2]);K=ea(g[s>>2]);L=ea(g[t>>2]);M=ea(g[u>>2]);N=H;O=I;P=J;Q=K;R=L;S=M;U=ea(g[v>>2]);V=G}else{N=o;O=k;P=m;Q=l;R=p;S=n;U=w;V=F}x=V+144|0;y=N;z=O;A=P;B=R;C=S;D=U;E=Q}Q=ea(g[x>>2]);U=ea(g[x+4>>2]);S=ea(g[x+8>>2]);R=ea(g[x+12>>2]);P=ea(g[x+16>>2]);O=ea(g[x+20>>2]);N=ea(-y);y=ea(-z);z=ea(-A);A=ea(ea(P-B)*ea(2.0));B=ea(ea(O-C)*ea(2.0));C=ea(ea(ea(g[x+24>>2])-D)*ea(2.0));D=ea(ea(E*E)+ea(-.5));O=ea(ea(ea(A*N)+ea(B*y))+ea(C*z));P=ea(ea(O*N)+ea(ea(D*A)+ea(E*ea(ea(C*y)-ea(B*z)))));w=ea(ea(O*y)+ea(ea(D*B)+ea(E*ea(ea(A*z)-ea(C*N)))));n=ea(ea(ea(D*C)+ea(E*ea(ea(B*N)-ea(A*y))))+ea(O*z));O=ea(ea(ea(S*y)+ea(ea(R*N)+ea(Q*E)))-ea(U*z));A=ea(ea(ea(Q*z)+ea(ea(R*y)+ea(U*E)))-ea(S*N));B=ea(ea(ea(U*N)+ea(ea(R*z)+ea(S*E)))-ea(Q*y));C=ea(ea(ea(ea(R*E)-ea(Q*N))-ea(U*y))-ea(S*z));gVa(b,f);f=c[b+292>>2]|0;do if(f){x=f+8|0;V=f+12|0;F=c[V>>2]|0;if(!(F&2)){W=f+52|0;X=F}else{G=f+16|0;v=c[G>>2]|0;if(!v){u=s4(c[x>>2]|0,F>>>24&15)|0;c[G>>2]=u;Y=c[V>>2]|0;Z=u}else{Y=F;Z=v}W=Z+28|0;X=Y}z=ea(g[W>>2]);S=ea(g[W+4>>2]);y=ea(g[W+8>>2]);U=ea(g[W+12>>2]);N=ea(g[W+16>>2]);Q=ea(g[W+20>>2]);E=ea(N*ea(2.0));N=ea(Q*ea(2.0));Q=ea(ea(g[W+24>>2])*ea(2.0));R=ea(ea(C*C)+ea(-.5));D=ea(ea(ea(O*E)+ea(A*N))+ea(B*Q));p=ea(P+ea(ea(O*D)+ea(ea(R*E)+ea(C*ea(ea(A*Q)-ea(B*N))))));l=ea(w+ea(ea(A*D)+ea(ea(R*N)+ea(C*ea(ea(B*E)-ea(O*Q))))));m=ea(n+ea(ea(ea(R*Q)+ea(C*ea(ea(O*N)-ea(A*E))))+ea(B*D)));D=ea(ea(ea(A*y)+ea(ea(C*z)+ea(O*U)))-ea(B*S));E=ea(ea(ea(B*z)+ea(ea(C*S)+ea(A*U)))-ea(O*y));N=ea(ea(ea(O*S)+ea(ea(C*y)+ea(B*U)))-ea(A*z));Q=ea(ea(ea(ea(C*U)-ea(O*z))-ea(A*S))-ea(B*y));g[h>>2]=D;v=h+4|0;g[v>>2]=E;F=h+8|0;g[F>>2]=N;u=h+12|0;g[u>>2]=Q;G=h+16|0;g[G>>2]=p;t=h+20|0;g[t>>2]=l;s=h+24|0;g[s>>2]=m;r=f+20|0;q=X>>>30;if((q|0)==2)if(!(a[(c[x>>2]|0)+2417>>0]|0))_=15;else $=x;else if((q|0)==3)$=x;else _=15;if((_|0)==15){W7(r,h);break}r=f+16|0;q=c[r>>2]|0;if(!q){d=s4(c[$>>2]|0,X>>>24&15)|0;c[r>>2]=d;aa=d;ba=ea(g[h>>2])}else{aa=q;ba=D}g[aa+28>>2]=ba;g[aa+32>>2]=ea(g[v>>2]);g[aa+36>>2]=ea(g[F>>2]);g[aa+40>>2]=ea(g[u>>2]);g[aa+44>>2]=ea(g[G>>2]);g[aa+48>>2]=ea(g[t>>2]);g[aa+52>>2]=ea(g[s>>2]);r4(c[$>>2]|0,x);c[V>>2]=c[V>>2]|2}while(0);$=b+324|0;if(!(c[$>>2]|0)){i=e;return}aa=b+320|0;ba=ea(ea(C*C)+ea(-.5));b=j+4|0;h=j+8|0;X=j+12|0;f=j+16|0;W=j+20|0;Y=j+24|0;Z=0;do{V=c[(c[aa>>2]|0)+(Z<<2)>>2]|0;x=mo[c[(c[V>>2]|0)+228>>2]&4095](V)|0;V=x+8|0;s=x+12|0;t=c[s>>2]|0;if(!(t&1)){ca=x+24|0;da=t}else{G=x+16|0;u=c[G>>2]|0;if(!u){F=s4(c[V>>2]|0,t>>>24&15)|0;c[G>>2]=F;fa=c[s>>2]|0;ga=F}else{fa=t;ga=u}ca=ga;da=fa}D=ea(g[ca>>2]);m=ea(g[ca+4>>2]);l=ea(g[ca+8>>2]);p=ea(g[ca+12>>2]);Q=ea(g[ca+16>>2]);N=ea(g[ca+20>>2]);E=ea(Q*ea(2.0));Q=ea(N*ea(2.0));N=ea(ea(g[ca+24>>2])*ea(2.0));y=ea(ea(ea(O*E)+ea(A*Q))+ea(B*N));S=ea(P+ea(ea(O*y)+ea(ea(ba*E)+ea(C*ea(ea(A*N)-ea(B*Q))))));z=ea(w+ea(ea(A*y)+ea(ea(ba*Q)+ea(C*ea(ea(B*E)-ea(O*N))))));U=ea(n+ea(ea(ea(ba*N)+ea(C*ea(ea(O*Q)-ea(A*E))))+ea(B*y)));y=ea(ea(ea(A*l)+ea(ea(C*D)+ea(O*p)))-ea(B*m));E=ea(ea(ea(B*D)+ea(ea(C*m)+ea(A*p)))-ea(O*l));Q=ea(ea(ea(O*m)+ea(ea(C*l)+ea(B*p)))-ea(A*D));N=ea(ea(ea(ea(C*p)-ea(O*D))-ea(A*m))-ea(B*l));g[j>>2]=y;g[b>>2]=E;g[h>>2]=Q;g[X>>2]=N;g[f>>2]=S;g[W>>2]=z;g[Y>>2]=U;u=x+20|0;t=da>>>30;if((t|0)==3){ha=V;_=30}else if((t|0)==2?(a[(c[V>>2]|0)+2417>>0]|0)!=0:0){ha=V;_=30}else _=29;if((_|0)==29){_=0;V7(u,j)}else if((_|0)==30){_=0;u=x+16|0;x=c[u>>2]|0;if(!x){t=s4(c[ha>>2]|0,da>>>24&15)|0;c[u>>2]=t;ia=ea(g[j>>2]);ja=t}else{ia=y;ja=x}g[ja>>2]=ia;g[ja+4>>2]=ea(g[b>>2]);g[ja+8>>2]=ea(g[h>>2]);g[ja+12>>2]=ea(g[X>>2]);g[ja+16>>2]=ea(g[f>>2]);g[ja+20>>2]=ea(g[W>>2]);g[ja+24>>2]=ea(g[Y>>2]);r4(c[ha>>2]|0,V);c[s>>2]=c[s>>2]|1}Z=Z+1|0}while(Z>>>0<(c[$>>2]|0)>>>0);i=e;return}function RW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0;f=i;KU(a)|0;hVa(a,b,0,d);d=c[a+288>>2]|0;if(ea(g[b>>2])==ea(0.0)?ea(g[b+4>>2])==ea(0.0):0)h=ea(g[b+8>>2])!=ea(0.0);else h=1;BV(d,h,e);i=f;return}function SW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0;f=i;KU(a)|0;hVa(a,0,b,d);d=c[a+288>>2]|0;if(ea(g[b>>2])==ea(0.0)?ea(g[b+4>>2])==ea(0.0):0)h=ea(g[b+8>>2])!=ea(0.0);else h=1;BV(d,h,e);i=f;return}function TW(a,b){a=a|0;b=b|0;var c=0;c=i;KU(a)|0;iVa(a,b);i=c;return}function UW(a,b){a=a|0;b=b|0;var c=0;c=i;KU(a)|0;iVa(a,b);i=c;return}function VW(a,b){a=a|0;b=b|0;var d=0;d=i;co[c[(c[a>>2]|0)+88>>2]&2047](a,b,1);i=d;return}function WW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0;f=i;i=i+32|0;h=f;j=KU(b)|0;k=b+48|0;l=b+284|0;if(!(c[l>>2]&512))m=b+112|0;else{n=b+56|0;o=c[n>>2]|0;if(!o){p=s4(c[k>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[n>>2]=p;q=p}else q=o;m=q+144|0}r=ea(ea(g[m+16>>2])*ea(2.0));s=ea(ea(g[m+20>>2])*ea(2.0));t=ea(ea(g[m+24>>2])*ea(2.0));u=ea(g[d+12>>2]);v=ea(ea(u*u)+ea(-.5));w=ea(g[d>>2]);x=ea(r*w);y=ea(g[d+4>>2]);z=ea(x+ea(s*y));x=ea(g[d+8>>2]);A=ea(z+ea(t*x));z=ea(ea(w*A)+ea(ea(r*v)+ea(u*ea(ea(t*y)-ea(s*x)))));B=ea(ea(y*A)+ea(ea(s*v)+ea(u*ea(ea(r*x)-ea(t*w)))));C=ea(ea(ea(t*v)+ea(u*ea(ea(s*w)-ea(r*y))))+ea(x*A));A=ea(ea(g[d+16>>2])+z);z=ea(ea(g[d+20>>2])+B);B=ea(ea(g[d+24>>2])+C);C=ea(g[m>>2]);r=ea(u*C);s=ea(g[m+12>>2]);v=ea(r+ea(w*s));r=ea(g[m+8>>2]);t=ea(v+ea(y*r));v=ea(g[m+4>>2]);D=ea(t-ea(x*v));t=ea(ea(ea(x*C)+ea(ea(y*s)+ea(u*v)))-ea(w*r));E=ea(ea(ea(w*v)+ea(ea(x*s)+ea(u*r)))-ea(y*C));F=ea(ea(ea(ea(u*s)-ea(w*C))-ea(y*v))-ea(x*r));g[h>>2]=D;g[h+4>>2]=t;g[h+8>>2]=E;g[h+12>>2]=F;g[h+16>>2]=A;g[h+20>>2]=z;g[h+24>>2]=B;g[b+224>>2]=D;g[b+228>>2]=t;g[b+232>>2]=E;g[b+236>>2]=F;g[b+240>>2]=A;g[b+244>>2]=z;g[b+248>>2]=B;m=(c[b+52>>2]|0)>>>30;if((m|0)==3){G=c[k>>2]|0;H=10}else if((m|0)==2?(m=c[k>>2]|0,(a[m+2417>>0]|0)!=0):0){G=m;H=10}else H=9;if((H|0)==9)M8(b+64|0,h);else if((H|0)==10){c[l>>2]=c[l>>2]&-131073;r4(G,k);c[l>>2]=c[l>>2]|65536}if((j|0)==0|e^1){i=f;return}BV(c[b+288>>2]|0,0,1);i=f;return}function XW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;h=KU(b)|0;j=b+48|0;g[b+252>>2]=ea(g[d>>2]);k=d+4|0;g[b+256>>2]=ea(g[k>>2]);l=d+8|0;g[b+260>>2]=ea(g[l>>2]);m=(c[b+52>>2]|0)>>>30;if((m|0)==2){n=c[j>>2]|0;if(!(a[n+2416>>0]|0))o=4;else{p=n;o=5}}else if((m|0)==3){p=c[j>>2]|0;o=5}else o=4;if((o|0)==4){g[b+144>>2]=ea(g[d>>2]);g[b+148>>2]=ea(g[k>>2]);g[b+152>>2]=ea(g[l>>2])}else if((o|0)==5){r4(p,j);j=b+284|0;c[j>>2]=c[j>>2]|262144}if(!h){i=f;return}h=c[b+288>>2]|0;if(ea(g[d>>2])==ea(0.0)?ea(g[k>>2])==ea(0.0):0)q=ea(g[l>>2])!=ea(0.0);else q=1;BV(h,q,e);i=f;return}function YW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;h=KU(b)|0;j=b+48|0;g[b+264>>2]=ea(g[d>>2]);k=d+4|0;g[b+268>>2]=ea(g[k>>2]);l=d+8|0;g[b+272>>2]=ea(g[l>>2]);m=(c[b+52>>2]|0)>>>30;if((m|0)==2){n=c[j>>2]|0;if(!(a[n+2416>>0]|0))o=4;else{p=n;o=5}}else if((m|0)==3){p=c[j>>2]|0;o=5}else o=4;if((o|0)==4){g[b+160>>2]=ea(g[d>>2]);g[b+164>>2]=ea(g[k>>2]);g[b+168>>2]=ea(g[l>>2])}else if((o|0)==5){r4(p,j);j=b+284|0;c[j>>2]=c[j>>2]|524288}if(!h){i=f;return}h=c[b+288>>2]|0;if(ea(g[d>>2])==ea(0.0)?ea(g[k>>2])==ea(0.0):0)q=ea(g[l>>2])!=ea(0.0);else q=1;BV(h,q,e);i=f;return}function ZW(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0;h=i;i=i+112|0;j=h+48|0;k=h+16|0;l=h;jVa(d,e,f);f=d+48|0;m=d+52|0;n=c[m>>2]|0;if(!(n&1))o=(c[450992+((n>>>24&15)<<2)>>2]|0)+f+8|0;else{p=d+56|0;q=c[p>>2]|0;if(!q){r=s4(c[f>>2]|0,n>>>24&15)|0;c[p>>2]=r;s=r}else s=q;o=s}if(!(b[o>>1]&1)){i=h;return}o=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0;t=ea(Um[c[(c[o>>2]|0)+296>>2]&63](o,0));o=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0;if(ea(t*ea(Um[c[(c[o>>2]|0)+296>>2]&63](o,3)))!=ea(0.0)){o=d+284|0;if(!(c[o>>2]&2))u=U8(d+64|0)|0;else{s=d+56|0;q=c[s>>2]|0;if(!q){r=s4(c[f>>2]|0,(c[m>>2]|0)>>>24&15)|0;c[s>>2]=r;v=r}else v=q;u=v+96|0}w=ea(g[u>>2]);x=ea(g[u+4>>2]);y=ea(g[u+8>>2]);if(w==ea(0.0))z=ea(0.0);else z=ea(ea(1.0)/w);if(x==ea(0.0))A=ea(0.0);else A=ea(ea(1.0)/x);if(y==ea(0.0))B=ea(0.0);else B=ea(ea(1.0)/y);if(!(c[o>>2]&1))C=ea(S8(d+64|0));else{o=d+56|0;u=c[o>>2]|0;if(!u){v=s4(c[f>>2]|0,(c[m>>2]|0)>>>24&15)|0;c[o>>2]=v;D=v}else D=u;C=ea(g[D+92>>2])}y=ea(ea(6.0)/ea(ea(1.0)/C));C=ea(z*y);z=ea(A*y);A=ea(B*y);y=ea(T(ea(S(ea(A+ea(z-C))))));B=ea(T(ea(S(ea(A+ea(C-z))))));x=ea(T(ea(S(ea(ea(C+z)-A)))));D=DKa(e,16777215)|0;kLa(j,d+224|0);u=EKa(D,j)|0;A=ea(y*ea(.5));y=ea(B*ea(.5));B=ea(x*ea(.5));x=ea(-y);z=ea(-B);g[k>>2]=ea(-A);g[k+4>>2]=x;g[k+8>>2]=z;g[k+12>>2]=A;g[k+16>>2]=y;g[k+20>>2]=B;a[k+24>>0]=1;HKa(u,k)|0}k=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0;B=ea(t*ea(Um[c[(c[k>>2]|0)+296>>2]&63](k,21)));k=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0;y=ea(t*ea(Um[c[(c[k>>2]|0)+296>>2]&63](k,22)));if(!(B!=ea(0.0)|y!=ea(0.0))){i=h;return}c[l>>2]=430496;g[l+4>>2]=B;g[l+8>>2]=y;c[l+12>>2]=e;_W(d,l);i=h;return}function _W(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im;d=i;i=i+224|0;e=d+156|0;f=d+64|0;h=d;j=d+100|0;k=d+128|0;l=d+184|0;m=d+36|0;n=d+96|0;o=d+92|0;p=d+32|0;q=d+28|0;r=c[a+296>>2]|0;if(!r){i=d;return}In[c[(c[a>>2]|0)+84>>2]&4095](f,a);s=a+292|0;a=c[s>>2]|0;In[c[(c[a>>2]|0)+36>>2]&4095](h,a);t=ea(ea(g[h+16>>2])*ea(2.0));u=ea(ea(g[h+20>>2])*ea(2.0));v=ea(ea(g[h+24>>2])*ea(2.0));w=ea(g[f+12>>2]);x=ea(ea(w*w)+ea(-.5));y=ea(g[f>>2]);z=ea(t*y);A=ea(g[f+4>>2]);B=ea(z+ea(u*A));z=ea(g[f+8>>2]);C=ea(B+ea(v*z));B=ea(ea(y*C)+ea(ea(t*x)+ea(w*ea(ea(v*A)-ea(u*z)))));D=ea(ea(A*C)+ea(ea(u*x)+ea(w*ea(ea(t*z)-ea(v*y)))));E=ea(ea(ea(v*x)+ea(w*ea(ea(u*y)-ea(t*A))))+ea(z*C));C=ea(ea(g[f+16>>2])+B);B=ea(ea(g[f+20>>2])+D);D=ea(ea(g[f+24>>2])+E);E=ea(g[h>>2]);t=ea(w*E);u=ea(g[h+12>>2]);x=ea(t+ea(y*u));t=ea(g[h+8>>2]);v=ea(x+ea(A*t));x=ea(g[h+4>>2]);F=ea(ea(ea(z*E)+ea(ea(A*u)+ea(w*x)))-ea(y*t));G=ea(ea(ea(y*x)+ea(ea(z*u)+ea(w*t)))-ea(A*E));H=ea(ea(ea(ea(w*u)-ea(y*E))-ea(A*x))-ea(z*t));g[e>>2]=ea(v-ea(z*x));h=e+4|0;g[h>>2]=F;f=e+8|0;g[f>>2]=G;a=e+12|0;g[a>>2]=H;g[e+16>>2]=C;g[e+20>>2]=B;g[e+24>>2]=D;In[c[(c[r>>2]|0)+84>>2]&4095](k,r);r=c[s>>2]|0;In[c[(c[r>>2]|0)+28>>2]&4095](l,r);D=ea(ea(g[l+16>>2])*ea(2.0));B=ea(ea(g[l+20>>2])*ea(2.0));C=ea(ea(g[l+24>>2])*ea(2.0));H=ea(g[k+12>>2]);G=ea(ea(H*H)+ea(-.5));F=ea(g[k>>2]);x=ea(D*F);z=ea(g[k+4>>2]);v=ea(x+ea(B*z));x=ea(g[k+8>>2]);t=ea(v+ea(C*x));v=ea(ea(F*t)+ea(ea(D*G)+ea(H*ea(ea(C*z)-ea(B*x)))));A=ea(ea(z*t)+ea(ea(B*G)+ea(H*ea(ea(D*x)-ea(C*F)))));E=ea(ea(ea(C*G)+ea(H*ea(ea(B*F)-ea(D*z))))+ea(x*t));t=ea(ea(g[k+16>>2])+v);v=ea(ea(g[k+20>>2])+A);A=ea(ea(g[k+24>>2])+E);E=ea(g[l>>2]);D=ea(H*E);B=ea(g[l+12>>2]);G=ea(D+ea(F*B));D=ea(g[l+8>>2]);C=ea(G+ea(z*D));G=ea(g[l+4>>2]);y=ea(ea(ea(x*E)+ea(ea(z*B)+ea(H*G)))-ea(F*D));u=ea(ea(ea(F*G)+ea(ea(x*B)+ea(H*D)))-ea(z*E));w=ea(ea(ea(ea(H*B)-ea(F*E))-ea(z*G))-ea(x*D));g[j>>2]=ea(C-ea(x*G));l=j+4|0;g[l>>2]=y;k=j+8|0;g[k>>2]=u;r=j+12|0;g[r>>2]=w;I=j+16|0;g[I>>2]=t;J=j+20|0;g[J>>2]=v;K=j+24|0;g[K>>2]=A;co[c[(c[b>>2]|0)+8>>2]&2047](b,e,j);A=ea(g[j>>2]);g[m>>2]=A;v=ea(g[l>>2]);g[m+4>>2]=v;t=ea(g[k>>2]);g[m+8>>2]=t;w=ea(g[r>>2]);g[m+12>>2]=w;g[m+16>>2]=ea(g[I>>2]);g[m+20>>2]=ea(g[J>>2]);g[m+24>>2]=ea(g[K>>2]);u=ea(g[e>>2]);y=ea(u*A);G=ea(g[h>>2]);x=ea(y+ea(G*v));y=ea(g[f>>2]);C=ea(x+ea(y*t));x=ea(g[a>>2]);if(ea(C+ea(x*w))<ea(0.0)){C=ea(-A);D=ea(-v);z=ea(-t);E=ea(-w);g[j>>2]=C;g[l>>2]=D;g[k>>2]=z;g[r>>2]=E;L=C;M=E;N=z;O=D}else{L=A;M=w;N=t;O=v}v=ea(-u);u=ea(-G);G=ea(-y);y=ea(ea(ea(ea(x*L)+ea(M*v))+ea(N*u))-ea(O*G));t=ea(ea(ea(L*G)+ea(ea(M*u)+ea(x*O)))-ea(N*v));w=ea(ea(ea(O*v)+ea(ea(M*G)+ea(x*N)))-ea(L*u));A=ea(ea(ea(ea(x*M)-ea(L*v))-ea(O*u))-ea(N*G));if(y!=ea(0.0)){G=ea(ea(1.0)/ea(T(ea(ea(ea(y*y)+ea(0.0))+ea(A*A)))));P=ea(y*G);Q=ea(G*ea(0.0));R=ea(A*G)}else{P=ea(0.0);Q=ea(0.0);R=ea(1.0)}G=ea(-P);N=ea(-Q);Q=ea(A*N);u=ea(y*N);O=ea(ea(ea(ea(t*R)+Q)+ea(w*G))-u);v=ea(ea(u+ea(ea(w*R)+Q))-ea(t*G));Q=ea(ea(ea(ea(A*R)-ea(y*G))-ea(t*N))-ea(w*N));N=ea(P/ea(R+ea(1.0)));r=c[s>>2]|0;co[c[(c[r>>2]|0)+132>>2]&2047](r,n,o);r=c[s>>2]|0;co[c[(c[r>>2]|0)+92>>2]&2047](r,p,q);r=c[s>>2]|0;R=ea(Kn[c[(c[r>>2]|0)+116>>2]&255](r));r=c[s>>2]|0;P=ea(Kn[c[(c[r>>2]|0)+148>>2]&255](r));w=ea(g[n>>2]);t=ea(g[o>>2]);o=ea(S(ea(N)))>ea(+X(+(+ea(t-P))));zo[c[(c[b>>2]|0)+16>>2]&3](b,m,w,t,o);t=ea(Q+ea(1.0));Q=ea(v/t);v=ea(-ea(O/t));t=ea(+X(+(+ea(ea(g[p>>2])*ea(.25)))));O=ea(+X(+(+ea(ea(g[q>>2])*ea(.25)))));w=ea(+X(+(+ea(R*ea(.25)))));R=ea(S(ea(Q)));Q=ea(S(ea(v)));v=ea(ea(ea(w+R)/ea(ea(1.0)-ea(w*R)))/t);R=ea(ea(ea(w+Q)/ea(ea(1.0)-ea(w*Q)))/O);q=!(ea(ea(v*v)+ea(R*R))<=ea(1.0));zo[c[(c[b>>2]|0)+20>>2]&3](b,m,t,O,q);i=d;return}function $W(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;c[b>>2]=430664;g=b+4|0;h=c[(FTa()|0)>>2]|0;if(h){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,h,m?443792:544544,443712,100)|0;c[g>>2]=l;if(l)GTa(l)}else c[g>>2]=0;c[b+8>>2]=d;d=b+12|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[b+40>>2]=0;d=b+44|0;g=e+0|0;e=d+88|0;do{c[d>>2]=c[g>>2];d=d+4|0;g=g+4|0}while((d|0)<(e|0));c[b+144>>2]=-16;c[b+132>>2]=0;c[b+136>>2]=0;c[b+140>>2]=0;a[b+148>>0]=0;i=f;return}function aX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[a>>2]=430664;yCa((c[a+8>>2]|0)+3376|0,a);e=c[a+12>>2]|0;f=c[a+20>>2]|0;if(!((f|0)<0|(f&2147483647|0)==0|(e|0)==0)){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=a+4|0;HTa(c[e>>2]|0);f=c[e>>2]|0;if(!f){VJa(d,a);i=b;return}e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,f);VJa(d,a);i=b;return}function bX(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=430664;yCa((c[a+8>>2]|0)+3376|0,a);d=c[a+12>>2]|0;e=c[a+20>>2]|0;if(!((e|0)<0|(e&2147483647|0)==0|(d|0)==0)){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+4|0;HTa(c[d>>2]|0);a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function cX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!(eTa(a+40|0,0,0)|0)){f=a+80|0;a=b+0|0;b=f+48|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(b|0));i=d;return}else{dKa(bKa()|0,8,430736,77,430816,e);i=d;return}}function dX(a){a=a|0;return a+80|0}function eX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+28|0;if(c[e>>2]|0){f=b+80|0;g=0;do{a[(c[f>>2]|0)+(g*80|0)+76>>0]=0;h=c[f>>2]|0;a[h+(g*80|0)+77>>0]=0;c[h+(g*80|0)+68>>2]=0;c[h+(g*80|0)+64>>2]=0;c[(c[f>>2]|0)+(g*80|0)+72>>2]=0;g=g+1|0}while(g>>>0<(c[e>>2]|0)>>>0)}e=b+32|0;if(c[e>>2]|0){g=b+96|0;f=0;do{a[(c[g>>2]|0)+(f<<5)+28>>0]=0;h=c[g>>2]|0;a[h+(f<<5)+29>>0]=0;c[h+(f<<5)+20>>2]=0;c[h+(f<<5)+16>>2]=0;c[(c[g>>2]|0)+(f<<5)+24>>2]=0;f=f+1|0}while(f>>>0<(c[e>>2]|0)>>>0)}e=b+36|0;if(!(c[e>>2]|0)){i=d;return}f=b+88|0;b=0;do{a[(c[f>>2]|0)+(b<<6)+60>>0]=0;g=c[f>>2]|0;a[g+(b<<6)+61>>0]=0;c[g+(b<<6)+52>>2]=0;c[g+(b<<6)+48>>2]=0;c[(c[f>>2]|0)+(b<<6)+56>>2]=0;b=b+1|0}while(b>>>0<(c[e>>2]|0)>>>0);i=d;return}function fX(f){f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0;h=i;i=i+192|0;j=h;k=h+168|0;l=h+188|0;m=h+186|0;n=h+184|0;o=f+8|0;p=c[o>>2]|0;q=c[p+1216>>2]|0;r=p+1208|0;p=c[r>>2]|0;s=c[r+4>>2]|0;Dn[c[(c[q>>2]|0)+8>>2]&511](q,136,p,s);r=f+40|0;t=eTa(r,1,0)|0;if((t|0)==-1){dKa(bKa()|0,8,430736,347,430960,j);Dn[c[(c[q>>2]|0)+12>>2]&511](q,136,p,s);i=h;return}else if((t|0)==1){dKa(bKa()|0,8,430736,342,430904,j);Dn[c[(c[q>>2]|0)+12>>2]&511](q,136,p,s);i=h;return}else{eX(f);Dn[c[(c[q>>2]|0)+12>>2]&511](q,136,p,s);s=a[f+76>>0]|0;p=f+84|0;q=c[p>>2]|0;t=c[f+80>>2]|0;u=c[f+104>>2]|0;v=f+100|0;w=c[v>>2]|0;x=c[f+96>>2]|0;y=c[f+112>>2]|0;z=f+92|0;A=c[z>>2]|0;B=c[f+88>>2]|0;C=c[f+108>>2]|0;D=c[f+48>>2]|0;E=c[f+52>>2]|0;F=c[f+56>>2]|0;c[k>>2]=c[f+44>>2];c[k+4>>2]=D;c[k+8>>2]=E;c[k+12>>2]=F;F=f+144|0;if((c[F>>2]|0)==-16){c[F>>2]=-16;E=f+24|0;a[f+148>>0]=0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;jTa(r,0)|0;i=h;return}E=f+12|0;D=j+4|0;G=j+8|0;H=j+12|0;I=j+16|0;J=j+20|0;K=j+44|0;L=j+48|0;M=j+52|0;N=j+68|0;O=j+72|0;P=j+76|0;Q=j+80|0;R=j+84|0;S=j+92|0;T=j+96|0;U=j+100|0;V=j+104|0;W=j+108|0;X=j+132|0;Y=j+136|0;Z=j+140|0;_=j+160|0;$=j+4|0;aa=j+24|0;ba=j+28|0;ca=j+32|0;da=j+36|0;fa=j+40|0;ga=j+4|0;ha=j+8|0;ia=j+12|0;ja=j+20|0;ka=j+24|0;la=j+28|0;ma=j+32|0;na=j+36|0;oa=j+44|0;pa=j+48|0;qa=j+52|0;ra=j+64|0;sa=j+4|0;ta=j+4|0;ua=j+8|0;va=j+12|0;wa=j+16|0;xa=j+20|0;ya=j+44|0;za=j+52|0;Aa=j+56|0;Ba=j+60|0;Ca=j+64|0;Da=j+68|0;Ea=j+76|0;Fa=j+80|0;Ga=j+84|0;Ha=j+88|0;Ia=j+92|0;Ja=j+116|0;Ka=j+128|0;La=j+4|0;Ma=j+24|0;Na=j+28|0;Oa=j+32|0;Pa=j+36|0;Qa=j+40|0;Ra=j+48|0;Sa=q;q=t;t=w;w=x;x=A;A=B;B=0;Ta=0;while(1){Ua=c[E>>2]|0;Va=Ua+B|0;Wa=Ua+(B+8)|0;Xa=Ua+(B+26)|0;if(!(a[Xa>>0]|0)){a[Xa>>0]=s;Ya=c[E>>2]|0}else Ya=Ua;Xa=B;B=c[Va>>2]|0;Za=Ua+(Xa+40)|0;if(!(c[Za>>2]|0))_a=64;else{c[Za>>2]=Ua+(Xa+64);_a=76}$a=Ua+(Xa+44)|0;if(!(c[$a>>2]|0))ab=_a;else{c[$a>>2]=Ua+(_a+Xa);ab=_a+12|0}$a=Ua+(Xa+56)|0;if(!(c[$a>>2]|0))bb=ab;else{c[$a>>2]=Ua+(ab+Xa);bb=ab+28|0}$a=Ua+(Xa+52)|0;if(c[$a>>2]|0){cb=bb+4|0;db=c[Ua+(bb+Xa)>>2]|0;if(!db)eb=Ua+(cb+Xa)|0;else if((db|0)==2)eb=Ua+(cb+Xa)|0;else if((db|0)==4)eb=Ua+(cb+Xa)|0;else if((db|0)==3)eb=Ua+(cb+Xa)|0;else eb=0;c[$a>>2]=eb}$a=a[Ua+(Xa+38)>>0]|0;if(!$a){cb=Sa-(c[p>>2]|0)>>6;db=u-cb|0;fb=Ua+(Xa+36)|0;gb=e[fb>>1]|0;c[D>>2]=0;c[G>>2]=0;c[H>>2]=-1;b[I>>1]=0;c[J+0>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;c[J+12>>2]=0;c[J+16>>2]=0;c[J+20>>2]=0;g[K>>2]=ea(3402823469999999843913219.0e14);g[L>>2]=ea(0.0);g[M>>2]=ea(0.0);a[N>>0]=0;c[O>>2]=Sa;c[P>>2]=gb>>>0<db>>>0?gb:db;c[Q>>2]=0;c[j>>2]=431384;a[R>>0]=0;c[S>>2]=0;c[T>>2]=0;c[U>>2]=-1;b[V>>1]=0;c[W+0>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;c[W+12>>2]=0;c[W+16>>2]=0;c[W+20>>2]=0;g[X>>2]=ea(3402823469999999843913219.0e14);g[Y>>2]=ea(0.0);g[Z>>2]=ea(0.0);a[_>>0]=0;db=c[o>>2]|0;b[l>>1]=b[Ua+(Xa+4)>>1]|0;r1(db,Za,j,l,c[Ua+(Xa+32)>>2]|0,Wa,0,k)|0;if((u|0)==(cb|0))hb=(b[fb>>1]|0)!=0;else hb=0;fb=(d[R>>0]|hb&1)&255;a[R>>0]=fb;cb=fb<<24>>24!=0;c[q+72>>2]=c[Ua+(Xa+28)>>2];c[q+0>>2]=c[$+0>>2];c[q+4>>2]=c[$+4>>2];c[q+8>>2]=c[$+8>>2];b[q+12>>1]=b[I>>1]|0;g[q+16>>2]=ea(g[J>>2]);g[q+20>>2]=ea(g[aa>>2]);g[q+24>>2]=ea(g[ba>>2]);g[q+28>>2]=ea(g[ca>>2]);g[q+32>>2]=ea(g[da>>2]);g[q+36>>2]=ea(g[fa>>2]);g[q+40>>2]=ea(g[K>>2]);fb=q+44|0;c[fb+0>>2]=c[L+0>>2];c[fb+4>>2]=c[L+4>>2];c[fb+8>>2]=c[L+8>>2];c[fb+12>>2]=c[L+12>>2];c[fb+16>>2]=c[L+16>>2];a[q+77>>0]=a[N>>0]|0;fb=c[Q>>2]|0;c[q+68>>2]=fb;a[q+76>>0]=cb?2:1;c[q+64>>2]=(fb|0)==0&cb?0:c[O>>2]|0;ib=Sa+(c[Q>>2]<<6)|0;jb=q+80|0;kb=t;lb=w;mb=x;nb=A}else if(($a|0)==1){cb=t-(c[v>>2]|0)>>4;fb=y-cb|0;db=Ua+(Xa+36)|0;gb=e[db>>1]|0;c[ga>>2]=0;c[ha>>2]=0;c[ia>>2]=-1;a[ja>>0]=0;c[ka>>2]=t;c[la>>2]=gb>>>0<fb>>>0?gb:fb;c[ma>>2]=0;c[j>>2]=431360;a[na>>0]=0;c[oa>>2]=0;c[pa>>2]=0;c[qa>>2]=-1;a[ra>>0]=0;fb=c[o>>2]|0;b[m>>1]=b[Ua+(Xa+4)>>1]|0;t1(fb,Za,j,m,c[Ua+(Xa+32)>>2]|0,Wa,0,k)|0;if((y|0)==(cb|0))ob=(b[db>>1]|0)!=0;else ob=0;db=(d[na>>0]|ob&1)&255;a[na>>0]=db;cb=db<<24>>24!=0;c[w+24>>2]=c[Ua+(Xa+28)>>2];c[w+0>>2]=c[sa+0>>2];c[w+4>>2]=c[sa+4>>2];c[w+8>>2]=c[sa+8>>2];c[w+12>>2]=c[sa+12>>2];a[w+29>>0]=a[ja>>0]|0;db=c[ma>>2]|0;c[w+20>>2]=db;a[w+28>>0]=cb?2:1;c[w+16>>2]=(db|0)==0&cb?0:c[ka>>2]|0;ib=Sa;jb=q;kb=t+(c[ma>>2]<<4)|0;lb=w+32|0;mb=x;nb=A}else if(($a|0)==2){$a=(x-(c[z>>2]|0)|0)/48|0;cb=C-$a|0;db=Ua+(Xa+36)|0;fb=e[db>>1]|0;c[ta>>2]=0;c[ua>>2]=0;c[va>>2]=-1;b[wa>>1]=0;c[xa+0>>2]=0;c[xa+4>>2]=0;c[xa+8>>2]=0;c[xa+12>>2]=0;c[xa+16>>2]=0;c[xa+20>>2]=0;g[ya>>2]=ea(3402823469999999843913219.0e14);a[za>>0]=0;c[Aa>>2]=x;c[Ba>>2]=fb>>>0<cb>>>0?fb:cb;c[Ca>>2]=0;c[j>>2]=431336;a[Da>>0]=0;c[Ea>>2]=0;c[Fa>>2]=0;c[Ga>>2]=-1;b[Ha>>1]=0;c[Ia+0>>2]=0;c[Ia+4>>2]=0;c[Ia+8>>2]=0;c[Ia+12>>2]=0;c[Ia+16>>2]=0;c[Ia+20>>2]=0;g[Ja>>2]=ea(3402823469999999843913219.0e14);a[Ka>>0]=0;cb=c[o>>2]|0;b[n>>1]=b[Ua+(Xa+4)>>1]|0;v1(cb,Za,j,n,c[Ua+(Xa+32)>>2]|0,Wa,0,k)|0;if((C|0)==($a|0))pb=(b[db>>1]|0)!=0;else pb=0;db=(d[Da>>0]|pb&1)&255;a[Da>>0]=db;$a=db<<24>>24!=0;c[A+56>>2]=c[Ua+(Xa+28)>>2];c[A+0>>2]=c[La+0>>2];c[A+4>>2]=c[La+4>>2];c[A+8>>2]=c[La+8>>2];b[A+12>>1]=b[wa>>1]|0;g[A+16>>2]=ea(g[xa>>2]);g[A+20>>2]=ea(g[Ma>>2]);g[A+24>>2]=ea(g[Na>>2]);g[A+28>>2]=ea(g[Oa>>2]);g[A+32>>2]=ea(g[Pa>>2]);g[A+36>>2]=ea(g[Qa>>2]);g[A+40>>2]=ea(g[ya>>2]);c[A+44>>2]=c[Ra>>2];a[A+61>>0]=a[za>>0]|0;Xa=c[Ca>>2]|0;c[A+52>>2]=Xa;a[A+60>>0]=$a?2:1;c[A+48>>2]=(Xa|0)==0&$a?0:c[Aa>>2]|0;ib=Sa;jb=q;kb=t;lb=w;mb=x+((c[Ca>>2]|0)*48|0)|0;nb=A+64|0}else{ib=Sa;jb=q;kb=t;lb=w;mb=x;nb=A}if((c[Va>>2]|0)==-16)break;Ta=Ta+1|0;if(Ta>>>0>=1e6)break;else{Sa=ib;q=jb;t=kb;w=lb;x=mb;A=nb}}c[F>>2]=-16;F=f+24|0;a[f+148>>0]=0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;jTa(r,0)|0;i=h;return}}function gX(d,e,f,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;o=i;i=i+64|0;p=o+32|0;q=o+8|0;r=d+28|0;if((c[r>>2]|0)>>>0>=(c[d+116>>2]|0)>>>0){i=o;return}s=d+40|0;if((eTa(s,-1,0)|0)==1){dKa(bKa()|0,8,430736,551,431040,o);i=o;return}c[r>>2]=(c[r>>2]|0)+1;r=b[k>>1]|0;k=p+2|0;b[k+0>>1]=b[l+0>>1]|0;b[k+2>>1]=b[l+2>>1]|0;b[k+4>>1]=b[l+4>>1]|0;b[k+6>>1]=b[l+6>>1]|0;b[k+8>>1]=b[l+8>>1]|0;b[k+10>>1]=b[l+10>>1]|0;b[k+12>>1]=b[l+12>>1]|0;b[k+14>>1]=b[l+14>>1]|0;k=b[l+16>>1]|0;t=a[l+18>>0]|0;l=d+12|0;u=d+24|0;v=c[u>>2]|0;w=v+40|0;x=c[d+20>>2]&2147483647;if(w>>>0>x>>>0?(y=(w*3|0)+256|0,x>>>0<y>>>0):0)kVa(l,y);lVa(l,w);y=c[u>>2]|0;x=c[l>>2]|0;c[x+y>>2]=-16;b[x+(y+4)>>1]=r;r=x+(y+6)+0|0;z=p+0|0;p=r+18|0;do{b[r>>1]=b[z>>1]|0;r=r+2|0;z=z+2|0}while((r|0)<(p|0));b[x+(y+24)>>1]=k;a[x+(y+26)>>0]=t;c[x+(y+28)>>2]=m;c[x+(y+32)>>2]=n;b[x+(y+36)>>1]=j;a[x+(y+38)>>0]=0;c[u>>2]=w;w=d+144|0;d=c[w>>2]|0;if((d|0)==-16)A=w;else A=(c[l>>2]|0)+d|0;c[A>>2]=v;c[w>>2]=v;c[q>>2]=e;c[q+4>>2]=f;g[q+8>>2]=h;c[q+12>>2]=0;c[q+16>>2]=0;g[q+20>>2]=ea(0.0);mVa(l,q);jTa(s,0)|0;i=o;return}function hX(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+64|0;n=m+32|0;o=m+8|0;p=d+32|0;if((c[p>>2]|0)>>>0>=(c[d+124>>2]|0)>>>0){i=m;return}q=d+40|0;if((eTa(q,-1,0)|0)==1){dKa(bKa()|0,8,430736,572,431112,m);i=m;return}c[p>>2]=(c[p>>2]|0)+1;p=n+2|0;b[p+0>>1]=b[j+0>>1]|0;b[p+2>>1]=b[j+2>>1]|0;b[p+4>>1]=b[j+4>>1]|0;b[p+6>>1]=b[j+6>>1]|0;b[p+8>>1]=b[j+8>>1]|0;b[p+10>>1]=b[j+10>>1]|0;b[p+12>>1]=b[j+12>>1]|0;b[p+14>>1]=b[j+14>>1]|0;p=b[j+16>>1]|0;r=a[j+18>>0]|0;j=d+12|0;s=d+24|0;t=c[s>>2]|0;u=t+40|0;v=c[d+20>>2]&2147483647;if(u>>>0>v>>>0?(w=(u*3|0)+256|0,v>>>0<w>>>0):0)kVa(j,w);lVa(j,u);w=c[s>>2]|0;v=c[j>>2]|0;c[v+w>>2]=-16;b[v+(w+4)>>1]=0;x=v+(w+6)+0|0;y=n+0|0;n=x+18|0;do{b[x>>1]=b[y>>1]|0;x=x+2|0;y=y+2|0}while((x|0)<(n|0));b[v+(w+24)>>1]=p;a[v+(w+26)>>0]=r;c[v+(w+28)>>2]=k;c[v+(w+32)>>2]=l;b[v+(w+36)>>1]=h;a[v+(w+38)>>0]=1;c[s>>2]=u;u=d+144|0;d=c[u>>2]|0;if((d|0)==-16)z=u;else z=(c[j>>2]|0)+d|0;c[z>>2]=t;c[u>>2]=t;c[o+12>>2]=e;c[o+16>>2]=f;g[o+20>>2]=ea(0.0);c[o+4>>2]=0;c[o>>2]=0;mVa(j,o);jTa(q,0)|0;i=m;return}function iX(e,f,h,j,k,l,m,n,o,p,q){e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im;r=i;i=i+64|0;s=r;t=r+32|0;u=r+8|0;v=e+36|0;if((c[v>>2]|0)>>>0>=(c[e+120>>2]|0)>>>0){i=r;return}w=e+40|0;if((eTa(w,-1,0)|0)==1){dKa(bKa()|0,8,430736,600,431184,s);i=r;return}c[v>>2]=(c[v>>2]|0)+1;v=b[m>>1]|0;x=t+2|0;b[x+0>>1]=b[n+0>>1]|0;b[x+2>>1]=b[n+2>>1]|0;b[x+4>>1]=b[n+4>>1]|0;b[x+6>>1]=b[n+6>>1]|0;b[x+8>>1]=b[n+8>>1]|0;b[x+10>>1]=b[n+10>>1]|0;b[x+12>>1]=b[n+12>>1]|0;b[x+14>>1]=b[n+14>>1]|0;x=b[n+16>>1]|0;y=a[n+18>>0]|0;n=e+12|0;z=e+24|0;A=c[z>>2]|0;B=A+40|0;C=c[e+20>>2]&2147483647;if(B>>>0>C>>>0?(D=(B*3|0)+256|0,C>>>0<D>>>0):0)kVa(n,D);lVa(n,B);D=c[z>>2]|0;C=c[n>>2]|0;c[C+D>>2]=-16;b[C+(D+4)>>1]=v;v=C+(D+6)+0|0;E=t+0|0;t=v+18|0;do{b[v>>1]=b[E>>1]|0;v=v+2|0;E=E+2|0}while((v|0)<(t|0));b[C+(D+24)>>1]=x;a[C+(D+26)>>0]=y;c[C+(D+28)>>2]=o;c[C+(D+32)>>2]=p;b[C+(D+36)>>1]=l;a[C+(D+38)>>0]=2;c[z>>2]=B;B=e+144|0;z=c[B>>2]|0;if((z|0)==-16)F=B;else F=(c[n>>2]|0)+z|0;c[F>>2]=A;c[B>>2]=A;A=b[m>>1]|0;B=e+148|0;a[B>>0]=(A&65535)>>>9&1|(d[B>>0]|0);if((A&768)==768){dKa(bKa()|0,4,430736,610,445720,s);B=b[m>>1]&-257;b[m>>1]=B;G=B}else G=A;if((G&528)==528){dKa(bKa()|0,4,430736,616,445792,s);A=b[m>>1]&-17;b[m>>1]=A;H=A}else H=G;if((H&256)!=0&q>ea(0.0)){dKa(bKa()|0,4,430736,624,445904,s);I=ea(0.0)}else I=q;c[u>>2]=0;g[u+8>>2]=k;c[u+4>>2]=j;c[u+12>>2]=f;c[u+16>>2]=h;g[u+20>>2]=I;mVa(n,u);jTa(w,0)|0;i=r;return}function jX(a){a=a|0;var b=0;b=i;i=i+16|0;if(!(eTa(a+40|0,0,0)|0)){p1(c[a+8>>2]|0,a);i=b;return}else{dKa(bKa()|0,8,430736,636,431256,b);i=b;return}}function kX(a){a=a|0;return c[a+52>>2]|0}function lX(a){a=a|0;return c[a+56>>2]|0}function mX(a){a=a|0;return c[a+44>>2]|0}function nX(a){a=a|0;return c[a+48>>2]|0}function oX(b){b=b|0;return a[b+76>>0]|0}function pX(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=g+4|0;k=a+16|0;c[a+56>>2]=d;c[a+64>>2]=c[f>>2];c[a+68>>2]=c[f+4>>2];c[a+72>>2]=c[f+8>>2];c[a+60>>2]=c[f+12>>2];c[a+76>>2]=c[f+16>>2];f=a+8|0;d=c[f>>2]|0;if((d|0)!=0?(BU(d+(c[426976+((e[d+4>>1]|0)<<2)>>2]|0)|0,0,a)|0)==-1:0){d=c[f>>2]|0;CU(d+(c[426976+((e[d+4>>1]|0)<<2)>>2]|0)|0,0,a,431400);l=1}else l=0;d=a+12|0;m=c[d>>2]|0;if((m|0)!=0?(BU(m+(c[426976+((e[m+4>>1]|0)<<2)>>2]|0)|0,0,a)|0)==-1:0){m=c[d>>2]|0;CU(m+(c[426976+((e[m+4>>1]|0)<<2)>>2]|0)|0,0,a,431400)}else n=7;if((n|0)==7?!l:0){i=g;return}l=c[f>>2]|0;if((l|0)!=0?(In[c[(c[l>>2]|0)+52>>2]&4095](h,l),(b[h>>1]&8)==0):0){l=c[f>>2]|0;o=mo[c[(c[l>>2]|0)+28>>2]&4095](l)|0}else o=0;l=c[d>>2]|0;if((l|0)!=0?(In[c[(c[l>>2]|0)+52>>2]&4095](j,l),(b[j>>1]&8)==0):0){j=c[d>>2]|0;p=mo[c[(c[j>>2]|0)+28>>2]&4095](j)|0}else p=0;if(!((c[f>>2]|0)!=0&(o|0)==0)?!((c[d>>2]|0)!=0&(p|0)==0):0)q=(o|0)!=0?o:p;else q=0;if((((c[a+20>>2]|0)>>>30)+-1|0)>>>0<2?(p=c[a+16>>2]|0,(p|0)!=0):0)r=P3(p)|0;else r=0;if((r|0)==(q|0)){i=g;return}if(r){p=r+3528|0;o=c[p>>2]|0;if(o){d=c[r+3524>>2]|0;f=0;while(1){j=f+1|0;if((c[d+(f<<2)>>2]|0)==(a|0)){s=f;break}if(j>>>0<o>>>0)f=j;else{s=j;break}}if((s|0)!=(o|0)){f=o+-1|0;c[p>>2]=f;c[d+(s<<2)>>2]=c[d+(f<<2)>>2]}}X3(r+16|0,k)}if(!q){i=g;return}r=q+3524|0;c[h>>2]=a;f=q+3528|0;d=c[f>>2]|0;if((c[q+3532>>2]&2147483647)>>>0>d>>>0){s=(c[r>>2]|0)+(d<<2)|0;if(s)c[s>>2]=a;c[f>>2]=d+1}else cVa(r,h)|0;W3(q+16|0,k);i=g;return}function qX(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+2|0;f=d;g=a+8|0;h=c[g>>2]|0;if((h|0)!=0?(In[c[(c[h>>2]|0)+52>>2]&4095](e,h),(b[e>>1]&8)==0):0){e=c[g>>2]|0;j=mo[c[(c[e>>2]|0)+28>>2]&4095](e)|0}else j=0;e=a+12|0;a=c[e>>2]|0;if((a|0)!=0?(In[c[(c[a>>2]|0)+52>>2]&4095](f,a),(b[f>>1]&8)==0):0){f=c[e>>2]|0;k=mo[c[(c[f>>2]|0)+28>>2]&4095](f)|0}else k=0;if((c[g>>2]|0)!=0&(j|0)==0){l=0;i=d;return l|0}if((c[e>>2]|0)!=0&(k|0)==0){l=0;i=d;return l|0}l=(j|0)!=0?j:k;i=d;return l|0}function rX(a){a=a|0;var b=0,d=0,e=0;b=i;if((((c[a+20>>2]|0)>>>30)+-1|0)>>>0<2?(d=c[a+16>>2]|0,(d|0)!=0):0)e=P3(d)|0;else e=0;i=b;return e|0}function sX(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=i;i=i+16|0;m=l;n=l+4|0;b[d+4>>1]=9;b[d+6>>1]=1;c[d>>2]=431472;o=d+8|0;c[o>>2]=f;p=d+12|0;c[p>>2]=g;q=d+16|0;c[q>>2]=0;c[d+24>>2]=0;r=d+20|0;c[r>>2]=0;R9(d+28|0,h,j,k);k=d+100|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;b[k+24>>1]=0;c[r>>2]=c[r>>2]&-251658241|100663296;a[d+128>>0]=1;if(f)CU(f+(c[426976+((e[f+4>>1]|0)<<2)>>2]|0)|0,0,d,431400);if(g)CU(g+(c[426976+((e[g+4>>1]|0)<<2)>>2]|0)|0,0,d,431568);g=c[o>>2]|0;if((g|0)!=0?(In[c[(c[g>>2]|0)+52>>2]&4095](m,g),(b[m>>1]&8)==0):0){g=c[o>>2]|0;s=mo[c[(c[g>>2]|0)+28>>2]&4095](g)|0}else s=0;g=c[p>>2]|0;if((g|0)!=0?(In[c[(c[g>>2]|0)+52>>2]&4095](n,g),(b[n>>1]&8)==0):0){n=c[p>>2]|0;t=mo[c[(c[n>>2]|0)+28>>2]&4095](n)|0}else t=0;if((c[o>>2]|0)!=0&(s|0)==0){i=l;return}if((c[p>>2]|0)!=0&(t|0)==0){i=l;return}p=(s|0)!=0?s:t;if(!p){i=l;return}t=p+3524|0;c[m>>2]=d;s=p+3528|0;o=c[s>>2]|0;if((c[p+3532>>2]&2147483647)>>>0>o>>>0){n=(c[t>>2]|0)+(o<<2)|0;if(n)c[n>>2]=d;c[s>>2]=o+1}else cVa(t,m)|0;W3(p+16|0,q);i=l;return}function tX(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;c[a>>2]=431472;if(b[a+6>>1]&1){e=c[a+56>>2]|0;ko[c[(c[e>>2]|0)+8>>2]&4095](e)}lY(c[107930]|0,a);VJa(d,a);i=d;return}function uX(a){a=a|0;var d=0,e=0;d=i;c[a>>2]=431472;if(b[a+6>>1]&1){e=c[a+56>>2]|0;ko[c[(c[e>>2]|0)+8>>2]&4095](e)}lY(c[107930]|0,a);i=d;return}function vX(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((((c[a+20>>2]|0)>>>30)+-1|0)>>>0<2?(d=c[a+16>>2]|0,(d|0)!=0):0)f=P3(d)|0;else f=0;KZ(c[108764]|0,a,0,1);d=c[a+8>>2]|0;if(d)DU(d+(c[426976+((e[d+4>>1]|0)<<2)>>2]|0)|0,d,0,a,431400);d=c[a+12>>2]|0;if(d)DU(d+(c[426976+((e[d+4>>1]|0)<<2)>>2]|0)|0,d,0,a,431568);if(!f){g=a+16|0;v3(g);i=b;return}d=f+3528|0;h=c[d>>2]|0;if(h){j=c[f+3524>>2]|0;k=0;while(1){l=k+1|0;if((c[j+(k<<2)>>2]|0)==(a|0)){m=k;break}if(l>>>0<h>>>0)k=l;else{m=l;break}}if((m|0)!=(h|0)){k=h+-1|0;c[d>>2]=k;c[j+(m<<2)>>2]=c[j+(k<<2)>>2]}}X3(f+16|0,a+16|0);g=a+16|0;v3(g);i=b;return}function wX(a){a=a|0;return a+-28|0}function xX(a){a=a|0;var b=0,d=0,e=0;b=i;if((((c[a+20>>2]|0)>>>30)+-1|0)>>>0<2?(d=c[a+16>>2]|0,(d|0)!=0):0)e=P3(d)|0;else e=0;i=b;return e|0}function yX(a,b,d){a=a|0;b=b|0;d=d|0;c[b>>2]=c[a+8>>2];c[d>>2]=c[a+12>>2];return}function zX(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+16|0;j=h;k=h+4|0;l=d+8|0;m=c[l>>2]|0;if(m)DU(m+(c[426976+(e[m+4>>1]<<2)>>2]|0)|0,m,0,d,431400);m=d+12|0;n=c[m>>2]|0;if(n)DU(n+(c[426976+(e[n+4>>1]<<2)>>2]|0)|0,n,0,d,431568);n=(f|0)==0;if(!n)CU(f+(c[426976+(e[f+4>>1]<<2)>>2]|0)|0,0,d,431400);o=(g|0)==0;if(!o)CU(g+(c[426976+(e[g+4>>1]<<2)>>2]|0)|0,0,d,431568);c[l>>2]=f;c[m>>2]=g;p=d+16|0;do if(!n){q=b[f+4>>1]|0;if(q<<16>>16==5){r=f+48|0;break}else if(q<<16>>16==15){r=f+48|0;break}else{r=f+48|0;break}}else r=0;while(0);do if(!o){f=b[g+4>>1]|0;if(f<<16>>16==15){s=g+48|0;break}else if(f<<16>>16==5){s=g+48|0;break}else{s=g+48|0;break}}else s=0;while(0);if(!r)t=0;else t=(c[450992+(((c[r+4>>2]|0)>>>24&15)<<2)>>2]|0)+r|0;if(!s)u=0;else u=(c[450992+(((c[s+4>>2]|0)>>>24&15)<<2)>>2]|0)+s|0;s=d+20|0;r=c[s>>2]|0;g=r>>>30;if((g|0)==3){v=p;w=27}else if((g|0)==2?(a[(c[p>>2]|0)+2417>>0]|0)!=0:0){v=p;w=27}else w=26;if((w|0)==26)V9(d+28|0,t,u);else if((w|0)==27){w=d+24|0;g=c[w>>2]|0;if(!g){o=s4(c[v>>2]|0,r>>>24&15)|0;c[w>>2]=o;x=o}else x=g;c[x>>2]=t;c[x+4>>2]=u;r4(c[v>>2]|0,p);c[s>>2]=c[s>>2]|1}v=d+100|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;v=c[l>>2]|0;if((v|0)!=0?(In[c[(c[v>>2]|0)+52>>2]&4095](j,v),(b[j>>1]&8)==0):0){v=c[l>>2]|0;y=mo[c[(c[v>>2]|0)+28>>2]&4095](v)|0}else y=0;v=c[m>>2]|0;if((v|0)!=0?(In[c[(c[v>>2]|0)+52>>2]&4095](k,v),(b[k>>1]&8)==0):0){k=c[m>>2]|0;z=mo[c[(c[k>>2]|0)+28>>2]&4095](k)|0}else z=0;if(!((c[l>>2]|0)!=0&(y|0)==0)?!((c[m>>2]|0)!=0&(z|0)==0):0)A=(y|0)!=0?y:z;else A=0;if((((c[s>>2]|0)>>>30)+-1|0)>>>0<2?(s=c[d+16>>2]|0,(s|0)!=0):0)B=P3(s)|0;else B=0;if((B|0)==(A|0)){i=h;return}if(B){s=B+3528|0;z=c[s>>2]|0;if(z){y=c[B+3524>>2]|0;m=0;while(1){l=m+1|0;if((c[y+(m<<2)>>2]|0)==(d|0)){C=m;break}if(l>>>0<z>>>0)m=l;else{C=l;break}}if((C|0)!=(z|0)){m=z+-1|0;c[s>>2]=m;c[y+(C<<2)>>2]=c[y+(m<<2)>>2]}}X3(B+16|0,p)}if(!A){i=h;return}B=A+3524|0;c[j>>2]=d;m=A+3528|0;y=c[m>>2]|0;if((c[A+3532>>2]&2147483647)>>>0>y>>>0){C=(c[B>>2]|0)+(y<<2)|0;if(C)c[C>>2]=d;c[m>>2]=y+1}else cVa(B,j)|0;W3(A+16|0,p);i=h;return}function AX(b){b=b|0;a[b+128>>0]=1;return}function BX(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=d+16|0;j=b[e>>1]|0;e=d+20|0;k=c[e>>2]|0;l=k>>>30;if((l|0)==3)m=h;else if((l|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)m=h;else n=4;if((n|0)==4){b[g>>1]=j;T9(d+28|0,g);i=f;return}g=d+24|0;d=c[g>>2]|0;if(!d){n=s4(c[m>>2]|0,k>>>24&15)|0;c[g>>2]=n;o=n}else o=d;b[o+16>>1]=j;r4(c[m>>2]|0,h);c[e>>2]=c[e>>2]|4;i=f;return}function CX(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[d+20>>2]|0;if(!(f&4)){b[a>>1]=(b[d+124>>1]|-2)&b[d+28>>1];i=e;return}g=d+24|0;h=c[g>>2]|0;if(!h){j=s4(c[d+16>>2]|0,f>>>24&15)|0;c[g>>2]=j;k=j}else k=h;b[a>>1]=(b[d+124>>1]|-2)&b[k+16>>1];i=e;return}function DX(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+16|0;h=g;j=d+16|0;k=d+20|0;l=c[k>>2]|0;if(!(l&4))m=(b[d+124>>1]|-2)&b[d+28>>1];else{n=d+24|0;o=c[n>>2]|0;if(!o){p=s4(c[j>>2]|0,l>>>24&15)|0;c[n>>2]=p;q=p}else q=o;m=(b[d+124>>1]|-2)&b[q+16>>1]}if(f)r=(m&65535|e)&65535;else r=m&((e^65535)&65535);e=c[k>>2]|0;m=e>>>30;if((m|0)==2)if(!(a[(c[j>>2]|0)+2417>>0]|0))s=12;else t=j;else if((m|0)==3)t=j;else s=12;if((s|0)==12){b[h>>1]=r;T9(d+28|0,h);i=g;return}h=d+24|0;d=c[h>>2]|0;if(!d){s=s4(c[t>>2]|0,e>>>24&15)|0;c[h>>2]=s;u=s}else u=d;b[u+16>>1]=r;r4(c[t>>2]|0,j);c[k>>2]=c[k>>2]|4;i=g;return}function EX(a,b,c){a=a|0;b=b|0;c=c|0;g[b>>2]=ea(g[a+100>>2]);g[b+4>>2]=ea(g[a+104>>2]);g[b+8>>2]=ea(g[a+108>>2]);g[c>>2]=ea(g[a+112>>2]);g[c+4>>2]=ea(g[a+116>>2]);g[c+8>>2]=ea(g[a+120>>2]);return}function FX(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+128|0;if(!(a[e>>0]|0)){i=d;return}f=c[b+56>>2]|0;if(!(W9(b+28|0,mo[c[c[f>>2]>>2]&4095](f)|0)|0)){i=d;return}a[e>>0]=0;i=d;return}function GX(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;h=b+16|0;j=b+20|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))m=4;else n=h;else if((l|0)==3)n=h;else m=4;if((m|0)==4){X9(b+28|0,d,e);i=f;return}m=b+24|0;b=c[m>>2]|0;if(!b){l=s4(c[n>>2]|0,k>>>24&15)|0;c[m>>2]=l;o=l}else o=b;g[o+8>>2]=d;g[o+12>>2]=e;r4(c[n>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function HX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;f=c[a+20>>2]|0;if(!(f&2)){Y9(a+28|0,b,d);i=e;return}h=a+24|0;j=c[h>>2]|0;if(!j){k=s4(c[a+16>>2]|0,f>>>24&15)|0;c[h>>2]=k;l=k}else l=j;g[b>>2]=ea(g[l+8>>2]);g[d>>2]=ea(g[l+12>>2]);i=e;return}function IX(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+16|0;h=b+20|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){Z9(b+28|0,d);i=e;return}m=b+24|0;b=c[m>>2]|0;if(!b){k=s4(c[l>>2]|0,j>>>24&15)|0;c[m>>2]=k;n=k}else n=b;g[n+20>>2]=d;r4(c[l>>2]|0,f);c[h>>2]=c[h>>2]|8;i=e;return}function JX(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+20>>2]|0;if(!(d&8)){e=a+92|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+24|0;j=c[h>>2]|0;if(!j){k=s4(c[a+16>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+20|0;f=ea(g[e>>2]);i=b;return ea(f)}function KX(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+8>>2]|0;if(!e)f=0;else f=(b[e+4>>1]|0)!=6;e=c[a+12>>2]|0;if(!e){g=0;h=f|g;i=d;return h|0}g=(b[e+4>>1]|0)!=6;h=f|g;i=d;return h|0}function LX(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+56>>2]|0;a=_n[c[(c[e>>2]|0)+20>>2]&4095](e,b)|0;i=d;return a|0}function MX(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+56>>2]|0;if((c[a+8>>2]|0)==(b|0))In[c[(c[e>>2]|0)+12>>2]&4095](e,0);if((c[a+12>>2]|0)!=(b|0)){i=d;return}In[c[(c[e>>2]|0)+12>>2]&4095](e,1);i=d;return}function NX(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+8|0;if((c[e>>2]|0)==(b|0)){c[e>>2]=0;i=d;return}else{c[a+12>>2]=0;i=d;return}}function OX(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+4|0;h=f;j=a+-16|0;co[c[(c[j>>2]|0)+28>>2]&2047](j,g,h);j=c[g>>2]|0;do if(j){g=b[j+4>>1]|0;if(g<<16>>16==15){k=j+48|0;break}else if(g<<16>>16==5){k=j+48|0;break}else{k=j+48|0;break}}else k=0;while(0);c[d>>2]=k;k=c[h>>2]|0;do if(k){h=b[k+4>>1]|0;if(h<<16>>16==15){l=k+48|0;break}else if(h<<16>>16==5){l=k+48|0;break}else{l=k+48|0;break}}else l=0;while(0);c[e>>2]=l;i=f;return}function PX(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;c[b>>2]=537552;e=b+4|0;f=c[(qTa()|0)>>2]|0;if(f){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,f,l?544576:544544,544464,111)|0;c[e>>2]=k;if(k)mTa(k)}else c[e>>2]=0;e=b+8|0;k=e+48|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(k|0));c[b>>2]=431640;c[b+324>>2]=0;a[b+316>>0]=1;c[b+320>>2]=b+60;c[b+328>>2]=64;c[b+332>>2]=32;c[b+336>>2]=0;c[b+340>>2]=0;c[b+344>>2]=1536;c[b+348>>2]=0;e=b+352|0;k=c[(qTa()|0)>>2]|0;if(k){l=mKa()|0;f=c[(c[l>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[f&255](l,k,j?544576:544544,544464,111)|0;c[e>>2]=h;if(h)mTa(h)}else c[e>>2]=0;e=b+356|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+380>>2]=ea(.75);c[b+384>>2]=-1;c[b+388>>2]=0;c[b+392>>2]=0;nVa(e,64);e=b+396|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+420>>2]=ea(.75);c[b+424>>2]=-1;c[b+428>>2]=0;c[b+432>>2]=0;oVa(e,64);e=b+436|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+460>>2]=ea(.75);c[b+464>>2]=-1;c[b+468>>2]=0;c[b+472>>2]=0;pVa(e,64);e=b+476|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+500>>2]=ea(.75);c[b+504>>2]=-1;c[b+508>>2]=0;c[b+512>>2]=0;qVa(e,64);e=b+516|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+540>>2]=ea(.75);c[b+544>>2]=-1;c[b+548>>2]=0;c[b+552>>2]=0;rVa(e,64);e=b+556|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+580>>2]=ea(.75);c[b+584>>2]=-1;c[b+588>>2]=0;c[b+592>>2]=0;sVa(e,64);c[b+596>>2]=0;c[b+600>>2]=0;c[b+604>>2]=0;i=d;return}function QX(a){a=a|0;var b=0;b=i;i=i+16|0;RX(a);VJa(b,a);i=b;return}function RX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=431640;d=c[a+604>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+596>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+556|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+516|0;d=c[e>>2]|0;if(d)VJa(e,d);d=a+476|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+436|0;d=c[e>>2]|0;if(d)VJa(e,d);d=a+396|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+356|0;d=c[e>>2]|0;if(d)VJa(e,d);d=a+352|0;nTa(c[d>>2]|0);e=c[d>>2]|0;if(!e){f=a+56|0;tVa(f);WLa(a);i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e);f=a+56|0;tVa(f);WLa(a);i=b;return}function SX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=0;f=d+4|0;c[f>>2]=0;g=d+8|0;c[g>>2]=0;h=c[a+392>>2]|0;if(h)uVa(d,h);h=a+368|0;a:do if(c[a+372>>2]|0){j=c[h>>2]|0;k=c[j>>2]|0;if((k|0)==-1){l=c[a+376>>2]|0;m=0;while(1){n=m+1|0;if((n|0)==(l|0)){o=-1;p=l;break a}q=c[j+(n<<2)>>2]|0;if((q|0)==-1)m=n;else{o=q;p=n;break}}}else{o=k;p=0}}else{o=-1;p=0}while(0);m=a+360|0;j=a+364|0;l=a+376|0;n=o;o=p;b:while(1){p=n;do{if((p|0)==-1)break b;q=c[(c[m>>2]|0)+(p<<2)>>2]|0;c[e>>2]=q;r=c[f>>2]|0;if((c[g>>2]&2147483647)>>>0>r>>>0){s=(c[d>>2]|0)+(r<<2)|0;if(s)c[s>>2]=q;c[f>>2]=r+1}else vVa(d,e)|0;p=c[(c[j>>2]|0)+(p<<2)>>2]|0}while((p|0)!=-1);p=c[l>>2]|0;k=o;while(1){r=k+1|0;if((r|0)==(p|0)){n=-1;o=p;continue b}q=c[(c[h>>2]|0)+(r<<2)>>2]|0;if((q|0)==-1)k=r;else{n=q;o=r;continue b}}}o=c[f>>2]|0;if(o){f=c[d>>2]|0;n=0;do{h=c[f+(n<<2)>>2]|0;ko[c[c[h>>2]>>2]&4095](h);n=n+1|0}while((n|0)!=(o|0))}o=c[g>>2]|0;if((o&2147483647|0)!=0&(o|0)>-1?(o=c[d>>2]|0,(o|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,o)}c[d>>2]=0;o=d+4|0;c[o>>2]=0;g=d+8|0;c[g>>2]=0;n=c[a+472>>2]|0;if(n)wVa(d,n);n=a+448|0;c:do if(c[a+452>>2]|0){f=c[n>>2]|0;h=c[f>>2]|0;if((h|0)==-1){l=c[a+456>>2]|0;j=0;while(1){m=j+1|0;if((m|0)==(l|0)){t=-1;u=l;break c}k=c[f+(m<<2)>>2]|0;if((k|0)==-1)j=m;else{t=k;u=m;break}}}else{t=h;u=0}}else{t=-1;u=0}while(0);j=a+440|0;f=a+444|0;l=a+456|0;m=t;t=u;d:while(1){u=m;do{if((u|0)==-1)break d;k=c[(c[j>>2]|0)+(u<<2)>>2]|0;c[e>>2]=k;p=c[o>>2]|0;if((c[g>>2]&2147483647)>>>0>p>>>0){r=(c[d>>2]|0)+(p<<2)|0;if(r)c[r>>2]=k;c[o>>2]=p+1}else cVa(d,e)|0;u=c[(c[f>>2]|0)+(u<<2)>>2]|0}while((u|0)!=-1);u=c[l>>2]|0;h=t;while(1){p=h+1|0;if((p|0)==(u|0)){m=-1;t=u;continue d}k=c[(c[n>>2]|0)+(p<<2)>>2]|0;if((k|0)==-1)h=p;else{m=k;t=p;continue d}}}t=c[o>>2]|0;if(t){o=c[d>>2]|0;m=0;do{n=c[o+(m<<2)>>2]|0;ko[c[c[n>>2]>>2]&4095](n);m=m+1|0}while((m|0)!=(t|0))}t=c[g>>2]|0;if((t&2147483647|0)!=0&(t|0)>-1?(t=c[d>>2]|0,(t|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,t)}c[d>>2]=0;t=d+4|0;c[t>>2]=0;g=d+8|0;c[g>>2]=0;m=c[a+432>>2]|0;if(m)xVa(d,m);m=a+408|0;e:do if(c[a+412>>2]|0){o=c[m>>2]|0;n=c[o>>2]|0;if((n|0)==-1){l=c[a+416>>2]|0;f=0;while(1){j=f+1|0;if((j|0)==(l|0)){v=-1;w=l;break e}h=c[o+(j<<2)>>2]|0;if((h|0)==-1)f=j;else{v=h;w=j;break}}}else{v=n;w=0}}else{v=-1;w=0}while(0);f=a+400|0;o=a+404|0;l=a+416|0;j=v;v=w;f:while(1){w=j;do{if((w|0)==-1)break f;h=c[(c[f>>2]|0)+(w<<2)>>2]|0;c[e>>2]=h;u=c[t>>2]|0;if((c[g>>2]&2147483647)>>>0>u>>>0){p=(c[d>>2]|0)+(u<<2)|0;if(p)c[p>>2]=h;c[t>>2]=u+1}else yVa(d,e)|0;w=c[(c[o>>2]|0)+(w<<2)>>2]|0}while((w|0)!=-1);w=c[l>>2]|0;n=v;while(1){u=n+1|0;if((u|0)==(w|0)){j=-1;v=w;continue f}h=c[(c[m>>2]|0)+(u<<2)>>2]|0;if((h|0)==-1)n=u;else{j=h;v=u;continue f}}}v=c[t>>2]|0;if(v){t=c[d>>2]|0;j=0;do{m=c[t+(j<<2)>>2]|0;ko[c[c[m>>2]>>2]&4095](m);j=j+1|0}while((j|0)!=(v|0))}v=c[g>>2]|0;if((v&2147483647|0)!=0&(v|0)>-1?(v=c[d>>2]|0,(v|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,v)}c[d>>2]=0;v=d+4|0;c[v>>2]=0;g=d+8|0;c[g>>2]=0;j=c[a+512>>2]|0;if(j)zVa(d,j);j=a+488|0;g:do if(c[a+492>>2]|0){t=c[j>>2]|0;m=c[t>>2]|0;if((m|0)==-1){l=c[a+496>>2]|0;o=0;while(1){f=o+1|0;if((f|0)==(l|0)){x=-1;y=l;break g}n=c[t+(f<<2)>>2]|0;if((n|0)==-1)o=f;else{x=n;y=f;break}}}else{x=m;y=0}}else{x=-1;y=0}while(0);o=a+480|0;t=a+484|0;l=a+496|0;f=x;x=y;h:while(1){y=f;do{if((y|0)==-1)break h;n=c[(c[o>>2]|0)+(y<<2)>>2]|0;c[e>>2]=n;w=c[v>>2]|0;if((c[g>>2]&2147483647)>>>0>w>>>0){u=(c[d>>2]|0)+(w<<2)|0;if(u)c[u>>2]=n;c[v>>2]=w+1}else AVa(d,e)|0;y=c[(c[t>>2]|0)+(y<<2)>>2]|0}while((y|0)!=-1);y=c[l>>2]|0;m=x;while(1){w=m+1|0;if((w|0)==(y|0)){f=-1;x=y;continue h}n=c[(c[j>>2]|0)+(w<<2)>>2]|0;if((n|0)==-1)m=w;else{f=n;x=w;continue h}}}x=c[v>>2]|0;if(x){v=c[d>>2]|0;f=0;do{j=c[v+(f<<2)>>2]|0;ko[c[c[j>>2]>>2]&4095](j);f=f+1|0}while((f|0)!=(x|0))}x=c[g>>2]|0;if((x&2147483647|0)!=0&(x|0)>-1?(x=c[d>>2]|0,(x|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,x)}x=a+592|0;if(c[x>>2]|0){d=a+560|0;do G1(c[c[d>>2]>>2]|0);while((c[x>>2]|0)!=0)}x=a+600|0;if(!(c[x>>2]|0)){XLa(a);i=b;return}d=a+596|0;do{g=c[c[d>>2]>>2]|0;ko[c[c[g>>2]>>2]&4095](g)}while((c[x>>2]|0)!=0);XLa(a);i=b;return}function TX(){var a=0,b=0,d=0,e=0,f=0;a=i;b=mKa()|0;d=c[(c[b>>2]|0)+8>>2]|0;e=pKa()|0;f=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;e=Bn[d&255](b,608,f?433160:544544,431648,138)|0;PX(e);c[107930]=e;i=a;return}function UX(){var a=0;a=i;SX(c[107930]|0);c[107930]=0;i=a;return}function VX(){c[107932]=2589;c[107934]=2590;return}function WX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=f+4|0;if(!(c[107934]|0)){dKa(bKa()|0,32,431648,238,431744,g);j=0;i=f;return j|0}k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[l&255](k,200,n?434424:544544,431648,210)|0;a3(m,d,e);if(!m){dKa(bKa()|0,32,431648,246,431848,g);j=0;i=f;return j|0}c[h>>2]=m;e=b+4|0;oTa(c[e>>2]|0);d=BVa(b+476|0,h,g)|0;if(!((a[g>>0]|0)!=0|(d|0)==0))c[d>>2]=c[h>>2];pTa(c[e>>2]|0);j=m;i=f;return j|0}function XX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=f+4|0;if(!(c[107932]|0)){dKa(bKa()|0,32,431648,259,431904,g);j=0;i=f;return j|0}k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[l&255](k,200,n?434544:544544,431648,205)|0;o3(m,d,e);if(!m){dKa(bKa()|0,32,431648,267,432008,g);j=0;i=f;return j|0}c[h>>2]=m;e=b+4|0;oTa(c[e>>2]|0);d=BVa(b+476|0,h,g)|0;if(!((a[g>>0]|0)!=0|(d|0)==0))c[d>>2]=c[h>>2];pTa(c[e>>2]|0);j=m;i=f;return j|0}function YX(){var a=0;a=i;c[108016]=247;c[108018]=3508;c[108020]=3509;Sba(c[116650]|0);i=a;return}function ZX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;c[f>>2]=b;if(d){d=a+4|0;oTa(c[d>>2]|0);g=a+596|0;h=a+600|0;j=c[h>>2]|0;k=a+604|0;if(!j)if((c[k>>2]&2147483584)>>>0<64){IVa(g,64);l=c[h>>2]|0}else l=0;else l=j;if((c[k>>2]&2147483647)>>>0>l>>>0){k=(c[g>>2]|0)+(l<<2)|0;if(k)c[k>>2]=b;c[h>>2]=l+1}else JVa(g,f)|0;pTa(c[d>>2]|0);i=e;return}else{d=a+596|0;g=a+600|0;l=c[g>>2]|0;h=a+604|0;if(!l)if((c[h>>2]&2147483584)>>>0<64){IVa(d,64);m=c[g>>2]|0}else m=0;else m=l;if((c[h>>2]&2147483647)>>>0<=m>>>0){JVa(d,f)|0;i=e;return}f=(c[d>>2]|0)+(m<<2)|0;if(f)c[f>>2]=b;c[g>>2]=m+1;i=e;return}}function _X(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;if(!(c[108018]|0)){dKa(bKa()|0,8,431648,353,432088,d);e=0;i=d;return e|0}f=GVa(b)|0;if(f)ZX(a,f,1);e=f;i=d;return e|0}function $X(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;if(!(c[108020]|0)){dKa(bKa()|0,8,431648,370,432088,d);e=0;i=d;return e|0}f=HVa(b)|0;if(f)ZX(a,f,1);e=f;i=d;return e|0}function aY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=a+600|0;g=c[f>>2]|0;a:do if(!g)h=0;else{j=c[a+596>>2]|0;k=0;while(1){l=j+(k<<2)|0;k=k+1|0;if((c[l>>2]|0)==(b|0))break;if(k>>>0>=g>>>0){h=0;break a}}k=g+-1|0;c[f>>2]=k;c[l>>2]=c[j+(k<<2)>>2];h=1}while(0);pTa(c[e>>2]|0);i=d;return h|0}function bY(a){a=a|0;return c[a+600>>2]|0}function cY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[a+600>>2]|0;g=f>>>0<d>>>0?f:d;if(!g){i=e;return g|0}h=a+596|0;a=~f;f=~d;d=~(a>>>0>f>>>0?a:f);f=0;do{c[b+(f<<2)>>2]=c[(c[h>>2]|0)+(f<<2)>>2];f=f+1|0}while((f|0)!=(d|0));i=e;return g|0}function dY(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+16|0;k=j;l=j+4|0;if(!(c[108016]|0)){dKa(bKa()|0,8,431648,432,432088,k);m=0;i=j;return m|0}n=b[h>>1]|0;h=mKa()|0;o=c[(c[h>>2]|0)+8>>2]|0;p=pKa()|0;q=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[o&255](h,152,q?434320:544544,431648,285)|0;b[k>>1]=n;B4(p,e,f,g,k);if(!p){dKa(bKa()|0,32,431648,446,432128,k);m=0;i=j;return m|0}c[l>>2]=p;g=d+4|0;oTa(c[g>>2]|0);f=BVa(d+476|0,l,k)|0;if(!((a[k>>0]|0)!=0|(f|0)==0))c[f>>2]=c[l>>2];pTa(c[g>>2]|0);m=p;i=j;return m|0}function eY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=c[a+496>>2]|0;a:do if((f|0)!=0?(g=b,h=g+~(g<<15)|0,g=(h>>>10^h)*9|0,h=g>>>6^g,g=h+~(h<<11)|0,h=(c[a+488>>2]|0)+((f+-1&(g>>>16^g))<<2)|0,g=c[h>>2]|0,(g|0)!=-1):0){j=c[a+480>>2]|0;k=a+484|0;l=g;g=h;while(1){if((c[j+(l<<2)>>2]|0)==(b|0))break;h=(c[k>>2]|0)+(l<<2)|0;m=c[h>>2]|0;if((m|0)==-1)break a;else{l=m;g=h}}if((l|0)!=-1){j=(c[k>>2]|0)+(l<<2)|0;c[g>>2]=c[j>>2];h=a+512|0;c[h>>2]=(c[h>>2]|0)+-1;h=a+508|0;c[h>>2]=(c[h>>2]|0)+1;h=a+504|0;c[j>>2]=c[h>>2];c[h>>2]=l}}while(0);pTa(c[e>>2]|0);i=d;return}function fY(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=a+4|0;oTa(c[b>>2]|0);KVa(a+556|0,e)|0;pTa(c[b>>2]|0);i=d;return}function gY(){c[108044]=60;c[108046]=1727;return}function hY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=d+4|0;if(!(c[108044]|0)){dKa(bKa()|0,8,431648,531,432192,e);g=0;i=d;return g|0}h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,108,l?434080:544544,431648,475)|0;fV(k);if(!k){dKa(bKa()|0,32,431648,477,434024,e);g=0;i=d;return g|0}c[f>>2]=k;l=b+4|0;oTa(c[l>>2]|0);h=LVa(b+396|0,f,e)|0;if(!((a[e>>0]|0)!=0|(h|0)==0))c[h>>2]=c[f>>2];pTa(c[l>>2]|0);g=k;i=d;return g|0}function iY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=c[a+416>>2]|0;a:do if((f|0)!=0?(g=b,h=g+~(g<<15)|0,g=(h>>>10^h)*9|0,h=g>>>6^g,g=h+~(h<<11)|0,h=(c[a+408>>2]|0)+((f+-1&(g>>>16^g))<<2)|0,g=c[h>>2]|0,(g|0)!=-1):0){j=c[a+400>>2]|0;k=a+404|0;l=g;g=h;while(1){if((c[j+(l<<2)>>2]|0)==(b|0))break;h=(c[k>>2]|0)+(l<<2)|0;m=c[h>>2]|0;if((m|0)==-1)break a;else{l=m;g=h}}if((l|0)!=-1){j=(c[k>>2]|0)+(l<<2)|0;c[g>>2]=c[j>>2];h=a+432|0;c[h>>2]=(c[h>>2]|0)+-1;h=a+428|0;c[h>>2]=(c[h>>2]|0)+1;h=a+424|0;c[j>>2]=c[h>>2];c[h>>2]=l}}while(0);pTa(c[e>>2]|0);i=d;return}function jY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;i=i+16|0;if(!(c[108046]|0)){dKa(bKa()|0,8,431648,554,432192,a);f=0;i=a;return f|0}else{f=NVa(b,d,e)|0;i=a;return f|0}return 0}function kY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+16|0;k=j+4|0;l=j;m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;o=Bn[n&255](m,132,p?432928:544544,431648,580)|0;sX(o,d,e,f,g,h);c[l>>2]=o;if(!o){i=j;return o|0}h=b+4|0;oTa(c[h>>2]|0);g=OVa(b+436|0,l,k)|0;if(!((a[k>>0]|0)!=0|(g|0)==0))c[g>>2]=c[l>>2];pTa(c[h>>2]|0);i=j;return o|0}function lY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=c[a+456>>2]|0;a:do if((f|0)!=0?(g=b,h=g+~(g<<15)|0,g=(h>>>10^h)*9|0,h=g>>>6^g,g=h+~(h<<11)|0,h=(c[a+448>>2]|0)+((f+-1&(g>>>16^g))<<2)|0,g=c[h>>2]|0,(g|0)!=-1):0){j=c[a+440>>2]|0;k=a+444|0;l=g;g=h;while(1){if((c[j+(l<<2)>>2]|0)==(b|0))break;h=(c[k>>2]|0)+(l<<2)|0;m=c[h>>2]|0;if((m|0)==-1)break a;else{l=m;g=h}}if((l|0)!=-1){j=(c[k>>2]|0)+(l<<2)|0;c[g>>2]=c[j>>2];h=a+472|0;c[h>>2]=(c[h>>2]|0)+-1;h=a+468|0;c[h>>2]=(c[h>>2]|0)+1;h=a+464|0;c[j>>2]=c[h>>2];c[h>>2]=l}}while(0);pTa(c[e>>2]|0);i=d;return}function mY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+4|0;h=f;j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,44,m?432816:544544,431648,603)|0;NU(l,d,e);c[h>>2]=l;if(!l){i=f;return l|0}e=b+4|0;oTa(c[e>>2]|0);d=PVa(b+356|0,h,g)|0;if(!((a[g>>0]|0)!=0|(d|0)==0))c[d>>2]=c[h>>2];pTa(c[e>>2]|0);i=f;return l|0}function nY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=c[a+376>>2]|0;a:do if((f|0)!=0?(g=b,h=g+~(g<<15)|0,g=(h>>>10^h)*9|0,h=g>>>6^g,g=h+~(h<<11)|0,h=(c[a+368>>2]|0)+((f+-1&(g>>>16^g))<<2)|0,g=c[h>>2]|0,(g|0)!=-1):0){j=c[a+360>>2]|0;k=a+364|0;l=g;g=h;while(1){if((c[j+(l<<2)>>2]|0)==(b|0))break;h=(c[k>>2]|0)+(l<<2)|0;m=c[h>>2]|0;if((m|0)==-1)break a;else{l=m;g=h}}if((l|0)!=-1){j=(c[k>>2]|0)+(l<<2)|0;c[g>>2]=c[j>>2];h=a+392|0;c[h>>2]=(c[h>>2]|0)+-1;h=a+388|0;c[h>>2]=(c[h>>2]|0)+1;h=a+384|0;c[j>>2]=c[h>>2];c[h>>2]=l}}while(0);pTa(c[e>>2]|0);i=d;return}function oY(d,e,f,h){d=d|0;e=ea(e);f=ea(f);h=ea(h);var j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;j=d+32|0;k=d;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;b[j+12>>1]=0;a[j+14>>0]=0;g[j+4>>2]=e;g[j>>2]=f;g[j+8>>2]=h;l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,64,o?432704:544544,431648,629)|0;bba(k,j);xY(n,k);i=d;return n|0}function pY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+352|0;oTa(c[e>>2]|0);f=b+348|0;g=c[f>>2]|0;if(!g){QVa(b+56|0);h=c[f>>2]|0}else h=g;c[f>>2]=c[h>>2];f=b+336|0;c[f>>2]=(c[f>>2]|0)+1;f=b+340|0;c[f>>2]=(c[f>>2]|0)+-1;if(!h){j=0;k=c[e>>2]|0;pTa(k);i=d;return j|0}c[h+40>>2]=0;a[h+32>>0]=1;c[h+36>>2]=h;c[h+44>>2]=4;j=h;k=c[e>>2]|0;pTa(k);i=d;return j|0}function qY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+352|0;oTa(c[f>>2]|0);g=b+56|0;if(!d){h=c[f>>2]|0;pTa(h);i=e;return}j=c[d+44>>2]|0;do if((j&2147483647|0)!=0&(j|0)>-1){k=c[d+36>>2]|0;if((d|0)==(k|0)){a[d+32>>0]=0;break}if(k){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,k)}}while(0);j=b+336|0;c[j>>2]=(c[j>>2]|0)+-1;j=b+348|0;c[d>>2]=c[j>>2];c[j>>2]=d;d=b+340|0;j=c[d>>2]|0;c[d>>2]=j+1;if((j|0)<((c[b+332>>2]|0)*50|0)){h=c[f>>2]|0;pTa(h);i=e;return}RVa(g);c[d>>2]=0;h=c[f>>2]|0;pTa(h);i=e;return}function rY(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=i;i=i+32|0;m=l+31|0;n=l+24|0;o=l;p=l+28|0;q=l+30|0;r=o+8|0;s=o+12|0;c[o+16>>2]=0;t=o+20|0;a[r>>0]=1;c[s>>2]=o;c[t>>2]=4;u=j&65535;b[p>>1]=0;SVa(o,u,p);if(j<<16>>16!=1){p=c[s>>2]|0;if(j<<16>>16){v=0;do{b[p+(v<<1)>>1]=c[(c[h+(v<<2)>>2]|0)+52>>2];v=v+1|0}while((v|0)!=(u|0))}}else b[c[s>>2]>>1]=c[(c[h>>2]|0)+52>>2];h=mKa()|0;v=c[(c[h>>2]|0)+8>>2]|0;p=pKa()|0;w=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[v&255](h,208,w?432480:544544,431648,703)|0;a[q>>0]=a[g>>0]|0;w1(p,f,q,c[s>>2]|0,j,k);if(!p)x=0;else{if(j<<16>>16){j=p+36|0;k=p+48|0;q=p+32|0;f=p+40|0;g=0;do{w=c[108764]|0;h=c[j>>2]|0;if(!(h&2)){v=e[($ea(k)|0)+(g<<1)>>1]|0;y=(c[w+52>>2]|0)+(v<<2)|0}else{v=c[q>>2]|0;z=c[f>>2]|0;if(!z){A=s4(v,h>>>24&15)|0;c[f>>2]=A;B=A}else B=z;z=B+56|0;if((b[B+60>>1]|0)==1)C=z;else C=(c[v+2488>>2]|0)+(c[z>>2]<<1)|0;y=(c[w+52>>2]|0)+(e[C+(g<<1)>>1]<<2)|0}fTa((c[y>>2]|0)+16|0)|0;g=g+1|0}while((g|0)!=(u|0))}c[n>>2]=p;u=d+4|0;oTa(c[u>>2]|0);g=CVa(d+556|0,n,m)|0;if(!((a[m>>0]|0)!=0|(g|0)==0))c[g>>2]=c[n>>2];pTa(c[u>>2]|0);x=p}p=c[t>>2]|0;if(!((p&2147483647|0)!=0&(p|0)>-1)){i=l;return x|0}p=c[s>>2]|0;if((o|0)==(p|0)){a[r>>0]=0;i=l;return x|0}if(!p){i=l;return x|0}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,p);i=l;return x|0}function sY(a){a=a|0;return c[a+592>>2]|0}function tY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[a+592>>2]|0;if(g>>>0<e>>>0){h=0;i=f;return h|0}j=g-e|0;g=j>>>0>d>>>0?j:d;d=c[a+560>>2]|0;if(!g){h=0;i=f;return h|0}else k=0;do{c[b+(k<<2)>>2]=c[d+(k+e<<2)>>2];k=k+1|0}while(k>>>0<g>>>0);h=g;i=f;return h|0}function uY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,112,l?432360:544544,431648,737)|0;I_(k,d);c[g>>2]=k;if(!k){i=e;return k|0}d=b+4|0;oTa(c[d>>2]|0);l=BVa(b+476|0,g,f)|0;if(!((a[f>>0]|0)!=0|(l|0)==0))c[l>>2]=c[g>>2];pTa(c[d>>2]|0);i=e;return k|0}function vY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,288,l?432240:544544,431648,746)|0;WZ(k,d);c[g>>2]=k;if(!k){i=e;return k|0}d=b+4|0;oTa(c[d>>2]|0);l=BVa(b+476|0,g,f)|0;if(!((a[f>>0]|0)!=0|(l|0)==0))c[l>>2]=c[g>>2];pTa(c[d>>2]|0);i=e;return k|0}function wY(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;do switch((c[a+4>>2]|0)>>>24&15|0){case 5:{e=a+-48|0;f=c[a+-40>>2]|0;g=c[e>>2]|0;if(!(b[e+6>>1]&1))ko[c[g+12>>2]&4095](e);else ko[c[g+16>>2]&4095](e);KZ(c[108764]|0,e,f,2);i=d;return}case 3:{f=a+-48|0;e=c[a+-40>>2]|0;g=c[f>>2]|0;if(!(b[f+6>>1]&1))ko[c[g+12>>2]&4095](f);else ko[c[g+16>>2]&4095](f);KZ(c[108764]|0,f,e,2);i=d;return}case 4:{e=a+-48|0;f=c[a+-40>>2]|0;g=c[e>>2]|0;if(!(b[e+6>>1]&1))ko[c[g+12>>2]&4095](e);else ko[c[g+16>>2]&4095](e);KZ(c[108764]|0,e,f,2);i=d;return}case 8:{f=a+-12|0;e=c[a+-4>>2]|0;g=c[f>>2]|0;if(!(b[f+6>>1]&1))ko[c[g+12>>2]&4095](f);else ko[c[g+16>>2]&4095](f);KZ(c[108764]|0,f,e,2);i=d;return}case 2:case 1:{e=a+-32|0;f=c[a+-24>>2]|0;g=c[e>>2]|0;if(!(b[a+-26>>1]&1))ko[c[g+12>>2]&4095](e);else ko[c[g+16>>2]&4095](e);KZ(c[108764]|0,e,f,2);i=d;return}case 9:{f=a+-8|0;e=c[f>>2]|0;if(!(b[f+6>>1]&1))ko[c[e+12>>2]&4095](f);else ko[c[e+16>>2]&4095](f);KZ(c[108764]|0,f,0,2);i=d;return}case 10:{f=a+-8|0;e=c[f>>2]|0;if(!(b[f+6>>1]&1))ko[c[e+12>>2]&4095](f);else ko[c[e+16>>2]&4095](f);KZ(c[108764]|0,f,0,2);i=d;return}case 11:{f=a+-20|0;e=c[a+-12>>2]|0;g=c[f>>2]|0;if(!(b[f+6>>1]&1))ko[c[g+12>>2]&4095](f);else ko[c[g+16>>2]&4095](f);KZ(c[108764]|0,f,e,2);i=d;return}case 7:{e=a+-20|0;f=c[a+-12>>2]|0;g=c[e>>2]|0;if(!(b[e+6>>1]&1))ko[c[g+12>>2]&4095](e);else ko[c[g+16>>2]&4095](e);KZ(c[108764]|0,e,f,2);i=d;return}case 6:{f=a+-16|0;e=c[f>>2]|0;if(!(b[f+6>>1]&1))ko[c[e+12>>2]&4095](f);else ko[c[e+16>>2]&4095](f);KZ(c[108764]|0,f,0,2);i=d;return}default:{i=d;return}}while(0)}function xY(e,f){e=e|0;f=f|0;var g=0,h=0,i=0;b[e+4>>1]=8;b[e+6>>1]=3;c[e>>2]=434976;c[e+8>>2]=0;g=e+12|0;c[g>>2]=434952;c[e+16>>2]=1;c[e>>2]=434672;c[g>>2]=434772;g=e+32|0;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];b[e+44>>1]=b[f+12>>1]|0;g=e+46|0;h=f+14|0;i=d[h>>0]|d[h+1>>0]<<8;a[g>>0]=i;a[g+1>>0]=i>>8;i=e+48|0;g=f+16|0;f=c[g+4>>2]|0;h=i;c[h>>2]=c[g>>2];c[h+4>>2]=f;c[i>>2]=e;return}function yY(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=434672;c[a+12>>2]=434772;VJa(b,a);i=b;return}function zY(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+-12|0;c[d>>2]=434672;c[d+12>>2]=434772;VJa(b,d);i=b;return}function AY(a){a=a|0;c[a>>2]=434672;c[a+12>>2]=434772;return}function BY(a){a=a|0;var b=0;b=a+-12|0;c[b>>2]=434672;c[b+12>>2]=434772;return}function CY(a,b){a=a|0;b=b|0;b=i;c[a+48>>2]=a;mZ(c[108764]|0,a)|0;i=b;return}function DY(a){a=a|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;qZ(c[108764]|0,a);f=c[a>>2]|0;if(!(b[a+6>>1]&1))ko[c[f+12>>2]&4095](a);else ko[c[f+16>>2]&4095](a);KZ(c[108764]|0,a,e,2);i=d;return}function EY(a){a=a|0;var d=0,e=0,f=0;d=i;e=a+-12|0;a=c[e+8>>2]|0;qZ(c[108764]|0,e);f=c[e>>2]|0;if(!(b[e+6>>1]&1))ko[c[f+12>>2]&4095](e);else ko[c[f+16>>2]&4095](e);KZ(c[108764]|0,e,a,2);i=d;return}function FY(a){a=a|0;var d=0,e=0;d=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);e=a+6|0;b[e>>1]=b[e>>1]&-3;e=a+12|0;if(gTa(a+16|0)|0){i=d;return}ko[c[(c[e>>2]|0)+8>>2]&4095](e);i=d;return}function GY(a){a=a|0;return c[a+16>>2]|0}function HY(a,b){a=a|0;b=ea(b);var d=0;d=i;g[a+32>>2]=b;rZ(c[108764]|0,a);i=d;return}function IY(a){a=a|0;var b=Im;b=ea(g[a+32>>2]);return ea(b)}function JY(a,b){a=a|0;b=ea(b);var d=0;d=i;g[a+36>>2]=b;rZ(c[108764]|0,a);i=d;return}function KY(a){a=a|0;var b=Im;b=ea(g[a+36>>2]);return ea(b)}function LY(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(b<ea(0.0)|b>ea(1.0)){f=bKa()|0;h[k>>3]=+b;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];dKa(f,4,434784,136,434856,e)}g[a+40>>2]=b;rZ(c[108764]|0,a);i=d;return}function MY(a){a=a|0;var b=Im;b=ea(g[a+40>>2]);return ea(b)}function NY(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0;g=i;h=a+44|0;if(f)b[h>>1]=e[h>>1]|0|d;else b[h>>1]=b[h>>1]&((d^65535)&65535);rZ(c[108764]|0,a);i=g;return}function OY(a,d){a=a|0;d=d|0;var e=0;e=i;b[a+44>>1]=b[d>>1]|0;rZ(c[108764]|0,a);i=e;return}function PY(a,c){a=a|0;c=c|0;b[a>>1]=b[c+44>>1]|0;return}function QY(b,e){b=b|0;e=e|0;var f=0,g=0;f=i;g=b+46|0;a[g>>0]=(d[g>>0]|0)&15|e<<4;rZ(c[108764]|0,b);i=f;return}function RY(a){a=a|0;return (d[a+46>>0]|0)>>>4|0}function SY(b,e){b=b|0;e=e|0;var f=0,g=0;f=i;g=b+46|0;a[g>>0]=(d[g>>0]|0)&240|e;rZ(c[108764]|0,b);i=f;return}function TY(a){a=a|0;return (d[a+46>>0]|0)&15|0}function UY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;c[b>>2]=435088;g=b+4|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;Qba(b+20|0,d);d=b+36|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=UJa(e,512,436152,100)|0;c[b+52>>2]=d;c[b+56>>2]=128;PEi(d|0,0,512)|0;c[b+60>>2]=436264;d=b+64|0;g=c[(qTa()|0)>>2]|0;if(g){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,g,l?544576:544544,544464,111)|0;c[d>>2]=k;if(k)mTa(k)}else c[d>>2]=0;c[b+68>>2]=0;c[b+72>>2]=0;c[b+76>>2]=0;c[b+80>>2]=436240;a[b+84>>0]=0;d=b+88|0;k=c[(qTa()|0)>>2]|0;if(k){l=mKa()|0;g=c[(c[l>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](l,k,j?544576:544544,544464,111)|0;c[d>>2]=h;if(h)mTa(h)}else c[d>>2]=0;d=tJa(mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0,435272,435072,16384)|0;c[b+92>>2]=d;if(!f){m=b+96|0;c[m>>2]=f;i=e;return}In[c[(c[f>>2]|0)+12>>2]&4095](f,d);m=b+96|0;c[m>>2]=f;i=e;return}function VY(a){a=a|0;var b=0;b=i;i=i+16|0;WY(a);VJa(b,a);i=b;return}function WY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b;c[a>>2]=435088;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;if(f){j=0;do{k=h+(j<<2)|0;l=c[k>>2]|0;if(l)ko[c[(c[l>>2]|0)+4>>2]&4095](l);c[k>>2]=0;j=j+1|0}while((j|0)!=(f|0))}c[e>>2]=0;TVa(a+36|0);e=a+92|0;f=c[e>>2]|0;if(f)ko[c[(c[f>>2]|0)+24>>2]&4095](f);c[e>>2]=0;c[a+96>>2]=0;e=a+68|0;f=a+72|0;j=c[f>>2]|0;if(j){h=j;j=0;while(1){k=c[(c[e>>2]|0)+(j<<2)>>2]|0;if(!k)m=h;else{l=c[k>>2]|0;if(l)VJa(k,l);VJa(d,k);m=c[f>>2]|0}j=j+1|0;if(j>>>0>=m>>>0)break;else h=m}}c[f>>2]=0;f=a+16|0;m=c[f>>2]|0;if(m){nTa(c[m>>2]|0);h=c[m>>2]|0;if(h){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,h)}VJa(d,c[f>>2]|0);c[f>>2]=0}f=a+88|0;nTa(c[f>>2]|0);d=c[f>>2]|0;if(d){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+76>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[e>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+64|0;nTa(c[d>>2]|0);e=c[d>>2]|0;if(e){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+48>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+40>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}Rba(a+20|0);e=c[a+12>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=b;return}e=c[g>>2]|0;if(!e){i=b;return}g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,e);i=b;return}function XY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+272|0;j=h;k=h+8|0;if((a|0)!=50528512){c[j>>2]=50528512;c[j+4>>2]=a;TUa(k,0,435288,j)|0;j=mo[c[(c[b>>2]|0)+4>>2]&4095](b)|0;En[c[(c[j>>2]|0)+8>>2]&127](j,4,k,435352,176);l=0;i=h;return l|0}if(ea(g[d>>2])>ea(0.0)?ea(g[d+4>>2])>ea(0.0):0){k=c[108766]|0;if(!k){gKa();j=mKa()|0;a=c[(c[j>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[a&255](j,100,n?436040:544544,435352,193)|0;UY(m,d,e,f);c[108764]=m;TX();mMa(c[107930]|0,(c[108764]|0)+80|0);o=c[108766]|0}else o=k;c[108766]=o+1;l=c[108764]|0;i=h;return l|0}o=mo[c[(c[b>>2]|0)+4>>2]&4095](b)|0;En[c[(c[o>>2]|0)+8>>2]&127](o,4,435424,435352,182);l=0;i=h;return l|0}function YY(a){a=a|0;var b=0;a=i;b=(c[108766]|0)+-1|0;c[108766]=b;if(b){i=a;return}UX();b=c[108764]|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);c[108764]=0;hKa();i=a;return}function ZY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;f=d+4|0;g=a+88|0;oTa(c[g>>2]|0);h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,3856,l?435936:544544,435352,234)|0;V_(k,b);c[f>>2]=k;if(!k){dKa(bKa()|0,32,435352,237,435440,e);m=0;n=c[g>>2]|0;pTa(n);i=d;return m|0}if(!(mo[c[(c[k>>2]|0)+444>>2]&4095](k)|0)){dKa(bKa()|0,32,435352,242,435464,e);m=0;n=c[g>>2]|0;pTa(n);i=d;return m|0}b$(k,b)|0;b=a+56|0;l=a+52|0;h=0;while(1){j=c[b>>2]|0;a:do if(h>>>0<j>>>0){o=c[l>>2]|0;p=h;while(1){if(c[o+(p<<2)>>2]|0){q=p;break a}r=p+1|0;if(r>>>0<j>>>0)p=r;else{q=r;break}}}else q=h;while(0);if(q>>>0>=j>>>0){s=12;break}if(G0(k,c[(c[l>>2]|0)+(q<<2)>>2]|0)|0)h=q+1|0;else break}if((s|0)==12?Aea(k+32|0)|0:0){s=a+4|0;q=a+8|0;h=c[q>>2]|0;if((c[a+12>>2]&2147483647)>>>0>h>>>0){a=(c[s>>2]|0)+(h<<2)|0;if(a)c[a>>2]=k;c[q>>2]=h+1;t=k}else{UVa(s,f)|0;t=c[f>>2]|0}m=t;n=c[g>>2]|0;pTa(n);i=d;return m|0}if(k)ko[c[(c[k>>2]|0)+4>>2]&4095](k);dKa(bKa()|0,16,435352,274,435440,e);m=0;n=c[g>>2]|0;pTa(n);i=d;return m|0}function _Y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+88|0;oTa(c[e>>2]|0);f=a+8|0;g=c[f>>2]|0;a:do if(g){h=c[a+4>>2]|0;j=0;while(1){k=h+(j<<2)|0;j=j+1|0;if((c[k>>2]|0)==(b|0))break;if(j>>>0>=g>>>0)break a}j=g+-1|0;c[f>>2]=j;c[k>>2]=c[h+(j<<2)>>2];if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b)}while(0);pTa(c[e>>2]|0);i=d;return}function $Y(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+88|0;oTa(c[d>>2]|0);e=c[a+8>>2]|0;pTa(c[d>>2]|0);i=b;return e|0}function aZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a+88|0;oTa(c[g>>2]|0);h=(c[a+8>>2]|0)-e|0;j=(h|0)<0?0:h;k=j>>>0<d>>>0?j:d;if(!k){l=c[g>>2]|0;pTa(l);i=f;return k|0}j=a+4|0;a=~d;d=(h|0)>0?~h:-1;h=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[j>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(h|0));l=c[g>>2]|0;pTa(l);i=f;return k|0}function bZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im;a=i;i=i+32|0;d=a;e=c[107930]|0;f=ea(g[b>>2]);h=ea(f*f);j=ea(g[b+4>>2]);k=ea(h+ea(j*j));h=ea(g[b+8>>2]);l=ea(k+ea(h*h));k=ea(g[b+12>>2]);m=ea(ea(1.0)/ea(T(ea(l+ea(k*k)))));l=ea(j*m);j=ea(h*m);h=ea(k*m);g[d>>2]=ea(f*m);g[d+4>>2]=l;g[d+8>>2]=j;g[d+12>>2]=h;g[d+16>>2]=ea(g[b+16>>2]);g[d+20>>2]=ea(g[b+20>>2]);g[d+24>>2]=ea(g[b+24>>2]);b=uY(e,d)|0;i=a;return b|0}function cZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=b;k=c[107930]|0;a[j>>0]=a[h>>0]|0;h=rY(k,d,j,e,f,g)|0;i=b;return h|0}function dZ(a){a=a|0;var b=0;a=i;b=sY(c[107930]|0)|0;i=a;return b|0}function eZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;f=tY(c[107930]|0,b,d,e)|0;i=a;return f|0}function fZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im;a=i;i=i+32|0;d=a;e=c[107930]|0;f=ea(g[b>>2]);h=ea(f*f);j=ea(g[b+4>>2]);k=ea(h+ea(j*j));h=ea(g[b+8>>2]);l=ea(k+ea(h*h));k=ea(g[b+12>>2]);m=ea(ea(1.0)/ea(T(ea(l+ea(k*k)))));l=ea(j*m);j=ea(h*m);h=ea(k*m);g[d>>2]=ea(f*m);g[d+4>>2]=l;g[d+8>>2]=j;g[d+12>>2]=h;g[d+16>>2]=ea(g[b+16>>2]);g[d+20>>2]=ea(g[b+20>>2]);g[d+24>>2]=ea(g[b+24>>2]);b=vY(e,d)|0;i=a;return b|0}function gZ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=i;h=kY(c[107930]|0,b,d,e,f,g)|0;i=a;return h|0}function hZ(a){a=a|0;var b=0;a=i;b=hY(c[107930]|0)|0;i=a;return b|0}function iZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=mY(c[107930]|0,b,d)|0;i=a;return e|0}function jZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=XX(c[107930]|0,b,d)|0;i=a;return e|0}function kZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=WX(c[107930]|0,b,d)|0;i=a;return e|0}function lZ(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;a=i;i=i+32|0;j=a;k=a+28|0;l=c[107930]|0;m=ea(g[d>>2]);n=ea(m*m);o=ea(g[d+4>>2]);p=ea(n+ea(o*o));n=ea(g[d+8>>2]);q=ea(p+ea(n*n));p=ea(g[d+12>>2]);r=ea(ea(1.0)/ea(T(ea(q+ea(p*p)))));q=ea(o*r);o=ea(n*r);n=ea(p*r);g[j>>2]=ea(m*r);g[j+4>>2]=q;g[j+8>>2]=o;g[j+12>>2]=n;g[j+16>>2]=ea(g[d+16>>2]);g[j+20>>2]=ea(g[d+20>>2]);g[j+24>>2]=ea(g[d+24>>2]);b[k>>1]=b[h>>1]|0;h=dY(l,j,e,f,k)|0;i=a;return h|0}function mZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+1|0;f=d;if(!b){g=0;i=d;return g|0}h=a+88|0;oTa(c[h>>2]|0);j=a+44|0;k=c[j>>2]|0;if(!k){l=a+36|0;m=c[l>>2]|0;c[l>>2]=m+1;n=m}else{m=k+-1|0;k=c[(c[a+40>>2]|0)+(m<<2)>>2]|0;c[j>>2]=m;n=k}k=a+56|0;m=c[k>>2]|0;do if(n>>>0<m>>>0){o=c[a+52>>2]|0;p=11}else{if(m>>>0>=65535){ko[c[c[b>>2]>>2]&4095](b);q=0;break}c[k>>2]=m<<1;j=UJa(e,m<<3,436152,189)|0;PEi(j|0,0,c[k>>2]<<2|0)|0;l=a+52|0;r=c[l>>2]|0;if(!m)s=r;else{t=r;r=0;while(1){c[j+(r<<2)>>2]=c[t+(r<<2)>>2];r=r+1|0;u=c[l>>2]|0;if((r|0)==(m|0)){s=u;break}else t=u}}VJa(f,s);c[l>>2]=j;o=j;p=11}while(0);if((p|0)==11){c[o+(n<<2)>>2]=b;c[(c[(c[a+52>>2]|0)+(n<<2)>>2]|0)+52>>2]=n;n=a+8|0;if(!(c[n>>2]|0))q=b;else{o=a+4|0;a=0;do{G0(c[(c[o>>2]|0)+(a<<2)>>2]|0,b)|0;a=a+1|0}while(a>>>0<(c[n>>2]|0)>>>0);q=b}}pTa(c[h>>2]|0);g=q;i=d;return g|0}function nZ(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=ea(e);var f=0,g=0;f=i;g=mZ(a,oY(c[107930]|0,b,d,e)|0)|0;i=f;return g|0}function oZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+88|0;oTa(c[d>>2]|0);e=c[a+56>>2]|0;if(!e)f=0;else{g=c[a+52>>2]|0;a=0;h=0;while(1){j=((c[g+(a<<2)>>2]|0)!=0&1)+h|0;a=a+1|0;if((a|0)==(e|0)){f=j;break}else h=j}}pTa(c[d>>2]|0);i=b;return f|0}function pZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;g=a+88|0;oTa(c[g>>2]|0);h=c[a+56>>2]|0;j=a+52|0;a=0;k=0;l=0;a:while(1){m=a;n=k;while(1){b:do if(m>>>0<h>>>0){o=c[j>>2]|0;p=m;while(1){if(c[o+(p<<2)>>2]|0){q=p;break b}r=p+1|0;if(r>>>0<h>>>0)p=r;else{q=r;break}}}else q=m;while(0);if(q>>>0>=h>>>0){s=l;t=11;break a}p=n;n=n+1|0;if(p>>>0>=e>>>0)break;else m=q}if((l|0)==(d|0)){s=d;t=11;break}c[b+(l<<2)>>2]=c[(c[j>>2]|0)+(q<<2)>>2];a=q+1|0;k=n;l=l+1|0}if((t|0)==11){pTa(c[g>>2]|0);i=f;return s|0}return 0}function qZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=a+88|0;oTa(c[f>>2]|0);g=a+8|0;if(c[g>>2]|0){h=a+4|0;j=0;do{I0(c[(c[h>>2]|0)+(j<<2)>>2]|0,b);j=j+1|0}while(j>>>0<(c[g>>2]|0)>>>0)}g=c[b+52>>2]|0;do if((g|0)!=-1){c[(c[a+52>>2]|0)+(g<<2)>>2]=0;c[e>>2]=g;b=a+36|0;if(((c[b>>2]|0)+-1|0)==(g|0)){c[b>>2]=g;break}b=a+40|0;j=a+44|0;h=c[j>>2]|0;if((c[a+48>>2]&2147483647)>>>0<=h>>>0){cUa(b,e)|0;break}k=(c[b>>2]|0)+(h<<2)|0;if(!k)l=h;else{c[k>>2]=g;l=c[j>>2]|0}c[j>>2]=l+1}while(0);pTa(c[f>>2]|0);i=d;return}function rZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+88|0;oTa(c[e>>2]|0);f=a+8|0;if(c[f>>2]|0){g=a+4|0;h=0;do{H0(c[(c[g>>2]|0)+(h<<2)>>2]|0,b);h=h+1|0}while(h>>>0<(c[f>>2]|0)>>>0)}c[(c[a+52>>2]|0)+(c[b+52>>2]<<2)>>2]=b;pTa(c[e>>2]|0);i=d;return}function sZ(a,b){a=a|0;b=b|0;var d=0;a=i;d=ZLa(c[107930]|0,b)|0;i=a;return d|0}function tZ(a){a=a|0;var b=0;a=i;b=$La(c[107930]|0)|0;i=a;return b|0}function uZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;f=aMa(c[107930]|0,b,d,e)|0;i=a;return f|0}function vZ(a,b){a=a|0;b=b|0;var d=0;a=i;d=hMa(c[107930]|0,b)|0;i=a;return d|0}function wZ(a,b){a=a|0;b=b|0;var d=0;a=i;d=iMa(c[107930]|0,b)|0;i=a;return d|0}function xZ(a){a=a|0;var b=0;a=i;b=kMa(c[107930]|0)|0;i=a;return b|0}function yZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;f=lMa(c[107930]|0,b,d,e)|0;i=a;return f|0}function zZ(a,b){a=a|0;b=b|0;var d=0;a=i;d=cMa(c[107930]|0,b)|0;i=a;return d|0}function AZ(a){a=a|0;var b=0;a=i;b=eMa(c[107930]|0)|0;i=a;return b|0}function BZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;f=fMa(c[107930]|0,b,d,e)|0;i=a;return f|0}function CZ(a,b){a=a|0;b=b|0;var d=0;a=i;d=_X(c[107930]|0,b)|0;i=a;return d|0}function DZ(a,b){a=a|0;b=b|0;var d=0;a=i;d=$X(c[107930]|0,b)|0;i=a;return d|0}function EZ(a){a=a|0;var b=0;a=i;b=bY(c[107930]|0)|0;i=a;return b|0}function FZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=cY(c[107930]|0,b,d)|0;i=a;return e|0}function GZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+16|0;j=h;k=b+64|0;oTa(c[k>>2]|0);l=b+68|0;m=b+72|0;n=c[m>>2]|0;a:do if(!n)o=0;else{p=c[l>>2]|0;q=0;while(1){r=q+1|0;if((c[(c[p+(q<<2)>>2]|0)+40>>2]|0)==(d|0)){o=q;break a}if(r>>>0<n>>>0)q=r;else{o=r;break}}}while(0);if((o|0)!=(n|0)){s=c[k>>2]|0;pTa(s);i=h;return}n=mKa()|0;o=c[(c[n>>2]|0)+8>>2]|0;q=pKa()|0;p=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[o&255](n,48,p?435672:544544,435352,645)|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;g[q+24>>2]=ea(.75);c[q+28>>2]=-1;c[q+32>>2]=0;c[q+36>>2]=0;VVa(q,64);c[q+40>>2]=d;a[q+44>>0]=a[e>>0]|0;e=q+45|0;a[e>>0]=0;c[j>>2]=q;if(!q){s=c[k>>2]|0;pTa(s);i=h;return}a[e>>0]=f&1;f=c[m>>2]|0;if((c[b+76>>2]&2147483647)>>>0>f>>>0){e=(c[l>>2]|0)+(f<<2)|0;if(e)c[e>>2]=q;c[m>>2]=f+1}else WVa(l,j)|0;a[b+84>>0]=1;s=c[k>>2]|0;pTa(s);i=h;return}function HZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;g=b+64|0;oTa(c[g>>2]|0);h=b+68|0;j=b+72|0;k=c[j>>2]|0;a:do if(!k)l=0;else{m=c[h>>2]|0;n=0;while(1){o=n+1|0;if((c[(c[m+(n<<2)>>2]|0)+40>>2]|0)==(d|0)){l=n;break a}if(o>>>0<k>>>0)n=o;else{l=o;break}}}while(0);if(l>>>0>=k>>>0){p=k;q=(p|0)!=0;r=b+84|0;s=q&1;a[r>>0]=s;t=c[g>>2]|0;pTa(t);i=e;return}d=c[h>>2]|0;n=c[d+(l<<2)>>2]|0;if(!n){u=k;v=d}else{d=c[n>>2]|0;if(d)VJa(n,d);VJa(f,n);u=c[j>>2]|0;v=c[h>>2]|0}h=u+-1|0;c[j>>2]=h;c[v+(l<<2)>>2]=c[v+(h<<2)>>2];p=h;q=(p|0)!=0;r=b+84|0;s=q&1;a[r>>0]=s;t=c[g>>2]|0;pTa(t);i=e;return}function IZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;j=b+68|0;k=c[b+72>>2]|0;a:do if(!k)l=0;else{b=c[j>>2]|0;m=0;while(1){n=m+1|0;if((c[(c[b+(m<<2)>>2]|0)+40>>2]|0)==(d|0)){l=m;break a}if(n>>>0<k>>>0)m=n;else{l=n;break}}}while(0);if(l>>>0>=k>>>0|(f|0)==0){i=g;return}k=c[(c[j>>2]|0)+(l<<2)>>2]|0;l=0;do{j=e+(l<<2)|0;d=XVa(k,j,h)|0;if(!((a[h>>0]|0)!=0|(d|0)==0))c[d>>2]=c[j>>2];l=l+1|0}while((l|0)!=(f|0));i=g;return}function JZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;h=b+68|0;j=c[b+72>>2]|0;a:do if(!j)k=0;else{b=c[h>>2]|0;l=0;while(1){m=l+1|0;if((c[(c[b+(l<<2)>>2]|0)+40>>2]|0)==(d|0)){k=l;break a}if(m>>>0<j>>>0)l=m;else{k=m;break}}}while(0);if(k>>>0>=j>>>0){i=g;return}j=c[(c[h>>2]|0)+(k<<2)>>2]|0;if((a[j+45>>0]|0)==0|(f|0)==0){i=g;return}k=j+20|0;h=j+12|0;d=j+4|0;l=j+8|0;b=j+36|0;m=j+32|0;n=j+28|0;j=0;do{o=c[k>>2]|0;b:do if((o|0)!=0?(p=c[e+(j<<2)>>2]|0,q=p,r=q+~(q<<15)|0,q=(r>>>10^r)*9|0,r=q>>>6^q,q=r+~(r<<11)|0,r=(c[h>>2]|0)+(((q>>>16^q)&o+-1)<<2)|0,q=c[r>>2]|0,(q|0)!=-1):0){s=c[d>>2]|0;t=q;q=r;while(1){if((c[s+(t<<2)>>2]|0)==(p|0))break;r=(c[l>>2]|0)+(t<<2)|0;u=c[r>>2]|0;if((u|0)==-1)break b;else{t=u;q=r}}if((t|0)!=-1){p=(c[l>>2]|0)+(t<<2)|0;c[q>>2]=c[p>>2];c[b>>2]=(c[b>>2]|0)+-1;c[m>>2]=(c[m>>2]|0)+1;c[p>>2]=c[n>>2];c[n>>2]=t}}while(0);j=j+1|0}while((j|0)!=(f|0));i=g;return}function KZ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;if(!(a[b+84>>0]|0)){i=h;return}j=b+64|0;oTa(c[j>>2]|0);k=b+72|0;if(c[k>>2]|0){l=b+68|0;b=e;m=b+~(b<<15)|0;b=(m>>>10^m)*9|0;m=b>>>6^b;b=m+~(m<<11)|0;m=b>>>16^b;b=0;do{n=c[(c[l>>2]|0)+(b<<2)>>2]|0;a:do if(d[n+44>>0]&g){if(!(a[n+45>>0]|0)){o=c[n+40>>2]|0;Dn[c[c[o>>2]>>2]&511](o,e,f,g);break}o=c[n+20>>2]|0;if((o|0)!=0?(p=c[(c[n+12>>2]|0)+((o+-1&m)<<2)>>2]|0,(p|0)!=-1):0){o=c[n+4>>2]|0;q=n+8|0;r=p;while(1){s=o+(r<<2)|0;if((c[s>>2]|0)==(e|0))break;r=c[(c[q>>2]|0)+(r<<2)>>2]|0;if((r|0)==-1)break a}if(s){r=c[n+40>>2]|0;Dn[c[c[r>>2]>>2]&511](r,e,f,g)}}}while(0);b=b+1|0}while(b>>>0<(c[k>>2]|0)>>>0)}pTa(c[j>>2]|0);i=h;return}function LZ(a){a=a|0;return a+20|0}function MZ(a){a=a|0;return c[a+92>>2]|0}function NZ(a){a=a|0;return c[a+96>>2]|0}function OZ(a){a=a|0;return 0}function PZ(a){a=a|0;return 0}function QZ(a){a=a|0;var b=0;a=i;b=bKa()|0;i=a;return b|0}function RZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=XY(a,b,c,d,e)|0;i=f;return g|0}function SZ(a){a=a|0;a=i;Zoa();gY();i=a;return}function TZ(a){a=a|0;a=i;_oa();vMa();i=a;return}function UZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;YX();d=a+88|0;oTa(c[d>>2]|0);e=a+8|0;if(!(c[e>>2]|0)){f=c[d>>2]|0;pTa(f);i=b;return}g=a+4|0;a=0;do{pca((c[(c[g>>2]|0)+(a<<2)>>2]|0)+32|0);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);f=c[d>>2]|0;pTa(f);i=b;return}function VZ(a){a=a|0;a=i;$oa();VX();i=a;return}function WZ(a,d){a=a|0;d=d|0;var e=0,f=0,h=0;e=i;b[a+4>>1]=5;b[a+6>>1]=3;f=a+8|0;c[f>>2]=0;c[a>>2]=438040;vU(a+12|0,0);c[f>>2]=0;c[a>>2]=437376;u2(a+20|0);c[a>>2]=437040;c[a+48>>2]=0;c[a+56>>2]=0;f=a+52|0;c[f>>2]=0;h=a+64|0;I8(h,1,d);c[f>>2]=c[f>>2]&-251658241|50331648;g[a+224>>2]=ea(g[a+80>>2]);g[a+228>>2]=ea(g[a+84>>2]);g[a+232>>2]=ea(g[a+88>>2]);g[a+236>>2]=ea(g[a+92>>2]);g[a+240>>2]=ea(g[a+96>>2]);g[a+244>>2]=ea(g[a+100>>2]);g[a+248>>2]=ea(g[a+104>>2]);g[a+252>>2]=ea(g[a+144>>2]);g[a+256>>2]=ea(g[a+148>>2]);g[a+260>>2]=ea(g[a+152>>2]);g[a+264>>2]=ea(g[a+160>>2]);g[a+268>>2]=ea(g[a+164>>2]);g[a+272>>2]=ea(g[a+168>>2]);g[a+276>>2]=ea(d9(h));c[a+280>>2]=1;c[a+284>>2]=0;c[a>>2]=436456;i=e;return}function XZ(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=437040;J8(a+64|0);c[a>>2]=437376;xKa(a+28|0);xKa(a+20|0);c[a>>2]=437712;MU(a);VJa(b,a);i=b;return}function YZ(a){a=a|0;var b=0;b=i;c[a>>2]=437040;J8(a+64|0);c[a>>2]=437376;xKa(a+28|0);xKa(a+20|0);c[a>>2]=437712;MU(a);i=b;return}function ZZ(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+20|0;g=a+24|0;a=b[g>>1]|0;if(!(a<<16>>16)){i=e;return}h=a&65535;j=a;a=0;while(1){if(j<<16>>16==1)k=f;else k=c[f>>2]|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,c[k+(a<<2)>>2]|0);l=a+1|0;if((l|0)==(h|0))break;j=b[g>>1]|0;a=l}i=e;return}function _Z(a){a=a|0;return a+-64|0}function $Z(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);e=a+48|0;f=c[a+52>>2]|0;if(((f>>>30)+-1|0)>>>0<2)g=c[e>>2]|0;else g=0;h=(b[(c[450992+((f>>>24&15)<<2)>>2]|0)+e+8>>1]&8)!=0;f=(g|0)!=0;if(f&h){j=a+20|0;C2(j,g,a);k=j;l=a}else{k=a+20|0;l=a}j=a+12|0;zU(j,l);y2(k,LU(a)|0);AU(j,a);if(!f){v3(e);i=d;return}V3(g,e,1,h);s$(P3(g)|0,a+36|0);v3(e);i=d;return}function a_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=0,U=0,V=0,W=0,X=0,Y=0;f=i;i=i+32|0;h=f;j=KU(b)|0;k=ea(g[d>>2]);l=ea(k*k);m=ea(g[d+4>>2]);n=ea(l+ea(m*m));l=ea(g[d+8>>2]);o=ea(n+ea(l*l));n=ea(g[d+12>>2]);p=ea(ea(1.0)/ea(T(ea(o+ea(n*n)))));o=ea(k*p);k=ea(m*p);m=ea(l*p);l=ea(n*p);p=ea(g[d+16>>2]);n=ea(g[d+20>>2]);q=ea(g[d+24>>2]);if(!j){r=ea(T(ea(ea(l*l)+ea(ea(m*m)+ea(ea(o*o)+ea(k*k))))));if(r!=ea(0.0)){s=ea(ea(1.0)/r);t=ea(l*s);u=ea(o*s);v=ea(k*s);w=ea(m*s)}else{t=l;u=o;v=k;w=m}d=b+48|0;x=b+284|0;if(!(c[x>>2]&512))y=b+112|0;else{z=b+56|0;A=c[z>>2]|0;if(!A){B=s4(c[d>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[z>>2]=B;C=B}else C=A;y=C+144|0}s=ea(ea(g[y+16>>2])*ea(2.0));r=ea(ea(g[y+20>>2])*ea(2.0));D=ea(ea(g[y+24>>2])*ea(2.0));E=ea(ea(t*t)+ea(-.5));F=ea(ea(ea(u*s)+ea(v*r))+ea(w*D));G=ea(p+ea(ea(u*F)+ea(ea(E*s)+ea(t*ea(ea(v*D)-ea(w*r))))));H=ea(n+ea(ea(v*F)+ea(ea(E*r)+ea(t*ea(ea(w*s)-ea(u*D))))));I=ea(q+ea(ea(ea(E*D)+ea(t*ea(ea(u*r)-ea(v*s))))+ea(w*F)));F=ea(g[y>>2]);s=ea(t*F);r=ea(g[y+12>>2]);D=ea(s+ea(u*r));s=ea(g[y+8>>2]);E=ea(D+ea(v*s));D=ea(g[y+4>>2]);J=ea(E-ea(w*D));E=ea(ea(ea(w*F)+ea(ea(v*r)+ea(t*D)))-ea(u*s));K=ea(ea(ea(u*D)+ea(ea(w*r)+ea(t*s)))-ea(v*F));L=ea(ea(ea(ea(t*r)-ea(u*F))-ea(v*D))-ea(w*s));g[h>>2]=J;g[h+4>>2]=E;g[h+8>>2]=K;g[h+12>>2]=L;g[h+16>>2]=G;g[h+20>>2]=H;g[h+24>>2]=I;g[b+224>>2]=J;g[b+228>>2]=E;g[b+232>>2]=K;g[b+236>>2]=L;g[b+240>>2]=G;g[b+244>>2]=H;g[b+248>>2]=I;y=(c[b+52>>2]|0)>>>30;if((y|0)==2){C=c[d>>2]|0;if(!(a[C+2417>>0]|0))M=37;else{N=C;M=38}}else if((y|0)==3){N=c[d>>2]|0;M=38}else M=37;if((M|0)==37){M8(b+64|0,h);i=f;return}else if((M|0)==38){c[x>>2]=c[x>>2]&-131073;r4(N,d);c[x>>2]=c[x>>2]|65536;i=f;return}}G2(b+20|0,j+3376|0);x=j+3400|0;c[x>>2]=(c[x>>2]|0)+1;I=ea(T(ea(ea(l*l)+ea(ea(m*m)+ea(ea(o*o)+ea(k*k))))));if(I!=ea(0.0)){H=ea(ea(1.0)/I);O=ea(l*H);P=ea(o*H);Q=ea(k*H);R=ea(m*H)}else{O=l;P=o;Q=k;R=m}x=b+48|0;j=b+284|0;if(!(c[j>>2]&512))S=b+112|0;else{d=b+56|0;N=c[d>>2]|0;if(!N){y=s4(c[x>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[d>>2]=y;U=y}else U=N;S=U+144|0}m=ea(ea(g[S+16>>2])*ea(2.0));k=ea(ea(g[S+20>>2])*ea(2.0));o=ea(ea(g[S+24>>2])*ea(2.0));l=ea(ea(O*O)+ea(-.5));H=ea(ea(ea(P*m)+ea(Q*k))+ea(R*o));I=ea(p+ea(ea(P*H)+ea(ea(l*m)+ea(O*ea(ea(Q*o)-ea(R*k))))));p=ea(n+ea(ea(Q*H)+ea(ea(l*k)+ea(O*ea(ea(R*m)-ea(P*o))))));n=ea(q+ea(ea(ea(l*o)+ea(O*ea(ea(P*k)-ea(Q*m))))+ea(R*H)));H=ea(g[S>>2]);m=ea(O*H);k=ea(g[S+12>>2]);o=ea(m+ea(P*k));m=ea(g[S+8>>2]);l=ea(o+ea(Q*m));o=ea(g[S+4>>2]);q=ea(l-ea(R*o));l=ea(ea(ea(R*H)+ea(ea(Q*k)+ea(O*o)))-ea(P*m));G=ea(ea(ea(P*o)+ea(ea(R*k)+ea(O*m)))-ea(Q*H));L=ea(ea(ea(ea(O*k)-ea(P*H))-ea(Q*o))-ea(R*m));g[h>>2]=q;g[h+4>>2]=l;g[h+8>>2]=G;g[h+12>>2]=L;g[h+16>>2]=I;g[h+20>>2]=p;g[h+24>>2]=n;g[b+224>>2]=q;g[b+228>>2]=l;g[b+232>>2]=G;g[b+236>>2]=L;g[b+240>>2]=I;g[b+244>>2]=p;g[b+248>>2]=n;S=b+52|0;U=(c[S>>2]|0)>>>30;if((U|0)==3){V=c[x>>2]|0;M=13}else if((U|0)==2?(U=c[x>>2]|0,(a[U+2417>>0]|0)!=0):0){V=U;M=13}else M=12;if((M|0)==12)M8(b+64|0,h);else if((M|0)==13){c[j>>2]=c[j>>2]&-131073;r4(V,x);c[j>>2]=c[j>>2]|65536}if(!e){i=f;return}if(!(c[j>>2]&4096))W=b+108|0;else{e=b+56|0;V=c[e>>2]|0;if(!V){h=s4(c[x>>2]|0,(c[S>>2]|0)>>>24&15)|0;c[e>>2]=h;X=h}else X=V;W=X+268|0}if(a[W>>0]&1){i=f;return}n=ea(g[(KU(b)|0)+2860>>2]);W=b+276|0;p=ea(g[W>>2]);X=b+280|0;V=p<n;I=V?n:p;if(!(V|(c[X>>2]|0)!=0)){i=f;return}V=(c[S>>2]|0)>>>30;if((V|0)==2){S=c[x>>2]|0;if(!(a[S+2416>>0]|0))M=25;else{Y=S;M=26}}else if((V|0)==3){Y=c[x>>2]|0;M=26}else M=25;if((M|0)==25){c[X>>2]=0;g[W>>2]=I;e9(b+64|0,I,1);i=f;return}else if((M|0)==26){c[X>>2]=0;g[W>>2]=I;r4(Y,x);c[j>>2]=c[j>>2]&-7340033|5242880;i=f;return}}function b_(a,b){a=a|0;b=b|0;var c=0,d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im;c=i;i=i+32|0;d=c;KU(a)|0;e=ea(g[b>>2]);f=ea(e*e);h=ea(g[b+4>>2]);j=ea(f+ea(h*h));f=ea(g[b+8>>2]);k=ea(j+ea(f*f));j=ea(g[b+12>>2]);l=ea(ea(1.0)/ea(T(ea(k+ea(j*j)))));k=ea(h*l);h=ea(f*l);f=ea(j*l);g[d>>2]=ea(e*l);g[d+4>>2]=k;g[d+8>>2]=h;g[d+12>>2]=f;g[d+16>>2]=ea(g[b+16>>2]);g[d+20>>2]=ea(g[b+20>>2]);g[d+24>>2]=ea(g[b+24>>2]);YVa(a,d);i=c;return}function c_(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;e=i;i=i+32|0;f=e;h=b+48|0;j=b+284|0;if(!(c[j>>2]&4096))k=b+108|0;else{l=b+56|0;m=c[l>>2]|0;if(!m){n=s4(c[h>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[l>>2]=n;o=n}else o=m;k=o+268|0}if(!(a[k>>0]&1)){p=0;i=e;return p|0}if(!(c[j>>2]&8192)){if((c[b+52>>2]&-1073741824|0)==-1073741824){p=0;i=e;return p|0}if(!(l9(b+64|0,f)|0)){p=0;i=e;return p|0}}else{k=b+56|0;o=c[k>>2]|0;if(!o){m=s4(c[h>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[k>>2]=m;q=m}else q=o;g[f>>2]=ea(g[q+192>>2]);g[f+4>>2]=ea(g[q+196>>2]);g[f+8>>2]=ea(g[q+200>>2]);g[f+12>>2]=ea(g[q+204>>2]);g[f+16>>2]=ea(g[q+208>>2]);g[f+20>>2]=ea(g[q+212>>2]);g[f+24>>2]=ea(g[q+216>>2])}if(!(c[j>>2]&512))r=b+112|0;else{j=b+56|0;q=c[j>>2]|0;if(!q){o=s4(c[h>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[j>>2]=o;s=o}else s=q;r=s+144|0}t=ea(g[r+16>>2]);u=ea(g[r+20>>2]);v=ea(t*ea(-2.0));t=ea(u*ea(-2.0));u=ea(ea(g[r+24>>2])*ea(-2.0));w=ea(g[r+12>>2]);x=ea(ea(w*w)+ea(-.5));y=ea(g[r>>2]);z=ea(v*y);A=ea(g[r+4>>2]);B=ea(z+ea(t*A));z=ea(g[r+8>>2]);C=ea(B+ea(u*z));B=ea(-y);D=ea(-A);E=ea(-z);F=ea(ea(ea(y*C)+ea(ea(v*x)-ea(w*ea(ea(u*A)-ea(t*z)))))*ea(2.0));G=ea(ea(ea(A*C)+ea(ea(t*x)-ea(w*ea(ea(v*z)-ea(u*y)))))*ea(2.0));H=ea(ea(ea(ea(u*x)-ea(w*ea(ea(t*y)-ea(v*A))))+ea(z*C))*ea(2.0));C=ea(g[f+12>>2]);z=ea(ea(C*C)+ea(-.5));A=ea(g[f>>2]);v=ea(A*F);y=ea(g[f+4>>2]);t=ea(v+ea(y*G));v=ea(g[f+8>>2]);x=ea(ea(v*H)+t);t=ea(ea(A*x)+ea(ea(z*F)+ea(C*ea(ea(y*H)-ea(v*G)))));u=ea(ea(y*x)+ea(ea(z*G)+ea(C*ea(ea(v*F)-ea(A*H)))));I=ea(ea(ea(z*H)+ea(C*ea(ea(A*G)-ea(y*F))))+ea(v*x));x=ea(ea(g[f+16>>2])+t);t=ea(ea(g[f+20>>2])+u);u=ea(ea(g[f+24>>2])+I);I=ea(ea(ea(v*B)+ea(ea(C*D)+ea(w*y)))-ea(A*E));F=ea(ea(ea(A*D)+ea(ea(C*E)+ea(w*v)))-ea(y*B));G=ea(ea(ea(ea(w*C)-ea(A*B))-ea(y*D))-ea(v*E));g[d>>2]=ea(ea(ea(ea(C*B)+ea(w*A))+ea(y*E))-ea(v*D));g[d+4>>2]=I;g[d+8>>2]=F;g[d+12>>2]=G;g[d+16>>2]=x;g[d+20>>2]=t;g[d+24>>2]=u;p=1;i=e;return p|0}function d_(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=Im,O=Im;e=i;i=i+96|0;f=e+56|0;h=e+28|0;j=e;k=ea(g[d>>2]);l=ea(k*k);m=ea(g[d+4>>2]);n=ea(l+ea(m*m));l=ea(g[d+8>>2]);o=ea(n+ea(l*l));n=ea(g[d+12>>2]);p=ea(ea(1.0)/ea(T(ea(o+ea(n*n)))));o=ea(m*p);m=ea(l*p);l=ea(n*p);g[f>>2]=ea(k*p);g[f+4>>2]=o;g[f+8>>2]=m;g[f+12>>2]=l;g[f+16>>2]=ea(g[d+16>>2]);g[f+20>>2]=ea(g[d+20>>2]);g[f+24>>2]=ea(g[d+24>>2]);d=b+48|0;q=b+284|0;if(!(c[q>>2]&512))r=b+112|0;else{s=b+56|0;t=c[s>>2]|0;if(!t){u=s4(c[d>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[s>>2]=u;v=u}else v=t;r=v+144|0}l=ea(g[r>>2]);m=ea(g[r+4>>2]);o=ea(g[r+8>>2]);p=ea(g[r+12>>2]);k=ea(g[r+16>>2]);n=ea(g[r+20>>2]);w=ea(g[r+24>>2]);ZVa(b,f);if(!(c[q>>2]&4096))x=b+108|0;else{f=b+56|0;r=c[f>>2]|0;if(!r){v=s4(c[d>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=v;y=v}else y=r;x=y+268|0}if(!(a[x>>0]&1)){i=e;return}do if(!(c[q>>2]&8192)){if((c[b+52>>2]&-1073741824|0)==-1073741824){i=e;return}if(l9(b+64|0,h)|0){z=ea(g[h+12>>2]);A=ea(g[h>>2]);B=ea(g[h+4>>2]);C=ea(g[h+8>>2]);D=ea(g[h+16>>2]);E=ea(g[h+20>>2]);F=z;G=A;H=B;I=C;J=D;K=E;L=ea(g[h+24>>2]);break}else{i=e;return}}else{x=b+56|0;y=c[x>>2]|0;if(!y){r=s4(c[d>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[x>>2]=r;M=r}else M=y;E=ea(g[M+192>>2]);g[h>>2]=E;D=ea(g[M+196>>2]);g[h+4>>2]=D;C=ea(g[M+200>>2]);g[h+8>>2]=C;B=ea(g[M+204>>2]);g[h+12>>2]=B;A=ea(g[M+208>>2]);g[h+16>>2]=A;z=ea(g[M+212>>2]);g[h+20>>2]=z;N=ea(g[M+216>>2]);g[h+24>>2]=N;F=B;G=E;H=D;I=C;J=A;K=z;L=N}while(0);N=ea(k*ea(-2.0));k=ea(n*ea(-2.0));n=ea(w*ea(-2.0));w=ea(ea(p*p)+ea(-.5));z=ea(ea(ea(l*N)+ea(m*k))+ea(o*n));A=ea(-l);C=ea(-m);D=ea(-o);E=ea(ea(ea(l*z)+ea(ea(N*w)-ea(p*ea(ea(m*n)-ea(o*k)))))*ea(2.0));B=ea(ea(ea(m*z)+ea(ea(w*k)-ea(p*ea(ea(o*N)-ea(l*n)))))*ea(2.0));O=ea(ea(ea(ea(w*n)-ea(p*ea(ea(l*k)-ea(m*N))))+ea(o*z))*ea(2.0));z=ea(ea(F*F)+ea(-.5));o=ea(ea(ea(E*G)+ea(B*H))+ea(O*I));N=ea(J+ea(ea(G*o)+ea(ea(E*z)+ea(F*ea(ea(O*H)-ea(B*I))))));J=ea(K+ea(ea(H*o)+ea(ea(B*z)+ea(F*ea(ea(E*I)-ea(O*G))))));K=ea(L+ea(ea(ea(O*z)+ea(F*ea(ea(B*G)-ea(E*H))))+ea(I*o)));o=ea(ea(ea(I*A)+ea(ea(F*C)+ea(p*H)))-ea(G*D));E=ea(ea(ea(G*C)+ea(ea(F*D)+ea(p*I)))-ea(H*A));B=ea(ea(ea(ea(p*F)-ea(G*A))-ea(H*C))-ea(I*D));g[j>>2]=ea(ea(ea(ea(F*A)+ea(p*G))+ea(H*D))-ea(I*C));g[j+4>>2]=o;g[j+8>>2]=E;g[j+12>>2]=B;g[j+16>>2]=N;g[j+20>>2]=J;g[j+24>>2]=K;YVa(b,j);i=e;return}function e_(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+48|0;h=b+64|0;j=c[b+52>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){X8(h,d);i=e;return}h=b+56|0;m=c[h>>2]|0;if(!m){k=s4(c[l>>2]|0,j>>>24&15)|0;c[h>>2]=k;n=k}else n=m;g[n+108>>2]=d;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|4;i=e;return}function f_(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0;b=i;if(!(c[a+284>>2]&4)){d=ea(W8(a+64|0));i=b;return ea(d)}e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=ea(g[j+108>>2]);i=b;return ea(d)}function g_(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+48|0;h=b+64|0;j=c[b+52>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){Z8(h,d);i=e;return}h=b+56|0;m=c[h>>2]|0;if(!m){k=s4(c[l>>2]|0,j>>>24&15)|0;c[h>>2]=k;n=k}else n=m;g[n+112>>2]=d;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|8;i=e;return}function h_(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0;b=i;if(!(c[a+284>>2]&8)){d=ea(Y8(a+64|0));i=b;return ea(d)}e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=ea(g[j+112>>2]);i=b;return ea(d)}function i_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0;f=i;h=KU(b)|0;j=b+48|0;g[b+252>>2]=ea(g[d>>2]);k=d+4|0;g[b+256>>2]=ea(g[k>>2]);l=d+8|0;g[b+260>>2]=ea(g[l>>2]);m=b+52|0;n=(c[m>>2]|0)>>>30;if((n|0)==2){o=c[j>>2]|0;if(!(a[o+2416>>0]|0))p=4;else{q=o;p=5}}else if((n|0)==3){q=c[j>>2]|0;p=5}else p=4;if((p|0)==4){g[b+144>>2]=ea(g[d>>2]);g[b+148>>2]=ea(g[k>>2]);g[b+152>>2]=ea(g[l>>2])}else if((p|0)==5){r4(q,j);q=b+284|0;c[q>>2]=c[q>>2]|262144}if(!h){i=f;return}if(ea(g[d>>2])==ea(0.0)?ea(g[k>>2])==ea(0.0):0)r=ea(g[l>>2])!=ea(0.0);else r=1;s=ea(g[(KU(b)|0)+2860>>2]);l=b+276|0;t=ea(g[l>>2]);k=b+280|0;d=t<s&e;u=d?s:t;if(!(d|(r|e)&(c[k>>2]|0)!=0)){i=f;return}e=(c[m>>2]|0)>>>30;if((e|0)==3){v=c[j>>2]|0;p=15}else if((e|0)==2?(e=c[j>>2]|0,(a[e+2416>>0]|0)!=0):0){v=e;p=15}else p=14;if((p|0)==14){c[k>>2]=0;g[l>>2]=u;e9(b+64|0,u,1);i=f;return}else if((p|0)==15){c[k>>2]=0;g[l>>2]=u;r4(v,j);j=b+284|0;c[j>>2]=c[j>>2]&-7340033|5242880;i=f;return}}function j_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=0,m=0,n=Im,o=0,p=0;h=i;j=ea(g[(KU(b)|0)+2860>>2]);b=d+228|0;k=ea(g[b>>2]);l=d+232|0;m=k<j&f;n=m?j:k;if(!(m|(f|e)&(c[l>>2]|0)!=0)){i=h;return}e=(c[d+4>>2]|0)>>>30;if((e|0)==3){o=c[d>>2]|0;p=6}else if((e|0)==2?(e=c[d>>2]|0,(a[e+2416>>0]|0)!=0):0){o=e;p=6}else p=5;if((p|0)==5){c[l>>2]=0;g[b>>2]=n;e9(d+16|0,n,1);i=h;return}else if((p|0)==6){c[l>>2]=0;g[b>>2]=n;r4(o,d);o=d+236|0;c[o>>2]=c[o>>2]&-7340033|5242880;i=h;return}}function k_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0;f=i;h=KU(b)|0;j=b+48|0;g[b+264>>2]=ea(g[d>>2]);k=d+4|0;g[b+268>>2]=ea(g[k>>2]);l=d+8|0;g[b+272>>2]=ea(g[l>>2]);m=b+52|0;n=(c[m>>2]|0)>>>30;if((n|0)==3){o=c[j>>2]|0;p=5}else if((n|0)==2?(n=c[j>>2]|0,(a[n+2416>>0]|0)!=0):0){o=n;p=5}else p=4;if((p|0)==4){g[b+160>>2]=ea(g[d>>2]);g[b+164>>2]=ea(g[k>>2]);g[b+168>>2]=ea(g[l>>2])}else if((p|0)==5){r4(o,j);o=b+284|0;c[o>>2]=c[o>>2]|524288}if(!h){i=f;return}if(ea(g[d>>2])==ea(0.0)?ea(g[k>>2])==ea(0.0):0)q=ea(g[l>>2])!=ea(0.0);else q=1;r=ea(g[(KU(b)|0)+2860>>2]);l=b+276|0;s=ea(g[l>>2]);k=b+280|0;d=s<r&e;t=d?r:s;if(!(d|(q|e)&(c[k>>2]|0)!=0)){i=f;return}e=(c[m>>2]|0)>>>30;if((e|0)==3){u=c[j>>2]|0;p=15}else if((e|0)==2?(e=c[j>>2]|0,(a[e+2416>>0]|0)!=0):0){u=e;p=15}else p=14;if((p|0)==14){c[k>>2]=0;g[l>>2]=t;e9(b+64|0,t,1);i=f;return}else if((p|0)==15){c[k>>2]=0;g[l>>2]=t;r4(u,j);j=b+284|0;c[j>>2]=c[j>>2]&-7340033|5242880;i=f;return}}function l_(b,d){b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+48|0;h=ea(d*d);j=b+64|0;k=c[b+52>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){$8(j,h);i=e;return}j=b+56|0;m=c[j>>2]|0;if(!m){l=s4(c[n>>2]|0,k>>>24&15)|0;c[j>>2]=l;o=l}else o=m;g[o+116>>2]=h;r4(c[n>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|16;i=e;return}function m_(a){a=a|0;var b=0,d=Im,e=Im,f=0,h=0,j=0,k=0;b=i;if(!(c[a+284>>2]&16)){d=ea(_8(a+64|0));e=ea(T(ea(d)));i=b;return ea(e)}f=a+56|0;h=c[f>>2]|0;if(!h){j=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;d=ea(g[k+116>>2]);e=ea(T(ea(d)));i=b;return ea(e)}function n_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=0,o=Im,p=0,q=0;h=i;KU(b)|0;j=b+48|0;_Va(b,d,0,e);if(ea(g[d>>2])==ea(0.0)?ea(g[d+4>>2])==ea(0.0):0)k=ea(g[d+8>>2])!=ea(0.0);else k=1;l=ea(g[(KU(b)|0)+2860>>2]);d=b+276|0;m=ea(g[d>>2]);e=b+280|0;n=m<l&f;o=n?l:m;if(!(n|(k|f)&(c[e>>2]|0)!=0)){i=h;return}f=(c[b+52>>2]|0)>>>30;if((f|0)==2){k=c[j>>2]|0;if(!(a[k+2416>>0]|0))p=8;else{q=k;p=9}}else if((f|0)==3){q=c[j>>2]|0;p=9}else p=8;if((p|0)==8){c[e>>2]=0;g[d>>2]=o;e9(b+64|0,o,1);i=h;return}else if((p|0)==9){c[e>>2]=0;g[d>>2]=o;r4(q,j);j=b+284|0;c[j>>2]=c[j>>2]&-7340033|5242880;i=h;return}}function o_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=0,o=Im,p=0,q=0;h=i;KU(b)|0;j=b+48|0;_Va(b,0,d,e);if(ea(g[d>>2])==ea(0.0)?ea(g[d+4>>2])==ea(0.0):0)k=ea(g[d+8>>2])!=ea(0.0);else k=1;l=ea(g[(KU(b)|0)+2860>>2]);d=b+276|0;m=ea(g[d>>2]);e=b+280|0;n=m<l&f;o=n?l:m;if(!(n|(k|f)&(c[e>>2]|0)!=0)){i=h;return}f=(c[b+52>>2]|0)>>>30;if((f|0)==3){p=c[j>>2]|0;q=9}else if((f|0)==2?(f=c[j>>2]|0,(a[f+2416>>0]|0)!=0):0){p=f;q=9}else q=8;if((q|0)==8){c[e>>2]=0;g[d>>2]=o;e9(b+64|0,o,1);i=h;return}else if((q|0)==9){c[e>>2]=0;g[d>>2]=o;r4(p,j);j=b+284|0;c[j>>2]=c[j>>2]&-7340033|5242880;i=h;return}}function p_(a,b){a=a|0;b=b|0;var c=0;c=i;KU(a)|0;$Va(a,b);i=c;return}function q_(a,b){a=a|0;b=b|0;var c=0;c=i;KU(a)|0;$Va(a,b);i=c;return}function r_(a){a=a|0;var b=0;b=i;KU(a)|0;i=b;return (c[a+280>>2]|0)!=0|0}function s_(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+48|0;h=c[b+52>>2]|0;j=h>>>30;if((j|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))k=4;else l=f;else if((j|0)==3)l=f;else k=4;if((k|0)==4){g[b+208>>2]=d;i=e;return}k=b+56|0;j=c[k>>2]|0;if(!j){m=s4(c[l>>2]|0,h>>>24&15)|0;c[k>>2]=m;n=m}else n=j;g[n+120>>2]=d;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|32;i=e;return}function t_(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;if(!(c[a+284>>2]&32)){d=a+208|0;e=ea(g[d>>2]);i=b;return ea(e)}f=a+56|0;h=c[f>>2]|0;if(!h){j=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;d=k+120|0;e=ea(g[d>>2]);i=b;return ea(e)}function u_(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+48|0;h=c[b+52>>2]|0;j=h>>>30;if((j|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))k=4;else l=f;else if((j|0)==3)l=f;else k=4;if((k|0)==4){g[b+212>>2]=d;i=e;return}k=b+56|0;j=c[k>>2]|0;if(!j){m=s4(c[l>>2]|0,h>>>24&15)|0;c[k>>2]=m;n=m}else n=j;g[n+176>>2]=d;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|2048;i=e;return}function v_(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;if(!(c[a+284>>2]&2048)){d=a+212|0;e=ea(g[d>>2]);i=b;return ea(e)}f=a+56|0;h=c[f>>2]|0;if(!h){j=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;d=k+176|0;e=ea(g[d>>2]);i=b;return ea(e)}function w_(a,b){a=a|0;b=ea(b);var c=0;c=i;dVa(a+48|0,b);i=c;return}function x_(a){a=a|0;var b=Im;b=ea(g[a+276>>2]);return ea(b)}function y_(b){b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0;d=i;KU(b)|0;e=b+48|0;f=c[e>>2]|0;h=ea(g[f+2844>>2]);j=(c[b+52>>2]|0)>>>30;if((j|0)==3)k=4;else if((j|0)==2?(a[f+2416>>0]|0)!=0:0)k=4;else k=3;if((k|0)==3){c[b+280>>2]=0;g[b+276>>2]=h;e9(b+64|0,h,1);i=d;return}else if((k|0)==4){c[b+280>>2]=0;g[b+276>>2]=h;r4(f,e);e=b+284|0;c[e>>2]=c[e>>2]&-7340033|5242880;i=d;return}}function z_(a){a=a|0;var b=0;b=i;KU(a)|0;eVa(a+48|0);i=b;return}function A_(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;h=d+48|0;j=(f<<8|e&255)&65535;e=c[d+52>>2]|0;f=e>>>30;if((f|0)==3)k=h;else if((f|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)k=h;else l=4;if((l|0)==4){b[d+110>>1]=j;i=g;return}l=d+56|0;f=c[l>>2]|0;if(!f){m=s4(c[k>>2]|0,e>>>24&15)|0;c[l>>2]=m;n=m}else n=f;b[n+132>>1]=j;r4(c[k>>2]|0,h);h=d+284|0;c[h>>2]=c[h>>2]|256;i=g;return}function B_(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!(c[a+284>>2]&256))g=a+110|0;else{h=a+56|0;j=c[h>>2]|0;if(!j){k=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[h>>2]=k;l=k}else l=j;g=l+132|0}l=e[g>>1]|0;c[d>>2]=l>>>8;c[b>>2]=l&255;i=f;return}function C_(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0;e=i;f=b+48|0;h=d<ea(0.0);j=h?ea(0.0):d;h=c[b+52>>2]|0;k=h>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){g[b+172>>2]=j;i=e;return}m=b+56|0;k=c[m>>2]|0;if(!k){n=s4(c[l>>2]|0,h>>>24&15)|0;c[m>>2]=n;o=n}else o=k;g[o+128>>2]=j;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|128;i=e;return}function D_(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;if(!(c[a+284>>2]&128)){d=a+172|0;e=ea(g[d>>2]);i=b;return ea(e)}f=a+56|0;h=c[f>>2]|0;if(!h){j=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;d=k+128|0;e=ea(g[d>>2]);i=b;return ea(e)}function E_(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;f=(Zba(a+16|0)|0)+20|0;a=b[f+4>>1]|0;if(a<<16>>16==1)g=f;else g=c[f>>2]|0;c[d>>2]=g;i=e;return a&65535|0}function F_(a){a=a|0;var b=0;b=i;aWa(a+48|0);i=b;return}function G_(b){b=b|0;var d=0,e=0;d=i;e=b+48|0;b=c[e>>2]|0;if(!b){i=d;return}if(a[b+2417>>0]|0){i=d;return}R3(b,e,1);i=d;return}function H_(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=0;h=i;i=i+96|0;j=h+32|0;k=h;bWa(d,e,f);l=d+48|0;m=d+52|0;n=c[m>>2]|0;if(!(n&1))o=(c[450992+((n>>>24&15)<<2)>>2]|0)+l+8|0;else{p=d+56|0;q=c[p>>2]|0;if(!q){r=s4(c[l>>2]|0,n>>>24&15)|0;c[p>>2]=r;s=r}else s=q;o=s}if(!(b[o>>1]&1)){i=h;return}t=ea(Um[c[(c[f>>2]|0)+296>>2]&63](f,0));if(!(ea(t*ea(Um[c[(c[f>>2]|0)+296>>2]&63](f,3)))!=ea(0.0))){i=h;return}t=ea(g[d+276>>2]);u=ea(t/ea(g[f+2860>>2]));f=u>ea(1.0);o=~~ea(u*ea(255.0))>>>0;s=f?255:o;if(!(c[d+280>>2]|0))v=s<<8|s|s<<16;else v=16711680;s=d+284|0;if(!(c[s>>2]&2))w=U8(d+64|0)|0;else{o=d+56|0;f=c[o>>2]|0;if(!f){q=s4(c[l>>2]|0,(c[m>>2]|0)>>>24&15)|0;c[o>>2]=q;x=q}else x=f;w=x+96|0}u=ea(g[w>>2]);t=ea(g[w+4>>2]);y=ea(g[w+8>>2]);if(u==ea(0.0))z=ea(0.0);else z=ea(ea(1.0)/u);if(t==ea(0.0))A=ea(0.0);else A=ea(ea(1.0)/t);if(y==ea(0.0))B=ea(0.0);else B=ea(ea(1.0)/y);if(!(c[s>>2]&1))C=ea(S8(d+64|0));else{s=d+56|0;w=c[s>>2]|0;if(!w){x=s4(c[l>>2]|0,(c[m>>2]|0)>>>24&15)|0;c[s>>2]=x;D=x}else D=w;C=ea(g[D+92>>2])}y=ea(ea(6.0)/ea(ea(1.0)/C));C=ea(z*y);z=ea(A*y);A=ea(B*y);y=ea(T(ea(S(ea(A+ea(z-C))))));B=ea(T(ea(S(ea(A+ea(C-z))))));t=ea(T(ea(S(ea(ea(C+z)-A)))));D=DKa(e,v)|0;kLa(j,d+224|0);d=EKa(D,j)|0;A=ea(y*ea(.5));y=ea(B*ea(.5));B=ea(t*ea(.5));t=ea(-y);z=ea(-B);g[k>>2]=ea(-A);g[k+4>>2]=t;g[k+8>>2]=z;g[k+12>>2]=A;g[k+16>>2]=y;g[k+20>>2]=B;a[k+24>>0]=1;HKa(d,k)|0;i=h;return}function I_(d,e){d=d|0;e=e|0;var f=0,h=0,j=0;f=i;b[d+4>>1]=6;b[d+6>>1]=3;h=d+8|0;c[h>>2]=0;c[d>>2]=438968;vU(d+12|0,0);c[h>>2]=0;c[d>>2]=438680;u2(d+20|0);c[d>>2]=438376;c[d+48>>2]=0;c[d+56>>2]=0;h=d+52|0;c[h>>2]=0;Tba(d+64|0,0);j=d+108|0;a[j>>0]=0;g[d+80>>2]=ea(g[e>>2]);g[d+84>>2]=ea(g[e+4>>2]);g[d+88>>2]=ea(g[e+8>>2]);g[d+92>>2]=ea(g[e+12>>2]);g[d+96>>2]=ea(g[e+16>>2]);g[d+100>>2]=ea(g[e+20>>2]);g[d+104>>2]=ea(g[e+24>>2]);a[j>>0]=0;c[h>>2]=c[h>>2]&-251658241|83886080;i=f;return}function J_(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=438376;Uba(a+64|0);c[a>>2]=438680;xKa(a+28|0);xKa(a+20|0);c[a>>2]=438832;MU(a);VJa(b,a);i=b;return}function K_(a){a=a|0;var b=0;b=i;c[a>>2]=438376;Uba(a+64|0);c[a>>2]=438680;xKa(a+28|0);xKa(a+20|0);c[a>>2]=438832;MU(a);i=b;return}function L_(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+20|0;g=a+24|0;a=b[g>>1]|0;if(!(a<<16>>16)){i=e;return}h=a&65535;j=a;a=0;while(1){if(j<<16>>16==1)k=f;else k=c[f>>2]|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,c[k+(a<<2)>>2]|0);l=a+1|0;if((l|0)==(h|0))break;j=b[g>>1]|0;a=l}i=e;return}function M_(a){a=a|0;return a+-64|0}function N_(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);e=a+48|0;f=c[a+52>>2]|0;if(((f>>>30)+-1|0)>>>0<2)g=c[e>>2]|0;else g=0;h=(b[(c[450992+((f>>>24&15)<<2)>>2]|0)+e+8>>1]&8)!=0;f=(g|0)!=0;if(f&h){j=a+20|0;C2(j,g,a);k=j;l=a}else{k=a+20|0;l=a}j=a+12|0;zU(j,l);y2(k,LU(a)|0);AU(j,a);if(!f){v3(e);i=d;return}T3(g,e,1,h);s$(P3(g)|0,a+36|0);v3(e);i=d;return}function O_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im;e=i;i=i+32|0;f=e;h=e+4|0;j=LU(b)|0;k=b+48|0;l=ea(g[d>>2]);m=ea(l*l);n=ea(g[d+4>>2]);o=ea(m+ea(n*n));m=ea(g[d+8>>2]);p=ea(o+ea(m*m));o=ea(g[d+12>>2]);q=ea(ea(1.0)/ea(T(ea(p+ea(o*o)))));p=ea(l*q);l=ea(n*q);n=ea(m*q);m=ea(o*q);g[h>>2]=p;r=h+4|0;g[r>>2]=l;s=h+8|0;g[s>>2]=n;t=h+12|0;g[t>>2]=m;u=h+16|0;g[u>>2]=ea(g[d+16>>2]);v=h+20|0;g[v>>2]=ea(g[d+20>>2]);w=h+24|0;g[w>>2]=ea(g[d+24>>2]);d=b+64|0;x=b+52|0;y=c[x>>2]|0;z=y>>>30;if((z|0)==3){A=k;B=5}else if((z|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0){A=k;B=5}else B=4;if((B|0)==4)cga(d,h);else if((B|0)==5){d=b+56|0;z=c[d>>2]|0;if(!z){C=s4(c[A>>2]|0,y>>>24&15)|0;c[d>>2]=C;D=C;E=ea(g[h>>2])}else{D=z;E=p}g[D+96>>2]=E;g[D+100>>2]=ea(g[r>>2]);g[D+104>>2]=ea(g[s>>2]);g[D+108>>2]=ea(g[t>>2]);g[D+112>>2]=ea(g[u>>2]);g[D+116>>2]=ea(g[v>>2]);g[D+120>>2]=ea(g[w>>2]);r4(c[A>>2]|0,k);c[x>>2]=c[x>>2]|64}if(j){dKa(bKa()|0,128,438520,113,438600,f);G2(b+20|0,j+3376|0);f=j+3396|0;c[f>>2]=(c[f>>2]|0)+1}f=c[b+16>>2]|0;if(!f){i=e;return}j=c[f+36>>2]|0;x=c[f+40>>2]|0;if(!x){i=e;return}f=0;while(1){if(!(a[j+(f<<3)>>0]|0)){k=c[j+(f<<3)+4>>2]|0;if(!k){B=17;break}MX(k,b)}f=f+1|0;if(f>>>0>=x>>>0){B=17;break}}if((B|0)==17){i=e;return}}function P_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b+52>>2]|0;if(!(e&64))f=b+80|0;else{h=b+56|0;j=c[h>>2]|0;if(!j){k=s4(c[b+48>>2]|0,e>>>24&15)|0;c[h>>2]=k;l=k}else l=j;f=l+96|0}g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);g[a+12>>2]=ea(g[f+12>>2]);g[a+16>>2]=ea(g[f+16>>2]);g[a+20>>2]=ea(g[f+20>>2]);g[a+24>>2]=ea(g[f+24>>2]);i=d;return}function Q_(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h;if((mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0)==65535){k=0;i=h;return k|0}l=c[108764]|0;m=c[(c[l>>2]|0)+124>>2]|0;a[j>>0]=a[g>>0]|0;g=Km[m&127](l,d,e,f,1,j)|0;if(!g){k=0;i=h;return k|0}w2(b+20|0,g,b);G1(g);k=g;i=h;return k|0}function R_(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=(Zba((c[450992+(((c[a+4>>2]|0)>>>24&15)<<2)>>2]|0)+a|0)|0)+20|0;a=b[f+4>>1]|0;if(a<<16>>16==1){g=f;c[d>>2]=g;h=a&65535;i=e;return h|0}g=c[f>>2]|0;c[d>>2]=g;h=a&65535;i=e;return h|0}function S_(b){b=b|0;var d=0,e=0;d=i;e=b+48|0;b=c[e>>2]|0;if(!b){i=d;return}if(a[b+2417>>0]|0){i=d;return}Q3(b,e,0);i=d;return}function T_(b){b=b|0;var d=0,e=0;d=i;e=b+48|0;b=c[e>>2]|0;if(!b){i=d;return}if(a[b+2417>>0]|0){i=d;return}R3(b,e,0);i=d;return}function U_(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=Im;h=i;i=i+128|0;j=h+56|0;k=h+24|0;l=h;I2(d+20|0,e,f,d);m=d+48|0;n=c[d+52>>2]|0;if(!(n&1))o=(c[450992+((n>>>24&15)<<2)>>2]|0)+m+8|0;else{p=d+56|0;q=c[p>>2]|0;if(!q){r=s4(c[m>>2]|0,n>>>24&15)|0;c[p>>2]=r;s=r}else s=q;o=s}if(!(b[o>>1]&1)){i=h;return}o=f+3372|0;s=c[o>>2]|0;if((s&64|0)!=0?(a[f+3012>>0]|0)!=0:0){t=ea(g[f+2864>>2]);u=s}else{v=ea(Cda(f+32|0,0));t=v;u=c[o>>2]|0}if((u&64|0)!=0?(a[f+3023>>0]|0)!=0:0)w=ea(g[f+2908>>2]);else w=ea(Cda(f+32|0,11));v=ea(t*w);if(!(v!=ea(0.0))){i=h;return}In[c[(c[d>>2]|0)+84>>2]&4095](k,d);kLa(j,k);k=EKa(e,j)|0;g[l>>2]=v;g[l+4>>2]=v;g[l+8>>2]=v;c[l+12>>2]=-65536;c[l+16>>2]=-16711936;c[l+20>>2]=-16776961;JKa(k,l)|0;i=h;return}function V_(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;h=f;c[d+4>>2]=0;c[d>>2]=439128;j=d+16|0;k=c[108764]|0;l=mo[c[(c[k>>2]|0)+176>>2]&4095](k)|0;k=h;c[k>>2]=d;c[k+4>>2]=0;c[h+8>>2]=(l|0)==0?0:l+8|0;N3(j,e,h);jCa(d+3376|0,j,e);c[d>>2]=439576;c[d+3460>>2]=422368;PEi(d+3464|0,0,132)|0;g[d+3596>>2]=ea(.75);c[d+3600>>2]=-1;c[d+3604>>2]=0;c[d+3608>>2]=0;cWa(d+3572|0,64);j=d+3648|0;h=d+3612|0;l=h+36|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(l|0));h=c[(FTa()|0)>>2]|0;if(h){l=mKa()|0;k=c[(c[l>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[k&255](l,h,n?443792:544544,443712,100)|0;c[j>>2]=m;if(m)GTa(m)}else c[j>>2]=0;m=d+3652|0;n=c[(FTa()|0)>>2]|0;if(n){h=mKa()|0;l=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;o=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[l&255](h,n,o?443792:544544,443712,100)|0;c[m>>2]=k;if(k)GTa(k)}else c[m>>2]=0;a[d+3656>>0]=0;a[d+3657>>0]=(c[e+152>>2]|0)==1&1;a[d+3658>>0]=0;c[d+3664>>2]=1;c[d+3668>>2]=0;c[d+3672>>2]=0;c[d+3676>>2]=0;e=d+3684|0;b[d+3688>>1]=-1;b[d+3690>>1]=0;c[d+3692>>2]=0;c[e>>2]=443968;c[d+3696>>2]=0;c[d+3700>>2]=0;c[e>>2]=445576;c[d+3704>>2]=j;j=d+3708|0;b[d+3712>>1]=-1;b[d+3714>>1]=0;c[d+3716>>2]=0;c[j>>2]=443968;c[d+3720>>2]=0;c[d+3724>>2]=0;c[j>>2]=445576;c[d+3728>>2]=m;m=d+3732|0;b[d+3736>>1]=-1;b[d+3738>>1]=0;c[d+3740>>2]=0;c[m>>2]=443968;c[d+3744>>2]=0;c[d+3748>>2]=0;c[m>>2]=444056;m=d+3752|0;c[m>>2]=0;c[d+3756>>2]=440024;j=d+3760|0;b[d+3764>>1]=-1;b[d+3766>>1]=0;c[d+3768>>2]=0;c[j>>2]=443968;c[d+3772>>2]=0;c[d+3776>>2]=0;c[j>>2]=444008;j=d+3780|0;c[j>>2]=0;c[d+3784>>2]=440048;e=d+3788|0;b[d+3792>>1]=-1;b[d+3794>>1]=0;c[d+3796>>2]=0;c[e>>2]=443968;c[d+3800>>2]=0;c[d+3804>>2]=0;c[e>>2]=443920;e=d+3808|0;c[e>>2]=0;c[d+3812>>2]=440064;a[d+3816>>0]=0;c[d+3820>>2]=0;c[d+3824>>2]=0;c[d+3828>>2]=0;c[d+3832>>2]=0;c[d+3840>>2]=0;rTa(d+3844|0);a[d+3848>>0]=0;c[m>>2]=d;c[j>>2]=d;c[e>>2]=d;c[d+3680>>2]=c[d+2400>>2];c[d+3836>>2]=MTa()|0;i=f;return}function W_(a){a=a|0;var b=0;b=i;c[a>>2]=439128;nCa(a+3376|0);dWa(a+16|0);ACi(a);i=b;return}function X_(a){a=a|0;var b=0;b=i;c[a>>2]=439128;nCa(a+3376|0);dWa(a+16|0);i=b;return}function Y_(a){a=a|0;var b=0;b=i;i=i+16|0;Z_(a);VJa(b,a);i=b;return}function Z_(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=439576;g=a+3560|0;h=a+3564|0;a:do if(c[h>>2]|0){j=439576|0;while(1){co[c[j+64>>2]&2047](a,c[c[g>>2]>>2]|0,0);if(!(c[h>>2]|0))break a;j=c[a>>2]|0}}while(0);h=a+3624|0;j=a+3628|0;if(c[j>>2]|0)do co[c[(c[a>>2]|0)+52>>2]&2047](a,c[c[h>>2]>>2]|0,0);while((c[j>>2]|0)!=0);j=a+3636|0;k=a+3640|0;if(c[k>>2]|0)do co[c[(c[a>>2]|0)+52>>2]&2047](a,c[c[j>>2]>>2]|0,0);while((c[k>>2]|0)!=0);k=a+3536|0;l=a+3540|0;if(c[l>>2]|0)do co[c[(c[a>>2]|0)+52>>2]&2047](a,c[c[k>>2]>>2]|0,0);while((c[l>>2]|0)!=0);l=a+3548|0;m=a+3552|0;if(c[m>>2]|0)do co[c[(c[a>>2]|0)+40>>2]&2047](a,c[c[l>>2]>>2]|0,0);while((c[m>>2]|0)!=0);c[e>>2]=0;m=e+4|0;c[m>>2]=0;n=e+8|0;c[n>>2]=0;o=a+3572|0;p=c[a+3608>>2]|0;if(p)eWa(e,p);p=a+3584|0;b:do if(c[a+3588>>2]|0){q=c[p>>2]|0;r=c[q>>2]|0;if((r|0)==-1){s=c[a+3592>>2]|0;t=0;while(1){u=t+1|0;if((u|0)==(s|0)){v=-1;w=s;break b}x=c[q+(u<<2)>>2]|0;if((x|0)==-1)t=u;else{v=x;w=u;break}}}else{v=r;w=0}}else{v=-1;w=0}while(0);t=a+3576|0;q=a+3580|0;s=a+3592|0;u=v;v=w;c:while(1){w=u;do{if((w|0)==-1)break c;x=c[(c[t>>2]|0)+(w<<2)>>2]|0;c[f>>2]=x;y=c[m>>2]|0;if((c[n>>2]&2147483647)>>>0>y>>>0){z=(c[e>>2]|0)+(y<<2)|0;if(z)c[z>>2]=x;c[m>>2]=y+1}else fWa(e,f)|0;w=c[(c[q>>2]|0)+(w<<2)>>2]|0}while((w|0)!=-1);w=c[s>>2]|0;r=v;while(1){y=r+1|0;if((y|0)==(w|0)){u=-1;v=w;continue c}x=c[(c[p>>2]|0)+(y<<2)>>2]|0;if((x|0)==-1)r=y;else{u=x;v=y;continue c}}}v=c[m>>2]|0;if(v){m=c[e>>2]|0;u=0;do{__(a,c[m+(u<<2)>>2]|0);u=u+1|0}while(u>>>0<v>>>0)}v=a+16|0;u=(b[((c[a+3372>>2]&4|0)==0?a+1232|0:a+3348|0)>>1]&4096)==0;m=a+3612|0;p=a+3616|0;s=c[p>>2]|0;if(s){q=s;do{q=q+-1|0;s=c[(c[m>>2]|0)+(q<<2)>>2]|0;if(s)ko[c[(c[s>>2]|0)+60>>2]&4095](s)}while((q|0)!=0)}c[p>>2]=0;O3(v);if(!u)ko[c[(c[a>>2]|0)+404>>2]&4095](a);NTa(c[a+3836>>2]|0);u=c[n>>2]|0;if((u&2147483647|0)!=0&(u|0)>-1?(u=c[e>>2]|0,(u|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,u)}sTa(a+3844|0);c[a+3788>>2]=443968;c[a+3796>>2]=0;c[a+3760>>2]=443968;c[a+3768>>2]=0;c[a+3732>>2]=443968;c[a+3740>>2]=0;c[a+3708>>2]=443968;c[a+3716>>2]=0;c[a+3684>>2]=443968;c[a+3692>>2]=0;u=c[a+3676>>2]|0;if((u&2147483647|0)!=0&(u|0)>-1?(u=c[a+3668>>2]|0,(u|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,u)}u=a+3652|0;HTa(c[u>>2]|0);e=c[u>>2]|0;if(e){u=mKa()|0;In[c[(c[u>>2]|0)+12>>2]&4095](u,e)}e=a+3648|0;HTa(c[e>>2]|0);u=c[e>>2]|0;if(u){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,u)}u=c[a+3644>>2]|0;if((u&2147483647|0)!=0&(u|0)>-1?(u=c[j>>2]|0,(u|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,u)}u=c[a+3632>>2]|0;if((u&2147483647|0)!=0&(u|0)>-1?(u=c[h>>2]|0,(u|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,u)}u=c[a+3620>>2]|0;if((u&2147483647|0)!=0&(u|0)>-1?(u=c[m>>2]|0,(u|0)!=0):0){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,u)}u=c[o>>2]|0;if(u)VJa(o,u);u=c[a+3568>>2]|0;do if((u&2147483647|0)!=0&(u|0)>-1){o=c[g>>2]|0;if(!o)break;m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,o)}while(0);g=c[a+3556>>2]|0;do if((g&2147483647|0)!=0&(g|0)>-1){u=c[l>>2]|0;if(!u)break;o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,u)}while(0);l=c[a+3544>>2]|0;do if((l&2147483647|0)!=0&(l|0)>-1){g=c[k>>2]|0;if(!g)break;u=mKa()|0;In[c[(c[u>>2]|0)+12>>2]&4095](u,g)}while(0);k=c[a+3532>>2]|0;if(!((k&2147483647|0)!=0&(k|0)>-1)){A=a+3460|0;gWa(A);c[a>>2]=439128;B=a+3376|0;nCa(B);dWa(v);i=d;return}k=c[a+3524>>2]|0;if(!k){A=a+3460|0;gWa(A);c[a>>2]=439128;B=a+3376|0;nCa(B);dWa(v);i=d;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,k);A=a+3460|0;gWa(A);c[a>>2]=439128;B=a+3376|0;nCa(B);dWa(v);i=d;return}function __(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+3592>>2]|0;a:do if((e|0)!=0?(f=b,g=f+~(f<<15)|0,f=(g>>>10^g)*9|0,g=f>>>6^f,f=g+~(g<<11)|0,g=(c[a+3584>>2]|0)+((e+-1&(f>>>16^f))<<2)|0,f=c[g>>2]|0,(f|0)!=-1):0){h=c[a+3576>>2]|0;j=a+3580|0;k=f;f=g;while(1){if((c[h+(k<<2)>>2]|0)==(b|0))break;g=(c[j>>2]|0)+(k<<2)|0;l=c[g>>2]|0;if((l|0)==-1)break a;else{k=l;f=g}}if((k|0)!=-1){h=(c[j>>2]|0)+(k<<2)|0;c[f>>2]=c[h>>2];g=a+3608|0;c[g>>2]=(c[g>>2]|0)+-1;g=a+3604|0;c[g>>2]=(c[g>>2]|0)+1;g=a+3600|0;c[h>>2]=c[g>>2];c[g>>2]=k}}while(0);if(!b){i=d;return}ko[c[(c[b>>2]|0)+60>>2]&4095](b);i=d;return}function $_(d){d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;if(b[((c[d+3372>>2]&4|0)==0?d+1232|0:d+3348|0)>>1]&4096)co[c[(c[d>>2]|0)+400>>2]&2047](d,440080,225);if((a[d+3656>>0]|0)==0?(a[d+3657>>0]|0)==0:0){g=c[108764]|0;_Y(g,d);i=e;return}dKa(bKa()|0,8,440080,233,440152,f);xo[c[(c[d>>2]|0)+236>>2]&2047](d,1,0)|0;g=c[108764]|0;_Y(g,d);i=e;return}function a$(a){a=a|0;return a+-16|0}function b$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+48|0;f=c[e>>2]|0;if(f)if((c[a+3544>>2]&2147483647)>>>0<f>>>0){hWa(a+3536|0,f);g=c[e>>2]|0}else g=f;else g=0;sca(a+32|0,g,c[b+52>>2]|0,c[b+56>>2]|0,c[b+60>>2]|0,c[b+64>>2]|0);c[a+4>>2]=c[b+128>>2];i=d;return 1}function c$(b,d){b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[d>>2]);if(!(a[b+2432>>0]|0)){g[b+64>>2]=f;g[b+68>>2]=ea(g[d+4>>2]);g[b+72>>2]=ea(g[d+8>>2]);c[b+76>>2]=1;i=e;return}else{g[b+3332>>2]=f;g[b+3336>>2]=ea(g[d+4>>2]);g[b+3340>>2]=ea(g[d+8>>2]);d=b+3372|0;c[d>>2]=c[d>>2]|1;i=e;return}}function d$(a,b){a=a|0;b=b|0;var d=0;d=i;if(!(c[b+3372>>2]&1)){g[a>>2]=ea(g[b+64>>2]);g[a+4>>2]=ea(g[b+68>>2]);g[a+8>>2]=ea(g[b+72>>2]);i=d;return}else{g[a>>2]=ea(g[b+3332>>2]);g[a+4>>2]=ea(g[b+3336>>2]);g[a+8>>2]=ea(g[b+3340>>2]);i=d;return}}function e$(b,d){b=b|0;d=ea(d);var e=0,f=0;e=i;if(!(a[b+2432>>0]|0)){Hca(b+32|0,d);i=e;return}else{g[b+3344>>2]=d;f=b+3372|0;c[f>>2]=c[f>>2]|2;i=e;return}}function f$(a){a=a|0;var b=0,d=Im;b=i;if(!(c[a+3372>>2]&2)){d=ea(Ica(a+32|0));i=b;return ea(d)}else{d=ea(g[a+3344>>2]);i=b;return ea(d)}return ea(0.0)}function g$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b>>2]|0;if(e)if((c[a+3544>>2]&2147483647)>>>0<e>>>0){hWa(a+3536|0,e);f=c[b>>2]|0}else f=e;else f=0;e=a+32|0;g=b+8|0;h=b+12|0;sca(e,f,c[b+4>>2]|0,c[g>>2]|0,c[h>>2]|0,c[b+16>>2]|0);gca(e,b);mCa(a+3376|0,c[g>>2]|0,c[h>>2]|0);i=d;return}function h$(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Lda(b+32|0)|0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];c[a+20>>2]=c[e+20>>2];c[a+24>>2]=c[e+24>>2];c[a+28>>2]=c[e+28>>2];i=d;return}function i$(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;h=d+3372|0;j=c[h>>2]|0;k=d+3348|0;l=d+1232|0;m=b[((j&4|0)==0?l:k)>>1]|0;if(f)n=(m&65535|e)&65535;else n=m&((e^65535)&65535);if(!(a[d+2433>>0]|0)){e=d+32|0;b[l>>1]=n;jca(e,(n&512)!=0);kca(e,(n&2048)==0);i=g;return}else{b[k>>1]=n;c[h>>2]=j|4;i=g;return}}function j$(a,d){a=a|0;d=d|0;var e=0;e=i;if(!(c[d+3372>>2]&4)){b[a>>1]=b[d+1232>>1]|0;i=e;return}else{b[a>>1]=b[d+3348>>1]|0;i=e;return}}function k$(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;f=d;g=c[a+1216>>2]|0;h=a+1208|0;j=c[h>>2]|0;k=c[h+4>>2]|0;Dn[c[(c[g>>2]|0)+8>>2]&511](g,48,j,k);h=(c[b+((c[427044+((e[b+4>>1]|0)<<2)>>2]|0)+4)>>2]|0)>>>30;if(!h)l=3;else if((h|0)==3?(KU(b)|0)==(a|0):0)l=3;else l=4;if((l|0)==3){l$(a,b);m=c[g>>2]|0;n=m+12|0;o=c[n>>2]|0;Dn[o&511](g,48,j,k);i=d;return}else if((l|0)==4){dKa(bKa()|0,8,440080,355,440256,f);m=c[g>>2]|0;n=m+12|0;o=c[n>>2]|0;Dn[o&511](g,48,j,k);i=d;return}}function l$(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;h=f+8|0;j=f+4|0;switch(e[d+4>>1]|0){case 15:{dKa(bKa()|0,2,440080,408,440400,g);i=f;return}case 5:{n$(a,d);i=f;return}case 10:{h4(a+16|0,d+20|0);k=a+3636|0;c[j>>2]=d;l=a+3640|0;m=c[l>>2]|0;if((c[a+3644>>2]&2147483647)>>>0<=m>>>0){jWa(k,j)|0;i=f;return}j=(c[k>>2]|0)+(m<<2)|0;if(j)c[j>>2]=d;c[l>>2]=m+1;i=f;return}case 12:{f4(a+16|0,d+20|0);m=a+3624|0;c[g>>2]=d;l=a+3628|0;j=c[l>>2]|0;if((c[a+3632>>2]&2147483647)>>>0<=j>>>0){iWa(m,g)|0;i=f;return}k=(c[m>>2]|0)+(j<<2)|0;if(k)c[k>>2]=d;c[l>>2]=j+1;i=f;return}case 6:{if(!(b[d+24>>1]|0))dKa(bKa()|0,2,440080,366,440336,g);m$(a,d);i=f;return}case 11:{f4(a+16|0,d+20|0);g=a+3624|0;c[h>>2]=d;j=a+3628|0;l=c[j>>2]|0;if((c[a+3632>>2]&2147483647)>>>0<=l>>>0){iWa(g,h)|0;i=f;return}h=(c[g>>2]|0)+(l<<2)|0;if(h)c[h>>2]=d;c[j>>2]=l+1;i=f;return}default:{i=f;return}}}function m$(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;In[c[(c[d>>2]|0)+52>>2]&4095](f,d);h=(b[f>>1]&8)!=0;S3(a+16|0,d+48|0,h);F2(d+20|0,d);if(!h?(c[d+16>>2]|0)!=0:0)IU(d+12|0);h=a+3536|0;f=a+3540|0;c[d+36>>2]=c[f>>2];c[g>>2]=d;j=c[f>>2]|0;if((c[a+3544>>2]&2147483647)>>>0<=j>>>0){kWa(h,g)|0;i=e;return}g=(c[h>>2]|0)+(j<<2)|0;if(g)c[g>>2]=d;c[f>>2]=j+1;i=e;return}function n$(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;In[c[(c[d>>2]|0)+52>>2]&4095](f,d);h=(b[f>>1]&8)!=0;U3(a+16|0,d+48|0,h);F2(d+20|0,d);if(!h?(c[d+16>>2]|0)!=0:0)IU(d+12|0);h=a+3536|0;f=a+3540|0;c[d+36>>2]=c[f>>2];c[g>>2]=d;j=c[f>>2]|0;if((c[a+3544>>2]&2147483647)>>>0<=j>>>0){kWa(h,g)|0;i=e;return}g=(c[h>>2]|0)+(j<<2)|0;if(g)c[g>>2]=d;c[f>>2]=j+1;i=e;return}function o$(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;l=d+3376|0;m=d+16|0;c[f>>2]=m;d=f+4|0;c[d>>2]=c[d>>2]&1073741823|-2147483648;d=b[g+4>>1]|0;if(d<<16>>16!=1)if(!(d<<16>>16)){i=k;return}else n=c[g>>2]|0;else n=g;f=g+8|0;o=g+12|0;g=d&65535;d=0;do{p=n+(d<<2)|0;q=c[p>>2]|0;r=a[q+112>>0]|0;fTa(q+16|0)|0;if(k2(q)|0){c[q+32>>2]=m;s=q+36|0;c[s>>2]=c[s>>2]&1073741823|-2147483648}if(r&2){if(!(r&5))t=0;else t=j+(d*24|0)|0;r=pCa(l,c[p>>2]|0,e,h,t)|0;if((b[o>>1]|0)==1)u=f;else u=c[f>>2]|0;c[u+(d<<2)>>2]=r}d=d+1|0}while((d|0)!=(g|0));i=k;return}function p$(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+256|0;j=h;k=h+224|0;l=h+16|0;m=h+8|0;n=h+4|0;o=c[d+1216>>2]|0;p=d+1208|0;q=c[p>>2]|0;r=c[p+4>>2]|0;Dn[c[(c[o>>2]|0)+8>>2]&511](o,48,q,r);if(a[d+3656>>0]|0){dKa(bKa()|0,2,440080,456,440488,j);s=c[o>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](o,48,q,r);i=h;return}p=d+32|0;_da(p,k);c[k+12>>2]=64;c[k+16>>2]=20;c[k+20>>2]=64;c[k+24>>2]=20;c[k+28>>2]=o2()|0;v=l+192|0;w=l+196|0;c[l+200>>2]=0;x=l+204|0;a[v>>0]=1;c[w>>2]=l;c[x>>2]=8;a:do if(g){y=d+3536|0;z=d+3540|0;A=d+3544|0;B=0;b:while(1){C=B+1|0;D=C>>>0<g>>>0;if(D){E=c[f+(C<<2)>>2]|0;F=E;G=VEi(F|0,0,6)|0;I=H;J=_Ei(F|0,0,287,0)|0;F=VEi(J|0,H|0,6)|0;J=H;K=ZEi(1,0,G|0,I|0)|0;I=_Ei(K|0,H|0,F|0,J|0)|0;J=I;I=H;F=E;while(1){J=_Ei(J|0,I|0,-1,-1)|0;I=H;if((J|0)==0&(I|0)==0)break;else F=F+64|0}}F=f+(B<<2)|0;I=c[F>>2]|0;J=b[I+4>>1]|0;E=(c[I+((c[427044+((J&65535)<<2)>>2]|0)+4)>>2]|0)>>>30;if((E|0)==3){if((KU(I)|0)!=(d|0)){L=10;break}}else if(E){L=10;break}c:do switch(J<<16>>16){case 6:{E=c[F>>2]|0;I=E+48|0;K=c[E+52>>2]|0;if(!(K&1))M=(c[450992+((K>>>24&15)<<2)>>2]|0)+I+8|0;else{G=E+56|0;N=c[G>>2]|0;if(!N){O=s4(c[I>>2]|0,K>>>24&15)|0;c[G>>2]=O;P=O}else P=N;M=P}if(b[M>>1]&8){m$(d,E);break c}lWa(l,e[E+24>>1]|0);aea(p,E,k,c[w>>2]|0);o$(d,E,I,E+20|0,0,c[w>>2]|0);c[E+36>>2]=c[z>>2];c[m>>2]=E;I=c[z>>2]|0;if((c[A>>2]&2147483647)>>>0>I>>>0){N=(c[y>>2]|0)+(I<<2)|0;if(N)c[N>>2]=E;c[z>>2]=I+1}else kWa(y,m)|0;if(c[E+16>>2]|0)IU(E+12|0);break}case 5:{E=c[F>>2]|0;I=E+48|0;N=c[E+52>>2]|0;if(!(N&1))Q=(c[450992+((N>>>24&15)<<2)>>2]|0)+I+8|0;else{O=E+56|0;G=c[O>>2]|0;if(!G){K=s4(c[I>>2]|0,N>>>24&15)|0;c[O>>2]=K;R=K}else R=G;Q=R}if(b[Q>>1]&8){n$(d,E);break c}lWa(l,e[E+24>>1]|0);bea(p,E,k,c[w>>2]|0);o$(d,E,I,E+20|0,1,c[w>>2]|0);c[E+36>>2]=c[z>>2];c[n>>2]=E;I=c[z>>2]|0;if((c[A>>2]&2147483647)>>>0>I>>>0){G=(c[y>>2]|0)+(I<<2)|0;if(G)c[G>>2]=E;c[z>>2]=I+1}else kWa(y,n)|0;if(c[E+16>>2]|0)IU(E+12|0);break}case 12:case 11:case 10:{l$(d,c[F>>2]|0);break}default:{L=42;break b}}while(0);if(D)B=C;else{L=45;break a}}if((L|0)==10)dKa(bKa()|0,8,440080,485,440552,j);else if((L|0)==42)dKa(bKa()|0,2,440080,526,440632,j);cea(p,k);if(B){y=0;do{q$(d,c[f+(y<<2)>>2]|0,0,1);y=y+1|0}while((y|0)!=(B|0))}}else L=45;while(0);if((L|0)==45)cea(p,k);k=c[x>>2]|0;if(!((k&2147483647|0)!=0&(k|0)>-1)){s=c[o>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](o,48,q,r);i=h;return}k=c[w>>2]|0;if((l|0)==(k|0)){a[v>>0]=0;s=c[o>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](o,48,q,r);i=h;return}if(!k){s=c[o>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](o,48,q,r);i=h;return}v=mKa()|0;In[c[(c[v>>2]|0)+12>>2]&4095](v,k);s=c[o>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](o,48,q,r);i=h;return}function q$(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;switch(mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0){case 2:{g4(a+16|0,b+20|0,0);h=a+3628|0;j=c[h>>2]|0;if(!j){i=f;return}k=c[a+3624>>2]|0;l=0;while(1){m=l+1|0;if((c[k+(l<<2)>>2]|0)==(b|0)){n=l;break}if(m>>>0<j>>>0)l=m;else{n=m;break}}if((n|0)==(j|0)){i=f;return}l=j+-1|0;c[h>>2]=l;c[k+(n<<2)>>2]=c[k+(l<<2)>>2];i=f;return}case 4:{dKa(bKa()|0,2,440080,696,440728,g);i=f;return}case 1:{v$(a,b,d,e);i=f;return}case 3:{g4(a+16|0,b+20|0,0);g=a+3628|0;l=c[g>>2]|0;if(!l){i=f;return}k=c[a+3624>>2]|0;n=0;while(1){h=n+1|0;if((c[k+(n<<2)>>2]|0)==(b|0)){o=n;break}if(h>>>0<l>>>0)n=h;else{o=h;break}}if((o|0)==(l|0)){i=f;return}n=l+-1|0;c[g>>2]=n;c[k+(o<<2)>>2]=c[k+(n<<2)>>2];i=f;return}case 5:{i4(a+16|0,b+20|0);n=a+3640|0;k=c[n>>2]|0;if(!k){i=f;return}o=c[a+3636>>2]|0;g=0;while(1){l=g+1|0;if((c[o+(g<<2)>>2]|0)==(b|0)){p=g;break}if(l>>>0<k>>>0)g=l;else{p=l;break}}if((p|0)==(k|0)){i=f;return}g=k+-1|0;c[n>>2]=g;c[o+(p<<2)>>2]=c[o+(g<<2)>>2];i=f;return}case 0:{u$(a,b,d,e);i=f;return}default:{i=f;return}}}function r$(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;h=i;i=i+560|0;j=h;k=h+8|0;l=h+554|0;m=h+552|0;n=d+16|0;o=c[d+1216>>2]|0;p=d+1208|0;q=c[p>>2]|0;r=c[p+4>>2]|0;Dn[c[(c[o>>2]|0)+8>>2]&511](o,49,q,r);p=d+32|0;s=d+3540|0;Bda(p,c[s>>2]|0,f);t=k+256|0;u=k+260|0;v=k+264|0;c[v>>2]=0;w=k+268|0;a[t>>0]=1;c[u>>2]=k;c[w>>2]=64;x=k+528|0;y=k+532|0;z=k+536|0;c[z>>2]=0;A=k+540|0;a[x>>0]=1;c[y>>2]=k+272;c[A>>2]=64;B=d+1276|0;c[B>>2]=k;a:do if(f){C=d+3536|0;D=d+3376|0;E=d+3536|0;F=0;b:while(1){G=F;F=F+1|0;I=F>>>0<f>>>0;if(I){J=c[e+(F<<2)>>2]|0;K=J;L=VEi(K|0,0,6)|0;M=H;N=_Ei(K|0,0,287,0)|0;K=VEi(N|0,H|0,6)|0;N=H;O=ZEi(1,0,L|0,M|0)|0;M=_Ei(O|0,H|0,K|0,N|0)|0;N=M;M=H;K=J;while(1){N=_Ei(N|0,M|0,-1,-1)|0;M=H;if((N|0)==0&(M|0)==0)break;else K=K+64|0}}K=e+(G<<2)|0;M=c[K>>2]|0;N=b[M+4>>1]|0;if((d|0)!=(mo[c[(c[M>>2]|0)+28>>2]&4095](M)|0)){P=7;break}c[v>>2]=0;c[z>>2]=0;c:do switch(N<<16>>16){case 5:{M=c[K>>2]|0;In[c[(c[M>>2]|0)+52>>2]&4095](m,M);J=M+20|0;O=b[J+4>>1]|0;if(O<<16>>16==1){Q=J;P=24}else if(O<<16>>16){Q=c[J>>2]|0;P=24}if((P|0)==24){P=0;O=c[Q>>2]|0;L=O;R=VEi(L|0,0,6)|0;S=H;T=_Ei(L|0,0,207,0)|0;L=VEi(T|0,H|0,6)|0;T=H;U=ZEi(1,0,R|0,S|0)|0;S=_Ei(U|0,H|0,L|0,T|0)|0;T=S;S=H;L=O;while(1){T=_Ei(T|0,S|0,-1,-1)|0;S=H;if((T|0)==0&(S|0)==0)break;else L=L+64|0}}L=M+48|0;Vda(p,M+64|0);S=c[(c[C>>2]|0)+((c[s>>2]|0)+-1<<2)>>2]|0;T=S;O=VEi(T|0,0,6)|0;U=H;R=_Ei(T|0,0,287,0)|0;T=VEi(R|0,H|0,6)|0;R=H;V=ZEi(1,0,O|0,U|0)|0;U=_Ei(V|0,H|0,T|0,R|0)|0;R=U;U=H;T=S;while(1){R=_Ei(R|0,U|0,-1,-1)|0;U=H;if((R|0)==0&(U|0)==0)break;else T=T+64|0}if(!(b[m>>1]&8))HU(M+12|0);z2(J,D);V3(n,L,g,(b[(c[450992+(((c[M+52>>2]|0)>>>24&15)<<2)>>2]|0)+L+8>>1]&8)!=0);T=M+36|0;U=(c[s>>2]|0)+-1|0;R=c[T>>2]|0;c[s>>2]=U;S=c[E>>2]|0;c[S+(R<<2)>>2]=c[S+(U<<2)>>2];if((U|0)!=0?(S=c[T>>2]|0,(U|0)!=(S|0)):0){U=c[(c[E>>2]|0)+(S<<2)>>2]|0;S=mo[c[(c[U>>2]|0)+24>>2]&4095](U)|0;if(!S){c[U+36>>2]=c[T>>2];break c}else if((S|0)==1){c[U+36>>2]=c[T>>2];break c}else break c}break}case 6:{T=c[K>>2]|0;In[c[(c[T>>2]|0)+52>>2]&4095](l,T);U=T+20|0;S=b[U+4>>1]|0;if(S<<16>>16==1){W=U;P=11}else if(S<<16>>16){W=c[U>>2]|0;P=11}if((P|0)==11){P=0;S=c[W>>2]|0;R=S;V=VEi(R|0,0,6)|0;O=H;X=_Ei(R|0,0,207,0)|0;R=VEi(X|0,H|0,6)|0;X=H;Y=ZEi(1,0,V|0,O|0)|0;O=_Ei(Y|0,H|0,R|0,X|0)|0;X=O;O=H;R=S;while(1){X=_Ei(X|0,O|0,-1,-1)|0;O=H;if((X|0)==0&(O|0)==0)break;else R=R+64|0}}R=T+48|0;Uda(p,T+64|0);O=c[(c[C>>2]|0)+((c[s>>2]|0)+-1<<2)>>2]|0;X=O;M=VEi(X|0,0,6)|0;L=H;J=_Ei(X|0,0,287,0)|0;X=VEi(J|0,H|0,6)|0;J=H;S=ZEi(1,0,M|0,L|0)|0;L=_Ei(S|0,H|0,X|0,J|0)|0;J=L;L=H;X=O;while(1){J=_Ei(J|0,L|0,-1,-1)|0;L=H;if((J|0)==0&(L|0)==0)break;else X=X+64|0}if(!(b[l>>1]&8))HU(T+12|0);z2(U,D);T3(n,R,g,(b[(c[450992+(((c[T+52>>2]|0)>>>24&15)<<2)>>2]|0)+R+8>>1]&8)!=0);X=T+36|0;L=(c[s>>2]|0)+-1|0;J=c[X>>2]|0;c[s>>2]=L;O=c[E>>2]|0;c[O+(J<<2)>>2]=c[O+(L<<2)>>2];if((L|0)!=0?(O=c[X>>2]|0,(L|0)!=(O|0)):0){L=c[(c[E>>2]|0)+(O<<2)>>2]|0;O=mo[c[(c[L>>2]|0)+24>>2]&4095](L)|0;if(!O){c[L+36>>2]=c[X>>2];break c}else if((O|0)==1){c[L+36>>2]=c[X>>2];break c}else break c}break}case 12:case 11:case 10:{q$(d,c[K>>2]|0,g,1);break}default:{P=37;break b}}while(0);if(!I)break a}if((P|0)==7){E=bKa()|0;c[j>>2]=440696;dKa(E,8,440080,92,445328,j);break}else if((P|0)==37){dKa(bKa()|0,2,440080,634,440728,j);break}}while(0);c[B>>2]=0;B=c[A>>2]|0;do if((B&2147483647|0)!=0&(B|0)>-1){A=c[y>>2]|0;if((k+272|0)==(A|0)){a[x>>0]=0;break}if(A){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,A)}}while(0);x=c[w>>2]|0;if(!((x&2147483647|0)!=0&(x|0)>-1)){Z=c[o>>2]|0;_=Z+12|0;$=c[_>>2]|0;Dn[$&511](o,49,q,r);i=h;return}x=c[u>>2]|0;if((k|0)==(x|0)){a[t>>0]=0;Z=c[o>>2]|0;_=Z+12|0;$=c[_>>2]|0;Dn[$&511](o,49,q,r);i=h;return}if(!x){Z=c[o>>2]|0;_=Z+12|0;$=c[_>>2]|0;Dn[$&511](o,49,q,r);i=h;return}t=mKa()|0;In[c[(c[t>>2]|0)+12>>2]&4095](t,x);Z=c[o>>2]|0;_=Z+12|0;$=c[_>>2]|0;Dn[$&511](o,49,q,r);i=h;return}function s$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+3540|0;f=(c[e>>2]|0)+-1|0;g=c[b>>2]|0;c[e>>2]=f;e=a+3536|0;a=c[e>>2]|0;c[a+(g<<2)>>2]=c[a+(f<<2)>>2];if(!f){i=d;return}a=c[b>>2]|0;if((f|0)==(a|0)){i=d;return}f=c[(c[e>>2]|0)+(a<<2)>>2]|0;a=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;if((a|0)==1){c[f+36>>2]=c[b>>2];i=d;return}else if(!a){c[f+36>>2]=c[b>>2];i=d;return}else{i=d;return}}function t$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[a+1216>>2]|0;h=a+1208|0;j=c[h>>2]|0;k=c[h+4>>2]|0;Dn[c[(c[g>>2]|0)+8>>2]&511](g,49,j,k);if((a|0)==(mo[c[(c[b>>2]|0)+28>>2]&4095](b)|0)){q$(a,b,d,1);l=c[g>>2]|0;m=l+12|0;n=c[m>>2]|0;Dn[n&511](g,49,j,k);i=e;return}else{d=bKa()|0;c[f>>2]=440816;dKa(d,8,440080,92,445328,f);l=c[g>>2]|0;m=l+12|0;n=c[m>>2]|0;Dn[n&511](g,49,j,k);i=e;return}}function u$(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g;In[c[(c[d>>2]|0)+52>>2]&4095](h,d);j=(b[h>>1]&8)==0;if(f?(mo[c[(c[d>>2]|0)+80>>2]&4095](d)|0)!=0:0)TU(mo[c[(c[d>>2]|0)+80>>2]&4095](d)|0,d,0)|0;z2(d+20|0,a+3376|0);if(j)HU(d+12|0);j=d+48|0;T3(a+16|0,j,e,(b[(c[450992+(((c[d+52>>2]|0)>>>24&15)<<2)>>2]|0)+j+8>>1]&8)!=0);j=d+36|0;d=a+3540|0;e=(c[d>>2]|0)+-1|0;f=c[j>>2]|0;c[d>>2]=e;d=a+3536|0;a=c[d>>2]|0;c[a+(f<<2)>>2]=c[a+(e<<2)>>2];if(!e){i=g;return}a=c[j>>2]|0;if((e|0)==(a|0)){i=g;return}e=c[(c[d>>2]|0)+(a<<2)>>2]|0;a=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;if(!a){c[e+36>>2]=c[j>>2];i=g;return}else if((a|0)==1){c[e+36>>2]=c[j>>2];i=g;return}else{i=g;return}}function v$(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g;In[c[(c[d>>2]|0)+52>>2]&4095](h,d);j=(b[h>>1]&8)==0;if(f?(mo[c[(c[d>>2]|0)+80>>2]&4095](d)|0)!=0:0)TU(mo[c[(c[d>>2]|0)+80>>2]&4095](d)|0,d,0)|0;z2(d+20|0,a+3376|0);if(j)HU(d+12|0);j=d+48|0;V3(a+16|0,j,e,(b[(c[450992+(((c[d+52>>2]|0)>>>24&15)<<2)>>2]|0)+j+8>>1]&8)!=0);j=d+36|0;d=a+3540|0;e=(c[d>>2]|0)+-1|0;f=c[j>>2]|0;c[d>>2]=e;d=a+3536|0;a=c[d>>2]|0;c[a+(f<<2)>>2]=c[a+(e<<2)>>2];if(!e){i=g;return}a=c[j>>2]|0;if((e|0)==(a|0)){i=g;return}e=c[(c[d>>2]|0)+(a<<2)>>2]|0;a=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;if((a|0)==1){c[e+36>>2]=c[j>>2];i=g;return}else if(!a){c[e+36>>2]=c[j>>2];i=g;return}else{i=g;return}}function w$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i4(a+16|0,b+20|0);e=a+3640|0;f=c[e>>2]|0;if(!f){i=d;return}g=c[a+3636>>2]|0;a=0;while(1){h=a+1|0;if((c[g+(a<<2)>>2]|0)==(b|0)){j=a;break}if(h>>>0<f>>>0)a=h;else{j=h;break}}if((j|0)==(f|0)){i=d;return}a=f+-1|0;c[e>>2]=a;c[g+(j<<2)>>2]=c[g+(a<<2)>>2];i=d;return}function x$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=(c[b+16>>2]|0)>>>30;if(!f)g=3;else if((f|0)==3?(P3(c[b+12>>2]|0)|0)==(a|0):0)g=3;else g=4;if((g|0)==3){y$(a,b);i=d;return}else if((g|0)==4){dKa(bKa()|0,8,440080,850,440848,e);i=d;return}}function y$(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+80|0;f=e;h=e+36|0;j=e+24|0;k=e+16|0;l=e+64|0;m=e+4|0;n=e+48|0;o=e+60|0;p=mo[c[(c[d>>2]|0)+108>>2]&4095](d)|0;q=c[c[d+88>>2]>>2]|0;if(ea(Kn[c[(c[q>>2]|0)+132>>2]&255](q))==ea(0.0)){dKa(bKa()|0,2,440080,864,440944,f);Fn[c[(c[q>>2]|0)+128>>2]&255](q,ea(1.0))}In[c[(c[q>>2]|0)+144>>2]&4095](h,q);if(!((!(ea(g[h>>2])==ea(0.0))?!(ea(g[h+4>>2])==ea(0.0)):0)?!(ea(g[h+8>>2])==ea(0.0)):0)){dKa(bKa()|0,2,440080,871,441048,f);h=c[(c[q>>2]|0)+140>>2]|0;g[j>>2]=ea(1.0);g[j+4>>2]=ea(1.0);g[j+8>>2]=ea(1.0);In[h&4095](q,j)}if((((ea(g[q+252>>2])==ea(0.0)?ea(g[q+256>>2])==ea(0.0):0)?ea(g[q+260>>2])==ea(0.0):0)?ea(g[q+264>>2])==ea(0.0):0)?ea(g[q+268>>2])==ea(0.0):0)r=ea(g[q+272>>2])!=ea(0.0);else r=1;j=b+16|0;U3(j,q+48|0,0);F2(q+20|0,q);Y3(j,d+12|0);h=mo[c[(c[q>>2]|0)+228>>2]&4095](q)|0;if(h)_3(j,h+8|0);if(c[q+16>>2]|0)IU(q+12|0);h=p<<2;s=h>>>0>1024;t=k+4|0;a[t>>0]=s&1;if(s){s=sKa(l,h,440080,887)|0;c[k>>2]=s;u=s}else{s=i;i=i+((1*h|0)+15&-16)|0;c[k>>2]=s;u=s}c[u>>2]=q;q=p+-1|0;if(!q)v=r;else{p=n+4|0;u=n+8|0;s=m+4|0;h=m+8|0;l=0;w=r;r=1;while(1){x=c[(c[k>>2]|0)+(l<<2)>>2]|0;if(!(c[x+324>>2]|0))y=0;else y=c[x+320>>2]|0;if(!(mo[c[(c[x>>2]|0)+232>>2]&4095](x)|0)){z=w;A=r}else{B=0;C=w;D=r;while(1){E=c[y+(B<<2)>>2]|0;if(ea(Kn[c[(c[E>>2]|0)+132>>2]&255](E))==ea(0.0)){dKa(bKa()|0,2,440080,903,440944,f);Fn[c[(c[E>>2]|0)+128>>2]&255](E,ea(1.0))}In[c[(c[E>>2]|0)+144>>2]&4095](m,E);F=ea(g[m>>2])==ea(0.0);G=F|ea(g[s>>2])==ea(0.0);if(G|ea(g[h>>2])==ea(0.0)){dKa(bKa()|0,2,440080,910,441048,f);G=c[(c[E>>2]|0)+140>>2]|0;g[n>>2]=ea(1.0);g[p>>2]=ea(1.0);g[u>>2]=ea(1.0);In[G&4095](E,n)}do if(((!C?ea(g[E+252>>2])==ea(0.0):0)?ea(g[E+256>>2])==ea(0.0):0)?ea(g[E+260>>2])==ea(0.0):0){if(!(ea(g[E+264>>2])==ea(0.0))){H=1;break}if(!(ea(g[E+268>>2])==ea(0.0))){H=1;break}H=ea(g[E+272>>2])!=ea(0.0)}else H=1;while(0);U3(j,E+48|0,0);F2(E+20|0,E);G=mo[c[(c[E>>2]|0)+228>>2]&4095](E)|0;if(G)_3(j,G+8|0);if(c[E+16>>2]|0)IU(E+12|0);c[(c[k>>2]|0)+(D<<2)>>2]=E;G=D+1|0;B=B+1|0;if(B>>>0>=(mo[c[(c[x>>2]|0)+232>>2]&4095](x)|0)>>>0){z=H;A=G;break}else{C=H;D=G}}}l=l+1|0;if((l|0)==(q|0)){v=z;break}else{w=z;r=A}}}if(!(ea(g[d+60>>2])!=ea(0.0)|v^1))BV(d,1,0);v=b+3548|0;c[o>>2]=d;A=b+3552|0;r=c[A>>2]|0;if((c[b+3556>>2]&2147483647)>>>0>r>>>0){b=(c[v>>2]|0)+(r<<2)|0;if(b)c[b>>2]=d;c[A>>2]=r+1}else yVa(v,o)|0;if(!(a[t>>0]|0)){i=e;return}tKa(k,c[k>>2]|0);i=e;return}function z$(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+16|0;U3(e,b+48|0,0);F2(b+20|0,b);a=mo[c[(c[b>>2]|0)+228>>2]&4095](b)|0;if(a)_3(e,a+8|0);if(!(c[b+16>>2]|0)){i=d;return}IU(b+12|0);i=d;return}function A$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;if((a|0)==(mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0)){B$(a,b,d,1);i=e;return}else{d=bKa()|0;c[f>>2]=441168;dKa(d,8,440080,92,445328,f);i=e;return}}function B$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+16|0;h=g;j=g+8|0;k=mo[c[(c[d>>2]|0)+108>>2]&4095](d)|0;if(f?(mo[c[(c[d>>2]|0)+128>>2]&4095](d)|0)!=0:0)WU(mo[c[(c[d>>2]|0)+128>>2]&4095](d)|0,d,0)|0;f=k<<2;l=f>>>0>1024;m=h+4|0;a[m>>0]=l&1;if(l){l=sKa(j,f,440080,963)|0;c[h>>2]=l;n=l}else{l=i;i=i+((1*f|0)+15&-16)|0;c[h>>2]=l;n=l}c[n>>2]=c[c[d+88>>2]>>2];n=k+-1|0;if(n){l=0;f=1;while(1){j=c[(c[h>>2]|0)+(l<<2)>>2]|0;if(!(c[j+324>>2]|0))o=0;else o=c[j+320>>2]|0;if(!(mo[c[(c[j>>2]|0)+232>>2]&4095](j)|0))p=f;else{q=0;r=f;while(1){c[(c[h>>2]|0)+(r<<2)>>2]=c[o+(q<<2)>>2];s=r+1|0;q=q+1|0;if(q>>>0>=(mo[c[(c[j>>2]|0)+232>>2]&4095](j)|0)>>>0){p=s;break}else r=s}}l=l+1|0;if((l|0)==(n|0))break;else f=p}}if((k|0)>0){p=b+3376|0;f=b+16|0;n=k;do{n=n+-1|0;k=c[(c[h>>2]|0)+(n<<2)>>2]|0;l=mo[c[(c[k>>2]|0)+228>>2]&4095](k)|0;HU(k+12|0);z2(k+20|0,p);if(l)$3(f,l+8|0);V3(f,k+48|0,e,0)}while((n|0)>0);t=f}else t=b+16|0;Z3(t,d+12|0);t=b+3552|0;f=c[t>>2]|0;if(f){n=c[b+3548>>2]|0;b=0;while(1){e=b+1|0;if((c[n+(b<<2)>>2]|0)==(d|0)){u=b;break}if(e>>>0<f>>>0)b=e;else{u=e;break}}if((u|0)!=(f|0)){b=f+-1|0;c[t>>2]=b;c[n+(u<<2)>>2]=c[n+(b<<2)>>2]}}if(!(a[m>>0]|0)){i=g;return}tKa(h,c[h>>2]|0);i=g;return}function C$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=d+4|0;g=a+16|0;h=c[a+1216>>2]|0;j=a+1208|0;k=c[j>>2]|0;l=c[j+4>>2]|0;Dn[c[(c[h>>2]|0)+8>>2]&511](h,50,k,l);j=b+8|0;m=(c[b+12>>2]|0)>>>30;if((m|0)==3){if((P3(c[j>>2]|0)|0)!=(a|0))n=11}else if(m)n=11;if((n|0)==11){dKa(bKa()|0,8,440080,1058,441216,e);o=c[h>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](h,50,k,l);i=d;return}a4(g,j);j=c[b+36>>2]|0;if(j){g=b+40|0;e=0;do{RU(b,c[(c[g>>2]|0)+(e<<2)>>2]|0,a);e=e+1|0}while((e|0)!=(j|0))}j=a+3560|0;c[f>>2]=b;e=a+3564|0;g=c[e>>2]|0;if((c[a+3568>>2]&2147483647)>>>0<=g>>>0){vVa(j,f)|0;o=c[h>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](h,50,k,l);i=d;return}f=(c[j>>2]|0)+(g<<2)|0;if(f)c[f>>2]=b;c[e>>2]=g+1;o=c[h>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](h,50,k,l);i=d;return}function D$(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=f;h=a+16|0;j=c[a+1216>>2]|0;k=a+1208|0;l=c[k>>2]|0;m=c[k+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,51,l,m);k=mo[c[(c[b>>2]|0)+52>>2]&4095](b)|0;if((a|0)!=(k|0)){n=bKa()|0;c[g>>2]=441304;dKa(n,8,440080,92,445328,g);o=c[j>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](j,51,l,m);i=f;return}if((mo[c[(c[b>>2]|0)+52>>2]&4095](b)|0)!=(k|0)){o=c[j>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](j,51,l,m);i=f;return}k=c[b+36>>2]|0;if(!k)r=b+8|0;else{g=b+40|0;n=b+8|0;s=0;do{t=c[(c[g>>2]|0)+(s<<2)>>2]|0;if((mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0)==4){if(mo[c[(c[t>>2]|0)+28>>2]&4095](t)|0){u=c[t+288>>2]|0;v=c[u+88>>2]|0;if(mo[c[(c[u>>2]|0)+108>>2]&4095](u)|0){w=0;do{u3(n,(c[v+(w<<2)>>2]|0)+48|0,0);w=w+1|0}while(w>>>0<(mo[c[(c[u>>2]|0)+108>>2]&4095](u)|0)>>>0)}B$(a,u,d,0)}}else{u3(n,t+(c[427044+((e[t+4>>1]|0)<<2)>>2]|0)|0,0);q$(a,t,d,0)}s=s+1|0}while((s|0)!=(k|0));r=n}b4(h,r);r=a+3564|0;h=c[r>>2]|0;if(!h){o=c[j>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](j,51,l,m);i=f;return}n=c[a+3560>>2]|0;a=0;while(1){k=a+1|0;if((c[n+(a<<2)>>2]|0)==(b|0)){x=a;break}if(k>>>0<h>>>0)a=k;else{x=k;break}}if((x|0)==(h|0)){o=c[j>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](j,51,l,m);i=f;return}a=h+-1|0;c[r>>2]=a;c[n+(x<<2)>>2]=c[n+(a<<2)>>2];o=c[j>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](j,51,l,m);i=f;return}function E$(a){a=a|0;return c[a+3564>>2]|0}function F$(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[a+3564>>2]|0)-e|0;h=(g|0)<0?0:g;j=h>>>0<d>>>0?h:d;if(!j){i=f;return j|0}h=a+3560|0;a=~d;d=(g|0)>0?~g:-1;g=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[h>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(g|0));i=f;return j|0}function G$(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[d+80>>2]|0;if(!f){i=e;return}g=d+48|0;d=0;do{h=c[(c[g>>2]|0)+(d<<4)>>2]|0;switch(b[h+4>>1]|0){case 5:{if(!(mo[c[(c[h>>2]|0)+80>>2]&4095](h)|0))In[c[(c[a>>2]|0)+44>>2]&4095](a,h);break}case 6:{if(!(mo[c[(c[h>>2]|0)+80>>2]&4095](h)|0))In[c[(c[a>>2]|0)+44>>2]&4095](a,h);break}case 10:{if(!(mo[c[(c[h>>2]|0)+80>>2]&4095](h)|0))In[c[(c[a>>2]|0)+44>>2]&4095](a,h);break}case 11:{if(!(mo[c[(c[h>>2]|0)+80>>2]&4095](h)|0))In[c[(c[a>>2]|0)+44>>2]&4095](a,h);break}case 12:{if(!(mo[c[(c[h>>2]|0)+80>>2]&4095](h)|0))In[c[(c[a>>2]|0)+44>>2]&4095](a,h);break}case 14:{if(!(mo[c[(c[h>>2]|0)+128>>2]&4095](h)|0))In[c[(c[a>>2]|0)+36>>2]&4095](a,h);break}case 13:{In[c[(c[a>>2]|0)+60>>2]&4095](a,h);break}default:{}}d=d+1|0}while((d|0)!=(f|0));i=e;return}function H$(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b[d>>1]|0;if((f&1)!=0?(d=c[a+3540>>2]|0,(d|0)!=0):0){g=c[a+3536>>2]|0;h=d;d=0;while(1){h=h+-1|0;j=c[g+(h<<2)>>2]|0;k=(((j|0)==0?1:(b[j+4>>1]|0)!=6)&1^1)+d|0;if(!h){l=k;break}else d=k}}else l=0;if((f&2)!=0?(d=c[a+3540>>2]|0,(d|0)!=0):0){h=c[a+3536>>2]|0;g=d;d=l;while(1){g=g+-1|0;k=c[h+(g<<2)>>2]|0;j=(((k|0)==0?1:(b[k+4>>1]|0)!=5)&1^1)+d|0;if(!g){m=j;break}else d=j}}else m=l;if((f&4)!=0?(l=c[a+3628>>2]|0,(l|0)!=0):0){d=c[a+3624>>2]|0;g=0;h=m;while(1){j=c[d+(g<<2)>>2]|0;k=(((j|0)==0?1:(b[j+4>>1]|0)!=11)&1^1)+h|0;g=g+1|0;if(g>>>0>=l>>>0){n=k;break}else h=k}}else n=m;if((f&8)!=0?(m=c[a+3628>>2]|0,(m|0)!=0):0){h=c[a+3624>>2]|0;l=0;g=n;while(1){d=c[h+(l<<2)>>2]|0;k=(((d|0)==0?1:(b[d+4>>1]|0)!=12)&1^1)+g|0;l=l+1|0;if(l>>>0>=m>>>0){o=k;break}else g=k}}else o=n;if(!(f&32)){p=o;i=e;return p|0}p=(c[a+3640>>2]|0)+o|0;i=e;return p|0}function I$(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=i;j=b[d>>1]|0;a:do if((j&3)!=0?(d=c[a+3540>>2]|0,(d|0)!=0&(f|0)!=0):0){k=a+3536|0;if(!(j&1)){l=0;m=0;n=0;while(1){if((j&2)!=0?(o=c[(c[k>>2]|0)+(l<<2)>>2]|0,!((o|0)==0?1:(b[o+4>>1]|0)!=5)):0){if(m>>>0<g>>>0)p=n;else{c[e+(n<<2)>>2]=o;p=n+1|0}q=m+1|0;r=p}else{q=m;r=n}l=l+1|0;if(!(l>>>0<d>>>0&r>>>0<f>>>0)){s=q;t=r;break a}else{m=q;n=r}}}else{u=0;v=0;w=0}while(1){n=c[(c[k>>2]|0)+(u<<2)>>2]|0;if((n|0)==0?1:(b[n+4>>1]|0)!=6)if((j&2)!=0?(m=c[(c[k>>2]|0)+(u<<2)>>2]|0,!((m|0)==0?1:(b[m+4>>1]|0)!=5)):0){if(v>>>0<g>>>0)x=w;else{c[e+(w<<2)>>2]=m;x=w+1|0}y=v+1|0;z=x}else{y=v;z=w}else{if(v>>>0<g>>>0)A=w;else{c[e+(w<<2)>>2]=n;A=w+1|0}y=v+1|0;z=A}u=u+1|0;if(!(u>>>0<d>>>0&z>>>0<f>>>0)){s=y;t=z;break}else{v=y;w=z}}}else{s=0;t=0}while(0);b:do if((j&12)!=0?(z=c[a+3628>>2]|0,(z|0)!=0&t>>>0<f>>>0):0){w=a+3624|0;if(!(j&4)){y=0;v=s;u=t;while(1){if((j&8)!=0?(A=c[(c[w>>2]|0)+(y<<2)>>2]|0,!((A|0)==0?1:(b[A+4>>1]|0)!=12)):0){if(v>>>0<g>>>0)B=u;else{c[e+(u<<2)>>2]=A;B=u+1|0}C=v+1|0;D=B}else{C=v;D=u}y=y+1|0;if(!(y>>>0<z>>>0&D>>>0<f>>>0)){E=C;F=D;break b}else{v=C;u=D}}}else{G=0;H=s;I=t}while(1){u=c[(c[w>>2]|0)+(G<<2)>>2]|0;if((u|0)==0?1:(b[u+4>>1]|0)!=11)if((j&8)!=0?(v=c[(c[w>>2]|0)+(G<<2)>>2]|0,!((v|0)==0?1:(b[v+4>>1]|0)!=12)):0){if(H>>>0<g>>>0)J=I;else{c[e+(I<<2)>>2]=v;J=I+1|0}K=H+1|0;L=J}else{K=H;L=I}else{if(H>>>0<g>>>0)M=I;else{c[e+(I<<2)>>2]=u;M=I+1|0}K=H+1|0;L=M}G=G+1|0;if(!(G>>>0<z>>>0&L>>>0<f>>>0)){E=K;F=L;break}else{H=K;I=L}}}else{E=s;F=t}while(0);if(!(j&32)){N=F;i=h;return N|0}j=c[a+3640>>2]|0;if(!((j|0)!=0&F>>>0<f>>>0)){N=F;i=h;return N|0}t=a+3636|0;a=0;s=E;E=F;while(1){if(s>>>0<g>>>0)O=E;else{c[e+(E<<2)>>2]=c[(c[t>>2]|0)+(a<<2)>>2];O=E+1|0}a=a+1|0;if(!(a>>>0<j>>>0&O>>>0<f>>>0)){N=O;break}else{s=s+1|0;E=O}}i=h;return N|0}function J$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;if(!(a[b+2432>>0]|0)){g=pea(b+32|0,d,e)|0;i=f;return g|0}else{dKa(bKa()|0,2,444208,795,445232,f);c[d>>2]=0;g=0;i=f;return g|0}return 0}function K$(a){a=a|0;return c[a+3552>>2]|0}function L$(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[a+3552>>2]|0)-e|0;h=(g|0)<0?0:g;j=h>>>0<d>>>0?h:d;if(!j){i=f;return j|0}h=a+3548|0;a=~d;d=(g|0)>0?~g:-1;g=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[h>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(g|0));i=f;return j|0}function M$(a){a=a|0;return c[a+3528>>2]|0}function N$(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[a+3528>>2]|0)-e|0;h=(g|0)<0?0:g;j=h>>>0<d>>>0?h:d;if(!j){i=f;return j|0}h=a+3524|0;a=~d;d=(g|0)>0?~g:-1;g=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[h>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(g|0));i=f;return j|0}function O$(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;if(!(a[b+3656>>0]|0)){d=b+3460|0;i=c;return d|0}dKa(bKa()|0,2,440080,1378,441344,c);d=b+3460|0;i=c;return d|0}function P$(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+240|0;e=d+128|0;f=d+104|0;h=d+72|0;j=d+32|0;k=d;c[b+3468>>2]=0;c[b+3480>>2]=0;c[b+3492>>2]=0;c[b+3504>>2]=0;c[b+3516>>2]=0;if(ea(Um[c[(c[b>>2]|0)+296>>2]&63](b,0))==ea(0.0)){i=d;return}l=b+3460|0;m=e+36|0;n=e+0|0;o=n+36|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));g[m>>2]=ea(1.0);m=e+40|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[e+56>>2]=ea(1.0);m=e+60|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[e+76>>2]=ea(1.0);m=e+80|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[e+96>>2]=ea(1.0);c[e+100>>2]=l;p=ea(Um[c[(c[b>>2]|0)+296>>2]&63](b,1));if(p!=ea(0.0)){g[f>>2]=p;g[f+4>>2]=p;g[f+8>>2]=p;c[f+12>>2]=-65536;c[f+16>>2]=-16711936;c[f+20>>2]=-16776961;JKa(e,f)|0}f=b+3552|0;if(c[f>>2]|0){l=b+3548|0;m=0;do{LV(c[(c[l>>2]|0)+(m<<2)>>2]|0,e,b);m=m+1|0}while(m>>>0<(c[f>>2]|0)>>>0)}f=c[b+3536>>2]|0;m=c[b+3540>>2]|0;l=f+(m<<2)|0;n=b+3640|0;if(c[n>>2]|0){o=b+3636|0;q=0;do{r=c[(c[o>>2]|0)+(q<<2)>>2]|0;co[c[(c[r>>2]|0)+492>>2]&2047](r,e,b);q=q+1|0}while(q>>>0<(c[n>>2]|0)>>>0)}if(m){m=f;do{f=c[m>>2]|0;n=(mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0)==1;f=c[m>>2]|0;if(n)H_(f,e,b);else U_(f,e,b);m=m+4|0}while((m|0)!=(l|0))}l=ea(Um[c[(c[b>>2]|0)+296>>2]&63](b,18))!=ea(0.0);m=ea(Um[c[(c[b>>2]|0)+296>>2]&63](b,19))!=ea(0.0);if(l?(l=c[b+3388>>2]|0,(l|0)!=0):0)co[c[(c[l>>2]|0)+48>>2]&2047](l,e,-16776961);if(m?(m=c[b+3392>>2]|0,(m|0)!=0):0)co[c[(c[m>>2]|0)+48>>2]&2047](m,e,-65536);if(!(ea(Um[c[(c[b>>2]|0)+296>>2]&63](b,36))!=ea(0.0))){i=d;return}g[h>>2]=ea(0.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);g[h+12>>2]=ea(1.0);g[h+16>>2]=ea(0.0);g[h+20>>2]=ea(0.0);g[h+24>>2]=ea(0.0);FKa(e,h)|0;h=b+16|0;b=v4(h)|0;if(!b){i=d;return}m=j+36|0;l=k+4|0;f=j+4|0;n=k+8|0;q=j+8|0;o=k+12|0;r=j+12|0;s=k+16|0;t=j+16|0;u=k+20|0;v=j+20|0;w=k+24|0;x=0;do{w4(h,j,1,x)|0;if(!(a[m>>0]|0))DKa(e,-16777216)|0;else DKa(e,-256)|0;g[k>>2]=ea(g[j>>2]);g[l>>2]=ea(g[f>>2]);g[n>>2]=ea(g[q>>2]);g[o>>2]=ea(g[r>>2]);g[s>>2]=ea(g[t>>2]);g[u>>2]=ea(g[v>>2]);a[w>>0]=1;HKa(e,k)|0;x=x+1|0}while((x|0)!=(b|0));i=d;return}function Q$(b,c){b=b|0;c=c|0;var d=0;d=i;i=i+16|0;if(!(a[b+3656>>0]|0)){Qda(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,440080,1468,441416,d);i=d;return}}function R$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+3664|0;c[f>>2]=(c[f>>2]|0)+1;f=b+3360|0;a[e>>0]=-1;g=b+3364|0;h=c[g>>2]|0;if((c[b+3368>>2]&2147483647)>>>0>h>>>0){j=(c[f>>2]|0)+h|0;if(!j)k=h;else{a[j>>0]=-1;k=c[g>>2]|0}c[g>>2]=k+1}else mWa(f,e)|0;if(!(a[b+2433>>0]|0)){l=qea(b+32|0)|0;i=d;return l|0}else{e=b+3356|0;c[e>>2]=(c[e>>2]|0)+1;l=(c[g>>2]|0)+255&255;i=d;return l|0}return 0}function S$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=a[e>>0]|0;if(!(a[b+2433>>0]|0)){a[g>>0]=h;rea(b+32|0,d,g);i=f;return}else{a[(c[b+3360>>2]|0)+(d&255)>>0]=h;h=b+3372|0;c[h>>2]=c[h>>2]|32;i=f;return}}function T$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if((c[d+3372>>2]&32|0)!=0?(g=a[(c[d+3360>>2]|0)+(e&255)>>0]|0,g<<24>>24!=-1):0){a[b>>0]=g;i=f;return}Dda(b,d+32|0,e);i=f;return}function U$(a,b){a=a|0;b=b|0;var c=0;c=i;ica(a+32|0,b);i=c;return}function V$(a){a=a|0;var b=0,c=0;b=i;c=Kca(a+32|0)|0;i=b;return c|0}function W$(b,c){b=b|0;c=ea(c);var d=0;d=i;i=i+16|0;if(!(a[b+2433>>0]|0)){sea(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,444208,852,444912,d);i=d;return}}function X$(a){a=a|0;var b=0,c=Im;b=i;c=ea(tea(a+32|0));i=b;return ea(c)}function Y$(b,c){b=b|0;c=ea(c);var d=0;d=i;i=i+16|0;if(!(a[b+2433>>0]|0)){uea(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,444208,869,444800,d);i=d;return}}function Z$(a){a=a|0;var b=0,c=Im;b=i;c=ea(vea(a+32|0));i=b;return ea(c)}function _$(b,c){b=b|0;c=c|0;var d=0;d=i;i=i+16|0;if(!(a[b+2433>>0]|0)){wea(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,444208,886,444688,d);i=d;return}}function $$(a){a=a|0;var b=0,c=0;b=i;c=xea(a+32|0)|0;i=b;return c|0}function a0(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=i;i=i+16|0;if(!(a[b+2433>>0]|0)){lca(b+32|0,c,d);i=e;return}else{dKa(bKa()|0,2,444208,564,444584,e);i=e;return}}function b0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Qca(a+32|0,b)|0;i=c;return d|0}function c0(b,c){b=b|0;c=c|0;var d=0;d=i;i=i+16|0;if(!(a[b+2433>>0]|0)){mca(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,444208,577,444480,d);i=d;return}}function d0(a){a=a|0;var b=0,c=0;b=i;c=Rca(a+32|0)|0;i=b;return c|0}function e0(b,c){b=b|0;c=c|0;var d=0;d=i;i=i+16|0;if(!(a[b+2433>>0]|0)){nca(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,444208,590,444480,d);i=d;return}}function f0(a){a=a|0;var b=0,c=0;b=i;c=Sca(a+32|0)|0;i=b;return c|0}function g0(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=i;i=i+16|0;if(!(a[b+2433>>0]|0)){hca(b+32|0,c,d);i=e;return}else{dKa(bKa()|0,2,444208,616,444384,e);i=e;return}}function h0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Uca(a+32|0,b)|0;i=c;return d|0}function i0(b,c){b=b|0;c=c|0;var d=0;d=i;i=i+16|0;if(!(a[b+2433>>0]|0)){oca(b+32|0,c);i=d;return}else{dKa(bKa()|0,2,444208,603,444288,d);i=d;return}}function j0(a){a=a|0;var b=0,c=0;b=i;c=Tca(a+32|0)|0;i=b;return c|0}function k0(a){a=a|0;var b=0,c=0;b=i;c=t4(a+16|0)|0;i=b;return c|0}function l0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=u4(a+16|0,b)|0;i=c;return d|0}function m0(a){a=a|0;var b=0,c=0;b=i;c=v4(a+16|0)|0;i=b;return c|0}function n0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=w4(a+16|0,b,c,d)|0;i=e;return f|0}function o0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=0;d=i;i=i+16|0;e=ea(g[b>>2]);if(e>ea(g[b+12>>2])){dKa(bKa()|0,4,440080,1659,441520,d);f=-1;i=d;return f|0}else{f=x4(a+16|0,b,c)|0;i=d;return f|0}return 0}function p0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=y4(a+16|0,b)|0;i=c;return d|0}function q0(a){a=a|0;return c[a+1124>>2]|0}function r0(a){a=a|0;return c[a+1128>>2]|0}function s0(a){a=a|0;return c[a+1132>>2]|0}function t0(a){a=a|0;return c[a+1136>>2]|0}function u0(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;f=b;switch(e[d+4>>1]|0){case 12:{g=d+20|0;h=g+4|0;j=(c[h>>2]|0)>>>30;if((j|0)==2){k=c[g>>2]|0;if(!(a[k+2417>>0]|0))l=19;else{m=k;l=20}}else if((j|0)==3){m=c[g>>2]|0;l=20}else l=19;if((l|0)==19){kha(g+12|0);i=b;return}else if((l|0)==20){r4(m,g);c[h>>2]=c[h>>2]|65536;i=b;return}break}case 11:{h=d+20|0;g=h+4|0;m=(c[g>>2]|0)>>>30;if((m|0)==3){n=c[h>>2]|0;l=15}else if((m|0)==2?(m=c[h>>2]|0,(a[m+2417>>0]|0)!=0):0){n=m;l=15}else l=14;if((l|0)==14){kha(h+12|0);i=b;return}else if((l|0)==15){r4(n,h);c[g>>2]=c[g>>2]|65536;i=b;return}break}case 6:{nWa(d,d+48|0,0,0)|0;i=b;return}case 15:{pWa(d,d+48|0,0,0)|0;BV(c[d+288>>2]|0,0,1);i=b;return}case 5:{g=d+48|0;oWa(d,g,0,0)|0;if(!(c[d+284>>2]&4096))o=d+108|0;else{h=d+56|0;n=c[h>>2]|0;if(!n){l=s4(c[g>>2]|0,(c[d+52>>2]|0)>>>24&15)|0;c[h>>2]=l;p=l}else p=n;o=p+268|0}if(a[o>>0]&1){i=b;return}j_(d,g,0,1);i=b;return}default:{dKa(bKa()|0,4,440080,1750,441600,f);i=b;return}}}function v0(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;h=e[d+4>>1]|0;if((h|0)==6){nWa(d,d+48|0,f,g)|0;i=b;return}else if((h|0)==15){pWa(d,d+48|0,f,g)|0;BV(c[d+288>>2]|0,0,1);i=b;return}else if((h|0)==5){h=d+48|0;oWa(d,h,f,g)|0;if(!(c[d+284>>2]&4096))j=d+108|0;else{g=d+56|0;f=c[g>>2]|0;if(!f){k=s4(c[h>>2]|0,(c[d+52>>2]|0)>>>24&15)|0;c[g>>2]=k;l=k}else l=f;j=l+268|0}if(a[j>>0]&1){i=b;return}j_(d,h,0,1);i=b;return}else{i=b;return}}function w0(a){a=a|0;return c[108764]|0}function x0(d,e,f,h,j,k){d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;l=i;m=d+1216|0;if((a[536618]|0)!=0?(n=c[m>>2]|0,(n|0)!=0):0){o=d+1208|0;En[c[(c[n>>2]|0)+16>>2]&127](n,b[268308]|0,c[o>>2]|0,c[o+4>>2]|0,99999789)}P$(d);a[d+3656>>0]=1;a[d+3657>>0]=1;a[d+3658>>0]=1;g[d+3660>>2]=e;a[d+3848>>0]=1;o=d+16|0;n=c[m>>2]|0;p=d+1208|0;q=p;r=c[q>>2]|0;s=c[q+4>>2]|0;Dn[c[(c[n>>2]|0)+8>>2]&511](n,61,r,s);q=d+3528|0;if(c[q>>2]|0){t=d+3524|0;u=0;do{FX(c[(c[t>>2]|0)+(u<<2)>>2]|0);u=u+1|0}while(u>>>0<(c[q>>2]|0)>>>0)}Dn[c[(c[n>>2]|0)+12>>2]&511](n,61,r,s);j4(o,c[(mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0)+52>>2]|0);k4(o,e);a[d+2432>>0]=1;a[d+2433>>0]=1;Pda(d+32|0,h,j);j=c[m>>2]|0;h=p;o=c[h>>2]|0;s=c[h+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,62,o,s);if(k){h=c[m>>2]|0;m=p;p=c[m>>2]|0;r=c[m+4>>2]|0;Dn[c[(c[h>>2]|0)+8>>2]&511](h,63,p,r);m=d+3680|0;n=c[m>>2]|0;ko[c[(c[n>>2]|0)+28>>2]&4095](n);Dn[c[(c[h>>2]|0)+12>>2]&511](h,63,p,r);r=c[m>>2]|0;ko[c[(c[r>>2]|0)+32>>2]&4095](r);v=m}else v=d+3680|0;a[d+3816>>0]=k&1;k=d+3684|0;m=c[v>>2]|0;c[d+3700>>2]=1;c[d+3696>>2]=f;c[d+3692>>2]=m;if(!f){w=d+3732|0;x=c[v>>2]|0;y=d+3748|0;c[y>>2]=1;z=d+3744|0;c[z>>2]=k;A=d+3740|0;c[A>>2]=x;B=c[k>>2]|0;C=B+16|0;D=c[C>>2]|0;ko[D&4095](k);E=c[k>>2]|0;F=E+20|0;G=c[F>>2]|0;ko[G&4095](k);H=c[w>>2]|0;I=H+20|0;J=c[I>>2]|0;ko[J&4095](w);K=c[j>>2]|0;L=K+12|0;M=c[L>>2]|0;Dn[M&511](j,62,o,s);i=l;return}ko[c[(c[f>>2]|0)+16>>2]&4095](f);w=d+3732|0;x=c[v>>2]|0;y=d+3748|0;c[y>>2]=1;z=d+3744|0;c[z>>2]=k;A=d+3740|0;c[A>>2]=x;B=c[k>>2]|0;C=B+16|0;D=c[C>>2]|0;ko[D&4095](k);E=c[k>>2]|0;F=E+20|0;G=c[F>>2]|0;ko[G&4095](k);H=c[w>>2]|0;I=H+20|0;J=c[I>>2]|0;ko[J&4095](w);K=c[j>>2]|0;L=K+12|0;M=c[L>>2]|0;Dn[M&511](j,62,o,s);i=l;return}function y0(a,b,c,d,e,f){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;f=i;i=i+16|0;dKa(bKa()|0,32,440080,2017,441688,f);i=f;return}function z0(a,b,c,d,e){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;e=i;i=i+16|0;dKa(bKa()|0,32,440080,2062,441688,e);i=e;return}function A0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a+1216>>2]|0;f=a+1208|0;g=c[f>>2]|0;h=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,46,g,h);f=c[a+3648>>2]|0;if(b)j=KTa(f,-1)|0;else j=KTa(f,0)|0;Dn[c[(c[e>>2]|0)+12>>2]&511](e,46,g,h);i=d;return j|0}function B0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a+1216>>2]|0;f=a+1208|0;g=c[f>>2]|0;h=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,46,g,h);f=c[a+3652>>2]|0;if(b)j=KTa(f,-1)|0;else j=KTa(f,0)|0;Dn[c[(c[e>>2]|0)+12>>2]&511](e,46,g,h);i=d;return j|0}function C0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+144|0;e=d;f=d+8|0;g=c[b+1216>>2]|0;h=b+1208|0;j=c[h>>2]|0;k=c[h+4>>2]|0;Dn[c[(c[g>>2]|0)+8>>2]&511](g,110,j,k);h=b+32|0;b=Ida(h)|0;l=zca(h)|0;m=l+4|0;n=c[m>>2]|0;if(!n)o=b;else{p=0;q=b;while(1){b=c[(c[l>>2]|0)+(p<<2)>>2]|0;if((c[b+12>>2]&-1073741824|0)!=-1073741824){r=f+0|0;s=r+128|0;do{a[r>>0]=0;r=r+1|0}while((r|0)<(s|0));r=c[b+36>>2]|0;if(r){s=b+40|0;t=0;u=q;while(1){v=c[(c[s>>2]|0)+(t<<2)>>2]|0;w=mo[c[(c[v>>2]|0)+68>>2]&4095](v)|0;v=f+(w&255)|0;if(!(a[v>>0]|0)){a[v>>0]=1;v=Uca(h,w)|0;if(!v)x=1;else{In[c[(c[v>>2]|0)+12>>2]&4095](v,b);x=u}}else x=u;t=t+1|0;if((t|0)==(r|0)){y=x;break}else u=x}}else y=q}else y=q;p=p+1|0;if((p|0)==(n|0)){o=y;break}else q=y}}c[e>>2]=0;qWa(l,0,e);rWa(l,c[m>>2]|0);if(!o){Fda(h);z=c[g>>2]|0;A=z+12|0;B=c[A>>2]|0;Dn[B&511](g,110,j,k);i=d;return}dKa(bKa()|0,2,440080,2212,441728,e);Fda(h);z=c[g>>2]|0;A=z+12|0;B=c[A>>2]|0;Dn[B&511](g,110,j,k);i=d;return}function D0(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;h=d+3656|0;do if(!(a[h>>0]|0)){j=d+3658|0;if(a[j>>0]|0){k=c[d+1216>>2]|0;l=d+1208|0;m=c[l>>2]|0;n=c[l+4>>2]|0;Dn[c[(c[k>>2]|0)+8>>2]&511](k,46,m,n);l=c[d+3652>>2]|0;if(e)o=KTa(l,-1)|0;else o=KTa(l,0)|0;Dn[c[(c[k>>2]|0)+12>>2]&511](k,46,m,n);if(!o){p=0;i=g;return p|0}if(a[h>>0]|0){q=11;break}if(!(a[j>>0]|0))q=9}else q=9;if((q|0)==9?(a[d+3657>>0]|0)==0:0){p=0;i=g;return p|0}r=d+1208|0;s=d+1216|0}else q=11;while(0);if((q|0)==11){q=d+1216|0;o=c[q>>2]|0;j=d+1208|0;n=j;m=c[n>>2]|0;k=c[n+4>>2]|0;Dn[c[(c[o>>2]|0)+8>>2]&511](o,46,m,k);n=c[d+3648>>2]|0;if(e)t=KTa(n,-1)|0;else t=KTa(n,0)|0;Dn[c[(c[o>>2]|0)+12>>2]&511](o,46,m,k);if(t){r=j;s=q}else{p=0;i=g;return p|0}}q=d+16|0;j=c[s>>2]|0;t=r;k=c[t>>2]|0;m=c[t+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,47,k,m);t=d+32|0;Hda(t);q4(q);Lca(t);C0(d);Jda(t);a[d+2432>>0]=0;a[d+2433>>0]=0;o=c[s>>2]|0;n=r;e=c[n>>2]|0;l=c[n+4>>2]|0;Dn[c[(c[o>>2]|0)+8>>2]&511](o,113,e,l);p4(q,f);Dn[c[(c[o>>2]|0)+12>>2]&511](o,113,e,l);l=c[s>>2]|0;e=r;o=c[e>>2]|0;f=c[e+4>>2]|0;Dn[c[(c[l>>2]|0)+8>>2]&511](l,111,o,f);sCa(d+3376|0);Dn[c[(c[l>>2]|0)+12>>2]&511](l,111,o,f);f=c[s>>2]|0;o=r;l=c[o>>2]|0;e=c[o+4>>2]|0;Dn[c[(c[f>>2]|0)+8>>2]&511](f,112,l,e);Gda(t);Dn[c[(c[f>>2]|0)+12>>2]&511](f,112,l,e);rca(t);e=c[s>>2]|0;l=r;f=c[l>>2]|0;o=c[l+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,114,f,o);if(b[((c[d+3372>>2]&4|0)==0?d+1232|0:d+3348|0)>>1]&2)oea(t);Dn[c[(c[e>>2]|0)+12>>2]&511](e,114,f,o);sWa(d+3460|0,Aca(t)|0);if((a[h>>0]|0)!=0?(a[d+3816>>0]|0)!=0:0){t=c[d+3680>>2]|0;ko[c[(c[t>>2]|0)+36>>2]&4095](t)}a[h>>0]=0;a[d+3657>>0]=0;a[d+3658>>0]=0;ITa(c[d+3648>>2]|0);ITa(c[d+3652>>2]|0);if((a[536618]|0)!=0?(d=c[s>>2]|0,(d|0)!=0):0){s=r;En[c[(c[d>>2]|0)+20>>2]&127](d,b[268308]|0,c[s>>2]|0,c[s+4>>2]|0,99999789)}Dn[c[(c[j>>2]|0)+12>>2]&511](j,47,k,m);p=1;i=g;return p|0}function E0(d,e){d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;if(!(a[d+3656>>0]|0)){h=d+2504|0;b[g>>1]=0;tWa(h,0,g);uWa(h,c[d+2508>>2]|0);h=d+2516|0;c[g>>2]=0;vWa(h,0,g);wWa(h,c[d+2520>>2]|0);h=d+2528|0;c[g>>2]=0;xWa(h,0,g);yWa(h,c[d+2532>>2]|0);Mca(d+32|0,e);i=f;return}else{dKa(bKa()|0,2,440080,2341,441864,g);i=f;return}}function F0(b){b=b|0;var c=0;c=i;i=i+16|0;if(!(a[b+3656>>0]|0)){uCa(b+3376|0);i=c;return}else{dKa(bKa()|0,2,440080,2360,441976,c);i=c;return}}function G0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=c4(a+16|0,b+32|0)|0;i=c;return d|0}function H0(a,b){a=a|0;b=b|0;var c=0;c=i;d4(a+16|0,b+32|0);i=c;return}function I0(a,b){a=a|0;b=b|0;var c=0;c=i;e4(a+16|0,b+32|0);i=c;return}function J0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b+16|0;if(!(a[b+2433>>0]|0)){eea(b+32|0,d,e,f);i=h;return}k=d&255;l=e&255;if((d&255)<(e&255)){e=j+(k<<2)+3064|0;d=1<<l;c[e>>2]=c[e>>2]|d;m=d}else{d=j+(l<<2)+3064|0;c[d>>2]=c[d>>2]|1<<k;m=1<<l}d=ea(g[f>>2])!=ea(0.0);e=j+(k<<2)+3188|0;n=c[e>>2]|0;if(d)o=n|m;else o=n&~m;c[e>>2]=o;o=ea(g[f+4>>2])!=ea(0.0);f=j+(l<<2)+3188|0;l=c[f>>2]|0;j=1<<k;if(o)p=l|j;else p=l&~j;c[f>>2]=p;p=b+3372|0;c[p>>2]=c[p>>2]|8;i=h;return}function K0(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im;f=i;h=b+16|0;if(c[b+3372>>2]&8){j=d&255;k=e&255;if((d&255)<(e&255))l=c[h+(j<<2)+3064>>2]&1<<k;else l=c[h+(k<<2)+3064>>2]&1<<j;if(l){m=ea((c[h+(j<<2)+3188>>2]&1<<k)>>>k>>>0);n=ea((c[h+(k<<2)+3188>>2]&1<<j)>>>j>>>0);o=ea(m);m=ea(n);j=a;g[j>>2]=o;g[j+4>>2]=m;i=f;return}}fea(a,b+32|0,d,e);i=f;return}function L0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+3628|0;f=c[e>>2]|0;if(!f){i=d;return}g=c[a+3624>>2]|0;a=0;while(1){h=a+1|0;if((c[g+(a<<2)>>2]|0)==(b|0)){j=a;break}if(h>>>0<f>>>0)a=h;else{j=h;break}}if((j|0)==(f|0)){i=d;return}a=f+-1|0;c[e>>2]=a;c[g+(j<<2)>>2]=c[g+(a<<2)>>2];i=d;return}function M0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+4|0;h=f;j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,120,m?442928:544544,440080,2556)|0;J2(l,b+3376|0,d,e);c[h>>2]=l;l=zWa(b+3572|0,h,g)|0;b=c[h>>2]|0;if((a[g>>0]|0)!=0|(l|0)==0){i=f;return b|0}c[l>>2]=b;i=f;return b|0}function N0(a,b){a=a|0;b=b|0;var c=0;c=i;lCa(a+3376|0,b);i=c;return}function O0(a){a=a|0;return c[a+3448>>2]|0}function P0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;vCa(a+3376|0,b,c);i=d;return}function Q0(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+2433>>0]|0)){fca(b+32|0,d);i=e;return}else{c[b+3352>>2]=d;d=b+3372|0;c[d>>2]=c[d>>2]|16;i=e;return}}function R0(a){a=a|0;var b=0,d=0;b=i;if(!(c[a+3372>>2]&16)){d=gea(a+32|0)|0;i=b;return d|0}else{d=c[a+3352>>2]|0;i=b;return d|0}return 0}function S0(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0;f=i;i=i+16|0;h=f;if((d|0)>36){dKa(bKa()|0,4,440080,2609,442088,h);j=0;i=f;return j|0}if(e<ea(0.0)){dKa(bKa()|0,4,440080,2614,442144,h);j=0;i=f;return j|0}h=b+16|0;if(!(a[b+2433>>0]|0)){hea(b+32|0,d,e);j=1;i=f;return j|0}else{a[h+d+2996>>0]=1;g[h+(d<<2)+2848>>2]=e;d=b+3372|0;c[d>>2]=c[d>>2]|64;j=1;i=f;return j|0}return 0}function T0(b,d){b=b|0;d=d|0;var e=0,f=Im,h=0;e=i;i=i+16|0;if((d|0)>=37){dKa(bKa()|0,4,440080,2629,442208,e);f=ea(0.0);i=e;return ea(f)}h=b+16|0;if((c[b+3372>>2]&64|0)!=0?(a[h+d+2996>>0]|0)!=0:0){f=ea(g[h+(d<<2)+2848>>2]);i=e;return ea(f)}f=ea(Cda(b+32|0,d));i=e;return ea(f)}function U0(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+2433>>0]|0)){iea(b+32|0,d);i=e;return}else{a[b+3076>>0]=1;g[b+3052>>2]=ea(g[d>>2]);g[b+3056>>2]=ea(g[d+4>>2]);g[b+3060>>2]=ea(g[d+8>>2]);g[b+3064>>2]=ea(g[d+12>>2]);g[b+3068>>2]=ea(g[d+16>>2]);g[b+3072>>2]=ea(g[d+20>>2]);d=b+3372|0;c[d>>2]=c[d>>2]|64;i=e;return}}function V0(b){b=b|0;var d=0,e=0;d=i;if((c[b+3372>>2]&64|0)!=0?(a[b+3076>>0]|0)!=0:0){e=b+3052|0;i=d;return e|0}e=jea(b+32|0)|0;i=d;return e|0}function W0(a,b){a=a|0;b=b|0;var c=0;c=i;Mda(a+32|0,b);i=c;return}function X0(a){a=a|0;var b=0,c=0;b=i;c=Nda(a+32|0)|0;i=b;return c|0}function Y0(a){a=a|0;var b=0,c=0;b=i;c=Oda(a+32|0)|0;i=b;return c|0}function Z0(a){a=a|0;return c[a+92>>2]|0}function _0(a){a=a|0;return c[a+3396>>2]|0}function $0(a){a=a|0;var b=0,c=Im;b=i;c=ea(kea(a+32|0));i=b;return ea(c)}function a1(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+388>>2]&4095](a)|0;a=mo[c[(c[d>>2]|0)+16>>2]&4095](d)|0;i=b;return a|0}function b1(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+388>>2]&4095](a)|0;a=mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0;i=b;return a|0}function c1(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+388>>2]&4095](a)|0;a=mo[c[(c[d>>2]|0)+24>>2]&4095](d)|0;i=b;return a|0}function d1(a){a=a|0;return c[a+3440>>2]|0}function e1(a){a=a|0;return c[a+3444>>2]|0}function f1(a){a=a|0;var b=0,c=Im;b=i;c=ea(lea(a+32|0));i=b;return ea(c)}function g1(a){a=a|0;var b=0,c=Im;b=i;c=ea(mea(a+32|0));i=b;return ea(c)}function h1(a){a=a|0;var b=0,c=0;b=i;c=nea(a+32|0)|0;i=b;return c|0}function i1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;b=a+3836|0;e=OTa(c[b>>2]|0)|0;f=e>>>16;PTa(c[b>>2]|0,e&-16711681|(f<<16)+65536&16711680)|0;e=c[a+3840>>2]|0;if(!((e|0)!=(LTa()|0)&(f&255)<<24>>24==0)){i=d;return}tTa(a+3844|0);i=d;return}function j1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=a+3836|0;e=OTa(c[d>>2]|0)|0;f=e>>>16&255;if(!(f<<24>>24)){dKa(bKa()|0,8,440080,2899,442264,b);i=b;return}g=f+-1<<24>>24;PTa(c[d>>2]|0,e&-16711681|(g&255)<<16)|0;e=c[a+3840>>2]|0;if(!((e|0)!=(LTa()|0)&g<<24>>24==0)){i=b;return}vTa(a+3844|0);i=b;return}function k1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=a+3836|0;g=OTa(c[f>>2]|0)|0;h=g>>>24;j=h&255;if(!(j<<24>>24!=0|(g&16711680|0)==0)){k=bKa()|0;l=(b|0)!=0;dKa(k,8,l?b:440080,l?d:2920,442368,e);i=e;return}PTa(c[f>>2]|0,g&16777215|(h<<24)+16777216)|0;if(!(j<<24>>24))uTa(a+3844|0);c[a+3840>>2]=LTa()|0;i=e;return}function l1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=a+3836|0;e=OTa(c[d>>2]|0)|0;f=e>>>24&255;if(!(f<<24>>24)){dKa(bKa()|0,8,440080,2942,442496,b);i=b;return}g=f+-1<<24>>24;PTa(c[d>>2]|0,(g&255)<<24|e&16777215)|0;if(g<<24>>24){i=b;return}c[a+3840>>2]=0;wTa(a+3844|0);i=b;return}function m1(a){a=a|0;var b=Im;b=ea(g[a+2860>>2]);return ea(b)}function n1(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=Im,E=Im;e=i;i=i+16|0;f=e+4|0;h=b+16|0;if(a[b+2433>>0]|0){dKa(bKa()|0,2,440080,2994,442608,e);i=e;return}j=c[b+1216>>2]|0;k=b+1208|0;l=c[k>>2]|0;m=c[k+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,52,l,m);k=b+3536|0;n=c[b+3540>>2]|0;o=n>>>2;if(!o)p=0;else{q=o+-1|0;r=d+4|0;s=d+8|0;t=0;u=0;while(1){v=u+4|0;if(t>>>0>=q>>>0?v>>>0<n>>>0:0){w=v;while(1){x=w+1|0;if((x|0)==(n|0)){y=u;break}else w=x}}else y=u;do{w=c[(c[k>>2]|0)+(y<<2)>>2]|0;x=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;if((x|0)==1){z=ea(g[d>>2]);A=w+240|0;g[A>>2]=ea(ea(g[A>>2])-z);z=ea(g[r>>2]);A=w+244|0;g[A>>2]=ea(ea(g[A>>2])-z);z=ea(g[s>>2]);A=w+248|0;g[A>>2]=ea(ea(g[A>>2])-z);j9(w+64|0,d)}else if(!x){z=ea(g[d>>2]);x=w+96|0;g[x>>2]=ea(ea(g[x>>2])-z);z=ea(g[r>>2]);x=w+100|0;g[x>>2]=ea(ea(g[x>>2])-z);z=ea(g[s>>2]);x=w+104|0;g[x>>2]=ea(ea(g[x>>2])-z)}else{z=ea(g[d>>2]);x=w+240|0;g[x>>2]=ea(ea(g[x>>2])-z);z=ea(g[r>>2]);x=w+244|0;g[x>>2]=ea(ea(g[x>>2])-z);z=ea(g[s>>2]);x=w+248|0;g[x>>2]=ea(ea(g[x>>2])-z);j9(w+64|0,d)}y=y+1|0}while(y>>>0<v>>>0);t=t+1|0;if(t>>>0>=o>>>0)break;else u=v}p=o<<2}if(p>>>0<n>>>0){o=d+4|0;u=d+8|0;t=p;do{p=c[(c[k>>2]|0)+(t<<2)>>2]|0;y=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;if(!y){z=ea(g[d>>2]);s=p+96|0;g[s>>2]=ea(ea(g[s>>2])-z);z=ea(g[o>>2]);s=p+100|0;g[s>>2]=ea(ea(g[s>>2])-z);z=ea(g[u>>2]);s=p+104|0;g[s>>2]=ea(ea(g[s>>2])-z)}else if((y|0)==1){z=ea(g[d>>2]);y=p+240|0;g[y>>2]=ea(ea(g[y>>2])-z);z=ea(g[o>>2]);y=p+244|0;g[y>>2]=ea(ea(g[y>>2])-z);z=ea(g[u>>2]);y=p+248|0;g[y>>2]=ea(ea(g[y>>2])-z);j9(p+64|0,d)}else{z=ea(g[d>>2]);y=p+240|0;g[y>>2]=ea(ea(g[y>>2])-z);z=ea(g[o>>2]);y=p+244|0;g[y>>2]=ea(ea(g[y>>2])-z);z=ea(g[u>>2]);y=p+248|0;g[y>>2]=ea(ea(g[y>>2])-z);j9(p+64|0,d)}t=t+1|0}while((t|0)!=(n|0))}n=b+3552|0;if(c[n>>2]|0){t=b+3548|0;u=d+4|0;o=d+8|0;k=0;do{p=c[(c[t>>2]|0)+(k<<2)>>2]|0;y=c[p+88>>2]|0;if(mo[c[(c[p>>2]|0)+108>>2]&4095](p)|0){s=0;do{r=c[y+(s<<2)>>2]|0;q=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;if((q|0)==1){z=ea(g[d>>2]);w=r+240|0;g[w>>2]=ea(ea(g[w>>2])-z);z=ea(g[u>>2]);w=r+244|0;g[w>>2]=ea(ea(g[w>>2])-z);z=ea(g[o>>2]);w=r+248|0;g[w>>2]=ea(ea(g[w>>2])-z);j9(r+64|0,d)}else if(!q){z=ea(g[d>>2]);q=r+96|0;g[q>>2]=ea(ea(g[q>>2])-z);z=ea(g[u>>2]);q=r+100|0;g[q>>2]=ea(ea(g[q>>2])-z);z=ea(g[o>>2]);q=r+104|0;g[q>>2]=ea(ea(g[q>>2])-z)}else{z=ea(g[d>>2]);q=r+240|0;g[q>>2]=ea(ea(g[q>>2])-z);z=ea(g[u>>2]);q=r+244|0;g[q>>2]=ea(ea(g[q>>2])-z);z=ea(g[o>>2]);q=r+248|0;g[q>>2]=ea(ea(g[q>>2])-z);j9(r+64|0,d)}s=s+1|0}while(s>>>0<(mo[c[(c[p>>2]|0)+108>>2]&4095](p)|0)>>>0)}k=k+1|0}while(k>>>0<(c[n>>2]|0)>>>0)}o4(h,d);wCa(b+3376|0,d);h=b+3584|0;a:do if(c[b+3588>>2]|0){n=c[h>>2]|0;k=c[n>>2]|0;if((k|0)==-1){o=c[b+3592>>2]|0;u=0;while(1){t=u+1|0;if((t|0)==(o|0)){B=o;C=-1;break a}p=c[n+(t<<2)>>2]|0;if((p|0)==-1)u=t;else{B=t;C=p;break}}}else{B=0;C=k}}else{B=0;C=-1}while(0);u=b+3576|0;n=b+3580|0;o=b+3592|0;p=B;B=C;b:while(1){C=B;do{if((C|0)==-1)break b;$2(c[(c[u>>2]|0)+(C<<2)>>2]|0,d);C=c[(c[n>>2]|0)+(C<<2)>>2]|0}while((C|0)!=-1);C=c[o>>2]|0;k=p;while(1){t=k+1|0;if((t|0)==(C|0)){p=C;B=-1;continue b}s=c[(c[h>>2]|0)+(t<<2)>>2]|0;if((s|0)==-1)k=t;else{p=t;B=s;continue b}}}z=ea(-ea(g[d>>2]));D=ea(-ea(g[d+4>>2]));E=ea(-ea(g[d+8>>2]));g[f>>2]=z;g[f+4>>2]=D;g[f+8>>2]=E;rUa(b+3460|0,f);Dn[c[(c[j>>2]|0)+12>>2]&511](j,52,l,m);i=e;return}function o1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,152,j?442816:544544,440080,3145)|0;$W(h,a,b);c[e>>2]=h;b=a+3612|0;j=a+3616|0;f=c[j>>2]|0;if((c[a+3620>>2]&2147483647)>>>0<=f>>>0){AWa(b,e)|0;k=c[e>>2]|0;i=d;return k|0}e=(c[b>>2]|0)+(f<<2)|0;if(e)c[e>>2]=h;c[j>>2]=f+1;k=h;i=d;return k|0}function p1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+3616|0;f=c[e>>2]|0;if(f){g=c[a+3612>>2]|0;a=0;while(1){h=a+1|0;if((c[g+(a<<2)>>2]|0)==(b|0)){j=a;break}if(h>>>0<f>>>0)a=h;else{j=h;break}}if((j|0)!=(f|0)){a=f+-1|0;c[e>>2]=a;c[g+(j<<2)>>2]=c[g+(a<<2)>>2]}}if(!b){i=d;return}ko[c[(c[b>>2]|0)+60>>2]&4095](b);i=d;return}function q1(a,d,e,f,h,j,k,l,m){a=a|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;i=i+32|0;o=n;p=n+24|0;q=c[a+1216>>2]|0;r=a+1208|0;s=c[r>>2]|0;t=c[r+4>>2]|0;Dn[c[(c[q>>2]|0)+8>>2]&511](q,127,s,t);c[o>>2]=d;c[o+4>>2]=e;g[o+8>>2]=f;c[o+12>>2]=0;c[o+16>>2]=0;g[o+20>>2]=ea(0.0);b[p>>1]=b[j>>1]|0;j=r1(a,o,h,p,m,k,l,0)|0;Dn[c[(c[q>>2]|0)+12>>2]&511](q,127,s,t);i=n;return j|0}function r1(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0;n=i;i=i+80|0;o=n+4|0;p=n;q=k+16|0;r=b[q>>1]|0;if(!j)s=0;else{t=JU(c[j+4>>2]|0)|0;s=H2(t,c[j>>2]|0)|0}j=d+3376|0;uCa(j);t=f+68|0;a[t>>0]=0;u=f+80|0;c[u>>2]=0;v=ea(g[e+8>>2]);w=b[h>>1]|0;c[o>>2]=446160;c[o+4>>2]=d;c[o+8>>2]=e;c[o+12>>2]=f;b[o+16>>1]=w;c[o+20>>2]=k;c[o+24>>2]=l;l=o+28|0;g[l>>2]=v;c[o+32>>2]=m;a[o+36>>0]=1;a[o+68>>0]=0;c[o+72>>2]=0;m=o+41|0;a[m>>0]=0;k=(r&65535)>>>4&1;a[o+39>>0]=k;a[o+40>>0]=(w&64)!=0?1:k;k=b[q>>1]|0;w=(k&65535)>>>5&1;a[o+38>>0]=w;a[o+37>>0]=w;do if((s|0)!=0?(c[f+76>>2]|0)==0:0){w=qCa(j,CCa(s)|0)|0;a[m>>0]=1;r=BWa(o,p,w,1)|0;a[m>>0]=0;if(!r)if(!(a[t>>0]|0)){x=16;break}else{x=17;break}else{y=b[q>>1]|0;x=8;break}}else{y=k;x=8}while(0);do if((x|0)==8){k=c[d+3388>>2]|0;q=c[d+3392>>2]|0;m=y&65535;p=m&2;if((m&1|0)!=0?!(Bn[c[(c[k>>2]|0)+16>>2]&255](k,c[e>>2]|0,c[e+4>>2]|0,l,o)|0):0)if(!(a[t>>0]|0)){x=16;break}else{x=17;break}if(!p)z=1;else z=(Bn[c[(c[q>>2]|0)+16>>2]&255](q,c[e>>2]|0,c[e+4>>2]|0,l,o)|0)&1;q=a[t>>0]|0;if(!(q<<24>>24))A=(c[u>>2]|0)!=0;else A=1;if(z<<24>>24){p=c[u>>2]|0;if(!(q<<24>>24)){B=A;C=p;break}else{D=A;E=p;x=19;break}}else{F=A;G=c[f>>2]|0;H=G+4|0;I=c[H>>2]|0;ko[I&4095](f);i=n;return F|0}}while(0);if((x|0)==16){A=c[u>>2]|0;B=(A|0)!=0;C=A}else if((x|0)==17){D=1;E=c[u>>2]|0;x=19}if((x|0)==19){if(!E){F=D;G=c[f>>2]|0;H=G+4|0;I=c[H>>2]|0;ko[I&4095](f);i=n;return F|0}x=c[f+72>>2]|0;v=ea(g[f+44>>2]);A=0;z=E;while(1){t=x+(A<<6)+40|0;if(ea(g[t>>2])>v){o=z+-1|0;l=b[x+(o<<6)+12>>1]|0;J=ea(g[x+(o<<6)+16>>2]);K=ea(g[x+(o<<6)+20>>2]);L=ea(g[x+(o<<6)+24>>2]);M=ea(g[x+(o<<6)+28>>2]);N=ea(g[x+(o<<6)+32>>2]);O=ea(g[x+(o<<6)+36>>2]);P=ea(g[x+(o<<6)+40>>2]);aFi(x+(A<<6)|0,x+(o<<6)|0,12)|0;b[x+(A<<6)+12>>1]=l;g[x+(A<<6)+16>>2]=J;g[x+(A<<6)+20>>2]=K;g[x+(A<<6)+24>>2]=L;g[x+(A<<6)+28>>2]=M;g[x+(A<<6)+32>>2]=N;g[x+(A<<6)+36>>2]=O;g[t>>2]=P;aFi(x+(A<<6)+44|0,x+(o<<6)+44|0,20)|0;Q=o}else Q=z;A=A+1|0;if((A|0)==(E|0))break;else z=Q}c[u>>2]=Q;B=D;C=Q}if(!C){F=B;G=c[f>>2]|0;H=G+4|0;I=c[H>>2]|0;ko[I&4095](f);i=n;return F|0}if(!(xo[c[c[f>>2]>>2]&2047](f,c[f+72>>2]|0,C)|0)){F=B;G=c[f>>2]|0;H=G+4|0;I=c[H>>2]|0;ko[I&4095](f);i=n;return F|0}c[u>>2]=0;F=B;G=c[f>>2]|0;H=G+4|0;I=c[H>>2]|0;ko[I&4095](f);i=n;return F|0}function s1(a,d,e,f,h,j){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+32|0;l=k;m=k+24|0;n=c[a+1216>>2]|0;o=a+1208|0;p=c[o>>2]|0;q=c[o+4>>2]|0;Dn[c[(c[n>>2]|0)+8>>2]&511](n,128,p,q);c[l+12>>2]=d;c[l+16>>2]=e;g[l+20>>2]=ea(0.0);c[l+4>>2]=0;c[l>>2]=0;b[m>>1]=0;e=t1(a,l,f,m,0,h,j,0)|0;Dn[c[(c[n>>2]|0)+12>>2]&511](n,128,p,q);i=k;return e|0}function t1(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;n=i;i=i+288|0;o=n+208|0;p=n;q=k+16|0;r=b[q>>1]|0;if(!j)s=0;else{t=JU(c[j+4>>2]|0)|0;s=H2(t,c[j>>2]|0)|0}j=d+3376|0;uCa(j);t=f+20|0;a[t>>0]=0;u=f+32|0;c[u>>2]=0;v=b[h>>1]|0;c[o>>2]=446136;c[o+4>>2]=d;c[o+8>>2]=e;c[o+12>>2]=f;b[o+16>>1]=v;c[o+20>>2]=k;c[o+24>>2]=l;g[o+28>>2]=ea(3402823469999999843913219.0e14);c[o+32>>2]=m;a[o+36>>0]=1;a[o+68>>0]=0;m=o+72|0;c[m>>2]=0;l=o+41|0;a[l>>0]=0;k=(r&65535)>>>4&1;a[o+39>>0]=k;a[o+40>>0]=(v&64)!=0?1:k;k=b[q>>1]|0;v=(k&65535)>>>5&1;a[o+38>>0]=v;a[o+37>>0]=v;do if((s|0)!=0?(c[f+28>>2]|0)==0:0){v=qCa(j,CCa(s)|0)|0;a[l>>0]=1;r=CWa(o,0,v,1)|0;a[l>>0]=0;if(r){w=b[q>>1]|0;x=9;break}if(!(a[t>>0]|0)){y=c[u>>2]|0;x=18}else x=19}else{w=k;x=9}while(0);do if((x|0)==9){k=c[d+3388>>2]|0;q=c[d+3392>>2]|0;l=w&65535;s=l&2;DWa(p,c[e+12>>2]|0,c[e+16>>2]|0,ea(g[e+20>>2]));c[m>>2]=p;if((l&1|0)!=0?!(xo[c[(c[k>>2]|0)+20>>2]&2047](k,p,o)|0):0){if(a[t>>0]|0){x=19;break}y=c[u>>2]|0;x=18;break}if(!s)z=1;else z=(xo[c[(c[q>>2]|0)+20>>2]&2047](q,p,o)|0)&1;q=a[t>>0]|0;if(!(q<<24>>24))A=(c[u>>2]|0)!=0;else A=1;if(z<<24>>24){s=c[u>>2]|0;k=(s|0)==0;if(!(q<<24>>24))if(k){B=A;break}else{C=A;D=s;x=24;break}else if(k){B=A;break}else{E=A;F=s;x=22;break}}else B=A}while(0);if((x|0)==18){A=(y|0)!=0;if(!y)B=A;else{C=A;D=y;x=24}}else if((x|0)==19){y=c[u>>2]|0;if(!y)B=1;else{E=1;F=y;x=22}}if((x|0)==22){c[u>>2]=F;C=E;D=F;x=24}if((x|0)==24)if(xo[c[c[f>>2]>>2]&2047](f,c[f+24>>2]|0,D)|0){c[u>>2]=0;B=C}else B=C;ko[c[(c[f>>2]|0)+4>>2]&4095](f);i=n;return B|0}function u1(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im;p=i;i=i+48|0;q=p;r=p+8|0;s=p+32|0;t=c[a+1216>>2]|0;u=a+1208|0;v=c[u>>2]|0;w=c[u+4>>2]|0;Dn[c[(c[t>>2]|0)+8>>2]&511](t,133,v,w);u=b[k>>1]|0;if((u&768)==768){dKa(bKa()|0,4,445640,104,445720,q);x=b[k>>1]&-257;b[k>>1]=x;y=x}else y=u;if((y&528)==528){dKa(bKa()|0,4,445640,110,445792,q);u=b[k>>1]&-17;b[k>>1]=u;z=u}else z=y;if((z&256)!=0&o>ea(0.0)){dKa(bKa()|0,4,445640,118,445904,q);A=ea(0.0)}else A=o;c[r>>2]=0;g[r+8>>2]=h;c[r+4>>2]=f;c[r+12>>2]=d;c[r+16>>2]=e;g[r+20>>2]=A;b[s>>1]=b[k>>1]|0;k=v1(a,r,j,s,n,l,m,0)|0;Dn[c[(c[t>>2]|0)+12>>2]&511](t,133,v,w);i=p;return k|0}function v1(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0;n=i;i=i+288|0;o=n+212|0;p=n+208|0;q=n;r=k+16|0;s=b[r>>1]|0;if(!j)t=0;else{u=JU(c[j+4>>2]|0)|0;t=H2(u,c[j>>2]|0)|0}j=d+3376|0;uCa(j);u=f+52|0;a[u>>0]=0;v=f+64|0;c[v>>2]=0;w=ea(g[e+8>>2]);x=w<ea(1.0e8);y=x?w:ea(1.0e8);x=b[h>>1]|0;c[o>>2]=446112;c[o+4>>2]=d;c[o+8>>2]=e;c[o+12>>2]=f;b[o+16>>1]=x;c[o+20>>2]=k;c[o+24>>2]=l;l=o+28|0;g[l>>2]=y;c[o+32>>2]=m;a[o+36>>0]=1;m=o+68|0;a[m>>0]=0;k=o+72|0;c[k>>2]=0;h=o+41|0;a[h>>0]=0;z=(s&65535)>>>4&1;a[o+39>>0]=z;a[o+40>>0]=(x&64)!=0?1:z;z=b[r>>1]|0;x=(z&65535)>>>5&1;a[o+38>>0]=x;a[o+37>>0]=x;do if((t|0)!=0?(c[f+60>>2]|0)==0:0){x=qCa(j,CCa(t)|0)|0;a[h>>0]=1;DWa(q,c[e+12>>2]|0,c[e+16>>2]|0,ea(g[e+20>>2]));g[o+44>>2]=ea(g[q+120>>2]);g[o+48>>2]=ea(g[q+124>>2]);g[o+52>>2]=ea(g[q+128>>2]);g[o+56>>2]=ea(g[q+132>>2]);g[o+60>>2]=ea(g[q+136>>2]);g[o+64>>2]=ea(g[q+140>>2]);a[m>>0]=1;c[k>>2]=q;s=EWa(o,p,x,1)|0;c[k>>2]=0;a[h>>0]=0;if(!s)if(!(a[u>>0]|0)){A=16;break}else{A=17;break}else{B=b[r>>1]|0;A=8;break}}else{B=z;A=8}while(0);do if((A|0)==8){z=c[d+3388>>2]|0;r=c[d+3392>>2]|0;h=B&65535;p=h&2;DWa(q,c[e+12>>2]|0,c[e+16>>2]|0,ea(g[e+20>>2]));g[o+44>>2]=ea(g[q+120>>2]);g[o+48>>2]=ea(g[q+124>>2]);g[o+52>>2]=ea(g[q+128>>2]);g[o+56>>2]=ea(g[q+132>>2]);g[o+60>>2]=ea(g[q+136>>2]);g[o+64>>2]=ea(g[q+140>>2]);a[m>>0]=1;c[k>>2]=q;if((h&1|0)!=0?!(Bn[c[(c[z>>2]|0)+24>>2]&255](z,q,c[e+4>>2]|0,l,o)|0):0)if(!(a[u>>0]|0)){A=16;break}else{A=17;break}if(!p)C=1;else C=(Bn[c[(c[r>>2]|0)+24>>2]&255](r,q,c[e+4>>2]|0,l,o)|0)&1;r=a[u>>0]|0;if(!(r<<24>>24))D=(c[v>>2]|0)!=0;else D=1;if(C<<24>>24){p=c[v>>2]|0;if(!(r<<24>>24)){E=D;F=p;break}else{G=D;H=p;A=19;break}}else{I=D;J=c[f>>2]|0;K=J+4|0;L=c[K>>2]|0;ko[L&4095](f);i=n;return I|0}}while(0);if((A|0)==16){D=c[v>>2]|0;E=(D|0)!=0;F=D}else if((A|0)==17){G=1;H=c[v>>2]|0;A=19}if((A|0)==19){if(!H){I=G;J=c[f>>2]|0;K=J+4|0;L=c[K>>2]|0;ko[L&4095](f);i=n;return I|0}A=c[f+56>>2]|0;y=ea(g[f+44>>2]);D=0;C=H;while(1){u=A+(D*48|0)+40|0;if(ea(g[u>>2])>y){o=C+-1|0;l=b[A+(o*48|0)+12>>1]|0;w=ea(g[A+(o*48|0)+16>>2]);M=ea(g[A+(o*48|0)+20>>2]);N=ea(g[A+(o*48|0)+24>>2]);O=ea(g[A+(o*48|0)+28>>2]);P=ea(g[A+(o*48|0)+32>>2]);Q=ea(g[A+(o*48|0)+36>>2]);R=ea(g[A+(o*48|0)+40>>2]);e=c[A+(o*48|0)+44>>2]|0;aFi(A+(D*48|0)|0,A+(o*48|0)|0,12)|0;b[A+(D*48|0)+12>>1]=l;g[A+(D*48|0)+16>>2]=w;g[A+(D*48|0)+20>>2]=M;g[A+(D*48|0)+24>>2]=N;g[A+(D*48|0)+28>>2]=O;g[A+(D*48|0)+32>>2]=P;g[A+(D*48|0)+36>>2]=Q;g[u>>2]=R;c[A+(D*48|0)+44>>2]=e;S=o}else S=C;D=D+1|0;if((D|0)==(H|0))break;else C=S}c[v>>2]=S;E=G;F=S}if(!F){I=E;J=c[f>>2]|0;K=J+4|0;L=c[K>>2]|0;ko[L&4095](f);i=n;return I|0}if(!(xo[c[c[f>>2]>>2]&2047](f,c[f+56>>2]|0,F)|0)){I=E;J=c[f>>2]|0;K=J+4|0;L=c[K>>2]|0;ko[L&4095](f);i=n;return I|0}c[v>>2]=0;I=E;J=c[f>>2]|0;K=J+4|0;L=c[K>>2]|0;ko[L&4095](f);i=n;return I|0}function w1(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;i=i+16|0;l=k;b[d+4>>1]=7;b[d+6>>1]=3;c[d>>2]=447208;m=d+8|0;c[m>>2]=0;n=d+12|0;c[n>>2]=434952;c[d+16>>2]=1;c[d>>2]=446184;c[n>>2]=446360;c[d+20>>2]=0;n=a[f>>0]|0;c[d+32>>2]=0;c[d+40>>2]=0;f=d+36|0;c[f>>2]=0;a[l>>0]=n;Vea(d+48|0,e,l,g,h);c[f>>2]=c[f>>2]&-251658241|(j?16777216:33554432);c[d+192>>2]=0;a[d+196>>0]=j&1;c[m>>2]=0;m=s2(d)|0;if(!m){i=k;return}fTa(m+4|0)|0;i=k;return}function x1(a){a=a|0;var b=0;b=i;i=i+16|0;z1(a);VJa(b,a);i=b;return}function y1(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=a+-12|0;z1(c);VJa(b,c);i=b;return}function z1(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;c[a>>2]=446184;c[a+12>>2]=446360;f=s2(a)|0;if((f|0)!=0?(gTa(f+4|0)|0)==0:0)ko[c[(c[f>>2]|0)+8>>2]&4095](f);f=a+32|0;g=a+36|0;h=c[g>>2]|0;if(!(h&2))j=_ea(a+48|0)|0;else{k=a+40|0;l=c[k>>2]|0;if(!l){m=s4(c[f>>2]|0,h>>>24&15)|0;c[k>>2]=m;n=m}else n=l;j=b[n+60>>1]|0}n=a+48|0;if(!(j<<16>>16)){Xea(n);i=d;return}l=a+40|0;a=j&65535;j=0;do{m=c[108764]|0;k=c[g>>2]|0;if(!(k&2)){h=e[($ea(n)|0)+(j<<1)>>1]|0;o=(c[m+52>>2]|0)+(h<<2)|0}else{h=c[f>>2]|0;p=c[l>>2]|0;if(!p){q=s4(h,k>>>24&15)|0;c[l>>2]=q;r=q}else r=p;p=r+56|0;if((b[r+60>>1]|0)==1)s=p;else s=(c[h+2488>>2]|0)+(c[p>>2]<<1)|0;o=(c[m+52>>2]|0)+(e[s+(j<<1)>>1]<<2)|0}m=c[o>>2]|0;p=m+12|0;if(!(gTa(m+16|0)|0))ko[c[(c[p>>2]|0)+8>>2]&4095](p);j=j+1|0}while((j|0)!=(a|0));Xea(n);i=d;return}function A1(a){a=a|0;var b=0;b=i;z1(a+-12|0);i=b;return}function B1(a){a=a|0;var b=0;b=i;fY(c[107930]|0,a);wY(a+32|0);i=b;return}function C1(a){a=a|0;var b=0,d=0;b=i;d=a+-12|0;fY(c[107930]|0,d);wY(d+32|0);i=b;return}function D1(a,b){a=a|0;b=b|0;var d=0;d=i;ffa(a+48|0,b);In[c[(c[b>>2]|0)+16>>2]&4095](b,c[a+192>>2]|0);i=d;return}function E1(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=a+32|0;h=a+116|0;j=c[h>>2]|0;if((j|0)==5){k=c[a+36>>2]|0;if(!(k&1))l=h;else{m=a+40|0;n=c[m>>2]|0;if(!n){o=s4(c[g>>2]|0,k>>>24&15)|0;c[m>>2]=o;p=o}else p=n;l=p}q=c[l+36>>2]|0;r=17}else if((j|0)==4){l=c[a+36>>2]|0;if(!(l&1))s=h;else{p=a+40|0;n=c[p>>2]|0;if(!n){o=s4(c[g>>2]|0,l>>>24&15)|0;c[p>>2]=o;t=o}else t=n;s=t}q=c[s+32>>2]|0;r=17}else if((j|0)==6){j=c[a+36>>2]|0;if(!(j&1))u=h;else{h=a+40|0;s=c[h>>2]|0;if(!s){t=s4(c[g>>2]|0,j>>>24&15)|0;c[h>>2]=t;v=t}else v=s;u=v}q=c[u+4>>2]|0;r=17}if((r|0)==17?(q|0)!=0:0)In[c[(c[d>>2]|0)+8>>2]&4095](d,q);q=a+36|0;r=c[q>>2]|0;if(!(r&2))w=_ea(a+48|0)|0;else{u=a+40|0;v=c[u>>2]|0;if(!v){s=s4(c[g>>2]|0,r>>>24&15)|0;c[u>>2]=s;x=s}else x=v;w=b[x+60>>1]|0}if(!(w<<16>>16)){i=f;return}x=a+48|0;v=a+40|0;a=w&65535;w=0;do{s=c[108764]|0;u=c[q>>2]|0;if(!(u&2)){r=e[($ea(x)|0)+(w<<1)>>1]|0;y=(c[s+52>>2]|0)+(r<<2)|0}else{r=c[g>>2]|0;t=c[v>>2]|0;if(!t){h=s4(r,u>>>24&15)|0;c[v>>2]=h;z=h}else z=t;t=z+56|0;if((b[z+60>>1]|0)==1)A=t;else A=(c[r+2488>>2]|0)+(c[t>>2]<<1)|0;y=(c[s+52>>2]|0)+(e[A+(w<<1)>>1]<<2)|0}In[c[(c[d>>2]|0)+8>>2]&4095](d,c[y>>2]|0);w=w+1|0}while((w|0)!=(a|0));i=f;return}function F1(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=a+6|0;g=(b[f>>1]&2)!=0;if(!(g|(mo[c[(c[a>>2]|0)+140>>2]&4095](a)|0)^1)){dKa(bKa()|0,8,446376,187,446448,e);h=a+20|0;j=JU(c[h>>2]|0)|0;x2(j,a,c[h>>2]|0,1);i=d;return}if(!g){dKa(bKa()|0,8,446376,193,446568,e);i=d;return}KZ(c[108764]|0,a,c[a+8>>2]|0,1);b[f>>1]=b[f>>1]&-3;f=a+12|0;if(gTa(a+16|0)|0){i=d;return}ko[c[(c[f>>2]|0)+8>>2]&4095](f);i=d;return}function G1(a){a=a|0;var d=0,e=0;d=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);e=a+6|0;b[e>>1]=b[e>>1]&-3;e=a+12|0;if(gTa(a+16|0)|0){i=d;return}ko[c[(c[e>>2]|0)+8>>2]&4095](e);i=d;return}function H1(a){a=a|0;return c[a+116>>2]|0}function I1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;if((c[d>>2]|0)!=(c[b+116>>2]|0)){dKa(bKa()|0,4,446376,236,446632,e);i=e;return}f=s2(b)|0;if((f|0)!=0?(gTa(f+4|0)|0)==0:0)ko[c[(c[f>>2]|0)+8>>2]&4095](f);f=b+32|0;FWa(f,d)|0;d=s2(b)|0;if(d)fTa(d+4|0)|0;d=c[b+36>>2]|0;if(!(d&64))g=b+112|0;else{h=b+40|0;j=c[h>>2]|0;if(!j){k=s4(c[f>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;g=l+116|0}if(!(a[g>>0]&2)){i=e;return}g=b+20|0;l=c[g>>2]|0;if(!l){i=e;return}j=KU(l)|0;if(!j){i=e;return}oCa(j+3376|0,H2(JU(c[g>>2]|0)|0,b)|0);i=e;return}function J1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+36>>2]|0;if(!(e&1))f=b+116|0;else{g=b+40|0;h=c[g>>2]|0;if(!h){j=s4(c[b+32>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=k}k=a+0|0;a=f+0|0;f=k+40|0;do{c[k>>2]=c[a>>2];k=k+4|0;a=a+4|0}while((k|0)<(f|0));i=d;return}function K1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+116|0;if((c[e>>2]|0)!=3){f=0;i=d;return f|0}h=c[a+36>>2]|0;if(!(h&1)){j=e;k=3}else{e=a+40|0;l=c[e>>2]|0;if(!l){m=s4(c[a+32>>2]|0,h>>>24&15)|0;c[e>>2]=m;n=m}else n=l;j=n;k=c[n>>2]|0}c[b>>2]=k;g[b+4>>2]=ea(g[j+4>>2]);g[b+8>>2]=ea(g[j+8>>2]);g[b+12>>2]=ea(g[j+12>>2]);f=1;i=d;return f|0}function L1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+116|0;if(c[e>>2]|0){f=0;i=d;return f|0}g=c[a+36>>2]|0;if(!(g&1))h=e;else{e=a+40|0;j=c[e>>2]|0;if(!j){k=s4(c[a+32>>2]|0,g>>>24&15)|0;c[e>>2]=k;l=k}else l=j;h=l}l=h;h=c[l+4>>2]|0;j=b;c[j>>2]=c[l>>2];c[j+4>>2]=h;f=1;i=d;return f|0}function M1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+116|0;if((c[e>>2]|0)!=2){f=0;i=d;return f|0}g=c[a+36>>2]|0;if(!(g&1))h=e;else{e=a+40|0;j=c[e>>2]|0;if(!j){k=s4(c[a+32>>2]|0,g>>>24&15)|0;c[e>>2]=k;l=k}else l=j;h=l};c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];f=1;i=d;return f|0}function N1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((c[a+116>>2]|0)!=1){e=0;i=d;return e|0}f=c[a+36>>2]|0;if(!(f&1))g=1;else{h=a+40|0;j=c[h>>2]|0;if(!j){k=s4(c[a+32>>2]|0,f>>>24&15)|0;c[h>>2]=k;l=k}else l=j;g=c[l>>2]|0}c[b>>2]=g;e=1;i=d;return e|0}function O1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+116|0;if((c[e>>2]|0)!=4){f=0;i=d;return f|0}h=c[a+36>>2]|0;if(!(h&1)){j=e;k=4}else{e=a+40|0;l=c[e>>2]|0;if(!l){m=s4(c[a+32>>2]|0,h>>>24&15)|0;c[e>>2]=m;n=m}else n=l;j=n;k=c[n>>2]|0}c[b>>2]=k;g[b+4>>2]=ea(g[j+4>>2]);g[b+8>>2]=ea(g[j+8>>2]);g[b+12>>2]=ea(g[j+12>>2]);g[b+16>>2]=ea(g[j+16>>2]);g[b+20>>2]=ea(g[j+20>>2]);g[b+24>>2]=ea(g[j+24>>2]);g[b+28>>2]=ea(g[j+28>>2]);c[b+32>>2]=c[j+32>>2];f=1;i=d;return f|0}function P1(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;h=b+116|0;if((c[h>>2]|0)!=5){j=0;i=f;return j|0}k=c[b+36>>2]|0;if(!(k&1)){l=h;m=5}else{h=b+40|0;n=c[h>>2]|0;if(!n){o=s4(c[b+32>>2]|0,k>>>24&15)|0;c[h>>2]=o;p=o}else p=n;l=p;m=c[p>>2]|0}c[e>>2]=m;g[e+4>>2]=ea(g[l+4>>2]);g[e+8>>2]=ea(g[l+8>>2]);g[e+12>>2]=ea(g[l+12>>2]);g[e+16>>2]=ea(g[l+16>>2]);g[e+20>>2]=ea(g[l+20>>2]);g[e+24>>2]=ea(g[l+24>>2]);g[e+28>>2]=ea(g[l+28>>2]);m=l+32|0;l=m;p=d[l>>0]|d[l+1>>0]<<8|d[l+2>>0]<<16|d[l+3>>0]<<24;l=m+4|0;m=d[l>>0]|d[l+1>>0]<<8|d[l+2>>0]<<16|d[l+3>>0]<<24;l=e+32|0;e=l;a[e>>0]=p;a[e+1>>0]=p>>8;a[e+2>>0]=p>>16;a[e+3>>0]=p>>24;p=l+4|0;a[p>>0]=m;a[p+1>>0]=m>>8;a[p+2>>0]=m>>16;a[p+3>>0]=m>>24;j=1;i=f;return j|0}function Q1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+116|0;if((c[e>>2]|0)!=6){f=0;i=d;return f|0}g=c[a+36>>2]|0;if(!(g&1))h=e;else{e=a+40|0;j=c[e>>2]|0;if(!j){k=s4(c[a+32>>2]|0,g>>>24&15)|0;c[e>>2]=k;l=k}else l=j;h=l};c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];c[b+20>>2]=c[h+20>>2];f=1;i=d;return f|0}function R1(a){a=a|0;return c[a+20>>2]|0}function S1(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;h=b+32|0;j=ea(g[d>>2]);k=ea(j*j);l=ea(g[d+4>>2]);m=ea(k+ea(l*l));k=ea(g[d+8>>2]);n=ea(m+ea(k*k));m=ea(g[d+12>>2]);o=ea(ea(1.0)/ea(T(ea(n+ea(m*m)))));n=ea(l*o);l=ea(k*o);k=ea(m*o);g[f>>2]=ea(j*o);g[f+4>>2]=n;g[f+8>>2]=l;g[f+12>>2]=k;g[f+16>>2]=ea(g[d+16>>2]);g[f+20>>2]=ea(g[d+20>>2]);g[f+24>>2]=ea(g[d+24>>2]);GWa(h,b+48|0,f);f=c[b+36>>2]|0;if(!(f&64))p=b+112|0;else{d=b+40|0;q=c[d>>2]|0;if(!q){r=s4(c[h>>2]|0,f>>>24&15)|0;c[d>>2]=r;s=r}else s=q;p=s+116|0}if(!(a[p>>0]&2)){i=e;return}p=b+20|0;s=c[p>>2]|0;if(!s){i=e;return}q=LU(s)|0;if(!q){i=e;return}oCa(q+3376|0,H2(JU(c[p>>2]|0)|0,b)|0);i=e;return}function T1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b+36>>2]|0;if(!(e&4))f=b+80|0;else{h=b+40|0;j=c[h>>2]|0;if(!j){k=s4(c[b+32>>2]|0,e>>>24&15)|0;c[h>>2]=k;l=k}else l=j;f=l+64|0}g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);g[a+12>>2]=ea(g[f+12>>2]);g[a+16>>2]=ea(g[f+16>>2]);g[a+20>>2]=ea(g[f+20>>2]);g[a+24>>2]=ea(g[f+24>>2]);i=d;return}function U1(a,b){a=a|0;b=b|0;var c=0;c=i;HWa(a+32|0,a+48|0,b);i=c;return}function V1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+36>>2]|0;if(!(e&8))f=b+64|0;else{g=b+40|0;h=c[g>>2]|0;if(!h){j=s4(c[b+32>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=k+92|0};c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function W1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;dKa(bKa()|0,1,446376,454,446728,b);e=a+20|0;f=c[e>>2]|0;if(!f){i=b;return}g=KU(f)|0;if(!g){i=b;return}c[d>>2]=a;Dn[c[(c[g>>2]|0)+216>>2]&511](g,c[e>>2]|0,d,1);i=b;return}function X1(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function Y1(a,b){a=a|0;b=b|0;var d=0;d=b+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function Z1(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+16|0;j=h;k=h+8|0;l=d+32|0;m=d+36|0;n=c[m>>2]|0;if(!(n&2))o=_ea(d+48|0)|0;else{p=d+40|0;q=c[p>>2]|0;if(!q){r=s4(c[l>>2]|0,n>>>24&15)|0;c[p>>2]=r;s=r}else s=q;o=b[s+60>>1]|0}s=o&65535;q=s<<2;r=q>>>0>1024;p=j+4|0;a[p>>0]=r&1;if(r){r=sKa(k,q,446376,503)|0;c[j>>2]=r;t=r}else{r=i;i=i+((4*s|0)+15&-16)|0;c[j>>2]=r;t=r}r=c[108764]|0;q=c[m>>2]|0;do if(q&2){m=d+40|0;k=c[m>>2]|0;if(!k){n=s4(c[l>>2]|0,q>>>24&15)|0;c[m>>2]=n;u=n}else u=k;k=b[u+60>>1]|0;if(k<<16>>16==1){v=1;w=u+56|0;break}else{v=k;w=(c[(c[l>>2]|0)+2488>>2]|0)+(c[u+56>>2]<<1)|0;break}}else{k=d+48|0;n=$ea(k)|0;v=_ea(k)|0;w=n}while(0);d=v&65535;if((d>>>0<s>>>0?d:s)|0){v=r+52|0;r=~s;u=~d;d=~(r>>>0>u>>>0?r:u);u=0;do{c[t+(u<<2)>>2]=c[(c[v>>2]|0)+(e[w+(u<<1)>>1]<<2)>>2];u=u+1|0}while((u|0)!=(d|0))}if(IWa(l,f,g)|0){if(g<<16>>16){l=g&65535;g=0;do{fTa((c[f+(g<<2)>>2]|0)+16|0)|0;g=g+1|0}while((g|0)!=(l|0))}if(o<<16>>16){o=0;do{l=c[(c[j>>2]|0)+(o<<2)>>2]|0;g=l+12|0;if(!(gTa(l+16|0)|0))ko[c[(c[g>>2]|0)+8>>2]&4095](g);o=o+1|0}while((o|0)!=(s|0))}}if(!(a[p>>0]|0)){i=h;return}tKa(j,c[j>>2]|0);i=h;return}function _1(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[a+36>>2]|0;if(!(e&2)){f=_ea(a+48|0)|0;i=d;return f|0}g=a+40|0;h=c[g>>2]|0;if(!h){j=s4(c[a+32>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=b[k+60>>1]|0;i=d;return f|0}function $1(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=a+32|0;j=c[108764]|0;k=c[a+36>>2]|0;do if(k&2){l=a+40|0;m=c[l>>2]|0;if(!m){n=s4(c[h>>2]|0,k>>>24&15)|0;c[l>>2]=n;o=n}else o=m;m=b[o+60>>1]|0;if(m<<16>>16==1){p=1;q=o+56|0;break}else{p=m;q=(c[(c[h>>2]|0)+2488>>2]|0)+(c[o+56>>2]<<1)|0;break}}else{m=a+48|0;n=$ea(m)|0;p=_ea(m)|0;q=n}while(0);a=p&65535;p=a>>>0<f>>>0?a:f;if(!p){i=g;return p|0}o=j+52|0;j=~f;f=~a;a=~(j>>>0>f>>>0?j:f);f=0;do{c[d+(f<<2)>>2]=c[(c[o>>2]|0)+((e[q+(f<<1)>>1]|0)<<2)>>2];f=f+1|0}while((f|0)!=(a|0));i=g;return p|0}function a2(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;h=f;j=f+40|0;k=(mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0)==6;l=(mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0)==5;if((d|0)==-1&(k|l)){dKa(bKa()|0,2,446376,544,446792,h);m=0;i=f;return m|0}if(!k)if(l?(c[h>>2]=5,g[h+4>>2]=ea(1.0),g[h+8>>2]=ea(1.0),g[h+12>>2]=ea(1.0),g[h+16>>2]=ea(0.0),g[h+20>>2]=ea(0.0),g[h+24>>2]=ea(0.0),g[h+28>>2]=ea(1.0),l=h+32|0,c[l>>2]=0,c[l+4>>2]=0,_n[c[(c[a>>2]|0)+56>>2]&4095](a,h)|0,l=c[h+36>>2]|0,(c[l+176>>2]|0)!=0):0)n=_n[c[(c[l>>2]|0)+48>>2]&4095](l,d)|0;else n=0;else{c[j>>2]=6;l=j+4|0;c[l>>2]=0;g[j+8>>2]=ea(1.0);g[j+12>>2]=ea(1.0);g[j+16>>2]=ea(1.0);c[j+20>>2]=0;_n[c[(c[a>>2]|0)+60>>2]&4095](a,j)|0;j=c[l>>2]|0;n=_n[c[(c[j>>2]|0)+68>>2]&4095](j,d)|0}d=n&65535;n=c[108764]|0;j=c[a+36>>2]|0;if(!(j&2)){l=e[($ea(a+48|0)|0)+(d<<1)>>1]|0;o=(c[n+52>>2]|0)+(l<<2)|0}else{l=c[a+32>>2]|0;h=a+40|0;a=c[h>>2]|0;if(!a){k=s4(l,j>>>24&15)|0;c[h>>2]=k;p=k}else p=a;a=p+56|0;if((b[p+60>>1]|0)==1)q=a;else q=(c[l+2488>>2]|0)+(c[a>>2]<<1)|0;o=(c[n+52>>2]|0)+(e[q+(d<<1)>>1]<<2)|0}m=c[o>>2]|0;i=f;return m|0}function b2(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;h=e+4|0;j=b+32|0;k=b+48|0;l=b+36|0;m=c[l>>2]|0;n=m>>>30;if((n|0)==3){o=j;p=6}else if((n|0)==2?(a[(c[j>>2]|0)+2417>>0]|0)!=0:0){o=j;p=6}else p=4;if((p|0)==4){n=a[b+112>>0]|0;g[b+108>>2]=d;q=c[j+-12>>2]|0;if((q|0)==0|(m&-1073741824|0)==1073741824){i=e;return}c[f>>2]=16;a[h>>0]=n;Yba(q+64|0,k,f,h);i=e;return}else if((p|0)==6){p=b+40|0;b=c[p>>2]|0;if(!b){h=s4(c[o>>2]|0,m>>>24&15)|0;c[p>>2]=h;r=h}else r=b;g[r+108>>2]=d;r4(c[o>>2]|0,j);c[l>>2]=c[l>>2]|16;i=e;return}}function c2(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+36>>2]|0;if(!(d&16)){e=a+108|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+40|0;j=c[h>>2]|0;if(!j){k=s4(c[a+32>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+108|0;f=ea(g[e>>2]);i=b;return ea(f)}function d2(a,b){a=a|0;b=ea(b);var c=0;c=i;JWa(a+32|0,a+48|0,b);i=c;return}function e2(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0,l=0;b=i;d=c[a+36>>2]|0;if(!(d&32)){e=a+176|0;f=ea(g[e>>2]);i=b;return ea(f)}h=a+40|0;j=c[h>>2]|0;if(!j){k=s4(c[a+32>>2]|0,d>>>24&15)|0;c[h>>2]=k;l=k}else l=j;e=l+112|0;f=ea(g[e>>2]);i=b;return ea(f)}function f2(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function g2(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+16|0;h=g;j=g+4|0;k=e+32|0;l=e+116|0;m=a[f>>0]|0;if(((c[l>>2]|0)+-5|0)>>>0<2)if(!(m&4))n=1;else{dKa(bKa()|0,4,446376,626,446888,h);i=g;return}else n=0;if((m&5)==5){dKa(bKa()|0,4,446376,633,446968,h);i=g;return}o=c[e+36>>2]|0;if(!(o&64)){p=e+112|0;q=m}else{r=e+40|0;s=c[r>>2]|0;if(!s){t=s4(c[k>>2]|0,o>>>24&15)|0;c[r>>2]=t;u=a[f>>0]|0;v=t}else{u=m;v=s}p=v+116|0;q=u}u=d[p>>0]|0;p=(u&1|0)!=0;v=q&1;q=e+20|0;s=c[q>>2]|0;do if(s){m=b[s+4>>1]|0;if(m<<16>>16==5){In[c[(c[s>>2]|0)+204>>2]&4095](j,s);w=(a[j>>0]&1)!=0}else w=0;if(!(m<<16>>16==6|w|v<<24>>24==0|p)){if(!n?(c[l>>2]|0)!=1:0)break;dKa(bKa()|0,4,446376,657,447064,h);i=g;return}}while(0);l=a[f>>0]|0;f=(l&2)!=0;a[h>>0]=l;KWa(k,e+48|0,h);if(!((u&2|0)!=0^f)){i=g;return}u=c[q>>2]|0;if(!u){i=g;return}h=LU(u)|0;if(!h){i=g;return}u=JU(c[q>>2]|0)|0;k=h+3376|0;if(f){D2(u,k,c[q>>2]|0,e);i=g;return}else{E2(u,k,e);i=g;return}}function h2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=c[b+36>>2]|0;if(!(h&64))j=b+112|0;else{k=b+40|0;l=c[k>>2]|0;if(!l){m=s4(c[b+32>>2]|0,h>>>24&15)|0;c[k>>2]=m;n=m}else n=l;j=n+116|0}n=a[j>>0]|0;if(e)o=(n&255|d)&255;else o=n&((d^255)&255);a[g>>0]=o;g2(b,g);i=f;return}function i2(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[e>>0]=a[c>>0]|0;g2(b,e);i=d;return}function j2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[d+36>>2]|0;if(!(f&64)){a[b>>0]=a[d+112>>0]|0;i=e;return}g=d+40|0;h=c[g>>2]|0;if(!h){j=s4(c[d+32>>2]|0,f>>>24&15)|0;c[g>>2]=j;k=j}else k=h;a[b>>0]=a[k+116>>0]|0;i=e;return}function k2(b){b=b|0;return (a[b+196>>0]&1)!=0|0}function l2(a,b){a=a|0;b=b|0;c[a+192>>2]=b;return}function m2(a){a=a|0;return c[a+192>>2]|0}function n2(a){a=a|0;var b=0,d=0;b=c[a+-12>>2]|0;if(!b)d=0;else d=b+64|0;return d|0}function o2(){return 48}function p2(a){a=a|0;return a+-48|0}function q2(a){a=a|0;var b=0;b=i;fTa(a+-16|0)|0;i=b;return}function r2(a){a=a|0;var b=0,d=0;b=i;d=a+-20|0;if(gTa(a+-16|0)|0){i=b;return}ko[c[(c[d>>2]|0)+8>>2]&4095](d);i=b;return}function s2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;d=a+32|0;e=a+116|0;f=c[e>>2]|0;if((f|0)==4){g=c[a+36>>2]|0;if(!(g&1))h=e;else{j=a+40|0;k=c[j>>2]|0;if(!k){l=s4(c[d>>2]|0,g>>>24&15)|0;c[j>>2]=l;m=l}else m=k;h=m}m=c[h+32>>2]|0;if(!m){n=0;i=b;return n|0}n=m+8|0;i=b;return n|0}else if((f|0)==5){m=c[a+36>>2]|0;if(!(m&1))o=e;else{h=a+40|0;k=c[h>>2]|0;if(!k){l=s4(c[d>>2]|0,m>>>24&15)|0;c[h>>2]=l;p=l}else p=k;o=p}p=c[o+36>>2]|0;if(!p){n=0;i=b;return n|0}n=p+8|0;i=b;return n|0}else if((f|0)==6){f=c[a+36>>2]|0;if(!(f&1))q=e;else{e=a+40|0;a=c[e>>2]|0;if(!a){p=s4(c[d>>2]|0,f>>>24&15)|0;c[e>>2]=p;r=p}else r=a;q=r}r=c[q+4>>2]|0;if(!r){n=0;i=b;return n|0}n=r+8|0;i=b;return n|0}else{n=0;i=b;return n|0}return 0}function t2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im;f=i;i=i+512|0;h=f+44|0;j=f+160|0;k=f+336|0;l=f+424|0;m=f+200|0;n=f+272|0;o=f+400|0;p=f+456|0;q=f+504|0;r=f+40|0;s=f+188|0;t=f+72|0;u=f;v=f+88|0;w=f+224|0;x=f+136|0;y=KU(e)|0;z=ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,0));if(!(z!=ea(0.0))){i=f;return}In[c[(c[e>>2]|0)+84>>2]&4095](j,e);e=b+32|0;A=b+36|0;B=c[A>>2]|0;if(!(B&4))C=b+80|0;else{D=b+40|0;E=c[D>>2]|0;if(!E){F=s4(c[e>>2]|0,B>>>24&15)|0;c[D>>2]=F;G=F}else G=E;C=G+64|0}I=ea(ea(g[C+16>>2])*ea(2.0));J=ea(ea(g[C+20>>2])*ea(2.0));K=ea(ea(g[C+24>>2])*ea(2.0));L=ea(g[j+12>>2]);M=ea(ea(L*L)+ea(-.5));N=ea(g[j>>2]);O=ea(I*N);P=ea(g[j+4>>2]);Q=ea(O+ea(J*P));O=ea(g[j+8>>2]);R=ea(Q+ea(K*O));Q=ea(ea(N*R)+ea(ea(I*M)+ea(L*ea(ea(K*P)-ea(J*O)))));S=ea(ea(P*R)+ea(ea(J*M)+ea(L*ea(ea(I*O)-ea(K*N)))));T=ea(ea(ea(K*M)+ea(L*ea(ea(J*N)-ea(I*P))))+ea(O*R));R=ea(ea(g[j+16>>2])+Q);Q=ea(ea(g[j+20>>2])+S);S=ea(ea(g[j+24>>2])+T);T=ea(g[C>>2]);I=ea(L*T);J=ea(g[C+12>>2]);M=ea(I+ea(N*J));I=ea(g[C+8>>2]);K=ea(M+ea(P*I));M=ea(g[C+4>>2]);U=ea(ea(ea(O*T)+ea(ea(P*J)+ea(L*M)))-ea(N*I));V=ea(ea(ea(N*M)+ea(ea(O*J)+ea(L*I)))-ea(P*T));W=ea(ea(ea(ea(L*J)-ea(N*T))-ea(P*M))-ea(O*I));g[h>>2]=ea(K-ea(O*M));C=h+4|0;g[C>>2]=U;j=h+8|0;g[j>>2]=V;G=h+12|0;g[G>>2]=W;E=h+16|0;g[E>>2]=R;F=h+20|0;g[F>>2]=Q;D=h+24|0;g[D>>2]=S;if(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,12))!=ea(0.0)){B=DKa(d,-256)|0;g[k>>2]=ea(1.0);X=k+4|0;c[X+0>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;c[X+12>>2]=0;g[k+20>>2]=ea(1.0);X=k+24|0;c[X+0>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;c[X+12>>2]=0;g[k+40>>2]=ea(1.0);X=k+44|0;c[X+0>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;c[X+12>>2]=0;g[k+60>>2]=ea(1.0);X=EKa(B,k)|0;k=c[A>>2]|0;if(!(k&1))Y=b+116|0;else{A=b+40|0;B=c[A>>2]|0;if(!B){Z=s4(c[e>>2]|0,k>>>24&15)|0;c[A>>2]=Z;_=Z}else _=B;Y=_}oMa(Y,m,h,ea(0.0),0);g[l>>2]=ea(g[m>>2]);g[l+4>>2]=ea(g[m+4>>2]);g[l+8>>2]=ea(g[m+8>>2]);g[l+12>>2]=ea(g[m+12>>2]);g[l+16>>2]=ea(g[m+16>>2]);g[l+20>>2]=ea(g[m+20>>2]);a[l+24>>0]=1;HKa(X,l)|0}S=ea(z*ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,14)));if(S!=ea(0.0)){kLa(n,h);l=EKa(d,n)|0;g[o>>2]=S;g[o+4>>2]=S;g[o+8>>2]=S;c[o+12>>2]=13565952;c[o+16>>2]=52992;c[o+20>>2]=207;JKa(l,o)|0}if((!(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,13))!=ea(0.0))?!(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,16))!=ea(0.0)):0)?!(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,17))!=ea(0.0)):0){i=f;return}o=mo[c[(c[y>>2]|0)+304>>2]&4095](y)|0;S=ea(z*ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,16)));l=cFi(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,30))!=ea(0.0)|0,0,30)|0;n=H;X=cFi(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,16))!=ea(0.0)|0,0,16)|0;m=H|n;n=cFi(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,17))!=ea(0.0)|0,0,17)|0;Y=m|H;m=cFi(ea(Um[c[(c[y>>2]|0)+296>>2]&63](y,13))!=ea(0.0)|0,0,13)|0;y=X|l|n|m;m=Y|H;z=ea(g[h>>2]);Q=ea(z+z);R=ea(g[C>>2]);W=ea(R+R);V=ea(g[j>>2]);U=ea(V+V);M=ea(g[G>>2]);O=ea(Q*M);K=ea(W*M);I=ea(M*U);M=ea(z*Q);Q=ea(z*W);P=ea(z*U);z=ea(R*W);W=ea(R*U);R=ea(V*U);g[p>>2]=ea(ea(ea(1.0)-z)-R);g[p+4>>2]=ea(Q+I);g[p+8>>2]=ea(P-K);g[p+12>>2]=ea(Q-I);I=ea(ea(1.0)-M);g[p+16>>2]=ea(I-R);g[p+20>>2]=ea(W+O);g[p+24>>2]=ea(P+K);g[p+28>>2]=ea(W-O);g[p+32>>2]=ea(I-z);g[p+36>>2]=ea(g[E>>2]);g[p+40>>2]=ea(g[F>>2]);g[p+44>>2]=ea(g[D>>2]);Y=(_ea(b+48|0)|0)&65535;switch(mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0){case 0:{c[q>>2]=0;g[q+4>>2]=ea(0.0);_n[c[(c[b>>2]|0)+40>>2]&4095](b,q)|0;lLa(q,d,p,o,y,m,S,Y);i=f;return}case 1:{c[r>>2]=1;_n[c[(c[b>>2]|0)+48>>2]&4095](b,r)|0;mLa(r,d,p,o,y,m,S,Y);i=f;return}case 2:{c[s>>2]=2;g[s+4>>2]=ea(0.0);g[s+8>>2]=ea(0.0);_n[c[(c[b>>2]|0)+44>>2]&4095](b,s)|0;nLa(s,d,p,o,y,m,S,Y);i=f;return}case 3:{c[t>>2]=3;g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);_n[c[(c[b>>2]|0)+36>>2]&4095](b,t)|0;oLa(t,d,p,o,y,m,S,Y);i=f;return}case 4:{c[u>>2]=4;t=u+4|0;g[t>>2]=ea(1.0);g[u+8>>2]=ea(1.0);g[u+12>>2]=ea(1.0);s=u+16|0;g[s>>2]=ea(0.0);r=u+20|0;g[r>>2]=ea(0.0);q=u+24|0;g[q>>2]=ea(0.0);n=u+28|0;g[n>>2]=ea(1.0);c[u+32>>2]=0;_n[c[(c[b>>2]|0)+52>>2]&4095](b,u)|0;z=ea(g[h>>2]);I=ea(g[C>>2]);O=ea(g[j>>2]);W=ea(g[G>>2]);K=ea(z+z);P=ea(I+I);R=ea(O+O);M=ea(I*P);Q=ea(O*R);U=ea(K*I);I=ea(K*O);V=ea(K*W);T=ea(P*O);O=ea(P*W);P=ea(R*W);W=ea(ea(ea(1.0)-M)-Q);R=ea(U+P);N=ea(I-O);J=ea(U-P);P=ea(ea(1.0)-ea(z*K));K=ea(P-Q);Q=ea(T+V);z=ea(I+O);O=ea(T-V);V=ea(P-M);M=ea(g[s>>2]);P=ea(g[r>>2]);T=ea(g[q>>2]);I=ea(g[n>>2]);U=ea(M+M);L=ea(P+P);$=ea(T+T);aa=ea(P*L);ba=ea(T*$);ca=ea(U*P);P=ea(U*T);da=ea(U*I);fa=ea(L*T);T=ea(L*I);L=ea($*I);I=ea(ea(ea(1.0)-aa)-ba);$=ea(ca+L);ga=ea(P-T);ha=ea(ca-L);L=ea(ea(1.0)-ea(M*U));U=ea(L-ba);ba=ea(fa+da);M=ea(P+T);T=ea(fa-da);da=ea(L-aa);aa=ea(g[t>>2]);L=ea(aa*I);fa=ea(aa*ha);P=ea(aa*M);aa=ea(g[t+4>>2]);ca=ea($*aa);ia=ea(U*aa);ja=ea(T*aa);aa=ea(g[t+8>>2]);ka=ea(ga*aa);la=ea(ba*aa);ma=ea(da*aa);aa=ea(ea(ea(I*L)+ea($*ca))+ea(ga*ka));na=ea(ea(ea(I*fa)+ea($*ia))+ea(ga*la));oa=ea(ea(ea(I*P)+ea($*ja))+ea(ga*ma));ga=ea(ea(ea(ha*L)+ea(U*ca))+ea(ba*ka));$=ea(ea(ea(ha*fa)+ea(U*ia))+ea(ba*la));I=ea(ea(ea(ha*P)+ea(U*ja))+ea(ba*ma));ba=ea(ea(ea(M*L)+ea(T*ca))+ea(da*ka));ka=ea(ea(ea(M*fa)+ea(T*ia))+ea(da*la));la=ea(ea(ea(M*P)+ea(T*ja))+ea(da*ma));ma=ea(ea(O*oa)+ea(ea(R*aa)+ea(K*na)));da=ea(ea(V*oa)+ea(ea(N*aa)+ea(Q*na)));ja=ea(ea(z*I)+ea(ea(W*ga)+ea(J*$)));T=ea(ea(O*I)+ea(ea(R*ga)+ea(K*$)));P=ea(ea(V*I)+ea(ea(N*ga)+ea(Q*$)));$=ea(ea(z*la)+ea(ea(W*ba)+ea(J*ka)));ga=ea(ea(O*la)+ea(ea(R*ba)+ea(K*ka)));K=ea(ea(V*la)+ea(ea(N*ba)+ea(Q*ka)));g[v>>2]=ea(ea(z*oa)+ea(ea(W*aa)+ea(J*na)));g[v+4>>2]=ma;g[v+8>>2]=da;g[v+12>>2]=ja;g[v+16>>2]=T;g[v+20>>2]=P;g[v+24>>2]=$;g[v+28>>2]=ga;g[v+32>>2]=K;g[v+36>>2]=ea(g[E>>2]);g[v+40>>2]=ea(g[F>>2]);g[v+44>>2]=ea(g[D>>2]);pLa(u,d,v,o,y,m,S,Y);i=f;return}case 5:{c[u>>2]=5;v=u+4|0;g[v>>2]=ea(1.0);g[u+8>>2]=ea(1.0);g[u+12>>2]=ea(1.0);t=u+16|0;g[t>>2]=ea(0.0);n=u+20|0;g[n>>2]=ea(0.0);q=u+24|0;g[q>>2]=ea(0.0);r=u+28|0;g[r>>2]=ea(1.0);s=u+32|0;c[s>>2]=0;c[s+4>>2]=0;_n[c[(c[b>>2]|0)+56>>2]&4095](b,u)|0;K=ea(g[h>>2]);ga=ea(g[C>>2]);$=ea(g[j>>2]);P=ea(g[G>>2]);T=ea(K+K);ja=ea(ga+ga);da=ea($+$);ma=ea(ga*ja);na=ea($*da);J=ea(T*ga);ga=ea(T*$);aa=ea(T*P);W=ea(ja*$);$=ea(ja*P);ja=ea(da*P);P=ea(ea(ea(1.0)-ma)-na);da=ea(J+ja);oa=ea(ga-$);z=ea(J-ja);ja=ea(ea(1.0)-ea(K*T));T=ea(ja-na);na=ea(W+aa);K=ea(ga+$);$=ea(W-aa);aa=ea(ja-ma);ma=ea(g[t>>2]);ja=ea(g[n>>2]);W=ea(g[q>>2]);ga=ea(g[r>>2]);J=ea(ma+ma);ka=ea(ja+ja);Q=ea(W+W);ba=ea(ja*ka);N=ea(W*Q);la=ea(J*ja);ja=ea(J*W);V=ea(J*ga);R=ea(ka*W);W=ea(ka*ga);ka=ea(Q*ga);ga=ea(ea(ea(1.0)-ba)-N);Q=ea(la+ka);O=ea(ja-W);I=ea(la-ka);ka=ea(ea(1.0)-ea(ma*J));J=ea(ka-N);N=ea(R+V);ma=ea(ja+W);W=ea(R-V);V=ea(ka-ba);ba=ea(g[v>>2]);ka=ea(ba*ga);R=ea(ba*I);ja=ea(ba*ma);ba=ea(g[v+4>>2]);la=ea(Q*ba);M=ea(J*ba);ia=ea(W*ba);ba=ea(g[v+8>>2]);fa=ea(O*ba);ca=ea(N*ba);L=ea(V*ba);ba=ea(ea(ea(ga*ka)+ea(Q*la))+ea(O*fa));U=ea(ea(ea(ga*R)+ea(Q*M))+ea(O*ca));ha=ea(ea(ea(ga*ja)+ea(Q*ia))+ea(O*L));O=ea(ea(ea(I*ka)+ea(J*la))+ea(N*fa));Q=ea(ea(ea(I*R)+ea(J*M))+ea(N*ca));ga=ea(ea(ea(I*ja)+ea(J*ia))+ea(N*L));N=ea(ea(ea(ma*ka)+ea(W*la))+ea(V*fa));fa=ea(ea(ea(ma*R)+ea(W*M))+ea(V*ca));ca=ea(ea(ea(ma*ja)+ea(W*ia))+ea(V*L));L=ea(ea($*ha)+ea(ea(da*ba)+ea(T*U)));V=ea(ea(aa*ha)+ea(ea(oa*ba)+ea(na*U)));ia=ea(ea(K*ga)+ea(ea(P*O)+ea(z*Q)));W=ea(ea($*ga)+ea(ea(da*O)+ea(T*Q)));ja=ea(ea(aa*ga)+ea(ea(oa*O)+ea(na*Q)));Q=ea(ea(K*ca)+ea(ea(P*N)+ea(z*fa)));O=ea(ea($*ca)+ea(ea(da*N)+ea(T*fa)));T=ea(ea(aa*ca)+ea(ea(oa*N)+ea(na*fa)));g[w>>2]=ea(ea(K*ha)+ea(ea(P*ba)+ea(z*U)));g[w+4>>2]=L;g[w+8>>2]=V;g[w+12>>2]=ia;g[w+16>>2]=W;g[w+20>>2]=ja;g[w+24>>2]=Q;g[w+28>>2]=O;g[w+32>>2]=T;g[w+36>>2]=ea(g[E>>2]);g[w+40>>2]=ea(g[F>>2]);g[w+44>>2]=ea(g[D>>2]);qLa(u,d,w,o,y,m,S,Y);i=f;return}case 6:{c[x>>2]=6;c[x+4>>2]=0;g[x+8>>2]=ea(1.0);g[x+12>>2]=ea(1.0);g[x+16>>2]=ea(1.0);c[x+20>>2]=0;_n[c[(c[b>>2]|0)+60>>2]&4095](b,x)|0;rLa(x,d,p,o,y,m,S,Y);i=f;return}default:{i=f;return}}}function u2(d){d=d|0;c[d>>2]=0;b[d+4>>1]=0;a[d+6>>0]=1;a[d+7>>0]=0;c[d+8>>2]=0;b[d+12>>1]=0;a[d+14>>0]=1;a[d+15>>0]=0;return}function v2(a,b){a=a|0;b=b|0;var c=0;c=i;BKa(a,b);BKa(a+8|0,b);i=c;return}function w2(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=d+4|0;l=e[k>>1]|0;yKa(d,f);m=d+8|0;yKa(m,0);n=LU(g)|0;if((n|0)!=0?(j2(j,f),(a[j>>0]&2)!=0):0){j=b[g+4>>1]|0;if((b[k>>1]|0)==1)o=d;else o=c[d>>2]|0;k=pCa(n+3376|0,c[o+(l<<2)>>2]|0,g,j<<16>>16==5|j<<16>>16==15,0)|0;if((b[d+12>>1]|0)==1)p=m;else p=c[m>>2]|0;c[p+(l<<2)>>2]=k}LWa(g+(c[427044+(e[g+4>>1]<<2)>>2]|0)|0,f+32|0);fTa(f+16|0)|0;if(!(mo[c[(c[f>>2]|0)+140>>2]&4095](f)|0)){i=h;return}f2(f,g);i=h;return}function x2(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=zKa(d,f)|0;m=g+(c[427044+(e[g+4>>1]<<2)>>2]|0)|0;n=LU(g)|0;if((n|0)!=0?(j2(k,f),(a[k>>0]&2)!=0):0){k=d+8|0;if((b[d+12>>1]|0)==1)o=k;else o=c[k>>2]|0;rCa(n+3376|0,c[o+(l<<2)>>2]|0)}o=f+12|0;n=f+16|0;MWa(m,f+32|0,h,(c[n>>2]|0)==1);AKa(d,l);AKa(d+8|0,l);if(k2(f)|0)f2(f,0);if(gTa(n)|0){i=j;return}ko[c[(c[o>>2]|0)+8>>2]&4095](o);i=j;return}function y2(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b[a+4>>1]|0;if(f<<16>>16==1)g=a;else g=c[a>>2]|0;if(d)z2(a,d+3376|0);if(!(f<<16>>16)){xKa(a);h=a+8|0;xKa(h);i=e;return}d=f&65535;f=0;do{j=c[g+(f<<2)>>2]|0;if(k2(j)|0)f2(j,0);k=j+12|0;if(!(gTa(j+16|0)|0))ko[c[(c[k>>2]|0)+8>>2]&4095](k);f=f+1|0}while((f|0)!=(d|0));xKa(a);h=a+8|0;xKa(h);i=e;return}function z2(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f;h=b[d+4>>1]|0;if(h<<16>>16==1)j=d;else j=c[d>>2]|0;k=h&65535;l=d+8|0;if((b[d+12>>1]|0)==1)m=l;else m=c[l>>2]|0;if(!(h<<16>>16)){i=f;return}h=k+-1|0;l=0;do{if(l>>>0<h>>>0){d=c[j+(l+1<<2)>>2]|0;n=d;o=VEi(n|0,0,6)|0;p=H;q=_Ei(n|0,0,207,0)|0;n=VEi(q|0,H|0,6)|0;q=H;r=ZEi(1,0,o|0,p|0)|0;p=_Ei(r|0,H|0,n|0,q|0)|0;q=p;p=H;n=d;while(1){q=_Ei(q|0,p|0,-1,-1)|0;p=H;if((q|0)==0&(p|0)==0)break;else n=n+64|0}}j2(g,c[j+(l<<2)>>2]|0);n=m+(l<<2)|0;if(a[g>>0]&2)rCa(e,c[n>>2]|0);c[n>>2]=0;l=l+1|0}while((l|0)!=(k|0));i=f;return}function A2(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=b[a+4>>1]|0;if(h<<16>>16==1)j=a;else j=c[a>>2]|0;a=(h&65535)-f|0;h=(a|0)<0?0:a;a=h>>>0<e>>>0?h:e;YEi(d|0,j+(f<<2)|0,a<<2|0)|0;i=g;return a|0}function B2(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im;f=i;i=i+96|0;h=f+56|0;j=f+32|0;k=f;g[a>>2]=ea(8507058669999999534545717.0e13);l=a+4|0;g[l>>2]=ea(8507058669999999534545717.0e13);m=a+8|0;g[m>>2]=ea(8507058669999999534545717.0e13);n=a+12|0;g[n>>2]=ea(-8507058669999999534545717.0e13);o=a+16|0;g[o>>2]=ea(-8507058669999999534545717.0e13);p=a+20|0;g[p>>2]=ea(-8507058669999999534545717.0e13);q=d+4|0;r=b[q>>1]|0;In[c[(c[e>>2]|0)+84>>2]&4095](h,e);if((b[q>>1]|0)==1)s=d;else s=c[d>>2]|0;if(!(r<<16>>16)){i=f;return}d=h+12|0;q=h+4|0;e=h+8|0;t=h+16|0;u=h+20|0;v=h+24|0;w=k+4|0;x=k+8|0;y=k+12|0;z=k+16|0;A=k+20|0;B=k+24|0;C=j+4|0;D=j+8|0;E=j+12|0;F=j+16|0;G=j+20|0;H=r&65535;I=ea(8507058669999999534545717.0e13);r=0;do{J=s+(r<<2)|0;K=c[J>>2]|0;L=c[K+36>>2]|0;if(L&1){M=K+40|0;N=c[M>>2]|0;if(!N){O=s4(c[K+32>>2]|0,L>>>24&15)|0;c[M>>2]=O;M=c[J>>2]|0;P=O;Q=c[M+36>>2]|0;R=M}else{P=N;Q=L;R=K}}else{P=K+116|0;Q=L;R=K}if(!(Q&4))S=R+80|0;else{K=R+40|0;L=c[K>>2]|0;if(!L){N=s4(c[R+32>>2]|0,Q>>>24&15)|0;c[K>>2]=N;T=N}else T=L;S=T+64|0}U=ea(ea(g[S+16>>2])*ea(2.0));V=ea(ea(g[S+20>>2])*ea(2.0));W=ea(ea(g[S+24>>2])*ea(2.0));X=ea(g[d>>2]);Y=ea(ea(X*X)+ea(-.5));Z=ea(g[h>>2]);_=ea(U*Z);$=ea(g[q>>2]);aa=ea(_+ea(V*$));_=ea(g[e>>2]);ba=ea(aa+ea(W*_));aa=ea(ea(Z*ba)+ea(ea(U*Y)+ea(X*ea(ea(W*$)-ea(V*_)))));ca=ea(ea($*ba)+ea(ea(V*Y)+ea(X*ea(ea(U*_)-ea(W*Z)))));da=ea(ea(ea(W*Y)+ea(X*ea(ea(V*Z)-ea(U*$))))+ea(_*ba));ba=ea(ea(g[t>>2])+aa);aa=ea(ea(g[u>>2])+ca);ca=ea(ea(g[v>>2])+da);da=ea(g[S>>2]);U=ea(X*da);V=ea(g[S+12>>2]);Y=ea(U+ea(Z*V));U=ea(g[S+8>>2]);W=ea(Y+ea($*U));Y=ea(g[S+4>>2]);fa=ea(ea(ea(_*da)+ea(ea($*V)+ea(X*Y)))-ea(Z*U));ga=ea(ea(ea(Z*Y)+ea(ea(_*V)+ea(X*U)))-ea($*da));ha=ea(ea(ea(ea(X*V)-ea(Z*da))-ea($*Y))-ea(_*U));g[k>>2]=ea(W-ea(_*Y));g[w>>2]=fa;g[x>>2]=ga;g[y>>2]=ha;g[z>>2]=ba;g[A>>2]=aa;g[B>>2]=ca;oMa(P,j,k,ea(0.0),0);ca=ea(g[j>>2]);I=I<ca?I:ca;ca=ea(g[l>>2]);aa=ea(g[C>>2]);ba=ea(g[m>>2]);ha=ea(g[D>>2]);g[l>>2]=ca<aa?ca:aa;g[m>>2]=ba<ha?ba:ha;ha=ea(g[n>>2]);ba=ea(g[E>>2]);aa=ea(g[o>>2]);ca=ea(g[F>>2]);ga=ea(g[p>>2]);fa=ea(g[G>>2]);g[n>>2]=ha>ba?ha:ba;g[o>>2]=aa>ca?aa:ca;g[p>>2]=ga>fa?ga:fa;r=r+1|0}while((r|0)!=(H|0));g[a>>2]=I;i=f;return}function C2(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;f=b[a+4>>1]|0;if(f<<16>>16!=1)if(!(f<<16>>16)){i=e;return}else g=c[a>>2]|0;else g=a;a=d+2448|0;d=f&65535;f=0;do{h=c[g+(f<<2)>>2]|0;if(c[h+36>>2]&268435456)L3(a,h+32|0);f=f+1|0}while((f|0)!=(d|0));i=e;return}function D2(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=zKa(a,f)|0;f=b[e+4>>1]|0;if((b[a+4>>1]|0)==1)j=a;else j=c[a>>2]|0;k=pCa(d,c[j+(h<<2)>>2]|0,e,f<<16>>16==5|f<<16>>16==15,0)|0;f=a+8|0;if((b[a+12>>1]|0)==1){l=f;m=l+(h<<2)|0;c[m>>2]=k;i=g;return}else{l=c[f>>2]|0;m=l+(h<<2)|0;c[m>>2]=k;i=g;return}}function E2(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=zKa(a,e)|0;e=a+8|0;h=a+12|0;if((b[h>>1]|0)==1)j=e;else j=c[e>>2]|0;rCa(d,c[j+(g<<2)>>2]|0);if((b[h>>1]|0)==1){k=e;l=k+(g<<2)|0;c[l>>2]=0;i=f;return}else{k=c[e>>2]|0;l=k+(g<<2)|0;c[l>>2]=0;i=f;return}}function F2(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;h=(LU(e)|0)+3376|0;j=b[d+4>>1]|0;if(j<<16>>16!=1){k=b[e+4>>1]|0;if(!(j<<16>>16)){i=f;return}else{l=k<<16>>16==5|k<<16>>16==15;m=c[d>>2]|0}}else{k=b[e+4>>1]|0;l=k<<16>>16==5|k<<16>>16==15;m=d}k=d+8|0;n=d+12|0;d=j&65535;j=0;do{o=m+(j<<2)|0;j2(g,c[o>>2]|0);if(a[g>>0]&2){p=pCa(h,c[o>>2]|0,e,l,0)|0;if((b[n>>1]|0)==1)q=k;else q=c[k>>2]|0;c[q+(j<<2)>>2]=p}j=j+1|0}while((j|0)!=(d|0));i=f;return}function G2(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b[a+4>>1]|0;g=a+8|0;if((b[a+12>>1]|0)==1)h=g;else h=c[g>>2]|0;if(!(f<<16>>16)){i=e;return}g=f&65535;f=0;do{a=c[h+(f<<2)>>2]|0;if(a)oCa(d,a);f=f+1|0}while((f|0)!=(g|0));i=e;return}function H2(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;f=zKa(a,d)|0;d=a+8|0;if((b[a+12>>1]|0)==1)g=d;else g=c[d>>2]|0;i=e;return c[g+(f<<2)>>2]|0}function I2(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im;j=i;i=i+208|0;k=j+176|0;l=j+152|0;m=j+124|0;n=j+96|0;o=j+32|0;p=j;q=b[d+4>>1]|0;if(q<<16>>16==1)r=d;else r=c[d>>2]|0;In[c[(c[h>>2]|0)+84>>2]&4095](k,h);if((q&65535)>1)s=ea(Um[c[(c[f>>2]|0)+296>>2]&63](f,15))!=ea(0.0);else s=0;if(!(q<<16>>16)){i=j;return}f=n+16|0;d=n+20|0;t=n+24|0;u=k+12|0;v=k+4|0;w=k+8|0;x=k+16|0;y=k+20|0;z=k+24|0;A=n+12|0;B=n+8|0;C=n+4|0;D=m+4|0;E=m+8|0;F=m+12|0;G=m+16|0;H=m+20|0;I=m+24|0;J=l+4|0;K=l+8|0;L=l+12|0;M=l+16|0;N=l+20|0;O=q&65535;if(s){P=ea(8507058669999999534545717.0e13);Q=ea(8507058669999999534545717.0e13);R=ea(8507058669999999534545717.0e13);S=ea(-8507058669999999534545717.0e13);T=ea(-8507058669999999534545717.0e13);U=ea(-8507058669999999534545717.0e13);V=0}else{q=0;do{W=r+(q<<2)|0;X=c[W>>2]|0;Y=X+32|0;Z=c[X+36>>2]|0;if(!(Z&64))_=X+112|0;else{$=X+40|0;X=c[$>>2]|0;if(!X){aa=s4(c[Y>>2]|0,Z>>>24&15)|0;c[$>>2]=aa;ba=aa}else ba=X;_=ba+116|0}if(a[_>>0]&8){X=c[W>>2]|0;co[c[(c[X>>2]|0)+164>>2]&2047](X,e,h)}q=q+1|0}while((q|0)!=(O|0));i=j;return}while(1){q=r+(V<<2)|0;_=c[q>>2]|0;ba=_+32|0;X=c[_+36>>2]|0;if(!(X&64))ca=_+112|0;else{W=_+40|0;_=c[W>>2]|0;if(!_){aa=s4(c[ba>>2]|0,X>>>24&15)|0;c[W>>2]=aa;da=aa}else da=_;ca=da+116|0}if(!(a[ca>>0]&8)){fa=P;ga=S;ha=Q;ia=R;ja=T;ka=U}else{_=c[q>>2]|0;co[c[(c[_>>2]|0)+164>>2]&2047](_,e,h);_=c[q>>2]|0;aa=c[_+36>>2]|0;if(aa&1){W=_+40|0;X=c[W>>2]|0;if(!X){ba=s4(c[_+32>>2]|0,aa>>>24&15)|0;c[W>>2]=ba;la=ba;ma=c[q>>2]|0}else{la=X;ma=_}}else{la=_+116|0;ma=_}In[c[(c[ma>>2]|0)+72>>2]&4095](n,ma);na=ea(ea(g[f>>2])*ea(2.0));oa=ea(ea(g[d>>2])*ea(2.0));pa=ea(ea(g[t>>2])*ea(2.0));qa=ea(g[u>>2]);ra=ea(ea(qa*qa)+ea(-.5));sa=ea(g[k>>2]);ta=ea(na*sa);ua=ea(g[v>>2]);va=ea(ta+ea(oa*ua));ta=ea(g[w>>2]);wa=ea(va+ea(pa*ta));va=ea(ea(sa*wa)+ea(ea(na*ra)+ea(qa*ea(ea(pa*ua)-ea(oa*ta)))));xa=ea(ea(ua*wa)+ea(ea(oa*ra)+ea(qa*ea(ea(na*ta)-ea(pa*sa)))));ya=ea(ea(ea(pa*ra)+ea(qa*ea(ea(oa*sa)-ea(na*ua))))+ea(ta*wa));wa=ea(ea(g[x>>2])+va);va=ea(ea(g[y>>2])+xa);xa=ea(ea(g[z>>2])+ya);ya=ea(g[n>>2]);na=ea(qa*ya);oa=ea(g[A>>2]);ra=ea(na+ea(sa*oa));na=ea(g[B>>2]);pa=ea(ra+ea(ua*na));ra=ea(g[C>>2]);za=ea(ea(ea(ta*ya)+ea(ea(ua*oa)+ea(qa*ra)))-ea(sa*na));Aa=ea(ea(ea(sa*ra)+ea(ea(ta*oa)+ea(qa*na)))-ea(ua*ya));Ba=ea(ea(ea(ea(qa*oa)-ea(sa*ya))-ea(ua*ra))-ea(ta*na));g[m>>2]=ea(pa-ea(ta*ra));g[D>>2]=za;g[E>>2]=Aa;g[F>>2]=Ba;g[G>>2]=wa;g[H>>2]=va;g[I>>2]=xa;oMa(la,l,m,ea(0.0),0);xa=ea(g[l>>2]);va=ea(g[J>>2]);wa=ea(g[K>>2]);Ba=ea(g[L>>2]);Aa=ea(g[M>>2]);za=ea(g[N>>2]);fa=P<xa?P:xa;ga=S>Ba?S:Ba;ha=Q<va?Q:va;ia=R<wa?R:wa;ja=T>Aa?T:Aa;ka=U>za?U:za}V=V+1|0;if((V|0)==(O|0))break;else{P=fa;Q=ha;R=ia;S=ga;T=ja;U=ka}}if(fa>ga|s^1){i=j;return}s=DKa(e,-65281)|0;g[o>>2]=ea(1.0);e=o+4|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[o+20>>2]=ea(1.0);e=o+24|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[o+40>>2]=ea(1.0);e=o+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[o+60>>2]=ea(1.0);e=EKa(s,o)|0;g[p>>2]=fa;g[p+4>>2]=ha;g[p+8>>2]=ia;g[p+12>>2]=ga;g[p+16>>2]=ja;g[p+20>>2]=ka;a[p+24>>0]=1;HKa(e,p)|0;i=j;return}function J2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;c[b>>2]=447368;c[b+80>>2]=d;d=b+84|0;c[d>>2]=0;c[b+88>>2]=0;c[b+92>>2]=0;c[b+96>>2]=0;c[b+100>>2]=0;c[b+104>>2]=0;c[b+4>>2]=-1;c[b+72>>2]=e;c[b+76>>2]=f;a[b+117>>0]=1;a[b+116>>0]=1;if(!e)h=0;else{NWa(d,e);h=c[b+104>>2]&2147483647}if(h>>>0>=f>>>0){i=g;return}NWa(b+96|0,f);i=g;return}function K2(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[a>>2]=447368;e=c[a+104>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+96>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+92>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){VJa(d,a);i=b;return}e=c[a+84>>2]|0;if(!e){VJa(d,a);i=b;return}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e);VJa(d,a);i=b;return}function L2(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=447368;d=c[a+104>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+96>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+92>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+84>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function M2(b){b=b|0;c[b+4>>2]=-1;c[b+88>>2]=0;c[b+100>>2]=0;a[b+117>>0]=1;a[b+116>>0]=1;return}function N2(a){a=a|0;var b=0;b=i;__(xCa(c[a+80>>2]|0)|0,a);i=b;return}function O2(a){a=a|0;var b=0,d=0;b=i;if(!(mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0)){d=-1;i=b;return d|0}d=(c[a+100>>2]|0)+(c[a+88>>2]|0)|0;i=b;return d|0}function P2(b){b=b|0;var d=0,e=0,f=0;d=i;if(((a[b+116>>0]|0)==0?(a[b+117>>0]|0)==0:0)?(e=c[b+80>>2]|0,(c[e+20>>2]|0)==(c[b+108>>2]|0)):0)f=(c[e+24>>2]|0)==(c[b+112>>2]|0);else f=0;i=d;return f|0}function Q2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;h=f;g[b+44>>2]=ea(g[e>>2]);g[b+48>>2]=ea(g[e+4>>2]);g[b+52>>2]=ea(g[e+8>>2]);g[b+56>>2]=ea(g[e+12>>2]);g[b+60>>2]=ea(g[e+16>>2]);g[b+64>>2]=ea(g[e+20>>2]);g[b+68>>2]=ea(g[e+24>>2]);e=b+4|0;c[e>>2]=c[d>>2];j=c[d>>2]|0;if(!j){k=d;l=c[k+4>>2]|0;m=e;c[m>>2]=c[k>>2];c[m+4>>2]=l}else if((j|0)==3){c[e>>2]=3;g[b+8>>2]=ea(g[d+4>>2]);g[b+12>>2]=ea(g[d+8>>2]);g[b+16>>2]=ea(g[d+12>>2])}else if((j|0)==2){c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2]}else{c[e>>2]=-1;dKa(bKa()|0,4,447432,152,447512,h);a[b+117>>0]=1;a[b+116>>0]=1;n=2;i=f;return n|0}a[b+117>>0]=1;a[b+116>>0]=1;h=R2(b,0,0,0)|0;e=R2(b,1,0,0)|0;n=(h|0)<(e|0)?e:h;i=f;return n|0}function R2(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+80|0;k=j+8|0;l=j+77|0;m=j+48|0;n=j+56|0;o=j+78|0;p=j;q=j+76|0;r=(g|0)==0;s=e+(f<<2)+72|0;do if(r){t=c[s>>2]|0;u=t+1|0;if(u>>>0<65){v=i;i=i+((1*(u<<4)|0)+15&-16)|0;w=v;x=1;break}v=sKa(l,(t<<4)+16|0,447432,188)|0;if(!v){a[e+f+116>>0]=1;t=bKa()|0;c[k>>2]=c[s>>2];dKa(t,16,447432,192,447576,k);y=3;i=j;return y|0}else{w=v;x=0}}else{w=g;x=0}while(0);l=e+(f*12|0)+84|0;c[m>>2]=0;c[m+4>>2]=0;OWa(l,0,m);m=(f|0)!=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;b[n+16>>1]=m?2:1;a[n+18>>0]=0;v=c[s>>2]|0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=-1;t=k+20|0;a[t>>0]=0;c[k+24>>2]=w;c[k+28>>2]=v+1;u=k+32|0;c[u>>2]=0;c[k>>2]=420288;if(r){r=xCa(c[e+80>>2]|0)|0;Km[c[(c[r>>2]|0)+356>>2]&127](r,e+4|0,e+44|0,k,n,0)|0;z=c[s>>2]|0;A=(d[t>>0]|0)+(c[u>>2]|0)|0}else{z=v;A=h}if((A|0)>(z|0)){if(!(x|(w|0)==(g|0)))tKa(o,w);a[e+f+116>>0]=1;y=1;i=j;return y|0}if((A|0)>0){o=p+4|0;z=e+(f*12|0)+92|0;h=e+(f*12|0)+88|0;v=0;do{c[p>>2]=c[w+(v<<4)>>2];c[o>>2]=c[w+(v<<4)+4>>2];u=c[h>>2]|0;if((c[z>>2]&2147483647)>>>0>u>>>0){t=(c[l>>2]|0)+(u<<3)|0;if(!t)B=u;else{u=p;s=c[u+4>>2]|0;n=t;c[n>>2]=c[u>>2];c[n+4>>2]=s;B=c[h>>2]|0}c[h>>2]=B+1}else PWa(l,p)|0;v=v+1|0}while((v|0)!=(A|0))}A=c[e+80>>2]|0;if(m)c[e+112>>2]=c[A+24>>2];else c[e+108>>2]=c[A+20>>2];a[e+f+116>>0]=0;if(x|(w|0)==(g|0)){y=0;i=j;return y|0}tKa(q,w);y=0;i=j;return y|0}function S2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0;e=i;f=b+0|0;b=a+4|0;h=f+40|0;do{c[f>>2]=c[b>>2];f=f+4|0;b=b+4|0}while((f|0)<(h|0));g[d>>2]=ea(g[a+44>>2]);g[d+4>>2]=ea(g[a+48>>2]);g[d+8>>2]=ea(g[a+52>>2]);g[d+12>>2]=ea(g[a+56>>2]);g[d+16>>2]=ea(g[a+60>>2]);g[d+20>>2]=ea(g[a+64>>2]);g[d+24>>2]=ea(g[a+68>>2]);d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=e;return d|0}function T2(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+80|0;g=f+56|0;h=f+77|0;j=f;k=f+76|0;l=d+4|0;if((c[l>>2]|0)==-1){i=f;return}m=d+80|0;n=d+112|0;o=g+16|0;p=g+18|0;q=j+4|0;r=j+8|0;s=j+12|0;t=j+20|0;u=j+24|0;v=j+28|0;w=j+32|0;x=j+36|0;y=j+40|0;z=j+44|0;A=j+48|0;B=j+52|0;C=d+44|0;if((a[d+116>>0]|0)==0?(c[(c[m>>2]|0)+20>>2]|0)==(c[d+108>>2]|0):0)D=0;else{E=c[d+72>>2]|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;b[o>>1]=1;a[p>>0]=0;F=E+1|0;if(F>>>0<66){G=i;i=i+1568|0;H=G;I=G+1040|0}else{G=sKa(h,F*24|0,447432,343)|0;H=G;I=G+(F<<4)|0}c[q>>2]=0;c[r>>2]=0;c[s>>2]=-1;a[t>>0]=0;c[u>>2]=H;c[v>>2]=F;c[w>>2]=0;c[j>>2]=447888;c[x>>2]=d;c[y>>2]=e;c[z>>2]=0;c[A>>2]=I;a[B>>0]=0;I=xCa(c[m>>2]|0)|0;Km[c[(c[I>>2]|0)+356>>2]&127](I,l,C,j,g,0)|0;I=a[B>>0]|0;if(E>>>0>64){tKa(k,H);D=I}else D=I}if((a[d+117>>0]|0)==0?(c[(c[m>>2]|0)+24>>2]|0)==(c[n>>2]|0):0)J=0;else{n=c[d+76>>2]|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;b[o>>1]=2;a[p>>0]=0;p=n+1|0;if(p>>>0<66){o=i;i=i+1568|0;K=o;L=o+1040|0}else{o=sKa(h,p*24|0,447432,343)|0;K=o;L=o+(p<<4)|0}c[q>>2]=0;c[r>>2]=0;c[s>>2]=-1;a[t>>0]=0;c[u>>2]=K;c[v>>2]=p;c[w>>2]=0;c[j>>2]=447888;c[x>>2]=d;c[y>>2]=e;c[z>>2]=1;c[A>>2]=L;a[B>>0]=0;L=xCa(c[m>>2]|0)|0;Km[c[(c[L>>2]|0)+356>>2]&127](L,l,C,j,g,0)|0;g=a[B>>0]|0;if(n>>>0>64){tKa(k,K);J=g}else J=g}if(D<<24>>24==0?(D=c[d+88>>2]|0,(D|0)!=0):0)co[c[c[e>>2]>>2]&2047](e,D,c[d+84>>2]|0);if(J<<24>>24==0?(J=c[d+100>>2]|0,(J|0)!=0):0)co[c[c[e>>2]>>2]&2047](e,J,c[d+96>>2]|0);ko[c[(c[e>>2]|0)+4>>2]&4095](e);i=f;return}function U2(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=b+88|0;if((c[f>>2]|0)>>>0>d>>>0){a[b+116>>0]=1;c[f>>2]=0}c[b+72>>2]=d;if((c[b+92>>2]&2147483647)>>>0>=d>>>0){i=e;return}NWa(b+84|0,d);i=e;return}function V2(a){a=a|0;return c[a+72>>2]|0}function W2(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=b+100|0;if((c[f>>2]|0)>>>0>d>>>0){a[b+117>>0]=1;c[f>>2]=0}c[b+76>>2]=d;if((c[b+104>>2]&2147483647)>>>0>=d>>>0){i=e;return}NWa(b+96|0,d);i=e;return}function X2(a){a=a|0;return c[a+76>>2]|0}function Y2(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=i;i=i+32|0;n=m;o=m+24|0;c[n>>2]=d;c[n+4>>2]=e;g[n+8>>2]=f;c[n+12>>2]=0;c[n+16>>2]=0;g[n+20>>2]=ea(0.0);b[o>>1]=b[j>>1]|0;j=QWa(a,n,h,o,k,l,ea(0.0))|0;i=m;return j|0}function Z2(a,d,e,f,h,j,k,l,m,n){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0;o=i;i=i+32|0;p=o;q=o+24|0;c[p>>2]=0;g[p+8>>2]=h;c[p+4>>2]=f;c[p+12>>2]=d;c[p+16>>2]=e;g[p+20>>2]=ea(0.0);b[q>>1]=b[k>>1]|0;k=RWa(a,p,j,q,l,m,n)|0;i=o;return k|0}function _2(a,d,e,f,h,j){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0;k=i;i=i+32|0;l=k;m=k+24|0;c[l+12>>2]=d;c[l+16>>2]=e;g[l+20>>2]=ea(0.0);c[l+4>>2]=0;c[l>>2]=0;b[m>>1]=0;e=SWa(a,l,f,m,h,j,ea(0.0))|0;i=k;return e|0}function $2(a,b){a=a|0;b=b|0;var c=Im,d=0;c=ea(g[b>>2]);d=a+60|0;g[d>>2]=ea(ea(g[d>>2])-c);c=ea(g[b+4>>2]);d=a+64|0;g[d>>2]=ea(ea(g[d>>2])-c);c=ea(g[b+8>>2]);b=a+68|0;g[b>>2]=ea(ea(g[b>>2])-c);return}function a3(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;c[g>>2]=3;b[a+4>>1]=12;b[a+6>>1]=3;h=a+8|0;c[h>>2]=0;c[a>>2]=449064;vU(a+12|0,0);c[h>>2]=0;c[a>>2]=448488;A3(a+20|0,g,d,e);c[a>>2]=447912;i=f;return}function b3(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=448488;B3(a+20|0);c[a>>2]=448776;MU(a);VJa(b,a);i=b;return}function c3(a){a=a|0;var b=0;b=i;c[a>>2]=448488;B3(a+20|0);c[a>>2]=448776;MU(a);i=b;return}function d3(a){a=a|0;return a+-32|0}function e3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[(c[b>>2]|0)+84>>2]|0;a[f>>0]=a[d>>0]|0;d=_n[g&4095](b,f)|0;i=e;return d|0}function f3(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+88>>2]&4095](a)|0;i=b;return d|0}function g3(a,b){a=a|0;b=b|0;return ((b|0)==3?a:0)|0}function h3(a,b){a=a|0;b=b|0;return ((b|0)==3?a:0)|0}function i3(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&32)){e=ea(Wga(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+4>>2]);i=b;return ea(e)}function j3(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){Xga(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+4>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|32;i=e;return}function k3(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&64)){e=ea(Yga(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+8>>2]);i=b;return ea(e)}function l3(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){Zga(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+8>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|64;i=e;return}function m3(a){a=a|0;var b=0,c=Im;b=i;c=ea(yha(a+32|0));i=b;return ea(c)}function n3(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==2)g=2;else if((f|0)==3){i=e;return}if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}zha(b+32|0,d);i=e;return}function o3(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;c[g>>2]=2;b[a+4>>1]=11;b[a+6>>1]=3;h=a+8|0;c[h>>2]=0;c[a>>2]=450688;vU(a+12|0,0);c[h>>2]=0;c[a>>2]=450176;A3(a+20|0,g,d,e);c[a>>2]=449360;i=f;return}function p3(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=450176;B3(a+20|0);c[a>>2]=450432;MU(a);VJa(b,a);i=b;return}function q3(a){a=a|0;var b=0;b=i;c[a>>2]=450176;B3(a+20|0);c[a>>2]=450432;MU(a);i=b;return}function r3(a){a=a|0;return a+-32|0}function s3(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+2|0;k=h;l=d+32|0;pha(k,l);if(g){g=(e[k>>1]|f)&65535;b[k>>1]=g;m=g}else{g=b[k>>1]&((f^65535)&65535);b[k>>1]=g;m=g}g=(c[d+24>>2]|0)>>>30;if((g|0)==2)n=5;else if((g|0)==3){i=h;return}if((n|0)==5?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0){i=h;return}b[j>>1]=m;qha(l,j);i=h;return}function t3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=b+4|0;h=c[g>>2]|0;j=h>>>30;if((j+-1|0)>>>0<2)k=c[b>>2]|0;else k=0;if((j|0)==3){i=e;return}if((k|0)!=0?(a[k+2417>>0]|0)!=0:0){k=b+8|0;l=c[k>>2]|0;if(!l){m=s4(c[b>>2]|0,h>>>24&15)|0;c[k>>2]=m;n=m}else n=l;l=c[n+8>>2]|0;a:do if((l|0)!=-1?(m=c[(c[b>>2]|0)+2512>>2]|0,k=n+12|0,h=c[k>>2]|0,(h|0)!=0):0){o=0;while(1){p=m+(o+l<<2)|0;o=o+1|0;if((c[p>>2]|0)==(d|0))break;if(o>>>0>=h>>>0)break a}c[p>>2]=c[m+(l+-1+h<<2)>>2];c[k>>2]=h+-1}while(0);l=c[n>>2]|0;p=c[b>>2]|0;if((l|0)==-1){o=p+2512|0;q=c[p+2516>>2]|0;r=q+(c[b+20>>2]|0)|0;c[f>>2]=0;xWa(o,r,f);c[n>>2]=q;s=(c[o>>2]|0)+(q<<2)|0}else s=(c[p+2512>>2]|0)+(l<<2)|0;l=n+4|0;n=c[l>>2]|0;c[s+(n<<2)>>2]=d;c[l>>2]=n+1;if((j|0)==1){c[g>>2]=c[g>>2]|1;i=e;return}else{r4(c[b>>2]|0,b);c[g>>2]=c[g>>2]|1;i=e;return}}c[(c[450992+(((c[d+4>>2]|0)>>>24&15)<<2)>>2]|0)+d>>2]=c[b+16>>2];i=e;return}function u3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f;h=b+4|0;j=c[h>>2]|0;if(((j>>>30)+-1|0)>>>0<2)k=c[b>>2]|0;else k=0;if((j&-1073741824|0)==-1073741824){i=f;return}if((k|0)!=0?(a[k+2417>>0]|0)!=0:0){k=b+8|0;l=c[k>>2]|0;if(!l){m=s4(c[b>>2]|0,j>>>24&15)|0;c[k>>2]=m;n=m}else n=l;l=c[n>>2]|0;m=c[b>>2]|0;a:do if((l|0)!=-1?(k=c[m+2512>>2]|0,j=n+4|0,o=c[j>>2]|0,(o|0)!=0):0){p=0;while(1){q=k+(p+l<<2)|0;p=p+1|0;if((c[q>>2]|0)==(d|0))break;if(p>>>0>=o>>>0)break a}c[q>>2]=c[k+(l+-1+o<<2)>>2];c[j>>2]=o+-1;i=f;return}while(0);l=n+8|0;q=c[l>>2]|0;if((q|0)==-1){p=m+2512|0;r=c[m+2516>>2]|0;s=r+(c[b+20>>2]|0)|0;c[g>>2]=0;xWa(p,s,g);c[l>>2]=r;t=(c[p>>2]|0)+(r<<2)|0}else t=(c[m+2512>>2]|0)+(q<<2)|0;q=n+12|0;n=c[q>>2]|0;c[t+(n<<2)>>2]=d;c[q>>2]=n+1;r4(c[b>>2]|0,b);c[h>>2]=c[h>>2]|2;i=f;return}n=(c[450992+(((c[d+4>>2]|0)>>>24&15)<<2)>>2]|0)+d|0;c[n>>2]=-1;if((((c[h>>2]|0)>>>30)+-1|0)>>>0>=2){i=f;return}if((c[b>>2]|0)==0|e^1){i=f;return}h7(n);i=f;return}function v3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+4|0;f=c[e>>2]|0;g=f>>>30;if((g|0)==2)if(!(a[(c[b>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){wY(b);i=d;return}else if((h|0)==4){c[e>>2]=f|536870912;i=d;return}}function w3(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h;c[a>>2]=0;c[a+8>>2]=0;k=a+4|0;c[k>>2]=0;b[j>>1]=b[g>>1]|0;aja(a+12|0,d,e,f,j);c[k>>2]=c[k>>2]&-251658241|184549376;i=h;return}function x3(a){a=a|0;var b=0;b=i;cja(a+12|0);i=b;return}function y3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=a+4|0;if(c[e>>2]|0){i=d;return}c[e>>2]=UJa(d,b*12|0,451040,48)|0;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,12,h?482432:544544,451040,49)|0;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[a>>2]=g;a=(b+31|0)>>>5;b=c[g>>2]|0;if(!a){j=b;k=0}else{e=g+8|0;if(b)VJa(e,b);c[h>>2]=a;b=UJa(e,a<<2,543784,362)|0;c[g>>2]=b;j=b;k=c[h>>2]<<2}PEi(j|0,0,k|0)|0;i=d;return}function z3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+1|0;f=d;g=c[b>>2]|0;if(!g){h=b+8|0;a[h>>0]=0;i=d;return}j=c[g>>2]|0;if((j|0)!=0?(c[g+4>>2]|0)>-1:0)VJa(g+8|0,j);VJa(e,g);c[b>>2]=0;g=b+4|0;VJa(f,c[g>>2]|0);c[g>>2]=0;h=b+8|0;a[h>>0]=0;i=d;return}function A3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;c[b>>2]=0;c[b+8>>2]=0;h=b+4|0;c[h>>2]=0;Nga(b+12|0,d,e,f);f=b+152|0;c[b+168>>2]=0;c[b+172>>2]=0;a[b+176>>0]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;a[f+12>>0]=0;c[h>>2]=c[h>>2]&-251658241|117440512;i=g;return}function B3(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+152|0;e=c[d>>2]|0;if(e){ko[c[(c[e>>2]|0)+12>>2]&4095](e);c[d>>2]=0}Pga(a+12|0);i=b;return}function C3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=(c[b+4>>2]|0)>>>30;if((g|0)==3)h=3;else if((g|0)==2?(a[(c[b>>2]|0)+2417>>0]|0)!=0:0)h=3;if((h|0)==3){dKa(bKa()|0,8,451040,92,451136,f);j=0;i=e;return j|0}h=c[b+152>>2]|0;if(!h){j=Cha(b+12|0,d)|0;i=e;return j|0}g=h+72|0;if(!(a[g>>0]|0))k=h+73|0;else{l=bKa()|0;m=h+73|0;c[f>>2]=451208;c[f+4>>2]=m;dKa(l,8,451512,67,451608,f);k=m}UEi(k|0,451208,128)|0;a[h+200>>0]=0;a[g>>0]=1;g=Cha(b+12|0,d)|0;ko[c[(c[h>>2]|0)+4>>2]&4095](h);j=g;i=e;return j|0}function D3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;h=c[b+152>>2]|0;j=(h|0)==0;if(!j){k=h+72|0;if(!(a[k>>0]|0))l=h+73|0;else{m=bKa()|0;n=h+73|0;c[g>>2]=451248;c[g+4>>2]=n;dKa(m,8,451512,67,451608,g);l=n}UEi(l|0,451248,128)|0;a[h+200>>0]=0;a[k>>0]=1}do if(d){k=(c[b+4>>2]|0)>>>30;if((k|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)o=9}else if((k|0)==3)o=9;if((o|0)==9){dKa(bKa()|0,8,451040,117,451136,g);break}Dha(b+12|0,d,e);if(a[b+164>>0]|0){k=c[e>>2]|0;l=e+4|0;n=c[c[b+156>>2]>>2]|0;m=0;do{p=c[k+(da(c[l>>2]|0,m)|0)>>2]|0;q=n+(p>>>5<<2)|0;c[q>>2]=c[q>>2]&~(1<<(p&31));m=m+1|0}while((m|0)!=(d|0))}if(a[b+176>>0]|0){m=c[e>>2]|0;n=e+4|0;l=c[c[b+168>>2]>>2]|0;k=0;do{p=c[m+(da(c[n>>2]|0,k)|0)>>2]|0;q=l+(p>>>5<<2)|0;c[q>>2]=c[q>>2]&~(1<<(p&31));k=k+1|0}while((k|0)!=(d|0))}}while(0);if(j){i=f;return}ko[c[(c[h>>2]|0)+4>>2]&4095](h);i=f;return}function E3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[b+152>>2]|0;g=(f|0)==0;if(!g){h=f+72|0;if(!(a[h>>0]|0))j=f+73|0;else{k=bKa()|0;l=f+73|0;c[e>>2]=451248;c[e+4>>2]=l;dKa(k,8,451512,67,451608,e);j=l}UEi(j|0,451248,128)|0;a[f+200>>0]=0;a[h>>0]=1}h=(c[b+4>>2]|0)>>>30;if((h|0)==2)if(!(a[(c[b>>2]|0)+2417>>0]|0))m=9;else m=8;else if((h|0)==3)m=8;else m=9;if((m|0)==8)dKa(bKa()|0,8,451040,143,451136,e);else if((m|0)==9){Eha(b+12|0);m=b+164|0;if(a[m>>0]|0){e=c[b+156>>2]|0;PEi(c[e>>2]|0,0,c[e+4>>2]<<2|0)|0;a[m>>0]=0}m=b+176|0;if(a[m>>0]|0){e=c[b+168>>2]|0;PEi(c[e>>2]|0,0,c[e+4>>2]<<2|0)|0;a[m>>0]=0}}if(g){i=d;return}ko[c[(c[f>>2]|0)+4>>2]&4095](f);i=d;return}function F3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=c[b+152>>2]|0;k=(j|0)==0;if(!k){l=j+72|0;if(!(a[l>>0]|0))m=j+73|0;else{n=bKa()|0;o=j+73|0;c[h>>2]=451288;c[h+4>>2]=o;dKa(n,8,451512,67,451608,h);m=o}UEi(m|0,451288,128)|0;a[j+200>>0]=0;a[l>>0]=1}l=(c[b+4>>2]|0)>>>30;if((l|0)==2)if(!(a[(c[b>>2]|0)+2417>>0]|0))p=9;else p=8;else if((l|0)==3)p=8;else p=9;if((p|0)==8)dKa(bKa()|0,8,451040,165,451136,h);else if((p|0)==9)Fha(b+12|0,d,e,f);if(k){i=g;return}ko[c[(c[j>>2]|0)+4>>2]&4095](j);i=g;return}function G3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=c[b+152>>2]|0;k=(j|0)==0;if(!k){l=j+72|0;if(!(a[l>>0]|0))m=j+73|0;else{n=bKa()|0;o=j+73|0;c[h>>2]=451320;c[h+4>>2]=o;dKa(n,8,451512,67,451608,h);m=o}UEi(m|0,451320,128)|0;a[j+200>>0]=0;a[l>>0]=1}l=(c[b+4>>2]|0)>>>30;if((l|0)==3)p=8;else if((l|0)==2?(a[(c[b>>2]|0)+2417>>0]|0)!=0:0)p=8;else p=9;if((p|0)==8)dKa(bKa()|0,8,451040,184,451136,h);else if((p|0)==9)Gha(b+12|0,d,e,f);if(k){i=g;return}ko[c[(c[j>>2]|0)+4>>2]&4095](j);i=g;return}function H3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=c[b+152>>2]|0;k=(j|0)==0;if(!k){l=j+72|0;if(!(a[l>>0]|0))m=j+73|0;else{n=bKa()|0;o=j+73|0;c[h>>2]=451352;c[h+4>>2]=o;dKa(n,8,451512,67,451608,h);m=o}UEi(m|0,451352,128)|0;a[j+200>>0]=0;a[l>>0]=1}l=(c[b+4>>2]|0)>>>30;if((l|0)==2)if(!(a[(c[b>>2]|0)+2417>>0]|0))p=9;else p=8;else if((l|0)==3)p=8;else p=9;if((p|0)==8)dKa(bKa()|0,8,451040,203,451136,h);else if((p|0)==9)Hha(b+12|0,d,e,f);if(k){i=g;return}ko[c[(c[j>>2]|0)+4>>2]&4095](j);i=g;return}function I3(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0;j=i;i=i+16|0;k=j;l=c[b+4>>2]|0;m=l>>>30;if((m|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)n=3}else if((m|0)==3)n=3;if((n|0)==3){dKa(bKa()|0,8,451040,220,451136,k);i=j;return}if(!(l&1024))o=ea(aha(b+12|0));else{n=b+8|0;m=c[n>>2]|0;if(!m){p=s4(c[b>>2]|0,l>>>24&15)|0;c[n>>2]=p;q=p}else q=m;o=ea(g[q+44>>2])}if((h|0)==1){r=0;s=ea(ea(1.0)/o)}else if((h|0)==3){r=1;s=ea(1.0)}else if((h|0)==2){r=0;s=ea(1.0)}else if(!h){r=1;s=ea(ea(1.0)/o)}else{dKa(bKa()|0,2,451040,250,451392,k);r=1;s=ea(ea(1.0)/o)}k=r?b+156|0:b+168|0;y3(k,rha(b+12|0)|0);if(!d){i=j;return}b=c[e>>2]|0;r=e+4|0;e=c[f>>2]|0;h=f+4|0;f=c[c[k>>2]>>2]|0;q=k+4|0;m=0;do{p=c[b+(da(c[r>>2]|0,m)|0)>>2]|0;n=da(c[h>>2]|0,m)|0;o=ea(s*ea(g[e+n>>2]));t=ea(s*ea(g[e+(n+4)>>2]));u=ea(s*ea(g[e+(n+8)>>2]));n=f+(p>>>5<<2)|0;l=c[n>>2]|0;v=1<<(p&31);if(!(l&v)){c[n>>2]=l|v;v=c[q>>2]|0;g[v+(p*12|0)>>2]=o;g[v+(p*12|0)+4>>2]=t;g[v+(p*12|0)+8>>2]=u}else{v=c[q>>2]|0;l=v+(p*12|0)|0;g[l>>2]=ea(o+ea(g[l>>2]));l=v+(p*12|0)+4|0;g[l>>2]=ea(t+ea(g[l>>2]));l=v+(p*12|0)+8|0;g[l>>2]=ea(u+ea(g[l>>2]))}m=m+1|0}while((m|0)!=(d|0));a[k+8>>0]=1;i=j;return}function J3(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=c[b+152>>2]|0;h=(g|0)==0;if(!h){j=g+72|0;if(!(a[j>>0]|0))k=g+73|0;else{l=bKa()|0;m=g+73|0;c[f>>2]=451456;c[f+4>>2]=m;dKa(l,8,451512,67,451608,f);k=m}UEi(k|0,451456,128)|0;a[g+200>>0]=0;a[j>>0]=1}j=b+164|0;if((a[j>>0]|0)!=0?(k=b+156|0,Iha(b+12|0,c[k>>2]|0,c[b+160>>2]|0,d),(a[j>>0]|0)!=0):0){m=c[k>>2]|0;PEi(c[m>>2]|0,0,c[m+4>>2]<<2|0)|0;a[j>>0]=0}j=b+176|0;if((a[j>>0]|0)!=0?(m=b+168|0,Iha(b+12|0,c[m>>2]|0,c[b+172>>2]|0,ea(1.0)),(a[j>>0]|0)!=0):0){b=c[m>>2]|0;PEi(c[b>>2]|0,0,c[b+4>>2]<<2|0)|0;a[j>>0]=0}if(h){i=e;return}ko[c[(c[g>>2]|0)+4>>2]&4095](g);i=e;return}function K3(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+16|0;f=e;h=c[d+152>>2]|0;j=(h|0)==0;if(!j){k=h+72|0;if(!(a[k>>0]|0))l=h+73|0;else{m=bKa()|0;n=h+73|0;c[f>>2]=451488;c[f+4>>2]=n;dKa(m,8,451512,67,451608,f);l=n}UEi(l|0,451488,128)|0;a[h+200>>0]=0;a[k>>0]=1}k=d+4|0;l=c[k>>2]|0;n=d+8|0;do if(l&16777215){m=c[n>>2]|0;if(!m){o=s4(c[d>>2]|0,l>>>24&15)|0;c[n>>2]=o;p=c[k>>2]|0;q=o}else{p=l;q=m}if(!(p&32))r=p;else{Xga(d+12|0,ea(g[q+4>>2]));r=c[k>>2]|0}if(!(r&64))s=r;else{Zga(d+12|0,ea(g[q+8>>2]));s=c[k>>2]|0}if(!(s&128))t=s;else{$ga(d+12|0,ea(g[q+12>>2]));t=c[k>>2]|0}if(!(t&256))u=t;else{Oga(d+12|0,q+16|0);u=c[k>>2]|0}if(!(u&512))v=u;else{Nha(d+12|0,q+28|0);v=c[k>>2]|0}if(!(v&1024))w=v;else{bha(d+12|0,ea(g[q+44>>2]));w=c[k>>2]|0}if(!(w&2048))x=w;else{dha(d+12|0,ea(g[q+48>>2]));x=c[k>>2]|0}if(!(x&4096))y=x;else{fha(d+12|0,ea(g[q+52>>2]));y=c[k>>2]|0}if(y&8192)hha(d+12|0,ea(g[q+56>>2]));if(l&65536)kha(d+12|0);m=c[k>>2]|0;if(!(m&16384))z=m;else{jha(d+12|0,q+60|0);z=c[k>>2]|0}if(!(z&32768))A=z;else{b[f>>1]=b[q+76>>1]|0;mha(d+12|0,f);A=c[k>>2]|0}if(!(A&7))B=A;else{m=A>>>24&15;o=(c[450992+(m<<2)>>2]|0)+d|0;C=c[n>>2]|0;if(!C){D=s4(c[d>>2]|0,m)|0;c[n>>2]=D;E=c[k>>2]|0;F=D}else{E=A;F=C}if(!(E&1))G=E;else{b[f>>1]=b[F>>1]|0;f7(o,f);G=c[k>>2]|0}if(!(G&2))H=G;else{g7(o,a[F+2>>0]|0);H=c[k>>2]|0}if(!(H&4)){B=H;break}a[o+11>>0]=a[F+3>>0]|0;B=c[k>>2]|0}}else B=l;while(0);c[n>>2]=0;c[k>>2]=B&-16777216;if(j){i=e;return}ko[c[(c[h>>2]|0)+4>>2]&4095](h);i=e;return}function L3(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;TWa(a,e)|0;i=d;return}function M3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=c[a+4>>2]|0;e=a+36|0;if(!(c[e>>2]|0)){i=b;return}else f=0;do{g=d+(f<<2)|0;h=c[g>>2]|0;j=h+4|0;k=c[j>>2]|0;l=k&268435455;if(((k>>>30)+-1|0)>>>0<2)c[j>>2]=l|-2147483648;else{c[j>>2]=l;c[h>>2]=0}if(k&536870912)wY(c[g>>2]|0);f=f+1|0;m=c[e>>2]|0}while(f>>>0<m>>>0);f=c[a+20>>2]|0;if((f|0)==0|(m|0)==0){i=b;return}PEi(c[a+12>>2]|0,-1,f<<2|0)|0;f=a+16|0;m=c[f>>2]|0;d=m+-1|0;g=a+8|0;k=c[g>>2]|0;if(!d){n=m;o=k}else{m=k;k=0;while(1){h=k+1|0;p=c[g>>2]|0;c[p+(k<<2)>>2]=h;if((h|0)==(d|0))break;else{m=p;k=h}}n=c[f>>2]|0;o=p}c[o+(n+-1<<2)>>2]=-1;c[a+28>>2]=0;c[e>>2]=0;i=b;return}function N3(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+16|0;j=h;eca(d+16|0,e,f);c[d+2400>>2]=0;c[d+2404>>2]=0;c[d+2408>>2]=0;f=d+2412|0;k=c[(qTa()|0)>>2]|0;if(k){l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,k,o?544576:544544,544464,111)|0;c[f>>2]=n;if(n)mTa(n)}else c[f>>2]=0;a[d+2416>>0]=0;a[d+2417>>0]=(c[e+152>>2]|0)==1&1;VWa(d+2420|0,16384);f=d+2448|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2472>>2]=ea(.75);c[d+2476>>2]=-1;c[d+2480>>2]=0;c[d+2484>>2]=0;WWa(f,64);f=d+2548|0;n=d+2488|0;o=n+60|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));g[f>>2]=ea(.75);c[d+2552>>2]=-1;c[d+2556>>2]=0;c[d+2560>>2]=0;WWa(d+2524|0,64);f=d+2564|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2588>>2]=ea(.75);c[d+2592>>2]=-1;c[d+2596>>2]=0;c[d+2600>>2]=0;WWa(f,64);f=d+2604|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2628>>2]=ea(.75);c[d+2632>>2]=-1;c[d+2636>>2]=0;c[d+2640>>2]=0;WWa(f,64);f=d+2644|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2668>>2]=ea(.75);c[d+2672>>2]=-1;c[d+2676>>2]=0;c[d+2680>>2]=0;WWa(f,64);f=d+2684|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2708>>2]=ea(.75);c[d+2712>>2]=-1;c[d+2716>>2]=0;c[d+2720>>2]=0;WWa(f,64);f=d+2724|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2748>>2]=ea(.75);c[d+2752>>2]=-1;c[d+2756>>2]=0;c[d+2760>>2]=0;WWa(f,64);f=d+2764|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2788>>2]=ea(.75);c[d+2792>>2]=-1;c[d+2796>>2]=0;c[d+2800>>2]=0;WWa(f,64);f=d+2804|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[d+2828>>2]=ea(.75);c[d+2832>>2]=-1;c[d+2836>>2]=0;c[d+2840>>2]=0;WWa(f,64);g[d+2844>>2]=ea(g[e+156>>2]);b[d+3332>>1]=0;n=d+3064|0;o=n+124|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));n=d+2996|0;o=n+37|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));n=d+3340|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;a[j>>0]=-1;mWa(d+3344|0,j)|0;c[d+3356>>2]=0;i=h;return}function O3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;qca(a+16|0);c[a+2492>>2]=0;c[a+2504>>2]=0;c[a+2516>>2]=0;e=a+2420|0;oTa(c[e>>2]|0);f=a+2436|0;g=(c[f>>2]|0)+2|0;h=a+2428|0;j=c[h>>2]|0;if(j>>>0<=g>>>0){c[f>>2]=0;k=a+2440|0;c[k>>2]=0;l=c[e>>2]|0;pTa(l);i=b;return}m=a+2424|0;n=j;do{j=n+-1|0;o=c[(c[m>>2]|0)+(j<<2)>>2]|0;c[h>>2]=j;VJa(d,o);n=c[h>>2]|0}while(n>>>0>g>>>0);c[f>>2]=0;k=a+2440|0;c[k>>2]=0;l=c[e>>2]|0;pTa(l);i=b;return}function P3(a){a=a|0;var b=0,c=0;b=i;c=a$(a)|0;i=b;return c|0}function Q3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+272|0;g=f;h=c[d+4>>2]|0;if((h&-1073741824|0)!=-2147483648){i=f;return}j=g+256|0;k=g+260|0;l=g+264|0;c[l>>2]=0;m=g+268|0;a[j>>0]=1;c[k>>2]=g;c[m>>2]=64;n=b+16|0;b=(c[450992+((h>>>24&15)<<2)>>2]|0)+d|0;if(e)Yda(n,b,g,1);else Wda(n,b,g,1);b=c[k>>2]|0;if(c[l>>2]|0){n=0;do{r2((c[b+(n<<2)>>2]|0)+-16|0);n=n+1|0}while(n>>>0<(c[l>>2]|0)>>>0)}l=c[m>>2]|0;if(!((l&2147483647|0)!=0&(l|0)>-1)){i=f;return}l=c[k>>2]|0;if((g|0)==(l|0)){a[j>>0]=0;i=f;return}if(!l){i=f;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,l);i=f;return}function R3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=b+4|0;if((c[g>>2]&-1073741824|0)!=-2147483648){i=e;return}h=o2()|0;j=h+-16|0;if(d){d=E_(b,f)|0;Xda(a+16|0,(c[450992+(((c[g>>2]|0)>>>24&15)<<2)>>2]|0)+b|0,c[f>>2]|0,d,h);k=d}else{d=R_(b,f)|0;Tda(a+16|0,(c[450992+(((c[g>>2]|0)>>>24&15)<<2)>>2]|0)+b|0,c[f>>2]|0,d,h);k=d}if(!k){i=e;return}else l=0;do{q2((c[(c[f>>2]|0)+(l<<2)>>2]|0)+j|0);l=l+1|0}while((l|0)!=(k|0));i=e;return}function S3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+816|0;h=f+544|0;j=f+272|0;k=f;l=b+2524|0;if(e){ZWa(b,d,l);i=f;return}XWa(b,d,l);if(!(a[b+2417>>0]|0)){i=f;return}l=c[b+1260>>2]|0;if(l){b=h+256|0;a[b>>0]=0;YWa(h,l+272|0);l=o2()|0;e=l+-16|0;m=R_(d,g)|0;n=c[d>>2]|0;o=c[d+4>>2]&-1073741824;if(m){p=l+-12|0;l=0;do{q=c[(c[g>>2]|0)+(l<<2)>>2]|0;r=q+p|0;s=c[r>>2]|0;if((s&251658240|0)==16777216){c[r>>2]=s&1073741823|o;c[q+e>>2]=n}l=l+1|0}while((l|0)!=(m|0))}m=c[h+268>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=f;return}m=c[h+260>>2]|0;if((h|0)==(m|0)){a[b>>0]=0;i=f;return}if(!m){i=f;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,m);i=f;return}m=j+256|0;b=j+260|0;c[j+264>>2]=0;h=j+268|0;a[m>>0]=1;c[b>>2]=j;c[h>>2]=64;l=k+256|0;a[l>>0]=0;YWa(k,j);n=o2()|0;e=n+-16|0;o=R_(d,g)|0;p=c[d>>2]|0;q=c[d+4>>2]&-1073741824;if(o){d=n+-12|0;n=0;do{s=c[(c[g>>2]|0)+(n<<2)>>2]|0;r=s+d|0;t=c[r>>2]|0;if((t&251658240|0)==16777216){c[r>>2]=t&1073741823|q;c[s+e>>2]=p}n=n+1|0}while((n|0)!=(o|0))}o=c[k+268>>2]|0;do if((o&2147483647|0)!=0&(o|0)>-1){n=c[k+260>>2]|0;if((k|0)==(n|0)){a[l>>0]=0;break}if(n){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,n)}}while(0);l=c[h>>2]|0;if(!((l&2147483647|0)!=0&(l|0)>-1)){i=f;return}l=c[b>>2]|0;if((j|0)==(l|0)){a[m>>0]=0;i=f;return}if(!l){i=f;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,l);i=f;return}function T3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+832|0;h=g+824|0;j=g+552|0;k=g+280|0;l=g+8|0;m=g+828|0;n=g;o=b+2524|0;do if(!f){p=b+2417|0;do if(a[p>>0]|0){q=d+4|0;r=c[q>>2]|0;s=r>>>30;if((s|0)==1){c[q>>2]=r&1073741823;c[h>>2]=d;TWa(o,h)|0;break}else if((s|0)!=2)break;c[q>>2]=r|-1073741824;if((r&268435456|0)==0?(c[n>>2]=d,r=UWa(o,n,m)|0,!((a[m>>0]|0)!=0|(r|0)==0)):0)c[r>>2]=c[n>>2]}else{_Wa(b+16|0,d,e);r=d+4|0;c[r>>2]=c[r>>2]&268435455;c[d>>2]=0}while(0);if(a[p>>0]|0){if(e){r=d+4|0;c[r>>2]=c[r>>2]|16}r=c[b+1260>>2]|0;if(r){q=j+256|0;a[q>>0]=0;YWa(j,r+272|0);r=o2()|0;s=r+-16|0;t=R_(d,h)|0;u=c[d>>2]|0;v=c[d+4>>2]&-1073741824;if(t){w=r+-12|0;r=0;do{x=c[(c[h>>2]|0)+(r<<2)>>2]|0;y=x+w|0;z=c[y>>2]|0;if((z&251658240|0)==16777216){c[y>>2]=z&1073741823|v;c[x+s>>2]=u}r=r+1|0}while((r|0)!=(t|0))}t=c[j+268>>2]|0;if(!((t&2147483647|0)!=0&(t|0)>-1))break;t=c[j+260>>2]|0;if((j|0)==(t|0)){a[q>>0]=0;break}if(!t)break;r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,t);break}t=k+256|0;r=k+260|0;c[k+264>>2]=0;u=k+268|0;a[t>>0]=1;c[r>>2]=k;c[u>>2]=64;s=l+256|0;a[s>>0]=0;YWa(l,k);v=o2()|0;w=v+-16|0;p=R_(d,h)|0;x=c[d>>2]|0;z=c[d+4>>2]&-1073741824;if(p){y=v+-12|0;v=0;do{A=c[(c[h>>2]|0)+(v<<2)>>2]|0;B=A+y|0;C=c[B>>2]|0;if((C&251658240|0)==16777216){c[B>>2]=C&1073741823|z;c[A+w>>2]=x}v=v+1|0}while((v|0)!=(p|0))}p=c[l+268>>2]|0;do if((p&2147483647|0)!=0&(p|0)>-1){v=c[l+260>>2]|0;if((l|0)==(v|0)){a[s>>0]=0;break}if(v){x=mKa()|0;In[c[(c[x>>2]|0)+12>>2]&4095](x,v)}}while(0);s=c[u>>2]|0;if((s&2147483647|0)!=0&(s|0)>-1){s=c[r>>2]|0;if((k|0)==(s|0)){a[t>>0]=0;break}if(s){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,s)}}}}else $Wa(b,d,o);while(0);o=d+4|0;c[o>>2]=c[o>>2]&-33;i=g;return}function U3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+832|0;h=f+816|0;j=f+544|0;k=f+272|0;l=f;m=b+2564|0;if(e){bXa(b,d,m);if((((((ea(g[d+228>>2])==ea(0.0)?ea(g[d+204>>2])==ea(0.0):0)?ea(g[d+208>>2])==ea(0.0):0)?ea(g[d+212>>2])==ea(0.0):0)?ea(g[d+216>>2])==ea(0.0):0)?ea(g[d+220>>2])==ea(0.0):0)?ea(g[d+224>>2])==ea(0.0):0){c[d+232>>2]=1;i=f;return}c[d+232>>2]=0;i=f;return}aXa(b,d,m);if((((((ea(g[d+228>>2])==ea(0.0)?ea(g[d+204>>2])==ea(0.0):0)?ea(g[d+208>>2])==ea(0.0):0)?ea(g[d+212>>2])==ea(0.0):0)?ea(g[d+216>>2])==ea(0.0):0)?ea(g[d+220>>2])==ea(0.0):0)?ea(g[d+224>>2])==ea(0.0):0)c[d+232>>2]=1;else c[d+232>>2]=0;if(!(a[b+2417>>0]|0)){i=f;return}m=c[b+1260>>2]|0;if(m){b=j+256|0;a[b>>0]=0;YWa(j,m+272|0);m=o2()|0;e=m+-16|0;n=E_(d,h)|0;o=c[d>>2]|0;p=c[d+4>>2]&-1073741824;if(n){q=m+-12|0;m=0;do{r=c[(c[h>>2]|0)+(m<<2)>>2]|0;s=r+q|0;t=c[s>>2]|0;if((t&251658240|0)==16777216){c[s>>2]=t&1073741823|p;c[r+e>>2]=o}m=m+1|0}while((m|0)!=(n|0))}n=c[j+268>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=f;return}n=c[j+260>>2]|0;if((j|0)==(n|0)){a[b>>0]=0;i=f;return}if(!n){i=f;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,n);i=f;return}n=k+256|0;b=k+260|0;c[k+264>>2]=0;j=k+268|0;a[n>>0]=1;c[b>>2]=k;c[j>>2]=64;m=l+256|0;a[m>>0]=0;YWa(l,k);o=o2()|0;e=o+-16|0;p=E_(d,h)|0;q=c[d>>2]|0;r=c[d+4>>2]&-1073741824;if(p){d=o+-12|0;o=0;do{t=c[(c[h>>2]|0)+(o<<2)>>2]|0;s=t+d|0;u=c[s>>2]|0;if((u&251658240|0)==16777216){c[s>>2]=u&1073741823|r;c[t+e>>2]=q}o=o+1|0}while((o|0)!=(p|0))}p=c[l+268>>2]|0;do if((p&2147483647|0)!=0&(p|0)>-1){o=c[l+260>>2]|0;if((l|0)==(o|0)){a[m>>0]=0;break}if(o){q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,o)}}while(0);m=c[j>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=f;return}m=c[b>>2]|0;if((k|0)==(m|0)){a[n>>0]=0;i=f;return}if(!m){i=f;return}n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,m);i=f;return}function V3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+832|0;h=g+824|0;j=g+552|0;k=g+280|0;l=g+8|0;m=g+828|0;n=g;if(f){dXa(b,d,b+2564|0);f=d+236|0;if(!(c[f>>2]&4096))o=d+60|0;else{p=d+8|0;q=c[p>>2]|0;if(!q){r=s4(c[d>>2]|0,(c[d+4>>2]|0)>>>24&15)|0;c[p>>2]=r;s=r}else s=q;o=s+268|0}if(!(a[o>>0]&1)){c[d+232>>2]=1;c[f>>2]=c[f>>2]&-49153}else eVa(d);f=d+4|0;c[f>>2]=c[f>>2]&-33;i=g;return}f=d+16|0;o=d+4|0;do if((c[o>>2]&-1073741824|0)==1073741824?(s=d+172|0,(c[s>>2]|0)!=0):0){q=h9(f,1)|0;r=(c[s>>2]|0)==0;if(q){if(r)break;c9(f,c[(c[d>>2]|0)+1256>>2]|0,1);break}if((!r?h9(f,0)|0:0)?(c[s>>2]|0)!=0:0)c9(f,c[(c[d>>2]|0)+1256>>2]|0,0)}while(0);f=b+2564|0;s=b+2417|0;do if(a[s>>0]|0){r=c[o>>2]|0;q=r>>>30;if((q|0)==1){c[o>>2]=r&1073741823;c[h>>2]=d;TWa(f,h)|0;break}else if((q|0)!=2)break;c[o>>2]=r|-1073741824;if((r&268435456|0)==0?(c[n>>2]=d,r=UWa(f,n,m)|0,!((a[m>>0]|0)!=0|(r|0)==0)):0)c[r>>2]=c[n>>2]}else{cXa(b+16|0,d,e);c[o>>2]=c[o>>2]&268435455;c[d>>2]=0}while(0);n=d+236|0;if(!(c[n>>2]&4096))t=d+60|0;else{m=d+8|0;f=c[m>>2]|0;if(!f){r=s4(c[d>>2]|0,(c[o>>2]|0)>>>24&15)|0;c[m>>2]=r;u=r}else u=f;t=u+268|0}if(!(a[t>>0]&1)){c[d+232>>2]=1;c[n>>2]=c[n>>2]&-49153}else eVa(d);n=c[o>>2]&-33;c[o>>2]=n;if(!(a[s>>0]|0)){i=g;return}if(e)c[o>>2]=n|16;n=c[b+1260>>2]|0;if(n){b=j+256|0;a[b>>0]=0;YWa(j,n+272|0);n=o2()|0;e=n+-16|0;s=E_(d,h)|0;t=c[d>>2]|0;u=c[o>>2]&-1073741824;if(s){f=n+-12|0;n=0;do{r=c[(c[h>>2]|0)+(n<<2)>>2]|0;m=r+f|0;q=c[m>>2]|0;if((q&251658240|0)==16777216){c[m>>2]=q&1073741823|u;c[r+e>>2]=t}n=n+1|0}while((n|0)!=(s|0))}s=c[j+268>>2]|0;if(!((s&2147483647|0)!=0&(s|0)>-1)){i=g;return}s=c[j+260>>2]|0;if((j|0)==(s|0)){a[b>>0]=0;i=g;return}if(!s){i=g;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,s);i=g;return}s=k+256|0;b=k+260|0;c[k+264>>2]=0;j=k+268|0;a[s>>0]=1;c[b>>2]=k;c[j>>2]=64;n=l+256|0;a[n>>0]=0;YWa(l,k);t=o2()|0;e=t+-16|0;u=E_(d,h)|0;f=c[d>>2]|0;d=c[o>>2]&-1073741824;if(u){o=t+-12|0;t=0;do{r=c[(c[h>>2]|0)+(t<<2)>>2]|0;q=r+o|0;m=c[q>>2]|0;if((m&251658240|0)==16777216){c[q>>2]=m&1073741823|d;c[r+e>>2]=f}t=t+1|0}while((t|0)!=(u|0))}u=c[l+268>>2]|0;do if((u&2147483647|0)!=0&(u|0)>-1){t=c[l+260>>2]|0;if((l|0)==(t|0)){a[n>>0]=0;break}if(t){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,t)}}while(0);n=c[j>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=g;return}n=c[b>>2]|0;if((k|0)==(n|0)){a[s>>0]=0;i=g;return}if(!n){i=g;return}s=mKa()|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,n);i=g;return}function W3(a,b){a=a|0;b=b|0;var c=0;c=i;eXa(a,b,a+2644|0);i=c;return}function X3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(a[b+2417>>0]|0)){Xca(b+16|0,d+12|0);h=d+4|0;c[h>>2]=c[h>>2]&268435455;c[d>>2]=0;i=e;return}h=b+2644|0;b=d+4|0;j=c[b>>2]|0;k=j>>>30;if((k|0)==1){c[b>>2]=j&1073741823;c[f>>2]=d;TWa(h,f)|0;i=e;return}else if((k|0)==2){c[b>>2]=j|-1073741824;if(j&268435456){i=e;return}c[g>>2]=d;d=UWa(h,g,f)|0;if((a[f>>0]|0)!=0|(d|0)==0){i=e;return}c[d>>2]=c[g>>2];i=e;return}else{i=e;return}}function Y3(b,c){b=b|0;c=c|0;var d=0;d=i;fXa(b,c,b+2684|0);a[c+52>>0]=ea(g[c+48>>2])==ea(0.0)&1;i=d;return}function Z3(b,c){b=b|0;c=c|0;var d=0;d=i;gXa(b,c,b+2684|0,0);a[c+52>>0]=1;i=d;return}function _3(a,b){a=a|0;b=b|0;var c=0;c=i;hXa(a,b,a+2724|0);i=c;return}function $3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+2724|0;if(!(a[b+2417>>0]|0)){$ca(b+16|0,d+12|0);b=d+4|0;c[b>>2]=c[b>>2]&268435455;c[d>>2]=0;i=e;return}b=d+4|0;j=c[b>>2]|0;k=j>>>30;if((k|0)==1){c[b>>2]=j&1073741823;c[f>>2]=d;TWa(h,f)|0;i=e;return}else if((k|0)==2){c[b>>2]=j|-1073741824;if(j&268435456){i=e;return}c[g>>2]=d;d=UWa(h,g,f)|0;if((a[f>>0]|0)!=0|(d|0)==0){i=e;return}c[d>>2]=c[g>>2];i=e;return}else{i=e;return}}function a4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;c[d>>2]=b;if(!(a[b+2417>>0]|0)){c[d+16>>2]=Lea(b+16|0,c[d+12>>2]|0,(a[d+24>>0]|0)!=0)|0;h=d+4|0;c[h>>2]=c[h>>2]&268435455|-2147483648;i=e;return}h=b+2764|0;b=d+4|0;j=c[b>>2]|0;k=j&1073741823;if((j&-1073741824|0)==-1073741824){c[b>>2]=k|-2147483648;if(j&268435456){i=e;return}c[f>>2]=d;TWa(h,f)|0;i=e;return}else{c[b>>2]=k|1073741824;c[g>>2]=d;d=UWa(h,g,f)|0;if((a[f>>0]|0)!=0|(d|0)==0){i=e;return}c[d>>2]=c[g>>2];i=e;return}}function b4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(a[b+2417>>0]|0)){Mea(b+16|0,c[d+16>>2]|0);h=d+4|0;c[h>>2]=c[h>>2]&268435455;c[d>>2]=0;i=e;return}h=b+2764|0;b=d+4|0;j=c[b>>2]|0;k=j>>>30;if((k|0)==2){c[b>>2]=j|-1073741824;if(j&268435456){i=e;return}c[g>>2]=d;l=UWa(h,g,f)|0;if((a[f>>0]|0)!=0|(l|0)==0){i=e;return}c[l>>2]=c[g>>2];i=e;return}else if((k|0)==1){c[b>>2]=j&1073741823;c[f>>2]=d;TWa(h,f)|0;i=e;return}else{i=e;return}}function c4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=a+2412|0;oTa(c[f>>2]|0);c[e+4>>2]=0;c[e>>2]=c[b+20>>2];b=a+2400|0;g=a+2404|0;h=c[g>>2]|0;if((c[a+2408>>2]&2147483647)>>>0<=h>>>0){iXa(b,e)|0;j=c[f>>2]|0;pTa(j);i=d;return 1}a=(c[b>>2]|0)+(h<<3)|0;if(!a)k=h;else{h=e;e=c[h+4>>2]|0;b=a;c[b>>2]=c[h>>2];c[b+4>>2]=e;k=c[g>>2]|0}c[g>>2]=k+1;j=c[f>>2]|0;pTa(j);i=d;return 1}function d4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=a+2412|0;oTa(c[f>>2]|0);c[e+4>>2]=1;c[e>>2]=c[b+20>>2];b=a+2400|0;g=a+2404|0;h=c[g>>2]|0;if((c[a+2408>>2]&2147483647)>>>0<=h>>>0){iXa(b,e)|0;j=c[f>>2]|0;pTa(j);i=d;return}a=(c[b>>2]|0)+(h<<3)|0;if(!a)k=h;else{h=e;e=c[h+4>>2]|0;b=a;c[b>>2]=c[h>>2];c[b+4>>2]=e;k=c[g>>2]|0}c[g>>2]=k+1;j=c[f>>2]|0;pTa(j);i=d;return}function e4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+20|0;if((c[f>>2]|0)==-1){i=d;return}b=a+2412|0;oTa(c[b>>2]|0);c[e+4>>2]=2;c[e>>2]=c[f>>2];f=a+2400|0;g=a+2404|0;h=c[g>>2]|0;if((c[a+2408>>2]&2147483647)>>>0>h>>>0){a=(c[f>>2]|0)+(h<<3)|0;if(!a)j=h;else{h=e;k=c[h+4>>2]|0;l=a;c[l>>2]=c[h>>2];c[l+4>>2]=k;j=c[g>>2]|0}c[g>>2]=j+1}else iXa(f,e)|0;pTa(c[b>>2]|0);i=d;return}function f4(a,b){a=a|0;b=b|0;var c=0;c=i;jXa(a,b,a+2604|0);i=c;return}function g4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;if(!(a[b+2417>>0]|0)){z3(d+156|0);z3(d+168|0);Cea(b+16|0,d+12|0,e);e=d+4|0;c[e>>2]=c[e>>2]&268435455;c[d>>2]=0;i=f;return}e=b+2604|0;b=d+4|0;j=c[b>>2]|0;k=j>>>30;if((k|0)==1){c[b>>2]=j&1073741823;c[g>>2]=d;TWa(e,g)|0;i=f;return}else if((k|0)==2){c[b>>2]=j|-1073741824;if(j&268435456){i=f;return}c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}else{i=f;return}}function h4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=e+4|0;c[d>>2]=b;if(!(a[b+2417>>0]|0))if(Fea(b+16|0,d+12|0)|0){h=d+4|0;c[h>>2]=c[h>>2]&268435455|-2147483648;i=e;return}else{dKa(bKa()|0,32,451688,810,451768,f);i=e;return}h=b+2804|0;b=d+4|0;j=c[b>>2]|0;k=j&1073741823;if((j&-1073741824|0)==-1073741824){c[b>>2]=k|-2147483648;if(j&268435456){i=e;return}c[f>>2]=d;TWa(h,f)|0;i=e;return}else{c[b>>2]=k|1073741824;c[g>>2]=d;d=UWa(h,g,f)|0;if((a[f>>0]|0)!=0|(d|0)==0){i=e;return}c[d>>2]=c[g>>2];i=e;return}}function i4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(a[b+2417>>0]|0)){Gea(b+16|0,d+12|0);h=d+4|0;c[h>>2]=c[h>>2]&268435455;c[d>>2]=0;i=e;return}h=b+2804|0;b=d+4|0;j=c[b>>2]|0;k=j>>>30;if((k|0)==1){c[b>>2]=j&1073741823;c[f>>2]=d;TWa(h,f)|0;i=e;return}else if((k|0)==2){c[b>>2]=j|-1073741824;if(j&268435456){i=e;return}c[g>>2]=d;d=UWa(h,g,f)|0;if((a[f>>0]|0)!=0|(d|0)==0){i=e;return}c[d>>2]=c[g>>2];i=e;return}else{i=e;return}}function j4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;f=a+2412|0;oTa(c[f>>2]|0);g=a+1136|0;h=a+2400|0;j=a+2404|0;if(!(c[j>>2]|0)){k=e;l=k;c[l>>2]=0;m=k+4|0;n=m;c[n>>2]=0;lXa(h,0,e);o=c[f>>2]|0;pTa(o);i=d;return}p=a+1140|0;a=0;do{q=c[h>>2]|0;r=c[q+(a<<3)>>2]|0;s=c[b+(r<<2)>>2]|0;t=c[q+(a<<3)+4>>2]|0;if((t|0)==2){if(r>>>0<(c[p>>2]|0)>>>0)c[(c[g>>2]|0)+(r<<5)+20>>2]=-1}else if((t|0)==1){if(s){r=s+32|0;q=(c[g>>2]|0)+(c[s+52>>2]<<5)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[q+16>>2]=c[r+16>>2];c[q+20>>2]=c[r+20>>2]}}else if((t|0)==0?(s|0)!=0:0){t=s+32|0;r=c[s+52>>2]|0;kXa(g,r+1|0);s=(c[g>>2]|0)+(r<<5)|0;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2]}a=a+1|0}while(a>>>0<(c[j>>2]|0)>>>0);k=e;l=k;c[l>>2]=0;m=k+4|0;n=m;c[n>>2]=0;lXa(h,0,e);o=c[f>>2]|0;pTa(o);i=d;return}function k4(a,b){a=a|0;b=ea(b);var e=0,f=0,g=0,h=0;e=i;f=a+16|0;a=Dea(f)|0;g=Eea(f)|0;if(!a){i=e;return}else h=0;do{f=c[g+(h<<2)>>2]|0;J3(f-(c[450968+((d[f+10>>0]|0)<<2)>>2]|0)|0,b);h=h+1|0}while((h|0)!=(a|0));i=e;return}function l4(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e;h=e+8|0;j=d+3340|0;if(c[j>>2]|0){k=d+16|0;do{qea(k)|0;l=(c[j>>2]|0)+-1|0;c[j>>2]=l}while((l|0)!=0)}j=d+3356|0;k=c[j>>2]|0;if(!k){c[j>>2]=0;m=d+3064|0;n=m+0|0;o=n+124|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));p=d+2996|0;n=p+0|0;o=n+37|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));i=e;return}if(k&1){g[d+48>>2]=ea(g[d+3316>>2]);g[d+52>>2]=ea(g[d+3320>>2]);g[d+56>>2]=ea(g[d+3324>>2]);c[d+60>>2]=1}if(!(k&2))q=k;else{Hca(d+16|0,ea(g[d+3328>>2]));q=c[j>>2]|0}if(q&4)b[d+1216>>1]=b[d+3332>>1]|0;if(!(q&8))r=q;else{q=d+16|0;k=f+4|0;l=0;do{s=d+(l<<2)+3064|0;t=l;l=l+1|0;if(c[s>>2]|0){u=d+(t<<2)+3188|0;v=1<<t;w=t&255;x=l;do{g[f>>2]=ea(0.0);g[k>>2]=ea(0.0);if(t>>>0<x>>>0)y=c[s>>2]&1<<x;else y=c[d+(x<<2)+3064>>2]&v;if(y){g[f>>2]=ea((c[u>>2]&1<<x)>>>x>>>0);g[k>>2]=ea((c[d+(x<<2)+3188>>2]&v)>>>t>>>0);eea(q,w,x&255,f)}x=x+1|0}while((x|0)!=32)}}while((l|0)!=31);r=c[j>>2]|0}if(!(r&16))z=r;else{fca(d+16|0,c[d+3336>>2]|0);z=c[j>>2]|0}if((z&32|0)!=0?(r=d+3348|0,l=c[r>>2]|0,(l|0)!=0):0){f=d+3344|0;q=d+16|0;k=l;l=0;while(1){y=a[(c[f>>2]|0)+l>>0]|0;if(y<<24>>24==-1)A=k;else{a[h>>0]=y;rea(q,l&255,h);a[(c[f>>2]|0)+l>>0]=-1;A=c[r>>2]|0}l=l+1|0;if(l>>>0>=A>>>0)break;else k=A}B=c[j>>2]|0}else B=z;if(!(B&64)){c[j>>2]=0;m=d+3064|0;n=m+0|0;o=n+124|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));p=d+2996|0;n=p+0|0;o=n+37|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));i=e;return}B=d+16|0;z=0;do{if(a[d+z+2996>>0]|0)hea(B,z,ea(g[d+(z<<2)+2848>>2]));z=z+1|0}while((z|0)!=37);c[j>>2]=0;m=d+3064|0;n=m+0|0;o=n+124|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));p=d+2996|0;n=p+0|0;o=n+37|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(o|0));i=e;return}function m4(a,b,c){a=a|0;b=b|0;c=c|0;return}function n4(a,b,c){a=a|0;b=b|0;c=c|0;return}function o4(a,b){a=a|0;b=b|0;var c=0;c=i;Nea(a+16|0,b);i=c;return}function p4(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+8|0;if(e)c[e>>2]=Kda(b+16|0)|0;e=b+2420|0;oTa(c[e>>2]|0);l4(b);k=b+2800|0;if(c[k>>2]|0){l=b+2768|0;m=b+16|0;n=0;do{o=c[(c[l>>2]|0)+(n<<2)>>2]|0;p=c[o+4>>2]|0;if((p&-1073741824|0)!=1073741824){if(p&268435456)mXa(o,b)}else{c[o+16>>2]=Lea(m,c[o+12>>2]|0,(a[o+24>>0]|0)!=0)|0;mXa(o,b)}n=n+1|0}while(n>>>0<(c[k>>2]|0)>>>0)}M3(b+2764|0);c[b+2516>>2]=0;k=b+2524|0;n=c[b+2528>>2]|0;m=b+2560|0;l=b+16|0;if(c[m>>2]|0){o=0;do{p=c[n+(o<<2)>>2]|0;q=c[p+4>>2]|0;if((q&-1073741824|0)!=1073741824){if(q&268435456)oXa(p)}else nXa(l,p);o=o+1|0}while(o>>>0<(c[m>>2]|0)>>>0)}M3(k);c[j>>2]=0;c[j+4>>2]=0;dea(l,j);k=Bfa(j)|0;if(k){m=k;do{k=m-(c[450968+(d[m+10>>0]<<2)>>2]|0)|0;if(!(c[k+4>>2]&268435456))pXa(k);m=Bfa(j)|0}while((m|0)!=0)}m=c[b+1156>>2]|0;j=c[b+1152>>2]|0;if(m){k=0;do{o=c[j+(k<<2)>>2]|0;n=o-(c[450968+(d[o+10>>0]<<2)>>2]|0)|0;if(!(c[n+4>>2]&268435456))pXa(n);k=k+1|0}while((k|0)!=(m|0))}m=b+2564|0;k=c[b+2568>>2]|0;j=b+2600|0;if(c[j>>2]|0){n=0;do{o=c[k+(n<<2)>>2]|0;p=c[o+4>>2]|0;if((p&-1073741824|0)!=1073741824){if(p&268435456)pXa(o)}else qXa(l,o);n=n+1|0}while(n>>>0<(c[j>>2]|0)>>>0)}M3(m);c[b+2504>>2]=0;m=b+2484|0;j=c[m>>2]|0;if(j){n=b+2452|0;k=j;j=0;while(1){o=c[(c[n>>2]|0)+(j<<2)>>2]|0;if(!(c[o+4>>2]&268435456))r=k;else{A4(o);r=c[m>>2]|0}j=j+1|0;if(j>>>0>=r>>>0)break;else k=r}}M3(b+2448|0);c[b+2492>>2]=0;r=Kea(l)|0;k=Jea(l)|0;if(k){j=0;do{m=(c[r+(j<<2)>>2]|0)+-12|0;if(!(c[m+4>>2]&268435456))rXa(m);j=j+1|0}while((j|0)!=(k|0))}k=b+2644|0;j=c[b+2648>>2]|0;r=b+2680|0;if(c[r>>2]|0){m=0;do{n=c[j+(m<<2)>>2]|0;o=c[n+4>>2]|0;if((o&-1073741824|0)!=1073741824){if(o&268435456)rXa(n)}else{OX(n,g,h);o=c[g>>2]|0;if(!o)s=0;else s=(c[450992+(((c[o+4>>2]|0)>>>24&15)<<2)>>2]|0)+o|0;o=c[h>>2]|0;if(!o)t=0;else t=(c[450992+(((c[o+4>>2]|0)>>>24&15)<<2)>>2]|0)+o|0;Wca(l,n+12|0,s,t)}m=m+1|0}while(m>>>0<(c[r>>2]|0)>>>0)}M3(k);k=Iea(l)|0;r=Hea(l)|0;if(r){m=0;do{t=(c[k+(m<<2)>>2]|0)+-12|0;if(!(c[t+4>>2]&268435456))sXa(t);m=m+1|0}while((m|0)!=(r|0))}r=b+2684|0;m=c[b+2688>>2]|0;k=b+2720|0;if(c[k>>2]|0){t=0;do{s=c[m+(t<<2)>>2]|0;j=c[s+4>>2]|0;if((j&-1073741824|0)!=1073741824){if(j&268435456)sXa(s)}else Yca(l,s+12|0,(RV(s)|0)+16|0);t=t+1|0}while(t>>>0<(c[k>>2]|0)>>>0)}M3(r);r=b+2724|0;k=c[b+2728>>2]|0;t=b+2760|0;if(c[t>>2]|0){m=0;do{s=c[k+(m<<2)>>2]|0;j=c[s+4>>2]|0;if((j&-1073741824|0)!=1073741824){if(j&268435456)tXa(s)}else{BW(s,g,h);_ca(l,s+12|0,(c[g>>2]|0)+16|0,(c[h>>2]|0)+16|0)}m=m+1|0}while(m>>>0<(c[t>>2]|0)>>>0)}M3(r);r=Dea(l)|0;t=Eea(l)|0;if(r){m=0;do{h=c[t+(m<<2)>>2]|0;K3(h-(c[450968+(d[h+10>>0]<<2)>>2]|0)|0);m=m+1|0}while((m|0)!=(r|0))}r=b+2640|0;if(c[r>>2]|0){m=b+2608|0;t=0;do{h=c[(c[m>>2]|0)+(t<<2)>>2]|0;k=(c[h+4>>2]|0)>>>30;if((k|0)==3){z3(h+156|0);z3(h+168|0)}else if((k|0)==1)Bea(l,h+12|0);t=t+1|0}while(t>>>0<(c[r>>2]|0)>>>0)}M3(b+2604|0);r=b+2840|0;if(c[r>>2]|0){t=b+2808|0;m=0;do{h=c[(c[t>>2]|0)+(m<<2)>>2]|0;if((c[h+4>>2]&-1073741824|0)==1073741824?!(Fea(l,h+12|0)|0):0)dKa(bKa()|0,32,451688,1274,451768,g);m=m+1|0}while(m>>>0<(c[r>>2]|0)>>>0)}M3(b+2804|0);r=b+2436|0;m=(c[r>>2]|0)+2|0;l=b+2428|0;t=c[l>>2]|0;if(t>>>0<=m>>>0){c[r>>2]=0;u=b+2440|0;c[u>>2]=0;v=c[e>>2]|0;pTa(v);i=f;return}h=b+2424|0;k=t;do{t=k+-1|0;s=c[(c[h>>2]|0)+(t<<2)>>2]|0;c[l>>2]=t;VJa(g,s);k=c[l>>2]|0}while(k>>>0>m>>>0);c[r>>2]=0;u=b+2440|0;c[u>>2]=0;v=c[e>>2]|0;pTa(v);i=f;return}function q4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+2560|0;e=c[d>>2]|0;if(e){f=a+2528|0;g=e;e=0;while(1){h=c[(c[f>>2]|0)+(e<<2)>>2]|0;if((c[h+4>>2]&-1073741824|0)==-2147483648){uXa(h);j=c[d>>2]|0}else j=g;e=e+1|0;if(e>>>0>=j>>>0)break;else g=j}}j=a+2600|0;g=c[j>>2]|0;if(g){e=a+2568|0;f=g;g=0;while(1){h=c[(c[e>>2]|0)+(g<<2)>>2]|0;if((c[h+4>>2]&-1073741824|0)==-2147483648){uXa(h);k=c[j>>2]|0}else k=f;g=g+1|0;if(g>>>0>=k>>>0)break;else f=k}}k=a+2680|0;if(c[k>>2]|0){f=a+2648|0;g=a+16|0;e=0;do{h=c[(c[f>>2]|0)+(e<<2)>>2]|0;l=h+4|0;if((c[l>>2]&-1073741824|0)==-1073741824?(Xca(g,h+12|0),(c[l>>2]&268435456|0)==0):0)rXa(h);e=e+1|0}while(e>>>0<(c[k>>2]|0)>>>0)}k=a+2760|0;e=c[k>>2]|0;if(e){g=a+2728|0;f=a+16|0;h=e;e=0;while(1){l=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((c[l+4>>2]&-1073741824|0)==-1073741824){$ca(f,l+12|0);m=c[k>>2]|0}else m=h;e=e+1|0;if(e>>>0>=m>>>0)break;else h=m}}m=c[d>>2]|0;if(m){h=a+2528|0;e=a+16|0;k=m;m=0;while(1){f=c[(c[h>>2]|0)+(m<<2)>>2]|0;g=c[f+4>>2]|0;if((g&-1073741824|0)==-1073741824){_Wa(e,f,(g&16|0)!=0);n=c[d>>2]|0}else n=k;m=m+1|0;if(m>>>0>=n>>>0)break;else k=n}}if(c[j>>2]|0){n=a+2568|0;k=a+16|0;m=0;do{d=c[(c[n>>2]|0)+(m<<2)>>2]|0;e=d+4|0;h=c[e>>2]|0;if((h&-1073741824|0)==-1073741824?(cXa(k,d,(h&16|0)!=0),(c[e>>2]&268435456|0)==0):0)pXa(d);m=m+1|0}while(m>>>0<(c[j>>2]|0)>>>0)}j=a+2720|0;if(c[j>>2]|0){m=a+2688|0;k=a+16|0;n=0;do{d=c[(c[m>>2]|0)+(n<<2)>>2]|0;e=d+4|0;h=c[e>>2]|0;if((h&-1073741824|0)==-1073741824?(c[e>>2]=h&-769,Zca(k,d+12|0),(c[e>>2]&268435456|0)==0):0)sXa(d);n=n+1|0}while(n>>>0<(c[j>>2]|0)>>>0)}j=a+2640|0;n=c[j>>2]|0;if(n){k=a+2608|0;m=a+16|0;d=n;n=0;while(1){e=c[(c[k>>2]|0)+(n<<2)>>2]|0;h=c[e+4>>2]|0;if((h&-1073741824|0)==-1073741824){Cea(m,e+12|0,(h&536870912|0)!=0);o=c[j>>2]|0}else o=d;n=n+1|0;if(n>>>0>=o>>>0)break;else d=o}}o=a+2840|0;d=c[o>>2]|0;if(d){n=a+2808|0;j=a+16|0;m=d;d=0;while(1){k=c[(c[n>>2]|0)+(d<<2)>>2]|0;if((c[k+4>>2]&-1073741824|0)==-1073741824){Gea(j,k+12|0);p=c[o>>2]|0}else p=m;d=d+1|0;if(d>>>0>=p>>>0)break;else m=p}}p=a+2800|0;m=c[p>>2]|0;if(!m){i=b;return}d=a+2768|0;o=a+16|0;j=m;m=0;while(1){n=c[(c[d>>2]|0)+(m<<2)>>2]|0;if((c[n+4>>2]&-1073741824|0)==-1073741824){mXa(n,a);Mea(o,c[n+16>>2]|0);q=c[p>>2]|0}else q=j;m=m+1|0;if(m>>>0>=q>>>0)break;else j=q}i=b;return}function r4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e+47|0;g=e+16|0;h=e+40|0;j=e+36|0;k=e+46|0;l=e+8|0;m=e+42|0;n=e+24|0;o=e+44|0;p=e+28|0;q=e+49|0;r=e+20|0;s=e+41|0;t=e+12|0;u=e+48|0;v=e;w=e+43|0;x=e+32|0;y=e+45|0;z=e+4|0;A=d+4|0;B=c[A>>2]|0;do switch(B>>>24&15|0){case 8:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[l>>2]=d;C=UWa(b+2684|0,l,k)|0;if((a[k>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[l>>2];i=e;return}case 7:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[n>>2]=d;C=UWa(b+2604|0,n,m)|0;if((a[m>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[n>>2];i=e;return}case 9:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[j>>2]=d;C=UWa(b+2724|0,j,h)|0;if((a[h>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[j>>2];i=e;return}case 2:case 1:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[x>>2]=d;C=UWa(b+2448|0,x,w)|0;if((a[w>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[x>>2];i=e;return}case 6:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[p>>2]=d;C=UWa(b+2644|0,p,o)|0;if((a[o>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[p>>2];i=e;return}case 3:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[v>>2]=d;C=UWa(b+2564|0,v,u)|0;if((a[u>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[v>>2];i=e;return}case 5:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[r>>2]=d;C=UWa(b+2524|0,r,q)|0;if((a[q>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[r>>2];i=e;return}case 4:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[t>>2]=d;C=UWa(b+2564|0,t,s)|0;if((a[s>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[t>>2];i=e;return}case 10:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[g>>2]=d;C=UWa(b+2764|0,g,f)|0;if((a[f>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[g>>2];i=e;return}case 11:{if(B&268435456){i=e;return}c[A>>2]=B|268435456;if((B&-1073741824|0)!=-2147483648){i=e;return}c[z>>2]=d;C=UWa(b+2804|0,z,y)|0;if((a[y>>0]|0)!=0|(C|0)==0){i=e;return}c[C>>2]=c[z>>2];i=e;return}default:{i=e;return}}while(0)}function s4(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;do switch(e|0){case 2:case 1:{g=vXa(d+2420|0,128,16)|0;if(!g){h=0;i=f;return h|0}c[g>>2]=-1;c[g+56>>2]=0;b[g+60>>1]=0;j=g+92|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;a[g+116>>0]=0;h=g;i=f;return h|0}case 4:{g=vXa(d+2420|0,272,16)|0;if(!g){h=0;i=f;return h|0}b[g>>1]=0;a[g+3>>0]=0;c[g+28>>2]=0;a[g+20>>0]=1;c[g+24>>2]=g+4;c[g+32>>2]=4;c[g+76>>2]=0;a[g+68>>0]=1;c[g+72>>2]=g+36;c[g+80>>2]=4;c[g+84>>2]=0;c[g+88>>2]=0;j=g+220|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));a[j+48>>0]=0;h=g;i=f;return h|0}case 6:{m=vXa(d+2420|0,24,16)|0;if(!m){h=0;i=f;return h|0}b[m+16>>1]=0;h=m;i=f;return h|0}case 3:{m=vXa(d+2420|0,272,16)|0;if(!m){h=0;i=f;return h|0}b[m>>1]=0;a[m+3>>0]=0;c[m+28>>2]=0;a[m+20>>0]=1;c[m+24>>2]=m+4;c[m+32>>2]=4;c[m+76>>2]=0;a[m+68>>0]=1;c[m+72>>2]=m+36;c[m+80>>2]=4;c[m+84>>2]=0;c[m+88>>2]=0;n=m+220|0;k=n+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));a[n+48>>0]=0;h=m;i=f;return h|0}case 7:{g=vXa(d+2420|0,80,16)|0;if(!g){h=0;i=f;return h|0}b[g>>1]=0;a[g+3>>0]=0;j=g+60|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;b[j+16>>1]=0;h=g;i=f;return h|0}case 9:{h=vXa(d+2420|0,140,16)|0;i=f;return h|0}case 10:{g=vXa(d+2420|0,16,16)|0;if(!g){h=0;i=f;return h|0}c[g>>2]=-1;c[g+4>>2]=0;c[g+8>>2]=-1;c[g+12>>2]=0;h=g;i=f;return h|0}case 8:{g=vXa(d+2420|0,28,16)|0;i=f;return g|0}case 5:{g=vXa(d+2420|0,128,16)|0;if(!g){h=0;i=f;return h|0}b[g>>1]=0;a[g+3>>0]=0;c[g+28>>2]=0;a[g+20>>0]=1;c[g+24>>2]=g+4;c[g+32>>2]=4;c[g+76>>2]=0;a[g+68>>0]=1;c[g+72>>2]=g+36;c[g+80>>2]=4;c[g+84>>2]=0;c[g+88>>2]=0;h=g;i=f;return h|0}default:{h=0;i=f;return h|0}}while(0);return 0}function t4(a){a=a|0;var b=0,c=0;b=i;c=tca(a+16|0)|0;i=b;return c|0}function u4(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=uca(a+16|0,b)|0;i=c;return d|0}function v4(a){a=a|0;var b=0,c=0;b=i;c=vca(a+16|0)|0;i=b;return c|0}function w4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=wca(a+16|0,b,c,d)|0;i=e;return f|0}function x4(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;if(!(a[b+2417>>0]|0)){f=xca(b+16|0,c,d)|0;i=e;return f|0}else{dKa(bKa()|0,2,451688,1469,451808,e);f=-1;i=e;return f|0}return 0}function y4(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;if(!(a[b+2417>>0]|0)){e=yca(b+16|0,c)|0;i=d;return e|0}else{dKa(bKa()|0,2,451688,1478,451904,d);e=0;i=d;return e|0}return 0}function z4(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g;j=g+16|0;k=g+8|0;l=f&65535;if(f<<16>>16==1){b[j>>1]=c[(c[e>>2]|0)+52>>2];Wea(d+16|0,j,1);m=1;i=g;return m|0}j=l<<1;n=j>>>0>1024;o=k+4|0;a[o>>0]=n&1;if(n){n=sKa(g+18|0,j,452448,49)|0;c[k>>2]=n;if(!n){dKa(bKa()|0,16,452448,58,452528,h);if(!(a[o>>0]|0)){m=0;i=g;return m|0}tKa(k,c[k>>2]|0);m=0;i=g;return m|0}else{p=n;q=k}}else{n=i;i=i+((2*l|0)+15&-16)|0;c[k>>2]=n;p=n;q=k}if(f<<16>>16){n=0;do{b[p+(n<<1)>>1]=c[(c[e+(n<<2)>>2]|0)+52>>2];n=n+1|0}while((n|0)!=(l|0))}Wea(d+16|0,p,f);if(!(a[o>>0]|0)){m=1;i=g;return m|0}tKa(k,c[q>>2]|0);m=1;i=g;return m|0}function A4(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+16|0;f=e+5|0;h=e;j=e+4|0;k=d+4|0;l=c[k>>2]|0;m=l&16777215;if(!m){n=d+8|0;c[n>>2]=0;o=c[k>>2]|0;p=o&-16777216;c[k>>2]=p;i=e;return}q=d+16|0;r=a[d+80>>0]|0;s=d+8|0;t=c[s>>2]|0;if(!t){u=s4(c[d>>2]|0,l>>>24&15)|0;c[s>>2]=u;v=u}else v=t;if(l&1)bfa(q,v);if(l&2){l=b[v+60>>1]|0;if(l<<16>>16==1)w=v+56|0;else w=(c[(c[d>>2]|0)+2488>>2]|0)+(c[v+56>>2]<<1)|0;Wea(q,w,l)}l=c[k>>2]|0;if(!(l&4))x=l;else{Yea(q,v+64|0);x=c[k>>2]|0}if(!(x&8))y=x;else{Zea(q,v+92|0);y=c[k>>2]|0}if(y&16)g[d+76>>2]=ea(g[v+108>>2]);if(!(y&32))z=y;else{afa(q,ea(g[v+112>>2]));z=c[k>>2]|0}if(z&64){a[f>>0]=a[v+116>>0]|0;cfa(q,f)}f=n2(d)|0;if(!f){n=s;c[n>>2]=0;o=c[k>>2]|0;p=o&-16777216;c[k>>2]=p;i=e;return}c[h>>2]=m;a[j>>0]=r;Yba(f,q,h,j);n=s;c[n>>2]=0;o=c[k>>2]|0;p=o&-16777216;c[k>>2]=p;i=e;return}function B4(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=j;b[d+4>>1]=10;b[d+6>>1]=3;l=d+8|0;c[l>>2]=0;c[d>>2]=454232;vU(d+12|0,0);c[l>>2]=0;c[d>>2]=452608;b[k>>1]=b[h>>1]|0;w3(d+20|0,e,f+16|0,g,k);c[d+124>>2]=f;c[d+128>>2]=462640;c[d+140>>2]=d;c[d+144>>2]=0;a[d+148>>0]=1;fTa(f+12|0)|0;i=j;return}function C4(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;c[a>>2]=452608;d=a+124|0;if((c[(c[d>>2]|0)+12>>2]|0)==1)c[a+64>>2]=0;e=c[d>>2]|0;d=e+8|0;if(!(gTa(e+12|0)|0))ko[c[(c[d>>2]|0)+8>>2]&4095](d);x3(a+20|0);c[a>>2]=453736;MU(a);VJa(b,a);i=b;return}function D4(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=452608;d=a+124|0;if((c[(c[d>>2]|0)+12>>2]|0)==1)c[a+64>>2]=0;e=c[d>>2]|0;d=e+8|0;if(!(gTa(e+12|0)|0))ko[c[(c[d>>2]|0)+8>>2]&4095](d);x3(a+20|0);c[a>>2]=453736;MU(a);i=b;return}function E4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+124|0;f=c[e>>2]|0;if(!f)g=0;else{h=xo[c[c[b>>2]>>2]&2047](b,-2147483648,f)|0;c[e>>2]=h;g=h}fTa(g+12|0)|0;zja(a+32|0,(c[e>>2]|0)+16|0);i=d;return}function F4(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[b>>2]|0)+8>>2]&4095](b,c[a+124>>2]|0);i=d;return}function G4(a){a=a|0;return a+-32|0}function H4(a){a=a|0;var b=0,d=0;b=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);d=LU(a)|0;if(d)w$(d,a);v3(a+20|0);i=b;return}function I4(a){a=a|0;return 5}function J4(a){a=a|0;return (c[a+64>>2]|0)+-16|0}function K4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))j=3;else j=4;else if((h|0)==3)j=4;else j=3;if((j|0)==3){Kja(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,243,462176,g);i=f;return}}function L4(a){a=a|0;var b=0,c=0;b=i;c=gja(a+32|0)|0;i=b;return c|0}function M4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){Bja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,256,462088,f);i=e;return}}function N4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){j=rja(b+32|0,d)|0;i=e;return j|0}else if((h|0)==4){dKa(bKa()|0,8,454728,266,462e3,f);j=0;i=e;return j|0}return 0}function O4(a){a=a|0;var b=0,c=0;b=i;c=Lja(a+32|0)|0;i=b;return c|0}function P4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){Mja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,292,461912,f);i=e;return}}function Q4(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==2)if(!(a[(c[d+20>>2]|0)+2417>>0]|0))j=3;else j=4;else if((h|0)==3)j=4;else j=3;if((j|0)==3){Nja(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,281,461816,f);g[b>>2]=ea(1.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(1.0);i=e;return}}function R4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){Cja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,300,461728,f);i=e;return}}function S4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){j=sja(b+32|0,d)|0;i=e;return j|0}else if((h|0)==4){dKa(bKa()|0,8,454728,310,461640,f);j=0;i=e;return j|0}return 0}function T4(a){a=a|0;var b=0,c=0;b=i;c=Oja(a+32|0)|0;i=b;return c|0}function U4(a){a=a|0;var b=0;b=i;Pja(a+32|0);i=b;return}function V4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){Dja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,330,461552,f);i=e;return}}function W4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){j=tja(b+32|0,d)|0;i=e;return j|0}else if((h|0)==4){dKa(bKa()|0,8,454728,340,461464,f);j=0;i=e;return j|0}return 0}function X4(a){a=a|0;var b=0,c=0;b=i;c=Qja(a+32|0)|0;i=b;return c|0}function Y4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Rja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,355,461384,f);i=e;return}}function Z4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){Sja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,362,461296,f);i=e;return}}function _4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){Tja(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,369,461216,g);i=f;return}}function $4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=lja(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,377,461128,e);h=0;i=d;return h|0}return 0}function a5(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j;l=(c[b+24>>2]|0)>>>30;if((l|0)==3)m=4;else if((l|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){qja(b+32|0,d,e,f,g,h);i=j;return}else if((m|0)==4){dKa(bKa()|0,8,454728,388,461048,k);i=j;return}}function b5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){Uja(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,397,460968,g);i=f;return}}function c5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Vja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,404,460880,f);i=e;return}}function d5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=oja(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,412,460792,e);h=0;i=d;return h|0}return 0}function e5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Wja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,422,460704,f);i=e;return}}function f5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Xja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,429,460616,f);i=e;return}}function g5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){Yja(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,436,460528,g);i=f;return}}function h5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=nja(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,444,460440,e);h=0;i=d;return h|0}return 0}function i5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Zja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,454,460360,f);i=e;return}}function j5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){_ja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,461,460272,f);i=e;return}}function k5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){$ja(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,468,460192,g);i=f;return}}function l5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=pja(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,476,460104,e);h=0;i=d;return h|0}return 0}function m5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){aka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,486,460024,f);i=e;return}}function n5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){bka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,493,459936,f);i=e;return}}function o5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=mja(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,501,459848,e);h=0;i=d;return h|0}return 0}function p5(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;k=(c[b+24>>2]|0)>>>30;if((k|0)==3)l=4;else if((k|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)l=4;else l=3;if((l|0)==3){Aja(b+32|0,d,e,f,g);i=h;return}else if((l|0)==4){dKa(bKa()|0,8,454728,512,459768,j);i=h;return}}function q5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=hja(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,522,459680,e);h=0;i=d;return h|0}return 0}function r5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){jja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,533,459600,f);i=e;return}}function s5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ija(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,543,459512,e);h=0;i=d;return h|0}return 0}function t5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){kja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,554,459424,f);i=e;return}}function u5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0;e=i;i=i+32|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(j*j);l=ea(g[d+4>>2]);m=ea(k+ea(l*l));k=ea(g[d+8>>2]);n=ea(m+ea(k*k));m=ea(g[d+12>>2]);o=ea(ea(1.0)/ea(T(ea(n+ea(m*m)))));n=ea(l*o);l=ea(k*o);k=ea(m*o);g[h>>2]=ea(j*o);g[h+4>>2]=n;g[h+8>>2]=l;g[h+12>>2]=k;g[h+16>>2]=ea(g[d+16>>2]);g[h+20>>2]=ea(g[d+20>>2]);g[h+24>>2]=ea(g[d+24>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)p=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)p=4;else p=3;if((p|0)==3){dja(b+32|0,h);i=e;return}else if((p|0)==4){dKa(bKa()|0,8,454728,575,459344,f);i=e;return}}function v5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){xja(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,564,459264,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);g[b+12>>2]=ea(1.0);g[b+16>>2]=ea(0.0);g[b+20>>2]=ea(0.0);g[b+24>>2]=ea(0.0);i=e;return}}function w5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0;e=i;i=i+32|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(j*j);l=ea(g[d+4>>2]);m=ea(k+ea(l*l));k=ea(g[d+8>>2]);n=ea(m+ea(k*k));m=ea(g[d+12>>2]);o=ea(ea(1.0)/ea(T(ea(n+ea(m*m)))));n=ea(l*o);l=ea(k*o);k=ea(m*o);g[h>>2]=ea(j*o);g[h+4>>2]=n;g[h+8>>2]=l;g[h+12>>2]=k;g[h+16>>2]=ea(g[d+16>>2]);g[h+20>>2]=ea(g[d+20>>2]);g[h+24>>2]=ea(g[d+24>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)p=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)p=4;else p=3;if((p|0)==3){ika(b+32|0,h);i=e;return}else if((p|0)==4){dKa(bKa()|0,8,454728,584,459184,f);i=e;return}}function x5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;Gja(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,605,459096,f);i=e;return}}function y5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){wja(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,594,459008,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function z5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;dka(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,625,458920,f);i=e;return}}function A5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){cka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,614,458832,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function B5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;fka(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,645,458744,f);i=e;return}}function C5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){eka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,634,458656,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function D5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;hka(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,665,458568,f);i=e;return}}function E5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){gka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,654,458480,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function F5(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=b+20|0;k=b+24|0;l=(c[k>>2]|0)>>>30;if((l|0)==3)m=4;else if((l|0)==2?(a[(c[j>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=d;g[h+4>>2]=d;g[h+8>>2]=d;dka(b+32|0,h)}else if((m|0)==4)dKa(bKa()|0,8,454728,625,458920,f);l=(c[k>>2]|0)>>>30;if((l|0)==3)m=8;else if((l|0)==2?(a[(c[j>>2]|0)+2417>>0]|0)!=0:0)m=8;else m=7;if((m|0)==7){g[h>>2]=d;g[h+4>>2]=d;g[h+8>>2]=d;fka(b+32|0,h);i=e;return}else if((m|0)==8){dKa(bKa()|0,8,454728,645,458744,f);i=e;return}}function G5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;jka(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,685,458392,f);i=e;return}}function H5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){kka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,674,458304,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function I5(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){lka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,705,458216,f);i=e;return}}function J5(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(mka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,694,458128,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function K5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;nka(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,725,458040,f);i=e;return}}function L5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){oka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,714,457952,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function M5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0;e=i;i=i+16|0;f=e;h=e+4|0;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);d=(c[b+24>>2]|0)>>>30;if((d|0)==3)m=4;else if((d|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)m=4;else m=3;if((m|0)==3){g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;pka(b+32|0,h);i=e;return}else if((m|0)==4){dKa(bKa()|0,8,454728,745,457864,f);i=e;return}}function N5(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){qka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,734,457776,f);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=e;return}}function O5(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0;d=i;i=i+32|0;e=d+12|0;f=d;h=c[(c[a>>2]|0)+184>>2]|0;g[e>>2]=b;g[e+4>>2]=b;g[e+8>>2]=b;In[h&4095](a,e);e=c[(c[a>>2]|0)+192>>2]|0;g[f>>2]=b;g[f+4>>2]=b;g[f+8>>2]=b;In[e&4095](a,f);i=d;return}function P5(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){rka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,763,457688,f);i=e;return}}function Q5(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(ska(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,754,457600,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function R5(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){tka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,781,457512,f);i=e;return}}function S5(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(uka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,772,457424,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function T5(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){vka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,798,457336,f);i=e;return}}function U5(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(wka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,789,457248,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function V5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){Eja(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,806,457160,g);i=f;return}}function W5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){j=uja(b+32|0,d)|0;i=e;return j|0}else if((h|0)==4){dKa(bKa()|0,8,454728,815,457072,f);j=0;i=e;return j|0}return 0}function X5(a){a=a|0;var b=0,c=0;b=i;c=xka(a+32|0)|0;i=b;return c|0}function Y5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Fja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,831,456992,f);i=e;return}}function Z5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){j=vja(b+32|0,d)|0;i=e;return j|0}else if((h|0)==4){dKa(bKa()|0,8,454728,840,456912,f);j=0;i=e;return j|0}return 0}function _5(a){a=a|0;var b=0,c=0;b=i;c=yka(a+32|0)|0;i=b;return c|0}function $5(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){zka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,867,456832,f);i=e;return}}function a6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(Aka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,856,456752,e);h=ea(60.0);i=d;return ea(h)}return ea(0.0)}function b6(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Bka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,887,456664,f);i=e;return}}function c6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(Cka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,876,456576,e);h=ea(60.0);i=d;return ea(h)}return ea(0.0)}function d6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){Dka(b+32|0,d,e);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,896,456496,g);i=f;return}}function e6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Eka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,904,456416,f);i=e;return}}function f6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;i=i+16|0;h=f;j=(c[d+24>>2]|0)>>>30;if((j|0)==3)k=4;else if((j|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)k=4;else k=3;if((k|0)==3){Fka(b,d+32|0,e);i=f;return}else if((k|0)==4){dKa(bKa()|0,8,454728,913,456336,h);g[b>>2]=ea(1.0);g[b+4>>2]=ea(1.0);g[b+8>>2]=ea(1.0);g[b+12>>2]=ea(1.0);i=f;return}}function g6(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=(c[d+24>>2]|0)>>>30;if((h|0)==3)j=4;else if((h|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)j=4;else j=3;if((j|0)==3){Gka(b,d+32|0);i=e;return}else if((j|0)==4){dKa(bKa()|0,8,454728,924,456256,f);g[b>>2]=ea(1.0);g[b+4>>2]=ea(1.0);i=e;return}}function h6(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=d+24|0;j=d+32|0;k=d+20|0;l=(b[e>>1]&1)!=0;m=(c[h>>2]|0)>>>30;if((m|0)==3)n=4;else if((m|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)n=4;else n=3;if((n|0)==3)Hka(j,1,l);else if((n|0)==4)dKa(bKa()|0,8,454728,946,456176,g);l=(b[e>>1]&2)!=0;m=(c[h>>2]|0)>>>30;if((m|0)==3)n=7;else if((m|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)n=7;else n=8;if((n|0)==7)dKa(bKa()|0,8,454728,946,456176,g);else if((n|0)==8)Hka(j,2,l);l=(b[e>>1]&4)!=0;e=(c[h>>2]|0)>>>30;if((e|0)==3)n=11;else if((e|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)n=11;else n=12;if((n|0)==11){dKa(bKa()|0,8,454728,946,456176,g);LU(d)|0;i=f;return}else if((n|0)==12){Hka(j,4,l);LU(d)|0;i=f;return}}function i6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[b+24>>2]|0)>>>30;if((h|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))j=3;else j=4;else if((h|0)==3)j=4;else j=3;if((j|0)==3){Hka(b+32|0,d,e);LU(b)|0;i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,946,456176,g);LU(b)|0;i=f;return}}function j6(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=(c[e+24>>2]|0)>>>30;if((h|0)==2)if(!(a[(c[e+20>>2]|0)+2417>>0]|0))j=3;else j=4;else if((h|0)==3)j=4;else j=3;if((j|0)==3){Ika(d,e+32|0);i=f;return}else if((j|0)==4){dKa(bKa()|0,8,454728,935,456096,g);b[d>>1]=0;i=f;return}}function k6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;KU(b)|0;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=Jka(b+32|0)|0;i=d;return h|0}else if((g|0)==4){dKa(bKa()|0,8,454728,956,456024,e);h=0;i=d;return h|0}return 0}function l6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))g=3;else g=4;else if((f|0)==3)g=4;else g=3;if((g|0)==3){h=ea(Kka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,968,455936,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function m6(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Lka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,979,455848,f);i=e;return}}function n6(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))h=3;else h=4;else if((g|0)==3)h=4;else h=3;if((h|0)==3){Hja(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,988,455768,f);i=e;return}}function o6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(yja(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,998,455688,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function p6(b){b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;i=i+16|0;e=d;KU(b)|0;f=c[b+20>>2]|0;h=(c[b+24>>2]|0)>>>30;if((h|0)==2)if(!(a[f+2417>>0]|0))j=3;else j=4;else if((h|0)==3)j=4;else j=3;if((j|0)==3){eja(b+32|0,ea(g[f+2844>>2]));i=d;return}else if((j|0)==4){dKa(bKa()|0,8,454728,1012,455616,e);i=d;return}}function q6(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;KU(b)|0;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){Mka(b+32|0);i=d;return}else if((g|0)==4){dKa(bKa()|0,8,454728,1021,455544,e);i=d;return}}function r6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=e+4|0;h=b+128|0;a[g>>0]=a[d>>0]|0;if(!(c7(h,g)|0)){dKa(bKa()|0,8,453104,921,453184,f);j=0;i=e;return j|0}g=(c[b+24>>2]|0)>>>30;if((g|0)==2)if(!(a[(c[b+20>>2]|0)+2417>>0]|0))k=5;else k=6;else if((g|0)==3)k=6;else k=5;if((k|0)==5){Nka(b+32|0,h);j=h;i=e;return j|0}else if((k|0)==6){dKa(bKa()|0,8,454728,1030,455464,f);c[b+132>>2]=0;c[b+136>>2]=0;j=h;i=e;return j|0}return 0}function s6(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[(c[b>>2]|0)+92>>2]|0;a[e>>0]=1;g=_n[f&4095](b,e)|0;i=d;return g|0}function t6(a){a=a|0;var b=0;b=i;Oka(a+32|0);i=b;return}function u6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(Pka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,1044,455384,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function v6(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;i=i+32|0;h=f;j=f+8|0;k=(c[d+24>>2]|0)>>>30;if((k|0)==2)if(!(a[(c[d+20>>2]|0)+2417>>0]|0))l=3;else l=4;else if((k|0)==3)l=4;else l=3;if((l|0)==3){Qka(j,d+32|0);m=ea(g[j>>2]);n=ea(g[j+12>>2]);o=ea(g[j+4>>2]);p=ea(g[j+16>>2]);q=ea(g[j+8>>2]);r=m;s=n;t=o;u=p;v=q;w=ea(g[j+20>>2])}else if((l|0)==4){dKa(bKa()|0,8,454728,1056,455304,h);g[j>>2]=ea(8507058669999999534545717.0e13);g[j+4>>2]=ea(8507058669999999534545717.0e13);g[j+8>>2]=ea(8507058669999999534545717.0e13);g[j+12>>2]=ea(-8507058669999999534545717.0e13);g[j+16>>2]=ea(-8507058669999999534545717.0e13);g[j+20>>2]=ea(-8507058669999999534545717.0e13);r=ea(8507058669999999534545717.0e13);s=ea(-8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);u=ea(-8507058669999999534545717.0e13);v=ea(8507058669999999534545717.0e13);w=ea(-8507058669999999534545717.0e13)}q=ea(ea(r+s)*ea(.5));p=ea(ea(t+u)*ea(.5));o=ea(ea(v+w)*ea(.5));n=ea(ea(ea(s-r)*ea(.5))*e);r=ea(ea(ea(u-t)*ea(.5))*e);t=ea(ea(ea(w-v)*ea(.5))*e);e=ea(p-r);v=ea(o-t);w=ea(q+n);u=ea(p+r);r=ea(o+t);g[b>>2]=ea(q-n);g[b+4>>2]=e;g[b+8>>2]=v;g[b+12>>2]=w;g[b+16>>2]=u;g[b+20>>2]=r;i=f;return}function w6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Rka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,1066,455216,f);i=e;return}}function x6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[d+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){$ia(b,d+32|0);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,1075,455128,f);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=e;return}}function y6(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Ska(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,1085,455048,f);i=e;return}}function z6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(Tka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,1094,454968,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function A6(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(c[b+24>>2]|0)>>>30;if((g|0)==3)h=4;else if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)h=4;else h=3;if((h|0)==3){Uka(b+32|0,d);i=e;return}else if((h|0)==4){dKa(bKa()|0,8,454728,1104,454888,f);i=e;return}}function B6(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im;d=i;i=i+16|0;e=d;f=(c[b+24>>2]|0)>>>30;if((f|0)==3)g=4;else if((f|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0)g=4;else g=3;if((g|0)==3){h=ea(Vka(b+32|0));i=d;return ea(h)}else if((g|0)==4){dKa(bKa()|0,8,454728,1113,454808,e);h=ea(0.0);i=d;return ea(h)}return ea(0.0)}function C6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im;e=i;i=i+160|0;f=e+64|0;h=e+60|0;j=e+108|0;k=e+96|0;l=e+80|0;m=e+104|0;n=e+120|0;o=e+148|0;p=e+24|0;q=e+12|0;r=e+76|0;s=e+36|0;t=e;u=e+48|0;v=mo[c[(c[a>>2]|0)+96>>2]&4095](a)|0;if(!v){i=e;return}w=mo[c[(c[a>>2]|0)+84>>2]&4095](a)|0;x=mo[c[(c[w>>2]|0)+36>>2]&4095](w)|0;y=mo[c[(c[w>>2]|0)+28>>2]&4095](w)|0;z=mo[c[(c[w>>2]|0)+40>>2]&4095](w)|0;c[h>>2]=0;c[f>>2]=0;c[f+4>>2]=0;A=f+8|0;c[A>>2]=0;xUa(f,x,h);c[k>>2]=0;c[k+4>>2]=0;c[j>>2]=0;c[j+4>>2]=0;h=j+8|0;c[h>>2]=0;wXa(j,y,k);c[m>>2]=0;c[l>>2]=0;c[l+4>>2]=0;k=l+8|0;c[k>>2]=0;xUa(l,z,m);m=c[f>>2]|0;xo[c[(c[w>>2]|0)+52>>2]&2047](w,m,x)|0;x=c[j>>2]|0;xo[c[(c[w>>2]|0)+48>>2]&2047](w,x,y)|0;B=c[l>>2]|0;xo[c[(c[w>>2]|0)+56>>2]&2047](w,B,z)|0;z=v+4|0;C=c[z>>2]|0;In[c[(c[a>>2]|0)+124>>2]&4095](n,a);CKa(b,1)|0;if(!y)D=d;else{E=n+12|0;F=n+4|0;G=n+8|0;H=n+16|0;I=n+20|0;J=n+24|0;K=o+4|0;L=o+8|0;M=p+4|0;N=p+8|0;O=0;P=0;while(1){Q=_n[c[(c[w>>2]|0)+72>>2]&4095](w,P)|0;if((Q|0)==2){R=ea(Um[c[(c[d>>2]|0)+296>>2]&63](d,32));S=10}else if((Q|0)==1){R=ea(Um[c[(c[d>>2]|0)+296>>2]&63](d,31));S=10}else if((Q|0)==3){R=ea(Um[c[(c[d>>2]|0)+296>>2]&63](d,33));S=10}else if((Q|0)==4){R=ea(Um[c[(c[d>>2]|0)+296>>2]&63](d,34));S=10}else T=O;if((S|0)==10){S=0;if(R==ea(0.0))T=O;else{DKa(b,c[453288+(O<<2)>>2]|0)|0;Q=c[x+(P<<3)+4>>2]|0;if(!Q)U=0;else U=c[m+(Q+-1<<2)>>2]<<1;V=c[m+(Q<<2)>>2]<<1;if(U>>>0<V>>>0){Q=U;do{W=c[B+(Q<<2)>>2]|0;X=c[B+((Q|1)<<2)>>2]|0;Q=Q+2|0;Y=ea(ea(g[C+(W<<4)>>2])*ea(2.0));Z=ea(ea(g[C+(W<<4)+4>>2])*ea(2.0));_=ea(ea(g[C+(W<<4)+8>>2])*ea(2.0));$=ea(g[E>>2]);aa=ea(ea($*$)+ea(-.5));ba=ea(g[n>>2]);ca=ea(Y*ba);da=ea(g[F>>2]);fa=ea(ca+ea(Z*da));ca=ea(g[G>>2]);ga=ea(fa+ea(_*ca));fa=ea(ea(ba*ga)+ea(ea(Y*aa)+ea($*ea(ea(_*da)-ea(Z*ca)))));ha=ea(ea(da*ga)+ea(ea(Z*aa)+ea($*ea(ea(Y*ca)-ea(_*ba)))));ia=ea(ea(ea(_*aa)+ea($*ea(ea(Z*ba)-ea(Y*da))))+ea(ca*ga));ga=ea(ea(g[H>>2])+fa);fa=ea(ea(g[I>>2])+ha);ha=ea(ea(g[J>>2])+ia);g[o>>2]=ga;g[K>>2]=fa;g[L>>2]=ha;GKa(b,o)|0;ha=ea(ea(g[C+(X<<4)>>2])*ea(2.0));fa=ea(ea(g[C+(X<<4)+4>>2])*ea(2.0));ga=ea(ea(g[C+(X<<4)+8>>2])*ea(2.0));ia=ea(g[E>>2]);ca=ea(ea(ia*ia)+ea(-.5));da=ea(g[n>>2]);Y=ea(ha*da);ba=ea(g[F>>2]);Z=ea(Y+ea(fa*ba));Y=ea(g[G>>2]);$=ea(Z+ea(ga*Y));Z=ea(ea(da*$)+ea(ea(ha*ca)+ea(ia*ea(ea(ga*ba)-ea(fa*Y)))));aa=ea(ea(ba*$)+ea(ea(fa*ca)+ea(ia*ea(ea(ha*Y)-ea(ga*da)))));_=ea(ea(ea(ga*ca)+ea(ia*ea(ea(fa*da)-ea(ha*ba))))+ea(Y*$));$=ea(ea(g[H>>2])+Z);Z=ea(ea(g[I>>2])+aa);aa=ea(ea(g[J>>2])+_);g[p>>2]=$;g[M>>2]=Z;g[N>>2]=aa;GKa(b,p)|0}while(Q>>>0<V>>>0)}T=((O+1|0)>>>0)%5|0}}P=P+1|0;if((P|0)==(y|0)){D=d;break}else O=T}}if(ea(Um[c[(c[D>>2]|0)+296>>2]&63](d,35))>ea(0.0)?(d=mo[c[(c[a>>2]|0)+356>>2]&4095](a)|0,(d|0)!=0):0){CKa(b,0)|0;DKa(b,-1)|0;c[r>>2]=0;c[q>>2]=0;c[q+4>>2]=0;D=q+8|0;c[D>>2]=0;xUa(q,d<<2,r);r=c[q>>2]|0;In[c[(c[a>>2]|0)+360>>2]&4095](a,r);T=mo[c[(c[a>>2]|0)+364>>2]&4095](a)|0;c[s>>2]=0;c[s+4>>2]=0;O=s+8|0;c[O>>2]=0;KUa(s,T,t);t=c[s>>2]|0;In[c[(c[a>>2]|0)+368>>2]&4095](a,t);a=n+12|0;T=n+4|0;y=n+8|0;P=n+16|0;p=n+20|0;N=n+24|0;M=u+4|0;J=u+8|0;I=0;do{H=I<<2;G=c[r+(H<<2)>>2]|0;F=c[r+((H|1)<<2)>>2]|0;E=c[r+((H|2)<<2)>>2]|0;C=c[z>>2]|0;R=ea(ea(g[C+(G<<4)>>2])*ea(2.0));aa=ea(ea(g[C+(G<<4)+4>>2])*ea(2.0));Z=ea(ea(g[C+(G<<4)+8>>2])*ea(2.0));$=ea(g[a>>2]);_=ea(ea($*$)+ea(-.5));Y=ea(g[n>>2]);ba=ea(R*Y);ha=ea(g[T>>2]);da=ea(ba+ea(aa*ha));ba=ea(g[y>>2]);fa=ea(da+ea(Z*ba));da=ea(ea(Y*fa)+ea(ea(R*_)+ea($*ea(ea(Z*ha)-ea(aa*ba)))));ia=ea(ea(ha*fa)+ea(ea(aa*_)+ea($*ea(ea(R*ba)-ea(Z*Y)))));ca=ea(ea(ea(Z*_)+ea($*ea(ea(aa*Y)-ea(R*ha))))+ea(ba*fa));fa=ea(g[P>>2]);R=ea(fa+da);da=ea(g[p>>2]);aa=ea(da+ia);ia=ea(g[N>>2]);Z=ea(ia+ca);ca=ea(ea(g[C+(F<<4)>>2])*ea(2.0));ga=ea(ea(g[C+(F<<4)+4>>2])*ea(2.0));ja=ea(ea(g[C+(F<<4)+8>>2])*ea(2.0));ka=ea(ea(ea(Y*ca)+ea(ha*ga))+ea(ba*ja));la=ea(fa+ea(ea(Y*ka)+ea(ea(_*ca)+ea($*ea(ea(ha*ja)-ea(ba*ga))))));ma=ea(da+ea(ea(ha*ka)+ea(ea(_*ga)+ea($*ea(ea(ba*ca)-ea(Y*ja))))));na=ea(ia+ea(ea(ea(_*ja)+ea($*ea(ea(Y*ga)-ea(ha*ca))))+ea(ba*ka)));ka=ea(ea(g[C+(E<<4)>>2])*ea(2.0));ca=ea(ea(g[C+(E<<4)+4>>2])*ea(2.0));ga=ea(ea(g[C+(E<<4)+8>>2])*ea(2.0));ja=ea(ea(ea(Y*ka)+ea(ha*ca))+ea(ba*ga));oa=ea(fa+ea(ea(Y*ja)+ea(ea(_*ka)+ea($*ea(ea(ha*ga)-ea(ba*ca))))));fa=ea(da+ea(ea(ha*ja)+ea(ea(_*ca)+ea($*ea(ea(ba*ka)-ea(Y*ga))))));da=ea(ia+ea(ea(ea(_*ga)+ea($*ea(ea(Y*ca)-ea(ha*ka))))+ea(ba*ja)));E=c[r+((H|3)<<2)>>2]|0;ja=ea(g[t+(E*12|0)>>2]);ba=ea(g[t+(E*12|0)+4>>2]);ka=ea(g[t+(E*12|0)+8>>2]);ha=ea(ea(ea(aa*ja)+ea(ma*ba))+ea(ka*fa));fa=ea(ea(ea(Z*ja)+ea(na*ba))+ea(ka*da));g[u>>2]=ea(ea(ea(R*ja)+ea(la*ba))+ea(ka*oa));g[M>>2]=ha;g[J>>2]=fa;GKa(b,u)|0;I=I+1|0}while((I|0)!=(d|0));d=c[O>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[s>>2]|0,(d|0)!=0):0){s=mKa()|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,d)}d=c[D>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[q>>2]|0,(d|0)!=0):0){q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,d)}}ko[c[(c[v>>2]|0)+4>>2]&4095](v);v=c[k>>2]|0;if((v&2147483647|0)!=0&(v|0)>-1?(v=c[l>>2]|0,(v|0)!=0):0){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,v)}v=c[h>>2]|0;if((v&2147483647|0)!=0&(v|0)>-1?(v=c[j>>2]|0,(v|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,v)}v=c[A>>2]|0;if(!((v&2147483647|0)!=0&(v|0)>-1)){i=e;return}v=c[f>>2]|0;if(!v){i=e;return}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,v);i=e;return}function D6(a,b){a=a|0;b=b|0;var c=0;c=i;$ka(a+16|0,b);i=c;return}function E6(a){a=a|0;var d=0,e=0;d=i;b[a+4>>1]=4;b[a+6>>1]=3;c[a>>2]=462544;e=a+8|0;c[e>>2]=434952;c[a+12>>2]=1;c[a>>2]=462264;c[e>>2]=462368;Yka(a+16|0);i=d;return}function F6(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=462264;c[a+8>>2]=462368;Zka(a+16|0);VJa(b,a);i=b;return}function G6(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+-8|0;c[d>>2]=462264;c[d+8>>2]=462368;Zka(d+16|0);VJa(b,d);i=b;return}function H6(a){a=a|0;var b=0;b=i;c[a>>2]=462264;c[a+8>>2]=462368;Zka(a+16|0);i=b;return}function I6(a){a=a|0;var b=0,d=0;b=i;d=a+-8|0;c[d>>2]=462264;c[d+8>>2]=462368;Zka(d+16|0);i=b;return}function J6(a){a=a|0;var d=0,e=0;d=i;KZ(c[108764]|0,a,0,1);e=a+6|0;b[e>>1]=b[e>>1]&-3;e=a+8|0;if(gTa(a+12|0)|0){i=d;return}ko[c[(c[e>>2]|0)+8>>2]&4095](e);i=d;return}function K6(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;if(!(aY(c[107930]|0,a)|0)){dKa(bKa()|0,8,462384,98,462472,d);i=d;return}e=c[a>>2]|0;if(!(b[a+6>>1]&1))ko[c[e+12>>2]&4095](a);else ko[c[e+16>>2]&4095](a);KZ(c[108764]|0,a,0,2);i=d;return}function L6(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=a+-8|0;if(!(aY(c[107930]|0,e)|0)){dKa(bKa()|0,8,462384,98,462472,d);i=d;return}a=c[e>>2]|0;if(!(b[e+6>>1]&1))ko[c[a+12>>2]&4095](e);else ko[c[a+16>>2]&4095](e);KZ(c[108764]|0,e,0,2);i=d;return}function M6(a){a=a|0;return c[a+12>>2]|0}function N6(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ala(a+16|0,b)|0;i=c;return d|0}function O6(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=bla(a+16|0,b)|0;i=c;return d|0}function P6(a){a=a|0;var b=0,c=0;b=i;c=cla(a+16|0)|0;i=b;return c|0}function Q6(a){a=a|0;var b=0,c=0;b=i;c=dla(a+16|0)|0;i=b;return c|0}function R6(a){a=a|0;var b=0,c=0;b=i;c=ela(a+16|0)|0;i=b;return c|0}function S6(a){a=a|0;var b=0,c=0;b=i;c=fla(a+16|0)|0;i=b;return c|0}function T6(a){a=a|0;var b=0,c=0;b=i;c=gla(a+16|0)|0;i=b;return c|0}function U6(a){a=a|0;var b=0,c=0;b=i;c=hla(a+16|0)|0;i=b;return c|0}function V6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=ila(a+16|0,b,c)|0;i=d;return e|0}function W6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=kla(a+16|0,b,c)|0;i=d;return e|0}function X6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=lla(a+16|0,b,c)|0;i=d;return e|0}function Y6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=jla(a+16|0,b,c)|0;i=d;return e|0}function Z6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=mla(a+16|0,b,c)|0;i=d;return e|0}function _6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=nla(a+16|0,b,c)|0;i=d;return e|0}function $6(a,b){a=a|0;b=b|0;return c[(c[a+24>>2]|0)+(b<<2)>>2]|0}function a7(a,b){a=a|0;b=ea(b);var c=0;c=i;ola(a+16|0,b);i=c;return}function b7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+20|0;f=a[e>>0]|0;g=f&255;if(!(g&4)){h=b+12|0;if(g&2){g=c[h>>2]|0;co[c[(c[g>>2]|0)+100>>2]&2047](g,c[b+4>>2]|0,c[b+8>>2]|0)}t6(c[h>>2]|0);j=a[e>>0]|0}else j=f;a[e>>0]=j&249;j=b+16|0;c[j>>2]=(c[j>>2]|0)+-1;i=d;return}function c7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+20|0;g=a[d>>0]|a[f>>0];a[d>>0]=g;d=c[b+16>>2]|0;if(g&6)if(!d)h=1;else{j=0;i=e;return j|0}else h=d+1|0;a[f>>0]=g;c[b+16>>2]=h;j=1;i=e;return j|0}function d7(d,e,f,g,h,i){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[d>>2]=-1;c[d+4>>2]=0;b[d+8>>1]=f;a[d+10>>0]=e;a[d+11>>0]=h;a[d+12>>0]=i;a[d+13>>0]=g;return}function e7(a){a=a|0;return}function f7(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0;f=i;g=a+8|0;h=b[g>>1]|0;j=b[d>>1]|0;if(j<<16>>16==h<<16>>16){i=f;return}b[g>>1]=j;j=c[a+4>>2]|0;if(!j){i=f;return}co[c[(c[j>>2]|0)+16>>2]&2047](j,h&65535,e[d>>1]|0);i=f;return}function g7(b,d){b=b|0;d=d|0;var e=0;e=i;a[b+12>>0]=d;d=c[b+4>>2]|0;if(!d){i=e;return}r7(d);i=e;return}function h7(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b;f=a+4|0;g=c[f>>2]|0;if(!g){i=b;return}h=d[a+10>>0]|0;if((h|0)==4|(h|0)==1){h=K8(a)|0;c[h+132>>2]=1073741823;c[h+136>>2]=1073741823;j=c[f>>2]|0}else j=g;c[e>>2]=0;Afa(e,j);j=zfa(e)|0;if(!j){i=b;return}else k=j;do{Ofa(k);k=zfa(e)|0}while((k|0)!=0);i=b;return}function i7(a){a=a|0;return}function j7(a){a=a|0;var b=0,d=0;b=i;d=c[(q7(c[a+4>>2]|0)|0)+1088>>2]|0;i=b;return d|0}function k7(a){a=a|0;var b=0,d=0;b=i;d=c[(q7(c[a+-24+4>>2]|0)|0)+1088>>2]|0;i=b;return d|0}function l7(a){a=a|0;var b=0,d=0;b=i;d=a+20|0;Pba(c[(c[a+8>>2]|0)+1088>>2]|0,c[d>>2]|0);c[d>>2]=0;i=b;return}function m7(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=Oba(c[(c[b+8>>2]|0)+1088>>2]|0)|0;c[b+20>>2]=e;if(!e){i=d;return}c[e+16>>2]=c[(c[b>>2]|0)+56>>2];f=b+4|0;c[e+20>>2]=c[(c[f>>2]|0)+56>>2];c[e+24>>2]=dca(c[b>>2]|0)|0;c[e+28>>2]=dca(c[f>>2]|0)|0;g=c[(c[b>>2]|0)+52>>2]|0;b=c[(c[f>>2]|0)+52>>2]|0;a[e+32>>0]=a[g+13>>0]|0;a[e+33>>0]=a[b+13>>0]|0;a[e+34>>0]=a[g+11>>0]|0;a[e+35>>0]=a[b+11>>0]|0;i=d;return}function n7(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;oia(b,c[d+1212>>2]|0,a[e+10>>0]|0,f);c[b>>2]=462664;c[b+52>>2]=e;c[e+4>>2]=b;i=g;return}function o7(a){a=a|0;var b=0;b=i;i=i+16|0;qia(a);VJa(b,a);i=b;return}function p7(a){a=a|0;var b=0;b=i;qia(a);i=b;return}function q7(a){a=a|0;return c[(c[a+36>>2]|0)+1008>>2]|0}function r7(d){d=d|0;var f=0,g=0,h=0,j=0;f=i;g=c[d+20>>2]|0;h=c[d+28>>2]|0;d=g+(h<<2)|0;if((h|0)>0)j=g;else{i=f;return}do{g=c[j>>2]|0;if(((a[g+21>>0]&3)!=0?(h=Qaa(g)|0,(h|0)!=0):0)?(g=h+4|0,b[g>>1]=e[g>>1]|0|8,g=h+6|0,(b[g>>1]&2)==0):0){Oaa(h);b[g>>1]=e[g>>1]|0|2}j=j+4|0}while(j>>>0<d>>>0);i=f;return}function s7(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;k=c[d+20>>2]|0;l=c[d+28>>2]|0;d=k+(l<<2)|0;if((l|0)<=0){i=j;return}if(!g){l=k;do{m=c[l>>2]|0;if(((a[m+21>>0]&h)<<24>>24!=0?(n=Qaa(m)|0,(n|0)!=0):0)?(m=n+4|0,b[m>>1]=e[m>>1]|0|f,m=n+6|0,(b[m>>1]&2)==0):0){Oaa(n);b[m>>1]=e[m>>1]|0|2}l=l+4|0}while(l>>>0<d>>>0);i=j;return}else o=k;do{k=c[o>>2]|0;if(!((c[k+4>>2]|0)!=(g|0)?(c[k+8>>2]|0)!=(g|0):0))p=10;if((((p|0)==10?(p=0,(a[k+21>>0]&h)<<24>>24!=0):0)?(l=Qaa(k)|0,(l|0)!=0):0)?(k=l+4|0,b[k>>1]=e[k>>1]|0|f,k=l+6|0,(b[k>>1]&2)==0):0){Oaa(l);b[k>>1]=e[k>>1]|0|2}o=o+4|0}while(o>>>0<d>>>0);i=j;return}function t7(a){a=a|0;var d=0,e=0,f=Im;c[a>>2]=0;d=c[116650]|0;c[a+4>>2]=4;c[a+8>>2]=4;c[a+12>>2]=4;g[a+20>>2]=ea(ea(g[d>>2])*ea(.100000001));b[a+16>>1]=260;e=d+8|0;f=ea(g[e>>2]);g[a+24>>2]=ea(f*ea(f*ea(.0000499999987)));g[a+32>>2]=ea(g[116652]);f=ea(g[e>>2]);g[a+28>>2]=ea(f*ea(f*ea(4.99999987e-06)));return}function u7(a){a=a|0;return}function v7(a){a=a|0;return c[a+4>>2]|0}function w7(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function x7(a){a=a|0;return c[a+8>>2]|0}function y7(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function z7(a){a=a|0;return c[a+12>>2]|0}function A7(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function B7(a){a=a|0;var b=Im;b=ea(g[a+20>>2]);return ea(b)}function C7(a,b){a=a|0;b=ea(b);g[a+20>>2]=b;return}function D7(a){a=a|0;var b=Im;b=ea(g[a+32>>2]);return ea(b)}function E7(a,b){a=a|0;b=ea(b);g[a+32>>2]=b;return}function F7(a,b){a=a|0;b=ea(b);g[a+32>>2]=b;return}function G7(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a>>2]|0;if(!d){e=ea(g[a+32>>2])==ea(0.0);i=b;return e|0}else{e=z8(d)|0;i=b;return e|0}return 0}function H7(a,b){a=a|0;b=ea(b);g[a+32>>2]=b;return}function I7(a){a=a|0;g[a+32>>2]=ea(0.0);return}function J7(a){a=a|0;var b=Im;b=ea(g[a+24>>2]);return ea(b)}function K7(a,b){a=a|0;b=ea(b);g[a+24>>2]=b;return}function L7(a,b){a=a|0;b=ea(b);g[a+28>>2]=b;return}function M7(a){a=a|0;return b[a+16>>1]|0}function N7(a,c){a=a|0;c=c|0;b[a+16>>1]=c;return}function O7(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,g=0;e=i;f=c[a>>2]|0;if(!f){g=0;i=e;return g|0}g=D8(f,b,d)|0;i=e;return g|0}function P7(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0;f=i;E8(c[a>>2]|0,b,d,e);i=f;return}function Q7(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;if(!e){i=d;return}F8(e,b);i=d;return}function R7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=c[a>>2]|0;if(!h){i=g;return}G8(h,b,d,e,f);i=g;return}function S7(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=c[a>>2]|0;if(!k){i=j;return}H8(k,b,d,e,f,g,h);i=j;return}function T7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=b+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[f>>2]=ea(1.0);h=b+20|0;i=b+44|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;g[i>>2]=ea(1.0);j=b+48|0;g[j>>2]=ea(0.0);k=b+52|0;g[k>>2]=ea(0.0);l=b+56|0;g[l>>2]=ea(0.0);m=b+104|0;g[m>>2]=ea(0.0);n=b+108|0;g[n>>2]=ea(0.0);o=b+120|0;g[o>>2]=ea(.0500000007);p=b+144|0;g[p>>2]=ea(.0500000007);g[b+4>>2]=ea(g[d>>2]);g[b+8>>2]=ea(g[d+4>>2]);g[b+12>>2]=ea(g[d+8>>2]);g[f>>2]=ea(g[d+12>>2]);g[h>>2]=ea(g[d+16>>2]);g[b+24>>2]=ea(g[d+20>>2]);g[b+28>>2]=ea(g[d+24>>2]);g[b+32>>2]=ea(g[e>>2]);g[b+36>>2]=ea(g[e+4>>2]);g[b+40>>2]=ea(g[e+8>>2]);g[i>>2]=ea(g[e+12>>2]);g[j>>2]=ea(g[e+16>>2]);g[k>>2]=ea(g[e+20>>2]);g[l>>2]=ea(g[e+24>>2]);g[b+60>>2]=ea(0.0);g[b+64>>2]=ea(0.0);g[b+68>>2]=ea(0.0);g[b+72>>2]=ea(1.0);e=b+76|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;g[m>>2]=ea(1.0);g[n>>2]=ea(1.0);g[b+112>>2]=ea(.785398185);g[b+116>>2]=ea(.785398185);g[o>>2]=ea(.0500000007);a[b+124>>0]=0;g[b+128>>2]=ea(0.0);g[b+132>>2]=ea(0.0);g[b+140>>2]=ea(-.785398185);g[b+136>>2]=ea(.785398185);g[p>>2]=ea(.0500000007);a[b+148>>0]=0;g[b+152>>2]=ea(.198912367);g[b+156>>2]=ea(.198912367);g[b+160>>2]=ea(.0125006512);g[b+164>>2]=ea(.198912367);g[b+168>>2]=ea(-.198912367);g[b+172>>2]=ea(.0125006512);return}function U7(a){a=a|0;return}function V7(a,b){a=a|0;b=b|0;g[a+4>>2]=ea(g[b>>2]);g[a+8>>2]=ea(g[b+4>>2]);g[a+12>>2]=ea(g[b+8>>2]);g[a+16>>2]=ea(g[b+12>>2]);g[a+20>>2]=ea(g[b+16>>2]);g[a+24>>2]=ea(g[b+20>>2]);g[a+28>>2]=ea(g[b+24>>2]);return}function W7(a,b){a=a|0;b=b|0;g[a+32>>2]=ea(g[b>>2]);g[a+36>>2]=ea(g[b+4>>2]);g[a+40>>2]=ea(g[b+8>>2]);g[a+44>>2]=ea(g[b+12>>2]);g[a+48>>2]=ea(g[b+16>>2]);g[a+52>>2]=ea(g[b+20>>2]);g[a+56>>2]=ea(g[b+24>>2]);return}function X7(a,b){a=a|0;b=b|0;g[a+60>>2]=ea(g[b>>2]);g[a+64>>2]=ea(g[b+4>>2]);g[a+68>>2]=ea(g[b+8>>2]);g[a+72>>2]=ea(g[b+12>>2]);return}function Y7(a,b){a=a|0;b=b|0;g[a+76>>2]=ea(g[b>>2]);g[a+80>>2]=ea(g[b+4>>2]);g[a+84>>2]=ea(g[b+8>>2]);return}function Z7(a,b){a=a|0;b=ea(b);g[a+88>>2]=b;return}function _7(a,b){a=a|0;b=ea(b);g[a+92>>2]=b;return}function $7(a,b){a=a|0;b=ea(b);g[a+104>>2]=b;return}function a8(a,b){a=a|0;b=ea(b);g[a+108>>2]=b;return}function b8(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a+112>>2]=b;g[a+116>>2]=c;g[a+152>>2]=ea(+X(+(+ea(b*ea(.25)))));g[a+156>>2]=ea(+X(+(+ea(c*ea(.25)))));return}function c8(a,b){a=a|0;b=ea(b);g[a+128>>2]=b;return}function d8(a,b){a=a|0;b=ea(b);g[a+132>>2]=b;return}function e8(b,c){b=b|0;c=c|0;a[b+124>>0]=c&1;return}function f8(a,b){a=a|0;b=ea(b);g[a+120>>2]=b;g[a+160>>2]=ea(+X(+(+ea(b*ea(.25)))));return}function g8(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a+140>>2]=b;g[a+136>>2]=c;g[a+164>>2]=ea(+X(+(+ea(c*ea(.25)))));g[a+168>>2]=ea(+X(+(+ea(b*ea(.25)))));return}function h8(b,c){b=b|0;c=c|0;a[b+148>>0]=c&1;return}function i8(a,b){a=a|0;b=ea(b);g[a+144>>2]=b;g[a+172>>2]=ea(+X(+(+ea(b*ea(.25)))));return}function j8(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;Gia(a,e,f,5,0);b[a+28>>1]=-1;b[a+30>>1]=0;c[a>>2]=462696;c[a+24>>2]=462732;c[a+32>>2]=-1;h=a+36|0;c[h>>2]=d;d=o8(a,0)|0;j=a+4|0;Oia(c[(c[j>>2]|0)+36>>2]|0,a,d);via(c[j>>2]|0,a);via(c[a+8>>2]|0,a);s8(c[e+152>>2]|0,f,e,a);c[c[h>>2]>>2]=a;i=g;return}function k8(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=462696;c[a+24>>2]=462732;d=a+32|0;if((c[d>>2]|0)!=-1)Mua(Via(c[(q7(c[a+4>>2]|0)|0)+1212>>2]|0)|0,2,d);d=c[a+8>>2]|0;w8(c[d+152>>2]|0,d);c[c[a+36>>2]>>2]=0;VJa(b,a);i=b;return}function l8(a){a=a|0;var b=0;b=i;k8(a+-24|0);i=b;return}function m8(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=462696;c[a+24>>2]=462732;d=a+32|0;if((c[d>>2]|0)!=-1)Mua(Via(c[(q7(c[a+4>>2]|0)|0)+1212>>2]|0)|0,2,d);d=c[a+8>>2]|0;w8(c[d+152>>2]|0,d);c[c[a+36>>2]>>2]=0;i=b;return}function n8(a){a=a|0;var b=0,d=0;b=i;d=a+-24|0;c[d>>2]=462696;c[d+24>>2]=462732;a=d+32|0;if((c[a>>2]|0)!=-1)Mua(Via(c[(q7(c[d+4>>2]|0)|0)+1212>>2]|0)|0,2,a);a=c[d+8>>2]|0;w8(c[a+152>>2]|0,a);c[c[d+36>>2]>>2]=0;i=b;return}function o8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+32|0;h=b+4|0;if((c[g>>2]|0)==-1){j=Via(c[(c[h>>2]|0)+36>>2]|0)|0;c[e>>2]=c[(c[h>>2]|0)+188>>2];c[f>>2]=c[(c[b+8>>2]|0)+188>>2];Fua(j,2,e,f,g);Jua(j,g);Kua(j,g)}if(!(a[(c[h>>2]|0)+51>>0]&1)){i=d;return 0}else{i=d;return (a[(c[b+8>>2]|0)+51>>0]&1)!=0|0}return 0}function p8(a,b){a=a|0;b=b|0;return 1}function q8(a){a=a|0;var d=0,f=0;d=i;f=a+30|0;if(b[f>>1]&2){Paa(a+24|0);b[f>>1]=(e[f>>1]|0)&65533}f=a+4|0;wia(c[f>>2]|0,a);wia(c[a+8>>2]|0,a);Pia(c[(c[f>>2]|0)+36>>2]|0,a);ko[c[(c[a>>2]|0)+12>>2]&4095](a);i=d;return}function r8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g;c[b>>2]=0;c[b+4>>2]=e;j=b+8|0;c[j>>2]=d;k=b+12|0;l=b+24|0;m=b+32|0;n=b+88|0;o=b+160|0;p=k+0|0;q=p+36|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));p=n+0|0;q=p+72|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));a[o>>0]=1;o=c[(c[e+1212>>2]|0)+1e3>>2]|0;yXa(k,16);if((c[b+44>>2]&2147483632)>>>0<16)zXa(b+36|0,16);if((c[m>>2]&2147483632)>>>0<16)AXa(l,16);l=Isa(o)|0;c[b>>2]=l;if(!l){dKa(bKa()|0,32,462752,70,462848,h);i=g;return}else{s8(b,K8(f)|0,0,0);c[c[j>>2]>>2]=b;c[b+72>>2]=d+4;c[b+48>>2]=0;d=b+56|0;j=b+76|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;i=g;return}}function s8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;h=g+4|0;j=g;c[h>>2]=f;k=b+24|0;c[j>>2]=d;l=b+28|0;m=c[l>>2]|0;if((c[b+32>>2]&2147483647)>>>0>m>>>0){n=(c[k>>2]|0)+(m<<2)|0;if(n)c[n>>2]=d;c[l>>2]=m+1}else BXa(k,j)|0;j=b+36|0;m=b+40|0;n=c[m>>2]|0;if((c[b+44>>2]&2147483647)>>>0>n>>>0){o=(c[j>>2]|0)+(n<<2)|0;if(o)c[o>>2]=f;c[m>>2]=n+1}else CXa(j,h)|0;j=b+12|0;n=b+16|0;m=c[n>>2]|0;f=c[b+20>>2]|0;o=f&2147483647;if(o>>>0>m>>>0)p=m;else{yXa(j,(o|0)==0?1:f<<1);p=c[n>>2]|0}f=c[j>>2]|0;c[n>>2]=p+1;c[f+(p<<5)+16>>2]=d+64;c[f+(p<<5)+20>>2]=(c[d+52>>2]|0)+16;n=f+(p<<5)|0;c[n>>2]=0;c[n+4>>2]=0;n=DXa(d)|0;q=ea(D7(c[b+8>>2]|0));if(!e){o=q==ea(0.0);c[f+(p<<5)+28>>2]=-1;r=f+(p<<5)+8|0;c[r>>2]=1;c[r+4>>2]=0;c[f+(p<<5)+24>>2]=0;s=o;t=o&n}else{o=c[k>>2]|0;r=c[o>>2]|0;u=(a[r+51>>0]&1)==0;v=n&u;n=c[l>>2]|0;a:do if(!n)w=-2147483648;else{x=r;y=0;while(1){z=y+1|0;if((x|0)==(e|0)){w=y;break a}if(z>>>0>=n>>>0){w=-2147483648;break a}x=c[o+(z<<2)>>2]|0;y=z}}while(0);c[f+(p<<5)+28>>2]=w;o=(c[j>>2]|0)+(w<<5)+8|0;n=c[o>>2]|0;e=c[o+4>>2]|0;o=cFi(1,0,m|0)|0;r=H;y=f+(p<<5)+8|0;c[y>>2]=n|o;c[y+4>>2]=e|r;c[f+(p<<5)+24>>2]=(c[(c[h>>2]|0)+36>>2]|0)+4;h=(c[j>>2]|0)+(w<<5)|0;w=h;j=c[w+4>>2]|r;r=h;c[r>>2]=c[w>>2]|o;c[r+4>>2]=j;s=u;t=v}if(!(t|s^1)?(c[l>>2]|0)!=1:0){s=0;do{G9(c[(c[k>>2]|0)+(s<<2)>>2]|0,q);s=s+1|0}while(s>>>0<((c[l>>2]|0)+-1|0)>>>0)}Q9(d,b,q,t);t=c[b>>2]|m;m=Via(c[(q7(d)|0)+1212>>2]|0)|0;l=d+188|0;if(!(t&63)){Dua(m,t,b,l);A=b+160|0;a[A>>0]=1;i=g;return}else{Cua(m,t,b,l);A=b+160|0;a[A>>0]=1;i=g;return}}function t8(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a>>2]|0;if(d){Jsa(c[(c[(c[a+4>>2]|0)+1212>>2]|0)+1e3>>2]|0,d);c[c[a+8>>2]>>2]=0}d=c[a+148>>2]|0;e=c[a+156>>2]|0;if(!((e|0)<0|(e&2147483647|0)==0|(d|0)==0)){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+136>>2]|0;e=c[a+144>>2]|0;if(!((e|0)<0|(e&2147483647|0)==0|(d|0)==0)){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+132>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+124>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+120>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+112>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+108>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+100>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+96>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+88>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+44>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+36>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+32>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+24>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+20>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+12>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function u8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+28|0;if(!(c[e>>2]|0)){i=d;return}f=a+24|0;a=0;do{r9(c[(c[f>>2]|0)+(a<<2)>>2]|0,b);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=d;return}function v8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a>>2]|0;f=c[a+28>>2]|0;a:do if(!f)g=-2147483648;else{h=c[a+24>>2]|0;j=0;while(1){if((c[h+(j<<2)>>2]|0)==(b|0)){g=j;break a}j=j+1|0;if(j>>>0>=f>>>0){g=-2147483648;break}}}while(0);i=d;return g|e|0}function w8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[b+28>>2]|0;a:do if(!f)g=-2147483648;else{h=c[b+24>>2]|0;j=0;while(1){if((c[h+(j<<2)>>2]|0)==(d|0)){g=j;break a}j=j+1|0;if(j>>>0>=f>>>0){g=-2147483648;break}}}while(0);Q9(d,0,ea(0.0),1);d=b+12|0;f=g+1|0;j=b+16|0;h=c[j>>2]|0;if(f>>>0<h>>>0){k=b+24|0;l=b+36|0;m=g;n=f;while(1){f=c[d>>2]|0;o=f+(m<<5)|0;p=f+(n<<5)|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[o+16>>2]=c[p+16>>2];c[o+20>>2]=c[p+20>>2];c[o+24>>2]=c[p+24>>2];c[o+28>>2]=c[p+28>>2];p=c[k>>2]|0;c[p+(m<<2)>>2]=c[p+(n<<2)>>2];p=c[l>>2]|0;c[p+(m<<2)>>2]=c[p+(n<<2)>>2];p=c[(c[k>>2]|0)+(m<<2)>>2]|0;o=c[b>>2]|m;f=Via(c[(q7(p)|0)+1212>>2]|0)|0;q=p+188|0;if(!(o&63))Dua(f,o,b,q);else Cua(f,o,b,q);q=n+1|0;o=c[j>>2]|0;if(q>>>0<o>>>0){f=n;n=q;m=f}else{r=o;break}}}else r=h;h=cFi(1,0,g|0)|0;m=H;n=_Ei(h|0,m|0,-1,-1)|0;k=H;l=~(n|h);h=~(k|m);if(!r){s=0;t=s+-1|0;c[j>>2]=t;u=b+160|0;a[u>>0]=1;i=e;return}m=c[d>>2]|0;d=0;do{o=c[m+(d<<5)+28>>2]|0;if((o|0)!=-1&o>>>0>g>>>0){o=m+(d<<5)+8|0;f=o;q=c[f>>2]|0;p=c[f+4>>2]|0;f=VEi(q&l|0,p&h|0,1)|0;v=o;c[v>>2]=f|q&n;c[v+4>>2]=H|p&k}p=m+(d<<5)|0;v=p;q=c[v>>2]|0;f=c[v+4>>2]|0;v=VEi(q&l|0,f&h|0,1)|0;o=p;c[o>>2]=v|q&n;c[o+4>>2]=H|f&k;d=d+1|0}while(d>>>0<r>>>0);s=r;t=s+-1|0;c[j>>2]=t;u=b+160|0;a[u>>0]=1;i=e;return}function x8(d){d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+176|0;h=f;j=f+136|0;k=f+80|0;l=f+32|0;m=f+164|0;n=f+128|0;o=f+132|0;p=f+169|0;q=f+168|0;if(!(c[d+28>>2]|0)){i=f;return}if((c[(c[c[d+24>>2]>>2]|0)+188>>2]|0)==-1){i=f;return}r=d+16|0;s=c[r>>2]|0;t=d+160|0;if(!(a[t>>0]|0)){i=f;return}u=d+48|0;v=d+84|0;if((s|0)!=(e[v>>1]|0)){w=d+124|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;EXa(w,s,h);h=d+112|0;g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(1.0);g[j+16>>2]=ea(0.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);FXa(h,s,j);j=d+100|0;g[k>>2]=ea(1.0);x=k+4|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[k+20>>2]=ea(1.0);x=k+24|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[k+40>>2]=ea(1.0);g[k+44>>2]=ea(0.0);GXa(j,s,k);k=d+88|0;g[l>>2]=ea(1.0);x=l+4|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[l+20>>2]=ea(1.0);x=l+24|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[l+40>>2]=ea(1.0);g[l+44>>2]=ea(0.0);GXa(k,s,l);Gza(s,m,n,o);s=d+136|0;l=c[n>>2]|0;a[p>>0]=0;HXa(s,l,p);c[d+56>>2]=c[w>>2];c[d+64>>2]=c[j>>2];c[d+68>>2]=c[k>>2];c[d+60>>2]=c[h>>2];b[d+82>>1]=c[m>>2];b[d+80>>1]=c[n>>2];c[u>>2]=c[s>>2];s=d+148|0;n=c[o>>2]|0;a[q>>0]=0;HXa(s,n,q);c[d+76>>2]=c[s>>2];b[d+86>>1]=c[o>>2]}o=d+104|0;PEi(c[d+100>>2]|0,0,(c[o>>2]|0)*48|0)|0;PEi(c[d+88>>2]|0,0,(c[o>>2]|0)*48|0)|0;c[d+52>>2]=c[d+12>>2];b[v>>1]=c[r>>2];c[c[d>>2]>>2]=u;a[t>>0]=0;i=f;return}function y8(b,d,e,f){b=b|0;d=ea(d);e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0;f=i;if(!(c[b+28>>2]|0)){i=f;return}h=b+24|0;j=c[c[h>>2]>>2]|0;if(!(a[j+51>>0]&1)){i=f;return}k=b+8|0;l=c[k>>2]|0;m=ea(g[l+24>>2]);n=ea(g[l+28>>2]);o=b+16|0;if(c[o>>2]|0){b=j;j=1;p=ea(0.0);q=ea(3402823469999999843913219.0e14);while(1){r=ea(I9(b,d,m,n,e,0));s=p>r?p:r;t=q<r?q:r;if(j>>>0>=(c[o>>2]|0)>>>0)break;b=c[(c[h>>2]|0)+(j<<2)>>2]|0;j=j+1|0;p=s;q=t}E7(c[k>>2]|0,s);if(s!=ea(0.0)){if(!(t==ea(0.0))){i=f;return}if(!(c[o>>2]|0)){i=f;return}else u=0;do{k=c[(c[(c[h>>2]|0)+(u<<2)>>2]|0)+52>>2]|0;t=ea(d9(k));j=t<ea(9.99999997e-07);g[k+152>>2]=j?ea(9.99999997e-07):t;u=u+1|0}while(u>>>0<(c[o>>2]|0)>>>0);i=f;return}}else E7(l,ea(0.0));if(!(c[o>>2]|0)){i=f;return}else v=0;do{A9(c[(c[h>>2]|0)+(v<<2)>>2]|0);H9(c[(c[h>>2]|0)+(v<<2)>>2]|0);v=v+1|0}while(v>>>0<(c[o>>2]|0)>>>0);i=f;return}function z8(b){b=b|0;var d=0,e=0;d=i;if(!(c[b+28>>2]|0)){e=1;i=d;return e|0}e=(a[(c[c[b+24>>2]>>2]|0)+51>>0]&1)==0;i=d;return e|0}function A8(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;e=a+8|0;if(!(ea(D7(c[e>>2]|0))<b)){i=d;return}E7(c[e>>2]|0,b);e=a+16|0;if(!(c[e>>2]|0)){i=d;return}f=a+24|0;a=0;do{G9(c[(c[f>>2]|0)+(a<<2)>>2]|0,b);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=d;return}function B8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+28|0;g=c[f>>2]|0;if(!g){i=e;return}h=a+24|0;a=g;g=0;do{j=g;g=g+1|0;uia(c[(c[h>>2]|0)+(j<<2)>>2]|0,b,d);a=c[f>>2]|0}while(g>>>0<a>>>0);i=e;return}function C8(a,b,d,e,f,g,h){a=a|0;b=ea(b);d=ea(d);e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;k=a+28|0;l=c[k>>2]|0;if(!l){i=j;return}m=a+24|0;a=l;l=0;do{n=l;l=l+1|0;N9(c[(c[m>>2]|0)+(n<<2)>>2]|0,b,d,e,f,g,h);a=c[k>>2]|0}while(l>>>0<a>>>0);i=j;return}function D8(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;x8(a);g=a+16|0;Gza(c[g>>2]|0,e+8|0,f,e);h=UJa(e+12|0,c[f>>2]|0,462752,408)|0;Pza(h,c[g>>2]&65535,c[a+12>>2]|0,b,d,c[a+148>>2]|0,c[a+152>>2]|0);i=e;return h|0}function E8(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0;f=i;x8(a);Pza(b,c[a+16>>2]&65535,c[a+12>>2]|0,d,e,c[a+148>>2]|0,c[a+152>>2]|0);i=f;return}function F8(a,b){a=a|0;b=b|0;a=i;i=i+16|0;VJa(a,b);i=a;return}function G8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;h=i;i=i+4096|0;j=h+2048|0;k=h;l=a+16|0;m=c[l>>2]<<5;PEi(k|0,0,m|0)|0;PEi(j|0,0,m|0)|0;m=K8(b)|0;b=c[a+28>>2]|0;a:do if(!b)n=-2147483648;else{o=c[a+24>>2]|0;p=0;while(1){if((c[o+(p<<2)>>2]|0)==(m|0)){n=p;break a}p=p+1|0;if(p>>>0>=b>>>0){n=-2147483648;break}}}while(0);q=ea(-ea(g[e>>2]));r=ea(-ea(g[e+4>>2]));s=ea(-ea(g[e+8>>2]));g[k+(n<<5)>>2]=q;g[k+(n<<5)+4>>2]=r;g[k+(n<<5)+8>>2]=s;g[k+(n<<5)+12>>2]=ea(0.0);s=ea(-ea(g[f>>2]));r=ea(-ea(g[f+4>>2]));q=ea(-ea(g[f+8>>2]));g[k+(n<<5)+16>>2]=s;g[k+(n<<5)+20>>2]=r;g[k+(n<<5)+24>>2]=q;g[k+(n<<5)+28>>2]=ea(0.0);zza(d,k,j);k=c[l>>2]|0;if(!k){i=h;return}l=c[a+24>>2]|0;a=0;do{d=c[(c[l+(a<<2)>>2]|0)+52>>2]|0;q=ea(g[j+(a<<5)>>2]);r=ea(g[j+(a<<5)+4>>2]);s=ea(g[j+(a<<5)+8>>2]);t=ea(g[j+(a<<5)+16>>2]);u=ea(g[j+(a<<5)+20>>2]);v=ea(g[j+(a<<5)+24>>2]);n=d+80|0;w=ea(q+ea(g[n>>2]));f=d+84|0;q=ea(r+ea(g[f>>2]));e=d+88|0;r=ea(s+ea(g[e>>2]));g[n>>2]=w;g[f>>2]=q;g[e>>2]=r;e=d+96|0;r=ea(t+ea(g[e>>2]));f=d+100|0;t=ea(u+ea(g[f>>2]));n=d+104|0;u=ea(v+ea(g[n>>2]));g[e>>2]=r;g[f>>2]=t;g[n>>2]=u;a=a+1|0}while(a>>>0<k>>>0);i=h;return}function H8(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;k=i;i=i+64|0;l=k+32|0;m=k;n=K8(b)|0;b=c[a+28>>2]|0;a:do if(!b)o=-2147483648;else{p=c[a+24>>2]|0;q=0;while(1){if((c[p+(q<<2)>>2]|0)==(n|0)){o=q;break a}q=q+1|0;if(q>>>0>=b>>>0){o=-2147483648;break}}}while(0);r=ea(g[h>>2]);s=ea(g[h+4>>2]);t=ea(g[h+8>>2]);u=ea(g[j>>2]);v=ea(g[j+4>>2]);w=ea(g[j+8>>2]);g[m>>2]=r;g[m+4>>2]=s;g[m+8>>2]=t;g[m+12>>2]=ea(0.0);g[m+16>>2]=u;g[m+20>>2]=v;g[m+24>>2]=w;g[m+28>>2]=ea(0.0);Bza(f,o,m,l);w=ea(g[l>>2]);v=ea(g[l+4>>2]);u=ea(g[l+8>>2]);g[d>>2]=w;g[d+4>>2]=v;g[d+8>>2]=u;u=ea(g[l+16>>2]);v=ea(g[l+20>>2]);w=ea(g[l+24>>2]);g[e>>2]=u;g[e+4>>2]=v;g[e+8>>2]=w;i=k;return}function I8(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im;h=i;Tba(d,e);j=d+44|0;a[j>>0]=0;k=c[116650]|0;g[d+152>>2]=ea(g[116652]);g[d+128>>2]=ea(1.0);g[d+132>>2]=ea(1.0);g[d+136>>2]=ea(1.0);g[d+140>>2]=ea(1.0);g[d+16>>2]=ea(g[f>>2]);g[d+20>>2]=ea(g[f+4>>2]);g[d+24>>2]=ea(g[f+8>>2]);g[d+28>>2]=ea(g[f+12>>2]);g[d+32>>2]=ea(g[f+16>>2]);g[d+36>>2]=ea(g[f+20>>2]);g[d+40>>2]=ea(g[f+24>>2]);f=k+8|0;l=ea(g[f>>2]);g[d+144>>2]=ea(l*ea(l*ea(.0000499999987)));l=ea(g[f>>2]);g[d+148>>2]=ea(l*ea(l*ea(9.99999974e-06)));c[d+156>>2]=0;g[d+92>>2]=ea(-1000000029999999928682502.0e8);a[j>>0]=0;g[d+80>>2]=ea(0.0);g[d+84>>2]=ea(0.0);g[d+88>>2]=ea(0.0);g[d+96>>2]=ea(0.0);g[d+100>>2]=ea(0.0);g[d+104>>2]=ea(0.0);g[d+120>>2]=ea(0.0);g[d+116>>2]=ea(3402823469999999843913219.0e14);b[d+46>>1]=260;g[d+108>>2]=ea(3402823469999999843913219.0e14);g[d+48>>2]=ea(0.0);g[d+52>>2]=ea(0.0);g[d+56>>2]=ea(0.0);g[d+60>>2]=ea(1.0);g[d+64>>2]=ea(0.0);g[d+68>>2]=ea(0.0);g[d+72>>2]=ea(0.0);g[d+76>>2]=ea(.150000006);a[d+45>>0]=0;j=d+124|0;if((e|0)==1){g[j>>2]=ea(.0500000007);g[d+112>>2]=ea(49.0);i=h;return}else{g[j>>2]=ea(0.0);g[d+112>>2]=ea(3402823469999999843913219.0e14);i=h;return}}function J8(a){a=a|0;var b=0;b=i;Uba(a);i=b;return}function K8(a){a=a|0;return c[a+4>>2]|0}function L8(a,b){a=a|0;b=ea(b);g[a+76>>2]=b;return}function M8(a,b){a=a|0;b=b|0;var d=0;d=i;g[a+16>>2]=ea(g[b>>2]);g[a+20>>2]=ea(g[b+4>>2]);g[a+24>>2]=ea(g[b+8>>2]);g[a+28>>2]=ea(g[b+12>>2]);g[a+32>>2]=ea(g[b+16>>2]);g[a+36>>2]=ea(g[b+20>>2]);g[a+40>>2]=ea(g[b+24>>2]);b=c[a+4>>2]|0;if(!b){i=d;return}y9(b);i=d;return}function N8(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im;j=i;k=c[b+4>>2]|0;if(k)t9(k);k=b+156|0;b=c[k>>2]|0;if(b)if(!(a[b+31>>0]|0))l=b;else{m=b;n=8}else{b=e+292|0;o=c[b>>2]|0;if(!o){IXa(e);p=c[b>>2]|0}else p=o;c[b>>2]=c[p>>2];b=e+280|0;c[b>>2]=(c[b>>2]|0)+1;b=e+284|0;c[b>>2]=(c[b>>2]|0)+-1;m=(p|0)==0?0:p;n=8}if((n|0)==8){n=m+0|0;p=n+64|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(p|0));c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;a[m+12>>0]=0;c[k>>2]=m;l=m}m=l+12|0;a[m>>0]=d[m>>0]|2;if(f){q=ea(g[f>>2]);g[l>>2]=ea(q+ea(g[l>>2]));q=ea(g[f+4>>2]);m=l+4|0;g[m>>2]=ea(q+ea(g[m>>2]));q=ea(g[f+8>>2]);f=l+8|0;g[f>>2]=ea(q+ea(g[f>>2]))}if(!h){i=j;return}q=ea(g[h>>2]);f=l+16|0;g[f>>2]=ea(q+ea(g[f>>2]));q=ea(g[h+4>>2]);f=l+20|0;g[f>>2]=ea(q+ea(g[f>>2]));q=ea(g[h+8>>2]);h=l+24|0;g[h>>2]=ea(q+ea(g[h>>2]));i=j;return}function O8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;j=b+156|0;k=c[j>>2]|0;l=(k|0)==0;if(e){if(l){e=d+292|0;m=c[e>>2]|0;if(!m){IXa(d);n=c[e>>2]|0}else n=m;c[e>>2]=c[n>>2];e=d+280|0;c[e>>2]=(c[e>>2]|0)+1;e=d+284|0;c[e>>2]=(c[e>>2]|0)+-1;o=(n|0)==0?0:n}else o=k;p=o+0|0;q=p+64|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(q|0));a[o+31>>0]=1;a[o+28>>0]=f&1;f=b+120|0;g[o+48>>2]=ea(g[f>>2]);g[o+52>>2]=ea(g[b+124>>2]);g[o+32>>2]=ea(g[b+128>>2]);g[o+36>>2]=ea(g[b+132>>2]);g[o+40>>2]=ea(g[b+136>>2]);g[o+44>>2]=ea(g[b+140>>2]);n=b+112|0;g[o+56>>2]=ea(g[n>>2]);e=b+116|0;g[o+60>>2]=ea(g[e>>2]);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[n>>2]=ea(3402823469999999843913219.0e14);g[e>>2]=ea(3402823469999999843913219.0e14);r=o;c[j>>2]=r;i=h;return 1}else{if(l){l=d+292|0;o=c[l>>2]|0;if(!o){IXa(d);s=c[l>>2]|0}else s=o;c[l>>2]=c[s>>2];l=d+280|0;c[l>>2]=(c[l>>2]|0)+1;l=d+284|0;c[l>>2]=(c[l>>2]|0)+-1;t=(s|0)==0?0:s}else t=k;p=t+0|0;q=p+64|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(q|0));c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;a[t+12>>0]=0;r=t;c[j>>2]=r;i=h;return 1}return 0}function P8(b){b=b|0;var e=0,f=0;e=i;f=c[b+4>>2]|0;if(f)u9(f);f=c[b+156>>2]|0;if(!f){i=e;return}b=f+12|0;a[b>>0]=d[b>>0]|0|2;g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);i=e;return}function Q8(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im;j=i;k=c[b+4>>2]|0;if(k)v9(k);k=b+156|0;b=c[k>>2]|0;if(b)if(!(a[b+31>>0]|0))l=b;else{m=b;n=8}else{b=e+292|0;o=c[b>>2]|0;if(!o){IXa(e);p=c[b>>2]|0}else p=o;c[b>>2]=c[p>>2];b=e+280|0;c[b>>2]=(c[b>>2]|0)+1;b=e+284|0;c[b>>2]=(c[b>>2]|0)+-1;m=(p|0)==0?0:p;n=8}if((n|0)==8){n=m+0|0;p=n+64|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(p|0));c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;a[m+12>>0]=0;c[k>>2]=m;l=m}m=l+12|0;a[m>>0]=d[m>>0]|4;if(f){q=ea(g[f>>2]);m=l+32|0;g[m>>2]=ea(q+ea(g[m>>2]));q=ea(g[f+4>>2]);m=l+36|0;g[m>>2]=ea(q+ea(g[m>>2]));q=ea(g[f+8>>2]);f=l+40|0;g[f>>2]=ea(q+ea(g[f>>2]))}if(!h){i=j;return}q=ea(g[h>>2]);f=l+48|0;g[f>>2]=ea(q+ea(g[f>>2]));q=ea(g[h+4>>2]);f=l+52|0;g[f>>2]=ea(q+ea(g[f>>2]));q=ea(g[h+8>>2]);h=l+56|0;g[h>>2]=ea(q+ea(g[h>>2]));i=j;return}function R8(b){b=b|0;var e=0,f=0;e=i;f=c[b+4>>2]|0;if(f)w9(f);f=c[b+156>>2]|0;if(!f){i=e;return}b=f+12|0;a[b>>0]=d[b>>0]|0|4;g[f+32>>2]=ea(0.0);g[f+36>>2]=ea(0.0);g[f+40>>2]=ea(0.0);g[f+48>>2]=ea(0.0);g[f+52>>2]=ea(0.0);g[f+56>>2]=ea(0.0);i=e;return}function S8(b){b=b|0;var d=0,e=0,f=0,h=Im;d=i;e=c[b+156>>2]|0;if((e|0)!=0?(a[e+31>>0]|0)==1:0)f=e+44|0;else f=b+140|0;h=ea(g[f>>2]);i=d;return ea(h)}function T8(b,d){b=b|0;d=ea(d);var e=0,f=0;e=i;f=c[b+156>>2]|0;if((f|0)!=0?(a[f+31>>0]|0)==1:0){g[f+44>>2]=d;i=e;return}g[b+140>>2]=d;i=e;return}function U8(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+156>>2]|0;if((e|0)!=0?(a[e+31>>0]|0)==1:0){f=e+32|0;i=d;return f|0}f=b+128|0;i=d;return f|0}function V8(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+156>>2]|0;if((f|0)!=0?(a[f+31>>0]|0)==1:0){g[f+32>>2]=ea(g[d>>2]);g[f+36>>2]=ea(g[d+4>>2]);g[f+40>>2]=ea(g[d+8>>2]);i=e;return}g[b+128>>2]=ea(g[d>>2]);g[b+132>>2]=ea(g[d+4>>2]);g[b+136>>2]=ea(g[d+8>>2]);i=e;return}function W8(b){b=b|0;var d=0,e=0,f=0,h=Im;d=i;e=c[b+156>>2]|0;if((e|0)!=0?(a[e+31>>0]|0)==1:0)f=e+48|0;else f=b+120|0;h=ea(g[f>>2]);i=d;return ea(h)}function X8(b,d){b=b|0;d=ea(d);var e=0,f=0;e=i;f=c[b+156>>2]|0;if((f|0)!=0?(a[f+31>>0]|0)==1:0){g[f+48>>2]=d;i=e;return}g[b+120>>2]=d;i=e;return}function Y8(b){b=b|0;var d=0,e=0,f=0,h=Im;d=i;e=c[b+156>>2]|0;if((e|0)!=0?(a[e+31>>0]|0)==1:0)f=e+52|0;else f=b+124|0;h=ea(g[f>>2]);i=d;return ea(h)}function Z8(b,d){b=b|0;d=ea(d);var e=0,f=0;e=i;f=c[b+156>>2]|0;if((f|0)!=0?(a[f+31>>0]|0)==1:0){g[f+52>>2]=d;i=e;return}g[b+124>>2]=d;i=e;return}function _8(b){b=b|0;var d=0,e=0,f=0,h=Im;d=i;e=c[b+156>>2]|0;if((e|0)!=0?(a[e+31>>0]|0)==1:0)f=e+56|0;else f=b+112|0;h=ea(g[f>>2]);i=d;return ea(h)}function $8(b,d){b=b|0;d=ea(d);var e=0,f=0;e=i;f=c[b+156>>2]|0;if((f|0)!=0?(a[f+31>>0]|0)==1:0){g[f+56>>2]=d;i=e;return}g[b+112>>2]=d;i=e;return}function a9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;h=b+44|0;j=a[h>>0]|0;k=a[e>>0]|0;if(k<<24>>24==j<<24>>24){i=f;return}l=k&1;m=(j&1)!=0;j=(l|0)!=0&(m^1);n=m&(l|0)==0;if(j){b9(b);o=a[e>>0]|0}else o=k;a[h>>0]=o;o=c[b+4>>2]|0;if(!o){i=f;return}if(j){j=b+156|0;h=c[j>>2]|0;if(!h){k=d+292|0;e=c[k>>2]|0;if(!e){IXa(d);p=c[k>>2]|0}else p=e;c[k>>2]=c[p>>2];k=d+280|0;c[k>>2]=(c[k>>2]|0)+1;k=d+284|0;c[k>>2]=(c[k>>2]|0)+-1;q=(p|0)==0?0:p}else q=h;h=q+0|0;p=h+64|0;do{a[h>>0]=0;h=h+1|0}while((h|0)<(p|0));a[q+31>>0]=1;a[q+28>>0]=0;h=b+120|0;g[q+48>>2]=ea(g[h>>2]);g[q+52>>2]=ea(g[b+124>>2]);g[q+32>>2]=ea(g[b+128>>2]);g[q+36>>2]=ea(g[b+132>>2]);g[q+40>>2]=ea(g[b+136>>2]);g[q+44>>2]=ea(g[b+140>>2]);p=b+112|0;g[q+56>>2]=ea(g[p>>2]);k=b+116|0;g[q+60>>2]=ea(g[k>>2]);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;g[p>>2]=ea(3402823469999999843913219.0e14);g[k>>2]=ea(3402823469999999843913219.0e14);c[j>>2]=q;B9(o);i=f;return}if(!n){i=f;return}n=b+156|0;q=c[n>>2]|0;if(q){g[b+140>>2]=ea(g[q+44>>2]);g[b+128>>2]=ea(g[q+32>>2]);g[b+132>>2]=ea(g[q+36>>2]);g[b+136>>2]=ea(g[q+40>>2]);g[b+120>>2]=ea(g[q+48>>2]);g[b+124>>2]=ea(g[q+52>>2]);g[b+112>>2]=ea(g[q+56>>2]);g[b+116>>2]=ea(g[q+60>>2]);b=d+280|0;c[b>>2]=(c[b>>2]|0)+-1;b=d+292|0;c[q>>2]=c[b>>2];c[b>>2]=q;q=d+284|0;b=c[q>>2]|0;c[q>>2]=b+1;if((b|0)>=((c[d+276>>2]|0)*50|0)){JXa(d);c[q>>2]=0}c[n>>2]=0}C9(o);i=f;return}function b9(b){b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;g[b+80>>2]=ea(0.0);g[b+84>>2]=ea(0.0);g[b+88>>2]=ea(0.0);g[b+96>>2]=ea(0.0);g[b+100>>2]=ea(0.0);g[b+104>>2]=ea(0.0);e=b+4|0;f=c[e>>2]|0;h=(f|0)!=0;if(h){u9(f);w9(f)}j=c[b+156>>2]|0;if((j|0)!=0?(a[j+31>>0]|0)==0:0){g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(0.0);g[j+56>>2]=ea(0.0);g[j+32>>2]=ea(0.0);g[j+36>>2]=ea(0.0);g[j+40>>2]=ea(0.0);g[j+16>>2]=ea(0.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0)}g[b+152>>2]=ea(0.0);b=c[e>>2]|0;if(b)z9(b,ea(0.0),0);if(!h){i=d;return}E9(f);i=d;return}function c9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0;e=i;f=a+156|0;h=c[f>>2]|0;if(!h){i=e;return}if(d){g[a+140>>2]=ea(g[h+44>>2]);g[a+128>>2]=ea(g[h+32>>2]);g[a+132>>2]=ea(g[h+36>>2]);g[a+136>>2]=ea(g[h+40>>2]);g[a+120>>2]=ea(g[h+48>>2]);g[a+124>>2]=ea(g[h+52>>2]);g[a+112>>2]=ea(g[h+56>>2]);g[a+116>>2]=ea(g[h+60>>2])}a=b+280|0;c[a>>2]=(c[a>>2]|0)+-1;a=b+292|0;c[h>>2]=c[a>>2];c[a>>2]=h;h=b+284|0;a=c[h>>2]|0;c[h>>2]=a+1;if((a|0)>=((c[b+276>>2]|0)*50|0)){JXa(b);c[h>>2]=0}c[f>>2]=0;i=e;return}function d9(a){a=a|0;var b=Im;b=ea(g[a+152>>2]);return ea(b)}function e9(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0;e=i;g[a+152>>2]=b;f=c[a+4>>2]|0;if(!f){i=e;return}if(b>ea(0.0)|d)D9(f);z9(f,b,d);i=e;return}function f9(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+4>>2]|0;if(!e){f=1;i=d;return f|0}f=(a[e+51>>0]&1)==0;i=d;return f|0}function g9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;j=b+156|0;k=c[j>>2]|0;if(k){g[k>>2]=ea(g[e>>2]);g[k+4>>2]=ea(g[e+4>>2]);g[k+8>>2]=ea(g[e+8>>2]);g[k+12>>2]=ea(g[e+12>>2]);g[k+16>>2]=ea(g[e+16>>2]);g[k+20>>2]=ea(g[e+20>>2]);g[k+24>>2]=ea(g[e+24>>2]);a[k+28>>0]=1;k=b+4|0;l=c[k>>2]|0;if(!l)m=k;else{n9(l);m=k}}else{k=d+292|0;l=c[k>>2]|0;if(!l){IXa(d);n=c[k>>2]|0}else n=l;c[k>>2]=c[n>>2];k=d+280|0;c[k>>2]=(c[k>>2]|0)+1;k=d+284|0;c[k>>2]=(c[k>>2]|0)+-1;k=(n|0)==0?0:n;n=k+0|0;d=n+64|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(d|0));a[k+31>>0]=1;n=k+28|0;a[n>>0]=1;d=b+120|0;g[k+48>>2]=ea(g[d>>2]);g[k+52>>2]=ea(g[b+124>>2]);g[k+32>>2]=ea(g[b+128>>2]);g[k+36>>2]=ea(g[b+132>>2]);g[k+40>>2]=ea(g[b+136>>2]);g[k+44>>2]=ea(g[b+140>>2]);l=b+112|0;g[k+56>>2]=ea(g[l>>2]);o=b+116|0;g[k+60>>2]=ea(g[o>>2]);c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;g[l>>2]=ea(3402823469999999843913219.0e14);g[o>>2]=ea(3402823469999999843913219.0e14);c[j>>2]=k;g[k>>2]=ea(g[e>>2]);g[k+4>>2]=ea(g[e+4>>2]);g[k+8>>2]=ea(g[e+8>>2]);g[k+12>>2]=ea(g[e+12>>2]);g[k+16>>2]=ea(g[e+16>>2]);g[k+20>>2]=ea(g[e+20>>2]);g[k+24>>2]=ea(g[e+24>>2]);a[n>>0]=1;m=b+4|0}g[b+152>>2]=f;b=c[m>>2]|0;if(!b){i=h;return}D9(b);z9(b,f,1);i=h;return}function h9(b,d){b=b|0;d=d|0;return (a[(c[b+156>>2]|0)+31>>0]|0)==1^d^1|0}function i9(b){b=b|0;a[(c[b+156>>2]|0)+28>>0]=0;return}function j9(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im,j=0,k=0,l=0;e=i;f=c[b+4>>2]|0;h=ea(g[d>>2]);j=b+32|0;g[j>>2]=ea(ea(g[j>>2])-h);j=d+4|0;h=ea(g[j>>2]);k=b+36|0;g[k>>2]=ea(ea(g[k>>2])-h);k=d+8|0;h=ea(g[k>>2]);l=b+40|0;g[l>>2]=ea(ea(g[l>>2])-h);l=c[b+156>>2]|0;if(((l|0)!=0?(a[b+44>>0]&1)!=0:0)?(a[l+28>>0]|0)!=0:0){b=l+16|0;h=ea(g[d>>2]);g[b>>2]=ea(ea(g[b>>2])-h);h=ea(g[j>>2]);b=l+20|0;g[b>>2]=ea(ea(g[b>>2])-h);h=ea(g[k>>2]);b=l+24|0;g[b>>2]=ea(ea(g[b>>2])-h)}h=ea(g[d>>2]);d=f+112|0;g[d>>2]=ea(ea(g[d>>2])-h);h=ea(g[j>>2]);j=f+116|0;g[j>>2]=ea(ea(g[j>>2])-h);h=ea(g[k>>2]);k=f+120|0;g[k>>2]=ea(ea(g[k>>2])-h);i=e;return}function k9(a){a=a|0;var b=0,c=0;b=i;c=Zba(a+-16|0)|0;i=b;return c|0}function l9(b,d){b=b|0;d=d|0;var e=0,f=0,h=0;e=i;f=c[b+156>>2]|0;if(!f){h=0;i=e;return h|0}if((a[f+31>>0]|0)!=1){h=0;i=e;return h|0}if(!(a[f+28>>0]|0)){h=0;i=e;return h|0}g[d>>2]=ea(g[f>>2]);g[d+4>>2]=ea(g[f+4>>2]);g[d+8>>2]=ea(g[f+8>>2]);g[d+12>>2]=ea(g[f+12>>2]);g[d+16>>2]=ea(g[f+16>>2]);g[d+20>>2]=ea(g[f+20>>2]);g[d+24>>2]=ea(g[f+24>>2]);h=1;i=e;return h|0}function m9(f,h,j){f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;_ba(f,h,j,4);c[f>>2]=463784;l=f+60|0;m=j+16|0;n=f+96|0;o=l+0|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));g[n>>2]=ea(g[m>>2]);g[f+100>>2]=ea(g[j+20>>2]);g[f+104>>2]=ea(g[j+24>>2]);g[f+108>>2]=ea(g[j+28>>2]);g[f+112>>2]=ea(g[j+32>>2]);g[f+116>>2]=ea(g[j+36>>2]);g[f+120>>2]=ea(g[j+40>>2]);c[f+124>>2]=0;c[f+128>>2]=m;c[f+132>>2]=1073741823;c[f+136>>2]=1073741823;m=f+144|0;b[m>>1]=0;n=f+146|0;a[n>>0]=1;b[f+148>>1]=0;o=f+152|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[f+168>>2]=ea(1.0);p=f+172|0;q=f+188|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[q>>2]=-1;p=c[h+1212>>2]|0;if(b[j+8>>1]&2)b[m>>1]=1;h=j+156|0;if(((c[h>>2]|0)!=0?h9(j,0)|0:0)?(r=c[h>>2]|0,(r|0)!=0):0){s=r+12|0;t=a[s>>0]|0;if(t<<24>>24)if((((((((((ea(g[r>>2])==ea(0.0)?ea(g[r+4>>2])==ea(0.0):0)?ea(g[r+8>>2])==ea(0.0):0)?ea(g[r+16>>2])==ea(0.0):0)?ea(g[r+20>>2])==ea(0.0):0)?ea(g[r+24>>2])==ea(0.0):0)?ea(g[r+32>>2])==ea(0.0):0)?ea(g[r+36>>2])==ea(0.0):0)?ea(g[r+40>>2])==ea(0.0):0)?ea(g[r+48>>2])==ea(0.0):0)?ea(g[r+52>>2])==ea(0.0):0)u=ea(g[r+56>>2])!=ea(0.0);else u=1;else u=0;a[n>>0]=t;a[s>>0]=0;v=u}else v=0;if(((!(ea(d9(j))>ea(0.0))?ea(g[j+80>>2])==ea(0.0):0)?ea(g[j+84>>2])==ea(0.0):0)?ea(g[j+88>>2])==ea(0.0):0){if(ea(g[j+96>>2])==ea(0.0)?ea(g[j+100>>2])==ea(0.0):0)w=ea(g[j+104>>2])!=ea(0.0);else w=1;x=v|w}else x=1;w=a[(c[f+52>>2]|0)+44>>0]&1;v=f+36|0;u=Via(c[v>>2]|0)|0;do if((a[f+50>>0]|0)==4){Bua(Via(c[v>>2]|0)|0,q);s=c[o>>2]|0;if(s){t=v8(s,f)|0;s=Via(c[v>>2]|0)|0;if(!(t&63)){Dua(s,t,f,q);break}else{Cua(s,t,f,q);break}}}else KXa(u,f,q,w<<24>>24!=0);while(0);Mia(p,f,x);p=(c[u+16>>2]|0)+((c[q>>2]|0)*12|0)+8|0;q=d[p>>0]&231;if(x){a[p>>0]=q|8;a[u+273>>0]=1}else{a[p>>0]=q|16;a[u+273>>0]=1}if(!(w<<24>>24)){i=k;return}ria(f,2);w=f+64|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;c[w+24>>2]=0;c[w+28>>2]=0;w=c[l>>2]|0;if(w){l=baa(w)|0;if(c[l+20>>2]|0)yaa(l);waa(l)}if(((c[h>>2]|0)!=0?h9(j,1)|0:0)?(c[h>>2]|0)!=0:0){b[m>>1]=e[m>>1]|4;i=k;return}O8(j,c[(q7(f)|0)+1240>>2]|0,1,0)|0;j=Via(c[v>>2]|0)|0;v=(c[j+16>>2]|0)+((c[f+188>>2]|0)*12|0)+8|0;a[v>>0]=d[v>>0]&231|16;a[j+273>>0]=1;i=k;return}function n9(a){a=a|0;var c=0;c=a+144|0;b[c>>1]=e[c>>1]|0|4;return}function o9(a){a=a|0;var b=0;b=i;i=i+16|0;p9(a);VJa(b,a);i=b;return}function p9(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;c[d>>2]=463784;g=c[(q7(d)|0)+1212>>2]|0;if(a[d+51>>0]&1){h=c[(c[g>>2]|0)+((c[g+4>>2]|0)+-1<<2)>>2]|0;j=h;k=VEi(j|0,0,6)|0;l=H;m=_Ei(j|0,0,51,0)|0;j=VEi(m|0,H|0,6)|0;m=H;n=ZEi(1,0,k|0,l|0)|0;l=_Ei(n|0,H|0,j|0,m|0)|0;m=l;l=H;j=h;while(1){m=_Ei(m|0,l|0,-1,-1)|0;l=H;if((m|0)==0&(l|0)==0)break;else j=j+64|0}}j=d+52|0;l=c[j>>2]|0;m=c[(q7(d)|0)+1240>>2]|0;c9(l,m,(a[(c[j>>2]|0)+44>>0]&1)!=0);m=d+144|0;b[m>>1]=e[m>>1]|0|8;Vca(q7(d)|0,d);m=c[d+152>>2]|0;if(m)w8(m,d);m=d+188|0;if((c[m>>2]|0)==-1){Nia(g,d);o=c[j>>2]|0;p=o+4|0;c[p>>2]=0;aca(d);i=f;return}Eua(Via(g)|0,m);Nia(g,d);o=c[j>>2]|0;p=o+4|0;c[p>>2]=0;aca(d);i=f;return}function q9(b){b=b|0;var e=0,f=0;e=i;if((a[b+50>>0]|0)==4){i=e;return}f=(c[b+52>>2]|0)+45|0;a[f>>0]=d[f>>0]&254;zea(q7(b)|0,b);i=e;return}function r9(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;h=e;if(a[(c[b+52>>2]|0)+45>>0]&1){i=e;return}c[f>>2]=0;Afa(f,b);b=zfa(f)|0;if(!b){i=e;return}j=d+16|0;d=h+4|0;k=h+8|0;l=h+12|0;m=h+16|0;n=h+20|0;o=h+24|0;p=b;do{b=p+24|0;if((c[b>>2]|0)!=-1){Ifa(h,p);q=c[b>>2]|0;b=c[j>>2]|0;g[b+(q*28|0)>>2]=ea(g[h>>2]);g[b+(q*28|0)+4>>2]=ea(g[d>>2]);g[b+(q*28|0)+8>>2]=ea(g[k>>2]);g[b+(q*28|0)+12>>2]=ea(g[l>>2]);g[b+(q*28|0)+16>>2]=ea(g[m>>2]);g[b+(q*28|0)+20>>2]=ea(g[n>>2]);g[b+(q*28|0)+24>>2]=ea(g[o>>2])}p=zfa(f)|0}while((p|0)!=0);i=e;return}function s9(d){d=d|0;var e=0,f=0,h=0,j=0;e=i;f=b[d+144>>1]|0;if(!(f&8)){h=d+52|0;j=c[h>>2]|0;g[j+80>>2]=ea(0.0);g[j+84>>2]=ea(0.0);g[j+88>>2]=ea(0.0);g[j+96>>2]=ea(0.0);g[j+100>>2]=ea(0.0);g[j+104>>2]=ea(0.0);j=f&1;f=c[h>>2]|0;h=f+156|0;if(((c[h>>2]|0)!=0?h9(f,0)|0:0)?(f=c[h>>2]|0,(f|0)!=0):0){g[f+48>>2]=ea(0.0);g[f+52>>2]=ea(0.0);g[f+56>>2]=ea(0.0);g[f+32>>2]=ea(0.0);g[f+36>>2]=ea(0.0);g[f+40>>2]=ea(0.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0)}a[d+146>>0]=j^1}if((a[d+50>>0]|0)==4){i=e;return}yea(q7(d)|0,d);i=e;return}function t9(b){b=b|0;var c=0;c=b+146|0;a[c>>0]=d[c>>0]|0|2;return}function u9(b){b=b|0;var c=0;c=b+146|0;a[c>>0]=d[c>>0]|0|2;return}function v9(b){b=b|0;var c=0;c=b+146|0;a[c>>0]=d[c>>0]|0|4;return}function w9(b){b=b|0;var c=0;c=b+146|0;a[c>>0]=d[c>>0]|0|4;return}function x9(c,d,f){c=c|0;d=d|0;f=f|0;var g=0,h=0;g=i;h=f&2;if((h|0)==(d&2|0)){i=g;return}d=c+146|0;if(!(a[d>>0]|0))a[d>>0]=1;d=c+144|0;c=e[d>>1]|0;if(!h){b[d>>1]=c&65534;i=g;return}else{b[d>>1]=c|1;i=g;return}}function y9(a){a=a|0;var b=0,d=0;b=i;d=c[a+128>>2]|0;g[a+96>>2]=ea(g[d>>2]);g[a+100>>2]=ea(g[d+4>>2]);g[a+104>>2]=ea(g[d+8>>2]);g[a+108>>2]=ea(g[d+12>>2]);g[a+112>>2]=ea(g[d+16>>2]);g[a+116>>2]=ea(g[d+20>>2]);g[a+120>>2]=ea(g[d+24>>2]);owa(a+64|0,c[(c[a+36>>2]|0)+1e3>>2]|0);bca(a);r9(a,(c[(c[(q7(a)|0)+1212>>2]|0)+1e3>>2]|0)+7384|0);i=b;return}function z9(b,e,f){b=b|0;e=ea(e);f=f|0;var g=0,h=0;g=i;if(e>ea(0.0)|f){f=Via(c[b+36>>2]|0)|0;h=(c[f+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[h>>0]=d[h>>0]|0|8;a[f+273>>0]=1;i=g;return}if(!(DXa(b)|0)){i=g;return}f=Via(c[b+36>>2]|0)|0;h=(c[f+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[h>>0]=(d[h>>0]|0)&247;a[f+273>>0]=1;i=g;return}function A9(b){b=b|0;var e=0,f=0,g=0;e=i;f=Via(c[b+36>>2]|0)|0;g=(c[f+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[g>>0]=(d[g>>0]|0)&247;a[f+273>>0]=1;i=e;return}function B9(a){a=a|0;var b=0,d=0,e=0;b=i;ria(a,2);d=a+64|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;d=c[a+60>>2]|0;if(d){e=baa(d)|0;if(c[e+20>>2]|0)yaa(e);waa(e)}e=a+188|0;if((c[e>>2]|0)==-1){i=b;return}Aua(Via(c[a+36>>2]|0)|0,e,1);i=b;return}function C9(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d+188|0;if((c[f>>2]|0)!=-1)Aua(Via(c[d+36>>2]|0)|0,f,0);f=c[d+52>>2]|0;h=f+156|0;if(((c[h>>2]|0)!=0?h9(f,0)|0:0)?(f=c[h>>2]|0,(f|0)!=0):0){g[f+48>>2]=ea(0.0);g[f+52>>2]=ea(0.0);g[f+56>>2]=ea(0.0);g[f+32>>2]=ea(0.0);g[f+36>>2]=ea(0.0);g[f+40>>2]=ea(0.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0)}a[d+146>>0]=1;f=c[d+60>>2]|0;if(!f){s7(d,5,0,4);j=d+144|0;k=b[j>>1]|0;l=k&65535;m=l&65019;n=m&65535;b[j>>1]=n;ria(d,4);i=e;return}h=baa(f)|0;if(c[h+20>>2]|0)yaa(h);waa(h);s7(d,5,0,4);j=d+144|0;k=b[j>>1]|0;l=k&65535;m=l&65019;n=m&65535;b[j>>1]=n;ria(d,4);i=e;return}function D9(b){b=b|0;var e=0,f=0,g=0;e=i;uia(b,1,0);f=Via(c[b+36>>2]|0)|0;g=(c[f+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[g>>0]=(d[g>>0]|0)&231|8;a[f+273>>0]=1;i=e;return}function E9(f){f=f|0;var g=0,h=0,j=0;g=i;uia(f,0,0);h=Via(c[f+36>>2]|0)|0;j=(c[h+16>>2]|0)+((c[f+188>>2]|0)*12|0)+8|0;a[j>>0]=(d[j>>0]|0)&231|16;a[h+273>>0]=1;h=f+144|0;b[h>>1]=(e[h>>1]|0)&65023;i=g;return}function F9(b,e){b=b|0;e=ea(e);var f=0,h=0,j=0,k=0;f=i;h=c[b+152>>2]|0;if(h){A8(h,e);i=f;return}h=b+52|0;j=c[h>>2]|0;if(a[j+44>>0]&1){i=f;return}if(!(ea(d9(j))<e)){i=f;return}g[(c[h>>2]|0)+152>>2]=e;uia(b,1,0);j=Via(c[b+36>>2]|0)|0;k=(c[j+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[k>>0]=(d[k>>0]|0)&231|8;a[j+273>>0]=1;j=(c[h>>2]|0)+45|0;a[j>>0]=(d[j>>0]|0)&254;i=f;return}function G9(b,e){b=b|0;e=ea(e);var f=0,h=0,j=0,k=0;f=i;h=b+52|0;j=c[h>>2]|0;if(a[j+44>>0]&1){i=f;return}if(!(ea(d9(j))<e)){i=f;return}g[(c[h>>2]|0)+152>>2]=e;uia(b,1,0);j=Via(c[b+36>>2]|0)|0;k=(c[j+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[k>>0]=(d[k>>0]|0)&231|8;a[j+273>>0]=1;j=(c[h>>2]|0)+45|0;a[j>>0]=(d[j>>0]|0)&254;i=f;return}function H9(a){a=a|0;g[a+156>>2]=ea(0.0);g[a+160>>2]=ea(0.0);g[a+164>>2]=ea(0.0);g[a+172>>2]=ea(0.0);g[a+176>>2]=ea(0.0);g[a+180>>2]=ea(0.0);return}function I9(f,h,j,k,l,m){f=f|0;h=ea(h);j=ea(j);k=ea(k);l=ea(l);m=m|0;var n=0,o=0,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im;n=i;o=f+52|0;p=c[o>>2]|0;q=ea(d9(p));if(m){m=c[o>>2]|0;r=U8(p)|0;s=ea(g[r>>2]);t=ea(g[r+4>>2]);u=ea(g[r+8>>2]);if(s>ea(0.0))v=ea(ea(1.0)/s);else v=ea(1.0);if(t>ea(0.0))w=ea(ea(1.0)/t);else w=ea(1.0);if(u>ea(0.0))x=ea(ea(1.0)/u);else x=ea(1.0);u=ea(g[f+64>>2]);t=ea(g[f+68>>2]);s=ea(g[f+72>>2]);y=ea(ea(g[f+80>>2])*ea(2.0));z=ea(ea(g[f+84>>2])*ea(2.0));A=ea(ea(g[f+88>>2])*ea(2.0));B=ea(g[m+28>>2]);C=ea(ea(B*B)+ea(-.5));D=ea(g[m+16>>2]);E=ea(y*D);F=ea(g[m+20>>2]);G=ea(E+ea(z*F));E=ea(g[m+24>>2]);H=ea(G+ea(A*E));G=ea(ea(D*H)+ea(ea(y*C)-ea(B*ea(ea(A*F)-ea(z*E)))));I=ea(ea(F*H)+ea(ea(z*C)-ea(B*ea(ea(y*E)-ea(A*D)))));J=ea(ea(ea(A*C)-ea(B*ea(ea(z*D)-ea(y*F))))+ea(E*H));m=b[f+46>>1]|0;H=ea(S8(p));r=H==ea(0.0);E=ea(ea(ea(ea(ea(u*u)+ea(t*t))+ea(s*s))+ea((r?ea(1.0):H)*ea(ea(x*ea(J*J))+ea(ea(v*ea(G*G))+ea(w*ea(I*I))))))*ea(.5));if(m<<16>>16==0?1:(b[f+144>>1]&2)==0)K=ea(0.0);else K=ea(((m&65535)+1|0)>>>0);I=ea(ea(K*K)*k);r=f+168|0;w=ea(ea(g[r>>2])-h);L=w>ea(0.0);g[r>>2]=L?w:ea(0.0);if(!(E>=I)){w=ea(ea(1.0)-ea(h*ea(.5)));L=p+80|0;G=ea(w*ea(g[L>>2]));M=p+84|0;v=ea(w*ea(g[M>>2]));N=p+88|0;J=ea(w*ea(g[N>>2]));g[L>>2]=G;g[M>>2]=v;g[N>>2]=J;N=p+96|0;J=ea(w*ea(g[N>>2]));M=p+100|0;v=ea(w*ea(g[M>>2]));L=p+104|0;G=ea(w*ea(g[L>>2]));g[N>>2]=J;g[M>>2]=v;g[L>>2]=G;g[f+184>>2]=ea(l*ea(.899999976));if(E<k?ea(g[r>>2])==ea(0.0):0){k=ea(g[f+96>>2]);l=ea(g[f+100>>2]);G=ea(g[f+104>>2]);v=ea(g[f+108>>2]);J=ea(g[f+112>>2]);w=ea(g[f+116>>2]);x=ea(g[f+120>>2]);g[p+16>>2]=k;g[p+20>>2]=l;g[p+24>>2]=G;g[p+28>>2]=v;g[p+32>>2]=J;g[p+36>>2]=w;g[p+40>>2]=x;O=1}else O=0}else{g[r>>2]=ea(1.0);if(!(E>=ea(K*I)))O=0;else{g[f+184>>2]=ea(0.0);O=0}}r=(c[o>>2]|0)+45|0;L=d[r>>0]|0;a[r>>0]=O?L|1:L&254;if(!(!(E>=j)&(!(I>ea(0.0))|O))?q<ea(.199999988)|q<h:0){g[f+156>>2]=ea(0.0);g[f+160>>2]=ea(0.0);g[f+164>>2]=ea(0.0);g[f+172>>2]=ea(0.0);g[f+176>>2]=ea(0.0);g[f+180>>2]=ea(0.0);if(j==ea(0.0))P=ea(.399999976);else{I=ea(E/j);O=I<ea(2.0);E=ea(ea(I*ea(.5))*ea(.399999976));P=O?E:ea(.399999976)}E=ea(ea(ea(ea(m&65535)+ea(-1.0))*h)+P);g[p+152>>2]=E;if(!(q==ea(0.0))){Q=E;i=n;return ea(Q)}m=Via(c[f+36>>2]|0)|0;O=(c[m+16>>2]|0)+((c[f+188>>2]|0)*12|0)+8|0;a[O>>0]=d[O>>0]|0|8;a[m+273>>0]=1;Q=E;i=n;return ea(Q)}}else if(q<ea(.199999988)|q<h){m=c[o>>2]|0;o=U8(p)|0;E=ea(g[o>>2]);P=ea(g[o+4>>2]);I=ea(g[o+8>>2]);if(E>ea(0.0))R=ea(ea(1.0)/E);else R=ea(1.0);if(P>ea(0.0))S=ea(ea(1.0)/P);else S=ea(1.0);if(I>ea(0.0))T=ea(ea(1.0)/I);else T=ea(1.0);I=ea(g[f+64>>2]);P=ea(g[f+68>>2]);E=ea(g[f+72>>2]);K=ea(ea(g[f+80>>2])*ea(2.0));x=ea(ea(g[f+84>>2])*ea(2.0));w=ea(ea(g[f+88>>2])*ea(2.0));J=ea(g[m+28>>2]);v=ea(ea(J*J)+ea(-.5));G=ea(g[m+16>>2]);l=ea(K*G);k=ea(g[m+20>>2]);H=ea(l+ea(x*k));l=ea(g[m+24>>2]);s=ea(H+ea(w*l));H=ea(ea(G*s)+ea(ea(K*v)-ea(J*ea(ea(w*k)-ea(x*l)))));t=ea(ea(k*s)+ea(ea(x*v)-ea(J*ea(ea(K*l)-ea(w*G)))));u=ea(ea(ea(w*v)-ea(J*ea(ea(x*G)-ea(K*k))))+ea(l*s));m=f+156|0;g[m>>2]=ea(I+ea(g[m>>2]));o=f+160|0;g[o>>2]=ea(P+ea(g[o>>2]));O=f+164|0;g[O>>2]=ea(E+ea(g[O>>2]));L=f+172|0;g[L>>2]=ea(ea(g[L>>2])+H);r=f+176|0;g[r>>2]=ea(t+ea(g[r>>2]));M=f+180|0;g[M>>2]=ea(u+ea(g[M>>2]));u=ea(S8(p));N=u==ea(0.0);t=N?ea(1.0):u;u=ea(g[L>>2]);H=ea(u*u);u=ea(g[r>>2]);E=ea(u*u);u=ea(g[M>>2]);P=ea(t*ea(ea(ea(R*H)+ea(S*E))+ea(T*ea(u*u))));u=ea(g[m>>2]);T=ea(u*u);u=ea(g[o>>2]);E=ea(T+ea(u*u));u=ea(g[O>>2]);T=ea(ea(P+ea(E+ea(u*u)))*ea(.5));u=ea(((e[f+48>>1]|0)+1|0)>>>0);E=ea(u*j);if(T>=E){g[m>>2]=ea(0.0);g[o>>2]=ea(0.0);g[O>>2]=ea(0.0);g[L>>2]=ea(0.0);g[r>>2]=ea(0.0);g[M>>2]=ea(0.0);if(E==ea(0.0))U=ea(.399999976);else{j=ea(T/E);M=j<ea(2.0);E=ea(ea(j*ea(.5))*ea(.399999976));U=M?E:ea(.399999976)}E=ea(ea(ea(u+ea(-1.0))*h)+U);g[p+152>>2]=E;if(!(q==ea(0.0))){Q=E;i=n;return ea(Q)}M=Via(c[f+36>>2]|0)|0;r=(c[M+16>>2]|0)+((c[f+188>>2]|0)*12|0)+8|0;a[r>>0]=d[r>>0]|0|8;a[M+273>>0]=1;Q=E;i=n;return ea(Q)}}E=ea(q-h);M=E>ea(0.0);h=M?E:ea(0.0);g[p+152>>2]=h;Q=h;i=n;return ea(Q)}function J9(b,e,f,h){b=b|0;e=ea(e);f=ea(f);h=h|0;var j=0,k=0,l=Im;j=i;k=c[b+52>>2]|0;l=ea(g[k+144>>2]);if(!(ea(I9(b,e,l,ea(g[k+148>>2]),f,h))==ea(0.0))){i=j;return}h=Via(c[b+36>>2]|0)|0;k=(c[h+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[k>>0]=(d[k>>0]|0)&247;a[h+273>>0]=1;g[b+156>>2]=ea(0.0);g[b+160>>2]=ea(0.0);g[b+164>>2]=ea(0.0);g[b+172>>2]=ea(0.0);g[b+176>>2]=ea(0.0);g[b+180>>2]=ea(0.0);i=j;return}function K9(a,d){a=a|0;d=ea(d);var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;f=i;h=a+52|0;j=c[h>>2]|0;k=a+144|0;a=e[k>>1]|0;if(!(a&4)){g[j+80>>2]=ea(0.0);g[j+84>>2]=ea(0.0);g[j+88>>2]=ea(0.0);g[j+96>>2]=ea(0.0);g[j+100>>2]=ea(0.0);g[j+104>>2]=ea(0.0);i=f;return}b[k>>1]=a&65023;a=c[j+156>>2]|0;l=ea(g[a>>2]);m=ea(g[a+4>>2]);n=ea(g[a+8>>2]);o=ea(g[a+12>>2]);p=ea(g[a+16>>2]);q=ea(g[a+20>>2]);r=ea(g[a+24>>2]);a=c[h>>2]|0;s=ea(p-ea(g[a+32>>2]));p=ea(q-ea(g[a+36>>2]));q=ea(s*d);s=ea(p*d);p=ea(ea(r-ea(g[a+40>>2]))*d);r=ea(-ea(g[a+16>>2]));t=ea(-ea(g[a+20>>2]));u=ea(-ea(g[a+24>>2]));v=ea(g[a+28>>2]);w=ea(ea(ea(m*u)+ea(ea(o*r)+ea(l*v)))-ea(n*t));x=ea(ea(ea(n*r)+ea(ea(o*t)+ea(m*v)))-ea(l*u));y=ea(ea(ea(l*t)+ea(ea(o*u)+ea(n*v)))-ea(m*r));z=ea(ea(ea(ea(o*v)-ea(l*r))-ea(m*t))-ea(n*u));if(z<ea(0.0)){A=ea(-w);B=ea(-x);C=ea(-y);D=ea(-z)}else{A=w;B=x;C=y;D=z}z=ea(ea(C*C)+ea(ea(B*B)+ea(A*A)));if(!(z<ea(1.00000002e-16))){y=ea(ea(1.0)/ea(T(ea(z))));x=ea(A*y);A=ea(B*y);B=ea(C*y);if(ea(S(ea(D)))<ea(9.99999993e-09)){E=ea(3.14159274);F=x;G=A;H=B}else{E=ea(ea(+$(+(+ea(z*y)),+(+D)))*ea(2.0));F=x;G=A;H=B}}else{E=ea(0.0);F=ea(1.0);G=ea(0.0);H=ea(0.0)}B=ea(ea(E*F)*d);F=ea(ea(E*G)*d);G=ea(ea(E*H)*d);g[j+80>>2]=q;g[j+84>>2]=s;g[j+88>>2]=p;g[j+96>>2]=B;g[j+100>>2]=F;g[j+104>>2]=G;i=f;return}function L9(a){a=a|0;var d=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;f=a+52|0;h=c[f>>2]|0;j=a+144|0;a=e[j>>1]|0;if(!(a&4)){i=d;return}b[j>>1]=a&65023;a=c[h+156>>2]|0;k=ea(g[a>>2]);l=ea(g[a+4>>2]);m=ea(g[a+8>>2]);n=ea(g[a+12>>2]);o=ea(g[a+16>>2]);p=ea(g[a+20>>2]);q=ea(g[a+24>>2]);a=c[f>>2]|0;g[a+16>>2]=k;g[a+20>>2]=l;g[a+24>>2]=m;g[a+28>>2]=n;g[a+32>>2]=o;g[a+36>>2]=p;g[a+40>>2]=q;i=d;return}function M9(f){f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=f+144|0;k=e[j>>1]|0;if(!(k&512)){b[j>>1]=k&65019|512;l=0;i=h;return l|0}else{m=c[f+52>>2]|0;b[j>>1]=k&65023;g[m+152>>2]=ea(0.0);m=f+36|0;k=Via(c[m>>2]|0)|0;j=f+188|0;n=(c[k+16>>2]|0)+((c[j>>2]|0)*12|0)+8|0;a[n>>0]=(d[n>>0]|0)&247;a[k+273>>0]=1;k=Via(c[m>>2]|0)|0;m=(c[k+16>>2]|0)+((c[j>>2]|0)*12|0)+8|0;a[m>>0]=(d[m>>0]|0)&231|16;a[k+273>>0]=1;uia(f,0,0);l=1;i=h;return l|0}return 0}function N9(f,h,j,k,l,m,n){f=f|0;h=ea(h);j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0;k=i;o=f+146|0;p=d[o>>0]|0;q=(p&4|0)==0;r=f+144|0;s=e[r>>1]|0;b[r>>1]=m?s|2:s&65533;s=f+52|0;t=c[s>>2]|0;if((((p&6|0)!=0?(p=t+156|0,(c[p>>2]|0)!=0):0)?h9(t,0)|0:0)?(t=c[p>>2]|0,(t|0)!=0):0){j=ea(g[t>>2]);u=ea(g[t+4>>2]);v=ea(g[t+8>>2]);w=ea(g[t+16>>2]);x=ea(g[t+20>>2]);y=ea(g[t+24>>2]);if(q){z=w;A=x;B=y;C=j;D=u;E=v}else{q=c[s>>2]|0;F=ea(g[t+32>>2]);p=q+80|0;g[p>>2]=ea(F+ea(g[p>>2]));F=ea(g[t+36>>2]);p=q+84|0;g[p>>2]=ea(F+ea(g[p>>2]));F=ea(g[t+40>>2]);p=q+88|0;g[p>>2]=ea(F+ea(g[p>>2]));F=ea(g[t+48>>2]);p=q+96|0;g[p>>2]=ea(F+ea(g[p>>2]));F=ea(g[t+52>>2]);p=q+100|0;g[p>>2]=ea(F+ea(g[p>>2]));F=ea(g[t+56>>2]);t=q+104|0;g[t>>2]=ea(F+ea(g[t>>2]));z=w;A=x;B=y;C=j;D=u;E=v}}else{z=ea(0.0);A=ea(0.0);B=ea(0.0);C=ea(0.0);D=ea(0.0);E=ea(0.0)}if(!(b[r>>1]&1)){v=ea(ea(1.0)-ea(ea(g[f+184>>2])*h));r=v>ea(0.0);h=r?v:ea(0.0);v=ea(ea(g[l>>2])*h);u=ea(ea(g[l+4>>2])*h);G=ea(C+v);H=ea(D+u);I=ea(E+ea(ea(g[l+8>>2])*h))}else{G=C;H=D;I=E}if(n&m?(m=b[f+148>>1]|0,(m&65535)>1):0){E=ea(ea(1.0)/ea(m&65535));J=ea(H*E);K=ea(I*E);L=ea(G*E)}else{J=H;K=I;L=G}g[f+64>>2]=L;g[f+68>>2]=J;g[f+72>>2]=K;g[f+76>>2]=ea(0.0);g[f+80>>2]=z;g[f+84>>2]=A;g[f+88>>2]=B;g[f+92>>2]=ea(0.0);f=a[o>>0]|0;m=c[s>>2]|0;s=m+156|0;if(!(c[s>>2]|0)){M=(f&255)>>>1;N=M&1;a[o>>0]=N;i=k;return}if(!(h9(m,0)|0)){M=(f&255)>>>1;N=M&1;a[o>>0]=N;i=k;return}m=c[s>>2]|0;if(!m){M=(f&255)>>>1;N=M&1;a[o>>0]=N;i=k;return}g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(0.0);g[m+56>>2]=ea(0.0);g[m+32>>2]=ea(0.0);g[m+36>>2]=ea(0.0);g[m+40>>2]=ea(0.0);g[m+16>>2]=ea(0.0);g[m+20>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);M=(f&255)>>>1;N=M&1;a[o>>0]=N;i=k;return}function O9(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=c[b+28>>2]|0;j=c[d+28>>2]|0;if(h>>>0>j>>>0){k=c[d+20>>2]|0;l=k+(j<<2)|0;m=k;n=b}else{k=c[b+20>>2]|0;l=k+(h<<2)|0;m=k;n=d}if(m>>>0<l>>>0)o=m;else{p=0;q=0;a[f>>0]=q;i=g;return p|0}while(1){r=c[o>>2]|0;if((a[r+20>>0]|0)==1){if((c[r+4>>2]|0)==(n|0))break;if((c[r+8>>2]|0)==(n|0))break}o=o+4|0;if(o>>>0>=l>>>0){p=0;q=0;s=10;break}}if((s|0)==10){a[f>>0]=q;i=g;return p|0}p=1;q=(e[c[(c[r+32>>2]|0)+100>>2]>>1]|0)>>>3&1^1;a[f>>0]=q;i=g;return p|0}function P9(d){d=d|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[d+20>>2]|0;h=c[d+28>>2]|0;j=g+(h<<2)|0;k=d+46|0;b[k>>1]=(b[k>>1]|0)+-1<<16>>16;a:do if((h|0)>0){k=g;while(1){if((a[(c[k>>2]|0)+20>>0]|0)==1)break;k=k+4|0;if(k>>>0>=j>>>0)break a}i=f;return}while(0);j=d+144|0;b[j>>1]=e[j>>1]&65279;i=f;return}function Q9(b,e,f,h){b=b|0;e=e|0;f=ea(f);h=h|0;var j=0,k=0,l=0;j=i;c[b+152>>2]=e;if(!e){i=j;return}g[(c[b+52>>2]|0)+152>>2]=f;if(h){h=b+36|0;e=Via(c[h>>2]|0)|0;k=b+188|0;l=(c[e+16>>2]|0)+((c[k>>2]|0)*12|0)+8|0;a[l>>0]=(d[l>>0]|0)&247;a[e+273>>0]=1;e=Via(c[h>>2]|0)|0;h=(c[e+16>>2]|0)+((c[k>>2]|0)*12|0)+8|0;a[h>>0]=(d[h>>0]|0)&231|16;a[e+273>>0]=1;uia(b,0,0);i=j;return}else{uia(b,1,0);e=Via(c[b+36>>2]|0)|0;h=(c[e+16>>2]|0)+((c[b+188>>2]|0)*12|0)+8|0;a[h>>0]=(d[h>>0]|0)&231|8;a[e+273>>0]=1;i=j;return}}function R9(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0;b[a>>1]=64;h=a+4|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[a+28>>2]=d;c[a+32>>2]=c[e+12>>2];c[a+36>>2]=c[e>>2];c[a+40>>2]=c[e+4>>2];c[a+44>>2]=c[e+8>>2];c[a+48>>2]=c[e+16>>2];c[a+52>>2]=f;g[a+56>>2]=ea(3402823469999999843913219.0e14);g[a+60>>2]=ea(3402823469999999843913219.0e14);g[a+64>>2]=ea(0.0);c[a+68>>2]=0;return}function S9(a){a=a|0;return}function T9(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+2|0;g=e;h=b[d>>1]|0;j=b[a>>1]|0;if(h<<16>>16==j<<16>>16){i=e;return}b[a>>1]=h;h=c[a+68>>2]|0;if(!h){i=e;return}b[f>>1]=j;b[g>>1]=b[d>>1]|0;Jaa(h,f,g);i=e;return}function U9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+68>>2]|0;if(!f){g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);g[d>>2]=ea(0.0);g[d+4>>2]=ea(0.0);g[d+8>>2]=ea(0.0);i=e;return}else{Haa(f,b,d);i=e;return}}function V9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+68>>2]|0;if(!f){i=e;return}Faa(f,b,d);i=e;return}function W9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+68>>2]|0;if(!e){f=0;i=d;return f|0}YEi(c[e+60>>2]|0,b|0,c[e+44>>2]|0)|0;f=1;i=d;return f|0}function X9(a,b,d){a=a|0;b=ea(b);d=ea(d);var e=0,f=0;e=i;g[a+56>>2]=b;g[a+60>>2]=d;f=c[a+68>>2]|0;if(!f){i=e;return}Iaa(f,b,d);i=e;return}function Y9(a,b,c){a=a|0;b=b|0;c=c|0;g[b>>2]=ea(g[a+56>>2]);g[c>>2]=ea(g[a+60>>2]);return}function Z9(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;g[a+64>>2]=b;e=c[a+68>>2]|0;if(!e){i=d;return}g[e+92>>2]=b;i=d;return}function _9(a){a=a|0;var b=0,c=0;b=i;c=wX(a)|0;i=b;return c|0}function $9(a){a=a|0;b[a>>1]=e[a>>1]|0|1;return}function aaa(b,d){b=b|0;d=d|0;c[b>>2]=d;c[b+4>>2]=b;c[b+8>>2]=b;d=b+12|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;a[d+32>>0]=0;return}function baa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=c[a+4>>2]|0;e=c[d+4>>2]|0;if((e|0)==(d|0)){f=d;i=b;return f|0}else{g=1;h=e}while(1){e=c[h+4>>2]|0;if((h|0)==(e|0))break;else{g=g+1|0;h=e}}if(!g){f=h;i=b;return f|0}else{j=d;k=a;l=g}while(1){c[k+4>>2]=h;g=l+-1|0;if(!g){f=h;break}a=j;j=c[j+4>>2]|0;l=g;k=a}i=b;return f|0}function caa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+40>>2]=d;if(!b){i=e;return}d=b+32|0;c[a+36>>2]=c[d>>2];c[d>>2]=a;c[a+28>>2]=b;i=e;return}function daa(a){a=a|0;var b=0;b=a+20|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;return}function eaa(a){a=a|0;var b=0;b=i;zaa(a);i=b;return}function faa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0;h=i;Gia(a,f,g,1,2);b[a+28>>1]=-1;b[a+30>>1]=0;c[a>>2]=463816;c[a+24>>2]=463856;c[a+32>>2]=d;c[a+36>>2]=-1;a=c[d+108>>2]|0;g=c[d+112>>2]|0;if(a){d=a+144|0;b[d>>1]=e[d>>1]|0|256;d=a+46|0;b[d>>1]=(b[d>>1]|0)+1<<16>>16}if(!g){i=h;return}d=g+144|0;b[d>>1]=e[d>>1]|0|256;d=g+46|0;b[d>>1]=(b[d>>1]|0)+1<<16>>16;i=h;return}function gaa(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=463816;c[a+24>>2]=463856;VJa(b,a);i=b;return}function haa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+-24|0;c[d>>2]=463816;c[d+24>>2]=463856;VJa(b,d);i=b;return}function iaa(a){a=a|0;c[a>>2]=463816;c[a+24>>2]=463856;return}function jaa(a){a=a|0;var b=0;b=a+-24|0;c[b>>2]=463816;c[b+24>>2]=463856;return}function kaa(d){d=d|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=d+4|0;h=q7(c[g>>2]|0)|0;j=d+32|0;k=c[j>>2]|0;if((a[k+116>>0]&6)==6)cda(h,k);k=d+36|0;if((c[k>>2]|0)!=-1)Mua(Via(c[h+1212>>2]|0)|0,1,k);k=d+30|0;if(b[k>>1]&2){Paa(d+24|0);b[k>>1]=(e[k>>1]|0)&65533}wia(c[g>>2]|0,d);wia(c[d+8>>2]|0,d);Pia(c[(c[g>>2]|0)+36>>2]|0,d);d=c[j>>2]|0;j=c[d+108>>2]|0;g=c[d+112>>2]|0;if(j)P9(j);if(!g){i=f;return}P9(g);i=f;return}function laa(a){a=a|0;var c=0,d=0;c=i;d=a+30|0;if(b[d>>1]&2){Paa(a+24|0);b[d>>1]=(e[d>>1]|0)&65533}b[a+28>>1]=0;i=c;return}function maa(a){a=a|0;var c=0,d=0,f=0;c=i;d=a+-24|0;a=d+30|0;if(!(b[a>>1]&2)){f=d+28|0;b[f>>1]=0;i=c;return}Paa(d+24|0);b[a>>1]=(e[a>>1]|0)&65533;f=d+28|0;b[f>>1]=0;i=c;return}function naa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+32|0;h=c[g>>2]|0;j=c[h+108>>2]|0;k=c[h+112>>2]|0;h=b+36|0;if((c[h>>2]|0)==-1){l=Via(c[(q7(c[b+4>>2]|0)|0)+1212>>2]|0)|0;if(!j)m=-1;else m=c[j+188>>2]|0;c[e>>2]=m;if(!k)n=-1;else n=c[k+188>>2]|0;c[f>>2]=n;Fua(l,1,e,f,h);Iua(l,h,(c[g>>2]|0)+32|0);Kua(l,h)}if(!j)o=1;else o=(a[j+51>>0]&1)!=0;if((k|0)!=0?!(o|(a[k+51>>0]&1)!=0):0){p=0;i=d;return p|0}if((a[(c[g>>2]|0)+116>>0]&6)!=2){p=1;i=d;return p|0}k=q7(c[b+4>>2]|0)|0;bda(k,c[g>>2]|0);p=1;i=d;return p|0}function oaa(b,d){b=b|0;d=d|0;var e=0,f=0;d=i;e=b+32|0;if((a[(c[e>>2]|0)+116>>0]&6)!=6){i=d;return 1}f=q7(c[b+4>>2]|0)|0;cda(f,c[e>>2]|0);i=d;return 1}function paa(b){b=b|0;var d=0;c[b+272>>2]=0;a[b+264>>0]=1;c[b+268>>2]=b+8;c[b+276>>2]=64;c[b+280>>2]=32;c[b+284>>2]=0;c[b+288>>2]=0;c[b+292>>2]=1536;d=b+296|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;return}function qaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=b+300|0;c[f>>2]=d;h=b+304|0;j=c[h>>2]|0;if((c[b+308>>2]&2147483647)>>>0<=j>>>0){LXa(g,f)|0;k=d+116|0;l=a[k>>0]|0;m=l|1;a[k>>0]=m;i=e;return}f=(c[g>>2]|0)+(j<<2)|0;if(f)c[f>>2]=d;c[h>>2]=j+1;k=d+116|0;l=a[k>>0]|0;m=l|1;a[k>>0]=m;i=e;return}function raa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=b+304|0;h=c[g>>2]|0;if(h){j=c[b+300>>2]|0;b=0;while(1){k=b+1|0;if((c[j+(b<<2)>>2]|0)==(e|0)){l=b;break}if(k>>>0<h>>>0)b=k;else{l=k;break}}if((l|0)!=(h|0)){b=h+-1|0;c[g>>2]=b;c[j+(l<<2)>>2]=c[j+(b<<2)>>2]}}b=e+116|0;a[b>>0]=(d[b>>0]|0)&254;i=f;return}function saa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+60|0;g=c[f>>2]|0;if(g){h=baa(g)|0;if(!(c[h+20>>2]|0))j=h;else{yaa(h);j=h}}else{h=a+296|0;g=c[h>>2]|0;if(!g){MXa(a+4|0);k=c[h>>2]|0}else k=g;c[h>>2]=c[k>>2];h=a+284|0;c[h>>2]=(c[h>>2]|0)+1;h=a+288|0;c[h>>2]=(c[h>>2]|0)+-1;if(!k)l=0;else{aaa(k,b);l=k}c[f>>2]=l;j=l}if(!d){i=e;return}l=d+60|0;f=c[l>>2]|0;if(f){k=baa(f)|0;if(!(c[k+20>>2]|0))m=k;else{yaa(k);m=k}}else{k=a+296|0;f=c[k>>2]|0;if(!f){MXa(a+4|0);n=c[k>>2]|0}else n=f;c[k>>2]=c[n>>2];k=a+284|0;c[k>>2]=(c[k>>2]|0)+1;k=a+288|0;c[k>>2]=(c[k>>2]|0)+-1;if(!n)o=0;else{aaa(n,d);o=n}c[l>>2]=o;m=o}if((j|0)==(m|0)){i=e;return}o=m+12|0;l=c[o>>2]|0;if((c[j+12>>2]|0)>>>0>l>>>0){p=j;q=m}else{c[o>>2]=l+1;p=m;q=j}c[q+4>>2]=p;j=p+8|0;c[(c[j>>2]|0)+16>>2]=q;c[j>>2]=c[q+8>>2];i=e;return}function taa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e;g=b+300|0;h=b+304|0;j=c[h>>2]|0;if(!j){i=e;return}k=b+308|0;l=0;do{m=c[(c[g>>2]|0)+(l<<2)>>2]|0;n=m+116|0;a[n>>0]=d[n>>0]&254;n=m+108|0;o=c[n>>2]|0;if(((o|0)!=0?(c[o+60>>2]|0)==0:0)?(p=c[o+20>>2]|0,q=c[o+28>>2]|0,o=p+(q<<2)|0,(q|0)>0):0){q=p;do{p=c[q>>2]|0;if(((a[p+20>>0]|0)==1?(r=c[p+32>>2]|0,(r|0)!=(m|0)):0)?(p=r+116|0,(a[p>>0]&1)==0):0){c[f>>2]=r;s=c[h>>2]|0;if((c[k>>2]&2147483647)>>>0>s>>>0){t=(c[g>>2]|0)+(s<<2)|0;if(t)c[t>>2]=r;c[h>>2]=s+1}else LXa(g,f)|0;a[p>>0]=a[p>>0]|1}q=q+4|0}while(q>>>0<o>>>0)}o=m+112|0;q=c[o>>2]|0;if(((q|0)!=0?(c[q+60>>2]|0)==0:0)?(p=c[q+20>>2]|0,s=c[q+28>>2]|0,q=p+(s<<2)|0,(s|0)>0):0){s=p;do{p=c[s>>2]|0;if(((a[p+20>>0]|0)==1?(r=c[p+32>>2]|0,(r|0)!=(m|0)):0)?(p=r+116|0,(a[p>>0]&1)==0):0){c[f>>2]=r;t=c[h>>2]|0;if((c[k>>2]&2147483647)>>>0>t>>>0){u=(c[g>>2]|0)+(t<<2)|0;if(u)c[u>>2]=r;c[h>>2]=t+1}else LXa(g,f)|0;a[p>>0]=a[p>>0]|1}s=s+4|0}while(s>>>0<q>>>0)}q=c[n>>2]|0;if(!q)v=c[o>>2]|0;else v=q;if((q|0)==(v|0))w=c[o>>2]|0;else w=q;saa(b,v,w,m);l=l+1|0}while(l>>>0<(c[h>>2]|0)>>>0);l=0;do{w=c[(c[g>>2]|0)+(l<<2)>>2]|0;v=c[w+108>>2]|0;if(!v)x=c[w+112>>2]|0;else x=v;v=baa(c[x+60>>2]|0)|0;if(!(c[v+20>>2]|0))waa(v);l=l+1|0}while((l|0)!=(j|0));c[h>>2]=0;i=e;return}function uaa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f;h=baa(d)|0;if(!h){i=f;return}d=b+300|0;j=b+308|0;k=b+304|0;l=b+4|0;m=b+284|0;n=b+296|0;o=b+288|0;p=b+280|0;b=h;do{h=c[b>>2]|0;q=c[h+20>>2]|0;r=c[h+28>>2]|0;s=q+(r<<2)|0;if((r|0)>0){r=q;do{q=c[r>>2]|0;if((((a[q+20>>0]|0)==1?(t=c[q+32>>2]|0,(t|0)!=(e|0)):0)?Caa(t)|0:0)?(q=t+116|0,(a[q>>0]&1)==0):0){c[g>>2]=t;u=c[k>>2]|0;if((c[j>>2]&2147483647)>>>0>u>>>0){v=(c[d>>2]|0)+(u<<2)|0;if(v)c[v>>2]=t;c[k>>2]=u+1}else LXa(d,g)|0;a[q>>0]=a[q>>0]|1}r=r+4|0}while(r>>>0<s>>>0);w=c[b>>2]|0}else w=h;s=b;b=c[b+16>>2]|0;c[w+60>>2]=0;if(c[s+20>>2]|0)yaa(s);c[m>>2]=(c[m>>2]|0)+-1;c[s>>2]=c[n>>2];c[n>>2]=s;s=c[o>>2]|0;c[o>>2]=s+1;if((s|0)>=((c[p>>2]|0)*50|0)){NXa(l);c[o>>2]=0}}while((b|0)!=0);i=f;return}function vaa(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=c[c[d>>2]>>2]|0;j=Eaa(b)|0;k=e[c[b+100>>2]>>1]|0;l=b+108|0;if((c[l>>2]|0)==(h|0)){m=j?0:k&4;n=j?0:k&2;o=b+112|0}else{m=j?0:k&2;n=j?0:k&4;o=l}l=c[o>>2]|0;o=(l|0)==0;if(!o?(a[(c[l+52>>2]|0)+44>>0]&1)==0:0){l=(m|0)==0;do if(!n)if(l){p=c[d+8>>2]|0;break}else{c[f>>2]=c[f>>2]&-402653185;k=d+8|0;j=c[k>>2]&-402653185;c[k>>2]=j;p=j;break}else{j=c[f>>2]|0;if(l){k=d+8|0;h=j&402653184|c[k>>2]|-2147483648;c[k>>2]=h;p=h;break}else{c[f>>2]=j&-268435457;j=d+8|0;h=c[j>>2]&-268435457;c[j>>2]=h;p=h;break}}while(0);c[d+8>>2]=p+1;i=g;return}if(!m)q=0;else{c[f>>2]=0;f=d+8|0;c[f>>2]=c[f>>2]&-402653185;q=-2147483648}f=q|(o?1073741824:536870912);o=d+4|0;q=c[d+8>>2]|0;if((c[o>>2]|0)==0|f>>>0>q>>>0)c[o>>2]=b;c[d+8>>2]=q|f;i=g;return}function waa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+816|0;f=e;g=e+24|0;h=e+4|0;j=e+16|0;k=e+810|0;l=e+809|0;m=e+808|0;n=g+768|0;o=g+772|0;p=g+776|0;c[p>>2]=0;q=g+780|0;a[n>>0]=1;c[o>>2]=g;c[q>>2]=64;do if(b){r=h+8|0;s=h+4|0;t=b;do{u=c[t>>2]|0;v=t+44|0;w=d[v>>0]|0;do if(!(a[(c[u+52>>2]|0)+44>>0]&1)){a[v>>0]=w&254;c[h>>2]=t;c[r>>2]=0;c[s>>2]=0;c[j>>2]=402653184;x=c[u+20>>2]|0;y=c[u+28>>2]|0;z=x+(y<<2)|0;if((y|0)>0){y=x;do{x=c[y>>2]|0;if((a[x+20>>0]|0)==1)vaa(c[x+32>>2]|0,h,j);y=y+4|0}while(y>>>0<z>>>0);if((c[r>>2]|0)>>>0>2415919103)a[v>>0]=d[v>>0]|1}z=c[p>>2]|0;if((c[q>>2]&2147483647)>>>0<=z>>>0){OXa(g,h)|0;break}y=(c[o>>2]|0)+(z*12|0)|0;if(!y)A=z;else{c[y+0>>2]=c[h+0>>2];c[y+4>>2]=c[h+4>>2];c[y+8>>2]=c[h+8>>2];A=c[p>>2]|0}c[p>>2]=A+1}else a[v>>0]=w|1;while(0);t=c[t+16>>2]|0}while((t|0)!=0);t=c[p>>2]|0;if(t){PXa(c[o>>2]|0,t,k,f);t=UJa(l,c[p>>2]<<2,464136,252)|0;if(!t){dKa(bKa()|0,16,464136,395,464240,f);break}r=0;s=0;w=0;v=-1879048192;u=0;y=c[p>>2]|0;while(1){a:do if(r>>>0<y>>>0){z=r;x=s;B=t;while(1){C=c[o>>2]|0;D=C+(z*12|0)+8|0;if((c[D>>2]|0)>>>0<v>>>0){E=z;F=x;G=B;break a}H=c[C+(z*12|0)>>2]|0;I=C+(z*12|0)+4|0;caa(H,0,c[I>>2]|0);if(!(c[D>>2]&1610612736))J=B+((xaa(H,c[I>>2]|0,B)|0)<<2)|0;else{c[B>>2]=H;J=B+4|0}c[H+24>>2]=x;I=z+1|0;if(I>>>0<y>>>0){z=I;x=H;B=J}else{E=I;F=H;G=J;break}}}else{E=r;F=s;G=t}while(0);if((t|0)!=(G|0)){B=t;x=G;do{z=c[B>>2]|0;B=B+4|0;x=x+((xaa(z,c[z+40>>2]|0,x)|0)<<2)|0}while((B|0)!=(x|0))}r=E+u|0;x=c[p>>2]|0;b:do if(r>>>0<x>>>0){B=x;z=r;H=0;I=r;while(1){D=c[o>>2]|0;if((c[D+(z*12|0)+8>>2]|0)>>>0<=2281701375){K=B;L=H;M=I;break b}C=(c[D+(z*12|0)>>2]|0)+44|0;D=d[C>>0]|0;if(!(D&1)){a[C>>0]=D|1;D=c[o>>2]|0;C=D+(I*12|0)|0;N=D+(z*12|0)|0;c[C+0>>2]=c[N+0>>2];c[C+4>>2]=c[N+4>>2];c[C+8>>2]=c[N+8>>2];O=c[p>>2]|0;P=H;Q=I+1|0}else{O=B;P=H+1|0;Q=I}z=z+1|0;if(z>>>0>=O>>>0){K=O;L=P;M=Q;break}else{B=O;H=P;I=Q}}}else{K=x;L=0;M=r}while(0);w=w+1|0;if((w|0)==2)break;else{s=F;v=-2013265920;u=L;y=M}}if(r>>>0<K>>>0){y=K;u=F;v=r;while(1){s=c[o>>2]|0;w=c[s+(v*12|0)>>2]|0;x=w+44|0;I=d[x>>0]|0;if(!(I&1)){a[x>>0]=I|1;I=t+((xaa(w,c[s+(v*12|0)+4>>2]|0,t)|0)<<2)|0;if((t|0)!=(I|0)){s=t;x=I;do{I=c[s>>2]|0;s=s+4|0;x=x+((xaa(I,c[I+40>>2]|0,x)|0)<<2)|0}while((s|0)!=(x|0))}c[w+24>>2]=u;R=c[p>>2]|0;S=w}else{R=y;S=u}v=v+1|0;if(v>>>0>=R>>>0){T=S;break}else{y=R;u=S}}}else T=F;c[b+20>>2]=T;VJa(m,t)}}while(0);m=c[q>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=e;return}m=c[o>>2]|0;if((g|0)==(m|0)){a[n>>0]=0;i=e;return}if(!m){i=e;return}n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,m);i=e;return}function xaa(b,f,g){b=b|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;j=c[b>>2]|0;k=c[j+20>>2]|0;l=c[j+28>>2]|0;m=k+(l<<2)|0;if((l|0)>0){n=g;o=k;p=0}else{q=0;i=h;return q|0}while(1){k=c[o>>2]|0;if((a[k+20>>0]|0)==1?(g=c[k+32>>2]|0,(g|0)!=(f|0)):0){k=Eaa(g)|0;l=e[c[g+100>>2]>>1]|0;r=g+108|0;if((c[r>>2]|0)==(j|0)){s=k?0:l&4;t=k?0:l&2;u=g+112|0}else{s=k?0:l&2;t=k?0:l&4;u=r}r=c[u>>2]|0;if((((r|0)!=0?(a[(c[r+52>>2]|0)+44>>0]&1)==0:0)?!((s|0)!=0&(t|0)==0):0)?(l=c[r+60>>2]|0,r=l+44|0,(a[r>>0]&1)==0):0){c[n>>2]=l;caa(l,b,g);a[r>>0]=d[r>>0]|1;v=n+4|0;w=p+1|0}else{v=n;w=p}}else{v=n;w=p}o=o+4|0;if(o>>>0>=m>>>0){q=w;break}else{n=v;p=w}}i=h;return q|0}function yaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+20|0;a=c[d>>2]|0;do{e=a;a=c[a+24>>2]|0;f=e;while(1){e=c[f+32>>2]|0;if(e){f=e;continue}e=c[f+28>>2]|0;g=c[f+36>>2]|0;if(e)c[e+32>>2]=0;daa(f);f=(g|0)==0?e:g;if(!f)break}}while((a|0)!=0);c[d>>2]=0;i=b;return}function zaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+48|0;d=b;e=d+36|0;f=c[a+20>>2]|0;do{aaa(d,c[f>>2]|0);c[e>>2]=f;a=d;g=f;while(1){if(!g){h=c[a+28>>2]|0;if(!h)break;else j=h}else{h=g;while(1){k=c[h+40>>2]|0;if(((k|0)!=0?Laa(k)|0:0)?Caa(k)|0:0)Maa(k,c[h>>2]|0);k=c[h+32>>2]|0;if(!k){j=h;break}else h=k}}a=j;g=c[j+36>>2]|0}f=c[f+24>>2]|0}while((f|0)!=0);i=b;return}function Aaa(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=i;i=i+16|0;l=k+4|0;m=k;n=d+96|0;c[n>>2]=j;o=d+100|0;c[o>>2]=e;p=d+116|0;a[p>>0]=0;q=d+12|0;r=(f|0)!=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;if(r?(a[f+10>>0]|0)!=0:0)s=Wba(f)|0;else s=0;c[d+108>>2]=s;s=(h|0)!=0;if(s?(a[h+10>>0]|0)!=0:0)t=Wba(h)|0;else t=0;c[d+112>>2]=t;if(!(Baa(d)|0)){i=k;return}t=j+2376|0;u=c[t>>2]|0;c[t>>2]=u+1;c[d+88>>2]=u;Y9(e,l,m);u=ea(g[l>>2])<ea(3402823469999999843913219.0e14);if(u|ea(g[m>>2])<ea(3402823469999999843913219.0e14))a[p>>0]=a[p>>0]|2;c[e+68>>2]=d;if((b[c[o>>2]>>1]&6)!=0?(c[q>>2]|0)==0:0)qaa(c[j+80>>2]|0,d);q=c[(c[n>>2]|0)+1236>>2]|0;if(r)v=Wba(f)|0;else v=c[j+1216>>2]|0;if(s)w=Wba(h)|0;else w=c[j+1216>>2]|0;j=q+292|0;h=c[j>>2]|0;if(!h){QXa(q);x=c[j>>2]|0}else x=h;c[j>>2]=c[x>>2];j=q+280|0;c[j>>2]=(c[j>>2]|0)+1;j=q+284|0;c[j>>2]=(c[j>>2]|0)+-1;if(!x)y=0;else{faa(x,d,v,w);y=x}c[d+104>>2]=y;ko[c[c[y>>2]>>2]&4095](y);i=k;return}function Baa(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=c[a+100>>2]|0;f=c[d+52>>2]|0;h=dda(c[a+96>>2]|0,f)|0;if(!h){dKa(bKa()|0,32,464400,113,464496,b);j=0;i=b;return j|0}PEi(h|0,0,f|0)|0;Y9(d,a+32|0,a+36|0);c[a+84>>2]=e[d>>1];c[a+40>>2]=c[d+44>>2];c[a+44>>2]=f;c[a+48>>2]=c[d+36>>2];c[a+52>>2]=c[d+32>>2];c[a+56>>2]=c[d+40>>2];c[a+60>>2]=h;c[a+64>>2]=a;h=c[a+108>>2]|0;f=(h|0)==0;k=f?0:h+64|0;c[a+68>>2]=k;h=c[a+112>>2]|0;l=(h|0)==0;m=l?0:h+64|0;c[a+72>>2]=m;if(f)n=0;else n=c[k+64>>2]|0;c[a+76>>2]=n;if(l)o=0;else o=c[m+64>>2]|0;c[a+80>>2]=o;g[a+92>>2]=ea(g[d+64>>2]);j=1;i=b;return j|0}function Caa(a){a=a|0;var d=0,e=0;d=i;if(!(b[c[a+100>>2]>>1]&6)){e=0;i=d;return e|0}e=(c[a+12>>2]|0)==0;i=d;return e|0}function Daa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(a[b+116>>0]&1)raa(c[(c[b+96>>2]|0)+80>>2]|0,b);e=b+104|0;if(!(c[b+12>>2]|0)){f=c[e>>2]|0;ko[c[(c[f>>2]|0)+4>>2]&4095](f)}f=b+96|0;g=c[(c[f>>2]|0)+1236>>2]|0;h=c[e>>2]|0;if((h|0)!=0?(ko[c[(c[h>>2]|0)+8>>2]&4095](h),e=g+280|0,c[e>>2]=(c[e>>2]|0)+-1,e=g+292|0,c[h>>2]=c[e>>2],c[e>>2]=h,h=g+284|0,e=c[h>>2]|0,c[h>>2]=e+1,(e|0)>=((c[g+276>>2]|0)*50|0)):0){RXa(g);c[h>>2]=0}h=c[b+60>>2]|0;if(!h){j=b+100|0;k=c[j>>2]|0;l=k+68|0;c[l>>2]=0;i=d;return}eda(c[f>>2]|0,h,c[b+44>>2]|0);j=b+100|0;k=c[j>>2]|0;l=k+68|0;c[l>>2]=0;i=d;return}function Eaa(a){a=a|0;return (c[a+12>>2]|0)!=0|0}function Faa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;h=d+108|0;j=c[h>>2]|0;if((j|0)!=0?(k=c[j+60>>2]|0,(k|0)!=0):0){l=k;m=6}else m=3;if(((m|0)==3?(k=c[d+112>>2]|0,(k|0)!=0):0)?(j=(c[k+60>>2]|0)==0?0:k,(j|0)!=0):0){l=c[j+60>>2]|0;m=6}if((((m|0)==6?(m=d+96|0,uaa(c[(c[m>>2]|0)+80>>2]|0,l,d),(b[c[d+100>>2]>>1]&6)!=0):0)?(c[d+12>>2]|0)==0:0)?(a[d+116>>0]&1)==0:0)qaa(c[(c[m>>2]|0)+80>>2]|0,d);m=(e|0)!=0;if(m?(a[e+10>>0]|0)!=0:0)n=Wba(e)|0;else n=0;l=(f|0)!=0;if(l?(a[f+10>>0]|0)!=0:0)o=Wba(f)|0;else o=0;j=(n|0)==0;k=j?0:n+64|0;c[d+68>>2]=k;p=(o|0)==0;q=p?0:o+64|0;c[d+72>>2]=q;if(j)r=0;else r=c[k+64>>2]|0;c[d+76>>2]=r;if(p)s=0;else s=c[q+64>>2]|0;c[d+80>>2]=s;s=d+104|0;if(!(c[d+12>>2]|0)){q=c[s>>2]|0;ko[c[(c[q>>2]|0)+4>>2]&4095](q)}c[h>>2]=n;c[d+112>>2]=o;o=d+96|0;n=c[(c[o>>2]|0)+1236>>2]|0;h=c[s>>2]|0;if((h|0)!=0?(ko[c[(c[h>>2]|0)+8>>2]&4095](h),q=n+280|0,c[q>>2]=(c[q>>2]|0)+-1,q=n+292|0,c[h>>2]=c[q>>2],c[q>>2]=h,h=n+284|0,q=c[h>>2]|0,c[h>>2]=q+1,(q|0)>=((c[n+276>>2]|0)*50|0)):0){RXa(n);c[h>>2]=0}h=c[o>>2]|0;n=c[h+1236>>2]|0;if(m)t=Wba(e)|0;else t=c[h+1216>>2]|0;if(l)u=Wba(f)|0;else u=c[(c[o>>2]|0)+1216>>2]|0;o=n+292|0;f=c[o>>2]|0;if(!f){QXa(n);v=c[o>>2]|0}else v=f;c[o>>2]=c[v>>2];o=n+280|0;c[o>>2]=(c[o>>2]|0)+1;o=n+284|0;c[o>>2]=(c[o>>2]|0)+-1;if(!v){w=0;c[s>>2]=w;x=c[w>>2]|0;y=c[x>>2]|0;ko[y&4095](w);i=g;return}faa(v,d,t,u);w=v;c[s>>2]=w;x=c[w>>2]|0;y=c[x>>2]|0;ko[y&4095](w);i=g;return}function Gaa(d){d=d|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(!(c[d+12>>2]|0)){i=f;return}g=d+100|0;ada(c[d+96>>2]|0,c[g>>2]|0);$9(c[g>>2]|0);g=d+104|0;d=c[g>>2]|0;ko[c[(c[d>>2]|0)+4>>2]&4095](d);d=c[g>>2]|0;g=c[d+4>>2]|0;h=c[d+8>>2]|0;d=(c[g+28>>2]|0)>>>0<(c[h+28>>2]|0)>>>0?g:h;h=c[d+20>>2]|0;g=c[d+28>>2]|0;d=h+(g<<2)|0;if((g|0)>0)j=h;else{i=f;return}do{h=c[j>>2]|0;if(a[h+21>>0]&1){if(!h)k=0;else k=h+-8|0;h=k+4|0;b[h>>1]=e[h>>1]|0|1;h=k+6|0;if(!(b[h>>1]&2)){Oaa(k);b[h>>1]=e[h>>1]|0|2}}j=j+4|0}while(j>>>0<d>>>0);i=f;return}function Haa(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im,f=Im,h=Im,i=Im;e=ea(g[(c[a+96>>2]|0)+52>>2]);f=ea(e*ea(g[a>>2]));h=ea(e*ea(g[a+4>>2]));i=ea(e*ea(g[a+8>>2]));g[b>>2]=f;g[b+4>>2]=h;g[b+8>>2]=i;i=ea(e*ea(g[a+16>>2]));h=ea(e*ea(g[a+20>>2]));f=ea(e*ea(g[a+24>>2]));g[d>>2]=i;g[d+4>>2]=h;g[d+8>>2]=f;return}function Iaa(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0;f=i;h=b+116|0;j=a[h>>0]|0;k=d<ea(3402823469999999843913219.0e14)|e<ea(3402823469999999843913219.0e14);do if((k?2:0)<<24>>24!=(j&2)){if(k){a[h>>0]=j|2;l=b+96|0;if(!(Qia(c[(c[l>>2]|0)+1212>>2]|0,c[b+104>>2]|0)|0))break;bda(c[l>>2]|0,b);break}if(!(j&4))m=j;else{cda(c[b+96>>2]|0,b);m=a[h>>0]|0}a[h>>0]=m&253}while(0);g[b+32>>2]=d;g[b+36>>2]=e;i=f;return}function Jaa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=b[f>>1]|0;c[d+84>>2]=h&65535;f=(h&6)!=0;h=(b[e>>1]&6)==0;if(!(f&h)){if(f|h){i=g;return}if(a[d+116>>0]&1){raa(c[(c[d+96>>2]|0)+80>>2]|0,d);i=g;return}h=c[d+108>>2]|0;if((h|0)!=0?(f=c[h+60>>2]|0,(f|0)!=0):0)j=f;else k=18;do if((k|0)==18){f=c[d+112>>2]|0;if(!f){i=g;return}h=(c[f+60>>2]|0)==0?0:f;if(!h){i=g;return}else{j=c[h+60>>2]|0;break}}while(0);uaa(c[(c[d+96>>2]|0)+80>>2]|0,j,0);i=g;return}j=c[d+108>>2]|0;h=c[d+112>>2]|0;f=(j|0)!=0;if(!(f?(c[j+60>>2]|0)==0:0))k=4;do if((k|0)==4){if((h|0)!=0?(c[h+60>>2]|0)==0:0)break;if(f){e=baa(c[j+60>>2]|0)|0;if(c[e+20>>2]|0)yaa(e);waa(e);i=g;return}else{e=baa(c[h+60>>2]|0)|0;if(c[e+20>>2]|0)yaa(e);waa(e);i=g;return}}while(0);qaa(c[(c[d+96>>2]|0)+80>>2]|0,d);i=g;return}function Kaa(a,b){a=a|0;b=b|0;var d=0;d=c[a+104>>2]|0;return c[((b|0)==0?d+4|0:d+8|0)>>2]|0}function Laa(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+108>>2]|0;if((e|0)!=0?(a[(c[e+52>>2]|0)+44>>0]&1)==0:0){f=1;i=d;return f|0}e=c[b+112>>2]|0;if(!e){f=0;i=d;return f|0}f=(a[(c[e+52>>2]|0)+44>>0]&1)==0;i=d;return f|0}function Maa(a,b){a=a|0;b=b|0;var d=0;d=i;psa(a+32|0,(c[a+112>>2]|0)==(b|0),ea(g[(c[a+96>>2]|0)+48>>2]));i=d;return}function Naa(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im;e=i;i=i+176|0;f=e+148|0;h=e+120|0;j=e+16|0;k=e;l=a+100|0;if(!(b[c[l>>2]>>1]&32)){i=e;return}m=c[a+68>>2]|0;n=c[a+72>>2]|0;if(!m){g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(1.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0)}else{o=c[m+64>>2]|0;g[f>>2]=ea(g[o>>2]);g[f+4>>2]=ea(g[o+4>>2]);g[f+8>>2]=ea(g[o+8>>2]);g[f+12>>2]=ea(g[o+12>>2]);g[f+16>>2]=ea(g[o+16>>2]);g[f+20>>2]=ea(g[o+20>>2]);g[f+24>>2]=ea(g[o+24>>2])}if(!n){g[h>>2]=ea(0.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);g[h+12>>2]=ea(1.0);g[h+16>>2]=ea(0.0);g[h+20>>2]=ea(0.0);g[h+24>>2]=ea(0.0)}else{o=c[n+64>>2]|0;g[h>>2]=ea(g[o>>2]);g[h+4>>2]=ea(g[o+4>>2]);g[h+8>>2]=ea(g[o+8>>2]);g[h+12>>2]=ea(g[o+12>>2]);g[h+16>>2]=ea(g[o+16>>2]);g[h+20>>2]=ea(g[o+20>>2]);g[h+24>>2]=ea(g[o+24>>2])}o=a+96|0;n=c[o>>2]|0;p=ea(g[n+1416>>2]);q=ea(p*ea(Cda(n,21)));n=c[o>>2]|0;p=ea(g[n+1416>>2]);r=ea(p*ea(Cda(n,22)));n=j+36|0;o=j+0|0;m=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(m|0));g[n>>2]=ea(1.0);n=j+40|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[j+56>>2]=ea(1.0);n=j+60|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[j+76>>2]=ea(1.0);n=j+80|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[j+96>>2]=ea(1.0);c[j+100>>2]=d;c[k>>2]=430496;g[k+4>>2]=q;g[k+8>>2]=r;c[k+12>>2]=j;En[c[(c[l>>2]|0)+48>>2]&127](k,c[a+60>>2]|0,f,h,3);i=e;return}function Oaa(a){a=a|0;var b=0;b=i;Fba(mo[c[(c[a>>2]|0)+12>>2]&4095](a)|0,a);i=b;return}function Paa(a){a=a|0;var b=0;b=i;Gba(mo[c[(c[a>>2]|0)+12>>2]&4095](a)|0,a)|0;i=b;return}function Qaa(a){a=a|0;var b=0,c=0;b=i;switch(d[a+20>>0]|0|0){case 4:case 3:case 2:case 0:{c=a+-8|0;break}case 1:{c=a+24|0;break}default:c=0}i=b;return c|0}function Raa(a){a=a|0;return (b[(c[a+40>>2]|0)+16>>1]|0)==1|0}function Saa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+8|0;e=_n[c[(c[d>>2]|0)+16>>2]&4095](d,0)|0;f=a+12|0;Oia(c[(c[f>>2]|0)+36>>2]|0,d,e);via(c[f>>2]|0,d);via(c[a+16>>2]|0,d);i=b;return}function Taa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+-8|0;a=d+8|0;e=_n[c[(c[a>>2]|0)+16>>2]&4095](a,0)|0;f=d+12|0;Oia(c[(c[f>>2]|0)+36>>2]|0,a,e);via(c[f>>2]|0,a);via(c[d+16>>2]|0,a);i=b;return}function Uaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+8|0;e=a+12|0;wia(c[e>>2]|0,d);wia(c[a+16>>2]|0,d);Pia(c[(c[e>>2]|0)+36>>2]|0,d);i=b;return}function Vaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+-8|0;a=d+8|0;e=d+12|0;wia(c[e>>2]|0,a);wia(c[d+16>>2]|0,a);Pia(c[(c[e>>2]|0)+36>>2]|0,a);i=b;return}function Waa(a){a=a|0;var c=0,d=0;c=i;d=a+6|0;if(b[d>>1]&2){Paa(a);b[d>>1]=(e[d>>1]|0)&65533}b[a+4>>1]=0;i=c;return}function Xaa(a,b){a=a|0;b=b|0;return 0}function Yaa(a,b){a=a|0;b=b|0;return 0}function Zaa(a,b){a=a|0;b=b|0;return 1}function _aa(a,b){a=a|0;b=b|0;return 1}function $aa(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h;k=c[d+8>>2]|0;l=c[k+20>>2]|0;m=l+(c[k+28>>2]<<2)|0;k=j;c[k>>2]=l;c[k+4>>2]=m;c[j+8>>2]=d;d=Aia(j)|0;if(!d){i=h;return}else n=d;do{if((a[n+21>>0]&g)<<24>>24!=0?(d=n+-8|0,m=d+4|0,b[m>>1]=e[m>>1]|0|f,m=d+6|0,(b[m>>1]&2)==0):0){Oaa(d);b[m>>1]=e[m>>1]|0|2}n=Aia(j)|0}while((n|0)!=0);i=h;return}function aba(a){a=a|0;var b=0,d=0;b=i;d=c[(q7(c[(c[a+32>>2]|0)+8>>2]|0)|0)+1088>>2]|0;i=b;return d|0}function bba(e,f){e=e|0;f=f|0;var g=0,h=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];b[e+12>>1]=b[f+12>>1]|0;g=e+14|0;h=f+14|0;f=d[h>>0]|d[h+1>>0]<<8;a[g>>0]=f;a[g+1>>0]=f>>8;c[e+16>>2]=0;c[e+20>>2]=-1;return}function cba(a){a=a|0;return}function dba(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;c[d>>2]=e;e=f+144|0;j=d+4|0;k=j+40|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));l=c[e>>2]|0;e=b[f+100>>1]|0;f=d+44|0;c[f>>2]=0;c[d+48>>2]=0;c[d+52>>2]=l;c[d+56>>2]=l;c[d+60>>2]=0;a[d+64>>0]=(e&65535)>>>10&1;c[f>>2]=UJa(h,l,474544,167)|0;l=d+120|0;h=d+376|0;f=d+380|0;c[d+384>>2]=0;e=d+388|0;j=d+68|0;k=j+44|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));a[h>>0]=1;c[f>>2]=l;c[e>>2]=64;c[d+392>>2]=32;c[d+396>>2]=0;c[d+400>>2]=0;c[d+404>>2]=768;c[d+408>>2]=0;c[d+680>>2]=0;a[d+672>>0]=1;c[d+676>>2]=d+416;c[d+684>>2]=64;c[d+688>>2]=32;c[d+692>>2]=0;c[d+696>>2]=0;c[d+700>>2]=768;c[d+704>>2]=0;c[d+976>>2]=0;a[d+968>>0]=1;c[d+972>>2]=d+712;c[d+980>>2]=64;c[d+984>>2]=32;c[d+988>>2]=0;c[d+992>>2]=0;c[d+996>>2]=2176;c[d+1e3>>2]=0;c[d+1272>>2]=0;a[d+1264>>0]=1;c[d+1268>>2]=d+1008;c[d+1276>>2]=64;c[d+1280>>2]=32;c[d+1284>>2]=0;c[d+1288>>2]=0;c[d+1292>>2]=1920;c[d+1296>>2]=0;c[d+1568>>2]=0;a[d+1560>>0]=1;c[d+1564>>2]=d+1304;c[d+1572>>2]=64;c[d+1576>>2]=32;c[d+1580>>2]=0;c[d+1584>>2]=0;c[d+1588>>2]=1152;c[d+1592>>2]=0;c[d+1864>>2]=0;a[d+1856>>0]=1;c[d+1860>>2]=d+1600;c[d+1868>>2]=64;c[d+1872>>2]=32;c[d+1876>>2]=0;c[d+1880>>2]=0;c[d+1884>>2]=1280;c[d+1888>>2]=0;c[d+2160>>2]=0;a[d+2152>>0]=1;c[d+2156>>2]=d+1896;c[d+2164>>2]=64;c[d+2168>>2]=32;c[d+2172>>2]=0;c[d+2176>>2]=0;c[d+2180>>2]=1536;c[d+2184>>2]=0;i=g;return}function eba(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;fba(a,0);SXa(a+1892|0);TXa(a+1596|0);UXa(a+1300|0);VXa(a+1004|0);WXa(a+708|0);XXa(a+412|0);YXa(a+116|0);ZXa(a+80|0);e=c[a+76>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+68>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}VJa(d,c[a+44>>2]|0);d=c[a+40>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+32>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+24>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+16>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+12>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+4>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function fba(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f;h=a+4|0;j=a+8|0;if(c[j>>2]|0){k=a+116|0;l=a+396|0;m=a+408|0;n=a+400|0;o=a+392|0;a=0;do{p=c[(c[h>>2]|0)+(a<<2)>>2]|0;q=p+16|0;r=b[q>>1]|0;b[q>>1]=r+-1<<16>>16;if((r&65535)<=1){if(p){if(c[p+20>>2]|0)l7(p);r=(c[p>>2]|0)+46|0;b[r>>1]=(b[r>>1]|0)+-1<<16>>16;r=(c[p+4>>2]|0)+46|0;b[r>>1]=(b[r>>1]|0)+-1<<16>>16;c[l>>2]=(c[l>>2]|0)+-1;c[p>>2]=c[m>>2];c[m>>2]=p;r=c[n>>2]|0;c[n>>2]=r+1;if((r|0)>=((c[o>>2]|0)*50|0)){_Xa(k);c[n>>2]=0}}}else{r=p+12|0;b[r>>1]=(e[r>>1]|0)&65534}a=a+1|0}while(a>>>0<(c[j>>2]|0)>>>0)}if(d){c[g>>2]=0;$Xa(h,0,g);aYa(h,c[j>>2]|0);i=f;return}else{c[j>>2]=0;i=f;return}}function gba(a){a=a|0;return c[a+56>>2]|0}function hba(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;j=i;i=i+160|0;k=j;l=j+152|0;m=j+64|0;n=j+124|0;o=j+96|0;p=j+154|0;q=j+88|0;r=e+12|0;s=VEi(c[r>>2]|0,c[r+4>>2]|0,30)|0;r=f+12|0;t=VEi(c[r>>2]|0,c[r+4>>2]|0,30)|0;r=(s&3)>>>0>(t&3)>>>0;t=r?e:f;s=r?f:e;e=t+12|0;f=VEi(c[e>>2]|0,c[e+4>>2]|0,30)|0;e=f&3;if((e|0)==2){if(!(0==0?(c[s+12>>2]&-1073741824|0)==0:0)){i=j;return}f=_ia(c[t+20>>2]|0)|0;Ika(p,yla(f)|0);if(!(b[p>>1]&4)){i=j;return}bYa(q,d,t,s,0);if(b[q>>1]&3){i=j;return}switch(c[(c[s+28>>2]|0)+68>>2]|0){case 0:{Cla(f,s);i=j;return}case 1:{Gla(f,s);i=j;return}case 2:{Ela(f,s);i=j;return}case 3:{Ila(f,s);i=j;return}case 4:{Kla(f,s);i=j;return}case 5:{Mla(f,s);i=j;return}case 6:{Ola(f,s);i=j;return}default:{i=j;return}}}else if((e|0)==1){if(!(0==0?(c[s+12>>2]&-1073741824|0)==0:0)){i=j;return}f=a[(c[s+8>>2]|0)+50>>0]|0;if(f<<24>>24==1|f<<24>>24==4?(lha(l,Pha(Iga(t)|0)|0),(b[l>>1]&2)==0):0){i=j;return}if((b[t+42>>1]|0)==-1){dKa(bKa()|0,2,464776,278,464872,k);i=j;return}l=s+28|0;f=c[(c[l>>2]|0)+68>>2]|0;do if((f+-5|0)>>>0<2){Jga(t,m);if((f|0)==5){q=(c[l>>2]|0)+68|0;u=ea(g[m>>2]);v=ea(g[m+12>>2]);w=ea(u+v);x=ea(g[m+4>>2]);y=ea(g[m+16>>2]);z=ea(x+y);A=ea(g[m+8>>2]);B=ea(g[m+20>>2]);C=ea(w*ea(.5));w=ea(z*ea(.5));z=ea(ea(A+B)*ea(.5));D=ea(ea(v-u)*ea(.5));u=ea(ea(y-x)*ea(.5));x=ea(ea(B-A)*ea(.5));g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(1.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=C;g[k+40>>2]=w;g[k+44>>2]=z;g[k+48>>2]=D;g[k+52>>2]=u;g[k+56>>2]=x;Ifa(n,s);if(CQa(q,n,k)|0)break;i=j;return}else if((f|0)==6){q=(c[l>>2]|0)+68|0;x=ea(g[m>>2]);u=ea(g[m+12>>2]);D=ea(x+u);z=ea(g[m+4>>2]);w=ea(g[m+16>>2]);C=ea(z+w);A=ea(g[m+8>>2]);B=ea(g[m+20>>2]);y=ea(D*ea(.5));D=ea(C*ea(.5));C=ea(ea(A+B)*ea(.5));v=ea(ea(u-x)*ea(.5));x=ea(ea(w-z)*ea(.5));z=ea(ea(B-A)*ea(.5));g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(1.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=y;g[k+40>>2]=D;g[k+44>>2]=C;g[k+48>>2]=v;g[k+52>>2]=x;g[k+56>>2]=z;Ifa(o,s);if(QRa(q,o,k)|0)break;i=j;return}else{i=j;return}}while(0);iba(d,t,s,h)|0;i=j;return}else if(!e){jba(d,t,s)|0;i=j;return}else{i=j;return}}function iba(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+16|0;k=j;l=c[g+8>>2]|0;m=c[f+36>>2]|0;n=b[f+42>>1]|0;o=m+((n&65535)<<2)|0;a:do if(n<<16>>16){p=m;while(1){q=c[p>>2]|0;if((c[q+16>>2]|0)==(l|0)?(c[q+32>>2]|0)==(f|0):0)break;p=p+4|0;if(p>>>0>=o>>>0){r=7;break a}}if(q)s=c[q+40>>2]|0;else r=7}else r=7;while(0);if((r|0)==7){bYa(k,d,f,g,0);r=e[k>>1]|0;if(r&1){t=0;i=j;return t|0}q=c[f+8>>2]|0;o=d+704|0;l=c[o>>2]|0;if(!l){cYa(d+412|0);u=c[o>>2]|0}else u=l;c[o>>2]=c[u>>2];o=d+692|0;c[o>>2]=(c[o>>2]|0)+1;o=d+696|0;c[o>>2]=(c[o>>2]|0)+-1;if(!u)v=0;else{o=b[k+2>>1]|0;c[u>>2]=q;c[u+4>>2]=g;b[u+8>>1]=o;o=u+12|0;c[o+0>>2]=0;c[o+4>>2]=0;a[o+8>>0]=0;v=u}a[v+19>>0]=r>>>1&1;r=c[k+4>>2]|0;a[v+18>>0]=(r|0)!=0&1;if(!r)s=v;else{a[r+8>>0]=1;c[r+4>>2]=v;s=v}}v=d+2184|0;r=c[v>>2]|0;if(!r){dYa(d+1892|0);w=c[v>>2]|0}else w=r;c[v>>2]=c[w>>2];v=d+2172|0;c[v>>2]=(c[v>>2]|0)+1;v=d+2176|0;c[v>>2]=(c[v>>2]|0)+-1;if(!w)x=0;else{uga(w,f,g,s);g=s+16|0;b[g>>1]=(b[g>>1]|0)+1<<16>>16;zga(w,h);x=w}if(!(a[s+18>>0]|0)){t=x;i=j;return t|0}s=x+6|0;b[s>>1]=e[s>>1]|4;t=x;i=j;return t|0}function jba(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h;k=h+10|0;l=h+8|0;oba(j,d,f,g,0);m=c[j>>2]|0;n=m>>>16&65535;if(m&1){o=0;i=h;return o|0}do if(!(m&2)){if((a[(c[f+28>>2]|0)+64>>0]&4)==0?(a[(c[g+28>>2]|0)+64>>0]&4)==0:0){b[k>>1]=n;p=pba(d,f,g,k)|0;break}b[l>>1]=n;p=qba(d,f,g,l)|0}else{q=d+1888|0;r=c[q>>2]|0;if(!r){eYa(d+1596|0);s=c[q>>2]|0}else s=r;c[q>>2]=c[s>>2];q=d+1876|0;c[q>>2]=(c[q>>2]|0)+1;q=d+1880|0;c[q>>2]=(c[q>>2]|0)+-1;if(!s)t=0;else{c[s>>2]=466432;b[s+4>>1]=-1;b[s+6>>1]=1;Gia(s+8|0,c[f+8>>2]|0,c[g+8>>2]|0,3,5);c[s+32>>2]=f;c[s+36>>2]=g;c[s>>2]=464704;c[s+8>>2]=464748;t=s}Saa(t);p=t}while(0);t=c[j+4>>2]|0;if(!t){o=p;i=h;return o|0}j=p+6|0;b[j>>1]=e[j>>1]|0|4;a[t+8>>0]=0;c[t+4>>2]=p;o=p;i=h;return o|0}function kba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+64|0;g=f+32|0;h=f;j=d>>>2;if(!j)k=0;else{l=j+-1|0;m=g+4|0;n=g+8|0;o=g+12|0;p=g+16|0;q=g+20|0;r=g+24|0;s=g+28|0;t=h+4|0;u=h+8|0;v=h+12|0;w=h+16|0;x=h+20|0;y=h+24|0;z=h+28|0;A=0;B=0;do{C=A>>>0<l>>>0;D=B;B=B+4|0;if(!C){if(B>>>0<d>>>0){E=0;F=B;while(1){G=c[b+(F<<3)+4>>2]|0;c[g+(E<<2)>>2]=c[b+(F<<3)>>2];c[g+((E|1)<<2)>>2]=G;F=F+1|0;if((F|0)==(d|0))break;else E=E+2|0}}}else{E=c[b+(B<<3)+4>>2]|0;c[g>>2]=c[b+(B<<3)>>2];c[m>>2]=E;E=D+5|0;F=c[b+(E<<3)+4>>2]|0;c[n>>2]=c[b+(E<<3)>>2];c[o>>2]=F;F=D+6|0;E=c[b+(F<<3)+4>>2]|0;c[p>>2]=c[b+(F<<3)>>2];c[q>>2]=E;E=D+7|0;F=c[b+(E<<3)+4>>2]|0;c[r>>2]=c[b+(E<<3)>>2];c[s>>2]=F}hba(a,c[b+(D<<3)>>2]|0,c[b+(D<<3)+4>>2]|0,e);a:do if(!C){if(B>>>0<d>>>0){F=0;E=B;while(1){G=F|1;H=c[(c[g+(G<<2)>>2]|0)+8>>2]|0;c[h+(F<<2)>>2]=c[(c[g+(F<<2)>>2]|0)+8>>2];c[h+(G<<2)>>2]=H;H=E+1|0;if((H|0)==(d|0))break a;F=F+2|0;E=H}}}else{E=c[(c[m>>2]|0)+8>>2]|0;c[h>>2]=c[(c[g>>2]|0)+8>>2];c[t>>2]=E;E=c[(c[o>>2]|0)+8>>2]|0;c[u>>2]=c[(c[n>>2]|0)+8>>2];c[v>>2]=E;E=c[(c[q>>2]|0)+8>>2]|0;c[w>>2]=c[(c[p>>2]|0)+8>>2];c[x>>2]=E;E=c[(c[s>>2]|0)+8>>2]|0;c[y>>2]=c[(c[r>>2]|0)+8>>2];c[z>>2]=E}while(0);E=D|1;hba(a,c[b+(E<<3)>>2]|0,c[b+(E<<3)+4>>2]|0,e);b:do if(C){}else if(B>>>0<d>>>0){E=0;F=B;while(1){H=F+1|0;if((H|0)==(d|0))break b;E=E+2|0;F=H}}while(0);F=D|2;hba(a,c[b+(F<<3)>>2]|0,c[b+(F<<3)+4>>2]|0,e);c:do if(!C)if(B>>>0<d>>>0){F=0;E=B;while(1){H=E+1|0;if((H|0)==(d|0))break c;F=F+2|0;E=H}}while(0);C=D|3;hba(a,c[b+(C<<3)>>2]|0,c[b+(C<<3)+4>>2]|0,e);A=A+1|0}while(A>>>0<j>>>0);k=j<<2}if(k>>>0<d>>>0)I=k;else{i=f;return}do{hba(a,c[b+(I<<3)>>2]|0,c[b+(I<<3)+4>>2]|0,e);I=I+1|0}while((I|0)!=(d|0));i=f;return}function lba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=(c[(c[d+8>>2]|0)+28>>2]|0)>>>0<(c[(c[b+8>>2]|0)+28>>2]|0)>>>0;j=h?d:b;k=h?b:d;h=c[j+8>>2]|0;l=c[h+20>>2]|0;m=l+(c[h+28>>2]<<2)|0;h=g;c[h>>2]=l;c[h+4>>2]=m;c[g+8>>2]=j;j=Aia(g)|0;a:do if(j){m=j;while(1){if((c[m+24>>2]|0)==(k|0))break;if((c[m+28>>2]|0)==(k|0)){n=5;break}h=Aia(g)|0;if(!h)break a;else m=h}if((n|0)==5?(m|0)==0:0)break;mba(a,m+-8|0,4,e)}while(0);e=0==0?(c[b+12>>2]&-1073741824|0)==-2147483648:0;a=e?b:d;n=e?d:b;if(!(0==0?(c[a+12>>2]&-1073741824|0)==-2147483648:0)){i=f;return}if(!(0==0?(c[n+12>>2]&-1073741824|0)==0:0)){i=f;return}b=_ia(c[a+20>>2]|0)|0;switch(c[(c[n+28>>2]|0)+68>>2]|0){case 1:{Hla(b,n);i=f;return}case 0:{Dla(b,n);i=f;return}case 2:{Fla(b,n);i=f;return}case 3:{Jla(b,n);i=f;return}case 4:{Lla(b,n);i=f;return}case 5:{Nla(b,n);i=f;return}case 6:{Pla(b,n);i=f;return}default:{i=f;return}}}function mba(a,f,g,h){a=a|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+80|0;k=j+56|0;l=j+40|0;m=j+24|0;n=j+8|0;o=j+4|0;p=j;q=f+6|0;r=b[q>>1]|0;if(!(r&2))s=r;else{Paa(f);r=(e[q>>1]|0)&65533;b[q>>1]=r;s=r}if((s&4)!=0?mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0:0){s=uba(a,f)|0;r=c[f+32>>2]|0;q=c[f+36>>2]|0;t=c[s>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;co[c[(c[r>>2]|0)+8>>2]&2047](r,o,m);co[c[(c[q>>2]|0)+8>>2]&2047](q,p,n);q=c[(c[a>>2]|0)+1104>>2]|0;r=c[(c[q>>2]|0)+4>>2]|0;u=c[o>>2]|0;o=c[p>>2]|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];Wn[r&127](q,t,u,l,o,k,(g&1|0)!=0);tba(a,s)}s=d[f+28>>0]|0;if((s|0)==3){Uaa(f);if(!f){i=j;return}ko[c[c[f>>2]>>2]&4095](f);k=a+1876|0;c[k>>2]=(c[k>>2]|0)+-1;k=a+1888|0;c[f>>2]=c[k>>2];c[k>>2]=f;k=a+1880|0;o=c[k>>2]|0;c[k>>2]=o+1;if((o|0)<((c[a+1872>>2]|0)*50|0)){i=j;return}gYa(a+1596|0);c[k>>2]=0;i=j;return}else if((s|0)==2){Bba(a,f,1,(g&1|0)!=0);sga(f);if(!f){i=j;return}ko[c[c[f>>2]>>2]&4095](f);k=a+1284|0;c[k>>2]=(c[k>>2]|0)+-1;k=a+1296|0;c[f>>2]=c[k>>2];c[k>>2]=f;k=a+1288|0;o=c[k>>2]|0;c[k>>2]=o+1;if((o|0)<((c[a+1280>>2]|0)*50|0)){i=j;return}fYa(a+1004|0);c[k>>2]=0;i=j;return}else if((s|0)==4){zba(a,f,g,h);i=j;return}else if(!s){Iba(a,f,g,h);i=j;return}else{i=j;return}}function nba(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=d+12|0;j=VEi(c[h>>2]|0,c[h+4>>2]|0,30)|0;h=j&3;if((h|0)==1){j=e|1;k=c[d+36>>2]|0;l=b[d+42>>1]|0;if(!(l<<16>>16)){i=f;return}m=k+((l&65535)<<2)|0;do{m=m+-4|0;mba(a,c[m>>2]|0,j,0)}while(k>>>0<m>>>0);i=f;return}else if(!h){h=e|3;e=c[d+8>>2]|0;m=c[e+20>>2]|0;k=m+(c[e+28>>2]<<2)|0;e=g;c[e>>2]=m;c[e+4>>2]=k;c[g+8>>2]=d;d=Bia(g)|0;if(!d){i=f;return}else n=d;do{mba(a,n+-8|0,h,0);n=Bia(g)|0}while((n|0)!=0);i=f;return}else{i=f;return}}function oba(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;l=i;i=i+16|0;m=l+8|0;n=l;o=f;c[o>>2]=0;c[o+4>>2]=0;o=Vfa(h)|0;p=Vfa(j)|0;q=o+50|0;r=a[q>>0]|0;s=p+50|0;t=a[s>>0]|0;if(r<<24>>24==1|r<<24>>24==4)u=o;else u=0;if(t<<24>>24==1|t<<24>>24==4)v=p;else v=0;w=(d[(c[h+28>>2]|0)+64>>0]|0)>>>2;x=(d[(c[j+28>>2]|0)+64>>0]|0)>>>2;if(r<<24>>24==1|r<<24>>24==4)y=(a[(c[u+52>>2]|0)+44>>0]&1)!=0;else y=0;if(t<<24>>24==1|t<<24>>24==4)z=(a[(c[v+52>>2]|0)+44>>0]&1)!=0;else z=0;A=e[(c[g>>2]|0)+1200>>1]|0;if((A&32|0)==0&(w&1|0)==0&(x&1|0)==0){B=(r<<24>>24!=4&r<<24>>24!=1|t<<24>>24!=4&t<<24>>24!=1)&(y|z);C=B?2:0;D=B}else{C=0;D=0}if((A&64|0)==0&(w&1|0)==0){w=z&(y&(x&1|0)==0);if(w|D)E=w?2:C;else F=14}else if(D)E=C;else F=14;a:do if((F|0)==14){a[m>>0]=0;if((u|0)!=0?(b[u+144>>1]&256)!=0:0)if(O9(u,p,m)|0)F=20;else G=0;else if(((v|0)!=0?(b[v+144>>1]&256)!=0:0)?O9(v,o,m)|0:0)F=20;else G=0;if((F|0)==20)G=(a[m>>0]|0)!=0;if(((a[q>>0]|0)==4?(a[s>>0]|0)==4:0)?(C=c[o+20>>2]|0,D=c[o+28>>2]|0,w=C+(D<<2)|0,(D|0)>0):0){D=C;do{C=c[D>>2]|0;if((a[C+20>>0]|0)==5){if((c[C+4>>2]|0)==(p|0)){E=1;break a}if((c[C+8>>2]|0)==(p|0)){E=1;break a}}D=D+4|0}while(D>>>0<w>>>0)}if(G)E=2;else{bYa(n,g,h,j,k);w=n;D=c[w>>2]|0;C=c[w+4>>2]|0;w=f;c[w>>2]=D;c[w+4>>2]=C;w=f+2|0;x=VEi(D|0,C|0,16)|0;C=x&65535;if(((((Mfa(h)|0)!=0?(a[(c[(Mfa(h)|0)+52>>2]|0)+44>>0]&1)!=0:0)?(Mfa(j)|0)!=0:0)?(a[(c[(Mfa(j)|0)+52>>2]|0)+44>>0]&1)!=0:0)?(x&1|0)!=0:0)H=x&65534;else H=C;b[w>>1]=H;i=l;return}}while(0);if(k)tba(g,k);b[f>>1]=E;i=l;return}function pba(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+16|0;j=h;k=Vfa(e)|0;if(!(a[k+50>>0]|0))l=0;else l=(c[k+56>>2]|0)+2|0;k=Vfa(f)|0;if(!(a[k+50>>0]|0))m=0;else m=(c[k+56>>2]|0)+2|0;if(l>>>0>=m>>>0?(a[(Vfa(e)|0)+50>>0]|0)!=0:0){n=f;o=e}else{n=e;o=f}f=rba(d,o,n)|0;e=d+1e3|0;m=c[e>>2]|0;if(!m){hYa(d+708|0);p=c[e>>2]|0}else p=m;c[e>>2]=c[p>>2];e=d+988|0;c[e>>2]=(c[e>>2]|0)+1;e=d+992|0;c[e>>2]=(c[e>>2]|0)+-1;if(!p)q=0;else{b[j>>1]=b[g>>1]|0;gfa(p,o,n,f,j);q=p}nfa(q);c[q+52>>2]=-1;if(c[q+44>>2]&134217728){i=h;return q|0}mfa(q);i=h;return q|0}function qba(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;j=(a[(c[f+28>>2]|0)+64>>0]&4)==0;k=j?f:e;l=j?e:f;f=d+1296|0;e=c[f>>2]|0;if(!e){iYa(d+1004|0);m=c[f>>2]|0}else m=e;c[f>>2]=c[m>>2];f=d+1284|0;c[f>>2]=(c[f>>2]|0)+1;f=d+1288|0;c[f>>2]=(c[f>>2]|0)+-1;if(!m){n=0;qga(n);o=b[g>>1]|0;p=n+56|0;q=b[p>>1]|0;r=q&65535;s=o&65535;t=s&20;u=r&65504;v=u|t;w=v&65535;b[p>>1]=w;i=h;return n|0}c[m>>2]=466432;b[m+4>>1]=-1;b[m+6>>1]=1;Gia(m+8|0,c[l+8>>2]|0,c[k+8>>2]|0,2,5);c[m+32>>2]=l;c[m+36>>2]=k;c[m>>2]=475080;c[m+8>>2]=475124;b[m+56>>1]=32;a[m+58>>0]=0;n=m;qga(n);o=b[g>>1]|0;p=n+56|0;q=b[p>>1]|0;r=q&65535;s=o&65535;t=s&20;u=r&65504;v=u|t;w=v&65535;b[p>>1]=w;i=h;return n|0}function rba(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;if((c[(c[e+8>>2]|0)+28>>2]|0)>>>0<(c[(c[f+8>>2]|0)+28>>2]|0)>>>0){h=Vfa(e)|0;j=h;k=Vfa(f)|0}else{h=Vfa(f)|0;j=h;k=Vfa(e)|0}h=c[j+20>>2]|0;l=c[j+28>>2]|0;m=h+(l<<2)|0;a:do if((l|0)>0){n=h;while(1){o=c[n>>2]|0;p=c[o+4>>2]|0;if((p|0)==(j|0)?(c[o+8>>2]|0)==(k|0):0)q=10;else q=8;if(((q|0)==8?(q=0,(p|0)==(k|0)):0)?(c[o+8>>2]|0)==(j|0):0)q=10;if((q|0)==10?(q=0,(a[o+21>>0]&16)!=0):0)break;n=n+4|0;if(n>>>0>=m>>>0)break a}n=c[o+-8+48>>2]|0;if(n){r=n;i=g;return r|0}}while(0);o=Vfa(e)|0;e=Vfa(f)|0;f=d+408|0;m=c[f>>2]|0;if(!m){jYa(d+116|0);s=c[f>>2]|0}else s=m;c[f>>2]=c[s>>2];f=d+396|0;c[f>>2]=(c[f>>2]|0)+1;f=d+400|0;c[f>>2]=(c[f>>2]|0)+-1;if(!s){r=0;i=g;return r|0}c[s>>2]=o;c[s+4>>2]=e;c[s+8>>2]=q7(o)|0;b[s+12>>1]=0;b[s+14>>1]=0;b[s+16>>1]=0;c[s+20>>2]=0;f=o+46|0;b[f>>1]=(b[f>>1]|0)+1<<16>>16;f=e+46|0;b[f>>1]=(b[f>>1]|0)+1<<16>>16;r=s;i=g;return r|0}function sba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=b+96|0;f=c[e>>2]|0;do if(!f)if(kYa(b+80|0)|0){g=c[e>>2]|0;break}else{h=0;i=d;return h|0}else g=f;while(0);f=g+-1|0;g=c[(c[b+92>>2]|0)+(f<<2)>>2]|0;c[e>>2]=f;f=b+104|0;e=c[g>>2]|0;j=(e+32|0)>>>5;k=b+108|0;if(j>>>0>(c[k>>2]&2147483647)>>>0){l=b+112|0;b=UJa(l,j<<2,543784,339)|0;m=c[f>>2]|0;if((m|0)!=0?(YEi(b|0,m|0,c[k>>2]<<2|0)|0,(c[k>>2]|0)>-1):0)VJa(l,c[f>>2]|0);l=c[k>>2]|0;PEi(b+((l&2147483647)<<2)|0,0,j-l<<2|0)|0;c[f>>2]=b;c[k>>2]=j;n=b}else n=c[f>>2]|0;f=n+(e>>>5<<2)|0;c[f>>2]=c[f>>2]|1<<(e&31);if(!g){h=0;i=d;return h|0}c[g+4>>2]=0;a[g+8>>0]=2;h=g;i=d;return h|0}function tba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=c[b>>2]|0;g=a+104|0;h=(f+32|0)>>>5;j=a+108|0;if(h>>>0>(c[j>>2]&2147483647)>>>0){k=a+112|0;l=UJa(k,h<<2,543784,339)|0;m=c[g>>2]|0;if((m|0)!=0?(YEi(l|0,m|0,c[j>>2]<<2|0)|0,(c[j>>2]|0)>-1):0)VJa(k,c[g>>2]|0);k=c[j>>2]|0;PEi(l+((k&2147483647)<<2)|0,0,h-k<<2|0)|0;c[g>>2]=l;c[j>>2]=h;n=l}else n=c[g>>2]|0;g=n+(f>>>5<<2)|0;c[g>>2]=c[g>>2]&~(1<<(f&31));f=a+92|0;g=a+96|0;n=c[g>>2]|0;if((c[a+100>>2]&2147483647)>>>0<=n>>>0){lYa(f,e)|0;i=d;return}e=(c[f>>2]|0)+(n<<2)|0;if(e)c[e>>2]=b;c[g>>2]=n+1;i=d;return}function uba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+104|0;f=c[a+108>>2]&2147483647;if(!f){g=0;i=d;return g|0}h=c[e>>2]|0;j=0;while(1){k=c[h+(j<<2)>>2]|0;if(k)break;l=j+1|0;if(l>>>0<f>>>0)j=l;else{g=0;m=19;break}}if((m|0)==19){i=d;return g|0}l=c[425648+((da(k&0-k,125613361)|0)>>>27<<2)>>2]|j<<5;n=k+-1&k;a:do if(!n){k=j;while(1){o=k+1|0;if(o>>>0>=f>>>0){p=o;q=0;break a}r=c[h+(o<<2)>>2]|0;if(!r)k=o;else{p=o;q=r;break}}}else{p=j;q=n}while(0);if((l|0)==-1){g=0;i=d;return g|0}n=c[a+80>>2]|0;a=l;l=p;p=q;b:while(1){q=l<<5;j=a;h=p;while(1){s=j&31;t=c[n+(j>>>5<<2)>>2]|0;if((c[t+(s*12|0)+4>>2]|0)==(b|0)){m=18;break b}if(!h){g=0;m=19;break b}j=c[425648+((da(h&0-h,125613361)|0)>>>27<<2)>>2]|q;h=h+-1&h;if(!h){u=l;break}if((j|0)==-1){g=0;m=19;break b}}while(1){u=u+1|0;if(u>>>0>=f>>>0){v=0;break}h=c[(c[e>>2]|0)+(u<<2)>>2]|0;if(h){v=h;break}}if((j|0)==-1){g=0;m=19;break}else{a=j;l=u;p=v}}if((m|0)==18){g=t+(s*12|0)|0;i=d;return g|0}else if((m|0)==19){i=d;return g|0}return 0}function vba(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;j=i;i=i+112|0;k=j+80|0;l=j+64|0;m=j+40|0;n=j+24|0;o=j+96|0;p=j+56|0;q=j+8|0;r=j;s=j+16|0;t=g+28|0;u=d[t>>0]|0;if((u|0)==0|(u|0)==3|(u|0)==2){v=q;c[v>>2]=0;c[v+4>>2]=0;if(!h){v=g+6|0;if(!(b[v>>1]&4)){w=g+32|0;x=g+36|0;y=0}else{z=uba(f,g)|0;A=g+32|0;B=c[A>>2]|0;C=g+36|0;D=c[C>>2]|0;E=c[z>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;co[c[(c[B>>2]|0)+8>>2]&2047](B,o,m);co[c[(c[D>>2]|0)+8>>2]&2047](D,p,n);D=c[(c[f>>2]|0)+1104>>2]|0;B=c[(c[D>>2]|0)+4>>2]|0;F=c[o>>2]|0;G=c[p>>2]|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];Wn[B&127](D,E,F,l,G,k,0);w=A;x=C;y=z}oba(r,f,c[w>>2]|0,c[x>>2]|0,y);y=r;r=c[y>>2]|0;x=c[y+4>>2]|0;y=q;c[y>>2]=r;c[y+4>>2]=x;y=VEi(r|0,x|0,16)|0;H=v;I=x;J=y&65535;K=r&65535}else{r=h;y=c[r>>2]|0;x=c[r+4>>2]|0;r=q;c[r>>2]=y;c[r+4>>2]=x;r=y&65535;v=x;w=VEi(y|0,x|0,16)|0;x=w&65535;y=g+32|0;if((r&13)==13){z=c[y>>2]|0;C=g+36|0;A=c[C>>2]|0;G=c[v>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;co[c[(c[z>>2]|0)+8>>2]&2047](z,o,m);co[c[(c[A>>2]|0)+8>>2]&2047](A,p,n);A=c[(c[f>>2]|0)+1104>>2]|0;z=c[(c[A>>2]|0)+4>>2]|0;F=c[o>>2]|0;E=c[p>>2]|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];Wn[z&127](A,G,F,l,E,k,0);tba(f,v);c[q+4>>2]=0;L=C;M=0}else{L=g+36|0;M=v}v=c[y>>2]|0;y=c[L>>2]|0;L=q+2|0;if(((((Mfa(v)|0)!=0?(a[(c[(Mfa(v)|0)+52>>2]|0)+44>>0]&1)!=0:0)?(Mfa(y)|0)!=0:0)?(a[(c[(Mfa(y)|0)+52>>2]|0)+44>>0]&1)!=0:0)?(w&1|0)!=0:0)N=w&65534;else N=x;b[L>>1]=N;H=g+6|0;I=M;J=N;K=r}r=e[H>>1]|0;if(r&4){N=c[q>>2]|0;M=N&65535;L=N>>>16&65535;if((M&12)!=12?(b[H>>1]=r&65531,(I|0)!=0):0){tba(f,I);c[q+4>>2]=0;O=M;P=L}else{O=M;P=L}}else{O=K;P=J}J=c[g+32>>2]|0;K=c[g+36>>2]|0;L=O&65535;if(!(L&1))if(!(L&2))if(!(a[(c[J+28>>2]|0)+64>>0]&4))Q=(a[(c[K+28>>2]|0)+64>>0]&4)==0?0:2;else Q=2;else Q=3;else Q=6;if((d[t>>0]|0)!=(Q|0)){R=wba(f,g,Q,q)|0;i=j;return R|0}if(!u){q=P&65535;Q=g+44|0;t=c[Q>>2]|0;if((q^t)&32767){do if((t&6291456|0)!=0&(q&8|0)==0){if(!(t&2097152)){c[Q>>2]=t&-4194305;break}K=g+52|0;J=c[K>>2]|0;L=f+28|0;O=c[L>>2]|0;if(J>>>0<O>>>0){M=O+-1|0;I=f+20|0;if((J|0)==(M|0)?1:O>>>0>=(c[I>>2]|0)>>>0){S=O;T=J}else{O=c[f+16>>2]|0;r=c[O+(M<<2)>>2]|0;c[O+(J<<2)>>2]=r;c[r+52>>2]=J;S=c[L>>2]|0;T=M}c[L>>2]=S+-1;U=I;V=c[Q>>2]|0;W=T}else{U=f+20|0;V=t;W=J}c[Q>>2]=V&-2097153;c[K>>2]=-1;K=(c[U>>2]|0)+-1|0;c[U>>2]=K;J=f+16|0;I=c[J>>2]|0;c[I+(W<<2)>>2]=c[I+(K<<2)>>2];if(W>>>0<K>>>0)c[(c[(c[J>>2]|0)+(W<<2)>>2]|0)+52>>2]=W}while(0);if(((t&448|0)!=0&(q&448|0)==0?(q=c[Q>>2]|0,c[Q>>2]=q&-1572865,(q&8388608|0)!=0):0)?(t=g+52|0,W=c[t>>2]|0,c[Q>>2]=q&-9961473,c[t>>2]=-1,t=f+36|0,q=(c[t>>2]|0)+-1|0,c[t>>2]=q,t=f+32|0,U=c[t>>2]|0,c[U+(W<<2)>>2]=c[U+(q<<2)>>2],W>>>0<q>>>0):0)c[(c[(c[t>>2]|0)+(W<<2)>>2]|0)+52>>2]=W}c[Q>>2]=P&32767|c[Q>>2]&-32768;R=g;i=j;return R|0}else if((u|0)==2){Q=g+56|0;b[Q>>1]=e[Q>>1]&65504|P&20;R=g;i=j;return R|0}else{R=g;i=j;return R|0}}else if((u|0)==4){u=c[g+40>>2]|0;do if(!h){P=c[(c[f>>2]|0)+60>>2]|0;Q=u+12|0;if((c[Q>>2]|0)!=(P|0)){c[Q>>2]=P;if(!(b[g+6>>1]&4)){X=g+32|0;Y=g+36|0;Z=0}else{P=uba(f,u)|0;Q=g+32|0;W=c[Q>>2]|0;t=g+36|0;q=c[t>>2]|0;U=c[P>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;co[c[(c[W>>2]|0)+8>>2]&2047](W,o,m);co[c[(c[q>>2]|0)+8>>2]&2047](q,p,n);q=c[(c[f>>2]|0)+1104>>2]|0;W=c[(c[q>>2]|0)+4>>2]|0;V=c[o>>2]|0;T=c[p>>2]|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];Wn[W&127](q,U,V,l,T,k,0);X=Q;Y=t;Z=P}bYa(s,f,c[X>>2]|0,c[Y>>2]|0,Z);P=s;t=c[P>>2]|0;Q=c[P+4>>2]|0;P=VEi(t|0,Q|0,16)|0;a[u+18>>0]=(Q>>>0>0|(Q|0)==0&t>>>0>4294967295)&1;b[u+8>>1]=P;if(t&1){a[u+20>>0]=1;break}P=u+19|0;if(!(t&2)){a[P>>0]=0;break}else{a[P>>0]=1;break}}}else{P=c[h+4>>2]|0;t=P;if(((P|0)!=0?(a[u+20>>0]|0)!=0:0)?mo[c[(c[g>>2]|0)+16>>2]&4095](g)|0:0){P=c[g+32>>2]|0;Q=c[g+36>>2]|0;T=c[t>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;co[c[(c[P>>2]|0)+8>>2]&2047](P,o,m);co[c[(c[Q>>2]|0)+8>>2]&2047](Q,p,n);Q=c[(c[f>>2]|0)+1104>>2]|0;P=c[(c[Q>>2]|0)+4>>2]|0;V=c[o>>2]|0;U=c[p>>2]|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];Wn[P&127](Q,T,V,l,U,k,0);tba(f,t)}}while(0);k=g+6|0;l=e[k>>1]|0;if(!(a[u+18>>0]|0)){if(l&4)b[k>>1]=l&65531}else b[k>>1]=l|4;if(!(a[u+20>>0]|0)){R=g;i=j;return R|0}zba(f,g,0,0);R=0;i=j;return R|0}else{R=0;i=j;return R|0}return 0}function wba(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+16|0;k=j+2|0;l=j;m=c[f+32>>2]|0;n=c[f+36>>2]|0;o=c[f+12>>2]|0;if((a[o+51>>0]&1)==0?(a[o+50>>0]|0)==1:0)F9(o,ea(.399999976));o=c[f+16>>2]|0;if((a[o+51>>0]&1)==0?(a[o+50>>0]|0)==1:0)F9(o,ea(.399999976));if((g|0)==3){o=d+1888|0;p=c[o>>2]|0;if(!p){eYa(d+1596|0);q=c[o>>2]|0}else q=p;c[o>>2]=c[q>>2];o=d+1876|0;c[o>>2]=(c[o>>2]|0)+1;o=d+1880|0;c[o>>2]=(c[o>>2]|0)+-1;if(!q)r=0;else{c[q>>2]=466432;b[q+4>>1]=-1;b[q+6>>1]=1;Gia(q+8|0,c[m+8>>2]|0,c[n+8>>2]|0,3,5);c[q+32>>2]=m;c[q+36>>2]=n;c[q>>2]=464704;c[q+8>>2]=464748;r=q}Saa(r);s=r}else if(!g){b[k>>1]=b[h+2>>1]|0;s=pba(d,m,n,k)|0}else if((g|0)==2){b[l>>1]=b[h+2>>1]|0;s=qba(d,m,n,l)|0}else s=0;l=c[h+4>>2]|0;if(l){h=s+6|0;b[h>>1]=e[h>>1]|4;a[l+8>>0]=0;c[l+4>>2]=s}l=f+6|0;h=e[l>>1]|0;if(!(h&4)){mba(d,f,4,0);i=j;return s|0}b[l>>1]=h&65531;mba(d,f,4,0);i=j;return s|0}function xba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+52|0;f=c[e>>2]|0;g=a+28|0;h=c[g>>2]|0;if(f>>>0<h>>>0){j=h+-1|0;k=a+20|0;if((f|0)==(j|0)?1:h>>>0>=(c[k>>2]|0)>>>0){l=h;m=f}else{h=c[a+16>>2]|0;n=c[h+(j<<2)>>2]|0;c[h+(f<<2)>>2]=n;c[n+52>>2]=f;l=c[g>>2]|0;m=j}c[g>>2]=l+-1;o=k;p=m}else{o=a+20|0;p=f}f=b+44|0;c[f>>2]=c[f>>2]&-2097153;c[e>>2]=-1;e=(c[o>>2]|0)+-1|0;c[o>>2]=e;o=a+16|0;a=c[o>>2]|0;c[a+(p<<2)>>2]=c[a+(e<<2)>>2];if(p>>>0>=e>>>0){i=d;return}c[(c[(c[o>>2]|0)+(p<<2)>>2]|0)+52>>2]=p;i=d;return}function yba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+52|0;f=c[e>>2]|0;g=b+44|0;c[g>>2]=c[g>>2]&-8388609;c[e>>2]=-1;e=a+36|0;g=(c[e>>2]|0)+-1|0;c[e>>2]=g;e=a+32|0;a=c[e>>2]|0;c[a+(f<<2)>>2]=c[a+(g<<2)>>2];if(f>>>0>=g>>>0){i=d;return}c[(c[(c[e>>2]|0)+(f<<2)>>2]|0)+52>>2]=f;i=d;return}function zba(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=c[d+40>>2]|0;j=h+16|0;k=(b[j>>1]|0)+-1<<16>>16;b[j>>1]=k;if((k<<16>>16==0?(k=a+412|0,(h|0)!=0):0)?(j=a+692|0,c[j>>2]=(c[j>>2]|0)+-1,j=a+704|0,c[h>>2]=c[j>>2],c[j>>2]=h,h=a+696|0,j=c[h>>2]|0,c[h>>2]=j+1,(j|0)>=((c[a+688>>2]|0)*50|0)):0){mYa(k);c[h>>2]=0}Aga(d,(e&3|0)==3,f);if(!d){i=g;return}ko[c[c[d>>2]>>2]&4095](d);f=a+2172|0;c[f>>2]=(c[f>>2]|0)+-1;f=a+2184|0;c[d>>2]=c[f>>2];c[f>>2]=d;d=a+2176|0;f=c[d>>2]|0;c[d>>2]=f+1;if((f|0)<((c[a+2168>>2]|0)*50|0)){i=g;return}nYa(a+1892|0);c[d>>2]=0;i=g;return}function Aba(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;f=(c[a>>2]|0)+1212|0;g=c[f>>2]|0;h=c[g+96>>2]|0;if(!h){i=d;return}j=h<<2>>2;h=c[g+40>>2]|0;g=0;while(1){k=c[h>>2]|0;if(!k)l=0;else l=k+-8|0;Bba(a,l,0,0);k=l+56|0;m=e[k>>1]|0;do if(m&32){b[k>>1]=m&65503;if(_n[c[(c[l>>2]|0)+20>>2]&4095](l,0)|0){n=h+4|0;break}else{Sia(c[f>>2]|0,(l|0)==0?0:l+8|0);n=h;break}}else n=h+4|0;while(0);g=g+1|0;if((g|0)==(j|0))break;else h=n}i=d;return}function Bba(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+96|0;j=h+68|0;k=h+40|0;l=h+16|0;m=h;n=c[e+32>>2]|0;o=c[e+36>>2]|0;p=b[e+56>>1]|0;if(f)if(g){a[(c[d>>2]|0)+100>>0]=1;q=0}else q=0;else{g=n+28|0;f=o+28|0;r=(c[(c[d>>2]|0)+1192>>2]|0)+((c[(c[g>>2]|0)+68>>2]|0)*28|0)+(c[(c[f>>2]|0)+68>>2]<<2)+48|0;c[r>>2]=(c[r>>2]|0)+1;r=(c[(c[g>>2]|0)+68>>2]|0)>(c[(c[f>>2]|0)+68>>2]|0);f=r?o:n;g=r?n:o;r=g+28|0;s=c[(c[r>>2]|0)+68>>2]|0;t=f+28|0;u=c[(c[t>>2]|0)+68>>2]|0;v=c[(uMa()|0)+(u*28|0)+(s<<2)>>2]|0;s=(c[t>>2]|0)+68|0;Ifa(j,f);f=(c[r>>2]|0)+68|0;Ifa(k,g);q=Bn[v&255](s,j,f,k,e+40|0)|0}k=e+58|0;if(!(a[k>>0]|0))w=q?4:0;else w=q?0:16;if(!((w&p)<<16>>16)){x=q&1;a[k>>0]=x;i=h;return}a[l+20>>0]=0;c[l>>2]=dfa(c[n+28>>2]|0)|0;c[l+8>>2]=dfa(c[o+28>>2]|0)|0;c[l+16>>2]=w&65535;w=c[(Vfa(n)|0)+52>>2]|0;p=c[(Vfa(o)|0)+52>>2]|0;c[l+4>>2]=Zba(w)|0;c[l+12>>2]=Zba(p)|0;e=c[o+20>>2]|0;o=a[w+13>>0]|0;f=a[p+13>>0]|0;j=a[w+11>>0]|0;w=a[p+11>>0]|0;c[m>>2]=c[n+20>>2];c[m+4>>2]=e;a[m+8>>0]=o;a[m+9>>0]=f;a[m+10>>0]=j;a[m+11>>0]=w;w=c[d>>2]|0;j=w+84|0;f=w+88|0;o=c[f>>2]|0;if((c[w+92>>2]&2147483647)>>>0>o>>>0){w=c[j>>2]|0;e=w+(o*24|0)|0;if(!e)y=o;else{c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];c[e+16>>2]=c[l+16>>2];a[w+(o*24|0)+20>>0]=0;y=c[f>>2]|0}c[f>>2]=y+1}else oYa(j,l)|0;l=c[(c[d>>2]|0)+96>>2]|0;d=l+4|0;j=c[d>>2]|0;if((c[l+8>>2]&2147483647)>>>0<=j>>>0){pYa(l,m)|0;x=q&1;a[k>>0]=x;i=h;return}y=(c[l>>2]|0)+(j*12|0)|0;if(!y)z=j;else{c[y+0>>2]=c[m+0>>2];c[y+4>>2]=c[m+4>>2];c[y+8>>2]=c[m+8>>2];z=c[d>>2]|0}c[d>>2]=z+1;x=q&1;a[k>>0]=x;i=h;return}function Cba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[a>>2]|0;if(ea(g[e+1416>>2])==ea(0.0)){i=d;return}a=c[e+1212>>2]|0;e=c[a+16>>2]|0;f=c[a+88>>2]|0;a=e+(f<<2)|0;if((f|0)<=0){i=d;return}h=e+(f+-1<<2)|0;f=e;j=e+16|0;while(1){if(j>>>0>h>>>0)k=j;else k=j+4|0;e=c[f>>2]|0;if(!e)l=0;else l=e+-8|0;hfa(l,b);f=f+4|0;if(f>>>0>=a>>>0)break;else j=k}i=d;return}function Dba(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+28>>2]|0;if(!d){i=b;return}e=d;d=c[a+16>>2]|0;while(1){e=e+-1|0;a=c[d>>2]|0;f=(e|0)==0;if(c[a+44>>2]&8)jfa(a,8,0,0,0,0);if(f)break;else d=d+4|0}i=b;return}function Eba(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+48|0;g=f+32|0;h=f+36|0;j=f+40|0;k=f+42|0;l=f+8|0;m=f;n=f+16|0;o=c[d>>2]|0;p=c[o+1184>>2]|0;q=o+1176|0;o=c[q>>2]|0;r=c[q+4>>2]|0;Dn[c[(c[p>>2]|0)+8>>2]&511](p,109,o,r);q=c[(c[d>>2]|0)+1104>>2]|0;if(!q){s=c[p>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](p,109,o,r);i=f;return}b[j>>1]=0;b[k>>1]=0;if(!(kn[c[(c[q>>2]|0)+8>>2]&511](q,h,k,j)|0)){s=c[p>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](p,109,o,r);i=f;return}v=d+80|0;w=l+2|0;x=l+4|0;y=m+4|0;z=m+2|0;A=n+8|0;do{B=c[h>>2]|0;C=B&31;D=c[(c[v>>2]|0)+(B>>>5<<2)>>2]|0;B=D+(C*12|0)|0;E=b[j>>1]|0;if((E&3)==3){dKa(bKa()|0,2,464776,882,466448,g);F=E&65534}else F=E;b[j>>1]=F;E=D+(C*12|0)+4|0;if(!(a[D+(C*12|0)+8>>0]|0)){C=c[E>>2]|0;D=l;c[D>>2]=0;c[D+4>>2]=0;b[l>>1]=F;b[w>>1]=b[k>>1]|0;c[x>>2]=B;if((vba(d,C,l)|0)==(C|0)){D=C+4|0;b[D>>1]=e[D>>1]|1;D=C+6|0;if(!(b[D>>1]&2)){Oaa(C);b[D>>1]=e[D>>1]|2}ko[c[(c[C>>2]|0)+8>>2]&4095](C)}}else{C=c[E>>2]|0;E=m;c[E>>2]=0;c[E+4>>2]=0;if((F&12)==12){c[y>>2]=B;G=F}else{tba(d,B);a[C+18>>0]=0;G=b[j>>1]|0}b[m>>1]=G;B=b[k>>1]|0;b[z>>1]=B;b[C+8>>1]=B;B=e[j>>1]|0;if(!(B&1)){if(B&2)a[C+19>>0]=1}else a[C+20>>0]=1;B=c[C>>2]|0;E=c[C+4>>2]|0;C=c[E+8>>2]|0;D=c[C+20>>2]|0;H=D+(c[C+28>>2]<<2)|0;C=n;c[C>>2]=D;c[C+4>>2]=H;c[A>>2]=E;H=Bia(n)|0;if(H){C=H;do{if((((a[C+21>>0]&8)!=0?(H=C+-8|0,(c[H+36>>2]|0)==(E|0)):0)?(c[H+12>>2]|0)==(B|0):0)?(vba(d,H,m)|0)==(H|0):0)ko[c[(c[H>>2]|0)+8>>2]&4095](H);C=Bia(n)|0}while((C|0)!=0)}}}while(kn[c[(c[q>>2]|0)+8>>2]&511](q,h,k,j)|0);s=c[p>>2]|0;t=s+12|0;u=c[t>>2]|0;Dn[u&511](p,109,o,r);i=f;return}function Fba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=a+68|0;g=a+72|0;h=c[g>>2]|0;if((c[a+76>>2]&2147483647)>>>0<=h>>>0){qYa(f,e)|0;i=d;return}e=(c[f>>2]|0)+(h<<2)|0;if(e)c[e>>2]=b;c[g>>2]=h+1;i=d;return}function Gba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+72|0;f=c[e>>2]|0;if(!f){g=0;i=d;return g|0}h=c[a+68>>2]|0;a=0;while(1){j=h+(a<<2)|0;a=a+1|0;if((c[j>>2]|0)==(b|0))break;if(a>>>0>=f>>>0){g=0;k=6;break}}if((k|0)==6){i=d;return g|0}k=f+-1|0;c[e>>2]=k;c[j>>2]=c[h+(k<<2)>>2];g=1;i=d;return g|0}function Hba(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;f=c[a>>2]|0;a:do if(c[f+1196>>2]&6){g=c[f+1212>>2]|0;h=541280;do{j=c[h>>2]|0;k=c[g+(j*12|0)+16>>2]|0;l=c[g+(j*12|0)+20>>2]|0;h=h+4|0}while((l|0)<1&h>>>0<(541292|0)>>>0);j=k+(l<<2)|0;m=k;n=h;b:while(1){o=j;while(1){if(m>>>0>=o>>>0)break a;p=o+-4|0;q=c[p>>2]|0;if(!q)r=0;else r=q+-8|0;q=r+4|0;b[q>>1]=e[q>>1]|0|65534;s=r+6|0;t=b[s>>1]|0;if(!(t&2)){Oaa(r);u=(e[s>>1]|0|2)&65535;b[s>>1]=u;v=u}else v=t;if(!(((v&1)!=0?(b[q>>1]&1)!=0:0)?(vba(a,r,0)|0)!=(r|0):0))ko[c[(c[r>>2]|0)+8>>2]&4095](r);if(m>>>0<p>>>0)o=p;else{w=n;x=p;y=m;break}}while(1){if(w>>>0>=(541292|0)>>>0){j=x;m=y;n=w;continue b}o=c[w>>2]|0;p=c[g+(o*12|0)+16>>2]|0;q=c[g+(o*12|0)+20>>2]|0;o=p+(q<<2)|0;t=w+4|0;if((q|0)>0){j=o;m=p;n=t;continue b}else{w=t;x=o;y=p}}}}while(0);y=a+72|0;x=c[y>>2]|0;if(!x){c[y>>2]=0;i=d;return}w=a+68|0;r=x;do{r=r+-1|0;x=c[(c[w>>2]|0)+(r<<2)>>2]|0;if(!(((b[x+6>>1]&1)!=0?(b[x+4>>1]&1)!=0:0)?(vba(a,x,0)|0)!=(x|0):0))ko[c[(c[x>>2]|0)+8>>2]&4095](x)}while((r|0)!=0);c[y>>2]=0;i=d;return}function Iba(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=d+48|0;k=c[j>>2]|0;l=d+44|0;m=c[l>>2]|0;if(!((m&476|0)==0|(m&32768|0)==0)){n=(f&1|0)!=0;o=(m>>>11&256|16)&m;if(o)jfa(d,o,(b[k+14>>1]|0)==1?8:0,n,1,g);if(n){n=c[j>>2]|0;j=n+20|0;g=c[j>>2]|0;if(!g){m7(n);p=c[j>>2]|0}else p=g;if(b[p+10>>1]&8)ifa(d,p)}}p=c[l>>2]|0;if(!(p&32768)){l=c[d+56>>2]|0;if(!l)q=p&98304;else q=e[l+114>>1]&3;if(!q)r=14}else r=14;do if((r|0)==14?(q=Mfa(c[d+32>>2]|0)|0,l=Mfa(c[d+36>>2]|0)|0,(f&4|0)!=0):0){p=(q|0)==0;g=(l|0)==0;if(!(p|g)){mda(c[a>>2]|0,q,l);break}if(!p)F9(q,ea(.399999976));if(!g)F9(l,ea(.399999976))}while(0);ko[c[(c[d>>2]|0)+24>>2]&4095](d);f=a+708|0;if((d|0)!=0?(ko[c[c[d>>2]>>2]&4095](d),r=a+988|0,c[r>>2]=(c[r>>2]|0)+-1,r=a+1e3|0,c[d>>2]=c[r>>2],c[r>>2]=d,d=a+992|0,r=c[d>>2]|0,c[d>>2]=r+1,(r|0)>=((c[a+984>>2]|0)*50|0)):0){rYa(f);c[d>>2]=0}if(b[k+16>>1]|0){i=h;return}if(!k){i=h;return}if(c[k+20>>2]|0)l7(k);d=(c[k>>2]|0)+46|0;b[d>>1]=(b[d>>1]|0)+-1<<16>>16;d=(c[k+4>>2]|0)+46|0;b[d>>1]=(b[d>>1]|0)+-1<<16>>16;d=a+396|0;c[d>>2]=(c[d>>2]|0)+-1;d=a+408|0;c[k>>2]=c[d>>2];c[d>>2]=k;k=a+400|0;d=c[k>>2]|0;c[k>>2]=d+1;if((d|0)<((c[a+392>>2]|0)*50|0)){i=h;return}_Xa(a+116|0);c[k>>2]=0;i=h;return}function Jba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;g=b+44|0;c[g>>2]=c[g>>2]|2097152;g=a+16|0;h=a+20|0;j=c[h>>2]|0;k=a+28|0;l=c[k>>2]|0;if((j|0)==(l|0)){c[b+52>>2]=j;m=c[h>>2]|0;if((c[a+24>>2]&2147483647)>>>0<=m>>>0){sYa(g,e)|0;n=c[k>>2]|0;o=n+1|0;c[k>>2]=o;i=d;return}e=(c[g>>2]|0)+(m<<2)|0;if(e)c[e>>2]=b;c[h>>2]=m+1;n=c[k>>2]|0;o=n+1|0;c[k>>2]=o;i=d;return}else{m=c[g>>2]|0;e=c[m+(l<<2)>>2]|0;c[f>>2]=e;c[e+52>>2]=j;j=c[h>>2]|0;if((c[a+24>>2]&2147483647)>>>0>j>>>0){a=m+(j<<2)|0;if(a)c[a>>2]=e;c[h>>2]=j+1}else sYa(g,f)|0;c[b+52>>2]=c[k>>2];c[(c[g>>2]|0)+(c[k>>2]<<2)>>2]=b;n=c[k>>2]|0;o=n+1|0;c[k>>2]=o;i=d;return}}function Kba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=b+44|0;c[f>>2]=c[f>>2]|2097152;f=a+16|0;g=a+20|0;c[b+52>>2]=c[g>>2];h=c[g>>2]|0;if((c[a+24>>2]&2147483647)>>>0<=h>>>0){sYa(f,e)|0;i=d;return}e=(c[f>>2]|0)+(h<<2)|0;if(e)c[e>>2]=b;c[g>>2]=h+1;i=d;return}function Lba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=b+44|0;c[f>>2]=c[f>>2]|8388608;f=a+32|0;g=a+36|0;c[b+52>>2]=c[g>>2];h=c[g>>2]|0;if((c[a+40>>2]&2147483647)>>>0<=h>>>0){sYa(f,e)|0;i=d;return}e=(c[f>>2]|0)+(h<<2)|0;if(e)c[e>>2]=b;c[g>>2]=h+1;i=d;return}function Mba(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g+1|0;j=g;k=b+44|0;l=((((e&15|0)!=0&1)<<4)+e&-16)+(d<<5)|0;d=b+48|0;e=c[d>>2]|0;m=e+15&-16;c[f>>2]=m;n=b+52|0;o=c[n>>2]|0;if((m+l|0)>>>0>o>>>0){if(!(a[b+64>>0]|0))p=o;else{q=0;i=g;return q|0}do{p=p<<1;c[n>>2]=p}while(((c[f>>2]|0)+l|0)>>>0>p>>>0);n=UJa(h,p,474544,167)|0;YEi(n|0,c[k>>2]|0,o|0)|0;VJa(j,c[k>>2]|0);c[k>>2]=n;r=n;s=c[f>>2]|0}else{r=c[k>>2]|0;s=m}c[b+60>>2]=s;c[d>>2]=l-e+m+(c[d>>2]|0);q=r+s|0;i=g;return q|0}function Nba(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+16|0;k=j+2|0;l=j+1|0;m=j;n=d+44|0;o=(((g&15|0)!=0&1)<<4)+g|0;g=o&-16;p=g+(f<<5)|0;q=c[h>>2]|0;r=d+60|0;if((c[r>>2]|0)==(q|0)){s=d+48|0;c[s>>2]=q;t=q+15&-16;u=t+p|0;v=d+52|0;w=c[v>>2]|0;if(u>>>0>w>>>0){if(!(a[d+64>>0]|0))x=w;else{y=0;i=j;return y|0}do x=x<<1;while(u>>>0>x>>>0);c[v>>2]=x;v=UJa(k,x,474544,167)|0;YEi(v|0,c[n>>2]|0,w|0)|0;VJa(m,c[n>>2]|0);c[n>>2]=v;z=v;A=c[s>>2]|0}else{z=c[n>>2]|0;A=q}c[r>>2]=t;c[s>>2]=p-q+t+A;B=z+t|0;C=t}else{t=d+48|0;z=c[t>>2]|0;A=z+15&-16;q=A+p|0;s=d+52|0;v=c[s>>2]|0;if(q>>>0>v>>>0){if(!(a[d+64>>0]|0))D=v;else{y=0;i=j;return y|0}do D=D<<1;while(q>>>0>D>>>0);c[s>>2]=D;s=UJa(k,D,474544,167)|0;YEi(s|0,c[n>>2]|0,v|0)|0;VJa(l,c[n>>2]|0);c[n>>2]=s;E=s;F=c[t>>2]|0}else{E=c[n>>2]|0;F=z}c[r>>2]=A;c[t>>2]=p-z+A+F;B=E+A|0;C=A}A=c[n>>2]|0;n=c[h>>2]|0;E=A+n|0;if(!B){y=0;i=j;return y|0}F=h+10|0;z=e[F>>1]&65520;p=g>>>0>z>>>0;if((n|0)==(C|0)){if(p)aFi(B+g|0,A+(z+C)|0,e[h+6>>1]<<5|0)|0}else{if(p){YEi(B|0,E|0,e[h+8>>1]|0)|0;YEi(B+g|0,A+(z+n)|0,e[h+6>>1]<<5|0)|0}else YEi(B|0,E|0,(e[h+6>>1]<<5)+z|0)|0;c[h>>2]=C}C=h+4|0;if((e[C>>1]|0)>>>0<f>>>0)b[C>>1]=f;if(!p){y=B;i=j;return y|0}b[F>>1]=e[F>>1]&15|o&65520;y=B;i=j;return y|0}function Oba(d){d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d+1592|0;g=c[f>>2]|0;if(!g){tYa(d+1300|0);h=c[f>>2]|0}else h=g;c[f>>2]=c[h>>2];f=d+1580|0;c[f>>2]=(c[f>>2]|0)+1;f=d+1584|0;c[f>>2]=(c[f>>2]|0)+-1;if(!h){j=0;i=e;return j|0}b[h+4>>1]=0;b[h+10>>1]=0;c[h+12>>2]=-1;c[h+16>>2]=-1;c[h+20>>2]=-1;c[h+24>>2]=0;c[h+28>>2]=0;a[h+32>>0]=-1;a[h+33>>0]=-1;a[h+34>>0]=0;a[h+35>>0]=0;j=h;i=e;return j|0}function Pba(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){i=d;return}e=a+1580|0;c[e>>2]=(c[e>>2]|0)+-1;e=a+1592|0;c[b>>2]=c[e>>2];c[e>>2]=b;b=a+1584|0;e=c[b>>2]|0;c[b>>2]=e+1;if((e|0)<((c[a+1576>>2]|0)*50|0)){i=d;return}uYa(a+1300|0);c[b>>2]=0;i=d;return}function Qba(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=0;c[116650]=a;apa();i=d;return}function Rba(a){a=a|0;var b=0,d=0;b=i;d=c[a+12>>2]|0;if(d)ko[c[(c[d>>2]|0)+4>>2]&4095](d);bpa();c[116650]=0;i=b;return}function Sba(a){a=a|0;var b=0,d=0;b=i;d=a+12|0;if(c[d>>2]|0){i=b;return}c[d>>2]=Ula(0,0)|0;i=b;return}function Tba(a,b){a=a|0;b=b|0;var c=0;c=i;d7(a,b,1,0,0,0);i=c;return}function Uba(a){a=a|0;return}function Vba(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+4>>2]|0;if(!e){i=d;return}Zda(q7(e)|0,e,b);i=d;return}function Wba(a){a=a|0;return c[a+4>>2]|0}function Xba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+4>>2]|0;if(!f){i=e;return}a=cca(f,b)|0;Sda(q7(f)|0,a,d);i=e;return}function Yba(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=c[b+4>>2]|0;if(!j){i=g;return}b=cca(j,d)|0;d=c[e>>2]|0;if(!(d&1))k=d;else{Zfa(b);k=c[e>>2]|0}if(!(k&2))l=k;else{Rfa(b);l=c[e>>2]|0}if(!(l&128))m=l;else{Qfa(b);m=c[e>>2]|0}if(!(m&4))n=m;else{Yfa(b);n=c[e>>2]|0}if(!(n&8))o=n;else{Pfa(b);o=c[e>>2]|0}if(!(o&64))p=o;else{a[h>>0]=a[f>>0]|0;Tfa(b,h);p=c[e>>2]|0}if(!(p&32)){i=g;return}Sfa(b);i=g;return}function Zba(a){a=a|0;var b=0,c=0,e=0;b=i;c=d[a+10>>0]|0;if((c|0)==1)e=_Z(a)|0;else if(!c)e=M_(a)|0;else if((c|0)==4)e=IW(a)|0;else e=0;i=b;return e|0}function _ba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;n7(a,b,d,e);c[a>>2]=466624;e=c[b+1208>>2]|0;b=e+8|0;d=c[b>>2]|0;if(!d){g=c[e>>2]|0;c[e>>2]=g+1;h=g;j=a+56|0;c[j>>2]=h;i=f;return}else{g=d+-1|0;d=c[(c[e+4>>2]|0)+(g<<2)>>2]|0;c[b>>2]=g;h=d;j=a+56|0;c[j>>2]=h;i=f;return}}function $ba(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=466624;d=c[(q7(a)|0)+1208>>2]|0;vYa(d,c[a+56>>2]|0);p7(a);VJa(b,a);i=b;return}function aca(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=466624;d=c[(q7(a)|0)+1208>>2]|0;vYa(d,c[a+56>>2]|0);p7(a);i=b;return}function bca(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+32>>2]|0;if(!d){i=b;return}else e=d;do{if(0==0?(c[e+12>>2]&-1073741824|0)==0:0)Yfa(e);e=c[e+4>>2]|0}while((e|0)!=0);i=b;return}function cca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Afa(e,a);while(1){a=zfa(e)|0;if(!a){f=1;g=4;break}if((c[a+28>>2]|0)==(b|0)){f=a;g=4;break}}if((g|0)==4){i=d;return f|0}return 0}function dca(a){a=a|0;var b=0,d=0;b=i;d=Zba(c[a+52>>2]|0)|0;i=b;return d|0}function eca(d,f,h){d=d|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=0,J=0,K=0;j=i;i=i+32|0;k=j+18|0;l=j+4|0;m=j+17|0;n=j;o=j+16|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;p=d+44|0;c[p>>2]=1;g[d+48>>2]=ea(0.0);g[d+52>>2]=ea(0.0);g[d+56>>2]=ea(0.0);c[d+60>>2]=1;q=d+64|0;c[d+84>>2]=0;c[d+88>>2]=0;c[d+92>>2]=0;a[d+100>>0]=0;r=d+176|0;s=d+204|0;t=d+460|0;u=d+464|0;c[d+468>>2]=0;v=d+472|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;q=d+104|0;w=q+48|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(w|0));c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;a[t>>0]=1;c[u>>2]=s;c[v>>2]=64;c[d+476>>2]=64;c[d+480>>2]=0;c[d+484>>2]=0;c[d+488>>2]=8192;c[d+492>>2]=0;c[d+764>>2]=0;a[d+756>>0]=1;c[d+760>>2]=d+500;c[d+768>>2]=64;c[d+772>>2]=32;c[d+776>>2]=0;c[d+780>>2]=0;c[d+784>>2]=8192;c[d+788>>2]=0;c[d+1060>>2]=0;a[d+1052>>0]=1;c[d+1056>>2]=d+796;c[d+1064>>2]=64;c[d+1068>>2]=21;c[d+1072>>2]=0;c[d+1076>>2]=0;c[d+1080>>2]=8192;c[d+1084>>2]=0;v=d+1088|0;c[v>>2]=0;s=UJa(k,4115,474640,61)|0;if(!s)x=0;else{u=s+19&-16;c[u+-4>>2]=u-s;x=u}c[d+1120>>2]=x;c[d+1124>>2]=128;u=0;do{c[x+(u<<5)+20>>2]=-1;u=u+1|0}while((u|0)!=128);u=d+1136|0;x=d+1140|0;s=f+100|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;t=b[s>>1]|0;a[d+1162>>0]=(t&65535)>>>14&1;r=d+1164|0;c[r>>2]=0;y=d+1168|0;c[y>>2]=0;z=d+1172|0;c[z>>2]=0;A=d+1176|0;B=h;C=c[B+4>>2]|0;D=A;c[D>>2]=c[B>>2];c[D+4>>2]=C;c[d+1184>>2]=c[h+8>>2];c[d+1196>>2]=0;b[d+1200>>1]=t;t=d+1216|0;c[t>>2]=0;h=d+1244|0;C=d+1272|0;g[d+1416>>2]=ea(0.0);a[d+1420>>0]=0;c[d+1424>>2]=0;c[d+1428>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[d+1460>>2]=c[f+152>>2];wYa(d+1464|0,466648);C=d+1556|0;b[d+1560>>1]=-1;b[d+1562>>1]=0;c[d+1564>>2]=0;c[C>>2]=443968;c[d+1568>>2]=0;c[d+1572>>2]=0;c[C>>2]=474280;c[d+1576>>2]=d;c[d+1580>>2]=466680;C=d+1584|0;b[d+1588>>1]=-1;b[d+1590>>1]=0;c[d+1592>>2]=0;c[C>>2]=443968;c[d+1596>>2]=0;c[d+1600>>2]=0;c[C>>2]=474232;c[d+1604>>2]=d;c[d+1608>>2]=466712;wYa(d+1612|0,466744);C=d+1704|0;wYa(C,466776);c[C>>2]=474184;c[d+1796>>2]=d;C=d+1800|0;wYa(C,466808);c[C>>2]=474136;c[d+1892>>2]=d;C=d+1896|0;b[d+1900>>1]=-1;b[d+1902>>1]=0;c[d+1904>>2]=0;c[C>>2]=443968;c[d+1908>>2]=0;c[d+1912>>2]=0;c[C>>2]=474088;c[d+1916>>2]=d;c[d+1920>>2]=466840;C=d+1964|0;h=d+1968|0;q=d+1924|0;w=q+36|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(w|0));b[h>>1]=-1;b[d+1970>>1]=0;c[d+1972>>2]=0;c[C>>2]=443968;c[d+1976>>2]=0;c[d+1980>>2]=0;c[C>>2]=474040;c[d+1984>>2]=d;c[d+1988>>2]=466872;C=d+1992|0;b[d+1996>>1]=-1;b[d+1998>>1]=0;c[d+2e3>>2]=0;c[C>>2]=443968;c[d+2004>>2]=0;c[d+2008>>2]=0;c[C>>2]=473992;c[d+2012>>2]=d;c[d+2016>>2]=466896;C=d+2020|0;b[d+2024>>1]=-1;b[d+2026>>1]=0;c[d+2028>>2]=0;c[C>>2]=443968;c[d+2032>>2]=0;c[d+2036>>2]=0;c[C>>2]=473944;c[d+2040>>2]=d;c[d+2044>>2]=466928;C=d+2048|0;b[d+2052>>1]=-1;b[d+2054>>1]=0;c[d+2056>>2]=0;c[C>>2]=443968;c[d+2060>>2]=0;c[d+2064>>2]=0;c[C>>2]=473896;c[d+2068>>2]=d;c[d+2072>>2]=466968;C=d+2076|0;b[d+2080>>1]=-1;b[d+2082>>1]=0;c[d+2084>>2]=0;c[C>>2]=443968;c[d+2088>>2]=0;c[d+2092>>2]=0;c[C>>2]=473848;c[d+2096>>2]=d;c[d+2100>>2]=467e3;C=d+2104|0;b[d+2108>>1]=-1;b[d+2110>>1]=0;c[d+2112>>2]=0;c[C>>2]=443968;c[d+2116>>2]=0;c[d+2120>>2]=0;c[C>>2]=473800;c[d+2124>>2]=d;c[d+2128>>2]=467032;C=d+2132|0;b[d+2136>>1]=-1;b[d+2138>>1]=0;c[d+2140>>2]=0;c[C>>2]=443968;c[d+2144>>2]=0;c[d+2148>>2]=0;c[C>>2]=473752;c[d+2152>>2]=d;c[d+2156>>2]=467056;C=d+2160|0;wYa(C,467088);c[C>>2]=473704;c[d+2252>>2]=d;C=d+2256|0;b[d+2260>>1]=-1;b[d+2262>>1]=0;c[d+2264>>2]=0;c[C>>2]=443968;c[d+2268>>2]=0;c[d+2272>>2]=0;c[C>>2]=473656;c[d+2276>>2]=d;c[d+2280>>2]=467120;C=d+2284|0;b[d+2288>>1]=-1;b[d+2290>>1]=0;c[d+2292>>2]=0;c[C>>2]=443968;c[d+2296>>2]=0;c[d+2300>>2]=0;c[C>>2]=473608;c[d+2304>>2]=d;c[d+2308>>2]=467144;C=d+2312|0;b[d+2316>>1]=-1;b[d+2318>>1]=0;c[d+2320>>2]=0;c[C>>2]=443968;c[d+2324>>2]=0;c[d+2328>>2]=0;c[C>>2]=473560;c[d+2332>>2]=d;c[d+2336>>2]=467168;C=d+2340|0;VWa(C,16384);a[d+2372>>0]=0;c[d+2376>>2]=0;q=d+152|0;w=q+24|0;do{a[q>>0]=0;q=q+1|0}while((q|0)<(w|0));q=mKa()|0;w=c[(c[q>>2]|0)+8>>2]|0;h=pKa()|0;D=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[w&255](q,1012,D?473424:544544,467192,182)|0;Hia(h,d);D=d+1212|0;c[D>>2]=h;h=mKa()|0;q=c[(c[h>>2]|0)+8>>2]|0;w=pKa()|0;B=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;w=Bn[q&255](h,188,B?473312:544544,467192,183)|0;_fa(w);c[d+1192>>2]=w;w=mKa()|0;B=c[(c[w>>2]|0)+8>>2]|0;h=pKa()|0;q=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[B&255](w,40,q?473184:544544,467192,184)|0;c[h+28>>2]=0;c[h+32>>2]=0;c[h+36>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[d+1204>>2]=h;h=mKa()|0;q=c[(c[h>>2]|0)+8>>2]|0;w=pKa()|0;B=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;w=Bn[q&255](h,40,B?473184:544544,467192,185)|0;c[w+28>>2]=0;c[w+32>>2]=0;c[w+36>>2]=0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;c[d+1208>>2]=w;w=UJa(m,12,467192,187)|0;c[d+96>>2]=w;if(w){c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0}w=mKa()|0;m=c[(c[w>>2]|0)+8>>2]|0;B=pKa()|0;h=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;B=Bn[m&255](w,32,h?473008:544544,467192,190)|0;c[B>>2]=64;c[B+4>>2]=60;h=B+8|0;w=B+12|0;m=B+16|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;a[B+24>>0]=1;c[B+28>>2]=467280;c[l+4>>2]=0;c[l+8>>2]=0;c[l>>2]=UJa(k,3840,468528,60)|0;h=c[m>>2]|0;if((c[B+20>>2]&2147483647)>>>0>h>>>0){q=(c[w>>2]|0)+(h*12|0)|0;if(!q)E=h;else{c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];E=c[m>>2]|0}c[m>>2]=E+1}else xYa(w,l)|0;w=d+1224|0;c[w>>2]=B;B=mKa()|0;E=c[(c[B>>2]|0)+8>>2]|0;m=pKa()|0;q=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[E&255](B,32,q?472832:544544,467192,191)|0;c[m>>2]=64;c[m+4>>2]=192;q=m+8|0;B=m+12|0;E=m+16|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;a[m+24>>0]=1;c[m+28>>2]=467296;c[l+4>>2]=0;c[l+8>>2]=0;c[l>>2]=UJa(k,12288,468528,60)|0;q=c[E>>2]|0;if((c[m+20>>2]&2147483647)>>>0>q>>>0){h=(c[B>>2]|0)+(q*12|0)|0;if(!h)F=q;else{c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];F=c[E>>2]|0}c[E>>2]=F+1}else xYa(B,l)|0;c[d+1228>>2]=m;m=mKa()|0;B=c[(c[m>>2]|0)+8>>2]|0;F=pKa()|0;E=mo[c[(c[F>>2]|0)+24>>2]&4095](F)|0;F=Bn[B&255](m,32,E?472656:544544,467192,192)|0;c[F>>2]=64;c[F+4>>2]=32;E=F+8|0;m=F+12|0;B=F+16|0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;a[F+24>>0]=1;c[F+28>>2]=467304;c[l+4>>2]=0;c[l+8>>2]=0;c[l>>2]=UJa(k,2048,468528,60)|0;k=c[B>>2]|0;if((c[F+20>>2]&2147483647)>>>0>k>>>0){E=(c[m>>2]|0)+(k*12|0)|0;if(!E)G=k;else{c[E+0>>2]=c[l+0>>2];c[E+4>>2]=c[l+4>>2];c[E+8>>2]=c[l+8>>2];G=c[B>>2]|0}c[B>>2]=G+1}else xYa(m,l)|0;c[d+1220>>2]=F;F=mKa()|0;l=c[(c[F>>2]|0)+8>>2]|0;m=pKa()|0;G=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[l&255](F,296,G?472360:544544,467192,193)|0;c[m+268>>2]=0;a[m+260>>0]=1;c[m+264>>2]=m+4;c[m+272>>2]=64;c[m+276>>2]=32;c[m+280>>2]=0;c[m+284>>2]=0;c[m+288>>2]=4096;c[m+292>>2]=0;c[d+1232>>2]=m;m=mKa()|0;G=c[(c[m>>2]|0)+8>>2]|0;F=pKa()|0;l=mo[c[(c[F>>2]|0)+24>>2]&4095](F)|0;F=Bn[G&255](m,296,l?472032:544544,467192,194)|0;c[F+268>>2]=0;a[F+260>>0]=1;c[F+264>>2]=F+4;c[F+272>>2]=64;c[F+276>>2]=32;c[F+280>>2]=0;c[F+284>>2]=0;c[F+288>>2]=1280;c[F+292>>2]=0;c[d+1236>>2]=F;F=mKa()|0;l=c[(c[F>>2]|0)+8>>2]|0;m=pKa()|0;G=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[l&255](F,296,G?471744:544544,467192,196)|0;c[m+268>>2]=0;a[m+260>>0]=1;c[m+264>>2]=m+4;c[m+272>>2]=64;c[m+276>>2]=32;c[m+280>>2]=0;c[m+284>>2]=0;c[m+288>>2]=2048;c[m+292>>2]=0;c[d+1240>>2]=m;m=mKa()|0;G=c[(c[m>>2]|0)+8>>2]|0;F=pKa()|0;l=mo[c[(c[F>>2]|0)+24>>2]&4095](F)|0;F=Bn[G&255](m,24,l?471632:544544,467192,198)|0;c[F+16>>2]=0;c[F+20>>2]=0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;a[F+12>>0]=0;c[n>>2]=F;l=c[y>>2]|0;if((c[z>>2]&2147483647)>>>0>l>>>0){z=(c[r>>2]|0)+(l<<2)|0;if(z)c[z>>2]=F;c[y>>2]=l+1}else yYa(r,n)|0;n=mKa()|0;r=c[(c[n>>2]|0)+8>>2]|0;l=pKa()|0;y=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[r&255](n,312,y?471480:544544,467192,199)|0;paa(l);c[d+80>>2]=l;l=uJa(c[f+104>>2]|0,c[f+108>>2]|0,c[f+112>>2]|0)|0;c[d+2368>>2]=l;y=d+1432|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;c[y+20>>2]=0;c[y+24>>2]=0;if(!(Jia(c[D>>2]|0,f,l,C,A)|0)){i=j;return}jta(c[(c[D>>2]|0)+1e3>>2]|0,c[f+132>>2]|0);H=ea(g[f+80>>2]);A=c[(c[D>>2]|0)+1e3>>2]|0;g[A+6164>>2]=H;g[A+6168>>2]=ea(g[f+88>>2]);g[(c[A+12>>2]|0)+144>>2]=ea(g[f+96>>2]);g[A+6172>>2]=ea(g[c[116650]>>2]);Gsa(A,ea(-ea(g[f+92>>2])));A=mKa()|0;C=c[(c[A>>2]|0)+8>>2]|0;l=pKa()|0;y=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[C&255](A,48,y?471360:544544,467192,227)|0;Tba(l,0);g[l+16>>2]=ea(0.0);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(0.0);g[l+28>>2]=ea(1.0);y=l+32|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;a[y+12>>0]=0;y=c[w>>2]|0;w=c[y+8>>2]|0;A=c[y+12>>2]|0;C=c[y+4>>2]|0;n=A+(w*12|0)+4|0;r=c[n>>2]|0;do if(!r){F=A+(w*12|0)+8|0;z=c[F>>2]|0;if((z|0)!=(c[y>>2]|0)?(c[F>>2]=z+1,F=(c[A+(w*12|0)>>2]|0)+(da(z,C)|0)|0,(F|0)!=0):0){I=F;J=33;break}F=zYa(y)|0;if(!F)K=0;else{I=F;J=33}}else{c[n>>2]=c[r>>2];I=r;J=33}while(0);if((J|0)==33){ega(I,d,l);K=I}c[t>>2]=K;K=mKa()|0;t=c[(c[K>>2]|0)+8>>2]|0;I=pKa()|0;l=mo[c[(c[I>>2]|0)+24>>2]&4095](I)|0;I=Bn[t&255](K,2188,l?471240:544544,467192,231)|0;dba(I,d,f);c[v>>2]=I;I=0;v=-2;while(1){c[d+(I<<2)+1288>>2]=~v;I=I+1|0;if((I|0)==32)break;else v=v<<1}a[d+1160>>0]=1;a[d+1161>>0]=1;v=f+48|0;c[d+0>>2]=c[v+0>>2];c[d+4>>2]=c[v+4>>2];c[d+8>>2]=c[v+8>>2];c[d+12>>2]=c[v+12>>2];c[d+16>>2]=c[v+16>>2];c[d+20>>2]=c[v+20>>2];c[d+24>>2]=c[v+24>>2];c[d+28>>2]=c[v+28>>2];v=d+1164|0;c[(c[c[v>>2]>>2]|0)+20>>2]=c[f+44>>2];g[d+32>>2]=ea(g[f>>2]);g[d+36>>2]=ea(g[f+4>>2]);g[d+40>>2]=ea(g[f+8>>2]);c[p>>2]=1;p=c[(c[D>>2]|0)+1e3>>2]|0;c[p+7372>>2]=c[f+84>>2];I=b[s>>1]|0;a[p+7376>>0]=(I&65535)>>>9&1;a[p+7377>>0]=(I&65535)>>>11&1^1;I=c[f+12>>2]|0;p=(c[c[v>>2]>>2]|0)+16|0;if(!((c[p>>2]|0)!=0|(I|0)==0)?(c[x>>2]|0)!=0:0){v=0;do{s=(K8(c[(c[u>>2]|0)+(v<<2)>>2]|0)|0)+144|0;b[s>>1]=e[s>>1]|0|64;v=v+1|0}while(v>>>0<(c[x>>2]|0)>>>0)}c[p>>2]=I;c[(c[(c[D>>2]|0)+1e3>>2]|0)+5912>>2]=c[f+16>>2];nta(c[(c[D>>2]|0)+1e3>>2]|0,c[f+20>>2]|0);pta(c[(c[D>>2]|0)+1e3>>2]|0,c[f+148>>2]|0);D=f+24|0;if(!(c[D>>2]|0)){c[d+1092>>2]=0;c[d+1096>>2]=0}else{I=f+28|0;p=UJa(o,c[I>>2]|0,467192,263)|0;c[d+1092>>2]=p;YEi(p|0,c[D>>2]|0,c[I>>2]|0)|0;c[d+1096>>2]=c[I>>2]}c[d+1100>>2]=c[f+32>>2];c[d+1104>>2]=c[f+36>>2];pca(d);i=j;return}function fca(a,b){a=a|0;b=b|0;var d=0;d=i;jta(c[(c[a+1212>>2]|0)+1e3>>2]|0,b);i=d;return}function gca(a,b){a=a|0;b=b|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];return}function hca(a,b,d){a=a|0;b=b|0;d=d|0;c[(c[(c[a+1164>>2]|0)+((d&255)<<2)>>2]|0)+20>>2]=b;return}function ica(a,b){a=a|0;b=b|0;c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+7372>>2]=b;return}function jca(b,d){b=b|0;d=d|0;a[(c[(c[b+1212>>2]|0)+1e3>>2]|0)+7376>>0]=d&1;return}function kca(b,d){b=b|0;d=d|0;a[(c[(c[b+1212>>2]|0)+1e3>>2]|0)+7377>>0]=d&1;return}function lca(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(c[(c[a+1164>>2]|0)+((f&255)<<2)>>2]|0)+16|0;if((c[h>>2]|0)!=0|(d|0)==0){c[h>>2]=d;i=g;return}f=a+1140|0;if(!(c[f>>2]|0)){c[h>>2]=d;i=g;return}j=a+1136|0;a=0;do{k=(K8(c[(c[j>>2]|0)+(a<<2)>>2]|0)|0)+144|0;b[k>>1]=e[k>>1]|0|64;a=a+1|0}while(a>>>0<(c[f>>2]|0)>>>0);c[h>>2]=d;i=g;return}function mca(a,b){a=a|0;b=b|0;c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+5912>>2]=b;return}function nca(a,b){a=a|0;b=b|0;var d=0;d=i;nta(c[(c[a+1212>>2]|0)+1e3>>2]|0,b);i=d;return}function oca(a,b){a=a|0;b=b|0;var d=0;d=i;pta(c[(c[a+1212>>2]|0)+1e3>>2]|0,b);i=d;return}function pca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+152|0;if(c[d>>2]|0){i=b;return}e=c[(c[116650]|0)+12>>2]|0;if(e)c[a+168>>2]=e;e=a+2368|0;f=c[e>>2]|0;if(f)mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;f=c[a+1184>>2]|0;if(!f)g=0;else g=f+-8|0;f=c[a+168>>2]|0;if(!f)h=c[d>>2]|0;else{j=xo[c[(c[f>>2]|0)+16>>2]&2047](f,g,c[e>>2]|0)|0;c[d>>2]=j;h=j}if(h)In[c[(c[h>>2]|0)+44>>2]&4095](h,2591);h=c[a+172>>2]|0;if(!h)k=c[a+156>>2]|0;else{j=xo[c[(c[h>>2]|0)+16>>2]&2047](h,g,c[e>>2]|0)|0;c[a+156>>2]=j;k=j}if(!k){i=b;return}In[c[(c[k>>2]|0)+44>>2]&4095](k,2591);i=b;return}function qca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+2|0;e=b;f=a+60|0;c[f>>2]=(c[f>>2]|0)+1;c[a+180>>2]=0;f=a+1088|0;g=c[f>>2]|0;if(g){eba(g);VJa(d,g)}c[f>>2]=0;f=a+1092|0;VJa(b+1|0,c[f>>2]|0);c[f>>2]=0;f=c[a+1216>>2]|0;if((f|0)!=0?(g=c[f+52>>2]|0,h=c[a+1224>>2]|0,ko[c[c[f>>2]>>2]&4095](f),AYa(h,f),(g|0)!=0):0){Uba(g);VJa(d,g)}rca(a);g=c[a+2368>>2]|0;if(g)ko[c[(c[g>>2]|0)+60>>2]&4095](g);g=a+80|0;f=c[g>>2]|0;if(f){h=c[f+308>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[f+300>>2]|0,(h|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,h)}BYa(f+4|0);VJa(d,f)}c[g>>2]=0;g=a+1168|0;f=c[g>>2]|0;if(f){h=a+1164|0;j=f;f=0;while(1){k=c[h>>2]|0;l=c[k+(f<<2)>>2]|0;if(!l){m=k;n=j}else{k=c[l+8>>2]|0;if((k&2147483647|0)!=0&(k|0)>-1?(k=c[l>>2]|0,(k|0)!=0):0){o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,k)}VJa(d,l);m=c[h>>2]|0;n=c[g>>2]|0}c[m+(f<<2)>>2]=0;f=f+1|0;if(f>>>0>=n>>>0)break;else j=n}}n=c[a+1236>>2]|0;if(n){CYa(n);VJa(d,n)}n=c[a+1232>>2]|0;if(n){DYa(n);VJa(d,n)}n=c[a+1240>>2]|0;if(n){EYa(n);VJa(d,n)}n=c[a+1224>>2]|0;if(n){j=n+12|0;f=c[n+16>>2]|0;if(f){m=0;do{g=(c[j>>2]|0)+(m*12|0)|0;VJa(d,c[g>>2]|0);c[g>>2]=0;m=m+1|0}while((m|0)!=(f|0))}f=c[n+20>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[j>>2]|0,(f|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}VJa(d,n)}n=c[a+1220>>2]|0;if(n){f=n+12|0;j=c[n+16>>2]|0;if(j){m=0;do{g=(c[f>>2]|0)+(m*12|0)|0;VJa(d,c[g>>2]|0);c[g>>2]=0;m=m+1|0}while((m|0)!=(j|0))}j=c[n+20>>2]|0;if((j&2147483647|0)!=0&(j|0)>-1?(j=c[f>>2]|0,(j|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,j)}VJa(d,n)}n=c[a+1228>>2]|0;if(n){j=n+12|0;f=c[n+16>>2]|0;if(f){m=0;do{g=(c[j>>2]|0)+(m*12|0)|0;VJa(d,c[g>>2]|0);c[g>>2]=0;m=m+1|0}while((m|0)!=(f|0))}f=c[n+20>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[j>>2]|0,(f|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}VJa(d,n)}n=c[a+152>>2]|0;if(n)ko[c[(c[n>>2]|0)+4>>2]&4095](n);n=c[a+156>>2]|0;if(n)ko[c[(c[n>>2]|0)+4>>2]&4095](n);n=c[a+172>>2]|0;if(n)ko[c[(c[n>>2]|0)+4>>2]&4095](n);n=a+96|0;f=c[n>>2]|0;j=c[f+8>>2]|0;if((j&2147483647|0)!=0&(j|0)>-1?(j=c[f>>2]|0,(j|0)!=0):0){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,j);p=c[n>>2]|0}else p=f;VJa(e,p);p=c[a+1208>>2]|0;if(p){e=c[p+36>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[p+28>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[p+16>>2]|0;do if(e){if((c[p+20>>2]|0)<=-1)break;VJa(p+24|0,e)}while(0);e=c[p+12>>2]|0;do if((e&2147483647|0)!=0&(e|0)>-1){f=c[p+4>>2]|0;if(!f)break;n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,f)}while(0);VJa(d,p)}p=c[a+1204>>2]|0;if(p){e=c[p+36>>2]|0;do if((e&2147483647|0)!=0&(e|0)>-1){f=c[p+28>>2]|0;if(!f)break;n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,f)}while(0);e=c[p+16>>2]|0;do if(e){if((c[p+20>>2]|0)<=-1)break;VJa(p+24|0,e)}while(0);e=c[p+12>>2]|0;do if((e&2147483647|0)!=0&(e|0)>-1){f=c[p+4>>2]|0;if(!f)break;n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,f)}while(0);VJa(d,p)}p=c[a+1192>>2]|0;if(p)VJa(d,p);p=c[a+1212>>2]|0;if(!p){i=b;return}Iia(p);VJa(d,p);i=b;return}function rca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+16|0;d=b;e=a+1204|0;f=c[e>>2]|0;g=f+32|0;if(!(c[g>>2]|0))h=f;else{j=f+28|0;k=f+4|0;l=f+12|0;m=f+8|0;f=0;do{n=c[(c[j>>2]|0)+(f<<2)>>2]|0;c[d>>2]=n;o=c[m>>2]|0;if((c[l>>2]&2147483647)>>>0>o>>>0){p=(c[k>>2]|0)+(o<<2)|0;if(!p)q=o;else{c[p>>2]=n;q=c[m>>2]|0}c[m>>2]=q+1}else cUa(k,d)|0;f=f+1|0}while(f>>>0<(c[g>>2]|0)>>>0);h=c[e>>2]|0}c[g>>2]=0;PEi(c[h+16>>2]|0,0,c[h+20>>2]<<2|0)|0;h=a+1208|0;a=c[h>>2]|0;g=a+32|0;if(!(c[g>>2]|0)){r=a;c[g>>2]=0;s=r+20|0;t=c[s>>2]|0;u=r+16|0;v=c[u>>2]|0;w=t<<2;PEi(v|0,0,w|0)|0;i=b;return}e=a+28|0;f=a+4|0;k=a+12|0;q=a+8|0;a=0;do{m=c[(c[e>>2]|0)+(a<<2)>>2]|0;c[d>>2]=m;l=c[q>>2]|0;if((c[k>>2]&2147483647)>>>0>l>>>0){j=(c[f>>2]|0)+(l<<2)|0;if(!j)x=l;else{c[j>>2]=m;x=c[q>>2]|0}c[q>>2]=x+1}else cUa(f,d)|0;a=a+1|0}while(a>>>0<(c[g>>2]|0)>>>0);r=c[h>>2]|0;c[g>>2]=0;s=r+20|0;t=c[s>>2]|0;u=r+16|0;v=c[u>>2]|0;w=t<<2;PEi(v|0,0,w|0)|0;i=b;return}function sca(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+16|0;j=h+12|0;k=h;l=c[a+1224>>2]|0;if((b|0)!=0?(m=l+12|0,n=l+16|0,o=c[l>>2]|0,p=da(o,c[n>>2]|0)|0,p>>>0<b>>>0):0){q=k+4|0;r=k+8|0;s=da(c[l+4>>2]|0,o)|0;t=l+20|0;l=p;do{c[q>>2]=0;c[r>>2]=0;c[k>>2]=UJa(j,s,468528,60)|0;p=c[n>>2]|0;if((c[t>>2]&2147483647)>>>0>p>>>0){u=(c[m>>2]|0)+(p*12|0)|0;if(!u)v=p;else{c[u+0>>2]=c[k+0>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];v=c[n>>2]|0}c[n>>2]=v+1}else xYa(m,k)|0;l=l+o|0}while(l>>>0<b>>>0)}b=c[a+1228>>2]|0;if((d|0)!=0?(l=b+12|0,o=b+16|0,m=c[b>>2]|0,v=da(m,c[o>>2]|0)|0,v>>>0<d>>>0):0){n=k+4|0;t=k+8|0;s=da(c[b+4>>2]|0,m)|0;r=b+20|0;b=v;do{c[n>>2]=0;c[t>>2]=0;c[k>>2]=UJa(j,s,468528,60)|0;v=c[o>>2]|0;if((c[r>>2]&2147483647)>>>0>v>>>0){q=(c[l>>2]|0)+(v*12|0)|0;if(!q)w=v;else{c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];w=c[o>>2]|0}c[o>>2]=w+1}else xYa(l,k)|0;b=b+m|0}while(b>>>0<d>>>0)}Tia(c[a+1212>>2]|0,d,e,f,g);g=c[a+1220>>2]|0;a=f+e|0;if(!a){i=h;return}e=g+12|0;f=g+16|0;d=c[g>>2]|0;b=da(d,c[f>>2]|0)|0;if(b>>>0>=a>>>0){i=h;return}m=k+4|0;l=k+8|0;w=da(c[g+4>>2]|0,d)|0;o=g+20|0;g=b;do{c[m>>2]=0;c[l>>2]=0;c[k>>2]=UJa(j,w,468528,60)|0;b=c[f>>2]|0;if((c[o>>2]&2147483647)>>>0>b>>>0){r=(c[e>>2]|0)+(b*12|0)|0;if(!r)x=b;else{c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];x=c[f>>2]|0}c[f>>2]=x+1}else xYa(e,k)|0;g=g+d|0}while(g>>>0<a>>>0);i=h;return}function tca(a){a=a|0;var b=0,d=0;b=i;d=c[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+49828>>2]|0;a=mo[c[(c[d>>2]|0)+36>>2]&4095](d)|0;i=b;return a|0}function uca(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+49828>>2]|0;a=_n[c[(c[e>>2]|0)+8>>2]&4095](e,b)|0;i=d;return a|0}function vca(a){a=a|0;var b=0,d=0;b=i;d=c[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+49828>>2]|0;a=mo[c[(c[d>>2]|0)+12>>2]&4095](d)|0;i=b;return a|0}function wca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+49828>>2]|0;a=kn[c[(c[g>>2]|0)+16>>2]&511](g,b,d,e)|0;i=f;return a|0}function xca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+49828>>2]|0;a=xo[c[(c[f>>2]|0)+20>>2]&2047](f,b,d)|0;i=e;return a|0}function yca(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+49828>>2]|0;a=_n[c[(c[e>>2]|0)+24>>2]&4095](e,b)|0;i=d;return a|0}function zca(a){a=a|0;return (c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0)+51612|0}function Aca(a){a=a|0;return (c[(c[a+1212>>2]|0)+1e3>>2]|0)+5928|0}function Bca(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+4|0;g=e;h=d+64|0;c[h>>2]=(c[h>>2]|0)+1;a[d+2372>>0]=0;h=(c[(c[d+1212>>2]|0)+1e3>>2]|0)+5928|0;ko[c[(c[h>>2]|0)+44>>2]&4095](h);c[d+180>>2]=0;Cca(d);h=d+128|0;j=d+132|0;c[j>>2]=0;k=d+120|0;l=c[k>>2]|0;m=d+136|0;if((c[m>>2]&2147483647)>>>0<l>>>0){FYa(h,l);n=c[k>>2]|0}else n=l;if(!n){Dca(d);i=e;return}n=d+116|0;l=0;do{o=c[(c[n>>2]|0)+(l<<2)>>2]|0;lha(f,o);do if(b[f>>1]&4){p=Rga(o)|0;c[g>>2]=p;q=c[j>>2]|0;if((c[m>>2]&2147483647)>>>0<=q>>>0){GYa(h,g)|0;break}r=(c[h>>2]|0)+(q<<2)|0;if(r)c[r>>2]=p;c[j>>2]=q+1}while(0);l=l+1|0}while(l>>>0<(c[k>>2]|0)>>>0);Dca(d);i=e;return}function Cca(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+1420|0;if(!(a[e>>0]|0)){i=d;return}f=b+1212|0;if(!(((!(ea(kta(c[(c[f>>2]|0)+1e3>>2]|0,7))!=ea(0.0))?!(ea(kta(c[(c[f>>2]|0)+1e3>>2]|0,8))!=ea(0.0)):0)?!(ea(kta(c[(c[f>>2]|0)+1e3>>2]|0,9))!=ea(0.0)):0)?!(ea(kta(c[(c[f>>2]|0)+1e3>>2]|0,10))!=ea(0.0)):0)){f=b+1196|0;c[f>>2]=c[f>>2]|4}a[e>>0]=0;i=d;return}function Dca(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+112|0;d=b;e=c[a+1184>>2]|0;f=a+1176|0;h=c[f>>2]|0;j=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,64,h,j);if(!(ea(g[a+1416>>2])!=ea(0.0))){k=c[e>>2]|0;l=k+12|0;m=c[l>>2]|0;Dn[m&511](e,64,h,j);i=b;return}f=a+1212|0;n=(c[f>>2]|0)+1e3|0;o=(c[n>>2]|0)+5928|0;p=d+36|0;q=d+0|0;r=q+36|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));g[p>>2]=ea(1.0);p=d+40|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[d+56>>2]=ea(1.0);p=d+60|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[d+76>>2]=ea(1.0);p=d+80|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[d+96>>2]=ea(1.0);c[d+100>>2]=o;if(ea(kta(c[n>>2]|0,15))!=ea(0.0))jpa(c[(c[(c[f>>2]|0)+1e3>>2]|0)+8>>2]|0,d);n=a+72|0;if(c[n>>2]|0){o=a+68|0;p=0;do{Naa(c[(c[(c[o>>2]|0)+(p<<2)>>2]|0)+68>>2]|0,(c[(c[f>>2]|0)+1e3>>2]|0)+5928|0);p=p+1|0}while(p>>>0<(c[n>>2]|0)>>>0)}Cba(c[a+1088>>2]|0,d);n=a+120|0;if(!(c[n>>2]|0)){k=c[e>>2]|0;l=k+12|0;m=c[l>>2]|0;Dn[m&511](e,64,h,j);i=b;return}p=a+116|0;a=0;do{eia(Rga(c[(c[p>>2]|0)+(a<<2)>>2]|0)|0,d);a=a+1|0}while(a>>>0<(c[n>>2]|0)>>>0);k=c[e>>2]|0;l=k+12|0;m=c[l>>2]|0;Dn[m&511](e,64,h,j);i=b;return}function Eca(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=Im,h=0,j=0;e=i;if(!(b!=ea(0.0))){i=e;return}g[a+48>>2]=b;if(b>ea(0.0))f=ea(ea(1.0)/b);else f=ea(0.0);g[a+52>>2]=f;Bca(a);Fca(a);h=a+2284|0;c[a+2300>>2]=1;j=a+2296|0;c[j>>2]=d;if(d){ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[a+2292>>2]=c[(c[j>>2]|0)+8>>2]}j=a+2312|0;c[a+2328>>2]=1;d=a+2324|0;c[d>>2]=h;ko[c[(c[h>>2]|0)+16>>2]&4095](h);c[a+2320>>2]=c[(c[d>>2]|0)+8>>2];ko[c[(c[h>>2]|0)+20>>2]&4095](h);ko[c[(c[j>>2]|0)+20>>2]&4095](j);i=e;return}function Fca(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=i;d=c[a+1184>>2]|0;e=a+1176|0;f=c[e>>2]|0;h=c[e+4>>2]|0;Dn[c[(c[d>>2]|0)+8>>2]&511](d,66,f,h);j=ea(g[a+48>>2]);e=a+56|0;g[e>>2]=ea(j+ea(g[e>>2]));taa(c[a+80>>2]|0);e=c[a+1212>>2]|0;k=c[e+12>>2]|0;l=c[e>>2]|0;e=l+(k<<2)|0;if(!k){m=a+1088|0;n=c[m>>2]|0;Hba(n);o=a+1196|0;p=c[o>>2]|0;q=p&-7;c[o>>2]=q;r=c[d>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](d,66,f,h);i=b;return}u=a+52|0;v=0;w=l+64|0;while(1){if(w>>>0<e>>>0){x=c[w>>2]|0;y=x;z=VEi(y|0,0,6)|0;A=H;B=_Ei(y|0,0,1023,0)|0;y=VEi(B|0,H|0,6)|0;B=H;C=ZEi(1,0,z|0,A|0)|0;A=_Ei(C|0,H|0,y|0,B|0)|0;B=A;A=H;y=x;while(1){B=_Ei(B|0,A|0,-1,-1)|0;A=H;if((B|0)==0&(A|0)==0)break;else y=y+64|0}D=w+4|0}else D=w;K9(c[l+(v<<2)>>2]|0,ea(g[u>>2]));v=v+1|0;if((v|0)==(k|0))break;else w=D}m=a+1088|0;n=c[m>>2]|0;Hba(n);o=a+1196|0;p=c[o>>2]|0;q=p&-7;c[o>>2]=q;r=c[d>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](d,66,f,h);i=b;return}function Gca(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=Im,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;if(!(b!=ea(0.0))){i=e;return}g[a+48>>2]=b;if(b>ea(0.0))f=ea(ea(1.0)/b);else f=ea(0.0);h=a+52|0;g[h>>2]=f;j=c[a+1184>>2]|0;k=a+1176|0;l=c[k>>2]|0;m=c[k+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,66,l,m);k=c[a+1212>>2]|0;n=c[k+12>>2]|0;o=c[k>>2]|0;k=o+(n<<2)|0;if(n){p=0;q=o+64|0;while(1){if(q>>>0<k>>>0){r=c[q>>2]|0;s=r;t=VEi(s|0,0,6)|0;u=H;v=_Ei(s|0,0,1023,0)|0;s=VEi(v|0,H|0,6)|0;v=H;w=ZEi(1,0,t|0,u|0)|0;u=_Ei(w|0,H|0,s|0,v|0)|0;v=u;u=H;s=r;while(1){v=_Ei(v|0,u|0,-1,-1)|0;u=H;if((v|0)==0&(u|0)==0)break;else s=s+64|0}x=q+4|0}else x=q;K9(c[o+(p<<2)>>2]|0,ea(g[h>>2]));p=p+1|0;if((p|0)==(n|0))break;else q=x}}Dn[c[(c[j>>2]|0)+12>>2]&511](j,66,l,m);m=a+2284|0;c[a+2300>>2]=1;l=a+2296|0;c[l>>2]=d;if(d){ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[a+2292>>2]=c[(c[l>>2]|0)+8>>2]}ko[c[(c[m>>2]|0)+20>>2]&4095](m);i=e;return}function Hca(a,b){a=a|0;b=ea(b);var d=0;d=i;Gsa(c[(c[a+1212>>2]|0)+1e3>>2]|0,ea(-b));i=d;return}function Ica(a){a=a|0;var b=0,d=Im;b=i;d=ea(-ea(Hsa(c[(c[a+1212>>2]|0)+1e3>>2]|0)));i=b;return ea(d)}function Jca(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;g[a+48>>2]=b;Bca(a);$fa(c[a+1192>>2]|0);gta(c[(c[a+1212>>2]|0)+1e3>>2]|0);f=a+2312|0;c[a+2328>>2]=1;h=a+2324|0;c[h>>2]=d;if(!d){j=c[f>>2]|0;k=j+20|0;l=c[k>>2]|0;ko[l&4095](f);i=e;return}ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[a+2320>>2]=c[(c[h>>2]|0)+8>>2];j=c[f>>2]|0;k=j+20|0;l=c[k>>2]|0;ko[l&4095](f);i=e;return}function Kca(a){a=a|0;return c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+7372>>2]|0}function Lca(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+1088|0;Eba(c[d>>2]|0);e=c[d>>2]|0;c[e+28>>2]=c[e+20>>2];e=a+60|0;c[e>>2]=(c[e>>2]|0)+1&2147483647;e=a+64|0;c[e>>2]=(c[e>>2]|0)+1;i=b;return}function Mca(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+32|0;h=g;if(f){Nca(d,1);Oca(d);j=d+1088|0}else{f=d+1088|0;fba(c[f>>2]|0,1);j=f}rca(d);f=c[j>>2]|0;c[f+48>>2]=0;c[f+60>>2]=-1;j=f+52|0;k=f+56|0;if((c[j>>2]|0)!=(c[k>>2]|0)){l=f+44|0;VJa(g+24|0,c[l>>2]|0);c[l>>2]=UJa(h,c[k>>2]|0,474544,167)|0;c[j>>2]=c[k>>2]}HYa(d+68|0,c[d+72>>2]|0);k=d+84|0;a[h+20>>0]=0;IYa(k,0,h);JYa(k,c[d+88>>2]|0);k=c[d+96>>2]|0;c[h+0>>2]=-1;c[h+4>>2]=-1;b[h+8>>1]=65535;a[h+10>>0]=0;a[h+11>>0]=0;KYa(k,0,h);LYa(k,c[k+4>>2]|0);k=d+180|0;c[k>>2]=0;j=d+176|0;c[h>>2]=0;MYa(j,0,h);HYa(j,c[k>>2]|0);k=d+1140|0;if(c[k>>2]|0){j=d+1136|0;l=0;do{f=(K8(c[(c[j>>2]|0)+(l<<2)>>2]|0)|0)+144|0;b[f>>1]=(e[f>>1]|0)&65423;l=l+1|0}while(l>>>0<(c[k>>2]|0)>>>0)}l=d+1152|0;if(c[l>>2]|0){j=d+1148|0;f=0;do{m=(K8(c[(c[j>>2]|0)+(f<<2)>>2]|0)|0)+144|0;b[m>>1]=(e[m>>1]|0)&65359;f=f+1|0}while(f>>>0<(c[l>>2]|0)>>>0)}c[k>>2]=0;c[l>>2]=0;a[d+1160>>0]=1;a[d+1161>>0]=1;f=d+1136|0;c[h>>2]=0;NYa(f,0,h);OYa(f,c[k>>2]|0);k=d+1148|0;c[h>>2]=0;NYa(k,0,h);OYa(k,c[l>>2]|0);PYa(d+1164|0,c[d+1168>>2]|0);l=c[d+1204>>2]|0;k=l+32|0;if(c[k>>2]|0){f=l+28|0;j=l+4|0;m=l+12|0;n=l+8|0;o=0;do{p=c[(c[f>>2]|0)+(o<<2)>>2]|0;c[h>>2]=p;q=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>q>>>0){r=(c[j>>2]|0)+(q<<2)|0;if(!r)s=q;else{c[r>>2]=p;s=c[n>>2]|0}c[n>>2]=s+1}else cUa(j,h)|0;o=o+1|0}while(o>>>0<(c[k>>2]|0)>>>0)}c[k>>2]=0;o=l+28|0;c[h>>2]=0;xUa(o,0,h);yUa(o,c[k>>2]|0);k=c[d+1208>>2]|0;o=k+32|0;if(c[o>>2]|0){l=k+28|0;j=k+4|0;s=k+12|0;n=k+8|0;m=0;do{f=c[(c[l>>2]|0)+(m<<2)>>2]|0;c[h>>2]=f;p=c[n>>2]|0;if((c[s>>2]&2147483647)>>>0>p>>>0){r=(c[j>>2]|0)+(p<<2)|0;if(!r)t=p;else{c[r>>2]=f;t=c[n>>2]|0}c[n>>2]=t+1}else cUa(j,h)|0;m=m+1|0}while(m>>>0<(c[o>>2]|0)>>>0)}c[o>>2]=0;m=k+28|0;c[h>>2]=0;xUa(m,0,h);yUa(m,c[o>>2]|0);Pca(d);o=d+1248|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;QYa(o,0,h);RYa(o,c[d+1252>>2]|0);o=d+1212|0;Uia(c[o>>2]|0);SYa(d+116|0,c[d+120>>2]|0);m=d+128|0;c[h>>2]=0;TYa(m,0,h);FYa(m,c[d+132>>2]|0);IAa((c[(c[o>>2]|0)+1e3>>2]|0)+44|0);i=g;return}function Nca(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;h=i;i=i+16|0;j=h;k=d+1088|0;l=c[k>>2]|0;m=c[l+4>>2]|0;n=c[l+8>>2]|0;if(!n){o=l;p=o+48|0;c[p>>2]=0;q=o+60|0;c[q>>2]=-1;fba(o,f);i=h;return}l=n+-1|0;l=d+1208|0;r=j+14|0;s=j+4|0;t=j+8|0;u=j+12|0;v=d+1164|0;w=d+1204|0;d=0;while(1){x=c[m+(d<<2)>>2]|0;y=x+20|0;z=c[y>>2]|0;if(!z){m7(x);A=c[y>>2]|0}else A=z;z=A+10|0;B=e[z>>1]|0;if(!(B&2)){C=b[A+6>>1]|0;D=c[(c[k>>2]|0)+44>>2]|0;E=c[A>>2]|0;F=D+(E+(B&65520))|0;if((B&1|0)!=0?(G=C&65535,H=c[w>>2]|0,C<<16>>16!=0):0){I=c[H+20>>2]&2147483647;J=H+16|0;H=0;do{K=c[F+(H<<5)+24>>2]|0;L=c[F+(H<<5)+28>>2]|0;M=F+(H<<5)+20|0;N=b[M>>1]|0;O=K>>>5;if(O>>>0<I>>>0?(c[(c[J>>2]|0)+(O<<2)>>2]&1<<(K&31)|0)!=0:0)P=(N&65535|1)&65535;else P=N;N=L>>>5;if(N>>>0<I>>>0?(c[(c[J>>2]|0)+(N<<2)>>2]&1<<(L&31)|0)!=0:0)Q=(P&65535|2)&65535;else Q=P;b[M>>1]=Q;H=H+1|0}while((H|0)!=(G|0))}G=d+1|0;if(G>>>0<n>>>0){H=c[m+(G<<2)>>2]|0;J=H+20|0;I=c[J>>2]|0;if(!I){m7(H);R=c[J>>2]|0}else R=I;S=c[y>>2]|0}else S=A;do if(!S){m7(x);I=c[y>>2]|0;J=a[I+32>>0]|0;if(I){T=I;U=a[I+33>>0]|0;V=J;W=28;break}m7(x);I=c[y>>2]|0;H=a[I+33>>0]|0;if(!I){m7(x);M=c[y>>2]|0;L=a[M+34>>0]|0;if(!M){m7(x);X=c[y>>2]|0;Y=L;Z=J;_=H;W=32;break}else{N=a[M+35>>0]|0;K=c[l>>2]|0;b[r>>1]=0;$=M;aa=K;ba=J;ca=H;da=N;fa=L;break}}else{T=I;U=H;V=J;W=28}}else{T=S;U=a[S+33>>0]|0;V=a[S+32>>0]|0;W=28}while(0);if((W|0)==28){W=0;X=T;Y=a[T+34>>0]|0;Z=V;_=U;W=32}if((W|0)==32){W=0;J=a[X+35>>0]|0;H=c[l>>2]|0;b[r>>1]=0;if(!X){m7(x);$=c[y>>2]|0;aa=H;ba=Z;ca=_;da=J;fa=Y}else{$=X;aa=H;ba=Z;ca=_;da=J;fa=Y}}c[j>>2]=c[$+24>>2];J=c[y>>2]|0;if(!J){m7(x);ga=c[y>>2]|0}else ga=J;c[s>>2]=c[ga+28>>2];J=c[y>>2]|0;if(!J){m7(x);ha=c[y>>2]|0}else ha=J;J=c[ha+16>>2]|0;H=J>>>5;I=aa+20|0;L=c[I>>2]|0;if(H>>>0<(L&2147483647)>>>0)ia=(c[(c[aa+16>>2]|0)+(H<<2)>>2]&1<<(J&31)|0)!=0&1;else ia=0;if(!ha){m7(x);ja=c[y>>2]|0;ka=c[I>>2]|0}else{ja=ha;ka=L}L=c[ja+20>>2]|0;I=L>>>5;if(I>>>0<(ka&2147483647)>>>0?(c[(c[aa+16>>2]|0)+(I<<2)>>2]&1<<(L&31)|0)!=0:0)la=(ia&65535|2)&65535;else la=ia;b[r>>1]=la;L=A+8|0;I=b[L>>1]|0;if(I<<16>>16){J=(I&65535)+65532&65535;c[t>>2]=D+(E+4);if(!(B&8))ma=J;else{I=c[x>>2]|0;H=c[x+4>>2]|0;if(!(a[I+50>>0]|0)){g[D+(E+12)>>2]=ea(0.0);g[D+(E+16)>>2]=ea(0.0);g[D+(E+20)>>2]=ea(0.0);g[D+(E+36)>>2]=ea(0.0);g[D+(E+40)>>2]=ea(0.0);g[D+(E+44)>>2]=ea(0.0)}else{N=c[I+52>>2]|0;g[D+(E+12)>>2]=ea(g[N+80>>2]);g[D+(E+16)>>2]=ea(g[N+84>>2]);g[D+(E+20)>>2]=ea(g[N+88>>2]);g[D+(E+36)>>2]=ea(g[N+96>>2]);g[D+(E+40)>>2]=ea(g[N+100>>2]);g[D+(E+44)>>2]=ea(g[N+104>>2])}if(!(a[H+50>>0]|0)){g[D+(E+24)>>2]=ea(0.0);g[D+(E+28)>>2]=ea(0.0);g[D+(E+32)>>2]=ea(0.0);g[D+(E+48)>>2]=ea(0.0);g[D+(E+52)>>2]=ea(0.0);g[D+(E+56)>>2]=ea(0.0)}else{N=c[H+52>>2]|0;g[D+(E+24)>>2]=ea(g[N+80>>2]);g[D+(E+28)>>2]=ea(g[N+84>>2]);g[D+(E+32)>>2]=ea(g[N+88>>2]);g[D+(E+48)>>2]=ea(g[N+96>>2]);g[D+(E+52)>>2]=ea(g[N+100>>2]);g[D+(E+56)>>2]=ea(g[N+104>>2])}b[z>>1]=e[z>>1]&65527;ma=J}}else{c[t>>2]=0;ma=0}b[u>>1]=ma;J=c[(c[v>>2]|0)+((ba&255)<<2)>>2]|0;N=c[J+16>>2]|0;do if(N){if(ba<<24>>24!=ca<<24>>24?(a[J+12>>0]&2)==0|(da&2)==0:0)break;Dn[c[(c[N>>2]|0)+12>>2]&511](N,j,F,C&65535)}while(0);if((ba<<24>>24!=ca<<24>>24?(N=c[(c[v>>2]|0)+((ca&255)<<2)>>2]|0,J=c[N+16>>2]|0,(J|0)!=0):0)?!((a[N+12>>0]&2)==0|(fa&2)==0):0)Dn[c[(c[J>>2]|0)+12>>2]&511](J,j,F,C&65535);b[A+4>>1]=C;J=e[L>>1]|0;b[z>>1]=(((J&15|0)!=0&1)<<4)+J&65520|e[z>>1]&15;na=G}else na=d+1|0;if((na|0)==(n|0))break;else d=na}o=c[k>>2]|0;p=o+48|0;c[p>>2]=0;q=o+60|0;c[q>>2]=-1;fba(o,f);i=h;return}function Oca(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+848|0;f=e+784|0;g=e;h=b+84|0;j=b+88|0;k=c[j>>2]|0;if(!k){c[j>>2]=0;l=b+96|0;m=c[l>>2]|0;n=m+4|0;c[n>>2]=0;o=b+100|0;a[o>>0]=0;i=e;return}p=b+1164|0;if((c[b+1168>>2]|0)==1?(q=c[(c[c[p>>2]>>2]|0)+16>>2]|0,(q|0)!=0):0){if(!(a[b+100>>0]|0)){co[c[(c[q>>2]|0)+16>>2]&2047](q,c[h>>2]|0,k);c[j>>2]=0;l=b+96|0;m=c[l>>2]|0;n=m+4|0;c[n>>2]=0;o=b+100|0;a[o>>0]=0;i=e;return}q=b+1204|0;r=b+96|0;s=0;do{t=c[q>>2]|0;u=c[c[r>>2]>>2]|0;v=c[h>>2]|0;w=c[u+(s*12|0)>>2]|0;x=w>>>5;y=c[t+20>>2]&2147483647;if(x>>>0<y>>>0)z=(c[(c[t+16>>2]|0)+(x<<2)>>2]&1<<(w&31)|0)==0;else z=1;w=z&1^1;x=c[u+(s*12|0)+4>>2]|0;u=x>>>5;if(u>>>0<y>>>0?(c[(c[t+16>>2]|0)+(u<<2)>>2]&1<<(x&31)|0)!=0:0){A=(w&255|2)&255;B=13}else B=12;if((B|0)==12?(B=0,!z):0){A=w;B=13}if((B|0)==13){B=0;w=v+(s*24|0)+20|0;a[w>>0]=a[w>>0]|A}s=s+1|0}while((s|0)!=(k|0));s=c[(c[c[p>>2]>>2]|0)+16>>2]|0;co[c[(c[s>>2]|0)+16>>2]&2047](s,c[h>>2]|0,k);c[j>>2]=0;l=b+96|0;m=c[l>>2]|0;n=m+4|0;c[n>>2]=0;o=b+100|0;a[o>>0]=0;i=e;return};c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;s=b+96|0;A=b+1164|0;z=b+100|0;r=b+1204|0;q=0;w=1;v=0;while(1){x=c[c[s>>2]>>2]|0;u=a[x+(v*12|0)+10>>0]|0;t=a[x+(v*12|0)+11>>0]|0;y=x+(v*12|0)+8|0;C=a[y>>0]|0;D=c[A>>2]|0;E=c[D+((C&255)<<2)>>2]|0;F=a[E+12>>0]|0;G=x+(v*12|0)+9|0;H=a[G>>0]|0;I=c[D+((H&255)<<2)>>2]|0;D=a[I+12>>0]|0;if(c[E+16>>2]|0)if(C<<24>>24!=H<<24>>24)if(!(F&1))J=0;else J=(t&1)!=0;else J=1;else J=0;if((c[I+16>>2]|0)==0?1:C<<24>>24==H<<24>>24)K=0;else K=(u&1&D)<<24>>24!=0;if(J|K){do if(a[z>>0]|0){D=c[r>>2]|0;u=c[h>>2]|0;H=c[x+(v*12|0)>>2]|0;C=H>>>5;I=c[D+20>>2]&2147483647;if(C>>>0<I>>>0)L=(c[(c[D+16>>2]|0)+(C<<2)>>2]&1<<(H&31)|0)==0;else L=1;H=L&1^1;C=c[x+(v*12|0)+4>>2]|0;t=C>>>5;if(t>>>0<I>>>0?(c[(c[D+16>>2]|0)+(t<<2)>>2]&1<<(C&31)|0)!=0:0)M=(H&255|2)&255;else if(L)break;else M=H;H=u+(v*24|0)+20|0;a[H>>0]=a[H>>0]|M}while(0);if(J){x=d[y>>0]|0;H=f+(x>>>3<<2)|0;c[H>>2]=1<<(x&7)|c[H>>2];H=x+1&65535;N=(H&65535)<(q&65535)?q:H}else{a[y>>0]=-128;N=q}if(K){H=d[G>>0]|0;x=f+(H>>>3<<2)|0;c[x>>2]=1<<(H&7)|c[x>>2];x=H+1&65535;O=(x&65535)<(N&65535)?N:x}else{a[G>>0]=-128;O=N}P=O;Q=v+1|0}else{x=c[h>>2]|0;H=x+(v*24|0)|0;u=(c[j>>2]|0)+-1|0;c[j>>2]=u;C=x+(u*24|0)|0;c[H+0>>2]=c[C+0>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];c[H+12>>2]=c[C+12>>2];c[H+16>>2]=c[C+16>>2];a[H+20>>0]=a[C+20>>0]|0;C=c[s>>2]|0;H=c[C>>2]|0;u=H+(v*12|0)|0;x=C+4|0;C=(c[x>>2]|0)+-1|0;c[x>>2]=C;x=H+(C*12|0)|0;c[u+0>>2]=c[x+0>>2];c[u+4>>2]=c[x+4>>2];c[u+8>>2]=c[x+8>>2];P=q;Q=v}if((w|0)==(k|0))break;q=P;w=w+1|0;v=Q}v=g+768|0;w=g+772|0;q=g+776|0;c[q>>2]=0;k=g+780|0;a[v>>0]=1;c[w>>2]=g;c[k>>2]=32;if(!(P<<16>>16))R=32;else{s=b+96|0;O=P&65535;if(!Q){P=0;do{if(c[f+(P>>>3<<2)>>2]&1<<(P&7)){c[q>>2]=0;N=c[(c[(c[p>>2]|0)+(P<<2)>>2]|0)+16>>2]|0;co[c[(c[N>>2]|0)+16>>2]&2047](N,c[w>>2]|0,c[q>>2]|0)}P=P+1|0}while((P|0)!=(O|0))}else{P=0;do{if(c[f+(P>>>3<<2)>>2]&1<<(P&7)){c[q>>2]=0;if((c[k>>2]&2147483647)>>>0<Q>>>0){UYa(g,Q);S=0}else S=0;do{N=c[c[s>>2]>>2]|0;if(!((d[N+(S*12|0)+8>>0]|0)!=(P|0)?(d[N+(S*12|0)+9>>0]|0)!=(P|0):0))B=50;do if((B|0)==50){B=0;N=c[h>>2]|0;K=N+(S*24|0)|0;J=c[q>>2]|0;if((c[k>>2]&2147483647)>>>0<=J>>>0){VYa(g,K)|0;break}M=c[w>>2]|0;L=M+(J*24|0)|0;if(!L)T=J;else{c[L+0>>2]=c[K+0>>2];c[L+4>>2]=c[K+4>>2];c[L+8>>2]=c[K+8>>2];c[L+12>>2]=c[K+12>>2];c[L+16>>2]=c[K+16>>2];a[M+(J*24|0)+20>>0]=a[N+(S*24|0)+20>>0]|0;T=c[q>>2]|0}c[q>>2]=T+1}while(0);S=S+1|0}while((S|0)!=(Q|0));G=c[(c[(c[p>>2]|0)+(P<<2)>>2]|0)+16>>2]|0;co[c[(c[G>>2]|0)+16>>2]&2047](G,c[w>>2]|0,c[q>>2]|0)}P=P+1|0}while((P|0)!=(O|0))}R=c[k>>2]|0}if(!((R&2147483647|0)!=0&(R|0)>-1)){c[j>>2]=0;l=b+96|0;m=c[l>>2]|0;n=m+4|0;c[n>>2]=0;o=b+100|0;a[o>>0]=0;i=e;return}R=c[w>>2]|0;if((g|0)==(R|0)){a[v>>0]=0;c[j>>2]=0;l=b+96|0;m=c[l>>2]|0;n=m+4|0;c[n>>2]=0;o=b+100|0;a[o>>0]=0;i=e;return}else{tKa(g,R);c[j>>2]=0;l=b+96|0;m=c[l>>2]|0;n=m+4|0;c[n>>2]=0;o=b+100|0;a[o>>0]=0;i=e;return}}function Pca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=b+1252|0;if(!(c[e>>2]|0))f=b+1264|0;else{g=b+1248|0;h=b+1264|0;j=b+1260|0;k=0;do{l=c[g>>2]|0;m=c[l+(k<<4)+8>>2]|0;n=m>>>5;o=c[h>>2]&2147483647;if(n>>>0<o>>>0)p=c[(c[j>>2]|0)+(n<<2)>>2]&1<<(m&31);else p=0;m=c[l+(k<<4)+12>>2]|0;n=m>>>5;if(n>>>0<o>>>0)q=(c[(c[j>>2]|0)+(n<<2)>>2]&1<<(m&31)|0)==0;else q=1;m=(p|0)!=0;do if(!(q&(m^1))){if(!m)F9(c[l+(k<<4)>>2]|0,ea(.399999976));if(q)F9(c[(c[g>>2]|0)+(k<<4)+4>>2]|0,ea(.399999976))}else{n=c[l+(k<<4)>>2]|0;o=(a[(c[l+(k<<4)+4>>2]|0)+51>>0]&1)==0;if(!(a[n+51>>0]&1)){if(o)break}else if(!o)break;F9(n,ea(.399999976));F9(c[(c[g>>2]|0)+(k<<4)+4>>2]|0,ea(.399999976))}while(0);k=k+1|0}while(k>>>0<(c[e>>2]|0)>>>0);f=h}c[e>>2]=0;PEi(c[b+1260>>2]|0,0,c[f>>2]<<2|0)|0;f=b+108|0;if(!(c[f>>2]|0)){i=d;return}e=b+104|0;b=0;do{x8(c[c[(c[e>>2]|0)+(b<<2)>>2]>>2]|0);b=b+1|0}while(b>>>0<(c[f>>2]|0)>>>0);i=d;return}function Qca(a,b){a=a|0;b=b|0;return c[(c[(c[a+1164>>2]|0)+((b&255)<<2)>>2]|0)+16>>2]|0}function Rca(a){a=a|0;return c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+5912>>2]|0}function Sca(a){a=a|0;var b=0,d=0;b=i;d=mta(c[(c[a+1212>>2]|0)+1e3>>2]|0)|0;i=b;return d|0}function Tca(a){a=a|0;var b=0,d=0;b=i;d=ota(c[(c[a+1212>>2]|0)+1e3>>2]|0)|0;i=b;return d|0}function Uca(a,b){a=a|0;b=b|0;return c[(c[(c[a+1164>>2]|0)+((b&255)<<2)>>2]|0)+20>>2]|0}function Vca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[b+60>>2]|0;if(e)uaa(c[a+80>>2]|0,e,0);e=c[b+52>>2]|0;f=a+1140|0;g=c[f>>2]|0;if(g){h=c[a+1136>>2]|0;j=0;while(1){k=j+1|0;if((c[h+(j<<2)>>2]|0)==(e|0)){l=j;break}if(k>>>0<g>>>0)j=k;else{l=k;break}}if((l|0)!=(g|0)){j=g+-1|0;c[f>>2]=j;c[h+(l<<2)>>2]=c[h+(j<<2)>>2]}}j=a+1152|0;h=c[j>>2]|0;if(h){l=c[a+1148>>2]|0;f=0;while(1){g=f+1|0;if((c[l+(f<<2)>>2]|0)==(e|0)){m=f;break}if(g>>>0<h>>>0)f=g;else{m=g;break}}if((m|0)!=(h|0)){f=h+-1|0;c[j>>2]=f;c[l+(m<<2)>>2]=c[l+(f<<2)>>2]}}f=c[b+56>>2]|0;b=a+1260|0;l=(f+32|0)>>>5;m=a+1264|0;if(l>>>0<=(c[m>>2]&2147483647)>>>0){n=c[b>>2]|0;o=f&31;p=1<<o;q=f>>>5;r=n+(q<<2)|0;s=c[r>>2]|0;t=s|p;c[r>>2]=t;i=d;return}j=a+1268|0;a=UJa(j,l<<2,543784,339)|0;h=c[b>>2]|0;if((h|0)!=0?(YEi(a|0,h|0,c[m>>2]<<2|0)|0,(c[m>>2]|0)>-1):0)VJa(j,c[b>>2]|0);j=c[m>>2]|0;PEi(a+((j&2147483647)<<2)|0,0,l-j<<2|0)|0;c[b>>2]=a;c[m>>2]=l;n=a;o=f&31;p=1<<o;q=f>>>5;r=n+(q<<2)|0;s=c[r>>2]|0;t=s|p;c[r>>2]=t;i=d;return}function Wca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=c[a+1232>>2]|0;j=h+292|0;k=c[j>>2]|0;if(!k){WYa(h);l=c[j>>2]|0}else l=k;c[j>>2]=c[l>>2];j=h+280|0;c[j>>2]=(c[j>>2]|0)+1;j=h+284|0;c[j>>2]=(c[j>>2]|0)+-1;if(l)Aaa(l,b,d,e,a);e=a+68|0;c[g>>2]=b;d=a+72|0;l=c[d>>2]|0;if((c[a+76>>2]&2147483647)>>>0<=l>>>0){XYa(e,g)|0;i=f;return}g=(c[e>>2]|0)+(l<<2)|0;if(g)c[g>>2]=b;c[d>>2]=l+1;i=f;return}function Xca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[b+68>>2]|0;if(e){f=c[e+108>>2]|0;if(!f)g=c[e+112>>2]|0;else g=f;f=c[g+60>>2]|0;if(f)uaa(c[a+80>>2]|0,f,e);f=c[a+1232>>2]|0;Daa(e);g=f+280|0;c[g>>2]=(c[g>>2]|0)+-1;g=f+292|0;c[e>>2]=c[g>>2];c[g>>2]=e;e=f+284|0;g=c[e>>2]|0;c[e>>2]=g+1;if((g|0)>=((c[f+276>>2]|0)*50|0)){YYa(f);c[e>>2]=0}}e=a+72|0;f=c[e>>2]|0;if(!f){i=d;return}g=c[a+68>>2]|0;a=0;while(1){h=a+1|0;if((c[g+(a<<2)>>2]|0)==(b|0)){j=a;break}if(h>>>0<f>>>0)a=h;else{j=h;break}}if((j|0)==(f|0)){i=d;return}a=f+-1|0;c[e>>2]=a;c[g+(j<<2)>>2]=c[g+(a<<2)>>2];i=d;return}function Yca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,164,l?470352:544544,467192,774)|0;r8(k,b,a,d);if((k|0)!=0?(c[k>>2]|0)==0:0){t8(k);VJa(f,k);i=e;return}k=a+104|0;c[g>>2]=b;f=a+108|0;d=c[f>>2]|0;if((c[a+112>>2]&2147483647)>>>0<=d>>>0){ZYa(k,g)|0;i=e;return}g=(c[k>>2]|0)+(d<<2)|0;if(g)c[g>>2]=b;c[f>>2]=d+1;i=e;return}function Zca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=c[b>>2]|0;if(e){t8(e);VJa(d,e)}e=a+108|0;f=c[e>>2]|0;if(!f){i=d;return}g=c[a+104>>2]|0;a=0;while(1){h=a+1|0;if((c[g+(a<<2)>>2]|0)==(b|0)){j=a;break}if(h>>>0<f>>>0)a=h;else{j=h;break}}if((j|0)==(f|0)){i=d;return}a=f+-1|0;c[e>>2]=a;c[g+(j<<2)>>2]=c[g+(a<<2)>>2];i=d;return}function _ca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;a=i;f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,40,j?470080:544544,467192,796)|0;j=K8(d)|0;j8(h,b,j,K8(e)|0);i=a;return}function $ca(a,b){a=a|0;b=b|0;var d=0;a=i;d=c[b>>2]|0;if(!d){i=a;return}ko[c[(c[d>>2]|0)+4>>2]&4095](d);i=a;return}function ada(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=a+176|0;g=a+180|0;h=c[g>>2]|0;if((c[a+184>>2]&2147483647)>>>0<=h>>>0){XYa(f,e)|0;i=d;return}e=(c[f>>2]|0)+(h<<2)|0;if(e)c[e>>2]=b;c[g>>2]=h+1;i=d;return}function bda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;c[f>>2]=d;g=b+188|0;h=b+192|0;j=c[h>>2]|0;if((c[b+196>>2]&2147483647)>>>0<=j>>>0){LXa(g,f)|0;k=c[f>>2]|0;l=k+116|0;m=a[l>>0]|0;n=m|4;a[l>>0]=n;i=e;return}f=(c[g>>2]|0)+(j<<2)|0;if(f)c[f>>2]=d;c[h>>2]=j+1;k=d;l=k+116|0;m=a[l>>0]|0;n=m|4;a[l>>0]=n;i=e;return}function cda(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=b+192|0;h=c[g>>2]|0;if(h){j=c[b+188>>2]|0;b=0;while(1){k=b+1|0;if((c[j+(b<<2)>>2]|0)==(e|0)){l=b;break}if(k>>>0<h>>>0)b=k;else{l=k;break}}if((l|0)!=(h|0)){b=h+-1|0;c[g>>2]=b;c[j+(l<<2)>>2]=c[j+(b<<2)>>2]}}b=e+116|0;a[b>>0]=(d[b>>0]|0)&251;i=f;return}function dda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;if(b>>>0<129){f=a+492|0;g=c[f>>2]|0;if(!g){_Ya(a+200|0);h=c[f>>2]|0}else h=g;c[f>>2]=c[h>>2];f=a+480|0;c[f>>2]=(c[f>>2]|0)+1;f=a+484|0;c[f>>2]=(c[f>>2]|0)+-1;j=h;i=d;return j|0}if(b>>>0<257){h=a+788|0;f=c[h>>2]|0;if(!f){$Ya(a+496|0);k=c[h>>2]|0}else k=f;c[h>>2]=c[k>>2];h=a+776|0;c[h>>2]=(c[h>>2]|0)+1;h=a+780|0;c[h>>2]=(c[h>>2]|0)+-1;j=k;i=d;return j|0}if(b>>>0>=385){j=UJa(e,b,467192,843)|0;i=d;return j|0}b=a+1084|0;e=c[b>>2]|0;if(!e){aZa(a+792|0);l=c[b>>2]|0}else l=e;c[b>>2]=c[l>>2];b=a+1072|0;c[b>>2]=(c[b>>2]|0)+1;b=a+1076|0;c[b>>2]=(c[b>>2]|0)+-1;j=l;i=d;return j|0}function eda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;if(d>>>0<129){if(!b){i=e;return}g=a+480|0;c[g>>2]=(c[g>>2]|0)+-1;g=a+492|0;c[b>>2]=c[g>>2];c[g>>2]=b;g=a+484|0;h=c[g>>2]|0;c[g>>2]=h+1;if((h|0)<((c[a+476>>2]|0)*50|0)){i=e;return}bZa(a+200|0);c[g>>2]=0;i=e;return}if(d>>>0<257){if(!b){i=e;return}g=a+776|0;c[g>>2]=(c[g>>2]|0)+-1;g=a+788|0;c[b>>2]=c[g>>2];c[g>>2]=b;g=a+780|0;h=c[g>>2]|0;c[g>>2]=h+1;if((h|0)<((c[a+772>>2]|0)*50|0)){i=e;return}cZa(a+496|0);c[g>>2]=0;i=e;return}if(d>>>0>=385){VJa(f,b);i=e;return}if(!b){i=e;return}f=a+1072|0;c[f>>2]=(c[f>>2]|0)+-1;f=a+1084|0;c[b>>2]=c[f>>2];c[f>>2]=b;b=a+1076|0;f=c[b>>2]|0;c[b>>2]=f+1;if((f|0)<((c[a+1068>>2]|0)*50|0)){i=e;return}dZa(a+792|0);c[b>>2]=0;i=e;return}function fda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im;d=i;i=i+16|0;e=a+144|0;f=a+140|0;h=a+156|0;j=c[h>>2]|0;if(!j){i=d;return}if(!(mo[c[(c[j>>2]|0)+48>>2]&4095](j)|0)){j=c[h>>2]|0;k=ea(g[a+48>>2]);c[a+164>>2]=ro[c[(c[j>>2]|0)+16>>2]&7](j,k,b)|0;i=d;return}dKa(bKa()|0,2,467192,901,467320,d);if(c[e>>2]|0){b=0;do{Hka(c[(c[f>>2]|0)+(b<<2)>>2]|0,1,0);b=b+1|0}while(b>>>0<(c[e>>2]|0)>>>0)}e=c[h>>2]|0;if(e)ko[c[(c[e>>2]|0)+4>>2]&4095](e);c[h>>2]=0;c[a+164>>2]=0;i=d;return}function gda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;h=b+1704|0;j=b+1792|0;oTa(c[j>>2]|0);k=b+1716|0;fTa(k)|0;l=b+1712|0;c[l>>2]=c[d+8>>2];c[g>>2]=d;m=b+1752|0;n=b+1748|0;o=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>o>>>0){p=(c[b+1744>>2]|0)+(o<<2)|0;if(p)c[p>>2]=d;c[n>>2]=o+1}else eZa(b+1724|0,g)|0;ko[c[(c[d>>2]|0)+16>>2]&4095](d);d=b+1788|0;a[d>>0]=1;pTa(c[j>>2]|0);oTa(c[j>>2]|0);fTa(k)|0;c[l>>2]=c[e+8>>2];c[g>>2]=e;l=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>l>>>0){m=(c[b+1744>>2]|0)+(l<<2)|0;if(m)c[m>>2]=e;c[n>>2]=l+1}else eZa(b+1724|0,g)|0;ko[c[(c[e>>2]|0)+16>>2]&4095](e);a[d>>0]=1;pTa(c[j>>2]|0);ko[c[(c[h>>2]|0)+20>>2]&4095](h);if(!(c[b+132>>2]|0)){q=h;i=f;return q|0}else{j=jia(c[b+1212>>2]|0,b+128|0,h)|0;ko[c[(c[h>>2]|0)+20>>2]&4095](h);q=j;i=f;return q|0}return 0}function hda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;h=b+1612|0;j=b+1700|0;oTa(c[j>>2]|0);k=b+1624|0;fTa(k)|0;l=b+1620|0;c[l>>2]=c[d+8>>2];c[g>>2]=d;m=b+1660|0;n=b+1656|0;o=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>o>>>0){p=(c[b+1652>>2]|0)+(o<<2)|0;if(p)c[p>>2]=d;c[n>>2]=o+1}else eZa(b+1632|0,g)|0;ko[c[(c[d>>2]|0)+16>>2]&4095](d);d=b+1696|0;a[d>>0]=1;pTa(c[j>>2]|0);oTa(c[j>>2]|0);fTa(k)|0;c[l>>2]=c[e+8>>2];c[g>>2]=e;l=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>l>>>0){m=(c[b+1652>>2]|0)+(l<<2)|0;if(m)c[m>>2]=e;c[n>>2]=l+1}else eZa(b+1632|0,g)|0;ko[c[(c[e>>2]|0)+16>>2]&4095](e);a[d>>0]=1;pTa(c[j>>2]|0);fZa(h);if(!(c[b+132>>2]|0)){q=h;i=f;return q|0}else{j=lia(c[b+1212>>2]|0,b+128|0,h)|0;fZa(h);q=j;i=f;return q|0}return 0}function ida(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0;f=i;i=i+16|0;h=f;j=c[d+1184>>2]|0;k=d+1176|0;l=c[k>>2]|0;m=c[k+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,65,l,m);k=d+48|0;if(!(ea(g[k>>2])!=ea(0.0))){n=c[j>>2]|0;o=n+12|0;p=c[o>>2]|0;Dn[p&511](j,65,l,m);i=f;return}q=d+1800|0;r=d+1888|0;oTa(c[r>>2]|0);fTa(d+1812|0)|0;c[d+1808>>2]=c[e+8>>2];c[h>>2]=e;s=d+1844|0;t=c[s>>2]|0;if((c[d+1848>>2]&2147483647)>>>0>t>>>0){u=(c[d+1840>>2]|0)+(t<<2)|0;if(u)c[u>>2]=e;c[s>>2]=t+1}else eZa(d+1820|0,h)|0;ko[c[(c[e>>2]|0)+16>>2]&4095](e);a[d+1884>>0]=1;pTa(c[r>>2]|0);ko[c[(c[q>>2]|0)+20>>2]&4095](q);if(!(b[d+1200>>1]&4)){c[d+1980>>2]=1;r=d+1976|0;c[r>>2]=q;ko[c[(c[q>>2]|0)+16>>2]&4095](q);c[d+1972>>2]=c[(c[r>>2]|0)+8>>2]}else{r=d+1896|0;c[d+1912>>2]=1;e=d+1908|0;c[e>>2]=q;ko[c[(c[q>>2]|0)+16>>2]&4095](q);c[d+1904>>2]=c[(c[e>>2]|0)+8>>2];c[d+1980>>2]=1;e=d+1976|0;c[e>>2]=r;ko[c[(c[r>>2]|0)+16>>2]&4095](r);c[d+1972>>2]=c[(c[e>>2]|0)+8>>2];ko[c[(c[r>>2]|0)+20>>2]&4095](r)}r=d+1964|0;e=d+152|0;a:do if(!(c[e>>2]|0))v=17;else{t=d+144|0;s=d+140|0;u=0;while(1){if(u>>>0>=(c[t>>2]|0)>>>0){v=17;break a}Ika(h,c[(c[s>>2]|0)+(u<<2)>>2]|0);if(!(b[h>>1]&4))u=u+1|0;else break}u=c[e>>2]|0;w=ea(g[k>>2]);s=ro[c[(c[u>>2]|0)+16>>2]&7](u,w,r)|0;c[d+1572>>2]=1;u=d+1568|0;c[u>>2]=s;if(s){ko[c[(c[s>>2]|0)+16>>2]&4095](s);c[d+1564>>2]=c[(c[u>>2]|0)+8>>2]}ko[c[(c[s>>2]|0)+20>>2]&4095](s);x=d+1556|0}while(0);if((v|0)==17){ko[c[(c[r>>2]|0)+16>>2]&4095](r);x=r}v=d+1992|0;c[d+2008>>2]=1;k=d+2004|0;c[k>>2]=x;ko[c[(c[x>>2]|0)+16>>2]&4095](x);c[d+2e3>>2]=c[(c[k>>2]|0)+8>>2];k=d+2076|0;c[d+2092>>2]=1;e=d+2088|0;c[e>>2]=v;ko[c[(c[v>>2]|0)+16>>2]&4095](v);c[d+2084>>2]=c[(c[e>>2]|0)+8>>2];e=d+2104|0;c[d+2120>>2]=1;h=d+2116|0;c[h>>2]=k;ko[c[(c[k>>2]|0)+16>>2]&4095](k);c[d+2112>>2]=c[(c[h>>2]|0)+8>>2];ko[c[(c[q>>2]|0)+20>>2]&4095](q);ko[c[(c[r>>2]|0)+20>>2]&4095](r);ko[c[(c[x>>2]|0)+20>>2]&4095](x);ko[c[(c[v>>2]|0)+20>>2]&4095](v);ko[c[(c[k>>2]|0)+20>>2]&4095](k);ko[c[(c[e>>2]|0)+20>>2]&4095](e);n=c[j>>2]|0;o=n+12|0;p=c[o>>2]|0;Dn[p&511](j,65,l,m);i=f;return}function jda(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0;f=i;i=i+16|0;h=f;j=d+1184|0;k=c[j>>2]|0;l=d+1176|0;m=l;n=c[m>>2]|0;o=c[m+4>>2]|0;Dn[c[(c[k>>2]|0)+8>>2]&511](k,65,n,o);if((a[536674]|0)!=0?(m=c[j>>2]|0,(m|0)!=0):0){j=l;En[c[(c[m>>2]|0)+16>>2]&127](m,b[268336]|0,c[j>>2]|0,c[j+4>>2]|0,99999789)}$fa(c[d+1192>>2]|0);j=d+1212|0;gta(c[(c[j>>2]|0)+1e3>>2]|0);m=d+132|0;if(c[m>>2]|0){l=d+128|0;p=0;do{bia(c[(c[l>>2]|0)+(p<<2)>>2]|0);p=p+1|0}while(p>>>0<(c[m>>2]|0)>>>0)}p=d+1800|0;c[d+1808>>2]=c[e+8>>2];ko[c[(c[p>>2]|0)+16>>2]&4095](p);l=d+1584|0;c[d+1600>>2]=1;q=d+1596|0;c[q>>2]=e;if(e){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[d+1592>>2]=c[(c[q>>2]|0)+8>>2]}q=d+2132|0;c[d+2148>>2]=1;e=d+2144|0;c[e>>2]=l;ko[c[(c[l>>2]|0)+16>>2]&4095](l);r=d+2140|0;c[r>>2]=c[(c[e>>2]|0)+8>>2];e=d+2160|0;s=d+2248|0;oTa(c[s>>2]|0);t=d+2172|0;fTa(t)|0;u=d+2168|0;c[u>>2]=c[r>>2];c[h>>2]=q;r=d+2208|0;v=d+2204|0;w=c[v>>2]|0;if((c[r>>2]&2147483647)>>>0>w>>>0){x=(c[d+2200>>2]|0)+(w<<2)|0;if(x)c[x>>2]=q;c[v>>2]=w+1}else eZa(d+2180|0,h)|0;ko[c[(c[q>>2]|0)+16>>2]&4095](q);w=d+2244|0;a[w>>0]=1;pTa(c[s>>2]|0);x=d+2256|0;c[d+2272>>2]=1;y=d+2268|0;c[y>>2]=e;ko[c[(c[e>>2]|0)+16>>2]&4095](e);z=d+2264|0;c[z>>2]=c[(c[y>>2]|0)+8>>2];y=d+1464|0;A=d+1552|0;oTa(c[A>>2]|0);B=d+1476|0;fTa(B)|0;C=d+1472|0;c[C>>2]=c[z>>2];c[h>>2]=x;z=d+1512|0;D=d+1508|0;E=c[D>>2]|0;if((c[z>>2]&2147483647)>>>0>E>>>0){F=(c[d+1504>>2]|0)+(E<<2)|0;if(F)c[F>>2]=x;c[D>>2]=E+1}else eZa(d+1484|0,h)|0;ko[c[(c[x>>2]|0)+16>>2]&4095](x);E=d+1548|0;a[E>>0]=1;pTa(c[A>>2]|0);if(c[m>>2]|0){ko[c[(c[p>>2]|0)+16>>2]&4095](p);if(!(c[m>>2]|0)){ko[c[(c[l>>2]|0)+16>>2]&4095](l);G=l}else G=mia(c[j>>2]|0,d+128|0,l)|0;F=hda(d,G,p)|0;if(!(c[m>>2]|0)){ko[c[(c[G>>2]|0)+16>>2]&4095](G);H=G}else H=kia(c[j>>2]|0,d+128|0,G)|0;j=gda(d,x,H)|0;oTa(c[s>>2]|0);fTa(t)|0;c[u>>2]=c[F+8>>2];c[h>>2]=F;u=c[v>>2]|0;if((c[r>>2]&2147483647)>>>0>u>>>0){r=(c[d+2200>>2]|0)+(u<<2)|0;if(r)c[r>>2]=F;c[v>>2]=u+1}else eZa(d+2180|0,h)|0;ko[c[(c[F>>2]|0)+16>>2]&4095](F);a[w>>0]=1;pTa(c[s>>2]|0);ko[c[(c[e>>2]|0)+20>>2]&4095](e);oTa(c[A>>2]|0);fTa(B)|0;c[C>>2]=c[j+8>>2];c[h>>2]=j;s=c[D>>2]|0;if((c[z>>2]&2147483647)>>>0>s>>>0){w=(c[d+1504>>2]|0)+(s<<2)|0;if(w)c[w>>2]=j;c[D>>2]=s+1}else eZa(d+1484|0,h)|0;ko[c[(c[j>>2]|0)+16>>2]&4095](j);a[E>>0]=1;pTa(c[A>>2]|0);fZa(y);ko[c[(c[p>>2]|0)+20>>2]&4095](p);ko[c[(c[G>>2]|0)+20>>2]&4095](G);ko[c[(c[F>>2]|0)+20>>2]&4095](F);ko[c[(c[H>>2]|0)+20>>2]&4095](H);ko[c[(c[j>>2]|0)+20>>2]&4095](j)}fda(d,p);j=d+152|0;a:do if(!(c[j>>2]|0))I=44;else{H=d+144|0;F=d+140|0;G=0;while(1){if(G>>>0>=(c[H>>2]|0)>>>0)break;Ika(h,c[(c[F>>2]|0)+(G<<2)>>2]|0);if(!(b[h>>1]&4))G=G+1|0;else{I=44;break a}}G=c[j>>2]|0;J=ea(g[d+48>>2]);F=ro[c[(c[G>>2]|0)+16>>2]&7](G,J,p)|0;c[d+1572>>2]=1;G=d+1568|0;c[G>>2]=F;if(F){ko[c[(c[F>>2]|0)+16>>2]&4095](F);c[d+1564>>2]=c[(c[G>>2]|0)+8>>2]}ko[c[(c[F>>2]|0)+20>>2]&4095](F);K=d+1556|0}while(0);if((I|0)==44){ko[c[(c[p>>2]|0)+16>>2]&4095](p);K=p}oTa(c[A>>2]|0);fTa(B)|0;c[C>>2]=c[K+8>>2];c[h>>2]=K;C=c[D>>2]|0;if((c[z>>2]&2147483647)>>>0<=C>>>0){eZa(d+1484|0,h)|0;L=c[K>>2]|0;M=L+16|0;N=c[M>>2]|0;ko[N&4095](K);a[E>>0]=1;O=c[A>>2]|0;pTa(O);fZa(y);P=c[K>>2]|0;Q=P+20|0;R=c[Q>>2]|0;ko[R&4095](K);S=c[l>>2]|0;T=S+20|0;U=c[T>>2]|0;ko[U&4095](l);V=c[q>>2]|0;W=V+20|0;X=c[W>>2]|0;ko[X&4095](q);Y=c[e>>2]|0;Z=Y+20|0;_=c[Z>>2]|0;ko[_&4095](e);$=c[x>>2]|0;aa=$+20|0;ba=c[aa>>2]|0;ko[ba&4095](x);fZa(y);ca=c[k>>2]|0;da=ca+12|0;fa=c[da>>2]|0;Dn[fa&511](k,65,n,o);i=f;return}h=(c[d+1504>>2]|0)+(C<<2)|0;if(h)c[h>>2]=K;c[D>>2]=C+1;L=c[K>>2]|0;M=L+16|0;N=c[M>>2]|0;ko[N&4095](K);a[E>>0]=1;O=c[A>>2]|0;pTa(O);fZa(y);P=c[K>>2]|0;Q=P+20|0;R=c[Q>>2]|0;ko[R&4095](K);S=c[l>>2]|0;T=S+20|0;U=c[T>>2]|0;ko[U&4095](l);V=c[q>>2]|0;W=V+20|0;X=c[W>>2]|0;ko[X&4095](q);Y=c[e>>2]|0;Z=Y+20|0;_=c[Z>>2]|0;ko[_&4095](e);$=c[x>>2]|0;aa=$+20|0;ba=c[aa>>2]|0;ko[ba&4095](x);fZa(y);ca=c[k>>2]|0;da=ca+12|0;fa=c[da>>2]|0;Dn[fa&511](k,65,n,o);i=f;return}function kda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0;f=c[e+49848>>2]|0;g=c[e+49836>>2]|0;h=a+1184|0;j=c[h>>2]|0;k=a+1176|0;l=k;m=c[l>>2]|0;n=c[l+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,67,m,n);l=a+1088|0;kba(c[l>>2]|0,c[e+49832>>2]|0,g,b);hpa(e);Dn[c[(c[j>>2]|0)+12>>2]&511](j,67,m,n);n=c[h>>2]|0;h=k;k=c[h>>2]|0;m=c[h+4>>2]|0;Dn[c[(c[n>>2]|0)+8>>2]&511](n,68,k,m);if(!f){ipa(e);o=c[n>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](n,68,k,m);i=d;return}h=f;f=c[e+49844>>2]|0;while(1){h=h+-1|0;lba(c[l>>2]|0,c[f>>2]|0,c[f+4>>2]|0,b);if(!h)break;else f=f+8|0}ipa(e);o=c[n>>2]|0;p=o+12|0;q=c[p>>2]|0;Dn[q&511](n,68,k,m);i=d;return}function lda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+64|0;e=d+32|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d;k=d+24|0;l=c[(c[b+1212>>2]|0)+1e3>>2]|0;m=c[b+1184>>2]|0;n=b+1176|0;o=c[n>>2]|0;p=c[n+4>>2]|0;Dn[c[(c[m>>2]|0)+8>>2]&511](m,75,o,p);c[h>>2]=0;cta(l,f,g,0)|0;n=c[f>>2]<<3;q=n>>>0>1024;r=j+4|0;a[r>>0]=q&1;if(q){q=sKa(d+49|0,n,467192,1238)|0;c[j>>2]=q;s=q}else{q=i;i=i+((1*n|0)+15&-16)|0;c[j>>2]=q;s=q}q=c[g>>2]<<3;n=q>>>0>1024;t=k+4|0;a[t>>0]=n&1;if(n){n=sKa(d+48|0,q,467192,1239)|0;c[k>>2]=n;u=j;v=c[j>>2]|0;w=n}else{n=i;i=i+((1*q|0)+15&-16)|0;c[k>>2]=n;u=j;v=s;w=n}dta(l,v,f,w,g,0,h)|0;if((c[f>>2]|0)>0){h=0;do{kfa(c[(c[u>>2]|0)+(h<<3)+4>>2]|0,0,1);h=h+1|0}while((h|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=e+4|0;h=e+8|0;w=e+12|0;v=b+1248|0;l=b+1256|0;n=b+1252|0;s=0;do{q=c[(c[k>>2]|0)+(s<<3)+4>>2]|0;do if(lfa(q,0,1)|0){x=Mfa(c[q+32>>2]|0)|0;y=Mfa(c[q+36>>2]|0)|0;c[e>>2]=x;c[f>>2]=y;c[h>>2]=c[x+56>>2];c[w>>2]=c[y+56>>2];y=c[n>>2]|0;if((c[l>>2]&2147483647)>>>0<=y>>>0){gZa(v,e)|0;break}x=(c[v>>2]|0)+(y<<4)|0;if(!x)z=y;else{c[x+0>>2]=c[e+0>>2];c[x+4>>2]=c[e+4>>2];c[x+8>>2]=c[e+8>>2];c[x+12>>2]=c[e+12>>2];z=c[n>>2]|0}c[n>>2]=z+1}while(0);s=s+1|0}while((s|0)<(c[g>>2]|0))}Dba(c[b+1088>>2]|0);if(a[t>>0]|0)tKa(k,c[k>>2]|0);if(!(a[r>>0]|0)){A=c[m>>2]|0;B=A+12|0;C=c[B>>2]|0;Dn[C&511](m,75,o,p);i=d;return}tKa(j,c[u>>2]|0);A=c[m>>2]|0;B=A+12|0;C=c[B>>2]|0;Dn[C&511](m,75,o,p);i=d;return}function mda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;c[f>>2]=b;c[f+4>>2]=d;c[f+8>>2]=c[b+56>>2];c[f+12>>2]=c[d+56>>2];d=a+1248|0;b=a+1252|0;g=c[b>>2]|0;if((c[a+1256>>2]&2147483647)>>>0<=g>>>0){gZa(d,f)|0;i=e;return}a=(c[d>>2]|0)+(g<<4)|0;if(!a)h=g;else{c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];h=c[b>>2]|0}c[b>>2]=h+1;i=e;return}function nda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;d=a+1212|0;e=Via(c[d>>2]|0)|0;f=c[e+292>>2]|0;h=(c[e+296>>2]|0)-f|0;j=e+284|0;k=c[j>>2]|0;if(!f)l=k;else{m=0;do{n=c[k+(h+m<<2)>>2]|0;o=n;if(!(o&15))if(!n){p=0;q=6}else uia(n,0,2);else{p=o&-2;q=6}if((q|0)==6){q=0;B8(p,0,2)}m=m+1|0}while((m|0)!=(f|0));l=c[j>>2]|0}j=c[e+288>>2]|0;if(j){f=0;do{m=c[l+(f<<2)>>2]|0;p=m;if(!(p&15))if(!m){r=0;q=14}else uia(m,1,2);else{r=p&-2;q=14}if((q|0)==14){q=0;B8(r,1,2)}f=f+1|0}while((f|0)!=(j|0))}j=c[a+1184>>2]|0;f=a+1176|0;r=c[f>>2]|0;q=c[f+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,70,r,q);Aba(c[a+1088>>2]|0);Dn[c[(c[j>>2]|0)+12>>2]&511](j,70,r,q);Rua(e);q=c[e+304>>2]|0;if(!q){i=b;return}r=c[e+300>>2]|0;e=a+2020|0;j=a+1992|0;c[a+2036>>2]=1;f=a+2032|0;c[f>>2]=j;ko[c[(c[j>>2]|0)+16>>2]&4095](j);c[a+2028>>2]=c[(c[f>>2]|0)+8>>2];f=a+2048|0;c[a+2064>>2]=1;j=a+2060|0;c[j>>2]=e;ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[a+2056>>2]=c[(c[j>>2]|0)+8>>2];ata(c[(c[d>>2]|0)+1e3>>2]|0,ea(g[a+48>>2]),r,q,f);ko[c[(c[e>>2]|0)+20>>2]&4095](e);ko[c[(c[f>>2]|0)+20>>2]&4095](f);i=b;return}function oda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+4|0;j=e+24|0;k=e+16|0;l=b+1212|0;m=Via(c[l>>2]|0)|0;n=b+1184|0;o=c[n>>2]|0;p=b+1176|0;b=p;q=c[b>>2]|0;r=c[b+4>>2]|0;Dn[c[(c[o>>2]|0)+8>>2]&511](o,77,q,r);c[h>>2]=0;b=c[(c[l>>2]|0)+1e3>>2]|0;cta(b,f,g,0)|0;l=c[f>>2]<<3;s=l>>>0>1024;t=j+4|0;a[t>>0]=s&1;if(s){s=sKa(e+33|0,l,467192,1393)|0;c[j>>2]=s;u=s}else{s=i;i=i+((1*l|0)+15&-16)|0;c[j>>2]=s;u=s}s=c[g>>2]<<3;l=s>>>0>1024;v=k+4|0;a[v>>0]=l&1;if(l){l=sKa(e+32|0,s,467192,1394)|0;c[k>>2]=l;w=j;x=c[j>>2]|0;y=l}else{l=i;i=i+((1*s|0)+15&-16)|0;c[k>>2]=l;w=j;x=u;y=l}dta(b,x,f,y,g,0,h)|0;if((c[f>>2]|0)>0){h=0;do{xfa(c[(c[w>>2]|0)+(h<<3)+4>>2]|0,m,1);h=h+1|0}while((h|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=0;do{xfa(c[(c[k>>2]|0)+(f<<3)+4>>2]|0,m,0);f=f+1|0}while((f|0)<(c[g>>2]|0))}if(a[v>>0]|0)tKa(k,c[k>>2]|0);if(!(a[t>>0]|0)){z=c[o>>2]|0;A=z+12|0;B=c[A>>2]|0;Dn[B&511](o,77,q,r);C=c[n>>2]|0;D=p;E=D;F=c[E>>2]|0;G=D+4|0;H=G;I=c[H>>2]|0;J=c[C>>2]|0;K=J+8|0;L=c[K>>2]|0;Dn[L&511](C,78,F,I);Xua(m,d,0);M=c[C>>2]|0;N=M+12|0;O=c[N>>2]|0;Dn[O&511](C,78,F,I);i=e;return}tKa(j,c[w>>2]|0);z=c[o>>2]|0;A=z+12|0;B=c[A>>2]|0;Dn[B&511](o,77,q,r);C=c[n>>2]|0;D=p;E=D;F=c[E>>2]|0;G=D+4|0;H=G;I=c[H>>2]|0;J=c[C>>2]|0;K=J+8|0;L=c[K>>2]|0;Dn[L&511](C,78,F,I);Xua(m,d,0);M=c[C>>2]|0;N=M+12|0;O=c[N>>2]|0;Dn[O&511](C,78,F,I);i=e;return}function pda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;d=Via(c[a+1212>>2]|0)|0;e=c[a+1184>>2]|0;f=a+1176|0;a=c[f>>2]|0;g=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,79,a,g);f=c[d+292>>2]|0;h=(c[d+296>>2]|0)-f|0;j=c[d+284>>2]|0;if(f){k=0;do{l=c[j+(h+k<<2)>>2]|0;m=l;if(!(m&15))if(!l){n=0;o=6}else uia(l,0,4);else{n=m&-2;o=6}if((o|0)==6){o=0;B8(n,0,4)}k=k+1|0}while((k|0)!=(f|0))}Sua(d);f=c[d+300>>2]|0;k=c[d+304>>2]|0;if(!k){p=c[e>>2]|0;q=p+12|0;r=c[q>>2]|0;Dn[r&511](e,79,a,g);i=b;return}else s=0;do{yfa(c[(c[f+(s<<3)>>2]|0)+12>>2]|0);s=s+1|0}while((s|0)!=(k|0));p=c[e>>2]|0;q=p+12|0;r=c[q>>2]|0;Dn[r&511](e,79,a,g);i=b;return}function qda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+1212|0;Xsa(c[(c[e>>2]|0)+1e3>>2]|0);Zsa(c[(c[e>>2]|0)+1e3>>2]|0);f=c[e>>2]|0;h=c[f>>2]|0;j=c[f+4>>2]|0;f=h+(j<<2)|0;if((j|0)<=0){rda(a);k=c[e>>2]|0;l=k+1e3|0;m=c[l>>2]|0;n=a+48|0;o=ea(g[n>>2]);p=a+1120|0;fta(m,o,b,p);i=d;return}q=h+(j+-1<<2)|0;j=h;r=h+32|0;while(1){if(r>>>0>q>>>0)s=r;else{h=c[r>>2]|0;t=h;u=VEi(t|0,0,6)|0;v=H;w=_Ei(t|0,0,511,0)|0;t=VEi(w|0,H|0,6)|0;w=H;x=ZEi(1,0,u|0,v|0)|0;v=_Ei(x|0,H|0,t|0,w|0)|0;w=v;v=H;t=h;while(1){w=_Ei(w|0,v|0,-1,-1)|0;v=H;if((w|0)==0&(v|0)==0)break;else t=t+64|0}s=r+4|0}t=c[j>>2]|0;v=c[t+128>>2]|0;g[t+96>>2]=ea(g[v>>2]);g[t+100>>2]=ea(g[v+4>>2]);g[t+104>>2]=ea(g[v+8>>2]);g[t+108>>2]=ea(g[v+12>>2]);g[t+112>>2]=ea(g[v+16>>2]);g[t+116>>2]=ea(g[v+20>>2]);g[t+120>>2]=ea(g[v+24>>2]);j=j+4|0;if(j>>>0>=f>>>0)break;else r=s}rda(a);k=c[e>>2]|0;l=k+1e3|0;m=c[l>>2]|0;n=a+48|0;o=ea(g[n>>2]);p=a+1120|0;fta(m,o,b,p);i=d;return}function rda(a){a=a|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0;d=i;e=c[a+1184>>2]|0;f=a+1176|0;h=c[f>>2]|0;j=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,80,h,j);f=c[(c[a+1212>>2]|0)+1e3>>2]|0;k=c[f+6576>>2]|0;l=c[f+6584>>2]|0;m=c[f+6560>>2]|0;n=c[f+6564>>2]|0;f=a+44|0;o=(c[f>>2]|0)!=0;p=(b[a+1200>>1]&16)!=0;q=a+32|0;if(!n){c[f>>2]=0;r=c[e>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](e,80,h,j);i=d;return}u=a+48|0;v=a+52|0;a=0;do{w=m+(a<<4)+4|0;x=c[w>>2]|0;y=(x|0)<0;z=c[m+(a<<4)>>2]|0;a=a+1|0;A=c[m+(a<<4)>>2]|0;if(z>>>0<A>>>0){B=A+-1|0;B=z;do{z=B;B=B+1|0;C=ea(g[u>>2]);N9((c[k+(z<<2)>>2]|0)+-64|0,C,ea(g[v>>2]),o,q,y,p)}while((B|0)!=(A|0));D=c[w>>2]|0}else D=x;A=D&2147483647;B=c[m+(a<<4)+4>>2]|0;z=B&2147483647;if(A>>>0<z>>>0){E=z+-1|0;z=B&2147483647;B=A;do{A=B;B=B+1|0;C=ea(g[u>>2]);C8(c[l+(A<<2)>>2]|0,C,ea(g[v>>2]),o,q,y,p)}while((B|0)!=(z|0))}}while((a|0)!=(n|0));c[f>>2]=0;r=c[e>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](e,80,h,j);i=d;return}function sda(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f=i;i=i+96|0;g=f+56|0;h=f+28|0;j=f;if(!(b[d+1200>>1]&4)){i=f;return}if(a[d+2372>>0]|0)tda(d);k=d+1948|0;l=d+1952|0;m=c[l>>2]|0;if((m|0)!=2){n=c[k>>2]|0;o=n+(m*28|0)|0;if((m|0)>0){m=n;do{ko[c[c[m>>2]>>2]&4095](m);m=m+28|0}while(m>>>0<o>>>0)}c[l>>2]=0;o=d+1924|0;m=c[o>>2]|0;n=d+1928|0;p=c[n>>2]|0;q=m+(p*28|0)|0;if((p|0)>0){p=m;do{ko[c[c[p>>2]>>2]&4095](p);p=p+28|0}while(p>>>0<q>>>0)}c[n>>2]=0;q=d+1936|0;p=c[q>>2]|0;m=d+1940|0;r=c[m>>2]|0;s=p+(r*28|0)|0;if((r|0)>0){r=p;do{ko[c[c[r>>2]>>2]&4095](r);r=r+28|0}while(r>>>0<s>>>0)}c[m>>2]=0;s=d+1956|0;if((c[s>>2]&2147483646)>>>0<2)hZa(k,2);r=d+1932|0;if((c[r>>2]&2147483646)>>>0<2)iZa(o,2);p=d+1944|0;if((c[p>>2]&2147483646)>>>0<2)jZa(q,2);t=g+4|0;u=g+6|0;v=g+8|0;w=g+12|0;x=g+16|0;y=g+20|0;z=g+24|0;A=h+4|0;B=h+6|0;C=h+8|0;D=h+12|0;E=h+16|0;F=h+20|0;G=h+24|0;H=j+4|0;I=j+6|0;J=j+8|0;K=j+12|0;L=j+16|0;M=j+20|0;N=j+24|0;O=0;do{b[t>>1]=-1;b[u>>1]=0;c[v>>2]=0;c[g>>2]=443968;c[w>>2]=0;c[x>>2]=0;c[g>>2]=469400;c[y>>2]=d;c[z>>2]=467376;P=c[l>>2]|0;if((c[s>>2]&2147483647)>>>0>P>>>0){Q=c[k>>2]|0;R=Q+(P*28|0)|0;S=t;T=c[S>>2]|0;U=c[S+4>>2]|0;S=Q+(P*28|0)+4|0;V=S;b[V>>1]=T;b[V+2>>1]=T>>>16;T=S+4|0;b[T>>1]=U;b[T+2>>1]=U>>>16;c[R>>2]=443968;U=Q+(P*28|0)+12|0;c[U>>2]=c[w>>2];c[Q+(P*28|0)+16>>2]=c[x>>2];c[U>>2]=c[w>>2];c[R>>2]=469400;R=y;U=c[R+4>>2]|0;T=Q+(P*28|0)+20|0;c[T>>2]=c[R>>2];c[T+4>>2]=U;c[l>>2]=(c[l>>2]|0)+1}else kZa(k,g)|0;c[g>>2]=443968;c[v>>2]=0;b[A>>1]=-1;b[B>>1]=0;c[C>>2]=0;c[h>>2]=443968;c[D>>2]=0;c[E>>2]=0;c[h>>2]=469152;c[F>>2]=d;c[G>>2]=467400;U=c[n>>2]|0;if((c[r>>2]&2147483647)>>>0>U>>>0){T=c[o>>2]|0;R=T+(U*28|0)|0;P=A;Q=c[P>>2]|0;S=c[P+4>>2]|0;P=T+(U*28|0)+4|0;V=P;b[V>>1]=Q;b[V+2>>1]=Q>>>16;Q=P+4|0;b[Q>>1]=S;b[Q+2>>1]=S>>>16;c[R>>2]=443968;S=T+(U*28|0)+12|0;c[S>>2]=c[D>>2];c[T+(U*28|0)+16>>2]=c[E>>2];c[S>>2]=c[D>>2];c[R>>2]=469152;R=F;S=c[R+4>>2]|0;Q=T+(U*28|0)+20|0;c[Q>>2]=c[R>>2];c[Q+4>>2]=S;c[n>>2]=(c[n>>2]|0)+1}else lZa(o,h)|0;c[h>>2]=443968;c[C>>2]=0;b[H>>1]=-1;b[I>>1]=0;c[J>>2]=0;c[j>>2]=443968;c[K>>2]=0;c[L>>2]=0;c[j>>2]=468872;c[M>>2]=d;c[N>>2]=467432;S=c[m>>2]|0;if((c[p>>2]&2147483647)>>>0>S>>>0){Q=c[q>>2]|0;R=Q+(S*28|0)|0;U=H;T=c[U>>2]|0;P=c[U+4>>2]|0;U=Q+(S*28|0)+4|0;V=U;b[V>>1]=T;b[V+2>>1]=T>>>16;T=U+4|0;b[T>>1]=P;b[T+2>>1]=P>>>16;c[R>>2]=443968;P=Q+(S*28|0)+12|0;c[P>>2]=c[K>>2];c[Q+(S*28|0)+16>>2]=c[L>>2];c[P>>2]=c[K>>2];c[R>>2]=468872;R=M;P=c[R+4>>2]|0;T=Q+(S*28|0)+20|0;c[T>>2]=c[R>>2];c[T+4>>2]=P;c[m>>2]=(c[m>>2]|0)+1}else mZa(q,j)|0;c[j>>2]=443968;c[J>>2]=0;O=O+1|0}while((O|0)!=2)}O=d+1212|0;bta(c[(c[O>>2]|0)+1e3>>2]|0);sta(c[(c[O>>2]|0)+1e3>>2]|0);O=d+1936|0;d=c[O>>2]|0;c[d+16>>2]=1;J=d+12|0;c[J>>2]=e;if(e){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[d+8>>2]=c[(c[J>>2]|0)+8>>2]}J=c[O>>2]|0;ko[c[(c[J>>2]|0)+20>>2]&4095](J);i=f;return}function tda(d){d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;if(!(a[d+2372>>0]|0)){i=f;return}h=d+1088|0;d=c[h>>2]|0;j=c[d+4>>2]|0;k=c[d+8>>2]|0;if(!k){i=f;return}d=k+-1|0;d=0;while(1){l=c[j+(d<<2)>>2]|0;m=l+20|0;n=c[m>>2]|0;if(!n){m7(l);o=c[m>>2]|0}else o=n;n=o+10|0;m=e[n>>1]|0;if(!(m&2)){p=c[(c[h>>2]|0)+44>>2]|0;q=c[o>>2]|0;r=d+1|0;if(r>>>0<k>>>0){s=c[j+(r<<2)>>2]|0;t=s+20|0;u=c[t>>2]|0;if(!u){m7(s);v=c[t>>2]|0}else v=u}if((b[o+8>>1]|0)==0|(m&8|0)==0)w=r;else{m=c[l>>2]|0;u=c[l+4>>2]|0;if(!(a[m+50>>0]|0)){g[p+(q+12)>>2]=ea(0.0);g[p+(q+16)>>2]=ea(0.0);g[p+(q+20)>>2]=ea(0.0);g[p+(q+36)>>2]=ea(0.0);g[p+(q+40)>>2]=ea(0.0);g[p+(q+44)>>2]=ea(0.0)}else{l=c[m+52>>2]|0;g[p+(q+12)>>2]=ea(g[l+80>>2]);g[p+(q+16)>>2]=ea(g[l+84>>2]);g[p+(q+20)>>2]=ea(g[l+88>>2]);g[p+(q+36)>>2]=ea(g[l+96>>2]);g[p+(q+40)>>2]=ea(g[l+100>>2]);g[p+(q+44)>>2]=ea(g[l+104>>2])}if(!(a[u+50>>0]|0)){g[p+(q+24)>>2]=ea(0.0);g[p+(q+28)>>2]=ea(0.0);g[p+(q+32)>>2]=ea(0.0);g[p+(q+48)>>2]=ea(0.0);g[p+(q+52)>>2]=ea(0.0);g[p+(q+56)>>2]=ea(0.0)}else{l=c[u+52>>2]|0;g[p+(q+24)>>2]=ea(g[l+80>>2]);g[p+(q+28)>>2]=ea(g[l+84>>2]);g[p+(q+32)>>2]=ea(g[l+88>>2]);g[p+(q+48)>>2]=ea(g[l+96>>2]);g[p+(q+52)>>2]=ea(g[l+100>>2]);g[p+(q+56)>>2]=ea(g[l+104>>2])}b[n>>1]=e[n>>1]&65527;w=r}}else w=d+1|0;if((w|0)==(k|0))break;else d=w}i=f;return}function uda(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if((a[536570]|0)!=0?(g=c[d+1184>>2]|0,(g|0)!=0):0){h=d+1176|0;En[c[(c[g>>2]|0)+16>>2]&127](g,b[268284]|0,c[h>>2]|0,c[h+4>>2]|0,99999789)}h=c[(c[d+1212>>2]|0)+1e3>>2]|0;g=qta(h)|0;j=ota(h)|0;if((g|0)!=0?(rta(h)|0)==0:0){i=f;return}k=g&1;l=k^1;m=j+-1|0;j=(g|0)!=(m|0);if(j?(n=c[d+1936>>2]|0,c[n+(l*28|0)+16>>2]=1,o=n+(l*28|0)+12|0,c[o>>2]=e,(e|0)!=0):0){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[n+(l*28|0)+8>>2]=c[(c[o>>2]|0)+8>>2]}o=d+1948|0;n=c[o>>2]|0;if((g|0)==(m|0))p=e;else p=(c[d+1936>>2]|0)+(l*28|0)|0;c[n+(k*28|0)+16>>2]=1;e=n+(k*28|0)+12|0;c[e>>2]=p;if(p){ko[c[(c[p>>2]|0)+16>>2]&4095](p);c[n+(k*28|0)+8>>2]=c[(c[e>>2]|0)+8>>2]}e=d+1924|0;n=c[e>>2]|0;p=(c[o>>2]|0)+(k*28|0)|0;c[n+(k*28|0)+16>>2]=1;m=n+(k*28|0)+12|0;c[m>>2]=p;if(p){ko[c[(c[p>>2]|0)+16>>2]&4095](p);c[n+(k*28|0)+8>>2]=c[(c[m>>2]|0)+8>>2]}Wsa(h,(c[e>>2]|0)+(k*28|0)|0,1);h=(c[o>>2]|0)+(k*28|0)|0;ko[c[(c[h>>2]|0)+20>>2]&4095](h);h=(c[e>>2]|0)+(k*28|0)|0;ko[c[(c[h>>2]|0)+20>>2]&4095](h);if(!j){i=f;return}j=(c[d+1936>>2]|0)+(l*28|0)|0;ko[c[(c[j>>2]|0)+20>>2]&4095](j);i=f;return}function vda(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im;f=i;h=d+64|0;c[h>>2]=(c[h>>2]|0)+1;h=c[(c[d+1212>>2]|0)+1e3>>2]|0;kda(d,(qta(h)|0)+1|0);if((a[536570]|0)!=0?(j=c[d+1184>>2]|0,(j|0)!=0):0){k=d+1176|0;En[c[(c[j>>2]|0)+20>>2]&127](j,b[268284]|0,c[k>>2]|0,c[k+4>>2]|0,99999789)}bta(h);l=ea(g[d+48>>2]);tta(h,l,e,(b[d+1200>>1]&8)!=0);i=f;return}function wda(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=d+1212|0;g=c[(c[f>>2]|0)+1e3>>2]|0;h=g+44|0;zta(c[g+12>>2]|0);KAa(h);c[g+7368>>2]=HAa(h)|0;h=c[f>>2]|0;f=c[h+12>>2]|0;g=c[h>>2]|0;j=g+(f<<2)|0;k=c[h+1e3>>2]|0;if(f){h=k+5920|0;l=k+5924|0;m=k+5916|0;k=0;n=g+64|0;while(1){if(n>>>0<j>>>0){o=c[n>>2]|0;p=o;q=VEi(p|0,0,6)|0;r=H;s=_Ei(p|0,0,1023,0)|0;p=VEi(s|0,H|0,6)|0;s=H;t=ZEi(1,0,q|0,r|0)|0;r=_Ei(t|0,H|0,p|0,s|0)|0;s=r;r=H;p=o;while(1){s=_Ei(s|0,r|0,-1,-1)|0;r=H;if((s|0)==0&(r|0)==0)break;else p=p+64|0}u=n+4|0}else u=n;p=c[g+(k<<2)>>2]|0;L9(p);r=c[p+136>>2]|0;if((r|0)!=1073741823){p=(r+32|0)>>>5;if(p>>>0>(c[h>>2]&2147483647)>>>0){s=UJa(l,p<<2,543784,339)|0;o=c[m>>2]|0;if((o|0)!=0?(YEi(s|0,o|0,c[h>>2]<<2|0)|0,(c[h>>2]|0)>-1):0)VJa(l,c[m>>2]|0);o=c[h>>2]|0;PEi(s+((o&2147483647)<<2)|0,0,p-o<<2|0)|0;c[m>>2]=s;c[h>>2]=p;v=s}else v=c[m>>2]|0;s=v+(r>>>5<<2)|0;c[s>>2]=c[s>>2]|1<<(r&31)}k=k+1|0;if((k|0)==(f|0))break;else n=u}}xda(d);yda(d,0);if(!(a[536698]|0)){i=e;return}u=c[d+1184>>2]|0;if(!u){i=e;return}n=d+1176|0;En[c[(c[u>>2]|0)+20>>2]&127](u,b[268348]|0,c[n>>2]|0,c[n+4>>2]|0,99999789);i=e;return}function xda(b){b=b|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0;e=i;i=i+16|0;f=e;h=c[b+1212>>2]|0;j=c[h>>2]|0;k=c[h+4>>2]|0;h=j+(k<<2)|0;l=k<<2;m=l>>>0>1024;n=f+4|0;a[n>>0]=m&1;if(m)c[f>>2]=sKa(e+8|0,l,467192,1968)|0;else{l=i;i=i+((4*k|0)+15&-16)|0;c[f>>2]=l}l=b+48|0;o=ea(ea(1.0)/ea(g[l>>2]));m=b+1184|0;p=c[m>>2]|0;q=b+1176|0;r=q;s=c[r>>2]|0;t=c[r+4>>2]|0;Dn[c[(c[p>>2]|0)+8>>2]&511](p,105,s,t);if((k|0)>0){r=j+(k+-1<<2)|0;k=b+1162|0;u=j;v=j+32|0;j=0;while(1){if(v>>>0>r>>>0)w=v;else{x=c[v>>2]|0;y=x;z=VEi(y|0,0,6)|0;A=H;B=_Ei(y|0,0,511,0)|0;y=VEi(B|0,H|0,6)|0;B=H;C=ZEi(1,0,z|0,A|0)|0;A=_Ei(C|0,H|0,y|0,B|0)|0;B=A;A=H;y=x;while(1){B=_Ei(B|0,A|0,-1,-1)|0;A=H;if((B|0)==0&(A|0)==0)break;else y=y+64|0}w=v+4|0}y=c[u>>2]|0;A=c[y+60>>2]|0;if(((A|0)!=0?(B=baa(A)|0,A=B+44|0,(a[A>>0]&2)==0):0)?(c[B+20>>2]|0)!=0:0){c[(c[f>>2]|0)+(j<<2)>>2]=B;a[A>>0]=d[A>>0]|2;D=j+1|0}else D=j;if((a[(c[y+52>>2]|0)+44>>0]&1)==0?(a[y+50>>0]|0)!=4:0){E=ea(g[l>>2]);J9(y,E,o,(a[k>>0]|0)!=0)}u=u+4|0;if(u>>>0>=h>>>0){F=D;break}else{v=w;j=D}}}else F=0;Dn[c[(c[p>>2]|0)+12>>2]&511](p,105,s,t);t=b+108|0;if(c[t>>2]|0){s=b+104|0;p=b+1162|0;b=0;do{E=ea(g[l>>2]);y8(c[c[(c[s>>2]|0)+(b<<2)>>2]>>2]|0,E,o,(a[p>>0]|0)!=0);b=b+1|0}while(b>>>0<(c[t>>2]|0)>>>0)}t=c[m>>2]|0;m=q;q=c[m>>2]|0;b=c[m+4>>2]|0;Dn[c[(c[t>>2]|0)+8>>2]&511](t,106,q,b);if(F){m=F;do{m=m+-1|0;eaa(c[(c[f>>2]|0)+(m<<2)>>2]|0);F=(c[(c[f>>2]|0)+(m<<2)>>2]|0)+44|0;a[F>>0]=d[F>>0]&253}while((m|0)!=0)}Dn[c[(c[t>>2]|0)+12>>2]&511](t,106,q,b);if(!(a[n>>0]|0)){i=e;return}tKa(f,c[f>>2]|0);i=e;return}function yda(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=0,Z=0,_=0,$=0;e=i;i=i+32|0;f=e+16|0;h=e+8|0;j=e;k=e+24|0;l=b+1184|0;m=c[l>>2]|0;n=b+1176|0;o=n;p=c[o>>2]|0;q=c[o+4>>2]|0;Dn[c[(c[m>>2]|0)+8>>2]&511](m,103,p,q);o=b+1212|0;r=c[(c[o>>2]|0)+1e3>>2]|0;s=r+5868|0;t=(c[r+5872>>2]|0)==0;nZa(r+5880|0,s);u=c[b+1088>>2]|0;c[f>>2]=c[u+32>>2];v=c[u+36>>2]|0;c[h>>2]=v;c[f+4>>2]=c[u+16>>2];c[h+4>>2]=c[u+20>>2];u=b+48|0;w=r+5884|0;x=r+5900|0;y=r+5896|0;z=r+5888|0;r=v;v=0;while(1){if(r){A=r;B=c[f+(v<<2)>>2]|0;do{A=A+-1|0;C=B;B=B+4|0;D=c[C>>2]|0;C=(A|0)==0;E=D+44|0;F=c[E>>2]|0;a:do if(F&448){G=F<<1&1048576;I=G|F&-1572865;c[E>>2]=I;b:do if(!t){J=c[D+12>>2]|0;K=a[J+50>>0]|0;if(K<<24>>24==1|K<<24>>24==4)L=J+64|0;else L=0;J=c[D+16>>2]|0;K=a[J+50>>0]|0;if(K<<24>>24==1|K<<24>>24==4)M=J+64|0;else M=0;N=ea(g[u>>2]);J=c[w>>2]|0;K=c[x>>2]|0;O=c[y>>2]|0;P=L>>>0<M>>>0;Q=P?L:M;R=P?M:L;P=c[z>>2]|0;S=R;T=_Ei(S|0,Q|0,-1,~S|0)|0;S=H;U=VEi(T|0,S|0,22)|0;V=U^T;T=H^S;S=cFi(V|0,T|0,13)|0;U=_Ei(V|0,T|0,~S|0,~H|0)|0;S=H;T=VEi(U|0,S|0,8)|0;V=gFi(T^U|0,H^S|0,9,0)|0;S=H;U=VEi(V|0,S|0,15)|0;T=U^V;V=H^S;S=cFi(T|0,V|0,27)|0;U=_Ei(T|0,V|0,~S|0,~H|0)|0;S=H;V=VEi(U|0,S|0,31)|0;S=c[J+((((V^U)>>>0)%(P>>>0)|0)<<2)>>2]|0;if((S|0)!=-1){P=c[s>>2]|0;U=S;while(1){W=c[O+(U<<3)>>2]|0;if((c[P+(W<<4)>>2]|0)==(Q|0)?(c[P+(W<<4)+4>>2]|0)==(R|0):0)break;S=c[K+(U<<2)>>2]|0;if((S|0)==-1)break b;else U=S}X=ea(g[O+(U<<3)+4>>2]);if(X>ea(N*ea(g[P+(W<<4)+12>>2]))){c[E>>2]=I|524288;if(!G){if(!(F&64))break a;jfa(D,64,0,0,0,d);break a}else{if(!(F&128))break a;jfa(D,128,0,0,0,d);break a}}}}while(0);if(!((G|0)==0|(F&256|0)==0))jfa(D,256,0,0,0,d)}while(0)}while(!C)}A=v+1|0;if((A|0)==2)break;r=c[h+(A<<2)>>2]|0;v=A}Nua(Via(c[o>>2]|0)|0);v=c[o>>2]|0;o=(c[v+1e3>>2]|0)+7384|0;h=c[v>>2]|0;r=c[v+4>>2]|0;v=h+(r<<2)|0;d=r<<2;W=d>>>0>1024;s=j+4|0;a[s>>0]=W&1;if(W)c[j>>2]=sKa(k,d,467192,2106)|0;else{d=i;i=i+((4*r|0)+15&-16)|0;c[j>>2]=d}d=c[l>>2]|0;l=n;n=c[l>>2]|0;k=c[l+4>>2]|0;Dn[c[(c[d>>2]|0)+8>>2]&511](d,104,n,k);if((r|0)>0){l=h+(r+-1<<2)|0;r=h;W=h+32|0;while(1){h=c[r>>2]|0;if(W>>>0>l>>>0)Y=W;else{z=c[W>>2]|0;L=z;M=VEi(L|0,0,6)|0;y=H;x=_Ei(L|0,0,511,0)|0;L=VEi(x|0,H|0,6)|0;x=H;w=ZEi(1,0,M|0,y|0)|0;y=_Ei(w|0,H|0,L|0,x|0)|0;x=y;y=H;L=z;while(1){x=_Ei(x|0,y|0,-1,-1)|0;y=H;if((x|0)==0&(y|0)==0)break;else L=L+64|0}Y=W+4|0}r9(h,o);r=r+4|0;if(r>>>0>=v>>>0)break;else W=Y}}Dn[c[(c[d>>2]|0)+12>>2]&511](d,104,n,k);k=b+108|0;if(c[k>>2]|0){n=b+104|0;b=0;do{u8(c[c[(c[n>>2]|0)+(b<<2)>>2]>>2]|0,o);b=b+1|0}while(b>>>0<(c[k>>2]|0)>>>0)}if(!(a[s>>0]|0)){Z=c[m>>2]|0;_=Z+12|0;$=c[_>>2]|0;Dn[$&511](m,103,p,q);i=e;return}tKa(j,c[j>>2]|0);Z=c[m>>2]|0;_=Z+12|0;$=c[_>>2]|0;Dn[$&511](m,103,p,q);i=e;return}function zda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+64|0;e=d+16|0;f=d+36|0;g=d+8|0;h=d+32|0;j=d+48|0;k=d+40|0;l=d;m=c[(c[b+1212>>2]|0)+1e3>>2]|0;n=qta(m)|0;cta(m,f,g,h)|0;o=c[f>>2]<<3;p=o>>>0>1024;q=j+4|0;a[q>>0]=p&1;if(p)c[j>>2]=sKa(d+56|0,o,467192,1675)|0;else{p=i;i=i+((1*o|0)+15&-16)|0;c[j>>2]=p}p=c[g>>2]<<3;o=p>>>0>1024;r=k+4|0;a[r>>0]=o&1;if(o){o=sKa(d+57|0,p,467192,1676)|0;c[k>>2]=o;s=o}else{o=i;i=i+((1*p|0)+15&-16)|0;c[k>>2]=o;s=o}o=c[h>>2]<<3;p=o>>>0>1024;t=l+4|0;a[t>>0]=p&1;if(p){p=sKa(d+58|0,o,467192,1677)|0;c[l>>2]=p;u=k;v=c[k>>2]|0;w=p}else{p=i;i=i+((1*o|0)+15&-16)|0;c[l>>2]=p;u=k;v=s;w=p}p=c[j>>2]|0;dta(m,p,f,v,g,w,h)|0;a:do if((c[f>>2]|0)>0){w=p;v=0;while(1){kfa(c[w+(v<<3)+4>>2]|0,n,1);m=v+1|0;if((m|0)>=(c[f>>2]|0))break a;w=c[j>>2]|0;v=m}}while(0);if((c[g>>2]|0)>0){f=e+4|0;p=e+8|0;v=e+12|0;w=b+1248|0;m=b+1256|0;s=b+1252|0;o=0;do{x=c[(c[u>>2]|0)+(o<<3)+4>>2]|0;do if(lfa(x,n,1)|0){y=Mfa(c[x+32>>2]|0)|0;z=Mfa(c[x+36>>2]|0)|0;c[e>>2]=y;c[f>>2]=z;c[p>>2]=c[y+56>>2];c[v>>2]=c[z+56>>2];z=c[s>>2]|0;if((c[m>>2]&2147483647)>>>0<=z>>>0){gZa(w,e)|0;break}y=(c[w>>2]|0)+(z<<4)|0;if(!y)A=z;else{c[y+0>>2]=c[e+0>>2];c[y+4>>2]=c[e+4>>2];c[y+8>>2]=c[e+8>>2];c[y+12>>2]=c[e+12>>2];A=c[s>>2]|0}c[s>>2]=A+1}while(0);o=o+1|0}while((o|0)<(c[g>>2]|0))}g=c[h>>2]|0;if((g|0)>0){o=g;g=0;while(1){A=c[(c[l>>2]|0)+(g<<3)+4>>2]|0;if(!(c[A+44>>2]&32))B=o;else{jfa(A,32,0,0,0,n);B=c[h>>2]|0}g=g+1|0;if((g|0)>=(B|0))break;else o=B}}yda(b,n);if(a[t>>0]|0)tKa(l,c[l>>2]|0);if(a[r>>0]|0)tKa(k,c[u>>2]|0);if(!(a[q>>0]|0)){i=d;return}tKa(j,c[j>>2]|0);i=d;return}function Ada(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+112|0;d=b+104|0;e=b;f=a+1184|0;h=c[f>>2]|0;j=a+1176|0;k=j;l=c[k>>2]|0;m=c[k+4>>2]|0;Dn[c[(c[h>>2]|0)+8>>2]&511](h,115,l,m);k=c[f>>2]|0;n=j;o=c[n>>2]|0;p=c[n+4>>2]|0;Dn[c[(c[k>>2]|0)+8>>2]&511](k,107,o,p);n=c[a+192>>2]|0;if(n){q=a+188|0;r=n;do{r=r+-1|0;Gaa(c[(c[q>>2]|0)+(r<<2)>>2]|0)}while((r|0)!=0)}Dn[c[(c[k>>2]|0)+12>>2]&511](k,107,o,p);p=a+132|0;if(c[p>>2]|0){o=a+128|0;k=0;do{dia(c[(c[o>>2]|0)+(k<<2)>>2]|0);k=k+1|0}while(k>>>0<(c[p>>2]|0)>>>0)}p=c[f>>2]|0;f=j;j=c[f>>2]|0;k=c[f+4>>2]|0;Dn[c[(c[p>>2]|0)+8>>2]&511](p,108,j,k);if(ea(g[a+1416>>2])!=ea(0.0)){f=(c[(c[a+1212>>2]|0)+1e3>>2]|0)+5928|0;o=e+36|0;r=e+0|0;q=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(q|0));g[o>>2]=ea(1.0);o=e+40|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[e+56>>2]=ea(1.0);o=e+60|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[e+76>>2]=ea(1.0);o=e+80|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[e+96>>2]=ea(1.0);c[e+100>>2]=f;f=a+120|0;if(c[f>>2]|0){o=a+116|0;r=0;do{hia(Rga(c[(c[o>>2]|0)+(r<<2)>>2]|0)|0,e);r=r+1|0}while(r>>>0<(c[f>>2]|0)>>>0)}}Dn[c[(c[p>>2]|0)+12>>2]&511](p,108,j,k);k=a+2340|0;oTa(c[k>>2]|0);j=a+2356|0;p=(c[j>>2]|0)+2|0;f=a+2348|0;r=c[f>>2]|0;if(r>>>0<=p>>>0){c[j>>2]=0;s=a+2360|0;c[s>>2]=0;t=c[k>>2]|0;pTa(t);u=a+64|0;v=c[u>>2]|0;w=v+1|0;c[u>>2]=w;x=c[h>>2]|0;y=x+12|0;z=c[y>>2]|0;Dn[z&511](h,115,l,m);i=b;return}e=a+2344|0;o=r;do{r=o+-1|0;q=c[(c[e>>2]|0)+(r<<2)>>2]|0;c[f>>2]=r;VJa(d,q);o=c[f>>2]|0}while(o>>>0>p>>>0);c[j>>2]=0;s=a+2360|0;c[s>>2]=0;t=c[k>>2]|0;pTa(t);u=a+64|0;v=c[u>>2]|0;w=v+1|0;c[u>>2]=w;x=c[h>>2]|0;y=x+12|0;z=c[y>>2]|0;Dn[z&511](h,115,l,m);i=b;return}function Bda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=(b+31|0)>>>5;b=a+1264|0;if(f>>>0>(c[b>>2]&2147483647)>>>0){g=a+1268|0;h=UJa(g,f<<2,543784,339)|0;j=a+1260|0;k=c[j>>2]|0;if((k|0)!=0?(YEi(h|0,k|0,c[b>>2]<<2|0)|0,(c[b>>2]|0)>-1):0)VJa(g,c[j>>2]|0);g=c[b>>2]|0;PEi(h+((g&2147483647)<<2)|0,0,f-g<<2|0)|0;c[j>>2]=h;c[b>>2]=f}b=c[a+1208>>2]|0;h=b+20|0;if(f>>>0>(c[h>>2]&2147483647)>>>0){j=b+24|0;g=UJa(j,f<<2,543784,339)|0;k=b+16|0;l=c[k>>2]|0;if((l|0)!=0?(YEi(g|0,l|0,c[h>>2]<<2|0)|0,(c[h>>2]|0)>-1):0)VJa(j,c[k>>2]|0);j=c[h>>2]|0;PEi(g+((j&2147483647)<<2)|0,0,f-j<<2|0)|0;c[k>>2]=g;c[h>>2]=f}if((c[b+36>>2]&2147483647)>>>0<d>>>0)yUa(b+28|0,d);b=c[a+1204>>2]|0;a=b+20|0;if(f>>>0>(c[a>>2]&2147483647)>>>0){h=b+24|0;g=UJa(h,f<<2,543784,339)|0;k=b+16|0;j=c[k>>2]|0;if((j|0)!=0?(YEi(g|0,j|0,c[a>>2]<<2|0)|0,(c[a>>2]|0)>-1):0)VJa(h,c[k>>2]|0);h=c[a>>2]|0;PEi(g+((h&2147483647)<<2)|0,0,f-h<<2|0)|0;c[k>>2]=g;c[a>>2]=f}if((c[b+36>>2]&2147483647)>>>0>=d>>>0){i=e;return}yUa(b+28|0,d);i=e;return}function Cda(a,b){a=a|0;b=b|0;var d=0,e=Im;d=i;e=ea(kta(c[(c[a+1212>>2]|0)+1e3>>2]|0,b));i=d;return ea(e)}function Dda(b,d,e){b=b|0;d=d|0;e=e|0;a[b>>0]=a[(c[(c[d+1164>>2]|0)+((e&255)<<2)>>2]|0)+12>>0]|0;return}function Eda(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;f=i;i=i+1024|0;g=f+488|0;h=f+424|0;j=f+416|0;k=f+400|0;l=f;m=c[d+180>>2]|0;n=g+512|0;o=g+516|0;p=g+520|0;c[p>>2]=0;q=g+524|0;a[n>>0]=1;c[o>>2]=g;c[q>>2]=32;if(m>>>0<=32){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;if(!m){r=h;s=0}else{t=h;u=4}}else{oZa(g,m);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;t=h;u=4}if((u|0)==4){v=d+176|0;w=d+1216|0;x=d+1164|0;y=k+4|0;z=k+8|0;A=k+12|0;B=k+14|0;C=0;D=0;while(1){E=c[(c[v>>2]|0)+(D<<2)>>2]|0;F=E+68|0;G=c[F>>2]|0;if(G){H=Kaa(G,0)|0;if((H|0)==(c[w>>2]|0))I=0;else I=c[(Kaa(c[F>>2]|0,0)|0)+52>>2]|0;H=Kaa(c[F>>2]|0,1)|0;if((H|0)==(c[w>>2]|0))J=0;else J=c[(Kaa(c[F>>2]|0,1)|0)+52>>2]|0;F=(I|0)!=0;if(F)K=a[I+13>>0]|0;else K=0;H=(J|0)!=0;if(H)L=a[J+13>>0]|0;else L=0;if(F)M=a[I+11>>0]&4;else M=0;if(H)N=a[J+11>>0]&4;else N=0;H=K&255;F=c[x>>2]|0;G=c[F+(H<<2)>>2]|0;O=a[G+12>>0]&4;P=L&255;Q=c[F+(P<<2)>>2]|0;F=a[Q+12>>0]&4;if(c[G+16>>2]|0)if(K<<24>>24==L<<24>>24)R=1;else R=O<<24>>24!=0&N<<24>>24!=0;else R=0;O=((c[Q+16>>2]|0)!=0?K<<24>>24!=L<<24>>24:0)&M<<24>>24!=0&F<<24>>24!=0;if(R|O){c[j>>2]=-1;F=c[E+28>>2]|0;Q=_n[c[(c[F>>2]|0)+20>>2]&4095](F,j)|0;F=_9(E)|0;E=c[j>>2]|0;c[k>>2]=F;c[y>>2]=Q;c[z>>2]=E;b[A>>1]=R?K&255:-1;b[B>>1]=O?L&255:-1;E=c[p>>2]|0;if((c[q>>2]&2147483647)>>>0>E>>>0){Q=(c[o>>2]|0)+(E<<4)|0;if(!Q)S=E;else{c[Q+0>>2]=c[k+0>>2];c[Q+4>>2]=c[k+4>>2];c[Q+8>>2]=c[k+8>>2];c[Q+12>>2]=c[k+12>>2];S=c[p>>2]|0}c[p>>2]=S+1}else pZa(g,k)|0;if(R){Q=h+(H>>>3<<2)|0;c[Q>>2]=c[Q>>2]|1<<(H&7);Q=H+1&65535;T=(Q&65535)<(C&65535)?C:Q}else T=C;if(O){O=h+(P>>>3<<2)|0;c[O>>2]=c[O>>2]|1<<(P&7);O=P+1&65535;U=(O&65535)<(T&65535)?T:O}else U=T}else U=C}else U=C;D=D+1|0;if((D|0)==(m|0)){r=t;s=U;break}else C=U}}U=l+384|0;C=l+388|0;t=l+392|0;c[t>>2]=0;r=l+396|0;a[U>>0]=1;c[C>>2]=l;c[r>>2]=32;if(!(s<<16>>16))V=32;else{m=d+1164|0;d=s&65535;s=0;do{if(c[h+(s>>>3<<2)>>2]&1<<(s&7)){c[t>>2]=0;D=c[p>>2]|0;if((c[r>>2]&2147483647)>>>0<D>>>0){qZa(l,D);W=c[p>>2]|0}else W=D;if(W){D=0;do{T=c[o>>2]|0;if(!((e[T+(D<<4)+12>>1]|0|0)!=(s|0)?(e[T+(D<<4)+14>>1]|0|0)!=(s|0):0))u=40;do if((u|0)==40){u=0;R=T+(D<<4)|0;k=c[t>>2]|0;if((c[r>>2]&2147483647)>>>0<=k>>>0){rZa(l,R)|0;break}S=(c[C>>2]|0)+(k*12|0)|0;if(!S)X=k;else{c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];X=c[t>>2]|0}c[t>>2]=X+1}while(0);D=D+1|0}while(D>>>0<(c[p>>2]|0)>>>0)}D=c[(c[(c[m>>2]|0)+(s<<2)>>2]|0)+16>>2]|0;co[c[c[D>>2]>>2]&2047](D,c[C>>2]|0,c[t>>2]|0)}s=s+1|0}while((s|0)!=(d|0));V=c[r>>2]|0}do if((V&2147483647|0)!=0&(V|0)>-1){r=c[C>>2]|0;if((l|0)==(r|0)){a[U>>0]=0;break}else{tKa(l,r);break}}while(0);l=c[q>>2]|0;if(!((l&2147483647|0)!=0&(l|0)>-1)){i=f;return}l=c[o>>2]|0;if((g|0)==(l|0)){a[n>>0]=0;i=f;return}else{tKa(g,l);i=f;return}}function Fda(a){a=a|0;var b=0;b=i;Eda(a);Oca(a);Nca(a,0);i=b;return}function Gda(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+16|0;g=f+1|0;h=f;j=d+1161|0;if(!(a[j>>0]|0)){k=d+1140|0;a:do if(c[k>>2]|0){l=d+1136|0;m=0;do{while(1){if(!(b[(K8(c[(c[l>>2]|0)+(m<<2)>>2]|0)|0)+144>>1]&128))break;n=(c[k>>2]|0)+-1|0;c[k>>2]=n;o=c[l>>2]|0;c[o+(m<<2)>>2]=c[o+(n<<2)>>2];if(m>>>0>=n>>>0)break a}m=m+1|0}while(m>>>0<(c[k>>2]|0)>>>0)}while(0);a[j>>0]=1}k=d+1160|0;m=d+1152|0;l=c[m>>2]|0;if(!(a[k>>0]|0)){b:do if(!l)p=0;else{n=d+1148|0;o=0;while(1){while(1){if(!(b[(K8(c[(c[n>>2]|0)+(o<<2)>>2]|0)|0)+144>>1]&64))break;q=(c[m>>2]|0)+-1|0;c[m>>2]=q;r=c[n>>2]|0;c[r+(o<<2)>>2]=c[r+(q<<2)>>2];if(o>>>0>=q>>>0){p=q;break b}}o=o+1|0;q=c[m>>2]|0;if(o>>>0>=q>>>0){p=q;break}}}while(0);a[k>>0]=1;s=p}else s=l;l=d+1140|0;p=c[l>>2]|0;m=d+1152|0;o=p>>>0<s>>>0?s:p;if(!o){t=p;u=0}else{n=UJa(g,o<<2,467192,2599)|0;o=(n|0)==0;if(!((p|0)==0|o)){g=d+1136|0;q=d+1164|0;r=0;v=0;w=-1;while(1){x=c[(c[g>>2]|0)+(v<<2)>>2]|0;y=a[x+13>>0]|0;if(w<<24>>24!=y<<24>>24){z=c[(c[(c[q>>2]|0)+((y&255)<<2)>>2]|0)+16>>2]|0;if((z|0)==0|(r|0)==0){A=0;B=y}else{co[c[(c[z>>2]|0)+8>>2]&2047](z,n,r);A=0;B=y}}else{A=r;B=w}if(!(b[x+8>>1]&4))C=A;else{c[n+(A<<2)>>2]=Zba(x)|0;C=A+1|0}v=v+1|0;if((v|0)==(p|0))break;else{r=C;w=B}}w=c[(c[(c[q>>2]|0)+((B&255)<<2)>>2]|0)+16>>2]|0;if(!((w|0)==0|(C|0)==0))co[c[(c[w>>2]|0)+8>>2]&2047](w,n,C)}if(!((s|0)==0|o)){o=d+1148|0;C=d+1164|0;w=0;B=0;q=-1;while(1){r=c[(c[o>>2]|0)+(B<<2)>>2]|0;p=a[r+13>>0]|0;if(q<<24>>24!=p<<24>>24){v=c[(c[(c[C>>2]|0)+((p&255)<<2)>>2]|0)+16>>2]|0;if((v|0)==0|(w|0)==0){D=0;E=p}else{co[c[(c[v>>2]|0)+4>>2]&2047](v,n,w);D=0;E=p}}else{D=w;E=q}if(!(b[r+8>>1]&4))F=D;else{c[n+(D<<2)>>2]=Zba(r)|0;F=D+1|0}B=B+1|0;if((B|0)==(s|0))break;else{w=F;q=E}}q=c[(c[(c[C>>2]|0)+((E&255)<<2)>>2]|0)+16>>2]|0;if(!((q|0)==0|(F|0)==0))co[c[(c[q>>2]|0)+4>>2]&2047](q,n,F)}t=c[l>>2]|0;u=n}if(t){t=d+1136|0;n=0;do{F=(K8(c[(c[t>>2]|0)+(n<<2)>>2]|0)|0)+144|0;b[F>>1]=e[F>>1]&65423;n=n+1|0}while(n>>>0<(c[l>>2]|0)>>>0)}if(!(c[m>>2]|0)){c[l>>2]=0;c[m>>2]=0;a[k>>0]=1;a[j>>0]=1;VJa(h,u);i=f;return}n=d+1148|0;d=0;do{t=(K8(c[(c[n>>2]|0)+(d<<2)>>2]|0)|0)+144|0;b[t>>1]=e[t>>1]&65359;d=d+1|0}while(d>>>0<(c[m>>2]|0)>>>0);c[l>>2]=0;c[m>>2]=0;a[k>>0]=1;a[j>>0]=1;VJa(h,u);i=f;return}function Hda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0;f=c[e+51604>>2]|0;g=a+1272|0;h=a+1276|0;c[h>>2]=0;if(!f){i=b;return}j=e+51600|0;e=a+1280|0;a=0;k=0;while(1){l=c[(c[(c[j>>2]|0)+(k<<2)>>2]|0)+20>>2]|0;c[d>>2]=l;if((c[e>>2]&2147483647)>>>0>a>>>0){m=(c[g>>2]|0)+(a<<2)|0;if(!m)n=a;else{c[m>>2]=l;n=c[h>>2]|0}c[h>>2]=n+1}else cUa(g,d)|0;l=k+1|0;if((l|0)==(f|0))break;a=c[h>>2]|0;k=l}i=b;return}function Ida(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0;f=e+51600|0;g=e+51604|0;e=c[g>>2]|0;h=c[a+1204>>2]|0;if(!e){j=0;c[d>>2]=0;qWa(f,0,d);k=c[g>>2]|0;rWa(f,k);i=b;return j|0}l=a+1272|0;m=h+20|0;n=h+16|0;h=a+1164|0;a=0;o=0;while(1){p=c[(c[f>>2]|0)+(a<<2)>>2]|0;q=c[(c[l>>2]|0)+(a<<2)>>2]|0;r=q>>>5;if(r>>>0<(c[m>>2]&2147483647)>>>0?(c[(c[n>>2]|0)+(r<<2)>>2]&1<<(q&31)|0)!=0:0)s=o;else{q=dca(c[p+8>>2]|0)|0;r=(mo[c[(c[q>>2]|0)+68>>2]&4095](q)|0)&255;t=c[(c[(c[h>>2]|0)+(r<<2)>>2]|0)+20>>2]|0;if(!t)s=1;else{r=dfa(c[p+28>>2]|0)|0;co[c[(c[t>>2]|0)+8>>2]&2047](t,r,q);s=o}}a=a+1|0;if((a|0)==(e|0)){j=s;break}else o=s}c[d>>2]=0;qWa(f,0,d);k=c[g>>2]|0;rWa(f,k);i=b;return j|0}function Jda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+1212|0;a=c[d>>2]|0;e=c[a+12>>2]|0;f=c[a>>2]|0;g=f+(e<<2)|0;if(!e){h=a;Yia(h,1);i=b;return}a=e;e=f+64|0;while(1){a=a+-1|0;if(e>>>0<g>>>0)j=e+4|0;else j=e;k=c[f+(a<<2)>>2]|0;M9(k)|0;i9(c[k+52>>2]|0);if(!a)break;else e=j}h=c[d>>2]|0;Yia(h,1);i=b;return}function Kda(a){a=a|0;return c[a+1284>>2]|0}function Lda(a){a=a|0;return a|0}function Mda(a,b){a=a|0;b=b|0;var d=0;d=i;EAa((c[(c[a+1212>>2]|0)+1e3>>2]|0)+44|0,b);i=d;return}function Nda(a){a=a|0;var b=0,d=0;b=i;d=FAa((c[(c[a+1212>>2]|0)+1e3>>2]|0)+44|0)|0;i=b;return d|0}function Oda(a){a=a|0;var b=0,d=0;b=i;d=GAa((c[(c[a+1212>>2]|0)+1e3>>2]|0)+44|0)|0;i=b;return d|0}function Pda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Rsa(c[(c[a+1212>>2]|0)+1e3>>2]|0,b,d);i=e;return}function Qda(a,b){a=a|0;b=b|0;var d=0;d=i;aga(c[a+1192>>2]|0,b,(c[(c[a+1212>>2]|0)+1e3>>2]|0)+6752|0);c[b+12>>2]=c[a+1424>>2];c[b+16>>2]=c[a+1428>>2];c[b+20>>2]=c[a+1432>>2];c[b+24>>2]=c[a+1436>>2];c[b+28>>2]=c[a+1440>>2];c[b+32>>2]=c[a+1444>>2];c[b+36>>2]=c[a+1448>>2];c[b+40>>2]=c[a+1452>>2];c[b+44>>2]=c[a+1456>>2];i=d;return}function Rda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;c[h>>2]=0;Afa(h,b);b=zfa(h)|0;c[j>>2]=b;if(!b)l=d+264|0;else{m=d+268|0;n=d+264|0;o=d+260|0;p=e+268|0;q=e+264|0;r=e+260|0;s=b;do{b=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>b>>>0){t=(c[o>>2]|0)+(b<<2)|0;if(t)c[t>>2]=s;c[n>>2]=b+1;u=s}else{sZa(d,j)|0;u=c[j>>2]|0}b=c[u+28>>2]|0;c[k>>2]=b;t=c[q>>2]|0;if((c[p>>2]&2147483647)>>>0>t>>>0){v=(c[r>>2]|0)+(t<<2)|0;if(v)c[v>>2]=b;c[q>>2]=t+1}else tZa(e,k)|0;s=zfa(h)|0;c[j>>2]=s}while((s|0)!=0);l=n}if(!(c[l>>2]|0)){i=g;return}n=d+260|0;d=a+1220|0;s=0;do{j=c[(c[n>>2]|0)+(s<<2)>>2]|0;h=a+(c[(c[j+28>>2]|0)+68>>2]<<2)+1432|0;c[h>>2]=(c[h>>2]|0)+-1;Nfa(j,f);if(j){h=c[d>>2]|0;ko[c[c[j>>2]>>2]&4095](j);AYa(h,j)}s=s+1|0}while(s>>>0<(c[l>>2]|0)>>>0);i=g;return}function Sda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+(c[(c[b+28>>2]|0)+68>>2]<<2)+1432|0;c[f>>2]=(c[f>>2]|0)+-1;Nfa(b,d);if(!b){i=e;return}d=c[a+1220>>2]|0;ko[c[c[b>>2]>>2]&4095](b);AYa(d,b);i=e;return}function Tda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;h=c[a+1224>>2]|0;j=c[h+8>>2]|0;k=c[h+12>>2]|0;l=c[h+4>>2]|0;m=k+(j*12|0)+4|0;n=c[m>>2]|0;do if(!n){o=k+(j*12|0)+8|0;p=c[o>>2]|0;if((p|0)!=(c[h>>2]|0)?(c[o>>2]=p+1,o=(c[k+(j*12|0)>>2]|0)+(da(p,l)|0)|0,(o|0)!=0):0){q=o;r=6;break}o=zYa(h)|0;if(!o)s=0;else{q=o;r=6}}else{c[m>>2]=c[n>>2];q=n;r=6}while(0);if((r|0)==6){ega(q,a,b);s=q}q=a+1424|0;c[q>>2]=(c[q>>2]|0)+1;if(!e){i=g;return}q=a+1220|0;b=0;do{n=(c[d+(b<<2)>>2]|0)+f|0;m=c[q>>2]|0;h=c[m+8>>2]|0;l=c[m+12>>2]|0;j=c[m+4>>2]|0;k=l+(h*12|0)+4|0;o=c[k>>2]|0;do if(!o){p=l+(h*12|0)+8|0;t=c[p>>2]|0;if((t|0)!=(c[m>>2]|0)?(c[p>>2]=t+1,p=(c[l+(h*12|0)>>2]|0)+(da(t,j)|0)|0,(p|0)!=0):0){u=p;r=14;break}p=zYa(m)|0;if(p){u=p;r=14}}else{c[k>>2]=c[o>>2];u=o;r=14}while(0);if((r|0)==14){r=0;Cfa(u,s,n,0,0)}o=a+(c[n+68>>2]<<2)+1432|0;c[o>>2]=(c[o>>2]|0)+1;b=b+1|0}while((b|0)!=(e|0));i=g;return}function Uda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;d=bga(b)|0;if(!d){i=a;return}b=d;e=VEi(b|0,0,6)|0;f=H;g=_Ei(b|0,0,59,0)|0;b=VEi(g|0,H|0,6)|0;g=H;h=ZEi(1,0,e|0,f|0)|0;f=_Ei(h|0,H|0,b|0,g|0)|0;g=f;f=H;b=d;while(1){g=_Ei(g|0,f|0,-1,-1)|0;f=H;if((g|0)==0&(f|0)==0)break;else b=b+64|0}b=c[d+32>>2]|0;d=b;f=VEi(d|0,0,6)|0;g=H;h=_Ei(d|0,0,19,0)|0;d=VEi(h|0,H|0,6)|0;h=H;e=ZEi(1,0,f|0,g|0)|0;g=_Ei(e|0,H|0,d|0,h|0)|0;h=g;g=H;d=b;while(1){h=_Ei(h|0,g|0,-1,-1)|0;g=H;if((h|0)==0&(g|0)==0)break;else d=d+64|0}i=a;return}function Vda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;d=K8(b)|0;if(!d){i=a;return}b=d;e=VEi(b|0,0,6)|0;f=H;g=_Ei(b|0,0,191,0)|0;b=VEi(g|0,H|0,6)|0;g=H;h=ZEi(1,0,e|0,f|0)|0;f=_Ei(h|0,H|0,b|0,g|0)|0;g=f;f=H;b=d;while(1){g=_Ei(g|0,f|0,-1,-1)|0;f=H;if((g|0)==0&(f|0)==0)break;else b=b+64|0}b=c[d+32>>2]|0;d=b;f=VEi(d|0,0,6)|0;g=H;h=_Ei(d|0,0,19,0)|0;d=VEi(h|0,H|0,6)|0;h=H;e=ZEi(1,0,f|0,g|0)|0;g=_Ei(e|0,H|0,d|0,h|0)|0;h=g;g=H;d=b;while(1){h=_Ei(h|0,g|0,-1,-1)|0;g=H;if((h|0)==0&(g|0)==0)break;else d=d+64|0}i=a;return}function Wda(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+272|0;h=g;j=bga(d)|0;if(!j){i=g;return}k=c[b+1244>>2]|0;do if(!k){l=h+256|0;m=h+260|0;c[h+264>>2]=0;n=h+268|0;a[l>>0]=1;c[m>>2]=h;c[n>>2]=64;Rda(b,j,h,e,f);o=c[n>>2]|0;if((o&2147483647|0)!=0&(o|0)>-1){o=c[m>>2]|0;if((h|0)==(o|0)){a[l>>0]=0;break}if(o){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,o)}}}else Rda(b,j,k,e,f);while(0);f=c[b+1224>>2]|0;e=bga(d)|0;if(e){ko[c[c[e>>2]>>2]&4095](e);AYa(f,e)}e=b+1424|0;c[e>>2]=(c[e>>2]|0)+-1;i=g;return}function Xda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=c[a+1228>>2]|0;j=c[h+8>>2]|0;k=c[h+12>>2]|0;l=c[h+4>>2]|0;m=k+(j*12|0)+4|0;n=c[m>>2]|0;do if(!n){o=k+(j*12|0)+8|0;p=c[o>>2]|0;if((p|0)!=(c[h>>2]|0)?(c[o>>2]=p+1,o=(c[k+(j*12|0)>>2]|0)+(da(p,l)|0)|0,(o|0)!=0):0){q=o;r=6;break}o=zYa(h)|0;if(!o)s=0;else{q=o;r=6}}else{c[m>>2]=c[n>>2];q=n;r=6}while(0);if((r|0)==6){m9(q,a,b);s=q}q=a+1428|0;c[q>>2]=(c[q>>2]|0)+1;q=s+64|0;if(!e){i=g;return}b=a+1220|0;n=0;do{m=(c[d+(n<<2)>>2]|0)+f|0;h=c[b>>2]|0;l=c[h+8>>2]|0;j=c[h+12>>2]|0;k=c[h+4>>2]|0;o=j+(l*12|0)+4|0;p=c[o>>2]|0;do if(!p){t=j+(l*12|0)+8|0;u=c[t>>2]|0;if((u|0)!=(c[h>>2]|0)?(c[t>>2]=u+1,t=(c[j+(l*12|0)>>2]|0)+(da(u,k)|0)|0,(t|0)!=0):0){v=t;r=14;break}t=zYa(h)|0;if(t){v=t;r=14}}else{c[o>>2]=c[p>>2];v=p;r=14}while(0);if((r|0)==14){r=0;Cfa(v,s,m,q,0)}p=a+(c[m+68>>2]<<2)+1432|0;c[p>>2]=(c[p>>2]|0)+1;n=n+1|0}while((n|0)!=(e|0));i=g;return}function Yda(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+272|0;h=g;j=K8(d)|0;if(!j){i=g;return}d=c[b+1244>>2]|0;do if(!d){k=h+256|0;l=h+260|0;c[h+264>>2]=0;m=h+268|0;a[k>>0]=1;c[l>>2]=h;c[m>>2]=64;Rda(b,j,h,e,f);n=c[m>>2]|0;if((n&2147483647|0)!=0&(n|0)>-1){n=c[l>>2]|0;if((h|0)==(n|0)){a[k>>0]=0;break}if(n){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,n)}}}else Rda(b,j,d,e,f);while(0);f=c[b+1228>>2]|0;ko[c[c[j>>2]>>2]&4095](j);AYa(f,j);j=b+1428|0;c[j>>2]=(c[j>>2]|0)+-1;i=g;return}function Zda(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=d[b+50>>0]|0;if((g|0)==4|(g|0)==1)h=b+64|0;else h=0;g=c[a+1220>>2]|0;j=c[g+8>>2]|0;k=c[g+12>>2]|0;l=c[g+4>>2]|0;m=k+(j*12|0)+4|0;n=c[m>>2]|0;do if(!n){o=k+(j*12|0)+8|0;p=c[o>>2]|0;if((p|0)!=(c[g>>2]|0)?(c[o>>2]=p+1,o=(c[k+(j*12|0)>>2]|0)+(da(p,l)|0)|0,(o|0)!=0):0){q=o;break}o=zYa(g)|0;if(!o){r=e+68|0;s=c[r>>2]|0;t=a+(s<<2)+1432|0;u=c[t>>2]|0;v=u+1|0;c[t>>2]=v;i=f;return}else q=o}else{c[m>>2]=c[n>>2];q=n}while(0);Cfa(q,b,e,h,0);r=e+68|0;s=c[r>>2]|0;t=a+(s<<2)+1432|0;u=c[t>>2]|0;v=u+1|0;c[t>>2]=v;i=f;return}function _da(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[a+1220>>2]|0;f=c[e+8>>2]|0;g=c[e+12>>2]|0;h=c[e+4>>2]|0;j=g+(f*12|0)+4|0;k=c[j>>2]|0;do if(!k){l=g+(f*12|0)+8|0;m=c[l>>2]|0;if((m|0)!=(c[e>>2]|0)?(c[l>>2]=m+1,l=(c[g+(f*12|0)>>2]|0)+(da(m,h)|0)|0,(l|0)!=0):0){n=l;break}n=zYa(e)|0}else{c[j>>2]=c[k>>2];n=k}while(0);k=n;j=VEi(k|0,0,6)|0;e=H;h=_Ei(k|0,0,31,0)|0;k=VEi(h|0,H|0,6)|0;h=H;f=ZEi(1,0,j|0,e|0)|0;e=_Ei(f|0,H|0,k|0,h|0)|0;h=e;e=H;k=n;while(1){h=_Ei(h|0,e|0,-1,-1)|0;e=H;if((h|0)==0&(e|0)==0)break;else k=k+64|0}c[b+8>>2]=n;n=c[a+1224>>2]|0;k=c[n+8>>2]|0;e=c[n+12>>2]|0;h=c[n+4>>2]|0;f=e+(k*12|0)+4|0;j=c[f>>2]|0;do if(!j){g=e+(k*12|0)+8|0;l=c[g>>2]|0;if((l|0)!=(c[n>>2]|0)?(c[g>>2]=l+1,g=(c[e+(k*12|0)>>2]|0)+(da(l,h)|0)|0,(g|0)!=0):0){o=g;break}o=zYa(n)|0}else{c[f>>2]=c[j>>2];o=j}while(0);j=o;f=VEi(j|0,0,6)|0;n=H;h=_Ei(j|0,0,59,0)|0;j=VEi(h|0,H|0,6)|0;h=H;k=ZEi(1,0,f|0,n|0)|0;n=_Ei(k|0,H|0,j|0,h|0)|0;h=n;n=H;j=o;while(1){h=_Ei(h|0,n|0,-1,-1)|0;n=H;if((h|0)==0&(n|0)==0)break;else j=j+64|0}c[b+4>>2]=o;o=c[a+1228>>2]|0;a=c[o+8>>2]|0;j=c[o+12>>2]|0;n=c[o+4>>2]|0;h=j+(a*12|0)+4|0;k=c[h>>2]|0;do if(!k){f=j+(a*12|0)+8|0;e=c[f>>2]|0;if((e|0)!=(c[o>>2]|0)?(c[f>>2]=e+1,f=(c[j+(a*12|0)>>2]|0)+(da(e,n)|0)|0,(f|0)!=0):0){p=f;break}p=zYa(o)|0}else{c[h>>2]=c[k>>2];p=k}while(0);k=p;h=VEi(k|0,0,6)|0;o=H;n=_Ei(k|0,0,191,0)|0;k=VEi(n|0,H|0,6)|0;n=H;a=ZEi(1,0,h|0,o|0)|0;o=_Ei(a|0,H|0,k|0,n|0)|0;n=o;o=H;k=p;while(1){n=_Ei(n|0,o|0,-1,-1)|0;o=H;if((n|0)==0&(o|0)==0)break;else k=k+64|0}c[b>>2]=p;i=d;return}function $da(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;if(!d){i=k;return}l=_Ei(e+144|0,0,-1,-1)|0;m=H;n=a+1220|0;o=e+68|0;p=0;do{q=p;p=p+1|0;if(p>>>0<d>>>0){r=c[b+(p<<2)>>2]|0;s=r;t=VEi(s|0,0,6)|0;u=H;v=_Ei(l|0,m|0,s|0,0)|0;s=VEi(v|0,H|0,6)|0;v=H;w=ZEi(1,0,t|0,u|0)|0;u=_Ei(w|0,H|0,s|0,v|0)|0;v=u;u=H;s=r;while(1){v=_Ei(v|0,u|0,-1,-1)|0;u=H;if((v|0)==0&(u|0)==0)break;else s=s+64|0}}s=c[n>>2]|0;u=c[s+8>>2]|0;v=c[s+12>>2]|0;r=c[s+4>>2]|0;w=v+(u*12|0)+4|0;t=c[w>>2]|0;do if(!t){x=v+(u*12|0)+8|0;y=c[x>>2]|0;if((y|0)!=(c[s>>2]|0)?(c[x>>2]=y+1,x=(c[v+(u*12|0)>>2]|0)+(da(y,r)|0)|0,(x|0)!=0):0){z=x;break}z=zYa(s)|0}else{c[w>>2]=c[t>>2];z=t}while(0);t=z;w=VEi(t|0,0,6)|0;s=H;r=_Ei(t|0,0,31,0)|0;t=VEi(r|0,H|0,6)|0;r=H;u=ZEi(1,0,w|0,s|0)|0;s=_Ei(u|0,H|0,t|0,r|0)|0;r=s;s=H;t=z;while(1){r=_Ei(r|0,s|0,-1,-1)|0;s=H;if((r|0)==0&(s|0)==0)break;else t=t+64|0}t=c[b+(q<<2)>>2]|0;Cfa(c[h>>2]|0,f,t+e|0,g,j+(q*24|0)|0);c[h>>2]=z;s=a+(c[t+o>>2]<<2)+1432|0;c[s>>2]=(c[s>>2]|0)+1}while((p|0)!=(d|0));i=k;return}function aea(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;j=f+4|0;k=c[j>>2]|0;l=c[f+16>>2]|0;m=d+l|0;n=d+(l+4)|0;l=b[n>>1]|0;if(l<<16>>16!=1){o=c[m>>2]|0;if(!(l<<16>>16))p=o;else{q=o;r=4}}else{q=m;r=4}if((r|0)==4){r=c[q>>2]|0;m=(c[f+28>>2]|0)+144|0;o=r;l=VEi(o|0,0,6)|0;s=H;t=_Ei(o|0,0,-1,-1)|0;o=_Ei(t|0,H|0,m|0,0)|0;m=VEi(o|0,H|0,6)|0;o=H;t=ZEi(1,0,l|0,s|0)|0;s=_Ei(t|0,H|0,m|0,o|0)|0;o=s;s=H;m=r;while(1){o=_Ei(o|0,s|0,-1,-1)|0;s=H;if((o|0)==0&(s|0)==0){p=q;break}else m=m+64|0}}ega(k,a,d+(c[f+12>>2]|0)|0);d=c[a+1224>>2]|0;m=c[d+8>>2]|0;q=c[d+12>>2]|0;s=c[d+4>>2]|0;o=q+(m*12|0)+4|0;r=c[o>>2]|0;do if(!r){t=q+(m*12|0)+8|0;l=c[t>>2]|0;if((l|0)!=(c[d>>2]|0)?(c[t>>2]=l+1,t=(c[q+(m*12|0)>>2]|0)+(da(l,s)|0)|0,(t|0)!=0):0){u=t;break}u=zYa(d)|0}else{c[o>>2]=c[r>>2];u=r}while(0);r=u;o=VEi(r|0,0,6)|0;d=H;s=_Ei(r|0,0,59,0)|0;r=VEi(s|0,H|0,6)|0;s=H;m=ZEi(1,0,o|0,d|0)|0;d=_Ei(m|0,H|0,r|0,s|0)|0;s=d;d=H;r=u;while(1){s=_Ei(s|0,d|0,-1,-1)|0;d=H;if((s|0)==0&(d|0)==0)break;else r=r+64|0}c[j>>2]=u;$da(a,p,e[n>>1]|0,c[f+28>>2]|0,k,0,f+8|0,g);g=a+1424|0;c[g>>2]=(c[g>>2]|0)+1;i=h;return}function bea(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;j=c[f>>2]|0;k=c[f+24>>2]|0;l=d+k|0;m=d+(k+4)|0;k=b[m>>1]|0;if(k<<16>>16!=1){n=c[l>>2]|0;if(!(k<<16>>16))o=n;else{p=n;q=4}}else{p=l;q=4}if((q|0)==4){q=c[p>>2]|0;l=(c[f+28>>2]|0)+144|0;n=q;k=VEi(n|0,0,6)|0;r=H;s=_Ei(n|0,0,-1,-1)|0;n=_Ei(s|0,H|0,l|0,0)|0;l=VEi(n|0,H|0,6)|0;n=H;s=ZEi(1,0,k|0,r|0)|0;r=_Ei(s|0,H|0,l|0,n|0)|0;n=r;r=H;l=q;while(1){n=_Ei(n|0,r|0,-1,-1)|0;r=H;if((n|0)==0&(r|0)==0){o=p;break}else l=l+64|0}}m9(j,a,d+(c[f+20>>2]|0)|0);d=c[a+1228>>2]|0;l=c[d+8>>2]|0;p=c[d+12>>2]|0;r=c[d+4>>2]|0;n=p+(l*12|0)+4|0;q=c[n>>2]|0;do if(!q){s=p+(l*12|0)+8|0;k=c[s>>2]|0;if((k|0)!=(c[d>>2]|0)?(c[s>>2]=k+1,s=(c[p+(l*12|0)>>2]|0)+(da(k,r)|0)|0,(s|0)!=0):0){t=s;break}t=zYa(d)|0}else{c[n>>2]=c[q>>2];t=q}while(0);q=t;n=VEi(q|0,0,6)|0;d=H;r=_Ei(q|0,0,191,0)|0;q=VEi(r|0,H|0,6)|0;r=H;l=ZEi(1,0,n|0,d|0)|0;d=_Ei(l|0,H|0,q|0,r|0)|0;r=d;d=H;q=t;while(1){r=_Ei(r|0,d|0,-1,-1)|0;d=H;if((r|0)==0&(d|0)==0)break;else q=q+64|0}c[f>>2]=t;$da(a,o,e[m>>1]|0,c[f+28>>2]|0,j,j+64|0,f+8|0,g);g=a+1428|0;c[g>>2]=(c[g>>2]|0)+1;i=h;return}function cea(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+4>>2]|0;if(e)AYa(c[a+1224>>2]|0,e);e=c[b>>2]|0;if(e)AYa(c[a+1228>>2]|0,e);e=c[b+8>>2]|0;if(!e){i=d;return}AYa(c[a+1220>>2]|0,e);i=d;return}function dea(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a+1212>>2]|0;a=c[d>>2]|0;e=a+(c[d+4>>2]<<2)|0;d=b;c[d>>2]=a;c[d+4>>2]=e;return}function eea(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,i=0,j=0;f=b&255;b=a+(f<<2)+1288|0;h=d&255;d=1<<h;if(ea(g[e>>2])!=ea(0.0))i=c[b>>2]|d;else i=c[b>>2]&~d;c[b>>2]=i;i=a+(h<<2)+1288|0;h=1<<f;if(ea(g[e+4>>2])!=ea(0.0))j=c[i>>2]|h;else j=c[i>>2]&~h;c[i>>2]=j;j=a+1196|0;c[j>>2]=c[j>>2]|2;return}function fea(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=Im,i=Im;f=d&255;d=e&255;h=(c[b+(f<<2)+1288>>2]&1<<d|0)!=0?ea(1.0):ea(0.0);i=(c[b+(d<<2)+1288>>2]&1<<f|0)!=0?ea(1.0):ea(0.0);g[a>>2]=h;g[a+4>>2]=i;return}function gea(a){a=a|0;var b=0,d=0;b=i;d=ita(c[(c[a+1212>>2]|0)+1e3>>2]|0)|0;i=b;return d|0}function hea(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0;f=i;a[b+1420>>0]=1;lta(c[(c[b+1212>>2]|0)+1e3>>2]|0,d,e);if(d){i=f;return}g[b+1416>>2]=e;i=f;return}function iea(a,b){a=a|0;b=b|0;var d=0;d=c[(c[a+1212>>2]|0)+1e3>>2]|0;g[d+6140>>2]=ea(g[b>>2]);g[d+6144>>2]=ea(g[b+4>>2]);g[d+6148>>2]=ea(g[b+8>>2]);g[d+6152>>2]=ea(g[b+12>>2]);g[d+6156>>2]=ea(g[b+16>>2]);g[d+6160>>2]=ea(g[b+20>>2]);return}function jea(a){a=a|0;return (c[(c[a+1212>>2]|0)+1e3>>2]|0)+6140|0}function kea(a){a=a|0;var b=Im;b=ea(g[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+6164>>2]);return ea(b)}function lea(a){a=a|0;var b=Im;b=ea(g[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+6168>>2]);return ea(b)}function mea(a){a=a|0;var b=Im;b=ea(g[(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+12>>2]|0)+144>>2]);return ea(b)}function nea(a){a=a|0;var b=0,d=0;b=i;d=gba(c[a+1088>>2]|0)|0;i=b;return d|0}function oea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=c[a+1164>>2]|0;e=c[a+1168>>2]|0;f=c[a+1212>>2]|0;a=c[f+4>>2]|0;g=c[f>>2]|0;if(e){f=0;while(1){c[(c[d+(f<<2)>>2]|0)+4>>2]=0;h=f+1|0;if((h|0)==(e|0))break;else f=h}}f=a&-32;if(f){h=a+-1|0;h=0;do{j=0;do{k=j+h|0;uZa(c[g+(k<<2)>>2]|0,d,e);j=j+1|0}while((j|0)!=32);h=h+32|0}while(h>>>0<f>>>0)}if(f>>>0>=a>>>0){i=b;return}h=a+-1|0;h=f;do{f=h;h=h+1|0;uZa(c[g+(f<<2)>>2]|0,d,e)}while((h|0)!=(a|0));i=b;return}function pea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[(c[a+1164>>2]|0)+((d&255)<<2)>>2]|0;d=c[f+4>>2]|0;c[b>>2]=d;if(!d){g=0;i=e;return g|0}g=c[f>>2]|0;i=e;return g|0}function qea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=b+1164|0;g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](g,24,k?471632:544544,467192,3233)|0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;a[j+12>>0]=0;c[e>>2]=j;k=b+1168|0;g=c[k>>2]|0;if((c[b+1172>>2]&2147483647)>>>0<=g>>>0){yYa(f,e)|0;l=c[k>>2]|0;m=l+255|0;n=m&255;i=d;return n|0}e=(c[f>>2]|0)+(g<<2)|0;if(e)c[e>>2]=j;j=g+1|0;c[k>>2]=j;l=j;m=l+255|0;n=m&255;i=d;return n|0}function rea(b,d,e){b=b|0;d=d|0;e=e|0;a[(c[(c[b+1164>>2]|0)+((d&255)<<2)>>2]|0)+12>>0]=a[e>>0]|0;return}function sea(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+152>>2]|0;if(e)Fn[c[(c[e>>2]|0)+20>>2]&255](e,b);e=c[a+156>>2]|0;if(!e){i=d;return}Fn[c[(c[e>>2]|0)+20>>2]&255](e,b);i=d;return}function tea(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+152>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+24>>2]&255](d));i=b;return ea(e)}function uea(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+152>>2]|0;if(e)Fn[c[(c[e>>2]|0)+28>>2]&255](e,b);e=c[a+156>>2]|0;if(!e){i=d;return}Fn[c[(c[e>>2]|0)+28>>2]&255](e,b);i=d;return}function vea(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+152>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+32>>2]&255](d));i=b;return ea(e)}function wea(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+152>>2]|0;if(e)In[c[(c[e>>2]|0)+36>>2]&4095](e,b);e=c[a+156>>2]|0;if(!e){i=d;return}In[c[(c[e>>2]|0)+36>>2]&4095](e,b);i=d;return}function xea(a){a=a|0;var b=0,d=0;b=i;d=c[a+152>>2]|0;a=mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;i=b;return a|0}function yea(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+4|0;h=f;j=e+144|0;k=b[j>>1]|0;l=k&65535;if(!(c[(c[c[d+1164>>2]>>2]|0)+16>>2]|0)){do if(!(l&16)){m=d+1136|0;n=c[e+52>>2]|0;c[h>>2]=n;o=d+1140|0;p=c[o>>2]|0;if((c[d+1144>>2]&2147483647)>>>0<=p>>>0){vZa(m,h)|0;q=b[j>>1]|0;break}r=(c[m>>2]|0)+(p<<2)|0;if(r)c[r>>2]=n;c[o>>2]=p+1;q=k}else q=k;while(0);b[j>>1]=q&65535|16;i=f;return}if(!(l&128))s=k;else{k=l&65407;b[j>>1]=k;a[d+1160>>0]=0;s=k}k=s&65535;s=(k|64)&65535;b[j>>1]=s;if(k&16){i=f;return}k=d+1136|0;l=c[e+52>>2]|0;c[g>>2]=l;e=d+1140|0;q=c[e>>2]|0;if((c[d+1144>>2]&2147483647)>>>0>q>>>0){d=(c[k>>2]|0)+(q<<2)|0;if(d)c[d>>2]=l;c[e>>2]=q+1;t=s}else{vZa(k,g)|0;t=b[j>>1]|0}b[j>>1]=t&65535|16;i=f;return}function zea(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;if(!(c[(c[c[d+1164>>2]>>2]|0)+16>>2]|0)){i=f;return}h=e+144|0;j=b[h>>1]|0;k=j&65535;if(!(k&64))l=j;else{j=k&65471;b[h>>1]=j;a[d+1161>>0]=0;l=j}j=l&65535;l=(j|128)&65535;b[h>>1]=l;if(j&32){i=f;return}j=d+1148|0;k=c[e+52>>2]|0;c[g>>2]=k;e=d+1152|0;m=c[e>>2]|0;if((c[d+1156>>2]&2147483647)>>>0>m>>>0){d=(c[j>>2]|0)+(m<<2)|0;if(d)c[d>>2]=k;c[e>>2]=m+1;n=l}else{vZa(j,g)|0;n=b[h>>1]|0}b[h>>1]=n&65535|32;i=f;return}function Aea(a){a=a|0;return (c[(c[a+1212>>2]|0)+1e3>>2]|0)!=0|0}function Bea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,400,j?467992:544544,467192,3520)|0;Oha(h,a,b);if(!h){dKa(bKa()|0,32,467192,3524,467464,d);i=d;return}h=a+116|0;c[e>>2]=b;j=a+120|0;f=c[j>>2]|0;if((c[a+124>>2]&2147483647)>>>0<=f>>>0){wZa(h,e)|0;i=d;return}e=(c[h>>2]|0)+(f<<2)|0;if(e)c[e>>2]=b;c[j>>2]=f+1;i=d;return}function Cea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+120|0;g=c[f>>2]|0;h=c[a+116>>2]|0;a:do if(!g){j=0;k=0}else{a=0;while(1){l=a+1|0;if((c[h+(a<<2)>>2]|0)==(b|0)){j=g;k=a;break a}if(l>>>0<g>>>0)a=l;else{j=g;k=l;break}}}while(0);g=j+-1|0;c[f>>2]=g;c[h+(k<<2)>>2]=c[h+(g<<2)>>2];Qha(Rga(b)|0,d);i=e;return}function Dea(a){a=a|0;return c[a+120>>2]|0}function Eea(a){a=a|0;return c[a+116>>2]|0}function Fea(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;f=d;g=d+8|0;h=d+4|0;j=c[b+28>>2]|0;Ika(g,b);k=(e[g>>1]|0)&1;do if(!k){l=j;m=0}else{if((c[a+(k<<2)+152>>2]|0)!=0?(g=c[a+(k<<2)+168>>2]|0,n=_n[c[(c[g>>2]|0)+20>>2]&4095](g,j)|0,(n|0)!=0):0){Xka(b,n);l=n;m=k;break}dKa(bKa()|0,2,467192,3595,467504,f);Hka(b,1,0);l=j;m=0}while(0);j=c[a+(m<<2)+152>>2]|0;In[c[(c[j>>2]|0)+8>>2]&4095](j,l);l=a+140|0;c[h>>2]=b;j=a+144|0;m=c[j>>2]|0;if((c[a+148>>2]&2147483647)>>>0>m>>>0){f=(c[l>>2]|0)+(m<<2)|0;if(f)c[f>>2]=b;c[j>>2]=m+1}else xZa(l,h)|0;h=mKa()|0;l=c[(c[h>>2]|0)+8>>2]|0;m=pKa()|0;j=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;ula(Bn[l&255](h,140,j?467624:544544,467192,3605)|0,a,b);i=d;return 1}function Gea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+144|0;f=c[e>>2]|0;if(f){g=c[a+140>>2]|0;h=0;while(1){j=h+1|0;if((c[g+(h<<2)>>2]|0)==(b|0)){k=h;break}if(j>>>0<f>>>0)h=j;else{k=j;break}}if((k|0)!=(f|0)){h=f+-1|0;c[e>>2]=h;c[g+(k<<2)>>2]=c[g+(h<<2)>>2]}}h=c[b+28>>2]|0;g=c[(mo[c[(c[h>>2]|0)+16>>2]&4095](h)|0)+4>>2]|0;k=c[a+(g<<2)+152>>2]|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,h);if(g){g=c[a+168>>2]|0;Xka(b,_n[c[(c[g>>2]|0)+20>>2]&4095](g,h)|0)}h=_ia(b)|0;if(!h){i=d;return}ko[c[(c[h>>2]|0)+4>>2]&4095](h);i=d;return}function Hea(a){a=a|0;return c[a+108>>2]|0}function Iea(a){a=a|0;return c[a+104>>2]|0}function Jea(a){a=a|0;return c[a+72>>2]|0}function Kea(a){a=a|0;return c[a+68>>2]|0}function Lea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kpa(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0,b,d)|0;i=e;return f|0}function Mea(a,b){a=a|0;b=b|0;var d=0;d=i;lpa(c[(c[(c[a+1212>>2]|0)+1e3>>2]|0)+8>>2]|0,b);i=d;return}function Nea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0;d=i;i=i+16|0;e=d;f=c[(c[a+1212>>2]|0)+1e3>>2]|0;Ssa(f,b);Npa(c[f+8>>2]|0,b);f=c[a+1164>>2]|0;h=c[a+1168>>2]|0;if(h){j=b+4|0;k=b+8|0;l=0;do{m=c[f+(l<<2)>>2]|0;n=c[m>>2]|0;o=c[m+4>>2]|0;m=(o>>>0)/6|0;if(o>>>0>5){p=o>>>0>11;q=0;r=0;s=n+256|0;while(1){t=r;r=r+6|0;do{u=ea(g[b>>2]);v=n+(t*36|0)+24|0;g[v>>2]=ea(ea(g[v>>2])-u);u=ea(g[j>>2]);v=n+(t*36|0)+28|0;g[v>>2]=ea(ea(g[v>>2])-u);u=ea(g[k>>2]);v=n+(t*36|0)+32|0;g[v>>2]=ea(ea(g[v>>2])-u);t=t+1|0}while(t>>>0<r>>>0);q=q+1|0;if(q>>>0>=m>>>0)break;else s=s+256|0}w=p?m*6|0:6}else w=0;if(w>>>0<o>>>0){s=w;do{u=ea(g[b>>2]);q=n+(s*36|0)+24|0;g[q>>2]=ea(ea(g[q>>2])-u);u=ea(g[j>>2]);q=n+(s*36|0)+28|0;g[q>>2]=ea(ea(g[q>>2])-u);u=ea(g[k>>2]);q=n+(s*36|0)+32|0;g[q>>2]=ea(ea(g[q>>2])-u);s=s+1|0}while((s|0)!=(o|0))}l=l+1|0}while((l|0)!=(h|0))}h=a+72|0;if(c[h>>2]|0){l=a+68|0;k=0;do{j=c[(c[(c[l>>2]|0)+(k<<2)>>2]|0)+28>>2]|0;In[c[(c[j>>2]|0)+16>>2]&4095](j,b);k=k+1|0}while(k>>>0<(c[h>>2]|0)>>>0)}h=a+144|0;if(c[h>>2]|0){k=a+140|0;l=0;do{Wka(c[(c[k>>2]|0)+(l<<2)>>2]|0,b);l=l+1|0}while(l>>>0<(c[h>>2]|0)>>>0)}h=c[a+120>>2]|0;if(!h){i=d;return}l=a+116|0;k=0;do{j=c[(c[l>>2]|0)+(k<<2)>>2]|0;Qha(Rga(j)|0,0);Uga(j,b);w=mKa()|0;f=c[(c[w>>2]|0)+8>>2]|0;o=pKa()|0;s=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;o=Bn[f&255](w,400,s?467992:544544,467192,3784)|0;Oha(o,a,j);if(!o)dKa(bKa()|0,32,467192,3787,467568,e);k=k+1|0}while((k|0)!=(h|0));i=d;return}function Oea(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=c[c[(Vfa(f)|0)+52>>2]>>2]|0;k=e;e=c[k+4>>2]|0;l=h;c[l>>2]=c[k>>2];c[l+4>>2]=e;Kfa(f,d,b,j,h);h=(c[(c[c[a+1088>>2]>>2]|0)+1192>>2]|0)+24|0;c[h>>2]=(c[h>>2]|0)+1;i=g;return}function Pea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=Mfa(e)|0;j=Vfa(e)|0;if(!(a[j+50>>0]|0))k=0;else k=(c[j+56>>2]|0)+2|0;if(!h){l=1073741823;m=0;n=0;o=1073741823}else{j=h+132|0;l=c[j>>2]|0;m=0;n=0;o=c[j+4>>2]|0}j=c[c[(Vfa(e)|0)+52>>2]>>2]|0;h=g;c[h>>2]=l|m;c[h+4>>2]=n|o;Kfa(e,k,d,j,g);g=(c[(c[c[b+1088>>2]>>2]|0)+1192>>2]|0)+24|0;c[g>>2]=(c[g>>2]|0)+1;i=f;return}function Qea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+8|0;f=d;g=c[b+44>>2]|0;In[c[(c[g>>2]|0)+8>>2]&4095](e,g);g=c[(Pha(Iga(b)|0)|0)>>2]|0;c[f>>2]=1073741823;c[f+4>>2]=1073741823;Eia(b,1,e,g,f)|0;f=(c[(c[c[a+1088>>2]>>2]|0)+1192>>2]|0)+28|0;c[f>>2]=(c[f>>2]|0)+1;i=d;return}function Rea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d+8|0;f=d;g=b+20|0;Qka(e,c[g>>2]|0);h=c[c[(_ia(c[g>>2]|0)|0)+52>>2]>>2]|0;c[f>>2]=1073741823;c[f+4>>2]=1073741823;Eia(b,1,e,h,f)|0;f=(c[(c[c[a+1088>>2]>>2]|0)+1192>>2]|0)+32|0;c[f>>2]=(c[f>>2]|0)+1;i=d;return}function Sea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+1088|0;nba(c[f>>2]|0,d,b?4:0);Lfa(d)|0;d=(c[(c[c[f>>2]>>2]|0)+1192>>2]|0)+36|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function Tea(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+1088|0;nba(c[e>>2]|0,b,0);Fia(b)|0;b=(c[(c[c[e>>2]>>2]|0)+1192>>2]|0)+40|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function Uea(a,b){a=a|0;b=b|0;var d=0;d=i;nba(c[a+1088>>2]|0,b,0);Fia(b)|0;i=d;return}function Vea(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0;j=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+68>>2]=-1;g[b+128>>2]=ea(0.0);a[b+132>>0]=1;k=c[116650]|0;CLa(b+68|0,d);g[b+32>>2]=ea(0.0);g[b+36>>2]=ea(0.0);g[b+40>>2]=ea(0.0);g[b+44>>2]=ea(1.0);g[b+48>>2]=ea(0.0);g[b+52>>2]=ea(0.0);g[b+56>>2]=ea(0.0);g[b+60>>2]=ea(ea(g[k>>2])*ea(.0199999996));a[b+64>>0]=a[e>>0]|0;Wea(b,f,h);i=j;return}function Wea(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+16|0;j=h;k=c[d+68>>2]|0;b[d+66>>1]=b[f>>1]|0;if((k|0)==6){l=d+96|0;m=d+132|0;n=d+100|0;o=g&65535;p=c[l>>2]|0;if((e[n>>1]|0)<(g&65535)){if((p|0)!=0?(a[m>>0]|0)!=0:0){VJa(j,p);b[n>>1]=0}q=o<<1;r=UJa(j,q,474736,101)|0;c[l>>2]=r;b[n>>1]=g;a[m>>0]=1;s=q;t=r}else{s=o<<1;t=p}YEi(t|0,f|0,s|0)|0;i=h;return}else if((k|0)==5){k=d+116|0;s=d+132|0;t=d+120|0;d=g&65535;p=c[k>>2]|0;if((e[t>>1]|0)<(g&65535)){if((p|0)!=0?(a[s>>0]|0)!=0:0){VJa(j,p);b[t>>1]=0}o=d<<1;r=UJa(j,o,474736,101)|0;c[k>>2]=r;b[t>>1]=g;a[s>>0]=1;u=o;v=r}else{u=d<<1;v=p}YEi(v|0,f|0,u|0)|0;i=h;return}else{i=h;return}}function Xea(d){d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d+68>>2]|0;if((g|0)==6){if(!(a[d+132>>0]|0)){i=e;return}VJa(f,c[d+96>>2]|0);b[d+100>>1]=0;i=e;return}else if((g|0)==5){if(!(a[d+132>>0]|0)){i=e;return}VJa(f,c[d+116>>2]|0);b[d+120>>1]=0;i=e;return}else{i=e;return}}function Yea(a,b){a=a|0;b=b|0;g[a+32>>2]=ea(g[b>>2]);g[a+36>>2]=ea(g[b+4>>2]);g[a+40>>2]=ea(g[b+8>>2]);g[a+44>>2]=ea(g[b+12>>2]);g[a+48>>2]=ea(g[b+16>>2]);g[a+52>>2]=ea(g[b+20>>2]);g[a+56>>2]=ea(g[b+24>>2]);return}function Zea(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function _ea(a){a=a|0;var d=0,e=0,f=0;d=i;e=c[a+68>>2]|0;do if((e+-5|0)>>>0<=1)if((e|0)==5){f=b[a+120>>1]|0;break}else{f=b[a+100>>1]|0;break}else f=1;while(0);i=d;return f|0}function $ea(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+68>>2]|0;do if((d+-5|0)>>>0<=1)if((d|0)==5){e=c[a+116>>2]|0;break}else{e=c[a+96>>2]|0;break}else e=a+66|0;while(0);i=b;return e|0}function afa(a,b){a=a|0;b=ea(b);g[a+128>>2]=b;return}function bfa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;h=d+68|0;j=c[h>>2]|0;k=c[e>>2]|0;if((j|0)==5){l=d+116|0;m=c[l>>2]|0;n=c[l+4>>2]|0;l=VEi(m|0,n|0,48)|0;o=n&65535;p=m;q=l&65535}else if((j|0)==6){j=d+96|0;l=c[j>>2]|0;m=c[j+4>>2]|0;j=VEi(l|0,m|0,48)|0;o=m&65535;p=l;q=j&65535}else{o=0;p=0;q=0}CLa(h,e);if((k+-5|0)>>>0<2){e=(k|0)==5?d+116|0:d+96|0;if(!(o<<16>>16)){k=UJa(g,2,474736,101)|0;c[e>>2]=k;b[e+4>>1]=1;b[k>>1]=b[d+66>>1]|0;a[d+132>>0]=1;i=f;return}else{k=cFi(q&65535|0,0,48)|0;q=e;c[q>>2]=k|p;c[q+4>>2]=o&65535|H;i=f;return}}if(!(o<<16>>16)){i=f;return}if(!(a[d+132>>0]|0)){i=f;return}VJa(g,p);i=f;return}function cfa(b,c){b=b|0;c=c|0;a[b+64>>0]=a[c>>0]|0;return}function dfa(a){a=a|0;var b=0,c=0;b=i;c=p2(a)|0;i=b;return c|0}function efa(a){a=a|0;var b=0,c=0;b=i;c=p2(a+-32|0)|0;i=b;return c|0}function ffa(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;f=c[a+68>>2]|0;if((f|0)==6){In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+96>>2]|0,(e[a+100>>1]|0)<<1);i=d;return}else if((f|0)==5){In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+116>>2]|0,(e[a+120>>1]|0)<<1);i=d;return}else{i=d;return}}function gfa(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;c[a>>2]=466432;b[a+4>>1]=-1;b[a+6>>1]=1;Gia(a+8|0,c[d+8>>2]|0,c[f+8>>2]|0,0,21);c[a+32>>2]=d;c[a+36>>2]=f;c[a>>2]=474824;c[a+8>>2]=474868;c[a+40>>2]=-1;c[a+48>>2]=g;c[a+52>>2]=-1;c[a+56>>2]=0;c[a+60>>2]=-1;b[a+64>>1]=0;c[a+44>>2]=(e[h>>1]|0)&32767;i=j;return}function hfa(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=Im,Ba=0;f=i;i=i+96|0;h=f+12|0;j=f+48|0;k=f+24|0;l=f+60|0;m=f+84|0;n=f;o=f+36|0;p=f+72|0;q=a+56|0;if(!(c[q>>2]|0)){i=f;return}r=a+32|0;s=Dfa(c[r>>2]|0)|0;t=ea(g[s+1416>>2]);u=c[c[a+48>>2]>>2]|0;a=(u|0)==(Vfa(c[r>>2]|0)|0);v=a?ea(1.0):ea(-1.0);a=h+4|0;r=h+8|0;u=j+4|0;w=j+8|0;x=ea(t*ea(.100000001));y=k+4|0;z=k+8|0;A=l+4|0;B=l+8|0;C=m+4|0;D=m+8|0;E=n+4|0;F=n+8|0;G=o+4|0;H=o+8|0;I=p+4|0;J=p+8|0;K=0;while(1){L=c[q>>2]|0;a:do if(L){M=c[L+40>>2]|0;N=c[L+44>>2]|0;O=c[L+48>>2]|0;if(!(b[L+114>>1]&16))P=0;else P=N+(O+15&-16)|0;if(b[L+36>>1]|0)if(!K){Q=P;R=(M|0)!=0&1;T=O;U=N;break}else V=1;else V=0;if(M){N=M;M=V;while(1){if((M|0)==(K|0))break;O=c[N>>2]|0;if(!O){Q=0;R=K;T=0;U=0;break a}else{N=O;M=M+1|0}}M=e[N+4>>1]|0;Q=N+(M+15&131056)|0;R=((c[N>>2]|0)!=0&1)+K|0;T=M+-8|0;U=N+8|0}else{Q=0;R=K;T=0;U=0}}else{Q=0;R=K;T=0;U=0}while(0);W=ea(Cda(s,10));X=ea(Cda(s,8));Y=ea(Cda(s,9));Z=ea(Cda(s,7));if(T){L=e[U+2>>1]|0;M=L&2;O=(M|0)!=0;_=U+(M<<3|4)|0;M=O?4:32;if(O){$=1;aa=M;ba=72;ca=_}else{$=0;aa=M;ba=L<<3&8|16;ca=_}}else{$=0;aa=0;ba=0;ca=0}_=U;if((ca-_|0)>>>0<T>>>0){L=W==ea(0.0)|(Q|0)==0;M=X!=ea(0.0);fa=ea(t*X);O=Y!=ea(0.0);X=ea(t*Y);ga=Z!=ea(0.0);Z=ea(t*W);ha=ca;do{ia=b[ha>>1]|0;ja=ia&65535;ka=ha;ha=ha+((da(ja,ba)|0)+aa)|0;la=ka+aa|0;b:do if(ia<<16>>16){ma=ka+4|0;if(L){na=0;oa=la}else{pa=0;qa=la;while(1){pa=pa+1|0;W=ea(Z*ea(g[Q>>2]));if(W!=ea(0.0)){ra=DKa(CKa(d,1)|0,16711680)|0;g[h>>2]=ea(g[qa>>2]);sa=qa+4|0;g[a>>2]=ea(g[sa>>2]);ta=qa+8|0;g[r>>2]=ea(g[ta>>2]);ua=GKa(ra,h)|0;ra=$?qa+24|0:ma;Y=ea(W*ea(g[ra>>2]));va=ea(W*ea(g[ra+4>>2]));wa=ea(v*Y);Y=ea(v*va);va=ea(v*ea(W*ea(g[ra+8>>2])));W=ea(wa+ea(g[qa>>2]));wa=ea(Y+ea(g[sa>>2]));Y=ea(va+ea(g[ta>>2]));g[j>>2]=W;g[u>>2]=wa;g[w>>2]=Y;GKa(ua,j)|0}if(ga){Y=ea(g[qa>>2]);wa=ea(g[qa+4>>2]);W=ea(g[qa+8>>2]);DKa(CKa(d,1)|0,-65536)|0;va=ea(wa+ea(0.0));xa=ea(W+ea(0.0));g[k>>2]=ea(Y-x);g[y>>2]=va;g[z>>2]=xa;ua=GKa(d,k)|0;g[l>>2]=ea(x+Y);g[A>>2]=va;g[B>>2]=xa;GKa(ua,l)|0;ya=ea(Y+ea(0.0));Y=ea(wa-x);g[m>>2]=ya;g[C>>2]=Y;g[D>>2]=xa;ua=GKa(d,m)|0;Y=ea(x+wa);g[n>>2]=ya;g[E>>2]=Y;g[F>>2]=xa;GKa(ua,n)|0;xa=ea(W-x);g[o>>2]=ya;g[G>>2]=va;g[H>>2]=xa;ua=GKa(d,o)|0;xa=ea(x+W);g[p>>2]=ya;g[I>>2]=va;g[J>>2]=xa;GKa(ua,p)|0}if((pa|0)==(ja|0))break b;else qa=qa+ba|0}}do{na=na+1|0;if(!M){if(O){za=16776960;Aa=ea(S(ea(X*ea(g[oa+12>>2]))));Ba=24}}else{za=255;Aa=fa;Ba=24}if((Ba|0)==24?(Ba=0,Aa!=ea(0.0)):0){qa=DKa(CKa(d,1)|0,za)|0;g[h>>2]=ea(g[oa>>2]);pa=oa+4|0;g[a>>2]=ea(g[pa>>2]);ua=oa+8|0;g[r>>2]=ea(g[ua>>2]);ta=GKa(qa,h)|0;qa=$?oa+24|0:ma;xa=ea(Aa*ea(g[qa>>2]));va=ea(Aa*ea(g[qa+4>>2]));ya=ea(v*xa);xa=ea(v*va);va=ea(v*ea(Aa*ea(g[qa+8>>2])));W=ea(ya+ea(g[oa>>2]));ya=ea(xa+ea(g[pa>>2]));xa=ea(va+ea(g[ua>>2]));g[j>>2]=W;g[u>>2]=ya;g[w>>2]=xa;GKa(ta,j)|0}if(ga){xa=ea(g[oa>>2]);ya=ea(g[oa+4>>2]);W=ea(g[oa+8>>2]);DKa(CKa(d,1)|0,-65536)|0;va=ea(ya+ea(0.0));Y=ea(W+ea(0.0));g[k>>2]=ea(xa-x);g[y>>2]=va;g[z>>2]=Y;ta=GKa(d,k)|0;g[l>>2]=ea(x+xa);g[A>>2]=va;g[B>>2]=Y;GKa(ta,l)|0;wa=ea(xa+ea(0.0));xa=ea(ya-x);g[m>>2]=wa;g[C>>2]=xa;g[D>>2]=Y;ta=GKa(d,m)|0;xa=ea(x+ya);g[n>>2]=wa;g[E>>2]=xa;g[F>>2]=Y;GKa(ta,n)|0;Y=ea(W-x);g[o>>2]=wa;g[G>>2]=va;g[H>>2]=Y;ta=GKa(d,o)|0;Y=ea(x+W);g[p>>2]=wa;g[I>>2]=va;g[J>>2]=Y;GKa(ta,p)|0}oa=oa+ba|0}while((na|0)!=(ja|0))}while(0)}while((ha-_|0)>>>0<T>>>0)}if((R|0)==(K|0))break;else K=R}i=f;return}function ifa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;h=c[(c[(Dfa(c[d+32>>2]|0)|0)+1088>>2]|0)+44>>2]|0;j=c[e>>2]|0;k=c[d+48>>2]|0;d=c[k>>2]|0;l=c[k+4>>2]|0;if(!(a[d+50>>0]|0)){g[h+(j+12)>>2]=ea(0.0);g[h+(j+16)>>2]=ea(0.0);g[h+(j+20)>>2]=ea(0.0);g[h+(j+36)>>2]=ea(0.0);g[h+(j+40)>>2]=ea(0.0);g[h+(j+44)>>2]=ea(0.0)}else{k=c[d+52>>2]|0;g[h+(j+12)>>2]=ea(g[k+80>>2]);g[h+(j+16)>>2]=ea(g[k+84>>2]);g[h+(j+20)>>2]=ea(g[k+88>>2]);g[h+(j+36)>>2]=ea(g[k+96>>2]);g[h+(j+40)>>2]=ea(g[k+100>>2]);g[h+(j+44)>>2]=ea(g[k+104>>2])}if(!(a[l+50>>0]|0)){g[h+(j+24)>>2]=ea(0.0);g[h+(j+28)>>2]=ea(0.0);g[h+(j+32)>>2]=ea(0.0);g[h+(j+48)>>2]=ea(0.0);g[h+(j+52)>>2]=ea(0.0);g[h+(j+56)>>2]=ea(0.0);m=e+10|0;n=b[m>>1]|0;o=n&65535;p=o&65527;q=p&65535;b[m>>1]=q;i=f;return}else{k=c[l+52>>2]|0;g[h+(j+24)>>2]=ea(g[k+80>>2]);g[h+(j+28)>>2]=ea(g[k+84>>2]);g[h+(j+32)>>2]=ea(g[k+88>>2]);g[h+(j+48)>>2]=ea(g[k+96>>2]);g[h+(j+52)>>2]=ea(g[k+100>>2]);g[h+(j+56)>>2]=ea(g[k+104>>2]);m=e+10|0;n=b[m>>1]|0;o=n&65535;p=o&65527;q=p&65535;b[m>>1]=q;i=f;return}}function jfa(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;l=i;i=i+16|0;m=l;n=(k|0)!=0;o=n?f|32:f;f=d+56|0;p=d+32|0;q=Dfa(c[p>>2]|0)|0;r=c[q+1088>>2]|0;s=d+44|0;t=c[s>>2]|0;u=t&28672;v=d+48|0;w=c[c[v>>2]>>2]|0;x=(w|0)==(Vfa(c[p>>2]|0)|0);w=d+36|0;y=c[(x?p:w)>>2]|0;z=c[(x?w:p)>>2]|0;p=c[v>>2]|0;w=p+12|0;A=e[w>>1]|0;if(!(A&1)){b[w>>1]=A|1;A=c[v>>2]|0;c[m>>2]=A;w=r+4|0;B=r+8|0;C=c[B>>2]|0;if((c[r+12>>2]&2147483647)>>>0>C>>>0){D=(c[w>>2]|0)+(C<<2)|0;if(D)c[D>>2]=A;c[B>>2]=C+1}else yZa(w,m)|0;m=(c[v>>2]|0)+16|0;b[m>>1]=(b[m>>1]|0)+1<<16>>16;E=c[v>>2]|0}else E=p;p=c[q+60>>2]|0;m=c[q+64>>2]|0;w=E+20|0;C=c[w>>2]|0;do if(!C){m7(E);B=c[w>>2]|0;A=c[v>>2]|0;D=c[A+20>>2]|0;F=A+20|0;if(!D){m7(A);G=c[F>>2]|0;H=G+12|0;I=(c[H>>2]|0)!=(p|0);if(!G){m7(A);c[(c[F>>2]|0)+12>>2]=p;if(I){J=B;K=B;L=17;break}else{M=B;N=B;L=32;break}}else{c[H>>2]=p;if(I){J=B;K=B;L=17;break}else{M=B;N=B;L=32;break}}}else{O=B;P=B;Q=D;L=13}}else{O=C;P=C;Q=C;L=13}while(0);if((L|0)==13){C=Q+12|0;Q=(c[C>>2]|0)==(p|0);c[C>>2]=p;if(Q){M=P;N=O;L=32}else{J=O;K=P;L=17}}do if((L|0)==17){P=K+4|0;O=b[P>>1]|0;if(!(O<<16>>16)){b[P>>1]=2;R=2}else R=O;O=K+10|0;P=e[O>>1]|0;if(!((u|0)==0|j)){Q=P&65520;p=(t&4096|0)==0?4:56;if(!(t&8192))S=p;else S=(p&65535)+52&65535;if(!(t&16384))T=S;else T=(S&65535)+60&65535;p=(T&65535)+4|0;C=p&65535;if(C>>>0>Q>>>0){b[O>>1]=P&15|(((p&15|0)!=0&1)<<4)+p&65520;U=C}else U=Q}else{b[O>>1]=P&15;U=0}P=Mba(r,R&65535,U,K)|0;if(!U){b[K+6>>1]=0;b[K+8>>1]=0;b[O>>1]=e[O>>1]&65520;V=K;W=J;X=P;L=49;break}if(P){b[K+6>>1]=0;b[K+8>>1]=0;b[O>>1]=e[O>>1]&65520;Q=c[v>>2]|0;zZa(J,P,u,c[Q>>2]|0,c[Q+4>>2]|0,k,0,4);if((t&10240|0)==10240){a[q+2372>>0]=1;V=K;W=J;X=P;L=49}else{Y=O;Z=K;_=J;$=P}}else{aa=K;L=52}}else if((L|0)==32){P=b[M+6>>1]|0;O=P&65535;if(P<<16>>16){Q=(c[r+44>>2]|0)+(c[M>>2]|0)|0;if(!((u|0)==0|j)){C=b[M+8>>1]|0;p=C<<16>>16!=0;if(p)ba=e[Q>>1]|0;else ba=-1;if((ba|0)<(k|0)){w=C&65535;E=(t&4096|0)==0?4:56;if(!(t&8192))ca=E;else ca=(E&65535)+52&65535;if(!(t&16384))da=ca;else da=(ca&65535)+60&65535;if(!(C<<16>>16))ea=(da&65535)+4&65535;else ea=da;C=(ea&65535)+w&65535;E=M+10|0;if(C>>>0>(e[E>>1]&65520)>>>0){D=b[M+4>>1]|0;fa=Nba(r,((P&65535)>=(D&65535)&1)+(D&65535)|0,C,N)|0}else fa=Q;if(!fa){b[E>>1]=b[E>>1]|4;V=M;W=N;X=Q;L=49;break}C=c[v>>2]|0;zZa(N,fa,u,c[C>>2]|0,c[C+4>>2]|0,k,O,p?w:4);if((t&10240|0)==10240){a[q+2372>>0]=1;V=M;W=N;X=fa;L=49}else{Y=E;Z=M;_=N;$=fa}}else{V=M;W=N;X=Q;L=49}}else{V=M;W=N;X=Q;L=49}}else{aa=M;L=52}}while(0);if((L|0)==49)if(!X){aa=V;L=52}else{Y=V+10|0;Z=V;_=W;$=X}if((L|0)==52){L=aa+10|0;b[L>>1]=b[L>>1]|2;i=l;return}L=e[Y>>1]&65520;aa=$+L|0;$=d+40|0;if((c[$>>2]|0)==(m|0)){X=e[d+64>>1]|0;W=aa+(X<<5)+22|0;b[W>>1]=e[W>>1]|o;W=aa+(X<<5)+20|0;b[W>>1]=b[W>>1]|g;ga=aa+(X<<5)|0}else{X=Z+6|0;W=b[X>>1]|0;V=W&65535;do if((W&65535)<(e[Z+4>>1]|0)){ha=W;ia=aa+(V<<5)|0}else{M=Nba(r,V+1+(V>>>1)|0,L,_)|0;N=b[Y>>1]|0;if(M){fa=b[X>>1]|0;ha=fa;ia=M+(N&65520)+((fa&65535)<<5)|0;break}b[Y>>1]=N|4;i=l;return}while(0);b[d+64>>1]=ha;c[ia>>2]=dfa(c[y+28>>2]|0)|0;c[ia+4>>2]=dfa(c[z+28>>2]|0)|0;ha=ia+8|0;c[ha+0>>2]=0;c[ha+4>>2]=0;c[ha+8>>2]=0;b[ia+20>>1]=g;b[ia+22>>1]=o;c[ia+24>>2]=c[y+20>>2];c[ia+28>>2]=c[z+20>>2];b[X>>1]=(b[X>>1]|0)+1<<16>>16;c[$>>2]=m;ga=ia}ia=c[s>>2]|0;if(h)b[Y>>1]=b[Y>>1]|1;if(!(ia&131072)){i=l;return}Y=c[f>>2]|0;if(!Y){i=l;return}f=ga+8|0;if(!((c[f>>2]|0)==0&(o&272|0)==0)){i=l;return}o=c[Y+40>>2]|0;h=c[Y+44>>2]|0;s=c[Y+48>>2]|0;if(!(b[Y+114>>1]&16))ja=0;else ja=h+(s+15&-16)|0;m=e[Y+36>>1]|0;if((s|0)==0|n){if(!o){i=l;return}if((b[o+6>>1]|0)!=0|n^1){i=l;return}}if(n){n=e[o+4>>1]|0;Y=n+15&131056;ka=Y+-8|0;la=o+8|0;ma=n+-8|0;na=o+Y|0;oa=1}else{ka=s+15&-16;la=h;ma=s;na=ja;oa=m}m=ga+20|0;ja=e[m>>1]|(x?0:64)|ia>>>22&16;ia=(na|0)==0?0:oa<<2;c[f>>2]=la;b[ga+16>>1]=oa;b[ga+18>>1]=ma;c[ga+12>>2]=ia+ka;b[m>>1]=(ia|0)==0?ja:ja|32;i=l;return}function kfa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a+44|0;h=c[g>>2]|0;if(h&32768){i=f;return}c[g>>2]=h&-98305|32768;if(e){e=(c[a+48>>2]|0)+14|0;b[e>>1]=(b[e>>1]|0)+1<<16>>16;e=a+32|0;h=Mfa(c[e>>2]|0)|0;j=Mfa(c[a+36>>2]|0)|0;if(h){k=h+148|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16}if(!j)l=e;else{k=j+148|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16;l=e}}else l=a+32|0;Kua(Via(c[(Dfa(c[l>>2]|0)|0)+1212>>2]|0)|0,a+60|0);e=c[g>>2]|0;if(!(e&476)){i=f;return}if(e&4)jfa(a,4,(b[(c[a+48>>2]|0)+14>>1]|0)==1?4:0,0,0,d);if(e&8){Kba(c[(Dfa(c[l>>2]|0)|0)+1088>>2]|0,a);i=f;return}if(!(e&448)){i=f;return}Lba(c[(Dfa(c[l>>2]|0)|0)+1088>>2]|0,a);i=f;return}function lfa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=a+44|0;if(!(c[g>>2]&32768)){h=0;i=f;return h|0}j=a+32|0;Lua(Via(c[(Dfa(c[j>>2]|0)|0)+1212>>2]|0)|0,a+60|0);k=c[g>>2]|0;if(k&476){l=(k>>>11&256|16)&k;if(!l)m=k;else{jfa(a,l,(b[(c[a+48>>2]|0)+14>>1]|0)==1?8:0,0,1,d);m=c[g>>2]|0}if(!(m&10485760))n=m;else{d=c[(Dfa(c[j>>2]|0)|0)+1088>>2]|0;if(!(m&8388608))xba(d,a);else yba(d,a);d=c[g>>2]&-1572865;c[g>>2]=d;n=d}}else n=k;c[g>>2]=n&-98305|65536;if(e){e=(c[a+48>>2]|0)+14|0;b[e>>1]=(b[e>>1]|0)+-1<<16>>16;e=Mfa(c[j>>2]|0)|0;n=a+36|0;g=Mfa(c[n>>2]|0)|0;if(e){k=e+148|0;b[k>>1]=(b[k>>1]|0)+-1<<16>>16}if(!g)o=n;else{k=g+148|0;b[k>>1]=(b[k>>1]|0)+-1<<16>>16;o=n}}else o=a+36|0;a=Mfa(c[j>>2]|0)|0;j=Mfa(c[o>>2]|0)|0;o=(a|0)!=0;n=(j|0)==0;if(!(n|o^1)){h=1;i=f;return h|0}if(o)F9(a,ea(.399999976));if(n){h=0;i=f;return h|0}F9(j,ea(.399999976));h=0;i=f;return h|0}function mfa(d){d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im;f=i;i=i+16|0;h=f;j=d+44|0;k=c[j>>2]|0;l=d+4|0;m=b[l>>1]|0;n=d+6|0;if(b[n>>1]&2){Paa(d);b[n>>1]=(e[n>>1]|0)&65533}b[l>>1]=0;l=d+32|0;n=Dfa(c[l>>2]|0)|0;o=n+1212|0;p=c[o>>2]|0;do if(m&33){q=c[j>>2]|0;r=Mfa(c[l>>2]|0)|0;s=Mfa(c[d+36>>2]|0)|0;if((r|0)!=0?(a[(c[r+52>>2]|0)+44>>0]&1)==0:0)if(!(q&1))t=9;else t=10;else if((s|0)!=0?!((q&1|0)==0?1:(a[(c[s+52>>2]|0)+44>>0]&1)!=0):0)t=10;else t=9;if((t|0)==9)u=c[j>>2]|262144;else if((t|0)==10)u=c[j>>2]&-262145;c[j>>2]=u;if(((((q&514|0)==0?!(ea(Cda(n,7))!=ea(0.0)):0)?!(ea(Cda(n,8))!=ea(0.0)):0)?!(ea(Cda(n,9))!=ea(0.0)):0)?!(ea(Cda(n,10))!=ea(0.0)):0){c[j>>2]=c[j>>2]&-131073;break}c[j>>2]=c[j>>2]|131072}while(0);u=m&65535;do if((u&5|0)==5){m=Mfa(c[l>>2]|0)|0;q=Mfa(c[d+36>>2]|0)|0;if((m|0)!=0?(a[(c[m+52>>2]|0)+44>>0]&1)!=0:0)v=c[j>>2]|16777216;else v=c[j>>2]&-16777217;c[j>>2]=v;if((q|0)!=0?(a[(c[q+52>>2]|0)+44>>0]&1)!=0:0){q=v|33554432;c[j>>2]=q;w=q;break}q=v&-33554433;c[j>>2]=q;w=q}else w=c[j>>2]|0;while(0);a:do if(!(w&476))x=w;else{if(((c[d+52>>2]|0)==-1?Qia(c[o>>2]|0,d+8|0)|0:0)?(v=c[j>>2]|0,!((v&32768|0)==0|(v&448|0)==0)):0)Lba(c[n+1088>>2]|0,d);v=c[j>>2]|0;do if(v&512){if(((c[(c[(c[l>>2]|0)+28>>2]|0)+68>>2]|0)+-5|0)>>>0>=2?((c[(c[(c[d+36>>2]|0)+28>>2]|0)+68>>2]|0)+-5|0)>>>0>=2:0)break;q=v|67108864;c[j>>2]=q;x=q;break a}while(0);q=v&-67108865;c[j>>2]=q;x=q}while(0);do if(((x^k)&393694|0)==0?(n=d+56|0,o=c[n>>2]|0,(o|0)!=0):0){w=c[l>>2]|0;q=d+36|0;m=c[q>>2]|0;if(!(u&8))y=o;else{o=Mfa(w)|0;s=Mfa(m)|0;if(!o)z=0;else z=a[(c[o+52>>2]|0)+12>>0]|0;if(!s)A=0;else A=a[(c[s+52>>2]|0)+12>>0]|0;fea(h,Dfa(c[l>>2]|0)|0,z,A);s=c[n>>2]|0;g[s+100>>2]=ea(g[h>>2]);g[s+104>>2]=ea(g[h+4>>2]);y=s}if(u&16){B=ea(g[(c[w+28>>2]|0)+128>>2]);g[y+108>>2]=ea(B+ea(g[(c[m+28>>2]|0)+128>>2]))}if((a[(c[(c[l>>2]|0)+8>>2]|0)+51>>0]&1)==0?(a[(c[(c[q>>2]|0)+8>>2]|0)+51>>0]&1)==0:0){c[j>>2]=c[j>>2]|134217728;break}c[j>>2]=c[j>>2]&-134217729;if(!y)vfa(d)}else t=53;while(0);do if((t|0)==53?Qia(p,d+8|0)|0:0){AZa(d);if((a[(c[(c[l>>2]|0)+8>>2]|0)+51>>0]&1)==0?(a[(c[(c[d+36>>2]|0)+8>>2]|0)+51>>0]&1)==0:0){c[j>>2]=c[j>>2]|134217728;break}c[j>>2]=c[j>>2]&-134217729;vfa(d)}while(0);l=c[d+56>>2]|0;if(!l){i=f;return}Bsa(l,(c[j>>2]&2048|0)!=0);i=f;return}function nfa(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f+4|0;h=f;j=e+32|0;k=Via(c[(Dfa(c[j>>2]|0)|0)+1212>>2]|0)|0;l=Mfa(c[j>>2]|0)|0;m=e+36|0;n=Mfa(c[m>>2]|0)|0;if(!l)o=0;else o=d[l+50>>0]|0;if(!n)p=0;else p=d[n+50>>0]|0;if((o|0)==1|(o|0)==4)q=c[l+188>>2]|0;else q=-1;if((p|0)==1|(p|0)==4)r=c[n+188>>2]|0;else r=-1;c[g>>2]=q;c[h>>2]=r;r=e+60|0;Fua(k,0,g,h,r);if((a[(c[(c[j>>2]|0)+8>>2]|0)+51>>0]&1)==0?(a[(c[(c[m>>2]|0)+8>>2]|0)+51>>0]&1)==0:0){m=e+44|0;c[m>>2]=c[m>>2]|134217728;Kua(k,r)}else{r=e+44|0;c[r>>2]=c[r>>2]&-134217729}r=e+8|0;k=_n[c[(c[r>>2]|0)+16>>2]&4095](r,0)|0;m=e+12|0;Oia(c[(c[m>>2]|0)+36>>2]|0,r,k);via(c[m>>2]|0,r);via(c[e+16>>2]|0,r);r=(c[e+48>>2]|0)+16|0;b[r>>1]=(b[r>>1]|0)+1<<16>>16;i=f;return}function ofa(a){a=a|0;var b=0;b=i;nfa(a+-8|0);i=b;return}function pfa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;AZa(a);e=a+32|0;Mua(Via(c[(Dfa(c[e>>2]|0)|0)+1212>>2]|0)|0,0,a+60|0);f=a+8|0;g=a+12|0;wia(c[g>>2]|0,f);wia(c[a+16>>2]|0,f);Pia(c[(c[g>>2]|0)+36>>2]|0,f);do if((c[a+52>>2]|0)!=-1){f=Dfa(c[e>>2]|0)|0;g=a+44|0;h=c[f+1088>>2]|0;if(!(c[g>>2]&8388608)){xba(h,a);j=g;break}else{yba(h,a);j=g;break}}else j=a+44|0;while(0);if(!(c[j>>2]&32768)){k=a+48|0;l=c[k>>2]|0;m=l+16|0;n=b[m>>1]|0;o=n+-1<<16>>16;b[m>>1]=o;i=d;return}j=Mfa(c[e>>2]|0)|0;e=Mfa(c[a+36>>2]|0)|0;if(j){g=j+148|0;b[g>>1]=(b[g>>1]|0)+-1<<16>>16}if(e){g=e+148|0;b[g>>1]=(b[g>>1]|0)+-1<<16>>16}g=a+48|0;a=(c[g>>2]|0)+14|0;b[a>>1]=(b[a>>1]|0)+-1<<16>>16;k=g;l=c[k>>2]|0;m=l+16|0;n=b[m>>1]|0;o=n+-1<<16>>16;b[m>>1]=o;i=d;return}function qfa(a){a=a|0;var b=0;b=i;pfa(a+-8|0);i=b;return}function rfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+44|0;g=c[f>>2]|0;if((g&476|0)!=0&(d&2|0)==0^1|(g&4194304|0)==0)h=g;else{Jba(c[(Dfa(c[b+32>>2]|0)|0)+1088>>2]|0,b);g=c[f>>2]&-4194305;c[f>>2]=g;h=g}g=b+32|0;if((a[(c[(c[g>>2]|0)+8>>2]|0)+51>>0]&1)==0?(a[(c[(c[b+36>>2]|0)+8>>2]|0)+51>>0]&1)==0:0){c[f>>2]=h|134217728;j=0;i=e;return j|0}d=h&-134217729;c[f>>2]=d;h=b+56|0;k=c[h>>2]|0;do if(!k){vfa(b);l=c[h>>2]|0;if(!l){j=0;i=e;return j|0}else{m=c[f>>2]|0;n=l;break}}else{m=d;n=k}while(0);if(!(m&32768)){Lua(Via(c[(Dfa(c[g>>2]|0)|0)+1212>>2]|0)|0,b+60|0);o=c[f>>2]|0;p=c[h>>2]|0}else{o=m;p=n}Bsa(p,(o&2048|0)!=0);j=1;i=e;return j|0}function sfa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rfa(a+-8|0,b)|0;i=c;return d|0}function tfa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;do if(!(d&4)){if((c[a+52>>2]|0)!=-1){g=a+44|0;h=c[g>>2]|0;c[g>>2]=h<<1&4194304|h;h=Dfa(c[a+32>>2]|0)|0;j=c[h+1088>>2]|0;if(!(c[g>>2]&8388608)){xba(j,a);break}else{yba(j,a);break}}}else{j=(b[(c[a+56>>2]|0)+114>>1]&2)!=0;g=a+44|0;h=c[g>>2]|0;if(!(j^(h&32768|0)!=0)){if((c[a+52>>2]|0)==-1)break;c[g>>2]=h<<1&4194304|h;k=Dfa(c[a+32>>2]|0)|0;l=c[k+1088>>2]|0;if(!(c[g>>2]&8388608)){xba(l,a);break}else{yba(l,a);break}}if(j){j=h&-98305;c[g>>2]=j|32768;if(!(h&456))break;c[g>>2]=j|4227072;break}if(!(h&456))m=h;else{j=h&-4194305;c[g>>2]=j;m=j}c[g>>2]=m&-98305|65536}while(0);m=c[a+56>>2]|0;if(m){g=a+44|0;j=c[g>>2]|0;if((j&98304|0)==0?(h=e[m+114>>1]|0,(h&3|0)!=0&(h&2|0)==0):0)c[g>>2]=j|65536;AZa(a)}if(d&6){i=f;return 1}Kua(Via(c[(Dfa(c[a+32>>2]|0)|0)+1212>>2]|0)|0,a+60|0);i=f;return 1}function ufa(a,b){a=a|0;b=b|0;var c=0;c=i;tfa(a+-8|0,b)|0;i=c;return 1}function vfa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0;d=i;i=i+96|0;e=d+80|0;f=d;h=b+32|0;j=Dfa(c[h>>2]|0)|0;k=j+1120|0;l=c[h>>2]|0;h=c[b+36>>2]|0;m=a[(c[l+8>>2]|0)+50>>0]|0;n=a[(c[h+8>>2]|0)+50>>0]|0;o=c[b+44>>2]|0;if(!(o&262144)){p=o>>>10&1^1;q=o>>>11&1^1}else{p=1;q=1}if(!(o&512))r=(o&131072|0)!=0;else r=1;s=r&1;if(!p)t=(o&448|0)!=0;else t=0;r=t&1;if(!(o&98304))u=0;else u=(o>>>14&2)+-1|0;t=o>>>1&1;o=Mfa(l)|0;v=Mfa(h)|0;w=(o|0)!=0;if(w)x=a[(c[o+52>>2]|0)+12>>0]|0;else x=0;y=(v|0)!=0;if(y)z=a[(c[v+52>>2]|0)+12>>0]|0;else z=0;fea(e,j,x,z);z=j+1212|0;j=(c[(c[z>>2]|0)+1e3>>2]|0)+7384|0;Hfa(l,j);Hfa(h,j);j=f+0|0;x=j+80|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(x|0));j=f+4|0;g[j>>2]=ea(1.0);x=f+8|0;g[x>>2]=ea(1.0);A=l+28|0;B=ea(g[(c[A>>2]|0)+128>>2]);C=h+28|0;g[f+48>>2]=ea(B+ea(g[(c[C>>2]|0)+128>>2]));c[f+12>>2]=w?o+64|0:0;c[f+16>>2]=y?v+64|0:0;c[f+36>>2]=s;c[f+40>>2]=r;c[f+44>>2]=t;c[f+52>>2]=p;c[f+56>>2]=q;g[j>>2]=ea(g[e>>2]);g[x>>2]=ea(g[e+4>>2]);c[f+20>>2]=(c[A>>2]|0)+32;c[f+24>>2]=(c[C>>2]|0)+32;c[f+60>>2]=(n<<24>>24==4&1)<<1|m<<24>>24==4;c[f+64>>2]=(n<<24>>24!=0&1)<<1|m<<24>>24!=0;c[f+68>>2]=u;c[f+28>>2]=Wfa(l)|0;c[f+32>>2]=Wfa(h)|0;c[f+72>>2]=c[l+24>>2];c[f+76>>2]=c[h+24>>2];c[f>>2]=b;h=Psa(c[(c[z>>2]|0)+1e3>>2]|0,f,k)|0;k=b+56|0;c[k>>2]=h;if(!h){i=d;return}h=Via(c[z>>2]|0)|0;Gua(h,b+60|0,c[k>>2]|0);i=d;return}function wfa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if(c[a+56>>2]|0){i=b;return}d=a+32|0;e=Dfa(c[d>>2]|0)|0;Kua(Via(c[e+1212>>2]|0)|0,a+60|0);if(c[a+44>>2]&98304){i=b;return}f=Mfa(c[d>>2]|0)|0;d=Mfa(c[a+36>>2]|0)|0;if((f|0)==0|(d|0)==0){i=b;return}mda(e,f,d);i=b;return}function xfa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=(c[a+48>>2]|0)+14|0;h=b[g>>1]|0;if(e){b[g>>1]=h+1<<16>>16;e=Mfa(c[a+32>>2]|0)|0;j=Mfa(c[a+36>>2]|0)|0;if(e){k=e+148|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16}if(j){k=j+148|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16}Kua(d,a+60|0);i=f;return}else{b[g>>1]=h+-1<<16>>16;h=Mfa(c[a+32>>2]|0)|0;g=Mfa(c[a+36>>2]|0)|0;if(h){k=h+148|0;b[k>>1]=(b[k>>1]|0)+-1<<16>>16}if(g){k=g+148|0;b[k>>1]=(b[k>>1]|0)+-1<<16>>16}Lua(d,a+60|0);i=f;return}}function yfa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+44|0;f=c[e>>2]|0;if((f&476|0)==0|(f&4194304|0)==0)g=f;else{Jba(c[(Dfa(c[a+32>>2]|0)|0)+1088>>2]|0,a);f=c[e>>2]&-4194305;c[e>>2]=f;g=f}f=(g&32768|0)!=0;if(!(b[(c[a+56>>2]|0)+114>>1]&2)){if(!f){i=d;return}if(!(lfa(a,0,0)|0)){i=d;return}e=a+32|0;h=Dfa(c[e>>2]|0)|0;j=Mfa(c[e>>2]|0)|0;mda(h,j,Mfa(c[a+36>>2]|0)|0);i=d;return}if(!f){kfa(a,0,0);i=d;return}if(!(g&8)){i=d;return}jfa(a,8,0,0,0,0);i=d;return}function zfa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a>>2]|0;while(1){if(!d){e=0;f=5;break}g=c[d+4>>2]|0;c[a>>2]=g;if(0==0?(c[d+12>>2]&-1073741824|0)==0:0)break;else d=g}if((f|0)==5){i=b;return e|0}e=d;i=b;return e|0}function Afa(a,b){a=a|0;b=b|0;c[a>>2]=c[b+32>>2];return}function Bfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;f=c[b>>2]|0;do{if(f>>>0>=e>>>0){g=0;h=5;break}j=c[f>>2]|0;f=f+4|0;c[b>>2]=f;k=a[j+50>>0]|0}while(!(k<<24>>24==1|k<<24>>24==4));if((h|0)==5){i=d;return g|0}g=c[j+52>>2]|0;i=d;return g|0}function Cfa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0;j=i;i=i+32|0;k=j+8|0;l=j;c[b>>2]=475888;c[b+4>>2]=0;m=b+8|0;c[m>>2]=d;n=b+12|0;o=n;c[o>>2]=1073741823;c[o+4>>2]=1073741823;xia(d,b);c[b>>2]=475024;c[b+24>>2]=-1;c[b+28>>2]=e;o=c[(c[(c[m>>2]|0)+36>>2]|0)+1008>>2]|0;if(a[e+64>>0]&5){Efa(k,0,e,d);if(!(a[d+50>>0]|0))p=0;else p=(c[d+56>>2]|0)+2|0;if(!f){c[l>>2]=1073741823;c[l+4>>2]=1073741823;Oea(o,k,p,l,b)}else{d=f+68|0;f=d;m=c[f+4>>2]|0;q=l;c[q>>2]=c[f>>2];c[q+4>>2]=m;Oea(o,k,p,l,b);l=n;n=c[l+4>>2]&1073741823;p=d;c[p>>2]=c[l>>2]&1073741823;c[p+4>>2]=n}if(h){n=e+60|0;r=ea(g[n>>2]);s=ea(r+ea(g[k>>2]));t=ea(r+ea(g[k+4>>2]));u=ea(r+ea(g[k+8>>2]));g[h>>2]=s;g[h+4>>2]=t;g[h+8>>2]=u;u=ea(g[n>>2]);t=ea(ea(g[k+12>>2])-u);s=ea(ea(g[k+16>>2])-u);r=ea(ea(g[k+20>>2])-u);g[h+12>>2]=t;g[h+16>>2]=s;g[h+20>>2]=r}}h=c[o+1204>>2]|0;o=h+8|0;k=c[o>>2]|0;if(!k){n=c[h>>2]|0;c[h>>2]=n+1;v=n;w=b+20|0;c[w>>2]=v;i=j;return}else{n=k+-1|0;k=c[(c[h+4>>2]|0)+(n<<2)>>2]|0;c[o>>2]=n;v=k;w=b+20|0;c[w>>2]=v;i=j;return}}function Dfa(a){a=a|0;return c[(c[(c[a+8>>2]|0)+36>>2]|0)+1008>>2]|0}function Efa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;d=i;i=i+32|0;h=d;j=e+32|0;k=a[f+50>>0]|0;if(k<<24>>24==1|k<<24>>24==4){k=c[f+52>>2]|0;BZa(k+16|0,j,k+48|0,h);l=e+68|0;m=e+60|0;n=ea(g[m>>2]);oMa(l,b,h,n,0);i=d;return}else{k=c[f+52>>2]|0;o=ea(g[k+32>>2]);p=ea(g[k+36>>2]);q=ea(g[k+40>>2]);r=ea(g[k+16>>2]);s=ea(g[k+20>>2]);t=ea(g[k+24>>2]);u=ea(g[k+28>>2]);v=ea(g[e+48>>2]);w=ea(g[e+52>>2]);x=ea(g[e+56>>2]);y=ea(g[j>>2]);z=ea(g[j+4>>2]);A=ea(g[j+8>>2]);B=ea(g[j+12>>2]);C=ea(ea(u*B)-ea(ea(ea(r*y)+ea(s*z))+ea(t*A)));D=ea(ea(r*B)+ea(ea(u*y)+ea(ea(s*A)-ea(t*z))));E=ea(ea(s*B)+ea(ea(u*z)+ea(ea(t*y)-ea(r*A))));F=ea(ea(t*B)+ea(ea(u*A)+ea(ea(r*z)-ea(s*y))));y=ea(ea(u*u)+ea(-.5));z=ea(ea(ea(r*v)+ea(s*w))+ea(t*x));A=ea(p+ea(ea(ea(s*z)+ea(ea(w*y)+ea(u*ea(ea(t*v)-ea(r*x)))))*ea(2.0)));p=ea(q+ea(ea(ea(ea(y*x)+ea(u*ea(ea(r*w)-ea(s*v))))+ea(t*z))*ea(2.0)));g[h+16>>2]=ea(o+ea(ea(ea(r*z)+ea(ea(v*y)+ea(u*ea(ea(s*x)-ea(t*w)))))*ea(2.0)));g[h+20>>2]=A;g[h+24>>2]=p;g[h>>2]=D;g[h+4>>2]=E;g[h+8>>2]=F;g[h+12>>2]=C;l=e+68|0;m=e+60|0;n=ea(g[m>>2]);oMa(l,b,h,n,0);i=d;return}}function Ffa(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=475024;vYa(c[(c[(c[(c[a+8>>2]|0)+36>>2]|0)+1008>>2]|0)+1204>>2]|0,c[a+20>>2]|0);Dia(a);VJa(b,a);i=b;return}function Gfa(a){a=a|0;var b=0;b=i;c[a>>2]=475024;vYa(c[(c[(c[(c[a+8>>2]|0)+36>>2]|0)+1008>>2]|0)+1204>>2]|0,c[a+20>>2]|0);Dia(a);i=b;return}function Hfa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d;f=a+24|0;h=c[f>>2]|0;if((h|0)!=-1){j=b+28|0;k=h;l=c[j>>2]|0;m=l+(k<<2)|0;n=c[m>>2]|0;o=n+1|0;c[m>>2]=o;i=d;return}h=b+16|0;p=c[b+24>>2]|0;q=p&2147483647;r=b+8|0;s=c[r>>2]|0;if(!s){t=c[b>>2]|0;c[b>>2]=t+1;u=t}else{t=s+-1|0;s=c[(c[b+4>>2]|0)+(t<<2)>>2]|0;c[r>>2]=t;u=s}if((u|0)==(q|0)){s=p<<1;if(q>>>0<s>>>0)CZa(h,s);h=b+28|0;if((c[b+36>>2]&2147483647)>>>0<s>>>0)yUa(h,s);c[b+20>>2]=s;c[b+32>>2]=s;PEi((c[h>>2]|0)+(q<<2)|0,0,p<<2|0)|0}p=b+28|0;c[(c[p>>2]|0)+(u<<2)>>2]=0;Ifa(e,a);a=c[b+16>>2]|0;g[a+(u*28|0)>>2]=ea(g[e>>2]);g[a+(u*28|0)+4>>2]=ea(g[e+4>>2]);g[a+(u*28|0)+8>>2]=ea(g[e+8>>2]);g[a+(u*28|0)+12>>2]=ea(g[e+12>>2]);g[a+(u*28|0)+16>>2]=ea(g[e+16>>2]);g[a+(u*28|0)+20>>2]=ea(g[e+20>>2]);g[a+(u*28|0)+24>>2]=ea(g[e+24>>2]);c[f>>2]=u;j=p;k=u;l=c[j>>2]|0;m=l+(k<<2)|0;n=c[m>>2]|0;o=n+1|0;c[m>>2]=o;i=d;return}function Ifa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;e=i;f=c[d+28>>2]|0;h=f+32|0;j=c[d+8>>2]|0;d=c[j+52>>2]|0;k=d+16|0;if(!(a[j+50>>0]|0)){l=ea(ea(g[f+48>>2])*ea(2.0));m=ea(ea(g[f+52>>2])*ea(2.0));n=ea(ea(g[f+56>>2])*ea(2.0));o=ea(g[d+28>>2]);p=ea(ea(o*o)+ea(-.5));q=ea(g[k>>2]);r=ea(l*q);s=ea(g[d+20>>2]);t=ea(r+ea(m*s));r=ea(g[d+24>>2]);u=ea(t+ea(n*r));t=ea(ea(q*u)+ea(ea(l*p)+ea(o*ea(ea(n*s)-ea(m*r)))));v=ea(ea(s*u)+ea(ea(m*p)+ea(o*ea(ea(l*r)-ea(n*q)))));w=ea(ea(ea(n*p)+ea(o*ea(ea(m*q)-ea(l*s))))+ea(r*u));u=ea(ea(g[d+32>>2])+t);t=ea(ea(g[d+36>>2])+v);v=ea(ea(g[d+40>>2])+w);w=ea(g[h>>2]);l=ea(o*w);m=ea(g[f+44>>2]);p=ea(l+ea(q*m));l=ea(g[f+40>>2]);n=ea(p+ea(s*l));p=ea(g[f+36>>2]);x=ea(ea(ea(r*w)+ea(ea(s*m)+ea(o*p)))-ea(q*l));y=ea(ea(ea(q*p)+ea(ea(r*m)+ea(o*l)))-ea(s*w));z=ea(ea(ea(ea(o*m)-ea(q*w))-ea(s*p))-ea(r*l));g[b>>2]=ea(n-ea(r*p));g[b+4>>2]=x;g[b+8>>2]=y;g[b+12>>2]=z;g[b+16>>2]=u;g[b+20>>2]=t;g[b+24>>2]=v;i=e;return}else{v=ea(g[d+64>>2]);t=ea(g[d+68>>2]);u=ea(v*ea(-2.0));v=ea(t*ea(-2.0));t=ea(ea(g[d+72>>2])*ea(-2.0));z=ea(g[d+60>>2]);y=ea(ea(z*z)+ea(-.5));x=ea(g[d+48>>2]);p=ea(u*x);r=ea(g[d+52>>2]);n=ea(p+ea(v*r));p=ea(g[d+56>>2]);l=ea(n+ea(t*p));n=ea(-x);s=ea(-r);w=ea(-p);q=ea(ea(ea(x*l)+ea(ea(u*y)-ea(z*ea(ea(t*r)-ea(v*p)))))*ea(2.0));m=ea(ea(ea(r*l)+ea(ea(v*y)-ea(z*ea(ea(u*p)-ea(t*x)))))*ea(2.0));o=ea(ea(ea(ea(t*y)-ea(z*ea(ea(v*x)-ea(u*r))))+ea(p*l))*ea(2.0));l=ea(g[d+28>>2]);p=ea(ea(l*l)+ea(-.5));r=ea(g[k>>2]);u=ea(r*q);x=ea(g[d+20>>2]);v=ea(u+ea(x*m));u=ea(g[d+24>>2]);y=ea(ea(u*o)+v);v=ea(ea(r*y)+ea(ea(p*q)+ea(l*ea(ea(x*o)-ea(u*m)))));t=ea(ea(x*y)+ea(ea(p*m)+ea(l*ea(ea(u*q)-ea(r*o)))));A=ea(ea(ea(p*o)+ea(l*ea(ea(r*m)-ea(x*q))))+ea(u*y));y=ea(ea(g[d+32>>2])+v);v=ea(ea(g[d+36>>2])+t);t=ea(ea(g[d+40>>2])+A);A=ea(ea(ea(ea(l*n)+ea(z*r))+ea(x*w))-ea(u*s));q=ea(ea(ea(u*n)+ea(ea(l*s)+ea(z*x)))-ea(r*w));m=ea(ea(ea(r*s)+ea(ea(l*w)+ea(z*u)))-ea(x*n));o=ea(ea(ea(ea(z*l)-ea(r*n))-ea(x*s))-ea(u*w));w=ea(ea(g[f+48>>2])*ea(2.0));u=ea(ea(g[f+52>>2])*ea(2.0));s=ea(ea(g[f+56>>2])*ea(2.0));x=ea(ea(o*o)+ea(-.5));n=ea(ea(ea(A*w)+ea(q*u))+ea(m*s));r=ea(y+ea(ea(A*n)+ea(ea(x*w)+ea(o*ea(ea(q*s)-ea(m*u))))));y=ea(v+ea(ea(q*n)+ea(ea(x*u)+ea(o*ea(ea(m*w)-ea(A*s))))));v=ea(t+ea(ea(ea(x*s)+ea(o*ea(ea(A*u)-ea(q*w))))+ea(m*n)));n=ea(g[h>>2]);w=ea(o*n);u=ea(g[f+44>>2]);s=ea(w+ea(A*u));w=ea(g[f+40>>2]);x=ea(s+ea(q*w));s=ea(g[f+36>>2]);t=ea(ea(ea(m*n)+ea(ea(q*u)+ea(o*s)))-ea(A*w));l=ea(ea(ea(A*s)+ea(ea(m*u)+ea(o*w)))-ea(q*n));z=ea(ea(ea(ea(o*u)-ea(A*n))-ea(q*s))-ea(m*w));g[b>>2]=ea(x-ea(m*s));g[b+4>>2]=t;g[b+8>>2]=l;g[b+12>>2]=z;g[b+16>>2]=r;g[b+20>>2]=y;g[b+24>>2]=v;i=e;return}}function Jfa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=a+24|0;a=(c[b+28>>2]|0)+(c[f>>2]<<2)|0;g=(c[a>>2]|0)+-1|0;c[a>>2]=g;if(g){i=d;return}g=c[f>>2]|0;c[e>>2]=g;a=b+4|0;h=b+8|0;j=c[h>>2]|0;if((c[b+12>>2]&2147483647)>>>0>j>>>0){b=(c[a>>2]|0)+(j<<2)|0;if(!b)k=j;else{c[b>>2]=g;k=c[h>>2]|0}c[h>>2]=k+1}else cUa(a,e)|0;c[f>>2]=-1;i=d;return}function Kfa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+32|0;j=h+8|0;k=h;if(!(Eia(b,d,e,f,g)|0)){i=h;return}g=c[b+28>>2]|0;f=g+32|0;e=c[g+68>>2]|0;if((e|0)==5)l=(c[g+108>>2]|0)+128|0;else if((e|0)==4)l=c[g+104>>2]|0;else if((e|0)==6)l=(c[g+92>>2]|0)+40|0;else l=0;g=c[b+8>>2]|0;e=c[(c[g+36>>2]|0)+1e3>>2]|0;d=a[g+50>>0]|0;if(d<<24>>24==1|d<<24>>24==4){c[j>>2]=f;c[j+12>>2]=l;c[j+8>>2]=(c[g+52>>2]|0)+16;c[j+4>>2]=g+64;rpa(c[e+8>>2]|0,c[b+12>>2]&1073741823,j)}else{c[k>>2]=f;c[k+4>>2]=(c[g+52>>2]|0)+16;qpa(c[e+8>>2]|0,c[b+12>>2]&1073741823,k)}k=c[b+16>>2]|0;b=k&1073741823;g=e+5916|0;f=(b+32|0)>>>5;j=e+5920|0;if(f>>>0>(c[j>>2]&2147483647)>>>0){l=e+5924|0;e=UJa(l,f<<2,543784,339)|0;d=c[g>>2]|0;if((d|0)!=0?(YEi(e|0,d|0,c[j>>2]<<2|0)|0,(c[j>>2]|0)>-1):0)VJa(l,c[g>>2]|0);l=c[j>>2]|0;PEi(e+((l&2147483647)<<2)|0,0,f-l<<2|0)|0;c[g>>2]=e;c[j>>2]=f;m=e}else m=c[g>>2]|0;g=m+(b>>>5<<2)|0;c[g>>2]=c[g>>2]|1<<(k&31);i=h;return}function Lfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+16>>2]|0;f=e&1073741823;if((f|0)!=1073741823){g=c[(c[(c[b+8>>2]|0)+36>>2]|0)+1e3>>2]|0;h=g+5916|0;j=(f+32|0)>>>5;k=g+5920|0;if(j>>>0>(c[k>>2]&2147483647)>>>0){l=g+5924|0;g=UJa(l,j<<2,543784,339)|0;m=c[h>>2]|0;if((m|0)!=0?(YEi(g|0,m|0,c[k>>2]<<2|0)|0,(c[k>>2]|0)>-1):0)VJa(l,c[h>>2]|0);l=c[k>>2]|0;PEi(g+((l&2147483647)<<2)|0,0,j-l<<2|0)|0;c[h>>2]=g;c[k>>2]=j;n=g}else n=c[h>>2]|0;h=n+(f>>>5<<2)|0;c[h>>2]=c[h>>2]&~(1<<(e&31))}e=Fia(b)|0;if(!e){i=d;return e|0}h=c[b+8>>2]|0;b=a[h+50>>0]|0;if(!(b<<24>>24==1|b<<24>>24==4)){i=d;return e|0}if(!h){i=d;return e|0}c[h+132>>2]=1073741823;c[h+136>>2]=1073741823;i=d;return e|0}function Mfa(b){b=b|0;var d=0,e=0;d=c[b+8>>2]|0;b=a[d+50>>0]|0;if(b<<24>>24==1|b<<24>>24==4)e=d;else e=0;return e|0}function Nfa(a,b){a=a|0;b=b|0;var d=0;d=i;if(0==0?(c[a+12>>2]&1073741823|0)==1073741823:0){i=d;return}Sea(c[(c[(c[a+8>>2]|0)+36>>2]|0)+1008>>2]|0,b,a);i=d;return}function Ofa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b;e=a+8|0;Sea(c[(c[(c[e>>2]|0)+36>>2]|0)+1008>>2]|0,1,a);f=c[e>>2]|0;e=c[(c[f+36>>2]|0)+1008>>2]|0;Efa(d,0,c[a+28>>2]|0,f);Pea(e,d,a);i=b;return}function Pfa(a){a=a|0;var b=0;b=i;$aa(a,1,4);i=b;return}function Qfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=b+12|0;if(!(0==0?(c[f>>2]&1073741823|0)==1073741823:0))Sea(c[(c[(c[b+8>>2]|0)+36>>2]|0)+1008>>2]|0,1,b);g=c[b+28>>2]|0;if(!(a[g+64>>0]&5)){i=d;return}h=b+8|0;j=c[h>>2]|0;k=c[(c[j+36>>2]|0)+1008>>2]|0;Efa(e,0,g,j);Pea(k,e,b);b=c[h>>2]|0;h=a[b+50>>0]|0;if(!(h<<24>>24==1|h<<24>>24==4)){i=d;return}if(!b){i=d;return}if(h<<24>>24==1|h<<24>>24==4)l=b;else l=0;b=f;f=c[b+4>>2]&1073741823;h=l+132|0;c[h>>2]=c[b>>2]&1073741823;c[h+4>>2]=f;i=d;return}function Rfa(a){a=a|0;var b=0;b=i;$aa(a,2,1);i=b;return}function Sfa(a){a=a|0;var b=0;b=i;$aa(a,16,1);i=b;return}function Tfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=b+28|0;h=a[(c[g>>2]|0)+64>>0]|0;j=a[d>>0]|0;if(!((j^h)&4))k=j;else{$aa(b,1,4);k=a[d>>0]|0}d=(k&5)!=0;k=(h&5)==0;if(d|k){if(!(d&k)){i=e;return}Sea(c[(c[(c[b+8>>2]|0)+36>>2]|0)+1008>>2]|0,1,b);i=e;return}k=b+8|0;d=c[k>>2]|0;h=c[(c[d+36>>2]|0)+1008>>2]|0;Efa(f,0,c[g>>2]|0,d);Pea(h,f,b);f=c[k>>2]|0;k=a[f+50>>0]|0;if(!(k<<24>>24==1|k<<24>>24==4)){i=e;return}if(!f){i=e;return}if(k<<24>>24==1|k<<24>>24==4)l=f;else l=0;f=b+12|0;b=c[f+4>>2]&1073741823;k=l+132|0;c[k>>2]=c[f>>2]&1073741823;c[k+4>>2]=b;i=e;return}function Ufa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;c[d>>2]=0;g=b+28|0;h=(a[(c[g>>2]|0)+64>>0]&4)==0?0:32;c[d>>2]=h;j=c[b+8>>2]|0;b=a[j+50>>0]|0;do if(b<<24>>24==1|b<<24>>24==4?(j|0)!=0:0){if(b<<24>>24==4){c[d>>2]=h|4;break}if(!(a[(c[j+52>>2]|0)+44>>0]&1))k=h;else{l=h|16;c[d>>2]=l;k=l}c[d>>2]=k|1}while(0);k=(c[g>>2]|0)+16|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];i=f;return}function Vfa(a){a=a|0;return c[a+8>>2]|0}function Wfa(a){a=a|0;return (c[(c[a+8>>2]|0)+52>>2]|0)+16|0}function Xfa(b){b=b|0;var d=0;d=a[(c[b+8>>2]|0)+50>>0]|0;return d<<24>>24==1|d<<24>>24==4|0}function Yfa(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+16|0;h=g;j=f+8|0;k=c[j>>2]|0;l=c[k+36>>2]|0;m=c[f+16>>2]|0;n=m&1073741823;if((n|0)==1073741823)o=k;else{k=l+1e3|0;p=c[k>>2]|0;q=p+5916|0;r=(n+32|0)>>>5;s=p+5920|0;if(r>>>0>(c[s>>2]&2147483647)>>>0){t=p+5924|0;u=UJa(t,r<<2,543784,339)|0;v=c[q>>2]|0;if((v|0)!=0?(YEi(u|0,v|0,c[s>>2]<<2|0)|0,(c[s>>2]|0)>-1):0)VJa(t,c[q>>2]|0);t=c[s>>2]|0;PEi(u+((t&2147483647)<<2)|0,0,r-t<<2|0)|0;c[q>>2]=u;c[s>>2]=r;w=u;x=c[k>>2]|0}else{w=c[q>>2]|0;x=p}p=w+(n>>>5<<2)|0;c[p>>2]=c[p>>2]|1<<(m&31);vpa(c[x+8>>2]|0,n);o=c[j>>2]|0}n=a[o+51>>0]|0;x=c[o+20>>2]|0;m=x+(c[o+28>>2]<<2)|0;o=h;c[o>>2]=x;c[o+4>>2]=m;c[h+8>>2]=f;m=Aia(h)|0;a:do if(m){if(!(n&1))y=m;else{o=m;while(1){x=d[o+20>>0]|0;if((x|0)==2){p=o+-8|0;w=p+56|0;b[w>>1]=e[w>>1]|0|32;w=p+8|0;if(!(Qia(l,w)|0))Ria(l,w)}else if((x|0)==4){w=o+-8|0;p=w+32|0;q=Iga(c[p>>2]|0)|0;$ha(q,c[p>>2]|0,c[w+36>>2]|0)}else if((x|0)==0?(x=c[o+-8+56>>2]|0,(x|0)!=0):0)Csa(x);o=Aia(h)|0;if(!o)break a}}do{o=d[y+20>>0]|0;if((o|0)==2){x=y+-8|0;w=x+56|0;b[w>>1]=e[w>>1]|0|32;w=x+8|0;if(!(Qia(l,w)|0))Ria(l,w)}else if((o|0)==4){w=y+-8|0;x=w+32|0;p=Iga(c[x>>2]|0)|0;$ha(p,c[x>>2]|0,c[w+36>>2]|0)}else if(!o){o=y+-8|0;w=c[o+56>>2]|0;if(w)Csa(w);wfa(o)}y=Aia(h)|0}while((y|0)!=0)}while(0);y=c[j>>2]|0;j=a[y+50>>0]|0;Tsa(c[(c[y+36>>2]|0)+1e3>>2]|0,(c[f+28>>2]|0)+32|0,(c[y+52>>2]|0)+16|0,j<<24>>24==1|j<<24>>24==4);i=g;return}function Zfa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+16|0;f=e;g=c[b+16>>2]|0;h=g&1073741823;j=b+8|0;if((h|0)!=1073741823){k=c[(c[(c[j>>2]|0)+36>>2]|0)+1e3>>2]|0;l=k+5916|0;m=(h+32|0)>>>5;n=k+5920|0;if(m>>>0>(c[n>>2]&2147483647)>>>0){o=k+5924|0;k=UJa(o,m<<2,543784,339)|0;p=c[l>>2]|0;if((p|0)!=0?(YEi(k|0,p|0,c[n>>2]<<2|0)|0,(c[n>>2]|0)>-1):0)VJa(o,c[l>>2]|0);o=c[n>>2]|0;PEi(k+((o&2147483647)<<2)|0,0,m-o<<2|0)|0;c[l>>2]=k;c[n>>2]=m;q=k}else q=c[l>>2]|0;l=q+(h>>>5<<2)|0;c[l>>2]=c[l>>2]|1<<(g&31);vpa(c[(c[(c[(c[j>>2]|0)+36>>2]|0)+1e3>>2]|0)+8>>2]|0,h)}h=c[j>>2]|0;g=c[h+20>>2]|0;l=g+(c[h+28>>2]<<2)|0;h=f;c[h>>2]=g;c[h+4>>2]=l;c[f+8>>2]=b;l=Aia(f)|0;if(!l){r=c[j>>2]|0;s=r+36|0;t=c[s>>2]|0;u=t+1e3|0;v=c[u>>2]|0;w=b+28|0;x=c[w>>2]|0;y=x+32|0;z=r+52|0;A=c[z>>2]|0;B=A+16|0;C=r+50|0;D=a[C>>0]|0;E=D<<24>>24==1;F=D<<24>>24==4;G=E|F;Tsa(v,y,B,G);i=e;return}else H=l;do{l=d[H+20>>0]|0;if(!l){h=c[H+-8+56>>2]|0;if(h)Csa(h)}else if((l|0)==4){l=H+-8|0;h=l+32|0;g=Iga(c[h>>2]|0)|0;$ha(g,c[h>>2]|0,c[l+36>>2]|0)}H=Aia(f)|0}while((H|0)!=0);r=c[j>>2]|0;s=r+36|0;t=c[s>>2]|0;u=t+1e3|0;v=c[u>>2]|0;w=b+28|0;x=c[w>>2]|0;y=x+32|0;z=r+52|0;A=c[z>>2]|0;B=A+16|0;C=r+50|0;D=a[C>>0]|0;E=D<<24>>24==1;F=D<<24>>24==4;G=E|F;Tsa(v,y,B,G);i=e;return}function _fa(a){a=a|0;var b=0;b=i;PEi(a|0,0,188)|0;i=b;return}function $fa(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;d=b+0|0;e=b+24|0;f=d+12|0;do{a[d>>0]=a[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));d=b+12|0;e=b+36|0;f=d+12|0;do{a[d>>0]=a[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));PEi(b+24|0,0,164)|0;i=c;return}function aga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+896|0;f=e;xXa(f);YEi(b|0,f|0,888)|0;f=0;do{g=a+(f*28|0)+48|0;h=b+(f*28|0)+676|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);if(f){h=b+(f<<2)+676|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0)}g=a+(f*28|0)+52|0;h=b+(f*28|0)+680|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);if((f|0)!=1){h=b+(f<<2)+704|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0)}g=a+(f*28|0)+56|0;h=b+(f*28|0)+684|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);if((f|0)!=2){h=b+(f<<2)+732|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0)}g=a+(f*28|0)+60|0;h=b+(f*28|0)+688|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);if((f|0)!=3){h=b+(f<<2)+760|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0)}g=a+(f*28|0)+64|0;h=b+(f*28|0)+692|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);if((f|0)!=4){h=b+(f<<2)+788|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0)}g=a+(f*28|0)+68|0;h=b+(f*28|0)+696|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);h=b+(f<<2)+816|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);g=a+(f*28|0)+72|0;h=b+(f*28|0)+700|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);h=b+(f<<2)+844|0;c[h>>2]=(c[h>>2]|0)+(c[g>>2]|0);f=f+1|0}while((f|0)!=5);c[b+64>>2]=c[a>>2];c[b+76>>2]=c[a+12>>2];c[b+68>>2]=c[a+4>>2];c[b+80>>2]=c[a+16>>2];c[b+72>>2]=c[a+8>>2];c[b+84>>2]=c[a+20>>2];a=0;do{c[b+(a*28|0)+(a<<2)+88>>2]=c[d+(a*28|0)+(a<<2)>>2];c[b+(a*28|0)+(a<<2)+480>>2]=c[d+(a*28|0)+(a<<2)+392>>2];c[b+(a*28|0)+(a<<2)+284>>2]=c[d+(a*28|0)+(a<<2)+196>>2];f=a;a=a+1|0;if(a>>>0<7){g=a;do{h=c[d+(f*28|0)+(g<<2)>>2]|0;c[b+(f*28|0)+(g<<2)+88>>2]=h;c[b+(g*28|0)+(f<<2)+88>>2]=h;h=c[d+(f*28|0)+(g<<2)+392>>2]|0;c[b+(f*28|0)+(g<<2)+480>>2]=h;c[b+(g*28|0)+(f<<2)+480>>2]=h;h=c[d+(f*28|0)+(g<<2)+196>>2]|0;c[b+(f*28|0)+(g<<2)+284>>2]=h;c[b+(g*28|0)+(f<<2)+284>>2]=h;g=g+1|0}while((g|0)!=7)}}while((a|0)!=7);c[b+872>>2]=c[d+588>>2];c[b>>2]=c[d+592>>2];c[b+4>>2]=c[d+596>>2];c[b+8>>2]=c[d+600>>2];c[b+48>>2]=c[d+604>>2];c[b+60>>2]=c[d+616>>2]<<14;c[b+52>>2]=c[d+608>>2];c[b+56>>2]=c[d+612>>2];i=e;return}function bga(a){a=a|0;return c[a+4>>2]|0}function cga(a,b){a=a|0;b=b|0;var d=0;d=i;g[a+16>>2]=ea(g[b>>2]);g[a+20>>2]=ea(g[b+4>>2]);g[a+24>>2]=ea(g[b+8>>2]);g[a+28>>2]=ea(g[b+12>>2]);g[a+32>>2]=ea(g[b+16>>2]);g[a+36>>2]=ea(g[b+20>>2]);g[a+40>>2]=ea(g[b+24>>2]);b=c[a+4>>2]|0;if(!b){i=d;return}hga(b);i=d;return}function dga(a){a=a|0;var b=0,c=0;b=i;c=Zba(a+-16|0)|0;i=b;return c|0}function ega(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;_ba(a,b,d,8);c[a>>2]=475048;Mia(c[b+1212>>2]|0,a,0);i=e;return}function fga(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=475048;Nia(c[a+36>>2]|0,a);c[(c[a+52>>2]|0)+4>>2]=0;aca(a);VJa(b,a);i=b;return}function gga(a){a=a|0;var b=0;b=i;c[a>>2]=475048;Nia(c[a+36>>2]|0,a);c[(c[a+52>>2]|0)+4>>2]=0;aca(a);i=b;return}function hga(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+32|0;d=b+28|0;e=b;bca(a);f=c[(c[(q7(a)|0)+1212>>2]|0)+1e3>>2]|0;c[d>>2]=0;Afa(d,a);a=zfa(d)|0;if(!a){i=b;return}h=f+7400|0;f=e+4|0;j=e+8|0;k=e+12|0;l=e+16|0;m=e+20|0;n=e+24|0;o=a;do{a=o+24|0;if((c[a>>2]|0)!=-1){Ifa(e,o);p=c[a>>2]|0;a=c[h>>2]|0;g[a+(p*28|0)>>2]=ea(g[e>>2]);g[a+(p*28|0)+4>>2]=ea(g[f>>2]);g[a+(p*28|0)+8>>2]=ea(g[j>>2]);g[a+(p*28|0)+12>>2]=ea(g[k>>2]);g[a+(p*28|0)+16>>2]=ea(g[l>>2]);g[a+(p*28|0)+20>>2]=ea(g[m>>2]);g[a+(p*28|0)+24>>2]=ea(g[n>>2])}o=zfa(d)|0}while((o|0)!=0);i=b;return}function iga(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function jga(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a+-8|0);i=b;return}function kga(a){a=a|0;return}function lga(a){a=a|0;return}function mga(d,e){d=d|0;e=e|0;var f=0;e=i;if(b[d+56>>1]&32){f=1;i=e;return f|0}if(a[(c[d+12>>2]|0)+51>>0]&1){f=1;i=e;return f|0}f=(a[(c[d+16>>2]|0)+51>>0]&1)!=0;i=e;return f|0}function nga(d,e){d=d|0;e=e|0;var f=0,g=0;e=i;f=d+-8|0;if(b[f+56>>1]&32){g=1;i=e;return g|0}if(a[(c[f+12>>2]|0)+51>>0]&1){g=1;i=e;return g|0}g=(a[(c[f+16>>2]|0)+51>>0]&1)!=0;i=e;return g|0}function oga(d,e){d=d|0;e=e|0;var f=0;e=i;if(b[d+56>>1]&32){f=0;i=e;return f|0}if(a[(c[d+12>>2]|0)+51>>0]&1){f=0;i=e;return f|0}f=(a[(c[d+16>>2]|0)+51>>0]&1)==0;i=e;return f|0}function pga(d,e){d=d|0;e=e|0;var f=0,g=0;e=i;f=d+-8|0;if(b[f+56>>1]&32){g=0;i=e;return g|0}if(a[(c[f+12>>2]|0)+51>>0]&1){g=0;i=e;return g|0}g=(a[(c[f+16>>2]|0)+51>>0]&1)==0;i=e;return g|0}function qga(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;e=a+8|0;f=_n[c[(c[e>>2]|0)+16>>2]&4095](e,0)|0;g=a+12|0;Oia(c[(c[g>>2]|0)+36>>2]|0,e,f);via(c[g>>2]|0,e);via(c[a+16>>2]|0,e);b[a+52>>1]=0;i=d;return}function rga(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;e=a+-8|0;a=e+8|0;f=_n[c[(c[a>>2]|0)+16>>2]&4095](a,0)|0;g=e+12|0;Oia(c[(c[g>>2]|0)+36>>2]|0,a,f);via(c[g>>2]|0,a);via(c[e+16>>2]|0,a);b[e+52>>1]=0;i=d;return}function sga(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+8|0;e=a+12|0;wia(c[e>>2]|0,d);wia(c[a+16>>2]|0,d);Pia(c[(c[e>>2]|0)+36>>2]|0,d);i=b;return}function tga(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+-8|0;a=d+8|0;e=d+12|0;wia(c[e>>2]|0,a);wia(c[d+16>>2]|0,a);Pia(c[(c[e>>2]|0)+36>>2]|0,a);i=b;return}function uga(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;c[d>>2]=466432;b[d+4>>1]=-1;b[d+6>>1]=1;Gia(d+8|0,c[e+8>>2]|0,c[f+8>>2]|0,4,12);c[d+32>>2]=e;c[d+36>>2]=f;c[d+40>>2]=g;c[d>>2]=475160;c[d+8>>2]=475204;b[d+44>>1]=-1;a[d+46>>0]=0;i=h;return}function vga(a){a=a|0;return}function wga(a){a=a|0;return}function xga(a){a=a|0;return}function yga(a){a=a|0;return}function zga(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d+8|0;h=_n[c[(c[g>>2]|0)+16>>2]&4095](g,0)|0;j=d+12|0;Oia(c[(c[j>>2]|0)+36>>2]|0,g,h);via(c[j>>2]|0,g);via(c[d+16>>2]|0,g);g=d+32|0;j=c[g>>2]|0;h=j+36|0;k=j+42|0;l=b[k>>1]|0;m=j+40|0;if(l<<16>>16==(b[m>>1]|0)){Mga(j,h,m,l,(l&65535)+1&65535);n=h;o=b[k>>1]|0}else{n=h;o=l}l=o+1<<16>>16;b[k>>1]=l;c[(c[n>>2]|0)+((o&65535)<<2)>>2]=d;b[d+44>>1]=(l&65535)+65535;l=d+46|0;a[l>>0]=0;if(a[(c[d+40>>2]|0)+19>>0]|0){i=f;return}o=d+36|0;if(a[(c[(c[o>>2]|0)+28>>2]|0)+64>>0]&4){i=f;return}d=Iga(c[g>>2]|0)|0;Zha(d,c[g>>2]|0,c[o>>2]|0,e);a[l>>0]=1;i=f;return}function Aga(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;h=d+32|0;j=c[h>>2]|0;if((a[(c[d+40>>2]|0)+19>>0]|0)==0?(k=d+36|0,(a[(c[(c[k>>2]|0)+28>>2]|0)+64>>0]&4)==0):0){l=Iga(j)|0;_ha(l,c[h>>2]|0,c[k>>2]|0,e,f);a[d+46>>0]=0}f=d+44|0;e=b[f>>1]|0;k=j+42|0;h=(b[k>>1]|0)+-1<<16>>16;b[k>>1]=h;k=j+36|0;j=c[k>>2]|0;l=e&65535;c[j+(l<<2)>>2]=c[j+((h&65535)<<2)>>2];if((e&65535)<(h&65535))b[(c[(c[k>>2]|0)+(l<<2)>>2]|0)+44>>1]=e;b[f>>1]=-1;f=d+8|0;e=d+12|0;wia(c[e>>2]|0,f);wia(c[d+16>>2]|0,f);Pia(c[(c[e>>2]|0)+36>>2]|0,f);i=g;return}function Bga(b,d){b=b|0;d=d|0;var e=0;d=i;e=(a[(Iga(c[b+32>>2]|0)|0)+51>>0]&1)!=0;i=d;return e|0}function Cga(b,d){b=b|0;d=d|0;var e=0;d=i;e=(a[(Iga(c[b+-8+32>>2]|0)|0)+51>>0]&1)!=0;i=d;return e|0}function Dga(b,d){b=b|0;d=d|0;var e=0;d=i;e=(a[(Iga(c[b+32>>2]|0)|0)+51>>0]&1)==0;i=d;return e|0}function Ega(b,d){b=b|0;d=d|0;var e=0;d=i;e=(a[(Iga(c[b+-8+32>>2]|0)|0)+51>>0]&1)==0;i=d;return e|0}function Fga(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;c[a>>2]=475888;c[a+4>>2]=0;h=a+8|0;c[h>>2]=d;j=a+12|0;c[j>>2]=2147483647;c[j+4>>2]=1073741823;xia(d,a);c[a>>2]=475240;d=a+36|0;c[d>>2]=0;c[d+4>>2]=0;c[a+44>>2]=f;In[c[(c[f>>2]|0)+12>>2]&4095](f,a);b[a+48>>1]=e;Qea(q7(c[h>>2]|0)|0,a);i=g;return}function Gga(a){a=a|0;var b=0;b=i;i=i+16|0;Hga(a);VJa(b,a);i=b;return}function Hga(a){a=a|0;var d=0,f=0,g=0,h=0,j=0;d=i;c[a>>2]=475240;f=a+8|0;Rha(c[f>>2]|0,a);Tea(q7(c[f>>2]|0)|0,a);g=a+44|0;h=c[g>>2]|0;if(h){ko[c[(c[h>>2]|0)+20>>2]&4095](h);c[g>>2]=0}b[a+42>>1]=0;g=a+36|0;h=a+40|0;j=c[g>>2]|0;if((j|0)==0|(j|0)==(a+20|0)){b[h>>1]=0;c[g>>2]=0;Dia(a);i=d;return}Xia(c[(c[f>>2]|0)+36>>2]|0,j,e[h>>1]|0);b[h>>1]=0;c[g>>2]=0;Dia(a);i=d;return}function Iga(a){a=a|0;return c[a+8>>2]|0}function Jga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;f=c[a+44>>2]|0;In[c[(c[f>>2]|0)+8>>2]&4095](e,f);g[b>>2]=ea(g[e>>2]);g[b+4>>2]=ea(g[e+4>>2]);g[b+8>>2]=ea(g[e+8>>2]);g[b+12>>2]=ea(g[e+12>>2]);g[b+16>>2]=ea(g[e+16>>2]);g[b+20>>2]=ea(g[e+20>>2]);i=d;return}function Kga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[b>>2]=0;g=a+8|0;a=Sha(c[g>>2]|0)|0;c[b>>2]=c[b>>2]|(a>>>16&1|2);Tha(f,c[g>>2]|0);c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];i=e;return}function Lga(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0;f=i;g=c[a+36>>2]|0;h=b[a+42>>1]|0;a=g+((h&65535)<<2)|0;if(!(h<<16>>16)){i=f;return}else j=g;do{g=c[j>>2]|0;h=g+4|0;b[h>>1]=e[h>>1]|0|d;h=g+6|0;if(!(b[h>>1]&2)){Oaa(g);b[h>>1]=e[h>>1]|0|2}j=j+4|0}while(j>>>0<a>>>0);i=f;return}function Mga(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;k=h&65535;do if(h<<16>>16)if((h&65535)<5){l=4;m=a+20|0;break}else{n=k+-1|0;o=n>>>1|n;n=o>>>2|o;o=n>>>4|n;n=o>>>8|o;o=(n>>>16|n)+1|0;l=o&65535;m=Wia(c[(c[a+8>>2]|0)+36>>2]|0,o&65535)|0;break}else{l=0;m=0}while(0);YEi(m|0,c[d>>2]|0,(g&65535)<<2|0)|0;g=c[d>>2]|0;if((g|0)==0|(g|0)==(a+20|0)){b[f>>1]=l;c[d>>2]=m;i=j;return}Xia(c[(c[a+8>>2]|0)+36>>2]|0,g,e[f>>1]|0);b[f>>1]=l;c[d>>2]=m;i=j;return}function Nga(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h;d7(a,c[d>>2]|0,1,0,0,0);k=a+16|0;l=a+20|0;c[k>>2]=0;g[a+48>>2]=ea(.00100000005);m=a+52|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];g[a+36>>2]=ea(0.0);g[a+40>>2]=ea(0.0);g[a+44>>2]=ea(0.0);b[a+132>>1]=9;j=a+72|0;l=f?54:38;c[j>>2]=l;if((c[d>>2]|0)==2){g[m>>2]=ea(.0599999987);g[a+56>>2]=ea(1.0);d=(~~ea(ca(ea(10.000001)))>>>0)+-1|0;n=d>>>1|d;d=n>>>2|n;n=d>>>4|d;d=n>>>8|n;n=(d>>>16|d)+1|0;d=n>>>0>4?n:4;n=0;while(1){d=d>>>1;o=n;n=n+1|0;if(!d){p=o;break}if(n>>>0>=32){p=-1;break}}c[a+76>>2]=p;g[a+100>>2]=ea(0.0);g[a+60>>2]=ea(0.0);g[a+92>>2]=ea(0.0)}else{c[j>>2]=l|65536;g[m>>2]=ea(.0199999996);g[a+56>>2]=ea(2.0);m=(~~ea(ca(ea(15.000001)))>>>0)+-1|0;l=m>>>1|m;m=l>>>2|l;l=m>>>4|m;m=l>>>8|l;l=(m>>>16|m)+1|0;m=l>>>0>4?l:4;l=0;while(1){m=m>>>1;j=l;l=l+1|0;if(!m){q=j;break}if(l>>>0>=32){q=-1;break}}c[a+76>>2]=q;g[a+100>>2]=ea(20.0);g[a+60>>2]=ea(6.0);g[a+92>>2]=ea(1.0e3)}g[a+104>>2]=ea(.0599999987);g[a+108>>2]=ea(.00400000019);g[a+112>>2]=ea(.00800000038);g[a+96>>2]=ea(0.0);c[a+136>>2]=0;g[a+80>>2]=ea(.5);g[a+84>>2]=ea(.0500000007);g[a+88>>2]=ea(0.0);g[a+116>>2]=ea(0.0);g[a+120>>2]=ea(0.0);g[a+124>>2]=ea(1.0);g[a+128>>2]=ea(0.0);a=e>>>0<4294967294?e:-2;q=rva(a,f)|0;c[k>>2]=q;if((a|0)==0|f^1){i=h;return}PEi(c[q+52>>2]|0,0,(e>>>0<4294967294?-4-(e<<2^-4)|0:-8)|0)|0;i=h;return}function Oga(a,b){a=a|0;b=b|0;g[a+36>>2]=ea(g[b>>2]);g[a+40>>2]=ea(g[b+4>>2]);g[a+44>>2]=ea(g[b+8>>2]);return}function Pga(a){a=a|0;var b=0,d=0;b=i;d=c[a+16>>2]|0;if(d)sva(d);e7(a);i=b;return}function Qga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+80|0;e=d+24|0;f=d;g=a+16|0;h=c[g>>2]|0;if(h){nva(h,b);i=d;return}c[e+16>>2]=0;c[e+20>>2]=12;c[e+24>>2]=0;c[e+28>>2]=12;c[e+32>>2]=0;c[e+36>>2]=4;c[e+40>>2]=0;c[e+44>>2]=4;h=a+4|0;a=Yha(c[h>>2]|0)|0;Dn[c[(c[a>>2]|0)+20>>2]&511](a,e,1,0);a=c[h>>2]|0;if(!a)j=c[g>>2]|0;else j=Yha(a)|0;In[c[(c[j>>2]|0)+40>>2]&4095](f,j);j=qva(e,f)|0;nva(j,b);sva(j);i=d;return}function Rga(a){a=a|0;return c[a+4>>2]|0}function Sga(a){a=a|0;var b=0;b=a+16|0;a=c[b>>2]|0;c[b>>2]=0;return a|0}function Tga(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function Uga(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[a+116>>2]);f=ea(e*ea(g[b>>2]));e=ea(g[a+120>>2]);h=ea(f+ea(e*ea(g[b+4>>2])));e=ea(g[a+124>>2]);f=ea(h+ea(e*ea(g[b+8>>2])));j=a+128|0;g[j>>2]=ea(ea(g[j>>2])+f);pva(c[a+16>>2]|0,b);i=d;return}function Vga(b){b=b|0;var c=0,d=0;c=i;if((a[b+10>>0]|0)==2){d=r3(b)|0;i=c;return d|0}else{d=d3(b)|0;i=c;return d|0}return 0}function Wga(a){a=a|0;var b=Im;b=ea(g[a+100>>2]);return ea(b)}function Xga(a,b){a=a|0;b=ea(b);g[a+100>>2]=b;return}function Yga(a){a=a|0;var b=Im;b=ea(g[a+60>>2]);return ea(b)}function Zga(a,b){a=a|0;b=ea(b);g[a+60>>2]=b;return}function _ga(a){a=a|0;var b=Im;b=ea(g[a+96>>2]);return ea(b)}function $ga(a,b){a=a|0;b=ea(b);g[a+96>>2]=b;return}function aha(a){a=a|0;var b=Im;b=ea(g[a+48>>2]);return ea(b)}function bha(a,b){a=a|0;b=ea(b);g[a+48>>2]=b;return}function cha(a){a=a|0;var b=Im;b=ea(g[a+80>>2]);return ea(b)}function dha(a,b){a=a|0;b=ea(b);g[a+80>>2]=b;return}function eha(a){a=a|0;var b=Im;b=ea(g[a+84>>2]);return ea(b)}function fha(a,b){a=a|0;b=ea(b);g[a+84>>2]=b;return}function gha(a){a=a|0;var b=Im;b=ea(g[a+88>>2]);return ea(b)}function hha(a,b){a=a|0;b=ea(b);g[a+88>>2]=b;return}function iha(a){a=a|0;return a+20|0}function jha(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+20|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=c[a+4>>2]|0;if(!b){i=d;return}Uha(b);i=d;return}function kha(a){a=a|0;var b=0,d=0;b=i;d=c[a+4>>2]|0;if(!d){i=b;return}Vha(d);i=b;return}function lha(a,d){a=a|0;d=d|0;b[a>>1]=c[d+72>>2];return}function mha(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=a+4|0;h=c[g>>2]|0;j=b[d>>1]|0;if(!h){k=a+72|0;c[k>>2]=c[k>>2]&-65536|j&65535;i=f;return}if(!(j&99)){k=a+72|0;c[k>>2]=c[k>>2]&-65536|j&65535;l=j;m=h}else{j=q7(h)|0;Cea(j,a,0);h=a+72|0;c[h>>2]=c[h>>2]&-65536|(e[d>>1]|0);Bea(j,a);l=b[d>>1]|0;m=c[g>>2]|0}Wha(m,l&65535);i=f;return}function nha(a){a=a|0;return c[a+72>>2]|0}function oha(a){a=a|0;var b=0;b=a+72|0;c[b>>2]=c[b>>2]&-65;return}function pha(a,c){a=a|0;c=c|0;b[a>>1]=b[c+132>>1]|0;return}function qha(a,c){a=a|0;c=c|0;b[a+132>>1]=b[c>>1]|0;return}function rha(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+4>>2]|0;if(!d)e=c[a+16>>2]|0;else e=Yha(d)|0;d=mo[c[(c[e>>2]|0)+44>>2]&4095](e)|0;i=b;return d|0}function sha(a){a=a|0;var b=Im;b=ea(g[a+104>>2]);return ea(b)}function tha(a,b){a=a|0;b=ea(b);g[a+104>>2]=b;return}function uha(a){a=a|0;var b=Im;b=ea(g[a+108>>2]);return ea(b)}function vha(a,b){a=a|0;b=ea(b);g[a+108>>2]=b;return}function wha(a){a=a|0;var b=Im;b=ea(g[a+112>>2]);return ea(b)}function xha(a,b){a=a|0;b=ea(b);g[a+112>>2]=b;return}function yha(a){a=a|0;var b=Im;b=ea(g[a+52>>2]);return ea(b)}function zha(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=0,h=Im,j=0,k=Im,l=0,m=0,n=0;d=i;i=i+32|0;e=ea(g[a+56>>2]);f=a+52|0;h=ea(e*ea(g[f>>2]));j=a+76|0;k=ea(h*ea(1<<c[j>>2]>>>0));g[f>>2]=b;f=(~~ea(ca(ea(k/ea(e*b))))>>>0)+-1|0;a=f>>>1|f;f=a>>>2|a;a=f>>>4|f;f=a>>>8|a;a=(f>>>16|f)+1|0;f=a>>>0>4?a:4;a=0;while(1){f=f>>>1;l=a;a=a+1|0;if(!f){m=l;n=4;break}if(a>>>0>=32){m=-1;n=4;break}}if((n|0)==4){c[j>>2]=m;i=d;return}}function Aha(a){a=a|0;var b=Im,d=Im;b=ea(g[a+56>>2]);d=ea(b*ea(g[a+52>>2]));b=ea(d*ea(1<<c[a+76>>2]>>>0));return ea(b)}function Bha(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=ea(g[a+56>>2]);f=(~~ea(ca(ea(b/ea(e*ea(g[a+52>>2])))))>>>0)+-1|0;h=f>>>1|f;f=h>>>2|h;h=f>>>4|f;f=h>>>8|h;h=(f>>>16|f)+1|0;f=h>>>0>4?h:4;h=0;while(1){f=f>>>1;j=h;h=h+1|0;if(!f){k=j;l=4;break}if(h>>>0>=32){k=-1;l=4;break}}if((l|0)==4){c[a+76>>2]=k;i=d;return}}function Cha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+4>>2]|0;if(!e)f=c[a+16>>2]|0;else f=Yha(e)|0;e=_n[c[(c[f>>2]|0)+8>>2]&4095](f,b)|0;i=d;return e|0}function Dha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+4>>2]|0;if(!f)g=c[a+16>>2]|0;else g=Yha(f)|0;co[c[(c[g>>2]|0)+12>>2]&2047](g,b,d);i=e;return}function Eha(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+4>>2]|0;if(!d)e=c[a+16>>2]|0;else e=Yha(d)|0;ko[c[(c[e>>2]|0)+16>>2]&4095](e);i=b;return}function Fha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[a+4>>2]|0;if(!g)h=c[a+16>>2]|0;else h=Yha(g)|0;Dn[c[(c[h>>2]|0)+24>>2]&511](h,b,d,e);i=f;return}function Gha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[a+4>>2]|0;if(!g)h=c[a+16>>2]|0;else h=Yha(g)|0;Dn[c[(c[h>>2]|0)+28>>2]&511](h,b,d,e);i=f;return}function Hha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[a+4>>2]|0;if(!g)h=c[a+16>>2]|0;else h=Yha(g)|0;Dn[c[(c[h>>2]|0)+32>>2]&511](h,b,d,e);i=f;return}function Iha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,g=0,h=0;f=i;g=c[a+4>>2]|0;if(!g)h=c[a+16>>2]|0;else h=Yha(g)|0;so[c[(c[h>>2]|0)+36>>2]&15](h,b,d,e);i=f;return}function Jha(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+96|0;g=f+88|0;h=f+40|0;j=f;In[c[c[e>>2]>>2]&4095](g,e);k=(a[g>>0]&4)!=0;c[h+16>>2]=0;c[h+20>>2]=12;c[h+24>>2]=0;c[h+28>>2]=12;g=h+32|0;c[g>>2]=0;l=h+36|0;c[l>>2]=4;c[h+40>>2]=0;c[h+44>>2]=4;m=d+4|0;n=c[m>>2]|0;if(!n)o=c[d+16>>2]|0;else o=Yha(n)|0;Dn[c[(c[o>>2]|0)+20>>2]&511](o,h,0,k);c[e+4>>2]=c[h+4>>2];o=c[h+8>>2]|0;c[e+8>>2]=o;n=c[h+12>>2]|0;if(!n)p=0;else p=c[n>>2]|0;c[e+12>>2]=p;p=e+16|0;n=p;c[n>>2]=0;c[n+4>>2]=12;n=e+24|0;q=n;c[q>>2]=0;c[q+4>>2]=12;q=e+32|0;r=q;c[r>>2]=0;c[r+4>>2]=4;r=e+40|0;s=r;c[s>>2]=0;c[s+4>>2]=2;s=e+48|0;t=s;c[t>>2]=0;c[t+4>>2]=12;t=e+56|0;u=t;c[u>>2]=0;c[u+4>>2]=12;u=e+64|0;e=u;c[e>>2]=0;c[e+4>>2]=4;if(!o){i=f;return}o=d+132|0;d=b[o>>1]|0;if(!(d&1))v=d;else{d=h+16|0;e=c[d+4>>2]|0;w=p;c[w>>2]=c[d>>2];c[w+4>>2]=e;v=b[o>>1]|0}if(!(v&2))x=v;else{v=h+24|0;e=c[v+4>>2]|0;w=n;c[w>>2]=c[v>>2];c[w+4>>2]=e;x=b[o>>1]|0}if(!(x&4))y=x;else{x=h+40|0;h=c[x+4>>2]|0;e=q;c[e>>2]=c[x>>2];c[e+4>>2]=h;y=b[o>>1]|0}if(y&8){y=c[l>>2]|0;l=r;c[l>>2]=c[g>>2];c[l+4>>2]=y}y=c[m>>2]|0;if(!y){i=f;return}c[j>>2]=0;c[j+4>>2]=4;c[j+8>>2]=0;c[j+12>>2]=12;c[j+16>>2]=0;c[j+20>>2]=12;c[j+24>>2]=0;c[j+28>>2]=12;c[j+32>>2]=0;c[j+36>>2]=4;Xha(y,j,k);k=b[o>>1]|0;if(!(k&16))z=k;else{k=j+8|0;y=c[k+4>>2]|0;m=s;c[m>>2]=c[k>>2];c[m+4>>2]=y;z=b[o>>1]|0}if(!(z&32))A=z;else{z=j+16|0;y=c[z+4>>2]|0;m=t;c[m>>2]=c[z>>2];c[m+4>>2]=y;A=b[o>>1]|0}if(!(A&64)){i=f;return}A=j;j=c[A+4>>2]|0;o=u;c[o>>2]=c[A>>2];c[o+4>>2]=j;i=f;return}function Kha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+4>>2]|0;if(!e)f=c[b+16>>2]|0;else f=Yha(e)|0;In[c[(c[f>>2]|0)+40>>2]&4095](a,f);i=d;return}function Lha(a){a=a|0;return a+36|0}function Mha(a){a=a|0;return a+116|0}function Nha(a,b){a=a|0;b=b|0;g[a+116>>2]=ea(g[b>>2]);g[a+120>>2]=ea(g[b+4>>2]);g[a+124>>2]=ea(g[b+8>>2]);g[a+128>>2]=ea(g[b+12>>2]);return}function Oha(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+6|0;j=g+4|0;n7(d,e,f,8);c[d>>2]=475264;c[d+328>>2]=0;a[d+320>>0]=1;c[d+324>>2]=d+64;c[d+332>>2]=64;c[d+336>>2]=32;c[d+340>>2]=0;c[d+344>>2]=0;c[d+348>>2]=1664;e=d+352|0;k=d+372|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;b[d+376>>1]=-1;b[d+378>>1]=0;c[d+380>>2]=0;c[k>>2]=443968;c[d+384>>2]=0;c[d+388>>2]=0;c[k>>2]=475672;c[d+392>>2]=d;c[d+396>>2]=475288;k=d+24|0;if((c[k>>2]|0)>>>0<=32)zia(d,d+20|0,k,c[d+28>>2]|0,32);k=c[(c[(q7(d)|0)+1212>>2]|0)+1e3>>2]|0;e=Sga(f)|0;l=d+52|0;lha(h,c[l>>2]|0);m=(b[h>>1]&64)!=0;h=f+52|0;n=Nsa(k,e,h,m)|0;o=d+56|0;c[o>>2]=n;if((n|0)!=0|m^1)p=n;else{dKa(bKa()|0,2,475336,74,475448,g);c[o>>2]=Nsa(k,e,h,0)|0;oha(c[l>>2]|0);p=c[o>>2]|0}if(!p){c[f+4>>2]=0;Tga(f,e);i=g;return}lha(j,c[l>>2]|0);if(!(b[j>>1]&4)){i=g;return}j=c[o>>2]|0;In[c[(c[j>>2]|0)+28>>2]&4095](j,1);i=g;return}function Pha(a){a=a|0;return c[a+52>>2]|0}function Qha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=a+360|0;f=c[e>>2]|0;a:do if(f){g=a+356|0;h=a+60|0;j=a+340|0;k=a+352|0;l=a+344|0;m=a+336|0;n=f;o=1;while(1){p=c[(c[g>>2]|0)+(n+-1<<2)>>2]|0;if((p|0)!=0?(ko[c[c[p>>2]>>2]&4095](p),c[j>>2]=(c[j>>2]|0)+-1,c[p>>2]=c[k>>2],c[k>>2]=p,p=c[l>>2]|0,c[l>>2]=p+1,(p|0)>=((c[m>>2]|0)*50|0)):0){DZa(h);c[l>>2]=0}if((o|0)==(f|0))break a;n=c[e>>2]|0;o=o+1|0}}while(0);e=a+56|0;if(c[e>>2]|0){f=c[(c[(q7(a)|0)+1212>>2]|0)+1e3>>2]|0;o=Osa(f,c[e>>2]|0,b^1)|0;e=a+52|0;if(!b)Tga(c[e>>2]|0,o);c[(c[e>>2]|0)+4>>2]=0}if(!a){i=d;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);i=d;return}function Rha(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=b[d+48>>1]|0;d=a+360|0;f=(c[d>>2]|0)+-1|0;g=c[a+356>>2]|0;a=c[g+(f<<2)>>2]|0;b[a+48>>1]=e;c[d>>2]=f;c[g+((e&65535)<<2)>>2]=a;return}function Sha(a){a=a|0;var b=0,d=0;b=i;d=nha(c[a+52>>2]|0)|0;i=b;return d|0}function Tha(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=iha(c[b+52>>2]|0)|0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];i=d;return}function Uha(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+360|0;if(!(c[d>>2]|0)){i=b;return}e=a+356|0;a=0;do{Lga(c[(c[e>>2]|0)+(a<<2)>>2]|0,1);a=a+1|0}while(a>>>0<(c[d>>2]|0)>>>0);i=b;return}function Vha(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=q7(a)|0;e=c[a+360>>2]|0;if(!e){i=b;return}f=a+356|0;a=0;do{Tea(d,c[(c[f>>2]|0)+(a<<2)>>2]|0);Qea(d,c[(c[f>>2]|0)+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(e|0));i=b;return}function Wha(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+2|0;g=e;h=a+52|0;lha(f,c[h>>2]|0);if((b[f>>1]&4)!=0&(d&4|0)==0){f=c[a+56>>2]|0;In[c[(c[f>>2]|0)+28>>2]&4095](f,1);i=e;return}lha(g,c[h>>2]|0);if((b[g>>1]&4)!=0|(d&4|0)==0){i=e;return}d=c[a+56>>2]|0;In[c[(c[d>>2]|0)+28>>2]&4095](d,0);i=e;return}function Xha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+56>>2]|0;co[c[(c[f>>2]|0)+4>>2]&2047](f,b,d);i=e;return}function Yha(a){a=a|0;var b=0,d=0;b=i;d=c[a+56>>2]|0;a=mo[c[c[d>>2]>>2]&4095](d)|0;i=b;return a|0}function Zha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[d+28>>2]|0)+32|0;h=Xfa(d)|0;j=Wfa(d)|0;if(h)tqa((c[(c[a+36>>2]|0)+1e3>>2]|0)+1448|0,j);d=c[a+56>>2]|0;rn[c[(c[d>>2]|0)+36>>2]&127](d,c[b+44>>2]|0,g,j,h,(e|0)!=0);e=a+368|0;c[e>>2]=(c[e>>2]|0)+1;i=f;return}function _ha(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(c[d+28>>2]|0)+32|0;j=Xfa(d)|0;k=Wfa(d)|0;if(j)uqa((c[(c[a+36>>2]|0)+1e3>>2]|0)+1448|0,k);d=c[a+56>>2]|0;Wn[c[(c[d>>2]|0)+40>>2]&127](d,c[b+44>>2]|0,h,k,j,e,(f|0)!=0);f=a+368|0;c[f>>2]=(c[f>>2]|0)+-1;i=g;return}function $ha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!(Mfa(d)|0))f=0;else f=(c[(Mfa(d)|0)+52>>2]|0)+16|0;g=c[a+56>>2]|0;Dn[c[(c[g>>2]|0)+44>>2]&511](g,c[b+44>>2]|0,(c[d+28>>2]|0)+32|0,f);i=e;return}function aia(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=0,Q=0,R=0;e=i;i=i+128|0;f=e+114|0;h=e+112|0;j=e+64|0;k=e+24|0;l=e+16|0;m=e;n=d+52|0;lha(f,c[n>>2]|0);if(!(b[f>>1]&1)){i=e;return}lha(h,c[n>>2]|0);if(!(b[h>>1]&2)){i=e;return}o=ea(aha(c[n>>2]|0));h=d+56|0;f=c[h>>2]|0;p=mo[c[c[f>>2]>>2]&4095](f)|0;if(!(mo[c[(c[p>>2]|0)+48>>2]&4095](p)|0)){i=e;return}p=j+16|0;c[p>>2]=0;f=j+20|0;c[f>>2]=12;c[j+24>>2]=0;c[j+28>>2]=12;q=j+32|0;c[q>>2]=0;r=j+36|0;c[r>>2]=4;c[j+40>>2]=0;c[j+44>>2]=4;s=c[h>>2]|0;t=mo[c[c[s>>2]>>2]&4095](s)|0;Dn[c[(c[t>>2]|0)+20>>2]&511](t,j,0,0);if(!(c[j+8>>2]|0)){i=e;return}c[k>>2]=0;c[k+4>>2]=4;c[k+8>>2]=0;c[k+12>>2]=12;c[k+16>>2]=0;c[k+20>>2]=12;t=k+24|0;c[t>>2]=0;s=k+28|0;c[s>>2]=12;u=k+32|0;c[u>>2]=0;v=k+36|0;c[v>>2]=4;w=c[h>>2]|0;co[c[(c[w>>2]|0)+4>>2]&2047](w,k,0);k=c[j+12>>2]|0;j=k+4|0;w=c[j>>2]&2147483647;if(!w){i=e;return}h=c[k>>2]|0;x=0;while(1){y=c[h+(x<<2)>>2]|0;if(y)break;z=x+1|0;if(z>>>0<w>>>0)x=z;else{A=28;break}}if((A|0)==28){i=e;return}z=c[425648+((da(y&0-y,125613361)|0)>>>27<<2)>>2]|x<<5;B=y+-1&y;a:do if(!B){y=x;while(1){C=y+1|0;if(C>>>0>=w>>>0){D=C;E=0;break a}F=c[h+(C<<2)>>2]|0;if(!F)y=C;else{D=C;E=F;break}}}else{D=x;E=B}while(0);if((z|0)==-1){i=e;return}B=m+4|0;x=m+8|0;h=D;D=E;E=z;b:while(1){z=h<<5;w=D;y=E;while(1){F=c[(c[u>>2]|0)+(da(c[v>>2]|0,y)|0)>>2]|0;do if(((F|0)!=0?(C=b[(c[q>>2]|0)+(da(c[r>>2]|0,y)|0)>>1]|0,G=F+-16|0,H=G+16|0,!(ea(g[H+124>>2])==ea(0.0))):0)?(I=q7(d)|0,fea(l,I,a[(c[n>>2]|0)+12>>0]|0,a[G+12>>0]|0),(C&8)==0?ea(g[l>>2])!=ea(0.0):0):0){C=(c[p>>2]|0)+(da(c[f>>2]|0,y)|0)|0;I=c[t>>2]|0;J=da(c[s>>2]|0,y)|0;K=I+J|0;L=I+(J+4)|0;if((ea(g[K>>2])==ea(0.0)?ea(g[L>>2])==ea(0.0):0)?ea(g[I+(J+8)>>2])==ea(0.0):0)break;F9(K8(G)|0,ea(.399999976));M=ea(o*ea(g[K>>2]));N=ea(o*ea(g[L>>2]));O=ea(o*ea(g[I+(J+8)>>2]));g[m>>2]=M;g[B>>2]=N;g[x>>2]=O;EZa(H,m,C)}while(0);if(!w){A=28;break b}y=c[425648+((da(w&0-w,125613361)|0)>>>27<<2)>>2]|z;w=w+-1&w;P=c[j>>2]&2147483647;if(!w){Q=h;break}if((y|0)==-1){A=28;break b}}while(1){Q=Q+1|0;if(Q>>>0>=P>>>0){R=0;break}w=c[(c[k>>2]|0)+(Q<<2)>>2]|0;if(w){R=w;break}}if((y|0)==-1){A=28;break}else{h=Q;D=R;E=y}}if((A|0)==28){i=e;return}}function bia(a){a=a|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im;d=i;i=i+16|0;e=d;f=q7(a)|0;h=c[f+1184>>2]|0;j=f+1176|0;f=c[j>>2]|0;k=c[j+4>>2]|0;Dn[c[(c[h>>2]|0)+8>>2]&511](h,116,f,k);j=a+52|0;l=Lha(c[j>>2]|0)|0;g[e>>2]=ea(g[l>>2]);m=e+4|0;g[m>>2]=ea(g[l+4>>2]);n=e+8|0;g[n>>2]=ea(g[l+8>>2]);if(!(b[(c[j>>2]|0)+8>>1]&2)){j=q7(a)|0;o=ea(g[j+32>>2]);p=ea(g[j+36>>2]);q=ea(g[j+40>>2]);g[e>>2]=ea(o+ea(g[e>>2]));g[m>>2]=ea(p+ea(g[m>>2]));g[n>>2]=ea(q+ea(g[n>>2]))}n=a+56|0;m=c[n>>2]|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,e);e=c[n>>2]|0;n=c[(c[e>>2]|0)+20>>2]|0;q=ea(g[(q7(a)|0)+48>>2]);Fn[n&255](e,q);Dn[c[(c[h>>2]|0)+12>>2]&511](h,116,f,k);i=d;return}function cia(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b+16|0;f=b;g=c[(q7(a)|0)+1184>>2]|0;h=(q7(a)|0)+1176|0;j=c[h>>2]|0;k=c[h+4>>2]|0;h=e[268332]|e[268333]<<16;l=(g|0)==0|(h&16711680|0)==0;if(!l)Dn[c[(c[g>>2]|0)+8>>2]&511](g,h&65535,j,k);m=c[a+56>>2]|0;In[c[(c[m>>2]|0)+8>>2]&4095](m,f);m=f+12|0;if(c[m>>2]|0){n=f+8|0;o=a+60|0;p=a+340|0;q=a+352|0;r=a+344|0;s=a+336|0;t=0;do{u=c[(c[n>>2]|0)+(t<<2)>>2]|0;v=mo[c[(c[u>>2]|0)+16>>2]&4095](u)|0;if((v|0)!=0?(ko[c[c[v>>2]>>2]&4095](v),c[p>>2]=(c[p>>2]|0)+-1,c[v>>2]=c[q>>2],c[q>>2]=v,v=c[r>>2]|0,c[r>>2]=v+1,(v|0)>=((c[s>>2]|0)*50|0)):0){DZa(o);c[r>>2]=0}t=t+1|0}while(t>>>0<(c[m>>2]|0)>>>0)}m=f+4|0;if(c[m>>2]|0){t=a+356|0;r=a+360|0;o=a+352|0;s=a+60|0;q=a+340|0;p=a+344|0;n=a+364|0;v=0;do{u=c[(c[f>>2]|0)+(v<<2)>>2]|0;w=c[r>>2]|0;x=c[o>>2]|0;if(!x){FZa(s);y=c[o>>2]|0}else y=x;c[o>>2]=c[y>>2];c[q>>2]=(c[q>>2]|0)+1;c[p>>2]=(c[p>>2]|0)+-1;do if(!y){c[d>>2]=0;ko[c[(c[u>>2]|0)+20>>2]&4095](u)}else{Fga(y,a,w,u);c[d>>2]=y;x=c[r>>2]|0;if((c[n>>2]&2147483647)>>>0<=x>>>0){GZa(t,d)|0;break}z=(c[t>>2]|0)+(x<<2)|0;if(z)c[z>>2]=y;c[r>>2]=x+1}while(0);v=v+1|0}while(v>>>0<(c[m>>2]|0)>>>0)}if(l){i=b;return}Dn[c[(c[g>>2]|0)+12>>2]&511](g,h&65535,j,k);i=b;return}function dia(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=q7(a)|0;e=c[d+1184>>2]|0;f=d+1176|0;d=c[f>>2]|0;g=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,117,d,g);f=c[a+56>>2]|0;ko[c[(c[f>>2]|0)+48>>2]&4095](f);cia(a);aia(a);Dn[c[(c[e>>2]|0)+12>>2]&511](e,117,d,g);i=b;return}function eia(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+80|0;h=f+56|0;j=f+28|0;k=f;if(!(b[(c[d+52>>2]|0)+8>>1]&1)){i=f;return}g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(1.0);g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);FKa(e,k)|0;if(ea(Cda(q7(d)|0,26))>ea(0.0)){k=c[d+56>>2]|0;l=mo[c[c[k>>2]>>2]&4095](k)|0;In[c[(c[l>>2]|0)+40>>2]&4095](h,l);l=DKa(e,-65536)|0;g[j>>2]=ea(g[h>>2]);g[j+4>>2]=ea(g[h+4>>2]);g[j+8>>2]=ea(g[h+8>>2]);g[j+12>>2]=ea(g[h+12>>2]);g[j+16>>2]=ea(g[h+16>>2]);g[j+20>>2]=ea(g[h+20>>2]);a[j+24>>0]=1;HKa(l,j)|0}fia(d,e);if(ea(Cda(q7(d)|0,27))>ea(0.0))gia(d,e);if(!(ea(Cda(q7(d)|0,28))>ea(0.0))){i=f;return}l=d+360|0;if(!(c[l>>2]|0)){i=f;return}k=d+356|0;d=j+4|0;m=h+4|0;n=j+8|0;o=h+8|0;p=j+12|0;q=h+12|0;r=j+16|0;s=h+16|0;t=j+20|0;u=h+20|0;v=j+24|0;w=0;do{x=c[(c[(c[k>>2]|0)+(w<<2)>>2]|0)+44>>2]|0;In[c[(c[x>>2]|0)+8>>2]&4095](h,x);x=DKa(e,-16776961)|0;g[j>>2]=ea(g[h>>2]);g[d>>2]=ea(g[m>>2]);g[n>>2]=ea(g[o>>2]);g[p>>2]=ea(g[q>>2]);g[r>>2]=ea(g[s>>2]);g[t>>2]=ea(g[u>>2]);a[v>>0]=1;HKa(x,j)|0;w=w+1|0}while(w>>>0<(c[l>>2]|0)>>>0);i=f;return}function fia(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;e=i;i=i+416|0;f=e+16|0;h=e+400|0;j=e+402|0;k=e+96|0;l=e+208|0;m=e+228|0;n=e+288|0;o=e+308|0;p=e+64|0;q=e+336|0;r=e+192|0;s=e+72|0;t=e;u=e+84|0;v=e+216|0;w=e+296|0;x=e+128|0;y=e+256|0;z=ea(g[(q7(a)|0)+48>>2]);A=f+16|0;c[A>>2]=0;B=f+20|0;c[B>>2]=12;C=f+24|0;c[C>>2]=0;D=f+28|0;c[D>>2]=12;c[f+32>>2]=0;c[f+36>>2]=4;c[f+40>>2]=0;c[f+44>>2]=4;E=c[a+56>>2]|0;F=mo[c[c[E>>2]>>2]&4095](E)|0;Dn[c[(c[F>>2]|0)+20>>2]&511](F,f,0,0);if(!(c[f+4>>2]|0)){i=e;return}F=a+52|0;pha(h,c[F>>2]|0);E=b[h>>1]&1;pha(j,c[F>>2]|0);h=(b[j>>1]&2)!=0;j=E<<16>>16==0;a:do if(!(!(ea(Cda(q7(a)|0,29))>ea(0.0))|j)?(G=ea(sha(c[F>>2]|0)),E=c[f+12>>2]|0,H=E+4|0,I=c[H>>2]&2147483647,(I|0)!=0):0){J=c[E>>2]|0;K=0;while(1){L=c[J+(K<<2)>>2]|0;if(L)break;M=K+1|0;if(M>>>0<I>>>0)K=M;else break a}M=c[425648+((da(L&0-L,125613361)|0)>>>27<<2)>>2]|K<<5;N=L+-1&L;b:do if(!N){O=K;while(1){P=O+1|0;if(P>>>0>=I>>>0){Q=P;R=0;break b}S=c[J+(P<<2)>>2]|0;if(!S)O=P;else{Q=P;R=S;break}}}else{Q=K;R=N}while(0);if((M|0)!=-1){U=ea(G*ea(.990000009));N=k+4|0;K=k+8|0;J=k+12|0;I=k+16|0;O=k+20|0;S=k+24|0;P=l+4|0;V=m+4|0;W=m+8|0;X=m+12|0;Y=m+16|0;Z=m+20|0;_=m+24|0;$=n+4|0;aa=o+4|0;ba=o+8|0;ca=o+12|0;fa=o+16|0;ga=o+20|0;ha=o+24|0;ia=p+4|0;ja=Q;ka=R;la=M;while(1){ma=ja<<5;c:do if(h){na=ka;oa=la;while(1){pa=c[A>>2]|0;qa=da(c[B>>2]|0,oa)|0;ra=pa+qa|0;sa=c[C>>2]|0;ta=da(c[D>>2]|0,oa)|0;ua=ea(g[sa+ta>>2]);va=ea(ua*ua);ua=ea(g[sa+(ta+4)>>2]);wa=ea(va+ea(ua*ua));ua=ea(g[sa+(ta+8)>>2]);if(!(ea(z*ea(T(ea(wa+ea(ua*ua)))))>=U))DKa(d,-16711936)|0;else DKa(d,-65536)|0;g[k>>2]=ea(0.0);g[N>>2]=ea(0.0);g[K>>2]=ea(0.0);g[J>>2]=ea(1.0);g[I>>2]=ea(g[ra>>2]);ta=pa+(qa+4)|0;g[O>>2]=ea(g[ta>>2]);sa=pa+(qa+8)|0;g[S>>2]=ea(g[sa>>2]);qa=FKa(d,k)|0;c[l>>2]=12;g[P>>2]=G;KKa(qa,l)|0;g[m>>2]=ea(0.0);g[V>>2]=ea(.707106769);g[W>>2]=ea(0.0);g[X>>2]=ea(.707106769);g[Y>>2]=ea(g[ra>>2]);g[Z>>2]=ea(g[ta>>2]);g[_>>2]=ea(g[sa>>2]);qa=FKa(d,m)|0;c[n>>2]=12;g[$>>2]=G;KKa(qa,n)|0;g[o>>2]=ea(.5);g[aa>>2]=ea(.5);g[ba>>2]=ea(.5);g[ca>>2]=ea(.5);g[fa>>2]=ea(g[ra>>2]);g[ga>>2]=ea(g[ta>>2]);g[ha>>2]=ea(g[sa>>2]);sa=FKa(d,o)|0;c[p>>2]=12;g[ia>>2]=G;KKa(sa,p)|0;if(!na)break a;oa=c[425648+((da(na&0-na,125613361)|0)>>>27<<2)>>2]|ma;na=na+-1&na;if(!na){xa=oa;break c}if((oa|0)==-1)break a}}else{oa=ka;na=la;while(1){sa=c[A>>2]|0;ta=da(c[B>>2]|0,na)|0;ra=sa+ta|0;DKa(d,-16711936)|0;g[k>>2]=ea(0.0);g[N>>2]=ea(0.0);g[K>>2]=ea(0.0);g[J>>2]=ea(1.0);g[I>>2]=ea(g[ra>>2]);qa=sa+(ta+4)|0;g[O>>2]=ea(g[qa>>2]);pa=sa+(ta+8)|0;g[S>>2]=ea(g[pa>>2]);ta=FKa(d,k)|0;c[l>>2]=12;g[P>>2]=G;KKa(ta,l)|0;g[m>>2]=ea(0.0);g[V>>2]=ea(.707106769);g[W>>2]=ea(0.0);g[X>>2]=ea(.707106769);g[Y>>2]=ea(g[ra>>2]);g[Z>>2]=ea(g[qa>>2]);g[_>>2]=ea(g[pa>>2]);ta=FKa(d,m)|0;c[n>>2]=12;g[$>>2]=G;KKa(ta,n)|0;g[o>>2]=ea(.5);g[aa>>2]=ea(.5);g[ba>>2]=ea(.5);g[ca>>2]=ea(.5);g[fa>>2]=ea(g[ra>>2]);g[ga>>2]=ea(g[qa>>2]);g[ha>>2]=ea(g[pa>>2]);pa=FKa(d,o)|0;c[p>>2]=12;g[ia>>2]=G;KKa(pa,p)|0;if(!oa)break a;na=c[425648+((da(oa&0-oa,125613361)|0)>>>27<<2)>>2]|ma;oa=oa+-1&oa;if(!oa){xa=na;break c}if((na|0)==-1)break a}}while(0);ma=c[H>>2]&2147483647;na=ja;while(1){na=na+1|0;if(na>>>0>=ma>>>0){ya=0;break}oa=c[(c[E>>2]|0)+(na<<2)>>2]|0;if(oa){ya=oa;break}}if((xa|0)==-1)break;else{ja=na;ka=ya;la=xa}}}}while(0);d:do if(!(!(ea(Cda(q7(a)|0,23))>ea(0.0))|j)?(G=ea(Cda(q7(a)|0,23)),U=ea(ea(G*ea(g[(q7(a)|0)+1416>>2]))*ea(.5)),xa=CKa(DKa(d,-16776961)|0,1)|0,g[q>>2]=ea(1.0),ya=q+4|0,c[ya+0>>2]=0,c[ya+4>>2]=0,c[ya+8>>2]=0,c[ya+12>>2]=0,g[q+20>>2]=ea(1.0),ya=q+24|0,c[ya+0>>2]=0,c[ya+4>>2]=0,c[ya+8>>2]=0,c[ya+12>>2]=0,g[q+40>>2]=ea(1.0),ya=q+44|0,c[ya+0>>2]=0,c[ya+4>>2]=0,c[ya+8>>2]=0,c[ya+12>>2]=0,g[q+60>>2]=ea(1.0),EKa(xa,q)|0,xa=c[f+12>>2]|0,ya=xa+4|0,p=c[ya>>2]&2147483647,(p|0)!=0):0){o=c[xa>>2]|0;n=0;while(1){za=c[o+(n<<2)>>2]|0;if(za)break;m=n+1|0;if(m>>>0<p>>>0)n=m;else break d}m=c[425648+((da(za&0-za,125613361)|0)>>>27<<2)>>2]|n<<5;l=za+-1&za;e:do if(!l){k=n;while(1){R=k+1|0;if(R>>>0>=p>>>0){Aa=R;Ba=0;break e}Q=c[o+(R<<2)>>2]|0;if(!Q)k=R;else{Aa=R;Ba=Q;break}}}else{Aa=n;Ba=l}while(0);if((m|0)!=-1){l=r+4|0;n=r+8|0;o=s+4|0;p=s+8|0;k=t+4|0;na=t+8|0;Q=u+4|0;R=u+8|0;L=v+4|0;F=v+8|0;la=w+4|0;ka=w+8|0;ja=Aa;E=Ba;H=m;while(1){ia=ja<<5;ha=E;ga=H;while(1){fa=c[A>>2]|0;ca=da(c[B>>2]|0,ga)|0;ba=fa+ca|0;G=ea(ea(g[ba>>2])+ea(0.0));aa=fa+(ca+4)|0;ua=ea(ea(g[aa>>2])+ea(0.0));$=fa+(ca+8)|0;wa=ea(U+ea(g[$>>2]));g[r>>2]=G;g[l>>2]=ua;g[n>>2]=wa;ca=GKa(d,r)|0;wa=ea(g[ba>>2]);ua=ea(g[aa>>2]);G=ea(ea(g[$>>2])-U);g[s>>2]=wa;g[o>>2]=ua;g[p>>2]=G;GKa(ca,s)|0;G=ea(ea(g[ba>>2])+ea(0.0));ua=ea(U+ea(g[aa>>2]));wa=ea(ea(g[$>>2])+ea(0.0));g[t>>2]=G;g[k>>2]=ua;g[na>>2]=wa;ca=GKa(d,t)|0;wa=ea(g[ba>>2]);ua=ea(ea(g[aa>>2])-U);G=ea(g[$>>2]);g[u>>2]=wa;g[Q>>2]=ua;g[R>>2]=G;GKa(ca,u)|0;G=ea(U+ea(g[ba>>2]));ua=ea(ea(g[aa>>2])+ea(0.0));wa=ea(ea(g[$>>2])+ea(0.0));g[v>>2]=G;g[L>>2]=ua;g[F>>2]=wa;ca=GKa(d,v)|0;wa=ea(ea(g[ba>>2])-U);ua=ea(g[aa>>2]);G=ea(g[$>>2]);g[w>>2]=wa;g[la>>2]=ua;g[ka>>2]=G;GKa(ca,w)|0;if(!ha)break d;ga=c[425648+((da(ha&0-ha,125613361)|0)>>>27<<2)>>2]|ia;ha=ha+-1&ha;Ca=c[ya>>2]&2147483647;if(!ha){Da=ja;break}if((ga|0)==-1)break d}while(1){Da=Da+1|0;if(Da>>>0>=Ca>>>0){Ea=0;break}ha=c[(c[xa>>2]|0)+(Da<<2)>>2]|0;if(ha){Ea=ha;break}}if((ga|0)==-1)break;else{ja=Da;E=Ea;H=ga}}}}while(0);if(!(ea(Cda(q7(a)|0,24))>ea(0.0))|j|h^1){i=e;return}U=ea(Cda(q7(a)|0,24));G=ea(U*ea(g[(q7(a)|0)+1416>>2]));a=DKa(d,-65536)|0;g[x>>2]=ea(1.0);h=x+4|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[x+20>>2]=ea(1.0);h=x+24|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[x+40>>2]=ea(1.0);h=x+44|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[x+60>>2]=ea(1.0);EKa(a,x)|0;x=c[f+12>>2]|0;f=x+4|0;a=c[f>>2]&2147483647;if(!a){i=e;return}h=c[x>>2]|0;j=0;while(1){Fa=c[h+(j<<2)>>2]|0;if(Fa)break;Ea=j+1|0;if(Ea>>>0<a>>>0)j=Ea;else{Ga=60;break}}if((Ga|0)==60){i=e;return}Ea=c[425648+((da(Fa&0-Fa,125613361)|0)>>>27<<2)>>2]|j<<5;Da=Fa+-1&Fa;f:do if(!Da){Fa=j;while(1){Ca=Fa+1|0;if(Ca>>>0>=a>>>0){Ha=Ca;Ia=0;break f}w=c[h+(Ca<<2)>>2]|0;if(!w)Fa=Ca;else{Ha=Ca;Ia=w;break}}}else{Ha=j;Ia=Da}while(0);if((Ea|0)==-1){i=e;return}Da=y+4|0;j=y+8|0;h=y+12|0;a=y+16|0;Fa=y+20|0;w=y+24|0;Ca=Ha;Ha=Ia;Ia=Ea;g:while(1){Ea=Ca<<5;v=Ha;u=Ia;while(1){t=c[A>>2]|0;s=da(c[B>>2]|0,u)|0;r=t+s|0;Ba=c[C>>2]|0;Aa=da(c[D>>2]|0,u)|0;U=ea(z*ea(g[Ba+Aa>>2]));ua=ea(z*ea(g[Ba+(Aa+4)>>2]));wa=ea(z*ea(g[Ba+(Aa+8)>>2]));g[y>>2]=ea(g[r>>2]);Aa=t+(s+4)|0;g[Da>>2]=ea(g[Aa>>2]);Ba=t+(s+8)|0;g[j>>2]=ea(g[Ba>>2]);va=ea(U+ea(g[r>>2]));U=ea(ua+ea(g[Aa>>2]));ua=ea(wa+ea(g[Ba>>2]));g[h>>2]=va;g[a>>2]=U;g[Fa>>2]=ua;g[w>>2]=G;IKa(d,y)|0;if(!v){Ga=60;break g}u=c[425648+((da(v&0-v,125613361)|0)>>>27<<2)>>2]|Ea;v=v+-1&v;Ja=c[f>>2]&2147483647;if(!v){Ka=Ca;break}if((u|0)==-1){Ga=60;break g}}while(1){Ka=Ka+1|0;if(Ka>>>0>=Ja>>>0){La=0;break}v=c[(c[x>>2]|0)+(Ka<<2)>>2]|0;if(v){La=v;break}}if((u|0)==-1){Ga=60;break}else{Ca=Ka;Ha=La;Ia=u}}if((Ga|0)==60){i=e;return}}function gia(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im;e=i;i=i+64|0;f=e+32|0;h=e;j=ea(Aha(c[b+52>>2]|0));k=b+360|0;if(!(c[k>>2]|0)){i=e;return}l=b+356|0;b=f+12|0;m=f+4|0;n=f+16|0;o=f+8|0;p=f+20|0;q=ea(ea(1.0)/j);r=h+4|0;s=h+8|0;t=h+12|0;u=h+16|0;v=h+20|0;w=h+24|0;x=0;do{y=c[(c[(c[l>>2]|0)+(x<<2)>>2]|0)+44>>2]|0;In[c[(c[y>>2]|0)+8>>2]&4095](f,y);z=ea(g[f>>2]);A=ea(z+ea(g[b>>2]));z=ea(g[m>>2]);B=ea(z+ea(g[n>>2]));z=ea(g[o>>2]);C=ea(ea(A*ea(.5))*q);A=ea(ea(B*ea(.5))*q);B=ea(q*ea(ea(z+ea(g[p>>2]))*ea(.5)));g[f>>2]=ea(j*ea(R(ea(C))));g[f+4>>2]=ea(j*ea(R(ea(A))));g[f+8>>2]=ea(j*ea(R(ea(B))));g[b>>2]=ea(j*ea(ca(ea(C))));g[b+4>>2]=ea(j*ea(ca(ea(A))));g[b+8>>2]=ea(j*ea(ca(ea(B))));y=DKa(d,-16776961)|0;g[h>>2]=ea(g[f>>2]);g[r>>2]=ea(g[m>>2]);g[s>>2]=ea(g[o>>2]);g[t>>2]=ea(g[b>>2]);g[u>>2]=ea(g[n>>2]);g[v>>2]=ea(g[p>>2]);a[w>>0]=1;HKa(y,h)|0;x=x+1|0}while(x>>>0<(c[k>>2]|0)>>>0);i=e;return}function hia(a,d){a=a|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=e;if(!(b[(c[a+52>>2]|0)+8>>1]&1)){i=e;return}g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(1.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);FKa(d,f)|0;iia(a,d);i=e;return}function iia(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=0,N=0,O=0;e=i;i=i+192|0;f=e+136|0;h=e+186|0;j=e+184|0;k=e+96|0;l=e+32|0;m=e;n=f+16|0;c[n>>2]=0;o=f+20|0;c[o>>2]=12;c[f+24>>2]=0;c[f+28>>2]=12;c[f+32>>2]=0;c[f+36>>2]=4;c[f+40>>2]=0;c[f+44>>2]=4;p=a+56|0;q=c[p>>2]|0;r=mo[c[c[q>>2]>>2]&4095](q)|0;Dn[c[(c[r>>2]|0)+20>>2]&511](r,f,0,0);if(!(c[f+4>>2]|0)){i=e;return}r=a+52|0;pha(h,c[r>>2]|0);q=b[h>>1]&1;pha(j,c[r>>2]|0);r=b[j>>1]&16;if(!(ea(Cda(q7(a)|0,25))>ea(0.0))|q<<16>>16==0|r<<16>>16==0){i=e;return}c[k>>2]=0;c[k+4>>2]=4;r=k+8|0;c[r>>2]=0;q=k+12|0;c[q>>2]=12;c[k+16>>2]=0;c[k+20>>2]=12;c[k+24>>2]=0;c[k+28>>2]=12;c[k+32>>2]=0;c[k+36>>2]=4;j=c[p>>2]|0;co[c[(c[j>>2]|0)+4>>2]&2047](j,k,0);s=ea(Cda(q7(a)|0,25));t=ea(s*ea(g[(q7(a)|0)+1416>>2]));a=DKa(d,-16711936)|0;g[l>>2]=ea(1.0);k=l+4|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[l+20>>2]=ea(1.0);k=l+24|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[l+40>>2]=ea(1.0);k=l+44|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[l+60>>2]=ea(1.0);EKa(a,l)|0;if(!(c[r>>2]|0)){i=e;return}l=c[f+12>>2]|0;f=l+4|0;a=c[f>>2]&2147483647;if(!a){i=e;return}k=c[l>>2]|0;j=0;while(1){u=c[k+(j<<2)>>2]|0;if(u)break;p=j+1|0;if(p>>>0<a>>>0)j=p;else{v=24;break}}if((v|0)==24){i=e;return}p=c[425648+((da(u&0-u,125613361)|0)>>>27<<2)>>2]|j<<5;h=u+-1&u;a:do if(!h){u=j;while(1){w=u+1|0;if(w>>>0>=a>>>0){x=w;y=0;break a}z=c[k+(w<<2)>>2]|0;if(!z)u=w;else{x=w;y=z;break}}}else{x=j;y=h}while(0);if((p|0)==-1){i=e;return}s=ea(t*ea(.100000001));h=m+4|0;j=m+8|0;k=m+12|0;a=m+16|0;u=m+20|0;z=m+24|0;w=x;x=y;y=p;b:while(1){p=w<<5;A=x;B=y;while(1){C=c[r>>2]|0;D=da(c[q>>2]|0,B)|0;E=ea(g[C+D>>2]);F=C+(D+4)|0;if(!((E==ea(0.0)?ea(g[F>>2])==ea(0.0):0)?ea(g[C+(D+8)>>2])==ea(0.0):0)){G=c[n>>2]|0;H=da(c[o>>2]|0,B)|0;I=G+H|0;J=ea(t*E);E=ea(t*ea(g[F>>2]));K=ea(t*ea(g[C+(D+8)>>2]));g[m>>2]=ea(g[I>>2]);D=G+(H+4)|0;g[h>>2]=ea(g[D>>2]);C=G+(H+8)|0;g[j>>2]=ea(g[C>>2]);L=ea(J+ea(g[I>>2]));J=ea(E+ea(g[D>>2]));E=ea(K+ea(g[C>>2]));g[k>>2]=L;g[a>>2]=J;g[u>>2]=E;g[z>>2]=s;IKa(d,m)|0}if(!A){v=24;break b}B=c[425648+((da(A&0-A,125613361)|0)>>>27<<2)>>2]|p;A=A+-1&A;M=c[f>>2]&2147483647;if(!A){N=w;break}if((B|0)==-1){v=24;break b}}while(1){N=N+1|0;if(N>>>0>=M>>>0){O=0;break}A=c[(c[l>>2]|0)+(N<<2)>>2]|0;if(A){O=A;break}}if((B|0)==-1){v=24;break}else{w=N;x=O;y=B}}if((v|0)==24){i=e;return}}function jia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+48|0;f=e+36|0;g=e+24|0;h=e+20|0;j=e+8|0;k=e;l=b+4|0;m=c[l>>2]|0;c[h>>2]=0;c[g>>2]=0;c[g+4>>2]=0;n=g+8|0;c[n>>2]=0;HZa(g,m,h);h=c[l>>2]|0;m=k;c[m>>2]=0;c[m+4>>2]=0;c[j>>2]=0;c[j+4>>2]=0;m=j+8|0;c[m>>2]=0;IZa(j,h,k);if(!(c[l>>2]|0))o=0;else{k=0;do{h=c[(c[b>>2]|0)+(k<<2)>>2]|0;p=c[j>>2]|0;q=h+360|0;r=c[q>>2]|0;if(r){s=UJa(f,r<<2,475336,850)|0;r=c[q>>2]|0;if(!r){t=0;u=s}else{q=h+356|0;h=0;do{c[s+(h<<2)>>2]=c[(c[(c[q>>2]|0)+(h<<2)>>2]|0)+44>>2];h=h+1|0}while((h|0)!=(r|0));t=r;u=s}}else{t=0;u=0}c[p+(k<<3)>>2]=u;c[p+(k<<3)+4>>2]=t;c[(c[g>>2]|0)+(k<<2)>>2]=c[(c[(c[b>>2]|0)+(k<<2)>>2]|0)+56>>2];k=k+1|0;s=c[l>>2]|0}while(k>>>0<s>>>0);o=s}k=Kva((c[a+1e3>>2]|0)+324|0,c[g>>2]|0,c[j>>2]|0,o,d)|0;d=c[m>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1)tKa(j,c[j>>2]|0);j=c[n>>2]|0;if(!((j&2147483647|0)!=0&(j|0)>-1)){i=e;return k|0}tKa(g,c[g>>2]|0);i=e;return k|0}function kia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+4|0;j=c[h>>2]|0;c[g>>2]=0;c[f>>2]=0;c[f+4>>2]=0;k=f+8|0;c[k>>2]=0;HZa(f,j,g);g=c[h>>2]|0;if(!g)l=0;else{h=0;do{c[(c[f>>2]|0)+(h<<2)>>2]=c[(c[(c[b>>2]|0)+(h<<2)>>2]|0)+56>>2];h=h+1|0}while(h>>>0<g>>>0);l=g}g=Lva((c[a+1e3>>2]|0)+324|0,c[f>>2]|0,l,d)|0;d=c[k>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=e;return g|0}tKa(f,c[f>>2]|0);i=e;return g|0}function lia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+4|0;j=e;k=b+4|0;l=c[k>>2]|0;c[g>>2]=0;c[f>>2]=0;c[f+4>>2]=0;m=f+8|0;c[m>>2]=0;HZa(f,l,g);g=c[k>>2]|0;c[j>>2]=0;c[h>>2]=0;l=h+4|0;c[l>>2]=0;n=h+8|0;c[n>>2]=0;JZa(h,g,j);j=c[k>>2]|0;if(j){k=0;do{c[(c[h>>2]|0)+(k<<2)>>2]=(c[(c[b>>2]|0)+(k<<2)>>2]|0)+372;c[(c[f>>2]|0)+(k<<2)>>2]=c[(c[(c[b>>2]|0)+(k<<2)>>2]|0)+56>>2];k=k+1|0}while(k>>>0<j>>>0)}j=Mva((c[a+1e3>>2]|0)+324|0,c[f>>2]|0,c[h>>2]|0,c[l>>2]|0,d)|0;d=c[n>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1)tKa(h,c[h>>2]|0);h=c[m>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=e;return j|0}tKa(f,c[f>>2]|0);i=e;return j|0}function mia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+4|0;j=c[h>>2]|0;c[g>>2]=0;c[f>>2]=0;c[f+4>>2]=0;k=f+8|0;c[k>>2]=0;HZa(f,j,g);g=c[h>>2]|0;if(!g)l=0;else{h=0;do{c[(c[f>>2]|0)+(h<<2)>>2]=c[(c[(c[b>>2]|0)+(h<<2)>>2]|0)+56>>2];h=h+1|0}while(h>>>0<g>>>0);l=g}g=Nva((c[a+1e3>>2]|0)+324|0,c[f>>2]|0,l,d)|0;d=c[k>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=e;return g|0}tKa(f,c[f>>2]|0);i=e;return g|0}function nia(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e+4|0;g=e;h=d+360|0;j=c[h>>2]|0;k=d+368|0;l=(j<<3)+8|0;m=UJa(e+8|0,l+(c[k>>2]<<4)|0,475336,868)|0;n=c[k>>2]|0;c[m>>2]=j;c[m+4>>2]=(n<<4)+l;if(!(c[h>>2]|0)){o=d+56|0;p=c[o>>2]|0;q=c[p>>2]|0;r=q+52|0;s=c[r>>2]|0;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];In[s&4095](p,f);i=e;return}l=d+356|0;n=d+36|0;j=m+8|0;k=0;while(1){t=c[(c[l>>2]|0)+(k<<2)>>2]|0;c[j>>2]=c[t+44>>2];u=j+4|0;v=j+8|0;c[u>>2]=0;w=c[t+36>>2]|0;x=b[t+42>>1]|0;t=w+((x&65535)<<2)|0;if(!(x<<16>>16))y=v;else{x=w;w=v;while(1){v=c[x>>2]|0;if((a[(c[v+40>>2]|0)+19>>0]|0)==0?(z=c[v+36>>2]|0,v=z+28|0,(a[(c[v>>2]|0)+64>>0]&4)==0):0){A=Xfa(z)|0;B=(c[(Vfa(z)|0)+52>>2]|0)+16|0;if(A)C=wqa((c[(c[n>>2]|0)+1e3>>2]|0)+1448|0,B)|0;else C=0;z=c[v>>2]|0;v=a[z+64>>0]|0;c[w>>2]=B;c[w+4>>2]=z+32;c[w+8>>2]=C;a[w+12>>0]=(v&255)>>>4&1;a[w+13>>0]=A&1;c[u>>2]=(c[u>>2]|0)+1;D=w+16|0}else D=w;x=x+4|0;if(x>>>0>=t>>>0){y=D;break}else w=D}}k=k+1|0;if(k>>>0>=(c[h>>2]|0)>>>0)break;else j=y}o=d+56|0;p=c[o>>2]|0;q=c[p>>2]|0;r=q+52|0;s=c[r>>2]|0;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];In[s&4095](p,f);i=e;return}function oia(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0;c[d>>2]=475864;h=d+20|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+36>>2]=e;c[d+40>>2]=-1;b[d+44>>1]=0;b[d+46>>1]=0;b[d+48>>1]=0;a[d+50>>0]=f;a[d+51>>0]=g;return}function pia(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;c[a>>2]=475864;c[a+28>>2]=0;d=a+20|0;e=a+24|0;f=c[d>>2]|0;if(!((f|0)==0|(f|0)==(a+4|0)))Xia(c[a+36>>2]|0,f,c[e>>2]|0);c[e>>2]=0;c[d>>2]=0;VJa(b,a);i=b;return}function qia(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=475864;c[a+28>>2]=0;d=a+20|0;e=a+24|0;f=c[d>>2]|0;if((f|0)==0|(f|0)==(a+4|0)){c[e>>2]=0;c[d>>2]=0;i=b;return}Xia(c[a+36>>2]|0,f,c[e>>2]|0);c[e>>2]=0;c[d>>2]=0;i=b;return}function ria(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+51|0;g=a[f>>0]|0;if(!(g&1))h=g;else{Lia(c[b+36>>2]|0,b);h=a[f>>0]|0}g=(h&241|d)&255;a[f>>0]=g;if(!(g&1)){i=e;return}Kia(c[b+36>>2]|0,b);i=e;return}function sia(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[a+28>>2]|0;g=a+44|0;h=b[g>>1]|0;j=h&65535;if(!(h<<16>>16))k=j;else{h=a+20|0;l=a+36|0;m=0;n=j;j=0;while(1){o=c[(c[h>>2]|0)+(m<<2)>>2]|0;if(!(Qia(c[l>>2]|0,o)|0)?_n[c[(c[o>>2]|0)+16>>2]&4095](o,d)|0:0)Ria(c[l>>2]|0,o);o=j+1<<16>>16;p=b[g>>1]|0;q=p&65535;if((o&65535)<(p&65535)){m=o&65535;n=q;j=o}else{k=q;break}}}if(k>>>0>=f>>>0){i=e;return}j=a+20|0;n=a+36|0;a=k;do{k=a;a=a+1|0;m=c[(c[j>>2]|0)+(k<<2)>>2]|0;if(!(Qia(c[n>>2]|0,m)|0)?_n[c[(c[m>>2]|0)+16>>2]&4095](m,d)|0:0)Ria(c[n>>2]|0,m)}while((a|0)!=(f|0));i=e;return}function tia(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;g=c[d+28>>2]|0;h=d+44|0;j=b[h>>1]|0;k=j&65535;a:do if(!(j<<16>>16))l=k;else{m=d+20|0;n=d+36|0;o=0;p=k;q=1;while(1){r=c[(c[m>>2]|0)+(o<<2)>>2]|0;s=c[r+4>>2]|0;if((s|0)==(d|0))t=c[r+8>>2]|0;else t=s;if(((a[t+51>>0]&1)==0?Qia(c[n>>2]|0,r)|0:0)?_n[c[(c[r>>2]|0)+20>>2]&4095](r,e)|0:0)Sia(c[n>>2]|0,r);r=b[h>>1]|0;s=r&65535;if((q&65535)>=(r&65535)){l=s;break a}o=q&65535;p=s;q=q+1<<16>>16}}while(0);if(l>>>0>=g>>>0){i=f;return}h=d+20|0;t=d+36|0;d=l;do{l=d;d=d+1|0;k=c[(c[h>>2]|0)+(l<<2)>>2]|0;if(Qia(c[t>>2]|0,k)|0?_n[c[(c[k>>2]|0)+20>>2]&4095](k,e)|0:0)Sia(c[t>>2]|0,k)}while((d|0)!=(g|0));i=f;return}function uia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=(e&1|0)!=0;h=a[b+51>>0]|0;if(!g?!((h&1)!=0^d):0){i=f;return}j=b+51|0;k=h&255;if(d){a[j>>0]=k|1;ko[c[(c[b>>2]|0)+8>>2]&4095](b);sia(b,e);if(g){i=f;return}Kia(c[b+36>>2]|0,b);i=f;return}else{a[j>>0]=k&254;tia(b,e);ko[c[(c[b>>2]|0)+12>>2]&4095](b);if(g){i=f;return}Lia(c[b+36>>2]|0,b);i=f;return}}function via(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g+4|0;j=g;c[h>>2]=f;k=a[f+20>>0]|0;l=f+4|0;m=a[(c[l>>2]|0)+50>>0]|0;if(m<<24>>24==1|m<<24>>24==4){m=a[(c[f+8>>2]|0)+50>>0]|0;n=m<<24>>24!=4&m<<24>>24!=1|k<<24>>24==2|k<<24>>24==3}else n=1;m=d+20|0;o=c[d+28>>2]|0;if(o>>>0>65534){i=g;return}do if(n){KZa(m,h,d);p=c[h>>2]|0;q=o&65535;if((c[p+4>>2]|0)==(d|0)){b[p+16>>1]=q;break}else{b[p+18>>1]=q;break}}else{q=d+44|0;p=e[q>>1]|0;do if((o|0)==(p|0)){KZa(m,h,d);r=c[h>>2]|0;s=o&65535;if((c[r+4>>2]|0)==(d|0)){b[r+16>>1]=s;break}else{b[r+18>>1]=s;break}}else{c[j>>2]=c[(c[m>>2]|0)+(p<<2)>>2];KZa(m,j,d);s=c[j>>2]|0;r=o&65535;if((c[s+4>>2]|0)==(d|0))b[s+16>>1]=r;else b[s+18>>1]=r;r=b[q>>1]|0;c[(c[m>>2]|0)+((r&65535)<<2)>>2]=f;if((c[l>>2]|0)==(d|0)){b[f+16>>1]=r;break}else{b[f+18>>1]=r;break}}while(0);b[q>>1]=(b[q>>1]|0)+1<<16>>16}while(0);if((k&255)>=2){i=g;return}k=d+48|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16;i=g;return}function wia(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=b[((c[e+4>>2]|0)==(a|0)?e+16|0:e+18|0)>>1]|0;h=g&65535;if(g<<16>>16==-1){i=f;return}j=a+44|0;k=b[j>>1]|0;do if((g&65535)<(k&65535)){l=k+-1<<16>>16;b[j>>1]=l;m=a+20|0;n=c[m>>2]|0;c[n+(h<<2)>>2]=c[n+((l&65535)<<2)>>2];l=c[m>>2]|0;n=c[l+(h<<2)>>2]|0;if((c[n+4>>2]|0)==(a|0))b[n+16>>1]=g;else b[n+18>>1]=g;n=b[j>>1]|0;o=n&65535;p=a+28|0;q=(c[p>>2]|0)+-1|0;c[p>>2]=q;c[l+(o<<2)>>2]=c[l+(q<<2)>>2];if(o>>>0<q>>>0){q=c[(c[m>>2]|0)+(o<<2)>>2]|0;if((c[q+4>>2]|0)==(a|0)){b[q+16>>1]=n;break}else{b[q+18>>1]=n;break}}}else{n=a+28|0;q=(c[n>>2]|0)+-1|0;c[n>>2]=q;n=a+20|0;o=c[n>>2]|0;c[o+(h<<2)>>2]=c[o+(q<<2)>>2];if(h>>>0<q>>>0){q=c[(c[n>>2]|0)+(h<<2)>>2]|0;if((c[q+4>>2]|0)==(a|0)){b[q+16>>1]=g;break}else{b[q+18>>1]=g;break}}}while(0);if((d[e+20>>0]|0)>=2){i=f;return}e=a+48|0;b[e>>1]=(b[e>>1]|0)+-1<<16>>16;i=f;return}function xia(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+4>>2]=c[d>>2];c[d>>2]=b;return}function yia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;a=c[e>>2]|0;if(!a){i=d;return}else{f=a;g=0}while(1){if((f|0)==(b|0))break;a=c[f+4>>2]|0;if(!a){h=7;break}else{j=f;f=a;g=j}}if((h|0)==7){i=d;return}h=c[b+4>>2]|0;if(!g){c[e>>2]=h;i=d;return}else{c[g+4>>2]=h;i=d;return}}function zia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do if(f)if(f>>>0<5){h=4;j=a+4|0;break}else{k=f+-1|0;l=k>>>1|k;k=l>>>2|l;l=k>>>4|k;k=l>>>8|l;l=(k>>>16|k)+1|0;h=l;j=Wia(c[a+36>>2]|0,l)|0;break}else{h=0;j=0}while(0);f=c[b>>2]|0;if((f|0)!=0?(YEi(j|0,f|0,e<<2|0)|0,e=c[b>>2]|0,(e|0)!=(a+4|0)):0)Xia(c[a+36>>2]|0,e,c[d>>2]|0);c[d>>2]=h;c[b>>2]=j;i=g;return}function Aia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b>>2]|0;f=c[b+4>>2]|0;if(e>>>0>=f>>>0){g=0;i=d;return g|0}h=b+8|0;j=e;while(1){k=c[j>>2]|0;if(a[k+21>>0]&9){e=c[h>>2]|0;if((c[k+24>>2]|0)==(e|0))break;if((c[k+28>>2]|0)==(e|0))break}e=j+4|0;c[b>>2]=e;if(e>>>0<f>>>0)j=e;else{g=0;l=8;break}}if((l|0)==8){i=d;return g|0}c[b>>2]=j+4;g=k;i=d;return g|0}function Bia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b>>2]|0;f=b+4|0;g=c[f>>2]|0;if(e>>>0>=g>>>0){h=0;i=d;return h|0}j=b+8|0;b=g;while(1){b=b+-4|0;k=c[b>>2]|0;if(a[k+21>>0]&9){g=c[j>>2]|0;if((c[k+24>>2]|0)==(g|0))break;if((c[k+28>>2]|0)==(g|0))break}c[f>>2]=b;if(e>>>0>=b>>>0){h=0;l=8;break}}if((l|0)==8){i=d;return h|0}c[f>>2]=b;h=k;i=d;return h|0}function Cia(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=475888;yia(c[a+8>>2]|0,a);VJa(b,a);i=b;return}function Dia(a){a=a|0;var b=0;b=i;c[a>>2]=475888;yia(c[a+8>>2]|0,a);i=b;return}function Eia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g+8|0;mpa(h,c[(c[(c[(c[a+8>>2]|0)+36>>2]|0)+1e3>>2]|0)+8>>2]|0,e,c[f+4>>2]|0,b,a,d);d=c[h>>2]|0;b=a+12|0;a=b;f=c[h+4>>2]&1073741823|c[a+4>>2]&-1073741824;h=b;c[h>>2]=c[a>>2]&-1073741824|d&1073741823;c[h+4>>2]=f;if((d|0)!=1073741823){j=1;i=g;return j|0}dKa(bKa()|0,32,475896,112,475992,g);j=0;i=g;return j|0}function Fia(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+12|0;e=c[d>>2]|0;if((e&1073741823|0)==1073741823&0==0){f=0;i=b;return f|0}g=spa(c[(c[(c[(c[a+8>>2]|0)+36>>2]|0)+1e3>>2]|0)+8>>2]|0,e&1073741823)|0;e=d;a=c[e+4>>2]|1073741823;h=d;c[h>>2]=c[e>>2]|1073741823;c[h+4>>2]=a;f=g;i=b;return f|0}function Gia(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[b>>2]=476080;c[b+4>>2]=d;c[b+8>>2]=e;e=b+12|0;c[e>>2]=-1;c[e+4>>2]=-1;a[b+20>>0]=f;a[b+21>>0]=g;return}function Hia(b,d){b=b|0;d=d|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+52>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;c[b+64>>2]=0;c[b+68>>2]=0;c[b+72>>2]=0;c[b+76>>2]=0;c[b+80>>2]=0;c[b+84>>2]=0;c[b+380>>2]=0;a[b+372>>0]=1;c[b+376>>2]=b+116;c[b+384>>2]=64;c[b+388>>2]=32;c[b+392>>2]=0;c[b+396>>2]=0;c[b+400>>2]=1024;c[b+404>>2]=0;c[b+676>>2]=0;a[b+668>>0]=1;c[b+672>>2]=b+412;c[b+680>>2]=64;c[b+684>>2]=32;c[b+688>>2]=0;c[b+692>>2]=0;c[b+696>>2]=2048;c[b+700>>2]=0;c[b+972>>2]=0;a[b+964>>0]=1;c[b+968>>2]=b+708;c[b+976>>2]=64;c[b+980>>2]=32;c[b+984>>2]=0;c[b+988>>2]=0;c[b+992>>2]=4096;c[b+996>>2]=0;c[b+1e3>>2]=0;c[b+1004>>2]=0;c[b+1008>>2]=d;d=b+88|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;return}function Iia(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=c[a+1e3>>2]|0;if(d){Esa(d);VJa(b,d)}LZa(a+704|0);MZa(a+408|0);NZa(a+112|0);d=c[a+84>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+76>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+72>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+64>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+60>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+52>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+48>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+40>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+36>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+28>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+24>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+16>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+8>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function Jia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;j=a+88|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;j=a+1e3|0;a=c[j>>2]|0;if(a){Esa(a);VJa(h,a);c[j>>2]=0}a=mKa()|0;k=c[(c[a>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](a,7424,m?476928:544544,476104,77)|0;Dsa(l,b,d,e,f,64);c[j>>2]=l;if(l){n=1;i=g;return n|0}dKa(bKa()|0,4,476104,81,476216,h);n=0;i=g;return n|0}function Kia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+12|0;k=b+4|0;l=c[k>>2]|0;if((a[d+51>>0]&14)==4){c[d+40>>2]=l;c[f>>2]=d;m=c[k>>2]|0;if((c[b+8>>2]&2147483647)>>>0<=m>>>0){OZa(b,f)|0;i=e;return}f=(c[b>>2]|0)+(m<<2)|0;if(f)c[f>>2]=d;c[k>>2]=m+1;i=e;return}m=c[j>>2]|0;do if((l|0)==(m|0)){c[d+40>>2]=l;c[h>>2]=d;f=c[k>>2]|0;if((c[b+8>>2]&2147483647)>>>0<=f>>>0){OZa(b,h)|0;break}n=(c[b>>2]|0)+(f<<2)|0;if(n)c[n>>2]=d;c[k>>2]=f+1}else{f=c[b>>2]|0;n=c[f+(m<<2)>>2]|0;c[g>>2]=n;c[d+40>>2]=m;c[f+(c[j>>2]<<2)>>2]=d;c[n+40>>2]=c[k>>2];f=c[k>>2]|0;if((c[b+8>>2]&2147483647)>>>0<=f>>>0){OZa(b,g)|0;break}o=(c[b>>2]|0)+(f<<2)|0;if(o)c[o>>2]=n;c[k>>2]=f+1}while(0);c[j>>2]=(c[j>>2]|0)+1;i=e;return}function Lia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=d+40|0;g=c[f>>2]|0;c[f>>2]=-2;f=b+12|0;h=b+4|0;j=c[h>>2]|0;if((a[d+51>>0]&14)==4){d=j+-1|0;c[h>>2]=d;k=c[b>>2]|0;c[k+(g<<2)>>2]=c[k+(d<<2)>>2];if(g>>>0>=d>>>0){i=e;return}c[(c[(c[b>>2]|0)+(g<<2)>>2]|0)+40>>2]=g;i=e;return}d=c[f>>2]|0;if((j|0)==(d|0)){k=j+-1|0;c[h>>2]=k;l=c[b>>2]|0;c[l+(g<<2)>>2]=c[l+(k<<2)>>2];if(g>>>0<k>>>0)c[(c[(c[b>>2]|0)+(g<<2)>>2]|0)+40>>2]=g}else{k=d+-1|0;if(g>>>0<k>>>0){d=c[b>>2]|0;l=c[d+(k<<2)>>2]|0;c[l+40>>2]=g;c[d+(g<<2)>>2]=l;m=c[h>>2]|0}else m=j;j=m+-1|0;c[h>>2]=j;h=c[b>>2]|0;c[h+(k<<2)>>2]=c[h+(j<<2)>>2];c[(c[(c[b>>2]|0)+(k<<2)>>2]|0)+40>>2]=k}c[f>>2]=(c[f>>2]|0)+-1;i=e;return}function Mia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;uia(b,d,1);if(d){Kia(a,b);i=e;return}else{c[b+40>>2]=-2;i=e;return}}function Nia(b,d){b=b|0;d=d|0;var e=0;e=i;if(a[d+51>>0]&1)Lia(b,d);c[d+40>>2]=-1;i=e;return}function Oia(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;c[g>>2]=b;h=d[b+20>>0]|0;j=a+(h*12|0)+16|0;k=a+(h*12|0)+20|0;c[b+12>>2]=c[k>>2];l=a+(h*12|0)+24|0;m=c[l>>2]|0;if(!(m&2147483647)){PZa(j,64);n=c[l>>2]|0}else n=m;m=c[k>>2]|0;if((n&2147483647)>>>0>m>>>0){n=(c[j>>2]|0)+(m<<2)|0;if(n)c[n>>2]=b;c[k>>2]=m+1}else QZa(j,g)|0;if(!e){i=f;return}e=c[(c[g>>2]|0)+12>>2]|0;g=a+(h<<2)+88|0;j=c[g>>2]|0;if(e>>>0>j>>>0){m=a+(h*12|0)+16|0;h=c[m>>2]|0;a=h+(e<<2)|0;k=c[a>>2]|0;b=c[h+(j<<2)>>2]|0;c[a>>2]=b;c[(c[m>>2]|0)+(j<<2)>>2]=k;c[k+12>>2]=j;c[b+12>>2]=e;o=c[g>>2]|0}else o=j;c[g>>2]=o+1;i=f;return}function Pia(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d[b+20>>0]|0;g=b+12|0;b=c[g>>2]|0;h=a+(f*12|0)+20|0;j=(c[h>>2]|0)+-1|0;c[h>>2]=j;k=a+(f*12|0)+16|0;l=c[k>>2]|0;c[l+(b<<2)>>2]=c[l+(j<<2)>>2];c[g>>2]=-1;if(b>>>0<(c[h>>2]|0)>>>0)c[(c[(c[k>>2]|0)+(b<<2)>>2]|0)+12>>2]=b;g=a+(f<<2)+88|0;f=c[g>>2]|0;if(b>>>0>=f>>>0){i=e;return}a=f+-1|0;c[g>>2]=a;if(a>>>0>=(c[h>>2]|0)>>>0){i=e;return}h=c[k>>2]|0;g=h+(b<<2)|0;f=c[g>>2]|0;j=c[h+(a<<2)>>2]|0;c[g>>2]=j;c[(c[k>>2]|0)+(a<<2)>>2]=f;c[f+12>>2]=a;c[j+12>>2]=b;i=e;return}function Qia(a,b){a=a|0;b=b|0;return (c[b+12>>2]|0)>>>0<(c[a+((d[b+20>>0]|0)<<2)+88>>2]|0)>>>0|0}function Ria(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d[b+20>>0]|0;g=a+(f<<2)+88|0;h=c[g>>2]|0;if(h>>>0>=(c[a+(f*12|0)+20>>2]|0)>>>0){j=h;k=j+1|0;c[g>>2]=k;i=e;return}l=c[b+12>>2]|0;b=a+(f*12|0)+16|0;f=c[b>>2]|0;a=f+(h<<2)|0;m=c[a>>2]|0;n=c[f+(l<<2)>>2]|0;c[a>>2]=n;c[(c[b>>2]|0)+(l<<2)>>2]=m;c[m+12>>2]=l;c[n+12>>2]=h;j=c[g>>2]|0;k=j+1|0;c[g>>2]=k;i=e;return}function Sia(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d[b+20>>0]|0;g=a+(f<<2)+88|0;h=c[g>>2]|0;if(h>>>0<=1){j=h;k=j+-1|0;c[g>>2]=k;i=e;return}l=h+-1|0;h=c[b+12>>2]|0;b=a+(f*12|0)+16|0;f=c[b>>2]|0;a=f+(l<<2)|0;m=c[a>>2]|0;n=c[f+(h<<2)>>2]|0;c[a>>2]=n;c[(c[b>>2]|0)+(h<<2)>>2]=m;c[m+12>>2]=h;c[n+12>>2]=l;j=c[g>>2]|0;k=j+-1|0;c[g>>2]=k;i=e;return}function Tia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=b>>>0>64?b:64;if((c[a+8>>2]&2147483647)>>>0<h>>>0)RZa(a,h);h=c[a+1e3>>2]|0;if(!h){i=g;return}Fsa(h,b,d,e,f);i=g;return}function Uia(a){a=a|0;var b=0;b=i;RZa(a,c[a+4>>2]|0);PZa(a+16|0,c[a+20>>2]|0);PZa(a+28|0,c[a+32>>2]|0);PZa(a+40|0,c[a+44>>2]|0);PZa(a+52|0,c[a+56>>2]|0);PZa(a+64|0,c[a+68>>2]|0);PZa(a+76|0,c[a+80>>2]|0);i=b;return}function Via(a){a=a|0;return (c[a+1e3>>2]|0)+6176|0}function Wia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;if((b|0)==8){f=a+404|0;g=c[f>>2]|0;if(!g){SZa(a+112|0);h=c[f>>2]|0}else h=g;c[f>>2]=c[h>>2];f=a+392|0;c[f>>2]=(c[f>>2]|0)+1;f=a+396|0;c[f>>2]=(c[f>>2]|0)+-1;j=h;i=d;return j|0}else if((b|0)==32){h=a+996|0;f=c[h>>2]|0;if(!f){UZa(a+704|0);k=c[h>>2]|0}else k=f;c[h>>2]=c[k>>2];h=a+984|0;c[h>>2]=(c[h>>2]|0)+1;h=a+988|0;c[h>>2]=(c[h>>2]|0)+-1;j=k;i=d;return j|0}else if((b|0)==16){k=a+700|0;h=c[k>>2]|0;if(!h){TZa(a+408|0);l=c[k>>2]|0}else l=h;c[k>>2]=c[l>>2];k=a+688|0;c[k>>2]=(c[k>>2]|0)+1;k=a+692|0;c[k>>2]=(c[k>>2]|0)+-1;j=l;i=d;return j|0}else{j=UJa(e,b<<2,476104,333)|0;i=d;return j|0}return 0}function Xia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;if((d|0)==16){if(!b){i=e;return}g=a+688|0;c[g>>2]=(c[g>>2]|0)+-1;g=a+700|0;c[b>>2]=c[g>>2];c[g>>2]=b;g=a+692|0;h=c[g>>2]|0;c[g>>2]=h+1;if((h|0)<((c[a+684>>2]|0)*50|0)){i=e;return}WZa(a+408|0);c[g>>2]=0;i=e;return}else if((d|0)==8){if(!b){i=e;return}g=a+392|0;c[g>>2]=(c[g>>2]|0)+-1;g=a+404|0;c[b>>2]=c[g>>2];c[g>>2]=b;g=a+396|0;h=c[g>>2]|0;c[g>>2]=h+1;if((h|0)<((c[a+388>>2]|0)*50|0)){i=e;return}VZa(a+112|0);c[g>>2]=0;i=e;return}else if((d|0)==32){if(!b){i=e;return}d=a+984|0;c[d>>2]=(c[d>>2]|0)+-1;d=a+996|0;c[b>>2]=c[d>>2];c[d>>2]=b;d=a+988|0;g=c[d>>2]|0;c[d>>2]=g+1;if((g|0)<((c[a+980>>2]|0)*50|0)){i=e;return}XZa(a+704|0);c[d>>2]=0;i=e;return}else{VJa(f,b);i=e;return}}function Yia(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!(a[(c[b+1008>>2]|0)+1162>>0]|0)){if(!d){i=e;return}f=b+1e3|0;NAa((c[f>>2]|0)+44|0);NAa((c[f>>2]|0)+44|0);i=e;return}else{if(d){i=e;return}NAa((c[b+1e3>>2]|0)+44|0);i=e;return}}function Zia(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+112|0;f=e;g=e+48|0;h=e+96|0;j=e+98|0;k=e+80|0;l=e+64|0;m=e+100|0;n=e+16|0;o=e+32|0;p=q7(c[a+4>>2]|0)|0;q=c[p+1100>>2]|0;b[h>>1]=0;r=a+44|0;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];s=d+44|0;c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];c[l+12>>2]=c[s+12>>2];t=c[p+1092>>2]|0;u=c[p+1096>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];Nn[q&31](j,5,g,5,f,h,t,u);u=b[j>>1]|0;if(!(u&4))v=u;else{u=d;t=u+~(u<<15)|0;u=(t>>>10^t)*9|0;t=u>>>6^u;u=t+~(t<<11)|0;t=a;q=t+~(t<<15)|0;t=(q>>>10^q)*9|0;q=t>>>6^t;t=q+~(q<<11)|0;q=c[p+1104>>2]|0;p=c[c[q>>2]>>2]|0;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];r=G4(a)|0;c[o+0>>2]=c[s+0>>2];c[o+4>>2]=c[s+4>>2];c[o+8>>2]=c[s+8>>2];c[o+12>>2]=c[s+12>>2];s=G4(d)|0;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];An[p&3](m,q,u>>>16^u^(t^-57320555^t>>>16)*1000007,5,g,r,0,5,f,s,0,h);h=b[m>>1]|0;b[j>>1]=h;v=h}h=v&65535;if(!(h&1)){i=e;return (h&2|0)==0|0}else{i=e;return 0}return 0}function _ia(a){a=a|0;return c[a+4>>2]|0}function $ia(a,b){a=a|0;b=b|0;var d=0;d=b+44|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function aja(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0;j=i;d7(a,5,1,0,0,0);g[a+16>>2]=ea(0.0);g[a+20>>2]=ea(0.0);g[a+24>>2]=ea(0.0);c[a+32>>2]=e;c[a+36>>2]=0;e=a+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;b[a+60>>1]=b[h>>1]|0;h=a+64|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;bja(a,d,f);i=j;return}function bja(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im;f=i;i=i+64|0;h=f+40|0;j=f+16|0;k=f+8|0;l=f;m=a+32|0;n=dla(c[m>>2]|0)|0;o=UJa(f+48|0,n*20|0,477040,142)|0;p=a+40|0;c[p>>2]=o;if(!o){i=f;return}if(n){o=0;q=0;do{Vla(j,q);r=(c[p>>2]|0)+(o*20|0)|0;if(r){c[r+0>>2]=c[j+0>>2];c[r+4>>2]=c[j+4>>2];c[r+8>>2]=c[j+8>>2];c[r+12>>2]=c[j+12>>2];c[r+16>>2]=c[j+16>>2]}q=q+1<<16>>16;o=q&65535}while(o>>>0<n>>>0)}o=e+((cla(c[m>>2]|0)|0)<<4)|0;q=c[(c[116650]|0)+12>>2]|0;j=c[(c[q>>2]|0)+12>>2]|0;r=k;c[r>>2]=e;c[r+4>>2]=o;o=c[c[m>>2]>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];k=xo[j&2047](q,h,o)|0;o=a+28|0;c[o>>2]=k;if(!k){i=f;return}In[c[(c[k>>2]|0)+52>>2]&4095](k,d+16|0);k=c[o>>2]|0;In[c[(c[k>>2]|0)+56>>2]&4095](k,d);d=c[o>>2]|0;ko[c[(c[d>>2]|0)+68>>2]&4095](d);d=c[p>>2]|0;p=c[o>>2]|0;k=c[(c[p>>2]|0)+160>>2]|0;q=l;c[q>>2]=d;c[q+4>>2]=d+(n*20|0);c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];In[k&4095](p,h);h=c[o>>2]|0;In[c[(c[h>>2]|0)+212>>2]&4095](h,(b[a+60>>1]&2)!=0);h=c[o>>2]|0;In[c[(c[h>>2]|0)+400>>2]&4095](h,a);s=ea(g[116652]);if(s>ea(4294967.0)){a=c[o>>2]|0;In[c[(c[a>>2]|0)+368>>2]&4095](a,-1);i=f;return}a=~~ea(s*ea(1.0e3))>>>0;h=(a>>>0)/5|0;p=h>>>0<200?h:200;h=p>>>0>1?p:1;p=c[o>>2]|0;k=mo[c[(c[p>>2]|0)+388>>2]&4095](p)|0;p=c[o>>2]|0;In[c[(c[p>>2]|0)+368>>2]&4095](p,h);p=c[o>>2]|0;In[c[(c[p>>2]|0)+376>>2]&4095](p,(a>>>0)/(h>>>0)|0);if(!(k&s==ea(0.0))){i=f;return}k=c[o>>2]|0;ko[c[(c[k>>2]|0)+392>>2]&4095](k);i=f;return}function cja(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=c[a+40>>2]|0;if(e)VJa(d,e);e=a+28|0;f=c[e>>2]|0;g=mo[c[(c[f>>2]|0)+12>>2]&4095](f)|0;f=c[e>>2]|0;if(f)ko[c[(c[f>>2]|0)+4>>2]&4095](f);if((b[g+4>>1]|0)!=0|(g|0)==0){e7(a);i=d;return}ko[c[(c[g>>2]|0)+4>>2]&4095](g);e7(a);i=d;return}function dja(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+28|0;a=c[e>>2]|0;In[c[(c[a>>2]|0)+52>>2]&4095](a,b+16|0);a=c[e>>2]|0;In[c[(c[a>>2]|0)+56>>2]&4095](a,b);b=c[e>>2]|0;ko[c[(c[b>>2]|0)+68>>2]&4095](b);i=d;return}function eja(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;if(b>ea(4294967.0)){e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+368>>2]&4095](e,-1);i=d;return}e=~~ea(b*ea(1.0e3))>>>0;f=(e>>>0)/5|0;g=f>>>0<200?f:200;f=g>>>0>1?g:1;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+388>>2]&4095](a)|0;a=c[g>>2]|0;In[c[(c[a>>2]|0)+368>>2]&4095](a,f);a=c[g>>2]|0;In[c[(c[a>>2]|0)+376>>2]&4095](a,(e>>>0)/(f>>>0)|0);if(!(h&b==ea(0.0))){i=d;return}h=c[g>>2]|0;ko[c[(c[h>>2]|0)+392>>2]&4095](h);i=d;return}function fja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0;d=i;i=i+336|0;e=d+152|0;f=d+24|0;h=d+8|0;j=d+16|0;k=d;l=d+48|0;m=d+80|0;n=d+232|0;o=d+96|0;p=d+112|0;q=d+128|0;r=d+32|0;s=d+332|0;t=d+160|0;u=d+200|0;v=d+216|0;w=d+136|0;x=d+248|0;y=d+256|0;z=d+272|0;A=d+284|0;B=d+296|0;C=d+308|0;D=d+320|0;E=d+236|0;F=a+28|0;G=c[F>>2]|0;In[c[(c[G>>2]|0)+36>>2]&4095](l,G);G=c[F>>2]|0;H=mo[c[(c[G>>2]|0)+20>>2]&4095](G)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;YZa(b,H,m);m=c[l>>2]|0;YEi(c[b>>2]|0,m|0,(c[l+4>>2]|0)-m|0)|0;m=c[F>>2]|0;if(mo[c[(c[m>>2]|0)+236>>2]&4095](m)|0){m=b+12|0;H=c[F>>2]|0;G=(mo[c[(c[H>>2]|0)+236>>2]&4095](H)|0)<<2;c[n>>2]=0;xUa(m,G,n);n=b+24|0;G=c[F>>2]|0;H=mo[c[(c[G>>2]|0)+240>>2]&4095](G)|0;g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);KUa(n,H,o);o=c[m>>2]|0;m=c[F>>2]|0;H=o+((mo[c[(c[m>>2]|0)+236>>2]&4095](m)|0)<<4)|0;m=c[F>>2]|0;G=mo[c[(c[m>>2]|0)+16>>2]&4095](m)|0;m=c[(c[G>>2]|0)+44>>2]|0;I=c[F>>2]|0;J=h;c[J>>2]=o;c[J+4>>2]=H;H=j;c[H>>2]=0;c[H+4>>2]=0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];Dn[m&511](G,I,f,e);I=c[n>>2]|0;n=c[F>>2]|0;G=I+((mo[c[(c[n>>2]|0)+240>>2]&4095](n)|0)*12|0)|0;n=c[F>>2]|0;m=mo[c[(c[n>>2]|0)+16>>2]&4095](n)|0;n=c[(c[m>>2]|0)+44>>2]|0;H=c[F>>2]|0;J=h;c[J>>2]=0;c[J+4>>2]=0;J=j;c[J>>2]=I;c[J+4>>2]=G;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];Dn[n&511](m,H,f,e)}H=c[F>>2]|0;if(!(((mo[c[(c[H>>2]|0)+168>>2]&4095](H)|0)==0?(H=c[F>>2]|0,(mo[c[(c[H>>2]|0)+192>>2]&4095](H)|0)==0):0)?(H=c[F>>2]|0,(mo[c[(c[H>>2]|0)+204>>2]&4095](H)|0)==0):0)){H=b+36|0;m=c[F>>2]|0;ZZa(H,mo[c[(c[m>>2]|0)+168>>2]&4095](m)|0,p);p=b+48|0;m=c[F>>2]|0;n=(mo[c[(c[m>>2]|0)+176>>2]&4095](m)|0)<<1;c[q>>2]=0;xUa(p,n,q);q=b+60|0;n=c[F>>2]|0;_Za(q,mo[c[(c[n>>2]|0)+184>>2]&4095](n)|0,r);r=b+72|0;n=c[F>>2]|0;m=mo[c[(c[n>>2]|0)+192>>2]&4095](n)|0;c[s>>2]=0;xUa(r,m,s);s=b+84|0;m=c[F>>2]|0;$Za(s,mo[c[(c[m>>2]|0)+204>>2]&4095](m)|0,t);qja(a,c[H>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0)}s=c[F>>2]|0;if((mo[c[(c[s>>2]|0)+268>>2]&4095](s)|0)!=0?(s=b+96|0,r=c[F>>2]|0,q=mo[c[(c[r>>2]|0)+268>>2]&4095](r)|0,c[u+0>>2]=0,c[u+4>>2]=0,c[u+8>>2]=0,c[u+12>>2]=0,a_a(s,q,u),u=c[s>>2]|0,s=c[F>>2]|0,q=mo[c[(c[s>>2]|0)+268>>2]&4095](s)|0,(q|0)!=0):0){s=c[F>>2]|0;r=mo[c[(c[s>>2]|0)+16>>2]&4095](s)|0;s=c[(c[r>>2]|0)+32>>2]|0;p=c[F>>2]|0;H=k;c[H>>2]=u;c[H+4>>2]=u+(q<<4);c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];co[s&2047](r,p,e)}p=c[F>>2]|0;if((mo[c[(c[p>>2]|0)+300>>2]&4095](p)|0)!=0?(p=b+108|0,r=c[F>>2]|0,s=mo[c[(c[r>>2]|0)+300>>2]&4095](r)|0,c[v+0>>2]=0,c[v+4>>2]=0,c[v+8>>2]=0,c[v+12>>2]=0,b_a(p,s,v),v=c[p>>2]|0,p=c[F>>2]|0,s=mo[c[(c[p>>2]|0)+300>>2]&4095](p)|0,(s|0)!=0):0){p=c[F>>2]|0;r=mo[c[(c[p>>2]|0)+16>>2]&4095](p)|0;p=c[(c[r>>2]|0)+36>>2]|0;k=c[F>>2]|0;q=j;c[q>>2]=v;c[q+4>>2]=v+(s<<4);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];co[p&2047](r,k,e)}k=c[F>>2]|0;if((mo[c[(c[k>>2]|0)+316>>2]&4095](k)|0)!=0?(k=b+120|0,r=c[F>>2]|0,c_a(k,mo[c[(c[r>>2]|0)+316>>2]&4095](r)|0,w),w=c[k>>2]|0,k=c[F>>2]|0,r=mo[c[(c[k>>2]|0)+316>>2]&4095](k)|0,(r|0)!=0):0){k=c[F>>2]|0;p=mo[c[(c[k>>2]|0)+16>>2]&4095](k)|0;k=c[(c[p>>2]|0)+40>>2]|0;j=c[F>>2]|0;s=h;c[s>>2]=w;c[s+4>>2]=w+(r<<4);c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];co[k&2047](p,j,e)}j=c[F>>2]|0;if(mo[c[(c[j>>2]|0)+340>>2]&4095](j)|0){j=b+132|0;p=c[F>>2]|0;k=mo[c[(c[p>>2]|0)+340>>2]&4095](p)|0;c[x>>2]=0;xUa(j,k,x);x=c[j>>2]|0;j=c[F>>2]|0;k=mo[c[(c[j>>2]|0)+340>>2]&4095](j)|0;j=c[F>>2]|0;p=mo[c[(c[j>>2]|0)+16>>2]&4095](j)|0;j=c[(c[p>>2]|0)+48>>2]|0;h=c[F>>2]|0;c[f>>2]=x;c[f+4>>2]=x+(k<<2);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[j&2047](p,h,e)}h=c[F>>2]|0;if(mo[c[(c[h>>2]|0)+348>>2]&4095](h)|0){h=b+144|0;p=c[F>>2]|0;j=mo[c[(c[p>>2]|0)+348>>2]&4095](p)|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c_a(h,j,y);y=c[h>>2]|0;h=c[F>>2]|0;j=mo[c[(c[h>>2]|0)+348>>2]&4095](h)|0;h=c[F>>2]|0;p=mo[c[(c[h>>2]|0)+16>>2]&4095](h)|0;h=c[(c[p>>2]|0)+52>>2]|0;k=c[F>>2]|0;c[f>>2]=y;c[f+4>>2]=y+(j<<4);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[h&2047](p,k,e)}e=c[F>>2]|0;g[b+156>>2]=ea(Kn[c[(c[e>>2]|0)+248>>2]&255](e));e=c[F>>2]|0;g[b+160>>2]=ea(Kn[c[(c[e>>2]|0)+256>>2]&255](e));e=c[F>>2]|0;g[b+164>>2]=ea(Kn[c[(c[e>>2]|0)+276>>2]&255](e));e=c[F>>2]|0;g[b+168>>2]=ea(Kn[c[(c[e>>2]|0)+280>>2]&255](e));e=c[F>>2]|0;g[b+172>>2]=ea(Kn[c[(c[e>>2]|0)+288>>2]&255](e));K=ea(g[a+16>>2]);L=ea(g[a+20>>2]);M=ea(g[a+24>>2]);g[b+176>>2]=K;g[b+180>>2]=L;g[b+184>>2]=M;a=c[F>>2]|0;In[c[(c[a>>2]|0)+92>>2]&4095](z,a);g[b+188>>2]=ea(g[z>>2]);g[b+192>>2]=ea(g[z+4>>2]);g[b+196>>2]=ea(g[z+8>>2]);z=c[F>>2]|0;g[b+200>>2]=ea(Kn[c[(c[z>>2]|0)+228>>2]&255](z));z=c[F>>2]|0;g[b+204>>2]=ea(Kn[c[(c[z>>2]|0)+216>>2]&255](z));z=c[F>>2]|0;In[c[(c[z>>2]|0)+100>>2]&4095](A,z);g[b+208>>2]=ea(g[A>>2]);g[b+212>>2]=ea(g[A+4>>2]);g[b+216>>2]=ea(g[A+8>>2]);A=c[F>>2]|0;In[c[(c[A>>2]|0)+108>>2]&4095](B,A);g[b+220>>2]=ea(g[B>>2]);g[b+224>>2]=ea(g[B+4>>2]);g[b+228>>2]=ea(g[B+8>>2]);B=c[F>>2]|0;In[c[(c[B>>2]|0)+116>>2]&4095](C,B);g[b+232>>2]=ea(g[C>>2]);g[b+236>>2]=ea(g[C+4>>2]);g[b+240>>2]=ea(g[C+8>>2]);C=c[F>>2]|0;In[c[(c[C>>2]|0)+124>>2]&4095](D,C);g[b+244>>2]=ea(g[D>>2]);g[b+248>>2]=ea(g[D+4>>2]);g[b+252>>2]=ea(g[D+8>>2]);D=c[F>>2]|0;In[c[(c[D>>2]|0)+132>>2]&4095](E,D);g[b+256>>2]=ea(g[E>>2]);g[b+260>>2]=ea(g[E+4>>2]);g[b+264>>2]=ea(g[E+8>>2]);E=c[F>>2]|0;g[b+268>>2]=ea(Kn[c[(c[E>>2]|0)+140>>2]&255](E));E=c[F>>2]|0;g[b+272>>2]=ea(Kn[c[(c[E>>2]|0)+148>>2]&255](E));E=c[F>>2]|0;g[b+276>>2]=ea(Kn[c[(c[E>>2]|0)+324>>2]&255](E));E=c[F>>2]|0;g[b+280>>2]=ea(Kn[c[(c[E>>2]|0)+332>>2]&255](E));E=c[F>>2]|0;D=mo[c[(c[E>>2]|0)+60>>2]&4095](E)|0;E=c[F>>2]|0;C=mo[c[(c[E>>2]|0)+64>>2]&4095](E)|0;M=ea(g[C>>2]);L=ea(g[C+4>>2]);K=ea(g[C+8>>2]);N=ea(g[C+12>>2]);O=ea(g[D>>2]);P=ea(g[D+4>>2]);Q=ea(g[D+8>>2]);g[b+284>>2]=M;g[b+288>>2]=L;g[b+292>>2]=K;g[b+296>>2]=N;g[b+300>>2]=O;g[b+304>>2]=P;g[b+308>>2]=Q;D=c[F>>2]|0;g[b+312>>2]=ea(Kn[c[(c[D>>2]|0)+364>>2]&255](D));D=c[F>>2]|0;C=mo[c[(c[D>>2]|0)+372>>2]&4095](D)|0;if((C|0)!=-1){D=c[F>>2]|0;E=mo[c[(c[D>>2]|0)+380>>2]&4095](D)|0;D=c[F>>2]|0;F=mo[c[(c[D>>2]|0)+384>>2]&4095](D)|0;if(F>>>0<E>>>0)R=ea(ea((da(E-F|0,C)|0)>>>0)/ea(1.0e3));else R=ea(0.0)}else R=ea(3402823469999999843913219.0e14);g[b+316>>2]=R;b=c[l+20>>2]|0;C=c[l+24>>2]|0;F=(c[l+8>>2]|0)+(C>>1)|0;if(!(C&1)){S=b;ko[S&4095](F);i=d;return}else{S=c[(c[F>>2]|0)+b>>2]|0;ko[S&4095](F);i=d;return}}function gja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0;i=b;return a|0}function hja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+236>>2]&4095](d)|0;i=b;return a|0}function ija(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+240>>2]&4095](d)|0;i=b;return a|0}function jja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=a+28|0;a=c[j>>2]|0;k=b+((mo[c[(c[a>>2]|0)+236>>2]&4095](a)|0)<<4)|0;a=c[j>>2]|0;l=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[l>>2]|0)+44>>2]|0;m=c[j>>2]|0;j=g;c[j>>2]=b;c[j+4>>2]=k;k=h;c[k>>2]=0;c[k+4>>2]=0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];Dn[a&511](l,m,f,e);i=d;return}function kja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=a+28|0;a=c[j>>2]|0;k=b+((mo[c[(c[a>>2]|0)+240>>2]&4095](a)|0)*12|0)|0;a=c[j>>2]|0;l=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[l>>2]|0)+44>>2]|0;m=c[j>>2]|0;j=g;c[j>>2]=0;c[j+4>>2]=0;j=h;c[j>>2]=b;c[j+4>>2]=k;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];Dn[a&511](l,m,f,e);i=d;return}function lja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+168>>2]&4095](d)|0;i=b;return a|0}function mja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+192>>2]&4095](d)|0;i=b;return a|0}function nja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+204>>2]&4095](d)|0;i=b;return a|0}function oja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+176>>2]&4095](d)|0;i=b;return a|0}function pja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+184>>2]&4095](d)|0;i=b;return a|0}function qja(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+80|0;j=h+72|0;k=h+40|0;l=h+48|0;m=h+56|0;n=h+64|0;o=h+32|0;p=h+24|0;q=h;r=h+8|0;s=h+16|0;if(!b)t=0;else{u=c[a+28>>2]|0;t=mo[c[(c[u>>2]|0)+168>>2]&4095](u)|0}if(!d)v=0;else{u=c[a+28>>2]|0;v=(mo[c[(c[u>>2]|0)+176>>2]&4095](u)|0)<<1}if(!e)w=0;else{u=c[a+28>>2]|0;w=mo[c[(c[u>>2]|0)+184>>2]&4095](u)|0}if(!f)x=0;else{u=c[a+28>>2]|0;x=mo[c[(c[u>>2]|0)+192>>2]&4095](u)|0}u=a+28|0;if(!g)y=0;else{a=c[u>>2]|0;y=(mo[c[(c[a>>2]|0)+204>>2]&4095](a)|0)*3|0}a=c[u>>2]|0;z=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[z>>2]|0)+28>>2]|0;A=c[u>>2]|0;u=o;c[u>>2]=b;c[u+4>>2]=b+(t<<4);t=p;c[t>>2]=d;c[t+4>>2]=d+(v<<2);v=q;c[v>>2]=e;c[v+4>>2]=e+(w<<4);w=r;c[w>>2]=f;c[w+4>>2]=f+(x<<2);x=s;c[x>>2]=g;c[x+4>>2]=g+(y*12|0);c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];Wn[a&127](z,A,n,m,l,k,j);i=h;return}function rja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+268>>2]&4095](a)|0;if(!h){j=0;i=d;return j|0}a=c[g>>2]|0;k=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[k>>2]|0)+32>>2]|0;l=c[g>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=b+(h<<4);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[a&2047](k,l,e);j=1;i=d;return j|0}function sja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+300>>2]&4095](a)|0;if(!h){j=0;i=d;return j|0}a=c[g>>2]|0;k=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[k>>2]|0)+36>>2]|0;l=c[g>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=b+(h<<4);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[a&2047](k,l,e);j=1;i=d;return j|0}function tja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+316>>2]&4095](a)|0;if(!h){j=0;i=d;return j|0}a=c[g>>2]|0;k=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[k>>2]|0)+40>>2]|0;l=c[g>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=b+(h<<4);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[a&2047](k,l,e);j=1;i=d;return j|0}function uja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+340>>2]&4095](a)|0;a=c[g>>2]|0;j=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[j>>2]|0)+48>>2]|0;k=c[g>>2]|0;c[f>>2]=b;c[f+4>>2]=b+(h<<2);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[a&2047](j,k,e);i=d;return (h|0)!=0|0}function vja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+348>>2]&4095](a)|0;a=c[g>>2]|0;j=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=c[(c[j>>2]|0)+52>>2]|0;k=c[g>>2]|0;c[f>>2]=b;c[f+4>>2]=b+(h<<4);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];co[a&2047](j,k,e);i=d;return 1}function wja(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+16>>2]);g[a+4>>2]=ea(g[b+20>>2]);g[a+8>>2]=ea(g[b+24>>2]);return}function xja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+28|0;b=c[e>>2]|0;f=mo[c[(c[b>>2]|0)+60>>2]&4095](b)|0;b=c[e>>2]|0;e=mo[c[(c[b>>2]|0)+64>>2]&4095](b)|0;g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);g[a+12>>2]=ea(g[e+12>>2]);g[a+16>>2]=ea(g[f>>2]);g[a+20>>2]=ea(g[f+4>>2]);g[a+24>>2]=ea(g[f+8>>2]);i=d;return}function yja(a){a=a|0;var b=0,d=0,e=0,f=Im,g=0;b=i;d=a+28|0;a=c[d>>2]|0;e=mo[c[(c[a>>2]|0)+372>>2]&4095](a)|0;if((e|0)==-1){f=ea(3402823469999999843913219.0e14);i=b;return ea(f)}a=c[d>>2]|0;g=mo[c[(c[a>>2]|0)+380>>2]&4095](a)|0;a=c[d>>2]|0;d=mo[c[(c[a>>2]|0)+384>>2]&4095](a)|0;if(d>>>0>=g>>>0){f=ea(0.0);i=b;return ea(f)}f=ea(ea((da(g-d|0,e)|0)>>>0)/ea(1.0e3));i=b;return ea(f)}function zja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im;d=i;i=i+80|0;e=d+16|0;f=d+40|0;h=d;j=d+8|0;k=d+48|0;l=d+72|0;m=d+32|0;n=d+56|0;o=d+64|0;p=d+24|0;c[a+32>>2]=b;b=a+36|0;q=c[b>>2]|0;bja(a,q+284|0,c[q>>2]|0);q=a+28|0;r=c[q>>2]|0;s=c[(c[r>>2]|0)+164>>2]|0;t=c[b>>2]|0;u=c[t+36>>2]|0;v=u+(c[t+40>>2]<<4)|0;c[l>>2]=u;c[l+4>>2]=v;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];Dn[s&511](r,e,0,0);r=c[q>>2]|0;s=c[(c[r>>2]|0)+172>>2]|0;l=c[b>>2]|0;v=c[l+48>>2]|0;u=v+((c[l+52>>2]|0)>>>1<<2)|0;c[m>>2]=v;c[m+4>>2]=u;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];Dn[s&511](r,e,0,0);r=c[q>>2]|0;s=c[(c[r>>2]|0)+180>>2]|0;m=c[b>>2]|0;u=c[m+60>>2]|0;v=u+(c[m+64>>2]<<4)|0;c[n>>2]=u;c[n+4>>2]=v;c[e+0>>2]=c[n+0>>2];c[e+4>>2]=c[n+4>>2];Dn[s&511](r,e,0,0);r=c[q>>2]|0;s=c[(c[r>>2]|0)+188>>2]|0;n=c[b>>2]|0;v=c[n+72>>2]|0;u=v+(c[n+76>>2]<<2)|0;c[o>>2]=v;c[o+4>>2]=u;c[e+0>>2]=c[o+0>>2];c[e+4>>2]=c[o+4>>2];Dn[s&511](r,e,0,0);r=c[q>>2]|0;s=c[(c[r>>2]|0)+196>>2]|0;o=c[b>>2]|0;u=c[o+84>>2]|0;v=u+((c[o+88>>2]|0)*36|0)|0;c[p>>2]=u;c[p+4>>2]=v;c[e+0>>2]=c[p+0>>2];c[e+4>>2]=c[p+4>>2];Dn[s&511](r,e,0,0);r=c[b>>2]|0;s=c[r+16>>2]|0;if(!s)w=r;else{p=c[r+12>>2]|0;v=c[r+24>>2]|0;u=v+((c[r+28>>2]|0)*12|0)|0;r=c[q>>2]|0;o=c[(c[r>>2]|0)+232>>2]|0;n=h;c[n>>2]=p;c[n+4>>2]=p+(s>>>2<<4);s=j;c[s>>2]=v;c[s+4>>2]=u;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];co[o&2047](r,f,e);w=c[b>>2]|0}do if(c[w+100>>2]|0){r=c[w+96>>2]|0;o=c[q>>2]|0;if(!r){ko[c[(c[o>>2]|0)+264>>2]&4095](o);break}else{In[c[(c[o>>2]|0)+260>>2]&4095](f,o);o=c[f>>2]|0;YEi(o|0,r|0,(c[f+4>>2]|0)-o|0)|0;break}}while(0);f=c[b>>2]|0;do if(c[f+112>>2]|0){w=c[f+108>>2]|0;o=c[q>>2]|0;if(!w){ko[c[(c[o>>2]|0)+296>>2]&4095](o);break}else{In[c[(c[o>>2]|0)+292>>2]&4095](h,o);o=c[h>>2]|0;YEi(o|0,w|0,(c[h+4>>2]|0)-o|0)|0;break}}while(0);h=c[b>>2]|0;do if(c[h+124>>2]|0){f=c[h+120>>2]|0;o=c[q>>2]|0;if(!f){ko[c[(c[o>>2]|0)+312>>2]&4095](o);break}else{In[c[(c[o>>2]|0)+308>>2]&4095](j,o);o=c[j>>2]|0;YEi(o|0,f|0,(c[j+4>>2]|0)-o|0)|0;break}}while(0);j=c[b>>2]|0;h=c[j+136>>2]|0;if(!h)x=j;else{o=c[j+132>>2]|0;j=c[q>>2]|0;f=c[(c[j>>2]|0)+336>>2]|0;c[k>>2]=o;c[k+4>>2]=o+(h<<2);c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];In[f&4095](j,e);x=c[b>>2]|0}if(!(c[x+148>>2]|0))y=x;else{j=c[x+144>>2]|0;if(!j)z=0;else{x=c[q>>2]|0;z=mo[c[(c[x>>2]|0)+20>>2]&4095](x)|0}x=c[q>>2]|0;f=c[(c[x>>2]|0)+344>>2]|0;c[k>>2]=j;c[k+4>>2]=j+(z<<4);c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];In[f&4095](x,e);y=c[b>>2]|0}e=c[q>>2]|0;A=ea(g[y+156>>2]);Fn[c[(c[e>>2]|0)+244>>2]&255](e,A);e=c[q>>2]|0;A=ea(g[(c[b>>2]|0)+160>>2]);Fn[c[(c[e>>2]|0)+252>>2]&255](e,A);e=c[q>>2]|0;y=c[b>>2]|0;A=ea(g[y+164>>2]);B=ea(g[y+168>>2]);on[c[(c[e>>2]|0)+272>>2]&31](e,A,B);e=c[q>>2]|0;B=ea(g[(c[b>>2]|0)+172>>2]);Fn[c[(c[e>>2]|0)+284>>2]&255](e,B);e=c[b>>2]|0;B=ea(g[e+176>>2]);A=ea(g[e+180>>2]);C=ea(g[e+184>>2]);g[a+16>>2]=B;g[a+20>>2]=A;g[a+24>>2]=C;a=c[q>>2]|0;In[c[(c[a>>2]|0)+88>>2]&4095](a,e+188|0);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+200>>2]);Fn[c[(c[e>>2]|0)+224>>2]&255](e,C);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+204>>2]);Fn[c[(c[e>>2]|0)+220>>2]&255](e,C);e=c[q>>2]|0;In[c[(c[e>>2]|0)+96>>2]&4095](e,(c[b>>2]|0)+208|0);e=c[q>>2]|0;In[c[(c[e>>2]|0)+104>>2]&4095](e,(c[b>>2]|0)+220|0);e=c[q>>2]|0;In[c[(c[e>>2]|0)+112>>2]&4095](e,(c[b>>2]|0)+232|0);e=c[q>>2]|0;In[c[(c[e>>2]|0)+120>>2]&4095](e,(c[b>>2]|0)+244|0);e=c[q>>2]|0;In[c[(c[e>>2]|0)+128>>2]&4095](e,(c[b>>2]|0)+256|0);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+268>>2]);Fn[c[(c[e>>2]|0)+136>>2]&255](e,C);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+272>>2]);Fn[c[(c[e>>2]|0)+144>>2]&255](e,C);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+276>>2]);Fn[c[(c[e>>2]|0)+320>>2]&255](e,C);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+280>>2]);Fn[c[(c[e>>2]|0)+328>>2]&255](e,C);e=c[q>>2]|0;C=ea(g[(c[b>>2]|0)+312>>2]);Fn[c[(c[e>>2]|0)+360>>2]&255](e,C);C=ea(g[(c[b>>2]|0)+316>>2]);if(C>ea(4294967.0)){e=c[q>>2]|0;In[c[(c[e>>2]|0)+368>>2]&4095](e,-1);c[b>>2]=0;i=d;return}e=~~ea(C*ea(1.0e3))>>>0;a=(e>>>0)/5|0;y=a>>>0<200?a:200;a=y>>>0>1?y:1;y=c[q>>2]|0;x=mo[c[(c[y>>2]|0)+388>>2]&4095](y)|0;y=c[q>>2]|0;In[c[(c[y>>2]|0)+368>>2]&4095](y,a);y=c[q>>2]|0;In[c[(c[y>>2]|0)+376>>2]&4095](y,(e>>>0)/(a>>>0)|0);if(!(x&C==ea(0.0))){c[b>>2]=0;i=d;return}x=c[q>>2]|0;ko[c[(c[x>>2]|0)+392>>2]&4095](x);c[b>>2]=0;i=d;return}function Aja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+24|0;j=g+16|0;k=g+8|0;l=g;m=c[a+28>>2]|0;a=c[(c[m>>2]|0)+232>>2]|0;n=k;c[n>>2]=d;c[n+4>>2]=d+(b<<4);b=l;c[b>>2]=f;c[b+4>>2]=f+(e*12|0);c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];co[a&2047](m,j,h);i=g;return}function Bja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[a+28>>2]|0;if(!b){ko[c[(c[f>>2]|0)+264>>2]&4095](f);i=d;return}else{In[c[(c[f>>2]|0)+260>>2]&4095](e,f);f=c[e>>2]|0;YEi(f|0,b|0,(c[e+4>>2]|0)-f|0)|0;i=d;return}}function Cja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[a+28>>2]|0;if(!b){ko[c[(c[f>>2]|0)+296>>2]&4095](f);i=d;return}else{In[c[(c[f>>2]|0)+292>>2]&4095](e,f);f=c[e>>2]|0;YEi(f|0,b|0,(c[e+4>>2]|0)-f|0)|0;i=d;return}}function Dja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[a+28>>2]|0;if(!b){ko[c[(c[f>>2]|0)+312>>2]&4095](f);i=d;return}else{In[c[(c[f>>2]|0)+308>>2]&4095](e,f);f=c[e>>2]|0;YEi(f|0,b|0,(c[e+4>>2]|0)-f|0)|0;i=d;return}}function Eja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+28>>2]|0;a=c[(c[h>>2]|0)+336>>2]|0;c[g>>2]=b;c[g+4>>2]=b+(d<<2);c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[a&4095](h,f);i=e;return}function Fja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;if(!b)h=0;else{a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0}a=c[g>>2]|0;g=c[(c[a>>2]|0)+344>>2]|0;c[f>>2]=b;c[f+4>>2]=b+(h<<4);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];In[g&4095](a,e);i=d;return}function Gja(a,b){a=a|0;b=b|0;g[a+16>>2]=ea(g[b>>2]);g[a+20>>2]=ea(g[b+4>>2]);g[a+24>>2]=ea(g[b+8>>2]);return}function Hja(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;if(b>ea(4294967.0)){e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+368>>2]&4095](e,-1);i=d;return}e=~~ea(b*ea(1.0e3))>>>0;f=(e>>>0)/5|0;g=f>>>0<200?f:200;f=g>>>0>1?g:1;g=a+28|0;a=c[g>>2]|0;h=mo[c[(c[a>>2]|0)+388>>2]&4095](a)|0;a=c[g>>2]|0;In[c[(c[a>>2]|0)+368>>2]&4095](a,f);a=c[g>>2]|0;In[c[(c[a>>2]|0)+376>>2]&4095](a,(e>>>0)/(f>>>0)|0);if(!(h&b==ea(0.0))){i=d;return}h=c[g>>2]|0;ko[c[(c[h>>2]|0)+392>>2]&4095](h);i=d;return}function Ija(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)!=0?(f=c[a+8>>2]|0,!((c[a+4>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<4);f=c[a+12>>2]|0;if((f|0)!=0?(e=c[a+20>>2]|0,!((c[a+16>>2]|0)==0&(e&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<2);e=c[a+24>>2]|0;if((e|0)!=0?(f=c[a+32>>2]&2147483647,(f|c[a+28>>2]|0)!=0):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f*12|0);f=c[a+36>>2]|0;if((f|0)!=0?(e=c[a+44>>2]|0,!((c[a+40>>2]|0)==0&(e&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<4);e=c[a+48>>2]|0;if((e|0)!=0?(f=c[a+56>>2]|0,!((c[a+52>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<2);f=c[a+60>>2]|0;if((f|0)!=0?(e=c[a+68>>2]|0,!((c[a+64>>2]|0)==0&(e&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<4);e=c[a+72>>2]|0;if((e|0)!=0?(f=c[a+80>>2]|0,!((c[a+76>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<2);f=c[a+84>>2]|0;if((f|0)!=0?(e=c[a+92>>2]&2147483647,(e|c[a+88>>2]|0)!=0):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e*36|0);e=c[a+96>>2]|0;if((e|0)!=0?(f=c[a+104>>2]|0,!((c[a+100>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<4);f=c[a+108>>2]|0;if((f|0)!=0?(e=c[a+116>>2]|0,!((c[a+112>>2]|0)==0&(e&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<4);e=c[a+120>>2]|0;if((e|0)!=0?(f=c[a+128>>2]|0,!((c[a+124>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<4);f=c[a+144>>2]|0;if(!f){i=d;return}e=c[a+152>>2]|0;if((c[a+148>>2]|0)==0&(e&2147483647|0)==0){i=d;return}co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<4);i=d;return}function Jja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,320,h?477136:544544,477040,362)|0;PEi(g|0,0,156)|0;fja(a,g);co[c[(c[b>>2]|0)+8>>2]&2047](b,g,320);Ija(g,b);if(!g){i=d;return}d_a(g);VJa(d,g);i=d;return}function Kja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+64|0;f=e+28|0;g=e;if(b){h=c[a+28>>2]|0;In[c[(c[h>>2]|0)+32>>2]&4095](f,h);h=c[f>>2]|0;if((h|0)!=(b|0))YEi(h|0,b|0,(c[f+4>>2]|0)-h|0)|0;h=c[f+20>>2]|0;b=c[f+24>>2]|0;j=(c[f+8>>2]|0)+(b>>1)|0;if(!(b&1))k=h;else k=c[(c[j>>2]|0)+h>>2]|0;ko[k&4095](j)}if(!d){i=e;return}j=c[a+28>>2]|0;In[c[(c[j>>2]|0)+40>>2]&4095](g,j);j=c[g>>2]|0;if((j|0)!=(d|0))YEi(j|0,d|0,(c[g+4>>2]|0)-j|0)|0;j=c[g+20>>2]|0;d=c[g+24>>2]|0;a=(c[g+8>>2]|0)+(d>>1)|0;if(!(d&1))l=j;else l=c[(c[a>>2]|0)+j>>2]|0;ko[l&4095](a);i=e;return}function Lja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+268>>2]&4095](d)|0;i=b;return a|0}function Mja(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im;d=i;e=a+28|0;a=c[e>>2]|0;f=ea(g[b>>2]);h=ea(g[b+4>>2]);on[c[(c[a>>2]|0)+272>>2]&31](a,f,h);a=c[e>>2]|0;h=ea(g[b+8>>2]);Fn[c[(c[a>>2]|0)+284>>2]&255](a,h);i=d;return}function Nja(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=b+28|0;b=c[e>>2]|0;g[a>>2]=ea(Kn[c[(c[b>>2]|0)+276>>2]&255](b));b=c[e>>2]|0;g[a+4>>2]=ea(Kn[c[(c[b>>2]|0)+280>>2]&255](b));b=c[e>>2]|0;g[a+8>>2]=ea(Kn[c[(c[b>>2]|0)+288>>2]&255](b));i=d;return}function Oja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+300>>2]&4095](d)|0;i=b;return a|0}function Pja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;ko[c[(c[d>>2]|0)+304>>2]&4095](d);i=b;return}function Qja(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+316>>2]&4095](d)|0;i=b;return a|0}function Rja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+28>>2]|0;h=c[(c[g>>2]|0)+164>>2]|0;c[f>>2]=b;c[f+4>>2]=b+16;b=a+72|0;a=c[b>>2]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[h&511](g,e,a,a);c[b>>2]=(c[b>>2]|0)+1;i=d;return}function Sja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;h=c[g>>2]|0;j=mo[c[(c[h>>2]|0)+176>>2]&4095](h)|0;h=c[g>>2]|0;k=c[(c[h>>2]|0)+164>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[k&511](h,e,b,b+1|0);b=c[g>>2]|0;g=mo[c[(c[b>>2]|0)+176>>2]&4095](b)|0;b=a+76|0;c[b>>2]=g-j+(c[b>>2]|0);b=a+72|0;c[b>>2]=(c[b>>2]|0)+-1;i=d;return}function Tja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e;h=a+28|0;j=c[h>>2]|0;k=mo[c[(c[j>>2]|0)+176>>2]&4095](j)|0;j=c[h>>2]|0;l=c[(c[j>>2]|0)+164>>2]|0;c[g>>2]=b;c[g+4>>2]=b+(d<<4);b=a+72|0;m=c[b>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Dn[l&511](j,f,0,m);m=c[h>>2]|0;h=mo[c[(c[m>>2]|0)+176>>2]&4095](m)|0;m=a+76|0;c[m>>2]=h-k+(c[m>>2]|0);c[b>>2]=d;i=e;return}function Uja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;c[g>>2]=b;c[g+4>>2]=d;d=c[a+28>>2]|0;b=c[(c[d>>2]|0)+172>>2]|0;c[h>>2]=g;c[h+4>>2]=g+8;g=a+76|0;a=c[g>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];Dn[b&511](d,f,a,a);c[g>>2]=(c[g>>2]|0)+1;i=e;return}function Vja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+28>>2]|0;h=c[(c[g>>2]|0)+172>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[h&511](g,e,b,b+1|0);b=a+76|0;c[b>>2]=(c[b>>2]|0)+-1;i=d;return}function Wja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+28>>2]|0;h=c[(c[g>>2]|0)+196>>2]|0;c[f>>2]=b;c[f+4>>2]=b+36;b=a+88|0;a=c[b>>2]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[h&511](g,e,a,a);c[b>>2]=(c[b>>2]|0)+1;i=d;return}function Xja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+28>>2]|0;h=c[(c[g>>2]|0)+196>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[h&511](g,e,b,b+1|0);b=a+88|0;c[b>>2]=(c[b>>2]|0)+-1;i=d;return}
function Yja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+28>>2]|0;j=c[(c[h>>2]|0)+196>>2]|0;c[g>>2]=b;c[g+4>>2]=b+(d*36|0);b=a+88|0;a=c[b>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Dn[j&511](h,f,0,a);c[b>>2]=d;i=e;return}function Zja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+28>>2]|0;h=c[(c[g>>2]|0)+180>>2]|0;c[f>>2]=b;c[f+4>>2]=b+16;b=a+80|0;a=c[b>>2]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[h&511](g,e,a,a);c[b>>2]=(c[b>>2]|0)+1;i=d;return}function _ja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;h=c[g>>2]|0;j=mo[c[(c[h>>2]|0)+192>>2]&4095](h)|0;h=c[g>>2]|0;k=c[(c[h>>2]|0)+180>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[k&511](h,e,b,b+1|0);b=c[g>>2]|0;g=mo[c[(c[b>>2]|0)+192>>2]&4095](b)|0;b=a+84|0;c[b>>2]=g-j+(c[b>>2]|0);b=a+80|0;c[b>>2]=(c[b>>2]|0)+-1;i=d;return}function $ja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e;h=a+28|0;j=c[h>>2]|0;k=mo[c[(c[j>>2]|0)+192>>2]&4095](j)|0;j=c[h>>2]|0;l=c[(c[j>>2]|0)+180>>2]|0;c[g>>2]=b;c[g+4>>2]=b+(d<<4);b=a+80|0;m=c[b>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Dn[l&511](j,f,0,m);m=c[h>>2]|0;h=mo[c[(c[m>>2]|0)+192>>2]&4095](m)|0;m=a+84|0;c[m>>2]=h-k+(c[m>>2]|0);c[b>>2]=d;i=e;return}function aka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d;c[f>>2]=b;b=c[a+28>>2]|0;h=c[(c[b>>2]|0)+188>>2]|0;c[g>>2]=f;c[g+4>>2]=f+4;f=a+84|0;a=c[f>>2]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];Dn[h&511](b,e,a,a);c[f>>2]=(c[f>>2]|0)+1;i=d;return}function bka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+28>>2]|0;h=c[(c[g>>2]|0)+188>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[h&511](g,e,b,b+1|0);b=a+84|0;c[b>>2]=(c[b>>2]|0)+-1;i=d;return}function cka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+28>>2]|0;In[c[(c[e>>2]|0)+116>>2]&4095](a,e);i=d;return}function dka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+112>>2]&4095](e,b);i=d;return}function eka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+28>>2]|0;In[c[(c[e>>2]|0)+124>>2]&4095](a,e);i=d;return}function fka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+120>>2]&4095](e,b);i=d;return}function gka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+28>>2]|0;In[c[(c[e>>2]|0)+132>>2]&4095](a,e);i=d;return}function hka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+128>>2]&4095](e,b);i=d;return}function ika(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+28|0;a=c[e>>2]|0;In[c[(c[a>>2]|0)+52>>2]&4095](a,b+16|0);a=c[e>>2]|0;In[c[(c[a>>2]|0)+56>>2]&4095](a,b);i=d;return}function jka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+88>>2]&4095](e,b);i=d;return}function kka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+28>>2]|0;In[c[(c[e>>2]|0)+92>>2]&4095](a,e);i=d;return}function lka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+224>>2]&255](e,b);i=d;return}function mka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+228>>2]&255](d));i=b;return ea(e)}function nka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+96>>2]&4095](e,b);i=d;return}function oka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+28>>2]|0;In[c[(c[e>>2]|0)+100>>2]&4095](a,e);i=d;return}function pka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+28>>2]|0;In[c[(c[e>>2]|0)+104>>2]&4095](e,b);i=d;return}function qka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+28>>2]|0;In[c[(c[e>>2]|0)+108>>2]&4095](a,e);i=d;return}function rka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+220>>2]&255](e,b);i=d;return}function ska(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+216>>2]&255](d));i=b;return ea(e)}function tka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+320>>2]&255](e,b);i=d;return}function uka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+324>>2]&255](d));i=b;return ea(e)}function vka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+328>>2]&255](e,b);i=d;return}function wka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+332>>2]&255](d));i=b;return ea(e)}function xka(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+340>>2]&4095](d)|0;i=b;return a|0}function yka(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+348>>2]&4095](d)|0;i=b;return a|0}function zka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+136>>2]&255](e,b);i=d;return}function Aka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+140>>2]&255](d));i=b;return ea(e)}function Bka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+144>>2]&255](e,b);i=d;return}function Cka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+148>>2]&255](d));i=b;return ea(e)}function Dka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0;e=i;i=i+48|0;f=e+32|0;h=e+8|0;j=e;Vla(h,-1);g[h+4>>2]=ea(g[d>>2]);k=d+4|0;g[h+8>>2]=ea(g[k>>2]);l=d+12|0;g[h+16>>2]=ea(g[l>>2]);m=d+8|0;g[h+12>>2]=ea(g[m>>2]);h=a+32|0;n=dla(c[h>>2]|0)|0;if(!n)o=a+40|0;else{p=c[(c[h>>2]|0)+8>>2]|0;h=a+40|0;q=0;do{if((c[p+(q<<2)>>2]|0)==(b|0)){r=ea(g[d>>2]);s=c[h>>2]|0;g[s+(q*20|0)+4>>2]=r;g[s+(q*20|0)+8>>2]=ea(g[k>>2]);g[s+(q*20|0)+12>>2]=ea(g[m>>2]);g[s+(q*20|0)+16>>2]=ea(g[l>>2])}q=q+1|0}while((q|0)!=(n|0));o=h}h=c[o>>2]|0;o=c[a+28>>2]|0;a=c[(c[o>>2]|0)+160>>2]|0;q=j;c[q>>2]=h;c[q+4>>2]=h+(n*20|0);c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];In[a&4095](o,f);i=e;return}function Eka(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im;d=i;e=a+28|0;a=c[e>>2]|0;f=ea(g[b+4>>2]);Fn[c[(c[a>>2]|0)+244>>2]&255](a,f);a=c[e>>2]|0;f=ea(g[b>>2]);Fn[c[(c[a>>2]|0)+252>>2]&255](a,f);i=d;return}function Fka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;e=i;i=i+32|0;f=e;Vla(f,-1);h=b+32|0;j=dla(c[h>>2]|0)|0;a:do if(j){k=c[(c[h>>2]|0)+8>>2]|0;l=0;while(1){m=l+1|0;if((c[k+(l<<2)>>2]|0)==(d|0))break;if(m>>>0<j>>>0)l=m;else break a}k=(c[b+40>>2]|0)+(l*20|0)|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2]}while(0);n=ea(g[f+4>>2]);o=ea(g[f+8>>2]);p=ea(g[f+12>>2]);q=ea(g[f+16>>2]);g[a>>2]=n;g[a+4>>2]=o;g[a+8>>2]=p;g[a+12>>2]=q;i=e;return}function Gka(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im;d=i;e=b+28|0;b=c[e>>2]|0;f=ea(Kn[c[(c[b>>2]|0)+256>>2]&255](b));b=c[e>>2]|0;h=ea(Kn[c[(c[b>>2]|0)+248>>2]&255](b));g[a>>2]=f;g[a+4>>2]=h;i=d;return}function Hka(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0;g=i;h=a+60|0;if(f)b[h>>1]=e[h>>1]|0|d;else b[h>>1]=b[h>>1]&((d^65535)&65535);if((d|0)==2){h=c[a+28>>2]|0;In[c[(c[h>>2]|0)+212>>2]&4095](h,f);i=g;return}else if((d|0)==1){h=a+4|0;if(!(c[h>>2]|0)){i=g;return}j=c[a+28>>2]|0;if(!((c[(mo[c[(c[j>>2]|0)+16>>2]&4095](j)|0)+4>>2]|0)!=0^f)){i=g;return}Bla(c[h>>2]|0);i=g;return}else if((d|0)==4){if(f){i=g;return}f=c[a+4>>2]|0;if(!f){i=g;return}Qla(f);i=g;return}else{i=g;return}}function Ika(a,c){a=a|0;c=c|0;b[a>>1]=b[c+60>>1]|0;return}function Jka(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;a=mo[c[(c[d>>2]|0)+388>>2]&4095](d)|0;i=b;return a|0}function Kka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+364>>2]&255](d));i=b;return ea(e)}function Lka(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a+28>>2]|0;Fn[c[(c[e>>2]|0)+360>>2]&255](e,b);i=d;return}function Mka(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;ko[c[(c[d>>2]|0)+392>>2]&4095](d);i=b;return}function Nka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+80|0;f=e+68|0;g=e+56|0;h=e+28|0;j=e;In[c[c[d>>2]>>2]&4095](f,d);k=b+28|0;b=c[k>>2]|0;if(a[f>>0]&4){In[c[(c[b>>2]|0)+48>>2]&4095](g,b);c[d+4>>2]=c[g>>2];c[d+8>>2]=c[g+4>>2];i=e;return}ko[c[(c[b>>2]|0)+24>>2]&4095](b);b=c[k>>2]|0;In[c[(c[b>>2]|0)+36>>2]&4095](h,b);c[d+4>>2]=c[h>>2];b=c[h+20>>2]|0;g=c[h+24>>2]|0;f=(c[h+8>>2]|0)+(g>>1)|0;if(!(g&1))l=b;else l=c[(c[f>>2]|0)+b>>2]|0;ko[l&4095](f);f=c[k>>2]|0;In[c[(c[f>>2]|0)+44>>2]&4095](j,f);c[d+8>>2]=c[j>>2];d=c[j+20>>2]|0;f=c[j+24>>2]|0;k=(c[j+8>>2]|0)+(f>>1)|0;if(!(f&1))m=d;else m=c[(c[k>>2]|0)+d>>2]|0;ko[m&4095](k);i=e;return}function Oka(a){a=a|0;var b=0,d=0;b=i;d=c[a+28>>2]|0;ko[c[(c[d>>2]|0)+28>>2]&4095](d);i=b;return}function Pka(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+76>>2]&255](d));i=b;return ea(e)}function Qka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;d=i;i=i+64|0;e=d+32|0;f=d;h=b+28|0;b=c[h>>2]|0;j=mo[c[(c[b>>2]|0)+352>>2]&4095](b)|0;b=c[h>>2]|0;k=mo[c[(c[b>>2]|0)+356>>2]&4095](b)|0;l=ea(g[j>>2]);m=ea(g[k>>2]);n=ea(l-m);o=ea(g[j+4>>2]);p=ea(g[k+4>>2]);q=ea(o-p);r=ea(g[j+8>>2]);s=ea(g[k+8>>2]);t=ea(r-s);u=ea(l+m);m=ea(o+p);p=ea(r+s);g[e>>2]=n;g[e+4>>2]=q;g[e+8>>2]=t;g[e+12>>2]=u;g[e+16>>2]=m;g[e+20>>2]=p;k=c[h>>2]|0;j=mo[c[(c[k>>2]|0)+60>>2]&4095](k)|0;k=c[h>>2]|0;h=mo[c[(c[k>>2]|0)+64>>2]&4095](k)|0;g[f>>2]=ea(g[h>>2]);g[f+4>>2]=ea(g[h+4>>2]);g[f+8>>2]=ea(g[h+8>>2]);g[f+12>>2]=ea(g[h+12>>2]);g[f+16>>2]=ea(g[j>>2]);g[f+20>>2]=ea(g[j+4>>2]);g[f+24>>2]=ea(g[j+8>>2]);e_a(a,f,e);i=d;return}function Rka(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function Ska(a,b){a=a|0;b=ea(b);g[a+64>>2]=b;return}function Tka(a){a=a|0;var b=Im;b=ea(g[a+64>>2]);return ea(b)}function Uka(a,b){a=a|0;b=ea(b);g[a+68>>2]=b;return}function Vka(a){a=a|0;var b=Im;b=ea(g[a+68>>2]);return ea(b)}function Wka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im;d=i;i=i+16|0;e=d;f=c[a+28>>2]|0;a=c[(c[f>>2]|0)+72>>2]|0;h=ea(-ea(g[b>>2]));j=ea(-ea(g[b+4>>2]));k=ea(-ea(g[b+8>>2]));g[e>>2]=h;g[e+4>>2]=j;g[e+8>>2]=k;In[a&4095](f,e);i=d;return}function Xka(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+28|0;g=c[f>>2]|0;h=mo[c[(c[g>>2]|0)+12>>2]&4095](g)|0;g=c[f>>2]|0;j=c[(mo[c[(c[g>>2]|0)+16>>2]&4095](g)|0)+4>>2]|0;g=c[f>>2]|0;if(g)ko[c[(c[g>>2]|0)+4>>2]&4095](g);c[f>>2]=d;if(!(b[h+4>>1]|0)){if(j)c[(c[a+32>>2]|0)+4>>2]=0;if(h)ko[c[(c[h>>2]|0)+4>>2]&4095](h)}if(!(c[(mo[c[(c[d>>2]|0)+16>>2]&4095](d)|0)+4>>2]|0)){i=e;return}h=c[a+32>>2]|0;c[h+4>>2]=mo[c[(c[d>>2]|0)+12>>2]&4095](d)|0;i=e;return}function Yka(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;return}function Zka(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;e=c[a>>2]|0;if((e|0)!=0?(f=e+4|0,g=(b[f>>1]|0)+-1<<16>>16,b[f>>1]=g,g<<16>>16==0):0)ko[c[(c[e>>2]|0)+4>>2]&4095](e);e=c[a+16>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=d;return}e=c[a+8>>2]|0;if(!e){i=d;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,e);i=d;return}function _ka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+4>>2]|0;if((e|0)!=0?(f=c[a+12>>2]|0,!((c[a+8>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<2);f=c[a+16>>2]|0;if((f|0)!=0?(e=c[a+24>>2]|0,!((c[a+20>>2]|0)==0&(e&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<2);e=c[a+28>>2]|0;if((e|0)!=0?(f=c[a+36>>2]|0,!((c[a+32>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<2);f=c[a+40>>2]|0;if((f|0)!=0?(e=c[a+48>>2]|0,!((c[a+44>>2]|0)==0&(e&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<2);e=c[a+52>>2]|0;if((e|0)!=0?(f=c[a+60>>2]|0,!((c[a+56>>2]|0)==0&(f&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f<<2);f=c[a+64>>2]|0;if(!f){i=d;return}e=c[a+72>>2]|0;if((c[a+68>>2]|0)==0&(e&2147483647|0)==0){i=d;return}co[c[(c[b>>2]|0)+8>>2]&2047](b,f,e<<2);i=d;return}function $ka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+128|0;e=d+16|0;f=d+48|0;h=d+88|0;j=d+104|0;k=d+64|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+116|0;p=d+8|0;q=d+56|0;r=d+24|0;s=d;t=d+32|0;u=d+72|0;v=d+40|0;w=c[a+8>>2]|0;if((w|0)!=0?(x=c[a+16>>2]|0,!((c[a+12>>2]|0)==0&(x&2147483647|0)==0)):0)co[c[(c[b>>2]|0)+8>>2]&2047](b,w,x<<2);if(!(c[a>>2]|0)){i=d;return}x=mKa()|0;w=c[(c[x>>2]|0)+8>>2]|0;y=pKa()|0;z=mo[c[(c[y>>2]|0)+24>>2]&4095](y)|0;y=Bn[w&255](x,76,z?478496:544544,478104,97)|0;z=y+4|0;x=z+0|0;w=x+72|0;do{c[x>>2]=0;x=x+4|0}while((x|0)<(w|0));x=c[(c[116650]|0)+12>>2]|0;w=c[a>>2]|0;c[y>>2]=mo[c[(c[w>>2]|0)+28>>2]&4095](w)|0;w=c[a>>2]|0;A=mo[c[(c[w>>2]|0)+12>>2]&4095](w)|0;c[m>>2]=0;xUa(z,A,m);m=y+16|0;A=c[a>>2]|0;w=mo[c[(c[A>>2]|0)+20>>2]&4095](A)|0;c[n>>2]=0;xUa(m,w,n);n=y+28|0;w=c[a>>2]|0;A=mo[c[(c[w>>2]|0)+16>>2]&4095](w)|0;g[o>>2]=ea(0.0);GUa(n,A,o);o=y+40|0;A=c[a>>2]|0;w=mo[c[(c[A>>2]|0)+24>>2]&4095](A)|0;c[p>>2]=0;xUa(o,w,p);p=y+52|0;w=c[a>>2]|0;A=mo[c[(c[w>>2]|0)+32>>2]&4095](w)|0;if((c[y+60>>2]&2147483647)>>>0<A>>>0)yUa(p,A);A=y+64|0;w=c[a>>2]|0;B=mo[c[(c[w>>2]|0)+32>>2]&4095](w)|0;if((c[y+72>>2]&2147483647)>>>0<B>>>0)HUa(A,B);B=c[(c[x>>2]|0)+24>>2]|0;w=c[a>>2]|0;a=c[z>>2]|0;z=a+(c[y+8>>2]<<2)|0;c[q>>2]=a;c[q+4>>2]=z;z=c[m>>2]|0;m=z+(c[y+20>>2]<<2)|0;c[r>>2]=z;c[r+4>>2]=m;m=c[n>>2]|0;n=m+(c[y+32>>2]<<2)|0;c[s>>2]=m;c[s+4>>2]=n;n=c[o>>2]|0;o=n+(c[y+44>>2]<<2)|0;c[t>>2]=n;c[t+4>>2]=o;o=c[p>>2]|0;p=o+(c[y+56>>2]<<2)|0;c[u>>2]=o;c[u+4>>2]=p;p=c[A>>2]|0;A=p+(c[y+68>>2]<<2)|0;c[v>>2]=p;c[v+4>>2]=A;c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[e+0>>2]=c[v+0>>2];c[e+4>>2]=c[v+4>>2];Nn[B&31](x,w,l,k,j,h,f,e);co[c[(c[b>>2]|0)+8>>2]&2047](b,y,76);_ka(y,b);if(!y){i=d;return}f_a(y);VJa(e,y);i=d;return}function ala(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+144|0;e=d;f=d+80|0;h=d+52|0;j=d+40|0;k=d+84|0;l=d+64|0;m=d+68|0;n=d+48|0;o=d+96|0;p=d+108|0;q=d+112|0;r=d+124|0;s=d+128|0;t=d+140|0;xo[c[c[b>>2]>>2]&2047](b,f,4)|0;if((c[f>>2]|0)!=50528512){dKa(bKa()|0,32,478104,165,478208,e);u=0;i=d;return u|0}f=e+0|0;v=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(v|0));xo[c[c[b>>2]>>2]&2047](b,e,4)|0;f=e+4|0;xo[c[c[b>>2]>>2]&2047](b,f,4)|0;v=e+12|0;xo[c[c[b>>2]>>2]&2047](b,v,4)|0;w=e+28|0;xo[c[c[b>>2]>>2]&2047](b,w,4)|0;x=c[f>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[h>>2]=0;c[h+4>>2]=0;y=h+8|0;c[y>>2]=0;wXa(h,x,j);j=c[h>>2]|0;xo[c[c[b>>2]>>2]&2047](b,j,c[f>>2]<<3)|0;c[e+8>>2]=j;j=c[v>>2]|0;c[l>>2]=0;c[k>>2]=0;f=k+4|0;c[f>>2]=0;x=k+8|0;c[x>>2]=0;xUa(k,j,l);l=c[k>>2]|0;xo[c[c[b>>2]>>2]&2047](b,l,c[v>>2]<<2)|0;c[e+16>>2]=l;v=c[l+((c[f>>2]|0)+-1<<2)>>2]|0;g[n>>2]=ea(0.0);c[m>>2]=0;c[m+4>>2]=0;f=m+8|0;c[f>>2]=0;GUa(m,v,n);n=c[m>>2]|0;xo[c[c[b>>2]>>2]&2047](b,n,v<<2)|0;c[e+24>>2]=n;c[p>>2]=0;c[o>>2]=0;c[o+4>>2]=0;m=o+8|0;c[m>>2]=0;xUa(o,v<<1,p);p=c[o>>2]|0;xo[c[c[b>>2]>>2]&2047](b,p,v<<3)|0;c[e+20>>2]=p;v=c[w>>2]|0;c[r>>2]=0;c[q>>2]=0;c[q+4>>2]=0;o=q+8|0;c[o>>2]=0;xUa(q,v,r);r=c[q>>2]|0;xo[c[c[b>>2]>>2]&2047](b,r,c[w>>2]<<2)|0;c[e+32>>2]=r;q=c[w>>2]|0;g[t>>2]=ea(0.0);c[s>>2]=0;c[s+4>>2]=0;v=s+8|0;c[v>>2]=0;GUa(s,q,t);t=c[s>>2]|0;xo[c[c[b>>2]>>2]&2047](b,t,c[w>>2]<<2)|0;c[e+36>>2]=t;w=bla(a,e)|0;e=c[v>>2]|0;if(!((e|0)<0|(e&2147483647|0)==0|(t|0)==0)){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,t)}t=c[o>>2]|0;if(!((t|0)<0|(t&2147483647|0)==0|(r|0)==0)){t=mKa()|0;In[c[(c[t>>2]|0)+12>>2]&4095](t,r)}r=c[m>>2]|0;if(!((r|0)<0|(r&2147483647|0)==0|(p|0)==0)){r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,p)}p=c[f>>2]|0;if(!((p|0)<0|(p&2147483647|0)==0|(n|0)==0)){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,n)}n=c[x>>2]|0;if(!((n|0)<0|(n&2147483647|0)==0|(l|0)==0)){n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,l)}l=c[y>>2]|0;if(!((l&2147483647|0)!=0&(l|0)>-1)){u=w;i=d;return u|0}l=c[h>>2]|0;if(!l){u=w;i=d;return u|0}h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,l);u=w;i=d;return u|0}function bla(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+144|0;f=e;g=e+56|0;h=e+8|0;j=e+32|0;k=e+72|0;l=e+40|0;m=e+48|0;n=e+16|0;o=e+64|0;p=e+80|0;q=e+92|0;r=e+96|0;s=e+104|0;t=e+112|0;u=e+120|0;v=e+128|0;w=e+136|0;x=a+8|0;y=d+4|0;z=c[y>>2]|0;c[m>>2]=0;g_a(x,z,m);m=c[y>>2]|0;c[o>>2]=0;c[n>>2]=0;z=n+4|0;c[z>>2]=0;A=n+8|0;c[A>>2]=0;xUa(n,m,o);o=c[y>>2]|0;c[q>>2]=0;c[p>>2]=0;c[p+4>>2]=0;m=p+8|0;c[m>>2]=0;xUa(p,o,q);a:do if(!(c[y>>2]|0)){B=c[n>>2]|0;C=7}else{q=c[d+8>>2]|0;o=c[n>>2]|0;D=0;while(1){E=c[q+(D<<3)>>2]|0;if((E|0)==0|(E|0)>4)break;c[(c[x>>2]|0)+(D<<2)>>2]=E;c[o+(D<<2)>>2]=c[q+(D<<3)+4>>2];D=D+1|0;if(D>>>0>=(c[y>>2]|0)>>>0){B=o;C=7;break a}}dKa(bKa()|0,4,478104,224,478288,f);F=0;G=o}while(0);if((C|0)==7){C=c[(c[116650]|0)+12>>2]|0;y=c[d+12>>2]|0;x=c[d+16>>2]|0;n=c[x+(y+-1<<2)>>2]|0;D=c[(c[C>>2]|0)+8>>2]|0;q=c[d>>2]|0;E=B+(c[z>>2]<<2)|0;c[r>>2]=B;c[r+4>>2]=E;c[s>>2]=x;c[s+4>>2]=x+(y<<2);y=c[d+24>>2]|0;c[t>>2]=y;c[t+4>>2]=y+(n<<2);y=c[d+20>>2]|0;c[u>>2]=y;c[u+4>>2]=y+(n<<1<<2);n=c[d+32>>2]|0;y=c[d+28>>2]|0;c[v>>2]=n;c[v+4>>2]=n+(y<<2);n=c[d+36>>2]|0;c[w>>2]=n;c[w+4>>2]=n+(y<<2);c[l+0>>2]=c[r+0>>2];c[l+4>>2]=c[r+4>>2];c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];w=Oo[D&63](C,q,l,k,j,h,g,f)|0;c[a>>2]=w;a=w+4|0;b[a>>1]=(b[a>>1]|0)+1<<16>>16;F=1;G=B}B=c[m>>2]|0;if((B&2147483647|0)!=0&(B|0)>-1?(B=c[p>>2]|0,(B|0)!=0):0){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,B)}B=c[A>>2]|0;if((B|0)<0|(B&2147483647|0)==0|(G|0)==0){i=e;return F|0}B=mKa()|0;In[c[(c[B>>2]|0)+12>>2]&4095](B,G);i=e;return F|0}function cla(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0;i=b;return a|0}function dla(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+12>>2]&4095](d)|0;i=b;return a|0}function ela(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0;i=b;return a|0}function fla(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+24>>2]&4095](d)|0;i=b;return a|0}function gla(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+16>>2]&4095](d)|0;i=b;return a|0}function hla(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;a=mo[c[(c[d>>2]|0)+32>>2]&4095](d)|0;i=b;return a|0}function ila(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+112|0;f=e+48|0;g=e+40|0;h=e+88|0;j=e+72|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+108|0;o=e+16|0;p=e+8|0;q=e+56|0;r=e+24|0;s=e;t=e+32|0;u=c[a>>2]|0;v=mo[c[(c[u>>2]|0)+12>>2]&4095](u)|0;if(v>>>0>d>>>0){w=0;i=e;return w|0}c[n>>2]=0;c[m>>2]=0;d=m+4|0;c[d>>2]=0;u=m+8|0;c[u>>2]=0;xUa(m,v,n);n=c[(c[116650]|0)+12>>2]|0;x=c[(c[n>>2]|0)+24>>2]|0;y=c[a>>2]|0;z=c[m>>2]|0;m=z+(c[d>>2]<<2)|0;c[o>>2]=z;c[o+4>>2]=m;c[p>>2]=0;c[p+4>>2]=0;c[q>>2]=0;c[q+4>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[s>>2]=0;c[s+4>>2]=0;c[t>>2]=0;c[t+4>>2]=0;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];Nn[x&31](n,y,l,k,j,h,g,f);if(v){f=c[a+8>>2]|0;a=0;do{c[b+(a<<3)+4>>2]=c[z+(a<<2)>>2];c[b+(a<<3)>>2]=c[f+(a<<2)>>2];a=a+1|0}while((a|0)!=(v|0))}a=c[u>>2]|0;if((a|0)<0|(a&2147483647|0)==0|(z|0)==0){w=v;i=e;return w|0}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,z);w=v;i=e;return w|0}function jla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+96|0;f=e+8|0;g=e+32|0;h=e+72|0;j=e;k=e+64|0;l=e+80|0;m=e+88|0;n=e+48|0;o=e+40|0;p=e+16|0;q=e+24|0;r=e+56|0;s=c[a>>2]|0;t=mo[c[(c[s>>2]|0)+16>>2]&4095](s)|0;if(t>>>0>d>>>0){u=0;i=e;return u|0}d=c[(c[116650]|0)+12>>2]|0;s=c[(c[d>>2]|0)+24>>2]|0;v=c[a>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[n>>2]=0;c[n+4>>2]=0;c[o>>2]=b;c[o+4>>2]=b+(t<<2);c[p>>2]=0;c[p+4>>2]=0;c[q>>2]=0;c[q+4>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];Nn[s&31](d,v,l,k,j,h,g,f);u=t;i=e;return u|0}function kla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+96|0;f=e+8|0;g=e+32|0;h=e+72|0;j=e;k=e+64|0;l=e+80|0;m=e+88|0;n=e+48|0;o=e+40|0;p=e+16|0;q=e+24|0;r=e+56|0;s=c[a>>2]|0;t=mo[c[(c[s>>2]|0)+20>>2]&4095](s)|0;if(t>>>0>d>>>0){u=0;i=e;return u|0}d=c[(c[116650]|0)+12>>2]|0;s=c[(c[d>>2]|0)+24>>2]|0;v=c[a>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[n>>2]=b;c[n+4>>2]=b+(t<<2);c[o>>2]=0;c[o+4>>2]=0;c[p>>2]=0;c[p+4>>2]=0;c[q>>2]=0;c[q+4>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];Nn[s&31](d,v,l,k,j,h,g,f);u=t;i=e;return u|0}function lla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+96|0;f=e+8|0;g=e+32|0;h=e+72|0;j=e;k=e+64|0;l=e+80|0;m=e+88|0;n=e+48|0;o=e+40|0;p=e+16|0;q=e+24|0;r=e+56|0;s=c[a>>2]|0;t=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;if(t>>>0>d>>>0){u=0;i=e;return u|0}d=c[(c[116650]|0)+12>>2]|0;s=c[(c[d>>2]|0)+24>>2]|0;v=c[a>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[n>>2]=0;c[n+4>>2]=0;c[o>>2]=0;c[o+4>>2]=0;c[p>>2]=b;c[p+4>>2]=b+(t<<2);c[q>>2]=0;c[q+4>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];Nn[s&31](d,v,l,k,j,h,g,f);u=t;i=e;return u|0}function mla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+96|0;f=e+8|0;g=e+32|0;h=e+72|0;j=e;k=e+64|0;l=e+80|0;m=e+88|0;n=e+48|0;o=e+40|0;p=e+16|0;q=e+24|0;r=e+56|0;s=c[a>>2]|0;t=mo[c[(c[s>>2]|0)+32>>2]&4095](s)|0;if(t>>>0>d>>>0){u=0;i=e;return u|0}d=c[(c[116650]|0)+12>>2]|0;s=c[(c[d>>2]|0)+24>>2]|0;v=c[a>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[n>>2]=0;c[n+4>>2]=0;c[o>>2]=0;c[o+4>>2]=0;c[p>>2]=0;c[p+4>>2]=0;c[q>>2]=b;c[q+4>>2]=b+(t<<2);c[r>>2]=0;c[r+4>>2]=0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];Nn[s&31](d,v,l,k,j,h,g,f);u=t;i=e;return u|0}function nla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+96|0;f=e+8|0;g=e+32|0;h=e+72|0;j=e;k=e+64|0;l=e+80|0;m=e+88|0;n=e+48|0;o=e+40|0;p=e+16|0;q=e+24|0;r=e+56|0;s=c[a>>2]|0;t=mo[c[(c[s>>2]|0)+32>>2]&4095](s)|0;if(t>>>0>d>>>0){u=0;i=e;return u|0}d=c[(c[116650]|0)+12>>2]|0;s=c[(c[d>>2]|0)+24>>2]|0;v=c[a>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[n>>2]=0;c[n+4>>2]=0;c[o>>2]=0;c[o+4>>2]=0;c[p>>2]=0;c[p+4>>2]=0;c[q>>2]=0;c[q+4>>2]=0;c[r>>2]=b;c[r+4>>2]=b+(t<<2);c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];Nn[s&31](d,v,l,k,j,h,g,f);u=t;i=e;return u|0}function ola(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=c[a>>2]|0;Fn[c[(c[e>>2]|0)+36>>2]&255](e,b);e=c[a>>2]|0;Fn[c[(c[e>>2]|0)+40>>2]&255](e,b);e=a+4|0;a=c[e>>2]|0;if(!a){i=d;return}Fn[c[(c[a>>2]|0)+36>>2]&255](a,b);a=c[e>>2]|0;Fn[c[(c[a>>2]|0)+40>>2]&255](a,b);i=d;return}function pla(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;c[d>>2]=475888;c[d+4>>2]=0;h=d+8|0;c[h>>2]=e;j=d+12|0;c[j>>2]=-1073741825;c[j+4>>2]=1073741823;xia(e,d);c[d>>2]=478640;j=yla(e)|0;c[d+20>>2]=j;Ika(g,j);j=b[g>>1]&4;a[d+24>>0]=(j&65535)>>>2;if(!(j<<16>>16)){i=f;return}Rea(q7(c[h>>2]|0)|0,d);i=f;return}function qla(b){b=b|0;var d=0;d=i;i=i+16|0;c[b>>2]=478640;if(a[b+24>>0]|0)Uea(q7(c[b+8>>2]|0)|0,b);Dia(b);VJa(d,b);i=d;return}function rla(b){b=b|0;var d=0;d=i;c[b>>2]=478640;if(!(a[b+24>>0]|0)){Dia(b);i=d;return}Uea(q7(c[b+8>>2]|0)|0,b);Dia(b);i=d;return}function sla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[b>>2]=5;$ia(f,c[a+20>>2]|0);c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];i=e;return}function tla(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im;e=i;i=i+32|0;f=e+24|0;h=e;j=d+20|0;Ika(f,c[j>>2]|0);k=d+24|0;l=(a[k>>0]|0)!=0;if(!(b[f>>1]&4)){if(!l){i=e;return}Uea(q7(c[d+8>>2]|0)|0,d);a[k>>0]=0;i=e;return}f=d+8|0;if(!l){Rea(q7(c[f>>2]|0)|0,d);a[k>>0]=1}k=c[(c[(c[(c[f>>2]|0)+36>>2]|0)+1e3>>2]|0)+8>>2]|0;Qka(h,c[j>>2]|0);m=ea(Tka(c[j>>2]|0));n=ea(g[h>>2]);j=h+12|0;o=ea(g[j>>2]);if(!(n>o)){g[h>>2]=ea(n-m);f=h+4|0;g[f>>2]=ea(ea(g[f>>2])-m);f=h+8|0;g[f>>2]=ea(ea(g[f>>2])-m);g[j>>2]=ea(m+o);j=h+16|0;g[j>>2]=ea(m+ea(g[j>>2]));j=h+20|0;g[j>>2]=ea(m+ea(g[j>>2]))}upa(k,c[d+12>>2]&1073741823,h);i=e;return}function ula(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im;f=i;i=i+16|0;h=f;n7(a,d,e,8);c[a>>2]=478664;pla(a+56|0,a);e=a+84|0;d=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));Ala(a);e=a+52|0;wja(h,c[e>>2]|0);d=c[e>>2]|0;if(b[d+8>>1]&2){j=d;k=j+28|0;l=c[k>>2]|0;m=c[l>>2]|0;n=m+80|0;o=c[n>>2]|0;In[o&4095](l,h);i=f;return}d=q7(a)|0;p=ea(g[d+32>>2]);q=ea(g[d+36>>2]);r=ea(g[d+40>>2]);g[h>>2]=ea(p+ea(g[h>>2]));d=h+4|0;g[d>>2]=ea(q+ea(g[d>>2]));d=h+8|0;g[d>>2]=ea(r+ea(g[d>>2]));j=c[e>>2]|0;k=j+28|0;l=c[k>>2]|0;m=c[l>>2]|0;n=m+80|0;o=c[n>>2]|0;In[o&4095](l,h);i=f;return}function vla(a){a=a|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im;d=i;i=i+16|0;e=d;Ala(a);f=a+52|0;wja(e,c[f>>2]|0);h=c[f>>2]|0;if(b[h+8>>1]&2){j=h;k=j+28|0;l=c[k>>2]|0;m=c[l>>2]|0;n=m+80|0;o=c[n>>2]|0;In[o&4095](l,e);i=d;return}h=q7(a)|0;p=ea(g[h+32>>2]);q=ea(g[h+36>>2]);r=ea(g[h+40>>2]);g[e>>2]=ea(p+ea(g[e>>2]));h=e+4|0;g[h>>2]=ea(q+ea(g[h>>2]));h=e+8|0;g[h>>2]=ea(r+ea(g[h>>2]));j=c[f>>2]|0;k=j+28|0;l=c[k>>2]|0;m=c[l>>2]|0;n=m+80|0;o=c[n>>2]|0;In[o&4095](l,e);i=d;return}function wla(a){a=a|0;var b=0;b=i;i=i+16|0;xla(a);VJa(b,a);i=b;return}function xla(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=478664;c[(c[a+52>>2]|0)+4>>2]=0;d=c[a+136>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+128>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+124>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+116>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}rla(a+56|0);p7(a);i=b;return}function yla(a){a=a|0;return c[a+52>>2]|0}function zla(a){a=a|0;var b=0;b=i;tla(a+56|0);i=b;return}function Ala(f){f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=0,gb=0,hb=0,ib=0,jb=Im,kb=Im,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0;h=i;i=i+912|0;j=h+464|0;k=h+816|0;l=h+908|0;m=h+404|0;n=h+416|0;o=h+376|0;p=h+80|0;q=h+96|0;r=h+124|0;s=h+152|0;t=h+168|0;u=h+184|0;v=h+192|0;w=h+204|0;x=h+232|0;y=h+264|0;z=h+280|0;A=h+308|0;B=h+752|0;C=h+776|0;D=h+800|0;E=h+832|0;F=h+864|0;G=h+448|0;H=h+880|0;I=h+512|0;J=h+540|0;K=h+568|0;L=h+592|0;M=h+608|0;N=h+616|0;O=h+628|0;P=h+640|0;Q=h+668|0;R=h+696|0;S=h+910|0;T=h+64|0;U=h+52|0;V=h+736|0;W=h+336|0;X=h;Y=h+40|0;Z=h+364|0;_=h+768|0;$=h+28|0;aa=h+848|0;ba=h+728|0;ca=h+792|0;fa=c[f+52>>2]|0;Ika(l,fa);if(!(b[l>>1]&4)){i=h;return}ga=ea(Vka(fa));l=c[f+116>>2]|0;c[m>>2]=0;ha=m+4|0;c[ha>>2]=0;ia=m+8|0;c[ia>>2]=0;ja=f+84|0;a:do if(!(c[ja>>2]|0))ka=l;else{la=o+16|0;ma=n+16|0;na=o+20|0;oa=n+20|0;pa=o+24|0;qa=n+24|0;ra=n+12|0;sa=n+4|0;ta=n+8|0;ua=p+4|0;va=p+8|0;wa=p+12|0;xa=0;ya=0;za=1;Aa=l;while(1){Ba=c[Aa>>2]|0;Ca=c[Ba+28>>2]|0;xja(n,fa);Ifa(o,Ba);Da=ea(g[la>>2]);Ea=ea(Da-ea(g[ma>>2]));Da=ea(g[na>>2]);Fa=ea(Da-ea(g[oa>>2]));Da=ea(g[pa>>2]);Ga=ea(Ea*ea(2.0));Ea=ea(Fa*ea(2.0));Fa=ea(ea(Da-ea(g[qa>>2]))*ea(2.0));Da=ea(g[ra>>2]);Ha=ea(ea(Da*Da)+ea(-.5));Ia=ea(g[n>>2]);Ja=ea(Ga*Ia);Ka=ea(g[sa>>2]);La=ea(Ja+ea(Ea*Ka));Ja=ea(g[ta>>2]);Ma=ea(La+ea(Fa*Ja));La=ea(ea(Ia*Ma)+ea(ea(Ga*Ha)-ea(Da*ea(ea(Fa*Ka)-ea(Ea*Ja)))));Na=ea(ea(Ka*Ma)+ea(ea(Ea*Ha)-ea(Da*ea(ea(Ga*Ja)-ea(Fa*Ia)))));Oa=ea(ea(ea(Fa*Ha)-ea(Da*ea(ea(Ea*Ia)-ea(Ga*Ka))))+ea(Ja*Ma));Ma=ea(ga+ea(g[Ca+72>>2]));g[p>>2]=La;g[ua>>2]=Na;g[va>>2]=Oa;g[wa>>2]=Ma;if(xa>>>0>ya>>>0){Ca=c[m>>2]|0;Ba=Ca+(ya<<4)|0;if(Ba){g[Ba>>2]=La;g[Ca+(ya<<4)+4>>2]=Na;g[Ca+(ya<<4)+8>>2]=Oa;g[Ca+(ya<<4)+12>>2]=Ma}c[ha>>2]=ya+1}else wUa(m,p)|0;Ca=Aa+4|0;if(za>>>0>=(c[ja>>2]|0)>>>0){ka=Ca;break a}xa=c[ia>>2]&2147483647;ya=c[ha>>2]|0;za=za+1|0;Aa=Ca}}while(0);ja=f+88|0;if(!(c[ja>>2]|0))Pa=ka;else{p=q+4|0;n=q+8|0;o=q+12|0;l=r+16|0;Aa=q+16|0;za=r+20|0;ya=q+20|0;xa=r+24|0;wa=q+24|0;va=r+12|0;ua=r+8|0;ta=r+4|0;sa=s+4|0;ra=s+8|0;qa=s+12|0;pa=t+4|0;oa=t+8|0;na=t+12|0;ma=0;la=ka;while(1){ka=c[la>>2]|0;Ca=c[ka+28>>2]|0;xja(q,fa);Ifa(r,ka);Ma=ea(-ea(g[q>>2]));Oa=ea(-ea(g[p>>2]));Na=ea(-ea(g[n>>2]));La=ea(g[o>>2]);Ja=ea(g[l>>2]);Ka=ea(Ja-ea(g[Aa>>2]));Ja=ea(g[za>>2]);Ga=ea(Ja-ea(g[ya>>2]));Ja=ea(g[xa>>2]);Ia=ea(Ka*ea(2.0));Ka=ea(Ga*ea(2.0));Ga=ea(ea(Ja-ea(g[wa>>2]))*ea(2.0));Ja=ea(ea(La*La)+ea(-.5));Ea=ea(ea(ea(Ia*Ma)+ea(Ka*Oa))+ea(Ga*Na));Da=ea(ea(Ea*Ma)+ea(ea(Ja*Ia)+ea(La*ea(ea(Ga*Oa)-ea(Ka*Na)))));Ha=ea(ea(Ea*Oa)+ea(ea(Ja*Ka)+ea(La*ea(ea(Ia*Na)-ea(Ga*Ma)))));Fa=ea(ea(ea(Ja*Ga)+ea(La*ea(ea(Ka*Ma)-ea(Ia*Oa))))+ea(Ea*Na));Ea=ea(g[r>>2]);Ia=ea(La*Ea);Ka=ea(g[va>>2]);Ga=ea(Ia+ea(Ka*Ma));Ia=ea(g[ua>>2]);Ja=ea(Ga+ea(Ia*Oa));Ga=ea(g[ta>>2]);Qa=ea(Ja-ea(Ga*Na));Ja=ea(ea(ea(Ea*Na)+ea(ea(Ka*Oa)+ea(La*Ga)))-ea(Ia*Ma));Ra=ea(ea(ea(Ga*Ma)+ea(ea(Ka*Na)+ea(La*Ia)))-ea(Ea*Oa));Sa=ea(ea(ea(ea(La*Ka)-ea(Ea*Ma))-ea(Ga*Oa))-ea(Ia*Na));Na=ea(ea(g[Ca+76>>2])*ea(2.0));Ia=ea(ea(Sa*Sa)+ea(-.5));Oa=ea(Ja*ea(0.0));Ga=ea(Ra*ea(0.0));Ma=ea(Ga+ea(ea(Na*Qa)+Oa));Ea=ea(ea(Qa*Ma)+ea(ea(Na*Ia)+ea(Sa*ea(Oa-Ga))));Ga=ea(Ia*ea(0.0));Ia=ea(Qa*ea(0.0));Qa=ea(ea(Ga+ea(Sa*ea(ea(Na*Ra)-Ia)))+ea(Ja*Ma));Oa=ea(ea(Ga+ea(Sa*ea(Ia-ea(Na*Ja))))+ea(Ra*Ma));Ma=ea(ga+ea(g[Ca+72>>2]));Ra=ea(Da-Ea);Ja=ea(Ha-Qa);Na=ea(Fa-Oa);g[s>>2]=Ra;g[sa>>2]=Ja;g[ra>>2]=Na;g[qa>>2]=Ma;Ca=c[ia>>2]|0;ka=c[ha>>2]|0;if((Ca&2147483647)>>>0>ka>>>0){Ba=c[m>>2]|0;Ta=Ba+(ka<<4)|0;if(Ta){g[Ta>>2]=Ra;g[Ba+(ka<<4)+4>>2]=Ja;g[Ba+(ka<<4)+8>>2]=Na;g[Ba+(ka<<4)+12>>2]=Ma}Ba=ka+1|0;c[ha>>2]=Ba;Ua=Ca;Va=Ba}else{wUa(m,s)|0;Ua=c[ia>>2]|0;Va=c[ha>>2]|0}Na=ea(Da+Ea);Ea=ea(Ha+Qa);Qa=ea(Fa+Oa);g[t>>2]=Na;g[pa>>2]=Ea;g[oa>>2]=Qa;g[na>>2]=Ma;if((Ua&2147483647)>>>0>Va>>>0){Ba=c[m>>2]|0;Ca=Ba+(Va<<4)|0;if(Ca){g[Ca>>2]=Na;g[Ba+(Va<<4)+4>>2]=Ea;g[Ba+(Va<<4)+8>>2]=Qa;g[Ba+(Va<<4)+12>>2]=Ma}c[ha>>2]=Va+1}else wUa(m,t)|0;ma=ma+1|0;Ba=la+4|0;if(ma>>>0>=(c[ja>>2]|0)>>>0){Pa=Ba;break}else la=Ba}}la=c[fa+72>>2]|0;ja=c[ha>>2]|0;ha=fa+28|0;ma=c[ha>>2]|0;t=c[(c[ma>>2]|0)+164>>2]|0;Va=c[m>>2]|0;c[u>>2]=Va;c[u+4>>2]=Va+(ja<<4);c[j+0>>2]=c[u+0>>2];c[j+4>>2]=c[u+4>>2];Dn[t&511](ma,j,la,ja+la|0);c[v>>2]=0;la=v+4|0;c[la>>2]=0;ja=v+8|0;c[ja>>2]=0;ma=f+92|0;if(!(c[ma>>2]|0))Wa=Pa;else{t=w+4|0;u=w+8|0;Va=w+12|0;Ua=x+16|0;na=w+16|0;oa=x+20|0;pa=w+20|0;s=x+24|0;qa=w+24|0;ra=x+12|0;sa=x+8|0;ta=x+4|0;ua=y+4|0;va=y+8|0;r=y+12|0;wa=0;xa=Pa;while(1){Pa=c[xa>>2]|0;xja(w,fa);Ifa(x,Pa);Ma=ea(-ea(g[w>>2]));Qa=ea(-ea(g[t>>2]));Ea=ea(-ea(g[u>>2]));Na=ea(g[Va>>2]);Oa=ea(g[Ua>>2]);Fa=ea(Oa-ea(g[na>>2]));Oa=ea(g[oa>>2]);Ha=ea(Oa-ea(g[pa>>2]));Oa=ea(g[s>>2]);Da=ea(Fa*ea(2.0));Fa=ea(Ha*ea(2.0));Ha=ea(ea(Oa-ea(g[qa>>2]))*ea(2.0));Oa=ea(ea(Na*Na)+ea(-.5));Ja=ea(ea(ea(Da*Ma)+ea(Fa*Qa))+ea(Ha*Ea));Ra=ea(ea(Ja*Ma)+ea(ea(Oa*Da)+ea(Na*ea(ea(Ha*Qa)-ea(Fa*Ea)))));Ia=ea(ea(Ja*Qa)+ea(ea(Oa*Fa)+ea(Na*ea(ea(Da*Ea)-ea(Ha*Ma)))));Sa=ea(ea(ea(Oa*Ha)+ea(Na*ea(ea(Fa*Ma)-ea(Da*Qa))))+ea(Ja*Ea));Ja=ea(g[x>>2]);Da=ea(Na*Ja);Fa=ea(g[ra>>2]);Ha=ea(Da+ea(Fa*Ma));Da=ea(g[sa>>2]);Oa=ea(Ha+ea(Da*Qa));Ha=ea(g[ta>>2]);Ga=ea(Oa-ea(Ha*Ea));Oa=ea(ea(ea(Ja*Ea)+ea(ea(Fa*Qa)+ea(Na*Ha)))-ea(Da*Ma));Ka=ea(ea(ea(Ha*Ma)+ea(ea(Fa*Ea)+ea(Na*Da)))-ea(Ja*Qa));La=ea(ea(ea(ea(Na*Fa)-ea(Ja*Ma))-ea(Ha*Qa))-ea(Da*Ea));Ea=ea(ea(La*La)+ea(-.5));Da=ea(Oa*ea(0.0));Qa=ea(Ka*ea(0.0));Ha=ea(Qa+ea(ea(Ga*ea(2.0))+Da));Ma=ea(ea(Ga*Ha)+ea(ea(Ea*ea(2.0))+ea(La*ea(Da-Qa))));Qa=ea(Ea*ea(0.0));Ea=ea(Ga*ea(0.0));Ga=ea(ea(Qa+ea(La*ea(ea(Ka*ea(2.0))-Ea)))+ea(Oa*Ha));Da=ea(ea(Qa+ea(La*ea(Ea-ea(Oa*ea(2.0)))))+ea(Ka*Ha));Ha=ea(ea(0.0)-ea(ea(Sa*Da)+ea(ea(Ra*Ma)+ea(Ia*Ga))));g[y>>2]=Ma;g[ua>>2]=Ga;g[va>>2]=Da;Ia=ea(Ha-ga);g[r>>2]=Ia;Pa=c[la>>2]|0;if((c[ja>>2]&2147483647)>>>0>Pa>>>0){ya=c[v>>2]|0;za=ya+(Pa<<4)|0;if(za){g[za>>2]=Ma;g[ya+(Pa<<4)+4>>2]=Ga;g[ya+(Pa<<4)+8>>2]=Da;g[ya+(Pa<<4)+12>>2]=Ia}c[la>>2]=Pa+1}else h_a(v,y)|0;wa=wa+1|0;Pa=xa+4|0;if(wa>>>0>=(c[ma>>2]|0)>>>0){Wa=Pa;break}else xa=Pa}}xa=f+96|0;if(!(c[xa>>2]|0))Xa=Wa;else{ma=z+4|0;wa=z+8|0;y=z+12|0;r=A+16|0;va=z+16|0;ua=A+20|0;ta=z+20|0;sa=A+24|0;ra=z+24|0;x=A+12|0;qa=A+8|0;s=A+4|0;pa=B+4|0;oa=B+8|0;na=B+12|0;Ua=C+4|0;Va=C+8|0;u=C+12|0;t=D+4|0;w=D+8|0;Pa=D+12|0;ya=E+4|0;za=E+8|0;Aa=E+12|0;l=F+4|0;o=F+8|0;n=F+12|0;p=G+4|0;q=G+8|0;Ba=G+12|0;Ca=0;ka=Wa;while(1){Wa=c[ka>>2]|0;Ta=c[Wa+28>>2]|0;xja(z,fa);Ifa(A,Wa);Ia=ea(-ea(g[z>>2]));Da=ea(-ea(g[ma>>2]));Ga=ea(-ea(g[wa>>2]));Ma=ea(g[y>>2]);Ha=ea(g[r>>2]);Ra=ea(Ha-ea(g[va>>2]));Ha=ea(g[ua>>2]);Sa=ea(Ha-ea(g[ta>>2]));Ha=ea(g[sa>>2]);Ka=ea(Ra*ea(2.0));Ra=ea(Sa*ea(2.0));Sa=ea(ea(Ha-ea(g[ra>>2]))*ea(2.0));Ha=ea(ea(Ma*Ma)+ea(-.5));Oa=ea(ea(ea(Ka*Ia)+ea(Ra*Da))+ea(Sa*Ga));Ea=ea(ea(Oa*Ia)+ea(ea(Ha*Ka)+ea(Ma*ea(ea(Sa*Da)-ea(Ra*Ga)))));La=ea(ea(Oa*Da)+ea(ea(Ha*Ra)+ea(Ma*ea(ea(Ka*Ga)-ea(Sa*Ia)))));Qa=ea(ea(ea(Ha*Sa)+ea(Ma*ea(ea(Ra*Ia)-ea(Ka*Da))))+ea(Oa*Ga));Oa=ea(g[A>>2]);Ka=ea(Ma*Oa);Ra=ea(g[x>>2]);Sa=ea(Ka+ea(Ra*Ia));Ka=ea(g[qa>>2]);Ha=ea(Sa+ea(Ka*Da));Sa=ea(g[s>>2]);Ja=ea(Ha-ea(Sa*Ga));Ha=ea(ea(ea(Oa*Ga)+ea(ea(Ra*Da)+ea(Ma*Sa)))-ea(Ka*Ia));Fa=ea(ea(ea(Sa*Ia)+ea(ea(Ra*Ga)+ea(Ma*Ka)))-ea(Oa*Da));Na=ea(ea(ea(ea(Ma*Ra)-ea(Oa*Ia))-ea(Sa*Da))-ea(Ka*Ga));Ga=ea(ga+ea(g[Ta+72>>2]));Ka=ea(ga+ea(g[Ta+76>>2]));Da=ea(ga+ea(g[Ta+80>>2]));Sa=ea(-Ga);Ga=ea(ea(Na*Na)+ea(-.5));Ia=ea(Ja*ea(2.0));Oa=ea(Ha*ea(0.0));Ra=ea(Fa*ea(0.0));Ma=ea(Ra+ea(Ia+Oa));Ya=ea(Ga*ea(2.0));Za=ea(Na*ea(Oa-Ra));_a=ea(ea(Ja*Ma)+ea(Ya+Za));$a=ea(Ga*ea(0.0));ab=ea(Fa*ea(2.0));bb=ea(Ja*ea(0.0));cb=ea(ea($a+ea(Na*ea(ab-bb)))+ea(Ha*Ma));db=ea(Ha*ea(2.0));eb=ea(ea($a+ea(Na*ea(bb-db)))+ea(Fa*Ma));Ma=ea(Sa-ea(ea(Qa*eb)+ea(ea(Ea*_a)+ea(La*cb))));g[B>>2]=_a;g[pa>>2]=cb;g[oa>>2]=eb;g[na>>2]=Ma;Ta=c[ja>>2]|0;Wa=c[la>>2]|0;if((Ta&2147483647)>>>0>Wa>>>0){fb=c[v>>2]|0;gb=fb+(Wa<<4)|0;if(gb){g[gb>>2]=_a;g[fb+(Wa<<4)+4>>2]=cb;g[fb+(Wa<<4)+8>>2]=eb;g[fb+(Wa<<4)+12>>2]=Ma}fb=Wa+1|0;c[la>>2]=fb;hb=Ta;ib=fb}else{h_a(v,B)|0;hb=c[ja>>2]|0;ib=c[la>>2]|0}Ma=ea(Ja*ea(-2.0));eb=ea(Ra+ea(Ma+Oa));cb=ea(Ga*ea(-2.0));Ga=ea(ea(Ja*eb)+ea(cb+Za));Za=ea(Fa*ea(-2.0));_a=ea(ea($a+ea(Na*ea(Za-bb)))+ea(Ha*eb));jb=ea(Ha*ea(-2.0));kb=ea(ea($a+ea(Na*ea(bb-jb)))+ea(Fa*eb));eb=ea(Sa-ea(ea(Qa*kb)+ea(ea(Ea*Ga)+ea(La*_a))));g[C>>2]=Ga;g[Ua>>2]=_a;g[Va>>2]=kb;g[u>>2]=eb;if((hb&2147483647)>>>0>ib>>>0){fb=c[v>>2]|0;Ta=fb+(ib<<4)|0;if(Ta){g[Ta>>2]=Ga;g[fb+(ib<<4)+4>>2]=_a;g[fb+(ib<<4)+8>>2]=kb;g[fb+(ib<<4)+12>>2]=eb}fb=ib+1|0;c[la>>2]=fb;lb=hb;mb=fb}else{h_a(v,C)|0;lb=c[ja>>2]|0;mb=c[la>>2]|0}eb=ea(-Ka);Ka=ea(Ra+ea(bb+db));kb=ea(ea(Ja*Ka)+ea($a+ea(Na*ea(Oa-ab))));_a=ea(Na*ea(Ra-bb));Ga=ea(ea(Ya+_a)+ea(Ha*Ka));Sa=ea(ea($a+ea(Na*ea(Ia-Oa)))+ea(Fa*Ka));Ka=ea(eb-ea(ea(Qa*Sa)+ea(ea(Ea*kb)+ea(La*Ga))));g[D>>2]=kb;g[t>>2]=Ga;g[w>>2]=Sa;g[Pa>>2]=Ka;if((lb&2147483647)>>>0>mb>>>0){fb=c[v>>2]|0;Ta=fb+(mb<<4)|0;if(Ta){g[Ta>>2]=kb;g[fb+(mb<<4)+4>>2]=Ga;g[fb+(mb<<4)+8>>2]=Sa;g[fb+(mb<<4)+12>>2]=Ka}fb=mb+1|0;c[la>>2]=fb;nb=lb;ob=fb}else{h_a(v,D)|0;nb=c[ja>>2]|0;ob=c[la>>2]|0}Ka=ea(Ra+ea(bb+jb));Sa=ea(ea(Ja*Ka)+ea($a+ea(Na*ea(Oa-Za))));Ga=ea(ea(cb+_a)+ea(Ha*Ka));_a=ea(ea($a+ea(Na*ea(Ma-Oa)))+ea(Fa*Ka));Ka=ea(eb-ea(ea(Qa*_a)+ea(ea(Ea*Sa)+ea(La*Ga))));g[E>>2]=Sa;g[ya>>2]=Ga;g[za>>2]=_a;g[Aa>>2]=Ka;if((nb&2147483647)>>>0>ob>>>0){fb=c[v>>2]|0;Ta=fb+(ob<<4)|0;if(Ta){g[Ta>>2]=Sa;g[fb+(ob<<4)+4>>2]=Ga;g[fb+(ob<<4)+8>>2]=_a;g[fb+(ob<<4)+12>>2]=Ka}fb=ob+1|0;c[la>>2]=fb;pb=nb;qb=fb}else{h_a(v,E)|0;pb=c[ja>>2]|0;qb=c[la>>2]|0}Ka=ea(-Da);Da=ea(bb+Oa);_a=ea(ab+Da);ab=ea(ea(Ja*_a)+ea($a+ea(Na*ea(db-Ra))));db=ea(ea($a+ea(Na*ea(Ra-Ia)))+ea(Ha*_a));Ia=ea(Na*ea(bb-Oa));Oa=ea(ea(Ya+Ia)+ea(Fa*_a));_a=ea(Ka-ea(ea(Qa*Oa)+ea(ea(Ea*ab)+ea(La*db))));g[F>>2]=ab;g[l>>2]=db;g[o>>2]=Oa;g[n>>2]=_a;if((pb&2147483647)>>>0>qb>>>0){fb=c[v>>2]|0;Ta=fb+(qb<<4)|0;if(Ta){g[Ta>>2]=ab;g[fb+(qb<<4)+4>>2]=db;g[fb+(qb<<4)+8>>2]=Oa;g[fb+(qb<<4)+12>>2]=_a}fb=qb+1|0;c[la>>2]=fb;rb=pb;sb=fb}else{h_a(v,F)|0;rb=c[ja>>2]|0;sb=c[la>>2]|0}_a=ea(Za+Da);Da=ea(ea(Ja*_a)+ea($a+ea(Na*ea(jb-Ra))));jb=ea(ea($a+ea(Na*ea(Ra-Ma)))+ea(Ha*_a));Ha=ea(ea(cb+Ia)+ea(Fa*_a));_a=ea(Ka-ea(ea(Qa*Ha)+ea(ea(Ea*Da)+ea(La*jb))));g[G>>2]=Da;g[p>>2]=jb;g[q>>2]=Ha;g[Ba>>2]=_a;if((rb&2147483647)>>>0>sb>>>0){fb=c[v>>2]|0;Ta=fb+(sb<<4)|0;if(Ta){g[Ta>>2]=Da;g[fb+(sb<<4)+4>>2]=jb;g[fb+(sb<<4)+8>>2]=Ha;g[fb+(sb<<4)+12>>2]=_a}c[la>>2]=sb+1}else h_a(v,G)|0;Ca=Ca+1|0;fb=ka+4|0;if(Ca>>>0>=(c[xa>>2]|0)>>>0){Xa=fb;break}else ka=fb}}ka=f+100|0;if(!(c[ka>>2]|0))tb=Xa;else{xa=I+4|0;Ca=I+8|0;G=I+12|0;sb=J+16|0;rb=I+16|0;Ba=J+20|0;q=I+20|0;p=J+24|0;F=I+24|0;pb=J+12|0;qb=J+8|0;n=J+4|0;o=H+4|0;l=H+8|0;E=H+12|0;nb=H+16|0;ob=H+20|0;Aa=H+24|0;za=j+4|0;ya=j+8|0;D=K+4|0;lb=j+12|0;mb=j+16|0;Pa=j+20|0;w=K+8|0;t=j+24|0;C=j+28|0;hb=j+32|0;ib=K+12|0;u=j+36|0;Va=j+40|0;Ua=j+44|0;B=L+4|0;na=L+8|0;oa=L+12|0;pa=0;s=Xa;while(1){Xa=c[s>>2]|0;qa=c[Xa+28>>2]|0;xja(I,fa);Ifa(J,Xa);_a=ea(-ea(g[I>>2]));Ha=ea(-ea(g[xa>>2]));jb=ea(-ea(g[Ca>>2]));Da=ea(g[G>>2]);La=ea(g[sb>>2]);Ea=ea(La-ea(g[rb>>2]));La=ea(g[Ba>>2]);Qa=ea(La-ea(g[q>>2]));La=ea(g[p>>2]);Ka=ea(Ea*ea(2.0));Ea=ea(Qa*ea(2.0));Qa=ea(ea(La-ea(g[F>>2]))*ea(2.0));La=ea(ea(Da*Da)+ea(-.5));Fa=ea(ea(ea(Ka*_a)+ea(Ea*Ha))+ea(Qa*jb));Ia=ea(ea(Fa*_a)+ea(ea(La*Ka)+ea(Da*ea(ea(Qa*Ha)-ea(Ea*jb)))));cb=ea(ea(Fa*Ha)+ea(ea(La*Ea)+ea(Da*ea(ea(Ka*jb)-ea(Qa*_a)))));Ma=ea(ea(ea(La*Qa)+ea(Da*ea(ea(Ea*_a)-ea(Ka*Ha))))+ea(Fa*jb));Fa=ea(g[J>>2]);Ka=ea(Da*Fa);Ea=ea(g[pb>>2]);Qa=ea(Ka+ea(Ea*_a));Ka=ea(g[qb>>2]);La=ea(Qa+ea(Ka*Ha));Qa=ea(g[n>>2]);Ra=ea(ea(ea(Fa*jb)+ea(ea(Ea*Ha)+ea(Da*Qa)))-ea(Ka*_a));Na=ea(ea(ea(Qa*_a)+ea(ea(Ea*jb)+ea(Da*Ka)))-ea(Fa*Ha));$a=ea(ea(ea(ea(Da*Ea)-ea(Fa*_a))-ea(Qa*Ha))-ea(Ka*jb));g[H>>2]=ea(La-ea(Qa*jb));g[o>>2]=Ra;g[l>>2]=Na;g[E>>2]=$a;g[nb>>2]=Ia;g[ob>>2]=cb;g[Aa>>2]=Ma;i_a(j,H,qa+72|0);Xa=qa+100|0;qa=c[Xa>>2]|0;x=mo[c[(c[qa>>2]|0)+36>>2]&4095](qa)|0;if(x){Ma=ea(g[j>>2]);cb=ea(g[za>>2]);Ia=ea(g[ya>>2]);$a=ea(g[lb>>2]);Na=ea(g[mb>>2]);Ra=ea(g[Pa>>2]);jb=ea(g[t>>2]);Qa=ea(g[C>>2]);La=ea(g[hb>>2]);Ka=ea(g[u>>2]);Ha=ea(g[Va>>2]);_a=ea(g[Ua>>2]);qa=0;do{A=c[Xa>>2]|0;xo[c[(c[A>>2]|0)+40>>2]&2047](A,qa,K)|0;Fa=ea(g[K>>2]);Ea=ea(Fa*Ma);Da=ea(Fa*cb);Ja=ea(Fa*Ia);Fa=ea(g[D>>2]);Za=ea(Ea+ea(Fa*$a));Ea=ea(Da+ea(Fa*Na));Da=ea(Ja+ea(Fa*Ra));Fa=ea(g[w>>2]);Ja=ea(Za+ea(Fa*jb));Za=ea(Ea+ea(Fa*Qa));Ea=ea(Da+ea(Fa*La));Fa=ea(ea(ea(g[ib>>2])-ea(ea(ea(Ja*Ka)+ea(Za*Ha))+ea(Ea*_a)))-ga);g[L>>2]=Ja;g[B>>2]=Za;g[na>>2]=Ea;g[oa>>2]=Fa;A=c[la>>2]|0;if((c[ja>>2]&2147483647)>>>0>A>>>0){ra=c[v>>2]|0;sa=ra+(A<<4)|0;if(sa){g[sa>>2]=Ja;g[ra+(A<<4)+4>>2]=Za;g[ra+(A<<4)+8>>2]=Ea;g[ra+(A<<4)+12>>2]=Fa}c[la>>2]=A+1}else h_a(v,L)|0;qa=qa+1|0}while((qa|0)!=(x|0))}pa=pa+1|0;x=s+4|0;if(pa>>>0>=(c[ka>>2]|0)>>>0){tb=x;break}else s=x}}s=c[fa+80>>2]|0;ka=c[la>>2]|0;la=c[ha>>2]|0;pa=c[(c[la>>2]|0)+180>>2]|0;L=c[v>>2]|0;c[M>>2]=L;c[M+4>>2]=L+(ka<<4);c[j+0>>2]=c[M+0>>2];c[j+4>>2]=c[M+4>>2];Dn[pa&511](la,j,s,ka+s|0);c[N>>2]=0;s=N+4|0;c[s>>2]=0;ka=N+8|0;c[ka>>2]=0;c[O>>2]=0;la=O+4|0;c[la>>2]=0;pa=O+8|0;c[pa>>2]=0;M=f+104|0;if(!(c[M>>2]|0)){ub=0;vb=0;wb=tb}else{L=P+4|0;oa=P+8|0;na=P+12|0;B=Q+16|0;ib=P+16|0;w=Q+20|0;D=P+20|0;K=Q+24|0;Ua=P+24|0;Va=Q+12|0;u=Q+8|0;hb=Q+4|0;C=R+4|0;t=R+8|0;Pa=R+12|0;mb=R+16|0;lb=R+20|0;ya=R+24|0;za=f+128|0;H=j+4|0;Aa=j+8|0;ob=j+12|0;nb=j+16|0;E=j+20|0;l=j+24|0;o=j+28|0;n=j+32|0;qb=j+36|0;pb=j+40|0;J=j+44|0;F=T+4|0;p=T+8|0;q=0;Ba=tb;while(1){tb=c[Ba>>2]|0;rb=c[tb+28>>2]|0;xja(P,fa);Ifa(Q,tb);_a=ea(-ea(g[P>>2]));Ha=ea(-ea(g[L>>2]));Ka=ea(-ea(g[oa>>2]));La=ea(g[na>>2]);Qa=ea(g[B>>2]);jb=ea(Qa-ea(g[ib>>2]));Qa=ea(g[w>>2]);Ra=ea(Qa-ea(g[D>>2]));Qa=ea(g[K>>2]);Na=ea(jb*ea(2.0));jb=ea(Ra*ea(2.0));Ra=ea(ea(Qa-ea(g[Ua>>2]))*ea(2.0));Qa=ea(ea(La*La)+ea(-.5));$a=ea(ea(ea(Na*_a)+ea(jb*Ha))+ea(Ra*Ka));Ia=ea(ea($a*_a)+ea(ea(Qa*Na)+ea(La*ea(ea(Ra*Ha)-ea(jb*Ka)))));cb=ea(ea($a*Ha)+ea(ea(Qa*jb)+ea(La*ea(ea(Na*Ka)-ea(Ra*_a)))));Ma=ea(ea(ea(Qa*Ra)+ea(La*ea(ea(jb*_a)-ea(Na*Ha))))+ea($a*Ka));$a=ea(g[Q>>2]);Na=ea(La*$a);jb=ea(g[Va>>2]);Ra=ea(Na+ea(jb*_a));Na=ea(g[u>>2]);Qa=ea(Ra+ea(Na*Ha));Ra=ea(g[hb>>2]);Fa=ea(ea(ea($a*Ka)+ea(ea(jb*Ha)+ea(La*Ra)))-ea(Na*_a));Ea=ea(ea(ea(Ra*_a)+ea(ea(jb*Ka)+ea(La*Na)))-ea($a*Ha));Za=ea(ea(ea(ea(La*jb)-ea($a*_a))-ea(Ra*Ha))-ea(Na*Ka));g[R>>2]=ea(Qa-ea(Ra*Ka));g[C>>2]=Fa;g[t>>2]=Ea;g[Pa>>2]=Za;g[mb>>2]=Ia;g[lb>>2]=cb;g[ya>>2]=Ma;i_a(j,R,rb+72|0);tb=c[s>>2]|0;sb=rb+104|0;rb=c[sb>>2]|0;In[c[(c[rb>>2]|0)+40>>2]&4095](S,rb);rb=(a[S>>0]&2)==0;G=c[sb>>2]|0;sb=mo[c[(c[G>>2]|0)+32>>2]&4095](G)|0;Ca=mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0;b:do if(rb){xa=mo[c[(c[G>>2]|0)+28>>2]&4095](G)|0;if(sb){I=tb;x=0;while(1){qa=x*3|0;Xa=c[Ca+(qa<<2)>>2]|0;A=xa+(Xa*12|0)|0;ra=c[ka>>2]|0;if((ra&2147483647)>>>0>I>>>0){sa=c[N>>2]|0;ta=sa+(I*12|0)|0;if(ta){g[ta>>2]=ea(g[A>>2]);g[sa+(I*12|0)+4>>2]=ea(g[xa+(Xa*12|0)+4>>2]);g[sa+(I*12|0)+8>>2]=ea(g[xa+(Xa*12|0)+8>>2])}Xa=I+1|0;c[s>>2]=Xa;xb=ra;yb=Xa}else{_Ua(N,A)|0;xb=c[ka>>2]|0;yb=c[s>>2]|0}A=c[Ca+(qa+1<<2)>>2]|0;Xa=xa+(A*12|0)|0;if((xb&2147483647)>>>0>yb>>>0){ra=c[N>>2]|0;sa=ra+(yb*12|0)|0;if(sa){g[sa>>2]=ea(g[Xa>>2]);g[ra+(yb*12|0)+4>>2]=ea(g[xa+(A*12|0)+4>>2]);g[ra+(yb*12|0)+8>>2]=ea(g[xa+(A*12|0)+8>>2])}A=yb+1|0;c[s>>2]=A;zb=xb;Ab=A}else{_Ua(N,Xa)|0;zb=c[ka>>2]|0;Ab=c[s>>2]|0}Xa=c[Ca+(qa+2<<2)>>2]|0;qa=xa+(Xa*12|0)|0;if((zb&2147483647)>>>0>Ab>>>0){A=c[N>>2]|0;ra=A+(Ab*12|0)|0;if(ra){g[ra>>2]=ea(g[qa>>2]);g[A+(Ab*12|0)+4>>2]=ea(g[xa+(Xa*12|0)+4>>2]);g[A+(Ab*12|0)+8>>2]=ea(g[xa+(Xa*12|0)+8>>2])}c[s>>2]=Ab+1}else _Ua(N,qa)|0;qa=x+1|0;if((qa|0)==(sb|0))break b;I=c[s>>2]|0;x=qa}}}else{x=mo[c[(c[G>>2]|0)+28>>2]&4095](G)|0;if(sb){I=tb;xa=0;while(1){qa=xa*3|0;Xa=e[Ca+(qa<<1)>>1]|0;A=x+(Xa*12|0)|0;ra=c[ka>>2]|0;if((ra&2147483647)>>>0>I>>>0){sa=c[N>>2]|0;ta=sa+(I*12|0)|0;if(ta){g[ta>>2]=ea(g[A>>2]);g[sa+(I*12|0)+4>>2]=ea(g[x+(Xa*12|0)+4>>2]);g[sa+(I*12|0)+8>>2]=ea(g[x+(Xa*12|0)+8>>2])}Xa=I+1|0;c[s>>2]=Xa;Bb=ra;Cb=Xa}else{_Ua(N,A)|0;Bb=c[ka>>2]|0;Cb=c[s>>2]|0}A=e[Ca+(qa+1<<1)>>1]|0;Xa=x+(A*12|0)|0;if((Bb&2147483647)>>>0>Cb>>>0){ra=c[N>>2]|0;sa=ra+(Cb*12|0)|0;if(sa){g[sa>>2]=ea(g[Xa>>2]);g[ra+(Cb*12|0)+4>>2]=ea(g[x+(A*12|0)+4>>2]);g[ra+(Cb*12|0)+8>>2]=ea(g[x+(A*12|0)+8>>2])}A=Cb+1|0;c[s>>2]=A;Db=Bb;Eb=A}else{_Ua(N,Xa)|0;Db=c[ka>>2]|0;Eb=c[s>>2]|0}Xa=e[Ca+(qa+2<<1)>>1]|0;qa=x+(Xa*12|0)|0;if((Db&2147483647)>>>0>Eb>>>0){A=c[N>>2]|0;ra=A+(Eb*12|0)|0;if(ra){g[ra>>2]=ea(g[qa>>2]);g[A+(Eb*12|0)+4>>2]=ea(g[x+(Xa*12|0)+4>>2]);g[A+(Eb*12|0)+8>>2]=ea(g[x+(Xa*12|0)+8>>2])}c[s>>2]=Eb+1}else _Ua(N,qa)|0;qa=xa+1|0;if((qa|0)==(sb|0))break b;I=c[s>>2]|0;xa=qa}}}while(0);sb=c[za>>2]|0;Ca=sb+(q*48|0)|0;Ma=ea(g[Ca>>2]);G=sb+(q*48|0)+4|0;cb=ea(g[G>>2]);rb=sb+(q*48|0)+8|0;Ia=ea(g[rb>>2]);xa=sb+(q*48|0)+12|0;Za=ea(g[xa>>2]);I=sb+(q*48|0)+16|0;Ea=ea(g[I>>2]);x=sb+(q*48|0)+20|0;Fa=ea(g[x>>2]);qa=sb+(q*48|0)+24|0;Ka=ea(g[qa>>2]);Xa=sb+(q*48|0)+28|0;Ra=ea(g[Xa>>2]);A=sb+(q*48|0)+32|0;Qa=ea(g[A>>2]);ra=sb+(q*48|0)+36|0;Na=ea(g[ra>>2]);sa=sb+(q*48|0)+40|0;Ha=ea(g[sa>>2]);ta=sb+(q*48|0)+44|0;_a=ea(g[ta>>2]);$a=ea(g[j>>2]);g[Ca>>2]=$a;jb=ea(g[H>>2]);g[G>>2]=jb;La=ea(g[Aa>>2]);g[rb>>2]=La;Ja=ea(g[ob>>2]);g[xa>>2]=Ja;Da=ea(g[nb>>2]);g[I>>2]=Da;Oa=ea(g[E>>2]);g[x>>2]=Oa;db=ea(g[l>>2]);g[qa>>2]=db;ab=ea(g[o>>2]);g[Xa>>2]=ab;Ya=ea(g[n>>2]);g[A>>2]=Ya;bb=ea(g[qb>>2]);g[ra>>2]=bb;Ga=ea(g[pb>>2]);g[sa>>2]=Ga;Sa=ea(g[J>>2]);g[ta>>2]=Sa;ta=c[s>>2]|0;sa=c[N>>2]|0;if(tb>>>0<ta>>>0){ra=tb;do{eb=ea(g[sa+(ra*12|0)>>2]);kb=ea(Ma*eb);Fb=ea(cb*eb);Gb=ea(Ia*eb);eb=ea(g[sa+(ra*12|0)+4>>2]);Hb=ea(kb+ea(Za*eb));kb=ea(Fb+ea(Ea*eb));Fb=ea(Gb+ea(Fa*eb));eb=ea(g[sa+(ra*12|0)+8>>2]);Gb=ea(Na+ea(Hb+ea(Ka*eb)));Hb=ea(Ha+ea(kb+ea(Ra*eb)));kb=ea(_a+ea(Fb+ea(Qa*eb)));g[T>>2]=Gb;g[F>>2]=Hb;g[p>>2]=kb;A=c[la>>2]|0;if((c[pa>>2]&2147483647)>>>0>A>>>0){Xa=c[O>>2]|0;qa=Xa+(A*12|0)|0;if(qa){g[qa>>2]=Gb;g[Xa+(A*12|0)+4>>2]=Hb;g[Xa+(A*12|0)+8>>2]=kb}c[la>>2]=A+1}else _Ua(O,T)|0;ra=ra+1|0}while((ra|0)!=(ta|0))}ra=sa+(ta*12|0)|0;c:do if((tb|0)<(ta|0)){A=sa+(tb*12|0)|0;Qa=$a;_a=jb;Ra=La;Ha=Ja;Ka=Da;Na=Oa;Fa=db;Ea=ab;Za=Ya;Ia=bb;cb=Ga;Ma=Sa;while(1){kb=ea(g[A>>2]);Hb=ea(kb*Qa);Gb=ea(kb*_a);eb=ea(kb*Ra);Xa=A+4|0;kb=ea(g[Xa>>2]);Fb=ea(Hb+ea(kb*Ha));Hb=ea(Gb+ea(kb*Ka));Gb=ea(eb+ea(kb*Na));qa=A+8|0;kb=ea(g[qa>>2]);eb=ea(ea(Hb+ea(kb*Ea))+cb);Hb=ea(ea(Gb+ea(kb*Za))+Ma);g[A>>2]=ea(ea(Fb+ea(kb*Fa))+Ia);g[Xa>>2]=eb;g[qa>>2]=Hb;qa=A+12|0;if(qa>>>0>=ra>>>0)break c;Hb=ea(g[j>>2]);eb=ea(g[H>>2]);kb=ea(g[Aa>>2]);Fb=ea(g[ob>>2]);Gb=ea(g[nb>>2]);Ib=ea(g[E>>2]);Jb=ea(g[l>>2]);Kb=ea(g[o>>2]);Lb=ea(g[n>>2]);Mb=ea(g[qb>>2]);Nb=ea(g[pb>>2]);A=qa;Qa=Hb;_a=eb;Ra=kb;Ha=Fb;Ka=Gb;Na=Ib;Fa=Jb;Ea=Kb;Za=Lb;Ia=Mb;cb=Nb;Ma=ea(g[J>>2])}}while(0);q=q+1|0;ra=Ba+4|0;if(q>>>0>=(c[M>>2]|0)>>>0){ub=sa;vb=ta;wb=ra;break}else Ba=ra}}c[U>>2]=0;Ba=U+4|0;c[Ba>>2]=0;q=U+8|0;c[q>>2]=0;c[V>>2]=0;c[V+4>>2]=0;J=V+8|0;c[J>>2]=0;pb=f+108|0;if(!(c[pb>>2]|0)){Ob=vb;Pb=ub}else{ub=W+4|0;vb=W+8|0;qb=W+12|0;n=X+16|0;o=W+16|0;l=X+20|0;E=W+20|0;nb=X+24|0;ob=W+24|0;Aa=X+12|0;H=X+8|0;T=X+4|0;p=f+128|0;f=Y+4|0;F=Y+8|0;za=k+4|0;Eb=k+8|0;Db=0;Bb=wb;while(1){wb=c[Bb>>2]|0;Cb=c[wb+28>>2]|0;xja(W,fa);Ifa(X,wb);Sa=ea(-ea(g[W>>2]));Ga=ea(-ea(g[ub>>2]));bb=ea(-ea(g[vb>>2]));Ya=ea(g[qb>>2]);ab=ea(g[n>>2]);db=ea(ab-ea(g[o>>2]));ab=ea(g[l>>2]);Oa=ea(ab-ea(g[E>>2]));ab=ea(g[nb>>2]);Da=ea(db*ea(2.0));db=ea(Oa*ea(2.0));Oa=ea(ea(ab-ea(g[ob>>2]))*ea(2.0));ab=ea(ea(Ya*Ya)+ea(-.5));Ja=ea(ea(ea(Da*Sa)+ea(db*Ga))+ea(Oa*bb));La=ea(ea(Ja*Sa)+ea(ea(ab*Da)+ea(Ya*ea(ea(Oa*Ga)-ea(db*bb)))));jb=ea(ea(Ja*Ga)+ea(ea(ab*db)+ea(Ya*ea(ea(Da*bb)-ea(Oa*Sa)))));$a=ea(ea(ea(ab*Oa)+ea(Ya*ea(ea(db*Sa)-ea(Da*Ga))))+ea(Ja*bb));Ja=ea(g[X>>2]);Da=ea(Ya*Ja);db=ea(g[Aa>>2]);Oa=ea(Da+ea(db*Sa));Da=ea(g[H>>2]);ab=ea(Oa+ea(Da*Ga));Oa=ea(g[T>>2]);Ma=ea(ab-ea(Oa*bb));ab=ea(ea(ea(Ja*bb)+ea(ea(db*Ga)+ea(Ya*Oa)))-ea(Da*Sa));cb=ea(ea(ea(Oa*Sa)+ea(ea(db*bb)+ea(Ya*Da)))-ea(Ja*Ga));Ia=ea(ea(ea(ea(Ya*db)-ea(Ja*Sa))-ea(Oa*Ga))-ea(Da*bb));bb=ea(Ma+Ma);Da=ea(ab+ab);Ga=ea(cb+cb);Oa=ea(bb*Ia);Sa=ea(Ia*Da);Ja=ea(Ia*Ga);Ia=ea(Ma*Da);db=ea(Ma*Ga);Ya=ea(ab*Da);Da=ea(ab*Ga);ab=ea(cb*Ga);Ga=ea(ea(ea(1.0)-Ya)-ab);cb=ea(Ja+Ia);Za=ea(db-Sa);Ea=ea(Ia-Ja);Ja=ea(ea(1.0)-ea(Ma*bb));bb=ea(Ja-ab);ab=ea(Oa+Da);Ma=ea(db+Sa);Sa=ea(Da-Oa);Oa=ea(Ja-Ya);Ya=ea(g[Cb+80>>2]);Ja=ea(Ya*Ga);Ga=ea(Ya*cb);cb=ea(Ya*Za);Za=ea(g[Cb+76>>2]);Ya=ea(Za*Ea);Ea=ea(Za*bb);bb=ea(Za*ab);ab=ea(g[Cb+84>>2]);Za=ea(ab*Ma);Ma=ea(ab*Sa);Sa=ea(ab*Oa);wb=Cb+72|0;Cb=c[wb>>2]|0;Ab=mo[c[(c[Cb>>2]|0)+36>>2]&4095](Cb)|0;zb=mo[c[(c[Cb>>2]|0)+32>>2]&4095](Cb)|0;xb=da(zb,Ab)|0;c[j>>2]=0;j_a(V,xb,j);yb=c[V>>2]|0;xo[c[(c[Cb>>2]|0)+24>>2]&2047](Cb,yb,xb<<2)|0;if((c[q>>2]&2147483647)>>>0<xb>>>0)k_a(U,xb);if(!((zb|0)==0|(Ab|0)==0)){xb=0;do{Oa=ea(xb>>>0);Cb=da(xb,Ab)|0;S=0;do{ab=ea(b[yb+(S+Cb<<2)>>1]|0);Da=ea(S>>>0);g[k>>2]=Oa;g[za>>2]=ab;g[Eb>>2]=Da;R=c[Ba>>2]|0;if((c[q>>2]&2147483647)>>>0>R>>>0){ya=c[U>>2]|0;lb=ya+(R*12|0)|0;if(lb){g[lb>>2]=Oa;g[ya+(R*12|0)+4>>2]=ab;g[ya+(R*12|0)+8>>2]=Da}c[Ba>>2]=R+1}else _Ua(U,k)|0;S=S+1|0}while((S|0)!=(Ab|0));xb=xb+1|0}while((xb|0)!=(zb|0))}zb=c[s>>2]|0;xb=c[wb>>2]|0;Ab=c[U>>2]|0;ta=mo[c[(c[xb>>2]|0)+36>>2]&4095](xb)|0;sa=mo[c[(c[xb>>2]|0)+32>>2]&4095](xb)|0;S=sa+-1|0;Cb=ta+-1|0;R=(da(Cb*6|0,S)|0)+zb|0;if((c[ka>>2]&2147483647)>>>0<R>>>0)k_a(N,R);if(Cb){R=(S|0)==0;ya=0;while(1){if(R)Qb=ya+1|0;else{lb=da(ya,sa)|0;mb=ya+1|0;Pa=da(mb,sa)|0;t=0;do{C=(da(t,ta)|0)+ya|0;hb=(d[yb+(C<<2)+2>>0]|0)>>>7;u=t+lb|0;Va=u+1|0;Q=t+Pa|0;Ua=Q+1|0;K=C<<1;do if((_n[c[(c[xb>>2]|0)+68>>2]&4095](xb,K)|0)<<16>>16!=127){C=Ab+(Q*12|0)|0;D=c[ka>>2]|0;w=c[s>>2]|0;if((D&2147483647)>>>0>w>>>0){ib=c[N>>2]|0;B=ib+(w*12|0)|0;if(B){g[B>>2]=ea(g[C>>2]);g[ib+(w*12|0)+4>>2]=ea(g[Ab+(Q*12|0)+4>>2]);g[ib+(w*12|0)+8>>2]=ea(g[Ab+(Q*12|0)+8>>2])}ib=w+1|0;c[s>>2]=ib;Rb=D;Sb=ib}else{_Ua(N,C)|0;Rb=c[ka>>2]|0;Sb=c[s>>2]|0}C=Ab+(u*12|0)|0;if((Rb&2147483647)>>>0>Sb>>>0){ib=c[N>>2]|0;D=ib+(Sb*12|0)|0;if(D){g[D>>2]=ea(g[C>>2]);g[ib+(Sb*12|0)+4>>2]=ea(g[Ab+(u*12|0)+4>>2]);g[ib+(Sb*12|0)+8>>2]=ea(g[Ab+(u*12|0)+8>>2])}ib=Sb+1|0;c[s>>2]=ib;Tb=Rb;Ub=ib}else{_Ua(N,C)|0;Tb=c[ka>>2]|0;Ub=c[s>>2]|0}C=hb<<24>>24!=0?Ua:Va;ib=Ab+(C*12|0)|0;if((Tb&2147483647)>>>0<=Ub>>>0){_Ua(N,ib)|0;break}D=c[N>>2]|0;w=D+(Ub*12|0)|0;if(w){g[w>>2]=ea(g[ib>>2]);g[D+(Ub*12|0)+4>>2]=ea(g[Ab+(C*12|0)+4>>2]);g[D+(Ub*12|0)+8>>2]=ea(g[Ab+(C*12|0)+8>>2])}c[s>>2]=Ub+1}while(0);do if((_n[c[(c[xb>>2]|0)+68>>2]&4095](xb,K|1)|0)<<16>>16!=127){C=Ab+(Va*12|0)|0;D=c[ka>>2]|0;ib=c[s>>2]|0;if((D&2147483647)>>>0>ib>>>0){w=c[N>>2]|0;B=w+(ib*12|0)|0;if(B){g[B>>2]=ea(g[C>>2]);g[w+(ib*12|0)+4>>2]=ea(g[Ab+(Va*12|0)+4>>2]);g[w+(ib*12|0)+8>>2]=ea(g[Ab+(Va*12|0)+8>>2])}w=ib+1|0;c[s>>2]=w;Vb=D;Wb=w}else{_Ua(N,C)|0;Vb=c[ka>>2]|0;Wb=c[s>>2]|0}C=Ab+(Ua*12|0)|0;if((Vb&2147483647)>>>0>Wb>>>0){w=c[N>>2]|0;D=w+(Wb*12|0)|0;if(D){g[D>>2]=ea(g[C>>2]);g[w+(Wb*12|0)+4>>2]=ea(g[Ab+(Ua*12|0)+4>>2]);g[w+(Wb*12|0)+8>>2]=ea(g[Ab+(Ua*12|0)+8>>2])}w=Wb+1|0;c[s>>2]=w;Xb=Vb;Yb=w}else{_Ua(N,C)|0;Xb=c[ka>>2]|0;Yb=c[s>>2]|0}C=hb<<24>>24!=0?u:Q;w=Ab+(C*12|0)|0;if((Xb&2147483647)>>>0<=Yb>>>0){_Ua(N,w)|0;break}D=c[N>>2]|0;ib=D+(Yb*12|0)|0;if(ib){g[ib>>2]=ea(g[w>>2]);g[D+(Yb*12|0)+4>>2]=ea(g[Ab+(C*12|0)+4>>2]);g[D+(Yb*12|0)+8>>2]=ea(g[Ab+(C*12|0)+8>>2])}c[s>>2]=Yb+1}while(0);t=t+1|0}while((t|0)!=(S|0));Qb=mb}if((Qb|0)==(Cb|0))break;else ya=Qb}}ya=(c[M>>2]|0)+Db|0;Cb=c[p>>2]|0;S=Cb+(ya*48|0)|0;Oa=ea(g[S>>2]);Ab=Cb+(ya*48|0)+4|0;Da=ea(g[Ab>>2]);xb=Cb+(ya*48|0)+8|0;ab=ea(g[xb>>2]);yb=Cb+(ya*48|0)+12|0;db=ea(g[yb>>2]);ta=Cb+(ya*48|0)+16|0;Ia=ea(g[ta>>2]);sa=Cb+(ya*48|0)+20|0;Fa=ea(g[sa>>2]);R=Cb+(ya*48|0)+24|0;Na=ea(g[R>>2]);wb=Cb+(ya*48|0)+28|0;Ka=ea(g[wb>>2]);mb=Cb+(ya*48|0)+32|0;Ha=ea(g[mb>>2]);t=Cb+(ya*48|0)+36|0;Ra=ea(g[t>>2]);Pa=Cb+(ya*48|0)+40|0;_a=ea(g[Pa>>2]);lb=Cb+(ya*48|0)+44|0;Qa=ea(g[lb>>2]);g[S>>2]=Ja;g[Ab>>2]=Ga;g[xb>>2]=cb;g[yb>>2]=Ya;g[ta>>2]=Ea;g[sa>>2]=bb;g[R>>2]=Za;g[wb>>2]=Ma;g[mb>>2]=Sa;g[t>>2]=La;g[Pa>>2]=jb;g[lb>>2]=$a;lb=c[s>>2]|0;Pa=c[N>>2]|0;if(zb>>>0<lb>>>0){t=zb;do{Nb=ea(g[Pa+(t*12|0)>>2]);Mb=ea(Oa*Nb);Lb=ea(Da*Nb);Kb=ea(ab*Nb);Nb=ea(g[Pa+(t*12|0)+4>>2]);Jb=ea(Mb+ea(db*Nb));Mb=ea(Lb+ea(Ia*Nb));Lb=ea(Kb+ea(Fa*Nb));Nb=ea(g[Pa+(t*12|0)+8>>2]);Kb=ea(Ra+ea(Jb+ea(Na*Nb)));Jb=ea(_a+ea(Mb+ea(Ka*Nb)));Mb=ea(Qa+ea(Lb+ea(Ha*Nb)));g[Y>>2]=Kb;g[f>>2]=Jb;g[F>>2]=Mb;mb=c[la>>2]|0;if((c[pa>>2]&2147483647)>>>0>mb>>>0){wb=c[O>>2]|0;R=wb+(mb*12|0)|0;if(R){g[R>>2]=Kb;g[wb+(mb*12|0)+4>>2]=Jb;g[wb+(mb*12|0)+8>>2]=Mb}c[la>>2]=mb+1}else _Ua(O,Y)|0;t=t+1|0}while((t|0)!=(lb|0))}t=Pa+(lb*12|0)|0;if((zb|0)<(lb|0)){mb=Pa+(zb*12|0)|0;do{Ha=ea(g[mb>>2]);Qa=ea(Ja*Ha);Ka=ea(Ga*Ha);_a=ea(cb*Ha);wb=mb+4|0;Ha=ea(g[wb>>2]);Na=ea(Qa+ea(Ya*Ha));Qa=ea(Ka+ea(Ea*Ha));Ka=ea(_a+ea(bb*Ha));R=mb+8|0;Ha=ea(g[R>>2]);_a=ea(jb+ea(Qa+ea(Ma*Ha)));Qa=ea($a+ea(Ka+ea(Sa*Ha)));g[mb>>2]=ea(La+ea(Na+ea(Za*Ha)));g[wb>>2]=_a;g[R>>2]=Qa;mb=mb+12|0}while(mb>>>0<t>>>0)}KUa(U,0,Z);c[_>>2]=0;j_a(V,0,_);Db=Db+1|0;if(Db>>>0>=(c[pb>>2]|0)>>>0){Ob=lb;Pb=Pa;break}else Bb=Bb+4|0}}Bb=c[ha>>2]|0;pb=mo[c[(c[Bb>>2]|0)+352>>2]&4095](Bb)|0;g[$>>2]=ea(g[pb>>2]);g[$+4>>2]=ea(g[pb+4>>2]);g[$+8>>2]=ea(g[pb+8>>2]);pb=c[ha>>2]|0;Bb=mo[c[(c[pb>>2]|0)+356>>2]&4095](pb)|0;Za=ea(Tka(fa));La=ea(Za+ea(g[Bb>>2]));Sa=ea(Za+ea(g[Bb+4>>2]));$a=ea(Za+ea(g[Bb+8>>2]));g[aa>>2]=La;g[aa+4>>2]=Sa;g[aa+8>>2]=$a;if(!Ob)Zb=0;else{Bb=c[O>>2]|0;pb=0;Db=0;while(1){_=pb+1|0;Z=pb+2|0;if((XPa($,aa,Pb+(pb*12|0)|0,Pb+(_*12|0)|0,Pb+(Z*12|0)|0)|0)==0?(XPa($,aa,Bb+(pb*12|0)|0,Bb+(_*12|0)|0,Bb+(Z*12|0)|0)|0)==0:0)_b=Db;else{g[Pb+(Db*12|0)>>2]=ea(g[Pb+(pb*12|0)>>2]);g[Pb+(Db*12|0)+4>>2]=ea(g[Pb+(pb*12|0)+4>>2]);g[Pb+(Db*12|0)+8>>2]=ea(g[Pb+(pb*12|0)+8>>2]);Y=Db+1|0;g[Pb+(Y*12|0)>>2]=ea(g[Pb+(_*12|0)>>2]);g[Pb+(Y*12|0)+4>>2]=ea(g[Pb+(_*12|0)+4>>2]);g[Pb+(Y*12|0)+8>>2]=ea(g[Pb+(_*12|0)+8>>2]);la=Db+2|0;g[Pb+(la*12|0)>>2]=ea(g[Pb+(Z*12|0)>>2]);g[Pb+(la*12|0)+4>>2]=ea(g[Pb+(Z*12|0)+4>>2]);g[Pb+(la*12|0)+8>>2]=ea(g[Pb+(Z*12|0)+8>>2]);g[Bb+(Db*12|0)>>2]=ea(g[Bb+(pb*12|0)>>2]);g[Bb+(Db*12|0)+4>>2]=ea(g[Bb+(pb*12|0)+4>>2]);g[Bb+(Db*12|0)+8>>2]=ea(g[Bb+(pb*12|0)+8>>2]);g[Bb+(Y*12|0)>>2]=ea(g[Bb+(_*12|0)>>2]);g[Bb+(Y*12|0)+4>>2]=ea(g[Bb+(_*12|0)+4>>2]);g[Bb+(Y*12|0)+8>>2]=ea(g[Bb+(_*12|0)+8>>2]);g[Bb+(la*12|0)>>2]=ea(g[Bb+(Z*12|0)>>2]);g[Bb+(la*12|0)+4>>2]=ea(g[Bb+(Z*12|0)+4>>2]);g[Bb+(la*12|0)+8>>2]=ea(g[Bb+(Z*12|0)+8>>2]);_b=Db+3|0}pb=pb+3|0;if(pb>>>0>=Ob>>>0){Zb=_b;break}else Db=_b}}_b=c[O>>2]|0;O=_b+(Zb*12|0)|0;Db=Pb+(Zb*12|0)|0;l_a(_b,O,ga);l_a(Pb,Db,ga);Zb=c[ha>>2]|0;ha=c[(c[Zb>>2]|0)+200>>2]|0;c[ba>>2]=_b;c[ba+4>>2]=O;c[ca>>2]=Pb;c[ca+4>>2]=Db;Db=c[fa+88>>2]|0;c[k+0>>2]=c[ba+0>>2];c[k+4>>2]=c[ba+4>>2];c[j+0>>2]=c[ca+0>>2];c[j+4>>2]=c[ca+4>>2];Dn[ha&511](Zb,k,j,Db);Db=c[J>>2]|0;if((Db&2147483647|0)!=0&(Db|0)>-1?(Db=c[V>>2]|0,(Db|0)!=0):0){V=mKa()|0;In[c[(c[V>>2]|0)+12>>2]&4095](V,Db)}Db=c[q>>2]|0;if((Db&2147483647|0)!=0&(Db|0)>-1?(Db=c[U>>2]|0,(Db|0)!=0):0){U=mKa()|0;In[c[(c[U>>2]|0)+12>>2]&4095](U,Db)}Db=c[pa>>2]|0;if(!((Db|0)<0|(Db&2147483647|0)==0|(_b|0)==0)){Db=mKa()|0;In[c[(c[Db>>2]|0)+12>>2]&4095](Db,_b)}_b=c[ka>>2]|0;if(!((_b|0)<0|(_b&2147483647|0)==0|(Pb|0)==0)){_b=mKa()|0;In[c[(c[_b>>2]|0)+12>>2]&4095](_b,Pb)}Pb=c[ja>>2]|0;if((Pb&2147483647|0)!=0&(Pb|0)>-1?(Pb=c[v>>2]|0,(Pb|0)!=0):0){v=mKa()|0;In[c[(c[v>>2]|0)+12>>2]&4095](v,Pb)}Pb=c[ia>>2]|0;if(!((Pb&2147483647|0)!=0&(Pb|0)>-1)){i=h;return}Pb=c[m>>2]|0;if(!Pb){i=h;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,Pb);i=h;return}function Bla(a){a=a|0;var b=0,d=0,e=0;b=i;d=q7(a)|0;e=c[a+52>>2]|0;Gea(d,e);Fea(d,e)|0;i=b;return}function Cla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=0;d=i;i=i+96|0;e=d;f=d+60|0;h=d+32|0;j=d+16|0;k=d+8|0;l=c[a+52>>2]|0;m=a+84|0;n=(c[m>>2]|0)+(c[l+72>>2]|0)|0;if(n>>>0>31){dKa(bKa()|0,2,478688,136,478784,e);i=d;return}o=c[b+28>>2]|0;xja(f,l);Ifa(h,b);p=ea(-ea(g[f>>2]));q=ea(-ea(g[f+4>>2]));r=ea(-ea(g[f+8>>2]));s=ea(g[f+12>>2]);t=ea(g[h+16>>2]);u=ea(t-ea(g[f+16>>2]));t=ea(g[h+20>>2]);v=ea(t-ea(g[f+20>>2]));t=ea(g[h+24>>2]);w=ea(u*ea(2.0));u=ea(v*ea(2.0));v=ea(ea(t-ea(g[f+24>>2]))*ea(2.0));t=ea(ea(s*s)+ea(-.5));x=ea(ea(ea(w*p)+ea(u*q))+ea(v*r));y=ea(ea(x*p)+ea(ea(t*w)+ea(s*ea(ea(v*q)-ea(u*r)))));z=ea(ea(x*q)+ea(ea(t*u)+ea(s*ea(ea(w*r)-ea(v*p)))));A=ea(ea(ea(t*v)+ea(s*ea(ea(u*p)-ea(w*q))))+ea(x*r));r=ea(g[o+72>>2]);g[j>>2]=y;g[j+4>>2]=z;g[j+8>>2]=A;g[j+12>>2]=r;o=c[l+28>>2]|0;l=c[(c[o>>2]|0)+164>>2]|0;c[k>>2]=j;c[k+4>>2]=j+16;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];Dn[l&511](o,e,n,n);n=c[m>>2]|0;c[m>>2]=n+1;m=a+116|0;c[e>>2]=0;o=a+120|0;l=c[o>>2]|0;if((c[a+124>>2]&2147483647)>>>0>l>>>0){a=(c[m>>2]|0)+(l<<2)|0;if(a)c[a>>2]=0;a=l+1|0;c[o>>2]=a;B=m;C=a}else{m_a(m,e)|0;B=m;C=c[o>>2]|0}o=C+-1|0;if(o>>>0>n>>>0){m=o;o=C;while(1){C=c[B>>2]|0;c[C+(m<<2)>>2]=c[C+(o+-2<<2)>>2];C=m+-1|0;if(C>>>0>n>>>0){e=m;m=C;o=e}else break}}c[(c[B>>2]|0)+(n<<2)>>2]=b;i=d;return}function Dla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+52>>2]|0;h=a+116|0;j=c[h>>2]|0;k=a+84|0;l=c[k>>2]|0;m=0;while(1){if(m>>>0>=l>>>0){n=9;break}o=j+(m<<2)|0;p=m+1|0;if((c[o>>2]|0)==(b|0))break;else m=p}if((n|0)==9){i=d;return}n=a+120|0;a=c[n>>2]|0;if(p>>>0<a>>>0){b=p;p=o;while(1){if(p)c[p>>2]=c[(c[h>>2]|0)+(b<<2)>>2];b=b+1|0;if((b|0)==(a|0))break;else p=p+4|0}}c[n>>2]=a+-1;c[k>>2]=l+-1;l=(c[g+72>>2]|0)+m|0;m=c[g+28>>2]|0;g=c[(c[m>>2]|0)+164>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[g&511](m,e,l,l+1|0);i=d;return}function Ela(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0;d=i;i=i+128|0;e=d;f=d+32|0;h=d+60|0;j=d+88|0;k=d+16|0;l=d+8|0;m=d+24|0;n=c[a+84>>2]|0;o=c[a+52>>2]|0;p=a+88|0;q=c[p>>2]|0;r=q+(c[o+76>>2]|0)|0;if(r>>>0>31){dKa(bKa()|0,2,478688,185,478840,e);i=d;return}s=(q<<1)+n+(c[o+72>>2]|0)|0;if(s>>>0>31){dKa(bKa()|0,2,478688,192,478896,e);i=d;return}q=c[b+28>>2]|0;xja(f,o);Ifa(h,b);t=ea(-ea(g[f>>2]));u=ea(-ea(g[f+4>>2]));v=ea(-ea(g[f+8>>2]));w=ea(g[f+12>>2]);x=ea(g[h+16>>2]);y=ea(x-ea(g[f+16>>2]));x=ea(g[h+20>>2]);z=ea(x-ea(g[f+20>>2]));x=ea(g[h+24>>2]);A=ea(y*ea(2.0));y=ea(z*ea(2.0));z=ea(ea(x-ea(g[f+24>>2]))*ea(2.0));x=ea(ea(w*w)+ea(-.5));B=ea(ea(ea(A*t)+ea(y*u))+ea(z*v));C=ea(ea(B*t)+ea(ea(x*A)+ea(w*ea(ea(z*u)-ea(y*v)))));D=ea(ea(B*u)+ea(ea(x*y)+ea(w*ea(ea(A*v)-ea(z*t)))));E=ea(ea(ea(x*z)+ea(w*ea(ea(y*t)-ea(A*u))))+ea(B*v));B=ea(g[h>>2]);A=ea(w*B);y=ea(g[h+12>>2]);z=ea(A+ea(y*t));A=ea(g[h+8>>2]);x=ea(z+ea(A*u));z=ea(g[h+4>>2]);F=ea(x-ea(z*v));x=ea(ea(ea(B*v)+ea(ea(y*u)+ea(w*z)))-ea(A*t));G=ea(ea(ea(z*t)+ea(ea(y*v)+ea(w*A)))-ea(B*u));H=ea(ea(ea(ea(w*y)-ea(B*t))-ea(z*u))-ea(A*v));v=ea(ea(g[q+76>>2])*ea(2.0));A=ea(ea(H*H)+ea(-.5));u=ea(x*ea(0.0));z=ea(G*ea(0.0));t=ea(z+ea(ea(v*F)+u));B=ea(ea(F*t)+ea(ea(v*A)+ea(H*ea(u-z))));z=ea(A*ea(0.0));A=ea(F*ea(0.0));F=ea(ea(z+ea(H*ea(ea(v*G)-A)))+ea(x*t));u=ea(ea(z+ea(H*ea(A-ea(v*x))))+ea(G*t));t=ea(g[q+72>>2]);G=ea(D-F);x=ea(E-u);g[j>>2]=ea(C-B);g[j+4>>2]=G;g[j+8>>2]=x;g[j+12>>2]=t;x=ea(D+F);F=ea(E+u);g[j+16>>2]=ea(C+B);g[j+20>>2]=x;g[j+24>>2]=F;g[j+28>>2]=t;q=o+28|0;o=c[q>>2]|0;h=c[(c[o>>2]|0)+164>>2]|0;c[k>>2]=j;c[k+4>>2]=j+32;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];Dn[h&511](o,e,s,s);c[l>>2]=s;c[l+4>>2]=s+1;s=c[q>>2]|0;q=c[(c[s>>2]|0)+172>>2]|0;c[m>>2]=l;c[m+4>>2]=l+8;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];Dn[q&511](s,e,r,r);r=c[p>>2]|0;c[p>>2]=r+1;p=r+n|0;n=a+116|0;c[e>>2]=0;r=a+120|0;s=c[r>>2]|0;if((c[a+124>>2]&2147483647)>>>0>s>>>0){a=(c[n>>2]|0)+(s<<2)|0;if(a)c[a>>2]=0;a=s+1|0;c[r>>2]=a;I=n;J=a}else{m_a(n,e)|0;I=n;J=c[r>>2]|0}r=J+-1|0;if(r>>>0>p>>>0){n=r;r=J;while(1){J=c[I>>2]|0;c[J+(n<<2)>>2]=c[J+(r+-2<<2)>>2];J=n+-1|0;if(J>>>0>p>>>0){e=n;n=J;r=e}else break}}c[(c[I>>2]|0)+(p<<2)>>2]=b;i=d;return}function Fla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+52>>2]|0;h=c[a+84>>2]|0;j=a+116|0;k=c[j>>2]|0;l=a+88|0;m=c[l>>2]|0;if(!m){i=d;return}else n=0;while(1){o=n+h|0;p=k+(o<<2)|0;q=n+1|0;if((c[p>>2]|0)==(b|0))break;if(q>>>0<m>>>0)n=q;else{r=9;break}}if((r|0)==9){i=d;return}r=o+1|0;o=a+120|0;a=c[o>>2]|0;if(r>>>0<a>>>0){b=r;r=p;while(1){if(r)c[r>>2]=c[(c[j>>2]|0)+(b<<2)>>2];b=b+1|0;if((b|0)==(a|0))break;else r=r+4|0}}c[o>>2]=a+-1;c[l>>2]=m+-1;m=(c[g+72>>2]|0)+(n<<1)+h|0;h=c[g+28>>2]|0;g=c[(c[h>>2]|0)+164>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[g&511](h,e,m,m+2|0);i=d;return}function Gla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0;d=i;i=i+112|0;e=d;f=d+32|0;h=d+60|0;j=d+88|0;k=d+16|0;l=d+8|0;m=d+24|0;n=c[a+52>>2]|0;o=a+92|0;p=(c[o>>2]|0)+(c[n+80>>2]|0)|0;if(p>>>0>31){dKa(bKa()|0,2,478688,246,478952,e);i=d;return}q=(c[a+84>>2]|0)+(c[a+88>>2]|0)|0;xja(f,n);Ifa(h,b);r=ea(-ea(g[f>>2]));s=ea(-ea(g[f+4>>2]));t=ea(-ea(g[f+8>>2]));u=ea(g[f+12>>2]);v=ea(g[h+16>>2]);w=ea(v-ea(g[f+16>>2]));v=ea(g[h+20>>2]);x=ea(v-ea(g[f+20>>2]));v=ea(g[h+24>>2]);y=ea(w*ea(2.0));w=ea(x*ea(2.0));x=ea(ea(v-ea(g[f+24>>2]))*ea(2.0));v=ea(ea(u*u)+ea(-.5));z=ea(ea(ea(y*r)+ea(w*s))+ea(x*t));A=ea(ea(z*r)+ea(ea(v*y)+ea(u*ea(ea(x*s)-ea(w*t)))));B=ea(ea(z*s)+ea(ea(v*w)+ea(u*ea(ea(y*t)-ea(x*r)))));C=ea(ea(ea(v*x)+ea(u*ea(ea(w*r)-ea(y*s))))+ea(z*t));z=ea(g[h>>2]);y=ea(u*z);w=ea(g[h+12>>2]);x=ea(y+ea(w*r));y=ea(g[h+8>>2]);v=ea(x+ea(y*s));x=ea(g[h+4>>2]);D=ea(v-ea(x*t));v=ea(ea(ea(z*t)+ea(ea(w*s)+ea(u*x)))-ea(y*r));E=ea(ea(ea(x*r)+ea(ea(w*t)+ea(u*y)))-ea(z*s));F=ea(ea(ea(ea(u*w)-ea(z*r))-ea(x*s))-ea(y*t));t=ea(ea(F*F)+ea(-.5));y=ea(v*ea(0.0));s=ea(E*ea(0.0));x=ea(s+ea(ea(D*ea(2.0))+y));r=ea(ea(D*x)+ea(ea(t*ea(2.0))+ea(F*ea(y-s))));s=ea(t*ea(0.0));t=ea(D*ea(0.0));D=ea(ea(s+ea(F*ea(ea(E*ea(2.0))-t)))+ea(v*x));y=ea(ea(s+ea(F*ea(t-ea(v*ea(2.0)))))+ea(E*x));x=ea(ea(0.0)-ea(ea(C*y)+ea(ea(A*r)+ea(B*D))));g[j>>2]=r;g[j+4>>2]=D;g[j+8>>2]=y;g[j+12>>2]=x;h=n+28|0;f=c[h>>2]|0;G=c[(c[f>>2]|0)+180>>2]|0;c[k>>2]=j;c[k+4>>2]=j+16;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];Dn[G&511](f,e,p,p);f=(c[o>>2]|0)+(c[n+84>>2]|0)|0;c[l>>2]=1<<p;p=c[h>>2]|0;h=c[(c[p>>2]|0)+188>>2]|0;c[m>>2]=l;c[m+4>>2]=l+4;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];Dn[h&511](p,e,f,f);f=c[o>>2]|0;c[o>>2]=f+1;o=q+f|0;f=a+116|0;c[e>>2]=0;q=a+120|0;p=c[q>>2]|0;if((c[a+124>>2]&2147483647)>>>0>p>>>0){a=(c[f>>2]|0)+(p<<2)|0;if(a)c[a>>2]=0;a=p+1|0;c[q>>2]=a;H=f;I=a}else{m_a(f,e)|0;H=f;I=c[q>>2]|0}q=I+-1|0;if(q>>>0>o>>>0){f=q;q=I;while(1){I=c[H>>2]|0;c[I+(f<<2)>>2]=c[I+(q+-2<<2)>>2];I=f+-1|0;if(I>>>0>o>>>0){e=f;f=I;q=e}else break}}c[(c[H>>2]|0)+(o<<2)>>2]=b;i=d;return}function Hla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+52>>2]|0;h=(c[a+88>>2]|0)+(c[a+84>>2]|0)|0;j=a+116|0;k=c[j>>2]|0;l=a+92|0;m=c[l>>2]|0;if(!m){i=d;return}else n=0;while(1){o=h+n|0;p=k+(o<<2)|0;q=n+1|0;if((c[p>>2]|0)==(b|0))break;if(q>>>0<m>>>0)n=q;else{r=9;break}}if((r|0)==9){i=d;return}r=o+1|0;o=a+120|0;a=c[o>>2]|0;if(r>>>0<a>>>0){b=r;r=p;while(1){if(r)c[r>>2]=c[(c[j>>2]|0)+(b<<2)>>2];b=b+1|0;if((b|0)==(a|0))break;else r=r+4|0}}c[o>>2]=a+-1;c[l>>2]=m+-1;m=(c[g+80>>2]|0)+n|0;n=c[g+28>>2]|0;g=c[(c[n>>2]|0)+180>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[g&511](n,e,m,m+1|0);i=d;return}function Ila(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0;d=i;i=i+192|0;e=d;f=d+32|0;h=d+60|0;j=d+88|0;k=d+16|0;l=d+8|0;m=d+24|0;n=a+92|0;o=c[n>>2]|0;p=c[a+52>>2]|0;q=a+96|0;r=(c[p+80>>2]|0)+o+((c[q>>2]|0)*6|0)|0;if((r+6|0)>>>0>32){dKa(bKa()|0,2,478688,298,479e3,e);i=d;return}s=c[a+88>>2]|0;t=c[a+84>>2]|0;u=c[b+28>>2]|0;xja(f,p);Ifa(h,b);v=ea(-ea(g[f>>2]));w=ea(-ea(g[f+4>>2]));x=ea(-ea(g[f+8>>2]));y=ea(g[f+12>>2]);z=ea(g[h+16>>2]);A=ea(z-ea(g[f+16>>2]));z=ea(g[h+20>>2]);B=ea(z-ea(g[f+20>>2]));z=ea(g[h+24>>2]);C=ea(A*ea(2.0));A=ea(B*ea(2.0));B=ea(ea(z-ea(g[f+24>>2]))*ea(2.0));z=ea(ea(y*y)+ea(-.5));D=ea(ea(ea(C*v)+ea(A*w))+ea(B*x));E=ea(ea(D*v)+ea(ea(z*C)+ea(y*ea(ea(B*w)-ea(A*x)))));F=ea(ea(D*w)+ea(ea(z*A)+ea(y*ea(ea(C*x)-ea(B*v)))));G=ea(ea(ea(z*B)+ea(y*ea(ea(A*v)-ea(C*w))))+ea(D*x));D=ea(g[h>>2]);C=ea(y*D);A=ea(g[h+12>>2]);B=ea(C+ea(A*v));C=ea(g[h+8>>2]);z=ea(B+ea(C*w));B=ea(g[h+4>>2]);H=ea(z-ea(B*x));z=ea(ea(ea(D*x)+ea(ea(A*w)+ea(y*B)))-ea(C*v));I=ea(ea(ea(B*v)+ea(ea(A*x)+ea(y*C)))-ea(D*w));J=ea(ea(ea(ea(y*A)-ea(D*v))-ea(B*w))-ea(C*x));x=ea(g[u+72>>2]);C=ea(g[u+76>>2]);w=ea(g[u+80>>2]);B=ea(-x);x=ea(ea(J*J)+ea(-.5));v=ea(H*ea(2.0));D=ea(z*ea(0.0));A=ea(I*ea(0.0));y=ea(A+ea(v+D));K=ea(x*ea(2.0));L=ea(J*ea(D-A));M=ea(ea(H*y)+ea(K+L));N=ea(x*ea(0.0));O=ea(I*ea(2.0));P=ea(H*ea(0.0));Q=ea(ea(N+ea(J*ea(O-P)))+ea(z*y));R=ea(z*ea(2.0));S=ea(ea(N+ea(J*ea(P-R)))+ea(I*y));y=ea(B-ea(ea(G*S)+ea(ea(E*M)+ea(F*Q))));g[j>>2]=M;g[j+4>>2]=Q;g[j+8>>2]=S;g[j+12>>2]=y;y=ea(H*ea(-2.0));S=ea(A+ea(y+D));Q=ea(x*ea(-2.0));x=ea(ea(H*S)+ea(Q+L));L=ea(I*ea(-2.0));M=ea(ea(N+ea(J*ea(L-P)))+ea(z*S));T=ea(z*ea(-2.0));U=ea(ea(N+ea(J*ea(P-T)))+ea(I*S));S=ea(B-ea(ea(G*U)+ea(ea(E*x)+ea(F*M))));g[j+16>>2]=x;g[j+20>>2]=M;g[j+24>>2]=U;g[j+28>>2]=S;S=ea(-C);C=ea(A+ea(P+R));U=ea(ea(H*C)+ea(N+ea(J*ea(D-O))));M=ea(J*ea(A-P));x=ea(ea(K+M)+ea(z*C));B=ea(ea(N+ea(J*ea(v-D)))+ea(I*C));C=ea(S-ea(ea(G*B)+ea(ea(E*U)+ea(F*x))));g[j+32>>2]=U;g[j+36>>2]=x;g[j+40>>2]=B;g[j+44>>2]=C;C=ea(A+ea(P+T));B=ea(ea(H*C)+ea(N+ea(J*ea(D-L))));x=ea(ea(Q+M)+ea(z*C));M=ea(ea(N+ea(J*ea(y-D)))+ea(I*C));C=ea(S-ea(ea(G*M)+ea(ea(E*B)+ea(F*x))));g[j+48>>2]=B;g[j+52>>2]=x;g[j+56>>2]=M;g[j+60>>2]=C;C=ea(-w);w=ea(P+D);M=ea(O+w);O=ea(ea(H*M)+ea(N+ea(J*ea(R-A))));R=ea(ea(N+ea(J*ea(A-v)))+ea(z*M));v=ea(J*ea(P-D));D=ea(ea(K+v)+ea(I*M));M=ea(C-ea(ea(G*D)+ea(ea(E*O)+ea(F*R))));g[j+64>>2]=O;g[j+68>>2]=R;g[j+72>>2]=D;g[j+76>>2]=M;M=ea(L+w);w=ea(ea(H*M)+ea(N+ea(J*ea(T-A))));T=ea(ea(N+ea(J*ea(A-y)))+ea(z*M));z=ea(ea(Q+v)+ea(I*M));M=ea(C-ea(ea(G*z)+ea(ea(E*w)+ea(F*T))));g[j+80>>2]=w;g[j+84>>2]=T;g[j+88>>2]=z;g[j+92>>2]=M;u=p+28|0;h=c[u>>2]|0;f=c[(c[h>>2]|0)+180>>2]|0;c[k>>2]=j;c[k+4>>2]=j+96;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];Dn[f&511](h,e,r,r);h=(c[n>>2]|0)+(c[p+84>>2]|0)+(c[q>>2]|0)|0;c[l>>2]=63<<r;r=c[u>>2]|0;u=c[(c[r>>2]|0)+188>>2]|0;c[m>>2]=l;c[m+4>>2]=l+4;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];Dn[u&511](r,e,h,h);h=c[q>>2]|0;c[q>>2]=h+1;q=s+o+t+h|0;h=a+116|0;c[e>>2]=0;t=a+120|0;o=c[t>>2]|0;if((c[a+124>>2]&2147483647)>>>0>o>>>0){a=(c[h>>2]|0)+(o<<2)|0;if(a)c[a>>2]=0;a=o+1|0;c[t>>2]=a;V=h;W=a}else{m_a(h,e)|0;V=h;W=c[t>>2]|0}t=W+-1|0;if(t>>>0>q>>>0){h=t;t=W;while(1){W=c[V>>2]|0;c[W+(h<<2)>>2]=c[W+(t+-2<<2)>>2];W=h+-1|0;if(W>>>0>q>>>0){e=h;h=W;t=e}else break}}c[(c[V>>2]|0)+(q<<2)>>2]=b;i=d;return}function Jla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+52>>2]|0;h=c[a+92>>2]|0;j=(c[a+88>>2]|0)+(c[a+84>>2]|0)+h|0;k=a+116|0;l=c[k>>2]|0;m=a+96|0;n=c[m>>2]|0;if(!n){i=d;return}else o=0;while(1){p=j+o|0;q=l+(p<<2)|0;r=o+1|0;if((c[q>>2]|0)==(b|0))break;if(r>>>0<n>>>0)o=r;else{s=9;break}}if((s|0)==9){i=d;return}s=p+1|0;p=a+120|0;a=c[p>>2]|0;if(s>>>0<a>>>0){b=s;s=q;while(1){if(s)c[s>>2]=c[(c[k>>2]|0)+(b<<2)>>2];b=b+1|0;if((b|0)==(a|0))break;else s=s+4|0}}c[p>>2]=a+-1;c[m>>2]=n+-1;n=(c[g+80>>2]|0)+(o*6|0)+h|0;h=c[g+28>>2]|0;g=c[(c[h>>2]|0)+180>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[g&511](h,e,n,n+6|0);i=d;return}function Kla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=0,X=0,Y=0,Z=0;d=i;i=i+224|0;e=d;f=d+24|0;h=d+120|0;j=d+92|0;k=d+148|0;l=d+8|0;m=d+72|0;n=d+176|0;o=d+192|0;p=d+200|0;q=d+208|0;r=a+92|0;s=a+96|0;t=(c[a+88>>2]|0)+(c[a+84>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0;u=c[a+52>>2]|0;v=c[b+28>>2]|0;w=v+100|0;x=c[w>>2]|0;y=mo[c[(c[x>>2]|0)+36>>2]&4095](x)|0;x=a+112|0;z=(c[r>>2]|0)+(c[u+80>>2]|0)+((c[s>>2]|0)*6|0)+(c[x>>2]|0)|0;if((z+y|0)>>>0>32){dKa(bKa()|0,2,478688,361,479048,e);i=d;return}xja(j,u);Ifa(k,b);A=ea(-ea(g[j>>2]));B=ea(-ea(g[j+4>>2]));C=ea(-ea(g[j+8>>2]));D=ea(g[j+12>>2]);E=ea(g[k+16>>2]);F=ea(E-ea(g[j+16>>2]));E=ea(g[k+20>>2]);G=ea(E-ea(g[j+20>>2]));E=ea(g[k+24>>2]);H=ea(F*ea(2.0));F=ea(G*ea(2.0));G=ea(ea(E-ea(g[j+24>>2]))*ea(2.0));E=ea(ea(D*D)+ea(-.5));I=ea(ea(ea(H*A)+ea(F*B))+ea(G*C));J=ea(ea(I*A)+ea(ea(E*H)+ea(D*ea(ea(G*B)-ea(F*C)))));K=ea(ea(I*B)+ea(ea(E*F)+ea(D*ea(ea(H*C)-ea(G*A)))));L=ea(ea(ea(E*G)+ea(D*ea(ea(F*A)-ea(H*B))))+ea(I*C));I=ea(g[k>>2]);H=ea(D*I);F=ea(g[k+12>>2]);G=ea(H+ea(F*A));H=ea(g[k+8>>2]);E=ea(G+ea(H*B));G=ea(g[k+4>>2]);M=ea(ea(ea(I*C)+ea(ea(F*B)+ea(D*G)))-ea(H*A));N=ea(ea(ea(G*A)+ea(ea(F*C)+ea(D*H)))-ea(I*B));O=ea(ea(ea(ea(D*F)-ea(I*A))-ea(G*B))-ea(H*C));g[h>>2]=ea(E-ea(G*C));g[h+4>>2]=M;g[h+8>>2]=N;g[h+12>>2]=O;g[h+16>>2]=J;g[h+20>>2]=K;g[h+24>>2]=L;i_a(f,h,v+72|0);c[l>>2]=0;v=l+4|0;c[v>>2]=0;h=l+8|0;c[h>>2]=0;if(y){n_a(l,y);L=ea(g[f>>2]);K=ea(g[f+4>>2]);J=ea(g[f+8>>2]);k=m+4|0;O=ea(g[f+12>>2]);N=ea(g[f+16>>2]);M=ea(g[f+20>>2]);j=m+8|0;C=ea(g[f+24>>2]);G=ea(g[f+28>>2]);E=ea(g[f+32>>2]);P=m+12|0;H=ea(g[f+36>>2]);B=ea(g[f+40>>2]);A=ea(g[f+44>>2]);f=n+4|0;Q=n+8|0;R=n+12|0;S=0;do{T=c[w>>2]|0;xo[c[(c[T>>2]|0)+40>>2]&2047](T,S,m)|0;I=ea(g[m>>2]);F=ea(I*L);D=ea(I*K);U=ea(I*J);I=ea(g[k>>2]);V=ea(F+ea(I*O));F=ea(D+ea(I*N));D=ea(U+ea(I*M));I=ea(g[j>>2]);U=ea(V+ea(I*C));V=ea(F+ea(I*G));F=ea(D+ea(I*E));I=ea(ea(g[P>>2])-ea(ea(ea(U*H)+ea(V*B))+ea(F*A)));g[n>>2]=U;g[f>>2]=V;g[Q>>2]=F;g[R>>2]=I;T=c[v>>2]|0;if((c[h>>2]&2147483647)>>>0>T>>>0){W=c[l>>2]|0;X=W+(T<<4)|0;if(X){g[X>>2]=U;g[W+(T<<4)+4>>2]=V;g[W+(T<<4)+8>>2]=F;g[W+(T<<4)+12>>2]=I}c[v>>2]=T+1}else h_a(l,n)|0;S=S+1|0}while((S|0)!=(y|0))}S=u+28|0;n=c[S>>2]|0;v=c[(c[n>>2]|0)+180>>2]|0;R=c[l>>2]|0;c[o>>2]=R;c[o+4>>2]=R+(y<<4);c[e+0>>2]=c[o+0>>2];c[e+4>>2]=c[o+4>>2];Dn[v&511](n,e,z,z);n=a+100|0;v=(c[r>>2]|0)+(c[u+84>>2]|0)+(c[s>>2]|0)+(c[n>>2]|0)|0;c[p>>2]=(1<<y)+-1<<z;z=c[S>>2]|0;S=c[(c[z>>2]|0)+188>>2]|0;c[q>>2]=p;c[q+4>>2]=p+4;c[e+0>>2]=c[q+0>>2];c[e+4>>2]=c[q+4>>2];Dn[S&511](z,e,v,v);c[x>>2]=(c[x>>2]|0)+y;y=c[n>>2]|0;c[n>>2]=y+1;n=t+y|0;y=a+116|0;c[e>>2]=0;t=a+120|0;x=c[t>>2]|0;if((c[a+124>>2]&2147483647)>>>0>x>>>0){a=(c[y>>2]|0)+(x<<2)|0;if(a)c[a>>2]=0;a=x+1|0;c[t>>2]=a;Y=y;Z=a}else{m_a(y,e)|0;Y=y;Z=c[t>>2]|0}t=Z+-1|0;if(t>>>0>n>>>0){y=t;t=Z;while(1){Z=c[Y>>2]|0;c[Z+(y<<2)>>2]=c[Z+(t+-2<<2)>>2];Z=y+-1|0;if(Z>>>0>n>>>0){e=y;y=Z;t=e}else break}}c[(c[Y>>2]|0)+(n<<2)>>2]=b;b=c[h>>2]|0;if((b|0)<0|(b&2147483647|0)==0|(R|0)==0){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,R);i=d;return}function Lla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+52>>2]|0;h=c[a+92>>2]|0;j=c[a+96>>2]|0;k=(c[a+88>>2]|0)+(c[a+84>>2]|0)+h+j|0;l=a+116|0;m=c[l>>2]|0;n=a+100|0;if(!(c[n>>2]|0)){i=d;return}o=0;p=(j*6|0)+h+(c[g+80>>2]|0)|0;while(1){q=k+o|0;h=m+(q<<2)|0;j=c[(c[(c[h>>2]|0)+28>>2]|0)+100>>2]|0;r=mo[c[(c[j>>2]|0)+36>>2]&4095](j)|0;if((c[h>>2]|0)==(b|0))break;o=o+1|0;if(o>>>0>=(c[n>>2]|0)>>>0){s=11;break}else p=r+p|0}if((s|0)==11){i=d;return}s=q+1|0;o=a+120|0;b=c[o>>2]|0;if(s>>>0<b>>>0){m=s;s=(c[l>>2]|0)+(q<<2)|0;while(1){if(s)c[s>>2]=c[(c[l>>2]|0)+(m<<2)>>2];m=m+1|0;if((m|0)==(b|0))break;else s=s+4|0}}c[o>>2]=b+-1;c[n>>2]=(c[n>>2]|0)+-1;n=c[g+28>>2]|0;g=c[(c[n>>2]|0)+180>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];Dn[g&511](n,e,p,r+p|0);p=a+112|0;c[p>>2]=(c[p>>2]|0)-r;i=d;return}function Mla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0;d=i;i=i+144|0;e=d+136|0;f=d+88|0;h=d+56|0;j=d+28|0;k=d;l=(c[a+88>>2]|0)+(c[a+84>>2]|0)+(c[a+92>>2]|0)+(c[a+96>>2]|0)+(c[a+100>>2]|0)|0;m=c[b+28>>2]|0;xja(j,c[a+52>>2]|0);Ifa(k,b);n=ea(-ea(g[j>>2]));o=ea(-ea(g[j+4>>2]));p=ea(-ea(g[j+8>>2]));q=ea(g[j+12>>2]);r=ea(g[k+16>>2]);s=ea(r-ea(g[j+16>>2]));r=ea(g[k+20>>2]);t=ea(r-ea(g[j+20>>2]));r=ea(g[k+24>>2]);u=ea(s*ea(2.0));s=ea(t*ea(2.0));t=ea(ea(r-ea(g[j+24>>2]))*ea(2.0));r=ea(ea(q*q)+ea(-.5));v=ea(ea(ea(u*n)+ea(s*o))+ea(t*p));w=ea(ea(v*n)+ea(ea(r*u)+ea(q*ea(ea(t*o)-ea(s*p)))));x=ea(ea(v*o)+ea(ea(r*s)+ea(q*ea(ea(u*p)-ea(t*n)))));y=ea(ea(ea(r*t)+ea(q*ea(ea(s*n)-ea(u*o))))+ea(v*p));v=ea(g[k>>2]);u=ea(q*v);s=ea(g[k+12>>2]);t=ea(u+ea(s*n));u=ea(g[k+8>>2]);r=ea(t+ea(u*o));t=ea(g[k+4>>2]);z=ea(ea(ea(v*p)+ea(ea(s*o)+ea(q*t)))-ea(u*n));A=ea(ea(ea(t*n)+ea(ea(s*p)+ea(q*u)))-ea(v*o));B=ea(ea(ea(ea(q*s)-ea(v*n))-ea(t*o))-ea(u*p));g[h>>2]=ea(r-ea(t*p));g[h+4>>2]=z;g[h+8>>2]=A;g[h+12>>2]=B;g[h+16>>2]=w;g[h+20>>2]=x;g[h+24>>2]=y;i_a(f,h,m+72|0);m=a+104|0;h=c[m>>2]|0;c[m>>2]=h+1;m=l+h|0;h=a+116|0;c[e>>2]=0;l=a+120|0;k=c[l>>2]|0;if((c[a+124>>2]&2147483647)>>>0>k>>>0){j=(c[h>>2]|0)+(k<<2)|0;if(j)c[j>>2]=0;j=k+1|0;c[l>>2]=j;C=h;D=j}else{m_a(h,e)|0;C=h;D=c[l>>2]|0}l=D+-1|0;if(l>>>0>m>>>0){h=l;l=D;while(1){D=c[C>>2]|0;c[D+(h<<2)>>2]=c[D+(l+-2<<2)>>2];D=h+-1|0;if(D>>>0>m>>>0){e=h;h=D;l=e}else break}}c[(c[C>>2]|0)+(m<<2)>>2]=b;b=a+128|0;m=a+132|0;C=c[m>>2]|0;if((c[a+136>>2]&2147483647)>>>0<=C>>>0){o_a(b,f)|0;i=d;return}a=c[b>>2]|0;b=a+(C*48|0)|0;if(b){g[b>>2]=ea(g[f>>2]);g[a+(C*48|0)+4>>2]=ea(g[f+4>>2]);g[a+(C*48|0)+8>>2]=ea(g[f+8>>2]);g[a+(C*48|0)+12>>2]=ea(g[f+12>>2]);g[a+(C*48|0)+16>>2]=ea(g[f+16>>2]);g[a+(C*48|0)+20>>2]=ea(g[f+20>>2]);g[a+(C*48|0)+24>>2]=ea(g[f+24>>2]);g[a+(C*48|0)+28>>2]=ea(g[f+28>>2]);g[a+(C*48|0)+32>>2]=ea(g[f+32>>2]);g[a+(C*48|0)+36>>2]=ea(g[f+36>>2]);g[a+(C*48|0)+40>>2]=ea(g[f+40>>2]);g[a+(C*48|0)+44>>2]=ea(g[f+44>>2])}c[m>>2]=C+1;i=d;return}function Nla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=(c[a+88>>2]|0)+(c[a+84>>2]|0)+(c[a+92>>2]|0)+(c[a+96>>2]|0)+(c[a+100>>2]|0)|0;f=a+116|0;h=c[f>>2]|0;j=a+104|0;k=c[j>>2]|0;if(!k){i=d;return}else l=0;while(1){m=e+l|0;n=h+(m<<2)|0;o=l+1|0;if((c[n>>2]|0)==(b|0))break;if(o>>>0<k>>>0)l=o;else{p=14;break}}if((p|0)==14){i=d;return}p=m+1|0;m=a+120|0;b=c[m>>2]|0;if(p>>>0<b>>>0){h=p;p=n;while(1){if(p)c[p>>2]=c[(c[f>>2]|0)+(h<<2)>>2];h=h+1|0;if((h|0)==(b|0))break;else p=p+4|0}}c[m>>2]=b+-1;b=a+132|0;m=c[b>>2]|0;if(o>>>0<m>>>0){p=c[a+128>>2]|0;a=o;o=p+(l*48|0)|0;while(1){if(o){g[o>>2]=ea(g[p+(a*48|0)>>2]);g[o+4>>2]=ea(g[p+(a*48|0)+4>>2]);g[o+8>>2]=ea(g[p+(a*48|0)+8>>2]);g[o+12>>2]=ea(g[p+(a*48|0)+12>>2]);g[o+16>>2]=ea(g[p+(a*48|0)+16>>2]);g[o+20>>2]=ea(g[p+(a*48|0)+20>>2]);g[o+24>>2]=ea(g[p+(a*48|0)+24>>2]);g[o+28>>2]=ea(g[p+(a*48|0)+28>>2]);g[o+32>>2]=ea(g[p+(a*48|0)+32>>2]);g[o+36>>2]=ea(g[p+(a*48|0)+36>>2]);g[o+40>>2]=ea(g[p+(a*48|0)+40>>2]);g[o+44>>2]=ea(g[p+(a*48|0)+44>>2])}a=a+1|0;if((a|0)==(m|0))break;else o=o+48|0}}c[b>>2]=m+-1;c[j>>2]=k+-1;i=d;return}function Ola(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0;d=i;i=i+112|0;e=d+104|0;f=d+56|0;h=d+28|0;j=d;k=(c[a+88>>2]|0)+(c[a+84>>2]|0)+(c[a+92>>2]|0)+(c[a+96>>2]|0)+(c[a+100>>2]|0)+(c[a+104>>2]|0)|0;l=c[b+28>>2]|0;xja(h,c[a+52>>2]|0);Ifa(j,b);m=ea(-ea(g[h>>2]));n=ea(-ea(g[h+4>>2]));o=ea(-ea(g[h+8>>2]));p=ea(g[h+12>>2]);q=ea(g[j+16>>2]);r=ea(q-ea(g[h+16>>2]));q=ea(g[j+20>>2]);s=ea(q-ea(g[h+20>>2]));q=ea(g[j+24>>2]);t=ea(r*ea(2.0));r=ea(s*ea(2.0));s=ea(ea(q-ea(g[h+24>>2]))*ea(2.0));q=ea(ea(p*p)+ea(-.5));u=ea(ea(ea(t*m)+ea(r*n))+ea(s*o));v=ea(ea(u*m)+ea(ea(q*t)+ea(p*ea(ea(s*n)-ea(r*o)))));w=ea(ea(u*n)+ea(ea(q*r)+ea(p*ea(ea(t*o)-ea(s*m)))));x=ea(ea(ea(q*s)+ea(p*ea(ea(r*m)-ea(t*n))))+ea(u*o));u=ea(g[j>>2]);t=ea(p*u);r=ea(g[j+12>>2]);s=ea(t+ea(r*m));t=ea(g[j+8>>2]);q=ea(s+ea(t*n));s=ea(g[j+4>>2]);y=ea(q-ea(s*o));q=ea(ea(ea(u*o)+ea(ea(r*n)+ea(p*s)))-ea(t*m));z=ea(ea(ea(s*m)+ea(ea(r*o)+ea(p*t)))-ea(u*n));A=ea(ea(ea(ea(p*r)-ea(u*m))-ea(s*n))-ea(t*o));o=ea(y+y);t=ea(q+q);n=ea(z+z);s=ea(o*A);m=ea(A*t);u=ea(A*n);A=ea(y*t);r=ea(y*n);p=ea(q*t);t=ea(q*n);q=ea(z*n);n=ea(ea(ea(1.0)-p)-q);z=ea(u+A);B=ea(r-m);C=ea(A-u);u=ea(ea(1.0)-ea(y*o));o=ea(u-q);q=ea(s+t);y=ea(r+m);m=ea(t-s);s=ea(u-p);g[f+36>>2]=v;g[f+40>>2]=w;g[f+44>>2]=x;p=ea(g[l+80>>2]);u=ea(p*n);g[f>>2]=u;n=ea(p*z);g[f+4>>2]=n;z=ea(p*B);g[f+8>>2]=z;B=ea(g[l+76>>2]);p=ea(B*C);g[f+12>>2]=p;C=ea(B*o);g[f+16>>2]=C;o=ea(B*q);g[f+20>>2]=o;q=ea(g[l+84>>2]);B=ea(q*y);g[f+24>>2]=B;y=ea(q*m);g[f+28>>2]=y;m=ea(q*s);g[f+32>>2]=m;l=a+108|0;j=c[l>>2]|0;c[l>>2]=j+1;l=k+j|0;j=a+116|0;c[e>>2]=0;k=a+120|0;h=c[k>>2]|0;if((c[a+124>>2]&2147483647)>>>0>h>>>0){D=(c[j>>2]|0)+(h<<2)|0;if(D)c[D>>2]=0;D=h+1|0;c[k>>2]=D;E=j;F=D}else{m_a(j,e)|0;E=j;F=c[k>>2]|0}k=F+-1|0;if(k>>>0>l>>>0){j=k;k=F;while(1){F=c[E>>2]|0;c[F+(j<<2)>>2]=c[F+(k+-2<<2)>>2];F=j+-1|0;if(F>>>0>l>>>0){e=j;j=F;k=e}else break}}c[(c[E>>2]|0)+(l<<2)>>2]=b;b=a+128|0;l=a+132|0;E=c[l>>2]|0;if((c[a+136>>2]&2147483647)>>>0<=E>>>0){o_a(b,f)|0;i=d;return}f=c[b>>2]|0;b=f+(E*48|0)|0;if(b){g[b>>2]=u;g[f+(E*48|0)+4>>2]=n;g[f+(E*48|0)+8>>2]=z;g[f+(E*48|0)+12>>2]=p;g[f+(E*48|0)+16>>2]=C;g[f+(E*48|0)+20>>2]=o;g[f+(E*48|0)+24>>2]=B;g[f+(E*48|0)+28>>2]=y;g[f+(E*48|0)+32>>2]=m;g[f+(E*48|0)+36>>2]=v;g[f+(E*48|0)+40>>2]=w;g[f+(E*48|0)+44>>2]=x}c[l>>2]=E+1;i=d;return}function Pla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=c[a+104>>2]|0;f=(c[a+88>>2]|0)+(c[a+84>>2]|0)+(c[a+92>>2]|0)+(c[a+96>>2]|0)+(c[a+100>>2]|0)+e|0;h=a+116|0;j=c[h>>2]|0;k=a+108|0;l=c[k>>2]|0;if(!l){i=d;return}else m=0;while(1){n=f+m|0;o=j+(n<<2)|0;p=m+1|0;if((c[o>>2]|0)==(b|0))break;if(p>>>0<l>>>0)m=p;else{q=14;break}}if((q|0)==14){i=d;return}q=n+1|0;n=a+120|0;b=c[n>>2]|0;if(q>>>0<b>>>0){j=q;q=o;while(1){if(q)c[q>>2]=c[(c[h>>2]|0)+(j<<2)>>2];j=j+1|0;if((j|0)==(b|0))break;else q=q+4|0}}c[n>>2]=b+-1;b=e+m|0;m=b+1|0;e=a+132|0;n=c[e>>2]|0;if(m>>>0<n>>>0){q=c[a+128>>2]|0;a=m;m=q+(b*48|0)|0;while(1){if(m){g[m>>2]=ea(g[q+(a*48|0)>>2]);g[m+4>>2]=ea(g[q+(a*48|0)+4>>2]);g[m+8>>2]=ea(g[q+(a*48|0)+8>>2]);g[m+12>>2]=ea(g[q+(a*48|0)+12>>2]);g[m+16>>2]=ea(g[q+(a*48|0)+16>>2]);g[m+20>>2]=ea(g[q+(a*48|0)+20>>2]);g[m+24>>2]=ea(g[q+(a*48|0)+24>>2]);g[m+28>>2]=ea(g[q+(a*48|0)+28>>2]);g[m+32>>2]=ea(g[q+(a*48|0)+32>>2]);g[m+36>>2]=ea(g[q+(a*48|0)+36>>2]);g[m+40>>2]=ea(g[q+(a*48|0)+40>>2]);g[m+44>>2]=ea(g[q+(a*48|0)+44>>2])}a=a+1|0;if((a|0)==(n|0))break;else m=m+48|0}}c[e>>2]=n+-1;c[k>>2]=l+-1;i=d;return}function Qla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;d=b+32|0;e=b+24|0;f=b+16|0;g=b+8|0;h=b;j=c[a+52>>2]|0;k=c[j+28>>2]|0;l=c[k>>2]|0;m=c[l+164>>2]|0;c[e>>2]=0;c[e+4>>2]=0;n=c[j+72>>2]|0;o=mo[c[l+168>>2]&4095](k)|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];Dn[m&511](k,d,n,o);o=c[k>>2]|0;n=c[o+180>>2]|0;c[f>>2]=0;c[f+4>>2]=0;m=c[j+80>>2]|0;e=mo[c[o+184>>2]&4095](k)|0;c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];Dn[n&511](k,d,m,e);e=c[k>>2]|0;m=c[e+196>>2]|0;c[g>>2]=0;c[g+4>>2]=0;n=c[j+88>>2]|0;j=mo[c[e+204>>2]&4095](k)|0;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];Dn[m&511](k,d,n,j);j=a+84|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;c[h>>2]=0;p_a(a+116|0,0,h);i=b;return}function Rla(a){a=a|0;var b=0,d=0,e=0;b=i;if(!a){d=0;i=b;return d|0}e=mKa()|0;d=Bn[c[(c[e>>2]|0)+8>>2]&255](e,a,3653512,479568,38)|0;i=b;return d|0}function Sla(a){a=a|0;var b=0,d=0;b=i;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function Tla(){var a=0;a=c[119912]|0;c[119912]=a+1;return a|0}function Ula(a,b){a=a|0;b=b|0;var c=0;b=i;if((a|0)==0?(a=Rla(24)|0,Bna(a),(a|0)!=0):0)c=a+4|0;else c=0;i=b;return c|0}function Vla(a,c){a=a|0;c=c|0;b[a>>1]=c;b[a+2>>1]=-1;g[a+4>>2]=ea(1.0);g[a+8>>2]=ea(1.0);g[a+12>>2]=ea(1.0);g[a+16>>2]=ea(1.0);return}function Wla(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,h=0,i=Im,j=Im,k=Im,l=Im;b[a>>1]=b[c>>1]|0;b[a+2>>1]=-1;d=a+4|0;g[d>>2]=ea(1.0);e=a+8|0;g[e>>2]=ea(1.0);f=a+12|0;g[f>>2]=ea(1.0);h=a+16|0;g[h>>2]=ea(1.0);i=ea(ea(1.0)-ea(g[c+4>>2]));a=i<ea(1.0);j=a?i:ea(1.0);a=j<ea(0.0);i=a?ea(0.0):j;if(i!=ea(0.0))k=ea(+ba(+(+i))/.6931471824645996);else k=ea(-128.0);g[d>>2]=k;k=ea(g[c+8>>2]);d=k<ea(1.0);i=d?k:ea(1.0);d=i<ea(0.0);k=d?ea(0.0):i;if(k!=ea(0.0))l=ea(+ba(+(+k))/.6931471824645996);else l=ea(-128.0);g[e>>2]=l;g[f>>2]=ea(ea(1.0)-ea(ea(1.0)/ea(g[c+12>>2])));g[h>>2]=ea(ea(1.0)-ea(ea(1.0)/ea(g[c+16>>2])));return}function Xla(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;c[a>>2]=d;d=a+4|0;c[d>>2]=e;e=a+8|0;m=a+12|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+232|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[a+248>>2]=1;c[a+252>>2]=0;c[a+256>>2]=0;c[a+260>>2]=0;q=a+272|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;q=a+452|0;r=a+488|0;c[a+532>>2]=0;PEi(a+308|0,0,132)|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;r=c[f>>2]|0;q=c[f+4>>2]|0;q_a(a,r,q);f=q-r>>4;q=f+3|0;if((c[a+16>>2]&2147483647)>>>0<q>>>0)r_a(e,q);s_a(e,f);a=c[e>>2]|0;s=c[m>>2]|0;t=a+(s<<4)|0;if((s|0)>0){s=a;a=r;while(1){if(s){g[s>>2]=ea(g[a>>2]);g[s+4>>2]=ea(g[a+4>>2]);g[s+8>>2]=ea(g[a+8>>2]);g[s+12>>2]=ea(g[a+12>>2])}s=s+16|0;if(s>>>0>=t>>>0)break;else a=a+16|0}};c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;t_a(e,q,j);c[o>>2]=0;j=c[m>>2]|0;if((c[p>>2]&2147483647)>>>0<j>>>0){r_a(n,j);u=c[m>>2]|0}else u=j;j=c[n>>2]|0;m=j+(u<<4)|0;if((u|0)<=0){c[o>>2]=u;t_a(e,f,k);t_a(n,f,l);v=c[d>>2]|0;w=v+8|0;x=b[w>>1]|0;y=x+1<<16>>16;b[w>>1]=y;i=h;return}p=j;j=c[e>>2]|0;while(1){if(p){g[p>>2]=ea(g[j>>2]);g[p+4>>2]=ea(g[j+4>>2]);g[p+8>>2]=ea(g[j+8>>2]);g[p+12>>2]=ea(g[j+12>>2])}p=p+16|0;if(p>>>0>=m>>>0)break;else j=j+16|0}c[o>>2]=u;t_a(e,f,k);t_a(n,f,l);v=c[d>>2]|0;w=v+8|0;x=b[w>>1]|0;y=x+1<<16>>16;b[w>>1]=y;i=h;return}function Yla(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;c[a>>2]=d;d=a+4|0;c[d>>2]=c[e+4>>2];g=a+8|0;h=a+20|0;j=a+232|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[a+248>>2]=1;u_a(a+252|0,e+252|0);j=a+272|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;k=a+308|0;l=a+332|0;m=a+344|0;n=e+344|0;o=k+0|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));v_a(m,n);w_a(a+356|0,e+356|0);w_a(a+368|0,e+368|0);c[a+380>>2]=0;c[a+384>>2]=0;c[a+388>>2]=0;w_a(a+392|0,e+392|0);w_a(a+404|0,e+404|0);x_a(a+416|0,e+416|0);x_a(a+428|0,e+428|0);y_a(a+452|0,e+452|0);w_a(a+464|0,e+464|0);c[a+476>>2]=c[e+476>>2];z_a(a+488|0,e+488|0);w_a(a+500|0,e+500|0);A_a(a,e);B_a(g,e+8|0);B_a(h,e+20|0);B_a(j,e+272|0);B_a(a+284|0,e+284|0);B_a(k,e+308|0);B_a(a+320|0,e+320|0);B_a(l,e+332|0);e=(c[d>>2]|0)+8|0;b[e>>1]=(b[e>>1]|0)+1<<16>>16;i=f;return}function Zla(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;e=(c[a+4>>2]|0)+8|0;b[e>>1]=(b[e>>1]|0)+-1<<16>>16;e=a+500|0;f=c[a+508>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[e>>2]|0,(f|0)!=0):0)VJa(e,f+(0-(c[f+-4>>2]|0))|0);f=a+488|0;e=c[a+496>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1)VJa(f,c[f>>2]|0);f=a+464|0;e=c[a+472>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[f>>2]|0,(e|0)!=0):0)VJa(f,e+(0-(c[e+-4>>2]|0))|0);e=a+452|0;f=c[a+460>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1)VJa(e,c[e>>2]|0);e=a+428|0;f=c[a+436>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1)VJa(e,c[e>>2]|0);e=a+416|0;f=c[a+424>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1)VJa(e,c[e>>2]|0);e=a+404|0;f=c[a+412>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[e>>2]|0,(f|0)!=0):0)VJa(e,f+(0-(c[f+-4>>2]|0))|0);f=a+392|0;e=c[a+400>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[f>>2]|0,(e|0)!=0):0)VJa(f,e+(0-(c[e+-4>>2]|0))|0);e=a+380|0;f=c[a+388>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1)VJa(e,c[e>>2]|0);e=a+368|0;f=c[a+376>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[e>>2]|0,(f|0)!=0):0)VJa(e,f+(0-(c[f+-4>>2]|0))|0);f=a+356|0;e=c[a+364>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[f>>2]|0,(e|0)!=0):0)VJa(f,e+(0-(c[e+-4>>2]|0))|0);e=a+344|0;f=c[a+352>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1)VJa(e,c[e>>2]|0);e=a+332|0;f=c[a+340>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[e>>2]|0,(f|0)!=0):0)VJa(e,f+(0-(c[f+-4>>2]|0))|0);f=a+308|0;e=a+320|0;g=c[a+328>>2]|0;if((g&2147483647|0)!=0&(g|0)>-1?(g=c[e>>2]|0,(g|0)!=0):0)VJa(e,g+(0-(c[g+-4>>2]|0))|0);g=c[a+316>>2]|0;if((g&2147483647|0)!=0&(g|0)>-1?(g=c[f>>2]|0,(g|0)!=0):0)VJa(f,g+(0-(c[g+-4>>2]|0))|0);g=a+272|0;f=a+284|0;e=c[a+292>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[f>>2]|0,(e|0)!=0):0)VJa(f,e+(0-(c[e+-4>>2]|0))|0);e=c[a+280>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[g>>2]|0,(e|0)!=0):0)VJa(g,e+(0-(c[e+-4>>2]|0))|0);e=a+252|0;g=c[a+260>>2]|0;if((g&2147483647|0)!=0&(g|0)>-1)VJa(e,c[e>>2]|0);e=a+232|0;g=c[a+240>>2]|0;if((g&2147483647|0)!=0&(g|0)>-1)VJa(e,c[e>>2]|0);e=a+20|0;g=c[a+28>>2]|0;do if((g&2147483647|0)!=0&(g|0)>-1){f=c[e>>2]|0;if(!f)break;VJa(e,f+(0-(c[f+-4>>2]|0))|0)}while(0);e=a+8|0;g=c[a+16>>2]|0;if(!((g&2147483647|0)!=0&(g|0)>-1)){i=d;return}g=c[e>>2]|0;if(!g){i=d;return}VJa(e,g+(0-(c[g+-4>>2]|0))|0);i=d;return}function _la(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+12>>2]|0;b=d+12|0;h=d+20|0;if(!(c[h>>2]&2147483647)){c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;t_a(b,g+3&-4,f)}s_a(b,g);g=c[b>>2]|0;f=d+16|0;j=c[f>>2]|0;c[a>>2]=g;c[a+4>>2]=g+(j<<4);a=d+4|0;if(c[a>>2]|0){i=e;return}k=c[d>>2]|0;c[d>>2]=g;c[b>>2]=k;c[a>>2]=j;c[f>>2]=0;f=d+8|0;d=c[f>>2]|0;c[f>>2]=c[h>>2];c[h>>2]=d;i=e;return}function $la(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+12|0;e=b;f=c[a>>2]|0;c[d>>2]=f;c[a>>2]=0;g=a+4|0;c[d+4>>2]=c[g>>2];c[g>>2]=0;g=a+8|0;h=c[g>>2]|0;c[d+8>>2]=h;c[g>>2]=0;if(!((h|0)<0|(h&2147483647|0)==0|(f|0)==0))VJa(d,f+(0-(c[f+-4>>2]|0))|0);f=a+12|0;d=c[f>>2]|0;c[e>>2]=d;c[f>>2]=0;f=a+16|0;c[e+4>>2]=c[f>>2];c[f>>2]=0;f=a+20|0;a=c[f>>2]|0;c[e+8>>2]=a;c[f>>2]=0;if((a|0)<0|(a&2147483647|0)==0|(d|0)==0){i=b;return}VJa(e,d+(0-(c[d+-4>>2]|0))|0);i=b;return}function ama(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function bma(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[b>>2]|0)+20>>2]&4095](b,a+4|0)|0;i=d;return e|0}function cma(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[b>>2]|0)+20>>2]&4095](b,a)|0;i=d;return e|0}function dma(a){a=a|0;return c[a+28>>2]|0}function ema(a){a=a|0;return c[a+24>>2]|0}function fma(a){a=a|0;return}function gma(a){a=a|0;return}function hma(a){a=a|0;return}function ima(a){a=a|0;return}function jma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+24>>2]|0;g=f+((mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0)<<4)|0;c[b>>2]=f;c[b+4>>2]=g;c[b+8>>2]=d+4;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;g=d+4|0;a[g>>0]=1;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;g=b+20|0;a[g>>0]=28;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;b=g+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function kma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d+-4|0;g=c[d+20>>2]|0;h=g+((mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0)<<4)|0;c[b>>2]=g;c[b+4>>2]=h;c[b+8>>2]=d;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;h=d+4|0;a[h>>0]=1;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;h=b+20|0;a[h>>0]=28;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;b=h+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function lma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+24>>2]|0;g=f+((mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0)<<4)|0;c[b>>2]=f;c[b+4>>2]=g;c[b+8>>2]=d+4;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;g=d+4|0;a[g>>0]=1;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;g=b+20|0;a[g>>0]=28;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;b=g+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function mma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d+-4|0;g=c[d+20>>2]|0;h=g+((mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0)<<4)|0;c[b>>2]=g;c[b+4>>2]=h;c[b+8>>2]=d;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;h=d+4|0;a[h>>0]=1;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;h=b+20|0;a[h>>0]=28;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;b=h+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function nma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+36>>2]|0;g=f+((mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0)<<4)|0;c[b>>2]=f;c[b+4>>2]=g;c[b+8>>2]=d+4;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;g=d+4|0;a[g>>0]=1;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;g=b+20|0;a[g>>0]=28;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;b=g+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function oma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d+-4|0;g=c[d+32>>2]|0;h=g+((mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0)<<4)|0;c[b>>2]=g;c[b+4>>2]=h;c[b+8>>2]=d;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;h=d+4|0;a[h>>0]=1;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;h=b+20|0;a[h>>0]=28;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;b=h+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function pma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+36>>2]|0;g=f+((mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0)<<4)|0;c[b>>2]=f;c[b+4>>2]=g;c[b+8>>2]=d+4;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;g=d+4|0;a[g>>0]=1;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;g=b+20|0;a[g>>0]=28;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;b=g+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function qma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d+-4|0;g=c[d+32>>2]|0;h=g+((mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0)<<4)|0;c[b>>2]=g;c[b+4>>2]=h;c[b+8>>2]=d;d=b+12|0;a[d>>0]=24;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;h=d+4|0;a[h>>0]=1;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;h=b+20|0;a[h>>0]=28;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;b=h+4|0;a[b>>0]=1;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;i=e;return}function rma(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function sma(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function tma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+20|0;f=d;h=a+268|0;Vla(e,-1);C_a(h,0,e);e=c[b>>2]|0;j=c[b+4>>2]|0;if(e>>>0>=j>>>0){k=a+540|0;c[k>>2]=0;i=d;return}l=a+276|0;m=a+272|0;n=e;do{do if(ea(g[n+4>>2])>ea(0.0)){Wla(f,n);e=c[m>>2]|0;if((c[l>>2]&2147483647)>>>0<=e>>>0){D_a(h,f)|0;break}o=(c[h>>2]|0)+(e*20|0)|0;if(!o)p=e;else{c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];c[o+16>>2]=c[f+16>>2];p=c[m>>2]|0}c[m>>2]=p+1}while(0);n=n+20|0}while(n>>>0<j>>>0);c[b>>2]=n;k=a+540|0;c[k>>2]=0;i=d;return}function uma(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];tma(a+-4|0,e);i=d;return}function vma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+504|0;f=c[b>>2]|0;E_a(e,(c[b+4>>2]|0)-f>>2);b=c[e>>2]|0;e=c[a+508>>2]|0;g=b+(e<<2)|0;if((e|0)>0){h=b;j=f}else{k=a+540|0;c[k>>2]=0;i=d;return}while(1){if(h)c[h>>2]=c[j>>2];h=h+4|0;if(h>>>0>=g>>>0)break;else j=j+4|0}k=a+540|0;c[k>>2]=0;i=d;return}function wma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b>>2]|0;f=a+500|0;E_a(f,(c[b+4>>2]|0)-e>>2);b=c[f>>2]|0;f=c[a+504>>2]|0;g=b+(f<<2)|0;if((f|0)>0){h=b;j=e}else{k=a+536|0;c[k>>2]=0;i=d;return}while(1){if(h)c[h>>2]=c[j>>2];h=h+4|0;if(h>>>0>=g>>>0)break;else j=j+4|0}k=a+536|0;c[k>>2]=0;i=d;return}function xma(a){a=a|0;return c[a+492>>2]|0}function yma(a){a=a|0;return c[a+488>>2]|0}function zma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=b+348|0;g=b+352|0;h=c[g>>2]|0;if(!h){j=c[b+28>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;t_a(f,j,e);k=c[g>>2]|0}else k=h;c[b+540>>2]=0;b=c[f>>2]|0;c[a>>2]=b;c[a+4>>2]=b+(k<<4);i=d;return}function Ama(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=b+344|0;g=b+348|0;h=c[g>>2]|0;if(!h){j=c[b+24>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;t_a(f,j,e);k=c[g>>2]|0}else k=h;c[b+536>>2]=0;b=c[f>>2]|0;c[a>>2]=b;c[a+4>>2]=b+(k<<4);i=d;return}function Bma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=a+348|0;f=c[e>>2]|0;c[d>>2]=f;c[e>>2]=0;e=a+352|0;c[d+4>>2]=c[e>>2];c[e>>2]=0;e=a+356|0;g=c[e>>2]|0;c[d+8>>2]=g;c[e>>2]=0;if((g|0)<0|(g&2147483647|0)==0|(f|0)==0){h=a+540|0;c[h>>2]=0;i=b;return}VJa(d,f+(0-(c[f+-4>>2]|0))|0);h=a+540|0;c[h>>2]=0;i=b;return}function Cma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=a+344|0;f=c[e>>2]|0;c[d>>2]=f;c[e>>2]=0;e=a+348|0;c[d+4>>2]=c[e>>2];c[e>>2]=0;e=a+352|0;g=c[e>>2]|0;c[d+8>>2]=g;c[e>>2]=0;if((g|0)<0|(g&2147483647|0)==0|(f|0)==0){h=a+536|0;c[h>>2]=0;i=b;return}VJa(d,f+(0-(c[f+-4>>2]|0))|0);h=a+536|0;c[h>>2]=0;i=b;return}function Dma(a,d,f){a=a|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im;h=i;i=i+112|0;j=h+88|0;k=h+48|0;l=h+8|0;m=h+96|0;n=h;o=h+72|0;p=h+16|0;q=h+32|0;r=a+492|0;c[r>>2]=0;s=c[a+28>>2]|0;t=d;u=c[t>>2]|0;v=c[t+4>>2]|0;t=l;c[t>>2]=u;c[t+4>>2]=v;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];Xoa(k,j);Yoa(k,s&65535,4);b[m>>1]=s;b[m+2>>1]=s+1;b[m+4>>1]=s+2;b[m+6>>1]=0;s=k+12|0;j=c[s>>2]|0;l=c[k+16>>2]|0;v=j+(l<<2)|0;t=c[k>>2]|0;w=a+468|0;F_a(w,0,h+104|0);x=((c[d+4>>2]|0)-u>>4)+((l<<2>>2)*3|0)|0;u=a+476|0;if((c[u>>2]&2147483647)>>>0<x>>>0)G_a(w,x);if(!l){y=w;z=a+472|0}else{l=a+472|0;x=n+2|0;d=n+4|0;A=n+6|0;B=j;j=t;while(1){t=c[B>>2]|0;C=j+(t<<4)|0;if(!t)D=j;else{E=((t<<4)+-16|0)>>>4;t=j;do{b[n>>1]=c[t>>2];b[x>>1]=c[t+4>>2];b[d>>1]=c[t+8>>2];b[A>>1]=c[t+12>>2];F=c[l>>2]|0;if((c[u>>2]&2147483647)>>>0>F>>>0){G=(c[w>>2]|0)+(F<<3)|0;if(!G)H=F;else{F=n;I=c[F>>2]|0;J=c[F+4>>2]|0;F=G;G=F;b[G>>1]=I;b[G+2>>1]=I>>>16;I=F+4|0;b[I>>1]=J;b[I+2>>1]=J>>>16;H=c[l>>2]|0}c[l>>2]=H+1}else H_a(w,n)|0;t=t+16|0;c[r>>2]=(c[r>>2]|0)+1}while((t|0)!=(C|0));D=j+(E+1<<4)|0}F_a(w,(c[l>>2]|0)+3&-4,m);B=B+4|0;if((B|0)==(v|0)){y=w;z=l;break}else j=D}}D=c[y>>2]|0;j=c[z>>2]|0;l=o+4|0;if((j|0)>=0){w=j<<3;j=w>>3;c[l>>2]=j;v=o+8|0;c[v>>2]=j;if(j){j=UJa(o,w,537640,558)|0;w=c[l>>2]|0;c[o>>2]=j;B=j+(w<<3)|0;if((w|0)>0){m=j;r=D;while(1){if(m){D=r;n=D;H=e[n>>1]|e[n+2>>1]<<16;n=D+4|0;D=e[n>>1]|e[n+2>>1]<<16;n=m;A=n;b[A>>1]=H;b[A+2>>1]=H>>>16;H=n+4|0;b[H>>1]=D;b[H+2>>1]=D>>>16}m=m+8|0;if(m>>>0>=B>>>0)break;else r=r+8|0}K=v;L=c[o>>2]|0;M=c[l>>2]|0}else{K=v;L=j;M=w}}else N=19}else{c[l>>2]=0;c[o+8>>2]=0;N=19}if((N|0)==19){c[o>>2]=0;K=o+8|0;L=0;M=0}N=c[y>>2]|0;c[o>>2]=N;c[y>>2]=L;c[l>>2]=c[z>>2];c[z>>2]=M;M=c[K>>2]|0;z=c[u>>2]|0;c[K>>2]=z;c[u>>2]=M;if((z&2147483647|0)!=0&(z|0)>-1)VJa(o,N);N=a+480|0;o=c[N>>2]|0;c[p>>2]=o;c[N>>2]=0;z=a+484|0;c[p+4>>2]=c[z>>2];c[z>>2]=0;M=a+488|0;a=c[M>>2]|0;c[p+8>>2]=a;c[M>>2]=0;if((a|0)<0|(a&2147483647|0)==0|(o|0)==0)O=0;else{VJa(p,o+(0-(c[o+-4>>2]|0))|0);O=c[M>>2]&2147483647}o=c[f+4>>2]|0;p=c[f>>2]|0;a=(o-p|0)/12|0;if(O>>>0<a>>>0)r_a(N,a);if(p>>>0<o>>>0){a=q+4|0;O=q+8|0;u=q+12|0;K=p;do{P=ea(g[K>>2]);Q=ea(g[K+4>>2]);R=ea(g[K+8>>2]);S=ea(ea(1.0)/ea(ea(ea(P*P)+ea(Q*Q))+ea(R*R)));g[q>>2]=P;g[a>>2]=Q;g[O>>2]=R;g[u>>2]=S;p=c[z>>2]|0;if((c[M>>2]&2147483647)>>>0>p>>>0){l=c[N>>2]|0;L=l+(p<<4)|0;if(L){g[L>>2]=P;g[l+(p<<4)+4>>2]=Q;g[l+(p<<4)+8>>2]=R;g[l+(p<<4)+12>>2]=S}c[z>>2]=p+1}else I_a(N,q)|0;K=K+12|0}while(K>>>0<o>>>0);c[f>>2]=K}K=c[k+20>>2]|0;if((K&2147483647|0)!=0&(K|0)>-1)VJa(s,c[s>>2]|0);s=c[k+8>>2]|0;if(!((s&2147483647|0)!=0&(s|0)>-1)){i=h;return}VJa(k,c[k>>2]|0);i=h;return}function Ema(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];Dma(a+-4|0,g,f);i=e;return}function Fma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;c[b>>2]=c[d+12>>2];c[b+4>>2]=c[d+8>>2];c[b+8>>2]=c[d+20>>2];h=d+32|0;j=ea(g[h>>2]);k=d+44|0;g[b+12>>2]=ea(j-ea(g[k>>2]));j=ea(g[h>>2]);g[b+24>>2]=ea(j+ea(g[k>>2]));k=d+36|0;j=ea(g[k>>2]);h=d+48|0;g[b+16>>2]=ea(j-ea(g[h>>2]));j=ea(g[k>>2]);g[b+28>>2]=ea(j+ea(g[h>>2]));h=d+40|0;j=ea(g[h>>2]);k=d+52|0;g[b+20>>2]=ea(j-ea(g[k>>2]));j=ea(g[h>>2]);g[b+32>>2]=ea(j+ea(g[k>>2]));g[b+36>>2]=ea(0.0);k=c[d+256>>2]|0;if(!k)l=0;else l=c[d+252>>2]|0;c[b+64>>2]=l;c[b+68>>2]=l+(k*20|0);c[b+72>>2]=c[e+20>>2];c[b+76>>2]=c[e+24>>2];c[b+80>>2]=c[e+32>>2];c[b+84>>2]=c[e+36>>2];c[b+88>>2]=c[e+44>>2];c[b+92>>2]=c[e+48>>2];c[b+96>>2]=c[e+56>>2];c[b+100>>2]=c[e+60>>2];j=ea(g[d+144>>2]);m=ea(ea(j*ea(g[d+228>>2]))*ea(.693147182));c[b+104>>2]=c[e+68>>2];c[b+108>>2]=c[e+72>>2];g[b+112>>2]=ea(1.0-+aa(+(+ea(m*ea(g[d+264>>2])))));j=ea(g[d+268>>2]);g[b+116>>2]=ea(j*ea(g[e+80>>2]));if(!(c[d+276>>2]|0))n=0;else n=c[d+272>>2]|0;c[b+120>>2]=n;if(!(c[d+288>>2]|0))o=0;else o=c[d+284>>2]|0;c[b+124>>2]=o;g[b+128>>2]=ea(1.0-+aa(+(+ea(m*ea(g[d+304>>2])))));if(!(c[d+312>>2]|0))p=0;else p=c[d+308>>2]|0;c[b+132>>2]=p;if(!(c[d+324>>2]|0))q=0;else q=c[d+320>>2]|0;c[b+136>>2]=q;if(!(c[d+336>>2]|0))r=0;else r=c[d+332>>2]|0;c[b+140>>2]=r;r=c[d+360>>2]|0;if(!r)s=0;else s=c[d+356>>2]|0;c[b+144>>2]=s;if(!(c[d+372>>2]|0))t=s;else t=c[d+368>>2]|0;c[b+148>>2]=t;c[b+152>>2]=r;r=c[d+348>>2]|0;if(!r)u=0;else u=c[d+344>>2]|0;c[b+156>>2]=u;c[b+160>>2]=r;r=c[d+396>>2]|0;if(!r)v=0;else v=c[d+392>>2]|0;c[b+164>>2]=v;if(!(c[d+408>>2]|0))w=v;else w=c[d+404>>2]|0;c[b+168>>2]=w;c[b+172>>2]=r;r=c[d+384>>2]|0;if(!r)x=0;else x=c[d+380>>2]|0;c[b+176>>2]=x;c[b+180>>2]=r;r=c[d+420>>2]|0;if(!r)y=0;else y=c[d+416>>2]|0;c[b+184>>2]=y;if(!(c[d+432>>2]|0))z=y;else z=c[d+428>>2]|0;c[b+188>>2]=z;c[b+192>>2]=(r>>>0)/3|0;r=c[d+456>>2]|0;if(!r)A=0;else A=c[d+452>>2]|0;c[b+196>>2]=A;c[b+200>>2]=A+(r<<2<<1);r=c[d+468>>2]|0;if(!r)B=0;else B=c[d+464>>2]|0;c[b+204>>2]=B;c[b+208>>2]=r;a[b+212>>0]=a[d+440>>0]|0;g[b+220>>2]=ea(g[d+444>>2]);g[b+216>>2]=ea(g[d+448>>2]);g[b+224>>2]=ea(g[d+480>>2]);g[b+228>>2]=ea(1.0-+aa(+(+ea(m*ea(g[d+484>>2])))));r=d+492|0;if(c[r>>2]|0){B=c[d+488>>2]|0;c[b+236>>2]=B;if(!B)C=36;else D=r}else{c[b+236>>2]=0;C=36}if((C|0)==36)D=b;c[b+232>>2]=c[D>>2];if(!(c[d+504>>2]|0)){E=0;F=b+240|0;c[F>>2]=E;G=d+524|0;H=c[G>>2]|0;I=b+244|0;c[I>>2]=H;J=d+528|0;K=c[J>>2]|0;L=b+248|0;c[L>>2]=K;i=f;return}E=c[d+500>>2]|0;F=b+240|0;c[F>>2]=E;G=d+524|0;H=c[G>>2]|0;I=b+244|0;c[I>>2]=H;J=d+528|0;K=c[J>>2]|0;L=b+248|0;c[L>>2]=K;i=f;return}function Gma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,i=Im;d=a+12|0;e=b+32|0;f=b+44|0;h=a+24|0;i=ea(g[h>>2]);g[e>>2]=ea(ea(i+ea(g[d>>2]))*ea(.5));i=ea(g[h>>2]);g[f>>2]=ea(ea(i-ea(g[d>>2]))*ea(.5));d=a+28|0;i=ea(g[d>>2]);h=a+16|0;g[e+4>>2]=ea(ea(i+ea(g[h>>2]))*ea(.5));i=ea(g[d>>2]);g[f+4>>2]=ea(ea(i-ea(g[h>>2]))*ea(.5));h=a+32|0;i=ea(g[h>>2]);d=a+20|0;g[e+8>>2]=ea(ea(i+ea(g[d>>2]))*ea(.5));i=ea(g[h>>2]);g[f+8>>2]=ea(ea(i-ea(g[d>>2]))*ea(.5));c[b+528>>2]=c[a+248>>2];c[b+524>>2]=c[a+244>>2];return}function Hma(a){a=a|0;return}function Ima(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Jma(a,b,c,d);i=e;return}function Jma(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;j=b+416|0;k=b+420|0;l=b+432|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[l>>2]=d;m=b+436|0;c[m>>2]=e;c[b+444>>2]=f;f=d+152|0;n=c[f>>2]<<4;if(!n){o=0;p=d;q=e}else{r=e+8|0;s=(c[r>>2]|0)+23&-16;t=s;u=t+-8|0;v=e+12|0;c[u>>2]=c[v>>2];c[t+-4>>2]=n&2147483632;c[v>>2]=u;c[r>>2]=t+n;o=s;p=c[l>>2]|0;q=c[m>>2]|0}c[b+424>>2]=o;o=(c[p+160>>2]|0)*48|0;if(!o){w=0;x=p}else{p=q+8|0;s=(c[p>>2]|0)+23&-16;n=s;t=n+-8|0;r=q+12|0;c[t>>2]=c[r>>2];c[n+-4>>2]=o&2147483632;c[r>>2]=t;c[p>>2]=n+o;w=s;x=c[l>>2]|0}c[b+428>>2]=w;if((a[x+212>>0]|0)==0?!(ea(g[x+216>>2])>ea(0.0)):0){i=h;return}w=c[m>>2]|0;b=c[x+152>>2]<<4;if(!b){y=0;z=x;A=w}else{x=w+8|0;s=(c[x>>2]|0)+23&-16;o=s;n=o+-8|0;p=w+12|0;c[n>>2]=c[p>>2];c[o+-4>>2]=b&2147483632;c[p>>2]=n;c[x>>2]=o+b;y=s;z=c[l>>2]|0;A=c[m>>2]|0}c[j>>2]=y;y=(c[z+160>>2]|0)*48|0;if(!y)B=0;else{z=A+8|0;m=(c[z>>2]|0)+23&-16;l=m;s=l+-8|0;b=A+12|0;c[s>>2]=c[b>>2];c[l+-4>>2]=y&2147483632;c[b>>2]=s;c[z>>2]=l+y;B=m}c[k>>2]=B;k=c[f>>2]|0;if(!k)C=c[j>>2]|0;else{f=c[j>>2]|0;j=f;m=k;k=c[d+144>>2]|0;while(1){m=m+-1|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];if(!m){C=f;break}else{j=j+16|0;k=k+16|0}}}J_a(B,C,c[d+156>>2]|0,c[d+160>>2]|0);i=h;return}function Kma(a){a=a|0;var b=0;b=i;Lma(a);i=b;return}function Lma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=a+436|0;e=c[d>>2]|0;f=c[a+424>>2]|0;a:do if((f|0)!=0?(g=f+-4|0,c[g>>2]=c[g>>2]|-2147483648,g=e+12|0,h=c[g>>2]|0,(h|0)!=0):0){j=e+8|0;k=h;do{if((c[k+4>>2]|0)>=0)break a;c[j>>2]=k;k=c[k>>2]|0;c[g>>2]=k}while((k|0)!=0)}while(0);e=c[d>>2]|0;f=c[a+428>>2]|0;b:do if((f|0)!=0?(k=f+-4|0,c[k>>2]=c[k>>2]|-2147483648,k=e+12|0,g=c[k>>2]|0,(g|0)!=0):0){j=e+8|0;h=g;do{if((c[h+4>>2]|0)>=0)break b;c[j>>2]=h;h=c[h>>2]|0;c[k>>2]=h}while((h|0)!=0)}while(0);e=c[d>>2]|0;f=c[a+416>>2]|0;c:do if((f|0)!=0?(h=f+-4|0,c[h>>2]=c[h>>2]|-2147483648,h=e+12|0,k=c[h>>2]|0,(k|0)!=0):0){j=e+8|0;g=k;do{if((c[g+4>>2]|0)>=0)break c;c[j>>2]=g;g=c[g>>2]|0;c[h>>2]=g}while((g|0)!=0)}while(0);e=c[d>>2]|0;d=c[a+420>>2]|0;if(!d){i=b;return}a=d+-4|0;c[a>>2]=c[a>>2]|-2147483648;a=e+12|0;d=c[a>>2]|0;if(!d){i=b;return}f=e+8|0;e=d;while(1){if((c[e+4>>2]|0)>=0){l=21;break}c[f>>2]=e;e=c[e>>2]|0;c[a>>2]=e;if(!e){l=21;break}}if((l|0)==21){i=b;return}}function Mma(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;e=i;c[b+440>>2]=0;Nma(b,d);Oma(b,d);Pma(b);f=b+432|0;h=c[f>>2]|0;j=c[h+152>>2]|0;if(!j){i=e;return}k=c[d>>2]|0;l=c[h+148>>2]|0;if((k|0)==1){m=c[b+424>>2]|0;n=m;o=j;p=l;while(1){o=o+-1|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];if(!o){q=m;break}else{n=n+16|0;p=p+16|0}}}else{r=ea(k>>>0);s=ea(g[d+4>>2]);t=ea(s+ea(ea(1.0)-ea(r*s)));d=c[b+424>>2]|0;k=d;p=j;j=l;l=c[h+144>>2]|0;while(1){p=p+-1|0;s=ea(g[j>>2]);r=ea(g[l>>2]);u=ea(s-r);s=ea(g[j+4>>2]);v=ea(g[l+4>>2]);w=ea(s-v);s=ea(g[j+8>>2]);x=ea(g[l+8>>2]);y=ea(s-x);s=ea(g[j+12>>2]);z=ea(g[l+12>>2]);A=ea(r+ea(t*u));u=ea(v+ea(t*w));w=ea(x+ea(t*y));y=ea(z+ea(t*ea(s-z)));z=ea(A);A=ea(u);u=ea(w);w=ea(y);g[k>>2]=z;g[k+4>>2]=A;g[k+8>>2]=u;g[k+12>>2]=w;if(!p){q=d;break}else{k=k+16|0;j=j+16|0;l=l+16|0}}}l=b+424|0;j=c[f>>2]|0;J_a(c[b+428>>2]|0,q,c[j+156>>2]|0,c[j+160>>2]|0);if(Qma(b)|0){if(a[(c[f>>2]|0)+212>>0]|0)Rma(b);Sma(b);Sma(b+192|0);if(!(a[(c[f>>2]|0)+212>>0]|0))Tma(b);Uma(b)}f=b+416|0;if(!(c[f>>2]|0)){i=e;return}b=l;j=c[b>>2]|0;q=c[b+4>>2]|0;b=f;k=c[b+4>>2]|0;d=l;c[d>>2]=c[b>>2];c[d+4>>2]=k;k=f;c[k>>2]=j;c[k+4>>2]=q;i=e;return}function Nma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=Im,$a=0,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;d=i;i=i+336|0;e=d+32|0;f=d+144|0;h=d+208|0;j=d+224|0;k=d+16|0;l=d;m=d+96|0;n=a+432|0;o=c[n>>2]|0;if(!(c[o+180>>2]|0)){i=d;return}p=a+436|0;q=c[p>>2]|0;r=c[o+172>>2]<<5;if(!r){s=0;t=o}else{o=q+8|0;u=(c[o>>2]|0)+23&-16;v=u+-8|0;w=q+12|0;c[v>>2]=c[w>>2];c[u+-4>>2]=r&2147483616;c[w>>2]=v;c[o>>2]=u+r;s=u;t=c[n>>2]|0}u=c[t+168>>2]|0;r=c[b>>2]|0;if((r|0)==1){o=c[t+172>>2]|0;if(o){v=s;w=o;o=u;while(1){w=w+-1|0;c[v>>2]=c[o>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];if(!w)break;else{v=v+16|0;o=o+16|0}}}}else{x=ea(g[b+4>>2]);b=c[t+172>>2]|0;if(b){y=ea(ea(r>>>0)*x);z=ea(x+ea(ea(1.0)-y));r=s;o=b;b=u;u=c[t+164>>2]|0;while(1){o=o+-1|0;y=ea(g[b>>2]);x=ea(g[u>>2]);A=ea(y-x);y=ea(g[b+4>>2]);B=ea(g[u+4>>2]);C=ea(y-B);y=ea(g[b+8>>2]);D=ea(g[u+8>>2]);E=ea(y-D);y=ea(g[b+12>>2]);F=ea(g[u+12>>2]);G=ea(x+ea(z*A));A=ea(B+ea(z*C));C=ea(D+ea(z*E));E=ea(F+ea(z*ea(y-F)));F=ea(G);G=ea(A);A=ea(C);C=ea(E);g[r>>2]=F;g[r+4>>2]=G;g[r+8>>2]=A;g[r+12>>2]=C;if(!o)break;else{r=r+16|0;b=b+16|0;u=u+16|0}}}}u=c[n>>2]|0;z=ea(g[u+216>>2]);g[h>>2]=z;g[h+4>>2]=z;g[h+8>>2]=z;g[h+12>>2]=z;n=c[u+4>>2]|0;b=c[u>>2]<<2;r=n+(b<<2)|0;a:do if((b|0)>0){o=e+4|0;t=e+8|0;v=e+12|0;w=e+16|0;q=e+20|0;H=e+24|0;I=e+28|0;J=e+32|0;K=e+36|0;L=e+40|0;M=e+44|0;N=e+52|0;O=e+56|0;P=e+60|0;Q=e+48|0;R=j+96|0;S=j+100|0;T=j+104|0;U=j+108|0;V=k+4|0;W=k+8|0;X=k+12|0;Y=l+4|0;Z=l+8|0;_=l+12|0;$=f+4|0;aa=f+8|0;ba=f+12|0;ca=f+16|0;da=f+20|0;fa=f+24|0;ga=f+28|0;ha=f+32|0;ia=f+36|0;ja=f+40|0;ka=f+44|0;la=f+52|0;ma=f+56|0;na=f+60|0;oa=f+48|0;pa=j+16|0;qa=j+32|0;ra=j+48|0;sa=j+64|0;ta=j+80|0;ua=m+4|0;va=m+8|0;wa=m+12|0;xa=m+16|0;ya=m+20|0;za=m+24|0;Aa=m+28|0;Ba=m+32|0;Ca=m+36|0;Da=m+40|0;Ea=m+44|0;Fa=j+4|0;Ga=j+8|0;Ha=j+12|0;Ia=j+16|0;Ja=j+20|0;Ka=j+24|0;La=j+28|0;Ma=j+32|0;Na=j+36|0;Oa=j+40|0;Pa=j+44|0;if(z>ea(0.0)){Qa=n;Ra=c[u+8>>2]|0}else{Sa=n;while(1){C=ea(g[Sa>>2]);Ta=Sa+4|0;A=ea(g[Ta>>2]);Ua=Sa+8|0;G=ea(g[Ua>>2]);Va=Sa+12|0;F=ea(g[Va>>2]);E=ea(C);C=ea(A);y=ea(G);D=ea(F);g[e>>2]=E;g[o>>2]=C;g[t>>2]=y;g[v>>2]=D;Wa=Sa+16|0;D=ea(g[Wa>>2]);Xa=Sa+20|0;y=ea(g[Xa>>2]);Ya=Sa+24|0;C=ea(g[Ya>>2]);Za=Sa+28|0;E=ea(g[Za>>2]);B=ea(D);x=ea(y);y=ea(C);_a=ea(E);g[w>>2]=B;g[q>>2]=x;g[H>>2]=y;g[I>>2]=_a;$a=Sa+32|0;_a=ea(g[$a>>2]);ab=Sa+36|0;y=ea(g[ab>>2]);bb=Sa+40|0;x=ea(g[bb>>2]);cb=Sa+44|0;B=ea(g[cb>>2]);db=ea(_a);eb=ea(y);fb=ea(x);x=ea(B);g[J>>2]=db;g[K>>2]=eb;g[L>>2]=fb;g[M>>2]=x;gb=Sa+48|0;x=ea(g[gb>>2]);hb=Sa+52|0;fb=ea(g[hb>>2]);ib=Sa+56|0;eb=ea(g[ib>>2]);jb=Sa+60|0;db=ea(g[jb>>2]);g[P>>2]=db;g[o>>2]=D;g[t>>2]=_a;g[v>>2]=x;g[w>>2]=A;g[H>>2]=y;g[I>>2]=fb;g[J>>2]=G;g[K>>2]=C;g[M>>2]=eb;g[Q>>2]=F;g[N>>2]=E;g[O>>2]=B;kb=j+0|0;lb=kb+96|0;do{c[kb>>2]=0;kb=kb+4|0}while((kb|0)<(lb|0));c[R>>2]=c[119914];c[S>>2]=c[119915];c[T>>2]=c[119916];c[U>>2]=c[119917];cna(a,s,e,j);B=ea(g[R>>2]);mb=B>ea(g[119914]);E=ea(g[S>>2]);nb=E>ea(g[119915]);F=ea(g[T>>2]);ob=F>ea(g[119916]);eb=ea(g[U>>2]);pb=eb>ea(g[119917]);c[k>>2]=~((mb^1)<<31>>31);c[V>>2]=~((nb^1)<<31>>31);c[W>>2]=~((ob^1)<<31>>31);c[X>>2]=~((pb^1)<<31>>31);if(mb|nb|ob|pb){C=ea(ea(1.0)/B);B=ea(ea(1.0)/E);E=ea(ea(1.0)/F);F=ea(ea(1.0)/eb);g[l>>2]=C;g[Y>>2]=B;g[Z>>2]=E;g[_>>2]=F;eb=ea(ea(g[j>>2])*C);G=ea(ea(g[Fa>>2])*B);fb=ea(ea(g[Ga>>2])*E);y=ea(ea(g[Ha>>2])*F);A=ea(eb+ea(g[e>>2]));eb=ea(G+ea(g[o>>2]));G=ea(fb+ea(g[t>>2]));fb=ea(y+ea(g[v>>2]));g[e>>2]=A;y=ea(ea(g[Ia>>2])*C);x=ea(ea(g[Ja>>2])*B);_a=ea(ea(g[Ka>>2])*E);D=ea(ea(g[La>>2])*F);db=ea(y+ea(g[w>>2]));y=ea(x+ea(g[q>>2]));x=ea(_a+ea(g[H>>2]));_a=ea(D+ea(g[I>>2]));g[q>>2]=y;y=ea(ea(g[Ma>>2])*C);C=ea(ea(g[Na>>2])*B);B=ea(ea(g[Oa>>2])*E);E=ea(ea(g[Pa>>2])*F);F=ea(y+ea(g[J>>2]));y=ea(C+ea(g[K>>2]));C=ea(B+ea(g[L>>2]));B=ea(E+ea(g[M>>2]));g[L>>2]=C;g[o>>2]=db;g[t>>2]=F;g[v>>2]=ea(g[Q>>2]);g[w>>2]=eb;g[H>>2]=y;g[I>>2]=ea(g[N>>2]);g[J>>2]=G;g[K>>2]=x;g[M>>2]=ea(g[O>>2]);g[Q>>2]=fb;g[N>>2]=_a;g[O>>2]=B;g[Sa>>2]=A;g[Ta>>2]=ea(g[o>>2]);g[Ua>>2]=ea(g[t>>2]);g[Va>>2]=ea(g[v>>2]);g[Wa>>2]=ea(g[w>>2]);g[Xa>>2]=ea(g[q>>2]);g[Ya>>2]=ea(g[H>>2]);g[Za>>2]=ea(g[I>>2]);g[$a>>2]=ea(g[J>>2]);g[ab>>2]=ea(g[K>>2]);g[bb>>2]=ea(g[L>>2]);g[cb>>2]=ea(g[M>>2]);g[gb>>2]=ea(g[Q>>2]);g[hb>>2]=ea(g[N>>2]);g[ib>>2]=ea(g[O>>2]);g[jb>>2]=ea(g[P>>2])}Sa=Sa+64|0;if(Sa>>>0>=r>>>0)break a}}while(1){A=ea(g[Qa>>2]);Sa=Qa+4|0;B=ea(g[Sa>>2]);pb=Qa+8|0;_a=ea(g[pb>>2]);ob=Qa+12|0;fb=ea(g[ob>>2]);x=ea(A);A=ea(B);G=ea(_a);y=ea(fb);g[e>>2]=x;g[o>>2]=A;g[t>>2]=G;g[v>>2]=y;nb=Qa+16|0;y=ea(g[nb>>2]);mb=Qa+20|0;G=ea(g[mb>>2]);qb=Qa+24|0;A=ea(g[qb>>2]);rb=Qa+28|0;x=ea(g[rb>>2]);eb=ea(y);F=ea(G);G=ea(A);db=ea(x);g[w>>2]=eb;g[q>>2]=F;g[H>>2]=G;g[I>>2]=db;sb=Qa+32|0;db=ea(g[sb>>2]);tb=Qa+36|0;G=ea(g[tb>>2]);ub=Qa+40|0;F=ea(g[ub>>2]);vb=Qa+44|0;eb=ea(g[vb>>2]);C=ea(db);E=ea(G);D=ea(F);F=ea(eb);g[J>>2]=C;g[K>>2]=E;g[L>>2]=D;g[M>>2]=F;wb=Qa+48|0;F=ea(g[wb>>2]);xb=Qa+52|0;D=ea(g[xb>>2]);yb=Qa+56|0;E=ea(g[yb>>2]);zb=Qa+60|0;C=ea(g[zb>>2]);g[P>>2]=C;g[o>>2]=y;g[t>>2]=db;g[v>>2]=F;g[w>>2]=B;g[H>>2]=G;g[I>>2]=D;g[J>>2]=_a;g[K>>2]=A;g[M>>2]=E;g[Q>>2]=fb;g[N>>2]=x;g[O>>2]=eb;kb=j+0|0;lb=kb+96|0;do{c[kb>>2]=0;kb=kb+4|0}while((kb|0)<(lb|0));c[R>>2]=c[119914];c[S>>2]=c[119915];c[T>>2]=c[119916];c[U>>2]=c[119917];cna(a,s,e,j);eb=ea(g[R>>2]);jb=eb>ea(g[119914]);x=ea(g[S>>2]);ib=x>ea(g[119915]);fb=ea(g[T>>2]);hb=fb>ea(g[119916]);E=ea(g[U>>2]);gb=E>ea(g[119917]);c[k>>2]=~((jb^1)<<31>>31);c[V>>2]=~((ib^1)<<31>>31);c[W>>2]=~((hb^1)<<31>>31);c[X>>2]=~((gb^1)<<31>>31);if(jb|ib|hb|gb){A=ea(ea(1.0)/x);x=ea(ea(1.0)/fb);fb=ea(ea(1.0)/E);g[l>>2]=ea(ea(1.0)/eb);g[Y>>2]=A;g[Z>>2]=x;g[_>>2]=fb;fb=ea(g[Ra>>2]);gb=Ra+4|0;x=ea(g[gb>>2]);hb=Ra+8|0;A=ea(g[hb>>2]);ib=Ra+12|0;eb=ea(g[ib>>2]);E=ea(fb);fb=ea(x);_a=ea(A);D=ea(eb);g[f>>2]=E;g[$>>2]=fb;g[aa>>2]=_a;g[ba>>2]=D;jb=Ra+16|0;D=ea(g[jb>>2]);cb=Ra+20|0;_a=ea(g[cb>>2]);bb=Ra+24|0;fb=ea(g[bb>>2]);ab=Ra+28|0;E=ea(g[ab>>2]);G=ea(D);B=ea(_a);_a=ea(fb);F=ea(E);g[ca>>2]=G;g[da>>2]=B;g[fa>>2]=_a;g[ga>>2]=F;$a=Ra+32|0;F=ea(g[$a>>2]);Za=Ra+36|0;_a=ea(g[Za>>2]);Ya=Ra+40|0;B=ea(g[Ya>>2]);Xa=Ra+44|0;G=ea(g[Xa>>2]);db=ea(F);y=ea(_a);C=ea(B);B=ea(G);g[ha>>2]=db;g[ia>>2]=y;g[ja>>2]=C;g[ka>>2]=B;Wa=Ra+48|0;B=ea(g[Wa>>2]);Va=Ra+52|0;C=ea(g[Va>>2]);Ua=Ra+56|0;y=ea(g[Ua>>2]);Ta=Ra+60|0;db=ea(g[Ta>>2]);g[na>>2]=db;g[$>>2]=D;g[aa>>2]=F;g[ba>>2]=B;g[ca>>2]=x;g[fa>>2]=_a;g[ga>>2]=C;g[ha>>2]=A;g[ia>>2]=fb;g[ka>>2]=y;g[oa>>2]=eb;g[la>>2]=E;g[ma>>2]=G;K_a(j,pa,qa,ra,sa,ta,e,f,l,h,k,m);G=ea(g[f>>2]);E=ea(G-ea(g[m>>2]));G=ea(g[$>>2]);eb=ea(G-ea(g[ua>>2]));G=ea(g[aa>>2]);y=ea(G-ea(g[va>>2]));G=ea(g[ba>>2]);fb=ea(G-ea(g[wa>>2]));g[f>>2]=E;G=ea(g[ca>>2]);A=ea(G-ea(g[xa>>2]));G=ea(g[da>>2]);C=ea(G-ea(g[ya>>2]));G=ea(g[fa>>2]);_a=ea(G-ea(g[za>>2]));G=ea(g[ga>>2]);x=ea(G-ea(g[Aa>>2]));g[da>>2]=C;C=ea(g[ha>>2]);G=ea(C-ea(g[Ba>>2]));C=ea(g[ia>>2]);B=ea(C-ea(g[Ca>>2]));C=ea(g[ja>>2]);F=ea(C-ea(g[Da>>2]));C=ea(g[ka>>2]);D=ea(C-ea(g[Ea>>2]));g[ja>>2]=F;g[$>>2]=A;g[aa>>2]=G;g[ba>>2]=ea(g[oa>>2]);g[ca>>2]=eb;g[fa>>2]=B;g[ga>>2]=ea(g[la>>2]);g[ha>>2]=y;g[ia>>2]=_a;g[ka>>2]=ea(g[ma>>2]);g[oa>>2]=fb;g[la>>2]=x;g[ma>>2]=D;g[Ra>>2]=E;g[gb>>2]=ea(g[$>>2]);g[hb>>2]=ea(g[aa>>2]);g[ib>>2]=ea(g[ba>>2]);g[jb>>2]=ea(g[ca>>2]);g[cb>>2]=ea(g[da>>2]);g[bb>>2]=ea(g[fa>>2]);g[ab>>2]=ea(g[ga>>2]);g[$a>>2]=ea(g[ha>>2]);g[Za>>2]=ea(g[ia>>2]);g[Ya>>2]=ea(g[ja>>2]);g[Xa>>2]=ea(g[ka>>2]);g[Wa>>2]=ea(g[oa>>2]);g[Va>>2]=ea(g[la>>2]);g[Ua>>2]=ea(g[ma>>2]);g[Ta>>2]=ea(g[na>>2]);E=ea(g[l>>2]);D=ea(g[Y>>2]);x=ea(g[Z>>2]);fb=ea(g[_>>2]);_a=ea(ea(g[j>>2])*E);y=ea(ea(g[Fa>>2])*D);B=ea(ea(g[Ga>>2])*x);eb=ea(ea(g[Ha>>2])*fb);G=ea(_a+ea(g[e>>2]));_a=ea(y+ea(g[o>>2]));y=ea(B+ea(g[t>>2]));B=ea(eb+ea(g[v>>2]));g[e>>2]=G;eb=ea(ea(g[Ia>>2])*E);A=ea(ea(g[Ja>>2])*D);F=ea(ea(g[Ka>>2])*x);C=ea(ea(g[La>>2])*fb);db=ea(eb+ea(g[w>>2]));eb=ea(A+ea(g[q>>2]));A=ea(F+ea(g[H>>2]));F=ea(C+ea(g[I>>2]));g[q>>2]=eb;eb=ea(ea(g[Ma>>2])*E);E=ea(ea(g[Na>>2])*D);D=ea(ea(g[Oa>>2])*x);x=ea(ea(g[Pa>>2])*fb);fb=ea(eb+ea(g[J>>2]));eb=ea(E+ea(g[K>>2]));E=ea(D+ea(g[L>>2]));D=ea(x+ea(g[M>>2]));g[L>>2]=E;g[o>>2]=db;g[t>>2]=fb;g[v>>2]=ea(g[Q>>2]);g[w>>2]=_a;g[H>>2]=eb;g[I>>2]=ea(g[N>>2]);g[J>>2]=y;g[K>>2]=A;g[M>>2]=ea(g[O>>2]);g[Q>>2]=B;g[N>>2]=F;g[O>>2]=D;g[Qa>>2]=G;g[Sa>>2]=ea(g[o>>2]);g[pb>>2]=ea(g[t>>2]);g[ob>>2]=ea(g[v>>2]);g[nb>>2]=ea(g[w>>2]);g[mb>>2]=ea(g[q>>2]);g[qb>>2]=ea(g[H>>2]);g[rb>>2]=ea(g[I>>2]);g[sb>>2]=ea(g[J>>2]);g[tb>>2]=ea(g[K>>2]);g[ub>>2]=ea(g[L>>2]);g[vb>>2]=ea(g[M>>2]);g[wb>>2]=ea(g[Q>>2]);g[xb>>2]=ea(g[N>>2]);g[yb>>2]=ea(g[O>>2]);g[zb>>2]=ea(g[P>>2])}Ta=Qa+64|0;if(Ta>>>0>=r>>>0)break a;Qa=Ta;Ra=Ra+64|0}}while(0);Ra=c[p>>2]|0;if(!s){i=d;return}p=s+-4|0;c[p>>2]=c[p>>2]|-2147483648;p=Ra+12|0;s=c[p>>2]|0;if(!s){i=d;return}Qa=Ra+8|0;Ra=s;while(1){if((c[Ra+4>>2]|0)>=0){Ab=25;break}c[Qa>>2]=Ra;Ra=c[Ra>>2]|0;c[p>>2]=Ra;if(!Ra){Ab=25;break}}if((Ab|0)==25){i=d;return}}function Oma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;d=i;i=i+176|0;e=d+112|0;f=d;h=a+432|0;j=c[h>>2]|0;l=c[j+192>>2]|0;if(!l){i=d;return}m=a+436|0;n=c[m>>2]|0;o=l*80|0;if(!o){p=0;q=j}else{j=n+8|0;l=(c[j>>2]|0)+23&-16;r=l+-8|0;s=n+12|0;c[r>>2]=c[s>>2];c[l+-4>>2]=o&2147483632;c[s>>2]=r;c[j>>2]=l+o;p=l;q=c[h>>2]|0}l=c[q+188>>2]|0;o=c[b>>2]|0;if((o|0)==1){j=c[q+192>>2]|0;if(j){r=c[119922]|0;s=c[119923]|0;n=c[119924]|0;t=c[119925]|0;u=c[119926]|0;v=c[119927]|0;w=c[119928]|0;x=c[119929]|0;y=c[119930]|0;z=c[119931]|0;A=c[119932]|0;B=c[119933]|0;C=p;D=j;j=l;while(1){D=D+-1|0;E=ea(g[j>>2]);F=ea(g[j+4>>2]);G=ea(g[j+8>>2]);H=ea(g[j+12>>2]);I=(g[k>>2]=E,c[k>>2]|0);J=(g[k>>2]=F,c[k>>2]|0);K=(g[k>>2]=G,c[k>>2]|0);L=(g[k>>2]=H,c[k>>2]|0);M=ea(g[j+16>>2]);N=ea(g[j+20>>2]);O=ea(g[j+24>>2]);P=ea(g[j+28>>2]);Q=ea(g[j+32>>2]);j=j+36|0;R=ea(g[j>>2]);S=ea(H-E);U=ea(M-F);M=ea(N-G);N=ea(O-H);V=(g[k>>2]=S,c[k>>2]|0);W=(g[k>>2]=U,c[k>>2]|0);X=(g[k>>2]=M,c[k>>2]|0);Y=(g[k>>2]=N,c[k>>2]|0);N=ea(O-E);E=ea(P-F);F=ea(Q-G);G=ea(R-H);Z=(g[k>>2]=N,c[k>>2]|0);_=(g[k>>2]=E,c[k>>2]|0);$=(g[k>>2]=F,c[k>>2]|0);aa=(g[k>>2]=G,c[k>>2]|0);G=ea(ea(U*F)-ea(M*E));H=ea(ea(M*N)-ea(S*F));R=ea(ea(S*E)-ea(U*N));Q=ea(ea(ea(S*S)+ea(U*U))+ea(M*M));ba=(g[k>>2]=Q,c[k>>2]|0);P=ea(ea(ea(N*N)+ea(E*E))+ea(F*F));ca=(g[k>>2]=P,c[k>>2]|0);O=ea(ea(ea(S*N)+ea(U*E))+ea(M*F));da=(g[k>>2]=O,c[k>>2]|0);F=ea(ea(1.0)/ea(T(ea(ea(R*R)+ea(ea(G*G)+ea(H*H))))));M=ea(ea(Q*P)-ea(O*O));fa=(g[k>>2]=M,c[k>>2]|0);M=ea(ea(ea(Q+P)-O)-O);ga=(g[k>>2]=M,c[k>>2]|0);ha=ga^fa;fa=ha&r^ga;ia=ha&s^ga;ja=ha&n^ga;ka=ha&t^ga;ga=(fa^ba)&u^fa;fa=(ia^ba)&v^ia;ia=(ja^ba)&w^ja;ja=(ka^ba)&x^ka;g[C>>2]=(c[k>>2]=(da^I)&y^I,ea(g[k>>2]));g[C+4>>2]=(c[k>>2]=(da^J)&z^J,ea(g[k>>2]));g[C+8>>2]=(c[k>>2]=(da^K)&A^K,ea(g[k>>2]));g[C+12>>2]=(c[k>>2]=(da^L)&B^L,ea(g[k>>2]));L=C+16|0;g[L>>2]=(c[k>>2]=(ba^V)&y^V,ea(g[k>>2]));g[L+4>>2]=(c[k>>2]=(ba^W)&z^W,ea(g[k>>2]));g[L+8>>2]=(c[k>>2]=(ba^X)&A^X,ea(g[k>>2]));g[L+12>>2]=(c[k>>2]=(ba^Y)&B^Y,ea(g[k>>2]));Y=C+32|0;g[Y>>2]=(c[k>>2]=(ca^Z)&y^Z,ea(g[k>>2]));g[Y+4>>2]=(c[k>>2]=(ca^_)&z^_,ea(g[k>>2]));g[Y+8>>2]=(c[k>>2]=(ca^$)&A^$,ea(g[k>>2]));g[Y+12>>2]=(c[k>>2]=(ca^aa)&B^aa,ea(g[k>>2]));aa=C+48|0;M=ea(H*F);H=ea(R*F);R=ea(F*ea(0.0));g[aa>>2]=ea(G*F);g[aa+4>>2]=M;g[aa+8>>2]=H;g[aa+12>>2]=R;aa=C+64|0;R=ea(ea(1.0)/(c[k>>2]=(ga^ca)&y^ga,ea(g[k>>2])));H=ea(ea(1.0)/(c[k>>2]=(fa^ca)&z^fa,ea(g[k>>2])));M=ea(ea(1.0)/(c[k>>2]=(ia^ca)&A^ia,ea(g[k>>2])));F=ea(ea(1.0)/(c[k>>2]=(ja^ca)&B^ja,ea(g[k>>2])));g[aa>>2]=R;g[aa+4>>2]=H;g[aa+8>>2]=M;g[aa+12>>2]=F;if(!D)break;else C=C+80|0}}}else{F=ea(g[b+4>>2]);b=c[q+192>>2]|0;if(b){M=ea(ea(o>>>0)*F);H=ea(F+ea(ea(1.0)-M));o=c[119922]|0;C=c[119923]|0;D=c[119924]|0;B=c[119925]|0;A=c[119926]|0;z=c[119927]|0;y=c[119928]|0;x=c[119929]|0;w=c[119930]|0;v=c[119931]|0;u=c[119932]|0;t=c[119933]|0;n=p;s=b;b=c[q+184>>2]|0;q=l;while(1){s=s+-1|0;M=ea(g[b>>2]);F=ea(g[b+4>>2]);R=ea(g[b+8>>2]);G=ea(g[b+12>>2]);O=ea(g[q>>2]);P=ea(g[q+4>>2]);Q=ea(g[q+8>>2]);E=ea(M+ea(H*ea(O-M)));M=ea(F+ea(H*ea(P-F)));F=ea(R+ea(H*ea(Q-R)));R=ea(G+ea(H*ea(ea(g[q+12>>2])-G)));l=(g[k>>2]=E,c[k>>2]|0);r=(g[k>>2]=M,c[k>>2]|0);j=(g[k>>2]=F,c[k>>2]|0);aa=(g[k>>2]=R,c[k>>2]|0);G=ea(g[b+16>>2]);Q=ea(g[b+20>>2]);P=ea(g[b+24>>2]);O=ea(g[q+16>>2]);U=ea(g[q+20>>2]);N=ea(G+ea(H*ea(O-G)));G=ea(Q+ea(H*ea(U-Q)));Q=ea(P+ea(H*ea(ea(g[q+24>>2])-P)));P=ea(g[b+28>>2]);U=ea(g[b+32>>2]);b=b+36|0;O=ea(g[b>>2]);S=ea(g[q+28>>2]);la=ea(g[q+32>>2]);q=q+36|0;ma=ea(P+ea(H*ea(S-P)));P=ea(U+ea(H*ea(la-U)));U=ea(O+ea(H*ea(ea(g[q>>2])-O)));O=ea(R-E);la=ea(N-M);N=ea(G-F);G=ea(Q-R);ja=(g[k>>2]=O,c[k>>2]|0);ca=(g[k>>2]=la,c[k>>2]|0);ia=(g[k>>2]=N,c[k>>2]|0);fa=(g[k>>2]=G,c[k>>2]|0);G=ea(Q-E);E=ea(ma-M);M=ea(P-F);F=ea(U-R);ga=(g[k>>2]=G,c[k>>2]|0);Y=(g[k>>2]=E,c[k>>2]|0);$=(g[k>>2]=M,c[k>>2]|0);_=(g[k>>2]=F,c[k>>2]|0);F=ea(ea(la*M)-ea(N*E));R=ea(ea(N*G)-ea(O*M));U=ea(ea(O*E)-ea(la*G));P=ea(ea(ea(O*O)+ea(la*la))+ea(N*N));Z=(g[k>>2]=P,c[k>>2]|0);ma=ea(ea(ea(G*G)+ea(E*E))+ea(M*M));ba=(g[k>>2]=ma,c[k>>2]|0);Q=ea(ea(ea(O*G)+ea(la*E))+ea(N*M));L=(g[k>>2]=Q,c[k>>2]|0);M=ea(ea(1.0)/ea(T(ea(ea(U*U)+ea(ea(F*F)+ea(R*R))))));N=ea(ea(P*ma)-ea(Q*Q));X=(g[k>>2]=N,c[k>>2]|0);N=ea(ea(ea(P+ma)-Q)-Q);W=(g[k>>2]=N,c[k>>2]|0);V=W^X;X=V&o^W;da=V&C^W;K=V&D^W;J=V&B^W;W=(X^Z)&A^X;X=(da^Z)&z^da;da=(K^Z)&y^K;K=(J^Z)&x^J;g[n>>2]=(c[k>>2]=(L^l)&w^l,ea(g[k>>2]));g[n+4>>2]=(c[k>>2]=(L^r)&v^r,ea(g[k>>2]));g[n+8>>2]=(c[k>>2]=(L^j)&u^j,ea(g[k>>2]));g[n+12>>2]=(c[k>>2]=(L^aa)&t^aa,ea(g[k>>2]));aa=n+16|0;g[aa>>2]=(c[k>>2]=(Z^ja)&w^ja,ea(g[k>>2]));g[aa+4>>2]=(c[k>>2]=(Z^ca)&v^ca,ea(g[k>>2]));g[aa+8>>2]=(c[k>>2]=(Z^ia)&u^ia,ea(g[k>>2]));g[aa+12>>2]=(c[k>>2]=(Z^fa)&t^fa,ea(g[k>>2]));fa=n+32|0;g[fa>>2]=(c[k>>2]=(ba^ga)&w^ga,ea(g[k>>2]));g[fa+4>>2]=(c[k>>2]=(ba^Y)&v^Y,ea(g[k>>2]));g[fa+8>>2]=(c[k>>2]=(ba^$)&u^$,ea(g[k>>2]));g[fa+12>>2]=(c[k>>2]=(ba^_)&t^_,ea(g[k>>2]));_=n+48|0;N=ea(M*R);R=ea(M*U);U=ea(M*ea(0.0));g[_>>2]=ea(M*F);g[_+4>>2]=N;g[_+8>>2]=R;g[_+12>>2]=U;_=n+64|0;U=ea(ea(1.0)/(c[k>>2]=(W^ba)&w^W,ea(g[k>>2])));R=ea(ea(1.0)/(c[k>>2]=(X^ba)&v^X,ea(g[k>>2])));N=ea(ea(1.0)/(c[k>>2]=(da^ba)&u^da,ea(g[k>>2])));F=ea(ea(1.0)/(c[k>>2]=(K^ba)&t^K,ea(g[k>>2])));g[_>>2]=U;g[_+4>>2]=R;g[_+8>>2]=N;g[_+12>>2]=F;if(!s)break;else n=n+80|0}}}n=c[h>>2]|0;h=c[n+4>>2]|0;s=c[n>>2]<<2;n=h+(s<<2)|0;if((s|0)>0){s=e+4|0;t=e+8|0;u=e+12|0;v=e+16|0;w=e+20|0;x=e+24|0;y=e+28|0;z=e+32|0;A=e+36|0;B=e+40|0;D=e+44|0;C=e+52|0;o=e+56|0;q=e+60|0;b=e+48|0;_=f+96|0;K=f+100|0;ba=f+104|0;da=f+108|0;X=f+4|0;W=f+8|0;fa=f+12|0;$=f+16|0;Y=f+20|0;ga=f+24|0;Z=f+28|0;aa=f+32|0;ia=f+36|0;ca=f+40|0;ja=f+44|0;L=h;do{H=ea(g[L>>2]);h=L+4|0;F=ea(g[h>>2]);j=L+8|0;N=ea(g[j>>2]);r=L+12|0;R=ea(g[r>>2]);U=ea(H);H=ea(F);M=ea(N);Q=ea(R);g[e>>2]=U;g[s>>2]=H;g[t>>2]=M;g[u>>2]=Q;l=L+16|0;Q=ea(g[l>>2]);J=L+20|0;M=ea(g[J>>2]);V=L+24|0;H=ea(g[V>>2]);I=L+28|0;U=ea(g[I>>2]);ma=ea(Q);P=ea(M);M=ea(H);E=ea(U);g[v>>2]=ma;g[w>>2]=P;g[x>>2]=M;g[y>>2]=E;ka=L+32|0;E=ea(g[ka>>2]);ha=L+36|0;M=ea(g[ha>>2]);na=L+40|0;P=ea(g[na>>2]);oa=L+44|0;ma=ea(g[oa>>2]);la=ea(E);G=ea(M);O=ea(P);P=ea(ma);g[z>>2]=la;g[A>>2]=G;g[B>>2]=O;g[D>>2]=P;pa=L+48|0;P=ea(g[pa>>2]);qa=L+52|0;O=ea(g[qa>>2]);ra=L+56|0;G=ea(g[ra>>2]);sa=L+60|0;la=ea(g[sa>>2]);g[q>>2]=la;g[s>>2]=Q;g[t>>2]=E;g[u>>2]=P;g[v>>2]=F;g[x>>2]=M;g[y>>2]=O;g[z>>2]=N;g[A>>2]=H;g[D>>2]=G;g[b>>2]=R;g[C>>2]=U;g[o>>2]=ma;ta=f+0|0;ua=ta+96|0;do{c[ta>>2]=0;ta=ta+4|0}while((ta|0)<(ua|0));c[_>>2]=c[119914];c[K>>2]=c[119915];c[ba>>2]=c[119916];c[da>>2]=c[119917];dna(a,p,e,f);ma=ea(g[_>>2]);ta=ma>ea(g[119914]);U=ea(g[K>>2]);ua=U>ea(g[119915]);R=ea(g[ba>>2]);va=R>ea(g[119916]);G=ea(g[da>>2]);if(ta|ua|va|G>ea(g[119917])){H=ea(ea(1.0)/ma);ma=ea(ea(1.0)/U);U=ea(ea(1.0)/R);R=ea(ea(1.0)/G);G=ea(H*ea(g[f>>2]));N=ea(ma*ea(g[X>>2]));O=ea(U*ea(g[W>>2]));M=ea(R*ea(g[fa>>2]));F=ea(G+ea(g[e>>2]));G=ea(N+ea(g[s>>2]));N=ea(O+ea(g[t>>2]));O=ea(M+ea(g[u>>2]));g[e>>2]=F;M=ea(H*ea(g[$>>2]));P=ea(ma*ea(g[Y>>2]));E=ea(U*ea(g[ga>>2]));Q=ea(R*ea(g[Z>>2]));la=ea(M+ea(g[v>>2]));M=ea(P+ea(g[w>>2]));P=ea(E+ea(g[x>>2]));E=ea(Q+ea(g[y>>2]));g[w>>2]=M;M=ea(H*ea(g[aa>>2]));H=ea(ma*ea(g[ia>>2]));ma=ea(U*ea(g[ca>>2]));U=ea(R*ea(g[ja>>2]));R=ea(M+ea(g[z>>2]));M=ea(H+ea(g[A>>2]));H=ea(ma+ea(g[B>>2]));ma=ea(U+ea(g[D>>2]));g[B>>2]=H;g[s>>2]=la;g[t>>2]=R;g[u>>2]=ea(g[b>>2]);g[v>>2]=G;g[x>>2]=M;g[y>>2]=ea(g[C>>2]);g[z>>2]=N;g[A>>2]=P;g[D>>2]=ea(g[o>>2]);g[b>>2]=O;g[C>>2]=E;g[o>>2]=ma;g[L>>2]=F;g[h>>2]=ea(g[s>>2]);g[j>>2]=ea(g[t>>2]);g[r>>2]=ea(g[u>>2]);g[l>>2]=ea(g[v>>2]);g[J>>2]=ea(g[w>>2]);g[V>>2]=ea(g[x>>2]);g[I>>2]=ea(g[y>>2]);g[ka>>2]=ea(g[z>>2]);g[ha>>2]=ea(g[A>>2]);g[na>>2]=ea(g[B>>2]);g[oa>>2]=ea(g[D>>2]);g[pa>>2]=ea(g[b>>2]);g[qa>>2]=ea(g[C>>2]);g[ra>>2]=ea(g[o>>2]);g[sa>>2]=ea(g[q>>2])}L=L+64|0}while(L>>>0<n>>>0)}n=c[m>>2]|0;if(!p){i=d;return}m=p+-4|0;c[m>>2]=c[m>>2]|-2147483648;m=n+12|0;p=c[m>>2]|0;if(!p){i=d;return}L=n+8|0;n=p;while(1){if((c[n+4>>2]|0)>=0){wa=21;break}c[L>>2]=n;n=c[n>>2]|0;c[m>>2]=n;if(!n){wa=21;break}}if((wa|0)==21){i=d;return}}function Pma(a){a=a|0;var b=0,d=0,e=0,f=0,h=Im,j=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0;b=i;d=a+432|0;a=c[d>>2]|0;e=c[a+4>>2]|0;f=e+(c[a>>2]<<4)|0;h=ea(-ea(g[119962]));j=ea(-ea(g[119963]));l=ea(-ea(g[119964]));m=ea(-ea(g[119965]));if(e>>>0<f>>>0){n=ea(3402823469999999843913219.0e14);o=ea(3402823469999999843913219.0e14);p=ea(3402823469999999843913219.0e14);q=ea(-3402823469999999843913219.0e14);r=ea(-3402823469999999843913219.0e14);s=ea(-3402823469999999843913219.0e14);t=ea(-3402823469999999843913219.0e14);u=e;e=c[a+8>>2]|0;while(1){v=c[u>>2]|0;w=u+4|0;x=c[w>>2]|0;y=u+8|0;z=c[y>>2]|0;A=u+12|0;B=c[A>>2]|0;C=(c[k>>2]=v,ea(g[k>>2]));n=C<n?C:n;D=(c[k>>2]=x,ea(g[k>>2]));o=D<o?D:o;E=(c[k>>2]=z,ea(g[k>>2]));p=E<p?E:p;F=(c[k>>2]=B,ea(g[k>>2]));q=q<C?C:q;r=r<D?D:r;s=s<E?E:s;t=t<F?F:t;G=(D>j?c[e+4>>2]^x:0)^x;x=(E>l?c[e+8>>2]^z:0)^z;z=(F>m?c[e+12>>2]^B:0)^B;c[u>>2]=(C>h?c[e>>2]^v:0)^v;c[w>>2]=G;c[y>>2]=x;c[A>>2]=z;u=u+16|0;if(u>>>0>=f>>>0)break;else e=e+16|0}H=p;I=o;J=n;K=t;L=s;M=r;N=q;O=c[d>>2]|0}else{H=ea(3402823469999999843913219.0e14);I=ea(3402823469999999843913219.0e14);J=ea(3402823469999999843913219.0e14);K=ea(-3402823469999999843913219.0e14);L=ea(-3402823469999999843913219.0e14);M=ea(-3402823469999999843913219.0e14);N=ea(-3402823469999999843913219.0e14);O=a}a=O+12|0;q=ea(g[a>>2]);e=O+16|0;r=ea(g[e>>2]);f=O+20|0;s=ea(g[f>>2]);u=O+24|0;t=ea(g[u>>2]);z=O+28|0;n=ea(g[z>>2]);A=O+32|0;o=ea(g[A>>2]);x=O+36|0;p=ea(g[x>>2]);g[a>>2]=J;g[e>>2]=I;g[f>>2]=H;g[u>>2]=N;g[z>>2]=M;g[A>>2]=L;g[x>>2]=K;x=c[d>>2]|0;g[x+36>>2]=q;g[x+40>>2]=r;g[x+44>>2]=s;g[x+48>>2]=t;g[x+52>>2]=n;g[x+56>>2]=o;g[x+60>>2]=p;i=b;return}function Qma(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0;d=i;e=b+424|0;f=c[e>>2]|0;h=b+432|0;j=c[h>>2]|0;l=c[j+152>>2]|0;m=f+(l<<4)|0;n=(l|0)==0;if(n){o=-8388609;p=-8388609;q=-8388609;r=-8388609;s=2139095039;t=2139095039;u=2139095039;v=2139095039}else{w=f;f=-8388609;x=-8388609;y=-8388609;z=-8388609;A=2139095039;B=2139095039;C=2139095039;D=2139095039;while(1){E=(c[k>>2]=D,ea(g[k>>2]));F=(c[k>>2]=C,ea(g[k>>2]));G=(c[k>>2]=B,ea(g[k>>2]));H=(c[k>>2]=A,ea(g[k>>2]));I=(c[k>>2]=z,ea(g[k>>2]));J=(c[k>>2]=y,ea(g[k>>2]));K=(c[k>>2]=x,ea(g[k>>2]));L=(c[k>>2]=f,ea(g[k>>2]));M=ea(g[w>>2]);N=ea(g[w+4>>2]);O=ea(g[w+8>>2]);P=ea(g[w+12>>2]);Q=ea(M-P);R=ea(N-P);T=ea(O-P);U=ea(P-P);V=(g[k>>2]=Q<E?Q:E,c[k>>2]|0);W=(g[k>>2]=R<F?R:F,c[k>>2]|0);X=(g[k>>2]=T<G?T:G,c[k>>2]|0);Y=(g[k>>2]=U<H?U:H,c[k>>2]|0);H=ea(M+P);M=ea(N+P);N=ea(O+P);O=ea(P+P);Z=(g[k>>2]=I<H?H:I,c[k>>2]|0);_=(g[k>>2]=J<M?M:J,c[k>>2]|0);$=(g[k>>2]=K<N?N:K,c[k>>2]|0);aa=(g[k>>2]=L<O?O:L,c[k>>2]|0);w=w+16|0;if((w|0)==(m|0)){o=aa;p=$;q=_;r=Z;s=Y;t=X;u=W;v=V;break}else{f=aa;x=$;y=_;z=Z;A=Y;B=X;C=W;D=V}}}L=ea(g[j+12>>2]);O=ea(g[j+16>>2]);K=ea(g[j+20>>2]);N=ea(g[j+24>>2]);D=(g[k>>2]=N,c[k>>2]|0);J=ea(g[j+28>>2]);M=ea(g[j+32>>2]);I=ea(g[j+36>>2]);if(!(a[j+212>>0]|0)){ba=I;ca=M;da=J;fa=K;ga=O;ha=L;ia=v;ja=u;ka=t;la=s;ma=D;na=D;oa=r;pa=q;qa=p;ra=o}else{D=c[b+416>>2]|0;C=D+(l<<4)|0;if(n){sa=o;ta=p;ua=q;va=r;wa=s;xa=t;ya=u;za=v}else{n=D;D=o;o=p;p=q;q=r;r=s;s=t;t=u;u=v;while(1){H=(c[k>>2]=u,ea(g[k>>2]));P=(c[k>>2]=t,ea(g[k>>2]));U=(c[k>>2]=s,ea(g[k>>2]));G=(c[k>>2]=r,ea(g[k>>2]));T=(c[k>>2]=q,ea(g[k>>2]));F=(c[k>>2]=p,ea(g[k>>2]));R=(c[k>>2]=o,ea(g[k>>2]));E=(c[k>>2]=D,ea(g[k>>2]));Q=ea(g[n>>2]);Aa=ea(g[n+4>>2]);Ba=ea(g[n+8>>2]);Ca=ea(g[n+12>>2]);Da=ea(Q-Ca);Ea=ea(Aa-Ca);Fa=ea(Ba-Ca);Ga=ea(Ca-Ca);v=(g[k>>2]=Da<H?Da:H,c[k>>2]|0);l=(g[k>>2]=Ea<P?Ea:P,c[k>>2]|0);B=(g[k>>2]=Fa<U?Fa:U,c[k>>2]|0);A=(g[k>>2]=Ga<G?Ga:G,c[k>>2]|0);G=ea(Q+Ca);Q=ea(Aa+Ca);Aa=ea(Ba+Ca);Ba=ea(Ca+Ca);z=(g[k>>2]=T<G?G:T,c[k>>2]|0);y=(g[k>>2]=F<Q?Q:F,c[k>>2]|0);x=(g[k>>2]=R<Aa?Aa:R,c[k>>2]|0);f=(g[k>>2]=E<Ba?Ba:E,c[k>>2]|0);n=n+16|0;if((n|0)==(C|0)){sa=f;ta=x;ua=y;va=z;wa=A;xa=B;ya=l;za=v;break}else{D=f;o=x;p=y;q=z;r=A;s=B;t=l;u=v}}}E=ea(g[j+40>>2]);Ba=ea(g[j+44>>2]);R=ea(g[j+48>>2]);Aa=ea(g[j+52>>2]);F=ea(g[j+56>>2]);Q=ea(g[j+60>>2]);j=(g[k>>2]=R<N?R:N,c[k>>2]|0);ba=I<Q?Q:I;ca=M<F?F:M;da=J<Aa?Aa:J;fa=Ba<K?Ba:K;ga=E<O?E:O;ha=I<L?I:L;ia=za;ja=ya;ka=xa;la=wa;ma=j;na=(g[k>>2]=N<R?R:N,c[k>>2]|0);oa=va;pa=ua;qa=ta;ra=sa}N=(c[k>>2]=ia,ea(g[k>>2]));R=N<ha?ha:N;N=(c[k>>2]=ja,ea(g[k>>2]));ha=N<ga?ga:N;N=(c[k>>2]=ka,ea(g[k>>2]));ga=N<fa?fa:N;N=(c[k>>2]=la,ea(g[k>>2]));fa=(c[k>>2]=ma,ea(g[k>>2]));L=N<fa?fa:N;N=(c[k>>2]=na,ea(g[k>>2]));fa=(c[k>>2]=oa,ea(g[k>>2]));I=N<fa?N:fa;fa=(c[k>>2]=pa,ea(g[k>>2]));N=da<fa?da:fa;fa=(c[k>>2]=qa,ea(g[k>>2]));da=ca<fa?ca:fa;fa=(c[k>>2]=ra,ea(g[k>>2]));ca=ba<fa?ba:fa;fa=ea(I-R);ba=ea(da-ga);O=ea(ca-L);ra=(g[k>>2]=fa,c[k>>2]|0);qa=(g[k>>2]=ba,c[k>>2]|0);pa=(g[k>>2]=O,c[k>>2]|0)&~c[119933];if(!((c[k>>2]=ra&~c[119930],ea(g[k>>2]))>=ea(0.0))){Ha=0;i=d;return Ha|0}O=ea(N-ha);ra=!((c[k>>2]=(g[k>>2]=O,c[k>>2]|0)&~c[119931],ea(g[k>>2]))>=ea(0.0));oa=ra|!((c[k>>2]=qa&~c[119932],ea(g[k>>2]))>=ea(0.0));if(oa|!((c[k>>2]=pa,ea(g[k>>2]))>=ea(0.0))){Ha=0;i=d;return Ha|0}O=ea(S(ea(R)));ba=ea(S(ea(ha)));fa=ea(S(ea(ga)));E=ea(S(ea(L)));K=ea(g[119958]);Ba=ea(O*K);O=ea(g[119959]);J=ea(ba*O);ba=ea(g[119960]);Aa=ea(fa*ba);fa=ea(g[119961]);M=ea(R-Ba);Ba=ea(ha-J);J=ea(ga-Aa);Aa=ea(ea(I+ea(K*ea(S(ea(I)))))-M);I=ea(ea(N+ea(O*ea(S(ea(N)))))-Ba);N=ea(ea(da+ea(ba*ea(S(ea(da)))))-J);da=ea(ea(ca+ea(fa*ea(S(ea(ca)))))-ea(L-ea(E*fa)));fa=ea(g[119914]);E=ea(g[119915]);L=ea(g[119916]);ca=ea(g[119917]);ba=ea(ea(1.0)/(Aa<fa?fa:Aa));Aa=ea(ea(1.0)/(I<E?E:I));I=ea(ea(1.0)/(N<L?L:N));N=ea(ea(1.0)/(da<ca?ca:da));da=ea(ea(g[119954])*ba);ba=ea(ea(g[119955])*Aa);Aa=ea(ea(g[119956])*I);I=ea(ea(g[119957])*N);N=ea(da);ca=ea(ba);L=ea(Aa);E=ea(I);g[b+384>>2]=N;g[b+388>>2]=ca;g[b+392>>2]=L;g[b+396>>2]=E;E=ea(-ea(M*da));da=ea(-ea(Ba*ba));ba=ea(-ea(J*Aa));Aa=ea(E);E=ea(da);da=ea(ba);g[b+400>>2]=Aa;g[b+404>>2]=E;g[b+408>>2]=da;g[b+412>>2]=ea(1.0);PEi(b|0,0,192)|0;if(a[(c[h>>2]|0)+212>>0]|0)Xma(b,c[b+416>>2]|0);Xma(b,c[e>>2]|0);e=b+192|0;PEi(e|0,0,192)|0;pa=c[b+428>>2]|0;oa=c[(c[h>>2]|0)+160>>2]|0;h=pa+(oa*48|0)|0;if(!oa){Ha=1;i=d;return Ha|0}oa=b+192|0;qa=pa;pa=1;while(1){if(!(ea(g[qa+12>>2])==ea(0.0))){ra=c[qa+44>>2]|0;na=oa;ma=b;while(1){if(c[ma>>2]&ra)c[na>>2]=c[na>>2]|pa;ma=ma+4|0;if((ma|0)==(e|0))break;else na=na+4|0}}qa=qa+48|0;if((qa|0)==(h|0)){Ha=1;break}else pa=pa<<1}i=d;return Ha|0}function Rma(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=0,Ma=Im,Na=0,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im;b=i;i=i+352|0;d=b+16|0;e=b+112|0;f=b+80|0;h=b+176|0;j=b+336|0;l=b;m=b+96|0;n=b+288|0;o=c[a+432>>2]|0;p=ea(g[o+220>>2]);q=p>ea(0.0);r=ea(g[o+216>>2]);s=r>ea(0.0);g[f>>2]=r;g[f+4>>2]=r;g[f+8>>2]=r;g[f+12>>2]=r;t=c[o+4>>2]|0;u=c[o>>2]<<2;v=t+(u<<2)|0;if((u|0)<=0){i=b;return}u=e+4|0;w=e+8|0;x=e+12|0;y=e+16|0;z=e+20|0;A=e+24|0;B=e+28|0;C=e+32|0;D=e+36|0;E=e+40|0;F=e+44|0;G=e+52|0;H=e+56|0;I=e+60|0;J=e+48|0;K=d+4|0;L=d+8|0;M=d+12|0;N=d+16|0;O=d+20|0;P=d+24|0;Q=d+28|0;R=d+32|0;S=d+36|0;T=d+40|0;U=d+44|0;V=d+48|0;W=d+52|0;X=d+56|0;Y=d+60|0;Z=h+96|0;_=h+100|0;$=h+104|0;aa=h+108|0;ba=l+4|0;ca=l+8|0;da=l+12|0;fa=m+4|0;ga=m+8|0;ha=m+12|0;ia=h+16|0;ja=h+32|0;ka=h+48|0;la=h+64|0;ma=h+80|0;na=n+4|0;oa=n+8|0;pa=n+12|0;qa=n+16|0;ra=n+20|0;sa=n+24|0;ta=n+28|0;ua=n+32|0;va=n+36|0;wa=n+40|0;xa=n+44|0;ya=h+4|0;za=h+8|0;Aa=h+12|0;Ba=h+16|0;Ca=h+20|0;Da=h+24|0;Ea=h+28|0;Fa=h+32|0;Ga=h+36|0;Ha=h+40|0;Ia=h+44|0;Ja=t;t=c[o+8>>2]|0;while(1){r=ea(g[t>>2]);o=t+4|0;Ka=ea(g[o>>2]);La=t+8|0;Ma=ea(g[La>>2]);Na=t+12|0;Oa=ea(g[Na>>2]);Pa=ea(r);r=ea(Ka);Qa=ea(Ma);Ra=ea(Oa);g[e>>2]=Pa;g[u>>2]=r;g[w>>2]=Qa;g[x>>2]=Ra;Sa=t+16|0;Ra=ea(g[Sa>>2]);Ta=t+20|0;Qa=ea(g[Ta>>2]);Ua=t+24|0;r=ea(g[Ua>>2]);Va=t+28|0;Pa=ea(g[Va>>2]);Wa=ea(Ra);Xa=ea(Qa);Qa=ea(r);Ya=ea(Pa);g[y>>2]=Wa;g[z>>2]=Xa;g[A>>2]=Qa;g[B>>2]=Ya;Za=t+32|0;Ya=ea(g[Za>>2]);_a=t+36|0;Qa=ea(g[_a>>2]);$a=t+40|0;Xa=ea(g[$a>>2]);ab=t+44|0;Wa=ea(g[ab>>2]);bb=ea(Ya);cb=ea(Qa);db=ea(Xa);Xa=ea(Wa);g[C>>2]=bb;g[D>>2]=cb;g[E>>2]=db;g[F>>2]=Xa;eb=t+48|0;Xa=ea(g[eb>>2]);fb=t+52|0;db=ea(g[fb>>2]);gb=t+56|0;cb=ea(g[gb>>2]);hb=t+60|0;bb=ea(g[hb>>2]);g[I>>2]=bb;g[u>>2]=Ra;g[w>>2]=Ya;g[x>>2]=Xa;g[y>>2]=Ka;g[A>>2]=Qa;g[B>>2]=db;g[C>>2]=Ma;g[D>>2]=r;g[F>>2]=cb;g[J>>2]=Oa;g[G>>2]=Pa;g[H>>2]=Wa;Wa=ea(g[Ja>>2]);ib=Ja+4|0;Pa=ea(g[ib>>2]);jb=Ja+8|0;Oa=ea(g[jb>>2]);kb=Ja+12|0;cb=ea(g[kb>>2]);r=ea(Wa);Wa=ea(Pa);Ma=ea(Oa);db=ea(cb);g[d>>2]=r;g[K>>2]=Wa;g[L>>2]=Ma;g[M>>2]=db;lb=Ja+16|0;db=ea(g[lb>>2]);mb=Ja+20|0;Ma=ea(g[mb>>2]);nb=Ja+24|0;Wa=ea(g[nb>>2]);ob=Ja+28|0;r=ea(g[ob>>2]);Qa=ea(db);Ka=ea(Ma);Ma=ea(Wa);Xa=ea(r);g[N>>2]=Qa;g[O>>2]=Ka;g[P>>2]=Ma;g[Q>>2]=Xa;pb=Ja+32|0;Xa=ea(g[pb>>2]);qb=Ja+36|0;Ma=ea(g[qb>>2]);rb=Ja+40|0;Ka=ea(g[rb>>2]);sb=Ja+44|0;Qa=ea(g[sb>>2]);Ya=ea(Xa);Ra=ea(Ma);bb=ea(Ka);Ka=ea(Qa);g[R>>2]=Ya;g[S>>2]=Ra;g[T>>2]=bb;g[U>>2]=Ka;tb=Ja+48|0;Ka=ea(g[tb>>2]);ub=Ja+52|0;bb=ea(g[ub>>2]);vb=Ja+56|0;Ra=ea(g[vb>>2]);wb=Ja+60|0;Ya=ea(g[wb>>2]);g[Y>>2]=Ya;g[K>>2]=db;g[L>>2]=Xa;g[M>>2]=Ka;g[N>>2]=Pa;g[P>>2]=Ma;g[Q>>2]=bb;g[R>>2]=Oa;g[S>>2]=Wa;g[U>>2]=Ra;g[V>>2]=cb;g[W>>2]=r;g[X>>2]=Qa;xb=h+0|0;yb=xb+96|0;do{c[xb>>2]=0;xb=xb+4|0}while((xb|0)<(yb|0));c[Z>>2]=c[119914];c[_>>2]=c[119915];c[$>>2]=c[119916];c[aa>>2]=c[119917];bna(j,a,e,d,h);ana(a,j,e,d,h);Qa=ea(g[Z>>2]);xb=Qa>ea(g[119914]);r=ea(g[_>>2]);yb=r>ea(g[119915]);cb=ea(g[$>>2]);zb=cb>ea(g[119916]);Ra=ea(g[aa>>2]);Ab=Ra>ea(g[119917]);c[l>>2]=~((xb^1)<<31>>31);c[ba>>2]=~((yb^1)<<31>>31);c[ca>>2]=~((zb^1)<<31>>31);c[da>>2]=~((Ab^1)<<31>>31);if(xb|yb|zb|Ab){Wa=ea(ea(1.0)/r);r=ea(ea(1.0)/cb);cb=ea(ea(1.0)/Ra);g[m>>2]=ea(ea(1.0)/Qa);g[fa>>2]=Wa;g[ga>>2]=r;g[ha>>2]=cb;if(s){K_a(h,ia,ja,ka,la,ma,d,e,m,f,l,n);cb=ea(g[e>>2]);r=ea(cb-ea(g[n>>2]));cb=ea(g[u>>2]);Wa=ea(cb-ea(g[na>>2]));cb=ea(g[w>>2]);Qa=ea(cb-ea(g[oa>>2]));cb=ea(g[x>>2]);Ra=ea(cb-ea(g[pa>>2]));g[e>>2]=r;cb=ea(g[y>>2]);Oa=ea(cb-ea(g[qa>>2]));cb=ea(g[z>>2]);bb=ea(cb-ea(g[ra>>2]));cb=ea(g[A>>2]);Ma=ea(cb-ea(g[sa>>2]));cb=ea(g[B>>2]);Pa=ea(cb-ea(g[ta>>2]));g[z>>2]=bb;bb=ea(g[C>>2]);cb=ea(bb-ea(g[ua>>2]));bb=ea(g[D>>2]);Ka=ea(bb-ea(g[va>>2]));bb=ea(g[E>>2]);Xa=ea(bb-ea(g[wa>>2]));bb=ea(g[F>>2]);db=ea(bb-ea(g[xa>>2]));g[E>>2]=Xa;g[u>>2]=Oa;g[w>>2]=cb;g[x>>2]=ea(g[J>>2]);g[y>>2]=Wa;g[A>>2]=Ka;g[B>>2]=ea(g[G>>2]);g[C>>2]=Qa;g[D>>2]=Ma;g[F>>2]=ea(g[H>>2]);g[J>>2]=Ra;g[G>>2]=Pa;g[H>>2]=db;g[t>>2]=r;g[o>>2]=ea(g[u>>2]);g[La>>2]=ea(g[w>>2]);g[Na>>2]=ea(g[x>>2]);g[Sa>>2]=ea(g[y>>2]);g[Ta>>2]=ea(g[z>>2]);g[Ua>>2]=ea(g[A>>2]);g[Va>>2]=ea(g[B>>2]);g[Za>>2]=ea(g[C>>2]);g[_a>>2]=ea(g[D>>2]);g[$a>>2]=ea(g[E>>2]);g[ab>>2]=ea(g[F>>2]);g[eb>>2]=ea(g[J>>2]);g[fb>>2]=ea(g[G>>2]);g[gb>>2]=ea(g[H>>2]);g[hb>>2]=ea(g[I>>2])}if(q){r=ea(g[m>>2]);db=ea(r*r);r=ea(g[fa>>2]);Pa=ea(r*r);Ra=ea(g[ga>>2]);Ma=ea(Ra*Ra);Qa=ea(g[ha>>2]);Ka=ea(Qa*Qa);Wa=ea(g[h>>2]);cb=ea(Wa*Wa);Oa=ea(g[ya>>2]);Xa=ea(Oa*Oa);bb=ea(g[za>>2]);Ya=ea(bb*bb);Bb=ea(g[Aa>>2]);Cb=ea(Bb*Bb);Db=ea(g[Ba>>2]);Eb=ea(Db*Db);Fb=ea(g[Ca>>2]);Gb=ea(Fb*Fb);Hb=ea(g[Da>>2]);Ib=ea(Hb*Hb);Jb=ea(g[Ea>>2]);Kb=ea(cb+Eb);Eb=ea(Xa+Gb);Gb=ea(Ya+Ib);Ib=ea(Cb+ea(Jb*Jb));Cb=ea(g[Fa>>2]);Ya=ea(Cb*Cb);Xa=ea(g[Ga>>2]);cb=ea(Xa*Xa);Lb=ea(g[Ha>>2]);Mb=ea(Lb*Lb);Nb=ea(g[Ia>>2]);Ob=ea(db*ea(Kb+Ya));Ya=ea(Pa*ea(Eb+cb));cb=ea(Ma*ea(Gb+Mb));Mb=ea(Ka*ea(Ib+ea(Nb*Nb)));Ib=ea(p*Ob);Ob=ea(p*Ya);Ya=ea(p*cb);cb=ea(p*Mb);Mb=ea(Ib+ea(g[119938]));Ib=ea(Ob+ea(g[119939]));Ob=ea(Ya+ea(g[119940]));Ya=ea(ea(1.0)/Mb);Mb=ea(ea(1.0)/Ib);Ib=ea(ea(1.0)/Ob);Ob=ea(ea(1.0)/ea(cb+ea(g[119941])));cb=ea(g[V>>2]);Ka=ea(Ya*cb);Ya=ea(g[W>>2]);Gb=ea(Mb*Ya);Mb=ea(g[X>>2]);Ma=ea(Ib*Mb);Ib=ea(g[Y>>2]);Eb=ea(Ob*Ib);Ab=(g[k>>2]=Ka,c[k>>2]|0);zb=(g[k>>2]=Gb,c[k>>2]|0);yb=(g[k>>2]=Ma,c[k>>2]|0);xb=(g[k>>2]=Eb,c[k>>2]|0);Pb=(g[k>>2]=cb,c[k>>2]|0);Qb=(g[k>>2]=Ya,c[k>>2]|0);Rb=(g[k>>2]=Mb,c[k>>2]|0);Sb=(g[k>>2]=Ib,c[k>>2]|0);Tb=c[l>>2]&(Pb^Ab)^Pb;Pb=c[ba>>2]&(Qb^zb)^Qb;Qb=c[ca>>2]&(Rb^yb)^Rb;Rb=c[da>>2]&(Sb^xb)^Sb;c[V>>2]=Tb;c[W>>2]=Pb;c[X>>2]=Qb;c[Y>>2]=Rb;Ib=(c[k>>2]=Tb,ea(g[k>>2]));Mb=(c[k>>2]=Pb,ea(g[k>>2]));Ub=Wa;Vb=Oa;Wb=r;Xb=bb;Yb=Ra;Zb=Bb;_b=Qa;$b=Db;ac=Fb;bc=Hb;cc=Jb;dc=Cb;ec=Xa;fc=Lb;gc=Nb;hc=Ib;ic=Mb;jc=(c[k>>2]=Qb,ea(g[k>>2]))}else{Mb=ea(g[h>>2]);Ib=ea(g[ya>>2]);Nb=ea(g[fa>>2]);Lb=ea(g[za>>2]);Xa=ea(g[ga>>2]);Cb=ea(g[Aa>>2]);Jb=ea(g[ha>>2]);Hb=ea(g[Ba>>2]);Fb=ea(g[Ca>>2]);Db=ea(g[Da>>2]);Qa=ea(g[Ea>>2]);Bb=ea(g[Fa>>2]);Ra=ea(g[Ga>>2]);bb=ea(g[Ha>>2]);r=ea(g[Ia>>2]);Oa=ea(g[V>>2]);Wa=ea(g[W>>2]);Ub=Mb;Vb=Ib;Wb=Nb;Xb=Lb;Yb=Xa;Zb=Cb;_b=Jb;$b=Hb;ac=Fb;bc=Db;cc=Qa;dc=Bb;ec=Ra;fc=bb;gc=r;hc=Oa;ic=Wa;jc=ea(g[X>>2])}Wa=ea(g[m>>2]);Oa=ea(Ub*Wa);r=ea(Vb*Wb);bb=ea(Xb*Yb);Ra=ea(Zb*_b);Bb=ea(Oa+ea(g[d>>2]));Oa=ea(r+ea(g[K>>2]));r=ea(bb+ea(g[L>>2]));bb=ea(Ra+ea(g[M>>2]));g[d>>2]=Bb;Ra=ea($b*Wa);Qa=ea(ac*Wb);Db=ea(bc*Yb);Fb=ea(cc*_b);Hb=ea(Ra+ea(g[N>>2]));Ra=ea(Qa+ea(g[O>>2]));Qa=ea(Db+ea(g[P>>2]));Db=ea(Fb+ea(g[Q>>2]));g[O>>2]=Ra;Ra=ea(dc*Wa);Wa=ea(ec*Wb);Fb=ea(fc*Yb);Jb=ea(gc*_b);Cb=ea(Ra+ea(g[R>>2]));Ra=ea(Wa+ea(g[S>>2]));Wa=ea(Fb+ea(g[T>>2]));Fb=ea(Jb+ea(g[U>>2]));g[T>>2]=Wa;g[K>>2]=Hb;g[L>>2]=Cb;g[M>>2]=hc;g[N>>2]=Oa;g[P>>2]=Ra;g[Q>>2]=ic;g[R>>2]=r;g[S>>2]=Qa;g[U>>2]=jc;g[V>>2]=bb;g[W>>2]=Db;g[X>>2]=Fb;g[Ja>>2]=Bb;g[ib>>2]=ea(g[K>>2]);g[jb>>2]=ea(g[L>>2]);g[kb>>2]=ea(g[M>>2]);g[lb>>2]=ea(g[N>>2]);g[mb>>2]=ea(g[O>>2]);g[nb>>2]=ea(g[P>>2]);g[ob>>2]=ea(g[Q>>2]);g[pb>>2]=ea(g[R>>2]);g[qb>>2]=ea(g[S>>2]);g[rb>>2]=ea(g[T>>2]);g[sb>>2]=ea(g[U>>2]);g[tb>>2]=ea(g[V>>2]);g[ub>>2]=ea(g[W>>2]);g[vb>>2]=ea(g[X>>2]);g[wb>>2]=ea(g[Y>>2])}Ja=Ja+64|0;if(Ja>>>0>=v>>>0)break;else t=t+64|0}i=b;return}function Sma(a){a=a|0;var b=0;c[a>>2]=c[a>>2]&c[a+96>>2];b=a+4|0;c[b>>2]=c[b>>2]&c[a+100>>2];b=a+8|0;c[b>>2]=c[b>>2]&c[a+104>>2];b=a+12|0;c[b>>2]=c[b>>2]&c[a+108>>2];b=a+16|0;c[b>>2]=c[b>>2]&c[a+112>>2];b=a+20|0;c[b>>2]=c[b>>2]&c[a+116>>2];b=a+24|0;c[b>>2]=c[b>>2]&c[a+120>>2];b=a+28|0;c[b>>2]=c[b>>2]&c[a+124>>2];b=a+32|0;c[b>>2]=c[b>>2]&c[a+128>>2];b=a+36|0;c[b>>2]=c[b>>2]&c[a+132>>2];b=a+40|0;c[b>>2]=c[b>>2]&c[a+136>>2];b=a+44|0;c[b>>2]=c[b>>2]&c[a+140>>2];b=a+48|0;c[b>>2]=c[b>>2]&c[a+144>>2];b=a+52|0;c[b>>2]=c[b>>2]&c[a+148>>2];b=a+56|0;c[b>>2]=c[b>>2]&c[a+152>>2];b=a+60|0;c[b>>2]=c[b>>2]&c[a+156>>2];b=a+64|0;c[b>>2]=c[b>>2]&c[a+160>>2];b=a+68|0;c[b>>2]=c[b>>2]&c[a+164>>2];b=a+72|0;c[b>>2]=c[b>>2]&c[a+168>>2];b=a+76|0;c[b>>2]=c[b>>2]&c[a+172>>2];b=a+80|0;c[b>>2]=c[b>>2]&c[a+176>>2];b=a+84|0;c[b>>2]=c[b>>2]&c[a+180>>2];b=a+88|0;c[b>>2]=c[b>>2]&c[a+184>>2];b=a+92|0;c[b>>2]=c[b>>2]&c[a+188>>2];return}function Tma(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=0,Ma=Im,Na=0,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im;b=i;i=i+352|0;d=b+16|0;e=b+112|0;f=b+32|0;h=b+176|0;j=b+336|0;l=b;m=b+96|0;n=b+288|0;o=c[a+432>>2]|0;p=ea(g[o+220>>2]);q=ea(g[o+216>>2]);g[d>>2]=q;g[d+4>>2]=q;g[d+8>>2]=q;g[d+12>>2]=q;r=p>ea(0.0);s=q>ea(0.0);t=c[o+4>>2]|0;u=c[o>>2]<<2;v=t+(u<<2)|0;if((u|0)<=0){i=b;return}u=e+4|0;w=e+8|0;x=e+12|0;y=e+16|0;z=e+20|0;A=e+24|0;B=e+28|0;C=e+32|0;D=e+36|0;E=e+40|0;F=e+44|0;G=e+48|0;H=e+52|0;I=e+56|0;J=e+60|0;K=h+96|0;L=h+100|0;M=h+104|0;N=h+108|0;O=l+4|0;P=l+8|0;Q=l+12|0;R=m+4|0;S=m+8|0;T=m+12|0;U=f+4|0;V=f+8|0;W=f+12|0;X=f+16|0;Y=f+20|0;Z=f+24|0;_=f+28|0;$=f+32|0;aa=f+36|0;ba=f+40|0;ca=f+44|0;da=f+52|0;fa=f+56|0;ga=f+60|0;ha=f+48|0;ia=h+16|0;ja=h+32|0;ka=h+48|0;la=h+64|0;ma=h+80|0;na=n+4|0;oa=n+8|0;pa=n+12|0;qa=n+16|0;ra=n+20|0;sa=n+24|0;ta=n+28|0;ua=n+32|0;va=n+36|0;wa=n+40|0;xa=n+44|0;ya=h+4|0;za=h+8|0;Aa=h+12|0;Ba=h+16|0;Ca=h+20|0;Da=h+24|0;Ea=h+28|0;Fa=h+32|0;Ga=h+36|0;Ha=h+40|0;Ia=h+44|0;Ja=t;t=c[o+8>>2]|0;while(1){q=ea(g[Ja>>2]);o=Ja+4|0;Ka=ea(g[o>>2]);La=Ja+8|0;Ma=ea(g[La>>2]);Na=Ja+12|0;Oa=ea(g[Na>>2]);Pa=ea(q);q=ea(Ka);Qa=ea(Ma);Ra=ea(Oa);g[e>>2]=Pa;g[u>>2]=q;g[w>>2]=Qa;g[x>>2]=Ra;Sa=Ja+16|0;Ra=ea(g[Sa>>2]);Ta=Ja+20|0;Qa=ea(g[Ta>>2]);Ua=Ja+24|0;q=ea(g[Ua>>2]);Va=Ja+28|0;Pa=ea(g[Va>>2]);Wa=ea(Ra);Xa=ea(Qa);Qa=ea(q);Ya=ea(Pa);g[y>>2]=Wa;g[z>>2]=Xa;g[A>>2]=Qa;g[B>>2]=Ya;Za=Ja+32|0;Ya=ea(g[Za>>2]);_a=Ja+36|0;Qa=ea(g[_a>>2]);$a=Ja+40|0;Xa=ea(g[$a>>2]);ab=Ja+44|0;Wa=ea(g[ab>>2]);bb=ea(Ya);cb=ea(Qa);db=ea(Xa);Xa=ea(Wa);g[C>>2]=bb;g[D>>2]=cb;g[E>>2]=db;g[F>>2]=Xa;eb=Ja+48|0;Xa=ea(g[eb>>2]);fb=Ja+52|0;db=ea(g[fb>>2]);gb=Ja+56|0;cb=ea(g[gb>>2]);hb=Ja+60|0;bb=ea(g[hb>>2]);g[J>>2]=bb;g[u>>2]=Ra;g[w>>2]=Ya;g[x>>2]=Xa;g[y>>2]=Ka;g[A>>2]=Qa;g[B>>2]=db;g[C>>2]=Ma;g[D>>2]=q;g[F>>2]=cb;g[G>>2]=Oa;g[H>>2]=Pa;g[I>>2]=Wa;ib=h+0|0;jb=ib+96|0;do{c[ib>>2]=0;ib=ib+4|0}while((ib|0)<(jb|0));c[K>>2]=c[119914];c[L>>2]=c[119915];c[M>>2]=c[119916];c[N>>2]=c[119917];$ma(j,a,e,h);_ma(a,j,e,h);Wa=ea(g[K>>2]);ib=Wa>ea(g[119914]);Pa=ea(g[L>>2]);jb=Pa>ea(g[119915]);Oa=ea(g[M>>2]);kb=Oa>ea(g[119916]);cb=ea(g[N>>2]);lb=cb>ea(g[119917]);c[l>>2]=~((ib^1)<<31>>31);c[O>>2]=~((jb^1)<<31>>31);c[P>>2]=~((kb^1)<<31>>31);c[Q>>2]=~((lb^1)<<31>>31);if(ib|jb|kb|lb){q=ea(ea(1.0)/Pa);Pa=ea(ea(1.0)/Oa);Oa=ea(ea(1.0)/cb);g[m>>2]=ea(ea(1.0)/Wa);g[R>>2]=q;g[S>>2]=Pa;g[T>>2]=Oa;if(s){Oa=ea(g[t>>2]);lb=t+4|0;Pa=ea(g[lb>>2]);kb=t+8|0;q=ea(g[kb>>2]);jb=t+12|0;Wa=ea(g[jb>>2]);cb=ea(Oa);Oa=ea(Pa);Ma=ea(q);db=ea(Wa);g[f>>2]=cb;g[U>>2]=Oa;g[V>>2]=Ma;g[W>>2]=db;ib=t+16|0;db=ea(g[ib>>2]);mb=t+20|0;Ma=ea(g[mb>>2]);nb=t+24|0;Oa=ea(g[nb>>2]);ob=t+28|0;cb=ea(g[ob>>2]);Qa=ea(db);Ka=ea(Ma);Ma=ea(Oa);Xa=ea(cb);g[X>>2]=Qa;g[Y>>2]=Ka;g[Z>>2]=Ma;g[_>>2]=Xa;pb=t+32|0;Xa=ea(g[pb>>2]);qb=t+36|0;Ma=ea(g[qb>>2]);rb=t+40|0;Ka=ea(g[rb>>2]);sb=t+44|0;Qa=ea(g[sb>>2]);Ya=ea(Xa);Ra=ea(Ma);bb=ea(Ka);Ka=ea(Qa);g[$>>2]=Ya;g[aa>>2]=Ra;g[ba>>2]=bb;g[ca>>2]=Ka;tb=t+48|0;Ka=ea(g[tb>>2]);ub=t+52|0;bb=ea(g[ub>>2]);vb=t+56|0;Ra=ea(g[vb>>2]);wb=t+60|0;Ya=ea(g[wb>>2]);g[ga>>2]=Ya;g[U>>2]=db;g[V>>2]=Xa;g[W>>2]=Ka;g[X>>2]=Pa;g[Z>>2]=Ma;g[_>>2]=bb;g[$>>2]=q;g[aa>>2]=Oa;g[ca>>2]=Ra;g[ha>>2]=Wa;g[da>>2]=cb;g[fa>>2]=Qa;K_a(h,ia,ja,ka,la,ma,e,f,m,d,l,n);Qa=ea(g[f>>2]);cb=ea(Qa-ea(g[n>>2]));Qa=ea(g[U>>2]);Wa=ea(Qa-ea(g[na>>2]));Qa=ea(g[V>>2]);Ra=ea(Qa-ea(g[oa>>2]));Qa=ea(g[W>>2]);Oa=ea(Qa-ea(g[pa>>2]));g[f>>2]=cb;Qa=ea(g[X>>2]);q=ea(Qa-ea(g[qa>>2]));Qa=ea(g[Y>>2]);bb=ea(Qa-ea(g[ra>>2]));Qa=ea(g[Z>>2]);Ma=ea(Qa-ea(g[sa>>2]));Qa=ea(g[_>>2]);Pa=ea(Qa-ea(g[ta>>2]));g[Y>>2]=bb;bb=ea(g[$>>2]);Qa=ea(bb-ea(g[ua>>2]));bb=ea(g[aa>>2]);Ka=ea(bb-ea(g[va>>2]));bb=ea(g[ba>>2]);Xa=ea(bb-ea(g[wa>>2]));bb=ea(g[ca>>2]);db=ea(bb-ea(g[xa>>2]));g[ba>>2]=Xa;g[U>>2]=q;g[V>>2]=Qa;g[W>>2]=ea(g[ha>>2]);g[X>>2]=Wa;g[Z>>2]=Ka;g[_>>2]=ea(g[da>>2]);g[$>>2]=Ra;g[aa>>2]=Ma;g[ca>>2]=ea(g[fa>>2]);g[ha>>2]=Oa;g[da>>2]=Pa;g[fa>>2]=db;g[t>>2]=cb;g[lb>>2]=ea(g[U>>2]);g[kb>>2]=ea(g[V>>2]);g[jb>>2]=ea(g[W>>2]);g[ib>>2]=ea(g[X>>2]);g[mb>>2]=ea(g[Y>>2]);g[nb>>2]=ea(g[Z>>2]);g[ob>>2]=ea(g[_>>2]);g[pb>>2]=ea(g[$>>2]);g[qb>>2]=ea(g[aa>>2]);g[rb>>2]=ea(g[ba>>2]);g[sb>>2]=ea(g[ca>>2]);g[tb>>2]=ea(g[ha>>2]);g[ub>>2]=ea(g[da>>2]);g[vb>>2]=ea(g[fa>>2]);g[wb>>2]=ea(g[ga>>2])}if(r){cb=ea(g[m>>2]);db=ea(cb*cb);cb=ea(g[R>>2]);Pa=ea(cb*cb);Oa=ea(g[S>>2]);Ma=ea(Oa*Oa);Ra=ea(g[T>>2]);Ka=ea(Ra*Ra);Wa=ea(g[h>>2]);Qa=ea(Wa*Wa);q=ea(g[ya>>2]);Xa=ea(q*q);bb=ea(g[za>>2]);Ya=ea(bb*bb);xb=ea(g[Aa>>2]);yb=ea(xb*xb);zb=ea(g[Ba>>2]);Ab=ea(zb*zb);Bb=ea(g[Ca>>2]);Cb=ea(Bb*Bb);Db=ea(g[Da>>2]);Eb=ea(Db*Db);Fb=ea(g[Ea>>2]);Gb=ea(Qa+Ab);Ab=ea(Xa+Cb);Cb=ea(Ya+Eb);Eb=ea(yb+ea(Fb*Fb));yb=ea(g[Fa>>2]);Ya=ea(yb*yb);Xa=ea(g[Ga>>2]);Qa=ea(Xa*Xa);Hb=ea(g[Ha>>2]);Ib=ea(Hb*Hb);Jb=ea(g[Ia>>2]);Kb=ea(db*ea(Gb+Ya));Ya=ea(Pa*ea(Ab+Qa));Qa=ea(Ma*ea(Cb+Ib));Ib=ea(Ka*ea(Eb+ea(Jb*Jb)));Eb=ea(p*Kb);Kb=ea(p*Ya);Ya=ea(p*Qa);Qa=ea(p*Ib);Ib=ea(Eb+ea(g[119938]));Eb=ea(Kb+ea(g[119939]));Kb=ea(Ya+ea(g[119940]));Ya=ea(ea(1.0)/Ib);Ib=ea(ea(1.0)/Eb);Eb=ea(ea(1.0)/Kb);Kb=ea(ea(1.0)/ea(Qa+ea(g[119941])));Qa=ea(g[G>>2]);Ka=ea(Ya*Qa);Ya=ea(g[H>>2]);Cb=ea(Ib*Ya);Ib=ea(g[I>>2]);Ma=ea(Eb*Ib);Eb=ea(g[J>>2]);Ab=ea(Kb*Eb);wb=(g[k>>2]=Ka,c[k>>2]|0);vb=(g[k>>2]=Cb,c[k>>2]|0);ub=(g[k>>2]=Ma,c[k>>2]|0);tb=(g[k>>2]=Ab,c[k>>2]|0);sb=(g[k>>2]=Qa,c[k>>2]|0);rb=(g[k>>2]=Ya,c[k>>2]|0);qb=(g[k>>2]=Ib,c[k>>2]|0);pb=(g[k>>2]=Eb,c[k>>2]|0);ob=c[l>>2]&(sb^wb)^sb;sb=c[O>>2]&(rb^vb)^rb;rb=c[P>>2]&(qb^ub)^qb;qb=c[Q>>2]&(pb^tb)^pb;c[G>>2]=ob;c[H>>2]=sb;c[I>>2]=rb;c[J>>2]=qb;Eb=(c[k>>2]=ob,ea(g[k>>2]));Ib=(c[k>>2]=sb,ea(g[k>>2]));Lb=Wa;Mb=q;Nb=cb;Ob=bb;Pb=Oa;Qb=xb;Rb=Ra;Sb=zb;Tb=Bb;Ub=Db;Vb=Fb;Wb=yb;Xb=Xa;Yb=Hb;Zb=Jb;_b=Eb;$b=Ib;ac=(c[k>>2]=rb,ea(g[k>>2]))}else{Ib=ea(g[h>>2]);Eb=ea(g[ya>>2]);Jb=ea(g[R>>2]);Hb=ea(g[za>>2]);Xa=ea(g[S>>2]);yb=ea(g[Aa>>2]);Fb=ea(g[T>>2]);Db=ea(g[Ba>>2]);Bb=ea(g[Ca>>2]);zb=ea(g[Da>>2]);Ra=ea(g[Ea>>2]);xb=ea(g[Fa>>2]);Oa=ea(g[Ga>>2]);bb=ea(g[Ha>>2]);cb=ea(g[Ia>>2]);q=ea(g[G>>2]);Wa=ea(g[H>>2]);Lb=Ib;Mb=Eb;Nb=Jb;Ob=Hb;Pb=Xa;Qb=yb;Rb=Fb;Sb=Db;Tb=Bb;Ub=zb;Vb=Ra;Wb=xb;Xb=Oa;Yb=bb;Zb=cb;_b=q;$b=Wa;ac=ea(g[I>>2])}Wa=ea(g[m>>2]);q=ea(Lb*Wa);cb=ea(Mb*Nb);bb=ea(Ob*Pb);Oa=ea(Qb*Rb);xb=ea(q+ea(g[e>>2]));q=ea(cb+ea(g[u>>2]));cb=ea(bb+ea(g[w>>2]));bb=ea(Oa+ea(g[x>>2]));g[e>>2]=xb;Oa=ea(Sb*Wa);Ra=ea(Tb*Nb);zb=ea(Ub*Pb);Bb=ea(Vb*Rb);Db=ea(Oa+ea(g[y>>2]));Oa=ea(Ra+ea(g[z>>2]));Ra=ea(zb+ea(g[A>>2]));zb=ea(Bb+ea(g[B>>2]));g[z>>2]=Oa;Oa=ea(Wb*Wa);Wa=ea(Xb*Nb);Bb=ea(Yb*Pb);Fb=ea(Zb*Rb);yb=ea(Oa+ea(g[C>>2]));Oa=ea(Wa+ea(g[D>>2]));Wa=ea(Bb+ea(g[E>>2]));Bb=ea(Fb+ea(g[F>>2]));g[E>>2]=Wa;g[u>>2]=Db;g[w>>2]=yb;g[x>>2]=_b;g[y>>2]=q;g[A>>2]=Oa;g[B>>2]=$b;g[C>>2]=cb;g[D>>2]=Ra;g[F>>2]=ac;g[G>>2]=bb;g[H>>2]=zb;g[I>>2]=Bb;g[Ja>>2]=xb;g[o>>2]=ea(g[u>>2]);g[La>>2]=ea(g[w>>2]);g[Na>>2]=ea(g[x>>2]);g[Sa>>2]=ea(g[y>>2]);g[Ta>>2]=ea(g[z>>2]);g[Ua>>2]=ea(g[A>>2]);g[Va>>2]=ea(g[B>>2]);g[Za>>2]=ea(g[C>>2]);g[_a>>2]=ea(g[D>>2]);g[$a>>2]=ea(g[E>>2]);g[ab>>2]=ea(g[F>>2]);g[eb>>2]=ea(g[G>>2]);g[fb>>2]=ea(g[H>>2]);g[gb>>2]=ea(g[I>>2]);g[hb>>2]=ea(g[J>>2])}rb=Ja+64|0;if(rb>>>0>=v>>>0)break;Ja=rb;t=t+64|0}i=b;return}function Uma(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=Im,cb=Im,db=Im,eb=0,fb=Im,gb=Im,hb=Im,ib=Im,jb=0,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=0,tb=0,ub=0,vb=0,wb=Im,xb=Im,yb=Im,zb=Im,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=0,Pb=0,Qb=0,Rb=0,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=0,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=0,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=0,jc=0,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=0,yc=0,zc=0,Ac=0,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=Im,Ud=Im,Vd=Im,Wd=Im,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=Im,ce=Im,de=Im,ee=Im,fe=Im,ge=Im,he=Im,ie=Im,je=Im,ke=Im,le=Im,me=Im,ne=Im,oe=Im,pe=Im,qe=Im,re=Im,se=Im,te=Im,ue=Im,ve=Im,we=Im,xe=Im,ye=Im,ze=Im,Ae=Im,Be=Im,Ce=Im,De=Im,Ee=Im,Fe=Im,Ge=Im,He=Im,Ie=Im,Je=Im,Ke=Im,Le=Im,Me=Im,Ne=Im,Oe=Im,Pe=Im,Qe=Im,Re=Im,Se=Im,Te=Im,Ue=Im,Ve=Im,We=Im;b=i;i=i+336|0;d=b+16|0;f=b+192|0;h=b+32|0;j=b+240|0;l=b+320|0;m=b;n=b+144|0;o=b+256|0;p=a+432|0;q=c[p>>2]|0;r=ea(g[q+220>>2]);s=ea(g[q+216>>2]);g[d>>2]=s;g[d+4>>2]=s;g[d+8>>2]=s;g[d+12>>2]=s;t=r>ea(0.0);u=s>ea(0.0);v=c[q+204>>2]|0;w=c[q+4>>2]|0;x=c[q+8>>2]|0;y=c[q>>2]|0;s=ea(g[a+384>>2]);z=ea(ea(1.0)/s);A=ea(g[a+388>>2]);B=ea(ea(1.0)/A);C=ea(g[a+392>>2]);D=ea(ea(1.0)/C);E=ea(g[a+396>>2]);F=ea(ea(1.0)/E);G=ea(g[119914]);H=ea(g[119915]);I=ea(g[119916]);q=E>ea(g[119917]);J=y+1|0;K=y+2|0;E=s>G?z:ea(0.0);z=ea(E*ea(g[a+400>>2]));G=A>H?B:ea(0.0);B=ea(G*ea(g[a+404>>2]));H=C>I?D:ea(0.0);D=ea(H*ea(g[a+408>>2]));I=q?F:ea(0.0);F=ea(z-E);E=ea(B-G);G=ea(D-H);H=ea(ea(I*ea(g[a+412>>2]))-I);I=ea(F);F=ea(E);E=ea(G);G=ea(H);g[w+(K<<4)>>2]=I;g[w+(K<<4)+4>>2]=F;g[w+(K<<4)+8>>2]=E;g[w+(K<<4)+12>>2]=G;g[w+(J<<4)>>2]=I;g[w+(J<<4)+4>>2]=F;g[w+(J<<4)+8>>2]=E;g[w+(J<<4)+12>>2]=G;g[w+(y<<4)>>2]=I;g[w+(y<<4)+4>>2]=F;g[w+(y<<4)+8>>2]=E;g[w+(y<<4)+12>>2]=G;y=c[p>>2]|0;p=c[y+196>>2]|0;J=c[y+200>>2]|0;if((p|0)==(J|0)){i=b;return}y=f+4|0;K=f+8|0;q=f+12|0;L=f+16|0;M=f+20|0;N=f+24|0;O=f+28|0;P=f+32|0;Q=f+36|0;R=f+40|0;S=f+44|0;T=h+96|0;U=h+100|0;V=h+104|0;W=h+108|0;X=l+4|0;Y=l+8|0;Z=l+12|0;_=m+4|0;$=m+8|0;aa=m+12|0;ba=h+4|0;ca=h+8|0;da=h+12|0;fa=h+16|0;ga=h+20|0;ha=h+24|0;ia=h+28|0;ja=h+32|0;ka=h+36|0;la=h+40|0;ma=h+44|0;na=n+4|0;oa=n+8|0;pa=n+12|0;qa=n+16|0;ra=n+20|0;sa=n+24|0;ta=n+28|0;ua=n+32|0;va=n+36|0;wa=n+40|0;xa=n+44|0;ya=o+48|0;za=o+52|0;Aa=o+56|0;Ba=o+60|0;Ca=h+48|0;Da=h+64|0;Ea=h+80|0;Fa=o+4|0;Ga=o+8|0;Ha=o+12|0;Ia=o+24|0;Ja=o+28|0;Ka=o+44|0;La=o+16|0;Ma=o+32|0;Na=o+36|0;Oa=o+20|0;Pa=o+40|0;Qa=p;do{p=(e[Qa>>1]|0)<<4;G=ea(g[w+p>>2]);E=ea(g[w+(p|4)>>2]);F=ea(g[w+(p|8)>>2]);I=ea(g[w+(p|12)>>2]);p=Qa+2|0;Ra=(e[p>>1]|0)<<4;H=ea(g[w+Ra>>2]);D=ea(g[w+(Ra|4)>>2]);B=ea(g[w+(Ra|8)>>2]);z=ea(g[w+(Ra|12)>>2]);Ra=Qa+4|0;Sa=(e[Ra>>1]|0)<<4;C=ea(g[w+Sa>>2]);A=ea(g[w+(Sa|4)>>2]);s=ea(g[w+(Sa|8)>>2]);Ta=ea(g[w+(Sa|12)>>2]);Sa=(e[Qa+6>>1]|0)<<4;Ua=ea(g[v+Sa>>2]);Va=ea(g[v+(Sa|4)>>2]);Wa=ea(g[v+(Sa|8)>>2]);Xa=ea(g[v+(Sa|12)>>2]);Sa=(g[k>>2]=Ua,c[k>>2]|0);Ya=(g[k>>2]=Va,c[k>>2]|0);Za=(g[k>>2]=Wa,c[k>>2]|0);_a=Qa+8|0;$a=(e[_a>>1]|0)<<4;ab=ea(g[w+$a>>2]);bb=ea(g[w+($a|4)>>2]);cb=ea(g[w+($a|8)>>2]);db=ea(g[w+($a|12)>>2]);$a=Qa+10|0;eb=(e[$a>>1]|0)<<4;fb=ea(g[w+eb>>2]);gb=ea(g[w+(eb|4)>>2]);hb=ea(g[w+(eb|8)>>2]);ib=ea(g[w+(eb|12)>>2]);eb=Qa+12|0;jb=(e[eb>>1]|0)<<4;kb=ea(g[w+jb>>2]);lb=ea(g[w+(jb|4)>>2]);mb=ea(g[w+(jb|8)>>2]);nb=ea(g[w+(jb|12)>>2]);jb=(e[Qa+14>>1]|0)<<4;ob=ea(g[v+jb>>2]);pb=ea(g[v+(jb|4)>>2]);qb=ea(g[v+(jb|8)>>2]);rb=ea(g[v+(jb|12)>>2]);jb=(g[k>>2]=ob,c[k>>2]|0);sb=(g[k>>2]=pb,c[k>>2]|0);tb=(g[k>>2]=qb,c[k>>2]|0);ub=Qa+16|0;vb=(e[ub>>1]|0)<<4;wb=ea(g[w+vb>>2]);xb=ea(g[w+(vb|4)>>2]);yb=ea(g[w+(vb|8)>>2]);zb=ea(g[w+(vb|12)>>2]);vb=Qa+18|0;Ab=(e[vb>>1]|0)<<4;Bb=ea(g[w+Ab>>2]);Cb=ea(g[w+(Ab|4)>>2]);Db=ea(g[w+(Ab|8)>>2]);Eb=ea(g[w+(Ab|12)>>2]);Ab=Qa+20|0;Fb=(e[Ab>>1]|0)<<4;Gb=ea(g[w+Fb>>2]);Hb=ea(g[w+(Fb|4)>>2]);Ib=ea(g[w+(Fb|8)>>2]);Jb=ea(g[w+(Fb|12)>>2]);Fb=(e[Qa+22>>1]|0)<<4;Kb=ea(g[v+Fb>>2]);Lb=ea(g[v+(Fb|4)>>2]);Mb=ea(g[v+(Fb|8)>>2]);Nb=ea(g[v+(Fb|12)>>2]);Fb=(g[k>>2]=Kb,c[k>>2]|0);Ob=(g[k>>2]=Lb,c[k>>2]|0);Pb=(g[k>>2]=Mb,c[k>>2]|0);Qb=Qa+26|0;Rb=(e[Qb>>1]|0)<<4;Sb=ea(g[w+Rb>>2]);Tb=ea(g[w+(Rb|4)>>2]);Ub=ea(g[w+(Rb|8)>>2]);Vb=ea(g[w+(Rb|12)>>2]);Rb=Qa+24|0;Wb=(e[Rb>>1]|0)<<4;Xb=ea(g[w+Wb>>2]);Yb=ea(g[w+(Wb|4)>>2]);Zb=ea(g[w+(Wb|8)>>2]);_b=ea(g[w+(Wb|12)>>2]);Wb=Qa+28|0;$b=(e[Wb>>1]|0)<<4;ac=ea(g[w+$b>>2]);bc=ea(g[w+($b|4)>>2]);cc=ea(g[w+($b|8)>>2]);dc=ea(g[w+($b|12)>>2]);$b=(e[Qa+30>>1]|0)<<4;ec=ea(g[v+$b>>2]);fc=ea(g[v+($b|4)>>2]);gc=ea(g[v+($b|8)>>2]);hc=ea(g[v+($b|12)>>2]);$b=(g[k>>2]=ec,c[k>>2]|0);ic=(g[k>>2]=fc,c[k>>2]|0);jc=(g[k>>2]=gc,c[k>>2]|0);kc=ea(ea(ea(G*Ua)+ea(H*Va))+ea(C*Wa));lc=ea(ea(ea(E*Ua)+ea(D*Va))+ea(A*Wa));mc=ea(ea(ea(F*Ua)+ea(B*Va))+ea(s*Wa));nc=ea(kc);kc=ea(ea(ea(ab*ob)+ea(fb*pb))+ea(kb*qb));oc=ea(ea(ea(bb*ob)+ea(gb*pb))+ea(lb*qb));pc=ea(ea(ea(cb*ob)+ea(hb*pb))+ea(mb*qb));qc=ea(oc);oc=ea(ea(ea(wb*Kb)+ea(Bb*Lb))+ea(Gb*Mb));rc=ea(ea(ea(xb*Kb)+ea(Cb*Lb))+ea(Hb*Mb));sc=ea(ea(ea(yb*Kb)+ea(Db*Lb))+ea(Ib*Mb));tc=ea(sc);sc=ea(ea(ea(Xb*ec)+ea(Sb*fc))+ea(ac*gc));uc=ea(ea(ea(Yb*ec)+ea(Tb*fc))+ea(bc*gc));vc=ea(ea(ea(Zb*ec)+ea(Ub*fc))+ea(cc*gc));wc=ea(kc);kc=ea(oc);oc=ea(sc);sc=ea(lc);lc=ea(rc);rc=ea(uc);uc=ea(mc);mc=ea(pc);pc=ea(vc);g[f>>2]=nc;g[y>>2]=wc;g[K>>2]=kc;g[q>>2]=oc;g[L>>2]=sc;g[M>>2]=qc;g[N>>2]=lc;g[O>>2]=rc;g[P>>2]=uc;g[Q>>2]=mc;g[R>>2]=tc;g[S>>2]=pc;xc=h+0|0;yc=xc+96|0;do{c[xc>>2]=0;xc=xc+4|0}while((xc|0)<(yc|0));c[T>>2]=c[119914];c[U>>2]=c[119915];c[V>>2]=c[119916];c[W>>2]=c[119917];$ma(j,a,f,h);_ma(a,j,f,h);pc=ea(g[T>>2]);xc=pc>ea(g[119914]);tc=ea(g[U>>2]);yc=tc>ea(g[119915]);mc=ea(g[V>>2]);zc=mc>ea(g[119916]);uc=ea(g[W>>2]);Ac=uc>ea(g[119917]);c[l>>2]=~((xc^1)<<31>>31);c[X>>2]=~((yc^1)<<31>>31);c[Y>>2]=~((zc^1)<<31>>31);c[Z>>2]=~((Ac^1)<<31>>31);if(xc|yc|zc|Ac){rc=ea(ea(1.0)/pc);pc=ea(ea(1.0)/tc);tc=ea(ea(1.0)/mc);mc=ea(ea(1.0)/uc);g[m>>2]=rc;g[_>>2]=pc;g[$>>2]=tc;g[aa>>2]=mc;uc=ea(ea(g[h>>2])*rc);lc=ea(ea(g[ba>>2])*pc);qc=ea(ea(g[ca>>2])*tc);sc=ea(mc*ea(g[da>>2]));oc=ea(rc*ea(g[fa>>2]));kc=ea(pc*ea(g[ga>>2]));wc=ea(tc*ea(g[ha>>2]));nc=ea(mc*ea(g[ia>>2]));vc=ea(rc*ea(g[ja>>2]));rc=ea(pc*ea(g[ka>>2]));pc=ea(tc*ea(g[la>>2]));tc=ea(mc*ea(g[ma>>2]));Ac=c[119937]|0;mc=ea(g[119934]);Bc=ea(g[119935]);Cc=ea(g[119936]);Dc=ea(Ua*Xa);Ec=ea(Va*Xa);Fc=ea(Wa*Xa);Gc=ea(ob*rb);Hc=ea(pb*rb);Ic=ea(qb*rb);Jc=ea(Kb*Nb);Kc=ea(Lb*Nb);Lc=ea(Mb*Nb);Mc=ea(ec*hc);Nc=ea(fc*hc);Oc=ea(gc*hc);if(u){zc=(e[Qa>>1]|0)<<4;Pc=ea(g[x+zc>>2]);Qc=ea(g[x+(zc|4)>>2]);Rc=ea(g[x+(zc|8)>>2]);Sc=ea(g[x+(zc|12)>>2]);zc=(e[p>>1]|0)<<4;Tc=ea(g[x+zc>>2]);Uc=ea(g[x+(zc|4)>>2]);Vc=ea(g[x+(zc|8)>>2]);Wc=ea(g[x+(zc|12)>>2]);zc=(e[Ra>>1]|0)<<4;Xc=ea(g[x+zc>>2]);Yc=ea(g[x+(zc|4)>>2]);Zc=ea(g[x+(zc|8)>>2]);_c=ea(g[x+(zc|12)>>2]);zc=(e[_a>>1]|0)<<4;$c=ea(g[x+zc>>2]);ad=ea(g[x+(zc|4)>>2]);bd=ea(g[x+(zc|8)>>2]);cd=ea(g[x+(zc|12)>>2]);zc=(e[$a>>1]|0)<<4;dd=ea(g[x+zc>>2]);ed=ea(g[x+(zc|4)>>2]);fd=ea(g[x+(zc|8)>>2]);gd=ea(g[x+(zc|12)>>2]);zc=(e[eb>>1]|0)<<4;hd=ea(g[x+zc>>2]);id=ea(g[x+(zc|4)>>2]);jd=ea(g[x+(zc|8)>>2]);kd=ea(g[x+(zc|12)>>2]);zc=(e[ub>>1]|0)<<4;ld=ea(g[x+zc>>2]);md=ea(g[x+(zc|4)>>2]);nd=ea(g[x+(zc|8)>>2]);od=ea(g[x+(zc|12)>>2]);zc=(e[vb>>1]|0)<<4;pd=ea(g[x+zc>>2]);qd=ea(g[x+(zc|4)>>2]);rd=ea(g[x+(zc|8)>>2]);sd=ea(g[x+(zc|12)>>2]);zc=(e[Ab>>1]|0)<<4;td=ea(g[x+zc>>2]);ud=ea(g[x+(zc|4)>>2]);vd=ea(g[x+(zc|8)>>2]);wd=ea(g[x+(zc|12)>>2]);zc=(e[Rb>>1]|0)<<4;xd=ea(g[x+zc>>2]);yd=ea(g[x+(zc|4)>>2]);zd=ea(g[x+(zc|8)>>2]);Ad=ea(g[x+(zc|12)>>2]);zc=(e[Qb>>1]|0)<<4;Bd=ea(g[x+zc>>2]);Cd=ea(g[x+(zc|4)>>2]);Dd=ea(g[x+(zc|8)>>2]);Ed=ea(g[x+(zc|12)>>2]);zc=(e[Wb>>1]|0)<<4;Fd=ea(g[x+zc>>2]);Gd=ea(g[x+(zc|4)>>2]);Hd=ea(g[x+(zc|8)>>2]);Id=ea(g[x+(zc|12)>>2]);Jd=ea(ea(ea(Ua*Pc)+ea(Va*Tc))+ea(Wa*Xc));Kd=ea(ea(ea(Ua*Qc)+ea(Va*Uc))+ea(Wa*Yc));Ld=ea(ea(ea(Ua*Rc)+ea(Va*Vc))+ea(Wa*Zc));Md=ea(Jd);Jd=ea(ea(ea(ob*$c)+ea(pb*dd))+ea(qb*hd));Nd=ea(ea(ea(ob*ad)+ea(pb*ed))+ea(qb*id));Od=ea(ea(ea(ob*bd)+ea(pb*fd))+ea(qb*jd));Pd=ea(Nd);Nd=ea(ea(ea(Kb*ld)+ea(Lb*pd))+ea(Mb*td));Qd=ea(ea(ea(Kb*md)+ea(Lb*qd))+ea(Mb*ud));Rd=ea(ea(ea(Kb*nd)+ea(Lb*rd))+ea(Mb*vd));Sd=ea(Rd);Rd=ea(ea(ea(ec*xd)+ea(fc*Bd))+ea(gc*Fd));Td=ea(ea(ea(ec*yd)+ea(fc*Cd))+ea(gc*Gd));Ud=ea(ea(ea(ec*zd)+ea(fc*Dd))+ea(gc*Hd));Vd=ea(Jd);Jd=ea(Nd);Nd=ea(Rd);Rd=ea(Kd);Kd=ea(Qd);Qd=ea(Td);Td=ea(Ld);Ld=ea(Od);Od=ea(Ud);g[n>>2]=Md;g[na>>2]=Vd;g[oa>>2]=Jd;g[pa>>2]=Nd;g[qa>>2]=Rd;g[ra>>2]=Pd;g[sa>>2]=Kd;g[ta>>2]=Qd;g[ua>>2]=Td;g[va>>2]=Ld;g[wa>>2]=Sd;g[xa>>2]=Od;zc=c[119935]|0;yc=c[119936]|0;xc=c[119937]|0;c[ya>>2]=c[119934];c[za>>2]=zc;c[Aa>>2]=yc;c[Ba>>2]=xc;K_a(h,fa,ja,Ca,Da,Ea,f,n,m,d,l,o);Od=ea(g[Fa>>2]);Sd=ea(g[Ga>>2]);Ld=ea(g[Ha>>2]);Td=ea(g[Ia>>2]);Qd=ea(g[Ja>>2]);Kd=ea(g[Ka>>2]);Pd=ea(g[La>>2]);g[Fa>>2]=Pd;Rd=ea(g[Ma>>2]);g[Ga>>2]=Rd;Nd=ea(g[ya>>2]);g[Ha>>2]=Nd;g[La>>2]=Od;Jd=ea(g[Na>>2]);g[Ia>>2]=Jd;Vd=ea(g[za>>2]);g[Ja>>2]=Vd;g[Ma>>2]=Sd;g[Na>>2]=Td;Md=ea(g[Aa>>2]);g[Ka>>2]=Md;g[ya>>2]=Ld;g[za>>2]=Qd;g[Aa>>2]=Kd;Ud=ea(g[o>>2]);Wd=ea(Pc-ea(Dc*Ud));Pc=ea(Qc-ea(Dc*Pd));Qc=ea(Rc-ea(Dc*Rd));Rc=ea(Sc-ea(Dc*Nd));Sc=ea(Tc-ea(Ec*Ud));Tc=ea(Uc-ea(Ec*Pd));Uc=ea(Vc-ea(Ec*Rd));Vc=ea(Wc-ea(Ec*Nd));Wc=ea(Xc-ea(Fc*Ud));Ud=ea(Yc-ea(Fc*Pd));Pd=ea(Zc-ea(Fc*Rd));Rd=ea(_c-ea(Fc*Nd));Nd=ea(Gc*Od);_c=ea(g[Oa>>2]);Zc=ea($c-Nd);Nd=ea(ad-ea(Gc*_c));ad=ea(bd-ea(Gc*Jd));bd=ea(cd-ea(Gc*Vd));cd=ea(dd-ea(Hc*Od));dd=ea(ed-ea(Hc*_c));ed=ea(fd-ea(Hc*Jd));fd=ea(gd-ea(Hc*Vd));gd=ea(hd-ea(Ic*Od));Od=ea(id-ea(Ic*_c));_c=ea(jd-ea(Ic*Jd));Jd=ea(kd-ea(Ic*Vd));Vd=ea(Jc*Sd);kd=ea(Jc*Td);jd=ea(g[Pa>>2]);id=ea(ld-Vd);Vd=ea(md-kd);kd=ea(nd-ea(Jc*jd));nd=ea(od-ea(Jc*Md));od=ea(pd-ea(Kc*Sd));pd=ea(qd-ea(Kc*Td));qd=ea(rd-ea(Kc*jd));rd=ea(sd-ea(Kc*Md));sd=ea(td-ea(Lc*Sd));Sd=ea(ud-ea(Lc*Td));Td=ea(vd-ea(Lc*jd));jd=ea(wd-ea(Lc*Md));Md=ea(Mc*Ld);wd=ea(Mc*Qd);vd=ea(Mc*Kd);ud=ea(g[Ba>>2]);td=ea(xd-Md);Md=ea(yd-wd);wd=ea(zd-vd);vd=ea(Ad-ea(Mc*ud));Ad=ea(Bd-ea(Nc*Ld));Bd=ea(Cd-ea(Nc*Qd));Cd=ea(Dd-ea(Nc*Kd));Dd=ea(Ed-ea(Nc*ud));Ed=ea(Fd-ea(Oc*Ld));Ld=ea(Gd-ea(Oc*Qd));Qd=ea(Hd-ea(Oc*Kd));Kd=ea(Id-ea(Oc*ud));xc=(e[Qa>>1]|0)<<4;g[x+xc>>2]=Wd;g[x+(xc|4)>>2]=Pc;g[x+(xc|8)>>2]=Qc;g[x+(xc|12)>>2]=Rc;xc=(e[p>>1]|0)<<4;g[x+xc>>2]=Sc;g[x+(xc|4)>>2]=Tc;g[x+(xc|8)>>2]=Uc;g[x+(xc|12)>>2]=Vc;xc=(e[Ra>>1]|0)<<4;g[x+xc>>2]=Wc;g[x+(xc|4)>>2]=Ud;g[x+(xc|8)>>2]=Pd;g[x+(xc|12)>>2]=Rd;xc=(e[_a>>1]|0)<<4;g[x+xc>>2]=Zc;g[x+(xc|4)>>2]=Nd;g[x+(xc|8)>>2]=ad;g[x+(xc|12)>>2]=bd;xc=(e[$a>>1]|0)<<4;g[x+xc>>2]=cd;g[x+(xc|4)>>2]=dd;g[x+(xc|8)>>2]=ed;g[x+(xc|12)>>2]=fd;xc=(e[eb>>1]|0)<<4;g[x+xc>>2]=gd;g[x+(xc|4)>>2]=Od;g[x+(xc|8)>>2]=_c;g[x+(xc|12)>>2]=Jd;xc=(e[ub>>1]|0)<<4;g[x+xc>>2]=id;g[x+(xc|4)>>2]=Vd;g[x+(xc|8)>>2]=kd;g[x+(xc|12)>>2]=nd;xc=(e[vb>>1]|0)<<4;g[x+xc>>2]=od;g[x+(xc|4)>>2]=pd;g[x+(xc|8)>>2]=qd;g[x+(xc|12)>>2]=rd;xc=(e[Ab>>1]|0)<<4;g[x+xc>>2]=sd;g[x+(xc|4)>>2]=Sd;g[x+(xc|8)>>2]=Td;g[x+(xc|12)>>2]=jd;xc=(e[Rb>>1]|0)<<4;g[x+xc>>2]=td;g[x+(xc|4)>>2]=Md;g[x+(xc|8)>>2]=wd;g[x+(xc|12)>>2]=vd;xc=(e[Qb>>1]|0)<<4;g[x+xc>>2]=Ad;g[x+(xc|4)>>2]=Bd;g[x+(xc|8)>>2]=Cd;g[x+(xc|12)>>2]=Dd;xc=(e[Wb>>1]|0)<<4;g[x+xc>>2]=Ed;g[x+(xc|4)>>2]=Ld;g[x+(xc|8)>>2]=Qd;g[x+(xc|12)>>2]=Kd}if(t){Kd=ea(g[m>>2]);Qd=ea(Kd*Kd);Kd=ea(g[_>>2]);Ld=ea(Kd*Kd);Kd=ea(g[$>>2]);Ed=ea(Kd*Kd);Kd=ea(g[aa>>2]);Dd=ea(Kd*Kd);Kd=ea(g[h>>2]);Cd=ea(Kd*Kd);Kd=ea(g[ba>>2]);Bd=ea(Kd*Kd);Kd=ea(g[ca>>2]);Ad=ea(Kd*Kd);Kd=ea(g[da>>2]);vd=ea(Kd*Kd);Kd=ea(g[fa>>2]);wd=ea(Kd*Kd);Kd=ea(g[ga>>2]);Md=ea(Kd*Kd);Kd=ea(g[ha>>2]);td=ea(Kd*Kd);Kd=ea(g[ia>>2]);jd=ea(Cd+wd);wd=ea(Bd+Md);Md=ea(Ad+td);td=ea(vd+ea(Kd*Kd));Kd=ea(g[ja>>2]);vd=ea(Kd*Kd);Kd=ea(g[ka>>2]);Ad=ea(Kd*Kd);Kd=ea(g[la>>2]);Bd=ea(Kd*Kd);Kd=ea(g[ma>>2]);Cd=ea(Qd*ea(jd+vd));vd=ea(Ld*ea(wd+Ad));Ad=ea(Ed*ea(Md+Bd));Bd=ea(Dd*ea(td+ea(Kd*Kd)));Kd=ea(r*Cd);Cd=ea(r*vd);vd=ea(r*Ad);Ad=ea(r*Bd);Bd=ea(g[119938]);td=ea(Kd+Bd);Kd=ea(g[119939]);Dd=ea(Cd+Kd);Cd=ea(g[119940]);Md=ea(vd+Cd);vd=ea(g[119941]);Ed=ea(ea(ea(1.0)/td)-Bd);td=ea(ea(ea(1.0)/Dd)-Kd);Dd=ea(ea(ea(1.0)/Md)-Cd);Md=ea(ea(ea(1.0)/ea(Ad+vd))-vd);vd=ea(g[l>>2]);xc=(g[k>>2]=vd,c[k>>2]|0);vd=ea(Ed*(c[k>>2]=xc&Sa,ea(g[k>>2])));Ad=ea(Ed*(c[k>>2]=xc&Ya,ea(g[k>>2])));wd=ea(Bd+vd);vd=ea(Kd+Ad);Ad=ea(Cd+ea(Ed*(c[k>>2]=xc&Za,ea(g[k>>2]))));Ed=ea(g[X>>2]);xc=(g[k>>2]=Ed,c[k>>2]|0);Ed=ea(td*(c[k>>2]=xc&jb,ea(g[k>>2])));Ld=ea(td*(c[k>>2]=xc&sb,ea(g[k>>2])));jd=ea(Bd+Ed);Ed=ea(Kd+Ld);Ld=ea(Cd+ea(td*(c[k>>2]=xc&tb,ea(g[k>>2]))));td=ea(g[Y>>2]);xc=(g[k>>2]=td,c[k>>2]|0);td=ea(Dd*(c[k>>2]=xc&Fb,ea(g[k>>2])));Qd=ea(Dd*(c[k>>2]=xc&Ob,ea(g[k>>2])));Td=ea(Bd+td);td=ea(Kd+Qd);Qd=ea(Cd+ea(Dd*(c[k>>2]=xc&Pb,ea(g[k>>2]))));Dd=ea(g[Z>>2]);xc=(g[k>>2]=Dd,c[k>>2]|0);Dd=ea(Md*(c[k>>2]=xc&$b,ea(g[k>>2])));Sd=ea(Md*(c[k>>2]=xc&ic,ea(g[k>>2])));sd=ea(Bd+Dd);Dd=ea(Kd+Sd);Sd=ea(Cd+ea(Md*(c[k>>2]=xc&jc,ea(g[k>>2]))));xc=c[119950]|0;yc=c[119951]|0;zc=c[119952]|0;Xd=c[119953]|0;Yd=(g[k>>2]=wd,c[k>>2]|0);Zd=c[119930]|0;_d=c[119931]|0;$d=c[119932]|0;ae=c[119933]|0;wd=ea(G*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));Md=ea(E*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Cd=ea(F*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));Kd=ea(I*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=vd,c[k>>2]|0);vd=ea(H*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));Bd=ea(D*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));rd=ea(B*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));qd=ea(z*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Ad,c[k>>2]|0);Ad=ea(C*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));pd=ea(A*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));od=ea(s*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));nd=ea(Ta*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=jd,c[k>>2]|0);jd=ea(ab*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));kd=ea(bb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Vd=ea(cb*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));id=ea(db*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Ed,c[k>>2]|0);Ed=ea(fb*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));Jd=ea(gb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));_c=ea(hb*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));Od=ea(ib*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Ld,c[k>>2]|0);Ld=ea(kb*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));gd=ea(lb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));fd=ea(mb*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));ed=ea(nb*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Td,c[k>>2]|0);Td=ea(wb*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));dd=ea(xb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));cd=ea(yb*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));bd=ea(zb*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=td,c[k>>2]|0);td=ea(Bb*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));ad=ea(Cb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Nd=ea(Db*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));Zc=ea(Eb*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Qd,c[k>>2]|0);Qd=ea(Gb*(c[k>>2]=Zd&Yd|xc,ea(g[k>>2])));Rd=ea(Hb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Pd=ea(Ib*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));Ud=ea(Jb*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=sd,c[k>>2]|0);sd=ea(Xb*(c[k>>2]=Yd&Zd|xc,ea(g[k>>2])));Wc=ea(Yb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Vc=ea(Zb*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));Uc=ea(_b*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Dd,c[k>>2]|0);Dd=ea(Sb*(c[k>>2]=Yd&Zd|xc,ea(g[k>>2])));Tc=ea(Tb*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Sc=ea(Ub*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));Rc=ea(Vb*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Yd=(g[k>>2]=Sd,c[k>>2]|0);Sd=ea(ac*(c[k>>2]=Yd&Zd|xc,ea(g[k>>2])));Qc=ea(bc*(c[k>>2]=_d&Yd|yc,ea(g[k>>2])));Pc=ea(cc*(c[k>>2]=$d&Yd|zc,ea(g[k>>2])));be=Kd;ce=Cd;de=Md;ee=wd;fe=qd;ge=rd;he=Bd;ie=vd;je=nd;ke=od;le=pd;me=Ad;ne=id;oe=Vd;pe=kd;qe=jd;re=Od;se=_c;te=Jd;ue=Ed;ve=ed;we=fd;xe=gd;ye=Ld;ze=bd;Ae=cd;Be=dd;Ce=Td;De=Zc;Ee=Nd;Fe=ad;Ge=td;He=Ud;Ie=Pd;Je=Rd;Ke=Qd;Le=Rc;Me=Sc;Ne=Tc;Oe=Dd;Pe=Uc;Qe=Vc;Re=Wc;Se=sd;Te=ea(dc*(c[k>>2]=ae&Yd|Xd,ea(g[k>>2])));Ue=Pc;Ve=Qc;We=Sd}else{be=I;ce=F;de=E;ee=G;fe=z;ge=B;he=D;ie=H;je=Ta;ke=s;le=A;me=C;ne=db;oe=cb;pe=bb;qe=ab;re=ib;se=hb;te=gb;ue=fb;ve=nb;we=mb;xe=lb;ye=kb;ze=zb;Ae=yb;Be=xb;Ce=wb;De=Eb;Ee=Db;Fe=Cb;Ge=Bb;He=Jb;Ie=Ib;Je=Hb;Ke=Gb;Le=Vb;Me=Ub;Ne=Tb;Oe=Sb;Pe=_b;Qe=Zb;Re=Yb;Se=Xb;Te=dc;Ue=cc;Ve=bc;We=ac}Sd=ea(ea(Dc*uc)+ee);Qc=ea(ea(Dc*oc)+de);Pc=ea(ea(Dc*vc)+ce);sd=ea(ea(Dc*mc)+be);Dc=ea(ea(Ec*uc)+ie);Wc=ea(ea(Ec*oc)+he);Vc=ea(ea(Ec*vc)+ge);Uc=ea(ea(Ec*mc)+fe);Ec=ea(ea(Fc*uc)+me);uc=ea(ea(Fc*oc)+le);oc=ea(ea(Fc*vc)+ke);vc=ea(ea(Fc*mc)+je);mc=ea(ea(Gc*lc)+qe);Fc=ea(ea(Gc*kc)+pe);Dd=ea(ea(Gc*rc)+oe);Tc=ea(ea(Gc*Bc)+ne);Gc=ea(ea(Hc*lc)+ue);Sc=ea(ea(Hc*kc)+te);Rc=ea(ea(Hc*rc)+se);Qd=ea(ea(Hc*Bc)+re);Hc=ea(ea(Ic*lc)+ye);lc=ea(ea(Ic*kc)+xe);kc=ea(ea(Ic*rc)+we);rc=ea(ea(Ic*Bc)+ve);Bc=ea(ea(Jc*qc)+Ce);Ic=ea(ea(Jc*wc)+Be);Rd=ea(ea(Jc*pc)+Ae);Pd=ea(ea(Jc*Cc)+ze);Jc=ea(ea(Kc*qc)+Ge);Ud=ea(ea(Kc*wc)+Fe);td=ea(ea(Kc*pc)+Ee);ad=ea(ea(Kc*Cc)+De);Kc=ea(ea(Lc*qc)+Ke);qc=ea(ea(Lc*wc)+Je);wc=ea(ea(Lc*pc)+Ie);pc=ea(ea(Lc*Cc)+He);Cc=ea(Mc*sc);Lc=ea(Mc*nc);Nd=ea(Mc*tc);Zc=(c[k>>2]=Ac,ea(g[k>>2]));Td=ea(Cc+Se);Cc=ea(Lc+Re);Lc=ea(Nd+Qe);Nd=ea(ea(Mc*Zc)+Pe);Mc=ea(ea(Nc*sc)+Oe);dd=ea(ea(Nc*nc)+Ne);cd=ea(ea(Nc*tc)+Me);bd=ea(ea(Nc*Zc)+Le);Nc=ea(ea(Oc*sc)+We);sc=ea(ea(Oc*nc)+Ve);nc=ea(ea(Oc*tc)+Ue);tc=ea(ea(Oc*Zc)+Te);Ac=(e[Qa>>1]|0)<<4;g[w+Ac>>2]=Sd;g[w+(Ac|4)>>2]=Qc;g[w+(Ac|8)>>2]=Pc;g[w+(Ac|12)>>2]=sd;Ac=(e[p>>1]|0)<<4;g[w+Ac>>2]=Dc;g[w+(Ac|4)>>2]=Wc;g[w+(Ac|8)>>2]=Vc;g[w+(Ac|12)>>2]=Uc;Ac=(e[Ra>>1]|0)<<4;g[w+Ac>>2]=Ec;g[w+(Ac|4)>>2]=uc;g[w+(Ac|8)>>2]=oc;g[w+(Ac|12)>>2]=vc;Ac=(e[_a>>1]|0)<<4;g[w+Ac>>2]=mc;g[w+(Ac|4)>>2]=Fc;g[w+(Ac|8)>>2]=Dd;g[w+(Ac|12)>>2]=Tc;Ac=(e[$a>>1]|0)<<4;g[w+Ac>>2]=Gc;g[w+(Ac|4)>>2]=Sc;g[w+(Ac|8)>>2]=Rc;g[w+(Ac|12)>>2]=Qd;Ac=(e[eb>>1]|0)<<4;g[w+Ac>>2]=Hc;g[w+(Ac|4)>>2]=lc;g[w+(Ac|8)>>2]=kc;g[w+(Ac|12)>>2]=rc;Ac=(e[ub>>1]|0)<<4;g[w+Ac>>2]=Bc;g[w+(Ac|4)>>2]=Ic;g[w+(Ac|8)>>2]=Rd;g[w+(Ac|12)>>2]=Pd;Ac=(e[vb>>1]|0)<<4;g[w+Ac>>2]=Jc;g[w+(Ac|4)>>2]=Ud;g[w+(Ac|8)>>2]=td;g[w+(Ac|12)>>2]=ad;Ac=(e[Ab>>1]|0)<<4;g[w+Ac>>2]=Kc;g[w+(Ac|4)>>2]=qc;g[w+(Ac|8)>>2]=wc;g[w+(Ac|12)>>2]=pc;Ac=(e[Rb>>1]|0)<<4;g[w+Ac>>2]=Td;g[w+(Ac|4)>>2]=Cc;g[w+(Ac|8)>>2]=Lc;g[w+(Ac|12)>>2]=Nd;Ac=(e[Qb>>1]|0)<<4;g[w+Ac>>2]=Mc;g[w+(Ac|4)>>2]=dd;g[w+(Ac|8)>>2]=cd;g[w+(Ac|12)>>2]=bd;Ac=(e[Wb>>1]|0)<<4;g[w+Ac>>2]=Nc;g[w+(Ac|4)>>2]=sc;g[w+(Ac|8)>>2]=nc;g[w+(Ac|12)>>2]=tc}Qa=Qa+32|0}while((Qa|0)!=(J|0));i=b;return}function Vma(a){a=a|0;var b=0,d=0;b=(c[a+420>>2]|0)*80|0;d=c[a+396>>2]<<5;return (b>>>0<d>>>0?d:b)|0}function Wma(a){a=a|0;return (c[a+360>>2]<<5)+((c[a+348>>2]|0)*96|0)|0}function Xma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;e=c[(c[a+432>>2]|0)+152>>2]|0;f=b+(e<<4)|0;if(!e){i=d;return}h=ea(g[a+384>>2]);j=ea(g[a+388>>2]);k=ea(g[a+392>>2]);l=ea(g[a+400>>2]);m=ea(g[a+404>>2]);n=ea(g[a+408>>2]);e=a+96|0;o=b;b=1;while(1){p=ea(g[o>>2]);q=ea(g[o+4>>2]);r=ea(g[o+8>>2]);s=ea(g[o+12>>2]);t=ea(ea(ea(p-s)*h)+l);u=ea(ea(ea(q-s)*j)+m);v=ea(ea(ea(r-s)*k)+n);w=ea(g[119934]);x=ea(g[119935]);y=ea(g[119936]);z=~~ea(R(ea(t<w?w:t)));A=~~ea(R(ea(u<x?x:u)));B=~~ea(R(ea(v<y?y:v)));v=ea(ea(ea(p+s)*h)+l);p=ea(ea(ea(q+s)*j)+m);q=ea(ea(ea(r+s)*k)+n);s=ea(g[119954]);r=ea(g[119955]);y=ea(g[119956]);C=~~ea(R(ea(s<v?s:v)));D=~~ea(R(ea(r<p?r:p)));E=~~ea(R(ea(y<q?y:q)));if((z|0)<8){F=z;do{z=a+(F<<2)|0;c[z>>2]=c[z>>2]|b;F=F+1|0}while((F|0)!=8)}if((C|0)>-1){F=C;while(1){z=e+(F<<2)|0;c[z>>2]=c[z>>2]|b;if((F|0)>0)F=F+-1|0;else break}}F=a+32|0;C=a+128|0;if((A|0)<8){z=A;do{G=F+(z<<2)|0;c[G>>2]=c[G>>2]|b;z=z+1|0}while((z|0)!=8)}if((D|0)>-1){z=D;while(1){F=C+(z<<2)|0;c[F>>2]=c[F>>2]|b;if((z|0)>0)z=z+-1|0;else break}}z=a+64|0;C=a+160|0;if((B|0)<8){D=B;do{F=z+(D<<2)|0;c[F>>2]=c[F>>2]|b;D=D+1|0}while((D|0)!=8)}if((E|0)>-1){D=E;while(1){z=C+(D<<2)|0;c[z>>2]=c[z>>2]|b;if((D|0)>0)D=D+-1|0;else break}}D=o+16|0;if((D|0)==(f|0))break;o=D;b=b<<1}i=d;return}function Yma(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=ea(g[b+384>>2]);f=ea(e*ea(g[d>>2]));h=ea(e*ea(g[d+4>>2]));i=ea(e*ea(g[d+8>>2]));j=ea(e*ea(g[d+12>>2]));e=ea(g[b+400>>2]);k=ea(f+e);f=ea(h+e);h=ea(i+e);i=ea(j+e);e=ea(g[b+388>>2]);j=ea(e*ea(g[d+16>>2]));l=ea(e*ea(g[d+20>>2]));m=ea(e*ea(g[d+24>>2]));n=ea(e*ea(g[d+28>>2]));e=ea(g[b+404>>2]);o=ea(j+e);j=ea(l+e);l=ea(m+e);m=ea(n+e);e=ea(g[b+392>>2]);n=ea(e*ea(g[d+32>>2]));p=ea(e*ea(g[d+36>>2]));q=ea(e*ea(g[d+40>>2]));r=ea(e*ea(g[d+44>>2]));e=ea(g[b+408>>2]);s=ea(n+e);n=ea(p+e);p=ea(q+e);q=ea(r+e);d=b+192|0;t=~~ea(R(ea(k)));u=~~ea(R(ea(f)));v=~~ea(R(ea(h)));w=~~ea(R(ea(i)));x=t&7;y=u&7;z=v&7;A=w&7;B=t>>>0<8;t=u>>>0<8;u=v>>>0<8;v=w>>>0<8;w=b+32|0;C=b+224|0;D=~~ea(R(ea(o)));E=~~ea(R(ea(j)));F=~~ea(R(ea(l)));G=~~ea(R(ea(m)));H=D&7;I=E&7;J=F&7;K=G&7;L=D>>>0<8;D=E>>>0<8;E=F>>>0<8;F=G>>>0<8;G=(B?c[b+(x<<2)>>2]|0:0)&(L?c[w+(H<<2)>>2]|0:0);M=(t?c[b+(y<<2)>>2]|0:0)&(D?c[w+(I<<2)>>2]|0:0);N=(u?c[b+(z<<2)>>2]|0:0)&(E?c[w+(J<<2)>>2]|0:0);O=(v?c[b+(A<<2)>>2]|0:0)&(F?c[w+(K<<2)>>2]|0:0);w=b+64|0;P=b+256|0;b=~~ea(R(ea(s)));Q=~~ea(R(ea(n)));S=~~ea(R(ea(p)));T=~~ea(R(ea(q)));U=b&7;V=Q&7;W=S&7;X=T&7;Y=b>>>0<8;b=Q>>>0<8;Q=S>>>0<8;S=T>>>0<8;T=Y?c[w+(U<<2)>>2]|0:0;Z=b?c[w+(V<<2)>>2]|0:0;_=Q?c[w+(W<<2)>>2]|0:0;$=S?c[w+(X<<2)>>2]|0:0;w=(t?c[d+(y<<2)>>2]|0:0)&(D?c[C+(I<<2)>>2]|0:0)&(b?c[P+(V<<2)>>2]|0:0);V=(u?c[d+(z<<2)>>2]|0:0)&(E?c[C+(J<<2)>>2]|0:0)&(Q?c[P+(W<<2)>>2]|0:0);W=(v?c[d+(A<<2)>>2]|0:0)&(F?c[C+(K<<2)>>2]|0:0)&(S?c[P+(X<<2)>>2]|0:0);c[a>>2]=(B?c[d+(x<<2)>>2]|0:0)&(L?c[C+(H<<2)>>2]|0:0)&(Y?c[P+(U<<2)>>2]|0:0);c[a+4>>2]=w;c[a+8>>2]=V;c[a+12>>2]=W;c[a+16>>2]=G&T;c[a+20>>2]=M&Z;c[a+24>>2]=N&_;c[a+28>>2]=O&$;return}function Zma(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;f=i;h=ea(g[b+384>>2]);j=ea(g[b+388>>2]);k=ea(g[b+392>>2]);l=ea(g[b+400>>2]);m=ea(g[b+404>>2]);n=ea(g[b+408>>2]);o=ea(h*ea(g[d>>2]));p=ea(h*ea(g[d+4>>2]));q=ea(h*ea(g[d+8>>2]));r=ea(l+o);o=ea(l+p);p=ea(l+q);q=ea(l+ea(h*ea(g[d+12>>2])));s=ea(j*ea(g[d+16>>2]));t=ea(j*ea(g[d+20>>2]));u=ea(j*ea(g[d+24>>2]));v=ea(m+s);s=ea(m+t);t=ea(m+u);u=ea(m+ea(j*ea(g[d+28>>2])));w=ea(k*ea(g[d+32>>2]));x=ea(k*ea(g[d+36>>2]));y=ea(k*ea(g[d+40>>2]));z=ea(n+w);w=ea(n+x);x=ea(n+y);y=ea(n+ea(k*ea(g[d+44>>2])));A=ea(h*ea(g[e>>2]));B=ea(h*ea(g[e+4>>2]));C=ea(h*ea(g[e+8>>2]));D=ea(l+A);A=ea(l+B);B=ea(l+C);C=ea(l+ea(h*ea(g[e+12>>2])));h=ea(j*ea(g[e+16>>2]));l=ea(j*ea(g[e+20>>2]));E=ea(j*ea(g[e+24>>2]));F=ea(m+h);h=ea(m+l);l=ea(m+E);E=ea(m+ea(j*ea(g[e+28>>2])));j=ea(k*ea(g[e+32>>2]));m=ea(k*ea(g[e+36>>2]));G=ea(k*ea(g[e+40>>2]));H=ea(n+j);j=ea(n+m);m=ea(n+G);G=ea(n+ea(k*ea(g[e+44>>2])));k=r<D?D:r;n=o<A?A:o;I=p<B?B:p;J=q<C?C:q;K=ea(g[119954]);L=ea(g[119955]);M=ea(g[119956]);N=ea(g[119957]);O=v<F?F:v;P=s<h?h:s;Q=t<l?l:t;S=u<E?E:u;T=z<H?H:z;U=w<j?j:w;V=x<m?m:x;W=y<G?G:y;e=b+192|0;d=~~ea(R(ea(K<k?K:k)));X=~~ea(R(ea(L<n?L:n)));Y=~~ea(R(ea(M<I?M:I)));Z=~~ea(R(ea(N<J?N:J)));_=d&7;$=X&7;aa=Y&7;ba=Z&7;ca=d>>>0<8;d=X>>>0<8;X=Y>>>0<8;Y=Z>>>0<8;Z=a+4|0;da=a+8|0;fa=a+12|0;ga=a+16|0;ha=a+20|0;ia=a+24|0;ja=a+28|0;ka=b+32|0;la=b+224|0;ma=~~ea(R(ea(K<O?K:O)));na=~~ea(R(ea(L<P?L:P)));oa=~~ea(R(ea(M<Q?M:Q)));pa=~~ea(R(ea(N<S?N:S)));qa=ma&7;ra=na&7;sa=oa&7;ta=pa&7;ua=ma>>>0<8;ma=na>>>0<8;na=oa>>>0<8;oa=pa>>>0<8;pa=(ca?c[b+(_<<2)>>2]|0:0)&(ua?c[ka+(qa<<2)>>2]|0:0);va=(d?c[b+($<<2)>>2]|0:0)&(ma?c[ka+(ra<<2)>>2]|0:0);wa=(X?c[b+(aa<<2)>>2]|0:0)&(na?c[ka+(sa<<2)>>2]|0:0);xa=(Y?c[b+(ba<<2)>>2]|0:0)&(oa?c[ka+(ta<<2)>>2]|0:0);ka=b+64|0;ya=b+256|0;za=~~ea(R(ea(K<T?K:T)));Aa=~~ea(R(ea(L<U?L:U)));Ba=~~ea(R(ea(M<V?M:V)));Ca=~~ea(R(ea(N<W?N:W)));Da=za&7;Ea=Aa&7;Fa=Ba&7;Ga=Ca&7;Ha=za>>>0<8;za=Aa>>>0<8;Aa=Ba>>>0<8;Ba=Ca>>>0<8;Ca=Ha?c[ka+(Da<<2)>>2]|0:0;Ia=za?c[ka+(Ea<<2)>>2]|0:0;Ja=Aa?c[ka+(Fa<<2)>>2]|0:0;Ka=Ba?c[ka+(Ga<<2)>>2]|0:0;ka=(d?c[e+($<<2)>>2]|0:0)&(ma?c[la+(ra<<2)>>2]|0:0)&(za?c[ya+(Ea<<2)>>2]|0:0);Ea=(X?c[e+(aa<<2)>>2]|0:0)&(na?c[la+(sa<<2)>>2]|0:0)&(Aa?c[ya+(Fa<<2)>>2]|0:0);Fa=(Y?c[e+(ba<<2)>>2]|0:0)&(oa?c[la+(ta<<2)>>2]|0:0)&(Ba?c[ya+(Ga<<2)>>2]|0:0);c[a>>2]=(ca?c[e+(_<<2)>>2]|0:0)&(ua?c[la+(qa<<2)>>2]|0:0)&(Ha?c[ya+(Da<<2)>>2]|0:0);c[Z>>2]=ka;c[da>>2]=Ea;c[fa>>2]=Fa;c[ga>>2]=pa&Ca;c[ha>>2]=va&Ia;c[ia>>2]=wa&Ja;c[ja>>2]=xa&Ka;W=D<r?D:r;r=A<o?A:o;o=B<p?B:p;p=C<q?C:q;Ka=W<ea(0.0);q=Ka?ea(0.0):W;Ka=r<ea(0.0);W=Ka?ea(0.0):r;Ka=o<ea(0.0);r=Ka?ea(0.0):o;Ka=p<ea(0.0);o=Ka?ea(0.0):p;p=F<v?F:v;v=h<s?h:s;s=l<t?l:t;t=E<u?E:u;Ka=p<ea(0.0);u=Ka?ea(0.0):p;Ka=v<ea(0.0);p=Ka?ea(0.0):v;Ka=s<ea(0.0);v=Ka?ea(0.0):s;Ka=t<ea(0.0);s=Ka?ea(0.0):t;t=H<z?H:z;z=j<w?j:w;w=m<x?m:x;x=G<y?G:y;Ka=t<ea(0.0);y=Ka?ea(0.0):t;Ka=z<ea(0.0);t=Ka?ea(0.0):z;Ka=w<ea(0.0);z=Ka?ea(0.0):w;Ka=x<ea(0.0);w=Ka?ea(0.0):x;Ka=b+96|0;xa=b+288|0;Ja=~~ea(R(ea(q)));wa=~~ea(R(ea(W)));Ia=~~ea(R(ea(r)));va=~~ea(R(ea(o)));Ca=Ja&7;pa=wa&7;Fa=Ia&7;Ea=va&7;ka=Ja>>>0<8;Ja=wa>>>0<8;wa=Ia>>>0<8;Ia=va>>>0<8;va=b+128|0;Da=b+320|0;ya=~~ea(R(ea(u)));Ha=~~ea(R(ea(p)));qa=~~ea(R(ea(v)));la=~~ea(R(ea(s)));ua=ya&7;_=Ha&7;e=qa&7;ca=la&7;Ga=ya>>>0<8;ya=Ha>>>0<8;Ha=qa>>>0<8;qa=la>>>0<8;la=c[ga>>2]&(ka?c[Ka+(Ca<<2)>>2]|0:0)&(Ga?c[va+(ua<<2)>>2]|0:0);Ba=c[ha>>2]&(Ja?c[Ka+(pa<<2)>>2]|0:0)&(ya?c[va+(_<<2)>>2]|0:0);ta=c[ia>>2]&(wa?c[Ka+(Fa<<2)>>2]|0:0)&(Ha?c[va+(e<<2)>>2]|0:0);oa=c[ja>>2]&(Ia?c[Ka+(Ea<<2)>>2]|0:0)&(qa?c[va+(ca<<2)>>2]|0:0);va=b+160|0;Ka=b+352|0;b=~~ea(R(ea(y)));ba=~~ea(R(ea(t)));Y=~~ea(R(ea(z)));Aa=~~ea(R(ea(w)));sa=b&7;na=ba&7;aa=Y&7;X=Aa&7;za=b>>>0<8;b=ba>>>0<8;ba=Y>>>0<8;Y=Aa>>>0<8;Aa=za?c[va+(sa<<2)>>2]|0:0;ra=b?c[va+(na<<2)>>2]|0:0;ma=ba?c[va+(aa<<2)>>2]|0:0;$=Y?c[va+(X<<2)>>2]|0:0;va=c[Z>>2]&(Ja?c[xa+(pa<<2)>>2]|0:0)&(ya?c[Da+(_<<2)>>2]|0:0)&(b?c[Ka+(na<<2)>>2]|0:0);na=c[da>>2]&(wa?c[xa+(Fa<<2)>>2]|0:0)&(Ha?c[Da+(e<<2)>>2]|0:0)&(ba?c[Ka+(aa<<2)>>2]|0:0);aa=c[fa>>2]&(Ia?c[xa+(Ea<<2)>>2]|0:0)&(qa?c[Da+(ca<<2)>>2]|0:0)&(Y?c[Ka+(X<<2)>>2]|0:0);c[a>>2]=c[a>>2]&(ka?c[xa+(Ca<<2)>>2]|0:0)&(Ga?c[Da+(ua<<2)>>2]|0:0)&(za?c[Ka+(sa<<2)>>2]|0:0);c[Z>>2]=va;c[da>>2]=na;c[fa>>2]=aa;c[ga>>2]=la&Aa;c[ha>>2]=Ba&ra;c[ia>>2]=ta&ma;c[ja>>2]=oa&$;i=f;return}function _ma(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=0,$=Im,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0;f=i;h=c[a+424>>2]|0;j=ea(g[(c[a+432>>2]|0)+216>>2])>ea(0.0);k=c[b+4>>2]|c[b>>2]|c[b+8>>2]|c[b+12>>2];if(!k){i=f;return}b=d+4|0;l=d+8|0;m=d+12|0;n=d+16|0;o=d+20|0;p=d+24|0;q=d+28|0;r=d+32|0;s=d+36|0;t=d+40|0;u=d+44|0;v=e+4|0;w=e+8|0;x=e+12|0;y=e+16|0;z=e+20|0;A=e+24|0;B=e+28|0;C=e+32|0;D=e+36|0;E=e+40|0;F=e+44|0;G=e+96|0;H=e+100|0;I=e+104|0;J=e+108|0;K=a+416|0;a=e+48|0;L=e+52|0;M=e+56|0;N=e+60|0;O=e+64|0;P=e+68|0;Q=e+72|0;R=e+76|0;S=e+80|0;U=e+84|0;V=e+88|0;W=e+92|0;X=k;do{k=X&0-X;Y=0;while(1){k=k>>>1;if(!k)break;else Y=Y+1|0}k=Y<<4;X=X+-1&X;Z=ea(g[h+(Y<<4)>>2]);_=k|4;$=ea(g[h+_>>2]);aa=k|8;ba=ea(g[h+aa>>2]);ca=ea(g[h+(k|12)>>2]);da=ea(ea(g[d>>2])-Z);fa=ea(ea(g[b>>2])-Z);ga=ea(ea(g[l>>2])-Z);ha=ea(ea(g[m>>2])-Z);ia=ea(ea(g[n>>2])-$);ja=ea(ea(g[o>>2])-$);ka=ea(ea(g[p>>2])-$);la=ea(ea(g[q>>2])-$);ma=ea(ea(g[r>>2])-ba);na=ea(ea(g[s>>2])-ba);oa=ea(ea(g[t>>2])-ba);pa=ea(ea(g[u>>2])-ba);qa=ea(da*da);ra=ea(fa*fa);sa=ea(ga*ga);ta=ea(ha*ha);ua=ea(qa+ea(g[119914]));qa=ea(ra+ea(g[119915]));ra=ea(sa+ea(g[119916]));sa=ea(ea(1.0)-ea(ca*ea(ea(1.0)/ea(T(ea(ea(ma*ma)+ea(ea(ia*ia)+ua)))))));ua=ea(ea(1.0)-ea(ca*ea(ea(1.0)/ea(T(ea(ea(na*na)+ea(ea(ja*ja)+qa)))))));qa=ea(ea(1.0)-ea(ca*ea(ea(1.0)/ea(T(ea(ea(oa*oa)+ea(ea(ka*ka)+ra)))))));ra=ea(ea(1.0)-ea(ca*ea(ea(1.0)/ea(T(ea(ea(pa*pa)+ea(ea(la*la)+ea(ta+ea(g[119917])))))))));k=sa<ea(0.0);va=ua<ea(0.0);wa=qa<ea(0.0);xa=ra<ea(0.0);if(k|va|wa|xa?(ta=k?sa:ea(0.0),sa=ea(da*ta),da=va?ua:ea(0.0),ua=ea(fa*da),fa=wa?qa:ea(0.0),qa=ea(ga*fa),ga=xa?ra:ea(0.0),ra=ea(ha*ga),ha=ea(ea(g[e>>2])-sa),sa=ea(ea(g[v>>2])-ua),ua=ea(ea(g[w>>2])-qa),qa=ea(ea(g[x>>2])-ra),ra=ea(ha),ha=ea(sa),sa=ea(ua),ua=ea(qa),g[e>>2]=ra,g[v>>2]=ha,g[w>>2]=sa,g[x>>2]=ua,ua=ea(ia*ta),ia=ea(ja*da),ja=ea(ka*fa),ka=ea(la*ga),la=ea(ea(g[y>>2])-ua),ua=ea(ea(g[z>>2])-ia),ia=ea(ea(g[A>>2])-ja),ja=ea(ea(g[B>>2])-ka),ka=ea(la),la=ea(ua),ua=ea(ia),ia=ea(ja),g[y>>2]=ka,g[z>>2]=la,g[A>>2]=ua,g[B>>2]=ia,ia=ea(ma*ta),ta=ea(na*da),da=ea(oa*fa),fa=ea(pa*ga),ga=ea(ea(g[C>>2])-ia),ia=ea(ea(g[D>>2])-ta),ta=ea(ea(g[E>>2])-da),da=ea(ea(g[F>>2])-fa),fa=ea(ga),ga=ea(ia),ia=ea(ta),ta=ea(da),g[C>>2]=fa,g[D>>2]=ga,g[E>>2]=ia,g[F>>2]=ta,ta=ea(g[G>>2]),ia=ea((k?ea(1.0):ea(0.0))+ta),ta=ea(g[H>>2]),ga=ea((va?ea(1.0):ea(0.0))+ta),ta=ea(g[I>>2]),fa=ea((wa?ea(1.0):ea(0.0))+ta),ta=ea(g[J>>2]),da=ea((xa?ea(1.0):ea(0.0))+ta),ta=ea(ia),ia=ea(ga),ga=ea(fa),fa=ea(da),g[G>>2]=ta,g[H>>2]=ia,g[I>>2]=ga,g[J>>2]=fa,j):0){ya=c[K>>2]|0;fa=ea(g[ya+(Y<<4)>>2]);ga=ea(g[ya+_>>2]);ia=ea(Z-fa);fa=ea($-ga);ga=ea(ba-ea(g[ya+aa>>2]));ba=ea(g[a>>2]);$=ea((k?ia:ea(0.0))+ba);ba=ea(g[L>>2]);Z=ea((va?ia:ea(0.0))+ba);ba=ea(g[M>>2]);ta=ea((wa?ia:ea(0.0))+ba);ba=ea(g[N>>2]);da=ea((xa?ia:ea(0.0))+ba);ba=ea($);$=ea(Z);Z=ea(ta);ta=ea(da);g[a>>2]=ba;g[L>>2]=$;g[M>>2]=Z;g[N>>2]=ta;ta=ea(g[O>>2]);Z=ea((k?fa:ea(0.0))+ta);ta=ea(g[P>>2]);$=ea((va?fa:ea(0.0))+ta);ta=ea(g[Q>>2]);ba=ea((wa?fa:ea(0.0))+ta);ta=ea(g[R>>2]);da=ea((xa?fa:ea(0.0))+ta);ta=ea(Z);Z=ea($);$=ea(ba);ba=ea(da);g[O>>2]=ta;g[P>>2]=Z;g[Q>>2]=$;g[R>>2]=ba;ba=ea(g[S>>2]);$=ea((k?ga:ea(0.0))+ba);ba=ea(g[U>>2]);Z=ea((va?ga:ea(0.0))+ba);ba=ea(g[V>>2]);ta=ea((wa?ga:ea(0.0))+ba);ba=ea(g[W>>2]);da=ea((xa?ga:ea(0.0))+ba);ba=ea($);$=ea(Z);Z=ea(ta);ta=ea(da);g[S>>2]=ba;g[U>>2]=$;g[V>>2]=Z;g[W>>2]=ta}}while((X|0)!=0);i=f;return}function $ma(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=Im,Ha=0,Ia=Im,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=0,nb=Im,ob=Im,pb=Im,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0;f=i;i=i+32|0;h=f;j=c[b+428>>2]|0;l=b+432|0;m=ea(g[(c[l>>2]|0)+216>>2]);Yma(h,b,d);n=h+4|0;o=h+8|0;p=h+12|0;q=c[n>>2]|c[h>>2]|c[o>>2]|c[p>>2];if(!q){r=h+16|0;s=h+20|0;t=h+24|0;u=h+28|0;v=c[r>>2]|0;c[a>>2]=v;w=c[s>>2]|0;x=a+4|0;c[x>>2]=w;y=c[t>>2]|0;z=a+8|0;c[z>>2]=y;A=c[u>>2]|0;B=a+12|0;c[B>>2]=A;i=f;return}C=j+32|0;D=j+16|0;E=d+4|0;F=d+8|0;G=d+12|0;H=d+16|0;I=d+20|0;J=d+24|0;K=d+28|0;L=d+32|0;M=d+36|0;N=d+40|0;O=d+44|0;P=h+16|0;Q=h+20|0;R=h+24|0;S=h+28|0;U=e+4|0;V=e+8|0;W=e+12|0;X=e+16|0;Y=e+20|0;Z=e+24|0;_=e+28|0;$=e+32|0;aa=e+36|0;ba=e+40|0;ca=e+44|0;da=e+96|0;fa=e+100|0;ga=e+104|0;ha=e+108|0;ia=b+416|0;ja=b+424|0;b=e+48|0;ka=e+52|0;la=e+56|0;ma=e+60|0;na=e+64|0;oa=e+68|0;pa=e+72|0;qa=e+76|0;ra=e+80|0;sa=e+84|0;ta=e+88|0;ua=e+92|0;if(m>ea(0.0)){va=q;wa=q;xa=q;ya=q;za=q;do{Aa=za&0-za;Ba=0;while(1){Aa=Aa>>>1;if(!Aa)break;else Ba=Ba+1|0}Aa=Ba*48|0;za=za+-1&za;Ca=va;va=va+-1&va;Da=wa;wa=wa+-1&wa;Ea=xa;xa=xa+-1&xa;m=ea(g[j+(Ba*48|0)>>2]);Fa=Aa|4;Ga=ea(g[j+Fa>>2]);Ha=Aa|8;Ia=ea(g[j+Ha>>2]);Ja=Aa|12;Ka=ea(g[j+Ja>>2]);La=ea(ea(g[d>>2])-m);Ma=ea(ea(g[E>>2])-m);Na=ea(ea(g[F>>2])-m);Oa=ea(ea(g[G>>2])-m);m=ea(ea(g[H>>2])-Ga);Pa=ea(ea(g[I>>2])-Ga);Qa=ea(ea(g[J>>2])-Ga);Ra=ea(ea(g[K>>2])-Ga);Ga=ea(ea(g[L>>2])-Ia);Sa=ea(ea(g[M>>2])-Ia);Ta=ea(ea(g[N>>2])-Ia);Ua=ea(ea(g[O>>2])-Ia);Ia=ea(g[D+Aa>>2]);Va=ea(g[D+Fa>>2]);Wa=ea(g[D+Ha>>2]);Xa=ea(g[D+Ja>>2]);Ya=ea(ea(ea(La*Ia)+ea(m*Va))+ea(Ga*Wa));Za=ea(ea(ea(Ma*Ia)+ea(Pa*Va))+ea(Sa*Wa));_a=ea(ea(ea(Na*Ia)+ea(Qa*Va))+ea(Ta*Wa));$a=ea(ea(ea(Oa*Ia)+ea(Ra*Va))+ea(Ua*Wa));ab=ea(Ka+ea(Xa*Ya));bb=ea(Ka+ea(Xa*Za));cb=ea(Ka+ea(Xa*_a));db=ea(Ka+ea(Xa*$a));Ka=ea(g[119934]);eb=ea(g[119935]);fb=ea(g[119936]);gb=ea(g[119937]);hb=ea(ea(ea(ea(La*La)+ea(m*m))+ea(Ga*Ga))-ea(Ya*Ya));ib=ea(ea(ea(ea(Ma*Ma)+ea(Pa*Pa))+ea(Sa*Sa))-ea(Za*Za));jb=ea(ea(ea(ea(Na*Na)+ea(Qa*Qa))+ea(Ta*Ta))-ea(_a*_a));kb=ea(ea(ea(ea(Oa*Oa)+ea(Ra*Ra))+ea(Ua*Ua))-ea($a*$a));lb=ea(g[C+Ja>>2]);Ja=(g[k>>2]=lb,c[k>>2]|0);lb=(c[h>>2]&0-Ca|0)!=0?(ab<Ka?Ka:ab):ea(0.0);ab=ea(lb*lb);Ka=(c[n>>2]&0-Da|0)!=0?(bb<eb?eb:bb):ea(0.0);bb=ea(Ka*Ka);eb=(c[o>>2]&0-Ea|0)!=0?(cb<fb?fb:cb):ea(0.0);cb=ea(eb*eb);fb=(c[p>>2]&0-ya|0)!=0?(db<gb?gb:db):ea(0.0);ya=ya+-1&ya;Ea=ab>hb;Da=bb>ib;Ca=cb>jb;mb=ea(fb*fb)>kb;if(Ea|Da|Ca|mb){cb=ea(g[C+Aa>>2]);bb=ea(g[C+Ha>>2]);ab=ea(g[C+Fa>>2]);db=ea(g[119914]);gb=hb<db?db:hb;hb=ea(g[119915]);db=ib<hb?hb:ib;ib=ea(g[119916]);hb=jb<ib?ib:jb;jb=ea(g[119917]);ib=kb<jb?jb:kb;kb=ea(ea(1.0)/ea(T(ea(gb))));jb=ea(ea(1.0)/ea(T(ea(db))));nb=ea(ea(1.0)/ea(T(ea(hb))));ob=ea(ea(1.0)/ea(T(ea(ib))));pb=ea(Ya+ea(ea(Xa*gb)*kb));gb=ea(Za+ea(ea(Xa*db)*jb));db=ea(_a+ea(ea(Xa*hb)*nb));hb=ea($a+ea(ea(Xa*ib)*ob));ib=ea(-ab);Xa=Ea?pb:ea(0.0);pb=Da?gb:ea(0.0);gb=Ca?db:ea(0.0);db=mb?hb:ea(0.0);Fa=Xa<ib;Ha=pb<ib;Aa=gb<ib;qb=db<ib;rb=Xa>ab;sb=pb>ab;tb=gb>ab;ub=db>ab;vb=(g[k>>2]=bb,c[k>>2]|0);wb=~vb;xb=~(vb^Ja);vb=(Ha?-1:wb)&c[Q>>2]&(sb?-1:xb);yb=(Aa?-1:wb)&c[R>>2]&(tb?-1:xb);zb=(qb?-1:wb)&c[S>>2]&(ub?-1:xb);c[P>>2]=(Fa?-1:wb)&c[P>>2]&(rb?-1:xb);c[Q>>2]=vb;c[R>>2]=yb;c[S>>2]=zb;zb=rb|Fa|Ea^1;Ea=sb|Ha|Da^1;Da=tb|Aa|Ca^1;Ca=ub|qb|mb^1;if(!(Ea&zb&Da&Ca)){bb=ea(Ua-ea(Wa*db));Ua=ea(Ta-ea(Wa*gb));Ta=ea(Sa-ea(Wa*pb));Sa=ea(Ga-ea(Wa*Xa));Wa=ea(Ra-ea(Va*db));Ra=ea(Qa-ea(Va*gb));Qa=ea(Pa-ea(Va*pb));Pa=ea(m-ea(Va*Xa));Va=ea(ea(cb*ea(fb*ob))-cb);ob=ea(Oa-ea(Ia*db));db=ea(ea(cb*ea(eb*nb))-cb);nb=ea(Na-ea(Ia*gb));gb=ea(ea(cb*ea(Ka*jb))-cb);jb=ea(Ma-ea(Ia*pb));pb=ea(ea(cb*ea(lb*kb))-cb);cb=ea(La-ea(Ia*Xa));Xa=zb?ea(0.0):pb;pb=ea(cb*Xa);cb=Ea?ea(0.0):gb;gb=ea(jb*cb);jb=Da?ea(0.0):db;db=ea(nb*jb);nb=Ca?ea(0.0):Va;Va=ea(ob*nb);ob=ea(pb+ea(g[e>>2]));pb=ea(gb+ea(g[U>>2]));gb=ea(db+ea(g[V>>2]));db=ea(Va+ea(g[W>>2]));Va=ea(ob);ob=ea(pb);pb=ea(gb);gb=ea(db);g[e>>2]=Va;g[U>>2]=ob;g[V>>2]=pb;g[W>>2]=gb;gb=ea(Pa*Xa);Pa=ea(Qa*cb);Qa=ea(Ra*jb);Ra=ea(Wa*nb);Wa=ea(gb+ea(g[X>>2]));gb=ea(Pa+ea(g[Y>>2]));Pa=ea(Qa+ea(g[Z>>2]));Qa=ea(Ra+ea(g[_>>2]));Ra=ea(Wa);Wa=ea(gb);gb=ea(Pa);Pa=ea(Qa);g[X>>2]=Ra;g[Y>>2]=Wa;g[Z>>2]=gb;g[_>>2]=Pa;Pa=ea(Sa*Xa);Xa=ea(Ta*cb);cb=ea(Ua*jb);jb=ea(bb*nb);nb=ea(Pa+ea(g[$>>2]));Pa=ea(Xa+ea(g[aa>>2]));Xa=ea(cb+ea(g[ba>>2]));cb=ea(jb+ea(g[ca>>2]));jb=ea(nb);nb=ea(Pa);Pa=ea(Xa);Xa=ea(cb);g[$>>2]=jb;g[aa>>2]=nb;g[ba>>2]=Pa;g[ca>>2]=Xa;Xa=ea(g[da>>2]);Pa=ea((zb?ea(0.0):ea(1.0))+Xa);Xa=ea(g[fa>>2]);nb=ea((Ea?ea(0.0):ea(1.0))+Xa);Xa=ea(g[ga>>2]);jb=ea((Da?ea(0.0):ea(1.0))+Xa);Xa=ea(g[ha>>2]);cb=ea((Ca?ea(0.0):ea(1.0))+Xa);Xa=ea(Pa);Pa=ea(nb);nb=ea(jb);jb=ea(cb);g[da>>2]=Xa;g[fa>>2]=Pa;g[ga>>2]=nb;g[ha>>2]=jb;mb=c[(c[l>>2]|0)+156>>2]|0;qb=c[mb+(Ba<<3)>>2]|0;ub=c[mb+(Ba<<3)+4>>2]|0;mb=c[ia>>2]|0;Aa=c[ja>>2]|0;tb=qb<<4;jb=ea(g[mb+(qb<<4)>>2]);Ha=tb|4;nb=ea(g[mb+Ha>>2]);sb=tb|8;Pa=ea(g[mb+sb>>2]);Xa=ea(g[Aa+(qb<<4)>>2]);cb=ea(g[Aa+Ha>>2]);bb=ea(g[Aa+sb>>2]);sb=ub<<4;Ua=ea(g[mb+(ub<<4)>>2]);Ha=sb|4;Ta=ea(g[mb+Ha>>2]);qb=sb|8;Sa=ea(g[mb+qb>>2]);gb=ea(g[Aa+(ub<<4)>>2]);Wa=ea(g[Aa+Ha>>2]);Ra=ea(Xa-jb);jb=ea(cb-nb);nb=ea(bb-Pa);Pa=ea(ea(gb-Ua)-Ra);Ua=ea(ea(Wa-Ta)-jb);Ta=ea(ea(ea(g[Aa+qb>>2])-Sa)-nb);Sa=ea(g[119946]);Wa=ea(Ya*Sa);Ya=ea(g[119947]);gb=ea(Za*Ya);Za=ea(g[119948]);bb=ea(_a*Za);_a=ea(g[119949]);cb=ea(Sa+Wa);Wa=ea(Ya+gb);gb=ea(Za+bb);bb=ea(_a+ea($a*_a));_a=ea(Ra+ea(Pa*cb));$a=ea(Ra+ea(Pa*Wa));Za=ea(Ra+ea(Pa*gb));Ya=ea(Ra+ea(Pa*bb));Pa=ea(jb+ea(Ua*cb));Ra=ea(jb+ea(Ua*Wa));Sa=ea(jb+ea(Ua*gb));Xa=ea(jb+ea(Ua*bb));Ua=ea(nb+ea(Ta*cb));cb=ea(nb+ea(Ta*Wa));Wa=ea(nb+ea(Ta*gb));gb=ea(nb+ea(Ta*bb));bb=ea(g[b>>2]);Ta=ea(bb+(zb?ea(0.0):_a));_a=ea(g[ka>>2]);bb=ea(_a+(Ea?ea(0.0):$a));$a=ea(g[la>>2]);_a=ea($a+(Da?ea(0.0):Za));Za=ea(g[ma>>2]);$a=ea(Za+(Ca?ea(0.0):Ya));Ya=ea(Ta);Ta=ea(bb);bb=ea(_a);_a=ea($a);g[b>>2]=Ya;g[ka>>2]=Ta;g[la>>2]=bb;g[ma>>2]=_a;_a=ea(g[na>>2]);bb=ea((zb?ea(0.0):Pa)+_a);_a=ea(g[oa>>2]);Pa=ea((Ea?ea(0.0):Ra)+_a);_a=ea(g[pa>>2]);Ra=ea((Da?ea(0.0):Sa)+_a);_a=ea(g[qa>>2]);Sa=ea((Ca?ea(0.0):Xa)+_a);_a=ea(bb);bb=ea(Pa);Pa=ea(Ra);Ra=ea(Sa);g[na>>2]=_a;g[oa>>2]=bb;g[pa>>2]=Pa;g[qa>>2]=Ra;Ra=ea(g[ra>>2]);Pa=ea((zb?ea(0.0):Ua)+Ra);Ra=ea(g[sa>>2]);Ua=ea((Ea?ea(0.0):cb)+Ra);Ra=ea(g[ta>>2]);cb=ea((Da?ea(0.0):Wa)+Ra);Ra=ea(g[ua>>2]);Wa=ea((Ca?ea(0.0):gb)+Ra);Ra=ea(Pa);Pa=ea(Ua);Ua=ea(cb);cb=ea(Wa);g[ra>>2]=Ra;g[sa>>2]=Pa;g[ta>>2]=Ua;g[ua>>2]=cb}}else{Ca=~Ja;Ja=c[Q>>2]&Ca;Da=c[R>>2]&Ca;Ea=c[S>>2]&Ca;c[P>>2]=c[P>>2]&Ca;c[Q>>2]=Ja;c[R>>2]=Da;c[S>>2]=Ea}}while((za|0)!=0);r=P;s=Q;t=R;u=S;v=c[r>>2]|0;c[a>>2]=v;w=c[s>>2]|0;x=a+4|0;c[x>>2]=w;y=c[t>>2]|0;z=a+8|0;c[z>>2]=y;A=c[u>>2]|0;B=a+12|0;c[B>>2]=A;i=f;return}else{za=q;ua=q;ta=q;sa=q;ra=q;do{q=ra&0-ra;qa=0;while(1){q=q>>>1;if(!q)break;else qa=qa+1|0}q=qa*48|0;ra=ra+-1&ra;Ba=za;za=za+-1&za;pa=ua;ua=ua+-1&ua;oa=ta;ta=ta+-1&ta;cb=ea(g[j+(qa*48|0)>>2]);na=q|4;Ua=ea(g[j+na>>2]);ma=q|8;Pa=ea(g[j+ma>>2]);la=q|12;Ra=ea(g[j+la>>2]);Wa=ea(ea(g[d>>2])-cb);gb=ea(ea(g[E>>2])-cb);bb=ea(ea(g[F>>2])-cb);_a=ea(ea(g[G>>2])-cb);cb=ea(ea(g[H>>2])-Ua);Sa=ea(ea(g[I>>2])-Ua);Xa=ea(ea(g[J>>2])-Ua);Ta=ea(ea(g[K>>2])-Ua);Ua=ea(ea(g[L>>2])-Pa);Ya=ea(ea(g[M>>2])-Pa);$a=ea(ea(g[N>>2])-Pa);Za=ea(ea(g[O>>2])-Pa);Pa=ea(g[D+q>>2]);nb=ea(g[D+na>>2]);jb=ea(g[D+ma>>2]);Qa=ea(g[D+la>>2]);pb=ea(ea(ea(Wa*Pa)+ea(cb*nb))+ea(Ua*jb));ob=ea(ea(ea(gb*Pa)+ea(Sa*nb))+ea(Ya*jb));Va=ea(ea(ea(bb*Pa)+ea(Xa*nb))+ea($a*jb));db=ea(ea(ea(_a*Pa)+ea(Ta*nb))+ea(Za*jb));Ia=ea(Ra+ea(Qa*pb));La=ea(Ra+ea(Qa*ob));kb=ea(Ra+ea(Qa*Va));lb=ea(Ra+ea(Qa*db));Ra=ea(g[119934]);Ma=ea(g[119935]);Ka=ea(g[119936]);Na=ea(g[119937]);eb=ea(ea(ea(ea(Wa*Wa)+ea(cb*cb))+ea(Ua*Ua))-ea(pb*pb));Oa=ea(ea(ea(ea(gb*gb)+ea(Sa*Sa))+ea(Ya*Ya))-ea(ob*ob));fb=ea(ea(ea(ea(bb*bb)+ea(Xa*Xa))+ea($a*$a))-ea(Va*Va));m=ea(ea(ea(ea(_a*_a)+ea(Ta*Ta))+ea(Za*Za))-ea(db*db));Ga=ea(g[C+la>>2]);la=(g[k>>2]=Ga,c[k>>2]|0);Ga=(c[h>>2]&0-Ba|0)!=0?(Ia<Ra?Ra:Ia):ea(0.0);Ia=ea(Ga*Ga);Ra=(c[n>>2]&0-pa|0)!=0?(La<Ma?Ma:La):ea(0.0);La=ea(Ra*Ra);Ma=(c[o>>2]&0-oa|0)!=0?(kb<Ka?Ka:kb):ea(0.0);kb=ea(Ma*Ma);Ka=(c[p>>2]&0-sa|0)!=0?(lb<Na?Na:lb):ea(0.0);sa=sa+-1&sa;oa=Ia>eb;pa=La>Oa;Ba=kb>fb;ka=ea(Ka*Ka)>m;if(oa|pa|Ba|ka){kb=ea(g[C+q>>2]);La=ea(g[C+ma>>2]);Ia=ea(g[C+na>>2]);lb=ea(g[119914]);Na=eb<lb?lb:eb;eb=ea(g[119915]);lb=Oa<eb?eb:Oa;Oa=ea(g[119916]);eb=fb<Oa?Oa:fb;fb=ea(g[119917]);Oa=m<fb?fb:m;m=ea(ea(1.0)/ea(T(ea(Na))));fb=ea(ea(1.0)/ea(T(ea(lb))));ab=ea(ea(1.0)/ea(T(ea(eb))));ib=ea(ea(1.0)/ea(T(ea(Oa))));hb=ea(pb+ea(ea(Qa*Na)*m));Na=ea(ob+ea(ea(Qa*lb)*fb));lb=ea(Va+ea(ea(Qa*eb)*ab));eb=ea(db+ea(ea(Qa*Oa)*ib));Oa=ea(-Ia);Qa=oa?hb:ea(0.0);hb=pa?Na:ea(0.0);Na=Ba?lb:ea(0.0);lb=ka?eb:ea(0.0);na=Qa<Oa;ma=hb<Oa;q=Na<Oa;b=lb<Oa;ja=Qa>Ia;ia=hb>Ia;l=Na>Ia;ya=lb>Ia;xa=(g[k>>2]=La,c[k>>2]|0);wa=~xa;va=~(xa^la);xa=(ma?-1:wa)&c[Q>>2]&(ia?-1:va);Ea=(q?-1:wa)&c[R>>2]&(l?-1:va);Da=(b?-1:wa)&c[S>>2]&(ya?-1:va);c[P>>2]=(na?-1:wa)&c[P>>2]&(ja?-1:va);c[Q>>2]=xa;c[R>>2]=Ea;c[S>>2]=Da;Da=ja|na|oa^1;oa=ia|ma|pa^1;pa=l|q|Ba^1;Ba=ya|b|ka^1;if(!(oa&Da&pa&Ba)){La=ea(Za-ea(jb*lb));Za=ea($a-ea(jb*Na));$a=ea(Ya-ea(jb*hb));Ya=ea(Ua-ea(jb*Qa));jb=ea(Ta-ea(nb*lb));Ta=ea(Xa-ea(nb*Na));Xa=ea(Sa-ea(nb*hb));Sa=ea(cb-ea(nb*Qa));nb=ea(ea(kb*ea(Ka*ib))-kb);ib=ea(_a-ea(Pa*lb));lb=ea(ea(kb*ea(Ma*ab))-kb);ab=ea(bb-ea(Pa*Na));Na=ea(ea(kb*ea(Ra*fb))-kb);fb=ea(gb-ea(Pa*hb));hb=ea(ea(kb*ea(Ga*m))-kb);kb=ea(Wa-ea(Pa*Qa));Qa=Da?ea(0.0):hb;hb=ea(kb*Qa);kb=oa?ea(0.0):Na;Na=ea(fb*kb);fb=pa?ea(0.0):lb;lb=ea(ab*fb);ab=Ba?ea(0.0):nb;nb=ea(ib*ab);ib=ea(hb+ea(g[e>>2]));hb=ea(Na+ea(g[U>>2]));Na=ea(lb+ea(g[V>>2]));lb=ea(nb+ea(g[W>>2]));nb=ea(ib);ib=ea(hb);hb=ea(Na);Na=ea(lb);g[e>>2]=nb;g[U>>2]=ib;g[V>>2]=hb;g[W>>2]=Na;Na=ea(Sa*Qa);Sa=ea(Xa*kb);Xa=ea(Ta*fb);Ta=ea(jb*ab);jb=ea(Na+ea(g[X>>2]));Na=ea(Sa+ea(g[Y>>2]));Sa=ea(Xa+ea(g[Z>>2]));Xa=ea(Ta+ea(g[_>>2]));Ta=ea(jb);jb=ea(Na);Na=ea(Sa);Sa=ea(Xa);g[X>>2]=Ta;g[Y>>2]=jb;g[Z>>2]=Na;g[_>>2]=Sa;Sa=ea(Ya*Qa);Qa=ea($a*kb);kb=ea(Za*fb);fb=ea(La*ab);ab=ea(Sa+ea(g[$>>2]));Sa=ea(Qa+ea(g[aa>>2]));Qa=ea(kb+ea(g[ba>>2]));kb=ea(fb+ea(g[ca>>2]));fb=ea(ab);ab=ea(Sa);Sa=ea(Qa);Qa=ea(kb);g[$>>2]=fb;g[aa>>2]=ab;g[ba>>2]=Sa;g[ca>>2]=Qa;Qa=ea(g[da>>2]);Sa=ea((Da?ea(0.0):ea(1.0))+Qa);Qa=ea(g[fa>>2]);ab=ea((oa?ea(0.0):ea(1.0))+Qa);Qa=ea(g[ga>>2]);fb=ea((pa?ea(0.0):ea(1.0))+Qa);Qa=ea(g[ha>>2]);kb=ea((Ba?ea(0.0):ea(1.0))+Qa);Qa=ea(Sa);Sa=ea(ab);ab=ea(fb);fb=ea(kb);g[da>>2]=Qa;g[fa>>2]=Sa;g[ga>>2]=ab;g[ha>>2]=fb}}else{Ba=~la;la=c[Q>>2]&Ba;pa=c[R>>2]&Ba;oa=c[S>>2]&Ba;c[P>>2]=c[P>>2]&Ba;c[Q>>2]=la;c[R>>2]=pa;c[S>>2]=oa}}while((ra|0)!=0);r=P;s=Q;t=R;u=S;v=c[r>>2]|0;c[a>>2]=v;w=c[s>>2]|0;x=a+4|0;c[x>>2]=w;y=c[t>>2]|0;z=a+8|0;c[z>>2]=y;A=c[u>>2]|0;B=a+12|0;c[B>>2]=A;i=f;return}}function ana(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=0,na=Im,oa=0,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=0,zb=0,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im;h=i;j=c[a+416>>2]|0;l=c[a+424>>2]|0;m=ea(g[(c[a+432>>2]|0)+216>>2])>ea(0.0);a=c[b+4>>2]|c[b>>2]|c[b+8>>2]|c[b+12>>2];if(!a){i=h;return}b=d+4|0;n=d+8|0;o=d+12|0;p=d+16|0;q=d+20|0;r=d+24|0;s=d+28|0;t=d+32|0;u=d+36|0;v=d+40|0;w=d+44|0;x=e+4|0;y=e+8|0;z=e+12|0;A=e+16|0;B=e+20|0;C=e+24|0;D=e+28|0;E=e+32|0;F=e+36|0;G=e+40|0;H=e+44|0;I=f+4|0;J=f+8|0;K=f+12|0;L=f+16|0;M=f+20|0;N=f+24|0;O=f+28|0;P=f+32|0;Q=f+36|0;R=f+40|0;S=f+44|0;U=f+96|0;V=f+100|0;W=f+104|0;X=f+108|0;Y=f+48|0;Z=f+52|0;_=f+56|0;$=f+60|0;aa=f+64|0;ba=f+68|0;ca=f+72|0;da=f+76|0;fa=f+80|0;ga=f+84|0;ha=f+88|0;ia=f+92|0;ja=a;do{a=ja&0-ja;ka=0;while(1){a=a>>>1;if(!a)break;else ka=ka+1|0}a=ka<<4;ja=ja+-1&ja;la=ea(g[j+(ka<<4)>>2]);ma=a|4;na=ea(g[j+ma>>2]);oa=a|8;pa=ea(g[j+oa>>2]);qa=a|12;ra=ea(g[j+qa>>2]);sa=ea(ea(g[d>>2])-la);ta=ea(ea(g[b>>2])-la);ua=ea(ea(g[n>>2])-la);va=ea(ea(g[o>>2])-la);wa=ea(ea(g[p>>2])-na);xa=ea(ea(g[q>>2])-na);ya=ea(ea(g[r>>2])-na);za=ea(ea(g[s>>2])-na);Aa=ea(ea(g[t>>2])-pa);Ba=ea(ea(g[u>>2])-pa);Ca=ea(ea(g[v>>2])-pa);Da=ea(ea(g[w>>2])-pa);Ea=ea(g[119966]);Fa=ea(ra*Ea);Ga=ea(g[119967]);Ha=ea(ra*Ga);Ia=ea(g[119968]);Ja=ea(ra*Ia);Ka=ea(g[119969]);La=ea(ra*Ka);ra=ea(g[l+(ka<<4)>>2]);Ma=ea(g[l+ma>>2]);Na=ea(g[l+oa>>2]);Oa=ea(g[l+qa>>2]);Pa=ea(ea(g[e>>2])-ra);Qa=ea(ea(g[x>>2])-ra);Ra=ea(ea(g[y>>2])-ra);Sa=ea(ea(g[z>>2])-ra);Ta=ea(ea(g[A>>2])-Ma);Ua=ea(ea(g[B>>2])-Ma);Va=ea(ea(g[C>>2])-Ma);Wa=ea(ea(g[D>>2])-Ma);Xa=ea(ea(g[E>>2])-Na);Ya=ea(ea(g[F>>2])-Na);Za=ea(ea(g[G>>2])-Na);_a=ea(ea(g[H>>2])-Na);$a=ea(Ea*Oa);Ea=ea(Ga*Oa);Ga=ea(Ia*Oa);Ia=ea(Ka*Oa);Ka=ea(Pa*Pa);ab=ea(Qa*Qa);bb=ea(Ra*Ra);cb=ea(Sa*Sa);db=ea(g[119914]);eb=ea(Ka+db);Ka=ea(g[119915]);fb=ea(ab+Ka);ab=ea(g[119916]);gb=ea(bb+ab);bb=ea(g[119917]);hb=ea(ea(Xa*Xa)+ea(ea(Ta*Ta)+eb));eb=ea(ea(Ya*Ya)+ea(ea(Ua*Ua)+fb));fb=ea(ea(Za*Za)+ea(ea(Va*Va)+gb));gb=ea(ea(_a*_a)+ea(ea(Wa*Wa)+ea(cb+bb)));cb=ea(ea(ea(ea(sa*sa)+ea(wa*wa))+ea(Aa*Aa))-ea(Fa*Fa));ib=ea(ea(ea(ea(ta*ta)+ea(xa*xa))+ea(Ba*Ba))-ea(Ha*Ha));jb=ea(ea(ea(ea(ua*ua)+ea(ya*ya))+ea(Ca*Ca))-ea(Ja*Ja));kb=ea(ea(ea(ea(va*va)+ea(za*za))+ea(Da*Da))-ea(La*La));lb=ea(ea(ea(ea(sa*Pa)+ea(wa*Ta))+ea(Aa*Xa))-ea(Fa*$a));Fa=ea(ea(ea(ea(ta*Qa)+ea(xa*Ua))+ea(Ba*Ya))-ea(Ha*Ea));Ha=ea(ea(ea(ea(ua*Ra)+ea(ya*Va))+ea(Ca*Za))-ea(Ja*Ga));Ja=ea(ea(ea(ea(va*Sa)+ea(za*Wa))+ea(Da*_a))-ea(La*Ia));La=ea(hb-ea($a*$a));$a=ea(eb-ea(Ea*Ea));Ea=ea(fb-ea(Ga*Ga));Ga=ea(gb-ea(Ia*Ia));Ia=ea(ea(lb*lb)-ea(cb*La));mb=ea(ea(Fa*Fa)-ea(ib*$a));nb=ea(ea(Ha*Ha)-ea(jb*Ea));ob=ea(ea(Ja*Ja)-ea(kb*Ga));pb=ea(T(ea(Ia)));qb=ea(T(ea(mb)));rb=ea(T(ea(nb)));sb=ea(T(ea(ob)));tb=ea(lb-cb);cb=ea(Fa-ib);ib=ea(Ha-jb);jb=ea(Ja-kb);kb=ea(tb+ea(lb-La));La=ea(cb+ea(Fa-$a));$a=ea(ib+ea(Ha-Ea));Ea=ea(jb+ea(Ja-Ga));Ga=ea(ea(1.0)/kb);Ja=ea(ea(1.0)/La);Ha=ea(ea(1.0)/$a);Fa=ea(ea(1.0)/Ea);lb=ea(tb+pb);ub=ea(cb+qb);vb=ea(ib+rb);wb=ea(jb+sb);qa=lb<ea(0.0);xb=qa?lb:ea(0.0);qa=ub<ea(0.0);lb=qa?ub:ea(0.0);qa=vb<ea(0.0);ub=qa?vb:ea(0.0);qa=wb<ea(0.0);vb=ea(xb*Ga);Ga=ea(lb*Ja);Ja=ea(ub*Ha);Ha=ea((qa?wb:ea(0.0))*Fa);qa=kb<ea(-db)&(Ia>=ea(0.0)&(tb<pb&vb<ea(1.0)));oa=La<ea(-Ka)&(mb>=ea(0.0)&(cb<qb&Ga<ea(1.0)));ma=$a<ea(-ab)&(nb>=ea(0.0)&(ib<rb&Ja<ea(1.0)));a=Ea<ea(-bb)&(ob>=ea(0.0)&(jb<sb&Ha<ea(1.0)));if((c[k>>2]=qa<<31>>31,ea(g[k>>2]))==ea(0.0)?(yb=(c[k>>2]=oa<<31>>31,ea(g[k>>2]))==ea(0.0),zb=yb&(c[k>>2]=ma<<31>>31,ea(g[k>>2]))==ea(0.0),zb&(c[k>>2]=a<<31>>31,ea(g[k>>2]))==ea(0.0)):0){Ab=gb;Bb=fb;Cb=eb;Db=hb;Eb=Sa;Fb=Ra;Gb=Qa;Hb=Pa;Ib=Wa;Jb=Va;Kb=Ua;Lb=Ta;Mb=_a;Nb=Za;Ob=Ya;Pb=Xa}else{hb=ea(sa-Pa);sa=ea(ta-Qa);ta=ea(ua-Ra);ua=ea(va-Sa);va=ea(wa-Ta);wa=ea(xa-Ua);xa=ea(ya-Va);ya=ea(za-Wa);za=ea(Aa-Xa);Aa=ea(Ba-Ya);Ba=ea(Ca-Za);Ca=ea(Da-_a);Da=ea(ea(1.0)-vb);vb=ea(ea(1.0)-Ga);Ga=ea(ea(1.0)-Ja);Ja=ea(ea(1.0)-Ha);Ha=qa?Da:ea(0.0);Da=ea(hb*Ha);hb=oa?vb:ea(0.0);vb=ea(sa*hb);sa=ma?Ga:ea(0.0);Ga=ea(ta*sa);ta=a?Ja:ea(0.0);Ja=ea(Pa+Da);Da=ea(Qa+vb);vb=ea(Ra+Ga);Ga=ea(Sa+ea(ua*ta));ua=ea(Ta+ea(va*Ha));va=ea(Ua+ea(wa*hb));wa=ea(Va+ea(xa*sa));xa=ea(Wa+ea(ya*ta));ya=ea(Xa+ea(za*Ha));Ha=ea(Ya+ea(Aa*hb));hb=ea(Za+ea(Ba*sa));sa=ea(_a+ea(Ca*ta));ta=ea(ra+Ja);Ca=ea(ra+Da);_a=ea(ra+vb);Ba=ea(ra+Ga);Za=ea(ta);ta=ea(Ca);Ca=ea(_a);_a=ea(Ba);g[e>>2]=Za;g[x>>2]=ta;g[y>>2]=Ca;g[z>>2]=_a;_a=ea(Ma+ua);Ca=ea(Ma+va);ta=ea(Ma+wa);Za=ea(Ma+xa);Ba=ea(_a);_a=ea(Ca);Ca=ea(ta);ta=ea(Za);g[A>>2]=Ba;g[B>>2]=_a;g[C>>2]=Ca;g[D>>2]=ta;ta=ea(Na+ya);Ca=ea(Na+Ha);_a=ea(Na+hb);Ba=ea(Na+sa);Za=ea(ta);ta=ea(Ca);Ca=ea(_a);_a=ea(Ba);g[E>>2]=Za;g[F>>2]=ta;g[G>>2]=Ca;g[H>>2]=_a;_a=ea(Ja*Ja);Ca=ea(Da*Da);ta=ea(vb*vb);Za=ea(Ga*Ga);Ba=ea(_a+ea(g[119914]));_a=ea(Ca+ea(g[119915]));Ca=ea(ta+ea(g[119916]));Ab=ea(ea(sa*sa)+ea(ea(xa*xa)+ea(Za+ea(g[119917]))));Bb=ea(ea(hb*hb)+ea(ea(wa*wa)+Ca));Cb=ea(ea(Ha*Ha)+ea(ea(va*va)+_a));Db=ea(ea(ya*ya)+ea(ea(ua*ua)+Ba));Eb=Ga;Fb=vb;Gb=Da;Hb=Ja;Ib=xa;Jb=wa;Kb=va;Lb=ua;Mb=sa;Nb=hb;Ob=Ha;Pb=ya}ya=ea(ea(1.0)-ea(Oa*ea(ea(1.0)/ea(T(ea(Db))))));Ha=ea(ea(1.0)-ea(Oa*ea(ea(1.0)/ea(T(ea(Cb))))));hb=ea(ea(1.0)-ea(Oa*ea(ea(1.0)/ea(T(ea(Bb))))));sa=ea(ea(1.0)-ea(Oa*ea(ea(1.0)/ea(T(ea(Ab))))));a=ya<ea(0.0);ma=Ha<ea(0.0);oa=hb<ea(0.0);qa=sa<ea(0.0);if(a|ma|oa|qa?(Oa=a?ya:ea(0.0),ya=ea(Hb*Oa),ua=ma?Ha:ea(0.0),Ha=ea(Gb*ua),va=oa?hb:ea(0.0),hb=ea(Fb*va),wa=qa?sa:ea(0.0),sa=ea(Eb*wa),xa=ea(ea(g[f>>2])-ya),ya=ea(ea(g[I>>2])-Ha),Ha=ea(ea(g[J>>2])-hb),hb=ea(ea(g[K>>2])-sa),sa=ea(xa),xa=ea(ya),ya=ea(Ha),Ha=ea(hb),g[f>>2]=sa,g[I>>2]=xa,g[J>>2]=ya,g[K>>2]=Ha,Ha=ea(Lb*Oa),ya=ea(Kb*ua),xa=ea(Jb*va),sa=ea(Ib*wa),hb=ea(ea(g[L>>2])-Ha),Ha=ea(ea(g[M>>2])-ya),ya=ea(ea(g[N>>2])-xa),xa=ea(ea(g[O>>2])-sa),sa=ea(hb),hb=ea(Ha),Ha=ea(ya),ya=ea(xa),g[L>>2]=sa,g[M>>2]=hb,g[N>>2]=Ha,g[O>>2]=ya,ya=ea(Pb*Oa),Oa=ea(Ob*ua),ua=ea(Nb*va),va=ea(Mb*wa),wa=ea(ea(g[P>>2])-ya),ya=ea(ea(g[Q>>2])-Oa),Oa=ea(ea(g[R>>2])-ua),ua=ea(ea(g[S>>2])-va),va=ea(wa),wa=ea(ya),ya=ea(Oa),Oa=ea(ua),g[P>>2]=va,g[Q>>2]=wa,g[R>>2]=ya,g[S>>2]=Oa,Oa=ea(g[U>>2]),ya=ea((a?ea(1.0):ea(0.0))+Oa),Oa=ea(g[V>>2]),wa=ea((ma?ea(1.0):ea(0.0))+Oa),Oa=ea(g[W>>2]),va=ea((oa?ea(1.0):ea(0.0))+Oa),Oa=ea(g[X>>2]),ua=ea((qa?ea(1.0):ea(0.0))+Oa),Oa=ea(ya),ya=ea(wa),wa=ea(va),va=ea(ua),g[U>>2]=Oa,g[V>>2]=ya,g[W>>2]=wa,g[X>>2]=va,m):0){va=ea(ra-la);la=ea(Ma-na);na=ea(Na-pa);pa=ea(g[Y>>2]);Na=ea((a?va:ea(0.0))+pa);pa=ea(g[Z>>2]);Ma=ea((ma?va:ea(0.0))+pa);pa=ea(g[_>>2]);ra=ea((oa?va:ea(0.0))+pa);pa=ea(g[$>>2]);wa=ea((qa?va:ea(0.0))+pa);pa=ea(Na);Na=ea(Ma);Ma=ea(ra);ra=ea(wa);g[Y>>2]=pa;g[Z>>2]=Na;g[_>>2]=Ma;g[$>>2]=ra;ra=ea(g[aa>>2]);Ma=ea((a?la:ea(0.0))+ra);ra=ea(g[ba>>2]);Na=ea((ma?la:ea(0.0))+ra);ra=ea(g[ca>>2]);pa=ea((oa?la:ea(0.0))+ra);ra=ea(g[da>>2]);wa=ea((qa?la:ea(0.0))+ra);ra=ea(Ma);Ma=ea(Na);Na=ea(pa);pa=ea(wa);g[aa>>2]=ra;g[ba>>2]=Ma;g[ca>>2]=Na;g[da>>2]=pa;pa=ea(g[fa>>2]);Na=ea((a?na:ea(0.0))+pa);pa=ea(g[ga>>2]);Ma=ea((ma?na:ea(0.0))+pa);pa=ea(g[ha>>2]);ra=ea((oa?na:ea(0.0))+pa);pa=ea(g[ia>>2]);wa=ea((qa?na:ea(0.0))+pa);pa=ea(Na);Na=ea(Ma);Ma=ea(ra);ra=ea(wa);g[fa>>2]=pa;g[ga>>2]=Na;g[ha>>2]=Ma;g[ia>>2]=ra}}while((ja|0)!=0);i=h;return}function bna(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=Im,Wa=0,Xa=Im,Ya=0,Za=Im,_a=0,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=0,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=0,Xb=0,Yb=0,Zb=0,_b=Im,$b=Im,ac=Im,bc=Im,cc=0,dc=0,ec=0,fc=0,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=0,xc=0,yc=0,zc=0,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0;h=i;i=i+32|0;j=h;l=c[b+420>>2]|0;m=c[b+428>>2]|0;n=b+432|0;o=ea(g[(c[n>>2]|0)+216>>2])>ea(0.0);Zma(j,b,d,e);p=j+4|0;q=j+8|0;r=j+12|0;s=c[p>>2]|c[j>>2]|c[q>>2]|c[r>>2];if(!s){t=j+16|0;u=j+20|0;v=j+24|0;w=j+28|0;x=c[t>>2]|0;c[a>>2]=x;y=c[u>>2]|0;z=a+4|0;c[z>>2]=y;A=c[v>>2]|0;B=a+8|0;c[B>>2]=A;C=c[w>>2]|0;D=a+12|0;c[D>>2]=C;i=h;return}E=m+32|0;F=m+16|0;G=l+32|0;H=l+16|0;I=d+4|0;J=d+8|0;K=d+12|0;L=d+16|0;M=d+20|0;N=d+24|0;O=d+28|0;P=d+32|0;Q=d+36|0;R=d+40|0;U=d+44|0;V=e+4|0;W=e+8|0;X=e+12|0;Y=e+16|0;Z=e+20|0;_=e+24|0;$=e+28|0;aa=e+32|0;ba=e+36|0;ca=e+40|0;da=e+44|0;fa=j+16|0;ga=j+20|0;ha=j+24|0;ia=j+28|0;ja=f+4|0;ka=f+8|0;la=f+12|0;ma=f+16|0;na=f+20|0;oa=f+24|0;pa=f+28|0;qa=f+32|0;ra=f+36|0;sa=f+40|0;ta=f+44|0;ua=f+96|0;va=f+100|0;wa=f+104|0;xa=f+108|0;ya=b+416|0;za=b+424|0;b=f+48|0;Aa=f+52|0;Ba=f+56|0;Ca=f+60|0;Da=f+64|0;Ea=f+68|0;Fa=f+72|0;Ga=f+76|0;Ha=f+80|0;Ia=f+84|0;Ja=f+88|0;Ka=f+92|0;La=s;Ma=s;Na=s;Oa=s;Pa=s;do{s=Pa&0-Pa;Qa=0;while(1){s=s>>>1;if(!s)break;else Qa=Qa+1|0}s=Qa*48|0;Pa=Pa+-1&Pa;Ra=(c[j>>2]&0-La|0)!=0;Sa=(c[p>>2]&0-Ma|0)!=0;Ta=(c[q>>2]&0-Na|0)!=0;Ua=(c[r>>2]&0-Oa|0)!=0;La=La+-1&La;Ma=Ma+-1&Ma;Na=Na+-1&Na;Oa=Oa+-1&Oa;Va=ea(g[l+(Qa*48|0)>>2]);Wa=s|4;Xa=ea(g[l+Wa>>2]);Ya=s|8;Za=ea(g[l+Ya>>2]);_a=s|12;$a=ea(g[l+_a>>2]);ab=ea(g[H+s>>2]);bb=ea(g[H+Wa>>2]);cb=ea(g[H+Ya>>2]);db=ea(g[H+_a>>2]);eb=ea(ea(g[d>>2])-Va);fb=ea(ea(g[I>>2])-Va);gb=ea(ea(g[J>>2])-Va);hb=ea(ea(g[K>>2])-Va);Va=ea(ea(g[L>>2])-Xa);ib=ea(ea(g[M>>2])-Xa);jb=ea(ea(g[N>>2])-Xa);kb=ea(ea(g[O>>2])-Xa);Xa=ea(ea(g[P>>2])-Za);lb=ea(ea(g[Q>>2])-Za);mb=ea(ea(g[R>>2])-Za);nb=ea(ea(g[U>>2])-Za);Za=ea(ea(cb*Va)-ea(bb*Xa));ob=ea(ea(cb*ib)-ea(bb*lb));pb=ea(ea(cb*jb)-ea(bb*mb));qb=ea(ea(cb*kb)-ea(bb*nb));rb=ea(ea(ab*Xa)-ea(cb*eb));sb=ea(ea(ab*lb)-ea(cb*fb));tb=ea(ea(ab*mb)-ea(cb*gb));ub=ea(ea(ab*nb)-ea(cb*hb));vb=ea(ea(bb*eb)-ea(ab*Va));wb=ea(ea(bb*fb)-ea(ab*ib));xb=ea(ea(bb*gb)-ea(ab*jb));yb=ea(ea(bb*hb)-ea(ab*kb));zb=ea($a+ea(db*ea(ea(ea(ab*eb)+ea(bb*Va))+ea(cb*Xa))));Ab=ea($a+ea(db*ea(ea(ea(ab*fb)+ea(bb*ib))+ea(cb*lb))));Bb=ea($a+ea(db*ea(ea(ea(ab*gb)+ea(bb*jb))+ea(cb*mb))));Cb=ea($a+ea(db*ea(ea(ea(ab*hb)+ea(bb*kb))+ea(cb*nb))));$a=ea(g[m+(Qa*48|0)>>2]);Db=ea(g[m+Wa>>2]);Eb=ea(g[m+Ya>>2]);Fb=ea(g[m+_a>>2]);Gb=ea(g[F+s>>2]);Hb=ea(g[F+Wa>>2]);Ib=ea(g[F+Ya>>2]);Jb=ea(g[F+_a>>2]);Kb=ea(g[E+s>>2]);Lb=ea(g[E+Wa>>2]);Mb=ea(g[E+_a>>2]);Nb=ea(ea(g[e>>2])-$a);Ob=ea(ea(g[V>>2])-$a);Pb=ea(ea(g[W>>2])-$a);Qb=ea(ea(g[X>>2])-$a);_a=(g[k>>2]=Nb,c[k>>2]|0);s=(g[k>>2]=Ob,c[k>>2]|0);Ya=(g[k>>2]=Pb,c[k>>2]|0);Rb=(g[k>>2]=Qb,c[k>>2]|0);Sb=ea(ea(g[Y>>2])-Db);Tb=ea(ea(g[Z>>2])-Db);Ub=ea(ea(g[_>>2])-Db);Vb=ea(ea(g[$>>2])-Db);Wb=(g[k>>2]=Sb,c[k>>2]|0);Xb=(g[k>>2]=Tb,c[k>>2]|0);Yb=(g[k>>2]=Ub,c[k>>2]|0);Zb=(g[k>>2]=Vb,c[k>>2]|0);_b=ea(ea(g[aa>>2])-Eb);$b=ea(ea(g[ba>>2])-Eb);ac=ea(ea(g[ca>>2])-Eb);bc=ea(ea(g[da>>2])-Eb);cc=(g[k>>2]=_b,c[k>>2]|0);dc=(g[k>>2]=$b,c[k>>2]|0);ec=(g[k>>2]=ac,c[k>>2]|0);fc=(g[k>>2]=bc,c[k>>2]|0);gc=ea(ea(Ib*Sb)-ea(Hb*_b));hc=ea(ea(Ib*Tb)-ea(Hb*$b));ic=ea(ea(Ib*Ub)-ea(Hb*ac));jc=ea(ea(Ib*Vb)-ea(Hb*bc));kc=ea(ea(Gb*_b)-ea(Ib*Nb));lc=ea(ea(Gb*$b)-ea(Ib*Ob));mc=ea(ea(Gb*ac)-ea(Ib*Pb));nc=ea(ea(Gb*bc)-ea(Ib*Qb));oc=ea(ea(Hb*Nb)-ea(Gb*Sb));pc=ea(ea(Hb*Ob)-ea(Gb*Tb));qc=ea(ea(Hb*Pb)-ea(Gb*Ub));rc=ea(ea(Hb*Qb)-ea(Gb*Vb));sc=ea(ea(ea(Gb*Nb)+ea(Hb*Sb))+ea(Ib*_b));tc=ea(ea(ea(Gb*Ob)+ea(Hb*Tb))+ea(Ib*$b));uc=ea(ea(ea(Gb*Pb)+ea(Hb*Ub))+ea(Ib*ac));vc=ea(ea(ea(Gb*Qb)+ea(Hb*Vb))+ea(Ib*bc));wc=(g[k>>2]=sc,c[k>>2]|0);xc=(g[k>>2]=tc,c[k>>2]|0);yc=(g[k>>2]=uc,c[k>>2]|0);zc=(g[k>>2]=vc,c[k>>2]|0);Ac=ea(Fb+ea(Jb*sc));sc=ea(Fb+ea(Jb*tc));tc=ea(Fb+ea(Jb*uc));uc=ea(Fb+ea(Jb*vc));vc=ea(gc*gc);Bc=ea(hc*hc);Cc=ea(ic*ic);Dc=ea(jc*jc);Ec=ea(g[119914]);Fc=ea(vc+Ec);vc=ea(g[119915]);Gc=ea(Bc+vc);Bc=ea(g[119916]);Hc=ea(Cc+Bc);Cc=ea(g[119917]);Ic=ea(ea(oc*oc)+ea(ea(kc*kc)+Fc));Fc=ea(ea(pc*pc)+ea(ea(lc*lc)+Gc));Gc=ea(ea(qc*qc)+ea(ea(mc*mc)+Hc));Hc=ea(ea(rc*rc)+ea(ea(nc*nc)+ea(Dc+Cc)));Jc=(g[k>>2]=Ic,c[k>>2]|0);Kc=(g[k>>2]=Fc,c[k>>2]|0);Lc=(g[k>>2]=Gc,c[k>>2]|0);Mc=(g[k>>2]=Hc,c[k>>2]|0);Nc=zb<ea(0.0);Oc=Ab<ea(0.0);Pc=Bb<ea(0.0);Qc=Cb<ea(0.0);Rc=Ac<ea(0.0);Sc=sc<ea(0.0);Tc=tc<ea(0.0);Uc=uc<ea(0.0);Vc=Rc?0:(g[k>>2]=Ac,c[k>>2]|0);Rc=Sc?0:(g[k>>2]=sc,c[k>>2]|0);Sc=Tc?0:(g[k>>2]=tc,c[k>>2]|0);Tc=Ra?Vc:0;Vc=Sa?Rc:0;Rc=Ta?Sc:0;Sc=Ua?(Uc?0:(g[k>>2]=uc,c[k>>2]|0)):0;uc=Nc?ea(0.0):zb;zb=Ra?uc:ea(0.0);uc=ea(g[119966]);tc=ea(zb*uc);zb=Oc?ea(0.0):Ab;Ab=Sa?zb:ea(0.0);zb=ea(g[119967]);sc=ea(Ab*zb);Ab=Pc?ea(0.0):Bb;Bb=Ta?Ab:ea(0.0);Ab=ea(g[119968]);Ac=ea(Bb*Ab);Bb=Qc?ea(0.0):Cb;Cb=Ua?Bb:ea(0.0);Bb=ea(g[119969]);Dc=ea(Cb*Bb);Cb=ea(uc*(c[k>>2]=Tc,ea(g[k>>2])));uc=ea(zb*(c[k>>2]=Vc,ea(g[k>>2])));zb=ea(Ab*(c[k>>2]=Rc,ea(g[k>>2])));Ab=ea(Bb*(c[k>>2]=Sc,ea(g[k>>2])));Bb=ea(ea(ea(vb*vb)+ea(ea(Za*Za)+ea(rb*rb)))-ea(tc*tc));Wc=ea(ea(ea(wb*wb)+ea(ea(ob*ob)+ea(sb*sb)))-ea(sc*sc));Xc=ea(ea(ea(xb*xb)+ea(ea(pb*pb)+ea(tb*tb)))-ea(Ac*Ac));Yc=ea(ea(ea(yb*yb)+ea(ea(qb*qb)+ea(ub*ub)))-ea(Dc*Dc));Zc=ea(ea(ea(vb*oc)+ea(ea(Za*gc)+ea(rb*kc)))-ea(tc*Cb));tc=ea(ea(ea(wb*pc)+ea(ea(ob*hc)+ea(sb*lc)))-ea(sc*uc));sc=ea(ea(ea(xb*qc)+ea(ea(pb*ic)+ea(tb*mc)))-ea(Ac*zb));Ac=ea(ea(ea(yb*rc)+ea(ea(qb*jc)+ea(ub*nc)))-ea(Dc*Ab));Dc=ea(Ic-ea(Cb*Cb));Cb=ea(Fc-ea(uc*uc));uc=ea(Gc-ea(zb*zb));zb=ea(Hc-ea(Ab*Ab));Ab=ea(ea(Zc*Zc)-ea(Bb*Dc));Hc=ea(ea(tc*tc)-ea(Wc*Cb));Gc=ea(ea(sc*sc)-ea(Xc*uc));Fc=ea(ea(Ac*Ac)-ea(Yc*zb));Ic=ea(T(ea(Ab)));nc=ea(T(ea(Hc)));ub=ea(T(ea(Gc)));jc=ea(T(ea(Fc)));qb=ea(Zc-Bb);Bb=ea(tc-Wc);Wc=ea(sc-Xc);Xc=ea(Ac-Yc);Yc=ea(ea(Zc-Dc)+qb);Dc=ea(ea(tc-Cb)+Bb);Cb=ea(ea(sc-uc)+Wc);uc=ea(ea(Ac-zb)+Xc);zb=ea(ea(1.0)/Yc);Ac=ea(ea(1.0)/Dc);sc=ea(ea(1.0)/Cb);tc=ea(ea(1.0)/uc);Zc=ea(Ic+qb);rc=ea(nc+Bb);yb=ea(ub+Wc);mc=ea(jc+Xc);Qc=Zc<ea(0.0);tb=Qc?Zc:ea(0.0);Qc=rc<ea(0.0);Zc=Qc?rc:ea(0.0);Qc=yb<ea(0.0);rc=Qc?yb:ea(0.0);Qc=mc<ea(0.0);yb=ea(zb*tb);tb=ea(Ac*Zc);Zc=ea(sc*rc);rc=ea(tc*(Qc?mc:ea(0.0)));Qc=Yc<ea(-Ec)&(Ab>=ea(0.0)&(qb<Ic&yb<ea(1.0)));Pc=Dc<ea(-vc)&(Hc>=ea(0.0)&(Bb<nc&tb<ea(1.0)));Oc=Cb<ea(-Bc)&(Gc>=ea(0.0)&(Wc<ub&Zc<ea(1.0)));Nc=uc<ea(-Cc)&(Fc>=ea(0.0)&(Xc<jc&rc<ea(1.0)));if((c[k>>2]=Qc<<31>>31,ea(g[k>>2]))==ea(0.0)?(Uc=(c[k>>2]=Pc<<31>>31,ea(g[k>>2]))==ea(0.0),_c=Uc&(c[k>>2]=Oc<<31>>31,ea(g[k>>2]))==ea(0.0),_c&(c[k>>2]=Nc<<31>>31,ea(g[k>>2]))==ea(0.0)):0){$c=wc;ad=xc;bd=yc;cd=zc;dd=fc;ed=ec;fd=dc;gd=cc;hd=Zb;id=Yb;jd=Xb;kd=Wb;ld=Rb;md=Ya;nd=s;od=_a;pd=Tc;qd=Vc;rd=Rc;sd=Sc;td=Jc;ud=Kc;vd=Lc;wd=Mc}else xd=8;do if((xd|0)==8){xd=0;jc=ea(eb-Nb);Xc=ea(fb-Ob);Fc=ea(gb-Pb);Cc=ea(hb-Qb);uc=ea(Va-Sb);ub=ea(ib-Tb);Wc=ea(jb-Ub);Gc=ea(kb-Vb);Bc=ea(Xa-_b);Cb=ea(lb-$b);nc=ea(mb-ac);Bb=ea(nb-bc);Hc=ea(eb-ea(jc*yb));vc=ea(fb-ea(Xc*tb));Dc=ea(gb-ea(Fc*Zc));Ic=ea(hb-ea(Cc*rc));qb=ea(Va-ea(uc*yb));Ab=ea(ib-ea(ub*tb));Ec=ea(jb-ea(Wc*Zc));Yc=ea(kb-ea(Gc*rc));mc=ea(Xa-ea(Bc*yb));tc=ea(lb-ea(Cb*tb));sc=ea(mb-ea(nc*Zc));Ac=ea(nb-ea(Bb*rc));zb=ea(Gb*Lb);ic=ea(Hb*Lb);pb=ea(Ib*Lb);qc=ea(g[G+Wa>>2]);xb=ea(zb-ea(ab*qc));lc=ea(ic-ea(bb*qc));sb=ea(pb-ea(cb*qc));qc=ea(ea(1.0)-yb);hc=ea(ea(1.0)-tb);ob=ea(ea(1.0)-Zc);pc=ea(ea(1.0)-rc);wb=ea(zb-ea(qc*xb));kc=ea(zb-ea(hc*xb));rb=ea(zb-ea(ob*xb));gc=ea(zb-ea(pc*xb));zb=ea(ic-ea(qc*lc));Za=ea(ic-ea(hc*lc));oc=ea(ic-ea(ob*lc));vb=ea(ic-ea(pc*lc));ic=ea(pb-ea(qc*sb));yd=ea(pb-ea(hc*sb));zd=ea(pb-ea(ob*sb));Ad=ea(pb-ea(pc*sb));pb=ea(ea(Jb*yb)+ea(db*qc));Bd=ea(ea(Jb*tb)+ea(db*hc));Cd=ea(ea(Jb*Zc)+ea(db*ob));Dd=ea(ea(Jb*rc)+ea(db*pc));Ed=ea(pb*ea(g[119966]));pb=ea(Bd*ea(g[119967]));Bd=ea(Cd*ea(g[119968]));Cd=ea(ea(1.0)/ea(T(ea(ea(ic*ic)+ea(ea(wb*wb)+ea(zb*zb))))));Fd=ea(ea(1.0)/ea(T(ea(ea(yd*yd)+ea(ea(kc*kc)+ea(Za*Za))))));Gd=ea(ea(1.0)/ea(T(ea(ea(zd*zd)+ea(ea(rb*rb)+ea(oc*oc))))));Hd=ea(ea(1.0)/ea(T(ea(ea(Ad*Ad)+ea(ea(gc*gc)+ea(vb*vb))))));Id=ea(ea(ea(mc*ic)+ea(ea(Hc*wb)+ea(qb*zb)))*Cd);zb=ea(ea(ea(tc*yd)+ea(ea(vc*kc)+ea(Ab*Za)))*Fd);Za=ea(ea(ea(sc*zd)+ea(ea(Dc*rb)+ea(Ec*oc)))*Gd);oc=ea(ea(ea(Ac*Ad)+ea(ea(Ic*gc)+ea(Yc*vb)))*Hd);vb=ea(ea(ea(mc*mc)+ea(ea(Hc*Hc)+ea(qb*qb)))-ea(Id*Id));qb=ea(ea(ea(tc*tc)+ea(ea(vc*vc)+ea(Ab*Ab)))-ea(zb*zb));Ab=ea(ea(ea(sc*sc)+ea(ea(Dc*Dc)+ea(Ec*Ec)))-ea(Za*Za));Ec=ea(ea(ea(Ac*Ac)+ea(ea(Ic*Ic)+ea(Yc*Yc)))-ea(oc*oc));Yc=ea(ea(1.0)/ea(T(ea(vb))));Ic=ea(ea(1.0)/ea(T(ea(qb))));Ac=ea(ea(1.0)/ea(T(ea(Ab))));Dc=ea(ea(1.0)/ea(T(ea(Ec))));_c=vb>ea(0.0);Uc=qb>ea(0.0);Jd=Ab>ea(0.0);Kd=Ec>ea(0.0);sc=ea(Ed*vb);vb=ea(pb*qb);qb=ea(Bd*Ab);Ab=ea(ea(Dd*ea(g[119969]))*Ec);Ec=ea(sc*(_c?Yc:ea(0.0)));Yc=ea(vb*(Uc?Ic:ea(0.0)));Ic=ea(qb*(Jd?Ac:ea(0.0)));Ac=ea(Cd*ea(Id+Ec));Ec=ea(Fd*ea(zb+Yc));Yc=ea(Gd*ea(Za+Ic));Ic=ea(Hd*ea(oc+ea(Ab*(Kd?Dc:ea(0.0)))));Dc=Qc?Ac:ea(0.0);Ac=ea(S(ea(Dc)));Ab=Pc?Ec:ea(0.0);Ec=ea(S(ea(Ab)));oc=Oc?Yc:ea(0.0);Yc=ea(S(ea(oc)));Hd=Nc?Ic:ea(0.0);Kd=Qc&Ac<ea(1.0);Jd=Pc&Ec<ea(1.0);Uc=Oc&Yc<ea(1.0);_c=Nc&ea(S(ea(Hd)))<ea(1.0);if((c[k>>2]=Kd<<31>>31,ea(g[k>>2]))==ea(0.0)?(Ld=(c[k>>2]=Jd<<31>>31,ea(g[k>>2]))==ea(0.0),Md=Ld&(c[k>>2]=Uc<<31>>31,ea(g[k>>2]))==ea(0.0),Md&(c[k>>2]=_c<<31>>31,ea(g[k>>2]))==ea(0.0)):0){$c=wc;ad=xc;bd=yc;cd=zc;dd=fc;ed=ec;fd=dc;gd=cc;hd=Zb;id=Yb;jd=Xb;kd=Wb;ld=Rb;md=Ya;nd=s;od=_a;pd=Tc;qd=Vc;rd=Rc;sd=Sc;td=Jc;ud=Kc;vd=Lc;wd=Mc;break}Yc=ea(jc+ea(xb*Dc));jc=ea(Xc+ea(xb*Ab));Xc=ea(Fc+ea(xb*oc));Fc=ea(Cc+ea(xb*Hd));xb=ea(uc+ea(lc*Dc));uc=ea(ub+ea(lc*Ab));ub=ea(Wc+ea(lc*oc));Wc=ea(Gc+ea(lc*Hd));lc=ea(Bc+ea(sb*Dc));Dc=ea(Cb+ea(sb*Ab));Ab=ea(nc+ea(sb*oc));oc=ea(Bb+ea(sb*Hd));Hd=Kd?qc:ea(0.0);qc=ea(Yc*Hd);Yc=Jd?hc:ea(0.0);hc=ea(jc*Yc);jc=Uc?ob:ea(0.0);ob=ea(Xc*jc);Xc=_c?pc:ea(0.0);pc=ea(Nb+qc);qc=ea(Ob+hc);hc=ea(Pb+ob);ob=ea(Qb+ea(Fc*Xc));_c=(g[k>>2]=pc,c[k>>2]|0);Uc=(g[k>>2]=qc,c[k>>2]|0);Jd=(g[k>>2]=hc,c[k>>2]|0);Kd=(g[k>>2]=ob,c[k>>2]|0);Fc=ea(Sb+ea(xb*Hd));xb=ea(Tb+ea(uc*Yc));uc=ea(Ub+ea(ub*jc));ub=ea(Vb+ea(Wc*Xc));Md=(g[k>>2]=Fc,c[k>>2]|0);Ld=(g[k>>2]=xb,c[k>>2]|0);Nd=(g[k>>2]=uc,c[k>>2]|0);Od=(g[k>>2]=ub,c[k>>2]|0);Wc=ea(_b+ea(lc*Hd));Hd=ea($b+ea(Dc*Yc));Yc=ea(ac+ea(Ab*jc));jc=ea(bc+ea(oc*Xc));Pd=(g[k>>2]=Wc,c[k>>2]|0);Qd=(g[k>>2]=Hd,c[k>>2]|0);Rd=(g[k>>2]=Yc,c[k>>2]|0);Sd=(g[k>>2]=jc,c[k>>2]|0);Xc=ea(ea(Ib*Wc)+ea(ea(Gb*pc)+ea(Hb*Fc)));oc=ea(ea(Ib*Hd)+ea(ea(Gb*qc)+ea(Hb*xb)));Ab=ea(ea(Ib*Yc)+ea(ea(Gb*hc)+ea(Hb*uc)));Dc=ea(ea(Ib*jc)+ea(ea(Gb*ob)+ea(Hb*ub)));Td=(g[k>>2]=Xc,c[k>>2]|0);Ud=(g[k>>2]=oc,c[k>>2]|0);Vd=(g[k>>2]=Ab,c[k>>2]|0);Wd=(g[k>>2]=Dc,c[k>>2]|0);lc=ea(Fb+ea(Jb*Xc));sb=ea(Fb+ea(Jb*oc));Bb=ea(Fb+ea(Jb*Ab));nc=ea(Fb+ea(Jb*Dc));Xd=lc<ea(0.0);Yd=sb<ea(0.0);Zd=Bb<ea(0.0);_d=nc<ea(0.0);$d=Xd?0:(g[k>>2]=lc,c[k>>2]|0);Xd=Yd?0:(g[k>>2]=sb,c[k>>2]|0);Yd=Zd?0:(g[k>>2]=Bb,c[k>>2]|0);Zd=Ua?(_d?0:(g[k>>2]=nc,c[k>>2]|0)):0;nc=ea(ea(ea(Wc*Wc)+ea(ea(pc*pc)+ea(Fc*Fc)))-ea(Xc*Xc));Xc=ea(ea(ea(Hd*Hd)+ea(ea(qc*qc)+ea(xb*xb)))-ea(oc*oc));oc=ea(ea(ea(Yc*Yc)+ea(ea(hc*hc)+ea(uc*uc)))-ea(Ab*Ab));Ab=ea(ea(ea(jc*jc)+ea(ea(ob*ob)+ea(ub*ub)))-ea(Dc*Dc));_d=(g[k>>2]=nc,c[k>>2]|0);ae=(g[k>>2]=Xc,c[k>>2]|0);be=(g[k>>2]=oc,c[k>>2]|0);ce=(g[k>>2]=Ab,c[k>>2]|0);Ab=ea($a+pc);pc=ea($a+qc);qc=ea($a+hc);hc=ea($a+ob);ob=ea(Ab);Ab=ea(pc);pc=ea(qc);qc=ea(hc);g[e>>2]=ob;g[V>>2]=Ab;g[W>>2]=pc;g[X>>2]=qc;qc=ea(Db+Fc);Fc=ea(Db+xb);xb=ea(Db+uc);uc=ea(Db+ub);ub=ea(qc);qc=ea(Fc);Fc=ea(xb);xb=ea(uc);g[Y>>2]=ub;g[Z>>2]=qc;g[_>>2]=Fc;g[$>>2]=xb;xb=ea(Eb+Wc);Wc=ea(Eb+Hd);Hd=ea(Eb+Yc);Yc=ea(Eb+jc);jc=ea(xb);xb=ea(Wc);Wc=ea(Hd);Hd=ea(Yc);g[aa>>2]=jc;g[ba>>2]=xb;g[ca>>2]=Wc;g[da>>2]=Hd;$c=Td;ad=Ud;bd=Vd;cd=Wd;dd=Sd;ed=Rd;fd=Qd;gd=Pd;hd=Od;id=Nd;jd=Ld;kd=Md;ld=Kd;md=Jd;nd=Uc;od=_c;pd=Ra?$d:0;qd=Sa?Xd:0;rd=Ta?Yd:0;sd=Zd;td=_d;ud=ae;vd=be;wd=ce}while(0);Eb=(c[k>>2]=pd,ea(g[k>>2]));Db=ea(Eb*Eb);$a=(c[k>>2]=qd,ea(g[k>>2]));Fb=ea($a*$a);bc=(c[k>>2]=rd,ea(g[k>>2]));ac=ea(bc*bc);$b=(c[k>>2]=sd,ea(g[k>>2]));_b=ea($b*$b);Vb=(c[k>>2]=td,ea(g[k>>2]));Ta=Db>Vb;Db=(c[k>>2]=ud,ea(g[k>>2]));Sa=Fb>Db;Fb=(c[k>>2]=vd,ea(g[k>>2]));Ra=ac>Fb;ac=(c[k>>2]=wd,ea(g[k>>2]));Ua=_b>ac;Mc=Ta^1;Lc=Sa^1;Kc=Ra^1;Jc=Ua^1;Sc=(g[k>>2]=Mb,c[k>>2]|0);Rc=c[ga>>2]&~((Pc?0:Lc<<31>>31)&Sc);Vc=c[ha>>2]&~((Oc?0:Kc<<31>>31)&Sc);Tc=c[ia>>2]&~((Nc?0:Jc<<31>>31)&Sc);c[fa>>2]=c[fa>>2]&~((Qc?0:Mc<<31>>31)&Sc);c[ga>>2]=Rc;c[ha>>2]=Vc;c[ia>>2]=Tc;if((Ta|Sa|Ra|Ua?(_b=ea(ea(1.0)/ea(T(ea(Vb)))),Ub=ea(ea(1.0)/ea(T(ea(Db)))),Tb=ea(ea(1.0)/ea(T(ea(Fb)))),Sb=ea(ea(1.0)/ea(T(ea(ac)))),Qb=ea(g[119934]),Pb=ea(g[119935]),Ob=ea(g[119936]),Ua=ac>ea(g[119937]),Nb=ea(Jb*Vb),db=ea(Jb*Db),rc=ea(Jb*Fb),Zc=ea(Jb*ac),ac=Vb>Qb?_b:ea(0.0),_b=ea(Nb*ac),Nb=Db>Pb?Ub:ea(0.0),Ub=ea(db*Nb),db=Fb>Ob?Tb:ea(0.0),Tb=ea(rc*db),rc=Ua?Sb:ea(0.0),Sb=ea(Zc*rc),Zc=(c[k>>2]=$c,ea(g[k>>2])),Ob=ea(Zc+_b),_b=(c[k>>2]=ad,ea(g[k>>2])),Fb=ea(_b+Ub),Ub=(c[k>>2]=bd,ea(g[k>>2])),Pb=ea(Ub+Tb),Tb=(c[k>>2]=cd,ea(g[k>>2])),Db=ea(Tb+Sb),Sb=ea(-Lb),Ua=Ob>Lb|Ob<Sb|Mc,Mc=Fb>Lb|Fb<Sb|Lc,Lc=Pb>Lb|Pb<Sb|Kc,Kc=Db>Lb|Db<Sb|Jc,!(Mc&Ua&Lc&Kc)):0)?(Sb=ea(Kb*ea($b*rc)),rc=ea(Kb*ea(bc*db)),db=ea(Kb*ea($a*Nb)),Nb=ea(Kb*ea(Eb*ac)),ac=(c[k>>2]=dd,ea(g[k>>2])),Eb=(c[k>>2]=ed,ea(g[k>>2])),$a=(c[k>>2]=fd,ea(g[k>>2])),bc=(c[k>>2]=gd,ea(g[k>>2])),$b=ea(Ib*Db),Qb=ea(Ib*Pb),Vb=ea(Ib*Fb),tb=ea(Ib*Ob),yb=(c[k>>2]=hd,ea(g[k>>2])),cb=(c[k>>2]=id,ea(g[k>>2])),bb=(c[k>>2]=jd,ea(g[k>>2])),ab=(c[k>>2]=kd,ea(g[k>>2])),nb=ea(Hb*Db),mb=ea(Hb*Pb),lb=ea(Hb*Fb),Xa=ea(Hb*Ob),kb=(c[k>>2]=ld,ea(g[k>>2])),jb=(c[k>>2]=md,ea(g[k>>2])),ib=(c[k>>2]=nd,ea(g[k>>2])),Va=ea(Sb-Kb),Sb=ea(rc-Kb),rc=ea(db-Kb),db=ea(Nb-Kb),Nb=ea(ac-$b),$b=ea(Eb-Qb),Qb=ea($a-Vb),Vb=ea(bc-tb),tb=ea(yb-nb),nb=ea(cb-mb),mb=ea(bb-lb),lb=ea(ab-Xa),Xa=ea(kb-ea(Gb*Db)),Db=ea(jb-ea(Gb*Pb)),Pb=ea(ib-ea(Gb*Fb)),Fb=ea((c[k>>2]=od,ea(g[k>>2]))-ea(Gb*Ob)),Ob=Ua?ea(0.0):db,db=ea(Fb*Ob),Fb=Mc?ea(0.0):rc,rc=ea(Pb*Fb),Pb=Lc?ea(0.0):Sb,Sb=ea(Db*Pb),Db=Kc?ea(0.0):Va,Va=ea(Xa*Db),Xa=ea(db+ea(g[f>>2])),db=ea(rc+ea(g[ja>>2])),rc=ea(Sb+ea(g[ka>>2])),Sb=ea(Va+ea(g[la>>2])),Va=ea(Xa),Xa=ea(db),db=ea(rc),rc=ea(Sb),g[f>>2]=Va,g[ja>>2]=Xa,g[ka>>2]=db,g[la>>2]=rc,rc=ea(lb*Ob),lb=ea(mb*Fb),mb=ea(nb*Pb),nb=ea(tb*Db),tb=ea(rc+ea(g[ma>>2])),rc=ea(lb+ea(g[na>>2])),lb=ea(mb+ea(g[oa>>2])),mb=ea(nb+ea(g[pa>>2])),nb=ea(tb),tb=ea(rc),rc=ea(lb),lb=ea(mb),g[ma>>2]=nb,g[na>>2]=tb,g[oa>>2]=rc,g[pa>>2]=lb,lb=ea(Vb*Ob),Ob=ea(Qb*Fb),Fb=ea($b*Pb),Pb=ea(Nb*Db),Db=ea(lb+ea(g[qa>>2])),lb=ea(Ob+ea(g[ra>>2])),Ob=ea(Fb+ea(g[sa>>2])),Fb=ea(Pb+ea(g[ta>>2])),Pb=ea(Db),Db=ea(lb),lb=ea(Ob),Ob=ea(Fb),g[qa>>2]=Pb,g[ra>>2]=Db,g[sa>>2]=lb,g[ta>>2]=Ob,Ob=ea(g[ua>>2]),lb=ea((Ua?ea(0.0):ea(1.0))+Ob),Ob=ea(g[va>>2]),Db=ea((Mc?ea(0.0):ea(1.0))+Ob),Ob=ea(g[wa>>2]),Pb=ea((Lc?ea(0.0):ea(1.0))+Ob),Ob=ea(g[xa>>2]),Fb=ea((Kc?ea(0.0):ea(1.0))+Ob),Ob=ea(lb),lb=ea(Db),Db=ea(Pb),Pb=ea(Fb),g[ua>>2]=Ob,g[va>>2]=lb,g[wa>>2]=Db,g[xa>>2]=Pb,o):0){Jc=c[(c[n>>2]|0)+156>>2]|0;Ra=c[Jc+(Qa<<3)>>2]|0;Sa=c[Jc+(Qa<<3)+4>>2]|0;Jc=c[ya>>2]|0;Ta=c[za>>2]|0;Tc=Ra<<4;Pb=ea(g[Jc+(Ra<<4)>>2]);Vc=Tc|4;Db=ea(g[Jc+Vc>>2]);Rc=Tc|8;lb=ea(g[Jc+Rc>>2]);Ob=ea(g[Ta+(Ra<<4)>>2]);Fb=ea(g[Ta+Vc>>2]);Nb=ea(g[Ta+Rc>>2]);Rc=Sa<<4;$b=ea(g[Jc+(Sa<<4)>>2]);Vc=Rc|4;Qb=ea(g[Jc+Vc>>2]);Ra=Rc|8;Vb=ea(g[Jc+Ra>>2]);rc=ea(g[Ta+(Sa<<4)>>2]);tb=ea(g[Ta+Vc>>2]);nb=ea(Ob-Pb);Pb=ea(Fb-Db);Db=ea(Nb-lb);lb=ea(ea(rc-$b)-nb);$b=ea(ea(tb-Qb)-Pb);Qb=ea(ea(ea(g[Ta+Ra>>2])-Vb)-Db);Vb=ea(g[119946]);tb=ea(Zc*Vb);Zc=ea(g[119947]);rc=ea(_b*Zc);_b=ea(g[119948]);Nb=ea(Ub*_b);Ub=ea(g[119949]);Fb=ea(Vb+tb);tb=ea(Zc+rc);rc=ea(_b+Nb);Nb=ea(Ub+ea(Tb*Ub));Ub=ea(nb+ea(lb*Fb));Tb=ea(nb+ea(lb*tb));_b=ea(nb+ea(lb*rc));Zc=ea(nb+ea(lb*Nb));lb=ea(Pb+ea($b*Fb));nb=ea(Pb+ea($b*tb));Vb=ea(Pb+ea($b*rc));Ob=ea(Pb+ea($b*Nb));$b=ea(Db+ea(Qb*Fb));Fb=ea(Db+ea(Qb*tb));tb=ea(Db+ea(Qb*rc));rc=ea(Db+ea(Qb*Nb));Nb=ea(g[b>>2]);Qb=ea(Nb+(Ua?ea(0.0):Ub));Ub=ea(g[Aa>>2]);Nb=ea(Ub+(Mc?ea(0.0):Tb));Tb=ea(g[Ba>>2]);Ub=ea(Tb+(Lc?ea(0.0):_b));_b=ea(g[Ca>>2]);Tb=ea(_b+(Kc?ea(0.0):Zc));Zc=ea(Qb);Qb=ea(Nb);Nb=ea(Ub);Ub=ea(Tb);g[b>>2]=Zc;g[Aa>>2]=Qb;g[Ba>>2]=Nb;g[Ca>>2]=Ub;Ub=ea(g[Da>>2]);Nb=ea((Ua?ea(0.0):lb)+Ub);Ub=ea(g[Ea>>2]);lb=ea((Mc?ea(0.0):nb)+Ub);Ub=ea(g[Fa>>2]);nb=ea((Lc?ea(0.0):Vb)+Ub);Ub=ea(g[Ga>>2]);Vb=ea((Kc?ea(0.0):Ob)+Ub);Ub=ea(Nb);Nb=ea(lb);lb=ea(nb);nb=ea(Vb);g[Da>>2]=Ub;g[Ea>>2]=Nb;g[Fa>>2]=lb;g[Ga>>2]=nb;nb=ea(g[Ha>>2]);lb=ea((Ua?ea(0.0):$b)+nb);nb=ea(g[Ia>>2]);$b=ea((Mc?ea(0.0):Fb)+nb);nb=ea(g[Ja>>2]);Fb=ea((Lc?ea(0.0):tb)+nb);nb=ea(g[Ka>>2]);tb=ea((Kc?ea(0.0):rc)+nb);nb=ea(lb);lb=ea($b);$b=ea(Fb);Fb=ea(tb);g[Ha>>2]=nb;g[Ia>>2]=lb;g[Ja>>2]=$b;g[Ka>>2]=Fb}}while((Pa|0)!=0);t=fa;u=ga;v=ha;w=ia;x=c[t>>2]|0;c[a>>2]=x;y=c[u>>2]|0;z=a+4|0;c[z>>2]=y;A=c[v>>2]|0;B=a+8|0;c[B>>2]=A;C=c[w>>2]|0;D=a+12|0;c[D>>2]=C;i=h;return}function cna(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;f=i;h=a+432|0;a=c[(c[h>>2]|0)+172>>2]|0;j=b+(a<<4)|0;if(!a){l=0;m=0;n=0;o=0}else{p=ea(g[d+32>>2]);q=ea(g[d+36>>2]);r=ea(g[d+40>>2]);s=ea(g[d+44>>2]);t=ea(g[d+16>>2]);u=ea(g[d+20>>2]);v=ea(g[d+24>>2]);w=ea(g[d+28>>2]);x=ea(g[d>>2]);y=ea(g[d+4>>2]);z=ea(g[d+8>>2]);A=ea(g[d+12>>2]);d=1;B=1;C=1;D=1;E=0;F=0;G=0;H=0;I=j;J=b;while(1){K=ea(g[J+12>>2]);L=ea(g[J+8>>2]);M=ea(K+ea(L*p));N=ea(K+ea(L*q));O=ea(K+ea(L*r));P=ea(K+ea(L*s));L=ea(g[J+4>>2]);K=ea(M+ea(L*t));M=ea(N+ea(L*u));N=ea(O+ea(L*v));O=ea(P+ea(L*w));L=ea(g[J>>2]);P=ea(K+ea(L*x));K=ea(M+ea(L*y));M=ea(N+ea(L*z));N=ea(O+ea(L*A));L=ea(P);O=ea(K);Q=ea(M);R=ea(N);g[I>>2]=L;g[I+4>>2]=O;g[I+8>>2]=Q;g[I+12>>2]=R;S=P<ea(0.0);T=K<ea(0.0);U=M<ea(0.0);V=N<ea(0.0);W=(S?d:0)|E;S=(T?B:0)|F;T=(U?C:0)|G;U=(V?D:0)|H;J=J+16|0;if((J|0)==(j|0)){l=U;m=T;n=S;o=W;break}else{d=d<<1;B=B<<1;C=C<<1;D=D<<1;E=W;F=S;G=T;H=U;I=I+16|0}}}if(!(m|l|n|o)){i=f;return}I=c[h>>2]|0;h=c[I+176>>2]|0;H=c[I+180>>2]|0;I=h+(H<<2)|0;if(!H){i=f;return}H=e+4|0;G=e+8|0;F=e+12|0;E=e+16|0;D=e+20|0;C=e+24|0;B=e+28|0;d=e+32|0;j=e+36|0;J=e+40|0;U=e+44|0;T=e+96|0;S=e+100|0;W=e+104|0;V=e+108|0;X=h;do{h=c[X>>2]|0;Y=(h&o|0)==(h|0);Z=(h&n|0)==(h|0);_=(h&m|0)==(h|0);$=(h&l|0)==(h|0);if(Y|Z|(_|$)){aa=h&0-h;ba=0;while(1){aa=aa>>>1;if(!aa)break;else ba=ba+1|0}aa=c[b+(ba<<4)>>2]|0;ca=c[b+(ba<<4)+4>>2]|0;da=c[b+(ba<<4)+8>>2]|0;fa=ba+a|0;ga=c[b+(fa<<4)>>2]|0;ha=c[b+(fa<<4)+4>>2]|0;ia=c[b+(fa<<4)+8>>2]|0;ja=c[b+(fa<<4)+12>>2]|0;fa=h+-1&h;if(!fa){ka=aa;la=aa;ma=aa;na=aa;oa=ca;pa=ca;qa=ca;ra=ca;sa=da;ta=da;ua=da;va=da;wa=ja;xa=ia;ya=ha;za=ga}else{Aa=fa;fa=ga;ga=ha;ha=ia;ia=ja;ja=aa;Ba=aa;Ca=aa;Da=aa;aa=ca;Ea=ca;Fa=ca;Ga=ca;ca=da;Ha=da;Ia=da;Ja=da;while(1){da=Aa&0-Aa;Ka=0;while(1){da=da>>>1;if(!da)break;else Ka=Ka+1|0}da=c[b+(Ka<<4)>>2]|0;La=c[b+(Ka<<4)+4>>2]|0;Ma=c[b+(Ka<<4)+8>>2]|0;Na=Ka+a|0;A=ea(g[b+(Na<<4)>>2]);z=(c[k>>2]=fa,ea(g[k>>2]));y=ea(g[b+(Na<<4)+4>>2]);x=(c[k>>2]=ga,ea(g[k>>2]));w=ea(g[b+(Na<<4)+8>>2]);v=(c[k>>2]=ha,ea(g[k>>2]));u=ea(g[b+(Na<<4)+12>>2]);t=(c[k>>2]=ia,ea(g[k>>2]));Na=A>z;Oa=y>x;Pa=w>v;Qa=u>t;Ra=(Na?da^ja:0)^ja;Sa=(Oa?da^Ba:0)^Ba;Ta=(Pa?da^Ca:0)^Ca;Ua=(Qa?da^Da:0)^Da;da=(Na?La^aa:0)^aa;Va=(Oa?La^Ea:0)^Ea;Wa=(Pa?La^Fa:0)^Fa;Xa=(Qa?La^Ga:0)^Ga;La=(Na?Ma^ca:0)^ca;Na=(Oa?Ma^Ha:0)^Ha;Oa=(Pa?Ma^Ia:0)^Ia;Pa=(Qa?Ma^Ja:0)^Ja;Ma=(g[k>>2]=A<z?z:A,c[k>>2]|0);Qa=(g[k>>2]=y<x?x:y,c[k>>2]|0);Ya=(g[k>>2]=w<v?v:w,c[k>>2]|0);Za=(g[k>>2]=u<t?t:u,c[k>>2]|0);Aa=Aa+-1&Aa;if(!Aa){ka=Ua;la=Ta;ma=Sa;na=Ra;oa=Xa;pa=Wa;qa=Va;ra=da;sa=Pa;ta=Oa;ua=Na;va=La;wa=Za;xa=Ya;ya=Qa;za=Ma;break}else{fa=Ma;ga=Qa;ha=Ya;ia=Za;ja=Ra;Ba=Sa;Ca=Ta;Da=Ua;aa=da;Ea=Va;Fa=Wa;Ga=Xa;ca=La;Ha=Na;Ia=Oa;Ja=Pa}}}u=(c[k>>2]=na,ea(g[k>>2]));t=(c[k>>2]=za,ea(g[k>>2]));w=Y?t:ea(0.0);t=ea(u*w);u=(c[k>>2]=ma,ea(g[k>>2]));v=(c[k>>2]=ya,ea(g[k>>2]));y=Z?v:ea(0.0);v=ea(u*y);u=(c[k>>2]=la,ea(g[k>>2]));x=(c[k>>2]=xa,ea(g[k>>2]));A=_?x:ea(0.0);x=ea(u*A);u=(c[k>>2]=ka,ea(g[k>>2]));z=(c[k>>2]=wa,ea(g[k>>2]));s=$?z:ea(0.0);z=ea(u*s);u=ea(ea(g[e>>2])-t);t=ea(ea(g[H>>2])-v);v=ea(ea(g[G>>2])-x);x=ea(ea(g[F>>2])-z);z=ea(u);u=ea(t);t=ea(v);v=ea(x);g[e>>2]=z;g[H>>2]=u;g[G>>2]=t;g[F>>2]=v;v=ea((c[k>>2]=ra,ea(g[k>>2]))*w);t=ea((c[k>>2]=qa,ea(g[k>>2]))*y);u=ea((c[k>>2]=pa,ea(g[k>>2]))*A);z=ea((c[k>>2]=oa,ea(g[k>>2]))*s);x=ea(ea(g[E>>2])-v);v=ea(ea(g[D>>2])-t);t=ea(ea(g[C>>2])-u);u=ea(ea(g[B>>2])-z);z=ea(x);x=ea(v);v=ea(t);t=ea(u);g[E>>2]=z;g[D>>2]=x;g[C>>2]=v;g[B>>2]=t;t=ea((c[k>>2]=va,ea(g[k>>2]))*w);w=ea((c[k>>2]=ua,ea(g[k>>2]))*y);y=ea((c[k>>2]=ta,ea(g[k>>2]))*A);A=ea((c[k>>2]=sa,ea(g[k>>2]))*s);s=ea(ea(g[d>>2])-t);t=ea(ea(g[j>>2])-w);w=ea(ea(g[J>>2])-y);y=ea(ea(g[U>>2])-A);A=ea(s);s=ea(t);t=ea(w);w=ea(y);g[d>>2]=A;g[j>>2]=s;g[J>>2]=t;g[U>>2]=w;w=ea(g[T>>2]);t=ea((Y?ea(1.0):ea(0.0))+w);w=ea(g[S>>2]);s=ea((Z?ea(1.0):ea(0.0))+w);w=ea(g[W>>2]);A=ea((_?ea(1.0):ea(0.0))+w);w=ea(g[V>>2]);y=ea(($?ea(1.0):ea(0.0))+w);w=ea(t);t=ea(s);s=ea(A);A=ea(y);g[T>>2]=w;g[S>>2]=t;g[W>>2]=s;g[V>>2]=A}X=X+4|0}while((X|0)!=(I|0));i=f;return}function dna(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=0,Va=0,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;f=i;h=c[(c[a+432>>2]|0)+192>>2]|0;a=b+(h*80|0)|0;if(!h){j=ea(0.0);l=ea(0.0);m=ea(0.0);n=ea(0.0);o=ea(0.0);p=ea(0.0);q=ea(0.0);r=ea(0.0);s=ea(0.0);t=ea(0.0);u=ea(0.0);v=ea(0.0);w=ea(0.0);x=ea(0.0);y=ea(0.0);z=ea(0.0)}else{A=ea(g[d>>2]);B=ea(g[d+4>>2]);C=ea(g[d+8>>2]);D=ea(g[d+12>>2]);E=ea(g[d+16>>2]);F=ea(g[d+20>>2]);G=ea(g[d+24>>2]);H=ea(g[d+28>>2]);I=ea(g[d+32>>2]);J=ea(g[d+36>>2]);K=ea(g[d+40>>2]);L=ea(g[d+44>>2]);d=c[119918]|0;h=c[119919]|0;M=c[119920]|0;N=c[119921]|0;O=0;P=0;Q=0;R=0;S=0;T=0;U=0;V=0;W=0;X=0;Y=0;Z=0;_=0;$=0;aa=0;ba=0;ca=b;while(1){da=ea(g[ca>>2]);fa=ea(g[ca+4>>2]);ga=ea(g[ca+8>>2]);ha=ea(g[ca+12>>2]);b=ca+16|0;ia=ea(g[b>>2]);ja=ea(g[b+4>>2]);ka=ea(g[b+8>>2]);la=ea(g[b+12>>2]);b=ca+32|0;ma=ea(g[b>>2]);na=ea(g[b+4>>2]);oa=ea(g[b+8>>2]);pa=ea(g[b+12>>2]);b=ca+48|0;qa=ea(g[b>>2]);ra=ea(g[b+4>>2]);sa=ea(g[b+8>>2]);b=ca+64|0;ta=ea(g[b>>2]);ua=ea(g[b+4>>2]);va=ea(g[b+8>>2]);wa=ea(g[b+12>>2]);xa=ea(A-da);ya=ea(B-da);za=ea(C-da);Aa=ea(D-da);da=ea(E-fa);Ba=ea(F-fa);Ca=ea(G-fa);Da=ea(H-fa);fa=ea(I-ga);Ea=ea(J-ga);Fa=ea(K-ga);Ga=ea(L-ga);b=(g[k>>2]=qa,c[k>>2]|0);Ha=(g[k>>2]=ra,c[k>>2]|0);Ia=(g[k>>2]=sa,c[k>>2]|0);ga=ea(ea(ea(ia*xa)+ea(ja*da))+ea(ka*fa));Ja=ea(ea(ea(ia*ya)+ea(ja*Ba))+ea(ka*Ea));Ka=ea(ea(ea(ia*za)+ea(ja*Ca))+ea(ka*Fa));La=ea(ea(ea(ia*Aa)+ea(ja*Da))+ea(ka*Ga));Ma=ea(ea(ea(ma*xa)+ea(na*da))+ea(oa*fa));Na=ea(ea(ea(ma*ya)+ea(na*Ba))+ea(oa*Ea));Oa=ea(ea(ea(ma*za)+ea(na*Ca))+ea(oa*Fa));Pa=ea(ea(ea(ma*Aa)+ea(na*Da))+ea(oa*Ga));Qa=ea(ea(ea(qa*xa)+ea(ra*da))+ea(sa*fa));Ra=ea(ea(ea(qa*ya)+ea(ra*Ba))+ea(sa*Ea));Sa=ea(ea(ea(qa*za)+ea(ra*Ca))+ea(sa*Fa));Ta=ea(ea(ea(qa*Aa)+ea(ra*Da))+ea(sa*Ga));Ua=(g[k>>2]=Qa,c[k>>2]|0);Va=(g[k>>2]=Ra,c[k>>2]|0);Wa=(g[k>>2]=Sa,c[k>>2]|0);Xa=(g[k>>2]=Ta,c[k>>2]|0);sa=ea(ea(pa*ga)-ea(ha*Ma));ra=ea(ea(pa*Ja)-ea(ha*Na));qa=ea(ea(pa*Ka)-ea(ha*Oa));Ya=ea(ea(pa*La)-ea(ha*Pa));Za=ea(ea(la*Ma)-ea(ha*ga));_a=ea(ea(la*Na)-ea(ha*Ja));$a=ea(ea(la*Oa)-ea(ha*Ka));ab=ea(ea(la*Pa)-ea(ha*La));bb=sa>ea(0.0);cb=ra>ea(0.0);db=qa>ea(0.0);eb=Ya>ea(0.0);fb=Za>ea(0.0);gb=_a>ea(0.0);hb=$a>ea(0.0);ib=ab>ea(0.0);la=ea(ta*sa);sa=ea(ta*ra);ra=ea(ta*qa);qa=ea(ta*Ya);jb=(g[k>>2]=la,c[k>>2]|0);kb=(g[k>>2]=sa,c[k>>2]|0);lb=(g[k>>2]=ra,c[k>>2]|0);mb=(g[k>>2]=qa,c[k>>2]|0);qa=ea(va*ga);ra=ea(va*Ja);sa=ea(va*Ka);la=ea(va*La);nb=(g[k>>2]=qa,c[k>>2]|0);ob=(g[k>>2]=ra,c[k>>2]|0);pb=(g[k>>2]=sa,c[k>>2]|0);qb=(g[k>>2]=la,c[k>>2]|0);rb=(fb?jb^nb:0)^nb;nb=(gb?kb^ob:0)^ob;ob=(hb?lb^pb:0)^pb;pb=(ib?mb^qb:0)^qb;la=ea(ta*Za);Za=ea(ta*_a);_a=ea(ta*$a);$a=ea(ta*ab);qb=(g[k>>2]=la,c[k>>2]|0);mb=(g[k>>2]=Za,c[k>>2]|0);ib=(g[k>>2]=_a,c[k>>2]|0);lb=(g[k>>2]=$a,c[k>>2]|0);$a=ea(wa*Ma);_a=ea(wa*Na);Za=ea(wa*Oa);la=ea(wa*Pa);hb=(g[k>>2]=$a,c[k>>2]|0);kb=(g[k>>2]=_a,c[k>>2]|0);gb=(g[k>>2]=Za,c[k>>2]|0);jb=(g[k>>2]=la,c[k>>2]|0);la=(c[k>>2]=rb,ea(g[k>>2]));Za=(c[k>>2]=(bb?qb^hb:0)^hb,ea(g[k>>2]));_a=ea(la+Za);la=(c[k>>2]=nb,ea(g[k>>2]));$a=(c[k>>2]=(cb?mb^kb:0)^kb,ea(g[k>>2]));wa=ea(la+$a);la=(c[k>>2]=ob,ea(g[k>>2]));ab=(c[k>>2]=(db?ib^gb:0)^gb,ea(g[k>>2]));ta=ea(la+ab);la=(c[k>>2]=pb,ea(g[k>>2]));sa=(c[k>>2]=(eb?lb^jb:0)^jb,ea(g[k>>2]));jb=_a>ea(1.0);lb=wa>ea(1.0);eb=ta>ea(1.0);gb=ea(la+sa)>ea(1.0);la=ea(pa-ha);ha=ea(ua*ea(ea(la+ga)-Ma));Ma=ea(ua*ea(ea(la+Ja)-Na));Na=ea(ua*ea(ea(la+Ka)-Oa));Oa=ea(ua*ea(ea(la+La)-Pa));ib=(g[k>>2]=ha,c[k>>2]|0);db=(g[k>>2]=Ma,c[k>>2]|0);kb=(g[k>>2]=Na,c[k>>2]|0);mb=(gb?pb^(g[k>>2]=Oa,c[k>>2]|0):0)^pb;Oa=(c[k>>2]=(jb?rb^ib:0)^rb,ea(g[k>>2]));rb=Oa<ea(1.0);Na=rb?Oa:ea(1.0);Oa=(c[k>>2]=(lb?nb^db:0)^nb,ea(g[k>>2]));nb=Oa<ea(1.0);Ma=nb?Oa:ea(1.0);Oa=(c[k>>2]=(eb?ob^kb:0)^ob,ea(g[k>>2]));ob=Oa<ea(1.0);ha=ob?Oa:ea(1.0);Oa=(c[k>>2]=mb,ea(g[k>>2]));mb=Oa<ea(1.0);Pa=mb?Oa:ea(1.0);mb=Na>ea(0.0);ob=Ma>ea(0.0);kb=ha>ea(0.0);eb=Pa>ea(0.0);Oa=mb?Na:ea(0.0);Na=ea(ea(1.0)-Oa);La=ob?Ma:ea(0.0);Ma=ea(ea(1.0)-La);la=kb?ha:ea(0.0);ha=ea(ea(1.0)-la);ua=eb?Pa:ea(0.0);Pa=ea(ea(1.0)-ua);Ka=Za<Na?Za:Na;Na=$a<Ma?$a:Ma;Ma=ab<ha?ab:ha;ha=sa<Pa?sa:Pa;eb=Ka>ea(0.0);kb=Na>ea(0.0);ob=Ma>ea(0.0);mb=ha>ea(0.0);Pa=ea(xa-ea(ia*Oa));xa=ea(ya-ea(ia*La));ya=ea(za-ea(ia*la));za=ea(Aa-ea(ia*ua));ia=eb?Ka:ea(0.0);Ka=ea(ma*ia);Aa=kb?Na:ea(0.0);Na=ea(ma*Aa);sa=ob?Ma:ea(0.0);Ma=ea(ma*sa);ab=mb?ha:ea(0.0);ha=ea(Pa-Ka);Ka=ea(xa-Na);Na=ea(ya-Ma);Ma=ea(za-ea(ma*ab));ma=ea(ea(da-ea(ja*Oa))-ea(na*ia));da=ea(ea(Ba-ea(ja*La))-ea(na*Aa));Ba=ea(ea(Ca-ea(ja*la))-ea(na*sa));Ca=ea(ea(Da-ea(ja*ua))-ea(na*ab));na=ea(ea(fa-ea(ka*Oa))-ea(oa*ia));ia=ea(ea(Ea-ea(ka*La))-ea(oa*Aa));Aa=ea(ea(Fa-ea(ka*la))-ea(oa*sa));sa=ea(ea(Ga-ea(ka*ua))-ea(oa*ab));ab=ea(ea(na*na)+ea(ea(ha*ha)+ea(ma*ma)));ma=ea(ea(ia*ia)+ea(ea(Ka*Ka)+ea(da*da)));da=ea(ea(Aa*Aa)+ea(ea(Na*Na)+ea(Ba*Ba)));Ba=ea(ea(sa*sa)+ea(ea(Ma*Ma)+ea(Ca*Ca)));mb=Qa<ea(0.0);ob=Ra<ea(0.0);kb=Sa<ea(0.0);eb=Ta<ea(0.0);Ta=ea((mb?ea(.0000999999974):ea(0.0))*ab);Sa=ea((ob?ea(.0000999999974):ea(0.0))*ma);Ra=ea((kb?ea(.0000999999974):ea(0.0))*da);Qa=ea(ab+Ta);Ta=ea(ma+Sa);Sa=ea(da+Ra);Ra=ea(Ba+ea((eb?ea(.0000999999974):ea(0.0))*Ba));Ba=(c[k>>2]=d,ea(g[k>>2]));da=(c[k>>2]=h,ea(g[k>>2]));ma=(c[k>>2]=M,ea(g[k>>2]));ab=(c[k>>2]=N,ea(g[k>>2]));eb=Qa<Ba;kb=Ta<da;ob=Sa<ma;mb=Ra<ab;O=(eb?b^O:0)^O;P=(kb?b^P:0)^P;Q=(ob?b^Q:0)^Q;R=(mb?b^R:0)^R;S=(eb?Ha^S:0)^S;T=(kb?Ha^T:0)^T;U=(ob?Ha^U:0)^U;V=(mb?Ha^V:0)^V;W=(eb?Ia^W:0)^W;X=(kb?Ia^X:0)^X;Y=(ob?Ia^Y:0)^Y;Z=(mb?Ia^Z:0)^Z;_=(eb?Ua^_:0)^_;$=(kb?Va^$:0)^$;aa=(ob?Wa^aa:0)^aa;ba=(mb?Xa^ba:0)^ba;d=(g[k>>2]=Ba<Qa?Ba:Qa,c[k>>2]|0);h=(g[k>>2]=da<Ta?da:Ta,c[k>>2]|0);M=(g[k>>2]=ma<Sa?ma:Sa,c[k>>2]|0);ca=ca+80|0;if((ca|0)==(a|0))break;else N=(g[k>>2]=ab<Ra?ab:Ra,c[k>>2]|0)}L=(c[k>>2]=_,ea(g[k>>2]));K=(c[k>>2]=$,ea(g[k>>2]));J=(c[k>>2]=aa,ea(g[k>>2]));I=(c[k>>2]=ba,ea(g[k>>2]));H=(c[k>>2]=O,ea(g[k>>2]));G=(c[k>>2]=P,ea(g[k>>2]));F=(c[k>>2]=Q,ea(g[k>>2]));E=(c[k>>2]=R,ea(g[k>>2]));D=(c[k>>2]=S,ea(g[k>>2]));C=(c[k>>2]=T,ea(g[k>>2]));B=(c[k>>2]=U,ea(g[k>>2]));A=(c[k>>2]=V,ea(g[k>>2]));Ra=(c[k>>2]=W,ea(g[k>>2]));ab=(c[k>>2]=X,ea(g[k>>2]));Sa=(c[k>>2]=Y,ea(g[k>>2]));j=E;l=F;m=G;n=H;o=A;p=B;q=C;r=D;s=(c[k>>2]=Z,ea(g[k>>2]));t=Sa;u=ab;v=Ra;w=I;x=J;y=K;z=L}Z=z<ea(0.0);Y=y<ea(0.0);X=x<ea(0.0);W=w<ea(0.0);if(!(Z|Y|X|W)){i=f;return}L=Z?z:ea(0.0);z=ea(n*L);n=Y?y:ea(0.0);y=ea(m*n);m=X?x:ea(0.0);x=ea(l*m);l=W?w:ea(0.0);w=ea(j*l);j=ea(ea(g[e>>2])-z);V=e+4|0;z=ea(ea(g[V>>2])-y);U=e+8|0;y=ea(ea(g[U>>2])-x);T=e+12|0;x=ea(ea(g[T>>2])-w);w=ea(j);j=ea(z);z=ea(y);y=ea(x);g[e>>2]=w;g[V>>2]=j;g[U>>2]=z;g[T>>2]=y;T=e+16|0;y=ea(r*L);r=ea(q*n);q=ea(p*m);p=ea(o*l);o=ea(ea(g[T>>2])-y);U=e+20|0;y=ea(ea(g[U>>2])-r);V=e+24|0;r=ea(ea(g[V>>2])-q);S=e+28|0;q=ea(ea(g[S>>2])-p);p=ea(o);o=ea(y);y=ea(r);r=ea(q);g[T>>2]=p;g[U>>2]=o;g[V>>2]=y;g[S>>2]=r;S=e+32|0;r=ea(v*L);L=ea(u*n);n=ea(t*m);m=ea(s*l);l=ea(ea(g[S>>2])-r);V=e+36|0;r=ea(ea(g[V>>2])-L);U=e+40|0;L=ea(ea(g[U>>2])-n);T=e+44|0;n=ea(ea(g[T>>2])-m);m=ea(l);l=ea(r);r=ea(L);L=ea(n);g[S>>2]=m;g[V>>2]=l;g[U>>2]=r;g[T>>2]=L;T=e+96|0;L=ea(g[T>>2]);r=ea((Z?ea(1.0):ea(0.0))+L);Z=e+100|0;L=ea(g[Z>>2]);l=ea((Y?ea(1.0):ea(0.0))+L);Y=e+104|0;L=ea(g[Y>>2]);m=ea((X?ea(1.0):ea(0.0))+L);X=e+108|0;L=ea(g[X>>2]);n=ea((W?ea(1.0):ea(0.0))+L);L=ea(r);r=ea(l);l=ea(m);m=ea(n);g[T>>2]=L;g[Z>>2]=r;g[Y>>2]=l;g[X>>2]=m;i=f;return}function ena(a,d,e,f,h,j,k,l,m,n){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=0;o=i;i=i+64|0;p=o+8|0;q=o+48|0;r=o+24|0;s=o+50|0;t=o+52|0;u=o+44|0;v=o+32|0;w=o+12|0;x=o;y=o+28|0;b[a+8>>1]=0;c[a>>2]=479896;c[a+4>>2]=479948;z=a+12|0;c[z>>2]=d;d=a+16|0;c[d>>2]=e;e=a+20|0;A=a+24|0;B=a+32|0;C=a+36|0;D=a+40|0;E=a+44|0;F=a+48|0;G=a+52|0;H=a+56|0;I=a+60|0;J=a+64|0;K=a+68|0;L=a+72|0;M=a+76|0;N=a+80|0;O=e+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));g[N>>2]=ea(1.0);c[a+84>>2]=n;n=c[f>>2]|0;E_a(e,(c[f+4>>2]|0)-n>>2);f=c[e>>2]|0;e=c[A>>2]|0;A=f+(e<<2)|0;if((e|0)>0){e=f;f=n;while(1){if(e)c[e>>2]=c[f>>2];e=e+4|0;if(e>>>0>=A>>>0)break;else f=f+4|0}}f=c[h+4>>2]|0;A=c[h>>2]|0;h=(f-A>>2)+1|0;e=c[D>>2]|0;if((e&2147483647)>>>0<h>>>0){L_a(B,h);Q=c[D>>2]|0}else Q=e;c[p>>2]=0;e=c[C>>2]|0;if((Q&2147483647)>>>0>e>>>0){Q=(c[B>>2]|0)+(e<<2)|0;if(!Q)R=e;else{c[Q>>2]=0;R=c[C>>2]|0}c[C>>2]=R+1}else M_a(B,p)|0;p=c[j>>2]|0;c[a+88>>2]=(c[j+4>>2]|0)-p>>2;j=c[k>>2]|0;if((A|0)!=(f|0)){k=j;R=p;Q=A;while(1){A=k;e=R;h=c[Q>>2]|0;n=p+(h<<2)|0;N=j+(h<<1<<2)|0;O=(n-e|0)>>>2;if((R|0)==(n|0))S=R;else{P=(p+(h+-1<<2)+(0-e)|0)>>>2;e=R;do{T=c[F>>2]|0;if((c[G>>2]&2147483647)>>>0>T>>>0){U=(c[E>>2]|0)+(T<<2)|0;if(U)g[U>>2]=ea(g[e>>2]);c[F>>2]=T+1}else N_a(E,e)|0;e=e+4|0}while((e|0)!=(n|0));S=R+(P+1<<2)|0}if((k|0)==(N|0))V=k;else{n=(j+((h<<1)+-1<<2)+(0-A)|0)>>>2;e=k;do{T=c[e>>2]&65535;b[q>>1]=T;U=c[I>>2]|0;if((c[J>>2]&2147483647)>>>0>U>>>0){W=(c[H>>2]|0)+(U<<1)|0;if(W)b[W>>1]=T;c[I>>2]=U+1}else O_a(H,q)|0;e=e+4|0}while((e|0)!=(N|0));V=k+(n+1<<2)|0}N=O&3;if(N){e=N;do{g[r>>2]=ea(-3402823469999999843913219.0e14);N=c[F>>2]|0;if((c[G>>2]&2147483647)>>>0>N>>>0){A=(c[E>>2]|0)+(N<<2)|0;if(A)g[A>>2]=ea(-3402823469999999843913219.0e14);c[F>>2]=N+1}else N_a(E,r)|0;N=e+65535+(c[d>>2]|0)&65535;b[s>>1]=N;A=c[J>>2]|0;h=c[I>>2]|0;if((A&2147483647)>>>0>h>>>0){P=(c[H>>2]|0)+(h<<1)|0;if(P)b[P>>1]=N;P=h+1|0;c[I>>2]=P;X=A;Y=P}else{O_a(H,s)|0;X=c[J>>2]|0;Y=c[I>>2]|0}b[t>>1]=N;if((X&2147483647)>>>0>Y>>>0){P=(c[H>>2]|0)+(Y<<1)|0;if(P)b[P>>1]=N;c[I>>2]=Y+1}else O_a(H,t)|0;e=e+1&3}while((e|0)!=0)}e=c[F>>2]|0;c[u>>2]=e;O=c[C>>2]|0;if((c[D>>2]&2147483647)>>>0>O>>>0){n=(c[B>>2]|0)+(O<<2)|0;if(!n)Z=O;else{c[n>>2]=e;Z=c[C>>2]|0}c[C>>2]=Z+1}else M_a(B,u)|0;Q=Q+4|0;if((Q|0)==(f|0))break;else{k=V;R=S}}}S=c[E>>2]|0;R=c[F>>2]|0;V=v+4|0;if((R|0)>=0){k=R<<2;R=k>>2;c[V>>2]=R;c[v+8>>2]=R;if((R|0)!=0?(R=UJa(v,k+19|0,537640,558)|0,(R|0)!=0):0){k=R+19&-16;c[k+-4>>2]=k-R;_=k}else _=0}else{c[V>>2]=0;c[v+8>>2]=0;_=0}c[v>>2]=_;k=c[V>>2]|0;R=_+(k<<2)|0;if((k|0)>0){f=_;Q=S;while(1){if(f)g[f>>2]=ea(g[Q>>2]);f=f+4|0;if(f>>>0>=R>>>0)break;else Q=Q+4|0}}Q=c[E>>2]|0;c[v>>2]=Q;c[E>>2]=_;c[V>>2]=c[F>>2];c[F>>2]=k;k=v+8|0;F=c[k>>2]|0;V=c[G>>2]|0;c[k>>2]=V;c[G>>2]=F;if(!((V|0)<0|(V&2147483647|0)==0|(Q|0)==0))VJa(v,Q+(0-(c[Q+-4>>2]|0))|0);Q=c[H>>2]|0;v=c[I>>2]|0;V=w+4|0;if((v|0)>=0){F=v<<1;v=F>>1;c[V>>2]=v;G=w+8|0;c[G>>2]=v;if(v){v=UJa(w,F,537640,558)|0;F=c[V>>2]|0;c[w>>2]=v;k=v+(F<<1)|0;if((F|0)>0){_=v;E=Q;while(1){if(_)b[_>>1]=b[E>>1]|0;_=_+2|0;if(_>>>0>=k>>>0){$=G;aa=v;ba=F;break}else E=E+2|0}}else{$=G;aa=v;ba=F}}else ca=68}else{c[V>>2]=0;c[w+8>>2]=0;ca=68}if((ca|0)==68){c[w>>2]=0;$=w+8|0;aa=0;ba=0}ca=c[H>>2]|0;c[w>>2]=ca;c[H>>2]=aa;c[V>>2]=c[I>>2];c[I>>2]=ba;ba=c[$>>2]|0;I=c[J>>2]|0;c[$>>2]=I;c[J>>2]=ba;if((I&2147483647|0)!=0&(I|0)>-1)VJa(w,ca);ca=c[l+4>>2]|0;w=c[l>>2]|0;I=(ca-w>>2)+2|0;if((c[M>>2]&2147483647)>>>0<I>>>0)P_a(K,I);if(w>>>0<ca>>>0){I=x+4|0;ba=w;w=c[m>>2]|0;do{da=ea(g[w>>2]);b[x>>1]=c[ba>>2];g[I>>2]=da;J=c[L>>2]|0;if((c[M>>2]&2147483647)>>>0>J>>>0){$=(c[K>>2]|0)+(J<<3)|0;if(!$)fa=J;else{J=x;V=c[J+4>>2]|0;aa=$;c[aa>>2]=c[J>>2];c[aa+4>>2]=V;fa=c[L>>2]|0}c[L>>2]=fa+1}else Q_a(K,x)|0;ba=ba+4|0;w=w+4|0}while(ba>>>0<ca>>>0);c[m>>2]=w;c[l>>2]=ba}ba=c[z>>2]|0;z=ba+12|0;c[y>>2]=a;l=ba+16|0;w=c[l>>2]|0;if((c[ba+20>>2]&2147483647)>>>0<=w>>>0){R_a(z,y)|0;i=o;return}y=(c[z>>2]|0)+(w<<2)|0;if(y)c[y>>2]=a;c[l>>2]=w+1;i=o;return}function fna(a){a=a|0;var b=0;b=i;hna(a);i=b;return}function gna(a){a=a|0;var b=0;b=i;hna(a+-4|0);i=b;return}function hna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;c[a>>2]=479896;d=a+4|0;c[d>>2]=479948;e=c[a+12>>2]|0;f=e+16|0;g=c[f>>2]|0;h=c[e+12>>2]|0;a:do if(!g)j=0;else{e=0;while(1){k=e+1|0;if((c[h+(e<<2)>>2]|0)==(a|0)){j=e;break a}if(k>>>0<g>>>0)e=k;else{j=k;break}}}while(0);e=g+-1|0;c[f>>2]=e;c[h+(j<<2>>2<<2)>>2]=c[h+(e<<2)>>2];e=a+68|0;h=c[a+76>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1)VJa(e,c[e>>2]|0);e=a+56|0;h=c[a+64>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1)VJa(e,c[e>>2]|0);e=a+44|0;h=c[a+52>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[e>>2]|0,(h|0)!=0):0)VJa(e,h+(0-(c[h+-4>>2]|0))|0);h=a+32|0;e=c[a+40>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1)VJa(h,c[h>>2]|0);h=a+20|0;e=c[a+28>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){c[d>>2]=480016;c[a>>2]=48e4;Sla(a);i=b;return}VJa(h,c[h>>2]|0);c[d>>2]=480016;c[a>>2]=48e4;Sla(a);i=b;return}function ina(a){a=a|0;var b=0;b=i;hna(a+-4|0);i=b;return}function jna(a){a=a|0;return (c[a+12>>2]|0)+4|0}function kna(a){a=a|0;return (c[a+8>>2]|0)+4|0}function lna(a){a=a|0;return c[a+24>>2]|0}function mna(a){a=a|0;return c[a+20>>2]|0}function nna(a){a=a|0;return c[a+88>>2]|0}function ona(a){a=a|0;return c[a+84>>2]|0}function pna(a){a=a|0;return (c[a+36>>2]|0)+-1|0}function qna(a){a=a|0;return (c[a+32>>2]|0)+-1|0}function rna(a){a=a|0;return c[a+88>>2]<<1|0}function sna(a){a=a|0;return c[a+84>>2]<<1|0}function tna(a){a=a|0;return c[a+16>>2]|0}function una(a){a=a|0;return c[a+12>>2]|0}function vna(a){a=a|0;return c[a+72>>2]|0}function wna(a){a=a|0;return c[a+68>>2]|0}function xna(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0;d=i;e=c[a+44>>2]|0;f=c[a+48>>2]|0;a=e+(f<<2)|0;if(!f){i=d;return}else h=e;do{g[h>>2]=ea(ea(g[h>>2])*b);h=h+4|0}while((h|0)!=(a|0));i=d;return}function yna(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0;d=i;e=c[a+40>>2]|0;f=c[a+44>>2]|0;a=e+(f<<2)|0;if(!f){i=d;return}else h=e;do{g[h>>2]=ea(ea(g[h>>2])*b);h=h+4|0}while((h|0)!=(a|0));i=d;return}function zna(a,b){a=a|0;b=ea(b);var c=0;c=a+80|0;g[c>>2]=ea(ea(g[c>>2])*b);return}function Ana(a,b){a=a|0;b=ea(b);var c=0;c=a+76|0;g[c>>2]=ea(ea(g[c>>2])*b);return}function Bna(a){a=a|0;c[a+8>>2]=0;c[a>>2]=480072;c[a+4>>2]=480152;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function Cna(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=480072;c[a+4>>2]=480152;d=a+12|0;e=c[a+20>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1)VJa(d,c[d>>2]|0);c[a>>2]=48e4;Sla(a);i=b;return}function Dna(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+-4|0;c[d>>2]=480072;c[d+4>>2]=480152;a=d+12|0;e=c[d+20>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1)VJa(a,c[a>>2]|0);c[d>>2]=48e4;Sla(d);i=b;return}function Ena(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=480072;c[a+4>>2]=480152;d=a+12|0;e=c[a+20>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1)VJa(d,c[d>>2]|0);c[a>>2]=48e4;Sla(a);i=b;return}function Fna(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+-4|0;c[d>>2]=480072;c[d+4>>2]=480152;a=d+12|0;e=c[d+20>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1)VJa(a,c[a>>2]|0);c[d>>2]=48e4;Sla(d);i=b;return}function Gna(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+96|0;l=k+88|0;m=k+48|0;n=k+56|0;o=k+64|0;p=k+72|0;q=k+80|0;r=k+40|0;s=k+32|0;t=k;u=k+8|0;v=k+16|0;w=k+24|0;x=Rla(96)|0;y=d;d=c[y+4>>2]|0;z=r;c[z>>2]=c[y>>2];c[z+4>>2]=d;d=e;e=c[d+4>>2]|0;z=s;c[z>>2]=c[d>>2];c[z+4>>2]=e;e=f;f=c[e+4>>2]|0;z=t;c[z>>2]=c[e>>2];c[z+4>>2]=f;f=g;g=c[f+4>>2]|0;z=u;c[z>>2]=c[f>>2];c[z+4>>2]=g;g=h;h=c[g+4>>2]|0;z=v;c[z>>2]=c[g>>2];c[z+4>>2]=h;h=j;j=c[h+4>>2]|0;z=w;c[z>>2]=c[h>>2];c[z+4>>2]=j;j=Tla()|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[p+0>>2]=c[s+0>>2];c[p+4>>2]=c[s+4>>2];c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[m+0>>2]=c[v+0>>2];c[m+4>>2]=c[v+4>>2];c[l+0>>2]=c[w+0>>2];c[l+4>>2]=c[w+4>>2];ena(x,a,b,q,p,o,n,m,l,j);if(!x){A=0;i=k;return A|0}A=x+4|0;i=k;return A|0}function Hna(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+96|0;l=k+88|0;m=k+48|0;n=k+56|0;o=k+64|0;p=k+72|0;q=k+80|0;r=k+40|0;s=k+32|0;t=k;u=k+8|0;v=k+16|0;w=k+24|0;x=d;d=c[x>>2]|0;y=c[x+4>>2]|0;x=e;e=c[x>>2]|0;z=c[x+4>>2]|0;x=f;f=c[x>>2]|0;A=c[x+4>>2]|0;x=g;g=c[x>>2]|0;B=c[x+4>>2]|0;x=h;h=c[x>>2]|0;C=c[x+4>>2]|0;x=j;j=c[x>>2]|0;D=c[x+4>>2]|0;x=Rla(96)|0;E=r;c[E>>2]=d;c[E+4>>2]=y;y=s;c[y>>2]=e;c[y+4>>2]=z;z=t;c[z>>2]=f;c[z+4>>2]=A;A=u;c[A>>2]=g;c[A+4>>2]=B;B=v;c[B>>2]=h;c[B+4>>2]=C;C=w;c[C>>2]=j;c[C+4>>2]=D;D=Tla()|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[p+0>>2]=c[s+0>>2];c[p+4>>2]=c[s+4>>2];c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[m+0>>2]=c[v+0>>2];c[m+4>>2]=c[v+4>>2];c[l+0>>2]=c[w+0>>2];c[l+4>>2]=c[w+4>>2];ena(x,a+-4|0,b,q,p,o,n,m,l,D);if(!x){F=0;i=k;return F|0}F=x+4|0;i=k;return F|0}function Ina(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e;h=Rla(560)|0;j=b;b=c[j>>2]|0;k=c[j+4>>2]|0;j=h+4|0;c[h>>2]=480232;c[j>>2]=480648;l=g;c[l>>2]=b;c[l+4>>2]=k;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Xla(h+16|0,a+4+-4|0,d+-4|0,f);i=e;return ((h|0)==0?0:j)|0}function Jna(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e;h=b;b=c[h>>2]|0;j=c[h+4>>2]|0;h=Rla(560)|0;k=h+4|0;c[h>>2]=480232;c[k>>2]=480648;l=g;c[l>>2]=b;c[l+4>>2]=j;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Xla(h+16|0,a+-4|0,d+-4|0,f);i=e;return ((h|0)==0?0:k)|0}function Kna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=i;d=Rla(116)|0;uoa(d,b,c);if(!d){e=0;i=a;return e|0}e=d+4|0;i=a;return e|0}function Lna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=i;d=Rla(116)|0;uoa(d,b,c);if(!d){e=0;i=a;return e|0}e=d+4|0;i=a;return e|0}function Mna(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!(c[(mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0)+4>>2]|0)){e=Rla(560)|0;f=e+4|0;c[e>>2]=480232;c[f>>2]=480648;Yla(e+16|0,a+4+-4|0,b+12|0);i=d;return ((e|0)==0?0:f)|0}else{f=_n[c[(c[b>>2]|0)+8>>2]&4095](b,a+4|0)|0;i=d;return f|0}return 0}function Nna(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+-4|0;if(!(c[(mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0)+4>>2]|0)){a=Rla(560)|0;f=a+4|0;c[a>>2]=480232;c[f>>2]=480648;Yla(a+16|0,e,b+12|0);i=d;return ((a|0)==0?0:f)|0}else{f=_n[c[(c[b>>2]|0)+8>>2]&4095](b,e+4|0)|0;i=d;return f|0}return 0}function Ona(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;YEi(d|0,b|0,c-b|0)|0;i=a;return}function Pna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;YEi(d|0,b|0,c-b|0)|0;i=a;return}function Qna(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[(c[a>>2]|0)+56>>2]&511](a,b,d,e);i=f;return}function Rna(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=a+-4|0;Dn[c[(c[g>>2]|0)+56>>2]&511](g,b,d,e);i=f;return}function Sna(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;f=i;Dn[c[(c[a>>2]|0)+56>>2]&511](a,b,d,e);i=f;return}function Tna(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;g=a+-4|0;Dn[c[(c[g>>2]|0)+56>>2]&511](g,b,d,e);i=f;return}function Una(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;f=i;Dn[c[(c[a>>2]|0)+56>>2]&511](a,b,d,e);i=f;return}function Vna(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;g=a+-4|0;Dn[c[(c[g>>2]|0)+56>>2]&511](g,b,d,e);i=f;return}function Wna(a,d,f,h,j,k,l,m){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im;a=i;n=d+-4|0;d=c[f>>2]|0;o=c[f+4>>2]|0;if(d>>>0<o>>>0){p=c[n+20>>2]|0;q=d;d=0;while(1){c[q>>2]=c[p+(d<<2)>>2];q=q+4|0;if(q>>>0>=o>>>0)break;else d=d+1|0}c[f>>2]=q}q=c[n+32>>2]|0;f=q+(c[n+36>>2]<<2)|0;d=c[n+44>>2]|0;o=c[h>>2]|0;p=c[j>>2]|0;r=c[k>>2]|0;s=o>>>0<(c[h+4>>2]|0)>>>0;h=n+16|0;t=p>>>0<(c[j+4>>2]|0)>>>0;j=r>>>0<(c[k+4>>2]|0)>>>0;k=r;r=c[n+56>>2]|0;u=0;v=p;p=d;w=o;o=q;a:while(1){q=k;x=r;y=u;z=v;A=p;B=o;while(1){B=B+4|0;if((B|0)==(f|0))break a;C=c[B>>2]|0;D=d+(C<<2)|0;if((A|0)==(D|0)){E=q;F=x;G=y;H=z;I=A}else{J=(d+(C+-1<<2)+(0-A)|0)>>>2;b:do if(t){if(j){C=q;K=x;L=y;M=z;N=A;while(1){O=b[K>>1]|0;P=b[K+2>>1]|0;if((((O&65535)<(P&65535)?P:O)&65535)>>>0<(c[h>>2]|0)>>>0){g[M>>2]=ea(g[N>>2]);c[C>>2]=O&65535;c[C+4>>2]=P&65535;Q=C+8|0;R=L+1|0;S=M+4|0}else{Q=C;R=L;S=M}N=N+4|0;if((N|0)==(D|0)){T=R;U=Q;V=S;break b}else{C=Q;K=K+4|0;L=R;M=S}}}M=c[h>>2]|0;L=x;K=y;C=z;N=A;while(1){P=b[L>>1]|0;O=b[L+2>>1]|0;if((((P&65535)<(O&65535)?O:P)&65535)>>>0<M>>>0){g[C>>2]=ea(g[N>>2]);W=K+1|0;X=C+4|0}else{W=K;X=C}N=N+4|0;if((N|0)==(D|0)){T=W;U=q;V=X;break}else{L=L+4|0;K=W;C=X}}}else{if(j){Y=q;Z=x;_=y;$=A}else{C=c[h>>2]|0;K=x;L=y;N=A;while(1){M=b[K>>1]|0;P=b[K+2>>1]|0;O=L+((((M&65535)<(P&65535)?P:M)&65535)>>>0<C>>>0&1)|0;N=N+4|0;if((N|0)==(D|0)){T=O;U=q;V=z;break b}else{K=K+4|0;L=O}}}while(1){L=b[Z>>1]|0;K=b[Z+2>>1]|0;if((((L&65535)<(K&65535)?K:L)&65535)>>>0<(c[h>>2]|0)>>>0){c[Y>>2]=L&65535;c[Y+4>>2]=K&65535;aa=Y+8|0;ba=_+1|0}else{aa=Y;ba=_}$=$+4|0;if(($|0)==(D|0)){T=ba;U=aa;V=z;break}else{Y=aa;Z=Z+4|0;_=ba}}}while(0);E=U;F=x+((J<<1)+2<<1)|0;G=T;H=V;I=A+(J+1<<2)|0}if(s)break;else{q=E;x=F;y=G;z=H;A=I}}c[w>>2]=G;k=E;r=F;u=G;v=H;p=I;w=w+4|0;o=B}o=c[l>>2]|0;w=c[l+4>>2]|0;if(o>>>0<w>>>0){I=c[n+68>>2]|0;p=o;o=0;while(1){c[p>>2]=e[I+(o<<3)>>1];p=p+4|0;if(p>>>0>=w>>>0)break;else o=o+1|0}c[l>>2]=p}p=c[m>>2]|0;l=c[m+4>>2]|0;if(p>>>0>=l>>>0){i=a;return}o=c[n+68>>2]|0;w=n+80|0;n=p;p=0;while(1){ca=ea(g[o+(p<<3)+4>>2]);g[n>>2]=ea(ca*ea(g[w>>2]));n=n+4|0;if(n>>>0>=l>>>0)break;else p=p+1|0}c[m>>2]=n;i=a;return}function Xna(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+48|0;k=a+40|0;l=a+32|0;m=a+24|0;n=a+16|0;o=a+8|0;p=a;c[p+0>>2]=c[d+0>>2];c[p+4>>2]=c[d+4>>2];c[o+0>>2]=c[e+0>>2];c[o+4>>2]=c[e+4>>2];c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[m+0>>2]=c[g+0>>2];c[m+4>>2]=c[g+4>>2];c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];Wna(0,b,p,o,n,m,l,k);i=a;return}function Yna(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;a=i;j=b+368|0;k=c[b+372>>2]|0;if((k|0)!=0?(l=c[d>>2]|0,l>>>0<(c[d+4>>2]|0)>>>0):0)YEi(l|0,c[j>>2]|0,k<<4|0)|0;k=b+356|0;j=c[b+360>>2]|0;if((j|0)!=0?(l=c[e>>2]|0,l>>>0<(c[e+4>>2]|0)>>>0):0)YEi(l|0,c[k>>2]|0,j<<3|0)|0;j=b+404|0;k=c[b+408>>2]|0;if((k|0)!=0?(l=c[f>>2]|0,l>>>0<(c[f+4>>2]|0)>>>0):0)YEi(l|0,c[j>>2]|0,k<<4|0)|0;k=b+392|0;j=c[b+396>>2]|0;if((j|0)!=0?(l=c[g>>2]|0,l>>>0<(c[g+4>>2]|0)>>>0):0)YEi(l|0,c[k>>2]|0,j<<2|0)|0;j=c[b+432>>2]|0;if(!j){i=a;return}k=c[h>>2]|0;if(k>>>0>=(c[h+4>>2]|0)>>>0){i=a;return}YEi(k|0,c[b+428>>2]|0,j*12|0)|0;i=a;return}function Zna(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;a=i;j=c[d>>2]|0;k=c[e>>2]|0;l=c[e+4>>2]|0;e=c[f>>2]|0;m=c[f+4>>2]|0;f=c[g>>2]|0;n=c[g+4>>2]|0;g=c[h>>2]|0;o=c[h+4>>2]|0;h=c[b+372>>2]|0;if((h|0)!=0?j>>>0<(c[d+4>>2]|0)>>>0:0)YEi(j|0,c[b+368>>2]|0,h<<4|0)|0;h=c[b+360>>2]|0;if((h|0)!=0&k>>>0<l>>>0)YEi(k|0,c[b+356>>2]|0,h<<3|0)|0;h=c[b+408>>2]|0;if((h|0)!=0&e>>>0<m>>>0)YEi(e|0,c[b+404>>2]|0,h<<4|0)|0;h=c[b+396>>2]|0;if((h|0)!=0&f>>>0<n>>>0)YEi(f|0,c[b+392>>2]|0,h<<2|0)|0;h=c[b+432>>2]|0;if(!((h|0)!=0&g>>>0<o>>>0)){i=a;return}YEi(g|0,c[b+428>>2]|0,h*12|0)|0;i=a;return}function _na(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=(c[b+300>>2]|0)==0?b+284|0:b+296|0;b=c[e+4>>2]|0;if(!b){i=a;return}YEi(c[d>>2]|0,c[e>>2]|0,b<<4|0)|0;i=a;return}function $na(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=(c[b+300>>2]|0)==0?b+284|0:b+296|0;b=c[e+4>>2]|0;if(!b){i=a;return}YEi(c[d>>2]|0,c[e>>2]|0,b<<4|0)|0;i=a;return}function aoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=(c[b+336>>2]|0)==0?b+320|0:b+332|0;b=c[e+4>>2]|0;if(!b){i=a;return}YEi(c[d>>2]|0,c[e>>2]|0,b<<4|0)|0;i=a;return}function boa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=(c[b+336>>2]|0)==0?b+320|0:b+332|0;b=c[e+4>>2]|0;if(!b){i=a;return}YEi(c[d>>2]|0,c[e>>2]|0,b<<4|0)|0;i=a;return}function coa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=c[b+348>>2]|0;if(!e){i=a;return}YEi(c[d>>2]|0,c[b+344>>2]|0,e<<4|0)|0;i=a;return}function doa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=c[b+348>>2]|0;if(!e){i=a;return}YEi(c[d>>2]|0,c[b+344>>2]|0,e<<4|0)|0;i=a;return}function eoa(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=0,q=0;a=i;h=mo[c[(c[b>>2]|0)+236>>2]&4095](b)|0;j=mo[c[(c[b>>2]|0)+240>>2]&4095](b)|0;k=c[f>>2]|0;if((((c[f+4>>2]|0)-k|0)/12|0|0)==(j|0)?(f=c[b+476>>2]|0,l=f+(j<<4)|0,(j|0)!=0):0){j=k;k=f;while(1){m=ea(g[k>>2]);n=ea(g[k+4>>2]);o=ea(g[k+8>>2]);g[j>>2]=m;g[j+4>>2]=n;g[j+8>>2]=o;k=k+16|0;if((k|0)==(l|0))break;else j=j+12|0}}j=c[d>>2]|0;if(((c[d+4>>2]|0)-j>>4|0)!=(h|0)){i=a;return}h=c[b+464>>2]|0;d=c[b+468>>2]|0;l=h+(d<<3)|0;k=c[b+24>>2]|0;if(!d){i=a;return}d=j;j=h;while(1){h=e[j>>1]|0;if(h>>>0<k>>>0){b=e[j+2>>1]|0;f=e[j+4>>1]|0;p=e[j+6>>1]|0;c[d>>2]=h;c[d+4>>2]=b;c[d+8>>2]=f;c[d+12>>2]=p;q=d+16|0}else q=d;j=j+8|0;if((j|0)==(l|0))break;else d=q}i=a;return}function foa(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0;a=i;h=c[d>>2]|0;j=c[d+4>>2]|0;d=c[f>>2]|0;k=c[f+4>>2]|0;f=mo[c[(c[b>>2]|0)+236>>2]&4095](b)|0;l=mo[c[(c[b>>2]|0)+240>>2]&4095](b)|0;if(((k-d|0)/12|0|0)==(l|0)?(k=c[b+476>>2]|0,m=k+(l<<4)|0,(l|0)!=0):0){l=d;d=k;while(1){n=ea(g[d>>2]);o=ea(g[d+4>>2]);p=ea(g[d+8>>2]);g[l>>2]=n;g[l+4>>2]=o;g[l+8>>2]=p;d=d+16|0;if((d|0)==(m|0))break;else l=l+12|0}}if((j-h>>4|0)!=(f|0)){i=a;return}f=c[b+464>>2]|0;j=c[b+468>>2]|0;l=f+(j<<3)|0;m=c[b+24>>2]|0;if(!j){i=a;return}j=h;h=f;while(1){f=e[h>>1]|0;if(f>>>0<m>>>0){b=e[h+2>>1]|0;d=e[h+4>>1]|0;k=e[h+6>>1]|0;c[j>>2]=f;c[j+4>>2]=b;c[j+8>>2]=d;c[j+12>>2]=k;q=j+16|0}else q=j;h=h+8|0;if((h|0)==(l|0))break;else j=q}i=a;return}function goa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+500>>2]|0;Dn[c[(c[a>>2]|0)+56>>2]&511](a,f,f+(c[b+504>>2]<<2)|0,c[d>>2]|0);i=e;return}function hoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+-4|0;a=c[b+500>>2]|0;Dn[c[(c[f>>2]|0)+56>>2]&511](f,a,a+(c[b+504>>2]<<2)|0,c[d>>2]|0);i=e;return}function ioa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+512>>2]|0;Dn[c[(c[a>>2]|0)+56>>2]&511](a,f,f+(c[b+516>>2]<<4)|0,c[d>>2]|0);i=e;return}function joa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+-4|0;a=c[b+512>>2]|0;Dn[c[(c[f>>2]|0)+56>>2]&511](f,a,a+(c[b+516>>2]<<4)|0,c[d>>2]|0);i=e;return}function koa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=Im,p=0,q=0;m=i;c[a+96>>2]=b;c[a+100>>2]=d;c[a+104>>2]=0;c[a+108>>2]=0;c[a+112>>2]=0;n=a+120|0;c[n>>2]=0;c[a+124>>2]=j;c[a+128>>2]=k;c[a+132>>2]=l;o=ea(e);g[a+32>>2]=o;g[a+36>>2]=o;g[a+40>>2]=o;c[a+44>>2]=0;o=ea(e*e);e=ea(o);g[a+48>>2]=e;g[a+52>>2]=e;g[a+56>>2]=e;c[a+60>>2]=0;e=ea(f);g[a+64>>2]=e;g[a+68>>2]=e;g[a+72>>2]=e;g[a+76>>2]=e;c[a+92>>2]=h;if(!d){i=m;return}else{p=0;q=0}do{p=(c[b+(q*76|0)+8>>2]|0)+p|0;c[n>>2]=p;q=q+1|0}while((q|0)!=(d|0));i=m;return}function loa(a){a=a|0;return}function moa(d){d=d|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=Im,ac=0,bc=0,cc=0,dc=Im,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=Im,cf=Im,df=Im,ef=Im,ff=Im,gf=Im,hf=Im,jf=Im,kf=Im,lf=Im,mf=Im,nf=Im,of=Im,pf=Im,qf=Im,rf=Im,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0;f=i;i=i+384|0;h=f;j=f+176|0;l=f+40|0;m=f+104|0;n=f+152|0;o=f+128|0;p=f+8|0;q=f+304|0;r=f+320|0;s=f+336|0;t=f+352|0;u=f+368|0;c[d+140>>2]=0;c[d+136>>2]=0;v=d+128|0;w=c[v>>2]|0;x=d+120|0;y=c[x>>2]|0;z=y<<1;if(!z){A=0;B=y;C=w}else{y=w+8|0;D=(c[y>>2]|0)+23&-16;E=D;F=E+-8|0;G=w+12|0;c[F>>2]=c[G>>2];c[E+-4>>2]=z&2147483646;c[G>>2]=F;c[y>>2]=E+z;A=D;B=c[x>>2]|0;C=c[v>>2]|0}x=d+104|0;c[x>>2]=A;A=B<<2;if(!A){H=0;I=C}else{B=C+8|0;D=(c[B>>2]|0)+23&-16;z=D;E=z+-8|0;y=C+12|0;c[E>>2]=c[y>>2];c[z+-4>>2]=A&2147483644;c[y>>2]=E;c[B>>2]=z+A;H=D;I=c[v>>2]|0}D=d+108|0;c[D>>2]=H;H=d+100|0;A=c[H>>2]<<2;if(!A)J=0;else{z=I+8|0;B=(c[z>>2]|0)+23&-16;E=B;y=E+-8|0;C=I+12|0;c[y>>2]=c[C>>2];c[E+-4>>2]=A&2147483644;c[C>>2]=y;c[z>>2]=E+A;J=B}B=d+116|0;c[B>>2]=J;A=d+92|0;if(!(c[A>>2]|0))K=J;else{J=d+96|0;E=d+32|0;z=d+36|0;y=d+40|0;C=d+44|0;I=d+124|0;F=h+4|0;G=d+112|0;w=l+4|0;L=l+8|0;M=l+12|0;N=l+48|0;O=l+52|0;P=l+56|0;Q=l+60|0;S=l+16|0;T=l+20|0;U=l+24|0;V=l+28|0;W=l+32|0;X=l+36|0;Y=l+40|0;Z=l+44|0;_=l+16|0;$=l+32|0;aa=l+48|0;ba=q+4|0;ca=q+8|0;da=q+12|0;fa=r+4|0;ga=r+8|0;ha=r+12|0;ia=s+4|0;ja=s+8|0;ka=s+12|0;la=u+4|0;ma=u+8|0;na=u+12|0;oa=t+4|0;pa=t+8|0;qa=t+12|0;ra=n+4|0;sa=n+8|0;ta=n+12|0;ua=n+16|0;va=n+20|0;wa=p+4|0;xa=p+8|0;ya=p+12|0;za=p+16|0;Aa=p+20|0;Ba=p+24|0;Ca=o+4|0;Da=o+8|0;Ea=o+12|0;Fa=o+16|0;Ga=o+20|0;Ha=l+4|0;Ia=l+8|0;Ja=l+12|0;Ka=l+16|0;La=l+20|0;Ma=m+4|0;Na=m+8|0;Oa=m+12|0;Pa=m+16|0;Qa=m+20|0;Ra=0;Sa=0;Ta=0;Ua=0;Va=1;while(1){Wa=c[J>>2]|0;Xa=c[H>>2]|0;Ya=c[E>>2]|0;Za=c[z>>2]|0;_a=c[y>>2]|0;$a=c[C>>2]|0;ab=c[x>>2]|0;bb=c[D>>2]|0;cb=c[B>>2]|0;db=c[I>>2]|0;eb=c[v>>2]|0;fb=(Xa*76|0)/76|0;gb=fb<<5;if(!gb){hb=0;ib=0;jb=0}else{kb=eb+8|0;lb=(c[kb>>2]|0)+23&-16;mb=lb;nb=mb+-8|0;ob=eb+12|0;c[nb>>2]=c[ob>>2];pb=gb&2147483616;c[mb+-4>>2]=pb;qb=mb+gb+23&-16;rb=qb+-8|0;c[rb>>2]=nb;c[qb+-4>>2]=pb;c[ob>>2]=rb;c[kb>>2]=qb+gb;hb=mb;ib=qb;jb=lb}lb=fb<<2;if(!lb)sb=0;else{qb=eb+8|0;mb=(c[qb>>2]|0)+23&-16;gb=mb+-8|0;kb=eb+12|0;c[gb>>2]=c[kb>>2];c[mb+-4>>2]=lb&2147483644;c[kb>>2]=gb;c[qb>>2]=mb+lb;sb=mb}mb=(Xa|0)==0;if(mb){tb=ea(-3402823469999999843913219.0e14);ub=ea(-3402823469999999843913219.0e14);vb=ea(-3402823469999999843913219.0e14);wb=ea(3402823469999999843913219.0e14);xb=ea(3402823469999999843913219.0e14);yb=ea(3402823469999999843913219.0e14)}else{zb=(c[k>>2]=Ya,ea(g[k>>2]));Ab=ea(3402823469999999843913219.0e14);Bb=ea(3402823469999999843913219.0e14);Cb=ea(3402823469999999843913219.0e14);Db=ea(-3402823469999999843913219.0e14);Eb=ea(-3402823469999999843913219.0e14);Fb=ea(-3402823469999999843913219.0e14);Xa=0;while(1){Gb=ea(zb+ea(g[Wa+(Xa*76|0)+56>>2]));Hb=ea(zb+ea(g[Wa+(Xa*76|0)+60>>2]));Ib=ea(zb+ea(g[Wa+(Xa*76|0)+64>>2]));Jb=ea(g[Wa+(Xa*76|0)+44>>2]);Kb=ea(Jb-Gb);Lb=ea(g[Wa+(Xa*76|0)+48>>2]);Mb=ea(Lb-Hb);Nb=ea(g[Wa+(Xa*76|0)+52>>2]);Ob=ea(Nb-Ib);Pb=ea(Gb+Jb);Jb=ea(Hb+Lb);Lb=ea(Ib+Nb);g[l>>2]=Kb;g[Ha>>2]=Mb;g[Ia>>2]=Ob;g[Ja>>2]=Pb;g[Ka>>2]=Jb;g[La>>2]=Lb;e_a(m,Wa+(Xa*76|0)+16|0,l);Lb=ea(g[m>>2]);Jb=ea(g[Ma>>2]);Pb=ea(g[Na>>2]);Ob=ea(Lb);Mb=ea(Jb);Kb=ea(Pb);Nb=ea(g[Oa>>2]);Ib=ea(g[Pa>>2]);Hb=ea(g[Qa>>2]);Gb=ea(Nb);Qb=ea(Ib);Rb=ea(Hb);c[sb+(Xa<<2)>>2]=Xa;g[jb+(Xa<<5)>>2]=Ob;g[jb+(Xa<<5)+4>>2]=Mb;g[jb+(Xa<<5)+8>>2]=Kb;c[jb+(Xa<<5)+12>>2]=0;g[jb+(Xa<<5)+16>>2]=Gb;g[jb+(Xa<<5)+20>>2]=Qb;g[jb+(Xa<<5)+24>>2]=Rb;c[jb+(Xa<<5)+28>>2]=0;Rb=Lb<Ab?Lb:Ab;Lb=Jb<Bb?Jb:Bb;Jb=Pb<Cb?Pb:Cb;Pb=Db<Nb?Nb:Db;Nb=Eb<Ib?Ib:Eb;Ib=Fb<Hb?Hb:Fb;Xa=Xa+1|0;if(Xa>>>0>=fb>>>0){tb=Ib;ub=Nb;vb=Pb;wb=Jb;xb=Lb;yb=Rb;break}else{Ab=Rb;Bb=Lb;Cb=Jb;Db=Pb;Eb=Nb;Fb=Ib}}}Fb=ea(vb-yb);Eb=ea(ub-xb);Db=ea(tb-wb);if(Fb>Eb)Sb=Fb>Db?0:2;else Sb=Eb>Db?1:2;Xa=h;c[Xa>>2]=0;c[Xa+4>>2]=0;a[F>>0]=0;c[h>>2]=j;Xa=fb+-1|0;if((Xa|0)>0){lb=0;qb=32;gb=0;kb=0;rb=Xa;Xa=j;a:while(1){ob=rb;pb=kb;nb=gb;while(1){if((ob|0)>(pb|0)){if((ob-pb|0)>>>0<5)Tb=pb;else break;do{Ub=Tb;Tb=Tb+1|0;Vb=Tb;Wb=Ub;while(1){Db=ea(g[jb+(c[sb+(Vb<<2)>>2]<<5)+(Sb<<2)>>2]);Xb=Db<ea(g[jb+(c[sb+(Wb<<2)>>2]<<5)+(Sb<<2)>>2]);Wb=Xb?Vb:Wb;if((Vb|0)>=(ob|0))break;else Vb=Vb+1|0}Vb=sb+(Wb<<2)|0;Xb=sb+(Ub<<2)|0;Yb=c[Vb>>2]|0;c[Vb>>2]=c[Xb>>2];c[Xb>>2]=Yb}while((Tb|0)!=(ob|0))}if(!nb)break a;Yb=nb+-2|0;ob=c[Xa+(nb+-1<<2)>>2]|0;pb=c[Xa+(Yb<<2)>>2]|0;nb=Yb}Yb=sb+(((ob+pb|0)/2|0)<<2)|0;Xb=c[Yb>>2]|0;Vb=sb+(pb<<2)|0;Zb=c[Vb>>2]|0;Db=ea(g[jb+(Xb<<5)+(Sb<<2)>>2]);Eb=ea(g[jb+(Zb<<5)+(Sb<<2)>>2]);if(Db<Eb){c[Vb>>2]=Xb;c[Yb>>2]=Zb;_b=c[Vb>>2]|0;$b=ea(g[jb+(_b<<5)+(Sb<<2)>>2]);ac=Zb;bc=_b}else{$b=Eb;ac=Xb;bc=Zb}Zb=sb+(ob<<2)|0;Xb=c[Zb>>2]|0;Eb=ea(g[jb+(Xb<<5)+(Sb<<2)>>2]);if(Eb<$b){c[Vb>>2]=Xb;c[Zb>>2]=bc;cc=c[Yb>>2]|0;dc=$b;ec=bc}else{cc=ac;dc=Eb;ec=Xb}if(dc<ea(g[jb+(cc<<5)+(Sb<<2)>>2])){c[Yb>>2]=ec;c[Zb>>2]=cc;fc=c[Yb>>2]|0}else fc=cc;Zb=ob+-1|0;Xb=sb+(Zb<<2)|0;c[Yb>>2]=c[Xb>>2];c[Xb>>2]=fc;Yb=fc;Vb=pb;_b=Zb;while(1){Eb=ea(g[jb+(Yb<<5)+(Sb<<2)>>2]);gc=Vb;while(1){hc=gc+1|0;ic=sb+(hc<<2)|0;jc=c[ic>>2]|0;if(ea(g[jb+(jc<<5)+(Sb<<2)>>2])<Eb)gc=hc;else{kc=_b;break}}do{kc=kc+-1|0;lc=sb+(kc<<2)|0;mc=c[lc>>2]|0}while(Eb<ea(g[jb+(mc<<5)+(Sb<<2)>>2]));if((hc|0)>=(kc|0))break;c[ic>>2]=mc;c[lc>>2]=jc;Yb=c[Xb>>2]|0;Vb=hc;_b=kc}c[ic>>2]=Yb;c[Xb>>2]=jc;if((hc-pb|0)<(ob-hc|0)){do if(nb>>>0<(qb+-1|0)>>>0){nc=lb;oc=qb;pc=Xa}else{_b=qb<<1;Vb=qb<<3;if(!Vb)qc=0;else{Zb=mKa()|0;rc=c[(c[Zb>>2]|0)+8>>2]|0;sc=pKa()|0;tc=mo[c[(c[sc>>2]|0)+24>>2]&4095](sc)|0;qc=Bn[rc&255](Zb,Vb,tc?541832:544544,523928,148)|0}YEi(qc|0,Xa|0,nb<<2|0)|0;if(lb<<24>>24==0|(Xa|0)==0){nc=1;oc=_b;pc=qc;break}tc=mKa()|0;In[c[(c[tc>>2]|0)+12>>2]&4095](tc,Xa);nc=1;oc=_b;pc=qc}while(0);c[pc+(nb<<2)>>2]=pb;c[pc+(nb+1<<2)>>2]=gc;uc=nc;vc=oc;wc=gc+2|0;xc=ob;yc=pc}else{Xb=gc+2|0;do if(nb>>>0<(qb+-1|0)>>>0){zc=lb;Ac=qb;Bc=Xa}else{Yb=qb<<1;_b=qb<<3;if(!_b)Cc=0;else{tc=mKa()|0;Vb=c[(c[tc>>2]|0)+8>>2]|0;Zb=pKa()|0;rc=mo[c[(c[Zb>>2]|0)+24>>2]&4095](Zb)|0;Cc=Bn[Vb&255](tc,_b,rc?541832:544544,523928,148)|0}YEi(Cc|0,Xa|0,nb<<2|0)|0;if(lb<<24>>24==0|(Xa|0)==0){zc=1;Ac=Yb;Bc=Cc;break}rc=mKa()|0;In[c[(c[rc>>2]|0)+12>>2]&4095](rc,Xa);zc=1;Ac=Yb;Bc=Cc}while(0);c[Bc+(nb<<2)>>2]=Xb;c[Bc+(nb+1<<2)>>2]=ob;uc=zc;vc=Ac;wc=pb;xc=gc;yc=Bc}lb=uc;qb=vc;gb=nb+2|0;kb=wc;rb=xc;Xa=yc}if(!(lb<<24>>24==0|(Xa|0)==0)){rb=mKa()|0;In[c[(c[rb>>2]|0)+12>>2]&4095](rb,Xa)}}if(a[F>>0]|0)tKa(h,c[h>>2]|0);if(mb){Dc=0;Ec=-8388609;Fc=2139095039;Gc=-8388609;Hc=2139095039;Ic=-8388609;Jc=2139095039;Kc=-8388609;Lc=2139095039}else{Eb=(c[k>>2]=Ya,ea(g[k>>2]));Db=(c[k>>2]=Za,ea(g[k>>2]));Fb=(c[k>>2]=_a,ea(g[k>>2]));Cb=(c[k>>2]=$a,ea(g[k>>2]));rb=-8388609;kb=-8388609;gb=-8388609;qb=-8388609;Yb=2139095039;rc=2139095039;_b=2139095039;tc=2139095039;Vb=0;Zb=0;while(1){sc=sb+(Vb<<2)|0;Mc=c[sc>>2]|0;Nc=Wa+(Mc*76|0)+44|0;Bb=ea(g[Nc>>2]);Ab=ea(g[Nc+4>>2]);zb=ea(g[Nc+8>>2]);Ib=ea(g[Nc+12>>2]);Nc=Wa+(Mc*76|0)+56|0;Nb=ea(g[Nc+4>>2]);Pb=ea(g[Nc+8>>2]);Jb=ea(Eb+Ib);Lb=ea(Db+Nb);Nb=ea(Fb+Pb);Pb=ea(Cb+ea(g[Nc+12>>2]));Rb=ea(Bb-Jb);Hb=ea(Ab-Lb);Qb=ea(zb-Nb);Gb=ea(Ib-Pb);Kb=ea(Bb+Jb);Jb=ea(Ab+Lb);Lb=ea(zb+Nb);Nb=ea(Ib+Pb);Pb=ea(g[Wa+(Mc*76|0)+16>>2]);Ib=ea(g[Wa+(Mc*76|0)+20>>2]);zb=ea(g[Wa+(Mc*76|0)+24>>2]);Ab=ea(g[Wa+(Mc*76|0)+28>>2]);Bb=ea(Pb+Pb);Mb=ea(Ib+Ib);Ob=ea(zb+zb);Oc=ea(Ib*Mb);Pc=ea(zb*Ob);Qc=ea(Bb*Ib);Rc=ea(Bb*zb);Sc=ea(Bb*Ab);Tc=ea(Mb*zb);Uc=ea(Mb*Ab);Mb=ea(Ob*Ab);Ob=ea(ea(ea(1.0)-Oc)-Pc);Vc=ea(Qc+Mb);Wc=ea(Rc-Uc);Xc=ea(Qc-Mb);Mb=ea(ea(1.0)-ea(Pb*Bb));Bb=ea(Mb-Pc);Pc=ea(Tc+Sc);Qc=ea(Rc+Uc);Uc=ea(Tc-Sc);Sc=ea(Mb-Oc);Oc=ea(g[Wa+(Mc*76|0)+32>>2]);Mb=ea(g[Wa+(Mc*76|0)+36>>2]);Tc=ea(g[Wa+(Mc*76|0)+40>>2]);Rc=ea(Oc*ea(-2.0));Yc=ea(Mb*ea(-2.0));Zc=ea(Tc*ea(-2.0));_c=ea(ea(Ab*Ab)+ea(-.5));$c=ea(ea(ea(Pb*Rc)+ea(Ib*Yc))+ea(zb*Zc));ad=ea(ea(Pb*$c)+ea(ea(Rc*_c)-ea(Ab*ea(ea(Ib*Zc)-ea(zb*Yc)))));bd=ea(ea(Ib*$c)+ea(ea(_c*Yc)-ea(Ab*ea(ea(zb*Rc)-ea(Pb*Zc)))));cd=ea(ea(ea(_c*Zc)-ea(Ab*ea(ea(Pb*Yc)-ea(Ib*Rc))))+ea(zb*$c));$c=ea(-Pb);Pb=ea(-Ib);Ib=ea(-zb);zb=ea(g[jb+(Mc<<5)+(Sb<<2)>>2]);Rc=ea(g[jb+(Mc<<5)+(Sb<<2)+16>>2]);b:do if(!Vb)dd=0;else{Nc=Vb;while(1){if(!(ea(g[jb+(c[sb+(Nc<<2)>>2]<<5)+(Sb<<2)+16>>2])>zb)){dd=Nc;break b}Nc=Nc+-1|0;if(!Nc){dd=0;break}}}while(0);c:do if(dd>>>0<fb>>>0){nb=Wa+(Mc*76|0)+72|0;pb=Gb<ea(0.0);ob=pb?0:(g[k>>2]=Gb,c[k>>2]|0);pb=Nb>ea(0.0);Xb=pb?0:(g[k>>2]=Nb,c[k>>2]|0);pb=dd;Nc=0;ed=0;while(1){do if((Vb|0)==(pb|0)){fd=Nc;gd=ed}else{hd=sb+(pb<<2)|0;id=c[hd>>2]|0;if(ea(g[jb+(id<<5)+(Sb<<2)>>2])>Rc){jd=Nc;kd=ed;break c}if(!(_n[db&4095](c[nb>>2]|0,c[Wa+(id*76|0)+72>>2]|0)|0)){fd=Nc;gd=ed;break}ld=1<<c[hd>>2]|ed;zb=ea(Eb+ea(g[Wa+(id*76|0)+56>>2]));Yc=ea(Eb+ea(g[Wa+(id*76|0)+60>>2]));Zc=ea(Eb+ea(g[Wa+(id*76|0)+64>>2]));md=ea(g[Wa+(id*76|0)+44>>2]);nd=ea(md-zb);od=ea(g[Wa+(id*76|0)+48>>2]);pd=ea(od-Yc);qd=ea(g[Wa+(id*76|0)+52>>2]);rd=ea(qd-Zc);sd=ea(zb+md);md=ea(Yc+od);od=ea(Zc+qd);g[n>>2]=nd;g[ra>>2]=pd;g[sa>>2]=rd;g[ta>>2]=sd;g[ua>>2]=md;g[va>>2]=od;od=ea(ea(g[Wa+(id*76|0)+32>>2])*ea(2.0));md=ea(ea(g[Wa+(id*76|0)+36>>2])*ea(2.0));sd=ea(ea(g[Wa+(id*76|0)+40>>2])*ea(2.0));rd=ea(ea(ea(od*$c)+ea(md*Pb))+ea(sd*Ib));pd=ea(ad+ea(ea(rd*$c)+ea(ea(_c*od)+ea(Ab*ea(ea(sd*Pb)-ea(md*Ib))))));nd=ea(bd+ea(ea(rd*Pb)+ea(ea(_c*md)+ea(Ab*ea(ea(od*Ib)-ea(sd*$c))))));qd=ea(cd+ea(ea(ea(_c*sd)+ea(Ab*ea(ea(md*$c)-ea(od*Pb))))+ea(rd*Ib)));rd=ea(g[Wa+(id*76|0)+16>>2]);od=ea(Ab*rd);md=ea(g[Wa+(id*76|0)+28>>2]);sd=ea(od+ea(md*$c));od=ea(g[Wa+(id*76|0)+24>>2]);Zc=ea(sd+ea(od*Pb));sd=ea(g[Wa+(id*76|0)+20>>2]);Yc=ea(ea(ea(rd*Ib)+ea(ea(md*Pb)+ea(Ab*sd)))-ea(od*$c));zb=ea(ea(ea(sd*$c)+ea(ea(md*Ib)+ea(Ab*od)))-ea(rd*Pb));td=ea(ea(ea(ea(Ab*md)-ea(rd*$c))-ea(sd*Pb))-ea(od*Ib));g[p>>2]=ea(Zc-ea(sd*Ib));g[wa>>2]=Yc;g[xa>>2]=zb;g[ya>>2]=td;g[za>>2]=pd;g[Aa>>2]=nd;g[Ba>>2]=qd;e_a(o,p,n);qd=ea(g[o>>2]);nd=ea(g[Ca>>2]);pd=ea(g[Da>>2]);td=ea(g[Ea>>2]);zb=ea(g[Fa>>2]);Yc=ea(g[Ga>>2]);id=(g[k>>2]=Rb<qd?qd:Rb,c[k>>2]|0);hd=(g[k>>2]=Hb<nd?nd:Hb,c[k>>2]|0);ud=(g[k>>2]=Qb<pd?pd:Qb,c[k>>2]|0);vd=(g[k>>2]=td<Kb?td:Kb,c[k>>2]|0);wd=(g[k>>2]=zb<Jb?zb:Jb,c[k>>2]|0);xd=c[120264]|0;yd=c[120265]|0;zd=c[120266]|0;Ad=c[120267]|0;Bd=c[120268]|0;Cd=c[120269]|0;Dd=c[120270]|0;Ed=c[120271]|0;Fd=Bd&-8388609|xd&id;id=Cd&-8388609|yd&hd;hd=Dd&-8388609|zd&ud;ud=Ed&-8388609|Ad&ob;Gd=Bd&2139095039|xd&vd;vd=Cd&2139095039|yd&wd;wd=Dd&2139095039|zd&(g[k>>2]=Yc<Lb?Yc:Lb,c[k>>2]|0);zd=Ed&2139095039|Ad&Xb;Yc=(c[k>>2]=Fd,ea(g[k>>2]));if(Yc>(c[k>>2]=Gd,ea(g[k>>2]))){fd=Nc;gd=ld;break}Yc=(c[k>>2]=id,ea(g[k>>2]));if(Yc>(c[k>>2]=vd,ea(g[k>>2]))){fd=Nc;gd=ld;break}Yc=(c[k>>2]=hd,ea(g[k>>2]));if(Yc>(c[k>>2]=wd,ea(g[k>>2]))){fd=Nc;gd=ld;break}Yc=(c[k>>2]=ud,ea(g[k>>2]));if(Yc>(c[k>>2]=zd,ea(g[k>>2]))){fd=Nc;gd=ld;break}c[ib+(Nc<<5)>>2]=Fd;c[ib+(Nc<<5)+4>>2]=id;c[ib+(Nc<<5)+8>>2]=hd;c[ib+(Nc<<5)+12>>2]=ud;c[ib+(Nc<<5)+16>>2]=Gd;c[ib+(Nc<<5)+20>>2]=vd;c[ib+(Nc<<5)+24>>2]=wd;c[ib+(Nc<<5)+28>>2]=zd;fd=Nc+1|0;gd=ld}while(0);pb=pb+1|0;if(pb>>>0>=fb>>>0){jd=fd;kd=gd;break}else{Nc=fd;ed=gd}}}else{jd=0;kd=0}while(0);ed=c[sc>>2]|0;c[cb+(ed<<2)>>2]=kd;Nc=c[Wa+(Mc*76|0)>>2]|0;pb=c[Wa+(Mc*76|0)+4>>2]|0;Lb=ea(ea(1.0)/ea(g[Wa+(ed*76|0)+68>>2]));Xb=Wa+(Mc*76|0)+8|0;ob=c[Xb>>2]|0;if(!ob){Hd=rb;Id=kb;Jd=gb;Kd=qb;Ld=Yb;Md=rc;Nd=_b;Od=tc;Pd=Zb}else{nb=Wa+(Mc*76|0)+12|0;Ub=c[nb>>2]|0;Wb=(Ub|0)==0;ld=ib+(jd<<5)|0;zd=(ib|0)==(ld|0);wd=ed&65535;ed=rb;vd=kb;Gd=gb;ud=qb;hd=Yb;id=rc;Fd=_b;Ad=tc;Ed=ob;ob=0;Dd=Zb;while(1){do if(Wb){Qd=ob;Rd=ob;Sd=Nc+(ob<<4)|0}else{yd=c[Ub+(ob<<2)>>2]|0;Cd=c[nb>>2]|0;xd=Nc+(yd<<4)|0;if(!Cd){Qd=ob;Rd=yd;Sd=xd;break}Qd=c[Cd+(ob<<2)>>2]|0;Rd=yd;Sd=xd}while(0);xd=pb+(Qd<<4)|0;yd=c[Sd>>2]|0;Cd=Sd+4|0;Bd=c[Cd>>2]|0;Td=Sd+8|0;Ud=c[Td>>2]|0;Vd=Sd+12|0;Wd=c[Vd>>2]|0;d:do if(zd){Xd=ed;Yd=vd;Zd=Gd;_d=ud;$d=hd;ae=id;be=Fd;ce=Ad;de=Ed;ee=Dd}else{Jb=(c[k>>2]=yd,ea(g[k>>2]));Kb=(c[k>>2]=Bd,ea(g[k>>2]));Qb=(c[k>>2]=Ud,ea(g[k>>2]));Hb=(c[k>>2]=Wd,ea(g[k>>2]));fe=ib;e:while(1){do if(!(ea(g[fe>>2])>Jb)){if(ea(g[fe+4>>2])>Kb)break;if(ea(g[fe+8>>2])>Qb)break;if(ea(g[fe+12>>2])>Hb)break;if(Jb>ea(g[fe+16>>2]))break;if(Kb>ea(g[fe+20>>2]))break;if(Qb>ea(g[fe+24>>2]))break;if(!(Hb>ea(g[fe+28>>2])))break e}while(0);fe=fe+32|0;if((fe|0)==(ld|0)){Xd=ed;Yd=vd;Zd=Gd;_d=ud;$d=hd;ae=id;be=Fd;ce=Ad;de=Ed;ee=Dd;break d}}Rb=ea(ea(ea(Oc+ea(Ob*Jb))+ea(Xc*Kb))+ea(Qc*Qb));Ib=ea(ea(ea(Mb+ea(Vc*Jb))+ea(Bb*Kb))+ea(Uc*Qb));Pb=ea(ea(ea(Tc+ea(Wc*Jb))+ea(Pc*Kb))+ea(Sc*Qb));$c=ea(ea(ea(ea(Jb*ea(0.0))+ea(1.0))+ea(Kb*ea(0.0)))+ea(Qb*ea(0.0)));fe=(g[k>>2]=Rb,c[k>>2]|0);ge=(g[k>>2]=Ib,c[k>>2]|0);he=(g[k>>2]=Pb,c[k>>2]|0);ie=c[120265]&(ge^Bd)^Bd;ge=c[120266]&(he^Ud)^Ud;he=c[120267]&((g[k>>2]=$c,c[k>>2]|0)^Wd)^Wd;c[Sd>>2]=c[120264]&(fe^yd)^yd;c[Cd>>2]=ie;c[Td>>2]=ge;c[Vd>>2]=he;$c=ea(Jb-ea(g[xd>>2]));fe=pb+(Qd<<4)+4|0;Pb=ea(Kb-ea(g[fe>>2]));je=pb+(Qd<<4)+8|0;Ib=ea(Qb-ea(g[je>>2]));ke=pb+(Qd<<4)+12|0;Rb=ea(Lb*$c);$c=ea(Lb*Pb);Pb=ea(Lb*Ib);Ib=ea(Lb*ea(Hb-ea(g[ke>>2])));le=(g[k>>2]=Ib,c[k>>2]|0);Ib=ea(ea(ea(Ob*Rb)+ea(Xc*$c))+ea(Qc*Pb));Ab=ea(ea(ea(Vc*Rb)+ea(Bb*$c))+ea(Uc*Pb));_c=ea(ea(ea(Wc*Rb)+ea(Pc*$c))+ea(Sc*Pb));cd=ea(ea(ea(Rb*ea(0.0))+ea($c*ea(0.0)))+ea(Pb*ea(0.0)));me=(g[k>>2]=Ib,c[k>>2]|0);ne=(g[k>>2]=Ab,c[k>>2]|0);oe=(g[k>>2]=_c,c[k>>2]|0);pe=(g[k>>2]=cd,c[k>>2]|0);qe=(g[k>>2]=Rb,c[k>>2]|0);re=(g[k>>2]=$c,c[k>>2]|0);se=(g[k>>2]=Pb,c[k>>2]|0);te=(ne^re)&c[120265]^re;re=(oe^se)&c[120266]^se;se=(pe^le)&c[120267]^le;c[xd>>2]=(me^qe)&c[120264]^qe;c[fe>>2]=te;c[je>>2]=re;c[ke>>2]=se;se=Nc+(Rd+1<<4)|0;f:do if((Sd|0)==(se|0)){ue=ed;ve=vd;we=Gd;xe=ud;ye=hd;ze=id;Ae=Fd;Be=Ad}else{Pb=(c[k>>2]=he,ea(g[k>>2]));$c=(c[k>>2]=ge,ea(g[k>>2]));ke=Sd;re=ed;je=id;te=Fd;fe=Ad;qe=vd;me=Gd;le=ud;pe=hd;Rb=(c[k>>2]=ie,ea(g[k>>2]));cd=$c;$c=Pb;while(1){Pb=(c[k>>2]=fe,ea(g[k>>2]));_c=(c[k>>2]=te,ea(g[k>>2]));Ab=(c[k>>2]=je,ea(g[k>>2]));Ib=(c[k>>2]=pe,ea(g[k>>2]));bd=(c[k>>2]=le,ea(g[k>>2]));ad=(c[k>>2]=me,ea(g[k>>2]));Rc=(c[k>>2]=qe,ea(g[k>>2]));Nb=(c[k>>2]=re,ea(g[k>>2]));Gb=ea(g[ke>>2]);oe=(g[k>>2]=Gb<Pb?Gb:Pb,c[k>>2]|0);ne=(g[k>>2]=Rb<_c?Rb:_c,c[k>>2]|0);Ce=(g[k>>2]=cd<Ab?cd:Ab,c[k>>2]|0);De=(g[k>>2]=$c<Ib?$c:Ib,c[k>>2]|0);Ee=(g[k>>2]=bd<Gb?Gb:bd,c[k>>2]|0);Fe=(g[k>>2]=ad<Rb?Rb:ad,c[k>>2]|0);Ge=(g[k>>2]=Rc<cd?cd:Rc,c[k>>2]|0);He=(g[k>>2]=Nb<$c?$c:Nb,c[k>>2]|0);Ie=ke+16|0;if((Ie|0)==(se|0)){ue=He;ve=Ge;we=Fe;xe=Ee;ye=De;ze=Ce;Ae=ne;Be=oe;break f}Nb=ea(g[ke+20>>2]);Rc=ea(g[ke+24>>2]);ad=ea(g[ke+28>>2]);ke=Ie;re=He;je=Ce;te=ne;fe=oe;qe=Ge;me=Fe;le=Ee;pe=De;Rb=Nb;cd=Rc;$c=ad}}while(0);b[ab+(Dd<<1)>>1]=wd;c[bb+(Dd<<2)>>2]=Rd<<4>>4;Xd=ue;Yd=ve;Zd=we;_d=xe;$d=ye;ae=ze;be=Ae;ce=Be;de=c[Xb>>2]|0;ee=Dd+1|0}while(0);ob=ob+1|0;if(ob>>>0>=de>>>0){Hd=Xd;Id=Yd;Jd=Zd;Kd=_d;Ld=$d;Md=ae;Nd=be;Od=ce;Pd=ee;break}else{ed=Xd;vd=Yd;Gd=Zd;ud=_d;hd=$d;id=ae;Fd=be;Ad=ce;Ed=de;Dd=ee}}}Vb=Vb+1|0;if(Vb>>>0>=fb>>>0){Dc=Pd;Ec=Kd;Fc=Od;Gc=Jd;Hc=Nd;Ic=Id;Jc=Md;Kc=Hd;Lc=Ld;break}else{rb=Hd;kb=Id;gb=Jd;qb=Kd;Yb=Ld;rc=Md;_b=Nd;tc=Od;Zb=Pd}}}g:do if((sb|0)!=0?(Zb=sb+-4|0,c[Zb>>2]=c[Zb>>2]|-2147483648,Zb=eb+12|0,tc=c[Zb>>2]|0,(tc|0)!=0):0){_b=eb+8|0;rc=tc;do{if((c[rc+4>>2]|0)>=0)break g;c[_b>>2]=rc;rc=c[rc>>2]|0;c[Zb>>2]=rc}while((rc|0)!=0)}while(0);h:do if((ib|0)!=0?(rc=ib+-4|0,c[rc>>2]=c[rc>>2]|-2147483648,rc=eb+12|0,Zb=c[rc>>2]|0,(Zb|0)!=0):0){_b=eb+8|0;tc=Zb;do{if((c[tc+4>>2]|0)>=0)break h;c[_b>>2]=tc;tc=c[tc>>2]|0;c[rc>>2]=tc}while((tc|0)!=0)}while(0);i:do if((hb|0)!=0?(tc=hb+-4|0,c[tc>>2]=c[tc>>2]|-2147483648,tc=eb+12|0,rc=c[tc>>2]|0,(rc|0)!=0):0){_b=eb+8|0;Zb=rc;do{if((c[Zb+4>>2]|0)>=0)break i;c[_b>>2]=Zb;Zb=c[Zb>>2]|0;c[tc>>2]=Zb}while((Zb|0)!=0)}while(0);c[G>>2]=Dc;j:do if(Dc){Eb=(c[k>>2]=Ec,ea(g[k>>2]));Cb=(c[k>>2]=Fc,ea(g[k>>2]));Fb=ea(Eb-Cb);Eb=(c[k>>2]=Gc,ea(g[k>>2]));Db=(c[k>>2]=Hc,ea(g[k>>2]));Sc=ea(Eb-Db);Eb=(c[k>>2]=Ic,ea(g[k>>2]));Pc=(c[k>>2]=Jc,ea(g[k>>2]));Wc=ea(Eb-Pc);Eb=(c[k>>2]=Kc,ea(g[k>>2]));Uc=(c[k>>2]=Lc,ea(g[k>>2]));Bb=ea(Eb-Uc);Eb=ea(g[120272]);Vc=Fb<Eb?Eb:Fb;Fb=ea(g[120273]);Eb=Sc<Fb?Fb:Sc;Sc=ea(g[120274]);Fb=Wc<Sc?Sc:Wc;Wc=ea(g[120275]);Sc=Bb<Wc?Wc:Bb;g[q>>2]=Vc;g[ba>>2]=Eb;g[ca>>2]=Fb;g[da>>2]=Sc;if(Vc>Eb)Je=Vc>Fb?0:2;else Je=Eb>Fb?1:2;Bb=ea(Vc*ea(.00395256933));Vc=ea(Eb*ea(.00395256933));Eb=ea(Fb*ea(.00395256933));Fb=ea(Sc*ea(.00395256933));Sc=ea(g[E>>2]);Wc=ea(g[z>>2]);Qc=ea(g[y>>2]);Xc=ea(g[C>>2]);g[r>>2]=Sc<Bb?Bb:Sc;g[fa>>2]=Wc<Vc?Vc:Wc;g[ga>>2]=Qc<Eb?Eb:Qc;g[ha>>2]=Xc<Fb?Fb:Xc;g[r+(Je<<2)>>2]=ea(ea(g[q+(Je<<2)>>2])/ea(65533.0));g[s>>2]=ea(254.0);g[ia>>2]=ea(254.0);g[ja>>2]=ea(254.0);g[ka>>2]=ea(254.0);g[s+(Je<<2)>>2]=ea(65534.0);Xc=ea(ea(1.0)/ea(g[r>>2]));Fb=ea(ea(1.0)/ea(g[fa>>2]));Qc=ea(ea(1.0)/ea(g[ga>>2]));Eb=ea(ea(1.0)/ea(g[ha>>2]));Wc=ea(ea(1.0)-ea(Cb*Xc));Cb=ea(ea(1.0)-ea(Db*Fb));Db=ea(ea(1.0)-ea(Pc*Qc));Pc=ea(ea(1.0)-ea(Uc*Eb));eb=c[v>>2]|0;Zb=Dc<<2;tc=Zb+4096|0;_b=(tc>>>0<Zb>>>0?Zb:tc)+(Dc<<3)|0;if(!_b){Ke=0;Le=Dc}else{tc=eb+8|0;Zb=(c[tc>>2]|0)+23&-16;rc=Zb+-8|0;Yb=eb+12|0;c[rc>>2]=c[Yb>>2];c[Zb+-4>>2]=_b&2147483644;c[Yb>>2]=rc;c[tc>>2]=Zb+_b;Ke=Zb;Le=c[G>>2]|0}Zb=Ke+(Le<<2)|0;_b=Le<<1;tc=Ke+(_b<<2)|0;rc=Ke+(_b+1024<<2)|0;_b=tc>>>0<rc>>>0?rc:tc;if(!Le)Me=0;else{tc=c[x>>2]|0;rc=c[D>>2]|0;Yb=c[J>>2]|0;Uc=ea(g[s>>2]);Vc=ea(g[ia>>2]);Sc=ea(g[ja>>2]);Bb=ea(g[ka>>2]);eb=t+(Je<<2)|0;qb=t+((((Je+1|0)>>>0)%3|0)<<2)|0;gb=t+((((Je+2|0)>>>0)%3|0)<<2)|0;kb=0;do{rb=c[rc+(kb<<2)>>2]|0;fb=c[Yb+((e[tc+(kb<<1)>>1]|0)*76|0)>>2]|0;Ob=ea(Xc*ea(g[fb+(rb<<4)>>2]));Lb=ea(Fb*ea(g[fb+(rb<<4)+4>>2]));Tc=ea(Qc*ea(g[fb+(rb<<4)+8>>2]));Mb=ea(Wc+Ob);Ob=ea(Cb+Lb);Lb=ea(Db+Tc);Tc=ea(Pc+ea(Eb*ea(g[fb+(rb<<4)+12>>2])));Oc=Uc<Mb?Uc:Mb;Mb=Vc<Ob?Vc:Ob;Ob=Sc<Lb?Sc:Lb;Lb=Bb<Tc?Bb:Tc;rb=Oc>ea(1.0);Tc=rb?Oc:ea(1.0);rb=Mb>ea(1.0);Oc=rb?Mb:ea(1.0);rb=Ob>ea(1.0);Mb=rb?Ob:ea(1.0);rb=Lb>ea(1.0);fb=~~ea(R(ea(Oc)));Vb=~~ea(R(ea(Mb)));bb=~~ea(R(ea(rb?Lb:ea(1.0))));c[t>>2]=~~ea(R(ea(Tc)));c[oa>>2]=fb;c[pa>>2]=Vb;c[qa>>2]=bb;c[_b+(kb<<2)>>2]=c[qb>>2]<<16|c[eb>>2]|c[gb>>2]<<24;kb=kb+1|0;bb=c[G>>2]|0}while(kb>>>0<bb>>>0);Me=bb}kb=_b+(Me<<2)|0;gb=Me<<2;eb=gb>>2;qb=gb>>1;gb=qb+256|0;tc=qb+512|0;Yb=qb+768|0;PEi(Ke+(qb<<2)|0,0,4096)|0;if(!Me){Ne=0;Oe=0;Pe=0;Qe=0;Re=0}else{rc=_b;do{bb=c[rc>>2]|0;Vb=Ke+((bb&255)+qb<<2)|0;c[Vb>>2]=(c[Vb>>2]|0)+1;Vb=Ke+((bb>>>8&255)+gb<<2)|0;c[Vb>>2]=(c[Vb>>2]|0)+1;Vb=Ke+((bb>>>16&255)+tc<<2)|0;c[Vb>>2]=(c[Vb>>2]|0)+1;Vb=Ke+((bb>>>24)+Yb<<2)|0;c[Vb>>2]=(c[Vb>>2]|0)+1;rc=rc+4|0}while((rc|0)!=(kb|0));Ne=0;Oe=0;Pe=0;Qe=0;Re=0}do{kb=Ke+(Ne+qb<<2)|0;rc=Oe;Oe=(c[kb>>2]|0)+Oe|0;c[kb>>2]=rc;rc=Ke+(Ne+gb<<2)|0;kb=Pe;Pe=(c[rc>>2]|0)+Pe|0;c[rc>>2]=kb;kb=Ke+(Ne+tc<<2)|0;rc=Qe;Qe=(c[kb>>2]|0)+Qe|0;c[kb>>2]=rc;rc=Ke+(Ne+Yb<<2)|0;kb=Re;Re=(c[rc>>2]|0)+Re|0;c[rc>>2]=kb;Ne=Ne+1|0}while((Ne|0)!=256);if(eb){kb=0;do{rc=Ke+((c[_b+(kb<<2)>>2]&255)+qb<<2)|0;Vb=c[rc>>2]|0;c[rc>>2]=Vb+1;c[Ke+(Vb+eb<<2)>>2]=kb;kb=kb+1|0}while((kb|0)!=(eb|0));Se=eb;Te=0;while(1){kb=c[Ke+(Se<<2)>>2]|0;qb=Ke+(((c[_b+(kb<<2)>>2]|0)>>>8&255)+gb<<2)|0;Vb=c[qb>>2]|0;c[qb>>2]=Vb+1;c[Ke+(Vb<<2)>>2]=kb;kb=Te+1|0;if((kb|0)==(eb|0)){Ue=Ke;Ve=0;break}else{Se=kb+eb|0;Te=kb}}while(1){gb=c[Ue>>2]|0;kb=Ke+(((c[_b+(gb<<2)>>2]|0)>>>16&255)+tc<<2)|0;Vb=c[kb>>2]|0;c[kb>>2]=Vb+1;c[Ke+(Vb+eb<<2)>>2]=gb;gb=Ve+1|0;if((gb|0)==(eb|0)){We=eb;Xe=0;break}else{Ue=Ke+(gb<<2)|0;Ve=gb}}while(1){tc=c[Ke+(We<<2)>>2]|0;gb=Ke+(((c[_b+(tc<<2)>>2]|0)>>>24)+Yb<<2)|0;Vb=c[gb>>2]|0;c[gb>>2]=Vb+1;c[Ke+(Vb<<2)>>2]=tc;tc=Xe+1|0;if((tc|0)==(eb|0))break;else{We=tc+eb|0;Xe=tc}}}eb=c[G>>2]|0;Yb=c[Ke+((eb<<1)+769<<2)>>2]|0;if(!eb)Ye=0;else{eb=0;do{c[Ke+(eb+Le<<2)>>2]=c[_b+(c[Ke+(eb<<2)>>2]<<2)>>2];eb=eb+1|0;tc=c[G>>2]|0}while(eb>>>0<tc>>>0);Ye=tc}c[Ke+(Ye+Le<<2)>>2]=-1;Bb=ea(Xc*ea(g[E>>2]));Sc=ea(Fb*ea(g[z>>2]));Vc=ea(Qc*ea(g[y>>2]));eb=~~ea(R(ea(Sc)));_b=~~ea(R(ea(Vc)));tc=~~ea(R(ea(Eb*ea(g[C>>2]))));c[u>>2]=~~ea(R(ea(Bb)));c[la>>2]=eb;c[ma>>2]=_b;c[na>>2]=tc;noa(d,Zb,Yb,Ke,c[G>>2]|0,(c[u+(Je<<2)>>2]|0)+2|0);tc=c[v>>2]|0;if(!Ke)break;_b=Ke+-4|0;c[_b>>2]=c[_b>>2]|-2147483648;_b=tc+12|0;eb=c[_b>>2]|0;if(!eb)break;Vb=tc+8|0;tc=eb;do{if((c[tc+4>>2]|0)>=0)break j;c[Vb>>2]=tc;tc=c[tc>>2]|0;c[_b>>2]=tc}while((tc|0)!=0)}while(0);if(!(c[G>>2]|0)){Ze=Ua;_e=Ta;$e=Sa;af=Ra}else{tc=c[x>>2]|0;_b=c[J>>2]|0;Vb=c[D>>2]|0;Eb=ea(0.0);Yb=Ra;Zb=Sa;eb=Ta;gb=Ua;kb=0;qb=-1;while(1){rc=b[tc+(kb<<1)>>1]|0;bb=rc&65535;if(rc<<16>>16==qb<<16>>16){Qc=ea(g[w>>2]);Fb=ea(g[L>>2]);Xc=ea(g[M>>2]);Bb=ea(g[N>>2]);Vc=ea(g[O>>2]);Sc=ea(g[P>>2]);Uc=ea(g[Q>>2]);Pc=ea(g[S>>2]);Db=ea(g[T>>2]);Cb=ea(g[U>>2]);Wc=ea(g[V>>2]);Tc=ea(g[W>>2]);Lb=ea(g[X>>2]);Mb=ea(g[Y>>2]);bf=Eb;cf=Qc;df=Fb;ef=Xc;ff=Bb;gf=Vc;hf=Sc;jf=Uc;kf=Pc;lf=Db;mf=Cb;nf=Wc;of=Tc;pf=Lb;qf=Mb;rf=ea(g[Z>>2]);sf=Yb;tf=Zb;uf=eb;vf=gb;wf=qb}else{Mb=ea(g[_b+(bb*76|0)+32>>2]);Lb=ea(g[_b+(bb*76|0)+36>>2]);Tc=ea(Mb*ea(-2.0));Mb=ea(Lb*ea(-2.0));Lb=ea(ea(g[_b+(bb*76|0)+40>>2])*ea(-2.0));Wc=ea(g[_b+(bb*76|0)+28>>2]);Cb=ea(ea(Wc*Wc)+ea(-.5));Db=ea(g[_b+(bb*76|0)+16>>2]);Pc=ea(Tc*Db);Uc=ea(g[_b+(bb*76|0)+20>>2]);Sc=ea(Pc+ea(Mb*Uc));Pc=ea(g[_b+(bb*76|0)+24>>2]);Vc=ea(Sc+ea(Lb*Pc));Sc=ea(ea(Db*Vc)+ea(ea(Tc*Cb)-ea(Wc*ea(ea(Lb*Uc)-ea(Mb*Pc)))));Bb=ea(ea(Uc*Vc)+ea(ea(Mb*Cb)-ea(Wc*ea(ea(Tc*Pc)-ea(Lb*Db)))));Xc=ea(ea(ea(Lb*Cb)-ea(Wc*ea(ea(Mb*Db)-ea(Tc*Uc))))+ea(Pc*Vc));Vc=ea(-Db);Tc=ea(-Uc);Mb=ea(-Pc);Cb=ea(Vc-Db);Db=ea(Tc-Uc);Uc=ea(Mb-Pc);Pc=ea(Db*Tc);Lb=ea(Uc*Mb);Fb=ea(Cb*Tc);Tc=ea(Cb*Mb);Qc=ea(Wc*Cb);Oc=ea(Db*Mb);Mb=ea(Wc*Db);Db=ea(Wc*Uc);Uc=ea(ea(ea(1.0)-Pc)-Lb);Wc=ea(Fb+Db);Ob=ea(Tc-Mb);Hb=ea(Fb-Db);Db=ea(ea(1.0)-ea(Cb*Vc));Vc=ea(Db-Lb);Lb=ea(Qc+Oc);Cb=ea(Tc+Mb);Mb=ea(Oc-Qc);Qc=ea(Db-Pc);Pc=ea(Uc);Db=ea(Wc);Oc=ea(Ob);g[l>>2]=Pc;g[w>>2]=Db;g[L>>2]=Oc;c[M>>2]=0;Oc=ea(Hb);Db=ea(Vc);Pc=ea(Lb);g[_>>2]=Oc;g[T>>2]=Db;g[U>>2]=Pc;c[V>>2]=0;Pc=ea(Cb);Db=ea(Mb);Oc=ea(Qc);g[$>>2]=Pc;g[X>>2]=Db;g[Y>>2]=Oc;c[Z>>2]=0;Oc=ea(Sc);Db=ea(Bb);Pc=ea(Xc);g[aa>>2]=Oc;g[O>>2]=Db;g[P>>2]=Pc;c[Q>>2]=1065353216;Pc=ea(g[_b+(bb*76|0)+68>>2]);rc=(g[k>>2]=Pc,c[k>>2]|0);bf=Uc;cf=Wc;df=Ob;ef=ea(0.0);ff=Sc;gf=Bb;hf=Xc;jf=ea(1.0);kf=Hb;lf=Vc;mf=Lb;nf=ea(0.0);of=Cb;pf=Mb;qf=Qc;rf=ea(0.0);sf=rc;tf=rc;uf=rc;vf=rc;wf=b[(c[x>>2]|0)+(kb<<1)>>1]|0}rc=c[Vb+(kb<<2)>>2]|0;fb=c[_b+(bb*76|0)>>2]|0;rb=fb+(rc<<4)|0;ab=c[_b+(bb*76|0)+4>>2]|0;bb=ab+(rc<<4)|0;Qc=ea(g[rb>>2]);Mb=ea(ea(Qc*bf)+ff);Cb=ea(ea(Qc*cf)+gf);Lb=ea(ea(Qc*df)+hf);Vc=ea(ea(Qc*ef)+jf);Wa=fb+(rc<<4)+4|0;Hb=ea(g[Wa>>2]);Xc=ea(Mb+ea(Hb*kf));Mb=ea(Cb+ea(Hb*lf));Cb=ea(Lb+ea(Hb*mf));Lb=ea(Vc+ea(Hb*nf));cb=fb+(rc<<4)+8|0;Vc=ea(g[cb>>2]);Bb=ea(Xc+ea(Vc*of));Xc=ea(Mb+ea(Vc*pf));Mb=ea(Cb+ea(Vc*qf));Cb=ea(Lb+ea(Vc*rf));db=(g[k>>2]=Bb,c[k>>2]|0);$a=(g[k>>2]=Xc,c[k>>2]|0);_a=(g[k>>2]=Mb,c[k>>2]|0);Za=(g[k>>2]=Cb,c[k>>2]|0);Ya=(g[k>>2]=Qc,c[k>>2]|0);mb=(g[k>>2]=Hb,c[k>>2]|0);Xa=(g[k>>2]=Vc,c[k>>2]|0);lb=fb+(rc<<4)+12|0;fb=c[lb>>2]|0;Dd=(db^Ya)&c[120264]^Ya;Ya=($a^mb)&c[120265]^mb;mb=(_a^Xa)&c[120266]^Xa;Xa=(fb^Za)&c[120267]^fb;c[rb>>2]=Dd;c[Wa>>2]=Ya;c[cb>>2]=mb;c[lb>>2]=Xa;Vc=ea(g[bb>>2]);Hb=ea((c[k>>2]=sf,ea(g[k>>2]))*Vc);lb=ab+(rc<<4)+4|0;Vc=ea(g[lb>>2]);Qc=ea((c[k>>2]=tf,ea(g[k>>2]))*Vc);cb=ab+(rc<<4)+8|0;Vc=ea(g[cb>>2]);Cb=ea((c[k>>2]=uf,ea(g[k>>2]))*Vc);Wa=ab+(rc<<4)+12|0;Vc=ea(g[Wa>>2]);Mb=ea((c[k>>2]=vf,ea(g[k>>2]))*Vc);rc=(g[k>>2]=Mb,c[k>>2]|0);Eb=ea(g[l>>2]);Mb=ea(ea(ea(Hb*Eb)+ea(Qc*kf))+ea(Cb*of));Vc=ea(ea(ea(Hb*cf)+ea(Qc*lf))+ea(Cb*pf));Xc=ea(ea(ea(Hb*df)+ea(Qc*mf))+ea(Cb*qf));Bb=ea(ea(ea(Hb*ef)+ea(Qc*nf))+ea(Cb*rf));ab=(g[k>>2]=Mb,c[k>>2]|0);rb=(g[k>>2]=Vc,c[k>>2]|0);fb=(g[k>>2]=Xc,c[k>>2]|0);Za=(g[k>>2]=Bb,c[k>>2]|0);_a=(g[k>>2]=Hb,c[k>>2]|0);$a=(g[k>>2]=Qc,c[k>>2]|0);db=(g[k>>2]=Cb,c[k>>2]|0);Cb=(c[k>>2]=Dd,ea(g[k>>2]));Qc=ea(Cb-(c[k>>2]=(ab^_a)&c[120264]^_a,ea(g[k>>2])));Cb=(c[k>>2]=Ya,ea(g[k>>2]));Hb=ea(Cb-(c[k>>2]=(rb^$a)&c[120265]^$a,ea(g[k>>2])));Cb=(c[k>>2]=mb,ea(g[k>>2]));Bb=ea(Cb-(c[k>>2]=(fb^db)&c[120266]^db,ea(g[k>>2])));Cb=(c[k>>2]=Xa,ea(g[k>>2]));Xc=ea(Cb-(c[k>>2]=(Za^rc)&c[120267]^rc,ea(g[k>>2])));Cb=ea(g[120276]);Vc=ea(g[120277]);Mb=ea(g[120278]);Lb=ea(g[120279]);Sc=ea(Cb<Qc?Qc:Cb);Cb=ea(Vc<Hb?Hb:Vc);Vc=ea(Mb<Bb?Bb:Mb);Mb=ea(Lb<Xc?Xc:Lb);g[bb>>2]=Sc;g[lb>>2]=Cb;g[cb>>2]=Vc;g[Wa>>2]=Mb;kb=kb+1|0;if(kb>>>0>=(c[G>>2]|0)>>>0){Ze=vf;_e=uf;$e=tf;af=sf;break}else{Yb=sf;Zb=tf;eb=uf;gb=vf;qb=wf}}}if(Va>>>0>=(c[A>>2]|0)>>>0)break;Ra=af;Sa=$e;Ta=_e;Ua=Ze;Va=Va+1|0}K=c[B>>2]|0}B=c[v>>2]|0;k:do if((K|0)!=0?(Va=K+-4|0,c[Va>>2]=c[Va>>2]|-2147483648,Va=B+12|0,Ze=c[Va>>2]|0,(Ze|0)!=0):0){Ua=B+8|0;_e=Ze;do{if((c[_e+4>>2]|0)>=0)break k;c[Ua>>2]=_e;_e=c[_e>>2]|0;c[Va>>2]=_e}while((_e|0)!=0)}while(0);B=c[v>>2]|0;K=c[D>>2]|0;l:do if((K|0)!=0?(D=K+-4|0,c[D>>2]=c[D>>2]|-2147483648,D=B+12|0,_e=c[D>>2]|0,(_e|0)!=0):0){Va=B+8|0;Ua=_e;do{if((c[Ua+4>>2]|0)>=0)break l;c[Va>>2]=Ua;Ua=c[Ua>>2]|0;c[D>>2]=Ua}while((Ua|0)!=0)}while(0);B=c[v>>2]|0;v=c[x>>2]|0;if(!v){i=f;return}x=v+-4|0;c[x>>2]=c[x>>2]|-2147483648;x=B+12|0;v=c[x>>2]|0;if(!v){i=f;return}K=B+8|0;B=v;while(1){if((c[B+4>>2]|0)>=0){xf=161;break}c[K>>2]=B;B=c[B>>2]|0;c[x>>2]=B;if(!B){xf=161;break}}if((xf|0)==161){i=f;return}}function noa(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;j=i;i=i+48|0;k=j+20|0;l=j;m=c[d>>2]|0;n=m&65535;o=n>>>0>h>>>0?h:n;n=m+h|0;p=m|65535;q=n>>>0<p>>>0?n:p;c[k>>2]=d;p=m;n=d;while(1){r=n+4|0;if(p>>>0>=q>>>0)break;p=c[r>>2]|0;n=r}r=m-o|0;c[l>>2]=n;o=r+65536|0;s=p;p=n;while(1){t=p+4|0;if(s>>>0>=o>>>0)break;s=c[t>>2]|0;p=t}c[k+4>>2]=p;o=q+65536|0;t=s;s=p;while(1){p=s+4|0;if(t>>>0>=o>>>0)break;t=c[p>>2]|0;s=p}c[l+4>>2]=s;s=r+16711680|0;t=d+(e<<2)|0;while(1){u=c[t>>2]|0;if(u>>>0<s>>>0)t=t+4|0;else break}c[k+8>>2]=t;s=q+16711680|0;e=u;u=t;while(1){t=u+4|0;if(e>>>0>=s>>>0)break;e=c[t>>2]|0;u=t}c[l+8>>2]=u;u=r+16777216|0;e=m;s=d;while(1){t=s+4|0;if(e>>>0>=u>>>0)break;e=c[t>>2]|0;s=t}c[k+12>>2]=s;u=q+16777216|0;t=e;e=s;while(1){s=e+4|0;if(t>>>0>=u>>>0)break;t=c[s>>2]|0;e=s}c[l+12>>2]=e;e=r+16842752|0;r=m;m=d;while(1){t=m+4|0;if(r>>>0>=e>>>0)break;r=c[t>>2]|0;m=t}c[k+16>>2]=m;e=q+16842752|0;q=r;r=m;while(1){m=r+4|0;if(q>>>0>=e>>>0)break;q=c[m>>2]|0;r=m}c[l+16>>2]=r;r=f+(g<<2)|0;if(!g){i=j;return}g=a+104|0;q=a+80|0;e=a+116|0;m=a+84|0;t=a+96|0;u=a+108|0;s=a+88|0;o=a+4|0;p=a+8|0;v=a+12|0;w=a+16|0;x=a+20|0;y=a+24|0;z=a+28|0;A=d;B=d;d=n;n=f;while(1){C=c[n>>2]|0;D=b[(c[g>>2]|0)+(C<<1)>>1]|0;b[q>>1]=D;E=D&65535;c[m>>2]=c[(c[e>>2]|0)+(E<<2)>>2];D=c[t>>2]|0;F=c[(c[u>>2]|0)+(C<<2)>>2]|0;c[s>>2]=F;C=D+(E*76|0)|0;G=c[C>>2]|0;c[a>>2]=c[G+(F<<4)>>2];c[o>>2]=c[G+(F<<4)+4>>2];c[p>>2]=c[G+(F<<4)+8>>2];c[v>>2]=c[G+(F<<4)+12>>2];G=D+(E*76|0)+4|0;E=c[G>>2]|0;c[w>>2]=c[E+(F<<4)>>2];c[x>>2]=c[E+(F<<4)+4>>2];c[y>>2]=c[E+(F<<4)+8>>2];c[z>>2]=c[E+(F<<4)+12>>2];F=c[B>>2]|0;E=F&65535;D=F-(E>>>0>h>>>0?h:E)|0;E=F+h|0;H=F|65535;F=E>>>0<H>>>0?E:H;if((c[d>>2]|0)>>>0<F>>>0){H=d;do H=H+4|0;while((c[H>>2]|0)>>>0<F>>>0);c[l>>2]=H;I=H}else I=d;E=f+(I-A>>2<<2)|0;J=n+4|0;if((J|0)==(E|0))K=1;else{L=J;do{poa(a,c[L>>2]|0);L=L+4|0}while((L|0)!=(E|0));K=1}do{E=c[481152+(K<<2)>>2]|0;L=D+E|0;H=k+(K<<2)|0;M=c[H>>2]|0;if((c[M>>2]|0)>>>0<L>>>0){N=M;do N=N+4|0;while((c[N>>2]|0)>>>0<L>>>0);c[H>>2]=N;O=N}else O=M;L=E+F|0;P=l+(K<<2)|0;Q=c[P>>2]|0;if((c[Q>>2]|0)>>>0<L>>>0){R=Q;do R=R+4|0;while((c[R>>2]|0)>>>0<L>>>0);c[P>>2]=R;S=R}else S=Q;L=S-A>>2;E=f+(L<<2)|0;M=O-A>>2;if((M|0)!=(L|0)){L=f+(M<<2)|0;do{poa(a,c[L>>2]|0);L=L+4|0}while((L|0)!=(E|0))}K=K+1|0}while((K|0)!=5);F=c[s>>2]|0;D=c[C>>2]|0;c[D+(F<<4)>>2]=c[a>>2];c[D+(F<<4)+4>>2]=c[o>>2];c[D+(F<<4)+8>>2]=c[p>>2];c[D+(F<<4)+12>>2]=c[v>>2];F=c[s>>2]|0;D=c[G>>2]|0;c[D+(F<<4)>>2]=c[w>>2];c[D+(F<<4)+4>>2]=c[x>>2];c[D+(F<<4)+8>>2]=c[y>>2];c[D+(F<<4)+12>>2]=c[z>>2];F=(c[k>>2]|0)+4|0;c[k>>2]=F;if((J|0)==(r|0))break;B=F;d=c[l>>2]|0;n=J}i=j;return}function ooa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b)e=0;else{f=0;g=0;while(1){h=(c[a+(f*76|0)+8>>2]|0)+g|0;f=f+1|0;if((f|0)==(b|0)){e=h;break}else g=h}}g=e<<2;f=g+4096|0;i=d;return g+(b<<6)+(f>>>0<g>>>0?g:f)+(b<<3)+(e*10|0)|0}function poa(a,b){a=a|0;b=b|0;var d=0,f=0,h=0,j=0,l=0,m=Im,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=0,v=Im,w=0,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0;d=i;f=e[(c[a+104>>2]|0)+(b<<1)>>1]|0;if(!(1<<f&c[a+84>>2])){i=d;return}h=c[a+96>>2]|0;j=c[(c[a+108>>2]|0)+(b<<2)>>2]|0;b=c[h+(f*76|0)>>2]|0;l=b+(j<<4)|0;m=ea(g[l>>2]);n=ea(g[a>>2]);o=ea(m-n);p=b+(j<<4)+4|0;q=ea(g[p>>2]);r=a+4|0;s=ea(g[r>>2]);t=ea(q-s);u=b+(j<<4)+8|0;v=ea(g[u>>2]);w=a+8|0;x=ea(g[w>>2]);y=ea(v-x);z=b+(j<<4)+12|0;v=ea(g[z>>2]);b=a+12|0;A=ea(g[b>>2]);B=ea(v-A);C=ea(ea(ea(o*o)+ea(t*t))+ea(y*y));if(((C>ea(g[a+48>>2])?C>ea(g[a+52>>2]):0)?C>ea(g[a+56>>2]):0)?C>ea(g[a+60>>2]):0){i=d;return}D=ea(ea(1.0)/ea(T(ea(C))));C=ea(D*ea(g[a+32>>2]));E=ea(D*ea(g[a+36>>2]));F=ea(D*ea(g[a+40>>2]));G=ea(D*ea(g[a+44>>2]));D=ea(A+ea(g[120272]));H=ea(A+ea(g[120273]));I=ea(A+ea(g[120274]));J=ea(ea(1.0)/ea(v+D));D=ea(ea(1.0)/ea(v+H));H=ea(ea(1.0)/ea(v+I));I=ea(ea(1.0)/ea(v+ea(A+ea(g[120275]))));K=ea(J*ea(g[a+64>>2]));J=ea(D*ea(g[a+68>>2]));D=ea(H*ea(g[a+72>>2]));H=ea(ea(o-ea(o*C))*K);K=ea(ea(t-ea(t*E))*J);J=ea(ea(y-ea(y*F))*D);D=ea(ea(B-ea(B*G))*ea(I*ea(g[a+76>>2])));L=(g[k>>2]=H,c[k>>2]|0);M=(g[k>>2]=K,c[k>>2]|0);N=(g[k>>2]=J,c[k>>2]|0);O=c[120267]&(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=c[120264]&L,ea(g[k>>2]));J=ea(A*D);K=(c[k>>2]=c[120265]&M,ea(g[k>>2]));H=ea(A*K);I=(c[k>>2]=c[120266]&N,ea(g[k>>2]));G=ea(A*I);B=(c[k>>2]=O,ea(g[k>>2]));F=ea(A*B);y=ea(J+n);n=ea(H+s);s=ea(G+x);x=ea(A+F);A=ea(y);y=ea(n);n=ea(s);s=ea(x);g[a>>2]=A;g[r>>2]=y;g[w>>2]=n;g[b>>2]=s;s=ea(v*D);D=ea(v*K);K=ea(v*I);I=ea(v*B);B=ea(m-s);m=ea(q-D);q=ea(ea(g[u>>2])-K);v=ea(ea(g[z>>2])-I);n=ea(B);B=ea(m);m=ea(q);q=ea(v);g[l>>2]=n;g[p>>2]=B;g[u>>2]=m;g[z>>2]=q;z=c[h+(f*76|0)+4>>2]|0;f=z+(j<<4)|0;h=a+16|0;q=ea(J+ea(g[h>>2]));u=a+20|0;J=ea(H+ea(g[u>>2]));p=a+24|0;H=ea(G+ea(g[p>>2]));l=a+28|0;G=ea(F+ea(g[l>>2]));F=ea(q);q=ea(J);J=ea(H);H=ea(G);g[h>>2]=F;g[u>>2]=q;g[p>>2]=J;g[l>>2]=H;H=ea(ea(g[f>>2])-s);l=z+(j<<4)+4|0;s=ea(ea(g[l>>2])-D);p=z+(j<<4)+8|0;D=ea(ea(g[p>>2])-K);u=z+(j<<4)+12|0;K=ea(ea(g[u>>2])-I);I=ea(H);H=ea(s);s=ea(D);D=ea(K);g[f>>2]=I;g[l>>2]=H;g[p>>2]=s;g[u>>2]=D;i=d;return}function qoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=0,l=0;e=i;c[a+48>>2]=b;c[a+52>>2]=d;f=ea(g[b+224>>2]);h=ea(f);g[a>>2]=h;g[a+4>>2]=h;g[a+8>>2]=h;g[a+12>>2]=h;h=ea(f*f);f=ea(h);g[a+16>>2]=f;g[a+20>>2]=f;g[a+24>>2]=f;g[a+28>>2]=f;f=ea(g[b+228>>2]);b=(g[k>>2]=f,c[k>>2]|0);d=b&c[120281];j=b&c[120282];l=b&c[120283];c[a+32>>2]=b&c[120280];c[a+36>>2]=d;c[a+40>>2]=j;c[a+44>>2]=l;i=e;return}function roa(a){a=a|0;return}function soa(a){a=a|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=Im,C=0,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,S=Im,T=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;d=i;i=i+80|0;f=d+64|0;h=d+48|0;j=d+32|0;k=d+16|0;l=d;c[a+60>>2]=0;c[a+56>>2]=0;m=a+48|0;n=c[m>>2]|0;o=ea(g[n+224>>2]);p=ea(g[n+228>>2]);if(!((o<p?o:p)>ea(0.0))){i=d;return}p=ea(g[n+12>>2]);o=ea(g[n+16>>2]);q=ea(g[n+20>>2]);r=ea(g[n+24>>2]);s=ea(g[n+28>>2]);t=ea(g[n+32>>2]);u=ea(r-p);v=ea(s-o);s=ea(t-q);t=ea(ea(g[n+36>>2])-r);w=ea(g[120284]);x=u<w?w:u;u=ea(g[120285]);w=v<u?u:v;v=ea(g[120286]);u=s<v?v:s;s=ea(g[120287]);v=t<s?s:t;g[f>>2]=x;g[f+4>>2]=w;g[f+8>>2]=u;g[f+12>>2]=v;if(x>w)y=x>u?0:2;else y=w>u?1:2;t=ea(x*ea(.00395256933));x=ea(w*ea(.00395256933));w=ea(u*ea(.00395256933));u=ea(v*ea(.00395256933));v=ea(g[a>>2]);z=a+4|0;s=ea(g[z>>2]);A=a+8|0;B=ea(g[A>>2]);C=a+12|0;D=ea(g[C>>2]);g[h>>2]=v<t?t:v;E=h+4|0;g[E>>2]=s<x?x:s;F=h+8|0;g[F>>2]=B<w?w:B;G=h+12|0;g[G>>2]=D<u?u:D;g[h+(y<<2)>>2]=ea(ea(g[f+(y<<2)>>2])/ea(65533.0));g[j>>2]=ea(254.0);f=j+4|0;g[f>>2]=ea(254.0);H=j+8|0;g[H>>2]=ea(254.0);I=j+12|0;g[I>>2]=ea(254.0);g[j+(y<<2)>>2]=ea(65534.0);D=ea(ea(1.0)/ea(g[h>>2]));u=ea(ea(1.0)/ea(g[E>>2]));B=ea(ea(1.0)/ea(g[F>>2]));w=ea(ea(1.0)/ea(g[G>>2]));s=ea(ea(1.0)-ea(p*D));p=ea(ea(1.0)-ea(o*u));o=ea(ea(1.0)-ea(q*B));q=ea(ea(1.0)-ea(r*w));G=c[n+232>>2]|0;F=a+52|0;E=c[F>>2]|0;h=G<<2;J=G<<1;K=J+2048|0;L=h+4|0;M=(J+2&-4)+h+(K>>>0<L>>>0?L:K)|0;if(!M){N=0;O=n}else{n=E+8|0;K=(c[n>>2]|0)+23&-16;L=K+-8|0;h=E+12|0;c[L>>2]=c[h>>2];c[K+-4>>2]=M&2147483646;c[h>>2]=L;c[n>>2]=K+M;N=K;O=c[m>>2]|0}K=c[O+236>>2]|0;M=N+(G<<2)|0;n=M+((G+1&-2)<<1)|0;L=c[O+4>>2]|0;O=(G|0)==0;if(!O){r=ea(g[j>>2]);x=ea(g[f>>2]);v=ea(g[H>>2]);t=ea(g[I>>2]);I=k+4|0;H=k+8|0;f=k+12|0;j=k+(y<<2)|0;h=k+((((y+1|0)>>>0)%3|0)<<2)|0;E=k+((((y+2|0)>>>0)%3|0)<<2)|0;if(!K){P=0;do{Q=ea(D*ea(g[L+(P<<4)>>2]));S=ea(u*ea(g[L+(P<<4)+4>>2]));T=ea(B*ea(g[L+(P<<4)+8>>2]));U=ea(s+Q);Q=ea(p+S);S=ea(o+T);T=ea(q+ea(w*ea(g[L+(P<<4)+12>>2])));V=r<U?r:U;U=x<Q?x:Q;Q=v<S?v:S;S=t<T?t:T;W=V>ea(1.0);T=W?V:ea(1.0);W=U>ea(1.0);V=W?U:ea(1.0);W=Q>ea(1.0);U=W?Q:ea(1.0);W=S>ea(1.0);X=~~ea(R(ea(V)));Y=~~ea(R(ea(U)));Z=~~ea(R(ea(W?S:ea(1.0))));c[k>>2]=~~ea(R(ea(T)));c[I>>2]=X;c[H>>2]=Y;c[f>>2]=Z;c[N+(P<<2)>>2]=c[h>>2]<<16|c[j>>2]|c[E>>2]<<24;P=P+1|0}while((P|0)!=(G|0))}else{P=0;do{Z=c[K+(P<<2)>>2]|0;T=ea(D*ea(g[L+(Z<<4)>>2]));S=ea(u*ea(g[L+(Z<<4)+4>>2]));U=ea(B*ea(g[L+(Z<<4)+8>>2]));V=ea(s+T);T=ea(p+S);S=ea(o+U);U=ea(q+ea(w*ea(g[L+(Z<<4)+12>>2])));Q=r<V?r:V;V=x<T?x:T;T=v<S?v:S;S=t<U?t:U;Z=Q>ea(1.0);U=Z?Q:ea(1.0);Z=V>ea(1.0);Q=Z?V:ea(1.0);Z=T>ea(1.0);V=Z?T:ea(1.0);Z=S>ea(1.0);Y=~~ea(R(ea(Q)));X=~~ea(R(ea(V)));W=~~ea(R(ea(Z?S:ea(1.0))));c[k>>2]=~~ea(R(ea(U)));c[I>>2]=Y;c[H>>2]=X;c[f>>2]=W;c[N+(P<<2)>>2]=c[h>>2]<<16|c[j>>2]|c[E>>2]<<24;P=P+1|0}while((P|0)!=(G|0))}}P=(M-N|0)>>>2&65535;E=P<<1;j=E+256|0;h=E+512|0;f=E+768|0;PEi(N+(P+G<<2)|0,0,2048)|0;if((N|0)==(M|0)){_=0;$=0;aa=0;ba=0;ca=0}else{H=N;do{I=c[H>>2]|0;k=M+((I&255)+E<<1)|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16;k=M+((I>>>8&255)+j<<1)|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16;k=M+((I>>>16&255)+h<<1)|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16;k=M+((I>>>24)+f<<1)|0;b[k>>1]=(b[k>>1]|0)+1<<16>>16;H=H+4|0}while((H|0)!=(M|0));_=0;$=0;aa=0;ba=0;ca=0}do{H=M+(_+E<<1)|0;k=$;$=(e[H>>1]|0)+($&65535)&65535;b[H>>1]=k;k=M+(_+j<<1)|0;H=aa;aa=(e[k>>1]|0)+(aa&65535)&65535;b[k>>1]=H;H=M+(_+h<<1)|0;k=ba;ba=(e[H>>1]|0)+(ba&65535)&65535;b[H>>1]=k;k=M+(_+f<<1)|0;H=ca;ca=(e[k>>1]|0)+(ca&65535)&65535;b[k>>1]=H;_=_+1|0}while((_|0)!=256);if(P){_=0;ca=0;do{ba=M+((c[N+(_<<2)>>2]&255)+E<<1)|0;aa=b[ba>>1]|0;b[ba>>1]=aa+1<<16>>16;b[M+((aa&65535)+P<<1)>>1]=ca;ca=ca+1<<16>>16;_=ca&65535}while((_|0)!=(P|0));da=P;fa=0;while(1){_=b[M+(da<<1)>>1]|0;ca=M+(((c[N+((_&65535)<<2)>>2]|0)>>>8&255)+j<<1)|0;E=b[ca>>1]|0;b[ca>>1]=E+1<<16>>16;b[M+((E&65535)<<1)>>1]=_;fa=fa+1<<16>>16;_=fa&65535;if((_|0)==(P|0)){ga=M;ha=0;break}else da=_+P|0}while(1){da=b[ga>>1]|0;fa=M+(((c[N+((da&65535)<<2)>>2]|0)>>>16&255)+h<<1)|0;j=b[fa>>1]|0;b[fa>>1]=j+1<<16>>16;b[M+((j&65535)+P<<1)>>1]=da;ha=ha+1<<16>>16;da=ha&65535;if((da|0)==(P|0)){ia=P;ja=0;break}else ga=M+(da<<1)|0}while(1){ga=b[M+(ia<<1)>>1]|0;ha=M+(((c[N+((ga&65535)<<2)>>2]|0)>>>24)+f<<1)|0;h=b[ha>>1]|0;b[ha>>1]=h+1<<16>>16;b[M+((h&65535)<<1)>>1]=ga;ja=ja+1<<16>>16;ga=ja&65535;if((ga|0)==(P|0))break;else ia=ga+P|0}}P=b[M+(J+769<<1)>>1]|0;if(!O){J=0;do{c[n+(J<<2)>>2]=c[N+((e[M+(J<<1)>>1]|0)<<2)>>2];J=J+1|0}while((J|0)!=(G|0))}c[n+(G<<2)>>2]=-1;if(K)if(O)ka=N;else{O=0;do{b[N+(O<<1)>>1]=c[K+((e[M+(O<<1)>>1]|0)<<2)>>2];O=O+1|0}while((O|0)!=(G|0));ka=N}else ka=M;t=ea(D*ea(g[a>>2]));D=ea(u*ea(g[z>>2]));u=ea(B*ea(g[A>>2]));A=~~ea(R(ea(D)));z=~~ea(R(ea(u)));M=~~ea(R(ea(w*ea(g[C>>2]))));c[l>>2]=~~ea(R(ea(t)));c[l+4>>2]=A;c[l+8>>2]=z;c[l+12>>2]=M;M=(c[l+(y<<2)>>2]|0)+2|0;if(!(c[(c[m>>2]|0)+240>>2]|0))T_a(a,n,P,ka,M);else S_a(a,n,P,ka,M);M=c[F>>2]|0;if(!N){i=d;return}F=N+-4|0;c[F>>2]=c[F>>2]|-2147483648;F=M+12|0;N=c[F>>2]|0;if(!N){i=d;return}ka=M+8|0;M=N;while(1){if((c[M+4>>2]|0)>=0){la=32;break}c[ka>>2]=M;M=c[M>>2]|0;c[F>>2]=M;if(!M){la=32;break}}if((la|0)==32){i=d;return}}function toa(a){a=a|0;var b=0,d=0,e=0,f=Im,h=Im,j=0,k=0;b=i;d=c[a+492>>2]|0;if(!d)e=c[a+12>>2]|0;else e=d;f=ea(g[a+480>>2]);h=ea(-ea(g[a+484>>2]));if(!((f<h?f:h)>ea(0.0))){j=0;i=b;return j|0}a=e<<2;d=e<<1;e=d+2048|0;k=a+4|0;j=(d+2&-4)+a+(e>>>0<k>>>0?k:e)|0;i=b;return j|0}function uoa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0;e=i;c[a>>2]=481184;c[a+4>>2]=481244;f=a+8|0;b[a+12>>1]=-1;b[a+14>>1]=0;c[a+16>>2]=0;c[f>>2]=443968;c[a+20>>2]=0;c[a+24>>2]=0;c[f>>2]=481584;c[a+32>>2]=0;c[a+36>>2]=0;c[a+40>>2]=0;f=a+44|0;b[a+48>>1]=-1;b[a+50>>1]=0;c[a+52>>2]=0;c[f>>2]=443968;c[a+56>>2]=0;c[a+60>>2]=0;c[f>>2]=481632;c[a+72>>2]=d;if(!d)h=-1;else h=_n[c[(c[d>>2]|0)+36>>2]&4095](d,481296)|0;b[a+76>>1]=h;g[a+80>>2]=ea(0.0);g[a+84>>2]=ea(1.0);c[a+88>>2]=1;h=a+96|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[a+28>>2]=a;c[a+64>>2]=a;i=e;return}function voa(a){a=a|0;var b=0;b=i;xoa(a);i=b;return}function woa(a){a=a|0;var b=0;b=i;xoa(a+-4|0);i=b;return}function xoa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;c[a>>2]=481184;c[a+4>>2]=481244;d=c[a+96>>2]|0;if(d)VJa(b,d);d=c[a+112>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+104>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}c[a+44>>2]=443968;c[a+52>>2]=0;d=a+32|0;e=c[d>>2]|0;f=c[a+36>>2]|0;g=e+(f*40|0)|0;if((f|0)>0){f=e;do{ko[c[c[f>>2]>>2]&4095](f);f=f+40|0}while(f>>>0<g>>>0)}g=c[a+40>>2]|0;if(!((g&2147483647|0)!=0&(g|0)>-1)){h=a+8|0;c[h>>2]=443968;j=a+16|0;c[j>>2]=0;c[a>>2]=48e4;Sla(a);i=b;return}VJa(d,c[d>>2]|0);h=a+8|0;c[h>>2]=443968;j=a+16|0;c[j>>2]=0;c[a>>2]=48e4;Sla(a);i=b;return}function yoa(a){a=a|0;var b=0;b=i;xoa(a+-4|0);i=b;return}function zoa(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+48|0;f=e+44|0;h=e+40|0;j=e;k=a+32|0;l=j+4|0;b[l>>1]=-1;b[j+6>>1]=0;c[j+8>>2]=0;c[j>>2]=443968;m=j+12|0;c[m>>2]=0;n=j+16|0;c[n>>2]=0;c[j>>2]=481496;o=j+20|0;c[o>>2]=d+12;c[j+24>>2]=a+44;c[j+28>>2]=0;c[j+32>>2]=0;g[j+36>>2]=ea(0.0);d=a+36|0;p=c[d>>2]|0;if((c[a+40>>2]&2147483647)>>>0<=p>>>0){U_a(k,j)|0;q=k;r=c[d>>2]|0;s=c[q>>2]|0;c[h>>2]=2592;W_a(s,r,h,f);i=e;return}j=c[k>>2]|0;a=j+(p*40|0)|0;if(!a)t=p;else{u=l;l=c[u>>2]|0;v=c[u+4>>2]|0;u=j+(p*40|0)+4|0;w=u;b[w>>1]=l;b[w+2>>1]=l>>>16;l=u+4|0;b[l>>1]=v;b[l+2>>1]=v>>>16;c[a>>2]=443968;v=j+(p*40|0)+12|0;c[v>>2]=c[m>>2];c[j+(p*40|0)+16>>2]=c[n>>2];c[v>>2]=c[m>>2];c[a>>2]=481496;a=j+(p*40|0)+20|0;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];t=c[d>>2]|0}o=t+1|0;c[d>>2]=o;q=k;r=o;s=c[q>>2]|0;c[h>>2]=2592;W_a(s,r,h,f);i=e;return}function Aoa(a,b){a=a|0;b=b|0;var c=0;c=i;zoa(a+-4|0,b);i=c;return}function Boa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+4|0;h=f;j=d+12|0;d=a+32|0;k=c[d>>2]|0;l=a+36|0;a=c[l>>2]|0;m=k+(a*40|0)|0;if(!a){i=f;return}else n=k;while(1){k=n+40|0;if((c[n+20>>2]|0)==(j|0))break;if((k|0)==(m|0)){o=5;break}else n=k}if((o|0)==5){i=f;return}Sla(c[n+32>>2]|0);o=c[d>>2]|0;m=(n-o|0)/40|0;n=(c[l>>2]|0)+-1|0;c[l>>2]=n;j=o+(n*40|0)+4|0;k=j;a=e[k>>1]|e[k+2>>1]<<16;k=j+4|0;j=e[k>>1]|e[k+2>>1]<<16;k=o+(m*40|0)+4|0;p=k;b[p>>1]=a;b[p+2>>1]=a>>>16;a=k+4|0;b[a>>1]=j;b[a+2>>1]=j>>>16;c[o+(m*40|0)+12>>2]=c[o+(n*40|0)+12>>2];c[o+(m*40|0)+16>>2]=c[o+(n*40|0)+16>>2];j=o+(m*40|0)+20|0;m=o+(n*40|0)+20|0;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[j+16>>2]=c[m+16>>2];m=(c[d>>2]|0)+((c[l>>2]|0)*40|0)|0;ko[c[c[m>>2]>>2]&4095](m);m=c[d>>2]|0;d=c[l>>2]|0;c[h>>2]=2592;W_a(m,d,h,g);i=f;return}function Coa(a,b){a=a|0;b=b|0;var c=0;c=i;Boa(a+-4|0,b);i=c;return}function Doa(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=0,j=0;e=i;if(!(c[a+36>>2]|0)){ko[c[(c[d>>2]|0)+16>>2]&4095](d);f=d;i=e;return f|0}h=a+44|0;c[a+60>>2]=1;j=a+56|0;c[j>>2]=d;if(d){ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[a+52>>2]=c[(c[j>>2]|0)+8>>2]}g[a+68>>2]=b;c[a+24>>2]=1;j=a+20|0;c[j>>2]=h;ko[c[(c[h>>2]|0)+16>>2]&4095](h);c[a+16>>2]=c[(c[j>>2]|0)+8>>2];ko[c[(c[h>>2]|0)+20>>2]&4095](h);f=a+8|0;i=e;return f|0}function Eoa(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=0,j=0;e=i;f=a+-4|0;if(!(c[f+36>>2]|0)){ko[c[(c[d>>2]|0)+16>>2]&4095](d);h=d;i=e;return h|0}a=f+44|0;c[f+60>>2]=1;j=f+56|0;c[j>>2]=d;if(d){ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[f+52>>2]=c[(c[j>>2]|0)+8>>2]}g[f+68>>2]=b;c[f+24>>2]=1;j=f+20|0;c[j>>2]=a;ko[c[(c[a>>2]|0)+16>>2]&4095](a);c[f+16>>2]=c[(c[j>>2]|0)+8>>2];ko[c[(c[a>>2]|0)+20>>2]&4095](a);h=f+8|0;i=e;return h|0}function Foa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=Im;b=i;i=i+320|0;d=b+160|0;e=b+313|0;f=b+312|0;h=b+144|0;j=b;k=a+88|0;if(!(c[k>>2]|0)){i=b;return}l=a+80|0;if(ea(g[l>>2])==ea(0.0)){i=b;return}m=a+104|0;X_a(m,0,b+236|0);n=a+36|0;if(c[n>>2]|0){o=a+32|0;p=d+4|0;q=d+8|0;r=d+12|0;s=d+16|0;t=d+20|0;u=d+24|0;v=d+28|0;w=d+32|0;x=d+36|0;y=d+40|0;z=d+44|0;A=d+48|0;B=d+52|0;C=d+56|0;D=d+60|0;E=d+64|0;F=d+68|0;G=d+72|0;H=0;do{I=c[o>>2]|0;J=c[I+(H*40|0)+20>>2]|0;K=ea(g[I+(H*40|0)+36>>2]);I=c[J+20>>2]|0;L=c[J+492>>2]|0;if(!L){M=c[J+12>>2]|0;N=0}else{M=L;N=c[J+488>>2]|0}L=c[J+532>>2]|0;c[d>>2]=c[J+8>>2];c[p>>2]=I;c[q>>2]=M;c[r>>2]=N;g[s>>2]=ea(g[J+148>>2]);g[t>>2]=ea(g[J+152>>2]);g[u>>2]=ea(g[J+156>>2]);g[v>>2]=ea(g[J+160>>2]);g[w>>2]=ea(g[J+164>>2]);g[x>>2]=ea(g[J+168>>2]);g[y>>2]=ea(g[J+172>>2]);g[z>>2]=ea(g[J+32>>2]);g[A>>2]=ea(g[J+36>>2]);g[B>>2]=ea(g[J+40>>2]);g[C>>2]=ea(g[J+44>>2]);g[D>>2]=ea(g[J+48>>2]);g[E>>2]=ea(g[J+52>>2]);g[F>>2]=K;c[G>>2]=L;Y_a(m,d)|0;H=H+1|0}while(H>>>0<(c[n>>2]|0)>>>0)}n=a+108|0;H=ooa(c[m>>2]|0,c[n>>2]|0)|0;d=a+100|0;G=c[d>>2]|0;F=a+96|0;E=c[F>>2]|0;if(G>>>0<H>>>0){if(E)VJa(e,E);e=UJa(f,H,481328,256)|0;c[F>>2]=e;c[d>>2]=H;O=e;P=H}else{O=E;P=G}c[h>>2]=O;c[h+4>>2]=P;c[h+8>>2]=O;c[h+12>>2]=0;K=ea(g[l>>2]);Q=ea(g[a+84>>2]);koa(j,c[m>>2]|0,c[n>>2]|0,K,Q,c[k>>2]|0,c[a+92>>2]|0,h,c[a+72>>2]|0);moa(j);i=b;return}function Goa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+20|0;f=c[e>>2]|0;g=c[f+72>>2]|0;if(!g)h=f;else{j=g+8|0;g=f;En[c[(c[j>>2]|0)+16>>2]&127](j,b[f+76>>1]|0,g,((g|0)<0)<<31>>31,g);h=c[e>>2]|0}e=c[h+32>>2]|0;g=c[h+36>>2]|0;h=e+(g*40|0)|0;if(!g){i=d;return}g=a+12|0;a=e;do{e=c[a+20>>2]|0;if((c[e+524>>2]|0)>>>0<(c[e+516>>2]|0)>>>0){e=c[g>>2]|0;c[a+16>>2]=1;f=a+12|0;c[f>>2]=e;if(e){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[a+8>>2]=c[(c[f>>2]|0)+8>>2]}ko[c[(c[a>>2]|0)+20>>2]&4095](a)}a=a+40|0}while((a|0)!=(h|0));i=d;return}function Hoa(a){a=a|0;return 481408}function Ioa(a){a=a|0;var d=0,e=0,f=0;d=i;e=a+20|0;Foa(c[e>>2]|0);a=c[e>>2]|0;e=c[a+72>>2]|0;if(!e){i=d;return}f=e+8|0;e=a;En[c[(c[f>>2]|0)+20>>2]&127](f,b[a+76>>1]|0,e,((e|0)<0)<<31>>31,e);i=d;return}function Joa(a){a=a|0;return 481448}function Koa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im;b=i;i=i+1072|0;d=b;e=b+1056|0;f=b+320|0;h=b+256|0;j=a+20|0;k=Qoa(c[j>>2]|0)|0;l=a+28|0;if((c[l>>2]|0)>>>0<k>>>0){m=a+32|0;Sla(c[m>>2]|0);c[m>>2]=Rla(k)|0;c[l>>2]=k}k=a+24|0;n=ea(g[(c[k>>2]|0)+24>>2]);if(n==ea(0.0)){i=b;return}Z_a(h,c[j>>2]|0,n);g[a+36>>2]=ea(g[h+4>>2]);m=c[j>>2]|0;j=c[(c[(c[k>>2]|0)+20>>2]|0)+72>>2]|0;k=c[a+32>>2]|0;a=c[l>>2]|0;Fma(d,m,c[m+4>>2]|0);c[e>>2]=k;c[e+4>>2]=a;c[e+8>>2]=k;c[e+12>>2]=0;Noa(f,m,d,e,h,j);Ooa(f);Kma(f+12|0);Gma(d,m);i=b;return}function Loa(a){a=a|0;return 481536}function Moa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+64|0;d=b+48|0;e=c[a+20>>2]|0;f=e+284|0;g=e+288|0;h=c[g>>2]|0;if(h){j=e+272|0;k=c[j>>2]|0;c[j>>2]=c[f>>2];c[f>>2]=k;k=e+276|0;j=c[k>>2]|0;c[k>>2]=h;c[g>>2]=j;j=e+280|0;g=e+292|0;h=c[j>>2]|0;c[j>>2]=c[g>>2];c[g>>2]=h;t_a(f,0,d)}f=e+320|0;h=e+324|0;g=c[h>>2]|0;if(g){j=e+308|0;k=c[j>>2]|0;c[j>>2]=c[f>>2];c[f>>2]=k;k=e+312|0;j=c[k>>2]|0;c[k>>2]=g;c[h>>2]=j;j=e+316|0;h=e+328|0;g=c[j>>2]|0;c[j>>2]=c[h>>2];c[h>>2]=g;t_a(f,0,d)}d=e+368|0;f=e+372|0;g=c[f>>2]|0;if(g){h=e+356|0;j=c[h>>2]|0;c[h>>2]=c[d>>2];c[d>>2]=j;j=e+360|0;h=c[j>>2]|0;c[j>>2]=g;c[f>>2]=h;h=e+364|0;f=e+376|0;g=c[h>>2]|0;c[h>>2]=c[f>>2];c[f>>2]=g;t_a(d,0,b+32|0)}d=e+404|0;g=e+408|0;f=c[g>>2]|0;if(f){h=e+392|0;j=c[h>>2]|0;c[h>>2]=c[d>>2];c[d>>2]=j;j=e+396|0;h=c[j>>2]|0;c[j>>2]=f;c[g>>2]=h;h=e+400|0;g=e+412|0;f=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=f;t_a(d,0,b+16|0)}d=e+428|0;f=e+432|0;g=c[f>>2]|0;if(!g){l=a+24|0;m=c[l>>2]|0;n=c[m>>2]|0;o=n+20|0;p=c[o>>2]|0;ko[p&4095](m);i=b;return}h=e+416|0;j=c[h>>2]|0;c[h>>2]=c[d>>2];c[d>>2]=j;j=e+420|0;h=c[j>>2]|0;c[j>>2]=g;c[f>>2]=h;h=e+424|0;f=e+436|0;e=c[h>>2]|0;c[h>>2]=c[f>>2];c[f>>2]=e;__a(d,0,b);l=a+24|0;m=c[l>>2]|0;n=c[m>>2]|0;o=n+20|0;p=c[o>>2]|0;ko[p&4095](m);i=b;return}function Noa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=e;Ima(a+12|0,d,e,g);qoa(a+460|0,d,e);$_a(a+524|0,f,b);c[a+732>>2]=g;i=h;return}function Ooa(a){a=a|0;var b=0;b=i;Poa(a);i=b;return}function Poa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+524|0;if(!(c[d>>2]|0)){i=b;return}e=a+12|0;f=a+460|0;do{Roa(a);Uoa(a);Soa(a);Toa(a);Voa(a);Mma(e,d);soa(f);Woa(a);a$a(d)}while((c[d>>2]|0)!=0);i=b;return}function Qoa(a){a=a|0;var b=0,c=0,d=0,e=0;b=i;c=Vma(a)|0;d=toa(a)|0;e=(Wma(a)|0)+1024+(c>>>0<d>>>0?d:c)|0;i=b;return e|0}function Roa(a){a=a|0;var b=0,d=0,e=0,f=0,h=Im,j=Im,l=0,m=0,n=0,o=0;b=i;i=i+64|0;d=b+40|0;e=b;f=c[(c[a+4>>2]|0)+140>>2]|0;h=ea(g[a+532>>2]);j=ea(h*h);l=(g[k>>2]=j,c[k>>2]|0);if(!f){c[d>>2]=c[a+588>>2];c[d+4>>2]=c[a+592>>2];c[d+8>>2]=c[a+596>>2];c[d+12>>2]=c[a+600>>2];b$a(a,d,a+604|0);i=b;return}else{d=c[120507]&l;m=c[120506]&l;n=c[120505]&l;o=c[120504]&l;c[e>>2]=f;c[e+4>>2]=o;c[e+8>>2]=n;c[e+12>>2]=m;c[e+16>>2]=d;c[e+20>>2]=c[a+588>>2];c[e+24>>2]=c[a+592>>2];c[e+28>>2]=c[a+596>>2];c[e+32>>2]=c[a+600>>2];c$a(a,e,a+604|0);i=b;return}}function Soa(a){a=a|0;var b=0,d=0,f=Im,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im;b=i;d=c[a+4>>2]|0;f=ea(g[d+112>>2]);if(f==ea(0.0)){i=b;return}a=c[d+108>>2]|0;if(!a){i=b;return}h=c[d>>2]|0;j=c[d+4>>2]|0;l=h<<2;m=j+(l<<2)|0;n=c[d+104>>2]|0;o=n+(a<<3)|0;p=ea(ea(f*ea(h>>>0))/ea(a>>>0));a=(g[k>>2]=p,c[k>>2]|0);p=ea(g[d+116>>2]);if(!l){i=b;return}f=(c[k>>2]=a&c[120504],ea(g[k>>2]));q=(c[k>>2]=a&c[120505],ea(g[k>>2]));r=(c[k>>2]=a&c[120506],ea(g[k>>2]));s=(c[k>>2]=a&c[120507],ea(g[k>>2]));a=j;l=n;while(1){t=ea(g[a>>2]);n=a+4|0;u=ea(g[n>>2]);d=a+8|0;v=ea(g[d>>2]);w=a+12|0;x=ea(g[w>>2]);if(l>>>0<o>>>0){y=ea(g[120512]);z=ea(g[120513]);A=ea(g[120514]);B=ea(g[120515]);C=ea(0.0);D=ea(0.0);E=ea(0.0);F=ea(0.0);G=l;while(1){H=(e[G>>1]|0)<<4;I=ea(g[j+H>>2]);J=ea(g[j+(H|4)>>2]);K=ea(g[j+(H|8)>>2]);L=ea(I-t);I=ea(J-u);J=ea(K-v);K=ea(ea(g[j+(H|12)>>2])-x);M=ea(ea(ea(L*L)+ea(I*I))+ea(J*J));N=ea(y+M);O=ea(M+z);P=ea(M+A);Q=ea(M+B);M=ea(p*ea(g[G+4>>2]));R=ea(ea(1.0)-ea(M*ea(ea(1.0)/ea(T(ea(N))))));N=ea(ea(1.0)-ea(M*ea(ea(1.0)/ea(T(ea(O))))));O=ea(ea(1.0)-ea(M*ea(ea(1.0)/ea(T(ea(P))))));P=ea(ea(1.0)-ea(M*ea(ea(1.0)/ea(T(ea(Q))))));H=R<ea(0.0);Q=H?ea(0.0):R;H=N<ea(0.0);R=H?ea(0.0):N;H=O<ea(0.0);N=H?ea(0.0):O;H=P<ea(0.0);O=ea(C+ea(L*Q));Q=ea(D+ea(I*R));R=ea(E+ea(J*N));N=ea(F+ea(K*(H?ea(0.0):P)));G=G+(h<<3)|0;if(G>>>0>=o>>>0){S=N;U=R;V=Q;W=O;break}else{C=O;D=Q;E=R;F=N}}}else{S=ea(0.0);U=ea(0.0);V=ea(0.0);W=ea(0.0)}F=ea(u+ea(q*V));E=ea(v+ea(r*U));D=ea(x+ea(s*S));g[a>>2]=ea(t+ea(f*W));g[n>>2]=F;g[d>>2]=E;g[w>>2]=D;a=a+16|0;if((a|0)==(m|0))break;else l=l+8|0}i=b;return}function Toa(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,l=0,m=0,n=0,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=Im,da=0,fa=Im,ga=0,ha=Im,ia=0,ja=Im,ka=Im,la=0,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=Im,sa=0,ta=Im,ua=0,va=Im,wa=0,xa=Im,ya=Im,za=0,Aa=Im,Ba=0,Ca=Im,Da=0,Ea=Im,Fa=Im,Ga=0,Ha=Im,Ia=0,Ja=Im,Ka=0,La=Im,Ma=Im,Na=0,Oa=Im,Pa=0,Qa=Im,Ra=0,Sa=Im,Ta=Im,Ua=0,Va=Im,Wa=0,Xa=Im,Ya=0,Za=Im,_a=Im,$a=0,ab=Im,bb=0,cb=Im,db=0,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=Im,Vb=Im,Wb=Im;b=i;d=c[a+4>>2]|0;f=c[d+64>>2]|0;h=c[d+68>>2]|0;j=c[d+72>>2]|0;l=c[d+88>>2]|0;m=c[d+80>>2]|0;n=c[d+96>>2]|0;o=ea(g[(c[a>>2]|0)+144>>2]);p=ea(o*ea(g[a+532>>2]));if((f|0)==(h|0)){i=b;return}a=c[d+4>>2]|0;d=c[120500]|0;q=c[120501]|0;r=c[120502]|0;s=c[120503]|0;t=c[120508]|0;u=c[120510]|0;v=c[120511]|0;w=f;do{f=c[j+((e[w>>1]|0)<<2)>>2]|0;x=c[m+(f<<2)>>2]|0;y=l+(x<<2)|0;z=c[m+(f+1<<2)>>2]|0;f=l+(z<<2)|0;A=n+(x<<1<<1)|0;B=w+4|0;o=ea(g[B>>2]);C=ea(g[B+4>>2]);D=ea(g[B+8>>2]);E=ea(g[B+12>>2]);B=(g[k>>2]=o,c[k>>2]|0);F=(g[k>>2]=C,c[k>>2]|0);G=(g[k>>2]=D,c[k>>2]|0);H=(g[k>>2]=E,c[k>>2]|0);I=ea(ea(1.0)-ea(+aa(+ea(ea(p*o)*ea(.693147182)))));o=ea(ea(1.0)-ea(+aa(+ea(ea(p*C)*ea(.693147182)))));C=ea(ea(1.0)-ea(+aa(+ea(ea(p*D)*ea(.693147182)))));D=ea(ea(1.0)-ea(+aa(+ea(ea(p*E)*ea(.693147182)))));J=(g[k>>2]=I,c[k>>2]|0);K=(g[k>>2]=o,c[k>>2]|0);L=(g[k>>2]=C,c[k>>2]|0);M=d&(J^B)^B;B=q&(K^F)^F;F=r&(L^G)^G;G=s&((g[k>>2]=D,c[k>>2]|0)^H)^H;if((c[k>>2]=t&M,ea(g[k>>2]))==ea(0.0)?(H=(c[k>>2]=c[120509]&B,ea(g[k>>2]))==ea(0.0),L=H&(c[k>>2]=u&F,ea(g[k>>2]))==ea(0.0),L&(c[k>>2]=v&G,ea(g[k>>2]))==ea(0.0)):0){if((x|0)!=(z|0)){D=ea(g[120516]);C=ea(g[120517]);o=ea(g[120518]);I=ea(g[120519]);E=ea(g[120512]);N=ea(g[120513]);O=ea(g[120514]);P=ea(g[120515]);L=c[120504]|0;H=c[120505]|0;K=c[120506]|0;J=c[120507]|0;Q=(c[k>>2]=M,ea(g[k>>2]));R=A;S=y;while(1){U=(e[R>>1]|0)<<4;V=(e[R+2>>1]|0)<<4;W=(e[R+4>>1]|0)<<4;X=(e[R+6>>1]|0)<<4;Y=(e[R+8>>1]|0)<<4;Z=(e[R+10>>1]|0)<<4;_=(e[R+12>>1]|0)<<4;$=(e[R+14>>1]|0)<<4;ba=a+U|0;ca=ea(g[ba>>2]);da=a+(U|4)|0;fa=ea(g[da>>2]);ga=a+(U|8)|0;ha=ea(g[ga>>2]);ia=a+(U|12)|0;ja=ea(g[ia>>2]);U=a+V|0;ka=ea(g[U>>2]);la=a+(V|4)|0;ma=ea(g[la>>2]);na=a+(V|8)|0;oa=ea(g[na>>2]);pa=a+(V|12)|0;qa=ea(g[pa>>2]);V=a+W|0;ra=ea(g[V>>2]);sa=a+(W|4)|0;ta=ea(g[sa>>2]);ua=a+(W|8)|0;va=ea(g[ua>>2]);wa=a+(W|12)|0;xa=ea(g[wa>>2]);W=a+X|0;ya=ea(g[W>>2]);za=a+(X|4)|0;Aa=ea(g[za>>2]);Ba=a+(X|8)|0;Ca=ea(g[Ba>>2]);Da=a+(X|12)|0;Ea=ea(g[Da>>2]);X=a+Y|0;Fa=ea(g[X>>2]);Ga=a+(Y|4)|0;Ha=ea(g[Ga>>2]);Ia=a+(Y|8)|0;Ja=ea(g[Ia>>2]);Ka=a+(Y|12)|0;La=ea(g[Ka>>2]);Y=a+Z|0;Ma=ea(g[Y>>2]);Na=a+(Z|4)|0;Oa=ea(g[Na>>2]);Pa=a+(Z|8)|0;Qa=ea(g[Pa>>2]);Ra=a+(Z|12)|0;Sa=ea(g[Ra>>2]);Z=a+_|0;Ta=ea(g[Z>>2]);Ua=a+(_|4)|0;Va=ea(g[Ua>>2]);Wa=a+(_|8)|0;Xa=ea(g[Wa>>2]);Ya=a+(_|12)|0;Za=ea(g[Ya>>2]);_=a+$|0;_a=ea(g[_>>2]);$a=a+($|4)|0;ab=ea(g[$a>>2]);bb=a+($|8)|0;cb=ea(g[bb>>2]);db=a+($|12)|0;eb=ea(g[db>>2]);fb=ea(ea(D*ca)+ka);gb=ea(ea(C*fa)+ma);hb=ea(ea(o*ha)+oa);ib=ea(ea(I*ja)+qa);jb=ea(ea(D*ra)+ya);kb=ea(ea(C*ta)+Aa);lb=ea(ea(o*va)+Ca);mb=ea(ea(I*xa)+Ea);nb=ea(ea(D*Fa)+Ma);ob=ea(ea(C*Ha)+Oa);pb=ea(ea(o*Ja)+Qa);qb=ea(ea(I*La)+Sa);rb=ea(ea(D*Ta)+_a);sb=ea(ea(C*Va)+ab);tb=ea(ea(o*Xa)+cb);ub=ea(ea(I*Za)+eb);vb=ea(g[S>>2]);wb=ea(g[S+4>>2]);xb=ea(g[S+8>>2]);yb=ea(g[S+12>>2]);zb=ea(ea(1.0)-ea(vb*ea(ea(1.0)/ea(T(ea(ea(hb*hb)+ea(ea(gb*gb)+ea(E+ea(fb*fb)))))))));Ab=ea(ea(1.0)-ea(wb*ea(ea(1.0)/ea(T(ea(ea(lb*lb)+ea(ea(kb*kb)+ea(N+ea(jb*jb)))))))));Bb=ea(ea(1.0)-ea(xb*ea(ea(1.0)/ea(T(ea(ea(pb*pb)+ea(ea(ob*ob)+ea(O+ea(nb*nb)))))))));Cb=ea(ea(1.0)-ea(yb*ea(ea(1.0)/ea(T(ea(ea(tb*tb)+ea(ea(sb*sb)+ea(P+ea(rb*rb)))))))));Db=ea(Q*(vb>E?zb:ea(0.0)));zb=ea(Q*(wb>N?Ab:ea(0.0)));Ab=ea(Q*(xb>O?Bb:ea(0.0)));Bb=ea(Db*ea(ea(1.0)/ea(E+ib)));Db=ea(zb*ea(ea(1.0)/ea(N+mb)));zb=ea(Ab*ea(ea(1.0)/ea(O+qb)));Ab=ea(ea(Q*(yb>P?Cb:ea(0.0)))*ea(ea(1.0)/ea(P+ub)));Cb=ea(fb*Bb);fb=ea(gb*Bb);gb=ea(hb*Bb);hb=ea(ib*Bb);$=(g[k>>2]=Cb,c[k>>2]|0);Eb=(g[k>>2]=fb,c[k>>2]|0);Fb=(g[k>>2]=gb,c[k>>2]|0);Gb=(g[k>>2]=hb,c[k>>2]|0)&J;hb=ea(jb*Db);jb=ea(kb*Db);kb=ea(lb*Db);lb=ea(mb*Db);Hb=(g[k>>2]=hb,c[k>>2]|0);Ib=(g[k>>2]=jb,c[k>>2]|0);Jb=(g[k>>2]=kb,c[k>>2]|0);Kb=(g[k>>2]=lb,c[k>>2]|0)&J;lb=ea(nb*zb);nb=ea(ob*zb);ob=ea(pb*zb);pb=ea(qb*zb);Lb=(g[k>>2]=lb,c[k>>2]|0);Mb=(g[k>>2]=nb,c[k>>2]|0);Nb=(g[k>>2]=ob,c[k>>2]|0);Ob=(g[k>>2]=pb,c[k>>2]|0)&J;pb=ea(rb*Ab);rb=ea(sb*Ab);sb=ea(tb*Ab);tb=ea(ub*Ab);Pb=(g[k>>2]=pb,c[k>>2]|0);Qb=(g[k>>2]=rb,c[k>>2]|0);Rb=(g[k>>2]=sb,c[k>>2]|0);Sb=(g[k>>2]=tb,c[k>>2]|0)&J;tb=(c[k>>2]=$&L,ea(g[k>>2]));sb=ea(ja*tb);rb=(c[k>>2]=Eb&H,ea(g[k>>2]));pb=ea(ja*rb);Ab=(c[k>>2]=Fb&K,ea(g[k>>2]));ub=ea(ja*Ab);ob=(c[k>>2]=Gb,ea(g[k>>2]));nb=ea(fa+pb);pb=ea(ha+ub);ub=ea(ja+ea(ja*ob));g[ba>>2]=ea(ca+sb);g[da>>2]=nb;g[ga>>2]=pb;g[ia>>2]=ub;ub=ea(ma-ea(qa*rb));rb=ea(oa-ea(qa*Ab));Ab=ea(qa-ea(qa*ob));g[U>>2]=ea(ka-ea(qa*tb));g[la>>2]=ub;g[na>>2]=rb;g[pa>>2]=Ab;Ab=(c[k>>2]=Hb&L,ea(g[k>>2]));rb=ea(xa*Ab);ub=(c[k>>2]=Ib&H,ea(g[k>>2]));tb=ea(xa*ub);qa=(c[k>>2]=Jb&K,ea(g[k>>2]));ka=ea(xa*qa);ob=(c[k>>2]=Kb,ea(g[k>>2]));oa=ea(ta+tb);tb=ea(va+ka);ka=ea(xa+ea(xa*ob));g[V>>2]=ea(ra+rb);g[sa>>2]=oa;g[ua>>2]=tb;g[wa>>2]=ka;ka=ea(Aa-ea(Ea*ub));ub=ea(Ca-ea(Ea*qa));qa=ea(Ea-ea(Ea*ob));g[W>>2]=ea(ya-ea(Ea*Ab));g[za>>2]=ka;g[Ba>>2]=ub;g[Da>>2]=qa;qa=(c[k>>2]=Lb&L,ea(g[k>>2]));ub=ea(La*qa);ka=(c[k>>2]=Mb&H,ea(g[k>>2]));Ab=ea(La*ka);Ea=(c[k>>2]=Nb&K,ea(g[k>>2]));ya=ea(La*Ea);ob=(c[k>>2]=Ob,ea(g[k>>2]));Ca=ea(Ha+Ab);Ab=ea(Ja+ya);ya=ea(La+ea(La*ob));g[X>>2]=ea(Fa+ub);g[Ga>>2]=Ca;g[Ia>>2]=Ab;g[Ka>>2]=ya;ya=ea(Oa-ea(Sa*ka));ka=ea(Qa-ea(Sa*Ea));Ea=ea(Sa-ea(Sa*ob));g[Y>>2]=ea(Ma-ea(Sa*qa));g[Na>>2]=ya;g[Pa>>2]=ka;g[Ra>>2]=Ea;Ea=(c[k>>2]=Pb&L,ea(g[k>>2]));ka=ea(Za*Ea);ya=(c[k>>2]=Qb&H,ea(g[k>>2]));qa=ea(Za*ya);Sa=(c[k>>2]=Rb&K,ea(g[k>>2]));Ma=ea(Za*Sa);ob=(c[k>>2]=Sb,ea(g[k>>2]));Qa=ea(Va+qa);qa=ea(Xa+Ma);Ma=ea(Za+ea(Za*ob));g[Z>>2]=ea(Ta+ka);g[Ua>>2]=Qa;g[Wa>>2]=qa;g[Ya>>2]=Ma;Ma=ea(ab-ea(eb*ya));ya=ea(cb-ea(eb*Sa));Sa=ea(eb-ea(eb*ob));g[_>>2]=ea(_a-ea(eb*Ea));g[$a>>2]=Ma;g[bb>>2]=ya;g[db>>2]=Sa;S=S+16|0;if((S|0)==(f|0))break;else R=R+16|0}}}else Tb=8;if((Tb|0)==8?(Tb=0,P=(c[k>>2]=G,ea(g[k>>2])),Q=(c[k>>2]=F,ea(g[k>>2])),O=(c[k>>2]=B,ea(g[k>>2])),(x|0)!=(z|0)):0){N=ea(g[120516]);E=ea(g[120517]);I=ea(g[120518]);o=ea(g[120519]);C=ea(g[120512]);D=ea(g[120513]);Sa=ea(g[120514]);ya=ea(g[120515]);R=c[120504]|0;S=c[120505]|0;K=c[120506]|0;H=c[120507]|0;Ma=(c[k>>2]=M,ea(g[k>>2]));L=A;J=y;while(1){db=(e[L>>1]|0)<<4;bb=(e[L+2>>1]|0)<<4;$a=(e[L+4>>1]|0)<<4;_=(e[L+6>>1]|0)<<4;Ya=(e[L+8>>1]|0)<<4;Wa=(e[L+10>>1]|0)<<4;Ua=(e[L+12>>1]|0)<<4;Z=(e[L+14>>1]|0)<<4;Sb=a+db|0;Ea=ea(g[Sb>>2]);Rb=a+(db|4)|0;eb=ea(g[Rb>>2]);Qb=a+(db|8)|0;_a=ea(g[Qb>>2]);Pb=a+(db|12)|0;ob=ea(g[Pb>>2]);db=a+bb|0;cb=ea(g[db>>2]);Ra=a+(bb|4)|0;ab=ea(g[Ra>>2]);Pa=a+(bb|8)|0;qa=ea(g[Pa>>2]);Na=a+(bb|12)|0;Qa=ea(g[Na>>2]);bb=a+$a|0;ka=ea(g[bb>>2]);Y=a+($a|4)|0;Ta=ea(g[Y>>2]);Ka=a+($a|8)|0;Za=ea(g[Ka>>2]);Ia=a+($a|12)|0;Xa=ea(g[Ia>>2]);$a=a+_|0;Va=ea(g[$a>>2]);Ga=a+(_|4)|0;Oa=ea(g[Ga>>2]);X=a+(_|8)|0;Ab=ea(g[X>>2]);Ob=a+(_|12)|0;Ca=ea(g[Ob>>2]);_=a+Ya|0;ub=ea(g[_>>2]);Nb=a+(Ya|4)|0;Fa=ea(g[Nb>>2]);Mb=a+(Ya|8)|0;La=ea(g[Mb>>2]);Lb=a+(Ya|12)|0;Ja=ea(g[Lb>>2]);Ya=a+Wa|0;Ha=ea(g[Ya>>2]);Da=a+(Wa|4)|0;Aa=ea(g[Da>>2]);Ba=a+(Wa|8)|0;tb=ea(g[Ba>>2]);za=a+(Wa|12)|0;oa=ea(g[za>>2]);Wa=a+Ua|0;rb=ea(g[Wa>>2]);W=a+(Ua|4)|0;ra=ea(g[W>>2]);wa=a+(Ua|8)|0;xa=ea(g[wa>>2]);ua=a+(Ua|12)|0;va=ea(g[ua>>2]);Ua=a+Z|0;ta=ea(g[Ua>>2]);sa=a+(Z|4)|0;ma=ea(g[sa>>2]);V=a+(Z|8)|0;pb=ea(g[V>>2]);Kb=a+(Z|12)|0;nb=ea(g[Kb>>2]);sb=ea(ea(N*Ea)+cb);ca=ea(ea(E*eb)+ab);ja=ea(ea(I*_a)+qa);ha=ea(ea(o*ob)+Qa);fa=ea(ea(N*ka)+Va);lb=ea(ea(E*Ta)+Oa);zb=ea(ea(I*Za)+Ab);qb=ea(ea(o*Xa)+Ca);kb=ea(ea(N*ub)+Ha);jb=ea(ea(E*Fa)+Aa);hb=ea(ea(I*La)+tb);Db=ea(ea(o*Ja)+oa);mb=ea(ea(N*rb)+ta);gb=ea(ea(E*ra)+ma);fb=ea(ea(I*xa)+pb);Cb=ea(ea(o*va)+nb);Bb=ea(g[J>>2]);ib=ea(g[J+4>>2]);yb=ea(g[J+8>>2]);xb=ea(g[J+12>>2]);wb=ea(ea(1.0)-ea(Bb*ea(ea(1.0)/ea(T(ea(ea(ja*ja)+ea(ea(ca*ca)+ea(C+ea(sb*sb)))))))));vb=ea(ea(1.0)-ea(ib*ea(ea(1.0)/ea(T(ea(ea(zb*zb)+ea(ea(lb*lb)+ea(D+ea(fa*fa)))))))));Ub=ea(ea(1.0)-ea(yb*ea(ea(1.0)/ea(T(ea(ea(hb*hb)+ea(ea(jb*jb)+ea(Sa+ea(kb*kb)))))))));Vb=ea(ea(1.0)-ea(xb*ea(ea(1.0)/ea(T(ea(ea(fb*fb)+ea(ea(gb*gb)+ea(ya+ea(mb*mb)))))))));Wb=Bb>C?wb:ea(0.0);wb=P<Wb?P:Wb;Bb=ib>D?vb:ea(0.0);vb=P<Bb?P:Bb;ib=yb>Sa?Ub:ea(0.0);Ub=P<ib?P:ib;yb=xb>ya?Vb:ea(0.0);Vb=P<yb?P:yb;xb=ea(ea(ea(1.0)/ea(C+ha))*ea(Ma*ea(Wb-ea(O*(Q<wb?wb:Q)))));wb=ea(ea(ea(1.0)/ea(D+qb))*ea(Ma*ea(Bb-ea(O*(Q<vb?vb:Q)))));vb=ea(ea(ea(1.0)/ea(Sa+Db))*ea(Ma*ea(ib-ea(O*(Q<Ub?Ub:Q)))));Ub=ea(ea(ea(1.0)/ea(ya+Cb))*ea(Ma*ea(yb-ea(O*(Q<Vb?Vb:Q)))));Vb=ea(sb*xb);sb=ea(ca*xb);ca=ea(ja*xb);ja=ea(ha*xb);Z=(g[k>>2]=Vb,c[k>>2]|0);Jb=(g[k>>2]=sb,c[k>>2]|0);Ib=(g[k>>2]=ca,c[k>>2]|0);Hb=(g[k>>2]=ja,c[k>>2]|0)&H;ja=ea(fa*wb);fa=ea(lb*wb);lb=ea(zb*wb);zb=ea(qb*wb);pa=(g[k>>2]=ja,c[k>>2]|0);na=(g[k>>2]=fa,c[k>>2]|0);la=(g[k>>2]=lb,c[k>>2]|0);U=(g[k>>2]=zb,c[k>>2]|0)&H;zb=ea(kb*vb);kb=ea(jb*vb);jb=ea(hb*vb);hb=ea(Db*vb);ia=(g[k>>2]=zb,c[k>>2]|0);ga=(g[k>>2]=kb,c[k>>2]|0);da=(g[k>>2]=jb,c[k>>2]|0);ba=(g[k>>2]=hb,c[k>>2]|0)&H;hb=ea(mb*Ub);mb=ea(gb*Ub);gb=ea(fb*Ub);fb=ea(Cb*Ub);Gb=(g[k>>2]=hb,c[k>>2]|0);Fb=(g[k>>2]=mb,c[k>>2]|0);Eb=(g[k>>2]=gb,c[k>>2]|0);$=(g[k>>2]=fb,c[k>>2]|0)&H;fb=(c[k>>2]=Z&R,ea(g[k>>2]));gb=ea(ob*fb);mb=(c[k>>2]=Jb&S,ea(g[k>>2]));hb=ea(ob*mb);Ub=(c[k>>2]=Ib&K,ea(g[k>>2]));Cb=ea(ob*Ub);jb=(c[k>>2]=Hb,ea(g[k>>2]));kb=ea(eb+hb);hb=ea(_a+Cb);Cb=ea(ob+ea(ob*jb));g[Sb>>2]=ea(Ea+gb);g[Rb>>2]=kb;g[Qb>>2]=hb;g[Pb>>2]=Cb;Cb=ea(ab-ea(Qa*mb));mb=ea(qa-ea(Qa*Ub));Ub=ea(Qa-ea(Qa*jb));g[db>>2]=ea(cb-ea(Qa*fb));g[Ra>>2]=Cb;g[Pa>>2]=mb;g[Na>>2]=Ub;Ub=(c[k>>2]=pa&R,ea(g[k>>2]));mb=ea(Xa*Ub);Cb=(c[k>>2]=na&S,ea(g[k>>2]));fb=ea(Xa*Cb);Qa=(c[k>>2]=la&K,ea(g[k>>2]));cb=ea(Xa*Qa);jb=(c[k>>2]=U,ea(g[k>>2]));qa=ea(Ta+fb);fb=ea(Za+cb);cb=ea(Xa+ea(Xa*jb));g[bb>>2]=ea(ka+mb);g[Y>>2]=qa;g[Ka>>2]=fb;g[Ia>>2]=cb;cb=ea(Oa-ea(Ca*Cb));Cb=ea(Ab-ea(Ca*Qa));Qa=ea(Ca-ea(Ca*jb));g[$a>>2]=ea(Va-ea(Ca*Ub));g[Ga>>2]=cb;g[X>>2]=Cb;g[Ob>>2]=Qa;Qa=(c[k>>2]=ia&R,ea(g[k>>2]));Cb=ea(Ja*Qa);cb=(c[k>>2]=ga&S,ea(g[k>>2]));Ub=ea(Ja*cb);Ca=(c[k>>2]=da&K,ea(g[k>>2]));Va=ea(Ja*Ca);jb=(c[k>>2]=ba,ea(g[k>>2]));Ab=ea(Fa+Ub);Ub=ea(La+Va);Va=ea(Ja+ea(Ja*jb));g[_>>2]=ea(ub+Cb);g[Nb>>2]=Ab;g[Mb>>2]=Ub;g[Lb>>2]=Va;Va=ea(Aa-ea(oa*cb));cb=ea(tb-ea(oa*Ca));Ca=ea(oa-ea(oa*jb));g[Ya>>2]=ea(Ha-ea(oa*Qa));g[Da>>2]=Va;g[Ba>>2]=cb;g[za>>2]=Ca;Ca=(c[k>>2]=Gb&R,ea(g[k>>2]));cb=ea(va*Ca);Va=(c[k>>2]=Fb&S,ea(g[k>>2]));Qa=ea(va*Va);oa=(c[k>>2]=Eb&K,ea(g[k>>2]));Ha=ea(va*oa);jb=(c[k>>2]=$,ea(g[k>>2]));tb=ea(ra+Qa);Qa=ea(xa+Ha);Ha=ea(va+ea(va*jb));g[Wa>>2]=ea(rb+cb);g[W>>2]=tb;g[wa>>2]=Qa;g[ua>>2]=Ha;Ha=ea(ma-ea(nb*Va));Va=ea(pb-ea(nb*oa));oa=ea(nb-ea(nb*jb));g[Ua>>2]=ea(ta-ea(nb*Ca));g[sa>>2]=Ha;g[V>>2]=Va;g[Kb>>2]=oa;J=J+16|0;if((J|0)==(f|0))break;else L=L+16|0}}w=w+20|0}while((w|0)!=(h|0));i=b;return}function Uoa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,l=0,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;b=i;d=c[a+4>>2]|0;e=c[d+120>>2]|0;if(!e){i=b;return}f=c[d+4>>2]|0;h=f+(c[d>>2]<<4)|0;j=c[d+124>>2]|0;l=(c[a>>2]|0)+296|0;m=ea(g[l>>2]);n=ea(g[l+4>>2]);o=ea(g[l+12>>2]);l=(g[k>>2]=m,c[k>>2]|0);p=(g[k>>2]=n,c[k>>2]|0);q=(g[k>>2]=o,c[k>>2]|0);o=ea(g[d+128>>2]);d=(g[k>>2]=o,c[k>>2]|0);r=c[120504]|0;s=c[120505]|0;t=c[120507]|0;u=(d^l)&r^d;l=s&(d^p)^d;p=t&(d^q)^d;if(!j){o=(c[k>>2]=u,ea(g[k>>2]));n=(c[k>>2]=l,ea(g[k>>2]));d$a(f,h,e,o,n,(c[k>>2]=p,ea(g[k>>2])));i=b;return}d=c[a+524>>2]|0;if((d|0)==1){n=(c[k>>2]=u,ea(g[k>>2]));o=(c[k>>2]=l,ea(g[k>>2]));d$a(f,h,j,n,o,(c[k>>2]=p,ea(g[k>>2])));i=b;return}o=ea(g[a+528>>2]);n=(c[k>>2]=u,ea(g[k>>2]));m=(c[k>>2]=l,ea(g[k>>2]));v=(c[k>>2]=p,ea(g[k>>2]));if(f>>>0>=h>>>0){i=b;return}w=ea(o+ea(ea(1.0)-ea(ea(d>>>0)*o)));d=f;f=r;r=s;s=t;t=j;j=e;while(1){e=c[d>>2]|0;p=d+4|0;l=c[p>>2]|0;u=d+8|0;a=c[u>>2]|0;q=d+12|0;x=c[q>>2]|0;y=d+16|0;z=c[y>>2]|0;A=d+20|0;B=c[A>>2]|0;C=d+24|0;D=c[C>>2]|0;E=d+28|0;F=c[E>>2]|0;G=d+32|0;H=c[G>>2]|0;I=d+36|0;J=c[I>>2]|0;K=d+40|0;L=c[K>>2]|0;M=d+44|0;N=c[M>>2]|0;O=d+48|0;P=c[O>>2]|0;Q=d+52|0;R=c[Q>>2]|0;S=d+56|0;U=c[S>>2]|0;V=d+60|0;W=c[V>>2]|0;o=ea(g[t>>2]);X=ea(g[j>>2]);Y=ea(o-X);o=ea(g[t+4>>2]);Z=ea(g[j+4>>2]);_=ea(o-Z);o=ea(g[t+8>>2]);$=ea(g[j+8>>2]);aa=ea(o-$);o=ea(g[t+12>>2]);ba=ea(g[j+12>>2]);ca=ea(X+ea(w*Y));Y=ea(Z+ea(w*_));_=ea($+ea(w*aa));aa=ea(ba+ea(w*ea(o-ba)));da=c[120506]|0;ba=ea(ca-(c[k>>2]=f&e,ea(g[k>>2])));ca=ea(Y-(c[k>>2]=r&l,ea(g[k>>2])));Y=ea(_-(c[k>>2]=da&a,ea(g[k>>2])));_=ea(aa-(c[k>>2]=s&x,ea(g[k>>2])));aa=ea(g[t+16>>2]);o=ea(g[j+16>>2]);$=ea(aa-o);aa=ea(g[t+20>>2]);Z=ea(g[j+20>>2]);X=ea(aa-Z);aa=ea(g[t+24>>2]);fa=ea(g[j+24>>2]);ga=ea(aa-fa);aa=ea(g[t+28>>2]);ha=ea(g[j+28>>2]);ia=ea(o+ea(w*$));$=ea(Z+ea(w*X));X=ea(fa+ea(w*ga));ga=ea(ha+ea(w*ea(aa-ha)));ha=ea(ia-(c[k>>2]=f&z,ea(g[k>>2])));ia=ea($-(c[k>>2]=r&B,ea(g[k>>2])));$=ea(X-(c[k>>2]=da&D,ea(g[k>>2])));X=ea(ga-(c[k>>2]=s&F,ea(g[k>>2])));ga=ea(g[t+32>>2]);aa=ea(g[j+32>>2]);fa=ea(ga-aa);ga=ea(g[t+36>>2]);Z=ea(g[j+36>>2]);o=ea(ga-Z);ga=ea(g[t+40>>2]);ja=ea(g[j+40>>2]);ka=ea(ga-ja);ga=ea(g[t+44>>2]);la=ea(g[j+44>>2]);ma=ea(aa+ea(w*fa));fa=ea(Z+ea(w*o));o=ea(ja+ea(w*ka));ka=ea(la+ea(w*ea(ga-la)));la=ea(ma-(c[k>>2]=f&H,ea(g[k>>2])));ma=ea(fa-(c[k>>2]=r&J,ea(g[k>>2])));fa=ea(o-(c[k>>2]=da&L,ea(g[k>>2])));o=ea(ka-(c[k>>2]=s&N,ea(g[k>>2])));ka=ea(g[t+48>>2]);ga=ea(g[j+48>>2]);ja=ea(ka-ga);ka=ea(g[t+52>>2]);Z=ea(g[j+52>>2]);aa=ea(ka-Z);ka=ea(g[t+56>>2]);na=ea(g[j+56>>2]);oa=ea(ka-na);ka=ea(g[t+60>>2]);pa=ea(g[j+60>>2]);qa=ea(ga+ea(w*ja));ja=ea(Z+ea(w*aa));aa=ea(na+ea(w*oa));oa=ea(pa+ea(w*ea(ka-pa)));pa=ea(qa-(c[k>>2]=f&P,ea(g[k>>2])));qa=ea(ja-(c[k>>2]=r&R,ea(g[k>>2])));ja=ea(aa-(c[k>>2]=da&U,ea(g[k>>2])));aa=ea(oa-(c[k>>2]=s&W,ea(g[k>>2])));oa=ea(ba*ba);ka=ea(ha*ha);na=ea(la*la);Z=ea(pa*pa);ga=ea(oa+ea(g[120512]));oa=ea(ka+ea(g[120513]));ka=ea(na+ea(g[120514]));na=ea(ea(Y*Y)+ea(ea(ca*ca)+ga));ga=ea(ea($*$)+ea(ea(ia*ia)+oa));oa=ea(ea(fa*fa)+ea(ea(ma*ma)+ka));ka=ea(ea(ja*ja)+ea(ea(qa*qa)+ea(Z+ea(g[120515]))));Z=ea(m+ea(n*_));ra=ea(m+ea(n*X));sa=ea(m+ea(n*o));ta=ea(m+ea(n*aa));ua=Z>ea(0.0);va=ua?Z:ea(0.0);ua=ra>ea(0.0);Z=ua?ra:ea(0.0);ua=sa>ea(0.0);ra=ua?sa:ea(0.0);ua=ta>ea(0.0);sa=ua?ta:ea(0.0);ta=ea(ea(1.0)-ea(va*ea(ea(1.0)/ea(T(ea(na))))));na=ea(ea(1.0)-ea(Z*ea(ea(1.0)/ea(T(ea(ga))))));ga=ea(ea(1.0)-ea(ra*ea(ea(1.0)/ea(T(ea(oa))))));oa=ea(ea(1.0)-ea(sa*ea(ea(1.0)/ea(T(ea(ka))))));ua=ta>ea(0.0);wa=na>ea(0.0);xa=ga>ea(0.0);ya=oa>ea(0.0);if(ua|wa|xa|ya){za=(g[k>>2]=aa,c[k>>2]|0);Aa=(g[k>>2]=fa,c[k>>2]|0);Ba=(g[k>>2]=ia,c[k>>2]|0);Ca=(g[k>>2]=ba,c[k>>2]|0);Da=(g[k>>2]=ja,c[k>>2]|0);Ea=(g[k>>2]=qa,c[k>>2]|0);Fa=(g[k>>2]=ma,c[k>>2]|0);Ga=(g[k>>2]=pa,c[k>>2]|0);Ha=(g[k>>2]=la,c[k>>2]|0);Ia=(g[k>>2]=ha,c[k>>2]|0);Ja=(g[k>>2]=o,c[k>>2]|0);Ka=(g[k>>2]=X,c[k>>2]|0);La=(g[k>>2]=$,c[k>>2]|0);Ma=(g[k>>2]=_,c[k>>2]|0);Na=(g[k>>2]=Y,c[k>>2]|0);Oa=(g[k>>2]=ca,c[k>>2]|0);ca=ea(g[120524]);Y=ea(g[120525]);_=ea(g[120526]);$=ea(g[120527]);Pa=va>ca;Qa=Z>Y;Ra=ra>_;X=ea(v*ta);ta=ea(v*na);na=ea(v*ga);ga=ea(v*oa);oa=ua?X:ea(0.0);X=ea((c[k>>2]=Ca&f,ea(g[k>>2]))*oa);o=ea((c[k>>2]=Oa&r,ea(g[k>>2]))*oa);ha=ea((c[k>>2]=Na&da,ea(g[k>>2]))*oa);la=ea((c[k>>2]=Ma&s,ea(g[k>>2]))*oa);oa=(c[k>>2]=e,ea(g[k>>2]));pa=ea(X+(Pa?oa:ea(0.0)));oa=(c[k>>2]=l,ea(g[k>>2]));X=ea(o+(va>Y?oa:ea(0.0)));oa=(c[k>>2]=a,ea(g[k>>2]));o=ea(ha+(va>_?oa:ea(0.0)));oa=(c[k>>2]=x,ea(g[k>>2]));ha=ea(la+(va>$?oa:ea(0.0)));oa=ea(pa);pa=ea(X);X=ea(o);o=ea(ha);g[d>>2]=oa;g[p>>2]=pa;g[u>>2]=X;g[q>>2]=o;o=wa?ta:ea(0.0);ta=ea(o*(c[k>>2]=c[120504]&Ia,ea(g[k>>2])));X=ea(o*(c[k>>2]=c[120505]&Ba,ea(g[k>>2])));pa=ea(o*(c[k>>2]=c[120506]&La,ea(g[k>>2])));oa=ea(o*(c[k>>2]=c[120507]&Ka,ea(g[k>>2])));o=(c[k>>2]=z,ea(g[k>>2]));ha=ea((Z>ca?o:ea(0.0))+ta);ta=(c[k>>2]=B,ea(g[k>>2]));o=ea((Qa?ta:ea(0.0))+X);X=(c[k>>2]=D,ea(g[k>>2]));ta=ea((Z>_?X:ea(0.0))+pa);pa=(c[k>>2]=F,ea(g[k>>2]));X=ea((Z>$?pa:ea(0.0))+oa);oa=ea(ha);ha=ea(o);o=ea(ta);ta=ea(X);g[y>>2]=oa;g[A>>2]=ha;g[C>>2]=o;g[E>>2]=ta;ta=xa?na:ea(0.0);na=ea(ta*(c[k>>2]=c[120504]&Ha,ea(g[k>>2])));o=ea(ta*(c[k>>2]=c[120505]&Fa,ea(g[k>>2])));ha=ea(ta*(c[k>>2]=c[120506]&Aa,ea(g[k>>2])));oa=ea(ta*(c[k>>2]=c[120507]&Ja,ea(g[k>>2])));ta=(c[k>>2]=H,ea(g[k>>2]));X=ea((ra>ca?ta:ea(0.0))+na);na=(c[k>>2]=J,ea(g[k>>2]));ta=ea((ra>Y?na:ea(0.0))+o);o=(c[k>>2]=L,ea(g[k>>2]));na=ea((Ra?o:ea(0.0))+ha);ha=(c[k>>2]=N,ea(g[k>>2]));o=ea((ra>$?ha:ea(0.0))+oa);oa=ea(X);X=ea(ta);ta=ea(na);na=ea(o);g[G>>2]=oa;g[I>>2]=X;g[K>>2]=ta;g[M>>2]=na;na=ya?ga:ea(0.0);ga=ea(na*(c[k>>2]=c[120504]&Ga,ea(g[k>>2])));ta=ea(na*(c[k>>2]=c[120505]&Ea,ea(g[k>>2])));X=ea(na*(c[k>>2]=c[120506]&Da,ea(g[k>>2])));oa=ea(na*(c[k>>2]=c[120507]&za,ea(g[k>>2])));na=(c[k>>2]=P,ea(g[k>>2]));o=ea((Pa?na:ea(0.0))+ga);ga=(c[k>>2]=R,ea(g[k>>2]));na=ea((Qa?ga:ea(0.0))+ta);ta=(c[k>>2]=U,ea(g[k>>2]));ga=ea((Ra?ta:ea(0.0))+X);X=(c[k>>2]=W,ea(g[k>>2]));ta=ea((sa>$?X:ea(0.0))+oa);oa=ea(o);o=ea(na);na=ea(ga);ga=ea(ta);g[O>>2]=oa;g[Q>>2]=o;g[S>>2]=na;g[V>>2]=ga}V=d+64|0;if(V>>>0>=h>>>0)break;d=V;f=c[120504]|0;r=c[120505]|0;s=c[120507]|0;t=t+64|0;j=j+64|0}i=b;return}function Voa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,l=Im,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;b=i;d=c[a+4>>2]|0;e=c[d+132>>2]|0;if(!e){i=b;return}f=c[d+4>>2]|0;h=f+(c[d>>2]<<4)|0;j=c[d+136>>2]|0;if(!j){e$a(f,h,e);i=b;return}d=c[a+524>>2]|0;if((d|0)==1){e$a(f,h,j);i=b;return}l=ea(g[a+528>>2]);if(f>>>0>=h>>>0){i=b;return}m=ea(l+ea(ea(1.0)-ea(ea(d>>>0)*l)));d=f;f=j;j=e;while(1){e=c[d>>2]|0;a=d+4|0;n=c[a>>2]|0;o=d+8|0;p=c[o>>2]|0;q=d+12|0;r=c[q>>2]|0;s=d+16|0;t=c[s>>2]|0;u=d+20|0;v=c[u>>2]|0;w=d+24|0;x=c[w>>2]|0;y=d+28|0;z=c[y>>2]|0;A=d+32|0;B=c[A>>2]|0;C=d+36|0;D=c[C>>2]|0;E=d+40|0;F=c[E>>2]|0;G=d+44|0;H=c[G>>2]|0;I=d+48|0;J=c[I>>2]|0;K=d+52|0;L=c[K>>2]|0;M=d+56|0;N=c[M>>2]|0;O=d+60|0;P=c[O>>2]|0;l=ea(g[f>>2]);Q=ea(g[j>>2]);R=ea(l-Q);l=ea(g[f+4>>2]);S=ea(g[j+4>>2]);U=ea(l-S);l=ea(g[f+8>>2]);V=ea(g[j+8>>2]);W=ea(l-V);l=ea(g[f+12>>2]);X=ea(g[j+12>>2]);Y=ea(Q+ea(m*R));R=ea(S+ea(m*U));U=ea(V+ea(m*W));W=ea(X+ea(m*ea(l-X)));Z=c[120504]|0;_=c[120505]|0;$=c[120506]|0;aa=c[120507]|0;X=ea(Y-(c[k>>2]=Z&e,ea(g[k>>2])));Y=ea(R-(c[k>>2]=_&n,ea(g[k>>2])));R=ea(U-(c[k>>2]=$&p,ea(g[k>>2])));U=ea(W-(c[k>>2]=aa&r,ea(g[k>>2])));W=ea(g[f+16>>2]);l=ea(g[j+16>>2]);V=ea(W-l);W=ea(g[f+20>>2]);S=ea(g[j+20>>2]);Q=ea(W-S);W=ea(g[f+24>>2]);ba=ea(g[j+24>>2]);ca=ea(W-ba);W=ea(g[f+28>>2]);da=ea(g[j+28>>2]);fa=ea(l+ea(m*V));V=ea(S+ea(m*Q));Q=ea(ba+ea(m*ca));ca=ea(da+ea(m*ea(W-da)));da=ea(fa-(c[k>>2]=Z&t,ea(g[k>>2])));fa=ea(V-(c[k>>2]=_&v,ea(g[k>>2])));V=ea(Q-(c[k>>2]=$&x,ea(g[k>>2])));Q=ea(ca-(c[k>>2]=aa&z,ea(g[k>>2])));ca=ea(g[f+32>>2]);W=ea(g[j+32>>2]);ba=ea(ca-W);ca=ea(g[f+36>>2]);S=ea(g[j+36>>2]);l=ea(ca-S);ca=ea(g[f+40>>2]);ga=ea(g[j+40>>2]);ha=ea(ca-ga);ca=ea(g[f+44>>2]);ia=ea(g[j+44>>2]);ja=ea(W+ea(m*ba));ba=ea(S+ea(m*l));l=ea(ga+ea(m*ha));ha=ea(ia+ea(m*ea(ca-ia)));ia=ea(ja-(c[k>>2]=Z&B,ea(g[k>>2])));ja=ea(ba-(c[k>>2]=_&D,ea(g[k>>2])));ba=ea(l-(c[k>>2]=$&F,ea(g[k>>2])));l=ea(ha-(c[k>>2]=aa&H,ea(g[k>>2])));ha=ea(g[f+48>>2]);ca=ea(g[j+48>>2]);ga=ea(ha-ca);ha=ea(g[f+52>>2]);S=ea(g[j+52>>2]);W=ea(ha-S);ha=ea(g[f+56>>2]);ka=ea(g[j+56>>2]);la=ea(ha-ka);ha=ea(g[f+60>>2]);ma=ea(g[j+60>>2]);na=ea(ca+ea(m*ga));ga=ea(S+ea(m*W));W=ea(ka+ea(m*la));la=ea(ma+ea(m*ea(ha-ma)));ma=ea(na-(c[k>>2]=Z&J,ea(g[k>>2])));na=ea(ga-(c[k>>2]=_&L,ea(g[k>>2])));ga=ea(W-(c[k>>2]=$&N,ea(g[k>>2])));W=ea(la-(c[k>>2]=aa&P,ea(g[k>>2])));la=ea(X*X);ha=ea(da*da);ka=ea(ia*ia);S=ea(ma*ma);ca=ea(la+ea(g[120512]));la=ea(ha+ea(g[120513]));ha=ea(ka+ea(g[120514]));ka=ea(ea(1.0)-ea(U*ea(ea(1.0)/ea(T(ea(ea(R*R)+ea(ea(Y*Y)+ca)))))));ca=ea(ea(1.0)-ea(Q*ea(ea(1.0)/ea(T(ea(ea(V*V)+ea(ea(fa*fa)+la)))))));la=ea(ea(1.0)-ea(l*ea(ea(1.0)/ea(T(ea(ea(ba*ba)+ea(ea(ja*ja)+ha)))))));ha=ea(ea(1.0)-ea(W*ea(ea(1.0)/ea(T(ea(ea(ga*ga)+ea(ea(na*na)+ea(S+ea(g[120515])))))))));oa=ka<ea(0.0);pa=ca<ea(0.0);qa=la<ea(0.0);ra=ha<ea(0.0);if(oa|pa|qa|ra){sa=(g[k>>2]=W,c[k>>2]|0);ta=(g[k>>2]=ba,c[k>>2]|0);ua=(g[k>>2]=fa,c[k>>2]|0);va=(g[k>>2]=X,c[k>>2]|0);wa=(g[k>>2]=ga,c[k>>2]|0);xa=(g[k>>2]=na,c[k>>2]|0);ya=(g[k>>2]=ja,c[k>>2]|0);za=(g[k>>2]=ma,c[k>>2]|0);Aa=(g[k>>2]=ia,c[k>>2]|0);Ba=(g[k>>2]=da,c[k>>2]|0);Ca=(g[k>>2]=l,c[k>>2]|0);Da=(g[k>>2]=Q,c[k>>2]|0);Ea=(g[k>>2]=V,c[k>>2]|0);Fa=(g[k>>2]=U,c[k>>2]|0);Ga=(g[k>>2]=R,c[k>>2]|0);Ha=(g[k>>2]=Y,c[k>>2]|0)&_;Y=oa?ka:ea(0.0);ka=ea((c[k>>2]=va&Z,ea(g[k>>2]))*Y);R=ea((c[k>>2]=Ha,ea(g[k>>2]))*Y);U=ea((c[k>>2]=Ga&$,ea(g[k>>2]))*Y);V=ea((c[k>>2]=Fa&aa,ea(g[k>>2]))*Y);Y=ea((c[k>>2]=e,ea(g[k>>2]))+ka);ka=ea((c[k>>2]=n,ea(g[k>>2]))+R);R=ea((c[k>>2]=p,ea(g[k>>2]))+U);U=ea((c[k>>2]=r,ea(g[k>>2]))+V);V=ea(Y);Y=ea(ka);ka=ea(R);R=ea(U);g[d>>2]=V;g[a>>2]=Y;g[o>>2]=ka;g[q>>2]=R;R=pa?ca:ea(0.0);ca=ea(R*(c[k>>2]=c[120504]&Ba,ea(g[k>>2])));ka=ea(R*(c[k>>2]=c[120505]&ua,ea(g[k>>2])));Y=ea(R*(c[k>>2]=c[120506]&Ea,ea(g[k>>2])));V=ea(R*(c[k>>2]=c[120507]&Da,ea(g[k>>2])));R=ea((c[k>>2]=t,ea(g[k>>2]))+ca);ca=ea((c[k>>2]=v,ea(g[k>>2]))+ka);ka=ea((c[k>>2]=x,ea(g[k>>2]))+Y);Y=ea((c[k>>2]=z,ea(g[k>>2]))+V);V=ea(R);R=ea(ca);ca=ea(ka);ka=ea(Y);g[s>>2]=V;g[u>>2]=R;g[w>>2]=ca;g[y>>2]=ka;ka=qa?la:ea(0.0);la=ea(ka*(c[k>>2]=c[120504]&Aa,ea(g[k>>2])));ca=ea(ka*(c[k>>2]=c[120505]&ya,ea(g[k>>2])));R=ea(ka*(c[k>>2]=c[120506]&ta,ea(g[k>>2])));V=ea(ka*(c[k>>2]=c[120507]&Ca,ea(g[k>>2])));ka=ea((c[k>>2]=B,ea(g[k>>2]))+la);la=ea((c[k>>2]=D,ea(g[k>>2]))+ca);ca=ea((c[k>>2]=F,ea(g[k>>2]))+R);R=ea((c[k>>2]=H,ea(g[k>>2]))+V);V=ea(ka);ka=ea(la);la=ea(ca);ca=ea(R);g[A>>2]=V;g[C>>2]=ka;g[E>>2]=la;g[G>>2]=ca;ca=ra?ha:ea(0.0);ha=ea(ca*(c[k>>2]=c[120504]&za,ea(g[k>>2])));la=ea(ca*(c[k>>2]=c[120505]&xa,ea(g[k>>2])));ka=ea(ca*(c[k>>2]=c[120506]&wa,ea(g[k>>2])));V=ea(ca*(c[k>>2]=c[120507]&sa,ea(g[k>>2])));ca=ea((c[k>>2]=J,ea(g[k>>2]))+ha);ha=ea((c[k>>2]=L,ea(g[k>>2]))+la);la=ea((c[k>>2]=N,ea(g[k>>2]))+ka);ka=ea((c[k>>2]=P,ea(g[k>>2]))+V);V=ea(ca);ca=ea(ha);ha=ea(la);la=ea(ka);g[I>>2]=V;g[K>>2]=ca;g[M>>2]=ha;g[O>>2]=la}d=d+64|0;if(d>>>0>=h>>>0)break;else{f=f+64|0;j=j+64|0}}i=b;return}function Woa(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;d=ea(g[a+532>>2]);e=~~ea(d*ea(1.0e3))>>>0;f=a+4|0;h=(c[f>>2]|0)+248|0;c[h>>2]=(e>>>0>1?e:1)+(c[h>>2]|0);h=c[f>>2]|0;if((c[h+248>>2]|0)>>>0<(c[(c[a>>2]|0)+512>>2]|0)>>>0){i=b;return}e=c[h+4>>2]|0;j=e+(c[h>>2]<<4)|0;if(e>>>0<j>>>0){l=e;e=c[h+8>>2]|0;m=0;n=0;o=0;p=0;while(1){q=ea(g[l>>2]);r=ea(q-ea(g[e>>2]));q=ea(g[l+4>>2]);s=ea(q-ea(g[e+4>>2]));q=ea(g[l+8>>2]);t=ea(q-ea(g[e+8>>2]));q=ea(g[l+12>>2]);u=ea(S(ea(r)));r=ea(S(ea(s)));s=ea(S(ea(t)));t=ea(S(ea(q-ea(g[e+12>>2]))));q=(c[k>>2]=m,ea(g[k>>2]));v=(c[k>>2]=n,ea(g[k>>2]));w=(c[k>>2]=o,ea(g[k>>2]));x=(c[k>>2]=p,ea(g[k>>2]));y=(g[k>>2]=q<u?u:q,c[k>>2]|0);z=(g[k>>2]=v<r?r:v,c[k>>2]|0);A=(g[k>>2]=w<s?s:w,c[k>>2]|0);B=(g[k>>2]=x<t?t:x,c[k>>2]|0);l=l+16|0;if(l>>>0>=j>>>0){C=B;D=A;E=z;F=y;break}else{e=e+16|0;m=y;n=z;o=A;p=B}}}else{C=0;D=0;E=0;F=0}p=c[120505]|0;o=c[120504]&F;F=c[120506]&D;D=c[120507]&C;C=h+244|0;c[C>>2]=(c[C>>2]|0)+1;C=c[a>>2]|0;x=ea(ea(g[C+520>>2])*d);if(!((c[k>>2]=o,ea(g[k>>2]))>=x)?(o=!((c[k>>2]=p&E,ea(g[k>>2]))>=x),E=o&!((c[k>>2]=F,ea(g[k>>2]))>=x),E&!((c[k>>2]=D,ea(g[k>>2]))>=x)):0)G=C;else{c[(c[f>>2]|0)+244>>2]=0;G=c[a>>2]|0}a=(c[f>>2]|0)+248|0;c[a>>2]=(c[a>>2]|0)-(c[G+512>>2]|0);i=b;return}function Xoa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[b>>2]|0;f=c[b+4>>2]|0;b=a+4|0;if(f>>>0>=e>>>0){g=f-e|0;f=g>>4;c[b>>2]=f;c[a+8>>2]=f;if(f){f=UJa(a,g,537640,558)|0;g=c[b>>2]|0;c[a>>2]=f;h=f+(g<<4)|0;if((g|0)>0){g=f;f=e;while(1){if(g){c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2]}g=g+16|0;if(g>>>0>=h>>>0)break;else f=f+16|0}}}else j=4}else{c[b>>2]=0;c[a+8>>2]=0;j=4}if((j|0)==4)c[a>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;i=d;return}function Yoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+48|0;f=e+24|0;g=e+8|0;h=e+4|0;j=e;k=a+4|0;if(!(c[k>>2]|0)){i=e;return}c[h>>2]=-1;c[g>>2]=0;c[g+4>>2]=0;l=g+8|0;c[l>>2]=0;f$a(g,b,h);c[j>>2]=0;h=c[a>>2]|0;b=c[k>>2]|0;k=h+(b<<4)|0;if(b){b=k;m=a+12|0;n=a+20|0;o=a+16|0;a=0;p=0;q=h;while(1){h=b-q>>4;r=h>>>0>d>>>0?d:h;h=q+(r<<4)|0;a:do if((r|0)==0|(q|0)==(k|0)){s=a;t=q;u=k;v=14}else{w=c[g>>2]|0;x=a;y=q;z=k;while(1){A=y+8|0;B=y+4|0;C=z;while(1){D=w+(c[y>>2]<<2)|0;if(((c[D>>2]|0)!=(p|0)?(c[w+(c[B>>2]<<2)>>2]|0)!=(p|0):0)?(c[w+(c[A>>2]<<2)>>2]|0)!=(p|0):0){E=C;break}F=C+-16|0;if((y|0)==(F|0)){E=y;break};c[f+0>>2]=c[y+0>>2];c[f+4>>2]=c[y+4>>2];c[f+8>>2]=c[y+8>>2];c[f+12>>2]=c[y+12>>2];c[y+0>>2]=c[F+0>>2];c[y+4>>2]=c[F+4>>2];c[y+8>>2]=c[F+8>>2];c[y+12>>2]=c[F+12>>2];c[F+0>>2]=c[f+0>>2];c[F+4>>2]=c[f+4>>2];c[F+8>>2]=c[f+8>>2];c[F+12>>2]=c[f+12>>2];C=F}if((y|0)==(E|0)){G=x;H=y;v=15;break a}c[D>>2]=p;c[w+(c[B>>2]<<2)>>2]=p;c[w+(c[A>>2]<<2)>>2]=p;C=y+16|0;F=x+1|0;c[j>>2]=F;if((C|0)==(h|0)|(C|0)==(E|0)){s=F;t=C;u=E;v=14;break}else{x=F;y=C;z=E}}}while(0);if((v|0)==14){v=0;if((t|0)==(u|0)){G=s;H=t;v=15}else{I=s;J=t}}if((v|0)==15){v=0;if(G>>>0>d>>>0){h=(G>>>0)%(d>>>0)|0;r=G-h|0;c[j>>2]=r;K=r;L=H+(0-h<<4)|0}else{K=G;L=H}h=c[o>>2]|0;if((c[n>>2]&2147483647)>>>0>h>>>0){r=(c[m>>2]|0)+(h<<2)|0;if(!r)M=h;else{c[r>>2]=K;M=c[o>>2]|0}c[o>>2]=M+1}else M_a(m,j)|0;c[j>>2]=0;I=0;J=L}if((J|0)==(k|0))break;else{a=I;p=p+1|0;q=J}}}J=c[l>>2]|0;if(!((J&2147483647|0)!=0&(J|0)>-1)){i=e;return}VJa(g,c[g>>2]|0);i=e;return}function Zoa(){var a=0;a=i;c[125130]=1;c[125132]=127;c[125134]=3493;Hwa();i=a;return}function _oa(){c[125156]=106;c[125170]=107;c[125177]=108;c[125184]=109;c[125206]=106;c[125220]=107;c[125227]=108;c[125234]=109;return}function $oa(){var a=0;a=i;Ksa();i=a;return}function apa(){var a=0;a=i;_Aa();i=a;return}function bpa(){var a=0;a=i;$Aa();i=a;return}function cpa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;c[a>>2]=e;c[a+4>>2]=d;d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[a+40>>2]=1073741823;c[a+44>>2]=0;c[a+48>>2]=0;c[a+52>>2]=1073741823;c[a+56>>2]=0;c[a+60>>2]=0;c[a+64>>2]=1073741823;c[a+68>>2]=0;c[a+72>>2]=0;c[a+80>>2]=0;c[a+84>>2]=0;c[a+88>>2]=0;c[a+92>>2]=64;c[a+96>>2]=0;c[a+100>>2]=0;c[a+108>>2]=0;c[a+112>>2]=0;c[a+116>>2]=0;c[a+120>>2]=64;c[a+124>>2]=0;c[a+128>>2]=0;c[a+136>>2]=0;c[a+140>>2]=0;c[a+144>>2]=0;c[a+148>>2]=64;d=a+208|0;g=a+152|0;h=g+56|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));c[d>>2]=1073741822;d=a+212|0;c[a+232>>2]=0;c[a+236>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+244|0;c[a+280>>2]=0;c[a+284>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[a+292>>2]=1073741823;d=a+296|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[a+328>>2]=1073741823;c[a+332>>2]=0;c[a+336>>2]=0;c[a+340>>2]=1073741823;c[a+344>>2]=0;c[a+348>>2]=0;c[a+352>>2]=1073741823;c[a+356>>2]=0;c[a+360>>2]=0;c[a+368>>2]=0;c[a+372>>2]=0;c[a+376>>2]=0;c[a+380>>2]=64;c[a+16896>>2]=e;c[a+16900>>2]=0;c[a+16904>>2]=0;c[a+16912>>2]=0;c[a+33312>>2]=e;c[a+33316>>2]=0;c[a+33320>>2]=0;c[a+33328>>2]=0;c[a+37440>>2]=e;c[a+37444>>2]=0;c[a+37448>>2]=0;c[a+41552>>2]=e;c[a+41556>>2]=0;c[a+41560>>2]=0;c[a+41568>>2]=0;c[a+45680>>2]=e;c[a+45684>>2]=0;c[a+45688>>2]=0;c[a+45696>>2]=0;c[a+49808>>2]=e;c[a+49812>>2]=0;c[a+49816>>2]=0;e=a+49868|0;g=a+49824|0;h=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));aqa(e);eqa(a+50324|0);iqa(a+50608|0);e=a+51012|0;b[a+51016>>1]=-1;b[a+51018>>1]=0;c[a+51020>>2]=0;c[e>>2]=443968;c[a+51024>>2]=0;c[a+51028>>2]=0;c[e>>2]=483280;c[a+51032>>2]=0;e=a+51056|0;b[a+51060>>1]=-1;b[a+51062>>1]=0;c[a+51064>>2]=0;c[e>>2]=443968;c[a+51068>>2]=0;c[a+51072>>2]=0;c[e>>2]=483328;c[a+51096>>2]=0;aqa(a+51100|0);e=a+51556|0;b[a+51560>>1]=-1;b[a+51562>>1]=0;c[a+51564>>2]=0;c[e>>2]=443968;c[a+51568>>2]=0;c[a+51572>>2]=0;c[e>>2]=483376;e=a+51596|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;e=0;do{c[a+(e<<2)+384>>2]=1<<e;e=e+1|0}while((e|0)!=32);dpa(a,64,64,0);i=f;return}function dpa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+1|0;h=f;j=b+31&-32;b=d+31&-32;d=b+j|0;if(!(d|e)){i=f;return}if((c[a+36>>2]|0)>>>0<d>>>0){g$a(a+8|0,d);k=a+48|0;l=c[k>>2]|0;if(l>>>0<j>>>0){m=UJa(g,j<<3,483416,1503)|0;n=a+44|0;o=c[n>>2]|0;if(o){YEi(m|0,o|0,l<<3|0)|0;PEi(m+(l<<3)|0,0,j-l<<3|0)|0}o=a+52|0;p=j+-1|0;c[m+(p<<3)>>2]=c[o>>2];if(l>>>0<p>>>0){q=l;do{l=q;q=q+1|0;c[m+(l<<3)>>2]=q}while((q|0)!=(p|0))}c[o>>2]=c[k>>2];VJa(h,c[n>>2]|0);c[n>>2]=m;c[k>>2]=j}j=a+60|0;k=c[j>>2]|0;if(k>>>0<b>>>0){m=UJa(g,b<<4,483416,1503)|0;n=a+56|0;o=c[n>>2]|0;if(o){YEi(m|0,o|0,k<<4|0)|0;PEi(m+(k<<4)|0,0,b-k<<4|0)|0}o=a+64|0;p=b+-1|0;c[m+(p<<4)>>2]=c[o>>2];if(k>>>0<p>>>0){q=k;do{k=q;q=q+1|0;c[m+(k<<4)>>2]=q}while((q|0)!=(p|0))}c[o>>2]=c[j>>2];VJa(h,c[n>>2]|0);c[n>>2]=m;c[j>>2]=b}b=a+92|0;j=c[b>>2]|0;m=j>>>0<d>>>0?d:j;c[b>>2]=m;b=a+88|0;j=c[b>>2]|0;if(m>>>0>j>>>0){n=m+31&-32;m=a+80|0;o=c[m>>2]|0;p=UJa(g,n<<2,483416,76)|0;if(o)YEi(p|0,o|0,j<<2|0)|0;PEi(p+(j<<2)|0,0,n-j<<2|0)|0;VJa(h,o);c[m>>2]=p;c[b>>2]=n}n=a+120|0;b=c[n>>2]|0;p=b>>>0<d>>>0?d:b;c[n>>2]=p;n=a+116|0;b=c[n>>2]|0;if(p>>>0>b>>>0){m=p+31&-32;p=a+108|0;o=c[p>>2]|0;j=UJa(g,m<<2,483416,76)|0;if(o)YEi(j|0,o|0,b<<2|0)|0;PEi(j+(b<<2)|0,0,m-b<<2|0)|0;VJa(h,o);c[p>>2]=j;c[n>>2]=m}m=a+148|0;n=c[m>>2]|0;j=n>>>0<d>>>0?d:n;c[m>>2]=j;m=a+144|0;n=c[m>>2]|0;if(j>>>0>n>>>0){p=j+31&-32;j=a+136|0;o=c[j>>2]|0;b=UJa(g,p<<2,483416,76)|0;if(o)YEi(b|0,o|0,n<<2|0)|0;PEi(b+(n<<2)|0,0,p-n<<2|0)|0;VJa(h,o);c[j>>2]=b;c[m>>2]=p}p=(d>>>5)+3&268435452;m=a+72|0;b=c[m>>2]|0;j=b&2147483647;if(p>>>0>j>>>0){o=a+68|0;n=c[o>>2]|0;q=UJa(g,p<<2,483416,76)|0;if(n)YEi(q|0,n|0,b<<2|0)|0;PEi(q+(j<<2)|0,0,p-b<<2|0)|0;VJa(h,n);c[o>>2]=q;c[m>>2]=p|-2147483648}m=a+100|0;q=c[m>>2]|0;o=q&2147483647;if(p>>>0>o>>>0){n=a+96|0;b=c[n>>2]|0;j=UJa(g,p<<2,483416,76)|0;if(b)YEi(j|0,b|0,q<<2|0)|0;PEi(j+(o<<2)|0,0,p-q<<2|0)|0;VJa(h,b);c[n>>2]=j;c[m>>2]=p|-2147483648}m=a+128|0;j=c[m>>2]|0;n=j&2147483647;if(p>>>0>n>>>0){b=a+124|0;q=c[b>>2]|0;o=UJa(g,p<<2,483416,76)|0;if(q)YEi(o|0,q|0,j<<2|0)|0;PEi(o+(n<<2)|0,0,p-j<<2|0)|0;VJa(h,q);c[b>>2]=o;c[m>>2]=p|-2147483648}}if((c[a+324>>2]|0)>>>0<d>>>0){c[a+328>>2]=1073741823;g$a(a+296|0,d)}if((c[a+164>>2]|0)>>>0<d>>>0)h$a(a+152|0,d);if((c[a+196>>2]|0)>>>0>=e>>>0){i=f;return}d=e+3&-4;i$a(a+176|0,d);e=((d+31|0)>>>5)+3&268435452;d=a+360|0;p=c[d>>2]|0;m=p&2147483647;if(e>>>0<=m>>>0){i=f;return}o=a+356|0;a=c[o>>2]|0;b=UJa(g,e<<2,483416,76)|0;if(a)YEi(b|0,a|0,p<<2|0)|0;PEi(b+(m<<2)|0,0,e-p<<2|0)|0;VJa(h,a);c[o>>2]=b;c[d>>2]=e|-2147483648;i=f;return}function epa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b+4|0;e=b+3|0;f=b+2|0;g=b+1|0;h=b;j=a+49860|0;k=c[j>>2]|0;l=a+49856|0;if(k){m=k;k=0;while(1){n=c[(c[l>>2]|0)+(k*12|0)+8>>2]|0;if(!n)o=m;else{p=c[n>>2]|0;if((p|0)!=0?(c[n+4>>2]|0)>-1:0)VJa(n+8|0,p);VJa(d,n);c[(c[l>>2]|0)+(k*12|0)+8>>2]=0;o=c[j>>2]|0}k=k+1|0;if(k>>>0>=o>>>0)break;else m=o}}VJa(f,c[a+49832>>2]|0);VJa(g,c[a+49844>>2]|0);VJa(h,c[l>>2]|0);l=a+512|0;j$a(l);h=a+16928|0;j$a(h);g=a+41584|0;k$a(g);f=a+45712|0;k$a(f);o=c[a+51620>>2]|0;if((o&2147483647|0)!=0&(o|0)>-1?(o=c[a+51612>>2]|0,(o|0)!=0):0){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,o)}o=c[a+51608>>2]|0;if((o&2147483647|0)!=0&(o|0)>-1?(o=c[a+51600>>2]|0,(o|0)!=0):0){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,o)}c[a+51556>>2]=443968;c[a+51564>>2]=0;cqa(a+51100|0);c[a+51056>>2]=443968;c[a+51064>>2]=0;c[a+51012>>2]=443968;c[a+51020>>2]=0;kqa(a+50608|0);gqa(a+50324|0);cqa(a+49868|0);k$a(f);k$a(g);k$a(a+37456|0);k$a(a+33344|0);j$a(h);j$a(l);l=a+356|0;VJa(d,c[l>>2]|0);VJa(e,c[a+368>>2]|0);h=c[l>>2]|0;if((h|0)!=0?(c[a+360>>2]|0)>-1:0)VJa(a+364|0,h);VJa(d,c[a+296>>2]|0);VJa(d,c[a+344>>2]|0);VJa(d,c[a+332>>2]|0);h=c[a+244>>2]|0;if(h)VJa(d,h);h=c[a+280>>2]|0;if((h|0)!=0?(c[a+284>>2]|0)>-1:0)VJa(a+288|0,h);h=c[a+268>>2]|0;if((h|0)!=0?(c[a+272>>2]|0)>-1:0)VJa(a+276|0,h);VJa(d,c[a+176>>2]|0);h=c[a+232>>2]|0;if((h|0)!=0?(c[a+236>>2]|0)>-1:0)VJa(a+240|0,h);h=c[a+220>>2]|0;if((h|0)!=0?(c[a+224>>2]|0)>-1:0)VJa(a+228|0,h);VJa(d,c[a+152>>2]|0);h=a+124|0;VJa(d,c[h>>2]|0);VJa(e,c[a+136>>2]|0);l=c[h>>2]|0;if((l|0)!=0?(c[a+128>>2]|0)>-1:0)VJa(a+132|0,l);l=a+96|0;VJa(d,c[l>>2]|0);VJa(e,c[a+108>>2]|0);h=c[l>>2]|0;if((h|0)!=0?(c[a+100>>2]|0)>-1:0)VJa(a+104|0,h);h=a+68|0;VJa(d,c[h>>2]|0);VJa(e,c[a+80>>2]|0);e=c[h>>2]|0;if(!e){q=a+8|0;r=c[q>>2]|0;VJa(d,r);s=a+56|0;t=c[s>>2]|0;VJa(d,t);u=a+44|0;v=c[u>>2]|0;VJa(d,v);i=b;return}if((c[a+72>>2]|0)<=-1){q=a+8|0;r=c[q>>2]|0;VJa(d,r);s=a+56|0;t=c[s>>2]|0;VJa(d,t);u=a+44|0;v=c[u>>2]|0;VJa(d,v);i=b;return}VJa(a+76|0,e);q=a+8|0;r=c[q>>2]|0;VJa(d,r);s=a+56|0;t=c[s>>2]|0;VJa(d,t);u=a+44|0;v=c[u>>2]|0;VJa(d,v);i=b;return}function fpa(a,b){a=a|0;b=b|0;c[a+49828>>2]=b;return}function gpa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=c[a+49828>>2]|0;ko[c[(c[d>>2]|0)+40>>2]&4095](d);if(!a){i=b;return}epa(a);VJa(b,a);i=b;return}function hpa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a+49840|0;if((c[d>>2]|0)>>>0<=64){i=b;return}e=a+49832|0;VJa(b+1|0,c[e>>2]|0);c[e>>2]=UJa(b,512,482112,257)|0;c[d>>2]=64;i=b;return}function ipa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a+49852|0;if((c[d>>2]|0)>>>0<=64){i=b;return}e=a+49844|0;VJa(b+1|0,c[e>>2]|0);c[e>>2]=UJa(b,512,482112,267)|0;c[d>>2]=64;i=b;return}function jpa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+96|0;f=e+56|0;h=e+28|0;j=e;g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(1.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);FKa(d,f)|0;f=c[b+196>>2]|0;if(!f){i=e;return}l=b+180|0;m=b+356|0;n=b+12|0;o=h+4|0;p=h+8|0;q=h+12|0;r=h+16|0;s=h+20|0;t=h+24|0;u=b+300|0;v=j+4|0;w=j+8|0;x=j+12|0;y=j+16|0;z=j+20|0;A=j+24|0;B=b+316|0;b=0;do{C=c[l>>2]|0;if(a[C+(b*1048|0)+1025>>0]|0){if(!(c[(c[m>>2]|0)+(b>>>5<<2)>>2]&1<<(b&31)))DKa(d,-16711936)|0;else DKa(d,-65536)|0;D=c[C+(b*1048|0)+1028>>2]|0;E=c[n>>2]|0;F=c[E+(D*24|0)>>2]|0;G=c[E+(D*24|0)+4>>2]|0;H=c[E+(D*24|0)+8>>2]|0;I=c[E+(D*24|0)+12>>2]|0;J=c[E+(D*24|0)+16>>2]|0;K=c[E+(D*24|0)+20>>2]|0;g[h>>2]=(c[k>>2]=(F|0)<0?F&2147483647:~F,ea(g[k>>2]));g[o>>2]=(c[k>>2]=(G|0)<0?G&2147483647:~G,ea(g[k>>2]));g[p>>2]=(c[k>>2]=(H|0)<0?H&2147483647:~H,ea(g[k>>2]));g[q>>2]=(c[k>>2]=(I|0)<0?I&2147483647:~I,ea(g[k>>2]));g[r>>2]=(c[k>>2]=(J|0)<0?J&2147483647:~J,ea(g[k>>2]));g[s>>2]=(c[k>>2]=(K|0)<0?K&2147483647:~K,ea(g[k>>2]));a[t>>0]=1;HKa(d,h)|0;K=c[C+(b*1048|0)+1032>>2]|0;if((K|0)!=1073741823){C=K;do{DKa(d,-16711681)|0;K=c[u>>2]|0;J=c[K+(C*24|0)>>2]|0;I=c[K+(C*24|0)+4>>2]|0;H=c[K+(C*24|0)+8>>2]|0;G=c[K+(C*24|0)+12>>2]|0;F=c[K+(C*24|0)+16>>2]|0;D=c[K+(C*24|0)+20>>2]|0;g[j>>2]=(c[k>>2]=(J|0)<0?J&2147483647:~J,ea(g[k>>2]));g[v>>2]=(c[k>>2]=(I|0)<0?I&2147483647:~I,ea(g[k>>2]));g[w>>2]=(c[k>>2]=(H|0)<0?H&2147483647:~H,ea(g[k>>2]));g[x>>2]=(c[k>>2]=(G|0)<0?G&2147483647:~G,ea(g[k>>2]));g[y>>2]=(c[k>>2]=(F|0)<0?F&2147483647:~F,ea(g[k>>2]));g[z>>2]=(c[k>>2]=(D|0)<0?D&2147483647:~D,ea(g[k>>2]));a[A>>0]=1;HKa(d,j)|0;C=c[(c[B>>2]|0)+(C<<2)>>2]|0}while((C|0)!=1073741823)}}b=b+1|0}while((b|0)!=(f|0));i=e;return}function kpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=a+196|0;g=c[f>>2]|0;h=l$a(a+176|0,b,d)|0;d=c[f>>2]|0;if(d>>>0<=g>>>0){j=h<<1;k=j|1;i=e;return k|0}g=((d+31|0)>>>5)+3&268435452;d=a+360|0;f=c[d>>2]|0;b=f&2147483647;if(g>>>0<=b>>>0){j=h<<1;k=j|1;i=e;return k|0}l=a+356|0;a=c[l>>2]|0;m=UJa(e+1|0,g<<2,483416,76)|0;if(a)YEi(m|0,a|0,f<<2|0)|0;PEi(m+(b<<2)|0,0,g-f<<2|0)|0;VJa(e,a);c[l>>2]=m;c[d>>2]=g|-2147483648;j=h<<1;k=j|1;i=e;return k|0}function lpa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=d>>>1;g=b+180|0;h=c[g>>2]|0;j=c[h+(f*1048|0)+1040>>2]|0;k=b+292|0;l=c[k>>2]|0;if((j|0)==1073741823){m=h;n=l}else{h=b+256|0;o=b+248|0;p=b+252|0;q=b+260|0;r=b+268|0;s=b+280|0;t=c[h>>2]|0;u=l;l=j;while(1){j=c[t+(l<<2)>>2]|0;c[(c[o>>2]|0)+(l*24|0)>>2]=u;a[(c[p>>2]|0)+l>>0]=0;t=c[h>>2]|0;c[t+(l<<2)>>2]=1073741823;c[(c[q>>2]|0)+(l<<2)>>2]=1073741823;v=~(1<<(l&31));w=l>>>5;x=(c[r>>2]|0)+(w<<2)|0;c[x>>2]=c[x>>2]&v;x=(c[s>>2]|0)+(w<<2)|0;c[x>>2]=c[x>>2]&v;if((j|0)==1073741823)break;else{v=l;l=j;u=v}}m=c[g>>2]|0;n=l}c[k>>2]=n;n=b+204|0;c[(c[b+200>>2]|0)+(c[n>>2]<<2)>>2]=f;c[n>>2]=(c[n>>2]|0)+1;n=m+(f*1048|0)+1036|0;k=b+216|0;c[(c[b+212>>2]|0)+(c[k>>2]<<2)>>2]=c[n>>2];c[k>>2]=(c[k>>2]|0)+1;c[n>>2]=1073741823;c[m+(f*1048|0)+1040>>2]=1073741823;m=(c[b+184>>2]|0)+(f<<4)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;m=(c[b+188>>2]|0)+(f<<4)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;m=(c[b+232>>2]|0)+(d>>>6<<2)|0;c[m>>2]=c[m>>2]&~(1<<(f&31));i=e;return}function mpa(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;m=i;i=i+512|0;n=m;if((f|0)==-1){o=l+12|0;p=c[l>>2]|0;q=c[l+4>>2]|0;r=c[l+8>>2]|0;s=c[o>>2]|0;t=c[o+4>>2]|0;u=c[o+8>>2]|0;o=npa(e)|0;v=(c[e+96>>2]|0)+(o>>>5<<2)|0;c[v>>2]=c[v>>2]|1<<(o&31);c[(c[e+16>>2]|0)+(o<<2)>>2]=k;c[(c[e+20>>2]|0)+(o<<2)>>2]=j;v=c[e+12>>2]|0;c[v+(o*24|0)>>2]=((p|0)<0?~p:p|-2147483648)+-16&-16;c[v+(o*24|0)+4>>2]=((q|0)<0?~q:q|-2147483648)+-16&-16;c[v+(o*24|0)+8>>2]=((r|0)<0?~r:r|-2147483648)+-16&-16;c[v+(o*24|0)+12>>2]=((s|0)<0?~s:s|-2147483648)+16&-16|1;c[v+(o*24|0)+16>>2]=((t|0)<0?~t:t|-2147483648)+16&-16|1;c[v+(o*24|0)+20>>2]=((u|0)<0?~u:u|-2147483648)+16&-16|1;if((h|0)==1073741823){u=e+152|0;v=e+172|0;t=c[v>>2]|0;do if(!t){s=e+160|0;r=c[s>>2]|0;q=c[e+164>>2]|0;if(r>>>0<q>>>0){c[s>>2]=r+1;w=r;break}else{h$a(u,q+32|0);q=c[s>>2]|0;c[s>>2]=q+1;w=q;break}}else{q=t+-1|0;s=c[(c[e+168>>2]|0)+(q<<2)>>2]|0;c[v>>2]=q;w=s}while(0);v=c[e+156>>2]|0;c[(c[e+24>>2]|0)+(o<<2)>>2]=w<<1;c[(c[e+28>>2]|0)+(o<<2)>>2]=1073741823;c[v+(w<<2)>>2]=o;x=w}else{w=h>>>1;v=c[e+156>>2]|0;c[(c[e+24>>2]|0)+(o<<2)>>2]=w<<1;t=v+(w<<2)|0;c[(c[e+28>>2]|0)+(o<<2)>>2]=c[t>>2];c[t>>2]=o;x=w}if(o>>>0<536870911&x>>>0<536870911){c[b>>2]=o<<1;c[b+4>>2]=x<<1;i=m;return}else{c[b>>2]=1073741823;c[b+4>>2]=1073741823;i=m;return}}x=f>>>1;o=c[e+180>>2]|0;w=o+(x*1048|0)|0;t=o+(x*1048|0)+1032|0;v=l+12|0;u=c[l>>2]|0;s=((u|0)<0?~u:u|-2147483648)+-16&-16;u=c[l+4>>2]|0;q=((u|0)<0?~u:u|-2147483648)+-16&-16;u=c[l+8>>2]|0;l=((u|0)<0?~u:u|-2147483648)+-16&-16;u=c[v>>2]|0;r=((u|0)<0?~u:u|-2147483648)+16&-16|1;u=c[v+4>>2]|0;p=((u|0)<0?~u:u|-2147483648)+16&-16|1;u=c[v+8>>2]|0;v=((u|0)<0?~u:u|-2147483648)+16&-16|1;if((c[t>>2]|0)==1073741823){u=npa(e)|0;c[o+(x*1048|0)+1028>>2]=u;c[(c[e+24>>2]|0)+(u<<2)>>2]=f|1;c[(c[e+20>>2]|0)+(u<<2)>>2]=c[o+(x*1048|0)+1036>>2];y=c[e+12>>2]|0;c[y+(u*24|0)>>2]=s;c[y+(u*24|0)+4>>2]=q;c[y+(u*24|0)+8>>2]=l;c[y+(u*24|0)+12>>2]=r;c[y+(u*24|0)+16>>2]=p;c[y+(u*24|0)+20>>2]=v;y=(c[e+96>>2]|0)+(u>>>5<<2)|0;c[y>>2]=c[y>>2]|1<<(u&31);u=opa(e)|0;c[(c[e+304>>2]|0)+(u<<2)>>2]=k;c[(c[e+308>>2]|0)+(u<<2)>>2]=j;y=c[e+300>>2]|0;c[y+(u*24|0)>>2]=s;c[y+(u*24|0)+4>>2]=q;c[y+(u*24|0)+8>>2]=l;c[y+(u*24|0)+12>>2]=r;c[y+(u*24|0)+16>>2]=p;c[y+(u*24|0)+20>>2]=v;c[(c[e+316>>2]|0)+(u<<2)>>2]=1073741823;c[(c[e+320>>2]|0)+(u<<2)>>2]=1073741823;y=(c[e+356>>2]|0)+(f>>>6<<2)|0;z=c[y>>2]|0;A=1<<(x&31);if(!(z&A))c[y>>2]=z|A;c[t>>2]=u;A=o+(x*1048|0)+1025|0;a[A>>0]=(a[A>>0]|0)+1<<24>>24;A=o+(x*1048|0)+1026|0;a[A>>0]=(a[A>>0]|0)+1<<24>>24;do if((h|0)==1073741823){A=e+292|0;z=c[A>>2]|0;if((z|0)==1073741823){y=c[e+264>>2]<<1;m$a(e+244|0,y>>>0<64?64:y);B=c[A>>2]|0}else B=z;z=c[e+248>>2]|0;c[A>>2]=c[z+(B*24|0)>>2];g[z+(B*24|0)>>2]=ea(8507058669999999534545717.0e13);g[z+(B*24|0)+4>>2]=ea(8507058669999999534545717.0e13);g[z+(B*24|0)+8>>2]=ea(8507058669999999534545717.0e13);g[z+(B*24|0)+12>>2]=ea(-8507058669999999534545717.0e13);g[z+(B*24|0)+16>>2]=ea(-8507058669999999534545717.0e13);g[z+(B*24|0)+20>>2]=ea(-8507058669999999534545717.0e13);z=e+252|0;a[(c[z>>2]|0)+B>>0]=0;c[(c[e+260>>2]|0)+(B<<2)>>2]=x;A=o+(x*1048|0)+1040|0;y=c[A>>2]|0;C=(c[e+256>>2]|0)+(B<<2)|0;if((y|0)==1073741823){c[C>>2]=1073741823;c[A>>2]=B;D=z;E=B;break}else{c[C>>2]=y;c[A>>2]=B;D=z;E=B;break}}else{D=e+252|0;E=h>>>1}while(0);B=E<<1|1;c[(c[e+312>>2]|0)+(u<<2)>>2]=B;z=(c[D>>2]|0)+E|0;a[z>>0]=(a[z>>0]|0)+1<<24>>24;z=1<<(E&31);D=E>>>5;A=(c[e+280>>2]|0)+(D<<2)|0;c[A>>2]=c[A>>2]&~z;if(!(a[o+(x*1048|0)+1024>>0]|0)){A=(c[e+268>>2]|0)+(D<<2)|0;c[A>>2]=c[A>>2]|z}if(f>>>0<1073741822&E>>>0<536870911){c[b>>2]=u<<1|1;c[b+4>>2]=B;i=m;return}else{c[b>>2]=1073741823;c[b+4>>2]=1073741823;i=m;return}}B=c[e+188>>2]|0;u=4;while(1){E=u;u=u+-1|0;if(!E){F=38;break}G=c[B+(x<<4)+(u<<2)>>2]|0;if(G){F=31;break}}if((F|0)==31){E=G>>>1|G;G=E>>>2|E;E=G>>>4|G;G=E>>>8|E;E=(c[482792+((da(G>>>16|G,130329821)|0)>>>27<<2)>>2]|0)+(u<<5)|0;if((E|0)!=0?(u=B+(x<<4)+(E>>>5<<2)|0,c[u>>2]=c[u>>2]&~(1<<(E&31)),(E|0)!=1073741823):0){u=c[t>>2]|0;if((u|0)!=1073741823){B=c[e+316>>2]|0;G=u;u=0;while(1){c[n+(u<<2)>>2]=G;G=c[B+(G<<2)>>2]|0;if((G|0)==1073741823)break;else u=u+1|0}}u=c[n+((d[o+(x*1048|0)+1025>>0]|0)+~E<<2)>>2]|0;c[(c[e+304>>2]|0)+(u<<2)>>2]=k;c[(c[e+308>>2]|0)+(u<<2)>>2]=j;E=c[e+300>>2]|0;c[E+(u*24|0)>>2]=s;c[E+(u*24|0)+4>>2]=q;c[E+(u*24|0)+8>>2]=l;c[E+(u*24|0)+12>>2]=r;c[E+(u*24|0)+16>>2]=p;c[E+(u*24|0)+20>>2]=v;c[(c[e+320>>2]|0)+(u<<2)>>2]=1073741823;E=o+(x*1048|0)+1026|0;a[E>>0]=(a[E>>0]|0)+1<<24>>24;E=(c[e+356>>2]|0)+(f>>>6<<2)|0;G=c[E>>2]|0;B=1<<(x&31);if(!(G&B)){c[E>>2]=G|B;H=u}else H=u}else F=38}do if((F|0)==38){u=o+(x*1048|0)+1025|0;if((a[u>>0]|0)>-1){ppa(e,w);B=opa(e)|0;G=c[t>>2]|0;c[(c[e+304>>2]|0)+(B<<2)>>2]=k;c[(c[e+308>>2]|0)+(B<<2)>>2]=j;E=c[e+300>>2]|0;c[E+(B*24|0)>>2]=s;c[E+(B*24|0)+4>>2]=q;c[E+(B*24|0)+8>>2]=l;c[E+(B*24|0)+12>>2]=r;c[E+(B*24|0)+16>>2]=p;c[E+(B*24|0)+20>>2]=v;c[(c[e+316>>2]|0)+(B<<2)>>2]=G;c[(c[e+320>>2]|0)+(B<<2)>>2]=1073741823;c[t>>2]=B;a[u>>0]=(a[u>>0]|0)+1<<24>>24;u=o+(x*1048|0)+1026|0;a[u>>0]=(a[u>>0]|0)+1<<24>>24;u=(c[e+356>>2]|0)+(f>>>6<<2)|0;G=c[u>>2]|0;E=1<<(x&31);if(G&E){H=B;break}c[u>>2]=G|E;H=B;break}else{dKa(bKa()|0,32,482112,541,482200,n);c[b>>2]=1073741823;c[b+4>>2]=1073741823;i=m;return}}while(0);n=c[o+(x*1048|0)+1028>>2]|0;f=c[e+12>>2]|0;t=f+(n*24|0)|0;j=c[t>>2]|0;k=f+(n*24|0)+4|0;w=c[k>>2]|0;F=f+(n*24|0)+8|0;B=c[F>>2]|0;E=f+(n*24|0)+12|0;G=c[E>>2]|0;u=f+(n*24|0)+16|0;z=c[u>>2]|0;A=f+(n*24|0)+20|0;f=c[A>>2]|0;D=G>>>0<r>>>0;y=z>>>0<p>>>0;if((!(f>>>0>=v>>>0&((j>>>0>s>>>0|w>>>0>q>>>0|B>>>0>l>>>0|D|y)^1))?(c[t>>2]=j>>>0<s>>>0?j:s,c[k>>2]=w>>>0<q>>>0?w:q,c[F>>2]=B>>>0<l>>>0?B:l,c[E>>2]=D?r:G,c[u>>2]=y?p:z,c[A>>2]=f>>>0<v>>>0?v:f,f=n>>>5,v=1<<(n&31),(c[(c[e+96>>2]|0)+(f<<2)>>2]&v|0)==0):0)?(n=(c[e+68>>2]|0)+(f<<2)|0,f=c[n>>2]|0,(f&v|0)==0):0)c[n>>2]=f|v;do if((h|0)==1073741823){v=e+292|0;f=c[v>>2]|0;if((f|0)==1073741823){n=c[e+264>>2]<<1;m$a(e+244|0,n>>>0<64?64:n);I=c[v>>2]|0}else I=f;f=c[e+248>>2]|0;c[v>>2]=c[f+(I*24|0)>>2];g[f+(I*24|0)>>2]=ea(8507058669999999534545717.0e13);g[f+(I*24|0)+4>>2]=ea(8507058669999999534545717.0e13);g[f+(I*24|0)+8>>2]=ea(8507058669999999534545717.0e13);g[f+(I*24|0)+12>>2]=ea(-8507058669999999534545717.0e13);g[f+(I*24|0)+16>>2]=ea(-8507058669999999534545717.0e13);g[f+(I*24|0)+20>>2]=ea(-8507058669999999534545717.0e13);f=e+252|0;a[(c[f>>2]|0)+I>>0]=0;c[(c[e+260>>2]|0)+(I<<2)>>2]=x;v=o+(x*1048|0)+1040|0;n=c[v>>2]|0;A=(c[e+256>>2]|0)+(I<<2)|0;if((n|0)==1073741823){c[A>>2]=1073741823;c[v>>2]=I;J=f;K=I;break}else{c[A>>2]=n;c[v>>2]=I;J=f;K=I;break}}else{J=e+252|0;K=h>>>1}while(0);h=K<<1|1;c[(c[e+312>>2]|0)+(H<<2)>>2]=h;I=(c[J>>2]|0)+K|0;a[I>>0]=(a[I>>0]|0)+1<<24>>24;I=1<<(K&31);J=K>>>5;f=(c[e+280>>2]|0)+(J<<2)|0;c[f>>2]=c[f>>2]&~I;if(!(a[o+(x*1048|0)+1024>>0]|0)){x=(c[e+268>>2]|0)+(J<<2)|0;c[x>>2]=c[x>>2]|I}if(H>>>0<536870911&K>>>0<536870911){c[b>>2]=H<<1|1;c[b+4>>2]=h;i=m;return}else{c[b>>2]=1073741823;c[b+4>>2]=1073741823;i=m;return}}function npa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+40|0;g=c[f>>2]|0;if((g|0)!=1073741823){h=a+20|0;c[f>>2]=c[(c[h>>2]|0)+(g<<2)>>2];j=c[a+12>>2]|0;c[j+(g*24|0)+8>>2]=-8388609;c[j+(g*24|0)+4>>2]=-8388609;c[j+(g*24|0)>>2]=-8388609;c[j+(g*24|0)+20>>2]=8388608;c[j+(g*24|0)+16>>2]=8388608;c[j+(g*24|0)+12>>2]=8388608;c[(c[a+16>>2]|0)+(g<<2)>>2]=0;c[(c[h>>2]|0)+(g<<2)>>2]=1073741823;c[(c[a+24>>2]|0)+(g<<2)>>2]=1073741823;c[(c[a+32>>2]|0)+(g<<2)>>2]=1073741823;c[(c[a+28>>2]|0)+(g<<2)>>2]=1073741823;k=g;i=b;return k|0}g=c[a+36>>2]|0;h=(g|0)==0?32:g<<1;g$a(a+8|0,h);g=((h+31|0)>>>5)+3&268435452;h=a+72|0;j=c[h>>2]|0;l=j&2147483647;if(g>>>0>l>>>0){m=a+68|0;n=c[m>>2]|0;o=UJa(d,g<<2,483416,76)|0;if(n)YEi(o|0,n|0,j<<2|0)|0;PEi(o+(l<<2)|0,0,g-j<<2|0)|0;VJa(e,n);c[m>>2]=o;c[h>>2]=g|-2147483648}h=a+100|0;o=c[h>>2]|0;m=o&2147483647;if(g>>>0>m>>>0){n=a+96|0;j=c[n>>2]|0;l=UJa(d,g<<2,483416,76)|0;if(j)YEi(l|0,j|0,o<<2|0)|0;PEi(l+(m<<2)|0,0,g-o<<2|0)|0;VJa(e,j);c[n>>2]=l;c[h>>2]=g|-2147483648}h=a+128|0;l=c[h>>2]|0;n=l&2147483647;if(g>>>0>n>>>0){j=a+124|0;o=c[j>>2]|0;m=UJa(d,g<<2,483416,76)|0;if(o)YEi(m|0,o|0,l<<2|0)|0;PEi(m+(n<<2)|0,0,g-l<<2|0)|0;VJa(e,o);c[j>>2]=m;c[h>>2]=g|-2147483648}g=c[f>>2]|0;h=a+20|0;c[f>>2]=c[(c[h>>2]|0)+(g<<2)>>2];f=c[a+12>>2]|0;c[f+(g*24|0)+8>>2]=-8388609;c[f+(g*24|0)+4>>2]=-8388609;c[f+(g*24|0)>>2]=-8388609;c[f+(g*24|0)+20>>2]=8388608;c[f+(g*24|0)+16>>2]=8388608;c[f+(g*24|0)+12>>2]=8388608;c[(c[a+16>>2]|0)+(g<<2)>>2]=0;c[(c[h>>2]|0)+(g<<2)>>2]=1073741823;c[(c[a+24>>2]|0)+(g<<2)>>2]=1073741823;c[(c[a+32>>2]|0)+(g<<2)>>2]=1073741823;c[(c[a+28>>2]|0)+(g<<2)>>2]=1073741823;k=g;i=b;return k|0}function opa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=a+328|0;f=c[e>>2]|0;if((f|0)!=1073741823){g=a+308|0;c[e>>2]=c[(c[g>>2]|0)+(f<<2)>>2];h=c[a+300>>2]|0;c[h+(f*24|0)+8>>2]=-8388609;c[h+(f*24|0)+4>>2]=-8388609;c[h+(f*24|0)>>2]=-8388609;c[h+(f*24|0)+20>>2]=8388608;c[h+(f*24|0)+16>>2]=8388608;c[h+(f*24|0)+12>>2]=8388608;c[(c[a+304>>2]|0)+(f<<2)>>2]=0;c[(c[g>>2]|0)+(f<<2)>>2]=1073741823;c[(c[a+312>>2]|0)+(f<<2)>>2]=1073741823;c[(c[a+320>>2]|0)+(f<<2)>>2]=1073741823;c[(c[a+316>>2]|0)+(f<<2)>>2]=1073741823;j=f;i=b;return j|0}f=c[a+324>>2]|0;g=(f|0)==0?32:f<<1;g$a(a+296|0,g);f=((g+31|0)>>>5)+3&268435452;g=a+360|0;h=c[g>>2]|0;k=h&2147483647;if(f>>>0>k>>>0){l=a+356|0;m=c[l>>2]|0;n=UJa(b+1|0,f<<2,483416,76)|0;if(m)YEi(n|0,m|0,h<<2|0)|0;PEi(n+(k<<2)|0,0,f-h<<2|0)|0;VJa(d,m);c[l>>2]=n;c[g>>2]=f|-2147483648}f=c[e>>2]|0;g=a+308|0;c[e>>2]=c[(c[g>>2]|0)+(f<<2)>>2];e=c[a+300>>2]|0;c[e+(f*24|0)+8>>2]=-8388609;c[e+(f*24|0)+4>>2]=-8388609;c[e+(f*24|0)>>2]=-8388609;c[e+(f*24|0)+20>>2]=8388608;c[e+(f*24|0)+16>>2]=8388608;c[e+(f*24|0)+12>>2]=8388608;c[(c[a+304>>2]|0)+(f<<2)>>2]=0;c[(c[g>>2]|0)+(f<<2)>>2]=1073741823;c[(c[a+312>>2]|0)+(f<<2)>>2]=1073741823;c[(c[a+320>>2]|0)+(f<<2)>>2]=1073741823;c[(c[a+316>>2]|0)+(f<<2)>>2]=1073741823;j=f;i=b;return j|0}function ppa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+1024|0;g=f;h=e+1025|0;j=a[h>>0]|0;k=j&255;YEi(g|0,e|0,1024)|0;PEi(e|0,0,1024)|0;if(j<<24>>24){j=0;do{l=j;j=j+1|0;if(j>>>0<k>>>0){m=j;do{n=((da(m+-1|0,m)|0)>>>1)+l|0;o=m;m=m+1|0;if(1<<(n&31)&c[g+(n>>>5<<2)>>2]){n=((da(m,o)|0)>>>1)+j|0;o=e+(n>>>5<<2)|0;c[o>>2]=c[o>>2]|1<<(n&31)}}while((m|0)!=(k|0))}}while((j|0)!=(k|0))}k=c[b+49860>>2]|0;if(!k){i=f;return}j=b+24|0;g=b+180|0;m=k;k=c[b+49856>>2]|0;do{m=m+-1|0;l=c[j>>2]|0;n=c[l+(c[k>>2]<<2)>>2]|0;if(!(n&1))p=0;else p=(c[g>>2]|0)+((n>>>1)*1048|0)|0;n=c[l+(c[k+4>>2]<<2)>>2]|0;if(!(n&1))q=0;else q=(c[g>>2]|0)+((n>>>1)*1048|0)|0;n=(q|0)!=0;do if(!p){if(n&(q|0)==(e|0)){l=k+8|0;c[l>>2]=Mpa(b,c[l>>2]|0,d[h>>0]|0,1,0,-1)|0}}else{l=(p|0)==(e|0);if(!n){if(!l)break;o=k+8|0;c[o>>2]=Mpa(b,c[o>>2]|0,d[h>>0]|0,1,0,-1)|0;break}if(l){l=k+8|0;c[l>>2]=Mpa(b,c[l>>2]|0,d[h>>0]|0,d[q+1025>>0]|0,0,-1)|0;break}if((q|0)==(e|0)){l=k+8|0;c[l>>2]=Mpa(b,c[l>>2]|0,d[p+1025>>0]|0,d[h>>0]|0,-1,0)|0}}while(0);k=k+12|0}while((m|0)!=0);i=f;return}function qpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if(!(b&1)){n$a(a+8|0,b>>>1,c);i=d;return}else{n$a(a+296|0,b>>>1,c);i=d;return}}function rpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if(!(b&1)){o$a(a+8|0,b>>>1,c);i=d;return}else{o$a(a+296|0,b>>>1,c);i=d;return}}function spa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;g=e>>>1;if(!(e&1)){tpa(b,g);h=e>>>6;e=(c[b+68>>2]|0)+(h<<2)|0;j=c[e>>2]|0;k=1<<(g&31);if(j&k)c[e>>2]=j&~k;j=(c[b+96>>2]|0)+(h<<2)|0;e=c[j>>2]|0;if(!(e&k)){l=(c[b+124>>2]|0)+(h<<2)|0;c[l>>2]=c[l>>2]|k}else c[j>>2]=e&~k;k=(c[(c[b+24>>2]|0)+(g<<2)>>2]|0)>>>1;e=(c[b+156>>2]|0)+(k<<2)|0;j=c[e>>2]|0;l=c[b+28>>2]|0;h=c[l+(j<<2)>>2]|0;if((g|0)!=(j|0)){m=h;n=j;while(1){o=c[l+(m<<2)>>2]|0;if((m|0)==(g|0))break;else{j=m;m=o;n=j}}c[l+(n<<2)>>2]=o;c[l+(g<<2)>>2]=1073741823;p=0;i=f;return p|0}if((h|0)==1073741823){c[e>>2]=1073741823;o=b+172|0;c[(c[b+168>>2]|0)+(c[o>>2]<<2)>>2]=k;c[o>>2]=(c[o>>2]|0)+1;c[l+(g<<2)>>2]=1073741823;p=1;i=f;return p|0}else{c[e>>2]=h;p=0;i=f;return p|0}}h=b+312|0;e=c[(c[h>>2]|0)+(g<<2)>>2]|0;l=e>>>1;o=c[(c[b+260>>2]|0)+(l<<2)>>2]|0;k=b+180|0;n=c[k>>2]|0;if(!(a[n+(o*1048|0)+1024>>0]|0)){m=(c[b+268>>2]|0)+(e>>>6<<2)|0;c[m>>2]=c[m>>2]|1<<(l&31)}m=(c[b+252>>2]|0)+l|0;j=a[m>>0]|0;a[m>>0]=j+-1<<24>>24;if((j&255)>1)q=0;else{j=(c[b+280>>2]|0)+(e>>>6<<2)|0;c[j>>2]=c[j>>2]|1<<(l&31);q=1}l=n+(o*1048|0)+1026|0;a[l>>0]=(a[l>>0]|0)+-1<<24>>24;j=o>>>5;e=b+356|0;m=(c[e>>2]|0)+(j<<2)|0;r=c[m>>2]|0;s=1<<(o&31);if(!(r&s))c[m>>2]=r|s;r=b+308|0;c[(c[r>>2]|0)+(g<<2)>>2]=1073741823;m=b+320|0;c[(c[m>>2]|0)+(g<<2)>>2]=1073741823;t=n+(o*1048|0)+1032|0;u=c[t>>2]|0;if((u|0)==(g|0))v=-1;else{w=c[b+316>>2]|0;x=u;u=0;while(1){x=c[w+(x<<2)>>2]|0;if((x|0)==(g|0))break;else u=u+1|0}v=-2-u|0}u=v+(d[n+(o*1048|0)+1025>>0]|0)|0;v=b+184|0;g=(c[v>>2]|0)+(o<<4)+(u>>>5<<2)|0;c[g>>2]=1<<(u&31)|c[g>>2];if(a[l>>0]|0){p=q;i=f;return p|0}l=c[n+(o*1048|0)+1028>>2]|0;tpa(b,l);n=(c[e>>2]|0)+(j<<2)|0;e=c[n>>2]|0;if(e&s)c[n>>2]=e&~s;e=l>>>5;n=(c[b+68>>2]|0)+(e<<2)|0;g=c[n>>2]|0;u=1<<(l&31);if(g&u)c[n>>2]=g&~u;g=(c[b+96>>2]|0)+(e<<2)|0;n=c[g>>2]|0;if(!(n&u)){l=(c[b+124>>2]|0)+(e<<2)|0;c[l>>2]=c[l>>2]|u}else c[g>>2]=n&~u;u=c[t>>2]|0;if((u|0)!=1073741823){t=b+316|0;n=b+300|0;g=b+304|0;l=b+328|0;e=b+340|0;x=b+332|0;w=b+352|0;y=b+344|0;z=c[t>>2]|0;A=c[m>>2]|0;B=u;do{u=B;B=c[z+(B<<2)>>2]|0;C=c[A+(u<<2)>>2]|0;do if((C|0)!=1073741823)if(!(c[(c[r>>2]|0)+(u<<2)>>2]|0)){c[(c[x>>2]|0)+(C<<3)>>2]=c[e>>2];c[e>>2]=C;break}else{c[(c[y>>2]|0)+(C<<4)>>2]=c[w>>2];c[w>>2]=C;break}while(0);C=c[n>>2]|0;c[C+(u*24|0)+8>>2]=-8388609;c[C+(u*24|0)+4>>2]=-8388609;c[C+(u*24|0)>>2]=-8388609;c[C+(u*24|0)+20>>2]=8388608;c[C+(u*24|0)+16>>2]=8388608;c[C+(u*24|0)+12>>2]=8388608;c[(c[g>>2]|0)+(u<<2)>>2]=0;C=(c[r>>2]|0)+(u<<2)|0;c[C>>2]=1073741823;c[(c[h>>2]|0)+(u<<2)>>2]=1073741823;A=c[m>>2]|0;c[A+(u<<2)>>2]=1073741823;z=c[t>>2]|0;c[z+(u<<2)>>2]=1073741823;c[C>>2]=c[l>>2];c[l>>2]=u}while((B|0)!=1073741823)}B=c[k>>2]|0;a[B+(o*1048|0)+1024>>0]=1;a[B+(o*1048|0)+1025>>0]=0;a[B+(o*1048|0)+1026>>0]=0;c[B+(o*1048|0)+1028>>2]=1073741823;c[B+(o*1048|0)+1032>>2]=1073741823;c[B+(o*1048|0)+1044>>2]=0;B=~s;s=(c[b+220>>2]|0)+(j<<2)|0;c[s>>2]=c[s>>2]&B;s=(c[b+232>>2]|0)+(j<<2)|0;c[s>>2]=c[s>>2]&B;B=(c[v>>2]|0)+(o<<4)|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;B=(c[b+188>>2]|0)+(o<<4)|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;p=q;i=f;return p|0}function tpa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=a+49860|0;g=c[f>>2]|0;if(!g){i=d;return}h=a+49856|0;a=g;g=0;a:while(1){j=a;while(1){j=j+-1|0;k=c[h>>2]|0;if((c[k+(g*12|0)>>2]|0)!=(b|0)?(c[k+(g*12|0)+4>>2]|0)!=(b|0):0)break;l=c[k+(g*12|0)+8>>2]|0;if(!l)m=k;else{k=c[l>>2]|0;if((k|0)!=0?(c[l+4>>2]|0)>-1:0)VJa(l+8|0,k);VJa(e,l);c[(c[h>>2]|0)+(g*12|0)+8>>2]=0;m=c[h>>2]|0}l=m+(g*12|0)|0;k=(c[f>>2]|0)+-1|0;c[f>>2]=k;n=m+(k*12|0)|0;c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];if(!j){o=13;break a}}if(!j){o=13;break}else{a=j;g=g+1|0}}if((o|0)==13){i=d;return}}function upa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=d+12|0;g=c[d>>2]|0;h=((g|0)<0?~g:g|-2147483648)+-16&-16;g=c[d+4>>2]|0;j=((g|0)<0?~g:g|-2147483648)+-16&-16;g=c[d+8>>2]|0;d=((g|0)<0?~g:g|-2147483648)+-16&-16;g=c[f>>2]|0;k=((g|0)<0?~g:g|-2147483648)+16&-16|1;g=c[f+4>>2]|0;l=((g|0)<0?~g:g|-2147483648)+16&-16|1;g=c[f+8>>2]|0;f=((g|0)<0?~g:g|-2147483648)+16&-16|1;g=b>>>1;if(b&1){m=c[a+300>>2]|0;c[m+(g*24|0)>>2]=h;c[m+(g*24|0)+4>>2]=j;c[m+(g*24|0)+8>>2]=d;c[m+(g*24|0)+12>>2]=k;c[m+(g*24|0)+16>>2]=l;c[m+(g*24|0)+20>>2]=f;m=c[(c[a+260>>2]|0)+((c[(c[a+312>>2]|0)+(g<<2)>>2]|0)>>>1<<2)>>2]|0;n=(c[a+356>>2]|0)+(m>>>5<<2)|0;o=c[n>>2]|0;p=1<<(m&31);if(o&p){i=e;return}c[n>>2]=o|p;i=e;return}p=c[a+12>>2]|0;c[p+(g*24|0)>>2]=h;c[p+(g*24|0)+4>>2]=j;c[p+(g*24|0)+8>>2]=d;c[p+(g*24|0)+12>>2]=k;c[p+(g*24|0)+16>>2]=l;c[p+(g*24|0)+20>>2]=f;f=b>>>6;b=1<<(g&31);if(c[(c[a+96>>2]|0)+(f<<2)>>2]&b){i=e;return}g=(c[a+68>>2]|0)+(f<<2)|0;f=c[g>>2]|0;if(f&b){i=e;return}c[g>>2]=f|b;i=e;return}function vpa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!(d&1)){i=e;return}f=d>>>1;if(a[(c[b+180>>2]|0)+((c[(c[b+260>>2]|0)+(f<<2)>>2]|0)*1048|0)+1024>>0]|0){i=e;return}g=(c[b+268>>2]|0)+(d>>>6<<2)|0;c[g>>2]=c[g>>2]|1<<(f&31);i=e;return}function wpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=c[b+12>>2]|0;b=c[e+(d*24|0)>>2]|0;f=c[e+(d*24|0)+4>>2]|0;g=c[e+(d*24|0)+8>>2]|0;h=c[e+(d*24|0)+12>>2]|0;i=c[e+(d*24|0)+16>>2]|0;j=c[e+(d*24|0)+20>>2]|0;d=a+12|0;c[a>>2]=(b|0)<0?b&2147483647:~b;c[a+4>>2]=(f|0)<0?f&2147483647:~f;c[a+8>>2]=(g|0)<0?g&2147483647:~g;c[d>>2]=(h|0)<0?h&2147483647:~h;c[d+4>>2]=(i|0)<0?i&2147483647:~i;c[d+8>>2]=(j|0)<0?j&2147483647:~j;return}function xpa(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=i;i=i+32|0;n=m+20|0;o=m;c[o>>2]=d;c[o+4>>2]=e;c[o+8>>2]=f;a[o+12>>0]=k&1;c[o+16>>2]=l;l=c[b+36>>2]|0;if(l){do if(l>>>0>4096){k=l<<2;f=k+15&-16;e=c[b+16896>>2]|0;if(!e){d=UJa(n,f,483416,1936)|0;c[b+16900>>2]=d;p=k;q=d;break}else{d=p$a(e,f,1)|0;c[b+16900>>2]=d;p=k;q=d;break}}else{d=b+512|0;c[b+16900>>2]=d;p=l<<2;q=d}while(0);PEi(q|0,0,p|0)|0;c[b+16904>>2]=l}c[b+16912>>2]=0;l=c[b+324>>2]|0;if(l){do if(l>>>0>4096){p=l<<2;q=p+15&-16;d=c[b+33312>>2]|0;if(!d){k=UJa(n,q,483416,1936)|0;c[b+33316>>2]=k;r=p;s=k;break}else{k=p$a(d,q,1)|0;c[b+33316>>2]=k;r=p;s=k;break}}else{k=b+16928|0;c[b+33316>>2]=k;r=l<<2;s=k}while(0);PEi(s|0,0,r|0)|0;c[b+33320>>2]=l}c[b+33328>>2]=0;l=c[b+264>>2]|0;if(l){do if(l>>>0>1024){r=l<<2;s=r+15&-16;k=c[b+37440>>2]|0;if(!k){p=UJa(n,s,483416,1936)|0;c[b+37444>>2]=p;t=r;u=p;break}else{p=p$a(k,s,1)|0;c[b+37444>>2]=p;t=r;u=p;break}}else{p=b+33344|0;c[b+37444>>2]=p;t=l<<2;u=p}while(0);PEi(u|0,0,t|0)|0;c[b+37448>>2]=l}l=c[b+196>>2]|0;if(l){do if(l>>>0>1024){t=l<<2;u=t+15&-16;p=c[b+41552>>2]|0;if(!p){r=UJa(n,u,483416,1936)|0;c[b+41556>>2]=r;v=t;w=r;break}else{r=p$a(p,u,1)|0;c[b+41556>>2]=r;v=t;w=r;break}}else{r=b+37456|0;c[b+41556>>2]=r;v=l<<2;w=r}while(0);PEi(w|0,0,v|0)|0;c[b+41560>>2]=l}c[b+41568>>2]=0;ypa(b,h,j,o);zpa(b);PEi(c[b+280>>2]|0,0,c[b+284>>2]<<2|0)|0;j=c[b+136>>2]|0;h=c[b+140>>2]|0;if(h){l=b+32|0;v=b+20|0;w=b+12|0;n=b+16|0;r=b+24|0;t=b+28|0;u=b+40|0;p=b+52|0;s=b+44|0;k=b+64|0;q=b+56|0;d=c[l>>2]|0;f=0;do{e=c[j+(f<<2)>>2]|0;x=c[d+(e<<2)>>2]|0;do if((x|0)!=1073741823)if(!(c[(c[v>>2]|0)+(e<<2)>>2]|0)){c[(c[s>>2]|0)+(x<<3)>>2]=c[p>>2];c[p>>2]=x;break}else{c[(c[q>>2]|0)+(x<<4)>>2]=c[k>>2];c[k>>2]=x;break}while(0);x=c[w>>2]|0;c[x+(e*24|0)+8>>2]=-8388609;c[x+(e*24|0)+4>>2]=-8388609;c[x+(e*24|0)>>2]=-8388609;c[x+(e*24|0)+20>>2]=8388608;c[x+(e*24|0)+16>>2]=8388608;c[x+(e*24|0)+12>>2]=8388608;c[(c[n>>2]|0)+(e<<2)>>2]=0;x=(c[v>>2]|0)+(e<<2)|0;c[x>>2]=1073741823;c[(c[r>>2]|0)+(e<<2)>>2]=1073741823;d=c[l>>2]|0;c[d+(e<<2)>>2]=1073741823;c[(c[t>>2]|0)+(e<<2)>>2]=1073741823;c[x>>2]=c[u>>2];c[u>>2]=e;f=f+1|0}while((f|0)!=(h|0))}h=b+49868|0;c[b+49888>>2]=3;f=b+51100|0;c[b+51120>>2]=2;u=b+51556|0;c[b+51596>>2]=b;c[b+51124>>2]=b;t=b+51056|0;c[b+51096>>2]=b;d=b+51012|0;c[b+51032>>2]=b;l=b+50608|0;c[b+50628>>2]=b;c[b+49892>>2]=b;r=b+50324|0;c[b+50344>>2]=b;v=b+51576|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];v=b+51128|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];v=b+51076|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];v=b+51036|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];v=b+50632|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];v=b+49896|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];v=b+50348|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];c[b+51572>>2]=1;o=b+51568|0;c[o>>2]=g;if(g){ko[c[(c[g>>2]|0)+16>>2]&4095](g);c[b+51564>>2]=c[(c[o>>2]|0)+8>>2]}c[b+51116>>2]=1;o=b+51112|0;c[o>>2]=u;ko[c[(c[u>>2]|0)+16>>2]&4095](u);c[b+51108>>2]=c[(c[o>>2]|0)+8>>2];c[b+51072>>2]=1;o=b+51068|0;c[o>>2]=f;ko[c[(c[f>>2]|0)+16>>2]&4095](f);c[b+51064>>2]=c[(c[o>>2]|0)+8>>2];c[b+51028>>2]=1;o=b+51024|0;c[o>>2]=t;ko[c[(c[t>>2]|0)+16>>2]&4095](t);c[b+51020>>2]=c[(c[o>>2]|0)+8>>2];c[b+50624>>2]=1;o=b+50620|0;c[o>>2]=d;ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[b+50616>>2]=c[(c[o>>2]|0)+8>>2];c[b+49884>>2]=1;o=b+49880|0;c[o>>2]=l;ko[c[(c[l>>2]|0)+16>>2]&4095](l);c[b+49876>>2]=c[(c[o>>2]|0)+8>>2];c[b+50340>>2]=1;o=b+50336|0;c[o>>2]=h;ko[c[(c[h>>2]|0)+16>>2]&4095](h);c[b+50332>>2]=c[(c[o>>2]|0)+8>>2];ko[c[(c[u>>2]|0)+20>>2]&4095](u);ko[c[(c[f>>2]|0)+20>>2]&4095](f);ko[c[(c[t>>2]|0)+20>>2]&4095](t);ko[c[(c[d>>2]|0)+20>>2]&4095](d);ko[c[(c[l>>2]|0)+20>>2]&4095](l);ko[c[(c[h>>2]|0)+20>>2]&4095](h);ko[c[(c[r>>2]|0)+20>>2]&4095](r);i=m;return}function ypa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;f=i;i=i+160|0;g=f+157|0;h=f+156|0;j=f;k=f+144|0;l=b+268|0;do if(c[l>>2]|0){m=c[b+196>>2]|0;n=c[b>>2]|0;o=j+128|0;c[o>>2]=n;p=j+132|0;c[p>>2]=0;q=j+136|0;c[q>>2]=0;if(m){r=(m+31|0)>>>5;do if(m>>>0>1024){s=(r<<2)+15&1073741808;if(!n){t=UJa(g,s,483416,2004)|0;c[p>>2]=t;u=r|-2147483648;c[q>>2]=u;v=u;w=t;break}else{t=p$a(n,s,1)|0;c[p>>2]=t;s=r|-2147483648;c[q>>2]=s;v=s;w=t;break}}else{c[p>>2]=j;t=r|-2147483648;c[q>>2]=t;v=t;w=j}while(0);PEi(w|0,0,v<<2|0)|0}q=c[b+41556>>2]|0;r=b+272|0;n=c[r>>2]&2147483647;a:do if(n){m=c[l>>2]|0;t=0;while(1){x=c[m+(t<<2)>>2]|0;if(x)break;s=t+1|0;if(s>>>0<n>>>0)t=s;else{y=0;break a}}s=c[425648+((da(x&0-x,125613361)|0)>>>27<<2)>>2]|t<<5;u=x+-1&x;b:do if(!u){z=t;while(1){A=z+1|0;if(A>>>0>=n>>>0){B=A;C=0;break b}D=c[m+(A<<2)>>2]|0;if(!D)z=A;else{B=A;C=D;break}}}else{B=t;C=u}while(0);if((s|0)!=-1){u=b+356|0;t=b+96|0;m=b+68|0;z=c[b+260>>2]|0;D=c[b+180>>2]|0;A=B;E=C;F=0;G=s;while(1){H=A<<5;I=E;J=F;K=G;while(1){L=c[z+(K<<2)>>2]|0;if(a[D+(L*1048|0)+1025>>0]|0){M=L>>>5;N=(c[p>>2]|0)+(M<<2)|0;O=c[N>>2]|0;P=1<<(L&31);if(!(O&P)){c[N>>2]=O|P;c[q+(J<<2)>>2]=L;Q=J+1|0}else Q=J;O=(c[u>>2]|0)+(M<<2)|0;M=c[O>>2]|0;if(!(M&P))c[O>>2]=M|P;P=c[D+(L*1048|0)+1028>>2]|0;L=P>>>5;M=1<<(P&31);if((c[(c[t>>2]|0)+(L<<2)>>2]&M|0)==0?(P=(c[m>>2]|0)+(L<<2)|0,L=c[P>>2]|0,(L&M|0)==0):0){c[P>>2]=L|M;R=Q}else R=Q}else R=J;if(!I){y=R;break a}K=c[425648+((da(I&0-I,125613361)|0)>>>27<<2)>>2]|H;I=I+-1&I;S=c[r>>2]&2147483647;if(!I){T=A;break}if((K|0)==-1){y=R;break a}else J=R}while(1){T=T+1|0;if(T>>>0>=S>>>0){U=0;break}J=c[(c[l>>2]|0)+(T<<2)>>2]|0;if(J){U=J;break}}if((K|0)==-1){y=R;break}else{A=T;E=U;F=R;G=K}}}else y=0}else y=0;while(0);c[b+41568>>2]=y;r=c[p>>2]|0;if(!((r|0)==0|(r|0)==(j|0))){q=c[o>>2]|0;if(!q){VJa(h,r);break}n=c[q+16>>2]|0;if(n>>>0<=r>>>0?(n+(c[q+20>>2]|0)|0)>>>0>r>>>0:0){oTa(c[q>>2]|0);n=q+8|0;G=c[n>>2]|0;F=q+4|0;E=c[F>>2]|0;A=G;while(1){m=A+-1|0;V=E+(m<<2)|0;if((c[V>>2]|0)>>>0<r>>>0)A=m;else break}if(A>>>0<G>>>0){E=A;o=V;while(1){if(o)c[o>>2]=c[(c[F>>2]|0)+(E<<2)>>2];E=E+1|0;if((E|0)==(G|0))break;else o=o+4|0}}c[n>>2]=G+-1;pTa(c[q>>2]|0);break}VJa(g,r)}}while(0);g=c[b+16900>>2]|0;V=k+4|0;c[k>>2]=d;c[V>>2]=e|-2147483648;h=e&2147483647;c:do if(h){j=0;while(1){W=c[d+(j<<2)>>2]|0;if(W)break;y=j+1|0;if(y>>>0<h>>>0)j=y;else{X=y;Y=0;Z=-1;break c}}r=c[425648+((da(W&0-W,125613361)|0)>>>27<<2)>>2]|j<<5;q=W+-1&W;G=e&2147483647;if(!q){n=j;while(1){y=n+1|0;if(y>>>0>=G>>>0){X=y;Y=0;Z=r;break c}R=c[d+(y<<2)>>2]|0;if(!R)n=y;else{X=y;Y=R;Z=r;break}}}else{X=j;Y=q;Z=r}}else{X=0;Y=0;Z=-1}while(0);e=b+156|0;W=b+96|0;h=b+68|0;n=b+28|0;G=b+260|0;R=b+180|0;y=b+356|0;U=X;X=Y;Y=0;T=Z;d:while(1){Z=U<<5;l=X;_=Y;S=T;while(1){Q=S;while(1)if((Q|0)==1073741823)Q=1073741823;else if((Q|0)==-1)break d;else break;C=Q>>>1;if(!(Q&1)){B=c[(c[e>>2]|0)+(C<<2)>>2]|0;if((B|0)==1073741823)$=_;else{x=c[W>>2]|0;v=_;w=B;while(1){c[g+(v<<2)>>2]=w;B=v+1|0;o=w>>>5;E=1<<(w&31);if((c[x+(o<<2)>>2]&E|0)==0?(F=(c[h>>2]|0)+(o<<2)|0,o=c[F>>2]|0,(o&E|0)==0):0)c[F>>2]=o|E;w=c[(c[n>>2]|0)+(w<<2)>>2]|0;if((w|0)==1073741823){$=B;break}else v=B}}}else{v=c[(c[G>>2]|0)+(C<<2)>>2]|0;w=c[R>>2]|0;if(a[w+(v*1048|0)+1025>>0]|0){x=(c[y>>2]|0)+(v>>>5<<2)|0;Q=c[x>>2]|0;B=1<<(v&31);if(!(Q&B))c[x>>2]=Q|B;B=c[w+(v*1048|0)+1028>>2]|0;v=B>>>5;w=1<<(B&31);if((c[(c[W>>2]|0)+(v<<2)>>2]&w|0)==0?(B=(c[h>>2]|0)+(v<<2)|0,v=c[B>>2]|0,(v&w|0)==0):0){c[B>>2]=v|w;$=_}else $=_}else $=_}if(!l){l=0;_=$;S=-1;continue}S=c[425648+((da(l&0-l,125613361)|0)>>>27<<2)>>2]|Z;l=l+-1&l;aa=c[V>>2]&2147483647;if(!l){ba=U;break}else _=$}while(1){l=ba+1|0;if(l>>>0>=aa>>>0){U=l;X=0;Y=$;T=S;continue d}Z=c[d+(l<<2)>>2]|0;if(!Z)ba=l;else{U=l;X=Z;Y=$;T=S;continue d}}}c[b+16912>>2]=_;if((d|0)!=0&(c[V>>2]|0)>-1)VJa(k+8|0,d);q$a(b+356|0);d=c[b+33316>>2]|0;k=c[b+372>>2]|0;V=c[b+368>>2]|0;if(!k){ca=0;ea=b+33328|0;c[ea>>2]=ca;fa=b+68|0;q$a(fa);ga=b+96|0;q$a(ga);ha=b+124|0;q$a(ha);i=f;return}_=b+232|0;T=b+308|0;$=b+316|0;Y=c[R>>2]|0;R=0;X=0;while(1){U=c[V+(X<<2)>>2]|0;if((a[Y+(U*1048|0)+1024>>0]|0)==0?(c[(c[_>>2]|0)+(U>>>5<<2)>>2]&1<<(U&31)|0)==0:0)ia=R;else{ba=c[Y+(U*1048|0)+1032>>2]|0;if((ba|0)==1073741823)ja=R;else{aa=c[T>>2]|0;y=R;G=ba;while(1){if((c[aa+(G<<2)>>2]|0)==1073741823)ka=y;else{c[d+(y<<2)>>2]=G;ka=y+1|0}G=c[(c[$>>2]|0)+(G<<2)>>2]|0;if((G|0)==1073741823){ja=ka;break}else y=ka}}y=c[Y+(U*1048|0)+1028>>2]|0;G=y>>>5;aa=1<<(y&31);if((c[(c[W>>2]|0)+(G<<2)>>2]&aa|0)==0?(y=(c[h>>2]|0)+(G<<2)|0,G=c[y>>2]|0,(G&aa|0)==0):0){c[y>>2]=G|aa;ia=ja}else ia=ja}X=X+1|0;if((X|0)==(k|0)){ca=ia;break}else R=ia}ea=b+33328|0;c[ea>>2]=ca;fa=b+68|0;q$a(fa);ga=b+96|0;q$a(ga);ha=b+124|0;q$a(ha);i=f;return}function zpa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+544|0;e=d+528|0;f=d;g=b+280|0;if(!(c[g>>2]|0)){i=d;return}h=c[b+196>>2]|0;j=c[b>>2]|0;c[f+512>>2]=j;k=f+516|0;c[k>>2]=0;l=f+520|0;c[l>>2]=0;if(h){m=(h+31|0)>>>5;do if(h>>>0>4096){n=(m<<2)+15&1073741808;if(!j){o=UJa(e,n,483416,2004)|0;c[k>>2]=o;p=m|-2147483648;c[l>>2]=p;q=p;r=o;break}else{o=p$a(j,n,1)|0;c[k>>2]=o;n=m|-2147483648;c[l>>2]=n;q=n;r=o;break}}else{c[k>>2]=f;o=m|-2147483648;c[l>>2]=o;q=o;r=f}while(0);PEi(r|0,0,q<<2|0)|0}q=b+284|0;r=c[q>>2]&2147483647;a:do if(r){m=c[g>>2]|0;j=0;while(1){s=c[m+(j<<2)>>2]|0;if(s)break;e=j+1|0;if(e>>>0<r>>>0)j=e;else break a}e=c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|j<<5;h=s+-1&s;b:do if(!h){o=j;while(1){n=o+1|0;if(n>>>0>=r>>>0){t=n;u=0;break b}p=c[m+(n<<2)>>2]|0;if(!p)o=n;else{t=n;u=p;break}}}else{t=j;u=h}while(0);if((e|0)!=-1){h=c[b+260>>2]|0;j=c[k>>2]|0;m=t;o=u;p=e;while(1){n=m<<5;v=o;w=p;while(1){x=c[h+(w<<2)>>2]|0;y=j+(x>>>5<<2)|0;c[y>>2]=c[y>>2]|1<<(x&31);if(!v)break a;w=c[425648+((da(v&0-v,125613361)|0)>>>27<<2)>>2]|n;v=v+-1&v;z=c[q>>2]&2147483647;if(!v){A=m;break}if((w|0)==-1)break a}while(1){A=A+1|0;if(A>>>0>=z>>>0){B=0;break}v=c[(c[g>>2]|0)+(A<<2)>>2]|0;if(v){B=v;break}}if((w|0)==-1)break;else{m=A;o=B;p=w}}}}while(0);B=f+516|0;A=c[l>>2]&2147483647;c:do if(A){z=c[B>>2]|0;q=0;while(1){C=c[z+(q<<2)>>2]|0;if(C)break;u=q+1|0;if(u>>>0<A>>>0)q=u;else break c}u=c[425648+((da(C&0-C,125613361)|0)>>>27<<2)>>2]|q<<5;t=C+-1&C;d:do if(!t){k=q;while(1){r=k+1|0;if(r>>>0>=A>>>0){D=r;E=0;break d}s=c[z+(r<<2)>>2]|0;if(!s)k=r;else{D=r;E=s;break}}}else{D=q;E=t}while(0);if((u|0)!=-1){t=b+180|0;q=b+252|0;z=b+256|0;k=b+292|0;w=b+248|0;s=b+260|0;r=b+268|0;p=D;o=E;m=u;while(1){j=p<<5;h=o;e=m;while(1){v=(c[t>>2]|0)+(e*1048|0)+1040|0;n=c[v>>2]|0;e:do if((n|0)!=1073741823){x=n;while(1){y=(c[q>>2]|0)+x|0;if(a[y>>0]|0)break;F=c[(c[z>>2]|0)+(x<<2)>>2]|0;c[(c[w>>2]|0)+(x*24|0)>>2]=c[k>>2];c[k>>2]=x;a[y>>0]=0;c[(c[z>>2]|0)+(x<<2)>>2]=1073741823;c[(c[s>>2]|0)+(x<<2)>>2]=1073741823;y=~(1<<(x&31));G=x>>>5;H=(c[r>>2]|0)+(G<<2)|0;c[H>>2]=c[H>>2]&y;H=(c[g>>2]|0)+(G<<2)|0;c[H>>2]=c[H>>2]&y;if((F|0)==1073741823){I=39;break e}else x=F}c[v>>2]=x;if((x|0)!=1073741823){F=c[z>>2]|0;y=x;f:while(1){H=c[F+(y<<2)>>2]|0;if((H|0)==1073741823){J=F;break}else{K=F;L=H}while(1){H=(c[q>>2]|0)+L|0;if(a[H>>0]|0)break;G=c[K+(L<<2)>>2]|0;c[(c[w>>2]|0)+(L*24|0)>>2]=c[k>>2];c[k>>2]=L;a[H>>0]=0;H=c[z>>2]|0;c[H+(L<<2)>>2]=1073741823;c[(c[s>>2]|0)+(L<<2)>>2]=1073741823;M=~(1<<(L&31));N=L>>>5;O=(c[r>>2]|0)+(N<<2)|0;c[O>>2]=c[O>>2]&M;O=(c[g>>2]|0)+(N<<2)|0;c[O>>2]=c[O>>2]&M;if((G|0)==1073741823){J=H;break f}else{K=H;L=G}}c[K+(y<<2)>>2]=L;if((L|0)==1073741823)break e;else{F=K;y=L}}c[J+(y<<2)>>2]=1073741823}}else I=39;while(0);if((I|0)==39){I=0;c[v>>2]=1073741823}if(!h)break c;e=c[425648+((da(h&0-h,125613361)|0)>>>27<<2)>>2]|j;h=h+-1&h;P=c[l>>2]&2147483647;if(!h)break;if((e|0)==-1)break c}h=c[B>>2]|0;j=p;while(1){j=j+1|0;if(j>>>0>=P>>>0){Q=0;break}n=c[h+(j<<2)>>2]|0;if(n){Q=n;break}}if((e|0)==-1)break;else{p=j;o=Q;m=e}}}}while(0);r$a(f);i=d;return}function Apa(a){a=a|0;var b=0;b=i;_pa(a+49868|0);$pa(a+50608|0);i=b;return}function Bpa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;e=i;i=i+1072|0;f=e+1060|0;g=e+528|0;h=e+1056|0;j=e;k=b+49828|0;l=c[k>>2]|0;m=mo[c[(c[l>>2]|0)+28>>2]&4095](l)|0;l=c[k>>2]|0;n=mo[c[(c[l>>2]|0)+32>>2]&4095](l)|0;if(m){l=b+24|0;o=b+16|0;p=b+51600|0;q=b+51608|0;r=b+51604|0;s=b+180|0;t=b+51612|0;u=b+51620|0;v=b+51616|0;w=m;m=n;do{w=w+-1|0;n=c[m>>2]|0;m=m+4|0;x=c[(c[l>>2]|0)+(n<<2)>>2]|0;do if(!(x&1)){y=c[(c[o>>2]|0)+(n<<2)>>2]|0;c[h>>2]=y;z=c[r>>2]|0;if((c[q>>2]&2147483647)>>>0<=z>>>0){s$a(p,h)|0;break}A=(c[p>>2]|0)+(z<<2)|0;if(A)c[A>>2]=y;c[r>>2]=z+1}else{z=(c[s>>2]|0)+((x>>>1)*1048|0)+1044|0;y=c[v>>2]|0;if((c[u>>2]&2147483647)>>>0<=y>>>0){s$a(t,z)|0;break}A=(c[t>>2]|0)+(y<<2)|0;if(A)c[A>>2]=c[z>>2];c[v>>2]=y+1}while(0)}while((w|0)!=0)}w=b+49836|0;c[w>>2]=0;v=b+49848|0;c[v>>2]=0;t=c[k>>2]|0;u=mo[c[(c[t>>2]|0)+48>>2]&4095](t)|0;t=c[k>>2]|0;s=mo[c[(c[t>>2]|0)+56>>2]&4095](t)|0;t=c[k>>2]|0;r=mo[c[(c[t>>2]|0)+52>>2]&4095](t)|0;t=c[k>>2]|0;k=mo[c[(c[t>>2]|0)+60>>2]&4095](t)|0;if(!u)B=0;else{t=b+24|0;p=b+16|0;h=b+49840|0;q=b+49832|0;o=0;l=0;while(1){m=c[r+(o<<3)>>2]|0;x=c[r+(o<<3)+4>>2]|0;n=c[t>>2]|0;if(!((c[n+(x<<2)>>2]|c[n+(m<<2)>>2])&1)){n=c[p>>2]|0;y=c[n+(m<<2)>>2]|0;z=c[n+(x<<2)>>2]|0;n=c[w>>2]|0;if((n|0)==(c[h>>2]|0)){A=(n|0)==0?32:n<<1;C=c[q>>2]|0;D=UJa(f,A<<3,483416,76)|0;if(C)YEi(D|0,C|0,n<<3|0)|0;PEi(D+(n<<3)|0,0,A-n<<3|0)|0;VJa(g,C);c[q>>2]=D;c[h>>2]=A;E=c[w>>2]|0;F=D}else{E=n;F=c[q>>2]|0}c[w>>2]=E+1;c[F+(E<<3)>>2]=y;c[F+(E<<3)+4>>2]=z;G=l}else{c[r+(l<<3)>>2]=m;c[r+(l<<3)+4>>2]=x;G=l+1|0}o=o+1|0;if((o|0)==(u|0)){B=G;break}else l=G}}if(s){G=b+24|0;l=b+16|0;u=b+49852|0;o=b+49844|0;E=0;F=0;while(1){w=c[k+(E<<3)>>2]|0;q=c[k+(E<<3)+4>>2]|0;h=c[G>>2]|0;if(!((c[h+(q<<2)>>2]|c[h+(w<<2)>>2])&1)){h=c[l>>2]|0;p=c[h+(w<<2)>>2]|0;t=c[h+(q<<2)>>2]|0;h=c[v>>2]|0;if((h|0)==(c[u>>2]|0)){x=(h|0)==0?32:h<<1;m=c[o>>2]|0;z=UJa(f,x<<3,483416,76)|0;if(m)YEi(z|0,m|0,h<<3|0)|0;PEi(z+(h<<3)|0,0,x-h<<3|0)|0;VJa(g,m);c[o>>2]=z;c[u>>2]=x;H=c[v>>2]|0;I=z}else{H=h;I=c[o>>2]|0}c[v>>2]=H+1;c[I+(H<<3)>>2]=p;c[I+(H<<3)+4>>2]=t;J=F}else{c[k+(F<<3)>>2]=w;c[k+(F<<3)+4>>2]=q;J=F+1|0}E=E+1|0;if((E|0)==(s|0))break;else F=J}if(J){F=0;do{Cpa(b,c[k+(F<<3)>>2]|0,c[k+(F<<3)+4>>2]|0)|0;F=F+1|0}while((F|0)!=(J|0))}}if(B){J=b+49860|0;F=b+49864|0;k=b+49856|0;s=0;do{E=c[r+(s<<3)>>2]|0;H=c[r+(s<<3)+4>>2]|0;I=c[J>>2]|0;if((I|0)==(c[F>>2]|0)){v=(I|0)==0?32:I<<1;o=c[k>>2]|0;u=UJa(f,v*12|0,483416,76)|0;if(o)YEi(u|0,o|0,I*12|0)|0;PEi(u+(I*12|0)|0,0,(v-I|0)*12|0)|0;VJa(g,o);c[k>>2]=u;c[F>>2]=v;K=c[J>>2]|0;L=u}else{K=I;L=c[k>>2]|0}c[J>>2]=K+1;I=E>>>0<H>>>0;c[L+(K*12|0)>>2]=I?E:H;c[L+(K*12|0)+4>>2]=I?H:E;c[L+(K*12|0)+8>>2]=0;s=s+1|0}while((s|0)!=(B|0))}B=b+196|0;s=c[B>>2]|0;if(!s){i=e;return}K=c[b>>2]|0;c[g+512>>2]=K;L=g+516|0;c[L>>2]=0;J=g+520|0;c[J>>2]=0;k=(s+31|0)>>>5;do if(s>>>0>4096){F=(k<<2)+15&1073741808;if(!K){r=UJa(f,F,483416,2004)|0;c[L>>2]=r;E=k|-2147483648;c[J>>2]=E;M=E;N=r;break}else{r=p$a(K,F,1)|0;c[L>>2]=r;F=k|-2147483648;c[J>>2]=F;M=F;N=r;break}}else{c[L>>2]=g;r=k|-2147483648;c[J>>2]=r;M=r;N=g}while(0);PEi(N|0,0,M<<2|0)|0;PEi(c[L>>2]|0,0,c[J>>2]<<2|0)|0;M=c[B>>2]|0;B=c[b>>2]|0;c[j+512>>2]=B;N=j+516|0;c[N>>2]=0;k=j+520|0;c[k>>2]=0;if(!M){O=0;P=0}else{K=(M+31|0)>>>5;do if(M>>>0>4096){s=(K<<2)+15&1073741808;if(!B){r=UJa(f,s,483416,2004)|0;c[N>>2]=r;F=K|-2147483648;c[k>>2]=F;Q=F;R=r;break}else{r=p$a(B,s,1)|0;c[N>>2]=r;s=K|-2147483648;c[k>>2]=s;Q=s;R=r;break}}else{c[N>>2]=j;r=K|-2147483648;c[k>>2]=r;Q=r;R=j}while(0);PEi(R|0,0,Q<<2|0)|0;O=c[N>>2]|0;P=c[k>>2]<<2}PEi(O|0,0,P|0)|0;P=b+49860|0;O=c[P>>2]|0;if(O){do if(O>>>0>1024){Q=O<<2;R=Q+15&-16;K=c[b+49808>>2]|0;if(!K){B=UJa(f,R,483416,1936)|0;c[b+49812>>2]=B;S=Q;T=B;break}else{B=p$a(K,R,1)|0;c[b+49812>>2]=B;S=Q;T=B;break}}else{B=b+45712|0;c[b+49812>>2]=B;S=O<<2;T=B}while(0);PEi(T|0,0,S|0)|0;c[b+49816>>2]=O}O=c[b+49812>>2]|0;S=b+356|0;T=c[b+372>>2]|0;B=c[b+368>>2]|0;if(!T)U=0;else{Q=b+232|0;R=b+220|0;K=c[b+180>>2]|0;M=0;r=0;while(1){s=c[B+(r<<2)>>2]|0;if((a[K+(s*1048|0)+1024>>0]|0)!=0?(a[K+(s*1048|0)+1026>>0]|0)!=0:0){F=(c[N>>2]|0)+(s>>>5<<2)|0;c[F>>2]=c[F>>2]|1<<(s&31);V=M+1|0}else{F=s>>>5;E=1<<(s&31);if((c[(c[Q>>2]|0)+(F<<2)>>2]&E|0)==0?(a[K+(s*1048|0)+1026>>0]|0)!=0:0){s=(c[R>>2]|0)+(F<<2)|0;c[s>>2]=c[s>>2]|E;V=M}else V=M}r=r+1|0;if((r|0)==(T|0)){U=V;break}else M=V}}V=c[P>>2]|0;if(!V){W=0;X=U}else{P=c[b+49856>>2]|0;M=c[b+24>>2]|0;T=b+68|0;r=b+96|0;R=c[N>>2]|0;N=c[L>>2]|0;L=b+220|0;K=0;Q=U;U=0;while(1){B=c[P+(U*12|0)>>2]|0;E=c[P+(U*12|0)+4>>2]|0;s=c[M+(B<<2)>>2]|0;F=(s&1|0)==0;if(F){H=B>>>5;I=1<<(B&31);if(!(c[(c[T>>2]|0)+(H<<2)>>2]&I)){u=(c[(c[r>>2]|0)+(H<<2)>>2]&I|0)!=0;if(u|F)Y=u;else Z=81}else Y=1}else Z=81;do if((Z|0)==81){Z=0;if((c[(c[S>>2]|0)+(s>>>6<<2)>>2]&1<<(s>>>1&31)|0)==0?(c[(c[r>>2]|0)+(B>>>5<<2)>>2]&1<<(B&31)|0)==0:0){Y=0;break}Y=1}while(0);B=M+(E<<2)|0;u=c[B>>2]|0;I=(u&1|0)==0;if(I){H=E>>>5;v=1<<(E&31);if((c[(c[T>>2]|0)+(H<<2)>>2]&v|0)==0?(c[(c[r>>2]|0)+(H<<2)>>2]&v|0)==0:0)if(I)if(Y)Z=91;else{_=K;$=Q}else Z=88;else Z=91}else Z=88;if((Z|0)==88){Z=0;if((c[(c[S>>2]|0)+(u>>>6<<2)>>2]&1<<(u>>>1&31)|0)==0?!((c[(c[r>>2]|0)+(E>>>5<<2)>>2]&1<<(E&31)|0)!=0|Y):0){_=K;$=Q}else Z=91}if((Z|0)==91){Z=0;if(!F){I=s>>>1;v=s>>>6;H=N+(v<<2)|0;o=1<<(I&31);if((c[H>>2]&o|0)==0?(l=(c[L>>2]|0)+(v<<2)|0,v=c[l>>2]|0,(v&o|0)!=0):0){c[l>>2]=v&~o;c[H>>2]=c[H>>2]|o;aa=c[B>>2]|0;ba=I}else{aa=u;ba=I}}else{aa=u;ba=1073741823}if(aa&1){u=aa>>>1;I=aa>>>6;B=N+(I<<2)|0;o=1<<(u&31);if((c[B>>2]&o|0)==0?(H=(c[L>>2]|0)+(I<<2)|0,I=c[H>>2]|0,(I&o|0)!=0):0){c[H>>2]=I&~o;c[B>>2]=c[B>>2]|o;ca=u}else ca=u}else ca=1073741823;if((ba|0)!=1073741823?(u=R+(ba>>>5<<2)|0,o=c[u>>2]|0,B=1<<(ba&31),(o&B|0)==0):0){c[u>>2]=o|B;ea=Q+1|0}else ea=Q;do if((ca|0)==1073741823)fa=ea;else{B=R+(ca>>>5<<2)|0;o=c[B>>2]|0;u=1<<(ca&31);if(o&u){fa=ea;break}c[B>>2]=o|u;fa=ea+1|0}while(0);c[O+(K<<2)>>2]=U;_=K+1|0;$=fa}U=U+1|0;if((U|0)==(V|0)){W=_;X=$;break}else{K=_;Q=$}}}c[b+49824>>2]=W;a:do if(X){do if(X>>>0>1024){W=X<<2;$=W+15&-16;Q=c[b+45680>>2]|0;if(!Q){_=UJa(f,$,483416,1936)|0;c[b+45684>>2]=_;ga=W;ha=_;break}else{_=p$a(Q,$,1)|0;c[b+45684>>2]=_;ga=W;ha=_;break}}else{_=b+41584|0;c[b+45684>>2]=_;ga=X<<2;ha=_}while(0);PEi(ha|0,0,ga|0)|0;c[b+45688>>2]=X;_=c[b+45684>>2]|0;W=j+516|0;$=c[k>>2]&2147483647;if($){Q=c[W>>2]|0;K=0;while(1){ia=c[Q+(K<<2)>>2]|0;if(ia)break;V=K+1|0;if(V>>>0<$>>>0)K=V;else{ja=0;break a}}V=c[425648+((da(ia&0-ia,125613361)|0)>>>27<<2)>>2]|K<<5;U=ia+-1&ia;b:do if(!U){fa=K;while(1){O=fa+1|0;if(O>>>0>=$>>>0){ka=O;la=0;break b}ea=c[Q+(O<<2)>>2]|0;if(!ea)fa=O;else{ka=O;la=ea;break}}}else{ka=K;la=U}while(0);if((V|0)!=-1){U=c[W>>2]|0;K=ka;Q=la;$=0;fa=V;while(1){ea=K<<5;O=Q;ca=$;R=fa;while(1){c[_+(ca<<2)>>2]=R;ma=ca+1|0;if(!O){ja=ma;break a}R=c[425648+((da(O&0-O,125613361)|0)>>>27<<2)>>2]|ea;O=O+-1&O;na=c[k>>2]&2147483647;if(!O){oa=K;break}if((R|0)==-1){ja=ma;break a}else ca=ma}while(1){oa=oa+1|0;if(oa>>>0>=na>>>0){pa=0;break}ca=c[U+(oa<<2)>>2]|0;if(ca){pa=ca;break}}if((R|0)==-1){ja=ma;break}else{K=oa;Q=pa;$=ma;fa=R}}}else ja=0}else ja=0}else ja=0;while(0);c[b+45696>>2]=ja;ja=c[b+33316>>2]|0;ma=g+516|0;pa=c[J>>2]&2147483647;c:do if(pa){oa=c[ma>>2]|0;na=0;while(1){qa=c[oa+(na<<2)>>2]|0;if(qa)break;k=na+1|0;if(k>>>0<pa>>>0)na=k;else{ra=0;break c}}k=c[425648+((da(qa&0-qa,125613361)|0)>>>27<<2)>>2]|na<<5;la=qa+-1&qa;d:do if(!la){ka=na;while(1){ia=ka+1|0;if(ia>>>0>=pa>>>0){sa=ia;ta=0;break d}X=c[oa+(ia<<2)>>2]|0;if(!X)ka=ia;else{sa=ia;ta=X;break}}}else{sa=na;ta=la}while(0);if((k|0)!=-1){la=b+308|0;na=b+316|0;oa=b+312|0;ka=b+252|0;R=c[b+180>>2]|0;X=c[S>>2]|0;ia=sa;ga=ta;ha=0;f=k;while(1){fa=ia<<5;$=ga;Q=ha;K=f;while(1){U=c[R+(K*1048|0)+1032>>2]|0;_=(U|0)==1073741823;if(!(c[X+(K>>>5<<2)>>2]&1<<(K&31)))if(_)ua=Q;else{V=c[la>>2]|0;W=c[na>>2]|0;ca=Q;O=U;while(1){if((c[V+(O<<2)>>2]|0)==1073741823)va=ca;else{c[ja+(ca<<2)>>2]=O;va=ca+1|0}O=c[W+(O<<2)>>2]|0;if((O|0)==1073741823){ua=va;break}else ca=va}}else if(_)ua=Q;else{ca=c[la>>2]|0;O=Q;W=U;while(1){do if((c[ca+(W<<2)>>2]|0)==1073741823)wa=O;else{if((d[(c[ka>>2]|0)+((c[(c[oa>>2]|0)+(W<<2)>>2]|0)>>>1)>>0]|0)<=1){wa=O;break}c[ja+(O<<2)>>2]=W;wa=O+1|0}while(0);W=c[(c[na>>2]|0)+(W<<2)>>2]|0;if((W|0)==1073741823){ua=wa;break}else O=wa}}if(!$){ra=ua;break c}K=c[425648+((da($&0-$,125613361)|0)>>>27<<2)>>2]|fa;$=$+-1&$;xa=c[J>>2]&2147483647;if(!$)break;if((K|0)==-1){ra=ua;break c}else Q=ua}Q=c[ma>>2]|0;$=ia;while(1){$=$+1|0;if($>>>0>=xa>>>0){ya=0;break}fa=c[Q+($<<2)>>2]|0;if(fa){ya=fa;break}}if((K|0)==-1){ra=ua;break}else{ia=$;ga=ya;ha=ua;f=K}}}else ra=0}else ra=0;while(0);c[b+33328>>2]=ra;r$a(j);r$a(g);i=e;return}function Cpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=b>>>0<d>>>0;h=g?b:d;j=g?d:b;b=a+49860|0;d=c[b>>2]|0;if(!d){k=0;i=e;return k|0}g=a+49856|0;l=c[g>>2]|0;m=0;while(1){if((c[l+(m*12|0)>>2]|0)==(h|0)?(c[l+(m*12|0)+4>>2]|0)==(j|0):0)break;n=m+1|0;if(n>>>0<d>>>0)m=n;else{k=0;o=24;break}}if((o|0)==24){i=e;return k|0}o=c[l+(m*12|0)+8>>2]|0;if(!o){p=l;q=d}else{d=c[a+24>>2]|0;l=c[d+(h<<2)>>2]|0;if(!(l&1))r=0;else r=(c[a+180>>2]|0)+((l>>>1)*1048|0)|0;l=c[d+(j<<2)>>2]|0;if(!(l&1))s=0;else s=(c[a+180>>2]|0)+((l>>>1)*1048|0)|0;l=(s|0)!=0;do if(!r){if(l)Fpa(a,h,s,o)}else if(l){Epa(a,r,s,o);break}else{Fpa(a,j,r,o);break}while(0);o=c[g>>2]|0;r=c[o+(m*12|0)+8>>2]|0;if(!r)t=o;else{o=c[r>>2]|0;if((o|0)!=0?(c[r+4>>2]|0)>-1:0)VJa(r+8|0,o);VJa(f,r);t=c[g>>2]|0}c[t+(m*12|0)+8>>2]=0;p=c[g>>2]|0;q=c[b>>2]|0}g=p+(m*12|0)|0;m=q+-1|0;c[b>>2]=m;b=p+(m*12|0)|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];k=1;i=e;return k|0}function Dpa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+232|0;PEi(c[d>>2]|0,0,c[a+236>>2]<<2|0)|0;e=a+49860|0;if(!(c[e>>2]|0)){i=b;return}f=c[a+49856>>2]|0;g=c[a+24>>2]|0;a=0;do{h=c[g+(c[f+(a*12|0)>>2]<<2)>>2]|0;if(h&1){j=(c[d>>2]|0)+(h>>>6<<2)|0;c[j>>2]=c[j>>2]|1<<(h>>>1&31)}h=c[g+(c[f+(a*12|0)+4>>2]<<2)>>2]|0;if(h&1){j=(c[d>>2]|0)+(h>>>6<<2)|0;c[j>>2]=c[j>>2]|1<<(h>>>1&31)}a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=b;return}function Epa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=i;i=i+32|0;h=g+17|0;j=g+16|0;k=g+8|0;l=g;m=d+1032|0;n=c[m>>2]|0;o=e+1032|0;p=c[o>>2]|0;q=a[d+1025>>0]|0;d=q&255;r=a[e+1025>>0]|0;e=r&255;s=k+4|0;a[s>>0]=0;t=i;i=i+((4*d|0)+15&-16)|0;c[k>>2]=t;u=l+4|0;a[u>>0]=0;v=i;i=i+((4*e|0)+15&-16)|0;c[l>>2]=v;w=q<<24>>24==0;if(!w){q=b+316|0;x=r<<24>>24==0;y=c[b+308>>2]|0;z=0;A=n;n=0;while(1){if(!((c[y+(A<<2)>>2]|0)!=1073741823|x)){B=c[f>>2]|0;C=0;do{D=C+z|0;E=B+(D>>>5<<2)|0;c[E>>2]=c[E>>2]&~c[b+((D&31)<<2)+384>>2];C=C+1|0}while((C|0)!=(e|0))}c[t+(n<<2)>>2]=A;n=n+1|0;if((n|0)==(d|0))break;else{z=z+e|0;A=c[(c[q>>2]|0)+(A<<2)>>2]|0}}}A=r<<24>>24==0;if(A)F=0;else{r=c[b+308>>2]|0;q=c[b+316>>2]|0;z=p;p=0;n=0;while(1){t=((c[r+(z<<2)>>2]|0)!=1073741823&1)+n|0;c[v+(p<<2)>>2]=z;p=p+1|0;if((p|0)==(e|0)){F=t;break}else{z=c[q+(z<<2)>>2]|0;n=t}}}if(((F|0)!=(e|0)?(F=c[m>>2]|0,!w):0)?(w=b+316|0,!A):0){A=c[b+308>>2]|0;m=0;n=F;F=0;while(1){a:do if((c[A+(n<<2)>>2]|0)!=1073741823){z=o;q=0;while(1){p=c[z>>2]|0;if((c[A+(p<<2)>>2]|0)==1073741823){v=q+m|0;r=(c[f>>2]|0)+(v>>>5<<2)|0;c[r>>2]=c[r>>2]&~c[b+((v&31)<<2)+384>>2]}v=q+1|0;if((v|0)==(e|0))break a;z=(c[w>>2]|0)+(p<<2)|0;q=v}}while(0);F=F+1|0;if((F|0)==(d|0))break;else{m=m+e|0;n=c[(c[w>>2]|0)+(n<<2)>>2]|0}}}n=f+4|0;w=c[n>>2]&2147483647;b:do if(w){m=c[f>>2]|0;d=0;while(1){G=c[m+(d<<2)>>2]|0;if(G)break;F=d+1|0;if(F>>>0<w>>>0)d=F;else break b}F=c[425648+((da(G&0-G,125613361)|0)>>>27<<2)>>2]|d<<5;A=G+-1&G;c:do if(!A){o=d;while(1){q=o+1|0;if(q>>>0>=w>>>0){H=q;I=0;break c}z=c[m+(q<<2)>>2]|0;if(!z)o=q;else{H=q;I=z;break}}}else{H=d;I=A}while(0);if((F|0)!=-1){A=b+304|0;d=b+49848|0;m=b+49852|0;o=b+49844|0;z=I;q=H;v=F;while(1){p=q<<5;r=z;t=v;while(1){x=(c[f>>2]|0)+(t>>>5<<2)|0;c[x>>2]=c[x>>2]&~c[b+((t&31)<<2)+384>>2];x=c[A>>2]|0;y=c[x+(c[(c[k>>2]|0)+(((t>>>0)/(e>>>0)|0)<<2)>>2]<<2)>>2]|0;C=c[x+(c[(c[l>>2]|0)+(((t>>>0)%(e>>>0)|0)<<2)>>2]<<2)>>2]|0;x=c[d>>2]|0;if((x|0)==(c[m>>2]|0)){B=(x|0)==0?32:x<<1;D=c[o>>2]|0;E=UJa(h,B<<3,483416,76)|0;if(D)YEi(E|0,D|0,x<<3|0)|0;PEi(E+(x<<3)|0,0,B-x<<3|0)|0;VJa(j,D);c[o>>2]=E;c[m>>2]=B;J=c[d>>2]|0;K=E}else{J=x;K=c[o>>2]|0}c[d>>2]=J+1;c[K+(J<<3)>>2]=y;c[K+(J<<3)+4>>2]=C;if(!r)break b;t=c[425648+((da(r&0-r,125613361)|0)>>>27<<2)>>2]|p;r=r+-1&r;L=c[n>>2]&2147483647;if(!r){M=q;break}if((t|0)==-1)break b}while(1){M=M+1|0;if(M>>>0>=L>>>0){N=0;break}r=c[(c[f>>2]|0)+(M<<2)>>2]|0;if(r){N=r;break}}if((t|0)==-1)break;else{z=N;q=M;v=t}}}}while(0);if(a[u>>0]|0)tKa(l,c[l>>2]|0);if(!(a[s>>0]|0)){i=g;return}tKa(k,c[k>>2]|0);i=g;return}function Fpa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;i=i+16|0;h=g+9|0;j=g+8|0;k=g;l=c[(c[b+16>>2]|0)+(d<<2)>>2]|0;d=c[e+1032>>2]|0;m=a[e+1025>>0]|0;e=m&255;n=k+4|0;a[n>>0]=0;o=i;i=i+((4*e|0)+15&-16)|0;c[k>>2]=o;if(m<<24>>24){m=b+316|0;p=c[b+308>>2]|0;q=d;d=0;while(1){if((c[p+(q<<2)>>2]|0)==1073741823){r=(c[f>>2]|0)+(d>>>5<<2)|0;c[r>>2]=c[r>>2]&~c[b+((d&31)<<2)+384>>2]}c[o+(d<<2)>>2]=q;d=d+1|0;if((d|0)==(e|0))break;else q=c[(c[m>>2]|0)+(q<<2)>>2]|0}}q=f+4|0;m=c[q>>2]&2147483647;a:do if(m){e=c[f>>2]|0;d=0;while(1){s=c[e+(d<<2)>>2]|0;if(s)break;o=d+1|0;if(o>>>0<m>>>0)d=o;else break a}o=c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|d<<5;p=s+-1&s;b:do if(!p){r=d;while(1){t=r+1|0;if(t>>>0>=m>>>0){u=t;v=0;break b}w=c[e+(t<<2)>>2]|0;if(!w)r=t;else{u=t;v=w;break}}}else{u=d;v=p}while(0);if((o|0)!=-1){p=b+304|0;d=b+49848|0;e=b+49852|0;r=b+49844|0;w=u;t=v;x=o;while(1){y=w<<5;z=t;A=x;while(1){B=(c[f>>2]|0)+(A>>>5<<2)|0;c[B>>2]=c[B>>2]&~c[b+((A&31)<<2)+384>>2];B=c[(c[p>>2]|0)+(c[(c[k>>2]|0)+(A<<2)>>2]<<2)>>2]|0;C=c[d>>2]|0;if((C|0)==(c[e>>2]|0)){D=(C|0)==0?32:C<<1;E=c[r>>2]|0;F=UJa(h,D<<3,483416,76)|0;if(E)YEi(F|0,E|0,C<<3|0)|0;PEi(F+(C<<3)|0,0,D-C<<3|0)|0;VJa(j,E);c[r>>2]=F;c[e>>2]=D;G=c[d>>2]|0;H=F}else{G=C;H=c[r>>2]|0}c[d>>2]=G+1;c[H+(G<<3)>>2]=l;c[H+(G<<3)+4>>2]=B;if(!z)break a;A=c[425648+((da(z&0-z,125613361)|0)>>>27<<2)>>2]|y;z=z+-1&z;I=c[q>>2]&2147483647;if(!z){J=w;break}if((A|0)==-1)break a}while(1){J=J+1|0;if(J>>>0>=I>>>0){K=0;break}z=c[(c[f>>2]|0)+(J<<2)>>2]|0;if(z){K=z;break}}if((A|0)==-1)break;else{w=J;t=K;x=A}}}}while(0);if(!(a[n>>0]|0)){i=g;return}tKa(k,c[k>>2]|0);i=g;return}function Gpa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+2064|0;d=f+2049|0;h=f+2048|0;j=f+1024|0;k=f+512|0;l=f;m=c[a+300>>2]|0;n=a+45696|0;if(!(c[n>>2]|0)){i=f;return}o=a+45684|0;p=a+180|0;q=a+308|0;r=a+316|0;a=0;s=0;while(1){t=c[(c[o>>2]|0)+(a<<2)>>2]|0;u=c[(c[p>>2]|0)+(t*1048|0)+1032>>2]|0;if((u|0)==1073741823){v=0;w=0}else{x=c[q>>2]|0;y=c[r>>2]|0;z=u;u=0;A=0;while(1){if((c[x+(z<<2)>>2]|0)==1073741823)B=A;else{c[j+(A<<3)>>2]=c[m+(z*24|0)>>2];c[j+(A<<3)+4>>2]=u;B=A+1|0}c[k+(u<<2)>>2]=z;C=u+1|0;z=c[y+(z<<2)>>2]|0;if((z|0)==1073741823){v=C;w=B;break}else{u=C;A=B}}}t$a(j,w,d,h);if(w){A=0;do{c[l+(A<<2)>>2]=c[j+(A<<3)+4>>2];A=A+1|0}while((A|0)!=(w|0))}A=b+(s<<2)|0;c[g+(t<<3)>>2]=A;u=g+(t<<3)+4|0;c[u>>2]=e+(s<<2);YEi(A|0,l|0,w<<2|0)|0;YEi(c[u>>2]|0,k|0,v<<2|0)|0;a=a+1|0;if(a>>>0>=(c[n>>2]|0)>>>0)break;else s=v+s|0}i=f;return}function Hpa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[b+372>>2]|0;g=c[b+368>>2]|0;if(!f){i=e;return}h=b+180|0;j=0;do{k=c[g+(j<<2)>>2]|0;l=d+(k<<3)|0;m=c[h>>2]|0;n=m+(k*1048|0)|0;if((a[m+(k*1048|0)+1024>>0]|0)!=0?(a[m+(k*1048|0)+1025>>0]|0)!=0:0)Ipa(b,l,n,n);j=j+1|0}while((j|0)!=(f|0));i=e;return}function Ipa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=i;i=i+1040|0;h=g+1025|0;j=g+1024|0;k=g;PEi(k|0,0,1024)|0;l=c[d>>2]|0;m=d+4|0;d=c[m>>2]|0;n=c[b+300>>2]|0;o=a[e+1026>>0]|0;e=l+((o&255)<<2)|0;a:do if(!(o<<24>>24))p=0;else{q=b+308|0;r=b+304|0;s=b+49836|0;t=b+49840|0;u=b+49832|0;v=l;w=l;while(1){x=c[w>>2]|0;w=w+4|0;y=d+(x<<2)|0;z=v;while(1){if(z>>>0>=e>>>0){A=z;break}B=z+4|0;if((c[n+((c[d+(c[z>>2]<<2)>>2]|0)*24|0)>>2]|0)>>>0<(c[n+((c[y>>2]|0)*24|0)>>2]|0)>>>0)z=B;else{A=B;break}}z=A>>>0<e>>>0;if(z)C=A;else{p=0;break a}do{B=c[C>>2]|0;C=C+4|0;D=c[d+(B<<2)>>2]|0;E=c[y>>2]|0;if((c[n+(D*24|0)>>2]|0)>>>0>(c[n+(E*24|0)+12>>2]|0)>>>0)break;if(((((((x|0)!=(B|0)?(F=c[q>>2]|0,(c[F+(E<<2)>>2]|0)!=(c[F+(D<<2)>>2]|0)):0)?(c[n+(E*24|0)+20>>2]|0)>>>0>=(c[n+(D*24|0)+8>>2]|0)>>>0:0)?(c[n+(D*24|0)+20>>2]|0)>>>0>=(c[n+(E*24|0)+8>>2]|0)>>>0:0)?(c[n+(E*24|0)+16>>2]|0)>>>0>=(c[n+(D*24|0)+4>>2]|0)>>>0:0)?(c[n+(D*24|0)+16>>2]|0)>>>0>=(c[n+(E*24|0)+4>>2]|0)>>>0:0)?(F=x>>>0<B>>>0,G=F?B:x,H=((da(G+-1|0,G)|0)>>>1)+(F?x:B)|0,B=1<<(H&31),F=H>>>5,H=k+(F<<2)|0,c[H>>2]=c[H>>2]|B,(c[f+(F<<2)>>2]&B|0)==0):0){B=c[r>>2]|0;F=c[B+(E<<2)>>2]|0;E=c[B+(D<<2)>>2]|0;D=c[s>>2]|0;if((D|0)==(c[t>>2]|0)){B=(D|0)==0?32:D<<1;H=c[u>>2]|0;G=UJa(h,B<<3,483416,76)|0;if(H)YEi(G|0,H|0,D<<3|0)|0;PEi(G+(D<<3)|0,0,B-D<<3|0)|0;VJa(j,H);c[u>>2]=G;c[t>>2]=B;I=c[s>>2]|0;J=G}else{I=D;J=c[u>>2]|0}c[s>>2]=I+1;c[J+(I<<3)>>2]=F;c[J+(I<<3)+4>>2]=E}}while(C>>>0<e>>>0);if(!(z&w>>>0<e>>>0)){p=0;break}else v=A}}while(0);while(1){K=c[f+(p<<2)>>2]|0;if(K){L=26;break}M=p+1|0;if(M>>>0<256)p=M;else{L=25;break}}b:do if((L|0)==25){N=-1;O=c[m>>2]|0;P=1;Q=M;R=0;S=0;T=0}else if((L|0)==26){A=c[m>>2]|0;e=c[425648+((da(K&0-K,125613361)|0)>>>27<<2)>>2]|p<<5;C=1;while(1){I=C+1|0;if((da(I,C)|0)>>>1>>>0>e>>>0)break;else C=I}I=e-((da(C+-1|0,C)|0)>>>1)|0;J=K+-1&K;if(!J){n=p;while(1){d=n+1|0;if(d>>>0>=256){N=e;O=A;P=C;Q=d;R=0;S=I;T=C;break b}l=c[f+(d<<2)>>2]|0;if(!l)n=d;else{N=e;O=A;P=C;Q=d;R=l;S=I;T=C;break}}}else{N=e;O=A;P=C;Q=p;R=J;S=I;T=C}}while(0);p=b+308|0;K=b+304|0;m=b+49848|0;L=b+49852|0;M=b+49844|0;b=P;P=Q;Q=R;R=S;S=N;N=T;c:while(1){T=P<<5;n=b;l=Q;d=R;o=S;v=N;while(1){w=((da(v+-1|0,v)|0)>>>1)+d|0;s=k+(w>>>5<<2)|0;u=1<<(w&31);w=O+(d<<2)|0;t=O+(v<<2)|0;r=l;q=o;while(1){if((q|0)==-1)break c;if(((c[s>>2]&u|0)==0?(x=c[w>>2]|0,y=c[t>>2]|0,E=c[p>>2]|0,(c[E+(x<<2)>>2]|0)!=1073741823):0)?(c[E+(y<<2)>>2]|0)!=1073741823:0){E=c[K>>2]|0;F=c[E+(x<<2)>>2]|0;x=c[E+(y<<2)>>2]|0;y=c[m>>2]|0;if((y|0)==(c[L>>2]|0)){E=(y|0)==0?32:y<<1;D=c[M>>2]|0;G=UJa(h,E<<3,483416,76)|0;if(D)YEi(G|0,D|0,y<<3|0)|0;PEi(G+(y<<3)|0,0,E-y<<3|0)|0;VJa(j,D);c[M>>2]=G;c[L>>2]=E;U=c[m>>2]|0;V=G}else{U=y;V=c[M>>2]|0}c[m>>2]=U+1;c[V+(U<<3)>>2]=F;c[V+(U<<3)+4>>2]=x}if(!r){r=0;q=-1}else break}o=c[425648+((da(r&0-r,125613361)|0)>>>27<<2)>>2]|T;W=n;while(1){q=W+1|0;if((da(q,W)|0)>>>1>>>0>o>>>0)break;else W=q}d=o-((da(W+-1|0,W)|0)>>>1)|0;l=r+-1&r;if(!l){X=P;break}else{n=W;v=W}}while(1){v=X+1|0;if(v>>>0>=256){b=W;P=v;Q=0;R=d;S=o;N=W;continue c}n=c[f+(v<<2)>>2]|0;if(!n)X=v;else{b=W;P=v;Q=n;R=d;S=o;N=W;continue c}}}YEi(f|0,k|0,1024)|0;i=g;return}function Jpa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;f=a+49824|0;if(!(c[f>>2]|0)){i=e;return}g=a+49812|0;h=a+49856|0;j=a+24|0;k=a+180|0;l=0;do{m=c[(c[g>>2]|0)+(l<<2)>>2]|0;n=c[h>>2]|0;o=c[n+(m*12|0)>>2]|0;p=c[n+(m*12|0)+4>>2]|0;q=c[j>>2]|0;r=c[q+(o<<2)>>2]|0;if(!(r&1)){s=0;t=1073741823}else{u=r>>>1;s=(c[k>>2]|0)+(u*1048|0)|0;t=u}u=c[q+(p<<2)>>2]|0;if(!(u&1)){v=0;w=1073741823}else{q=u>>>1;v=(c[k>>2]|0)+(q*1048|0)|0;w=q}q=(v|0)!=0;do if(!s){if(q){u=n+(m*12|0)+8|0;r=c[u>>2]|0;if(!r){x=mKa()|0;y=c[(c[x>>2]|0)+8>>2]|0;z=pKa()|0;A=mo[c[(c[z>>2]|0)+24>>2]&4095](z)|0;z=Bn[y&255](x,12,A?482432:544544,482112,2343)|0;c[z>>2]=0;A=z+4|0;c[A>>2]=0;c[u>>2]=z;x=((d[v+1025>>0]|0)+31|0)>>>5;y=c[z>>2]|0;if(!x){B=y;C=0}else{D=z+8|0;if(y)VJa(D,y);c[A>>2]=x;y=UJa(D,x<<2,543784,362)|0;c[z>>2]=y;B=y;C=c[A>>2]<<2}PEi(B|0,0,C|0)|0;E=c[u>>2]|0}else E=r;Lpa(a,b+(w<<3)|0,v,o,E)}}else{r=n+(m*12|0)+8|0;u=c[r>>2]|0;A=(u|0)!=0;if(q){if(A)F=u;else{y=mKa()|0;z=c[(c[y>>2]|0)+8>>2]|0;x=pKa()|0;D=mo[c[(c[x>>2]|0)+24>>2]&4095](x)|0;x=Bn[z&255](y,12,D?482432:544544,482112,2316)|0;c[x>>2]=0;D=x+4|0;c[D>>2]=0;c[r>>2]=x;y=((da(d[v+1025>>0]|0,d[s+1025>>0]|0)|0)+31|0)>>>5;z=c[x>>2]|0;if(!y){G=z;H=0}else{I=x+8|0;if(z)VJa(I,z);c[D>>2]=y;z=UJa(I,y<<2,543784,362)|0;c[x>>2]=z;G=z;H=c[D>>2]<<2}PEi(G|0,0,H|0)|0;F=c[r>>2]|0}Kpa(a,b+(t<<3)|0,s,b+(w<<3)|0,v,F);break}else{if(A)J=u;else{u=mKa()|0;A=c[(c[u>>2]|0)+8>>2]|0;D=pKa()|0;z=mo[c[(c[D>>2]|0)+24>>2]&4095](D)|0;D=Bn[A&255](u,12,z?482432:544544,482112,2328)|0;c[D>>2]=0;z=D+4|0;c[z>>2]=0;c[r>>2]=D;u=((d[s+1025>>0]|0)+31|0)>>>5;A=c[D>>2]|0;if(!u){K=A;L=0}else{x=D+8|0;if(A)VJa(x,A);c[z>>2]=u;A=UJa(x,u<<2,543784,362)|0;c[D>>2]=A;K=A;L=c[z>>2]<<2}PEi(K|0,0,L|0)|0;J=c[r>>2]|0}Lpa(a,b+(t<<3)|0,s,p,J);break}}while(0);l=l+1|0}while(l>>>0<(c[f>>2]|0)>>>0);i=e;return}function Kpa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0;k=i;i=i+2080|0;l=k+2065|0;m=k+2064|0;n=k;o=d[h+1025>>0]|0;p=c[e+4>>2]|0;q=c[g+4>>2]|0;r=n+2048|0;c[r>>2]=c[b>>2];s=n+2052|0;c[s>>2]=n;c[n+2056>>2]=-2147483136;PEi(n|0,0,2048)|0;t=c[b+300>>2]|0;u=c[e>>2]|0;e=c[g>>2]|0;g=a[f+1026>>0]|0;f=u+((g&255)<<2)|0;v=a[h+1026>>0]|0;h=e+((v&255)<<2)|0;w=v<<24>>24!=0&g<<24>>24!=0;a:do if(w){g=b+308|0;v=b+304|0;x=b+49836|0;y=b+49840|0;z=b+49832|0;A=e;B=u;while(1){C=c[B>>2]|0;B=B+4|0;b:do if(A>>>0<h>>>0){D=c[t+((c[p+(C<<2)>>2]|0)*24|0)>>2]|0;E=A;while(1){F=E+4|0;if((c[t+((c[q+(c[E>>2]<<2)>>2]|0)*24|0)>>2]|0)>>>0>=D>>>0){G=E;break b}if(F>>>0<h>>>0)E=F;else{G=F;break}}}else G=A;while(0);E=G>>>0<h>>>0;if(!E)break;D=p+(C<<2)|0;F=da(C,o)|0;H=G;do{I=c[H>>2]|0;H=H+4|0;J=c[q+(I<<2)>>2]|0;K=c[D>>2]|0;if((c[t+(J*24|0)>>2]|0)>>>0>(c[t+(K*24|0)+12>>2]|0)>>>0)break;L=c[g>>2]|0;if(((((((c[L+(K<<2)>>2]|0)!=(c[L+(J<<2)>>2]|0)?(c[t+(K*24|0)>>2]|0)>>>0<=(c[t+(J*24|0)+12>>2]|0)>>>0:0)?(c[t+(J*24|0)+4>>2]|0)>>>0<=(c[t+(K*24|0)+16>>2]|0)>>>0:0)?(c[t+(K*24|0)+4>>2]|0)>>>0<=(c[t+(J*24|0)+16>>2]|0)>>>0:0)?(c[t+(J*24|0)+8>>2]|0)>>>0<=(c[t+(K*24|0)+20>>2]|0)>>>0:0)?(c[t+(K*24|0)+8>>2]|0)>>>0<=(c[t+(J*24|0)+20>>2]|0)>>>0:0)?(L=I+F|0,I=b+((L&31)<<2)+384|0,M=L>>>5,L=(c[s>>2]|0)+(M<<2)|0,c[L>>2]=c[L>>2]|c[I>>2],(c[I>>2]&c[(c[j>>2]|0)+(M<<2)>>2]|0)==0):0){M=c[v>>2]|0;I=c[M+(K<<2)>>2]|0;K=c[M+(J<<2)>>2]|0;J=c[x>>2]|0;if((J|0)==(c[y>>2]|0)){M=(J|0)==0?32:J<<1;L=c[z>>2]|0;N=UJa(l,M<<3,483416,76)|0;if(L)YEi(N|0,L|0,J<<3|0)|0;PEi(N+(J<<3)|0,0,M-J<<3|0)|0;VJa(m,L);c[z>>2]=N;c[y>>2]=M;O=c[x>>2]|0;P=N}else{O=J;P=c[z>>2]|0}c[x>>2]=O+1;c[P+(O<<3)>>2]=I;c[P+(O<<3)+4>>2]=K}}while(H>>>0<h>>>0);if(!(E&B>>>0<f>>>0))break;else A=G}if(w){A=b+308|0;B=b+304|0;x=b+49836|0;z=b+49840|0;y=b+49832|0;v=u;g=e;while(1){H=c[g>>2]|0;g=g+4|0;c:do if(v>>>0<f>>>0){F=c[t+((c[q+(H<<2)>>2]|0)*24|0)>>2]|0;D=v;while(1){C=D+4|0;if((c[t+((c[p+(c[D>>2]<<2)>>2]|0)*24|0)>>2]|0)>>>0>F>>>0){Q=D;break c}if(C>>>0<f>>>0)D=C;else{Q=C;break}}}else Q=v;while(0);E=Q>>>0<f>>>0;if(!E)break a;D=q+(H<<2)|0;F=Q;do{C=c[F>>2]|0;F=F+4|0;K=c[p+(C<<2)>>2]|0;I=c[D>>2]|0;if((c[t+(K*24|0)>>2]|0)>>>0>(c[t+(I*24|0)+12>>2]|0)>>>0)break;J=c[A>>2]|0;if(((((((c[J+(K<<2)>>2]|0)!=(c[J+(I<<2)>>2]|0)?(c[t+(I*24|0)>>2]|0)>>>0<=(c[t+(K*24|0)+12>>2]|0)>>>0:0)?(c[t+(I*24|0)+4>>2]|0)>>>0<=(c[t+(K*24|0)+16>>2]|0)>>>0:0)?(c[t+(K*24|0)+4>>2]|0)>>>0<=(c[t+(I*24|0)+16>>2]|0)>>>0:0)?(c[t+(I*24|0)+8>>2]|0)>>>0<=(c[t+(K*24|0)+20>>2]|0)>>>0:0)?(c[t+(K*24|0)+8>>2]|0)>>>0<=(c[t+(I*24|0)+20>>2]|0)>>>0:0)?(J=(da(C,o)|0)+H|0,C=b+((J&31)<<2)+384|0,N=J>>>5,J=(c[s>>2]|0)+(N<<2)|0,c[J>>2]=c[J>>2]|c[C>>2],(c[C>>2]&c[(c[j>>2]|0)+(N<<2)>>2]|0)==0):0){N=c[B>>2]|0;C=c[N+(K<<2)>>2]|0;K=c[N+(I<<2)>>2]|0;I=c[x>>2]|0;if((I|0)==(c[z>>2]|0)){N=(I|0)==0?32:I<<1;J=c[y>>2]|0;M=UJa(l,N<<3,483416,76)|0;if(J)YEi(M|0,J|0,I<<3|0)|0;PEi(M+(I<<3)|0,0,N-I<<3|0)|0;VJa(m,J);c[y>>2]=M;c[z>>2]=N;R=c[x>>2]|0;S=M}else{R=I;S=c[y>>2]|0}c[x>>2]=R+1;c[S+(R<<3)>>2]=C;c[S+(R<<3)+4>>2]=K}}while(F>>>0<f>>>0);if(!(E&g>>>0<h>>>0))break;else v=Q}}}while(0);Q=j+4|0;h=c[Q>>2]|0;f=h&2147483647;d:do if(f){R=c[j>>2]|0;S=0;while(1){T=c[R+(S<<2)>>2]|0;if(T)break;t=S+1|0;if(t>>>0<f>>>0)S=t;else{U=57;break d}}t=c[425648+((da(T&0-T,125613361)|0)>>>27<<2)>>2]|S<<5;e=T+-1&T;e:do if(!e){u=S;while(1){w=u+1|0;if(w>>>0>=f>>>0){V=w;W=0;break e}G=c[R+(w<<2)>>2]|0;if(!G)u=w;else{V=w;W=G;break}}}else{V=S;W=e}while(0);if((t|0)!=-1){e=b+308|0;S=b+304|0;R=b+49848|0;u=b+49852|0;E=b+49844|0;G=V;w=W;O=t;f:while(1){P=G<<5;v=w;g=O;while(1){if(((c[b+((g&31)<<2)+384>>2]&c[(c[s>>2]|0)+(g>>>5<<2)>>2]|0)==0?(x=(g>>>0)/(o>>>0)|0,y=g-(da(x,o)|0)|0,z=c[p+(x<<2)>>2]|0,x=c[q+(y<<2)>>2]|0,y=c[e>>2]|0,(c[y+(z<<2)>>2]|0)!=1073741823):0)?(c[y+(x<<2)>>2]|0)!=1073741823:0){y=c[S>>2]|0;B=c[y+(z<<2)>>2]|0;z=c[y+(x<<2)>>2]|0;x=c[R>>2]|0;if((x|0)==(c[u>>2]|0)){y=(x|0)==0?32:x<<1;A=c[E>>2]|0;F=UJa(l,y<<3,483416,76)|0;if(A)YEi(F|0,A|0,x<<3|0)|0;PEi(F+(x<<3)|0,0,y-x<<3|0)|0;VJa(m,A);c[E>>2]=F;c[u>>2]=y;X=c[R>>2]|0;Y=F}else{X=x;Y=c[E>>2]|0}c[R>>2]=X+1;c[Y+(X<<3)>>2]=B;c[Y+(X<<3)+4>>2]=z}if(!v)break f;g=c[425648+((da(v&0-v,125613361)|0)>>>27<<2)>>2]|P;v=v+-1&v;Z=c[Q>>2]|0;_=Z&2147483647;if(!v){$=G;break}if((g|0)==-1)break f}while(1){$=$+1|0;if($>>>0>=_>>>0){aa=0;break}v=c[(c[j>>2]|0)+($<<2)>>2]|0;if(v){aa=v;break}}if((g|0)==-1){ba=j;ca=Z;break d}else{G=$;w=aa;O=g}}ba=j;ca=c[Q>>2]|0}else U=57}else U=57;while(0);if((U|0)==57){ba=j;ca=h}YEi(c[ba>>2]|0,c[s>>2]|0,ca<<2|0)|0;ca=c[s>>2]|0;if((ca|0)==0|(ca|0)==(n|0)){i=k;return}n=c[r>>2]|0;if(!n){VJa(m,ca);i=k;return}m=c[n+16>>2]|0;if(m>>>0<=ca>>>0?(m+(c[n+20>>2]|0)|0)>>>0>ca>>>0:0){oTa(c[n>>2]|0);m=n+8|0;r=c[m>>2]|0;s=n+4|0;ba=c[s>>2]|0;h=r;while(1){j=h+-1|0;ea=ba+(j<<2)|0;if((c[ea>>2]|0)>>>0<ca>>>0)h=j;else break}if(h>>>0<r>>>0){ba=h;h=ea;while(1){if(h)c[h>>2]=c[(c[s>>2]|0)+(ba<<2)>>2];ba=ba+1|0;if((ba|0)==(r|0))break;else h=h+4|0}}c[m>>2]=r+-1;pTa(c[n>>2]|0);i=k;return}VJa(l,ca);i=k;return}function Lpa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0;j=i;i=i+80|0;k=j+65|0;l=j+64|0;m=j;n=j+40|0;o=j+32|0;p=m+16|0;c[p>>2]=c[b>>2];q=m+20|0;c[q>>2]=m;c[m+24>>2]=-2147483644;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;r=d[f+1025>>0]|0;s=c[b+300>>2]|0;t=b+308|0;u=c[t>>2]|0;v=c[e>>2]|0;w=c[e+4>>2]|0;e=(c[b+12>>2]|0)+(g*24|0)|0;c[n+0>>2]=c[e+0>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];c[o>>2]=c[(c[b+20>>2]|0)+(g<<2)>>2];e=a[f+1026>>0]|0;f=v+((e&255)<<2)|0;x=e<<24>>24==0;a:do if(!x){y=b+304|0;z=b+16|0;A=b+49836|0;B=b+49840|0;C=b+49832|0;b:do if(!(e<<24>>24))D=v;else{E=c[n>>2]|0;F=v;while(1){G=F+4|0;if((c[s+((c[w+(c[F>>2]<<2)>>2]|0)*24|0)>>2]|0)>>>0>=E>>>0){D=F;break b}if(G>>>0<f>>>0)F=G;else{D=G;break}}}while(0);c:do if(D>>>0<f>>>0){F=n+16|0;E=n+4|0;G=n+20|0;H=n+8|0;I=c[n+12>>2]|0;J=D;do{K=c[J>>2]|0;J=J+4|0;L=c[w+(K<<2)>>2]|0;if((c[s+(L*24|0)>>2]|0)>>>0>I>>>0)break c;if(((((((c[u+(L<<2)>>2]|0)!=(c[o>>2]|0)?(c[n>>2]|0)>>>0<=(c[s+(L*24|0)+12>>2]|0)>>>0:0)?(c[s+(L*24|0)+4>>2]|0)>>>0<=(c[F>>2]|0)>>>0:0)?(c[E>>2]|0)>>>0<=(c[s+(L*24|0)+16>>2]|0)>>>0:0)?(c[s+(L*24|0)+8>>2]|0)>>>0<=(c[G>>2]|0)>>>0:0)?(c[H>>2]|0)>>>0<=(c[s+(L*24|0)+20>>2]|0)>>>0:0)?(M=b+((K&31)<<2)+384|0,N=K>>>5,K=(c[q>>2]|0)+(N<<2)|0,c[K>>2]=c[K>>2]|c[M>>2],(c[M>>2]&c[(c[h>>2]|0)+(N<<2)>>2]|0)==0):0){N=c[(c[y>>2]|0)+(L<<2)>>2]|0;L=c[(c[z>>2]|0)+(g<<2)>>2]|0;M=c[A>>2]|0;if((M|0)==(c[B>>2]|0)){K=(M|0)==0?32:M<<1;O=c[C>>2]|0;P=UJa(k,K<<3,483416,76)|0;if(O)YEi(P|0,O|0,M<<3|0)|0;PEi(P+(M<<3)|0,0,K-M<<3|0)|0;VJa(l,O);c[C>>2]=P;c[B>>2]=K;Q=c[A>>2]|0;R=P}else{Q=M;R=c[C>>2]|0}c[A>>2]=Q+1;c[R+(Q<<3)>>2]=N;c[R+(Q<<3)+4>>2]=L}}while(J>>>0<f>>>0)}while(0);if(!x){A=b+304|0;C=b+16|0;B=b+49836|0;z=b+49840|0;y=b+49832|0;J=482320;H=v;while(1){G=c[H>>2]|0;H=H+4|0;d:do if(J>>>0<(482324|0)>>>0){E=c[s+((c[w+(G<<2)>>2]|0)*24|0)>>2]|0;F=J;while(1){I=F+4|0;if((c[n+((c[482320+(c[F>>2]<<2)>>2]|0)*24|0)>>2]|0)>>>0>E>>>0){S=F;break d}if(I>>>0<(482324|0)>>>0)F=I;else{S=I;break}}}else S=J;while(0);F=S>>>0<(482324|0)>>>0;if(!F)break a;E=w+(G<<2)|0;I=S;do{L=c[I>>2]|0;I=I+4|0;N=c[482320+(L<<2)>>2]|0;M=c[E>>2]|0;if((c[n+(N*24|0)>>2]|0)>>>0>(c[s+(M*24|0)+12>>2]|0)>>>0)break;if(((((((c[u+(M<<2)>>2]|0)!=(c[o+(N<<2)>>2]|0)?(c[s+(M*24|0)>>2]|0)>>>0<=(c[n+(N*24|0)+12>>2]|0)>>>0:0)?(c[s+(M*24|0)+4>>2]|0)>>>0<=(c[n+(N*24|0)+16>>2]|0)>>>0:0)?(c[n+(N*24|0)+4>>2]|0)>>>0<=(c[s+(M*24|0)+16>>2]|0)>>>0:0)?(c[s+(M*24|0)+8>>2]|0)>>>0<=(c[n+(N*24|0)+20>>2]|0)>>>0:0)?(c[n+(N*24|0)+8>>2]|0)>>>0<=(c[s+(M*24|0)+20>>2]|0)>>>0:0)?(N=(da(L,r)|0)+G|0,L=b+((N&31)<<2)+384|0,P=N>>>5,N=(c[q>>2]|0)+(P<<2)|0,c[N>>2]=c[N>>2]|c[L>>2],(c[L>>2]&c[(c[h>>2]|0)+(P<<2)>>2]|0)==0):0){P=c[(c[A>>2]|0)+(M<<2)>>2]|0;M=c[(c[C>>2]|0)+(g<<2)>>2]|0;L=c[B>>2]|0;if((L|0)==(c[z>>2]|0)){N=(L|0)==0?32:L<<1;K=c[y>>2]|0;O=UJa(k,N<<3,483416,76)|0;if(K)YEi(O|0,K|0,L<<3|0)|0;PEi(O+(L<<3)|0,0,N-L<<3|0)|0;VJa(l,K);c[y>>2]=O;c[z>>2]=N;T=c[B>>2]|0;U=O}else{T=L;U=c[y>>2]|0}c[B>>2]=T+1;c[U+(T<<3)>>2]=P;c[U+(T<<3)+4>>2]=M}}while(I>>>0<(482324|0)>>>0);if(!(F&H>>>0<f>>>0))break;else J=S}}}while(0);S=h+4|0;f=c[S>>2]|0;T=f&2147483647;e:do if(T){U=c[h>>2]|0;s=0;while(1){V=c[U+(s<<2)>>2]|0;if(V)break;n=s+1|0;if(n>>>0<T>>>0)s=n;else{W=55;break e}}n=c[425648+((da(V&0-V,125613361)|0)>>>27<<2)>>2]|s<<5;o=V+-1&V;f:do if(!o){u=s;while(1){v=u+1|0;if(v>>>0>=T>>>0){X=v;Y=0;break f}x=c[U+(v<<2)>>2]|0;if(!x)u=v;else{X=v;Y=x;break}}}else{X=s;Y=o}while(0);if((n|0)!=-1){o=b+304|0;s=b+16|0;U=b+49848|0;u=b+49852|0;F=b+49844|0;x=X;v=Y;Q=n;g:while(1){R=x<<5;D=v;e=Q;while(1){if((c[b+((e&31)<<2)+384>>2]&c[(c[q>>2]|0)+(e>>>5<<2)>>2]|0)==0?(J=c[w+(((e>>>0)%(r>>>0)|0)<<2)>>2]|0,(c[(c[t>>2]|0)+(J<<2)>>2]|0)!=1073741823):0){H=c[(c[o>>2]|0)+(J<<2)>>2]|0;J=c[(c[s>>2]|0)+(g<<2)>>2]|0;B=c[U>>2]|0;if((B|0)==(c[u>>2]|0)){y=(B|0)==0?32:B<<1;z=c[F>>2]|0;C=UJa(k,y<<3,483416,76)|0;if(z)YEi(C|0,z|0,B<<3|0)|0;PEi(C+(B<<3)|0,0,y-B<<3|0)|0;VJa(l,z);c[F>>2]=C;c[u>>2]=y;Z=c[U>>2]|0;_=C}else{Z=B;_=c[F>>2]|0}c[U>>2]=Z+1;c[_+(Z<<3)>>2]=H;c[_+(Z<<3)+4>>2]=J}if(!D)break g;e=c[425648+((da(D&0-D,125613361)|0)>>>27<<2)>>2]|R;D=D+-1&D;$=c[S>>2]|0;aa=$&2147483647;if(!D){ba=x;break}if((e|0)==-1)break g}while(1){ba=ba+1|0;if(ba>>>0>=aa>>>0){ca=0;break}D=c[(c[h>>2]|0)+(ba<<2)>>2]|0;if(D){ca=D;break}}if((e|0)==-1){ea=h;fa=$;break e}else{x=ba;v=ca;Q=e}}ea=h;fa=c[S>>2]|0}else W=55}else W=55;while(0);if((W|0)==55){ea=h;fa=f}YEi(c[ea>>2]|0,c[q>>2]|0,fa<<2|0)|0;fa=c[q>>2]|0;if((fa|0)==0|(fa|0)==(m|0)){i=j;return}m=c[p>>2]|0;if(!m){VJa(l,fa);i=j;return}l=c[m+16>>2]|0;if(l>>>0<=fa>>>0?(l+(c[m+20>>2]|0)|0)>>>0>fa>>>0:0){oTa(c[m>>2]|0);l=m+8|0;p=c[l>>2]|0;q=m+4|0;ea=c[q>>2]|0;f=p;while(1){h=f+-1|0;ga=ea+(h<<2)|0;if((c[ga>>2]|0)>>>0<fa>>>0)f=h;else break}if(f>>>0<p>>>0){ea=f;f=ga;while(1){if(f)c[f>>2]=c[(c[q>>2]|0)+(ea<<2)>>2];ea=ea+1|0;if((ea|0)==(p|0))break;else f=f+4|0}}c[l>>2]=p+-1;pTa(c[m>>2]|0);i=j;return}VJa(k,fa);i=j;return}function Mpa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+16|0;j=h;if(!b){k=0;i=h;return k|0}l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,12,o?482432:544544,482112,2633)|0;c[n>>2]=0;o=n+4|0;c[o>>2]=0;l=((f|0)!=-1&1)+d|0;m=da(((g|0)!=-1&1)+e|0,l)|0;if(!(m&127))p=m;else p=m+128&-128;m=(p+31|0)>>>5;if(!m){q=0;r=0}else{c[o>>2]=m;p=UJa(n+8|0,m<<2,543784,362)|0;c[n>>2]=p;q=p;r=c[o>>2]<<2}PEi(q|0,0,r|0)|0;if((e|0)!=0?(d|0)!=0:0){r=0;q=0;o=0;while(1){p=c[b>>2]|0;m=((q|0)==(g|0)?l:0)+r|0;s=0;t=o;while(1){u=((s|0)==(f|0)&1)+m|0;if(c[a+((t&31)<<2)+384>>2]&c[p+(t>>>5<<2)>>2]){v=(c[n>>2]|0)+(u>>>5<<2)|0;c[v>>2]=c[v>>2]|c[a+((u&31)<<2)+384>>2]}m=u+1|0;s=s+1|0;if((s|0)==(d|0))break;else t=t+1|0}q=q+1|0;if((q|0)==(e|0))break;else{r=m;o=o+d|0}}}d=c[b>>2]|0;if((d|0)!=0?(c[b+4>>2]|0)>-1:0)VJa(b+8|0,d);VJa(j,b);k=n;i=h;return k|0}function Npa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0;e=i;f=c[b+196>>2]|0;if(f){h=b+180|0;j=b+12|0;l=d+4|0;m=d+8|0;n=b+96|0;o=b+68|0;p=b+300|0;q=b+316|0;r=0;do{s=c[h>>2]|0;if(a[s+(r*1048|0)+1025>>0]|0){t=c[s+(r*1048|0)+1028>>2]|0;u=c[j>>2]|0;v=u+(t*24|0)|0;w=c[v>>2]|0;x=u+(t*24|0)+4|0;y=c[x>>2]|0;z=u+(t*24|0)+8|0;A=c[z>>2]|0;B=u+(t*24|0)+12|0;C=c[B>>2]|0;D=u+(t*24|0)+16|0;E=c[D>>2]|0;F=u+(t*24|0)+20|0;u=c[F>>2]|0;G=ea(g[d>>2]);H=ea((c[k>>2]=(w|0)<0?w&2147483647:~w,ea(g[k>>2]))-G);w=(g[k>>2]=H,c[k>>2]|0);H=ea(g[l>>2]);I=ea((c[k>>2]=(y|0)<0?y&2147483647:~y,ea(g[k>>2]))-H);y=(g[k>>2]=I,c[k>>2]|0);I=ea(g[m>>2]);J=ea((c[k>>2]=(A|0)<0?A&2147483647:~A,ea(g[k>>2]))-I);A=(g[k>>2]=J,c[k>>2]|0);J=ea((c[k>>2]=(C|0)<0?C&2147483647:~C,ea(g[k>>2]))-G);C=(g[k>>2]=J,c[k>>2]|0);J=ea((c[k>>2]=(E|0)<0?E&2147483647:~E,ea(g[k>>2]))-H);E=(g[k>>2]=J,c[k>>2]|0);J=ea((c[k>>2]=(u|0)<0?u&2147483647:~u,ea(g[k>>2]))-I);u=(g[k>>2]=J,c[k>>2]|0);c[v>>2]=((w|0)<0?~w:w|-2147483648)+-16&-16;c[x>>2]=((y|0)<0?~y:y|-2147483648)+-16&-16;c[z>>2]=((A|0)<0?~A:A|-2147483648)+-16&-16;c[B>>2]=((C|0)<0?~C:C|-2147483648)+16&-16|1;c[D>>2]=((E|0)<0?~E:E|-2147483648)+16&-16|1;c[F>>2]=((u|0)<0?~u:u|-2147483648)+16&-16|1;u=t>>>5;F=1<<(t&31);if((c[(c[n>>2]|0)+(u<<2)>>2]&F|0)==0?(t=(c[o>>2]|0)+(u<<2)|0,u=c[t>>2]|0,(u&F|0)==0):0)c[t>>2]=u|F;F=c[s+(r*1048|0)+1032>>2]|0;if((F|0)!=1073741823){s=F;do{F=c[p>>2]|0;u=F+(s*24|0)|0;t=c[u>>2]|0;E=F+(s*24|0)+4|0;D=c[E>>2]|0;C=F+(s*24|0)+8|0;B=c[C>>2]|0;A=F+(s*24|0)+12|0;z=c[A>>2]|0;y=F+(s*24|0)+16|0;x=c[y>>2]|0;w=F+(s*24|0)+20|0;F=c[w>>2]|0;J=ea(g[d>>2]);I=ea((c[k>>2]=(t|0)<0?t&2147483647:~t,ea(g[k>>2]))-J);t=(g[k>>2]=I,c[k>>2]|0);I=ea(g[l>>2]);H=ea((c[k>>2]=(D|0)<0?D&2147483647:~D,ea(g[k>>2]))-I);D=(g[k>>2]=H,c[k>>2]|0);H=ea(g[m>>2]);G=ea((c[k>>2]=(B|0)<0?B&2147483647:~B,ea(g[k>>2]))-H);B=(g[k>>2]=G,c[k>>2]|0);G=ea((c[k>>2]=(z|0)<0?z&2147483647:~z,ea(g[k>>2]))-J);z=(g[k>>2]=G,c[k>>2]|0);G=ea((c[k>>2]=(x|0)<0?x&2147483647:~x,ea(g[k>>2]))-I);x=(g[k>>2]=G,c[k>>2]|0);G=ea((c[k>>2]=(F|0)<0?F&2147483647:~F,ea(g[k>>2]))-H);F=(g[k>>2]=G,c[k>>2]|0);c[u>>2]=((t|0)<0?~t:t|-2147483648)+-16&-16;c[E>>2]=((D|0)<0?~D:D|-2147483648)+-16&-16;c[C>>2]=((B|0)<0?~B:B|-2147483648)+-16&-16;c[A>>2]=((z|0)<0?~z:z|-2147483648)+16&-16|1;c[y>>2]=((x|0)<0?~x:x|-2147483648)+16&-16|1;c[w>>2]=((F|0)<0?~F:F|-2147483648)+16&-16|1;s=c[(c[q>>2]|0)+(s<<2)>>2]|0}while((s|0)!=1073741823)}}r=r+1|0}while((r|0)!=(f|0))}f=c[b+164>>2]|0;if(!f){K=b+49828|0;L=c[K>>2]|0;M=c[L>>2]|0;N=M+68|0;O=c[N>>2]|0;In[O&4095](L,d);i=e;return}r=b+156|0;q=b+12|0;m=d+4|0;l=d+8|0;p=b+96|0;o=b+68|0;n=b+28|0;j=0;do{h=c[(c[r>>2]|0)+(j<<2)>>2]|0;if((h|0)!=1073741823){s=h;do{h=c[q>>2]|0;F=h+(s*24|0)|0;w=c[F>>2]|0;x=h+(s*24|0)+4|0;y=c[x>>2]|0;z=h+(s*24|0)+8|0;A=c[z>>2]|0;B=h+(s*24|0)+12|0;C=c[B>>2]|0;D=h+(s*24|0)+16|0;E=c[D>>2]|0;t=h+(s*24|0)+20|0;h=c[t>>2]|0;G=ea(g[d>>2]);H=ea((c[k>>2]=(w|0)<0?w&2147483647:~w,ea(g[k>>2]))-G);w=(g[k>>2]=H,c[k>>2]|0);H=ea(g[m>>2]);I=ea((c[k>>2]=(y|0)<0?y&2147483647:~y,ea(g[k>>2]))-H);y=(g[k>>2]=I,c[k>>2]|0);I=ea(g[l>>2]);J=ea((c[k>>2]=(A|0)<0?A&2147483647:~A,ea(g[k>>2]))-I);A=(g[k>>2]=J,c[k>>2]|0);J=ea((c[k>>2]=(C|0)<0?C&2147483647:~C,ea(g[k>>2]))-G);C=(g[k>>2]=J,c[k>>2]|0);J=ea((c[k>>2]=(E|0)<0?E&2147483647:~E,ea(g[k>>2]))-H);E=(g[k>>2]=J,c[k>>2]|0);J=ea((c[k>>2]=(h|0)<0?h&2147483647:~h,ea(g[k>>2]))-I);h=(g[k>>2]=J,c[k>>2]|0);c[F>>2]=((w|0)<0?~w:w|-2147483648)+-16&-16;c[x>>2]=((y|0)<0?~y:y|-2147483648)+-16&-16;c[z>>2]=((A|0)<0?~A:A|-2147483648)+-16&-16;c[B>>2]=((C|0)<0?~C:C|-2147483648)+16&-16|1;c[D>>2]=((E|0)<0?~E:E|-2147483648)+16&-16|1;c[t>>2]=((h|0)<0?~h:h|-2147483648)+16&-16|1;h=s>>>5;t=1<<(s&31);if((c[(c[p>>2]|0)+(h<<2)>>2]&t|0)==0?(E=(c[o>>2]|0)+(h<<2)|0,h=c[E>>2]|0,(h&t|0)==0):0)c[E>>2]=h|t;s=c[(c[n>>2]|0)+(s<<2)>>2]|0}while((s|0)!=1073741823)}j=j+1|0}while((j|0)!=(f|0));K=b+49828|0;L=c[K>>2]|0;M=c[L>>2]|0;N=M+68|0;O=c[N>>2]|0;In[O&4095](L,d);i=e;return}function Opa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=0,y=Im,z=Im,A=0,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im;d=i;i=i+112|0;e=d+76|0;f=d+64|0;h=d+52|0;j=d+24|0;k=d;l=c[a>>2]|0;m=c[a+4>>2]|0;n=c[a+8>>2]|0;o=c[a+12>>2]|0;a=n+48|0;p=ea(g[a>>2]);q=n+52|0;r=ea(g[q>>2]);s=n+56|0;t=ea(p*ea(-2.0));p=ea(r*ea(-2.0));r=ea(ea(g[s>>2])*ea(-2.0));u=n+44|0;v=ea(g[u>>2]);w=ea(ea(v*v)+ea(-.5));x=n+32|0;y=ea(g[x>>2]);z=ea(t*y);A=n+36|0;B=ea(g[A>>2]);C=ea(z+ea(p*B));D=n+40|0;z=ea(g[D>>2]);E=ea(C+ea(r*z));C=ea(-y);F=ea(-B);G=ea(-z);H=ea(ea(ea(y*E)+ea(ea(t*w)-ea(v*ea(ea(r*B)-ea(p*z)))))*ea(2.0));I=ea(ea(ea(B*E)+ea(ea(p*w)-ea(v*ea(ea(t*z)-ea(r*y)))))*ea(2.0));J=ea(ea(ea(ea(r*w)-ea(v*ea(ea(p*y)-ea(t*B))))+ea(z*E))*ea(2.0));E=ea(g[n+12>>2]);z=ea(ea(E*E)+ea(-.5));B=ea(g[n>>2]);t=ea(B*H);y=ea(g[n+4>>2]);p=ea(t+ea(y*I));t=ea(g[n+8>>2]);w=ea(ea(t*J)+p);p=ea(ea(B*w)+ea(ea(z*H)+ea(E*ea(ea(y*J)-ea(t*I)))));r=ea(ea(y*w)+ea(ea(z*I)+ea(E*ea(ea(t*H)-ea(B*J)))));K=ea(ea(ea(z*J)+ea(E*ea(ea(B*I)-ea(y*H))))+ea(t*w));w=ea(ea(g[n+16>>2])+p);p=ea(ea(g[n+20>>2])+r);r=ea(ea(g[n+24>>2])+K);K=ea(ea(ea(ea(E*C)+ea(v*B))+ea(y*G))-ea(t*F));H=ea(ea(ea(t*C)+ea(ea(E*F)+ea(v*y)))-ea(B*G));I=ea(ea(ea(B*F)+ea(ea(E*G)+ea(v*t)))-ea(y*C));J=ea(ea(ea(ea(v*E)-ea(B*C))-ea(y*F))-ea(t*G));n=l+16|0;G=ea(ea(g[n>>2])*ea(2.0));L=l+20|0;t=ea(ea(g[L>>2])*ea(2.0));M=l+24|0;F=ea(ea(g[M>>2])*ea(2.0));y=ea(ea(J*J)+ea(-.5));C=ea(ea(ea(K*G)+ea(H*t))+ea(I*F));B=ea(w+ea(ea(K*C)+ea(ea(y*G)+ea(J*ea(ea(H*F)-ea(I*t))))));w=ea(p+ea(ea(H*C)+ea(ea(y*t)+ea(J*ea(ea(I*G)-ea(K*F))))));p=ea(r+ea(ea(ea(y*F)+ea(J*ea(ea(K*t)-ea(H*G))))+ea(I*C)));C=ea(g[l>>2]);G=ea(J*C);N=l+12|0;t=ea(g[N>>2]);F=ea(G+ea(K*t));O=l+8|0;G=ea(g[O>>2]);y=ea(F+ea(H*G));P=l+4|0;F=ea(g[P>>2]);r=ea(ea(ea(I*C)+ea(ea(H*t)+ea(J*F)))-ea(K*G));E=ea(ea(ea(K*F)+ea(ea(I*t)+ea(J*G)))-ea(H*C));v=ea(ea(ea(ea(J*t)-ea(K*C))-ea(H*F))-ea(I*G));g[e>>2]=ea(y-ea(I*F));g[e+4>>2]=r;g[e+8>>2]=E;g[e+12>>2]=v;g[e+16>>2]=B;g[e+20>>2]=w;g[e+24>>2]=p;Q=l+36|0;p=ea(pMa(Q,f,h,e,o));w=ea(g[f>>2]);B=ea(g[h>>2]);v=ea(w-B);e=f+4|0;E=ea(g[e>>2]);r=ea(g[h+4>>2]);F=ea(E-r);R=f+8|0;I=ea(g[R>>2]);y=ea(g[h+8>>2]);G=ea(I-y);H=ea(w+B);B=ea(E+r);r=ea(I+y);y=ea(g[m+32>>2]);I=ea(g[m+36>>2]);E=ea(g[m+40>>2]);w=ea(g[m+44>>2]);C=ea(g[m+48>>2]);K=ea(g[m+52>>2]);t=ea(g[m+56>>2]);J=ea(g[a>>2]);z=ea(g[q>>2]);S=ea(J*ea(-2.0));J=ea(z*ea(-2.0));z=ea(ea(g[s>>2])*ea(-2.0));T=ea(g[u>>2]);U=ea(ea(T*T)+ea(-.5));V=ea(g[x>>2]);W=ea(S*V);X=ea(g[A>>2]);Y=ea(W+ea(J*X));W=ea(g[D>>2]);Z=ea(Y+ea(z*W));Y=ea(-V);_=ea(-X);$=ea(-W);aa=ea(ea(ea(V*Z)+ea(ea(S*U)-ea(T*ea(ea(z*X)-ea(J*W)))))*ea(2.0));ba=ea(ea(ea(X*Z)+ea(ea(J*U)-ea(T*ea(ea(S*W)-ea(z*V)))))*ea(2.0));ca=ea(ea(ea(ea(z*U)-ea(T*ea(ea(J*V)-ea(S*X))))+ea(W*Z))*ea(2.0));Z=ea(ea(w*w)+ea(-.5));W=ea(ea(E*ca)+ea(ea(y*aa)+ea(I*ba)));X=ea(C+ea(ea(y*W)+ea(ea(Z*aa)+ea(w*ea(ea(I*ca)-ea(E*ba))))));C=ea(K+ea(ea(I*W)+ea(ea(Z*ba)+ea(w*ea(ea(E*aa)-ea(y*ca))))));K=ea(t+ea(ea(ea(Z*ca)+ea(w*ea(ea(y*ba)-ea(I*aa))))+ea(E*W)));W=ea(ea(ea(ea(y*T)+ea(w*Y))+ea(I*$))-ea(E*_));aa=ea(ea(ea(E*Y)+ea(ea(I*T)+ea(w*_)))-ea(y*$));ba=ea(ea(ea(y*_)+ea(ea(E*T)+ea(w*$)))-ea(I*Y));ca=ea(ea(ea(ea(w*T)-ea(y*Y))-ea(I*_))-ea(E*$));$=ea(ea(g[n>>2])*ea(2.0));E=ea(ea(g[L>>2])*ea(2.0));_=ea(ea(g[M>>2])*ea(2.0));I=ea(ea(ca*ca)+ea(-.5));Y=ea(ea(ea($*W)+ea(E*aa))+ea(_*ba));y=ea(ea(ea(W*Y)+ea(ea($*I)+ea(ca*ea(ea(_*aa)-ea(E*ba)))))+X);X=ea(ea(ea(aa*Y)+ea(ea(E*I)+ea(ca*ea(ea($*ba)-ea(_*W)))))+C);C=ea(ea(ea(ea(_*I)+ea(ca*ea(ea(E*W)-ea($*aa))))+ea(ba*Y))+K);K=ea(g[l>>2]);Y=ea(ca*K);$=ea(g[N>>2]);E=ea(Y+ea(W*$));Y=ea(g[O>>2]);I=ea(E+ea(aa*Y));E=ea(g[P>>2]);_=ea(ea(ea(K*ba)+ea(ea(aa*$)+ea(ca*E)))-ea(W*Y));T=ea(ea(ea(W*E)+ea(ea(ba*$)+ea(ca*Y)))-ea(aa*K));w=ea(ea(ea(ea(ca*$)-ea(W*K))-ea(aa*E))-ea(ba*Y));g[j>>2]=ea(I-ea(ba*E));g[j+4>>2]=_;g[j+8>>2]=T;g[j+12>>2]=w;g[j+16>>2]=y;g[j+20>>2]=X;g[j+24>>2]=C;oMa(Q,k,j,ea(0.0),o);C=ea(g[k>>2]);X=ea(g[k+4>>2]);y=ea(g[k+8>>2]);w=ea(g[k+12>>2]);T=ea(g[k+16>>2]);_=ea(g[k+20>>2]);E=ea(g[l+28>>2]);ba=ea((F<X?F:X)-E);F=ea((G<y?G:y)-E);g[b>>2]=ea((v<C?v:C)-E);g[b+4>>2]=ba;g[b+8>>2]=F;F=ea((B>T?B:T)+E);B=ea(E+(r>_?r:_));g[b+12>>2]=ea((H>w?H:w)+E);g[b+16>>2]=F;g[b+20>>2]=B;B=ea(ea(C+w)*ea(.5));w=ea(ea(X+T)*ea(.5));T=ea(ea(y+_)*ea(.5));_=ea(B-ea(g[f>>2]));B=ea(w-ea(g[e>>2]));w=ea(T-ea(g[R>>2]));R=ea(ea(ea(ea(_*_)+ea(B*B))+ea(w*w))-ea(p*p))>=ea(0.0);p=R?ea(1.0):ea(0.0);i=d;return ea(p)}function Ppa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;i=i+32|0;e=d;f=c[a>>2]|0;h=c[a+4>>2]|0;j=ea(g[h+16>>2]);k=ea(g[h+20>>2]);l=ea(g[h+24>>2]);m=ea(g[h>>2]);n=ea(g[h+4>>2]);o=ea(g[h+8>>2]);p=ea(g[h+12>>2]);q=ea(g[f+16>>2]);r=ea(g[f+20>>2]);s=ea(g[f+24>>2]);t=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[f+12>>2]);x=ea(ea(p*p)+ea(-.5));y=ea(ea(ea(m*q)+ea(n*r))+ea(o*s));z=ea(k+ea(ea(ea(n*y)+ea(ea(x*r)+ea(p*ea(ea(o*q)-ea(m*s)))))*ea(2.0)));k=ea(l+ea(ea(ea(ea(x*s)+ea(p*ea(ea(m*r)-ea(n*q))))+ea(o*y))*ea(2.0)));l=ea(ea(p*w)-ea(ea(ea(m*t)+ea(n*u))+ea(o*v)));A=ea(ea(ea(n*v)-ea(o*u))+ea(ea(p*t)+ea(m*w)));B=ea(ea(ea(o*t)-ea(m*v))+ea(ea(p*u)+ea(n*w)));C=ea(ea(ea(m*u)-ea(n*t))+ea(ea(p*v)+ea(o*w)));g[e+16>>2]=ea(j+ea(ea(ea(m*y)+ea(ea(q*x)+ea(p*ea(ea(n*s)-ea(o*r)))))*ea(2.0)));g[e+20>>2]=z;g[e+24>>2]=k;g[e>>2]=A;g[e+4>>2]=B;g[e+8>>2]=C;g[e+12>>2]=l;oMa(f+36|0,b,e,ea(g[f+28>>2]),0);i=d;return}function Qpa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im;f=i;i=i+32|0;h=f;j=c[d>>2]|0;k=c[d+8>>2]|0;l=c[d+12>>2]|0;if(b?(a[k+28>>0]&4)!=0:0){m=ea(Opa(d,e));i=f;return ea(m)}n=ea(-ea(g[k+48>>2]));o=ea(-ea(g[k+52>>2]));p=ea(-ea(g[k+56>>2]));q=ea(g[k+16>>2]);r=ea(g[k+20>>2]);s=ea(g[k+24>>2]);t=ea(g[k>>2]);u=ea(g[k+4>>2]);v=ea(g[k+8>>2]);w=ea(g[k+12>>2]);d=k+32|0;x=ea(g[d>>2]);y=ea(g[d+4>>2]);z=ea(g[d+8>>2]);A=ea(g[d+12>>2]);B=ea(ea(A*A)+ea(-.5));C=ea(ea(ea(x*n)+ea(y*o))+ea(z*p));D=ea(ea(ea(x*C)+ea(ea(B*n)-ea(A*ea(ea(y*p)-ea(z*o)))))*ea(2.0));E=ea(ea(ea(y*C)+ea(ea(B*o)-ea(A*ea(ea(z*n)-ea(x*p)))))*ea(2.0));F=ea(ea(ea(z*C)+ea(ea(B*p)-ea(A*ea(ea(x*o)-ea(y*n)))))*ea(2.0));n=ea(-x);x=ea(-y);y=ea(-z);z=ea(g[j+16>>2]);o=ea(g[j+20>>2]);p=ea(g[j+24>>2]);B=ea(g[j>>2]);C=ea(g[j+4>>2]);G=ea(g[j+8>>2]);H=ea(g[j+12>>2]);I=ea(ea(w*w)+ea(-.5));J=ea(ea(v*F)+ea(ea(t*D)+ea(u*E)));K=ea(ea(w*A)-ea(ea(ea(t*n)+ea(u*x))+ea(v*y)));L=ea(ea(ea(u*y)-ea(v*x))+ea(ea(w*n)+ea(t*A)));M=ea(ea(ea(v*n)-ea(t*y))+ea(ea(w*x)+ea(u*A)));N=ea(ea(ea(t*x)-ea(u*n))+ea(ea(w*y)+ea(v*A)));A=ea(ea(K*K)+ea(-.5));y=ea(ea(N*p)+ea(ea(z*L)+ea(o*M)));n=ea(ea(ea(ea(ea(o*A)+ea(K*ea(ea(z*N)-ea(L*p))))+ea(M*y))*ea(2.0))+ea(r+ea(ea(ea(ea(I*E)+ea(w*ea(ea(v*D)-ea(t*F))))+ea(u*J))*ea(2.0))));r=ea(ea(ea(ea(ea(p*A)+ea(K*ea(ea(o*L)-ea(z*M))))+ea(N*y))*ea(2.0))+ea(s+ea(ea(ea(ea(I*F)+ea(w*ea(ea(t*E)-ea(u*D))))+ea(v*J))*ea(2.0))));s=ea(ea(K*H)-ea(ea(ea(L*B)+ea(M*C))+ea(N*G)));x=ea(ea(ea(M*G)-ea(N*C))+ea(ea(K*B)+ea(L*H)));O=ea(ea(ea(N*B)-ea(L*G))+ea(ea(K*C)+ea(M*H)));P=ea(ea(ea(L*C)-ea(M*B))+ea(ea(K*G)+ea(N*H)));g[h+16>>2]=ea(ea(ea(ea(ea(z*A)+ea(K*ea(ea(M*p)-ea(o*N))))+ea(L*y))*ea(2.0))+ea(q+ea(ea(ea(ea(I*D)+ea(w*ea(ea(u*F)-ea(v*E))))+ea(t*J))*ea(2.0))));g[h+20>>2]=n;g[h+24>>2]=r;g[h>>2]=x;g[h+4>>2]=O;g[h+8>>2]=P;g[h+12>>2]=s;oMa(j+36|0,e,h,ea(g[j+28>>2]),l);m=ea(0.0);i=f;return ea(m)}function Rpa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;oMa(e+36|0,b,e,ea(g[e+28>>2]),0);i=d;return}function Spa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;d=i;i=i+32|0;e=d;f=c[a>>2]|0;h=c[a+8>>2]|0;j=c[a+12>>2]|0;k=ea(-ea(g[h+48>>2]));l=ea(-ea(g[h+52>>2]));m=ea(-ea(g[h+56>>2]));a=h+32|0;n=ea(g[a>>2]);o=ea(g[a+4>>2]);p=ea(g[a+8>>2]);q=ea(g[a+12>>2]);r=ea(ea(q*q)+ea(-.5));s=ea(ea(ea(n*k)+ea(o*l))+ea(p*m));t=ea(ea(ea(n*s)+ea(ea(r*k)-ea(q*ea(ea(o*m)-ea(p*l)))))*ea(2.0));u=ea(ea(ea(o*s)+ea(ea(r*l)-ea(q*ea(ea(p*k)-ea(n*m)))))*ea(2.0));v=ea(ea(ea(p*s)+ea(ea(r*m)-ea(q*ea(ea(n*l)-ea(o*k)))))*ea(2.0));k=ea(-n);n=ea(-o);o=ea(-p);p=ea(g[f+16>>2]);l=ea(g[f+20>>2]);m=ea(g[f+24>>2]);s=ea(g[f>>2]);w=ea(g[f+4>>2]);x=ea(g[f+8>>2]);y=ea(g[f+12>>2]);z=ea(ea(ea(p*k)+ea(l*n))+ea(m*o));A=ea(u+ea(ea(ea(z*n)+ea(ea(r*l)+ea(q*ea(ea(p*o)-ea(m*k)))))*ea(2.0)));u=ea(v+ea(ea(ea(ea(r*m)+ea(q*ea(ea(l*k)-ea(p*n))))+ea(z*o))*ea(2.0)));v=ea(ea(q*y)-ea(ea(ea(s*k)+ea(w*n))+ea(x*o)));B=ea(ea(ea(x*n)-ea(w*o))+ea(ea(q*s)+ea(y*k)));C=ea(ea(ea(s*o)-ea(x*k))+ea(ea(q*w)+ea(y*n)));D=ea(ea(ea(w*k)-ea(s*n))+ea(ea(q*x)+ea(y*o)));g[e+16>>2]=ea(t+ea(ea(ea(z*k)+ea(ea(p*r)+ea(q*ea(ea(m*n)-ea(l*o)))))*ea(2.0)));g[e+20>>2]=A;g[e+24>>2]=u;g[e>>2]=B;g[e+4>>2]=C;g[e+8>>2]=D;g[e+12>>2]=v;oMa(f+36|0,b,e,ea(g[f+28>>2]),j);i=d;return}function Tpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+32|0;e=d;e_a(e,a,b);g[c>>2]=ea(g[e>>2]);g[c+4>>2]=ea(g[e+4>>2]);g[c+8>>2]=ea(g[e+8>>2]);g[c+12>>2]=ea(g[e+12>>2]);g[c+16>>2]=ea(g[e+16>>2]);g[c+20>>2]=ea(g[e+20>>2]);i=d;return}function Upa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;h=i;i=i+80|0;j=h+48|0;k=h+24|0;l=h;if(b?(a[d+28>>0]&4)!=0:0){e_a(j,c+32|0,e);g[f>>2]=ea(g[j>>2]);c=f+4|0;g[c>>2]=ea(g[j+4>>2]);b=f+8|0;g[b>>2]=ea(g[j+8>>2]);m=f+12|0;g[m>>2]=ea(g[j+12>>2]);n=f+16|0;g[n>>2]=ea(g[j+16>>2]);o=f+20|0;g[o>>2]=ea(g[j+20>>2]);e_a(k,d,e);p=ea(g[f>>2]);q=ea(g[k>>2]);r=ea(g[c>>2]);s=ea(g[k+4>>2]);t=ea(g[b>>2]);u=ea(g[k+8>>2]);g[f>>2]=p<q?p:q;g[c>>2]=r<s?r:s;g[b>>2]=t<u?t:u;u=ea(g[m>>2]);t=ea(g[k+12>>2]);s=ea(g[n>>2]);r=ea(g[k+16>>2]);q=ea(g[o>>2]);p=ea(g[k+20>>2]);g[m>>2]=u>t?u:t;g[n>>2]=s>r?s:r;g[o>>2]=q>p?q:p;v=ea(1.0);i=h;return ea(v)}e_a(l,d,e);g[f>>2]=ea(g[l>>2]);g[f+4>>2]=ea(g[l+4>>2]);g[f+8>>2]=ea(g[l+8>>2]);g[f+12>>2]=ea(g[l+12>>2]);g[f+16>>2]=ea(g[l+16>>2]);g[f+20>>2]=ea(g[l+20>>2]);v=ea(0.0);i=h;return ea(v)}function Vpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=Im,A=0,B=0,C=Im,D=0,E=Im;h=i;i=i+80|0;j=h+48|0;k=h+24|0;l=h;m=e+(c[d+(c[a>>2]<<2)>>2]<<4)|0;n=(b&3|0)!=0?b&-4:b+-4|0;if(!n){o=m;p=ea(0.0)}else{q=j+12|0;r=j+4|0;s=j+8|0;t=q+4|0;u=q+8|0;v=0;w=m;x=ea(0.0);while(1){m=0;y=w;z=x;do{A=m+v|0;B=y;y=e+(c[d+(c[a+(A+1<<2)>>2]<<2)>>2]<<4)|0;z=ea(z+ea(Qpa(f,B,j)));B=c[a+(A<<2)>>2]|0;A=c[j>>2]|0;c[g+(B*24|0)>>2]=((A|0)<0?~A:A|-2147483648)+-16&-16;A=c[r>>2]|0;c[g+(B*24|0)+4>>2]=((A|0)<0?~A:A|-2147483648)+-16&-16;A=c[s>>2]|0;c[g+(B*24|0)+8>>2]=((A|0)<0?~A:A|-2147483648)+-16&-16;A=c[q>>2]|0;c[g+(B*24|0)+12>>2]=((A|0)<0?~A:A|-2147483648)+16&-16|1;A=c[t>>2]|0;c[g+(B*24|0)+16>>2]=((A|0)<0?~A:A|-2147483648)+16&-16|1;A=c[u>>2]|0;c[g+(B*24|0)+20>>2]=((A|0)<0?~A:A|-2147483648)+16&-16|1;m=m+1|0}while((m|0)!=4);v=v+4|0;if(v>>>0>=n>>>0){o=y;p=z;break}else{w=y;x=z}}}w=b+-1|0;if(n>>>0<w>>>0){b=k+12|0;v=k+4|0;u=k+8|0;t=b+4|0;q=b+8|0;s=n;n=o;x=p;while(1){r=s;s=s+1|0;j=e+(c[d+(c[a+(s<<2)>>2]<<2)>>2]<<4)|0;C=ea(x+ea(Qpa(f,n,k)));m=c[a+(r<<2)>>2]|0;r=c[k>>2]|0;c[g+(m*24|0)>>2]=((r|0)<0?~r:r|-2147483648)+-16&-16;r=c[v>>2]|0;c[g+(m*24|0)+4>>2]=((r|0)<0?~r:r|-2147483648)+-16&-16;r=c[u>>2]|0;c[g+(m*24|0)+8>>2]=((r|0)<0?~r:r|-2147483648)+-16&-16;r=c[b>>2]|0;c[g+(m*24|0)+12>>2]=((r|0)<0?~r:r|-2147483648)+16&-16|1;r=c[t>>2]|0;c[g+(m*24|0)+16>>2]=((r|0)<0?~r:r|-2147483648)+16&-16|1;r=c[q>>2]|0;c[g+(m*24|0)+20>>2]=((r|0)<0?~r:r|-2147483648)+16&-16|1;if((s|0)==(w|0)){D=j;E=C;break}else{n=j;x=C}}}else{D=o;E=p}p=ea(E+ea(Qpa(f,D,l)));D=c[a+(w<<2)>>2]|0;w=l+12|0;a=c[l>>2]|0;c[g+(D*24|0)>>2]=((a|0)<0?~a:a|-2147483648)+-16&-16;a=c[l+4>>2]|0;c[g+(D*24|0)+4>>2]=((a|0)<0?~a:a|-2147483648)+-16&-16;a=c[l+8>>2]|0;c[g+(D*24|0)+8>>2]=((a|0)<0?~a:a|-2147483648)+-16&-16;a=c[w>>2]|0;c[g+(D*24|0)+12>>2]=((a|0)<0?~a:a|-2147483648)+16&-16|1;a=c[w+4>>2]|0;c[g+(D*24|0)+16>>2]=((a|0)<0?~a:a|-2147483648)+16&-16|1;a=c[w+8>>2]|0;c[g+(D*24|0)+20>>2]=((a|0)<0?~a:a|-2147483648)+16&-16|1;i=h;return ~~p>>>0|0}function Wpa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+80|0;h=g+48|0;j=g+24|0;k=g;l=e+(c[d+(c[a>>2]<<2)>>2]<<3)|0;m=(b&3|0)!=0?b&-4:b+-4|0;if(!m)n=l;else{o=h+12|0;p=h+4|0;q=h+8|0;r=o+4|0;s=o+8|0;t=0;u=l;while(1){l=0;v=u;do{w=l+t|0;x=v;v=e+(c[d+(c[a+(w+1<<2)>>2]<<2)>>2]<<3)|0;Ppa(x,h);x=c[a+(w<<2)>>2]|0;w=c[h>>2]|0;c[f+(x*24|0)>>2]=((w|0)<0?~w:w|-2147483648)+-16&-16;w=c[p>>2]|0;c[f+(x*24|0)+4>>2]=((w|0)<0?~w:w|-2147483648)+-16&-16;w=c[q>>2]|0;c[f+(x*24|0)+8>>2]=((w|0)<0?~w:w|-2147483648)+-16&-16;w=c[o>>2]|0;c[f+(x*24|0)+12>>2]=((w|0)<0?~w:w|-2147483648)+16&-16|1;w=c[r>>2]|0;c[f+(x*24|0)+16>>2]=((w|0)<0?~w:w|-2147483648)+16&-16|1;w=c[s>>2]|0;c[f+(x*24|0)+20>>2]=((w|0)<0?~w:w|-2147483648)+16&-16|1;l=l+1|0}while((l|0)!=4);t=t+4|0;if(t>>>0>=m>>>0){n=v;break}else u=v}}u=b+-1|0;if(m>>>0<u>>>0){b=j+12|0;t=j+4|0;s=j+8|0;r=b+4|0;o=b+8|0;q=m;m=n;while(1){p=q;q=q+1|0;h=e+(c[d+(c[a+(q<<2)>>2]<<2)>>2]<<3)|0;Ppa(m,j);l=c[a+(p<<2)>>2]|0;p=c[j>>2]|0;c[f+(l*24|0)>>2]=((p|0)<0?~p:p|-2147483648)+-16&-16;p=c[t>>2]|0;c[f+(l*24|0)+4>>2]=((p|0)<0?~p:p|-2147483648)+-16&-16;p=c[s>>2]|0;c[f+(l*24|0)+8>>2]=((p|0)<0?~p:p|-2147483648)+-16&-16;p=c[b>>2]|0;c[f+(l*24|0)+12>>2]=((p|0)<0?~p:p|-2147483648)+16&-16|1;p=c[r>>2]|0;c[f+(l*24|0)+16>>2]=((p|0)<0?~p:p|-2147483648)+16&-16|1;p=c[o>>2]|0;c[f+(l*24|0)+20>>2]=((p|0)<0?~p:p|-2147483648)+16&-16|1;if((q|0)==(u|0)){y=h;break}else m=h}}else y=n;Ppa(y,k);y=c[a+(u<<2)>>2]|0;u=k+12|0;a=c[k>>2]|0;c[f+(y*24|0)>>2]=((a|0)<0?~a:a|-2147483648)+-16&-16;a=c[k+4>>2]|0;c[f+(y*24|0)+4>>2]=((a|0)<0?~a:a|-2147483648)+-16&-16;a=c[k+8>>2]|0;c[f+(y*24|0)+8>>2]=((a|0)<0?~a:a|-2147483648)+-16&-16;a=c[u>>2]|0;c[f+(y*24|0)+12>>2]=((a|0)<0?~a:a|-2147483648)+16&-16|1;a=c[u+4>>2]|0;c[f+(y*24|0)+16>>2]=((a|0)<0?~a:a|-2147483648)+16&-16|1;a=c[u+8>>2]|0;c[f+(y*24|0)+20>>2]=((a|0)<0?~a:a|-2147483648)+16&-16|1;i=g;return}function Xpa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16464|0;e=d+8264|0;f=d+72|0;g=d+16|0;h=d+40|0;j=d+56|0;k=d+64|0;l=d+24|0;m=d+48|0;n=d+8|0;o=d;p=d+32|0;q=g;c[q>>2]=0;c[q+4>>2]=0;q=h;c[q>>2]=0;c[q+4>>2]=0;q=j;c[q>>2]=0;c[q+4>>2]=0;q=k;c[q>>2]=0;c[q+4>>2]=0;q=l;c[q>>2]=0;c[q+4>>2]=0;q=m;c[q>>2]=0;c[q+4>>2]=0;q=n;c[q>>2]=0;c[q+4>>2]=0;q=o;c[q>>2]=0;c[q+4>>2]=0;q=p;c[q>>2]=0;c[q+4>>2]=0;q=c[b+44>>2]|0;if(!(q&1))r=0;else{s=c[b+20>>2]|0;c[g>>2]=c[s+16900>>2];c[h>>2]=c[s+20>>2];c[j>>2]=c[s+32>>2];c[k>>2]=c[s+44>>2];c[l>>2]=c[s+56>>2];c[m>>2]=c[s+12>>2];c[n>>2]=c[s+36>>2];c[o>>2]=c[b+48>>2];c[p>>2]=c[b+52>>2];r=1}if(!(q&2))if(!r){t=0;u=b+64|0;v=c[u>>2]|0;w=v+t|0;c[u>>2]=w;i=d;return}else x=1;else{q=c[b+20>>2]|0;c[g+(r<<2)>>2]=c[q+33316>>2];c[h+(r<<2)>>2]=c[q+308>>2];c[j+(r<<2)>>2]=c[q+320>>2];c[k+(r<<2)>>2]=c[q+332>>2];c[l+(r<<2)>>2]=c[q+344>>2];c[m+(r<<2)>>2]=c[q+300>>2];c[n+(r<<2)>>2]=c[q+324>>2];c[o+(r<<2)>>2]=c[b+56>>2];c[p+(r<<2)>>2]=c[b+60>>2];x=r+1|0}r=b+36|0;q=0;s=0;while(1){y=c[g+(q<<2)>>2]|0;z=c[h+(q<<2)>>2]|0;A=c[j+(q<<2)>>2]|0;B=c[k+(q<<2)>>2]|0;C=c[l+(q<<2)>>2]|0;D=c[m+(q<<2)>>2]|0;E=c[n+(q<<2)>>2]|0;F=c[o+(q<<2)>>2]|0;G=(c[p+(q<<2)>>2]|0)+F|0;if(F>>>0<G>>>0){H=F;F=s;I=0;J=0;while(1){K=c[y+(H<<2)>>2]|0;if(!(c[z+(K<<2)>>2]|0)){c[e+(J<<2)>>2]=K;L=J+1|0;if((L|0)==2048){Wpa(e,2048,A,B,D,E);M=F;N=I;O=0}else{M=F;N=I;O=L}}else{c[f+(I<<2)>>2]=K;K=I+1|0;if((K|0)==2048){M=(Vpa(f,2048,A,C,(a[r>>0]|0)!=0,D,E)|0)+F|0;N=0;O=J}else{M=F;N=K;O=J}}H=H+1|0;if((H|0)==(G|0))break;else{F=M;I=N;J=O}}if(O)Wpa(e,O,A,B,D,E);if(!N)P=M;else P=(Vpa(f,N,A,C,(a[r>>0]|0)!=0,D,E)|0)+M|0}else P=s;q=q+1|0;if((q|0)==(x|0)){t=P;break}else s=P}u=b+64|0;v=c[u>>2]|0;w=v+t|0;c[u>>2]=w;i=d;return}function Ypa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=Im,C=Im;b=i;i=i+3584|0;d=b+3072|0;e=b;f=c[a+32>>2]|0;h=(c[a+36>>2]|0)+f|0;if(f>>>0>=h>>>0){i=b;return}j=a+24|0;k=a+20|0;l=a+28|0;a=c[k>>2]|0;m=a;n=a;a=f;while(1){f=c[(c[n+180>>2]|0)+((c[(c[j>>2]|0)+(a<<2)>>2]|0)*1048|0)+1032>>2]|0;if((f|0)!=1073741823){o=m;p=0;q=f;while(1){f=c[(c[o+312>>2]|0)+(q<<2)>>2]|0;r=f>>>1;if((c[(c[c[l>>2]>>2]|0)+(f>>>6<<2)>>2]&1<<(r&31)|0)!=0?(f=c[o+248>>2]|0,g[f+(r*24|0)>>2]=ea(8507058669999999534545717.0e13),g[f+(r*24|0)+4>>2]=ea(8507058669999999534545717.0e13),g[f+(r*24|0)+8>>2]=ea(8507058669999999534545717.0e13),g[f+(r*24|0)+12>>2]=ea(-8507058669999999534545717.0e13),g[f+(r*24|0)+16>>2]=ea(-8507058669999999534545717.0e13),g[f+(r*24|0)+20>>2]=ea(-8507058669999999534545717.0e13),f=c[(c[o+308>>2]|0)+(q<<2)>>2]|0,(f|0)!=1073741823):0){c[d+(p<<2)>>2]=r;r=c[(c[o+320>>2]|0)+(q<<2)>>2]|0;if((f|0)!=0?(f=c[o+344>>2]|0,(c[f+(r<<4)+4>>2]|0)!=0):0)Spa(f+(r<<4)|0,e+(p*24|0)|0);else Rpa((c[o+332>>2]|0)+(r<<3)|0,e+(p*24|0)|0);s=c[k>>2]|0;t=p+1|0}else{s=o;t=p}q=c[(c[s+316>>2]|0)+(q<<2)>>2]|0;if((q|0)==1073741823)break;else{o=s;p=t}}if(!t){u=s;v=s}else{p=c[s+248>>2]|0;o=0;do{q=c[d+(o<<2)>>2]|0;r=p+(q*24|0)|0;w=ea(g[r>>2]);x=ea(g[e+(o*24|0)>>2]);f=p+(q*24|0)+4|0;y=ea(g[f>>2]);z=ea(g[e+(o*24|0)+4>>2]);A=p+(q*24|0)+8|0;B=ea(g[A>>2]);C=ea(g[e+(o*24|0)+8>>2]);g[r>>2]=w<x?w:x;g[f>>2]=y<z?y:z;g[A>>2]=B<C?B:C;A=p+(q*24|0)+12|0;C=ea(g[A>>2]);B=ea(g[e+(o*24|0)+12>>2]);f=p+(q*24|0)+16|0;z=ea(g[f>>2]);y=ea(g[e+(o*24|0)+16>>2]);r=p+(q*24|0)+20|0;x=ea(g[r>>2]);w=ea(g[e+(o*24|0)+20>>2]);g[A>>2]=C>B?C:B;g[f>>2]=z>y?z:y;g[r>>2]=x>w?x:w;o=o+1|0}while((o|0)!=(t|0));u=s;v=s}}else{u=n;v=m}a=a+1|0;if((a|0)==(h|0))break;else{m=v;n=u}}i=b;return}function Zpa(b){b=b|0;var d=0,e=0,f=0,h=Im,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;d=i;i=i+32|0;e=d;f=c[b+52>>2]|0;if(!f){h=ea(0.0);j=~~h>>>0;l=b+56|0;c[l>>2]=j;i=d;return}m=b+20|0;n=c[m>>2]|0;o=c[n+368>>2]|0;p=c[n+12>>2]|0;q=c[n+300>>2]|0;r=c[b+48>>2]|0;s=r+f|0;if(r>>>0>=s>>>0){h=ea(0.0);j=~~h>>>0;l=b+56|0;c[l>>2]=j;i=d;return}f=b+44|0;t=e+12|0;u=e+4|0;v=e+8|0;w=t+4|0;x=t+8|0;y=e+16|0;z=e+20|0;A=b+36|0;B=n;n=r;C=ea(0.0);while(1){r=c[o+(n<<2)>>2]|0;D=c[B+180>>2]|0;if((a[D+(r*1048|0)+1024>>0]|0)==0?(c[(c[B+232>>2]|0)+(r>>>5<<2)>>2]&1<<(r&31)|0)==0:0){E=c[D+(r*1048|0)+1032>>2]|0;if((E|0)!=1073741823){F=c[B+308>>2]|0;G=E;do{if((c[F+(G<<2)>>2]|0)!=1073741823)c[(c[f>>2]|0)+((c[(c[B+312>>2]|0)+(G<<2)>>2]|0)>>>1<<2)>>2]=G;G=c[(c[B+316>>2]|0)+(G<<2)>>2]|0}while((G|0)!=1073741823)}G=c[D+(r*1048|0)+1040>>2]|0;if((G|0)==1073741823){H=-25165825;I=-25165825;J=-25165825;K=2122317823;L=2122317823;M=2122317823;N=C}else{F=B;E=2122317823;O=2122317823;P=2122317823;Q=-25165825;R=-25165825;S=-25165825;T=G;U=C;while(1){G=a[(c[F+252>>2]|0)+T>>0]|0;if(!(G<<24>>24)){V=F;W=S;X=R;Y=Q;Z=P;_=O;$=E;aa=U}else{ba=(c[F+248>>2]|0)+(T*24|0)|0;ca=c[(c[f>>2]|0)+(T<<2)>>2]|0;da=c[(c[F+320>>2]|0)+(ca<<2)>>2]|0;if((c[(c[F+308>>2]|0)+(ca<<2)>>2]|0)!=0?(fa=c[F+344>>2]|0,ga=c[fa+(da<<4)+4>>2]|0,(ga|0)!=0):0)ha=ea(U+ea(Upa((a[A>>0]|0)!=0,ga,c[fa+(da<<4)+8>>2]|0,ba,e)));else{Tpa(c[(c[F+332>>2]|0)+(da<<3)+4>>2]|0,ba,e);ha=U}if(G<<24>>24==1){G=c[e>>2]|0;ba=c[u>>2]|0;da=c[v>>2]|0;fa=c[t>>2]|0;ga=c[w>>2]|0;ia=c[x>>2]|0;c[q+(ca*24|0)>>2]=((G|0)<0?~G:G|-2147483648)+-16&-16;c[q+(ca*24|0)+4>>2]=((ba|0)<0?~ba:ba|-2147483648)+-16&-16;c[q+(ca*24|0)+8>>2]=((da|0)<0?~da:da|-2147483648)+-16&-16;c[q+(ca*24|0)+12>>2]=((fa|0)<0?~fa:fa|-2147483648)+16&-16|1;c[q+(ca*24|0)+16>>2]=((ga|0)<0?~ga:ga|-2147483648)+16&-16|1;c[q+(ca*24|0)+20>>2]=((ia|0)<0?~ia:ia|-2147483648)+16&-16|1}ja=(c[k>>2]=E,ea(g[k>>2]));ka=ea(g[e>>2]);la=(c[k>>2]=O,ea(g[k>>2]));ma=ea(g[u>>2]);na=(c[k>>2]=P,ea(g[k>>2]));oa=ea(g[v>>2]);ia=(g[k>>2]=ja<ka?ja:ka,c[k>>2]|0);ca=(g[k>>2]=la<ma?la:ma,c[k>>2]|0);ga=(g[k>>2]=na<oa?na:oa,c[k>>2]|0);oa=(c[k>>2]=Q,ea(g[k>>2]));na=ea(g[t>>2]);ma=(c[k>>2]=R,ea(g[k>>2]));la=ea(g[y>>2]);ka=(c[k>>2]=S,ea(g[k>>2]));ja=ea(g[z>>2]);fa=(g[k>>2]=oa>na?oa:na,c[k>>2]|0);da=(g[k>>2]=ma>la?ma:la,c[k>>2]|0);V=c[m>>2]|0;W=(g[k>>2]=ka>ja?ka:ja,c[k>>2]|0);X=da;Y=fa;Z=ga;_=ca;$=ia;aa=ha}T=c[(c[V+256>>2]|0)+(T<<2)>>2]|0;if((T|0)==1073741823){H=W;I=X;J=Y;K=Z;L=_;M=$;N=aa;break}else{F=V;E=$;O=_;P=Z;Q=Y;R=X;S=W;U=aa}}}S=c[D+(r*1048|0)+1028>>2]|0;c[p+(S*24|0)>>2]=((M|0)<0?~M:M|-2147483648)+-16&-16;c[p+(S*24|0)+4>>2]=((L|0)<0?~L:L|-2147483648)+-16&-16;c[p+(S*24|0)+8>>2]=((K|0)<0?~K:K|-2147483648)+-16&-16;c[p+(S*24|0)+12>>2]=((J|0)<0?~J:J|-2147483648)+16&-16|1;c[p+(S*24|0)+16>>2]=((I|0)<0?~I:I|-2147483648)+16&-16|1;c[p+(S*24|0)+20>>2]=((H|0)<0?~H:H|-2147483648)+16&-16|1;pa=N}else{S=c[D+(r*1048|0)+1032>>2]|0;if((S|0)==1073741823){qa=8388608;ra=-8388609;sa=-8388609;ta=8388608;ua=8388608;va=-8388609}else{R=c[B+308>>2]|0;Q=c[B+316>>2]|0;P=-8388609;O=-8388609;E=-8388609;F=8388608;T=8388608;ia=8388608;ca=S;while(1){if((c[R+(ca<<2)>>2]|0)==1073741823){wa=ia;xa=T;ya=F;za=E;Aa=O;Ba=P}else{S=c[q+(ca*24|0)>>2]|0;ga=c[q+(ca*24|0)+4>>2]|0;fa=c[q+(ca*24|0)+8>>2]|0;da=c[q+(ca*24|0)+12>>2]|0;ba=c[q+(ca*24|0)+16>>2]|0;G=c[q+(ca*24|0)+20>>2]|0;wa=ia>>>0<G>>>0?G:ia;xa=T>>>0<ba>>>0?ba:T;ya=F>>>0<da>>>0?da:F;za=E>>>0<fa>>>0?E:fa;Aa=O>>>0<ga>>>0?O:ga;Ba=P>>>0<S>>>0?P:S}ca=c[Q+(ca<<2)>>2]|0;if((ca|0)==1073741823){qa=wa;ra=Aa;sa=Ba;ta=xa;ua=ya;va=za;break}else{P=Ba;O=Aa;E=za;F=ya;T=xa;ia=wa}}}ia=c[D+(r*1048|0)+1028>>2]|0;c[p+(ia*24|0)>>2]=sa;c[p+(ia*24|0)+4>>2]=ra;c[p+(ia*24|0)+8>>2]=va;c[p+(ia*24|0)+12>>2]=ua;c[p+(ia*24|0)+16>>2]=ta;c[p+(ia*24|0)+20>>2]=qa;pa=C}ia=n+1|0;if((ia|0)==(s|0)){h=pa;break}B=c[m>>2]|0;n=ia;C=pa}j=~~h>>>0;l=b+56|0;c[l>>2]=j;i=d;return}function _pa(a){a=a|0;var b=0;b=c[a+44>>2]|0;c[b>>2]=(c[b>>2]|0)+((c[a+452>>2]|0)+((c[a+384>>2]|0)+((c[a+316>>2]|0)+((c[a+248>>2]|0)+((c[a+180>>2]|0)+(c[a+112>>2]|0))))));return}function $pa(a){a=a|0;var b=0;b=c[a+40>>2]|0;c[b>>2]=(c[b>>2]|0)+((c[a+400>>2]|0)+((c[a+340>>2]|0)+((c[a+280>>2]|0)+((c[a+220>>2]|0)+((c[a+160>>2]|0)+(c[a+100>>2]|0))))));return}function aqa(a){a=a|0;var d=0;b[a+4>>1]=-1;b[a+6>>1]=0;c[a+8>>2]=0;c[a>>2]=443968;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=482992;c[a+20>>2]=4;c[a+24>>2]=0;d=a+48|0;b[a+52>>1]=-1;b[a+54>>1]=0;c[a+56>>2]=0;c[d>>2]=443968;c[a+60>>2]=0;c[a+64>>2]=0;c[d>>2]=483136;c[a+68>>2]=0;c[a+92>>2]=4;d=a+96|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+116|0;b[a+120>>1]=-1;b[a+122>>1]=0;c[a+124>>2]=0;c[d>>2]=443968;c[a+128>>2]=0;c[a+132>>2]=0;c[d>>2]=483136;c[a+136>>2]=0;c[a+160>>2]=4;d=a+164|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+184|0;b[a+188>>1]=-1;b[a+190>>1]=0;c[a+192>>2]=0;c[d>>2]=443968;c[a+196>>2]=0;c[a+200>>2]=0;c[d>>2]=483136;c[a+204>>2]=0;c[a+228>>2]=4;d=a+232|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+252|0;b[a+256>>1]=-1;b[a+258>>1]=0;c[a+260>>2]=0;c[d>>2]=443968;c[a+264>>2]=0;c[a+268>>2]=0;c[d>>2]=483136;c[a+272>>2]=0;c[a+296>>2]=4;d=a+300|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+320|0;b[a+324>>1]=-1;b[a+326>>1]=0;c[a+328>>2]=0;c[d>>2]=443968;c[a+332>>2]=0;c[a+336>>2]=0;c[d>>2]=483136;c[a+340>>2]=0;c[a+364>>2]=4;d=a+368|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+388|0;b[a+392>>1]=-1;b[a+394>>1]=0;c[a+396>>2]=0;c[d>>2]=443968;c[a+400>>2]=0;c[a+404>>2]=0;c[d>>2]=483136;c[a+408>>2]=0;c[a+432>>2]=4;d=a+436|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;return}function bqa(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function cqa(a){a=a|0;c[a+388>>2]=443968;c[a+396>>2]=0;c[a+320>>2]=443968;c[a+328>>2]=0;c[a+252>>2]=443968;c[a+260>>2]=0;c[a+184>>2]=443968;c[a+192>>2]=0;c[a+116>>2]=443968;c[a+124>>2]=0;c[a+48>>2]=443968;c[a+56>>2]=0;c[a>>2]=443968;c[a+8>>2]=0;return}function dqa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+96|0;e=d+72|0;f=d+48|0;g=d+24|0;h=d;c[a+112>>2]=0;c[a+180>>2]=0;c[a+248>>2]=0;c[a+316>>2]=0;c[a+384>>2]=0;c[a+452>>2]=0;j=a+24|0;k=a+28|0;l=a+20|0;m=0;do{n=c[j>>2]|0;o=c[l>>2]|0;p=a+(m*68|0)+48|0;b[a+(m*68|0)+52>>1]=-1;b[a+(m*68|0)+54>>1]=0;c[a+(m*68|0)+56>>2]=0;c[p>>2]=443968;c[a+(m*68|0)+60>>2]=0;c[a+(m*68|0)+64>>2]=0;c[p>>2]=483136;c[a+(m*68|0)+68>>2]=n;n=a+(m*68|0)+72|0;c[n+0>>2]=c[k+0>>2];c[n+4>>2]=c[k+4>>2];c[n+8>>2]=c[k+8>>2];c[n+12>>2]=c[k+12>>2];c[n+16>>2]=c[k+16>>2];c[a+(m*68|0)+92>>2]=o;o=a+(m*68|0)+96|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;m=m+1|0}while((m|0)!=6);m=c[a+28>>2]|0;k=m>>>0>6?6:m;o=c[l>>2]|0;do if((o&1|0)!=0?(n=c[(c[j>>2]|0)+16912>>2]|0,(n|0)!=0):0){if(!(k>>>0>1&n>>>0>256)){c[a+96>>2]=0;c[a+100>>2]=n;q=o;r=n;break}u$a(n,k,e,f);if(k){p=m>>>0<6?m:6;s=0;do{t=c[f+(s<<2)>>2]|0;c[a+(s*68|0)+96>>2]=c[e+(s<<2)>>2];c[a+(s*68|0)+100>>2]=t;s=s+1|0}while((s|0)!=(p|0))}q=c[l>>2]|0;r=n}else{q=o;r=0}while(0);do if((q&2|0)!=0?(o=c[(c[j>>2]|0)+33328>>2]|0,(o|0)!=0):0){if(!(k>>>0>1&o>>>0>256)){c[a+104>>2]=0;c[a+108>>2]=o;u=o;v=18;break}u$a(o,k,g,h);if(k){l=m>>>0<6?m:6;e=0;do{f=c[h+(e<<2)>>2]|0;c[a+(e*68|0)+104>>2]=c[g+(e<<2)>>2];c[a+(e*68|0)+108>>2]=f;e=e+1|0}while((e|0)!=(l|0));u=o;v=18}}else{u=0;v=18}while(0);if(((v|0)==18?k>>>0>1:0)?r>>>0>256|u>>>0>256:0){u=(k|0)==0;if(u){i=d;return}k=a+12|0;r=m>>>0<6?m:6;v=0;do{g=c[k>>2]|0;c[a+(v*68|0)+64>>2]=1;h=a+(v*68|0)+60|0;c[h>>2]=g;if(g){ko[c[(c[g>>2]|0)+16>>2]&4095](g);c[a+(v*68|0)+56>>2]=c[(c[h>>2]|0)+8>>2]}v=v+1|0}while((v|0)!=(r|0));if(u){i=d;return}u=m>>>0<6?m:6;m=0;do{r=a+(m*68|0)+48|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);m=m+1|0}while((m|0)!=(u|0));i=d;return}u=a+48|0;ko[c[(c[u>>2]|0)+8>>2]&4095](u);i=d;return}function eqa(a){a=a|0;var d=0;b[a+4>>1]=-1;b[a+6>>1]=0;c[a+8>>2]=0;c[a>>2]=443968;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=483040;c[a+20>>2]=0;d=a+44|0;b[a+48>>1]=-1;b[a+50>>1]=0;c[a+52>>2]=0;c[d>>2]=443968;c[a+56>>2]=0;c[a+60>>2]=0;c[d>>2]=483184;d=a+64|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+84|0;b[a+88>>1]=-1;b[a+90>>1]=0;c[a+92>>2]=0;c[d>>2]=443968;c[a+96>>2]=0;c[a+100>>2]=0;c[d>>2]=483184;d=a+104|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+124|0;b[a+128>>1]=-1;b[a+130>>1]=0;c[a+132>>2]=0;c[d>>2]=443968;c[a+136>>2]=0;c[a+140>>2]=0;c[d>>2]=483184;d=a+144|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+164|0;b[a+168>>1]=-1;b[a+170>>1]=0;c[a+172>>2]=0;c[d>>2]=443968;c[a+176>>2]=0;c[a+180>>2]=0;c[d>>2]=483184;d=a+184|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+204|0;b[a+208>>1]=-1;b[a+210>>1]=0;c[a+212>>2]=0;c[d>>2]=443968;c[a+216>>2]=0;c[a+220>>2]=0;c[d>>2]=483184;d=a+224|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;d=a+244|0;b[a+248>>1]=-1;b[a+250>>1]=0;c[a+252>>2]=0;c[d>>2]=443968;c[a+256>>2]=0;c[a+260>>2]=0;c[d>>2]=483184;d=a+264|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;return}function fqa(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function gqa(a){a=a|0;c[a+244>>2]=443968;c[a+252>>2]=0;c[a+204>>2]=443968;c[a+212>>2]=0;c[a+164>>2]=443968;c[a+172>>2]=0;c[a+124>>2]=443968;c[a+132>>2]=0;c[a+84>>2]=443968;c[a+92>>2]=0;c[a+44>>2]=443968;c[a+52>>2]=0;c[a>>2]=443968;c[a+8>>2]=0;return}function hqa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+24|0;f=d;g=a+20|0;h=c[g>>2]|0;j=h+268|0;k=c[h+41556>>2]|0;l=c[h+41568>>2]|0;m=h;h=0;while(1){n=a+(h*40|0)+44|0;b[a+(h*40|0)+48>>1]=-1;b[a+(h*40|0)+50>>1]=0;c[a+(h*40|0)+52>>2]=0;c[n>>2]=443968;c[a+(h*40|0)+56>>2]=0;c[a+(h*40|0)+60>>2]=0;c[n>>2]=483184;c[a+(h*40|0)+64>>2]=m;c[a+(h*40|0)+68>>2]=k;c[a+(h*40|0)+72>>2]=j;c[a+(h*40|0)+76>>2]=0;c[a+(h*40|0)+80>>2]=0;n=h+1|0;if((n|0)==6)break;m=c[g>>2]|0;h=n}h=c[a+24>>2]|0;g=h>>>0>6?6:h;do if(l){m=g>>>0>1&l>>>0>32;if(!m){c[a+76>>2]=0;c[a+80>>2]=l;break}v$a(l,g,e,f);if(!g){i=d;return}j=h>>>0<6?h:6;k=0;do{n=c[f+(k<<2)>>2]|0;c[a+(k*40|0)+76>>2]=c[e+(k<<2)>>2];c[a+(k*40|0)+80>>2]=n;k=k+1|0}while((k|0)!=(j|0));if(m){j=(g|0)==0;if(j){i=d;return}k=a+12|0;n=h>>>0<6?h:6;o=0;do{p=c[k>>2]|0;c[a+(o*40|0)+60>>2]=1;q=a+(o*40|0)+56|0;c[q>>2]=p;if(p){ko[c[(c[p>>2]|0)+16>>2]&4095](p);c[a+(o*40|0)+52>>2]=c[(c[q>>2]|0)+8>>2]}o=o+1|0}while((o|0)!=(n|0));if(j){i=d;return}n=h>>>0<6?h:6;o=0;do{k=a+(o*40|0)+44|0;ko[c[(c[k>>2]|0)+20>>2]&4095](k);o=o+1|0}while((o|0)!=(n|0));i=d;return}}while(0);h=a+44|0;ko[c[(c[h>>2]|0)+8>>2]&4095](h);i=d;return}function iqa(a){a=a|0;var d=0;b[a+4>>1]=-1;b[a+6>>1]=0;c[a+8>>2]=0;c[a>>2]=443968;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=483088;c[a+20>>2]=0;d=a+44|0;b[a+48>>1]=-1;b[a+50>>1]=0;c[a+52>>2]=0;c[d>>2]=443968;c[a+56>>2]=0;c[a+60>>2]=0;c[d>>2]=483232;c[a+64>>2]=0;d=a+88|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+104|0;b[a+108>>1]=-1;b[a+110>>1]=0;c[a+112>>2]=0;c[d>>2]=443968;c[a+116>>2]=0;c[a+120>>2]=0;c[d>>2]=483232;c[a+124>>2]=0;d=a+148|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+164|0;b[a+168>>1]=-1;b[a+170>>1]=0;c[a+172>>2]=0;c[d>>2]=443968;c[a+176>>2]=0;c[a+180>>2]=0;c[d>>2]=483232;c[a+184>>2]=0;d=a+208|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+224|0;b[a+228>>1]=-1;b[a+230>>1]=0;c[a+232>>2]=0;c[d>>2]=443968;c[a+236>>2]=0;c[a+240>>2]=0;c[d>>2]=483232;c[a+244>>2]=0;d=a+268|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+284|0;b[a+288>>1]=-1;b[a+290>>1]=0;c[a+292>>2]=0;c[d>>2]=443968;c[a+296>>2]=0;c[a+300>>2]=0;c[d>>2]=483232;c[a+304>>2]=0;d=a+328|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+344|0;b[a+348>>1]=-1;b[a+350>>1]=0;c[a+352>>2]=0;c[d>>2]=443968;c[a+356>>2]=0;c[a+360>>2]=0;c[d>>2]=483232;c[a+364>>2]=0;d=a+388|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;return}function jqa(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function kqa(a){a=a|0;c[a+344>>2]=443968;c[a+352>>2]=0;c[a+284>>2]=443968;c[a+292>>2]=0;c[a+224>>2]=443968;c[a+232>>2]=0;c[a+164>>2]=443968;c[a+172>>2]=0;c[a+104>>2]=443968;c[a+112>>2]=0;c[a+44>>2]=443968;c[a+52>>2]=0;c[a>>2]=443968;c[a+8>>2]=0;return}function lqa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+24|0;f=d;c[a+100>>2]=0;c[a+160>>2]=0;c[a+220>>2]=0;c[a+280>>2]=0;c[a+340>>2]=0;c[a+400>>2]=0;g=a+20|0;h=a+24|0;j=0;do{k=c[g>>2]|0;l=c[k+37444>>2]|0;m=a+(j*60|0)+44|0;b[a+(j*60|0)+48>>1]=-1;b[a+(j*60|0)+50>>1]=0;c[a+(j*60|0)+52>>2]=0;c[m>>2]=443968;c[a+(j*60|0)+56>>2]=0;c[a+(j*60|0)+60>>2]=0;c[m>>2]=483232;c[a+(j*60|0)+64>>2]=k;k=a+(j*60|0)+68|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];c[k+12>>2]=c[h+12>>2];c[k+16>>2]=c[h+16>>2];c[a+(j*60|0)+88>>2]=l;c[a+(j*60|0)+92>>2]=0;c[a+(j*60|0)+96>>2]=0;c[a+(j*60|0)+100>>2]=0;j=j+1|0}while((j|0)!=6);j=c[a+24>>2]|0;h=j>>>0>6?6:j;l=c[(c[g>>2]|0)+372>>2]|0;do if(l){g=h>>>0>1&l>>>0>32;if(!g){c[a+92>>2]=0;c[a+96>>2]=l;break}v$a(l,h,e,f);if(!h){i=d;return}k=j>>>0<6?j:6;m=0;do{n=c[f+(m<<2)>>2]|0;c[a+(m*60|0)+92>>2]=c[e+(m<<2)>>2];c[a+(m*60|0)+96>>2]=n;m=m+1|0}while((m|0)!=(k|0));if(g){k=(h|0)==0;if(k){i=d;return}m=a+12|0;n=j>>>0<6?j:6;o=0;do{p=c[m>>2]|0;c[a+(o*60|0)+60>>2]=1;q=a+(o*60|0)+56|0;c[q>>2]=p;if(p){ko[c[(c[p>>2]|0)+16>>2]&4095](p);c[a+(o*60|0)+52>>2]=c[(c[q>>2]|0)+8>>2]}o=o+1|0}while((o|0)!=(n|0));if(k){i=d;return}n=j>>>0<6?j:6;o=0;do{m=a+(o*60|0)+44|0;ko[c[(c[m>>2]|0)+20>>2]&4095](m);o=o+1|0}while((o|0)!=(n|0));i=d;return}}while(0);j=a+44|0;ko[c[(c[j>>2]|0)+8>>2]&4095](j);i=d;return}function mqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+48|0;d=b;e=a+20|0;Apa(c[e>>2]|0);f=c[e>>2]|0;e=c[f+112>>2]|0;g=c[f+80>>2]|0;h=c[f+84>>2]|0;j=c[f+136>>2]|0;k=c[f+140>>2]|0;l=c[f+12>>2]|0;m=c[f+20>>2]|0;n=c[f+36>>2]|0;c[d>>2]=c[f+108>>2];c[d+4>>2]=e;c[d+8>>2]=g;c[d+12>>2]=h;c[d+16>>2]=j;c[d+20>>2]=k;c[d+24>>2]=l;c[d+28>>2]=m;c[d+32>>2]=n;n=c[f+49828>>2]|0;En[c[(c[n>>2]|0)+44>>2]&127](n,c[a+24>>2]|0,c[a+32>>2]|0,d,c[a+12>>2]|0);i=b;return}function nqa(a){a=a|0;var b=0;b=i;Bpa(c[a+40>>2]|0,a+20|0);i=b;return}function oqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;b=i;i=i+10304|0;d=b+10290|0;e=b+10289|0;f=b+6176|0;g=b+10288|0;h=b+2064|0;j=b;k=a+40|0;a=c[k>>2]|0;if(!(c[a+45696>>2]|0))l=a;else{m=c[a>>2]|0;c[f+4096>>2]=m;n=f+4100|0;c[n>>2]=0;o=f+4104|0;c[o>>2]=0;p=h+4096|0;c[p>>2]=c[a>>2];q=h+4100|0;c[q>>2]=0;r=h+4104|0;c[r>>2]=0;s=j+2048|0;c[s>>2]=c[a>>2];t=j+2052|0;c[t>>2]=0;u=j+2056|0;c[u>>2]=0;v=c[a+324>>2]|0;if(v){do if(v>>>0>1024){w=v<<2;x=w+15&-16;if(!m){y=UJa(d,x,483416,1936)|0;c[n>>2]=y;z=w;A=y;break}else{y=p$a(m,x,1)|0;c[n>>2]=y;z=w;A=y;break}}else{c[n>>2]=f;z=v<<2;A=f}while(0);PEi(A|0,0,z|0)|0;c[o>>2]=v;v=c[k>>2]|0;z=c[v+324>>2]|0;if(!z){B=g;C=v}else{do if(z>>>0>1024){v=z<<2;A=v+15&-16;m=c[p>>2]|0;if(!m){y=UJa(g,A,483416,1936)|0;c[q>>2]=y;D=v;E=y;break}else{y=p$a(m,A,1)|0;c[q>>2]=y;D=v;E=y;break}}else{c[q>>2]=h;D=z<<2;E=h}while(0);PEi(E|0,0,D|0)|0;c[r>>2]=z;B=g;C=c[k>>2]|0}}else{B=g;C=a}a=c[C+196>>2]|0;if(!a)F=C;else{do if(a>>>0>256){C=a<<3;g=C+15&-16;B=c[s>>2]|0;if(!B){z=UJa(d,g,483416,1936)|0;c[t>>2]=z;G=C;H=z;break}else{z=p$a(B,g,1)|0;c[t>>2]=z;G=C;H=z;break}}else{c[t>>2]=j;G=a<<3;H=j}while(0);PEi(H|0,0,G|0)|0;c[u>>2]=a;F=c[k>>2]|0}Gpa(F,c[n>>2]|0,c[o>>2]|0,c[q>>2]|0,c[r>>2]|0,c[t>>2]|0);Hpa(c[k>>2]|0,c[t>>2]|0);Jpa(c[k>>2]|0,c[t>>2]|0);r=c[t>>2]|0;do if(!((r|0)==0|(r|0)==(j|0))){t=c[s>>2]|0;if(!t){VJa(e,r);break}q=c[t+16>>2]|0;if(q>>>0<=r>>>0?(q+(c[t+20>>2]|0)|0)>>>0>r>>>0:0){oTa(c[t>>2]|0);q=t+8|0;o=c[q>>2]|0;n=t+4|0;F=c[n>>2]|0;a=o;while(1){u=a+-1|0;I=F+(u<<2)|0;if((c[I>>2]|0)>>>0<r>>>0)a=u;else break}if(a>>>0<o>>>0){F=a;u=I;while(1){if(u)c[u>>2]=c[(c[n>>2]|0)+(F<<2)>>2];F=F+1|0;if((F|0)==(o|0))break;else u=u+4|0}}c[q>>2]=o+-1;pTa(c[t>>2]|0);break}VJa(d,r)}while(0);k$a(h);k$a(f);l=c[k>>2]|0}h=c[l+49828>>2]|0;ko[c[(c[h>>2]|0)+64>>2]&4095](h);h=c[k>>2]|0;l=h+116|0;r=h+120|0;if((c[l>>2]|0)>>>0>(c[r>>2]|0)>>>0){d=h+108|0;VJa(e,c[d>>2]|0);c[d>>2]=UJa(f,c[r>>2]<<2,483416,1340)|0;c[l>>2]=c[r>>2]}c[h+112>>2]=0;r=c[h+96>>2]|0;if(r)PEi(r|0,0,c[h+100>>2]<<2|0)|0;h=c[k>>2]|0;r=h+88|0;l=h+92|0;if((c[r>>2]|0)>>>0>(c[l>>2]|0)>>>0){d=h+80|0;VJa(e,c[d>>2]|0);c[d>>2]=UJa(f,c[l>>2]<<2,483416,1340)|0;c[r>>2]=c[l>>2]}c[h+84>>2]=0;l=c[h+68>>2]|0;if(l)PEi(l|0,0,c[h+72>>2]<<2|0)|0;h=c[k>>2]|0;l=h+144|0;r=h+148|0;if((c[l>>2]|0)>>>0>(c[r>>2]|0)>>>0){d=h+136|0;VJa(e,c[d>>2]|0);c[d>>2]=UJa(f,c[r>>2]<<2,483416,1340)|0;c[l>>2]=c[r>>2]}c[h+140>>2]=0;r=c[h+124>>2]|0;if(r)PEi(r|0,0,c[h+128>>2]<<2|0)|0;h=c[k>>2]|0;r=h+376|0;l=h+380|0;if((c[r>>2]|0)>>>0>(c[l>>2]|0)>>>0){d=h+368|0;VJa(e,c[d>>2]|0);c[d>>2]=UJa(f,c[l>>2]<<2,483416,1340)|0;c[r>>2]=c[l>>2]}c[h+372>>2]=0;l=c[h+356>>2]|0;if(l)PEi(l|0,0,c[h+360>>2]<<2|0)|0;j$a((c[k>>2]|0)+512|0);h=c[k>>2]|0;c[h+16912>>2]=0;j$a(h+16928|0);h=c[k>>2]|0;c[h+33328>>2]=0;k$a(h+33344|0);k$a((c[k>>2]|0)+37456|0);h=c[k>>2]|0;c[h+41568>>2]=0;k$a(h+41584|0);h=c[k>>2]|0;c[h+45696>>2]=0;k$a(h+45712|0);h=c[k>>2]|0;c[h+49824>>2]=0;PEi(c[h+268>>2]|0,0,c[h+272>>2]<<2|0)|0;h=c[k>>2]|0;l=h+196|0;if(!(c[l>>2]|0)){J=h;Dpa(J);i=b;return}r=h+188|0;f=h+184|0;h=0;do{d=c[r>>2]|0;e=c[f>>2]|0;I=d+(h<<4)|0;c[I>>2]=c[I>>2]|c[e+(h<<4)>>2];I=d+(h<<4)+4|0;c[I>>2]=c[I>>2]|c[e+(h<<4)+4>>2];I=d+(h<<4)+8|0;c[I>>2]=c[I>>2]|c[e+(h<<4)+8>>2];I=d+(h<<4)+12|0;c[I>>2]=c[I>>2]|c[e+(h<<4)+12>>2];I=e+(h<<4)|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;h=h+1|0}while(h>>>0<(c[l>>2]|0)>>>0);J=c[k>>2]|0;Dpa(J);i=b;return}function pqa(a){a=a|0;c[a>>2]=0;return}function qqa(a){a=a|0;return}function rqa(b){b=b|0;var d=0;d=i;c[b+4364>>2]=0;a[b+4356>>0]=1;c[b+4360>>2]=b+4100;c[b+4368>>2]=64;c[b+4372>>2]=256;c[b+4376>>2]=0;c[b+4380>>2]=0;c[b+4384>>2]=10240;c[b+4388>>2]=0;c[b+4392>>2]=0;PEi(b|0,0,4096)|0;i=d;return}function sqa(a){a=a|0;var b=0;b=i;w$a(a+4096|0);i=b;return}function tqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b;f=e+~(e<<15)|0;e=(f>>>10^f)*9|0;f=e>>>6^e;e=f+~(f<<11)|0;f=a+(((e>>>16^e)&1023)<<2)|0;e=c[f>>2]|0;if(e){h=c[e+32>>2]|0;a:do if(!h)j=e;else{k=h;l=e;while(1){if((c[l+28>>2]|0)==(b|0)){j=l;break a}m=c[k+32>>2]|0;if(!m){j=k;break}else{n=k;k=m;l=n}}}while(0);if((c[j+28>>2]|0)==(b|0)){e=j+36|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}if(j){e=a+4388|0;h=c[e>>2]|0;if(!h){x$a(a+4096|0);o=c[e>>2]|0}else o=h;c[e>>2]=c[o>>2];e=a+4376|0;c[e>>2]=(c[e>>2]|0)+1;e=a+4380|0;c[e>>2]=(c[e>>2]|0)+-1;if(!o)p=0;else{q=o+0|0;r=q+40|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));g[o>>2]=ea(g[b>>2]);g[o+4>>2]=ea(g[b+4>>2]);g[o+8>>2]=ea(g[b+8>>2]);g[o+12>>2]=ea(g[b+12>>2]);g[o+16>>2]=ea(g[b+16>>2]);g[o+20>>2]=ea(g[b+20>>2]);g[o+24>>2]=ea(g[b+24>>2]);c[o+32>>2]=0;c[o+28>>2]=b;p=o}c[j+32>>2]=p;s=p}else t=12}else t=12;if((t|0)==12){t=a+4388|0;p=c[t>>2]|0;if(!p){x$a(a+4096|0);u=c[t>>2]|0}else u=p;c[t>>2]=c[u>>2];t=a+4376|0;c[t>>2]=(c[t>>2]|0)+1;t=a+4380|0;c[t>>2]=(c[t>>2]|0)+-1;if(!u)v=0;else{q=u+0|0;r=q+40|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));g[u>>2]=ea(g[b>>2]);g[u+4>>2]=ea(g[b+4>>2]);g[u+8>>2]=ea(g[b+8>>2]);g[u+12>>2]=ea(g[b+12>>2]);g[u+16>>2]=ea(g[b+16>>2]);g[u+20>>2]=ea(g[b+20>>2]);g[u+24>>2]=ea(g[b+24>>2]);c[u+32>>2]=0;c[u+28>>2]=b;v=u}c[f>>2]=v;s=v}c[s+36>>2]=1;s=a+4392|0;c[s>>2]=(c[s>>2]|0)+1;i=d;return}function uqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=b;f=e+~(e<<15)|0;e=(f>>>10^f)*9|0;f=e>>>6^e;e=f+~(f<<11)|0;f=a+(((e>>>16^e)&1023)<<2)|0;e=c[f>>2]|0;a:do if(e){g=c[e+32>>2]|0;if(!g){h=e;j=0}else{k=g;g=e;l=0;while(1){if((c[g+28>>2]|0)==(b|0)){h=g;j=l;break a}m=c[k+32>>2]|0;if(!m){h=k;j=g;break}else{n=k;k=m;l=g;g=n}}}}else{h=0;j=0}while(0);b=h+36|0;e=c[b>>2]|0;if((e|0)!=1){c[b>>2]=e+-1;i=d;return}e=c[h+32>>2]|0;if(!j){c[f>>2]=e;if(h)o=9}else{c[j+32>>2]=e;o=9}if((o|0)==9?(o=a+4376|0,c[o>>2]=(c[o>>2]|0)+-1,o=a+4388|0,c[h>>2]=c[o>>2],c[o>>2]=h,h=a+4380|0,o=c[h>>2]|0,c[h>>2]=o+1,(o|0)>=((c[a+4372>>2]|0)*50|0)):0){y$a(a+4096|0);c[h>>2]=0}h=a+4392|0;c[h>>2]=(c[h>>2]|0)+-1;i=d;return}function vqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;e=b;f=e+~(e<<15)|0;e=(f>>>10^f)*9|0;f=e>>>6^e;e=f+~(f<<11)|0;f=c[a+(((e>>>16^e)&1023)<<2)>>2]|0;a:do if(f){e=c[f+32>>2]|0;if(!e)h=f;else{a=e;e=f;while(1){if((c[e+28>>2]|0)==(b|0)){h=e;break a}j=c[a+32>>2]|0;if(!j){h=a;break}else{k=a;a=j;e=k}}}}else h=0;while(0);g[h>>2]=ea(g[b>>2]);g[h+4>>2]=ea(g[b+4>>2]);g[h+8>>2]=ea(g[b+8>>2]);g[h+12>>2]=ea(g[b+12>>2]);g[h+16>>2]=ea(g[b+16>>2]);g[h+20>>2]=ea(g[b+20>>2]);g[h+24>>2]=ea(g[b+24>>2]);i=d;return}function wqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b;f=e+~(e<<15)|0;e=(f>>>10^f)*9|0;f=e>>>6^e;e=f+~(f<<11)|0;f=c[a+(((e>>>16^e)&1023)<<2)>>2]|0;if(!f){i=d;return 0}e=c[f+32>>2]|0;a:do if(!e)g=f;else{a=e;h=f;while(1){if((c[h+28>>2]|0)==(b|0)){g=h;break a}j=c[a+32>>2]|0;if(!j){g=a;break}else{k=a;a=j;h=k}}}while(0);i=d;return ((c[g+28>>2]|0)==(b|0)?g:0)|0}function xqa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if(!(c[a+4392>>2]|0)){i=b;return}else d=0;do{e=c[a+(d<<2)>>2]|0;if(e){f=e;do{e=c[f+28>>2]|0;g[f>>2]=ea(g[e>>2]);g[f+4>>2]=ea(g[e+4>>2]);g[f+8>>2]=ea(g[e+8>>2]);g[f+12>>2]=ea(g[e+12>>2]);g[f+16>>2]=ea(g[e+16>>2]);g[f+20>>2]=ea(g[e+20>>2]);g[f+24>>2]=ea(g[e+24>>2]);f=c[f+32>>2]|0}while((f|0)!=0)}d=d+1|0}while((d|0)!=1024);i=b;return}function yqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b;f=e+~(e<<15)|0;e=(f>>>10^f)*9|0;f=e>>>6^e;e=f+~(f<<11)|0;f=c[a+(((e>>>16^e)&1023)<<2)>>2]|0;if(f){e=f;while(1){f=e;e=c[e+32>>2]|0;g=(c[f+28>>2]|0)==(b|0);if(!e)break;if(g){h=1;j=6;break}}if((j|0)==6){i=d;return h|0}if(g){h=1;i=d;return h|0}}h=0;i=d;return h|0}function zqa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;if((f|0)!=0?(c[f+(c[g+((d>>>2)*12|0)>>2]<<2)>>2]|0)==(c[f+(c[g+((e>>>2)*12|0)>>2]<<2)>>2]|0):0){j=0;i=h;return j|0}g=d>>>0>e>>>0;f=g?e:d;k=g?d:e;e=k<<16|f&65535;d=e+~(e<<15)|0;e=(d>>10^d)*9|0;d=e>>6^e;e=d+~(d<<11)|0;d=e>>16^e;e=b+4|0;g=c[e>>2]&d;l=b+12|0;m=c[l>>2]|0;a:do if((m|0)!=0?(n=c[b+20>>2]|0,o=c[b+16>>2]|0,p=c[m+(g<<2)>>2]|0,(p|0)!=-1):0){q=p;while(1){r=n+(q*12|0)|0;if((c[r>>2]|0)==(f|0)?(c[n+(q*12|0)+4>>2]|0)==(k|0):0)break;p=c[o+(q<<2)>>2]|0;if((p|0)==-1)break a;else q=p}if(r){a[n+(q*12|0)+9>>0]=1;j=r;i=h;return j|0}}while(0);r=b+8|0;o=c[r>>2]|0;if(o>>>0<(c[b>>2]|0)>>>0){s=o;t=m;u=g}else{g=o+1|0;o=g>>>1|g;g=o>>>2|o;o=g>>>4|g;g=o>>>8|o;o=g>>>16|g;c[b>>2]=o+1;c[e>>2]=o;Aqa(b);s=c[r>>2]|0;t=c[l>>2]|0;u=c[e>>2]&d}d=c[b+20>>2]|0;e=d+(s*12|0)|0;c[e>>2]=f;c[d+(s*12|0)+4>>2]=k;a[d+(s*12|0)+8>>0]=1;a[d+(s*12|0)+9>>0]=0;s=t+(u<<2)|0;c[(c[b+16>>2]|0)+(c[r>>2]<<2)>>2]=c[s>>2];b=c[r>>2]|0;c[r>>2]=b+1;c[s>>2]=b;j=e;i=h;return j|0}function Aqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+12|0;g=c[f>>2]|0;if(g){VJa(b+5|0,g);c[f>>2]=0}g=UJa(b+4|0,c[a>>2]<<2,483800,1029)|0;c[f>>2]=g;h=c[a>>2]|0;if(!h)j=0;else{PEi(g|0,-1,h<<2|0)|0;j=(c[a>>2]|0)*12|0}h=UJa(b+3|0,j,483800,1033)|0;j=UJa(b+2|0,c[a>>2]<<2,483800,1034)|0;g=a+8|0;k=c[g>>2]|0;if((k|0)!=0?(YEi(h|0,c[a+20>>2]|0,k*12|0)|0,(c[g>>2]|0)!=0):0){k=c[a+20>>2]|0;l=a+4|0;m=c[f>>2]|0;f=0;do{n=c[k+(f*12|0)+4>>2]<<16|c[k+(f*12|0)>>2]&65535;o=n+~(n<<15)|0;n=(o>>10^o)*9|0;o=n>>6^n;n=o+~(o<<11)|0;o=m+(((n>>16^n)&c[l>>2])<<2)|0;c[j+(f<<2)>>2]=c[o>>2];c[o>>2]=f;f=f+1|0}while(f>>>0<(c[g>>2]|0)>>>0)}g=a+16|0;f=c[g>>2]|0;if(f){VJa(d,f);c[g>>2]=0}f=a+20|0;a=c[f>>2]|0;if(!a){c[f>>2]=h;c[g>>2]=j;i=b;return}VJa(e,a);c[f>>2]=0;c[f>>2]=h;c[g>>2]=j;i=b;return}function Bqa(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;d=a+12|0;h=c[d>>2]|0;j=h+(f<<2)|0;f=c[j>>2]|0;k=c[a+16>>2]|0;if((f|0)!=(g|0)){l=f;while(1){f=c[k+(l<<2)>>2]|0;if((f|0)==(g|0))break;else l=f}f=a+16|0;m=c[k+(g<<2)>>2]|0;if((l|0)==-1){n=m;o=f;p=6}else{c[k+(l<<2)>>2]=m;q=f}}else{n=c[k+(g<<2)>>2]|0;o=a+16|0;p=6}if((p|0)==6){c[j>>2]=n;q=o}o=a+8|0;n=c[o>>2]|0;j=n+-1|0;if((j|0)==(g|0)){r=n;s=r+-1|0;c[o>>2]=s;i=e;return}n=c[a+20>>2]|0;f=c[n+(j*12|0)+4>>2]<<16|c[n+(j*12|0)>>2]&65535;m=f+~(f<<15)|0;f=(m>>10^m)*9|0;m=f>>6^f;f=m+~(m<<11)|0;m=(f>>16^f)&c[a+4>>2];a=h+(m<<2)|0;h=c[a>>2]|0;if((h|0)!=(j|0)){f=h;while(1){h=c[k+(f<<2)>>2]|0;if((h|0)==(j|0))break;else f=h}h=c[k+(j<<2)>>2]|0;if((f|0)==-1){t=h;p=13}else c[k+(f<<2)>>2]=h}else{t=c[k+(j<<2)>>2]|0;p=13}if((p|0)==13)c[a>>2]=t;t=n+(g*12|0)|0;a=n+(j*12|0)|0;c[t+0>>2]=c[a+0>>2];c[t+4>>2]=c[a+4>>2];b[t+8>>1]=b[a+8>>1]|0;a=(c[d>>2]|0)+(m<<2)|0;c[(c[q>>2]|0)+(g<<2)>>2]=c[a>>2];c[a>>2]=g;r=c[o>>2]|0;s=r+-1|0;c[o>>2]=s;i=e;return}function Cqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=a+76|0;f=c[e>>2]|0;if(f){VJa(d,f);c[e>>2]=0}e=a+112|0;f=c[e>>2]|0;if(f){VJa(b+2|0,f);c[e>>2]=0}e=a+108|0;f=c[e>>2]|0;if(f){VJa(b+1|0,f);c[e>>2]=0}e=a+104|0;f=c[e>>2]|0;if(f){VJa(b,f);c[e>>2]=0}e=a+100|0;f=c[e>>2]|0;if(f){VJa(d,f);c[e>>2]=0}e=a+96|0;f=c[e>>2]|0;if(f){VJa(d,f);c[e>>2]=0}e=a+12984|0;f=c[e>>2]|0;if(!((f|0)==(a+12464|0)|(f|0)==0)){VJa(b+3|0,f);c[e>>2]=0}e=a+12988|0;f=c[e>>2]|0;if(!((f|0)==(a+176|0)|(f|0)==0)){VJa(d,f);c[e>>2]=0}e=a+12992|0;f=c[e>>2]|0;if(!((f|0)==(a+6320|0)|(f|0)==0)){VJa(d,f);c[e>>2]=0}c[a+12976>>2]=0;c[a+12980>>2]=0;MMa(a+132|0);e=a+124|0;f=c[e>>2]|0;if(!f){c[e>>2]=0;g=a+128|0;c[g>>2]=0;i=b;return}VJa(d,f);c[e>>2]=0;c[e>>2]=0;g=a+128|0;c[g>>2]=0;i=b;return}function Dqa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+8240|0;f=e+8233|0;g=e+40|0;h=e+8232|0;j=e;k=e+38|0;l=e+37|0;m=e+36|0;a[d+168>>0]=0;n=c[d+84>>2]|0;if(!n){o=d+124|0;p=c[o>>2]|0;if(p){VJa(f,p);c[o>>2]=0}c[o>>2]=0;c[d+128>>2]=0;i=e;return}o=n<<4;if(o>>>0<8193)q=g;else q=UJa(h,o,483800,1197)|0;o=q+(n<<2)|0;h=q+(n<<3)|0;p=q+(n*12|0)|0;r=d+128|0;s=d+124|0;t=d+96|0;u=0;v=0;w=0;while(1){x=u>>>5;if(x>>>0<(c[r>>2]|0)>>>0){y=c[(c[t>>2]|0)+(u*24|0)>>2]|0;if(!(c[(c[s>>2]|0)+(x<<2)>>2]&1<<(u&31))){z=y;A=12}else{c[q+(w<<2)>>2]=y;c[h+(w<<2)>>2]=u;B=v;C=w+1|0}}else{z=c[(c[t>>2]|0)+(u*24|0)>>2]|0;A=12}if((A|0)==12){A=0;c[o+(v<<2)>>2]=z;c[p+(v<<2)>>2]=u;B=v+1|0;C=w}u=u+1|0;if((u|0)==(n|0))break;else{v=B;w=C}}KMa(j);if(C>>>0<1024)D=NMa(d+132|0,q,C,1)|0;else D=NMa(j,q,C,1)|0;w=c[D+8>>2]|0;D=d+80|0;v=UJa(k,c[D>>2]<<1,483800,1245)|0;k=(c[D>>2]|0)+2|0;D=mKa()|0;u=c[(c[D>>2]|0)+8>>2]|0;z=pKa()|0;A=mo[c[(c[z>>2]|0)+24>>2]&4095](z)|0;z=Bn[u&255](D,k>>>0>178956970?-1:k*24|0,A?484488:544544,483800,1250)|0;c[z+(n*24|0)>>2]=-1;c[z+((n+1|0)*24|0)>>2]=-1;if(!C)E=-1;else E=c[q+(c[w>>2]<<2)>>2]|0;if(!B)F=-1;else F=c[o>>2]|0;A=d+104|0;k=d+96|0;D=d+76|0;u=0;t=E;E=F;F=0;s=0;while(1){if(t>>>0<E>>>0){r=c[h+(c[w+(F<<2)>>2]<<2)>>2]|0;y=F+1|0;if(y>>>0<C>>>0){G=r;H=c[q+(c[w+(y<<2)>>2]<<2)>>2]|0;I=E;J=y;K=s}else{G=r;H=-1;I=E;J=y;K=s}}else{y=c[p+(s<<2)>>2]|0;r=s+1|0;if(r>>>0<B>>>0){G=y;H=t;I=c[o+(r<<2)>>2]|0;J=F;K=r}else{G=y;H=t;I=-1;J=F;K=r}}r=b[(c[A>>2]|0)+(G<<1)>>1]|0;y=z+(u*24|0)|0;x=(c[k>>2]|0)+(G*24|0)|0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];c[y+12>>2]=c[x+12>>2];c[y+16>>2]=c[x+16>>2];c[y+20>>2]=c[x+20>>2];b[v+(u<<1)>>1]=r;c[(c[D>>2]|0)+((r&65535)<<3)>>2]=u;u=u+1|0;if((u|0)==(n|0))break;else{t=H;E=I;F=J;s=K}}if((q|0)!=(g|0)&(q|0)!=0)VJa(l,q);q=d+96|0;l=c[q>>2]|0;if(l){VJa(f,l);c[q>>2]=0}c[q>>2]=z;z=d+104|0;q=c[z>>2]|0;if(q){VJa(m,q);c[z>>2]=0}c[z>>2]=v;v=d+124|0;z=c[v>>2]|0;if(z){VJa(f,z);c[v>>2]=0}c[v>>2]=0;c[d+128>>2]=0;MMa(j);i=e;return}function Eqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b;e=a+68|0;f=(c[e>>2]|0)+128|0;g=f>>>0>536870911?-1:f<<3;if(!g)h=0;else{j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;h=Bn[k&255](j,g,m?484392:544544,483800,1327)|0}if(f){m=h+(f<<3)|0;g=h;do{c[g+4>>2]=-1;g=g+8|0}while((g|0)!=(m|0))}m=c[a+64>>2]|0;g=a+76|0;if(m)YEi(h|0,c[g>>2]|0,m<<3|0)|0;m=c[g>>2]|0;if(!m){c[g>>2]=h;c[e>>2]=f;i=b;return}VJa(d,m);c[g>>2]=0;c[g>>2]=h;c[e>>2]=f;i=b;return}function Fqa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=i;i=i+32|0;j=h;k=h+26|0;l=h+25|0;m=h+24|0;n=d+72|0;o=c[n>>2]|0;if((o|0)==-1){p=d+64|0;q=c[p>>2]|0;if((c[d+68>>2]|0)==(q|0)){Eqa(d);r=c[p>>2]|0;s=r;t=r}else{s=q;t=q}}else{c[n>>2]=c[(c[d+76>>2]|0)+((o&65535)<<3)>>2];s=c[d+64>>2]|0;t=o}o=t&65535;c[d+64>>2]=s+1;if(g){s=d+80|0;n=c[s>>2]|0;q=d+84|0;r=c[q>>2]|0;if((n|0)==(r|0)){p=n+128|0;u=d+96|0;v=c[u>>2]|0;w=p>>>0>178956970?-1:p*24|0;if(!w)x=0;else{y=mKa()|0;z=c[(c[y>>2]|0)+8>>2]|0;A=pKa()|0;B=mo[c[(c[A>>2]|0)+24>>2]&4095](A)|0;x=Bn[z&255](y,w,B?484488:544544,483800,1341)|0}if(n)YEi(x|0,v|0,n*24|0)|0;if(v)VJa(j,v);c[u>>2]=x;x=c[q>>2]|0;v=d+104|0;n=c[v>>2]|0;B=UJa(j,p<<1,483800,1350)|0;if(x)YEi(B|0,n|0,x<<1|0)|0;if(n)VJa(k,n);c[v>>2]=B;c[s>>2]=p;C=v;D=u;E=c[q>>2]|0}else{C=d+104|0;D=d+96|0;E=r}c[q>>2]=E+1;q=(c[D>>2]|0)+(E*24|0)|0;c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2];b[(c[C>>2]|0)+(E<<1)>>1]=o;a[d+168>>0]=1;C=d+124|0;q=E>>>5;D=d+128|0;if(q>>>0<(c[D>>2]|0)>>>0)F=c[C>>2]|0;else{r=E+128|0;u=((r&31|0)!=0&1)+(r>>>5)|0;r=UJa(j,u<<2,483800,429)|0;v=c[D>>2]|0;if(!v)G=0;else{YEi(r|0,c[C>>2]|0,v<<2|0)|0;G=c[D>>2]|0}if((u|0)!=(G|0))PEi(r+(G<<2)|0,0,u-G<<2|0)|0;G=c[C>>2]|0;if(G){VJa(k,G);c[C>>2]=0}c[C>>2]=r;c[D>>2]=u;F=r}r=F+(q<<2)|0;c[r>>2]=c[r>>2]|1<<(E&31);H=E}else{E=d+88|0;r=c[E>>2]|0;q=d+92|0;F=c[q>>2]|0;if((r|0)==(F|0)){u=r+128|0;D=d+100|0;C=c[D>>2]|0;G=u>>>0>178956970?-1:u*24|0;if(!G)I=0;else{v=mKa()|0;p=c[(c[v>>2]|0)+8>>2]|0;s=pKa()|0;B=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;I=Bn[p&255](v,G,B?484488:544544,483800,1341)|0}if(r)YEi(I|0,C|0,r*24|0)|0;if(C)VJa(j,C);c[D>>2]=I;I=c[q>>2]|0;C=d+108|0;r=c[C>>2]|0;B=UJa(j,u<<1,483800,1350)|0;if(I)YEi(B|0,r|0,I<<1|0)|0;if(r)VJa(k,r);c[C>>2]=B;c[E>>2]=u;E=d+112|0;B=c[E>>2]|0;if(B){VJa(l,B);c[E>>2]=0}c[E>>2]=UJa(m,(u<<2)+4|0,483800,1429)|0;J=D;K=C;L=c[q>>2]|0}else{J=d+100|0;K=d+108|0;L=F}c[q>>2]=L+1;q=(c[J>>2]|0)+(L*24|0)|0;c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2];b[(c[K>>2]|0)+(L<<1)>>1]=o;H=L}L=t&65535;t=c[d+76>>2]|0;K=t+(L<<3)|0;c[K>>2]=H;c[t+(L<<3)+4>>2]=f;if(g){i=h;return o|0}g=c[d+100>>2]|0;f=c[d+108>>2]|0;L=d+116|0;q=c[L>>2]|0;J=g+(q*24|0)|0;if((H|0)==(q|0)){c[J+0>>2]=c[e+0>>2];c[J+4>>2]=c[e+4>>2];c[J+8>>2]=c[e+8>>2];c[J+12>>2]=c[e+12>>2];c[J+16>>2]=c[e+16>>2];c[J+20>>2]=c[e+20>>2]}else{c[j+0>>2]=c[J+0>>2];c[j+4>>2]=c[J+4>>2];c[j+8>>2]=c[J+8>>2];c[j+12>>2]=c[J+12>>2];c[j+16>>2]=c[J+16>>2];c[j+20>>2]=c[J+20>>2];c[J+0>>2]=c[e+0>>2];c[J+4>>2]=c[e+4>>2];c[J+8>>2]=c[e+8>>2];c[J+12>>2]=c[e+12>>2];c[J+16>>2]=c[e+16>>2];c[J+20>>2]=c[e+20>>2];e=g+(H*24|0)|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];c[e+20>>2]=c[j+20>>2];j=f+(q<<1)|0;e=b[j>>1]|0;g=f+(H<<1)|0;b[j>>1]=b[g>>1]|0;b[g>>1]=e;c[t+((e&65535)<<3)>>2]=H;c[K>>2]=q}c[L>>2]=(c[L>>2]|0)+1;c[d+120>>2]=0;a[d+169>>0]=1;i=h;return o|0}function Gqa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+16|0;g=f+1|0;h=f;j=e&65535;e=d+76|0;k=c[e>>2]|0;l=k+(j<<3)|0;m=c[l>>2]|0;n=k+(j<<3)+4|0;if(!(c[n>>2]&1)){c[d+120>>2]=0;a[d+169>>0]=1;o=d+116|0;p=c[o>>2]|0;q=d+92|0;if(m>>>0<p>>>0){if((p|0)==(c[q>>2]|0)){r=p;s=m}else{t=p+-1|0;p=c[d+108>>2]|0;u=c[d+100>>2]|0;v=b[p+(t<<1)>>1]|0;w=u+(m*24|0)|0;x=u+(t*24|0)|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];c[w+16>>2]=c[x+16>>2];c[w+20>>2]=c[x+20>>2];b[p+(m<<1)>>1]=v;c[k+((v&65535)<<3)>>2]=m;r=c[o>>2]|0;s=t}c[o>>2]=r+-1;y=s}else y=m;s=c[d+108>>2]|0;r=c[d+100>>2]|0;o=(c[q>>2]|0)+-1|0;c[q>>2]=o;z=r;A=o;B=s;C=y}else{a[d+168>>0]=1;y=d+124|0;s=m>>>5;o=d+128|0;if(s>>>0<(c[o>>2]|0)>>>0)D=c[y>>2]|0;else{r=m+128|0;q=((r&31|0)!=0&1)+(r>>>5)|0;r=UJa(g,q<<2,483800,429)|0;g=c[o>>2]|0;if(!g)E=0;else{YEi(r|0,c[y>>2]|0,g<<2|0)|0;E=c[o>>2]|0}if((q|0)!=(E|0))PEi(r+(E<<2)|0,0,q-E<<2|0)|0;E=c[y>>2]|0;if(E){VJa(h,E);c[y>>2]=0}c[y>>2]=r;c[o>>2]=q;D=r}r=D+(s<<2)|0;c[r>>2]=c[r>>2]|1<<(m&31);r=c[d+104>>2]|0;s=c[d+96>>2]|0;D=d+84|0;q=(c[D>>2]|0)+-1|0;c[D>>2]=q;z=s;A=q;B=r;C=m}m=c[e>>2]|0;e=b[B+(A<<1)>>1]|0;r=z+(C*24|0)|0;q=z+(A*24|0)|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];c[r+16>>2]=c[q+16>>2];c[r+20>>2]=c[q+20>>2];b[B+(C<<1)>>1]=e;c[m+((e&65535)<<3)>>2]=C;C=d+72|0;c[l>>2]=c[C>>2];c[n>>2]=-1;c[C>>2]=j;j=d+64|0;c[j>>2]=(c[j>>2]|0)+-1;i=f;return}function Hqa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+32|0;h=g;j=g+24|0;k=f&65535;f=c[d+76>>2]|0;l=f+(k<<3)|0;m=c[l>>2]|0;if(!(c[f+(k<<3)+4>>2]&1)){if(m>>>0>=(c[d+120>>2]|0)>>>0)a[d+169>>0]=1;k=d+116|0;n=c[k>>2]|0;o=c[d+100>>2]|0;if(m>>>0<n>>>0){p=o+(m*24|0)|0;c[p+0>>2]=c[e+0>>2];c[p+4>>2]=c[e+4>>2];c[p+8>>2]=c[e+8>>2];c[p+12>>2]=c[e+12>>2];c[p+16>>2]=c[e+16>>2];c[p+20>>2]=c[e+20>>2];i=g;return}p=c[d+108>>2]|0;q=o+(n*24|0)|0;if((m|0)==(n|0)){c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2]}else{c[h+0>>2]=c[q+0>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];c[h+12>>2]=c[q+12>>2];c[h+16>>2]=c[q+16>>2];c[h+20>>2]=c[q+20>>2];c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2];q=o+(m*24|0)|0;c[q+0>>2]=c[h+0>>2];c[q+4>>2]=c[h+4>>2];c[q+8>>2]=c[h+8>>2];c[q+12>>2]=c[h+12>>2];c[q+16>>2]=c[h+16>>2];c[q+20>>2]=c[h+20>>2];q=p+(n<<1)|0;o=b[q>>1]|0;r=p+(m<<1)|0;b[q>>1]=b[r>>1]|0;b[r>>1]=o;c[f+((o&65535)<<3)>>2]=m;c[l>>2]=n}c[k>>2]=(c[k>>2]|0)+1;i=g;return}k=(c[d+96>>2]|0)+(m*24|0)|0;c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[k+16>>2]=c[e+16>>2];c[k+20>>2]=c[e+20>>2];a[d+168>>0]=1;e=d+124|0;k=c[l>>2]|0;l=k>>>5;m=d+128|0;if(l>>>0<(c[m>>2]|0)>>>0)s=c[e>>2]|0;else{d=k+128|0;n=((d&31|0)!=0&1)+(d>>>5)|0;d=UJa(h,n<<2,483800,429)|0;h=c[m>>2]|0;if(!h)t=0;else{YEi(d|0,c[e>>2]|0,h<<2|0)|0;t=c[m>>2]|0}if((n|0)!=(t|0))PEi(d+(t<<2)|0,0,n-t<<2|0)|0;t=c[e>>2]|0;if(t){VJa(j,t);c[e>>2]=0}c[e>>2]=d;c[m>>2]=n;s=d}d=s+(l<<2)|0;c[d>>2]=c[d>>2]|1<<(k&31);i=g;return}function Iqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=a+12800|0;if((c[g>>2]|0)>>>0>=b>>>0){i=e;return}h=a+12808|0;j=c[h>>2]|0;k=a+12288|0;if(!((j|0)==(k|0)|(j|0)==0)){VJa(e+1|0,j);c[h>>2]=0}j=a+12812|0;l=c[j>>2]|0;if(!((l|0)==(a|0)|(l|0)==0)){VJa(e+2|0,l);c[j>>2]=0}l=d+b|0;if(l>>>0<257){c[j>>2]=a;m=k}else{k=l>>>0>178956970?-1:l*24|0;if(!k)n=0;else{l=mKa()|0;a=c[(c[l>>2]|0)+8>>2]|0;d=pKa()|0;o=mo[c[(c[d>>2]|0)+24>>2]&4095](d)|0;n=Bn[a&255](l,k,o?484488:544544,483800,1891)|0}c[j>>2]=n;m=UJa(f,b<<1,483800,1893)|0}c[h>>2]=m;c[g>>2]=b;i=e;return}function Jqa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+16|0;g=f;h=d+116|0;j=c[h>>2]|0;c[h>>2]=0;k=d+120|0;if((c[k>>2]|0)!=(j|0))a[d+169>>0]=1;l=c[d+92>>2]|0;if(!l){a[d+28>>0]=0;c[k>>2]=0;a[d+169>>0]=1;i=f;return}m=c[d+100>>2]|0;n=c[d+112>>2]|0;o=l-j|0;p=(j|0)==0;if(!p){q=0;do{c[n+(q<<2)>>2]=c[m+(q*24|0)>>2];q=q+1|0}while((q|0)!=(j|0))}q=d+169|0;r=(a[q>>0]|0)==0;if(!(r|(l|0)==(j|0))){s=0;do{t=s+j|0;c[n+(t<<2)>>2]=c[m+(t*24|0)>>2];s=s+1|0}while((s|0)!=(o|0))}c[h>>2]=j;if(p){a[d+28>>0]=0;c[k>>2]=0;a[q>>0]=1;i=f;return}c[k>>2]=j;do if((l|0)==(j|0)){a[q>>0]=1;u=0;v=0}else{if(r){u=c[e+12808>>2]|0;v=c[e+12812>>2]|0;break}k=c[(NMa(d+132|0,n+(j<<2)|0,o,1)|0)+8>>2]|0;Iqa(e,o,2);p=c[e+12812>>2]|0;h=c[e+12808>>2]|0;s=d+108|0;t=0;do{w=(c[k+(t<<2)>>2]|0)+j|0;x=p+(t*24|0)|0;y=m+(w*24|0)|0;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];c[x+16>>2]=c[y+16>>2];c[x+20>>2]=c[y+20>>2];b[h+(t<<1)>>1]=b[(c[s>>2]|0)+(w<<1)>>1]|0;t=t+1|0}while((t|0)!=(o|0));c[p+(o*24|0)>>2]=-1;c[p+((o+1|0)*24|0)>>2]=-1;a[q>>0]=0;u=h;v=p}while(0);q=c[(NMa(d+132|0,n,j,1)|0)+8>>2]|0;n=e+12804|0;r=e+12816|0;l=c[r>>2]|0;if((c[n>>2]|0)>>>0<j>>>0){t=e+6144|0;if(!((l|0)==(t|0)|(l|0)==0)){VJa(g,l);c[r>>2]=0}g=j+2|0;if(g>>>0>=257){e=g>>>0>178956970?-1:g*24|0;if(!e)z=0;else{g=mKa()|0;s=c[(c[g>>2]|0)+8>>2]|0;k=pKa()|0;w=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;z=Bn[s&255](g,e,w?484488:544544,483800,1921)|0}}else z=t;c[r>>2]=z;c[n>>2]=j;A=z}else A=l;l=c[d+144>>2]|0;z=d+108|0;n=0;do{r=c[q+(n<<2)>>2]|0;t=A+(n*24|0)|0;w=m+(r*24|0)|0;c[t+0>>2]=c[w+0>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];c[t+12>>2]=c[w+12>>2];c[t+16>>2]=c[w+16>>2];c[t+20>>2]=c[w+20>>2];b[l+(n<<1)>>1]=b[(c[z>>2]|0)+(r<<1)>>1]|0;n=n+1|0}while((n|0)!=(j|0));c[A+(j*24|0)>>2]=-1;c[A+((j+1|0)*24|0)>>2]=-1;c[d>>2]=c[d+76>>2];c[d+4>>2]=A;c[d+8>>2]=v;c[d+12>>2]=l;c[d+16>>2]=u;c[d+20>>2]=j;c[d+24>>2]=o;a[d+28>>0]=1;i=f;return}function Kqa(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b+116|0;if(!(c[j>>2]|0)){i=h;return}a:do if(a[b+28>>0]|0){k=c[b>>2]|0;l=c[b+4>>2]|0;m=c[b+8>>2]|0;n=c[b+12>>2]|0;o=c[b+16>>2]|0;p=c[b+20>>2]|0;q=c[b+24>>2]|0;if(q){if(!p)break;else{r=0;s=0}while(1){t=c[l+(s*24|0)+12>>2]|0;u=c[l+(s*24|0)>>2]|0;v=r;while(1){w=c[m+(v*24|0)>>2]|0;if(w>>>0<u>>>0)v=v+1|0;else break}if(w>>>0<=t>>>0){u=l+(s*24|0)+4|0;x=l+(s*24|0)+8|0;y=l+(s*24|0)+16|0;z=l+(s*24|0)+20|0;A=n+(s<<1)|0;B=v;do{if(!(((c[m+(B*24|0)+20>>2]|0)-(c[x>>2]|0)|0)>>>1&1073741824|(c[m+(B*24|0)+16>>2]|0)-(c[u>>2]|0)&-2147483648|((c[y>>2]|0)-(c[m+(B*24|0)+4>>2]|0)|0)>>>2&536870912|((c[z>>2]|0)-(c[m+(B*24|0)+8>>2]|0)|0)>>>3&268435456))zqa(d,c[k+(e[A>>1]<<3)+4>>2]|0,c[k+(e[o+(B<<1)>>1]<<3)+4>>2]|0,f,g)|0;B=B+1|0}while((c[m+(B*24|0)>>2]|0)>>>0<=t>>>0)}s=s+1|0;if(!(v>>>0<q>>>0&s>>>0<p>>>0)){C=0;D=0;break}else r=v}while(1){t=c[m+(D*24|0)+12>>2]|0;B=c[m+(D*24|0)>>2]|0;A=C;while(1){E=c[l+(A*24|0)>>2]|0;if(E>>>0>B>>>0)break;else A=A+1|0}if(E>>>0<=t>>>0){B=m+(D*24|0)+4|0;v=m+(D*24|0)+8|0;z=m+(D*24|0)+16|0;y=m+(D*24|0)+20|0;u=o+(D<<1)|0;x=A;do{if(!(((c[l+(x*24|0)+20>>2]|0)-(c[v>>2]|0)|0)>>>1&1073741824|(c[l+(x*24|0)+16>>2]|0)-(c[B>>2]|0)&-2147483648|((c[z>>2]|0)-(c[l+(x*24|0)+4>>2]|0)|0)>>>2&536870912|((c[y>>2]|0)-(c[l+(x*24|0)+8>>2]|0)|0)>>>3&268435456))zqa(d,c[k+(e[n+(x<<1)>>1]<<3)+4>>2]|0,c[k+(e[u>>1]<<3)+4>>2]|0,f,g)|0;x=x+1|0}while((c[l+(x*24|0)>>2]|0)>>>0<=t>>>0)}D=D+1|0;if(!(A>>>0<p>>>0&D>>>0<q>>>0))break;else C=A}}if(p){q=0;o=0;while(1){m=c[l+(o*24|0)+12>>2]|0;t=c[l+(o*24|0)>>2]|0;x=q;do{u=x;x=x+1|0}while((c[l+(u*24|0)>>2]|0)>>>0<t>>>0);if(x>>>0>=p>>>0)break a;if((c[l+(x*24|0)>>2]|0)>>>0<=m>>>0){t=l+(o*24|0)+4|0;A=l+(o*24|0)+8|0;u=l+(o*24|0)+16|0;y=l+(o*24|0)+20|0;z=n+(o<<1)|0;B=x;do{if(!(((c[l+(B*24|0)+20>>2]|0)-(c[A>>2]|0)|0)>>>1&1073741824|(c[l+(B*24|0)+16>>2]|0)-(c[t>>2]|0)&-2147483648|((c[u>>2]|0)-(c[l+(B*24|0)+4>>2]|0)|0)>>>2&536870912|((c[y>>2]|0)-(c[l+(B*24|0)+8>>2]|0)|0)>>>3&268435456))zqa(d,c[k+(e[z>>1]<<3)+4>>2]|0,c[k+(e[n+(B<<1)>>1]<<3)+4>>2]|0,f,g)|0;B=B+1|0}while((c[l+(B*24|0)>>2]|0)>>>0<=m>>>0)}o=o+1|0;if(o>>>0>=p>>>0)break;else q=x}}}while(0);if((a[b+60>>0]|0)!=0?(C=c[b+36>>2]|0,D=c[b+40>>2]|0,E=c[b+32>>2]|0,r=c[b+44>>2]|0,s=c[b+48>>2]|0,w=c[b+52>>2]|0,q=c[b+56>>2]|0,(D|0)!=0&(C|0)!=0):0){b=0;p=0;while(1){o=c[r+(p*24|0)+12>>2]|0;l=c[r+(p*24|0)>>2]|0;n=b;while(1){F=c[s+(n*24|0)>>2]|0;if(F>>>0<l>>>0)n=n+1|0;else break}if(F>>>0<=o>>>0){l=r+(p*24|0)+4|0;k=r+(p*24|0)+8|0;m=r+(p*24|0)+16|0;B=r+(p*24|0)+20|0;z=q+(p<<1)|0;y=n;do{if(!(((c[s+(y*24|0)+20>>2]|0)-(c[k>>2]|0)|0)>>>1&1073741824|(c[s+(y*24|0)+16>>2]|0)-(c[l>>2]|0)&-2147483648|((c[m>>2]|0)-(c[s+(y*24|0)+4>>2]|0)|0)>>>2&536870912|((c[B>>2]|0)-(c[s+(y*24|0)+8>>2]|0)|0)>>>3&268435456))zqa(d,c[E+(e[z>>1]<<3)+4>>2]|0,c[E+(e[w+(y<<1)>>1]<<3)+4>>2]|0,f,g)|0;u=y+1|0;if((c[s+(u*24|0)>>2]|0)>>>0<=o>>>0?(((c[s+(u*24|0)+20>>2]|0)-(c[k>>2]|0)|0)>>>1&1073741824|(c[s+(u*24|0)+16>>2]|0)-(c[l>>2]|0)&-2147483648|((c[m>>2]|0)-(c[s+(u*24|0)+4>>2]|0)|0)>>>2&536870912|((c[B>>2]|0)-(c[s+(u*24|0)+8>>2]|0)|0)>>>3&268435456|0)==0:0)zqa(d,c[E+(e[z>>1]<<3)+4>>2]|0,c[E+(e[w+(u<<1)>>1]<<3)+4>>2]|0,f,g)|0;y=y+2|0}while((c[s+(y*24|0)>>2]|0)>>>0<=o>>>0)}p=p+1|0;if(!(n>>>0<D>>>0&p>>>0<C>>>0)){G=0;H=0;break}else b=n}while(1){b=c[s+(H*24|0)+12>>2]|0;p=c[s+(H*24|0)>>2]|0;F=G;while(1){I=c[r+(F*24|0)>>2]|0;if(I>>>0>p>>>0)break;else F=F+1|0}if(I>>>0<=b>>>0){p=s+(H*24|0)+4|0;n=s+(H*24|0)+8|0;o=s+(H*24|0)+16|0;y=s+(H*24|0)+20|0;z=w+(H<<1)|0;B=F;do{if(!(((c[r+(B*24|0)+20>>2]|0)-(c[n>>2]|0)|0)>>>1&1073741824|(c[r+(B*24|0)+16>>2]|0)-(c[p>>2]|0)&-2147483648|((c[o>>2]|0)-(c[r+(B*24|0)+4>>2]|0)|0)>>>2&536870912|((c[y>>2]|0)-(c[r+(B*24|0)+8>>2]|0)|0)>>>3&268435456))zqa(d,c[E+(e[q+(B<<1)>>1]<<3)+4>>2]|0,c[E+(e[z>>1]<<3)+4>>2]|0,f,g)|0;m=B+1|0;if((c[r+(m*24|0)>>2]|0)>>>0<=b>>>0?(((c[r+(m*24|0)+20>>2]|0)-(c[n>>2]|0)|0)>>>1&1073741824|(c[r+(m*24|0)+16>>2]|0)-(c[p>>2]|0)&-2147483648|((c[o>>2]|0)-(c[r+(m*24|0)+4>>2]|0)|0)>>>2&536870912|((c[y>>2]|0)-(c[r+(m*24|0)+8>>2]|0)|0)>>>3&268435456|0)==0:0)zqa(d,c[E+(e[q+(m<<1)>>1]<<3)+4>>2]|0,c[E+(e[z>>1]<<3)+4>>2]|0,f,g)|0;B=B+2|0}while((c[r+(B*24|0)>>2]|0)>>>0<=b>>>0)}H=H+1|0;if(!(F>>>0<C>>>0&H>>>0<D>>>0))break;else G=F}}c[j>>2]=0;i=h;return}function Lqa(a){a=a|0;var b=0;b=i;i=i+16|0;Mqa(a);VJa(b,a);i=b;return}function Mqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+2|0;e=b+1|0;f=b;c[a>>2]=483904;Nqa(a);g=a+5252|0;h=c[g>>2]|0;if(h){VJa(d,h);c[g>>2]=0}c[g>>2]=0;c[a+5256>>2]=0;dLa(a+5236|0);g=a+96|0;h=a+4208|0;do{h=h+-16|0;dLa(h)}while((h|0)!=(g|0));g=a+88|0;h=c[g>>2]|0;if(h){VJa(d,h);c[g>>2]=0}c[g>>2]=0;c[a+92>>2]=0;g=a+80|0;h=c[g>>2]|0;if(h){VJa(d,h);c[g>>2]=0}c[g>>2]=0;c[a+84>>2]=0;g=a+68|0;h=c[g>>2]|0;if(h){VJa(d,h);c[g>>2]=0}g=a+72|0;h=c[g>>2]|0;if(h){VJa(e,h);c[g>>2]=0}g=a+64|0;h=c[g>>2]|0;if(!h){j=a+52|0;c[j>>2]=0;k=a+56|0;c[k>>2]=0;l=a+60|0;c[l>>2]=0;m=a+36|0;dLa(m);n=a+20|0;dLa(n);i=b;return}VJa(f,h);c[g>>2]=0;j=a+52|0;c[j>>2]=0;k=a+56|0;c[k>>2]=0;l=a+60|0;c[l>>2]=0;m=a+36|0;dLa(m);n=a+20|0;dLa(n);i=b;return}function Nqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+2|0;e=b+1|0;f=b;g=a+8|0;h=c[g>>2]|0;j=a+20|0;if(h){k=h;h=c[a+28>>2]|0;while(1){k=k+-1|0;l=h+28|0;m=c[l>>2]|0;if(m){Cqa(m);VJa(d,m);c[l>>2]=0}if(!k)break;else h=h+40|0}}c[a+4>>2]=0;c[g>>2]=0;c[a+12>>2]=-1;c[a+16>>2]=-1;g=0;do{hLa(a+(g<<4)+96|0)|0;c[a+(g<<2)+4208>>2]=-1;g=g+1|0}while((g|0)!=257);hLa(j)|0;hLa(a+36|0)|0;j=a+68|0;g=c[j>>2]|0;if(g){VJa(d,g);c[j>>2]=0}j=a+72|0;g=c[j>>2]|0;if(g){VJa(e,g);c[j>>2]=0}j=a+64|0;g=c[j>>2]|0;if(g){VJa(f,g);c[j>>2]=0}c[a+52>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;j=a+80|0;g=c[j>>2]|0;if(g){VJa(d,g);c[j>>2]=0}c[j>>2]=0;c[a+84>>2]=0;j=a+88|0;g=c[j>>2]|0;if(g){VJa(d,g);c[j>>2]=0}c[j>>2]=0;c[a+92>>2]=0;hLa(a+5236|0)|0;j=a+5252|0;g=c[j>>2]|0;if(!g){c[j>>2]=0;n=a+5256|0;c[n>>2]=0;i=b;return}VJa(d,g);c[j>>2]=0;c[j>>2]=0;n=a+5256|0;c[n>>2]=0;i=b;return}function Oqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;if(b)iLa(a+20|0,b*10|0)|0;if(!d){i=e;return 1}iLa(a+36|0,d*3|0)|0;b=((d&31|0)!=0&1)+(d>>>5)|0;f=a+5256|0;c[f>>2]=b;g=a+5252|0;h=c[g>>2]|0;if(!h)j=b;else{VJa(e+1|0,h);c[g>>2]=0;j=c[f>>2]|0}h=UJa(e,j<<2,483800,409)|0;c[g>>2]=h;PEi(h|0,0,c[f>>2]<<2|0)|0;f=a+52|0;h=d<<1;if(!h){i=e;return 1}if(!(h+-1&h))k=h;else{g=d&2147483647|h;h=g>>>2|g;g=h>>>4|h;h=g>>>8|g;k=(h>>>16|h)+1|0}c[f>>2]=k;c[a+56>>2]=k+-1;c[a+76>>2]=k;Aqa(f);i=e;return 1}function Pqa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;i=i+80|0;g=f+48|0;h=f+24|0;j=f;k=c[a+28>>2]|0;l=c[a+40>>2]|0;m=(l>>>0)/3|0;n=c[a+44>>2]|0;if(l>>>0<=2){i=f;return}l=a+5252|0;o=a+5260|0;p=h+4|0;q=j+4|0;r=h+8|0;s=j+8|0;t=h+12|0;u=j+12|0;v=h+16|0;w=j+16|0;x=h+20|0;y=j+20|0;z=d+12|0;A=d+4|0;B=d+16|0;C=d+8|0;D=d+20|0;E=g+12|0;F=g+16|0;G=g+4|0;H=g+20|0;I=g+8|0;J=0;do{do if((c[(c[l>>2]|0)+(J>>>5<<2)>>2]&1<<(J&31)|0)==0?(b[n+(J*12|0)+6>>1]&4)==0:0){K=b[n+(J*12|0)+4>>1]|0;if(!(K<<16>>16)){wpa(h,c[o>>2]|0,c[n+(J*12|0)>>2]|0);L=c[h>>2]|0;M=((L|0)<0?L^-2:L|-2147483648)>>>1;c[j>>2]=M;L=c[p>>2]|0;N=((L|0)<0?L^-2:L|-2147483648)>>>1;c[q>>2]=N;L=c[r>>2]|0;O=((L|0)<0?L^-2:L|-2147483648)>>>1;c[s>>2]=O;L=c[t>>2]|0;P=((L|0)<0?L^-2:L|-2147483648)>>>1;c[u>>2]=P;L=c[v>>2]|0;Q=((L|0)<0?L^-2:L|-2147483648)>>>1;c[w>>2]=Q;L=c[x>>2]|0;R=((L|0)<0?L^-2:L|-2147483648)>>>1;c[y>>2]=R;if(P>>>0<(c[d>>2]|0)>>>0)break;if((c[z>>2]|0)>>>0<M>>>0)break;if(Q>>>0<(c[A>>2]|0)>>>0)break;if((c[B>>2]|0)>>>0<N>>>0)break;if(R>>>0<(c[C>>2]|0)>>>0)break;if((c[D>>2]|0)>>>0<O>>>0)break;Qqa(a,c[n+(J*12|0)+8>>2]|0,j)|0;break}O=n+(J*12|0)+8|0;if(K<<16>>16==1)S=O;else S=(c[a+((K&65535)<<4)+104>>2]|0)+(c[O>>2]<<2)|0;O=c[k+((e[S+2>>1]|0)*40|0)+28>>2]|0;K=e[S>>1]|0;R=c[O+76>>2]|0;N=R+(K<<3)+4|0;Q=c[R+(K<<3)>>2]|0;if(!(c[N>>2]&1)){K=(c[O+100>>2]|0)+(Q*24|0)|0;c[g+0>>2]=c[K+0>>2];c[g+4>>2]=c[K+4>>2];c[g+8>>2]=c[K+8>>2];c[g+12>>2]=c[K+12>>2];c[g+16>>2]=c[K+16>>2];c[g+20>>2]=c[K+20>>2]}else{K=(c[O+96>>2]|0)+(Q*24|0)|0;c[g+0>>2]=c[K+0>>2];c[g+4>>2]=c[K+4>>2];c[g+8>>2]=c[K+8>>2];c[g+12>>2]=c[K+12>>2];c[g+16>>2]=c[K+16>>2];c[g+20>>2]=c[K+20>>2]}K=c[N>>2]|0;if((((((c[E>>2]|0)>>>0>=(c[d>>2]|0)>>>0?(c[z>>2]|0)>>>0>=(c[g>>2]|0)>>>0:0)?(c[F>>2]|0)>>>0>=(c[A>>2]|0)>>>0:0)?(c[B>>2]|0)>>>0>=(c[G>>2]|0)>>>0:0)?(c[H>>2]|0)>>>0>=(c[C>>2]|0)>>>0:0)?(c[D>>2]|0)>>>0>=(c[I>>2]|0)>>>0:0)Qqa(a,K,g)|0}while(0);J=J+1|0}while(J>>>0<m>>>0);i=f;return}function Qqa(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;g=i;i=i+2064|0;h=g+2057|0;j=g+2056|0;k=g+1028|0;l=g;m=d>>>2;n=d&1;o=c[a+8>>2]|0;p=c[a+28>>2]|0;q=c[a+44>>2]|0;r=a+80|0;s=d>>>7;t=a+84|0;if(s>>>0<(c[t>>2]|0)>>>0)u=c[r>>2]|0;else{v=m+128|0;w=((v&31|0)!=0&1)+(v>>>5)|0;v=UJa(h,w<<2,483800,429)|0;x=c[t>>2]|0;if(!x)y=0;else{YEi(v|0,c[r>>2]|0,x<<2|0)|0;y=c[t>>2]|0}if((w|0)!=(y|0))PEi(v+(y<<2)|0,0,w-y<<2|0)|0;y=c[r>>2]|0;if(y){VJa(j,y);c[r>>2]=0}c[r>>2]=v;c[t>>2]=w;u=v}v=1<<(m&31);w=u+(s<<2)|0;c[w>>2]=c[w>>2]|v;w=q+(m*12|0)+4|0;u=b[w>>1]|0;t=u&65535;r=u<<16>>16==1;if(((((((r?(y=q+(m*12|0)+8|0,x=e[y+2>>1]|0,(c[p+(x*40|0)+32>>2]|0)==0):0)?(c[p+(x*40|0)+4>>2]|0)>>>0<=(c[f>>2]|0)>>>0:0)?(c[p+(x*40|0)+8>>2]|0)>>>0<=(c[f+4>>2]|0)>>>0:0)?(c[p+(x*40|0)+12>>2]|0)>>>0<=(c[f+8>>2]|0)>>>0:0)?(c[p+(x*40|0)+16>>2]|0)>>>0>=(c[f+12>>2]|0)>>>0:0)?(c[p+(x*40|0)+20>>2]|0)>>>0>=(c[f+16>>2]|0)>>>0:0)?(c[p+(x*40|0)+24>>2]|0)>>>0>=(c[f+20>>2]|0)>>>0:0){z=a+5252|0;A=a+5256|0;if(s>>>0<(c[A>>2]|0)>>>0)B=c[z>>2]|0;else{C=m+128|0;D=((C&31|0)!=0&1)+(C>>>5)|0;C=UJa(h,D<<2,483800,429)|0;E=c[A>>2]|0;if(!E)F=0;else{YEi(C|0,c[z>>2]|0,E<<2|0)|0;F=c[A>>2]|0}if((D|0)!=(F|0))PEi(C+(F<<2)|0,0,D-F<<2|0)|0;F=c[z>>2]|0;if(F){VJa(j,F);c[z>>2]=0}c[z>>2]=C;c[A>>2]=D;B=C}C=B+(s<<2)|0;c[C>>2]=c[C>>2]|v;Hqa(c[p+(x*40|0)+28>>2]|0,f,b[y>>1]|0);i=g;return 1}if(!o){G=0;H=1}else{y=c[f>>2]|0;x=f+12|0;C=f+4|0;B=f+16|0;D=f+8|0;A=f+20|0;z=0;F=0;E=1;while(1){I=c[p+(F*40|0)+16>>2]|0;if(((((I>>>0>=y>>>0?(J=c[x>>2]|0,K=c[p+(F*40|0)+4>>2]|0,J>>>0>=K>>>0):0)?(L=c[p+(F*40|0)+20>>2]|0,M=c[C>>2]|0,L>>>0>=M>>>0):0)?(N=c[B>>2]|0,O=c[p+(F*40|0)+8>>2]|0,N>>>0>=O>>>0):0)?(P=c[p+(F*40|0)+24>>2]|0,Q=c[D>>2]|0,P>>>0>=Q>>>0):0)?(R=c[A>>2]|0,S=c[p+(F*40|0)+12>>2]|0,R>>>0>=S>>>0):0){c[k+(z<<2)>>2]=F;T=z+1|0;U=P>>>0>=R>>>0&((K>>>0>y>>>0|O>>>0>M>>>0|S>>>0>Q>>>0|I>>>0<J>>>0|L>>>0<N>>>0)^1)&E}else{T=z;U=E}F=F+1|0;if((F|0)==(o|0)){G=T;H=U;break}else{z=T;E=U}}}U=q+(m*12|0)+8|0;if(!r){r=(c[a+(t<<4)+104>>2]|0)+(c[U>>2]<<2)|0;if(!(u<<16>>16)){V=G;W=1;X=r;Y=0}else{Z=r;_=r;$=41}}else{Z=U;_=U;$=41}if(($|0)==41){U=G;G=0;r=0;while(1){E=_+(G<<2)|0;T=e[_+(G<<2)+2>>1]|0;a:do if(!U)$=48;else{z=0;while(1){aa=k+(z<<2)|0;z=z+1|0;if((c[aa>>2]|0)==(T|0))break;if(z>>>0>=U>>>0){$=48;break a}}z=U+-1|0;c[aa>>2]=c[k+(z<<2)>>2];Hqa(c[p+(T*40|0)+28>>2]|0,f,b[E>>1]|0);c[l+(r<<2)>>2]=e[E>>1]|e[E+2>>1]<<16;ba=z;ca=r+1|0}while(0);if(($|0)==48){$=0;Gqa(c[p+(T*40|0)+28>>2]|0,b[E>>1]|0);ba=U;ca=r}G=G+1|0;if((G|0)==(t|0)){V=ba;W=0;X=Z;Y=ca;break}else{U=ba;r=ca}}}if(!V)da=Y;else{ca=(n|0)!=0;n=0;r=Y;while(1){ba=c[k+(n<<2)>>2]|0;b[l+(r<<2)>>1]=Fqa(c[p+(ba*40|0)+28>>2]|0,f,d,ca)|0;b[l+(r<<2)+2>>1]=ba;n=n+1|0;if((n|0)==(V|0))break;else r=r+1|0}da=V+Y|0}do if((t|0)==(da|0))if(!(u<<16>>16))$=65;else{YEi(X|0,l|0,t<<2|0)|0;$=65}else{if((u&65535)>1){Y=c[q+(m*12|0)+8>>2]|0;V=a+(t<<2)+4208|0;c[(c[a+(t<<4)+104>>2]|0)+(Y<<2)>>2]=c[V>>2];c[V>>2]=Y}if((da|0)==1){Y=c[l>>2]|0;V=q+(m*12|0)+8|0;b[V>>1]=Y;b[V+2>>1]=Y>>>16;b[w>>1]=1;break}else if(!da){$=65;break}Y=a+(da<<4)+96|0;V=a+(da<<2)+4208|0;r=c[V>>2]|0;if((r|0)==-1){n=a+(da<<4)+100|0;c[q+(m*12|0)+8>>2]=c[n>>2];ca=da&1073741823;f=c[n>>2]|0;if((f+ca|0)>>>0>(c[Y>>2]|0)>>>0){gLa(Y,ca)|0;ea=c[n>>2]|0}else ea=f;f=(c[a+(da<<4)+104>>2]|0)+(ea<<2)|0;c[n>>2]=ea+ca;fa=f}else{c[q+(m*12|0)+8>>2]=r;f=(c[a+(da<<4)+104>>2]|0)+(r<<2)|0;c[V>>2]=c[f>>2];fa=f}YEi(fa|0,l|0,da<<2|0)|0;$=65}while(0);if(($|0)==65?(b[w>>1]=da,!((da|0)!=0|W)):0){c[q+(m*12|0)+8>>2]=d;d=c[q+(m*12|0)>>2]|0;q=a+5236|0;W=a+5240|0;da=c[W>>2]|0;if((da|0)==(c[q>>2]|0)){gLa(q,1)|0;ga=c[W>>2]|0}else ga=da;c[W>>2]=ga+1;c[(c[a+5244>>2]|0)+(ga<<2)>>2]=d}d=a+5252|0;ga=a+5256|0;a=s>>>0<(c[ga>>2]|0)>>>0;if(H){if(a)ha=c[d>>2]|0;else{H=m+128|0;W=((H&31|0)!=0&1)+(H>>>5)|0;H=UJa(h,W<<2,483800,429)|0;da=c[ga>>2]|0;if(!da)ia=0;else{YEi(H|0,c[d>>2]|0,da<<2|0)|0;ia=c[ga>>2]|0}if((W|0)!=(ia|0))PEi(H+(ia<<2)|0,0,W-ia<<2|0)|0;ia=c[d>>2]|0;if(ia){VJa(j,ia);c[d>>2]=0}c[d>>2]=H;c[ga>>2]=W;ha=H}H=ha+(s<<2)|0;c[H>>2]=c[H>>2]|v;i=g;return 1}else{if(a)ja=c[d>>2]|0;else{a=m+128|0;m=((a&31|0)!=0&1)+(a>>>5)|0;a=UJa(h,m<<2,483800,429)|0;h=c[ga>>2]|0;if(!h)ka=0;else{YEi(a|0,c[d>>2]|0,h<<2|0)|0;ka=c[ga>>2]|0}if((m|0)!=(ka|0))PEi(a+(ka<<2)|0,0,m-ka<<2|0)|0;ka=c[d>>2]|0;if(ka){VJa(j,ka);c[d>>2]=0}c[d>>2]=a;c[ga>>2]=m;ja=a}a=ja+(s<<2)|0;c[a>>2]=c[a>>2]&~v;i=g;return 1}return 0}function Rqa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;h=b+16|0;j=c[h>>2]|0;if((j|0)==-1){k=b+8|0;l=c[k>>2]|0;if(l>>>0>255){dKa(bKa()|0,16,483800,2733,483912,g);m=-1;i=f;return m|0}c[k>>2]=l+1;g=b+20|0;n=b+24|0;o=c[n>>2]|0;if((o+10|0)>>>0>(c[g>>2]|0)>>>0){gLa(g,10)|0;p=c[n>>2]|0}else p=o;o=(c[b+28>>2]|0)+(p<<2)|0;c[n>>2]=p+10;q=k;r=o;s=l}else{l=c[b+28>>2]|0;c[h>>2]=c[l+(j*40|0)+36>>2];q=b+8|0;r=l+(j*40|0)|0;s=j}j=mKa()|0;l=c[(c[j>>2]|0)+8>>2]|0;h=pKa()|0;o=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[l&255](j,13008,o?484296:544544,483800,2741)|0;o=h+32|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;a[o+28>>0]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;a[h+28>>0]=0;c[h+64>>2]=0;c[h+68>>2]=0;c[h+72>>2]=-1;o=h+132|0;j=h+76|0;l=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(l|0));KMa(o);a[h+168>>0]=0;a[h+169>>0]=1;o=h+12976|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;o=r+4|0;j=c[d>>2]|0;c[o>>2]=((j|0)<0?j^-2:j|-2147483648)>>>1;j=c[d+4>>2]|0;c[r+8>>2]=((j|0)<0?j^-2:j|-2147483648)>>>1;j=c[d+8>>2]|0;c[r+12>>2]=((j|0)<0?j^-2:j|-2147483648)>>>1;j=c[d+12>>2]|0;c[r+16>>2]=((j|0)<0?j^-2:j|-2147483648)>>>1;j=c[d+16>>2]|0;c[r+20>>2]=((j|0)<0?j^-2:j|-2147483648)>>>1;j=c[d+20>>2]|0;c[r+24>>2]=((j|0)<0?j^-2:j|-2147483648)>>>1;c[r+28>>2]=h;c[r+36>>2]=c[d+24>>2];z$a(c[q>>2]|0,c[b+28>>2]|0);if(!e){m=s;i=f;return m|0}Pqa(b,o);m=s;i=f;return m|0}function Sqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=a+8|0;if((c[f>>2]|0)>>>0<=b>>>0){dKa(bKa()|0,4,483800,2762,483968,e);g=0;i=d;return g|0}h=a+28|0;j=c[h>>2]|0;k=j+(b*40|0)+28|0;l=c[k>>2]|0;if(!l){dKa(bKa()|0,4,483800,2772,483968,e);g=0;i=d;return g|0}c[j+(b*40|0)+4>>2]=2134900735;c[j+(b*40|0)+8>>2]=2134900735;c[j+(b*40|0)+12>>2]=2134900735;c[j+(b*40|0)+16>>2]=12582912;c[j+(b*40|0)+20>>2]=12582912;c[j+(b*40|0)+24>>2]=12582912;m=c[l+68>>2]|0;n=c[l+76>>2]|0;if(m){o=0;do{p=c[n+(o<<3)+4>>2]|0;if((p|0)!=-1)Tqa(a,p,l)|0;o=o+1|0}while((o|0)!=(m|0))}Cqa(l);VJa(e,l);c[k>>2]=0;k=a+16|0;c[j+(b*40|0)+36>>2]=c[k>>2];c[k>>2]=b;z$a(c[f>>2]|0,c[h>>2]|0);g=1;i=d;return g|0}function Tqa(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+1040|0;h=g;j=d>>>2;k=c[a+28>>2]|0;l=c[a+44>>2]|0;m=l+(j*12|0)+4|0;n=b[m>>1]|0;o=n&65535;p=l+(j*12|0)+8|0;if(n<<16>>16!=1)if(!(n<<16>>16))q=11;else{r=(c[a+(o<<4)+104>>2]|0)+(c[p>>2]<<2)|0;q=4}else{r=p;q=4}do if((q|0)==4){p=0;s=0;while(1){if((c[k+((e[r+(p<<2)+2>>1]|0)*40|0)+28>>2]|0)==(f|0))t=s;else{u=r+(p<<2)|0;c[h+(s<<2)>>2]=e[u>>1]|e[u+2>>1]<<16;t=s+1|0}p=p+1|0;if((p|0)==(o|0))break;else s=t}if((n&65535)>1){s=c[l+(j*12|0)+8>>2]|0;p=a+(o<<2)+4208|0;c[(c[a+(o<<4)+104>>2]|0)+(s<<2)>>2]=c[p>>2];c[p>>2]=s}if(!t){q=11;break}else if((t|0)==1){s=c[h>>2]|0;p=l+(j*12|0)+8|0;b[p>>1]=s;b[p+2>>1]=s>>>16;b[m>>1]=1;i=g;return 1}s=a+(t<<4)+96|0;p=a+(t<<2)+4208|0;u=c[p>>2]|0;if((u|0)==-1){v=a+(t<<4)+100|0;c[l+(j*12|0)+8>>2]=c[v>>2];w=t&1073741823;x=c[v>>2]|0;if((x+w|0)>>>0>(c[s>>2]|0)>>>0){gLa(s,w)|0;y=c[v>>2]|0}else y=x;x=(c[a+(t<<4)+104>>2]|0)+(y<<2)|0;c[v>>2]=y+w;z=x}else{c[l+(j*12|0)+8>>2]=u;x=(c[a+(t<<4)+104>>2]|0)+(u<<2)|0;c[p>>2]=c[x>>2];z=x}YEi(z|0,h|0,t<<2|0)|0;b[m>>1]=t;if(t){i=g;return 1}}while(0);if((q|0)==11)b[m>>1]=0;c[l+(j*12|0)+8>>2]=d;d=c[l+(j*12|0)>>2]|0;j=a+5236|0;l=a+5240|0;m=c[l>>2]|0;if((m|0)==(c[j>>2]|0)){gLa(j,1)|0;A=c[l>>2]|0}else A=m;c[l>>2]=A+1;c[(c[a+5244>>2]|0)+(A<<2)>>2]=d;i=g;return 1}function Uqa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;h=i;i=i+1040|0;j=h+1029|0;k=h+1028|0;l=h;m=a+12|0;n=c[m>>2]|0;o=a+36|0;if((n|0)==-1){p=a+40|0;q=c[p>>2]|0;if((q+3|0)>>>0>(c[o>>2]|0)>>>0){gLa(o,3)|0;r=c[p>>2]|0}else r=q;o=(c[a+44>>2]|0)+(r<<2)|0;c[p>>2]=r+3;s=(q>>>0)/3|0;t=0;u=o}else{o=c[a+44>>2]|0;c[m>>2]=c[o+(n*12|0)+8>>2];s=n;t=((e[o+(n*12|0)+6>>1]|0)>>>1&1^1)&65535;u=o+(n*12|0)|0}n=t<<1|g&1|s<<2;o=c[a+8>>2]|0;m=c[a+28>>2]|0;do if(!o){v=0;w=1}else{q=d+12|0;r=d+4|0;p=d+16|0;x=d+8|0;y=d+20|0;z=0;A=0;B=1;while(1){C=c[m+(z*40|0)+16>>2]|0;D=c[d>>2]|0;if(((((C>>>0>=D>>>0?(E=c[q>>2]|0,F=c[m+(z*40|0)+4>>2]|0,E>>>0>=F>>>0):0)?(G=c[m+(z*40|0)+20>>2]|0,H=c[r>>2]|0,G>>>0>=H>>>0):0)?(I=c[p>>2]|0,J=c[m+(z*40|0)+8>>2]|0,I>>>0>=J>>>0):0)?(K=c[m+(z*40|0)+24>>2]|0,L=c[x>>2]|0,K>>>0>=L>>>0):0)?(M=c[y>>2]|0,N=c[m+(z*40|0)+12>>2]|0,M>>>0>=N>>>0):0){b[l+(A<<2)>>1]=Fqa(c[m+(z*40|0)+28>>2]|0,d,n,g)|0;b[l+(A<<2)+2>>1]=z;O=A+1|0;P=K>>>0>=M>>>0&((F>>>0>D>>>0|J>>>0>H>>>0|N>>>0>L>>>0|C>>>0<E>>>0|G>>>0<I>>>0)^1)&B}else{O=A;P=B}z=z+1|0;if((z|0)==(o|0))break;else{A=O;B=P}}if(!O){v=0;w=P;break}else if((O|0)==1){B=c[l>>2]|0;A=u+8|0;b[A>>1]=B;b[A+2>>1]=B>>>16;v=1;w=P;break}B=a+(O<<4)+96|0;A=a+(O<<2)+4208|0;z=c[A>>2]|0;if((z|0)==-1){y=a+(O<<4)+100|0;c[u+8>>2]=c[y>>2];x=O&1073741823;p=c[y>>2]|0;if((p+x|0)>>>0>(c[B>>2]|0)>>>0){gLa(B,x)|0;Q=c[y>>2]|0}else Q=p;p=(c[a+(O<<4)+104>>2]|0)+(Q<<2)|0;c[y>>2]=Q+x;R=p}else{c[u+8>>2]=z;p=(c[a+(O<<4)+104>>2]|0)+(z<<2)|0;c[A>>2]=c[p>>2];R=p}YEi(R|0,l|0,O<<2|0)|0;v=O;w=P}while(0);b[u+4>>1]=v;P=(t|0)==0?0:2;t=(v|0)!=0;v=a+5252|0;O=s>>>5;l=a+5256|0;R=O>>>0<(c[l>>2]|0)>>>0;if(t&w){if(R)S=c[v>>2]|0;else{w=s+128|0;Q=((w&31|0)!=0&1)+(w>>>5)|0;w=UJa(j,Q<<2,483800,429)|0;o=c[l>>2]|0;if(!o)T=0;else{YEi(w|0,c[v>>2]|0,o<<2|0)|0;T=c[l>>2]|0}if((Q|0)!=(T|0))PEi(w+(T<<2)|0,0,Q-T<<2|0)|0;T=c[v>>2]|0;if(T){VJa(k,T);c[v>>2]=0}c[v>>2]=w;c[l>>2]=Q;S=w}w=S+(O<<2)|0;c[w>>2]=c[w>>2]|1<<(s&31)}else{if(R)U=c[v>>2]|0;else{R=s+128|0;w=((R&31|0)!=0&1)+(R>>>5)|0;R=UJa(j,w<<2,483800,429)|0;S=c[l>>2]|0;if(!S)V=0;else{YEi(R|0,c[v>>2]|0,S<<2|0)|0;V=c[l>>2]|0}if((w|0)!=(V|0))PEi(R+(V<<2)|0,0,w-V<<2|0)|0;V=c[v>>2]|0;if(V){VJa(k,V);c[v>>2]=0}c[v>>2]=R;c[l>>2]=w;U=R}R=U+(O<<2)|0;c[R>>2]=c[R>>2]&~(1<<(s&31))}if(!t){c[u+8>>2]=n;t=a+5236|0;R=a+5240|0;U=c[R>>2]|0;if((U|0)==(c[t>>2]|0)){gLa(t,1)|0;W=c[R>>2]|0}else W=U;c[R>>2]=W+1;c[(c[a+5244>>2]|0)+(W<<2)>>2]=f}if(g){X=u+6|0;b[X>>1]=P;c[u>>2]=f;i=h;return n|0}g=a+80|0;W=a+84|0;if(O>>>0<(c[W>>2]|0)>>>0)Y=c[g>>2]|0;else{a=s+128|0;R=((a&31|0)!=0&1)+(a>>>5)|0;a=UJa(j,R<<2,483800,429)|0;j=c[W>>2]|0;if(!j)Z=0;else{YEi(a|0,c[g>>2]|0,j<<2|0)|0;Z=c[W>>2]|0}if((R|0)!=(Z|0))PEi(a+(Z<<2)|0,0,R-Z<<2|0)|0;Z=c[g>>2]|0;if(Z){VJa(k,Z);c[g>>2]=0}c[g>>2]=a;c[W>>2]=R;Y=a}a=Y+(O<<2)|0;c[a>>2]=c[a>>2]|1<<(s&31);X=u+6|0;b[X>>1]=P;c[u>>2]=f;i=h;return n|0}function Vqa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=f+1|0;h=f;j=d>>>2;k=c[a+44>>2]|0;l=c[a+28>>2]|0;m=k+(j*12|0)+4|0;n=b[m>>1]|0;o=n&65535;if(n<<16>>16){p=k+(j*12|0)+8|0;if(n<<16>>16==1)q=p;else q=(c[a+(o<<4)+104>>2]|0)+(c[p>>2]<<2)|0;p=0;do{Gqa(c[l+((e[q+(p<<2)+2>>1]|0)*40|0)+28>>2]|0,b[q+(p<<2)>>1]|0);p=p+1|0}while((p|0)!=(o|0));if((n&65535)>1){n=c[k+(j*12|0)+8>>2]|0;p=a+(o<<2)+4208|0;c[(c[a+(o<<4)+104>>2]|0)+(n<<2)>>2]=c[p>>2];c[p>>2]=n}}b[m>>1]=0;m=k+(j*12|0)+6|0;b[m>>1]=e[m>>1]|0|4;m=a+12|0;c[k+(j*12|0)+8>>2]=c[m>>2];k=a+80|0;n=d>>>7;d=a+84|0;if(n>>>0<(c[d>>2]|0)>>>0)r=c[k>>2]|0;else{p=j+128|0;o=((p&31|0)!=0&1)+(p>>>5)|0;p=UJa(g,o<<2,483800,429)|0;q=c[d>>2]|0;if(!q)s=0;else{YEi(p|0,c[k>>2]|0,q<<2|0)|0;s=c[d>>2]|0}if((o|0)!=(s|0))PEi(p+(s<<2)|0,0,o-s<<2|0)|0;s=c[k>>2]|0;if(s){VJa(h,s);c[k>>2]=0}c[k>>2]=p;c[d>>2]=o;r=p}p=1<<(j&31);o=r+(n<<2)|0;c[o>>2]=c[o>>2]|p;c[m>>2]=j;m=a+88|0;o=a+92|0;if(n>>>0<(c[o>>2]|0)>>>0){t=c[m>>2]|0;u=t+(n<<2)|0;v=c[u>>2]|0;w=v|p;c[u>>2]=w;i=f;return 1}a=j+128|0;j=((a&31|0)!=0&1)+(a>>>5)|0;a=UJa(g,j<<2,483800,429)|0;g=c[o>>2]|0;if(!g)x=0;else{YEi(a|0,c[m>>2]|0,g<<2|0)|0;x=c[o>>2]|0}if((j|0)!=(x|0))PEi(a+(x<<2)|0,0,j-x<<2|0)|0;x=c[m>>2]|0;if(x){VJa(h,x);c[m>>2]=0}c[m>>2]=a;c[o>>2]=j;t=a;u=t+(n<<2)|0;v=c[u>>2]|0;w=v|p;c[u>>2]=w;i=f;return 1}function Wqa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;h=i;i=i+16|0;j=h+8|0;k=h;l=b+8|0;m=c[l>>2]|0;a:do if(m){n=b+20|0;o=f+4|0;p=e+120|0;q=e+96|0;r=j+4|0;s=e+104|0;t=e+100|0;u=g+4|0;v=e+108|0;w=k+4|0;x=e+116|0;y=e+112|0;z=b+4|0;A=0;B=m;while(1){C=A;b:while(1){D=c[n>>2]|0;E=D+(C*12|0)|0;F=D+(C*12|0)+8|0;do if(!(a[F>>0]|0)){G=D+(C*12|0)+9|0;if(a[G>>0]|0){a[G>>0]=0;break}H=c[E>>2]|0;I=c[D+(C*12|0)+4>>2]|0;J=H>>>2;K=I>>>2;L=H>>>7;G=c[o>>2]|0;if(L>>>0<G>>>0?(c[(c[f>>2]|0)+(L<<2)>>2]&1<<(J&31)|0)!=0:0)break b;M=I>>>7;if(M>>>0<G>>>0?(c[(c[f>>2]|0)+(M<<2)>>2]&1<<(K&31)|0)!=0:0)break b}else{M=c[d+(((c[E>>2]|0)>>>2)*12|0)>>2]|0;G=c[d+(((c[D+(C*12|0)+4>>2]|0)>>>2)*12|0)>>2]|0;N=c[p>>2]|0;do if((c[N+(M<<2)>>2]|0)!=(c[N+(G<<2)>>2]|0)){O=M>>>0<G>>>0;c[j>>2]=O?M:G;c[r>>2]=O?G:M;O=c[t>>2]|0;if((c[s>>2]&2147483647)>>>0<=O>>>0){A$a(q,j)|0;break}P=(c[q>>2]|0)+(O<<3)|0;if(!P)Q=O;else{O=j;R=c[O+4>>2]|0;S=P;c[S>>2]=c[O>>2];c[S+4>>2]=R;Q=c[t>>2]|0}c[t>>2]=Q+1}while(0);a[F>>0]=0;a[D+(C*12|0)+9>>0]=0}while(0);D=C+1|0;if(D>>>0<B>>>0)C=D;else break a}D=c[u>>2]|0;if(!(L>>>0<D>>>0?(c[(c[g>>2]|0)+(L<<2)>>2]&1<<(J&31)|0)!=0:0))T=21;do if((T|0)==21){T=0;F=I>>>7;if(F>>>0<D>>>0?(c[(c[g>>2]|0)+(F<<2)>>2]&1<<(K&31)|0)!=0:0)break;F=c[d+(J*12|0)>>2]|0;E=c[d+(K*12|0)>>2]|0;M=c[p>>2]|0;if((c[M+(F<<2)>>2]|0)!=(c[M+(E<<2)>>2]|0)){M=F>>>0<E>>>0;c[k>>2]=M?F:E;c[w>>2]=M?E:F;F=c[y>>2]|0;if((c[x>>2]&2147483647)>>>0<=F>>>0){A$a(v,k)|0;break}E=(c[v>>2]|0)+(F<<3)|0;if(!E)U=F;else{F=k;M=c[F+4>>2]|0;G=E;c[G>>2]=c[F>>2];c[G+4>>2]=M;U=c[y>>2]|0}c[y>>2]=U+1}}while(0);D=I<<16|H&65535;M=D+~(D<<15)|0;D=(M>>10^M)*9|0;M=D>>6^D;D=M+~(M<<11)|0;Bqa(b,0,0,c[z>>2]&(D>>16^D),C);B=B+-1|0;if(C>>>0>=B>>>0)break;else A=C}}while(0);H=c[l>>2]|0;l=H>>>1|H;H=l>>>2|l;l=H>>>4|H;H=l>>>8|l;l=H>>>16|H;H=l+1|0;if((c[b>>2]|0)==(H|0)){i=h;return 1}I=c[b+24>>2]|0;if((I|0)!=0&H>>>0<I>>>0){i=h;return 1}c[b>>2]=H;c[b+4>>2]=l;Aqa(b);i=h;return 1}function Xqa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+8>>2]|0;f=c[b+28>>2]|0;if(!e){i=d;return}else g=0;do{b=c[f+(g*40|0)+28>>2]|0;do if(b){h=b+116|0;j=(a[b+168>>0]|0)==0;if(!(c[h>>2]|0))if(j)break;else k=6;else if(!j)k=6;if((k|0)==6){k=0;Dqa(b);c[h>>2]=c[b+92>>2];c[b+120>>2]=0;a[b+169>>0]=1}Jqa(b,b+176|0);j=c[h>>2]|0;if((j|0)!=0?(h=c[b+84>>2]|0,(h|0)!=0):0){c[b+32>>2]=c[b+76>>2];c[b+36>>2]=j;c[b+40>>2]=h;c[b+44>>2]=c[b+12992>>2];c[b+48>>2]=c[b+96>>2];c[b+52>>2]=c[b+104>>2];c[b+56>>2]=c[b+144>>2];a[b+60>>0]=1;break}a[b+60>>0]=0}while(0);g=g+1|0}while((g|0)!=(e|0));i=d;return}function Yqa(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0;f=i;i=i+32|0;h=f;j=c[a+8>>2]|0;l=c[a+28>>2]|0;if(j){m=d+4|0;n=d+8|0;o=0;do{if(c[l+(o*40|0)+28>>2]|0){p=l+(o*40|0)+4|0;q=c[p>>2]<<1;r=l+(o*40|0)+8|0;s=c[r>>2]<<1;t=l+(o*40|0)+12|0;u=c[t>>2]<<1;v=l+(o*40|0)+16|0;w=c[v>>2]<<1;x=l+(o*40|0)+20|0;y=c[x>>2]<<1;z=l+(o*40|0)+24|0;A=c[z>>2]<<1;B=ea(g[d>>2]);C=ea((c[k>>2]=(q|0)<0?q&2147483646:~q,ea(g[k>>2]))-B);q=(g[k>>2]=C,c[k>>2]|0);C=ea(g[m>>2]);D=ea((c[k>>2]=(s|0)<0?s&2147483646:~s,ea(g[k>>2]))-C);s=(g[k>>2]=D,c[k>>2]|0);D=ea(g[n>>2]);E=ea((c[k>>2]=(u|0)<0?u&2147483646:~u,ea(g[k>>2]))-D);u=(g[k>>2]=E,c[k>>2]|0);E=ea((c[k>>2]=(w|0)<0?w&2147483646:~w,ea(g[k>>2]))-B);w=(g[k>>2]=E,c[k>>2]|0);E=ea((c[k>>2]=(y|0)<0?y&2147483646:~y,ea(g[k>>2]))-C);y=(g[k>>2]=E,c[k>>2]|0);E=ea((c[k>>2]=(A|0)<0?A&2147483646:~A,ea(g[k>>2]))-D);A=(g[k>>2]=E,c[k>>2]|0);c[p>>2]=((q|0)<0?q^-2:q|-2147483648)>>>1;c[r>>2]=((s|0)<0?s^-2:s|-2147483648)>>>1;c[t>>2]=((u|0)<0?u^-2:u|-2147483648)>>>1;c[v>>2]=((w|0)<0?w^-2:w|-2147483648)>>>1;c[x>>2]=((y|0)<0?y^-2:y|-2147483648)>>>1;c[z>>2]=((A|0)<0?A^-2:A|-2147483648)>>>1}o=o+1|0}while((o|0)!=(j|0))}j=c[a+40>>2]|0;o=(j>>>0)/3|0;n=c[a+44>>2]|0;if(j>>>0<=2){i=f;return}j=a+5260|0;m=h+4|0;d=h+8|0;A=h+12|0;z=h+16|0;y=h+20|0;x=0;do{w=b[n+(x*12|0)+4>>1]|0;v=w&65535;if(w<<16>>16){wpa(h,c[j>>2]|0,c[n+(x*12|0)>>2]|0);u=c[h>>2]|0;t=((u|0)<0?u^-2:u|-2147483648)>>>1;u=c[m>>2]|0;s=((u|0)<0?u^-2:u|-2147483648)>>>1;u=c[d>>2]|0;r=((u|0)<0?u^-2:u|-2147483648)>>>1;u=c[A>>2]|0;q=((u|0)<0?u^-2:u|-2147483648)>>>1;u=c[z>>2]|0;p=((u|0)<0?u^-2:u|-2147483648)>>>1;u=c[y>>2]|0;F=((u|0)<0?u^-2:u|-2147483648)>>>1;u=n+(x*12|0)+8|0;if(w<<16>>16==1)G=u;else G=(c[a+(v<<4)+104>>2]|0)+(c[u>>2]<<2)|0;u=0;do{w=c[l+((e[G+(u<<2)+2>>1]|0)*40|0)+28>>2]|0;H=e[G+(u<<2)>>1]|0;I=c[w+76>>2]|0;J=c[I+(H<<3)>>2]|0;if(!(c[I+(H<<3)+4>>2]&1)){H=c[w+100>>2]|0;c[H+(J*24|0)>>2]=t;c[H+(J*24|0)+4>>2]=s;c[H+(J*24|0)+8>>2]=r;c[H+(J*24|0)+12>>2]=q;c[H+(J*24|0)+16>>2]=p;c[H+(J*24|0)+20>>2]=F}else{H=c[w+96>>2]|0;c[H+(J*24|0)>>2]=t;c[H+(J*24|0)+4>>2]=s;c[H+(J*24|0)+8>>2]=r;c[H+(J*24|0)+12>>2]=q;c[H+(J*24|0)+16>>2]=p;c[H+(J*24|0)+20>>2]=F}u=u+1|0}while((u|0)!=(v|0))}x=x+1|0}while(x>>>0<o>>>0);i=f;return}function Zqa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;c[a>>2]=484016;bva(a+4|0,b,d);eva(a+44|0,b,d);d=a+96|0;b=a+104|0;h=a+108|0;j=a+116|0;k=a+88|0;l=k+36|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;o=Bn[n&255](m,5264,p?484216:544544,483800,3435)|0;c[o>>2]=483904;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=-1;c[o+16>>2]=-1;aLa(o+20|0);aLa(o+36|0);p=o+96|0;m=o+4208|0;k=o+52|0;l=k+44|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));k=p;do{aLa(k);k=k+16|0}while((k|0)!=(m|0));aLa(o+5236|0);c[o+5252>>2]=0;c[o+5256>>2]=0;c[o+5260>>2]=f;PEi(m|0,-1,1028)|0;c[a+84>>2]=o;Oqa(o,c[e+72>>2]|0,(c[e+60>>2]|0)+(c[e+56>>2]|0)|0)|0;if((c[b>>2]&2147482624)>>>0<1024)B$a(d,1024);if((c[j>>2]&2147482624)>>>0>=1024){i=g;return}B$a(h,1024);i=g;return}function _qa(a){a=a|0;var b=0;b=i;i=i+16|0;$qa(a);VJa(b,a);i=b;return}function $qa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;c[a>>2]=484016;d=a+84|0;e=c[d>>2]|0;if(e){ko[c[(c[e>>2]|0)+4>>2]&4095](e);c[d>>2]=0}VJa(b,c[a+88>>2]|0);d=c[a+116>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+108>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+104>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+96>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}c[a+44>>2]=443968;c[a+52>>2]=0;dva(a+4|0);i=b;return}function ara(b,d){b=b|0;d=d|0;c[d>>2]=256;c[d+4>>2]=0;a[d+8>>0]=1;return 1}function bra(a){a=a|0;return c[(c[a+84>>2]|0)+8>>2]|0}function cra(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;k=c[d+84>>2]|0;d=c[k+8>>2]|0;l=c[k+28>>2]|0;k=d>>>0<f>>>0?d:f;if(!k){i=j;return k|0}m=~d;d=~f;f=~(m>>>0>d>>>0?m:d);d=0;do{m=d+h|0;n=e+(d*40|0)|0;o=c[l+(m*40|0)+4>>2]<<1;c[n>>2]=(o|0)<0?o&2147483646:~o;o=c[l+(m*40|0)+8>>2]<<1;p=e+(d*40|0)+4|0;c[p>>2]=(o|0)<0?o&2147483646:~o;o=c[l+(m*40|0)+12>>2]<<1;q=e+(d*40|0)+8|0;c[q>>2]=(o|0)<0?o&2147483646:~o;o=c[l+(m*40|0)+16>>2]<<1;c[e+(d*40|0)+12>>2]=(o|0)<0?o&2147483646:~o;o=c[l+(m*40|0)+20>>2]<<1;r=e+(d*40|0)+16|0;c[r>>2]=(o|0)<0?o&2147483646:~o;o=c[l+(m*40|0)+24>>2]<<1;s=e+(d*40|0)+20|0;c[s>>2]=(o|0)<0?o&2147483646:~o;o=l+(m*40|0)+28|0;if(!(c[o>>2]|0)){g[n>>2]=ea(8507058669999999534545717.0e13);g[p>>2]=ea(8507058669999999534545717.0e13);g[q>>2]=ea(8507058669999999534545717.0e13);g[e+(d*40|0)+12>>2]=ea(-8507058669999999534545717.0e13);g[r>>2]=ea(-8507058669999999534545717.0e13);g[s>>2]=ea(-8507058669999999534545717.0e13);s=e+(d*40|0)+24|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;b[s+12>>1]=0}else{c[e+(d*40|0)+24>>2]=c[l+(m*40|0)+36>>2];a[e+(d*40|0)+36>>0]=1;a[e+(d*40|0)+37>>0]=(c[l+(m*40|0)+32>>2]|0)!=0&1;m=c[o>>2]|0;c[e+(d*40|0)+28>>2]=c[m+84>>2];c[e+(d*40|0)+32>>2]=c[m+92>>2]}d=d+1|0}while((d|0)!=(f|0));i=j;return k|0}function dra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Rqa(c[a+84>>2]|0,b,d)|0;i=e;return f|0}function era(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Sqa(c[a+84>>2]|0,b)|0;i=d;return e|0}function fra(a){a=a|0;var b=0;b=i;if(!a){i=b;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);i=b;return}function gra(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;hra(a,e);e=a+44|0;c[a+64>>2]=a;h=a+4|0;c[a+24>>2]=a;c[a+68>>2]=b;c[a+28>>2]=b;c[a+72>>2]=d;c[a+32>>2]=d;c[a+60>>2]=1;d=a+56|0;c[d>>2]=f;if(f){ko[c[(c[f>>2]|0)+16>>2]&4095](f);c[a+52>>2]=c[(c[d>>2]|0)+8>>2]}c[a+20>>2]=1;d=a+16|0;c[d>>2]=e;ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[a+12>>2]=c[(c[d>>2]|0)+8>>2];ko[c[(c[e>>2]|0)+20>>2]&4095](e);ko[c[(c[h>>2]|0)+20>>2]&4095](h);i=g;return}function hra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+48|0;f=d+24|0;g=d;h=c[b+32>>2]|0;j=a+92|0;if(h>>>0>(c[j>>2]|0)>>>0){k=UJa(d+49|0,h<<2,483800,3552)|0;l=c[j>>2]|0;if(!l)m=0;else{YEi(k|0,c[a+88>>2]|0,l<<2|0)|0;m=c[j>>2]|0}if(m>>>0<h>>>0)PEi(k+(m<<2)|0,-1,h-m<<2|0)|0;m=a+88|0;VJa(e,c[m>>2]|0);c[m>>2]=k;c[j>>2]=h}h=c[b+24>>2]|0;j=c[b+28>>2]|0;c[a+120>>2]=j;k=c[b+16>>2]|0;if((k|0)!=0?(m=c[b+20>>2]|0,(m|0)!=0):0){e=a+84|0;l=a+88|0;n=c[l>>2]|0;o=m;m=k;while(1){o=o+-1|0;k=c[m>>2]|0;Vqa(c[e>>2]|0,c[n+(k<<2)>>2]|0)|0;n=c[l>>2]|0;c[n+(k<<2)>>2]=-1;if(!o)break;else m=m+4|0}}m=c[b>>2]|0;if((m|0)!=0?(o=c[b+4>>2]|0,(o|0)!=0):0){n=f+4|0;l=f+8|0;e=f+12|0;k=f+16|0;p=f+20|0;q=a+84|0;r=a+88|0;s=m;m=o;while(1){m=m+-1|0;o=c[s>>2]|0;t=(c[j+(o<<2)>>2]|0)==0;c[f>>2]=(c[h+(o*24|0)>>2]|0)>>>1;c[n>>2]=(c[h+(o*24|0)+4>>2]|0)>>>1;c[l>>2]=(c[h+(o*24|0)+8>>2]|0)>>>1;c[e>>2]=(c[h+(o*24|0)+12>>2]|0)>>>1;c[k>>2]=(c[h+(o*24|0)+16>>2]|0)>>>1;c[p>>2]=(c[h+(o*24|0)+20>>2]|0)>>>1;u=Uqa(c[q>>2]|0,f,o,t)|0;c[(c[r>>2]|0)+(o<<2)>>2]=u;if(!m)break;else s=s+4|0}}s=c[b+8>>2]|0;if(!s){v=a+84|0;w=c[v>>2]|0;Xqa(w);i=d;return}m=c[b+12>>2]|0;if(!m){v=a+84|0;w=c[v>>2]|0;Xqa(w);i=d;return}b=g+4|0;r=g+8|0;f=g+12|0;q=g+16|0;p=g+20|0;k=a+84|0;e=a+88|0;l=m;m=s;while(1){s=l+-1|0;n=c[m>>2]|0;c[g>>2]=(c[h+(n*24|0)>>2]|0)>>>1;c[b>>2]=(c[h+(n*24|0)+4>>2]|0)>>>1;c[r>>2]=(c[h+(n*24|0)+8>>2]|0)>>>1;c[f>>2]=(c[h+(n*24|0)+12>>2]|0)>>>1;c[q>>2]=(c[h+(n*24|0)+16>>2]|0)>>>1;c[p>>2]=(c[h+(n*24|0)+20>>2]|0)>>>1;Qqa(c[k>>2]|0,c[(c[e>>2]|0)+(n<<2)>>2]|0,g)|0;if(!s)break;l=s;m=m+4|0}v=a+84|0;w=c[v>>2]|0;Xqa(w);i=d;return}function ira(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+84>>2]|0;e=c[a+120>>2]|0;a=c[d+8>>2]|0;f=c[d+28>>2]|0;g=c[d+44>>2]|0;if(!a){i=b;return}h=d+52|0;d=0;do{j=c[f+(d*40|0)+28>>2]|0;if(j)Kqa(j,h,e,g);d=d+1|0}while((d|0)!=(a|0));i=b;return}function jra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+84>>2]|0;e=c[d+8>>2]|0;f=c[d+28>>2]|0;if(e){g=0;do{h=c[f+(g*40|0)+28>>2]|0;if(h)c[h+116>>2]=0;g=g+1|0}while((g|0)!=(e|0))}e=d+80|0;Wqa(d+52|0,c[d+44>>2]|0,a,e,d+88|0)|0;PEi(c[e>>2]|0,0,c[d+84>>2]<<2|0)|0;i=b;return}function kra(a){a=a|0;return c[a+100>>2]|0}function lra(a){a=a|0;return c[a+96>>2]|0}function mra(a){a=a|0;return c[a+112>>2]|0}function nra(a){a=a|0;return c[a+108>>2]|0}function ora(a){a=a|0;return c[(c[a+84>>2]|0)+5240>>2]|0}function pra(a){a=a|0;return c[(c[a+84>>2]|0)+5244>>2]|0}function qra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=c[a+84>>2]|0;f=e+88|0;g=c[f>>2]|0;if(g){VJa(d,g);c[f>>2]=0}c[f>>2]=0;c[e+92>>2]=0;hLa(e+5236|0)|0;e=a+96|0;f=a+100|0;if((c[f>>2]|0)>>>0>1024){c[d>>2]=1073741823;c[d+4>>2]=1073741823;C$a(e,0,d);B$a(e,c[f>>2]|0);if((c[a+104>>2]&2147482624)>>>0<1024)B$a(e,1024)}else c[f>>2]=0;f=a+108|0;e=a+112|0;if((c[e>>2]|0)>>>0<=1024){c[e>>2]=0;i=b;return}c[d>>2]=1073741823;c[d+4>>2]=1073741823;C$a(f,0,d);B$a(f,c[e>>2]|0);if((c[a+116>>2]&2147482624)>>>0>=1024){i=b;return}B$a(f,1024);i=b;return}function rra(a,b){a=a|0;b=b|0;var d=0;d=i;Yqa(c[a+84>>2]|0,b);i=d;return}function sra(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+32|0;g=f+17|0;h=f+8|0;j=f+4|0;k=f+12|0;l=f+14|0;m=f+16|0;n=f+18|0;o=f+19|0;p=f+10|0;q=f+2|0;r=f;s=f+1|0;t=f+11|0;u=f+13|0;v=f+7|0;w=f+15|0;x=f+3|0;c[a>>2]=484584;c[a+4>>2]=d;c[a+8>>2]=e;e=a+12|0;b[a+16>>1]=-1;b[a+18>>1]=0;c[a+20>>2]=0;c[e>>2]=443968;c[a+24>>2]=0;c[a+28>>2]=0;c[e>>2]=498800;e=a+44|0;b[a+48>>1]=-1;b[a+50>>1]=0;c[a+52>>2]=0;c[e>>2]=443968;c[a+56>>2]=0;c[a+60>>2]=0;c[e>>2]=498848;e=a+192|0;Jra(e);d=a+256|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;b[a+260>>1]=-1;b[a+262>>1]=0;c[a+264>>2]=0;c[d>>2]=443968;c[a+268>>2]=0;c[a+272>>2]=0;c[d>>2]=484760;c[a+276>>2]=0;c[a+280>>2]=-1;d=a+284|0;y=a+296|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;b[a+300>>1]=-1;b[a+302>>1]=0;c[a+304>>2]=0;c[y>>2]=443968;c[a+308>>2]=0;c[a+312>>2]=0;c[y>>2]=484760;c[a+316>>2]=0;c[a+320>>2]=-1;y=a+324|0;d=a+336|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;c[y+20>>2]=0;c[y+24>>2]=0;c[y+28>>2]=0;b[a+340>>1]=-1;b[a+342>>1]=0;c[a+344>>2]=0;c[d>>2]=443968;c[a+348>>2]=0;c[a+352>>2]=0;c[d>>2]=484760;c[a+356>>2]=0;c[a+360>>2]=-1;c[a+364>>2]=0;c[a+368>>2]=0;c[a+372>>2]=0;c[a+168>>2]=0;c[a+172>>2]=0;d=a+108|0;c[d>>2]=64;y=a+112|0;c[y>>2]=UJa(f+9|0,512,484656,477)|0;z=a+116|0;c[z>>2]=UJa(f+6|0,(c[d>>2]<<3)+15&-16,484656,478)|0;A=UJa(f+5|0,(c[d>>2]<<3)+15&-16,484656,479)|0;c[a+120>>2]=A;if(!(c[d>>2]|0))B=0;else{C=c[y>>2]|0;y=c[z>>2]|0;z=0;do{c[C+(z<<3)>>2]=1073741823;c[C+(z<<3)+4>>2]=1073741823;c[y+(z<<3)>>2]=1073741823;c[y+(z<<3)+4>>2]=1073741823;c[A+(z<<3)>>2]=1073741823;c[A+(z<<3)+4>>2]=1073741823;z=z+1|0;D=c[d>>2]|0}while(z>>>0<D>>>0);B=D+15&-16}D=a+176|0;c[D>>2]=130;c[a+148>>2]=UJa(g,B,484656,493)|0;c[a+152>>2]=UJa(h,(c[D>>2]<<2)+15&-16,484656,494)|0;c[a+156>>2]=UJa(j,(c[D>>2]<<3)+15&-16,484656,495)|0;j=a+124|0;c[j>>2]=UJa(k,(c[D>>2]<<2)+15&-16,484656,500)|0;k=a+128|0;c[k>>2]=UJa(l,(c[D>>2]<<2)+15&-16,484656,501)|0;l=a+132|0;c[l>>2]=UJa(m,(c[D>>2]<<2)+15&-16,484656,502)|0;m=a+136|0;c[m>>2]=UJa(n,(c[D>>2]<<2)+15&-16,484656,503)|0;n=a+140|0;c[n>>2]=UJa(o,(c[D>>2]<<2)+15&-16,484656,504)|0;o=UJa(p,(c[D>>2]<<2)+15&-16,484656,505)|0;c[a+144>>2]=o;p=c[j>>2]|0;j=c[m>>2]|0;c[p>>2]=0;c[j>>2]=1073741822;c[p+4>>2]=-1;c[j+4>>2]=1073741823;j=c[k>>2]|0;k=c[n>>2]|0;c[j>>2]=0;c[k>>2]=1073741822;c[j+4>>2]=-1;c[k+4>>2]=1073741823;k=c[l>>2]|0;c[k>>2]=0;c[o>>2]=1073741822;c[k+4>>2]=-1;c[o+4>>2]=1073741823;c[a+180>>2]=UJa(q,4096,484656,516)|0;c[a+184>>2]=0;c[a+188>>2]=1024;c[a+236>>2]=0;c[a+248>>2]=0;c[a+232>>2]=UJa(r,512,484656,523)|0;c[a+240>>2]=64;c[a+244>>2]=UJa(s,512,484656,525)|0;c[a+252>>2]=64;s=a+160|0;c[s>>2]=UJa(t,(c[D>>2]<<2)+15&-16,484656,528)|0;t=UJa(u,(c[D>>2]<<2)+15&-16,484656,529)|0;c[a+164>>2]=t;u=c[D>>2]|0;r=c[s>>2]|0;if(u>>>0>1)E=1;else{F=u;G=F+-1|0;H=r+(G<<2)|0;c[H>>2]=G;c[t>>2]=0;Lra(e,64);I=a+356|0;c[I>>2]=a;J=a+360|0;c[J>>2]=2;K=a+316|0;c[K>>2]=a;L=a+320|0;c[L>>2]=1;M=a+276|0;c[M>>2]=a;N=a+280|0;c[N>>2]=0;O=UJa(v,65536,484656,548)|0;P=a+364|0;c[P>>2]=O;Q=a+372|0;c[Q>>2]=8192;R=UJa(w,65536,484656,549)|0;S=a+324|0;c[S>>2]=R;T=a+332|0;c[T>>2]=8192;U=UJa(x,65536,484656,550)|0;V=a+284|0;c[V>>2]=U;W=a+292|0;c[W>>2]=8192;i=f;return}do{u=E+-1|0;c[r+(u<<2)>>2]=E;c[t+(E<<2)>>2]=u;E=E+1|0;u=c[D>>2]|0}while(E>>>0<u>>>0);F=u;G=F+-1|0;H=r+(G<<2)|0;c[H>>2]=G;c[t>>2]=0;Lra(e,64);I=a+356|0;c[I>>2]=a;J=a+360|0;c[J>>2]=2;K=a+316|0;c[K>>2]=a;L=a+320|0;c[L>>2]=1;M=a+276|0;c[M>>2]=a;N=a+280|0;c[N>>2]=0;O=UJa(v,65536,484656,548)|0;P=a+364|0;c[P>>2]=O;Q=a+372|0;c[Q>>2]=8192;R=UJa(w,65536,484656,549)|0;S=a+324|0;c[S>>2]=R;T=a+332|0;c[T>>2]=8192;U=UJa(x,65536,484656,550)|0;V=a+284|0;c[V>>2]=U;W=a+292|0;c[W>>2]=8192;i=f;return}function tra(a){a=a|0;var b=0;b=i;ura(a);ACi(a);i=b;return}function ura(a){a=a|0;var b=0;b=i;i=i+32|0;c[a>>2]=484584;VJa(b+9|0,c[a+112>>2]|0);VJa(b+6|0,c[a+116>>2]|0);VJa(b+5|0,c[a+120>>2]|0);VJa(b+17|0,c[a+124>>2]|0);VJa(b+8|0,c[a+128>>2]|0);VJa(b+4|0,c[a+132>>2]|0);VJa(b+12|0,c[a+136>>2]|0);VJa(b+14|0,c[a+140>>2]|0);VJa(b+16|0,c[a+144>>2]|0);VJa(b+18|0,c[a+180>>2]|0);VJa(b+19|0,c[a+232>>2]|0);VJa(b+10|0,c[a+244>>2]|0);Mra(a+192|0);VJa(b+2|0,c[a+284>>2]|0);VJa(b,c[a+324>>2]|0);VJa(b+1|0,c[a+364>>2]|0);VJa(b+11|0,c[a+160>>2]|0);VJa(b+13|0,c[a+164>>2]|0);VJa(b+7|0,c[a+152>>2]|0);VJa(b+15|0,c[a+156>>2]|0);VJa(b+3|0,c[a+148>>2]|0);c[a+336>>2]=443968;c[a+344>>2]=0;c[a+296>>2]=443968;c[a+304>>2]=0;c[a+256>>2]=443968;c[a+264>>2]=0;c[a+44>>2]=443968;c[a+52>>2]=0;c[a+12>>2]=443968;c[a+20>>2]=0;i=b;return}function vra(a){a=a|0;var b=0;b=i;i=i+16|0;ko[c[c[a>>2]>>2]&4095](a);VJa(b,a);i=b;return}function wra(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=UJa(c,376,484656,607)|0;if(!d){i=c;return d|0}sra(d,a,b);i=c;return d|0}function xra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+5|0;e=b+4|0;f=b+3|0;g=b+2|0;h=b+1|0;j=b;c[a+236>>2]=0;c[a+248>>2]=0;k=a+232|0;l=a+240|0;if((c[l>>2]|0)!=64){m=UJa(d,512,484656,620)|0;n=c[k>>2]|0;if(n)VJa(e,n);c[k>>2]=m;c[l>>2]=64}l=a+244|0;m=a+252|0;if((c[m>>2]|0)!=64){k=UJa(d,512,484656,620)|0;d=c[l>>2]|0;if(d)VJa(e,d);c[l>>2]=k;c[m>>2]=64}c[a+184>>2]=0;m=a+188|0;if((c[m>>2]|0)>>>0>1024){k=a+180|0;VJa(f,c[k>>2]|0);c[k>>2]=UJa(g,4096,484656,640)|0;c[m>>2]=1024}m=a+292|0;if((c[m>>2]|0)>>>0>8192){g=a+284|0;VJa(h,c[g>>2]|0);c[g>>2]=UJa(j,65536,484656,650)|0;c[m>>2]=8192}c[a+288>>2]=0;m=a+332|0;if((c[m>>2]|0)>>>0>8192){g=a+324|0;VJa(h,c[g>>2]|0);c[g>>2]=UJa(j,65536,484656,650)|0;c[m>>2]=8192}c[a+328>>2]=0;m=a+372|0;if((c[m>>2]|0)>>>0<=8192){o=a+368|0;c[o>>2]=0;p=a+192|0;Sra(p);i=b;return}g=a+364|0;VJa(h,c[g>>2]|0);c[g>>2]=UJa(j,65536,484656,650)|0;c[m>>2]=8192;o=a+368|0;c[o>>2]=0;p=a+192|0;Sra(p);i=b;return}function yra(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+168|0;if(!(c[e>>2]|0)){i=d;return}f=ea(g[b>>2]);h=ea(g[b+4>>2]);j=ea(g[b+8>>2]);b=c[a+136>>2]|0;l=c[a+124>>2]|0;m=c[a+140>>2]|0;n=c[a+128>>2]|0;o=c[a+144>>2]|0;p=c[a+132>>2]|0;a=l+4|0;q=c[a>>2]|0;r=b+4|0;s=n+4|0;t=c[s>>2]|0;u=m+4|0;v=c[u>>2]|0;w=p+4|0;x=c[w>>2]|0;y=o+4|0;z=c[y>>2]|0;A=ea((c[k>>2]=(q|0)<0?q&2147483647:~q,ea(g[k>>2]))-f);q=(g[k>>2]=A,c[k>>2]|0);A=ea((c[k>>2]=(t|0)<0?t&2147483647:~t,ea(g[k>>2]))-h);t=(g[k>>2]=A,c[k>>2]|0);A=ea((c[k>>2]=(x|0)<0?x&2147483647:~x,ea(g[k>>2]))-j);x=(g[k>>2]=A,c[k>>2]|0);B=(q|0)<0?~q:q|-2147483648;if(!(c[r>>2]&1))C=B+-16&-16;else C=B+16&-16|1;c[a>>2]=C;C=(t|0)<0?~t:t|-2147483648;if(!(v&1))D=C+-16&-16;else D=C+16&-16|1;c[s>>2]=D;D=(x|0)<0?~x:x|-2147483648;if(!(z&1))E=D+-16&-16;else E=D+16&-16|1;c[w>>2]=E;if(c[e>>2]<<1>>>0<2){i=d;return}w=2;D=c[r>>2]&1;r=c[u>>2]&1;u=c[y>>2]&1;y=c[a>>2]|0;a=c[s>>2]|0;s=E;while(1){E=D;D=c[b+(w<<2)>>2]&1;z=r;r=c[m+(w<<2)>>2]&1;x=u;u=c[o+(w<<2)>>2]&1;C=l+(w<<2)|0;v=c[C>>2]|0;t=n+(w<<2)|0;B=c[t>>2]|0;q=p+(w<<2)|0;F=c[q>>2]|0;A=ea((c[k>>2]=(v|0)<0?v&2147483647:~v,ea(g[k>>2]))-f);v=(g[k>>2]=A,c[k>>2]|0);A=ea((c[k>>2]=(B|0)<0?B&2147483647:~B,ea(g[k>>2]))-h);B=(g[k>>2]=A,c[k>>2]|0);A=ea((c[k>>2]=(F|0)<0?F&2147483647:~F,ea(g[k>>2]))-j);F=(g[k>>2]=A,c[k>>2]|0);G=(v|0)<0?~v:v|-2147483648;if(!D)H=G+-16&-16;else H=G+16&-16|1;G=(B|0)<0?~B:B|-2147483648;if(!r)I=G+-16&-16;else I=G+16&-16|1;G=(F|0)<0?~F:F|-2147483648;if(!u)J=G+-16&-16;else J=G+16&-16|1;if(H>>>0<y>>>0)K=(D^E)+y|0;else K=H;if(I>>>0<a>>>0)L=(r^z)+a|0;else L=I;if(J>>>0<s>>>0)M=(u^x)+s|0;else M=J;c[C>>2]=K;c[t>>2]=L;c[q>>2]=M;w=w+1|0;if(w>>>0>c[e>>2]<<1>>>0)break;else{y=K;a=L;s=M}}i=d;return}function zra(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;Ara(a,e)|0;e=a+44|0;c[a+64>>2]=a;h=a+12|0;c[a+32>>2]=a;c[a+68>>2]=b;c[a+72>>2]=d;c[a+36>>2]=b;c[a+40>>2]=d;c[a+60>>2]=1;d=a+56|0;c[d>>2]=f;if(f){ko[c[(c[f>>2]|0)+16>>2]&4095](f);c[a+52>>2]=c[(c[d>>2]|0)+8>>2]}c[a+28>>2]=1;d=a+24|0;c[d>>2]=e;ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[a+20>>2]=c[(c[d>>2]|0)+8>>2];ko[c[(c[e>>2]|0)+20>>2]&4095](e);ko[c[(c[h>>2]|0)+20>>2]&4095](h);i=g;return}function Ara(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;i=i+32|0;f=e+25|0;g=e+23|0;h=e+4|0;j=e+5|0;k=e+6|0;l=e+7|0;m=e+8|0;n=e+20|0;o=e+22|0;p=e+24|0;q=e+26|0;r=e+27|0;s=e+14|0;t=e+15|0;u=e+16|0;v=e+17|0;w=e+18|0;x=e+3|0;y=e+2|0;z=e+19|0;A=e+9|0;B=e;C=e+1|0;D=e+10|0;E=e+21|0;c[b+76>>2]=c[d>>2];F=c[d+4>>2]|0;G=b+80|0;c[G>>2]=F;H=b+92|0;c[H>>2]=c[d+8>>2];I=b+96|0;c[I>>2]=c[d+12>>2];c[b+84>>2]=c[d+16>>2];c[b+88>>2]=c[d+20>>2];c[b+100>>2]=c[d+24>>2];c[b+104>>2]=c[d+28>>2];J=c[d+32>>2]|0;d=b+108|0;K=c[d>>2]|0;if(J>>>0>K>>>0){L=(J<<3)+15&-16;M=UJa(e+13|0,L,484656,949)|0;N=UJa(e+12|0,L,484656,950)|0;O=UJa(e+11|0,L,484656,951)|0;L=b+112|0;P=K<<3;YEi(M|0,c[L>>2]|0,P|0)|0;Q=b+116|0;YEi(N|0,c[Q>>2]|0,P|0)|0;R=b+120|0;YEi(O|0,c[R>>2]|0,P|0)|0;P=K;do{c[M+(P<<3)>>2]=1073741823;c[M+(P<<3)+4>>2]=1073741823;c[N+(P<<3)>>2]=1073741823;c[N+(P<<3)+4>>2]=1073741823;c[O+(P<<3)>>2]=1073741823;c[O+(P<<3)+4>>2]=1073741823;P=P+1|0}while((P|0)!=(J|0));VJa(f,c[L>>2]|0);VJa(g,c[Q>>2]|0);VJa(h,c[R>>2]|0);c[L>>2]=M;c[Q>>2]=N;c[R>>2]=O;c[d>>2]=J;O=b+148|0;VJa(j,c[O>>2]|0);c[O>>2]=UJa(k,J+15&-16,484656,977)|0;S=c[G>>2]|0}else S=F;F=b+168|0;J=S+(c[F>>2]|0)<<1;S=J+2|0;k=b+176|0;if(S>>>0>(c[k>>2]|0)>>>0){O=(S<<2)+15&-16;j=UJa(l,O,484656,986)|0;l=UJa(m,O,484656,987)|0;m=UJa(n,O,484656,988)|0;n=UJa(o,O,484656,989)|0;o=UJa(p,O,484656,990)|0;p=UJa(q,O,484656,991)|0;q=b+160|0;VJa(r,c[q>>2]|0);r=b+164|0;VJa(s,c[r>>2]|0);c[q>>2]=UJa(t,O,484656,997)|0;t=UJa(u,O,484656,998)|0;c[r>>2]=t;r=c[q>>2]|0;if((J|0)!=-2){q=1;do{u=q+-1|0;c[r+(u<<2)>>2]=q;c[t+(q<<2)>>2]=u;q=q+1|0}while(q>>>0<S>>>0)}q=J|1;c[r+(q<<2)>>2]=q;c[t>>2]=0;t=b+124|0;YEi(j|0,c[t>>2]|0,(c[F>>2]<<3)+8|0)|0;q=b+128|0;YEi(l|0,c[q>>2]|0,(c[F>>2]<<3)+8|0)|0;r=b+132|0;YEi(m|0,c[r>>2]|0,(c[F>>2]<<3)+8|0)|0;J=b+136|0;YEi(n|0,c[J>>2]|0,(c[F>>2]<<3)+8|0)|0;u=b+140|0;YEi(o|0,c[u>>2]|0,(c[F>>2]<<3)+8|0)|0;s=b+144|0;YEi(p|0,c[s>>2]|0,(c[F>>2]<<3)+8|0)|0;VJa(v,c[t>>2]|0);VJa(w,c[q>>2]|0);VJa(x,c[r>>2]|0);VJa(y,c[J>>2]|0);VJa(z,c[u>>2]|0);VJa(A,c[s>>2]|0);c[t>>2]=j;c[q>>2]=l;c[r>>2]=m;c[J>>2]=n;c[u>>2]=o;c[s>>2]=p;c[k>>2]=S;k=b+152|0;VJa(B,c[k>>2]|0);B=b+156|0;VJa(C,c[B>>2]|0);c[k>>2]=UJa(D,O,484656,1033)|0;c[B>>2]=UJa(E,S<<3,484656,1034)|0}S=b+148|0;PEi(c[S>>2]|0,0,c[d>>2]|0)|0;if(!(c[I>>2]|0)){T=c[G>>2]|0;U=c[F>>2]|0;V=U+T|0;c[F>>2]=V;i=e;return 1}else W=0;do{a[(c[S>>2]|0)+(c[(c[H>>2]|0)+(W<<2)>>2]|0)>>0]=1;W=W+1|0}while(W>>>0<(c[I>>2]|0)>>>0);T=c[G>>2]|0;U=c[F>>2]|0;V=U+T|0;c[F>>2]=V;i=e;return 1}function Bra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+192|0;e=a+180|0;f=a+184|0;g=a+188|0;h=c[a+288>>2]|0;j=c[a+284>>2]|0;if(h){k=0;do{l=c[j+(k<<3)>>2]|0;m=c[j+(k<<3)+4>>2]|0;if(l>>>0>m>>>0)D$a(l,m,d,e,f,g)|0;else E$a(l,m,d,e,f,g);k=k+1|0}while((k|0)!=(h|0))}h=c[a+328>>2]|0;k=c[a+324>>2]|0;if(h){j=0;do{m=c[k+(j<<3)>>2]|0;l=c[k+(j<<3)+4>>2]|0;if(m>>>0>l>>>0)D$a(m,l,d,e,f,g)|0;else E$a(m,l,d,e,f,g);j=j+1|0}while((j|0)!=(h|0))}h=c[a+368>>2]|0;j=c[a+364>>2]|0;if(h){k=0;do{l=c[j+(k<<3)>>2]|0;m=c[j+(k<<3)+4>>2]|0;if(l>>>0>m>>>0)D$a(l,m,d,e,f,g)|0;else E$a(l,m,d,e,f,g);k=k+1|0}while((k|0)!=(h|0))}Cra(a);Ura(c[a+104>>2]|0,c[e>>2]|0,c[f>>2]|0,a+232|0,a+236|0,a+240|0,a+244|0,a+248|0,a+252|0,d);c[a+172>>2]=c[a+168>>2];i=b;return}function Cra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;b=i;i=i+576|0;d=b+540|0;e=b+408|0;f=b+276|0;g=b+144|0;h=b+12|0;j=b;k=a+80|0;l=c[k>>2]|0;if(!l){i=b;return}m=c[a+76>>2]|0;n=c[a+100>>2]|0;o=l<<1;p=e+128|0;q=o>>>0<33;if(q)r=e;else r=UJa(d,l<<3,484800,56)|0;c[p>>2]=r;r=f+128|0;if(q)s=f;else s=UJa(d,l<<3,484800,56)|0;c[r>>2]=s;s=g+128|0;if(q)t=g;else t=UJa(d,l<<3,484800,56)|0;c[s>>2]=t;u=h+128|0;if(q){v=h;w=t}else{t=UJa(d,l<<3,484800,56)|0;v=t;w=c[s>>2]|0}c[u>>2]=v;t=c[p>>2]|0;q=c[r>>2]|0;KMa(d);x=(o|0)==0;y=a+168|0;z=o+-1|0;A=l<<1;B=0;do{C=B+3|0;D=0;do{E=c[m+(D<<2)>>2]|0;F=c[n+(E*24|0)+(C<<2)>>2]|0;G=D<<1;c[t+(G<<2)>>2]=c[n+(E*24|0)+(B<<2)>>2];H=E<<1;c[w+(G<<2)>>2]=H;E=G|1;c[t+(E<<2)>>2]=F;c[w+(E<<2)>>2]=H|1;D=D+1|0}while((D|0)!=(l|0));if(!x){D=0;do{c[q+(D<<2)>>2]=c[t+(D<<2)>>2];D=D+1|0}while((D|0)!=(A|0));D=c[(NMa(d,q,o,1)|0)+8>>2]|0;if(!x){C=0;do{H=D+(z-C<<2)|0;c[q+(C<<2)>>2]=c[t+(c[H>>2]<<2)>>2];c[v+(C<<2)>>2]=c[w+(c[H>>2]<<2)>>2];C=C+1|0}while((C|0)!=(A|0))}}else NMa(d,q,o,1)|0;C=c[a+(B<<2)+124>>2]|0;D=c[a+(B<<2)+136>>2]|0;H=(c[y>>2]|0)-(c[k>>2]|0)<<1;E=c[a+(B<<2)+112>>2]|0;F=H+o|0;G=H|1;I=F|1;c[C+(I<<2)>>2]=c[C+(G<<2)>>2];c[D+(I<<2)>>2]=c[D+(G<<2)>>2];a:do if((H|0)>=0){G=0;I=D+(H<<2)|0;J=C+(H<<2)|0;K=F;while(1){L=G;M=K;while(1){N=v+(L<<2)|0;O=c[J>>2]|0;P=c[q+(L<<2)>>2]|0;Q=(c[N>>2]&1|0)!=0?O>>>0<=P>>>0:O>>>0<P>>>0;R=Q?N:I;c[C+(M<<2)>>2]=Q?P:O;c[D+(M<<2)>>2]=c[R>>2];O=M;M=M+-1|0;P=c[R>>2]|0;c[E+(P>>>1<<3)+((P&1)<<2)>>2]=O;if(!Q)break;Q=L+1|0;if(Q>>>0>=o>>>0)break a;else L=Q}I=I+-4|0;if(I>>>0<D>>>0)break;else{G=L;J=J+-4|0;K=M}}}while(0);B=B+1|0}while((B|0)!=3);MMa(d);B=c[u>>2]|0;if((B|0)!=(h|0))VJa(d,B);B=c[s>>2]|0;if((B|0)!=(g|0))VJa(d,B);B=c[r>>2]|0;if((B|0)!=(f|0))VJa(d,B);B=c[p>>2]|0;if((B|0)!=(e|0))VJa(d,B);c[j>>2]=0;c[j+4>>2]=1;c[j+8>>2]=2;Hra(a,j);i=b;return}function Dra(a){a=a|0;var b=0,d=0;b=i;d=a+32|0;c[d>>2]=0;Era(c[a+20>>2]|0,c[a+24>>2]|0,a+28|0,d,a+36|0);i=b;return}function Era(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;h=i;i=i+32|0;j=h+25|0;k=h+24|0;l=h;m=b+96|0;n=c[m>>2]|0;if(!n){i=h;return}if((n*5|0)>>>0<(c[b+168>>2]|0)>>>0){Ira(b,d,e,f,g);i=h;return}n=c[g>>2]|0;o=c[b+100>>2]|0;p=c[b+116>>2]|0;c[l>>2]=p;q=c[b+120>>2]|0;c[l+4>>2]=q;c[l+8>>2]=q;q=c[b+112>>2]|0;c[l+12>>2]=q;c[l+16>>2]=q;c[l+20>>2]=p;p=d<<1;q=c[l+(p<<2)>>2]|0;r=c[l+((p|1)<<2)>>2]|0;p=c[b+104>>2]|0;l=c[b+(d<<2)+112>>2]|0;s=c[b+(d<<2)+124>>2]|0;t=c[b+(d<<2)+136>>2]|0;u=c[b+148>>2]|0;v=c[t+4>>2]|0;if((v&-2|0)==1073741822){i=h;return}w=v>>>1;c[s+4>>2]=c[o+(w*24|0)+(d<<2)>>2];v=c[m>>2]|0;m=u+w|0;w=a[m>>0]|0;x=b+156|0;y=c[x>>2]|0;c[y+4>>2]=0;c[y>>2]=0;z=c[t+8>>2]|0;a:do if((z&-2|0)==1073741822){A=y;B=y;C=n;D=0}else{E=b+164|0;F=d+3|0;G=b+160|0;H=y;I=z;J=y;K=2;L=n;M=0;N=(v<<1)-(w&255)|0;O=a[m>>0]|0;while(1){P=I>>>1;Q=a[u+P>>0]|0;if(!((Q|O)<<24>>24))if(!N){A=H;B=J;C=L;D=M;break a}else{R=H;S=J;T=L;U=M;V=N;W=O}else{X=N-(Q&255)|0;Y=I&1;Z=c[o+(P*24|0)+((0-Y&3)+d<<2)>>2]|0;c[s+(K<<2)>>2]=Z;_=c[E>>2]|0;$=c[_+(K<<2)>>2]|0;if((c[s+($<<2)>>2]|0)>>>0>Z>>>0){aa=c[o+(P*24|0)+(F<<2)>>2]|0;ba=c[p+(P<<2)>>2]|0;ca=q+(P<<3)|0;da=q+(P<<3)+4|0;ea=r+(P<<3)|0;fa=r+(P<<3)+4|0;if(!Y){Y=_;ga=$;ha=L;ia=M;ja=K;while(1){ka=c[t+(ga<<2)>>2]|0;if((((ka&1|0)!=0?(la=ka>>>1,(c[s+(c[l+(la<<3)>>2]<<2)>>2]|0)>>>0<aa>>>0):0)?((c[da>>2]|0)>>>0>(c[q+(la<<3)>>2]|0)>>>0?(c[q+(la<<3)+4>>2]|0)>>>0>(c[ca>>2]|0)>>>0:0)&(c[fa>>2]|0)>>>0>(c[r+(la<<3)>>2]|0)>>>0&(c[r+(la<<3)+4>>2]|0)>>>0>(c[ea>>2]|0)>>>0:0)?(ba|0)!=(c[p+(la<<2)>>2]|0):0){if((ia|0)==(ha|0)){ka=c[e>>2]|0;ma=UJa(j,ha<<4,484656,1503)|0;YEi(ma|0,ka|0,ha<<3|0)|0;VJa(k,ka);c[e>>2]=ma;na=c[E>>2]|0;oa=ma;pa=ha<<1}else{na=Y;oa=c[e>>2]|0;pa=ha}ma=P>>>0<la>>>0;c[oa+(ia<<3)>>2]=ma?la:P;c[oa+(ia<<3)+4>>2]=ma?P:la;qa=na;ra=pa;sa=ia+1|0}else{qa=Y;ra=ha;sa=ia}la=ja+-1|0;ma=c[qa+(ga<<2)>>2]|0;if(Z>>>0<(c[s+(ma<<2)>>2]|0)>>>0){Y=qa;ga=ma;ha=ra;ia=sa;ja=la}else{ta=qa;ua=ma;va=ra;wa=sa;xa=la;break}}}else{ja=_;ia=$;ha=L;ga=M;Y=K;while(1){aa=c[t+(ia<<2)>>2]|0;if(((aa&1|0)==0?(la=aa>>>1,((c[da>>2]|0)>>>0>(c[q+(la<<3)>>2]|0)>>>0?(c[q+(la<<3)+4>>2]|0)>>>0>(c[ca>>2]|0)>>>0:0)&(c[fa>>2]|0)>>>0>(c[r+(la<<3)>>2]|0)>>>0&(c[r+(la<<3)+4>>2]|0)>>>0>(c[ea>>2]|0)>>>0):0)?(ba|0)!=(c[p+(la<<2)>>2]|0):0){if((ga|0)==(ha|0)){aa=c[e>>2]|0;ma=UJa(j,ha<<4,484656,1503)|0;YEi(ma|0,aa|0,ha<<3|0)|0;VJa(k,aa);c[e>>2]=ma;ya=c[E>>2]|0;za=ma;Aa=ha<<1}else{ya=ja;za=c[e>>2]|0;Aa=ha}ma=P>>>0<la>>>0;c[za+(ga<<3)>>2]=ma?P:la;c[za+(ga<<3)+4>>2]=ma?la:P;Ba=ya;Ca=Aa;Da=ga+1|0}else{Ba=ja;Ca=ha;Da=ga}la=Y+-1|0;ma=c[Ba+(ia<<2)>>2]|0;if(Z>>>0<(c[s+(ma<<2)>>2]|0)>>>0){ja=Ba;ia=ma;ha=Ca;ga=Da;Y=la}else{ta=Ba;ua=ma;va=Ca;wa=Da;xa=la;break}}}Y=c[G>>2]|0;ga=Y+(K<<2)|0;ha=c[ga>>2]|0;ia=ta+(K<<2)|0;ja=c[ia>>2]|0;Z=Y+(ua<<2)|0;P=c[Z>>2]|0;c[Y+(ja<<2)>>2]=ha;c[ta+(ha<<2)>>2]=ja;c[ga>>2]=P;c[ia>>2]=ua;c[ta+(P<<2)>>2]=K;c[Z>>2]=K;Z=J;while(1)if(xa>>>0<(c[Z>>2]|0)>>>0)Z=Z+-8|0;else break;P=c[x>>2]|0;if((Z|0)!=(P|0)?xa>>>0<=((c[Z+4>>2]|0)+1|0)>>>0:0)Ea=Z;else{ia=Z+8|0;c[ia>>2]=xa;Ea=ia}c[Ea+4>>2]=K;R=P;S=Ea;T=va;U=wa;V=X;W=1}else{R=H;S=J;T=L;U=M;V=X;W=Q}}K=K+1|0;I=c[t+(K<<2)>>2]|0;if((I&-2|0)==1073741822){A=R;B=S;C=T;D=U;break}else{H=R;J=S;L=T;M=U;N=V;O=W}}}while(0);c[f>>2]=D;c[g>>2]=C;C=A+8|0;g=b+164|0;if(C>>>0<=B>>>0){D=b+160|0;b=A;A=C;while(1){C=c[A>>2]|0;f=b+12|0;W=c[f>>2]|0;if(C>>>0>W>>>0){Fa=C;Ga=W}else{W=c[g>>2]|0;V=C;do{c[W+(V<<2)>>2]=V;V=V+1|0;Ha=c[f>>2]|0}while(V>>>0<=Ha>>>0);Fa=c[A>>2]|0;Ga=Ha}if(Fa>>>0>Ga>>>0){Ia=Fa;Ja=Ga}else{V=c[D>>2]|0;W=c[g>>2]|0;C=Ga;U=Fa+-1|0;T=Fa;while(1){U=c[V+(U<<2)>>2]|0;S=c[W+(U<<2)>>2]|0;if((U|0)==(T|0))Ka=C;else{R=t+(S<<2)|0;wa=c[R>>2]|0;va=s+(T<<2)|0;Ea=c[va>>2]|0;xa=t+(T<<2)|0;x=c[xa>>2]|0;ta=s+(S<<2)|0;c[va>>2]=c[ta>>2];c[xa>>2]=c[R>>2];c[ta>>2]=Ea;c[R>>2]=x;x=W+(T<<2)|0;c[W+(S<<2)>>2]=c[x>>2];c[W+(c[x>>2]<<2)>>2]=S;c[l+(wa>>>1<<3)+((wa&1)<<2)>>2]=T;Ka=c[f>>2]|0}T=T+1|0;if(T>>>0>Ka>>>0)break;else C=Ka}Ia=c[A>>2]|0;Ja=Ka}C=Ia+-1|0;if(C>>>0<=Ja>>>0){T=c[g>>2]|0;W=c[D>>2]|0;U=C;do{C=U;U=U+1|0;c[T+(U<<2)>>2]=C;c[W+(C<<2)>>2]=U}while(U>>>0<=(c[f>>2]|0)>>>0)}f=A+8|0;if(f>>>0>B>>>0)break;else{U=A;A=f;b=U}}}c[c[g>>2]>>2]=0;i=h;return}function Fra(a,b){a=a|0;b=b|0;var d=0;b=i;Gra(a);d=a+256|0;ko[c[(c[d>>2]|0)+32>>2]&4095](d);d=a+296|0;ko[c[(c[d>>2]|0)+32>>2]&4095](d);d=a+336|0;ko[c[(c[d>>2]|0)+32>>2]&4095](d);i=b;return}function Gra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;i=i+544|0;d=b+528|0;e=b+12|0;f=b;g=a+88|0;h=c[g>>2]|0;if(!h){i=b;return}j=a+168|0;k=c[j>>2]|0;l=a+172|0;c[j>>2]=c[l>>2];m=a+84|0;n=h;h=0;do{o=c[a+(h<<2)+124>>2]|0;p=c[a+(h<<2)+136>>2]|0;if(!n)q=-1;else{r=c[m>>2]|0;s=c[a+(h<<2)+112>>2]|0;t=-1;u=0;while(1){v=c[r+(u<<2)>>2]|0;w=c[s+(v<<3)>>2]|0;x=c[s+(v<<3)+4>>2]|0;c[p+(w<<2)>>2]=1073741821;c[p+(x<<2)>>2]=1073741821;x=w>>>0<t>>>0?w:t;u=u+1|0;if(u>>>0>=(c[g>>2]|0)>>>0){q=x;break}else t=x}}t=(c[j>>2]<<1)+2|0;a:do if((q|0)!=(t|0)){u=a+(h<<2)+112|0;s=q;r=q;while(1){if((r|0)==(t|0))break a;else y=r;while(1){z=p+(y<<2)|0;if((c[z>>2]|0)!=1073741821)break;x=y+1|0;if((x|0)==(t|0))break a;else y=x}if((y|0)!=(s|0)?(c[o+(s<<2)>>2]=c[o+(y<<2)>>2],x=c[z>>2]|0,c[p+(s<<2)>>2]=x,(x&-2|0)!=1073741822):0)c[(c[u>>2]|0)+(x>>>1<<3)+((x&1)<<2)>>2]=s;x=y+1|0;if((x|0)==(t|0))break;else{s=s+1|0;r=x}}}while(0);h=h+1|0;n=c[g>>2]|0}while((h|0)!=3);if(n){n=c[m>>2]|0;h=c[a+112>>2]|0;y=c[a+116>>2]|0;z=c[a+120>>2]|0;q=0;do{t=c[n+(q<<2)>>2]|0;c[h+(t<<3)>>2]=1073741821;c[h+(t<<3)+4>>2]=1073741821;c[y+(t<<3)>>2]=1073741821;c[y+(t<<3)+4>>2]=1073741821;c[z+(t<<3)>>2]=1073741821;c[z+(t<<3)+4>>2]=1073741821;q=q+1|0}while(q>>>0<(c[g>>2]|0)>>>0)}q=((c[a+108>>2]|0)>>>5)+1|0;z=e+512|0;if(q>>>0<129){A=q<<2;B=e}else{y=q<<2;A=y;B=UJa(d,y,484800,56)|0}c[z>>2]=B;PEi(B|0,0,A|0)|0;A=f+4|0;B=c[z>>2]|0;c[f>>2]=B;c[A>>2]=q|-2147483648;if(c[g>>2]|0){q=c[m>>2]|0;m=0;do{y=c[q+(m<<2)>>2]|0;h=B+(y>>>5<<2)|0;c[h>>2]=c[h>>2]|1<<(y&31);m=m+1|0}while(m>>>0<(c[g>>2]|0)>>>0)}Tra(a+192|0,f)|0;m=k-(c[g>>2]|0)|0;c[j>>2]=m;c[l>>2]=m-(c[a+80>>2]|0);a=c[f>>2]|0;if((a|0)!=0&(c[A>>2]|0)>-1)VJa(f+8|0,a);a=c[z>>2]|0;if((a|0)==(e|0)){i=b;return}VJa(d,a);i=b;return}function Hra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+208|0;f=e+204|0;g=e+200|0;h=e+201|0;j=e+160|0;k=e+4|0;l=e;m=e+196|0;n=e+40|0;o=e+76|0;p=e+203|0;q=e+202|0;r=e+124|0;s=e+88|0;t=c[d>>2]|0;u=b+80|0;v=c[u>>2]|0;w=b+168|0;x=c[w>>2]|0;y=x-v|0;z=j+32|0;A=y>>>0<9;if(A)B=j;else B=UJa(f,y<<2,484800,56)|0;c[z>>2]=B;C=k+32|0;if(v>>>0<9){D=k;E=B}else{B=UJa(f,v<<2,484800,56)|0;D=B;E=c[z>>2]|0}c[C>>2]=D;c[l>>2]=0;c[m>>2]=0;B=(c[b+108>>2]<<1)+31|0;F=B>>>5;G=n+32|0;if(B>>>0<288){H=F<<2;I=n}else{B=F<<2;H=B;I=UJa(f,B,484800,56)|0}c[G>>2]=I;PEi(I|0,0,H|0)|0;H=o+4|0;c[o>>2]=I;c[H>>2]=F|-2147483648;a[p>>0]=0;a[q>>0]=0;F=b+112|0;I=b+104|0;Vra(o,0,c[u>>2]|0,c[b+76>>2]|0,F,c[I>>2]|0,c[b+(t<<2)+124>>2]|0,c[b+(t<<2)+136>>2]|0,(c[w>>2]<<1)+2|0,d,D,m,E,l,p,q);w=a[p>>0]|0;if(w<<24>>24==0|(a[q>>0]|0)==0){q=v+1|0;t=r+32|0;if(q>>>0<9){J=r;K=w}else{w=UJa(f,q<<2,484800,56)|0;J=w;K=a[p>>0]|0}c[t>>2]=J;p=b+192|0;w=b+180|0;q=b+184|0;u=b+188|0;Wra(d,D,c[m>>2]|0,K<<24>>24!=0,J,F,c[I>>2]|0,p,w,q,u);if((x|0)!=(v|0)){v=s+32|0;if(A){L=s;M=s}else{L=s;M=UJa(f,y<<2,484800,56)|0}c[v>>2]=M;Xra(d,D,c[m>>2]|0,E,c[l>>2]|0,J,M,F,c[I>>2]|0,p,w,q,u);u=c[v>>2]|0;if((u|0)!=(L|0))VJa(f,u)}u=c[t>>2]|0;if((u|0)!=(r|0))VJa(g,u)}u=c[o>>2]|0;if((u|0)!=0&(c[H>>2]|0)>-1)VJa(o+8|0,u);u=c[G>>2]|0;if((u|0)!=(n|0))VJa(h,u);u=c[C>>2]|0;if((u|0)!=(k|0))VJa(h,u);u=c[z>>2]|0;if((u|0)==(j|0)){i=e;return}VJa(h,u);i=e;return}function Ira(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;h=i;i=i+32|0;j=h+25|0;k=h+24|0;l=h;m=c[g>>2]|0;n=c[b+100>>2]|0;o=c[b+116>>2]|0;c[l>>2]=o;p=c[b+120>>2]|0;c[l+4>>2]=p;c[l+8>>2]=p;p=c[b+112>>2]|0;c[l+12>>2]=p;c[l+16>>2]=p;c[l+20>>2]=o;o=c[b+104>>2]|0;p=c[b+(d<<2)+112>>2]|0;q=c[b+(d<<2)+124>>2]|0;r=c[b+(d<<2)+136>>2]|0;s=d<<1;t=c[l+(s<<2)>>2]|0;u=c[l+((s|1)<<2)>>2]|0;s=c[b+148>>2]|0;l=c[b+168>>2]<<1|1;v=c[r+4>>2]|0;if((v&-2|0)==1073741822){i=h;return}w=b+96|0;x=c[w>>2]|0;a:do if(x>>>0>=512)if((l|0)==1)y=0;else{z=b+152|0;A=v;B=0;C=1;while(1){if((A&-2|0)==1073741822){y=B;break a}D=A>>>1;if(!(a[s+D>>0]|0))E=B;else{c[q+(C<<2)>>2]=c[n+(D*24|0)+((0-(A&1)&3)+d<<2)>>2];c[(c[z>>2]|0)+(B<<2)>>2]=C;E=B+1|0}D=C+1|0;if(D>>>0>=l>>>0){y=E;break a}A=c[r+(D<<2)>>2]|0;B=E;C=D}}else{if(!x){F=c[b+152>>2]|0;G=0}else{C=c[b+92>>2]|0;B=d+3|0;A=c[b+152>>2]|0;z=0;D=0;while(1){H=c[C+(z<<2)>>2]|0;I=c[n+(H*24|0)+(B<<2)>>2]|0;J=p+(H<<3)|0;c[q+(c[J>>2]<<2)>>2]=c[n+(H*24|0)+(d<<2)>>2];K=p+(H<<3)+4|0;c[q+(c[K>>2]<<2)>>2]=I;c[A+(D<<2)>>2]=c[J>>2];J=D+2|0;c[A+((D|1)<<2)>>2]=c[K>>2];z=z+1|0;if(z>>>0>=(c[w>>2]|0)>>>0){F=A;G=J;break}else D=J}}F$a(F,G,j,k);y=G}while(0);G=b+156|0;F=c[G>>2]|0;c[F+4>>2]=0;c[F>>2]=0;if(!y){L=F;M=F;N=m;O=0}else{w=b+152|0;x=d+3|0;d=b+164|0;E=b+160|0;l=c[d>>2]|0;v=F;D=0;A=F;F=m;m=0;while(1){z=c[(c[w>>2]|0)+(D<<2)>>2]|0;B=c[r+(z<<2)>>2]|0;C=c[l+(z<<2)>>2]|0;J=l;K=v;I=A;H=z;z=F;P=m;while(1){Q=B>>>1;R=c[q+(H<<2)>>2]|0;S=c[n+(Q*24|0)+(x<<2)>>2]|0;if((c[q+(C<<2)>>2]|0)>>>0>R>>>0){T=c[o+(Q<<2)>>2]|0;U=t+(Q<<3)|0;V=t+(Q<<3)+4|0;W=u+(Q<<3)|0;X=u+(Q<<3)+4|0;if(!(B&1)){Y=J;Z=C;_=z;$=P;aa=H;while(1){ba=c[r+(Z<<2)>>2]|0;if((((ba&1|0)!=0?(ca=ba>>>1,(c[q+(c[p+(ca<<3)>>2]<<2)>>2]|0)>>>0<S>>>0):0)?((c[V>>2]|0)>>>0>(c[t+(ca<<3)>>2]|0)>>>0?(c[t+(ca<<3)+4>>2]|0)>>>0>(c[U>>2]|0)>>>0:0)&(c[X>>2]|0)>>>0>(c[u+(ca<<3)>>2]|0)>>>0&(c[u+(ca<<3)+4>>2]|0)>>>0>(c[W>>2]|0)>>>0:0)?(T|0)!=(c[o+(ca<<2)>>2]|0):0){if(($|0)==(_|0)){ba=c[e>>2]|0;da=UJa(j,_<<4,484656,1503)|0;YEi(da|0,ba|0,_<<3|0)|0;VJa(k,ba);c[e>>2]=da;ea=c[d>>2]|0;fa=_<<1}else{ea=Y;fa=_}da=Q>>>0<ca>>>0;ba=c[e>>2]|0;c[ba+($<<3)>>2]=da?ca:Q;c[ba+($<<3)+4>>2]=da?Q:ca;ga=ea;ha=fa;ia=$+1|0}else{ga=Y;ha=_;ia=$}ca=aa+-1|0;da=c[ga+(Z<<2)>>2]|0;if(R>>>0<(c[q+(da<<2)>>2]|0)>>>0){Y=ga;Z=da;_=ha;$=ia;aa=ca}else{ja=ga;ka=da;la=ha;ma=ia;na=ca;break}}}else{aa=J;$=C;_=z;Z=P;Y=H;while(1){S=c[r+($<<2)>>2]|0;if(((S&1|0)==0?(ca=S>>>1,((c[V>>2]|0)>>>0>(c[t+(ca<<3)>>2]|0)>>>0?(c[t+(ca<<3)+4>>2]|0)>>>0>(c[U>>2]|0)>>>0:0)&(c[X>>2]|0)>>>0>(c[u+(ca<<3)>>2]|0)>>>0&(c[u+(ca<<3)+4>>2]|0)>>>0>(c[W>>2]|0)>>>0):0)?(T|0)!=(c[o+(ca<<2)>>2]|0):0){if((Z|0)==(_|0)){S=c[e>>2]|0;da=UJa(j,_<<4,484656,1503)|0;YEi(da|0,S|0,_<<3|0)|0;VJa(k,S);c[e>>2]=da;oa=c[d>>2]|0;pa=_<<1}else{oa=aa;pa=_}da=Q>>>0<ca>>>0;S=c[e>>2]|0;c[S+(Z<<3)>>2]=da?Q:ca;c[S+(Z<<3)+4>>2]=da?ca:Q;qa=oa;ra=pa;sa=Z+1|0}else{qa=aa;ra=_;sa=Z}ca=Y+-1|0;da=c[qa+($<<2)>>2]|0;if(R>>>0<(c[q+(da<<2)>>2]|0)>>>0){aa=qa;$=da;_=ra;Z=sa;Y=ca}else{ja=qa;ka=da;la=ra;ma=sa;na=ca;break}}}Y=c[E>>2]|0;Z=Y+(H<<2)|0;_=c[Z>>2]|0;$=ja+(H<<2)|0;aa=c[$>>2]|0;R=Y+(ka<<2)|0;Q=c[R>>2]|0;c[Y+(aa<<2)>>2]=_;c[ja+(_<<2)>>2]=aa;c[Z>>2]=Q;c[$>>2]=ka;c[ja+(Q<<2)>>2]=H;c[R>>2]=H;R=I;while(1)if(na>>>0<(c[R>>2]|0)>>>0)R=R+-8|0;else break;Q=c[G>>2]|0;if((R|0)!=(Q|0)?na>>>0<=((c[R+4>>2]|0)+1|0)>>>0:0)ta=R;else{$=R+8|0;c[$>>2]=na;ta=$}c[ta+4>>2]=H;ua=ja;va=Q;wa=ta;xa=la;ya=ma}else{ua=J;va=K;wa=I;xa=z;ya=P}H=H+1|0;B=c[r+(H<<2)>>2]|0;C=c[ua+(H<<2)>>2]|0;if((B&-2|0)==1073741822)break;if(a[s+(B>>>1)>>0]|0)break;if(!(a[s+((c[r+(C<<2)>>2]|0)>>>1)>>0]|0))break;else{J=ua;K=va;I=wa;z=xa;P=ya}}D=D+1|0;if((D|0)==(y|0)){L=va;M=wa;N=xa;O=ya;break}else{l=ua;v=va;A=wa;F=xa;m=ya}}}c[f>>2]=O;c[g>>2]=N;N=L+8|0;if(N>>>0>M>>>0){i=h;return}g=b+164|0;O=b+160|0;b=L;L=N;while(1){N=c[L>>2]|0;f=b+12|0;ya=c[f>>2]|0;if(N>>>0>ya>>>0){za=N;Aa=ya}else{ya=c[g>>2]|0;m=N;do{c[ya+(m<<2)>>2]=m;m=m+1|0;Ba=c[f>>2]|0}while(m>>>0<=Ba>>>0);za=c[L>>2]|0;Aa=Ba}if(za>>>0>Aa>>>0){Ca=za;Da=Aa}else{m=c[O>>2]|0;ya=c[g>>2]|0;N=Aa;xa=za+-1|0;F=za;while(1){xa=c[m+(xa<<2)>>2]|0;wa=c[ya+(xa<<2)>>2]|0;if((xa|0)==(F|0))Ea=N;else{A=r+(wa<<2)|0;va=c[A>>2]|0;v=q+(F<<2)|0;ua=c[v>>2]|0;l=r+(F<<2)|0;y=c[l>>2]|0;D=q+(wa<<2)|0;c[v>>2]=c[D>>2];c[l>>2]=c[A>>2];c[D>>2]=ua;c[A>>2]=y;y=ya+(F<<2)|0;c[ya+(wa<<2)>>2]=c[y>>2];c[ya+(c[y>>2]<<2)>>2]=wa;c[p+(va>>>1<<3)+((va&1)<<2)>>2]=F;Ea=c[f>>2]|0}F=F+1|0;if(F>>>0>Ea>>>0)break;else N=Ea}Ca=c[L>>2]|0;Da=Ea}N=Ca+-1|0;if(N>>>0<=Da>>>0){F=c[g>>2]|0;ya=c[O>>2]|0;xa=N;do{N=xa;xa=xa+1|0;c[F+(xa<<2)>>2]=N;c[ya+(N<<2)>>2]=xa}while(xa>>>0<=(c[f>>2]|0)>>>0)}f=L+8|0;if(f>>>0>M>>>0)break;else{xa=L;L=f;b=xa}}i=h;return}function Jra(a){a=a|0;var b=0,d=0;b=i;d=a+0|0;a=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function Kra(a){a=a|0;return}function Lra(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=(b<<2)+15&-16;c[a>>2]=UJa(d+3|0,e,485040,105)|0;c[a+4>>2]=UJa(d+2|0,e,485040,106)|0;c[a+20>>2]=UJa(d+1|0,(b<<3)+15&-16,485040,107)|0;c[a+24>>2]=UJa(d,b+15&-16,485040,108)|0;c[a+12>>2]=b;c[a+16>>2]=b;c[a+32>>2]=b;i=d;return}function Mra(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;VJa(b+3|0,c[a>>2]|0);VJa(b+2|0,c[a+4>>2]|0);VJa(b+1|0,c[a+20>>2]|0);VJa(b,c[a+24>>2]|0);d=a+0|0;a=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function Nra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!(c[a+8>>2]|0)){f=0;i=e;return f|0}g=b>>>0>d>>>0;h=g?d:b;j=g?b:d;d=j<<16|h;b=d+~(d<<15)|0;d=(b>>10^b)*9|0;b=d>>6^d;d=b+~(b<<11)|0;b=c[(c[a>>2]|0)+((c[a+36>>2]&(d>>16^d))<<2)>>2]|0;if((b|0)==1073741823){f=0;i=e;return f|0}d=c[a+20>>2]|0;g=a+4|0;a=b;while(1){if((c[d+(a<<3)>>2]|0)==(h|0)?(c[d+(a<<3)+4>>2]|0)==(j|0):0)break;b=c[(c[g>>2]|0)+(a<<2)>>2]|0;if((b|0)==1073741823){f=0;k=8;break}else a=b}if((k|0)==8){i=e;return f|0}f=d+(a<<3)|0;i=e;return f|0}function Ora(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=b+28|0;j=c[h>>2]|0;if((j|0)==1073741823){k=0;i=g;return k|0}l=d>>>0>e>>>0;m=l?e:d;n=l?d:e;e=n<<16|m;d=e+~(e<<15)|0;e=(d>>10^d)*9|0;d=e>>6^e;e=d+~(d<<11)|0;d=e>>16^e;e=b+36|0;l=c[e>>2]&d;o=b+8|0;p=c[o>>2]|0;a:do if((p|0)!=0?(q=c[(c[b>>2]|0)+(l<<2)>>2]|0,(q|0)!=1073741823):0){r=c[b+20>>2]|0;s=b+4|0;t=q;while(1){if((c[r+(t<<3)>>2]|0)==(m|0)?(c[r+(t<<3)+4>>2]|0)==(n|0):0)break;q=c[(c[s>>2]|0)+(t<<2)>>2]|0;if((q|0)==1073741823)break a;else t=q}s=r+(t<<3)|0;if(s){k=s;i=g;return k|0}}while(0);if(j>>>0<p>>>0){u=j;v=l}else{l=j+1|0;j=l>>>1|l;l=j>>>2|j;j=l>>>4|l;l=j>>>8|j;j=l>>>16|l;l=j+1|0;c[o>>2]=l;c[e>>2]=j;Pra(b,l>>>0>(c[b+12>>2]|0)>>>0);u=c[h>>2]|0;v=c[e>>2]&d}d=c[b+20>>2]|0;e=d+(u<<3)|0;c[e>>2]=m;c[d+(u<<3)+4>>2]=n;a[(c[b+24>>2]|0)+(c[h>>2]|0)>>0]=f;f=(c[b>>2]|0)+(v<<2)|0;c[(c[b+4>>2]|0)+(c[h>>2]<<2)>>2]=c[f>>2];b=c[h>>2]|0;c[h>>2]=b+1;c[f>>2]=b;k=e;i=g;return k|0}function Pra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+1|0;f=d+4|0;g=d+2|0;h=d+5|0;j=d+7|0;k=d;l=d+3|0;m=d+6|0;if(!b){b=a+8|0;if(c[b>>2]|0){n=c[a>>2]|0;o=0;do{c[n+(o<<2)>>2]=1073741823;o=o+1|0}while(o>>>0<(c[b>>2]|0)>>>0)}b=a+28|0;if(!(c[b>>2]|0)){i=d;return}o=c[a+20>>2]|0;n=a+36|0;p=c[a>>2]|0;q=c[a+4>>2]|0;r=0;do{s=c[o+(r<<3)+4>>2]<<16|c[o+(r<<3)>>2];t=s+~(s<<15)|0;s=(t>>10^t)*9|0;t=s>>6^s;s=t+~(t<<11)|0;t=p+(((s>>16^s)&c[n>>2])<<2)|0;c[q+(r<<2)>>2]=c[t>>2];c[t>>2]=r;r=r+1|0}while(r>>>0<(c[b>>2]|0)>>>0);i=d;return}VJa(e,c[a>>2]|0);e=a+8|0;b=c[e>>2]|0;c[a+12>>2]=b;c[a+32>>2]=b;r=UJa(f,b<<2,485040,456)|0;c[a>>2]=r;if(!(c[e>>2]|0))u=0;else{b=0;do{c[r+(b<<2)>>2]=1073741823;b=b+1|0;v=c[e>>2]|0}while(b>>>0<v>>>0);u=v<<3}v=UJa(g,u,485040,464)|0;u=UJa(h,c[e>>2]<<2,485040,465)|0;h=UJa(j,c[e>>2]|0,485040,466)|0;e=a+28|0;j=c[e>>2]|0;if(((j|0)!=0?(YEi(v|0,c[a+20>>2]|0,j<<3|0)|0,j=c[e>>2]|0,(j|0)!=0):0)?(YEi(h|0,c[a+24>>2]|0,j|0)|0,(c[e>>2]|0)!=0):0){j=a+20|0;g=c[j>>2]|0;b=a+36|0;r=c[a>>2]|0;f=0;do{q=c[g+(f<<3)+4>>2]<<16|c[g+(f<<3)>>2];n=q+~(q<<15)|0;q=(n>>10^n)*9|0;n=q>>6^q;q=n+~(n<<11)|0;n=r+(((q>>16^q)&c[b>>2])<<2)|0;c[u+(f<<2)>>2]=c[n>>2];c[n>>2]=f;f=f+1|0}while(f>>>0<(c[e>>2]|0)>>>0);w=j}else w=a+20|0;j=a+4|0;VJa(k,c[j>>2]|0);VJa(l,c[w>>2]|0);l=a+24|0;VJa(m,c[l>>2]|0);c[w>>2]=v;c[l>>2]=h;c[j>>2]=u;i=d;return}function Qra(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;d=c[b>>2]|0;h=d+(f<<2)|0;f=c[h>>2]|0;j=c[b+4>>2]|0;if((f|0)!=(g|0)){k=f;while(1){f=c[j+(k<<2)>>2]|0;if((f|0)==(g|0))break;else k=f}f=b+4|0;l=c[j+(g<<2)>>2]|0;if((k|0)==1073741823){m=l;n=f;o=6}else{c[j+(k<<2)>>2]=l;p=f}}else{m=c[j+(g<<2)>>2]|0;n=b+4|0;o=6}if((o|0)==6){c[h>>2]=m;p=n}n=b+28|0;m=c[n>>2]|0;h=m+-1|0;if((h|0)==(g|0)){q=m;r=q+-1|0;c[n>>2]=r;i=e;return}m=c[b+20>>2]|0;f=c[m+(h<<3)+4>>2]<<16|c[m+(h<<3)>>2];l=f+~(f<<15)|0;f=(l>>10^l)*9|0;l=f>>6^f;f=l+~(l<<11)|0;l=(f>>16^f)&c[b+36>>2];f=d+(l<<2)|0;d=c[f>>2]|0;if((d|0)!=(h|0)){k=d;while(1){d=c[j+(k<<2)>>2]|0;if((d|0)==(h|0))break;else k=d}d=c[j+(h<<2)>>2]|0;if((k|0)==1073741823){s=d;o=13}else c[j+(k<<2)>>2]=d}else{s=c[j+(h<<2)>>2]|0;o=13}if((o|0)==13)c[f>>2]=s;s=m+(h<<3)|0;f=c[s+4>>2]|0;o=m+(g<<3)|0;c[o>>2]=c[s>>2];c[o+4>>2]=f;f=c[b+24>>2]|0;a[f+g>>0]=a[f+h>>0]|0;h=(c[b>>2]|0)+(l<<2)|0;c[(c[p>>2]|0)+(g<<2)>>2]=c[h>>2];c[h>>2]=g;q=c[n>>2]|0;r=q+-1|0;c[n>>2]=r;i=e;return}function Rra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b>>>0>d>>>0;g=f?d:b;h=f?b:d;d=h<<16|g;b=d+~(d<<15)|0;d=(b>>10^b)*9|0;b=d>>6^d;d=b+~(b<<11)|0;b=a+36|0;f=c[b>>2]&(d>>16^d);d=a+8|0;if(!(c[d>>2]|0)){j=0;i=e;return j|0}k=c[(c[a>>2]|0)+(f<<2)>>2]|0;if((k|0)==1073741823){j=0;i=e;return j|0}l=c[a+20>>2]|0;m=a+4|0;n=k;while(1){if((c[l+(n<<3)>>2]|0)==(g|0)?(c[l+(n<<3)+4>>2]|0)==(h|0):0)break;k=c[(c[m>>2]|0)+(n<<2)>>2]|0;if((k|0)==1073741823){j=0;o=14;break}else n=k}if((o|0)==14){i=e;return j|0}if(!(l+(n<<3)|0)){j=0;i=e;return j|0}Qra(a,0,0,f,n);n=c[a+28>>2]|0;f=n>>>1|n;n=f>>>2|f;f=n>>>4|n;n=f>>>8|f;f=(n>>>16|n)+1|0;n=c[d>>2]|0;if((f|0)==(n|0)){j=1;i=e;return j|0}l=c[a+16>>2]|0;o=f>>>0<l>>>0;if(o&(n|0)==(l|0)){j=1;i=e;return j|0}n=o?l:f;c[d>>2]=n;c[b>>2]=n+-1;if(n>>>0<=l>>>0?n>>>0>(c[a+12>>2]|0)>>>2>>>0:0)p=n>>>0<=(c[a+32>>2]|0)>>>2>>>0;else p=1;Pra(a,p);j=1;i=e;return j|0}function Sra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+28>>2]|0;e=d>>>1|d;d=e>>>2|e;e=d>>>4|d;d=e>>>8|e;e=(d>>>16|d)+1|0;d=a+8|0;f=c[d>>2]|0;if((e|0)==(f|0)){i=b;return}g=c[a+16>>2]|0;h=e>>>0<g>>>0;if(h&(f|0)==(g|0)){i=b;return}f=h?g:e;c[d>>2]=f;c[a+36>>2]=f+-1;if(f>>>0<=g>>>0?f>>>0>(c[a+12>>2]|0)>>>2>>>0:0)j=f>>>0<=(c[a+32>>2]|0)>>>2>>>0;else j=1;Pra(a,j);i=b;return}function Tra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+28|0;f=c[e>>2]|0;if(!f){i=d;return 1}g=a+20|0;h=a+36|0;j=f;f=0;a:while(1){k=j;while(1){l=c[g>>2]|0;m=c[l+(f<<3)>>2]|0;n=c[l+(f<<3)+4>>2]|0;l=c[b>>2]|0;if((c[l+(m>>>5<<2)>>2]&1<<(m&31)|0)==0?(c[l+(n>>>5<<2)>>2]&1<<(n&31)|0)==0:0)break;l=n<<16|m;m=l+~(l<<15)|0;l=(m>>10^m)*9|0;m=l>>6^l;l=m+~(m<<11)|0;Qra(a,0,0,c[h>>2]&(l>>16^l),f);l=c[e>>2]|0;if(f>>>0<l>>>0)k=l;else{o=8;break a}}f=f+1|0;if(f>>>0>=k>>>0){o=8;break}else j=k}if((o|0)==8){i=d;return 1}return 0}function Ura(b,e,f,g,h,j,k,l,m,n){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;b=i;i=i+16|0;o=b+1|0;p=b;q=(f|0)==0;if(!q){r=n+20|0;s=n+24|0;t=0;do{u=c[e+(t<<2)>>2]|0;v=c[r>>2]|0;w=v+(u<<3)|0;x=w;y=(c[s>>2]|0)+(u<<3>>3)|0;z=a[y>>0]|0;if(!(z&2)){a[y>>0]=z&254;if(a[(c[s>>2]|0)+(x-(c[r>>2]|0)>>3)>>0]&4){y=c[h>>2]|0;if((y|0)==(c[j>>2]|0)){A=UJa(o,y<<4,485040,521)|0;YEi(A|0,c[g>>2]|0,c[j>>2]<<3|0)|0;VJa(p,c[g>>2]|0);c[g>>2]=A;c[j>>2]=y<<1;B=A;C=c[h>>2]|0}else{B=c[g>>2]|0;C=y}y=c[w>>2]|0;A=c[v+(u<<3)+4>>2]|0;D=y>>>0<A>>>0;E=B+(C<<3)|0;c[E>>2]=D?y:A;c[E+4>>2]=D?A:y;c[h>>2]=(c[h>>2]|0)+1;y=(c[s>>2]|0)+(x-(c[r>>2]|0)>>3)|0;a[y>>0]=(d[y>>0]|0)&251}}else if(!(z&4)){z=c[l>>2]|0;if((z|0)==(c[m>>2]|0)){y=UJa(o,z<<4,485040,521)|0;YEi(y|0,c[k>>2]|0,c[m>>2]<<3|0)|0;VJa(p,c[k>>2]|0);c[k>>2]=y;c[m>>2]=z<<1;F=c[l>>2]|0}else F=z;z=c[w>>2]|0;w=c[v+(u<<3)+4>>2]|0;u=z>>>0<w>>>0;v=(c[k>>2]|0)+(F<<3)|0;c[v>>2]=u?z:w;c[v+4>>2]=u?w:z;c[l>>2]=(c[l>>2]|0)+1}t=t+1|0}while((t|0)!=(f|0));t=c[l>>2]|0;if(q)G=t;else{q=n+20|0;F=n+24|0;r=0;s=t;while(1){t=c[e+(r<<2)>>2]|0;h=c[q>>2]|0;if((a[(c[F>>2]|0)+(t<<3>>3)>>0]&6)==6){if((s|0)==(c[m>>2]|0)){C=UJa(o,s<<4,485040,521)|0;YEi(C|0,c[k>>2]|0,c[m>>2]<<3|0)|0;VJa(p,c[k>>2]|0);c[k>>2]=C;c[m>>2]=s<<1}C=c[h+(t<<3)>>2]|0;B=c[h+(t<<3)+4>>2]|0;t=C>>>0<B>>>0;h=(c[k>>2]|0)+(s<<3)|0;c[h>>2]=t?C:B;c[h+4>>2]=t?B:C;H=s+1|0}else H=s;r=r+1|0;if((r|0)==(f|0)){G=H;break}else s=H}}}else G=c[l>>2]|0;if(!G){i=b;return}else I=0;do{l=c[k>>2]|0;Rra(n,c[l+(I<<3)>>2]|0,c[l+(I<<3)+4>>2]|0)|0;I=I+1|0}while((I|0)!=(G|0));i=b;return}function Vra(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;j=i;t=c[m>>2]|0;u=c[m+4>>2]|0;v=c[m+8>>2]|0;if(d>>>0<e>>>0){m=c[b>>2]|0;w=c[g+(t<<2)>>2]|0;x=c[g+(u<<2)>>2]|0;y=c[g+(v<<2)>>2]|0;z=-1;A=-1;B=-1;C=0;D=0;E=0;F=d;while(1){d=c[f+(F<<2)>>2]|0;G=m+(d>>>5<<2)|0;c[G>>2]=c[G>>2]|1<<(d&31);G=c[w+(d<<3)>>2]|0;H=z>>>0<G>>>0?z:G;G=c[x+(d<<3)>>2]|0;I=A>>>0<G>>>0?A:G;G=c[y+(d<<3)>>2]|0;J=B>>>0<G>>>0?B:G;G=c[w+(d<<3)+4>>2]|0;K=C>>>0<G>>>0?G:C;G=c[x+(d<<3)+4>>2]|0;L=D>>>0<G>>>0?G:D;G=c[y+(d<<3)+4>>2]|0;d=E>>>0<G>>>0?G:E;F=F+1|0;if((F|0)==(e|0)){M=H;N=I;O=J;P=K;Q=L;R=d;break}else{z=H;A=I;B=J;C=K;D=L;E=d}}}else{M=-1;N=-1;O=-1;P=0;Q=0;R=0}E=l+-1|0;if(E>>>0<=1){S=0;T=0;U=(T|0)==0;V=U&1;a[s>>0]=V;W=(S|0)==0;X=W&1;a[r>>0]=X;i=j;return}l=g+(t<<2)|0;t=g+(u<<2)|0;u=g+(v<<2)|0;v=1;g=0;D=0;while(1){C=c[k+(v<<2)>>2]|0;do if(!(C&1)){B=C>>>1;if(c[(c[b>>2]|0)+(C>>>6<<2)>>2]&1<<(B&31)){c[n+(c[o>>2]<<2)>>2]=B;c[o>>2]=(c[o>>2]|0)+1;Y=(c[h+(B<<2)>>2]|0)+g|0;Z=D;break}A=c[l>>2]|0;z=c[t>>2]|0;e=c[u>>2]|0;if((c[e+(B<<3)+4>>2]|0)>>>0>=O>>>0&(((P>>>0<(c[A+(B<<3)>>2]|0)>>>0?1:(c[A+(B<<3)+4>>2]|0)>>>0<M>>>0)|Q>>>0<(c[z+(B<<3)>>2]|0)>>>0|(c[z+(B<<3)+4>>2]|0)>>>0<N>>>0|R>>>0<(c[e+(B<<3)>>2]|0)>>>0)^1)){c[p+(c[q>>2]<<2)>>2]=B;c[q>>2]=(c[q>>2]|0)+1;Y=g;Z=(c[h+(B<<2)>>2]|0)+D|0}else{Y=g;Z=D}}else{Y=g;Z=D}while(0);v=v+1|0;if((v|0)==(E|0)){S=Y;T=Z;break}else{g=Y;D=Z}}U=(T|0)==0;V=U&1;a[s>>0]=V;W=(S|0)==0;X=W&1;a[r>>0]=X;i=j;return}function Wra(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=i;if(!d){i=n;return}o=c[a>>2]|0;p=c[a+4>>2]|0;q=c[a+8>>2]|0;a=c[g+(o<<2)>>2]|0;r=0;do{c[f+(r<<2)>>2]=c[a+(c[b+(r<<2)>>2]<<3)>>2];r=r+1|0}while((r|0)!=(d|0));if(e){i=n;return}e=g+(o<<2)|0;o=g+(p<<2)|0;p=g+(q<<2)|0;q=0;g=0;while(1){r=c[b+(g<<2)>>2]|0;a=c[(c[e>>2]|0)+(r<<3)+4>>2]|0;s=f+(g<<2)|0;g=g+1|0;t=q;while(1){if(t>>>0>=d>>>0){u=t;break}v=t+1|0;if((c[f+(t<<2)>>2]|0)>>>0<(c[s>>2]|0)>>>0)t=v;else{u=v;break}}t=u>>>0<d>>>0;if(!t){w=17;break}s=h+(r<<2)|0;v=u;do{if((c[f+(v<<2)>>2]|0)>>>0>a>>>0)break;x=c[b+(v<<2)>>2]|0;v=v+1|0;if((c[s>>2]|0)!=(c[h+(x<<2)>>2]|0)?(y=c[o>>2]|0,z=c[p>>2]|0,(c[z+(x<<3)+4>>2]|0)>>>0>=(c[z+(r<<3)>>2]|0)>>>0&((((c[y+(r<<3)+4>>2]|0)>>>0<(c[y+(x<<3)>>2]|0)>>>0?1:(c[y+(x<<3)+4>>2]|0)>>>0<(c[y+(r<<3)>>2]|0)>>>0)|(c[z+(r<<3)+4>>2]|0)>>>0<(c[z+(x<<3)>>2]|0)>>>0)^1)):0)D$a(r,x,j,k,l,m)|0}while(v>>>0<d>>>0);if(!(t&g>>>0<d>>>0)){w=17;break}else q=u}if((w|0)==17){i=n;return}}function Xra(a,b,d,e,f,g,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;p=i;if((d|0)==0|(f|0)==0){i=p;return}q=c[a>>2]|0;r=c[a+4>>2]|0;s=c[a+8>>2]|0;a=c[j+(q<<2)>>2]|0;t=0;do{c[g+(t<<2)>>2]=c[a+(c[b+(t<<2)>>2]<<3)>>2];t=t+1|0}while((t|0)!=(d|0));t=c[j+(q<<2)>>2]|0;a=0;do{c[h+(a<<2)>>2]=c[t+(c[e+(a<<2)>>2]<<3)>>2];a=a+1|0}while((a|0)!=(f|0));a=j+(q<<2)|0;t=j+(r<<2)|0;u=j+(s<<2)|0;v=0;w=0;while(1){x=c[b+(w<<2)>>2]|0;y=c[(c[a>>2]|0)+(x<<3)+4>>2]|0;a:do if(v>>>0<f>>>0){z=c[g+(w<<2)>>2]|0;A=v;while(1){B=A+1|0;if((c[h+(A<<2)>>2]|0)>>>0>=z>>>0){C=A;break a}if(B>>>0<f>>>0)A=B;else{C=B;break}}}else C=v;while(0);w=w+1|0;A=C>>>0<f>>>0;if(!A)break;z=k+(x<<2)|0;B=C;do{if((c[h+(B<<2)>>2]|0)>>>0>y>>>0)break;D=c[e+(B<<2)>>2]|0;B=B+1|0;if((c[z>>2]|0)!=(c[k+(D<<2)>>2]|0)?(E=c[t>>2]|0,F=c[u>>2]|0,(c[F+(D<<3)+4>>2]|0)>>>0>=(c[F+(x<<3)>>2]|0)>>>0&((((c[E+(x<<3)+4>>2]|0)>>>0<(c[E+(D<<3)>>2]|0)>>>0?1:(c[E+(D<<3)+4>>2]|0)>>>0<(c[E+(x<<3)>>2]|0)>>>0)|(c[F+(x<<3)+4>>2]|0)>>>0<(c[F+(D<<3)>>2]|0)>>>0)^1)):0)D$a(x,D,l,m,n,o)|0}while(B>>>0<f>>>0);if(!(A&w>>>0<d>>>0))break;else v=C}C=j+(q<<2)|0;q=j+(r<<2)|0;r=j+(s<<2)|0;s=0;j=0;while(1){v=c[e+(j<<2)>>2]|0;w=c[(c[C>>2]|0)+(v<<3)+4>>2]|0;b:do if(s>>>0<d>>>0){u=c[h+(j<<2)>>2]|0;t=s;while(1){a=t+1|0;if((c[g+(t<<2)>>2]|0)>>>0>u>>>0){G=t;break b}if(a>>>0<d>>>0)t=a;else{G=a;break}}}else G=s;while(0);j=j+1|0;A=G>>>0<d>>>0;if(!A){H=32;break}t=k+(v<<2)|0;u=G;do{if((c[g+(u<<2)>>2]|0)>>>0>w>>>0)break;a=c[b+(u<<2)>>2]|0;u=u+1|0;if((c[t>>2]|0)!=(c[k+(a<<2)>>2]|0)?(B=c[q>>2]|0,x=c[r>>2]|0,(c[x+(a<<3)+4>>2]|0)>>>0>=(c[x+(v<<3)>>2]|0)>>>0&((((c[B+(v<<3)+4>>2]|0)>>>0<(c[B+(a<<3)>>2]|0)>>>0?1:(c[B+(a<<3)+4>>2]|0)>>>0<(c[B+(v<<3)>>2]|0)>>>0)|(c[x+(v<<3)+4>>2]|0)>>>0<(c[x+(a<<3)>>2]|0)>>>0)^1)):0)D$a(v,a,l,m,n,o)|0}while(u>>>0<d>>>0);if(!(A&j>>>0<f>>>0)){H=32;break}else s=G}if((H|0)==32){i=p;return}}function Yra(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=Im,N=Im;h=i;i=i+64|0;j=h+48|0;k=h+36|0;l=h+24|0;m=h+12|0;n=h;o=ea(g[a>>2]);p=ea(g[c>>2]);q=ea(o-p);r=a+4|0;s=c+4|0;t=ea(g[a+8>>2]);u=ea(g[c+8>>2]);v=ea(t-u);w=ea(g[b>>2]);x=ea(g[d>>2]);y=ea(w+x);c=b+4|0;a=d+4|0;z=ea(g[b+8>>2]);A=ea(g[d+8>>2]);B=ea(z+A);if(ea(S(ea(q)))<=y){y=ea(g[a>>2]);q=ea(g[c>>2]);C=ea(g[s>>2]);D=ea(g[r>>2]);if(ea(S(ea(D-C)))<=ea(y+q)?ea(S(ea(v)))<=B:0){E=ea(0.0);i=h;return ea(E)}else{F=D;G=q;H=C;I=y}}else{y=ea(g[r>>2]);C=ea(g[c>>2]);q=ea(g[s>>2]);F=y;G=C;H=q;I=ea(g[a>>2])}q=ea(g[f>>2]);C=ea(q-ea(g[e>>2]));q=ea(g[f+4>>2]);y=ea(q-ea(g[e+4>>2]));q=ea(g[f+8>>2]);D=ea(q-ea(g[e+8>>2]));g[j>>2]=C;g[j+4>>2]=y;g[j+8>>2]=D;D=ea(F+G);y=ea(t+z);g[k>>2]=ea(o+w);g[k+4>>2]=D;g[k+8>>2]=y;y=ea(F-G);G=ea(t-z);g[l>>2]=ea(o-w);g[l+4>>2]=y;g[l+8>>2]=G;G=ea(H+I);y=ea(u+A);g[m>>2]=ea(p+x);g[m+4>>2]=G;g[m+8>>2]=y;y=ea(H-I);I=ea(u-A);g[n>>2]=ea(p-x);g[n+4>>2]=y;g[n+8>>2]=I;I=C;e=0;C=ea(0.0);y=ea(1.0);a:while(1){do if(I<ea(-9.99999997e-07)){x=ea(g[m+(e<<2)>>2]);p=ea(g[l+(e<<2)>>2]);if(x<p){E=ea(3402823469999999843913219.0e14);J=23;break a}A=ea(g[k+(e<<2)>>2]);u=ea(g[n+(e<<2)>>2]);if(A<u){H=ea(ea(A-u)/I);K=H>C?H:C}else K=C;if(x>p){H=ea(ea(p-x)/I);L=K;M=H<y?H:y}else{L=K;M=y}}else{if(!(I>ea(9.99999997e-07))){H=ea(g[m+(e<<2)>>2]);if(H<ea(g[l+(e<<2)>>2])){E=ea(3402823469999999843913219.0e14);J=23;break a}H=ea(g[n+(e<<2)>>2]);if(H>ea(g[k+(e<<2)>>2])){E=ea(3402823469999999843913219.0e14);J=23;break a}else{L=C;M=y;break}}H=ea(g[n+(e<<2)>>2]);x=ea(g[k+(e<<2)>>2]);if(H>x){E=ea(3402823469999999843913219.0e14);J=23;break a}p=ea(g[m+(e<<2)>>2]);u=ea(g[l+(e<<2)>>2]);if(p<u){A=ea(ea(u-p)/I);N=A>C?A:C}else N=C;if(x>H){A=ea(ea(x-H)/I);L=N;M=A<y?A:y}else{L=N;M=y}}while(0);f=e+1|0;if(L>M){E=ea(3402823469999999843913219.0e14);J=23;break}if(f>>>0>=3){E=L;J=23;break}I=ea(g[j+(f<<2)>>2]);e=f;C=L;y=M}if((J|0)==23){i=h;return ea(E)}return ea(0.0)}function Zra(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;h=f;b[d+4>>1]=-1;b[d+6>>1]=0;c[d+8>>2]=0;c[d>>2]=443968;c[d+12>>2]=0;c[d+16>>2]=0;c[d>>2]=487528;c[d+20>>2]=d;c[d+24>>2]=485136;j=d+28|0;b[d+32>>1]=-1;b[d+34>>1]=0;c[d+36>>2]=0;c[j>>2]=443968;c[d+40>>2]=0;c[d+44>>2]=0;c[j>>2]=487480;c[d+48>>2]=d;c[d+52>>2]=485168;j=d+56|0;b[d+60>>1]=-1;b[d+62>>1]=0;c[d+64>>2]=0;c[j>>2]=443968;c[d+68>>2]=0;c[d+72>>2]=0;c[j>>2]=487432;c[d+76>>2]=d;c[d+80>>2]=485200;a[d+88>>0]=0;c[d+92>>2]=0;c[d+96>>2]=0;j=d+100|0;k=d+104|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;c[h>>2]=Bn[m&255](l,2560,o?486672:544544,485816,203)|0;c[h+4>>2]=0;o=c[k>>2]|0;if((c[d+108>>2]&2147483647)>>>0>o>>>0){l=(c[j>>2]|0)+(o<<3)|0;if(!l)p=o;else{o=h;m=c[o+4>>2]|0;n=l;c[n>>2]=c[o>>2];c[n+4>>2]=m;p=c[k>>2]|0}c[k>>2]=p+1}else G$a(j,h)|0;j=d+116|0;p=d+120|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;k=mKa()|0;m=c[(c[k>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;c[h>>2]=Bn[m&255](k,1024,o?486280:544544,485816,203)|0;c[h+4>>2]=0;o=c[p>>2]|0;if((c[d+124>>2]&2147483647)>>>0>o>>>0){k=(c[j>>2]|0)+(o<<3)|0;if(!k)q=o;else{o=h;m=c[o+4>>2]|0;n=k;c[n>>2]=c[o>>2];c[n+4>>2]=m;q=c[p>>2]|0}c[p>>2]=q+1}else H$a(j,h)|0;j=d+132|0;q=d+136|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;p=mKa()|0;m=c[(c[p>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;c[h>>2]=Bn[m&255](p,12288,o?487048:544544,485816,203)|0;c[h+4>>2]=0;o=c[q>>2]|0;if((c[d+140>>2]&2147483647)>>>0>o>>>0){p=(c[j>>2]|0)+(o<<3)|0;if(!p)r=o;else{o=h;m=c[o+4>>2]|0;n=p;c[n>>2]=c[o>>2];c[n+4>>2]=m;r=c[q>>2]|0}c[q>>2]=r+1}else I$a(j,h)|0;j=d+196|0;r=d+148|0;q=r+48|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(q|0));g[j>>2]=ea(.75);c[d+200>>2]=-1;c[d+204>>2]=0;c[d+208>>2]=0;J$a(d+172|0,64);j=d+212|0;r=d+216|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;q=mKa()|0;m=c[(c[q>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;c[h>>2]=Bn[m&255](q,13824,o?485904:544544,485816,203)|0;c[h+4>>2]=0;o=c[r>>2]|0;if((c[d+220>>2]&2147483647)>>>0<=o>>>0){K$a(j,h)|0;s=d+228|0;t=d+260|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;c[s+20>>2]=0;c[s+24>>2]=0;c[s+28>>2]=0;c[t>>2]=1;u=d+264|0;c[u>>2]=e;i=f;return}q=(c[j>>2]|0)+(o<<3)|0;if(!q)v=o;else{o=h;h=c[o+4>>2]|0;j=q;c[j>>2]=c[o>>2];c[j+4>>2]=h;v=c[r>>2]|0}c[r>>2]=v+1;s=d+228|0;t=d+260|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;c[s+20>>2]=0;c[s+24>>2]=0;c[s+28>>2]=0;c[t>>2]=1;u=d+264|0;c[u>>2]=e;i=f;return}function _ra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+16|0;d=b;e=c[a+248>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+240>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+236>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+228>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=a+212|0;f=a+216|0;g=c[f>>2]|0;if(g){h=g;g=0;while(1){j=c[(c[e>>2]|0)+(g<<3)>>2]|0;if(!j)k=h;else{VJa(d,j);k=c[f>>2]|0}g=g+1|0;if(g>>>0>=k>>>0)break;else h=k}}c[a+224>>2]=0;k=c[a+220>>2]|0;if((k&2147483647|0)!=0&(k|0)>-1?(k=c[e>>2]|0,(k|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,k)}k=a+172|0;e=c[k>>2]|0;if(e)VJa(k,e);e=c[a+168>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+160>>2]|0,(e|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e)}e=c[a+156>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+148>>2]|0,(e|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e)}e=a+132|0;k=a+136|0;h=c[k>>2]|0;if(h){g=h;h=0;while(1){f=c[(c[e>>2]|0)+(h<<3)>>2]|0;if(!f)l=g;else{VJa(d,f);l=c[k>>2]|0}h=h+1|0;if(h>>>0>=l>>>0)break;else g=l}}c[a+144>>2]=0;l=c[a+140>>2]|0;if((l&2147483647|0)!=0&(l|0)>-1?(l=c[e>>2]|0,(l|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,l)}l=a+116|0;e=a+120|0;g=c[e>>2]|0;if(g){h=g;g=0;while(1){k=c[(c[l>>2]|0)+(g<<3)>>2]|0;if(!k)m=h;else{VJa(d,k);m=c[e>>2]|0}g=g+1|0;if(g>>>0>=m>>>0)break;else h=m}}c[a+128>>2]=0;m=c[a+124>>2]|0;if((m&2147483647|0)!=0&(m|0)>-1?(m=c[l>>2]|0,(m|0)!=0):0){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,m)}m=a+100|0;l=a+104|0;h=c[l>>2]|0;if(h){g=h;h=0;while(1){e=c[(c[m>>2]|0)+(h<<3)>>2]|0;if(!e)n=g;else{VJa(d,e);n=c[l>>2]|0}h=h+1|0;if(h>>>0>=n>>>0)break;else g=n}}c[a+112>>2]=0;n=c[a+108>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){o=a+56|0;c[o>>2]=443968;p=a+64|0;c[p>>2]=0;q=a+28|0;c[q>>2]=443968;r=a+36|0;c[r>>2]=0;c[a>>2]=443968;s=a+8|0;c[s>>2]=0;i=b;return}n=c[m>>2]|0;if(!n){o=a+56|0;c[o>>2]=443968;p=a+64|0;c[p>>2]=0;q=a+28|0;c[q>>2]=443968;r=a+36|0;c[r>>2]=0;c[a>>2]=443968;s=a+8|0;c[s>>2]=0;i=b;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,n);o=a+56|0;c[o>>2]=443968;p=a+64|0;c[p>>2]=0;q=a+28|0;c[q>>2]=443968;r=a+36|0;c[r>>2]=0;c[a>>2]=443968;s=a+8|0;c[s>>2]=0;i=b;return}function $ra(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=UJa(b,268,485240,275)|0;if(!c){i=b;return c|0}Zra(c,a);i=b;return c|0}function asa(a){a=a|0;var b=0;b=i;i=i+16|0;_ra(a);VJa(b,a);i=b;return}function bsa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;e=i;if(!d){f=c[b+4>>2]|0;h=c[b>>2]|0;j=ea(ea(g[h+16>>2])*ea(2.0));k=ea(ea(g[h+20>>2])*ea(2.0));l=ea(ea(g[h+24>>2])*ea(2.0));m=ea(g[f+12>>2]);n=ea(ea(m*m)+ea(-.5));o=ea(g[f>>2]);p=ea(j*o);q=ea(g[f+4>>2]);r=ea(p+ea(k*q));p=ea(g[f+8>>2]);s=ea(r+ea(l*p));r=ea(ea(o*s)+ea(ea(j*n)+ea(m*ea(ea(l*q)-ea(k*p)))));t=ea(ea(q*s)+ea(ea(k*n)+ea(m*ea(ea(j*p)-ea(l*o)))));u=ea(ea(ea(l*n)+ea(m*ea(ea(k*o)-ea(j*q))))+ea(p*s));s=ea(ea(g[f+16>>2])+r);r=ea(ea(g[f+20>>2])+t);t=ea(ea(g[f+24>>2])+u);u=ea(g[h>>2]);j=ea(m*u);k=ea(g[h+12>>2]);n=ea(j+ea(o*k));j=ea(g[h+8>>2]);l=ea(n+ea(q*j));n=ea(g[h+4>>2]);v=ea(ea(ea(p*u)+ea(ea(q*k)+ea(m*n)))-ea(o*j));w=ea(ea(ea(o*n)+ea(ea(p*k)+ea(m*j)))-ea(q*u));x=ea(ea(ea(ea(m*k)-ea(o*u))-ea(q*n))-ea(p*j));g[a>>2]=ea(l-ea(p*n));g[a+4>>2]=v;g[a+8>>2]=w;g[a+12>>2]=x;g[a+16>>2]=s;g[a+20>>2]=r;g[a+24>>2]=t;i=e;return}else{h=c[d+64>>2]|0;t=ea(g[h+48>>2]);r=ea(g[h+52>>2]);s=ea(t*ea(-2.0));t=ea(r*ea(-2.0));r=ea(ea(g[h+56>>2])*ea(-2.0));x=ea(g[h+44>>2]);w=ea(ea(x*x)+ea(-.5));v=ea(g[h+32>>2]);n=ea(s*v);p=ea(g[h+36>>2]);l=ea(n+ea(t*p));n=ea(g[h+40>>2]);j=ea(l+ea(r*n));l=ea(-v);q=ea(-p);u=ea(-n);o=ea(ea(ea(v*j)+ea(ea(s*w)-ea(x*ea(ea(r*p)-ea(t*n)))))*ea(2.0));k=ea(ea(ea(p*j)+ea(ea(t*w)-ea(x*ea(ea(s*n)-ea(r*v)))))*ea(2.0));m=ea(ea(ea(ea(r*w)-ea(x*ea(ea(t*v)-ea(s*p))))+ea(n*j))*ea(2.0));j=ea(g[h+12>>2]);n=ea(ea(j*j)+ea(-.5));p=ea(g[h>>2]);s=ea(p*o);v=ea(g[h+4>>2]);t=ea(s+ea(v*k));s=ea(g[h+8>>2]);w=ea(ea(s*m)+t);t=ea(ea(p*w)+ea(ea(n*o)+ea(j*ea(ea(v*m)-ea(s*k)))));r=ea(ea(v*w)+ea(ea(n*k)+ea(j*ea(ea(s*o)-ea(p*m)))));y=ea(ea(ea(n*m)+ea(j*ea(ea(p*k)-ea(v*o))))+ea(s*w));w=ea(ea(g[h+16>>2])+t);t=ea(ea(g[h+20>>2])+r);r=ea(ea(g[h+24>>2])+y);y=ea(ea(ea(ea(j*l)+ea(x*p))+ea(v*u))-ea(s*q));o=ea(ea(ea(s*l)+ea(ea(j*q)+ea(x*v)))-ea(p*u));k=ea(ea(ea(p*q)+ea(ea(j*u)+ea(x*s)))-ea(v*l));m=ea(ea(ea(ea(x*j)-ea(p*l))-ea(v*q))-ea(s*u));h=c[b>>2]|0;u=ea(ea(g[h+16>>2])*ea(2.0));s=ea(ea(g[h+20>>2])*ea(2.0));q=ea(ea(g[h+24>>2])*ea(2.0));v=ea(ea(m*m)+ea(-.5));l=ea(ea(ea(y*u)+ea(o*s))+ea(k*q));p=ea(w+ea(ea(y*l)+ea(ea(v*u)+ea(m*ea(ea(o*q)-ea(k*s))))));w=ea(t+ea(ea(o*l)+ea(ea(v*s)+ea(m*ea(ea(k*u)-ea(y*q))))));t=ea(r+ea(ea(ea(v*q)+ea(m*ea(ea(y*s)-ea(o*u))))+ea(k*l)));l=ea(g[h>>2]);u=ea(m*l);s=ea(g[h+12>>2]);q=ea(u+ea(y*s));u=ea(g[h+8>>2]);v=ea(q+ea(o*u));q=ea(g[h+4>>2]);r=ea(ea(ea(k*l)+ea(ea(o*s)+ea(m*q)))-ea(y*u));j=ea(ea(ea(y*q)+ea(ea(k*s)+ea(m*u)))-ea(o*l));x=ea(ea(ea(ea(m*s)-ea(y*l))-ea(o*q))-ea(k*u));g[a>>2]=ea(v-ea(k*q));g[a+4>>2]=r;g[a+8>>2]=j;g[a+12>>2]=x;g[a+16>>2]=p;g[a+20>>2]=w;g[a+24>>2]=t;i=e;return}}function csa(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im;e=ea(g[d+32>>2]);f=ea(g[d+36>>2]);h=ea(g[d+40>>2]);i=ea(g[d+44>>2]);j=ea(g[d+48>>2]);k=ea(g[d+52>>2]);l=ea(g[d+56>>2]);m=c[d+64>>2]|0;n=ea(g[m+48>>2]);o=ea(g[m+52>>2]);p=ea(n*ea(-2.0));n=ea(o*ea(-2.0));o=ea(ea(g[m+56>>2])*ea(-2.0));q=ea(g[m+44>>2]);r=ea(ea(q*q)+ea(-.5));s=ea(g[m+32>>2]);t=ea(p*s);u=ea(g[m+36>>2]);v=ea(t+ea(n*u));t=ea(g[m+40>>2]);w=ea(v+ea(o*t));v=ea(-s);x=ea(-u);y=ea(-t);z=ea(ea(ea(s*w)+ea(ea(p*r)-ea(q*ea(ea(o*u)-ea(n*t)))))*ea(2.0));A=ea(ea(ea(u*w)+ea(ea(n*r)-ea(q*ea(ea(p*t)-ea(o*s)))))*ea(2.0));B=ea(ea(ea(ea(o*r)-ea(q*ea(ea(n*s)-ea(p*u))))+ea(t*w))*ea(2.0));w=ea(ea(i*i)+ea(-.5));t=ea(ea(h*B)+ea(ea(e*z)+ea(f*A)));u=ea(j+ea(ea(e*t)+ea(ea(w*z)+ea(i*ea(ea(f*B)-ea(h*A))))));j=ea(k+ea(ea(f*t)+ea(ea(w*A)+ea(i*ea(ea(h*z)-ea(e*B))))));k=ea(l+ea(ea(ea(w*B)+ea(i*ea(ea(e*A)-ea(f*z))))+ea(h*t)));t=ea(ea(ea(ea(e*q)+ea(i*v))+ea(f*y))-ea(h*x));z=ea(ea(ea(h*v)+ea(ea(f*q)+ea(i*x)))-ea(e*y));A=ea(ea(ea(e*x)+ea(ea(h*q)+ea(i*y)))-ea(f*v));B=ea(ea(ea(ea(i*q)-ea(e*v))-ea(f*x))-ea(h*y));m=c[b>>2]|0;y=ea(ea(g[m+16>>2])*ea(2.0));h=ea(ea(g[m+20>>2])*ea(2.0));x=ea(ea(g[m+24>>2])*ea(2.0));f=ea(ea(B*B)+ea(-.5));v=ea(ea(ea(y*t)+ea(h*z))+ea(x*A));e=ea(ea(ea(t*v)+ea(ea(y*f)+ea(B*ea(ea(z*x)-ea(h*A)))))+u);u=ea(ea(ea(z*v)+ea(ea(h*f)+ea(B*ea(ea(y*A)-ea(t*x)))))+j);j=ea(ea(ea(ea(x*f)+ea(B*ea(ea(h*t)-ea(y*z))))+ea(A*v))+k);k=ea(g[m>>2]);v=ea(B*k);y=ea(g[m+12>>2]);h=ea(v+ea(t*y));v=ea(g[m+8>>2]);f=ea(h+ea(z*v));h=ea(g[m+4>>2]);x=ea(ea(ea(A*k)+ea(ea(z*y)+ea(B*h)))-ea(t*v));q=ea(ea(ea(t*h)+ea(ea(A*y)+ea(B*v)))-ea(z*k));i=ea(ea(ea(ea(B*y)-ea(t*k))-ea(z*h))-ea(A*v));g[a>>2]=ea(f-ea(A*h));g[a+4>>2]=x;g[a+8>>2]=q;g[a+12>>2]=i;g[a+16>>2]=e;g[a+20>>2]=u;g[a+24>>2]=j;return}function dsa(a,d,f,h){a=a|0;d=d|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=0;h=i;i=i+176|0;j=h+64|0;k=h+32|0;l=h;m=h+96|0;n=h+148|0;o=h+136|0;p=h+172|0;q=h+128|0;r=h+160|0;s=a+60|0;esa(a);t=c[a>>2]|0;u=c[a+4>>2]|0;v=c[a+8>>2]|0;w=c[a+12>>2]|0;x=c[s>>2]|0;y=a+64|0;z=c[y>>2]|0;A=(z|0)<(x|0);B=A?x:z;C=A?z:x;x=A?v:w;z=A?w:v;v=A?t:u;w=A?u:t;g[j>>2]=ea(g[z+40>>2]);g[j+4>>2]=ea(g[z+44>>2]);g[j+8>>2]=ea(g[z+48>>2]);g[j+12>>2]=ea(g[z+52>>2]);D=ea(g[z+56>>2]);g[j+16>>2]=D;E=ea(g[z+60>>2]);g[j+20>>2]=E;F=ea(g[z+64>>2]);g[j+24>>2]=F;g[l>>2]=ea(g[z+12>>2]);g[l+4>>2]=ea(g[z+16>>2]);g[l+8>>2]=ea(g[z+20>>2]);g[l+12>>2]=ea(g[z+24>>2]);G=ea(g[z+28>>2]);g[l+16>>2]=G;H=ea(g[z+32>>2]);g[l+20>>2]=H;I=ea(g[z+36>>2]);g[l+24>>2]=I;g[k>>2]=ea(g[x+40>>2]);g[k+4>>2]=ea(g[x+44>>2]);g[k+8>>2]=ea(g[x+48>>2]);g[k+12>>2]=ea(g[x+52>>2]);J=ea(g[x+56>>2]);g[k+16>>2]=J;K=ea(g[x+60>>2]);g[k+20>>2]=K;L=ea(g[x+64>>2]);g[k+24>>2]=L;g[m>>2]=ea(g[x+12>>2]);g[m+4>>2]=ea(g[x+16>>2]);g[m+8>>2]=ea(g[x+20>>2]);g[m+12>>2]=ea(g[x+24>>2]);M=ea(g[x+28>>2]);g[m+16>>2]=M;N=ea(g[x+32>>2]);g[m+20>>2]=N;O=ea(g[x+36>>2]);g[m+24>>2]=O;P=ea(D-G);G=ea(E-H);H=ea(F-I);I=ea(J-M);M=ea(K-N);N=ea(L-O);g[n>>2]=ea(0.0);t=n+4|0;g[t>>2]=ea(0.0);u=n+8|0;g[u>>2]=ea(0.0);g[o>>2]=ea(0.0);A=o+4|0;g[A>>2]=ea(0.0);Q=o+8|0;g[Q>>2]=ea(0.0);R=c[501e3+(C*28|0)+(B<<2)>>2]|0;S=a+52|0;T=c[S>>2]|0;O=ea(g[T+108>>2]);U=O>ea(0.0);L=U?O:ea(0.0);U=d+16|0;g[d+8764>>2]=f;V=d+8772|0;c[V>>2]=-1;W=a+28|0;f=ea(g[W>>2]);O=ea(Mn[R&15](z,x,w,v,j,k,l,m,L,n,o,T+60|0,U,f));if(O>=ea(1.0)){c[a+100>>2]=1;g[a+48>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[W>>2]=ea(3402823469999999843913219.0e14);X=O;i=h;return ea(X)}f=ea(H-N);L=ea(G-M);K=ea(P-I);T=a+72|0;c[T>>2]=c[V>>2];J=ea(g[n>>2]);F=ea(-J);E=ea(g[t>>2]);D=ea(-E);Y=ea(g[u>>2]);Z=ea(-Y);_=ea(ea(ea(K*F)+ea(L*D))+ea(f*Z));V=(c[y>>2]|0)<(c[s>>2]|0);if(V){$=J;aa=E;ba=Y}else{g[n>>2]=F;g[t>>2]=D;g[u>>2]=Z;$=F;aa=D;ba=Z}c[a+100>>2]=1;Z=ea(g[z+8>>2]);D=ea(g[x+8>>2]);if(_<ea(Z+D)){g[W>>2]=ea(3402823469999999843913219.0e14);X=ea(3402823469999999843913219.0e14);i=h;return ea(X)}if(O<=ea(0.0)){u=(w|0)!=0;if(u)ca=ea(g[(c[w+60>>2]|0)+4>>2]);else ca=ea(1.0);t=(v|0)!=0;if(t)da=ea(g[(c[v+60>>2]|0)+4>>2]);else da=ea(1.0);F=ea(-O);if((ca<da?ca:da)==ea(1.0)){if(u)fa=ea(g[(c[w+64>>2]|0)+60>>2]);else fa=ea(1.0);if(t)ga=ea(g[(c[v+64>>2]|0)+60>>2]);else ga=ea(1.0);da=t?D:ea(3402823469999999843913219.0e14);ha=F;ia=ea(ea((Z<da?Z:da)*(fa<ga?fa:ga))/_);ja=ea(0.0)}else{ha=F;ia=ea(0.0);ja=ea(0.0)}}else{ha=ea(0.0);ia=ea(0.0);ja=O}g[W>>2]=ja;g[a+48>>2]=ha;g[a+32>>2]=ia;W=a+36|0;if(V){ia=ea(P*ja);P=ea(G*ja);G=ea(H*ja);H=ea(ia+ea(g[o>>2]));ia=ea(P+ea(g[A>>2]));P=ea(G+ea(g[Q>>2]));g[W>>2]=H;g[a+40>>2]=ia;g[a+44>>2]=P}else{P=ea(I*ja);I=ea(M*ja);M=ea(N*ja);N=ea(P+ea(g[o>>2]));P=ea(I+ea(g[A>>2]));I=ea(M+ea(g[Q>>2]));g[W>>2]=N;g[a+40>>2]=P;g[a+44>>2]=I}g[a+16>>2]=$;Q=a+20|0;g[Q>>2]=aa;A=a+24|0;g[A>>2]=ba;o=d+4496|0;c[o>>2]=0;if((C+-5|0)>>>0<2)ka=c[T>>2]|0;else ka=-1;if((B+-5|0)>>>0<2)la=c[T>>2]|0;else la=-1;c[o>>2]=1;g[d+400>>2]=$;g[d+404>>2]=ea(g[Q>>2]);g[d+408>>2]=ea(g[A>>2]);g[d+416>>2]=ea(g[W>>2]);g[d+420>>2]=ea(g[a+40>>2]);g[d+424>>2]=ea(g[a+44>>2]);g[d+412>>2]=ea(0.0);c[d+448>>2]=ka;c[d+452>>2]=la;kn[c[501200+(C<<2)>>2]&511](c[z>>2]|0,0,U,p)|0;kn[c[501200+(B<<2)>>2]&511](c[x>>2]|0,1,U,p)|0;U=c[c[(c[S>>2]|0)+96>>2]>>2]|0;S=U+((e[p>>1]|0)<<5)|0;x=p+2|0;B=U+((e[x>>1]|0)<<5)|0;$=ea(iva(S,B));hva(q,ea(1.0),ea(1.0));jva(r,q,S,B);ba=ea(g[r>>2]);aa=ea(g[r+4>>2]);b[a+76>>1]=b[p>>1]|0;b[a+78>>1]=b[x>>1]|0;g[a+80>>2]=aa;g[a+84>>2]=ba;g[a+88>>2]=$;X=ja;i=h;return ea(X)}function esa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0;b=i;i=i+160|0;d=b+28|0;e=b+80|0;f=b+56|0;h=b+108|0;j=b+132|0;k=b;l=b+68|0;m=b+120|0;n=c[a>>2]|0;if((n|0)!=0?(o=a+8|0,p=c[o>>2]|0,(c[(c[n+60>>2]|0)+16>>2]|0)!=(c[p+92>>2]|0)):0){bsa(d,p,n);csa(e,c[o>>2]|0,c[a>>2]|0);n=d+16|0;q=ea(g[n>>2]);r=ea(g[e+16>>2]);s=ea(q-r);p=d+20|0;q=ea(g[p>>2]);t=ea(g[e+20>>2]);u=ea(q-t);v=d+24|0;q=ea(g[v>>2]);w=ea(g[e+24>>2]);x=ea(q-w);ea(pMa((c[c[o>>2]>>2]|0)+36|0,f,h,d,0));y=c[o>>2]|0;q=ea(ea(g[f>>2])-s);s=ea(ea(g[f+4>>2])-u);u=ea(ea(g[f+8>>2])-x);g[y+80>>2]=q;g[y+84>>2]=s;g[y+88>>2]=u;g[y+68>>2]=ea(g[h>>2]);g[y+72>>2]=ea(g[h+4>>2]);g[y+76>>2]=ea(g[h+8>>2]);g[y+12>>2]=ea(g[e>>2]);g[y+16>>2]=ea(g[e+4>>2]);g[y+20>>2]=ea(g[e+8>>2]);g[y+24>>2]=ea(g[e+12>>2]);g[y+28>>2]=r;g[y+32>>2]=t;g[y+36>>2]=w;g[y+40>>2]=ea(g[d>>2]);g[y+44>>2]=ea(g[d+4>>2]);g[y+48>>2]=ea(g[d+8>>2]);g[y+52>>2]=ea(g[d+12>>2]);g[y+56>>2]=ea(g[n>>2]);g[y+60>>2]=ea(g[p>>2]);g[y+64>>2]=ea(g[v>>2]);c[y+92>>2]=c[(c[(c[a>>2]|0)+60>>2]|0)+16>>2]}y=a+4|0;v=c[y>>2]|0;if(!v){i=b;return}p=a+12|0;a=c[p>>2]|0;if((c[(c[v+60>>2]|0)+16>>2]|0)==(c[a+92>>2]|0)){i=b;return}bsa(j,a,v);csa(k,c[p>>2]|0,c[y>>2]|0);v=j+16|0;w=ea(g[v>>2]);t=ea(g[k+16>>2]);r=ea(w-t);a=j+20|0;w=ea(g[a>>2]);u=ea(g[k+20>>2]);s=ea(w-u);n=j+24|0;w=ea(g[n>>2]);q=ea(g[k+24>>2]);x=ea(w-q);ea(pMa((c[c[p>>2]>>2]|0)+36|0,l,m,j,0));d=c[p>>2]|0;w=ea(ea(g[l>>2])-r);r=ea(ea(g[l+4>>2])-s);s=ea(ea(g[l+8>>2])-x);g[d+80>>2]=w;g[d+84>>2]=r;g[d+88>>2]=s;g[d+68>>2]=ea(g[m>>2]);g[d+72>>2]=ea(g[m+4>>2]);g[d+76>>2]=ea(g[m+8>>2]);g[d+12>>2]=ea(g[k>>2]);g[d+16>>2]=ea(g[k+4>>2]);g[d+20>>2]=ea(g[k+8>>2]);g[d+24>>2]=ea(g[k+12>>2]);g[d+28>>2]=t;g[d+32>>2]=u;g[d+36>>2]=q;g[d+40>>2]=ea(g[j>>2]);g[d+44>>2]=ea(g[j+4>>2]);g[d+48>>2]=ea(g[j+8>>2]);g[d+52>>2]=ea(g[j+12>>2]);g[d+56>>2]=ea(g[v>>2]);g[d+60>>2]=ea(g[a>>2]);g[d+64>>2]=ea(g[n>>2]);c[d+92>>2]=c[(c[(c[y>>2]|0)+60>>2]|0)+16>>2];i=b;return}function fsa(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;b=i;i=i+128|0;d=b+12|0;e=b+64|0;f=b+40|0;h=b+92|0;j=b+116|0;k=b;l=b+52|0;m=b+104|0;esa(a);n=c[a+4>>2]|0;o=c[a>>2]|0;p=c[a+8>>2]|0;q=c[a+12>>2]|0;r=c[a+64>>2]|0;s=c[a+60>>2]|0;t=(r|0)<(s|0);u=t?p:q;v=t?q:p;p=t?n:o;q=t?o:n;g[d>>2]=ea(g[v+40>>2]);g[d+4>>2]=ea(g[v+44>>2]);g[d+8>>2]=ea(g[v+48>>2]);g[d+12>>2]=ea(g[v+52>>2]);w=ea(g[v+56>>2]);g[d+16>>2]=w;x=ea(g[v+60>>2]);g[d+20>>2]=x;y=ea(g[v+64>>2]);g[d+24>>2]=y;z=ea(g[v+28>>2]);A=ea(g[v+32>>2]);B=ea(w-z);z=ea(x-A);A=ea(y-ea(g[v+36>>2]));g[f>>2]=B;g[f+4>>2]=z;g[f+8>>2]=A;g[e>>2]=ea(g[u+40>>2]);g[e+4>>2]=ea(g[u+44>>2]);g[e+8>>2]=ea(g[u+48>>2]);g[e+12>>2]=ea(g[u+52>>2]);y=ea(g[u+56>>2]);g[e+16>>2]=y;x=ea(g[u+60>>2]);g[e+20>>2]=x;w=ea(g[u+64>>2]);g[e+24>>2]=w;C=ea(g[u+28>>2]);D=ea(g[u+32>>2]);E=ea(y-C);C=ea(x-D);D=ea(w-ea(g[u+36>>2]));g[h>>2]=E;g[h+4>>2]=C;g[h+8>>2]=D;w=ea(g[(c[a+52>>2]|0)+108>>2]);n=w>ea(0.0);x=n?w:ea(0.0);w=ea(B-E);E=ea(z-C);C=ea(A-D);D=ea(g[v+8>>2]);A=ea(D+ea(g[u+8>>2]));n=a+100|0;c[n>>2]=0;if(ea(ea(ea(w*w)+ea(E*E))+ea(C*C))<=ea(A*A)){c[n>>2]=0;g[a+28>>2]=ea(3402823469999999843913219.0e14);F=ea(3402823469999999843913219.0e14);i=b;return ea(F)}n=t?s:r;if((n|0)==5){A=ea(iza(v,u,p,q,d,e,x));g[a+28>>2]=A;F=A;i=b;return ea(F)}else if((n|0)==6){A=ea(jza(v,u,p,q,d,e,x));g[a+28>>2]=A;F=A;i=b;return ea(F)}else{g[j>>2]=ea(g[v+80>>2]);g[j+4>>2]=ea(g[v+84>>2]);g[j+8>>2]=ea(g[v+88>>2]);A=ea(x+ea(g[v+68>>2]));C=ea(x+ea(g[v+72>>2]));E=ea(x+ea(g[v+76>>2]));g[k>>2]=ea(g[u+80>>2]);g[k+4>>2]=ea(g[u+84>>2]);g[k+8>>2]=ea(g[u+88>>2]);x=ea(g[u+68>>2]);w=ea(g[u+72>>2]);D=ea(g[u+76>>2]);z=ea(C*ea(1.10000002));C=ea(E*ea(1.10000002));g[l>>2]=ea(A*ea(1.10000002));g[l+4>>2]=z;g[l+8>>2]=C;C=ea(w*ea(1.10000002));w=ea(D*ea(1.10000002));g[m>>2]=ea(x*ea(1.10000002));g[m+4>>2]=C;g[m+8>>2]=w;w=ea(Yra(j,l,k,m,f,h));g[a+28>>2]=w;F=w;i=b;return ea(F)}return ea(0.0)}function gsa(d,e,f){d=d|0;e=ea(e);f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=Im,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0;h=i;i=i+48|0;j=h+32|0;l=h;m=c[d+8>>2]|0;n=c[d>>2]|0;o=c[d+12>>2]|0;p=c[d+4>>2]|0;q=(n|0)==0;if(!q?(b[(c[n+60>>2]|0)+2>>1]|0)==0:0)r=6;else r=3;do if((r|0)==3){if(!p){s=0;i=h;return s|0}if(!(b[(c[p+60>>2]|0)+2>>1]|0))if(q){r=7;break}else{r=6;break}else{s=0;i=h;return s|0}}while(0);if((r|0)==6?ea(g[(c[n+64>>2]|0)+124>>2])==ea(0.0):0)r=7;if((r|0)==7){if(!p){s=0;i=h;return s|0}if(ea(g[(c[p+64>>2]|0)+124>>2])==ea(0.0)){s=0;i=h;return s|0}}t=d+28|0;u=ea(g[t>>2]);if(!(u<ea(1.0))){s=0;i=h;return s|0}v=c[d+52>>2]|0;if(a[v+35>>0]|0){if(!q){w=c[n+64>>2]|0;if(ea(g[w+124>>2])==ea(0.0))x=u;else{y=ea(ea(1.0)-u);z=n+48|0;A=ea(y*ea(g[z>>2]));B=n+52|0;C=ea(y*ea(g[B>>2]));D=n+56|0;E=ea(y*ea(g[D>>2]));y=ea(u*ea(g[w+16>>2]));F=ea(u*ea(g[w+20>>2]));G=ea(A+y);y=ea(C+F);F=ea(E+ea(u*ea(g[w+24>>2])));g[z>>2]=G;g[B>>2]=y;g[D>>2]=F;D=n+32|0;g[l>>2]=ea(g[D>>2]);B=n+36|0;g[l+4>>2]=ea(g[B>>2]);z=n+40|0;g[l+8>>2]=ea(g[z>>2]);H=n+44|0;g[l+12>>2]=ea(g[H>>2]);g[l+16>>2]=G;g[l+20>>2]=y;g[l+24>>2]=F;rKa(j,u,l,w);g[D>>2]=ea(g[j>>2]);g[B>>2]=ea(g[j+4>>2]);g[z>>2]=ea(g[j+8>>2]);g[H>>2]=ea(g[j+12>>2]);x=ea(g[t>>2])}hsa(n,x,e,0)}if(!p){s=1;i=h;return s|0}x=ea(g[t>>2]);H=c[p+64>>2]|0;if(ea(g[H+124>>2])==ea(0.0))I=x;else{F=ea(ea(1.0)-x);z=p+48|0;y=ea(F*ea(g[z>>2]));B=p+52|0;G=ea(F*ea(g[B>>2]));D=p+56|0;E=ea(F*ea(g[D>>2]));F=ea(x*ea(g[H+16>>2]));C=ea(x*ea(g[H+20>>2]));A=ea(y+F);F=ea(G+C);C=ea(E+ea(x*ea(g[H+24>>2])));g[z>>2]=A;g[B>>2]=F;g[D>>2]=C;D=p+32|0;g[l>>2]=ea(g[D>>2]);B=p+36|0;g[l+4>>2]=ea(g[B>>2]);z=p+40|0;g[l+8>>2]=ea(g[z>>2]);w=p+44|0;g[l+12>>2]=ea(g[w>>2]);g[l+16>>2]=A;g[l+20>>2]=F;g[l+24>>2]=C;rKa(j,x,l,H);g[D>>2]=ea(g[j>>2]);g[B>>2]=ea(g[j+4>>2]);g[z>>2]=ea(g[j+8>>2]);g[w>>2]=ea(g[j+12>>2]);I=ea(g[t>>2])}hsa(p,I,e,0);s=1;i=h;return s|0}I=ea(ea(g[d+48>>2])*ea(-10.0));x=ea(g[d+16>>2]);C=ea(g[d+20>>2]);F=ea(g[d+24>>2]);if(((((g[k>>2]=x,c[k>>2]|0)&2139095040)>>>0<2139095040?((g[k>>2]=C,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?((g[k>>2]=F,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?ea(S(ea(ea(T(ea(ea(ea(x*x)+ea(C*C))+ea(F*F))))+ea(-1.0))))<ea(.0000999999974):0){A=ea(g[d+88>>2]);E=ea(g[d+84>>2]);G=ea(g[d+80>>2]);y=ea(g[v+104>>2]);t=(n|0)!=0;if(t){J=ea(g[v+100>>2]);v=c[n+64>>2]|0;w=c[m>>2]|0;K=ea(g[v+84>>2]);L=ea(g[w+24>>2]);M=ea(K*L);N=ea(g[v+88>>2]);O=ea(g[w+20>>2]);P=ea(M-ea(N*O));M=ea(g[w+16>>2]);Q=ea(N*M);N=ea(g[v+80>>2]);R=ea(Q-ea(L*N));L=ea(ea(O*N)-ea(K*M));M=ea(P+ea(g[v+64>>2]));P=ea(ea(g[v+68>>2])+R);R=ea(L+ea(g[v+72>>2]));U=M;V=P;W=R;X=ea(J*ea(g[v+124>>2]))}else{U=ea(0.0);V=ea(0.0);W=ea(0.0);X=ea(0.0)}v=(p|0)!=0;if(v){w=c[p+64>>2]|0;m=c[o>>2]|0;J=ea(g[w+84>>2]);R=ea(g[m+24>>2]);P=ea(J*R);M=ea(g[w+88>>2]);L=ea(g[m+20>>2]);K=ea(P-ea(M*L));P=ea(g[m+16>>2]);N=ea(M*P);M=ea(g[w+80>>2]);O=ea(N-ea(R*M));R=ea(ea(L*M)-ea(J*P));P=ea(K+ea(g[w+64>>2]));K=ea(ea(g[w+68>>2])+O);O=ea(R+ea(g[w+72>>2]));Y=P;Z=K;_=O;$=ea(y*ea(g[w+124>>2]))}else{Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0)}y=ea(Y-U);U=ea(Z-V);V=ea(_-W);W=ea(ea(F*V)+ea(ea(C*U)+ea(x*y)));_=ea(I+W);a:do if(_<ea(-9.99999997e-07)){I=ea(X+$);Z=ea(ea(ea(A+ea(1.0))*_)/I);if(!(a[d+104>>0]|0)){aa=ea(Z*x);ba=ea(Z*C);ca=ea(Z*F)}else{Y=ea(y-ea(x*W));O=ea(U-ea(C*W));K=ea(V-ea(F*W));P=ea(T(ea(ea(K*K)+ea(ea(Y*Y)+ea(O*O)))));if(P>ea(0.0)){R=ea(ea(1.0)/P);da=ea(Y*R);fa=ea(O*R);ga=ea(K*R)}else{da=Y;fa=O;ga=K}K=ea(P/I);if(!(ea(S(ea(E*Z)))>=K))ha=ea(-ea(G*Z));else ha=K;aa=ea(ea(da*ha)+ea(Z*x));ba=ea(ea(fa*ha)+ea(Z*C));ca=ea(ea(ga*ha)+ea(Z*F))}if(Z<ea(0.0)){g[d+96>>2]=ea(-Z);if(!(t?(b[(c[n+60>>2]|0)+2>>1]|0)!=0:0))r=46;do if((r|0)==46){if(v?(b[(c[p+60>>2]|0)+2>>1]|0)!=0:0)break;if(t){w=c[n+64>>2]|0;m=w+64|0;g[n>>2]=ea(g[m>>2]);o=w+68|0;g[n+4>>2]=ea(g[o>>2]);z=w+72|0;g[n+8>>2]=ea(g[z>>2]);Z=ea(X*aa);K=ea(X*ba);I=ea(X*ca);P=ea(Z+ea(g[m>>2]));Z=ea(K+ea(g[o>>2]));K=ea(I+ea(g[z>>2]));g[m>>2]=P;g[o>>2]=Z;g[z>>2]=K}if(!v)break a;z=c[p+64>>2]|0;o=z+64|0;g[p>>2]=ea(g[o>>2]);m=z+68|0;g[p+4>>2]=ea(g[m>>2]);w=z+72|0;g[p+8>>2]=ea(g[w>>2]);K=ea($*aa);Z=ea($*ba);P=ea($*ca);I=ea(ea(g[o>>2])-K);K=ea(ea(g[m>>2])-Z);Z=ea(ea(g[w>>2])-P);g[o>>2]=I;g[m>>2]=K;g[w>>2]=Z;break a}while(0);g[d+32>>2]=ea(0.0)}}while(0);if(t?(r=n+60|0,(b[(c[r>>2]|0)+2>>1]|0)==0):0){w=c[n+64>>2]|0;if(!(ea(g[w+124>>2])==ea(0.0))){ca=ea(ea(1.0)-u);m=n+48|0;$=ea(ca*ea(g[m>>2]));o=n+52|0;ba=ea(ca*ea(g[o>>2]));z=n+56|0;aa=ea(ca*ea(g[z>>2]));ca=ea(u*ea(g[w+16>>2]));X=ea(u*ea(g[w+20>>2]));F=ea($+ca);ca=ea(ba+X);X=ea(aa+ea(u*ea(g[w+24>>2])));g[m>>2]=F;g[o>>2]=ca;g[z>>2]=X;z=n+32|0;g[l>>2]=ea(g[z>>2]);o=n+36|0;g[l+4>>2]=ea(g[o>>2]);m=n+40|0;g[l+8>>2]=ea(g[m>>2]);B=n+44|0;g[l+12>>2]=ea(g[B>>2]);g[l+16>>2]=F;g[l+20>>2]=ca;g[l+24>>2]=X;rKa(j,u,l,w);g[z>>2]=ea(g[j>>2]);g[o>>2]=ea(g[j+4>>2]);g[m>>2]=ea(g[j+8>>2]);g[B>>2]=ea(g[j+12>>2])}if(f)ia=ea(g[d+32>>2])==ea(0.0);else ia=0;hsa(n,u,e,ia);ia=(c[r>>2]|0)+16|0;c[ia>>2]=(c[ia>>2]|0)+1}if(v?(ia=p+60|0,(b[(c[ia>>2]|0)+2>>1]|0)==0):0){r=c[p+64>>2]|0;if(!(ea(g[r+124>>2])==ea(0.0))){X=ea(ea(1.0)-u);B=p+48|0;ca=ea(X*ea(g[B>>2]));m=p+52|0;F=ea(X*ea(g[m>>2]));o=p+56|0;aa=ea(X*ea(g[o>>2]));X=ea(u*ea(g[r+16>>2]));ba=ea(u*ea(g[r+20>>2]));$=ea(ca+X);X=ea(F+ba);ba=ea(aa+ea(u*ea(g[r+24>>2])));g[B>>2]=$;g[m>>2]=X;g[o>>2]=ba;o=p+32|0;g[l>>2]=ea(g[o>>2]);m=p+36|0;g[l+4>>2]=ea(g[m>>2]);B=p+40|0;g[l+8>>2]=ea(g[B>>2]);z=p+44|0;g[l+12>>2]=ea(g[z>>2]);g[l+16>>2]=$;g[l+20>>2]=X;g[l+24>>2]=ba;rKa(j,u,l,r);g[o>>2]=ea(g[j>>2]);g[m>>2]=ea(g[j+4>>2]);g[B>>2]=ea(g[j+8>>2]);g[z>>2]=ea(g[j+12>>2])}if(f)ja=ea(g[d+32>>2])==ea(0.0);else ja=0;hsa(p,u,e,ja);ja=(c[ia>>2]|0)+16|0;c[ja>>2]=(c[ja>>2]|0)+1}ja=d+32|0;ba=ea(g[ja>>2]);if(ba>ea(0.0)){if(t?(b[(c[n+60>>2]|0)+2>>1]|0)==0:0){d=c[n+64>>2]|0;if(!(ea(g[d+124>>2])==ea(0.0))){X=ea(ea(1.0)-ba);ia=n+48|0;$=ea(X*ea(g[ia>>2]));z=n+52|0;aa=ea(X*ea(g[z>>2]));B=n+56|0;F=ea(X*ea(g[B>>2]));X=ea(ba*ea(g[d+16>>2]));ca=ea(ba*ea(g[d+20>>2]));ha=ea($+X);X=ea(aa+ca);ca=ea(F+ea(ba*ea(g[d+24>>2])));g[ia>>2]=ha;g[z>>2]=X;g[B>>2]=ca;B=n+32|0;g[l>>2]=ea(g[B>>2]);z=n+36|0;g[l+4>>2]=ea(g[z>>2]);ia=n+40|0;g[l+8>>2]=ea(g[ia>>2]);m=n+44|0;g[l+12>>2]=ea(g[m>>2]);g[l+16>>2]=ha;g[l+20>>2]=X;g[l+24>>2]=ca;rKa(j,ba,l,d);g[B>>2]=ea(g[j>>2]);g[z>>2]=ea(g[j+4>>2]);g[ia>>2]=ea(g[j+8>>2]);g[m>>2]=ea(g[j+12>>2])}if(f)hsa(n,ea(g[ja>>2]),e,1)}if(v?(b[(c[p+60>>2]|0)+2>>1]|0)==0:0){ba=ea(g[ja>>2]);m=c[p+64>>2]|0;if(!(ea(g[m+124>>2])==ea(0.0))){ca=ea(ea(1.0)-ba);ia=p+48|0;X=ea(ca*ea(g[ia>>2]));z=p+52|0;ha=ea(ca*ea(g[z>>2]));B=p+56|0;F=ea(ca*ea(g[B>>2]));ca=ea(ba*ea(g[m+16>>2]));aa=ea(ba*ea(g[m+20>>2]));$=ea(X+ca);ca=ea(ha+aa);aa=ea(F+ea(ba*ea(g[m+24>>2])));g[ia>>2]=$;g[z>>2]=ca;g[B>>2]=aa;B=p+32|0;g[l>>2]=ea(g[B>>2]);z=p+36|0;g[l+4>>2]=ea(g[z>>2]);ia=p+40|0;g[l+8>>2]=ea(g[ia>>2]);d=p+44|0;g[l+12>>2]=ea(g[d>>2]);g[l+16>>2]=$;g[l+20>>2]=ca;g[l+24>>2]=aa;rKa(j,ba,l,m);g[B>>2]=ea(g[j>>2]);g[z>>2]=ea(g[j+4>>2]);g[ia>>2]=ea(g[j+8>>2]);g[d>>2]=ea(g[j+12>>2])}if(f)hsa(p,ea(g[ja>>2]),e,1)}}if(t)b[(c[n+60>>2]|0)+2>>1]=1;if(!v){s=1;i=h;return s|0}b[(c[p+60>>2]|0)+2>>1]=1;s=1;i=h;return s|0}if(q){s=1;i=h;return s|0}q=n+60|0;if(b[(c[q>>2]|0)+2>>1]|0){s=1;i=h;return s|0}p=n+64|0;v=c[p>>2]|0;if(!(ea(g[v+124>>2])==ea(0.0))){e=ea(ea(1.0)-u);t=n+48|0;ba=ea(e*ea(g[t>>2]));ja=n+52|0;aa=ea(e*ea(g[ja>>2]));f=n+56|0;ca=ea(e*ea(g[f>>2]));e=ea(u*ea(g[v+16>>2]));$=ea(u*ea(g[v+20>>2]));F=ea(ba+e);e=ea(aa+$);$=ea(ca+ea(u*ea(g[v+24>>2])));g[t>>2]=F;g[ja>>2]=e;g[f>>2]=$;f=n+32|0;g[l>>2]=ea(g[f>>2]);ja=n+36|0;g[l+4>>2]=ea(g[ja>>2]);t=n+40|0;g[l+8>>2]=ea(g[t>>2]);d=n+44|0;g[l+12>>2]=ea(g[d>>2]);g[l+16>>2]=F;g[l+20>>2]=e;g[l+24>>2]=$;rKa(j,u,l,v);g[f>>2]=ea(g[j>>2]);g[ja>>2]=ea(g[j+4>>2]);g[t>>2]=ea(g[j+8>>2]);g[d>>2]=ea(g[j+12>>2])}j=c[p>>2]|0;if(ea(g[j+124>>2])==ea(0.0))ka=c[q>>2]|0;else{$=ea(g[n+48>>2]);e=ea(g[n+52>>2]);F=ea(g[n+56>>2]);g[j+16>>2]=$;g[j+20>>2]=e;g[j+24>>2]=F;F=ea(g[n+32>>2]);e=ea(g[n+36>>2]);$=ea(g[n+40>>2]);ca=ea(g[n+44>>2]);g[j>>2]=F;g[j+4>>2]=e;g[j+8>>2]=$;g[j+12>>2]=ca;ca=ea(ea(1.0)-u);j=c[q>>2]|0;q=j+4|0;u=ea(ca*ea(g[q>>2]));n=u>ea(.00999999977);g[q>>2]=n?u:ea(.00999999977);ka=j}j=ka+16|0;c[j>>2]=(c[j>>2]|0)+1;s=1;i=h;return s|0}function hsa(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;f=i;h=c[a+64>>2]|0;if(ea(g[h+124>>2])==ea(0.0)){i=f;return}j=h+16|0;k=a+32|0;l=a+36|0;m=a+40|0;n=a+44|0;o=ea(g[a+48>>2]);p=ea(g[a+52>>2]);q=ea(g[a+56>>2]);if(e){g[j>>2]=o;g[h+20>>2]=p;g[h+24>>2]=q;r=ea(g[k>>2]);s=ea(g[l>>2]);t=ea(g[m>>2]);u=ea(g[n>>2]);g[h>>2]=r;g[h+4>>2]=s;g[h+8>>2]=t;g[h+12>>2]=u;v=ea(ea(1.0)-b)}else{u=ea(ea(g[h+64>>2])*d);t=ea(ea(g[h+68>>2])*d);s=ea(ea(1.0)-b);b=ea(p+ea(s*t));t=ea(q+ea(s*ea(ea(g[h+72>>2])*d)));g[j>>2]=ea(o+ea(s*u));g[h+20>>2]=b;g[h+24>>2]=t;t=ea(ea(g[h+80>>2])*d);b=ea(ea(g[h+84>>2])*d);u=ea(s*t);t=ea(s*b);b=ea(s*ea(ea(g[h+88>>2])*d));d=ea(T(ea(ea(ea(u*u)+ea(t*t))+ea(b*b))));if(d>ea(9.99999968e-21)){o=ea(ea(1.0)/d);w=ea(u*o);x=ea(t*o);y=ea(b*o)}else{w=ea(1.0);x=ea(0.0);y=ea(0.0)}o=ea(d*ea(.5));d=ea(+W(+o));b=ea(+V(+o));o=ea(w*d);w=ea(x*d);x=ea(y*d);d=ea(g[k>>2]);y=ea(g[l>>2]);t=ea(g[m>>2]);u=ea(g[n>>2]);q=ea(ea(ea(o*t)+ea(ea(b*y)+ea(w*u)))-ea(x*d));p=ea(ea(ea(w*d)+ea(ea(b*t)+ea(x*u)))-ea(o*y));r=ea(ea(ea(ea(b*u)-ea(o*d))-ea(w*y))-ea(x*t));g[h>>2]=ea(ea(ea(x*y)+ea(ea(b*d)+ea(o*u)))-ea(w*t));g[h+4>>2]=q;g[h+8>>2]=p;g[h+12>>2]=r;v=s}h=(c[a+60>>2]|0)+4|0;s=ea(v*ea(g[h>>2]));a=s>ea(.00999999977);g[h>>2]=a?s:ea(.00999999977);i=f;return}function isa(a){a=a|0;c[a+92>>2]=0;c[a+96>>2]=0;return}function jsa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+92|0;if((c[d>>2]|0)==((c[a+260>>2]|0)+-1|0)){e=a+112|0;f=c[e>>2]|0;g=a+100|0;h=c[g>>2]|0;j=c[h+(f<<3)+4>>2]|0;if((j|0)==(0-(f<<7)|0))k=h;else{l=j+(f<<7)|0;f=h;h=0;while(1){c[(c[(c[f+(h>>>7<<3)>>2]|0)+((h&127)*20|0)+8>>2]|0)+60>>2]=0;h=h+1|0;j=c[g>>2]|0;if((h|0)==(l|0)){k=j;break}else f=j}}c[e>>2]=0;c[k+4>>2]=0}c[a+144>>2]=0;c[(c[a+132>>2]|0)+4>>2]=0;k=c[a+192>>2]|0;if(!k){m=c[d>>2]|0;n=m+1|0;c[d>>2]=n;i=b;return}e=a+208|0;if(!(c[e>>2]|0)){m=c[d>>2]|0;n=m+1|0;c[d>>2]=n;i=b;return}PEi(c[a+184>>2]|0,-1,k<<2|0)|0;k=a+188|0;f=c[k>>2]|0;l=f+-1|0;h=a+180|0;g=c[h>>2]|0;if(!l){o=f;p=g}else{f=g;g=0;while(1){j=g+1|0;q=c[h>>2]|0;c[q+(g<<2)>>2]=j;if((j|0)==(l|0))break;else{f=q;g=j}}o=c[k>>2]|0;p=q}c[p+(o+-1<<2)>>2]=-1;c[a+200>>2]=0;c[e>>2]=0;m=c[d>>2]|0;n=m+1|0;c[d>>2]=n;i=b;return}function ksa(f,h,j,k){f=f|0;h=ea(h);j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=Im,xb=Im,yb=Im,zb=0,Ab=Im,Bb=Im,Cb=Im,Db=0,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=0,gc=Im,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0;l=i;i=i+224|0;m=l+214|0;n=l+88|0;o=l+124|0;p=l+12|0;q=l+112|0;r=l+152|0;s=l+176|0;t=l+40|0;u=l+184|0;v=l+96|0;w=l+68|0;x=l+108|0;y=l;z=l+212|0;A=l+164|0;B=l+80|0;C=l+215|0;a[f+88>>0]=k&1;k=f+264|0;D=c[k>>2]|0;E=D+5868|0;c[D+5872>>2]=0;PEi(c[D+1344>>2]|0,0,c[D+1348>>2]<<2|0)|0;c[D+1356>>2]=0;c[D+1360>>2]=0;c[D+1364>>2]=0;if((c[f+92>>2]|0)!=0?(F=f+96|0,(c[F>>2]|0)==0):0)G=F;else{F=c[k>>2]|0;H=f+96|0;if(!(c[F+7380>>2]|0))G=H;else{c[H>>2]=0;H=CTa(c[F+224>>2]|0)|0;if(!H){I=mKa()|0;J=c[(c[I>>2]|0)+8>>2]|0;K=pKa()|0;L=mo[c[(c[K>>2]|0)+24>>2]&4095](K)|0;K=Bn[J&255](I,9459,L?490864:544544,490760,82)|0;if(K){L=K+19&-16;c[L+-4>>2]=L-K;K=L;if(!L)M=K;else{pya(K,F);M=K}}else M=0}else M=H;H=f+252|0;c[H>>2]=M;g[M+8764>>2]=h;M=f+212|0;K=f+224|0;c[K>>2]=0;c[(c[M>>2]|0)+4>>2]=0;F=f+228|0;L=f+232|0;c[L>>2]=0;I=f+116|0;c[f+128>>2]=0;c[(c[I>>2]|0)+4>>2]=0;J=c[k>>2]|0;N=c[J+6736>>2]|0;O=c[N+8>>2]|0;P=N;N=c[P>>2]|0;Q=c[P+4>>2]|0;P=e[268328]|e[268329]<<16;R=(O|0)==0|(P&16711680|0)==0;if(R)S=J;else{Dn[c[(c[O>>2]|0)+8>>2]&511](O,P&65535,N,Q);S=c[k>>2]|0}J=S+1332|0;T=S+1336|0;U=c[T>>2]&2147483647;a:do if(U){V=c[J>>2]|0;W=0;while(1){X=c[V+(W<<2)>>2]|0;if(X)break;Y=W+1|0;if(Y>>>0<U>>>0)W=Y;else break a}Y=c[425648+((da(X&0-X,125613361)|0)>>>27<<2)>>2]|W<<5;Z=X+-1&X;b:do if(!Z){_=W;while(1){$=_+1|0;if($>>>0>=U>>>0){aa=$;ba=0;break b}ca=c[V+($<<2)>>2]|0;if(!ca)_=$;else{aa=$;ba=ca;break}}}else{aa=W;ba=Z}while(0);if((Y|0)!=-1){Z=f+192|0;W=f+132|0;V=n+4|0;_=f+172|0;ca=p+4|0;$=o+4|0;fa=p+8|0;ga=o+8|0;ha=p+12|0;ia=o+12|0;ja=p+16|0;ka=o+16|0;la=p+20|0;ma=o+20|0;na=p+24|0;oa=o+24|0;pa=q+4|0;qa=q+8|0;ra=r+4|0;sa=r+8|0;ta=s+4|0;ua=u+4|0;va=t+4|0;wa=u+8|0;xa=t+8|0;ya=u+12|0;za=t+12|0;Aa=u+16|0;Ba=t+16|0;Ca=u+20|0;Da=t+20|0;Ea=u+24|0;Fa=t+24|0;Ga=v+4|0;Ha=v+8|0;Ia=w+4|0;Ja=w+8|0;Ka=f+100|0;La=f+112|0;Ma=f+184|0;Na=f+176|0;Oa=f+180|0;Pa=aa;Qa=ba;Ra=S;Sa=Y;Ta=0;c:while(1){Ua=Pa<<5;Va=Ra;Wa=Qa;Xa=Sa;Ya=Ta;while(1){Za=c[(c[Va+720>>2]|0)+(Xa>>>(c[Va+708>>2]|0)<<2)>>2]|0;_a=(c[Va+696>>2]|0)+-1&Xa;$a=Za+(_a<<7)|0;ab=Za+(_a<<7)+8|0;if((c[ab>>2]&2|0)!=0?(b[Za+(_a<<7)+38>>1]&24)!=24:0){bb=c[Za+(_a<<7)+80>>2]|0;cb=c[Za+(_a<<7)+84>>2]|0;db=c[Za+(_a<<7)+88>>2]|0;eb=c[Za+(_a<<7)+92>>2]|0;fb=c[$a>>2]|0;gb=c[Za+(_a<<7)+4>>2]|0;hb=c[Z>>2]|0;do if(!hb){ib=0;jb=42}else{kb=db;lb=kb+~(kb<<15)|0;kb=(lb>>>10^lb)*9|0;lb=kb>>>6^kb;kb=lb+~(lb<<11)|0;lb=bb;mb=lb+~(lb<<15)|0;lb=(mb>>>10^mb)*9|0;mb=lb>>>6^lb;lb=mb+~(mb<<11)|0;mb=hb+-1|0;nb=c[Ma>>2]|0;ob=c[nb+(((kb>>>16^kb^(lb^-57320555^lb>>>16)*1000007)&mb)<<2)>>2]|0;d:do if((ob|0)==-1)pb=0;else{lb=c[Na>>2]|0;kb=ob;while(1){if((c[lb+(kb*12|0)>>2]|0)==(bb|0)?(c[lb+(kb*12|0)+4>>2]|0)==(db|0):0)break;qb=c[(c[Oa>>2]|0)+(kb<<2)>>2]|0;if((qb|0)==-1){pb=0;break d}else kb=qb}pb=lb+(kb*12|0)|0}while(0);ob=eb;qb=ob+~(ob<<15)|0;ob=(qb>>>10^qb)*9|0;qb=ob>>>6^ob;ob=qb+~(qb<<11)|0;qb=cb;rb=qb+~(qb<<15)|0;qb=(rb>>>10^rb)*9|0;rb=qb>>>6^qb;qb=rb+~(rb<<11)|0;rb=c[nb+((mb&(ob>>>16^ob^(qb^-57320555^qb>>>16)*1000007))<<2)>>2]|0;e:do if((rb|0)==-1)sb=0;else{qb=c[Na>>2]|0;ob=rb;while(1){if((c[qb+(ob*12|0)>>2]|0)==(cb|0)?(c[qb+(ob*12|0)+4>>2]|0)==(eb|0):0)break;tb=c[(c[Oa>>2]|0)+(ob<<2)>>2]|0;if((tb|0)==-1){sb=0;break e}else ob=tb}sb=qb+(ob*12|0)|0}while(0);if(!pb)ub=0;else ub=c[pb+8>>2]|0;if(!sb)vb=0;else vb=c[sb+8>>2]|0;if(!ub){ib=vb;jb=42;break}h=ea(g[ub+8>>2]);wb=ea(g[ub+56>>2]);xb=ea(wb-ea(g[ub+28>>2]));wb=ea(g[ub+60>>2]);yb=ea(wb-ea(g[ub+32>>2]));wb=ea(g[ub+64>>2]);zb=vb;Ab=xb;Bb=yb;Cb=ea(wb-ea(g[ub+36>>2]));Db=ub;Eb=h}while(0);if((jb|0)==42){jb=0;hb=L$a(W)|0;c[n>>2]=bb;c[V>>2]=db;rb=M$a(_,n,m)|0;if(!((a[m>>0]|0)!=0|(rb|0)==0)){c[rb>>2]=c[n>>2];c[rb+4>>2]=c[V>>2];c[rb+8>>2]=hb}c[hb+4>>2]=bb;c[hb>>2]=db;bsa(o,hb,fb);if(!fb){h=ea(g[o>>2]);g[p>>2]=h;wb=ea(g[$>>2]);g[ca>>2]=wb;yb=ea(g[ga>>2]);g[fa>>2]=yb;xb=ea(g[ia>>2]);g[ha>>2]=xb;Fb=ea(g[ka>>2]);g[ja>>2]=Fb;Gb=ea(g[ma>>2]);g[la>>2]=Gb;Hb=ea(g[oa>>2]);g[na>>2]=Hb;Ib=Fb;Jb=Fb;Kb=Gb;Lb=Gb;Mb=Hb;Nb=Hb;Ob=h;Pb=wb;Qb=yb;Rb=xb}else{csa(p,hb,fb);xb=ea(g[ka>>2]);yb=ea(g[ja>>2]);wb=ea(g[ma>>2]);h=ea(g[la>>2]);Hb=ea(g[oa>>2]);Gb=ea(g[na>>2]);Fb=ea(g[p>>2]);Sb=ea(g[ca>>2]);Tb=ea(g[fa>>2]);Ib=xb;Jb=yb;Kb=wb;Lb=h;Mb=Hb;Nb=Gb;Ob=Fb;Pb=Sb;Qb=Tb;Rb=ea(g[ha>>2])}Tb=ea(Ib-Jb);Sb=ea(Kb-Lb);Fb=ea(Mb-Nb);Gb=ea(pMa(db+36|0,q,r,o,0));Hb=ea(ea(g[q>>2])-Tb);h=ea(ea(g[pa>>2])-Sb);wb=ea(ea(g[qa>>2])-Fb);g[hb+80>>2]=Hb;g[hb+84>>2]=h;g[hb+88>>2]=wb;g[hb+68>>2]=ea(g[r>>2]);g[hb+72>>2]=ea(g[ra>>2]);g[hb+76>>2]=ea(g[sa>>2]);g[hb+8>>2]=Gb;g[hb+12>>2]=Ob;g[hb+16>>2]=Pb;g[hb+20>>2]=Qb;g[hb+24>>2]=Rb;g[hb+28>>2]=Jb;g[hb+32>>2]=Lb;g[hb+36>>2]=Nb;g[hb+40>>2]=ea(g[o>>2]);g[hb+44>>2]=ea(g[$>>2]);g[hb+48>>2]=ea(g[ga>>2]);g[hb+52>>2]=ea(g[ia>>2]);g[hb+56>>2]=ea(g[ka>>2]);g[hb+60>>2]=ea(g[ma>>2]);g[hb+64>>2]=ea(g[oa>>2]);c[hb+92>>2]=0;zb=ib;Ab=Tb;Bb=Sb;Cb=Fb;Db=hb;Eb=Gb}if(!zb){hb=L$a(W)|0;c[hb+4>>2]=cb;c[hb>>2]=eb;c[s>>2]=cb;c[ta>>2]=eb;rb=M$a(_,s,m)|0;if(!((a[m>>0]|0)!=0|(rb|0)==0)){c[rb>>2]=c[s>>2];c[rb+4>>2]=c[ta>>2];c[rb+8>>2]=hb}bsa(t,hb,gb);if(!gb){Gb=ea(g[t>>2]);g[u>>2]=Gb;Fb=ea(g[va>>2]);g[ua>>2]=Fb;Sb=ea(g[xa>>2]);g[wa>>2]=Sb;Tb=ea(g[za>>2]);g[ya>>2]=Tb;wb=ea(g[Ba>>2]);g[Aa>>2]=wb;h=ea(g[Da>>2]);g[Ca>>2]=h;Hb=ea(g[Fa>>2]);g[Ea>>2]=Hb;Ub=wb;Vb=wb;Wb=h;Xb=h;Yb=Hb;Zb=Hb;_b=Gb;$b=Fb;ac=Sb;bc=Tb}else{csa(u,hb,gb);Tb=ea(g[Ba>>2]);Sb=ea(g[Aa>>2]);Fb=ea(g[Da>>2]);Gb=ea(g[Ca>>2]);Hb=ea(g[Fa>>2]);h=ea(g[Ea>>2]);wb=ea(g[u>>2]);yb=ea(g[ua>>2]);xb=ea(g[wa>>2]);Ub=Tb;Vb=Sb;Wb=Fb;Xb=Gb;Yb=Hb;Zb=h;_b=wb;$b=yb;ac=xb;bc=ea(g[ya>>2])}xb=ea(Ub-Vb);yb=ea(Wb-Xb);wb=ea(Yb-Zb);h=ea(pMa(eb+36|0,v,w,t,0));Hb=ea(ea(g[v>>2])-xb);Gb=ea(ea(g[Ga>>2])-yb);Fb=ea(ea(g[Ha>>2])-wb);g[hb+80>>2]=Hb;g[hb+84>>2]=Gb;g[hb+88>>2]=Fb;g[hb+68>>2]=ea(g[w>>2]);g[hb+72>>2]=ea(g[Ia>>2]);g[hb+76>>2]=ea(g[Ja>>2]);g[hb+8>>2]=h;g[hb+12>>2]=_b;g[hb+16>>2]=$b;g[hb+20>>2]=ac;g[hb+24>>2]=bc;g[hb+28>>2]=Vb;g[hb+32>>2]=Xb;g[hb+36>>2]=Zb;g[hb+40>>2]=ea(g[t>>2]);g[hb+44>>2]=ea(g[va>>2]);g[hb+48>>2]=ea(g[xa>>2]);g[hb+52>>2]=ea(g[za>>2]);g[hb+56>>2]=ea(g[Ba>>2]);g[hb+60>>2]=ea(g[Da>>2]);g[hb+64>>2]=ea(g[Fa>>2]);c[hb+92>>2]=0;cc=xb;dc=yb;ec=wb;fc=hb;gc=h}else{h=ea(g[zb+8>>2]);wb=ea(g[zb+56>>2]);yb=ea(wb-ea(g[zb+28>>2]));wb=ea(g[zb+60>>2]);xb=ea(wb-ea(g[zb+32>>2]));wb=ea(g[zb+64>>2]);cc=yb;dc=xb;ec=ea(wb-ea(g[zb+36>>2]));fc=zb;gc=h}hb=(fb|0)==0;if(!hb){rb=fb+60|0;mb=c[rb>>2]|0;if(!mb){nb=N$a(Ka)|0;c[rb>>2]=nb;kb=c[La>>2]|0;b[nb>>1]=(kb<<7)+65535+(c[(c[Ka>>2]|0)+(kb<<3)+4>>2]|0);c[nb+8>>2]=fb;nb=c[rb>>2]|0;g[nb+4>>2]=ea(1.0);c[nb+12>>2]=0;nb=c[rb>>2]|0;c[nb+16>>2]=0;hc=nb}else hc=mb;b[hc+2>>1]=0}mb=(gb|0)==0;f:do if(!mb){nb=gb+60|0;rb=c[nb>>2]|0;if(!rb){kb=N$a(Ka)|0;c[nb>>2]=kb;lb=c[La>>2]|0;b[kb>>1]=(lb<<7)+65535+(c[(c[Ka>>2]|0)+(lb<<3)+4>>2]|0);c[kb+8>>2]=gb;kb=c[nb>>2]|0;g[kb+4>>2]=ea(1.0);c[kb+12>>2]=0;kb=c[nb>>2]|0;c[kb+16>>2]=0;ic=kb}else ic=rb;b[ic+2>>1]=0;if(hb|mb)break;if(ea(g[(c[fb+64>>2]|0)+124>>2])==ea(0.0))break;if(ea(g[(c[gb+64>>2]|0)+124>>2])==ea(0.0))break;rb=fb+60|0;kb=gb+60|0;nb=c[kb>>2]|0;lb=c[(c[rb>>2]|0)+12>>2]|0;if(lb){tb=lb;do{if((c[tb>>2]|0)==(nb|0))break f;tb=c[tb+4>>2]|0}while((tb|0)!=0)}tb=O$a(I)|0;nb=O$a(I)|0;c[tb>>2]=c[kb>>2];c[nb>>2]=c[rb>>2];lb=(c[rb>>2]|0)+12|0;c[tb+4>>2]=c[lb>>2];c[lb>>2]=tb;tb=(c[kb>>2]|0)+12|0;c[nb+4>>2]=c[tb>>2];c[tb>>2]=nb}while(0);mb=P$a(M)|0;c[mb>>2]=fb;c[mb+4>>2]=gb;c[mb+8>>2]=Db;c[mb+12>>2]=fc;if(!(a[bb+28>>0]&8))jc=(d[cb+28>>0]|0)>>>3&1;else jc=1;a[mb+104>>0]=jc;g[mb+28>>2]=ea(3402823469999999843913219.0e14);hb=a[Za+(_a<<7)+112>>0]|0;eb=hb&255;c[mb+60>>2]=eb;db=a[Za+(_a<<7)+113>>0]|0;nb=db&255;c[mb+64>>2]=nb;c[mb+52>>2]=$a;c[mb+56>>2]=-1;a[mb+68>>0]=0;c[mb+72>>2]=-1;a[mb+69>>0]=c[ab>>2]&1;g[mb+96>>2]=ea(0.0);mb=(hb&255)<(db&255);db=c[k>>2]|0;hb=db+((mb?eb:nb)*28|0)+((mb?nb:eb)<<2)+6948|0;c[hb>>2]=(c[hb>>2]|0)+1;h=ea(Eb+gc);if(Ya){kc=db;lc=1}else{wb=ea(Ab-cc);xb=ea(Bb-dc);yb=ea(Cb-ec);kc=db;lc=ea(ea(yb*yb)+ea(ea(xb*xb)+ea(wb*wb)))>=ea(h*h)}}else{kc=Va;lc=Ya}if(!Wa){jb=73;break c}Xa=c[425648+((da(Wa&0-Wa,125613361)|0)>>>27<<2)>>2]|Ua;Wa=Wa+-1&Wa;mc=c[T>>2]&2147483647;if(!Wa){nc=Pa;break}if((Xa|0)==-1){jb=78;break c}else{Va=kc;Ya=lc}}while(1){nc=nc+1|0;if(nc>>>0>=mc>>>0){oc=0;break}Ya=c[(c[J>>2]|0)+(nc<<2)>>2]|0;if(Ya){oc=Ya;break}}if((Xa|0)==-1){jb=78;break}else{Pa=nc;Qa=oc;Ra=kc;Sa=Xa;Ta=lc}}if((jb|0)==73){if(!lc)break}else if((jb|0)==78?!lc:0)break;if(!R)Dn[c[(c[O>>2]|0)+12>>2]&511](O,P&65535,N,Q);Ta=c[K>>2]|0;Sa=c[(c[M>>2]|0)+(Ta<<3)+4>>2]|0;Ra=Sa+(Ta<<7)|0;Qa=f+236|0;if((c[Qa>>2]&2147483647)>>>0<Ra>>>0)Q$a(F,Ra);if(Ra){Pa=Sa+(Ta<<7)|0;Ta=0;do{Sa=(c[(c[M>>2]|0)+(Ta>>>7<<3)>>2]|0)+((Ta&127)*108|0)|0;c[x>>2]=Sa;Ka=c[L>>2]|0;if((c[Qa>>2]&2147483647)>>>0>Ka>>>0){La=(c[F>>2]|0)+(Ka<<2)|0;if(La)c[La>>2]=Sa;c[L>>2]=Ka+1}else R$a(F,x)|0;Ta=Ta+1|0}while((Ta|0)!=(Pa|0))}Pa=Ra>>>1|Ra;Ta=Pa>>>2|Pa;Pa=Ta>>>4|Ta;Ta=Pa>>>8|Pa;Pa=(Ta>>>16|Ta)+1|0;if((c[D+5876>>2]&2147483647)>>>0<Pa>>>0)S$a(E,Pa);Pa=f+112|0;Ta=c[Pa>>2]|0;Qa=f+100|0;Ka=c[(c[Qa>>2]|0)+(Ta<<3)+4>>2]|0;Sa=Ka+(Ta<<7)|0;c[y>>2]=0;c[y+4>>2]=0;La=y+8|0;c[La>>2]=0;b[z>>1]=0;tWa(y,Sa,z);c[A>>2]=0;Fa=A+4|0;c[Fa>>2]=0;Da=A+8|0;c[Da>>2]=0;Ba=(Sa|0)==0;if(!Ba)T$a(A,Sa);c[Fa>>2]=Sa;Fa=f+160|0;za=f+164|0;c[za>>2]=0;xa=Sa+1|0;if((c[f+168>>2]&2147483647)>>>0<xa>>>0)uWa(Fa,xa);c[za>>2]=xa;if(Ba)pc=0;else{PEi(c[y>>2]|0,-1,Ka+(Ta<<7)<<1|0)|0;Ba=Ka+(Ta<<7)|0;Ta=c[y>>2]|0;Ka=0;xa=0;while(1){za=Ta+(xa<<1)|0;if((b[za>>1]|0)==-1){va=(c[(c[Qa>>2]|0)+(xa>>>7<<3)>>2]|0)+((xa&127)*20|0)|0;b[za>>1]=Ka;za=c[A>>2]|0;c[za>>2]=va;Ja=0;Ia=1;Ha=va;while(1){va=Ia+-1|0;Ga=c[za+((va>>>0>1?Ia+-2|0:0)<<2)>>2]|0;ya=c[Ha+12>>2]|0;if(!ya){qc=Ja;rc=va;sc=Ga}else{wa=Ja;ua=ya;ya=va;va=Ga;while(1){Ga=c[ua>>2]|0;Ea=Ta+(e[Ga>>1]<<1)|0;if((b[Ea>>1]|0)==-1){b[Ea>>1]=Ka;c[za+(ya<<2)>>2]=Ga;tc=wa+1<<16>>16;uc=ya+1|0;vc=c[ua>>2]|0}else{tc=wa;uc=ya;vc=va}ua=c[ua+4>>2]|0;if(!ua){qc=tc;rc=uc;sc=vc;break}else{wa=tc;ya=uc;va=vc}}}if(!rc)break;else{Ja=qc;Ia=rc;Ha=sc}}b[(c[Fa>>2]|0)+((Ka&65535)<<1)>>1]=(qc&65535)+1;wc=Ka+1<<16>>16}else wc=Ka;xa=xa+1|0;if((xa|0)==(Ba|0)){pc=wc;break}else Ka=wc}}Ka=f+240|0;c[f+244>>2]=0;Ba=pc&65535;c[B>>2]=0;xUa(Ka,Ba,B);xa=c[L>>2]|0;if(xa){Ta=c[F>>2]|0;Ra=c[Ka>>2]|0;Ka=c[y>>2]|0;Ha=0;do{Ia=c[Ta+(Ha<<2)>>2]|0;Ja=c[Ia>>2]|0;do if(!Ja)xc=-1;else{if(ea(g[(c[Ja+64>>2]|0)+124>>2])==ea(0.0)){xc=-1;break}xc=e[Ka+(e[c[Ja+60>>2]>>1]<<1)>>1]|0}while(0);Ja=c[Ia+4>>2]|0;do if(!Ja)yc=-1;else{if(ea(g[(c[Ja+64>>2]|0)+124>>2])==ea(0.0)){yc=-1;break}yc=e[Ka+(e[c[Ja+60>>2]>>1]<<1)>>1]|0}while(0);Ja=xc>>>0<yc>>>0?xc:yc;c[Ia+56>>2]=Ja;za=Ra+(Ja<<2)|0;c[za>>2]=(c[za>>2]|0)+1;Ha=Ha+1|0}while((Ha|0)!=(xa|0))}xa=Ba+1|0;Ha=c[Fa>>2]|0;Ra=0;Ka=0;Ta=0;while(1){za=Ha+(Ra<<1)|0;Ja=b[za>>1]|0;b[za>>1]=Ta;Ka=Ka+1<<16>>16;Ra=Ka&65535;if(Ra>>>0>=xa>>>0)break;else Ta=(Ja&65535)+(Ta&65535)&65535}Ta=f+148|0;xa=f+152|0;c[xa>>2]=0;if((c[f+156>>2]&2147483647)>>>0<Sa>>>0)U$a(Ta,Sa);c[xa>>2]=Sa;xa=c[Pa>>2]|0;Ra=xa<<7;Ka=c[Qa>>2]|0;if((c[Ka+(xa<<3)+4>>2]|0)!=(0-Ra|0)){Ha=c[y>>2]|0;Ba=Ka;Ka=0;do{Ja=Ka&127;za=c[Ba+(Ka>>>7<<3)>>2]|0;Xa=(c[Fa>>2]|0)+(e[Ha+(e[za+(Ja*20|0)>>1]<<1)>>1]<<1)|0;va=e[Xa>>1]|0;b[Xa>>1]=va+1;c[(c[Ta>>2]|0)+(va<<2)>>2]=za+(Ja*20|0);Ka=Ka+1|0;Ba=c[Qa>>2]|0}while(Ka>>>0<((c[Ba+(xa<<3)+4>>2]|0)+Ra|0)>>>0)}Ra=f+56|0;c[f+72>>2]=1;xa=f+68|0;c[xa>>2]=j;if(j){ko[c[(c[j>>2]|0)+16>>2]&4095](j);c[f+64>>2]=c[(c[xa>>2]|0)+8>>2]}xa=f+28|0;c[f+44>>2]=1;Ba=f+40|0;c[Ba>>2]=Ra;ko[c[(c[Ra>>2]|0)+16>>2]&4095](Ra);c[f+36>>2]=c[(c[Ba>>2]|0)+8>>2];c[f+16>>2]=1;Ba=f+12|0;c[Ba>>2]=xa;ko[c[(c[xa>>2]|0)+16>>2]&4095](xa);c[f+8>>2]=c[(c[Ba>>2]|0)+8>>2];V$a(c[F>>2]|0,c[L>>2]|0,C,m);Ba=c[L>>2]|0;Ka=c[(c[k>>2]|0)+6728>>2]|0;Qa=mo[c[(c[Ka>>2]|0)+16>>2]&4095](Ka)|0;Ka=mo[c[(c[Qa>>2]|0)+4>>2]&4095](Qa)|0;Qa=(Ba>>>0)/((Ka>>>0>1?Ka:1)>>>0)|0;Ka=f+256|0;c[Ka>>2]=(Qa|0)==0?1:Qa;if(Ba)if(!f){Qa=0;do{Ta=c[(c[k>>2]|0)+6732>>2]|0;oTa(c[Ta>>2]|0);Ha=vXa(Ta,28,16)|0;pTa(c[Ta>>2]|0);Ta=(c[Ka>>2]|0)+Qa|0;if(!Ha)zc=0;else{Fa=(c[F>>2]|0)+(Qa<<2)|0;b[Ha+4>>1]=-1;b[Ha+6>>1]=0;c[Ha+8>>2]=0;c[Ha>>2]=443968;c[Ha+12>>2]=0;c[Ha+16>>2]=0;c[Ha>>2]=487648;c[Ha+20>>2]=Fa;c[Ha+24>>2]=(Ba>>>0<Ta>>>0?Ba:Ta)-Qa;zc=Ha}Ha=c[(c[k>>2]|0)+6728>>2]|0;c[zc+16>>2]=1;c[zc+12>>2]=f;c[zc+8>>2]=Ha;ko[c[(c[zc>>2]|0)+20>>2]&4095](zc);Qa=(c[Ka>>2]|0)+Qa|0}while(Qa>>>0<Ba>>>0)}else{Qa=0;do{Ha=c[(c[k>>2]|0)+6732>>2]|0;oTa(c[Ha>>2]|0);Ta=vXa(Ha,28,16)|0;pTa(c[Ha>>2]|0);Ha=(c[Ka>>2]|0)+Qa|0;if(!Ta)Ac=0;else{Fa=(c[F>>2]|0)+(Qa<<2)|0;b[Ta+4>>1]=-1;b[Ta+6>>1]=0;c[Ta+8>>2]=0;c[Ta>>2]=443968;c[Ta+12>>2]=0;c[Ta+16>>2]=0;c[Ta>>2]=487648;c[Ta+20>>2]=Fa;c[Ta+24>>2]=(Ba>>>0<Ha>>>0?Ba:Ha)-Qa;Ac=Ta}Ta=c[(c[k>>2]|0)+6728>>2]|0;c[Ac+16>>2]=1;c[Ac+12>>2]=f;c[Ac+8>>2]=Ta;ko[c[(c[f>>2]|0)+16>>2]&4095](f);ko[c[(c[Ac>>2]|0)+20>>2]&4095](Ac);Qa=(c[Ka>>2]|0)+Qa|0}while(Qa>>>0<Ba>>>0)}ko[c[(c[f>>2]|0)+20>>2]&4095](f);ko[c[(c[xa>>2]|0)+20>>2]&4095](xa);ko[c[(c[Ra>>2]|0)+20>>2]&4095](Ra);Ba=c[Da>>2]|0;do if((Ba&2147483647|0)!=0&(Ba|0)>-1){Qa=c[A>>2]|0;if(!Qa)break;Ka=mKa()|0;In[c[(c[Ka>>2]|0)+12>>2]&4095](Ka,Qa)}while(0);Ba=c[La>>2]|0;if(!((Ba&2147483647|0)!=0&(Ba|0)>-1)){i=l;return}Ba=c[y>>2]|0;if(!Ba){i=l;return}Da=mKa()|0;In[c[(c[Da>>2]|0)+12>>2]&4095](Da,Ba);i=l;return}}while(0);jsa(f);BTa(c[(c[k>>2]|0)+224>>2]|0,c[H>>2]|0);if(R){i=l;return}Dn[c[(c[O>>2]|0)+12>>2]&511](O,P&65535,N,Q);i=l;return}}c[G>>2]=0;jsa(f);i=l;return}function lsa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;f=i;h=c[d+244>>2]|0;if(!h){i=f;return}j=d+240|0;k=d+256|0;l=d+264|0;m=d+92|0;n=d+260|0;o=d+228|0;p=d+232|0;q=d+100|0;r=d+252|0;s=d+148|0;t=d+160|0;u=d+88|0;v=d+96|0;if(!e){w=0;x=0;while(1){y=w+1|0;z=w;A=0;while(1){if(z>>>0>=h>>>0){B=y;C=A;break}D=(c[(c[j>>2]|0)+(z<<2)>>2]|0)+A|0;E=z+1|0;if(D>>>0>(c[k>>2]|0)>>>0){B=E;C=D;break}else{z=E;A=D}}if((z|0)==(h|0))if(!C){F=19;break}else G=h;else G=B;A=c[(c[l>>2]|0)+6732>>2]|0;oTa(c[A>>2]|0);y=vXa(A,80,16)|0;pTa(c[A>>2]|0);if(!y)H=0;else{A=c[m>>2]|0;D=(A|0)==((c[n>>2]|0)+-1|0);E=c[o>>2]|0;I=c[p>>2]|0;J=c[l>>2]|0;K=ea(g[(c[r>>2]|0)+8764>>2]);L=c[s>>2]|0;M=c[t>>2]|0;N=a[u>>0]|0;b[y+4>>1]=-1;b[y+6>>1]=0;c[y+8>>2]=0;c[y>>2]=443968;c[y+12>>2]=0;c[y+16>>2]=0;c[y>>2]=487576;c[y+20>>2]=E;c[y+24>>2]=I;c[y+28>>2]=J;c[y+32>>2]=d;g[y+36>>2]=K;c[y+40>>2]=A;c[y+44>>2]=q;c[y+48>>2]=w;c[y+52>>2]=G-w;c[y+56>>2]=h;c[y+60>>2]=x;c[y+64>>2]=L;c[y+68>>2]=M;c[y+72>>2]=v;a[y+76>>0]=D&1;a[y+77>>0]=N;H=y}y=c[(c[l>>2]|0)+6728>>2]|0;c[H+16>>2]=1;c[H+12>>2]=0;c[H+8>>2]=y;ko[c[(c[H>>2]|0)+20>>2]&4095](H);if(G>>>0<h>>>0){w=G;x=C+x|0}else{F=19;break}}if((F|0)==19){i=f;return}}else{x=0;C=0;while(1){G=x+1|0;w=x;H=0;while(1){if(w>>>0>=h>>>0){O=G;P=H;break}B=(c[(c[j>>2]|0)+(w<<2)>>2]|0)+H|0;y=w+1|0;if(B>>>0>(c[k>>2]|0)>>>0){O=y;P=B;break}else{w=y;H=B}}if((w|0)==(h|0))if(!P){F=19;break}else Q=h;else Q=O;H=c[(c[l>>2]|0)+6732>>2]|0;oTa(c[H>>2]|0);G=vXa(H,80,16)|0;pTa(c[H>>2]|0);if(!G)R=0;else{H=c[m>>2]|0;z=(H|0)==((c[n>>2]|0)+-1|0);B=c[o>>2]|0;y=c[p>>2]|0;N=c[l>>2]|0;K=ea(g[(c[r>>2]|0)+8764>>2]);D=c[s>>2]|0;M=c[t>>2]|0;L=a[u>>0]|0;b[G+4>>1]=-1;b[G+6>>1]=0;c[G+8>>2]=0;c[G>>2]=443968;c[G+12>>2]=0;c[G+16>>2]=0;c[G>>2]=487576;c[G+20>>2]=B;c[G+24>>2]=y;c[G+28>>2]=N;c[G+32>>2]=d;g[G+36>>2]=K;c[G+40>>2]=H;c[G+44>>2]=q;c[G+48>>2]=x;c[G+52>>2]=Q-x;c[G+56>>2]=h;c[G+60>>2]=C;c[G+64>>2]=D;c[G+68>>2]=M;c[G+72>>2]=v;a[G+76>>0]=z&1;a[G+77>>0]=L;R=G}G=c[(c[l>>2]|0)+6728>>2]|0;c[R+16>>2]=1;c[R+12>>2]=e;c[R+8>>2]=G;ko[c[(c[e>>2]|0)+16>>2]&4095](e);ko[c[(c[R>>2]|0)+20>>2]&4095](R);if(Q>>>0<h>>>0){x=Q;C=P+C|0}else{F=19;break}}if((F|0)==19){i=f;return}}}function msa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0;e=i;i=i+48|0;f=e+28|0;h=e+4|0;j=e;k=e+24|0;l=e+34|0;m=e+32|0;n=e+8|0;o=c[d+244>>2]|0;p=d+264|0;q=c[p>>2]|0;if(!o){r=q;s=0;t=0;u=r+1360|0;v=c[u>>2]|0;w=v+s|0;c[u>>2]=w;x=r+1364|0;y=c[x>>2]|0;z=y+t|0;c[x>>2]=z;i=e;return}A=d+240|0;B=d+228|0;C=d+252|0;d=f+2|0;D=n+8|0;E=n+12|0;F=n+4|0;G=q+5868|0;H=q+5876|0;I=q+5872|0;q=0;J=0;K=0;L=0;while(1){M=K;K=(c[(c[A>>2]|0)+(L<<2)>>2]|0)+K|0;a:do if(M>>>0<K>>>0){N=q;O=J;P=M;while(1){Q=c[(c[B>>2]|0)+(P<<2)>>2]|0;if(ea(g[Q+28>>2])>ea(1.0)){R=N;S=O;break a}b:do if(a[Q+68>>0]|0){T=Q+52|0;U=c[T>>2]|0;V=U+8|0;c[V>>2]=c[V>>2]|4;V=b[U+114>>1]|0;W=(V&2)==0;X=c[p>>2]|0;Y=X+1344|0;Z=c[U+76>>2]|0;_=(Z+32|0)>>>5;$=X+1348|0;if(_>>>0>(c[$>>2]&2147483647)>>>0){aa=X+1352|0;X=UJa(aa,_<<2,543784,339)|0;ba=c[Y>>2]|0;if((ba|0)!=0?(YEi(X|0,ba|0,c[$>>2]<<2|0)|0,(c[$>>2]|0)>-1):0)VJa(aa,c[Y>>2]|0);aa=c[$>>2]|0;PEi(X+((aa&2147483647)<<2)|0,0,_-aa<<2|0)|0;c[Y>>2]=X;c[$>>2]=_;_=c[T>>2]|0;ca=X;da=_;fa=b[_+114>>1]|0}else{ca=c[Y>>2]|0;da=U;fa=V}V=ca+(Z>>>5<<2)|0;c[V>>2]=c[V>>2]|1<<(Z&31);Z=da+114|0;V=fa&65535;if(W){b[Z>>1]=V&65532|2;ga=N+1|0;ha=O}else{b[Z>>1]=V|8;ga=N;ha=O+1|0}V=da+38|0;W=b[V>>1]|0;U=W&65535;do if(!(U&1)){if(!(U&256)){ia=ga;ja=ha;break b}if((U&32|0)!=0?(c[(c[da+80>>2]|0)+92>>2]|0)!=2139095039:0)break;if(!(W&64)){ia=ga;ja=ha;break b}if((c[(c[da+84>>2]|0)+92>>2]|0)==2139095039){ia=ga;ja=ha;break b}}while(0);W=c[C>>2]|0;U=W+400|0;g[W+416>>2]=ea(g[Q+36>>2]);g[W+420>>2]=ea(g[Q+40>>2]);g[W+424>>2]=ea(g[Q+44>>2]);ka=ea(-ea(g[Q+16>>2]));la=ea(-ea(g[Q+20>>2]));ma=ea(-ea(g[Q+24>>2]));g[U>>2]=ka;g[W+404>>2]=la;g[W+408>>2]=ma;c[W+448>>2]=c[Q+72>>2];c[W+452>>2]=-1;g[W+412>>2]=ea(0.0);g[W+460>>2]=ea(g[Q+88>>2]);g[W+456>>2]=ea(g[Q+80>>2]);g[W+444>>2]=ea(g[Q+84>>2]);g[W+432>>2]=ea(0.0);g[W+436>>2]=ea(0.0);g[W+440>>2]=ea(0.0);g[W+428>>2]=ea(3402823469999999843913219.0e14);b[f>>1]=b[Q+76>>1]|0;b[d>>1]=b[Q+78>>1]|0;b[m>>1]=b[Z>>1]|0;Y=c[da+40>>2]|0;do if(!(xAa(U,1,W+16|0,l,j,k,h,4,m,c[da+96>>2]|0,(b[V>>1]&128)!=0,1,f,8,0,0,0)|0))if(!Y){c[(c[T>>2]|0)+40>>2]=0;break}else{b[Y+6>>1]=1;break}else{_=c[j>>2]|0;b[_+4>>1]=c[k>>2];b[_+6>>1]=0;c[(c[T>>2]|0)+40>>2]=_;b[(c[T>>2]|0)+114>>1]=b[m>>1]|0;if(!Y)c[_>>2]=0;else{c[_>>2]=Y;b[Y+6>>1]=1}ma=ea(g[Q+96>>2]);g[c[h>>2]>>2]=ma}while(0);if((b[(c[T>>2]|0)+38>>1]&24)==0?(ma=ea(g[Q+96>>2]),ma!=ea(0.0)):0){g[D>>2]=ma;Y=c[Q>>2]|0;if(!Y)na=ea(3402823469999999843913219.0e14);else na=ea(g[(c[Y+64>>2]|0)+92>>2]);V=c[Q+4>>2]|0;if(!V)oa=ea(3402823469999999843913219.0e14);else oa=ea(g[(c[V+64>>2]|0)+92>>2]);g[E>>2]=na<oa?na:oa;c[n>>2]=Y;c[F>>2]=V;if(V>>>0<Y>>>0){c[n>>2]=V;c[F>>2]=Y}Y=c[I>>2]|0;if((c[H>>2]&2147483647)>>>0<=Y>>>0){W$a(G,n)|0;ia=ga;ja=ha;break}V=(c[G>>2]|0)+(Y<<4)|0;if(!V)pa=Y;else{c[V+0>>2]=c[n+0>>2];c[V+4>>2]=c[n+4>>2];c[V+8>>2]=c[n+8>>2];c[V+12>>2]=c[n+12>>2];pa=c[I>>2]|0}c[I>>2]=pa+1;ia=ga;ja=ha}else{ia=ga;ja=ha}}else{ia=N;ja=O}while(0);P=P+1|0;if(P>>>0>=K>>>0){R=ia;S=ja;break}else{N=ia;O=ja}}}else{R=q;S=J}while(0);L=L+1|0;if((L|0)==(o|0))break;else{q=R;J=S}}r=c[p>>2]|0;s=R;t=S;u=r+1360|0;v=c[u>>2]|0;w=v+s|0;c[u>>2]=w;x=r+1364|0;y=c[x>>2]|0;z=y+t|0;c[x>>2]=z;i=e;return}function nsa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im;m=i;i=i+80|0;n=m;o=a+84|0;if(!(c[o>>2]|0)){i=m;return}c[n+8>>2]=efa(e)|0;c[n+12>>2]=efa(f)|0;a=(k|0)!=0;if(a)p=k9(h)|0;else p=dga(h)|0;c[n>>2]=p;p=(l|0)!=0;if(p)q=k9(j)|0;else q=dga(j)|0;c[n+4>>2]=q;if(a){r=ea(g[h+48>>2]);s=ea(g[h+52>>2]);t=ea(r*ea(-2.0));r=ea(s*ea(-2.0));s=ea(ea(g[h+56>>2])*ea(-2.0));u=ea(g[h+44>>2]);v=ea(ea(u*u)+ea(-.5));w=ea(g[h+32>>2]);x=ea(t*w);y=ea(g[h+36>>2]);z=ea(x+ea(r*y));x=ea(g[h+40>>2]);A=ea(z+ea(s*x));z=ea(-w);B=ea(-y);C=ea(-x);D=ea(ea(ea(w*A)+ea(ea(t*v)-ea(u*ea(ea(s*y)-ea(r*x)))))*ea(2.0));E=ea(ea(ea(y*A)+ea(ea(r*v)-ea(u*ea(ea(t*x)-ea(s*w)))))*ea(2.0));F=ea(ea(ea(ea(s*v)-ea(u*ea(ea(r*w)-ea(t*y))))+ea(x*A))*ea(2.0));A=ea(g[h+12>>2]);x=ea(ea(A*A)+ea(-.5));y=ea(g[h>>2]);t=ea(y*D);w=ea(g[h+4>>2]);r=ea(t+ea(w*E));t=ea(g[h+8>>2]);v=ea(ea(t*F)+r);r=ea(ea(y*v)+ea(ea(x*D)+ea(A*ea(ea(w*F)-ea(t*E)))));s=ea(ea(w*v)+ea(ea(x*E)+ea(A*ea(ea(t*D)-ea(y*F)))));G=ea(ea(ea(x*F)+ea(A*ea(ea(y*E)-ea(w*D))))+ea(t*v));v=ea(ea(g[h+16>>2])+r);r=ea(ea(g[h+20>>2])+s);s=ea(ea(g[h+24>>2])+G);G=ea(ea(ea(ea(A*z)+ea(u*y))+ea(w*C))-ea(t*B));D=ea(ea(ea(t*z)+ea(ea(A*B)+ea(u*w)))-ea(y*C));E=ea(ea(ea(y*B)+ea(ea(A*C)+ea(u*t)))-ea(w*z));F=ea(ea(ea(ea(u*A)-ea(y*z))-ea(w*B))-ea(t*C));C=ea(ea(g[e+16>>2])*ea(2.0));t=ea(ea(g[e+20>>2])*ea(2.0));B=ea(ea(g[e+24>>2])*ea(2.0));w=ea(ea(F*F)+ea(-.5));z=ea(ea(ea(G*C)+ea(D*t))+ea(E*B));y=ea(v+ea(ea(G*z)+ea(ea(w*C)+ea(F*ea(ea(D*B)-ea(E*t))))));v=ea(r+ea(ea(D*z)+ea(ea(w*t)+ea(F*ea(ea(E*C)-ea(G*B))))));r=ea(s+ea(ea(ea(w*B)+ea(F*ea(ea(G*t)-ea(D*C))))+ea(E*z)));z=ea(g[e>>2]);C=ea(F*z);t=ea(g[e+12>>2]);B=ea(C+ea(G*t));C=ea(g[e+8>>2]);w=ea(B+ea(D*C));B=ea(g[e+4>>2]);H=ea(w-ea(E*B));I=ea(ea(ea(E*z)+ea(ea(D*t)+ea(F*B)))-ea(G*C));J=ea(ea(ea(G*B)+ea(ea(E*t)+ea(F*C)))-ea(D*z));K=ea(ea(ea(ea(F*t)-ea(G*z))-ea(D*B))-ea(E*C));L=y;M=v;N=r}else{r=ea(ea(g[e+16>>2])*ea(2.0));v=ea(ea(g[e+20>>2])*ea(2.0));y=ea(ea(g[e+24>>2])*ea(2.0));C=ea(g[h+12>>2]);E=ea(ea(C*C)+ea(-.5));B=ea(g[h>>2]);D=ea(r*B);z=ea(g[h+4>>2]);G=ea(D+ea(v*z));D=ea(g[h+8>>2]);t=ea(G+ea(y*D));G=ea(ea(B*t)+ea(ea(r*E)+ea(C*ea(ea(y*z)-ea(v*D)))));F=ea(ea(z*t)+ea(ea(v*E)+ea(C*ea(ea(r*D)-ea(y*B)))));w=ea(ea(ea(y*E)+ea(C*ea(ea(v*B)-ea(r*z))))+ea(D*t));t=ea(ea(g[h+16>>2])+G);G=ea(ea(g[h+20>>2])+F);F=ea(ea(g[h+24>>2])+w);w=ea(g[e>>2]);r=ea(C*w);v=ea(g[e+12>>2]);E=ea(r+ea(B*v));r=ea(g[e+8>>2]);y=ea(E+ea(z*r));E=ea(g[e+4>>2]);H=ea(y-ea(D*E));I=ea(ea(ea(D*w)+ea(ea(z*v)+ea(C*E)))-ea(B*r));J=ea(ea(ea(B*E)+ea(ea(D*v)+ea(C*r)))-ea(z*w));K=ea(ea(ea(ea(C*v)-ea(B*w))-ea(z*E))-ea(D*r));L=t;M=G;N=F}g[n+16>>2]=H;g[n+20>>2]=I;g[n+24>>2]=J;g[n+28>>2]=K;g[n+32>>2]=L;g[n+36>>2]=M;g[n+40>>2]=N;if(p){N=ea(g[j+48>>2]);M=ea(g[j+52>>2]);L=ea(N*ea(-2.0));N=ea(M*ea(-2.0));M=ea(ea(g[j+56>>2])*ea(-2.0));K=ea(g[j+44>>2]);J=ea(ea(K*K)+ea(-.5));I=ea(g[j+32>>2]);H=ea(L*I);F=ea(g[j+36>>2]);G=ea(H+ea(N*F));H=ea(g[j+40>>2]);t=ea(G+ea(M*H));G=ea(-I);r=ea(-F);D=ea(-H);E=ea(ea(ea(I*t)+ea(ea(L*J)-ea(K*ea(ea(M*F)-ea(N*H)))))*ea(2.0));z=ea(ea(ea(F*t)+ea(ea(N*J)-ea(K*ea(ea(L*H)-ea(M*I)))))*ea(2.0));w=ea(ea(ea(ea(M*J)-ea(K*ea(ea(N*I)-ea(L*F))))+ea(H*t))*ea(2.0));t=ea(g[j+12>>2]);H=ea(ea(t*t)+ea(-.5));F=ea(g[j>>2]);L=ea(F*E);I=ea(g[j+4>>2]);N=ea(L+ea(I*z));L=ea(g[j+8>>2]);J=ea(ea(L*w)+N);N=ea(ea(F*J)+ea(ea(H*E)+ea(t*ea(ea(I*w)-ea(L*z)))));M=ea(ea(I*J)+ea(ea(H*z)+ea(t*ea(ea(L*E)-ea(F*w)))));B=ea(ea(ea(H*w)+ea(t*ea(ea(F*z)-ea(I*E))))+ea(L*J));J=ea(ea(g[j+16>>2])+N);N=ea(ea(g[j+20>>2])+M);M=ea(ea(g[j+24>>2])+B);B=ea(ea(ea(ea(t*G)+ea(K*F))+ea(I*D))-ea(L*r));E=ea(ea(ea(L*G)+ea(ea(t*r)+ea(K*I)))-ea(F*D));z=ea(ea(ea(F*r)+ea(ea(t*D)+ea(K*L)))-ea(I*G));w=ea(ea(ea(ea(K*t)-ea(F*G))-ea(I*r))-ea(L*D));D=ea(ea(g[f+16>>2])*ea(2.0));L=ea(ea(g[f+20>>2])*ea(2.0));r=ea(ea(g[f+24>>2])*ea(2.0));I=ea(ea(w*w)+ea(-.5));G=ea(ea(ea(B*D)+ea(E*L))+ea(z*r));F=ea(J+ea(ea(B*G)+ea(ea(I*D)+ea(w*ea(ea(E*r)-ea(z*L))))));J=ea(N+ea(ea(E*G)+ea(ea(I*L)+ea(w*ea(ea(z*D)-ea(B*r))))));N=ea(M+ea(ea(ea(I*r)+ea(w*ea(ea(B*L)-ea(E*D))))+ea(z*G)));G=ea(g[f>>2]);D=ea(w*G);L=ea(g[f+12>>2]);r=ea(D+ea(B*L));D=ea(g[f+8>>2]);I=ea(r+ea(E*D));r=ea(g[f+4>>2]);O=ea(I-ea(z*r));P=ea(ea(ea(z*G)+ea(ea(E*L)+ea(w*r)))-ea(B*D));Q=ea(ea(ea(B*r)+ea(ea(z*L)+ea(w*D)))-ea(E*G));R=ea(ea(ea(ea(w*L)-ea(B*G))-ea(E*r))-ea(z*D));S=F;T=J;U=N}else{N=ea(ea(g[f+16>>2])*ea(2.0));J=ea(ea(g[f+20>>2])*ea(2.0));F=ea(ea(g[f+24>>2])*ea(2.0));D=ea(g[j+12>>2]);z=ea(ea(D*D)+ea(-.5));r=ea(g[j>>2]);E=ea(N*r);G=ea(g[j+4>>2]);B=ea(E+ea(J*G));E=ea(g[j+8>>2]);L=ea(B+ea(F*E));B=ea(ea(r*L)+ea(ea(N*z)+ea(D*ea(ea(F*G)-ea(J*E)))));w=ea(ea(G*L)+ea(ea(J*z)+ea(D*ea(ea(N*E)-ea(F*r)))));I=ea(ea(ea(F*z)+ea(D*ea(ea(J*r)-ea(N*G))))+ea(E*L));L=ea(ea(g[j+16>>2])+B);B=ea(ea(g[j+20>>2])+w);w=ea(ea(g[j+24>>2])+I);I=ea(g[f>>2]);N=ea(D*I);J=ea(g[f+12>>2]);z=ea(N+ea(r*J));N=ea(g[f+8>>2]);F=ea(z+ea(G*N));z=ea(g[f+4>>2]);O=ea(F-ea(E*z));P=ea(ea(ea(E*I)+ea(ea(G*J)+ea(D*z)))-ea(r*N));Q=ea(ea(ea(r*z)+ea(ea(E*J)+ea(D*N)))-ea(G*I));R=ea(ea(ea(ea(D*J)-ea(r*I))-ea(G*z))-ea(E*N));S=L;T=B;U=w}g[n+44>>2]=O;g[n+48>>2]=P;g[n+52>>2]=Q;g[n+56>>2]=R;g[n+60>>2]=S;g[n+64>>2]=T;g[n+68>>2]=U;f=n+72|0;c[f>>2]=d;c[f+4>>2]=b;b=c[o>>2]|0;co[c[c[b>>2]>>2]&2047](b,n,1);i=m;return}function osa(a,d,f,h,j,k,l){a=a|0;d=d|0;f=f|0;h=ea(h);j=ea(j);k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;m=i;i=i+64|0;n=m+28|0;o=m;p=c[a+16>>2]|0;q=c[a+28>>2]|0;r=c[a+12>>2]|0;s=c[a+36>>2]|0;if(!s){g[n>>2]=ea(0.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(1.0);g[n+16>>2]=ea(0.0);g[n+20>>2]=ea(0.0);g[n+24>>2]=ea(0.0)}else{t=c[s+64>>2]|0;g[n>>2]=ea(g[t>>2]);g[n+4>>2]=ea(g[t+4>>2]);g[n+8>>2]=ea(g[t+8>>2]);g[n+12>>2]=ea(g[t+12>>2]);g[n+16>>2]=ea(g[t+16>>2]);g[n+20>>2]=ea(g[t+20>>2]);g[n+24>>2]=ea(g[t+24>>2])}t=c[a+40>>2]|0;if(!t){g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(1.0);g[o+16>>2]=ea(0.0);g[o+20>>2]=ea(0.0);g[o+24>>2]=ea(0.0)}else{s=c[t+64>>2]|0;g[o>>2]=ea(g[s>>2]);g[o+4>>2]=ea(g[s+4>>2]);g[o+8>>2]=ea(g[s+8>>2]);g[o+12>>2]=ea(g[s+12>>2]);g[o+16>>2]=ea(g[s+16>>2]);g[o+20>>2]=ea(g[s+20>>2]);g[o+24>>2]=ea(g[s+24>>2])}s=c[k>>2]|0;t=c[k+4>>2]|0;if((b[k+8>>1]|0)==-1)u=e[k+10>>1]|0;else u=0;v=d+(u<<6)|0;if((b[k+12>>1]|0)!=-1){w=0;x=d+(w<<6)|0;y=wsa(n,o,s,t,v,x,p,q,r,h,j,k,a,f,l)|0;i=m;return y|0}w=e[k+14>>1]|0;x=d+(w<<6)|0;y=wsa(n,o,s,t,v,x,p,q,r,h,j,k,a,f,l)|0;i=m;return y|0}function psa(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+64|0;f=e+28|0;h=e;j=c[a+36>>2]|0;k=c[a+40>>2]|0;if(!j){g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(1.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0)}else{l=c[j+64>>2]|0;g[f>>2]=ea(g[l>>2]);g[f+4>>2]=ea(g[l+4>>2]);g[f+8>>2]=ea(g[l+8>>2]);g[f+12>>2]=ea(g[l+12>>2]);g[f+16>>2]=ea(g[l+16>>2]);g[f+20>>2]=ea(g[l+20>>2]);g[f+24>>2]=ea(g[l+24>>2])}if(!k){g[h>>2]=ea(0.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);g[h+12>>2]=ea(1.0);g[h+16>>2]=ea(0.0);g[h+20>>2]=ea(0.0);g[h+24>>2]=ea(0.0)}else{l=c[k+64>>2]|0;g[h>>2]=ea(g[l>>2]);g[h+4>>2]=ea(g[l+4>>2]);g[h+8>>2]=ea(g[l+8>>2]);g[h+12>>2]=ea(g[l+12>>2]);g[h+16>>2]=ea(g[l+16>>2]);g[h+20>>2]=ea(g[l+20>>2]);g[h+24>>2]=ea(g[l+24>>2])}Dn[c[a+20>>2]&511](c[a+28>>2]|0,f,h,b);if(b){b=c[k+64>>2]|0;g[b>>2]=ea(g[h>>2]);g[b+4>>2]=ea(g[h+4>>2]);g[b+8>>2]=ea(g[h+8>>2]);g[b+12>>2]=ea(g[h+12>>2]);g[b+16>>2]=ea(g[h+16>>2]);g[b+20>>2]=ea(g[h+20>>2]);g[b+24>>2]=ea(g[h+24>>2]);i=e;return}else{h=c[j+64>>2]|0;g[h>>2]=ea(g[f>>2]);g[h+4>>2]=ea(g[f+4>>2]);g[h+8>>2]=ea(g[f+8>>2]);g[h+12>>2]=ea(g[f+12>>2]);g[h+16>>2]=ea(g[f+16>>2]);g[h+20>>2]=ea(g[f+20>>2]);g[h+24>>2]=ea(g[f+24>>2]);i=e;return}}function qsa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;e=i;i=i+288|0;f=e+140|0;g=e+8|0;h=e;j=e+272|0;k=c[d+4>>2]|0;l=c[d>>2]|0;m=l;n=c[d+12>>2]|0;o=c[d+8>>2]|0;p=c[d+20>>2]|0;q=c[d+16>>2]|0;r=c[d+32>>2]|0;PEi(f|0,0,132)|0;s=(k|0)==0;a:do if(!s){t=l;u=0;while(1){c[t+(u<<5)+28>>2]=0;b[t+(u<<5)+12>>1]=0;v=u+1|0;if((v|0)==(k|0))break a;t=c[d>>2]|0;u=v}}while(0);if(!n){l=(p|0)==0;if(!l){u=q;t=0;while(1){v=c[u>>2]|0;w=c[u+4>>2]|0;if((v-m|0)>>>5>>>0<k>>>0&(w-m|0)>>>5>>>0<k>>>0?(x=v+28|0,v=c[x>>2]|0,y=w+28|0,w=c[y>>2]|0,z=w|v,(z|0)!=-1):0){A=c[425648+((da(z+1&~z,125613361)|0)>>>27<<2)>>2]|0;z=1<<A;c[x>>2]=z|v;c[y>>2]=z|w;w=f+(A<<2)|0;c[w>>2]=(c[w>>2]|0)+1}w=t+1|0;if((w|0)==(p|0)){B=q;C=0;break}else{u=u+32|0;t=w}}while(1){t=c[B>>2]|0;u=(t-m|0)>>>5;w=c[B+4>>2]|0;A=u>>>0<k>>>0;z=(w-m|0)>>>5>>>0<k>>>0;do if(!(A&z)){y=u>>>0>=k>>>0;if(A)D=c[t+28>>2]|0;else D=-1;if(z)E=c[w+28>>2]|0;else E=-1;do if(y)if(!E){F=1;G=0}else{v=E>>>1|E;x=v>>>2|v;v=x>>>4|x;x=v>>>8|v;H=x>>>16|x;I=21}else if(!D){J=1;K=E|1;L=0;I=23;break}else{x=D>>>1|D;v=x>>>2|x;x=v>>>4|v;v=x>>>8|x;H=v>>>16|v;I=21;break}while(0);if((I|0)==21){I=0;v=(c[482792+((da(H,130329821)|0)>>>27<<2)>>2]|0)+1|0;if((v|0)==32)break;x=1<<v;M=x|E;if(y){F=M;G=v}else{J=x;K=M;L=v;I=23}}if((I|0)==23){I=0;c[t+28>>2]=J|D;F=K;G=L}if(z)c[w+28>>2]=F;if(G>>>0<32){v=f+(G<<2)|0;c[v>>2]=(c[v>>2]|0)+1}}while(0);w=C+1|0;if((w|0)==(p|0))break;else{B=B+32|0;C=w}}}C=0;B=0;do{c[g+(C<<2)>>2]=B;G=f+(C<<2)|0;B=(c[G>>2]|0)+B|0;c[G>>2]=0;C=C+1|0}while((C|0)!=33);if(!s){C=0;while(1){c[(c[d>>2]|0)+(C<<5)+28>>2]=0;B=C+1|0;if((B|0)==(k|0))break;else C=B}}if(l)N=0;else{l=g+128|0;C=f+128|0;B=q;G=0;while(1){F=c[B>>2]|0;L=c[B+4>>2]|0;do if((F-m|0)>>>5>>>0<k>>>0&(L-m|0)>>>5>>>0<k>>>0){K=F+28|0;D=c[K>>2]|0;J=L+28|0;E=c[J>>2]|0;H=E|D;if((H|0)==-1){w=c[C>>2]|0;z=r+(w+(c[l>>2]|0)<<5)|0;c[z+0>>2]=c[B+0>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];c[z+12>>2]=c[B+12>>2];c[z+16>>2]=c[B+16>>2];c[z+20>>2]=c[B+20>>2];c[z+24>>2]=c[B+24>>2];c[z+28>>2]=c[B+28>>2];c[C>>2]=w+1;break}else{w=c[425648+((da(H+1&~H,125613361)|0)>>>27<<2)>>2]|0;H=1<<w;c[K>>2]=H|D;c[J>>2]=H|E;E=f+(w<<2)|0;H=c[E>>2]|0;J=r+(H+(c[g+(w<<2)>>2]|0)<<5)|0;c[J+0>>2]=c[B+0>>2];c[J+4>>2]=c[B+4>>2];c[J+8>>2]=c[B+8>>2];c[J+12>>2]=c[B+12>>2];c[J+16>>2]=c[B+16>>2];c[J+20>>2]=c[B+20>>2];c[J+24>>2]=c[B+24>>2];c[J+28>>2]=c[B+28>>2];c[E>>2]=H+1;break}}while(0);L=G+1|0;if((L|0)==(p|0)){O=q;P=0;break}else{B=B+32|0;G=L}}while(1){G=c[O>>2]|0;B=c[O+4>>2]|0;L=(G-m|0)>>>5>>>0<k>>>0;F=(B-m|0)>>>5>>>0<k>>>0;b:do if(!(L&F)){if(L)Q=c[G+28>>2]|0;else Q=-1;if(F)R=c[B+28>>2]|0;else R=-1;do if(L)if(!Q){S=1;T=R|1;U=0;I=54;break}else{H=Q>>>1|Q;E=H>>>2|H;H=E>>>4|E;E=H>>>8|H;V=E>>>16|E;I=51;break}else if(!R){W=1;X=0}else{E=R>>>1|R;H=E>>>2|E;E=H>>>4|H;H=E>>>8|E;V=H>>>16|H;I=51}while(0);do if((I|0)==51){I=0;y=(c[482792+((da(V,130329821)|0)>>>27<<2)>>2]|0)+1|0;if((y|0)!=32){H=1<<y;E=H|R;if(L){S=H;T=E;U=y;I=54;break}else{W=E;X=y;break}}else{y=c[C>>2]|0;E=r+(y+(c[l>>2]|0)<<5)|0;c[E+0>>2]=c[O+0>>2];c[E+4>>2]=c[O+4>>2];c[E+8>>2]=c[O+8>>2];c[E+12>>2]=c[O+12>>2];c[E+16>>2]=c[O+16>>2];c[E+20>>2]=c[O+20>>2];c[E+24>>2]=c[O+24>>2];c[E+28>>2]=c[O+28>>2];c[C>>2]=y+1;break b}}while(0);if((I|0)==54){I=0;c[G+28>>2]=S|Q;W=T;X=U}if(F)c[B+28>>2]=W;if(X>>>0<32){y=f+(X<<2)|0;E=c[y>>2]|0;H=r+(E+(c[g+(X<<2)>>2]|0)<<5)|0;c[H+0>>2]=c[O+0>>2];c[H+4>>2]=c[O+4>>2];c[H+8>>2]=c[O+8>>2];c[H+12>>2]=c[O+12>>2];c[H+16>>2]=c[O+16>>2];c[H+20>>2]=c[O+20>>2];c[H+24>>2]=c[O+24>>2];c[H+28>>2]=c[O+28>>2];c[y>>2]=E+1}}while(0);B=P+1|0;if((B|0)==(p|0)){N=p;break}else{O=O+32|0;P=B}}}}else{P=n<<2;O=P>>>0>1024;X=h+4|0;a[X>>0]=O&1;if(O){O=sKa(j,P,487704,921)|0;c[h>>2]=O;Y=O}else{O=i;i=i+((1*P|0)+15&-16)|0;c[h>>2]=O;Y=O}O=0;do{P=c[o+(O*40|0)>>2]|0;c[Y+(O<<2)>>2]=P;c[P+28>>2]=0;b[P+14>>1]=0;b[P+12>>1]=0;O=O+1|0}while((O|0)!=(n|0));O=(p|0)==0;if(!O){Y=q;P=0;while(1){j=(b[Y+12>>1]|0)==-1;do if((b[Y+8>>1]|0)==-1){W=((c[Y>>2]|0)-m|0)>>>5;if(j){Z=W>>>0<k>>>0;_=((c[Y+4>>2]|0)-m|0)>>>5>>>0<k>>>0;break}else{Z=W>>>0<k>>>0;_=1;break}}else if(j){Z=1;_=((c[Y+4>>2]|0)-m|0)>>>5>>>0<k>>>0}else{Z=1;_=1}while(0);if(Z&_?(j=(c[Y>>2]|0)+28|0,W=c[j>>2]|0,U=(c[Y+4>>2]|0)+28|0,T=c[U>>2]|0,Q=T|W,(Q|0)!=-1):0){S=c[425648+((da(Q+1&~Q,125613361)|0)>>>27<<2)>>2]|0;Q=1<<S;c[j>>2]=Q|W;c[U>>2]=Q|T;T=f+(S<<2)|0;c[T>>2]=(c[T>>2]|0)+1}T=P+1|0;if((T|0)==(p|0)){$=q;aa=0;break}else{Y=Y+32|0;P=T}}while(1){P=(b[$+12>>1]|0)==-1;do if((b[$+8>>1]|0)==-1){Y=((c[$>>2]|0)-m|0)>>>5;if(P){ba=Y>>>0<k>>>0;ca=((c[$+4>>2]|0)-m|0)>>>5>>>0<k>>>0;I=82;break}else{ba=Y>>>0<k>>>0;ca=1;I=82;break}}else if(P){ba=1;ca=((c[$+4>>2]|0)-m|0)>>>5>>>0<k>>>0;I=82}while(0);if((I|0)==82?(I=0,!(ba&ca)):0){if(ba)ea=c[(c[$>>2]|0)+28>>2]|0;else ea=-1;if(ca){P=c[(c[$+4>>2]|0)+28>>2]|0;if(!P){fa=0;ga=0}else{Y=P>>>1|P;_=Y>>>2|Y;Y=_>>>4|_;_=Y>>>8|Y;fa=P;ga=(c[482792+((da(_>>>16|_,130329821)|0)>>>27<<2)>>2]|0)+1|0}}else if(!ea){fa=-1;ga=0}else{_=ea>>>1|ea;P=_>>>2|_;_=P>>>4|P;P=_>>>8|_;fa=-1;ga=(c[482792+((da(P>>>16|P,130329821)|0)>>>27<<2)>>2]|0)+1|0}if((ga|0)!=32&(ba|ca)){P=1<<ga;if(ba)c[(c[$>>2]|0)+28>>2]=P|ea;if(ca)c[(c[$+4>>2]|0)+28>>2]=P|fa;P=f+(ga<<2)|0;c[P>>2]=(c[P>>2]|0)+1}}P=aa+1|0;if((P|0)==(p|0))break;else{$=$+32|0;aa=P}}}aa=0;$=0;do{c[g+(aa<<2)>>2]=$;ga=f+(aa<<2)|0;$=(c[ga>>2]|0)+$|0;c[ga>>2]=0;aa=aa+1|0}while((aa|0)!=33);if(s)ha=0;else{s=0;while(1){c[(c[d>>2]|0)+(s<<5)+28>>2]=0;aa=s+1|0;if((aa|0)==(k|0)){ha=0;break}else s=aa}}do{c[(c[o+(ha*40|0)>>2]|0)+28>>2]=0;ha=ha+1|0}while((ha|0)!=(n|0));if(O){ia=0;ja=0}else{O=g+128|0;n=f+128|0;ha=q;o=0;s=0;while(1){aa=(b[ha+12>>1]|0)==-1;do if((b[ha+8>>1]|0)==-1){$=((c[ha>>2]|0)-m|0)>>>5;if(aa){ka=$>>>0<k>>>0;la=((c[ha+4>>2]|0)-m|0)>>>5>>>0<k>>>0;break}else{ka=$>>>0<k>>>0;la=1;break}}else if(aa){ka=1;la=((c[ha+4>>2]|0)-m|0)>>>5>>>0<k>>>0}else{ka=1;la=1}while(0);do if(ka&la){aa=(c[ha>>2]|0)+28|0;$=c[aa>>2]|0;ga=(c[ha+4>>2]|0)+28|0;fa=c[ga>>2]|0;ca=fa|$;if((ca|0)==-1){ea=c[n>>2]|0;ba=r+(ea+(c[O>>2]|0)<<5)|0;c[ba+0>>2]=c[ha+0>>2];c[ba+4>>2]=c[ha+4>>2];c[ba+8>>2]=c[ha+8>>2];c[ba+12>>2]=c[ha+12>>2];c[ba+16>>2]=c[ha+16>>2];c[ba+20>>2]=c[ha+20>>2];c[ba+24>>2]=c[ha+24>>2];c[ba+28>>2]=c[ha+28>>2];c[n>>2]=ea+1;ma=s+1|0;break}else{ea=c[425648+((da(ca+1&~ca,125613361)|0)>>>27<<2)>>2]|0;ca=1<<ea;c[aa>>2]=ca|$;c[ga>>2]=ca|fa;fa=f+(ea<<2)|0;ca=c[fa>>2]|0;ga=r+(ca+(c[g+(ea<<2)>>2]|0)<<5)|0;c[ga+0>>2]=c[ha+0>>2];c[ga+4>>2]=c[ha+4>>2];c[ga+8>>2]=c[ha+8>>2];c[ga+12>>2]=c[ha+12>>2];c[ga+16>>2]=c[ha+16>>2];c[ga+20>>2]=c[ha+20>>2];c[ga+24>>2]=c[ha+24>>2];c[ga+28>>2]=c[ha+28>>2];c[fa>>2]=ca+1;ma=s+1|0;break}}else ma=s;while(0);ca=o+1|0;if((ca|0)==(p|0)){na=q;oa=0;pa=0;break}else{ha=ha+32|0;o=ca;s=ma}}while(1){s=(b[na+12>>1]|0)==-1;do if((b[na+8>>1]|0)==-1){o=((c[na>>2]|0)-m|0)>>>5;if(s){qa=o>>>0<k>>>0;ra=((c[na+4>>2]|0)-m|0)>>>5>>>0<k>>>0;I=121;break}else{qa=o>>>0<k>>>0;ra=1;I=121;break}}else if(s){qa=1;ra=((c[na+4>>2]|0)-m|0)>>>5>>>0<k>>>0;I=121}else sa=pa;while(0);do if((I|0)==121){I=0;if(!(qa&ra)){if(qa)ta=c[(c[na>>2]|0)+28>>2]|0;else ta=-1;if(ra){s=c[(c[na+4>>2]|0)+28>>2]|0;if(!s){ua=0;va=0}else{o=s>>>1|s;ha=o>>>2|o;o=ha>>>4|ha;ha=o>>>8|o;ua=s;va=(c[482792+((da(ha>>>16|ha,130329821)|0)>>>27<<2)>>2]|0)+1|0}}else if(!ta){ua=-1;va=0}else{ha=ta>>>1|ta;s=ha>>>2|ha;ha=s>>>4|s;s=ha>>>8|ha;ua=-1;va=(c[482792+((da(s>>>16|s,130329821)|0)>>>27<<2)>>2]|0)+1|0}if(!((va|0)!=32&(qa|ra))){s=f+(va<<2)|0;ha=c[s>>2]|0;o=r+(ha+(c[g+(va<<2)>>2]|0)<<5)|0;c[o+0>>2]=c[na+0>>2];c[o+4>>2]=c[na+4>>2];c[o+8>>2]=c[na+8>>2];c[o+12>>2]=c[na+12>>2];c[o+16>>2]=c[na+16>>2];c[o+20>>2]=c[na+20>>2];c[o+24>>2]=c[na+24>>2];c[o+28>>2]=c[na+28>>2];c[s>>2]=ha+1;sa=pa+1|0;break}ha=1<<va;if(qa)c[(c[na>>2]|0)+28>>2]=ha|ta;if(ra)c[(c[na+4>>2]|0)+28>>2]=ha|ua;if(va>>>0<32){ha=f+(va<<2)|0;s=c[ha>>2]|0;o=r+(s+(c[g+(va<<2)>>2]|0)<<5)|0;c[o+0>>2]=c[na+0>>2];c[o+4>>2]=c[na+4>>2];c[o+8>>2]=c[na+8>>2];c[o+12>>2]=c[na+12>>2];c[o+16>>2]=c[na+16>>2];c[o+20>>2]=c[na+20>>2];c[o+24>>2]=c[na+24>>2];c[o+28>>2]=c[na+28>>2];c[ha>>2]=s+1;sa=pa+1|0}else sa=pa}else sa=pa}while(0);s=oa+1|0;if((s|0)==(p|0)){ia=sa;ja=ma;break}else{na=na+32|0;oa=s;pa=sa}}}sa=ia+ja|0;if(!(a[X>>0]|0))N=sa;else{tKa(h,c[h>>2]|0);N=sa}}c[d+44>>2]=0;c[d+48>>2]=N;c[d+52>>2]=0;N=0;sa=0;do{sa=(c[f+(N<<2)>>2]|0)==0?sa:N;N=N+1|0}while((N|0)!=32);YEi(c[d+64>>2]|0,f|0,132)|0;i=e;return sa|0}function rsa(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;if(!d){j=0;k=j&65535;i=h;return k|0}else{l=0;m=a;n=0}while(1){a=(b[m+8>>1]|0)==-1;g=(b[m+12>>1]|0)==-1;do if(a)if(g){o=c[m>>2]|0;p=c[m+4>>2]|0;q=(p-e|0)>>>5>>>0<f>>>0;if((o-e|0)>>>5>>>0<f>>>0){r=b[o+12>>1]|0;if(q){s=o;t=r;u=1;v=15;break}else{w=r;x=-1;y=o;z=p;A=1;B=0;break}}else if(q){s=o;t=-1;u=0;v=15;break}else{w=-1;x=-1;y=o;z=p;A=0;B=0;break}}else v=11;else{if(!g){p=c[m>>2]|0;if((p|0)!=(c[m+4>>2]|0)){C=p;v=12;break}if(a){v=11;break}if(!g?(p=c[m>>2]|0,(p|0)==(c[m+4>>2]|0)):0){C=p;v=12;break}}p=c[m+4>>2]|0;o=c[m>>2]|0;q=b[o+12>>1]|0;if((p-e|0)>>>5>>>0<f>>>0){s=o;t=q;u=1;v=15}else{w=q;x=-1;y=o;z=p;A=1;B=0}}while(0);if((v|0)==11){v=0;g=c[m>>2]|0;if((g-e|0)>>>5>>>0<f>>>0){C=g;v=12}else{s=g;t=-1;u=0;v=15}}if((v|0)==12){v=0;s=C;t=b[C+12>>1]|0;u=1;v=15}if((v|0)==15){v=0;g=c[m+4>>2]|0;w=t;x=b[g+12>>1]|0;y=s;z=g;A=u;B=1}b[m+28>>1]=w;b[m+30>>1]=x;g=(w&65535)+1&65535;a=(x&65535)+1&65535;p=(g&65535)<(a&65535)?a:g;o=(n&65535)<(p&65535)?p:n;if(A)b[y+12>>1]=g;if(B)b[z+12>>1]=a;a=l+1|0;if((a|0)==(d|0)){j=o;break}else{l=a;m=m+32|0;n=o}}k=j&65535;i=h;return k|0}function ssa(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;if(!d){i=h;return}else{j=0;k=a}while(1){a=(b[k+8>>1]|0)==-1;g=(b[k+12>>1]|0)==-1;do if(a)if(g){l=c[k>>2]|0;m=c[k+4>>2]|0;n=(m-e|0)>>>5>>>0<f>>>0;if((l-e|0)>>>5>>>0<f>>>0){o=b[l+14>>1]|0;b[k+28>>1]=o;if(n){p=m;q=o;r=l;s=19;break}else{t=o;u=l;s=18;break}}b[k+28>>1]=-1;if(n){v=m;s=20}else b[k+30>>1]=-1}else s=11;else{if(!g){m=c[k>>2]|0;n=c[k+4>>2]|0;if((m|0)!=(n|0)){w=n;x=m;s=14;break}if(a){s=11;break}if(!g?(m=c[k>>2]|0,(m|0)==(c[k+4>>2]|0)):0){w=m;x=m;s=14;break}}m=c[k+4>>2]|0;n=c[k>>2]|0;l=b[n+14>>1]|0;b[k+28>>1]=l;if((m-e|0)>>>5>>>0<f>>>0){p=m;q=l;r=n;s=19}else{t=l;u=n;s=18}}while(0);do if((s|0)==11){s=0;g=c[k>>2]|0;if((g-e|0)>>>5>>>0<f>>>0){w=c[k+4>>2]|0;x=g;s=14;break}else{b[k+28>>1]=-1;v=c[k+4>>2]|0;s=20;break}}else if((s|0)==18){s=0;b[k+30>>1]=-1;b[u+14>>1]=(t&65535)+1}while(0);if((s|0)==14){s=0;g=b[x+14>>1]|0;b[k+28>>1]=g;p=w;q=g;r=x;s=19}else if((s|0)==20){s=0;g=b[v+14>>1]|0;b[k+30>>1]=g;y=g;z=v;s=21}if((s|0)==19){s=0;g=k+30|0;b[g>>1]=b[p+14>>1]|0;b[r+14>>1]=(q&65535)+1;y=b[g>>1]|0;z=p;s=21}if((s|0)==21){s=0;b[z+14>>1]=(y&65535)+1}g=j+1|0;if((g|0)==(d|0))break;else{j=g;k=k+32|0}}i=h;return}function tsa(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=i;i=i+16|0;n=m;o=m+8|0;p=d;if(e){q=0;while(1){c[d+(q<<5)+28>>2]=0;b[d+(q<<5)+12>>1]=0;r=q+1|0;if((r|0)==(e|0))break;else q=r}}if(g){q=g<<2;d=q>>>0>1024;r=n+4|0;a[r>>0]=d&1;if(d){d=sKa(o,q,487704,1294)|0;c[n>>2]=d;s=d}else{d=i;i=i+((1*q|0)+15&-16)|0;c[n>>2]=d;s=d}d=0;do{q=c[f+(d*40|0)>>2]|0;c[s+(d<<2)>>2]=q;c[q+28>>2]=0;b[q+14>>1]=0;b[q+12>>1]=0;d=d+1|0}while((d|0)!=(g|0));d=rsa(h,j,p,e,s,g)|0;if(!l)t=j;else{g=0;s=j;while(1){f=c[k+(g<<4)+4>>2]|0;q=f+s|0;if(f){o=(c[k+(g<<4)+12>>2]|0)+12|0;u=b[o>>1]|0;v=c[k+(g<<4)>>2]|0;w=0;do{x=v+w|0;b[h+(x<<5)+28>>1]=u;b[h+(x<<5)+30>>1]=u;w=w+1|0}while(w>>>0<f>>>0);b[o>>1]=(b[o>>1]|0)+1<<16>>16}g=g+1|0;if((g|0)==(l|0)){t=q;break}else s=q}}if(!(a[r>>0]|0)){y=d;z=t}else{tKa(n,c[n>>2]|0);y=d;z=t}}else{if(!j)A=0;else{t=0;d=h;n=0;while(1){r=c[d>>2]|0;s=c[d+4>>2]|0;l=(r-p|0)>>>5>>>0<e>>>0;if(l)B=b[r+12>>1]|0;else B=-1;g=(s-p|0)>>>5>>>0<e>>>0;if(g)C=b[s+12>>1]|0;else C=-1;b[d+28>>1]=B;b[d+30>>1]=C;k=(B&65535)+1&65535;f=(C&65535)+1&65535;w=(k&65535)<(f&65535)?f:k;u=(n&65535)<(w&65535)?w:n;if(l)b[r+12>>1]=k;if(g)b[s+12>>1]=f;f=t+1|0;if((f|0)==(j|0)){A=u;break}else{t=f;d=d+32|0;n=u}}}y=A&65535;z=j}if(!z){i=m;return y|0}j=z>>>0<3?z:3;A=0;do{n=h+(A+z<<5)|0;d=h+(A<<5)|0;c[n+0>>2]=c[d+0>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[d+12>>2];c[n+16>>2]=c[d+16>>2];c[n+20>>2]=c[d+20>>2];c[n+24>>2]=c[d+24>>2];c[n+28>>2]=c[d+28>>2];A=A+1|0}while((A|0)!=(j|0));i=m;return y|0}function usa(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=i;i=i+16|0;n=m;o=m+8|0;p=d;if(e){q=0;while(1){c[d+(q<<5)+28>>2]=0;b[d+(q<<5)+14>>1]=0;r=q+1|0;if((r|0)==(e|0))break;else q=r}}if(!g){if(!j){i=m;return}else{s=0;t=h}while(1){q=c[t>>2]|0;d=c[t+4>>2]|0;r=(q-p|0)>>>5>>>0<e>>>0;if(r)u=b[q+14>>1]|0;else u=-1;v=(d-p|0)>>>5>>>0<e>>>0;if(v)w=b[d+14>>1]|0;else w=-1;b[t+28>>1]=u;b[t+30>>1]=w;if(r)b[q+14>>1]=(u&65535)+1;if(v)b[d+14>>1]=(w&65535)+1;d=s+1|0;if((d|0)==(j|0))break;else{s=d;t=t+32|0}}i=m;return}t=g<<2;s=t>>>0>1024;w=n+4|0;a[w>>0]=s&1;if(s){s=sKa(o,t,487704,1362)|0;c[n>>2]=s;x=s}else{s=i;i=i+((1*t|0)+15&-16)|0;c[n>>2]=s;x=s}s=0;do{t=c[f+(s*40|0)>>2]|0;c[x+(s<<2)>>2]=t;c[t+28>>2]=0;b[t+14>>1]=0;s=s+1|0}while((s|0)!=(g|0));ssa(h,j,p,e,x,g);if(l){g=0;do{x=c[k+(g<<4)+4>>2]|0;if(x){e=(c[k+(g<<4)+12>>2]|0)+14|0;p=b[e>>1]|0;j=c[k+(g<<4)>>2]|0;s=0;do{f=j+s|0;b[h+(f<<5)+28>>1]=p;b[h+(f<<5)+30>>1]=p;s=s+1|0}while(s>>>0<x>>>0);b[e>>1]=(b[e>>1]|0)+1<<16>>16}g=g+1|0}while((g|0)!=(l|0))}if(!(a[w>>0]|0)){i=m;return}tKa(n,c[n>>2]|0);i=m;return}function vsa(a,d,f,h,j,k,l,m){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=Im,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im;n=i;i=i+896|0;o=n+704|0;p=n+384|0;q=n+96|0;r=n+192|0;s=n+800|0;t=n;u=n+288|0;v=n+608|0;w=n+480|0;x=(f|0)==0;if(!x){y=0;do{z=d+(y*80|0)|0;a:do if(!y)A=0;else{B=b[d+(y*80|0)+78>>1]|0;C=y;while(1){D=C;C=C+-1|0;E=c[a+(C<<2)>>2]|0;if((B&65535)>=(e[E+78>>1]|0)){A=D;break a}c[a+(D<<2)>>2]=E;if(!C){A=0;break}}}while(0);c[a+(A<<2)>>2]=z;y=y+1|0}while((y|0)!=(f|0))}if(l){i=n;return}F=ea(g[h>>2]);G=ea(g[h+4>>2]);H=ea(g[h+8>>2]);I=ea(g[h+12>>2]);J=ea(g[h+16>>2]);K=ea(g[h+20>>2]);L=ea(g[h+24>>2]);M=ea(g[h+28>>2]);N=ea(g[h+32>>2]);O=ea(g[k+4>>2]);P=ea(G*O);G=ea(H*O);H=ea(I*O);I=ea(J*O);J=ea(K*O);K=ea(L*O);L=ea(M*O);M=ea(N*O);g[w>>2]=ea(F*O);l=w+4|0;g[l>>2]=P;y=w+8|0;g[y>>2]=G;g[w+12>>2]=ea(0.0);A=w+16|0;g[A>>2]=H;d=w+20|0;g[d>>2]=I;C=w+24|0;g[C>>2]=J;g[w+28>>2]=ea(0.0);B=w+32|0;g[B>>2]=K;E=w+36|0;g[E>>2]=L;D=w+40|0;g[D>>2]=M;g[w+44>>2]=ea(0.0);M=ea(g[j>>2]);L=ea(g[j+4>>2]);K=ea(g[j+8>>2]);J=ea(g[j+12>>2]);I=ea(g[j+16>>2]);H=ea(g[j+20>>2]);G=ea(g[j+24>>2]);P=ea(g[j+28>>2]);O=ea(g[j+32>>2]);F=ea(g[k+12>>2]);N=ea(L*F);L=ea(K*F);K=ea(J*F);J=ea(I*F);I=ea(H*F);H=ea(G*F);G=ea(P*F);P=ea(O*F);Q=w+48|0;g[Q>>2]=ea(M*F);R=w+52|0;g[R>>2]=N;S=w+56|0;g[S>>2]=L;g[w+60>>2]=ea(0.0);T=w+64|0;g[T>>2]=K;U=w+68|0;g[U>>2]=J;V=w+72|0;g[V>>2]=I;g[w+76>>2]=ea(0.0);W=w+80|0;g[W>>2]=H;X=w+84|0;g[X>>2]=G;Y=w+88|0;g[Y>>2]=P;g[w+92>>2]=ea(0.0);P=ea(g[h+48>>2]);h=w+96|0;g[h>>2]=ea(P*ea(g[k>>2]));P=ea(g[j+48>>2]);j=w+112|0;g[j>>2]=ea(P*ea(g[k+8>>2]));if(x){i=n;return}x=0;while(1){k=a+(x<<2)|0;Z=b[(c[k>>2]|0)+78>>1]|0;_=(Z&65535)>>>8;$=x;while(1){aa=$+1|0;ba=aa>>>0<f>>>0;if(!ba)break;if(((e[(c[a+(aa<<2)>>2]|0)+78>>1]|0)>>>8|0)==(_|0))$=aa;else break}if((_|0)==1){if(m){b:do if(x>>>0<aa>>>0){z=x;while(1){ca=z+1|0;if((b[(c[a+(z<<2)>>2]|0)+78>>1]&255)==2){da=z;break b}if(ca>>>0<aa>>>0)z=ca;else{da=ca;break}}}else da=x;while(0);if((da+2|0)==($|0))Y$a(a+(da<<2)|0,w);Y$a(k,w)}}else if((_|0)==4){c:do if(x>>>0<aa>>>0){z=Z;ca=x;while(1){fa=ca+1|0;if(z&255){ga=ca;break c}if(fa>>>0>=aa>>>0){ga=fa;break c}z=b[(c[a+(fa<<2)>>2]|0)+78>>1]|0;ca=fa}}else ga=x;while(0);Z=aa-x|0;_=ga-x|0;if((aa|0)!=(x|0)){k=~_;$=0;ca=-1;while(1){z=~(ca>>>0>k>>>0?ca:k);fa=a+($+x<<2)|0;ha=c[fa>>2]|0;if(!(b[ha+76>>1]&8)){ia=ha;ja=ea(0.0);ka=ea(g[ha+12>>2])}else{P=ea(g[ha+12>>2]);ia=ha;ja=P;ka=P}g[ha+72>>2]=ja;P=ea(g[ia>>2]);G=ea(g[ia+4>>2]);H=ea(g[ia+8>>2]);la=ha+16|0;I=ea(g[la>>2]);J=ea(g[la+4>>2]);K=ea(g[la+8>>2]);L=ea(g[la+12>>2]);la=ha+32|0;N=ea(g[la>>2]);F=ea(g[la+4>>2]);M=ea(g[la+8>>2]);la=ha+48|0;O=ea(g[la>>2]);ma=ea(g[la+4>>2]);na=ea(g[la+8>>2]);la=$>>>0<_>>>0;if(!((la?$:_)|0)){oa=ka;pa=H;qa=G;ra=P;sa=L;ta=K;ua=J;va=I;wa=M;xa=F;ya=N;za=na;Aa=ma;Ba=O;Ca=ha}else{Da=P;P=G;G=H;H=N;N=F;F=M;M=I;I=J;J=K;K=O;O=ma;ma=na;na=ka;Ea=L;ha=0;do{L=ea(g[o+(ha<<4)>>2]);Fa=ea(g[o+(ha<<4)+4>>2]);Ga=ea(g[o+(ha<<4)+8>>2]);Ha=ea(g[s+(ha<<4)>>2]);Ia=ea(g[s+(ha<<4)+4>>2]);Ja=ea(ea(H*L)+ea(Da*Ha));Ha=ea(ea(N*Fa)+ea(P*Ia));Ia=ea(ea(F*Ga)+ea(G*ea(g[s+(ha<<4)+8>>2])));Ga=ea(g[p+(ha<<4)>>2]);Fa=ea(g[p+(ha<<4)+4>>2]);L=ea(g[p+(ha<<4)+8>>2]);Ka=ea(g[t+(ha<<4)>>2]);La=ea(g[t+(ha<<4)+4>>2]);Ma=ea(ea(ea(Ja+ea(ea(K*Ga)+ea(M*Ka)))+ea(Ha+ea(ea(O*Fa)+ea(I*La))))+ea(Ia+ea(ea(ma*L)+ea(J*ea(g[t+(ha<<4)+8>>2])))));L=ea(g[u+(ha<<4)>>2]);Ia=ea(g[u+(ha<<4)+4>>2]);La=ea(g[u+(ha<<4)+8>>2]);Da=ea(Da-ea(L*Ma));P=ea(P-ea(Ia*Ma));G=ea(G-ea(La*Ma));na=ea(na-ea(ea(g[u+(ha<<4)+12>>2])*Ma));La=ea(g[v+(ha<<4)>>2]);Ia=ea(g[v+(ha<<4)+4>>2]);L=ea(g[v+(ha<<4)+8>>2]);M=ea(M-ea(Ma*La));I=ea(I-ea(Ma*Ia));J=ea(J-ea(Ma*L));Ea=ea(Ea-ea(Ma*ea(g[v+(ha<<4)+12>>2])));L=ea(g[q+(ha<<4)>>2]);Ia=ea(g[q+(ha<<4)+4>>2]);H=ea(H-ea(Ma*L));N=ea(N-ea(Ma*Ia));F=ea(F-ea(Ma*ea(g[q+(ha<<4)+8>>2])));Ia=ea(g[r+(ha<<4)>>2]);L=ea(g[r+(ha<<4)+4>>2]);K=ea(K-ea(Ma*Ia));O=ea(O-ea(Ma*L));ma=ea(ma-ea(Ma*ea(g[r+(ha<<4)+8>>2])));ha=ha+1|0}while((ha|0)!=(z|0));oa=na;pa=G;qa=P;ra=Da;sa=Ea;ta=J;ua=I;va=M;wa=F;xa=N;ya=H;za=ma;Aa=O;Ba=K;Ca=c[fa>>2]|0}g[Ca>>2]=ra;g[Ca+4>>2]=qa;g[Ca+8>>2]=pa;g[Ca+12>>2]=oa;z=c[fa>>2]|0;g[z+16>>2]=va;g[z+20>>2]=ua;g[z+24>>2]=ta;g[z+28>>2]=sa;z=c[fa>>2]|0;g[z+32>>2]=ya;g[z+36>>2]=xa;g[z+40>>2]=wa;g[z+48>>2]=Ba;g[z+52>>2]=Aa;g[z+56>>2]=za;if(la){g[u+($<<4)>>2]=ra;g[u+($<<4)+4>>2]=qa;g[u+($<<4)+8>>2]=pa;g[u+($<<4)+12>>2]=oa;g[v+($<<4)>>2]=va;g[v+($<<4)+4>>2]=ua;g[v+($<<4)+8>>2]=ta;g[v+($<<4)+12>>2]=sa;g[q+($<<4)>>2]=ya;g[q+($<<4)+4>>2]=xa;g[q+($<<4)+8>>2]=wa;g[q+($<<4)+12>>2]=ea(0.0);g[r+($<<4)>>2]=Ba;g[r+($<<4)+4>>2]=Aa;g[r+($<<4)+8>>2]=za;g[r+($<<4)+12>>2]=ea(0.0);Ma=ea(g[h>>2]);L=ea(ra*Ma);Ia=ea(qa*Ma);La=ea(pa*Ma);Ma=ea(g[j>>2]);Fa=ea(ya*Ma);Ha=ea(xa*Ma);Ka=ea(wa*Ma);Ma=ea(va*ea(g[w>>2]));Ga=ea(Ma+ea(ua*ea(g[A>>2])));Ma=ea(Ga+ea(ta*ea(g[B>>2])));Ga=ea(va*ea(g[l>>2]));Ja=ea(Ga+ea(ua*ea(g[d>>2])));Ga=ea(Ja+ea(ta*ea(g[E>>2])));Ja=ea(va*ea(g[y>>2]));Na=ea(Ja+ea(ua*ea(g[C>>2])));Ja=ea(Na+ea(ta*ea(g[D>>2])));Na=ea(Ba*ea(g[Q>>2]));Oa=ea(Na+ea(Aa*ea(g[T>>2])));Na=ea(Oa+ea(za*ea(g[W>>2])));Oa=ea(Ba*ea(g[R>>2]));Pa=ea(Oa+ea(Aa*ea(g[U>>2])));Oa=ea(Pa+ea(za*ea(g[X>>2])));Pa=ea(Ba*ea(g[S>>2]));Qa=ea(Pa+ea(Aa*ea(g[V>>2])));Pa=ea(Qa+ea(za*ea(g[Y>>2])));Qa=ea(ea(ea(ea(ea(ra*L)+ea(ya*Fa))+ea(ea(va*Ma)+ea(Ba*Na)))+ea(ea(ea(qa*Ia)+ea(xa*Ha))+ea(ea(ua*Ga)+ea(Aa*Oa))))+ea(ea(ea(pa*La)+ea(wa*Ka))+ea(ea(ta*Ja)+ea(za*Pa))));Ra=ea(ea(1.0)/Qa);z=!(Qa>ea(0.0));Qa=z?ea(0.0):Ra;Ra=ea(Ia*Qa);Ia=ea(La*Qa);La=ea(Qa*ea(0.0));g[s+($<<4)>>2]=ea(L*Qa);g[s+($<<4)+4>>2]=Ra;g[s+($<<4)+8>>2]=Ia;g[s+($<<4)+12>>2]=La;Ia=ea(Ga*Qa);Ga=ea(Ja*Qa);g[t+($<<4)>>2]=ea(Ma*Qa);g[t+($<<4)+4>>2]=Ia;g[t+($<<4)+8>>2]=Ga;g[t+($<<4)+12>>2]=La;La=ea(Ha*Qa);Ha=ea(Ka*Qa);g[o+($<<4)>>2]=ea(Fa*Qa);g[o+($<<4)+4>>2]=La;g[o+($<<4)+8>>2]=Ha;g[o+($<<4)+12>>2]=ea(0.0);Ha=ea(Oa*Qa);Oa=ea(Pa*Qa);g[p+($<<4)>>2]=ea(Na*Qa);g[p+($<<4)+4>>2]=Ha;g[p+($<<4)+8>>2]=Oa;g[p+($<<4)+12>>2]=ea(0.0)}$=$+1|0;if(($|0)==(Z|0))break;else ca=ca+-1|0}}}if(ba)x=aa;else break}i=n;return}function wsa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=ea(q);r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=0,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im;o=i;i=i+1136|0;v=o+64|0;w=o+1024|0;x=o+1040|0;y=o+1080|0;z=o+1064|0;A=o+1052|0;B=o+32|0;C=o;D=r+26|0;b[D>>1]=0;if(!m){E=0;i=o;return E|0}F=0;do{g[v+(F*80|0)+48>>2]=ea(0.0);g[v+(F*80|0)+52>>2]=ea(0.0);g[v+(F*80|0)+56>>2]=ea(0.0);g[v+(F*80|0)+72>>2]=ea(0.0);G=v+(F*80|0)+44|0;H=v+(F*80|0)+0|0;I=H+44|0;do{c[H>>2]=0;H=H+4|0}while((H|0)<(I|0));g[G>>2]=ea(-3402823469999999843913219.0e14);g[v+(F*80|0)+60>>2]=ea(3402823469999999843913219.0e14);g[v+(F*80|0)+64>>2]=ea(0.0);g[v+(F*80|0)+68>>2]=ea(0.0);b[v+(F*80|0)+76>>1]=0;b[v+(F*80|0)+78>>1]=0;F=F+1|0}while((F|0)!=12);c[w+0>>2]=c[121984];c[w+4>>2]=c[121985];c[w+8>>2]=c[121986];c[w+12>>2]=c[121987];g[x>>2]=ea(0.0);F=x+4|0;g[F>>2]=ea(0.0);H=x+8|0;g[H>>2]=ea(0.0);I=gn[m&127](v,x,12,w,n,d,f)|0;if(!I){E=0;i=o;return E|0}f=r+8|0;if((b[f>>1]|0)==-1)J=(b[r+12>>1]|0)!=-1;else J=1;d=J?176:112;n=da(d,I)|0;m=n+48|0;K=n+79&-16;do if(K>>>0>16384)L=QAa(c[t>>2]|0,K)|0;else{M=t+4|0;N=c[M>>2]|0;O=t+8|0;if((N|0)!=0?(P=c[O>>2]|0,Q=P+K|0,Q>>>0<=16384):0){c[O>>2]=Q;L=N+P|0;break}P=SAa(c[t>>2]|0,u)|0;c[M>>2]=P;c[O>>2]=K;L=P}while(0);K=L;if((K|0)==-1|(K|0)==0){E=0;i=o;return E|0}K=r+16|0;c[K>>2]=L;b[D>>1]=m>>>4;c[r+20>>2]=c[s+32>>2];b[r+24>>1]=8;PEi(L|0,0,m|0)|0;L=c[K>>2]|0;K=L+48|0;a[L>>0]=J?4:2;a[L+1>>0]=I;a[L+2>>0]=0;g[L+32>>2]=ea(g[w>>2]);D=w+4|0;g[L+36>>2]=ea(g[D>>2]);u=w+8|0;g[L+40>>2]=ea(-ea(g[u>>2]));t=w+12|0;g[L+44>>2]=ea(-ea(g[t>>2]));g[L+16>>2]=ea(g[x>>2]);g[L+20>>2]=ea(g[F>>2]);g[L+24>>2]=ea(g[H>>2]);g[L+4>>2]=ea(ea(g[s>>2])*p);g[L+8>>2]=ea(ea(g[s+4>>2])*p);H=c[s+52>>2]|0;if(J)R=1;else R=(H&512|0)!=0;F=s+52|0;vsa(y,v,I,k,l,w,R,(H&256|0)!=0);S=(c[F>>2]&128|0)!=0?ea(.699999988):ea(1.0);H=z+4|0;R=z+8|0;v=r+12|0;r=A+4|0;x=A+8|0;P=B+4|0;O=B+8|0;M=B+12|0;N=B+16|0;Q=B+20|0;T=B+24|0;U=B+28|0;V=C+4|0;W=C+8|0;X=C+12|0;Y=C+16|0;Z=C+20|0;_=C+24|0;$=C+28|0;aa=s+60|0;s=k+4|0;ba=k+8|0;ca=k+12|0;fa=k+16|0;ga=k+20|0;ha=k+24|0;ia=k+28|0;ja=k+32|0;ka=k+48|0;la=l+4|0;ma=l+8|0;na=l+12|0;oa=l+16|0;pa=l+20|0;qa=l+24|0;ra=l+28|0;sa=l+32|0;ta=l+48|0;ua=h+4|0;va=h+8|0;wa=h+16|0;xa=h+20|0;ya=h+24|0;za=j+4|0;Aa=j+8|0;Ba=j+16|0;Ca=j+20|0;Da=j+24|0;Ea=p<ea(1.0);Fa=Ea?p:ea(1.0);if(J){J=K;Ea=0;while(1){Ga=c[y+(Ea<<2)>>2]|0;Ha=Ga+76|0;if(!(b[Ha>>1]&32))Ia=ea(1.0);else Ia=(c[F>>2]&64|0)==0?ea(1.0):Fa;Ja=ea(Ia*ea(g[Ga+44>>2]));Ka=ea(Ia*ea(g[Ga+60>>2]));La=ea(g[Ga>>2]);g[J>>2]=La;Ma=J+4|0;g[Ma>>2]=ea(g[Ga+4>>2]);Na=J+8|0;g[Na>>2]=ea(g[Ga+8>>2]);Oa=J+16|0;g[Oa>>2]=ea(g[Ga+32>>2]);Pa=J+20|0;g[Pa>>2]=ea(g[Ga+36>>2]);Qa=J+24|0;g[Qa>>2]=ea(g[Ga+40>>2]);Ra=J+32|0;g[Ra>>2]=ea(g[Ga+16>>2]);Sa=J+36|0;g[Sa>>2]=ea(g[Ga+20>>2]);Ta=J+40|0;g[Ta>>2]=ea(g[Ga+24>>2]);Ua=J+48|0;g[Ua>>2]=ea(g[Ga+48>>2]);Va=J+52|0;g[Va>>2]=ea(g[Ga+52>>2]);Wa=J+56|0;g[Wa>>2]=ea(g[Ga+56>>2]);g[J+96>>2]=Ja;g[J+100>>2]=Ka;Xa=J+108|0;c[Xa>>2]=0;g[J+104>>2]=ea(0.0);Ya=b[f>>1]|0;c[z>>2]=h;c[H>>2]=k;b[R>>1]=Ya;Ya=b[v>>1]|0;c[A>>2]=j;c[r>>2]=l;b[x>>1]=Ya;g[B>>2]=La;g[P>>2]=ea(g[Ma>>2]);g[O>>2]=ea(g[Na>>2]);g[M>>2]=ea(0.0);g[N>>2]=ea(g[Ra>>2]);g[Q>>2]=ea(g[Sa>>2]);g[T>>2]=ea(g[Ta>>2]);g[U>>2]=ea(0.0);La=ea(g[w>>2]);Ka=ea(g[D>>2]);Ja=ea(-ea(g[Oa>>2]));Za=ea(-ea(g[Pa>>2]));_a=ea(-ea(g[Qa>>2]));$a=ea(-ea(g[Ua>>2]));ab=ea(-ea(g[Va>>2]));bb=ea(-ea(g[Wa>>2]));g[C>>2]=Ja;g[V>>2]=Za;g[W>>2]=_a;g[X>>2]=ea(0.0);g[Y>>2]=$a;g[Z>>2]=ab;g[_>>2]=bb;g[$>>2]=ea(0.0);bb=ea(g[u>>2]);ab=ea(ywa(z,B,J+112|0,La,Ka,A,C,J+144|0,bb,ea(g[t>>2]),1));Wa=e[Ha>>1]|0;if((Wa&4|0)!=0|(Wa&3|0)==3){bb=ea(wwa(z,J,Ra));cb=ea(bb-ea(wwa(A,Oa,Ua)))}else cb=ea(0.0);Z$a(J+12|0,J+28|0,J+44|0,J+60|0,Ga,cb,ab,ea(g[aa>>2]),S,p,q);if(b[Ha>>1]&16)c[Xa>>2]=c[Xa>>2]|2;Ea=Ea+1|0;if((Ea|0)==(I|0))break;else J=J+d|0}}else{J=K;K=0;while(1){Ea=c[y+(K<<2)>>2]|0;A=Ea+76|0;if(!(b[A>>1]&32))db=ea(1.0);else db=(c[F>>2]&64|0)==0?ea(1.0):Fa;cb=ea(db*ea(g[Ea+44>>2]));Ia=ea(db*ea(g[Ea+60>>2]));g[J>>2]=ea(g[Ea>>2]);z=Ea+4|0;C=J+4|0;g[C>>2]=ea(g[z>>2]);B=Ea+8|0;$=J+8|0;g[$>>2]=ea(g[B>>2]);_=Ea+32|0;Z=J+16|0;g[Z>>2]=ea(g[_>>2]);Y=Ea+36|0;X=J+20|0;g[X>>2]=ea(g[Y>>2]);W=Ea+40|0;V=J+24|0;g[V>>2]=ea(g[W>>2]);U=Ea+16|0;T=J+32|0;g[T>>2]=ea(g[U>>2]);Q=Ea+20|0;N=J+36|0;g[N>>2]=ea(g[Q>>2]);M=Ea+24|0;O=J+40|0;g[O>>2]=ea(g[M>>2]);P=Ea+48|0;x=J+48|0;g[x>>2]=ea(g[P>>2]);r=Ea+52|0;v=J+52|0;g[v>>2]=ea(g[r>>2]);R=Ea+56|0;H=J+56|0;g[H>>2]=ea(g[R>>2]);g[J+96>>2]=cb;g[J+100>>2]=Ia;f=J+108|0;c[f>>2]=0;g[J+104>>2]=ea(0.0);Ia=ea(g[w>>2]);cb=ea(g[D>>2]);ab=ea(g[U>>2]);bb=ea(ab*ea(g[k>>2]));Ka=ea(ab*ea(g[s>>2]));La=ea(ab*ea(g[ba>>2]));ab=ea(g[Q>>2]);$a=ea(ab*ea(g[ca>>2]));_a=ea(ab*ea(g[fa>>2]));Za=ea(bb+$a);$a=ea(Ka+_a);_a=ea(La+ea(ab*ea(g[ga>>2])));ab=ea(g[M>>2]);La=ea(ab*ea(g[ha>>2]));Ka=ea(ab*ea(g[ia>>2]));bb=ea(cb*ea(Za+La));La=ea(cb*ea($a+Ka));Ka=ea(cb*ea(_a+ea(ab*ea(g[ja>>2]))));g[J+64>>2]=bb;g[J+68>>2]=La;g[J+72>>2]=Ka;ab=ea(g[Ea>>2]);_a=ea(ab*ab);ab=ea(g[z>>2]);cb=ea(_a+ea(ab*ab));ab=ea(g[B>>2]);_a=ea(cb+ea(ab*ab));ab=ea(Ia*ea(ea(g[ka>>2])*_a));_a=ea(bb*ea(g[U>>2]));bb=ea(_a+ea(La*ea(g[Q>>2])));La=ea(ab+ea(bb+ea(Ka*ea(g[M>>2]))));Ka=ea(g[_>>2]);bb=ea(g[Y>>2]);ab=ea(g[W>>2]);_a=ea(-ea(g[P>>2]));Ia=ea(-ea(g[r>>2]));cb=ea(-ea(g[R>>2]));$a=ea(g[u>>2]);Za=ea(g[t>>2]);Ja=ea(ea(g[l>>2])*_a);eb=ea(ea(g[la>>2])*_a);fb=ea(ea(g[ma>>2])*_a);gb=ea(ea(g[na>>2])*Ia);hb=ea(ea(g[oa>>2])*Ia);ib=ea(Ja+gb);gb=ea(eb+hb);hb=ea(fb+ea(ea(g[pa>>2])*Ia));fb=ea(ea(g[qa>>2])*cb);eb=ea(ea(g[ra>>2])*cb);Ja=ea(Za*ea(ib+fb));fb=ea(Za*ea(gb+eb));eb=ea(Za*ea(hb+ea(ea(g[sa>>2])*cb)));g[J+80>>2]=Ja;g[J+84>>2]=fb;g[J+88>>2]=eb;hb=ea(ea(ea(Ka*Ka)+ea(bb*bb))+ea(ab*ab));ab=ea(La+ea(ea($a*ea(hb*ea(g[ta>>2])))+ea(ea(ea(Ja*_a)+ea(fb*Ia))+ea(eb*cb))));cb=ea(g[ka>>2]);g[J+76>>2]=ea(cb*ea(g[w>>2]));cb=ea(g[ta>>2]);g[J+92>>2]=ea(-ea(cb*ea(g[u>>2])));R=e[A>>1]|0;if((R&4|0)!=0|(R&3|0)==3){cb=ea(g[h>>2]);eb=ea(cb*ea(g[J>>2]));cb=ea(g[ua>>2]);Ia=ea(eb+ea(cb*ea(g[C>>2])));cb=ea(g[va>>2]);eb=ea(Ia+ea(cb*ea(g[$>>2])));cb=ea(g[wa>>2]);Ia=ea(cb*ea(g[T>>2]));cb=ea(g[xa>>2]);fb=ea(Ia+ea(cb*ea(g[N>>2])));cb=ea(g[ya>>2]);Ia=ea(eb+ea(fb+ea(cb*ea(g[O>>2]))));cb=ea(g[j>>2]);fb=ea(cb*ea(g[Z>>2]));cb=ea(g[za>>2]);eb=ea(fb+ea(cb*ea(g[X>>2])));cb=ea(g[Aa>>2]);fb=ea(eb+ea(cb*ea(g[V>>2])));cb=ea(g[Ba>>2]);eb=ea(cb*ea(g[x>>2]));cb=ea(g[Ca>>2]);_a=ea(eb+ea(cb*ea(g[v>>2])));cb=ea(g[Da>>2]);jb=ea(Ia-ea(fb+ea(_a+ea(cb*ea(g[H>>2])))))}else jb=ea(0.0);Z$a(J+12|0,J+28|0,J+44|0,J+60|0,Ea,jb,ab,ea(g[aa>>2]),S,p,q);if(b[A>>1]&16)c[f>>2]=c[f>>2]|2;K=K+1|0;if((K|0)==(I|0))break;else J=J+d|0}}c[L+m>>2]=0;c[L+(n+52)>>2]=0;E=I;i=o;return E|0}function xsa(d,f,h,j,k){d=d|0;f=ea(f);h=ea(h);j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=Im,Zb=0,_b=Im,$b=0,ac=Im,bc=0,cc=Im,dc=0,ec=0,fc=0,gc=Im,hc=Im,ic=0,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=0,vc=0,wc=0,xc=0,yc=Im,zc=0,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=Im,cd=Im,dd=Im,ed=Im;l=i;i=i+4176|0;m=l+3840|0;n=l;o=l+3984|0;p=l+3936|0;q=l+3872|0;r=l+3856|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;s=p+4|0;t=p+8|0;u=p+12|0;v=p+16|0;w=p+20|0;x=p+24|0;y=p+28|0;z=p+32|0;A=p+36|0;B=p+40|0;C=p+44|0;D=p+0|0;E=D+48|0;do{c[D>>2]=0;D=D+4|0}while((D|0)<(E|0));D=q+0|0;F=487952|0;E=D+64|0;do{c[D>>2]=c[F>>2];D=D+4|0;F=F+4|0}while((D|0)<(E|0));F=0;G=0;H=0;I=0;while(1){J=n+(H*80|0)|0;K=c[d+(F*52|0)+28>>2]|0;if(!K){L=1;M=56;break}if(I>>>0<12){N=I;do{O=N+H|0;g[n+(O*80|0)+48>>2]=ea(0.0);g[n+(O*80|0)+52>>2]=ea(0.0);g[n+(O*80|0)+56>>2]=ea(0.0);g[n+(O*80|0)+72>>2]=ea(0.0);P=n+(O*80|0)+44|0;D=n+(O*80|0)+0|0;E=D+44|0;do{c[D>>2]=0;D=D+4|0}while((D|0)<(E|0));g[P>>2]=ea(-3402823469999999843913219.0e14);g[n+(O*80|0)+60>>2]=ea(3402823469999999843913219.0e14);g[n+(O*80|0)+64>>2]=ea(0.0);g[n+(O*80|0)+68>>2]=ea(0.0);b[n+(O*80|0)+76>>1]=0;b[n+(O*80|0)+78>>1]=0;N=N+1|0}while((N|0)!=12)}N=q+(F<<4)|0;Q=gn[K&127](J,p+(F*12|0)|0,12,N,c[d+(F*52|0)+32>>2]|0,c[d+(F*52|0)+4>>2]|0,c[d+(F*52|0)+8>>2]|0)|0;if(!Q){L=1;M=56;break}R=Q>>>0<G>>>0?G:Q;c[d+(F*52|0)+44>>2]=H;c[d+(F*52|0)+48>>2]=Q;S=c[(c[d+(F*52|0)>>2]|0)+52>>2]|0;vsa(o+(H<<2)|0,J,Q,c[d+(F*52|0)+20>>2]|0,c[d+(F*52|0)+24>>2]|0,N,(S&512|0)!=0,(S&256|0)!=0);F=F+1|0;if(F>>>0>=4){M=7;break}else{G=R;H=Q+H|0;I=12-Q|0}}if((M|0)==7){I=R*416|0;H=I+128|0;F=I+159&-16;do if(F>>>0>16384)T=QAa(c[j>>2]|0,F)|0;else{I=j+4|0;n=c[I>>2]|0;D=j+8|0;if((n|0)!=0?(E=c[D>>2]|0,S=E+F|0,S>>>0<=16384):0){c[D>>2]=S;T=n+E|0;break}E=SAa(c[j>>2]|0,k)|0;c[I>>2]=E;c[D>>2]=F;T=E}while(0);F=T;if((F|0)==0|(F|0)==-1){F=d+40|0;c[(c[F>>2]|0)+16>>2]=0;k=c[F>>2]|0;b[k+26>>1]=0;c[k+20>>2]=c[(c[d>>2]|0)+32>>2];k=d+92|0;c[(c[k>>2]|0)+16>>2]=0;F=c[k>>2]|0;b[F+26>>1]=0;c[F+20>>2]=c[(c[d+52>>2]|0)+32>>2];F=d+144|0;c[(c[F>>2]|0)+16>>2]=0;k=c[F>>2]|0;b[k+26>>1]=0;c[k+20>>2]=c[(c[d+104>>2]|0)+32>>2];k=d+196|0;c[(c[k>>2]|0)+16>>2]=0;F=c[k>>2]|0;b[F+26>>1]=0;c[F+20>>2]=c[(c[d+156>>2]|0)+32>>2];L=0;i=l;return L|0}F=H>>>4&65535;H=d+40|0;c[(c[H>>2]|0)+16>>2]=T;k=c[H>>2]|0;b[k+26>>1]=F;c[k+20>>2]=c[(c[d>>2]|0)+32>>2];k=d+92|0;c[(c[k>>2]|0)+16>>2]=T;H=c[k>>2]|0;b[H+26>>1]=F;k=d+52|0;c[H+20>>2]=c[(c[k>>2]|0)+32>>2];H=d+144|0;c[(c[H>>2]|0)+16>>2]=T;j=c[H>>2]|0;b[j+26>>1]=F;H=d+104|0;c[j+20>>2]=c[(c[H>>2]|0)+32>>2];j=d+196|0;c[(c[j>>2]|0)+16>>2]=T;E=c[j>>2]|0;b[E+26>>1]=F;F=d+156|0;c[E+20>>2]=c[(c[F>>2]|0)+32>>2];g[r>>2]=(c[(c[d>>2]|0)+52>>2]&128|0)!=0?ea(.699999988):ea(1.0);E=r+4|0;g[E>>2]=(c[(c[k>>2]|0)+52>>2]&128|0)!=0?ea(.699999988):ea(1.0);j=r+8|0;g[j>>2]=(c[(c[H>>2]|0)+52>>2]&128|0)!=0?ea(.699999988):ea(1.0);D=r+12|0;g[D>>2]=(c[(c[F>>2]|0)+52>>2]&128|0)!=0?ea(.699999988):ea(1.0);I=T+128|0;n=c[d+20>>2]|0;S=c[d+72>>2]|0;N=c[d+124>>2]|0;U=c[d+176>>2]|0;V=c[d+24>>2]|0;W=c[d+76>>2]|0;X=c[d+128>>2]|0;Y=c[d+180>>2]|0;Z=ea(g[q>>2]);_=ea(g[q+16>>2]);$=ea(g[q+32>>2]);aa=ea(g[q+48>>2]);ba=ea(g[q+8>>2]);ca=ea(g[q+24>>2]);da=ea(g[q+40>>2]);fa=ea(g[q+56>>2]);ga=ea(g[n+48>>2]);ha=ea(g[S+48>>2]);ia=ea(g[N+48>>2]);ja=ea(Z*ga);ga=ea(_*ha);ha=ea($*ia);ia=ea(aa*ea(g[U+48>>2]));aa=ea(g[V+48>>2]);$=ea(g[W+48>>2]);_=ea(g[X+48>>2]);Z=ea(-ea(ba*aa));aa=ea(-ea(ca*$));$=ea(-ea(da*_));_=ea(-ea(fa*ea(g[Y+48>>2])));fa=ea(g[q+4>>2]);da=ea(g[q+20>>2]);ca=ea(g[q+36>>2]);ba=ea(g[q+52>>2]);ka=ea(g[q+12>>2]);la=ea(g[q+28>>2]);ma=ea(g[q+44>>2]);na=ea(g[q+60>>2]);oa=ea(g[n>>2]);pa=ea(g[n+4>>2]);qa=ea(g[n+8>>2]);ra=ea(g[n+12>>2]);sa=ea(g[n+16>>2]);ta=ea(g[n+20>>2]);ua=ea(g[n+24>>2]);va=ea(g[n+28>>2]);wa=ea(g[n+32>>2]);xa=ea(g[S>>2]);ya=ea(g[S+4>>2]);za=ea(g[S+8>>2]);Aa=ea(g[S+12>>2]);Ba=ea(g[S+16>>2]);Ca=ea(g[S+20>>2]);Da=ea(g[S+24>>2]);Ea=ea(g[S+28>>2]);Fa=ea(g[S+32>>2]);Ga=ea(g[N>>2]);Ha=ea(g[N+4>>2]);Ia=ea(g[N+8>>2]);Ja=ea(g[N+12>>2]);Ka=ea(g[N+16>>2]);La=ea(g[N+20>>2]);Ma=ea(g[N+24>>2]);Na=ea(g[N+28>>2]);Oa=ea(g[N+32>>2]);Pa=ea(g[U>>2]);Qa=ea(g[U+4>>2]);Ra=ea(g[U+8>>2]);Sa=ea(g[U+12>>2]);Ta=ea(g[U+16>>2]);Ua=ea(g[U+20>>2]);Va=ea(g[U+24>>2]);Wa=ea(g[U+28>>2]);Xa=ea(g[U+32>>2]);Ya=ea(g[V>>2]);Za=ea(g[V+4>>2]);_a=ea(g[V+8>>2]);$a=ea(g[V+12>>2]);ab=ea(g[V+16>>2]);bb=ea(g[V+20>>2]);cb=ea(g[V+24>>2]);db=ea(g[V+28>>2]);eb=ea(g[V+32>>2]);fb=ea(g[W>>2]);gb=ea(g[W+4>>2]);hb=ea(g[W+8>>2]);ib=ea(g[W+12>>2]);jb=ea(g[W+16>>2]);kb=ea(g[W+20>>2]);lb=ea(g[W+24>>2]);mb=ea(g[W+28>>2]);nb=ea(g[W+32>>2]);ob=ea(g[X>>2]);pb=ea(g[X+4>>2]);qb=ea(g[X+8>>2]);rb=ea(g[X+12>>2]);sb=ea(g[X+16>>2]);tb=ea(g[X+20>>2]);ub=ea(g[X+24>>2]);vb=ea(g[X+28>>2]);wb=ea(g[X+32>>2]);xb=ea(g[Y>>2]);yb=ea(g[Y+4>>2]);zb=ea(g[Y+8>>2]);Ab=ea(g[Y+12>>2]);Bb=ea(g[Y+16>>2]);Cb=ea(g[Y+20>>2]);Db=ea(g[Y+24>>2]);Eb=ea(g[Y+28>>2]);Fb=ea(fa*oa);oa=ea(da*xa);xa=ea(ca*Ga);Ga=ea(ba*Pa);Pa=ea(fa*pa);pa=ea(da*ya);ya=ea(ca*Ha);Ha=ea(ba*Qa);Qa=ea(fa*qa);qa=ea(da*za);za=ea(ca*Ia);Ia=ea(ba*Ra);Ra=ea(fa*ra);ra=ea(da*Aa);Aa=ea(ca*Ja);Ja=ea(ba*Sa);Sa=ea(fa*sa);sa=ea(da*Ba);Ba=ea(ca*Ka);Ka=ea(ba*Ta);Ta=ea(fa*ta);ta=ea(da*Ca);Ca=ea(ca*La);La=ea(ba*Ua);Ua=ea(fa*ua);ua=ea(da*Da);Da=ea(ca*Ma);Ma=ea(ba*Va);Va=ea(fa*va);va=ea(da*Ea);Ea=ea(ca*Na);Na=ea(ba*Wa);Wa=ea(fa*wa);wa=ea(da*Fa);Fa=ea(ca*Oa);Oa=ea(ba*Xa);Xa=ea(ka*Ya);Ya=ea(la*fb);fb=ea(ma*ob);ob=ea(na*xb);xb=ea(ka*Za);Za=ea(la*gb);gb=ea(ma*pb);pb=ea(na*yb);yb=ea(ka*_a);_a=ea(la*hb);hb=ea(ma*qb);qb=ea(na*zb);zb=ea(ka*$a);$a=ea(la*ib);ib=ea(ma*rb);rb=ea(na*Ab);Ab=ea(ka*ab);ab=ea(la*jb);jb=ea(ma*sb);sb=ea(na*Bb);Bb=ea(ka*bb);bb=ea(la*kb);kb=ea(ma*tb);tb=ea(na*Cb);Cb=ea(ka*cb);cb=ea(la*lb);lb=ea(ma*ub);ub=ea(na*Db);Db=ea(ka*db);db=ea(la*mb);mb=ea(ma*vb);vb=ea(na*Eb);Eb=ea(ka*eb);eb=ea(la*nb);nb=ea(ma*wb);wb=ea(na*ea(g[Y+32>>2]));na=ea(g[p>>2]);ma=ea(g[s>>2]);la=ea(g[t>>2]);ka=ea(g[u>>2]);ba=ea(g[v>>2]);ca=ea(g[w>>2]);da=ea(g[x>>2]);fa=ea(g[y>>2]);Gb=ea(g[z>>2]);Hb=ea(g[A>>2]);Ib=ea(g[B>>2]);Jb=ea(g[C>>2]);C=c[d>>2]|0;Kb=ea(g[C>>2]);B=c[k>>2]|0;Lb=ea(g[B>>2]);A=c[H>>2]|0;Mb=ea(g[A>>2]);z=c[F>>2]|0;Nb=ea(g[z>>2]);Ob=ea(g[C+4>>2]);Pb=ea(g[B+4>>2]);Qb=ea(g[A+4>>2]);Rb=ea(g[z+4>>2]);g[T+48>>2]=ja;g[T+52>>2]=ga;g[T+56>>2]=ha;g[T+60>>2]=ia;g[T+64>>2]=Z;g[T+68>>2]=aa;g[T+72>>2]=$;g[T+76>>2]=_;g[T+80>>2]=na;g[T+84>>2]=ka;g[T+88>>2]=da;g[T+92>>2]=Hb;g[T+96>>2]=ma;g[T+100>>2]=ba;g[T+104>>2]=fa;g[T+108>>2]=Ib;g[T+112>>2]=la;g[T+116>>2]=ca;g[T+120>>2]=Gb;g[T+124>>2]=Jb;c[T+4>>2]=R;a[T>>0]=9;Jb=ea(Lb*f);Lb=ea(Mb*f);Mb=ea(Nb*f);g[T+16>>2]=ea(Kb*f);g[T+20>>2]=Jb;g[T+24>>2]=Lb;g[T+28>>2]=Mb;Mb=ea(Pb*f);Pb=ea(Qb*f);Qb=ea(Rb*f);g[T+32>>2]=ea(Ob*f);g[T+36>>2]=Mb;g[T+40>>2]=Pb;g[T+44>>2]=Qb;z=d+48|0;a[T+8>>0]=c[z>>2];A=d+100|0;a[T+9>>0]=c[A>>2];B=d+152|0;a[T+10>>0]=c[B>>2];C=d+204|0;a[T+11>>0]=c[C>>2];y=(c[z>>2]|0)+-1|0;x=c[d+96>>2]|0;w=x+-1+(c[A>>2]|0)|0;v=c[d+148>>2]|0;u=v+-1+(c[B>>2]|0)|0;t=c[d+200>>2]|0;s=t+-1+(c[C>>2]|0)|0;if(!R)Sb=I;else{p=d+12|0;Y=d+16|0;X=d+64|0;W=d+68|0;V=d+116|0;U=d+120|0;N=d+168|0;S=d+172|0;n=f<ea(1.0);Qb=n?f:ea(1.0);n=(Q>>>0>G>>>0?Q:G)*416|0;G=0;Q=I;I=0;q=x;x=v;v=t;do{t=Q;Q=Q+416|0;Tb=c[o+(I<<2)>>2]|0;Ub=c[o+(q<<2)>>2]|0;Vb=c[o+(x<<2)>>2]|0;Wb=c[o+(v<<2)>>2]|0;I=((I|0)!=(y|0)&1)+I|0;q=((q|0)!=(w|0)&1)+q|0;x=((x|0)!=(u|0)&1)+x|0;v=((v|0)!=(s|0)&1)+v|0;Xb=Tb+76|0;if(!(b[Xb>>1]&32))Yb=ea(1.0);else Yb=(c[(c[d>>2]|0)+52>>2]&64|0)==0?ea(1.0):Qb;Zb=Ub+76|0;if(!(b[Zb>>1]&32))_b=ea(1.0);else _b=(c[(c[k>>2]|0)+52>>2]&64|0)==0?ea(1.0):Qb;$b=Vb+76|0;if(!(b[$b>>1]&32))ac=ea(1.0);else ac=(c[(c[H>>2]|0)+52>>2]&64|0)==0?ea(1.0):Qb;bc=Wb+76|0;if(!(b[bc>>1]&32))cc=ea(1.0);else cc=(c[(c[F>>2]|0)+52>>2]&64|0)==0?ea(1.0):Qb;Pb=ea(g[Tb>>2]);Mb=ea(g[Tb+4>>2]);Ob=ea(g[Tb+8>>2]);Rb=ea(g[Ub>>2]);Lb=ea(g[Ub+4>>2]);Jb=ea(g[Ub+8>>2]);Kb=ea(g[Vb>>2]);Nb=ea(g[Vb+4>>2]);Gb=ea(g[Vb+8>>2]);ca=ea(g[Wb>>2]);la=ea(g[Wb+4>>2]);Ib=ea(g[Wb+8>>2]);dc=Tb+16|0;fa=ea(g[dc>>2]);ba=ea(g[dc+4>>2]);ma=ea(g[dc+8>>2]);ec=Ub+16|0;Hb=ea(g[ec>>2]);da=ea(g[ec+4>>2]);ka=ea(g[ec+8>>2]);fc=Vb+16|0;na=ea(g[fc>>2]);gc=ea(g[fc+4>>2]);hc=ea(g[fc+8>>2]);ic=Wb+16|0;jc=ea(g[ic>>2]);kc=ea(g[ic+4>>2]);lc=ea(g[ic+8>>2]);mc=ea(g[Tb+60>>2]);nc=ea(g[Ub+60>>2]);oc=ea(g[Vb+60>>2]);pc=ea(g[Wb+60>>2]);qc=ea(g[Tb+44>>2]);rc=ea(g[Ub+44>>2]);sc=ea(g[Vb+44>>2]);tc=ea(g[Wb+44>>2]);uc=t+256|0;vc=t+260|0;wc=t+264|0;xc=t+268|0;c[uc+0>>2]=0;c[uc+4>>2]=0;c[uc+8>>2]=0;c[uc+12>>2]=0;g[t>>2]=Pb;g[t+4>>2]=Rb;g[t+8>>2]=Kb;g[t+12>>2]=ca;g[t+16>>2]=Mb;g[t+20>>2]=Lb;g[t+24>>2]=Nb;g[t+28>>2]=la;g[t+32>>2]=Ob;g[t+36>>2]=Jb;g[t+40>>2]=Gb;g[t+44>>2]=Ib;g[t+48>>2]=fa;g[t+52>>2]=Hb;g[t+56>>2]=na;g[t+60>>2]=jc;g[t+64>>2]=ba;g[t+68>>2]=da;g[t+72>>2]=gc;g[t+76>>2]=kc;g[t+80>>2]=ma;g[t+84>>2]=ka;g[t+88>>2]=hc;g[t+92>>2]=lc;yc=ea(_b*rc);rc=ea(ac*sc);sc=ea(cc*tc);g[t+208>>2]=ea(Yb*qc);g[t+212>>2]=yc;g[t+216>>2]=rc;g[t+220>>2]=sc;sc=ea(_b*nc);nc=ea(ac*oc);oc=ea(cc*pc);g[t+224>>2]=ea(Yb*mc);g[t+228>>2]=sc;g[t+232>>2]=nc;g[t+236>>2]=oc;zc=t+240|0;c[zc+0>>2]=c[m+0>>2];c[zc+4>>2]=c[m+4>>2];c[zc+8>>2]=c[m+8>>2];c[zc+12>>2]=c[m+12>>2];oc=ea(ea(Ua*ma)+ea(ea(Fb*fa)+ea(Ra*ba)));nc=ea(ea(ua*ka)+ea(ea(oa*Hb)+ea(ra*da)));sc=ea(ea(Da*hc)+ea(ea(xa*na)+ea(Aa*gc)));mc=ea(ea(Ma*lc)+ea(ea(Ga*jc)+ea(Ja*kc)));pc=ea(ea(Va*ma)+ea(ea(Pa*fa)+ea(Sa*ba)));rc=ea(ea(va*ka)+ea(ea(pa*Hb)+ea(sa*da)));yc=ea(ea(Ea*hc)+ea(ea(ya*na)+ea(Ba*gc)));qc=ea(ea(Na*lc)+ea(ea(Ha*jc)+ea(Ka*kc)));tc=ea(ea(Wa*ma)+ea(ea(Qa*fa)+ea(Ta*ba)));Ac=ea(ea(wa*ka)+ea(ea(qa*Hb)+ea(ta*da)));Bc=ea(ea(Fa*hc)+ea(ea(za*na)+ea(Ca*gc)));Cc=ea(ea(Oa*lc)+ea(ea(Ia*jc)+ea(La*kc)));Dc=ea(ea(Ob*Ob)+ea(ea(Pb*Pb)+ea(Mb*Mb)));Mb=ea(ea(Jb*Jb)+ea(ea(Rb*Rb)+ea(Lb*Lb)));Lb=ea(ea(Gb*Gb)+ea(ea(Kb*Kb)+ea(Nb*Nb)));Nb=ea(ea(Ib*Ib)+ea(ea(ca*ca)+ea(la*la)));la=ea(ea(ma*tc)+ea(ea(ba*pc)+ea(fa*oc)));fa=ea(ea(ka*Ac)+ea(ea(da*rc)+ea(Hb*nc)));Hb=ea(ea(hc*Bc)+ea(ea(gc*yc)+ea(na*sc)));na=ea(ea(lc*Cc)+ea(ea(kc*qc)+ea(jc*mc)));g[t+96>>2]=oc;g[t+100>>2]=nc;g[t+104>>2]=sc;g[t+108>>2]=mc;g[t+112>>2]=pc;g[t+116>>2]=rc;g[t+120>>2]=yc;g[t+124>>2]=qc;g[t+128>>2]=tc;g[t+132>>2]=Ac;g[t+136>>2]=Bc;g[t+140>>2]=Cc;Cc=ea(ea(ja*Dc)+la);la=ea(ea(ga*Mb)+fa);fa=ea(ea(ha*Lb)+Hb);Hb=ea(ea(ia*Nb)+na);zc=Tb+32|0;c[uc+0>>2]=0;c[uc+4>>2]=0;c[uc+8>>2]=0;c[uc+12>>2]=0;na=ea(g[zc>>2]);Nb=ea(g[zc+4>>2]);Lb=ea(g[zc+8>>2]);Ec=Ub+32|0;Mb=ea(g[Ec>>2]);Dc=ea(g[Ec+4>>2]);Bc=ea(g[Ec+8>>2]);Fc=Vb+32|0;Ac=ea(g[Fc>>2]);tc=ea(g[Fc+4>>2]);qc=ea(g[Fc+8>>2]);Gc=Wb+32|0;yc=ea(g[Gc>>2]);rc=ea(g[Gc+4>>2]);pc=ea(g[Gc+8>>2]);Hc=Tb+48|0;mc=ea(g[Hc>>2]);sc=ea(g[Hc+4>>2]);nc=ea(g[Hc+8>>2]);Ic=Ub+48|0;oc=ea(g[Ic>>2]);jc=ea(g[Ic+4>>2]);kc=ea(g[Ic+8>>2]);Jc=Vb+48|0;lc=ea(g[Jc>>2]);gc=ea(g[Jc+4>>2]);hc=ea(g[Jc+8>>2]);Kc=Wb+48|0;da=ea(g[Kc>>2]);ka=ea(g[Kc+4>>2]);ba=ea(g[Kc+8>>2]);ma=ea(ea(Cb*nc)+ea(ea(Xa*mc)+ea(zb*sc)));ca=ea(ea(cb*kc)+ea(ea(Ya*oc)+ea($a*jc)));Ib=ea(ea(lb*hc)+ea(ea(fb*lc)+ea(ib*gc)));Kb=ea(ea(ub*ba)+ea(ea(ob*da)+ea(rb*ka)));Gb=ea(ea(Db*nc)+ea(ea(xb*mc)+ea(Ab*sc)));Rb=ea(ea(db*kc)+ea(ea(Za*oc)+ea(ab*jc)));Jb=ea(ea(mb*hc)+ea(ea(gb*lc)+ea(jb*gc)));Pb=ea(ea(vb*ba)+ea(ea(pb*da)+ea(sb*ka)));Ob=ea(ea(Eb*nc)+ea(ea(yb*mc)+ea(Bb*sc)));Lc=ea(ea(eb*kc)+ea(ea(_a*oc)+ea(bb*jc)));Mc=ea(ea(nb*hc)+ea(ea(hb*lc)+ea(kb*gc)));Nc=ea(ea(wb*ba)+ea(ea(qb*da)+ea(tb*ka)));Oc=ea(ea(Lb*Lb)+ea(ea(na*na)+ea(Nb*Nb)));Pc=ea(ea(Bc*Bc)+ea(ea(Mb*Mb)+ea(Dc*Dc)));Qc=ea(ea(qc*qc)+ea(ea(Ac*Ac)+ea(tc*tc)));Rc=ea(ea(pc*pc)+ea(ea(yc*yc)+ea(rc*rc)));Sc=ea(ea(nc*Ob)+ea(ea(sc*Gb)+ea(mc*ma)));Tc=ea(ea(kc*Lc)+ea(ea(jc*Rb)+ea(oc*ca)));Uc=ea(ea(hc*Mc)+ea(ea(gc*Jb)+ea(lc*Ib)));Vc=ea(ea(ba*Nc)+ea(ea(ka*Pb)+ea(da*Kb)));g[t+272>>2]=na;g[t+276>>2]=Mb;g[t+280>>2]=Ac;g[t+284>>2]=yc;g[t+288>>2]=Nb;g[t+292>>2]=Dc;g[t+296>>2]=tc;g[t+300>>2]=rc;g[t+304>>2]=Lb;g[t+308>>2]=Bc;g[t+312>>2]=qc;g[t+316>>2]=pc;g[t+320>>2]=mc;g[t+324>>2]=oc;g[t+328>>2]=lc;g[t+332>>2]=da;g[t+336>>2]=sc;g[t+340>>2]=jc;g[t+344>>2]=gc;g[t+348>>2]=ka;g[t+352>>2]=nc;g[t+356>>2]=kc;g[t+360>>2]=hc;g[t+364>>2]=ba;ba=ea(-ca);ca=ea(-Ib);Ib=ea(-Kb);g[t+368>>2]=ea(-ma);g[t+372>>2]=ba;g[t+376>>2]=ca;g[t+380>>2]=Ib;Ib=ea(-Rb);Rb=ea(-Jb);Jb=ea(-Pb);g[t+384>>2]=ea(-Gb);g[t+388>>2]=Ib;g[t+392>>2]=Rb;g[t+396>>2]=Jb;Jb=ea(-Lc);Lc=ea(-Mc);Mc=ea(-Nc);g[t+400>>2]=ea(-Ob);g[t+404>>2]=Jb;g[t+408>>2]=Lc;g[t+412>>2]=Mc;Mc=ea(Cc+ea(Sc-ea(Oc*Z)));Oc=ea(la+ea(Tc-ea(Pc*aa)));Pc=ea(fa+ea(Uc-ea(Qc*$)));Qc=ea(Hb+ea(Vc-ea(Rc*_)));Wc=t+144|0;Xc=t+160|0;Yc=t+176|0;Zc=t+192|0;Rc=ea(g[(c[d>>2]|0)+60>>2]);Vc=ea(g[r>>2]);_c=c[p>>2]|0;$c=c[Y>>2]|0;if(G>>>0<(c[z>>2]|0)>>>0){ad=e[Xb>>1]|0;if((ad&4|0)!=0|(ad&3|0)==3){Hb=ea(g[_c>>2]);Uc=ea(Hb*ea(g[Tb>>2]));Hb=ea(g[_c+4>>2]);fa=ea(Uc+ea(Hb*ea(g[Tb+4>>2])));Hb=ea(g[_c+8>>2]);Uc=ea(fa+ea(Hb*ea(g[Tb+8>>2])));Hb=ea(g[_c+16>>2]);fa=ea(Hb*ea(g[dc>>2]));Hb=ea(g[_c+20>>2]);Tc=ea(fa+ea(Hb*ea(g[Tb+20>>2])));Hb=ea(g[_c+24>>2]);fa=ea(Uc+ea(Tc+ea(Hb*ea(g[Tb+24>>2]))));Hb=ea(g[$c>>2]);Tc=ea(Hb*ea(g[zc>>2]));Hb=ea(g[$c+4>>2]);Uc=ea(Tc+ea(Hb*ea(g[Tb+36>>2])));Hb=ea(g[$c+8>>2]);Tc=ea(Uc+ea(Hb*ea(g[Tb+40>>2])));Hb=ea(g[$c+16>>2]);Uc=ea(Hb*ea(g[Hc>>2]));Hb=ea(g[$c+20>>2]);la=ea(Uc+ea(Hb*ea(g[Tb+52>>2])));Hb=ea(g[$c+24>>2]);bd=ea(fa-ea(Tc+ea(la+ea(Hb*ea(g[Tb+56>>2])))))}else bd=ea(0.0);Z$a(Wc,Xc,Yc,Zc,Tb,bd,Mc,Rc,Vc,f,h)}else{g[Wc>>2]=ea(0.0);g[Xc>>2]=ea(0.0);g[Yc>>2]=ea(0.0);g[Zc>>2]=ea(0.0)}Zc=t+148|0;Yc=t+164|0;Xc=t+180|0;Wc=t+196|0;Vc=ea(g[(c[k>>2]|0)+60>>2]);Rc=ea(g[E>>2]);Tb=c[X>>2]|0;$c=c[W>>2]|0;if(G>>>0<(c[A>>2]|0)>>>0){Hc=e[Zb>>1]|0;if((Hc&4|0)!=0|(Hc&3|0)==3){Mc=ea(g[Tb>>2]);Hb=ea(Mc*ea(g[Ub>>2]));Mc=ea(g[Tb+4>>2]);la=ea(Hb+ea(Mc*ea(g[Ub+4>>2])));Mc=ea(g[Tb+8>>2]);Hb=ea(la+ea(Mc*ea(g[Ub+8>>2])));Mc=ea(g[Tb+16>>2]);la=ea(Mc*ea(g[ec>>2]));Mc=ea(g[Tb+20>>2]);Tc=ea(la+ea(Mc*ea(g[Ub+20>>2])));Mc=ea(g[Tb+24>>2]);la=ea(Hb+ea(Tc+ea(Mc*ea(g[Ub+24>>2]))));Mc=ea(g[$c>>2]);Tc=ea(Mc*ea(g[Ec>>2]));Mc=ea(g[$c+4>>2]);Hb=ea(Tc+ea(Mc*ea(g[Ub+36>>2])));Mc=ea(g[$c+8>>2]);Tc=ea(Hb+ea(Mc*ea(g[Ub+40>>2])));Mc=ea(g[$c+16>>2]);Hb=ea(Mc*ea(g[Ic>>2]));Mc=ea(g[$c+20>>2]);fa=ea(Hb+ea(Mc*ea(g[Ub+52>>2])));Mc=ea(g[$c+24>>2]);cd=ea(la-ea(Tc+ea(fa+ea(Mc*ea(g[Ub+56>>2])))))}else cd=ea(0.0);Z$a(Zc,Yc,Xc,Wc,Ub,cd,Oc,Vc,Rc,f,h)}else{g[Zc>>2]=ea(0.0);g[Yc>>2]=ea(0.0);g[Xc>>2]=ea(0.0);g[Wc>>2]=ea(0.0)}Wc=t+152|0;Xc=t+168|0;Yc=t+184|0;Zc=t+200|0;Rc=ea(g[(c[H>>2]|0)+60>>2]);Vc=ea(g[j>>2]);Ub=c[V>>2]|0;$c=c[U>>2]|0;if(G>>>0<(c[B>>2]|0)>>>0){Ic=e[$b>>1]|0;if((Ic&4|0)!=0|(Ic&3|0)==3){Oc=ea(g[Ub>>2]);Mc=ea(Oc*ea(g[Vb>>2]));Oc=ea(g[Ub+4>>2]);fa=ea(Mc+ea(Oc*ea(g[Vb+4>>2])));Oc=ea(g[Ub+8>>2]);Mc=ea(fa+ea(Oc*ea(g[Vb+8>>2])));Oc=ea(g[Ub+16>>2]);fa=ea(Oc*ea(g[fc>>2]));Oc=ea(g[Ub+20>>2]);Tc=ea(fa+ea(Oc*ea(g[Vb+20>>2])));Oc=ea(g[Ub+24>>2]);fa=ea(Mc+ea(Tc+ea(Oc*ea(g[Vb+24>>2]))));Oc=ea(g[$c>>2]);Tc=ea(Oc*ea(g[Fc>>2]));Oc=ea(g[$c+4>>2]);Mc=ea(Tc+ea(Oc*ea(g[Vb+36>>2])));Oc=ea(g[$c+8>>2]);Tc=ea(Mc+ea(Oc*ea(g[Vb+40>>2])));Oc=ea(g[$c+16>>2]);Mc=ea(Oc*ea(g[Jc>>2]));Oc=ea(g[$c+20>>2]);la=ea(Mc+ea(Oc*ea(g[Vb+52>>2])));Oc=ea(g[$c+24>>2]);dd=ea(fa-ea(Tc+ea(la+ea(Oc*ea(g[Vb+56>>2])))))}else dd=ea(0.0);Z$a(Wc,Xc,Yc,Zc,Vb,dd,Pc,Rc,Vc,f,h)}else{g[Wc>>2]=ea(0.0);g[Xc>>2]=ea(0.0);g[Yc>>2]=ea(0.0);g[Zc>>2]=ea(0.0)}Zc=t+156|0;Yc=t+172|0;Xc=t+188|0;Wc=t+204|0;Vc=ea(g[(c[F>>2]|0)+60>>2]);Rc=ea(g[D>>2]);t=c[N>>2]|0;Vb=c[S>>2]|0;if(G>>>0<(c[C>>2]|0)>>>0){$c=e[bc>>1]|0;if(($c&4|0)!=0|($c&3|0)==3){Pc=ea(g[t>>2]);Oc=ea(Pc*ea(g[Wb>>2]));Pc=ea(g[t+4>>2]);la=ea(Oc+ea(Pc*ea(g[Wb+4>>2])));Pc=ea(g[t+8>>2]);Oc=ea(la+ea(Pc*ea(g[Wb+8>>2])));Pc=ea(g[t+16>>2]);la=ea(Pc*ea(g[ic>>2]));Pc=ea(g[t+20>>2]);Tc=ea(la+ea(Pc*ea(g[Wb+20>>2])));Pc=ea(g[t+24>>2]);la=ea(Oc+ea(Tc+ea(Pc*ea(g[Wb+24>>2]))));Pc=ea(g[Vb>>2]);Tc=ea(Pc*ea(g[Gc>>2]));Pc=ea(g[Vb+4>>2]);Oc=ea(Tc+ea(Pc*ea(g[Wb+36>>2])));Pc=ea(g[Vb+8>>2]);Tc=ea(Oc+ea(Pc*ea(g[Wb+40>>2])));Pc=ea(g[Vb+16>>2]);Oc=ea(Pc*ea(g[Kc>>2]));Pc=ea(g[Vb+20>>2]);fa=ea(Oc+ea(Pc*ea(g[Wb+52>>2])));Pc=ea(g[Vb+24>>2]);ed=ea(la-ea(Tc+ea(fa+ea(Pc*ea(g[Wb+56>>2])))))}else ed=ea(0.0);Z$a(Zc,Yc,Xc,Wc,Wb,ed,Qc,Vc,Rc,f,h)}else{g[Zc>>2]=ea(0.0);g[Yc>>2]=ea(0.0);g[Xc>>2]=ea(0.0);g[Wc>>2]=ea(0.0)}if(b[Xb>>1]&16)c[uc>>2]=c[uc>>2]|2;if(b[Zb>>1]&16)c[vc>>2]=c[vc>>2]|2;if(b[$b>>1]&16)c[wc>>2]=c[wc>>2]|2;if(b[bc>>1]&16)c[xc>>2]=c[xc>>2]|2;G=G+1|0}while(G>>>0<R>>>0);Sb=T+(n+128)|0}c[Sb>>2]=0;c[Sb+4>>2]=0;L=2;i=l;return L|0}else if((M|0)==56){i=l;return L|0}return 0}function ysa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+12>>2]=0;c[a+60>>2]=0;c[a+8>>2]=0;c[a+76>>2]=d;c[a+80>>2]=0;c[a+84>>2]=0;g[a+108>>2]=ea(0.0);g[a+100>>2]=ea(1.0);g[a+104>>2]=ea(1.0);c[a+56>>2]=0;c[a+52>>2]=0;return}function zsa(a){a=a|0;return}function Asa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;c[d>>2]=c[e+12>>2];c[d+4>>2]=c[e+16>>2];j=c[e+20>>2]|0;c[d+88>>2]=j;k=c[e+24>>2]|0;c[d+92>>2]=k;c[d+80>>2]=c[e+28>>2];c[d+84>>2]=c[e+32>>2];g[d+108>>2]=ea(g[e+48>>2]);g[d+100>>2]=ea(g[e+4>>2]);g[d+104>>2]=ea(g[e+8>>2]);a[d+112>>0]=c[j+36>>2];a[d+113>>0]=c[k+36>>2];c[d+96>>2]=f;c[d+116>>2]=c[e+72>>2];c[d+120>>2]=c[e+76>>2];f=d+114|0;b[f>>1]=0;k=d+36|0;j=d+40|0;l=d+16|0;c[l>>2]=0;m=d+32|0;b[m>>1]=0;n=d+20|0;c[n>>2]=0;o=d+44|0;p=d+48|0;b[k>>1]=0;c[d+64>>2]=0;b[d+72>>1]=0;c[d+68>>2]=0;q=d+60|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;r=c[q>>2]|0;do if(r)if(!(r&1)){s=r;a[s+33>>0]=0;a[s+32>>0]=0;g[s+16>>2]=ea(3402823469999999843913219.0e14);g[s+20>>2]=ea(3402823469999999843913219.0e14);g[s+24>>2]=ea(3402823469999999843913219.0e14);g[s+28>>2]=ea(0.0);g[s>>2]=ea(0.0);g[s+4>>2]=ea(0.0);g[s+8>>2]=ea(0.0);g[s+12>>2]=ea(1.0);t=b[f>>1]|0;break}else{c[q>>2]=1;t=0;break}else t=0;while(0);b[f>>1]=t&65531;t=c[e+60>>2]|0;q=(t&1|0)==0?0:8;if(!(t&2))u=q;else u=(q&65535|16)&65535;q=c[e+64>>2]|0;if(!(q&1))v=u;else v=(u&65535|32)&65535;if(!(q&2))w=v;else w=(v&65535|64)&65535;v=c[e+52>>2]|0;if((v|0)==0?(c[e+44>>2]|0)==0:0)x=(w&65535|2)&65535;else x=w;a[d+34>>0]=(v|0)!=0&1;a[d+35>>0]=(c[e+56>>2]|0)!=0&1;if((c[e+36>>2]|0)==0?(c[e+44>>2]|0)==0:0)y=x;else y=(x&65535|1)&65535;if(!(c[e+40>>2]|0))z=y;else z=(y&65535|256)&65535;y=c[e+44>>2]|0;if(!y)A=z;else A=(z&65535|128)&65535;b[d+38>>1]=A;c[d+8>>2]=(y|0)!=0&1;c[d+12>>2]=c[e>>2];b[f>>1]=0;b[k>>1]=0;c[j>>2]=0;c[l>>2]=0;b[m>>1]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;p=c[e+68>>2]|0;if((p|0)>0){b[f>>1]=2;i=h;return}if((p|0)>=0){i=h;return}b[f>>1]=1;i=h;return}function Bsa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]&-7;c[d>>2]=b?a|2:a;return}function Csa(d){d=d|0;var f=0,h=0,j=0,k=0;f=i;b[d+36>>1]=0;h=d+40|0;c[d+64>>2]=0;b[d+72>>1]=0;c[d+68>>2]=0;j=d+60|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;h=c[j>>2]|0;do if(h)if(!(h&1)){k=h;a[k+33>>0]=0;a[k+32>>0]=0;g[k+16>>2]=ea(3402823469999999843913219.0e14);g[k+20>>2]=ea(3402823469999999843913219.0e14);g[k+24>>2]=ea(3402823469999999843913219.0e14);g[k+28>>2]=ea(0.0);g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(1.0);break}else{c[j>>2]=1;break}while(0);j=d+114|0;b[j>>1]=(e[j>>1]|0)&65531;i=f;return}function Dsa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;swa(d);m=d+8|0;c[m>>2]=0;n=d+12|0;c[n>>2]=0;o=d+20|0;_$a(o);p=d+44|0;CAa(p,o);q=d+224|0;r=c[(ETa()|0)>>2]|0;if(r){s=mKa()|0;t=c[(c[s>>2]|0)+8>>2]|0;u=pKa()|0;v=mo[c[(c[u>>2]|0)+24>>2]&4095](u)|0;u=Bn[t&255](s,r,v?489384:544544,489304,93)|0;c[q>>2]=u;if(u)zTa(u)}else c[q>>2]=0;q=d+232|0;c[q>>2]=16;u=d+236|0;c[u>>2]=1024;c[d+240>>2]=0;c[d+248>>2]=0;c[d+252>>2]=0;v=mKa()|0;r=c[(c[v>>2]|0)+8>>2]|0;s=pKa()|0;t=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;s=Bn[r&255](v,4096,t?489056:544544,488400,63)|0;t=c[u>>2]|0;c[d+256>>2]=s;c[d+260>>2]=d;c[d+264>>2]=0;c[d+268>>2]=0;s=d+244|0;c[s>>2]=0;if(t>>>0>1){t=c[q>>2]|0;q=0;while(1)if((t|0)==(1<<q|0))break;else q=q+1|0;c[s>>2]=q}q=d+276|0;c[q>>2]=256;s=d+280|0;c[s>>2]=1024;c[d+284>>2]=0;c[d+292>>2]=0;c[d+296>>2]=0;t=mKa()|0;u=c[(c[t>>2]|0)+8>>2]|0;v=pKa()|0;r=mo[c[(c[v>>2]|0)+24>>2]&4095](v)|0;v=Bn[u&255](t,4096,r?488488:544544,488400,63)|0;r=c[s>>2]|0;c[d+300>>2]=v;c[d+304>>2]=d;c[d+308>>2]=0;c[d+312>>2]=0;v=d+288|0;c[v>>2]=0;if(r>>>0>1){r=c[q>>2]|0;q=0;while(1)if((r|0)==(1<<q|0))break;else q=q+1|0;c[v>>2]=q}q=d+320|0;v=c[(qTa()|0)>>2]|0;if(v){r=mKa()|0;s=c[(c[r>>2]|0)+8>>2]|0;t=pKa()|0;u=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;t=Bn[s&255](r,v,u?544576:544544,544464,111)|0;c[q>>2]=t;if(t)mTa(t)}else c[q>>2]=0;Jva(d+324|0,d);q=d+696|0;c[q>>2]=256;t=d+700|0;c[t>>2]=4096;c[d+704>>2]=0;c[d+712>>2]=0;c[d+716>>2]=0;u=mKa()|0;v=c[(c[u>>2]|0)+8>>2]|0;r=pKa()|0;s=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[v&255](u,16384,s?488928:544544,488400,63)|0;s=c[t>>2]|0;c[d+720>>2]=r;c[d+724>>2]=d;c[d+728>>2]=0;c[d+732>>2]=0;r=d+708|0;c[r>>2]=0;if(s>>>0>1){s=c[q>>2]|0;q=0;while(1)if((s|0)==(1<<q|0))break;else q=q+1|0;c[r>>2]=q}c[d+1008>>2]=0;a[d+1e3>>0]=1;c[d+1004>>2]=d+744;c[d+1012>>2]=64;c[d+1016>>2]=32;c[d+1020>>2]=0;c[d+1024>>2]=0;c[d+1028>>2]=7680;c[d+1032>>2]=0;c[d+1304>>2]=0;a[d+1296>>0]=1;c[d+1300>>2]=d+1040;c[d+1308>>2]=64;c[d+1312>>2]=32;c[d+1316>>2]=0;c[d+1320>>2]=0;c[d+1324>>2]=3072;c[d+1328>>2]=0;c[d+1332>>2]=0;c[d+1336>>2]=0;q=d+1344|0;c[q>>2]=0;r=d+1348|0;c[r>>2]=0;s=d+1440|0;t=d+1368|0;u=t+72|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));v=c[(qTa()|0)>>2]|0;if(v){w=mKa()|0;x=c[(c[w>>2]|0)+8>>2]|0;y=pKa()|0;z=mo[c[(c[y>>2]|0)+24>>2]&4095](y)|0;y=Bn[x&255](w,v,z?544576:544544,544464,111)|0;c[s>>2]=y;if(y)mTa(y)}else c[s>>2]=0;a[d+1444>>0]=0;rqa(d+1448|0);c[d+5844>>2]=0;c[d+5848>>2]=0;s=d+5928|0;t=d+5856|0;u=t+68|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[s>>2]=422368;t=d+5932|0;u=t+60|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));g[d+6164>>2]=ea(0.0);g[d+6168>>2]=ea(0.0);g[d+6172>>2]=ea(0.0);xua(d+6176|0,k,o,j);k=d+6672|0;b[d+6676>>1]=-1;b[d+6678>>1]=0;c[d+6680>>2]=0;c[k>>2]=443968;c[d+6684>>2]=0;c[d+6688>>2]=0;c[k>>2]=489568;c[d+6692>>2]=d;c[d+6696>>2]=488016;k=d+6700|0;b[d+6704>>1]=-1;b[d+6706>>1]=0;c[d+6708>>2]=0;c[k>>2]=443968;c[d+6712>>2]=0;c[d+6716>>2]=0;c[k>>2]=489520;c[d+6720>>2]=d;c[d+6724>>2]=488064;c[d+6728>>2]=f;c[d+6732>>2]=h;h=d+6736|0;c[h>>2]=j;PEi(d+6752|0,0,624)|0;f=b[e+100>>1]|0;a[d+7376>>0]=(f&65535)>>>9&1;a[d+7377>>0]=0;a[d+7378>>0]=(f&65535)>>>15;f=d+7404|0;k=d+7412|0;s=d+7416|0;y=d+7420|0;z=d+7400|0;t=d+7380|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));CZa(z,512);z=c[y>>2]|0;if((z&2147483136)>>>0<512){yUa(k,512);A=c[y>>2]|0}else A=z;c[s>>2]=512;PEi(c[k>>2]|0,0,A<<2|0)|0;c[f>>2]=512;PEi(c[q>>2]|0,0,c[r>>2]<<2|0)|0;c[d+1356>>2]=0;c[d+1360>>2]=0;c[d+1364>>2]=0;g[d+6140>>2]=ea(-8507058669999999534545717.0e13);g[d+6144>>2]=ea(-8507058669999999534545717.0e13);g[d+6148>>2]=ea(-8507058669999999534545717.0e13);g[d+6152>>2]=ea(8507058669999999534545717.0e13);g[d+6156>>2]=ea(8507058669999999534545717.0e13);g[d+6160>>2]=ea(8507058669999999534545717.0e13);r=mKa()|0;q=c[(c[r>>2]|0)+8>>2]|0;f=pKa()|0;A=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=Bn[q&255](r,51632,A?489184:544544,488112,139)|0;cpa(f,j,o);c[m>>2]=f;j=c[h>>2]|0;if((c[e+40>>2]|0)==1){h=mKa()|0;A=c[(c[h>>2]|0)+8>>2]|0;r=pKa()|0;q=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[A&255](h,124,q?489784:544544,488112,88)|0;Zqa(r,o,j,e,f);B=r;C=c[m>>2]|0;fpa(C,B);D=uta(d)|0;c[n>>2]=D;E=$ra(d)|0;F=d+16|0;c[F>>2]=E;G=d+5992|0;PEi(G|0,0,148)|0;H=e+136|0;I=c[H>>2]|0;J=e+140|0;K=c[J>>2]|0;DAa(p,I,K);i=l;return}else{B=wra(o,j)|0;C=c[m>>2]|0;fpa(C,B);D=uta(d)|0;c[n>>2]=D;E=$ra(d)|0;F=d+16|0;c[F>>2]=E;G=d+5992|0;PEi(G|0,0,148)|0;H=e+136|0;I=c[H>>2]|0;J=e+140|0;K=c[J>>2]|0;DAa(p,I,K);i=l;return}}function Esa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=c[a+8>>2]|0;if(e)gpa(e);e=c[a+12>>2]|0;if(e)vta(e);e=c[a+16>>2]|0;if(e)asa(e);e=a+696|0;$$a(e);f=c[a+7420>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[a+7412>>2]|0,(f|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}f=c[a+7408>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[a+7400>>2]|0,(f|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}f=c[a+7396>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[a+7388>>2]|0,(f|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}c[a+6700>>2]=443968;c[a+6708>>2]=0;c[a+6672>>2]=443968;c[a+6680>>2]=0;yua(a+6176|0);gWa(a+5928|0);f=c[a+5916>>2]|0;if((f|0)!=0?(c[a+5920>>2]|0)>-1:0)VJa(a+5924|0,f);f=c[a+5880>>2]|0;if(f)VJa(d,f);f=c[a+5876>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[a+5868>>2]|0,(f|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,f)}f=c[a+5864>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[a+5856>>2]|0,(f|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,f)}f=c[a+5844>>2]|0;if((f|0)!=0?(c[a+5848>>2]|0)>-1:0)VJa(a+5852|0,f);sqa(a+1448|0);f=a+1440|0;nTa(c[f>>2]|0);d=c[f>>2]|0;if(d){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1436>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+1428>>2]|0,(d|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1424>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+1416>>2]|0,(d|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1412>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+1404>>2]|0,(d|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1400>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+1392>>2]|0,(d|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1388>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+1380>>2]|0,(d|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1376>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+1368>>2]|0,(d|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+1344>>2]|0;do if(d){if((c[a+1348>>2]|0)<=-1)break;VJa(a+1352|0,d)}while(0);d=c[a+1332>>2]|0;do if(d){if((c[a+1336>>2]|0)<=-1)break;VJa(a+1340|0,d)}while(0);a0a(a+1036|0);b0a(a+740|0);$$a(e);e=c[a+728>>2]|0;do if(e){if((c[a+732>>2]|0)<=-1)break;VJa(a+736|0,e)}while(0);c0a(a+600|0);c0a(a+508|0);c0a(a+416|0);c0a(a+324|0);e=a+320|0;nTa(c[e>>2]|0);d=c[e>>2]|0;if(d){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d0a(a+276|0);d=c[a+308>>2]|0;do if(d){if((c[a+312>>2]|0)<=-1)break;VJa(a+316|0,d)}while(0);e0a(a+232|0);d=c[a+264>>2]|0;do if(d){if((c[a+268>>2]|0)<=-1)break;VJa(a+272|0,d)}while(0);f0a(a+224|0);JAa(a+44|0);d=c[a+32>>2]|0;do if((d&2147483647|0)!=0&(d|0)>-1){e=c[a+24>>2]|0;if(!e)break;f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}while(0);d=a+20|0;nTa(c[d>>2]|0);e=c[d>>2]|0;if(!e){twa(a);i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e);twa(a);i=b;return}function Fsa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=e+d|0;if((h|0)==(0-f|0)){j=a+6176|0;zua(j,b);i=g;return}k=(h<<1)+256&-256;h=k>>>5;l=a+5920|0;if(h>>>0>(c[l>>2]&2147483647)>>>0){m=a+5924|0;n=UJa(m,k>>>3,543784,339)|0;k=a+5916|0;o=c[k>>2]|0;if((o|0)!=0?(YEi(n|0,o|0,c[l>>2]<<2|0)|0,(c[l>>2]|0)>-1):0)VJa(m,c[k>>2]|0);m=c[l>>2]|0;PEi(n+((m&2147483647)<<2)|0,0,h-m<<2|0)|0;c[k>>2]=n;c[l>>2]=h}h=c[a+8>>2]|0;if(!h){j=a+6176|0;zua(j,b);i=g;return}dpa(h,d,e,f);j=a+6176|0;zua(j,b);i=g;return}function Gsa(a,b){a=a|0;b=ea(b);g[(c[a+12>>2]|0)+140>>2]=b;return}function Hsa(a){a=a|0;var b=Im;b=ea(g[(c[a+12>>2]|0)+140>>2]);return ea(b)}function Isa(a){a=a|0;var b=0,c=0;b=i;c=uwa(a)|0;i=b;return c|0}function Jsa(a,b){a=a|0;b=b|0;var c=0;c=i;vwa(a,b);i=c;return}function Ksa(){var b=0;a[488200]=248;a[488201]=0;a[488202]=0;a[488203]=0;b=488204|0;a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;a[488208]=192;a[488209]=6;a[488210]=0;a[488211]=0;b=488212|0;a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;return}function Lsa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;f=a+252|0;g=c[f>>2]|0;if(!g)if(g0a(a+232|0)|0){h=c[f>>2]|0;j=4}else k=0;else{h=g;j=4}if((j|0)==4){j=h+-1|0;c[f>>2]=j;f=c[(c[a+248>>2]|0)+(j<<2)>>2]|0;j=c[f+1140>>2]|0;h=(c[a+264>>2]|0)+(j>>>5<<2)|0;c[h>>2]=c[h>>2]|1<<(j&31);k=f}gwa(k,b,d);i=e;return k|0}function Msa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(d)f=jwa(b)|0;else f=0;iwa(b);d=c[b+1140>>2]|0;g=(c[a+264>>2]|0)+(d>>>5<<2)|0;c[g>>2]=c[g>>2]&~(1<<(d&31));d=a+252|0;g=c[d>>2]|0;c[d>>2]=g+1;c[(c[a+248>>2]|0)+(g<<2)>>2]=b;i=e;return f|0}function Nsa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;h=d[488200]|d[488201]<<8|d[488202]<<16|d[488203]<<24;j=488204|0;k=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;j=a+(k>>1)|0;if(!(k&1))l=h;else l=c[(c[j>>2]|0)+h>>2]|0;h=kn[l&511](j,b,e,f)|0;i=g;return h|0}function Osa(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=d[488208]|d[488209]<<8|d[488210]<<16|d[488211]<<24;h=488212|0;j=d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24;h=a+(j>>1)|0;if(!(j&1))k=g;else k=c[(c[h>>2]|0)+g>>2]|0;g=xo[k&2047](h,b,e)|0;i=f;return g|0}function Psa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;h=f;j=b+716|0;k=c[j>>2]|0;do if(!k)if(h0a(b+696|0)|0){l=c[j>>2]|0;break}else{m=0;i=f;return m|0}else l=k;while(0);k=l+-1|0;c[j>>2]=k;j=c[(c[b+712>>2]|0)+(k<<2)>>2]|0;k=j+76|0;l=c[k>>2]|0;n=(c[b+728>>2]|0)+(l>>>5<<2)|0;c[n>>2]=c[n>>2]|1<<(l&31);if(!j){m=0;i=f;return m|0}Asa(j,d,e);do if(a[b+7376>>0]|0){e=a[j+112>>0]|0;d=a[j+113>>0]|0;if(!(a[(d&255)+(488216+((e&255)*7|0))>>0]|0)){c[j+60>>2]=0;break}if(!((e&255)<5&(d&255)<5)){c[j+60>>2]=1;break}if(e<<24>>24==0|d<<24>>24==0){d=b+1328|0;e=c[d>>2]|0;if(!e){i0a(b+1036|0);o=c[d>>2]|0}else o=e;c[d>>2]=c[o>>2];d=b+1316|0;c[d>>2]=(c[d>>2]|0)+1;d=b+1320|0;c[d>>2]=(c[d>>2]|0)+-1;if(o){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;d=o+16|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];a[o+32>>0]=0;a[o+33>>0]=0;c[o+44>>2]=o+48;g[d>>2]=ea(3402823469999999843913219.0e14);g[o+20>>2]=ea(3402823469999999843913219.0e14);g[o+24>>2]=ea(3402823469999999843913219.0e14);g[o+28>>2]=ea(0.0);g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(1.0)}c[j+60>>2]=o;break}else{d=b+1032|0;e=c[d>>2]|0;if(!e){j0a(b+740|0);p=c[d>>2]|0}else p=e;c[d>>2]=c[p>>2];d=b+1020|0;c[d>>2]=(c[d>>2]|0)+1;d=b+1024|0;c[d>>2]=(c[d>>2]|0)+-1;if(p){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;d=p+16|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];a[p+32>>0]=0;a[p+33>>0]=0;c[p+44>>2]=p+48;g[d>>2]=ea(3402823469999999843913219.0e14);g[p+20>>2]=ea(3402823469999999843913219.0e14);g[p+24>>2]=ea(3402823469999999843913219.0e14);g[p+28>>2]=ea(0.0);g[p>>2]=ea(0.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[p+12>>2]=ea(1.0)}c[j+60>>2]=p;break}}while(0);p=b+5844|0;h=c[k>>2]|0;o=h+256&-256;d=o>>>5;e=b+5848|0;if(d>>>0>(c[e>>2]&2147483647)>>>0){l=b+5852|0;n=UJa(l,o>>>3,543784,339)|0;o=c[p>>2]|0;if((o|0)!=0?(YEi(n|0,o|0,c[e>>2]<<2|0)|0,(c[e>>2]|0)>-1):0)VJa(l,c[p>>2]|0);l=c[e>>2]|0;PEi(n+((l&2147483647)<<2)|0,0,d-l<<2|0)|0;c[p>>2]=n;c[e>>2]=d;q=c[k>>2]|0}else q=h;h=b+1332|0;d=q+256&-256;e=d>>>5;n=b+1336|0;if(e>>>0>(c[n>>2]&2147483647)>>>0){l=b+1340|0;b=UJa(l,d>>>3,543784,339)|0;d=c[h>>2]|0;if((d|0)!=0?(YEi(b|0,d|0,c[n>>2]<<2|0)|0,(c[n>>2]|0)>-1):0)VJa(l,c[h>>2]|0);l=c[n>>2]|0;PEi(b+((l&2147483647)<<2)|0,0,e-l<<2|0)|0;c[h>>2]=b;c[n>>2]=e;r=c[k>>2]|0;s=b}else{r=q;s=c[h>>2]|0}h=s+(r>>>5<<2)|0;c[h>>2]=c[h>>2]|1<<(r&31);if(!(c[j+8>>2]&1)){m=j;i=f;return m|0}r=c[k>>2]|0;k=(c[p>>2]|0)+(r>>>5<<2)|0;c[k>>2]=c[k>>2]|1<<(r&31);m=j;i=f;return m|0}function Qsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;f=d+60|0;g=c[f>>2]|0;if(g){do if(!(g&1)){if((a[d+112>>0]|0)!=0?(a[d+113>>0]|0)!=0:0){h=b+1020|0;c[h>>2]=(c[h>>2]|0)+-1;h=b+1032|0;c[g>>2]=c[h>>2];c[h>>2]=g;h=b+1024|0;j=c[h>>2]|0;c[h>>2]=j+1;if((j|0)<((c[b+1016>>2]|0)*50|0))break;l0a(b+740|0);c[b+1024>>2]=0;break}j=b+1316|0;c[j>>2]=(c[j>>2]|0)+-1;j=b+1328|0;c[g>>2]=c[j>>2];c[j>>2]=g;j=b+1320|0;h=c[j>>2]|0;c[j>>2]=h+1;if((h|0)>=((c[b+1312>>2]|0)*50|0)){k0a(b+1036|0);c[b+1320>>2]=0}}while(0);c[f>>2]=0}f=d+76|0;g=c[f>>2]|0;h=b+1332|0;j=(g+32|0)>>>5;k=b+1336|0;if(j>>>0>(c[k>>2]&2147483647)>>>0){l=b+1340|0;m=UJa(l,j<<2,543784,339)|0;n=c[h>>2]|0;if((n|0)!=0?(YEi(m|0,n|0,c[k>>2]<<2|0)|0,(c[k>>2]|0)>-1):0)VJa(l,c[h>>2]|0);l=c[k>>2]|0;PEi(m+((l&2147483647)<<2)|0,0,j-l<<2|0)|0;c[h>>2]=m;c[k>>2]=j;o=m}else o=c[h>>2]|0;h=~(1<<(g&31));m=g>>>5;g=o+(m<<2)|0;c[g>>2]=c[g>>2]&h;g=b+5844|0;o=b+5848|0;if(j>>>0>(c[o>>2]&2147483647)>>>0){k=b+5852|0;l=UJa(k,j<<2,543784,339)|0;n=c[g>>2]|0;if((n|0)!=0?(YEi(l|0,n|0,c[o>>2]<<2|0)|0,(c[o>>2]|0)>-1):0)VJa(k,c[g>>2]|0);k=c[o>>2]|0;PEi(l+((k&2147483647)<<2)|0,0,j-k<<2|0)|0;c[g>>2]=l;c[o>>2]=j;p=l}else p=c[g>>2]|0;g=p+(m<<2)|0;c[g>>2]=c[g>>2]&h;g=b+1344|0;p=b+1348|0;if(j>>>0<=(c[p>>2]&2147483647)>>>0){q=c[g>>2]|0;r=q+(m<<2)|0;s=c[r>>2]|0;t=s&h;c[r>>2]=t;u=c[f>>2]|0;v=u&31;w=1<<v;x=~w;y=u>>>5;z=b+728|0;A=c[z>>2]|0;B=A+(y<<2)|0;C=c[B>>2]|0;D=C&x;c[B>>2]=D;E=b+716|0;F=c[E>>2]|0;G=F+1|0;c[E>>2]=G;H=b+712|0;I=c[H>>2]|0;J=I+(F<<2)|0;c[J>>2]=d;i=e;return}l=b+1352|0;o=UJa(l,j<<2,543784,339)|0;k=c[g>>2]|0;if((k|0)!=0?(YEi(o|0,k|0,c[p>>2]<<2|0)|0,(c[p>>2]|0)>-1):0)VJa(l,c[g>>2]|0);l=c[p>>2]|0;PEi(o+((l&2147483647)<<2)|0,0,j-l<<2|0)|0;c[g>>2]=o;c[p>>2]=j;q=o;r=q+(m<<2)|0;s=c[r>>2]|0;t=s&h;c[r>>2]=t;u=c[f>>2]|0;v=u&31;w=1<<v;x=~w;y=u>>>5;z=b+728|0;A=c[z>>2]|0;B=A+(y<<2)|0;C=c[B>>2]|0;D=C&x;c[B>>2]=D;E=b+716|0;F=c[E>>2]|0;G=F+1|0;c[E>>2]=G;H=b+712|0;I=c[H>>2]|0;J=I+(F<<2)|0;c[J>>2]=d;i=e;return}function Rsa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=a+24|0;h=a+28|0;j=c[h>>2]|0;k=j+-1|0;c[h>>2]=k;c[a+36>>2]=b;c[a+40>>2]=d;l=b+d|0;c[f>>2]=l;if((c[a+32>>2]&2147483647)>>>0<=k>>>0){m0a(g,f)|0;i=e;return}f=(c[g>>2]|0)+(k<<2)|0;if(f)c[f>>2]=l;c[h>>2]=j;i=e;return}function Ssa(d,e){d=d|0;e=e|0;var f=0,h=Im,j=0,k=Im,l=0,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;h=ea(g[e>>2]);j=e+4|0;k=ea(g[j>>2]);l=e+8|0;m=ea(g[l>>2]);n=c[d+7408>>2]|0;if(n&2147483647){o=c[d+7412>>2]|0;p=d+7400|0;q=n&2147483647;n=0;do{if(c[o+(n<<2)>>2]|0){r=c[p>>2]|0;s=r+(n*28|0)+16|0;g[s>>2]=ea(ea(g[s>>2])-h);s=r+(n*28|0)+20|0;g[s>>2]=ea(ea(g[s>>2])-k);s=r+(n*28|0)+24|0;g[s>>2]=ea(ea(g[s>>2])-m)}n=n+1|0}while((n|0)!=(q|0))}a:do if((a[d+7377>>0]|0)!=0?(q=d+1332|0,n=d+1336|0,p=c[n>>2]&2147483647,(p|0)!=0):0){o=c[q>>2]|0;s=0;while(1){t=c[o+(s<<2)>>2]|0;if(t)break;r=s+1|0;if(r>>>0<p>>>0)s=r;else break a}r=c[425648+((da(t&0-t,125613361)|0)>>>27<<2)>>2]|s<<5;u=t+-1&t;b:do if(!u){v=s;while(1){w=v+1|0;if(w>>>0>=p>>>0){x=w;y=0;break b}z=c[o+(w<<2)>>2]|0;if(!z)v=w;else{x=w;y=z;break}}}else{x=s;y=u}while(0);if((r|0)!=-1){u=d+708|0;s=d+720|0;o=d+696|0;p=x;v=y;z=r;while(1){w=p<<5;A=v;B=z;while(1){C=c[(c[(c[s>>2]|0)+(B>>>(c[u>>2]|0)<<2)>>2]|0)+(((c[o>>2]|0)+-1&B)<<7)+68>>2]|0;if((C|0)!=0?(D=C+64|0,E=C+16|0,m=ea(g[e>>2]),g[E>>2]=ea(ea(g[E>>2])-m),m=ea(g[j>>2]),E=C+20|0,g[E>>2]=ea(ea(g[E>>2])-m),m=ea(g[l>>2]),E=C+24|0,g[E>>2]=ea(ea(g[E>>2])-m),E=C+44|0,m=ea(g[e>>2]),g[E>>2]=ea(ea(g[E>>2])-m),m=ea(g[j>>2]),E=C+48|0,g[E>>2]=ea(ea(g[E>>2])-m),m=ea(g[l>>2]),E=C+52|0,g[E>>2]=ea(ea(g[E>>2])-m),E=b[C+56>>1]|0,F=E&65535,G=(a[C+58>>0]|0)==0,E<<16>>16!=0):0){E=F+-1|0;if(!(a[C+59>>0]|0))if(G){C=D;E=0;while(1){H=C+12|0;m=ea(g[e>>2]);g[H>>2]=ea(ea(g[H>>2])-m);m=ea(g[j>>2]);H=C+16|0;g[H>>2]=ea(ea(g[H>>2])-m);m=ea(g[l>>2]);H=C+20|0;g[H>>2]=ea(ea(g[H>>2])-m);E=E+1|0;if((E|0)==(F|0))break;else C=C+28|0}}else{C=D;E=0;while(1){H=C+12|0;m=ea(g[e>>2]);g[H>>2]=ea(ea(g[H>>2])-m);m=ea(g[j>>2]);H=C+16|0;g[H>>2]=ea(ea(g[H>>2])-m);m=ea(g[l>>2]);H=C+20|0;g[H>>2]=ea(ea(g[H>>2])-m);E=E+1|0;if((E|0)==(F|0))break;else C=C+36|0}}else if(G){C=D;E=0;while(1){H=(E|0)==0?C+12|0:C;m=ea(g[e>>2]);g[H>>2]=ea(ea(g[H>>2])-m);m=ea(g[j>>2]);I=H+4|0;g[I>>2]=ea(ea(g[I>>2])-m);m=ea(g[l>>2]);I=H+8|0;g[I>>2]=ea(ea(g[I>>2])-m);E=E+1|0;if((E|0)==(F|0))break;else C=H+16|0}}else{C=D;E=0;while(1){G=(E|0)==0?C+12|0:C;m=ea(g[e>>2]);g[G>>2]=ea(ea(g[G>>2])-m);m=ea(g[j>>2]);H=G+4|0;g[H>>2]=ea(ea(g[H>>2])-m);m=ea(g[l>>2]);H=G+8|0;g[H>>2]=ea(ea(g[H>>2])-m);E=E+1|0;if((E|0)==(F|0))break;else C=G+24|0}}}if(!A)break a;B=c[425648+((da(A&0-A,125613361)|0)>>>27<<2)>>2]|w;A=A+-1&A;J=c[n>>2]&2147483647;if(!A){K=p;break}if((B|0)==-1)break a}while(1){K=K+1|0;if(K>>>0>=J>>>0){L=0;break}A=c[(c[q>>2]|0)+(K<<2)>>2]|0;if(A){L=A;break}}if((B|0)==-1)break;else{p=K;v=L;z=B}}}}while(0);L=d+6140|0;m=ea(g[L>>2]);K=m!=ea(-8507058669999999534545717.0e13);k=ea(g[d+6144>>2]);if((((!(K|k!=ea(-8507058669999999534545717.0e13))?!(ea(g[d+6148>>2])!=ea(-8507058669999999534545717.0e13)):0)?!(ea(g[d+6152>>2])!=ea(8507058669999999534545717.0e13)):0)?!(ea(g[d+6156>>2])!=ea(8507058669999999534545717.0e13)):0)?!(ea(g[d+6160>>2])!=ea(8507058669999999534545717.0e13)):0){i=f;return}g[L>>2]=ea(m-ea(g[e>>2]));g[d+6144>>2]=ea(k-ea(g[j>>2]));k=ea(g[l>>2]);L=d+6148|0;g[L>>2]=ea(ea(g[L>>2])-k);k=ea(g[e>>2]);e=d+6152|0;g[e>>2]=ea(ea(g[e>>2])-k);k=ea(g[j>>2]);j=d+6156|0;g[j>>2]=ea(ea(g[j>>2])-k);k=ea(g[l>>2]);l=d+6160|0;g[l>>2]=ea(ea(g[l>>2])-k);i=f;return}function Tsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Usa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+320|0;oTa(c[f>>2]|0);g=a+296|0;h=c[g>>2]|0;if(!h)if(n0a(a+276|0)|0){j=c[g>>2]|0;k=4}else l=0;else{j=h;k=4}if((k|0)==4){k=j+-1|0;c[g>>2]=k;g=c[(c[a+292>>2]|0)+(k<<2)>>2]|0;k=c[g+4>>2]|0;j=(c[a+308>>2]|0)+(k>>>5<<2)|0;c[j>>2]=c[j>>2]|1<<(k&31);if(!g)l=0;else{Hva(g,b,d);l=g}}pTa(c[f>>2]|0);i=e;return l|0}function Vsa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+320|0;oTa(c[e>>2]|0);f=c[b+4>>2]|0;g=(c[a+308>>2]|0)+(f>>>5<<2)|0;c[g>>2]=c[g>>2]&~(1<<(f&31));f=a+296|0;g=c[f>>2]|0;c[f>>2]=g+1;c[(c[a+292>>2]|0)+(g<<2)>>2]=b;pTa(c[e>>2]|0);i=d;return}function Wsa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+5916|0;if(!(c[f>>2]|0)){i=e;return}g=a+7380|0;c[g>>2]=0;h=c[b+8>>2]|0;j=mo[c[(c[h>>2]|0)+16>>2]&4095](h)|0;h=mo[c[(c[j>>2]|0)+4>>2]&4095](j)|0;xpa(c[a+8>>2]|0,h,0,0,b,c[f>>2]|0,c[a+5920>>2]&2147483647,d,g);i=e;return}function Xsa(d){d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;f=i;h=d+5912|0;if(!(c[h>>2]|0)){i=f;return}j=c[d+6736>>2]|0;k=c[j+8>>2]|0;l=j;j=c[l>>2]|0;m=c[l+4>>2]|0;l=e[268324]|e[268325]<<16;n=(k|0)==0|(l&16711680|0)==0;if(!n)Dn[c[(c[k>>2]|0)+8>>2]&511](k,l&65535,j,m);o=d+5844|0;p=d+5848|0;q=c[p>>2]|0;r=q&2147483647;a:do if(r){s=c[o>>2]|0;t=0;while(1){u=c[s+(t<<2)>>2]|0;if(u)break;v=t+1|0;if(v>>>0<r>>>0)t=v;else{w=0;break a}}v=c[425648+((da(u&0-u,125613361)|0)>>>27<<2)>>2]|t<<5;x=u+-1&u;b:do if(!x){y=t;while(1){z=y+1|0;if(z>>>0>=r>>>0){A=z;B=0;break b}C=c[s+(z<<2)>>2]|0;if(!C)y=z;else{A=z;B=C;break}}}else{A=t;B=x}while(0);if((v|0)!=-1){x=A;t=B;s=0;while(1){y=x<<5;C=t;z=s;while(1){D=z+1|0;if(!C){w=D;break a}E=c[425648+((da(C&0-C,125613361)|0)>>>27<<2)>>2]|y;C=C+-1&C;if(!C){F=x;break}if((E|0)==-1){w=D;break a}else z=D}while(1){F=F+1|0;if(F>>>0>=r>>>0){G=0;break}z=c[(c[o>>2]|0)+(F<<2)>>2]|0;if(z){G=z;break}}if((E|0)==-1){w=D;break}else{x=F;t=G;s=D}}}else w=0}else w=0;while(0);D=d+5856|0;G=d+5860|0;c[G>>2]=0;F=d+5864|0;if((c[F>>2]&2147483647)>>>0<w>>>0){o0a(D,w);H=c[p>>2]|0}else H=q;q=H&2147483647;c:do if(q){H=c[o>>2]|0;w=0;while(1){I=c[H+(w<<2)>>2]|0;if(I)break;E=w+1|0;if(E>>>0<q>>>0)w=E;else break c}E=c[425648+((da(I&0-I,125613361)|0)>>>27<<2)>>2]|w<<5;r=I+-1&I;d:do if(!r){B=w;while(1){A=B+1|0;if(A>>>0>=q>>>0){J=A;K=0;break d}u=c[H+(A<<2)>>2]|0;if(!u)B=A;else{J=A;K=u;break}}}else{J=w;K=r}while(0);if((E|0)!=-1){r=d+708|0;w=d+720|0;H=d+696|0;B=J;u=K;A=E;while(1){s=B<<5;t=u;x=A;while(1){v=c[(c[w>>2]|0)+(x>>>(c[r>>2]|0)<<2)>>2]|0;z=(c[H>>2]|0)+-1&x;C=b[v+(z<<7)+36>>1]|0;if(C<<16>>16){y=c[F>>2]|0;L=y&2147483647;M=c[G>>2]|0;if(L>>>0>M>>>0)N=M;else{o0a(D,(L|0)==0?1:y<<1);N=c[G>>2]|0}y=c[D>>2]|0;c[G>>2]=N+1;L=v+(z<<7)+88|0;c[y+(N*80|0)+8>>2]=efa(c[L>>2]|0)|0;M=v+(z<<7)+92|0;c[y+(N*80|0)+12>>2]=efa(c[M>>2]|0)|0;O=v+(z<<7)+38|0;P=v+(z<<7)+80|0;Q=c[P>>2]|0;if(!(b[O>>1]&32))R=dga(Q)|0;else R=k9(Q)|0;c[y+(N*80|0)>>2]=R;Q=v+(z<<7)+84|0;S=c[Q>>2]|0;if(!(b[O>>1]&64))T=dga(S)|0;else T=k9(S)|0;c[y+(N*80|0)+4>>2]=T;S=c[L>>2]|0;L=c[P>>2]|0;P=b[O>>1]|0;if(!(P&32)){U=ea(ea(g[S+16>>2])*ea(2.0));V=ea(ea(g[S+20>>2])*ea(2.0));W=ea(ea(g[S+24>>2])*ea(2.0));X=ea(g[L+12>>2]);Y=ea(ea(X*X)+ea(-.5));Z=ea(g[L>>2]);_=ea(U*Z);$=ea(g[L+4>>2]);aa=ea(_+ea(V*$));_=ea(g[L+8>>2]);ba=ea(aa+ea(W*_));aa=ea(ea(Z*ba)+ea(ea(U*Y)+ea(X*ea(ea(W*$)-ea(V*_)))));ca=ea(ea($*ba)+ea(ea(V*Y)+ea(X*ea(ea(U*_)-ea(W*Z)))));fa=ea(ea(ea(W*Y)+ea(X*ea(ea(V*Z)-ea(U*$))))+ea(_*ba));ba=ea(ea(g[L+16>>2])+aa);aa=ea(ea(g[L+20>>2])+ca);ca=ea(ea(g[L+24>>2])+fa);fa=ea(g[S>>2]);U=ea(X*fa);V=ea(g[S+12>>2]);Y=ea(U+ea(Z*V));U=ea(g[S+8>>2]);W=ea(Y+ea($*U));Y=ea(g[S+4>>2]);ga=ea(W-ea(_*Y));ha=ea(ea(ea(_*fa)+ea(ea($*V)+ea(X*Y)))-ea(Z*U));ia=ea(ea(ea(Z*Y)+ea(ea(_*V)+ea(X*U)))-ea($*fa));ja=ea(ea(ea(ea(X*V)-ea(Z*fa))-ea($*Y))-ea(_*U));ka=ba;la=aa;ma=ca;na=P}else{ca=ea(g[L+48>>2]);aa=ea(g[L+52>>2]);ba=ea(ca*ea(-2.0));ca=ea(aa*ea(-2.0));aa=ea(ea(g[L+56>>2])*ea(-2.0));U=ea(g[L+44>>2]);_=ea(ea(U*U)+ea(-.5));Y=ea(g[L+32>>2]);$=ea(ba*Y);fa=ea(g[L+36>>2]);Z=ea($+ea(ca*fa));$=ea(g[L+40>>2]);V=ea(Z+ea(aa*$));Z=ea(-Y);X=ea(-fa);W=ea(-$);oa=ea(ea(ea(Y*V)+ea(ea(ba*_)-ea(U*ea(ea(aa*fa)-ea(ca*$)))))*ea(2.0));pa=ea(ea(ea(fa*V)+ea(ea(ca*_)-ea(U*ea(ea(ba*$)-ea(aa*Y)))))*ea(2.0));qa=ea(ea(ea(ea(aa*_)-ea(U*ea(ea(ca*Y)-ea(ba*fa))))+ea($*V))*ea(2.0));V=ea(g[L+12>>2]);$=ea(ea(V*V)+ea(-.5));fa=ea(g[L>>2]);ba=ea(fa*oa);Y=ea(g[L+4>>2]);ca=ea(ba+ea(Y*pa));ba=ea(g[L+8>>2]);_=ea(ea(ba*qa)+ca);ca=ea(ea(fa*_)+ea(ea($*oa)+ea(V*ea(ea(Y*qa)-ea(ba*pa)))));aa=ea(ea(Y*_)+ea(ea($*pa)+ea(V*ea(ea(ba*oa)-ea(fa*qa)))));ra=ea(ea(ea($*qa)+ea(V*ea(ea(fa*pa)-ea(Y*oa))))+ea(ba*_));_=ea(ea(g[L+16>>2])+ca);ca=ea(ea(g[L+20>>2])+aa);aa=ea(ea(g[L+24>>2])+ra);ra=ea(ea(ea(ea(V*Z)+ea(U*fa))+ea(Y*W))-ea(ba*X));oa=ea(ea(ea(ba*Z)+ea(ea(V*X)+ea(U*Y)))-ea(fa*W));pa=ea(ea(ea(fa*X)+ea(ea(V*W)+ea(U*ba)))-ea(Y*Z));qa=ea(ea(ea(ea(U*V)-ea(fa*Z))-ea(Y*X))-ea(ba*W));W=ea(ea(g[S+16>>2])*ea(2.0));ba=ea(ea(g[S+20>>2])*ea(2.0));X=ea(ea(g[S+24>>2])*ea(2.0));Y=ea(ea(qa*qa)+ea(-.5));Z=ea(ea(ea(ra*W)+ea(oa*ba))+ea(pa*X));fa=ea(_+ea(ea(ra*Z)+ea(ea(Y*W)+ea(qa*ea(ea(oa*X)-ea(pa*ba))))));_=ea(ca+ea(ea(oa*Z)+ea(ea(Y*ba)+ea(qa*ea(ea(pa*W)-ea(ra*X))))));ca=ea(aa+ea(ea(ea(Y*X)+ea(qa*ea(ea(ra*ba)-ea(oa*W))))+ea(pa*Z)));Z=ea(g[S>>2]);W=ea(qa*Z);ba=ea(g[S+12>>2]);X=ea(W+ea(ra*ba));W=ea(g[S+8>>2]);Y=ea(X+ea(oa*W));X=ea(g[S+4>>2]);aa=ea(Y-ea(pa*X));Y=ea(ea(ea(pa*Z)+ea(ea(oa*ba)+ea(qa*X)))-ea(ra*W));V=ea(ea(ea(ra*X)+ea(ea(pa*ba)+ea(qa*W)))-ea(oa*Z));U=ea(ea(ea(ea(qa*ba)-ea(ra*Z))-ea(oa*X))-ea(pa*W));ga=aa;ha=Y;ia=V;ja=U;ka=fa;la=_;ma=ca;na=b[O>>1]|0}g[y+(N*80|0)+16>>2]=ga;g[y+(N*80|0)+20>>2]=ha;g[y+(N*80|0)+24>>2]=ia;g[y+(N*80|0)+28>>2]=ja;g[y+(N*80|0)+32>>2]=ka;g[y+(N*80|0)+36>>2]=la;g[y+(N*80|0)+40>>2]=ma;O=c[M>>2]|0;M=c[Q>>2]|0;if(!(na&64)){ca=ea(ea(g[O+16>>2])*ea(2.0));_=ea(ea(g[O+20>>2])*ea(2.0));fa=ea(ea(g[O+24>>2])*ea(2.0));U=ea(g[M+12>>2]);V=ea(ea(U*U)+ea(-.5));Y=ea(g[M>>2]);aa=ea(ca*Y);W=ea(g[M+4>>2]);pa=ea(aa+ea(_*W));aa=ea(g[M+8>>2]);X=ea(pa+ea(fa*aa));pa=ea(ea(Y*X)+ea(ea(ca*V)+ea(U*ea(ea(fa*W)-ea(_*aa)))));oa=ea(ea(W*X)+ea(ea(_*V)+ea(U*ea(ea(ca*aa)-ea(fa*Y)))));Z=ea(ea(ea(fa*V)+ea(U*ea(ea(_*Y)-ea(ca*W))))+ea(aa*X));X=ea(ea(g[M+16>>2])+pa);pa=ea(ea(g[M+20>>2])+oa);oa=ea(ea(g[M+24>>2])+Z);Z=ea(g[O>>2]);ca=ea(U*Z);_=ea(g[O+12>>2]);V=ea(ca+ea(Y*_));ca=ea(g[O+8>>2]);fa=ea(V+ea(W*ca));V=ea(g[O+4>>2]);sa=ea(fa-ea(aa*V));ta=ea(ea(ea(aa*Z)+ea(ea(W*_)+ea(U*V)))-ea(Y*ca));ua=ea(ea(ea(Y*V)+ea(ea(aa*_)+ea(U*ca)))-ea(W*Z));va=ea(ea(ea(ea(U*_)-ea(Y*Z))-ea(W*V))-ea(aa*ca));wa=X;xa=pa;ya=oa}else{oa=ea(g[M+48>>2]);pa=ea(g[M+52>>2]);X=ea(oa*ea(-2.0));oa=ea(pa*ea(-2.0));pa=ea(ea(g[M+56>>2])*ea(-2.0));ca=ea(g[M+44>>2]);aa=ea(ea(ca*ca)+ea(-.5));V=ea(g[M+32>>2]);W=ea(X*V);Z=ea(g[M+36>>2]);Y=ea(W+ea(oa*Z));W=ea(g[M+40>>2]);_=ea(Y+ea(pa*W));Y=ea(-V);U=ea(-Z);fa=ea(-W);ra=ea(ea(ea(V*_)+ea(ea(X*aa)-ea(ca*ea(ea(pa*Z)-ea(oa*W)))))*ea(2.0));ba=ea(ea(ea(Z*_)+ea(ea(oa*aa)-ea(ca*ea(ea(X*W)-ea(pa*V)))))*ea(2.0));qa=ea(ea(ea(ea(pa*aa)-ea(ca*ea(ea(oa*V)-ea(X*Z))))+ea(W*_))*ea(2.0));_=ea(g[M+12>>2]);W=ea(ea(_*_)+ea(-.5));Z=ea(g[M>>2]);X=ea(Z*ra);V=ea(g[M+4>>2]);oa=ea(X+ea(V*ba));X=ea(g[M+8>>2]);aa=ea(ea(X*qa)+oa);oa=ea(ea(Z*aa)+ea(ea(W*ra)+ea(_*ea(ea(V*qa)-ea(X*ba)))));pa=ea(ea(V*aa)+ea(ea(W*ba)+ea(_*ea(ea(X*ra)-ea(Z*qa)))));$=ea(ea(ea(W*qa)+ea(_*ea(ea(Z*ba)-ea(V*ra))))+ea(X*aa));aa=ea(ea(g[M+16>>2])+oa);oa=ea(ea(g[M+20>>2])+pa);pa=ea(ea(g[M+24>>2])+$);$=ea(ea(ea(ea(_*Y)+ea(ca*Z))+ea(V*fa))-ea(X*U));ra=ea(ea(ea(X*Y)+ea(ea(_*U)+ea(ca*V)))-ea(Z*fa));ba=ea(ea(ea(Z*U)+ea(ea(_*fa)+ea(ca*X)))-ea(V*Y));qa=ea(ea(ea(ea(ca*_)-ea(Z*Y))-ea(V*U))-ea(X*fa));fa=ea(ea(g[O+16>>2])*ea(2.0));X=ea(ea(g[O+20>>2])*ea(2.0));U=ea(ea(g[O+24>>2])*ea(2.0));V=ea(ea(qa*qa)+ea(-.5));Y=ea(ea(ea($*fa)+ea(ra*X))+ea(ba*U));Z=ea(aa+ea(ea($*Y)+ea(ea(V*fa)+ea(qa*ea(ea(ra*U)-ea(ba*X))))));aa=ea(oa+ea(ea(ra*Y)+ea(ea(V*X)+ea(qa*ea(ea(ba*fa)-ea($*U))))));oa=ea(pa+ea(ea(ea(V*U)+ea(qa*ea(ea($*X)-ea(ra*fa))))+ea(ba*Y)));Y=ea(g[O>>2]);fa=ea(qa*Y);X=ea(g[O+12>>2]);U=ea(fa+ea($*X));fa=ea(g[O+8>>2]);V=ea(U+ea(ra*fa));U=ea(g[O+4>>2]);sa=ea(V-ea(ba*U));ta=ea(ea(ea(ba*Y)+ea(ea(ra*X)+ea(qa*U)))-ea($*fa));ua=ea(ea(ea($*U)+ea(ea(ba*X)+ea(qa*fa)))-ea(ra*Y));va=ea(ea(ea(ea(qa*X)-ea($*Y))-ea(ra*U))-ea(ba*fa));wa=Z;xa=aa;ya=oa}g[y+(N*80|0)+44>>2]=sa;g[y+(N*80|0)+48>>2]=ta;g[y+(N*80|0)+52>>2]=ua;g[y+(N*80|0)+56>>2]=va;g[y+(N*80|0)+60>>2]=wa;g[y+(N*80|0)+64>>2]=xa;g[y+(N*80|0)+68>>2]=ya;O=(c[v+(z<<7)+44>>2]|0)+24|0;M=y+(N*80|0)+72|0;c[M>>2]=C&65535;c[M+4>>2]=O;O=a[v+(z<<7)+112>>0]|0;M=a[v+(z<<7)+113>>0]|0;z=(O&255)<(M&255);v=d+(((z?O:M)&255)*28|0)+(((z?M:O)&255)<<2)+7144|0;c[v>>2]=(c[v>>2]|0)+1}if(!t)break c;x=c[425648+((da(t&0-t,125613361)|0)>>>27<<2)>>2]|s;t=t+-1&t;za=c[p>>2]&2147483647;if(!t){Aa=B;break}if((x|0)==-1)break c}while(1){Aa=Aa+1|0;if(Aa>>>0>=za>>>0){Ba=0;break}t=c[(c[o>>2]|0)+(Aa<<2)>>2]|0;if(t){Ba=t;break}}if((x|0)==-1)break;else{B=Aa;u=Ba;A=x}}}}while(0);Ba=c[G>>2]|0;if(Ba){G=c[h>>2]|0;co[c[c[G>>2]>>2]&2047](G,c[D>>2]|0,Ba)}Ba=c[p>>2]&2147483647;e:do if(Ba){D=c[o>>2]|0;G=0;while(1){Ca=c[D+(G<<2)>>2]|0;if(Ca)break;h=G+1|0;if(h>>>0<Ba>>>0)G=h;else break e}h=c[425648+((da(Ca&0-Ca,125613361)|0)>>>27<<2)>>2]|G<<5;Aa=Ca+-1&Ca;f:do if(!Aa){za=G;while(1){N=za+1|0;if(N>>>0>=Ba>>>0){Da=N;Ea=0;break f}na=c[D+(N<<2)>>2]|0;if(!na)za=N;else{Da=N;Ea=na;break}}}else{Da=G;Ea=Aa}while(0);if((h|0)!=-1){Aa=d+708|0;G=d+720|0;D=d+696|0;za=Da;x=Ea;na=h;while(1){N=za<<5;T=x;R=na;while(1){F=c[(c[G>>2]|0)+(R>>>(c[Aa>>2]|0)<<2)>>2]|0;K=(c[D>>2]|0)+-1&R;J=F+(K<<7)+36|0;if(b[J>>1]|0){q=c[F+(K<<7)+44>>2]|0;I=c[F+(K<<7)+48>>2]|0;if(I){A=e[q+2>>1]|0;u=A&2;B=(u|0)!=0;H=q+(u<<3|4)|0;u=B?4:32;if(B){Fa=1;Ga=u;Ha=72;Ia=H}else{Fa=0;Ga=u;Ha=A<<3&8|16;Ia=H}}else{Fa=0;Ga=0;Ha=0;Ia=0}H=q;if((Ia-H|0)>>>0<I>>>0){if(Fa){q=0;A=Ia;while(1){u=b[A>>1]|0;B=u&65535;r=A;A=A+((da(B,Ha)|0)+Ga)|0;if(!(u<<16>>16))Ja=q;else{u=0;w=q;E=r+Ga|0;while(1){u=u+1|0;r=(ea(g[E+48>>2])!=ea(0.0)&1)+w|0;if((u|0)==(B|0)){Ja=r;break}else{w=r;E=E+Ha|0}}}if((A-H|0)>>>0>=I>>>0){Ka=Ja;break}else q=Ja}}else{q=0;A=Ia;while(1){E=e[A>>1]|0;A=A+((da(E,Ha)|0)+Ga)|0;w=q+E|0;if((A-H|0)>>>0>=I>>>0){Ka=w;break}else q=w}}if(!Ka)La=78}else La=78}else La=78;if((La|0)==78){La=0;b[J>>1]=0;q=F+(K<<7)+40|0;c[F+(K<<7)+64>>2]=0;b[F+(K<<7)+72>>1]=0;c[F+(K<<7)+68>>2]=0;I=F+(K<<7)+60|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;q=c[I>>2]|0;do if(q)if(!(q&1)){H=q;a[H+33>>0]=0;a[H+32>>0]=0;g[H+16>>2]=ea(3402823469999999843913219.0e14);g[H+20>>2]=ea(3402823469999999843913219.0e14);g[H+24>>2]=ea(3402823469999999843913219.0e14);g[H+28>>2]=ea(0.0);g[H>>2]=ea(0.0);g[H+4>>2]=ea(0.0);g[H+8>>2]=ea(0.0);g[H+12>>2]=ea(1.0);break}else{c[I>>2]=1;break}while(0);I=F+(K<<7)+114|0;b[I>>1]=e[I>>1]&65531}if(!T)break e;R=c[425648+((da(T&0-T,125613361)|0)>>>27<<2)>>2]|N;T=T+-1&T;Ma=c[p>>2]&2147483647;if(!T){Na=za;break}if((R|0)==-1)break e}while(1){Na=Na+1|0;if(Na>>>0>=Ma>>>0){Oa=0;break}T=c[(c[o>>2]|0)+(Na<<2)>>2]|0;if(T){Oa=T;break}}if((R|0)==-1)break;else{za=Na;x=Oa;na=R}}}}while(0);if(n){i=f;return}Dn[c[(c[k>>2]|0)+12>>2]&511](k,l&65535,j,m);i=f;return}function Ysa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=CTa(c[b+224>>2]|0)|0;if(!e){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,9459,j?490864:544544,490760,82)|0;if(h){j=h+19&-16;c[j+-4>>2]=j-h;h=j;if(!j)k=h;else{pya(h,b);k=h}}else k=0}else k=e;e=b+6748|0;c[e>>2]=k;h=b+1344|0;j=c[b+1336>>2]&134217727;f=b+1348|0;g=c[f>>2]|0;if(j>>>0>(g&2147483647)>>>0){l=b+1352|0;m=UJa(l,j<<2,543784,339)|0;n=c[h>>2]|0;if((n|0)!=0?(YEi(m|0,n|0,c[f>>2]<<2|0)|0,(c[f>>2]|0)>-1):0)VJa(l,c[h>>2]|0);l=c[f>>2]|0;PEi(m+((l&2147483647)<<2)|0,0,j-l<<2|0)|0;c[h>>2]=m;c[f>>2]=j;o=c[e>>2]|0;p=j}else{o=k;p=g}c[o+8776>>2]=c[b+7372>>2];g=b+7376|0;a[o+8784>>0]=a[g>>0]|0;a[o+8787>>0]=a[b+7378>>0]|0;a[o+8785>>0]=a[b+7377>>0]|0;k=b+44|0;j=c[b+1368>>2]|0;e=c[b+1372>>2]|0;if(!(a[g>>0]|0)){pAa(0,0,0,0,0,o,k,0,0,j,e,c[b+1380>>2]|0,c[b+1384>>2]|0,c[b+1392>>2]|0,c[b+1396>>2]|0,c[b+1404>>2]|0,c[b+1408>>2]|0,c[b+1416>>2]|0,c[b+1420>>2]|0,c[b+1428>>2]|0,c[b+1432>>2]|0,c[h>>2]|0,p&2147483647,b+6740|0,b+6744|0,b+6700|0,c[b+6732>>2]|0);q=b+6700|0;r=c[q>>2]|0;s=r+20|0;t=c[s>>2]|0;ko[t&4095](q);i=d;return}else{qAa(0,0,0,o,k,0,0,j,e,c[b+1392>>2]|0,c[b+1396>>2]|0,c[b+1404>>2]|0,c[b+1408>>2]|0,c[b+1428>>2]|0,c[b+1432>>2]|0,c[h>>2]|0,p&2147483647,b+6740|0,b+6744|0,b+6700|0,c[b+6732>>2]|0);q=b+6700|0;r=c[q>>2]|0;s=r+20|0;t=c[s>>2]|0;ko[t&4095](q);i=d;return}}function Zsa(a){a=a|0;var b=0;b=i;LAa(a+44|0);i=b;return}function _sa(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;d=a+224|0;BTa(c[d>>2]|0,c[a+6748>>2]|0);f=c[a+6736>>2]|0;g=c[f+8>>2]|0;h=f;f=c[h>>2]|0;j=c[h+4>>2]|0;h=e[268320]|e[268321]<<16;k=(g|0)==0|(h&16711680|0)==0;if(!k)Dn[c[(c[g>>2]|0)+8>>2]&511](g,h&65535,f,j);l=a+1356|0;c[l>>2]=(c[l>>2]|0)+(c[a+6740>>2]|0);m=a+1360|0;c[m>>2]=(c[m>>2]|0)+(c[a+6744>>2]|0);n=DTa(c[d>>2]|0)|0;o=a+7340|0;c[o>>2]=0;p=(n|0)==0;do if(!p){if(n){q=a+7360|0;r=a+7364|0;s=a+1344|0;t=n;do{u=t;t=c[t>>2]|0;c[l>>2]=(c[l>>2]|0)+(c[u+9396>>2]|0);c[m>>2]=(c[m>>2]|0)+(c[u+9392>>2]|0);v=0;do{w=a+(v*28|0)+6752|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+120>>2]|0);w=a+(v*28|0)+6756|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+124>>2]|0);w=a+(v*28|0)+6760|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+128>>2]|0);w=a+(v*28|0)+6764|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+132>>2]|0);w=a+(v*28|0)+6768|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+136>>2]|0);w=a+(v*28|0)+6772|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+140>>2]|0);w=a+(v*28|0)+6776|0;c[w>>2]=(c[w>>2]|0)+(c[u+(v*28|0)+144>>2]|0);w=c[o>>2]|0;x=v;do{w=w+(c[u+(v*28|0)+(x<<2)+120>>2]|0)|0;c[o>>2]=w;x=x+1|0}while((x|0)!=7);v=v+1|0}while((v|0)!=7);c[q>>2]=(c[q>>2]|0)+(c[u+8788>>2]|0);c[r>>2]=(c[r>>2]|0)+(c[u+8792>>2]|0);YAa(u+16|0);p0a(s,c[u+9380>>2]|0,c[u+9384>>2]&2147483647)}while((t|0)!=0);if(p)break;else y=n}else y=n;do{t=y;y=c[y>>2]|0;BTa(c[d>>2]|0,t)}while((y|0)!=0)}while(0);if(k){i=b;return}Dn[c[(c[g>>2]|0)+12>>2]&511](g,h&65535,f,j);i=b;return}function $sa(d,f,h){d=d|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=i;k=c[d+6736>>2]|0;l=c[k+8>>2]|0;m=k;k=c[m>>2]|0;n=c[m+4>>2]|0;m=e[268312]|e[268313]<<16;o=(l|0)==0|(m&16711680|0)==0;if(!o)Dn[c[(c[l>>2]|0)+8>>2]&511](l,m&65535,k,n);PEi(c[d+1344>>2]|0,0,c[d+1348>>2]<<2|0)|0;c[d+1356>>2]=0;c[d+1360>>2]=0;c[d+1364>>2]=0;c[d+6716>>2]=1;p=d+6712|0;c[p>>2]=h;if(h){ko[c[(c[h>>2]|0)+16>>2]&4095](h);c[d+6708>>2]=c[(c[p>>2]|0)+8>>2]}p=d+6672|0;h=d+6700|0;c[d+6688>>2]=1;q=d+6684|0;c[q>>2]=h;ko[c[(c[h>>2]|0)+16>>2]&4095](h);c[d+6680>>2]=c[(c[q>>2]|0)+8>>2];c[d+1372>>2]=0;c[d+1384>>2]=0;c[d+1396>>2]=0;c[d+1408>>2]=0;c[d+1420>>2]=0;c[d+1432>>2]=0;q=d+1332|0;h=d+1336|0;r=c[h>>2]&2147483647;a:do if(r){s=c[q>>2]|0;t=0;while(1){u=c[s+(t<<2)>>2]|0;if(u)break;v=t+1|0;if(v>>>0<r>>>0)t=v;else{w=-1;x=v;y=0;break a}}v=c[425648+((da(u&0-u,125613361)|0)>>>27<<2)>>2]|t<<5;z=u+-1&u;if(!z){A=t;while(1){B=A+1|0;if(B>>>0>=r>>>0){w=v;x=B;y=0;break a}C=c[s+(B<<2)>>2]|0;if(!C)A=B;else{w=v;x=B;y=C;break}}}else{w=v;x=t;y=z}}else{w=-1;x=0;y=0}while(0);r=d+6732|0;oTa(c[c[r>>2]>>2]|0);u=c[r>>2]|0;if((w|0)==-1)D=u;else{A=d+708|0;s=d+720|0;C=d+696|0;B=y;y=x;x=u;u=w;while(1){w=vXa(x,160,16)|0;if(!w)E=0;else{b[w+4>>1]=-1;b[w+6>>1]=0;c[w+8>>2]=0;c[w>>2]=443968;c[w+12>>2]=0;c[w+16>>2]=0;c[w+148>>2]=0;g[w+152>>2]=f;c[w+156>>2]=d;F=w+20|0;G=F+128|0;do{a[F>>0]=0;F=F+1|0}while((F|0)<(G|0));c[w>>2]=489616;E=w}if((u|0)!=-1){F=E+148|0;G=B;z=y;t=0;v=u;while(1){H=(c[(c[s>>2]|0)+(v>>>(c[A>>2]|0)<<2)>>2]|0)+(((c[C>>2]|0)+-1&v)<<7)|0;I=c[F>>2]|0;c[F>>2]=I+1;c[E+(I<<2)+20>>2]=H;t=t+1|0;if(!G){J=-1;K=0;L=z;break}H=c[425648+((da(G&0-G,125613361)|0)>>>27<<2)>>2]|z<<5;I=G+-1&G;M=c[h>>2]&2147483647;b:do if(!I){N=z;while(1){O=N+1|0;if(O>>>0>=M>>>0){P=O;Q=0;break b}R=c[(c[q>>2]|0)+(O<<2)>>2]|0;if(!R)N=O;else{P=O;Q=R;break}}}else{P=z;Q=I}while(0);if(t>>>0>31|(H|0)==-1){J=H;K=Q;L=P;break}else{G=Q;z=P;v=H}}if(!t){S=L;T=K;U=J;V=25}else{c[E+16>>2]=1;v=E+12|0;c[v>>2]=p;ko[c[(c[p>>2]|0)+16>>2]&4095](p);c[E+8>>2]=c[(c[v>>2]|0)+8>>2];ko[c[(c[E>>2]|0)+20>>2]&4095](E);W=L;X=K;Y=J}}else{S=y;T=B;U=-1;V=25}if((V|0)==25){V=0;ko[c[(c[E>>2]|0)+28>>2]&4095](E);W=S;X=T;Y=U}v=c[r>>2]|0;if((Y|0)==-1){D=v;break}else{B=X;y=W;x=v;u=Y}}}pTa(c[D>>2]|0);ko[c[(c[p>>2]|0)+20>>2]&4095](p);if(o){i=j;return}Dn[c[(c[l>>2]|0)+12>>2]&511](l,m&65535,k,n);i=j;return}function ata(d,f,h,j,k){d=d|0;f=ea(f);h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;l=i;m=c[d+6736>>2]|0;n=c[m+8>>2]|0;o=m;m=c[o>>2]|0;p=c[o+4>>2]|0;o=e[268312]|e[268313]<<16;q=(n|0)==0|(o&16711680|0)==0;if(!q)Dn[c[(c[n>>2]|0)+8>>2]&511](n,o&65535,m,p);r=d+1348|0;PEi(c[d+1344>>2]|0,0,c[r>>2]<<2|0)|0;c[d+1356>>2]=0;c[d+1360>>2]=0;c[d+1364>>2]=0;s=d+224|0;t=DTa(c[s>>2]|0)|0;if(t){u=d+5920|0;v=t;do{w=v;v=c[v>>2]|0;rya(w,c[u>>2]<<5,c[r>>2]<<5)}while((v|0)!=0);x=t;do{t=x;x=c[x>>2]|0;BTa(c[s>>2]|0,t)}while((x|0)!=0)}c[d+6716>>2]=1;x=d+6712|0;c[x>>2]=k;if(k){ko[c[(c[k>>2]|0)+16>>2]&4095](k);c[d+6708>>2]=c[(c[x>>2]|0)+8>>2]}x=d+6672|0;k=d+6700|0;c[d+6688>>2]=1;s=d+6684|0;c[s>>2]=k;ko[c[(c[k>>2]|0)+16>>2]&4095](k);c[d+6680>>2]=c[(c[s>>2]|0)+8>>2];c[d+1372>>2]=0;c[d+1384>>2]=0;c[d+1396>>2]=0;c[d+1408>>2]=0;c[d+1420>>2]=0;c[d+1432>>2]=0;if(j){s=d+6732|0;k=~j;t=0;while(1){v=c[s>>2]|0;oTa(c[v>>2]|0);r=vXa(v,160,16)|0;pTa(c[v>>2]|0);if(!r)y=0;else{b[r+4>>1]=-1;b[r+6>>1]=0;c[r+8>>2]=0;c[r>>2]=443968;c[r+12>>2]=0;c[r+16>>2]=0;c[r+148>>2]=0;g[r+152>>2]=f;c[r+156>>2]=d;v=r+20|0;u=v+128|0;do{a[v>>0]=0;v=v+1|0}while((v|0)<(u|0));c[r>>2]=489616;y=r}v=j-t|0;u=v>>>0>32?32:v;if(u){v=y+148|0;w=t+k|0;z=w>>>0>4294967263?~w:32;w=0;A=0;while(1){B=c[h+(A+t<<3)>>2]|0;if(!B)C=w;else{D=c[v>>2]|0;c[v>>2]=D+1;c[y+(D<<2)+20>>2]=B;C=w+1|0}A=A+1|0;if((A|0)==(z|0))break;else w=C}w=u+t|0;if(!C){E=w;F=21}else{c[y+16>>2]=1;z=y+12|0;c[z>>2]=x;ko[c[(c[x>>2]|0)+16>>2]&4095](x);c[y+8>>2]=c[(c[z>>2]|0)+8>>2];ko[c[(c[y>>2]|0)+20>>2]&4095](y);G=w}}else{E=u+t|0;F=21}if((F|0)==21){F=0;ko[c[(c[y>>2]|0)+28>>2]&4095](y);G=E}if(G>>>0<j>>>0)t=G;else break}}ko[c[(c[x>>2]|0)+20>>2]&4095](x);if(q){i=l;return}Dn[c[(c[n>>2]|0)+12>>2]&511](n,o&65535,m,p);i=l;return}function bta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+224|0;e=DTa(c[d>>2]|0)|0;f=(e|0)==0;if(f){i=b;return}if(e){g=a+5920|0;h=a+1348|0;a=e;do{j=a;a=c[a>>2]|0;rya(j,c[g>>2]<<5,c[h>>2]<<5)}while((a|0)!=0);if(f){i=b;return}else k=e}else k=e;do{e=k;k=c[k>>2]|0;BTa(c[d>>2]|0,e)}while((k|0)!=0);i=b;return}function cta(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;if(b)c[b>>2]=c[a+1360>>2];if(d)c[d>>2]=c[a+1356>>2];if(!e){i=f;return 1}c[e>>2]=c[a+1364>>2];i=f;return 1}function dta(a,d,f,g,h,j,k){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;l=i;m=a+1344|0;n=c[a+1348>>2]&2147483647;a:do if(!n){o=d;p=g;q=j}else{r=c[m>>2]|0;s=0;while(1){t=c[r+(s<<2)>>2]|0;if(t)break;u=s+1|0;if(u>>>0<n>>>0)s=u;else{o=d;p=g;q=j;break a}}r=a+708|0;u=a+720|0;v=a+696|0;w=d;x=g;y=j;z=s;A=t;while(1){B=w;C=x;D=z;E=A;b:while(1){F=B;G=D;H=E;while(1){I=c[425648+((da(H&0-H,125613361)|0)>>>27<<2)>>2]|G<<5;J=H+-1&H;c:do if(!J){K=G;while(1){L=K+1|0;if(L>>>0>=n>>>0){M=0;N=L;break c}O=c[(c[m>>2]|0)+(L<<2)>>2]|0;if(!O)K=L;else{M=O;N=L;break}}}else{M=J;N=G}while(0);if((I|0)==-1){o=F;p=C;q=y;break a}P=c[(c[u>>2]|0)+(I>>>(c[r>>2]|0)<<2)>>2]|0;Q=(c[v>>2]|0)+-1&I;R=P+(Q<<7)|0;S=P+(Q<<7)+114|0;T=e[S>>1]|0;if(!(T&2))break;if(T&8)break b;c[F>>2]=R;c[F+4>>2]=c[P+(Q<<7)+12>>2];J=F+8|0;if(!M){o=J;p=C;q=y;break a}else{F=J;G=N;H=M}}c[C>>2]=R;c[C+4>>2]=c[P+(Q<<7)+12>>2];H=C+8|0;if(!M){o=F;p=H;q=y;break a}else{B=F;C=H;D=N;E=M}}c[y>>2]=R;c[y+4>>2]=c[P+(Q<<7)+12>>2];b[S>>1]=T&65527;E=y+8|0;if(!M){o=F;p=C;q=E;break}else{w=F;x=C;y=E;z=N;A=M}}}while(0);c[f>>2]=o-d>>3;c[h>>2]=p-g>>3;c[k>>2]=q-j>>3;i=l;return 1}function eta(a,b,c){a=a|0;b=ea(b);c=c|0;var d=0;d=i;Vua(a+6176|0,c,0);i=d;return}function fta(a,b,d,e){a=a|0;b=ea(b);d=d|0;e=e|0;e=i;OAa(a+44|0);yta(c[a+12>>2]|0,b,d);i=e;return}function gta(a){a=a|0;var b=0;b=i;PEi(a+6752|0,0,620)|0;i=b;return}function hta(a,b){a=a|0;b=b|0;var d=0;d=a+7344|0;c[d>>2]=(c[d>>2]|0)+(c[b>>2]|0);d=a+7348|0;c[d>>2]=(c[d>>2]|0)+(c[b+4>>2]|0);d=a+7352|0;c[d>>2]=(c[d>>2]|0)+(c[b+8>>2]|0);d=a+7356|0;c[d>>2]=(c[d>>2]|0)+(c[b+12>>2]|0);return}function ita(a){a=a|0;return c[(c[a+12>>2]|0)+148>>2]|0}function jta(a,b){a=a|0;b=b|0;c[(c[a+12>>2]|0)+148>>2]=b;return}function kta(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+(b<<2)+5992>>2]);return ea(c)}function lta(a,b,c){a=a|0;b=b|0;c=ea(c);g[a+(b<<2)+5992>>2]=c;return}function mta(a){a=a|0;return c[(c[a+16>>2]|0)+84>>2]|0}function nta(a,b){a=a|0;b=b|0;c[(c[a+16>>2]|0)+84>>2]=b;return}function ota(a){a=a|0;return c[(c[a+16>>2]|0)+260>>2]|0}function pta(a,b){a=a|0;b=b|0;c[(c[a+16>>2]|0)+260>>2]=b;return}function qta(a){a=a|0;return c[(c[a+16>>2]|0)+92>>2]|0}function rta(a){a=a|0;return c[(c[a+16>>2]|0)+96>>2]|0}function sta(a){a=a|0;var b=0;b=i;isa(c[a+16>>2]|0);i=b;return}function tta(a,b,d,e){a=a|0;b=ea(b);d=d|0;e=e|0;var f=0;f=i;ksa(c[a+16>>2]|0,b,d,e);i=f;return}function uta(a){a=a|0;var d=0,e=0,f=0,h=0;d=i;i=i+16|0;e=UJa(d,156,489904,135)|0;if(!e){i=d;return e|0}c[e+96>>2]=a;a=e+100|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;g[e+124>>2]=ea(1.0);g[e+128>>2]=ea(1.0);g[e+140>>2]=ea(-2.0);c[e+148>>2]=32;c[e+76>>2]=e;g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);g[e+16>>2]=ea(0.0);g[e+20>>2]=ea(0.0);g[e+24>>2]=ea(0.0);g[e+80>>2]=ea(0.0);c[e+72>>2]=0;a=e+68|0;f=e+32|0;h=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));g[a>>2]=ea(3402823469999999843913219.0e14);g[e+84>>2]=ea(-3402823469999999843913219.0e14);c[e+28>>2]=65535;b[e+12>>1]=-1;b[e+14>>1]=-1;c[e+136>>2]=Iwa()|0;i=d;return e|0}function vta(a){a=a|0;var b=0;b=i;i=i+16|0;wta(a);VJa(b,a);i=b;return}function wta(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+136>>2]|0;ko[c[c[d>>2]>>2]&4095](d);d=c[a+120>>2]|0;if(((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+112>>2]|0,(d|0)!=0):0)?(e=d+(0-(c[d+-4>>2]|0))|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+108>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=b;return}e=c[a+100>>2]|0;if(!e){i=b;return}a=e+(0-(c[e+-4>>2]|0))|0;if(!a){i=b;return}e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=b;return}function xta(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;c[h>>2]=c[d+152>>2];c[h+4>>2]=0;j=f+8|0;if((a[j>>0]|0)==2){k=c[f>>2]|0;l=k&-64;c[e>>2]=c[c[l>>2]>>2];b[e+10>>1]=b[(c[l>>2]|0)+34>>1]|0;b[e+8>>1]=k&63}else{b[e+8>>1]=-1;k=a[j>>0]|0;if(k<<24>>24==3)m=d;else m=(c[d+100>>2]|0)+((c[h+((k&255)<<2)>>2]|0)+(c[f>>2]|0)<<5)|0;c[e>>2]=m;m=a[j>>0]|0;if(m<<24>>24==3)n=0;else n=(c[f>>2]|0)+1+(c[h+((m&255)<<2)>>2]|0)&65535;b[e+10>>1]=n}n=f+9|0;if((a[n>>0]|0)==2){m=c[f+4>>2]|0;j=m&-64;c[e+4>>2]=c[c[j>>2]>>2];b[e+14>>1]=b[(c[j>>2]|0)+34>>1]|0;b[e+12>>1]=m&63;i=g;return}b[e+12>>1]=-1;m=a[n>>0]|0;if(m<<24>>24==3)o=d;else o=(c[d+100>>2]|0)+((c[h+((m&255)<<2)>>2]|0)+(c[f+4>>2]|0)<<5)|0;c[e+4>>2]=o;o=a[n>>0]|0;if(o<<24>>24==3)p=0;else p=(c[f+4>>2]|0)+1+(c[h+((o&255)<<2)>>2]|0)&65535;b[e+14>>1]=p;i=g;return}function yta(a,d,e){a=a|0;d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+96|0;h=f+64|0;j=f;k=a+96|0;l=c[(c[k>>2]|0)+6736>>2]|0;m=c[l+8>>2]|0;n=l;l=c[n>>2]|0;o=c[n+4>>2]|0;Dn[c[(c[m>>2]|0)+8>>2]&511](m,82,l,o);g[a+124>>2]=d;if(d==ea(0.0))p=ea(0.0);else p=ea(ea(1.0)/d);g[a+128>>2]=p;n=c[k>>2]|0;q=c[n+6564>>2]|0;if(!q){r=c[m>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](m,82,l,o);i=f;return}u=c[n+6500>>2]|0;c[a+152>>2]=u;v=c[n+6496>>2]|0;w=c[n+6560>>2]|0;x=w+(q<<4)|0;if(w){y=c[x>>2]|0;z=y+u|0;A=a+100|0;B=c[a+108>>2]&2147483647;if(z>>>0>B>>>0){C=z+31&-32;if(B>>>0<C>>>0){q0a(A,C);D=c[x>>2]|0}else D=y;C=u+32+D&-32;if((c[a+120>>2]&2147483647)>>>0<C>>>0){r0a(a+112|0,C);E=c[x>>2]|0}else E=D}else E=y;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;s0a(A,E+u|0,h);h=j+0|0;E=h+64|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(E|0));h=a+112|0;t0a(h,u+1+(c[x>>2]|0)|0,j);j=c[h>>2]|0;g[j>>2]=ea(g[a+32>>2]);g[j+4>>2]=ea(g[a+36>>2]);g[j+8>>2]=ea(g[a+40>>2]);g[j+12>>2]=ea(g[a+44>>2]);g[j+16>>2]=ea(g[a+48>>2]);g[j+20>>2]=ea(g[a+52>>2]);g[j+24>>2]=ea(g[a+56>>2]);g[j+28>>2]=ea(g[a+60>>2]);g[j+32>>2]=ea(g[a+64>>2]);E=j+36|0;j=a+68|0;c[E+0>>2]=c[j+0>>2];c[E+4>>2]=c[j+4>>2];c[E+8>>2]=c[j+8>>2];c[E+12>>2]=c[j+12>>2];c[E+16>>2]=c[j+16>>2];c[E+20>>2]=c[j+20>>2];c[E+24>>2]=c[j+24>>2];j=c[(c[k>>2]|0)+6736>>2]|0;E=c[j+8>>2]|0;y=j;j=c[y>>2]|0;D=c[y+4>>2]|0;Dn[c[(c[E>>2]|0)+8>>2]&511](E,92,j,D);if(u){y=c[A>>2]|0;C=0;do{B=c[v+(C<<2)>>2]|0;z=C;C=C+1|0;pwa(y+(z<<5)|0,(c[h>>2]|0)+(C<<6)|0,c[B+64>>2]|0,B);y=c[A>>2]|0;c[y+(z<<5)+28>>2]=65535;b[y+(z<<5)+12>>1]=-1;b[y+(z<<5)+14>>1]=-1}while((C|0)!=(u|0))}Dn[c[(c[E>>2]|0)+12>>2]&511](E,92,j,D)}D=c[a+148>>2]|0;if((q|0)<=0){r=c[m>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](m,82,l,o);i=f;return}q=n+6580|0;j=n+6576|0;E=n+6592|0;C=n+6588|0;n=(e|0)==0;y=w;while(1){w=c[y+4>>2]|0;A=w&2147483647;h=(c[q>>2]|0)+(A<<2)|0;v=c[y>>2]|0;z=(c[j>>2]|0)+(v<<2)|0;B=c[y+12>>2]|0;F=(c[E>>2]|0)+(B<<4)|0;G=c[y+8>>2]|0;H=(c[C>>2]|0)+(G<<4)|0;I=y+16|0;a:do if(I>>>0<x>>>0){J=0;K=I;L=y;while(1){if(!((J|0)==0?1:((c[K>>2]|0)-v|0)>>>0<D>>>0)){M=K;N=L;break a}if(((c[L+20>>2]&2147483647)-A|0)>>>0>=2){M=K;N=L;break a}O=K+16|0;if(O>>>0<x>>>0){P=K;J=(c[L+36>>2]&2147483647)-A+(c[L+44>>2]|0)-B+(c[L+40>>2]|0)-G|0;K=O;L=P}else{M=O;N=K;break}}}else{M=I;N=y}while(0);I=(c[N+20>>2]|0)-w&2147483647;A=(c[M>>2]|0)-v|0;K=(c[N+28>>2]|0)-B|0;L=(c[N+24>>2]|0)-G|0;if((I|0)!=(0-A|0)){J=v+u|0;O=c[k>>2]|0;P=c[O+6732>>2]|0;oTa(c[P>>2]|0);Q=CTa(c[O+224>>2]|0)|0;if(!Q){R=mKa()|0;S=c[(c[R>>2]|0)+8>>2]|0;T=pKa()|0;U=mo[c[(c[T>>2]|0)+24>>2]&4095](T)|0;T=Bn[S&255](R,9459,U?490864:544544,490760,82)|0;if(T){U=T+19&-16;c[U+-4>>2]=U-T;T=U;if(!U)V=T;else{pya(T,O);V=T}}else V=0}else V=Q;Q=vXa(P,68,16)|0;if(!Q)W=0;else{b[Q+4>>1]=-1;b[Q+6>>1]=0;c[Q+8>>2]=0;c[Q>>2]=443968;c[Q+12>>2]=0;c[Q+16>>2]=0;c[Q>>2]=491296;c[Q+20>>2]=a;c[Q+24>>2]=V;c[Q+28>>2]=z;c[Q+32>>2]=h;c[Q+36>>2]=0;c[Q+40>>2]=H;c[Q+44>>2]=F;c[Q+48>>2]=A;c[Q+52>>2]=I;c[Q+56>>2]=L;c[Q+60>>2]=K;c[Q+64>>2]=J;W=Q}Q=vXa(P,68,16)|0;if(!Q)X=0;else{b[Q+4>>1]=-1;b[Q+6>>1]=0;c[Q+8>>2]=0;c[Q>>2]=443968;c[Q+12>>2]=0;c[Q+16>>2]=0;c[Q>>2]=491224;c[Q+20>>2]=a;c[Q+24>>2]=V;c[Q+28>>2]=z;c[Q+32>>2]=h;c[Q+36>>2]=0;c[Q+40>>2]=H;c[Q+44>>2]=F;c[Q+48>>2]=A;c[Q+52>>2]=I;c[Q+56>>2]=L;c[Q+60>>2]=K;c[Q+64>>2]=J;X=Q}c[V+8776>>2]=c[O+7372>>2];O=vXa(P,48,16)|0;if(!O)Y=0;else{b[O+4>>1]=-1;b[O+6>>1]=0;c[O+8>>2]=0;c[O>>2]=443968;c[O+12>>2]=0;c[O+16>>2]=0;c[O>>2]=490064;c[O+20>>2]=a;c[O+24>>2]=V;c[O+28>>2]=J;c[O+32>>2]=A;c[O+36>>2]=I;c[O+40>>2]=L;c[O+44>>2]=K;Y=O}O=vXa(P,68,16)|0;if(!O)Z=0;else{b[O+4>>1]=-1;b[O+6>>1]=0;c[O+8>>2]=0;c[O>>2]=443968;c[O+12>>2]=0;c[O+16>>2]=0;c[O>>2]=491080;c[O+20>>2]=a;c[O+24>>2]=V;c[O+28>>2]=z;c[O+32>>2]=h;c[O+36>>2]=0;c[O+40>>2]=H;c[O+44>>2]=F;c[O+48>>2]=A;c[O+52>>2]=I;c[O+56>>2]=L;c[O+60>>2]=K;c[O+64>>2]=J;Z=O}O=vXa(P,68,16)|0;if(!O)_=0;else{b[O+4>>1]=-1;b[O+6>>1]=0;c[O+8>>2]=0;c[O>>2]=443968;c[O+12>>2]=0;c[O+16>>2]=0;c[O>>2]=490992;c[O+20>>2]=a;c[O+24>>2]=V;c[O+28>>2]=z;c[O+32>>2]=h;c[O+36>>2]=0;c[O+40>>2]=H;c[O+44>>2]=F;c[O+48>>2]=A;c[O+52>>2]=I;c[O+56>>2]=L;c[O+60>>2]=K;c[O+64>>2]=J;_=O}pTa(c[P>>2]|0);c[X+16>>2]=1;P=X+12|0;c[P>>2]=e;if(!n){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[X+8>>2]=c[(c[P>>2]|0)+8>>2]}c[Z+16>>2]=1;P=Z+12|0;c[P>>2]=X;if(X){ko[c[(c[X>>2]|0)+16>>2]&4095](X);c[Z+8>>2]=c[(c[P>>2]|0)+8>>2]}ko[c[(c[X>>2]|0)+20>>2]&4095](X);c[Y+16>>2]=1;P=Y+12|0;c[P>>2]=Z;if(Z){ko[c[(c[Z>>2]|0)+16>>2]&4095](Z);c[Y+8>>2]=c[(c[P>>2]|0)+8>>2]}ko[c[(c[Z>>2]|0)+20>>2]&4095](Z);c[_+16>>2]=1;P=_+12|0;c[P>>2]=Y;if(Y){ko[c[(c[Y>>2]|0)+16>>2]&4095](Y);c[_+8>>2]=c[(c[P>>2]|0)+8>>2]}ko[c[(c[Y>>2]|0)+20>>2]&4095](Y);c[W+16>>2]=1;P=W+12|0;c[P>>2]=_;if(_){ko[c[(c[_>>2]|0)+16>>2]&4095](_);c[W+8>>2]=c[(c[P>>2]|0)+8>>2]}ko[c[(c[_>>2]|0)+20>>2]&4095](_);ko[c[(c[W>>2]|0)+20>>2]&4095](W)}if(M>>>0<x>>>0)y=M;else break}r=c[m>>2]|0;s=r+12|0;t=c[s>>2]|0;Dn[t&511](m,82,l,o);i=f;return}function zta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b+16|0;e=b;f=a+96|0;a=c[(c[f>>2]|0)+6736>>2]|0;g=c[a+8>>2]|0;h=a;a=c[h>>2]|0;j=c[h+4>>2]|0;Dn[c[(c[g>>2]|0)+8>>2]&511](g,84,a,j);h=c[f>>2]|0;k=h+5868|0;l=h+5872|0;c[l>>2]=0;m=h+224|0;n=DTa(c[m>>2]|0)|0;o=(n|0)==0;if(o){p=0;q=0}else{p=n;q=c[n>>2]|0}r=c[f>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;s=c[r+6564>>2]|0;if(!s){c[e+8>>2]=c[r+6500>>2];c[e+4>>2]=0;c[e>>2]=0}else{t=c[r+6560>>2]|0;c[e+8>>2]=c[r+6500>>2];c[e+4>>2]=c[t+(s<<4)>>2];c[e>>2]=c[t+(s<<4)+12>>2]}hta(r,e);e=c[f>>2]|0;if(!p)u=e;else{r=h+5876|0;h=e;e=q;q=p;while(1){p0a(h+5916|0,c[q+9400>>2]|0,c[q+9404>>2]&2147483647);p=c[l>>2]|0;s=c[q+9360>>2]|0;t=s+p|0;v=t+63&-64;if((c[r>>2]&2147483647)>>>0<v>>>0)S$a(k,v);c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;u0a(k,t,d);YEi((c[k>>2]|0)+(p<<4)|0,c[q+9356>>2]|0,s<<4|0)|0;c[q+336>>2]=0;c[q+340>>2]=0;s=q+9412|0;hta(c[f>>2]|0,s);c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;if(!e)break;s=e;h=c[f>>2]|0;e=c[e>>2]|0;q=s}u=c[f>>2]|0}MAa(u+44|0);if(o){w=c[g>>2]|0;x=w+12|0;y=c[x>>2]|0;Dn[y&511](g,84,a,j);i=b;return}else z=n;do{n=z;z=c[z>>2]|0;BTa(c[m>>2]|0,n)}while((z|0)!=0);w=c[g>>2]|0;x=w+12|0;y=c[x>>2]|0;Dn[y&511](g,84,a,j);i=b;return}function Ata(a,d,f,g,h,j,k,l,m,n,o,p){a=ea(a);d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;q=(hTa(m,32)|0)+-32|0;if((q|0)>=(g|0)){r=0;s=0;t=0;hTa(n,t)|0;iTa(o,r)|0;iTa(p,s)|0;i=l;return}u=~g;v=q;q=0;w=0;x=0;while(1){y=g-v|0;z=(y|0)<32?y:32;y=z+-1|0;if((y|0)>0){A=v+u|0;B=(A|0)>-33?-2-A|0:31;A=0;C=q;D=w;while(1){E=A+v|0;F=c[d+(E<<2)>>2]|0;G=e[F+30>>1]|0;H=G&255;I=H>>>0<C>>>0?C:H;H=G>>>8;G=H>>>0<D>>>0?D:H;v0a(F,h+(E<<5)|0,h+(E<<5)+16|0,a);pwa(j+(E<<5)|0,k+(E+1<<6)|0,F,c[f+(E<<2)>>2]|0);c[j+(E<<5)+28>>2]=0;b[j+(E<<5)+12>>1]=0;b[j+(E<<5)+14>>1]=0;A=A+1|0;if((A|0)==(B|0)){J=I;K=G;break}else{C=I;D=G}}}else{J=q;K=w}D=y+v|0;C=c[d+(D<<2)>>2]|0;B=e[C+30>>1]|0;A=B&255;G=A>>>0<J>>>0?J:A;A=B>>>8;B=A>>>0<K>>>0?K:A;v0a(C,h+(D<<5)|0,h+(D<<5)+16|0,a);pwa(j+(D<<5)|0,k+(z+v<<6)|0,C,c[f+(D<<2)>>2]|0);c[j+(D<<5)+28>>2]=0;b[j+(D<<5)+12>>1]=0;b[j+(D<<5)+14>>1]=0;D=z+x|0;v=(hTa(m,32)|0)+-32|0;if((v|0)>=(g|0)){r=G;s=B;t=D;break}else{q=G;w=B;x=D}}hTa(n,t)|0;iTa(o,r)|0;iTa(p,s)|0;i=l;return}function Bta(a,d,f,g,h,j,k,l,m,n){a=ea(a);d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;l=i;if(!g){o=0;p=0}else{q=0;r=0;s=0;while(1){t=q+1|0;u=c[d+(q<<2)>>2]|0;v=e[u+30>>1]|0;w=v&255;x=w>>>0<r>>>0?r:w;w=v>>>8;v=w>>>0<s>>>0?s:w;v0a(u,h+(q<<5)|0,h+(q<<5)+16|0,a);pwa(j+(q<<5)|0,k+(t<<6)|0,u,c[f+(q<<2)>>2]|0);c[j+(q<<5)+28>>2]=0;b[j+(q<<5)+12>>1]=0;b[j+(q<<5)+14>>1]=0;if((t|0)==(g|0)){o=x;p=v;break}else{q=t;r=x;s=v}}}s=c[m>>2]|0;c[m>>2]=o>>>0<s>>>0?s:o;o=c[n>>2]|0;c[n>>2]=p>>>0<o>>>0?o:p;i=l;return}function Cta(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=Im;b=i;d=c[(c[(c[a+20>>2]|0)+96>>2]|0)+6736>>2]|0;f=c[d+8>>2]|0;h=d;d=c[h>>2]|0;j=c[h+4>>2]|0;h=e[268292]|e[268293]<<16;k=(f|0)==0|(h&16711680|0)==0;if(!k)Dn[c[(c[f>>2]|0)+8>>2]&511](f,h&65535,d,j);l=ea(g[a+48>>2]);Ata(l,c[a+24>>2]|0,c[a+28>>2]|0,c[a+52>>2]|0,c[a+44>>2]|0,c[a+32>>2]|0,c[a+36>>2]|0,0,c[a+56>>2]|0,c[a+60>>2]|0,c[a+64>>2]|0,c[a+68>>2]|0);if(k){i=b;return}Dn[c[(c[f>>2]|0)+12>>2]&511](f,h&65535,d,j);i=b;return}function Dta(a,d,e,f,h,j,k,l,m,n,o,p){a=a|0;d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;q=i;r=c[p+8>>2]|0;s=mo[c[(c[r>>2]|0)+16>>2]&4095](r)|0;r=mo[c[(c[s>>2]|0)+4>>2]&4095](s)|0;s=h>>>6;t=s+1|0;u=t>>>0<r>>>0?t:r;if(u>>>0<=1){Bta(ea(g[a+124>>2]),e,f,h,j,k,l,0,n,o);i=q;return}t=a+96|0;v=c[(c[t>>2]|0)+6732>>2]|0;oTa(c[v>>2]|0);w=vXa(v,u*72|0,16)|0;pTa(c[v>>2]|0);v=c[(c[t>>2]|0)+6732>>2]|0;oTa(c[v>>2]|0);t=vXa(v,8,16)|0;pTa(c[v>>2]|0);v=t+4|0;c[t>>2]=0;c[v>>2]=0;u=~r;r=-2-s|0;s=~(r>>>0<u>>>0?u:r);r=0;do{u=w+(r*72|0)|0;if(!u)x=0;else{b[w+(r*72|0)+4>>1]=-1;b[w+(r*72|0)+6>>1]=0;c[w+(r*72|0)+8>>2]=0;c[u>>2]=443968;c[w+(r*72|0)+12>>2]=0;c[w+(r*72|0)+16>>2]=0;c[u>>2]=490016;c[w+(r*72|0)+20>>2]=a;c[w+(r*72|0)+24>>2]=e;c[w+(r*72|0)+28>>2]=f;c[w+(r*72|0)+32>>2]=k;c[w+(r*72|0)+36>>2]=l;c[w+(r*72|0)+40>>2]=m;c[w+(r*72|0)+44>>2]=j;g[w+(r*72|0)+48>>2]=d;c[w+(r*72|0)+52>>2]=h;c[w+(r*72|0)+56>>2]=t;c[w+(r*72|0)+60>>2]=v;c[w+(r*72|0)+64>>2]=n;c[w+(r*72|0)+68>>2]=o;x=u}c[x+16>>2]=1;u=x+12|0;c[u>>2]=p;ko[c[(c[p>>2]|0)+16>>2]&4095](p);c[x+8>>2]=c[(c[u>>2]|0)+8>>2];ko[c[(c[x>>2]|0)+20>>2]&4095](x);r=r+1|0}while((r|0)!=(s|0));i=q;return}function Eta(a,b,c,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;y=i;Fta(a,b,c,d,e,f,g,h,j,k,l,o,q,r,s,t,u,v,w,x,0,z,A,B,C,D);i=y;return}function Fta(a,d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;var F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0;z=i;i=i+16|0;F=z;c[F>>2]=0;G=c[a+136>>2]|0;H=a+124|0;I=ea(g[H>>2]);Lm[c[(c[G>>2]|0)+20>>2]&1](G,I,d,f,h,j,k,l,m,n,o,p,q,r,t,u,v,C,D,w,F);D=(hTa(s,32)|0)+-32|0;if((D|0)<(A|0)){C=a+96|0;a=y+4|0;v=y+8|0;u=~A;t=32;r=D;q=0;while(1){p=A-r|0;o=(p|0)<32?p:32;p=t-o|0;if((o|0)>0){n=r+u|0;k=(n|0)>-33?n:-33;n=q+-1|0;j=~k;f=0;d=r;while(1){G=m+(d*40|0)|0;J=c[G>>2]|0;K=J+28|0;L=(da(e[J+12>>1]|0,c[F>>2]|0)|0)&65535;do{}while((c[K>>2]|0)!=(L|0));L=c[(c[C>>2]|0)+6736>>2]|0;K=c[L+8>>2]|0;J=L;L=c[J>>2]|0;M=c[J+4>>2]|0;J=e[268392]|e[268393]<<16;N=(K|0)==0|(J&16711680|0)==0;if(!N)Dn[c[(c[K>>2]|0)+8>>2]&511](K,J&65535,L,M);if(c[125132]|0)Qza(G,ea(g[H>>2]));O=m+(d*40|0)+36|0;P=b[O>>1]|0;if(P<<16>>16){Q=m+(d*40|0)+4|0;R=P;P=0;while(1){S=(c[(c[Q>>2]|0)+(P<<5)+16>>2]|0)+68|0;T=c[S>>2]|0;U=c[S+4>>2]|0;if((U|0)==1073741823)V=R;else{S=(U+32|0)>>>5;if(S>>>0>(c[a>>2]&2147483647)>>>0){W=UJa(v,S<<2,543784,339)|0;X=c[y>>2]|0;if((X|0)!=0?(YEi(W|0,X|0,c[a>>2]<<2|0)|0,(c[a>>2]|0)>-1):0)VJa(v,c[y>>2]|0);X=c[a>>2]|0;PEi(W+((X&2147483647)<<2)|0,0,S-X<<2|0)|0;c[y>>2]=W;c[a>>2]=S;Y=b[O>>1]|0;Z=W}else{Y=R;Z=c[y>>2]|0}W=VEi(T|0,U|0,37)|0;T=Z+(W<<2)|0;c[T>>2]=c[T>>2]|1<<(U&31);V=Y}P=P+1|0;if(P>>>0>=(V&65535)>>>0)break;else R=V}}if(!N)Dn[c[(c[K>>2]|0)+12>>2]&511](K,J&65535,L,M);f=f+1|0;if((f|0)==(j|0))break;else d=d+1|0}_=r+-1-k|0;$=n-k|0}else{_=r;$=q}if((t|0)==(o|0)){aa=32;ba=(hTa(s,32)|0)+-32|0}else{aa=p;ba=_}if((ba|0)<(A|0)){t=aa;r=ba;q=$}else{ca=aa;fa=ba;ga=$;break}}}else{ca=32;fa=D;ga=0}D=fa-A|0;if((D|0)>=(l|0)){ha=ga;hTa(B,ha)|0;i=z;return}fa=-32-A|0;A=~l;$=ca;ca=D;D=ga;while(1){ga=l-ca|0;if((((ga|0)<($|0)?ga:$)|0)>0){ga=~$;ba=ca+A|0;aa=(ba|0)<(ga|0)?ga:ba;ba=~aa;ga=0;q=ca;while(1){r=da(e[h+(q<<5)+12>>1]|0,c[F>>2]|0)|0;t=h+(q<<5)+28|0;do{}while((c[t>>2]|0)!=(r|0));w0a(c[x+(q<<2)>>2]|0,c[E+(q<<2)>>2]|0,w+(q<<5)|0,ea(g[H>>2]));ga=ga+1|0;if((ga|0)==(ba|0))break;else q=q+1|0}ia=D+-1-aa|0}else ia=D;ca=fa+(hTa(s,32)|0)|0;if((ca|0)>=(l|0)){ha=ia;break}else{$=32;D=ia}}hTa(B,ha)|0;i=z;return}function Gta(a,b,c,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;y=i;Hta(a,b,c,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,0,z,A,B,C,D);i=y;return}function Hta(a,d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;var I=0,J=0,K=0,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0;C=i;i=i+16|0;I=C+4|0;J=C;c[I>>2]=0;c[J>>2]=0;K=c[a+136>>2]|0;L=a+124|0;M=ea(g[L>>2]);uo[c[(c[K>>2]|0)+24>>2]&1](K,M,d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,w,x,y,F,G,z,I,J);G=(hTa(v,32)|0)+-32|0;if((G|0)<(D|0)){F=a+96|0;a=B+4|0;y=B+8|0;x=~D;w=32;u=G;t=0;while(1){s=D-u|0;r=(s|0)<32?s:32;s=w-r|0;if((r|0)>0){q=u+x|0;p=(q|0)>-33?q:-33;q=t+-1|0;o=~p;n=0;k=u;while(1){j=m+(k*40|0)|0;f=c[j>>2]|0;d=da(e[f+12>>1]|0,c[I>>2]|0)|0;K=f+28|0;N=(da(e[f+14>>1]|0,c[J>>2]|0)|0)+d&65535;do{}while((c[K>>2]|0)!=(N|0));N=c[(c[F>>2]|0)+6736>>2]|0;K=c[N+8>>2]|0;d=N;N=c[d>>2]|0;f=c[d+4>>2]|0;d=e[268392]|e[268393]<<16;O=(K|0)==0|(d&16711680|0)==0;if(!O)Dn[c[(c[K>>2]|0)+8>>2]&511](K,d&65535,N,f);if(c[125132]|0)Qza(j,ea(g[L>>2]));P=m+(k*40|0)+36|0;Q=b[P>>1]|0;if(Q<<16>>16){R=m+(k*40|0)+4|0;S=Q;Q=0;while(1){T=(c[(c[R>>2]|0)+(Q<<5)+16>>2]|0)+68|0;U=c[T>>2]|0;V=c[T+4>>2]|0;if((V|0)==1073741823)W=S;else{T=(V+32|0)>>>5;if(T>>>0>(c[a>>2]&2147483647)>>>0){X=UJa(y,T<<2,543784,339)|0;Y=c[B>>2]|0;if((Y|0)!=0?(YEi(X|0,Y|0,c[a>>2]<<2|0)|0,(c[a>>2]|0)>-1):0)VJa(y,c[B>>2]|0);Y=c[a>>2]|0;PEi(X+((Y&2147483647)<<2)|0,0,T-Y<<2|0)|0;c[B>>2]=X;c[a>>2]=T;Z=b[P>>1]|0;_=X}else{Z=S;_=c[B>>2]|0}X=VEi(U|0,V|0,37)|0;U=_+(X<<2)|0;c[U>>2]=c[U>>2]|1<<(V&31);W=Z}Q=Q+1|0;if(Q>>>0>=(W&65535)>>>0)break;else S=W}}if(!O)Dn[c[(c[K>>2]|0)+12>>2]&511](K,d&65535,N,f);n=n+1|0;if((n|0)==(o|0))break;else k=k+1|0}$=u+-1-p|0;aa=q-p|0}else{$=u;aa=t}if((w|0)==(r|0)){ba=32;ca=(hTa(v,32)|0)+-32|0}else{ba=s;ca=$}if((ca|0)<(D|0)){w=ba;u=ca;t=aa}else{fa=ba;ga=ca;ha=aa;break}}}else{fa=32;ga=G;ha=0}G=ga-D|0;if((G|0)>=(l|0)){ia=ha;hTa(E,ia)|0;i=C;return}ga=-32-D|0;D=~l;aa=fa;fa=G;G=ha;while(1){ha=l-fa|0;if((((ha|0)<(aa|0)?ha:aa)|0)>0){ha=~aa;ca=fa+D|0;ba=(ca|0)<(ha|0)?ha:ca;ca=~ba;ha=0;t=fa;while(1){u=da(e[h+(t<<5)+12>>1]|0,c[I>>2]|0)|0;w=(da(e[h+(t<<5)+14>>1]|0,c[J>>2]|0)|0)+u|0;u=h+(t<<5)+28|0;do{}while((c[u>>2]|0)!=(w|0));w0a(c[A+(t<<2)>>2]|0,c[H+(t<<2)>>2]|0,z+(t<<5)|0,ea(g[L>>2]));ha=ha+1|0;if((ha|0)==(ca|0))break;else t=t+1|0}ja=G+-1-ba|0}else ja=G;fa=ga+(hTa(v,32)|0)|0;if((fa|0)>=(l|0)){ia=ja;break}else{aa=32;G=ja}}hTa(E,ia)|0;i=C;return}function Ita(a,d,f,h,j,k,l,m,n,o,p,q){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=ea(m);n=ea(n);o=ea(o);p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=Im,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;h=i;i=i+368|0;d=h;r=h+256|0;s=h+320|0;t=h+16|0;u=h+336|0;v=h+352|0;w=h+240|0;x=h+304|0;y=h+272|0;z=h+32|0;A=c[j+9168>>2]|0;B=c[j+9180>>2]|0;C=c[j+9184>>2]|0;D=p+224|0;E=CTa(c[D>>2]|0)|0;if(!E){F=mKa()|0;G=c[(c[F>>2]|0)+8>>2]|0;H=pKa()|0;I=mo[c[(c[H>>2]|0)+24>>2]&4095](H)|0;H=Bn[G&255](F,9459,I?490864:544544,490760,82)|0;if(H){I=H+19&-16;c[I+-4>>2]=I-H;H=I;if(!I)J=H;else{pya(H,p);J=H}}else J=0}else J=E;E=J+16|0;H=J+332|0;c[J+336>>2]=0;c[J+340>>2]=0;p=hTa(k,8)|0;I=p+-8|0;if((I|0)>=(C|0)){K=0;L=c[D>>2]|0;BTa(L,J);hTa(q,K)|0;i=h;return K|0}F=C+-1|0;G=d+4|0;M=d+8|0;N=d+12|0;O=r+4|0;P=r+8|0;Q=r+12|0;R=s+4|0;S=s+8|0;T=s+12|0;U=t+4|0;V=t+8|0;W=t+12|0;X=u+4|0;Y=u+8|0;Z=u+12|0;_=v+4|0;$=v+8|0;aa=v+12|0;ba=w+4|0;ca=w+8|0;da=w+12|0;fa=x+4|0;ga=x+8|0;ha=x+12|0;ia=501448+(a<<2)|0;ja=j+8800|0;ka=j+316|0;j=y+4|0;la=y+8|0;ma=y+12|0;na=y+16|0;oa=y+20|0;pa=y+24|0;qa=501432+(a<<2)|0;ra=0;sa=p;p=I;while(1){I=(sa|0)<(C|0)?sa:C;a:do if(p>>>0<I>>>0){ta=p;ua=ra;while(1){va=ta;while(1){wa=va;va=va+1|0;xa=va>>>0<F>>>0?va:F;ya=B+(xa<<3)|0;za=c[ya>>2]|0;Aa=b[A+(za<<5)+26>>1]|0;b:do if(Aa<<16>>16==2){Ba=B+(xa<<3)+4|0;if(b[Ba>>1]|0){Ca=za;Da=0;while(1){Ea=Da+1|0;if(Ea>>>0>=(e[Ba>>1]|0)>>>0)break b;Ca=c[ya>>2]|0;Da=Ea}}}else if(Aa<<16>>16==1?(Da=B+(xa<<3)+4|0,(b[Da>>1]|0)!=0):0){Ca=za;Ba=0;while(1){Ea=Ba+1|0;if(Ea>>>0>=(e[Da>>1]|0)>>>0)break b;Ca=c[ya>>2]|0;Ba=Ea}}while(0);ya=wa+2|0;za=ya>>>0<F>>>0?ya:F;ya=B+(za<<3)+4|0;xa=b[ya>>1]|0;Aa=B+(za<<3)|0;za=c[Aa>>2]|0;if(!(xa<<16>>16)){Fa=za;Ga=xa&65535}else{xa=za;za=0;while(1){Ba=za+1|0;Ca=e[ya>>1]|0;Da=c[Aa>>2]|0;if(Ba>>>0<Ca>>>0){xa=Da;za=Ba}else{Fa=Da;Ga=Ca;break}}}Ha=B+(wa<<3)|0;za=c[Ha>>2]|0;xa=A+(za<<5)|0;Aa=b[A+(za<<5)+26>>1]|0;if(Aa<<16>>16==1){Ia=B+(wa<<3)+4|0;ya=b[Ia>>1]|0;if(ya<<16>>16!=4){Ja=ya;Ka=24;break}ya=za+1|0;Ca=A+(ya<<5)|0;Da=za+2|0;Ba=A+(Da<<5)|0;Ea=za+3|0;La=A+(Ea<<5)|0;Ma=c[A+(za<<5)+16>>2]|0;Na=c[A+(ya<<5)+16>>2]|0;Oa=c[A+(Da<<5)+16>>2]|0;Pa=c[A+(Ea<<5)+16>>2]|0;c[d>>2]=Ma+16;c[G>>2]=Na+16;c[M>>2]=Oa+16;c[N>>2]=Pa+16;c[r>>2]=xa;c[O>>2]=Ca;c[P>>2]=Ba;c[Q>>2]=La;c[s>>2]=c[xa>>2];c[R>>2]=c[Ca>>2];c[S>>2]=c[Ba>>2];c[T>>2]=c[La>>2];c[t>>2]=c[A+(za<<5)+4>>2];c[U>>2]=c[A+(ya<<5)+4>>2];c[V>>2]=c[A+(Da<<5)+4>>2];c[W>>2]=c[A+(Ea<<5)+4>>2];c[u>>2]=f+(e[A+(za<<5)+10>>1]<<6);c[X>>2]=f+(e[A+(ya<<5)+10>>1]<<6);c[Y>>2]=f+(e[A+(Da<<5)+10>>1]<<6);c[Z>>2]=f+(e[A+(Ea<<5)+10>>1]<<6);c[v>>2]=f+(e[A+(za<<5)+14>>1]<<6);c[_>>2]=f+(e[A+(ya<<5)+14>>1]<<6);c[$>>2]=f+(e[A+(Da<<5)+14>>1]<<6);c[aa>>2]=f+(e[A+(Ea<<5)+14>>1]<<6);c[w>>2]=c[Ma+80>>2];c[ba>>2]=c[Na+80>>2];c[ca>>2]=c[Oa+80>>2];c[da>>2]=c[Pa+80>>2];c[x>>2]=c[Ma+84>>2];c[fa>>2]=c[Na+84>>2];c[ga>>2]=c[Oa+84>>2];c[ha>>2]=c[Pa+84>>2];Qa=ea(g[ja>>2]);if((Sn[c[ia>>2]&3](d,E,r,s,t,u,v,w,x,m,n,o,Qa,ka,a)|0)==1){Ka=23;break}}else if(Aa<<16>>16==2){Ra=B+(wa<<3)+4|0;Aa=b[Ra>>1]|0;if(Aa<<16>>16!=4){Sa=Aa;Ka=46;break}g[y>>2]=ea(0.0);g[j>>2]=ea(0.0);g[la>>2]=ea(0.0);g[ma>>2]=ea(1.0);g[na>>2]=ea(0.0);g[oa>>2]=ea(0.0);g[pa>>2]=ea(0.0);Aa=za;za=0;while(1){Pa=Aa+za|0;Oa=A+(Pa<<5)|0;Na=c[A+(Pa<<5)+16>>2]|0;Ma=c[Na+16>>2]|0;Ea=c[Na+12>>2]|0;Da=c[Na+36>>2]|0;if(!Da)Ta=y;else Ta=c[Da+64>>2]|0;Da=c[Na+40>>2]|0;if(!Da)Ua=y;else Ua=c[Da+64>>2]|0;Da=c[Oa>>2]|0;ya=c[A+(Pa<<5)+4>>2]|0;if((b[A+(Pa<<5)+8>>1]|0)==-1)Va=e[A+(Pa<<5)+10>>1]|0;else Va=0;if((b[A+(Pa<<5)+12>>1]|0)==-1)Wa=e[A+(Pa<<5)+14>>1]|0;else Wa=0;c[z+(za*52|0)+32>>2]=c[Na+28>>2];c[z+(za*52|0)+36>>2]=Ea;c[z+(za*52|0)>>2]=Na;c[z+(za*52|0)+40>>2]=Oa;c[z+(za*52|0)+4>>2]=Ta;c[z+(za*52|0)+8>>2]=Ua;c[z+(za*52|0)+20>>2]=f+(Va<<6);c[z+(za*52|0)+24>>2]=f+(Wa<<6);c[z+(za*52|0)+12>>2]=Da;c[z+(za*52|0)+16>>2]=ya;c[z+(za*52|0)+28>>2]=Ma;Ma=za+1|0;if((Ma|0)==4)break;Aa=c[Ha>>2]|0;za=Ma}if((xsa(z,l,m,H,ka)|0)==1){Ka=45;break}}if(va>>>0>=I>>>0){Xa=ua;break a}}if((Ka|0)==23){Ka=0;Ja=b[Ia>>1]|0;Ka=24}else if((Ka|0)==45){Ka=0;Sa=b[Ra>>1]|0;Ka=46}if((Ka|0)==24){Ka=0;if(!(Ja<<16>>16))Ya=ua;else{za=ua;Aa=0;while(1){wa=(c[Ha>>2]|0)+Aa|0;Ma=A+(wa<<5)|0;ya=A+(wa<<5)+16|0;Da=c[ya>>2]|0;Oa=Da+16|0;if((b[A+(wa<<5)+8>>1]|0)==-1)Za=f+(e[A+(wa<<5)+10>>1]<<6)|0;else Za=f;if((b[A+(wa<<5)+12>>1]|0)==-1)_a=f+(e[A+(wa<<5)+14>>1]<<6)|0;else _a=f;Qa=ea(g[ja>>2]);en[c[qa>>2]&3](Oa,E,0,0,Ma,c[Ma>>2]|0,c[A+(wa<<5)+4>>2]|0,Za,_a,c[Da+80>>2]|0,c[Da+84>>2]|0,m,n,o,Qa,ka,a)|0;b[A+(wa<<5)+26>>1]=(c[Da+20>>2]|0)>>>4;c[ya>>2]=c[Oa>>2];if(!(b[Da+114>>1]&16)){$a=0;ab=0}else{$a=(c[Da+44>>2]|0)+((c[Da+48>>2]|0)+15&-16)|0;ab=b[Da+36>>1]|0}c[A+(wa<<5)+20>>2]=$a;b[A+(wa<<5)+24>>1]=ab;wa=(e[Da+32>>1]|0)+za|0;Aa=Aa+1|0;if(Aa>>>0>=(e[Ia>>1]|0)>>>0){Ya=wa;break}else za=wa}}}else if((Ka|0)==46){Ka=0;if(!(Sa<<16>>16))Ya=ua;else{za=ua;Aa=0;while(1){wa=(c[Ha>>2]|0)+Aa|0;Da=(osa(c[A+(wa<<5)+16>>2]|0,f,H,l,m,A+(wa<<5)|0,ka)|0)+za|0;Aa=Aa+1|0;if(Aa>>>0>=(e[Ra>>1]|0)>>>0){Ya=Da;break}else za=Da}}}if(va>>>0<I>>>0){ta=va;ua=Ya}else{Xa=Ya;break}}}else Xa=ra;while(0);sa=hTa(k,8)|0;p=sa+-8|0;if((p|0)>=(C|0)){K=Xa;break}else ra=Xa}L=c[D>>2]|0;BTa(L,J);hTa(q,K)|0;i=h;return K|0}function Jta(a,d,f,h,j,k,l){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=Im,$a=Im,ab=Im,bb=0,cb=0,db=0,eb=Im,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;k=i;i=i+528|0;j=k+480|0;f=k+192|0;m=k+96|0;n=k+128|0;o=k+48|0;p=k+64|0;q=k+400|0;r=k+432|0;s=k+464|0;t=k+512|0;u=k+144|0;v=k+32|0;w=k;x=k+16|0;y=k+176|0;z=k+80|0;A=k+416|0;B=k+112|0;C=k+448|0;D=c[l+9168>>2]|0;E=c[l+9180>>2]|0;F=c[l+9184>>2]|0;G=l+9268|0;H=c[G>>2]|0;I=ea(g[a+124>>2]);J=a+128|0;K=ea(g[J>>2]);L=a+96|0;M=c[L>>2]|0;N=CTa(c[M+224>>2]|0)|0;if(!N){O=mKa()|0;P=c[(c[O>>2]|0)+8>>2]|0;Q=pKa()|0;R=mo[c[(c[Q>>2]|0)+24>>2]&4095](Q)|0;Q=Bn[P&255](O,9459,R?490864:544544,490760,82)|0;if(Q){R=Q+19&-16;c[R+-4>>2]=R-Q;Q=R;if(!R)S=Q;else{pya(Q,M);S=Q}}else S=0}else S=N;N=S+16|0;Q=S+332|0;c[S+336>>2]=0;c[S+340>>2]=0;if(F>>>0>1){M=F+-1|0;R=j+4|0;O=j+8|0;P=j+12|0;T=j+16|0;U=j+20|0;V=j+24|0;W=l+316|0;X=m+4|0;Y=m+8|0;Z=m+12|0;_=n+4|0;$=n+8|0;aa=n+12|0;ba=o+4|0;ca=o+8|0;da=o+12|0;fa=p+4|0;ga=p+8|0;ha=p+12|0;ia=q+4|0;ja=q+8|0;ka=q+12|0;la=r+4|0;ma=r+8|0;na=r+12|0;oa=s+4|0;pa=s+8|0;qa=s+12|0;ra=t+4|0;sa=t+8|0;ta=t+12|0;ua=501448+(d<<2)|0;va=a+140|0;wa=a+144|0;xa=l+8800|0;ya=501432+(d<<2)|0;za=1;Aa=H;while(1){Ba=za+-1|0;Ca=E+(za<<3)|0;Da=c[Ca>>2]|0;Ea=b[D+(Da<<5)+26>>1]|0;a:do if(Ea<<16>>16==1){Fa=E+(za<<3)+4|0;if(b[Fa>>1]|0){Ga=Da;Ha=0;while(1){Ia=Ha+1|0;if(Ia>>>0>=(e[Fa>>1]|0)>>>0)break a;Ga=c[Ca>>2]|0;Ha=Ia}}}else if(Ea<<16>>16==2?(Ha=E+(za<<3)+4|0,(b[Ha>>1]|0)!=0):0){Ga=Da;Fa=0;while(1){Ia=Fa+1|0;if(Ia>>>0>=(e[Ha>>1]|0)>>>0)break a;Ga=c[Ca>>2]|0;Fa=Ia}}while(0);Ca=za+2|0;Da=Ca>>>0<M>>>0?Ca:M;Ca=E+(Da<<3)+4|0;Ea=b[Ca>>1]|0;Fa=E+(Da<<3)|0;Da=c[Fa>>2]|0;if(!(Ea<<16>>16)){Ja=Ea&65535;Ka=Da}else{Ea=Da;Da=0;while(1){Ga=Da+1|0;Ha=e[Ca>>1]|0;Ia=c[Fa>>2]|0;if(Ga>>>0<Ha>>>0){Ea=Ia;Da=Ga}else{Ja=Ha;Ka=Ia;break}}}Da=E+(Ba<<3)|0;Ea=c[Da>>2]|0;Fa=D+(Ea<<5)|0;Ca=b[D+(Ea<<5)+26>>1]|0;do if(Ca<<16>>16==2){Ia=E+(Ba<<3)+4|0;Ha=b[Ia>>1]|0;if(Ha<<16>>16==4){g[j>>2]=ea(0.0);g[R>>2]=ea(0.0);g[O>>2]=ea(0.0);g[P>>2]=ea(1.0);g[T>>2]=ea(0.0);g[U>>2]=ea(0.0);g[V>>2]=ea(0.0);Ga=Ea;La=0;while(1){Ma=Ga+La|0;Na=D+(Ma<<5)|0;Oa=c[D+(Ma<<5)+16>>2]|0;Pa=c[Oa+16>>2]|0;Qa=c[Oa+12>>2]|0;Ra=c[Oa+36>>2]|0;if(!Ra)Sa=j;else Sa=c[Ra+64>>2]|0;Ra=c[Oa+40>>2]|0;if(!Ra)Ta=j;else Ta=c[Ra+64>>2]|0;Ra=c[Na>>2]|0;Ua=c[D+(Ma<<5)+4>>2]|0;if((b[D+(Ma<<5)+8>>1]|0)==-1)Va=e[D+(Ma<<5)+10>>1]|0;else Va=0;if((b[D+(Ma<<5)+12>>1]|0)==-1)Wa=e[D+(Ma<<5)+14>>1]|0;else Wa=0;c[f+(La*52|0)+32>>2]=c[Oa+28>>2];c[f+(La*52|0)+36>>2]=Qa;c[f+(La*52|0)>>2]=Oa;c[f+(La*52|0)+40>>2]=Na;c[f+(La*52|0)+4>>2]=Sa;c[f+(La*52|0)+8>>2]=Ta;c[f+(La*52|0)+20>>2]=h+(Va<<6);c[f+(La*52|0)+24>>2]=h+(Wa<<6);c[f+(La*52|0)+12>>2]=Ra;c[f+(La*52|0)+16>>2]=Ua;c[f+(La*52|0)+28>>2]=Pa;Pa=La+1|0;if((Pa|0)==4)break;Ga=c[Da>>2]|0;La=Pa}if((xsa(f,I,K,Q,W)|0)!=1){Xa=Aa;break}Ya=b[Ia>>1]|0}else Ya=Ha;if(!(Ya<<16>>16))Xa=Aa;else{La=Aa;Ga=0;while(1){Pa=(c[Da>>2]|0)+Ga|0;Ua=(osa(c[D+(Pa<<5)+16>>2]|0,h,Q,I,K,D+(Pa<<5)|0,W)|0)+La|0;Ga=Ga+1|0;if(Ga>>>0>=(e[Ia>>1]|0)>>>0){Xa=Ua;break}else La=Ua}}}else if(Ca<<16>>16==1){La=E+(Ba<<3)+4|0;Ia=b[La>>1]|0;if(Ia<<16>>16==4){Ga=Ea+1|0;Ha=D+(Ga<<5)|0;Ua=Ea+2|0;Pa=D+(Ua<<5)|0;Ra=Ea+3|0;Na=D+(Ra<<5)|0;Oa=c[D+(Ea<<5)+16>>2]|0;Qa=c[D+(Ga<<5)+16>>2]|0;Ma=c[D+(Ua<<5)+16>>2]|0;Za=c[D+(Ra<<5)+16>>2]|0;c[m>>2]=Oa+16;c[X>>2]=Qa+16;c[Y>>2]=Ma+16;c[Z>>2]=Za+16;c[n>>2]=Fa;c[_>>2]=Ha;c[$>>2]=Pa;c[aa>>2]=Na;c[o>>2]=c[Fa>>2];c[ba>>2]=c[Ha>>2];c[ca>>2]=c[Pa>>2];c[da>>2]=c[Na>>2];c[p>>2]=c[D+(Ea<<5)+4>>2];c[fa>>2]=c[D+(Ga<<5)+4>>2];c[ga>>2]=c[D+(Ua<<5)+4>>2];c[ha>>2]=c[D+(Ra<<5)+4>>2];c[q>>2]=h+(e[D+(Ea<<5)+10>>1]<<6);c[ia>>2]=h+(e[D+(Ga<<5)+10>>1]<<6);c[ja>>2]=h+(e[D+(Ua<<5)+10>>1]<<6);c[ka>>2]=h+(e[D+(Ra<<5)+10>>1]<<6);c[r>>2]=h+(e[D+(Ea<<5)+14>>1]<<6);c[la>>2]=h+(e[D+(Ga<<5)+14>>1]<<6);c[ma>>2]=h+(e[D+(Ua<<5)+14>>1]<<6);c[na>>2]=h+(e[D+(Ra<<5)+14>>1]<<6);c[s>>2]=c[Oa+80>>2];c[oa>>2]=c[Qa+80>>2];c[pa>>2]=c[Ma+80>>2];c[qa>>2]=c[Za+80>>2];c[t>>2]=c[Oa+84>>2];c[ra>>2]=c[Qa+84>>2];c[sa>>2]=c[Ma+84>>2];c[ta>>2]=c[Za+84>>2];_a=ea(g[va>>2]);$a=ea(g[wa>>2]);ab=ea(g[xa>>2]);if((Sn[c[ua>>2]&3](m,N,n,o,p,q,r,s,t,K,_a,$a,ab,W,d)|0)!=1){Xa=Aa;break}bb=b[La>>1]|0}else bb=Ia;if(bb<<16>>16){Ia=Aa;Za=0;while(1){Ma=(c[Da>>2]|0)+Za|0;Qa=D+(Ma<<5)|0;Oa=D+(Ma<<5)+16|0;Ra=c[Oa>>2]|0;Ua=Ra+16|0;if((b[D+(Ma<<5)+8>>1]|0)==-1)cb=h+(e[D+(Ma<<5)+10>>1]<<6)|0;else cb=h;if((b[D+(Ma<<5)+12>>1]|0)==-1)db=h+(e[D+(Ma<<5)+14>>1]<<6)|0;else db=h;ab=ea(g[J>>2]);$a=ea(g[va>>2]);_a=ea(g[wa>>2]);eb=ea(g[xa>>2]);en[c[ya>>2]&3](Ua,N,0,0,Qa,c[Qa>>2]|0,c[D+(Ma<<5)+4>>2]|0,cb,db,c[Ra+80>>2]|0,c[Ra+84>>2]|0,ab,$a,_a,eb,W,d)|0;b[D+(Ma<<5)+26>>1]=(c[Ra+20>>2]|0)>>>4;c[Oa>>2]=c[Ua>>2];if(!(b[Ra+114>>1]&16)){fb=0;gb=0}else{fb=(c[Ra+44>>2]|0)+((c[Ra+48>>2]|0)+15&-16)|0;gb=b[Ra+36>>1]|0}c[D+(Ma<<5)+20>>2]=fb;b[D+(Ma<<5)+24>>1]=gb;Ma=(e[Ra+32>>1]|0)+Ia|0;Za=Za+1|0;if(Za>>>0>=(e[La>>1]|0)>>>0){Xa=Ma;break}else Ia=Ma}}else Xa=Aa}else Xa=Aa;while(0);za=za+1|0;if((za|0)==(F|0)){hb=Xa;break}else Aa=Xa}}else hb=H;if(!F){ib=hb;jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}H=F+-1|0;F=E+(H<<3)|0;Xa=c[F>>2]|0;Aa=D+(Xa<<5)|0;za=b[D+(Xa<<5)+26>>1]|0;if(za<<16>>16==2){gb=E+(H<<3)+4|0;fb=b[gb>>1]|0;do if(fb<<16>>16==4){g[u>>2]=ea(0.0);g[u+4>>2]=ea(0.0);g[u+8>>2]=ea(0.0);g[u+12>>2]=ea(1.0);g[u+16>>2]=ea(0.0);g[u+20>>2]=ea(0.0);g[u+24>>2]=ea(0.0);W=Xa;db=0;while(1){cb=W+db|0;ya=D+(cb<<5)|0;xa=c[D+(cb<<5)+16>>2]|0;wa=c[xa+16>>2]|0;va=c[xa+12>>2]|0;bb=c[xa+36>>2]|0;if(!bb)mb=u;else mb=c[bb+64>>2]|0;bb=c[xa+40>>2]|0;if(!bb)nb=u;else nb=c[bb+64>>2]|0;bb=c[ya>>2]|0;t=c[D+(cb<<5)+4>>2]|0;if((b[D+(cb<<5)+8>>1]|0)==-1)ob=e[D+(cb<<5)+10>>1]|0;else ob=0;if((b[D+(cb<<5)+12>>1]|0)==-1)pb=e[D+(cb<<5)+14>>1]|0;else pb=0;c[f+(db*52|0)+32>>2]=c[xa+28>>2];c[f+(db*52|0)+36>>2]=va;c[f+(db*52|0)>>2]=xa;c[f+(db*52|0)+40>>2]=ya;c[f+(db*52|0)+4>>2]=mb;c[f+(db*52|0)+8>>2]=nb;c[f+(db*52|0)+20>>2]=h+(ob<<6);c[f+(db*52|0)+24>>2]=h+(pb<<6);c[f+(db*52|0)+12>>2]=bb;c[f+(db*52|0)+16>>2]=t;c[f+(db*52|0)+28>>2]=wa;wa=db+1|0;if((wa|0)==4)break;W=c[F>>2]|0;db=wa}if((xsa(f,I,K,Q,l+316|0)|0)==1){qb=b[gb>>1]|0;break}else{ib=hb;jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}}else qb=fb;while(0);if(!(qb<<16>>16)){ib=hb;jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}qb=l+316|0;fb=hb;f=0;while(1){pb=(c[F>>2]|0)+f|0;ob=(osa(c[D+(pb<<5)+16>>2]|0,h,Q,I,K,D+(pb<<5)|0,qb)|0)+fb|0;f=f+1|0;if(f>>>0>=(e[gb>>1]|0)>>>0){ib=ob;break}else fb=ob}jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}else if(za<<16>>16==1){za=E+(H<<3)+4|0;H=b[za>>1]|0;do if(H<<16>>16==4){E=Xa+1|0;fb=D+(E<<5)|0;gb=Xa+2|0;f=D+(gb<<5)|0;qb=Xa+3|0;Q=D+(qb<<5)|0;ob=c[D+(E<<5)+16>>2]|0;pb=c[D+(gb<<5)+16>>2]|0;nb=c[D+(qb<<5)+16>>2]|0;c[v>>2]=(c[D+(Xa<<5)+16>>2]|0)+16;mb=v+4|0;c[mb>>2]=ob+16;ob=v+8|0;c[ob>>2]=pb+16;pb=v+12|0;c[pb>>2]=nb+16;c[w>>2]=Aa;c[w+4>>2]=fb;c[w+8>>2]=f;c[w+12>>2]=Q;c[x>>2]=c[Aa>>2];c[x+4>>2]=c[fb>>2];c[x+8>>2]=c[f>>2];c[x+12>>2]=c[Q>>2];c[y>>2]=c[D+(Xa<<5)+4>>2];c[y+4>>2]=c[D+(E<<5)+4>>2];c[y+8>>2]=c[D+(gb<<5)+4>>2];c[y+12>>2]=c[D+(qb<<5)+4>>2];c[z>>2]=h+(e[D+(Xa<<5)+10>>1]<<6);c[z+4>>2]=h+(e[D+(E<<5)+10>>1]<<6);c[z+8>>2]=h+(e[D+(gb<<5)+10>>1]<<6);c[z+12>>2]=h+(e[D+(qb<<5)+10>>1]<<6);c[A>>2]=h+(e[D+(Xa<<5)+14>>1]<<6);c[A+4>>2]=h+(e[D+(E<<5)+14>>1]<<6);c[A+8>>2]=h+(e[D+(gb<<5)+14>>1]<<6);c[A+12>>2]=h+(e[D+(qb<<5)+14>>1]<<6);qb=c[v>>2]|0;c[B>>2]=c[qb+64>>2];gb=c[mb>>2]|0;c[B+4>>2]=c[gb+64>>2];mb=c[ob>>2]|0;c[B+8>>2]=c[mb+64>>2];ob=c[pb>>2]|0;c[B+12>>2]=c[ob+64>>2];c[C>>2]=c[qb+68>>2];c[C+4>>2]=c[gb+68>>2];c[C+8>>2]=c[mb+68>>2];c[C+12>>2]=c[ob+68>>2];I=ea(g[a+140>>2]);eb=ea(g[a+144>>2]);_a=ea(g[l+8800>>2]);if((Sn[c[501448+(d<<2)>>2]&3](v,N,w,x,y,z,A,B,C,K,I,eb,_a,l+316|0,d)|0)==1){rb=b[za>>1]|0;break}else{ib=hb;jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}}else rb=H;while(0);if(!(rb<<16>>16)){ib=hb;jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}rb=501432+(d<<2)|0;H=a+140|0;C=a+144|0;a=l+8800|0;B=l+316|0;l=hb;A=0;while(1){z=(c[F>>2]|0)+A|0;y=D+(z<<5)|0;x=D+(z<<5)+16|0;w=c[x>>2]|0;v=w+16|0;if((b[D+(z<<5)+8>>1]|0)==-1)sb=h+(e[D+(z<<5)+10>>1]<<6)|0;else sb=h;if((b[D+(z<<5)+12>>1]|0)==-1)tb=h+(e[D+(z<<5)+14>>1]<<6)|0;else tb=h;K=ea(g[J>>2]);_a=ea(g[H>>2]);eb=ea(g[C>>2]);I=ea(g[a>>2]);en[c[rb>>2]&3](v,N,0,0,y,c[y>>2]|0,c[D+(z<<5)+4>>2]|0,sb,tb,c[w+80>>2]|0,c[w+84>>2]|0,K,_a,eb,I,B,d)|0;b[D+(z<<5)+26>>1]=(c[w+20>>2]|0)>>>4;c[x>>2]=c[v>>2];if(!(b[w+114>>1]&16)){ub=0;vb=0}else{ub=(c[w+44>>2]|0)+((c[w+48>>2]|0)+15&-16)|0;vb=b[w+36>>1]|0}c[D+(z<<5)+20>>2]=ub;b[D+(z<<5)+24>>1]=vb;z=(e[w+32>>1]|0)+l|0;A=A+1|0;if(A>>>0>=(e[za>>1]|0)>>>0){ib=z;break}else l=z}jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}else{ib=hb;jb=c[L>>2]|0;kb=jb+224|0;lb=c[kb>>2]|0;BTa(lb,S);c[G>>2]=ib;i=k;return}}function Kta(a){a=a|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im;d=i;i=i+144|0;e=d;f=a+24|0;h=c[f>>2]|0;j=c[h+8952>>2]|0;k=c[h+9148>>2]|0;c[h+9184>>2]=0;h=c[f>>2]|0;if((c[h+9188>>2]&2147483647)>>>0<k>>>0){X$a(h+9180|0,k);l=c[f>>2]|0}else l=h;c[l+9184>>2]=k;l=c[f>>2]|0;h=0;m=0;do{h=(c[l+(m<<2)+8816>>2]|0)+h|0;c[e+(m<<2)>>2]=h;m=m+1|0}while((m|0)!=33);m=0;h=0;l=c[e>>2]|0;n=0;a:while(1){if(h>>>0<32){o=m;p=n}else{q=m;r=n;s=16;break}do{if(o>>>0>=j>>>0){t=p;break a}u=p;p=p+1|0;v=c[(c[f>>2]|0)+9180>>2]|0;c[v+(u<<3)>>2]=o;w=l-o|0;x=w>>>0<4?w:4;w=c[(c[f>>2]|0)+9168>>2]|0;b:do if(((b[w+(o<<5)+8>>1]|0)==-1?(b[w+(o<<5)+12>>1]|0)==-1:0)?(y=b[w+(o<<5)+26>>1]|0,(y+-1<<16>>16&65535)<2&x>>>0>1):0){z=1;A=1;while(1){B=z+o|0;if(y<<16>>16!=(b[w+(B<<5)+26>>1]|0)){C=A;break b}if((b[w+(B<<5)+8>>1]|0)!=-1){C=A;break b}D=A+1<<16>>16;if((b[w+(B<<5)+12>>1]|0)!=-1){C=A;break b}z=D&65535;if(z>>>0>=x>>>0){C=D;break}else A=D}}else C=1;while(0);b[v+(u<<3)+4>>1]=C;o=(C&65535)+o|0}while((l|0)!=(o|0));x=h+1|0;w=l;h=x;l=c[e+(x<<2)>>2]|0;n=p;m=w}c:do if((s|0)==16)while(1){s=0;if(q>>>0>=j>>>0){t=r;break c}m=c[(c[f>>2]|0)+9180>>2]|0;c[m+(r<<3)>>2]=q;b[m+(r<<3)+4>>1]=1;q=q+1|0;r=r+1|0;s=16}while(0);if((k|0)==(j|0))E=t;else{s=t+k|0;r=k-j|0;k=0;q=t;while(1){m=c[(c[f>>2]|0)+9180>>2]|0;c[m+(q<<3)>>2]=k+j;b[m+(q<<3)+4>>1]=1;m=k+1|0;if((m|0)==(r|0))break;k=m;q=q+1|0}E=s-j|0}c[(c[f>>2]|0)+9184>>2]=E;c[(c[f>>2]|0)+9252>>2]=t;c[(c[f>>2]|0)+9256>>2]=E-t;t=c[(c[f>>2]|0)+9168>>2]|0;s=E>>>4;E=s+1|0;q=c[a+8>>2]|0;k=mo[c[(c[q>>2]|0)+16>>2]&4095](q)|0;q=mo[c[(c[k>>2]|0)+4>>2]&4095](k)|0;k=q>>>0<E>>>0?q:E;E=a+20|0;r=c[E>>2]|0;if(k>>>0<=1){m=c[f>>2]|0;Jta(r,c[m+8776>>2]|0,0,c[r+112>>2]|0,0,0,m);i=d;return}m=c[(c[r+96>>2]|0)+6732>>2]|0;oTa(c[m>>2]|0);r=vXa(m,4,16)|0;pTa(c[m>>2]|0);c[r>>2]=0;m=c[(c[(c[E>>2]|0)+96>>2]|0)+6732>>2]|0;oTa(c[m>>2]|0);p=vXa(m,(k*68|0)+-68|0,16)|0;pTa(c[m>>2]|0);m=a+12|0;a=~q;q=-2-s|0;s=~(q>>>0<a>>>0?a:q);q=1;do{a=q+-1|0;k=p+(a*68|0)|0;if(!k){F=p+(a*68|0)+12|0;G=p+(a*68|0)+16|0}else{n=c[f>>2]|0;e=c[n+8776>>2]|0;l=c[E>>2]|0;H=ea(g[l+124>>2]);I=ea(g[l+128>>2]);J=ea(g[l+140>>2]);K=ea(g[l+144>>2]);h=c[l+112>>2]|0;o=c[l+96>>2]|0;b[p+(a*68|0)+4>>1]=-1;b[p+(a*68|0)+6>>1]=0;c[p+(a*68|0)+8>>2]=0;c[k>>2]=443968;l=p+(a*68|0)+12|0;c[l>>2]=0;C=p+(a*68|0)+16|0;c[C>>2]=0;c[k>>2]=490704;c[p+(a*68|0)+20>>2]=e;g[p+(a*68|0)+24>>2]=I;g[p+(a*68|0)+28>>2]=H;g[p+(a*68|0)+32>>2]=J;g[p+(a*68|0)+36>>2]=K;c[p+(a*68|0)+40>>2]=j;c[p+(a*68|0)+44>>2]=t;c[p+(a*68|0)+48>>2]=h;c[p+(a*68|0)+52>>2]=r;c[p+(a*68|0)+56>>2]=n+9268;c[p+(a*68|0)+60>>2]=n;c[p+(a*68|0)+64>>2]=o;F=l;G=C}C=c[m>>2]|0;c[G>>2]=1;c[F>>2]=C;if(C){ko[c[(c[C>>2]|0)+16>>2]&4095](C);c[p+(a*68|0)+8>>2]=c[(c[F>>2]|0)+8>>2]}ko[c[(c[k>>2]|0)+20>>2]&4095](k);q=q+1|0}while((q|0)!=(s|0));s=c[f>>2]|0;f=c[E>>2]|0;K=ea(g[f+124>>2]);J=ea(g[f+128>>2]);H=ea(g[f+140>>2]);I=ea(g[f+144>>2]);Ita(c[s+8776>>2]|0,0,c[f+112>>2]|0,0,s,r,K,J,H,I,c[f+96>>2]|0,s+9268|0)|0;i=d;return}function Lta(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=Im,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=0;f=i;i=i+48|0;h=f+24|0;j=f+12|0;k=f;l=c[a+12>>2]|0;m=(l&1|0)==0;n=ea(g[a>>2]);g[h>>2]=n;o=h+4|0;p=a+4|0;q=ea(g[p>>2]);g[o>>2]=q;r=h+8|0;s=a+8|0;t=ea(g[s>>2]);g[r>>2]=t;if(d){g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0)}else{g[j>>2]=ea(g[a+32>>2]);g[j+4>>2]=ea(g[a+36>>2]);g[j+8>>2]=ea(g[a+40>>2])}if(!(l&2)){if(m){i=f;return}m=a+28|0;u=ea(g[m>>2]);if(u<ea(3.0)){l=ea(u+ea(-1.5))>=ea(0.0);v=l?ea(.5):ea(1.0)}else v=ea(ea(1.0)/u);u=ea(v*ea(g[a+16>>2]));w=ea(v*ea(g[a+20>>2]));x=ea(v*ea(g[a+24>>2]));g[a+64>>2]=u;g[a+68>>2]=w;g[a+72>>2]=x;l=a+32|0;x=ea(v*ea(g[l>>2]));d=a+36|0;w=ea(v*ea(g[d>>2]));y=a+40|0;u=ea(v*ea(g[y>>2]));g[j>>2]=x;g[j+4>>2]=w;g[j+8>>2]=u;g[l>>2]=x;g[d>>2]=w;g[y>>2]=u;if(!(v==ea(1.0))){v=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(q*q))+ea(t*t)))));u=ea(n*v);n=ea(q*v);q=ea(t*v);g[h>>2]=u;g[o>>2]=n;g[r>>2]=q;g[a>>2]=u;g[p>>2]=n;g[s>>2]=q}g[m>>2]=ea(0.0)}else{g[a+64>>2]=ea(g[a+16>>2]);g[a+68>>2]=ea(g[a+20>>2]);g[a+72>>2]=ea(g[a+24>>2])}m=a+80|0;y0a(k,m,m,h,j,c[a+76>>2]|0,e);if(b?(c[a+108>>2]|0)!=0:0){q=ea(g[m>>2]);n=ea(q-ea(g[k>>2]));q=ea(g[a+84>>2]);u=ea(q-ea(g[k+4>>2]));q=ea(g[a+88>>2]);v=ea(q-ea(g[k+8>>2]));g[a+96>>2]=n;g[a+100>>2]=u;g[a+104>>2]=v}g[m>>2]=ea(g[k>>2]);g[a+84>>2]=ea(g[k+4>>2]);g[a+88>>2]=ea(g[k+8>>2]);i=f;return}function Mta(a,d){a=a|0;d=d|0;c[a+96>>2]=d;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=0;c[a+144>>2]=0;c[a+148>>2]=0;c[a+152>>2]=0;c[a+188>>2]=0;c[a+192>>2]=0;c[a+196>>2]=0;c[a+232>>2]=0;c[a+236>>2]=0;c[a+240>>2]=0;c[a+276>>2]=0;c[a+280>>2]=0;c[a+284>>2]=0;c[a+320>>2]=0;c[a+324>>2]=0;c[a+328>>2]=0;c[a+364>>2]=0;c[a+368>>2]=0;c[a+372>>2]=0;c[a+408>>2]=0;c[a+412>>2]=0;c[a+416>>2]=0;d=a+452|0;b[a+456>>1]=-1;b[a+458>>1]=0;c[a+460>>2]=0;c[d>>2]=443968;c[a+464>>2]=0;c[a+468>>2]=0;c[d>>2]=492008;c[a+472>>2]=a;c[a+476>>2]=491872;return}function Nta(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a+452>>2]=443968;c[a+460>>2]=0;d=a+100|0;e=a+452|0;do{a=c[e+-36>>2]|0;e=e+-44|0;if(((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0)?(f=a+(0-(c[a+-4>>2]|0))|0,(f|0)!=0):0){a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,f)}}while((e|0)!=(d|0));i=b;return}function Ota(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;h=a+452|0;c[a+468>>2]=1;j=a+464|0;c[j>>2]=e;if(e){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[a+460>>2]=c[(c[j>>2]|0)+8>>2]}j=a+96|0;e=(c[(c[j>>2]|0)+40>>2]|0)>>>3;k=d+(c[d+4>>2]|0)|0;l=d+8|0;d=0;m=0;n=e>>>0<128?128:e;while(1){g[a+(d*44|0)+120>>2]=ea(8507058669999999534545717.0e13);g[a+(d*44|0)+124>>2]=ea(8507058669999999534545717.0e13);g[a+(d*44|0)+128>>2]=ea(8507058669999999534545717.0e13);g[a+(d*44|0)+132>>2]=ea(-8507058669999999534545717.0e13);g[a+(d*44|0)+136>>2]=ea(-8507058669999999534545717.0e13);g[a+(d*44|0)+140>>2]=ea(-8507058669999999534545717.0e13);n=(d|0)==7?-1:n;if((n|0)!=0&(l|0)!=(k|0)){e=l;o=0;do{p=e;e=e+(c[e+4>>2]<<4|8)|0;o=(c[(c[(c[p>>2]|0)+44>>2]|0)+8>>2]|0)+o|0}while(o>>>0<n>>>0&(e|0)!=(k|0));if(!o){q=e;r=m}else{c[a+(d*44|0)+112>>2]=l;c[a+(d*44|0)+116>>2]=e;q=e;r=m+1|0}}else{q=l;r=m}d=d+1|0;if((d|0)==8)break;else{l=q;m=r}}if(!r){s=c[h>>2]|0;t=s+20|0;u=c[t>>2]|0;ko[u&4095](h);i=f;return}m=0;do{q=c[(c[(c[j>>2]|0)+4>>2]|0)+6732>>2]|0;oTa(c[q>>2]|0);l=vXa(q,28,16)|0;pTa(c[q>>2]|0);if(!l)v=0;else{b[l+4>>1]=-1;b[l+6>>1]=0;c[l+8>>2]=0;c[l>>2]=443968;c[l+12>>2]=0;c[l+16>>2]=0;c[l>>2]=492184;c[l+20>>2]=a;c[l+24>>2]=m;v=l}c[v+16>>2]=1;l=v+12|0;c[l>>2]=h;ko[c[(c[h>>2]|0)+16>>2]&4095](h);c[v+8>>2]=c[(c[l>>2]|0)+8>>2];ko[c[(c[v>>2]|0)+20>>2]&4095](v);m=m+1|0}while((m|0)!=(r|0));s=c[h>>2]|0;t=s+20|0;u=c[t>>2]|0;ko[u&4095](h);i=f;return}function Pta(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=a+(b*44|0)+100|0;h=c[a+(b*44|0)+112>>2]|0;j=a+(b*44|0)+116|0;k=c[j>>2]|0;if((h|0)==(k|0)){i=e;return}l=f+4|0;m=f+8|0;n=a+(b*44|0)+104|0;o=a+96|0;p=a+(b*44|0)+120|0;b=h;h=k;while(1){c[f>>2]=c[b>>2];k=c[b+4>>2]|0;c[l>>2]=k;q=b+8|0;c[m>>2]=q;b=b+(k<<4|8)|0;if(k>>>0<d>>>0)r=h;else{c[n>>2]=0;if(k){s=0;do{z0a(0,g,q+(s<<4)|0);s=s+1|0}while(s>>>0<k>>>0)}k=c[o>>2]|0;s=c[k+8>>2]|0;Qta(a,c[s+48>>2]|0,c[k+20>>2]|0,c[k+64>>2]|0,c[k+68>>2]|0,k+44|0,c[k+60>>2]|0,p,c[k+36>>2]|0,c[s+52>>2]|0,c[g>>2]|0,f);r=c[j>>2]|0}if((b|0)==(r|0))break;else h=r}i=e;return}function Qta(d,f,h,j,k,l,m,n,o,p,q,r){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;s=i;i=i+576|0;t=s;u=s+8|0;v=s+552|0;w=s+532|0;x=s+520|0;y=c[(c[r>>2]|0)+44>>2]|0;z=c[y+8>>2]|0;A=c[y+12>>2]|0;B=t+4|0;a[B>>0]=1;C=sKa(s+560|0,4096,491904,282)|0;c[t>>2]=C;D=v+4|0;a[D>>0]=1;E=sKa(s+561|0,4608,491904,289)|0;c[v>>2]=E;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;a[w+16>>0]=0;if(!m){c[w+4>>2]=E;c[w+12>>2]=E+512;F=ea(b[y>>1]|0);G=ea(b[y+2>>1]|0);H=ea(b[y+4>>1]|0);I=ea(g[d+44>>2]);J=ea(G*I);G=ea(H*I);g[x>>2]=ea(F*I);g[x+4>>2]=J;g[x+8>>2]=G;K=0}else K=E;if(z){E=(p|0)==0;y=r+8|0;L=r+4|0;r=w+16|0;M=d+48|0;N=C;C=(z+127&127)+1|0;O=0;while(1){P=O+A|0;Q=N;R=0;while(1){S=c[o+(R+P<<2)>>2]|0;g[Q+(R<<5)>>2]=ea(g[f+(S<<5)>>2]);g[Q+(R<<5)+4>>2]=ea(g[f+(S<<5)+4>>2]);g[Q+(R<<5)+8>>2]=ea(g[f+(S<<5)+8>>2]);g[Q+(R<<5)+12>>2]=ea(g[f+(S<<5)+12>>2]);g[Q+(R<<5)+16>>2]=ea(g[f+(S<<5)+16>>2]);g[Q+(R<<5)+20>>2]=ea(g[f+(S<<5)+20>>2]);g[Q+(R<<5)+24>>2]=ea(g[f+(S<<5)+24>>2]);T=Q+(R<<5)+28|0;U=f+(S<<5)+28|0;S=e[U>>1]|e[U+2>>1]<<16;b[T>>1]=S;b[T+2>>1]=S>>>16;S=R+1|0;if(S>>>0>=C>>>0)break;Q=c[t>>2]|0;R=S}R=o+(P<<2)|0;if(E){G=ea(g[M>>2]);Q=0;do{g[u+(Q<<2)>>2]=G;Q=Q+1|0}while(Q>>>0<C>>>0)}else{Q=0;do{g[u+(Q<<2)>>2]=ea(g[p+(c[o+(Q+P<<2)>>2]<<2)>>2]);Q=Q+1|0}while(Q>>>0<C>>>0)}A0a(d,c[t>>2]|0,h,j,k,l,K,m,w,n,x,R,C,c[y>>2]|0,q,c[L>>2]|0,u);N=c[t>>2]|0;Q=0;do{S=c[o+(Q+P<<2)>>2]|0;g[f+(S<<5)>>2]=ea(g[N+(Q<<5)>>2]);g[f+(S<<5)+4>>2]=ea(g[N+(Q<<5)+4>>2]);g[f+(S<<5)+8>>2]=ea(g[N+(Q<<5)+8>>2]);g[f+(S<<5)+12>>2]=ea(g[N+(Q<<5)+12>>2]);g[f+(S<<5)+16>>2]=ea(g[N+(Q<<5)+16>>2]);g[f+(S<<5)+20>>2]=ea(g[N+(Q<<5)+20>>2]);g[f+(S<<5)+24>>2]=ea(g[N+(Q<<5)+24>>2]);T=f+(S<<5)+28|0;S=N+(Q<<5)+28|0;U=e[S>>1]|e[S+2>>1]<<16;b[T>>1]=U;b[T+2>>1]=U>>>16;Q=Q+1|0}while(Q>>>0<C>>>0);a[r>>0]=0;O=O+C|0;if(O>>>0>=z>>>0)break;else C=128}}if(a[D>>0]|0)tKa(v,c[v>>2]|0);if(!(a[B>>0]|0)){i=s;return}tKa(t,c[t>>2]|0);i=s;return}function Rta(f,h,j,k,l,m,n,o,p,q){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=0,M=Im,N=Im,O=Im,P=Im,Q=0,R=Im,S=Im,T=0,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;r=i;i=i+64|0;s=r+32|0;t=r+24|0;u=r+61|0;v=r+16|0;w=r+60|0;x=r;y=c[p+4>>2]|0;z=y+36|0;if(!(a[p+13>>0]|0))A=0;else A=c[p>>2]|0;B=q+28|0;C=q+44|0;D=ea(g[C>>2]);E=q+48|0;F=ea(g[E>>2]);G=q+52|0;H=ea(g[G>>2]);I=ea(D*ea(-2.0));J=ea(F*ea(-2.0));K=ea(H*ea(-2.0));L=q+40|0;M=ea(g[L>>2]);N=ea(ea(M*M)+ea(-.5));O=ea(g[B>>2]);P=ea(I*O);Q=q+32|0;R=ea(g[Q>>2]);S=ea(P+ea(J*R));T=q+36|0;P=ea(g[T>>2]);U=ea(S+ea(K*P));S=ea(ea(O*U)+ea(ea(I*N)-ea(M*ea(ea(K*R)-ea(J*P)))));V=ea(ea(R*U)+ea(ea(J*N)-ea(M*ea(ea(I*P)-ea(K*O)))));W=ea(ea(ea(K*N)-ea(M*ea(ea(J*O)-ea(I*R))))+ea(P*U));U=ea(-R);I=ea(-P);g[s>>2]=ea(-O);g[s+4>>2]=U;g[s+8>>2]=I;g[s+12>>2]=M;g[s+16>>2]=S;g[s+20>>2]=V;g[s+24>>2]=W;X=(j|0)==0;a:do if(!X){Y=q+12|0;Z=q+4|0;_=q+8|0;$=q+16|0;aa=q+20|0;ba=q+24|0;ca=l+4|0;W=D;V=F;S=H;I=M;U=O;J=R;N=P;da=0;while(1){c[k+(da*176|0)+124>>2]=c[k+(da*176|0)+12>>2]&2;K=ea(ea(g[k+(da*176|0)+64>>2])*ea(2.0));fa=ea(ea(g[k+(da*176|0)+68>>2])*ea(2.0));ga=ea(ea(g[k+(da*176|0)+72>>2])*ea(2.0));ha=ea(ea(I*I)+ea(-.5));ia=ea(ea(ea(K*U)+ea(fa*J))+ea(ga*N));ja=ea(V+ea(ea(J*ia)+ea(ea(fa*ha)+ea(I*ea(ea(K*N)-ea(ga*U))))));ka=ea(S+ea(ea(ea(ga*ha)+ea(I*ea(ea(fa*U)-ea(K*J))))+ea(N*ia)));g[k+(da*176|0)+128>>2]=ea(W+ea(ea(U*ia)+ea(ea(K*ha)+ea(I*ea(ea(ga*J)-ea(fa*N))))));g[k+(da*176|0)+132>>2]=ja;g[k+(da*176|0)+136>>2]=ka;ka=ea(ea(g[k+(da*176|0)+48>>2])*ea(2.0));ja=ea(ea(g[k+(da*176|0)+52>>2])*ea(2.0));fa=ea(ea(g[k+(da*176|0)+56>>2])*ea(2.0));ga=ea(g[Y>>2]);ha=ea(ea(ga*ga)+ea(-.5));K=ea(g[q>>2]);ia=ea(ka*K);la=ea(g[Z>>2]);ma=ea(ia+ea(ja*la));ia=ea(g[_>>2]);na=ea(ma+ea(fa*ia));ma=ea(ea(K*na)+ea(ea(ka*ha)+ea(ga*ea(ea(fa*la)-ea(ja*ia)))));oa=ea(ea(la*na)+ea(ea(ja*ha)+ea(ga*ea(ea(ka*ia)-ea(fa*K)))));pa=ea(ea(ea(fa*ha)+ea(ga*ea(ea(ja*K)-ea(ka*la))))+ea(ia*na));na=ea(ea(g[$>>2])+ma);ma=ea(ea(g[aa>>2])+oa);oa=ea(ea(g[ba>>2])+pa);g[k+(da*176|0)+112>>2]=na;g[k+(da*176|0)+116>>2]=ma;g[k+(da*176|0)+120>>2]=oa;qa=c[k+(da*176|0)+76>>2]|0;c[k+(da*176|0)+140>>2]=(c[l>>2]|0)+(qa<<4);c[k+(da*176|0)+156>>2]=(c[ca>>2]|0)+(qa<<4);g[k+(da*176|0)+144>>2]=ea(0.0);g[k+(da*176|0)+148>>2]=ea(0.0);g[k+(da*176|0)+152>>2]=ea(0.0);g[k+(da*176|0)+160>>2]=ea(0.0);g[k+(da*176|0)+164>>2]=ea(0.0);g[k+(da*176|0)+168>>2]=ea(0.0);qa=da+1|0;if((qa|0)==(j|0))break a;oa=ea(g[L>>2]);ma=ea(g[B>>2]);na=ea(g[Q>>2]);pa=ea(g[T>>2]);ia=ea(g[C>>2]);la=ea(g[E>>2]);W=ia;V=la;S=ea(g[G>>2]);I=oa;U=ma;J=na;N=pa;da=qa}}while(0);b:do switch(c[z>>2]|0){case 4:{G=d[(c[y+72>>2]|0)+39>>0]|0;E=G<<4;C=E>>>0>1024;T=t+4|0;a[T>>0]=C&1;if(C){C=sKa(u,E,491904,606)|0;c[t>>2]=C;ra=C}else{C=i;i=i+((16*G|0)+15&-16)|0;c[t>>2]=C;ra=C}Yta(ra,k,j,z,ea(g[f+52>>2]));if(!(a[T>>0]|0))sa=29;else{tKa(t,c[t>>2]|0);sa=29}break}case 1:{cua(k,j,z,ea(g[f+52>>2]));sa=29;break}case 2:{Vta(k,j,z,ea(g[f+52>>2]));sa=29;break}case 3:{Sta(k,j,z,ea(g[f+52>>2]));sa=29;break}case 0:{dua(k,j,z,ea(g[f+52>>2]));sa=29;break}case 5:{if(m){P=ea(g[f+28>>2]);R=ea(g[f+60>>2]);aua(j,k,m,z,B,s,P,R,ea(g[f+52>>2]));sa=27;break b}T=n+16|0;if(!(a[T>>0]|0)){C=j<<2;G=C>>>0>1024;E=v+4|0;a[E>>0]=G&1;if(G){G=sKa(w,C,491904,622)|0;c[v>>2]=G;ta=G}else{G=i;i=i+((1*C|0)+15&-16)|0;c[v>>2]=G;ta=G}R=ea(g[f+32>>2]);G=j+1|0;C=G>>>1|G;G=C>>>2|C;C=G>>>4|G;G=C>>>8|C;C=(G>>>16|G)+1|0;G=C>>>0>256?256:C;wua(h,j,c[n+12>>2]|0,c[n+4>>2]|0,ta,G,R,o);c[n+8>>2]=G;c[n>>2]=j;a[T>>0]=1;if(a[E>>0]|0)tKa(v,c[v>>2]|0)}$ta(k,n,z,B,s,ea(g[f+28>>2]),ea(g[f+60>>2]),ea(g[f+52>>2]),o);sa=27;break}case 6:{bua(k,j,z,ea(g[f+52>>2]),s);sa=27;break}default:sa=29}while(0);c:do if((sa|0)==27){if(!X){z=0;do{B0a(k+(z*176|0)|0,s,ea(0.0));z=z+1|0}while((z|0)!=(j|0))}}else if((sa|0)==29){if(!A){if(X)break;else ua=0;while(1){D0a(k+(ua*176|0)|0,s,ea(0.0));ua=ua+1|0;if((ua|0)==(j|0))break c}}if(!X){z=l+8|0;o=l+12|0;B=A+64|0;n=A+80|0;v=f+64|0;ta=0;do{h=c[z>>2]|0;if(!h)va=x;else va=h+(c[k+(ta*176|0)+76>>2]<<4)|0;h=c[o>>2]|0;if(!h)wa=x;else wa=h+(c[k+(ta*176|0)+76>>2]<<4)|0;c[va+0>>2]=0;c[va+4>>2]=0;c[va+8>>2]=0;c[va+12>>2]=0;c[wa+0>>2]=0;c[wa+4>>2]=0;c[wa+8>>2]=0;c[wa+12>>2]=0;C0a(k+(ta*176|0)|0,A,B,n,A,s,ea(g[v>>2]),va,wa);ta=ta+1|0}while((ta|0)!=(j|0))}}while(0);if((a[p+12>>0]|0)==0|X){i=r;return}else xa=0;do{if(c[k+(xa*176|0)+124>>2]&56){X=k+(xa*176|0)+60|0;b[X>>1]=e[X>>1]|8}xa=xa+1|0}while((xa|0)!=(j|0));i=r;return}function Sta(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+416|0;h=f+320|0;j=f;k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);m=ea(g[d+12>>2]);n=ea(ea(k*ea(-1.0))-e);o=ea(ea(m*ea(-1.0))-e);p=ea(l+e);q=ea(ea(l*ea(-1.0))-e);r=ea(k+e);s=ea(m+e);g[h>>2]=ea(1.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);t=ea(-k);g[h+12>>2]=t;g[h+16>>2]=ea(-1.0);g[h+20>>2]=ea(0.0);g[h+24>>2]=ea(0.0);g[h+28>>2]=t;g[h+32>>2]=ea(0.0);g[h+36>>2]=ea(1.0);g[h+40>>2]=ea(0.0);t=ea(-l);g[h+44>>2]=t;g[h+48>>2]=ea(0.0);g[h+52>>2]=ea(-1.0);g[h+56>>2]=ea(0.0);g[h+60>>2]=t;g[h+64>>2]=ea(0.0);g[h+68>>2]=ea(0.0);g[h+72>>2]=ea(1.0);t=ea(-m);g[h+76>>2]=t;g[h+80>>2]=ea(0.0);g[h+84>>2]=ea(0.0);g[h+88>>2]=ea(-1.0);g[h+92>>2]=t;if(!b){i=f;return}d=b+-1|0;u=0;v=0;while(1){t=ea(g[a+(u*176|0)+112>>2]);m=ea(g[a+(u*176|0)+128>>2]);l=ea(g[a+(u*176|0)+116>>2]);k=ea(g[a+(u*176|0)+132>>2]);w=ea(g[a+(u*176|0)+120>>2]);x=ea(g[a+(u*176|0)+136>>2]);if(!((w<x?w:x)>s)&(((n>(t>m?t:m)?1:(t<m?t:m)>r)|q>(l>k?l:k)|(l<k?l:k)>p|o>(w>x?w:x))^1)){g[j+(v<<4)+16>>2]=t;g[j+(v<<4)+20>>2]=l;g[j+(v<<4)+24>>2]=w;g[j+(v<<4)+28>>2]=ea(0.0);g[j+(v<<4)+80>>2]=m;g[j+(v<<4)+84>>2]=k;g[j+(v<<4)+88>>2]=x;g[j+(v<<4)+92>>2]=ea(0.0);c[j+(v<<2)+160>>2]=c[a+(u*176|0)+124>>2];g[j+(v<<2)+144>>2]=ea(g[a+(u*176|0)+92>>2]);g[j+(v<<2)+176>>2]=ea(g[a+(u*176|0)+44>>2]);c[j+(v<<2)>>2]=a+(u*176|0);y=v+1|0}else y=v;if((y|0)==4){Wta(j,h,6,e);z=0;do{A=c[j+(z<<2)>>2]|0;B=c[j+(z<<2)+160>>2]|0;if(B){C=A+124|0;c[C>>2]=c[C>>2]|B;g[A+44>>2]=ea(g[j+(z<<2)+176>>2]);g[A+144>>2]=ea(g[j+(z<<4)+192>>2]);g[A+148>>2]=ea(g[j+(z<<4)+196>>2]);g[A+152>>2]=ea(g[j+(z<<4)+200>>2]);g[A+160>>2]=ea(g[j+(z<<4)+256>>2]);g[A+164>>2]=ea(g[j+(z<<4)+260>>2]);g[A+168>>2]=ea(g[j+(z<<4)+264>>2])}z=z+1|0}while((z|0)!=4);D=0}else if(y)if((u|0)==(d|0))if(!y)D=0;else{z=0;do{Xta(c[j+(z<<2)>>2]|0,h,6,e);z=z+1|0}while((z|0)!=(y|0));D=y}else D=y;else D=0;u=u+1|0;if((u|0)==(b|0))break;else v=D}i=f;return}function Tta(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;h=i;j=a+124|0;k=c[j>>2]|0;if(k&2){i=h;return}l=ea(g[b>>2]);m=ea(g[d>>2]);n=ea(-m);o=l>n?l:n;n=o<m?o:m;m=ea(l-n);l=ea(g[b+4>>2]);o=ea(g[b+8>>2]);b=a+144|0;g[b>>2]=m;d=a+148|0;g[d>>2]=l;p=a+152|0;g[p>>2]=o;q=ea(T(ea(ea(o*o)+ea(ea(m*m)+ea(l*l)))));r=ea(g[e>>2]);if(!(q<ea(r+ea(g[f>>2])))){i=h;return}if(q!=ea(0.0)){r=ea(ea(1.0)/q);s=ea(m*r);g[b>>2]=s;m=ea(r*l);g[d>>2]=m;t=s;u=m;v=ea(r*o)}else{g[b>>2]=ea(0.0);g[d>>2]=ea(0.0);t=ea(0.0);u=ea(0.0);v=ea(0.0)}g[p>>2]=v;o=ea(g[e>>2]);r=ea(g[a+92>>2]);m=ea(o+r);o=ea(ea(m*u)+ea(0.0));u=ea(ea(m*v)+ea(0.0));g[a+160>>2]=ea(n+ea(t*m));g[a+164>>2]=o;g[a+168>>2]=u;c[j>>2]=k|32;if(!(q<ea(ea(g[e>>2])+r))){i=h;return}c[j>>2]=k|48;i=h;return}function Uta(a,b,d,e,f,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0;o=i;p=ea(g[k>>2]);if(!(p<=ea(0.0))?(q=ea(g[l>>2]),!(q==ea(0.0))):0){r=ea(ea(-ea(ea(g[m>>2])+ea(T(ea(p)))))/q);if(r<ea(0.0)|r>ea(1.0)){Tta(a,d,f,h,n);i=o;return}m=a+44|0;if(!(r<ea(g[m>>2]))){i=o;return}q=ea(r*ea(g[e>>2]));p=ea(r*ea(g[e+4>>2]));s=ea(r*ea(g[e+8>>2]));t=ea(q+ea(g[b>>2]));e=b+4|0;q=ea(p+ea(g[e>>2]));l=b+8|0;p=ea(s+ea(g[l>>2]));k=a+144|0;g[k>>2]=t;u=a+148|0;g[u>>2]=q;v=a+152|0;g[v>>2]=p;s=ea(t-ea(g[j>>2]));g[k>>2]=s;t=ea(ea(1.0)/ea(g[h>>2]));g[k>>2]=ea(s*t);g[u>>2]=ea(t*q);g[v>>2]=ea(t*p);g[a+160>>2]=ea(g[b>>2]);g[a+164>>2]=ea(g[e>>2]);g[a+168>>2]=ea(g[l>>2]);g[m>>2]=r;m=a+124|0;c[m>>2]=c[m>>2]|8;i=o;return}Tta(a,d,f,h,n);i=o;return}function Vta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0,f=0;e=i;if(!b){i=e;return}else f=0;do{E0a(a+(f*176|0)|0,c,d);f=f+1|0}while((f|0)!=(b|0));i=e;return}function Wta(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=Im,Ke=Im,Le=Im,Me=Im,Ne=Im,Oe=Im,Pe=Im,Qe=Im,Re=Im,Se=Im,Te=Im,Ue=Im,Ve=Im,We=Im,Xe=Im,Ye=Im,Ze=Im,_e=Im,$e=Im,af=Im,bf=Im,cf=Im,df=Im,ef=Im,ff=Im,gf=Im,hf=Im,jf=Im,kf=Im,lf=Im,mf=Im,nf=Im,of=Im,pf=Im,qf=Im,rf=Im,sf=Im,tf=Im,uf=Im,vf=Im,wf=0,xf=0,yf=0,zf=0,Af=Im,Bf=Im,Cf=Im,Df=Im,Ef=Im,Ff=Im,Gf=Im,Hf=Im,If=Im,Jf=Im,Kf=Im,Lf=Im,Mf=Im,Nf=Im,Of=Im,Pf=Im,Qf=Im,Rf=Im,Sf=Im,Tf=Im,Uf=Im,Vf=Im,Wf=Im,Xf=Im,Yf=0,Zf=0,_f=Im,$f=Im,ag=Im,bg=Im,cg=Im,dg=Im,eg=Im,fg=Im,gg=Im,hg=Im,ig=Im,jg=Im,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0;f=i;i=i+1312|0;h=f+640|0;j=f+576|0;k=f;l=f+32|0;m=f+48|0;n=f+1136|0;o=f+1264|0;p=f+624|0;q=f+112|0;r=f+128|0;s=f+144|0;t=f+160|0;u=f+176|0;v=f+192|0;w=f+208|0;x=f+224|0;y=f+240|0;z=f+256|0;A=f+272|0;B=f+288|0;C=f+304|0;D=f+320|0;E=f+336|0;F=f+352|0;G=f+368|0;H=f+384|0;I=f+400|0;J=f+416|0;K=f+432|0;L=f+448|0;M=f+464|0;N=f+480|0;O=f+496|0;P=f+512|0;Q=f+528|0;R=f+1120|0;S=f+1152|0;T=f+1184|0;U=f+1216|0;V=f+1248|0;W=f+1280|0;X=f+1296|0;Y=f+656|0;Z=f+672|0;_=f+688|0;$=f+704|0;aa=f+720|0;ba=f+736|0;ca=f+752|0;da=f+768|0;fa=f+784|0;ga=f+800|0;ha=f+816|0;ia=f+832|0;ja=f+848|0;ka=f+864|0;la=f+880|0;ma=f+896|0;na=f+912|0;oa=f+928|0;pa=f+944|0;qa=f+960|0;ra=f+976|0;sa=f+992|0;ta=f+1008|0;ua=f+1024|0;va=f+1040|0;wa=f+1056|0;xa=f+1072|0;ya=f+1088|0;za=f+80|0;Aa=f+16|0;Ba=f+64|0;Ca=f+1104|0;Da=f+544|0;Ea=f+560|0;Fa=f+1168|0;Ga=f+592|0;Ha=f+1200|0;Ia=f+96|0;Ja=f+608|0;Ka=f+1232|0;La=a+80|0;Ma=ea(g[La>>2]);Na=ea(g[La+4>>2]);Oa=ea(g[La+8>>2]);Pa=ea(g[La+12>>2]);La=a+16|0;Qa=ea(g[La>>2]);Ra=ea(g[La+4>>2]);Sa=ea(g[La+8>>2]);Ta=ea(g[La+12>>2]);La=a+96|0;Ua=ea(g[La>>2]);Va=ea(g[La+4>>2]);Wa=ea(g[La+8>>2]);Xa=ea(g[La+12>>2]);La=a+32|0;Ya=ea(g[La>>2]);Za=ea(g[La+4>>2]);_a=ea(g[La+8>>2]);$a=ea(g[La+12>>2]);La=a+112|0;ab=ea(g[La>>2]);bb=ea(g[La+4>>2]);cb=ea(g[La+8>>2]);db=ea(g[La+12>>2]);La=a+48|0;eb=ea(g[La>>2]);fb=ea(g[La+4>>2]);gb=ea(g[La+8>>2]);hb=ea(g[La+12>>2]);La=a+128|0;ib=ea(g[La>>2]);jb=ea(g[La+4>>2]);kb=ea(g[La+8>>2]);lb=ea(g[La+12>>2]);La=a+64|0;mb=ea(g[La>>2]);nb=ea(g[La+4>>2]);ob=ea(g[La+8>>2]);pb=ea(g[La+12>>2]);qb=ea(Ma-Qa);rb=ea(Na-Ra);sb=ea(Oa-Sa);tb=ea(Ua-Ya);ub=ea(Va-Za);vb=ea(Wa-_a);wb=ea(ab-eb);xb=ea(bb-fb);yb=ea(cb-gb);zb=ea(ib-mb);Ab=ea(jb-nb);Bb=ea(kb-ob);if(!d){Cb=ea(-3402823469999999843913219.0e14);Db=ea(-3402823469999999843913219.0e14);Eb=ea(-3402823469999999843913219.0e14);Fb=ea(-3402823469999999843913219.0e14);Gb=ea(3402823469999999843913219.0e14);Hb=ea(3402823469999999843913219.0e14);Ib=ea(3402823469999999843913219.0e14);Jb=ea(3402823469999999843913219.0e14);Kb=ea(-3402823469999999843913219.0e14);Lb=ea(-3402823469999999843913219.0e14);Mb=ea(-3402823469999999843913219.0e14);Nb=ea(-3402823469999999843913219.0e14);Ob=ea(-3402823469999999843913219.0e14);Pb=ea(-3402823469999999843913219.0e14);Qb=ea(-3402823469999999843913219.0e14);Rb=ea(-3402823469999999843913219.0e14);Sb=ea(0.0);Tb=ea(0.0);Ub=ea(0.0);Vb=ea(0.0);Wb=ea(0.0);Xb=ea(0.0);Yb=ea(0.0);Zb=ea(0.0);_b=ea(0.0);$b=ea(0.0);ac=ea(0.0);bc=ea(0.0);cc=ea(0.0);dc=ea(0.0);ec=ea(0.0);fc=ea(0.0);gc=ea(0.0);hc=ea(0.0);ic=ea(0.0);jc=ea(0.0);kc=ea(0.0);lc=ea(0.0);mc=ea(0.0);nc=ea(0.0);oc=ea(0.0);pc=ea(0.0);qc=ea(0.0);rc=ea(0.0);sc=ea(0.0);tc=ea(0.0);uc=ea(0.0);vc=ea(0.0);wc=ea(0.0);xc=ea(0.0);yc=ea(0.0);zc=ea(0.0);Ac=ea(0.0);Bc=ea(0.0);Cc=ea(0.0);Dc=ea(0.0);Ec=ea(0.0);Fc=ea(0.0);Gc=ea(0.0);Hc=ea(0.0);Ic=ea(0.0);Jc=ea(0.0);Kc=ea(0.0);Lc=ea(0.0);Mc=1;Nc=1;Oc=1;Pc=1}else{La=j+4|0;Qc=j+8|0;Rc=j+12|0;Sc=h+4|0;Tc=h+8|0;Uc=h+12|0;Vc=l+4|0;Wc=l+8|0;Xc=l+12|0;Yc=k+4|0;Zc=k+8|0;_c=k+12|0;$c=n+4|0;ad=n+8|0;bd=n+12|0;cd=m+4|0;dd=m+8|0;ed=m+12|0;fd=p+4|0;gd=p+8|0;hd=p+12|0;id=o+4|0;jd=o+8|0;kd=o+12|0;ld=r+4|0;md=r+8|0;nd=r+12|0;od=q+4|0;pd=q+8|0;qd=q+12|0;rd=t+4|0;sd=t+8|0;td=t+12|0;ud=s+4|0;vd=s+8|0;wd=s+12|0;xd=v+4|0;yd=v+8|0;zd=v+12|0;Ad=u+4|0;Bd=u+8|0;Cd=u+12|0;Dd=x+4|0;Ed=x+8|0;Fd=x+12|0;Gd=w+4|0;Hd=w+8|0;Id=w+12|0;Jd=z+4|0;Kd=z+8|0;Ld=z+12|0;Md=y+4|0;Nd=y+8|0;Od=y+12|0;Pd=B+4|0;Qd=B+8|0;Rd=B+12|0;Sd=A+4|0;Td=A+8|0;Ud=A+12|0;Vd=D+4|0;Wd=D+8|0;Xd=D+12|0;Yd=C+4|0;Zd=C+8|0;_d=C+12|0;$d=F+4|0;ae=F+8|0;be=F+12|0;ce=E+4|0;de=E+8|0;ee=E+12|0;fe=H+4|0;ge=H+8|0;he=H+12|0;ie=G+4|0;je=G+8|0;ke=G+12|0;le=J+4|0;me=J+8|0;ne=J+12|0;oe=I+4|0;pe=I+8|0;qe=I+12|0;re=L+4|0;se=L+8|0;te=L+12|0;ue=K+4|0;ve=K+8|0;we=K+12|0;xe=N+4|0;ye=N+8|0;ze=N+12|0;Ae=M+4|0;Be=M+8|0;Ce=M+12|0;De=P+4|0;Ee=P+8|0;Fe=P+12|0;Ge=O+4|0;He=O+8|0;Ie=O+12|0;Je=ea(-3402823469999999843913219.0e14);Ke=ea(-3402823469999999843913219.0e14);Le=ea(-3402823469999999843913219.0e14);Me=ea(-3402823469999999843913219.0e14);Ne=ea(0.0);Oe=ea(0.0);Pe=ea(0.0);Qe=ea(0.0);Re=ea(0.0);Se=ea(0.0);Te=ea(0.0);Ue=ea(0.0);Ve=ea(0.0);We=ea(0.0);Xe=ea(0.0);Ye=ea(0.0);Ze=ea(0.0);_e=ea(0.0);$e=ea(0.0);af=ea(0.0);bf=ea(-3402823469999999843913219.0e14);cf=ea(-3402823469999999843913219.0e14);df=ea(-3402823469999999843913219.0e14);ef=ea(-3402823469999999843913219.0e14);ff=ea(0.0);gf=ea(0.0);hf=ea(0.0);jf=ea(0.0);kf=ea(0.0);lf=ea(0.0);mf=ea(0.0);nf=ea(0.0);of=ea(0.0);pf=ea(0.0);qf=ea(0.0);rf=ea(0.0);sf=ea(0.0);tf=ea(0.0);uf=ea(0.0);vf=ea(0.0);wf=0;xf=0;yf=0;zf=0;Af=ea(3402823469999999843913219.0e14);Bf=ea(3402823469999999843913219.0e14);Cf=ea(3402823469999999843913219.0e14);Df=ea(3402823469999999843913219.0e14);Ef=ea(-3402823469999999843913219.0e14);Ff=ea(-3402823469999999843913219.0e14);Gf=ea(-3402823469999999843913219.0e14);Hf=ea(-3402823469999999843913219.0e14);If=ea(0.0);Jf=ea(0.0);Kf=ea(0.0);Lf=ea(0.0);Mf=ea(0.0);Nf=ea(0.0);Of=ea(0.0);Pf=ea(0.0);Qf=ea(0.0);Rf=ea(0.0);Sf=ea(0.0);Tf=ea(0.0);Uf=ea(0.0);Vf=ea(0.0);Wf=ea(0.0);Xf=ea(0.0);Yf=0;Zf=b;while(1){_f=ea(g[Zf>>2]);$f=ea(g[Zf+4>>2]);ag=ea(g[Zf+8>>2]);bg=ea(g[Zf+12>>2]);cg=ea(ea(Oa*ag)+ea(ea(Na*$f)+ea(ea(Ma*_f)+bg)));dg=ea(ea(Wa*ag)+ea(ea(Va*$f)+ea(ea(Ua*_f)+bg)));eg=ea(ea(cb*ag)+ea(ea(bb*$f)+ea(ea(ab*_f)+bg)));fg=ea(ea(kb*ag)+ea(ea(jb*$f)+ea(ea(ib*_f)+bg)));gg=ea(ea(Sa*ag)+ea(ea(Ra*$f)+ea(ea(Qa*_f)+bg)));hg=ea(ea(_a*ag)+ea(ea(Za*$f)+ea(ea(Ya*_f)+bg)));ig=ea(ea(gb*ag)+ea(ea(fb*$f)+ea(ea(eb*_f)+bg)));jg=ea(ea(ob*ag)+ea(ea(nb*$f)+ea(ea(mb*_f)+bg)));b=gg>Je;kg=hg>Ke;lg=ig>Le;mg=jg>Me;g[j>>2]=gg;g[La>>2]=hg;g[Qc>>2]=ig;g[Rc>>2]=jg;g[h>>2]=Je;g[Sc>>2]=Ke;g[Tc>>2]=Le;g[Uc>>2]=Me;Je=ea(g[(b?j:h)>>2]);Ke=ea(g[(kg?j:h)+4>>2]);Le=ea(g[(lg?j:h)+8>>2]);Me=ea(g[(mg?j:h)+12>>2]);g[l>>2]=_f;g[Vc>>2]=$f;g[Wc>>2]=ag;g[Xc>>2]=ea(0.0);g[k>>2]=Ne;g[Yc>>2]=Oe;g[Zc>>2]=Pe;g[_c>>2]=Qe;ng=b?l:k;Ne=ea(g[ng>>2]);Oe=ea(g[ng+4>>2]);Pe=ea(g[ng+8>>2]);Qe=ea(g[ng+12>>2]);g[n>>2]=_f;g[$c>>2]=$f;g[ad>>2]=ag;g[bd>>2]=ea(0.0);g[m>>2]=Re;g[cd>>2]=Se;g[dd>>2]=Te;g[ed>>2]=Ue;ng=kg?n:m;Re=ea(g[ng>>2]);Se=ea(g[ng+4>>2]);Te=ea(g[ng+8>>2]);Ue=ea(g[ng+12>>2]);g[p>>2]=_f;g[fd>>2]=$f;g[gd>>2]=ag;g[hd>>2]=ea(0.0);g[o>>2]=Ve;g[id>>2]=We;g[jd>>2]=Xe;g[kd>>2]=Ye;ng=lg?p:o;Ve=ea(g[ng>>2]);We=ea(g[ng+4>>2]);Xe=ea(g[ng+8>>2]);Ye=ea(g[ng+12>>2]);g[r>>2]=_f;g[ld>>2]=$f;g[md>>2]=ag;g[nd>>2]=ea(0.0);g[q>>2]=Ze;g[od>>2]=_e;g[pd>>2]=$e;g[qd>>2]=af;ng=mg?r:q;Ze=ea(g[ng>>2]);_e=ea(g[ng+4>>2]);$e=ea(g[ng+8>>2]);af=ea(g[ng+12>>2]);ng=cg>ea(0.0);mg=dg>ea(0.0);lg=eg>ea(0.0);kg=fg>ea(0.0);b=cg>bf;og=dg>cf;pg=eg>df;qg=fg>ef;g[t>>2]=cg;g[rd>>2]=dg;g[sd>>2]=eg;g[td>>2]=fg;g[s>>2]=bf;g[ud>>2]=cf;g[vd>>2]=df;g[wd>>2]=ef;fg=bf;bf=ea(g[(b?t:s)>>2]);eg=cf;cf=ea(g[(og?t:s)+4>>2]);dg=df;df=ea(g[(pg?t:s)+8>>2]);cg=ef;ef=ea(g[(qg?t:s)+12>>2]);g[v>>2]=_f;g[xd>>2]=$f;g[yd>>2]=ag;g[zd>>2]=ea(0.0);g[u>>2]=ff;g[Ad>>2]=gf;g[Bd>>2]=hf;g[Cd>>2]=jf;rg=b?v:u;ff=ea(g[rg>>2]);gf=ea(g[rg+4>>2]);hf=ea(g[rg+8>>2]);jf=ea(g[rg+12>>2]);g[x>>2]=_f;g[Dd>>2]=$f;g[Ed>>2]=ag;g[Fd>>2]=ea(0.0);g[w>>2]=kf;g[Gd>>2]=lf;g[Hd>>2]=mf;g[Id>>2]=nf;rg=og?x:w;kf=ea(g[rg>>2]);lf=ea(g[rg+4>>2]);mf=ea(g[rg+8>>2]);nf=ea(g[rg+12>>2]);g[z>>2]=_f;g[Jd>>2]=$f;g[Kd>>2]=ag;g[Ld>>2]=ea(0.0);g[y>>2]=of;g[Md>>2]=pf;g[Nd>>2]=qf;g[Od>>2]=rf;rg=pg?z:y;of=ea(g[rg>>2]);pf=ea(g[rg+4>>2]);qf=ea(g[rg+8>>2]);rf=ea(g[rg+12>>2]);g[B>>2]=_f;g[Pd>>2]=$f;g[Qd>>2]=ag;g[Rd>>2]=ea(0.0);g[A>>2]=sf;g[Sd>>2]=tf;g[Td>>2]=uf;g[Ud>>2]=vf;rg=qg?B:A;sf=ea(g[rg>>2]);tf=ea(g[rg+4>>2]);uf=ea(g[rg+8>>2]);vf=ea(g[rg+12>>2]);sg=ng&fg>ea(0.0)|(wf|0)!=0;tg=mg&eg>ea(0.0)|(xf|0)!=0;ug=lg&dg>ea(0.0)|(yf|0)!=0;vg=kg&cg>ea(0.0)|(zf|0)!=0;cg=ea(ea(sb*ag)+ea(ea(qb*_f)+ea(rb*$f)));dg=ea(ea(vb*ag)+ea(ea(tb*_f)+ea(ub*$f)));eg=ea(ea(yb*ag)+ea(ea(wb*_f)+ea(xb*$f)));fg=ea(ea(Bb*ag)+ea(ea(zb*_f)+ea(Ab*$f)));bg=ea(-ea(gg/cg));gg=ea(-ea(hg/dg));hg=ea(-ea(ig/eg));ig=ea(-ea(jg/fg));rg=cg>ea(0.0);qg=dg>ea(0.0);pg=eg>ea(0.0);og=fg>ea(0.0);g[D>>2]=bg;g[Vd>>2]=gg;g[Wd>>2]=hg;g[Xd>>2]=ig;g[C>>2]=Af;g[Yd>>2]=Bf;g[Zd>>2]=Cf;g[_d>>2]=Df;Af=ea(g[(Af>bg&rg?D:C)>>2]);Bf=ea(g[(Bf>gg&qg?D:C)+4>>2]);Cf=ea(g[(Cf>hg&pg?D:C)+8>>2]);Df=ea(g[(Df>ig&og?D:C)+12>>2]);og=cg<ea(0.0);pg=dg<ea(0.0);qg=eg<ea(0.0);rg=fg<ea(0.0);g[F>>2]=bg;g[$d>>2]=gg;g[ae>>2]=hg;g[be>>2]=ig;g[E>>2]=Ef;g[ce>>2]=Ff;g[de>>2]=Gf;g[ee>>2]=Hf;b=Ef<bg&og;bg=ea(g[(b?F:E)>>2]);og=Ff<gg&pg;gg=ea(g[(og?F:E)+4>>2]);pg=Gf<hg&qg;hg=ea(g[(pg?F:E)+8>>2]);qg=Hf<ig&rg;ig=ea(g[(qg?F:E)+12>>2]);g[H>>2]=_f;g[fe>>2]=$f;g[ge>>2]=ag;g[he>>2]=ea(0.0);g[G>>2]=If;g[ie>>2]=Jf;g[je>>2]=Kf;g[ke>>2]=Lf;rg=b?H:G;If=ea(g[rg>>2]);Jf=ea(g[rg+4>>2]);Kf=ea(g[rg+8>>2]);Lf=ea(g[rg+12>>2]);g[J>>2]=_f;g[le>>2]=$f;g[me>>2]=ag;g[ne>>2]=ea(0.0);g[I>>2]=Mf;g[oe>>2]=Nf;g[pe>>2]=Of;g[qe>>2]=Pf;rg=og?J:I;Mf=ea(g[rg>>2]);Nf=ea(g[rg+4>>2]);Of=ea(g[rg+8>>2]);Pf=ea(g[rg+12>>2]);g[L>>2]=_f;g[re>>2]=$f;g[se>>2]=ag;g[te>>2]=ea(0.0);g[K>>2]=Qf;g[ue>>2]=Rf;g[ve>>2]=Sf;g[we>>2]=Tf;rg=pg?L:K;Qf=ea(g[rg>>2]);Rf=ea(g[rg+4>>2]);Sf=ea(g[rg+8>>2]);Tf=ea(g[rg+12>>2]);g[N>>2]=_f;g[xe>>2]=$f;g[ye>>2]=ag;g[ze>>2]=ea(0.0);g[M>>2]=Uf;g[Ae>>2]=Vf;g[Be>>2]=Wf;g[Ce>>2]=Xf;rg=qg?N:M;Uf=ea(g[rg>>2]);Vf=ea(g[rg+4>>2]);Wf=ea(g[rg+8>>2]);Xf=ea(g[rg+12>>2]);rg=cg==ea(0.0)&ng;ng=dg==ea(0.0)&mg;mg=eg==ea(0.0)&lg;lg=fg==ea(0.0)&kg;g[P>>2]=ea(1.0);g[De>>2]=ea(1.0);g[Ee>>2]=ea(1.0);g[Fe>>2]=ea(1.0);g[O>>2]=bg;g[Ge>>2]=gg;g[He>>2]=hg;g[Ie>>2]=ig;Ef=ea(g[(rg?P:O)>>2]);Ff=ea(g[(ng?P:O)+4>>2]);Gf=ea(g[(mg?P:O)+8>>2]);Hf=ea(g[(lg?P:O)+12>>2]);Yf=Yf+1|0;if((Yf|0)==(d|0))break;else{wf=sg<<31>>31;xf=tg<<31>>31;yf=ug<<31>>31;zf=vg<<31>>31;Zf=Zf+16|0}}Cb=Hf;Db=Gf;Eb=Ff;Fb=Ef;Gb=Df;Hb=Cf;Ib=Bf;Jb=Af;Kb=ef;Lb=df;Mb=cf;Nb=bf;Ob=Me;Pb=Le;Qb=Ke;Rb=Je;Sb=vf;Tb=uf;Ub=tf;Vb=sf;Wb=rf;Xb=qf;Yb=pf;Zb=of;_b=nf;$b=mf;ac=lf;bc=kf;cc=jf;dc=hf;ec=gf;fc=ff;gc=Xf;hc=Wf;ic=Vf;jc=Uf;kc=Tf;lc=Sf;mc=Rf;nc=Qf;oc=Pf;pc=Of;qc=Nf;rc=Mf;sc=Lf;tc=Kf;uc=Jf;vc=If;wc=af;xc=$e;yc=_e;zc=Ze;Ac=Ye;Bc=Xe;Cc=We;Dc=Ve;Ec=Ue;Fc=Te;Gc=Se;Hc=Re;Ic=Qe;Jc=Pe;Kc=Oe;Lc=Ne;Mc=vg^1;Nc=ug^1;Oc=tg^1;Pc=sg^1}sg=a+160|0;tg=a+164|0;ug=a+168|0;vg=a+172|0;Ne=ea(g[a+144>>2]);Oe=ea(g[a+148>>2]);Pe=ea(g[a+152>>2]);Qe=ea(g[a+156>>2]);Zf=Nb>=ea(0.0)&(c[sg>>2]&2|0)==0;zf=Mb>=ea(0.0)&(c[tg>>2]&2|0)==0;yf=Lb>=ea(0.0)&(c[ug>>2]&2|0)==0;xf=Kb>=ea(0.0)&(c[vg>>2]&2|0)==0;c[R>>2]=32;c[R+4>>2]=32;c[R+8>>2]=32;c[R+12>>2]=32;c[Q+0>>2]=0;c[Q+4>>2]=0;c[Q+8>>2]=0;c[Q+12>>2]=0;wf=c[(Pc&(Nb<e&Zf)?R:Q)>>2]|0;Pc=c[(Oc&(Mb<e&zf)?R:Q)+4>>2]|0;Oc=c[(Nc&(Lb<e&yf)?R:Q)+8>>2]|0;Nc=c[(Mc&(Kb<e&xf)?R:Q)+12>>2]|0;c[T>>2]=16;c[T+4>>2]=16;c[T+8>>2]=16;c[T+12>>2]=16;c[S+0>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;c[S+12>>2]=0;Q=c[(Ne>Nb&Zf?T:S)>>2]|wf;wf=c[(Oe>Mb&zf?T:S)+4>>2]|Pc;Pc=c[(Pe>Lb&yf?T:S)+8>>2]|Oc;Oc=c[(Qe>Kb&xf?T:S)+12>>2]|Nc;Nc=a+176|0;e=ea(g[Nc>>2]);S=a+180|0;Re=ea(g[S>>2]);T=a+184|0;Se=ea(g[T>>2]);xf=a+188|0;Te=ea(g[xf>>2]);yf=Jb>=Fb&(e>Fb&Fb>=ea(0.0));zf=Ib>=Eb&(Re>Eb&Eb>=ea(0.0));Zf=Hb>=Db&(Se>Db&Db>=ea(0.0));R=Gb>=Cb&(Te>Cb&Cb>=ea(0.0));c[V>>2]=8;c[V+4>>2]=8;c[V+8>>2]=8;c[V+12>>2]=8;c[U>>2]=Q;c[U+4>>2]=wf;c[U+8>>2]=Pc;c[U+12>>2]=Oc;Oc=c[(yf?V:U)>>2]|0;Pc=c[(zf?V:U)+4>>2]|0;wf=c[(Zf?V:U)+8>>2]|0;Q=c[(R?V:U)+12>>2]|0;g[X>>2]=vc;g[X+4>>2]=uc;g[X+8>>2]=tc;g[X+12>>2]=sc;g[W>>2]=fc;g[W+4>>2]=ec;g[W+8>>2]=dc;g[W+12>>2]=cc;U=yf?X:W;cc=ea(g[U>>2]);dc=ea(g[U+4>>2]);ec=ea(g[U+8>>2]);fc=ea(g[U+12>>2]);g[Z>>2]=rc;g[Z+4>>2]=qc;g[Z+8>>2]=pc;g[Z+12>>2]=oc;g[Y>>2]=bc;g[Y+4>>2]=ac;g[Y+8>>2]=$b;g[Y+12>>2]=_b;U=zf?Z:Y;_b=ea(g[U>>2]);$b=ea(g[U+4>>2]);ac=ea(g[U+8>>2]);bc=ea(g[U+12>>2]);g[$>>2]=nc;g[$+4>>2]=mc;g[$+8>>2]=lc;g[$+12>>2]=kc;g[_>>2]=Zb;g[_+4>>2]=Yb;g[_+8>>2]=Xb;g[_+12>>2]=Wb;U=Zf?$:_;Wb=ea(g[U>>2]);Xb=ea(g[U+4>>2]);Yb=ea(g[U+8>>2]);Zb=ea(g[U+12>>2]);g[ba>>2]=jc;g[ba+4>>2]=ic;g[ba+8>>2]=hc;g[ba+12>>2]=gc;g[aa>>2]=Vb;g[aa+4>>2]=Ub;g[aa+8>>2]=Tb;g[aa+12>>2]=Sb;U=R?ba:aa;Sb=ea(g[U>>2]);Tb=ea(g[U+4>>2]);Ub=ea(g[U+8>>2]);Vb=ea(g[U+12>>2]);g[da>>2]=Fb;g[da+4>>2]=Eb;g[da+8>>2]=Db;g[da+12>>2]=Cb;g[ca>>2]=e;g[ca+4>>2]=Re;g[ca+8>>2]=Se;g[ca+12>>2]=Te;Te=ea(g[(yf?da:ca)>>2]);Se=ea(g[(zf?da:ca)+4>>2]);Re=ea(g[(Zf?da:ca)+8>>2]);e=ea(g[(R?da:ca)+12>>2]);g[ga>>2]=Ne;g[ga+4>>2]=Oe;g[ga+8>>2]=Pe;g[ga+12>>2]=Qe;g[fa>>2]=Nb;g[fa+4>>2]=Mb;g[fa+8>>2]=Lb;g[fa+12>>2]=Kb;Kb=ea(g[(yf?ga:fa)>>2]);Lb=ea(g[(zf?ga:fa)+4>>2]);Mb=ea(g[(Zf?ga:fa)+8>>2]);Nb=ea(g[(R?ga:fa)+12>>2]);g[ia>>2]=Qa;g[ia+4>>2]=Ra;g[ia+8>>2]=Sa;g[ia+12>>2]=Ta;g[ha>>2]=Ma;g[ha+4>>2]=Na;g[ha+8>>2]=Oa;g[ha+12>>2]=Pa;fa=yf?ia:ha;Pa=ea(g[fa>>2]);Oa=ea(g[fa+4>>2]);Na=ea(g[fa+8>>2]);Ma=ea(g[fa+12>>2]);g[ka>>2]=Ya;g[ka+4>>2]=Za;g[ka+8>>2]=_a;g[ka+12>>2]=$a;g[ja>>2]=Ua;g[ja+4>>2]=Va;g[ja+8>>2]=Wa;g[ja+12>>2]=Xa;fa=zf?ka:ja;Xa=ea(g[fa>>2]);Wa=ea(g[fa+4>>2]);Va=ea(g[fa+8>>2]);Ua=ea(g[fa+12>>2]);g[ma>>2]=eb;g[ma+4>>2]=fb;g[ma+8>>2]=gb;g[ma+12>>2]=hb;g[la>>2]=ab;g[la+4>>2]=bb;g[la+8>>2]=cb;g[la+12>>2]=db;fa=Zf?ma:la;db=ea(g[fa>>2]);cb=ea(g[fa+4>>2]);bb=ea(g[fa+8>>2]);ab=ea(g[fa+12>>2]);g[oa>>2]=mb;g[oa+4>>2]=nb;g[oa+8>>2]=ob;g[oa+12>>2]=pb;g[na>>2]=ib;g[na+4>>2]=jb;g[na+8>>2]=kb;g[na+12>>2]=lb;fa=R?oa:na;lb=ea(g[fa>>2]);kb=ea(g[fa+4>>2]);jb=ea(g[fa+8>>2]);ib=ea(g[fa+12>>2]);fa=Rb<=ea(0.0);na=Qb<=ea(0.0);oa=Pb<=ea(0.0);R=Ob<=ea(0.0);c[qa>>2]=8;c[qa+4>>2]=8;c[qa+8>>2]=8;c[qa+12>>2]=8;c[pa>>2]=Oc;c[pa+4>>2]=Pc;c[pa+8>>2]=wf;c[pa+12>>2]=Q;Q=c[(fa?qa:pa)>>2]|0;wf=c[(na?qa:pa)+4>>2]|0;Pc=c[(oa?qa:pa)+8>>2]|0;Oc=c[(R?qa:pa)+12>>2]|0;g[sa>>2]=Lc;g[sa+4>>2]=Kc;g[sa+8>>2]=Jc;g[sa+12>>2]=Ic;g[ra>>2]=cc;g[ra+4>>2]=dc;g[ra+8>>2]=ec;g[ra+12>>2]=fc;pa=fa?sa:ra;fc=ea(g[pa>>2]);ec=ea(g[pa+4>>2]);dc=ea(g[pa+8>>2]);cc=ea(g[pa+12>>2]);g[ua>>2]=Hc;g[ua+4>>2]=Gc;g[ua+8>>2]=Fc;g[ua+12>>2]=Ec;g[ta>>2]=_b;g[ta+4>>2]=$b;g[ta+8>>2]=ac;g[ta+12>>2]=bc;pa=na?ua:ta;bc=ea(g[pa>>2]);ac=ea(g[pa+4>>2]);$b=ea(g[pa+8>>2]);_b=ea(g[pa+12>>2]);g[wa>>2]=Dc;g[wa+4>>2]=Cc;g[wa+8>>2]=Bc;g[wa+12>>2]=Ac;g[va>>2]=Wb;g[va+4>>2]=Xb;g[va+8>>2]=Yb;g[va+12>>2]=Zb;pa=oa?wa:va;Zb=ea(g[pa>>2]);Yb=ea(g[pa+4>>2]);Xb=ea(g[pa+8>>2]);Wb=ea(g[pa+12>>2]);g[ya>>2]=zc;g[ya+4>>2]=yc;g[ya+8>>2]=xc;g[ya+12>>2]=wc;g[xa>>2]=Sb;g[xa+4>>2]=Tb;g[xa+8>>2]=Ub;g[xa+12>>2]=Vb;pa=R?ya:xa;Vb=ea(g[pa>>2]);Ub=ea(g[pa+4>>2]);Tb=ea(g[pa+8>>2]);Sb=ea(g[pa+12>>2]);g[Aa>>2]=Qa;g[Aa+4>>2]=Ra;g[Aa+8>>2]=Sa;g[Aa+12>>2]=Ta;g[za>>2]=Pa;g[za+4>>2]=Oa;g[za+8>>2]=Na;g[za+12>>2]=Ma;pa=fa?Aa:za;Ma=ea(g[pa>>2]);Na=ea(g[pa+4>>2]);Oa=ea(g[pa+8>>2]);Pa=ea(g[pa+12>>2]);g[Ca>>2]=Ya;g[Ca+4>>2]=Za;g[Ca+8>>2]=_a;g[Ca+12>>2]=$a;g[Ba>>2]=Xa;g[Ba+4>>2]=Wa;g[Ba+8>>2]=Va;g[Ba+12>>2]=Ua;pa=na?Ca:Ba;Ua=ea(g[pa>>2]);Va=ea(g[pa+4>>2]);Wa=ea(g[pa+8>>2]);Xa=ea(g[pa+12>>2]);g[Ea>>2]=eb;g[Ea+4>>2]=fb;g[Ea+8>>2]=gb;g[Ea+12>>2]=hb;g[Da>>2]=db;g[Da+4>>2]=cb;g[Da+8>>2]=bb;g[Da+12>>2]=ab;pa=oa?Ea:Da;ab=ea(g[pa>>2]);bb=ea(g[pa+4>>2]);cb=ea(g[pa+8>>2]);db=ea(g[pa+12>>2]);g[Ga>>2]=mb;g[Ga+4>>2]=nb;g[Ga+8>>2]=ob;g[Ga+12>>2]=pb;g[Fa>>2]=lb;g[Fa+4>>2]=kb;g[Fa+8>>2]=jb;g[Fa+12>>2]=ib;pa=R?Ga:Fa;ib=ea(g[pa>>2]);jb=ea(g[pa+4>>2]);kb=ea(g[pa+8>>2]);lb=ea(g[pa+12>>2]);g[Ia>>2]=Rb;g[Ia+4>>2]=Qb;g[Ia+8>>2]=Pb;g[Ia+12>>2]=Ob;g[Ha>>2]=Kb;g[Ha+4>>2]=Lb;g[Ha+8>>2]=Mb;g[Ha+12>>2]=Nb;Nb=ea(g[(fa?Ia:Ha)>>2]);Mb=ea(g[(na?Ia:Ha)+4>>2]);Lb=ea(g[(oa?Ia:Ha)+8>>2]);Kb=ea(g[(R?Ia:Ha)+12>>2]);c[Ka+0>>2]=0;c[Ka+4>>2]=0;c[Ka+8>>2]=0;c[Ka+12>>2]=0;g[Ja>>2]=Te;g[Ja+4>>2]=Se;g[Ja+8>>2]=Re;g[Ja+12>>2]=e;e=ea(g[(fa?Ka:Ja)>>2]);Re=ea(g[(na?Ka:Ja)+4>>2]);Se=ea(g[(oa?Ka:Ja)+8>>2]);Te=ea(g[(R?Ka:Ja)+12>>2]);Ob=ea(Ne-Nb);Nb=ea(Oe-Mb);Mb=ea(Pe-Lb);Lb=ea(Qe-Kb);Kb=ea(Na+ea(ec*Ob));Na=ea(Oa+ea(dc*Ob));Oa=ea(Pa+ea(cc*Ob));Pa=ea(Ua+ea(bc*Nb));Ua=ea(Va+ea(ac*Nb));Va=ea(Wa+ea($b*Nb));Wa=ea(Xa+ea(_b*Nb));Nb=ea(ab+ea(Zb*Mb));ab=ea(bb+ea(Yb*Mb));bb=ea(cb+ea(Xb*Mb));cb=ea(db+ea(Wb*Mb));Mb=ea(ib+ea(Vb*Lb));ib=ea(jb+ea(Ub*Lb));jb=ea(kb+ea(Tb*Lb));kb=ea(lb+ea(Sb*Lb));g[a+256>>2]=ea(Ma+ea(fc*Ob));g[a+260>>2]=Kb;g[a+264>>2]=Na;g[a+268>>2]=Oa;g[a+272>>2]=Pa;g[a+276>>2]=Ua;g[a+280>>2]=Va;g[a+284>>2]=Wa;g[a+288>>2]=Nb;g[a+292>>2]=ab;g[a+296>>2]=bb;g[a+300>>2]=cb;g[a+304>>2]=Mb;g[a+308>>2]=ib;g[a+312>>2]=jb;g[a+316>>2]=kb;g[a+192>>2]=fc;g[a+196>>2]=ec;g[a+200>>2]=dc;g[a+204>>2]=cc;g[a+208>>2]=bc;g[a+212>>2]=ac;g[a+216>>2]=$b;g[a+220>>2]=_b;g[a+224>>2]=Zb;g[a+228>>2]=Yb;g[a+232>>2]=Xb;g[a+236>>2]=Wb;g[a+240>>2]=Vb;g[a+244>>2]=Ub;g[a+248>>2]=Tb;g[a+252>>2]=Sb;g[Nc>>2]=e;g[S>>2]=Re;g[T>>2]=Se;g[xf>>2]=Te;c[sg>>2]=Q;c[tg>>2]=wf;c[ug>>2]=Pc;c[vg>>2]=Oc;i=f;return}function Xta(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=Im,w=0,x=0,y=Im,z=0,A=Im,B=Im,C=0,D=0,E=Im,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=Im,S=0,T=0,U=0,V=0,W=0;f=i;h=ea(g[a+128>>2]);j=ea(g[a+112>>2]);k=ea(h-j);l=ea(g[a+132>>2]);m=ea(g[a+116>>2]);n=ea(l-m);o=ea(g[a+136>>2]);p=ea(g[a+120>>2]);q=ea(o-p);if(!d){r=ea(-3402823469999999843913219.0e14);s=ea(-3402823469999999843913219.0e14);t=0;u=0;v=ea(-3402823469999999843913219.0e14);w=0;x=0;y=ea(3402823469999999843913219.0e14)}else{z=0;A=ea(-3402823469999999843913219.0e14);B=ea(-3402823469999999843913219.0e14);C=0;D=0;E=ea(-3402823469999999843913219.0e14);F=0;G=0;H=ea(3402823469999999843913219.0e14);while(1){I=ea(g[b+(z<<4)>>2]);J=ea(h*I);K=ea(g[b+(z<<4)+4>>2]);L=ea(J+ea(l*K));J=ea(g[b+(z<<4)+8>>2]);M=ea(L+ea(o*J));L=ea(g[b+(z<<4)+12>>2]);N=ea(L+M);M=ea(L+ea(ea(ea(I*j)+ea(K*m))+ea(J*p)));O=B>ea(0.0);P=M>E;L=P?M:E;Q=P?z:F;P=N>B;R=P?N:B;S=P?z:D;P=N>ea(0.0);T=C|O&P;N=ea(ea(ea(k*I)+ea(n*K))+ea(q*J));J=ea(ea(-M)/N);O=N<ea(0.0)&J>A;U=N>ea(0.0)&J<H;V=O?z:G;M=U?J:H;U=N==ea(0.0)&P;N=U?ea(3402823469999999843913219.0e14):O?J:A;z=z+1|0;if((z|0)==(d|0)){r=N;s=R;t=T;u=S;v=L;w=Q;x=V;y=M;break}else{A=N;B=R;C=T;D=S;E=L;F=Q;G=V;H=M}}}G=!(v<=ea(0.0));H=ea(g[a+92>>2]);F=!(s<=H);D=!(s>ea(0.0))|!(s<=e)|t;if(!G){G=a+124|0;c[G>>2]=c[G>>2]|8;g[a+44>>2]=ea(0.0);G=b+(w<<4)|0;g[a+144>>2]=ea(g[G>>2]);t=b+(w<<4)+4|0;g[a+148>>2]=ea(g[t>>2]);C=b+(w<<4)+8|0;g[a+152>>2]=ea(g[C>>2]);e=ea(H-v);v=ea(ea(g[G>>2])*e);E=ea(e*ea(g[t>>2]));B=ea(E+m);E=ea(ea(e*ea(g[C>>2]))+p);g[a+160>>2]=ea(v+j);g[a+164>>2]=B;g[a+168>>2]=E;i=f;return}if(r>=ea(0.0)?(C=a+44|0,r<=y?r<ea(g[C>>2]):0):0){g[a+144>>2]=ea(g[b+(x<<4)>>2]);g[a+148>>2]=ea(g[b+(x<<4)+4>>2]);g[a+152>>2]=ea(g[b+(x<<4)+8>>2]);g[a+160>>2]=j;g[a+164>>2]=m;g[a+168>>2]=p;g[C>>2]=r;C=a+124|0;c[C>>2]=c[C>>2]|8;i=f;return}C=a+124|0;x=c[C>>2]|0;if(x&2){i=f;return}if(D)W=x;else{D=b+(u<<4)|0;g[a+144>>2]=ea(g[D>>2]);t=b+(u<<4)+4|0;g[a+148>>2]=ea(g[t>>2]);G=b+(u<<4)+8|0;g[a+152>>2]=ea(g[G>>2]);r=ea(H-s);p=ea(ea(g[D>>2])*r);m=ea(r*ea(g[t>>2]));j=ea(m+l);m=ea(ea(r*ea(g[G>>2]))+o);g[a+160>>2]=ea(p+h);g[a+164>>2]=j;g[a+168>>2]=m;G=x|32;c[C>>2]=G;W=G}if(F){i=f;return}F=b+(u<<4)|0;g[a+144>>2]=ea(g[F>>2]);G=b+(u<<4)+4|0;g[a+148>>2]=ea(g[G>>2]);x=b+(u<<4)+8|0;g[a+152>>2]=ea(g[x>>2]);m=ea(H-s);s=ea(ea(g[F>>2])*m);H=ea(m*ea(g[G>>2]));j=ea(H+l);l=ea(ea(m*ea(g[x>>2]))+o);g[a+160>>2]=ea(s+h);g[a+164>>2]=j;g[a+168>>2]=l;c[C>>2]=W|16;i=f;return}function Yta(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0,Ga=0;k=i;i=i+1120|0;l=k+1008|0;m=k+1024|0;n=k+1040|0;o=k+1076|0;p=k+176|0;q=k;r=k+496|0;s=c[h+36>>2]|0;t=ea(g[h+16>>2]);u=ea(g[h+20>>2]);v=ea(g[h+24>>2]);w=ea(g[h+28>>2]);x=ea(t+t);y=ea(u+u);z=ea(v+v);A=ea(u*y);B=ea(v*z);C=ea(x*u);u=ea(x*v);D=ea(x*w);E=ea(y*v);v=ea(y*w);y=ea(z*w);w=ea(ea(ea(1.0)-A)-B);z=ea(C+y);F=ea(u-v);G=ea(C-y);y=ea(ea(1.0)-ea(t*x));x=ea(y-B);B=ea(E+D);t=ea(u+v);v=ea(E-D);D=ea(y-A);A=ea(g[h+4>>2]);y=ea(A*w);E=ea(A*G);u=ea(A*t);A=ea(g[h+8>>2]);C=ea(z*A);H=ea(x*A);I=ea(v*A);A=ea(g[h+12>>2]);J=ea(F*A);K=ea(B*A);L=ea(D*A);A=ea(ea(ea(w*E)+ea(z*H))+ea(F*K));M=ea(ea(ea(w*u)+ea(z*I))+ea(F*L));N=ea(ea(ea(G*y)+ea(x*C))+ea(B*J));O=ea(ea(ea(G*E)+ea(x*H))+ea(B*K));P=ea(ea(ea(G*u)+ea(x*I))+ea(B*L));B=ea(ea(ea(t*y)+ea(v*C))+ea(D*J));x=ea(ea(ea(t*E)+ea(v*H))+ea(D*K));K=ea(ea(ea(t*u)+ea(v*I))+ea(D*L));g[n>>2]=ea(ea(ea(w*y)+ea(z*C))+ea(F*J));h=n+4|0;g[h>>2]=A;Q=n+8|0;g[Q>>2]=M;R=n+12|0;g[R>>2]=N;U=n+16|0;g[U>>2]=O;V=n+20|0;g[V>>2]=P;W=n+24|0;g[W>>2]=B;X=n+28|0;g[X>>2]=x;Y=n+32|0;g[Y>>2]=K;F0a(o,n);K=ea(g[o>>2]);x=ea(g[o+4>>2]);B=ea(g[o+8>>2]);P=ea(g[o+12>>2]);O=ea(g[o+16>>2]);N=ea(g[o+20>>2]);M=ea(g[o+24>>2]);A=ea(g[o+28>>2]);J=ea(g[o+32>>2]);F=ea(g[s>>2]);C=ea(g[s+12>>2]);z=ea(F+C);y=ea(g[s+4>>2]);w=ea(g[s+16>>2]);L=ea(y+w);D=ea(g[s+8>>2]);I=ea(g[s+20>>2]);v=ea(z*ea(.5));z=ea(L*ea(.5));L=ea(ea(D+I)*ea(.5));u=ea(g[n>>2]);t=ea(v*u);H=ea(g[h>>2]);E=ea(v*H);G=ea(g[Q>>2]);Z=ea(v*G);v=ea(g[R>>2]);_=ea(z*v);$=ea(g[U>>2]);aa=ea(z*$);ba=ea(g[V>>2]);ca=ea(t+_);_=ea(E+aa);aa=ea(Z+ea(z*ba));z=ea(g[W>>2]);Z=ea(L*z);E=ea(g[X>>2]);t=ea(L*E);da=ea(g[Y>>2]);fa=ea(ca+Z);Z=ea(_+t);t=ea(aa+ea(L*da));L=ea(ea(C-F)*ea(.5));F=ea(ea(w-y)*ea(.5));y=ea(ea(I-D)*ea(.5));D=ea(ea(ea(S(ea(L*u)))+ea(S(ea(F*v))))+ea(S(ea(y*z))));z=ea(ea(ea(S(ea(L*H)))+ea(S(ea(F*$))))+ea(S(ea(y*E))));E=ea(ea(ea(S(ea(L*G)))+ea(S(ea(F*ba))))+ea(S(ea(y*da))));da=ea(ea(fa-D)-j);y=ea(ea(Z-z)-j);ba=ea(ea(t-E)-j);F=ea(ea(fa+D)+j);D=ea(ea(Z+z)+j);z=ea(ea(t+E)+j);g[q+112>>2]=ea(3402823469999999843913219.0e14);g[q+116>>2]=ea(3402823469999999843913219.0e14);g[q+120>>2]=ea(3402823469999999843913219.0e14);g[q+128>>2]=ea(3402823469999999843913219.0e14);g[q+132>>2]=ea(3402823469999999843913219.0e14);g[q+136>>2]=ea(3402823469999999843913219.0e14);if(!f){i=k;return}Y=s+39|0;X=s+40|0;s=m+4|0;W=m+8|0;V=m+12|0;U=~f;R=0;Q=0;while(1){h=f-Q|0;n=h>>>0<128?h:128;h=e+(Q*176|0)|0;o=(n|0)==0;if(!o){ga=0;ha=h;while(1){ia=ha+176|0;ja=ga|1;ka=ja>>>0<f>>>0;la=ka?ha+352|0:ia;ma=ka?ia:q;ia=ga|2;ka=ia>>>0<f>>>0;na=ka?la+176|0:la;oa=ka?la:q;la=ga|3;ka=la>>>0<f>>>0;pa=ka?na:q;qa=ha+112|0;E=ea(g[qa>>2]);t=ea(g[qa+4>>2]);Z=ea(g[qa+8>>2]);qa=ha+128|0;fa=ea(g[qa>>2]);G=ea(g[qa+4>>2]);L=ea(g[qa+8>>2]);qa=ma+112|0;$=ea(g[qa>>2]);H=ea(g[qa+4>>2]);v=ea(g[qa+8>>2]);qa=ma+128|0;u=ea(g[qa>>2]);I=ea(g[qa+4>>2]);w=ea(g[qa+8>>2]);qa=oa+112|0;C=ea(g[qa>>2]);aa=ea(g[qa+4>>2]);_=ea(g[qa+8>>2]);qa=oa+128|0;ca=ea(g[qa>>2]);ra=ea(g[qa+4>>2]);sa=ea(g[qa+8>>2]);qa=pa+112|0;ta=ea(g[qa>>2]);ua=ea(g[qa+4>>2]);va=ea(g[qa+8>>2]);qa=pa+128|0;wa=ea(g[qa>>2]);xa=ea(g[qa+4>>2]);ya=ea(g[qa+8>>2]);c[m>>2]=1;c[s>>2]=1;c[W>>2]=1;c[V>>2]=1;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;qa=c[((F>($<u?$:u)?D>(H<I?H:I):0)&z>(v<w?v:w)&($>u?$:u)>da&(H>I?H:I)>y&(v>w?v:w)>ba?m:l)+4>>2]|0;pa=c[((F>(C<ca?C:ca)?D>(aa<ra?aa:ra):0)&z>(_<sa?_:sa)&(C>ca?C:ca)>da&(aa>ra?aa:ra)>y&(_>sa?_:sa)>ba?m:l)+8>>2]|0;oa=c[((F>(ta<wa?ta:wa)?D>(ua<xa?ua:xa):0)&z>(va<ya?va:ya)&(ta>wa?ta:wa)>da&(ua>xa?ua:xa)>y&(va>ya?va:ya)>ba?m:l)+12>>2]|0;c[r+(ga<<2)>>2]=c[((F>(E<fa?E:fa)?D>(t<G?t:G):0)&z>(Z<L?Z:L)&(E>fa?E:fa)>da&(t>G?t:G)>y&(Z>L?Z:L)>ba?m:l)>>2];c[r+(ja<<2)>>2]=qa;c[r+(ia<<2)>>2]=pa;c[r+(la<<2)>>2]=oa;ga=ga+4|0;if(ga>>>0>=n>>>0)break;else ha=ka?na+176|0:na}if(!o){ha=n+-1|0;ga=Q+U|0;na=ga>>>0>4294967167?~ga:128;ga=0;ka=h;oa=R;la=0;while(1){if(!(c[r+(ga<<2)>>2]|0)){za=oa;Aa=la}else{if(!oa?(pa=a[Y>>0]|0,pa<<24>>24!=0):0){ia=pa&255;pa=b;qa=c[X>>2]|0;while(1){L=ea(g[qa>>2]);Z=ea(g[qa+4>>2]);G=ea(g[qa+8>>2]);t=ea(g[qa+12>>2]);fa=ea(ea(ea(K*L)+ea(x*Z))+ea(B*G));E=ea(ea(ea(P*L)+ea(O*Z))+ea(N*G));ya=ea(ea(ea(M*L)+ea(A*Z))+ea(J*G));G=ea(T(ea(ea(ya*ya)+ea(ea(fa*fa)+ea(E*E)))));if(G>ea(0.0)){Z=ea(ea(1.0)/G);Ba=ea(fa*Z);Ca=ea(E*Z);Da=ea(ya*Z)}else{Ba=fa;Ca=E;Da=ya}ya=ea(t/G);g[pa>>2]=Ba;g[pa+4>>2]=Ca;g[pa+8>>2]=Da;g[pa+12>>2]=ya;ia=ia+-1|0;if(!ia)break;else{pa=pa+16|0;qa=qa+20|0}}}g[p+(la<<4)+16>>2]=ea(g[ka+112>>2]);g[p+(la<<4)+20>>2]=ea(g[ka+116>>2]);g[p+(la<<4)+24>>2]=ea(g[ka+120>>2]);g[p+(la<<4)+80>>2]=ea(g[ka+128>>2]);g[p+(la<<4)+84>>2]=ea(g[ka+132>>2]);g[p+(la<<4)+88>>2]=ea(g[ka+136>>2]);c[p+(la<<2)+160>>2]=c[ka+124>>2];g[p+(la<<2)+144>>2]=ea(g[ka+92>>2]);g[p+(la<<2)+176>>2]=ea(g[ka+44>>2]);c[p+(la<<2)>>2]=ka;za=1;Aa=la+1|0}if((Aa|0)==4)Ea=17;else if(Aa)if((ga|0)==(ha|0))Ea=17;else Fa=Aa;else Fa=0;if((Ea|0)==17){Ea=0;Wta(p,b,d[Y>>0]|0,j);if(!Aa)Fa=0;else{qa=0;do{pa=c[p+(qa<<2)>>2]|0;ia=c[p+(qa<<2)+160>>2]|0;if(ia){ja=pa+124|0;c[ja>>2]=c[ja>>2]|ia;g[pa+44>>2]=ea(g[p+(qa<<2)+176>>2]);g[pa+144>>2]=ea(g[p+(qa<<4)+192>>2]);g[pa+148>>2]=ea(g[p+(qa<<4)+196>>2]);g[pa+152>>2]=ea(g[p+(qa<<4)+200>>2]);g[pa+160>>2]=ea(g[p+(qa<<4)+256>>2]);g[pa+164>>2]=ea(g[p+(qa<<4)+260>>2]);g[pa+168>>2]=ea(g[p+(qa<<4)+264>>2])}qa=qa+1|0}while((qa|0)!=(Aa|0));Fa=0}}ga=ga+1|0;if((ga|0)==(na|0)){Ga=za;break}else{ka=ka+176|0;oa=za;la=Fa}}}else Ga=R}else Ga=R;Q=n+Q|0;if(Q>>>0>=f>>>0)break;else R=Ga}i=k;return}function Zta(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im;j=i;i=i+96|0;k=j+72|0;l=j+12|0;m=j;e_a(k,b,f);n=ea(g[k>>2]);o=ea(g[k+4>>2]);p=ea(g[k+8>>2]);q=ea(g[k+12>>2]);r=ea(g[k+16>>2]);s=ea(g[k+20>>2]);t=ea(ea(n+q)*ea(.5));u=ea(ea(o+r)*ea(.5));v=ea(ea(p+s)*ea(.5));w=ea(ea(q-n)*ea(.5));n=ea(ea(r-o)*ea(.5));o=ea(ea(s-p)*ea(.5));g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);g[l+16>>2]=ea(1.0);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(0.0);g[l+28>>2]=ea(0.0);g[l+32>>2]=ea(1.0);k=l+36|0;g[k>>2]=t;f=l+40|0;g[f>>2]=u;b=l+44|0;g[b>>2]=v;x=l+48|0;g[x>>2]=w;y=l+52|0;g[y>>2]=n;z=l+56|0;g[z>>2]=o;if(e){A=a+16|0;B=c[A>>2]|0;c[m>>2]=B;C=a+32|0;D=m+4|0;c[D>>2]=C;E=a+20|0;F=ea(g[E>>2]);G=m+8|0;g[G>>2]=F;vQa(l,1,m,h,1);i=j;return}p=ea(g[d+36>>2]);s=ea(t*p);r=ea(g[d+40>>2]);q=ea(t*r);H=ea(g[d+44>>2]);I=ea(t*H);t=ea(g[d+48>>2]);J=ea(u*t);K=ea(g[d+52>>2]);L=ea(u*K);M=ea(g[d+56>>2]);N=ea(s+J);J=ea(q+L);L=ea(I+ea(u*M));u=ea(g[d+60>>2]);I=ea(v*u);q=ea(g[d+64>>2]);s=ea(v*q);O=ea(g[d+68>>2]);P=ea(N+I);I=ea(J+s);s=ea(L+ea(v*O));v=ea(ea(ea(S(ea(p*w)))+ea(S(ea(t*n))))+ea(S(ea(u*o))));u=ea(ea(ea(S(ea(r*w)))+ea(S(ea(K*n))))+ea(S(ea(q*o))));q=ea(ea(ea(S(ea(H*w)))+ea(S(ea(M*n))))+ea(S(ea(O*o))));o=ea(P-v);O=ea(I-u);n=ea(s-q);M=ea(P+v);v=ea(I+u);u=ea(s+q);q=ea(ea(O+v)*ea(.5));s=ea(ea(n+u)*ea(.5));g[k>>2]=ea(ea(o+M)*ea(.5));g[f>>2]=q;g[b>>2]=s;s=ea(ea(v-O)*ea(.5));O=ea(ea(u-n)*ea(.5));g[x>>2]=ea(ea(M-o)*ea(.5));g[y>>2]=s;g[z>>2]=O;A=a+16|0;B=c[A>>2]|0;c[m>>2]=B;C=a+32|0;D=m+4|0;c[D>>2]=C;E=a+20|0;F=ea(g[E>>2]);G=m+8|0;g[G>>2]=F;vQa(l,1,m,h,1);i=j;return}function _ta(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=Im;d=i;i=i+112|0;l=d;m=d+96|0;n=d+4|0;o=d+16|0;p=d+72|0;q=d+84|0;r=d+28|0;s=d+56|0;t=d+44|0;u=d+60|0;v=d+32|0;g[l>>2]=j;w=c[b+124>>2]|0;if(!(w&2))x=w>>>3&1;else x=1;a[m>>0]=x;g[n>>2]=ea(0.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[p>>2]=ea(0.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[r>>2]=ea(0.0);g[s>>2]=ea(0.0);if(!h){i=d;return}w=e+4|0;y=e+8|0;z=e+12|0;A=e+16|0;B=e+20|0;C=e+24|0;D=e+28|0;E=e+32|0;F=t+4|0;G=t+8|0;H=b+112|0;I=b+128|0;J=u+4|0;K=u+8|0;L=v+4|0;M=v+8|0;N=b+92|0;O=x;x=0;while(1){P=x*3|0;j=ea(g[f+(P*12|0)>>2]);Q=ea(g[e>>2]);R=ea(j*Q);S=ea(g[w>>2]);T=ea(j*S);U=ea(g[y>>2]);V=ea(j*U);j=ea(g[f+(P*12|0)+4>>2]);W=ea(g[z>>2]);X=ea(j*W);Y=ea(g[A>>2]);Z=ea(j*Y);_=ea(g[B>>2]);$=ea(R+X);X=ea(T+Z);Z=ea(V+ea(j*_));j=ea(g[f+(P*12|0)+8>>2]);V=ea(g[C>>2]);T=ea(j*V);R=ea(g[D>>2]);aa=ea(j*R);ba=ea(g[E>>2]);ca=ea($+T);T=ea(X+aa);aa=ea(Z+ea(j*ba));g[t>>2]=ca;g[F>>2]=T;g[G>>2]=aa;da=P+1|0;j=ea(g[f+(da*12|0)>>2]);Z=ea(j*Q);X=ea(j*S);$=ea(j*U);j=ea(g[f+(da*12|0)+4>>2]);fa=ea(Z+ea(j*W));Z=ea(X+ea(j*Y));X=ea($+ea(j*_));j=ea(g[f+(da*12|0)+8>>2]);$=ea(fa+ea(j*V));fa=ea(Z+ea(j*R));Z=ea(X+ea(j*ba));da=P+2|0;j=ea(g[f+(da*12|0)>>2]);X=ea(Q*j);Q=ea(S*j);S=ea(U*j);j=ea(g[f+(da*12|0)+4>>2]);U=ea(X+ea(W*j));W=ea(Q+ea(Y*j));Y=ea(S+ea(_*j));j=ea(g[f+(da*12|0)+8>>2]);_=ea(U+ea(V*j));V=ea(W+ea(R*j));R=ea(Y+ea(ba*j));j=ea(fa-T);fa=ea(Z-aa);g[u>>2]=ea($-ca);g[J>>2]=j;g[K>>2]=fa;fa=ea(V-T);T=ea(R-aa);g[v>>2]=ea(_-ca);g[L>>2]=fa;g[M>>2]=T;da=G0a(n,o,p,q,r,s,H,I,t,u,v,O<<24>>24!=0,N,l)|0;T=ea(g[r>>2]);H0a(b,m,da,T,ea(g[s>>2]),n,o,p,q,k);da=x+1|0;if((da|0)==(h|0))break;O=a[m>>0]|0;x=da}i=d;return}function $ta(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=ea(k);l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=0,eb=0;l=i;i=i+320|0;m=l+288|0;n=l+240|0;o=l+208|0;p=l+136|0;q=l+112|0;r=l;s=c[d+40>>2]|0;j=ea(g[e+16>>2]);h=ea(g[e+20>>2]);t=ea(j*ea(-2.0));j=ea(h*ea(-2.0));h=ea(ea(g[e+24>>2])*ea(-2.0));u=ea(g[e+12>>2]);v=ea(ea(u*u)+ea(-.5));w=ea(g[e>>2]);x=ea(t*w);y=ea(g[e+4>>2]);z=ea(x+ea(j*y));x=ea(g[e+8>>2]);A=ea(z+ea(h*x));z=ea(ea(w*A)+ea(ea(t*v)-ea(u*ea(ea(h*y)-ea(j*x)))));B=ea(ea(y*A)+ea(ea(j*v)-ea(u*ea(ea(t*x)-ea(h*w)))));C=ea(ea(ea(h*v)-ea(u*ea(ea(j*w)-ea(t*y))))+ea(x*A));A=ea(-y);y=ea(-x);g[o>>2]=ea(-w);g[o+4>>2]=A;g[o+8>>2]=y;g[o+12>>2]=u;g[o+16>>2]=z;g[o+20>>2]=B;g[o+24>>2]=C;D=d+4|0;i_a(n,o,D);I0a(m,n,s+128|0);if(ea(g[D>>2])==ea(1.0)?ea(g[d+8>>2])==ea(1.0):0)E=ea(g[d+12>>2])==ea(1.0);else E=0;g[p>>2]=ea(1.0);n=p+4|0;g[n>>2]=ea(0.0);o=p+8|0;g[o>>2]=ea(0.0);F=p+12|0;g[F>>2]=ea(0.0);G=p+16|0;g[G>>2]=ea(1.0);H=p+20|0;g[H>>2]=ea(0.0);I=p+24|0;g[I>>2]=ea(0.0);J=p+28|0;g[J>>2]=ea(0.0);K=p+32|0;g[K>>2]=ea(1.0);L=p+36|0;g[L>>2]=ea(1.0);M=p+40|0;g[M>>2]=ea(0.0);N=p+44|0;g[N>>2]=ea(0.0);O=p+48|0;g[O>>2]=ea(0.0);P=p+52|0;g[P>>2]=ea(1.0);Q=p+56|0;g[Q>>2]=ea(0.0);R=p+60|0;g[R>>2]=ea(0.0);S=p+64|0;g[S>>2]=ea(0.0);T=p+68|0;g[T>>2]=ea(1.0);if(!E)J0a(p,D,d+16|0);d=b+8|0;D=c[d>>2]|0;if(!D){i=l;return}U=b+12|0;V=q+4|0;W=q+8|0;X=q+12|0;Y=q+16|0;Z=q+20|0;_=b+4|0;C=ea(g[m>>2]);B=ea(g[m+12>>2]);z=ea(g[m+4>>2]);u=ea(g[m+16>>2]);y=ea(g[m+8>>2]);A=ea(g[m+20>>2]);m=r+4|0;b=r+8|0;$=r+12|0;aa=r+16|0;ba=r+20|0;ca=r+24|0;da=r+28|0;fa=r+32|0;ga=r+36|0;ha=r+40|0;ia=r+44|0;ja=r+48|0;ka=r+52|0;la=r+56|0;ma=r+60|0;na=r+64|0;oa=r+68|0;pa=r+72|0;qa=r+76|0;ra=r+80|0;sa=r+84|0;ta=r+88|0;ua=r+92|0;va=r+96|0;wa=r+100|0;xa=r+104|0;ya=D;D=0;while(1){za=c[U>>2]|0;Aa=c[za+(D<<4)+8>>2]|0;if((Aa|0)!=-1){g[q>>2]=ea(8507058669999999534545717.0e13);g[V>>2]=ea(8507058669999999534545717.0e13);g[W>>2]=ea(8507058669999999534545717.0e13);g[X>>2]=ea(-8507058669999999534545717.0e13);g[Y>>2]=ea(-8507058669999999534545717.0e13);g[Z>>2]=ea(-8507058669999999534545717.0e13);Ba=c[_>>2]|0;Ca=c[za+(D<<4)+12>>2]|0;za=Ba+(Aa+Ca<<2)|0;Da=(Aa|0)==0;if(Da){Ea=ea(-8507058669999999534545717.0e13);Fa=ea(-8507058669999999534545717.0e13);Ga=ea(-8507058669999999534545717.0e13);Ha=ea(8507058669999999534545717.0e13);Ia=ea(8507058669999999534545717.0e13);Ja=ea(8507058669999999534545717.0e13);Ka=ea(8507058669999999534545717.0e13);La=ea(8507058669999999534545717.0e13);Ma=ea(8507058669999999534545717.0e13);Na=ea(-8507058669999999534545717.0e13);Oa=ea(-8507058669999999534545717.0e13);Pa=ea(-8507058669999999534545717.0e13)}else{w=ea(8507058669999999534545717.0e13);x=ea(8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);j=ea(-8507058669999999534545717.0e13);v=ea(-8507058669999999534545717.0e13);h=ea(-8507058669999999534545717.0e13);Qa=ea(8507058669999999534545717.0e13);Ra=ea(8507058669999999534545717.0e13);Sa=ea(8507058669999999534545717.0e13);Ta=ea(-8507058669999999534545717.0e13);Ua=ea(-8507058669999999534545717.0e13);Va=ea(-8507058669999999534545717.0e13);Wa=Ba+(Ca<<2)|0;do{Xa=c[Wa>>2]|0;Ya=ea(g[a+(Xa*176|0)+48>>2]);w=w<Ya?w:Ya;Za=ea(g[a+(Xa*176|0)+52>>2]);x=x<Za?x:Za;_a=ea(g[a+(Xa*176|0)+56>>2]);t=t<_a?t:_a;j=j>Ya?j:Ya;v=v>Za?v:Za;h=h>_a?h:_a;_a=ea(g[a+(Xa*176|0)+64>>2]);Qa=Qa<_a?Qa:_a;Za=ea(g[a+(Xa*176|0)+68>>2]);Ra=Ra<Za?Ra:Za;Ya=ea(g[a+(Xa*176|0)+72>>2]);Sa=Sa<Ya?Sa:Ya;Ta=Ta>_a?Ta:_a;Ua=Ua>Za?Ua:Za;Va=Va>Ya?Va:Ya;Wa=Wa+4|0}while((Wa|0)!=(za|0));g[q>>2]=w;g[V>>2]=x;g[W>>2]=t;g[X>>2]=j;g[Y>>2]=v;g[Z>>2]=h;Ea=Va;Fa=Ua;Ga=Ta;Ha=Sa;Ia=Ra;Ja=Qa;Ka=w;La=x;Ma=t;Na=j;Oa=v;Pa=h}Ya=ea(Ja-k);Za=ea(Ia-k);_a=ea(Ha-k);$a=ea(Ga+k);ab=ea(Fa+k);bb=ea(Ea+k);cb=Ka<Ya?Ka:Ya;Ya=La<Za?La:Za;Za=Ma<_a?Ma:_a;g[q>>2]=cb;g[V>>2]=Ya;g[W>>2]=Za;_a=Na>$a?Na:$a;$a=Oa>ab?Oa:ab;ab=Pa>bb?Pa:bb;g[X>>2]=_a;g[Y>>2]=$a;g[Z>>2]=ab;if(!(Za>A)&((C>_a|cb>B|z>$a|Ya>u|y>ab)^1)){za=Ba+(Ca<<2)|0;c[m>>2]=2;c[r>>2]=492256;c[b>>2]=a;c[$>>2]=za;c[aa>>2]=Aa;c[ba>>2]=s;g[ca>>2]=ea(g[p>>2]);g[da>>2]=ea(g[n>>2]);g[fa>>2]=ea(g[o>>2]);g[ga>>2]=ea(g[F>>2]);g[ha>>2]=ea(g[G>>2]);g[ia>>2]=ea(g[H>>2]);g[ja>>2]=ea(g[I>>2]);g[ka>>2]=ea(g[J>>2]);g[la>>2]=ea(g[K>>2]);g[ma>>2]=ea(g[L>>2]);g[na>>2]=ea(g[M>>2]);g[oa>>2]=ea(g[N>>2]);g[pa>>2]=ea(g[O>>2]);g[qa>>2]=ea(g[P>>2]);g[ra>>2]=ea(g[Q>>2]);g[sa>>2]=ea(g[R>>2]);g[ta>>2]=ea(g[S>>2]);g[ua>>2]=ea(g[T>>2]);g[va>>2]=k;c[wa>>2]=0;c[xa>>2]=f;if(!Da){Wa=za;za=0;while(1){Xa=c[Wa>>2]|0;g[a+(Xa*176|0)+144>>2]=ea(0.0);g[a+(Xa*176|0)+148>>2]=ea(0.0);g[a+(Xa*176|0)+152>>2]=ea(0.0);db=a+(Xa*176|0)+160|0;za=za+1|0;c[db+0>>2]=0;c[db+4>>2]=0;c[db+8>>2]=0;c[db+12>>2]=0;if((za|0)==(Aa|0))break;else Wa=Wa+4|0}}Zta(s,e,p,E,q,r);eb=c[d>>2]|0}else eb=ya}else eb=ya;D=D+1|0;if(D>>>0>=eb>>>0)break;else ya=eb}i=l;return}function aua(d,f,h,j,k,l,m,n,o){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=ea(n);o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=Im,fb=0,gb=Im,hb=Im,ib=0,jb=Im,kb=Im,lb=Im,mb=0,nb=0,ob=Im,pb=0,qb=Im,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im;p=i;i=i+512|0;q=p+8|0;r=p+440|0;s=p+80|0;t=p+448|0;u=p+480|0;v=p;w=p+116|0;x=p+456|0;y=j+4|0;if(ea(g[y>>2])==ea(1.0)?ea(g[j+8>>2])==ea(1.0):0)z=ea(g[j+12>>2])==ea(1.0);else z=0;g[q>>2]=ea(1.0);A=q+4|0;g[A>>2]=ea(0.0);B=q+8|0;g[B>>2]=ea(0.0);C=q+12|0;g[C>>2]=ea(0.0);D=q+16|0;g[D>>2]=ea(1.0);E=q+20|0;g[E>>2]=ea(0.0);F=q+24|0;g[F>>2]=ea(0.0);G=q+28|0;g[G>>2]=ea(0.0);H=q+32|0;g[H>>2]=ea(1.0);I=q+36|0;g[I>>2]=ea(1.0);J=q+40|0;g[J>>2]=ea(0.0);K=q+44|0;g[K>>2]=ea(0.0);L=q+48|0;g[L>>2]=ea(0.0);M=q+52|0;g[M>>2]=ea(1.0);N=q+56|0;g[N>>2]=ea(0.0);O=q+60|0;g[O>>2]=ea(0.0);P=q+64|0;g[P>>2]=ea(0.0);Q=q+68|0;g[Q>>2]=ea(1.0);if(!z)J0a(q,y,j+16|0);m=ea(ea(n*ea(4.0))+o);g[r+4>>2]=ea(ea(ea(1.0)/m)*ea(254.0));g[r>>2]=ea(m*ea(.00393700786));y=c[j+40>>2]|0;R=(c[y+4>>2]|0)>>>0<65536;c[t>>2]=0;if(!d){i=p;return}S=u+4|0;T=u+8|0;U=u+12|0;V=u+16|0;W=u+20|0;X=y+12|0;Y=y+8|0;Z=w+4|0;_=w+8|0;$=w+12|0;aa=w+16|0;ba=w+20|0;ca=w+24|0;da=w+28|0;fa=w+32|0;ga=w+36|0;ha=w+40|0;ia=w+44|0;ja=w+48|0;ka=w+52|0;la=w+56|0;ma=w+60|0;na=w+64|0;oa=w+68|0;pa=w+72|0;qa=w+76|0;ra=w+80|0;sa=w+84|0;ta=w+88|0;ua=w+92|0;va=w+96|0;wa=w+100|0;xa=w+104|0;m=ea(o*ea(1.5));ya=x+4|0;za=x+8|0;Aa=x+12|0;Ba=x+16|0;Ca=x+20|0;Da=w+4|0;Ea=w+8|0;Fa=w+12|0;Ga=w+16|0;Ha=w+20|0;Ia=w+24|0;Ja=w+28|0;Ka=w+32|0;La=w+36|0;Ma=w+40|0;Na=w+44|0;Oa=w+48|0;Pa=w+52|0;Qa=w+56|0;Ra=w+60|0;Sa=w+64|0;Ta=w+68|0;Ua=w+72|0;Va=w+76|0;Wa=w+80|0;Xa=w+84|0;Ya=w+88|0;Za=w+92|0;_a=w+96|0;$a=w+100|0;ab=w+104|0;bb=0;do{cb=h+(bb<<5)|0;db=f+(bb*176|0)+64|0;n=ea(g[db>>2]);eb=ea(n-o);fb=f+(bb*176|0)+68|0;gb=ea(g[fb>>2]);hb=ea(gb-o);ib=f+(bb*176|0)+72|0;jb=ea(g[ib>>2]);kb=ea(jb-o);lb=ea(n+o);n=ea(gb+o);gb=ea(jb+o);mb=f+(bb*176|0)+48|0;jb=ea(g[mb>>2]);nb=f+(bb*176|0)+52|0;ob=ea(g[nb>>2]);pb=f+(bb*176|0)+56|0;qb=ea(g[pb>>2]);g[u>>2]=eb<jb?eb:jb;g[S>>2]=hb<ob?hb:ob;g[T>>2]=kb<qb?kb:qb;g[U>>2]=lb>jb?lb:jb;g[V>>2]=n>ob?n:ob;g[W>>2]=gb>qb?gb:qb;c[v>>2]=0;rb=f+(bb*176|0)+62|0;do if(K0a(cb,rb,v,s,u,r,j,R)|0){sb=c[v>>2]|0;if(sb){tb=c[X>>2]|0;ub=c[Y>>2]|0;if(R){vb=0;wb=s;while(1){xb=vb*3|0;yb=xb+1|0;zb=xb+2|0;Ab=((c[wb>>2]|0)*6|0)+tb|0;Bb=((e[Ab>>1]|0)*12|0)+ub|0;Cb=((e[Ab+2>>1]|0)*12|0)+ub|0;Db=((e[Ab+4>>1]|0)*12|0)+ub|0;g[w+(xb*12|0)>>2]=ea(g[Bb>>2]);g[w+(xb*12|0)+4>>2]=ea(g[Bb+4>>2]);g[w+(xb*12|0)+8>>2]=ea(g[Bb+8>>2]);g[w+(yb*12|0)>>2]=ea(g[Cb>>2]);g[w+(yb*12|0)+4>>2]=ea(g[Cb+4>>2]);g[w+(yb*12|0)+8>>2]=ea(g[Cb+8>>2]);g[w+(zb*12|0)>>2]=ea(g[Db>>2]);g[w+(zb*12|0)+4>>2]=ea(g[Db+4>>2]);g[w+(zb*12|0)+8>>2]=ea(g[Db+8>>2]);vb=vb+1|0;if(vb>>>0>=sb>>>0)break;else wb=wb+4|0}}else{wb=0;vb=s;while(1){Db=wb*3|0;zb=Db+1|0;Cb=Db+2|0;yb=((c[vb>>2]|0)*12|0)+tb|0;Bb=((c[yb>>2]|0)*12|0)+ub|0;xb=((c[yb+4>>2]|0)*12|0)+ub|0;Ab=((c[yb+8>>2]|0)*12|0)+ub|0;g[w+(Db*12|0)>>2]=ea(g[Bb>>2]);g[w+(Db*12|0)+4>>2]=ea(g[Bb+4>>2]);g[w+(Db*12|0)+8>>2]=ea(g[Bb+8>>2]);g[w+(zb*12|0)>>2]=ea(g[xb>>2]);g[w+(zb*12|0)+4>>2]=ea(g[xb+4>>2]);g[w+(zb*12|0)+8>>2]=ea(g[xb+8>>2]);g[w+(Cb*12|0)>>2]=ea(g[Ab>>2]);g[w+(Cb*12|0)+4>>2]=ea(g[Ab+4>>2]);g[w+(Cb*12|0)+8>>2]=ea(g[Ab+8>>2]);wb=wb+1|0;if(wb>>>0>=sb>>>0)break;else vb=vb+4|0}}vb=c[t>>2]|0;g[f+(vb*176|0)+144>>2]=ea(0.0);g[f+(vb*176|0)+148>>2]=ea(0.0);g[f+(vb*176|0)+152>>2]=ea(0.0);wb=f+(vb*176|0)+160|0;c[wb+0>>2]=0;c[wb+4>>2]=0;c[wb+8>>2]=0;c[wb+12>>2]=0;_ta(f+(vb*176|0)|0,0,q,w,sb,o,l)}}else if((b[rb>>1]&48)==48){c[Z>>2]=2;c[w>>2]=492256;c[_>>2]=f;c[$>>2]=t;c[aa>>2]=1;c[ba>>2]=y;g[ca>>2]=ea(g[q>>2]);g[da>>2]=ea(g[A>>2]);g[fa>>2]=ea(g[B>>2]);g[ga>>2]=ea(g[C>>2]);g[ha>>2]=ea(g[D>>2]);g[ia>>2]=ea(g[E>>2]);g[ja>>2]=ea(g[F>>2]);g[ka>>2]=ea(g[G>>2]);g[la>>2]=ea(g[H>>2]);g[ma>>2]=ea(g[I>>2]);g[na>>2]=ea(g[J>>2]);g[oa>>2]=ea(g[K>>2]);g[pa>>2]=ea(g[L>>2]);g[qa>>2]=ea(g[M>>2]);g[ra>>2]=ea(g[N>>2]);g[sa>>2]=ea(g[O>>2]);g[ta>>2]=ea(g[P>>2]);g[ua>>2]=ea(g[Q>>2]);g[va>>2]=o;c[wa>>2]=0;c[xa>>2]=l;vb=c[t>>2]|0;g[f+(vb*176|0)+144>>2]=ea(0.0);g[f+(vb*176|0)+148>>2]=ea(0.0);g[f+(vb*176|0)+152>>2]=ea(0.0);wb=f+(vb*176|0)+160|0;c[wb+0>>2]=0;c[wb+4>>2]=0;c[wb+8>>2]=0;c[wb+12>>2]=0;Zta(y,k,q,z,u,w);break}else{qb=ea(g[db>>2]);gb=ea(g[mb>>2]);ob=ea(qb-gb);n=ea(g[fb>>2]);jb=ea(g[nb>>2]);lb=ea(n-jb);kb=ea(g[ib>>2]);hb=ea(g[pb>>2]);eb=ea(qb+ea(ob*ea(3.0)));ob=ea(n+ea(lb*ea(3.0)));lb=ea(kb+ea(ea(kb-hb)*ea(3.0)));Eb=ea(eb-m);Fb=ea(ob-m);Gb=ea(lb-m);Hb=ea(m+eb);eb=ea(m+ob);ob=ea(m+lb);lb=ea(qb-m);Ib=ea(n-m);Jb=ea(kb-m);Kb=ea(m+qb);qb=ea(m+n);n=ea(m+kb);kb=Eb<lb?Eb:lb;lb=Fb<Ib?Fb:Ib;Ib=Gb<Jb?Gb:Jb;Jb=Hb>Kb?Hb:Kb;Kb=eb>qb?eb:qb;qb=ob>n?ob:n;g[x>>2]=kb<gb?kb:gb;g[ya>>2]=lb<jb?lb:jb;g[za>>2]=Ib<hb?Ib:hb;g[Aa>>2]=Jb>gb?Jb:gb;g[Ba>>2]=Kb>jb?Kb:jb;g[Ca>>2]=qb>hb?qb:hb;a[cb>>0]=0;c[h+(bb<<5)+28>>2]=s;c[Da>>2]=2;c[w>>2]=492256;c[Ea>>2]=f;c[Fa>>2]=t;c[Ga>>2]=1;c[Ha>>2]=y;g[Ia>>2]=ea(g[q>>2]);g[Ja>>2]=ea(g[A>>2]);g[Ka>>2]=ea(g[B>>2]);g[La>>2]=ea(g[C>>2]);g[Ma>>2]=ea(g[D>>2]);g[Na>>2]=ea(g[E>>2]);g[Oa>>2]=ea(g[F>>2]);g[Pa>>2]=ea(g[G>>2]);g[Qa>>2]=ea(g[H>>2]);g[Ra>>2]=ea(g[I>>2]);g[Sa>>2]=ea(g[J>>2]);g[Ta>>2]=ea(g[K>>2]);g[Ua>>2]=ea(g[L>>2]);g[Va>>2]=ea(g[M>>2]);g[Wa>>2]=ea(g[N>>2]);g[Xa>>2]=ea(g[O>>2]);g[Ya>>2]=ea(g[P>>2]);g[Za>>2]=ea(g[Q>>2]);g[_a>>2]=o;c[$a>>2]=cb;c[ab>>2]=l;wb=c[t>>2]|0;g[f+(wb*176|0)+144>>2]=ea(0.0);g[f+(wb*176|0)+148>>2]=ea(0.0);g[f+(wb*176|0)+152>>2]=ea(0.0);vb=f+(wb*176|0)+160|0;c[vb+0>>2]=0;c[vb+4>>2]=0;c[vb+8>>2]=0;c[vb+12>>2]=0;Zta(y,k,q,z,x,w);L0a(cb,rb,x,r,j,R);break}while(0);bb=(c[t>>2]|0)+1|0;c[t>>2]=bb}while(bb>>>0<d>>>0);i=p;return}
function bua(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im;j=i;i=i+256|0;k=j+4|0;l=j+52|0;m=j+184|0;n=j+108|0;o=j+88|0;p=j+144|0;q=j+244|0;r=j+220|0;s=j+232|0;t=j+72|0;u=j+20|0;v=j+84|0;w=j;x=j+32|0;y=j+8|0;z=j+208|0;g[k>>2]=f;c[l+12>>2]=c[e+4>>2];c[l+16>>2]=e;g[l+4>>2]=ea(ea(1.0)/ea(g[e+8>>2]));g[l>>2]=ea(ea(1.0)/ea(g[e+12>>2]));g[l+8>>2]=ea(ea(1.0)/ea(g[e+16>>2]));if(!d){i=j;return}e=m+4|0;A=m+8|0;B=m+12|0;C=m+16|0;D=m+20|0;E=n+4|0;F=n+12|0;G=n+20|0;H=r+4|0;I=r+8|0;J=s+4|0;K=s+8|0;L=t+4|0;M=t+8|0;N=u+4|0;O=u+8|0;P=x+12|0;Q=x+8|0;R=x+16|0;S=x+4|0;T=p+4|0;U=p+8|0;V=p+12|0;W=p+16|0;X=p+20|0;Y=p+24|0;Z=p+28|0;_=p+32|0;$=y+4|0;aa=y+8|0;ba=z+4|0;ca=z+8|0;fa=f;ga=0;while(1){ha=b+(ga*176|0)|0;ia=b+(ga*176|0)+112|0;ja=b+(ga*176|0)+128|0;f=ea(g[ia>>2]);ka=ea(g[ja>>2]);la=ea(g[b+(ga*176|0)+116>>2]);ma=ea(g[b+(ga*176|0)+132>>2]);na=ea(g[b+(ga*176|0)+120>>2]);oa=ea(g[b+(ga*176|0)+136>>2]);g[m>>2]=ea((f<ka?f:ka)-fa);g[e>>2]=ea((la<ma?la:ma)-fa);g[A>>2]=ea((na<oa?na:oa)-fa);g[B>>2]=ea(fa+(f>ka?f:ka));g[C>>2]=ea(fa+(la>ma?la:ma));g[D>>2]=ea(fa+(na>oa?na:oa));M0a(n,m,l);N0a(o,n);if(!(a[E>>0]|0))pa=(da(c[(c[(c[n>>2]|0)+12>>2]|0)+20>>2]|0,c[F>>2]|0)|0)+(c[G>>2]|0)|0;else pa=0;g[b+(ga*176|0)+144>>2]=ea(0.0);g[b+(ga*176|0)+148>>2]=ea(0.0);g[b+(ga*176|0)+152>>2]=ea(0.0);qa=b+(ga*176|0)+160|0;c[qa+0>>2]=0;c[qa+4>>2]=0;c[qa+8>>2]=0;c[qa+12>>2]=0;a[q>>0]=(c[b+(ga*176|0)+124>>2]|0)>>>1&1;g[r>>2]=ea(0.0);g[H>>2]=ea(0.0);g[I>>2]=ea(0.0);g[s>>2]=ea(0.0);g[J>>2]=ea(0.0);g[K>>2]=ea(0.0);g[t>>2]=ea(0.0);g[L>>2]=ea(0.0);g[M>>2]=ea(0.0);g[u>>2]=ea(0.0);g[N>>2]=ea(0.0);g[O>>2]=ea(0.0);g[v>>2]=ea(g[b+(ga*176|0)+44>>2]);g[w>>2]=ea(0.0);c[x+0>>2]=c[o+0>>2];c[x+4>>2]=c[o+4>>2];c[x+8>>2]=c[o+8>>2];c[x+12>>2]=c[o+12>>2];c[x+16>>2]=c[o+16>>2];qa=b+(ga*176|0)+92|0;while(1){ra=c[Q>>2]|0;sa=c[P>>2]|0;if((ra|0)==0&(pa|0)==(sa|0))break;ta=c[R>>2]|0;ua=(a[ta+32>>0]|0)!=0;O0a(c[(c[ta>>2]|0)+12>>2]|0,(sa<<1)+ra|0,c[x>>2]|0,c[S>>2]|0,p,p+((ua?2:1)*12|0)|0,p+((ua?1:2)*12|0)|0);oa=ea(g[p>>2]);ua=c[(c[ta>>2]|0)+16>>2]|0;na=ea(g[ua+12>>2]);ma=ea(oa*na);oa=ea(g[T>>2]);la=ea(g[ua+8>>2]);ka=ea(oa*la);oa=ea(g[U>>2]);f=ea(g[ua+16>>2]);va=ea(oa*f);g[p>>2]=ma;g[T>>2]=ka;g[U>>2]=va;oa=ea(ea(g[V>>2])*na);wa=ea(ea(g[W>>2])*la);xa=ea(ea(g[X>>2])*f);g[V>>2]=oa;g[W>>2]=wa;g[X>>2]=xa;ya=ea(ea(g[Y>>2])*na);na=ea(ea(g[Z>>2])*la);la=ea(ea(g[_>>2])*f);g[Y>>2]=ya;g[Z>>2]=na;g[_>>2]=la;f=ea(wa-ka);wa=ea(xa-va);g[y>>2]=ea(oa-ma);g[$>>2]=f;g[aa>>2]=wa;wa=ea(na-ka);ka=ea(la-va);g[z>>2]=ea(ya-ma);g[ba>>2]=wa;g[ca>>2]=ka;ua=G0a(r,s,t,u,v,w,ia,ja,p,y,z,(a[q>>0]|0)!=0,qa,k)|0;ka=ea(g[v>>2]);H0a(ha,q,ua,ka,ea(g[w>>2]),r,s,t,u,h);P0a(x)|0}ha=ga+1|0;if((ha|0)==(d|0))break;fa=ea(g[k>>2]);ga=ha}i=j;return}function cua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0;c=i;if(!b){i=c;return}else e=0;do{Q0a(a+(e*176|0)|0,d);e=e+1|0}while((e|0)!=(b|0));i=c;return}function dua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0,f=0;e=i;if(!b){i=e;return}else f=0;do{R0a(a+(f*176|0)|0,c,d);f=f+1|0}while((f|0)!=(b|0));i=e;return}function eua(a,d,f,g,h,j,k,l){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;m=i;i=i+64|0;n=m;if(!j){i=m;return}o=j+-1|0;p=l+8|0;q=(a|0)==0;a=l+28|0;r=l+32|0;l=0;do{s=g+(l<<4)+8|0;t=c[s>>2]|0;if((t|0)!=-1){u=e[g+(l<<4)>>1]|0;v=e[g+(l<<4)+2>>1]|0;w=e[g+(l<<4)+4>>1]|0;x=0;do{y=(e[492272+(x*6|0)>>1]|0)+u|0;z=y&65535;A=(e[492274+(x*6|0)>>1]|0)+v|0;B=A&65535;C=(e[492276+(x*6|0)>>1]|0)+w|0;D=C&65535;E=((A<<16>>16)*101|0)+(y<<16>>16)+((C<<16>>16)*7919|0)&o;C=c[g+(E<<4)+8>>2]|0;a:do if((C|0)!=-1){y=C;A=E;while(1){if((z<<16>>16==(b[g+(A<<4)>>1]|0)?B<<16>>16==(b[g+(A<<4)+2>>1]|0):0)?D<<16>>16==(b[g+(A<<4)+4>>1]|0):0)break;F=A+1&o;G=c[g+(F<<4)+8>>2]|0;if((G|0)==-1){H=0;break a}else{y=G;A=F}}if((y|0)!=-1)H=g+(A<<4)|0;else H=0}else H=0;while(0);c[n+(x<<2)>>2]=H;x=x+1|0}while((x|0)!=13);if(t>>>0>1){x=g+(l<<4)+12|0;w=t;v=1;do{u=(c[x>>2]|0)+v|0;S0a(d,d,f,f,h+(u+-1<<2)|0,1,h+(u<<2)|0,w-v|0,1,q,k,c[a>>2]|0,c[r>>2]|0);v=v+1|0;w=c[s>>2]|0}while(v>>>0<w>>>0);I=0;J=0}else{I=0;J=0}while(1){w=c[n+(I<<2)>>2]|0;if((w|0)!=0?(v=c[w+12>>2]|0,x=c[w+8>>2]|0,w=x+v|0,v>>>0<w>>>0):0){t=c[p>>2]|0;u=v;v=J;while(1){c[t+(v<<2)>>2]=c[h+(u<<2)>>2];u=u+1|0;if((u|0)==(w|0))break;else v=v+1|0}K=J+x|0}else K=J;I=I+1|0;if((I|0)==13)break;else J=K}if(K)S0a(d,d,f,f,h+(c[g+(l<<4)+12>>2]<<2)|0,c[s>>2]|0,c[p>>2]|0,K,1,q,k,c[a>>2]|0,c[r>>2]|0)}l=l+1|0}while((l|0)!=(j|0));i=m;return}function fua(a,d,f,g,h,j,k,l,m,n,o,p,q,r,s){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;t=i;i=i+112|0;u=t;v=s?o:n;w=s?l:m;x=s?j:k;y=s?k:j;j=y+(v<<4)|0;if((v|0)<=0){i=t;return}v=(s?n:o)+-1|0;o=r+8|0;n=(a|0)==0;a=r+28|0;k=r+32|0;r=y;do{y=r+8|0;do if((c[y>>2]|0)!=-1){z=e[r>>1]|0;A=e[r+2>>1]|0;B=e[r+4>>1]|0;C=0;while(1){D=(e[492352+(C*6|0)>>1]|0)+z|0;E=D&65535;F=(e[492354+(C*6|0)>>1]|0)+A|0;G=F&65535;H=(e[492356+(C*6|0)>>1]|0)+B|0;I=H&65535;J=((F<<16>>16)*101|0)+(D<<16>>16)+((H<<16>>16)*7919|0)&v;H=c[x+(J<<4)+8>>2]|0;a:do if((H|0)!=-1){D=H;F=J;while(1){if((E<<16>>16==(b[x+(F<<4)>>1]|0)?G<<16>>16==(b[x+(F<<4)+2>>1]|0):0)?I<<16>>16==(b[x+(F<<4)+4>>1]|0):0)break;K=F+1&v;L=c[x+(K<<4)+8>>2]|0;if((L|0)==-1){M=0;break a}else{D=L;F=K}}if((D|0)!=-1)M=x+(F<<4)|0;else M=0}else M=0;while(0);c[u+(C<<2)>>2]=M;C=C+1|0;if((C|0)==27){N=0;O=0;break}}while(1){C=c[u+(O<<2)>>2]|0;if((C|0)!=0?(B=c[C+12>>2]|0,A=c[C+8>>2]|0,C=A+B|0,B>>>0<C>>>0):0){z=c[o>>2]|0;I=B;B=N;while(1){c[z+(B<<2)>>2]=c[w+(I<<2)>>2];I=I+1|0;if((I|0)==(C|0))break;else B=B+1|0}P=N+A|0}else P=N;O=O+1|0;if((O|0)==27)break;else N=P}if(P)if(s){S0a(d,f,g,h,c[o>>2]|0,P,m+(c[r+12>>2]<<2)|0,c[y>>2]|0,p,n,q,c[a>>2]|0,c[k>>2]|0);break}else{S0a(d,f,g,h,l+(c[r+12>>2]<<2)|0,c[y>>2]|0,c[o>>2]|0,P,p,n,q,c[a>>2]|0,c[k>>2]|0);break}}while(0);r=r+16|0}while(r>>>0<j>>>0);i=t;return}function gua(a,d){a=a|0;d=d|0;c[a>>2]=d;c[a+4>>2]=0;c[a+96>>2]=0;d=a+100|0;b[a+104>>1]=-1;b[a+106>>1]=0;c[a+108>>2]=0;c[d>>2]=443968;c[a+112>>2]=0;c[a+116>>2]=0;c[d>>2]=496864;c[a+120>>2]=a;c[a+124>>2]=496648;d=a+128|0;b[a+132>>1]=-1;b[a+134>>1]=0;c[a+136>>2]=0;c[d>>2]=443968;c[a+140>>2]=0;c[a+144>>2]=0;c[d>>2]=496816;c[a+148>>2]=a;c[a+152>>2]=496680;c[a+164>>2]=0;return}function hua(a){a=a|0;c[a+128>>2]=443968;c[a+136>>2]=0;c[a+100>>2]=443968;c[a+108>>2]=0;return}function iua(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;if(!e){jua(a,0);i=b;return}f=e+(0-(c[e+-4>>2]|0))|0;if(f){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,f)}c[d>>2]=0;jua(a,0);i=b;return}function jua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+16|0;e=d+6|0;f=d+5|0;g=d+11|0;h=d+9|0;j=d+8|0;k=d+10|0;l=d+12|0;m=d+13|0;n=d+2|0;o=d+1|0;p=d+7|0;q=d+3|0;r=d;s=d+4|0;t=a+164|0;u=c[t>>2]|0;if(u>>>0>b>>>0){v=b;do{w=a+(v*44|0)+200|0;x=c[w>>2]|0;if(x){VJa(e,x);c[w>>2]=0}w=a+(v*44|0)+208|0;x=c[w>>2]|0;if(x){VJa(f,x);c[w>>2]=0}w=a+(v*44|0)+176|0;x=c[w>>2]|0;if(x){VJa(g,x);c[w>>2]=0}w=a+(v*44|0)+168|0;x=c[w>>2]|0;if(x){VJa(h,x);c[w>>2]=0}w=a+(v*44|0)+172|0;x=c[w>>2]|0;if(x){VJa(j,x);c[w>>2]=0}w=a+(v*44|0)+188|0;x=c[w>>2]|0;if(x){VJa(k,x);c[w>>2]=0}w=a+(v*44|0)+184|0;x=c[w>>2]|0;if(x){VJa(l,x);c[w>>2]=0}w=a+(v*44|0)+196|0;x=c[w>>2]|0;if(x){y=x+(0-(c[x+-4>>2]|0))|0;if(y){x=mKa()|0;In[c[(c[x>>2]|0)+12>>2]&4095](x,y)}c[w>>2]=0}w=a+(v*44|0)+180|0;y=c[w>>2]|0;if(y){x=y+(0-(c[y+-4>>2]|0))|0;if(x){y=mKa()|0;In[c[(c[y>>2]|0)+12>>2]&4095](y,x)}c[w>>2]=0}v=v+1|0;w=c[t>>2]|0}while(v>>>0<w>>>0);z=w}else z=u;if(z>>>0<b>>>0)A=z;else{c[t>>2]=b;i=d;return}do{z=a+(A*44|0)+192|0;c[z>>2]=1024;c[a+(A*44|0)+184>>2]=UJa(m,16384,496712,258)|0;c[a+(A*44|0)+188>>2]=UJa(n,c[z>>2]<<4,496712,259)|0;c[a+(A*44|0)+168>>2]=UJa(o,2048,496712,262)|0;c[a+(A*44|0)+172>>2]=UJa(p,2048,496712,263)|0;c[a+(A*44|0)+176>>2]=UJa(q,2048,496712,264)|0;z=mKa()|0;u=c[(c[z>>2]|0)+8>>2]|0;v=pKa()|0;l=mo[c[(c[v>>2]|0)+24>>2]&4095](v)|0;v=Bn[u&255](z,16403,l?528936:544544,496712,265)|0;if(!v)B=0;else{l=v+19&-16;c[l+-4>>2]=l-v;B=l}c[a+(A*44|0)+180>>2]=B;c[a+(A*44|0)+208>>2]=UJa(r,1024,496712,267)|0;l=mKa()|0;v=c[(c[l>>2]|0)+8>>2]|0;z=pKa()|0;u=mo[c[(c[z>>2]|0)+24>>2]&4095](z)|0;z=Bn[v&255](l,6211,u?528936:544544,496712,273)|0;if(!z)C=0;else{u=z+19&-16;c[u+-4>>2]=u-z;C=u}c[a+(A*44|0)+196>>2]=C;c[a+(A*44|0)+200>>2]=UJa(s,512,496712,275)|0;c[a+(A*44|0)+204>>2]=494600;A=A+1|0}while((A|0)!=(b|0));c[t>>2]=b;i=d;return}function kua(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;h=c[a>>2]|0;j=c[h+8>>2]|0;k=c[j+48>>2]|0;l=c[h+40>>2]|0;m=c[h+36>>2]|0;n=c[c[h+72>>2]>>2]|0;h=a+4|0;if(!(c[h>>2]|0)){o=c[j+8>>2]<<5|19;j=mKa()|0;p=c[(c[j>>2]|0)+8>>2]|0;q=pKa()|0;r=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[p&255](j,o,r?528936:544544,496712,315)|0;if(!q)s=0;else{r=q+19&-16;c[r+-4>>2]=r-q;s=r}c[h>>2]=s}s=a+96|0;if(!(c[s>>2]|0)){r=(c[(c[(c[a>>2]|0)+8>>2]|0)+8>>2]|0)*12|0;q=mKa()|0;o=c[(c[q>>2]|0)+8>>2]|0;j=pKa()|0;p=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[o&255](q,r+23|0,p?528936:544544,496712,326)|0;if(!j)t=0;else{p=j+19&-16;c[p+-4>>2]=p-j;t=p}c[s>>2]=t;PEi(t|0,0,r+4|0)|0}if(l){r=0;do{t=c[m+(r<<2)>>2]|0;s=c[h>>2]|0;g[s+(r<<5)>>2]=ea(g[k+(t<<5)>>2]);g[s+(r<<5)+4>>2]=ea(g[k+(t<<5)+4>>2]);g[s+(r<<5)+8>>2]=ea(g[k+(t<<5)+8>>2]);g[s+(r<<5)+12>>2]=ea(g[k+(t<<5)+12>>2]);g[s+(r<<5)+16>>2]=ea(g[k+(t<<5)+16>>2]);g[s+(r<<5)+20>>2]=ea(g[k+(t<<5)+20>>2]);g[s+(r<<5)+24>>2]=ea(g[k+(t<<5)+24>>2]);p=s+(r<<5)+28|0;s=k+(t<<5)+28|0;t=e[s>>1]|e[s+2>>1]<<16;b[p>>1]=t;b[p+2>>1]=t>>>16;r=r+1|0}while((r|0)!=(l|0))}r=l>>>3;l=0;k=0;h=0;m=r>>>0<512?512:r;while(1){m=(l|0)==7?-1:m;if((m|0)!=0&(h&65535)<1024){r=0;t=h;do{p=c[n+((t&65535)<<4)+8>>2]|0;r=((p|0)==-1?0:p)+r|0;t=t+1<<16>>16}while(r>>>0<m>>>0&(t&65535)<1024);p=a+(l<<2)+520|0;if(!r){u=p;v=t;w=17}else{b[p>>1]=h;b[a+(l<<2)+522>>1]=t;x=k+1|0;y=t}}else{u=a+(l<<2)+520|0;v=h;w=17}if((w|0)==17){w=0;b[u>>1]=-1;b[a+(l<<2)+522>>1]=-1;x=k;y=v}l=l+1|0;if((l|0)==8)break;else{k=x;h=y}}c[a+156>>2]=x;y=c[a+164>>2]|0;jua(a,x>>>0<y>>>0?y:x);c[a+144>>2]=1;x=a+140|0;c[x>>2]=d;if(!d){z=a+100|0;A=a+128|0;B=a+116|0;c[B>>2]=1;C=a+112|0;c[C>>2]=A;D=c[A>>2]|0;E=D+16|0;F=c[E>>2]|0;ko[F&4095](A);G=c[C>>2]|0;H=G+8|0;I=c[H>>2]|0;J=a+108|0;c[J>>2]=I;lua(a,0,z);K=c[z>>2]|0;L=K+20|0;M=c[L>>2]|0;ko[M&4095](z);i=f;return}ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[a+136>>2]=c[(c[x>>2]|0)+8>>2];z=a+100|0;A=a+128|0;B=a+116|0;c[B>>2]=1;C=a+112|0;c[C>>2]=A;D=c[A>>2]|0;E=D+16|0;F=c[E>>2]|0;ko[F&4095](A);G=c[C>>2]|0;H=G+8|0;I=c[H>>2]|0;J=a+108|0;c[J>>2]=I;lua(a,0,z);K=c[z>>2]|0;L=K+20|0;M=c[L>>2]|0;ko[M&4095](z);i=f;return}function lua(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;c[a+160>>2]=d;d=a+156|0;if(!(c[d>>2]|0)){i=f;return}g=(e|0)==0;h=0;do{j=c[(c[(c[a>>2]|0)+4>>2]|0)+6732>>2]|0;oTa(c[j>>2]|0);k=vXa(j,28,16)|0;pTa(c[j>>2]|0);if(!k)l=0;else{b[k+4>>1]=-1;b[k+6>>1]=0;c[k+8>>2]=0;c[k>>2]=443968;c[k+12>>2]=0;c[k+16>>2]=0;c[k>>2]=496912;c[k+20>>2]=a;c[k+24>>2]=h;l=k}c[l+16>>2]=1;k=l+12|0;c[k>>2]=e;if(!g){ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[l+8>>2]=c[(c[k>>2]|0)+8>>2]}ko[c[(c[l>>2]|0)+20>>2]&4095](l);h=h+1|0}while(h>>>0<(c[d>>2]|0)>>>0);i=f;return}function mua(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0,w=0;d=i;f=c[a>>2]|0;h=c[f+40>>2]|0;j=c[(c[f+8>>2]|0)+48>>2]|0;k=c[f+64>>2]|0;l=c[f+36>>2]|0;if(!h)m=c[a+96>>2]|0;else{f=a+4|0;n=a+16|0;o=a+76|0;p=a+96|0;q=0;do{r=c[l+(q<<2)>>2]|0;s=c[f>>2]|0;t=ea(g[n>>2]);u=ea(g[o>>2]);v=s+(q<<5)+12|0;g[v>>2]=ea(u*ea(ea(g[v>>2])-t));g[j+(r<<5)>>2]=ea(g[s+(q<<5)>>2]);g[j+(r<<5)+4>>2]=ea(g[s+(q<<5)+4>>2]);g[j+(r<<5)+8>>2]=ea(g[s+(q<<5)+8>>2]);g[j+(r<<5)+12>>2]=ea(g[v>>2]);g[j+(r<<5)+16>>2]=ea(g[s+(q<<5)+16>>2]);g[j+(r<<5)+20>>2]=ea(g[s+(q<<5)+20>>2]);g[j+(r<<5)+24>>2]=ea(g[s+(q<<5)+24>>2]);v=j+(r<<5)+28|0;w=s+(q<<5)+28|0;s=e[w>>1]|e[w+2>>1]<<16;b[v>>1]=s;b[v+2>>1]=s>>>16;s=c[p>>2]|0;g[k+(r*12|0)>>2]=ea(g[s+(q*12|0)>>2]);g[k+(r*12|0)+4>>2]=ea(g[s+(q*12|0)+4>>2]);g[k+(r*12|0)+8>>2]=ea(g[s+(q*12|0)+8>>2]);q=q+1|0}while((q|0)!=(h|0));m=s}h=a+96|0;if(!m){c[h>>2]=0;i=d;return}a=m+(0-(c[m+-4>>2]|0))|0;if(!a){c[h>>2]=0;i=d;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,a);c[h>>2]=0;i=d;return}function nua(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im;l=i;m=f+12|0;n=c[m>>2]|0;o=f+8|0;p=c[o>>2]|0;q=a+16|0;if(!((b|0)!=0|(p|0)==0)){r=0;do{s=r+n|0;g[e+(s<<5)+12>>2]=ea(g[q>>2]);g[d+(s*12|0)>>2]=ea(0.0);g[d+(s*12|0)+4>>2]=ea(0.0);g[d+(s*12|0)+8>>2]=ea(0.0);r=r+1|0}while((r|0)!=(p|0))}if(p>>>0<101?(c[j+784>>2]|0)>>>0<101:0){r=e+(n<<5)|0;s=d+(n*12|0)|0;if(p>>>0>1){n=k+36|0;t=(b|0)==0;u=k+28|0;v=k+32|0;w=p;p=1;do{x=c[n>>2]|0;S0a(s,s,r,r,x+(p+-1<<2)|0,1,x+(p<<2)|0,w-p|0,1,t,q,c[u>>2]|0,c[v>>2]|0);p=p+1|0;w=c[o>>2]|0}while(p>>>0<w>>>0)}T0a(a,b,d,e,h,j,k)}else oua(a,b,d,e,f,h,j,k);k=c[m>>2]|0;m=c[o>>2]|0;if((b|0)!=1|(m|0)==0){i=l;return}b=a+72|0;a=0;do{y=ea(g[b>>2]);o=a+k|0;z=ea(y*ea(ea(1.0)/ea(g[e+(o<<5)+12>>2])));j=d+(o*12|0)|0;g[j>>2]=ea(ea(g[j>>2])*z);j=d+(o*12|0)+4|0;g[j>>2]=ea(z*ea(g[j>>2]));j=d+(o*12|0)+8|0;g[j>>2]=ea(z*ea(g[j>>2]));a=a+1|0}while((a|0)!=(m|0));i=l;return}function oua(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+16|0;n=m;o=c[l>>2]|0;p=c[l+4>>2]|0;q=c[l+16>>2]|0;r=c[l+20>>2]|0;s=ea(b[h>>1]|0);t=ea(b[h+2>>1]|0);u=ea(b[h+4>>1]|0);v=a+16|0;w=ea(g[a+36>>2]);x=ea(t*w);t=ea(u*w);g[n>>2]=ea(s*w);g[n+4>>2]=x;g[n+8>>2]=t;y=c[h+8>>2]|0;z=c[h+12>>2]|0;a:do if(y){h=l+40|0;A=a+28|0;B=e+(z*12|0)|0;C=y;D=f+(z<<5)|0;do{E=C>>>0<512?C:512;F=E+1|0;G=F>>>1|F;F=G>>>2|G;G=F>>>4|F;F=G>>>8|G;G=(F>>>16|F)+1|0;wua(D,E,q,o,c[h>>2]|0,G,ea(g[A>>2]),n);eua(d,B,D,q,o,G,v,l);F=C;C=C-E|0;H=D;D=D+(E<<5)|0;I=B;B=B+(E*12|0)|0;J=(F|0)==(E|0);if(J)break a;else{K=B;L=C;M=D}while(1){F=L>>>0<512?L:512;N=F+1|0;O=N>>>1|N;N=O>>>2|O;O=N>>>4|N;N=O>>>8|O;O=(N>>>16|N)+1|0;wua(M,F,r,p,c[h>>2]|0,O,ea(g[A>>2]),n);fua(d,I,K,H,M,q,r,o,p,G,O,1,v,l,E>>>0<F>>>0);if((L|0)==(F|0))break;else{K=K+(F*12|0)|0;L=L-F|0;M=M+(F<<5)|0}}}while(!J)}while(0);if(!(c[k+784>>2]|0)){i=m;return}M=l+36|0;L=l+8|0;K=(d|0)==0;z=l+28|0;y=l+32|0;A=l+40|0;h=a+28|0;a=0;do{D=c[j+(a<<2)>>2]|0;if(D){C=D>>>0<201;B=c[492520+(a*80|0)>>2]|0;E=c[j+(a<<2)+108>>2]|0;G=(B|0)==0;H=e+(E*12|0)|0;I=D;F=f+(E<<5)|0;while(1){E=I>>>0<512?I:512;O=E+1|0;N=O>>>1|O;O=N>>>2|N;N=O>>>4|O;O=N>>>8|N;N=(O>>>16|O)+1|0;if(!G){O=0;P=0;while(1){Q=c[492520+(a*80|0)+(O<<2)+4>>2]|0;R=c[k+(Q<<2)>>2]|0;if(!(C&R>>>0<201)){if(!P)wua(F,E,q,o,c[A>>2]|0,N,ea(g[h>>2]),n);if(!R)S=1;else{T=R;R=f+(c[k+(Q<<2)+392>>2]<<5)|0;while(1){Q=T>>>0<512?T:512;U=Q+1|0;V=U>>>1|U;U=V>>>2|V;V=U>>>4|U;U=V>>>8|V;V=(U>>>16|U)+1|0;wua(R,Q,r,p,c[A>>2]|0,V,ea(g[h>>2]),n);fua(d,H,0,F,R,q,r,o,p,N,V,0,v,l,E>>>0>Q>>>0);if((T|0)==(Q|0)){S=1;break}else{T=T-Q|0;R=R+(Q<<5)|0}}}}else S=P;O=O+1|0;if((O|0)==(B|0))break;else P=S}if(!G){P=0;O=0;while(1){N=c[492520+(a*80|0)+(P<<2)+4>>2]|0;J=c[k+(N<<2)>>2]|0;if(C&(J|0)!=0&J>>>0<201){if((J+O|0)>>>0>512){S0a(H,0,F,f,c[M>>2]|0,D,c[L>>2]|0,O,0,K,v,c[z>>2]|0,c[y>>2]|0);W=0}else W=O;R=c[L>>2]|0;T=c[k+(N<<2)+392>>2]|0;N=0;Q=W;while(1){c[R+(Q<<2)>>2]=T;N=N+1|0;if((N|0)==(J|0))break;else{T=T+1|0;Q=Q+1|0}}X=W+J|0}else X=O;P=P+1|0;if((P|0)==(B|0))break;else O=X}if(X)S0a(H,0,F,f,c[M>>2]|0,D,c[L>>2]|0,X,0,K,v,c[z>>2]|0,c[y>>2]|0)}}if((I|0)==(E|0))break;else{H=H+(E*12|0)|0;I=I-E|0;F=F+(E<<5)|0}}}a=a+1|0}while((a|0)!=26);i=m;return}function pua(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;var h=0;h=i;i=i+16|0;c[a+4>>2]=0;c[a+8>>2]=b;g[a+12>>2]=d;c[a+16>>2]=e;e=a+20|0;c[e>>2]=0;c[a>>2]=UJa(h+1|0,b<<4,496976,54)|0;if(!f){i=h;return}c[e>>2]=UJa(h,b*216|0,496976,57)|0;i=h;return}function qua(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;VJa(b+1|0,c[a>>2]|0);d=c[a+20>>2]|0;if(!d){i=b;return}VJa(b,d);i=b;return}function rua(a,d,f,h,j,k,l){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0;k=i;i=i+16|0;m=k+1|0;n=k;o=c[a>>2]|0;p=0;do{c[o+(p<<4)+8>>2]=-1;p=p+1|0}while((p|0)!=1024);q=ea(ea(g[a+12>>2])/ea(1<<c[a+16>>2]>>>0));p=j+4|0;o=c[p>>2]<<6;c[d>>2]=0;r=UJa(m,o,496976,107)|0;o=c[p>>2]&2147483647;a:do if(o){m=c[j>>2]|0;s=0;while(1){t=c[m+(s<<2)>>2]|0;if(t)break;u=s+1|0;if(u>>>0<o>>>0)s=u;else{v=0;break a}}u=c[425648+((da(t&0-t,125613361)|0)>>>27<<2)>>2]|s<<5;w=t+-1&t;b:do if(!w){x=s;while(1){y=x+1|0;if(y>>>0>=o>>>0){z=y;A=0;break b}B=c[m+(y<<2)>>2]|0;if(!B)x=y;else{z=y;A=B;break}}}else{z=s;A=w}while(0);if((u|0)!=-1){w=a+8|0;s=z;m=A;x=0;B=u;while(1){y=s<<5;C=m;D=x;E=B;while(1){F=h+(E<<5)+28|0;c:do if(!(b[F>>1]&16)){G=ea(q*ea(g[h+(E<<5)>>2]));H=ea(q*ea(g[h+(E<<5)+4>>2]));I=~~ea(R(ea(G)));J=~~ea(R(ea(H)));K=~~ea(R(ea(q*ea(g[h+(E<<5)+8>>2]))));L=c[a>>2]|0;M=(c[w>>2]|0)+-1|0;N=((J<<16>>16)*101|0)+(I<<16>>16)+((K<<16>>16)*7919|0)&M;O=c[L+(N<<4)+8>>2]|0;d:do if((O|0)!=-1){P=O;Q=N;while(1){if((I<<16>>16==(b[L+(Q<<4)>>1]|0)?J<<16>>16==(b[L+(Q<<4)+2>>1]|0):0)?K<<16>>16==(b[L+(Q<<4)+4>>1]|0):0)break;S=Q+1&M;T=c[L+(S<<4)+8>>2]|0;if((T|0)==-1){U=S;V=20;break d}else{P=T;Q=S}}b[r+(E<<1)>>1]=Q;S=L+(Q<<4)+8|0;if((P|0)==-1){W=Q;X=S;V=22}else{Y=P;Z=S;_=D}}else{U=N;V=20}while(0);if((V|0)==20){V=0;b[r+(E<<1)>>1]=U;W=U;X=L+(U<<4)+8|0;V=22}do if((V|0)==22){V=0;if(D>>>0>923){b[F>>1]=e[F>>1]|16;N=h+(E<<5)+30|0;b[N>>1]=e[N>>1]&65532;$=D;break c}else{b[L+(W<<4)>>1]=I;b[L+(W<<4)+2>>1]=J;b[L+(W<<4)+4>>1]=K;c[X>>2]=0;Y=0;Z=X;_=D+1|0;break}}while(0);c[Z>>2]=Y+1;c[d>>2]=(c[d>>2]|0)+1;$=_}else $=D;while(0);if(!C){v=$;break a}E=c[425648+((da(C&0-C,125613361)|0)>>>27<<2)>>2]|y;C=C+-1&C;aa=c[p>>2]&2147483647;if(!C){ba=s;break}if((E|0)==-1){v=$;break a}else D=$}while(1){ba=ba+1|0;if(ba>>>0>=aa>>>0){ca=0;break}D=c[(c[j>>2]|0)+(ba<<2)>>2]|0;if(D){ca=D;break}}if((E|0)==-1){v=$;break}else{s=ba;m=ca;x=$;B=E}}}else v=0}else v=0;while(0);c[a+4>>2]=v;v=c[a>>2]|0;$=0;ca=0;while(1){ba=v+(ca<<4)+8|0;aa=c[ba>>2]|0;if((aa|0)==-1)fa=$;else{c[v+(ca<<4)+12>>2]=$;c[ba>>2]=0;fa=aa+$|0}ca=ca+1|0;if((ca|0)==1024)break;else $=fa}sua(a,f,fa,h,j,r);VJa(n,r);ko[c[(c[l>>2]|0)+20>>2]&4095](l);i=k;return}function sua(a,d,f,g,h,j){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;k=h+4|0;l=c[k>>2]&2147483647;if(!l){i=f;return}m=c[h>>2]|0;n=0;while(1){o=c[m+(n<<2)>>2]|0;if(o)break;p=n+1|0;if(p>>>0<l>>>0)n=p;else{q=19;break}}if((q|0)==19){i=f;return}p=c[425648+((da(o&0-o,125613361)|0)>>>27<<2)>>2]|n<<5;r=o+-1&o;a:do if(!r){o=n;while(1){s=o+1|0;if(s>>>0>=l>>>0){t=s;u=0;break a}v=c[m+(s<<2)>>2]|0;if(!v)o=s;else{t=s;u=v;break}}}else{t=n;u=r}while(0);if((p|0)==-1){i=f;return}r=t;t=u;u=p;b:while(1){p=r<<5;n=t;m=u;while(1){if(!(b[g+(m<<5)+28>>1]&16)){l=e[j+(m<<1)>>1]|0;o=c[a>>2]|0;v=o+(l<<4)+8|0;c[d+((c[v>>2]|0)+(c[o+(l<<4)+12>>2]|0)<<2)>>2]=m;c[v>>2]=(c[v>>2]|0)+1}if(!n){q=19;break b}m=c[425648+((da(n&0-n,125613361)|0)>>>27<<2)>>2]|p;n=n+-1&n;w=c[k>>2]&2147483647;if(!n){x=r;break}if((m|0)==-1){q=19;break b}}while(1){x=x+1|0;if(x>>>0>=w>>>0){y=0;break}n=c[(c[h>>2]|0)+(x<<2)>>2]|0;if(n){y=n;break}}if((m|0)==-1){q=19;break}else{r=x;t=y;u=m}}if((q|0)==19){i=f;return}}function tua(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;f=a+20|0;g=a+16|0;h=0;do{j=c[a>>2]|0;k=c[j+(h<<4)+8>>2]|0;if(!((k|0)==0|(k|0)==-1))uua(a,j+(h<<4)|0,(c[f>>2]|0)+(h*216|0)|0,c[g>>2]|0,d,b);h=h+1|0}while((h|0)!=1024);i=e;return}function uua(d,f,h,j,k,l){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0;m=i;i=i+32|0;n=m+8|0;o=m;p=m+16|0;q=1<<j;r=b[f>>1]<<j;s=b[f+2>>1]<<j;t=b[f+4>>1]<<j;PEi(h|0,0,216)|0;j=f+8|0;u=c[j>>2]|0;v=u&511;w=(v|0)==0?512:v;v=f+12|0;f=c[v>>2]|0;x=l+(f<<2)|0;y=u<<2;z=y>>>0>1024;A=n+4|0;a[A>>0]=z&1;if(z){z=sKa(m+17|0,y,496976,268)|0;c[n>>2]=z;B=z;C=c[j>>2]|0}else{z=i;i=i+((1*y|0)+15&-16)|0;c[n>>2]=z;B=z;C=u}if(w>>>0<=C>>>0){u=d+12|0;d=r&65535;r=s&65535;s=t&65535;t=C;C=w+-1|0;z=w;w=B;B=0;while(1){if(B>>>0<z>>>0){D=ea(g[u>>2]);y=C-B|0;E=B;F=w;while(1){G=c[l+(E+f<<2)>>2]|0;H=ea(D*ea(g[k+(G<<5)>>2]));I=ea(D*ea(g[k+(G<<5)+4>>2]));J=(~~ea(R(ea(H)))&65535)-d|0;K=(~~ea(R(ea(I)))&65535)-r|0;L=(~~ea(R(ea(D*ea(g[k+(G<<5)+8>>2]))))&65535)-s|0;if(((J<<16>>16)+1|0)==(q|0))M=9;else M=(J&65535)<<16>>16==0?0:18;if(((K<<16>>16)+1|0)==(q|0))N=M+3|0;else N=(K&65535)<<16>>16==0?M:M+6|0;if(((L<<16>>16)+1|0)==(q|0))O=N+1|0;else O=(L&65535)<<16>>16==0?N:N+2|0;b[F>>1]=O;L=h+(O<<2)|0;c[L>>2]=(c[L>>2]|0)+1;E=E+1|0;if((E|0)==(z|0))break;else F=F+2|0}P=c[j>>2]|0;Q=w+(y+1<<1)|0}else{P=t;Q=w}F=z+512|0;if(F>>>0>P>>>0)break;else{E=z;t=P;C=C+512|0;z=F;w=Q;B=E}}}B=c[v>>2]|0;Q=0;while(1){c[h+(Q<<2)+108>>2]=B;w=Q+1|0;if((w|0)==27)break;else{B=(c[h+(Q<<2)>>2]|0)+B|0;Q=w}}Q=c[j>>2]|0;B=Q<<4;w=B>>>0>1024;z=o+4|0;a[z>>0]=w&1;if(w){w=sKa(p,B,496976,306)|0;c[o>>2]=w;S=c[j>>2]|0;T=w}else{w=i;i=i+((1*B|0)+15&-16)|0;c[o>>2]=w;S=Q;T=w}YEi(T|0,x|0,S<<2|0)|0;S=c[o>>2]|0;x=c[n>>2]|0;T=c[j>>2]&511;w=(T|0)==0?512:T;T=h+0|0;Q=T+108|0;do{a[T>>0]=0;T=T+1|0}while((T|0)<(Q|0));T=c[j>>2]|0;if(w>>>0<=T>>>0){Q=x;x=T;T=w+-1|0;B=w;w=0;while(1){if(w>>>0<B>>>0){p=Q;C=w;while(1){P=e[p>>1]|0;t=h+(P<<2)|0;c[l+((c[h+(P<<2)+108>>2]|0)+f+(c[t>>2]|0)-(c[v>>2]|0)<<2)>>2]=c[S+(C<<2)>>2];c[t>>2]=(c[t>>2]|0)+1;C=C+1|0;if((C|0)==(B|0))break;else p=p+2|0}U=Q+(T+1-w<<1)|0;V=c[j>>2]|0}else{U=Q;V=x}p=B+512|0;if(p>>>0>V>>>0)break;else{C=B;Q=U;x=V;T=T+512|0;B=p;w=C}}}if(a[z>>0]|0)tKa(o,S);if(!(a[A>>0]|0)){i=m;return}tKa(n,c[n>>2]|0);i=m;return}function vua(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;PEi(d|0,0,788)|0;k=b[e>>1]|0;l=(k&65535)+65535|0;m=l&65535;n=e+2|0;o=b[n>>1]|0;p=e+4|0;q=b[p>>1]|0;r=h+-1|0;h=(l<<16>>16)+((o<<16>>16)*101|0)+((q<<16>>16)*7919|0)&r;l=c[f+(h<<4)+8>>2]|0;a:do if((l|0)!=-1){s=l;t=h;while(1){if((m<<16>>16==(b[f+(t<<4)>>1]|0)?o<<16>>16==(b[f+(t<<4)+2>>1]|0):0)?q<<16>>16==(b[f+(t<<4)+4>>1]|0):0)break;u=t+1&r;v=c[f+(u<<4)+8>>2]|0;if((v|0)==-1){w=k;x=o;y=q;break a}else{s=v;t=u}}if(!((s|0)==-1|(f+(t<<4)|0)==0)){z=d+392|0;A=g+(t*216|0)+144|0;B=z+36|0;do{a[z>>0]=a[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z=d+0|0;A=g+(t*216|0)+36|0;B=z+36|0;do{a[z>>0]=a[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));w=b[e>>1]|0;x=b[n>>1]|0;y=b[p>>1]|0}else{w=k;x=o;y=q}}else{w=k;x=o;y=q}while(0);q=(w&65535)+1|0;o=q&65535;k=(q<<16>>16)+((x<<16>>16)*101|0)+((y<<16>>16)*7919|0)&r;q=c[f+(k<<4)+8>>2]|0;b:do if((q|0)!=-1){m=q;h=k;while(1){if((o<<16>>16==(b[f+(h<<4)>>1]|0)?x<<16>>16==(b[f+(h<<4)+2>>1]|0):0)?y<<16>>16==(b[f+(h<<4)+4>>1]|0):0)break;l=h+1&r;t=c[f+(l<<4)+8>>2]|0;if((t|0)==-1){C=x;D=w;E=y;break b}else{m=t;h=l}}if(!((m|0)==-1|(f+(h<<4)|0)==0)){z=d+428|0;A=g+(h*216|0)+108|0;B=z+36|0;do{a[z>>0]=a[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z=d+36|0;A=g+(h*216|0)+0|0;B=z+36|0;do{a[z>>0]=a[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=b[n>>1]|0;D=b[e>>1]|0;E=b[p>>1]|0}else{C=x;D=w;E=y}}else{C=x;D=w;E=y}while(0);y=C&65535;w=y+65535|0;x=w&65535;p=D<<16>>16;e=(w<<16>>16)*101|0;w=(E<<16>>16)*7919|0;n=w+p|0;A=n+e&r;z=c[f+(A<<4)+8>>2]|0;c:do if((z|0)!=-1){B=z;o=A;while(1){if((D<<16>>16==(b[f+(o<<4)>>1]|0)?x<<16>>16==(b[f+(o<<4)+2>>1]|0):0)?E<<16>>16==(b[f+(o<<4)+4>>1]|0):0)break;k=o+1&r;q=c[f+(k<<4)+8>>2]|0;if((q|0)==-1)break c;else{B=q;o=k}}if(!((B|0)==-1|(f+(o<<4)|0)==0)){c[d+464>>2]=c[g+(o*216|0)+120>>2];c[d+72>>2]=c[g+(o*216|0)+12>>2];c[d+468>>2]=c[g+(o*216|0)+124>>2];c[d+76>>2]=c[g+(o*216|0)+16>>2];c[d+472>>2]=c[g+(o*216|0)+128>>2];c[d+80>>2]=c[g+(o*216|0)+20>>2];c[d+476>>2]=c[g+(o*216|0)+156>>2];c[d+84>>2]=c[g+(o*216|0)+48>>2];c[d+480>>2]=c[g+(o*216|0)+160>>2];c[d+88>>2]=c[g+(o*216|0)+52>>2];c[d+484>>2]=c[g+(o*216|0)+164>>2];c[d+92>>2]=c[g+(o*216|0)+56>>2];c[d+488>>2]=c[g+(o*216|0)+192>>2];c[d+96>>2]=c[g+(o*216|0)+84>>2];c[d+492>>2]=c[g+(o*216|0)+196>>2];c[d+100>>2]=c[g+(o*216|0)+88>>2];c[d+496>>2]=c[g+(o*216|0)+200>>2];c[d+104>>2]=c[g+(o*216|0)+92>>2]}}while(0);A=y+1|0;y=A&65535;z=(A<<16>>16)*101|0;A=n+z&r;n=c[f+(A<<4)+8>>2]|0;d:do if((n|0)!=-1){k=n;q=A;while(1){if((D<<16>>16==(b[f+(q<<4)>>1]|0)?y<<16>>16==(b[f+(q<<4)+2>>1]|0):0)?E<<16>>16==(b[f+(q<<4)+4>>1]|0):0)break;h=q+1&r;m=c[f+(h<<4)+8>>2]|0;if((m|0)==-1)break d;else{k=m;q=h}}if(!((k|0)==-1|(f+(q<<4)|0)==0)){c[d+500>>2]=c[g+(q*216|0)+108>>2];c[d+108>>2]=c[g+(q*216|0)>>2];c[d+504>>2]=c[g+(q*216|0)+112>>2];c[d+112>>2]=c[g+(q*216|0)+4>>2];c[d+508>>2]=c[g+(q*216|0)+116>>2];c[d+116>>2]=c[g+(q*216|0)+8>>2];c[d+512>>2]=c[g+(q*216|0)+144>>2];c[d+120>>2]=c[g+(q*216|0)+36>>2];c[d+516>>2]=c[g+(q*216|0)+148>>2];c[d+124>>2]=c[g+(q*216|0)+40>>2];c[d+520>>2]=c[g+(q*216|0)+152>>2];c[d+128>>2]=c[g+(q*216|0)+44>>2];c[d+524>>2]=c[g+(q*216|0)+180>>2];c[d+132>>2]=c[g+(q*216|0)+72>>2];c[d+528>>2]=c[g+(q*216|0)+184>>2];c[d+136>>2]=c[g+(q*216|0)+76>>2];c[d+532>>2]=c[g+(q*216|0)+188>>2];c[d+140>>2]=c[g+(q*216|0)+80>>2]}}while(0);A=E&65535;n=A+65535|0;o=n&65535;B=(C<<16>>16)*101|0;h=B+p|0;m=(n<<16>>16)*7919|0;n=h+m&r;l=c[f+(n<<4)+8>>2]|0;e:do if((l|0)!=-1){t=l;s=n;while(1){if((D<<16>>16==(b[f+(s<<4)>>1]|0)?C<<16>>16==(b[f+(s<<4)+2>>1]|0):0)?o<<16>>16==(b[f+(s<<4)+4>>1]|0):0)break;u=s+1&r;v=c[f+(u<<4)+8>>2]|0;if((v|0)==-1)break e;else{t=v;s=u}}if(!((t|0)==-1|(f+(s<<4)|0)==0)){c[d+536>>2]=c[g+(s*216|0)+112>>2];c[d+144>>2]=c[g+(s*216|0)+4>>2];c[d+540>>2]=c[g+(s*216|0)+124>>2];c[d+148>>2]=c[g+(s*216|0)+16>>2];c[d+544>>2]=c[g+(s*216|0)+136>>2];c[d+152>>2]=c[g+(s*216|0)+28>>2];c[d+548>>2]=c[g+(s*216|0)+148>>2];c[d+156>>2]=c[g+(s*216|0)+40>>2];c[d+552>>2]=c[g+(s*216|0)+160>>2];c[d+160>>2]=c[g+(s*216|0)+52>>2];c[d+556>>2]=c[g+(s*216|0)+172>>2];c[d+164>>2]=c[g+(s*216|0)+64>>2];c[d+560>>2]=c[g+(s*216|0)+184>>2];c[d+168>>2]=c[g+(s*216|0)+76>>2];c[d+564>>2]=c[g+(s*216|0)+196>>2];c[d+172>>2]=c[g+(s*216|0)+88>>2];c[d+568>>2]=c[g+(s*216|0)+208>>2];c[d+176>>2]=c[g+(s*216|0)+100>>2]}}while(0);n=A+1|0;A=n&65535;l=(n<<16>>16)*7919|0;n=h+l&r;h=c[f+(n<<4)+8>>2]|0;f:do if((h|0)!=-1){q=h;k=n;while(1){if((D<<16>>16==(b[f+(k<<4)>>1]|0)?C<<16>>16==(b[f+(k<<4)+2>>1]|0):0)?A<<16>>16==(b[f+(k<<4)+4>>1]|0):0)break;u=k+1&r;v=c[f+(u<<4)+8>>2]|0;if((v|0)==-1)break f;else{q=v;k=u}}if(!((q|0)==-1|(f+(k<<4)|0)==0)){c[d+572>>2]=c[g+(k*216|0)+108>>2];c[d+180>>2]=c[g+(k*216|0)>>2];c[d+576>>2]=c[g+(k*216|0)+120>>2];c[d+184>>2]=c[g+(k*216|0)+12>>2];c[d+580>>2]=c[g+(k*216|0)+132>>2];c[d+188>>2]=c[g+(k*216|0)+24>>2];c[d+584>>2]=c[g+(k*216|0)+144>>2];c[d+192>>2]=c[g+(k*216|0)+36>>2];c[d+588>>2]=c[g+(k*216|0)+156>>2];c[d+196>>2]=c[g+(k*216|0)+48>>2];c[d+592>>2]=c[g+(k*216|0)+168>>2];c[d+200>>2]=c[g+(k*216|0)+60>>2];c[d+596>>2]=c[g+(k*216|0)+180>>2];c[d+204>>2]=c[g+(k*216|0)+72>>2];c[d+600>>2]=c[g+(k*216|0)+192>>2];c[d+208>>2]=c[g+(k*216|0)+84>>2];c[d+604>>2]=c[g+(k*216|0)+204>>2];c[d+212>>2]=c[g+(k*216|0)+96>>2]}}while(0);n=D&65535;h=n+65535|0;s=h&65535;t=h<<16>>16;h=w+t|0;u=h+e&r;v=c[f+(u<<4)+8>>2]|0;g:do if((v|0)!=-1){F=v;G=u;while(1){if((s<<16>>16==(b[f+(G<<4)>>1]|0)?x<<16>>16==(b[f+(G<<4)+2>>1]|0):0)?E<<16>>16==(b[f+(G<<4)+4>>1]|0):0)break;H=G+1&r;I=c[f+(H<<4)+8>>2]|0;if((I|0)==-1)break g;else{F=I;G=H}}if(!((F|0)==-1|(f+(G<<4)|0)==0)){c[d+608>>2]=c[g+(G*216|0)+156>>2];c[d+216>>2]=c[g+(G*216|0)+48>>2];c[d+612>>2]=c[g+(G*216|0)+160>>2];c[d+220>>2]=c[g+(G*216|0)+52>>2];c[d+616>>2]=c[g+(G*216|0)+164>>2];c[d+224>>2]=c[g+(G*216|0)+56>>2]}}while(0);u=n+1|0;n=u&65535;v=u<<16>>16;u=w+v|0;w=u+e&r;k=c[f+(w<<4)+8>>2]|0;h:do if((k|0)!=-1){q=k;H=w;while(1){if((n<<16>>16==(b[f+(H<<4)>>1]|0)?x<<16>>16==(b[f+(H<<4)+2>>1]|0):0)?E<<16>>16==(b[f+(H<<4)+4>>1]|0):0)break;I=H+1&r;J=c[f+(I<<4)+8>>2]|0;if((J|0)==-1)break h;else{q=J;H=I}}if(!((q|0)==-1|(f+(H<<4)|0)==0)){c[d+620>>2]=c[g+(H*216|0)+120>>2];c[d+228>>2]=c[g+(H*216|0)+12>>2];c[d+624>>2]=c[g+(H*216|0)+124>>2];c[d+232>>2]=c[g+(H*216|0)+16>>2];c[d+628>>2]=c[g+(H*216|0)+128>>2];c[d+236>>2]=c[g+(H*216|0)+20>>2]}}while(0);w=h+z&r;h=c[f+(w<<4)+8>>2]|0;i:do if((h|0)!=-1){k=h;G=w;while(1){if((s<<16>>16==(b[f+(G<<4)>>1]|0)?y<<16>>16==(b[f+(G<<4)+2>>1]|0):0)?E<<16>>16==(b[f+(G<<4)+4>>1]|0):0)break;F=G+1&r;I=c[f+(F<<4)+8>>2]|0;if((I|0)==-1)break i;else{k=I;G=F}}if(!((k|0)==-1|(f+(G<<4)|0)==0)){c[d+632>>2]=c[g+(G*216|0)+144>>2];c[d+240>>2]=c[g+(G*216|0)+36>>2];c[d+636>>2]=c[g+(G*216|0)+148>>2];c[d+244>>2]=c[g+(G*216|0)+40>>2];c[d+640>>2]=c[g+(G*216|0)+152>>2];c[d+248>>2]=c[g+(G*216|0)+44>>2]}}while(0);w=u+z&r;u=c[f+(w<<4)+8>>2]|0;j:do if((u|0)!=-1){h=u;H=w;while(1){if((n<<16>>16==(b[f+(H<<4)>>1]|0)?y<<16>>16==(b[f+(H<<4)+2>>1]|0):0)?E<<16>>16==(b[f+(H<<4)+4>>1]|0):0)break;q=H+1&r;F=c[f+(q<<4)+8>>2]|0;if((F|0)==-1)break j;else{h=F;H=q}}if(!((h|0)==-1|(f+(H<<4)|0)==0)){c[d+644>>2]=c[g+(H*216|0)+108>>2];c[d+252>>2]=c[g+(H*216|0)>>2];c[d+648>>2]=c[g+(H*216|0)+112>>2];c[d+256>>2]=c[g+(H*216|0)+4>>2];c[d+652>>2]=c[g+(H*216|0)+116>>2];c[d+260>>2]=c[g+(H*216|0)+8>>2]}}while(0);E=t+B|0;w=E+m&r;u=c[f+(w<<4)+8>>2]|0;k:do if((u|0)!=-1){G=u;k=w;while(1){if((s<<16>>16==(b[f+(k<<4)>>1]|0)?C<<16>>16==(b[f+(k<<4)+2>>1]|0):0)?o<<16>>16==(b[f+(k<<4)+4>>1]|0):0)break;q=k+1&r;F=c[f+(q<<4)+8>>2]|0;if((F|0)==-1)break k;else{G=F;k=q}}if(!((G|0)==-1|(f+(k<<4)|0)==0)){c[d+656>>2]=c[g+(k*216|0)+148>>2];c[d+264>>2]=c[g+(k*216|0)+40>>2];c[d+660>>2]=c[g+(k*216|0)+160>>2];c[d+268>>2]=c[g+(k*216|0)+52>>2];c[d+664>>2]=c[g+(k*216|0)+172>>2];c[d+272>>2]=c[g+(k*216|0)+64>>2]}}while(0);w=v+B|0;B=w+m&r;u=c[f+(B<<4)+8>>2]|0;l:do if((u|0)!=-1){H=u;h=B;while(1){if((n<<16>>16==(b[f+(h<<4)>>1]|0)?C<<16>>16==(b[f+(h<<4)+2>>1]|0):0)?o<<16>>16==(b[f+(h<<4)+4>>1]|0):0)break;q=h+1&r;F=c[f+(q<<4)+8>>2]|0;if((F|0)==-1)break l;else{H=F;h=q}}if(!((H|0)==-1|(f+(h<<4)|0)==0)){c[d+668>>2]=c[g+(h*216|0)+112>>2];c[d+276>>2]=c[g+(h*216|0)+4>>2];c[d+672>>2]=c[g+(h*216|0)+124>>2];c[d+280>>2]=c[g+(h*216|0)+16>>2];c[d+676>>2]=c[g+(h*216|0)+136>>2];c[d+284>>2]=c[g+(h*216|0)+28>>2]}}while(0);B=E+l&r;E=c[f+(B<<4)+8>>2]|0;m:do if((E|0)!=-1){u=E;k=B;while(1){if((s<<16>>16==(b[f+(k<<4)>>1]|0)?C<<16>>16==(b[f+(k<<4)+2>>1]|0):0)?A<<16>>16==(b[f+(k<<4)+4>>1]|0):0)break;G=k+1&r;q=c[f+(G<<4)+8>>2]|0;if((q|0)==-1)break m;else{u=q;k=G}}if(!((u|0)==-1|(f+(k<<4)|0)==0)){c[d+680>>2]=c[g+(k*216|0)+144>>2];c[d+288>>2]=c[g+(k*216|0)+36>>2];c[d+684>>2]=c[g+(k*216|0)+156>>2];c[d+292>>2]=c[g+(k*216|0)+48>>2];c[d+688>>2]=c[g+(k*216|0)+168>>2];c[d+296>>2]=c[g+(k*216|0)+60>>2]}}while(0);B=w+l&r;w=c[f+(B<<4)+8>>2]|0;n:do if((w|0)!=-1){E=w;h=B;while(1){if((n<<16>>16==(b[f+(h<<4)>>1]|0)?C<<16>>16==(b[f+(h<<4)+2>>1]|0):0)?A<<16>>16==(b[f+(h<<4)+4>>1]|0):0)break;H=h+1&r;G=c[f+(H<<4)+8>>2]|0;if((G|0)==-1)break n;else{E=G;h=H}}if(!((E|0)==-1|(f+(h<<4)|0)==0)){c[d+692>>2]=c[g+(h*216|0)+108>>2];c[d+300>>2]=c[g+(h*216|0)>>2];c[d+696>>2]=c[g+(h*216|0)+120>>2];c[d+304>>2]=c[g+(h*216|0)+12>>2];c[d+700>>2]=c[g+(h*216|0)+132>>2];c[d+308>>2]=c[g+(h*216|0)+24>>2]}}while(0);C=e+p|0;B=C+m&r;w=c[f+(B<<4)+8>>2]|0;o:do if((w|0)!=-1){k=w;u=B;while(1){if((D<<16>>16==(b[f+(u<<4)>>1]|0)?x<<16>>16==(b[f+(u<<4)+2>>1]|0):0)?o<<16>>16==(b[f+(u<<4)+4>>1]|0):0)break;H=u+1&r;G=c[f+(H<<4)+8>>2]|0;if((G|0)==-1)break o;else{k=G;u=H}}if(!((k|0)==-1|(f+(u<<4)|0)==0)){c[d+704>>2]=c[g+(u*216|0)+124>>2];c[d+312>>2]=c[g+(u*216|0)+16>>2];c[d+708>>2]=c[g+(u*216|0)+160>>2];c[d+316>>2]=c[g+(u*216|0)+52>>2];c[d+712>>2]=c[g+(u*216|0)+196>>2];c[d+320>>2]=c[g+(u*216|0)+88>>2]}}while(0);B=z+p|0;p=B+m&r;w=c[f+(p<<4)+8>>2]|0;p:do if((w|0)!=-1){h=w;E=p;q:while(1){do if(D<<16>>16==(b[f+(E<<4)>>1]|0)){if(y<<16>>16!=(b[f+(E<<4)+2>>1]|0))break;if(o<<16>>16==(b[f+(E<<4)+4>>1]|0))break q}while(0);H=E+1&r;G=c[f+(H<<4)+8>>2]|0;if((G|0)==-1)break p;else{h=G;E=H}}if(!((h|0)==-1|(f+(E<<4)|0)==0)){c[d+716>>2]=c[g+(E*216|0)+112>>2];c[d+324>>2]=c[g+(E*216|0)+4>>2];c[d+720>>2]=c[g+(E*216|0)+148>>2];c[d+328>>2]=c[g+(E*216|0)+40>>2];c[d+724>>2]=c[g+(E*216|0)+184>>2];c[d+332>>2]=c[g+(E*216|0)+76>>2]}}while(0);p=C+l&r;C=c[f+(p<<4)+8>>2]|0;r:do if((C|0)!=-1){w=C;u=p;s:while(1){do if(D<<16>>16==(b[f+(u<<4)>>1]|0)){if(x<<16>>16!=(b[f+(u<<4)+2>>1]|0))break;if(A<<16>>16==(b[f+(u<<4)+4>>1]|0))break s}while(0);k=u+1&r;H=c[f+(k<<4)+8>>2]|0;if((H|0)==-1)break r;else{w=H;u=k}}if(!((w|0)==-1|(f+(u<<4)|0)==0)){c[d+728>>2]=c[g+(u*216|0)+120>>2];c[d+336>>2]=c[g+(u*216|0)+12>>2];c[d+732>>2]=c[g+(u*216|0)+156>>2];c[d+340>>2]=c[g+(u*216|0)+48>>2];c[d+736>>2]=c[g+(u*216|0)+192>>2];c[d+344>>2]=c[g+(u*216|0)+84>>2]}}while(0);p=B+l&r;B=c[f+(p<<4)+8>>2]|0;t:do if((B|0)!=-1){C=B;E=p;u:while(1){do if(D<<16>>16==(b[f+(E<<4)>>1]|0)){if(y<<16>>16!=(b[f+(E<<4)+2>>1]|0))break;if(A<<16>>16==(b[f+(E<<4)+4>>1]|0))break u}while(0);h=E+1&r;k=c[f+(h<<4)+8>>2]|0;if((k|0)==-1)break t;else{C=k;E=h}}if(!((C|0)==-1|(f+(E<<4)|0)==0)){c[d+740>>2]=c[g+(E*216|0)+108>>2];c[d+348>>2]=c[g+(E*216|0)>>2];c[d+744>>2]=c[g+(E*216|0)+144>>2];c[d+352>>2]=c[g+(E*216|0)+36>>2];c[d+748>>2]=c[g+(E*216|0)+180>>2];c[d+356>>2]=c[g+(E*216|0)+72>>2]}}while(0);D=e+t|0;p=D+m&r;B=c[f+(p<<4)+8>>2]|0;v:do if((B|0)!=-1){u=B;w=p;w:while(1){do if(s<<16>>16==(b[f+(w<<4)>>1]|0)){if(x<<16>>16!=(b[f+(w<<4)+2>>1]|0))break;if(o<<16>>16==(b[f+(w<<4)+4>>1]|0))break w}while(0);h=w+1&r;k=c[f+(h<<4)+8>>2]|0;if((k|0)==-1)break v;else{u=k;w=h}}if((u|0)==-1|(f+(w<<4)|0)==0)break;c[d+752>>2]=c[g+(w*216|0)+160>>2];c[d+360>>2]=c[g+(w*216|0)+52>>2]}while(0);p=D+l&r;D=c[f+(p<<4)+8>>2]|0;x:do if((D|0)!=-1){B=D;E=p;y:while(1){do if(s<<16>>16==(b[f+(E<<4)>>1]|0)){if(x<<16>>16!=(b[f+(E<<4)+2>>1]|0))break;if(A<<16>>16==(b[f+(E<<4)+4>>1]|0))break y}while(0);C=E+1&r;h=c[f+(C<<4)+8>>2]|0;if((h|0)==-1)break x;else{B=h;E=C}}if((B|0)==-1|(f+(E<<4)|0)==0)break;c[d+756>>2]=c[g+(E*216|0)+156>>2];c[d+364>>2]=c[g+(E*216|0)+48>>2]}while(0);p=z+t|0;t=p+m&r;D=c[f+(t<<4)+8>>2]|0;z:do if((D|0)!=-1){w=D;u=t;A:while(1){do if(s<<16>>16==(b[f+(u<<4)>>1]|0)){if(y<<16>>16!=(b[f+(u<<4)+2>>1]|0))break;if(o<<16>>16==(b[f+(u<<4)+4>>1]|0))break A}while(0);C=u+1&r;h=c[f+(C<<4)+8>>2]|0;if((h|0)==-1)break z;else{w=h;u=C}}if((w|0)==-1|(f+(u<<4)|0)==0)break;c[d+760>>2]=c[g+(u*216|0)+148>>2];c[d+368>>2]=c[g+(u*216|0)+40>>2]}while(0);t=p+l&r;p=c[f+(t<<4)+8>>2]|0;B:do if((p|0)!=-1){D=p;E=t;C:while(1){do if(s<<16>>16==(b[f+(E<<4)>>1]|0)){if(y<<16>>16!=(b[f+(E<<4)+2>>1]|0))break;if(A<<16>>16==(b[f+(E<<4)+4>>1]|0))break C}while(0);B=E+1&r;C=c[f+(B<<4)+8>>2]|0;if((C|0)==-1)break B;else{D=C;E=B}}if((D|0)==-1|(f+(E<<4)|0)==0)break;c[d+764>>2]=c[g+(E*216|0)+144>>2];c[d+372>>2]=c[g+(E*216|0)+36>>2]}while(0);s=e+v|0;e=s+m&r;t=c[f+(e<<4)+8>>2]|0;D:do if((t|0)!=-1){p=t;u=e;E:while(1){do if(n<<16>>16==(b[f+(u<<4)>>1]|0)){if(x<<16>>16!=(b[f+(u<<4)+2>>1]|0))break;if(o<<16>>16==(b[f+(u<<4)+4>>1]|0))break E}while(0);w=u+1&r;B=c[f+(w<<4)+8>>2]|0;if((B|0)==-1)break D;else{p=B;u=w}}if((p|0)==-1|(f+(u<<4)|0)==0)break;c[d+768>>2]=c[g+(u*216|0)+124>>2];c[d+376>>2]=c[g+(u*216|0)+16>>2]}while(0);e=s+l&r;s=c[f+(e<<4)+8>>2]|0;F:do if((s|0)!=-1){t=s;E=e;G:while(1){do if(n<<16>>16==(b[f+(E<<4)>>1]|0)){if(x<<16>>16!=(b[f+(E<<4)+2>>1]|0))break;if(A<<16>>16==(b[f+(E<<4)+4>>1]|0))break G}while(0);D=E+1&r;w=c[f+(D<<4)+8>>2]|0;if((w|0)==-1)break F;else{t=w;E=D}}if((t|0)==-1|(f+(E<<4)|0)==0)break;c[d+772>>2]=c[g+(E*216|0)+120>>2];c[d+380>>2]=c[g+(E*216|0)+12>>2]}while(0);x=z+v|0;v=x+m&r;m=c[f+(v<<4)+8>>2]|0;H:do if((m|0)!=-1){z=m;e=v;I:while(1){do if(n<<16>>16==(b[f+(e<<4)>>1]|0)){if(y<<16>>16!=(b[f+(e<<4)+2>>1]|0))break;if(o<<16>>16==(b[f+(e<<4)+4>>1]|0))break I}while(0);s=e+1&r;u=c[f+(s<<4)+8>>2]|0;if((u|0)==-1)break H;else{z=u;e=s}}if((z|0)==-1|(f+(e<<4)|0)==0)break;c[d+776>>2]=c[g+(e*216|0)+112>>2];c[d+384>>2]=c[g+(e*216|0)+4>>2]}while(0);o=x+l&r;l=c[f+(o<<4)+8>>2]|0;J:do if((l|0)!=-1){x=l;v=o;K:while(1){do if(n<<16>>16==(b[f+(v<<4)>>1]|0)){if(y<<16>>16!=(b[f+(v<<4)+2>>1]|0))break;if(A<<16>>16==(b[f+(v<<4)+4>>1]|0))break K}while(0);m=v+1&r;E=c[f+(m<<4)+8>>2]|0;if((E|0)==-1)break J;else{x=E;v=m}}if((x|0)==-1|(f+(v<<4)|0)==0)break;c[d+780>>2]=c[g+(v*216|0)+108>>2];c[d+388>>2]=c[g+(v*216|0)>>2]}while(0);g=d+784|0;f=0;r=0;do{A=c[d+(r<<2)>>2]|0;f=f>>>0<A>>>0?A:f;c[g>>2]=f;r=r+1|0}while((r|0)!=98);i=j;return}function wua(a,d,f,h,j,k,l,m){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0;n=i;i=i+128|0;o=n+96|0;p=n;q=(k|0)==0;if(!q){r=0;do{c[f+(r<<4)+8>>2]=-1;r=r+1|0}while((r|0)!=(k|0))}g[o>>2]=ea(3402823469999999843913219.0e14);g[o+4>>2]=ea(3402823469999999843913219.0e14);g[o+8>>2]=ea(3402823469999999843913219.0e14);r=d+7&-4;s=d>>>0>1?a+32|0:o;t=d>>>0>2?a+64|0:o;u=d>>>0>3?a+96|0:o;v=ea(g[a>>2]);w=ea(g[m>>2]);x=ea(v-w);v=ea(g[a+4>>2]);y=ea(g[m+4>>2]);z=ea(v-y);v=ea(g[a+8>>2]);A=ea(g[m+8>>2]);B=ea(v-A);c[p>>2]=~~ea(R(ea(x*l)));c[p+4>>2]=~~ea(R(ea(z*l)));c[p+8>>2]=~~ea(R(ea(B*l)));B=ea(ea(g[s>>2])-w);z=ea(ea(g[s+4>>2])-y);x=ea(ea(g[s+8>>2])-A);c[p+12>>2]=~~ea(R(ea(B*l)));c[p+16>>2]=~~ea(R(ea(z*l)));c[p+20>>2]=~~ea(R(ea(x*l)));x=ea(ea(g[t>>2])-w);z=ea(ea(g[t+4>>2])-y);B=ea(ea(g[t+8>>2])-A);c[p+24>>2]=~~ea(R(ea(x*l)));c[p+28>>2]=~~ea(R(ea(z*l)));c[p+32>>2]=~~ea(R(ea(B*l)));B=ea(ea(g[u>>2])-w);w=ea(ea(g[u+4>>2])-y);z=ea(ea(g[u+8>>2])-A);c[p+36>>2]=~~ea(R(ea(B*l)));c[p+40>>2]=~~ea(R(ea(w*l)));c[p+44>>2]=~~ea(R(ea(z*l)));if(r){z=ea(g[m>>2]);m=k+-1|0;u=0;do{t=u;u=u+4|0;if(u>>>0<d>>>0)C=a+(u<<5)|0;else C=o;s=t+5|0;if(s>>>0<d>>>0)D=a+(s<<5)|0;else D=o;s=t+6|0;if(s>>>0<d>>>0)E=a+(s<<5)|0;else E=o;s=t+7|0;if(s>>>0<d>>>0)F=a+(s<<5)|0;else F=o;s=u&4;w=ea(ea(g[C>>2])-z);B=ea(ea(g[C+4>>2])-y);x=ea(ea(g[C+8>>2])-A);c[p+(s*12|0)>>2]=~~ea(R(ea(w*l)));c[p+(s*12|0)+4>>2]=~~ea(R(ea(B*l)));c[p+(s*12|0)+8>>2]=~~ea(R(ea(x*l)));G=s|1;x=ea(ea(g[D>>2])-z);B=ea(ea(g[D+4>>2])-y);w=ea(ea(g[D+8>>2])-A);c[p+(G*12|0)>>2]=~~ea(R(ea(x*l)));c[p+(G*12|0)+4>>2]=~~ea(R(ea(B*l)));c[p+(G*12|0)+8>>2]=~~ea(R(ea(w*l)));G=s|2;w=ea(ea(g[E>>2])-z);B=ea(ea(g[E+4>>2])-y);x=ea(ea(g[E+8>>2])-A);c[p+(G*12|0)>>2]=~~ea(R(ea(w*l)));c[p+(G*12|0)+4>>2]=~~ea(R(ea(B*l)));c[p+(G*12|0)+8>>2]=~~ea(R(ea(x*l)));G=s|3;x=ea(ea(g[F>>2])-z);B=ea(ea(g[F+4>>2])-y);w=ea(ea(g[F+8>>2])-A);c[p+(G*12|0)>>2]=~~ea(R(ea(x*l)));c[p+(G*12|0)+4>>2]=~~ea(R(ea(B*l)));c[p+(G*12|0)+8>>2]=~~ea(R(ea(w*l)));G=t&4;s=0;do{H=s+t|0;a:do if(H>>>0<d>>>0){I=s+G|0;J=c[p+(I*12|0)>>2]|0;K=J&65535;L=c[p+(I*12|0)+4>>2]|0;M=L&65535;N=c[p+(I*12|0)+8>>2]|0;I=N&65535;O=((L<<16>>16)*101|0)+(J<<16>>16)+((N<<16>>16)*7919|0)&m;N=c[f+(O<<4)+8>>2]|0;b:do if((N|0)!=-1){J=N;L=O;while(1){if((K<<16>>16==(b[f+(L<<4)>>1]|0)?M<<16>>16==(b[f+(L<<4)+2>>1]|0):0)?I<<16>>16==(b[f+(L<<4)+4>>1]|0):0)break;P=L+1&m;Q=c[f+(P<<4)+8>>2]|0;if((Q|0)==-1){S=P;T=22;break b}else{J=Q;L=P}}b[j+(H<<1)>>1]=L;P=f+(L<<4)+8|0;if((J|0)==-1){U=L;V=P}else{c[P>>2]=J+1;break a}}else{S=O;T=22}while(0);if((T|0)==22){T=0;b[j+(H<<1)>>1]=S;U=S;V=f+(S<<4)+8|0}b[f+(U<<4)>>1]=K;b[f+(U<<4)+2>>1]=M;b[f+(U<<4)+4>>1]=I;c[V>>2]=1}while(0);s=s+1|0}while((s|0)!=4)}while(u>>>0<r>>>0)}if(!q){r=0;u=0;while(1){V=c[f+(r<<4)+8>>2]|0;if((V|0)==-1)W=u;else{c[f+(r<<4)+12>>2]=u;W=V+u|0}r=r+1|0;if((r|0)==(k|0))break;else u=W}if(!q){q=0;do{W=f+(q<<4)+8|0;if((c[W>>2]|0)!=-1)c[W>>2]=0;q=q+1|0}while((q|0)!=(k|0))}}if(!d){i=n;return}else X=0;do{k=e[j+(X<<1)>>1]|0;q=f+(k<<4)+8|0;c[h+((c[q>>2]|0)+(c[f+(k<<4)+12>>2]|0)<<2)>>2]=X;c[q>>2]=(c[q>>2]|0)+1;X=X+1|0}while((X|0)!=(d|0));i=n;return}function xua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;c[b>>2]=d;c[b+4>>2]=e;c[b+8>>2]=f;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=-1;c[b+12>>2]=497352;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+92>>2]=b+44;c[b+100>>2]=0;c[b+104>>2]=0;c[b+108>>2]=0;c[b+112>>2]=-1;c[b+96>>2]=497376;f=b+184|0;c[b+188>>2]=0;c[b+192>>2]=0;c[b+196>>2]=0;e=b+200|0;d=b+116|0;h=d+68|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));c[e>>2]=-1;c[f>>2]=497400;c[b+216>>2]=0;c[b+220>>2]=0;c[b+228>>2]=0;c[b+232>>2]=0;c[b+236>>2]=0;c[b+240>>2]=-1;c[b+224>>2]=497424;f=b+400|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=b+244|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;a[f+28>>0]=0;a[b+273>>0]=1;a[b+274>>0]=0;c[b+436>>2]=0;c[b+440>>2]=0;c[b+456>>2]=b+444;c[b+460>>2]=0;c[b+464>>2]=0;c[b+480>>2]=b+468;c[b+484>>2]=0;c[b+488>>2]=0;c[b+492>>2]=0;f=b+420|0;d=b+276|0;h=d+124|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;i=g;return}function yua(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+1|0;e=c[a+424>>2]|0;if(e)VJa(b,e);c[a+224>>2]=497424;VJa(d,c[a+228>>2]|0);c[a+184>>2]=497400;VJa(d,c[a+188>>2]|0);e=c[a+144>>2]|0;if(e)VJa(d,e);e=c[a+120>>2]|0;if(e)VJa(d,e);c[a+96>>2]=497376;VJa(d,c[a+100>>2]|0);c[a+12>>2]=497352;VJa(d,c[a+16>>2]|0);i=b;return}function zua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b){e=a+12|0;if((c[a+24>>2]|0)>>>0<256)In[c[(c[e>>2]|0)+8>>2]&4095](e,256);e=a+96|0;if((c[a+108>>2]|0)>>>0<256)In[c[(c[e>>2]|0)+8>>2]&4095](e,256);U0a(a+120|0,256);V0a(a+144|0,256);e=a+184|0;if((c[a+196>>2]|0)>>>0<256)In[c[(c[e>>2]|0)+8>>2]&4095](e,256);e=a+224|0;if((c[a+236>>2]|0)>>>0>=32){i=d;return}In[c[(c[e>>2]|0)+8>>2]&4095](e,32);i=d;return}else{e=b+31&-32;b=a+12|0;if((c[a+24>>2]|0)>>>0<e>>>0)In[c[(c[b>>2]|0)+8>>2]&4095](b,e);b=a+96|0;f=e<<1;if((c[a+108>>2]|0)>>>0<f>>>0)In[c[(c[b>>2]|0)+8>>2]&4095](b,f);U0a(a+120|0,e);V0a(a+144|0,f);f=a+184|0;if((c[a+196>>2]|0)>>>0<e>>>0)In[c[(c[f>>2]|0)+8>>2]&4095](f,e);e=a+224|0;if((c[a+236>>2]|0)>>>0>=32){i=d;return}In[c[(c[e>>2]|0)+8>>2]&4095](e,32);i=d;return}}function Aua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[b+16>>2]|0)+((c[d>>2]|0)*12|0)+8|0;h=a[g>>0]|0;j=h&255;a[g>>0]=e?j|1:j&254;if(!((h&1)!=0^e)){i=f;return}h=b+244|0;c[h>>2]=(c[h>>2]|0)+(e?-1:1);h=b+252|0;c[h>>2]=(c[h>>2]|0)+(e?1:-1);h=c[d>>2]|0;d=c[b+92>>2]|0;j=1<<(h&31);if(e){e=(c[d>>2]|0)+(h>>>5<<2)|0;c[e>>2]=c[e>>2]|j}else{e=(c[d>>2]|0)+(h>>>5<<2)|0;c[e>>2]=c[e>>2]&~j}a[b+273>>0]=1;i=f;return}function Bua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+1|0;g=e;h=b+12|0;j=b+28|0;k=c[j>>2]|0;do if((k|0)==-1){l=c[b+24>>2]|0;if(!l){m=-1;n=b+16|0;break}else{In[c[(c[h>>2]|0)+8>>2]&4095](h,l<<1);o=c[j>>2]|0;p=5;break}}else{o=k;p=5}while(0);if((p|0)==5){p=(c[b+20>>2]|0)+(o<<2)|0;c[j>>2]=c[p>>2];c[p>>2]=-1;p=b+16|0;j=c[p>>2]|0;c[j+(o*12|0)>>2]=0;c[j+(o*12|0)+4>>2]=-1;a[j+(o*12|0)+8>>0]=0;m=o;n=p}p=c[n>>2]|0;c[p+(m*12|0)+4>>2]=-1;c[p+(m*12|0)>>2]=-1;a[p+(m*12|0)+8>>0]=66;p=b+120|0;n=b+124|0;o=c[n>>2]|0;j=b+136|0;if((o|0)==(c[j>>2]|0)){k=o<<1;h=UJa(f,o<<4,497248,1373)|0;f=h+(k<<2)|0;YEi(h|0,c[p>>2]|0,c[n>>2]<<2|0)|0;l=b+128|0;YEi(f|0,c[l>>2]|0,c[b+132>>2]<<2|0)|0;VJa(g,c[p>>2]|0);c[p>>2]=h;c[l>>2]=f;c[j>>2]=k;q=h;r=c[n>>2]|0;s=q+(r<<2)|0;c[s>>2]=m;t=c[n>>2]|0;u=t+1|0;c[n>>2]=u;c[d>>2]=m;i=e;return}else{q=c[p>>2]|0;r=o;s=q+(r<<2)|0;c[s>>2]=m;t=c[n>>2]|0;u=t+1|0;c[n>>2]=u;c[d>>2]=m;i=e;return}}function Cua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;c[(c[b+16>>2]|0)+((c[f>>2]|0)*12|0)>>2]=d;a[b+273>>0]=1;return}function Dua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+224|0;k=b+240|0;l=c[k>>2]|0;do if((l|0)==-1){m=c[b+236>>2]|0;if(!m){n=-1;o=b+228|0;break}else{In[c[(c[j>>2]|0)+8>>2]&4095](j,m<<1);p=c[k>>2]|0;q=5;break}}else{p=l;q=5}while(0);if((q|0)==5){q=(c[b+232>>2]|0)+(p<<2)|0;c[k>>2]=c[q>>2];c[q>>2]=-1;q=b+228|0;k=c[q>>2]|0;c[k+(p<<3)>>2]=-1;c[k+(p<<3)+4>>2]=0;n=p;o=q}q=c[o>>2]|0;c[q+(n<<3)>>2]=e;c[q+(n<<3)+4>>2]=f;f=c[g>>2]|0;g=c[b+16>>2]|0;q=g+(f*12|0)+8|0;a[q>>0]=d[q>>0]|0|4;c[g+(f*12|0)>>2]=n;n=b+248|0;c[n>>2]=(c[n>>2]|0)+1;a[b+273>>0]=1;i=h;return}function Eua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=(c[b+16>>2]|0)+((c[d>>2]|0)*12|0)+8|0;g=a[f>>0]|0;h=(g&1)!=0;a[f>>0]=g&255|32;j=c[d>>2]|0;k=b+132|0;l=c[k>>2]|0;m=b+136|0;if((l|0)==(c[m>>2]|0)){n=l<<1;o=UJa(e+1|0,l<<4,497248,1373)|0;p=o+(n<<2)|0;q=b+120|0;YEi(o|0,c[q>>2]|0,c[b+124>>2]<<2|0)|0;r=b+128|0;YEi(p|0,c[r>>2]|0,c[k>>2]<<2|0)|0;VJa(e,c[q>>2]|0);c[q>>2]=o;c[r>>2]=p;c[m>>2]=n;s=p;t=c[k>>2]|0}else{s=c[b+128>>2]|0;t=l}c[s+(t<<2)>>2]=j;c[k>>2]=(c[k>>2]|0)+1;if(g&2){if(a[f>>0]&4){g=b+248|0;c[g>>2]=(c[g>>2]|0)+-1}}else{g=b+244|0;c[g>>2]=(c[g>>2]|0)+((h^1)<<31>>31);g=b+252|0;c[g>>2]=(c[g>>2]|0)+(h<<31>>31)}if(!(a[f>>0]&1)){c[d>>2]=-1;u=b+273|0;a[u>>0]=1;i=e;return}f=c[d>>2]|0;h=(c[c[b+92>>2]>>2]|0)+(f>>>5<<2)|0;c[h>>2]=c[h>>2]&~(1<<(f&31));c[d>>2]=-1;u=b+273|0;a[u>>0]=1;i=e;return}function Fua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;h=g+1|0;j=g;k=a+96|0;l=a+112|0;m=c[l>>2]|0;do if((m|0)==-1){n=c[a+108>>2]|0;if(!n){o=-1;p=a+100|0;break}else{In[c[(c[k>>2]|0)+8>>2]&4095](k,n<<1);q=c[l>>2]|0;r=5;break}}else{q=m;r=5}while(0);if((r|0)==5){r=(c[a+104>>2]|0)+(q<<2)|0;c[l>>2]=c[r>>2];c[r>>2]=-1;r=a+100|0;l=c[r>>2]|0;c[l+(q*12|0)>>2]=-1;c[l+(q*12|0)+4>>2]=-1;c[l+(q*12|0)+8>>2]=0;o=q;p=r}c[f>>2]=o;f=c[p>>2]|0;p=f+(o*12|0)|0;c[p>>2]=-1;r=f+(o*12|0)+4|0;c[r>>2]=-1;c[f+(o*12|0)+8>>2]=0;c[p>>2]=c[d>>2];c[r>>2]=c[e>>2];e=a+144|0;r=a+148|0;d=c[r>>2]|0;p=a+176|0;if((d|0)==(c[p>>2]|0)){f=d<<1;q=UJa(h,d<<5,497248,1550)|0;h=q+(f<<2)|0;l=q+(d<<2<<2)|0;m=q+(d*6<<2)|0;YEi(q|0,c[e>>2]|0,c[r>>2]<<2|0)|0;k=a+152|0;YEi(h|0,c[k>>2]|0,c[a+156>>2]<<2|0)|0;n=a+168|0;YEi(l|0,c[n>>2]|0,c[a+172>>2]<<2|0)|0;s=a+160|0;YEi(m|0,c[s>>2]|0,c[a+164>>2]<<2|0)|0;VJa(j,c[e>>2]|0);c[e>>2]=q;c[k>>2]=h;c[n>>2]=l;c[s>>2]=m;c[p>>2]=f;t=q;u=c[r>>2]|0;v=t+(u<<2)|0;c[v>>2]=o;w=c[r>>2]|0;x=w+1|0;c[r>>2]=x;y=a+(b<<2)+256|0;z=c[y>>2]|0;A=z+1|0;c[y>>2]=A;i=g;return}else{t=c[e>>2]|0;u=d;v=t+(u<<2)|0;c[v>>2]=o;w=c[r>>2]|0;x=w+1|0;c[r>>2]=x;y=a+(b<<2)+256|0;z=c[y>>2]|0;A=z+1|0;c[y>>2]=A;i=g;return}}function Gua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=(c[b+100>>2]|0)+((c[d>>2]|0)*12|0)+8|0;c[f>>2]=c[f>>2]|e;a[b+273>>0]=1;return}function Hua(b,d){b=b|0;d=d|0;var e=0;e=(c[b+100>>2]|0)+((c[d>>2]|0)*12|0)+8|0;c[e>>2]=c[e>>2]&15;a[b+273>>0]=1;return}function Iua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=(c[b+100>>2]|0)+((c[d>>2]|0)*12|0)+8|0;c[f>>2]=e|c[f>>2]|1;a[b+273>>0]=1;return}function Jua(b,d){b=b|0;d=d|0;var e=0;e=(c[b+100>>2]|0)+((c[d>>2]|0)*12|0)+8|0;c[e>>2]=c[e>>2]|2;a[b+273>>0]=1;return}function Kua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=c[d>>2]|0;d=(c[b+100>>2]|0)+(f*12|0)+8|0;g=c[d>>2]|0;if(g&4){i=e;return}c[d>>2]=g|4;g=b+172|0;d=c[g>>2]|0;h=b+176|0;if((d|0)==(c[h>>2]|0)){j=d<<1;k=UJa(e+1|0,d<<5,497248,1550)|0;l=k+(j<<2)|0;m=k+(d<<2<<2)|0;n=k+(d*6<<2)|0;o=b+144|0;YEi(k|0,c[o>>2]|0,c[b+148>>2]<<2|0)|0;p=b+152|0;YEi(l|0,c[p>>2]|0,c[b+156>>2]<<2|0)|0;q=b+168|0;YEi(m|0,c[q>>2]|0,c[g>>2]<<2|0)|0;r=b+160|0;YEi(n|0,c[r>>2]|0,c[b+164>>2]<<2|0)|0;VJa(e,c[o>>2]|0);c[o>>2]=k;c[p>>2]=l;c[q>>2]=m;c[r>>2]=n;c[h>>2]=j;s=m;t=c[g>>2]|0}else{s=c[b+168>>2]|0;t=d}c[s+(t<<2)>>2]=f;c[g>>2]=(c[g>>2]|0)+1;a[b+273>>0]=1;i=e;return}function Lua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=c[d>>2]|0;d=(c[b+100>>2]|0)+(f*12|0)+8|0;g=c[d>>2]|0;if(!(g&4)){i=e;return}c[d>>2]=g&-5;g=b+164|0;d=c[g>>2]|0;h=b+176|0;if((d|0)==(c[h>>2]|0)){j=d<<1;k=UJa(e+1|0,d<<5,497248,1550)|0;l=k+(j<<2)|0;m=k+(d<<2<<2)|0;n=k+(d*6<<2)|0;o=b+144|0;YEi(k|0,c[o>>2]|0,c[b+148>>2]<<2|0)|0;p=b+152|0;YEi(l|0,c[p>>2]|0,c[b+156>>2]<<2|0)|0;q=b+168|0;YEi(m|0,c[q>>2]|0,c[b+172>>2]<<2|0)|0;r=b+160|0;YEi(n|0,c[r>>2]|0,c[g>>2]<<2|0)|0;VJa(e,c[o>>2]|0);c[o>>2]=k;c[p>>2]=l;c[q>>2]=m;c[r>>2]=n;c[h>>2]=j;s=n;t=c[g>>2]|0}else{s=c[b+160>>2]|0;t=d}c[s+(t<<2)>>2]=f;c[g>>2]=(c[g>>2]|0)+1;a[b+273>>0]=1;i=e;return}function Mua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=c[e>>2]|0;h=(c[b+100>>2]|0)+(g*12|0)+8|0;c[h>>2]=c[h>>2]|8;h=b+156|0;j=c[h>>2]|0;k=b+176|0;if((j|0)==(c[k>>2]|0)){l=j<<1;m=UJa(f+1|0,j<<5,497248,1550)|0;n=m+(l<<2)|0;o=m+(j<<2<<2)|0;p=m+(j*6<<2)|0;q=b+144|0;YEi(m|0,c[q>>2]|0,c[b+148>>2]<<2|0)|0;r=b+152|0;YEi(n|0,c[r>>2]|0,c[h>>2]<<2|0)|0;s=b+168|0;YEi(o|0,c[s>>2]|0,c[b+172>>2]<<2|0)|0;t=b+160|0;YEi(p|0,c[t>>2]|0,c[b+164>>2]<<2|0)|0;VJa(f,c[q>>2]|0);c[q>>2]=m;c[r>>2]=n;c[s>>2]=o;c[t>>2]=p;c[k>>2]=l;u=n;v=c[h>>2]|0;w=u+(v<<2)|0;c[w>>2]=g;x=c[h>>2]|0;y=x+1|0;c[h>>2]=y;c[e>>2]=-1;z=b+(d<<2)+256|0;A=c[z>>2]|0;B=A+-1|0;c[z>>2]=B;C=b+273|0;a[C>>0]=1;i=f;return}else{u=c[b+152>>2]|0;v=j;w=u+(v<<2)|0;c[w>>2]=g;x=c[h>>2]|0;y=x+1|0;c[h>>2]=y;c[e>>2]=-1;z=b+(d<<2)+256|0;A=c[z>>2]|0;B=A+-1|0;c[z>>2]=B;C=b+273|0;a[C>>0]=1;i=f;return}}function Nua(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=b+428|0;f=b+436|0;if(!(c[f>>2]|0)){i=d;return}g=b+274|0;if((a[g>>0]|0)!=0?(c[b+252>>2]|0)!=0:0){h=c[e>>2]|0;j=c[b+432>>2]|0;k=c[b+488>>2]|0;l=c[b+492>>2]|0;m=c[b+480>>2]|0;PEi(c[m>>2]|0,0,c[m+4>>2]<<2|0)|0;_ua(c[b+92>>2]|0,h,j,b+12|0,b+96|0,b+184|0,m,k,l)}a[b+272>>0]=(c[b+388>>2]|0)==0&1;a[b+273>>0]=0;a[g>>0]=0;c[f>>2]=0;c[b+460>>2]=0;c[e>>2]=0;c[b+432>>2]=0;c[b+484>>2]=0;c[b+488>>2]=0;c[b+492>>2]=0;c[b+276>>2]=0;c[b+284>>2]=0;c[b+300>>2]=0;c[b+312>>2]=0;c[b+320>>2]=0;c[b+332>>2]=0;c[b+344>>2]=0;c[b+348>>2]=0;c[b+360>>2]=0;c[b+372>>2]=0;c[b+384>>2]=0;i=d;return}function Oua(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+28>>2]|0;if((g|0)==-1)h=0;else{j=c[b+20>>2]|0;k=0;l=g;while(1){g=k+1|0;l=c[j+(l<<2)>>2]|0;if((l|0)==-1){h=g;break}else k=g}}k=c[b+16>>2]|0;l=c[b+100>>2]|0;j=c[b+148>>2]|0;g=c[b+144>>2]|0;if(!j)m=0;else{n=0;o=0;while(1){p=c[g+(n<<2)>>2]|0;if(!(c[l+(p*12|0)+8>>2]&4)){q=c[l+(p*12|0)>>2]|0;if((q|0)==-1)r=o;else r=(a[k+(q*12|0)+8>>0]&1)+o|0;q=c[l+(p*12|0)+4>>2]|0;if((q|0)==-1)s=r;else s=(a[k+(q*12|0)+8>>0]&1)+r|0}else s=o;n=n+1|0;if((n|0)==(j|0)){m=s;break}else o=s}}s=c[b+172>>2]|0;o=c[b+168>>2]|0;if(!s)t=m;else{j=0;n=m;while(1){m=c[o+(j<<2)>>2]|0;r=c[l+(m*12|0)>>2]|0;if((r|0)==-1)u=n;else u=(a[k+(r*12|0)+8>>0]&1)+n|0;r=c[l+(m*12|0)+4>>2]|0;if((r|0)==-1)v=u;else v=(a[k+(r*12|0)+8>>0]&1)+u|0;j=j+1|0;if((j|0)==(s|0)){t=v;break}else n=v}}v=c[b+424>>2]|0;if(v){n=e+4|0;s=(c[b+196>>2]|0)>>>5;PEi(v|0,0,(s<<2)+15&1073741808|0)|0;c[e>>2]=v;c[n>>2]=s|-2147483648;s=c[b+92>>2]|0;j=c[s>>2]|0;u=c[s+4>>2]&2147483647;while(1){s=u;u=u+-1|0;if(!s){w=1;break}x=c[j+(u<<2)>>2]|0;if(x){y=21;break}}if((y|0)==21){s=x>>>1|x;x=s>>>2|s;s=x>>>4|x;x=s>>>8|s;w=(((c[482792+((da(x>>>16|x,130329821)|0)>>>27<<2)>>2]|0)+(u<<5)|0)>>>5)+1|0}u=0;do{x=c[j+(u<<2)>>2]|0;if(x){s=u<<5;o=x;do{x=c[425648+((da(o&0-o,125613361)|0)>>>27<<2)>>2]|s;if(!(a[k+(x*12|0)+8>>0]&64)){r=c[k+(x*12|0)+4>>2]|0;x=v+(r>>>5<<2)|0;c[x>>2]=c[x>>2]|1<<(r&31)}o=o+-1&o}while((o|0)!=0)}u=u+1|0}while((u|0)!=(w|0));w=c[n>>2]|0;n=w&2147483647;while(1){u=n;n=n+-1|0;if(!u){z=1;break}A=c[v+(n<<2)>>2]|0;if(A){y=32;break}}if((y|0)==32){y=A>>>1|A;A=y>>>2|y;y=A>>>4|A;A=y>>>8|y;z=(((c[482792+((da(A>>>16|A,130329821)|0)>>>27<<2)>>2]|0)+(n<<5)|0)>>>5)+1|0}n=c[b+188>>2]|0;A=c[b+116>>2]|0;y=t;u=0;while(1){j=c[v+(u<<2)>>2]|0;if(!j)B=y;else{o=u<<5;s=j;j=y;while(1){r=c[n+((c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|o)<<4)+4>>2]|0;if((r|0)==-1)C=j;else{x=r;r=j;while(1){if(!(c[l+(x*12|0)+8>>2]&8)){m=c[l+(x*12|0)>>2]|0;if((m|0)==-1)D=r;else D=(a[k+(m*12|0)+8>>0]&1)+r|0;m=c[l+(x*12|0)+4>>2]|0;if((m|0)==-1)E=D;else E=(a[k+(m*12|0)+8>>0]&1)+D|0}else E=r;x=c[A+(x<<2)>>2]|0;if((x|0)==-1){C=E;break}else r=E}}s=s+-1&s;if(!s){B=C;break}else j=C}}u=u+1|0;if((u|0)==(z|0))break;else y=B}if((v|0)!=0&(w|0)>-1){VJa(e+8|0,v);F=B}else F=B}else F=t;t=c[b+24>>2]|0;b=t-h+F|0;if(b>>>0<=t>>>0){i=d;return F|0}W0a(f,b+31&-32);i=d;return F|0}function Pua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;b=i;i=i+16|0;d=b+3|0;e=b+2|0;f=b+1|0;g=b;h=Oua(a)|0;j=(c[a+252>>2]|0)+h|0;c[a+268>>2]=j;h=c[a+24>>2]|0;k=h>>>5;l=c[a+256>>2]|0;m=c[a+260>>2]|0;n=m+l+(c[a+264>>2]|0)|0;o=a+244|0;p=c[o>>2]|0;q=a+248|0;r=c[q>>2]|0;s=r+p|0;t=(h<<2)+15&-16;u=(s<<2)+15&-16;v=(n<<3)+15&-16;w=(p<<2)+15&-16;x=(j<<2)+15&-16;y=(r<<2)+15&-16;z=l<<4;A=m<<4;B=(p+j+r<<4)+31|0;r=k<<2;p=r+15&1073741808;C=t+z+x+A+v+w+u+(B&-16)+(y<<1)|0;D=t<<1;E=C+D|0;F=E+(p<<1)+(t*3|0)|0;G=a+420|0;H=c[G>>2]|0;do if(F>>>0>H>>>0){I=F+16384|0;c[G>>2]=I;J=a+424|0;K=c[J>>2]|0;if(!K)L=I;else{VJa(d,K);L=c[G>>2]|0}K=UJa(e,L,497072,895)|0;c[J>>2]=K;M=K}else{if(!(F>>>0<H>>>1>>>0&F>>>0>16383)){M=c[a+424>>2]|0;break}c[G>>2]=F;K=a+424|0;J=c[K>>2]|0;if(!J)N=F;else{VJa(f,J);N=c[G>>2]|0}J=UJa(g,N,497072,902)|0;c[K>>2]=J;M=J}while(0);c[a+428>>2]=M;c[a+432>>2]=M+t;N=M+D|0;c[a+276>>2]=N;c[a+280>>2]=C;c[a+284>>2]=N;N=u+D|0;c[a+296>>2]=s;c[a+288>>2]=0;c[a+292>>2]=0;c[a+300>>2]=M+N;s=N+v|0;c[a+308>>2]=n;c[a+304>>2]=0;c[a+312>>2]=M+s;n=s+t|0;c[a+316>>2]=h;c[a+320>>2]=M+n;s=n+x|0;c[a+328>>2]=j;c[a+324>>2]=0;j=a+332|0;c[j>>2]=M+s;x=s+w|0;c[a+340>>2]=c[o>>2];c[a+336>>2]=0;o=a+344|0;c[o>>2]=M+x;w=x+y|0;x=a+348|0;c[x>>2]=M+w;s=w+y|0;c[a+356>>2]=c[q>>2];c[a+352>>2]=0;q=a+360|0;c[q>>2]=M+s;y=s+z|0;c[a+368>>2]=l;c[a+364>>2]=0;l=a+372|0;c[l>>2]=M+y;c[a+380>>2]=m;c[a+376>>2]=0;c[a+384>>2]=M+(y+A);c[a+392>>2]=B>>>4;c[a+388>>2]=0;c[a+396>>2]=0;B=M+E|0;A=a+436|0;c[A>>2]=B;y=E+p|0;E=a+440|0;c[E>>2]=k;PEi(B|0,0,r|0)|0;B=c[a+456>>2]|0;m=c[E>>2]|0;c[B>>2]=c[A>>2];c[B+4>>2]=m|-2147483648;m=M+y|0;B=a+460|0;c[B>>2]=m;A=y+p|0;p=a+464|0;c[p>>2]=k;PEi(m|0,0,r|0)|0;r=c[a+480>>2]|0;m=c[p>>2]|0;c[r>>2]=c[B>>2];c[r+4>>2]=m|-2147483648;c[a+484>>2]=M+A;m=A+t|0;c[a+488>>2]=M+m;c[a+492>>2]=M+(m+t);if(h>>>0<=(c[a+196>>2]|0)>>>0){O=c[j>>2]|0;P=a+400|0;c[P>>2]=O;Q=c[o>>2]|0;R=a+404|0;c[R>>2]=Q;S=c[x>>2]|0;T=a+408|0;c[T>>2]=S;U=c[q>>2]|0;V=a+412|0;c[V>>2]=U;W=c[l>>2]|0;X=a+416|0;c[X>>2]=W;i=b;return}X0a(a+184|0,h);O=c[j>>2]|0;P=a+400|0;c[P>>2]=O;Q=c[o>>2]|0;R=a+404|0;c[R>>2]=Q;S=c[x>>2]|0;T=a+408|0;c[T>>2]=S;U=c[q>>2]|0;V=a+412|0;c[V>>2]=U;W=c[l>>2]|0;X=a+416|0;c[X>>2]=W;i=b;return}function Qua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b;e=a+164|0;f=a+172|0;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=b;return}g=c[a+108>>2]|0;h=g<<2;if((c[a+280>>2]|0)>>>0<h>>>0){j=1;k=p$a(c[a+4>>2]|0,h,1)|0}else{j=0;k=c[a+276>>2]|0}if(!k){dKa(bKa()|0,16,497072,1092,497168,d);c[f>>2]=0;c[e>>2]=0;i=b;return}PEi(k|0,0,h|0)|0;Yua(a+144|0,k,g);if(!j){i=b;return}j=c[a+4>>2]|0;a=c[j+16>>2]|0;if(a>>>0<=k>>>0?(a+(c[j+20>>2]|0)|0)>>>0>k>>>0:0){oTa(c[j>>2]|0);a=j+8|0;g=c[a>>2]|0;h=j+4|0;e=c[h>>2]|0;f=g;while(1){l=f+-1|0;m=e+(l<<2)|0;if((c[m>>2]|0)>>>0<k>>>0)f=l;else break}if(f>>>0<g>>>0){e=f;f=m;while(1){if(f)c[f>>2]=c[(c[h>>2]|0)+(e<<2)>>2];e=e+1|0;if((e|0)==(g|0))break;else f=f+4|0}}c[a>>2]=g+-1;pTa(c[j>>2]|0);i=b;return}VJa(d,k);i=b;return}function Rua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+100>>2]|0;e=c[a+300>>2]|0;f=c[a+304>>2]|0;if(!f){i=b;return}else g=0;do{c[e+(g<<3)>>2]=c[d+((c[e+(g<<3)+4>>2]|0)*12|0)+8>>2]&-16;g=g+1|0}while((g|0)!=(f|0));i=b;return}function Sua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=c[a+100>>2]|0;e=c[a+300>>2]|0;f=a+304|0;a=c[f>>2]|0;if(!a){g=0;c[f>>2]=g;i=b;return}else{h=0;j=0}while(1){if((c[d+((c[e+(h<<3)+4>>2]|0)*12|0)+8>>2]|0)>>>0<16>>>0)k=j;else{l=e+(h<<3)|0;m=c[l+4>>2]|0;n=e+(j<<3)|0;c[n>>2]=c[l>>2];c[n+4>>2]=m;k=j+1|0}h=h+1|0;if((h|0)==(a|0)){g=k;break}else j=k}c[f>>2]=g;i=b;return}function Tua(a){a=a|0;return}function Uua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+128|0;g=a+132|0;h=a+120|0;j=a+124|0;k=a+152|0;l=a+156|0;m=a+144|0;n=a+148|0;o=a+160|0;p=a+164|0;q=a+168|0;r=a+172|0;$ua(c[a>>2]|0,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[a+92>>2]|0,c[a+252>>2]|0,a+12|0,a+96|0,a+184|0,a+224|0,a+276|0,a+428|0,c[a+8>>2]|0);c[j>>2]=0;c[g>>2]=0;g=a+136|0;j=a+140|0;if((c[g>>2]|0)>>>0>(c[j>>2]|0)>>>0){VJa(e,c[h>>2]|0);c[h>>2]=0;c[f>>2]=0;s=UJa(d,c[j>>2]<<3,497248,1307)|0;c[h>>2]=s;h=c[j>>2]|0;c[f>>2]=s+(h<<2);c[g>>2]=h}c[n>>2]=0;c[l>>2]=0;c[r>>2]=0;c[p>>2]=0;p=a+176|0;r=a+180|0;if((c[p>>2]|0)>>>0<=(c[r>>2]|0)>>>0){i=b;return}VJa(e,c[m>>2]|0);c[m>>2]=0;c[k>>2]=0;c[q>>2]=0;c[o>>2]=0;e=UJa(d,c[r>>2]<<4,497248,1437)|0;c[m>>2]=e;m=c[r>>2]|0;c[k>>2]=e+(m<<2);c[q>>2]=e+(m*3<<2);c[o>>2]=e+(m<<1<<2);c[p>>2]=m;i=b;return}function Vua(b,c,d){b=b|0;c=c|0;d=d|0;d=i;Pua(b);Qua(b);if((a[b+272>>0]|0)!=0?(a[b+273>>0]|0)==0:0){a[b+274>>0]=0;i=d;return}a[b+274>>0]=1;Uua(b);i=d;return}function Wua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=a+160|0;f=a+164|0;ava(c[a>>2]|0,b,c[e>>2]|0,c[f>>2]|0,a+12|0,a+96|0,a+184|0,a+224|0,a+276|0,a+428|0,c[a+8>>2]|0);c[a+148>>2]=0;c[a+156>>2]=0;c[a+172>>2]=0;c[f>>2]=0;f=a+176|0;b=a+180|0;if((c[f>>2]|0)>>>0<=(c[b>>2]|0)>>>0){i=d;return}g=a+144|0;VJa(d,c[g>>2]|0);c[g>>2]=0;h=a+152|0;c[h>>2]=0;j=a+168|0;c[j>>2]=0;c[e>>2]=0;a=UJa(d+1|0,c[b>>2]<<4,497248,1437)|0;c[g>>2]=a;g=c[b>>2]|0;c[h>>2]=a+(g<<2);c[j>>2]=a+(g*3<<2);c[e>>2]=a+(g<<1<<2);c[f>>2]=g;i=d;return}function Xua(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;d=i;Zua(a+144|0,c[a+100>>2]|0);b=c[a+480>>2]|0;PEi(c[b>>2]|0,0,c[b+4>>2]<<2|0)|0;e=c[a+384>>2]|0;f=c[a+392>>2]|0;g=f-(c[a+396>>2]|0)|0;if(g>>>0>=f>>>0){Wua(a,b);i=d;return}h=c[b>>2]|0;j=g;do{g=c[e+(j<<4)+12>>2]|0;k=h+(g>>>5<<2)|0;c[k>>2]=c[k>>2]|1<<(g&31);j=j+1|0}while((j|0)!=(f|0));Wua(a,b);i=d;return}function Yua(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+20|0;f=c[e>>2]|0;g=a+28|0;h=c[g>>2]|0;j=c[a+16>>2]|0;k=c[a+24>>2]|0;a=(f|0)==0;if(a)l=0;else{m=0;n=0;while(1){o=b+(c[j+(n<<2)>>2]<<2)|0;p=c[o>>2]|0;q=m|(p|0)!=0;c[o>>2]=p+-1;n=n+1|0;if((n|0)==(f|0)){l=q;break}else m=q}}m=(h|0)==0;if(m)r=l;else{n=l;l=0;while(1){q=b+(c[k+(l<<2)>>2]<<2)|0;p=c[q>>2]|0;o=n|(p|0)!=0;c[q>>2]=p+1;l=l+1|0;if((l|0)==(h|0)){r=o;break}else n=o}}if(!r){i=d;return}if(a)s=0;else{a=0;r=0;while(1){n=c[j+(a<<2)>>2]|0;l=b+(n<<2)|0;if((c[l>>2]|0)<0){c[j+(r<<2)>>2]=n;c[l>>2]=0;t=r+1|0}else t=r;a=a+1|0;if((a|0)==(f|0)){s=t;break}else r=t}}c[e>>2]=s;if(m)u=0;else{m=0;s=0;while(1){e=c[k+(m<<2)>>2]|0;t=b+(e<<2)|0;if((c[t>>2]|0)>0){c[k+(s<<2)>>2]=e;c[t>>2]=0;v=s+1|0}else v=s;m=m+1|0;if((m|0)==(h|0)){u=v;break}else s=v}}c[g>>2]=u;i=d;return}function Zua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+28|0;if(!(c[e>>2]|0)){i=d;return}f=c[a+16>>2]|0;g=a+20|0;a=c[g>>2]|0;if(!a)h=0;else{j=0;k=0;while(1){l=c[f+(j<<2)>>2]|0;if(!(c[b+(l*12|0)+8>>2]&4)){c[f+(k<<2)>>2]=l;m=k+1|0}else m=k;j=j+1|0;if((j|0)==(a|0)){h=m;break}else k=m}}c[g>>2]=h;c[e>>2]=0;i=d;return}function _ua(b,e,f,g,h,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;n=i;o=g+4|0;p=c[o>>2]|0;q=g+20|0;r=c[q>>2]|0;s=c[h+4>>2]|0;t=c[h+20>>2]|0;h=j+12|0;PEi(l|0,-1,c[h>>2]<<2|0)|0;PEi(m|0,-1,c[h>>2]<<2|0)|0;h=c[b>>2]|0;u=b+4|0;v=c[u>>2]&2147483647;while(1){w=v;v=v+-1|0;if(!w){x=1;break}y=c[h+(v<<2)>>2]|0;if(y){z=4;break}}if((z|0)==4){w=y>>>1|y;y=w>>>2|w;w=y>>>4|y;y=w>>>8|w;x=(((c[482792+((da(y>>>16|y,130329821)|0)>>>27<<2)>>2]|0)+(v<<5)|0)>>>5)+1|0}v=0;do{y=c[h+(v<<2)>>2]|0;if(y){w=v<<5;A=y;do{y=c[f+((c[425648+((da(A&0-A,125613361)|0)>>>27<<2)>>2]|w)<<2)>>2]|0;if((y|0)!=-1){B=y;do{y=p+(B*12|0)+8|0;a[y>>0]=d[y>>0]|0|32;y=c[p+(B*12|0)+4>>2]|0;c[l+(B<<2)>>2]=y;c[m+(B<<2)>>2]=-1;C=(c[k>>2]|0)+(y>>>5<<2)|0;c[C>>2]=c[C>>2]|1<<(y&31);B=c[f+(B<<2)>>2]|0}while((B|0)!=-1)}A=A+-1&A}while((A|0)!=0)}v=v+1|0}while((v|0)!=(x|0));x=c[k+4>>2]&2147483647;while(1){v=x;x=x+-1|0;if(!v){D=1;break}E=c[(c[k>>2]|0)+(x<<2)>>2]|0;if(E){z=15;break}}if((z|0)==15){v=E>>>1|E;E=v>>>2|v;v=E>>>4|E;E=v>>>8|v;D=(((c[482792+((da(E>>>16|E,130329821)|0)>>>27<<2)>>2]|0)+(x<<5)|0)>>>5)+1|0}x=j+4|0;E=c[k>>2]|0;k=0;do{v=c[E+(k<<2)>>2]|0;if(v){h=k<<5;A=c[x>>2]|0;w=c[o>>2]|0;B=c[q>>2]|0;y=v;do{v=c[425648+((da(y&0-y,125613361)|0)>>>27<<2)>>2]|h;C=A+(v<<4)|0;F=c[C>>2]|0;a:do if((F|0)==-1)z=22;else{G=F;while(1){if(!(a[w+(G*12|0)+8>>0]&32))break;H=B+(G<<2)|0;I=c[H>>2]|0;c[H>>2]=-1;if((I|0)==-1){z=22;break a}else G=I}c[C>>2]=G;I=G;b:while(1){J=B+(I<<2)|0;H=c[J>>2]|0;if((H|0)==-1)break;else K=H;while(1){if(!(a[w+(K*12|0)+8>>0]&32))break;H=B+(K<<2)|0;L=c[H>>2]|0;c[H>>2]=-1;if((L|0)==-1)break b;else K=L}c[J>>2]=K;if((K|0)==-1){M=I;break a}else I=K}c[J>>2]=-1;M=I}while(0);if((z|0)==22){z=0;c[C>>2]=-1;M=-1}c[A+(v<<4)+8>>2]=M;F=c[A+(v<<4)+4>>2]|0;if((F|0)!=-1){G=F;do{F=s+(G*12|0)|0;L=c[F>>2]|0;if((L|0)!=-1?(H=c[e+(L<<2)>>2]|0,(H|0)!=-1):0)c[F>>2]=H;H=s+(G*12|0)+4|0;F=c[H>>2]|0;if((F|0)!=-1?(L=c[e+(F<<2)>>2]|0,(L|0)!=-1):0)c[H>>2]=L;G=c[t+(G<<2)>>2]|0}while((G|0)!=-1)}y=y+-1&y}while((y|0)!=0)}k=k+1|0}while((k|0)!=(D|0));D=c[b>>2]|0;k=c[u>>2]&2147483647;while(1){s=k;k=k+-1|0;if(!s){N=1;break}O=c[D+(k<<2)>>2]|0;if(O){z=42;break}}if((z|0)==42){s=O>>>1|O;O=s>>>2|s;s=O>>>4|O;O=s>>>8|s;N=(((c[482792+((da(O>>>16|O,130329821)|0)>>>27<<2)>>2]|0)+(k<<5)|0)>>>5)+1|0}k=j+20|0;O=j+16|0;s=j+8|0;j=0;do{M=c[D+(j<<2)>>2]|0;if(M){J=j<<5;K=M;do{M=c[f+((c[425648+((da(K&0-K,125613361)|0)>>>27<<2)>>2]|J)<<2)>>2]|0;if((M|0)!=-1){q=c[l+(M<<2)>>2]|0;if((q|0)==-1)P=-1;else{E=q;while(1){q=c[m+(E<<2)>>2]|0;if((q|0)==-1){P=E;break}else E=q}}E=c[e+(M<<2)>>2]|0;q=c[x>>2]|0;c[p+(E*12|0)+4>>2]=P;y=q+(P<<4)|0;c[r+(E<<2)>>2]=c[y>>2];c[y>>2]=E;y=q+(P<<4)+8|0;q=c[y>>2]|0;c[y>>2]=(q|0)==-1?E:q;q=c[f+(M<<2)>>2]|0;if((q|0)!=-1){E=q;do{q=c[l+(E<<2)>>2]|0;if((q|0)==-1)Q=-1;else{y=q;while(1){q=c[m+(y<<2)>>2]|0;if((q|0)==-1){Q=y;break}else y=q}}if((P|0)!=(Q|0)?(y=Q>>>5,I=1<<(Q&31),(c[(c[k>>2]|0)+(y<<2)>>2]&I|0)!=0):0){q=c[x>>2]|0;A=q+(Q<<4)|0;B=c[A>>2]|0;if((B|0)!=-1){w=B;do{c[p+(w*12|0)+4>>2]=P;w=c[r+(w<<2)>>2]|0}while((w|0)!=-1)}w=q+(P<<4)+4|0;B=c[q+(Q<<4)+4>>2]|0;if((c[w>>2]|0)!=-1){if((B|0)!=-1){h=q+(P<<4)+12|0;c[t+(c[h>>2]<<2)>>2]=B;c[h>>2]=c[q+(Q<<4)+12>>2]}}else{c[w>>2]=B;c[q+(P<<4)+12>>2]=c[q+(Q<<4)+12>>2]}B=q+(P<<4)|0;w=c[A>>2]|0;if((c[B>>2]|0)!=-1){if((w|0)!=-1){h=q+(P<<4)+8|0;c[r+(c[h>>2]<<2)>>2]=w;c[h>>2]=c[q+(Q<<4)+8>>2]}}else{c[B>>2]=w;c[q+(P<<4)+8>>2]=c[q+(Q<<4)+8>>2]}w=q+(Q<<4)|0;c[w+0>>2]=-1;c[w+4>>2]=-1;c[w+8>>2]=-1;c[w+12>>2]=-1;c[(c[s>>2]|0)+(Q<<2)>>2]=c[O>>2];c[O>>2]=Q;w=(c[k>>2]|0)+(y<<2)|0;c[w>>2]=c[w>>2]&~I;c[m+(Q<<2)>>2]=P}E=c[f+(E<<2)>>2]|0}while((E|0)!=-1)}}K=K+-1&K}while((K|0)!=0)}j=j+1|0}while((j|0)!=(N|0));N=c[b>>2]|0;b=c[u>>2]&2147483647;while(1){u=b;b=b+-1|0;if(!u){R=1;break}S=c[N+(b<<2)>>2]|0;if(S){z=71;break}}if((z|0)==71){z=S>>>1|S;S=z>>>2|z;z=S>>>4|S;S=z>>>8|z;R=(((c[482792+((da(S>>>16|S,130329821)|0)>>>27<<2)>>2]|0)+(b<<5)|0)>>>5)+1|0}b=g+16|0;S=g+8|0;g=0;do{z=c[N+(g<<2)>>2]|0;if(z){u=g<<5;j=z;do{z=c[f+((c[425648+((da(j&0-j,125613361)|0)>>>27<<2)>>2]|u)<<2)>>2]|0;if((z|0)!=-1){P=z;do{z=c[o>>2]|0;c[z+(P*12|0)>>2]=0;c[z+(P*12|0)+4>>2]=-1;a[z+(P*12|0)+8>>0]=0;c[(c[S>>2]|0)+(P<<2)>>2]=c[b>>2];c[b>>2]=P;P=c[f+(P<<2)>>2]|0}while((P|0)!=-1)}j=j+-1&j}while((j|0)!=0)}g=g+1|0}while((g|0)!=(R|0));i=n;return}function $ua(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;m=i;i=i+4096|0;l=m;A=c[y+28>>2]|0;B=A+4|0;PEi(c[A>>2]|0,0,c[B>>2]<<2|0)|0;C=(z|0)!=0;if(C?(D=c[z+8>>2]|0,!((D|0)==0|(a[536794]|0)==0)):0){E=z;Dn[c[(c[D>>2]|0)+8>>2]&511](D,b[268396]|0,c[E>>2]|0,c[E+4>>2]|0)}E=y+52|0;D=c[E>>2]|0;F=D+4|0;PEi(c[D>>2]|0,0,c[F>>2]<<2|0)|0;G=t+4|0;H=c[G>>2]|0;I=(f|0)==0;if(!I){J=0;do{K=c[e+(J<<2)>>2]|0;if((a[H+(K*12|0)+8>>0]&96)==32){L=c[H+(K*12|0)+4>>2]|0;K=(c[A>>2]|0)+(L>>>5<<2)|0;c[K>>2]=c[K>>2]|1<<(L&31)}J=J+1|0}while((J|0)!=(f|0))}J=c[A>>2]|0;L=c[B>>2]&2147483647;while(1){K=L;L=L+-1|0;if(!K){M=1;break}N=c[J+(L<<2)>>2]|0;if(N){O=11;break}}if((O|0)==11){K=N>>>1|N;N=K>>>2|K;K=N>>>4|N;N=K>>>8|K;M=(((c[482792+((da(N>>>16|N,130329821)|0)>>>27<<2)>>2]|0)+(L<<5)|0)>>>5)+1|0}L=v+4|0;N=t+20|0;K=0;P=0;while(1){Q=c[J+(P<<2)>>2]|0;if(!Q)R=K;else{S=P<<5;T=Q;Q=K;while(1){U=c[425648+((da(T&0-T,125613361)|0)>>>27<<2)>>2]|S;if(Q>>>0<1024){c[l+(Q<<2)>>2]=U;V=Q+1|0}else{W=c[L>>2]|0;X=c[N>>2]|0;Y=0;do{Z=c[l+(Y<<2)>>2]|0;_=W+(Z<<4)|0;$=c[_>>2]|0;a:do if(($|0)!=-1){aa=$;while(1){if(!(a[H+(aa*12|0)+8>>0]&32))break;ba=X+(aa<<2)|0;ca=c[ba>>2]|0;c[ba>>2]=-1;if((ca|0)==-1){O=21;break a}else aa=ca}c[_>>2]=aa;ca=aa;b:while(1){ea=X+(ca<<2)|0;ba=c[ea>>2]|0;if((ba|0)==-1){O=26;break}else fa=ba;while(1){if(!(a[H+(fa*12|0)+8>>0]&32))break;ba=X+(fa<<2)|0;ga=c[ba>>2]|0;c[ba>>2]=-1;if((ga|0)==-1){O=26;break b}else fa=ga}c[ea>>2]=fa;if((fa|0)==-1)break;else ca=fa}if((O|0)==26){O=0;c[ea>>2]=-1}c[W+(Z<<4)+8>>2]=ca;if((ca|0)==-1)O=29}else O=21;while(0);if((O|0)==21){O=0;c[_>>2]=-1;c[W+(Z<<4)+8>>2]=-1;O=29}if((O|0)==29){O=0;$=(c[D>>2]|0)+(Z>>>5<<2)|0;c[$>>2]=c[$>>2]|1<<(Z&31)}Y=Y+1|0}while((Y|0)!=(Q|0));c[l>>2]=U;V=1}T=T+-1&T;if(!T){R=V;break}else Q=V}}P=P+1|0;if((P|0)==(M|0))break;else K=R}if(R){K=c[L>>2]|0;M=c[N>>2]|0;P=0;do{V=c[l+(P<<2)>>2]|0;ea=K+(V<<4)|0;fa=c[ea>>2]|0;c:do if((fa|0)!=-1){Q=fa;while(1){if(!(a[H+(Q*12|0)+8>>0]&32))break;T=M+(Q<<2)|0;S=c[T>>2]|0;c[T>>2]=-1;if((S|0)==-1){O=39;break c}else Q=S}c[ea>>2]=Q;U=Q;d:while(1){ha=M+(U<<2)|0;S=c[ha>>2]|0;if((S|0)==-1){O=44;break}else ia=S;while(1){if(!(a[H+(ia*12|0)+8>>0]&32))break;S=M+(ia<<2)|0;T=c[S>>2]|0;c[S>>2]=-1;if((T|0)==-1){O=44;break d}else ia=T}c[ha>>2]=ia;if((ia|0)==-1)break;else U=ia}if((O|0)==44){O=0;c[ha>>2]=-1}c[K+(V<<4)+8>>2]=U;if((U|0)==-1)O=47}else O=39;while(0);if((O|0)==39){O=0;c[ea>>2]=-1;c[K+(V<<4)+8>>2]=-1;O=47}if((O|0)==47){O=0;fa=(c[D>>2]|0)+(V>>>5<<2)|0;c[fa>>2]=c[fa>>2]|1<<(V&31)}P=P+1|0}while((P|0)!=(R|0))}PEi(J|0,0,c[B>>2]<<2|0)|0;Y0a(n,o,j,k,0,t,u,v,A);o=c[D>>2]|0;n=c[F>>2]&2147483647;while(1){B=n;n=n+-1|0;if(!B){ja=1;break}ka=c[o+(n<<2)>>2]|0;if(ka){O=52;break}}if((O|0)==52){B=ka>>>1|ka;ka=B>>>2|B;B=ka>>>4|ka;ka=B>>>8|B;ja=(((c[482792+((da(ka>>>16|ka,130329821)|0)>>>27<<2)>>2]|0)+(n<<5)|0)>>>5)+1|0}n=v+16|0;ka=v+8|0;B=v+20|0;J=0;do{R=c[o+(J<<2)>>2]|0;if(R){P=J<<5;K=R;do{R=c[425648+((da(K&0-K,125613361)|0)>>>27<<2)>>2]|0;ha=R|P;ia=(c[L>>2]|0)+(ha<<4)|0;c[ia+0>>2]=-1;c[ia+4>>2]=-1;c[ia+8>>2]=-1;c[ia+12>>2]=-1;c[(c[ka>>2]|0)+(ha<<2)>>2]=c[n>>2];c[n>>2]=ha;ia=~(1<<(R&31));R=ha>>>5;ha=(c[B>>2]|0)+(R<<2)|0;c[ha>>2]=c[ha>>2]&ia;ha=(c[A>>2]|0)+(R<<2)|0;c[ha>>2]=c[ha>>2]&ia;K=K+-1&K}while((K|0)!=0)}J=J+1|0}while((J|0)!=(ja|0));PEi(c[D>>2]|0,0,c[F>>2]<<2|0)|0;if(C){F=z+8|0;D=c[F>>2]|0;if((D|0)==0|(a[536794]|0)==0)la=D;else{ja=z;Dn[c[(c[D>>2]|0)+12>>2]&511](D,b[268396]|0,c[ja>>2]|0,c[ja+4>>2]|0);la=c[F>>2]|0}if(!((la|0)==0|(a[536802]|0)==0)){F=z;Dn[c[(c[la>>2]|0)+8>>2]&511](la,b[268400]|0,c[F>>2]|0,c[F+4>>2]|0)}}F=c[E>>2]|0;E=F+4|0;PEi(c[F>>2]|0,0,c[E>>2]<<2|0)|0;la=y+56|0;ja=c[la>>2]|0;D=y+60|0;J=c[D>>2]|0;o=y+64|0;K=c[o>>2]|0;P=c[G>>2]|0;V=u+4|0;ea=c[V>>2]|0;ia=c[N>>2]|0;ha=c[u+20>>2]|0;R=v+12|0;PEi(ja|0,-1,c[R>>2]<<2|0)|0;PEi(J|0,-1,c[R>>2]<<2|0)|0;PEi(K|0,-1,c[R>>2]<<2|0)|0;R=(q|0)==0;if(!R){M=0;do{H=c[p+(M<<2)>>2]|0;do if(!(c[ea+(H*12|0)+8>>2]&8)){l=c[ea+(H*12|0)>>2]|0;do if((l|0)!=-1){fa=P+(l*12|0)+4|0;Q=c[fa>>2]|0;if((Q|0)==-1){Z=c[n>>2]|0;_=(c[ka>>2]|0)+(Z<<2)|0;c[n>>2]=c[_>>2];c[_>>2]=-1;_=(c[L>>2]|0)+(Z<<4)|0;c[_+0>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;c[_+12>>2]=-1;_=1<<(Z&31);T=Z>>>5;S=(c[B>>2]|0)+(T<<2)|0;c[S>>2]=c[S>>2]|_;S=c[L>>2]|0;c[fa>>2]=Z;fa=S+(Z<<4)|0;c[ia+(l<<2)>>2]=c[fa>>2];c[fa>>2]=l;fa=S+(Z<<4)+8|0;Z=c[fa>>2]|0;c[fa>>2]=(Z|0)==-1?l:Z;Z=(c[F>>2]|0)+(T<<2)|0;c[Z>>2]=c[Z>>2]|_;break}else{_=(c[F>>2]|0)+(Q>>>5<<2)|0;c[_>>2]=c[_>>2]|1<<(Q&31);break}}while(0);l=c[ea+(H*12|0)+4>>2]|0;if((l|0)!=-1){U=P+(l*12|0)+4|0;Q=c[U>>2]|0;if((Q|0)==-1){_=c[n>>2]|0;Z=(c[ka>>2]|0)+(_<<2)|0;c[n>>2]=c[Z>>2];c[Z>>2]=-1;Z=(c[L>>2]|0)+(_<<4)|0;c[Z+0>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;c[Z+12>>2]=-1;Z=1<<(_&31);T=_>>>5;fa=(c[B>>2]|0)+(T<<2)|0;c[fa>>2]=c[fa>>2]|Z;fa=c[L>>2]|0;c[U>>2]=_;U=fa+(_<<4)|0;c[ia+(l<<2)>>2]=c[U>>2];c[U>>2]=l;U=fa+(_<<4)+8|0;_=c[U>>2]|0;c[U>>2]=(_|0)==-1?l:_;_=(c[F>>2]|0)+(T<<2)|0;c[_>>2]=c[_>>2]|Z;break}else{Z=(c[F>>2]|0)+(Q>>>5<<2)|0;c[Z>>2]=c[Z>>2]|1<<(Q&31);break}}}while(0);M=M+1|0}while((M|0)!=(q|0))}M=c[F>>2]|0;F=c[E>>2]&2147483647;while(1){E=F;F=F+-1|0;if(!E){ma=1;break}na=c[M+(F<<2)>>2]|0;if(na){O=77;break}}if((O|0)==77){E=na>>>1|na;na=E>>>2|E;E=na>>>4|na;na=E>>>8|E;ma=(((c[482792+((da(na>>>16|na,130329821)|0)>>>27<<2)>>2]|0)+(F<<5)|0)>>>5)+1|0}F=-1;na=-1;E=0;while(1){H=c[M+(E<<2)>>2]|0;if(!H){oa=F;pa=na}else{Q=E<<5;Z=c[L>>2]|0;_=H;H=F;T=na;while(1){l=c[425648+((da(_&0-_,125613361)|0)>>>27<<2)>>2]|Q;U=c[Z+(l<<4)>>2]|0;if((H|0)==-1)qa=U;else{c[ja+(c[Z+(H<<4)+8>>2]<<2)>>2]=U;qa=T}if((U|0)!=-1){fa=U;do{U=c[P+(fa*12|0)+4>>2]|0;S=ia+(fa<<2)|0;c[ja+(fa<<2)>>2]=c[S>>2];c[J+(fa<<2)>>2]=U;c[K+(U<<2)>>2]=-1;fa=c[S>>2]|0}while((fa|0)!=-1)}_=_+-1&_;if(!_){oa=l;pa=qa;break}else{H=l;T=qa}}}E=E+1|0;if((E|0)==(ma|0))break;else{F=oa;na=pa}}if(!R){R=0;do{na=c[p+(R<<2)>>2]|0;e:do if(!(c[ea+(na*12|0)+8>>2]&8)){oa=c[ea+(na*12|0)>>2]|0;if((oa|0)!=-1?(F=c[J+(oa<<2)>>2]|0,(F|0)!=-1):0){oa=F;while(1){F=c[K+(oa<<2)>>2]|0;if((F|0)==-1){ra=oa;break}else oa=F}}else ra=-1;oa=c[ea+(na*12|0)+4>>2]|0;do if((oa|0)==-1){sa=(ra|0)!=-1;ta=1}else{l=c[J+(oa<<2)>>2]|0;if((l|0)==-1){sa=(ra|0)!=-1;ta=1;break}else ua=l;while(1){va=K+(ua<<2)|0;l=c[va>>2]|0;if((l|0)==-1)break;else ua=l}l=(ra|0)!=-1;F=(ua|0)==-1;if(F|l^1){if(l|F){sa=l;ta=F;break}F=c[L>>2]|0;l=F+(ua<<4)+4|0;c[ha+(na<<2)>>2]=c[l>>2];c[l>>2]=na;l=F+(ua<<4)+12|0;F=c[l>>2]|0;c[l>>2]=(F|0)==-1?na:F;break e}F=c[L>>2]|0;l=F+(ra<<4)+4|0;c[ha+(na<<2)>>2]=c[l>>2];c[l>>2]=na;ma=F+(ra<<4)+12|0;E=c[ma>>2]|0;c[ma>>2]=(E|0)==-1?na:E;if((ra|0)==(ua|0))break e;c[va>>2]=ra;E=c[F+(ua<<4)+4>>2]|0;if((c[l>>2]|0)!=-1){if((E|0)!=-1){c[ha+(c[ma>>2]<<2)>>2]=E;c[ma>>2]=c[F+(ua<<4)+12>>2]}}else{c[l>>2]=E;c[ma>>2]=c[F+(ua<<4)+12>>2]}ma=F+(ra<<4)|0;E=c[F+(ua<<4)>>2]|0;if((c[ma>>2]|0)!=-1){if((E|0)!=-1){l=F+(ra<<4)+8|0;c[ia+(c[l>>2]<<2)>>2]=E;c[l>>2]=c[F+(ua<<4)+8>>2]}}else{c[ma>>2]=E;c[F+(ra<<4)+8>>2]=c[F+(ua<<4)+8>>2]}E=F+(ua<<4)|0;c[E+0>>2]=-1;c[E+4>>2]=-1;c[E+8>>2]=-1;c[E+12>>2]=-1;c[(c[ka>>2]|0)+(ua<<2)>>2]=c[n>>2];c[n>>2]=ua;E=1<<(ua&31);F=~E;ma=ua>>>5;l=(c[B>>2]|0)+(ma<<2)|0;c[l>>2]=c[l>>2]&F;l=c[A>>2]|0;qa=l+(ma<<2)|0;if(!(c[qa>>2]&E))break e;E=l+(ra>>>5<<2)|0;c[E>>2]=c[E>>2]|1<<(ra&31);c[qa>>2]=c[qa>>2]&F;break e}while(0);if(sa&ta){oa=c[L>>2]|0;F=oa+(ra<<4)+4|0;c[ha+(na<<2)>>2]=c[F>>2];c[F>>2]=na;F=oa+(ra<<4)+12|0;oa=c[F>>2]|0;c[F>>2]=(oa|0)==-1?na:oa}}while(0);R=R+1|0}while((R|0)!=(q|0))}if((pa|0)!=-1){q=pa;do{pa=c[J+(q<<2)>>2]|0;if((pa|0)==-1)wa=-1;else{R=pa;while(1){pa=c[K+(R<<2)>>2]|0;if((pa|0)==-1){wa=R;break}else R=pa}}c[P+(q*12|0)+4>>2]=wa;q=c[ja+(q<<2)>>2]|0}while((q|0)!=-1)}if(C){q=z+8|0;ja=c[q>>2]|0;if((ja|0)==0|(a[536802]|0)==0)xa=ja;else{wa=z;Dn[c[(c[ja>>2]|0)+12>>2]&511](ja,b[268400]|0,c[wa>>2]|0,c[wa+4>>2]|0);xa=c[q>>2]|0}if(!((xa|0)==0|(a[536810]|0)==0)){wa=z;Dn[c[(c[xa>>2]|0)+8>>2]&511](xa,b[268404]|0,c[wa>>2]|0,c[wa+4>>2]|0)}wa=c[G>>2]|0;xa=c[N>>2]|0;if(h){ja=0;do{P=c[g+(ja<<2)>>2]|0;K=wa+(P*12|0)+8|0;J=a[K>>0]|0;a[K>>0]=J&191;if((J&32)==0?(J=wa+(P*12|0)+4|0,(c[J>>2]|0)==-1):0){K=c[n>>2]|0;R=(c[ka>>2]|0)+(K<<2)|0;c[n>>2]=c[R>>2];c[R>>2]=-1;R=(c[L>>2]|0)+(K<<4)|0;c[R+0>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[R+12>>2]=-1;R=(c[B>>2]|0)+(K>>>5<<2)|0;c[R>>2]=c[R>>2]|1<<(K&31);R=c[L>>2]|0;c[J>>2]=K;J=R+(K<<4)|0;c[xa+(P<<2)>>2]=c[J>>2];c[J>>2]=P;J=R+(K<<4)+8|0;K=c[J>>2]|0;c[J>>2]=(K|0)==-1?P:K}ja=ja+1|0}while((ja|0)!=(h|0))}ja=c[q>>2]|0;if((ja|0)==0|(a[536810]|0)==0)O=135;else{q=z;Dn[c[(c[ja>>2]|0)+12>>2]&511](ja,b[268404]|0,c[q>>2]|0,c[q+4>>2]|0);O=135}}else{q=c[G>>2]|0;ja=c[N>>2]|0;if(!h)O=146;else{N=0;do{xa=c[g+(N<<2)>>2]|0;wa=q+(xa*12|0)+8|0;K=a[wa>>0]|0;a[wa>>0]=K&191;if((K&32)==0?(K=q+(xa*12|0)+4|0,(c[K>>2]|0)==-1):0){wa=c[n>>2]|0;P=(c[ka>>2]|0)+(wa<<2)|0;c[n>>2]=c[P>>2];c[P>>2]=-1;P=(c[L>>2]|0)+(wa<<4)|0;c[P+0>>2]=-1;c[P+4>>2]=-1;c[P+8>>2]=-1;c[P+12>>2]=-1;P=(c[B>>2]|0)+(wa>>>5<<2)|0;c[P>>2]=c[P>>2]|1<<(wa&31);P=c[L>>2]|0;c[K>>2]=wa;K=P+(wa<<4)|0;c[ja+(xa<<2)>>2]=c[K>>2];c[K>>2]=xa;K=P+(wa<<4)+8|0;wa=c[K>>2]|0;c[K>>2]=(wa|0)==-1?xa:wa}N=N+1|0}while((N|0)!=(h|0));O=135}}if((O|0)==135)if(C){h=z+8|0;N=c[h>>2]|0;if(!((N|0)==0|(a[536842]|0)==0)){ja=z;Dn[c[(c[N>>2]|0)+8>>2]&511](N,b[268420]|0,c[ja>>2]|0,c[ja+4>>2]|0)}if(!I){ja=t+16|0;N=t+8|0;L=0;do{n=c[e+(L<<2)>>2]|0;ka=c[G>>2]|0;c[ka+(n*12|0)>>2]=0;c[ka+(n*12|0)+4>>2]=-1;a[ka+(n*12|0)+8>>0]=0;c[(c[N>>2]|0)+(n<<2)>>2]=c[ja>>2];c[ja>>2]=n;L=L+1|0}while((L|0)!=(f|0))}if(k){L=u+16|0;ja=u+8|0;N=0;do{n=c[j+(N<<2)>>2]|0;ka=c[V>>2]|0;c[ka+(n*12|0)>>2]=-1;c[ka+(n*12|0)+4>>2]=-1;c[ka+(n*12|0)+8>>2]=0;c[(c[ja>>2]|0)+(n<<2)>>2]=c[L>>2];c[L>>2]=n;N=N+1|0}while((N|0)!=(k|0))}N=c[h>>2]|0;if(!((N|0)==0|(a[536842]|0)==0)){h=z;Dn[c[(c[N>>2]|0)+12>>2]&511](N,b[268420]|0,c[h>>2]|0,c[h+4>>2]|0)}}else O=146;if((O|0)==146){if(!I){I=t+16|0;h=t+8|0;N=0;do{L=c[e+(N<<2)>>2]|0;ja=c[G>>2]|0;c[ja+(L*12|0)>>2]=0;c[ja+(L*12|0)+4>>2]=-1;a[ja+(L*12|0)+8>>0]=0;c[(c[h>>2]|0)+(L<<2)>>2]=c[I>>2];c[I>>2]=L;N=N+1|0}while((N|0)!=(f|0))}if(k){f=u+16|0;N=u+8|0;I=0;do{h=c[j+(I<<2)>>2]|0;G=c[V>>2]|0;c[G+(h*12|0)>>2]=-1;c[G+(h*12|0)+4>>2]=-1;c[G+(h*12|0)+8>>2]=0;c[(c[N>>2]|0)+(h<<2)>>2]=c[f>>2];c[f>>2]=h;I=I+1|0}while((I|0)!=(k|0))}}do if(s){if(!C){Z0a(r,t,u,v,c[y>>2]|0,c[y+4>>2]|0,A);O=164;break}k=z+8|0;I=c[k>>2]|0;if(!((I|0)==0|(a[536818]|0)==0)){f=z;Dn[c[(c[I>>2]|0)+8>>2]&511](I,b[268408]|0,c[f>>2]|0,c[f+4>>2]|0)}Z0a(r,t,u,v,c[y>>2]|0,c[y+4>>2]|0,A);f=c[k>>2]|0;if(!((f|0)==0|(a[536818]|0)==0)){k=z;Dn[c[(c[f>>2]|0)+12>>2]&511](f,b[268408]|0,c[k>>2]|0,c[k+4>>2]|0);O=159}else O=159}else O=159;while(0);if((O|0)==159)if(C){y=z+8|0;r=c[y>>2]|0;if(!((r|0)==0|(a[536826]|0)==0)){s=z;Dn[c[(c[r>>2]|0)+8>>2]&511](r,b[268412]|0,c[s>>2]|0,c[s+4>>2]|0)}_0a(A,t,u,v,c[la>>2]|0,c[D>>2]|0,c[o>>2]|0,0);s=c[y>>2]|0;if(!((s|0)==0|(a[536826]|0)==0)){y=z;Dn[c[(c[s>>2]|0)+12>>2]&511](s,b[268412]|0,c[y>>2]|0,c[y+4>>2]|0)}}else O=164;if((O|0)==164)_0a(A,t,u,v,c[la>>2]|0,c[D>>2]|0,c[o>>2]|0,0);if(!C){$0a(B,d,t,u,v,w,x);i=m;return}C=z+8|0;o=c[C>>2]|0;if(!((o|0)==0|(a[536834]|0)==0)){D=z;Dn[c[(c[o>>2]|0)+8>>2]&511](o,b[268416]|0,c[D>>2]|0,c[D+4>>2]|0)}$0a(B,d,t,u,v,w,x);x=c[C>>2]|0;if((x|0)==0|(a[536834]|0)==0){i=m;return}C=z;Dn[c[(c[x>>2]|0)+12>>2]&511](x,b[268416]|0,c[C>>2]|0,c[C+4>>2]|0);i=m;return}function ava(d,e,f,g,h,j,k,l,m,n,o){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;q=c[n+28>>2]|0;PEi(c[q>>2]|0,0,c[q+4>>2]<<2|0)|0;r=(o|0)!=0;if(r){s=o+8|0;t=c[s>>2]|0;if(!((t|0)==0|(a[536794]|0)==0)){u=o;Dn[c[(c[t>>2]|0)+8>>2]&511](t,b[268396]|0,c[u>>2]|0,c[u+4>>2]|0)}Y0a(f,g,0,0,c[n>>2]|0,h,j,k,q);u=c[s>>2]|0;if(!((u|0)==0|(a[536794]|0)==0)){t=o;Dn[c[(c[u>>2]|0)+12>>2]&511](u,b[268396]|0,c[t>>2]|0,c[t+4>>2]|0)}t=c[s>>2]|0;if(!((t|0)==0|(a[536826]|0)==0)){u=o;Dn[c[(c[t>>2]|0)+8>>2]&511](t,b[268412]|0,c[u>>2]|0,c[u+4>>2]|0)}_0a(q,h,j,k,c[n+56>>2]|0,c[n+60>>2]|0,c[n+64>>2]|0,e);u=c[s>>2]|0;if(!((u|0)==0|(a[536826]|0)==0)){s=o;Dn[c[(c[u>>2]|0)+12>>2]&511](u,b[268412]|0,c[s>>2]|0,c[s+4>>2]|0)}if(r){r=o+8|0;s=c[r>>2]|0;if(!((s|0)==0|(a[536834]|0)==0)){u=o;Dn[c[(c[s>>2]|0)+8>>2]&511](s,b[268416]|0,c[u>>2]|0,c[u+4>>2]|0)}a1a(e,d,h,j,k,l,m);u=c[r>>2]|0;if((u|0)==0|(a[536834]|0)==0){i=p;return}r=o;Dn[c[(c[u>>2]|0)+12>>2]&511](u,b[268416]|0,c[r>>2]|0,c[r+4>>2]|0);i=p;return}}else{Y0a(f,g,0,0,c[n>>2]|0,h,j,k,q);_0a(q,h,j,k,c[n+56>>2]|0,c[n+60>>2]|0,c[n+64>>2]|0,e)}a1a(e,d,h,j,k,l,m);i=p;return}function bva(a,d,e){a=a|0;d=d|0;e=e|0;b[a+4>>1]=-1;b[a+6>>1]=0;c[a+8>>2]=0;c[a>>2]=443968;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;c[a>>2]=497448;c[a+32>>2]=d;c[a+36>>2]=e;return}function cva(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function dva(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function eva(a,d,e){a=a|0;d=d|0;e=e|0;b[a+4>>1]=-1;b[a+6>>1]=0;c[a+8>>2]=0;c[a>>2]=443968;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;c[a>>2]=497496;c[a+32>>2]=d;c[a+36>>2]=e;return}function fva(a){a=a|0;var b=0;b=i;ira(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function gva(a){a=a|0;var b=0;b=i;jra(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function hva(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a>>2]=b;g[a+4>>2]=c;return}function iva(a,b){a=a|0;b=b|0;var c=0,e=Im,f=Im,h=0,j=Im;c=i;e=ea(g[a+8>>2]);f=ea(g[b+8>>2]);h=(d[a+14>>0]|0)&15;a=(d[b+14>>0]|0)&15;b=h>>>0<a>>>0?a:h;if((b|0)==2)j=ea(e*f);else if((b|0)==3)j=e>f?e:f;else if((b|0)==1)j=e<f?e:f;else if(!b)j=ea(ea(e+f)*ea(.5));else j=ea(0.0);i=c;return ea(j)}function jva(a,e,f,h){a=a|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;j=i;k=(b[h+12>>1]|b[f+12>>1])&65535;l=a+8|0;c[l>>2]=k;if(k&1){c[l>>2]=k|2;g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);i=j;return}k=(d[f+14>>0]|0)>>>4;l=(d[h+14>>0]|0)>>>4;m=k>>>0<l>>>0?l:k;if((m|0)==1){n=ea(g[f>>2]);o=ea(g[h>>2]);p=ea(g[f+4>>2]);q=ea(g[h+4>>2]);r=n<o?n:o;s=p<q?p:q}else if(!m){q=ea(g[f>>2]);p=ea(ea(q+ea(g[h>>2]))*ea(.5));q=ea(g[f+4>>2]);r=p;s=ea(ea(q+ea(g[h+4>>2]))*ea(.5))}else if((m|0)==2){q=ea(g[f>>2]);p=ea(q*ea(g[h>>2]));q=ea(g[f+4>>2]);r=p;s=ea(q*ea(g[h+4>>2]))}else if((m|0)==3){q=ea(g[f>>2]);p=ea(g[h>>2]);o=ea(g[f+4>>2]);n=ea(g[h+4>>2]);r=q>p?q:p;s=o>n?o:n}else{r=ea(0.0);s=ea(0.0)}n=ea(r*ea(g[e+4>>2]));r=ea(s*ea(g[e>>2]));e=n>ea(0.0);s=e?n:ea(0.0);e=ea(r-s)>=ea(0.0);g[a+4>>2]=s;g[a>>2]=e?r:s;i=j;return}function kva(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;c[d>>2]=497592;j=d+56|0;c[j>>2]=0;k=d+60|0;c[k>>2]=0;a[d+4>>0]=1;l=c[e>>2]|0;c[d+8>>2]=l;m=e+40|0;n=(c[m>>2]|0)!=0;o=d+12|0;a[o>>0]=n&1;c[d+20>>2]=c[e+4>>2];p=d+16|0;c[p>>2]=c[e+8>>2];g[d+24>>2]=ea(g[f>>2]);g[d+28>>2]=ea(g[f+4>>2]);g[d+32>>2]=ea(g[f+8>>2]);g[d+36>>2]=ea(g[f+12>>2]);g[d+40>>2]=ea(g[f+16>>2]);g[d+44>>2]=ea(g[f+20>>2]);f=d+80|0;q=(l+31|0)>>>5;c[j>>2]=f;c[k>>2]=q|-2147483648;r=(q<<2)+15&1073741808;s=d+48|0;c[s>>2]=f+r;if(n)t=f+(r+(l<<5))|0;else t=0;l=d+52|0;c[l>>2]=t;t=c[e+12>>2]|0;if(t){r=t+4|0;n=c[r>>2]|0;u=n&134217727;if(u>>>0>q>>>0){c[k>>2]=u;v=UJa(d+64|0,u<<2,543784,362)|0;c[j>>2]=v;w=c[r>>2]|0;x=v}else{w=n;x=f}YEi(x|0,c[t>>2]|0,w<<2|0)|0;w=c[k>>2]|0;k=c[r>>2]|0;r=k&2147483647;if((w&2147483647)>>>0>r>>>0)PEi((c[j>>2]|0)+(r<<2)|0,0,w-k<<2|0)|0}else PEi(f|0,0,q<<2|0)|0;q=c[p>>2]|0;if(!q){i=h;return}p=c[s>>2]|0;f=0;do{b[p+(f<<5)+28>>1]=0;f=f+1|0}while(f>>>0<q>>>0);f=c[j>>2]|0;j=(q+-1|0)>>>5;q=e+16|0;p=e+20|0;k=e+24|0;w=e+28|0;r=0;do{t=c[f+(r<<2)>>2]|0;if(t){x=r<<5;n=c[s>>2]|0;v=c[q>>2]|0;u=c[p>>2]|0;d=c[k>>2]|0;y=c[w>>2]|0;z=t;do{t=c[425648+((da(z&0-z,125613361)|0)>>>27<<2)>>2]|x;A=da(u,t)|0;g[n+(t<<5)>>2]=ea(g[v+A>>2]);g[n+(t<<5)+4>>2]=ea(g[v+(A+4)>>2]);g[n+(t<<5)+8>>2]=ea(g[v+(A+8)>>2]);A=da(y,t)|0;g[n+(t<<5)+16>>2]=ea(g[d+A>>2]);g[n+(t<<5)+20>>2]=ea(g[d+(A+4)>>2]);g[n+(t<<5)+24>>2]=ea(g[d+(A+8)>>2]);g[n+(t<<5)+12>>2]=ea(0.0);b[n+(t<<5)+30>>1]=0;b[n+(t<<5)+28>>1]=1;z=z+-1&z}while((z|0)!=0)}r=r+1|0}while(r>>>0<=j>>>0);if(!(a[o>>0]|0)){i=h;return}o=e+44|0;e=0;do{r=c[f+(e<<2)>>2]|0;if(r){w=e<<5;k=c[m>>2]|0;p=c[o>>2]|0;q=c[l>>2]|0;s=r;do{r=c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|w;g[q+(r<<2)>>2]=ea(g[k+(da(p,r)|0)>>2]);s=s+-1&s}while((s|0)!=0)}e=e+1|0}while(e>>>0<=j>>>0);i=h;return}function lva(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=497592;d=c[a+48>>2]|0;if(d)VJa(b,d+(0-(c[d+-4>>2]|0))|0);d=c[a+56>>2]|0;if(!d){ACi(a);i=b;return}if((c[a+60>>2]|0)<=-1){ACi(a);i=b;return}VJa(a+64|0,d);ACi(a);i=b;return}function mva(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=497592;d=c[a+48>>2]|0;if(d)VJa(b,d+(0-(c[d+-4>>2]|0))|0);d=c[a+56>>2]|0;if(!d){i=b;return}if((c[a+60>>2]|0)<=-1){i=b;return}VJa(a+64|0,d);i=b;return}function nva(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;h=c[d+16>>2]|0;if(h){j=c[d+56>>2]|0;k=(h+-1|0)>>>5;h=d+48|0;l=0;do{m=c[j+(l<<2)>>2]|0;if(m){n=l<<5;o=c[h>>2]|0;p=m;do{m=c[425648+((da(p&0-p,125613361)|0)>>>27<<2)>>2]|n;b[o+(m<<5)+30>>1]=0;g[o+(m<<5)+12>>2]=ea(0.0);p=p+-1&p}while((p|0)!=0)}l=l+1|0}while(l>>>0<=k>>>0)}In[c[(c[e>>2]|0)+12>>2]&4095](e,16);k=c[d+8>>2]|0;co[c[(c[e>>2]|0)+8>>2]&2047](e,d,(k<<5)+80+((a[d+12>>0]|0)!=0?k<<2:0)+(((k+31|0)>>>5<<2)+15&1073741808)|0);i=f;return}function ova(a){a=a|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a+16>>2]|0;if(!e){i=d;return}f=c[a+56>>2]|0;h=(e+-1|0)>>>5;e=a+48|0;a=0;do{j=c[f+(a<<2)>>2]|0;if(j){k=a<<5;l=c[e>>2]|0;m=j;do{j=c[425648+((da(m&0-m,125613361)|0)>>>27<<2)>>2]|k;b[l+(j<<5)+30>>1]=0;g[l+(j<<5)+12>>2]=ea(0.0);m=m+-1&m}while((m|0)!=0)}a=a+1|0}while(a>>>0<=h>>>0);i=d;return}function pva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0;d=i;e=c[a+16>>2]|0;if(!e){f=b+4|0;h=b+8|0;j=b}else{k=c[a+56>>2]|0;l=(e+-1|0)>>>5;e=a+48|0;m=b+4|0;n=b+8|0;o=0;do{p=c[k+(o<<2)>>2]|0;if(p){q=o<<5;r=c[e>>2]|0;s=p;do{p=c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|q;t=ea(g[b>>2]);u=r+(p<<5)|0;g[u>>2]=ea(ea(g[u>>2])-t);t=ea(g[m>>2]);u=r+(p<<5)+4|0;g[u>>2]=ea(ea(g[u>>2])-t);t=ea(g[n>>2]);u=r+(p<<5)+8|0;g[u>>2]=ea(ea(g[u>>2])-t);s=s+-1&s}while((s|0)!=0)}o=o+1|0}while(o>>>0<=l>>>0);f=m;h=n;j=b}t=ea(g[j>>2]);b=a+24|0;g[b>>2]=ea(ea(g[b>>2])-t);t=ea(g[f>>2]);b=a+28|0;g[b>>2]=ea(ea(g[b>>2])-t);t=ea(g[h>>2]);b=a+32|0;g[b>>2]=ea(ea(g[b>>2])-t);t=ea(g[j>>2]);j=a+36|0;g[j>>2]=ea(ea(g[j>>2])-t);t=ea(g[f>>2]);f=a+40|0;g[f>>2]=ea(ea(g[f>>2])-t);t=ea(g[h>>2]);h=a+44|0;g[h>>2]=ea(ea(g[h>>2])-t);i=d;return}function qva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[a>>2]|0;f=(e<<5)+99+((c[a+40>>2]|0)!=0?e<<2:0)+(((e+31|0)>>>5<<2)+15&1073741808)|0;e=mKa()|0;g=c[(c[e>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](e,f,j?497744:544544,497648,230)|0;if(!h){k=0;i=d;return k|0}j=h+19&-16;c[j+-4>>2]=j-h;h=j;if(!j){k=h;i=d;return k|0}kva(h,a,b);k=h;i=d;return k|0}function rva(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=(b+31|0)>>>5;h=f<<2;j=h+15&1073741808;k=b<<5;l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,k+99+(d?b<<2:0)+j|0,o?497744:544544,497648,240)|0;if(!n){p=0;i=e;return p|0}o=n+19&-16;c[o+-4>>2]=o-n;n=o;if(!o){p=n;i=e;return p|0}c[n>>2]=497592;a[n+4>>0]=1;c[n+8>>2]=b;a[n+12>>0]=d&1;c[n+20>>2]=0;c[n+16>>2]=0;g[n+24>>2]=ea(8507058669999999534545717.0e13);g[n+28>>2]=ea(8507058669999999534545717.0e13);g[n+32>>2]=ea(8507058669999999534545717.0e13);g[n+36>>2]=ea(-8507058669999999534545717.0e13);g[n+40>>2]=ea(-8507058669999999534545717.0e13);g[n+44>>2]=ea(-8507058669999999534545717.0e13);b=n+80|0;c[n+56>>2]=b;c[n+60>>2]=f|-2147483648;c[n+48>>2]=b+j;if(d)q=b+(j+k)|0;else q=0;c[n+52>>2]=q;PEi(b|0,0,h|0)|0;p=n;i=e;return p|0}function sva(b){b=b|0;var d=0;d=i;i=i+16|0;if((a[b+4>>0]|0)==0|(b|0)==0){i=d;return}VJa(d,b+(0-(c[b+-4>>2]|0))|0);i=d;return}function tva(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=0,E=Im,F=0,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);h=d+4|0;j=h;k=c[j+4>>2]|0;l=d+12|0;m=c[l+4>>2]|0;n=d+20|0;if(!(c[n>>2]|0)){o=0;p=f}else{f=n;o=c[f+4>>2]|0;p=c[f>>2]|0}if(!(c[d>>2]|0))q=0;else{f=c[a+48>>2]|0;n=c[a+56>>2]|0;r=a+16|0;s=a+24|0;t=a+28|0;u=a+32|0;v=a+36|0;w=a+40|0;x=a+44|0;y=c[j>>2]|0;j=c[l>>2]|0;l=p;p=0;while(1){z=c[y>>2]|0;A=n+(z>>>5<<2)|0;c[A>>2]=c[A>>2]|1<<(z&31);A=z+1|0;if(A>>>0>(c[r>>2]|0)>>>0)c[r>>2]=A;B=ea(g[j>>2]);A=f+(z<<5)|0;g[A>>2]=B;C=ea(g[j+4>>2]);D=f+(z<<5)+4|0;g[D>>2]=C;E=ea(g[j+8>>2]);F=f+(z<<5)+8|0;g[F>>2]=E;g[f+(z<<5)+16>>2]=ea(g[l>>2]);g[f+(z<<5)+20>>2]=ea(g[l+4>>2]);g[f+(z<<5)+24>>2]=ea(g[l+8>>2]);b[f+(z<<5)+30>>1]=0;b[f+(z<<5)+28>>1]=1;g[f+(z<<5)+12>>2]=ea(0.0);G=ea(g[s>>2]);H=ea(g[t>>2]);I=ea(g[u>>2]);g[s>>2]=G<B?G:B;g[t>>2]=H<C?H:C;g[u>>2]=I<E?I:E;E=ea(g[v>>2]);I=ea(g[A>>2]);C=ea(g[w>>2]);H=ea(g[D>>2]);B=ea(g[x>>2]);G=ea(g[F>>2]);g[v>>2]=E>I?E:I;g[w>>2]=C>H?C:H;g[x>>2]=B>G?B:G;p=p+1|0;F=c[d>>2]|0;if(p>>>0>=F>>>0){q=F;break}else{y=y+k|0;j=j+m|0;l=l+o|0}}}o=c[a+52>>2]|0;if(!o){J=q;K=a+20|0;L=c[K>>2]|0;M=L+J|0;c[K>>2]=M;i=e;return 1}l=d+28|0;d=c[l>>2]|0;m=c[l+4>>2]|0;l=h;h=c[l>>2]|0;j=c[l+4>>2]|0;if(!q){J=0;K=a+20|0;L=c[K>>2]|0;M=L+J|0;c[K>>2]=M;i=e;return 1}l=h;h=d;d=0;while(1){g[o+(c[l>>2]<<2)>>2]=ea(g[h>>2]);d=d+1|0;if(d>>>0>=q>>>0){J=q;break}else{l=l+j|0;h=h+m|0}}K=a+20|0;L=c[K>>2]|0;M=L+J|0;c[K>>2]=M;i=e;return 1}function uva(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;if(d){g=c[e>>2]|0;h=e+4|0;e=c[a+48>>2]|0;j=c[a+56>>2]|0;k=0;do{l=c[g+(da(c[h>>2]|0,k)|0)>>2]|0;b[e+(l<<5)+28>>1]=0;m=j+(l>>>5<<2)|0;c[m>>2]=c[m>>2]&~(1<<(l&31));k=k+1|0}while((k|0)!=(d|0))}k=a+20|0;j=c[k>>2]|0;c[k>>2]=j-d;if((j|0)==(d|0)){n=0;o=a+16|0;c[o>>2]=n;i=f;return}d=a+56|0;j=c[a+60>>2]&2147483647;do{k=j;j=j+-1|0;if(!k){n=1;p=9;break}q=c[(c[d>>2]|0)+(j<<2)>>2]|0}while((q|0)==0);if((p|0)==9){o=a+16|0;c[o>>2]=n;i=f;return}p=q>>>1|q;q=p>>>2|p;p=q>>>4|q;q=p>>>8|p;n=(j<<5|1)+(c[482792+((da(q>>>16|q,130329821)|0)>>>27<<2)>>2]|0)|0;o=a+16|0;c[o>>2]=n;i=f;return}function vva(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+60|0;f=c[e>>2]&2147483647;a:do if(f){g=c[a+56>>2]|0;h=0;while(1){j=c[g+(h<<2)>>2]|0;if(j)break;k=h+1|0;if(k>>>0<f>>>0)h=k;else break a}k=c[425648+((da(j&0-j,125613361)|0)>>>27<<2)>>2]|h<<5;l=j+-1&j;b:do if(!l){m=h;while(1){n=m+1|0;if(n>>>0>=f>>>0){o=n;p=0;break b}q=c[g+(n<<2)>>2]|0;if(!q)m=n;else{o=n;p=q;break}}}else{o=h;p=l}while(0);if((k|0)!=-1){l=c[a+48>>2]|0;h=c[a+56>>2]|0;g=o;m=p;q=k;while(1){n=g<<5;r=m;s=q;while(1){b[l+(s<<5)+28>>1]=0;t=h+(s>>>5<<2)|0;c[t>>2]=c[t>>2]&~(1<<(s&31));if(!r)break a;s=c[425648+((da(r&0-r,125613361)|0)>>>27<<2)>>2]|n;r=r+-1&r;u=c[e>>2]&2147483647;if(!r){v=g;break}if((s|0)==-1)break a}while(1){v=v+1|0;if(v>>>0>=u>>>0){w=0;break}r=c[h+(v<<2)>>2]|0;if(r){w=r;break}}if((s|0)==-1)break;else{g=v;m=w;q=s}}}}while(0);c[a+20>>2]=0;c[a+16>>2]=0;i=d;return}function wva(a){a=a|0;return c[a+20>>2]|0}function xva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;c[b+12>>2]=a+56;d=a+20|0;c[b+4>>2]=c[d>>2];c[b>>2]=c[a+8>>2];c[b+8>>2]=c[a+16>>2];f=b+16|0;if(!(c[d>>2]|0)){d=f;c[d>>2]=0;c[d+4>>2]=12;d=b+24|0;c[d>>2]=0;c[d+4>>2]=12;d=b+32|0;c[d>>2]=0;c[d+4>>2]=4;d=b+40|0;c[d>>2]=0;c[d+4>>2]=4;i=e;return}else{d=a+48|0;g=f;c[g>>2]=c[d>>2];c[g+4>>2]=32;g=b+24|0;c[g>>2]=(c[d>>2]|0)+16;c[g+4>>2]=32;g=b+32|0;c[g>>2]=(c[d>>2]|0)+28;c[g+4>>2]=32;g=b+40|0;c[g>>2]=c[a+52>>2];c[g+4>>2]=4;i=e;return}}function yva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=Im,A=Im;f=i;h=d;d=c[h+4>>2]|0;j=e;e=c[j+4>>2]|0;if(!b){i=f;return}k=c[a+48>>2]|0;l=a+24|0;m=a+28|0;n=a+32|0;o=a+36|0;p=a+40|0;q=a+44|0;a=c[h>>2]|0;h=c[j>>2]|0;j=0;while(1){r=c[a>>2]|0;s=ea(g[h>>2]);t=k+(r<<5)|0;g[t>>2]=s;u=ea(g[h+4>>2]);v=k+(r<<5)+4|0;g[v>>2]=u;w=ea(g[h+8>>2]);x=k+(r<<5)+8|0;g[x>>2]=w;y=ea(g[l>>2]);z=ea(g[m>>2]);A=ea(g[n>>2]);g[l>>2]=y<s?y:s;g[m>>2]=z<u?z:u;g[n>>2]=A<w?A:w;w=ea(g[o>>2]);A=ea(g[t>>2]);u=ea(g[p>>2]);z=ea(g[v>>2]);s=ea(g[q>>2]);y=ea(g[x>>2]);g[o>>2]=w>A?w:A;g[p>>2]=u>z?u:z;g[q>>2]=s>y?s:y;j=j+1|0;if((j|0)==(b|0))break;else{a=a+d|0;h=h+e|0}}i=f;return}function zva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;h=d;d=c[h+4>>2]|0;j=e;e=c[j+4>>2]|0;if(!b){i=f;return}k=c[a+48>>2]|0;a=c[h>>2]|0;h=c[j>>2]|0;j=0;while(1){l=c[a>>2]|0;g[k+(l<<5)+16>>2]=ea(g[h>>2]);g[k+(l<<5)+20>>2]=ea(g[h+4>>2]);g[k+(l<<5)+24>>2]=ea(g[h+8>>2]);j=j+1|0;if((j|0)==(b|0))break;else{a=a+d|0;h=h+e|0}}i=f;return}function Ava(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;h=d;d=c[h+4>>2]|0;j=e;e=c[j+4>>2]|0;if(!b){i=f;return}k=c[a+52>>2]|0;a=c[h>>2]|0;h=c[j>>2]|0;j=0;while(1){g[k+(c[a>>2]<<2)>>2]=ea(g[h>>2]);j=j+1|0;if((j|0)==(b|0))break;else{a=a+d|0;h=h+e|0}}i=f;return}function Bva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=0;f=i;h=c[b+4>>2]&2147483647;if(!h){i=f;return}j=c[b>>2]|0;k=0;while(1){l=c[j+(k<<2)>>2]|0;if(l)break;m=k+1|0;if(m>>>0<h>>>0)k=m;else{n=17;break}}if((n|0)==17){i=f;return}m=c[425648+((da(l&0-l,125613361)|0)>>>27<<2)>>2]|k<<5;o=l+-1&l;a:do if(!o){l=k;while(1){p=l+1|0;if(p>>>0>=h>>>0){q=p;r=0;break a}s=c[j+(p<<2)>>2]|0;if(!s)l=p;else{q=p;r=s;break}}}else{q=k;r=o}while(0);if((m|0)==-1){i=f;return}o=c[a+48>>2]|0;a=q;q=r;r=m;b:while(1){m=a<<5;k=q;j=r;while(1){t=ea(ea(g[d+(j*12|0)>>2])*e);u=ea(ea(g[d+(j*12|0)+4>>2])*e);v=ea(ea(g[d+(j*12|0)+8>>2])*e);l=o+(j<<5)+16|0;g[l>>2]=ea(t+ea(g[l>>2]));l=o+(j<<5)+20|0;g[l>>2]=ea(u+ea(g[l>>2]));l=o+(j<<5)+24|0;g[l>>2]=ea(v+ea(g[l>>2]));if(!k){n=17;break b}j=c[425648+((da(k&0-k,125613361)|0)>>>27<<2)>>2]|m;k=k+-1&k;if(!k){w=a;break}if((j|0)==-1){n=17;break b}}while(1){w=w+1|0;if(w>>>0>=h>>>0){x=0;break}k=c[(c[b>>2]|0)+(w<<2)>>2]|0;if(k){x=k;break}}if((j|0)==-1){n=17;break}else{a=w;q=x;r=j}}if((n|0)==17){i=f;return}}function Cva(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+24>>2]);g[a+4>>2]=ea(g[b+28>>2]);g[a+8>>2]=ea(g[b+32>>2]);g[a+12>>2]=ea(g[b+36>>2]);g[a+16>>2]=ea(g[b+40>>2]);g[a+20>>2]=ea(g[b+44>>2]);return}function Dva(a){a=a|0;return c[a+8>>2]|0}function Eva(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=497872;c[a+4>>2]=d;c[a+8>>2]=0;c[a+44>>2]=0;c[a+48>>2]=0;return}function Fva(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Gva(a){a=a|0;return}function Hva(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,i=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;c[a+8>>2]=d;c[a+44>>2]=e;f=b[e>>1]|0;b[a+36>>1]=f;h=b[e+2>>1]|0;b[a+38>>1]=h;i=b[e+4>>1]|0;b[a+40>>1]=i;j=ea(f<<16>>16);k=ea(h<<16>>16);l=ea(i<<16>>16);i=d+684|0;m=ea(g[i>>2]);n=ea(j*m);j=ea(k*m);k=ea(l*m);m=ea(g[d+700>>2]);l=ea(j-m);o=ea(k-m);g[a+12>>2]=ea(n-m);g[a+16>>2]=l;g[a+20>>2]=o;o=ea(g[i>>2]);l=ea(m+ea(j+o));j=ea(m+ea(k+o));g[a+24>>2]=ea(m+ea(n+o));g[a+28>>2]=l;g[a+32>>2]=j;return}function Iva(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;Vsa(c[(c[d>>2]|0)+4>>2]|0,a);c[d>>2]=0;c[a+44>>2]=0;c[a+48>>2]=0;i=b;return}function Jva(a,b){a=a|0;b=b|0;var d=0;d=i;wYa(a,497896);wYa(a+92|0,497936);wYa(a+184|0,497976);wYa(a+276|0,498016);c[a+368>>2]=b;i=d;return}function Kva(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+16|0;j=h;if(!f)k=b+12|0;else{l=b+88|0;m=b+12|0;n=b+8|0;o=b+48|0;p=b+44|0;q=b+40|0;r=b+84|0;s=b+20|0;t=0;do{u=Sva(c[d+(t<<2)>>2]|0,e+(t<<3)|0,g)|0;oTa(c[l>>2]|0);fTa(m)|0;c[n>>2]=c[u+8>>2];c[j>>2]=u;v=c[p>>2]|0;if((c[o>>2]&2147483647)>>>0>v>>>0){w=(c[q>>2]|0)+(v<<2)|0;if(w)c[w>>2]=u;c[p>>2]=v+1}else eZa(s,j)|0;ko[c[(c[u>>2]|0)+16>>2]&4095](u);a[r>>0]=1;pTa(c[l>>2]|0);ko[c[(c[u>>2]|0)+20>>2]&4095](u);t=t+1|0}while((t|0)!=(f|0));k=m}if(!(c[k>>2]|0)){ko[c[(c[g>>2]|0)+16>>2]&4095](g);x=g;i=h;return x|0}if((c[k>>2]|0)>1)do fZa(b);while((c[k>>2]|0)>1);x=b;i=h;return x|0}function Lva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+16|0;h=g;if(!e)j=b+104|0;else{k=b+180|0;l=b+104|0;m=b+100|0;n=b+140|0;o=b+136|0;p=b+132|0;q=b+176|0;r=b+112|0;s=0;do{t=Tva(c[d+(s<<2)>>2]|0,f)|0;oTa(c[k>>2]|0);fTa(l)|0;c[m>>2]=c[t+8>>2];c[h>>2]=t;u=c[o>>2]|0;if((c[n>>2]&2147483647)>>>0>u>>>0){v=(c[p>>2]|0)+(u<<2)|0;if(v)c[v>>2]=t;c[o>>2]=u+1}else eZa(r,h)|0;ko[c[(c[t>>2]|0)+16>>2]&4095](t);a[q>>0]=1;pTa(c[k>>2]|0);ko[c[(c[t>>2]|0)+20>>2]&4095](t);s=s+1|0}while((s|0)!=(e|0));j=l}l=b+92|0;if(!(c[j>>2]|0)){ko[c[(c[f>>2]|0)+16>>2]&4095](f);w=f;i=g;return w|0}if((c[j>>2]|0)>1)do fZa(l);while((c[j>>2]|0)>1);w=l;i=g;return w|0}function Mva(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;h=d;if(f){j=b+272|0;k=b+196|0;l=b+192|0;m=b+232|0;n=b+228|0;o=b+224|0;p=b+268|0;q=b+204|0;if(!g){r=0;do{s=e+(r<<2)|0;t=c[s>>2]|0;c[t+16>>2]=1;c[t+12>>2]=0;t=c[s>>2]|0;oTa(c[j>>2]|0);fTa(k)|0;c[l>>2]=c[t+8>>2];c[h>>2]=t;u=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>u>>>0){v=(c[o>>2]|0)+(u<<2)|0;if(v)c[v>>2]=t;c[n>>2]=u+1}else eZa(q,h)|0;ko[c[(c[t>>2]|0)+16>>2]&4095](t);a[p>>0]=1;pTa(c[j>>2]|0);t=c[s>>2]|0;ko[c[(c[t>>2]|0)+20>>2]&4095](t);r=r+1|0}while((r|0)!=(f|0));w=k}else{r=0;do{t=e+(r<<2)|0;s=c[t>>2]|0;c[s+16>>2]=1;u=s+12|0;c[u>>2]=g;ko[c[(c[g>>2]|0)+16>>2]&4095](g);c[s+8>>2]=c[(c[u>>2]|0)+8>>2];u=c[t>>2]|0;oTa(c[j>>2]|0);fTa(k)|0;c[l>>2]=c[u+8>>2];c[h>>2]=u;s=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>s>>>0){v=(c[o>>2]|0)+(s<<2)|0;if(v)c[v>>2]=u;c[n>>2]=s+1}else eZa(q,h)|0;ko[c[(c[u>>2]|0)+16>>2]&4095](u);a[p>>0]=1;pTa(c[j>>2]|0);u=c[t>>2]|0;ko[c[(c[u>>2]|0)+20>>2]&4095](u);r=r+1|0}while((r|0)!=(f|0));w=k}}else w=b+196|0;k=b+184|0;if(!(c[w>>2]|0)){ko[c[(c[g>>2]|0)+16>>2]&4095](g);x=g;i=d;return x|0}if((c[w>>2]|0)>1)do fZa(k);while((c[w>>2]|0)>1);x=k;i=d;return x|0}function Nva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+16|0;h=g;if(!e)j=b+288|0;else{k=b+364|0;l=b+288|0;m=b+284|0;n=b+324|0;o=b+320|0;p=b+316|0;q=b+360|0;r=b+296|0;s=0;do{t=Uva(c[d+(s<<2)>>2]|0,f)|0;oTa(c[k>>2]|0);fTa(l)|0;c[m>>2]=c[t+8>>2];c[h>>2]=t;u=c[o>>2]|0;if((c[n>>2]&2147483647)>>>0>u>>>0){v=(c[p>>2]|0)+(u<<2)|0;if(v)c[v>>2]=t;c[o>>2]=u+1}else eZa(r,h)|0;ko[c[(c[t>>2]|0)+16>>2]&4095](t);a[q>>0]=1;pTa(c[k>>2]|0);ko[c[(c[t>>2]|0)+20>>2]&4095](t);s=s+1|0}while((s|0)!=(e|0));j=l}l=b+276|0;if(!(c[j>>2]|0)){ko[c[(c[f>>2]|0)+16>>2]&4095](f);w=f;i=g;return w|0}if((c[j>>2]|0)>1)do fZa(l);while((c[j>>2]|0)>1);w=l;i=g;return w|0}function Ova(){return}function Pva(a){a=a|0;return c[a+8>>2]|0}function Qva(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=d;c[f>>2]=0;c[f+4>>2]=4;f=d+8|0;g=f;c[g>>2]=0;c[g+4>>2]=12;g=d+16|0;h=g;c[h>>2]=0;c[h+4>>2]=12;h=d+24|0;j=h;c[j>>2]=0;c[j+4>>2]=12;j=d+32|0;k=j;c[k>>2]=0;c[k+4>>2]=4;k=c[a+8>>2]|0;if(!(c[k+20>>2]|0)){i=e;return}if(!(c[a+16>>2]|0)){i=e;return}l=a+12|0;m=b[(c[l>>2]|0)+80>>1]|0;if(!(m&64))n=m;else{m=d;c[m>>2]=(c[k+48>>2]|0)+12;c[m+4>>2]=32;n=b[(c[l>>2]|0)+80>>1]|0}if(!(n&16))o=n;else{n=f;c[n>>2]=c[a+64>>2];c[n+4>>2]=12;o=b[(c[l>>2]|0)+80>>1]|0}if(o&32){o=g;c[o>>2]=c[a+68>>2];c[o+4>>2]=12}o=a+20|0;a=c[o>>2]|0;if(!a){i=e;return}g=h;c[g>>2]=a;c[g+4>>2]=16;g=j;c[g>>2]=(c[o>>2]|0)+12;c[g+4>>2]=16;i=e;return}function Rva(a,b){a=a|0;b=b|0;var d=0,e=0;d=a+32|0;c[b+12>>2]=c[d>>2];e=a+24|0;c[b+8>>2]=c[e>>2];c[b+4>>2]=c[a+28>>2];c[b>>2]=(c[e>>2]|0)+(c[d>>2]<<2);return}function Sva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+1172|0;c[a+1188>>2]=1;g=a+1184|0;c[g>>2]=d;if(d){ko[c[(c[d>>2]|0)+16>>2]&4095](d);c[a+1180>>2]=c[(c[g>>2]|0)+8>>2]}c[a+1160>>2]=1;g=a+1156|0;c[g>>2]=f;ko[c[(c[f>>2]|0)+16>>2]&4095](f);c[a+1152>>2]=c[(c[g>>2]|0)+8>>2];ko[c[(c[f>>2]|0)+20>>2]&4095](f);f=b;b=c[f+4>>2]|0;g=a+1312|0;c[g>>2]=c[f>>2];c[g+4>>2]=b;i=e;return a+1144|0}function Tva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!(c[(c[a+12>>2]|0)+20>>2]&65536)){ko[c[(c[b>>2]|0)+16>>2]&4095](b);e=b;i=d;return e|0}c[a+1216>>2]=1;f=a+1212|0;c[f>>2]=b;if(b){ko[c[(c[b>>2]|0)+16>>2]&4095](b);c[a+1208>>2]=c[(c[f>>2]|0)+8>>2]}e=a+1200|0;i=d;return e|0}function Uva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+1256|0;c[a+1272>>2]=1;f=a+1268|0;c[f>>2]=b;if(b){ko[c[(c[b>>2]|0)+16>>2]&4095](b);c[a+1264>>2]=c[(c[f>>2]|0)+8>>2]}c[a+1244>>2]=1;f=a+1240|0;c[f>>2]=e;ko[c[(c[e>>2]|0)+16>>2]&4095](e);c[a+1236>>2]=c[(c[f>>2]|0)+8>>2];ko[c[(c[e>>2]|0)+20>>2]&4095](e);i=d;return a+1228|0}function Vva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;c[a+28>>2]=0;c[a+32>>2]=0;d=a+8|0;e=c[d>>2]|0;if(!(c[e+16>>2]|0)){i=b;return}f=a+36|0;if(!(c[f>>2]|0)){g=(c[e+8>>2]<<2)+19|0;e=mKa()|0;h=c[(c[e>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](e,g,k?528936:544544,498056,167)|0;if(!j)l=0;else{k=j+19&-16;g=k;c[g+-4>>2]=k-j;l=g}c[f>>2]=l}if(!(c[(c[a+12>>2]|0)+20>>2]&65536)){l=a+1172|0;ko[c[(c[l>>2]|0)+16>>2]&4095](l);m=l}else{l=a+1172|0;c[a+1300>>2]=1;g=a+1296|0;c[g>>2]=l;ko[c[(c[l>>2]|0)+16>>2]&4095](l);c[a+1292>>2]=c[(c[g>>2]|0)+8>>2];m=a+1284|0}g=c[d>>2]|0;rua(c[a+72>>2]|0,a+40|0,c[f>>2]|0,c[g+48>>2]|0,g+56|0,c[g+16>>2]|0,m);i=b;return}function Wva(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+16|0;g=f;if(!(c[(c[a+8>>2]|0)+16>>2]|0)){if(!e){i=f;return}h=a+32|0;j=a+24|0;k=c[h>>2]|0;l=k;m=0;while(1){c[(c[j>>2]|0)+(l<<2)>>2]=c[d+(m<<2)>>2];m=m+1|0;if((m|0)==(e|0))break;else l=l+1|0}c[h>>2]=k+e;i=f;return}c[g>>2]=0;k=g+4|0;h=g+8|0;c[k>>2]=32;l=UJa(h,128,543784,362)|0;c[g>>2]=l;PEi(l|0,0,c[k>>2]<<2|0)|0;l=a+72|0;m=a+32|0;j=a+24|0;if(e){n=0;do{o=c[d+(n<<2)>>2]|0;p=c[l>>2]|0;q=b[o+36>>1]|0;r=b[o+38>>1]|0;s=b[o+40>>1]|0;t=c[p>>2]|0;u=(c[p+8>>2]|0)+-1|0;p=((r<<16>>16)*101|0)+(q<<16>>16)+((s<<16>>16)*7919|0)&u;v=c[t+(p<<4)+8>>2]|0;a:do if((v|0)!=-1){w=v;x=p;while(1){if((q<<16>>16==(b[t+(x<<4)>>1]|0)?r<<16>>16==(b[t+(x<<4)+2>>1]|0):0)?s<<16>>16==(b[t+(x<<4)+4>>1]|0):0)break;y=x+1&u;z=c[t+(y<<4)+8>>2]|0;if((z|0)==-1){A=13;break a}else{w=z;x=y}}if((w|0)!=-1?(y=t+(x<<4)|0,(y|0)!=0):0){c[o+44>>2]=y;y=(c[g>>2]|0)+(x>>>5<<2)|0;c[y>>2]=c[y>>2]|1<<(x&31)}else A=13}else A=13;while(0);if((A|0)==13){A=0;t=c[m>>2]|0;c[m>>2]=t+1;c[(c[j>>2]|0)+(t<<2)>>2]=o}n=n+1|0}while((n|0)!=(e|0))}e=c[c[l>>2]>>2]|0;l=a+4|0;n=a+28|0;A=0;do{if(((c[(c[g>>2]|0)+(A>>>5<<2)>>2]&1<<(A&31)|0)==0?(c[e+(A<<4)+8>>2]|0)!=-1:0)?(d=Usa(c[l>>2]|0,a,e+(A<<4)|0)|0,(d|0)!=0):0){t=c[m>>2]|0;u=c[n>>2]|0;c[n>>2]=u+1;c[(c[j>>2]|0)+(u+t<<2)>>2]=d}A=A+1|0}while((A|0)!=1024);A=c[g>>2]|0;if(!((A|0)!=0&(c[k>>2]|0)>-1)){i=f;return}VJa(h,A);i=f;return}function Xva(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=0;d=i;e=c[a+12>>2]|0;f=ea(g[e+44>>2]);h=ea(g[a+1120>>2]);j=ea(f*h);if(j<ea(1.0))k=ea(ea(1.0)-j);else k=ea(0.0);g[a+652>>2]=k;g[a+640>>2]=ea(g[a+1128>>2]);g[a+644>>2]=ea(g[a+1132>>2]);g[a+648>>2]=ea(g[a+1136>>2]);g[a+712>>2]=ea(g[e+64>>2]);g[a+716>>2]=ea(g[e+68>>2]);g[a+720>>2]=ea(g[e+72>>2]);g[a+724>>2]=ea(g[e+76>>2]);g[a+704>>2]=h;if(h>ea(0.0))l=ea(ea(1.0)/h);else l=ea(0.0);g[a+708>>2]=l;l=ea(g[e+28>>2]);m=l<ea(0.0);h=m?ea(0.0):l;m=h>ea(.949999988);g[a+656>>2]=m?ea(.949999988):h;h=ea(g[e+32>>2]);m=h<ea(.00100000005);l=m?ea(.00100000005):h;m=l>ea(1.0);g[a+660>>2]=m?ea(1.0):l;l=ea(g[e+36>>2]);g[a+664>>2]=ea(l*l);m=c[e+84>>2]|0;c[a+732>>2]=(da(da(m,4999879)|0,m)|0)&65535;c[a+728>>2]=c[e+20>>2];e=c[a+8>>2]|0;g[e+24>>2]=ea(8507058669999999534545717.0e13);g[e+28>>2]=ea(8507058669999999534545717.0e13);g[e+32>>2]=ea(8507058669999999534545717.0e13);g[e+36>>2]=ea(-8507058669999999534545717.0e13);g[e+40>>2]=ea(-8507058669999999534545717.0e13);g[e+44>>2]=ea(-8507058669999999534545717.0e13);Ota(a+640|0,c[a+1320>>2]|0,b);i=d;return}function Yva(a,b){a=a|0;b=b|0;g[a+1128>>2]=ea(g[b>>2]);g[a+1132>>2]=ea(g[b+4>>2]);g[a+1136>>2]=ea(g[b+8>>2]);return}function Zva(a){a=a|0;return a+1128|0}function _va(a,b){a=a|0;b=ea(b);g[a+1120>>2]=b;return}function $va(a){a=a|0;var b=Im;b=ea(g[a+1120>>2]);return ea(b)}function awa(b,c){b=b|0;c=c|0;var d=0;d=i;a[b+1124>>0]=c&1;if(c){i=d;return}bwa(b);i=d;return}function bwa(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;f=c[a+8>>2]|0;a=c[f+48>>2]|0;g=f+56|0;h=c[f+60>>2]&2147483647;if(!h){i=d;return}f=c[g>>2]|0;j=0;while(1){k=c[f+(j<<2)>>2]|0;if(k)break;l=j+1|0;if(l>>>0<h>>>0)j=l;else{m=17;break}}if((m|0)==17){i=d;return}l=c[425648+((da(k&0-k,125613361)|0)>>>27<<2)>>2]|j<<5;n=k+-1&k;a:do if(!n){k=j;while(1){o=k+1|0;if(o>>>0>=h>>>0){p=o;q=0;break a}r=c[f+(o<<2)>>2]|0;if(!r)k=o;else{p=o;q=r;break}}}else{p=j;q=n}while(0);if((l|0)==-1){i=d;return}n=p;p=q;q=l;b:while(1){l=n<<5;j=p;f=q;while(1){k=a+(f<<5)+30|0;b[k>>1]=(e[k>>1]|0)&65532;if(!j){m=17;break b}f=c[425648+((da(j&0-j,125613361)|0)>>>27<<2)>>2]|l;j=j+-1&j;if(!j){s=n;break}if((f|0)==-1){m=17;break b}}while(1){s=s+1|0;if(s>>>0>=h>>>0){t=0;break}j=c[(c[g>>2]|0)+(s<<2)>>2]|0;if(j){t=j;break}}if((f|0)==-1){m=17;break}else{n=s;p=t;q=f}}if((m|0)==17){i=d;return}}function cwa(a){a=a|0;return d[a+1124>>0]|0|0}function dwa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;c[a>>2]=498160;c[a+4>>2]=d;c[a+8>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+36>>2]=0;c[a+40>>2]=0;c[a+60>>2]=0;c[a+64>>2]=0;c[a+68>>2]=0;gua(a+80|0,a);Mta(a+640|0,a);c[a+1140>>2]=e;e=a+1144|0;b[a+1148>>1]=-1;b[a+1150>>1]=0;c[a+1152>>2]=0;c[e>>2]=443968;c[a+1156>>2]=0;c[a+1160>>2]=0;c[e>>2]=498752;c[a+1164>>2]=a;c[a+1168>>2]=498224;e=a+1172|0;b[a+1176>>1]=-1;b[a+1178>>1]=0;c[a+1180>>2]=0;c[e>>2]=443968;c[a+1184>>2]=0;c[a+1188>>2]=0;c[e>>2]=498704;c[a+1192>>2]=a;c[a+1196>>2]=498272;e=a+1200|0;b[a+1204>>1]=-1;b[a+1206>>1]=0;c[a+1208>>2]=0;c[e>>2]=443968;c[a+1212>>2]=0;c[a+1216>>2]=0;c[e>>2]=498656;c[a+1220>>2]=a;c[a+1224>>2]=498320;e=a+1228|0;b[a+1232>>1]=-1;b[a+1234>>1]=0;c[a+1236>>2]=0;c[e>>2]=443968;c[a+1240>>2]=0;c[a+1244>>2]=0;c[e>>2]=498608;c[a+1248>>2]=a;c[a+1252>>2]=498360;e=a+1256|0;b[a+1260>>1]=-1;b[a+1262>>1]=0;c[a+1264>>2]=0;c[e>>2]=443968;c[a+1268>>2]=0;c[a+1272>>2]=0;c[e>>2]=498560;c[a+1276>>2]=a;c[a+1280>>2]=498400;e=a+1284|0;b[a+1288>>1]=-1;b[a+1290>>1]=0;c[a+1292>>2]=0;c[e>>2]=443968;c[a+1296>>2]=0;c[a+1300>>2]=0;c[e>>2]=498512;c[a+1304>>2]=a;c[a+1308>>2]=498448;i=f;return}function ewa(a){a=a|0;var b=0;b=i;c[a>>2]=498160;c[a+1284>>2]=443968;c[a+1292>>2]=0;c[a+1256>>2]=443968;c[a+1264>>2]=0;c[a+1228>>2]=443968;c[a+1236>>2]=0;c[a+1200>>2]=443968;c[a+1208>>2]=0;c[a+1172>>2]=443968;c[a+1180>>2]=0;c[a+1144>>2]=443968;c[a+1152>>2]=0;Nta(a+640|0);hua(a+80|0);ACi(a);i=b;return}function fwa(a){a=a|0;var b=0;b=i;c[a>>2]=498160;c[a+1284>>2]=443968;c[a+1292>>2]=0;c[a+1256>>2]=443968;c[a+1264>>2]=0;c[a+1228>>2]=443968;c[a+1236>>2]=0;c[a+1200>>2]=443968;c[a+1208>>2]=0;c[a+1172>>2]=443968;c[a+1180>>2]=0;c[a+1144>>2]=443968;c[a+1152>>2]=0;Nta(a+640|0);hua(a+80|0);i=b;return}function gwa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im;f=i;i=i+16|0;h=f+1|0;j=f;k=a+8|0;c[k>>2]=d;ova(d);d=a+12|0;c[d>>2]=e;g[a+1120>>2]=ea(0.0);g[a+1128>>2]=ea(0.0);g[a+1132>>2]=ea(0.0);g[a+1136>>2]=ea(0.0);c[a+36>>2]=0;hwa(a);e=c[(c[k>>2]|0)+8>>2]|0;k=(e<<4)+19|0;l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,k,o?528936:544544,498056,347)|0;if(!n)p=0;else{o=n+19&-16;c[o+-4>>2]=o-n;p=o}c[a+44>>2]=p;p=mKa()|0;o=c[(c[p>>2]|0)+8>>2]|0;n=pKa()|0;l=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[o&255](p,k,l?528936:544544,498056,348)|0;if(!n)q=0;else{l=n+19&-16;c[l+-4>>2]=l-n;q=l}c[a+48>>2]=q;q=c[d>>2]|0;l=c[q+20>>2]|0;if(!(l&2)){c[a+52>>2]=0;c[a+56>>2]=0;r=q;s=l}else{l=mKa()|0;q=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;p=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[q&255](l,k,p?528936:544544,498056,351)|0;if(!n)t=0;else{p=n+19&-16;c[p+-4>>2]=p-n;t=p}c[a+52>>2]=t;t=mKa()|0;p=c[(c[t>>2]|0)+8>>2]|0;n=pKa()|0;l=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[p&255](t,k,l?528936:544544,498056,352)|0;if(!n)u=0;else{l=n+19&-16;c[l+-4>>2]=l-n;u=l}c[a+56>>2]=u;u=c[d>>2]|0;r=u;s=c[u+20>>2]|0}if((s&3|0)==3){u=mKa()|0;l=c[(c[u>>2]|0)+8>>2]|0;n=pKa()|0;t=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[l&255](u,k,t?528936:544544,498056,362)|0;if(!n)v=0;else{t=n+19&-16;c[t+-4>>2]=t-n;v=t}c[a+20>>2]=v;v=c[d>>2]|0;w=c[v+20>>2]|0;x=v}else{w=s;x=r}if(!(w&32)){y=w;z=x}else{x=mKa()|0;w=c[(c[x>>2]|0)+8>>2]|0;r=pKa()|0;s=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[w&255](x,e<<5|19,s?528936:544544,498056,378)|0;if(!r)A=0;else{s=r+19&-16;c[s+-4>>2]=s-r;A=s}c[a+60>>2]=A;A=c[d>>2]|0;y=c[A+20>>2]|0;z=A}if((y&65536|0)==0?(y=b[z+80>>1]|0,(y&16)==0):0)B=y;else{y=mKa()|0;z=c[(c[y>>2]|0)+8>>2]|0;A=pKa()|0;s=mo[c[(c[A>>2]|0)+24>>2]&4095](A)|0;A=Bn[z&255](y,(e*12|0)+19|0,s?528936:544544,498056,386)|0;if(!A)C=0;else{s=A+19&-16;c[s+-4>>2]=s-A;C=s}c[a+64>>2]=C;B=b[(c[d>>2]|0)+80>>1]|0}if(B&32){B=mKa()|0;C=c[(c[B>>2]|0)+8>>2]|0;s=pKa()|0;A=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;s=Bn[C&255](B,(e*12|0)+19|0,A?528936:544544,498056,389)|0;if(!s)D=0;else{A=s+19&-16;c[A+-4>>2]=A-s;D=A}c[a+68>>2]=D}c[a+24>>2]=UJa(h,8192,498056,391)|0;c[a+28>>2]=0;c[a+32>>2]=0;h=UJa(j,24,498056,396)|0;c[a+72>>2]=h;if(!h){E=a+1320|0;c[E>>2]=0;F=a+16|0;c[F>>2]=0;i=f;return}G=ea(g[a+108>>2]);j=c[d>>2]|0;pua(h,1024,G,c[j+24>>2]|0,(c[j+20>>2]&65536|0)!=0);E=a+1320|0;c[E>>2]=0;F=a+16|0;c[F>>2]=0;i=f;return}function hwa(a){a=a|0;var b=0,d=0,e=Im,f=Im,h=Im,j=0,k=Im,l=Im,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=0,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=0,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;d=c[a+12>>2]|0;e=ea(g[d>>2]);f=ea(g[d+40>>2]);g[a+140>>2]=f;h=ea(f*ea(.00100000005));g[a+100>>2]=h;j=d+4|0;k=ea(e*ea(g[j>>2]));g[a+104>>2]=k;l=ea(ea(1.0)/k);g[a+108>>2]=l;g[a+112>>2]=ea(k*k);m=d+24|0;n=c[m>>2]|0;o=ea(k*ea(1<<n|0));g[a+116>>2]=o;p=ea(ea(g[j>>2])*ea(.100000001));q=ea(p*p);r=ea(q*ea(q*q));s=ea(ea(315.0)/ea(ea(p*ea(q*r))*ea(201.061935)));t=ea(ea(22.5)/ea(r*ea(3.14159274)));g[a+120>>2]=p;g[a+124>>2]=q;p=ea(s*h);g[a+128>>2]=p;s=ea(t*h);g[a+132>>2]=ea(s*ea(g[d+48>>2]));s=ea(q*ea(q*ea(q*p)));g[a+96>>2]=s;p=ea(ea(.100000001)/e);g[a+144>>2]=p;g[a+148>>2]=ea(p*p);g[a+152>>2]=ea(ea(1.0)/p);c[a+160>>2]=n;p=ea(f-s);if(p>ea(0.0))u=ea(ea(1.0)/p);else u=ea(0.0);g[a+156>>2]=u;u=ea(ea(g[j>>2])*ea(.100000001));p=ea(u*u);u=ea(p*ea(p*p));g[a+136>>2]=ea(h*ea(ea(g[d+8>>2])*ea(ea(45.0)/ea(u*ea(3.14159274)))));g[a+668>>2]=k;g[a+672>>2]=l;c[a+676>>2]=c[m>>2];c[a+680>>2]=1<<c[m>>2];g[a+684>>2]=o;g[a+688>>2]=ea(g[d+56>>2]);o=ea(g[d+60>>2]);g[a+692>>2]=o;l=ea(g[d+52>>2]);g[a+696>>2]=l;g[a+700>>2]=ea(ea(l+o)+ea(.00100000005));o=ea(g[d+44>>2]);l=ea(g[a+1120>>2]);k=ea(o*l);if(k<ea(1.0))v=ea(ea(1.0)-k);else v=ea(0.0);g[a+652>>2]=v;g[a+640>>2]=ea(g[a+1128>>2]);g[a+644>>2]=ea(g[a+1132>>2]);g[a+648>>2]=ea(g[a+1136>>2]);g[a+712>>2]=ea(g[d+64>>2]);g[a+716>>2]=ea(g[d+68>>2]);g[a+720>>2]=ea(g[d+72>>2]);g[a+724>>2]=ea(g[d+76>>2]);g[a+704>>2]=l;if(!(l>ea(0.0))){w=ea(0.0);x=a+708|0;g[x>>2]=w;y=d+28|0;z=ea(g[y>>2]);A=z<ea(0.0);B=A?ea(0.0):z;C=B>ea(.949999988);D=C?ea(.949999988):B;E=a+656|0;g[E>>2]=D;F=d+32|0;G=ea(g[F>>2]);H=G<ea(.00100000005);I=H?ea(.00100000005):G;J=I>ea(1.0);K=J?ea(1.0):I;L=a+660|0;g[L>>2]=K;M=d+36|0;N=ea(g[M>>2]);O=ea(N*N);P=a+664|0;g[P>>2]=O;Q=d+84|0;R=c[Q>>2]|0;S=da(R,4999879)|0;T=da(S,R)|0;U=T&65535;V=a+732|0;c[V>>2]=U;W=d+20|0;X=c[W>>2]|0;Y=a+728|0;c[Y>>2]=X;i=b;return}w=ea(ea(1.0)/l);x=a+708|0;g[x>>2]=w;y=d+28|0;z=ea(g[y>>2]);A=z<ea(0.0);B=A?ea(0.0):z;C=B>ea(.949999988);D=C?ea(.949999988):B;E=a+656|0;g[E>>2]=D;F=d+32|0;G=ea(g[F>>2]);H=G<ea(.00100000005);I=H?ea(.00100000005):G;J=I>ea(1.0);K=J?ea(1.0):I;L=a+660|0;g[L>>2]=K;M=d+36|0;N=ea(g[M>>2]);O=ea(N*N);P=a+664|0;g[P>>2]=O;Q=d+84|0;R=c[Q>>2]|0;S=da(R,4999879)|0;T=da(S,R)|0;U=T&65535;V=a+732|0;c[V>>2]=U;W=d+20|0;X=c[W>>2]|0;Y=a+728|0;c[Y>>2]=X;i=b;return}function iwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;iua(a+80|0);e=a+72|0;f=c[e>>2]|0;if(f){qua(f);VJa(b+1|0,c[e>>2]|0);c[e>>2]=0}e=a+44|0;f=c[e>>2]|0;if((f|0)!=0?(g=f+(0-(c[f+-4>>2]|0))|0,(g|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,g)}c[e>>2]=0;e=a+48|0;g=c[e>>2]|0;if((g|0)!=0?(f=g+(0-(c[g+-4>>2]|0))|0,(f|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}c[e>>2]=0;e=a+52|0;f=c[e>>2]|0;if(f){g=f+(0-(c[f+-4>>2]|0))|0;if(g){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,g)}c[e>>2]=0}e=a+56|0;g=c[e>>2]|0;if(g){f=g+(0-(c[g+-4>>2]|0))|0;if(f){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}c[e>>2]=0}e=a+60|0;f=c[e>>2]|0;if(f){g=f+(0-(c[f+-4>>2]|0))|0;if(g){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,g)}c[e>>2]=0}e=a+64|0;g=c[e>>2]|0;if(g){f=g+(0-(c[g+-4>>2]|0))|0;if(f){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,f)}c[e>>2]=0}e=a+68|0;f=c[e>>2]|0;if(f){g=f+(0-(c[f+-4>>2]|0))|0;if(g){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,g)}c[e>>2]=0}e=a+24|0;g=c[e>>2]|0;if(g){VJa(d,g);c[e>>2]=0}e=a+36|0;g=c[e>>2]|0;if(g){d=g+(0-(c[g+-4>>2]|0))|0;if(d){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,d)}c[e>>2]=0}c[a+40>>2]=0;e=a+20|0;d=c[e>>2]|0;if(d){g=d+(0-(c[d+-4>>2]|0))|0;if(g){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,g)}c[e>>2]=0}c[a+16>>2]=0;e=a+8|0;a=c[e>>2]|0;if(!a){i=b;return}sva(a);c[e>>2]=0;i=b;return}function jwa(a){a=a|0;var b=0;b=a+8|0;a=c[b>>2]|0;c[b>>2]=0;return a|0}function kwa(a,d,e,f,g,h,j){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0;j=i;k=e;if(!h){i=j;return}if(g){if(!(c[a+20>>2]|0)){i=j;return}lwa(a,d,f);i=j;return}f=c[a+60>>2]|0;if(!f){i=j;return}g=k+36|0;if((c[g>>2]|0)!=5){i=j;return}k=c[d+44>>2]|0;d=c[(c[a+8>>2]|0)+48>>2]|0;h=c[k+12>>2]|0;e=(c[k+8>>2]|0)+h|0;if(h>>>0>=e>>>0){i=j;return}k=c[a+36>>2]|0;a=h;do{h=c[k+(a<<2)>>2]|0;l=d+(h<<5)+30|0;m=b[l>>1]|0;if((m&48)!=0?(c[f+(h<<5)+28>>2]|0)==(g|0):0)b[l>>1]=m&65487;a=a+1|0}while((a|0)!=(e|0));i=j;return}function lwa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;h=c[d+44>>2]|0;d=c[(c[a+8>>2]|0)+48>>2]|0;j=c[h+12>>2]|0;k=(c[h+8>>2]|0)+j|0;if(j>>>0>=k>>>0){i=f;return}h=a+36|0;l=a+44|0;m=a+48|0;n=a+52|0;o=a+56|0;a=j;do{j=c[(c[h>>2]|0)+(a<<2)>>2]|0;do if((b[d+(j<<5)+28>>1]&1)!=0?(p=d+(j<<5)+30|0,q=b[p>>1]|0,r=q&65535,(r&3|0)!=0):0){s=c[l>>2]|0;t=c[m>>2]|0;u=c[n>>2]|0;v=c[o>>2]|0;w=c[v+(j<<4)+12>>2]|0;if((w|0)==(e|0)){x=r&65525;b[p>>1]=x;y=x}else y=q;q=u+(j<<4)+12|0;if((c[q>>2]|0)==(e|0)){x=y&65535;if(!(x&2)){b[p>>1]=x&65530;break}else{g[s+(j<<4)>>2]=ea(g[t+(j<<4)>>2]);g[s+(j<<4)+4>>2]=ea(g[t+(j<<4)+4>>2]);g[s+(j<<4)+8>>2]=ea(g[t+(j<<4)+8>>2]);g[s+(j<<4)+12>>2]=ea(g[t+(j<<4)+12>>2]);g[u+(j<<4)>>2]=ea(g[v+(j<<4)>>2]);g[u+(j<<4)+4>>2]=ea(g[v+(j<<4)+4>>2]);g[u+(j<<4)+8>>2]=ea(g[v+(j<<4)+8>>2]);c[q>>2]=w;b[p>>1]=x&65525;break}}}while(0);a=a+1|0}while((a|0)!=(k|0));i=f;return}function mwa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=c[a+60>>2]|0;if(!g){i=f;return}h=e+36|0;if((c[h>>2]|0)!=5){i=f;return}e=c[d+44>>2]|0;d=c[(c[a+8>>2]|0)+48>>2]|0;j=c[e+12>>2]|0;k=(c[e+8>>2]|0)+j|0;if(j>>>0>=k>>>0){i=f;return}e=c[a+36>>2]|0;a=j;do{j=c[e+(a<<2)>>2]|0;l=d+(j<<5)+30|0;m=b[l>>1]|0;if((m&48)!=0?(c[g+(j<<5)+28>>2]|0)==(h|0):0)b[l>>1]=m&65487;a=a+1|0}while((a|0)!=(k|0));i=f;return}function nwa(a,b){a=a|0;b=b|0;c[a+1320>>2]=c[b>>2];return}function owa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a+72>>2]|0;if((e|0)!=1073741823){f=b+5916|0;g=(e+32|0)>>>5;h=b+5920|0;if(g>>>0>(c[h>>2]&2147483647)>>>0){j=b+5924|0;k=UJa(j,g<<2,543784,339)|0;l=c[f>>2]|0;if((l|0)!=0?(YEi(k|0,l|0,c[h>>2]<<2|0)|0,(c[h>>2]|0)>-1):0)VJa(j,c[f>>2]|0);j=c[h>>2]|0;PEi(k+((j&2147483647)<<2)|0,0,g-j<<2|0)|0;c[f>>2]=k;c[h>>2]=g;m=k}else m=c[f>>2]|0;f=m+(e>>>5<<2)|0;c[f>>2]=c[f>>2]|1<<(e&31)}e=b+1448|0;f=a+64|0;if(!(c[b+5840>>2]|0)){i=d;return}if(!(yqa(e,c[f>>2]|0)|0)){i=d;return}vqa(e,c[f>>2]|0);i=d;return}function pwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;c[b+44>>2]=a;c[b+40>>2]=e;g[a>>2]=ea(g[d+64>>2]);g[a+4>>2]=ea(g[d+68>>2]);g[a+8>>2]=ea(g[d+72>>2]);g[a+16>>2]=ea(g[d+80>>2]);g[a+20>>2]=ea(g[d+84>>2]);g[a+24>>2]=ea(g[d+88>>2]);g[b+48>>2]=ea(g[d+124>>2]);g[b+52>>2]=ea(g[d+76>>2]);f=ea(g[d>>2]);h=ea(g[d+4>>2]);i=ea(g[d+8>>2]);j=ea(g[d+12>>2]);k=ea(f+f);l=ea(h+h);m=ea(i+i);n=ea(h*l);o=ea(i*m);p=ea(k*h);h=ea(k*i);q=ea(k*j);r=ea(l*i);i=ea(l*j);l=ea(m*j);j=ea(ea(ea(1.0)-n)-o);m=ea(p+l);s=ea(h-i);t=ea(p-l);l=ea(ea(1.0)-ea(f*k));k=ea(l-o);o=ea(r+q);f=ea(h+i);i=ea(r-q);q=ea(l-n);n=ea(g[d+112>>2]);l=ea(n*j);r=ea(n*m);h=ea(n*s);n=ea(g[d+116>>2]);p=ea(n*t);u=ea(n*k);v=ea(n*o);n=ea(g[d+120>>2]);w=ea(f*n);x=ea(i*n);y=ea(q*n);g[b>>2]=ea(ea(ea(j*l)+ea(t*p))+ea(f*w));a=b+12|0;g[a+4>>2]=ea(ea(ea(m*r)+ea(k*u))+ea(i*x));e=b+24|0;g[e+8>>2]=ea(ea(ea(s*h)+ea(o*v))+ea(q*y));y=ea(ea(ea(m*l)+ea(k*p))+ea(i*w));g[b+4>>2]=y;g[a>>2]=y;y=ea(ea(ea(s*l)+ea(o*p))+ea(q*w));g[b+8>>2]=y;g[e>>2]=y;y=ea(ea(ea(s*r)+ea(o*u))+ea(q*x));g[a+8>>2]=y;g[e+4>>2]=y;g[b+36>>2]=ea(g[d+92>>2]);return}function qwa(a){a=a|0;var b=0;b=i;Fra(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function rwa(a){a=a|0;var b=0;b=i;Bra(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function swa(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=UJa(d,296,498888,47)|0;c[b>>2]=e;if(!e){i=d;return}PEi(e|0,0,292)|0;a[e+260>>0]=1;c[e+264>>2]=e+4;c[e+272>>2]=64;c[e+276>>2]=32;c[e+280>>2]=0;c[e+284>>2]=0;c[e+288>>2]=2048;c[e+292>>2]=0;i=d;return}function twa(a){a=a|0;var b=0;b=i;i=i+16|0;b1a(c[a>>2]|0);VJa(b,c[a>>2]|0);i=b;return}function uwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a>>2]|0;a=d+292|0;e=c[a>>2]|0;if(!e){c1a(d);f=c[a>>2]|0}else f=e;c[a>>2]=c[f>>2];a=d+280|0;c[a>>2]=(c[a>>2]|0)+1;a=d+284|0;c[a>>2]=(c[a>>2]|0)+-1;if(!f){g=0;i=b;return g|0}pqa(f);g=f;i=b;return g|0}function vwa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;if(!b){i=d;return}a=e+280|0;c[a>>2]=(c[a>>2]|0)+-1;a=e+292|0;c[b>>2]=c[a>>2];c[a>>2]=b;b=e+284|0;a=c[b>>2]|0;c[b>>2]=a+1;if((a|0)<((c[e+276>>2]|0)*50|0)){i=d;return}d1a(e);c[b>>2]=0;i=d;return}function wwa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;f=i;h=b[a+8>>1]|0;if(h<<16>>16==-1){j=c[a>>2]|0;k=ea(g[j>>2]);l=ea(k*ea(g[d>>2]));k=ea(g[j+4>>2]);m=ea(l+ea(k*ea(g[d+4>>2])));k=ea(g[j+8>>2]);l=ea(m+ea(k*ea(g[d+8>>2])));k=ea(g[j+16>>2]);m=ea(k*ea(g[e>>2]));k=ea(g[j+20>>2]);n=ea(m+ea(k*ea(g[e+4>>2])));k=ea(g[j+24>>2]);o=ea(l+ea(n+ea(k*ea(g[e+8>>2]))));i=f;return ea(o)}else{j=h&65535;h=(c[a>>2]|0)+128|0;k=ea(g[h+(j<<5)>>2]);n=ea(g[h+(j<<5)+4>>2]);l=ea(g[h+(j<<5)+8>>2]);m=ea(g[h+(j<<5)+16>>2]);p=ea(g[h+(j<<5)+20>>2]);q=ea(g[h+(j<<5)+24>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);t=ea(g[d+8>>2]);u=ea(g[e>>2]);v=ea(g[e+4>>2]);o=ea(ea(ea(ea(k*r)+ea(n*s))+ea(l*t))+ea(ea(ea(m*u)+ea(p*v))+ea(q*ea(g[e+8>>2]))));i=f;return ea(o)}return ea(0.0)}function xwa(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im;e=i;f=b[d+8>>1]|0;if(f<<16>>16==-1){h=c[d>>2]|0;g[a>>2]=ea(g[h>>2]);g[a+4>>2]=ea(g[h+4>>2]);g[a+8>>2]=ea(g[h+8>>2]);i=e;return}else{h=f&65535;f=(c[d>>2]|0)+128|0;j=ea(g[f+(h<<5)>>2]);k=ea(g[f+(h<<5)+4>>2]);l=ea(g[f+(h<<5)+8>>2]);g[a>>2]=j;g[a+4>>2]=k;g[a+8>>2]=l;i=e;return}}function ywa(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=ea(m);n=ea(n);o=o|0;var p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;o=i;i=i+64|0;p=o+32|0;q=o;r=b[a+8>>1]|0;if(r<<16>>16==-1){s=ea(ea(g[d>>2])*f);t=ea(ea(g[d+4>>2])*f);u=ea(ea(g[d+8>>2])*f);v=ea(ea(g[d+16>>2])*h);w=ea(ea(g[d+20>>2])*h);x=ea(ea(g[d+24>>2])*h);y=c[a+4>>2]|0;z=ea(g[y+48>>2]);A=ea(t*z);t=ea(u*z);g[e>>2]=ea(s*z);g[e+4>>2]=A;g[e+8>>2]=t;t=ea(v*ea(g[y>>2]));A=ea(v*ea(g[y+4>>2]));z=ea(v*ea(g[y+8>>2]));v=ea(w*ea(g[y+12>>2]));s=ea(w*ea(g[y+16>>2]));u=ea(t+v);v=ea(A+s);s=ea(z+ea(w*ea(g[y+20>>2])));w=ea(x*ea(g[y+24>>2]));z=ea(x*ea(g[y+28>>2]));A=ea(v+z);z=ea(s+ea(x*ea(g[y+32>>2])));g[e+16>>2]=ea(u+w);g[e+20>>2]=A;g[e+24>>2]=z}else{y=c[a>>2]|0;z=ea(ea(g[d>>2])*f);A=ea(ea(g[d+4>>2])*f);w=ea(ea(g[d+8>>2])*f);f=ea(ea(g[d+16>>2])*h);u=ea(ea(g[d+20>>2])*h);x=ea(ea(g[d+24>>2])*h);g[p>>2]=z;g[p+4>>2]=A;g[p+8>>2]=w;g[p+12>>2]=ea(0.0);g[p+16>>2]=f;g[p+20>>2]=u;g[p+24>>2]=x;g[p+28>>2]=ea(0.0);Bza(y,r&65535,p,e)}p=b[j+8>>1]|0;if(p<<16>>16==-1){x=ea(ea(g[k>>2])*m);u=ea(ea(g[k+4>>2])*m);f=ea(ea(g[k+8>>2])*m);w=ea(ea(g[k+16>>2])*n);A=ea(ea(g[k+20>>2])*n);z=ea(ea(g[k+24>>2])*n);r=c[j+4>>2]|0;h=ea(g[r+48>>2]);s=ea(x*h);x=ea(u*h);u=ea(f*h);g[l>>2]=s;g[l+4>>2]=x;g[l+8>>2]=u;h=ea(w*ea(g[r>>2]));f=ea(w*ea(g[r+4>>2]));v=ea(w*ea(g[r+8>>2]));w=ea(A*ea(g[r+12>>2]));t=ea(A*ea(g[r+16>>2]));B=ea(h+w);w=ea(f+t);t=ea(v+ea(A*ea(g[r+20>>2])));A=ea(z*ea(g[r+24>>2]));v=ea(z*ea(g[r+28>>2]));f=ea(B+A);A=ea(w+v);v=ea(t+ea(z*ea(g[r+32>>2])));g[l+16>>2]=f;g[l+20>>2]=A;g[l+24>>2]=v;C=s;D=x;E=u;F=f;G=A;H=v}else{r=c[j>>2]|0;v=ea(ea(g[k>>2])*m);A=ea(ea(g[k+4>>2])*m);f=ea(ea(g[k+8>>2])*m);m=ea(ea(g[k+16>>2])*n);u=ea(ea(g[k+20>>2])*n);x=ea(ea(g[k+24>>2])*n);g[q>>2]=v;g[q+4>>2]=A;g[q+8>>2]=f;g[q+12>>2]=ea(0.0);g[q+16>>2]=m;g[q+20>>2]=u;g[q+24>>2]=x;g[q+28>>2]=ea(0.0);Bza(r,p&65535,q,l);x=ea(g[l>>2]);u=ea(g[l+4>>2]);m=ea(g[l+8>>2]);f=ea(g[l+16>>2]);A=ea(g[l+20>>2]);C=x;D=u;E=m;F=f;G=A;H=ea(g[l+24>>2])}A=ea(g[d>>2]);f=ea(A*ea(g[e>>2]));A=ea(g[d+4>>2]);m=ea(f+ea(A*ea(g[e+4>>2])));A=ea(g[d+8>>2]);f=ea(m+ea(A*ea(g[e+8>>2])));A=ea(g[d+16>>2]);m=ea(A*ea(g[e+16>>2]));A=ea(g[d+20>>2]);u=ea(m+ea(A*ea(g[e+20>>2])));A=ea(g[d+24>>2]);m=ea(f+ea(u+ea(A*ea(g[e+24>>2]))));A=ea(ea(g[k>>2])*C);C=ea(A+ea(ea(g[k+4>>2])*D));D=ea(C+ea(ea(g[k+8>>2])*E));E=ea(ea(g[k+16>>2])*F);F=ea(E+ea(ea(g[k+20>>2])*G));G=ea(m+ea(D+ea(F+ea(ea(g[k+24>>2])*H))));i=o;return ea(G)}function zwa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=ea(r);s=ea(s);t=ea(t);u=ea(u);v=ea(v);w=ea(w);var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=Im,rc=Im,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=0,Uc=0,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=0;q=i;i=i+432|0;p=q+160|0;x=q+128|0;y=q;z=q+224|0;A=q+384|0;B=q+396|0;C=q+408|0;D=q+420|0;E=q+352|0;F=q+64|0;G=q+32|0;H=q+288|0;I=q+192|0;J=q+96|0;K=q+320|0;L=q+256|0;if(!(c[f+4096>>2]|0)){i=q;return}M=n+8|0;N=b[M>>1]|0;if(N<<16>>16==-1)O=(c[n+4>>2]|0)+52|0;else{P=c[n>>2]|0;O=P+128+((e[P+8>>1]|0)*80|0)+((N&65535)<<2)|0}Q=ea(g[O>>2]);O=o+8|0;N=b[O>>1]|0;if(N<<16>>16==-1)R=(c[o+4>>2]|0)+52|0;else{P=c[o>>2]|0;R=P+128+((e[P+8>>1]|0)*80|0)+((N&65535)<<2)|0}S=ea(g[R>>2]);T=Q>S?Q:S;S=ea(g[d+84>>2]);Q=ea(S*t);t=ea(g[d+88>>2]);U=ea(t*v);v=ea(S*u);u=ea(t*w);w=ea(g[d+92>>2]);t=ea(r*ea(.800000011));R=d+22|0;N=(b[R>>1]&24)!=0;P=h+4232|0;if(!(c[P>>2]|0)){i=q;return}V=N?128:96;W=A+4|0;X=A+8|0;Y=D+4|0;Z=D+8|0;_=B+4|0;$=B+8|0;aa=C+4|0;ba=C+8|0;ca=d+40|0;d=V<<1;fa=V+80|0;ga=j+12|0;ha=j+4|0;ia=j+8|0;ja=k+12|0;ka=k+4|0;la=k+8|0;ma=j+16|0;na=j+20|0;oa=j+24|0;pa=k+16|0;qa=k+20|0;ra=k+24|0;sa=G+4|0;ta=G+8|0;ua=G+12|0;va=G+16|0;wa=G+20|0;xa=G+24|0;ya=G+28|0;za=H+4|0;Aa=H+8|0;Ba=H+12|0;Ca=H+16|0;Da=H+20|0;Ea=H+24|0;Fa=H+28|0;Ga=E+16|0;Ha=E+20|0;Ia=E+24|0;Ja=F+16|0;Ka=F+20|0;La=F+24|0;Ma=E+4|0;Na=E+8|0;Oa=F+4|0;Pa=F+8|0;Qa=K+4|0;Ra=K+8|0;Sa=K+12|0;Ta=K+16|0;Ua=K+20|0;Va=K+24|0;Wa=K+28|0;Xa=L+4|0;Ya=L+8|0;Za=L+12|0;_a=L+16|0;$a=L+20|0;ab=L+24|0;bb=L+28|0;cb=V|4;db=V|8;eb=V|12;fb=V|16;gb=V|20;hb=V|24;ib=V|28;jb=V+32|0;kb=V+36|0;lb=V+40|0;mb=V+44|0;nb=V+48|0;ob=I+16|0;pb=I+20|0;qb=I+24|0;rb=V+52|0;sb=V+56|0;tb=V+60|0;ub=V+64|0;vb=J+16|0;wb=J+20|0;xb=J+24|0;yb=V+68|0;zb=V+72|0;Ab=V+76|0;Bb=V+96|0;Cb=I+4|0;Db=I+8|0;Eb=V+100|0;Fb=V+104|0;Gb=V+108|0;Hb=V+112|0;Ib=J+4|0;Jb=J+8|0;Kb=V+116|0;Lb=V+120|0;Mb=V+124|0;Nb=y+4|0;Ob=y+8|0;Pb=y+12|0;Qb=y+16|0;Rb=y+20|0;Sb=y+24|0;Tb=y+28|0;Ub=z+4|0;Vb=z+8|0;Wb=z+12|0;Xb=z+16|0;Yb=z+20|0;Zb=z+24|0;_b=z+28|0;$b=p+16|0;ac=p+20|0;bc=p+24|0;cc=x+16|0;dc=x+20|0;ec=x+24|0;fc=p+4|0;gc=p+8|0;hc=x+4|0;ic=x+8|0;jc=0;kc=0;lc=m;while(1){m=c[h+(kc<<2)+3840>>2]|0;if(!m){mc=jc;nc=lc}else{oc=h+(kc<<2)+3968|0;pc=e[h+((c[oc>>2]|0)*12|0)>>1]|0;S=ea(g[f+(pc<<6)+60>>2]);qc=ea(g[f+(pc<<6)+44>>2]);rc=ea(g[f+(pc<<6)+56>>2]);sc=lc+32|0;tc=(c[f+(pc<<6)+52>>2]&1|0)==0;a[lc+5>>0]=m;if(tc)uc=e[h+(kc*96|0)+784>>1]<<1&255;else uc=0;a[lc+6>>0]=uc;if(!N)if(!(uc<<24>>24))vc=6;else vc=(b[R>>1]&64)==0?5:1;else vc=3;a[lc>>0]=vc;g[lc+16>>2]=qc;g[lc+20>>2]=rc;g[lc+24>>2]=Q;g[lc+28>>2]=U;g[lc+8>>2]=v;g[lc+12>>2]=u;m=c[oc>>2]|0;if((m|0)==65535)wc=sc;else{pc=S>ea(0.0);xc=m;m=sc;while(1){sc=b[h+(xc*12|0)+2>>1]|0;yc=e[h+(xc*12|0)>>1]|0;if(!(sc<<16>>16))zc=m;else{Ac=sc&65535;if(pc){sc=0;Bc=m;while(1){Cc=sc+yc|0;Dc=f+(Cc<<6)|0;rc=ea(g[Dc>>2]);Ec=f+(Cc<<6)+4|0;qc=ea(g[Ec>>2]);Fc=f+(Cc<<6)+8|0;Gc=ea(g[Fc>>2]);Hc=ea(ea(g[f+(Cc<<6)+12>>2])-w);Ic=ea(g[f+(Cc<<6)+16>>2]);Jc=ea(Ic-ea(g[ma>>2]));Kc=ea(g[f+(Cc<<6)+20>>2]);Lc=ea(Kc-ea(g[na>>2]));Mc=ea(g[f+(Cc<<6)+24>>2]);Nc=ea(Mc-ea(g[oa>>2]));Oc=ea(Ic-ea(g[pa>>2]));Ic=ea(Kc-ea(g[qa>>2]));Kc=ea(Mc-ea(g[ra>>2]));Mc=ea(ea(Lc*Gc)-ea(Nc*qc));Pc=ea(ea(Nc*rc)-ea(Jc*Gc));Nc=ea(ea(Jc*qc)-ea(Lc*rc));Lc=ea(ea(Ic*Gc)-ea(Kc*qc));Jc=ea(ea(Kc*rc)-ea(Oc*Gc));Kc=ea(ea(Oc*qc)-ea(Ic*rc));g[y>>2]=rc;g[Nb>>2]=qc;g[Ob>>2]=Gc;g[Pb>>2]=ea(0.0);g[Qb>>2]=Mc;g[Rb>>2]=Pc;g[Sb>>2]=Nc;g[Tb>>2]=ea(0.0);Ic=ea(-qc);Oc=ea(-Gc);Qc=ea(-Lc);Rc=ea(-Jc);Sc=ea(-Kc);g[z>>2]=ea(-rc);g[Ub>>2]=Ic;g[Vb>>2]=Oc;g[Wb>>2]=ea(0.0);g[Xb>>2]=Qc;g[Yb>>2]=Rc;g[Zb>>2]=Sc;g[_b>>2]=ea(0.0);Sc=ea(ywa(n,y,p,Q,v,o,z,x,U,u,0));Tc=b[M>>1]|0;if(Tc<<16>>16==-1){Uc=c[n>>2]|0;Rc=ea(g[Uc>>2]);Qc=ea(g[Dc>>2]);Oc=ea(Rc*Qc);Rc=ea(g[Uc+4>>2]);Ic=ea(g[Ec>>2]);Vc=ea(Oc+ea(Rc*Ic));Rc=ea(g[Uc+8>>2]);Oc=ea(g[Fc>>2]);Wc=ea(Vc+ea(Rc*Oc));Rc=ea(Mc*ea(g[Uc+16>>2]));Vc=ea(Rc+ea(Pc*ea(g[Uc+20>>2])));Xc=ea(Wc+ea(Vc+ea(Nc*ea(g[Uc+24>>2]))));Yc=Qc;Zc=Ic;_c=Oc}else{Uc=Tc&65535;Tc=(c[n>>2]|0)+128|0;Oc=ea(g[Tc+(Uc<<5)>>2]);Ic=ea(g[Tc+(Uc<<5)+4>>2]);Qc=ea(g[Tc+(Uc<<5)+8>>2]);Vc=ea(g[Tc+(Uc<<5)+16>>2]);Wc=ea(g[Tc+(Uc<<5)+20>>2]);Rc=ea(g[Tc+(Uc<<5)+24>>2]);$c=ea(g[Dc>>2]);ad=ea(g[Ec>>2]);bd=ea(g[Fc>>2]);Xc=ea(ea(ea(ea(Mc*Vc)+ea(Pc*Wc))+ea(Nc*Rc))+ea(ea(ea(Oc*$c)+ea(Ic*ad))+ea(Qc*bd)));Yc=$c;Zc=ad;_c=bd}Fc=b[O>>1]|0;if(Fc<<16>>16==-1){Ec=c[o>>2]|0;bd=ea(ea(g[Ec>>2])*Yc);ad=ea(bd+ea(ea(g[Ec+4>>2])*Zc));bd=ea(ad+ea(ea(g[Ec+8>>2])*_c));ad=ea(Lc*ea(g[Ec+16>>2]));$c=ea(ad+ea(Jc*ea(g[Ec+20>>2])));cd=ea(bd+ea($c+ea(Kc*ea(g[Ec+24>>2]))))}else{Ec=Fc&65535;Fc=(c[o>>2]|0)+128|0;$c=ea(g[Fc+(Ec<<5)>>2]);bd=ea(g[Fc+(Ec<<5)+4>>2]);ad=ea(g[Fc+(Ec<<5)+8>>2]);Qc=ea(g[Fc+(Ec<<5)+16>>2]);Ic=ea(g[Fc+(Ec<<5)+20>>2]);cd=ea(ea(ea(ea(Lc*Qc)+ea(Jc*Ic))+ea(Kc*ea(g[Fc+(Ec<<5)+24>>2])))+ea(ea(ea($c*Yc)+ea(bd*Zc))+ea(ad*_c)))}ad=ea(Xc-cd);bd=ea(ea(1.0)/Sc);Ec=Sc!=ea(0.0);Sc=Ec?bd:ea(0.0);bd=ea(t*Hc);$c=ea((T>bd?T:bd)*Sc);bd=ea(-ad);Ec=ea(Hc*r)<bd&ad<s;ad=Ec?ea(0.0):$c;$c=ea(S*bd);bd=Ec?$c:ea(0.0);g[Bc>>2]=rc;g[Bc+4>>2]=qc;g[Bc+8>>2]=Gc;g[Bc+12>>2]=Sc;g[Bc+16>>2]=Mc;g[Bc+20>>2]=Pc;g[Bc+24>>2]=Nc;g[Bc+28>>2]=ea(0.0);g[Bc+32>>2]=Lc;g[Bc+36>>2]=Jc;g[Bc+40>>2]=Kc;g[Bc+44>>2]=ea(0.0);Kc=ea(g[$b>>2]);Jc=ea(g[ac>>2]);Lc=ea(g[bc>>2]);g[Bc+64>>2]=Kc;g[Bc+68>>2]=Jc;g[Bc+72>>2]=Lc;g[Bc+76>>2]=ea(0.0);Lc=ea(g[cc>>2]);Jc=ea(g[dc>>2]);Kc=ea(g[ec>>2]);g[Bc+80>>2]=Lc;g[Bc+84>>2]=Jc;g[Bc+88>>2]=Kc;g[Bc+92>>2]=ea(0.0);Kc=ea(g[p>>2]);Jc=ea(g[fc>>2]);Lc=ea(g[gc>>2]);g[Bc+96>>2]=Kc;g[Bc+100>>2]=Jc;g[Bc+104>>2]=Lc;g[Bc+108>>2]=ea(0.0);Lc=ea(g[x>>2]);Jc=ea(g[hc>>2]);Kc=ea(g[ic>>2]);g[Bc+112>>2]=Lc;g[Bc+116>>2]=Jc;g[Bc+120>>2]=Kc;g[Bc+124>>2]=ea(0.0);Kc=ea(g[f+(Cc<<6)+28>>2]);g[Bc+48>>2]=ad;g[Bc+52>>2]=bd;g[Bc+56>>2]=Kc;g[Bc+60>>2]=ea(0.0);sc=sc+1|0;if((sc|0)==(Ac|0))break;else Bc=Bc+V|0}}else{Bc=0;sc=m;while(1){Cc=Bc+yc|0;Kc=ea(g[f+(Cc<<6)>>2]);bd=ea(g[f+(Cc<<6)+4>>2]);ad=ea(g[f+(Cc<<6)+8>>2]);Jc=ea(ea(g[f+(Cc<<6)+12>>2])-w);Lc=ea(g[f+(Cc<<6)+16>>2]);Nc=ea(Lc-ea(g[ma>>2]));Pc=ea(g[f+(Cc<<6)+20>>2]);Mc=ea(Pc-ea(g[na>>2]));Sc=ea(g[f+(Cc<<6)+24>>2]);Gc=ea(Sc-ea(g[oa>>2]));qc=ea(Lc-ea(g[pa>>2]));Lc=ea(Pc-ea(g[qa>>2]));Pc=ea(Sc-ea(g[ra>>2]));Sc=ea(ea(Mc*ad)-ea(Gc*bd));rc=ea(ea(Gc*Kc)-ea(Nc*ad));Gc=ea(ea(Nc*bd)-ea(Mc*Kc));Mc=ea(ea(Lc*ad)-ea(Pc*bd));Nc=ea(ea(Pc*Kc)-ea(qc*ad));Pc=ea(ea(qc*bd)-ea(Lc*Kc));g[y>>2]=Kc;g[Nb>>2]=bd;g[Ob>>2]=ad;g[Pb>>2]=ea(0.0);g[Qb>>2]=Sc;g[Rb>>2]=rc;g[Sb>>2]=Gc;g[Tb>>2]=ea(0.0);Lc=ea(-bd);qc=ea(-ad);$c=ea(-Mc);Hc=ea(-Nc);Ic=ea(-Pc);g[z>>2]=ea(-Kc);g[Ub>>2]=Lc;g[Vb>>2]=qc;g[Wb>>2]=ea(0.0);g[Xb>>2]=$c;g[Yb>>2]=Hc;g[Zb>>2]=Ic;g[_b>>2]=ea(0.0);Ic=ea(ywa(n,y,p,Q,v,o,z,x,U,u,0));Hc=ea(ea(1.0)/Ic);Ec=Ic!=ea(0.0);Ic=Ec?Hc:ea(0.0);Hc=ea(t*Jc);Jc=ea((T>Hc?T:Hc)*Ic);g[sc>>2]=Kc;g[sc+4>>2]=bd;g[sc+8>>2]=ad;g[sc+12>>2]=Ic;g[sc+16>>2]=Sc;g[sc+20>>2]=rc;g[sc+24>>2]=Gc;g[sc+28>>2]=ea(0.0);g[sc+32>>2]=Mc;g[sc+36>>2]=Nc;g[sc+40>>2]=Pc;g[sc+44>>2]=ea(0.0);Pc=ea(g[$b>>2]);Nc=ea(g[ac>>2]);Mc=ea(g[bc>>2]);g[sc+64>>2]=Pc;g[sc+68>>2]=Nc;g[sc+72>>2]=Mc;g[sc+76>>2]=ea(0.0);Mc=ea(g[cc>>2]);Nc=ea(g[dc>>2]);Pc=ea(g[ec>>2]);g[sc+80>>2]=Mc;g[sc+84>>2]=Nc;g[sc+88>>2]=Pc;g[sc+92>>2]=ea(0.0);Pc=ea(g[p>>2]);Nc=ea(g[fc>>2]);Mc=ea(g[gc>>2]);g[sc+96>>2]=Pc;g[sc+100>>2]=Nc;g[sc+104>>2]=Mc;g[sc+108>>2]=ea(0.0);Mc=ea(g[x>>2]);Nc=ea(g[hc>>2]);Pc=ea(g[ic>>2]);g[sc+112>>2]=Mc;g[sc+116>>2]=Nc;g[sc+120>>2]=Pc;g[sc+124>>2]=ea(0.0);Pc=ea(g[f+(Cc<<6)+28>>2]);g[sc+48>>2]=Jc;g[sc+52>>2]=ea(0.0);g[sc+56>>2]=Pc;g[sc+60>>2]=ea(0.0);Bc=Bc+1|0;if((Bc|0)==(Ac|0))break;else sc=sc+V|0}}zc=m+(da(V,Ac)|0)|0}sc=b[h+(xc*12|0)+4>>1]|0;if(sc<<16>>16==-1){wc=zc;break}else{xc=sc&65535;m=zc}}}if(tc){m=e[h+((c[oc>>2]|0)*12|0)>>1]|0;g[A>>2]=ea(g[f+(m<<6)>>2]);g[W>>2]=ea(g[f+(m<<6)+4>>2]);g[X>>2]=ea(g[f+(m<<6)+8>>2]);m=b[M>>1]|0;if(m<<16>>16==-1){xc=c[n>>2]|0;dd=xc+8|0;ed=xc+4|0;fd=xc}else{xc=m&65535;m=(c[n>>2]|0)+128|0;dd=m+(xc<<5)+8|0;ed=m+(xc<<5)+4|0;fd=m+(xc<<5)|0}S=ea(g[fd>>2]);Pc=ea(g[ed>>2]);Jc=ea(g[dd>>2]);xc=b[O>>1]|0;if(xc<<16>>16==-1){m=c[o>>2]|0;gd=m+8|0;hd=m+4|0;id=m}else{m=xc&65535;xc=(c[o>>2]|0)+128|0;gd=xc+(m<<5)+8|0;hd=xc+(m<<5)+4|0;id=xc+(m<<5)|0}Nc=ea(g[id>>2]);Mc=ea(g[hd>>2]);Gc=ea(Pc-Mc);Mc=ea(Jc-ea(g[gd>>2]));g[D>>2]=ea(S-Nc);g[Y>>2]=Gc;g[Z>>2]=Mc;e1a(D,A,B,C);Mc=ea(g[B>>2]);Gc=ea(g[_>>2]);Nc=ea(g[$>>2]);S=ea(g[C>>2]);Jc=ea(g[aa>>2]);Pc=ea(g[ba>>2]);m=(c[ca>>2]|0)+(jc*96|0)|0;xc=h+(kc*96|0)+784|0;if(b[xc>>1]|0)if(l){pc=0;sc=wc;while(1){Bc=sc+d|0;c[sc+80>>2]=m;c[sc+fa>>2]=m;rc=ea(ea(g[h+(kc*96|0)+(pc*12|0)+816>>2])*ea(2.0));Sc=ea(ea(g[h+(kc*96|0)+(pc*12|0)+820>>2])*ea(2.0));Ic=ea(ea(g[h+(kc*96|0)+(pc*12|0)+824>>2])*ea(2.0));ad=ea(g[ga>>2]);bd=ea(ea(ad*ad)+ea(-.5));Kc=ea(g[j>>2]);Hc=ea(rc*Kc);$c=ea(g[ha>>2]);qc=ea(Hc+ea(Sc*$c));Hc=ea(g[ia>>2]);Lc=ea(qc+ea(Ic*Hc));qc=ea(ea(Kc*Lc)+ea(ea(rc*bd)+ea(ad*ea(ea(Ic*$c)-ea(Sc*Hc)))));Qc=ea(ea($c*Lc)+ea(ea(Sc*bd)+ea(ad*ea(ea(rc*Hc)-ea(Ic*Kc)))));Oc=ea(ea(ea(Ic*bd)+ea(ad*ea(ea(Sc*Kc)-ea(rc*$c))))+ea(Hc*Lc));Lc=ea(ea(g[h+(kc*96|0)+(pc*12|0)+840>>2])*ea(2.0));Hc=ea(ea(g[h+(kc*96|0)+(pc*12|0)+844>>2])*ea(2.0));$c=ea(ea(g[h+(kc*96|0)+(pc*12|0)+848>>2])*ea(2.0));rc=ea(g[ja>>2]);Kc=ea(ea(rc*rc)+ea(-.5));Sc=ea(g[k>>2]);ad=ea(Lc*Sc);bd=ea(g[ka>>2]);Ic=ea(ad+ea(Hc*bd));ad=ea(g[la>>2]);Rc=ea(Ic+ea($c*ad));Ic=ea(ea(Sc*Rc)+ea(ea(Lc*Kc)+ea(rc*ea(ea($c*bd)-ea(Hc*ad)))));Wc=ea(ea(bd*Rc)+ea(ea(Hc*Kc)+ea(rc*ea(ea(Lc*ad)-ea($c*Sc)))));Vc=ea(ea(ea($c*Kc)+ea(rc*ea(ea(Hc*Sc)-ea(Lc*bd))))+ea(ad*Rc));Rc=ea(qc+ea(g[ma>>2]));ad=ea(Qc+ea(g[na>>2]));bd=ea(Oc+ea(g[oa>>2]));Lc=ea(ea(g[pa>>2])+Ic);Sc=ea(Wc+ea(g[qa>>2]));Hc=ea(Rc-Lc);Lc=ea(ad-Sc);Sc=ea(bd-ea(Vc+ea(g[ra>>2])));bd=ea(g[$>>2]);ad=ea(Qc*bd);Rc=ea(g[_>>2]);rc=ea(ad-ea(Oc*Rc));ad=ea(g[B>>2]);Kc=ea(ea(Oc*ad)-ea(qc*bd));$c=ea(ea(qc*Rc)-ea(Qc*ad));jd=ea(ea(Wc*bd)-ea(Vc*Rc));kd=ea(ea(Vc*ad)-ea(Ic*bd));ld=ea(ea(Ic*Rc)-ea(Wc*ad));g[G>>2]=ad;g[sa>>2]=Rc;g[ta>>2]=bd;g[ua>>2]=ea(0.0);g[va>>2]=rc;g[wa>>2]=Kc;g[xa>>2]=$c;g[ya>>2]=ea(0.0);md=ea(-Rc);nd=ea(-bd);od=ea(-jd);pd=ea(-kd);qd=ea(-ld);g[H>>2]=ea(-ad);g[za>>2]=md;g[Aa>>2]=nd;g[Ba>>2]=ea(0.0);g[Ca>>2]=od;g[Da>>2]=pd;g[Ea>>2]=qd;g[Fa>>2]=ea(0.0);qd=ea(ywa(n,G,E,Q,v,o,H,F,U,u,0));pd=ea(ea(ea(1.0)/qd)*ea(.800000011));yc=!(qd>ea(0.0));qd=yc?ea(0.0):pd;yc=e[h+(kc<<2)+(pc<<1)+4100>>1]|0;pd=ea(ea(g[f+(yc<<6)+32>>2])*ad);ad=ea(pd+ea(ea(g[f+(yc<<6)+36>>2])*Rc));Rc=ea(ad+ea(ea(g[f+(yc<<6)+40>>2])*bd));g[sc>>2]=Mc;g[sc+4>>2]=Gc;g[sc+8>>2]=Nc;g[sc+12>>2]=ea(0.0);g[sc+16>>2]=rc;g[sc+20>>2]=Kc;g[sc+24>>2]=$c;g[sc+28>>2]=qd;qd=ea(Hc*ea(g[B>>2]));$c=ea(qd+ea(Lc*ea(g[_>>2])));qd=ea(ea($c+ea(Sc*ea(g[$>>2])))*r);g[sc+32>>2]=jd;g[sc+36>>2]=kd;g[sc+40>>2]=ld;g[sc+44>>2]=qd;qd=ea(g[Ga>>2]);ld=ea(g[Ha>>2]);kd=ea(g[Ia>>2]);g[sc+48>>2]=qd;g[sc+52>>2]=ld;g[sc+56>>2]=kd;g[sc+60>>2]=ea(0.0);kd=ea(g[Ja>>2]);ld=ea(g[Ka>>2]);qd=ea(g[La>>2]);g[sc+64>>2]=kd;g[sc+68>>2]=ld;g[sc+72>>2]=qd;g[sc+76>>2]=Rc;Rc=ea(g[E>>2]);qd=ea(g[Ma>>2]);ld=ea(g[Na>>2]);g[sc+96>>2]=Rc;g[sc+100>>2]=qd;g[sc+104>>2]=ld;g[sc+108>>2]=ea(0.0);ld=ea(g[F>>2]);qd=ea(g[Oa>>2]);Rc=ea(g[Pa>>2]);g[sc+112>>2]=ld;g[sc+116>>2]=qd;g[sc+120>>2]=Rc;g[sc+124>>2]=ea(0.0);Rc=ea(g[ba>>2]);qd=ea(Qc*Rc);ld=ea(g[aa>>2]);kd=ea(qd-ea(Oc*ld));qd=ea(g[C>>2]);jd=ea(ea(Oc*qd)-ea(qc*Rc));Oc=ea(ea(qc*ld)-ea(Qc*qd));Qc=ea(ea(Wc*Rc)-ea(Vc*ld));qc=ea(ea(Vc*qd)-ea(Ic*Rc));Vc=ea(ea(Ic*ld)-ea(Wc*qd));g[K>>2]=qd;g[Qa>>2]=ld;g[Ra>>2]=Rc;g[Sa>>2]=ea(0.0);g[Ta>>2]=kd;g[Ua>>2]=jd;g[Va>>2]=Oc;g[Wa>>2]=ea(0.0);Wc=ea(-ld);ld=ea(-Rc);Rc=ea(-Qc);Ic=ea(-qc);$c=ea(-Vc);g[L>>2]=ea(-qd);g[Xa>>2]=Wc;g[Ya>>2]=ld;g[Za>>2]=ea(0.0);g[_a>>2]=Rc;g[$a>>2]=Ic;g[ab>>2]=$c;g[bb>>2]=ea(0.0);$c=ea(ywa(n,K,I,Q,v,o,L,J,U,u,0));Ic=ea(ea(ea(1.0)/$c)*ea(.800000011));yc=!($c>ea(0.0));$c=yc?ea(0.0):Ic;yc=e[h+(kc<<2)+(pc<<1)+4100>>1]|0;Ic=ea(g[f+(yc<<6)+32>>2]);Rc=ea(Ic*ea(g[B>>2]));Ic=ea(g[f+(yc<<6)+36>>2]);ld=ea(Rc+ea(Ic*ea(g[_>>2])));Ic=ea(g[f+(yc<<6)+40>>2]);Rc=ea(ld+ea(Ic*ea(g[$>>2])));g[sc+V>>2]=S;g[sc+cb>>2]=Jc;g[sc+db>>2]=Pc;g[sc+eb>>2]=ea(0.0);g[sc+fb>>2]=kd;g[sc+gb>>2]=jd;g[sc+hb>>2]=Oc;g[sc+ib>>2]=$c;$c=ea(Hc*ea(g[C>>2]));Hc=ea($c+ea(Lc*ea(g[aa>>2])));Lc=ea(ea(Hc+ea(Sc*ea(g[ba>>2])))*r);g[sc+jb>>2]=Qc;g[sc+kb>>2]=qc;g[sc+lb>>2]=Vc;g[sc+mb>>2]=Lc;Lc=ea(g[ob>>2]);Vc=ea(g[pb>>2]);qc=ea(g[qb>>2]);g[sc+nb>>2]=Lc;g[sc+rb>>2]=Vc;g[sc+sb>>2]=qc;g[sc+tb>>2]=ea(0.0);qc=ea(g[vb>>2]);Vc=ea(g[wb>>2]);Lc=ea(g[xb>>2]);g[sc+ub>>2]=qc;g[sc+yb>>2]=Vc;g[sc+zb>>2]=Lc;g[sc+Ab>>2]=Rc;Rc=ea(g[I>>2]);Lc=ea(g[Cb>>2]);Vc=ea(g[Db>>2]);g[sc+Bb>>2]=Rc;g[sc+Eb>>2]=Lc;g[sc+Fb>>2]=Vc;g[sc+Gb>>2]=ea(0.0);Vc=ea(g[J>>2]);Lc=ea(g[Ib>>2]);Rc=ea(g[Jb>>2]);g[sc+Hb>>2]=Vc;g[sc+Kb>>2]=Lc;g[sc+Lb>>2]=Rc;g[sc+Mb>>2]=ea(0.0);pc=pc+1|0;if(pc>>>0>=(e[xc>>1]|0)>>>0){rd=Bc;break}else sc=Bc}}else{sc=0;pc=wc;while(1){tc=pc+d|0;c[pc+80>>2]=m;c[pc+fa>>2]=m;Rc=ea(ea(g[h+(kc*96|0)+(sc*12|0)+816>>2])*ea(2.0));Lc=ea(ea(g[h+(kc*96|0)+(sc*12|0)+820>>2])*ea(2.0));Vc=ea(ea(g[h+(kc*96|0)+(sc*12|0)+824>>2])*ea(2.0));qc=ea(g[ga>>2]);Qc=ea(ea(qc*qc)+ea(-.5));Sc=ea(g[j>>2]);Hc=ea(Rc*Sc);$c=ea(g[ha>>2]);Oc=ea(Hc+ea(Lc*$c));Hc=ea(g[ia>>2]);jd=ea(Oc+ea(Vc*Hc));Oc=ea(ea(Sc*jd)+ea(ea(Rc*Qc)+ea(qc*ea(ea(Vc*$c)-ea(Lc*Hc)))));kd=ea(ea($c*jd)+ea(ea(Lc*Qc)+ea(qc*ea(ea(Rc*Hc)-ea(Vc*Sc)))));Ic=ea(ea(ea(Vc*Qc)+ea(qc*ea(ea(Lc*Sc)-ea(Rc*$c))))+ea(Hc*jd));jd=ea(ea(g[h+(kc*96|0)+(sc*12|0)+840>>2])*ea(2.0));Hc=ea(ea(g[h+(kc*96|0)+(sc*12|0)+844>>2])*ea(2.0));$c=ea(ea(g[h+(kc*96|0)+(sc*12|0)+848>>2])*ea(2.0));Rc=ea(g[ja>>2]);Sc=ea(ea(Rc*Rc)+ea(-.5));Lc=ea(g[k>>2]);qc=ea(jd*Lc);Qc=ea(g[ka>>2]);Vc=ea(qc+ea(Hc*Qc));qc=ea(g[la>>2]);ld=ea(Vc+ea($c*qc));Vc=ea(ea(Lc*ld)+ea(ea(jd*Sc)+ea(Rc*ea(ea($c*Qc)-ea(Hc*qc)))));Wc=ea(ea(Qc*ld)+ea(ea(Hc*Sc)+ea(Rc*ea(ea(jd*qc)-ea($c*Lc)))));qd=ea(ea(ea($c*Sc)+ea(Rc*ea(ea(Hc*Lc)-ea(jd*Qc))))+ea(qc*ld));ld=ea(Oc+ea(g[ma>>2]));qc=ea(kd+ea(g[na>>2]));Qc=ea(Ic+ea(g[oa>>2]));jd=ea(ea(g[pa>>2])+Vc);Lc=ea(Wc+ea(g[qa>>2]));Hc=ea(ld-jd);jd=ea(qc-Lc);Lc=ea(Qc-ea(qd+ea(g[ra>>2])));Qc=ea(g[$>>2]);qc=ea(kd*Qc);ld=ea(g[_>>2]);Rc=ea(qc-ea(Ic*ld));qc=ea(g[B>>2]);Sc=ea(ea(Ic*qc)-ea(Oc*Qc));$c=ea(ea(Oc*ld)-ea(kd*qc));Kc=ea(ea(Wc*Qc)-ea(qd*ld));rc=ea(ea(qd*qc)-ea(Vc*Qc));bd=ea(ea(Vc*ld)-ea(Wc*qc));g[G>>2]=qc;g[sa>>2]=ld;g[ta>>2]=Qc;g[ua>>2]=ea(0.0);g[va>>2]=Rc;g[wa>>2]=Sc;g[xa>>2]=$c;g[ya>>2]=ea(0.0);ad=ea(-ld);pd=ea(-Qc);od=ea(-Kc);nd=ea(-rc);md=ea(-bd);g[H>>2]=ea(-qc);g[za>>2]=ad;g[Aa>>2]=pd;g[Ba>>2]=ea(0.0);g[Ca>>2]=od;g[Da>>2]=nd;g[Ea>>2]=md;g[Fa>>2]=ea(0.0);md=ea(ywa(n,G,E,Q,v,o,H,F,U,u,0));nd=ea(ea(ea(1.0)/md)*ea(.800000011));Bc=!(md>ea(0.0));md=Bc?ea(0.0):nd;Bc=e[h+((c[oc>>2]|0)*12|0)>>1]|0;nd=ea(ea(g[f+(Bc<<6)+32>>2])*qc);qc=ea(nd+ea(ea(g[f+(Bc<<6)+36>>2])*ld));ld=ea(qc+ea(ea(g[f+(Bc<<6)+40>>2])*Qc));g[pc>>2]=Mc;g[pc+4>>2]=Gc;g[pc+8>>2]=Nc;g[pc+12>>2]=ea(0.0);g[pc+16>>2]=Rc;g[pc+20>>2]=Sc;g[pc+24>>2]=$c;g[pc+28>>2]=md;md=ea(Hc*ea(g[B>>2]));$c=ea(md+ea(jd*ea(g[_>>2])));md=ea(ea($c+ea(Lc*ea(g[$>>2])))*r);g[pc+32>>2]=Kc;g[pc+36>>2]=rc;g[pc+40>>2]=bd;g[pc+44>>2]=md;md=ea(g[Ga>>2]);bd=ea(g[Ha>>2]);rc=ea(g[Ia>>2]);g[pc+48>>2]=md;g[pc+52>>2]=bd;g[pc+56>>2]=rc;g[pc+60>>2]=ea(0.0);rc=ea(g[Ja>>2]);bd=ea(g[Ka>>2]);md=ea(g[La>>2]);g[pc+64>>2]=rc;g[pc+68>>2]=bd;g[pc+72>>2]=md;g[pc+76>>2]=ld;ld=ea(g[E>>2]);md=ea(g[Ma>>2]);bd=ea(g[Na>>2]);g[pc+96>>2]=ld;g[pc+100>>2]=md;g[pc+104>>2]=bd;g[pc+108>>2]=ea(0.0);bd=ea(g[F>>2]);md=ea(g[Oa>>2]);ld=ea(g[Pa>>2]);g[pc+112>>2]=bd;g[pc+116>>2]=md;g[pc+120>>2]=ld;g[pc+124>>2]=ea(0.0);ld=ea(g[ba>>2]);md=ea(kd*ld);bd=ea(g[aa>>2]);rc=ea(md-ea(Ic*bd));md=ea(g[C>>2]);Kc=ea(ea(Ic*md)-ea(Oc*ld));Ic=ea(ea(Oc*bd)-ea(kd*md));kd=ea(ea(Wc*ld)-ea(qd*bd));Oc=ea(ea(qd*md)-ea(Vc*ld));qd=ea(ea(Vc*bd)-ea(Wc*md));g[K>>2]=md;g[Qa>>2]=bd;g[Ra>>2]=ld;g[Sa>>2]=ea(0.0);g[Ta>>2]=rc;g[Ua>>2]=Kc;g[Va>>2]=Ic;g[Wa>>2]=ea(0.0);Wc=ea(-bd);bd=ea(-ld);ld=ea(-kd);Vc=ea(-Oc);$c=ea(-qd);g[L>>2]=ea(-md);g[Xa>>2]=Wc;g[Ya>>2]=bd;g[Za>>2]=ea(0.0);g[_a>>2]=ld;g[$a>>2]=Vc;g[ab>>2]=$c;g[bb>>2]=ea(0.0);$c=ea(ywa(n,K,I,Q,v,o,L,J,U,u,0));Vc=ea(ea(ea(1.0)/$c)*ea(.800000011));Bc=!($c>ea(0.0));$c=Bc?ea(0.0):Vc;Bc=e[h+((c[oc>>2]|0)*12|0)>>1]|0;Vc=ea(g[f+(Bc<<6)+32>>2]);ld=ea(Vc*ea(g[B>>2]));Vc=ea(g[f+(Bc<<6)+36>>2]);bd=ea(ld+ea(Vc*ea(g[_>>2])));Vc=ea(g[f+(Bc<<6)+40>>2]);ld=ea(bd+ea(Vc*ea(g[$>>2])));g[pc+V>>2]=S;g[pc+cb>>2]=Jc;g[pc+db>>2]=Pc;g[pc+eb>>2]=ea(0.0);g[pc+fb>>2]=rc;g[pc+gb>>2]=Kc;g[pc+hb>>2]=Ic;g[pc+ib>>2]=$c;$c=ea(Hc*ea(g[C>>2]));Hc=ea($c+ea(jd*ea(g[aa>>2])));jd=ea(ea(Hc+ea(Lc*ea(g[ba>>2])))*r);g[pc+jb>>2]=kd;g[pc+kb>>2]=Oc;g[pc+lb>>2]=qd;g[pc+mb>>2]=jd;jd=ea(g[ob>>2]);qd=ea(g[pb>>2]);Oc=ea(g[qb>>2]);g[pc+nb>>2]=jd;g[pc+rb>>2]=qd;g[pc+sb>>2]=Oc;g[pc+tb>>2]=ea(0.0);Oc=ea(g[vb>>2]);qd=ea(g[wb>>2]);jd=ea(g[xb>>2]);g[pc+ub>>2]=Oc;g[pc+yb>>2]=qd;g[pc+zb>>2]=jd;g[pc+Ab>>2]=ld;ld=ea(g[I>>2]);jd=ea(g[Cb>>2]);qd=ea(g[Db>>2]);g[pc+Bb>>2]=ld;g[pc+Eb>>2]=jd;g[pc+Fb>>2]=qd;g[pc+Gb>>2]=ea(0.0);qd=ea(g[J>>2]);jd=ea(g[Ib>>2]);ld=ea(g[Jb>>2]);g[pc+Hb>>2]=qd;g[pc+Kb>>2]=jd;g[pc+Lb>>2]=ld;g[pc+Mb>>2]=ea(0.0);sc=sc+1|0;if(sc>>>0>=(e[xc>>1]|0)>>>0){rd=tc;break}else pc=tc}}else rd=wc}else rd=wc;mc=jc+1|0;nc=rd}kc=kc+1|0;if(kc>>>0>=(c[P>>2]|0)>>>0)break;else{jc=mc;lc=nc}}i=q;return}function Awa(f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);p=ea(p);q=q|0;r=r|0;s=s|0;t=ea(t);u=ea(u);v=ea(v);w=ea(w);var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=0,V=Im,W=Im,X=0,Y=0,Z=0,_=Im,$=Im,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=0,lb=0,mb=0,nb=Im,ob=Im,pb=Im,qb=0,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=Im;m=i;i=i+400|0;x=m+316|0;y=m+340|0;z=m+328|0;A=m+224|0;B=m+160|0;C=m;D=m+96|0;E=m+304|0;F=m+352|0;G=m+376|0;H=m+280|0;I=m+292|0;J=m+364|0;K=m+256|0;L=m+64|0;M=m+32|0;N=m+192|0;O=m+128|0;P=b[q+8>>1]|0;if(P<<16>>16==-1)Q=(c[q+4>>2]|0)+52|0;else{R=c[q>>2]|0;Q=R+128+((e[R+8>>1]|0)*80|0)+((P&65535)<<2)|0}S=ea(g[Q>>2]);if((b[r+8>>1]|0)==-1)U=(c[r+4>>2]|0)+52|0;else{Q=c[r>>2]|0;U=Q+128+((e[Q+8>>1]|0)*80|0)+((P&65535)<<2)|0}V=ea(g[U>>2]);W=ea((S>V?S:V)/o);V=ea(g[f+92>>2]);U=e[f+22>>1]|0;P=(U&24|0)!=0;Q=c[j+1796>>2]|0;R=U>>>6;U=P?112:80;X=P?128:96;if(P){Y=3;Z=12}else{Y=(R<<2&4^5)&255;Z=(R&1^11)&255}R=f+84|0;S=ea(g[R>>2]);_=ea(S*t);P=f+88|0;t=ea(g[P>>2]);$=ea(t*v);v=ea(S*u);u=ea(t*w);f=(Q|0)==0;if(f){aa=0;i=m;return aa|0}ba=x+4|0;ca=x+8|0;fa=k+16|0;ga=k+20|0;ha=k+24|0;ia=l+16|0;ja=l+20|0;ka=l+24|0;la=y+4|0;ma=y+8|0;na=z+4|0;oa=z+8|0;pa=C+4|0;qa=C+8|0;ra=C+12|0;sa=C+16|0;ta=C+20|0;ua=C+24|0;va=C+28|0;wa=D+4|0;xa=D+8|0;ya=D+12|0;za=D+16|0;Aa=D+20|0;Ba=D+24|0;Ca=D+28|0;Da=A+16|0;Ea=A+20|0;Fa=A+24|0;Ga=A+4|0;Ha=A+8|0;Ia=B+16|0;Ja=B+20|0;Ka=B+24|0;La=B+4|0;Ma=B+8|0;Na=0;Oa=n;while(1){Pa=c[j+(Na<<2)+1408>>2]|0;if(Pa){Qa=j+(Na<<2)+1536|0;Ra=e[j+((c[Qa>>2]|0)*12|0)>>1]|0;w=ea(g[j+(Na*20|0)+768>>2]);t=ea(g[j+(Na*20|0)+772>>2]);S=ea(g[j+(Na*20|0)+776>>2]);g[x>>2]=w;g[ba>>2]=t;g[ca>>2]=S;Sa=ea(g[h+(Ra<<6)+60>>2]);Ra=Oa+48|0;a[Oa+1>>0]=Pa;a[Oa>>0]=Y;Pa=Oa+4|0;g[Pa>>2]=Sa;g[Oa+8>>2]=_;g[Oa+12>>2]=$;g[Oa+28>>2]=v;g[Oa+32>>2]=u;g[Oa+16>>2]=w;g[Oa+20>>2]=t;g[Oa+24>>2]=S;Ta=c[Qa>>2]|0;if((Ta|0)==65535)Ua=Ra;else{Qa=Ta;Ta=Ra;while(1){Ra=b[j+(Qa*12|0)+2>>1]|0;Va=e[j+(Qa*12|0)>>1]|0;if(!(Ra<<16>>16))Wa=Ta;else{Xa=Ra&65535;Ra=da(U,Xa)|0;Ya=0;Za=Ta;while(1){_a=Ya+Va|0;Sa=ea(g[h+(_a<<6)+12>>2]);$a=ea(g[h+(_a<<6)+16>>2]);ab=ea($a-ea(g[fa>>2]));bb=ea(g[h+(_a<<6)+20>>2]);cb=ea(bb-ea(g[ga>>2]));db=ea(g[h+(_a<<6)+24>>2]);eb=ea(db-ea(g[ha>>2]));fb=ea($a-ea(g[ia>>2]));$a=ea(bb-ea(g[ja>>2]));bb=ea(db-ea(g[ka>>2]));db=ea(g[h+(_a<<6)+32>>2]);gb=ea(g[h+(_a<<6)+36>>2]);hb=ea(g[h+(_a<<6)+40>>2]);ib=ea(g[h+(_a<<6)+28>>2]);jb=ea(Sa-V);Sa=ea(ea(ea(w*db)+ea(t*gb))+ea(S*hb));_a=Za+32|0;g[_a>>2]=W>jb?W:jb;kb=Za+36|0;g[kb>>2]=Sa;g[Za+40>>2]=ib;g[Za+44>>2]=ea(0.0);ib=ea(g[ca>>2]);Sa=ea(cb*ib);jb=ea(g[ba>>2]);hb=ea(Sa-ea(eb*jb));Sa=ea(g[x>>2]);gb=ea(ea(eb*Sa)-ea(ab*ib));eb=ea(ea(ab*jb)-ea(cb*Sa));g[y>>2]=hb;g[la>>2]=gb;g[ma>>2]=eb;cb=ea(ea($a*ib)-ea(bb*jb));ab=ea(ea(bb*Sa)-ea(fb*ib));bb=ea(ea(fb*jb)-ea($a*Sa));g[z>>2]=cb;g[na>>2]=ab;g[oa>>2]=bb;g[C>>2]=Sa;g[pa>>2]=jb;g[qa>>2]=ib;g[ra>>2]=ea(0.0);g[sa>>2]=hb;g[ta>>2]=gb;g[ua>>2]=eb;g[va>>2]=ea(0.0);eb=ea(-jb);jb=ea(-ib);ib=ea(-cb);cb=ea(-ab);ab=ea(-bb);g[D>>2]=ea(-Sa);g[wa>>2]=eb;g[xa>>2]=jb;g[ya>>2]=ea(0.0);g[za>>2]=ib;g[Aa>>2]=cb;g[Ba>>2]=ab;g[Ca>>2]=ea(0.0);ab=ea(ywa(q,C,A,_,v,r,D,B,$,u,0));cb=ea(wwa(q,x,y));ib=ea(cb-ea(wwa(r,x,z)));cb=ea(g[y>>2]);jb=ea(g[la>>2]);eb=ea(g[ma>>2]);g[Za>>2]=cb;g[Za+4>>2]=jb;g[Za+8>>2]=eb;lb=Za+12|0;g[lb>>2]=ea(0.0);eb=ea(g[z>>2]);jb=ea(g[na>>2]);cb=ea(g[oa>>2]);g[Za+16>>2]=eb;g[Za+20>>2]=jb;g[Za+24>>2]=cb;mb=Za+28|0;g[mb>>2]=ea(0.0);cb=ea(g[Pa>>2]);if(ab!=ea(0.0))nb=ea(ea(1.0)/ab);else nb=ea(0.0);ab=ea(ea(ea(g[_a>>2])*ea(nb*ea(.800000011)))*o);if(cb>ea(0.0)&ib<p){ob=ea(0.0);pb=ea(-ea(ib*cb))}else{ob=ab;pb=ea(0.0)}g[mb>>2]=nb;g[_a>>2]=ob;g[kb>>2]=pb;g[lb>>2]=ea(0.0);ab=ea(g[Da>>2]);cb=ea(g[Ea>>2]);ib=ea(g[Fa>>2]);g[Za+80>>2]=ea(g[A>>2]);g[Za+84>>2]=ea(g[Ga>>2]);g[Za+88>>2]=ea(g[Ha>>2]);g[Za+92>>2]=ea(0.0);g[Za+48>>2]=ab;g[Za+52>>2]=cb;g[Za+56>>2]=ib;g[Za+60>>2]=ea(0.0);ib=ea(g[Ia>>2]);cb=ea(g[Ja>>2]);ab=ea(g[Ka>>2]);g[Za+96>>2]=ea(g[B>>2]);g[Za+100>>2]=ea(g[La>>2]);g[Za+104>>2]=ea(g[Ma>>2]);g[Za+108>>2]=ea(0.0);g[Za+64>>2]=ib;g[Za+68>>2]=cb;g[Za+72>>2]=ab;g[Za+76>>2]=ea(0.0);Ya=Ya+1|0;if((Ya|0)==(Xa|0))break;else Za=Za+U|0}Wa=Ta+Ra|0}Za=b[j+(Qa*12|0)+4>>1]|0;if(Za<<16>>16==-1){Ua=Wa;break}else{Qa=Za&65535;Ta=Wa}}}}else Ua=Oa;Na=Na+1|0;if((Na|0)==(Q|0))break;else Oa=Ua}if(f){aa=0;i=m;return aa|0}f=E+4|0;Oa=E+8|0;Na=F+4|0;Wa=F+8|0;Ma=G+4|0;La=G+8|0;B=H+4|0;Ka=I+4|0;Ja=H+8|0;Ia=I+8|0;Ha=J+4|0;Ga=J+8|0;A=K+4|0;Fa=K+8|0;Ea=K+12|0;Da=K+16|0;oa=K+20|0;na=k+16|0;z=k+20|0;ma=k+24|0;k=l+16|0;la=l+20|0;y=l+24|0;l=(s|0)==0;x=N+4|0;D=N+8|0;C=N+12|0;Ca=N+16|0;Ba=N+20|0;Aa=N+24|0;za=N+28|0;ya=O+4|0;xa=O+8|0;wa=O+12|0;va=O+16|0;ua=O+20|0;ta=O+24|0;sa=O+28|0;ra=L+16|0;qa=L+20|0;pa=L+24|0;ba=L+4|0;ca=L+8|0;ka=M+16|0;ja=M+20|0;ia=M+24|0;ha=M+4|0;ga=M+8|0;fa=da(X,s)|0;Y=0;Ta=0;Qa=Ua;Ua=n;while(1){n=j+(Ta<<2)+1408|0;Pa=c[n>>2]|0;if(Pa){b[Ua+2>>1]=Qa-Ua;Za=Ua+((da(d[Ua+1>>0]|0,U)|0)+48)|0;pb=ea(g[j+(Ta*20|0)+768>>2]);ob=ea(g[j+(Ta*20|0)+772>>2]);nb=ea(g[j+(Ta*20|0)+776>>2]);Xa=j+(Ta<<2)+1536|0;Ya=e[j+((c[Xa>>2]|0)*12|0)>>1]|0;p=ea(g[h+(Ya<<6)+44>>2]);Va=(c[h+(Ya<<6)+52>>2]&1|0)==0;a[Qa+1>>0]=Pa;if(Va)qb=b[j+(Ta*20|0)+784>>1]&255;else qb=0;a[Qa+2>>0]=qb;Pa=Qa+((c[n>>2]<<2)+44&-16)|0;o=ea(-nb);g[E>>2]=ea(0.0);g[f>>2]=o;g[Oa>>2]=ob;g[F>>2]=ea(-ob);g[Na>>2]=pb;g[Wa>>2]=ea(0.0);n=~~pb;Ya=ea(((n|0)>-1?n:0-n|0)|0)<ea(.707106769);n=Ya?E:F;g[G>>2]=ea(g[n>>2]);g[Ma>>2]=ea(g[n+4>>2]);g[La>>2]=ea(g[n+8>>2]);xwa(H,q);xwa(I,r);o=ea(g[H>>2]);W=ea(o-ea(g[I>>2]));o=ea(g[B>>2]);V=ea(o-ea(g[Ka>>2]));o=ea(g[Ja>>2]);S=ea(o-ea(g[Ia>>2]));o=ea(ea(ea(pb*W)+ea(ob*V))+ea(nb*S));t=ea(W-ea(pb*o));W=ea(V-ea(ob*o));V=ea(S-ea(nb*o));g[J>>2]=t;g[Ha>>2]=W;g[Ga>>2]=V;n=ea(ea(ea(t*t)+ea(W*W))+ea(V*V))>ea(9.99999974e-06);Ya=n?J:G;V=ea(g[Ya>>2]);W=ea(V*V);t=ea(g[Ya+4>>2]);o=ea(W+ea(t*t));W=ea(g[Ya+8>>2]);S=ea(o+ea(W*W));if(S>ea(0.0)){o=ea(ea(1.0)/ea(T(ea(S))));rb=ea(t*o);sb=ea(W*o);tb=ea(V*o)}else{rb=ea(0.0);sb=ea(0.0);tb=ea(0.0)}o=ea(ea(nb*rb)-ea(ob*sb));V=ea(ea(pb*sb)-ea(nb*tb));nb=ea(ea(ob*tb)-ea(pb*rb));g[K>>2]=tb;g[A>>2]=rb;g[Fa>>2]=sb;g[Ea>>2]=o;g[Da>>2]=V;g[oa>>2]=nb;if(Va){g[Qa+4>>2]=p;g[Qa+8>>2]=ea(g[R>>2]);g[Qa+12>>2]=ea(g[P>>2]);g[Qa+16>>2]=v;g[Qa+20>>2]=u;a[Qa>>0]=Z;Va=c[Xa>>2]|0;if((Va|0)==65535){ub=1;vb=Pa;wb=Za}else{Xa=0;Ya=Va;Va=Pa;n=0;while(1){lb=j+(Ya*12|0)+2|0;kb=b[lb>>1]|0;_a=e[j+(Ya*12|0)>>1]|0;if(kb<<16>>16==0|l){xb=kb;yb=Xa;zb=Va}else{mb=kb&65535;kb=Xa;Ab=0;Bb=Va;while(1){Cb=Ab+n|0;Db=Ab+_a|0;p=ea(g[h+(Db<<6)+16>>2]);nb=ea(p-ea(g[na>>2]));V=ea(g[h+(Db<<6)+20>>2]);o=ea(V-ea(g[z>>2]));pb=ea(g[h+(Db<<6)+24>>2]);ob=ea(pb-ea(g[ma>>2]));W=ea(p-ea(g[k>>2]));p=ea(V-ea(g[la>>2]));V=ea(pb-ea(g[y>>2]));Eb=kb;Db=0;Fb=Bb;while(1){c[Fb+80>>2]=Cb;pb=ea(g[K+(Eb*12|0)>>2]);t=ea(g[K+(Eb*12|0)+4>>2]);S=ea(g[K+(Eb*12|0)+8>>2]);Eb=1-Eb|0;w=ea(ea(o*S)-ea(ob*t));ab=ea(ea(ob*pb)-ea(nb*S));cb=ea(ea(nb*t)-ea(o*pb));ib=ea(ea(p*S)-ea(V*t));jb=ea(ea(V*pb)-ea(W*S));eb=ea(ea(W*t)-ea(p*pb));g[N>>2]=pb;g[x>>2]=t;g[D>>2]=S;g[C>>2]=ea(0.0);g[Ca>>2]=w;g[Ba>>2]=ab;g[Aa>>2]=cb;g[za>>2]=ea(0.0);Sa=ea(-t);bb=ea(-S);gb=ea(-ib);hb=ea(-jb);$a=ea(-eb);g[O>>2]=ea(-pb);g[ya>>2]=Sa;g[xa>>2]=bb;g[wa>>2]=ea(0.0);g[va>>2]=gb;g[ua>>2]=hb;g[ta>>2]=$a;g[sa>>2]=ea(0.0);$a=ea(ywa(q,N,L,_,v,r,O,M,$,u,0));if($a>ea(0.0))Gb=ea(ea(1.0)/$a);else Gb=ea(0.0);g[Fb+28>>2]=Gb;g[Fb+16>>2]=w;g[Fb+20>>2]=ab;g[Fb+24>>2]=cb;g[Fb+32>>2]=ib;g[Fb+36>>2]=jb;g[Fb+40>>2]=eb;g[Fb>>2]=pb;g[Fb+4>>2]=t;g[Fb+8>>2]=S;g[Fb+12>>2]=ea(0.0);S=ea(g[ra>>2]);t=ea(g[qa>>2]);pb=ea(g[pa>>2]);g[Fb+96>>2]=ea(g[L>>2]);g[Fb+100>>2]=ea(g[ba>>2]);g[Fb+104>>2]=ea(g[ca>>2]);g[Fb+108>>2]=ea(0.0);g[Fb+48>>2]=S;g[Fb+52>>2]=t;g[Fb+56>>2]=pb;g[Fb+60>>2]=ea(0.0);pb=ea(g[ka>>2]);t=ea(g[ja>>2]);S=ea(g[ia>>2]);g[Fb+112>>2]=ea(g[M>>2]);g[Fb+116>>2]=ea(g[ha>>2]);g[Fb+120>>2]=ea(g[ga>>2]);g[Fb+124>>2]=ea(0.0);g[Fb+64>>2]=pb;g[Fb+68>>2]=t;g[Fb+72>>2]=S;g[Fb+76>>2]=ea(0.0);Db=Db+1|0;if((Db|0)==(s|0))break;else Fb=Fb+X|0}Bb=Bb+fa|0;Ab=Ab+1|0;if((Ab|0)==(mb|0))break;else kb=Eb}xb=b[lb>>1]|0;yb=Eb;zb=Bb}kb=b[j+(Ya*12|0)+4>>1]|0;if(kb<<16>>16==-1){ub=1;vb=zb;wb=Za;break}else{Xa=yb;Ya=kb&65535;Va=zb;n=(xb&65535)+n|0}}}}else{ub=Y;vb=Pa;wb=Za}}else{ub=Y;vb=Qa;wb=Ua}Ta=Ta+1|0;if((Ta|0)==(Q|0)){aa=ub;break}else{Y=ub;Qa=vb;Ua=wb}}i=m;return aa|0}function Bwa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=ea(r);s=ea(s);t=ea(t);u=ea(u);v=ea(v);w=ea(w);var x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=Im,Ua=Im,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=Im,vb=0,wb=0,xb=0,yb=0,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=0,fc=Im,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=0;l=i;i=i+64|0;x=l+48|0;y=l+32|0;z=l+16|0;A=l;if(!(c[f+4096>>2]|0)){i=l;return}B=d+22|0;C=(e[B>>1]|0)>>>8&1;D=ea(g[d+84>>2]);E=ea(g[d+88>>2]);F=ea(D*t);t=ea(E*v);v=ea(D*u);u=ea(E*w);w=ea(g[d+92>>2]);G=ea(g[p+52>>2]);H=ea(g[q+52>>2]);I=G>H?G:H;H=ea(g[j>>2]);G=ea(g[j+4>>2]);J=ea(g[j+8>>2]);K=ea(g[j+12>>2]);L=ea(g[j+16>>2]);M=ea(g[j+20>>2]);N=ea(g[j+24>>2]);O=ea(g[k>>2]);P=ea(g[k+4>>2]);Q=ea(g[k+8>>2]);R=ea(g[k+12>>2]);U=ea(g[k+16>>2]);V=ea(g[k+20>>2]);W=ea(g[k+24>>2]);X=ea(g[n>>2]);Y=ea(g[n+4>>2]);Z=ea(g[n+8>>2]);_=ea(g[o>>2]);$=ea(g[o+4>>2]);aa=ea(g[o+8>>2]);ba=ea(g[n+16>>2]);ca=ea(g[n+20>>2]);fa=ea(g[n+24>>2]);ga=ea(g[o+16>>2]);ha=ea(g[o+20>>2]);ia=ea(g[o+24>>2]);ja=ea(g[p+48>>2]);ka=ea(g[q+48>>2]);la=ea(g[p>>2]);ma=ea(g[p+4>>2]);na=ea(g[p+8>>2]);oa=ea(g[p+12>>2]);pa=ea(g[p+16>>2]);qa=ea(g[p+20>>2]);ra=ea(g[p+24>>2]);sa=ea(g[p+28>>2]);ta=ea(g[p+32>>2]);ua=ea(g[q>>2]);va=ea(g[q+4>>2]);wa=ea(g[q+8>>2]);xa=ea(g[q+12>>2]);ya=ea(g[q+16>>2]);za=ea(g[q+20>>2]);Aa=ea(g[q+24>>2]);Ba=ea(g[q+28>>2]);Ca=ea(g[q+32>>2]);Da=ea(r*ea(.800000011));q=(b[B>>1]&24)!=0;Ea=ea(F*ja);ja=ea(t*ka);ka=ea(-ja);t=ea(v*la);la=ea(v*ma);ma=ea(v*na);na=ea(v*oa);oa=ea(v*pa);pa=ea(v*qa);qa=ea(v*ra);ra=ea(v*sa);sa=ea(v*ta);ta=ea(u*ua);ua=ea(u*va);va=ea(u*wa);wa=ea(u*xa);xa=ea(u*ya);ya=ea(u*za);za=ea(u*Aa);Aa=ea(u*Ba);Ba=ea(u*Ca);p=h+4232|0;o=c[p>>2]|0;if(!o){i=l;return}n=q?128:96;k=q?3:6;Ca=ea(X-_);F=ea(Y-$);Fa=ea(Z-aa);j=y+4|0;Ga=y+8|0;Ha=y+12|0;Ia=x+4|0;Ja=x+8|0;Ka=x+12|0;La=A+4|0;Ma=A+8|0;Na=A+12|0;Oa=z+4|0;Pa=z+8|0;Qa=z+12|0;Ra=d+40|0;d=n<<1;Sa=n+80|0;Ta=ea(ea(K*K)+ea(-.5));Ua=ea(ea(R*R)+ea(-.5));Va=n|4;Wa=n|8;Xa=n|12;Ya=n|16;Za=n|20;_a=n|24;$a=n|28;ab=n+32|0;bb=n+36|0;cb=n+40|0;db=n+44|0;eb=n+48|0;fb=n+52|0;gb=n+56|0;hb=n+60|0;ib=n+64|0;jb=n+68|0;kb=n+72|0;lb=n+76|0;mb=o;o=0;nb=0;ob=m;while(1){m=c[h+(nb<<2)+3840>>2]|0;if(!m){pb=mb;qb=o;rb=ob}else{sb=h+(nb<<2)+3968|0;tb=e[h+((c[sb>>2]|0)*12|0)>>1]|0;ub=ea(g[f+(tb<<6)+60>>2]);vb=ob+32|0;a[ob+4>>0]=C;wb=c[sb>>2]|0;xb=b[h+(wb*12|0)>>1]|0;yb=xb&65535;zb=ea(g[f+(yb<<6)>>2]);Ab=ea(g[f+(yb<<6)+4>>2]);Bb=ea(g[f+(yb<<6)+8>>2]);Cb=ea(ea(ea(zb*zb)+ea(Ab*Ab))+ea(Bb*Bb));Db=ea(ea(ea(X*zb)+ea(Y*Ab))+ea(Z*Bb));Eb=ea(ea(ea(_*zb)+ea($*Ab))+ea(aa*Bb));Fb=ea(Ea*Cb);Gb=ea(Cb*ka);a:do if((wb|0)!=65535)if(ub>ea(0.0)){yb=xb;Hb=wb;Ib=vb;while(1){Jb=b[h+(Hb*12|0)+2>>1]|0;Kb=yb&65535;if(!(Jb<<16>>16))Lb=Ib;else{Mb=Jb&65535;Jb=da(n,Mb)|0;Nb=0;Ob=Ib;while(1){Pb=Nb+Kb|0;Cb=ea(g[f+(Pb<<6)+16>>2]);Qb=ea(g[f+(Pb<<6)+20>>2]);Rb=ea(g[f+(Pb<<6)+24>>2]);Sb=ea(g[f+(Pb<<6)+12>>2]);Tb=ea(g[f+(Pb<<6)+32>>2]);Ub=ea(g[f+(Pb<<6)+36>>2]);Vb=ea(ea(ea(zb*Tb)+ea(Ab*Ub))+ea(Bb*ea(g[f+(Pb<<6)+40>>2])));Ub=ea(Cb-L);Tb=ea(Qb-M);Wb=ea(Rb-N);Xb=ea(Cb-U);Cb=ea(Qb-V);Qb=ea(Rb-W);Rb=ea(ea(Bb*Tb)-ea(Ab*Wb));Yb=ea(ea(zb*Wb)-ea(Bb*Ub));Wb=ea(ea(Ab*Ub)-ea(zb*Tb));Tb=ea(ea(Bb*Cb)-ea(Ab*Qb));Ub=ea(ea(zb*Qb)-ea(Bb*Xb));Qb=ea(ea(Ab*Xb)-ea(zb*Cb));Cb=ea(ea(qa*Wb)+ea(ea(na*Yb)+ea(t*Rb)));Xb=ea(ea(ra*Wb)+ea(ea(oa*Yb)+ea(la*Rb)));Zb=ea(ea(sa*Wb)+ea(ea(pa*Yb)+ea(ma*Rb)));_b=ea(ea(za*Qb)+ea(ea(wa*Ub)+ea(ta*Tb)));$b=ea(ea(Aa*Qb)+ea(ea(xa*Ub)+ea(ua*Tb)));ac=ea(ea(Ba*Qb)+ea(ea(ya*Ub)+ea(va*Tb)));bc=ea(ea(Fb+ea(ea(Wb*Zb)+ea(ea(Rb*Cb)+ea(Yb*Xb))))+ea(ea(ea(Qb*ac)+ea(ea(Tb*_b)+ea(Ub*$b)))-Gb));cc=ea(ea(Db+ea(ea(fa*Wb)+ea(ea(ba*Rb)+ea(ca*Yb))))-ea(Eb+ea(ea(ia*Qb)+ea(ea(ga*Tb)+ea(ha*Ub)))));dc=ea(ea(1.0)/bc);ec=!(bc>ea(0.0));bc=ec?ea(0.0):dc;dc=ea(Sb-w);Sb=ea(dc*r);fc=ea(Da*dc);dc=ea((I>fc?I:fc)*bc);fc=ea(-cc);ec=Sb<fc&cc<s;cc=ec?ea(0.0):dc;dc=ea(ub*fc);fc=ea(Vb+(ec?dc:ea(0.0)));g[Ob>>2]=zb;g[Ob+4>>2]=Ab;g[Ob+8>>2]=Bb;g[Ob+12>>2]=bc;g[Ob+64>>2]=Cb;g[Ob+68>>2]=Xb;g[Ob+72>>2]=Zb;g[Ob+76>>2]=Ea;Zb=ea(-$b);$b=ea(-ac);g[Ob+80>>2]=ea(-_b);g[Ob+84>>2]=Zb;g[Ob+88>>2]=$b;g[Ob+92>>2]=ka;g[Ob+16>>2]=Rb;g[Ob+20>>2]=Yb;g[Ob+24>>2]=Wb;g[Ob+28>>2]=ea(0.0);g[Ob+32>>2]=Tb;g[Ob+36>>2]=Ub;g[Ob+40>>2]=Qb;g[Ob+44>>2]=ea(0.0);Qb=ea(g[f+(Pb<<6)+28>>2]);g[Ob+48>>2]=cc;g[Ob+52>>2]=fc;g[Ob+56>>2]=Qb;g[Ob+60>>2]=ea(0.0);Nb=Nb+1|0;if((Nb|0)==(Mb|0))break;else Ob=Ob+n|0}Lb=Ib+Jb|0}Ob=b[h+(Hb*12|0)+4>>1]|0;Mb=Ob&65535;if(Ob<<16>>16==-1){gc=Lb;break a}yb=b[h+(Mb*12|0)>>1]|0;Hb=Mb;Ib=Lb}}else{Ib=xb;Hb=wb;yb=vb;while(1){Mb=b[h+(Hb*12|0)+2>>1]|0;Ob=Ib&65535;if(!(Mb<<16>>16))hc=yb;else{Nb=Mb&65535;Mb=da(n,Nb)|0;Kb=0;Pb=yb;while(1){ec=Kb+Ob|0;Qb=ea(g[f+(ec<<6)+16>>2]);fc=ea(g[f+(ec<<6)+20>>2]);cc=ea(g[f+(ec<<6)+24>>2]);Ub=ea(g[f+(ec<<6)+12>>2]);Tb=ea(g[f+(ec<<6)+32>>2]);Wb=ea(g[f+(ec<<6)+36>>2]);Yb=ea(ea(ea(zb*Tb)+ea(Ab*Wb))+ea(Bb*ea(g[f+(ec<<6)+40>>2])));Wb=ea(Qb-L);Tb=ea(fc-M);Rb=ea(cc-N);$b=ea(Qb-U);Qb=ea(fc-V);fc=ea(cc-W);cc=ea(ea(Bb*Tb)-ea(Ab*Rb));Zb=ea(ea(zb*Rb)-ea(Bb*Wb));Rb=ea(ea(Ab*Wb)-ea(zb*Tb));Tb=ea(ea(Bb*Qb)-ea(Ab*fc));Wb=ea(ea(zb*fc)-ea(Bb*$b));fc=ea(ea(Ab*$b)-ea(zb*Qb));Qb=ea(ea(qa*Rb)+ea(ea(na*Zb)+ea(t*cc)));$b=ea(ea(ra*Rb)+ea(ea(oa*Zb)+ea(la*cc)));_b=ea(ea(sa*Rb)+ea(ea(pa*Zb)+ea(ma*cc)));ac=ea(ea(za*fc)+ea(ea(wa*Wb)+ea(ta*Tb)));Xb=ea(ea(Aa*fc)+ea(ea(xa*Wb)+ea(ua*Tb)));Cb=ea(ea(Ba*fc)+ea(ea(ya*Wb)+ea(va*Tb)));bc=ea(ea(Fb+ea(ea(Rb*_b)+ea(ea(cc*Qb)+ea(Zb*$b))))+ea(ea(ea(fc*Cb)+ea(ea(Tb*ac)+ea(Wb*Xb)))-Gb));dc=ea(ea(1.0)/bc);ic=!(bc>ea(0.0));bc=ic?ea(0.0):dc;dc=ea(Da*ea(Ub-w));Ub=ea((I>dc?I:dc)*bc);dc=ea(Yb+ea(0.0));g[Pb>>2]=zb;g[Pb+4>>2]=Ab;g[Pb+8>>2]=Bb;g[Pb+12>>2]=bc;g[Pb+64>>2]=Qb;g[Pb+68>>2]=$b;g[Pb+72>>2]=_b;g[Pb+76>>2]=Ea;_b=ea(-Xb);Xb=ea(-Cb);g[Pb+80>>2]=ea(-ac);g[Pb+84>>2]=_b;g[Pb+88>>2]=Xb;g[Pb+92>>2]=ka;g[Pb+16>>2]=cc;g[Pb+20>>2]=Zb;g[Pb+24>>2]=Rb;g[Pb+28>>2]=ea(0.0);g[Pb+32>>2]=Tb;g[Pb+36>>2]=Wb;g[Pb+40>>2]=fc;g[Pb+44>>2]=ea(0.0);fc=ea(g[f+(ec<<6)+28>>2]);g[Pb+48>>2]=Ub;g[Pb+52>>2]=dc;g[Pb+56>>2]=fc;g[Pb+60>>2]=ea(0.0);Kb=Kb+1|0;if((Kb|0)==(Nb|0))break;else Pb=Pb+n|0}hc=yb+Mb|0}Pb=b[h+(Hb*12|0)+4>>1]|0;Nb=Pb&65535;if(Pb<<16>>16==-1){gc=hc;break a}Ib=b[h+(Nb*12|0)>>1]|0;Hb=Nb;yb=hc}}else gc=vb;while(0);Gb=ea(g[f+(tb<<6)+44>>2]);Fb=ea(g[f+(tb<<6)+56>>2]);if(!(c[f+(tb<<6)+52>>2]&1)){vb=h+(nb*96|0)+784|0;wb=(b[vb>>1]|0)==0;a[ob+5>>0]=m;if(!wb){a[ob+6>>0]=e[vb>>1]<<1;if(q){jc=k;kc=1}else{jc=(b[B>>1]&64)==0?5:1;kc=1}}else lc=22}else{a[ob+5>>0]=m;lc=22}if((lc|0)==22){lc=0;a[ob+6>>0]=0;jc=k;kc=0}a[ob>>0]=jc;g[ob+16>>2]=Gb;g[ob+20>>2]=Fb;g[ob+24>>2]=D;g[ob+28>>2]=E;g[ob+8>>2]=v;g[ob+12>>2]=u;if(kc?(Fb=ea(-Bb),Gb=ea(-Ab),vb=ea(S(ea(zb)))<ea(.707106769),g[y>>2]=ea(0.0),g[j>>2]=Fb,g[Ga>>2]=Ab,g[Ha>>2]=ea(0.0),g[x>>2]=Gb,g[Ia>>2]=zb,g[Ja>>2]=ea(0.0),g[Ka>>2]=ea(0.0),wb=vb?y:x,Gb=ea(g[wb>>2]),Fb=ea(g[wb+4>>2]),ub=ea(g[wb+8>>2]),Eb=ea(ea(ea(Ca*zb)+ea(F*Ab))+ea(Fa*Bb)),Db=ea(Ca-ea(zb*Eb)),fc=ea(F-ea(Ab*Eb)),dc=ea(Fa-ea(Bb*Eb)),wb=ea(ea(dc*dc)+ea(ea(Db*Db)+ea(fc*fc)))>ea(.100000001),g[A>>2]=Db,g[La>>2]=fc,g[Ma>>2]=dc,g[Na>>2]=ea(0.0),g[z>>2]=Gb,g[Oa>>2]=Fb,g[Pa>>2]=ub,g[Qa>>2]=ea(0.0),vb=wb?A:z,ub=ea(g[vb>>2]),Fb=ea(g[vb+4>>2]),Gb=ea(g[vb+8>>2]),dc=ea(ea(1.0)/ea(T(ea(ea(ea(ub*ub)+ea(Fb*Fb))+ea(Gb*Gb))))),fc=ea(ub*dc),ub=ea(Fb*dc),Fb=ea(Gb*dc),dc=ea(ea(Ab*Fb)-ea(Bb*ub)),Gb=ea(ea(Bb*fc)-ea(zb*Fb)),Db=ea(ea(zb*ub)-ea(Ab*fc)),vb=(c[Ra>>2]|0)+(o*96|0)|0,wb=h+(nb*96|0)+784|0,(b[wb>>1]|0)!=0):0){xb=0;yb=gc;while(1){Hb=yb+d|0;Eb=ea(g[h+(nb*96|0)+(xb*12|0)+816>>2]);Ub=ea(g[h+(nb*96|0)+(xb*12|0)+820>>2]);Wb=ea(g[h+(nb*96|0)+(xb*12|0)+824>>2]);Tb=ea(g[h+(nb*96|0)+(xb*12|0)+840>>2]);Rb=ea(g[h+(nb*96|0)+(xb*12|0)+844>>2]);Zb=ea(g[h+(nb*96|0)+(xb*12|0)+848>>2]);c[yb+80>>2]=vb;c[yb+Sa>>2]=vb;cc=ea(ea(ea(H*Eb)+ea(G*Ub))+ea(J*Wb));Xb=ea(ea(ea(H*cc)+ea(ea(Ta*Eb)+ea(K*ea(ea(G*Wb)-ea(J*Ub)))))*ea(2.0));_b=ea(ea(ea(G*cc)+ea(ea(Ta*Ub)+ea(K*ea(ea(J*Eb)-ea(H*Wb)))))*ea(2.0));ac=ea(ea(ea(ea(Ta*Wb)+ea(K*ea(ea(H*Ub)-ea(G*Eb))))+ea(J*cc))*ea(2.0));cc=ea(ea(ea(O*Tb)+ea(P*Rb))+ea(Q*Zb));Eb=ea(ea(ea(O*cc)+ea(ea(Ua*Tb)+ea(R*ea(ea(P*Zb)-ea(Q*Rb)))))*ea(2.0));Ub=ea(ea(ea(P*cc)+ea(ea(Ua*Rb)+ea(R*ea(ea(Q*Tb)-ea(O*Zb)))))*ea(2.0));Wb=ea(ea(ea(ea(Ua*Zb)+ea(R*ea(ea(O*Rb)-ea(P*Tb))))+ea(Q*cc))*ea(2.0));cc=ea(ea(L+Xb)-ea(U+Eb));Tb=ea(ea(M+_b)-ea(V+Ub));Rb=ea(ea(N+ac)-ea(W+Wb));Zb=ea(ea(Fb*_b)-ea(ub*ac));Cb=ea(ea(fc*ac)-ea(Fb*Xb));$b=ea(ea(ub*Xb)-ea(fc*_b));Qb=ea(ea(Fb*Ub)-ea(ub*Wb));bc=ea(ea(fc*Wb)-ea(Fb*Eb));Yb=ea(ea(ub*Eb)-ea(fc*Ub));Vb=ea(ea(qa*$b)+ea(ea(t*Zb)+ea(na*Cb)));Sb=ea(ea(ra*$b)+ea(ea(la*Zb)+ea(oa*Cb)));mc=ea(ea(sa*$b)+ea(ea(ma*Zb)+ea(pa*Cb)));nc=ea(ea(za*Yb)+ea(ea(ta*Qb)+ea(wa*bc)));oc=ea(ea(Aa*Yb)+ea(ea(ua*Qb)+ea(xa*bc)));pc=ea(ea(Ba*Yb)+ea(ea(va*Qb)+ea(ya*bc)));qc=ea(ea(Ea+ea(ea($b*mc)+ea(ea(Zb*Vb)+ea(Cb*Sb))))+ea(ja+ea(ea(Yb*pc)+ea(ea(Qb*nc)+ea(bc*oc)))));rc=ea(ea(.800000011)/qc);Ib=!(qc>ea(0.0));qc=Ib?ea(0.0):rc;Ib=e[h+((c[sb>>2]|0)*12|0)>>1]|0;rc=ea(g[f+(Ib<<6)+32>>2]);sc=ea(g[f+(Ib<<6)+36>>2]);tc=ea(ea(ea(fc*rc)+ea(ub*sc))+ea(Fb*ea(g[f+(Ib<<6)+40>>2])));g[yb>>2]=fc;g[yb+4>>2]=ub;g[yb+8>>2]=Fb;g[yb+12>>2]=ea(0.0);g[yb+16>>2]=Zb;g[yb+20>>2]=Cb;g[yb+24>>2]=$b;g[yb+28>>2]=qc;qc=ea(ea(ea(Fb*Rb)+ea(ea(fc*cc)+ea(ub*Tb)))*r);g[yb+32>>2]=Qb;g[yb+36>>2]=bc;g[yb+40>>2]=Yb;g[yb+44>>2]=qc;g[yb+48>>2]=Vb;g[yb+52>>2]=Sb;g[yb+56>>2]=mc;g[yb+60>>2]=ea(0.0);mc=ea(-oc);oc=ea(-pc);g[yb+64>>2]=ea(-nc);g[yb+68>>2]=mc;g[yb+72>>2]=oc;g[yb+76>>2]=tc;tc=ea(ea(Db*_b)-ea(Gb*ac));oc=ea(ea(dc*ac)-ea(Db*Xb));ac=ea(ea(Gb*Xb)-ea(dc*_b));_b=ea(ea(Db*Ub)-ea(Gb*Wb));Xb=ea(ea(dc*Wb)-ea(Db*Eb));Wb=ea(ea(Gb*Eb)-ea(dc*Ub));Ub=ea(ea(qa*ac)+ea(ea(t*tc)+ea(na*oc)));Eb=ea(ea(ra*ac)+ea(ea(la*tc)+ea(oa*oc)));mc=ea(ea(sa*ac)+ea(ea(ma*tc)+ea(pa*oc)));nc=ea(ea(za*Wb)+ea(ea(ta*_b)+ea(wa*Xb)));pc=ea(ea(Aa*Wb)+ea(ea(ua*_b)+ea(xa*Xb)));Sb=ea(ea(Ba*Wb)+ea(ea(va*_b)+ea(ya*Xb)));Vb=ea(ea(Ea+ea(ea(ac*mc)+ea(ea(tc*Ub)+ea(oc*Eb))))+ea(ja+ea(ea(Wb*Sb)+ea(ea(_b*nc)+ea(Xb*pc)))));qc=ea(ea(.800000011)/Vb);Ib=!(Vb>ea(0.0));Vb=Ib?ea(0.0):qc;Ib=e[h+((c[sb>>2]|0)*12|0)>>1]|0;qc=ea(g[f+(Ib<<6)+32>>2]);Yb=ea(g[f+(Ib<<6)+36>>2]);bc=ea(ea(ea(dc*qc)+ea(Gb*Yb))+ea(Db*ea(g[f+(Ib<<6)+40>>2])));g[yb+n>>2]=dc;g[yb+Va>>2]=Gb;g[yb+Wa>>2]=Db;g[yb+Xa>>2]=ea(0.0);g[yb+Ya>>2]=tc;g[yb+Za>>2]=oc;g[yb+_a>>2]=ac;g[yb+$a>>2]=Vb;Vb=ea(ea(ea(Db*Rb)+ea(ea(dc*cc)+ea(Gb*Tb)))*r);g[yb+ab>>2]=_b;g[yb+bb>>2]=Xb;g[yb+cb>>2]=Wb;g[yb+db>>2]=Vb;g[yb+eb>>2]=Ub;g[yb+fb>>2]=Eb;g[yb+gb>>2]=mc;g[yb+hb>>2]=ea(0.0);mc=ea(-pc);pc=ea(-Sb);g[yb+ib>>2]=ea(-nc);g[yb+jb>>2]=mc;g[yb+kb>>2]=pc;g[yb+lb>>2]=bc;xb=xb+1|0;if(xb>>>0>=(e[wb>>1]|0)>>>0){uc=Hb;break}else yb=Hb}}else uc=gc;pb=c[p>>2]|0;qb=o+1|0;rb=uc}nb=nb+1|0;if(nb>>>0>=pb>>>0)break;else{mb=pb;o=qb;ob=rb}}i=l;return}function Cwa(d,f,h,j,k,l,m,n,o){d=d|0;f=f|0;h=h|0;j=ea(j);k=ea(k);l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=0,Ca=Im,Da=0,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=0,_a=Im,$a=Im,ab=Im,bb=0,cb=Im,db=Im,eb=Im,fb=0,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=Im,Ud=Im,Vd=Im,Wd=Im,Xd=Im,Yd=Im,Zd=Im,_d=Im,$d=Im,ae=Im,be=Im,ce=Im,de=Im,ee=Im,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=Im,Pe=Im,Qe=Im,Re=Im,Se=Im,Te=Im,Ue=Im,Ve=Im,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=Im,ph=Im,qh=Im,rh=Im,sh=Im,th=Im,uh=Im,vh=Im,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=Im,Dh=Im,Eh=Im,Fh=Im,Gh=Im,Hh=Im,Ih=Im,Jh=Im,Kh=Im,Lh=Im,Mh=Im,Nh=Im,Oh=Im,Ph=Im,Qh=Im,Rh=Im,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=Im,fj=Im,gj=Im,hj=Im,ij=Im,jj=Im,kj=Im,lj=Im,mj=Im,nj=Im,oj=Im,pj=Im,qj=Im,rj=Im,sj=Im,tj=Im,uj=Im,vj=Im,wj=Im,xj=Im,yj=Im,zj=Im,Aj=Im,Bj=Im,Cj=Im,Dj=Im,Ej=Im,Fj=Im,Gj=Im,Hj=Im,Ij=Im,Jj=Im,Kj=Im,Lj=Im,Mj=Im,Nj=Im,Oj=Im,Pj=Im,Qj=Im,Rj=Im,Sj=Im,Tj=Im,Uj=Im,Vj=Im,Wj=Im,Xj=Im,Yj=Im,Zj=Im,_j=Im,$j=Im,ak=Im,bk=Im,ck=Im,dk=Im,ek=Im,fk=Im,gk=Im,hk=Im,ik=Im,jk=Im,kk=Im,lk=Im,mk=Im,nk=Im,ok=Im,pk=Im,qk=Im,rk=Im,sk=Im,tk=Im,uk=Im,vk=Im,wk=Im,xk=Im,yk=Im,zk=Im,Ak=Im,Bk=Im,Ck=Im,Dk=Im,Ek=Im,Fk=Im,Gk=Im,Hk=Im,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=Im,vl=Im,wl=Im,xl=Im,yl=Im,zl=Im,Al=Im,Bl=Im,Cl=Im,Dl=Im,El=Im,Fl=Im,Gl=Im,Hl=Im,Il=Im,Jl=Im,Kl=Im,Ll=Im,Ml=Im,Nl=Im,Ol=Im,Pl=Im,Ql=Im,Rl=Im,Sl=Im,Tl=Im,Ul=Im,Vl=Im,Wl=Im,Xl=Im,Yl=Im,Zl=Im,_l=Im,$l=Im,am=Im,bm=Im,cm=Im,dm=Im,em=Im,fm=Im,gm=Im,hm=Im,im=Im,jm=Im,km=Im,lm=Im,mm=Im,nm=Im,om=Im,pm=Im,qm=Im,rm=Im,sm=Im,tm=Im,um=Im,vm=Im;p=i;i=i+384|0;q=p+176|0;r=p+160|0;s=p+16|0;t=p+336|0;u=p;v=p+64|0;w=p+80|0;x=p+96|0;y=p+256|0;z=p+288|0;A=p+320|0;B=p+352|0;C=p+368|0;D=p+192|0;E=p+208|0;F=p+224|0;G=p+32|0;H=p+240|0;I=p+112|0;J=p+48|0;K=p+128|0;L=p+272|0;M=p+144|0;N=p+304|0;O=c[d>>2]|0;P=b[O+22>>1]|0;Q=(P&65535)>>>8&1;R=d+56|0;S=c[R>>2]|0;U=b[S+22>>1]|0;V=(U&65535)>>>8&1;W=d+112|0;X=c[W>>2]|0;Y=b[X+22>>1]|0;Z=(Y&65535)>>>8&1;_=d+168|0;$=c[_>>2]|0;aa=b[$+22>>1]|0;ba=(aa&65535)>>>8&1;ca=((U|P|Y|aa)&64)!=0;aa=ca?272:176;Y=ca?336:240;fa=ea(g[O+84>>2]);ga=ea(g[S+84>>2]);ha=ea(g[X+84>>2]);ia=ea(g[$+84>>2]);ja=ea(g[O+88>>2]);ka=ea(g[S+88>>2]);la=ea(g[X+88>>2]);ma=ea(g[$+88>>2]);na=ea(g[l>>2]);oa=ea(g[l+4>>2]);pa=ea(g[l+8>>2]);qa=ea(fa*na);na=ea(ga*oa);oa=ea(ha*pa);pa=ea(ia*ea(g[l+12>>2]));ra=ea(g[n>>2]);sa=ea(g[n+4>>2]);ta=ea(g[n+8>>2]);ua=ea(ja*ra);ra=ea(ka*sa);sa=ea(la*ta);ta=ea(ma*ea(g[n+12>>2]));va=ea(g[m>>2]);wa=ea(g[m+4>>2]);xa=ea(g[m+8>>2]);ya=ea(fa*va);va=ea(ga*wa);wa=ea(ha*xa);xa=ea(ia*ea(g[m+12>>2]));ia=ea(g[o>>2]);ha=ea(g[o+4>>2]);ga=ea(g[o+8>>2]);fa=ea(ja*ia);ia=ea(ka*ha);ha=ea(la*ga);ga=ea(ma*ea(g[o+12>>2]));o=c[d+44>>2]|0;ma=ea(g[o+52>>2]);m=c[d+100>>2]|0;la=ea(g[m+52>>2]);n=c[d+156>>2]|0;ka=ea(g[n+52>>2]);l=c[d+212>>2]|0;ja=ea(g[l+52>>2]);P=c[d+48>>2]|0;za=ea(g[P+52>>2]);U=c[d+104>>2]|0;Aa=ea(g[U+52>>2]);Ba=c[d+160>>2]|0;Ca=ea(g[Ba+52>>2]);Da=c[d+216>>2]|0;Ea=ea(g[Da+52>>2]);Fa=ma>za?ma:za;za=la>Aa?la:Aa;Aa=ka>Ca?ka:Ca;Ca=ja>Ea?ja:Ea;Ea=ea(g[O+92>>2]);ja=ea(g[S+92>>2]);ka=ea(g[X+92>>2]);la=ea(g[$+92>>2]);$=c[d+36>>2]|0;ma=ea(g[$>>2]);Ga=ea(g[$+4>>2]);Ha=ea(g[$+8>>2]);X=c[d+92>>2]|0;Ia=ea(g[X>>2]);Ja=ea(g[X+4>>2]);Ka=ea(g[X+8>>2]);S=c[d+148>>2]|0;La=ea(g[S>>2]);Ma=ea(g[S+4>>2]);Na=ea(g[S+8>>2]);O=c[d+204>>2]|0;Oa=ea(g[O>>2]);Pa=ea(g[O+4>>2]);Qa=ea(g[O+8>>2]);Ra=c[d+40>>2]|0;Sa=ea(g[Ra>>2]);Ta=ea(g[Ra+4>>2]);Ua=ea(g[Ra+8>>2]);Va=c[d+96>>2]|0;Wa=ea(g[Va>>2]);Xa=ea(g[Va+4>>2]);Ya=ea(g[Va+8>>2]);Za=c[d+152>>2]|0;_a=ea(g[Za>>2]);$a=ea(g[Za+4>>2]);ab=ea(g[Za+8>>2]);bb=c[d+208>>2]|0;cb=ea(g[bb>>2]);db=ea(g[bb+4>>2]);eb=ea(g[bb+8>>2]);fb=$+16|0;gb=ea(g[fb>>2]);hb=ea(g[fb+4>>2]);ib=ea(g[fb+8>>2]);fb=X+16|0;jb=ea(g[fb>>2]);kb=ea(g[fb+4>>2]);lb=ea(g[fb+8>>2]);fb=S+16|0;mb=ea(g[fb>>2]);nb=ea(g[fb+4>>2]);ob=ea(g[fb+8>>2]);fb=O+16|0;pb=ea(g[fb>>2]);qb=ea(g[fb+4>>2]);rb=ea(g[fb+8>>2]);fb=Ra+16|0;sb=ea(g[fb>>2]);tb=ea(g[fb+4>>2]);ub=ea(g[fb+8>>2]);fb=Va+16|0;vb=ea(g[fb>>2]);wb=ea(g[fb+4>>2]);xb=ea(g[fb+8>>2]);fb=Za+16|0;yb=ea(g[fb>>2]);zb=ea(g[fb+4>>2]);Ab=ea(g[fb+8>>2]);fb=bb+16|0;Bb=ea(g[fb>>2]);Cb=ea(g[fb+4>>2]);Db=ea(g[fb+8>>2]);Eb=ea(ma-Sa);Fb=ea(Ia-Wa);Gb=ea(La-_a);Hb=ea(Oa-cb);Ib=ea(Ga-Ta);Jb=ea(Ja-Xa);Kb=ea(Ma-$a);Lb=ea(Pa-db);Mb=ea(Ha-Ua);Nb=ea(Ka-Ya);Ob=ea(Na-ab);Pb=ea(Qa-eb);Qb=ea(g[o+48>>2]);Rb=ea(g[m+48>>2]);Sb=ea(g[n+48>>2]);Tb=ea(g[l+48>>2]);Ub=ea(g[P+48>>2]);Vb=ea(g[U+48>>2]);Wb=ea(g[Ba+48>>2]);Xb=ea(qa*Qb);Qb=ea(na*Rb);Rb=ea(oa*Sb);Sb=ea(pa*Tb);Tb=ea(ua*Ub);Ub=ea(-Tb);ua=ea(ra*Vb);Vb=ea(-ua);ra=ea(sa*Wb);Wb=ea(-ra);sa=ea(ta*ea(g[Da+48>>2]));ta=ea(-sa);pa=ea(g[o>>2]);oa=ea(g[o+4>>2]);na=ea(g[o+8>>2]);qa=ea(g[o+12>>2]);Yb=ea(g[o+16>>2]);Zb=ea(g[o+20>>2]);_b=ea(g[o+24>>2]);$b=ea(g[o+28>>2]);ac=ea(g[o+32>>2]);bc=ea(g[m>>2]);cc=ea(g[m+4>>2]);dc=ea(g[m+8>>2]);ec=ea(g[m+12>>2]);fc=ea(g[m+16>>2]);gc=ea(g[m+20>>2]);hc=ea(g[m+24>>2]);ic=ea(g[m+28>>2]);jc=ea(g[m+32>>2]);kc=ea(g[n>>2]);lc=ea(g[n+4>>2]);mc=ea(g[n+8>>2]);nc=ea(g[n+12>>2]);oc=ea(g[n+16>>2]);pc=ea(g[n+20>>2]);qc=ea(g[n+24>>2]);rc=ea(g[n+28>>2]);sc=ea(g[n+32>>2]);tc=ea(g[l>>2]);uc=ea(g[l+4>>2]);vc=ea(g[l+8>>2]);wc=ea(g[l+12>>2]);xc=ea(g[l+16>>2]);yc=ea(g[l+20>>2]);zc=ea(g[l+24>>2]);Ac=ea(g[l+28>>2]);Bc=ea(g[l+32>>2]);Cc=ea(g[P>>2]);Dc=ea(g[P+4>>2]);Ec=ea(g[P+8>>2]);Fc=ea(g[P+12>>2]);Gc=ea(g[P+16>>2]);Hc=ea(g[P+20>>2]);Ic=ea(g[P+24>>2]);Jc=ea(g[P+28>>2]);Kc=ea(g[P+32>>2]);Lc=ea(g[U>>2]);Mc=ea(g[U+4>>2]);Nc=ea(g[U+8>>2]);Oc=ea(g[U+12>>2]);Pc=ea(g[U+16>>2]);Qc=ea(g[U+20>>2]);Rc=ea(g[U+24>>2]);Sc=ea(g[U+28>>2]);Tc=ea(g[U+32>>2]);Uc=ea(g[Ba>>2]);Vc=ea(g[Ba+4>>2]);Wc=ea(g[Ba+8>>2]);Xc=ea(g[Ba+12>>2]);Yc=ea(g[Ba+16>>2]);Zc=ea(g[Ba+20>>2]);_c=ea(g[Ba+24>>2]);$c=ea(g[Ba+28>>2]);ad=ea(g[Ba+32>>2]);bd=ea(g[Da>>2]);cd=ea(g[Da+4>>2]);dd=ea(g[Da+8>>2]);ed=ea(g[Da+12>>2]);fd=ea(g[Da+16>>2]);gd=ea(g[Da+20>>2]);hd=ea(g[Da+24>>2]);id=ea(g[Da+28>>2]);jd=ea(ya*pa);pa=ea(va*bc);bc=ea(wa*kc);kc=ea(xa*tc);tc=ea(ya*oa);oa=ea(va*cc);cc=ea(wa*lc);lc=ea(xa*uc);uc=ea(ya*na);na=ea(va*dc);dc=ea(wa*mc);mc=ea(xa*vc);vc=ea(ya*qa);qa=ea(va*ec);ec=ea(wa*nc);nc=ea(xa*wc);wc=ea(ya*Yb);Yb=ea(va*fc);fc=ea(wa*oc);oc=ea(xa*xc);xc=ea(ya*Zb);Zb=ea(va*gc);gc=ea(wa*pc);pc=ea(xa*yc);yc=ea(ya*_b);_b=ea(va*hc);hc=ea(wa*qc);qc=ea(xa*zc);zc=ea(ya*$b);$b=ea(va*ic);ic=ea(wa*rc);rc=ea(xa*Ac);Ac=ea(ya*ac);ac=ea(va*jc);jc=ea(wa*sc);sc=ea(xa*Bc);Bc=ea(fa*Cc);Cc=ea(ia*Lc);Lc=ea(ha*Uc);Uc=ea(ga*bd);bd=ea(fa*Dc);Dc=ea(ia*Mc);Mc=ea(ha*Vc);Vc=ea(ga*cd);cd=ea(fa*Ec);Ec=ea(ia*Nc);Nc=ea(ha*Wc);Wc=ea(ga*dd);dd=ea(fa*Fc);Fc=ea(ia*Oc);Oc=ea(ha*Xc);Xc=ea(ga*ed);ed=ea(fa*Gc);Gc=ea(ia*Pc);Pc=ea(ha*Yc);Yc=ea(ga*fd);fd=ea(fa*Hc);Hc=ea(ia*Qc);Qc=ea(ha*Zc);Zc=ea(ga*gd);gd=ea(fa*Ic);Ic=ea(ia*Rc);Rc=ea(ha*_c);_c=ea(ga*hd);hd=ea(fa*Jc);Jc=ea(ia*Sc);Sc=ea(ha*$c);$c=ea(ga*id);id=ea(fa*Kc);Kc=ea(ia*Tc);Tc=ea(ha*ad);ad=ea(ga*ea(g[Da+32>>2]));ga=ea(j*ea(.800000011));Da=c[d+28>>2]|0;ha=ea(g[Da+16>>2]);ia=ea(g[Da+20>>2]);fa=ea(g[Da+24>>2]);Ba=c[d+84>>2]|0;xa=ea(g[Ba+16>>2]);wa=ea(g[Ba+20>>2]);va=ea(g[Ba+24>>2]);U=c[d+140>>2]|0;ya=ea(g[U+16>>2]);kd=ea(g[U+20>>2]);ld=ea(g[U+24>>2]);P=c[d+196>>2]|0;md=ea(g[P+16>>2]);nd=ea(g[P+20>>2]);od=ea(g[P+24>>2]);l=c[d+32>>2]|0;pd=ea(g[l+16>>2]);qd=ea(g[l+20>>2]);rd=ea(g[l+24>>2]);n=c[d+88>>2]|0;sd=ea(g[n+16>>2]);td=ea(g[n+20>>2]);ud=ea(g[n+24>>2]);m=c[d+144>>2]|0;vd=ea(g[m+16>>2]);wd=ea(g[m+20>>2]);xd=ea(g[m+24>>2]);o=c[d+200>>2]|0;yd=ea(g[o+16>>2]);zd=ea(g[o+20>>2]);Ad=ea(g[o+24>>2]);Bd=ea(g[Da>>2]);Cd=ea(g[Da+4>>2]);Dd=ea(g[Da+8>>2]);Ed=ea(g[Da+12>>2]);Fd=ea(g[Ba>>2]);Gd=ea(g[Ba+4>>2]);Hd=ea(g[Ba+8>>2]);Id=ea(g[Ba+12>>2]);Jd=ea(g[U>>2]);Kd=ea(g[U+4>>2]);Ld=ea(g[U+8>>2]);Md=ea(g[U+12>>2]);Nd=ea(g[P>>2]);Od=ea(g[P+4>>2]);Pd=ea(g[P+8>>2]);Qd=ea(g[P+12>>2]);Rd=ea(g[l>>2]);Sd=ea(g[l+4>>2]);Td=ea(g[l+8>>2]);Ud=ea(g[l+12>>2]);Vd=ea(g[n>>2]);Wd=ea(g[n+4>>2]);Xd=ea(g[n+8>>2]);Yd=ea(g[n+12>>2]);Zd=ea(g[m>>2]);_d=ea(g[m+4>>2]);$d=ea(g[m+8>>2]);ae=ea(g[m+12>>2]);be=ea(g[o>>2]);ce=ea(g[o+4>>2]);de=ea(g[o+8>>2]);ee=ea(g[o+12>>2]);o=d+8|0;m=c[o>>2]|0;n=d+64|0;l=c[n>>2]|0;P=d+120|0;U=c[P>>2]|0;Ba=d+176|0;Da=c[Ba>>2]|0;fb=U>>>0<Da>>>0?Da:U;U=l>>>0<fb>>>0?fb:l;l=m>>>0<U>>>0?U:m;if(!l){i=p;return}m=r+4|0;U=r+8|0;fb=r+12|0;Da=s+4|0;bb=s+8|0;Za=s+12|0;Va=v+4|0;Ra=v+8|0;O=v+12|0;S=u+4|0;X=u+8|0;$=u+12|0;fe=w+4|0;ge=w+8|0;he=w+12|0;ie=ca?7:8;je=y+4|0;ke=y+8|0;le=y+12|0;me=B+4|0;ne=B+8|0;oe=B+12|0;pe=A+4|0;qe=A+8|0;re=A+12|0;se=D+4|0;te=D+8|0;ue=D+12|0;ve=F+4|0;we=F+8|0;xe=F+12|0;ye=E+4|0;ze=E+8|0;Ae=E+12|0;Be=H+4|0;Ce=H+8|0;De=H+12|0;Ee=G+4|0;Fe=G+8|0;Ge=G+12|0;He=J+4|0;Ie=J+8|0;Je=J+12|0;Ke=I+4|0;Le=I+8|0;Me=I+12|0;Ne=Y<<1;Oe=ea(ea(Ed*Ed)+ea(-.5));Pe=ea(ea(Id*Id)+ea(-.5));Qe=ea(ea(Md*Md)+ea(-.5));Re=ea(ea(Qd*Qd)+ea(-.5));Se=ea(ea(Ud*Ud)+ea(-.5));Te=ea(ea(Yd*Yd)+ea(-.5));Ue=ea(ea(ae*ae)+ea(-.5));Ve=ea(ea(ee*ee)+ea(-.5));We=L+4|0;Xe=L+8|0;Ye=L+12|0;Ze=Y+240|0;_e=Y+244|0;$e=Y+248|0;af=Y+252|0;bf=Y+256|0;cf=Y+260|0;df=Y+264|0;ef=Y+268|0;ff=Y+272|0;gf=Y+276|0;hf=Y+280|0;jf=Y+284|0;kf=Y+288|0;lf=Y+292|0;mf=Y+296|0;nf=Y+300|0;of=Y+304|0;pf=Y+308|0;qf=Y+312|0;rf=Y+316|0;sf=Y+320|0;tf=Y+324|0;uf=Y+328|0;vf=Y+332|0;wf=N+4|0;xf=N+8|0;yf=N+12|0;zf=Y|4;Af=Y|8;Bf=Y|12;Cf=Y+16|0;Df=Y+20|0;Ef=Y+24|0;Ff=Y+28|0;Gf=Y+32|0;Hf=Y+36|0;If=Y+40|0;Jf=Y+44|0;Kf=Y+48|0;Lf=Y+52|0;Mf=Y+56|0;Nf=Y+60|0;Of=Y+64|0;Pf=Y+68|0;Qf=Y+72|0;Rf=Y+76|0;Sf=Y+80|0;Tf=Y+84|0;Uf=Y+88|0;Vf=Y+92|0;Wf=Y+96|0;Xf=Y+100|0;Yf=Y+104|0;Zf=Y+108|0;_f=Y+112|0;$f=Y+116|0;ag=Y+120|0;bg=Y+124|0;cg=Y+128|0;dg=Y+132|0;eg=Y+136|0;fg=Y+140|0;gg=Y+144|0;hg=Y+148|0;ig=Y+152|0;jg=Y+156|0;kg=Y+160|0;lg=Y+164|0;mg=Y+168|0;ng=Y+172|0;og=Y+176|0;pg=Y+180|0;qg=Y+184|0;rg=Y+188|0;sg=Y+192|0;tg=Y+196|0;ug=Y+200|0;vg=Y+204|0;wg=Y+208|0;xg=Y+212|0;yg=Y+216|0;zg=Y+220|0;Ag=Y+224|0;Bg=Y+228|0;Cg=Y+232|0;Dg=Y+236|0;Eg=d+172|0;Fg=d+116|0;Gg=d+60|0;Hg=d+4|0;Ig=Y<<1;Jg=0;Kg=0;Lg=0;Mg=0;Ng=0;Og=0;Pg=0;Qg=0;Rg=0;Sg=0;Tg=0;Ug=0;Vg=0;Wg=h;while(1){h=Rg>>>0>=(c[o>>2]|0)>>>0;Xg=Rg>>>0>=(c[n>>2]|0)>>>0;Yg=Rg>>>0>=(c[P>>2]|0)>>>0;Zg=Rg>>>0>=(c[Ba>>2]|0)>>>0;if(h)_g=Ng;else _g=(c[Hg>>2]|0)+Rg|0;if(Xg)$g=Og;else $g=(c[Gg>>2]|0)+Rg|0;if(Yg)ah=Pg;else ah=(c[Fg>>2]|0)+Rg|0;if(Zg)bh=Qg;else bh=(c[Eg>>2]|0)+Rg|0;if(h)ch=0;else ch=c[f+(_g<<2)+8336>>2]&255;if(Xg)dh=0;else dh=c[f+($g<<2)+8336>>2]&255;if(Yg)eh=0;else eh=c[f+(ah<<2)+8336>>2]&255;if(Zg)fh=0;else fh=c[f+(bh<<2)+8336>>2]&255;gh=c[f+(_g<<2)+8464>>2]|0;hh=c[f+($g<<2)+8464>>2]|0;ih=c[f+(ah<<2)+8464>>2]|0;jh=c[f+(bh<<2)+8464>>2]|0;kh=e[f+(gh*12|0)+4496>>1]|0;lh=e[f+(hh*12|0)+4496>>1]|0;mh=e[f+(ih*12|0)+4496>>1]|0;nh=e[f+(jh*12|0)+4496>>1]|0;oh=ea(g[f+(kh<<6)+444>>2]);ph=ea(g[f+(lh<<6)+444>>2]);qh=ea(g[f+(mh<<6)+444>>2]);rh=ea(g[f+(nh<<6)+444>>2]);sh=ea(-oh);th=ea(-ph);uh=ea(-qh);vh=ea(-rh);wh=Wg+144|0;a[Wg+4>>0]=Q;a[Wg+5>>0]=V;a[Wg+6>>0]=Z;a[Wg+7>>0]=ba;xh=Wg+8|0;a[xh>>0]=ch;yh=Wg+9|0;a[yh>>0]=dh;zh=Wg+10|0;a[zh>>0]=eh;Ah=Wg+11|0;a[Ah>>0]=fh;g[Wg+64>>2]=Xb;g[Wg+68>>2]=Qb;g[Wg+72>>2]=Rb;g[Wg+76>>2]=Sb;g[Wg+80>>2]=Ub;g[Wg+84>>2]=Vb;g[Wg+88>>2]=Wb;g[Wg+92>>2]=ta;g[Wg+16>>2]=sh;g[Wg+20>>2]=th;g[Wg+24>>2]=uh;g[Wg+28>>2]=vh;Bh=f+(kh<<6)+384|0;Ch=ea(g[Bh>>2]);Dh=ea(g[Bh+4>>2]);Eh=ea(g[Bh+8>>2]);Bh=f+(lh<<6)+384|0;Fh=ea(g[Bh>>2]);Gh=ea(g[Bh+4>>2]);Hh=ea(g[Bh+8>>2]);Bh=f+(mh<<6)+384|0;Ih=ea(g[Bh>>2]);Jh=ea(g[Bh+4>>2]);Kh=ea(g[Bh+8>>2]);Bh=f+(nh<<6)+384|0;Lh=ea(g[Bh>>2]);Mh=ea(g[Bh+4>>2]);Nh=ea(g[Bh+8>>2]);g[Wg+96>>2]=Ch;g[Wg+100>>2]=Fh;g[Wg+104>>2]=Ih;g[Wg+108>>2]=Lh;g[Wg+112>>2]=Dh;g[Wg+116>>2]=Gh;g[Wg+120>>2]=Jh;g[Wg+124>>2]=Mh;g[Wg+128>>2]=Eh;g[Wg+132>>2]=Hh;g[Wg+136>>2]=Kh;g[Wg+140>>2]=Nh;Oh=ea(ea(ea(Ha*Eh)+ea(ea(ma*Ch)+ea(Ga*Dh)))-ea(ea(Ua*Eh)+ea(ea(Sa*Ch)+ea(Ta*Dh))));Ph=ea(ea(ea(Ka*Hh)+ea(ea(Ia*Fh)+ea(Ja*Gh)))-ea(ea(Ya*Hh)+ea(ea(Wa*Fh)+ea(Xa*Gh))));Qh=ea(ea(ea(Na*Kh)+ea(ea(La*Ih)+ea(Ma*Jh)))-ea(ea(ab*Kh)+ea(ea(_a*Ih)+ea($a*Jh))));Rh=ea(ea(ea(Qa*Nh)+ea(ea(Oa*Lh)+ea(Pa*Mh)))-ea(ea(eb*Nh)+ea(ea(cb*Lh)+ea(db*Mh))));Bh=(Xg&1)<<1|h&1|(Yg&1)<<2|(Zg&1)<<3;a:do if((gh|0)==65535)Sh=65535;else{Th=gh;while(1){if(b[f+(Th*12|0)+4498>>1]|0){Sh=Th;break a}Uh=b[f+(Th*12|0)+4500>>1]|0;Vh=Uh&65535;if(Uh<<16>>16==-1){Sh=Vh;break}else Th=Vh}}while(0);b:do if((hh|0)==65535)Wh=65535;else{gh=hh;while(1){if(b[f+(gh*12|0)+4498>>1]|0){Wh=gh;break b}Th=b[f+(gh*12|0)+4500>>1]|0;Vh=Th&65535;if(Th<<16>>16==-1){Wh=Vh;break}else gh=Vh}}while(0);c:do if((ih|0)==65535)Xh=65535;else{hh=ih;while(1){if(b[f+(hh*12|0)+4498>>1]|0){Xh=hh;break c}gh=b[f+(hh*12|0)+4500>>1]|0;Vh=gh&65535;if(gh<<16>>16==-1){Xh=Vh;break}else hh=Vh}}while(0);d:do if((jh|0)==65535)Yh=65535;else{ih=jh;while(1){if(b[f+(ih*12|0)+4498>>1]|0){Yh=ih;break d}hh=b[f+(ih*12|0)+4500>>1]|0;Vh=hh&65535;if(hh<<16>>16==-1){Yh=Vh;break}else ih=Vh}}while(0);e:do if(!h)if((Sh|0)==65535){Zh=0;_h=1;$h=65535;ai=65535}else{jh=1;ih=Sh;while(1){if((jh|0)!=(e[f+(ih*12|0)+4498>>1]|0)){Zh=0;_h=jh;$h=ih;ai=Sh;break e}Vh=b[f+(ih*12|0)+4500>>1]|0;hh=Vh&65535;if(Vh<<16>>16==-1){Zh=0;_h=0;$h=hh;ai=Sh;break}else{jh=0;ih=hh}}}else{Zh=Mg;_h=0;$h=Sh;ai=Ug}while(0);f:do if(!Xg)if((Wh|0)==65535){bi=0;ci=1;di=65535;ei=65535}else{ih=1;jh=Wh;while(1){if((ih|0)!=(e[f+(jh*12|0)+4498>>1]|0)){bi=0;ci=ih;di=jh;ei=Wh;break f}hh=b[f+(jh*12|0)+4500>>1]|0;Vh=hh&65535;if(hh<<16>>16==-1){bi=0;ci=0;di=Vh;ei=Wh;break}else{ih=0;jh=Vh}}}else{bi=Lg;ci=0;di=Wh;ei=Tg}while(0);g:do if(!Yg)if((Xh|0)==65535){fi=0;gi=1;hi=65535;ii=65535}else{jh=1;ih=Xh;while(1){if((jh|0)!=(e[f+(ih*12|0)+4498>>1]|0)){fi=0;gi=jh;hi=ih;ii=Xh;break g}Vh=b[f+(ih*12|0)+4500>>1]|0;hh=Vh&65535;if(Vh<<16>>16==-1){fi=0;gi=0;hi=hh;ii=Xh;break}else{jh=0;ih=hh}}}else{fi=Kg;gi=0;hi=Xh;ii=Sg}while(0);h:do if(!Zg)if((Yh|0)==65535){ji=0;ki=1;li=65535;mi=65535}else{ih=1;jh=Yh;while(1){if((ih|0)!=(e[f+(jh*12|0)+4498>>1]|0)){ji=0;ki=ih;li=jh;mi=Yh;break h}hh=b[f+(jh*12|0)+4500>>1]|0;Vh=hh&65535;if(hh<<16>>16==-1){ji=0;ki=0;li=Vh;mi=Yh;break}else{ih=0;jh=Vh}}}else{ji=Jg;ki=0;li=Yh;mi=Vg}while(0);if(h|($h|0)==65535)ni=1;else ni=_h>>>0>=(e[f+($h*12|0)+4498>>1]|0)>>>0;if(Xg|(di|0)==65535)oi=1;else oi=ci>>>0>=(e[f+(di*12|0)+4498>>1]|0)>>>0;if(Yg|(hi|0)==65535)pi=1;else pi=gi>>>0>=(e[f+(hi*12|0)+4498>>1]|0)>>>0;if(Zg|(li|0)==65535)qi=1;else qi=ki>>>0>=(e[f+(li*12|0)+4498>>1]|0)>>>0;jh=oh>ea(-0.0);ih=ph>ea(-0.0);Vh=qh>ea(-0.0);hh=rh>ea(-0.0);gh=Zh;Th=bi;Uh=fi;ri=ji;si=_h;ti=ci;ui=gi;vi=ki;wi=0;xi=Bh;yi=(oi&1)<<1|ni&1|(pi&1)<<2|(qi&1)<<3;zi=hi;Ai=ii;Bi=di;Ci=ei;Di=$h;Ei=ai;Fi=li;Gi=mi;Hi=wh;i:while(1){Ii=f+(Gi*12|0)+4496|0;Ji=gh;Ki=Th;Li=Uh;Mi=si;Ni=ti;Oi=ui;Pi=wi;Qi=xi;Ri=yi;Si=zi;Ti=Ai;Ui=Bi;Vi=Ci;Wi=Di;Xi=Ei;Yi=Hi;while(1){if((Qi|0)==15)break i;Zi=Pi+1|0;_i=Yi+aa|0;$i=(e[f+(Xi*12|0)+4496>>1]|0)+Ji|0;aj=(e[f+(Vi*12|0)+4496>>1]|0)+Ki|0;bj=(e[f+(Ti*12|0)+4496>>1]|0)+Li|0;cj=(e[Ii>>1]|0)+ri|0;dj=f+($i<<6)+400|0;ej=ea(g[dj>>2]);fj=ea(g[dj+4>>2]);gj=ea(g[dj+8>>2]);dj=f+(aj<<6)+400|0;hj=ea(g[dj>>2]);ij=ea(g[dj+4>>2]);jj=ea(g[dj+8>>2]);dj=f+(bj<<6)+400|0;kj=ea(g[dj>>2]);lj=ea(g[dj+4>>2]);mj=ea(g[dj+8>>2]);dj=f+(cj<<6)+400|0;nj=ea(g[dj>>2]);oj=ea(g[dj+4>>2]);pj=ea(g[dj+8>>2]);dj=f+($i<<6)+416|0;qj=ea(g[dj>>2]);rj=ea(g[dj+4>>2]);sj=ea(g[dj+8>>2]);dj=f+(aj<<6)+416|0;tj=ea(g[dj>>2]);uj=ea(g[dj+4>>2]);vj=ea(g[dj+8>>2]);dj=f+(bj<<6)+416|0;wj=ea(g[dj>>2]);xj=ea(g[dj+4>>2]);yj=ea(g[dj+8>>2]);dj=f+(cj<<6)+416|0;zj=ea(g[dj>>2]);Aj=ea(g[dj+4>>2]);Bj=ea(g[dj+8>>2]);Cj=ea(g[f+($i<<6)+396>>2]);Dj=ea(g[f+(aj<<6)+396>>2]);Ej=ea(g[f+(bj<<6)+396>>2]);Fj=ea(g[f+(cj<<6)+396>>2]);Gj=ea(g[f+($i<<6)+412>>2]);Hj=ea(g[f+(aj<<6)+412>>2]);Ij=ea(g[f+(bj<<6)+412>>2]);Jj=ea(g[f+(cj<<6)+412>>2]);Kj=ea(ea(Ch*qj)+ea(ea(Dh*rj)+ea(Eh*sj)));sj=ea(ea(Fh*tj)+ea(ea(Gh*uj)+ea(Hh*vj)));vj=ea(ea(Ih*wj)+ea(ea(Jh*xj)+ea(Kh*yj)));yj=ea(ea(Lh*zj)+ea(ea(Mh*Aj)+ea(Nh*Bj)));Bj=ea(ej-ha);Aj=ea(hj-xa);zj=ea(kj-ya);xj=ea(nj-md);wj=ea(fj-ia);uj=ea(ij-wa);tj=ea(lj-kd);rj=ea(oj-nd);qj=ea(gj-fa);Lj=ea(jj-va);Mj=ea(mj-ld);Nj=ea(pj-od);Oj=ea(ej-pd);ej=ea(hj-sd);hj=ea(kj-vd);kj=ea(nj-yd);nj=ea(fj-qd);fj=ea(ij-td);ij=ea(lj-wd);lj=ea(oj-zd);oj=ea(gj-rd);gj=ea(jj-ud);jj=ea(mj-xd);mj=ea(pj-Ad);pj=ea(ea(Eh*wj)-ea(Dh*qj));Pj=ea(ea(Hh*uj)-ea(Gh*Lj));Qj=ea(ea(Kh*tj)-ea(Jh*Mj));Rj=ea(ea(Nh*rj)-ea(Mh*Nj));Sj=ea(ea(Ch*qj)-ea(Eh*Bj));qj=ea(ea(Fh*Lj)-ea(Hh*Aj));Lj=ea(ea(Ih*Mj)-ea(Kh*zj));Mj=ea(ea(Lh*Nj)-ea(Nh*xj));Nj=ea(ea(Dh*Bj)-ea(Ch*wj));wj=ea(ea(Gh*Aj)-ea(Fh*uj));uj=ea(ea(Jh*zj)-ea(Ih*tj));tj=ea(ea(Mh*xj)-ea(Lh*rj));rj=ea(ea(uc*Nj)+ea(ea(tc*Sj)+ea(jd*pj)));xj=ea(ea(na*wj)+ea(ea(oa*qj)+ea(pa*Pj)));zj=ea(ea(dc*uj)+ea(ea(cc*Lj)+ea(bc*Qj)));Aj=ea(ea(mc*tj)+ea(ea(lc*Mj)+ea(kc*Rj)));Bj=ea(ea(xc*Nj)+ea(ea(wc*Sj)+ea(vc*pj)));Tj=ea(ea(Zb*wj)+ea(ea(Yb*qj)+ea(qa*Pj)));Uj=ea(ea(gc*uj)+ea(ea(fc*Lj)+ea(ec*Qj)));Vj=ea(ea(pc*tj)+ea(ea(oc*Mj)+ea(nc*Rj)));Wj=ea(ea(Ac*Nj)+ea(ea(zc*Sj)+ea(yc*pj)));Xj=ea(ea(ac*wj)+ea(ea($b*qj)+ea(_b*Pj)));Yj=ea(ea(jc*uj)+ea(ea(ic*Lj)+ea(hc*Qj)));Zj=ea(ea(sc*tj)+ea(ea(rc*Mj)+ea(qc*Rj)));_j=ea(Xb+ea(ea(Nj*Wj)+ea(ea(Sj*Bj)+ea(pj*rj))));$j=ea(Qb+ea(ea(wj*Xj)+ea(ea(qj*Tj)+ea(Pj*xj))));ak=ea(Rb+ea(ea(uj*Yj)+ea(ea(Lj*Uj)+ea(Qj*zj))));bk=ea(Sb+ea(ea(tj*Zj)+ea(ea(Mj*Vj)+ea(Rj*Aj))));ck=ea(Oh+ea(ea(ib*Nj)+ea(ea(hb*Sj)+ea(gb*pj))));dk=ea(Ph+ea(ea(lb*wj)+ea(ea(kb*qj)+ea(jb*Pj))));ek=ea(Qh+ea(ea(ob*uj)+ea(ea(nb*Lj)+ea(mb*Qj))));fk=ea(Rh+ea(ea(rb*tj)+ea(ea(qb*Mj)+ea(pb*Rj))));if(ca){gk=ea(ea(Eh*nj)-ea(Dh*oj));hk=ea(ea(Hh*fj)-ea(Gh*gj));ik=ea(ea(Kh*ij)-ea(Jh*jj));jk=ea(ea(Nh*lj)-ea(Mh*mj));kk=ea(ea(Ch*oj)-ea(Eh*Oj));oj=ea(ea(Fh*gj)-ea(Hh*ej));gj=ea(ea(Ih*jj)-ea(Kh*hj));jj=ea(ea(Lh*mj)-ea(Nh*kj));mj=ea(ea(Dh*Oj)-ea(Ch*nj));nj=ea(ea(Gh*ej)-ea(Fh*fj));fj=ea(ea(Jh*hj)-ea(Ih*ij));ij=ea(ea(Mh*kj)-ea(Lh*lj));lj=ea(ea(cd*mj)+ea(ea(bd*kk)+ea(Bc*gk)));kj=ea(ea(Ec*nj)+ea(ea(Dc*oj)+ea(Cc*hk)));hj=ea(ea(Nc*fj)+ea(ea(Mc*gj)+ea(Lc*ik)));ej=ea(ea(Wc*ij)+ea(ea(Vc*jj)+ea(Uc*jk)));Oj=ea(ea(fd*mj)+ea(ea(ed*kk)+ea(dd*gk)));lk=ea(ea(Hc*nj)+ea(ea(Gc*oj)+ea(Fc*hk)));mk=ea(ea(Qc*fj)+ea(ea(Pc*gj)+ea(Oc*ik)));nk=ea(ea(Zc*ij)+ea(ea(Yc*jj)+ea(Xc*jk)));ok=ea(ea(id*mj)+ea(ea(hd*kk)+ea(gd*gk)));pk=ea(ea(Kc*nj)+ea(ea(Jc*oj)+ea(Ic*hk)));qk=ea(ea(Tc*fj)+ea(ea(Sc*gj)+ea(Rc*ik)));rk=ea(ea(ad*ij)+ea(ea($c*jj)+ea(_c*jk)));sk=ea(_j+ea(Tb+ea(ea(mj*ok)+ea(ea(kk*Oj)+ea(gk*lj)))));tk=ea($j+ea(ua+ea(ea(nj*pk)+ea(ea(oj*lk)+ea(hk*kj)))));uk=ea(ak+ea(ra+ea(ea(fj*qk)+ea(ea(gj*mk)+ea(ik*hj)))));vk=ea(bk+ea(sa+ea(ea(ij*rk)+ea(ea(jj*nk)+ea(jk*ej)))));wk=ea(ck-ea(ea(ub*mj)+ea(ea(tb*kk)+ea(sb*gk))));xk=ea(dk-ea(ea(xb*nj)+ea(ea(wb*oj)+ea(vb*hk))));yk=ea(ek-ea(ea(Ab*fj)+ea(ea(zb*gj)+ea(yb*ik))));zk=ea(fk-ea(ea(Db*ij)+ea(ea(Cb*jj)+ea(Bb*jk))));g[Yi+176>>2]=gk;g[Yi+180>>2]=hk;g[Yi+184>>2]=ik;g[Yi+188>>2]=jk;g[Yi+192>>2]=kk;g[Yi+196>>2]=oj;g[Yi+200>>2]=gj;g[Yi+204>>2]=jj;g[Yi+208>>2]=mj;g[Yi+212>>2]=nj;g[Yi+216>>2]=fj;g[Yi+220>>2]=ij;ij=ea(-kj);kj=ea(-hj);hj=ea(-ej);g[Yi+224>>2]=ea(-lj);g[Yi+228>>2]=ij;g[Yi+232>>2]=kj;g[Yi+236>>2]=hj;hj=ea(-lk);lk=ea(-mk);mk=ea(-nk);g[Yi+240>>2]=ea(-Oj);g[Yi+244>>2]=hj;g[Yi+248>>2]=lk;g[Yi+252>>2]=mk;mk=ea(-pk);pk=ea(-qk);qk=ea(-rk);g[Yi+256>>2]=ea(-ok);g[Yi+260>>2]=mk;g[Yi+264>>2]=pk;g[Yi+268>>2]=qk;Ak=sk;Bk=tk;Ck=uk;Dk=vk;Ek=wk;Fk=xk;Gk=yk;Hk=zk}else{Ak=_j;Bk=$j;Ck=ak;Dk=bk;Ek=ck;Fk=dk;Gk=ek;Hk=fk}cj=Ak>ea(0.0);bj=Bk>ea(0.0);aj=Ck>ea(0.0);$i=Dk>ea(0.0);fk=ea(ea(1.0)/Bk);ek=ea(ea(1.0)/Ck);dk=ea(ea(1.0)/Dk);g[r>>2]=ea(ea(1.0)/Ak);g[m>>2]=fk;g[U>>2]=ek;g[fb>>2]=dk;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;dk=ea(g[(cj?r:q)>>2]);ek=ea(g[(bj?r:q)+4>>2]);fk=ea(g[(aj?r:q)+8>>2]);ck=ea(g[($i?r:q)+12>>2]);bk=ea(Cj-Ea);Cj=ea(Dj-ja);Dj=ea(Ej-ka);Ej=ea(Fj-la);Fj=ea(ga*bk);ak=ea(ga*Cj);$j=ea(ga*Dj);_j=ea(ga*Ej);$i=ea(bk*j)<ea(-Ek)&(Ek<k&jh);aj=ea(Cj*j)<ea(-Fk)&(Fk<k&ih);bj=ea(Dj*j)<ea(-Gk)&(Gk<k&Vh);cj=ea(Ej*j)<ea(-Hk)&(Hk<k&hh);Ej=ea(-ea((Fa>Fj?Fa:Fj)*dk));Fj=ea(-ea((za>ak?za:ak)*ek));ak=ea(-ea((Aa>$j?Aa:$j)*fk));$j=ea(-ea((Ca>_j?Ca:_j)*ck));c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[s>>2]=Ej;g[Da>>2]=Fj;g[bb>>2]=ak;g[Za>>2]=$j;$j=ea(g[($i?t:s)>>2]);ak=ea(g[(aj?t:s)+4>>2]);Fj=ea(g[(bj?t:s)+8>>2]);Ej=ea(g[(cj?t:s)+12>>2]);_j=ea(ea(Ek*sh)*dk);Dj=ea(ea(Fk*th)*ek);Cj=ea(ea(Gk*uh)*fk);bk=ea(ea(Hk*vh)*ck);g[Yi>>2]=pj;g[Yi+4>>2]=Pj;g[Yi+8>>2]=Qj;g[Yi+12>>2]=Rj;g[Yi+16>>2]=Sj;g[Yi+20>>2]=qj;g[Yi+24>>2]=Lj;g[Yi+28>>2]=Mj;g[Yi+32>>2]=Nj;g[Yi+36>>2]=wj;g[Yi+40>>2]=uj;g[Yi+44>>2]=tj;g[Yi+96>>2]=dk;g[Yi+100>>2]=ek;g[Yi+104>>2]=fk;g[Yi+108>>2]=ck;dj=Yi+112|0;c[dj+0>>2]=0;c[dj+4>>2]=0;c[dj+8>>2]=0;c[dj+12>>2]=0;g[v>>2]=_j;g[Va>>2]=Dj;g[Ra>>2]=Cj;g[O>>2]=bk;g[u>>2]=$j;g[S>>2]=ak;g[X>>2]=Fj;g[$>>2]=Ej;bk=ea(g[($i?v:u)>>2]);Cj=ea(g[(aj?v:u)+4>>2]);Dj=ea(g[(bj?v:u)+8>>2]);_j=ea(sj+Cj);Cj=ea(vj+Dj);Dj=ea(yj+ea(g[(cj?v:u)+12>>2]));g[Yi+144>>2]=ea(Kj+bk);g[Yi+148>>2]=_j;g[Yi+152>>2]=Cj;g[Yi+156>>2]=Dj;cj=$j<=ea(0.0);bj=ak<=ea(0.0);aj=Fj<=ea(0.0);$i=Ej<=ea(0.0);c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[w>>2]=$j;g[fe>>2]=ak;g[ge>>2]=Fj;g[he>>2]=Ej;Ej=ea(g[(cj?x:w)>>2]);Fj=ea(g[(bj?x:w)+4>>2]);ak=ea(g[(aj?x:w)+8>>2]);$j=ea(g[($i?x:w)+12>>2]);g[Yi+128>>2]=Ej;g[Yi+132>>2]=Fj;g[Yi+136>>2]=ak;g[Yi+140>>2]=$j;g[Yi+160>>2]=Gj;g[Yi+164>>2]=Hj;g[Yi+168>>2]=Ij;g[Yi+172>>2]=Jj;g[Yi+48>>2]=rj;g[Yi+52>>2]=xj;g[Yi+56>>2]=zj;g[Yi+60>>2]=Aj;g[Yi+64>>2]=Bj;g[Yi+68>>2]=Tj;g[Yi+72>>2]=Uj;g[Yi+76>>2]=Vj;g[Yi+80>>2]=Wj;g[Yi+84>>2]=Xj;g[Yi+88>>2]=Yj;g[Yi+92>>2]=Zj;if(!(Ri&1)){$i=Mi+1|0;do if((Wi|0)==65535){Ik=0;Jk=$i;Kk=65535}else{aj=$i;bj=Wi;while(1){if((aj|0)!=(e[f+(bj*12|0)+4498>>1]|0)){Lk=aj;Mk=bj;break}cj=b[f+(bj*12|0)+4500>>1]|0;dj=cj&65535;if(cj<<16>>16==-1){Lk=0;Mk=dj;break}else{aj=0;bj=dj}}if((Mk|0)==65535){Ik=0;Jk=Lk;Kk=65535;break}Ik=Lk>>>0<(e[f+(Mk*12|0)+4498>>1]|0)>>>0;Jk=Lk;Kk=Mk}while(0);Nk=Mi;Ok=Jk;Pk=Ik&1^1|Ri;Qk=Kk;Rk=Wi}else{Nk=Ji;Ok=Mi;Pk=Ri;Qk=Wi;Rk=Xi}if(!(Ri&2)){$i=Ni+1|0;do if((Ui|0)==65535){Sk=0;Tk=$i;Uk=65535}else{bj=$i;aj=Ui;while(1){if((bj|0)!=(e[f+(aj*12|0)+4498>>1]|0)){Vk=bj;Wk=aj;break}dj=b[f+(aj*12|0)+4500>>1]|0;cj=dj&65535;if(dj<<16>>16==-1){Vk=0;Wk=cj;break}else{bj=0;aj=cj}}if((Wk|0)==65535){Sk=0;Tk=Vk;Uk=65535;break}Sk=Vk>>>0<(e[f+(Wk*12|0)+4498>>1]|0)>>>0;Tk=Vk;Uk=Wk}while(0);Xk=Ni;Yk=Tk;Zk=(Sk&1)<<1^2|Pk;_k=Uk;$k=Ui}else{Xk=Ki;Yk=Ni;Zk=Pk;_k=Ui;$k=Vi}if(!(Ri&4)){$i=Oi+1|0;do if((Si|0)==65535){al=0;bl=$i;cl=65535}else{aj=$i;bj=Si;while(1){if((aj|0)!=(e[f+(bj*12|0)+4498>>1]|0)){dl=aj;el=bj;break}cj=b[f+(bj*12|0)+4500>>1]|0;dj=cj&65535;if(cj<<16>>16==-1){dl=0;el=dj;break}else{aj=0;bj=dj}}if((el|0)==65535){al=0;bl=dl;cl=65535;break}al=dl>>>0<(e[f+(el*12|0)+4498>>1]|0)>>>0;bl=dl;cl=el}while(0);fl=Oi;gl=bl;hl=(al&1)<<2^4|Zk;il=cl;jl=Si}else{fl=Li;gl=Oi;hl=Zk;il=Si;jl=Ti}if(!(Ri&8))break;else{$i=Ri;Ji=Nk;Ki=Xk;Li=fl;Mi=Ok;Ni=Yk;Oi=gl;Pi=Zi;Ri=hl;Si=il;Ti=jl;Ui=_k;Vi=$k;Wi=Qk;Xi=Rk;Yi=_i;Qi=$i}}Qi=vi+1|0;do if((Fi|0)==65535){kl=0;ll=Qi;ml=65535}else{Wi=Qi;Ui=Fi;while(1){if((Wi|0)!=(e[f+(Ui*12|0)+4498>>1]|0)){nl=Wi;ol=Ui;break}Si=b[f+(Ui*12|0)+4500>>1]|0;Oi=Si&65535;if(Si<<16>>16==-1){nl=0;ol=Oi;break}else{Wi=0;Ui=Oi}}if((ol|0)==65535){kl=0;ll=nl;ml=65535;break}kl=nl>>>0<(e[f+(ol*12|0)+4498>>1]|0)>>>0;ll=nl;ml=ol}while(0);Qi=Fi;Ui=vi;gh=Nk;Th=Xk;Uh=fl;si=Ok;ti=Yk;ui=gl;vi=ll;wi=Zi;xi=Ri;yi=(kl&1)<<3^8|hl;zi=il;Ai=jl;Bi=_k;Ci=$k;Di=Qk;Ei=Rk;Fi=ml;Hi=_i;Gi=Qi;ri=Ui}vh=ea(g[f+(kh<<6)+428>>2]);uh=ea(g[f+(lh<<6)+428>>2]);th=ea(g[f+(mh<<6)+428>>2]);sh=ea(g[f+(nh<<6)+428>>2]);rh=ea(g[f+(kh<<6)+440>>2]);qh=ea(g[f+(lh<<6)+440>>2]);ph=ea(g[f+(mh<<6)+440>>2]);oh=ea(g[f+(nh<<6)+440>>2]);a[Wg+1>>0]=Pi;a[xh>>0]=ch;a[yh>>0]=dh;a[zh>>0]=eh;a[Ah>>0]=fh;g[Wg+48>>2]=rh;g[Wg+52>>2]=qh;g[Wg+56>>2]=ph;g[Wg+60>>2]=oh;g[Wg+32>>2]=vh;g[Wg+36>>2]=uh;g[Wg+40>>2]=th;g[Wg+44>>2]=sh;if(h)pl=0;else pl=(c[f+(kh<<6)+436>>2]&1|0)!=0?0:e[f+(_g*96|0)+5280>>1]|0;if(Xg)ql=0;else ql=(c[f+(lh<<6)+436>>2]&1|0)!=0?0:e[f+($g*96|0)+5280>>1]|0;if(Yg)rl=0;else rl=(c[f+(mh<<6)+436>>2]&1|0)!=0?0:e[f+(ah*96|0)+5280>>1]|0;if(Zg)sl=0;else sl=(c[f+(nh<<6)+436>>2]&1|0)!=0?0:e[f+(bh*96|0)+5280>>1]|0;Hi=rl>>>0<sl>>>0?sl:rl;Fi=ql>>>0<Hi>>>0?Hi:ql;Hi=pl>>>0<Fi>>>0?Fi:pl;a[Wg+2>>0]=Hi<<1;a[Wg+12>>0]=pl<<1;a[Wg+13>>0]=ql<<1;a[Wg+14>>0]=rl<<1;a[Wg+15>>0]=sl<<1;a[Wg>>0]=ie;sh=ea(-Ch);th=ea(-Fh);uh=ea(-Ih);vh=ea(-Lh);Fi=(Ch>sh?Ch:sh)<ea(.707106769);Ei=(Fh>th?Fh:th)<ea(.707106769);Di=(Ih>uh?Ih:uh)<ea(.707106769);Ci=(Lh>vh?Lh:vh)<ea(.707106769);vh=ea(-Dh);uh=ea(-Gh);th=ea(-Jh);sh=ea(-Mh);c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;g[y>>2]=vh;g[je>>2]=uh;g[ke>>2]=th;g[le>>2]=sh;sh=ea(g[(Fi?z:y)>>2]);th=ea(g[(Ei?z:y)+4>>2]);uh=ea(g[(Di?z:y)+8>>2]);vh=ea(g[(Ci?z:y)+12>>2]);oh=ea(-Hh);ph=ea(-Kh);qh=ea(-Nh);g[B>>2]=ea(-Eh);g[me>>2]=oh;g[ne>>2]=ph;g[oe>>2]=qh;g[A>>2]=Ch;g[pe>>2]=Fh;g[qe>>2]=Ih;g[re>>2]=Lh;qh=ea(g[(Fi?B:A)>>2]);ph=ea(g[(Ei?B:A)+4>>2]);oh=ea(g[(Di?B:A)+8>>2]);rh=ea(g[(Ci?B:A)+12>>2]);g[D>>2]=Dh;g[se>>2]=Gh;g[te>>2]=Jh;g[ue>>2]=Mh;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;Zj=ea(g[(Fi?D:C)>>2]);Yj=ea(g[(Ei?D:C)+4>>2]);Xj=ea(g[(Di?D:C)+8>>2]);Wj=ea(g[(Ci?D:C)+12>>2]);Vj=ea(Eb-ea(Ch*Oh));Uj=ea(Fb-ea(Fh*Ph));Tj=ea(Gb-ea(Ih*Qh));Bj=ea(Hb-ea(Lh*Rh));Aj=ea(Ib-ea(Dh*Oh));zj=ea(Jb-ea(Gh*Ph));xj=ea(Kb-ea(Jh*Qh));rj=ea(Lb-ea(Mh*Rh));Jj=ea(Mb-ea(Eh*Oh));Ij=ea(Nb-ea(Hh*Ph));Hj=ea(Ob-ea(Kh*Qh));Gj=ea(Pb-ea(Nh*Rh));Ci=ea(ea(Vj*Vj)+ea(ea(Aj*Aj)+ea(Jj*Jj)))>ea(.100000001);Di=ea(ea(Uj*Uj)+ea(ea(zj*zj)+ea(Ij*Ij)))>ea(.100000001);Ei=ea(ea(Tj*Tj)+ea(ea(xj*xj)+ea(Hj*Hj)))>ea(.100000001);Fi=ea(ea(Bj*Bj)+ea(ea(rj*rj)+ea(Gj*Gj)))>ea(.100000001);g[F>>2]=Vj;g[ve>>2]=Uj;g[we>>2]=Tj;g[xe>>2]=Bj;g[E>>2]=sh;g[ye>>2]=th;g[ze>>2]=uh;g[Ae>>2]=vh;vh=ea(g[(Ci?F:E)>>2]);uh=ea(g[(Di?F:E)+4>>2]);th=ea(g[(Ei?F:E)+8>>2]);sh=ea(g[(Fi?F:E)+12>>2]);g[H>>2]=Aj;g[Be>>2]=zj;g[Ce>>2]=xj;g[De>>2]=rj;g[G>>2]=qh;g[Ee>>2]=ph;g[Fe>>2]=oh;g[Ge>>2]=rh;rh=ea(g[(Ci?H:G)>>2]);oh=ea(g[(Di?H:G)+4>>2]);ph=ea(g[(Ei?H:G)+8>>2]);qh=ea(g[(Fi?H:G)+12>>2]);g[J>>2]=Jj;g[He>>2]=Ij;g[Ie>>2]=Hj;g[Je>>2]=Gj;g[I>>2]=Zj;g[Ke>>2]=Yj;g[Le>>2]=Xj;g[Me>>2]=Wj;Wj=ea(g[(Ci?J:I)>>2]);Xj=ea(g[(Di?J:I)+4>>2]);Yj=ea(g[(Ei?J:I)+8>>2]);Zj=ea(g[(Fi?J:I)+12>>2]);Gj=ea(ea(1.0)/ea(T(ea(ea(ea(vh*vh)+ea(rh*rh))+ea(Wj*Wj)))));Hj=ea(ea(1.0)/ea(T(ea(ea(ea(uh*uh)+ea(oh*oh))+ea(Xj*Xj)))));Ij=ea(ea(1.0)/ea(T(ea(ea(ea(th*th)+ea(ph*ph))+ea(Yj*Yj)))));Jj=ea(ea(1.0)/ea(T(ea(ea(ea(sh*sh)+ea(qh*qh))+ea(Zj*Zj)))));rj=ea(vh*Gj);vh=ea(uh*Hj);uh=ea(th*Ij);th=ea(sh*Jj);sh=ea(rh*Gj);rh=ea(oh*Hj);oh=ea(ph*Ij);ph=ea(qh*Jj);qh=ea(Wj*Gj);Gj=ea(Xj*Hj);Hj=ea(Yj*Ij);Ij=ea(Zj*Jj);Jj=ea(ea(Dh*qh)-ea(Eh*sh));Zj=ea(ea(Gh*Gj)-ea(Hh*rh));Yj=ea(ea(Jh*Hj)-ea(Kh*oh));Xj=ea(ea(Mh*Ij)-ea(Nh*ph));Wj=ea(ea(Eh*rj)-ea(Ch*qh));xj=ea(ea(Hh*vh)-ea(Fh*Gj));zj=ea(ea(Kh*uh)-ea(Ih*Hj));Aj=ea(ea(Nh*th)-ea(Lh*Ij));Bj=ea(ea(Ch*sh)-ea(Dh*rj));Tj=ea(ea(Fh*rh)-ea(Gh*vh));Uj=ea(ea(Ih*oh)-ea(Jh*uh));Vj=ea(ea(Lh*ph)-ea(Mh*th));Fi=Rg*96|0;Ei=(c[(c[d>>2]|0)+40>>2]|0)+Fi|0;Di=(c[(c[R>>2]|0)+40>>2]|0)+Fi|0;Ci=(c[(c[W>>2]|0)+40>>2]|0)+Fi|0;Bi=(c[(c[_>>2]|0)+40>>2]|0)+Fi|0;if(!Hi)tl=Yi;else{Fi=f+(kh<<6)+416|0;Ai=Fi+4|0;zi=Fi+8|0;yi=f+(lh<<6)+416|0;xi=yi+4|0;wi=yi+8|0;vi=f+(mh<<6)+416|0;ui=vi+4|0;ti=vi+8|0;si=f+(nh<<6)+416|0;Uh=si+4|0;Th=si+8|0;gh=rl>>>0>sl>>>0?rl:sl;hh=gh>>>0>ql>>>0?gh:ql;gh=hh>>>0>pl>>>0?hh:pl;if(ca){$j=ea(1.0);ak=ea(1.0);Fj=ea(1.0);Ej=ea(1.0);Dj=rj;Cj=vh;_j=uh;bk=th;Kj=sh;yj=rh;vj=oh;sj=ph;ck=qh;fk=Gj;ek=Hj;dk=Ij;tj=Jj;uj=Zj;wj=Yj;Nj=Xj;Mj=Wj;Lj=xj;qj=zj;Sj=Aj;Rj=Bj;Qj=Tj;Pj=Uj;pj=Vj;hh=0;Vh=0;ih=0;jh=0;wh=0;Bh=Yi;while(1){Ui=wh>>>0<pl>>>0;hh=Ui?wh:hh;Qi=wh>>>0<ql>>>0;Vh=Qi?wh:Vh;Wi=wh>>>0<rl>>>0;ih=Wi?wh:ih;Oi=wh>>>0<sl>>>0;jh=Oi?wh:jh;$j=Ui?$j:ea(0.0);ak=Qi?ak:ea(0.0);Fj=Wi?Fj:ea(0.0);Ej=Oi?Ej:ea(0.0);Dj=ea(Dj*$j);Cj=ea(Cj*ak);_j=ea(_j*Fj);bk=ea(bk*Ej);Kj=ea(Kj*$j);yj=ea(yj*ak);vj=ea(vj*Fj);sj=ea(sj*Ej);ck=ea(ck*$j);fk=ea(fk*ak);ek=ea(ek*Fj);dk=ea(dk*Ej);tj=ea(tj*$j);uj=ea(uj*ak);wj=ea(wj*Fj);Nj=ea(Nj*Ej);Mj=ea(Mj*$j);Lj=ea(Lj*ak);qj=ea(qj*Fj);Sj=ea(Sj*Ej);Rj=ea(Rj*$j);Qj=ea(Qj*ak);Pj=ea(Pj*Fj);pj=ea(pj*Ej);zk=ea(g[f+(_g*96|0)+(hh*12|0)+5312>>2]);yk=ea(g[f+(_g*96|0)+(hh*12|0)+5316>>2]);xk=ea(g[f+(_g*96|0)+(hh*12|0)+5320>>2]);wk=ea(g[f+($g*96|0)+(Vh*12|0)+5312>>2]);vk=ea(g[f+($g*96|0)+(Vh*12|0)+5316>>2]);uk=ea(g[f+($g*96|0)+(Vh*12|0)+5320>>2]);tk=ea(g[f+(ah*96|0)+(ih*12|0)+5312>>2]);sk=ea(g[f+(ah*96|0)+(ih*12|0)+5316>>2]);qk=ea(g[f+(ah*96|0)+(ih*12|0)+5320>>2]);pk=ea(g[f+(bh*96|0)+(jh*12|0)+5312>>2]);mk=ea(g[f+(bh*96|0)+(jh*12|0)+5316>>2]);ok=ea(g[f+(bh*96|0)+(jh*12|0)+5320>>2]);rk=ea(ea(ea(Bd*zk)+ea(Cd*yk))+ea(Dd*xk));lk=ea(ea(ea(Bd*rk)+ea(ea(Oe*zk)+ea(Ed*ea(ea(Cd*xk)-ea(Dd*yk)))))*ea(2.0));hj=ea(ea(ea(Cd*rk)+ea(ea(Oe*yk)+ea(Ed*ea(ea(Dd*zk)-ea(Bd*xk)))))*ea(2.0));Oj=ea(ea(ea(ea(Oe*xk)+ea(Ed*ea(ea(Bd*yk)-ea(Cd*zk))))+ea(Dd*rk))*ea(2.0));rk=ea(ea(ea(Fd*wk)+ea(Gd*vk))+ea(Hd*uk));zk=ea(ea(ea(Fd*rk)+ea(ea(Pe*wk)+ea(Id*ea(ea(Gd*uk)-ea(Hd*vk)))))*ea(2.0));yk=ea(ea(ea(Gd*rk)+ea(ea(Pe*vk)+ea(Id*ea(ea(Hd*wk)-ea(Fd*uk)))))*ea(2.0));xk=ea(ea(ea(ea(Pe*uk)+ea(Id*ea(ea(Fd*vk)-ea(Gd*wk))))+ea(Hd*rk))*ea(2.0));rk=ea(ea(ea(Jd*tk)+ea(Kd*sk))+ea(Ld*qk));wk=ea(ea(ea(Jd*rk)+ea(ea(Qe*tk)+ea(Md*ea(ea(Kd*qk)-ea(Ld*sk)))))*ea(2.0));vk=ea(ea(ea(Kd*rk)+ea(ea(Qe*sk)+ea(Md*ea(ea(Ld*tk)-ea(Jd*qk)))))*ea(2.0));uk=ea(ea(ea(ea(Qe*qk)+ea(Md*ea(ea(Jd*sk)-ea(Kd*tk))))+ea(Ld*rk))*ea(2.0));rk=ea(ea(ea(Nd*pk)+ea(Od*mk))+ea(Pd*ok));tk=ea(ea(ea(Nd*rk)+ea(ea(Re*pk)+ea(Qd*ea(ea(Od*ok)-ea(Pd*mk)))))*ea(2.0));sk=ea(ea(ea(Od*rk)+ea(ea(Re*mk)+ea(Qd*ea(ea(Pd*pk)-ea(Nd*ok)))))*ea(2.0));qk=ea(ea(ea(ea(Re*ok)+ea(Qd*ea(ea(Nd*mk)-ea(Od*pk))))+ea(Pd*rk))*ea(2.0));rk=ea(ha+lk);pk=ea(xa+zk);mk=ea(ya+wk);ok=ea(md+tk);nk=ea(ia+hj);kj=ea(wa+yk);ij=ea(kd+vk);lj=ea(nd+sk);ej=ea(fa+Oj);fj=ea(va+xk);nj=ea(ld+uk);mj=ea(od+qk);jj=ea(g[f+(_g*96|0)+(hh*12|0)+5336>>2]);gj=ea(g[f+(_g*96|0)+(hh*12|0)+5340>>2]);oj=ea(g[f+(_g*96|0)+(hh*12|0)+5344>>2]);kk=ea(g[f+($g*96|0)+(Vh*12|0)+5336>>2]);jk=ea(g[f+($g*96|0)+(Vh*12|0)+5340>>2]);ik=ea(g[f+($g*96|0)+(Vh*12|0)+5344>>2]);hk=ea(g[f+(ah*96|0)+(ih*12|0)+5336>>2]);gk=ea(g[f+(ah*96|0)+(ih*12|0)+5340>>2]);ul=ea(g[f+(ah*96|0)+(ih*12|0)+5344>>2]);vl=ea(g[f+(bh*96|0)+(jh*12|0)+5336>>2]);wl=ea(g[f+(bh*96|0)+(jh*12|0)+5340>>2]);xl=ea(g[f+(bh*96|0)+(jh*12|0)+5344>>2]);yl=ea(ea(ea(Rd*jj)+ea(Sd*gj))+ea(Td*oj));zl=ea(ea(ea(Rd*yl)+ea(ea(Se*jj)+ea(Ud*ea(ea(Sd*oj)-ea(Td*gj)))))*ea(2.0));Al=ea(ea(ea(Sd*yl)+ea(ea(Se*gj)+ea(Ud*ea(ea(Td*jj)-ea(Rd*oj)))))*ea(2.0));Bl=ea(ea(ea(ea(Se*oj)+ea(Ud*ea(ea(Rd*gj)-ea(Sd*jj))))+ea(Td*yl))*ea(2.0));yl=ea(ea(ea(Vd*kk)+ea(Wd*jk))+ea(Xd*ik));jj=ea(ea(ea(Vd*yl)+ea(ea(Te*kk)+ea(Yd*ea(ea(Wd*ik)-ea(Xd*jk)))))*ea(2.0));gj=ea(ea(ea(Wd*yl)+ea(ea(Te*jk)+ea(Yd*ea(ea(Xd*kk)-ea(Vd*ik)))))*ea(2.0));oj=ea(ea(ea(ea(Te*ik)+ea(Yd*ea(ea(Vd*jk)-ea(Wd*kk))))+ea(Xd*yl))*ea(2.0));yl=ea(ea(ea(Zd*hk)+ea(_d*gk))+ea($d*ul));kk=ea(ea(ea(Zd*yl)+ea(ea(Ue*hk)+ea(ae*ea(ea(_d*ul)-ea($d*gk)))))*ea(2.0));jk=ea(ea(ea(_d*yl)+ea(ea(Ue*gk)+ea(ae*ea(ea($d*hk)-ea(Zd*ul)))))*ea(2.0));ik=ea(ea(ea(ea(Ue*ul)+ea(ae*ea(ea(Zd*gk)-ea(_d*hk))))+ea($d*yl))*ea(2.0));yl=ea(ea(ea(be*vl)+ea(ce*wl))+ea(de*xl));hk=ea(ea(ea(be*yl)+ea(ea(Ve*vl)+ea(ee*ea(ea(ce*xl)-ea(de*wl)))))*ea(2.0));gk=ea(ea(ea(ce*yl)+ea(ea(Ve*wl)+ea(ee*ea(ea(de*vl)-ea(be*xl)))))*ea(2.0));ul=ea(ea(ea(ea(Ve*xl)+ea(ee*ea(ea(be*wl)-ea(ce*vl))))+ea(de*yl))*ea(2.0));yl=ea(rk-ea(pd+zl));rk=ea(pk-ea(sd+jj));pk=ea(mk-ea(vd+kk));mk=ea(ok-ea(yd+hk));ok=ea(nk-ea(qd+Al));nk=ea(kj-ea(td+gj));kj=ea(ij-ea(wd+jk));ij=ea(lj-ea(zd+gk));lj=ea(ej-ea(rd+Bl));ej=ea(fj-ea(ud+oj));fj=ea(nj-ea(xd+ik));nj=ea(mj-ea(Ad+ul));mj=ea(ea(ck*hj)-ea(Kj*Oj));vl=ea(ea(fk*yk)-ea(yj*xk));wl=ea(ea(ek*vk)-ea(vj*uk));xl=ea(ea(dk*sk)-ea(sj*qk));Cl=ea(ea(Dj*Oj)-ea(ck*lk));Dl=ea(ea(Cj*xk)-ea(fk*zk));El=ea(ea(_j*uk)-ea(ek*wk));Fl=ea(ea(bk*qk)-ea(dk*tk));Gl=ea(ea(Kj*lk)-ea(Dj*hj));Hl=ea(ea(yj*zk)-ea(Cj*yk));Il=ea(ea(vj*wk)-ea(_j*vk));Jl=ea(ea(sj*tk)-ea(bk*sk));Kl=ea(ea(uc*Gl)+ea(ea(tc*Cl)+ea(jd*mj)));Ll=ea(ea(na*Hl)+ea(ea(oa*Dl)+ea(pa*vl)));Ml=ea(ea(dc*Il)+ea(ea(cc*El)+ea(bc*wl)));Nl=ea(ea(mc*Jl)+ea(ea(lc*Fl)+ea(kc*xl)));Ol=ea(ea(xc*Gl)+ea(ea(wc*Cl)+ea(vc*mj)));Pl=ea(ea(Zb*Hl)+ea(ea(Yb*Dl)+ea(qa*vl)));Ql=ea(ea(gc*Il)+ea(ea(fc*El)+ea(ec*wl)));Rl=ea(ea(pc*Jl)+ea(ea(oc*Fl)+ea(nc*xl)));Sl=ea(ea(Ac*Gl)+ea(ea(zc*Cl)+ea(yc*mj)));Tl=ea(ea(ac*Hl)+ea(ea($b*Dl)+ea(_b*vl)));Ul=ea(ea(jc*Il)+ea(ea(ic*El)+ea(hc*wl)));Vl=ea(ea(sc*Jl)+ea(ea(rc*Fl)+ea(qc*xl)));Wl=ea(ea(ck*Al)-ea(Kj*Bl));Xl=ea(ea(fk*gj)-ea(yj*oj));Yl=ea(ea(ek*jk)-ea(vj*ik));Zl=ea(ea(dk*gk)-ea(sj*ul));_l=ea(ea(Dj*Bl)-ea(ck*zl));$l=ea(ea(Cj*oj)-ea(fk*jj));am=ea(ea(_j*ik)-ea(ek*kk));bm=ea(ea(bk*ul)-ea(dk*hk));cm=ea(ea(Kj*zl)-ea(Dj*Al));dm=ea(ea(yj*jj)-ea(Cj*gj));em=ea(ea(vj*kk)-ea(_j*jk));fm=ea(ea(sj*hk)-ea(bk*gk));gm=ea(ea(cd*cm)+ea(ea(bd*_l)+ea(Bc*Wl)));hm=ea(ea(Ec*dm)+ea(ea(Dc*$l)+ea(Cc*Xl)));im=ea(ea(Nc*em)+ea(ea(Mc*am)+ea(Lc*Yl)));jm=ea(ea(Wc*fm)+ea(ea(Vc*bm)+ea(Uc*Zl)));km=ea(ea(fd*cm)+ea(ea(ed*_l)+ea(dd*Wl)));lm=ea(ea(Hc*dm)+ea(ea(Gc*$l)+ea(Fc*Xl)));mm=ea(ea(Qc*em)+ea(ea(Pc*am)+ea(Oc*Yl)));nm=ea(ea(Zc*fm)+ea(ea(Yc*bm)+ea(Xc*Zl)));om=ea(ea(id*cm)+ea(ea(hd*_l)+ea(gd*Wl)));pm=ea(ea(Kc*dm)+ea(ea(Jc*$l)+ea(Ic*Xl)));qm=ea(ea(Tc*em)+ea(ea(Sc*am)+ea(Rc*Yl)));rm=ea(ea(ad*fm)+ea(ea($c*bm)+ea(_c*Zl)));sm=ea(ea(Xb+ea(ea(Gl*Sl)+ea(ea(Cl*Ol)+ea(mj*Kl))))+ea(Tb+ea(ea(cm*om)+ea(ea(_l*km)+ea(Wl*gm)))));tm=ea(ea(Qb+ea(ea(Hl*Tl)+ea(ea(Dl*Pl)+ea(vl*Ll))))+ea(ua+ea(ea(dm*pm)+ea(ea($l*lm)+ea(Xl*hm)))));um=ea(ea(Rb+ea(ea(Il*Ul)+ea(ea(El*Ql)+ea(wl*Ml))))+ea(ra+ea(ea(em*qm)+ea(ea(am*mm)+ea(Yl*im)))));vm=ea(ea(Sb+ea(ea(Jl*Vl)+ea(ea(Fl*Rl)+ea(xl*Nl))))+ea(sa+ea(ea(fm*rm)+ea(ea(bm*nm)+ea(Zl*jm)))));g[Bh+240>>2]=Wl;g[Bh+244>>2]=Xl;g[Bh+248>>2]=Yl;g[Bh+252>>2]=Zl;g[Bh+256>>2]=_l;g[Bh+260>>2]=$l;g[Bh+264>>2]=am;g[Bh+268>>2]=bm;g[Bh+272>>2]=cm;g[Bh+276>>2]=dm;g[Bh+280>>2]=em;g[Bh+284>>2]=fm;fm=ea(-hm);hm=ea(-im);im=ea(-jm);g[Bh+288>>2]=ea(-gm);g[Bh+292>>2]=fm;g[Bh+296>>2]=hm;g[Bh+300>>2]=im;im=ea(-lm);lm=ea(-mm);mm=ea(-nm);g[Bh+304>>2]=ea(-km);g[Bh+308>>2]=im;g[Bh+312>>2]=lm;g[Bh+316>>2]=mm;mm=ea(-pm);pm=ea(-qm);qm=ea(-rm);g[Bh+320>>2]=ea(-om);g[Bh+324>>2]=mm;g[Bh+328>>2]=pm;g[Bh+332>>2]=qm;Si=sm>ea(0.0);Ni=tm>ea(0.0);Mi=um>ea(0.0);Ii=vm>ea(0.0);qm=ea(ea(.800000011)/tm);tm=ea(ea(.800000011)/um);um=ea(ea(.800000011)/vm);g[L>>2]=ea(ea(.800000011)/sm);g[We>>2]=qm;g[Xe>>2]=tm;g[Ye>>2]=um;c[K+0>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;c[K+12>>2]=0;um=ea(g[(Si?L:K)>>2]);tm=ea(g[(Ni?L:K)+4>>2]);qm=ea(g[(Mi?L:K)+8>>2]);sm=ea(g[(Ii?L:K)+12>>2]);vm=ea(g[Fi>>2]);pm=ea(g[Ai>>2]);mm=ea(g[zi>>2]);om=ea(g[yi>>2]);rm=ea(g[xi>>2]);lm=ea(g[wi>>2]);im=ea(g[vi>>2]);km=ea(g[ui>>2]);nm=ea(g[ti>>2]);hm=ea(g[si>>2]);fm=ea(g[Uh>>2]);gm=ea(um*ea(ea(ck*mm)+ea(ea(Dj*vm)+ea(Kj*pm))));pm=ea(tm*ea(ea(fk*lm)+ea(ea(Cj*om)+ea(yj*rm))));rm=ea(qm*ea(ea(ek*nm)+ea(ea(_j*im)+ea(vj*km))));km=ea(sm*ea(ea(dk*ea(g[Th>>2]))+ea(ea(bk*hm)+ea(sj*fm))));fm=ea(ea(ea(ea(ck*lj)+ea(ea(Kj*ok)+ea(Dj*yl)))*j)*um);hm=ea(ea(ea(ea(fk*ej)+ea(ea(yj*nk)+ea(Cj*rk)))*j)*tm);im=ea(ea(ea(ea(ek*fj)+ea(ea(vj*kj)+ea(_j*pk)))*j)*qm);nm=ea(ea(ea(ea(dk*nj)+ea(ea(sj*ij)+ea(bk*mk)))*j)*sm);om=ea(ak*Cj);lm=ea(Fj*_j);vm=ea(Ej*bk);g[Bh>>2]=ea($j*Dj);g[Bh+4>>2]=om;g[Bh+8>>2]=lm;g[Bh+12>>2]=vm;vm=ea(ak*yj);lm=ea(Fj*vj);om=ea(Ej*sj);g[Bh+16>>2]=ea($j*Kj);g[Bh+20>>2]=vm;g[Bh+24>>2]=lm;g[Bh+28>>2]=om;om=ea(ak*fk);lm=ea(Fj*ek);vm=ea(Ej*dk);g[Bh+32>>2]=ea($j*ck);g[Bh+36>>2]=om;g[Bh+40>>2]=lm;g[Bh+44>>2]=vm;Ii=Bh+48|0;c[Ii+0>>2]=0;c[Ii+4>>2]=0;c[Ii+8>>2]=0;c[Ii+12>>2]=0;g[Bh+64>>2]=mj;g[Bh+68>>2]=vl;g[Bh+72>>2]=wl;g[Bh+76>>2]=xl;g[Bh+80>>2]=Cl;g[Bh+84>>2]=Dl;g[Bh+88>>2]=El;g[Bh+92>>2]=Fl;g[Bh+96>>2]=Gl;g[Bh+100>>2]=Hl;g[Bh+104>>2]=Il;g[Bh+108>>2]=Jl;g[Bh+112>>2]=Kl;g[Bh+116>>2]=Ll;g[Bh+120>>2]=Ml;g[Bh+124>>2]=Nl;g[Bh+128>>2]=Ol;g[Bh+132>>2]=Pl;g[Bh+136>>2]=Ql;g[Bh+140>>2]=Rl;g[Bh+144>>2]=Sl;g[Bh+148>>2]=Tl;g[Bh+152>>2]=Ul;g[Bh+156>>2]=Vl;Vl=ea(hm-pm);pm=ea(im-rm);rm=ea(nm-km);g[Bh+160>>2]=ea(fm-gm);g[Bh+164>>2]=Vl;g[Bh+168>>2]=pm;g[Bh+172>>2]=rm;Ii=Bh+176|0;c[Ii+0>>2]=0;c[Ii+4>>2]=0;c[Ii+8>>2]=0;c[Ii+12>>2]=0;g[Bh+192>>2]=fm;g[Bh+196>>2]=hm;g[Bh+200>>2]=im;g[Bh+204>>2]=nm;g[Bh+208>>2]=um;g[Bh+212>>2]=tm;g[Bh+216>>2]=qm;g[Bh+220>>2]=sm;Ii=Ui?Ei:0;c[Bh+224>>2]=Ii;Ui=Qi?Di:0;c[Bh+228>>2]=Ui;Qi=Wi?Ci:0;c[Bh+232>>2]=Qi;Wi=Oi?Bi:0;c[Bh+236>>2]=Wi;sm=ea(ea(Rj*hj)-ea(Mj*Oj));qm=ea(ea(Qj*yk)-ea(Lj*xk));tm=ea(ea(Pj*vk)-ea(qj*uk));um=ea(ea(pj*sk)-ea(Sj*qk));nm=ea(ea(tj*Oj)-ea(Rj*lk));Oj=ea(ea(uj*xk)-ea(Qj*zk));xk=ea(ea(wj*uk)-ea(Pj*wk));uk=ea(ea(Nj*qk)-ea(pj*tk));qk=ea(ea(Mj*lk)-ea(tj*hj));hj=ea(ea(Lj*zk)-ea(uj*yk));yk=ea(ea(qj*wk)-ea(wj*vk));vk=ea(ea(Sj*tk)-ea(Nj*sk));sk=ea(ea(uc*qk)+ea(ea(tc*nm)+ea(jd*sm)));tk=ea(ea(na*hj)+ea(ea(oa*Oj)+ea(pa*qm)));wk=ea(ea(dc*yk)+ea(ea(cc*xk)+ea(bc*tm)));zk=ea(ea(mc*vk)+ea(ea(lc*uk)+ea(kc*um)));lk=ea(ea(xc*qk)+ea(ea(wc*nm)+ea(vc*sm)));im=ea(ea(Zb*hj)+ea(ea(Yb*Oj)+ea(qa*qm)));hm=ea(ea(gc*yk)+ea(ea(fc*xk)+ea(ec*tm)));fm=ea(ea(pc*vk)+ea(ea(oc*uk)+ea(nc*um)));rm=ea(ea(Ac*qk)+ea(ea(zc*nm)+ea(yc*sm)));pm=ea(ea(ac*hj)+ea(ea($b*Oj)+ea(_b*qm)));Vl=ea(ea(jc*yk)+ea(ea(ic*xk)+ea(hc*tm)));gm=ea(ea(sc*vk)+ea(ea(rc*uk)+ea(qc*um)));km=ea(ea(Rj*Al)-ea(Mj*Bl));Ul=ea(ea(Qj*gj)-ea(Lj*oj));Tl=ea(ea(Pj*jk)-ea(qj*ik));Sl=ea(ea(pj*gk)-ea(Sj*ul));Rl=ea(ea(tj*Bl)-ea(Rj*zl));Bl=ea(ea(uj*oj)-ea(Qj*jj));oj=ea(ea(wj*ik)-ea(Pj*kk));ik=ea(ea(Nj*ul)-ea(pj*hk));ul=ea(ea(Mj*zl)-ea(tj*Al));Al=ea(ea(Lj*jj)-ea(uj*gj));gj=ea(ea(qj*kk)-ea(wj*jk));jk=ea(ea(Sj*hk)-ea(Nj*gk));gk=ea(ea(cd*ul)+ea(ea(bd*Rl)+ea(Bc*km)));hk=ea(ea(Ec*Al)+ea(ea(Dc*Bl)+ea(Cc*Ul)));kk=ea(ea(Nc*gj)+ea(ea(Mc*oj)+ea(Lc*Tl)));jj=ea(ea(Wc*jk)+ea(ea(Vc*ik)+ea(Uc*Sl)));zl=ea(ea(fd*ul)+ea(ea(ed*Rl)+ea(dd*km)));Ql=ea(ea(Hc*Al)+ea(ea(Gc*Bl)+ea(Fc*Ul)));Pl=ea(ea(Qc*gj)+ea(ea(Pc*oj)+ea(Oc*Tl)));Ol=ea(ea(Zc*jk)+ea(ea(Yc*ik)+ea(Xc*Sl)));Nl=ea(ea(id*ul)+ea(ea(hd*Rl)+ea(gd*km)));Ml=ea(ea(Kc*Al)+ea(ea(Jc*Bl)+ea(Ic*Ul)));Ll=ea(ea(Tc*gj)+ea(ea(Sc*oj)+ea(Rc*Tl)));Kl=ea(ea(ad*jk)+ea(ea($c*ik)+ea(_c*Sl)));Jl=ea(ea(Xb+ea(ea(qk*rm)+ea(ea(nm*lk)+ea(sm*sk))))+ea(Tb+ea(ea(ul*Nl)+ea(ea(Rl*zl)+ea(km*gk)))));Il=ea(ea(Qb+ea(ea(hj*pm)+ea(ea(Oj*im)+ea(qm*tk))))+ea(ua+ea(ea(Al*Ml)+ea(ea(Bl*Ql)+ea(Ul*hk)))));Hl=ea(ea(Rb+ea(ea(yk*Vl)+ea(ea(xk*hm)+ea(tm*wk))))+ea(ra+ea(ea(gj*Ll)+ea(ea(oj*Pl)+ea(Tl*kk)))));Gl=ea(ea(Sb+ea(ea(vk*gm)+ea(ea(uk*fm)+ea(um*zk))))+ea(sa+ea(ea(jk*Kl)+ea(ea(ik*Ol)+ea(Sl*jj)))));g[Bh+Ze>>2]=km;g[Bh+_e>>2]=Ul;g[Bh+$e>>2]=Tl;g[Bh+af>>2]=Sl;g[Bh+bf>>2]=Rl;g[Bh+cf>>2]=Bl;g[Bh+df>>2]=oj;g[Bh+ef>>2]=ik;g[Bh+ff>>2]=ul;g[Bh+gf>>2]=Al;g[Bh+hf>>2]=gj;g[Bh+jf>>2]=jk;jk=ea(-hk);hk=ea(-kk);kk=ea(-jj);g[Bh+kf>>2]=ea(-gk);g[Bh+lf>>2]=jk;g[Bh+mf>>2]=hk;g[Bh+nf>>2]=kk;kk=ea(-Ql);Ql=ea(-Pl);Pl=ea(-Ol);g[Bh+of>>2]=ea(-zl);g[Bh+pf>>2]=kk;g[Bh+qf>>2]=Ql;g[Bh+rf>>2]=Pl;Pl=ea(-Ml);Ml=ea(-Ll);Ll=ea(-Kl);g[Bh+sf>>2]=ea(-Nl);g[Bh+tf>>2]=Pl;g[Bh+uf>>2]=Ml;g[Bh+vf>>2]=Ll;Oi=Jl>ea(0.0);Mi=Il>ea(0.0);Ni=Hl>ea(0.0);Si=Gl>ea(0.0);Ll=ea(ea(.800000011)/Il);Il=ea(ea(.800000011)/Hl);Hl=ea(ea(.800000011)/Gl);g[N>>2]=ea(ea(.800000011)/Jl);g[wf>>2]=Ll;g[xf>>2]=Il;g[yf>>2]=Hl;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;Hl=ea(g[(Oi?N:M)>>2]);Il=ea(g[(Mi?N:M)+4>>2]);Ll=ea(g[(Ni?N:M)+8>>2]);Jl=ea(g[(Si?N:M)+12>>2]);Gl=ea(g[Fi>>2]);Ml=ea(g[Ai>>2]);Pl=ea(g[zi>>2]);Nl=ea(g[yi>>2]);Kl=ea(g[xi>>2]);Ql=ea(g[wi>>2]);kk=ea(g[vi>>2]);zl=ea(g[ui>>2]);Ol=ea(g[ti>>2]);hk=ea(g[si>>2]);jk=ea(g[Uh>>2]);gk=ea(ea(Rj*Pl)+ea(ea(tj*Gl)+ea(Mj*Ml)));Ml=ea(ea(Qj*Ql)+ea(ea(uj*Nl)+ea(Lj*Kl)));Kl=ea(ea(Pj*Ol)+ea(ea(wj*kk)+ea(qj*zl)));zl=ea(ea(pj*ea(g[Th>>2]))+ea(ea(Nj*hk)+ea(Sj*jk)));jk=ea(ea(ea(Rj*lj)+ea(ea(Mj*ok)+ea(tj*yl)))*j);yl=ea(ea(ea(Qj*ej)+ea(ea(Lj*nk)+ea(uj*rk)))*j);rk=ea(ea(ea(Pj*fj)+ea(ea(qj*kj)+ea(wj*pk)))*j);pk=ea(ea(ea(pj*nj)+ea(ea(Sj*ij)+ea(Nj*mk)))*j);mk=ea(ak*uj);ij=ea(Fj*wj);nj=ea(Ej*Nj);g[Bh+Y>>2]=ea($j*tj);g[Bh+zf>>2]=mk;g[Bh+Af>>2]=ij;g[Bh+Bf>>2]=nj;nj=ea(ak*Lj);ij=ea(Fj*qj);mk=ea(Ej*Sj);g[Bh+Cf>>2]=ea($j*Mj);g[Bh+Df>>2]=nj;g[Bh+Ef>>2]=ij;g[Bh+Ff>>2]=mk;mk=ea(ak*Qj);ij=ea(Fj*Pj);nj=ea(Ej*pj);g[Bh+Gf>>2]=ea($j*Rj);g[Bh+Hf>>2]=mk;g[Bh+If>>2]=ij;g[Bh+Jf>>2]=nj;g[Bh+Kf>>2]=ea(0.0);g[Bh+Lf>>2]=ea(0.0);g[Bh+Mf>>2]=ea(0.0);g[Bh+Nf>>2]=ea(0.0);g[Bh+Of>>2]=sm;g[Bh+Pf>>2]=qm;g[Bh+Qf>>2]=tm;g[Bh+Rf>>2]=um;g[Bh+Sf>>2]=nm;g[Bh+Tf>>2]=Oj;g[Bh+Uf>>2]=xk;g[Bh+Vf>>2]=uk;g[Bh+Wf>>2]=qk;g[Bh+Xf>>2]=hj;g[Bh+Yf>>2]=yk;g[Bh+Zf>>2]=vk;g[Bh+_f>>2]=sk;g[Bh+$f>>2]=tk;g[Bh+ag>>2]=wk;g[Bh+bg>>2]=zk;g[Bh+cg>>2]=lk;g[Bh+dg>>2]=im;g[Bh+eg>>2]=hm;g[Bh+fg>>2]=fm;g[Bh+gg>>2]=rm;g[Bh+hg>>2]=pm;g[Bh+ig>>2]=Vl;g[Bh+jg>>2]=gm;gm=ea(Il*ea(yl-Ml));Ml=ea(Ll*ea(rk-Kl));Kl=ea(Jl*ea(pk-zl));g[Bh+kg>>2]=ea(Hl*ea(jk-gk));g[Bh+lg>>2]=gm;g[Bh+mg>>2]=Ml;g[Bh+ng>>2]=Kl;g[Bh+og>>2]=ea(0.0);g[Bh+pg>>2]=ea(0.0);g[Bh+qg>>2]=ea(0.0);g[Bh+rg>>2]=ea(0.0);Kl=ea(yl*Il);yl=ea(rk*Ll);rk=ea(pk*Jl);g[Bh+sg>>2]=ea(jk*Hl);g[Bh+tg>>2]=Kl;g[Bh+ug>>2]=yl;g[Bh+vg>>2]=rk;g[Bh+wg>>2]=Hl;g[Bh+xg>>2]=Il;g[Bh+yg>>2]=Ll;g[Bh+zg>>2]=Jl;c[Bh+Ag>>2]=Ii;c[Bh+Bg>>2]=Ui;c[Bh+Cg>>2]=Qi;c[Bh+Dg>>2]=Wi;wh=wh+1|0;if(wh>>>0>=Hi>>>0)break;else Bh=Bh+Ne|0}}else{Rj=ea(1.0);$j=ea(1.0);pj=ea(1.0);Ej=ea(1.0);Pj=rj;Fj=vh;Qj=uh;ak=th;Mj=sh;Sj=rh;qj=oh;Lj=ph;tj=qh;Nj=Gj;wj=Hj;uj=Ij;ck=Jj;dk=Zj;ek=Yj;fk=Xj;Kj=Wj;sj=xj;vj=zj;yj=Aj;Dj=Bj;bk=Tj;_j=Uj;Cj=Vj;Bh=0;wh=0;jh=0;ih=0;Vh=0;hh=Yi;while(1){nh=Vh>>>0<pl>>>0;Bh=nh?Vh:Bh;mh=Vh>>>0<ql>>>0;wh=mh?Vh:wh;lh=Vh>>>0<rl>>>0;jh=lh?Vh:jh;kh=Vh>>>0<sl>>>0;ih=kh?Vh:ih;Rj=nh?Rj:ea(0.0);$j=mh?$j:ea(0.0);pj=lh?pj:ea(0.0);Ej=kh?Ej:ea(0.0);Pj=ea(Pj*Rj);Fj=ea(Fj*$j);Qj=ea(Qj*pj);ak=ea(ak*Ej);Mj=ea(Mj*Rj);Sj=ea(Sj*$j);qj=ea(qj*pj);Lj=ea(Lj*Ej);tj=ea(tj*Rj);Nj=ea(Nj*$j);wj=ea(wj*pj);uj=ea(uj*Ej);ck=ea(ck*Rj);dk=ea(dk*$j);ek=ea(ek*pj);fk=ea(fk*Ej);Kj=ea(Kj*Rj);sj=ea(sj*$j);vj=ea(vj*pj);yj=ea(yj*Ej);Dj=ea(Dj*Rj);bk=ea(bk*$j);_j=ea(_j*pj);Cj=ea(Cj*Ej);Mh=ea(g[f+(_g*96|0)+(Bh*12|0)+5312>>2]);Lh=ea(g[f+(_g*96|0)+(Bh*12|0)+5316>>2]);Jh=ea(g[f+(_g*96|0)+(Bh*12|0)+5320>>2]);Ih=ea(g[f+($g*96|0)+(wh*12|0)+5312>>2]);Gh=ea(g[f+($g*96|0)+(wh*12|0)+5316>>2]);Fh=ea(g[f+($g*96|0)+(wh*12|0)+5320>>2]);Dh=ea(g[f+(ah*96|0)+(jh*12|0)+5312>>2]);Ch=ea(g[f+(ah*96|0)+(jh*12|0)+5316>>2]);Nh=ea(g[f+(ah*96|0)+(jh*12|0)+5320>>2]);Kh=ea(g[f+(bh*96|0)+(ih*12|0)+5312>>2]);Hh=ea(g[f+(bh*96|0)+(ih*12|0)+5316>>2]);Eh=ea(g[f+(bh*96|0)+(ih*12|0)+5320>>2]);Rh=ea(ea(ea(Bd*Mh)+ea(Cd*Lh))+ea(Dd*Jh));Qh=ea(ea(ea(Bd*Rh)+ea(ea(Oe*Mh)+ea(Ed*ea(ea(Cd*Jh)-ea(Dd*Lh)))))*ea(2.0));Ph=ea(ea(ea(Cd*Rh)+ea(ea(Oe*Lh)+ea(Ed*ea(ea(Dd*Mh)-ea(Bd*Jh)))))*ea(2.0));Oh=ea(ea(ea(ea(Oe*Jh)+ea(Ed*ea(ea(Bd*Lh)-ea(Cd*Mh))))+ea(Dd*Rh))*ea(2.0));Rh=ea(ea(ea(Fd*Ih)+ea(Gd*Gh))+ea(Hd*Fh));Mh=ea(ea(ea(Fd*Rh)+ea(ea(Pe*Ih)+ea(Id*ea(ea(Gd*Fh)-ea(Hd*Gh)))))*ea(2.0));Lh=ea(ea(ea(Gd*Rh)+ea(ea(Pe*Gh)+ea(Id*ea(ea(Hd*Ih)-ea(Fd*Fh)))))*ea(2.0));Jh=ea(ea(ea(ea(Pe*Fh)+ea(Id*ea(ea(Fd*Gh)-ea(Gd*Ih))))+ea(Hd*Rh))*ea(2.0));Rh=ea(ea(ea(Jd*Dh)+ea(Kd*Ch))+ea(Ld*Nh));Ih=ea(ea(ea(Jd*Rh)+ea(ea(Qe*Dh)+ea(Md*ea(ea(Kd*Nh)-ea(Ld*Ch)))))*ea(2.0));Gh=ea(ea(ea(Kd*Rh)+ea(ea(Qe*Ch)+ea(Md*ea(ea(Ld*Dh)-ea(Jd*Nh)))))*ea(2.0));Fh=ea(ea(ea(ea(Qe*Nh)+ea(Md*ea(ea(Jd*Ch)-ea(Kd*Dh))))+ea(Ld*Rh))*ea(2.0));Rh=ea(ea(ea(Nd*Kh)+ea(Od*Hh))+ea(Pd*Eh));Dh=ea(ea(ea(Nd*Rh)+ea(ea(Re*Kh)+ea(Qd*ea(ea(Od*Eh)-ea(Pd*Hh)))))*ea(2.0));Ch=ea(ea(ea(Od*Rh)+ea(ea(Re*Hh)+ea(Qd*ea(ea(Pd*Kh)-ea(Nd*Eh)))))*ea(2.0));Nh=ea(ea(ea(ea(Re*Eh)+ea(Qd*ea(ea(Nd*Hh)-ea(Od*Kh))))+ea(Pd*Rh))*ea(2.0));Rh=ea(ha+Qh);Kh=ea(xa+Mh);Hh=ea(ya+Ih);Eh=ea(md+Dh);Jl=ea(ia+Ph);Ll=ea(wa+Lh);Il=ea(kd+Gh);Hl=ea(nd+Ch);rk=ea(fa+Oh);yl=ea(va+Jh);Kl=ea(ld+Fh);jk=ea(od+Nh);pk=ea(g[f+(_g*96|0)+(Bh*12|0)+5336>>2]);Ml=ea(g[f+(_g*96|0)+(Bh*12|0)+5340>>2]);gm=ea(g[f+(_g*96|0)+(Bh*12|0)+5344>>2]);gk=ea(g[f+($g*96|0)+(wh*12|0)+5336>>2]);zl=ea(g[f+($g*96|0)+(wh*12|0)+5340>>2]);Vl=ea(g[f+($g*96|0)+(wh*12|0)+5344>>2]);pm=ea(g[f+(ah*96|0)+(jh*12|0)+5336>>2]);rm=ea(g[f+(ah*96|0)+(jh*12|0)+5340>>2]);fm=ea(g[f+(ah*96|0)+(jh*12|0)+5344>>2]);hm=ea(g[f+(bh*96|0)+(ih*12|0)+5336>>2]);im=ea(g[f+(bh*96|0)+(ih*12|0)+5340>>2]);lk=ea(g[f+(bh*96|0)+(ih*12|0)+5344>>2]);zk=ea(ea(ea(Rd*pk)+ea(Sd*Ml))+ea(Td*gm));wk=ea(ea(ea(Vd*gk)+ea(Wd*zl))+ea(Xd*Vl));tk=ea(ea(ea(Zd*pm)+ea(_d*rm))+ea($d*fm));sk=ea(ea(ea(be*hm)+ea(ce*im))+ea(de*lk));vk=ea(Rh-ea(pd+ea(ea(ea(Rd*zk)+ea(ea(Se*pk)+ea(Ud*ea(ea(Sd*gm)-ea(Td*Ml)))))*ea(2.0))));Rh=ea(Kh-ea(sd+ea(ea(ea(Vd*wk)+ea(ea(Te*gk)+ea(Yd*ea(ea(Wd*Vl)-ea(Xd*zl)))))*ea(2.0))));Kh=ea(Hh-ea(vd+ea(ea(ea(Zd*tk)+ea(ea(Ue*pm)+ea(ae*ea(ea(_d*fm)-ea($d*rm)))))*ea(2.0))));Hh=ea(Eh-ea(yd+ea(ea(ea(be*sk)+ea(ea(Ve*hm)+ea(ee*ea(ea(ce*lk)-ea(de*im)))))*ea(2.0))));Eh=ea(Jl-ea(qd+ea(ea(ea(Sd*zk)+ea(ea(Se*Ml)+ea(Ud*ea(ea(Td*pk)-ea(Rd*gm)))))*ea(2.0))));Jl=ea(Ll-ea(td+ea(ea(ea(Wd*wk)+ea(ea(Te*zl)+ea(Yd*ea(ea(Xd*gk)-ea(Vd*Vl)))))*ea(2.0))));Ll=ea(Il-ea(wd+ea(ea(ea(_d*tk)+ea(ea(Ue*rm)+ea(ae*ea(ea($d*pm)-ea(Zd*fm)))))*ea(2.0))));Il=ea(Hl-ea(zd+ea(ea(ea(ce*sk)+ea(ea(Ve*im)+ea(ee*ea(ea(de*hm)-ea(be*lk)))))*ea(2.0))));Hl=ea(rk-ea(rd+ea(ea(ea(ea(Se*gm)+ea(Ud*ea(ea(Rd*Ml)-ea(Sd*pk))))+ea(Td*zk))*ea(2.0))));zk=ea(yl-ea(ud+ea(ea(ea(ea(Te*Vl)+ea(Yd*ea(ea(Vd*zl)-ea(Wd*gk))))+ea(Xd*wk))*ea(2.0))));wk=ea(Kl-ea(xd+ea(ea(ea(ea(Ue*fm)+ea(ae*ea(ea(Zd*rm)-ea(_d*pm))))+ea($d*tk))*ea(2.0))));tk=ea(jk-ea(Ad+ea(ea(ea(ea(Ve*lk)+ea(ee*ea(ea(be*im)-ea(ce*hm))))+ea(de*sk))*ea(2.0))));sk=ea(ea(tj*Ph)-ea(Mj*Oh));hm=ea(ea(Nj*Lh)-ea(Sj*Jh));im=ea(ea(wj*Gh)-ea(qj*Fh));lk=ea(ea(uj*Ch)-ea(Lj*Nh));jk=ea(ea(Pj*Oh)-ea(tj*Qh));pm=ea(ea(Fj*Jh)-ea(Nj*Mh));rm=ea(ea(Qj*Fh)-ea(wj*Ih));fm=ea(ea(ak*Nh)-ea(uj*Dh));Kl=ea(ea(Mj*Qh)-ea(Pj*Ph));gk=ea(ea(Sj*Mh)-ea(Fj*Lh));zl=ea(ea(qj*Ih)-ea(Qj*Gh));Vl=ea(ea(Lj*Dh)-ea(ak*Ch));yl=ea(ea(uc*Kl)+ea(ea(tc*jk)+ea(jd*sk)));pk=ea(ea(na*gk)+ea(ea(oa*pm)+ea(pa*hm)));Ml=ea(ea(dc*zl)+ea(ea(cc*rm)+ea(bc*im)));gm=ea(ea(mc*Vl)+ea(ea(lc*fm)+ea(kc*lk)));rk=ea(ea(xc*Kl)+ea(ea(wc*jk)+ea(vc*sk)));yk=ea(ea(Zb*gk)+ea(ea(Yb*pm)+ea(qa*hm)));hj=ea(ea(gc*zl)+ea(ea(fc*rm)+ea(ec*im)));qk=ea(ea(pc*Vl)+ea(ea(oc*fm)+ea(nc*lk)));uk=ea(ea(Ac*Kl)+ea(ea(zc*jk)+ea(yc*sk)));xk=ea(ea(ac*gk)+ea(ea($b*pm)+ea(_b*hm)));Oj=ea(ea(jc*zl)+ea(ea(ic*rm)+ea(hc*im)));nm=ea(ea(sc*Vl)+ea(ea(rc*fm)+ea(qc*lk)));um=ea(Xb+ea(ea(Kl*uk)+ea(ea(jk*rk)+ea(sk*yl))));tm=ea(Qb+ea(ea(gk*xk)+ea(ea(pm*yk)+ea(hm*pk))));qm=ea(Rb+ea(ea(zl*Oj)+ea(ea(rm*hj)+ea(im*Ml))));sm=ea(Sb+ea(ea(Vl*nm)+ea(ea(fm*qk)+ea(lk*gm))));Zg=um>ea(0.0);Yg=tm>ea(0.0);Xg=qm>ea(0.0);h=sm>ea(0.0);nj=ea(ea(.800000011)/tm);tm=ea(ea(.800000011)/qm);qm=ea(ea(.800000011)/sm);g[L>>2]=ea(ea(.800000011)/um);g[We>>2]=nj;g[Xe>>2]=tm;g[Ye>>2]=qm;c[K+0>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;c[K+12>>2]=0;qm=ea(g[(Zg?L:K)>>2]);tm=ea(g[(Yg?L:K)+4>>2]);nj=ea(g[(Xg?L:K)+8>>2]);um=ea(g[(h?L:K)+12>>2]);sm=ea(g[Fi>>2]);ij=ea(g[Ai>>2]);mk=ea(g[zi>>2]);kj=ea(g[yi>>2]);fj=ea(g[xi>>2]);nk=ea(g[wi>>2]);ej=ea(g[vi>>2]);ok=ea(g[ui>>2]);lj=ea(g[ti>>2]);hk=ea(g[si>>2]);kk=ea(g[Uh>>2]);Ol=ea(qm*ea(ea(tj*mk)+ea(ea(Pj*sm)+ea(Mj*ij))));ij=ea(tm*ea(ea(Nj*nk)+ea(ea(Fj*kj)+ea(Sj*fj))));fj=ea(nj*ea(ea(wj*lj)+ea(ea(Qj*ej)+ea(qj*ok))));ok=ea(um*ea(ea(uj*ea(g[Th>>2]))+ea(ea(ak*hk)+ea(Lj*kk))));kk=ea(ea(ea(ea(tj*Hl)+ea(ea(Mj*Eh)+ea(Pj*vk)))*j)*qm);hk=ea(ea(ea(ea(Nj*zk)+ea(ea(Sj*Jl)+ea(Fj*Rh)))*j)*tm);ej=ea(ea(ea(ea(wj*wk)+ea(ea(qj*Ll)+ea(Qj*Kh)))*j)*nj);lj=ea(ea(ea(ea(uj*tk)+ea(ea(Lj*Il)+ea(ak*Hh)))*j)*um);kj=ea($j*Fj);nk=ea(pj*Qj);sm=ea(Ej*ak);g[hh>>2]=ea(Rj*Pj);g[hh+4>>2]=kj;g[hh+8>>2]=nk;g[hh+12>>2]=sm;sm=ea($j*Sj);nk=ea(pj*qj);kj=ea(Ej*Lj);g[hh+16>>2]=ea(Rj*Mj);g[hh+20>>2]=sm;g[hh+24>>2]=nk;g[hh+28>>2]=kj;kj=ea($j*Nj);nk=ea(pj*wj);sm=ea(Ej*uj);g[hh+32>>2]=ea(Rj*tj);g[hh+36>>2]=kj;g[hh+40>>2]=nk;g[hh+44>>2]=sm;h=hh+48|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[hh+64>>2]=sk;g[hh+68>>2]=hm;g[hh+72>>2]=im;g[hh+76>>2]=lk;g[hh+80>>2]=jk;g[hh+84>>2]=pm;g[hh+88>>2]=rm;g[hh+92>>2]=fm;g[hh+96>>2]=Kl;g[hh+100>>2]=gk;g[hh+104>>2]=zl;g[hh+108>>2]=Vl;g[hh+112>>2]=yl;g[hh+116>>2]=pk;g[hh+120>>2]=Ml;g[hh+124>>2]=gm;g[hh+128>>2]=rk;g[hh+132>>2]=yk;g[hh+136>>2]=hj;g[hh+140>>2]=qk;g[hh+144>>2]=uk;g[hh+148>>2]=xk;g[hh+152>>2]=Oj;g[hh+156>>2]=nm;nm=ea(hk-ij);ij=ea(ej-fj);fj=ea(lj-ok);g[hh+160>>2]=ea(kk-Ol);g[hh+164>>2]=nm;g[hh+168>>2]=ij;g[hh+172>>2]=fj;h=hh+176|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[hh+192>>2]=kk;g[hh+196>>2]=hk;g[hh+200>>2]=ej;g[hh+204>>2]=lj;g[hh+208>>2]=qm;g[hh+212>>2]=tm;g[hh+216>>2]=nj;g[hh+220>>2]=um;h=nh?Ei:0;c[hh+224>>2]=h;nh=mh?Di:0;c[hh+228>>2]=nh;mh=lh?Ci:0;c[hh+232>>2]=mh;lh=kh?Bi:0;c[hh+236>>2]=lh;um=ea(ea(Dj*Ph)-ea(Kj*Oh));nj=ea(ea(bk*Lh)-ea(sj*Jh));tm=ea(ea(_j*Gh)-ea(vj*Fh));qm=ea(ea(Cj*Ch)-ea(yj*Nh));lj=ea(ea(ck*Oh)-ea(Dj*Qh));Oh=ea(ea(dk*Jh)-ea(bk*Mh));Jh=ea(ea(ek*Fh)-ea(_j*Ih));Fh=ea(ea(fk*Nh)-ea(Cj*Dh));Nh=ea(ea(Kj*Qh)-ea(ck*Ph));Ph=ea(ea(sj*Mh)-ea(dk*Lh));Lh=ea(ea(vj*Ih)-ea(ek*Gh));Gh=ea(ea(yj*Dh)-ea(fk*Ch));Ch=ea(ea(uc*Nh)+ea(ea(tc*lj)+ea(jd*um)));Dh=ea(ea(na*Ph)+ea(ea(oa*Oh)+ea(pa*nj)));Ih=ea(ea(dc*Lh)+ea(ea(cc*Jh)+ea(bc*tm)));Mh=ea(ea(mc*Gh)+ea(ea(lc*Fh)+ea(kc*qm)));Qh=ea(ea(xc*Nh)+ea(ea(wc*lj)+ea(vc*um)));ej=ea(ea(Zb*Ph)+ea(ea(Yb*Oh)+ea(qa*nj)));hk=ea(ea(gc*Lh)+ea(ea(fc*Jh)+ea(ec*tm)));kk=ea(ea(pc*Gh)+ea(ea(oc*Fh)+ea(nc*qm)));fj=ea(ea(Ac*Nh)+ea(ea(zc*lj)+ea(yc*um)));ij=ea(ea(ac*Ph)+ea(ea($b*Oh)+ea(_b*nj)));nm=ea(ea(jc*Lh)+ea(ea(ic*Jh)+ea(hc*tm)));Ol=ea(ea(sc*Gh)+ea(ea(rc*Fh)+ea(qc*qm)));ok=ea(Xb+ea(ea(Nh*fj)+ea(ea(lj*Qh)+ea(um*Ch))));Oj=ea(Qb+ea(ea(Ph*ij)+ea(ea(Oh*ej)+ea(nj*Dh))));xk=ea(Rb+ea(ea(Lh*nm)+ea(ea(Jh*hk)+ea(tm*Ih))));uk=ea(Sb+ea(ea(Gh*Ol)+ea(ea(Fh*kk)+ea(qm*Mh))));kh=ok>ea(0.0);Xg=Oj>ea(0.0);Yg=xk>ea(0.0);Zg=uk>ea(0.0);qk=ea(ea(.800000011)/Oj);Oj=ea(ea(.800000011)/xk);xk=ea(ea(.800000011)/uk);g[N>>2]=ea(ea(.800000011)/ok);g[wf>>2]=qk;g[xf>>2]=Oj;g[yf>>2]=xk;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;xk=ea(g[(kh?N:M)>>2]);Oj=ea(g[(Xg?N:M)+4>>2]);qk=ea(g[(Yg?N:M)+8>>2]);ok=ea(g[(Zg?N:M)+12>>2]);uk=ea(g[Fi>>2]);hj=ea(g[Ai>>2]);yk=ea(g[zi>>2]);rk=ea(g[yi>>2]);gm=ea(g[xi>>2]);Ml=ea(g[wi>>2]);pk=ea(g[vi>>2]);yl=ea(g[ui>>2]);Vl=ea(g[ti>>2]);zl=ea(g[si>>2]);gk=ea(g[Uh>>2]);Kl=ea(ea(Dj*yk)+ea(ea(ck*uk)+ea(Kj*hj)));hj=ea(ea(bk*Ml)+ea(ea(dk*rk)+ea(sj*gm)));gm=ea(ea(_j*Vl)+ea(ea(ek*pk)+ea(vj*yl)));yl=ea(ea(Cj*ea(g[Th>>2]))+ea(ea(fk*zl)+ea(yj*gk)));gk=ea(ea(ea(Dj*Hl)+ea(ea(Kj*Eh)+ea(ck*vk)))*j);vk=ea(ea(ea(bk*zk)+ea(ea(sj*Jl)+ea(dk*Rh)))*j);Rh=ea(ea(ea(_j*wk)+ea(ea(vj*Ll)+ea(ek*Kh)))*j);Kh=ea(ea(ea(Cj*tk)+ea(ea(yj*Il)+ea(fk*Hh)))*j);Hh=ea($j*dk);Il=ea(pj*ek);tk=ea(Ej*fk);g[hh+Y>>2]=ea(Rj*ck);g[hh+zf>>2]=Hh;g[hh+Af>>2]=Il;g[hh+Bf>>2]=tk;tk=ea($j*sj);Il=ea(pj*vj);Hh=ea(Ej*yj);g[hh+Cf>>2]=ea(Rj*Kj);g[hh+Df>>2]=tk;g[hh+Ef>>2]=Il;g[hh+Ff>>2]=Hh;Hh=ea($j*bk);Il=ea(pj*_j);tk=ea(Ej*Cj);g[hh+Gf>>2]=ea(Rj*Dj);g[hh+Hf>>2]=Hh;g[hh+If>>2]=Il;g[hh+Jf>>2]=tk;g[hh+Kf>>2]=ea(0.0);g[hh+Lf>>2]=ea(0.0);g[hh+Mf>>2]=ea(0.0);g[hh+Nf>>2]=ea(0.0);g[hh+Of>>2]=um;g[hh+Pf>>2]=nj;g[hh+Qf>>2]=tm;g[hh+Rf>>2]=qm;g[hh+Sf>>2]=lj;g[hh+Tf>>2]=Oh;g[hh+Uf>>2]=Jh;g[hh+Vf>>2]=Fh;g[hh+Wf>>2]=Nh;g[hh+Xf>>2]=Ph;g[hh+Yf>>2]=Lh;g[hh+Zf>>2]=Gh;g[hh+_f>>2]=Ch;g[hh+$f>>2]=Dh;g[hh+ag>>2]=Ih;g[hh+bg>>2]=Mh;g[hh+cg>>2]=Qh;g[hh+dg>>2]=ej;g[hh+eg>>2]=hk;g[hh+fg>>2]=kk;g[hh+gg>>2]=fj;g[hh+hg>>2]=ij;g[hh+ig>>2]=nm;g[hh+jg>>2]=Ol;Ol=ea(Oj*ea(vk-hj));hj=ea(qk*ea(Rh-gm));gm=ea(ok*ea(Kh-yl));g[hh+kg>>2]=ea(xk*ea(gk-Kl));g[hh+lg>>2]=Ol;g[hh+mg>>2]=hj;g[hh+ng>>2]=gm;g[hh+og>>2]=ea(0.0);g[hh+pg>>2]=ea(0.0);g[hh+qg>>2]=ea(0.0);g[hh+rg>>2]=ea(0.0);gm=ea(vk*Oj);vk=ea(Rh*qk);Rh=ea(Kh*ok);g[hh+sg>>2]=ea(gk*xk);g[hh+tg>>2]=gm;g[hh+ug>>2]=vk;g[hh+vg>>2]=Rh;g[hh+wg>>2]=xk;g[hh+xg>>2]=Oj;g[hh+yg>>2]=qk;g[hh+zg>>2]=ok;c[hh+Ag>>2]=h;c[hh+Bg>>2]=nh;c[hh+Cg>>2]=mh;c[hh+Dg>>2]=lh;Vh=Vh+1|0;if(Vh>>>0>=Hi>>>0)break;else hh=hh+Ne|0}}tl=Yi+(da(Ig,gh)|0)|0}Rg=Rg+1|0;if(Rg>>>0>=l>>>0)break;else{Jg=ri;Kg=Li;Lg=Ki;Mg=Ji;Ng=_g;Og=$g;Pg=ah;Qg=bh;Sg=Ti;Tg=Vi;Ug=Xi;Vg=Gi;Wg=tl}}i=p;return}function Dwa(d,f,h,j,k,l,m,n,o,p,q,r,s){d=d|0;f=f|0;h=h|0;j=ea(j);k=ea(k);l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=Im,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=Im,_a=Im,$a=Im,ab=0,bb=Im,cb=Im,db=Im,eb=0,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=Im,ff=Im,gf=Im,hf=Im,jf=Im,kf=Im,lf=Im,mf=Im,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=Im,vf=Im,wf=Im,xf=Im,yf=Im,zf=Im,Af=Im,Bf=Im,Cf=Im,Df=Im,Ef=Im,Ff=Im,Gf=Im,Hf=Im,If=Im,Jf=Im,Kf=Im,Lf=Im,Mf=Im,Nf=Im,Of=Im,Pf=Im,Qf=Im,Rf=Im,Sf=Im,Tf=Im,Uf=Im,Vf=Im,Wf=Im,Xf=Im,Yf=Im,Zf=Im,_f=Im,$f=Im,ag=Im,bg=Im,cg=Im,dg=Im,eg=Im,fg=Im,gg=Im,hg=Im,ig=Im,jg=Im,kg=Im,lg=Im,mg=Im,ng=Im,og=Im,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=Im,yh=Im,zh=Im,Ah=Im,Bh=Im,Ch=Im,Dh=Im,Eh=Im,Fh=Im,Gh=Im,Hh=Im,Ih=Im,Jh=Im,Kh=Im,Lh=Im,Mh=Im,Nh=Im,Oh=Im,Ph=Im,Qh=Im,Rh=Im,Sh=Im,Th=Im,Uh=Im,Vh=Im,Wh=Im,Xh=Im,Yh=Im,Zh=Im,_h=Im,$h=Im,ai=Im,bi=Im,ci=Im,di=Im,ei=Im,fi=Im,gi=Im,hi=Im,ii=Im,ji=Im,ki=Im,li=Im,mi=Im,ni=Im,oi=Im,pi=Im,qi=Im,ri=Im,si=Im,ti=Im,ui=Im,vi=Im,wi=Im,xi=Im,yi=Im,zi=Im,Ai=Im,Bi=Im,Ci=Im,Di=Im,Ei=Im,Fi=Im,Gi=Im,Hi=Im,Ii=Im,Ji=Im,Ki=Im,Li=Im,Mi=Im,Ni=Im,Oi=Im,Pi=Im,Qi=Im,Ri=Im,Si=Im,Ti=Im,Ui=Im,Vi=Im,Wi=Im,Xi=Im,Yi=Im,Zi=Im,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0;o=i;i=i+416|0;t=o+384|0;u=o;v=o+16|0;w=o+192|0;x=o+352|0;y=o+64|0;z=o+80|0;A=o+96|0;B=o+288|0;C=o+336|0;D=o+368|0;E=o+400|0;F=o+208|0;G=o+224|0;H=o+240|0;I=o+32|0;J=o+256|0;K=o+112|0;L=o+272|0;M=o+48|0;N=o+128|0;O=o+304|0;P=o+160|0;Q=c[d>>2]|0;R=b[Q+22>>1]|0;S=(R&65535)>>>8&1;U=c[d+56>>2]|0;V=b[U+22>>1]|0;W=(V&65535)>>>8&1;X=c[d+112>>2]|0;Y=b[X+22>>1]|0;Z=(Y&65535)>>>8&1;_=c[d+168>>2]|0;$=b[_+22>>1]|0;aa=($&65535)>>>8&1;ba=((V|R|Y|$)&64)!=0;$=ba?272:176;Y=ba?288:192;ca=ea(g[Q+84>>2]);fa=ea(g[U+84>>2]);ga=ea(g[X+84>>2]);ha=ea(g[_+84>>2]);ia=ea(g[Q+88>>2]);ja=ea(g[U+88>>2]);ka=ea(g[X+88>>2]);la=ea(g[_+88>>2]);ma=ea(g[p>>2]);na=ea(g[p+4>>2]);oa=ea(g[p+8>>2]);pa=ea(ca*ma);ma=ea(fa*na);na=ea(ga*oa);oa=ea(ha*ea(g[p+12>>2]));qa=ea(g[r>>2]);ra=ea(g[r+4>>2]);sa=ea(g[r+8>>2]);ta=ea(ia*qa);qa=ea(ja*ra);ra=ea(ka*sa);sa=ea(la*ea(g[r+12>>2]));ua=ea(g[q>>2]);va=ea(g[q+4>>2]);wa=ea(g[q+8>>2]);xa=ea(ca*ua);ua=ea(fa*va);va=ea(ga*wa);wa=ea(ha*ea(g[q+12>>2]));ha=ea(g[s>>2]);ga=ea(g[s+4>>2]);fa=ea(g[s+8>>2]);ca=ea(ia*ha);ha=ea(ja*ga);ga=ea(ka*fa);fa=ea(la*ea(g[s+12>>2]));s=c[d+44>>2]|0;la=ea(g[s+52>>2]);q=c[d+100>>2]|0;ka=ea(g[q+52>>2]);r=c[d+156>>2]|0;ja=ea(g[r+52>>2]);p=c[d+212>>2]|0;ia=ea(g[p+52>>2]);R=c[d+48>>2]|0;ya=ea(g[R+52>>2]);V=c[d+104>>2]|0;za=ea(g[V+52>>2]);Aa=c[d+160>>2]|0;Ba=ea(g[Aa+52>>2]);Ca=c[d+216>>2]|0;Da=ea(g[Ca+52>>2]);Ea=la>ya?la:ya;ya=ka>za?ka:za;za=ja>Ba?ja:Ba;Ba=ia>Da?ia:Da;Da=ea(g[Q+92>>2]);ia=ea(g[U+92>>2]);ja=ea(g[X+92>>2]);ka=ea(g[_+92>>2]);_=c[d+36>>2]|0;la=ea(g[_>>2]);Fa=ea(g[_+4>>2]);Ga=ea(g[_+8>>2]);X=c[d+92>>2]|0;Ha=ea(g[X>>2]);Ia=ea(g[X+4>>2]);Ja=ea(g[X+8>>2]);U=c[d+148>>2]|0;Ka=ea(g[U>>2]);La=ea(g[U+4>>2]);Ma=ea(g[U+8>>2]);Q=c[d+204>>2]|0;Na=ea(g[Q>>2]);Oa=ea(g[Q+4>>2]);Pa=ea(g[Q+8>>2]);Qa=c[d+40>>2]|0;Ra=ea(g[Qa>>2]);Sa=ea(g[Qa+4>>2]);Ta=ea(g[Qa+8>>2]);Ua=c[d+96>>2]|0;Va=ea(g[Ua>>2]);Wa=ea(g[Ua+4>>2]);Xa=ea(g[Ua+8>>2]);Ya=c[d+152>>2]|0;Za=ea(g[Ya>>2]);_a=ea(g[Ya+4>>2]);$a=ea(g[Ya+8>>2]);ab=c[d+208>>2]|0;bb=ea(g[ab>>2]);cb=ea(g[ab+4>>2]);db=ea(g[ab+8>>2]);eb=_+16|0;fb=ea(g[eb>>2]);gb=ea(g[eb+4>>2]);hb=ea(g[eb+8>>2]);eb=X+16|0;ib=ea(g[eb>>2]);jb=ea(g[eb+4>>2]);kb=ea(g[eb+8>>2]);eb=U+16|0;lb=ea(g[eb>>2]);mb=ea(g[eb+4>>2]);nb=ea(g[eb+8>>2]);eb=Q+16|0;ob=ea(g[eb>>2]);pb=ea(g[eb+4>>2]);qb=ea(g[eb+8>>2]);eb=Qa+16|0;rb=ea(g[eb>>2]);sb=ea(g[eb+4>>2]);tb=ea(g[eb+8>>2]);eb=Ua+16|0;ub=ea(g[eb>>2]);vb=ea(g[eb+4>>2]);wb=ea(g[eb+8>>2]);eb=Ya+16|0;xb=ea(g[eb>>2]);yb=ea(g[eb+4>>2]);zb=ea(g[eb+8>>2]);eb=ab+16|0;Ab=ea(g[eb>>2]);Bb=ea(g[eb+4>>2]);Cb=ea(g[eb+8>>2]);Db=ea(la-Ra);Eb=ea(Ha-Va);Fb=ea(Ka-Za);Gb=ea(Na-bb);Hb=ea(Fa-Sa);Ib=ea(Ia-Wa);Jb=ea(La-_a);Kb=ea(Oa-cb);Lb=ea(Ga-Ta);Mb=ea(Ja-Xa);Nb=ea(Ma-$a);Ob=ea(Pa-db);Pb=ea(g[s+48>>2]);Qb=ea(g[q+48>>2]);Rb=ea(g[r+48>>2]);Sb=ea(g[p+48>>2]);Tb=ea(g[R+48>>2]);Ub=ea(g[V+48>>2]);Vb=ea(g[Aa+48>>2]);Wb=ea(pa*Pb);Pb=ea(ma*Qb);Qb=ea(na*Rb);Rb=ea(oa*Sb);Sb=ea(-ea(ta*Tb));Tb=ea(-ea(qa*Ub));Ub=ea(-ea(ra*Vb));Vb=ea(-ea(sa*ea(g[Ca+48>>2])));sa=ea(g[s>>2]);ra=ea(g[s+4>>2]);qa=ea(g[s+8>>2]);ta=ea(g[s+12>>2]);oa=ea(g[s+16>>2]);na=ea(g[s+20>>2]);ma=ea(g[s+24>>2]);pa=ea(g[s+28>>2]);Xb=ea(g[s+32>>2]);Yb=ea(g[q>>2]);Zb=ea(g[q+4>>2]);_b=ea(g[q+8>>2]);$b=ea(g[q+12>>2]);ac=ea(g[q+16>>2]);bc=ea(g[q+20>>2]);cc=ea(g[q+24>>2]);dc=ea(g[q+28>>2]);ec=ea(g[q+32>>2]);fc=ea(g[r>>2]);gc=ea(g[r+4>>2]);hc=ea(g[r+8>>2]);ic=ea(g[r+12>>2]);jc=ea(g[r+16>>2]);kc=ea(g[r+20>>2]);lc=ea(g[r+24>>2]);mc=ea(g[r+28>>2]);nc=ea(g[r+32>>2]);oc=ea(g[p>>2]);pc=ea(g[p+4>>2]);qc=ea(g[p+8>>2]);rc=ea(g[p+12>>2]);sc=ea(g[p+16>>2]);tc=ea(g[p+20>>2]);uc=ea(g[p+24>>2]);vc=ea(g[p+28>>2]);wc=ea(g[p+32>>2]);xc=ea(g[R>>2]);yc=ea(g[R+4>>2]);zc=ea(g[R+8>>2]);Ac=ea(g[R+12>>2]);Bc=ea(g[R+16>>2]);Cc=ea(g[R+20>>2]);Dc=ea(g[R+24>>2]);Ec=ea(g[R+28>>2]);Fc=ea(g[R+32>>2]);Gc=ea(g[V>>2]);Hc=ea(g[V+4>>2]);Ic=ea(g[V+8>>2]);Jc=ea(g[V+12>>2]);Kc=ea(g[V+16>>2]);Lc=ea(g[V+20>>2]);Mc=ea(g[V+24>>2]);Nc=ea(g[V+28>>2]);Oc=ea(g[V+32>>2]);Pc=ea(g[Aa>>2]);Qc=ea(g[Aa+4>>2]);Rc=ea(g[Aa+8>>2]);Sc=ea(g[Aa+12>>2]);Tc=ea(g[Aa+16>>2]);Uc=ea(g[Aa+20>>2]);Vc=ea(g[Aa+24>>2]);Wc=ea(g[Aa+28>>2]);Xc=ea(g[Aa+32>>2]);Yc=ea(g[Ca>>2]);Zc=ea(g[Ca+4>>2]);_c=ea(g[Ca+8>>2]);$c=ea(g[Ca+12>>2]);ad=ea(g[Ca+16>>2]);bd=ea(g[Ca+20>>2]);cd=ea(g[Ca+24>>2]);dd=ea(g[Ca+28>>2]);ed=ea(xa*sa);sa=ea(ua*Yb);Yb=ea(va*fc);fc=ea(wa*oc);oc=ea(xa*ra);ra=ea(ua*Zb);Zb=ea(va*gc);gc=ea(wa*pc);pc=ea(xa*qa);qa=ea(ua*_b);_b=ea(va*hc);hc=ea(wa*qc);qc=ea(xa*ta);ta=ea(ua*$b);$b=ea(va*ic);ic=ea(wa*rc);rc=ea(xa*oa);oa=ea(ua*ac);ac=ea(va*jc);jc=ea(wa*sc);sc=ea(xa*na);na=ea(ua*bc);bc=ea(va*kc);kc=ea(wa*tc);tc=ea(xa*ma);ma=ea(ua*cc);cc=ea(va*lc);lc=ea(wa*uc);uc=ea(xa*pa);pa=ea(ua*dc);dc=ea(va*mc);mc=ea(wa*vc);vc=ea(xa*Xb);Xb=ea(ua*ec);ec=ea(va*nc);nc=ea(wa*wc);wc=ea(ca*xc);xc=ea(ha*Gc);Gc=ea(ga*Pc);Pc=ea(fa*Yc);Yc=ea(ca*yc);yc=ea(ha*Hc);Hc=ea(ga*Qc);Qc=ea(fa*Zc);Zc=ea(ca*zc);zc=ea(ha*Ic);Ic=ea(ga*Rc);Rc=ea(fa*_c);_c=ea(ca*Ac);Ac=ea(ha*Jc);Jc=ea(ga*Sc);Sc=ea(fa*$c);$c=ea(ca*Bc);Bc=ea(ha*Kc);Kc=ea(ga*Tc);Tc=ea(fa*ad);ad=ea(ca*Cc);Cc=ea(ha*Lc);Lc=ea(ga*Uc);Uc=ea(fa*bd);bd=ea(ca*Dc);Dc=ea(ha*Mc);Mc=ea(ga*Vc);Vc=ea(fa*cd);cd=ea(ca*Ec);Ec=ea(ha*Nc);Nc=ea(ga*Wc);Wc=ea(fa*dd);dd=ea(ca*Fc);Fc=ea(ha*Oc);Oc=ea(ga*Xc);Xc=ea(fa*ea(g[Ca+32>>2]));fa=ea(j*ea(.800000011));Ca=c[d+28>>2]|0;ga=ea(g[Ca+16>>2]);ha=ea(g[Ca+20>>2]);ca=ea(g[Ca+24>>2]);Ca=c[d+84>>2]|0;wa=ea(g[Ca+16>>2]);va=ea(g[Ca+20>>2]);ua=ea(g[Ca+24>>2]);Ca=c[d+140>>2]|0;xa=ea(g[Ca+16>>2]);fd=ea(g[Ca+20>>2]);gd=ea(g[Ca+24>>2]);Ca=c[d+196>>2]|0;hd=ea(g[Ca+16>>2]);id=ea(g[Ca+20>>2]);jd=ea(g[Ca+24>>2]);Ca=c[d+32>>2]|0;kd=ea(g[Ca+16>>2]);ld=ea(g[Ca+20>>2]);md=ea(g[Ca+24>>2]);Ca=c[d+88>>2]|0;nd=ea(g[Ca+16>>2]);od=ea(g[Ca+20>>2]);pd=ea(g[Ca+24>>2]);Ca=c[d+144>>2]|0;qd=ea(g[Ca+16>>2]);rd=ea(g[Ca+20>>2]);sd=ea(g[Ca+24>>2]);Ca=c[d+200>>2]|0;td=ea(g[Ca+16>>2]);ud=ea(g[Ca+20>>2]);vd=ea(g[Ca+24>>2]);Ca=d+8|0;Aa=c[Ca>>2]|0;V=d+64|0;R=c[V>>2]|0;p=d+120|0;r=c[p>>2]|0;q=d+176|0;s=c[q>>2]|0;eb=r>>>0<s>>>0?s:r;r=R>>>0<eb>>>0?eb:R;R=Aa>>>0<r>>>0?r:Aa;if(!R){i=o;return 1}Aa=h+((R*112|0)+(da($,n)|0))|0;n=ba?7:8;r=ba?13:14;eb=(m|0)==2&1;s=t+4|0;ab=t+8|0;Ya=t+12|0;Ua=w+4|0;Qa=w+8|0;Q=w+12|0;U=v+4|0;X=v+8|0;_=v+12|0;wd=y+4|0;xd=y+8|0;yd=y+12|0;zd=A+4|0;Ad=A+8|0;Bd=A+12|0;Cd=z+4|0;Dd=z+8|0;Ed=z+12|0;Fd=C+4|0;Gd=C+8|0;Hd=C+12|0;Id=B+4|0;Jd=B+8|0;Kd=B+12|0;Ld=E+4|0;Md=E+8|0;Nd=E+12|0;Od=D+4|0;Pd=D+8|0;Qd=D+12|0;Rd=N+4|0;Sd=N+8|0;Td=N+12|0;Ud=N+16|0;Vd=N+20|0;Wd=N+24|0;Xd=N+28|0;Yd=O+4|0;Zd=O+8|0;_d=O+12|0;$d=O+16|0;ae=O+20|0;be=O+24|0;ce=O+28|0;de=P+4|0;ee=P+8|0;fe=P+12|0;ge=P+16|0;he=P+20|0;ie=P+24|0;je=P+28|0;ke=G+4|0;le=G+8|0;me=G+12|0;ne=H+4|0;oe=H+8|0;pe=H+12|0;qe=K+4|0;re=K+8|0;se=K+12|0;te=(m|0)==0;ue=M+4|0;ve=M+8|0;we=M+12|0;xe=d+172|0;ye=d+116|0;ze=d+60|0;Ae=d+4|0;d=da(Y,m)|0;Be=0;Ce=0;De=0;Ee=0;Fe=0;Ge=h;h=Aa;while(1){Aa=Fe>>>0>=(c[Ca>>2]|0)>>>0;He=Fe>>>0>=(c[V>>2]|0)>>>0;Ie=Fe>>>0>=(c[p>>2]|0)>>>0;Je=Fe>>>0>=(c[q>>2]|0)>>>0;if(Aa)Ke=Be;else Ke=(c[Ae>>2]|0)+Fe|0;if(He)Le=Ce;else Le=(c[ze>>2]|0)+Fe|0;if(Ie)Me=De;else Me=(c[ye>>2]|0)+Fe|0;if(Je)Ne=Ee;else Ne=(c[xe>>2]|0)+Fe|0;if(Aa)Oe=0;else Oe=c[l+(Ke<<2)+1408>>2]|0;if(He)Pe=0;else Pe=c[l+(Le<<2)+1408>>2]|0;if(Ie)Qe=0;else Qe=c[l+(Me<<2)+1408>>2]|0;if(Je)Re=0;else Re=c[l+(Ne<<2)+1408>>2]|0;if(Aa)Se=0;else Se=e[l+(Ke*20|0)+784>>1]|0;if(He)Te=0;else Te=e[l+(Le*20|0)+784>>1]|0;if(Ie)Ue=0;else Ue=e[l+(Me*20|0)+784>>1]|0;if(Je)Ve=0;else Ve=e[l+(Ne*20|0)+784>>1]|0;We=Qe>>>0<Re>>>0?Re:Qe;Xe=Pe>>>0<We>>>0?We:Pe;We=Oe>>>0<Xe>>>0?Xe:Oe;Xe=Ue>>>0<Ve>>>0?Ve:Ue;Ye=Te>>>0<Xe>>>0?Xe:Te;Xe=c[l+(Ke<<2)+1536>>2]|0;Ze=c[l+(Le<<2)+1536>>2]|0;_e=c[l+(Me<<2)+1536>>2]|0;$e=c[l+(Ne<<2)+1536>>2]|0;af=e[l+(Xe*12|0)>>1]|0;bf=e[l+(Ze*12|0)>>1]|0;cf=e[l+(_e*12|0)>>1]|0;df=e[l+($e*12|0)>>1]|0;ef=ea(g[f+(af<<6)+444>>2]);ff=ea(g[f+(bf<<6)+444>>2]);gf=ea(g[f+(cf<<6)+444>>2]);hf=ea(g[f+(df<<6)+444>>2]);jf=ea(g[f+(af<<6)+428>>2]);kf=ea(g[f+(bf<<6)+428>>2]);lf=ea(g[f+(cf<<6)+428>>2]);mf=ea(g[f+(df<<6)+428>>2]);b[Ge+2>>1]=h-Ge;nf=Ge+112|0;of=h+((We<<4)+64)|0;pf=Oe&255;a[Ge+4>>0]=pf;qf=Pe&255;a[Ge+5>>0]=qf;rf=Qe&255;a[Ge+6>>0]=rf;sf=Re&255;a[Ge+7>>0]=sf;tf=We&255;a[Ge+1>>0]=tf;g[Ge+80>>2]=Wb;g[Ge+84>>2]=Pb;g[Ge+88>>2]=Qb;g[Ge+92>>2]=Rb;g[Ge+96>>2]=Sb;g[Ge+100>>2]=Tb;g[Ge+104>>2]=Ub;g[Ge+108>>2]=Vb;g[Ge+16>>2]=ef;g[Ge+20>>2]=ff;g[Ge+24>>2]=gf;g[Ge+28>>2]=hf;a[Ge+8>>0]=S;a[Ge+9>>0]=W;a[Ge+10>>0]=Z;a[Ge+11>>0]=aa;a[Ge>>0]=n;g[h+32>>2]=Wb;g[h+36>>2]=Pb;g[h+40>>2]=Qb;g[h+44>>2]=Rb;g[h+48>>2]=Sb;g[h+52>>2]=Tb;g[h+56>>2]=Ub;g[h+60>>2]=Vb;a[h+7>>0]=Se;a[h+8>>0]=Te;a[h+9>>0]=Ue;a[h+10>>0]=Ve;a[h+1>>0]=tf;a[h+3>>0]=pf;a[h+4>>0]=qf;a[h+5>>0]=rf;a[h+6>>0]=sf;a[h>>0]=r;g[h+16>>2]=jf;g[h+20>>2]=kf;g[h+24>>2]=lf;g[h+28>>2]=mf;c[h+12>>2]=eb;a[h+2>>0]=Se>>>0<Ye>>>0?Ye:Se;Ye=f+(af<<6)+384|0;mf=ea(g[Ye>>2]);lf=ea(g[Ye+4>>2]);kf=ea(g[Ye+8>>2]);Ye=f+(bf<<6)+384|0;jf=ea(g[Ye>>2]);uf=ea(g[Ye+4>>2]);vf=ea(g[Ye+8>>2]);Ye=f+(cf<<6)+384|0;wf=ea(g[Ye>>2]);xf=ea(g[Ye+4>>2]);yf=ea(g[Ye+8>>2]);Ye=f+(df<<6)+384|0;zf=ea(g[Ye>>2]);Af=ea(g[Ye+4>>2]);Bf=ea(g[Ye+8>>2]);g[Ge+32>>2]=mf;g[Ge+36>>2]=jf;g[Ge+40>>2]=wf;g[Ge+44>>2]=zf;g[Ge+48>>2]=lf;g[Ge+52>>2]=uf;g[Ge+56>>2]=xf;g[Ge+60>>2]=Af;g[Ge+64>>2]=kf;g[Ge+68>>2]=vf;g[Ge+72>>2]=yf;g[Ge+76>>2]=Bf;Cf=ea(ea(kf*kf)+ea(ea(mf*mf)+ea(lf*lf)));Df=ea(ea(vf*vf)+ea(ea(jf*jf)+ea(uf*uf)));Ef=ea(ea(yf*yf)+ea(ea(wf*wf)+ea(xf*xf)));Ff=ea(ea(Bf*Bf)+ea(ea(zf*zf)+ea(Af*Af)));Gf=ea(ea(Ga*kf)+ea(ea(la*mf)+ea(Fa*lf)));Hf=ea(ea(Ja*vf)+ea(ea(Ha*jf)+ea(Ia*uf)));If=ea(ea(Ma*yf)+ea(ea(Ka*wf)+ea(La*xf)));Jf=ea(ea(Pa*Bf)+ea(ea(Na*zf)+ea(Oa*Af)));Kf=ea(ea(Ta*kf)+ea(ea(Ra*mf)+ea(Sa*lf)));Lf=ea(ea(Xa*vf)+ea(ea(Va*jf)+ea(Wa*uf)));Mf=ea(ea($a*yf)+ea(ea(Za*wf)+ea(_a*xf)));Nf=ea(ea(db*Bf)+ea(ea(bb*zf)+ea(cb*Af)));Of=ea(Wb*Cf);Pf=ea(Pb*Df);Qf=ea(Qb*Ef);Rf=ea(Rb*Ff);Sf=ea(Cf*Sb);Cf=ea(Df*Tb);Df=ea(Ef*Ub);Ef=ea(Ff*Vb);Ff=ea(-mf);Tf=ea(-jf);Uf=ea(-wf);Vf=ea(-zf);Ye=(mf>Ff?mf:Ff)<ea(.707106769);df=(jf>Tf?jf:Tf)<ea(.707106769);cf=(wf>Uf?wf:Uf)<ea(.707106769);bf=(zf>Vf?zf:Vf)<ea(.707106769);Vf=ea(-lf);Uf=ea(-uf);Tf=ea(-xf);Ff=ea(-Af);c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;g[t>>2]=Vf;g[s>>2]=Uf;g[ab>>2]=Tf;g[Ya>>2]=Ff;Ff=ea(g[(Ye?u:t)>>2]);Tf=ea(g[(df?u:t)+4>>2]);Uf=ea(g[(cf?u:t)+8>>2]);Vf=ea(g[(bf?u:t)+12>>2]);Wf=ea(-vf);Xf=ea(-yf);Yf=ea(-Bf);g[w>>2]=ea(-kf);g[Ua>>2]=Wf;g[Qa>>2]=Xf;g[Q>>2]=Yf;g[v>>2]=mf;g[U>>2]=jf;g[X>>2]=wf;g[_>>2]=zf;Yf=ea(g[(Ye?w:v)>>2]);Xf=ea(g[(df?w:v)+4>>2]);Wf=ea(g[(cf?w:v)+8>>2]);Zf=ea(g[(bf?w:v)+12>>2]);g[y>>2]=lf;g[wd>>2]=uf;g[xd>>2]=xf;g[yd>>2]=Af;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;_f=ea(g[(Ye?y:x)>>2]);$f=ea(g[(df?y:x)+4>>2]);ag=ea(g[(cf?y:x)+8>>2]);bg=ea(g[(bf?y:x)+12>>2]);cg=ea(ea(Lb*kf)+ea(ea(Db*mf)+ea(Hb*lf)));dg=ea(ea(Mb*vf)+ea(ea(Eb*jf)+ea(Ib*uf)));eg=ea(ea(Nb*yf)+ea(ea(Fb*wf)+ea(Jb*xf)));fg=ea(ea(Ob*Bf)+ea(ea(Gb*zf)+ea(Kb*Af)));gg=ea(Db-ea(mf*cg));hg=ea(Eb-ea(jf*dg));ig=ea(Fb-ea(wf*eg));jg=ea(Gb-ea(zf*fg));kg=ea(Hb-ea(lf*cg));lg=ea(Ib-ea(uf*dg));mg=ea(Jb-ea(xf*eg));ng=ea(Kb-ea(Af*fg));og=ea(Lb-ea(kf*cg));cg=ea(Mb-ea(vf*dg));dg=ea(Nb-ea(yf*eg));eg=ea(Ob-ea(Bf*fg));bf=ea(ea(gg*gg)+ea(ea(kg*kg)+ea(og*og)))>ea(.100000001);cf=ea(ea(hg*hg)+ea(ea(lg*lg)+ea(cg*cg)))>ea(.100000001);df=ea(ea(ig*ig)+ea(ea(mg*mg)+ea(dg*dg)))>ea(.100000001);Ye=ea(ea(jg*jg)+ea(ea(ng*ng)+ea(eg*eg)))>ea(.100000001);g[A>>2]=gg;g[zd>>2]=hg;g[Ad>>2]=ig;g[Bd>>2]=jg;g[z>>2]=Ff;g[Cd>>2]=Tf;g[Dd>>2]=Uf;g[Ed>>2]=Vf;Vf=ea(g[(bf?A:z)>>2]);Uf=ea(g[(cf?A:z)+4>>2]);Tf=ea(g[(df?A:z)+8>>2]);Ff=ea(g[(Ye?A:z)+12>>2]);g[C>>2]=kg;g[Fd>>2]=lg;g[Gd>>2]=mg;g[Hd>>2]=ng;g[B>>2]=Yf;g[Id>>2]=Xf;g[Jd>>2]=Wf;g[Kd>>2]=Zf;Zf=ea(g[(bf?C:B)>>2]);Wf=ea(g[(cf?C:B)+4>>2]);Xf=ea(g[(df?C:B)+8>>2]);Yf=ea(g[(Ye?C:B)+12>>2]);g[E>>2]=og;g[Ld>>2]=cg;g[Md>>2]=dg;g[Nd>>2]=eg;g[D>>2]=_f;g[Od>>2]=$f;g[Pd>>2]=ag;g[Qd>>2]=bg;bg=ea(g[(bf?E:D)>>2]);ag=ea(g[(cf?E:D)+4>>2]);$f=ea(g[(df?E:D)+8>>2]);_f=ea(g[(Ye?E:D)+12>>2]);eg=ea(ea(1.0)/ea(T(ea(ea(Vf*Vf)+ea(ea(Zf*Zf)+ea(bg*bg))))));dg=ea(ea(1.0)/ea(T(ea(ea(Uf*Uf)+ea(ea(Wf*Wf)+ea(ag*ag))))));cg=ea(ea(1.0)/ea(T(ea(ea(Tf*Tf)+ea(ea(Xf*Xf)+ea($f*$f))))));og=ea(ea(1.0)/ea(T(ea(ea(Ff*Ff)+ea(ea(Yf*Yf)+ea(_f*_f))))));ng=ea(Vf*eg);Vf=ea(Uf*dg);Uf=ea(Tf*cg);Tf=ea(Ff*og);Ff=ea(Zf*eg);Zf=ea(Wf*dg);Wf=ea(Xf*cg);Xf=ea(Yf*og);Yf=ea(bg*eg);eg=ea(ag*dg);dg=ea($f*cg);cg=ea(_f*og);og=ea(ea(lf*Yf)-ea(kf*Ff));_f=ea(ea(uf*eg)-ea(vf*Zf));$f=ea(ea(xf*dg)-ea(yf*Wf));ag=ea(ea(Af*cg)-ea(Bf*Xf));bg=ea(ea(kf*ng)-ea(mf*Yf));mg=ea(ea(vf*Vf)-ea(jf*eg));lg=ea(ea(yf*Uf)-ea(wf*dg));kg=ea(ea(Bf*Tf)-ea(zf*cg));jg=ea(ea(mf*Ff)-ea(lf*ng));ig=ea(ea(jf*Zf)-ea(uf*Vf));hg=ea(ea(wf*Wf)-ea(xf*Uf));gg=ea(ea(zf*Xf)-ea(Af*Tf));g[N>>2]=ng;g[Rd>>2]=Vf;g[Sd>>2]=Uf;g[Td>>2]=Tf;g[Ud>>2]=og;g[Vd>>2]=_f;g[Wd>>2]=$f;g[Xd>>2]=ag;g[O>>2]=Ff;g[Yd>>2]=Zf;g[Zd>>2]=Wf;g[_d>>2]=Xf;g[$d>>2]=bg;g[ae>>2]=mg;g[be>>2]=lg;g[ce>>2]=kg;g[P>>2]=Yf;g[de>>2]=eg;g[ee>>2]=dg;g[fe>>2]=cg;g[ge>>2]=jg;g[he>>2]=ig;g[ie>>2]=hg;g[je>>2]=gg;Ye=(He&1)<<1|Aa&1|(Ie&1)<<2|(Je&1)<<3;a:do if((Xe|0)==65535)pg=65535;else{df=Xe;while(1){if(b[l+(df*12|0)+2>>1]|0){pg=df;break a}cf=b[l+(df*12|0)+4>>1]|0;bf=cf&65535;if(cf<<16>>16==-1){pg=bf;break}else df=bf}}while(0);b:do if((Ze|0)==65535)qg=65535;else{Xe=Ze;while(1){if(b[l+(Xe*12|0)+2>>1]|0){qg=Xe;break b}df=b[l+(Xe*12|0)+4>>1]|0;bf=df&65535;if(df<<16>>16==-1){qg=bf;break}else Xe=bf}}while(0);c:do if((_e|0)==65535)rg=65535;else{Ze=_e;while(1){if(b[l+(Ze*12|0)+2>>1]|0){rg=Ze;break c}Xe=b[l+(Ze*12|0)+4>>1]|0;bf=Xe&65535;if(Xe<<16>>16==-1){rg=bf;break}else Ze=bf}}while(0);d:do if(($e|0)==65535)sg=65535;else{_e=$e;while(1){if(b[l+(_e*12|0)+2>>1]|0){sg=_e;break d}Ze=b[l+(_e*12|0)+4>>1]|0;bf=Ze&65535;if(Ze<<16>>16==-1){sg=bf;break}else _e=bf}}while(0);e:do if((pg|0)==65535){tg=1;ug=65535}else{$e=1;_e=pg;while(1){if(($e|0)!=(e[l+(_e*12|0)+2>>1]|0)){tg=$e;ug=_e;break e}bf=b[l+(_e*12|0)+4>>1]|0;Ze=bf&65535;if(bf<<16>>16==-1){tg=0;ug=Ze;break}else{$e=0;_e=Ze}}}while(0);f:do if((qg|0)==65535){vg=1;wg=65535}else{_e=1;$e=qg;while(1){if((_e|0)!=(e[l+($e*12|0)+2>>1]|0)){vg=_e;wg=$e;break f}Ze=b[l+($e*12|0)+4>>1]|0;bf=Ze&65535;if(Ze<<16>>16==-1){vg=0;wg=bf;break}else{_e=0;$e=bf}}}while(0);g:do if((rg|0)==65535){xg=1;yg=65535}else{$e=1;_e=rg;while(1){if(($e|0)!=(e[l+(_e*12|0)+2>>1]|0)){xg=$e;yg=_e;break g}bf=b[l+(_e*12|0)+4>>1]|0;Ze=bf&65535;if(bf<<16>>16==-1){xg=0;yg=Ze;break}else{$e=0;_e=Ze}}}while(0);h:do if((sg|0)==65535){zg=1;Ag=65535}else{_e=1;$e=sg;while(1){if((_e|0)!=(e[l+($e*12|0)+2>>1]|0)){zg=_e;Ag=$e;break h}Ze=b[l+($e*12|0)+4>>1]|0;bf=Ze&65535;if(Ze<<16>>16==-1){zg=0;Ag=bf;break}else{_e=0;$e=bf}}}while(0);if(Aa|(ug|0)==65535)Bg=1;else Bg=tg>>>0>=(e[l+(ug*12|0)+2>>1]|0)>>>0;if(He|(wg|0)==65535)Cg=1;else Cg=vg>>>0>=(e[l+(wg*12|0)+2>>1]|0)>>>0;if(Ie|(yg|0)==65535)Dg=1;else Dg=xg>>>0>=(e[l+(yg*12|0)+2>>1]|0)>>>0;if(Je|(Ag|0)==65535)Eg=1;else Eg=zg>>>0>=(e[l+(Ag*12|0)+2>>1]|0)>>>0;$e=ef>ea(0.0);_e=ff>ea(0.0);bf=gf>ea(0.0);Ze=hf>ea(0.0);Xe=tg;df=vg;cf=xg;af=zg;sf=0;rf=0;qf=0;pf=0;tf=pg;We=qg;Fg=rg;Gg=sg;Hg=Ye;Ig=0;Jg=(Cg&1)<<1|Bg&1|(Dg&1)<<2|(Eg&1)<<3;Kg=Ag;Lg=yg;Mg=wg;Ng=ug;Og=nf;Pg=of;i:while(1){Qg=l+(Gg*12|0)|0;Rg=tf;Sg=sf;Tg=We;Ug=rf;Vg=Fg;Wg=qf;Xg=Xe;Yg=df;Zg=cf;_g=Hg;$g=Ig;ah=Jg;bh=Lg;ch=Mg;dh=Ng;eh=Og;fh=Pg;while(1){if((_g|0)==15)break i;gh=eh+$|0;hh=(e[l+(Rg*12|0)>>1]|0)+Sg|0;ih=(e[l+(Tg*12|0)>>1]|0)+Ug|0;jh=(e[l+(Vg*12|0)>>1]|0)+Wg|0;kh=(e[Qg>>1]|0)+pf|0;lh=f+(hh<<6)+400|0;gg=ea(g[lh>>2]);hg=ea(g[lh+4>>2]);ig=ea(g[lh+8>>2]);lh=f+(ih<<6)+400|0;jg=ea(g[lh>>2]);cg=ea(g[lh+4>>2]);dg=ea(g[lh+8>>2]);lh=f+(jh<<6)+400|0;eg=ea(g[lh>>2]);Yf=ea(g[lh+4>>2]);kg=ea(g[lh+8>>2]);lh=f+(kh<<6)+400|0;lg=ea(g[lh>>2]);mg=ea(g[lh+4>>2]);bg=ea(g[lh+8>>2]);lh=f+(hh<<6)+416|0;Xf=ea(g[lh>>2]);mh=lh+4|0;Wf=ea(g[mh>>2]);nh=lh+8|0;Zf=ea(g[nh>>2]);oh=f+(ih<<6)+416|0;Ff=ea(g[oh>>2]);ph=oh+4|0;ag=ea(g[ph>>2]);qh=oh+8|0;$f=ea(g[qh>>2]);rh=f+(jh<<6)+416|0;_f=ea(g[rh>>2]);sh=rh+4|0;og=ea(g[sh>>2]);th=rh+8|0;Tf=ea(g[th>>2]);uh=f+(kh<<6)+416|0;Uf=ea(g[uh>>2]);vh=uh+4|0;Vf=ea(g[vh>>2]);wh=uh+8|0;ng=ea(g[wh>>2]);fg=ea(g[f+(hh<<6)+396>>2]);xh=ea(g[f+(ih<<6)+396>>2]);yh=ea(g[f+(jh<<6)+396>>2]);zh=ea(g[f+(kh<<6)+396>>2]);Ah=ea(g[f+(hh<<6)+412>>2]);Bh=ea(g[f+(ih<<6)+412>>2]);Ch=ea(g[f+(jh<<6)+412>>2]);Dh=ea(g[f+(kh<<6)+412>>2]);Eh=ea(ea(mf*Xf)+ea(ea(lf*Wf)+ea(kf*Zf)));Zf=ea(ea(jf*Ff)+ea(ea(uf*ag)+ea(vf*$f)));$f=ea(ea(wf*_f)+ea(ea(xf*og)+ea(yf*Tf)));Tf=ea(ea(zf*Uf)+ea(ea(Af*Vf)+ea(Bf*ng)));ng=ea(gg-ga);Vf=ea(jg-wa);Uf=ea(eg-xa);og=ea(lg-hd);_f=ea(hg-ha);ag=ea(cg-va);Ff=ea(Yf-fd);Wf=ea(mg-id);Xf=ea(ig-ca);Fh=ea(dg-ua);Gh=ea(kg-gd);Hh=ea(bg-jd);Ih=ea(gg-kd);gg=ea(jg-nd);jg=ea(eg-qd);eg=ea(lg-td);lg=ea(hg-ld);hg=ea(cg-od);cg=ea(Yf-rd);Yf=ea(mg-ud);mg=ea(ig-md);ig=ea(dg-pd);dg=ea(kg-sd);kg=ea(bg-vd);bg=ea(ea(kf*_f)-ea(lf*Xf));Jh=ea(ea(vf*ag)-ea(uf*Fh));Kh=ea(ea(yf*Ff)-ea(xf*Gh));Lh=ea(ea(Bf*Wf)-ea(Af*Hh));Mh=ea(ea(mf*Xf)-ea(kf*ng));Nh=ea(ea(jf*Fh)-ea(vf*Vf));Oh=ea(ea(wf*Gh)-ea(yf*Uf));Ph=ea(ea(zf*Hh)-ea(Bf*og));Qh=ea(ea(lf*ng)-ea(mf*_f));Rh=ea(ea(uf*Vf)-ea(jf*ag));Sh=ea(ea(xf*Uf)-ea(wf*Ff));Th=ea(ea(Af*og)-ea(zf*Wf));Uh=ea(ea(pc*Qh)+ea(ea(oc*Mh)+ea(ed*bg)));Vh=ea(ea(qa*Rh)+ea(ea(ra*Nh)+ea(sa*Jh)));Wh=ea(ea(_b*Sh)+ea(ea(Zb*Oh)+ea(Yb*Kh)));Xh=ea(ea(hc*Th)+ea(ea(gc*Ph)+ea(fc*Lh)));Yh=ea(ea(sc*Qh)+ea(ea(rc*Mh)+ea(qc*bg)));Zh=ea(ea(na*Rh)+ea(ea(oa*Nh)+ea(ta*Jh)));_h=ea(ea(bc*Sh)+ea(ea(ac*Oh)+ea($b*Kh)));$h=ea(ea(kc*Th)+ea(ea(jc*Ph)+ea(ic*Lh)));ai=ea(ea(vc*Qh)+ea(ea(uc*Mh)+ea(tc*bg)));bi=ea(ea(Xb*Rh)+ea(ea(pa*Nh)+ea(ma*Jh)));ci=ea(ea(ec*Sh)+ea(ea(dc*Oh)+ea(cc*Kh)));di=ea(ea(nc*Th)+ea(ea(mc*Ph)+ea(lc*Lh)));ei=ea(Of+ea(ea(Qh*ai)+ea(ea(Mh*Yh)+ea(bg*Uh))));fi=ea(Pf+ea(ea(Rh*bi)+ea(ea(Nh*Zh)+ea(Jh*Vh))));gi=ea(Qf+ea(ea(Sh*ci)+ea(ea(Oh*_h)+ea(Kh*Wh))));hi=ea(Rf+ea(ea(Th*di)+ea(ea(Ph*$h)+ea(Lh*Xh))));ii=ea(Gf+ea(ea(hb*Qh)+ea(ea(gb*Mh)+ea(fb*bg))));ji=ea(Hf+ea(ea(kb*Rh)+ea(ea(jb*Nh)+ea(ib*Jh))));ki=ea(If+ea(ea(nb*Sh)+ea(ea(mb*Oh)+ea(lb*Kh))));li=ea(Jf+ea(ea(qb*Th)+ea(ea(pb*Ph)+ea(ob*Lh))));if(ba){mi=ea(ea(kf*lg)-ea(lf*mg));ni=ea(ea(vf*hg)-ea(uf*ig));oi=ea(ea(yf*cg)-ea(xf*dg));pi=ea(ea(Bf*Yf)-ea(Af*kg));qi=ea(ea(mf*mg)-ea(kf*Ih));ri=ea(ea(jf*ig)-ea(vf*gg));si=ea(ea(wf*dg)-ea(yf*jg));ti=ea(ea(zf*kg)-ea(Bf*eg));ui=ea(ea(lf*Ih)-ea(mf*lg));vi=ea(ea(uf*gg)-ea(jf*hg));wi=ea(ea(xf*jg)-ea(wf*cg));xi=ea(ea(Af*eg)-ea(zf*Yf));yi=ea(ea(Zc*ui)+ea(ea(Yc*qi)+ea(wc*mi)));zi=ea(ea(zc*vi)+ea(ea(yc*ri)+ea(xc*ni)));Ai=ea(ea(Ic*wi)+ea(ea(Hc*si)+ea(Gc*oi)));Bi=ea(ea(Rc*xi)+ea(ea(Qc*ti)+ea(Pc*pi)));Ci=ea(ea(ad*ui)+ea(ea($c*qi)+ea(_c*mi)));Di=ea(ea(Cc*vi)+ea(ea(Bc*ri)+ea(Ac*ni)));Ei=ea(ea(Lc*wi)+ea(ea(Kc*si)+ea(Jc*oi)));Fi=ea(ea(Uc*xi)+ea(ea(Tc*ti)+ea(Sc*pi)));Gi=ea(ea(dd*ui)+ea(ea(cd*qi)+ea(bd*mi)));Hi=ea(ea(Fc*vi)+ea(ea(Ec*ri)+ea(Dc*ni)));Ii=ea(ea(Oc*wi)+ea(ea(Nc*si)+ea(Mc*oi)));Ji=ea(ea(Xc*xi)+ea(ea(Wc*ti)+ea(Vc*pi)));Ki=ea(ei+ea(ea(ea(ui*Gi)+ea(ea(qi*Ci)+ea(mi*yi)))-Sf));Li=ea(fi+ea(ea(ea(vi*Hi)+ea(ea(ri*Di)+ea(ni*zi)))-Cf));Mi=ea(gi+ea(ea(ea(wi*Ii)+ea(ea(si*Ei)+ea(oi*Ai)))-Df));Ni=ea(hi+ea(ea(ea(xi*Ji)+ea(ea(ti*Fi)+ea(pi*Bi)))-Ef));Oi=ea(ii-ea(Kf+ea(ea(tb*ui)+ea(ea(sb*qi)+ea(rb*mi)))));Pi=ea(ji-ea(Lf+ea(ea(wb*vi)+ea(ea(vb*ri)+ea(ub*ni)))));Qi=ea(ki-ea(Mf+ea(ea(zb*wi)+ea(ea(yb*si)+ea(xb*oi)))));Ri=ea(li-ea(Nf+ea(ea(Cb*xi)+ea(ea(Bb*ti)+ea(Ab*pi)))));g[eh+176>>2]=mi;g[eh+180>>2]=ni;g[eh+184>>2]=oi;g[eh+188>>2]=pi;g[eh+192>>2]=qi;g[eh+196>>2]=ri;g[eh+200>>2]=si;g[eh+204>>2]=ti;g[eh+208>>2]=ui;g[eh+212>>2]=vi;g[eh+216>>2]=wi;g[eh+220>>2]=xi;xi=ea(-zi);zi=ea(-Ai);Ai=ea(-Bi);g[eh+224>>2]=ea(-yi);g[eh+228>>2]=xi;g[eh+232>>2]=zi;g[eh+236>>2]=Ai;Ai=ea(-Di);Di=ea(-Ei);Ei=ea(-Fi);g[eh+240>>2]=ea(-Ci);g[eh+244>>2]=Ai;g[eh+248>>2]=Di;g[eh+252>>2]=Ei;Ei=ea(-Hi);Hi=ea(-Ii);Ii=ea(-Ji);g[eh+256>>2]=ea(-Gi);g[eh+260>>2]=Ei;g[eh+264>>2]=Hi;g[eh+268>>2]=Ii;Si=Ki;Ti=Li;Ui=Mi;Vi=Ni;Wi=Oi;Xi=Pi;Yi=Qi;Zi=Ri}else{Si=ei;Ti=fi;Ui=gi;Vi=hi;Wi=ii;Xi=ji;Yi=ki;Zi=li}kh=Si>ea(0.0);jh=Ti>ea(0.0);ih=Ui>ea(0.0);hh=Vi>ea(0.0);li=ea(ea(1.0)/Ti);ki=ea(ea(1.0)/Ui);ji=ea(ea(1.0)/Vi);g[G>>2]=ea(ea(1.0)/Si);g[ke>>2]=li;g[le>>2]=ki;g[me>>2]=ji;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;ji=ea(g[(kh?G:F)>>2]);ki=ea(g[(jh?G:F)+4>>2]);li=ea(g[(ih?G:F)+8>>2]);ii=ea(g[(hh?G:F)+12>>2]);hi=ea(fg-Da);fg=ea(xh-ia);xh=ea(yh-ja);yh=ea(zh-ka);zh=ea(fa*hi);gi=ea(fa*fg);fi=ea(fa*xh);ei=ea(fa*yh);Ri=ea((Ea>zh?Ea:zh)*ji);zh=ea((ya>gi?ya:gi)*ki);gi=ea((za>fi?za:fi)*li);fi=ea((Ba>ei?Ba:ei)*ii);ei=ea(-Wi);Qi=ea(-Xi);Pi=ea(-Yi);Oi=ea(-Zi);hh=ea(hi*j)<ei&(Wi<k&$e);ih=ea(fg*j)<Qi&(Xi<k&_e);jh=ea(xh*j)<Pi&(Yi<k&bf);kh=ea(yh*j)<Oi&(Zi<k&Ze);c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;g[H>>2]=Ri;g[ne>>2]=zh;g[oe>>2]=gi;g[pe>>2]=fi;fi=ea(g[(hh?I:H)>>2]);gi=ea(g[(ih?I:H)+4>>2]);zh=ea(g[(jh?I:H)+8>>2]);Ri=ea(g[(kh?I:H)+12>>2]);yh=ea(ff*Qi);Qi=ea(gf*Pi);Pi=ea(hf*Oi);g[K>>2]=ea(ef*ei);g[qe>>2]=yh;g[re>>2]=Qi;g[se>>2]=Pi;c[J+0>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;c[J+12>>2]=0;Pi=ea(g[(hh?K:J)>>2]);Qi=ea(g[(ih?K:J)+4>>2]);yh=ea(g[(jh?K:J)+8>>2]);ei=ea(Eh+Pi);Pi=ea(Zf+Qi);Qi=ea($f+yh);yh=ea(Tf+ea(g[(kh?K:J)+12>>2]));g[eh>>2]=bg;g[eh+4>>2]=Jh;g[eh+8>>2]=Kh;g[eh+12>>2]=Lh;g[eh+16>>2]=Mh;g[eh+20>>2]=Nh;g[eh+24>>2]=Oh;g[eh+28>>2]=Ph;g[eh+32>>2]=Qh;g[eh+36>>2]=Rh;g[eh+40>>2]=Sh;g[eh+44>>2]=Th;g[eh+112>>2]=ji;g[eh+116>>2]=ki;g[eh+120>>2]=li;g[eh+124>>2]=ii;kh=eh+96|0;c[kh+0>>2]=0;c[kh+4>>2]=0;c[kh+8>>2]=0;c[kh+12>>2]=0;g[eh+144>>2]=fi;g[eh+148>>2]=gi;g[eh+152>>2]=zh;g[eh+156>>2]=Ri;g[eh+128>>2]=ei;g[eh+132>>2]=Pi;g[eh+136>>2]=Qi;g[eh+140>>2]=yh;g[eh+160>>2]=Ah;g[eh+164>>2]=Bh;g[eh+168>>2]=Ch;g[eh+172>>2]=Dh;g[eh+48>>2]=Uh;g[eh+52>>2]=Vh;g[eh+56>>2]=Wh;g[eh+60>>2]=Xh;g[eh+64>>2]=Yh;g[eh+68>>2]=Zh;g[eh+72>>2]=_h;g[eh+76>>2]=$h;g[eh+80>>2]=ai;g[eh+84>>2]=bi;g[eh+88>>2]=ci;g[eh+92>>2]=di;di=ea(g[lh>>2]);ci=ea(g[mh>>2]);bi=ea(g[nh>>2]);ai=ea(g[oh>>2]);$h=ea(g[ph>>2]);_h=ea(g[qh>>2]);Zh=ea(g[rh>>2]);Yh=ea(g[sh>>2]);Xh=ea(g[th>>2]);Wh=ea(g[uh>>2]);Vh=ea(g[vh>>2]);Uh=ea(g[wh>>2]);if(te){_i=$g;$i=fh}else{if(ba){wh=0;vh=$g;uh=fh;while(1){Dh=ea(g[N+(vh<<4)>>2]);Ch=ea(g[N+(vh<<4)+4>>2]);Bh=ea(g[N+(vh<<4)+8>>2]);Ah=ea(g[N+(vh<<4)+12>>2]);yh=ea(g[O+(vh<<4)>>2]);Qi=ea(g[O+(vh<<4)+4>>2]);Pi=ea(g[O+(vh<<4)+8>>2]);ei=ea(g[O+(vh<<4)+12>>2]);Ri=ea(g[P+(vh<<4)>>2]);zh=ea(g[P+(vh<<4)+4>>2]);gi=ea(g[P+(vh<<4)+8>>2]);fi=ea(g[P+(vh<<4)+12>>2]);th=1-vh|0;ii=ea(ea(_f*Ri)-ea(Xf*yh));li=ea(ea(ag*zh)-ea(Fh*Qi));ki=ea(ea(Ff*gi)-ea(Gh*Pi));ji=ea(ea(Wf*fi)-ea(Hh*ei));Th=ea(ea(Xf*Dh)-ea(ng*Ri));Sh=ea(ea(Fh*Ch)-ea(Vf*zh));Rh=ea(ea(Gh*Bh)-ea(Uf*gi));Qh=ea(ea(Hh*Ah)-ea(og*fi));Ph=ea(ea(ng*yh)-ea(_f*Dh));Oh=ea(ea(Vf*Qi)-ea(ag*Ch));Nh=ea(ea(Uf*Pi)-ea(Ff*Bh));Mh=ea(ea(og*ei)-ea(Wf*Ah));Lh=ea(ea(pc*Ph)+ea(ea(oc*Th)+ea(ed*ii)));Kh=ea(ea(qa*Oh)+ea(ea(ra*Sh)+ea(sa*li)));Jh=ea(ea(_b*Nh)+ea(ea(Zb*Rh)+ea(Yb*ki)));bg=ea(ea(hc*Mh)+ea(ea(gc*Qh)+ea(fc*ji)));Tf=ea(ea(sc*Ph)+ea(ea(rc*Th)+ea(qc*ii)));$f=ea(ea(na*Oh)+ea(ea(oa*Sh)+ea(ta*li)));Zf=ea(ea(bc*Nh)+ea(ea(ac*Rh)+ea($b*ki)));Eh=ea(ea(kc*Mh)+ea(ea(jc*Qh)+ea(ic*ji)));Oi=ea(ea(vc*Ph)+ea(ea(uc*Th)+ea(tc*ii)));xh=ea(ea(Xb*Oh)+ea(ea(pa*Sh)+ea(ma*li)));fg=ea(ea(ec*Nh)+ea(ea(dc*Rh)+ea(cc*ki)));hi=ea(ea(nc*Mh)+ea(ea(mc*Qh)+ea(lc*ji)));Ni=ea(ea(lg*Ri)-ea(mg*yh));Mi=ea(ea(hg*zh)-ea(ig*Qi));Li=ea(ea(cg*gi)-ea(dg*Pi));Ki=ea(ea(Yf*fi)-ea(kg*ei));Ii=ea(ea(mg*Dh)-ea(Ih*Ri));Hi=ea(ea(ig*Ch)-ea(gg*zh));Ei=ea(ea(dg*Bh)-ea(jg*gi));Gi=ea(ea(kg*Ah)-ea(eg*fi));Ji=ea(ea(Ih*yh)-ea(lg*Dh));Di=ea(ea(gg*Qi)-ea(hg*Ch));Ai=ea(ea(jg*Pi)-ea(cg*Bh));Ci=ea(ea(eg*ei)-ea(Yf*Ah));Fi=ea(ea(Zc*Ji)+ea(ea(Yc*Ii)+ea(wc*Ni)));zi=ea(ea(zc*Di)+ea(ea(yc*Hi)+ea(xc*Mi)));xi=ea(ea(Ic*Ai)+ea(ea(Hc*Ei)+ea(Gc*Li)));yi=ea(ea(Rc*Ci)+ea(ea(Qc*Gi)+ea(Pc*Ki)));Bi=ea(ea(ad*Ji)+ea(ea($c*Ii)+ea(_c*Ni)));wi=ea(ea(Cc*Di)+ea(ea(Bc*Hi)+ea(Ac*Mi)));vi=ea(ea(Lc*Ai)+ea(ea(Kc*Ei)+ea(Jc*Li)));ui=ea(ea(Uc*Ci)+ea(ea(Tc*Gi)+ea(Sc*Ki)));ti=ea(ea(dd*Ji)+ea(ea(cd*Ii)+ea(bd*Ni)));si=ea(ea(Fc*Di)+ea(ea(Ec*Hi)+ea(Dc*Mi)));ri=ea(ea(Oc*Ai)+ea(ea(Nc*Ei)+ea(Mc*Li)));qi=ea(ea(Xc*Ci)+ea(ea(Wc*Gi)+ea(Vc*Ki)));pi=ea(ea(Wb+ea(ea(Ph*Oi)+ea(ea(Th*Tf)+ea(ii*Lh))))+ea(ea(ea(Ji*ti)+ea(ea(Ii*Bi)+ea(Ni*Fi)))-Sf));oi=ea(ea(Pb+ea(ea(Oh*xh)+ea(ea(Sh*$f)+ea(li*Kh))))+ea(ea(ea(Di*si)+ea(ea(Hi*wi)+ea(Mi*zi)))-Cf));ni=ea(ea(Qb+ea(ea(Nh*fg)+ea(ea(Rh*Zf)+ea(ki*Jh))))+ea(ea(ea(Ai*ri)+ea(ea(Ei*vi)+ea(Li*xi)))-Df));mi=ea(ea(Rb+ea(ea(Mh*hi)+ea(ea(Qh*Eh)+ea(ji*bg))))+ea(ea(ea(Ci*qi)+ea(ea(Gi*ui)+ea(Ki*yi)))-Ef));g[uh+192>>2]=Ni;g[uh+196>>2]=Mi;g[uh+200>>2]=Li;g[uh+204>>2]=Ki;g[uh+208>>2]=Ii;g[uh+212>>2]=Hi;g[uh+216>>2]=Ei;g[uh+220>>2]=Gi;g[uh+224>>2]=Ji;g[uh+228>>2]=Di;g[uh+232>>2]=Ai;g[uh+236>>2]=Ci;Ci=ea(-zi);zi=ea(-xi);xi=ea(-yi);g[uh+240>>2]=ea(-Fi);g[uh+244>>2]=Ci;g[uh+248>>2]=zi;g[uh+252>>2]=xi;xi=ea(-wi);wi=ea(-vi);vi=ea(-ui);g[uh+256>>2]=ea(-Bi);g[uh+260>>2]=xi;g[uh+264>>2]=wi;g[uh+268>>2]=vi;vi=ea(-si);si=ea(-ri);ri=ea(-qi);g[uh+272>>2]=ea(-ti);g[uh+276>>2]=vi;g[uh+280>>2]=si;g[uh+284>>2]=ri;sh=pi>ea(0.0);rh=oi>ea(0.0);qh=ni>ea(0.0);ph=mi>ea(0.0);ri=ea(ea(1.0)/oi);oi=ea(ea(1.0)/ni);ni=ea(ea(1.0)/mi);g[M>>2]=ea(ea(1.0)/pi);g[ue>>2]=ri;g[ve>>2]=oi;g[we>>2]=ni;c[L+0>>2]=0;c[L+4>>2]=0;c[L+8>>2]=0;c[L+12>>2]=0;ni=ea(g[(sh?M:L)>>2]);oi=ea(g[(rh?M:L)+4>>2]);ri=ea(g[(qh?M:L)+8>>2]);pi=ea(-ni);ni=ea(-oi);oi=ea(-ri);ri=ea(-ea(g[(ph?M:L)+12>>2]));ph=uh+144|0;c[ph+0>>2]=0;c[ph+4>>2]=0;c[ph+8>>2]=0;c[ph+12>>2]=0;g[uh+96>>2]=Lh;g[uh+100>>2]=Kh;g[uh+104>>2]=Jh;g[uh+108>>2]=bg;g[uh+112>>2]=Tf;g[uh+116>>2]=$f;g[uh+120>>2]=Zf;g[uh+124>>2]=Eh;g[uh+128>>2]=Oi;g[uh+132>>2]=xh;g[uh+136>>2]=fg;g[uh+140>>2]=hi;g[uh+48>>2]=ii;g[uh+52>>2]=li;g[uh+56>>2]=ki;g[uh+60>>2]=ji;g[uh+64>>2]=Th;g[uh+68>>2]=Sh;g[uh+72>>2]=Rh;g[uh+76>>2]=Qh;g[uh+80>>2]=Ph;g[uh+84>>2]=Oh;g[uh+88>>2]=Nh;g[uh+92>>2]=Mh;g[uh+160>>2]=pi;g[uh+164>>2]=ni;g[uh+168>>2]=oi;g[uh+172>>2]=ri;ri=ea(ea(ea(ai*Ch)+ea($h*Qi))+ea(_h*zh));oi=ea(ea(ea(Zh*Bh)+ea(Yh*Pi))+ea(Xh*gi));ni=ea(ea(ea(Wh*Ah)+ea(Vh*ei))+ea(Uh*fi));g[uh+176>>2]=ea(ea(ea(di*Dh)+ea(ci*yh))+ea(bi*Ri));g[uh+180>>2]=ri;g[uh+184>>2]=oi;g[uh+188>>2]=ni;g[uh>>2]=Dh;g[uh+4>>2]=Ch;g[uh+8>>2]=Bh;g[uh+12>>2]=Ah;g[uh+16>>2]=yh;g[uh+20>>2]=Qi;g[uh+24>>2]=Pi;g[uh+28>>2]=ei;g[uh+32>>2]=Ri;g[uh+36>>2]=zh;g[uh+40>>2]=gi;g[uh+44>>2]=fi;wh=wh+1|0;if((wh|0)==(m|0)){aj=th;break}else{vh=th;uh=uh+Y|0}}}else{uh=0;vh=$g;wh=fh;while(1){Yf=ea(g[N+(vh<<4)>>2]);eg=ea(g[N+(vh<<4)+4>>2]);cg=ea(g[N+(vh<<4)+8>>2]);jg=ea(g[N+(vh<<4)+12>>2]);hg=ea(g[O+(vh<<4)>>2]);gg=ea(g[O+(vh<<4)+4>>2]);lg=ea(g[O+(vh<<4)+8>>2]);Ih=ea(g[O+(vh<<4)+12>>2]);kg=ea(g[P+(vh<<4)>>2]);dg=ea(g[P+(vh<<4)+4>>2]);ig=ea(g[P+(vh<<4)+8>>2]);mg=ea(g[P+(vh<<4)+12>>2]);th=1-vh|0;fi=ea(ea(_f*kg)-ea(Xf*hg));gi=ea(ea(ag*dg)-ea(Fh*gg));zh=ea(ea(Ff*ig)-ea(Gh*lg));Ri=ea(ea(Wf*mg)-ea(Hh*Ih));ei=ea(ea(Xf*Yf)-ea(ng*kg));Pi=ea(ea(Fh*eg)-ea(Vf*dg));Qi=ea(ea(Gh*cg)-ea(Uf*ig));yh=ea(ea(Hh*jg)-ea(og*mg));Ah=ea(ea(ng*hg)-ea(_f*Yf));Bh=ea(ea(Vf*gg)-ea(ag*eg));Ch=ea(ea(Uf*lg)-ea(Ff*cg));Dh=ea(ea(og*Ih)-ea(Wf*jg));ni=ea(ea(pc*Ah)+ea(ea(oc*ei)+ea(ed*fi)));oi=ea(ea(qa*Bh)+ea(ea(ra*Pi)+ea(sa*gi)));ri=ea(ea(_b*Ch)+ea(ea(Zb*Qi)+ea(Yb*zh)));pi=ea(ea(hc*Dh)+ea(ea(gc*yh)+ea(fc*Ri)));Mh=ea(ea(sc*Ah)+ea(ea(rc*ei)+ea(qc*fi)));Nh=ea(ea(na*Bh)+ea(ea(oa*Pi)+ea(ta*gi)));Oh=ea(ea(bc*Ch)+ea(ea(ac*Qi)+ea($b*zh)));Ph=ea(ea(kc*Dh)+ea(ea(jc*yh)+ea(ic*Ri)));Qh=ea(ea(vc*Ah)+ea(ea(uc*ei)+ea(tc*fi)));Rh=ea(ea(Xb*Bh)+ea(ea(pa*Pi)+ea(ma*gi)));Sh=ea(ea(ec*Ch)+ea(ea(dc*Qi)+ea(cc*zh)));Th=ea(ea(nc*Dh)+ea(ea(mc*yh)+ea(lc*Ri)));ji=ea(Wb+ea(ea(Ah*Qh)+ea(ea(ei*Mh)+ea(fi*ni))));ki=ea(Pb+ea(ea(Bh*Rh)+ea(ea(Pi*Nh)+ea(gi*oi))));li=ea(Qb+ea(ea(Ch*Sh)+ea(ea(Qi*Oh)+ea(zh*ri))));ii=ea(Rb+ea(ea(Dh*Th)+ea(ea(yh*Ph)+ea(Ri*pi))));ph=ji>ea(0.0);qh=ki>ea(0.0);rh=li>ea(0.0);sh=ii>ea(0.0);hi=ea(ea(1.0)/ki);ki=ea(ea(1.0)/li);li=ea(ea(1.0)/ii);g[M>>2]=ea(ea(1.0)/ji);g[ue>>2]=hi;g[ve>>2]=ki;g[we>>2]=li;c[L+0>>2]=0;c[L+4>>2]=0;c[L+8>>2]=0;c[L+12>>2]=0;li=ea(g[(ph?M:L)>>2]);ki=ea(g[(qh?M:L)+4>>2]);hi=ea(g[(rh?M:L)+8>>2]);ji=ea(-li);li=ea(-ki);ki=ea(-hi);hi=ea(-ea(g[(sh?M:L)+12>>2]));sh=wh+144|0;c[sh+0>>2]=0;c[sh+4>>2]=0;c[sh+8>>2]=0;c[sh+12>>2]=0;g[wh+96>>2]=ni;g[wh+100>>2]=oi;g[wh+104>>2]=ri;g[wh+108>>2]=pi;g[wh+112>>2]=Mh;g[wh+116>>2]=Nh;g[wh+120>>2]=Oh;g[wh+124>>2]=Ph;g[wh+128>>2]=Qh;g[wh+132>>2]=Rh;g[wh+136>>2]=Sh;g[wh+140>>2]=Th;g[wh+48>>2]=fi;g[wh+52>>2]=gi;g[wh+56>>2]=zh;g[wh+60>>2]=Ri;g[wh+64>>2]=ei;g[wh+68>>2]=Pi;g[wh+72>>2]=Qi;g[wh+76>>2]=yh;g[wh+80>>2]=Ah;g[wh+84>>2]=Bh;g[wh+88>>2]=Ch;g[wh+92>>2]=Dh;g[wh+160>>2]=ji;g[wh+164>>2]=li;g[wh+168>>2]=ki;g[wh+172>>2]=hi;hi=ea(ea(ea(ai*eg)+ea($h*gg))+ea(_h*dg));ki=ea(ea(ea(Zh*cg)+ea(Yh*lg))+ea(Xh*ig));li=ea(ea(ea(Wh*jg)+ea(Vh*Ih))+ea(Uh*mg));g[wh+176>>2]=ea(ea(ea(di*Yf)+ea(ci*hg))+ea(bi*kg));g[wh+180>>2]=hi;g[wh+184>>2]=ki;g[wh+188>>2]=li;g[wh>>2]=Yf;g[wh+4>>2]=eg;g[wh+8>>2]=cg;g[wh+12>>2]=jg;g[wh+16>>2]=hg;g[wh+20>>2]=gg;g[wh+24>>2]=lg;g[wh+28>>2]=Ih;g[wh+32>>2]=kg;g[wh+36>>2]=dg;g[wh+40>>2]=ig;g[wh+44>>2]=mg;uh=uh+1|0;if((uh|0)==(m|0)){aj=th;break}else{vh=th;wh=wh+Y|0}}}_i=aj;$i=fh+d|0}if(!(ah&1)){wh=Xg+1|0;do if((dh|0)==65535){bj=0;cj=wh;dj=65535}else{vh=wh;uh=dh;while(1){if((vh|0)!=(e[l+(uh*12|0)+2>>1]|0)){ej=vh;fj=uh;break}th=b[l+(uh*12|0)+4>>1]|0;sh=th&65535;if(th<<16>>16==-1){ej=0;fj=sh;break}else{vh=0;uh=sh}}if((fj|0)==65535){bj=0;cj=ej;dj=65535;break}bj=ej>>>0<(e[l+(fj*12|0)+2>>1]|0)>>>0;cj=ej;dj=fj}while(0);gj=cj;hj=Xg;ij=dh;jj=bj&1^1|ah;kj=dj}else{gj=Xg;hj=Sg;ij=Rg;jj=ah;kj=dh}if(!(ah&2)){wh=Yg+1|0;do if((ch|0)==65535){lj=0;mj=wh;nj=65535}else{uh=wh;vh=ch;while(1){if((uh|0)!=(e[l+(vh*12|0)+2>>1]|0)){oj=uh;pj=vh;break}sh=b[l+(vh*12|0)+4>>1]|0;th=sh&65535;if(sh<<16>>16==-1){oj=0;pj=th;break}else{uh=0;vh=th}}if((pj|0)==65535){lj=0;mj=oj;nj=65535;break}lj=oj>>>0<(e[l+(pj*12|0)+2>>1]|0)>>>0;mj=oj;nj=pj}while(0);qj=mj;rj=Yg;sj=ch;tj=(lj&1)<<1^2|jj;uj=nj}else{qj=Yg;rj=Ug;sj=Tg;tj=jj;uj=ch}if(!(ah&4)){wh=Zg+1|0;do if((bh|0)==65535){vj=0;wj=wh;xj=65535}else{vh=wh;uh=bh;while(1){if((vh|0)!=(e[l+(uh*12|0)+2>>1]|0)){yj=vh;zj=uh;break}th=b[l+(uh*12|0)+4>>1]|0;sh=th&65535;if(th<<16>>16==-1){yj=0;zj=sh;break}else{vh=0;uh=sh}}if((zj|0)==65535){vj=0;wj=yj;xj=65535;break}vj=yj>>>0<(e[l+(zj*12|0)+2>>1]|0)>>>0;wj=yj;xj=zj}while(0);Aj=wj;Bj=Zg;Cj=bh;Dj=(vj&1)<<2^4|tj;Ej=xj}else{Aj=Zg;Bj=Wg;Cj=Vg;Dj=tj;Ej=bh}if(!(ah&8))break;else{wh=ah;Rg=ij;Sg=hj;Tg=sj;Ug=rj;Vg=Cj;Wg=Bj;Xg=gj;Yg=qj;Zg=Aj;$g=_i;ah=Dj;bh=Ej;ch=uj;dh=kj;eh=gh;fh=$i;_g=wh}}_g=af+1|0;do if((Kg|0)==65535){Fj=0;Gj=_g;Hj=65535}else{dh=_g;ch=Kg;while(1){if((dh|0)!=(e[l+(ch*12|0)+2>>1]|0)){Ij=dh;Jj=ch;break}bh=b[l+(ch*12|0)+4>>1]|0;$g=bh&65535;if(bh<<16>>16==-1){Ij=0;Jj=$g;break}else{dh=0;ch=$g}}if((Jj|0)==65535){Fj=0;Gj=Ij;Hj=65535;break}Fj=Ij>>>0<(e[l+(Jj*12|0)+2>>1]|0)>>>0;Gj=Ij;Hj=Jj}while(0);_g=Kg;ch=af;Xe=gj;df=qj;cf=Aj;af=Gj;sf=hj;rf=rj;qf=Bj;tf=ij;We=sj;Fg=Cj;Hg=ah;Ig=_i;Jg=(Fj&1)<<3^8|Dj;Kg=Hj;Lg=Ej;Mg=uj;Ng=kj;Og=gh;Pg=$i;Gg=_g;pf=ch}Fe=Fe+1|0;if(Fe>>>0>=R>>>0)break;else{Be=Ke;Ce=Le;De=Me;Ee=Ne;Ge=eh;h=fh}}i=o;return 1}function Ewa(f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=ea(s);t=ea(t);u=u|0;v=ea(v);w=ea(w);x=ea(x);y=ea(y);var z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=0,Jb=0,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0;m=i;i=i+64|0;z=m+48|0;A=m+32|0;B=m+16|0;C=m;D=f+22|0;E=(e[D>>1]|0)>>>8&1;F=ea(g[f+92>>2]);G=ea(g[k+16>>2]);H=ea(g[k+20>>2]);I=ea(g[k+24>>2]);J=ea(g[l+16>>2]);K=ea(g[l+20>>2]);L=ea(g[l+24>>2]);l=e[D>>1]|0;D=(l&24|0)!=0;k=c[j+1796>>2]|0;M=l>>>6;l=D?112:80;N=D?128:96;if(D){O=3;P=12}else{O=(M<<2&4^5)&255;P=(M&1^11)&255}Q=ea(g[o>>2]);R=ea(g[o+4>>2]);U=ea(g[o+8>>2]);V=ea(g[p>>2]);W=ea(g[p+4>>2]);X=ea(g[p+8>>2]);Y=ea(g[o+16>>2]);Z=ea(g[o+20>>2]);_=ea(g[o+24>>2]);$=ea(g[p+16>>2]);aa=ea(g[p+20>>2]);ba=ea(g[p+24>>2]);ca=ea(g[q+48>>2]);fa=ea(g[r+48>>2]);ga=ea(g[q+52>>2]);ha=ea(g[r+52>>2]);ia=ga>ha?ga:ha;ha=ea(g[q>>2]);ga=ea(g[q+4>>2]);ja=ea(g[q+8>>2]);ka=ea(g[q+12>>2]);la=ea(g[q+16>>2]);ma=ea(g[q+20>>2]);na=ea(g[q+24>>2]);oa=ea(g[q+28>>2]);pa=ea(g[q+32>>2]);qa=ea(g[r>>2]);ra=ea(g[r+4>>2]);sa=ea(g[r+8>>2]);ta=ea(g[r+12>>2]);ua=ea(g[r+16>>2]);va=ea(g[r+20>>2]);wa=ea(g[r+24>>2]);xa=ea(g[r+28>>2]);ya=ea(g[r+32>>2]);za=ea(s*ea(.800000011));r=f+84|0;Aa=ea(g[r>>2]);q=f+88|0;Ba=ea(g[q>>2]);Ca=ea(Aa*w);w=ea(-ea(Ba*y));y=ea(ca*ea(Aa*v));v=ea(fa*ea(Ba*x));x=ea(-v);Ba=ea(ha*Ca);ha=ea(ga*Ca);ga=ea(ja*Ca);ja=ea(ka*Ca);ka=ea(la*Ca);la=ea(ma*Ca);ma=ea(na*Ca);na=ea(oa*Ca);oa=ea(pa*Ca);Ca=ea(qa*w);qa=ea(ra*w);ra=ea(sa*w);sa=ea(ta*w);ta=ea(ua*w);ua=ea(va*w);va=ea(wa*w);wa=ea(xa*w);xa=ea(ya*w);f=(k|0)==0;if(f){Da=0;Ea=n;a[Ea>>0]=0;i=m;return Da|0}else{Fa=0;Ga=n}while(1){p=c[j+(Fa<<2)+1408>>2]|0;if(p){o=j+(Fa<<2)+1536|0;w=ea(g[j+(Fa*20|0)+768>>2]);ya=ea(g[j+(Fa*20|0)+772>>2]);pa=ea(g[j+(Fa*20|0)+776>>2]);M=h+((e[j+((c[o>>2]|0)*12|0)>>1]|0)<<6)+60|0;fa=ea(g[M>>2]);Aa=ea(ea(ea(Q*w)+ea(R*ya))+ea(U*pa));ca=ea(ea(ea(V*w)+ea(W*ya))+ea(X*pa));D=Ga+48|0;a[Ga+1>>0]=p;a[Ga>>0]=O;g[Ga+4>>2]=ea(g[M>>2]);g[Ga+8>>2]=y;g[Ga+12>>2]=x;g[Ga+16>>2]=w;g[Ga+20>>2]=ya;g[Ga+24>>2]=pa;a[Ga+36>>0]=E;M=c[o>>2]|0;if((M|0)==65535)Ha=D;else{o=fa>ea(0.0);p=M;M=D;while(1){D=b[j+(p*12|0)+2>>1]|0;Ia=e[j+(p*12|0)>>1]|0;if(!(D<<16>>16))Ja=M;else{Ka=D&65535;if(o){D=0;La=M;while(1){Ma=D+Ia|0;Na=ea(g[h+(Ma<<6)+16>>2]);Oa=ea(g[h+(Ma<<6)+20>>2]);Pa=ea(g[h+(Ma<<6)+24>>2]);Qa=ea(g[h+(Ma<<6)+12>>2]);Ra=ea(g[h+(Ma<<6)+32>>2]);Sa=ea(g[h+(Ma<<6)+36>>2]);Ta=ea(ea(ea(w*Ra)+ea(ya*Sa))+ea(pa*ea(g[h+(Ma<<6)+40>>2])));Sa=ea(Na-G);Ra=ea(Oa-H);Ua=ea(Pa-I);Va=ea(Na-J);Na=ea(Oa-K);Oa=ea(Pa-L);Pa=ea(g[h+(Ma<<6)+28>>2]);Wa=ea(ea(pa*Ra)-ea(ya*Ua));Xa=ea(ea(w*Ua)-ea(pa*Sa));Ua=ea(ea(ya*Sa)-ea(w*Ra));Ra=ea(ea(pa*Na)-ea(ya*Oa));Sa=ea(ea(w*Oa)-ea(pa*Va));Oa=ea(ea(ya*Va)-ea(w*Na));Na=ea(ea(ma*Ua)+ea(ea(Ba*Wa)+ea(ja*Xa)));Va=ea(ea(na*Ua)+ea(ea(ha*Wa)+ea(ka*Xa)));Ya=ea(ea(oa*Ua)+ea(ea(ga*Wa)+ea(la*Xa)));Za=ea(ea(va*Oa)+ea(ea(Ca*Ra)+ea(sa*Sa)));_a=ea(ea(wa*Oa)+ea(ea(qa*Ra)+ea(ta*Sa)));$a=ea(ea(xa*Oa)+ea(ea(ra*Ra)+ea(ua*Sa)));ab=ea(ea(y+ea(ea(Ua*Ya)+ea(ea(Wa*Na)+ea(Xa*Va))))-ea(ea(ea(Oa*$a)+ea(ea(Ra*Za)+ea(Sa*_a)))-v));bb=ea(ea(Aa+ea(ea(_*Ua)+ea(ea(Y*Wa)+ea(Z*Xa))))-ea(ca+ea(ea(ba*Oa)+ea(ea($*Ra)+ea(aa*Sa)))));cb=ea(ea(1.0)/ab);Ma=!(ab>ea(0.0));ab=Ma?ea(0.0):cb;cb=ea(Qa-F);Qa=ea(za*cb);db=ea((ia>Qa?ia:Qa)*ab);Qa=ea(cb*s);g[La+48>>2]=Na;g[La+52>>2]=Va;g[La+56>>2]=Ya;g[La+60>>2]=y;g[La+64>>2]=Za;g[La+68>>2]=_a;g[La+72>>2]=$a;g[La+76>>2]=x;$a=ea(-bb);Ma=Qa<$a&bb<t;bb=Ma?ea(0.0):db;db=ea(fa*$a);$a=ea(Ta+(Ma?db:ea(0.0)));g[La>>2]=Wa;g[La+4>>2]=Xa;g[La+8>>2]=Ua;g[La+12>>2]=ea(0.0);g[La+16>>2]=Ra;g[La+20>>2]=Sa;g[La+24>>2]=Oa;g[La+28>>2]=ab;g[La+32>>2]=bb;g[La+36>>2]=$a;g[La+40>>2]=Pa;g[La+44>>2]=ea(0.0);D=D+1|0;if((D|0)==(Ka|0))break;else La=La+l|0}}else{La=0;D=M;while(1){Ma=La+Ia|0;Pa=ea(g[h+(Ma<<6)+16>>2]);$a=ea(g[h+(Ma<<6)+20>>2]);bb=ea(g[h+(Ma<<6)+24>>2]);ab=ea(g[h+(Ma<<6)+12>>2]);Oa=ea(g[h+(Ma<<6)+32>>2]);Sa=ea(g[h+(Ma<<6)+36>>2]);Ra=ea(ea(ea(w*Oa)+ea(ya*Sa))+ea(pa*ea(g[h+(Ma<<6)+40>>2])));Sa=ea(Pa-G);Oa=ea($a-H);Ua=ea(bb-I);Xa=ea(Pa-J);Pa=ea($a-K);$a=ea(bb-L);bb=ea(g[h+(Ma<<6)+28>>2]);Wa=ea(ea(pa*Oa)-ea(ya*Ua));db=ea(ea(w*Ua)-ea(pa*Sa));Ua=ea(ea(ya*Sa)-ea(w*Oa));Oa=ea(ea(pa*Pa)-ea(ya*$a));Sa=ea(ea(w*$a)-ea(pa*Xa));$a=ea(ea(ya*Xa)-ea(w*Pa));Pa=ea(ea(ma*Ua)+ea(ea(Ba*Wa)+ea(ja*db)));Xa=ea(ea(na*Ua)+ea(ea(ha*Wa)+ea(ka*db)));Ta=ea(ea(oa*Ua)+ea(ea(ga*Wa)+ea(la*db)));Qa=ea(ea(va*$a)+ea(ea(Ca*Oa)+ea(sa*Sa)));_a=ea(ea(wa*$a)+ea(ea(qa*Oa)+ea(ta*Sa)));Za=ea(ea(xa*$a)+ea(ea(ra*Oa)+ea(ua*Sa)));Ya=ea(ea(y+ea(ea(Ua*Ta)+ea(ea(Wa*Pa)+ea(db*Xa))))-ea(ea(ea($a*Za)+ea(ea(Oa*Qa)+ea(Sa*_a)))-v));Va=ea(ea(1.0)/Ya);Ma=!(Ya>ea(0.0));Ya=Ma?ea(0.0):Va;Va=ea(za*ea(ab-F));ab=ea((ia>Va?ia:Va)*Ya);g[D+48>>2]=Pa;g[D+52>>2]=Xa;g[D+56>>2]=Ta;g[D+60>>2]=y;g[D+64>>2]=Qa;g[D+68>>2]=_a;g[D+72>>2]=Za;g[D+76>>2]=x;Za=ea(Ra+ea(0.0));g[D>>2]=Wa;g[D+4>>2]=db;g[D+8>>2]=Ua;g[D+12>>2]=ea(0.0);g[D+16>>2]=Oa;g[D+20>>2]=Sa;g[D+24>>2]=$a;g[D+28>>2]=Ya;g[D+32>>2]=ab;g[D+36>>2]=Za;g[D+40>>2]=bb;g[D+44>>2]=ea(0.0);La=La+1|0;if((La|0)==(Ka|0))break;else D=D+l|0}}Ja=M+(da(l,Ka)|0)|0}D=b[j+(p*12|0)+4>>1]|0;if(D<<16>>16==-1){Ha=Ja;break}else{p=D&65535;M=Ja}}}}else Ha=Ga;Fa=Fa+1|0;if((Fa|0)==(k|0))break;else Ga=Ha}if(f){Da=0;Ea=Ha;a[Ea>>0]=0;i=m;return Da|0}f=A+4|0;Ga=A+8|0;Fa=A+12|0;Ja=z+4|0;E=z+8|0;O=z+12|0;ia=ea(Q-V);V=ea(R-W);W=ea(U-X);M=C+4|0;p=C+8|0;o=C+12|0;D=B+4|0;La=B+8|0;Ia=B+12|0;Ma=(u|0)==0;eb=da(N,u)|0;fb=0;gb=0;hb=Ha;Ha=n;while(1){n=j+(gb<<2)+1408|0;ib=c[n>>2]|0;if(ib){jb=j+(gb<<2)+1536|0;kb=e[j+((c[jb>>2]|0)*12|0)>>1]|0;b[Ha+2>>1]=hb-Ha;lb=Ha+((da(d[Ha+1>>0]|0,l)|0)+48)|0;X=ea(g[h+(kb<<6)+44>>2]);mb=(c[h+(kb<<6)+52>>2]&1|0)==0;a[hb+1>>0]=ib;if(mb)nb=b[j+(gb*20|0)+784>>1]&255;else nb=0;a[hb+2>>0]=nb;ib=hb+((c[n>>2]<<2)+44&-16)|0;n=e[j+((c[jb>>2]|0)*12|0)>>1]|0;U=ea(g[h+(n<<6)>>2]);R=ea(g[h+(n<<6)+4>>2]);Q=ea(g[h+(n<<6)+8>>2]);F=ea(-Q);za=ea(-R);n=ea(S(ea(U)))<ea(.707106769);g[A>>2]=ea(0.0);g[f>>2]=F;g[Ga>>2]=R;g[Fa>>2]=ea(0.0);g[z>>2]=za;g[Ja>>2]=U;g[E>>2]=ea(0.0);g[O>>2]=ea(0.0);kb=n?A:z;za=ea(g[kb>>2]);F=ea(g[kb+4>>2]);t=ea(g[kb+8>>2]);s=ea(ea(ea(ia*U)+ea(V*R))+ea(W*Q));aa=ea(ia-ea(U*s));$=ea(V-ea(R*s));ba=ea(W-ea(Q*s));kb=ea(ea(ba*ba)+ea(ea(aa*aa)+ea($*$)))>ea(9.99999974e-06);g[C>>2]=aa;g[M>>2]=$;g[p>>2]=ba;g[o>>2]=ea(0.0);g[B>>2]=za;g[D>>2]=F;g[La>>2]=t;g[Ia>>2]=ea(0.0);n=kb?C:B;t=ea(g[n>>2]);F=ea(g[n+4>>2]);za=ea(g[n+8>>2]);ba=ea(ea(1.0)/ea(T(ea(ea(ea(t*t)+ea(F*F))+ea(za*za)))));$=ea(t*ba);t=ea(F*ba);F=ea(za*ba);if(mb?(g[hb+4>>2]=X,g[hb+8>>2]=ea(g[r>>2]),g[hb+12>>2]=ea(g[q>>2]),a[hb>>0]=P,mb=c[jb>>2]|0,(mb|0)!=65535):0){X=ea(ea(Q*t)-ea(R*F));ba=ea(ea(U*F)-ea(Q*$));Q=ea(ea(R*$)-ea(U*t));U=$;$=t;t=F;jb=fb;n=mb;mb=ib;kb=0;while(1){ob=j+(n*12|0)+2|0;pb=b[ob>>1]|0;qb=e[j+(n*12|0)>>1]|0;a:do if(!(pb<<16>>16)){rb=t;sb=$;tb=U;ub=Q;vb=ba;wb=X;xb=0;yb=jb;zb=mb}else{Ab=pb&65535;if(Ma){Bb=0;while(1){Bb=Bb+1|0;if((Bb|0)==(Ab|0)){rb=t;sb=$;tb=U;ub=Q;vb=ba;wb=X;xb=pb;yb=1;zb=mb;break a}}}else{Cb=X;Db=ba;Eb=Q;Fb=U;Gb=$;Hb=t;Ib=0;Jb=mb}while(1){Bb=Ib+kb|0;Kb=Ib+qb|0;F=ea(g[h+(Kb<<6)+16>>2]);R=ea(g[h+(Kb<<6)+20>>2]);za=ea(g[h+(Kb<<6)+24>>2]);aa=ea(F-G);s=ea(R-H);Z=ea(za-I);Y=ea(F-J);F=ea(R-K);R=ea(za-L);za=ea(g[h+(Kb<<6)+32>>2]);_=ea(g[h+(Kb<<6)+36>>2]);w=ea(g[h+(Kb<<6)+40>>2]);Lb=Hb;Mb=Gb;Nb=Fb;Ob=Cb;Pb=Db;Qb=Eb;Kb=0;Rb=Jb;while(1){c[Rb+80>>2]=Bb;ya=ea(ea(s*Lb)-ea(Z*Mb));pa=ea(ea(Z*Nb)-ea(aa*Lb));fa=ea(ea(aa*Mb)-ea(s*Nb));ca=ea(ea(F*Lb)-ea(R*Mb));Aa=ea(ea(R*Nb)-ea(Y*Lb));bb=ea(ea(Y*Mb)-ea(F*Nb));Za=ea(ea(ma*fa)+ea(ea(Ba*ya)+ea(ja*pa)));ab=ea(ea(na*fa)+ea(ea(ha*ya)+ea(ka*pa)));Ya=ea(ea(oa*fa)+ea(ea(ga*ya)+ea(la*pa)));$a=ea(ea(va*bb)+ea(ea(Ca*ca)+ea(sa*Aa)));Sa=ea(ea(wa*bb)+ea(ea(qa*ca)+ea(ta*Aa)));Oa=ea(ea(xa*bb)+ea(ea(ra*ca)+ea(ua*Aa)));Ua=ea(ea(y+ea(ea(fa*Ya)+ea(ea(ya*Za)+ea(pa*ab))))-ea(ea(ea(bb*Oa)+ea(ea(ca*$a)+ea(Aa*Sa)))-v));db=ea(ea(1.0)/Ua);Sb=!(Ua>ea(0.0));Ua=ea(-(Sb?ea(0.0):db));g[Rb>>2]=Nb;g[Rb+4>>2]=Mb;g[Rb+8>>2]=Lb;g[Rb+12>>2]=ea(0.0);g[Rb+16>>2]=ya;g[Rb+20>>2]=pa;g[Rb+24>>2]=fa;g[Rb+28>>2]=Ua;Ua=ea(ea(w*Lb)+ea(ea(_*Mb)+ea(za*Nb)));g[Rb+32>>2]=ca;g[Rb+36>>2]=Aa;g[Rb+40>>2]=bb;g[Rb+44>>2]=Ua;g[Rb+48>>2]=Za;g[Rb+52>>2]=ab;g[Rb+56>>2]=Ya;g[Rb+60>>2]=y;g[Rb+64>>2]=$a;g[Rb+68>>2]=Sa;g[Rb+72>>2]=Oa;g[Rb+76>>2]=x;Kb=Kb+1|0;if((Kb|0)==(u|0))break;else{Oa=Ob;Sa=Pb;$a=Qb;Rb=Rb+N|0;Qb=Lb;Pb=Mb;Ob=Nb;Nb=Oa;Mb=Sa;Lb=$a}}Jb=Jb+eb|0;Ib=Ib+1|0;if((Ib|0)==(Ab|0))break;else{Cb=Nb;Db=Mb;Eb=Lb;Fb=Ob;Gb=Pb;Hb=Qb}}rb=Qb;sb=Pb;tb=Ob;ub=Lb;vb=Mb;wb=Nb;xb=b[ob>>1]|0;yb=1;zb=Jb}while(0);ob=b[j+(n*12|0)+4>>1]|0;if(ob<<16>>16==-1){Tb=yb;Ub=zb;Vb=lb;break}else{X=wb;ba=vb;Q=ub;U=tb;$=sb;t=rb;jb=yb;n=ob&65535;mb=zb;kb=(xb&65535)+kb|0}}}else{Tb=fb;Ub=ib;Vb=lb}}else{Tb=fb;Ub=hb;Vb=Ha}gb=gb+1|0;if((gb|0)==(k|0)){Da=Tb;Ea=Ub;break}else{fb=Tb;hb=Ub;Ha=Vb}}a[Ea>>0]=0;i=m;return Da|0}function Fwa(a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=ea(b);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;var w=0;w=i;Xn[c[(c[a>>2]|0)+28>>2]&7](a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v);i=w;return}function Gwa(a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=ea(b);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;var w=0;w=i;Xn[c[(c[a>>2]|0)+32>>2]&7](a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v);i=w;return}function Hwa(){c[124773]=2602;c[124774]=2603;c[124781]=2604;c[124782]=2605;c[124789]=1783;c[124790]=1784;c[124799]=95;c[124800]=96;c[124809]=1785;c[124810]=1786;c[124819]=2606;c[124820]=2603;c[124833]=2607;c[124834]=2605;c[124847]=1787;c[124848]=1784;c[124863]=97;c[124864]=96;c[124879]=1788;c[124880]=1786;c[124828]=2608;c[124856]=1789;c[124872]=98;c[124888]=1789;return}function Iwa(){var a=0,b=0;a=i;i=i+16|0;b=UJa(a,4,499568,147)|0;if(!b){i=a;return b|0}c[b>>2]=499736;i=a;return b|0}function Jwa(a){a=a|0;var b=0;b=i;i=i+16|0;ko[c[(c[a>>2]|0)+4>>2]&4095](a);VJa(b,a);i=b;return}function Kwa(b,d,e,f,h,j,k,l,m,n,o,p,q,r,s){b=b|0;d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0;r=i;i=i+32|0;q=r;a[q+1>>0]=0;a:do if((e|0)>0){if(!p){k=e;while(1){a[q>>0]=(k|0)<4&1;k=k+-1|0;if((k|0)<=0)break a}}else t=e;do{a[q>>0]=(t|0)<4&1;k=0;do{In[c[499080+((a[c[o+(k<<5)+16>>2]>>0]&255)<<2)>>2]&4095](o+(k<<5)|0,q);k=k+1|0}while((k|0)!=(p|0));t=t+-1|0}while((t|0)>0)}while(0);if(l){t=0;do{g[s+(t<<5)>>2]=ea(g[h+(t<<5)>>2]);g[s+(t<<5)+4>>2]=ea(g[h+(t<<5)+4>>2]);g[s+(t<<5)+8>>2]=ea(g[h+(t<<5)+8>>2]);g[s+(t<<5)+16>>2]=ea(g[h+(t<<5)+16>>2]);g[s+(t<<5)+20>>2]=ea(g[h+(t<<5)+20>>2]);g[s+(t<<5)+24>>2]=ea(g[h+(t<<5)+24>>2]);t=t+1|0}while((t|0)!=(l|0))}if(n){l=0;do{if(c[125134]|0)Eza(m+(l*40|0)|0);l=l+1|0}while((l|0)!=(n|0))}n=(p|0)==0;if(!n){l=0;do{In[c[499664+((a[c[o+(l<<5)+16>>2]>>0]&255)<<2)>>2]&4095](o+(l<<5)|0,q);l=l+1|0}while((l|0)!=(p|0))}l=1-f|0;if((l|0)>0|n){i=r;return}else u=l;while(1){l=0;do{In[c[499080+((a[c[o+(l<<5)+16>>2]>>0]&255)<<2)>>2]&4095](o+(l<<5)|0,q);l=l+1|0}while((l|0)!=(p|0));if((u|0)<0)u=u+1|0;else break}i=r;return}function Lwa(b,d,e,f,h,j,k,l,m,n,o,p,q,r,s){b=b|0;d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0;k=i;i=i+32|0;j=k;if((e|0)>0){b=(p|0)==0;t=e;do{if(!b){u=0;do{In[c[499264+((a[c[o+(u<<5)+16>>2]>>0]&255)<<2)>>2]&4095](o+(u<<5)|0,j);u=u+1|0}while((u|0)!=(p|0))}t=t+-1|0}while((t|0)>0)}t=e<<1;if(!((t|0)<1|(r|0)==0)){e=t;do{t=0;do{In[c[499264+((a[c[q+(t<<5)+16>>2]>>0]&255)<<2)>>2]&4095](q+(t<<5)|0,j);t=t+1|0}while((t|0)!=(r|0));e=e+-1|0}while((e|0)>0)}if(l){e=0;do{g[s+(e<<5)>>2]=ea(g[h+(e<<5)>>2]);g[s+(e<<5)+4>>2]=ea(g[h+(e<<5)+4>>2]);g[s+(e<<5)+8>>2]=ea(g[h+(e<<5)+8>>2]);g[s+(e<<5)+16>>2]=ea(g[h+(e<<5)+16>>2]);g[s+(e<<5)+20>>2]=ea(g[h+(e<<5)+20>>2]);g[s+(e<<5)+24>>2]=ea(g[h+(e<<5)+24>>2]);e=e+1|0}while((e|0)!=(l|0))}if(n){l=0;do{if(c[125134]|0)Eza(m+(l*40|0)|0);l=l+1|0}while((l|0)!=(n|0))}n=(p|0)==0;if(!n){l=0;do{In[c[499696+((a[c[o+(l<<5)+16>>2]>>0]&255)<<2)>>2]&4095](o+(l<<5)|0,j);l=l+1|0}while((l|0)!=(p|0))}l=1-f|0;if((l|0)>=1){i=k;return}f=(r|0)!=0;if(n){n=l;while(1){if(f){m=0;do{In[c[499264+((a[c[q+(m<<5)+16>>2]>>0]&255)<<2)>>2]&4095](q+(m<<5)|0,j);m=m+1|0}while((m|0)!=(r|0))}if((n|0)<0)n=n+1|0;else break}i=k;return}else v=l;while(1){l=0;do{In[c[499264+((a[c[o+(l<<5)+16>>2]>>0]&255)<<2)>>2]&4095](o+(l<<5)|0,j);l=l+1|0}while((l|0)!=(p|0));if(f){l=0;do{In[c[499264+((a[c[q+(l<<5)+16>>2]>>0]&255)<<2)>>2]&4095](q+(l<<5)|0,j);l=l+1|0}while((l|0)!=(r|0))}if((v|0)<0)v=v+1|0;else break}i=k;return}function Mwa(d,e,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;u=i;i=i+32|0;s=u+4|0;r=u;c[s+16>>2]=k;c[s+4>>2]=w;c[s+12>>2]=x+4;k=s+8|0;c[k>>2]=0;l=s+1|0;a[l>>0]=0;d=c[t+4>>2]|0;if(!q){if(m){q=0;do{g[v+(q<<5)>>2]=ea(g[j+(q<<5)>>2]);g[v+(q<<5)+4>>2]=ea(g[j+(q<<5)+4>>2]);g[v+(q<<5)+8>>2]=ea(g[j+(q<<5)+8>>2]);g[v+(q<<5)+16>>2]=ea(g[j+(q<<5)+16>>2]);g[v+(q<<5)+20>>2]=ea(g[j+(q<<5)+20>>2]);g[v+(q<<5)+24>>2]=ea(g[j+(q<<5)+24>>2]);q=q+1|0}while((q|0)!=(m|0))}if(!o){i=u;return}else z=0;do{if(c[125134]|0)Eza(n+(z*40|0)|0);z=z+1|0}while((z|0)!=(o|0));i=u;return}if((f|0)>0){z=(d|0)>0;q=f;do{a[s>>0]=(q|0)<4&1;f=(q|0)==1?499224:499144;A=c[t>>2]|0;if(z){B=0;do{C=b[A+(B<<3)+4>>1]|0;D=C&65535;E=p+(c[A+(B<<3)>>2]<<5)|0;if(C<<16>>16){C=0;while(1){F=C+1|0;if((F|0)<(D|0))C=F;else break}}co[c[f+((b[A+(B<<3)+6>>1]&65535)<<2)>>2]&2047](E,D,s);B=B+1|0}while((B|0)!=(d|0))}q=q+-1|0}while((q|0)>0)}if(m){q=0;do{g[v+(q<<5)>>2]=ea(g[j+(q<<5)>>2]);g[v+(q<<5)+4>>2]=ea(g[j+(q<<5)+4>>2]);g[v+(q<<5)+8>>2]=ea(g[j+(q<<5)+8>>2]);g[v+(q<<5)+16>>2]=ea(g[j+(q<<5)+16>>2]);g[v+(q<<5)+20>>2]=ea(g[j+(q<<5)+20>>2]);g[v+(q<<5)+24>>2]=ea(g[j+(q<<5)+24>>2]);q=q+1|0}while((q|0)!=(m|0))}if(o){m=0;do{if(c[125134]|0)Eza(n+(m*40|0)|0);m=m+1|0}while((m|0)!=(o|0))}o=h+-1|0;a:do if((o|0)>0){m=(d|0)>0;n=1;while(1){q=c[t>>2]|0;if(m){j=0;do{v=b[q+(j<<3)+4>>1]|0;z=v&65535;B=p+(c[q+(j<<3)>>2]<<5)|0;if(v<<16>>16){v=0;while(1){A=v+1|0;if((A|0)<(z|0))v=A;else break}}co[c[499144+((b[q+(j<<3)+6>>1]&65535)<<2)>>2]&2047](B,z,s);j=j+1|0}while((j|0)!=(d|0))}if((n|0)==(o|0)){G=o;break a}n=n+1|0}}else G=0;while(0);c[r>>2]=c[y>>2];a[l>>0]=1;if((G|0)<(h|0)){l=(d|0)>0;o=G;do{G=c[t>>2]|0;if(l){n=0;do{m=b[G+(n<<3)+4>>1]|0;j=m&65535;q=p+(c[G+(n<<3)>>2]<<5)|0;if(m<<16>>16){m=0;while(1){D=m+1|0;if((D|0)<(j|0))m=D;else break}}rn[c[499184+((b[G+(n<<3)+6>>1]&65535)<<2)>>2]&127](q,j,s,w,x,r);n=n+1|0}while((n|0)!=(d|0))}o=o+1|0}while((o|0)!=(h|0))}c[y>>2]=c[k>>2];i=u;return}function Nwa(d,e,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;l=i;i=i+32|0;d=l+4|0;z=l;c[d+16>>2]=k;c[d+4>>2]=w;c[d+12>>2]=x+4;k=d+8|0;c[k>>2]=0;A=d+1|0;a[A>>0]=0;if(!q){if(m){q=0;do{g[v+(q<<5)>>2]=ea(g[j+(q<<5)>>2]);g[v+(q<<5)+4>>2]=ea(g[j+(q<<5)+4>>2]);g[v+(q<<5)+8>>2]=ea(g[j+(q<<5)+8>>2]);g[v+(q<<5)+16>>2]=ea(g[j+(q<<5)+16>>2]);g[v+(q<<5)+20>>2]=ea(g[j+(q<<5)+20>>2]);g[v+(q<<5)+24>>2]=ea(g[j+(q<<5)+24>>2]);q=q+1|0}while((q|0)!=(m|0))}if(!o){i=l;return}else B=0;do{if(c[125134]|0)Eza(n+(B*40|0)|0);B=B+1|0}while((B|0)!=(o|0));i=l;return}B=c[t+4>>2]|0;q=c[u+4>>2]|0;if((f|0)>0){C=(B|0)>0;D=f;do{E=(D|0)==1?499504:499376;F=c[t>>2]|0;if(C){G=0;do{H=b[F+(G<<3)+4>>1]|0;I=H&65535;J=p+(c[F+(G<<3)>>2]<<5)|0;if(H<<16>>16){H=0;while(1){K=H+1|0;if((K|0)<(I|0))H=K;else break}}co[c[E+((b[F+(G<<3)+6>>1]&65535)<<2)>>2]&2047](J,I,d);G=G+1|0}while((G|0)!=(B|0))}D=D+-1|0}while((D|0)>0)}D=(s|0)==0;a:do if(!D?(s=f<<1,(s|0)>0):0){C=(q|0)>0;G=f<<1;F=1;E=s;while(1){s=(E|0)==1?499504:499376;H=c[u>>2]|0;if(C){K=0;do{L=b[H+(K<<3)+4>>1]|0;M=L&65535;N=r+(c[H+(K<<3)>>2]<<5)|0;if(L<<16>>16){L=0;while(1){O=L+1|0;if((O|0)<(M|0))L=O;else break}}co[c[s+((b[H+(K<<3)+6>>1]&65535)<<2)>>2]&2047](N,M,d);K=K+1|0}while((K|0)!=(q|0))}if((F|0)==(G|0))break a;F=F+1|0;E=E+-1|0}}while(0);if(m){f=0;do{g[v+(f<<5)>>2]=ea(g[j+(f<<5)>>2]);g[v+(f<<5)+4>>2]=ea(g[j+(f<<5)+4>>2]);g[v+(f<<5)+8>>2]=ea(g[j+(f<<5)+8>>2]);g[v+(f<<5)+16>>2]=ea(g[j+(f<<5)+16>>2]);g[v+(f<<5)+20>>2]=ea(g[j+(f<<5)+20>>2]);g[v+(f<<5)+24>>2]=ea(g[j+(f<<5)+24>>2]);f=f+1|0}while((f|0)!=(m|0))}if(o){m=0;do{if(c[125134]|0)Eza(n+(m*40|0)|0);m=m+1|0}while((m|0)!=(o|0))}o=h+-1|0;b:do if((o|0)>0){m=(B|0)>0;n=(q|0)>0;f=1;while(1){j=c[t>>2]|0;if(m){v=0;do{E=b[j+(v<<3)+4>>1]|0;F=E&65535;G=p+(c[j+(v<<3)>>2]<<5)|0;if(E<<16>>16){E=0;while(1){C=E+1|0;if((C|0)<(F|0))E=C;else break}}co[c[499376+((b[j+(v<<3)+6>>1]&65535)<<2)>>2]&2047](G,F,d);v=v+1|0}while((v|0)!=(B|0))}if(!D?(v=c[u>>2]|0,n):0){j=0;do{E=b[v+(j<<3)+4>>1]|0;M=E&65535;N=r+(c[v+(j<<3)>>2]<<5)|0;if(E<<16>>16){E=0;while(1){C=E+1|0;if((C|0)<(M|0))E=C;else break}}co[c[499376+((b[v+(j<<3)+6>>1]&65535)<<2)>>2]&2047](N,M,d);j=j+1|0}while((j|0)!=(q|0))}if((f|0)==(o|0)){P=o;break b}f=f+1|0}}else P=0;while(0);c[z>>2]=c[y>>2];a[A>>0]=1;if((P|0)<(h|0)){A=(B|0)>0;o=(q|0)>0;f=P;do{P=c[t>>2]|0;if(A){n=0;do{m=b[P+(n<<3)+4>>1]|0;j=m&65535;v=p+(c[P+(n<<3)>>2]<<5)|0;if(m<<16>>16){m=0;while(1){E=m+1|0;if((E|0)<(j|0))m=E;else break}}rn[c[499440+((b[P+(n<<3)+6>>1]&65535)<<2)>>2]&127](v,j,d,w,x,z);n=n+1|0}while((n|0)!=(B|0))}if(!D?(n=c[u>>2]|0,o):0){P=0;do{m=b[n+(P<<3)+4>>1]|0;E=m&65535;F=r+(c[n+(P<<3)>>2]<<5)|0;if(m<<16>>16){m=0;while(1){G=m+1|0;if((G|0)<(E|0))m=G;else break}}rn[c[499440+((b[n+(P<<3)+6>>1]&65535)<<2)>>2]&127](F,E,d,w,x,z);P=P+1|0}while((P|0)!=(q|0))}f=f+1|0}while((f|0)!=(h|0))}c[y>>2]=c[k>>2];i=l;return}function Owa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){d=d|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;y=i;i=i+544|0;r=y+520|0;m=y;c[r+16>>2]=l;l=c[x+4>>2]|0;c[r+4>>2]=y+8;c[r+12>>2]=32;c[r+8>>2]=0;d=r+1|0;a[d>>0]=0;B=(hTa(s,4)|0)+-4|0;c[m>>2]=x;c[m+4>>2]=0;x=h+-1|0;if(!x){C=4;D=B;E=0;F=0}else{G=da(l,x)|0;H=0;I=4;J=B;B=0;K=0;while(1){B=B+l|0;a[r>>0]=(h-H|0)>>>0<4&1;if((J|0)<(B|0)){L=I;M=J;while(1){N=B-M|0;O=(N|0)<(L|0)?N:L;f1a(q,O,M,l,r,m,499144,K,0,K);if((L|0)==(O|0)){P=4;Q=(hTa(s,4)|0)+-4|0}else{P=L-O|0;Q=O+M|0}if((Q|0)<(B|0)){L=P;M=Q}else{R=P;S=Q;break}}}else{R=I;S=J}H=H+1|0;if((H|0)==(x|0)){C=R;D=S;E=G;F=x;break}else{I=R;J=S;K=K+1|0}}}if(F>>>0<h>>>0){K=da(l,h-F|0)|0;S=F;J=C;R=D;I=E;x=F;while(1){I=I+l|0;a[r>>0]=(h-S|0)>>>0<4&1;if((R|0)<(I|0)){G=J;H=R;while(1){Q=I-H|0;P=(Q|0)<(G|0)?Q:G;f1a(q,P,H,l,r,m,499224,x,0,x);if((G|0)==(P|0)){T=4;U=(hTa(s,4)|0)+-4|0}else{T=G-P|0;U=P+H|0}if((U|0)<(I|0)){G=T;H=U}else{V=T;W=U;break}}}else{V=J;W=R}S=S+1|0;if((S|0)==(h|0))break;else{J=V;R=W;x=x+1|0}}X=V;Y=W;Z=E+K|0;_=h}else{X=C;Y=D;Z=E;_=F}F=(hTa(t,64)|0)+-64|0;if((F|0)<(p|0)){E=~p;D=64;C=F;while(1){h=p-C|0;K=(h|0)>64?64:h;h=D-K|0;if((K|0)>0){W=C+E|0;V=(W|0)>-65?W:-65;W=~V;x=0;R=C;while(1){J=o+(R*40|0)|0;S=c[J>>2]|0;U=S+12|0;T=da(e[U>>1]|0,_)|0;I=S+28|0;if((c[I>>2]|0)!=(T|0))do{}while((c[I>>2]|0)!=(T|0));if(!(c[125134]|0))$=T;else{Eza(J);$=c[I>>2]|0}c[I>>2]=$+(e[U>>1]|0);x=x+1|0;if((x|0)==(W|0))break;else R=R+1|0}aa=C+-1-V|0}else aa=C;if((D|0)==(K|0)){ba=64;ca=(hTa(t,64)|0)+-64|0}else{ba=h;ca=aa}if((ca|0)<(p|0)){D=ba;C=ca}else{fa=ba;ga=ca;break}}}else{fa=64;ga=F}F=ga-p|0;if((F|0)<(n|0)){ga=~n;ca=fa;fa=F;while(1){F=n-fa|0;if((((ca|0)<(F|0)?ca:F)|0)>0){F=~ca;ba=fa+ga|0;C=~((ba|0)<(F|0)?F:ba);ba=0;F=fa;while(1){D=k+(F<<5)+12|0;aa=b[D>>1]|0;$=da(aa&65535,_)|0;o=k+(F<<5)+28|0;if((c[o>>2]|0)==($|0))ha=aa;else{do{}while((c[o>>2]|0)!=($|0));ha=b[D>>1]|0}g[z+(F<<5)>>2]=ea(g[k+(F<<5)>>2]);g[z+(F<<5)+4>>2]=ea(g[k+(F<<5)+4>>2]);g[z+(F<<5)+8>>2]=ea(g[k+(F<<5)+8>>2]);g[z+(F<<5)+16>>2]=ea(g[k+(F<<5)+16>>2]);g[z+(F<<5)+20>>2]=ea(g[k+(F<<5)+20>>2]);g[z+(F<<5)+24>>2]=ea(g[k+(F<<5)+24>>2]);c[o>>2]=$+(ha&65535);ba=ba+1|0;if((ba|0)==(C|0))break;else F=F+1|0}}fa=(hTa(t,64)|0)+-64-p|0;if((fa|0)>=(n|0))break;else ca=64}}ca=_+1|0;n=j+-1|0;if(!n){ia=X;ja=Y;ka=Z;la=_;ma=ca}else{fa=_+j|0;j=(da(l,n)|0)+Z|0;p=X;X=Y;Y=Z;Z=ca;while(1){Y=Y+l|0;if((X|0)<(Y|0)){ca=p;t=X;while(1){ha=Y-t|0;k=(ha|0)<(ca|0)?ha:ca;f1a(q,k,t+l|0,l,r,m,499144,Z,0,Z);if((ca|0)==(k|0)){na=4;oa=(hTa(s,4)|0)+-4|0}else{na=ca-k|0;oa=k+t|0}if((oa|0)<(Y|0)){ca=na;t=oa}else{pa=na;qa=oa;break}}}else{pa=p;qa=X}Z=Z+1|0;if((Z|0)==(fa|0))break;else{p=pa;X=qa}}ia=pa;ja=qa;ka=j;la=n+_|0;ma=fa}a[d>>0]=1;d=ka+l|0;if((ja|0)<(d|0)){ra=ia;sa=ja}else{ta=la+2|0;c[A>>2]=ta;i=y;return}while(1){ja=d-sa|0;ia=(ja|0)<(ra|0)?ja:ra;g1a(q,ia,sa+l|0,l,r,u,v,w,m,ma,0,ma,499184);if((ra|0)==(ia|0)){ua=4;va=(hTa(s,4)|0)+-4|0}else{ua=ra-ia|0;va=ia+sa|0}if((va|0)<(d|0)){ra=ua;sa=va}else break}ta=la+2|0;c[A>>2]=ta;i=y;return}function Pwa(a,d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D){a=a|0;d=ea(d);f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;var E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;s=i;i=i+560|0;q=s+528|0;l=s+8|0;a=s;c[q+16>>2]=k;k=c[z+4>>2]|0;E=c[A+4>>2]|0;c[q+4>>2]=s+16;c[q+12>>2]=32;c[q+8>>2]=0;F=(hTa(t,32)|0)+-32|0;G=hTa(u,32)|0;c[l>>2]=z;c[l+4>>2]=0;c[a>>2]=A;c[a+4>>2]=0;A=f+-1|0;if(!A){H=32;I=F;J=0;K=0}else{z=da(k,A)|0;L=0;M=32;N=F;F=0;O=0;while(1){F=F+k|0;if((N|0)<(F|0)){P=M;Q=N;while(1){R=F-Q|0;S=(R|0)<(P|0)?R:P;f1a(p,S,Q,k,q,l,499376,O,0,O);if((P|0)==(S|0)){T=32;U=(hTa(t,32)|0)+-32|0}else{T=P-S|0;U=S+Q|0}if((U|0)<(F|0)){P=T;Q=U}else{V=T;W=U;break}}}else{V=M;W=N}L=L+1|0;if((L|0)==(A|0)){H=V;I=W;J=z;K=A;break}else{M=V;N=W;O=O+1|0}}}if(K>>>0<f>>>0){O=da(k,f-K|0)|0;W=K;N=H;V=I;M=J;A=K;while(1){M=M+k|0;if((V|0)<(M|0)){z=N;L=V;while(1){U=M-L|0;T=(U|0)<(z|0)?U:z;f1a(p,T,L,k,q,l,499504,A,0,A);if((z|0)==(T|0)){X=32;Y=(hTa(t,32)|0)+-32|0}else{X=z-T|0;Y=T+L|0}if((Y|0)<(M|0)){z=X;L=Y}else{Z=X;_=Y;break}}}else{Z=N;_=V}W=W+1|0;if((W|0)==(f|0))break;else{N=Z;V=_;A=A+1|0}}$=Z;aa=_;ba=J+O|0;ca=f}else{$=H;aa=I;ba=J;ca=K}K=G+-32|0;G=f<<1;J=f<<1;f=J+-1|0;if(ca>>>0<(G+-1|0)>>>0){I=f-ca|0;H=da(E,I)|0;O=ca;_=32;Z=K;A=0;V=0;while(1){V=V+E|0;if((Z|0)<(V|0)){N=_;W=Z;while(1){Y=V-W|0;X=(Y|0)<(N|0)?Y:N;f1a(r,X,W,E,q,a,499376,ca,A,A);if((N|0)==(X|0)){fa=32;ga=(hTa(u,32)|0)+-32|0}else{fa=N-X|0;ga=X+W|0}if((ga|0)<(V|0)){N=fa;W=ga}else{ha=fa;ia=ga;break}}}else{ha=_;ia=Z}O=O+1|0;if((O|0)==(f|0)){ja=f;ka=ha;la=ia;ma=I;na=H;break}else{_=ha;Z=ia;A=A+1|0}}}else{ja=ca;ka=32;la=K;ma=0;na=0}if(ja>>>0<G>>>0){G=ma+J|0;K=da(E,J-ja|0)|0;A=ja;ia=ka;Z=la;ha=ma;_=na;while(1){_=_+E|0;if((Z|0)<(_|0)){H=ia;I=Z;while(1){f=_-I|0;O=(f|0)<(H|0)?f:H;f1a(r,O,I,E,q,a,499504,ca,ha,ha);if((H|0)==(O|0)){oa=32;pa=(hTa(u,32)|0)+-32|0}else{oa=H-O|0;pa=O+I|0}if((pa|0)<(_|0)){H=oa;I=pa}else{qa=oa;ra=pa;break}}}else{qa=ia;ra=Z}A=A+1|0;if((A|0)==(J|0))break;else{ia=qa;Z=ra;ha=ha+1|0}}sa=qa;ta=ra;ua=G-ja|0;va=na+K|0}else{sa=ka;ta=la;ua=ma;va=na}na=(hTa(v,64)|0)+-64|0;if((na|0)<(o|0)){ma=~o;la=64;ka=na;while(1){K=o-ka|0;ja=(K|0)>64?64:K;K=la-ja|0;if((ja|0)>0){G=ka+ma|0;ra=(G|0)>-65?G:-65;G=~ra;qa=0;ha=ka;while(1){Z=n+(ha*40|0)|0;ia=c[Z>>2]|0;J=ia+12|0;A=da(e[J>>1]|0,ca)|0;pa=(da(e[ia+14>>1]|0,ua)|0)+A|0;A=ia+28|0;if((c[A>>2]|0)!=(pa|0))do{}while((c[A>>2]|0)!=(pa|0));if(!(c[125134]|0))wa=pa;else{Eza(Z);wa=c[A>>2]|0}c[A>>2]=wa+(e[J>>1]|0);qa=qa+1|0;if((qa|0)==(G|0))break;else ha=ha+1|0}xa=ka+-1-ra|0}else xa=ka;if((la|0)==(ja|0)){ya=64;za=(hTa(v,64)|0)+-64|0}else{ya=K;za=xa}if((za|0)<(o|0)){la=ya;ka=za}else{Aa=ya;Ba=za;break}}}else{Aa=64;Ba=na}na=Ba-o|0;if((na|0)<(m|0)){Ba=~m;za=Aa;Aa=na;while(1){na=m-Aa|0;if((((za|0)<(na|0)?za:na)|0)>0){na=~za;ya=Aa+Ba|0;ka=~((ya|0)<(na|0)?na:ya);ya=0;na=Aa;while(1){la=j+(na<<5)+12|0;xa=b[la>>1]|0;wa=da(xa&65535,ca)|0;n=(da(e[j+(na<<5)+14>>1]|0,ua)|0)+wa|0;wa=j+(na<<5)+28|0;if((c[wa>>2]|0)==(n|0))Ca=xa;else{do{}while((c[wa>>2]|0)!=(n|0));Ca=b[la>>1]|0}g[B+(na<<5)>>2]=ea(g[j+(na<<5)>>2]);g[B+(na<<5)+4>>2]=ea(g[j+(na<<5)+4>>2]);g[B+(na<<5)+8>>2]=ea(g[j+(na<<5)+8>>2]);g[B+(na<<5)+16>>2]=ea(g[j+(na<<5)+16>>2]);g[B+(na<<5)+20>>2]=ea(g[j+(na<<5)+20>>2]);g[B+(na<<5)+24>>2]=ea(g[j+(na<<5)+24>>2]);c[wa>>2]=n+(Ca&65535);ya=ya+1|0;if((ya|0)==(ka|0))break;else na=na+1|0}}Aa=(hTa(v,64)|0)+-64-o|0;if((Aa|0)>=(m|0))break;else za=64}}za=ca+1|0;m=h+-1|0;Aa=ba+k|0;if(!m){Da=Aa;Ea=$;Fa=sa;Ga=ta;Ha=ua;Ia=aa;Ja=va;Ka=za}else{o=da(k,h)|0;v=da(E,m)|0;Ca=ca+h|0;h=Aa;Aa=$;$=sa;sa=ta;ta=ua;ca=aa;aa=va;j=za;while(1){if((ca|0)<(h|0)){za=Aa;B=ca;while(1){Ba=h-B|0;na=(Ba|0)<(za|0)?Ba:za;f1a(p,na,B+k|0,k,q,l,499376,j,ta,j);if((za|0)==(na|0)){La=32;Ma=(hTa(t,32)|0)+-32|0}else{La=za-na|0;Ma=na+B|0}if((Ma|0)<(h|0)){za=La;B=Ma}else{Na=La;Oa=Ma;break}}}else{Na=Aa;Oa=ca}j=j+1|0;aa=aa+E|0;if((sa|0)<(aa|0)){B=$;za=sa;while(1){na=aa-za|0;Ba=(na|0)<(B|0)?na:B;f1a(r,Ba,za,E,q,a,499376,j,ta,ta);if((B|0)==(Ba|0)){Pa=32;Qa=(hTa(u,32)|0)+-32|0}else{Pa=B-Ba|0;Qa=Ba+za|0}if((Qa|0)<(aa|0)){B=Pa;za=Qa}else{Ra=Pa;Sa=Qa;break}}}else{Ra=$;Sa=sa}if((j|0)==(Ca|0))break;else{h=h+k|0;Aa=Na;$=Ra;sa=Sa;ta=ta+1|0;ca=Oa}}Da=o+ba|0;Ea=Na;Fa=Ra;Ga=Sa;Ha=m+ua|0;Ia=Oa;Ja=v+va|0;Ka=Ca}if((Ia|0)<(Da|0)){Ca=Ea;Ea=Ia;while(1){Ia=Da-Ea|0;va=(Ia|0)<(Ca|0)?Ia:Ca;g1a(p,va,Ea+k|0,k,q,w,x,y,l,Ka,Ha,Ka,499440);if((Ca|0)==(va|0)){Ta=32;Ua=(hTa(t,32)|0)+-32|0}else{Ta=Ca-va|0;Ua=va+Ea|0}if((Ua|0)<(Da|0)){Ca=Ta;Ea=Ua}else break}}Ua=Ka+1|0;Ka=Ja+E|0;if((Ga|0)<(Ka|0)){Va=Fa;Wa=Ga}else{Xa=Ha+1|0;c[C>>2]=Ua;c[D>>2]=Xa;i=s;return}while(1){Ga=Ka-Wa|0;Fa=(Ga|0)<(Va|0)?Ga:Va;g1a(r,Fa,Wa,E,q,w,x,y,a,Ua,Ha,Ha,499440);if((Va|0)==(Fa|0)){Ya=32;Za=(hTa(u,32)|0)+-32|0}else{Ya=Va-Fa|0;Za=Fa+Wa|0}if((Za|0)<(Ka|0)){Va=Ya;Wa=Za}else break}Xa=Ha+1|0;c[C>>2]=Ua;c[D>>2]=Xa;i=s;return}function Qwa(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;n=d;c[n+16>>2]=l;c[n+4>>2]=h;c[n+12>>2]=j;j=n+8|0;c[j>>2]=0;if(!g){o=0;c[k>>2]=o;i=d;return}else p=0;do{if((b[f+(p<<5)+8>>1]|0)==-1)q=e[f+(p<<5)+10>>1]|0;else q=0;if((b[f+(p<<5)+12>>1]|0)==-1)r=e[f+(p<<5)+14>>1]|0;else r=0;Dn[c[m+((a[c[f+(p<<5)+16>>2]>>0]&255)<<2)>>2]&511](f+(p<<5)|0,n,l+(q<<6)|0,l+(r<<6)|0);p=p+1|0}while((p|0)!=(g|0));o=c[j>>2]|0;c[k>>2]=o;i=d;return}function Rwa(b,d,f,g,h,j,k,l,m,n){b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;f=i;i=i+32|0;b=f+4|0;o=f;c[b+16>>2]=m;c[b+4>>2]=j;c[b+12>>2]=k;c[b+8>>2]=0;c[o>>2]=0;if(!h){p=0;c[l>>2]=p;i=f;return}else q=0;do{m=c[g+(q<<3)>>2]|0;rn[c[n+((a[c[d+(m<<5)+16>>2]>>0]&255)<<2)>>2]&127](d+(m<<5)|0,e[g+(q<<3)+4>>1]|0,b,j,k,o);q=q+1|0}while((q|0)!=(h|0));p=c[o>>2]|0;c[l>>2]=p;i=f;return}function Swa(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=Im,ra=Im,sa=Im,ta=Im;e=i;f=c[b>>2]|0;h=c[b+4>>2]|0;j=c[b+16>>2]|0;k=ea(g[f>>2]);b=f+4|0;l=ea(g[b>>2]);m=f+8|0;n=ea(g[m>>2]);o=ea(g[h>>2]);p=h+4|0;q=ea(g[p>>2]);r=h+8|0;s=ea(g[r>>2]);t=f+16|0;u=ea(g[t>>2]);v=f+20|0;w=ea(g[v>>2]);x=f+24|0;y=ea(g[x>>2]);z=h+16|0;A=ea(g[z>>2]);B=h+20|0;C=ea(g[B>>2]);D=h+24|0;E=ea(g[D>>2]);F=j+1|0;if(!(a[F>>0]|0)){G=n;H=l;I=k;J=s;K=q;L=o;M=y;N=w;O=u;P=E;Q=C;R=A;g[f>>2]=I;g[b>>2]=H;g[m>>2]=G;g[t>>2]=O;g[v>>2]=N;g[x>>2]=M;g[h>>2]=L;g[p>>2]=K;g[r>>2]=J;g[z>>2]=R;g[B>>2]=Q;g[D>>2]=P;i=e;return}S=o;o=q;q=s;s=A;A=C;C=E;E=k;k=l;l=n;n=u;u=w;w=y;T=j+48|0;j=0;while(1){y=ea(g[T>>2]);U=ea(g[T+4>>2]);V=ea(g[T+8>>2]);W=ea(g[T+16>>2]);X=ea(g[T+20>>2]);Y=ea(g[T+24>>2]);Z=ea(g[T+32>>2]);_=ea(g[T+36>>2]);$=ea(g[T+40>>2]);aa=ea(g[T+48>>2]);ba=ea(g[T+52>>2]);ca=ea(g[T+56>>2]);da=ea(g[T+64>>2]);fa=ea(g[T+68>>2]);ga=ea(g[T+72>>2]);ha=ea(g[T+80>>2]);ia=ea(g[T+84>>2]);ja=ea(g[T+88>>2]);ka=ea(g[T+76>>2]);la=ea(g[T+92>>2]);ma=ea(g[T+12>>2]);na=ea(g[T+44>>2]);oa=ea(g[T+60>>2]);pa=T+104|0;qa=ea(g[pa>>2]);ra=ea(g[T+100>>2]);sa=ea(g[T+96>>2]);ta=ea(ea(ma+ea(ea(ea(ea(ea(ea(E*y)+ea(k*U))+ea(l*V))+ea(ea(ea(n*Z)+ea(u*_))+ea(w*$)))-ea(ea(ea(ea(S*W)+ea(o*X))+ea(q*Y))+ea(ea(ea(s*aa)+ea(A*ba))+ea(C*ca))))*na))+ea(oa*qa));oa=sa>ta?sa:ta;ta=ra>oa?oa:ra;ra=ea(ta-qa);qa=ea(y*ka);y=ea(U*ka);U=ea(V*ka);ka=ea(W*la);W=ea(X*la);X=ea(Y*la);g[pa>>2]=ta;ta=ea(E+ea(qa*ra));qa=ea(k+ea(y*ra));y=ea(l+ea(U*ra));U=ea(S+ea(ka*ra));ka=ea(o+ea(W*ra));W=ea(q+ea(X*ra));X=ea(n+ea(da*ra));da=ea(u+ea(fa*ra));fa=ea(w+ea(ga*ra));ga=ea(s+ea(ha*ra));ha=ea(A+ea(ia*ra));ia=ea(C+ea(ja*ra));j=j+1|0;if(j>>>0>=(d[F>>0]|0)>>>0){G=y;H=qa;I=ta;J=W;K=ka;L=U;M=fa;N=da;O=X;P=ia;Q=ha;R=ga;break}else{S=U;o=ka;q=W;s=ga;A=ha;C=ia;E=ta;k=qa;l=y;n=X;u=da;w=fa;T=T+112|0}}g[f>>2]=I;g[b>>2]=H;g[m>>2]=G;g[t>>2]=O;g[v>>2]=N;g[x>>2]=M;g[h>>2]=L;g[p>>2]=K;g[r>>2]=J;g[z>>2]=R;g[B>>2]=Q;g[D>>2]=P;i=e;return}function Twa(b,e){b=b|0;e=e|0;var f=0,h=0,j=0;e=i;f=c[b+16>>2]|0;b=(a[f>>0]|0)==4?176:112;h=f+1|0;if(!(a[h>>0]|0)){i=e;return}j=f+48|0;f=0;while(1){g[j+12>>2]=ea(g[j+28>>2]);f=f+1|0;if(f>>>0>=(d[h>>0]|0)>>>0)break;else j=j+b|0}i=e;return}function Uwa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=0,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im;f=i;h=c[d>>2]|0;j=c[d+4>>2]|0;k=ea(g[h>>2]);l=h+4|0;m=ea(g[l>>2]);n=h+8|0;o=ea(g[n>>2]);p=ea(g[j>>2]);q=j+4|0;r=ea(g[q>>2]);s=j+8|0;t=ea(g[s>>2]);u=h+16|0;v=ea(g[u>>2]);w=h+20|0;x=ea(g[w>>2]);y=h+24|0;z=ea(g[y>>2]);A=j+16|0;B=ea(g[A>>2]);C=j+20|0;D=ea(g[C>>2]);E=j+24|0;F=ea(g[E>>2]);G=c[d+16>>2]|0;H=b[d+26>>1]|0;d=G+((H&65535)<<4)|0;if(!(H<<16>>16)){I=o;J=m;K=k;L=t;M=r;N=p;O=z;P=x;Q=v;R=F;T=D;U=B;g[h>>2]=K;g[l>>2]=J;g[n>>2]=I;g[j>>2]=N;g[q>>2]=M;g[s>>2]=L;g[u>>2]=Q;g[w>>2]=P;g[y>>2]=O;g[A>>2]=U;g[C>>2]=T;g[E>>2]=R;i=f;return}H=e+1|0;V=B;B=D;D=F;F=v;v=x;x=z;z=p;p=r;r=t;t=k;k=m;m=o;H=G;while(1){G=H+32|0;W=a[H+5>>0]|0;X=W&255;Y=a[H+6>>0]|0;Z=Y&255;_=(X*96|0)+32|0;$=H+_|0;o=ea(g[H+108>>2]);aa=ea(g[H+124>>2]);if(!(W<<24>>24)){ba=m;ca=k;da=t;fa=r;ga=p;ha=z;ia=x;ja=v;ka=F;la=D;ma=B;na=V;oa=ea(0.0)}else{pa=r;qa=V;ra=B;sa=D;ta=ea(0.0);ua=t;va=k;wa=m;xa=F;ya=v;za=x;Aa=z;Ba=p;W=0;while(1){Ca=W;W=W+1|0;Da=ea(g[G+(Ca*96|0)>>2]);Ea=ea(g[G+(Ca*96|0)+4>>2]);Fa=ea(g[G+(Ca*96|0)+8>>2]);Ga=ea(g[G+(Ca*96|0)+12>>2]);Ha=ea(g[G+(Ca*96|0)+16>>2]);Ia=ea(g[G+(Ca*96|0)+20>>2]);Ja=ea(g[G+(Ca*96|0)+24>>2]);Ka=G+(Ca*96|0)+28|0;La=ea(g[Ka>>2]);Ma=ea(g[G+(Ca*96|0)+32>>2]);Na=ea(g[G+(Ca*96|0)+36>>2]);Oa=ea(g[G+(Ca*96|0)+40>>2]);Pa=ea(g[G+(Ca*96|0)+52>>2]);Qa=ea(g[G+(Ca*96|0)+48>>2]);Ra=ea(g[G+(Ca*96|0)+56>>2]);Sa=ea(ea(Ga*Pa)-Qa);Qa=ea(ea(ea(ea(ea(ua*Da)+ea(va*Ea))+ea(wa*Fa))+ea(ea(ea(xa*Ha)+ea(ya*Ia))+ea(za*Ja)))-ea(ea(ea(ea(Aa*Da)+ea(Ba*Ea))+ea(pa*Fa))+ea(ea(ea(qa*Ma)+ea(ra*Na))+ea(sa*Oa))));Oa=ea(g[G+(Ca*96|0)+64>>2]);Na=ea(g[G+(Ca*96|0)+68>>2]);Ma=ea(g[G+(Ca*96|0)+72>>2]);Ja=ea(g[G+(Ca*96|0)+80>>2]);Ia=ea(g[G+(Ca*96|0)+84>>2]);Ha=ea(g[G+(Ca*96|0)+88>>2]);Pa=ea(o*Da);Ta=ea(o*Ea);Ua=ea(o*Fa);Va=ea(aa*Da);Da=ea(aa*Ea);Ea=ea(aa*Fa);Fa=ea(Sa-ea(Ga*Qa));Qa=ea(-La);Ga=ea(La+(Fa>Qa?Fa:Qa));Qa=Ga>Ra?Ra:Ga;Ga=ea(Qa-La);La=ea(ua+ea(Pa*Ga));Pa=ea(va+ea(Ta*Ga));Ta=ea(wa+ea(Ua*Ga));Ua=ea(Aa+ea(Va*Ga));Va=ea(Ba+ea(Da*Ga));Da=ea(pa+ea(Ea*Ga));Ea=ea(xa+ea(Oa*Ga));Oa=ea(ya+ea(Na*Ga));Na=ea(za+ea(Ma*Ga));Ma=ea(qa+ea(Ja*Ga));Ja=ea(ra+ea(Ia*Ga));Ia=ea(sa+ea(Ha*Ga));g[Ka>>2]=Qa;Ga=ea(ta+Qa);if((W|0)==(X|0)){ba=Ta;ca=Pa;da=La;fa=Da;ga=Va;ha=Ua;ia=Na;ja=Oa;ka=Ea;la=Ia;ma=Ja;na=Ma;oa=Ga;break}else{pa=Da;qa=Ma;ra=Ja;sa=Ia;ta=Ga;ua=La;va=Pa;wa=Ta;xa=Ea;ya=Oa;za=Na;Aa=Ua;Ba=Va}}}if((a[e>>0]|0)==0|Y<<24>>24==0){Wa=ba;Xa=ca;Ya=da;Za=fa;_a=ga;$a=ha;ab=ia;bb=ja;cb=ka;db=la;eb=ma;fb=na}else{Ba=ea(g[H+16>>2]);Aa=ea(oa*Ba);Ba=ea(oa*ea(g[H+20>>2]));za=ea(-Ba);ya=da;xa=ca;wa=ba;va=ka;ua=ja;ta=ia;sa=ha;ra=ga;qa=fa;pa=na;Va=ma;Ua=la;X=0;while(1){W=X+1|0;Na=ea(g[$+(X*96|0)>>2]);Oa=ea(g[$+(X*96|0)+4>>2]);Ea=ea(g[$+(X*96|0)+8>>2]);G=$+(X*96|0)+12|0;Ta=ea(g[G>>2]);Pa=ea(g[$+(X*96|0)+16>>2]);La=ea(g[$+(X*96|0)+20>>2]);Ga=ea(g[$+(X*96|0)+24>>2]);Ia=ea(g[$+(X*96|0)+28>>2]);Ja=ea(g[$+(X*96|0)+32>>2]);Ma=ea(g[$+(X*96|0)+36>>2]);Da=ea(g[$+(X*96|0)+40>>2]);Qa=ea(g[$+(X*96|0)+44>>2]);Ka=$+(X*96|0)+60|0;Ha=ea(g[Ka>>2]);Ra=ea(ea(ea(ea(ea(ya*Na)+ea(xa*Oa))+ea(wa*Ea))+ea(ea(ea(va*Pa)+ea(ua*La))+ea(ta*Ga)))-ea(ea(ea(ea(sa*Na)+ea(ra*Oa))+ea(qa*Ea))+ea(ea(ea(pa*Ja)+ea(Va*Ma))+ea(Ua*Da))));Da=ea(Ta-ea(Ia*ea(Qa-ea(g[$+(X*96|0)+76>>2]))));Qa=ea(g[$+(X*96|0)+48>>2]);Ma=ea(g[$+(X*96|0)+52>>2]);Ja=ea(g[$+(X*96|0)+56>>2]);Ga=ea(g[$+(X*96|0)+64>>2]);La=ea(g[$+(X*96|0)+68>>2]);Pa=ea(g[$+(X*96|0)+72>>2]);Fa=ea(o*Na);Sa=ea(o*Oa);gb=ea(o*Ea);hb=ea(aa*Na);Na=ea(aa*Oa);Oa=ea(aa*Ea);Ea=ea(Da-ea(Ia*Ra));Ra=ea(S(ea(Ea)));Ia=Ea<za?za:Ea;Ca=!(Ra>Aa);Ra=Ca?Ea:Ba>Ia?Ia:Ba;Ia=ea(Ra-Ta);Ta=Ca?Ha:ea(1.0);Ha=ea(ya+ea(Fa*Ia));Fa=ea(xa+ea(Sa*Ia));Sa=ea(wa+ea(gb*Ia));gb=ea(sa+ea(hb*Ia));hb=ea(ra+ea(Na*Ia));Na=ea(qa+ea(Oa*Ia));Oa=ea(va+ea(Qa*Ia));Qa=ea(ua+ea(Ma*Ia));Ma=ea(ta+ea(Ja*Ia));Ja=ea(pa+ea(Ga*Ia));Ga=ea(Va+ea(La*Ia));La=ea(Ua+ea(Pa*Ia));g[G>>2]=Ra;g[Ka>>2]=Ta;if((W|0)==(Z|0)){Wa=Sa;Xa=Fa;Ya=Ha;Za=Na;_a=hb;$a=gb;ab=Ma;bb=Qa;cb=Oa;db=La;eb=Ga;fb=Ja;break}else{ya=Ha;xa=Fa;wa=Sa;va=Oa;ua=Qa;ta=Ma;sa=gb;ra=hb;qa=Na;pa=Ja;Va=Ga;Ua=La;X=W}}}H=H+(_+(Z*96|0))|0;if(H>>>0>=d>>>0){I=Wa;J=Xa;K=Ya;L=Za;M=_a;N=$a;O=ab;P=bb;Q=cb;R=db;T=eb;U=fb;break}else{V=fb;B=eb;D=db;F=cb;v=bb;x=ab;z=$a;p=_a;r=Za;t=Ya;k=Xa;m=Wa}}g[h>>2]=K;g[l>>2]=J;g[n>>2]=I;g[j>>2]=N;g[q>>2]=M;g[s>>2]=L;g[u>>2]=Q;g[w>>2]=P;g[y>>2]=O;g[A>>2]=U;g[C>>2]=T;g[E>>2]=R;i=f;return}function Vwa(d,e){d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im;f=i;h=c[d>>2]|0;j=ea(g[h>>2]);k=h+4|0;l=ea(g[k>>2]);m=h+8|0;n=ea(g[m>>2]);o=h+16|0;p=ea(g[o>>2]);q=h+20|0;r=ea(g[q>>2]);s=h+24|0;t=ea(g[s>>2]);u=c[d+16>>2]|0;v=b[d+26>>1]|0;d=u+((v&65535)<<4)|0;if(!(v<<16>>16)){w=n;x=l;y=j;z=t;A=r;B=p;g[h>>2]=y;g[k>>2]=x;g[m>>2]=w;g[o>>2]=B;g[q>>2]=A;g[s>>2]=z;i=f;return}v=e+1|0;C=p;p=r;r=t;t=j;j=l;l=n;v=u;while(1){u=v+32|0;D=a[v+5>>0]|0;E=D&255;F=a[v+6>>0]|0;G=F&255;H=(E*96|0)+32|0;I=v+H|0;n=ea(g[v+108>>2]);if(!(D<<24>>24)){J=l;K=j;L=t;M=r;N=p;O=C;P=ea(0.0)}else{Q=ea(0.0);R=t;T=j;U=l;V=C;W=p;X=r;D=0;while(1){Y=D;D=D+1|0;Z=ea(g[u+(Y*96|0)>>2]);_=ea(g[u+(Y*96|0)+4>>2]);$=ea(g[u+(Y*96|0)+8>>2]);aa=ea(g[u+(Y*96|0)+12>>2]);ba=ea(g[u+(Y*96|0)+16>>2]);ca=ea(g[u+(Y*96|0)+20>>2]);da=ea(g[u+(Y*96|0)+24>>2]);fa=u+(Y*96|0)+28|0;ga=ea(g[fa>>2]);ha=ea(g[u+(Y*96|0)+52>>2]);ia=ea(g[u+(Y*96|0)+48>>2]);ja=ea(g[u+(Y*96|0)+56>>2]);ka=ea(ea(aa*ha)-ia);ia=ea(ea(ea(ea(R*Z)+ea(T*_))+ea(U*$))+ea(ea(ea(V*ba)+ea(W*ca))+ea(X*da)));da=ea(g[u+(Y*96|0)+64>>2]);ca=ea(g[u+(Y*96|0)+68>>2]);ba=ea(g[u+(Y*96|0)+72>>2]);ha=ea(n*Z);Z=ea(n*_);_=ea(n*$);$=ea(ka-ea(aa*ia));ia=ea(-ga);aa=ea(ga+($>ia?$:ia));ia=aa>ja?ja:aa;aa=ea(ia-ga);ga=ea(R+ea(ha*aa));ha=ea(T+ea(Z*aa));Z=ea(U+ea(_*aa));_=ea(V+ea(da*aa));da=ea(W+ea(ca*aa));ca=ea(X+ea(ba*aa));g[fa>>2]=ia;aa=ea(Q+ia);if((D|0)==(E|0)){J=Z;K=ha;L=ga;M=ca;N=da;O=_;P=aa;break}else{Q=aa;R=ga;T=ha;U=Z;V=_;W=da;X=ca}}}if((a[e>>0]|0)==0|F<<24>>24==0){la=J;ma=K;na=L;oa=M;pa=N;qa=O}else{X=ea(P*ea(g[v+16>>2]));W=ea(P*ea(g[v+20>>2]));V=ea(-W);U=L;T=K;R=J;Q=O;ca=N;da=M;E=0;while(1){D=E+1|0;_=ea(g[I+(E*96|0)>>2]);Z=ea(g[I+(E*96|0)+4>>2]);ha=ea(g[I+(E*96|0)+8>>2]);u=I+(E*96|0)+12|0;ga=ea(g[u>>2]);aa=ea(g[I+(E*96|0)+16>>2]);ia=ea(g[I+(E*96|0)+20>>2]);ba=ea(g[I+(E*96|0)+24>>2]);ja=ea(g[I+(E*96|0)+28>>2]);$=ea(g[I+(E*96|0)+44>>2]);ka=ea(ea(ea(ea(U*_)+ea(T*Z))+ea(R*ha))+ea(ea(ea(Q*aa)+ea(ca*ia))+ea(da*ba)));ba=ea(ga-ea(ja*ea($-ea(g[I+(E*96|0)+76>>2]))));$=ea(g[I+(E*96|0)+48>>2]);ia=ea(g[I+(E*96|0)+52>>2]);aa=ea(g[I+(E*96|0)+56>>2]);fa=I+(E*96|0)+60|0;ra=ea(n*_);_=ea(n*Z);Z=ea(n*ha);ha=ea(g[fa>>2]);sa=ea(ba-ea(ja*ka));ka=ea(S(ea(sa)));ja=sa<V?V:sa;Y=!(ka>X);ka=Y?sa:W>ja?ja:W;ja=ea(ka-ga);ga=Y?ha:ea(1.0);ha=ea(U+ea(ra*ja));ra=ea(T+ea(_*ja));_=ea(R+ea(Z*ja));Z=ea(Q+ea($*ja));$=ea(ca+ea(ia*ja));ia=ea(da+ea(aa*ja));g[u>>2]=ka;g[fa>>2]=ga;if((D|0)==(G|0)){la=_;ma=ra;na=ha;oa=ia;pa=$;qa=Z;break}else{U=ha;T=ra;R=_;Q=Z;ca=$;da=ia;E=D}}}v=v+(H+(G*96|0))|0;if(v>>>0>=d>>>0){w=la;x=ma;y=na;z=oa;A=pa;B=qa;break}else{C=qa;p=pa;r=oa;t=na;j=ma;l=la}}g[h>>2]=y;g[k>>2]=x;g[m>>2]=w;g[o>>2]=B;g[q>>2]=A;g[s>>2]=z;i=f;return}function Wwa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0;e=i;f=c[d+16>>2]|0;h=b[d+26>>1]|0;d=f+((h&65535)<<4)|0;if(!(h<<16>>16)){i=e;return}else j=f;while(1){f=j+32|0;h=a[j+5>>0]|0;k=a[j+6>>0]|0;l=a[j>>0]|0;m=l<<24>>24==3?128:96;if(!(h<<24>>24)){n=l;o=f}else{l=h&255;h=da(m,l)|0;p=f;f=0;while(1){q=p+48|0;r=ea(g[q>>2]);s=r>ea(0.0);g[q>>2]=s?r:ea(0.0);g[p+60>>2]=ea(0.0);f=f+1|0;if((f|0)==(l|0))break;else p=p+m|0}n=a[j>>0]|0;o=j+(h+32)|0}m=n<<24>>24==3?128:96;if(!(k<<24>>24))t=o;else{p=k&255;l=da(m,p)|0;f=o;s=0;while(1){g[f+44>>2]=ea(0.0);s=s+1|0;if((s|0)==(p|0))break;else f=f+m|0}t=o+l|0}if(t>>>0<d>>>0)j=t;else break}i=e;return}function Xwa(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=Im,C=0,D=Im,E=0,F=0,G=0,H=0;j=i;k=c[d+16>>2]|0;l=b[d+26>>1]|0;m=k+((l&65535)<<4)|0;if(!(l<<16>>16)){i=j;return}l=k;n=ea(0.0);k=c[d+20>>2]|0;while(1){o=l+32|0;p=(a[l+4>>0]&1)==0;q=a[l+5>>0]|0;r=q&255;s=a[l+6>>0]|0;t=a[l>>0]|0;u=t<<24>>24==3?128:96;if(k)if(!(q<<24>>24)){v=t;w=o;x=n;y=k}else{q=k+(r<<2)|0;z=da(u,r)|0;A=o;o=0;B=n;C=k;while(1){D=ea(g[A+28>>2]);g[C>>2]=D;B=ea(B+D);o=o+1|0;if((o|0)==(r|0))break;else{A=A+u|0;C=C+4|0}}v=a[l>>0]|0;w=l+(z+32)|0;x=B;y=q}else{v=t;w=l+((da(u,r)|0)+32)|0;x=n;y=0}C=v<<24>>24==3?128:96;if(!(s<<24>>24))E=w;else{A=s&255;o=da(C,A)|0;F=w;G=0;do{H=c[F+80>>2]|0;if((H|0)!=0?(c[F+60>>2]|0)!=0:0)a[H>>0]=1;F=F+C|0;G=G+1|0}while((G|0)!=(A|0));E=w+o|0}if(E>>>0<m>>>0){l=E;n=x;k=y}else break}if(p){i=j;return}if((b[d+8>>1]|0)!=-1){i=j;return}if(!(x!=ea(0.0)?(b[d+12>>1]|0)==-1:0)){i=j;return}n=ea(g[f+36>>2]);d=n<ea(3402823469999999843913219.0e14);B=ea(g[h+36>>2]);if(!(d|B<ea(3402823469999999843913219.0e14))){i=j;return}d=c[f+40>>2]|0;f=c[h+40>>2]|0;h=f>>>0<d>>>0;p=e+8|0;y=c[p>>2]|0;c[p>>2]=y+1;p=c[e+4>>2]|0;c[p+(y<<4)>>2]=h?f:d;c[p+(y<<4)+4>>2]=h?d:f;g[p+(y<<4)+8>>2]=x;g[p+(y<<4)+12>>2]=n<B?n:B;i=j;return}function Ywa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0;f=i;e=c[b+20>>2]|0;if(!e){i=f;return}d=c[b+16>>2]|0;b=(a[d>>0]|0)==4?176:112;h=a[d+1>>0]|0;if(!(h<<24>>24)){j=ea(0.0);k=ea(0.0);l=ea(0.0);m=ea(0.0);n=ea(0.0);o=ea(0.0)}else{p=h&255;q=ea(0.0);r=ea(0.0);s=ea(0.0);t=ea(0.0);u=ea(0.0);v=ea(0.0);h=d+48|0;w=0;while(1){if(!(c[h+108>>2]&2)){x=q;y=v;z=u;A=t;B=s;C=r}else{D=ea(g[h+104>>2]);E=ea(D*ea(g[h>>2]));F=ea(D*ea(g[h+4>>2]));G=ea(q+E);E=ea(r+F);F=ea(s+ea(D*ea(g[h+8>>2])));H=ea(D*ea(g[h+32>>2]));I=ea(D*ea(g[h+36>>2]));x=G;y=ea(v+ea(D*ea(g[h+40>>2])));z=ea(u+I);A=ea(t+H);B=F;C=E}w=w+1|0;if(w>>>0>=p>>>0){j=B;k=z;l=A;m=C;n=x;o=y;break}else{q=x;r=C;s=B;t=A;u=z;v=y;h=h+b|0}}}y=ea(g[d+20>>2]);v=ea(j*y);z=ea(g[d+24>>2]);u=ea(v-ea(m*z));v=ea(n*z);z=ea(g[d+16>>2]);A=ea(l-u);u=ea(k-ea(v-ea(j*z)));v=ea(o-ea(ea(m*z)-ea(n*y)));g[e>>2]=n;g[e+4>>2]=m;g[e+8>>2]=j;g[e+16>>2]=A;g[e+20>>2]=u;g[e+24>>2]=v;y=ea(T(ea(ea(j*j)+ea(ea(m*m)+ea(n*n)))));if(y>ea(g[d+4>>2]))J=1;else{y=ea(T(ea(ea(v*v)+ea(ea(A*A)+ea(u*u)))));J=y>ea(g[d+8>>2])}c[e+12>>2]=J&1;i=f;return}function Zwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if(!b){i=d;return}else e=0;do{Swa(a+(e<<5)|0,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function _wa(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;if(!e){i=h;return}else j=0;do{Swa(b+(j<<5)|0,f);k=c[b+(j<<5)+16>>2]|0;l=(a[k>>0]|0)==4?176:112;m=k+1|0;if(a[m>>0]|0){n=k+48|0;k=0;while(1){g[n+12>>2]=ea(g[n+28>>2]);k=k+1|0;if(k>>>0>=(d[m>>0]|0)>>>0)break;else n=n+l|0}}j=j+1|0}while((j|0)!=(e|0));i=h;return}function $wa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;if(!b){i=f;return}else g=0;do{e=a+(g<<5)|0;Swa(e,c);Ywa(e,0,0,0);g=g+1|0}while((g|0)!=(b|0));i=f;return}function axa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if(!b){i=d;return}else e=0;do{Uwa(a+(e<<5)|0,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function bxa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0;h=i;if(!e){i=h;return}else j=0;do{Uwa(d+(j<<5)|0,f);k=c[d+(j<<5)+16>>2]|0;l=b[d+(j<<5)+26>>1]|0;m=k+((l&65535)<<4)|0;if(l<<16>>16){l=k;while(1){k=l+32|0;n=a[l+5>>0]|0;o=a[l+6>>0]|0;p=a[l>>0]|0;q=p<<24>>24==3?128:96;if(!(n<<24>>24)){r=p;s=k}else{p=n&255;n=k;k=0;while(1){t=n+48|0;u=ea(g[t>>2]);v=u>ea(0.0);g[t>>2]=v?u:ea(0.0);g[n+60>>2]=ea(0.0);k=k+1|0;if((k|0)==(p|0))break;else n=n+q|0}n=l+((da(q,p)|0)+32)|0;r=a[l>>0]|0;s=n}n=r<<24>>24==3?128:96;if(!(o<<24>>24))w=s;else{k=o&255;v=s;t=0;while(1){g[v+44>>2]=ea(0.0);t=t+1|0;if((t|0)==(k|0))break;else v=v+n|0}w=s+(da(n,k)|0)|0}if(w>>>0<m>>>0)l=w;else break}}j=j+1|0}while((j|0)!=(e|0));i=h;return}function cxa(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;g=i;if(b){j=d+16|0;k=0;do{l=a+(k<<5)|0;m=c[j>>2]|0;n=m+((e[a+(k<<5)+10>>1]|0)<<6)|0;o=m+((e[a+(k<<5)+14>>1]|0)<<6)|0;Uwa(l,d);Xwa(l,d,n,o);k=k+1|0}while((k|0)!=(b|0))}b=d+8|0;k=c[b>>2]|0;if(k>>>0<=((c[d+12>>2]|0)+-4|0)>>>0){i=g;return}a=hTa(h,k)|0;k=c[b>>2]|0;h=a-k|0;if(k){k=d+4|0;d=0;do{a=f+(h+d<<4)|0;j=(c[k>>2]|0)+(d<<4)|0;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];d=d+1|0}while(d>>>0<(c[b>>2]|0)>>>0)}c[b>>2]=0;i=g;return}function dxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if(!b){i=d;return}else e=0;do{Vwa(a+(e<<5)|0,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function exa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0;h=i;if(!e){i=h;return}else j=0;do{Vwa(d+(j<<5)|0,f);k=c[d+(j<<5)+16>>2]|0;l=b[d+(j<<5)+26>>1]|0;m=k+((l&65535)<<4)|0;if(l<<16>>16){l=k;while(1){k=l+32|0;n=a[l+5>>0]|0;o=a[l+6>>0]|0;p=a[l>>0]|0;q=p<<24>>24==3?128:96;if(!(n<<24>>24)){r=p;s=k}else{p=n&255;n=k;k=0;while(1){t=n+48|0;u=ea(g[t>>2]);v=u>ea(0.0);g[t>>2]=v?u:ea(0.0);g[n+60>>2]=ea(0.0);k=k+1|0;if((k|0)==(p|0))break;else n=n+q|0}n=l+((da(q,p)|0)+32)|0;r=a[l>>0]|0;s=n}n=r<<24>>24==3?128:96;if(!(o<<24>>24))w=s;else{k=o&255;v=s;t=0;while(1){g[v+44>>2]=ea(0.0);t=t+1|0;if((t|0)==(k|0))break;else v=v+n|0}w=s+(da(n,k)|0)|0}if(w>>>0<m>>>0)l=w;else break}}j=j+1|0}while((j|0)!=(e|0));i=h;return}function fxa(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;g=i;if(b){j=d+16|0;k=0;do{l=a+(k<<5)|0;m=c[j>>2]|0;n=m+((e[a+(k<<5)+10>>1]|0)<<6)|0;o=m+((e[a+(k<<5)+14>>1]|0)<<6)|0;Vwa(l,d);Xwa(l,d,n,o);k=k+1|0}while((k|0)!=(b|0))}b=d+8|0;k=c[b>>2]|0;if(k>>>0<=((c[d+12>>2]|0)+-4|0)>>>0){i=g;return}a=hTa(h,k)|0;k=c[b>>2]|0;h=a-k|0;if(k){k=d+4|0;d=0;do{a=f+(h+d<<4)|0;j=(c[k>>2]|0)+(d<<4)|0;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];d=d+1|0}while(d>>>0<(c[b>>2]|0)>>>0)}c[b>>2]=0;i=g;return}function gxa(b,e){b=b|0;e=e|0;var f=0,h=0,j=0;f=i;Swa(b,e);e=c[b+16>>2]|0;b=(a[e>>0]|0)==4?176:112;h=e+1|0;if(!(a[h>>0]|0)){i=f;return}j=e+48|0;e=0;while(1){g[j+12>>2]=ea(g[j+28>>2]);e=e+1|0;if(e>>>0>=(d[h>>0]|0)>>>0)break;else j=j+b|0}i=f;return}function hxa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0;f=i;Uwa(d,e);e=c[d+16>>2]|0;h=b[d+26>>1]|0;d=e+((h&65535)<<4)|0;if(!(h<<16>>16)){i=f;return}else j=e;while(1){e=j+32|0;h=a[j+5>>0]|0;k=a[j+6>>0]|0;l=a[j>>0]|0;m=l<<24>>24==3?128:96;if(!(h<<24>>24)){n=l;o=e}else{l=h&255;h=e;e=0;while(1){p=h+48|0;q=ea(g[p>>2]);r=q>ea(0.0);g[p>>2]=r?q:ea(0.0);g[h+60>>2]=ea(0.0);e=e+1|0;if((e|0)==(l|0))break;else h=h+m|0}h=j+((da(m,l)|0)+32)|0;n=a[j>>0]|0;o=h}h=n<<24>>24==3?128:96;if(!(k<<24>>24))s=o;else{e=k&255;r=o;p=0;while(1){g[r+44>>2]=ea(0.0);p=p+1|0;if((p|0)==(e|0))break;else r=r+h|0}s=o+(da(h,e)|0)|0}if(s>>>0<d>>>0)j=s;else break}i=f;return}function ixa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0;f=i;aya(d,e);e=c[d+16>>2]|0;h=b[d+26>>1]|0;d=e+((h&65535)<<4)|0;if(!(h<<16>>16)){i=f;return}else j=e;while(1){e=j+32|0;h=a[j+5>>0]|0;k=a[j+6>>0]|0;l=a[j>>0]|0;m=l<<24>>24==3?128:96;if(!(h<<24>>24)){n=l;o=e}else{l=h&255;h=e;e=0;while(1){p=h+48|0;q=ea(g[p>>2]);r=q>ea(0.0);g[p>>2]=r?q:ea(0.0);g[h+60>>2]=ea(0.0);e=e+1|0;if((e|0)==(l|0))break;else h=h+m|0}h=j+((da(m,l)|0)+32)|0;n=a[j>>0]|0;o=h}h=n<<24>>24==3?128:96;if(!(k<<24>>24))s=o;else{e=k&255;r=o;p=0;while(1){g[r+44>>2]=ea(0.0);p=p+1|0;if((p|0)==(e|0))break;else r=r+h|0}s=o+(da(h,e)|0)|0}if(s>>>0<d>>>0)j=s;else break}i=f;return}function jxa(b,e){b=b|0;e=e|0;var f=0,h=0,j=0;f=i;$xa(b,e);e=c[b+16>>2]|0;b=(a[e>>0]|0)==4?176:112;h=e+1|0;if(!(a[h>>0]|0)){i=f;return}j=e+48|0;e=0;while(1){g[j+12>>2]=ea(g[j+28>>2]);e=e+1|0;if(e>>>0>=(d[h>>0]|0)>>>0)break;else j=j+b|0}i=f;return}function kxa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0;f=i;Vwa(d,e);e=c[d+16>>2]|0;h=b[d+26>>1]|0;d=e+((h&65535)<<4)|0;if(!(h<<16>>16)){i=f;return}else j=e;while(1){e=j+32|0;h=a[j+5>>0]|0;k=a[j+6>>0]|0;l=a[j>>0]|0;m=l<<24>>24==3?128:96;if(!(h<<24>>24)){n=l;o=e}else{l=h&255;h=e;e=0;while(1){p=h+48|0;q=ea(g[p>>2]);r=q>ea(0.0);g[p>>2]=r?q:ea(0.0);g[h+60>>2]=ea(0.0);e=e+1|0;if((e|0)==(l|0))break;else h=h+m|0}h=j+((da(m,l)|0)+32)|0;n=a[j>>0]|0;o=h}h=n<<24>>24==3?128:96;if(!(k<<24>>24))s=o;else{e=k&255;r=o;p=0;while(1){g[r+44>>2]=ea(0.0);p=p+1|0;if((p|0)==(e|0))break;else r=r+h|0}s=o+(da(h,e)|0)|0}if(s>>>0<d>>>0)j=s;else break}i=f;return}function lxa(e,f,h,j){e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0;k=i;i=i+32|0;l=k+16|0;m=k;n=c[e+16>>2]|0;o=b[e+26>>1]|0;p=n+((o&65535)<<4)|0;q=c[e+20>>2]|0;r=c[e+52>>2]|0;s=c[e+84>>2]|0;t=c[e+116>>2]|0;u=(a[n>>0]|0)==7;v=u?272:176;w=u?336:240;c[l>>2]=0;if(!(o<<16>>16)){x=ea(0.0);y=ea(0.0);z=ea(0.0);A=ea(0.0)}else{o=l+1|0;u=l+2|0;B=l+3|0;C=ea(0.0);D=ea(0.0);E=ea(0.0);F=ea(0.0);G=n;n=q;q=r;r=s;s=t;while(1){t=a[G+1>>0]|0;H=t&255;I=a[G+2>>0]|0;J=I&255;K=(da(H,v)|0)+144|0;L=G+K|0;M=G;G=G+(K+(da(J,w)|0))|0;a[l>>0]=a[M+4>>0]&1;a[o>>0]=a[M+5>>0]&1;a[u>>0]=a[M+6>>0]&1;a[B>>0]=a[M+7>>0]&1;if(!(t<<24>>24)){N=F;O=E;P=D;Q=C;R=n;S=q;T=r;U=s}else{t=M+11|0;K=M+10|0;V=M+9|0;W=M+8|0;X=C;Y=D;Z=E;_=F;$=M+144|0;M=0;aa=n;ba=q;ca=r;fa=s;while(1){ga=ea(g[$+112>>2]);ha=ea(g[$+116>>2]);ia=ea(g[$+120>>2]);ja=ea(g[$+124>>2]);$=$+v|0;ka=ea(X+ga);la=ea(Y+ha);ma=ea(Z+ia);na=ea(_+ja);if(aa)if(M>>>0<(d[W>>0]|0)>>>0){g[aa>>2]=ga;oa=aa+4|0}else oa=aa;else oa=0;if(ba)if(M>>>0<(d[V>>0]|0)>>>0){g[ba>>2]=ha;pa=ba+4|0}else pa=ba;else pa=0;if(ca)if(M>>>0<(d[K>>0]|0)>>>0){g[ca>>2]=ia;qa=ca+4|0}else qa=ca;else qa=0;if(fa)if(M>>>0<(d[t>>0]|0)>>>0){g[fa>>2]=ja;ra=fa+4|0}else ra=fa;else ra=0;M=M+1|0;if((M|0)==(H|0)){N=na;O=ma;P=la;Q=ka;R=oa;S=pa;T=qa;U=ra;break}else{X=ka;Y=la;Z=ma;_=na;aa=oa;ba=pa;ca=qa;fa=ra}}}if(I<<24>>24){fa=L;ca=0;while(1){_=ea(g[fa+180>>2]);Z=ea(g[fa+184>>2]);ba=_==ea(0.0);aa=Z==ea(0.0);H=ea(g[fa+188>>2])==ea(0.0);M=c[fa+224>>2]|0;if((M|0)!=0?!(ea(g[fa+176>>2])==ea(0.0)):0)a[M>>0]=1;M=c[fa+228>>2]|0;if(!((M|0)==0|ba))a[M>>0]=1;M=c[fa+232>>2]|0;if(!((M|0)==0|aa))a[M>>0]=1;M=c[fa+236>>2]|0;if(!((M|0)==0|H))a[M>>0]=1;ca=ca+1|0;if((ca|0)==(J|0))break;else fa=fa+w|0}}if(G>>>0>=p>>>0){x=N;y=O;z=P;A=Q;break}else{C=Q;D=P;E=O;F=N;n=R;q=S;r=T;s=U}}}g[m>>2]=A;g[m+4>>2]=z;g[m+8>>2]=y;g[m+12>>2]=x;U=f+8|0;s=f+4|0;f=0;do{if(((((a[l+f>>0]|0)!=0?(b[e+(f<<5)+8>>1]|0)==-1:0)?(b[e+(f<<5)+12>>1]|0)==-1:0)?(T=c[m+(f<<2)>>2]|0,r=T|0,(T|0)!=0):0)?(T=c[h+(f<<2)>>2]|0,x=ea(g[T+36>>2]),S=x<ea(3402823469999999843913219.0e14),q=c[j+(f<<2)>>2]|0,y=ea(g[q+36>>2]),S|y<ea(3402823469999999843913219.0e14)):0){S=c[T+40>>2]|0;T=c[q+40>>2]|0;q=T>>>0<S>>>0;R=c[U>>2]|0;c[U>>2]=R+1;n=c[s>>2]|0;c[n+(R<<4)>>2]=q?T:S;c[n+(R<<4)+4>>2]=q?S:T;c[n+(R<<4)+8>>2]=r;g[n+(R<<4)+12>>2]=x<y?x:y}f=f+1|0}while((f|0)!=4);i=k;return}function mxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im;f=i;i=i+32|0;e=f+16|0;d=f;h=c[b+20>>2]|0;j=c[b+52>>2]|0;k=c[b+84>>2]|0;l=c[b+116>>2]|0;m=(h|0)!=0;n=(j|0)==0;o=(k|0)==0;p=(l|0)==0;if(n&(m^1)&o&p){i=f;return}q=c[b+16>>2]|0;b=(a[q>>0]|0)==9?416:272;r=q+4|0;if(!(c[r>>2]|0)){s=ea(0.0);t=ea(0.0);u=ea(0.0);v=ea(0.0);w=ea(0.0);x=ea(0.0);y=ea(0.0);z=ea(0.0);A=ea(0.0);B=ea(0.0);C=ea(0.0);D=ea(0.0);E=ea(0.0);F=ea(0.0);G=ea(0.0);H=ea(0.0);I=ea(0.0);J=ea(0.0);K=ea(0.0);L=ea(0.0);M=ea(0.0);N=ea(0.0);O=ea(0.0);P=ea(0.0)}else{Q=ea(0.0);R=ea(0.0);S=ea(0.0);U=ea(0.0);V=ea(0.0);W=ea(0.0);X=ea(0.0);Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0);ha=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=q+128|0;pa=0;while(1){qa=c[oa+256>>2]|0;ra=c[oa+260>>2]|0;sa=c[oa+264>>2]|0;ta=c[oa+268>>2]|0;aFi(d|0,oa+240|0,16)|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;ua=ea(g[((qa&2|0)==0?e:d)>>2]);va=ea(g[((ra&2|0)==0?e:d)+4>>2]);wa=ea(g[((sa&2|0)==0?e:d)+8>>2]);xa=ea(g[((ta&2|0)==0?e:d)+12>>2]);ya=ea(g[oa>>2]);za=ea(g[oa+4>>2]);Aa=ea(g[oa+8>>2]);Ba=ea(ca+ea(ua*ya));ya=ea(da+ea(va*za));za=ea(fa+ea(wa*Aa));Aa=ea(ga+ea(xa*ea(g[oa+12>>2])));Ca=ea(g[oa+16>>2]);Da=ea(g[oa+20>>2]);Ea=ea(g[oa+24>>2]);Fa=ea(ha+ea(ua*Ca));Ca=ea(ia+ea(va*Da));Da=ea(ja+ea(wa*Ea));Ea=ea(ka+ea(xa*ea(g[oa+28>>2])));Ga=ea(g[oa+32>>2]);Ha=ea(g[oa+36>>2]);Ia=ea(g[oa+40>>2]);Ja=ea(la+ea(ua*Ga));Ga=ea(ma+ea(va*Ha));Ha=ea(na+ea(wa*Ia));Ia=ea(Q+ea(xa*ea(g[oa+44>>2])));Ka=ea(g[oa+48>>2]);La=ea(g[oa+52>>2]);Ma=ea(g[oa+56>>2]);Na=ea(R+ea(ua*Ka));Ka=ea(S+ea(va*La));La=ea(U+ea(wa*Ma));Ma=ea(V+ea(xa*ea(g[oa+60>>2])));Oa=ea(g[oa+64>>2]);Pa=ea(g[oa+68>>2]);Qa=ea(g[oa+72>>2]);Ra=ea(W+ea(ua*Oa));Oa=ea(X+ea(va*Pa));Pa=ea(Y+ea(wa*Qa));Qa=ea(Z+ea(xa*ea(g[oa+76>>2])));Sa=ea(g[oa+80>>2]);Ta=ea(g[oa+84>>2]);Ua=ea(g[oa+88>>2]);Va=ea(_+ea(ua*Sa));Sa=ea($+ea(va*Ta));Ta=ea(aa+ea(wa*Ua));Ua=ea(ba+ea(xa*ea(g[oa+92>>2])));pa=pa+1|0;if(pa>>>0>=(c[r>>2]|0)>>>0){s=Aa;t=za;u=ya;v=Ba;w=Ea;x=Da;y=Ca;z=Fa;A=Ia;B=Ha;C=Ga;D=Ja;E=Ma;F=La;G=Ka;H=Na;I=Qa;J=Pa;K=Oa;L=Ra;M=Ua;N=Ta;O=Sa;P=Va;break}else{Q=Ia;R=Na;S=Ka;U=La;V=Ma;W=Ra;X=Oa;Y=Pa;Z=Qa;_=Va;$=Sa;aa=Ta;ba=Ua;ca=Ba;da=ya;fa=za;ga=Aa;ha=Fa;ia=Ca;ja=Da;ka=Ea;la=Ja;ma=Ga;na=Ha;oa=oa+b|0}}}na=ea(g[q+112>>2]);ma=ea(g[q+116>>2]);la=ea(g[q+120>>2]);ka=ea(g[q+124>>2]);ja=ea(g[q+96>>2]);ia=ea(g[q+100>>2]);ha=ea(g[q+104>>2]);ga=ea(g[q+108>>2]);fa=ea(H-ea(ea(D*ja)-ea(z*na)));H=ea(G-ea(ea(C*ia)-ea(y*ma)));G=ea(F-ea(ea(B*ha)-ea(x*la)));F=ea(E-ea(ea(A*ga)-ea(w*ka)));E=ea(g[q+80>>2]);da=ea(g[q+84>>2]);ca=ea(g[q+88>>2]);ba=ea(g[q+92>>2]);aa=ea(L-ea(ea(v*na)-ea(D*E)));na=ea(K-ea(ea(u*ma)-ea(C*da)));ma=ea(J-ea(ea(t*la)-ea(B*ca)));la=ea(I-ea(ea(s*ka)-ea(A*ba)));ka=ea(P-ea(ea(z*E)-ea(v*ja)));ja=ea(O-ea(ea(y*da)-ea(u*ia)));ia=ea(N-ea(ea(x*ca)-ea(t*ha)));ha=ea(M-ea(ea(w*ba)-ea(s*ga)));ga=ea(T(ea(ea(ea(u*u)+ea(y*y))+ea(C*C))));ba=ea(T(ea(ea(ea(t*t)+ea(x*x))+ea(B*B))));M=ea(T(ea(ea(ea(s*s)+ea(w*w))+ea(A*A))));ca=ea(T(ea(ea(ja*ja)+ea(ea(H*H)+ea(na*na)))));N=ea(T(ea(ea(ia*ia)+ea(ea(G*G)+ea(ma*ma)))));da=ea(T(ea(ea(ha*ha)+ea(ea(F*F)+ea(la*la)))));O=ea(g[q+20>>2]);E=ea(g[q+24>>2]);P=ea(g[q+28>>2]);I=ea(g[q+36>>2]);J=ea(g[q+40>>2]);b=M>P?1:da>ea(g[q+44>>2]);if(m){da=ea(ea(ka*ka)+ea(ea(fa*fa)+ea(aa*aa)));P=ea(D*D);M=ea(ea(v*v)+ea(z*z));K=ea(g[q+32>>2]);L=ea(T(ea(da)));da=ea(T(ea(M+P)));m=L>K?1:da>ea(g[q+16>>2]);g[h>>2]=v;g[h+4>>2]=z;g[h+8>>2]=D;g[h+16>>2]=fa;g[h+20>>2]=aa;g[h+24>>2]=ka;c[h+12>>2]=m&1}if(!n){g[j>>2]=u;g[j+4>>2]=y;g[j+8>>2]=C;g[j+16>>2]=H;g[j+20>>2]=na;g[j+24>>2]=ja;c[j+12>>2]=(ca>I|ga>O)&1}if(!o){g[k>>2]=t;g[k+4>>2]=x;g[k+8>>2]=B;g[k+16>>2]=G;g[k+20>>2]=ma;g[k+24>>2]=ia;c[k+12>>2]=(N>J|ba>E)&1}if(p){i=f;return}g[l>>2]=s;g[l+4>>2]=w;g[l+8>>2]=A;g[l+16>>2]=F;g[l+20>>2]=la;g[l+24>>2]=ha;c[l+12>>2]=b&1;i=f;return}function nxa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;h1a(a,c);i=b;return}function oxa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;i1a(a,c);i=b;return}function pxa(a,d,e){a=a|0;d=d|0;e=e|0;d=i;h1a(a,e);j1a(c[a+16>>2]|0,b[a+26>>1]|0,e,272,336);i=d;return}function qxa(a,d,e){a=a|0;d=d|0;e=e|0;d=i;i1a(a,e);j1a(c[a+16>>2]|0,b[a+26>>1]|0,e,176,240);i=d;return}function rxa(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;g=i;i=i+32|0;b=g+16|0;j=g;h1a(a,d);k=c[d+16>>2]|0;c[b>>2]=k+((e[a+10>>1]|0)<<6);c[b+4>>2]=k+((e[a+42>>1]|0)<<6);c[b+8>>2]=k+((e[a+74>>1]|0)<<6);c[b+12>>2]=k+((e[a+106>>1]|0)<<6);c[j>>2]=k+((e[a+14>>1]|0)<<6);c[j+4>>2]=k+((e[a+46>>1]|0)<<6);c[j+8>>2]=k+((e[a+78>>1]|0)<<6);c[j+12>>2]=k+((e[a+110>>1]|0)<<6);lxa(a,d,b,j);j=d+8|0;b=c[j>>2]|0;if(b>>>0<=((c[d+12>>2]|0)+-4|0)>>>0){i=g;return}a=hTa(h,b)|0;b=c[j>>2]|0;h=a-b|0;if(b){b=d+4|0;d=0;do{a=f+(h+d<<4)|0;k=(c[b>>2]|0)+(d<<4)|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];d=d+1|0}while(d>>>0<(c[j>>2]|0)>>>0)}c[j>>2]=0;i=g;return}function sxa(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;g=i;i=i+32|0;b=g+16|0;j=g;i1a(a,d);k=c[d+16>>2]|0;c[b>>2]=k+((e[a+10>>1]|0)<<6);c[b+4>>2]=k+((e[a+42>>1]|0)<<6);c[b+8>>2]=k+((e[a+74>>1]|0)<<6);c[b+12>>2]=k+((e[a+106>>1]|0)<<6);c[j>>2]=k+((e[a+14>>1]|0)<<6);c[j+4>>2]=k+((e[a+46>>1]|0)<<6);c[j+8>>2]=k+((e[a+78>>1]|0)<<6);c[j+12>>2]=k+((e[a+110>>1]|0)<<6);lxa(a,d,b,j);j=d+8|0;b=c[j>>2]|0;if(b>>>0<=((c[d+12>>2]|0)+-4|0)>>>0){i=g;return}a=hTa(h,b)|0;b=c[j>>2]|0;h=a-b|0;if(b){b=d+4|0;d=0;do{a=f+(h+d<<4)|0;k=(c[b>>2]|0)+(d<<4)|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];d=d+1|0}while(d>>>0<(c[j>>2]|0)>>>0)}c[j>>2]=0;i=g;return}function txa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;k1a(a);i=c;return}function uxa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;k1a(b);d=c[b+16>>2]|0;b=(a[d>>0]|0)==9?416:272;f=d+4|0;if(!(c[f>>2]|0)){i=e;return}g=d+128|0;d=0;while(1){h=g+144|0;j=g+160|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];d=d+1|0;if(d>>>0>=(c[f>>2]|0)>>>0)break;else g=g+b|0}i=e;return}function vxa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=i;k1a(a);mxa(a,0,0,0);i=f;return}function wxa(e,f,h,j){e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0;k=i;i=i+32|0;l=k+16|0;m=k;n=c[e+16>>2]|0;o=c[e+20>>2]|0;p=c[e+52>>2]|0;q=c[e+84>>2]|0;r=c[e+116>>2]|0;s=b[n+2>>1]|0;t=n+(s&65535)|0;u=(a[n>>0]|0)==7?272:176;c[l>>2]=0;if(!(s<<16>>16)){v=ea(0.0);w=ea(0.0);x=ea(0.0);y=ea(0.0)}else{s=l+1|0;z=l+2|0;A=l+3|0;B=ea(0.0);C=ea(0.0);D=ea(0.0);E=ea(0.0);F=n;n=o;o=p;p=q;q=r;while(1){r=F+112|0;a[l>>0]=a[F+8>>0]&1;a[s>>0]=a[F+9>>0]&1;a[z>>0]=a[F+10>>0]&1;a[A>>0]=a[F+11>>0]&1;G=a[F+1>>0]|0;if(!(G<<24>>24)){H=E;I=D;J=C;K=B;L=r;M=n;N=o;O=p;P=q}else{Q=F+7|0;R=F+6|0;S=F+5|0;T=F+4|0;U=G&255;G=da(u,U)|0;V=B;W=C;X=D;Y=E;Z=r;r=0;_=n;$=o;aa=p;ba=q;while(1){ca=ea(g[Z+96>>2]);fa=ea(g[Z+100>>2]);ga=ea(g[Z+104>>2]);ha=ea(g[Z+108>>2]);Z=Z+u|0;if(_)if(r>>>0<(d[T>>0]|0)>>>0){g[_>>2]=ca;ia=_+4|0}else ia=_;else ia=0;if($)if(r>>>0<(d[S>>0]|0)>>>0){g[$>>2]=fa;ja=$+4|0}else ja=$;else ja=0;if(aa)if(r>>>0<(d[R>>0]|0)>>>0){g[aa>>2]=ga;ka=aa+4|0}else ka=aa;else ka=0;if(ba)if(r>>>0<(d[Q>>0]|0)>>>0){g[ba>>2]=ha;la=ba+4|0}else la=ba;else la=0;V=ea(V+ca);W=ea(W+fa);X=ea(X+ga);Y=ea(Y+ha);r=r+1|0;if((r|0)==(U|0))break;else{_=ia;$=ja;aa=ka;ba=la}}H=Y;I=X;J=W;K=V;L=F+(G+112)|0;M=ia;N=ja;O=ka;P=la}if(L>>>0<t>>>0){B=K;C=J;D=I;E=H;F=L;n=M;o=N;p=O;q=P}else{v=H;w=I;x=J;y=K;break}}}g[m>>2]=y;g[m+4>>2]=x;g[m+8>>2]=w;g[m+12>>2]=v;P=f+8|0;q=f+4|0;f=0;do{if(((((a[l+f>>0]|0)!=0?(b[e+(f<<5)+8>>1]|0)==-1:0)?(b[e+(f<<5)+12>>1]|0)==-1:0)?(O=c[m+(f<<2)>>2]|0,p=O|0,(O|0)!=0):0)?(O=c[h+(f<<2)>>2]|0,v=ea(g[O+36>>2]),N=v<ea(3402823469999999843913219.0e14),o=c[j+(f<<2)>>2]|0,w=ea(g[o+36>>2]),N|w<ea(3402823469999999843913219.0e14)):0){N=c[O+40>>2]|0;O=c[o+40>>2]|0;o=O>>>0<N>>>0;M=c[P>>2]|0;c[P>>2]=M+1;n=c[q>>2]|0;c[n+(M<<4)>>2]=o?O:N;c[n+(M<<4)+4>>2]=o?N:O;c[n+(M<<4)+8>>2]=p;g[n+(M<<4)+12>>2]=v<w?v:w}f=f+1|0}while((f|0)!=4);i=k;return}function xxa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;l1a(a);i=c;return}function yxa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;m1a(a);i=c;return}function zxa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im;f=i;l1a(d);e=c[d+16>>2]|0;d=b[e+2>>1]|0;h=e+(d&65535)|0;j=(a[e>>0]|0)==7?272:176;if(!(d<<16>>16)){i=f;return}else k=e;while(1){e=k+112|0;d=a[k+1>>0]|0;if(!(d<<24>>24))l=e;else{m=d&255;d=e;e=0;while(1){n=d+144|0;o=ea(g[n>>2]);p=d+148|0;q=ea(g[p>>2]);r=d+152|0;s=ea(g[r>>2]);t=d+156|0;u=ea(g[t>>2]);v=o>ea(0.0);w=v?o:ea(0.0);v=q>ea(0.0);o=v?q:ea(0.0);v=s>ea(0.0);q=v?s:ea(0.0);v=u>ea(0.0);s=v?u:ea(0.0);g[n>>2]=w;g[p>>2]=o;g[r>>2]=q;g[t>>2]=s;e=e+1|0;if((e|0)==(m|0))break;else d=d+j|0}l=k+((da(m,j)|0)+112)|0}if(l>>>0<h>>>0)k=l;else break}i=f;return}function Axa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im;f=i;m1a(d);e=c[d+16>>2]|0;d=b[e+2>>1]|0;h=e+(d&65535)|0;j=(a[e>>0]|0)==7?272:176;if(!(d<<16>>16)){i=f;return}else k=e;while(1){e=k+112|0;d=a[k+1>>0]|0;if(!(d<<24>>24))l=e;else{m=d&255;d=e;e=0;while(1){n=d+144|0;o=ea(g[n>>2]);p=d+148|0;q=ea(g[p>>2]);r=d+152|0;s=ea(g[r>>2]);t=d+156|0;u=ea(g[t>>2]);v=o>ea(0.0);w=v?o:ea(0.0);v=q>ea(0.0);o=v?q:ea(0.0);v=s>ea(0.0);q=v?s:ea(0.0);v=u>ea(0.0);s=v?u:ea(0.0);g[n>>2]=w;g[p>>2]=o;g[r>>2]=q;g[t>>2]=s;e=e+1|0;if((e|0)==(m|0))break;else d=d+j|0}l=k+((da(m,j)|0)+112)|0}if(l>>>0<h>>>0)k=l;else break}i=f;return}function Bxa(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;g=i;i=i+32|0;b=g+16|0;j=g;l1a(a);k=c[d+16>>2]|0;c[b>>2]=k+((e[a+10>>1]|0)<<6);c[b+4>>2]=k+((e[a+42>>1]|0)<<6);c[b+8>>2]=k+((e[a+74>>1]|0)<<6);c[b+12>>2]=k+((e[a+106>>1]|0)<<6);c[j>>2]=k+((e[a+14>>1]|0)<<6);c[j+4>>2]=k+((e[a+46>>1]|0)<<6);c[j+8>>2]=k+((e[a+78>>1]|0)<<6);c[j+12>>2]=k+((e[a+110>>1]|0)<<6);wxa(a,d,b,j);j=d+8|0;b=c[j>>2]|0;if(b>>>0<=((c[d+12>>2]|0)+-4|0)>>>0){i=g;return}a=hTa(h,b)|0;b=c[j>>2]|0;h=a-b|0;if(b){b=d+4|0;d=0;do{a=f+(h+d<<4)|0;k=(c[b>>2]|0)+(d<<4)|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];d=d+1|0}while(d>>>0<(c[j>>2]|0)>>>0)}c[j>>2]=0;i=g;return}function Cxa(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;g=i;i=i+32|0;b=g+16|0;j=g;m1a(a);k=c[d+16>>2]|0;c[b>>2]=k+((e[a+10>>1]|0)<<6);c[b+4>>2]=k+((e[a+42>>1]|0)<<6);c[b+8>>2]=k+((e[a+74>>1]|0)<<6);c[b+12>>2]=k+((e[a+106>>1]|0)<<6);c[j>>2]=k+((e[a+14>>1]|0)<<6);c[j+4>>2]=k+((e[a+46>>1]|0)<<6);c[j+8>>2]=k+((e[a+78>>1]|0)<<6);c[j+12>>2]=k+((e[a+110>>1]|0)<<6);wxa(a,d,b,j);j=d+8|0;b=c[j>>2]|0;if(b>>>0<=((c[d+12>>2]|0)+-4|0)>>>0){i=g;return}a=hTa(h,b)|0;b=c[j>>2]|0;h=a-b|0;if(b){b=d+4|0;d=0;do{a=f+(h+d<<4)|0;k=(c[b>>2]|0)+(d<<4)|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];d=d+1|0}while(d>>>0<(c[j>>2]|0)>>>0)}c[j>>2]=0;i=g;return}function Dxa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;n1a(a);i=c;return}function Exa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;o1a(a);i=c;return}function Fxa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;n1a(a);i=c;return}function Gxa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;o1a(a);i=c;return}function Hxa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=i;n1a(a);i=f;return}function Ixa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=i;o1a(a);i=f;return}function Jxa(d,e){d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=Im,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=Im,za=Im,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im;e=i;f=c[d>>2]|0;h=c[d+4>>2]|0;j=ea(g[f>>2]);k=f+4|0;l=ea(g[k>>2]);m=f+8|0;n=ea(g[m>>2]);o=ea(g[h>>2]);p=h+4|0;q=ea(g[p>>2]);r=h+8|0;s=ea(g[r>>2]);t=f+16|0;u=ea(g[t>>2]);v=f+20|0;w=ea(g[v>>2]);x=f+24|0;y=ea(g[x>>2]);z=h+16|0;A=ea(g[z>>2]);B=h+20|0;C=ea(g[B>>2]);D=h+24|0;E=ea(g[D>>2]);F=c[d+16>>2]|0;d=b[F+2>>1]|0;G=F+(d&65535)|0;if(!(d<<16>>16)){H=n;I=l;J=j;K=s;L=q;M=o;N=y;O=w;P=u;Q=E;R=C;S=A;g[f>>2]=J;g[k>>2]=I;g[m>>2]=H;g[h>>2]=M;g[p>>2]=L;g[r>>2]=K;g[t>>2]=P;g[v>>2]=O;g[x>>2]=N;g[z>>2]=S;g[B>>2]=R;g[D>>2]=Q;i=e;return}else{T=A;U=C;V=E;W=u;X=w;Y=y;Z=d;_=q;$=o;aa=l;ba=j;ca=s;da=n;fa=F}while(1){F=fa+48|0;d=a[fa+1>>0]|0;ga=d&255;n=ea(g[fa+16>>2]);s=ea(g[fa+20>>2]);j=ea(g[fa+24>>2]);l=ea(g[fa+8>>2]);o=ea(g[fa+12>>2]);q=ea(n*l);y=ea(s*l);w=ea(j*l);u=ea(n*o);E=ea(s*o);C=ea(j*o);ha=ga*80|0;ia=fa+(ha+48)|0;ja=fa+((Z&65535)+32)|0;if(!(d<<24>>24)){ka=Y;la=X;ma=W;na=V;oa=U;pa=T;qa=ea(0.0)}else{A=X;ra=Y;sa=T;ta=U;ua=V;va=ea(ea(ea(ba*n)+ea(aa*s))+ea(da*j));wa=ea(ea(ea($*n)+ea(_*s))+ea(ca*j));j=ea(0.0);s=W;d=0;while(1){xa=d+1|0;n=ea(g[F+(d*80|0)>>2]);ya=ea(g[F+(d*80|0)+4>>2]);za=ea(g[F+(d*80|0)+8>>2]);Aa=F+(d*80|0)+12|0;Ba=ea(g[Aa>>2]);Ca=ea(g[F+(d*80|0)+16>>2]);Da=ea(g[F+(d*80|0)+20>>2]);Ea=ea(g[F+(d*80|0)+24>>2]);Fa=ea(g[F+(d*80|0)+28>>2]);Ga=ea(g[F+(d*80|0)+36>>2]);Ha=ea(g[F+(d*80|0)+32>>2]);Ia=ea(g[F+(d*80|0)+40>>2]);Ja=ea(ea(Fa*Ga)-Ha);Ha=ea(ea(va+ea(ea(ea(s*n)+ea(A*ya))+ea(ra*za)))-ea(wa+ea(ea(ea(sa*Ca)+ea(ta*Da))+ea(ua*Ea))));Ea=ea(g[F+(d*80|0)+48>>2]);Da=ea(g[F+(d*80|0)+52>>2]);Ca=ea(g[F+(d*80|0)+56>>2]);za=ea(g[F+(d*80|0)+64>>2]);ya=ea(g[F+(d*80|0)+68>>2]);n=ea(g[F+(d*80|0)+72>>2]);Ga=ea(Ja-ea(Fa*Ha));Ha=ea(-Ba);Fa=ea(Ba+(Ga>Ha?Ga:Ha));Ha=Fa>Ia?Ia:Fa;Fa=ea(Ha-Ba);Ba=ea(s+ea(Ea*Fa));Ea=ea(A+ea(Da*Fa));Da=ea(ra+ea(Ca*Fa));Ca=ea(sa+ea(za*Fa));za=ea(ta+ea(ya*Fa));ya=ea(ua+ea(n*Fa));va=ea(va+ea(l*Fa));wa=ea(wa+ea(o*Fa));n=ea(j+Fa);g[Aa>>2]=Ha;g[ja+(d<<2)>>2]=Ha;if((xa|0)==(ga|0)){ka=Da;la=Ea;ma=Ba;na=ya;oa=za;pa=Ca;qa=n;break}else{A=Ea;ra=Da;sa=Ca;ta=za;ua=ya;j=n;s=Ba;d=xa}}}s=ea(ba+ea(q*qa));j=ea(aa+ea(y*qa));ua=ea(da+ea(w*qa));ta=ea($+ea(u*qa));sa=ea(_+ea(E*qa));ra=ea(ca+ea(C*qa));if(ia>>>0>=G>>>0){H=ua;I=j;J=s;K=ra;L=sa;M=ta;N=ka;O=la;P=ma;Q=na;R=oa;S=pa;break}T=pa;U=oa;V=na;W=ma;X=la;Y=ka;Z=b[fa+(ha+50)>>1]|0;_=sa;$=ta;aa=j;ba=s;ca=ra;da=ua;fa=ia}g[f>>2]=J;g[k>>2]=I;g[m>>2]=H;g[h>>2]=M;g[p>>2]=L;g[r>>2]=K;g[t>>2]=P;g[v>>2]=O;g[x>>2]=N;g[z>>2]=S;g[B>>2]=R;g[D>>2]=Q;i=e;return}function Kxa(e,f){e=e|0;f=f|0;var h=0,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im;f=i;h=c[e>>2]|0;j=c[e+4>>2]|0;k=ea(g[h>>2]);l=h+4|0;m=ea(g[l>>2]);n=h+8|0;o=ea(g[n>>2]);p=ea(g[j>>2]);q=j+4|0;r=ea(g[q>>2]);s=j+8|0;t=ea(g[s>>2]);u=h+16|0;v=ea(g[u>>2]);w=h+20|0;x=ea(g[w>>2]);y=h+24|0;z=ea(g[y>>2]);A=j+16|0;B=ea(g[A>>2]);C=j+20|0;D=ea(g[C>>2]);E=j+24|0;F=ea(g[E>>2]);G=c[e+16>>2]|0;H=b[e+26>>1]|0;e=G+((H&65535)<<4)|0;if(!(H<<16>>16)){I=o;J=m;K=k;L=t;M=r;N=p;O=z;P=x;Q=v;R=F;S=D;T=B;g[h>>2]=K;g[l>>2]=J;g[n>>2]=I;g[j>>2]=N;g[q>>2]=M;g[s>>2]=L;g[u>>2]=Q;g[w>>2]=P;g[y>>2]=O;g[A>>2]=T;g[C>>2]=S;g[E>>2]=R;i=f;return}else{U=B;V=D;W=F;X=v;Y=x;Z=z;_=p;$=r;aa=t;ba=k;ca=m;da=o;fa=G}while(1){G=fa+32|0;H=(((d[fa+1>>0]|0)<<2)+12&2032)+32|0;ga=fa+H|0;ha=a[fa+2>>0]|0;ia=ha&255;o=ea(g[fa+4>>2]);fa=fa+(H+(ia*96|0))|0;if(!(ha<<24>>24)){ja=da;ka=ca;la=ba;ma=aa;na=$;oa=_;pa=Z;qa=Y;ra=X;sa=W;ta=V;ua=U}else{m=$;k=aa;t=U;r=V;p=W;z=ba;x=ca;v=da;F=X;D=Y;B=Z;va=_;ha=0;while(1){H=ha;ha=ha+1|0;wa=ea(g[ga+(H*96|0)>>2]);xa=ea(g[ga+(H*96|0)+4>>2]);ya=ea(g[ga+(H*96|0)+8>>2]);za=ga+(H*96|0)+12|0;Aa=ea(g[ga+(H*96|0)+16>>2]);Ba=ea(g[ga+(H*96|0)+20>>2]);Ca=ea(g[ga+(H*96|0)+24>>2]);Da=ea(g[ga+(H*96|0)+32>>2]);Ea=ea(g[ga+(H*96|0)+36>>2]);Fa=ea(g[ga+(H*96|0)+40>>2]);Ga=ea(g[za>>2]);Ha=ea(g[ga+(H*96|0)+28>>2]);Ia=ea(g[ga+(H*96|0)+44>>2]);Ja=ea(o*ea(g[G+(c[ga+(H*96|0)+80>>2]<<2)>>2]));Ka=ea(-Ja);La=ea(ea(ea(ea(ea(z*wa)+ea(x*xa))+ea(v*ya))+ea(ea(ea(F*Aa)+ea(D*Ba))+ea(B*Ca)))-ea(ea(ea(ea(va*wa)+ea(m*xa))+ea(k*ya))+ea(ea(ea(t*Da)+ea(r*Ea))+ea(p*Fa))));Fa=ea(g[ga+(H*96|0)+48>>2]);Ea=ea(g[ga+(H*96|0)+52>>2]);Da=ea(g[ga+(H*96|0)+56>>2]);Ca=ea(g[ga+(H*96|0)+64>>2]);Ba=ea(g[ga+(H*96|0)+68>>2]);Aa=ea(g[ga+(H*96|0)+72>>2]);Ma=ea(g[ga+(H*96|0)+60>>2]);Na=ea(wa*Ma);Oa=ea(xa*Ma);Pa=ea(ya*Ma);Ma=ea(g[ga+(H*96|0)+76>>2]);Qa=ea(wa*Ma);wa=ea(xa*Ma);xa=ea(ya*Ma);Ma=ea(ea(Ha*La)+ea(Ga-ea(Ha*Ia)));Ia=Ma>Ja?Ja:Ma;Ma=Ia>Ka?Ia:Ka;Ka=ea(Ma-Ga);Ga=ea(z+ea(Ka*Na));Na=ea(x+ea(Ka*Oa));Oa=ea(v+ea(Ka*Pa));Pa=ea(va+ea(Ka*Qa));Qa=ea(m+ea(Ka*wa));wa=ea(k+ea(Ka*xa));xa=ea(F+ea(Fa*Ka));Fa=ea(D+ea(Ea*Ka));Ea=ea(B+ea(Da*Ka));Da=ea(t+ea(Ca*Ka));Ca=ea(r+ea(Ba*Ka));Ba=ea(p+ea(Aa*Ka));g[za>>2]=Ma;if((ha|0)==(ia|0)){ja=Oa;ka=Na;la=Ga;ma=wa;na=Qa;oa=Pa;pa=Ea;qa=Fa;ra=xa;sa=Ba;ta=Ca;ua=Da;break}else{m=Qa;k=wa;t=Da;r=Ca;p=Ba;z=Ga;x=Na;v=Oa;F=xa;D=Fa;B=Ea;va=Pa}}}if(fa>>>0>=e>>>0){I=ja;J=ka;K=la;L=ma;M=na;N=oa;O=pa;P=qa;Q=ra;R=sa;S=ta;T=ua;break}else{U=ua;V=ta;W=sa;X=ra;Y=qa;Z=pa;_=oa;$=na;aa=ma;ba=la;ca=ka;da=ja}}g[h>>2]=K;g[l>>2]=J;g[n>>2]=I;g[j>>2]=N;g[q>>2]=M;g[s>>2]=L;g[u>>2]=Q;g[w>>2]=P;g[y>>2]=O;g[A>>2]=T;g[C>>2]=S;g[E>>2]=R;i=f;return}function Lxa(d,e){d=d|0;e=e|0;var f=0,h=Im,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im;e=i;f=c[d>>2]|0;h=ea(g[f>>2]);j=f+4|0;k=ea(g[j>>2]);l=f+8|0;m=ea(g[l>>2]);n=f+16|0;o=ea(g[n>>2]);p=f+20|0;q=ea(g[p>>2]);r=f+24|0;s=ea(g[r>>2]);t=c[d+16>>2]|0;d=b[t+2>>1]|0;u=t+(d&65535)|0;if(!(d<<16>>16)){v=m;w=k;x=h;y=s;z=q;A=o;g[f>>2]=x;g[j>>2]=w;g[l>>2]=v;g[n>>2]=A;g[p>>2]=z;g[r>>2]=y;i=e;return}else{B=o;C=q;D=s;E=d;F=k;G=h;H=m;I=t}while(1){t=I+48|0;d=a[I+1>>0]|0;J=d&255;K=J*80|0;L=I+(K+48)|0;M=I+((E&65535)+32)|0;m=ea(g[I+16>>2]);h=ea(g[I+20>>2]);k=ea(g[I+24>>2]);s=ea(g[I+8>>2]);q=ea(m*s);o=ea(h*s);N=ea(k*s);if(!(d<<24>>24)){O=D;P=C;Q=B;R=ea(0.0)}else{S=ea(0.0);T=B;U=C;V=D;W=ea(ea(ea(G*m)+ea(F*h))+ea(H*k));d=0;while(1){X=d+1|0;k=ea(g[t+(d*80|0)>>2]);h=ea(g[t+(d*80|0)+4>>2]);m=ea(g[t+(d*80|0)+8>>2]);Y=t+(d*80|0)+12|0;Z=ea(g[Y>>2]);_=ea(g[t+(d*80|0)+28>>2]);$=ea(g[t+(d*80|0)+48>>2]);aa=ea(g[t+(d*80|0)+52>>2]);ba=ea(g[t+(d*80|0)+56>>2]);ca=ea(g[t+(d*80|0)+36>>2]);da=ea(g[t+(d*80|0)+32>>2]);fa=ea(g[t+(d*80|0)+40>>2]);ga=ea(ea(ea(_*ca)-da)-ea(_*ea(W+ea(ea(ea(T*k)+ea(U*h))+ea(V*m)))));m=ea(-Z);h=ea(Z+(ga>m?ga:m));m=h>fa?fa:h;h=ea(m-Z);W=ea(W+ea(s*h));Z=ea(T+ea($*h));$=ea(U+ea(aa*h));aa=ea(V+ea(ba*h));ba=ea(S+h);g[Y>>2]=m;g[M+(d<<2)>>2]=m;if((X|0)==(J|0)){O=aa;P=$;Q=Z;R=ba;break}else{S=ba;T=Z;U=$;V=aa;d=X}}}V=ea(G+ea(q*R));U=ea(F+ea(o*R));T=ea(H+ea(N*R));if(L>>>0>=u>>>0){v=T;w=U;x=V;y=O;z=P;A=Q;break}B=Q;C=P;D=O;E=b[I+(K+50)>>1]|0;F=U;G=V;H=T;I=L}g[f>>2]=x;g[j>>2]=w;g[l>>2]=v;g[n>>2]=A;g[p>>2]=z;g[r>>2]=y;i=e;return}function Mxa(e,f){e=e|0;f=f|0;var h=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im;f=i;h=c[e>>2]|0;j=ea(g[h>>2]);k=h+4|0;l=ea(g[k>>2]);m=h+8|0;n=ea(g[m>>2]);o=h+16|0;p=ea(g[o>>2]);q=h+20|0;r=ea(g[q>>2]);s=h+24|0;t=ea(g[s>>2]);u=c[e+16>>2]|0;v=b[e+26>>1]|0;e=u+((v&65535)<<4)|0;if(!(v<<16>>16)){w=n;x=l;y=j;z=t;A=r;B=p;g[h>>2]=y;g[k>>2]=x;g[m>>2]=w;g[o>>2]=B;g[q>>2]=A;g[s>>2]=z;i=f;return}else{C=p;D=r;E=t;F=j;G=l;H=n;I=u}while(1){u=a[I+2>>0]|0;v=u&255;J=I+32|0;K=(((d[I+1>>0]|0)<<2)+12&2032)+32|0;L=I+K|0;n=ea(g[I+4>>2]);I=I+(K+(v*96|0))|0;if(!(u<<24>>24)){M=H;N=G;O=F;P=E;Q=D;R=C}else{l=F;j=G;t=H;r=C;p=D;S=E;u=0;while(1){K=u;u=u+1|0;T=ea(g[L+(K*96|0)>>2]);U=ea(g[L+(K*96|0)+4>>2]);V=ea(g[L+(K*96|0)+8>>2]);W=L+(K*96|0)+12|0;X=ea(g[L+(K*96|0)+16>>2]);Y=ea(g[L+(K*96|0)+20>>2]);Z=ea(g[L+(K*96|0)+24>>2]);_=ea(g[W>>2]);$=ea(g[L+(K*96|0)+28>>2]);aa=ea(g[L+(K*96|0)+44>>2]);ba=ea(n*ea(g[J+(c[L+(K*96|0)+80>>2]<<2)>>2]));ca=ea(-ba);da=ea(ea(ea(ea(l*T)+ea(j*U))+ea(t*V))+ea(ea(ea(r*X)+ea(p*Y))+ea(S*Z)));Z=ea(g[L+(K*96|0)+48>>2]);Y=ea(g[L+(K*96|0)+52>>2]);X=ea(g[L+(K*96|0)+56>>2]);fa=ea(g[L+(K*96|0)+60>>2]);ga=ea(T*fa);T=ea(U*fa);U=ea(V*fa);fa=ea(ea($*da)+ea(_-ea($*aa)));aa=fa>ba?ba:fa;fa=aa>ca?aa:ca;ca=ea(fa-_);_=ea(l+ea(ga*ca));ga=ea(j+ea(T*ca));T=ea(t+ea(U*ca));U=ea(r+ea(Z*ca));Z=ea(p+ea(Y*ca));Y=ea(S+ea(X*ca));g[W>>2]=fa;if((u|0)==(v|0)){M=T;N=ga;O=_;P=Y;Q=Z;R=U;break}else{l=_;j=ga;t=T;r=U;p=Z;S=Y}}}if(I>>>0>=e>>>0){w=M;x=N;y=O;z=P;A=Q;B=R;break}else{C=R;D=Q;E=P;F=O;G=N;H=M}}g[h>>2]=y;g[k>>2]=x;g[m>>2]=w;g[o>>2]=B;g[q>>2]=A;g[s>>2]=z;i=f;return}function Nxa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0;e=i;f=c[d+16>>2]|0;d=b[f+2>>1]|0;h=f+(d&65535)|0;if(!(d<<16>>16)){i=e;return}else j=f;while(1){f=j+48|0;d=a[j+1>>0]|0;k=(a[j>>0]|0)==3?112:80;if(!(d<<24>>24))l=f;else{m=d&255;d=da(k,m)|0;n=f;f=0;while(1){o=n+32|0;p=ea(g[o>>2]);q=p>ea(0.0);g[o>>2]=q?p:ea(0.0);g[n+44>>2]=ea(0.0);f=f+1|0;if((f|0)==(m|0))break;else n=n+k|0}l=j+(d+48)|0}if(l>>>0<h>>>0)j=l;else break}i=e;return}function Oxa(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;f=c[d+16>>2]|0;e=b[f+2>>1]|0;j=f+(e&65535)|0;k=(a[f>>0]|0)==3?112:80;if(!(e<<16>>16)){i=h;return}e=f;f=c[d+20>>2]|0;while(1){d=e+48|0;l=a[e+1>>0]|0;m=l&255;if(!f){n=e+((da(m,k)|0)+48)|0;if(n>>>0<j>>>0){e=n;f=0;continue}else{o=10;break}}if(!(l<<24>>24)){p=d;q=f}else{l=m>>>0>1?m:1;n=da(k,l)|0;r=d;d=0;s=f;while(1){g[s>>2]=ea(g[r+12>>2]);d=d+1|0;if(d>>>0>=m>>>0)break;else{r=r+k|0;s=s+4|0}}p=e+(n+48)|0;q=f+(l<<2)|0}if(p>>>0<j>>>0){e=p;f=q}else{o=10;break}}if((o|0)==10){i=h;return}}function Pxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{Kxa(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function Qxa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;if(!b){i=f;return}else g=0;do{Kxa(a+(g<<5)|0,0);g=g+1|0}while((g|0)!=(b|0));i=f;return}function Rxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{Mxa(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function Sxa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;if(!b){i=f;return}else g=0;do{Mxa(a+(g<<5)|0,0);g=g+1|0}while((g|0)!=(b|0));i=f;return}function Txa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{Jxa(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function Uxa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0;f=i;if(!e){i=f;return}else h=0;do{Jxa(d+(h<<5)|0,0);j=c[d+(h<<5)+16>>2]|0;k=b[j+2>>1]|0;l=j+(k&65535)|0;if(k<<16>>16){k=j;while(1){j=k+48|0;m=a[k+1>>0]|0;n=(a[k>>0]|0)==3?112:80;if(!(m<<24>>24))o=j;else{p=m&255;m=j;j=0;while(1){q=m+32|0;r=ea(g[q>>2]);s=r>ea(0.0);g[q>>2]=s?r:ea(0.0);g[m+44>>2]=ea(0.0);j=j+1|0;if((j|0)==(p|0))break;else m=m+n|0}o=k+((da(n,p)|0)+48)|0}if(o>>>0<l>>>0)k=o;else break}}h=h+1|0}while((h|0)!=(e|0));i=f;return}function Vxa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;if(e){l=0;do{Jxa(d+(l<<5)|0,0);m=c[d+(l<<5)+16>>2]|0;n=b[m+2>>1]|0;o=m+(n&65535)|0;p=(a[m>>0]|0)==3?112:80;if(n<<16>>16){n=m;m=c[d+(l<<5)+20>>2]|0;while(1){q=n+48|0;r=a[n+1>>0]|0;s=r&255;if(!m){t=n+((da(s,p)|0)+48)|0;if(t>>>0<o>>>0){n=t;m=0;continue}else break}if(!(r<<24>>24)){u=q;v=m}else{r=s>>>0>1?s:1;t=q;q=0;w=m;while(1){g[w>>2]=ea(g[t+12>>2]);q=q+1|0;if((q|0)==(s|0))break;else{t=t+p|0;w=w+4|0}}u=n+((da(r,p)|0)+48)|0;v=m+(r<<2)|0}if(u>>>0<o>>>0){n=u;m=v}else break}}l=l+1|0}while((l|0)!=(e|0))}e=f+8|0;l=c[e>>2]|0;if(l>>>0<=((c[f+12>>2]|0)+-4|0)>>>0){i=j;return}v=hTa(k,l)|0;l=c[e>>2]|0;k=v-l|0;if(l){l=f+4|0;f=0;do{v=h+(k+f<<4)|0;u=(c[l>>2]|0)+(f<<4)|0;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];f=f+1|0}while(f>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;i=j;return}function Wxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{Lxa(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function Xxa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0;f=i;if(!e){i=f;return}else h=0;do{Lxa(d+(h<<5)|0,0);j=c[d+(h<<5)+16>>2]|0;k=b[j+2>>1]|0;l=j+(k&65535)|0;if(k<<16>>16){k=j;while(1){j=k+48|0;m=a[k+1>>0]|0;n=(a[k>>0]|0)==3?112:80;if(!(m<<24>>24))o=j;else{p=m&255;m=j;j=0;while(1){q=m+32|0;r=ea(g[q>>2]);s=r>ea(0.0);g[q>>2]=s?r:ea(0.0);g[m+44>>2]=ea(0.0);j=j+1|0;if((j|0)==(p|0))break;else m=m+n|0}o=k+((da(n,p)|0)+48)|0}if(o>>>0<l>>>0)k=o;else break}}h=h+1|0}while((h|0)!=(e|0));i=f;return}function Yxa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;if(e){l=0;do{Lxa(d+(l<<5)|0,0);m=c[d+(l<<5)+16>>2]|0;n=b[m+2>>1]|0;o=m+(n&65535)|0;p=(a[m>>0]|0)==3?112:80;if(n<<16>>16){n=m;m=c[d+(l<<5)+20>>2]|0;while(1){q=n+48|0;r=a[n+1>>0]|0;s=r&255;if(!m){t=n+((da(s,p)|0)+48)|0;if(t>>>0<o>>>0){n=t;m=0;continue}else break}if(!(r<<24>>24)){u=q;v=m}else{r=s>>>0>1?s:1;t=q;q=0;w=m;while(1){g[w>>2]=ea(g[t+12>>2]);q=q+1|0;if((q|0)==(s|0))break;else{t=t+p|0;w=w+4|0}}u=n+((da(r,p)|0)+48)|0;v=m+(r<<2)|0}if(u>>>0<o>>>0){n=u;m=v}else break}}l=l+1|0}while((l|0)!=(e|0))}e=f+8|0;l=c[e>>2]|0;if(l>>>0<=((c[f+12>>2]|0)+-4|0)>>>0){i=j;return}v=hTa(k,l)|0;l=c[e>>2]|0;k=v-l|0;if(l){l=f+4|0;f=0;do{v=h+(k+f<<4)|0;u=(c[l>>2]|0)+(f<<4)|0;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];f=f+1|0}while(f>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;i=j;return}function Zxa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0;e=i;Jxa(d,0);f=c[d+16>>2]|0;d=b[f+2>>1]|0;h=f+(d&65535)|0;if(!(d<<16>>16)){i=e;return}else j=f;while(1){f=j+48|0;d=a[j+1>>0]|0;k=(a[j>>0]|0)==3?112:80;if(!(d<<24>>24))l=f;else{m=d&255;d=f;f=0;while(1){n=d+32|0;o=ea(g[n>>2]);p=o>ea(0.0);g[n>>2]=p?o:ea(0.0);g[d+44>>2]=ea(0.0);f=f+1|0;if((f|0)==(m|0))break;else d=d+k|0}l=j+((da(k,m)|0)+48)|0}if(l>>>0<h>>>0)j=l;else break}i=e;return}function _xa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0;e=i;Lxa(d,0);f=c[d+16>>2]|0;d=b[f+2>>1]|0;h=f+(d&65535)|0;if(!(d<<16>>16)){i=e;return}else j=f;while(1){f=j+48|0;d=a[j+1>>0]|0;k=(a[j>>0]|0)==3?112:80;if(!(d<<24>>24))l=f;else{m=d&255;d=f;f=0;while(1){n=d+32|0;o=ea(g[n>>2]);p=o>ea(0.0);g[n>>2]=p?o:ea(0.0);g[d+44>>2]=ea(0.0);f=f+1|0;if((f|0)==(m|0))break;else d=d+k|0}l=j+((da(k,m)|0)+48)|0}if(l>>>0<h>>>0)j=l;else break}i=e;return}function $xa(e,f){e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im;f=i;i=i+160|0;h=f+16|0;j=f+80|0;k=f+32|0;l=f+96|0;m=f+144|0;n=f;o=f+64|0;p=f+128|0;q=c[e+16>>2]|0;r=e+8|0;s=b[r>>1]|0;if(s<<16>>16==-1){t=c[e>>2]|0;u=ea(g[t>>2]);v=ea(g[t+4>>2]);w=ea(g[t+8>>2]);x=ea(g[t+16>>2]);y=ea(g[t+20>>2]);z=w;A=v;B=u;C=ea(g[t+24>>2]);D=y;E=x}else{Tza(k,c[e>>2]|0,s&65535);x=ea(g[k>>2]);y=ea(g[k+4>>2]);u=ea(g[k+8>>2]);v=ea(g[k+16>>2]);w=ea(g[k+20>>2]);z=u;A=y;B=x;C=ea(g[k+24>>2]);D=w;E=v}k=e+12|0;s=b[k>>1]|0;t=e+4|0;if(s<<16>>16==-1){F=c[t>>2]|0;v=ea(g[F>>2]);w=ea(g[F+4>>2]);x=ea(g[F+8>>2]);y=ea(g[F+16>>2]);u=ea(g[F+20>>2]);G=x;H=w;I=v;J=ea(g[F+24>>2]);K=u;L=y}else{Tza(l,c[t>>2]|0,s&65535);y=ea(g[l>>2]);u=ea(g[l+4>>2]);v=ea(g[l+8>>2]);w=ea(g[l+16>>2]);x=ea(g[l+20>>2]);G=v;H=u;I=y;J=ea(g[l+24>>2]);K=x;L=w}l=q+1|0;if(!(a[l>>0]|0)){M=z;N=A;O=B;P=C;Q=D;R=E;S=G;T=H;U=I;V=J;W=K;X=L;Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0);ha=ea(0.0);ia=ea(0.0)}else{w=E;E=D;D=C;C=B;B=A;A=z;z=L;L=K;K=J;J=I;I=H;H=G;G=ea(0.0);x=ea(0.0);y=ea(0.0);u=ea(0.0);v=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);s=q+48|0;F=0;while(1){qa=ea(g[s>>2]);ra=ea(g[s+4>>2]);sa=ea(g[s+8>>2]);ta=ea(g[s+12>>2]);ua=s+16|0;va=ea(g[ua>>2]);wa=ea(g[ua+4>>2]);xa=ea(g[ua+8>>2]);ua=s+32|0;ya=ea(g[ua>>2]);za=ea(g[ua+4>>2]);Aa=ea(g[ua+8>>2]);Ba=ea(g[ua+12>>2]);ua=s+48|0;Ca=ea(g[ua>>2]);Da=ea(g[ua+4>>2]);Ea=ea(g[ua+8>>2]);Fa=ea(g[ua+12>>2]);ua=s+96|0;Ga=ea(g[ua>>2]);Ha=ea(g[ua+4>>2]);Ia=ea(g[ua+8>>2]);Ja=ea(ea(Fa*Ia)+ea(ta+ea(Ba*ea(ea(ea(ea(ea(C*qa)+ea(w*ya))-ea(ea(J*va)+ea(z*Ca)))+ea(ea(ea(B*ra)+ea(E*za))-ea(ea(I*wa)+ea(L*Da))))+ea(ea(ea(A*sa)+ea(D*Aa))-ea(ea(H*xa)+ea(K*Ea)))))));Ba=Ga>Ja?Ga:Ja;Ja=Ha>Ba?Ba:Ha;Ha=ea(Ja-Ia);g[s+104>>2]=Ja;Ja=ea(G+ea(qa*Ha));qa=ea(x+ea(ra*Ha));ra=ea(y+ea(sa*Ha));sa=ea(u+ea(ya*Ha));ya=ea(v+ea(za*Ha));za=ea(ja+ea(Aa*Ha));Aa=ea(ka+ea(va*Ha));va=ea(la+ea(wa*Ha));wa=ea(ma+ea(xa*Ha));xa=ea(na+ea(Ca*Ha));Ca=ea(oa+ea(Da*Ha));Da=ea(pa+ea(Ea*Ha));Ea=ea(g[s+112>>2]);Ia=ea(g[s+116>>2]);Ba=ea(C+ea(Ea*Ha));Ea=ea(B+ea(Ia*Ha));Ia=ea(A+ea(ea(g[s+120>>2])*Ha));Ga=ea(g[s+128>>2]);ta=ea(g[s+132>>2]);Fa=ea(w+ea(Ga*Ha));Ga=ea(E+ea(ta*Ha));ta=ea(D+ea(ea(g[s+136>>2])*Ha));Ka=ea(g[s+144>>2]);La=ea(g[s+148>>2]);Ma=ea(J+ea(Ka*Ha));Ka=ea(I+ea(La*Ha));La=ea(H+ea(Ha*ea(g[s+152>>2])));Na=ea(g[s+160>>2]);Oa=ea(g[s+164>>2]);Pa=ea(z+ea(Ha*Na));Na=ea(L+ea(Ha*Oa));Oa=ea(K+ea(Ha*ea(g[s+168>>2])));F=F+1|0;if(F>>>0>=(d[l>>0]|0)>>>0){M=Ia;N=Ea;O=Ba;P=ta;Q=Ga;R=Fa;S=La;T=Ka;U=Ma;V=Oa;W=Na;X=Pa;Y=ra;Z=qa;_=Ja;$=wa;aa=va;ba=Aa;ca=za;da=ya;fa=sa;ga=Da;ha=Ca;ia=xa;break}else{w=Fa;E=Ga;D=ta;C=Ba;B=Ea;A=Ia;z=Pa;L=Na;K=Oa;J=Ma;I=Ka;H=La;G=Ja;x=qa;y=ra;u=sa;v=ya;ja=za;ka=Aa;la=va;ma=wa;na=xa;oa=Ca;pa=Da;s=s+176|0}}}s=b[r>>1]|0;if(s<<16>>16==-1){r=c[e>>2]|0;g[r>>2]=O;g[r+4>>2]=N;g[r+8>>2]=M;g[r+16>>2]=R;g[r+20>>2]=Q;g[r+24>>2]=P}else{r=c[e>>2]|0;P=ea(g[q+32>>2]);Q=ea(Z*P);Z=ea(Y*P);g[m>>2]=ea(_*P);g[m+4>>2]=Q;g[m+8>>2]=Z;g[m+12>>2]=ea(0.0);Z=ea(g[q+36>>2]);Q=ea(da*Z);da=ea(ca*Z);g[n>>2]=ea(fa*Z);g[n+4>>2]=Q;g[n+8>>2]=da;g[n+12>>2]=ea(0.0);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];Sza(r,s&65535,j,h)}s=b[k>>1]|0;if(s<<16>>16==-1){k=c[t>>2]|0;g[k>>2]=U;g[k+4>>2]=T;g[k+8>>2]=S;g[k+16>>2]=X;g[k+20>>2]=W;g[k+24>>2]=V;i=f;return}else{k=c[t>>2]|0;V=ea(g[q+40>>2]);W=ea(aa*V);aa=ea($*V);g[o>>2]=ea(ba*V);g[o+4>>2]=W;g[o+8>>2]=aa;g[o+12>>2]=ea(0.0);aa=ea(g[q+44>>2]);W=ea(ha*aa);ha=ea(ga*aa);g[p>>2]=ea(ia*aa);g[p+4>>2]=W;g[p+8>>2]=ha;g[p+12>>2]=ea(0.0);c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];Sza(k,s&65535,j,h);i=f;return}}function aya(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=0,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=0,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=0,rc=Im,sc=Im,tc=Im,uc=Im;f=i;i=i+160|0;h=f+16|0;j=f+80|0;k=f+32|0;l=f+96|0;m=f+144|0;n=f;o=f+64|0;p=f+128|0;q=d+8|0;r=b[q>>1]|0;if(r<<16>>16==-1){s=c[d>>2]|0;t=ea(g[s>>2]);u=ea(g[s+4>>2]);v=ea(g[s+8>>2]);w=ea(g[s+16>>2]);x=ea(g[s+20>>2]);y=v;z=u;A=t;B=ea(g[s+24>>2]);C=x;D=w}else{Tza(k,c[d>>2]|0,r&65535);w=ea(g[k>>2]);x=ea(g[k+4>>2]);t=ea(g[k+8>>2]);u=ea(g[k+16>>2]);v=ea(g[k+20>>2]);y=t;z=x;A=w;B=ea(g[k+24>>2]);C=v;D=u}k=d+12|0;r=b[k>>1]|0;s=d+4|0;if(r<<16>>16==-1){E=c[s>>2]|0;u=ea(g[E>>2]);v=ea(g[E+4>>2]);w=ea(g[E+8>>2]);x=ea(g[E+16>>2]);t=ea(g[E+20>>2]);F=w;G=v;H=u;I=ea(g[E+24>>2]);J=t;K=x}else{Tza(l,c[s>>2]|0,r&65535);x=ea(g[l>>2]);t=ea(g[l+4>>2]);u=ea(g[l+8>>2]);v=ea(g[l+16>>2]);w=ea(g[l+20>>2]);F=u;G=t;H=x;I=ea(g[l+24>>2]);J=w;K=v}l=c[d+16>>2]|0;r=b[d+26>>1]|0;E=l+((r&65535)<<4)|0;if(!(r<<16>>16)){L=y;M=z;N=A;O=B;P=C;Q=D;R=F;S=G;T=H;U=I;V=J;W=K;X=ea(0.0);Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0);ha=ea(0.0)}else{v=ea(0.0);w=ea(0.0);x=ea(0.0);t=ea(0.0);u=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=K;K=J;J=I;I=H;H=G;G=F;F=D;D=C;C=B;B=A;A=z;z=y;r=l;while(1){l=r+32|0;qa=a[r+5>>0]|0;ra=qa&255;sa=a[r+6>>0]|0;ta=sa&255;ua=ra<<7|32;va=r+ua|0;if(!(qa<<24>>24)){wa=z;xa=A;ya=B;za=C;Aa=D;Ba=F;Ca=G;Da=H;Ea=I;Fa=J;Ga=K;Ha=pa;Ia=ea(0.0);Ja=ea(0.0);Ka=ea(0.0);La=ea(0.0);Ma=ea(0.0);Na=ea(0.0);Oa=ea(0.0);Pa=ea(0.0);Qa=ea(0.0);Ra=ea(0.0);Sa=ea(0.0);Ta=ea(0.0);Ua=ea(0.0)}else{y=F;Va=D;Wa=C;Xa=B;Ya=A;Za=z;_a=pa;$a=K;ab=J;bb=I;cb=H;db=G;eb=ea(0.0);fb=ea(0.0);gb=ea(0.0);hb=ea(0.0);ib=ea(0.0);jb=ea(0.0);kb=ea(0.0);lb=ea(0.0);mb=ea(0.0);nb=ea(0.0);ob=ea(0.0);pb=ea(0.0);qb=ea(0.0);qa=0;while(1){rb=qa;qa=qa+1|0;sb=ea(g[l+(rb<<7)>>2]);tb=ea(g[l+(rb<<7)+4>>2]);ub=ea(g[l+(rb<<7)+8>>2]);vb=ea(g[l+(rb<<7)+12>>2]);wb=ea(g[l+(rb<<7)+16>>2]);xb=ea(g[l+(rb<<7)+20>>2]);yb=ea(g[l+(rb<<7)+24>>2]);zb=l+(rb<<7)+28|0;Ab=ea(g[zb>>2]);Bb=ea(g[l+(rb<<7)+32>>2]);Cb=ea(g[l+(rb<<7)+36>>2]);Db=ea(g[l+(rb<<7)+40>>2]);Eb=ea(g[l+(rb<<7)+52>>2]);Fb=ea(ea(ea(vb*Eb)-ea(g[l+(rb<<7)+48>>2]))-ea(vb*ea(ea(ea(ea(ea(Xa*sb)+ea(y*wb))-ea(ea(bb*sb)+ea(_a*Bb)))+ea(ea(ea(Ya*tb)+ea(Va*xb))-ea(ea(cb*tb)+ea($a*Cb))))+ea(ea(ea(Za*ub)+ea(Wa*yb))-ea(ea(db*ub)+ea(ab*Db))))));vb=ea(-Ab);Eb=Fb>vb?Fb:vb;vb=ea(g[l+(rb<<7)+96>>2]);Fb=ea(g[l+(rb<<7)+100>>2]);Gb=ea(Xa+ea(vb*Eb));vb=ea(Ya+ea(Fb*Eb));Fb=ea(Za+ea(ea(g[l+(rb<<7)+104>>2])*Eb));Hb=ea(g[l+(rb<<7)+64>>2]);Ib=ea(g[l+(rb<<7)+68>>2]);Jb=ea(y+ea(Hb*Eb));Hb=ea(Va+ea(Ib*Eb));Ib=ea(Wa+ea(ea(g[l+(rb<<7)+72>>2])*Eb));Kb=ea(g[l+(rb<<7)+112>>2]);Lb=ea(g[l+(rb<<7)+116>>2]);Mb=ea(bb+ea(Eb*Kb));Kb=ea(cb+ea(Eb*Lb));Lb=ea(db+ea(Eb*ea(g[l+(rb<<7)+120>>2])));Nb=ea(g[l+(rb<<7)+80>>2]);Ob=ea(g[l+(rb<<7)+84>>2]);Pb=ea(_a+ea(Eb*Nb));Nb=ea($a+ea(Eb*Ob));Ob=ea(ab+ea(Eb*ea(g[l+(rb<<7)+88>>2])));Qb=ea(sb*Eb);sb=ea(tb*Eb);tb=ea(ub*Eb);ub=ea(eb+Qb);Rb=ea(fb+sb);Sb=ea(gb+tb);Tb=ea(hb+ea(wb*Eb));wb=ea(ib+ea(xb*Eb));xb=ea(jb+ea(yb*Eb));yb=ea(kb+Qb);Qb=ea(lb+sb);sb=ea(mb+tb);tb=ea(nb+ea(Bb*Eb));Bb=ea(ob+ea(Cb*Eb));Cb=ea(pb+ea(Db*Eb));g[zb>>2]=ea(Ab+Eb);Db=ea(ea(qb+Ab)+Eb);if((qa|0)==(ra|0)){wa=Fb;xa=vb;ya=Gb;za=Ib;Aa=Hb;Ba=Jb;Ca=Lb;Da=Kb;Ea=Mb;Fa=Ob;Ga=Nb;Ha=Pb;Ia=Db;Ja=Sb;Ka=Rb;La=ub;Ma=sb;Na=Qb;Oa=yb;Pa=xb;Qa=wb;Ra=Tb;Sa=Cb;Ta=Bb;Ua=tb;break}else{y=Jb;Va=Hb;Wa=Ib;Xa=Gb;Ya=vb;Za=Fb;_a=Pb;$a=Nb;ab=Ob;bb=Mb;cb=Kb;db=Lb;eb=ub;fb=Rb;gb=Sb;hb=Tb;ib=wb;jb=xb;kb=yb;lb=Qb;mb=sb;nb=tb;ob=Bb;pb=Cb;qb=Db}}}if((a[e>>0]|0)==0|sa<<24>>24==0){Ub=La;Vb=Ka;Wb=Ja;Xb=Ra;Yb=Qa;Zb=Pa;_b=Oa;$b=Na;ac=Ma;bc=Ua;cc=Ta;dc=Sa;ec=wa;fc=xa;gc=ya;hc=za;ic=Aa;jc=Ba;kc=Ca;lc=Da;mc=Ea;nc=Fa;oc=Ga;pc=Ha}else{qb=ea(Ia*ea(g[r+16>>2]));pb=ea(Ia*ea(g[r+20>>2]));ob=ea(-pb);nb=ea(-qb);mb=Ba;lb=Aa;kb=za;jb=ya;ib=xa;hb=wa;gb=Ha;fb=Ga;eb=Fa;db=Ea;cb=Da;bb=Ca;ab=La;$a=Ka;_a=Ja;Za=Ra;Ya=Qa;Xa=Pa;Wa=Oa;Va=Na;y=Ma;Db=Ua;Cb=Ta;Bb=Sa;ra=0;while(1){qa=ra;ra=ra+1|0;tb=ea(g[va+(qa<<7)>>2]);sb=ea(g[va+(qa<<7)+4>>2]);Qb=ea(g[va+(qa<<7)+8>>2]);l=va+(qa<<7)+12|0;yb=ea(g[l>>2]);xb=ea(g[va+(qa<<7)+16>>2]);wb=ea(g[va+(qa<<7)+20>>2]);Tb=ea(g[va+(qa<<7)+24>>2]);Sb=ea(g[va+(qa<<7)+28>>2]);Rb=ea(g[va+(qa<<7)+32>>2]);ub=ea(g[va+(qa<<7)+36>>2]);Lb=ea(g[va+(qa<<7)+40>>2]);Kb=ea(g[va+(qa<<7)+44>>2]);Mb=ea(ea(ea(ea(ea(jb*tb)+ea(mb*xb))-ea(ea(db*tb)+ea(gb*Rb)))+ea(ea(ea(ib*sb)+ea(lb*wb))-ea(ea(cb*sb)+ea(fb*ub))))+ea(ea(ea(hb*Qb)+ea(kb*Tb))-ea(ea(bb*Qb)+ea(eb*Lb))));Ob=ea(yb-ea(Sb*ea(Kb-ea(g[va+(qa<<7)+76>>2]))));zb=va+(qa<<7)+60|0;Kb=ea(g[zb>>2]);Nb=ea(Ob-ea(Sb*Mb));rb=!(Nb>qb);qc=!(Nb<nb);Mb=qc?(rb?Nb:pb>Nb?Nb:pb):Nb<ob?ob:Nb;Nb=rb?Kb:ea(1.0);Kb=qc?Nb:ea(1.0);Nb=ea(Mb-yb);yb=ea(g[va+(qa<<7)+96>>2]);Sb=ea(g[va+(qa<<7)+100>>2]);Ob=ea(jb+ea(yb*Nb));yb=ea(ib+ea(Sb*Nb));Sb=ea(hb+ea(ea(g[va+(qa<<7)+104>>2])*Nb));Pb=ea(g[va+(qa<<7)+48>>2]);Fb=ea(g[va+(qa<<7)+52>>2]);vb=ea(mb+ea(Pb*Nb));Pb=ea(lb+ea(Fb*Nb));Fb=ea(kb+ea(ea(g[va+(qa<<7)+56>>2])*Nb));Gb=ea(g[va+(qa<<7)+112>>2]);Ib=ea(g[va+(qa<<7)+116>>2]);Hb=ea(db+ea(Gb*Nb));Gb=ea(cb+ea(Ib*Nb));Ib=ea(bb+ea(Nb*ea(g[va+(qa<<7)+120>>2])));Jb=ea(g[va+(qa<<7)+64>>2]);Eb=ea(g[va+(qa<<7)+68>>2]);Ab=ea(gb+ea(Nb*Jb));Jb=ea(fb+ea(Nb*Eb));Eb=ea(eb+ea(Nb*ea(g[va+(qa<<7)+72>>2])));rc=ea(tb*Nb);tb=ea(sb*Nb);sb=ea(Qb*Nb);Qb=ea(ab+rc);sc=ea($a+tb);tc=ea(_a+sb);uc=ea(Za+ea(xb*Nb));xb=ea(Ya+ea(wb*Nb));wb=ea(Xa+ea(Tb*Nb));Tb=ea(Wa+rc);rc=ea(Va+tb);tb=ea(y+sb);sb=ea(Db+ea(Rb*Nb));Rb=ea(Cb+ea(ub*Nb));ub=ea(Bb+ea(Lb*Nb));g[l>>2]=Mb;g[zb>>2]=Kb;if((ra|0)==(ta|0)){Ub=Qb;Vb=sc;Wb=tc;Xb=uc;Yb=xb;Zb=wb;_b=Tb;$b=rc;ac=tb;bc=sb;cc=Rb;dc=ub;ec=Sb;fc=yb;gc=Ob;hc=Fb;ic=Pb;jc=vb;kc=Ib;lc=Gb;mc=Hb;nc=Eb;oc=Jb;pc=Ab;break}else{mb=vb;lb=Pb;kb=Fb;jb=Ob;ib=yb;hb=Sb;gb=Ab;fb=Jb;eb=Eb;db=Hb;cb=Gb;bb=Ib;ab=Qb;$a=sc;_a=tc;Za=uc;Ya=xb;Xa=wb;Wa=Tb;Va=rc;y=tb;Db=sb;Cb=Rb;Bb=ub}}}Bb=ea(g[r+24>>2]);Cb=ea(v+ea(Ub*Bb));Db=ea(w+ea(Vb*Bb));y=ea(x+ea(Wb*Bb));Bb=ea(g[r+8>>2]);Va=ea(t+ea(Xb*Bb));Wa=ea(u+ea(Yb*Bb));Xa=ea(ia+ea(Zb*Bb));Bb=ea(g[r+28>>2]);Ya=ea(ja-ea(_b*Bb));Za=ea(ka-ea($b*Bb));_a=ea(la-ea(ac*Bb));Bb=ea(g[r+12>>2]);r=r+(ua+(ta<<7))|0;$a=ea(ma-ea(bc*Bb));ab=ea(na-ea(cc*Bb));bb=ea(oa-ea(dc*Bb));if(r>>>0>=E>>>0){L=ec;M=fc;N=gc;O=hc;P=ic;Q=jc;R=kc;S=lc;T=mc;U=nc;V=oc;W=pc;X=y;Y=Db;Z=Cb;_=_a;$=Za;aa=Ya;ba=Xa;ca=Wa;da=Va;fa=bb;ga=ab;ha=$a;break}else{v=Cb;w=Db;x=y;t=Va;u=Wa;ia=Xa;ja=Ya;ka=Za;la=_a;ma=$a;na=ab;oa=bb;pa=pc;K=oc;J=nc;I=mc;H=lc;G=kc;F=jc;D=ic;C=hc;B=gc;A=fc;z=ec}}}E=b[q>>1]|0;if(E<<16>>16==-1){q=c[d>>2]|0;g[q>>2]=N;g[q+4>>2]=M;g[q+8>>2]=L;g[q+16>>2]=Q;g[q+20>>2]=P;g[q+24>>2]=O}else{q=c[d>>2]|0;g[m>>2]=Z;g[m+4>>2]=Y;g[m+8>>2]=X;g[m+12>>2]=ea(0.0);g[n>>2]=da;g[n+4>>2]=ca;g[n+8>>2]=ba;g[n+12>>2]=ea(0.0);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];Sza(q,E&65535,j,h)}E=b[k>>1]|0;if(E<<16>>16==-1){k=c[s>>2]|0;g[k>>2]=T;g[k+4>>2]=S;g[k+8>>2]=R;g[k+16>>2]=W;g[k+20>>2]=V;g[k+24>>2]=U;i=f;return}else{k=c[s>>2]|0;g[o>>2]=aa;g[o+4>>2]=$;g[o+8>>2]=_;g[o+12>>2]=ea(0.0);g[p>>2]=ha;g[p+4>>2]=ga;g[p+8>>2]=fa;g[p+12>>2]=ea(0.0);c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];Sza(k,E&65535,j,h);i=f;return}}function bya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if(!b){i=d;return}else e=0;do{aya(a+(e<<5)|0,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function cya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!b){i=d;return}else e=0;do{f=a+(e<<5)|0;aya(f,c);Wwa(f,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function dya(a,d,f,g,h,j){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;h=i;if(d){k=f+16|0;l=0;do{m=a+(l<<5)|0;if((b[a+(l<<5)+8>>1]|0)==-1)n=e[a+(l<<5)+10>>1]|0;else n=0;o=c[k>>2]|0;if((b[a+(l<<5)+12>>1]|0)==-1)p=e[a+(l<<5)+14>>1]|0;else p=0;aya(m,f);Xwa(m,f,o+(n<<6)|0,o+(p<<6)|0);l=l+1|0}while((l|0)!=(d|0))}d=f+8|0;l=c[d>>2]|0;if(!l){i=h;return}p=hTa(j,l)|0;l=c[d>>2]|0;j=p-l|0;if(l){l=f+4|0;f=0;do{p=g+(j+f<<4)|0;n=(c[l>>2]|0)+(f<<4)|0;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[p+12>>2]=c[n+12>>2];f=f+1|0}while(f>>>0<(c[d>>2]|0)>>>0)}c[d>>2]=0;i=h;return}function eya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{$xa(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function fya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!b){i=d;return}else e=0;do{f=a+(e<<5)|0;$xa(f,0);Twa(f,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function gya(a,d,f,g,h,j){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;j=i;if(!d){i=j;return}h=f+16|0;g=0;do{k=a+(g<<5)|0;if((b[a+(g<<5)+8>>1]|0)==-1)l=e[a+(g<<5)+10>>1]|0;else l=0;m=c[h>>2]|0;if((b[a+(g<<5)+12>>1]|0)==-1)n=e[a+(g<<5)+14>>1]|0;else n=0;$xa(k,0);Ywa(k,f,m+(l<<6)|0,m+(n<<6)|0);g=g+1|0}while((g|0)!=(d|0));i=j;return}function hya(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=0,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im;e=i;i=i+160|0;f=e+16|0;h=e+80|0;j=e+32|0;k=e+96|0;l=e+144|0;m=e;n=e+64|0;o=e+128|0;p=d+8|0;q=b[p>>1]|0;if(q<<16>>16==-1){r=c[d>>2]|0;s=ea(g[r>>2]);t=ea(g[r+4>>2]);u=ea(g[r+8>>2]);v=ea(g[r+16>>2]);w=ea(g[r+20>>2]);x=u;y=t;z=s;A=ea(g[r+24>>2]);B=w;C=v}else{Tza(j,c[d>>2]|0,q&65535);v=ea(g[j>>2]);w=ea(g[j+4>>2]);s=ea(g[j+8>>2]);t=ea(g[j+16>>2]);u=ea(g[j+20>>2]);x=s;y=w;z=v;A=ea(g[j+24>>2]);B=u;C=t}j=d+12|0;q=b[j>>1]|0;r=d+4|0;if(q<<16>>16==-1){D=c[r>>2]|0;t=ea(g[D>>2]);u=ea(g[D+4>>2]);v=ea(g[D+8>>2]);w=ea(g[D+16>>2]);s=ea(g[D+20>>2]);E=v;F=u;G=t;H=ea(g[D+24>>2]);I=s;J=w}else{Tza(k,c[r>>2]|0,q&65535);w=ea(g[k>>2]);s=ea(g[k+4>>2]);t=ea(g[k+8>>2]);u=ea(g[k+16>>2]);v=ea(g[k+20>>2]);E=t;F=s;G=w;H=ea(g[k+24>>2]);I=v;J=u}k=c[d+16>>2]|0;q=b[k+2>>1]|0;D=k+(q&65535)|0;a:do if(!(q<<16>>16)){K=x;L=y;M=z;N=A;O=B;P=C;Q=E;R=F;S=G;T=H;U=I;V=J;W=ea(0.0);X=ea(0.0);Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0)}else{u=ea(0.0);v=ea(0.0);w=ea(0.0);s=ea(0.0);t=ea(0.0);ha=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=J;pa=I;qa=H;ra=G;sa=F;ta=E;ua=C;va=B;wa=A;xa=z;ya=y;za=x;Aa=q;Ba=k;while(1){Ca=Ba+48|0;Da=a[Ba+1>>0]|0;Ea=Da&255;Fa=Ba+((Aa&65535)+32)|0;Ga=Ea*112|0;Ha=Ba+(Ga+48)|0;Ia=ea(g[Ba+16>>2]);Ja=ea(g[Ba+20>>2]);Ka=ea(g[Ba+24>>2]);if(!(Da<<24>>24)){La=za;Ma=ya;Na=xa;Oa=wa;Pa=va;Qa=ua;Ra=ta;Sa=sa;Ta=ra;Ua=qa;Va=pa;Wa=oa;Xa=ea(0.0);Ya=ea(0.0);Za=ea(0.0);_a=ea(0.0);$a=ea(0.0);ab=ea(0.0);bb=ea(0.0);cb=ea(0.0);db=ea(0.0);eb=ea(0.0);fb=ea(0.0);gb=ea(0.0)}else{hb=ua;ib=va;jb=wa;kb=xa;lb=ya;mb=za;nb=oa;ob=pa;pb=qa;qb=ra;rb=sa;sb=ta;tb=ea(0.0);ub=ea(0.0);vb=ea(0.0);wb=ea(0.0);xb=ea(0.0);yb=ea(0.0);zb=ea(0.0);Ab=ea(0.0);Bb=ea(0.0);Cb=ea(0.0);Db=ea(0.0);Eb=ea(0.0);Da=0;while(1){Fb=Da+1|0;Gb=ea(g[Ca+(Da*112|0)+16>>2]);Hb=ea(g[Ca+(Da*112|0)+20>>2]);Ib=ea(g[Ca+(Da*112|0)+24>>2]);Jb=ea(g[Ca+(Da*112|0)+28>>2]);Kb=ea(g[Ca+(Da*112|0)>>2]);Lb=ea(g[Ca+(Da*112|0)+4>>2]);Mb=ea(g[Ca+(Da*112|0)+8>>2]);Nb=Ca+(Da*112|0)+12|0;Ob=ea(g[Nb>>2]);Pb=ea(g[Ca+(Da*112|0)+36>>2]);Qb=ea(ea(ea(Jb*Pb)-ea(g[Ca+(Da*112|0)+32>>2]))-ea(Jb*ea(ea(ea(ea(ea(Ia*kb)+ea(hb*Kb))-ea(ea(Ia*qb)+ea(nb*Gb)))+ea(ea(ea(Ja*lb)+ea(ib*Lb))-ea(ea(Ja*rb)+ea(ob*Hb))))+ea(ea(ea(Ka*mb)+ea(jb*Mb))-ea(ea(Ka*sb)+ea(pb*Ib))))));Jb=ea(-Ob);Pb=Qb>Jb?Qb:Jb;Jb=ea(g[Ca+(Da*112|0)+80>>2]);Qb=ea(g[Ca+(Da*112|0)+84>>2]);Rb=ea(kb+ea(Jb*Pb));Jb=ea(lb+ea(Qb*Pb));Qb=ea(mb+ea(ea(g[Ca+(Da*112|0)+88>>2])*Pb));Sb=ea(g[Ca+(Da*112|0)+48>>2]);Tb=ea(g[Ca+(Da*112|0)+52>>2]);Ub=ea(hb+ea(Sb*Pb));Sb=ea(ib+ea(Tb*Pb));Tb=ea(jb+ea(Pb*ea(g[Ca+(Da*112|0)+56>>2])));Vb=ea(g[Ca+(Da*112|0)+96>>2]);Wb=ea(g[Ca+(Da*112|0)+100>>2]);Xb=ea(qb+ea(Pb*Vb));Vb=ea(rb+ea(Pb*Wb));Wb=ea(sb+ea(Pb*ea(g[Ca+(Da*112|0)+104>>2])));Yb=ea(g[Ca+(Da*112|0)+64>>2]);Zb=ea(g[Ca+(Da*112|0)+68>>2]);_b=ea(nb+ea(Pb*Yb));Yb=ea(ob+ea(Pb*Zb));Zb=ea(pb+ea(Pb*ea(g[Ca+(Da*112|0)+72>>2])));$b=ea(Ia*Pb);ac=ea(Ja*Pb);bc=ea(Ka*Pb);cc=ea(tb+$b);dc=ea(ub+ac);ec=ea(vb+bc);fc=ea(wb+ea(Kb*Pb));Kb=ea(xb+ea(Lb*Pb));Lb=ea(yb+ea(Mb*Pb));Mb=ea(zb+$b);$b=ea(Ab+ac);ac=ea(Bb+bc);bc=ea(Cb+ea(Gb*Pb));Gb=ea(Db+ea(Hb*Pb));Hb=ea(Eb+ea(Ib*Pb));Ib=ea(Ob+Pb);g[Nb>>2]=Ib;g[Fa+(Da<<2)>>2]=Ib;if((Fb|0)==(Ea|0)){La=Qb;Ma=Jb;Na=Rb;Oa=Tb;Pa=Sb;Qa=Ub;Ra=Wb;Sa=Vb;Ta=Xb;Ua=Zb;Va=Yb;Wa=_b;Xa=ec;Ya=dc;Za=cc;_a=ac;$a=$b;ab=Mb;bb=Lb;cb=Kb;db=fc;eb=Hb;fb=Gb;gb=bc;break}else{hb=Ub;ib=Sb;jb=Tb;kb=Rb;lb=Jb;mb=Qb;nb=_b;ob=Yb;pb=Zb;qb=Xb;rb=Vb;sb=Wb;tb=cc;ub=dc;vb=ec;wb=fc;xb=Kb;yb=Lb;zb=Mb;Ab=$b;Bb=ac;Cb=bc;Db=Gb;Eb=Hb;Da=Fb}}}Eb=ea(g[Ba+8>>2]);Db=ea(u+ea(Za*Eb));Cb=ea(v+ea(Ya*Eb));Bb=ea(w+ea(Xa*Eb));Eb=ea(g[Ba+28>>2]);Ab=ea(s+ea(db*Eb));zb=ea(t+ea(cb*Eb));yb=ea(ha+ea(bb*Eb));Eb=ea(g[Ba+12>>2]);xb=ea(ia-ea(ab*Eb));wb=ea(ja-ea($a*Eb));vb=ea(ka-ea(_a*Eb));Eb=ea(g[Ba+32>>2]);ub=ea(la-ea(gb*Eb));tb=ea(ma-ea(fb*Eb));sb=ea(na-ea(eb*Eb));if(Ha>>>0>=D>>>0){K=La;L=Ma;M=Na;N=Oa;O=Pa;P=Qa;Q=Ra;R=Sa;S=Ta;T=Ua;U=Va;V=Wa;W=Bb;X=Cb;Y=Db;Z=vb;_=wb;$=xb;aa=yb;ba=zb;ca=Ab;da=sb;fa=tb;ga=ub;break a}u=Db;v=Cb;w=Bb;s=Ab;t=zb;ha=yb;ia=xb;ja=wb;ka=vb;la=ub;ma=tb;na=sb;oa=Wa;pa=Va;qa=Ua;ra=Ta;sa=Sa;ta=Ra;ua=Qa;va=Pa;wa=Oa;xa=Na;ya=Ma;za=La;Aa=b[Ba+(Ga+50)>>1]|0;Ba=Ha}}while(0);D=b[p>>1]|0;if(D<<16>>16==-1){p=c[d>>2]|0;g[p>>2]=M;g[p+4>>2]=L;g[p+8>>2]=K;g[p+16>>2]=P;g[p+20>>2]=O;g[p+24>>2]=N}else{p=c[d>>2]|0;g[l>>2]=Y;g[l+4>>2]=X;g[l+8>>2]=W;g[l+12>>2]=ea(0.0);g[m>>2]=ca;g[m+4>>2]=ba;g[m+8>>2]=aa;g[m+12>>2]=ea(0.0);c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];Sza(p,D&65535,h,f)}D=b[j>>1]|0;if(D<<16>>16==-1){j=c[r>>2]|0;g[j>>2]=S;g[j+4>>2]=R;g[j+8>>2]=Q;g[j+16>>2]=V;g[j+20>>2]=U;g[j+24>>2]=T;i=e;return}else{j=c[r>>2]|0;g[n>>2]=$;g[n+4>>2]=_;g[n+8>>2]=Z;g[n+12>>2]=ea(0.0);g[o>>2]=ga;g[o+4>>2]=fa;g[o+8>>2]=da;g[o+12>>2]=ea(0.0);c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];Sza(j,D&65535,h,f);i=e;return}}function iya(e,f){e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=Im,qb=Im,rb=Im,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im;f=i;i=i+160|0;h=f+16|0;j=f+80|0;k=f+32|0;l=f+96|0;m=f+144|0;n=f;o=f+64|0;p=f+128|0;q=e+8|0;r=b[q>>1]|0;if(r<<16>>16==-1){s=c[e>>2]|0;t=ea(g[s>>2]);u=ea(g[s+4>>2]);v=ea(g[s+8>>2]);w=ea(g[s+16>>2]);x=ea(g[s+20>>2]);y=v;z=u;A=t;B=ea(g[s+24>>2]);C=x;D=w}else{Tza(k,c[e>>2]|0,r&65535);w=ea(g[k>>2]);x=ea(g[k+4>>2]);t=ea(g[k+8>>2]);u=ea(g[k+16>>2]);v=ea(g[k+20>>2]);y=t;z=x;A=w;B=ea(g[k+24>>2]);C=v;D=u}k=e+12|0;r=b[k>>1]|0;s=e+4|0;if(r<<16>>16==-1){E=c[s>>2]|0;u=ea(g[E>>2]);v=ea(g[E+4>>2]);w=ea(g[E+8>>2]);x=ea(g[E+16>>2]);t=ea(g[E+20>>2]);F=w;G=v;H=u;I=ea(g[E+24>>2]);J=t;K=x}else{Tza(l,c[s>>2]|0,r&65535);x=ea(g[l>>2]);t=ea(g[l+4>>2]);u=ea(g[l+8>>2]);v=ea(g[l+16>>2]);w=ea(g[l+20>>2]);F=u;G=t;H=x;I=ea(g[l+24>>2]);J=w;K=v}l=c[e+16>>2]|0;r=b[e+26>>1]|0;E=l+((r&65535)<<4)|0;if(!(r<<16>>16)){L=y;M=z;N=A;O=B;P=C;Q=D;R=F;S=G;T=H;U=I;V=J;W=K;X=ea(0.0);Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0);ha=ea(0.0)}else{v=ea(0.0);w=ea(0.0);x=ea(0.0);t=ea(0.0);u=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=K;K=J;J=I;I=H;H=G;G=F;F=D;D=C;C=B;B=A;A=z;z=y;r=l;while(1){l=r+32|0;qa=(((d[r+1>>0]|0)<<2)+12&2032)+32|0;ra=r+qa|0;sa=a[r+2>>0]|0;ta=sa&255;y=ea(g[r+4>>2]);if(!(sa<<24>>24)){ua=z;va=A;wa=B;xa=C;ya=D;za=F;Aa=G;Ba=H;Ca=I;Da=J;Ea=K;Fa=pa;Ga=ea(0.0);Ha=ea(0.0);Ia=ea(0.0);Ja=ea(0.0);Ka=ea(0.0);La=ea(0.0);Ma=ea(0.0);Na=ea(0.0);Oa=ea(0.0);Pa=ea(0.0);Qa=ea(0.0);Ra=ea(0.0)}else{Sa=B;Ta=A;Ua=z;Va=F;Wa=D;Xa=C;Ya=I;Za=H;_a=G;$a=pa;ab=K;bb=J;cb=ea(0.0);db=ea(0.0);eb=ea(0.0);fb=ea(0.0);gb=ea(0.0);hb=ea(0.0);ib=ea(0.0);jb=ea(0.0);kb=ea(0.0);lb=ea(0.0);mb=ea(0.0);nb=ea(0.0);sa=0;while(1){ob=sa;sa=sa+1|0;pb=ea(g[ra+(ob<<7)>>2]);qb=ea(g[ra+(ob<<7)+4>>2]);rb=ea(g[ra+(ob<<7)+8>>2]);sb=ra+(ob<<7)+12|0;tb=ea(g[ra+(ob<<7)+16>>2]);ub=ea(g[ra+(ob<<7)+20>>2]);vb=ea(g[ra+(ob<<7)+24>>2]);wb=ea(g[ra+(ob<<7)+32>>2]);xb=ea(g[ra+(ob<<7)+36>>2]);yb=ea(g[ra+(ob<<7)+40>>2]);zb=ea(g[sb>>2]);Ab=ea(g[ra+(ob<<7)+28>>2]);Bb=ea(y*ea(g[l+(c[ra+(ob<<7)+80>>2]<<2)>>2]));Cb=ea(-Bb);Db=ea(zb-ea(Ab*ea(ea(ea(ea(ea(Sa*pb)+ea(Ta*qb))+ea(Ua*rb))+ea(ea(ea(Va*tb)+ea(Wa*ub))+ea(Xa*vb)))-ea(ea(ea(ea(Ya*pb)+ea(Za*qb))+ea(_a*rb))+ea(ea(ea($a*wb)+ea(ab*xb))+ea(bb*yb))))));Ab=Db>Bb?Bb:Db;Db=Ab>Cb?Ab:Cb;Cb=ea(Db-zb);zb=ea(g[ra+(ob<<7)+96>>2]);Ab=ea(g[ra+(ob<<7)+100>>2]);Bb=ea(Sa+ea(zb*Cb));zb=ea(Ta+ea(Ab*Cb));Ab=ea(Ua+ea(ea(g[ra+(ob<<7)+104>>2])*Cb));Eb=ea(g[ra+(ob<<7)+48>>2]);Fb=ea(g[ra+(ob<<7)+52>>2]);Gb=ea(Va+ea(Eb*Cb));Eb=ea(Wa+ea(Fb*Cb));Fb=ea(Xa+ea(ea(g[ra+(ob<<7)+56>>2])*Cb));Hb=ea(g[ra+(ob<<7)+112>>2]);Ib=ea(g[ra+(ob<<7)+116>>2]);Jb=ea(Ya+ea(Hb*Cb));Hb=ea(Za+ea(Cb*Ib));Ib=ea(_a+ea(Cb*ea(g[ra+(ob<<7)+120>>2])));Kb=ea(g[ra+(ob<<7)+64>>2]);Lb=ea(g[ra+(ob<<7)+68>>2]);Mb=ea($a+ea(Cb*Kb));Kb=ea(ab+ea(Cb*Lb));Lb=ea(bb+ea(Cb*ea(g[ra+(ob<<7)+72>>2])));Nb=ea(pb*Cb);pb=ea(qb*Cb);qb=ea(rb*Cb);rb=ea(cb+Nb);Ob=ea(db+pb);Pb=ea(eb+qb);Qb=ea(fb+ea(tb*Cb));tb=ea(gb+ea(ub*Cb));ub=ea(hb+ea(vb*Cb));vb=ea(ib+Nb);Nb=ea(jb+pb);pb=ea(kb+qb);qb=ea(lb+ea(wb*Cb));wb=ea(mb+ea(xb*Cb));xb=ea(nb+ea(yb*Cb));g[sb>>2]=Db;if((sa|0)==(ta|0)){ua=Ab;va=zb;wa=Bb;xa=Fb;ya=Eb;za=Gb;Aa=Ib;Ba=Hb;Ca=Jb;Da=Lb;Ea=Kb;Fa=Mb;Ga=Pb;Ha=Ob;Ia=rb;Ja=pb;Ka=Nb;La=vb;Ma=ub;Na=tb;Oa=Qb;Pa=xb;Qa=wb;Ra=qb;break}else{Sa=Bb;Ta=zb;Ua=Ab;Va=Gb;Wa=Eb;Xa=Fb;Ya=Jb;Za=Hb;_a=Ib;$a=Mb;ab=Kb;bb=Lb;cb=rb;db=Ob;eb=Pb;fb=Qb;gb=tb;hb=ub;ib=vb;jb=Nb;kb=pb;lb=qb;mb=wb;nb=xb}}}nb=ea(g[r+8>>2]);mb=ea(v+ea(Ia*nb));lb=ea(w+ea(Ha*nb));kb=ea(x+ea(Ga*nb));nb=ea(g[r+16>>2]);jb=ea(t+ea(Oa*nb));ib=ea(u+ea(Na*nb));hb=ea(ia+ea(Ma*nb));nb=ea(g[r+12>>2]);gb=ea(ja-ea(La*nb));fb=ea(ka-ea(Ka*nb));eb=ea(la-ea(Ja*nb));nb=ea(g[r+20>>2]);r=r+(qa+(ta<<7))|0;db=ea(ma-ea(Ra*nb));cb=ea(na-ea(Qa*nb));bb=ea(oa-ea(Pa*nb));if(r>>>0>=E>>>0){L=ua;M=va;N=wa;O=xa;P=ya;Q=za;R=Aa;S=Ba;T=Ca;U=Da;V=Ea;W=Fa;X=kb;Y=lb;Z=mb;_=eb;$=fb;aa=gb;ba=hb;ca=ib;da=jb;fa=bb;ga=cb;ha=db;break}else{v=mb;w=lb;x=kb;t=jb;u=ib;ia=hb;ja=gb;ka=fb;la=eb;ma=db;na=cb;oa=bb;pa=Fa;K=Ea;J=Da;I=Ca;H=Ba;G=Aa;F=za;D=ya;C=xa;B=wa;A=va;z=ua}}}E=b[q>>1]|0;if(E<<16>>16==-1){q=c[e>>2]|0;g[q>>2]=N;g[q+4>>2]=M;g[q+8>>2]=L;g[q+16>>2]=Q;g[q+20>>2]=P;g[q+24>>2]=O}else{q=c[e>>2]|0;g[m>>2]=Z;g[m+4>>2]=Y;g[m+8>>2]=X;g[m+12>>2]=ea(0.0);g[n>>2]=da;g[n+4>>2]=ca;g[n+8>>2]=ba;g[n+12>>2]=ea(0.0);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];Sza(q,E&65535,j,h)}E=b[k>>1]|0;if(E<<16>>16==-1){k=c[s>>2]|0;g[k>>2]=T;g[k+4>>2]=S;g[k+8>>2]=R;g[k+16>>2]=W;g[k+20>>2]=V;g[k+24>>2]=U;i=f;return}else{k=c[s>>2]|0;g[o>>2]=aa;g[o+4>>2]=$;g[o+8>>2]=_;g[o+12>>2]=ea(0.0);g[p>>2]=ha;g[p+4>>2]=ga;g[p+8>>2]=fa;g[p+12>>2]=ea(0.0);c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];Sza(k,E&65535,j,h);i=f;return}}function jya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{iya(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function kya(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;if(!b){i=f;return}else g=0;do{iya(a+(g<<5)|0,0);g=g+1|0}while((g|0)!=(b|0));i=f;return}function lya(a,b){a=a|0;b=b|0;var c=0;c=i;hya(a,0);Nxa(a,b);i=c;return}function mya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;if(!b){i=c;return}else d=0;do{hya(a+(d<<5)|0,0);d=d+1|0}while((d|0)!=(b|0));i=c;return}function nya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!b){i=d;return}else e=0;do{f=a+(e<<5)|0;hya(f,0);Nxa(f,c);e=e+1|0}while((e|0)!=(b|0));i=d;return}function oya(a,d,f,g,h,j){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;h=i;if(d){k=f+16|0;l=0;do{m=a+(l<<5)|0;if((b[a+(l<<5)+8>>1]|0)==-1)n=e[a+(l<<5)+10>>1]|0;else n=0;o=c[k>>2]|0;if((b[a+(l<<5)+12>>1]|0)==-1)p=e[a+(l<<5)+14>>1]|0;else p=0;hya(m,0);Oxa(m,f,o+(n<<6)|0,o+(p<<6)|0);l=l+1|0}while((l|0)!=(d|0))}d=f+8|0;l=c[d>>2]|0;if(!l){i=h;return}p=hTa(j,l)|0;l=c[d>>2]|0;j=p-l|0;if(l){l=f+4|0;f=0;do{p=g+(j+f<<4)|0;n=(c[l>>2]|0)+(f<<4)|0;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[p+12>>2]=c[n+12>>2];f=f+1|0}while(f>>>0<(c[d>>2]|0)>>>0)}c[d>>2]=0;i=h;return}function pya(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0,n=0,o=0,p=0;e=i;i=i+112|0;f=e;c[b>>2]=0;h=b+16|0;j=ea(g[d+6164>>2]);k=ea(g[d+6168>>2]);l=ea(g[d+6172>>2]);m=d+5928|0;n=f+36|0;o=f+0|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));g[n>>2]=ea(1.0);n=f+40|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[f+56>>2]=ea(1.0);n=f+60|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[f+76>>2]=ea(1.0);n=f+80|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[f+96>>2]=ea(1.0);c[f+100>>2]=m;XAa(h,j,k,l,f,d+44|0,(a[d+1444>>0]|0)!=0);c[b+8952>>2]=0;c[b+9092>>2]=0;c[b+9100>>2]=0;c[b+9268>>2]=0;a[b+9272>>0]=0;c[b+9276>>2]=0;c[b+9284>>2]=0;d=b+9292|0;c[b+9316>>2]=0;f=b+9392|0;h=b+9412|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;PEi(b+9108|0,0,144)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;o=b+9344|0;p=o+44|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;i=e;return}function qya(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=a+9112|0;c[j>>2]=0;k=b>>>1|b;l=k>>>2|k;k=l>>>4|l;l=k>>>8|k;k=(l>>>16|l)+1|0;l=k>>>0<64?64:k;if((c[a+9116>>2]&2147483647)>>>0<l>>>0)p1a(a+9108|0,l);c[j>>2]=b;j=a+9124|0;c[j>>2]=0;l=b+63&-64;if((c[a+9128>>2]&2147483647)>>>0<l>>>0)q1a(a+9120|0,l);c[j>>2]=b;j=a+9136|0;c[j>>2]=0;if((c[a+9140>>2]&2147483647)>>>0<l>>>0)q1a(a+9132|0,l);c[j>>2]=b;b=a+9144|0;c[a+9148>>2]=0;j=e+63&-64;if((c[a+9152>>2]&2147483647)>>>0<j>>>0)x0a(b,j);c[a+9172>>2]=0;j=e+66&-64;if((c[a+9176>>2]&2147483647)>>>0<j>>>0)x0a(a+9168|0,j);j=a+9156|0;c[a+9160>>2]=0;e=f+63&-64;if((c[a+9164>>2]&2147483647)>>>0<e>>>0)x0a(j,e);e=a+9348|0;c[e>>2]=0;f=d>>>1|d;l=f>>>2|f;f=l>>>4|l;l=f>>>8|f;f=(l>>>16|l)+1|0;l=f>>>0<64?64:f;if((c[a+9352>>2]&2147483647)>>>0<l>>>0)S$a(a+9344|0,l);c[e>>2]=d;d=a+9372|0;c[d>>2]=0;e=g>>>1|g;l=e>>>2|e;e=l>>>4|l;l=e>>>8|e;e=(l>>>16|l)+1|0;l=e>>>0<16?16:e;if((c[a+9376>>2]&2147483647)>>>0>=l>>>0){c[d>>2]=g;m=c[b>>2]|0;n=a+9308|0;c[n>>2]=m;o=c[j>>2]|0;p=a+9316|0;c[p>>2]=o;i=h;return}r1a(a+9368|0,l);c[d>>2]=g;m=c[b>>2]|0;n=a+9308|0;c[n>>2]=m;o=c[j>>2]|0;p=a+9316|0;c[p>>2]=o;i=h;return}function rya(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;cAa(b+360|0);c[b+336>>2]=0;c[b+340>>2]=0;c[b+352>>2]=0;c[b+356>>2]=0;rAa(b+372|0);g=b+9384|0;h=b+9380|0;PEi(c[h>>2]|0,0,c[g>>2]<<2|0)|0;j=(e+31|0)>>>5;if(j>>>0>(c[g>>2]&2147483647)>>>0){e=b+9388|0;k=UJa(e,j<<2,543784,339)|0;l=c[h>>2]|0;if((l|0)!=0?(YEi(k|0,l|0,c[g>>2]<<2|0)|0,(c[g>>2]|0)>-1):0)VJa(e,c[h>>2]|0);e=c[g>>2]|0;PEi(k+((e&2147483647)<<2)|0,0,j-e<<2|0)|0;c[h>>2]=k;c[g>>2]=j}c[b+9392>>2]=0;c[b+9396>>2]=0;j=b+9404|0;g=b+9400|0;PEi(c[g>>2]|0,0,c[j>>2]<<2|0)|0;k=(d+31|0)>>>5;if(k>>>0>(c[j>>2]&2147483647)>>>0){d=b+9408|0;h=UJa(d,k<<2,543784,339)|0;e=c[g>>2]|0;if((e|0)!=0?(YEi(h|0,e|0,c[j>>2]<<2|0)|0,(c[j>>2]|0)>-1):0)VJa(d,c[g>>2]|0);d=c[j>>2]|0;PEi(h+((d&2147483647)<<2)|0,0,k-d<<2|0)|0;c[g>>2]=h;c[j>>2]=k}c[b+9360>>2]=0;c[b+9308>>2]=c[b+9144>>2];c[b+9316>>2]=c[b+9156>>2];c[b+9300>>2]=0;c[b+9268>>2]=0;c[b+9292>>2]=0;c[b+9296>>2]=0;a[b+9272>>0]=0;c[b+8952>>2]=0;c[b+9092>>2]=0;c[b+9276>>2]=0;c[b+9100>>2]=0;c[b+9172>>2]=0;i=f;return}function sya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im;k=i;i=i+208|0;l=k+184|0;m=k+160|0;n=k+112|0;o=k+96|0;p=k+48|0;q=k;r=h+4|0;h=c[r>>2]|0;s=a+4|0;t=b+4|0;u=ea(g[d>>2]);v=ea(u+u);w=ea(g[d+4>>2]);x=ea(w+w);y=ea(g[d+8>>2]);z=ea(y+y);A=ea(g[d+12>>2]);B=ea(v*A);C=ea(x*A);D=ea(A*z);A=ea(u*v);v=ea(u*x);E=ea(u*z);u=ea(w*x);x=ea(w*z);w=ea(y*z);g[p>>2]=ea(ea(ea(1.0)-u)-w);F=p+4|0;g[F>>2]=ea(v+D);G=p+8|0;g[G>>2]=ea(E-C);H=p+12|0;g[H>>2]=ea(v-D);D=ea(ea(1.0)-A);I=p+16|0;g[I>>2]=ea(D-w);J=p+20|0;g[J>>2]=ea(x+B);K=p+24|0;g[K>>2]=ea(E+C);L=p+28|0;g[L>>2]=ea(x-B);M=p+32|0;g[M>>2]=ea(D-u);u=ea(g[d+16>>2]);g[p+36>>2]=u;D=ea(g[d+20>>2]);g[p+40>>2]=D;B=ea(g[d+24>>2]);g[p+44>>2]=B;x=ea(g[e>>2]);C=ea(x+x);E=ea(g[e+4>>2]);w=ea(E+E);A=ea(g[e+8>>2]);v=ea(A+A);z=ea(g[e+12>>2]);y=ea(C*z);N=ea(w*z);O=ea(z*v);z=ea(x*C);C=ea(x*w);P=ea(x*v);x=ea(E*w);w=ea(E*v);E=ea(A*v);v=ea(ea(ea(1.0)-x)-E);g[q>>2]=v;A=ea(C+O);g[q+4>>2]=A;Q=ea(P-N);g[q+8>>2]=Q;R=ea(C-O);g[q+12>>2]=R;O=ea(ea(1.0)-z);z=ea(O-E);g[q+16>>2]=z;E=ea(w+y);g[q+20>>2]=E;C=ea(P+N);g[q+24>>2]=C;N=ea(w-y);g[q+28>>2]=N;y=ea(O-x);g[q+32>>2]=y;x=ea(g[e+16>>2]);g[q+36>>2]=x;O=ea(g[e+20>>2]);g[q+40>>2]=O;w=ea(g[e+24>>2]);g[q+44>>2]=w;P=ea(g[f>>2]);T=ea(x-u);U=ea(O-D);V=ea(w-B);W=ea(g[p>>2]);X=ea(W*v);Y=ea(g[F>>2]);Z=ea(X+ea(Y*A));X=ea(g[G>>2]);_=ea(Z+ea(X*Q));Z=ea(ea(ea(W*R)+ea(Y*z))+ea(X*E));$=ea(ea(ea(W*C)+ea(Y*N))+ea(X*y));aa=ea(ea(ea(T*W)+ea(U*Y))+ea(V*X));ba=ea(ea(S(ea(_)))+ea(9.99999997e-07));ca=ea(ea(S(ea(Z)))+ea(9.99999997e-07));da=ea(ea(S(ea($)))+ea(9.99999997e-07));g[l>>2]=aa;fa=ea(g[s>>2]);ga=ea(g[t>>2]);ha=ea(fa+ea(ba*ga));ia=ea(g[b+8>>2]);ja=ea(ha+ea(ca*ia));ha=ea(g[b+12>>2]);ka=ea(P+ea(ea(ja+ea(da*ha))-ea(S(ea(aa)))));g[m>>2]=ka;if(ka<ea(0.0)){la=0;ma=h;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}ja=ea(g[H>>2]);qa=ea(v*ja);ra=ea(g[I>>2]);sa=ea(qa+ea(A*ra));qa=ea(g[J>>2]);ta=ea(sa+ea(Q*qa));sa=ea(ea(ea(R*ja)+ea(z*ra))+ea(E*qa));ua=ea(ea(ea(C*ja)+ea(N*ra))+ea(y*qa));va=ea(ea(ea(T*ja)+ea(U*ra))+ea(V*qa));wa=ea(ea(S(ea(ta)))+ea(9.99999997e-07));xa=ea(ea(S(ea(sa)))+ea(9.99999997e-07));ya=ea(ea(S(ea(ua)))+ea(9.99999997e-07));g[l+4>>2]=va;za=ea(g[a+8>>2]);Aa=ea(P+ea(ea(ea(ha*ya)+ea(ea(ia*xa)+ea(ea(ga*wa)+za)))-ea(S(ea(va)))));J=m+4|0;g[J>>2]=Aa;if(Aa<ea(0.0)){la=0;ma=h;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}Ba=ea(g[K>>2]);Ca=ea(v*Ba);Da=ea(g[L>>2]);Ea=ea(Ca+ea(A*Da));Ca=ea(g[M>>2]);Fa=ea(Ea+ea(Q*Ca));Ea=ea(ea(ea(R*Ba)+ea(z*Da))+ea(E*Ca));Ga=ea(ea(ea(C*Ba)+ea(N*Da))+ea(y*Ca));Ha=ea(ea(ea(T*Ba)+ea(U*Da))+ea(V*Ca));Ia=ea(ea(S(ea(Fa)))+ea(9.99999997e-07));Ja=ea(ea(S(ea(Ea)))+ea(9.99999997e-07));Ka=ea(ea(S(ea(Ga)))+ea(9.99999997e-07));g[l+8>>2]=Ha;La=ea(g[a+12>>2]);Ma=ea(P+ea(ea(ea(ha*Ka)+ea(ea(ia*Ja)+ea(ea(ga*Ia)+La)))-ea(S(ea(Ha)))));a=m+8|0;g[a>>2]=Ma;if(Ma<ea(0.0)){la=0;ma=h;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}Na=ea(ea(ea(T*v)+ea(U*A))+ea(V*Q));g[l+12>>2]=Na;Oa=ea(P+ea(ea(ea(ea(ga+ea(ba*fa))+ea(wa*za))+ea(Ia*La))-ea(S(ea(Na)))));M=m+12|0;g[M>>2]=Oa;if(Oa<ea(0.0)){la=0;ma=h;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}Na=ea(ea(ea(T*R)+ea(U*z))+ea(V*E));g[l+16>>2]=Na;Pa=ea(P+ea(ea(ea(ea(ea(ca*fa)+ia)+ea(xa*za))+ea(Ja*La))-ea(S(ea(Na)))));L=m+16|0;g[L>>2]=Pa;if(Pa<ea(0.0)){la=0;ma=h;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}Na=ea(ea(ea(T*C)+ea(U*N))+ea(V*y));g[l+20>>2]=Na;V=ea(P+ea(ea(ea(ea(ea(da*fa)+ha)+ea(ya*za))+ea(Ka*La))-ea(S(ea(Na)))));K=m+20|0;g[K>>2]=V;if(V<ea(0.0)){la=0;ma=h;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(!h){if(ea(S(ea(ea(ta*Ha)-ea(va*Fa))))>ea(ea(ca*ha)+ea(ea(da*ia)+ea(ea(P+ea(za*Ia))+ea(wa*La))))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(sa*Ha)-ea(va*Ea))))>ea(ea(ba*ha)+ea(ea(da*ga)+ea(ea(P+ea(za*Ja))+ea(xa*La))))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(ua*Ha)-ea(va*Ga))))>ea(ea(ba*ia)+ea(ea(ca*ga)+ea(ea(ya*La)+ea(P+ea(za*Ka)))))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(aa*Fa)-ea(_*Ha))))>ea(ea(ha*xa)+ea(ea(ia*ya)+ea(ea(P+ea(fa*Ia))+ea(ba*La))))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(aa*Ea)-ea(Z*Ha))))>ea(ea(ha*wa)+ea(ea(ga*ya)+ea(ea(ca*La)+ea(P+ea(fa*Ja)))))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(aa*Ga)-ea($*Ha))))>ea(ea(ia*wa)+ea(ea(ga*xa)+ea(ea(da*La)+ea(P+ea(fa*Ka)))))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(_*va)-ea(aa*ta))))>ea(ea(ha*Ja)+ea(ea(ea(P+ea(fa*wa))+ea(ba*za))+ea(ia*Ka)))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea(Z*va)-ea(aa*sa))))>ea(ea(ha*Ia)+ea(ea(ea(ca*za)+ea(P+ea(fa*xa)))+ea(ga*Ka)))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}if(ea(S(ea(ea($*va)-ea(aa*ua))))>ea(ea(ia*Ia)+ea(ea(ea(da*za)+ea(P+ea(fa*ya)))+ea(ga*Ja)))){la=0;ma=0;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}else{Qa=ka;Ra=Aa;Sa=Ma;Ta=Oa;Ua=Pa;Va=V}}else{I=m+(h+-1<<2)|0;g[I>>2]=ea(ea(g[I>>2])*ea(.999000012));V=ea(g[m>>2]);Pa=ea(g[J>>2]);Oa=ea(g[a>>2]);Ma=ea(g[M>>2]);Aa=ea(g[L>>2]);Qa=V;Ra=Pa;Sa=Oa;Ta=Ma;Ua=Aa;Va=ea(g[K>>2])}K=Qa>=ea(0.0)&Qa<ea(3402823469999999843913219.0e14);Aa=K?Qa:ea(3402823469999999843913219.0e14);K=Ra>=ea(0.0)&Ra<Aa;Qa=K?Ra:Aa;L=Sa>=ea(0.0)&Sa<Qa;Aa=L?Sa:Qa;M=Ta>=ea(0.0)&Ta<Aa;Qa=M?Ta:Aa;a=Ua>=ea(0.0)&Ua<Qa;J=Va>=ea(0.0)&Va<(a?Ua:Qa);m=J?5:a?4:M?3:L?2:K&1;K=m+1|0;L=ea(g[l+(m<<2)>>2])<ea(0.0);switch(m|0){case 4:{m=n+24|0;g[m>>2]=v;l=n+28|0;g[l>>2]=A;M=n+32|0;g[M>>2]=Q;if(L){g[o>>2]=R;g[o+4>>2]=z;g[o+8>>2]=E;Qa=ea(-z);Ua=ea(-E);g[n>>2]=ea(-R);g[n+4>>2]=Qa;g[n+8>>2]=Ua;Ua=ea(-N);Qa=ea(-y);g[n+12>>2]=ea(-C);g[n+16>>2]=Ua;g[n+20>>2]=Qa;Qa=ea(O+ea(z*ia));Ua=ea(w+ea(E*ia));g[n+36>>2]=ea(x+ea(R*ia));g[n+40>>2]=Qa;g[n+44>>2]=Ua}else{Ua=ea(-z);Qa=ea(-E);g[o>>2]=ea(-R);g[o+4>>2]=Ua;g[o+8>>2]=Qa;g[n>>2]=R;g[n+4>>2]=z;g[n+8>>2]=E;g[n+12>>2]=C;g[n+16>>2]=N;g[n+20>>2]=y;g[m>>2]=v;g[l>>2]=A;g[M>>2]=Q;Qa=ea(O-ea(z*ia));Ua=ea(w-ea(E*ia));g[n+36>>2]=ea(x-ea(R*ia));g[n+40>>2]=Qa;g[n+44>>2]=Ua}la=s1a(j,o,ha,ga,s,n,p,P)|0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}case 0:{if(L){g[o>>2]=W;g[o+4>>2]=Y;g[o+8>>2]=X;g[n>>2]=W;g[n+4>>2]=Y;g[n+8>>2]=X;g[n+12>>2]=ja;g[n+16>>2]=ra;g[n+20>>2]=qa;g[n+24>>2]=Ba;g[n+28>>2]=Da;g[n+32>>2]=Ca;Ua=ea(D-ea(Y*fa));Qa=ea(B-ea(X*fa));g[n+36>>2]=ea(u-ea(W*fa));g[n+40>>2]=Ua;g[n+44>>2]=Qa}else{Qa=ea(-W);Ua=ea(-Y);Va=ea(-X);g[o>>2]=Qa;g[o+4>>2]=Ua;g[o+8>>2]=Va;g[n>>2]=Qa;g[n+4>>2]=Ua;g[n+8>>2]=Va;Va=ea(-ra);Ua=ea(-qa);g[n+12>>2]=ea(-ja);g[n+16>>2]=Va;g[n+20>>2]=Ua;g[n+24>>2]=Ba;g[n+28>>2]=Da;g[n+32>>2]=Ca;Ua=ea(D+ea(Y*fa));Va=ea(B+ea(X*fa));g[n+36>>2]=ea(u+ea(W*fa));g[n+40>>2]=Ua;g[n+44>>2]=Va}la=s1a(j,o,za,La,t,n,q,P)|0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}case 5:{g[n+24>>2]=R;g[n+28>>2]=z;g[n+32>>2]=E;if(L){g[o>>2]=C;g[o+4>>2]=N;g[o+8>>2]=y;Va=ea(-N);Ua=ea(-y);g[n>>2]=ea(-C);g[n+4>>2]=Va;g[n+8>>2]=Ua;Ua=ea(-A);Va=ea(-Q);g[n+12>>2]=ea(-v);g[n+16>>2]=Ua;g[n+20>>2]=Va;Va=ea(O+ea(N*ha));Ua=ea(w+ea(y*ha));g[n+36>>2]=ea(x+ea(C*ha));g[n+40>>2]=Va;g[n+44>>2]=Ua}else{Ua=ea(-N);Va=ea(-y);g[o>>2]=ea(-C);g[o+4>>2]=Ua;g[o+8>>2]=Va;g[n>>2]=C;g[n+4>>2]=N;g[n+8>>2]=y;g[n+12>>2]=v;g[n+16>>2]=A;g[n+20>>2]=Q;Va=ea(O-ea(N*ha));Ua=ea(w-ea(y*ha));g[n+36>>2]=ea(x-ea(C*ha));g[n+40>>2]=Va;g[n+44>>2]=Ua}la=s1a(j,o,ga,ia,s,n,p,P)|0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}case 2:{g[n+24>>2]=ja;g[n+28>>2]=ra;g[n+32>>2]=qa;if(L){g[o>>2]=Ba;g[o+4>>2]=Da;g[o+8>>2]=Ca;g[n>>2]=Ba;g[n+4>>2]=Da;g[n+8>>2]=Ca;g[n+12>>2]=W;g[n+16>>2]=Y;g[n+20>>2]=X;Ua=ea(D-ea(Da*La));Va=ea(B-ea(Ca*La));g[n+36>>2]=ea(u-ea(Ba*La));g[n+40>>2]=Ua;g[n+44>>2]=Va}else{Va=ea(-Ba);Ua=ea(-Da);Qa=ea(-Ca);g[o>>2]=Va;g[o+4>>2]=Ua;g[o+8>>2]=Qa;g[n>>2]=Va;g[n+4>>2]=Ua;g[n+8>>2]=Qa;Qa=ea(-Y);Ua=ea(-X);g[n+12>>2]=ea(-W);g[n+16>>2]=Qa;g[n+20>>2]=Ua;Ua=ea(D+ea(Da*La));Qa=ea(B+ea(Ca*La));g[n+36>>2]=ea(u+ea(Ba*La));g[n+40>>2]=Ua;g[n+44>>2]=Qa}la=s1a(j,o,fa,za,t,n,q,P)|0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}case 1:{g[n+24>>2]=W;g[n+28>>2]=Y;g[n+32>>2]=X;if(L){g[o>>2]=ja;g[o+4>>2]=ra;g[o+8>>2]=qa;g[n>>2]=ja;g[n+4>>2]=ra;g[n+8>>2]=qa;g[n+12>>2]=Ba;g[n+16>>2]=Da;g[n+20>>2]=Ca;X=ea(D-ea(ra*za));Y=ea(B-ea(qa*za));g[n+36>>2]=ea(u-ea(ja*za));g[n+40>>2]=X;g[n+44>>2]=Y}else{Y=ea(-ja);X=ea(-ra);W=ea(-qa);g[o>>2]=Y;g[o+4>>2]=X;g[o+8>>2]=W;g[n>>2]=Y;g[n+4>>2]=X;g[n+8>>2]=W;W=ea(-Da);Da=ea(-Ca);g[n+12>>2]=ea(-Ba);g[n+16>>2]=W;g[n+20>>2]=Da;Da=ea(D+ea(ra*za));ra=ea(B+ea(qa*za));g[n+36>>2]=ea(u+ea(ja*za));g[n+40>>2]=Da;g[n+44>>2]=ra}la=s1a(j,o,La,fa,t,n,q,P)|0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}case 3:{if(L){g[o>>2]=v;g[o+4>>2]=A;g[o+8>>2]=Q;fa=ea(-A);La=ea(-Q);g[n>>2]=ea(-v);g[n+4>>2]=fa;g[n+8>>2]=La;La=ea(-z);fa=ea(-E);g[n+12>>2]=ea(-R);g[n+16>>2]=La;g[n+20>>2]=fa;g[n+24>>2]=C;g[n+28>>2]=N;g[n+32>>2]=y;fa=ea(O+ea(A*ga));La=ea(w+ea(Q*ga));g[n+36>>2]=ea(x+ea(v*ga));g[n+40>>2]=fa;g[n+44>>2]=La}else{La=ea(-A);fa=ea(-Q);g[o>>2]=ea(-v);g[o+4>>2]=La;g[o+8>>2]=fa;g[n>>2]=v;g[n+4>>2]=A;g[n+8>>2]=Q;g[n+12>>2]=R;g[n+16>>2]=z;g[n+20>>2]=E;g[n+24>>2]=C;g[n+28>>2]=N;g[n+32>>2]=y;y=ea(O-ea(A*ga));A=ea(w-ea(Q*ga));g[n+36>>2]=ea(x-ea(v*ga));g[n+40>>2]=y;g[n+44>>2]=A}la=s1a(j,o,ia,ha,s,n,p,P)|0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}default:{la=0;ma=K;na=(la|0)==0;oa=na?0:ma;c[r>>2]=oa;pa=na^1;i=k;return pa|0}}return 0}function tya(e,f,h,j,k,l,m){e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=Im,_a=Im,$a=Im,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=0,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=0,Bb=0,Cb=Im,Db=Im,Eb=Im;l=i;i=i+672|0;n=l+16|0;o=l+124|0;p=l+296|0;q=l+432|0;r=l+148|0;s=l+200|0;t=l+336|0;u=l+472|0;v=l+568|0;w=l+12|0;x=l+144|0;y=l+88|0;z=l;A=l+100|0;B=l+184|0;C=l+112|0;D=c[f+4>>2]|0;E=o+12|0;c[E>>2]=D;F=o+16|0;c[F>>2]=f;G=f+8|0;g[o+4>>2]=ea(ea(1.0)/ea(g[G>>2]));H=f+12|0;g[o>>2]=ea(ea(1.0)/ea(g[H>>2]));I=f+16|0;f=o+8|0;g[f>>2]=ea(ea(1.0)/ea(g[I>>2]));J=ea(g[h>>2]);K=ea(J+J);L=ea(g[h+4>>2]);M=ea(L+L);N=ea(g[h+8>>2]);O=ea(N+N);P=ea(g[h+12>>2]);Q=ea(K*P);U=ea(M*P);V=ea(P*O);P=ea(J*M);W=ea(J*O);X=ea(L*M);M=ea(L*O);L=ea(N*O);O=ea(ea(ea(1.0)-X)-L);N=ea(P+V);Y=ea(W-U);Z=ea(P-V);V=ea(ea(1.0)-ea(J*K));K=ea(V-L);L=ea(M+Q);J=ea(W+U);U=ea(M-Q);Q=ea(V-X);X=ea(g[h+16>>2]);V=ea(g[h+20>>2]);M=ea(g[h+24>>2]);W=ea(g[j>>2]);P=ea(W+W);_=ea(g[j+4>>2]);$=ea(_+_);aa=ea(g[j+8>>2]);ba=ea(aa+aa);fa=ea(g[j+12>>2]);ga=ea(P*fa);ha=ea($*fa);ia=ea(fa*ba);fa=ea(W*$);ja=ea(W*ba);ka=ea(_*$);$=ea(_*ba);_=ea(aa*ba);ba=ea(ea(ea(1.0)-ka)-_);aa=ea(fa+ia);la=ea(ja-ha);ma=ea(fa-ia);ia=ea(ea(1.0)-ea(W*P));P=ea(ia-_);_=ea($+ga);W=ea(ja+ha);ha=ea($-ga);ga=ea(ia-ka);ka=ea(g[j+16>>2]);ia=ea(g[j+20>>2]);$=ea(g[j+24>>2]);g[p>>2]=ba;g[p+4>>2]=aa;g[p+8>>2]=la;g[p+12>>2]=ma;g[p+16>>2]=P;g[p+20>>2]=_;g[p+24>>2]=W;g[p+28>>2]=ha;g[p+32>>2]=ga;F0a(q,p);ja=ea(g[q>>2]);fa=ea(g[q+4>>2]);na=ea(O*fa);oa=ea(g[q+8>>2]);pa=ea(g[q+12>>2]);qa=ea(g[q+16>>2]);ra=ea(N*qa);sa=ea(g[q+20>>2]);ta=ea(N*sa);ua=ea(na+ra);ra=ea(g[q+24>>2]);na=ea(g[q+28>>2]);va=ea(Y*na);wa=ea(g[q+32>>2]);xa=ea(Y*wa);ya=ea(ua+va);va=ea(ea(ea(Z*ja)+ea(K*pa))+ea(L*ra));ua=ea(ea(ea(Z*oa)+ea(K*sa))+ea(L*wa));za=ea(ea(J*oa)+ea(U*sa));sa=ea(Q*wa);wa=ea(ea(ea(J*fa)+ea(U*qa))+ea(Q*na));F0a(r,p);Aa=ea(X-ka);Ba=ea(V-ia);Ca=ea(M-$);Da=ea(g[r>>2]);Ea=ea(Aa*ea(g[r+4>>2]));Fa=ea(g[r+8>>2]);Ga=ea(g[r+12>>2]);Ha=ea(Ba*ea(g[r+16>>2]));Ia=ea(Ba*ea(g[r+20>>2]));Ja=ea(Ea+Ha);Ha=ea(g[r+24>>2]);Ea=ea(Ca*ea(g[r+28>>2]));Ka=ea(Ja+Ea);Ea=ea(ea(ea(O*ja)+ea(N*pa))+ea(Y*ra));Ja=ea(ea(ea(O*oa)+ta)+xa);xa=ea(ea(ea(Z*fa)+ea(K*qa))+ea(L*na));na=ea(ea(ea(J*ja)+ea(U*pa))+ea(Q*ra));ra=ea(za+sa);sa=ea(ea(ea(Aa*Da)+ea(Ba*Ga))+ea(Ca*Ha));Ha=ea(ea(ea(Aa*Fa)+Ia)+ea(Ca*ea(g[r+32>>2])));r=e+4|0;Ca=ea(g[r>>2]);p=e+8|0;Ia=ea(g[p>>2]);q=e+12|0;Fa=ea(g[q>>2]);e=0;do{j=e*3|0;Aa=ea(g[543968+(j<<2)>>2]);Ga=ea(Ca*Aa);Ba=ea(g[543968+(j+1<<2)>>2]);Da=ea(Ia*Ba);za=ea(g[543968+(j+2<<2)>>2]);pa=ea(Fa*za);g[s+(e*12|0)>>2]=Ga;g[s+(e*12|0)+4>>2]=Da;g[s+(e*12|0)+8>>2]=pa;j=t+(e*12|0)|0;g[j>>2]=Aa;h=t+(e*12|0)+4|0;g[h>>2]=Ba;La=t+(e*12|0)+8|0;g[La>>2]=za;pa=ea(T(ea(ea(za*za)+ea(ea(Aa*Aa)+ea(Ba*Ba)))));if(pa>ea(0.0)){Da=ea(ea(1.0)/pa);g[j>>2]=ea(Aa*Da);g[h>>2]=ea(Ba*Da);g[La>>2]=ea(za*Da)}e=e+1|0}while((e|0)!=8);e=0;do{Fa=ea(g[s+(e*12|0)>>2]);Ia=ea(Ea*Fa);Ca=ea(ya*Fa);Da=ea(Ja*Fa);Fa=ea(g[s+(e*12|0)+4>>2]);za=ea(Ia+ea(va*Fa));Ia=ea(Ca+ea(xa*Fa));Ca=ea(Da+ea(ua*Fa));Fa=ea(g[s+(e*12|0)+8>>2]);Da=ea(Ka+ea(Ia+ea(wa*Fa)));Ia=ea(Ha+ea(Ca+ea(ra*Fa)));g[u+(e*12|0)>>2]=ea(sa+ea(za+ea(na*Fa)));g[u+(e*12|0)+4>>2]=Da;g[u+(e*12|0)+8>>2]=Ia;Ia=ea(g[t+(e*12|0)>>2]);Da=ea(Ea*Ia);Fa=ea(ya*Ia);za=ea(Ja*Ia);Ia=ea(g[t+(e*12|0)+4>>2]);Ca=ea(Da+ea(va*Ia));Da=ea(Fa+ea(xa*Ia));Fa=ea(za+ea(ua*Ia));Ia=ea(g[t+(e*12|0)+8>>2]);za=ea(Da+ea(wa*Ia));Da=ea(Fa+ea(ra*Ia));g[v+(e*12|0)>>2]=ea(Ca+ea(na*Ia));g[v+(e*12|0)+4>>2]=za;g[v+(e*12|0)+8>>2]=Da;e=e+1|0}while((e|0)!=8);Da=ea(g[u>>2]);za=ea(g[u+4>>2]);Ia=ea(g[u+8>>2]);Ca=Da;Fa=Da;Da=za;Ba=za;za=Ia;Aa=Ia;e=1;do{t=u+(e*12|0)|0;Ia=ea(g[t>>2]);Ca=Ca<Ia?Ca:Ia;Fa=Fa>Ia?Fa:Ia;Ia=ea(g[t+4>>2]);Da=Da<Ia?Da:Ia;Ba=Ba>Ia?Ba:Ia;Ia=ea(g[t+8>>2]);za=za<Ia?za:Ia;Aa=Aa>Ia?Aa:Ia;e=e+1|0}while((e|0)!=8);e=D+40|0;t=ea(g[e>>2])<=ea(0.0);Ia=ea(g[o>>2]);pa=ea(g[f>>2]);if(ea(g[H>>2])<ea(0.0)){La=~~ea(R(ea(Ia*Fa)));h=c[D+16>>2]|0;j=h+-2|0;Ma=(La|0)>0?La:0;La=~~ea(ca(ea(Ia*Ca)));Na=h+-1|0;h=(La|0)>0?La:0;Oa=(h|0)>(Na|0)?Na:h;Pa=(Ma|0)>(j|0)?j:Ma}else{Ma=~~ea(R(ea(Ia*Ca)));j=c[D+16>>2]|0;h=j+-2|0;Na=(Ma|0)>0?Ma:0;Ma=~~ea(ca(ea(Ia*Fa)));La=j+-1|0;j=(Ma|0)>0?Ma:0;Oa=(j|0)>(La|0)?La:j;Pa=(Na|0)>(h|0)?h:Na}if(ea(g[I>>2])<ea(0.0)){Na=~~ea(R(ea(pa*Aa)));h=c[D+20>>2]|0;j=h+-2|0;La=(Na|0)>0?Na:0;Na=~~ea(ca(ea(pa*za)));Ma=h+-1|0;h=(Na|0)>0?Na:0;Qa=(h|0)>(Ma|0)?Ma:h;Ra=(La|0)>(j|0)?j:La}else{La=~~ea(R(ea(pa*za)));j=c[D+20>>2]|0;h=j+-2|0;Ma=(La|0)>0?La:0;La=~~ea(ca(ea(pa*Aa)));Na=j+-1|0;j=(La|0)>0?La:0;Qa=(j|0)>(Na|0)?Na:j;Ra=(Ma|0)>(h|0)?h:Ma}Aa=ea(yRa(D,Pa,Oa,Ra,Qa));za=ea(Aa*ea(g[G>>2]));if(t){if(Da>za){Sa=0;i=l;return Sa|0}Ma=y+4|0;h=y+8|0;j=m+4096|0;Na=0;do{do if(((((c[v+(Na*12|0)+4>>2]|0)<=0?(La=u+(Na*12|0)+4|0,Da=ea(g[k>>2]),ea(g[La>>2])<ea(za+Da)):0)?(Da=ea(g[u+(Na*12|0)>>2]),Aa=ea(g[u+(Na*12|0)+8>>2]),Fa=ea(Da*ea(g[o>>2])),Ca=ea(Aa*ea(g[f>>2])),!(!(Fa>=ea(0.0))|!(Ca>=ea(0.0)))):0)?(Ta=c[E>>2]|0,Fa<ea(ea(g[Ta+24>>2])+ea(1.0))):0)?Ca<ea(ea(g[Ta+28>>2])+ea(1.0)):0){Ua=xRa(Ta,ea(Ia*Da),ea(pa*Aa),w,x)|0;Aa=ea(g[w>>2]);Da=ea(g[x>>2]);Ca=ea(g[(c[F>>2]|0)+8>>2]);Fa=ea(Ca*ea(t1a(c[E>>2]|0,Ua,Aa,Da)));Ca=ea(ea(g[La>>2])-Fa);Fa=ea(g[k>>2]);Ga=ea(g[e>>2]);if(!(Ga<=ea(0.0))|!(Ca<=Fa)|!(Ga<=Ca)){if(!(Ga>ea(0.0)))break;if(!(Ca>ea(-Fa)&Ga>Ca))break}La=BRa(o,Ua,Aa,Da)|0;if((La|0)!=-1){Da=ea(g[w>>2]);u1a(y,o,Ua,Da,ea(g[x>>2]));Da=ea(g[y>>2]);Aa=ea(g[Ma>>2]);Ga=ea(g[h>>2]);Fa=ea(ea(ea(Da*Da)+ea(Aa*Aa))+ea(Ga*Ga));if(Fa>ea(0.0)){ja=ea(ea(1.0)/ea(T(ea(Fa))));Va=ea(Aa*ja);Wa=ea(Da*ja);Xa=ea(Ga*ja)}else{Va=ea(0.0);Wa=ea(0.0);Xa=ea(0.0)}ja=ea(g[s+(Na*12|0)>>2]);Ga=ea(g[s+(Na*12|0)+4>>2]);Da=ea(g[s+(Na*12|0)+8>>2]);Ua=c[j>>2]|0;if(Ua>>>0<=63){Aa=ea(Ca*Va);Ca=ea(ea(ga*Xa)+ea(ea(_*Va)+ea(la*Wa)));Fa=ea(ea(ha*Xa)+ea(ea(P*Va)+ea(aa*Wa)));qa=ea(ea(W*Xa)+ea(ea(ma*Va)+ea(ba*Wa)));fa=ea(M+ea(ea(ea(Y*ja)+ea(L*Ga))+ea(Q*Da)));ta=ea(V+ea(ea(ea(N*ja)+ea(K*Ga))+ea(U*Da)));oa=ea(X+ea(ea(ea(O*ja)+ea(Z*Ga))+ea(J*Da)));c[j>>2]=Ua+1;g[m+(Ua<<6)>>2]=qa;g[m+(Ua<<6)+4>>2]=Fa;g[m+(Ua<<6)+8>>2]=Ca;g[m+(Ua<<6)+16>>2]=oa;g[m+(Ua<<6)+20>>2]=ta;g[m+(Ua<<6)+24>>2]=fa;g[m+(Ua<<6)+12>>2]=Aa;c[m+(Ua<<6)+48>>2]=-1;c[m+(Ua<<6)+52>>2]=La}}}while(0);Na=Na+1|0}while((Na|0)!=8);Ya=j}else{if(Ba<za){Sa=0;i=l;return Sa|0}j=y+4|0;Na=y+8|0;h=m+4096|0;Ma=0;do{do if(((((c[v+(Ma*12|0)+4>>2]|0)<=0?(La=u+(Ma*12|0)+4|0,Ba=ea(g[k>>2]),ea(g[La>>2])>ea(za-Ba)):0)?(Ba=ea(g[u+(Ma*12|0)>>2]),Wa=ea(g[u+(Ma*12|0)+8>>2]),Va=ea(Ba*ea(g[o>>2])),Xa=ea(Wa*ea(g[f>>2])),!(!(Va>=ea(0.0))|!(Xa>=ea(0.0)))):0)?(Ua=c[E>>2]|0,Va<ea(ea(g[Ua+24>>2])+ea(1.0))):0)?Xa<ea(ea(g[Ua+28>>2])+ea(1.0)):0){Ta=xRa(Ua,ea(Ia*Ba),ea(pa*Wa),w,x)|0;Wa=ea(g[w>>2]);Ba=ea(g[x>>2]);Xa=ea(g[(c[F>>2]|0)+8>>2]);Va=ea(Xa*ea(t1a(c[E>>2]|0,Ta,Wa,Ba)));Xa=ea(ea(g[La>>2])-Va);Va=ea(g[k>>2]);Aa=ea(g[e>>2]);if(!(Aa<=ea(0.0))|!(Xa<=Va)|!(Aa<=Xa)){if(!(Aa>ea(0.0)))break;if(!(Xa>ea(-Va)&Aa>Xa))break}La=BRa(o,Ta,Wa,Ba)|0;if((La|0)!=-1){Ba=ea(g[w>>2]);u1a(y,o,Ta,Ba,ea(g[x>>2]));Ba=ea(g[y>>2]);Wa=ea(g[j>>2]);Aa=ea(g[Na>>2]);Va=ea(ea(ea(Ba*Ba)+ea(Wa*Wa))+ea(Aa*Aa));if(Va>ea(0.0)){fa=ea(ea(1.0)/ea(T(ea(Va))));Za=ea(Wa*fa);_a=ea(Ba*fa);$a=ea(Aa*fa)}else{Za=ea(0.0);_a=ea(0.0);$a=ea(0.0)}fa=ea(g[s+(Ma*12|0)>>2]);Aa=ea(g[s+(Ma*12|0)+4>>2]);Ba=ea(g[s+(Ma*12|0)+8>>2]);Ta=c[h>>2]|0;if(Ta>>>0<=63){Wa=ea(Xa*Za);Xa=ea(ea(ga*$a)+ea(ea(_*Za)+ea(la*_a)));Va=ea(ea(ha*$a)+ea(ea(P*Za)+ea(aa*_a)));ta=ea(ea(W*$a)+ea(ea(ma*Za)+ea(ba*_a)));oa=ea(M+ea(ea(ea(Y*fa)+ea(L*Aa))+ea(Q*Ba)));Ca=ea(V+ea(ea(ea(N*fa)+ea(K*Aa))+ea(U*Ba)));Fa=ea(X+ea(ea(ea(O*fa)+ea(Z*Aa))+ea(J*Ba)));c[h>>2]=Ta+1;g[m+(Ta<<6)>>2]=ta;g[m+(Ta<<6)+4>>2]=Va;g[m+(Ta<<6)+8>>2]=Xa;g[m+(Ta<<6)+16>>2]=Fa;g[m+(Ta<<6)+20>>2]=Ca;g[m+(Ta<<6)+24>>2]=oa;g[m+(Ta<<6)+12>>2]=Wa;c[m+(Ta<<6)+48>>2]=-1;c[m+(Ta<<6)+52>>2]=La}}}while(0);Ma=Ma+1|0}while((Ma|0)!=8);Ya=h}h=n+4|0;Ma=n+8|0;s=n+12|0;Na=n+16|0;j=n+20|0;y=n+24|0;x=n+28|0;w=n+32|0;F=n+36|0;f=n+40|0;La=n+44|0;Ta=n+48|0;Ua=n+52|0;ab=n+56|0;bb=n+60|0;cb=n+64|0;db=n+68|0;eb=0;do{fb=eb<<1;gb=d[544064+fb>>0]|0;J=ea(g[v+(gb*12|0)+4>>2]);hb=d[544064+(fb|1)>>0]|0;do if(!(ea(J+ea(g[v+(hb*12|0)+4>>2]))>ea(0.0))){fb=u+(gb*12|0)|0;ib=u+(hb*12|0)|0;jb=ea(g[e>>2])!=ea(0.0);Z=ea(g[u+(gb*12|0)+4>>2]);if(jb){if(Z>za?ea(g[u+(hb*12|0)+4>>2])>za:0)break}else if(Z<za?ea(g[u+(hb*12|0)+4>>2])<za:0)break;O=ea(g[ib>>2]);X=ea(O-ea(g[fb>>2]));O=ea(ea(g[u+(hb*12|0)+4>>2])-Z);Z=ea(g[u+(hb*12|0)+8>>2]);U=ea(Z-ea(g[u+(gb*12|0)+8>>2]));Z=ea(g[k>>2]);g[n>>2]=X;g[h>>2]=O;g[Ma>>2]=U;c[s>>2]=m;g[Na>>2]=ba;g[j>>2]=aa;g[y>>2]=la;g[x>>2]=ma;g[w>>2]=P;g[F>>2]=_;g[f>>2]=W;g[La>>2]=ha;g[Ta>>2]=ga;g[Ua>>2]=ka;g[ab>>2]=ia;g[bb>>2]=$;g[cb>>2]=Z;c[db>>2]=-1;v1a(o,fb,ib,n,0)}while(0);eb=eb+1|0}while((eb|0)!=12);if(Pa>>>0<=Oa>>>0){eb=Ra>>>0>Qa>>>0;db=D+20|0;cb=D+36|0;D=z+4|0;bb=z+8|0;ab=A+4|0;Ua=A+8|0;Ta=B+4|0;La=B+8|0;f=n+4|0;F=n+8|0;w=C+4|0;x=C+8|0;y=Pa;do{if(!eb){za=ea(y>>>0);Pa=Ra;do{j=(da(c[db>>2]|0,y)|0)+Pa|0;a:do if((((a[(c[(c[E>>2]|0)+36>>2]|0)+(j<<2)+3>>0]|0)<0?(J=ea(za*ea(g[H>>2])),Z=ea(g[G>>2]),U=ea(Z*ea(b[(c[cb>>2]|0)+(j<<2)>>1]|0)),Z=ea(ea(Pa>>>0)*ea(g[I>>2])),O=ea(J-sa),X=ea(U-Ka),K=ea(Z-Ha),N=ea(ea(Ja*K)+ea(ea(Ea*O)+ea(ya*X))),V=ea(ea(ua*K)+ea(ea(va*O)+ea(xa*X))),Q=ea(ea(ra*K)+ea(ea(na*O)+ea(wa*X))),g[z>>2]=N,g[D>>2]=V,g[bb>>2]=Q,X=ea(S(ea(N))),N=ea(X-ea(g[r>>2])),X=ea(g[k>>2]),ea(N-X)<ea(0.0)):0)?(N=ea(S(ea(V))),ea(ea(N-ea(g[p>>2]))-X)<ea(0.0)):0)?(N=ea(S(ea(Q))),ea(ea(N-ea(g[q>>2]))-X)<ea(0.0)):0){CRa(A,o,j,y,Pa);X=ea(g[A>>2]);if(t){N=ea(g[ab>>2]);kb=X;lb=N;mb=ea(g[Ua>>2])}else{N=ea(-X);X=ea(-ea(g[ab>>2]));kb=N;lb=X;mb=ea(-ea(g[Ua>>2]))}X=ea(ea(mb*mb)+ea(ea(lb*lb)+ea(kb*kb)));if(X>ea(0.0)){N=ea(ea(1.0)/ea(T(ea(X))));nb=ea(kb*N);ob=ea(lb*N);pb=ea(mb*N)}else{nb=ea(0.0);ob=ea(0.0);pb=ea(0.0)}N=ea(-ea(ea(Ja*pb)+ea(ea(ya*ob)+ea(Ea*nb))));X=ea(-ea(ea(ua*pb)+ea(ea(xa*ob)+ea(va*nb))));Q=ea(-ea(ea(ra*pb)+ea(ea(wa*ob)+ea(na*nb))));g[B>>2]=N;g[Ta>>2]=X;g[La>>2]=Q;V=ea(0.0);O=ea(0.0);K=ea(0.0);L=ea(-3402823469999999843913219.0e14);Y=ea(-3402823469999999843913219.0e14);Na=0;s=-1;Ma=-2;while(1){h=(Na>>>0)%3|0;M=Na>>>0>2?ea(-1.0):ea(1.0);g[n>>2]=ea(0.0);g[f>>2]=ea(0.0);g[F>>2]=ea(0.0);g[n+(h<<2)>>2]=M;_a=ea(M*ea(g[B+(h<<2)>>2]));Za=ea(g[z+(h<<2)>>2]);$a=ea(M*ea(Za-ea(M*ea(g[r+(h<<2)>>2]))));if($a>=ea(0.0))break a;do if(_a>ea(0.0)){if($a>L){M=ea(g[n>>2]);Za=ea(g[f>>2]);qb=ea(g[F>>2]);rb=Za;sb=M;tb=$a;ub=Na}else{qb=K;rb=O;sb=V;tb=L;ub=s}M=ea($a/_a);if(!(M>Y)){vb=qb;wb=rb;xb=sb;yb=tb;zb=Y;Ab=ub;Bb=Ma;break}vb=qb;wb=rb;xb=sb;yb=tb;zb=M;Ab=ub;Bb=Na}else{vb=K;wb=O;xb=V;yb=L;zb=Y;Ab=s;Bb=Ma}while(0);Na=Na+1|0;if(Na>>>0>=6)break;else{V=xb;O=wb;K=vb;L=yb;Y=zb;s=Ab;Ma=Bb}}Ma=(Ab|0)==(Bb|0);Y=Ma?yb:zb;L=ea(-(Ma?xb:N));K=ea(-(Ma?wb:X));O=ea(-(Ma?vb:Q));V=ea(ea(wa*O)+ea(ea(xa*K)+ea(ya*L)));_a=ea(ea(ra*O)+ea(ea(ua*K)+ea(Ja*L)));g[C>>2]=ea(ea(na*O)+ea(ea(va*K)+ea(Ea*L)));g[w>>2]=V;g[x>>2]=_a;w1a(o,C,j,y,Pa)|0;_a=ea(g[C>>2]);V=ea(nb*_a);L=ea(g[w>>2]);K=ea(V+ea(ob*L));V=ea(g[x>>2]);if(!(ea(K+ea(pb*V))<ea(1.1920929e-07))){K=ea(ea(ea(_a*_a)+ea(L*L))+ea(V*V));if(K>ea(0.0)){O=ea(ea(1.0)/ea(T(ea(K))));Cb=ea(_a*O);Db=ea(L*O);Eb=ea(V*O)}else{Cb=ea(0.0);Db=ea(0.0);Eb=ea(0.0)}g[C>>2]=Cb;g[w>>2]=Db;g[x>>2]=Eb;Ma=GRa(o,j,y,Pa)|0;O=ea(g[C>>2]);V=ea(g[w>>2]);L=ea(g[x>>2]);s=c[Ya>>2]|0;if(s>>>0<=63){_a=ea(ea(ea(la*O)+ea(_*V))+ea(ga*L));K=ea(ea(ea(aa*O)+ea(P*V))+ea(ha*L));$a=ea(ea(ea(ba*O)+ea(ma*V))+ea(W*L));L=ea($+ea(ea(ga*Z)+ea(ea(la*J)+ea(_*U))));V=ea(ia+ea(ea(ha*Z)+ea(ea(aa*J)+ea(P*U))));O=ea(ka+ea(ea(W*Z)+ea(ea(ba*J)+ea(ma*U))));c[Ya>>2]=s+1;g[m+(s<<6)>>2]=$a;g[m+(s<<6)+4>>2]=K;g[m+(s<<6)+8>>2]=_a;g[m+(s<<6)+16>>2]=O;g[m+(s<<6)+20>>2]=V;g[m+(s<<6)+24>>2]=L;g[m+(s<<6)+12>>2]=Y;c[m+(s<<6)+48>>2]=-1;c[m+(s<<6)+52>>2]=Ma}}}while(0);Pa=Pa+1|0}while(Pa>>>0<=Qa>>>0)}y=y+1|0}while(y>>>0<=Oa>>>0)}Sa=(c[Ya>>2]|0)!=0;i=l;return Sa|0}function uya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=UNa(a,b,c,d,e,f,g)|0;i=h;return j|0}function vya(a,b,e,f,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=0,Sa=0,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=0,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=0,Ib=0;j=i;i=i+304|0;l=j+132|0;m=j+120|0;n=j+180|0;o=j+152|0;p=j+148|0;q=j+168|0;r=j+192|0;s=j+208|0;t=j+72|0;u=j+12|0;v=j+144|0;w=j+96|0;x=j;y=j+108|0;z=ea(g[e>>2]);A=ea(z*ea(2.0));B=ea(g[e+12>>2]);C=ea(B*ea(2.0));D=ea(ea(z*A)+ea(ea(B*C)+ea(-1.0)));B=ea(g[e+8>>2]);z=ea(B*C);E=ea(g[e+4>>2]);F=ea(z+ea(A*E));z=ea(ea(A*B)-ea(C*E));E=ea(g[a+8>>2]);C=ea(E*D);D=ea(E*F);F=ea(E*z);z=ea(g[e+16>>2]);E=ea(z+C);B=ea(g[e+20>>2]);A=ea(B+D);G=ea(g[e+24>>2]);H=ea(F+G);g[t>>2]=E;e=t+4|0;g[e>>2]=A;I=t+8|0;g[I>>2]=H;H=ea(B-D);D=ea(G-F);J=t+12|0;g[J>>2]=ea(z-C);K=t+16|0;g[K>>2]=H;L=t+20|0;g[L>>2]=D;M=a+4|0;D=ea(g[M>>2]);H=ea(D+ea(g[h>>2]));D=ea(g[f>>2]);C=ea(g[f+4>>2]);z=ea(g[f+8>>2]);F=ea(g[f+12>>2]);G=ea(D+D);B=ea(C+C);A=ea(z+z);E=ea(C*B);N=ea(z*A);O=ea(G*C);C=ea(G*z);P=ea(G*F);Q=ea(B*z);z=ea(B*F);B=ea(A*F);F=ea(O+B);A=ea(C-z);R=ea(O-B);B=ea(ea(1.0)-ea(D*G));G=ea(B-N);D=ea(Q+P);O=ea(C+z);z=ea(Q-P);P=ea(B-E);g[u>>2]=ea(ea(ea(1.0)-E)-N);a=u+4|0;g[a>>2]=F;U=u+8|0;g[U>>2]=A;V=u+12|0;g[V>>2]=R;W=u+16|0;g[W>>2]=G;X=u+20|0;g[X>>2]=D;Y=u+24|0;g[Y>>2]=O;Z=u+28|0;g[Z>>2]=z;_=u+32|0;g[_>>2]=P;$=u+36|0;g[$>>2]=ea(g[f+16>>2]);aa=u+40|0;g[aa>>2]=ea(g[f+20>>2]);ba=u+44|0;g[ba>>2]=ea(g[f+24>>2]);f=u+48|0;g[f>>2]=ea(g[b+4>>2]);ca=u+52|0;g[ca>>2]=ea(g[b+8>>2]);da=u+56|0;g[da>>2]=ea(g[b+12>>2]);b=u+36|0;fa=u+48|0;P=ea(LOa(t,t+12|0,b,fa,u,v,w));if(P>=ea(H*H)){ga=0;i=j;return ga|0}if(P!=ea(0.0)){H=ea(g[v>>2]);z=ea(g[J>>2]);O=ea(g[t>>2]);D=ea(z-O);G=ea(g[K>>2]);R=ea(g[e>>2]);A=ea(G-R);F=ea(g[L>>2]);N=ea(g[I>>2]);E=ea(O+ea(H*D));D=ea(R+ea(H*A));A=ea(N+ea(H*ea(F-N)));H=ea(g[w>>2]);B=ea(g[u>>2]);Q=ea(H*B);C=ea(g[a>>2]);ha=ea(H*C);ia=ea(g[U>>2]);ja=ea(H*ia);v=w+4|0;H=ea(g[v>>2]);ka=ea(g[V>>2]);la=ea(H*ka);ma=ea(g[W>>2]);na=ea(H*ma);oa=ea(g[X>>2]);pa=ea(Q+la);la=ea(ha+na);na=ea(ja+ea(H*oa));qa=w+8|0;H=ea(g[qa>>2]);ja=ea(g[Y>>2]);ha=ea(H*ja);Q=ea(g[Z>>2]);ra=ea(H*Q);sa=ea(g[_>>2]);ta=ea(pa+ha);ha=ea(la+ra);ra=ea(na+ea(H*sa));H=ea(g[b>>2]);na=ea(ta+H);ta=ea(g[aa>>2]);la=ea(ha+ta);ha=ea(g[ba>>2]);pa=ea(ra+ha);g[w>>2]=na;g[v>>2]=la;g[qa>>2]=pa;ra=ea(E-na);na=ea(D-la);la=ea(A-pa);g[x>>2]=ra;ua=x+4|0;g[ua>>2]=na;va=x+8|0;g[va>>2]=la;pa=ea(T(ea(ea(la*la)+ea(ea(ra*ra)+ea(na*na)))));if(pa>ea(0.0)){A=ea(ea(1.0)/pa);g[x>>2]=ea(ra*A);g[ua>>2]=ea(A*na);g[va>>2]=ea(A*la);la=ea(g[M>>2]);x1a(k,t,la,u,x,ea(g[h>>2]));wa=k+4096|0;if((c[wa>>2]|0)==2){ga=1;i=j;return ga|0}la=ea(g[M>>2]);A=ea(g[h>>2]);xa=SKa()|0;TKa(s,b,fa,u,u+12|0,u+24|0);na=ea(g[t>>2]);g[l>>2]=na;ya=l+4|0;ra=ea(g[e>>2]);g[ya>>2]=ra;za=l+8|0;pa=ea(g[I>>2]);g[za>>2]=pa;D=ea(g[J>>2]);g[m>>2]=D;Aa=m+4|0;E=ea(g[K>>2]);g[Aa>>2]=E;Ba=m+8|0;Ca=ea(g[L>>2]);g[Ba>>2]=Ca;Da=ea(D-na);Ea=ea(E-ra);Fa=ea(Ca-pa);Ga=ea(T(ea(ea(ea(Da*Da)+ea(Ea*Ea))+ea(Fa*Fa))));if(Ga>ea(0.0)){Ha=ea(ea(.00999999977)/Ga);Ga=ea(Da*Ha);Da=ea(Ea*Ha);Ea=ea(Fa*Ha);Ha=ea(na-Ga);g[l>>2]=Ha;Fa=ea(ra-Da);g[ya>>2]=Fa;Ia=ea(pa-Ea);g[za>>2]=Ia;Ja=ea(D+Ga);g[m>>2]=Ja;Ga=ea(E+Da);g[Aa>>2]=Ga;Da=ea(Ca+Ea);g[Ba>>2]=Da;Ka=Ja;La=Ha;Ma=Ga;Na=Fa;Oa=Da;Pa=Ia}else{Ka=D;La=na;Ma=E;Na=ra;Oa=Ca;Pa=pa}pa=ea(Ka-La);Ka=ea(Ma-Na);Ma=ea(Oa-Pa);g[n>>2]=pa;g[n+4>>2]=Ka;g[n+8>>2]=Ma;Oa=ea(g[va>>2]);Ca=ea(Ka*Oa);ra=ea(g[ua>>2]);E=ea(Ca-ea(Ma*ra));Ca=ea(g[x>>2]);na=ea(-E);E=ea(-ea(ea(Ma*Ca)-ea(Oa*pa)));Ma=ea(-ea(ea(pa*ra)-ea(Ka*Ca)));g[o>>2]=na;g[o+4>>2]=E;g[o+8>>2]=Ma;g[o+12>>2]=ea(-ea(ea(Pa*Ma)+ea(ea(La*na)+ea(Na*E))));Na=ea(S(ea(na)));na=ea(S(ea(E)));E=ea(S(ea(Ma)));if(!(na>Na&na>E))if(E>Na){Qa=1;Ra=0}else{Qa=2;Ra=1}else{Qa=0;Ra=2}Na=ea(g[n+(Qa<<2)>>2]);E=ea(Na*ea(g[x+(Ra<<2)>>2]));Na=ea(g[n+(Ra<<2)>>2]);na=ea(ea(1.0)/ea(E-ea(Na*ea(g[x+(Qa<<2)>>2]))));ua=r+4|0;va=r+8|0;Na=ea(la+A);Ba=q+8|0;Aa=q+4|0;A=ea(g[x>>2]);x=xa;xa=1;while(1){za=d[x>>0]|0;ya=x+2|0;Sa=d[x+1>>0]|0;E=ea(-ra);Ma=ea(-Oa);g[r>>2]=ea(-A);g[ua>>2]=E;g[va>>2]=Ma;Ma=ea(g[s+(za*12|0)>>2]);E=ea(g[s+(za*12|0)+4>>2]);La=ea(g[s+(za*12|0)+8>>2]);Pa=ea(g[s+(Sa*12|0)>>2]);Ca=ea(g[s+(Sa*12|0)+4>>2]);if((y1a(l,m,n,o,Ra,Qa,na,r,Ma,E,La,Pa,Ca,ea(g[s+(Sa*12|0)+8>>2]),p,q)|0?(Ca=ea(g[p>>2]),Ca<Na):0)?(Sa=c[wa>>2]|0,Sa>>>0<=63):0){Pa=ea(g[Ba>>2]);La=ea(g[Aa>>2]);E=ea(Ca-la);Ma=ea(Pa-ea(Ca*Oa));Pa=ea(La-ea(Ca*ra));La=ea(ea(g[q>>2])-ea(Ca*A));c[wa>>2]=Sa+1;g[k+(Sa<<6)>>2]=A;g[k+(Sa<<6)+4>>2]=ra;g[k+(Sa<<6)+8>>2]=Oa;g[k+(Sa<<6)+16>>2]=La;g[k+(Sa<<6)+20>>2]=Pa;g[k+(Sa<<6)+24>>2]=Ma;g[k+(Sa<<6)+12>>2]=E;c[k+(Sa<<6)+48>>2]=-1;c[k+(Sa<<6)+52>>2]=-1}if((xa|0)==12)break;x=ya;xa=xa+1|0}if(c[wa>>2]|0){ga=1;i=j;return ga|0}la=ea(T(ea(P)));P=ea(la-ea(g[M>>2]));c[wa>>2]=1;g[k>>2]=A;g[k+4>>2]=ra;g[k+8>>2]=Oa;g[k+16>>2]=ea(g[w>>2]);g[k+20>>2]=ea(g[v>>2]);g[k+24>>2]=ea(g[qa>>2]);g[k+12>>2]=P;c[k+48>>2]=-1;c[k+52>>2]=-1;ga=1;i=j;return ga|0}else{Ta=O;Ua=R;Va=N;Wa=z;Xa=G;Ya=F;Za=H;_a=ta;$a=ha;ab=B;bb=C;cb=ia;db=ka;eb=ma;fb=oa;gb=ja;hb=Q;ib=sa}}else{sa=ea(g[t>>2]);Q=ea(g[e>>2]);ja=ea(g[I>>2]);oa=ea(g[J>>2]);ma=ea(g[K>>2]);ka=ea(g[L>>2]);ia=ea(g[$>>2]);C=ea(g[aa>>2]);B=ea(g[ba>>2]);ha=ea(g[u>>2]);ta=ea(g[a>>2]);H=ea(g[U>>2]);F=ea(g[V>>2]);G=ea(g[W>>2]);z=ea(g[X>>2]);N=ea(g[Y>>2]);R=ea(g[Z>>2]);Ta=sa;Ua=Q;Va=ja;Wa=oa;Xa=ma;Ya=ka;Za=ia;_a=C;$a=B;ab=ha;bb=ta;cb=H;db=F;eb=G;fb=z;gb=N;hb=R;ib=ea(g[_>>2])}R=ea(g[M>>2]);N=ea(g[f>>2]);z=ea(g[ca>>2]);G=ea(g[da>>2]);F=ea(0.0);H=ea(0.0);ta=ea(0.0);ha=ea(3402823469999999843913219.0e14);da=0;while(1){B=ea(g[u+(da*12|0)>>2]);C=ea(g[u+(da*12|0)+4>>2]);ia=ea(g[u+(da*12|0)+8>>2]);ka=ea(ea(ea(B*Ta)+ea(C*Ua))+ea(ia*Va));ma=ea(ea(ea(B*Wa)+ea(C*Xa))+ea(ia*Ya));ca=ka>ma;oa=ea((ca?ma:ka)-R);ja=ea(R+(ca?ka:ma));ma=ea(ea(ea(B*Za)+ea(C*_a))+ea(ia*$a));ka=ea(ea(ea(ea(S(ea(ea(ea(B*ab)+ea(C*bb))+ea(ia*cb))))*N)+ea(ea(S(ea(ea(ea(B*db)+ea(C*eb))+ea(ia*fb))))*z))+ea(ea(S(ea(ea(ea(B*gb)+ea(C*hb))+ea(ia*ib))))*G));Q=ea(ma-ka);sa=ea(ma+ka);if(ja<Q|sa<oa){ga=0;jb=52;break}ka=ea(ja-Q);Q=ea(sa-oa);oa=ka<Q?ka:Q;if(oa<ha){kb=ia;lb=C;mb=B;nb=oa}else{kb=ta;lb=H;mb=F;nb=ha}da=da+1|0;if(da>>>0>=3)break;else{F=mb;H=lb;ta=kb;ha=nb}}if((jb|0)==52){i=j;return ga|0}ha=ea(Wa-Ta);ta=ea(Xa-Ua);H=ea(Ya-Va);F=ea(ea(ea(ha*ha)+ea(ta*ta))+ea(H*H));if(F>ea(0.0)){oa=ea(ea(1.0)/ea(T(ea(F))));ob=ea(ta*oa);pb=ea(H*oa);qb=ea(ha*oa)}else{ob=ea(0.0);pb=ea(0.0);qb=ea(0.0)}oa=mb;mb=lb;lb=kb;kb=nb;da=0;while(1){nb=ea(g[u+(da*12|0)+8>>2]);ha=ea(ob*nb);H=ea(g[u+(da*12|0)+4>>2]);ta=ea(ha-ea(pb*H));ha=ea(g[u+(da*12|0)>>2]);F=ea(ea(pb*ha)-ea(qb*nb));nb=ea(ea(qb*H)-ea(ob*ha));if((!(+ea(S(ea(ta)))>1.0e-06)?!(+ea(S(ea(F)))>1.0e-06):0)?!(+ea(S(ea(nb)))>1.0e-06):0){rb=oa;sb=mb;tb=lb;ub=kb}else{ha=ea(ea(nb*nb)+ea(ea(ta*ta)+ea(F*F)));if(ha>ea(0.0)){H=ea(ea(1.0)/ea(T(ea(ha))));vb=ea(ta*H);wb=ea(F*H);xb=ea(nb*H)}else{vb=ea(0.0);wb=ea(0.0);xb=ea(0.0)}H=ea(ea(ea(vb*Ta)+ea(wb*Ua))+ea(xb*Va));nb=ea(ea(ea(vb*Wa)+ea(wb*Xa))+ea(xb*Ya));ca=H>nb;F=ea((ca?nb:H)-R);ta=ea(R+(ca?H:nb));nb=ea(ea(ea(vb*Za)+ea(wb*_a))+ea(xb*$a));H=ea(ea(ea(ea(S(ea(ea(ea(vb*ab)+ea(wb*bb))+ea(xb*cb))))*N)+ea(ea(S(ea(ea(ea(vb*db)+ea(wb*eb))+ea(xb*fb))))*z))+ea(ea(S(ea(ea(ea(vb*gb)+ea(wb*hb))+ea(xb*ib))))*G));ha=ea(nb-H);B=ea(nb+H);if(ta<ha|B<F){ga=0;jb=52;break}H=ea(ta-ha);ha=ea(B-F);F=H<ha?H:ha;if(F<kb){rb=vb;sb=wb;tb=xb;ub=F}else{rb=oa;sb=mb;tb=lb;ub=kb}}da=da+1|0;if(da>>>0>=3)break;else{oa=rb;mb=sb;lb=tb;kb=ub}}if((jb|0)==52){i=j;return ga|0}if(ea(ea(ea(rb*ea(ea(ea(Ta+Wa)*ea(.5))-Za))+ea(sb*ea(ea(ea(Ua+Xa)*ea(.5))-_a)))+ea(tb*ea(ea(ea(Va+Ya)*ea(.5))-$a)))<ea(0.0)){yb=ea(-rb);zb=ea(-sb);Ab=ea(-tb)}else{yb=rb;zb=sb;Ab=tb}g[y>>2]=yb;jb=y+4|0;g[jb>>2]=zb;da=y+8|0;g[da>>2]=Ab;x1a(k,t,R,u,y,ea(g[h>>2]));h=k+4096|0;if((c[h>>2]|0)==2){ga=1;i=j;return ga|0}R=ea(g[M>>2]);ca=SKa()|0;TKa(s,b,fa,u,u+12|0,u+24|0);Ab=ea(g[t>>2]);g[l>>2]=Ab;u=l+4|0;zb=ea(g[e>>2]);g[u>>2]=zb;fa=l+8|0;yb=ea(g[I>>2]);g[fa>>2]=yb;tb=ea(g[J>>2]);g[m>>2]=tb;b=m+4|0;sb=ea(g[K>>2]);g[b>>2]=sb;f=m+8|0;rb=ea(g[L>>2]);g[f>>2]=rb;$a=ea(tb-Ab);Ya=ea(sb-zb);Va=ea(rb-yb);_a=ea(T(ea(ea(ea($a*$a)+ea(Ya*Ya))+ea(Va*Va))));if(_a>ea(0.0)){Xa=ea(ea(.00999999977)/_a);_a=ea($a*Xa);$a=ea(Ya*Xa);Ya=ea(Va*Xa);Xa=ea(Ab-_a);g[l>>2]=Xa;Va=ea(zb-$a);g[u>>2]=Va;Ua=ea(yb-Ya);g[fa>>2]=Ua;Za=ea(tb+_a);g[m>>2]=Za;_a=ea(sb+$a);g[b>>2]=_a;$a=ea(rb+Ya);g[f>>2]=$a;Bb=Za;Cb=Xa;Db=_a;Eb=Va;Fb=$a;Gb=Ua}else{Bb=tb;Cb=Ab;Db=sb;Eb=zb;Fb=rb;Gb=yb}yb=ea(Bb-Cb);Bb=ea(Db-Eb);Db=ea(Fb-Gb);g[n>>2]=yb;g[n+4>>2]=Bb;g[n+8>>2]=Db;Fb=ea(g[da>>2]);rb=ea(Bb*Fb);zb=ea(g[jb>>2]);sb=ea(rb-ea(Db*zb));rb=ea(g[y>>2]);Ab=ea(ea(Db*rb)-ea(Fb*yb));Fb=ea(ea(yb*zb)-ea(Bb*rb));g[o>>2]=sb;g[o+4>>2]=Ab;g[o+8>>2]=Fb;g[o+12>>2]=ea(-ea(ea(Gb*Fb)+ea(ea(Cb*sb)+ea(Eb*Ab))));Eb=ea(S(ea(sb)));sb=ea(S(ea(Ab)));Ab=ea(S(ea(Fb)));if(!(sb>Eb&sb>Ab))if(Ab>Eb){Hb=0;Ib=1}else{Hb=1;Ib=2}else{Hb=2;Ib=0}Eb=ea(g[n+(Hb<<2)>>2]);Ab=ea(Eb*ea(g[y+(Ib<<2)>>2]));Eb=ea(g[n+(Ib<<2)>>2]);sb=ea(ea(1.0)/ea(Ab-ea(Eb*ea(g[y+(Hb<<2)>>2]))));f=q+8|0;b=q+4|0;fa=ca;ca=0;do{u=d[fa>>0]|0;_=d[fa+1>>0]|0;fa=fa+2|0;Eb=ea(g[s+(u*12|0)>>2]);Ab=ea(g[s+(u*12|0)+4>>2]);Fb=ea(g[s+(u*12|0)+8>>2]);Cb=ea(g[s+(_*12|0)>>2]);Gb=ea(g[s+(_*12|0)+4>>2]);if(y1a(l,m,n,o,Hb,Ib,sb,y,Eb,Ab,Fb,Cb,Gb,ea(g[s+(_*12|0)+8>>2]),p,q)|0?(Gb=ea(g[p>>2]),_=c[h>>2]|0,_>>>0<=63):0){Cb=ea(g[da>>2]);Fb=ea(g[jb>>2]);Ab=ea(g[y>>2]);Eb=ea(R+Gb);rb=ea(g[f>>2]);Bb=ea(g[b>>2]);zb=ea(-Eb);Eb=ea(rb-ea(Gb*Cb));rb=ea(Bb-ea(Gb*Fb));Bb=ea(ea(g[q>>2])-ea(Gb*Ab));c[h>>2]=_+1;g[k+(_<<6)>>2]=Ab;g[k+(_<<6)+4>>2]=Fb;g[k+(_<<6)+8>>2]=Cb;g[k+(_<<6)+16>>2]=Bb;g[k+(_<<6)+20>>2]=rb;g[k+(_<<6)+24>>2]=Eb;g[k+(_<<6)+12>>2]=zb;c[k+(_<<6)+48>>2]=-1;c[k+(_<<6)+52>>2]=-1}ca=ca+1|0}while((ca|0)!=12);if(c[h>>2]|0){ga=1;i=j;return ga|0}R=ea(g[t>>2]);sb=ea(R+ea(g[J>>2]));R=ea(g[e>>2]);zb=ea(R+ea(g[K>>2]));R=ea(g[I>>2]);Eb=ea(sb*ea(.5));sb=ea(zb*ea(.5));zb=ea(ea(R+ea(g[L>>2]))*ea(.5));R=ea(-ea(ub+ea(g[M>>2])));c[h>>2]=1;g[k>>2]=ea(g[y>>2]);g[k+4>>2]=ea(g[jb>>2]);g[k+8>>2]=ea(g[da>>2]);g[k+16>>2]=Eb;g[k+20>>2]=sb;g[k+24>>2]=zb;g[k+12>>2]=R;c[k+48>>2]=-1;c[k+52>>2]=-1;ga=1;i=j;return ga|0}function wya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=0,Ea=Im,Fa=Im,Ga=Im;h=i;i=i+128|0;k=h+16|0;l=h+88|0;m=h+92|0;n=h+96|0;o=h+8|0;p=h;q=h+64|0;r=ea(g[d>>2]);s=ea(r*ea(2.0));t=ea(g[d+12>>2]);u=ea(t*ea(2.0));v=ea(ea(r*s)+ea(ea(t*u)+ea(-1.0)));t=ea(g[d+8>>2]);r=ea(t*u);w=ea(g[d+4>>2]);x=ea(r+ea(s*w));r=ea(ea(s*t)-ea(u*w));w=ea(g[a+8>>2]);u=ea(w*v);v=ea(w*x);x=ea(w*r);g[k>>2]=u;y=k+4|0;g[y>>2]=v;z=k+8|0;g[z>>2]=x;r=ea(-v);v=ea(-x);A=k+12|0;g[A>>2]=ea(-u);B=k+16|0;g[B>>2]=r;C=k+20|0;g[C>>2]=v;D=k+24|0;v=ea(g[e>>2]);r=ea(v*ea(2.0));u=ea(g[e+12>>2]);x=ea(u*ea(2.0));w=ea(ea(v*r)+ea(ea(u*x)+ea(-1.0)));u=ea(g[e+8>>2]);v=ea(u*x);t=ea(g[e+4>>2]);s=ea(v+ea(r*t));v=ea(ea(r*u)-ea(x*t));t=ea(g[b+8>>2]);x=ea(t*w);w=ea(t*s);s=ea(t*v);E=k+28|0;F=k+32|0;G=k+36|0;H=k+40|0;I=k+44|0;v=ea(g[e+16>>2]);J=d+16|0;t=ea(v-ea(g[J>>2]));v=ea(g[e+20>>2]);K=d+20|0;u=ea(v-ea(g[K>>2]));v=ea(g[e+24>>2]);e=d+24|0;r=ea(v-ea(g[e>>2]));g[G>>2]=ea(t-x);g[H>>2]=ea(u-w);g[I>>2]=ea(r-s);g[D>>2]=ea(t+x);g[E>>2]=ea(u+w);g[F>>2]=ea(r+s);s=ea(NOa(k,D,l,m));d=a+4|0;r=ea(g[d>>2]);w=ea(r+ea(g[b+4>>2]));r=ea(w+ea(g[f>>2]));u=ea(r*r);if(!(s<u)){L=0;i=h;return L|0}r=ea(g[A>>2]);x=ea(g[k>>2]);t=ea(r-x);r=ea(g[B>>2]);v=ea(g[y>>2]);M=ea(r-v);r=ea(g[C>>2]);N=ea(g[z>>2]);O=ea(r-N);g[n>>2]=t;z=n+4|0;g[z>>2]=M;C=n+8|0;g[C>>2]=O;r=ea(g[G>>2]);P=ea(g[D>>2]);Q=ea(r-P);r=ea(g[H>>2]);R=ea(g[E>>2]);U=ea(r-R);r=ea(g[I>>2]);V=ea(g[F>>2]);W=ea(r-V);F=n+12|0;g[F>>2]=Q;I=n+16|0;g[I>>2]=U;E=n+20|0;g[E>>2]=W;r=ea(T(ea(ea(ea(t*t)+ea(M*M))+ea(O*O))));g[o>>2]=r;X=ea(T(ea(ea(ea(Q*Q)+ea(U*U))+ea(W*W))));g[o+4>>2]=X;if(r!=ea(0.0)){Y=ea(ea(1.0)/r);Z=ea(Y*t);g[n>>2]=Z;_=ea(Y*M);g[z>>2]=_;$=ea(Y*O);g[C>>2]=$;aa=Z;ba=_;ca=$}else{aa=t;ba=M;ca=O}if(X!=ea(0.0)){$=ea(ea(1.0)/X);_=ea($*Q);g[F>>2]=_;Z=ea($*U);g[I>>2]=Z;Y=ea($*W);g[E>>2]=Y;da=_;fa=Z;ga=Y}else{da=Q;fa=U;ga=W}if(ea(S(ea(ea(ea(aa*da)+ea(ba*fa))+ea(ca*ga))))>ea(.999800026)){ga=ea(r*ea(.00100000005));g[p>>2]=ga;g[p+4>>2]=ea(X*ea(.00100000005));E=q+12|0;I=q+16|0;F=q+4|0;C=q+20|0;z=q+8|0;H=j+4096|0;X=ga;ga=x;fa=v;da=N;Y=ba;Z=ca;D=0;G=0;while(1){y=1-D|0;B=k+(y*24|0)+12|0;A=k+(y*24|0)|0;f=q+(D*12|0)|0;ha=q+(D*12|0)+4|0;ia=q+(D*12|0)+8|0;_=ea(g[n+(D*12|0)>>2]);$=ea(-X);ja=o+(D<<2)|0;ka=q+(y*12|0)|0;la=q+(y*12|0)+4|0;ma=q+(y*12|0)+8|0;y=((D|0)!=1?b:a)+4|0;na=G;oa=0;while(1){pa=(oa|0)!=0?B:A;qa=ea(g[pa>>2]);g[f>>2]=qa;ra=ea(g[pa+4>>2]);g[ha>>2]=ra;sa=ea(g[pa+8>>2]);g[ia>>2]=sa;ta=ea(ea(ea(ea(qa-ga)*_)+ea(ea(ra-fa)*Y))+ea(ea(sa-da)*Z));if((ta>=$?ta<=ea(X+ea(g[ja>>2])):0)?(sa=ea(fa+ea(ta*Y)),ra=ea(da+ea(ta*Z)),g[ka>>2]=ea(ga+ea(ta*_)),g[la>>2]=sa,g[ma>>2]=ra,ra=ea(g[E>>2]),sa=ea(ra-ea(g[q>>2])),ta=ea(g[I>>2]),qa=ea(ta-ea(g[F>>2])),ua=ea(g[C>>2]),va=ea(ua-ea(g[z>>2])),wa=ea(ea(ea(sa*sa)+ea(qa*qa))+ea(va*va)),+wa>1.0e-06&wa<u):0){xa=ea(T(ea(wa)));wa=ea(ea(1.0)/xa);ya=ea(sa*wa);sa=ea(qa*wa);qa=ea(va*wa);wa=ea(g[y>>2]);pa=c[H>>2]|0;if(pa>>>0<=63){va=ea(qa*wa);za=ea(sa*wa);Aa=ea(ya*wa);wa=ea(g[e>>2]);Ba=ea(g[K>>2]);Ca=ea(xa-w);xa=ea(ea(ua-va)+wa);wa=ea(ea(ta-za)+Ba);Ba=ea(ea(ra-Aa)+ea(g[J>>2]));c[H>>2]=pa+1;g[j+(pa<<6)>>2]=ya;g[j+(pa<<6)+4>>2]=sa;g[j+(pa<<6)+8>>2]=qa;g[j+(pa<<6)+16>>2]=Ba;g[j+(pa<<6)+20>>2]=wa;g[j+(pa<<6)+24>>2]=xa;g[j+(pa<<6)+12>>2]=Ca;c[j+(pa<<6)+48>>2]=-1;c[j+(pa<<6)+52>>2]=-1}Da=na+1|0}else Da=na;oa=oa+1|0;if((oa|0)==2)break;else na=Da}na=D+1|0;if((na|0)==2)break;_=ea(g[k+(na*24|0)>>2]);$=ea(g[k+(na*24|0)+4>>2]);Ca=ea(g[k+(na*24|0)+8>>2]);xa=ea(g[n+(na*12|0)+4>>2]);wa=ea(g[n+(na*12|0)+8>>2]);X=ea(g[p+(na<<2)>>2]);ga=_;fa=$;da=Ca;Y=xa;Z=wa;D=na;G=Da}if(Da){L=1;i=h;return L|0}}Z=ea(g[l>>2]);Y=ea(x+ea(Z*t));t=ea(v+ea(Z*M));M=ea(N+ea(Z*O));O=ea(g[m>>2]);Z=ea(Y-ea(P+ea(O*Q)));Q=ea(t-ea(R+ea(O*U)));U=ea(M-ea(V+ea(O*W)));W=ea(ea(ea(Z*Z)+ea(Q*Q))+ea(U*U));if(+W<1.0e-06)if(+r>1.0e-06){Ea=ca;Fa=ba;Ga=aa}else{Ea=ea(0.0);Fa=ea(0.0);Ga=ea(1.0)}else{aa=ea(ea(1.0)/ea(T(ea(W))));Ea=ea(U*aa);Fa=ea(Q*aa);Ga=ea(Z*aa)}aa=ea(g[d>>2]);d=j+4096|0;m=c[d>>2]|0;if(m>>>0>63){L=1;i=h;return L|0}Z=ea(g[e>>2]);Q=ea(g[K>>2]);U=ea(ea(T(ea(s)))-w);w=ea(ea(M+Z)-ea(Ea*aa));Z=ea(ea(t+Q)-ea(Fa*aa));Q=ea(ea(Y+ea(g[J>>2]))-ea(Ga*aa));c[d>>2]=m+1;g[j+(m<<6)>>2]=Ga;g[j+(m<<6)+4>>2]=Fa;g[j+(m<<6)+8>>2]=Ea;g[j+(m<<6)+16>>2]=Q;g[j+(m<<6)+20>>2]=Z;g[j+(m<<6)+24>>2]=w;g[j+(m<<6)+12>>2]=U;c[j+(m<<6)+48>>2]=-1;c[j+(m<<6)+52>>2]=-1;L=1;i=h;return L|0}function xya(b,f,h,j,k,l,m){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=0,$=Im,aa=Im,ba=0,ca=Im,da=0,fa=Im,ga=0,ha=Im,ia=0,ja=0,ka=0,la=0,ma=Im,na=0,oa=Im,pa=0,qa=0,ra=Im,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=0,Oa=0,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=Im,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=0,Yb=0;l=i;i=i+9136|0;n=l+8820|0;o=l+240|0;p=l+304|0;q=l;r=l+400|0;s=l+8844|0;t=l+8908|0;u=l+8884|0;v=l+8880|0;w=l+8876|0;x=l+8872|0;y=l+8936|0;z=l+544|0;A=l+592|0;B=l+8848|0;C=l+616|0;D=l+8808|0;E=l+9124|0;F=l+8832|0;G=l+8920|0;H=l+8940|0;I=l+8860|0;J=l+224|0;K=l+272|0;L=l+288|0;M=l+208|0;N=l+8896|0;O=l+384|0;P=l+368|0;Q=l+8944|0;R=l+8968|0;U=l+9040|0;V=l+9112|0;W=l+604|0;X=c[f+32>>2]|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;Y=b+8|0;Z=ea(g[Y>>2]);_=b+4|0;$=ea(g[_>>2]);b=f+4|0;aa=ea(g[b>>2]);ba=f+8|0;ca=ea(g[ba>>2]);da=f+12|0;fa=ea(g[da>>2]);g[O>>2]=aa;g[O+4>>2]=ca;g[O+8>>2]=fa;g[O+12>>2]=ea(0.0);ga=f+16|0;fa=ea(g[ga>>2]);ca=ea(g[f+20>>2]);aa=ea(g[f+24>>2]);ha=ea(g[f+28>>2]);g[P>>2]=fa;g[P+4>>2]=ca;g[P+8>>2]=aa;g[P+12>>2]=ha;ha=ea(-ea(g[j>>2]));ia=j+4|0;aa=ea(-ea(g[ia>>2]));ja=j+8|0;ca=ea(-ea(g[ja>>2]));ka=j+12|0;fa=ea(g[ka>>2]);la=h+16|0;ma=ea(g[la>>2]);na=j+16|0;oa=ea(ma-ea(g[na>>2]));pa=h+20|0;ma=ea(g[pa>>2]);qa=j+20|0;ra=ea(ma-ea(g[qa>>2]));sa=h+24|0;ma=ea(g[sa>>2]);ta=j+24|0;ua=ea(oa*ea(2.0));oa=ea(ra*ea(2.0));ra=ea(ea(ma-ea(g[ta>>2]))*ea(2.0));ma=ea(ea(fa*fa)+ea(-.5));va=ea(ea(ea(ua*ha)+ea(oa*aa))+ea(ra*ca));wa=ea(ea(va*ha)+ea(ea(ma*ua)+ea(fa*ea(ea(ra*aa)-ea(oa*ca)))));xa=ea(ea(va*aa)+ea(ea(ma*oa)+ea(fa*ea(ea(ua*ca)-ea(ra*ha)))));ya=ea(ea(ea(ma*ra)+ea(fa*ea(ea(oa*ha)-ea(ua*aa))))+ea(va*ca));va=ea(g[h>>2]);ua=ea(fa*va);za=h+12|0;oa=ea(g[za>>2]);ra=ea(ua+ea(oa*ha));Aa=h+8|0;ua=ea(g[Aa>>2]);ma=ea(ra+ea(ua*aa));Ba=h+4|0;ra=ea(g[Ba>>2]);Ca=ea(ma-ea(ra*ca));ma=ea(ea(ea(va*ca)+ea(ea(oa*aa)+ea(fa*ra)))-ea(ua*ha));Da=ea(ea(ea(ra*ha)+ea(ea(oa*ca)+ea(fa*ua)))-ea(va*aa));Ea=ea(ea(ea(ea(fa*oa)-ea(va*ha))-ea(ra*aa))-ea(ua*ca));g[p+48>>2]=wa;g[p+52>>2]=xa;g[p+56>>2]=ya;g[p+60>>2]=ea(0.0);ya=ea(Ca+Ca);xa=ea(ma+ma);wa=ea(Da+Da);ca=ea(ma*xa);ua=ea(Da*wa);aa=ea(ya*ma);ma=ea(ya*Da);ra=ea(ya*Ea);ha=ea(Da*xa);Da=ea(Ea*xa);xa=ea(Ea*wa);wa=ea(ea(1.0)-ea(Ca*ya));ya=ea(aa+xa);Ca=ea(ma-Da);Ea=ea(aa-xa);xa=ea(wa-ua);aa=ea(ra+ha);va=ea(ma+Da);Da=ea(ha-ra);ra=ea(wa-ca);g[p>>2]=ea(ea(ea(1.0)-ca)-ua);g[p+4>>2]=ya;g[p+8>>2]=Ca;g[p+12>>2]=ea(0.0);g[p+16>>2]=Ea;g[p+20>>2]=xa;g[p+24>>2]=aa;g[p+28>>2]=ea(0.0);g[p+32>>2]=va;g[p+36>>2]=Da;g[p+40>>2]=ra;g[p+44>>2]=ea(0.0);z1a(q,X+16|0,M,O,P);ra=ea(Z*ea(0.0));P=r+64|0;c[r+0>>2]=c[M+0>>2];c[r+4>>2]=c[M+4>>2];c[r+8>>2]=c[M+8>>2];c[r+12>>2]=c[M+12>>2];c[r+80>>2]=4;O=r+20|0;X=r+36|0;g[r+48>>2]=ea(0.0);Fa=r+52|0;c[Fa+0>>2]=c[n+0>>2];c[Fa+4>>2]=c[n+4>>2];c[Fa+8>>2]=c[n+8>>2];g[r+128>>2]=$;Fa=r+132|0;c[Fa+0>>2]=c[N+0>>2];c[Fa+4>>2]=c[N+4>>2];c[Fa+8>>2]=c[N+8>>2];Da=ea(g[M>>2]);va=ea(g[M+4>>2]);aa=ea(g[M+8>>2]);xa=ea(ra+va);Ea=ea(ra+aa);g[r+96>>2]=ea(Z+Da);g[r+100>>2]=xa;g[r+104>>2]=Ea;g[r+108>>2]=ea(0.0);Ea=ea(va-ra);va=ea(aa-ra);g[r+112>>2]=ea(Da-Z);g[r+116>>2]=Ea;g[r+120>>2]=va;g[r+124>>2]=ea(0.0);g[r+16>>2]=$;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];g[r+32>>2]=$;c[X+0>>2]=c[N+0>>2];c[X+4>>2]=c[N+4>>2];c[X+8>>2]=c[N+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[P+0>>2]=c[o+0>>2];c[P+4>>2]=c[o+4>>2];c[P+8>>2]=c[o+8>>2];c[P+12>>2]=c[o+12>>2];if((uPa(r,q,p,l+256|0,J,K,L)|0)==1){Ga=ea(0.0);Ha=ea(0.0);Ia=ea(0.0);Ja=ea(0.0);Ka=ea(0.0);La=ea(0.0);Ma=ea(0.0)}else{$=ea(g[J>>2]);va=ea(g[J+4>>2]);Ea=ea(g[J+8>>2]);Z=ea(g[L>>2]);Da=ea(g[K>>2]);ra=ea(g[K+4>>2]);aa=ea(g[K+8>>2]);xa=ea($*ea(2.0));$=ea(va*ea(2.0));va=ea(Ea*ea(2.0));Ea=ea(g[ka>>2]);Ca=ea(ea(Ea*Ea)+ea(-.5));ya=ea(g[j>>2]);ua=ea(xa*ya);ca=ea(g[ia>>2]);wa=ea(ua+ea($*ca));ua=ea(g[ja>>2]);ha=ea(wa+ea(va*ua));wa=ea(ea(ya*ha)+ea(ea(xa*Ca)+ea(Ea*ea(ea(va*ca)-ea($*ua)))));ma=ea(ea(ca*ha)+ea(ea($*Ca)+ea(Ea*ea(ea(xa*ua)-ea(va*ya)))));oa=ea(ea(ea(va*Ca)+ea(Ea*ea(ea($*ya)-ea(xa*ca))))+ea(ua*ha));ha=ea(ea(g[na>>2])+wa);wa=ea(ea(g[qa>>2])+ma);ma=ea(Da*ea(2.0));Da=ea(ra*ea(2.0));ra=ea(aa*ea(2.0));aa=ea(ea(ea(ma*ya)+ea(Da*ca))+ea(ra*ua));Ga=Z;Ha=ea(ea(ya*aa)+ea(ea(ma*Ca)+ea(Ea*ea(ea(ra*ca)-ea(Da*ua)))));Ia=ea(ea(ca*aa)+ea(ea(Da*Ca)+ea(Ea*ea(ea(ma*ua)-ea(ra*ya)))));Ja=ea(ea(ea(ra*Ca)+ea(Ea*ea(ea(Da*ya)-ea(ma*ca))))+ea(ua*aa));Ka=ha;La=wa;Ma=ea(ea(g[ta>>2])+oa)}oa=ea(g[_>>2]);wa=ea(oa+ea(g[k>>2]));if(Ga>=ea(wa*wa)){Na=0;i=l;return Na|0}wa=ea(g[h>>2]);oa=ea(wa*ea(2.0));ha=ea(g[za>>2]);aa=ea(ha*ea(2.0));ua=ea(ea(wa*oa)+ea(ea(ha*aa)+ea(-1.0)));ha=ea(g[Aa>>2]);wa=ea(ha*aa);ca=ea(g[Ba>>2]);ma=ea(wa+ea(oa*ca));wa=ea(ea(oa*ha)-ea(aa*ca));ca=ea(g[Y>>2]);aa=ea(ca*ua);ua=ea(ca*ma);ma=ea(ca*wa);wa=ea(g[la>>2]);ca=ea(wa+aa);ha=ea(g[pa>>2]);oa=ea(ha+ua);ya=ea(g[sa>>2]);Da=ea(ma+ya);g[Q>>2]=ca;sa=Q+4|0;g[sa>>2]=oa;pa=Q+8|0;g[pa>>2]=Da;Ea=ea(wa-aa);aa=ea(ha-ua);ua=ea(ya-ma);la=Q+12|0;g[la>>2]=Ea;Y=Q+16|0;g[Y>>2]=aa;Ba=Q+20|0;g[Ba>>2]=ua;if(ca==Ea&oa==aa)Oa=Da==ua;else Oa=0;Aa=Oa?1:2;g[R>>2]=ea(1.0);za=R+4|0;g[za>>2]=ea(0.0);h=R+8|0;g[h>>2]=ea(0.0);K=R+12|0;g[K>>2]=ea(0.0);L=R+16|0;g[L>>2]=ea(1.0);J=R+20|0;g[J>>2]=ea(0.0);P=R+24|0;g[P>>2]=ea(0.0);N=R+28|0;g[N>>2]=ea(0.0);X=R+32|0;g[X>>2]=ea(1.0);g[R+36>>2]=ea(1.0);g[R+40>>2]=ea(0.0);g[R+44>>2]=ea(0.0);g[R+48>>2]=ea(0.0);g[R+52>>2]=ea(1.0);g[R+56>>2]=ea(0.0);g[R+60>>2]=ea(0.0);g[R+64>>2]=ea(0.0);g[R+68>>2]=ea(1.0);if(!((ea(g[b>>2])==ea(1.0)?ea(g[ba>>2])==ea(1.0):0)?ea(g[da>>2])==ea(1.0):0))J0a(R,b,ga);EOa(U,c[f+36>>2]|0,R);if(Ga>ea(0.0)){ma=ea(-Ia);Ia=ea(-Ja);g[V>>2]=ea(-Ha);f=V+4|0;g[f>>2]=ma;ga=V+8|0;g[ga>>2]=Ia;Ia=ea(g[_>>2]);A1a(m,j,U,b,Aa,Q,Ia,V,ea(g[k>>2]));da=m+4096|0;if((c[da>>2]|0)==2){Na=1;i=l;return Na|0}if(!Oa){Ia=ea(g[j>>2]);ma=ea(Ia+Ia);Ha=ea(g[ia>>2]);Ja=ea(Ha+Ha);ya=ea(g[ja>>2]);ha=ea(ya+ya);wa=ea(g[ka>>2]);Ca=ea(ma*wa);ra=ea(Ja*wa);Z=ea(wa*ha);wa=ea(Ia*Ja);xa=ea(Ia*ha);$=ea(Ha*Ja);Ja=ea(Ha*ha);Ha=ea(ya*ha);ha=ea(ea(ea(1.0)-$)-Ha);ya=ea(wa+Z);va=ea(xa-ra);fa=ea(wa-Z);Z=ea(ea(1.0)-ea(Ia*ma));ma=ea(Z-Ha);Ha=ea(Ja+Ca);Ia=ea(xa+ra);ra=ea(Ja-Ca);Ca=ea(Z-$);$=ea(g[na>>2]);Z=ea(g[qa>>2]);Ja=ea(g[ta>>2]);xa=ea(g[_>>2]);wa=ea(g[k>>2]);Pa=ea(g[V>>2]);Qa=ea(ha*Pa);Ra=ea(g[f>>2]);Sa=ea(Qa+ea(ya*Ra));Qa=ea(g[ga>>2]);Ta=ea(ea(ea(fa*Pa)+ea(ma*Ra))+ea(Ha*Qa));Ua=ea(ea(ea(Ia*Pa)+ea(ra*Ra))+ea(Ca*Qa));g[n>>2]=ea(Sa+ea(va*Qa));g[n+4>>2]=Ta;g[n+8>>2]=Ua;ba=xo[c[U+68>>2]&2047](U,R,n)|0;Ua=ea(g[Q>>2]);g[o>>2]=Ua;n=o+4|0;Ta=ea(g[sa>>2]);g[n>>2]=Ta;O=o+8|0;Sa=ea(g[pa>>2]);g[O>>2]=Sa;Va=ea(g[la>>2]);g[p>>2]=Va;M=p+4|0;Wa=ea(g[Y>>2]);g[M>>2]=Wa;Fa=p+8|0;Xa=ea(g[Ba>>2]);g[Fa>>2]=Xa;Ya=ea(Va-Ua);Za=ea(Wa-Ta);_a=ea(Xa-Sa);$a=ea(T(ea(ea(ea(Ya*Ya)+ea(Za*Za))+ea(_a*_a))));if($a>ea(0.0)){ab=ea(ea(.00999999977)/$a);$a=ea(Ya*ab);Ya=ea(Za*ab);Za=ea(_a*ab);ab=ea(Ua-$a);g[o>>2]=ab;_a=ea(Ta-Ya);g[n>>2]=_a;bb=ea(Sa-Za);g[O>>2]=bb;cb=ea(Va+$a);g[p>>2]=cb;$a=ea(Wa+Ya);g[M>>2]=$a;Ya=ea(Xa+Za);g[Fa>>2]=Ya;db=cb;eb=ab;fb=$a;gb=_a;hb=Ya;ib=bb}else{db=Va;eb=Ua;fb=Wa;gb=Ta;hb=Xa;ib=Sa}Sa=ea(db-eb);db=ea(fb-gb);fb=ea(hb-ib);g[q>>2]=Sa;g[q+4>>2]=db;g[q+8>>2]=fb;hb=ea(-ea(ea(db*Qa)-ea(fb*Ra)));Xa=ea(-ea(ea(fb*Pa)-ea(Qa*Sa)));fb=ea(-ea(ea(Sa*Ra)-ea(db*Pa)));g[r>>2]=hb;g[r+4>>2]=Xa;g[r+8>>2]=fb;g[r+12>>2]=ea(-ea(ea(ib*fb)+ea(ea(eb*hb)+ea(gb*Xa))));gb=ea(S(ea(hb)));hb=ea(S(ea(Xa)));Xa=ea(S(ea(fb)));if(!(hb>gb&hb>Xa))if(Xa>gb){jb=1;kb=0}else{jb=2;kb=1}else{jb=0;kb=2}gb=ea(g[q+(jb<<2)>>2]);Xa=ea(gb*ea(g[V+(kb<<2)>>2]));gb=ea(g[q+(kb<<2)>>2]);hb=ea(ea(1.0)/ea(Xa-ea(gb*ea(g[V+(jb<<2)>>2]))));Fa=c[U+28>>2]|0;M=c[U+24>>2]|0;O=c[U+32>>2]|0;n=e[M+(ba*20|0)+16>>1]|0;lb=a[M+(ba*20|0)+18>>0]|0;ba=lb&255;if(lb<<24>>24){lb=u+4|0;M=u+8|0;gb=ea(xa+wa);mb=t+8|0;nb=t+4|0;wa=ea(g[V>>2]);Xa=ea(-wa);fb=ea(-Ra);eb=ea(-Qa);ob=ba;pb=ba+-1|0;ba=0;while(1){ob=ob+-1|0;qb=d[O+(pb+n)>>0]|0;ib=ea(g[Fa+(qb*12|0)>>2]);Pa=ea(g[R>>2]);db=ea(ib*Pa);Sa=ea(g[za>>2]);Ta=ea(ib*Sa);Wa=ea(g[h>>2]);Ua=ea(ib*Wa);ib=ea(g[Fa+(qb*12|0)+4>>2]);Va=ea(g[K>>2]);bb=ea(ib*Va);Ya=ea(g[L>>2]);_a=ea(ib*Ya);$a=ea(g[J>>2]);ab=ea(db+bb);bb=ea(Ta+_a);_a=ea(Ua+ea(ib*$a));ib=ea(g[Fa+(qb*12|0)+8>>2]);Ua=ea(g[P>>2]);Ta=ea(ib*Ua);db=ea(g[N>>2]);cb=ea(ib*db);Za=ea(g[X>>2]);rb=ea(ab+Ta);Ta=ea(bb+cb);cb=ea(_a+ea(ib*Za));ib=ea($+ea(ea(ea(ha*rb)+ea(fa*Ta))+ea(Ia*cb)));_a=ea(Z+ea(ea(ea(ya*rb)+ea(ma*Ta))+ea(ra*cb)));bb=ea(Ja+ea(ea(ea(va*rb)+ea(Ha*Ta))+ea(Ca*cb)));qb=d[O+(ba+n)>>0]|0;cb=ea(g[Fa+(qb*12|0)>>2]);Ta=ea(Pa*cb);Pa=ea(Sa*cb);Sa=ea(Wa*cb);cb=ea(g[Fa+(qb*12|0)+4>>2]);Wa=ea(Ta+ea(Va*cb));Va=ea(Pa+ea(Ya*cb));Ya=ea(Sa+ea($a*cb));cb=ea(g[Fa+(qb*12|0)+8>>2]);$a=ea(Wa+ea(Ua*cb));Ua=ea(Va+ea(db*cb));db=ea(Ya+ea(Za*cb));cb=ea($+ea(ea(Ia*db)+ea(ea(ha*$a)+ea(fa*Ua))));Za=ea(Z+ea(ea(ra*db)+ea(ea(ya*$a)+ea(ma*Ua))));Ya=ea(Ja+ea(ea(Ca*db)+ea(ea(va*$a)+ea(Ha*Ua))));g[u>>2]=Xa;g[lb>>2]=fb;g[M>>2]=eb;if((B1a(o,p,q,r,kb,jb,hb,u,ib,_a,bb,cb,Za,Ya,s,t,ea(0.0))|0?(Ya=ea(g[s>>2]),Ya<gb):0)?(qb=c[da>>2]|0,qb>>>0<=63):0){Za=ea(g[mb>>2]);cb=ea(g[nb>>2]);bb=ea(Ya-xa);_a=ea(Za-ea(Ya*Qa));Za=ea(cb-ea(Ya*Ra));cb=ea(ea(g[t>>2])-ea(Ya*wa));c[da>>2]=qb+1;g[m+(qb<<6)>>2]=wa;g[m+(qb<<6)+4>>2]=Ra;g[m+(qb<<6)+8>>2]=Qa;g[m+(qb<<6)+16>>2]=cb;g[m+(qb<<6)+20>>2]=Za;g[m+(qb<<6)+24>>2]=_a;g[m+(qb<<6)+12>>2]=bb;c[m+(qb<<6)+48>>2]=-1;c[m+(qb<<6)+52>>2]=-1}if(!ob)break;else{qb=ba;ba=ba+1|0;pb=qb}}}}if(c[da>>2]|0){Na=1;i=l;return Na|0}Qa=ea(T(ea(Ga)));Ga=ea(Qa-ea(g[_>>2]));c[da>>2]=1;g[m>>2]=ea(g[V>>2]);g[m+4>>2]=ea(g[f>>2]);g[m+8>>2]=ea(g[ga>>2]);g[m+16>>2]=Ka;g[m+20>>2]=La;g[m+24>>2]=Ma;g[m+12>>2]=Ga;c[m+48>>2]=-1;c[m+52>>2]=-1;Na=1;i=l;return Na|0}Ga=ea(g[_>>2]);ga=U+16|0;f=c[ga>>2]|0;V=U+24|0;da=c[V>>2]|0;Ma=ea(g[j>>2]);La=ea(Ma+Ma);Ka=ea(g[ia>>2]);Qa=ea(Ka+Ka);Ra=ea(g[ja>>2]);wa=ea(Ra+Ra);xa=ea(g[ka>>2]);gb=ea(La*xa);hb=ea(Qa*xa);eb=ea(xa*wa);xa=ea(Ma*La);La=ea(Ma*Qa);fb=ea(Ma*wa);Ma=ea(Ka*Qa);Qa=ea(Ka*wa);Ka=ea(Ra*wa);wa=ea(ea(ea(1.0)-Ma)-Ka);g[z>>2]=wa;Ra=ea(La+eb);pb=z+4|0;g[pb>>2]=Ra;Xa=ea(fb-hb);ba=z+8|0;g[ba>>2]=Xa;Ha=ea(La-eb);ob=z+12|0;g[ob>>2]=Ha;eb=ea(ea(1.0)-xa);xa=ea(eb-Ka);t=z+16|0;g[t>>2]=xa;Ka=ea(Qa+gb);nb=z+20|0;g[nb>>2]=Ka;La=ea(fb+hb);mb=z+24|0;g[mb>>2]=La;hb=ea(Qa-gb);s=z+28|0;g[s>>2]=hb;gb=ea(eb-Ma);u=z+32|0;g[u>>2]=gb;g[z+36>>2]=ea(g[na>>2]);g[z+40>>2]=ea(g[qa>>2]);g[z+44>>2]=ea(g[ta>>2]);jb=(f|0)==0;a:do if(!jb){kb=A+4|0;r=A+8|0;q=U+64|0;Ma=ea(0.0);eb=ea(0.0);Qa=ea(0.0);fb=wa;va=Ra;Ca=Xa;Ja=Ha;ma=xa;ya=Ka;ra=La;Z=hb;fa=gb;ha=ea(3402823469999999843913219.0e14);p=0;while(1){Ia=ea(g[da+(p*20|0)>>2]);$=ea(fb*Ia);bb=ea(va*Ia);_a=ea(Ca*Ia);Ia=ea(g[da+(p*20|0)+4>>2]);Za=ea($+ea(Ja*Ia));$=ea(bb+ea(ma*Ia));bb=ea(_a+ea(ya*Ia));Ia=ea(g[da+(p*20|0)+8>>2]);_a=ea(Za+ea(ra*Ia));Za=ea($+ea(Z*Ia));$=ea(bb+ea(fa*Ia));g[A>>2]=_a;g[kb>>2]=Za;g[r>>2]=$;Ia=ea(ea(ea(_a*ca)+ea(Za*oa))+ea($*Da));bb=ea(ea(ea(_a*Ea)+ea(Za*aa))+ea($*ua));o=Ia>bb;$=ea((o?bb:Ia)-Ga);Za=ea(Ga+(o?Ia:bb));rn[c[q>>2]&127](U,A,z,R,v,w);bb=ea(g[v>>2]);if(Za<bb){Na=0;sb=64;break}Ia=ea(g[w>>2]);if(Ia<$){Na=0;sb=64;break}_a=ea(Za-bb);bb=ea(Ia-$);$=_a<bb?_a:bb;if($<ha){bb=ea(g[A>>2]);_a=ea(g[kb>>2]);tb=ea(g[r>>2]);ub=_a;vb=bb;wb=$}else{tb=Qa;ub=eb;vb=Ma;wb=ha}o=p+1|0;if(o>>>0>=f>>>0){xb=tb;yb=ub;zb=vb;Ab=wb;break a}$=ea(g[z>>2]);bb=ea(g[pb>>2]);_a=ea(g[ba>>2]);Ia=ea(g[ob>>2]);Za=ea(g[t>>2]);cb=ea(g[nb>>2]);Ya=ea(g[mb>>2]);ib=ea(g[s>>2]);Ma=vb;eb=ub;Qa=tb;fb=$;va=bb;Ca=_a;Ja=Ia;ma=Za;ya=cb;ra=Ya;Z=ib;fa=ea(g[u>>2]);ha=wb;p=o}if((sb|0)==64){i=l;return Na|0}}else{xb=ea(0.0);yb=ea(0.0);zb=ea(0.0);Ab=ea(3402823469999999843913219.0e14)}while(0);b:do if(!Oa){wb=ea(Ea-ca);tb=ea(aa-oa);ub=ea(ua-Da);vb=ea(ea(ea(wb*wb)+ea(tb*tb))+ea(ub*ub));if(vb>ea(0.0)){gb=ea(ea(1.0)/ea(T(ea(vb))));Bb=ea(tb*gb);Cb=ea(ub*gb);Db=ea(wb*gb)}else{Bb=ea(0.0);Cb=ea(0.0);Db=ea(0.0)}if(!jb){A=B+4|0;w=B+8|0;v=U+64|0;gb=zb;wb=yb;ub=xb;tb=Ab;p=0;while(1){vb=ea(g[da+(p*20|0)>>2]);hb=ea(vb*ea(g[z>>2]));La=ea(vb*ea(g[pb>>2]));Ka=ea(vb*ea(g[ba>>2]));vb=ea(g[da+(p*20|0)+4>>2]);xa=ea(vb*ea(g[ob>>2]));Ha=ea(vb*ea(g[t>>2]));Xa=ea(hb+xa);xa=ea(La+Ha);Ha=ea(Ka+ea(vb*ea(g[nb>>2])));vb=ea(g[da+(p*20|0)+8>>2]);Ka=ea(vb*ea(g[mb>>2]));La=ea(vb*ea(g[s>>2]));hb=ea(Xa+Ka);Ka=ea(xa+La);La=ea(Ha+ea(vb*ea(g[u>>2])));vb=ea(ea(Bb*La)-ea(Cb*Ka));Ha=ea(ea(Cb*hb)-ea(Db*La));La=ea(ea(Db*Ka)-ea(Bb*hb));g[B>>2]=vb;g[A>>2]=Ha;g[w>>2]=La;if((!(+ea(S(ea(vb)))>1.0e-06)?!(+ea(S(ea(Ha)))>1.0e-06):0)?!(+ea(S(ea(La)))>1.0e-06):0){Eb=ub;Fb=wb;Gb=gb;Hb=tb}else{hb=ea(ea(La*La)+ea(ea(vb*vb)+ea(Ha*Ha)));if(hb>ea(0.0)){Ka=ea(ea(1.0)/ea(T(ea(hb))));Ib=ea(vb*Ka);Jb=ea(Ha*Ka);Kb=ea(La*Ka)}else{Ib=ea(0.0);Jb=ea(0.0);Kb=ea(0.0)}g[B>>2]=Ib;g[A>>2]=Jb;g[w>>2]=Kb;Ka=ea(ea(ea(Ib*ca)+ea(Jb*oa))+ea(Kb*Da));La=ea(ea(ea(Ib*Ea)+ea(Jb*aa))+ea(Kb*ua));r=Ka>La;Ha=ea((r?La:Ka)-Ga);vb=ea(Ga+(r?Ka:La));rn[c[v>>2]&127](U,B,z,R,x,y);La=ea(g[x>>2]);if(vb<La){Na=0;sb=64;break}Ka=ea(g[y>>2]);if(Ka<Ha){Na=0;sb=64;break}hb=ea(vb-La);La=ea(Ka-Ha);Ha=hb<La?hb:La;if(Ha<tb){La=ea(g[B>>2]);hb=ea(g[A>>2]);Eb=ea(g[w>>2]);Fb=hb;Gb=La;Hb=Ha}else{Eb=ub;Fb=wb;Gb=gb;Hb=tb}}p=p+1|0;if(p>>>0>=f>>>0){Lb=Gb;Mb=Fb;Nb=Eb;break b}else{gb=Gb;wb=Fb;ub=Eb;tb=Hb}}if((sb|0)==64){i=l;return Na|0}}else{Lb=zb;Mb=yb;Nb=xb}}else{Lb=zb;Mb=yb;Nb=xb}while(0);xb=ea(ea(ca+Ea)*ea(.5));Ea=ea(ea(oa+aa)*ea(.5));aa=ea(ea(Da+ua)*ea(.5));ua=ea(ea(g[U>>2])*ea(2.0));Da=ea(ea(g[U+4>>2])*ea(2.0));oa=ea(ea(g[U+8>>2])*ea(2.0));ca=ea(g[ka>>2]);yb=ea(ea(ca*ca)+ea(-.5));zb=ea(g[j>>2]);Hb=ea(ua*zb);Eb=ea(g[ia>>2]);Fb=ea(Hb+ea(Da*Eb));Hb=ea(g[ja>>2]);Gb=ea(Fb+ea(oa*Hb));Fb=ea(ea(zb*Gb)+ea(ea(ua*yb)+ea(ca*ea(ea(oa*Eb)-ea(Da*Hb)))));Ga=ea(ea(Eb*Gb)+ea(ea(Da*yb)+ea(ca*ea(ea(ua*Hb)-ea(oa*zb)))));Kb=ea(ea(ea(oa*yb)+ea(ca*ea(ea(Da*zb)-ea(ua*Eb))))+ea(Hb*Gb));Gb=ea(ea(g[na>>2])+Fb);Fb=ea(ea(g[qa>>2])+Ga);if(ea(ea(Nb*ea(aa-ea(ea(g[ta>>2])+Kb)))+ea(ea(Lb*ea(xb-Gb))+ea(Mb*ea(Ea-Fb))))<ea(0.0)){Ob=ea(-Lb);Pb=ea(-Mb);Qb=ea(-Nb)}else{Ob=Lb;Pb=Mb;Qb=Nb}g[W>>2]=Ob;sb=W+4|0;g[sb>>2]=Pb;f=W+8|0;g[f>>2]=Qb;Qb=ea(g[_>>2]);A1a(m,j,U,b,Aa,Q,Qb,W,ea(g[k>>2]));Aa=m+4096|0;if((c[Aa>>2]|0)==2|Oa){Na=1;i=l;return Na|0}Qb=ea(g[_>>2]);Pb=ea(g[k>>2]);k=kOa(512,C,c[ga>>2]|0,c[V>>2]|0,c[U+32>>2]|0)|0;Ob=ea(g[Q>>2]);g[D>>2]=Ob;Q=D+4|0;Nb=ea(g[sa>>2]);g[Q>>2]=Nb;sa=D+8|0;Mb=ea(g[pa>>2]);g[sa>>2]=Mb;Lb=ea(g[la>>2]);g[E>>2]=Lb;la=E+4|0;Fb=ea(g[Y>>2]);g[la>>2]=Fb;Y=E+8|0;Ea=ea(g[Ba>>2]);g[Y>>2]=Ea;Gb=ea(Lb-Ob);xb=ea(Fb-Nb);Kb=ea(Ea-Mb);aa=ea(T(ea(ea(ea(Gb*Gb)+ea(xb*xb))+ea(Kb*Kb))));if(aa>ea(0.0)){Ga=ea(ea(.00999999977)/aa);aa=ea(Gb*Ga);Gb=ea(xb*Ga);xb=ea(Kb*Ga);Ga=ea(Ob-aa);g[D>>2]=Ga;Kb=ea(Nb-Gb);g[Q>>2]=Kb;Hb=ea(Mb-xb);g[sa>>2]=Hb;Eb=ea(Lb+aa);g[E>>2]=Eb;aa=ea(Fb+Gb);g[la>>2]=aa;Gb=ea(Ea+xb);g[Y>>2]=Gb;Rb=aa;Sb=Kb;Tb=Gb;Ub=Hb;Vb=Eb;Wb=Ga}else{Rb=Fb;Sb=Nb;Tb=Ea;Ub=Mb;Vb=Lb;Wb=Ob}Ob=ea(Vb-Wb);Vb=ea(Rb-Sb);Rb=ea(Tb-Ub);g[F>>2]=Ob;g[F+4>>2]=Vb;g[F+8>>2]=Rb;Tb=ea(g[f>>2]);Lb=ea(Vb*Tb);Mb=ea(g[sb>>2]);Ea=ea(Lb-ea(Rb*Mb));Lb=ea(g[W>>2]);Nb=ea(ea(Rb*Lb)-ea(Tb*Ob));Tb=ea(ea(Ob*Mb)-ea(Vb*Lb));g[G>>2]=Ea;g[G+4>>2]=Nb;g[G+8>>2]=Tb;g[G+12>>2]=ea(-ea(ea(Ub*Tb)+ea(ea(Wb*Ea)+ea(Sb*Nb))));Sb=ea(S(ea(Ea)));Ea=ea(S(ea(Nb)));Nb=ea(S(ea(Tb)));if(!(Ea>Sb&Ea>Nb))if(Nb>Sb){Xb=0;Yb=1}else{Xb=1;Yb=2}else{Xb=2;Yb=0}Sb=ea(g[F+(Xb<<2)>>2]);Nb=ea(Sb*ea(g[W+(Yb<<2)>>2]));Sb=ea(g[F+(Yb<<2)>>2]);Ea=ea(ea(1.0)/ea(Nb-ea(Sb*ea(g[W+(Xb<<2)>>2]))));Y=c[U+28>>2]|0;if(!k){Na=1;i=l;return Na|0}Sb=ea(ea(-Qb)-Pb);U=I+8|0;la=I+4|0;sa=0;do{Q=d[C+(sa<<4)>>0]|0;Pb=ea(g[Y+(Q*12|0)>>2]);Nb=ea(g[R>>2]);Tb=ea(Pb*Nb);Wb=ea(g[za>>2]);Ub=ea(Pb*Wb);Lb=ea(g[h>>2]);Vb=ea(Pb*Lb);Pb=ea(g[Y+(Q*12|0)+4>>2]);Mb=ea(g[K>>2]);Ob=ea(Pb*Mb);Rb=ea(g[L>>2]);Fb=ea(Pb*Rb);Ga=ea(g[J>>2]);Eb=ea(Tb+Ob);Ob=ea(Ub+Fb);Fb=ea(Vb+ea(Pb*Ga));Pb=ea(g[Y+(Q*12|0)+8>>2]);Vb=ea(g[P>>2]);Ub=ea(Pb*Vb);Tb=ea(g[N>>2]);Hb=ea(Pb*Tb);Gb=ea(g[X>>2]);Kb=ea(ea(Eb+Ub)*ea(2.0));Ub=ea(ea(Ob+Hb)*ea(2.0));Hb=ea(ea(Fb+ea(Pb*Gb))*ea(2.0));Pb=ea(g[ka>>2]);Fb=ea(ea(Pb*Pb)+ea(-.5));Ob=ea(g[j>>2]);Eb=ea(Kb*Ob);aa=ea(g[ia>>2]);xb=ea(Eb+ea(Ub*aa));Eb=ea(g[ja>>2]);ua=ea(xb+ea(Hb*Eb));xb=ea(ea(Ob*ua)+ea(ea(Kb*Fb)+ea(Pb*ea(ea(Hb*aa)-ea(Ub*Eb)))));zb=ea(ea(aa*ua)+ea(ea(Ub*Fb)+ea(Pb*ea(ea(Kb*Eb)-ea(Ob*Hb)))));Da=ea(ea(ea(Hb*Fb)+ea(Pb*ea(ea(Ub*Ob)-ea(Kb*aa))))+ea(Eb*ua));ua=ea(g[na>>2]);Kb=ea(ua+xb);xb=ea(g[qa>>2]);Ub=ea(xb+zb);zb=ea(g[ta>>2]);Hb=ea(zb+Da);Q=d[C+(sa<<4)+1>>0]|0;Da=ea(g[Y+(Q*12|0)>>2]);ca=ea(Nb*Da);Nb=ea(Wb*Da);Wb=ea(Lb*Da);Da=ea(g[Y+(Q*12|0)+4>>2]);Lb=ea(ca+ea(Mb*Da));Mb=ea(Nb+ea(Rb*Da));Rb=ea(Wb+ea(Ga*Da));Da=ea(g[Y+(Q*12|0)+8>>2]);Ga=ea(ea(Lb+ea(Vb*Da))*ea(2.0));Vb=ea(ea(Mb+ea(Tb*Da))*ea(2.0));Tb=ea(ea(Rb+ea(Gb*Da))*ea(2.0));Da=ea(ea(Eb*Tb)+ea(ea(Ob*Ga)+ea(aa*Vb)));if(B1a(D,E,F,G,Xb,Yb,Ea,W,Kb,Ub,Hb,ea(ua+ea(ea(Ob*Da)+ea(ea(Fb*Ga)+ea(Pb*ea(ea(aa*Tb)-ea(Eb*Vb)))))),ea(xb+ea(ea(aa*Da)+ea(ea(Fb*Vb)+ea(Pb*ea(ea(Eb*Ga)-ea(Ob*Tb)))))),ea(zb+ea(ea(ea(Fb*Tb)+ea(Pb*ea(ea(Ob*Vb)-ea(aa*Ga))))+ea(Eb*Da))),H,I,Sb)|0?(Da=ea(g[H>>2]),Q=c[Aa>>2]|0,Q>>>0<=63):0){Eb=ea(g[f>>2]);Ga=ea(g[sb>>2]);aa=ea(g[W>>2]);Vb=ea(Qb+Da);Ob=ea(g[U>>2]);Pb=ea(g[la>>2]);Tb=ea(-Vb);Vb=ea(Ob-ea(Da*Eb));Ob=ea(Pb-ea(Da*Ga));Pb=ea(ea(g[I>>2])-ea(Da*aa));c[Aa>>2]=Q+1;g[m+(Q<<6)>>2]=aa;g[m+(Q<<6)+4>>2]=Ga;g[m+(Q<<6)+8>>2]=Eb;g[m+(Q<<6)+16>>2]=Pb;g[m+(Q<<6)+20>>2]=Ob;g[m+(Q<<6)+24>>2]=Vb;g[m+(Q<<6)+12>>2]=Tb;c[m+(Q<<6)+48>>2]=-1;c[m+(Q<<6)+52>>2]=-1}sa=sa+1|0}while((sa|0)!=(k|0));Na=1;i=l;return Na|0}function yya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=xya(a,b,c,d,e,f,g)|0;i=h;return j|0}function zya(e,f,h,j,k,l,m){e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=Im,$=0,aa=Im,ba=Im,fa=Im,ga=Im,ha=0,ia=Im,ja=0,ka=Im,la=0,ma=Im,na=0,oa=Im,pa=0,qa=0,ra=Im,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=0,Ca=Im,Da=Im,Ea=0,Fa=Im,Ga=0,Ha=Im,Ia=Im,Ja=Im,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=Im,rb=Im,sb=Im,tb=0,ub=0,vb=Im,wb=Im,xb=Im,yb=0,zb=0,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=0,Jb=0,Kb=0,Lb=0,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=0,Rb=0,Sb=0;n=i;i=i+320|0;o=n+152|0;p=n+128|0;q=n+32|0;r=n+256|0;s=n;t=n+64|0;u=n+88|0;v=n+96|0;w=n+212|0;x=n+236|0;y=n+252|0;z=n+284|0;A=n+296|0;B=n+172|0;C=n+176|0;D=n+188|0;E=n+40|0;F=n+200|0;G=n+108|0;H=n+52|0;I=n+120|0;J=n+224|0;K=n+124|0;L=n+240|0;M=c[f+4>>2]|0;N=o+12|0;c[N>>2]=M;O=o+16|0;c[O>>2]=f;P=f+8|0;Q=o+4|0;g[Q>>2]=ea(ea(1.0)/ea(g[P>>2]));U=f+12|0;V=ea(ea(1.0)/ea(g[U>>2]));g[o>>2]=V;W=f+16|0;X=ea(ea(1.0)/ea(g[W>>2]));Y=o+8|0;g[Y>>2]=X;Z=ea(g[e+4>>2]);_=ea(Z+ea(g[k>>2]));$=e+8|0;aa=ea(g[$>>2]);ba=ea(Z*ea(.100000001));fa=ea(S(ea(V)));V=ea(S(ea(X)));X=ea(-ea(g[j>>2]));e=j+4|0;ga=ea(-ea(g[e>>2]));ha=j+8|0;ia=ea(-ea(g[ha>>2]));ja=j+12|0;ka=ea(g[ja>>2]);la=h+16|0;ma=ea(g[la>>2]);na=j+16|0;oa=ea(ma-ea(g[na>>2]));pa=h+20|0;ma=ea(g[pa>>2]);qa=j+20|0;ra=ea(ma-ea(g[qa>>2]));sa=h+24|0;ma=ea(g[sa>>2]);ta=j+24|0;ua=ea(oa*ea(2.0));oa=ea(ra*ea(2.0));ra=ea(ea(ma-ea(g[ta>>2]))*ea(2.0));ma=ea(ea(ka*ka)+ea(-.5));va=ea(ea(ea(ua*X)+ea(oa*ga))+ea(ra*ia));wa=ea(ka*ea(ea(ra*ga)-ea(oa*ia)));xa=ea(va*X);ya=ea(ea(va*ga)+ea(ea(ma*oa)+ea(ka*ea(ea(ua*ia)-ea(ra*X)))));za=ea(ka*ea(ea(oa*X)-ea(ua*ga)));oa=ea(va*ia);va=ea(g[h>>2]);Aa=ea(ka*va);Ba=h+12|0;Ca=ea(g[Ba>>2]);Da=ea(Aa+ea(Ca*X));Ea=h+8|0;Aa=ea(g[Ea>>2]);Fa=ea(Da+ea(Aa*ga));Ga=h+4|0;Da=ea(g[Ga>>2]);Ha=ea(Fa-ea(Da*ia));Fa=ea(ea(ea(Da*X)+ea(ea(Ca*ia)+ea(ka*Aa)))-ea(va*ga));Ia=ea(_*_);Ja=ea(ba*ba);ba=ea(_*fa);fa=ea(_*V);V=ea(xa+ea(ea(ma*ua)+wa));wa=ea(ea(ea(ma*ra)+za)+oa);oa=ea(ea(ea(va*ia)+ea(ea(Ca*ga)+ea(ka*Da)))-ea(Aa*X));za=ea(ea(ea(ea(ka*Ca)-ea(va*X))-ea(Da*ga))-ea(Aa*ia));ia=ea(aa*ea(-2.0));Aa=ea(ea(za*za)+ea(-.5));ga=ea(oa*ea(0.0));Da=ea(Fa*ea(0.0));X=ea(Da+ea(ea(ia*Ha)+ga));va=ea(za*ea(ga-Da));Ca=ea(Aa*ea(0.0));ka=ea(Ha*ea(0.0));ra=ea(V+ea(ea(Ha*X)+ea(ea(ia*Aa)+va)));ma=ea(ya+ea(ea(Ca+ea(za*ea(ea(ia*Fa)-ka)))+ea(oa*X)));ua=ea(wa+ea(ea(Ca+ea(za*ea(ka-ea(ia*oa))))+ea(Fa*X)));g[p>>2]=ra;Ka=p+4|0;g[Ka>>2]=ma;La=p+8|0;g[La>>2]=ua;X=ea(aa*ea(2.0));aa=ea(Da+ea(ea(X*Ha)+ga));ga=ea(V+ea(ea(Ha*aa)+ea(ea(X*Aa)+va)));va=ea(ya+ea(ea(Ca+ea(za*ea(ea(X*Fa)-ka)))+ea(oa*aa)));ya=ea(wa+ea(ea(Ca+ea(za*ea(ka-ea(X*oa))))+ea(Fa*aa)));Ma=p+12|0;g[Ma>>2]=ga;Na=p+16|0;g[Na>>2]=va;Oa=p+20|0;g[Oa>>2]=ya;c[q>>2]=0;g[q+4>>2]=Z;aa=ea(ra*ea(2.0));ra=ea(ma*ea(2.0));ma=ea(ua*ea(2.0));ua=ea(g[ja>>2]);Fa=ea(ea(ua*ua)+ea(-.5));oa=ea(g[j>>2]);X=ea(aa*oa);ka=ea(g[e>>2]);za=ea(X+ea(ra*ka));X=ea(g[ha>>2]);Ca=ea(za+ea(ma*X));za=ea(ea(oa*Ca)+ea(ea(aa*Fa)+ea(ua*ea(ea(ma*ka)-ea(ra*X)))));wa=ea(ea(ka*Ca)+ea(ea(ra*Fa)+ea(ua*ea(ea(aa*X)-ea(ma*oa)))));Aa=ea(ea(ea(ma*Fa)+ea(ua*ea(ea(ra*oa)-ea(aa*ka))))+ea(X*Ca));Ca=ea(g[na>>2]);aa=ea(Ca+za);za=ea(g[qa>>2]);ra=ea(za+wa);wa=ea(g[ta>>2]);ma=ea(wa+Aa);g[r>>2]=ea(0.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(1.0);g[r+16>>2]=aa;g[r+20>>2]=ra;g[r+24>>2]=ma;ma=ea(ga*ea(2.0));ga=ea(va*ea(2.0));va=ea(ya*ea(2.0));ya=ea(ea(ea(ma*oa)+ea(ga*ka))+ea(va*X));ra=ea(Ca+ea(ea(oa*ya)+ea(ea(ma*Fa)+ea(ua*ea(ea(va*ka)-ea(ga*X))))));Ca=ea(za+ea(ea(ka*ya)+ea(ea(ga*Fa)+ea(ua*ea(ea(ma*X)-ea(va*oa))))));za=ea(wa+ea(ea(ea(va*Fa)+ea(ua*ea(ea(ga*oa)-ea(ma*ka))))+ea(X*ya)));g[s>>2]=ea(0.0);g[s+4>>2]=ea(0.0);g[s+8>>2]=ea(0.0);g[s+12>>2]=ea(1.0);g[s+16>>2]=ra;g[s+20>>2]=Ca;g[s+24>>2]=za;Kya(q,f,r,j,k,l,m,1)|0;Kya(q,f,s,j,k,l,m,1)|0;za=ea(g[h>>2]);Ca=ea(za*ea(2.0));ra=ea(g[Ba>>2]);ya=ea(ra*ea(2.0));X=ea(ea(za*Ca)+ea(ea(ra*ya)+ea(-1.0)));ra=ea(g[Ea>>2]);za=ea(ra*ya);ka=ea(g[Ga>>2]);ma=ea(za+ea(Ca*ka));za=ea(ea(Ca*ra)-ea(ya*ka));ka=ea(g[$>>2]);ya=ea(ka*X);X=ea(ka*ma);ma=ea(ka*za);za=ea(g[la>>2]);ka=ea(za-ya);ra=ea(g[pa>>2]);Ca=ea(ra-X);oa=ea(g[sa>>2]);ga=ea(oa-ma);ua=ea(g[p>>2]);g[t>>2]=ua;p=t+4|0;g[p>>2]=ea(g[Ka>>2]);Ka=t+8|0;Fa=ea(g[La>>2]);g[Ka>>2]=Fa;La=t+12|0;va=ea(g[Ma>>2]);g[La>>2]=va;Ma=t+16|0;g[Ma>>2]=ea(g[Na>>2]);Na=t+20|0;wa=ea(g[Oa>>2]);g[Na>>2]=wa;Oa=m+4096|0;sa=c[Oa>>2]|0;aa=ea(g[o>>2]);Aa=ea(ua*aa);ua=ea(g[Y>>2]);Ha=ea(Fa*ua);Fa=ea(aa*va);va=ea(ua*wa);wa=ea(Aa-ba);ua=ea(Fa-ba);pa=~~ea(R(ea(wa<ua?wa:ua)));la=c[M+16>>2]|0;$=la+-2|0;Ga=(pa|0)>0?pa:0;pa=(Ga|0)>($|0)?$:Ga;ua=ea(ba+Aa);Aa=ea(ba+Fa);Ga=~~ea(ca(ea(ua>Aa?ua:Aa)));$=la+-1|0;la=(Ga|0)>0?Ga:0;Ga=(la|0)>($|0)?$:la;Aa=ea(Ha-fa);ua=ea(va-fa);la=~~ea(R(ea(Aa<ua?Aa:ua)));$=M+20|0;Ea=c[$>>2]|0;Ba=Ea+-2|0;h=(la|0)>0?la:0;la=(h|0)>(Ba|0)?Ba:h;ua=ea(fa+Ha);Ha=ea(fa+va);h=~~ea(ca(ea(ua>Ha?ua:Ha)));Ba=Ea+-1|0;Ea=(h|0)>0?h:0;h=(Ea|0)>(Ba|0)?Ba:Ea;if(pa>>>0<=Ga>>>0){Ea=la>>>0>h>>>0;Ba=M+36|0;l=H+4|0;k=H+8|0;s=t+12|0;q=J+4|0;r=J+8|0;ta=M+40|0;qa=(sa|0)==0;Ha=ea(ea(ma+oa)-ga);oa=ea(ea(ra+X)-Ca);X=ea(ea(za+ya)-ka);na=f+20|0;f=L+4|0;Pa=L+8|0;Qa=z+4|0;Ra=z+8|0;Sa=w+4|0;Ta=w+8|0;Ua=v+4|0;Va=v+8|0;Wa=A+4|0;Xa=A+8|0;Ya=C+4|0;Za=C+8|0;_a=D+4|0;$a=D+8|0;ab=E+4|0;bb=F+4|0;cb=E+8|0;db=F+8|0;eb=G+4|0;fb=G+8|0;gb=u+4|0;hb=pa;do{if(!Ea){pa=(hb|0)==(Ga|0)?1:3;ya=ea(hb>>>0);ib=la;do{jb=(da(c[$>>2]|0,hb)|0)+ib|0;kb=jb*3|0;lb=(ib|0)==(h|0)?2:0;if(lb>>>0<pa>>>0){mb=lb;do{lb=mb+kb|0;nb=C1a(M,lb,u)|0;ob=c[u>>2]|0;pb=(ob|0)==-1;do if((!(((nb|0)!=2|pb|(c[gb>>2]|0)==-1)&((nb|0)!=1|pb))?(JRa(o,lb,jb,hb,ib,v,w),za=ea(g[La>>2]),ra=ea(za-ea(g[t>>2])),za=ea(g[Ma>>2]),ma=ea(za-ea(g[p>>2])),za=ea(g[Na>>2]),ua=ea(za-ea(g[Ka>>2])),g[z>>2]=ra,g[Qa>>2]=ma,g[Ra>>2]=ua,ua=ea(MOa(t,z,v,w,x,y)),ua<Ia):0)?(ma=ea(g[y>>2]),ma>=ea(0.0)&ma<=ea(1.0)):0){if((mb|0)!=0?ma==ea(0.0)|ma==ea(1.0):0)break;ra=ea(g[x>>2]);za=ea(g[La>>2]);va=ea(g[t>>2]);fa=ea(za-va);za=ea(g[Ma>>2]);Aa=ea(g[p>>2]);Fa=ea(za-Aa);za=ea(g[Na>>2]);ba=ea(g[Ka>>2]);wa=ea(va+ea(ra*fa));fa=ea(Aa+ea(ra*Fa));Fa=ea(ba+ea(ra*ea(za-ba)));ba=ea(g[w>>2]);za=ea(g[Sa>>2]);ra=ea(ma*ba);ba=ea(ma*za);za=ea(ma*ea(g[Ta>>2]));ma=ea(ra+ea(g[v>>2]));ra=ea(ba+ea(g[Ua>>2]));ba=ea(za+ea(g[Va>>2]));za=ea(fa-ra);ra=ea(Fa-ba);g[A>>2]=ea(wa-ma);g[Wa>>2]=za;g[Xa>>2]=ra;ra=ea(g[ta>>2]);if(!(ra<=ea(0.0)&za>ea(0.0))?!(ra>ea(0.0)&za<ea(0.0)):0)break;D1a(C,o,d[na>>0]|0,A,j,ua,ma,ba,Ja,B);ba=ea(g[C>>2]);ma=ea(ba*ea(2.0));ua=ea(g[Ya>>2]);za=ea(ua*ea(2.0));ra=ea(g[Za>>2]);wa=ea(ra*ea(2.0));Fa=ea(g[ja>>2]);fa=ea(ea(Fa*Fa)+ea(-.5));Aa=ea(g[j>>2]);va=ea(ma*Aa);aa=ea(g[e>>2]);V=ea(va+ea(za*aa));va=ea(g[ha>>2]);Da=ea(V+ea(wa*va));V=ea(ea(Aa*Da)+ea(ea(ma*fa)-ea(Fa*ea(ea(wa*aa)-ea(za*va)))));ia=ea(ea(aa*Da)+ea(ea(za*fa)-ea(Fa*ea(ea(ma*va)-ea(wa*Aa)))));xa=ea(ea(ea(wa*fa)-ea(Fa*ea(ea(za*Aa)-ea(ma*aa))))+ea(va*Da));a:do if(!nb){qb=ra;rb=ua;sb=ba}else{tb=ob;ub=1;while(1){E1a(D,M,tb);Da=ea(g[D>>2]);va=ea(Da*ea(g[o>>2]));Da=ea(g[_a>>2]);aa=ea(Da*ea(g[Q>>2]));Da=ea(g[$a>>2]);ma=ea(Da*ea(g[Y>>2]));Da=ea(ea(ea(va*va)+ea(aa*aa))+ea(ma*ma));if(Da>ea(0.0)){Aa=ea(ea(1.0)/ea(T(ea(Da))));vb=ea(aa*Aa);wb=ea(ma*Aa);xb=ea(va*Aa)}else{vb=ea(0.0);wb=ea(0.0);xb=ea(0.0)}yb=tb>>>1;zb=c[$>>2]|0;O0a(M,tb,(yb>>>0)/(zb>>>0)|0,(yb>>>0)%(zb>>>0)|0,E,F,G);Aa=ea(g[E>>2]);va=ea(Aa+ea(g[F>>2]));Aa=ea(g[ab>>2]);ma=ea(Aa+ea(g[bb>>2]));Aa=ea(g[cb>>2]);aa=ea(Aa+ea(g[db>>2]));Aa=ea(va+ea(g[G>>2]));va=ea(ma+ea(g[eb>>2]));ma=ea(Aa*ea(.333333343));Aa=ea(va*ea(.333333343));va=ea(ea(aa+ea(g[fb>>2]))*ea(.333333343));zb=c[O>>2]|0;aa=ea(ma*ea(g[zb+12>>2]));ma=ea(Aa*ea(g[zb+8>>2]));Aa=ea(va*ea(g[zb+16>>2]));va=ea(g[Ta>>2]);Da=ea(vb*va);za=ea(g[Sa>>2]);Fa=ea(Da-ea(wb*za));Da=ea(g[w>>2]);fa=ea(ea(wb*Da)-ea(xb*va));va=ea(ea(xb*za)-ea(vb*Da));Da=ea(ea(va*va)+ea(ea(Fa*Fa)+ea(fa*fa)));if(Da>ea(0.0)){za=ea(ea(1.0)/ea(T(ea(Da))));Ab=ea(Fa*za);Bb=ea(fa*za);Cb=ea(va*za)}else{Ab=ea(0.0);Bb=ea(0.0);Cb=ea(0.0)}za=ea(aa-ea(g[v>>2]));aa=ea(ma-ea(g[Ua>>2]));if(ea(ea(ea(Ab*za)+ea(Bb*aa))+ea(Cb*ea(Aa-ea(g[Va>>2]))))<ea(0.0)){Db=ea(-Ab);Eb=ea(-Bb);Fb=ea(-Cb)}else{Db=Ab;Eb=Bb;Fb=Cb}if(ea(ea(xa*Fb)+ea(ea(ia*Eb)+ea(V*Db)))>ea(0.0))break;if(ub>>>0>=nb>>>0){qb=ra;rb=ua;sb=ba;break a}tb=c[u+(ub<<2)>>2]|0;ub=ub+1|0}Aa=ea(xb*ea(2.0));aa=ea(vb*ea(2.0));za=ea(wb*ea(2.0));ma=ea(g[ja>>2]);va=ea(ea(ma*ma)+ea(-.5));fa=ea(g[j>>2]);Fa=ea(Aa*fa);Da=ea(g[e>>2]);wa=ea(Fa+ea(aa*Da));Fa=ea(g[ha>>2]);_=ea(wa+ea(za*Fa));wa=ea(ea(fa*_)+ea(ea(Aa*va)+ea(ma*ea(ea(za*Da)-ea(aa*Fa)))));Gb=ea(ea(Da*_)+ea(ea(aa*va)+ea(ma*ea(ea(Aa*Fa)-ea(za*fa)))));Hb=ea(ea(ea(za*va)+ea(ma*ea(ea(aa*fa)-ea(Aa*Da))))+ea(Fa*_));g[C>>2]=wa;g[Ya>>2]=Gb;g[Za>>2]=Hb;qb=Hb;rb=Gb;sb=wa}while(0);ba=ea(g[x>>2]);ub=c[Oa>>2]|0;if(ub>>>0<=63){ua=ea(Ha*ba);ra=ea(oa*ba);V=ea(X*ba);ba=ea(ea(g[B>>2])-Z);ia=ea(ea(ga+ua)-ea(Z*qb));ua=ea(ea(Ca+ra)-ea(Z*rb));ra=ea(ea(ka+V)-ea(Z*sb));c[Oa>>2]=ub+1;g[m+(ub<<6)>>2]=sb;g[m+(ub<<6)+4>>2]=rb;g[m+(ub<<6)+8>>2]=qb;g[m+(ub<<6)+16>>2]=ra;g[m+(ub<<6)+20>>2]=ua;g[m+(ub<<6)+24>>2]=ia;g[m+(ub<<6)+12>>2]=ba;c[m+(ub<<6)+48>>2]=-1;c[m+(ub<<6)+52>>2]=ob}}while(0);mb=mb+1|0}while((mb|0)!=(pa|0))}do if((a[(c[(c[N>>2]|0)+36>>2]|0)+(jb<<2)+3>>0]|0)<0?(ba=ea(ya*ea(g[U>>2])),ia=ea(g[P>>2]),ua=ea(ia*ea(b[(c[Ba>>2]|0)+(jb<<2)>>1]|0)),ia=ea(ib>>>0),ra=ea(ia*ea(g[W>>2])),g[H>>2]=ba,g[l>>2]=ua,g[k>>2]=ra,ra=ea(IOa(t,s,H,I)),ra<Ia):0){ua=ea(g[I>>2]);ba=ea(g[La>>2]);ia=ea(g[t>>2]);V=ea(ba-ia);ba=ea(g[Ma>>2]);xa=ea(g[p>>2]);wa=ea(ba-xa);ba=ea(g[Na>>2]);Gb=ea(g[Ka>>2]);Hb=ea(ia+ea(ua*V));V=ea(xa+ea(ua*wa));wa=ea(Gb+ea(ua*ea(ba-Gb)));Gb=ea(g[H>>2]);ba=ea(Hb-Gb);Hb=ea(V-ea(g[l>>2]));V=ea(g[k>>2]);xa=ea(wa-V);g[J>>2]=ba;g[q>>2]=Hb;g[r>>2]=xa;xa=ea(g[ta>>2]);if(!(xa<=ea(0.0)&Hb>ea(0.0))?!(xa>ea(0.0)&Hb<ea(0.0)):0)break;b:do if(qa)Ib=45;else{mb=c[Ba>>2]|0;kb=0;while(1){ob=c[m+(kb<<6)+52>>2]|0;nb=ob>>>1;lb=(ob&1|0)==0;do if((a[mb+(nb<<2)+2>>0]|0)<0)if(lb){ob=c[$>>2]|0;Jb=ob+nb|0;Kb=nb;Lb=nb+1+ob|0;break}else{ob=nb+1|0;Jb=ob;Kb=(c[$>>2]|0)+ob|0;Lb=nb;break}else if(lb){Jb=nb;Kb=nb+1|0;Lb=(c[$>>2]|0)+nb|0;break}else{ob=c[$>>2]|0;pb=nb+1|0;Jb=ob+pb|0;Kb=ob+nb|0;Lb=pb;break}while(0);if((c[m+(kb<<6)+48>>2]|0)==0?(jb|0)==(Jb|0)|(jb|0)==(Kb|0)|(jb|0)==(Lb|0):0)break;nb=kb+1|0;if(nb>>>0<sa>>>0)kb=nb;else{Ib=45;break b}}Hb=ea(g[m+(kb<<6)>>2]);xa=ea(g[m+(kb<<6)+4>>2]);ba=ea(g[m+(kb<<6)+8>>2]);g[K>>2]=ea(1.0);Mb=ua;Nb=ba;Ob=xa;Pb=Hb}while(0);if((Ib|0)==45){Ib=0;g[K>>2]=ea(1.0);D1a(L,o,d[na>>0]|0,J,j,ra,Gb,V,Ja,K);ua=ea(g[L>>2]);Hb=ea(g[f>>2]);xa=ea(g[Pa>>2]);Mb=ea(g[I>>2]);Nb=xa;Ob=Hb;Pb=ua}mb=GRa(o,jb,hb,ib)|0;nb=c[Oa>>2]|0;if(nb>>>0<=63){ua=ea(Ha*Mb);Hb=ea(oa*Mb);xa=ea(X*Mb);ba=ea(ea(g[K>>2])-Z);wa=ea(ea(ga+ua)-ea(Z*Nb));ua=ea(ea(Ca+Hb)-ea(Z*Ob));Hb=ea(ea(ka+xa)-ea(Z*Pb));c[Oa>>2]=nb+1;g[m+(nb<<6)>>2]=Pb;g[m+(nb<<6)+4>>2]=Ob;g[m+(nb<<6)+8>>2]=Nb;g[m+(nb<<6)+16>>2]=Hb;g[m+(nb<<6)+20>>2]=ua;g[m+(nb<<6)+24>>2]=wa;g[m+(nb<<6)+12>>2]=ba;c[m+(nb<<6)+48>>2]=-1;c[m+(nb<<6)+52>>2]=mb}}while(0);ib=ib+1|0}while(ib>>>0<=h>>>0)}hb=hb+1|0}while(hb>>>0<=Ga>>>0)}if(!sa){Qb=c[Oa>>2]|0;Rb=(Qb|0)!=0;i=n;return Rb|0}else Sb=0;do{c[m+(Sb<<6)+48>>2]=-1;Sb=Sb+1|0}while((Sb|0)!=(sa|0));Qb=c[Oa>>2]|0;Rb=(Qb|0)!=0;i=n;return Rb|0}function Aya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=NNa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Bya(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;i=i+560|0;j=f+96|0;k=f+240|0;l=f+264|0;m=f+336|0;n=f+24|0;o=f;p=f+168|0;g[j>>2]=ea(1.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);g[j+16>>2]=ea(1.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);g[j+32>>2]=ea(1.0);g[j+36>>2]=ea(1.0);g[j+40>>2]=ea(0.0);g[j+44>>2]=ea(0.0);g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(1.0);g[j+56>>2]=ea(0.0);g[j+60>>2]=ea(0.0);g[j+64>>2]=ea(0.0);g[j+68>>2]=ea(1.0);q=a+4|0;r=ea(g[q>>2]);s=ea(-r);t=ea(g[a+8>>2]);u=ea(-t);v=ea(g[a+12>>2]);w=ea(-v);g[k>>2]=s;g[k+4>>2]=u;g[k+8>>2]=w;g[k+12>>2]=r;g[k+16>>2]=t;g[k+20>>2]=v;FOa(m,q);GOa(m,l);g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);g[n+16>>2]=ea(1.0);g[n+20>>2]=ea(0.0);g[n+24>>2]=ea(0.0);g[n+28>>2]=ea(0.0);g[n+32>>2]=ea(1.0);g[n+36>>2]=ea(1.0);g[n+40>>2]=ea(0.0);g[n+44>>2]=ea(0.0);g[n+48>>2]=ea(0.0);g[n+52>>2]=ea(1.0);g[n+56>>2]=ea(0.0);g[n+60>>2]=ea(0.0);g[n+64>>2]=ea(0.0);g[n+68>>2]=ea(1.0);m=jOa(b,n,o,p)|0;b=F1a(l,p,k,o,c,d,ea(g[e>>2]),h,j,n,1,m)|0;i=f;return b|0}function Cya(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+336|0;j=f+264|0;k=f+192|0;l=f+168|0;m=f+144|0;n=f+72|0;o=f;g[j>>2]=ea(1.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);g[j+16>>2]=ea(1.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);g[j+32>>2]=ea(1.0);g[j+36>>2]=ea(1.0);g[j+40>>2]=ea(0.0);g[j+44>>2]=ea(0.0);g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(1.0);g[j+56>>2]=ea(0.0);g[j+60>>2]=ea(0.0);g[j+64>>2]=ea(0.0);g[j+68>>2]=ea(1.0);g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(1.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=ea(1.0);g[k+40>>2]=ea(0.0);g[k+44>>2]=ea(0.0);g[k+48>>2]=ea(0.0);g[k+52>>2]=ea(1.0);g[k+56>>2]=ea(0.0);g[k+60>>2]=ea(0.0);g[k+64>>2]=ea(0.0);g[k+68>>2]=ea(1.0);p=jOa(a,j,l,n)|0;a=jOa(b,k,m,o)|0;b=F1a(n,o,l,m,c,d,ea(g[e>>2]),h,j,k,p,a)|0;i=f;return b|0}function Dya(f,h,j,k,l,m,n){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=0,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=Im,ob=Im,pb=Im,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=0,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=0,Ob=0,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=0,Vb=0,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=0,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=0,fc=0,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im;m=i;i=i+8512|0;o=m+36|0;p=m+144|0;q=m+8468|0;r=m;s=m+8432|0;t=m+8504|0;u=m+8508|0;v=m+8408|0;w=m+216|0;x=m+56|0;y=m+128|0;z=m+8420|0;A=ea(g[j>>2]);B=ea(A+A);C=ea(g[j+4>>2]);D=ea(C+C);E=ea(g[j+8>>2]);F=ea(E+E);G=ea(g[j+12>>2]);H=ea(B*G);I=ea(D*G);J=ea(G*F);G=ea(A*D);K=ea(A*F);L=ea(C*D);D=ea(C*F);C=ea(E*F);F=ea(ea(ea(1.0)-L)-C);E=ea(G+J);M=ea(K-I);N=ea(G-J);J=ea(ea(1.0)-ea(A*B));B=ea(J-C);C=ea(D+H);A=ea(K+I);I=ea(D-H);H=ea(J-L);L=ea(g[j+16>>2]);J=ea(g[j+20>>2]);D=ea(g[j+24>>2]);K=ea(g[k>>2]);G=ea(K+K);O=ea(g[k+4>>2]);P=ea(O+O);Q=ea(g[k+8>>2]);S=ea(Q+Q);U=ea(g[k+12>>2]);V=ea(G*U);W=ea(P*U);X=ea(U*S);U=ea(K*P);Y=ea(K*S);Z=ea(O*P);P=ea(O*S);O=ea(Q*S);S=ea(ea(ea(1.0)-Z)-O);Q=ea(U+X);_=ea(Y-W);$=ea(U-X);X=ea(ea(1.0)-ea(K*G));G=ea(X-O);O=ea(P+V);K=ea(Y+W);W=ea(P-V);V=ea(X-Z);Z=ea(g[k+16>>2]);X=ea(g[k+20>>2]);P=ea(g[k+24>>2]);k=c[h+4>>2]|0;j=o+12|0;c[j>>2]=k;aa=o+16|0;c[aa>>2]=h;ba=h+8|0;g[o+4>>2]=ea(ea(1.0)/ea(g[ba>>2]));fa=h+12|0;g[o>>2]=ea(ea(1.0)/ea(g[fa>>2]));ga=h+16|0;h=o+8|0;g[h>>2]=ea(ea(1.0)/ea(g[ga>>2]));ha=f+4|0;if(ea(g[ha>>2])==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0)ia=ea(g[f+12>>2])==ea(1.0);else ia=0;g[p>>2]=ea(1.0);ja=p+4|0;g[ja>>2]=ea(0.0);ka=p+8|0;g[ka>>2]=ea(0.0);la=p+12|0;g[la>>2]=ea(0.0);ma=p+16|0;g[ma>>2]=ea(1.0);na=p+20|0;g[na>>2]=ea(0.0);oa=p+24|0;g[oa>>2]=ea(0.0);pa=p+28|0;g[pa>>2]=ea(0.0);qa=p+32|0;g[qa>>2]=ea(1.0);ra=p+36|0;g[ra>>2]=ea(1.0);sa=p+40|0;g[sa>>2]=ea(0.0);ta=p+44|0;g[ta>>2]=ea(0.0);ua=p+48|0;g[ua>>2]=ea(0.0);va=p+52|0;g[va>>2]=ea(1.0);wa=p+56|0;g[wa>>2]=ea(0.0);xa=p+60|0;g[xa>>2]=ea(0.0);ya=p+64|0;g[ya>>2]=ea(0.0);za=p+68|0;g[za>>2]=ea(1.0);if(!ia)J0a(p,ha,f+16|0);g[q>>2]=S;g[q+4>>2]=Q;g[q+8>>2]=_;g[q+12>>2]=$;g[q+16>>2]=G;g[q+20>>2]=O;g[q+24>>2]=K;g[q+28>>2]=W;g[q+32>>2]=V;F0a(r,q);Y=ea(g[r>>2]);U=ea(F*Y);Aa=ea(g[r+4>>2]);Ba=ea(F*Aa);Ca=ea(g[r+8>>2]);Da=ea(F*Ca);Ea=ea(g[r+12>>2]);Fa=ea(E*Ea);Ga=ea(g[r+16>>2]);Ha=ea(E*Ga);Ia=ea(g[r+20>>2]);Ja=ea(U+Fa);Fa=ea(Ba+Ha);Ha=ea(Da+ea(E*Ia));Da=ea(g[r+24>>2]);Ba=ea(M*Da);U=ea(g[r+28>>2]);Ka=ea(M*U);La=ea(g[r+32>>2]);Ma=ea(Ja+Ba);Ba=ea(Fa+Ka);Ka=ea(Ha+ea(M*La));Ha=ea(ea(ea(N*Y)+ea(B*Ea))+ea(C*Da));Fa=ea(ea(ea(N*Aa)+ea(B*Ga))+ea(C*U));Ja=ea(ea(ea(N*Ca)+ea(B*Ia))+ea(C*La));Na=ea(ea(ea(A*Y)+ea(I*Ea))+ea(H*Da));Da=ea(ea(ea(A*Aa)+ea(I*Ga))+ea(H*U));U=ea(ea(ea(A*Ca)+ea(I*Ia))+ea(H*La));F0a(s,q);La=ea(L-Z);Ia=ea(J-X);Ca=ea(D-P);Ga=ea(La*ea(g[s>>2]));Aa=ea(La*ea(g[s+4>>2]));Ea=ea(La*ea(g[s+8>>2]));La=ea(Ia*ea(g[s+12>>2]));Y=ea(Ia*ea(g[s+16>>2]));Oa=ea(Ga+La);La=ea(Aa+Y);Y=ea(Ea+ea(Ia*ea(g[s+20>>2])));Ia=ea(Ca*ea(g[s+24>>2]));Ea=ea(Ca*ea(g[s+28>>2]));Aa=ea(Oa+Ia);Ia=ea(La+Ea);Ea=ea(Y+ea(Ca*ea(g[s+32>>2])));Ca=ea(g[p>>2]);Y=ea(F*Ca);La=ea(E*Ca);Oa=ea(M*Ca);Ga=ea(g[ja>>2]);Pa=ea(Y+ea(N*Ga));Y=ea(La+ea(B*Ga));La=ea(Oa+ea(C*Ga));Oa=ea(g[ka>>2]);Qa=ea(Pa+ea(A*Oa));Pa=ea(Y+ea(I*Oa));Y=ea(La+ea(H*Oa));La=ea(g[la>>2]);Ra=ea(F*La);Sa=ea(E*La);Ta=ea(M*La);Ua=ea(g[ma>>2]);Va=ea(Ra+ea(N*Ua));Ra=ea(Sa+ea(B*Ua));Sa=ea(Ta+ea(C*Ua));Ta=ea(g[na>>2]);Wa=ea(Va+ea(A*Ta));Va=ea(Ra+ea(I*Ta));Ra=ea(Sa+ea(H*Ta));Sa=ea(g[oa>>2]);Xa=ea(F*Sa);F=ea(E*Sa);E=ea(M*Sa);M=ea(g[pa>>2]);Ya=ea(Xa+ea(N*M));N=ea(F+ea(B*M));B=ea(E+ea(C*M));C=ea(g[qa>>2]);E=ea(Ya+ea(A*C));A=ea(N+ea(I*C));I=ea(B+ea(H*C));qa=c[f+36>>2]|0;f=qa+38|0;pa=i;i=i+((1*((d[f>>0]|0)*12|0)|0)+15&-16)|0;H=ea(ea(ea(Ma*Ca)+ea(Ha*Ga))+ea(Na*Oa));B=ea(ea(ea(Ba*Ca)+ea(Fa*Ga))+ea(Da*Oa));N=ea(ea(ea(Ka*Ca)+ea(Ja*Ga))+ea(U*Oa));Oa=ea(ea(ea(Ma*La)+ea(Ha*Ua))+ea(Na*Ta));Ga=ea(ea(ea(Ba*La)+ea(Fa*Ua))+ea(Da*Ta));Ca=ea(ea(ea(Ka*La)+ea(Ja*Ua))+ea(U*Ta));Ta=ea(ea(ea(Ma*Sa)+ea(Ha*M))+ea(Na*C));Ua=ea(ea(ea(Ba*Sa)+ea(Fa*M))+ea(Da*C));La=ea(ea(ea(Ka*Sa)+ea(Ja*M))+ea(U*C));oa=qa+40|0;na=qa+39|0;ma=(c[oa>>2]|0)+((d[na>>0]|0)*20|0)|0;if(a[f>>0]|0){la=0;do{C=ea(g[ma+(la*12|0)>>2]);M=ea(H*C);Sa=ea(B*C);Ya=ea(N*C);C=ea(g[ma+(la*12|0)+4>>2]);F=ea(M+ea(Oa*C));M=ea(Sa+ea(Ga*C));Sa=ea(Ya+ea(Ca*C));C=ea(g[ma+(la*12|0)+8>>2]);Ya=ea(Ia+ea(M+ea(Ua*C)));M=ea(Ea+ea(Sa+ea(La*C)));g[pa+(la*12|0)>>2]=ea(Aa+ea(F+ea(Ta*C)));g[pa+(la*12|0)+4>>2]=Ya;g[pa+(la*12|0)+8>>2]=M;la=la+1|0;Za=a[f>>0]|0}while(la>>>0<(Za&255)>>>0);if(Za<<24>>24){la=Za&255;Ta=ea(3402823469999999843913219.0e14);La=ea(3402823469999999843913219.0e14);Ca=ea(3402823469999999843913219.0e14);Oa=ea(-3402823469999999843913219.0e14);N=ea(-3402823469999999843913219.0e14);H=ea(-3402823469999999843913219.0e14);Za=0;while(1){M=ea(g[pa+(Za*12|0)>>2]);Ya=Ta<M?Ta:M;C=ea(g[pa+(Za*12|0)+4>>2]);F=La<C?La:C;Sa=ea(g[pa+(Za*12|0)+8>>2]);Xa=Ca<Sa?Ca:Sa;_a=Oa>M?Oa:M;M=N>C?N:C;C=H>Sa?H:Sa;Za=Za+1|0;if(Za>>>0>=la>>>0){$a=Xa;ab=F;bb=Ya;cb=C;db=M;eb=_a;break}else{Ta=Ya;La=F;Ca=Xa;Oa=_a;N=M;H=C}}}else{$a=ea(3402823469999999843913219.0e14);ab=ea(3402823469999999843913219.0e14);bb=ea(3402823469999999843913219.0e14);cb=ea(-3402823469999999843913219.0e14);db=ea(-3402823469999999843913219.0e14);eb=ea(-3402823469999999843913219.0e14)}}else{$a=ea(3402823469999999843913219.0e14);ab=ea(3402823469999999843913219.0e14);bb=ea(3402823469999999843913219.0e14);cb=ea(-3402823469999999843913219.0e14);db=ea(-3402823469999999843913219.0e14);eb=ea(-3402823469999999843913219.0e14)}la=k+40|0;Za=ea(g[la>>2])<=ea(0.0);H=ea(g[o>>2]);N=ea(g[h>>2]);ka=~~ea(R(ea(bb*H)));ja=c[k+16>>2]|0;p=ja+-2|0;s=(ka|0)>0?ka:0;ka=(s|0)>(p|0)?p:s;s=~~ea(ca(ea(eb*H)));p=ja+-1|0;ja=(s|0)>0?s:0;s=(ja|0)>(p|0)?p:ja;ja=~~ea(R(ea($a*N)));p=k+20|0;q=c[p>>2]|0;r=q+-2|0;ha=(ja|0)>0?ja:0;ja=(ha|0)>(r|0)?r:ha;ha=~~ea(ca(ea(cb*N)));r=q+-1|0;q=(ha|0)>0?ha:0;ha=(q|0)>(r|0)?r:q;cb=ea(yRa(k,ka,s,ja,ha));$a=ea(cb*ea(g[ba>>2]));if(Za){if(ab>$a){fb=0;i=m;return fb|0}}else if(db<$a){fb=0;i=m;return fb|0}q=a[f>>0]|0;if(!(q<<24>>24))gb=q&255;else{q=v+4|0;r=v+8|0;hb=n+4096|0;ib=0;do{jb=pa+(ib*12|0)+4|0;db=ea(g[jb>>2]);if(Za){if(db<$a)kb=19}else if(db>$a)kb=19;do if((((kb|0)==19?(kb=0,db=ea(g[pa+(ib*12|0)>>2]),ab=ea(g[pa+(ib*12|0)+8>>2]),cb=ea(db*ea(g[o>>2])),eb=ea(ab*ea(g[h>>2])),!(!(cb>=ea(0.0))|!(eb>=ea(0.0)))):0)?(lb=c[j>>2]|0,cb<ea(ea(g[lb+24>>2])+ea(1.0))):0)?eb<ea(ea(g[lb+28>>2])+ea(1.0)):0){mb=xRa(lb,ea(H*db),ea(N*ab),t,u)|0;ab=ea(g[t>>2]);db=ea(g[u>>2]);eb=ea(g[(c[aa>>2]|0)+8>>2]);cb=ea(eb*ea(t1a(c[j>>2]|0,mb,ab,db)));eb=ea(ea(g[jb>>2])-cb);cb=ea(g[l>>2]);bb=ea(g[la>>2]);if(!(bb<=ea(0.0))|!(eb<=cb)|!(bb<=eb)){if(!(bb>ea(0.0)))break;if(!(eb>ea(-cb)&bb>eb))break}lb=BRa(o,mb,ab,db)|0;if((lb|0)!=-1){db=ea(g[t>>2]);u1a(v,o,mb,db,ea(g[u>>2]));db=ea(g[v>>2]);ab=ea(g[q>>2]);bb=ea(g[r>>2]);cb=ea(ea(ea(db*db)+ea(ab*ab))+ea(bb*bb));if(cb>ea(0.0)){Oa=ea(ea(1.0)/ea(T(ea(cb))));nb=ea(ab*Oa);ob=ea(db*Oa);pb=ea(bb*Oa)}else{nb=ea(0.0);ob=ea(0.0);pb=ea(0.0)}Oa=ea(g[ma+(ib*12|0)>>2]);bb=ea(g[ma+(ib*12|0)+4>>2]);db=ea(g[ma+(ib*12|0)+8>>2]);mb=c[hb>>2]|0;if(mb>>>0<=63){ab=ea(eb*nb);eb=ea(ea(V*pb)+ea(ea(O*nb)+ea(_*ob)));cb=ea(ea(W*pb)+ea(ea(G*nb)+ea(Q*ob)));Ca=ea(ea(K*pb)+ea(ea($*nb)+ea(S*ob)));La=ea(D+ea(ea(ea(Y*Oa)+ea(Ra*bb))+ea(I*db)));Ta=ea(J+ea(ea(ea(Pa*Oa)+ea(Va*bb))+ea(A*db)));C=ea(L+ea(ea(ea(Qa*Oa)+ea(Wa*bb))+ea(E*db)));c[hb>>2]=mb+1;g[n+(mb<<6)>>2]=Ca;g[n+(mb<<6)+4>>2]=cb;g[n+(mb<<6)+8>>2]=eb;g[n+(mb<<6)+16>>2]=C;g[n+(mb<<6)+20>>2]=Ta;g[n+(mb<<6)+24>>2]=La;g[n+(mb<<6)+12>>2]=ab;c[n+(mb<<6)+48>>2]=-1;c[n+(mb<<6)+52>>2]=lb}}}while(0);ib=ib+1|0;jb=d[f>>0]|0}while(ib>>>0<jb>>>0);gb=jb}ib=d[na>>0]|0;f=c[oa>>2]|0;hb=kOa(512,w,ib,f,f+(ib*20|0)+((e[qa+36>>1]<<1)+(gb*15|0))|0)|0;if(hb){gb=x+4|0;qa=x+8|0;ib=x+12|0;f=x+16|0;ma=x+20|0;r=x+24|0;q=x+28|0;v=x+32|0;u=x+36|0;t=x+40|0;la=x+44|0;aa=x+48|0;h=x+52|0;jb=x+56|0;lb=x+60|0;mb=x+64|0;qb=x+68|0;if(Za){rb=0;do{E=ea(B*ea(g[w+(rb<<4)+4>>2]));Wa=ea(E+ea(Ga*ea(g[w+(rb<<4)+8>>2])));do if(!(ea(Wa+ea(Ua*ea(g[w+(rb<<4)+12>>2])))>ea(0.0))){sb=d[w+(rb<<4)>>0]|0;tb=pa+(sb*12|0)|0;ub=d[w+(rb<<4)+1>>0]|0;vb=pa+(ub*12|0)|0;if(ea(g[pa+(sb*12|0)+4>>2])>$a?ea(g[pa+(ub*12|0)+4>>2])>$a:0)break;E=ea(g[vb>>2]);Qa=ea(E-ea(g[tb>>2]));E=ea(g[pa+(ub*12|0)+4>>2]);L=ea(E-ea(g[pa+(sb*12|0)+4>>2]));E=ea(g[pa+(ub*12|0)+8>>2]);A=ea(E-ea(g[pa+(sb*12|0)+8>>2]));E=ea(g[l>>2]);g[x>>2]=Qa;g[gb>>2]=L;g[qa>>2]=A;c[ib>>2]=n;g[f>>2]=S;g[ma>>2]=Q;g[r>>2]=_;g[q>>2]=$;g[v>>2]=G;g[u>>2]=O;g[t>>2]=K;g[la>>2]=W;g[aa>>2]=V;g[h>>2]=Z;g[jb>>2]=X;g[lb>>2]=P;g[mb>>2]=E;c[qb>>2]=-1;v1a(o,tb,vb,x,0)}while(0);rb=rb+1|0}while((rb|0)!=(hb|0))}else{rb=0;do{Wa=ea(B*ea(g[w+(rb<<4)+4>>2]));E=ea(Wa+ea(Ga*ea(g[w+(rb<<4)+8>>2])));do if(!(ea(E+ea(Ua*ea(g[w+(rb<<4)+12>>2])))>ea(0.0))){vb=d[w+(rb<<4)>>0]|0;tb=pa+(vb*12|0)|0;sb=d[w+(rb<<4)+1>>0]|0;ub=pa+(sb*12|0)|0;if(ea(g[pa+(vb*12|0)+4>>2])<$a?ea(g[pa+(sb*12|0)+4>>2])<$a:0)break;Wa=ea(g[ub>>2]);A=ea(Wa-ea(g[tb>>2]));Wa=ea(g[pa+(sb*12|0)+4>>2]);L=ea(Wa-ea(g[pa+(vb*12|0)+4>>2]));Wa=ea(g[pa+(sb*12|0)+8>>2]);Qa=ea(Wa-ea(g[pa+(vb*12|0)+8>>2]));Wa=ea(g[l>>2]);g[x>>2]=A;g[gb>>2]=L;g[qa>>2]=Qa;c[ib>>2]=n;g[f>>2]=S;g[ma>>2]=Q;g[r>>2]=_;g[q>>2]=$;g[v>>2]=G;g[u>>2]=O;g[t>>2]=K;g[la>>2]=W;g[aa>>2]=V;g[h>>2]=Z;g[jb>>2]=X;g[lb>>2]=P;g[mb>>2]=Wa;c[qb>>2]=-1;v1a(o,tb,ub,x,0)}while(0);rb=rb+1|0}while((rb|0)!=(hb|0))}}if(ka>>>0>s>>>0)wb=n+4096|0;else{hb=ja>>>0>ha>>>0;rb=k+36|0;k=y+4|0;x=y+8|0;qb=z+4|0;mb=z+8|0;lb=n+4096|0;jb=ka;while(1){if(!hb){$a=ea(jb>>>0);ka=ja;do{h=(da(c[p>>2]|0,jb)|0)+ka|0;a:do if((a[(c[(c[j>>2]|0)+36>>2]|0)+(h<<2)+3>>0]|0)<0){Ua=ea($a*ea(g[fa>>2]));Ga=ea(g[ba>>2]);B=ea(Ga*ea(b[(c[rb>>2]|0)+(h<<2)>>1]|0));Ga=ea(ea(ka>>>0)*ea(g[ga>>2]));CRa(y,o,h,jb,ka);E=ea(g[y>>2]);if(Za){Wa=ea(g[k>>2]);xb=E;yb=Wa;zb=ea(g[x>>2])}else{Wa=ea(-E);E=ea(-ea(g[k>>2]));xb=Wa;yb=E;zb=ea(-ea(g[x>>2]))}E=ea(ea(zb*zb)+ea(ea(yb*yb)+ea(xb*xb)));if(E>ea(0.0)){Wa=ea(ea(1.0)/ea(T(ea(E))));Ab=ea(xb*Wa);Bb=ea(yb*Wa);Cb=ea(zb*Wa)}else{Ab=ea(0.0);Bb=ea(0.0);Cb=ea(0.0)}Wa=ea(Ua-Aa);E=ea(B-Ia);Qa=ea(Ga-Ea);L=ea(ea(Ka*Qa)+ea(ea(Ma*Wa)+ea(Ba*E)));A=ea(ea(Ja*Qa)+ea(ea(Ha*Wa)+ea(Fa*E)));Va=ea(ea(U*Qa)+ea(ea(Na*Wa)+ea(Da*E)));E=ea(-ea(ea(Ka*Cb)+ea(ea(Ba*Bb)+ea(Ma*Ab))));Wa=ea(-ea(ea(Ja*Cb)+ea(ea(Fa*Bb)+ea(Ha*Ab))));Qa=ea(-ea(ea(U*Cb)+ea(ea(Da*Bb)+ea(Na*Ab))));Pa=ea(g[l>>2]);aa=a[na>>0]|0;if(aa<<24>>24){la=c[oa>>2]|0;if(ia){t=aa&255;J=ea(0.0);I=ea(0.0);Ra=ea(0.0);Y=ea(-3402823469999999843913219.0e14);D=ea(-3402823469999999843913219.0e14);u=0;v=-1;q=-2;while(1){ob=ea(g[la+(u*20|0)>>2]);nb=ea(g[la+(u*20|0)+4>>2]);pb=ea(g[la+(u*20|0)+8>>2]);N=ea(ea(ea(g[la+(u*20|0)+12>>2])+ea(ea(Va*pb)+ea(ea(L*ob)+ea(A*nb))))-Pa);if(N>=ea(0.0))break a;H=ea(ea(ea(ob*E)+ea(nb*Wa))+ea(pb*Qa));do if(H>ea(0.0)){if(N>Y){Db=pb;Eb=nb;Fb=ob;Gb=N;Hb=u}else{Db=Ra;Eb=I;Fb=J;Gb=Y;Hb=v}ab=ea(N/H);if(!(ab>D)){Ib=Db;Jb=Eb;Kb=Fb;Lb=Gb;Mb=D;Nb=Hb;Ob=q;break}Ib=Db;Jb=Eb;Kb=Fb;Lb=Gb;Mb=ab;Nb=Hb;Ob=u}else{Ib=Ra;Jb=I;Kb=J;Lb=Y;Mb=D;Nb=v;Ob=q}while(0);u=u+1|0;if(u>>>0>=t>>>0){Pb=Ib;Qb=Jb;Rb=Kb;Sb=Lb;Tb=Mb;Ub=Nb;Vb=Ob;break}else{J=Kb;I=Jb;Ra=Ib;Y=Lb;D=Mb;v=Nb;q=Ob}}}else{D=ea(g[ra>>2]);Y=ea(g[sa>>2]);Ra=ea(g[ta>>2]);I=ea(g[ua>>2]);J=ea(g[va>>2]);H=ea(g[wa>>2]);N=ea(g[xa>>2]);ob=ea(g[ya>>2]);nb=ea(g[za>>2]);q=aa&255;pb=ea(0.0);ab=ea(0.0);La=ea(0.0);Ta=ea(-3402823469999999843913219.0e14);C=ea(-3402823469999999843913219.0e14);v=0;t=-1;u=-2;while(1){eb=ea(g[la+(v*20|0)+12>>2]);cb=ea(g[la+(v*20|0)>>2]);Ca=ea(D*cb);db=ea(g[la+(v*20|0)+4>>2]);bb=ea(Ca+ea(Y*db));Ca=ea(g[la+(v*20|0)+8>>2]);Oa=ea(bb+ea(Ra*Ca));bb=ea(ea(ea(cb*I)+ea(db*J))+ea(Ca*H));M=ea(ea(ea(cb*N)+ea(db*ob))+ea(Ca*nb));Ca=ea(ea(1.0)/ea(T(ea(ea(ea(Oa*Oa)+ea(bb*bb))+ea(M*M)))));db=ea(Oa*Ca);Oa=ea(bb*Ca);bb=ea(M*Ca);M=ea(ea(ea(eb*Ca)+ea(ea(Va*bb)+ea(ea(A*Oa)+ea(L*db))))-Pa);if(M>=ea(0.0))break a;Ca=ea(ea(bb*Qa)+ea(ea(db*E)+ea(Oa*Wa)));do if(Ca>ea(0.0)){if(M>Ta){Wb=bb;Xb=Oa;Yb=db;Zb=M;_b=v}else{Wb=La;Xb=ab;Yb=pb;Zb=Ta;_b=t}eb=ea(M/Ca);if(!(eb>C)){$b=Wb;ac=Xb;bc=Yb;cc=Zb;dc=C;ec=_b;fc=u;break}$b=Wb;ac=Xb;bc=Yb;cc=Zb;dc=eb;ec=_b;fc=v}else{$b=La;ac=ab;bc=pb;cc=Ta;dc=C;ec=t;fc=u}while(0);v=v+1|0;if(v>>>0>=q>>>0){Pb=$b;Qb=ac;Rb=bc;Sb=cc;Tb=dc;Ub=ec;Vb=fc;break}else{pb=bc;ab=ac;La=$b;Ta=cc;C=dc;t=ec;u=fc}}}if((Ub|0)==(Vb|0)){gc=Pb;hc=Qb;ic=Rb;jc=Sb}else{kc=Tb;kb=73}}else{kc=ea(-3402823469999999843913219.0e14);kb=73}if((kb|0)==73){kb=0;gc=Qa;hc=Wa;ic=E;jc=kc}C=ea(-ic);Ta=ea(-hc);La=ea(-gc);ab=ea(ea(Da*La)+ea(ea(Fa*Ta)+ea(Ba*C)));pb=ea(ea(U*La)+ea(ea(Ja*Ta)+ea(Ka*C)));g[z>>2]=ea(ea(Na*La)+ea(ea(Ha*Ta)+ea(Ma*C)));g[qb>>2]=ab;g[mb>>2]=pb;w1a(o,z,h,jb,ka)|0;pb=ea(g[z>>2]);ab=ea(Ab*pb);C=ea(g[qb>>2]);Ta=ea(ab+ea(Bb*C));ab=ea(g[mb>>2]);if(!(ea(Ta+ea(Cb*ab))<ea(1.1920929e-07))){Ta=ea(ea(ea(pb*pb)+ea(C*C))+ea(ab*ab));if(Ta>ea(0.0)){La=ea(ea(1.0)/ea(T(ea(Ta))));lc=ea(pb*La);mc=ea(C*La);nc=ea(ab*La)}else{lc=ea(0.0);mc=ea(0.0);nc=ea(0.0)}g[z>>2]=lc;g[qb>>2]=mc;g[mb>>2]=nc;u=GRa(o,h,jb,ka)|0;La=ea(g[z>>2]);ab=ea(g[qb>>2]);C=ea(g[mb>>2]);t=c[lb>>2]|0;if(t>>>0<=63){pb=ea(ea(ea(_*La)+ea(O*ab))+ea(V*C));Ta=ea(ea(ea(Q*La)+ea(G*ab))+ea(W*C));Pa=ea(ea(ea(S*La)+ea($*ab))+ea(K*C));C=ea(P+ea(ea(V*Ga)+ea(ea(_*Ua)+ea(O*B))));ab=ea(X+ea(ea(W*Ga)+ea(ea(Q*Ua)+ea(G*B))));La=ea(Z+ea(ea(K*Ga)+ea(ea(S*Ua)+ea($*B))));c[lb>>2]=t+1;g[n+(t<<6)>>2]=Pa;g[n+(t<<6)+4>>2]=Ta;g[n+(t<<6)+8>>2]=pb;g[n+(t<<6)+16>>2]=La;g[n+(t<<6)+20>>2]=ab;g[n+(t<<6)+24>>2]=C;g[n+(t<<6)+12>>2]=jc;c[n+(t<<6)+48>>2]=-1;c[n+(t<<6)+52>>2]=u}}}while(0);ka=ka+1|0}while(ka>>>0<=ha>>>0)}jb=jb+1|0;if(jb>>>0>s>>>0){wb=lb;break}}}fb=(c[wb>>2]|0)!=0;i=m;return fb|0}function Eya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=TNa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Fya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=Im,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=0,X=0,Y=0;h=i;l=ea(g[d>>2]);m=ea(l*ea(2.0));n=ea(g[d+12>>2]);o=ea(n*ea(2.0));p=ea(ea(l*m)+ea(ea(n*o)+ea(-1.0)));q=ea(g[d+8>>2]);r=ea(q*o);s=ea(g[d+4>>2]);t=ea(-p);p=ea(-ea(r+ea(m*s)));r=ea(-ea(ea(m*q)-ea(o*s)));o=ea(g[e>>2]);m=ea(o+o);u=ea(g[e+4>>2]);v=ea(u+u);w=ea(g[e+8>>2]);x=ea(w+w);y=ea(g[e+12>>2]);z=ea(m*y);A=ea(v*y);B=ea(y*x);C=ea(o*v);D=ea(o*x);E=ea(u*v);v=ea(u*x);F=ea(w*x);x=ea(ea(ea(1.0)-E)-F);G=ea(C+B);H=ea(D-A);I=ea(C-B);B=ea(ea(1.0)-ea(o*m));m=ea(B-F);F=ea(v+z);C=ea(D+A);A=ea(v-z);z=ea(B-E);E=ea(g[e+16>>2]);B=ea(g[e+20>>2]);v=ea(g[e+24>>2]);D=ea(-l);l=ea(-s);s=ea(-q);q=ea(E-ea(g[d+16>>2]));J=ea(B-ea(g[d+20>>2]));K=ea(q*ea(2.0));q=ea(J*ea(2.0));J=ea(ea(v-ea(g[d+24>>2]))*ea(2.0));L=ea(ea(ea(ea(ea(K*D)+ea(q*l))+ea(J*s))*D)+ea(ea(ea(ea(n*n)+ea(-.5))*K)+ea(n*ea(ea(J*l)-ea(q*s)))));q=ea(ea(ea(w*l)+ea(ea(y*D)+ea(o*n)))-ea(u*s));J=ea(ea(ea(o*s)+ea(ea(y*l)+ea(u*n)))-ea(w*D));K=ea(ea(ea(u*D)+ea(ea(y*s)+ea(w*n)))-ea(o*l));M=ea(ea(ea(ea(y*n)-ea(o*D))-ea(u*l))-ea(w*s));s=ea(J+J);w=ea(K+K);l=ea(ea(ea(1.0)-ea(J*s))-ea(K*w));K=ea(ea(q*s)-ea(M*w));J=ea(ea(q*w)+ea(M*s));s=ea(g[f>>2]);M=ea(s-L);L=ea(g[b+4>>2]);w=ea(g[b+8>>2]);q=ea(g[b+12>>2]);u=ea(L*l);l=ea(w*K);K=ea(J*q);J=ea(l+u);D=ea(ea(K+J)-M);b=(g[k>>2]=D,c[k>>2]|0);o=ea(ea(J-K)-M);d=(g[k>>2]=o,c[k>>2]|0);J=ea(u-l);n=ea(ea(K+J)-M);e=(g[k>>2]=n,c[k>>2]|0);y=ea(ea(J-K)-M);a=(g[k>>2]=y,c[k>>2]|0);J=ea(-u);N=ea(l-u);u=ea(ea(K+N)-M);O=(g[k>>2]=u,c[k>>2]|0);P=ea(ea(N-K)-M);Q=(g[k>>2]=P,c[k>>2]|0);N=ea(J-l);l=ea(ea(K+N)-M);R=(g[k>>2]=l,c[k>>2]|0);J=ea(ea(N-K)-M);S=(g[k>>2]=J,c[k>>2]|0);if((b|0)<0?(b=j+4096|0,T=c[b>>2]|0,T>>>0<=63):0){M=ea(s+D);D=ea(v+ea(ea(ea(H*L)+ea(F*w))+ea(z*q)));s=ea(B+ea(ea(ea(G*L)+ea(m*w))+ea(A*q)));K=ea(E+ea(ea(ea(x*L)+ea(I*w))+ea(C*q)));c[b>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=K;g[j+(T<<6)+20>>2]=s;g[j+(T<<6)+24>>2]=D;g[j+(T<<6)+12>>2]=M;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((d|0)<0?(M=ea(-q),d=j+4096|0,T=c[d>>2]|0,T>>>0<=63):0){D=ea(z*M);s=ea(A*M);K=ea(C*M);M=ea(ea(H*L)+ea(F*w));N=ea(ea(G*L)+ea(m*w));U=ea(ea(x*L)+ea(I*w));V=ea(o+ea(g[f>>2]));o=ea(v+ea(M+D));D=ea(B+ea(N+s));s=ea(E+ea(U+K));c[d>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=s;g[j+(T<<6)+20>>2]=D;g[j+(T<<6)+24>>2]=o;g[j+(T<<6)+12>>2]=V;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((e|0)<0?(V=ea(-w),e=j+4096|0,T=c[e>>2]|0,T>>>0<=63):0){o=ea(z*q);D=ea(A*q);s=ea(C*q);K=ea(ea(H*L)+ea(F*V));U=ea(ea(G*L)+ea(m*V));N=ea(ea(x*L)+ea(I*V));V=ea(n+ea(g[f>>2]));n=ea(v+ea(o+K));K=ea(B+ea(D+U));U=ea(E+ea(s+N));c[e>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=U;g[j+(T<<6)+20>>2]=K;g[j+(T<<6)+24>>2]=n;g[j+(T<<6)+12>>2]=V;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((a|0)<0?(V=ea(-w),n=ea(-q),a=j+4096|0,T=c[a>>2]|0,T>>>0<=63):0){K=ea(z*n);U=ea(A*n);N=ea(C*n);n=ea(ea(H*L)+ea(F*V));s=ea(ea(G*L)+ea(m*V));D=ea(ea(x*L)+ea(I*V));V=ea(y+ea(g[f>>2]));y=ea(v+ea(n+K));K=ea(B+ea(s+U));U=ea(E+ea(D+N));c[a>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=U;g[j+(T<<6)+20>>2]=K;g[j+(T<<6)+24>>2]=y;g[j+(T<<6)+12>>2]=V;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((O|0)<0?(V=ea(-L),O=j+4096|0,T=c[O>>2]|0,T>>>0<=63):0){y=ea(z*q);K=ea(A*q);U=ea(C*q);N=ea(ea(H*V)+ea(F*w));D=ea(ea(G*V)+ea(m*w));s=ea(ea(x*V)+ea(I*w));V=ea(u+ea(g[f>>2]));u=ea(v+ea(N+y));y=ea(B+ea(D+K));K=ea(E+ea(s+U));c[O>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=K;g[j+(T<<6)+20>>2]=y;g[j+(T<<6)+24>>2]=u;g[j+(T<<6)+12>>2]=V;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((Q|0)<0?(V=ea(-L),u=ea(-q),Q=j+4096|0,T=c[Q>>2]|0,T>>>0<=63):0){y=ea(z*u);K=ea(A*u);U=ea(C*u);u=ea(ea(H*V)+ea(F*w));s=ea(ea(G*V)+ea(m*w));D=ea(ea(x*V)+ea(I*w));V=ea(P+ea(g[f>>2]));P=ea(v+ea(u+y));y=ea(B+ea(s+K));K=ea(E+ea(D+U));c[Q>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=K;g[j+(T<<6)+20>>2]=y;g[j+(T<<6)+24>>2]=P;g[j+(T<<6)+12>>2]=V;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((R|0)<0?(V=ea(-L),P=ea(-w),R=j+4096|0,T=c[R>>2]|0,T>>>0<=63):0){y=ea(z*q);K=ea(A*q);U=ea(C*q);D=ea(ea(H*V)+ea(F*P));s=ea(ea(G*V)+ea(m*P));u=ea(ea(x*V)+ea(I*P));P=ea(l+ea(g[f>>2]));l=ea(v+ea(y+D));D=ea(B+ea(K+s));s=ea(E+ea(U+u));c[R>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=s;g[j+(T<<6)+20>>2]=D;g[j+(T<<6)+24>>2]=l;g[j+(T<<6)+12>>2]=P;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1}if((S|0)>=0){W=j+4096|0;X=c[W>>2]|0;Y=(X|0)!=0;i=h;return Y|0}P=ea(-L);L=ea(-w);w=ea(-q);S=j+4096|0;T=c[S>>2]|0;if(T>>>0>63){W=S;X=c[W>>2]|0;Y=(X|0)!=0;i=h;return Y|0}q=ea(z*w);z=ea(A*w);A=ea(C*w);w=ea(ea(H*P)+ea(F*L));F=ea(ea(G*P)+ea(m*L));m=ea(ea(x*P)+ea(I*L));L=ea(J+ea(g[f>>2]));J=ea(v+ea(w+q));q=ea(B+ea(F+z));z=ea(E+ea(m+A));c[S>>2]=T+1;g[j+(T<<6)>>2]=t;g[j+(T<<6)+4>>2]=p;g[j+(T<<6)+8>>2]=r;g[j+(T<<6)+16>>2]=z;g[j+(T<<6)+20>>2]=q;g[j+(T<<6)+24>>2]=J;g[j+(T<<6)+12>>2]=L;c[j+(T<<6)+48>>2]=-1;c[j+(T<<6)+52>>2]=-1;W=S;X=c[W>>2]|0;Y=(X|0)!=0;i=h;return Y|0}function Gya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=0,v=Im,w=Im,x=0,y=Im,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=Im,O=0,P=Im,Q=Im,R=0;h=i;k=ea(g[d>>2]);l=ea(-k);a=d+4|0;m=ea(g[a>>2]);n=ea(-m);o=d+8|0;p=ea(g[o>>2]);q=ea(-p);r=d+12|0;s=ea(g[r>>2]);t=ea(g[e+16>>2]);u=d+16|0;v=ea(g[u>>2]);w=ea(t-v);t=ea(g[e+20>>2]);x=d+20|0;y=ea(g[x>>2]);z=ea(t-y);t=ea(g[e+24>>2]);A=d+24|0;B=ea(g[A>>2]);C=ea(w*ea(2.0));w=ea(z*ea(2.0));z=ea(ea(t-B)*ea(2.0));t=ea(ea(s*s)+ea(-.5));D=ea(ea(ea(C*l)+ea(w*n))+ea(z*q));E=ea(ea(D*l)+ea(ea(t*C)+ea(s*ea(ea(z*n)-ea(w*q)))));F=ea(ea(D*n)+ea(ea(t*w)+ea(s*ea(ea(C*q)-ea(z*l)))));G=ea(ea(ea(t*z)+ea(s*ea(ea(w*l)-ea(C*n))))+ea(D*q));D=ea(g[e>>2]);C=ea(s*D);w=ea(g[e+12>>2]);z=ea(C+ea(w*l));C=ea(g[e+8>>2]);H=ea(z+ea(C*n));z=ea(g[e+4>>2]);I=ea(H-ea(z*q));H=ea(ea(ea(D*q)+ea(ea(w*n)+ea(s*z)))-ea(C*l));J=ea(ea(ea(z*l)+ea(ea(w*q)+ea(s*C)))-ea(D*n));K=ea(ea(ea(ea(s*w)-ea(D*l))-ea(z*n))-ea(C*q));q=ea(I*ea(2.0));C=ea(K*ea(2.0));n=ea(ea(I*q)+ea(ea(K*C)+ea(-1.0)));K=ea(ea(J*C)+ea(q*H));I=ea(ea(q*J)-ea(C*H));H=ea(g[b+8>>2]);C=ea(H*n);n=ea(H*K);K=ea(H*I);I=ea(E+C);H=ea(E-C);C=ea(F-n);E=ea(G-K);J=ea(g[d>>2]);q=ea(J*ea(2.0));z=ea(g[r>>2]);l=ea(z*ea(2.0));D=ea(ea(J*q)+ea(ea(z*l)+ea(-1.0)));z=ea(g[o>>2]);J=ea(z*l);w=ea(g[a>>2]);L=ea(J+ea(q*w));J=ea(ea(q*z)-ea(l*w));e=b+4|0;w=ea(g[e>>2]);l=ea(I-w);I=ea(H-w);w=ea(g[f>>2]);if(l<=w){z=ea(l*ea(2.0));q=ea(ea(F+n)*ea(2.0));n=ea(ea(G+K)*ea(2.0));K=ea(ea(p*n)+ea(ea(m*q)+ea(k*z)));b=j+4096|0;M=c[b>>2]|0;if(M>>>0>63){N=w;O=1}else{G=ea(-J);F=ea(-L);P=ea(-D);Q=ea(B+ea(ea(ea(t*n)+ea(s*ea(ea(k*q)-ea(m*z))))+ea(p*K)));B=ea(y+ea(ea(m*K)+ea(ea(t*q)+ea(s*ea(ea(p*z)-ea(k*n))))));y=ea(v+ea(ea(ea(t*z)+ea(s*ea(ea(m*n)-ea(p*q))))+ea(k*K)));c[b>>2]=M+1;g[j+(M<<6)>>2]=P;g[j+(M<<6)+4>>2]=F;g[j+(M<<6)+8>>2]=G;g[j+(M<<6)+16>>2]=y;g[j+(M<<6)+20>>2]=B;g[j+(M<<6)+24>>2]=Q;g[j+(M<<6)+12>>2]=l;c[j+(M<<6)+48>>2]=-1;c[j+(M<<6)+52>>2]=-1;N=ea(g[f>>2]);O=1}}else{N=w;O=0}if(!(I<=N)){R=O;i=h;return R|0}N=ea(ea(H-ea(g[e>>2]))*ea(2.0));H=ea(C*ea(2.0));C=ea(E*ea(2.0));E=ea(g[r>>2]);w=ea(ea(E*E)+ea(-.5));l=ea(g[d>>2]);Q=ea(N*l);B=ea(g[a>>2]);y=ea(Q+ea(H*B));Q=ea(g[o>>2]);G=ea(y+ea(C*Q));o=j+4096|0;a=c[o>>2]|0;if(a>>>0>63){R=1;i=h;return R|0}y=ea(Q*G);F=ea(ea(C*w)+ea(E*ea(ea(H*l)-ea(N*B))));P=ea(B*G);K=ea(ea(H*w)+ea(E*ea(ea(N*Q)-ea(C*l))));k=ea(l*G);G=ea(ea(N*w)+ea(E*ea(ea(C*B)-ea(H*Q))));Q=ea(g[A>>2]);H=ea(g[x>>2]);B=ea(-J);J=ea(-L);L=ea(-D);D=ea(ea(F+y)+Q);Q=ea(ea(P+K)+H);H=ea(ea(k+G)+ea(g[u>>2]));c[o>>2]=a+1;g[j+(a<<6)>>2]=L;g[j+(a<<6)+4>>2]=J;g[j+(a<<6)+8>>2]=B;g[j+(a<<6)+16>>2]=H;g[j+(a<<6)+20>>2]=Q;g[j+(a<<6)+24>>2]=D;g[j+(a<<6)+12>>2]=I;c[j+(a<<6)+48>>2]=-1;c[j+(a<<6)+52>>2]=-1;R=1;i=h;return R|0}function Hya(a,b,e,f,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im;j=i;i=i+80|0;a=j;l=c[b+36>>2]|0;m=(c[l+40>>2]|0)+((d[l+39>>0]|0)*20|0)|0;n=d[l+38>>0]|0;o=ea(-ea(g[e>>2]));l=e+4|0;p=ea(-ea(g[l>>2]));q=e+8|0;r=ea(-ea(g[q>>2]));s=e+12|0;t=ea(g[s>>2]);u=ea(g[f+16>>2]);v=e+16|0;w=ea(u-ea(g[v>>2]));u=ea(g[f+20>>2]);x=e+20|0;y=ea(u-ea(g[x>>2]));u=ea(g[f+24>>2]);z=e+24|0;A=ea(w*ea(2.0));w=ea(y*ea(2.0));y=ea(ea(u-ea(g[z>>2]))*ea(2.0));u=ea(ea(t*t)+ea(-.5));B=ea(ea(ea(A*o)+ea(w*p))+ea(y*r));C=ea(ea(B*o)+ea(ea(u*A)+ea(t*ea(ea(y*p)-ea(w*r)))));D=ea(ea(B*p)+ea(ea(u*w)+ea(t*ea(ea(A*r)-ea(y*o)))));E=ea(ea(ea(u*y)+ea(t*ea(ea(w*o)-ea(A*p))))+ea(B*r));B=ea(g[f>>2]);A=ea(t*B);w=ea(g[f+12>>2]);y=ea(A+ea(w*o));A=ea(g[f+8>>2]);u=ea(y+ea(A*p));y=ea(g[f+4>>2]);F=ea(u-ea(y*r));u=ea(ea(ea(B*r)+ea(ea(w*p)+ea(t*y)))-ea(A*o));G=ea(ea(ea(y*o)+ea(ea(w*r)+ea(t*A)))-ea(B*p));H=ea(ea(ea(ea(t*w)-ea(B*o))-ea(y*p))-ea(A*r));r=ea(F+F);A=ea(u+u);p=ea(G+G);y=ea(r*H);o=ea(H*A);B=ea(H*p);H=ea(F*A);w=ea(F*p);t=ea(u*A);A=ea(u*p);u=ea(G*p);p=ea(ea(ea(1.0)-t)-u);G=ea(B+H);I=ea(w-o);J=ea(H-B);B=ea(ea(1.0)-ea(F*r));r=ea(B-u);u=ea(y+A);F=ea(w+o);o=ea(A-y);y=ea(B-t);f=b+4|0;if(ea(g[f>>2])==ea(1.0)?ea(g[b+8>>2])==ea(1.0):0)K=ea(g[b+12>>2])==ea(1.0);else K=0;g[a>>2]=ea(1.0);L=a+4|0;g[L>>2]=ea(0.0);M=a+8|0;g[M>>2]=ea(0.0);N=a+12|0;g[N>>2]=ea(0.0);O=a+16|0;g[O>>2]=ea(1.0);P=a+20|0;g[P>>2]=ea(0.0);Q=a+24|0;g[Q>>2]=ea(0.0);R=a+28|0;g[R>>2]=ea(0.0);S=a+32|0;g[S>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+52>>2]=ea(1.0);g[a+56>>2]=ea(0.0);g[a+60>>2]=ea(0.0);g[a+64>>2]=ea(0.0);g[a+68>>2]=ea(1.0);if(K){T=ea(1.0);U=ea(0.0);V=ea(0.0);W=ea(0.0);X=ea(1.0);Y=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(1.0)}else{J0a(a,f,b+16|0);t=ea(g[a>>2]);B=ea(g[L>>2]);A=ea(g[M>>2]);w=ea(g[N>>2]);H=ea(g[O>>2]);aa=ea(g[P>>2]);ba=ea(g[Q>>2]);ca=ea(g[R>>2]);T=t;U=B;V=A;W=w;X=H;Y=aa;Z=ba;_=ca;$=ea(g[S>>2])}ca=ea(ea(ea(p*T)+ea(J*U))+ea(F*V));ba=ea(ea(ea(G*T)+ea(r*U))+ea(o*V));aa=ea(ea(ea(I*T)+ea(u*U))+ea(y*V));V=ea(ea(ea(p*W)+ea(J*X))+ea(F*Y));U=ea(ea(ea(G*W)+ea(r*X))+ea(o*Y));T=ea(ea(ea(I*W)+ea(u*X))+ea(y*Y));Y=ea(ea(ea(p*Z)+ea(J*_))+ea(F*$));F=ea(ea(ea(G*Z)+ea(r*_))+ea(o*$));o=ea(ea(ea(I*Z)+ea(u*_))+ea(y*$));$=ea(g[e>>2]);y=ea($+$);_=ea(g[l>>2]);u=ea(_+_);Z=ea(g[q>>2]);I=ea(Z+Z);r=ea(g[s>>2]);G=ea(y*r);J=ea(u*r);p=ea(r*I);r=ea($*u);X=ea($*I);W=ea(_*u);u=ea(_*I);_=ea(Z*I);I=ea(ea(ea(1.0)-W)-_);Z=ea(r+p);H=ea(X-J);w=ea(r-p);p=ea(ea(1.0)-ea($*y));y=ea(p-_);_=ea(u+G);$=ea(X+J);J=ea(u-G);G=ea(p-W);W=ea(g[v>>2]);p=ea(g[x>>2]);u=ea(g[z>>2]);X=ea(-I);r=ea(-Z);A=ea(-H);z=k+4096|0;x=m;m=n;n=0;a:while(1){v=x;s=m;do{q=s;s=s+-1|0;if(!q)break a;q=v;v=v+12|0;B=ea(g[q>>2]);t=ea(ca*B);da=ea(ba*B);fa=ea(aa*B);B=ea(g[q+4>>2]);ga=ea(t+ea(V*B));t=ea(da+ea(U*B));da=ea(fa+ea(T*B));B=ea(g[q+8>>2]);ha=ea(C+ea(ga+ea(Y*B)));ia=ea(D+ea(t+ea(F*B)));ja=ea(E+ea(da+ea(o*B)))}while(!(ha<=ea(g[h>>2])));q=c[z>>2]|0;if(q>>>0>63){x=v;m=s;n=1;continue}c[z>>2]=q+1;l=k+(q<<6)|0;if(!l){x=v;m=s;n=1;continue}g[l>>2]=X;g[k+(q<<6)+4>>2]=r;g[k+(q<<6)+8>>2]=A;B=ea(p+ea(ea(J*ja)+ea(ea(Z*ha)+ea(y*ia))));da=ea(u+ea(ea(G*ja)+ea(ea(H*ha)+ea(_*ia))));g[k+(q<<6)+16>>2]=ea(W+ea(ea($*ja)+ea(ea(I*ha)+ea(w*ia))));g[k+(q<<6)+20>>2]=B;g[k+(q<<6)+24>>2]=da;g[k+(q<<6)+12>>2]=ha;c[k+(q<<6)+48>>2]=-1;c[k+(q<<6)+52>>2]=-1;x=v;m=s;n=1}i=j;return n|0}function Iya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=0,L=Im,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0;h=i;k=ea(g[a+4>>2]);l=ea(g[f>>2]);m=ea(g[d+16>>2]);n=ea(g[e+16>>2]);o=ea(m-n);p=ea(g[d+20>>2]);q=ea(g[e+20>>2]);r=ea(p-q);s=ea(g[d+24>>2]);t=ea(g[e+24>>2]);u=ea(s-t);v=ea(o*ea(2.0));w=ea(r*ea(2.0));x=ea(u*ea(2.0));y=ea(g[e+12>>2]);z=ea(ea(y*y)+ea(-.5));A=ea(g[e>>2]);B=ea(v*A);C=ea(g[e+4>>2]);D=ea(B+ea(w*C));B=ea(g[e+8>>2]);E=ea(D+ea(x*B));D=ea(ea(A*E)+ea(ea(v*z)-ea(y*ea(ea(x*C)-ea(w*B)))));F=ea(ea(C*E)+ea(ea(w*z)-ea(y*ea(ea(v*B)-ea(x*A)))));G=ea(ea(ea(x*z)-ea(y*ea(ea(w*A)-ea(v*C))))+ea(B*E));E=ea(g[b+4>>2]);v=ea(-E);if(!(D<v))if(D>E){H=E;I=1}else{H=D;I=0}else{H=v;I=1}v=ea(g[b+8>>2]);D=ea(-v);if(!(F<D))if(F>v){J=v;K=1}else{J=F;K=I}else{J=D;K=1}D=ea(g[b+12>>2]);F=ea(-D);if(!(G<F)){b=G>D;if(b|K){L=b?D:G;M=9}else{w=ea(E-ea(S(ea(H))));E=ea(v-ea(S(ea(J))));v=ea(D-ea(S(ea(G))));do if(E<w)if(E<v){b=J>ea(0.0);N=E;O=ea(0.0);P=ea(0.0);Q=b?ea(2.0):ea(-2.0);break}else{b=G>ea(0.0);N=v;O=b?ea(1.0):ea(-1.0);P=ea(0.0);Q=ea(0.0);break}else if(w<v){b=H>ea(0.0);N=w;O=ea(0.0);P=b?ea(2.0):ea(-2.0);Q=ea(0.0);break}else{b=G>ea(0.0);N=v;O=b?ea(1.0):ea(-1.0);P=ea(0.0);Q=ea(0.0);break}while(0);v=ea(O*ea(2.0));O=ea(ea(ea(P*A)+ea(Q*C))+ea(v*B));R=ea(ea(ea(v*z)+ea(y*ea(ea(Q*A)-ea(P*C))))+ea(B*O));U=ea(ea(C*O)+ea(ea(Q*z)+ea(y*ea(ea(P*B)-ea(v*A)))));V=ea(ea(A*O)+ea(ea(P*z)+ea(y*ea(ea(v*C)-ea(Q*B)))));W=s;X=p;Y=m;Z=ea(-N)}}else{L=F;M=9}do if((M|0)==9){F=ea(H*ea(2.0));N=ea(J*ea(2.0));m=ea(L*ea(2.0));p=ea(ea(ea(A*F)+ea(C*N))+ea(B*m));s=ea(ea(A*p)+ea(ea(z*F)+ea(y*ea(ea(C*m)-ea(B*N)))));Q=ea(ea(C*p)+ea(ea(z*N)+ea(y*ea(ea(B*F)-ea(A*m)))));v=ea(ea(ea(y*ea(ea(A*N)-ea(C*F)))+ea(z*m))+ea(B*p));p=ea(o-s);m=ea(r-Q);F=ea(u-v);N=ea(ea(F*F)+ea(ea(p*p)+ea(m*m)));P=ea(k+l);if(N>ea(P*P)){_=0;i=h;return _|0}else{P=ea(ea(1.0)/ea(T(ea(N))));R=ea(F*P);U=ea(m*P);V=ea(p*P);W=ea(v+t);X=ea(Q+q);Y=ea(s+n);Z=ea(N*P);break}}while(0);M=j+4096|0;b=c[M>>2]|0;if(b>>>0>63){_=1;i=h;return _|0}n=ea(Z-k);c[M>>2]=b+1;g[j+(b<<6)>>2]=V;g[j+(b<<6)+4>>2]=U;g[j+(b<<6)+8>>2]=R;g[j+(b<<6)+16>>2]=Y;g[j+(b<<6)+20>>2]=X;g[j+(b<<6)+24>>2]=W;g[j+(b<<6)+12>>2]=n;c[j+(b<<6)+48>>2]=-1;c[j+(b<<6)+52>>2]=-1;_=1;i=h;return _|0}function Jya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im;h=i;i=i+32|0;k=h+8|0;l=h;m=d+16|0;n=ea(g[e>>2]);o=ea(n*ea(2.0));p=ea(g[e+12>>2]);q=ea(p*ea(2.0));r=ea(ea(n*o)+ea(ea(p*q)+ea(-1.0)));p=ea(g[e+8>>2]);n=ea(p*q);s=ea(g[e+4>>2]);t=ea(n+ea(o*s));n=ea(ea(o*p)-ea(q*s));s=ea(g[b+8>>2]);q=ea(s*r);r=ea(s*t);t=ea(s*n);n=ea(g[e+16>>2]);s=ea(n+q);p=ea(g[e+20>>2]);o=ea(p+r);u=ea(g[e+24>>2]);v=ea(t+u);g[k>>2]=s;e=k+4|0;g[e>>2]=o;w=k+8|0;g[w>>2]=v;v=ea(p-r);r=ea(u-t);x=k+12|0;g[x>>2]=ea(n-q);y=k+16|0;g[y>>2]=v;z=k+20|0;g[z>>2]=r;A=a+4|0;r=ea(g[A>>2]);v=ea(r+ea(g[b+4>>2]));r=ea(v+ea(g[f>>2]));q=ea(IOa(k,k+12|0,m,l));if(!(q<ea(r*r))){B=0;i=h;return B|0}r=ea(g[l>>2]);n=ea(g[x>>2]);t=ea(g[k>>2]);u=ea(n-t);n=ea(g[y>>2]);p=ea(g[e>>2]);o=ea(n-p);n=ea(g[z>>2]);s=ea(g[w>>2]);C=ea(t+ea(r*u));u=ea(p+ea(r*o));o=ea(s+ea(r*ea(n-s)));s=ea(g[m>>2]);n=ea(s-C);C=ea(g[d+20>>2]);r=ea(C-u);u=ea(g[d+24>>2]);p=ea(u-o);o=ea(ea(ea(n*n)+ea(r*r))+ea(p*p));if(o==ea(0.0)){D=ea(0.0);E=ea(0.0);F=ea(1.0)}else{t=ea(ea(1.0)/ea(T(ea(o))));D=ea(p*t);E=ea(r*t);F=ea(n*t)}t=ea(g[A>>2]);A=j+4096|0;d=c[A>>2]|0;if(d>>>0>63){B=1;i=h;return B|0}n=ea(ea(T(ea(q)))-v);v=ea(u-ea(D*t));u=ea(C-ea(E*t));C=ea(s-ea(F*t));c[A>>2]=d+1;g[j+(d<<6)>>2]=F;g[j+(d<<6)+4>>2]=E;g[j+(d<<6)+8>>2]=D;g[j+(d<<6)+16>>2]=C;g[j+(d<<6)+20>>2]=u;g[j+(d<<6)+24>>2]=v;g[j+(d<<6)+12>>2]=n;c[j+(d<<6)+48>>2]=-1;c[j+(d<<6)+52>>2]=-1;B=1;i=h;return B|0}function Kya(a,b,e,f,h,j,k,l){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,U=0,V=Im,W=Im,X=Im,Y=Im,Z=0,_=Im,$=Im,aa=0,ba=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=Im,kb=Im,lb=Im,mb=0,nb=Im,ob=Im,pb=Im,qb=0,rb=0,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=0,bc=0;j=i;i=i+480|0;m=j+120|0;n=j+104|0;o=j+164|0;p=j+316|0;q=j+36|0;r=j+152|0;s=j+168|0;t=j+312|0;u=j+448|0;v=j+456|0;w=j+24|0;x=j+12|0;y=j;z=j+140|0;A=j+80|0;B=j+92|0;C=j+184|0;D=j+108|0;E=c[b+4>>2]|0;F=m+12|0;c[F>>2]=E;G=m+16|0;c[G>>2]=b;H=m+4|0;g[H>>2]=ea(ea(1.0)/ea(g[b+8>>2]));I=ea(ea(1.0)/ea(g[b+12>>2]));g[m>>2]=I;J=ea(ea(1.0)/ea(g[b+16>>2]));K=m+8|0;g[K>>2]=J;L=ea(g[a+4>>2]);M=ea(L*ea(.100000001));a=e+16|0;N=ea(g[a>>2]);O=ea(N-ea(g[f+16>>2]));P=e+20|0;N=ea(g[P>>2]);Q=ea(N-ea(g[f+20>>2]));U=e+24|0;N=ea(g[U>>2]);V=ea(O*ea(2.0));O=ea(Q*ea(2.0));Q=ea(ea(N-ea(g[f+24>>2]))*ea(2.0));e=f+12|0;N=ea(g[e>>2]);W=ea(ea(N*N)+ea(-.5));X=ea(g[f>>2]);Y=ea(V*X);Z=f+4|0;_=ea(g[Z>>2]);$=ea(Y+ea(O*_));aa=f+8|0;Y=ea(g[aa>>2]);ba=ea($+ea(Q*Y));$=ea(ea(X*ba)+ea(ea(V*W)-ea(N*ea(ea(Q*_)-ea(O*Y)))));da=ea(ea(_*ba)+ea(ea(O*W)-ea(N*ea(ea(V*Y)-ea(Q*X)))));fa=ea(ea(ea(Q*W)-ea(N*ea(ea(O*X)-ea(V*_))))+ea(Y*ba));ba=ea(I*$);Y=ea(J*fa);do if((!(!(ba>=ea(0.0))|!(Y>=ea(0.0)))?ba<ea(ea(g[E+24>>2])+ea(1.0)):0)?Y<ea(ea(g[E+28>>2])+ea(1.0)):0){ga=xRa(E,ba,Y,n,o)|0;_=ea(g[n>>2]);V=ea(g[o>>2]);X=ea(g[(c[G>>2]|0)+8>>2]);O=ea(da-ea(X*ea(t1a(c[F>>2]|0,ga,_,V))));ha=E+40|0;X=ea(g[ha>>2]);if(!(X<=ea(0.0))|!(O<=M)|!(X<=O)){if(!(X>ea(0.0)))break;if(!(O>ea(-M)&X>O))break}ia=BRa(m,ga,_,V)|0;if((ia|0)==-1){ja=0;i=j;return ja|0}V=ea(g[Z>>2]);_=ea(V*ea(2.0));X=ea(g[e>>2]);N=ea(X*ea(2.0));W=ea(g[aa>>2]);Q=ea(W*N);ka=ea(g[f>>2]);la=ea(ea(_*ka)-Q);Q=ea(ea(V*_)+ea(ea(X*N)+ea(-1.0)));X=ea(ea(_*W)+ea(N*ka));ga=!(ea(g[ha>>2])<=ea(0.0));ha=k+4096|0;ma=c[ha>>2]|0;na=ma>>>0>63;if(ga){if(na){ja=1;i=j;return ja|0}ka=ea(ea(-O)-L);N=ea(-X);W=ea(-Q);_=ea(-la);c[ha>>2]=ma+1;g[k+(ma<<6)>>2]=_;g[k+(ma<<6)+4>>2]=W;g[k+(ma<<6)+8>>2]=N;g[k+(ma<<6)+16>>2]=ea(g[a>>2]);g[k+(ma<<6)+20>>2]=ea(g[P>>2]);g[k+(ma<<6)+24>>2]=ea(g[U>>2]);g[k+(ma<<6)+12>>2]=ka;c[k+(ma<<6)+48>>2]=-1;c[k+(ma<<6)+52>>2]=ia;ja=1;i=j;return ja|0}else{if(na){ja=1;i=j;return ja|0}ka=ea(O-L);c[ha>>2]=ma+1;g[k+(ma<<6)>>2]=la;g[k+(ma<<6)+4>>2]=Q;g[k+(ma<<6)+8>>2]=X;g[k+(ma<<6)+16>>2]=ea(g[a>>2]);g[k+(ma<<6)+20>>2]=ea(g[P>>2]);g[k+(ma<<6)+24>>2]=ea(g[U>>2]);g[k+(ma<<6)+12>>2]=ka;c[k+(ma<<6)+48>>2]=-1;c[k+(ma<<6)+52>>2]=ia;ja=1;i=j;return ja|0}}while(0);Y=ea(M*M);M=ea(L+ea(g[h>>2]));ba=ea(M*M);ka=ea($*ea(g[m>>2]));X=ea(fa*ea(g[K>>2]));Q=ea(M*ea(S(ea(I))));I=ea(M*ea(S(ea(J))));h=~~ea(R(ea(ka-Q)));F=c[E+16>>2]|0;o=F+-2|0;n=(h|0)>0?h:0;h=(n|0)>(o|0)?o:n;n=~~ea(ca(ea(ka+Q)));o=F+-1|0;F=(n|0)>0?n:0;n=(F|0)>(o|0)?o:F;F=~~ea(R(ea(X-I)));o=E+20|0;ia=c[o>>2]|0;ma=ia+-2|0;ha=(F|0)>0?F:0;F=(ha|0)>(ma|0)?ma:ha;ha=~~ea(ca(ea(X+I)));ma=ia+-1|0;na=(ha|0)>0?ha:0;ha=(na|0)>(ma|0)?ma:na;na=h>>>0<n>>>0;ma=k+4096|0;ga=F>>>0<ha>>>0;oa=r+4|0;pa=r+8|0;qa=s+4|0;ra=s+8|0;sa=E+40|0;ta=b+20|0;b=D+4|0;ua=D+8|0;va=x+4|0;wa=x+8|0;xa=y+4|0;ya=y+8|0;za=z+4|0;Aa=A+4|0;Ba=z+8|0;Ca=A+8|0;Da=B+4|0;Ea=B+8|0;Fa=w+8|0;Ga=w+4|0;Ha=v+4|0;Ia=v+8|0;I=ea(0.0);X=ea(0.0);Q=ea(0.0);Ja=0;Ka=0;while(1){La=(Ja|0)==0;if(na){Ma=La^1;ka=I;J=X;M=Q;Na=h;while(1){if(ga){la=ka;O=J;N=M;Oa=F;while(1){g[r>>2]=$;g[oa>>2]=da;g[pa>>2]=fa;Pa=DRa(m,Na,Oa,r,p,q,La,Ma,1)|0;if(!Pa){Qa=N;Ra=O;Sa=la}else{W=la;_=O;V=N;Ta=0;while(1){Ua=p+(Ta*12|0)|0;Va=ea(g[Ua>>2]);Wa=ea($-Va);Xa=ea(da-ea(g[p+(Ta*12|0)+4>>2]));Ya=p+(Ta*12|0)+8|0;Za=ea(g[Ya>>2]);_a=ea(fa-Za);g[s>>2]=Wa;g[qa>>2]=Xa;g[ra>>2]=_a;$a=ea(g[sa>>2]);if(!($a<=ea(0.0)&Xa>ea(0.0))?!($a>ea(0.0)&Xa<ea(0.0)):0){ab=V;bb=_;cb=W}else{$a=ea(ea(ea(Wa*Wa)+ea(Xa*Xa))+ea(_a*_a));if(!($a>ba)){g[t>>2]=ea(-1.0);db=q+(Ta<<2)|0;eb=c[db>>2]|0;fb=eb>>>30;a:do if((fb|0)==2){gb=c[ma>>2]|0;hb=eb&1073741823;ib=vRa(E,hb,(hb>>>0)/(ia>>>0)|0,(hb>>>0)%(ia>>>0)|0,C)|0;if(Ka>>>0<gb>>>0){if(!ib){hb=Ka;while(1){hb=hb+1|0;if((hb|0)==(gb|0)){jb=V;kb=_;lb=W;mb=41;break a}}}else{nb=W;ob=_;pb=V;qb=Ka}while(1){b:do if((c[k+(qb<<6)+48>>2]|0)==1){hb=c[k+(qb<<6)+52>>2]|0;rb=0;while(1){if((c[C+(rb<<4)>>2]|0)==(hb|0))break;rb=rb+1|0;if(rb>>>0>=ib>>>0){sb=pb;tb=ob;ub=nb;break b}}_a=ea(g[k+(qb<<6)>>2]);Xa=ea(g[k+(qb<<6)+4>>2]);Wa=ea(g[k+(qb<<6)+8>>2]);g[t>>2]=ea(T(ea($a)));sb=Wa;tb=Xa;ub=_a}else{sb=pb;tb=ob;ub=nb}while(0);qb=qb+1|0;if((qb|0)==(gb|0)){jb=sb;kb=tb;lb=ub;mb=41;break}else{nb=ub;ob=tb;pb=sb}}}else{jb=V;kb=_;lb=W;mb=41}}else if((fb|0)==1){gb=eb&1073741823;ib=C1a(E,gb,u)|0;rb=(gb>>>0)/3|0;JRa(m,gb,rb,(rb>>>0)/(ia>>>0)|0,(rb>>>0)%(ia>>>0)|0,v,w);_a=ea(g[Ua>>2]);D1a(x,m,d[ta>>0]|0,s,f,$a,_a,ea(g[Ya>>2]),Y,t);_a=ea(g[x>>2]);Xa=ea(g[va>>2]);Wa=ea(g[wa>>2]);vb=ea(_a*ea(2.0));wb=ea(Xa*ea(2.0));xb=ea(Wa*ea(2.0));yb=ea(g[e>>2]);zb=ea(ea(yb*yb)+ea(-.5));Ab=ea(g[f>>2]);Bb=ea(vb*Ab);Cb=ea(g[Z>>2]);Db=ea(Bb+ea(wb*Cb));Bb=ea(g[aa>>2]);Eb=ea(Db+ea(xb*Bb));Db=ea(ea(Ab*Eb)+ea(ea(vb*zb)-ea(yb*ea(ea(xb*Cb)-ea(wb*Bb)))));Fb=ea(ea(Cb*Eb)+ea(ea(wb*zb)-ea(yb*ea(ea(vb*Bb)-ea(xb*Ab)))));Gb=ea(ea(ea(xb*zb)-ea(yb*ea(ea(wb*Ab)-ea(vb*Cb))))+ea(Bb*Eb));if(!ib){jb=Wa;kb=Xa;lb=_a;mb=41}else{rb=0;while(1){gb=c[u+(rb<<2)>>2]|0;E1a(y,E,gb);Eb=ea(g[y>>2]);Bb=ea(Eb*ea(g[m>>2]));Eb=ea(g[xa>>2]);Cb=ea(Eb*ea(g[H>>2]));Eb=ea(g[ya>>2]);vb=ea(Eb*ea(g[K>>2]));Eb=ea(ea(ea(Bb*Bb)+ea(Cb*Cb))+ea(vb*vb));if(Eb>ea(0.0)){Ab=ea(ea(1.0)/ea(T(ea(Eb))));Hb=ea(Cb*Ab);Ib=ea(vb*Ab);Jb=ea(Bb*Ab)}else{Hb=ea(0.0);Ib=ea(0.0);Jb=ea(0.0)}hb=gb>>>1;Kb=c[o>>2]|0;O0a(E,gb,(hb>>>0)/(Kb>>>0)|0,(hb>>>0)%(Kb>>>0)|0,z,A,B);Ab=ea(g[z>>2]);Bb=ea(Ab+ea(g[A>>2]));Ab=ea(g[za>>2]);vb=ea(Ab+ea(g[Aa>>2]));Ab=ea(g[Ba>>2]);Cb=ea(Ab+ea(g[Ca>>2]));Ab=ea(Bb+ea(g[B>>2]));Bb=ea(vb+ea(g[Da>>2]));vb=ea(Ab*ea(.333333343));Ab=ea(Bb*ea(.333333343));Bb=ea(ea(Cb+ea(g[Ea>>2]))*ea(.333333343));Kb=c[G>>2]|0;Cb=ea(vb*ea(g[Kb+12>>2]));vb=ea(Ab*ea(g[Kb+8>>2]));Ab=ea(Bb*ea(g[Kb+16>>2]));Bb=ea(g[Fa>>2]);Eb=ea(Hb*Bb);wb=ea(g[Ga>>2]);yb=ea(Eb-ea(Ib*wb));Eb=ea(g[w>>2]);zb=ea(ea(Ib*Eb)-ea(Jb*Bb));Bb=ea(ea(Jb*wb)-ea(Hb*Eb));Eb=ea(ea(Bb*Bb)+ea(ea(yb*yb)+ea(zb*zb)));if(Eb>ea(0.0)){wb=ea(ea(1.0)/ea(T(ea(Eb))));Lb=ea(yb*wb);Mb=ea(zb*wb);Nb=ea(Bb*wb)}else{Lb=ea(0.0);Mb=ea(0.0);Nb=ea(0.0)}wb=ea(Cb-ea(g[v>>2]));Cb=ea(vb-ea(g[Ha>>2]));if(ea(ea(ea(Lb*wb)+ea(Mb*Cb))+ea(Nb*ea(Ab-ea(g[Ia>>2]))))<ea(0.0)){Ob=ea(-Lb);Pb=ea(-Mb);Qb=ea(-Nb)}else{Ob=Lb;Pb=Mb;Qb=Nb}rb=rb+1|0;if(ea(ea(Gb*Qb)+ea(ea(Fb*Pb)+ea(Db*Ob)))>ea(0.0))break;if(rb>>>0>=ib>>>0){jb=Wa;kb=Xa;lb=_a;mb=41;break a}}_a=ea(Jb*ea(2.0));Xa=ea(Hb*ea(2.0));Wa=ea(Ib*ea(2.0));Db=ea(g[e>>2]);Fb=ea(ea(Db*Db)+ea(-.5));Gb=ea(g[f>>2]);Ab=ea(_a*Gb);Cb=ea(g[Z>>2]);wb=ea(Ab+ea(Xa*Cb));Ab=ea(g[aa>>2]);vb=ea(wb+ea(Wa*Ab));jb=ea(ea(ea(Wa*Fb)+ea(Db*ea(ea(Xa*Gb)-ea(_a*Cb))))+ea(Ab*vb));kb=ea(ea(Cb*vb)+ea(ea(Xa*Fb)+ea(Db*ea(ea(_a*Ab)-ea(Wa*Gb)))));lb=ea(ea(Gb*vb)+ea(ea(_a*Fb)+ea(Db*ea(ea(Wa*Cb)-ea(Xa*Ab)))));mb=41}}else{Rb=Va;Sb=Za;mb=43}while(0);if((mb|0)==41){mb=0;if(ea(g[t>>2])==ea(-1.0)){Za=ea(g[Ua>>2]);Rb=Za;Sb=ea(g[Ya>>2]);mb=43}else{Tb=jb;Ub=kb;Vb=lb}}if((mb|0)==43){mb=0;D1a(D,m,d[ta>>0]|0,s,f,$a,Rb,Sb,Y,t);Za=ea(g[D>>2]);Va=ea(g[b>>2]);Tb=ea(g[ua>>2]);Ub=Va;Vb=Za}eb=c[ma>>2]|0;if(eb>>>0>63){ab=Tb;bb=Ub;cb=Vb}else{Za=ea(g[t>>2]);Va=ea(g[U>>2]);Ab=ea(g[P>>2]);ib=c[db>>2]&1073741823;Xa=ea(Za-L);Za=ea(Va-ea(L*Tb));Va=ea(Ab-ea(L*Ub));Ab=ea(ea(g[a>>2])-ea(L*Vb));c[ma>>2]=eb+1;g[k+(eb<<6)>>2]=Vb;g[k+(eb<<6)+4>>2]=Ub;g[k+(eb<<6)+8>>2]=Tb;g[k+(eb<<6)+16>>2]=Ab;g[k+(eb<<6)+20>>2]=Va;g[k+(eb<<6)+24>>2]=Za;g[k+(eb<<6)+12>>2]=Xa;c[k+(eb<<6)+48>>2]=fb;c[k+(eb<<6)+52>>2]=ib;ab=Tb;bb=Ub;cb=Vb}}else{ab=V;bb=_;cb=W}}Ta=Ta+1|0;if((Ta|0)==(Pa|0)){Qa=ab;Ra=bb;Sa=cb;break}else{W=cb;_=bb;V=ab}}}Oa=Oa+1|0;if(Oa>>>0>=ha>>>0){Wb=Qa;Xb=Ra;Yb=Sa;break}else{la=Sa;O=Ra;N=Qa}}}else{Wb=M;Xb=J;Yb=ka}Na=Na+1|0;if(Na>>>0>=n>>>0){Zb=Wb;_b=Xb;$b=Yb;break}else{ka=Yb;J=Xb;M=Wb}}}else{Zb=Q;_b=X;$b=I}if(!La){Na=Ja+1|0;if((Na|0)==2)break;else{I=$b;X=_b;Q=Zb;Ja=Na;continue}}else{I=$b;X=_b;Q=Zb;Ja=Ja+1|0;Ka=c[ma>>2]|0;continue}}if(!l)if(!Ka)ac=0;else{l=0;do{c[k+(l<<6)+48>>2]=-1;l=l+1|0}while((l|0)!=(Ka|0));ac=Ka}else ac=Ka;Ka=c[ma>>2]|0;if(ac>>>0<Ka>>>0){l=ac;do{ac=k+(l<<6)+52|0;Ja=c[ac>>2]|0;n=k+(l<<6)+48|0;ha=c[n>>2]|0;if((ha|0)==2){a=c[o>>2]|0;c[ac>>2]=GRa(m,Ja,(Ja>>>0)/(a>>>0)|0,(Ja>>>0)%(a>>>0)|0)|0}else if((ha|0)==1)c[ac>>2]=HRa(m,Ja)|0;c[n>>2]=-1;l=l+1|0;n=c[ma>>2]|0}while(l>>>0<n>>>0);bc=n}else bc=Ka;ja=(bc|0)!=0;i=j;return ja|0}function Lya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=Kya(a,b,c,d,e,f,g,0)|0;i=h;return j|0}function Mya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=ZNa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Nya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0;h=i;k=ea(g[d+16>>2]);l=ea(k-ea(g[e+16>>2]));m=ea(g[d+20>>2]);n=ea(m-ea(g[e+20>>2]));o=ea(g[d+24>>2]);p=ea(l*ea(2.0));l=ea(n*ea(2.0));n=ea(ea(o-ea(g[e+24>>2]))*ea(2.0));q=ea(g[e+12>>2]);r=ea(ea(q*q)+ea(-.5));s=ea(g[e>>2]);t=ea(p*s);u=ea(g[e+4>>2]);v=ea(t+ea(l*u));t=ea(g[e+8>>2]);w=ea(ea(s*ea(v+ea(n*t)))+ea(ea(p*r)-ea(q*ea(ea(n*u)-ea(l*t)))));l=ea(g[a+4>>2]);n=ea(w-l);if(!(n<=ea(g[f>>2]))){x=0;i=h;return x|0}w=ea(s*ea(2.0));r=ea(q*ea(2.0));p=ea(ea(s*w)+ea(ea(q*r)+ea(-1.0)));q=ea(ea(t*r)+ea(w*u));s=ea(ea(w*t)-ea(r*u));f=j+4096|0;a=c[f>>2]|0;if(a>>>0>63){x=1;i=h;return x|0}u=ea(o-ea(l*s));o=ea(m-ea(l*q));m=ea(k-ea(l*p));c[f>>2]=a+1;g[j+(a<<6)>>2]=p;g[j+(a<<6)+4>>2]=q;g[j+(a<<6)+8>>2]=s;g[j+(a<<6)+16>>2]=m;g[j+(a<<6)+20>>2]=o;g[j+(a<<6)+24>>2]=u;g[j+(a<<6)+12>>2]=n;c[j+(a<<6)+48>>2]=-1;c[j+(a<<6)+52>>2]=-1;x=1;i=h;return x|0}function Oya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im;h=i;k=ea(g[d+16>>2]);l=ea(k-ea(g[e+16>>2]));m=ea(g[d+20>>2]);n=ea(m-ea(g[e+20>>2]));o=ea(g[d+24>>2]);p=ea(o-ea(g[e+24>>2]));q=ea(ea(ea(l*l)+ea(n*n))+ea(p*p));r=ea(g[a+4>>2]);s=ea(g[b+4>>2]);t=ea(r+s);u=ea(t+ea(g[f>>2]));if(!(q<ea(u*u))){v=0;i=h;return v|0}u=ea(T(ea(q)));if(!(u<=ea(9.99999974e-06))){q=ea(ea(1.0)/u);w=ea(p*q);x=ea(n*q);y=ea(l*q)}else{w=ea(0.0);x=ea(0.0);y=ea(1.0)}q=ea(ea(ea(u+r)-s)*ea(-.5));f=j+4096|0;b=c[f>>2]|0;if(b>>>0>63){v=1;i=h;return v|0}s=ea(u-t);t=ea(ea(w*q)+o);o=ea(ea(x*q)+m);m=ea(ea(y*q)+k);c[f>>2]=b+1;g[j+(b<<6)>>2]=y;g[j+(b<<6)+4>>2]=x;g[j+(b<<6)+8>>2]=w;g[j+(b<<6)+16>>2]=m;g[j+(b<<6)+20>>2]=o;g[j+(b<<6)+24>>2]=t;g[j+(b<<6)+12>>2]=s;c[j+(b<<6)+48>>2]=-1;c[j+(b<<6)+52>>2]=-1;v=1;i=h;return v|0}function Pya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=ZRa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Qya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=_Ra(a,b,c,d,e,f,g)|0;i=h;return j|0}function Rya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=qSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Sya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=$Ra(a,b,c,d,e,f,g)|0;i=h;return j|0}function Tya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=0,L=0;k=i;i=i+64|0;l=k+16|0;m=k;n=k+44|0;o=k+32|0;p=ea(g[b>>2]);q=b+4|0;r=ea(g[q>>2]);s=b+8|0;t=ea(g[s>>2]);u=ea(g[e>>2]);v=e+4|0;w=ea(g[v>>2]);x=e+8|0;y=ea(p-u);u=ea(r-w);w=ea(t-ea(g[x>>2]));t=ea(g[d>>2]);z=d+4|0;r=ea(g[z>>2]);A=d+8|0;p=ea(g[A>>2]);B=ea(t*t);C=ea(r*r);D=ea(p*p);E=ea(g[f>>2]);F=f+4|0;G=ea(g[F>>2]);H=f+8|0;I=ea(g[H>>2]);J=ea(ea(B+C)+D);D=ea(ea(ea(E*E)+ea(G*G))+ea(I*I));C=ea(ea(ea(t*E)+ea(r*G))+ea(p*I));B=ea(ea(ea(y*t)+ea(u*r))+ea(w*p));K=J>ea(1.1920929e-07);L=D>ea(1.1920929e-07);p=ea(ea(1.0)/D);r=ea(ea(1.0)/C);t=ea(ea(1.0)/B);g[m>>2]=ea(ea(1.0)/J);g[m+4>>2]=p;g[m+8>>2]=r;g[m+12>>2]=t;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;t=ea(g[(K?m:l)>>2]);r=ea(g[(L?m:l)+4>>2]);p=ea(ea(ea(y*E)+ea(u*G))+ea(w*I));I=ea(ea(J*D)-ea(C*C));J=ea(ea(ea(C*p)-ea(B*D))/I);l=J>ea(1.0);D=l?ea(1.0):J;l=D>ea(0.0);J=l?D:ea(0.0);l=!(I<ea(1.1920929e-07));I=ea(r*ea(p+ea(C*(l?J:ea(.5)))));l=I>ea(1.0);J=l?ea(1.0):I;l=J>ea(0.0);I=l?J:ea(0.0);J=ea(t*ea(ea(C*I)-B));l=J>ea(1.0);B=l?ea(1.0):J;l=B>ea(0.0);J=l?B:ea(0.0);g[h>>2]=J;l=h+4|0;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];g[j>>2]=I;o=j+4|0;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];B=ea(g[d>>2]);C=ea(g[z>>2]);t=ea(g[A>>2]);p=ea(g[b>>2]);r=ea(g[q>>2]);D=ea(p+ea(B*J));B=ea(r+ea(C*J));C=ea(ea(g[s>>2])+ea(t*J));J=ea(g[f>>2]);t=ea(g[F>>2]);r=ea(g[H>>2]);p=ea(g[e>>2]);w=ea(g[v>>2]);G=ea(D-ea(p+ea(J*I)));J=ea(B-ea(ea(t*I)+w));w=ea(C-ea(ea(r*I)+ea(g[x>>2])));g[a>>2]=ea(ea(w*w)+ea(ea(G*G)+ea(J*J)));i=k;return}function Uya(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im;h=i;i=i+288|0;k=h+128|0;l=h+96|0;m=h+176|0;n=h+240|0;o=h+48|0;p=h+160|0;q=h+192|0;r=h+224|0;s=h+256|0;t=h+272|0;u=h+32|0;v=h+16|0;w=h;x=h+144|0;y=h+64|0;z=h+80|0;A=h+208|0;B=h+112|0;C=d+16|0;D=ea(g[C>>2]);E=ea(g[C+4>>2]);F=ea(g[C+8>>2]);G=ea(g[d>>2]);H=ea(g[d+4>>2]);I=ea(g[d+8>>2]);J=ea(g[d+12>>2]);d=e+16|0;K=ea(g[d>>2]);L=ea(g[d+4>>2]);M=ea(g[d+8>>2]);N=ea(g[e>>2]);O=ea(g[e+4>>2]);P=ea(g[e+8>>2]);Q=ea(g[e+12>>2]);R=ea(g[a+4>>2]);U=ea(g[a+8>>2]);V=ea(g[b+4>>2]);W=ea(g[b+8>>2]);X=ea(g[f>>2]);Y=ea(ea(D+K)*ea(.5));Z=ea(ea(E+L)*ea(.5));_=ea(ea(F+M)*ea(.5));$=ea(D-Y);D=ea(E-Z);E=ea(F-_);F=ea(K-Y);K=ea(L-Z);L=ea(M-_);c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;M=ea(G*ea(2.0));aa=ea(J*ea(2.0));ba=ea(ea(ea(ea(G*M)+ea(J*aa))+ea(-1.0))*U);J=ea(ea(ea(M*H)+ea(I*aa))*U);G=ea(ea(ea(M*I)-ea(H*aa))*U);U=ea($+ba);aa=ea(D+J);H=ea(E+G);g[v>>2]=U;f=v+4|0;g[f>>2]=aa;b=v+8|0;g[b>>2]=H;g[v+12>>2]=ea(0.0);I=ea($-ba);ba=ea(D-J);J=ea(E-G);G=ea(I-U);U=ea(ba-aa);aa=ea(J-H);g[w>>2]=G;a=w+4|0;g[a>>2]=U;e=w+8|0;g[e>>2]=aa;g[w+12>>2]=ea(0.0);H=ea(N*ea(2.0));E=ea(Q*ea(2.0));D=ea(ea(ea(ea(N*H)+ea(Q*E))+ea(-1.0))*W);Q=ea(ea(ea(H*O)+ea(P*E))*W);N=ea(ea(ea(H*P)-ea(O*E))*W);W=ea(F+D);E=ea(K+Q);O=ea(L+N);g[x>>2]=W;d=x+4|0;g[d>>2]=E;C=x+8|0;g[C>>2]=O;g[x+12>>2]=ea(0.0);P=ea(F-D);D=ea(K-Q);Q=ea(L-N);N=ea(P-W);W=ea(D-E);E=ea(Q-O);g[y>>2]=N;ca=y+4|0;g[ca>>2]=W;da=y+8|0;g[da>>2]=E;g[y+12>>2]=ea(0.0);O=ea(R+V);V=ea(O+X);X=ea(V*V);V=ea(ea(ea(G*G)+ea(U*U))+ea(aa*aa));aa=ea(ea(ea(N*N)+ea(W*W))+ea(E*E));Tya(B,v,w,x,y,z,A);E=ea(g[B>>2]);if(!(X>=E)){fa=0;i=h;return fa|0}B=V<ea(9.99999997e-07);ga=aa<ea(9.99999997e-07);c[l+0>>2]=c[u+0>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[l+12>>2]=c[u+12>>2];W=ea(g[w>>2]);N=ea(g[a>>2]);U=ea(g[e>>2]);G=ea(ea(1.0)/ea(T(ea(V))));L=ea(N*G);K=ea(U*G);g[k>>2]=ea(W*G);g[k+4>>2]=L;g[k+8>>2]=K;g[k+12>>2]=ea(0.0);e=B?l:k;K=ea(g[e>>2]);L=ea(g[e+4>>2]);G=ea(g[e+8>>2]);c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];c[n+12>>2]=c[u+12>>2];F=ea(g[y>>2]);H=ea(g[ca>>2]);$=ea(g[da>>2]);M=ea(ea(1.0)/ea(T(ea(aa))));aa=ea(H*M);ha=ea($*M);g[m>>2]=ea(F*M);g[m+4>>2]=aa;g[m+8>>2]=ha;g[m+12>>2]=ea(0.0);da=ga?n:m;ha=ea(g[da>>2]);aa=ea(g[da+4>>2]);if(ea(S(ea(ea(ea(K*ha)+ea(L*aa))+ea(G*ea(g[da+8>>2])))))>ea(.999800026)){G=ea(g[x>>2]);aa=ea(g[d>>2]);L=ea(g[C>>2]);ha=ea(g[v>>2]);K=ea(g[f>>2]);M=ea(g[b>>2]);ia=ea(I-ha);ja=ea(ba-K);ka=ea(J-M);la=ea(P-G);ma=ea(D-aa);na=ea(Q-L);oa=ea(ea(ea(ia*ia)+ea(ja*ja))+ea(ka*ka));pa=ea(ea(ea(la*la)+ea(ma*ma))+ea(na*na));qa=ea(ea(ea(ea(ea(G-ha)*ia)+ea(ea(aa-K)*ja))+ea(ea(L-M)*ka))/oa);ra=ea(ea(ea(ea(ea(P-ha)*ia)+ea(ea(D-K)*ja))+ea(ea(Q-M)*ka))/oa);ka=ea(ea(ea(ea(la*ea(ha-G))+ea(ma*ea(K-aa)))+ea(na*ea(M-L)))/pa);ja=ea(ea(ea(ea(ea(I-G)*la)+ea(ea(ba-aa)*ma))+ea(ea(J-L)*na))/pa);da=oa==ea(0.0);m=pa==ea(0.0);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[o>>2]=qa;g[o+4>>2]=ra;g[o+8>>2]=ka;g[o+12>>2]=ja;n=da?p:o;ja=ea(g[n>>2]);ka=ea(g[n+4>>2]);n=m?p:o;ra=ea(g[n+8>>2]);qa=ea(g[n+12>>2]);n=ka<=ea(1.0);o=ra<=ea(1.0);p=qa<=ea(1.0);m=ka>=ea(0.0);da=ra>=ea(0.0);ga=qa>=ea(0.0);if(ja<=ea(1.0)&ja>=ea(0.0)?(pa=ea(ea(ja*W)+ha),oa=ea(ea(ja*N)+K),na=ea(ea(ja*U)+M),ja=ea(pa-G),ma=ea(oa-aa),la=ea(na-L),ia=ea(ea(ea(ja*ja)+ea(ma*ma))+ea(la*la)),ia>ea(9.99999997e-07)&X>ia):0){sa=ea(T(ea(ia)));ia=ea(ea(1.0)/sa);ta=ea(ja*ia);ja=ea(ma*ia);ma=ea(la*ia);ca=j+4096|0;y=c[ca>>2]|0;if(y>>>0>63)ua=1;else{ia=ea(_+ea(na-ea(R*ma)));na=ea(Z+ea(oa-ea(R*ja)));oa=ea(Y+ea(pa-ea(R*ta)));pa=ea(sa-O);c[ca>>2]=y+1;ca=j+(y<<6)|0;g[ca>>2]=ta;g[ca+4>>2]=ja;g[ca+8>>2]=ma;g[ca+12>>2]=ea(0.0);ca=j+(y<<6)+16|0;g[ca>>2]=oa;g[ca+4>>2]=na;g[ca+8>>2]=ia;g[ca+12>>2]=ea(0.0);g[j+(y<<6)+12>>2]=pa;c[j+(y<<6)+48>>2]=-1;c[j+(y<<6)+52>>2]=-1;ua=1}}else ua=0;if(n&m?(pa=ea(ea(ka*W)+ha),ia=ea(ea(ka*N)+K),na=ea(ea(ka*U)+M),ka=ea(pa-P),P=ea(ia-D),D=ea(na-Q),Q=ea(ea(ea(ka*ka)+ea(P*P))+ea(D*D)),Q>ea(9.99999997e-07)&X>Q):0){oa=ea(T(ea(Q)));Q=ea(ea(1.0)/oa);ma=ea(ka*Q);ka=ea(P*Q);P=ea(D*Q);m=j+4096|0;n=c[m>>2]|0;if(n>>>0<=63){Q=ea(_+ea(na-ea(R*P)));na=ea(Z+ea(ia-ea(R*ka)));ia=ea(Y+ea(pa-ea(R*ma)));pa=ea(oa-O);c[m>>2]=n+1;m=j+(n<<6)|0;g[m>>2]=ma;g[m+4>>2]=ka;g[m+8>>2]=P;g[m+12>>2]=ea(0.0);m=j+(n<<6)+16|0;g[m>>2]=ia;g[m+4>>2]=na;g[m+8>>2]=Q;g[m+12>>2]=ea(0.0);g[j+(n<<6)+12>>2]=pa;c[j+(n<<6)+48>>2]=-1;c[j+(n<<6)+52>>2]=-1}va=ua+1|0}else va=ua;if(o&da?(pa=ea(ha-ea(ea(ra*F)+G)),Q=ea(K-ea(ea(ra*H)+aa)),na=ea(M-ea(ea(ra*$)+L)),ra=ea(ea(ea(pa*pa)+ea(Q*Q))+ea(na*na)),ra>ea(9.99999997e-07)&X>ra):0){ia=ea(T(ea(ra)));ra=ea(ea(1.0)/ia);P=ea(pa*ra);pa=ea(Q*ra);Q=ea(na*ra);da=j+4096|0;o=c[da>>2]|0;if(o>>>0<=63){ra=ea(_+ea(M-ea(R*Q)));na=ea(Z+ea(K-ea(R*pa)));ka=ea(Y+ea(ha-ea(R*P)));ma=ea(ia-O);c[da>>2]=o+1;da=j+(o<<6)|0;g[da>>2]=P;g[da+4>>2]=pa;g[da+8>>2]=Q;g[da+12>>2]=ea(0.0);da=j+(o<<6)+16|0;g[da>>2]=ka;g[da+4>>2]=na;g[da+8>>2]=ra;g[da+12>>2]=ea(0.0);g[j+(o<<6)+12>>2]=ma;c[j+(o<<6)+48>>2]=-1;c[j+(o<<6)+52>>2]=-1}wa=va+1|0}else wa=va;if(p&ga?(ma=ea(I-ea(ea(qa*F)+G)),ra=ea(ba-ea(ea(qa*H)+aa)),na=ea(J-ea(ea(qa*$)+L)),qa=ea(ea(ea(ma*ma)+ea(ra*ra))+ea(na*na)),qa>ea(9.99999997e-07)&X>qa):0){X=ea(T(ea(qa)));qa=ea(ea(1.0)/X);ka=ea(ma*qa);ma=ea(ra*qa);ra=ea(na*qa);ga=j+4096|0;p=c[ga>>2]|0;if(p>>>0<=63){qa=ea(_+ea(J-ea(R*ra)));J=ea(Z+ea(ba-ea(R*ma)));ba=ea(Y+ea(I-ea(R*ka)));I=ea(X-O);c[ga>>2]=p+1;ga=j+(p<<6)|0;g[ga>>2]=ka;g[ga+4>>2]=ma;g[ga+8>>2]=ra;g[ga+12>>2]=ea(0.0);ga=j+(p<<6)+16|0;g[ga>>2]=ba;g[ga+4>>2]=J;g[ga+8>>2]=qa;g[ga+12>>2]=ea(0.0);g[j+(p<<6)+12>>2]=I;c[j+(p<<6)+48>>2]=-1;c[j+(p<<6)+52>>2]=-1}xa=wa+1|0}else xa=wa;if(!xa){ya=ha;za=K;Aa=M;Ba=G;Ca=aa;Da=L}else{fa=1;i=h;return fa|0}}else{L=ea(g[v>>2]);aa=ea(g[f>>2]);G=ea(g[b>>2]);M=ea(g[x>>2]);K=ea(g[d>>2]);ya=L;za=aa;Aa=G;Ba=M;Ca=K;Da=ea(g[C>>2])}K=ea(g[z>>2]);M=ea(ea(W*K)+ya);ya=ea(ea(N*K)+za);za=ea(ea(U*K)+Aa);Aa=ea(g[A>>2]);K=ea(ea(F*Aa)+Ba);Ba=ea(ea(H*Aa)+Ca);Ca=ea(ea($*Aa)+Da);A=E<ea(9.99999997e-07);z=V>ea(9.99999997e-07);c[r+0>>2]=c[w+0>>2];c[r+4>>2]=c[w+4>>2];c[r+8>>2]=c[w+8>>2];c[r+12>>2]=c[w+12>>2];g[q>>2]=ea(1.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(0.0);w=z?r:q;V=ea(g[w>>2]);Da=ea(g[w+4>>2]);Aa=ea(g[w+8>>2]);$=ea(M-K);K=ea(ya-Ba);Ba=ea(za-Ca);g[t>>2]=V;g[t+4>>2]=Da;g[t+8>>2]=Aa;g[t+12>>2]=ea(0.0);g[s>>2]=$;g[s+4>>2]=K;g[s+8>>2]=Ba;g[s+12>>2]=ea(0.0);w=A?t:s;Ba=ea(g[w>>2]);K=ea(g[w+4>>2]);$=ea(g[w+8>>2]);Aa=ea(ea(1.0)/ea(T(ea(ea(ea(Ba*Ba)+ea(K*K))+ea($*$)))));Da=ea(Ba*Aa);Ba=ea(K*Aa);K=ea($*Aa);w=j+4096|0;s=c[w>>2]|0;if(s>>>0>63){fa=1;i=h;return fa|0}Aa=ea(T(ea(E)));E=ea(R*K);$=ea(R*Ba);V=ea(R*Da);R=ea((A?ea(0.0):Aa)-O);O=ea(_+ea(za-E));E=ea(Z+ea(ya-$));$=ea(Y+ea(M-V));c[w>>2]=s+1;w=j+(s<<6)|0;g[w>>2]=Da;g[w+4>>2]=Ba;g[w+8>>2]=K;g[w+12>>2]=ea(0.0);w=j+(s<<6)+16|0;g[w>>2]=$;g[w+4>>2]=E;g[w+8>>2]=O;g[w+12>>2]=ea(0.0);g[j+(s<<6)+12>>2]=R;c[j+(s<<6)+48>>2]=-1;c[j+(s<<6)+52>>2]=-1;fa=1;i=h;return fa|0}function Vya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=aSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Wya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=bSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Xya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=nSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Yya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=pSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function Zya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=ASa(a,b,c,d,e,f,g)|0;i=h;return j|0}function _ya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=BSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function $ya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=CSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function aza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im;h=i;i=i+64|0;k=h+48|0;l=h+32|0;m=h+16|0;n=h;o=d+16|0;p=ea(g[o>>2]);q=ea(g[o+4>>2]);r=ea(g[o+8>>2]);s=ea(g[e>>2]);t=ea(g[e+4>>2]);u=ea(g[e+8>>2]);v=ea(g[e+12>>2]);o=e+16|0;w=ea(g[o>>2]);x=ea(g[o+4>>2]);y=ea(g[o+8>>2]);z=ea(g[a+4>>2]);A=ea(g[f>>2]);B=ea(g[b+4>>2]);C=ea(g[b+8>>2]);D=ea(g[b+12>>2]);E=ea(p-w);F=ea(q-x);G=ea(r-y);H=ea(ea(v*v)+ea(-.5));I=ea(ea(ea(s*E)+ea(t*F))+ea(u*G));J=ea(ea(ea(s*I)+ea(ea(H*E)-ea(v*ea(ea(t*G)-ea(u*F)))))*ea(2.0));K=ea(ea(ea(t*I)+ea(ea(H*F)-ea(v*ea(ea(u*E)-ea(s*G)))))*ea(2.0));L=ea(ea(ea(ea(H*G)-ea(v*ea(ea(s*F)-ea(t*E))))+ea(u*I))*ea(2.0));I=ea(-B);E=ea(-C);F=ea(-D);G=ea(z+A);A=ea(G*G);G=J<B?J:B;M=K<C?K:C;N=L<D?L:D;O=G>I?G:I;I=M>E?M:E;E=N>F?N:F;F=ea(J-O);N=ea(K-I);M=ea(L-E);G=ea(ea(M*M)+ea(ea(F*F)+ea(N*N)));if(!(A>G)){P=0;i=h;return P|0}A=ea(-J);Q=ea(-K);R=ea(-L);if((C>=(K>Q?K:Q)?B>=(J>A?J:A):0)&D>=(L>R?L:R)){R=ea(-O);L=ea(-I);A=ea(-E);J=ea(B-(O>R?O:R));R=ea(C-(I>L?I:L));L=ea(D-(E>A?E:A));b=R>=L&J>=L&(L==L&ea(0.0)==ea(0.0));f=R>=J&(J==J&ea(0.0)==ea(0.0))&L>=J;a=O>=ea(0.0);A=a?ea(1.0):ea(-1.0);a=I>=ea(0.0);D=a?ea(1.0):ea(-1.0);a=E>=ea(0.0);C=a?ea(1.0):ea(-1.0);B=ea(D*ea(0.0));Q=ea(C*ea(0.0));K=ea(A*ea(0.0));g[l>>2]=A;g[l+4>>2]=B;g[l+8>>2]=Q;g[l+12>>2]=ea(0.0);g[k>>2]=K;g[k+4>>2]=D;g[k+8>>2]=Q;g[k+12>>2]=ea(0.0);a=f?l:k;Q=ea(g[a>>2]);D=ea(g[a+4>>2]);A=ea(g[a+8>>2]);g[n>>2]=K;g[n+4>>2]=B;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);g[m>>2]=Q;g[m+4>>2]=D;g[m+8>>2]=A;g[m+12>>2]=ea(0.0);a=b?n:m;A=ea(g[a>>2]);D=ea(g[a+4>>2]);Q=ea(g[a+8>>2]);C=ea(ea(ea(s*A)+ea(t*D))+ea(u*Q));B=ea(ea(ea(s*C)+ea(ea(H*A)+ea(v*ea(ea(t*Q)-ea(u*D)))))*ea(2.0));K=ea(ea(ea(t*C)+ea(ea(H*D)+ea(v*ea(ea(u*A)-ea(s*Q)))))*ea(2.0));S=ea(ea(ea(ea(H*Q)+ea(v*ea(ea(s*D)-ea(t*A))))+ea(u*C))*ea(2.0));C=ea(ea(-(b?L:f?J:R))-z);f=j+4096|0;b=c[f>>2]|0;c[f>>2]=b+1;f=j+(b<<6)|0;g[f>>2]=B;g[f+4>>2]=K;g[f+8>>2]=S;g[f+12>>2]=ea(0.0);f=j+(b<<6)+16|0;g[f>>2]=p;g[f+4>>2]=q;g[f+8>>2]=r;g[f+12>>2]=ea(0.0);g[j+(b<<6)+12>>2]=C;c[j+(b<<6)+48>>2]=-1;c[j+(b<<6)+52>>2]=-1;P=1;i=h;return P|0}else{C=ea(ea(1.0)/ea(T(ea(G))));G=ea(F*C);F=ea(N*C);N=ea(M*C);M=ea(ea(ea(1.0)/C)-z);z=ea(ea(u*N)+ea(ea(s*G)+ea(t*F)));C=ea(ea(ea(s*z)+ea(ea(H*G)+ea(v*ea(ea(t*N)-ea(u*F)))))*ea(2.0));r=ea(ea(ea(t*z)+ea(ea(H*F)+ea(v*ea(ea(u*G)-ea(s*N)))))*ea(2.0));q=ea(ea(ea(ea(H*N)+ea(v*ea(ea(s*F)-ea(t*G))))+ea(u*z))*ea(2.0));z=ea(ea(u*E)+ea(ea(s*O)+ea(t*I)));G=ea(w+ea(ea(ea(s*z)+ea(ea(H*O)+ea(v*ea(ea(t*E)-ea(u*I)))))*ea(2.0)));w=ea(x+ea(ea(ea(t*z)+ea(ea(H*I)+ea(v*ea(ea(u*O)-ea(s*E)))))*ea(2.0)));x=ea(y+ea(ea(ea(ea(H*E)+ea(v*ea(ea(s*I)-ea(t*O))))+ea(u*z))*ea(2.0)));b=j+4096|0;f=c[b>>2]|0;c[b>>2]=f+1;b=j+(f<<6)|0;g[b>>2]=C;g[b+4>>2]=r;g[b+8>>2]=q;g[b+12>>2]=ea(0.0);b=j+(f<<6)+16|0;g[b>>2]=G;g[b+4>>2]=w;g[b+8>>2]=x;g[b+12>>2]=ea(0.0);g[j+(f<<6)+12>>2]=M;c[j+(f<<6)+48>>2]=-1;c[j+(f<<6)+52>>2]=-1;P=1;i=h;return P|0}return 0}function bza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0;h=i;i=i+32|0;k=h+16|0;l=h;m=d+16|0;n=ea(g[m>>2]);o=ea(g[m+4>>2]);p=ea(g[m+8>>2]);q=ea(g[e>>2]);r=ea(g[e+4>>2]);s=ea(g[e+8>>2]);t=ea(g[e+12>>2]);m=e+16|0;u=ea(g[m>>2]);v=ea(g[m+4>>2]);w=ea(g[m+8>>2]);x=ea(g[a+4>>2]);y=ea(g[b+4>>2]);z=ea(g[f>>2]);A=ea(g[b+8>>2]);B=ea(q*ea(2.0));C=ea(t*ea(2.0));D=ea(ea(ea(ea(q*B)+ea(t*C))+ea(-1.0))*A);t=ea(ea(ea(B*r)+ea(s*C))*A);q=ea(ea(ea(B*s)-ea(r*C))*A);A=ea(u+D);C=ea(v+t);r=ea(w+q);s=ea(x+y);y=ea(s+z);z=ea(n-A);B=ea(o-C);E=ea(p-r);F=ea(ea(u-D)-A);D=ea(ea(v-t)-C);t=ea(ea(w-q)-r);q=ea(ea(t*t)+ea(ea(F*F)+ea(D*D)));w=ea(ea(ea(1.0)/q)*ea(ea(E*t)+ea(ea(z*F)+ea(B*D))));b=w>ea(1.0);v=b?ea(1.0):w;b=v>ea(0.0);w=b?v:ea(0.0);b=q!=ea(0.0);q=b?w:ea(0.0);w=ea(F*q);F=ea(D*q);D=ea(t*q);q=ea(z-w);z=ea(B-F);B=ea(E-D);E=ea(ea(B*B)+ea(ea(q*q)+ea(z*z)));if(!(ea(y*y)>E)){G=0;i=h;return G|0}y=ea(n-ea(A+w));w=ea(o-ea(C+F));F=ea(p-ea(r+D));D=ea(ea(F*F)+ea(ea(y*y)+ea(w*w)));b=D==ea(0.0);r=ea(ea(1.0)/ea(T(ea(D))));D=ea(y*r);y=ea(w*r);w=ea(F*r);g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);g[k>>2]=D;g[k+4>>2]=y;g[k+8>>2]=w;g[k+12>>2]=ea(0.0);f=b?l:k;w=ea(g[f>>2]);y=ea(g[f+4>>2]);D=ea(g[f+8>>2]);r=ea(n-ea(x*w));n=ea(o-ea(x*y));o=ea(p-ea(x*D));x=ea(ea(T(ea(E)))-s);f=j+4096|0;k=c[f>>2]|0;c[f>>2]=k+1;f=j+(k<<6)|0;g[f>>2]=w;g[f+4>>2]=y;g[f+8>>2]=D;g[f+12>>2]=ea(0.0);f=j+(k<<6)+16|0;g[f>>2]=r;g[f+4>>2]=n;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);g[j+(k<<6)+12>>2]=x;c[j+(k<<6)+48>>2]=-1;c[j+(k<<6)+52>>2]=-1;G=1;i=h;return G|0}function cza(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=DSa(a,b,c,d,e,f,g)|0;i=h;return j|0}function dza(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=ESa(a,b,c,d,e,f,g)|0;i=h;return j|0}function eza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im;h=i;b=d+16|0;k=ea(g[b>>2]);l=ea(g[b+4>>2]);m=ea(g[b+8>>2]);b=e+16|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(g[b+8>>2]);q=ea(g[e>>2]);r=ea(g[e+4>>2]);s=ea(g[e+8>>2]);t=ea(g[e+12>>2]);u=ea(g[a+4>>2]);v=ea(k-n);n=ea(l-o);o=ea(m-p);p=ea(ea(ea(ea(q*ea(ea(ea(v*q)+ea(n*r))+ea(o*s)))+ea(ea(v*ea(ea(t*t)+ea(-.5)))-ea(t*ea(ea(o*r)-ea(n*s)))))*ea(2.0))-u);if(!(ea(g[f>>2])>=p)){w=0;i=h;return w|0}n=ea(q*ea(2.0));o=ea(t*ea(2.0));v=ea(ea(n*r)+ea(s*o));x=ea(ea(n*s)-ea(r*o));r=ea(ea(ea(q*n)+ea(t*o))+ea(-1.0));o=ea(k-ea(u*r));k=ea(l-ea(u*v));l=ea(m-ea(u*x));f=j+4096|0;a=c[f>>2]|0;c[f>>2]=a+1;f=j+(a<<6)|0;g[f>>2]=r;g[f+4>>2]=v;g[f+8>>2]=x;g[f+12>>2]=ea(0.0);f=j+(a<<6)+16|0;g[f>>2]=o;g[f+4>>2]=k;g[f+8>>2]=l;g[f+12>>2]=ea(0.0);g[j+(a<<6)+12>>2]=p;c[j+(a<<6)+48>>2]=-1;c[j+(a<<6)+52>>2]=-1;w=1;i=h;return w|0}function fza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0;h=i;i=i+32|0;k=h+16|0;l=h;m=ea(g[f>>2]);f=d+16|0;n=ea(g[f>>2]);o=ea(g[f+4>>2]);p=ea(g[f+8>>2]);f=e+16|0;q=ea(g[f>>2]);r=ea(g[f+4>>2]);s=ea(g[f+8>>2]);t=ea(g[a+4>>2]);u=ea(g[b+4>>2]);v=ea(n-q);q=ea(o-r);r=ea(p-s);s=ea(ea(ea(v*v)+ea(q*q))+ea(r*r));w=ea(t+u);x=ea(m+w);if(!(ea(x*x)>s)){y=0;i=h;return y|0}x=ea(T(ea(s)));b=x<=ea(9.99999974e-06);s=ea(ea(1.0)/x);m=ea(v*s);v=ea(q*s);q=ea(r*s);g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);g[k>>2]=m;g[k+4>>2]=v;g[k+8>>2]=q;g[k+12>>2]=ea(0.0);a=b?l:k;q=ea(g[a>>2]);v=ea(g[a+4>>2]);m=ea(g[a+8>>2]);s=ea(ea(ea(t+x)-u)*ea(-.5));u=ea(n+ea(q*s));n=ea(o+ea(v*s));o=ea(p+ea(s*m));s=ea(x-w);a=j+4096|0;k=c[a>>2]|0;c[a>>2]=k+1;a=j+(k<<6)|0;g[a>>2]=q;g[a+4>>2]=v;g[a+8>>2]=m;g[a+12>>2]=ea(0.0);a=j+(k<<6)+16|0;g[a>>2]=u;g[a+4>>2]=n;g[a+8>>2]=o;g[a+12>>2]=ea(0.0);g[j+(k<<6)+12>>2]=s;c[j+(k<<6)+48>>2]=-1;c[j+(k<<6)+52>>2]=-1;y=1;i=h;return y|0}function gza(b,d){b=b|0;d=d|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0;f=i;h=b+12|0;if(!(c[h>>2]|0)){j=ea(g[b+64>>2]);k=ea(g[b+68>>2]);l=ea(0.0);m=j;n=k;o=ea(g[b+72>>2]);p=ea(ea(1.0)/l);q=b+64|0;r=ea(p*m);g[q>>2]=r;s=b+68|0;t=ea(p*n);g[s>>2]=t;u=b+72|0;v=ea(p*o);g[u>>2]=v;w=b+76|0;a[w>>0]=1;i=f;return}x=b+8|0;y=b+4|0;z=d+12|0;A=d+4|0;B=d+8|0;C=d+16|0;D=d+20|0;E=d+24|0;F=b+64|0;G=b+68|0;H=b+72|0;I=b+40|0;J=b+44|0;K=b+48|0;L=b+52|0;M=b+56|0;N=b+60|0;O=0;do{P=c[(c[x>>2]|0)+(O<<2)>>2]|0;Q=c[(c[b>>2]|0)+40>>2]|0;R=c[Q+12>>2]|0;if(!(a[Q+156>>0]&2)){S=c[Q+8>>2]|0;T=S+((c[R+(P*12|0)+4>>2]|0)*12|0)|0;U=S+((c[R+(P*12|0)+8>>2]|0)*12|0)|0;V=S+((c[R+(P*12|0)>>2]|0)*12|0)|0}else{S=c[Q+8>>2]|0;T=S+((e[R+(P*6|0)+2>>1]|0)*12|0)|0;U=S+((e[R+(P*6|0)+4>>1]|0)*12|0)|0;V=S+((e[R+(P*6|0)>>1]|0)*12|0)|0}P=c[y>>2]|0;k=ea(g[V>>2]);j=ea(k*ea(g[P>>2]));W=ea(k*ea(g[P+4>>2]));X=ea(k*ea(g[P+8>>2]));k=ea(g[V+4>>2]);Y=ea(k*ea(g[P+12>>2]));Z=ea(k*ea(g[P+16>>2]));_=ea(j+Y);Y=ea(W+Z);Z=ea(X+ea(k*ea(g[P+20>>2])));k=ea(g[V+8>>2]);X=ea(k*ea(g[P+24>>2]));W=ea(k*ea(g[P+28>>2]));j=ea(ea(_+X)*ea(2.0));X=ea(ea(Y+W)*ea(2.0));W=ea(ea(Z+ea(k*ea(g[P+32>>2])))*ea(2.0));k=ea(g[z>>2]);Z=ea(ea(k*k)+ea(-.5));Y=ea(g[d>>2]);_=ea(j*Y);$=ea(g[A>>2]);aa=ea(_+ea(X*$));_=ea(g[B>>2]);ba=ea(aa+ea(W*_));aa=ea(ea(Y*ba)+ea(ea(j*Z)+ea(k*ea(ea(W*$)-ea(X*_)))));ca=ea(ea($*ba)+ea(ea(X*Z)+ea(k*ea(ea(j*_)-ea(Y*W)))));da=ea(ea(ea(W*Z)+ea(k*ea(ea(X*Y)-ea(j*$))))+ea(_*ba));ba=ea(ea(g[C>>2])+aa);aa=ea(ea(g[D>>2])+ca);ca=ea(ea(g[E>>2])+da);g[F>>2]=ea(ea(g[F>>2])+ba);g[G>>2]=ea(ea(g[G>>2])+aa);g[H>>2]=ea(ca+ea(g[H>>2]));da=ea(g[I>>2]);_=ea(g[J>>2]);$=ea(g[K>>2]);g[I>>2]=da<ba?da:ba;g[J>>2]=_<aa?_:aa;g[K>>2]=$<ca?$:ca;$=ea(g[L>>2]);_=ea(g[M>>2]);da=ea(g[N>>2]);g[L>>2]=$>ba?$:ba;g[M>>2]=_>aa?_:aa;g[N>>2]=da>ca?da:ca;P=c[y>>2]|0;ca=ea(g[T>>2]);da=ea(ca*ea(g[P>>2]));aa=ea(ca*ea(g[P+4>>2]));_=ea(ca*ea(g[P+8>>2]));ca=ea(g[T+4>>2]);ba=ea(ca*ea(g[P+12>>2]));$=ea(ca*ea(g[P+16>>2]));j=ea(da+ba);ba=ea(aa+$);$=ea(_+ea(ca*ea(g[P+20>>2])));ca=ea(g[T+8>>2]);_=ea(ca*ea(g[P+24>>2]));aa=ea(ca*ea(g[P+28>>2]));da=ea(ea(j+_)*ea(2.0));_=ea(ea(ba+aa)*ea(2.0));aa=ea(ea($+ea(ca*ea(g[P+32>>2])))*ea(2.0));ca=ea(g[z>>2]);$=ea(ea(ca*ca)+ea(-.5));ba=ea(g[d>>2]);j=ea(da*ba);Y=ea(g[A>>2]);X=ea(j+ea(_*Y));j=ea(g[B>>2]);k=ea(X+ea(aa*j));X=ea(ea(ba*k)+ea(ea(da*$)+ea(ca*ea(ea(aa*Y)-ea(_*j)))));Z=ea(ea(Y*k)+ea(ea(_*$)+ea(ca*ea(ea(da*j)-ea(ba*aa)))));W=ea(ea(ea(aa*$)+ea(ca*ea(ea(_*ba)-ea(da*Y))))+ea(j*k));k=ea(ea(g[C>>2])+X);X=ea(ea(g[D>>2])+Z);Z=ea(ea(g[E>>2])+W);g[F>>2]=ea(ea(g[F>>2])+k);g[G>>2]=ea(ea(g[G>>2])+X);g[H>>2]=ea(Z+ea(g[H>>2]));W=ea(g[I>>2]);j=ea(g[J>>2]);Y=ea(g[K>>2]);g[I>>2]=W<k?W:k;g[J>>2]=j<X?j:X;g[K>>2]=Y<Z?Y:Z;Y=ea(g[L>>2]);j=ea(g[M>>2]);W=ea(g[N>>2]);g[L>>2]=Y>k?Y:k;g[M>>2]=j>X?j:X;g[N>>2]=W>Z?W:Z;P=c[y>>2]|0;Z=ea(g[U>>2]);W=ea(Z*ea(g[P>>2]));X=ea(Z*ea(g[P+4>>2]));j=ea(Z*ea(g[P+8>>2]));Z=ea(g[U+4>>2]);k=ea(Z*ea(g[P+12>>2]));Y=ea(Z*ea(g[P+16>>2]));da=ea(W+k);k=ea(X+Y);Y=ea(j+ea(Z*ea(g[P+20>>2])));Z=ea(g[U+8>>2]);j=ea(Z*ea(g[P+24>>2]));X=ea(Z*ea(g[P+28>>2]));W=ea(ea(da+j)*ea(2.0));j=ea(ea(k+X)*ea(2.0));X=ea(ea(Y+ea(Z*ea(g[P+32>>2])))*ea(2.0));Z=ea(g[z>>2]);Y=ea(ea(Z*Z)+ea(-.5));k=ea(g[d>>2]);da=ea(W*k);ba=ea(g[A>>2]);_=ea(da+ea(j*ba));da=ea(g[B>>2]);ca=ea(_+ea(X*da));_=ea(ea(k*ca)+ea(ea(W*Y)+ea(Z*ea(ea(X*ba)-ea(j*da)))));$=ea(ea(ba*ca)+ea(ea(j*Y)+ea(Z*ea(ea(W*da)-ea(k*X)))));aa=ea(ea(ea(X*Y)+ea(Z*ea(ea(j*k)-ea(W*ba))))+ea(da*ca));ca=ea(ea(g[C>>2])+_);_=ea(ea(g[D>>2])+$);$=ea(ea(g[E>>2])+aa);fa=ea(ea(g[F>>2])+ca);g[F>>2]=fa;ga=ea(ea(g[G>>2])+_);g[G>>2]=ga;ha=ea($+ea(g[H>>2]));g[H>>2]=ha;aa=ea(g[I>>2]);da=ea(g[J>>2]);ba=ea(g[K>>2]);g[I>>2]=aa<ca?aa:ca;g[J>>2]=da<_?da:_;g[K>>2]=ba<$?ba:$;ba=ea(g[L>>2]);da=ea(g[M>>2]);aa=ea(g[N>>2]);g[L>>2]=ba>ca?ba:ca;g[M>>2]=da>_?da:_;g[N>>2]=aa>$?aa:$;O=O+1|0;ia=c[h>>2]|0}while(O>>>0<ia>>>0);l=ea((ia*3|0)>>>0);m=fa;n=ga;o=ha;p=ea(ea(1.0)/l);q=b+64|0;r=ea(p*m);g[q>>2]=r;s=b+68|0;t=ea(p*n);g[s>>2]=t;u=b+72|0;v=ea(p*o);g[u>>2]=v;w=b+76|0;a[w>>0]=1;i=f;return}function hza(b,d,f){b=b|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;h=i;j=c[(c[d+8>>2]|0)+(f<<2)>>2]|0;f=c[(c[d>>2]|0)+40>>2]|0;k=c[f+12>>2]|0;if(!(a[f+156>>0]&2)){l=c[f+8>>2]|0;m=l+((c[k+(j*12|0)+8>>2]|0)*12|0)|0;n=l+((c[k+(j*12|0)>>2]|0)*12|0)|0;o=l+((c[k+(j*12|0)+4>>2]|0)*12|0)|0}else{l=c[f+8>>2]|0;m=l+((e[k+(j*6|0)+4>>1]|0)*12|0)|0;n=l+((e[k+(j*6|0)>>1]|0)*12|0)|0;o=l+((e[k+(j*6|0)+2>>1]|0)*12|0)|0}j=c[d+4>>2]|0;p=ea(g[n>>2]);q=ea(g[j>>2]);r=ea(p*q);s=ea(g[j+4>>2]);t=ea(p*s);u=ea(g[j+8>>2]);v=ea(p*u);p=ea(g[n+4>>2]);w=ea(g[j+12>>2]);x=ea(p*w);y=ea(g[j+16>>2]);z=ea(p*y);A=ea(g[j+20>>2]);B=ea(r+x);x=ea(t+z);z=ea(v+ea(p*A));p=ea(g[n+8>>2]);v=ea(g[j+24>>2]);t=ea(p*v);r=ea(g[j+28>>2]);C=ea(p*r);D=ea(g[j+32>>2]);E=ea(B+t);t=ea(x+C);C=ea(z+ea(p*D));p=ea(g[o>>2]);z=ea(q*p);x=ea(s*p);B=ea(u*p);p=ea(g[o+4>>2]);F=ea(z+ea(w*p));z=ea(x+ea(y*p));x=ea(B+ea(A*p));p=ea(g[o+8>>2]);B=ea(F+ea(v*p));F=ea(z+ea(r*p));z=ea(x+ea(D*p));p=ea(g[m>>2]);x=ea(q*p);q=ea(s*p);s=ea(u*p);p=ea(g[m+4>>2]);u=ea(x+ea(w*p));w=ea(q+ea(y*p));y=ea(s+ea(A*p));p=ea(g[m+8>>2]);A=ea(E-B);B=ea(t-F);F=ea(C-z);z=ea(E-ea(u+ea(v*p)));v=ea(t-ea(w+ea(r*p)));r=ea(C-ea(y+ea(D*p)));p=ea(ea(B*r)-ea(F*v));D=ea(ea(F*z)-ea(A*r));r=ea(ea(A*v)-ea(B*z));z=ea(ea(r*r)+ea(ea(p*p)+ea(D*D)));if(z>ea(0.0)){B=ea(ea(1.0)/ea(T(ea(z))));z=ea(D*B);D=ea(r*B);g[b>>2]=ea(p*B);g[b+4>>2]=z;g[b+8>>2]=D;i=h;return}else{g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=h;return}}function iza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=0,oa=Im;f=i;i=i+368|0;k=f+16|0;l=f+152|0;m=f+260|0;n=f;o=f+248|0;p=f+272|0;q=f+308|0;r=f+176|0;s=f+164|0;t=f+88|0;u=f+104|0;v=f+236|0;w=c[b>>2]|0;x=w+36|0;y=w+40|0;J0a(k,y,w+52|0);z=ea(g[a+56>>2]);A=ea(z-ea(g[a+28>>2]));z=ea(g[a+60>>2]);B=ea(z-ea(g[a+32>>2]));z=ea(g[a+64>>2]);C=ea(z-ea(g[a+36>>2]));g[l>>2]=A;g[l+4>>2]=B;g[l+8>>2]=C;z=ea(g[b+56>>2]);D=ea(z-ea(g[b+28>>2]));z=ea(g[b+60>>2]);E=ea(z-ea(g[b+32>>2]));z=ea(g[b+64>>2]);F=ea(z-ea(g[b+36>>2]));g[m>>2]=D;g[m+4>>2]=E;g[m+8>>2]=F;z=ea(A-D);D=ea(B-E);E=ea(C-F);g[n>>2]=z;g[n+4>>2]=D;g[n+8>>2]=E;g[o>>2]=z;G=o+4|0;g[G>>2]=D;H=o+8|0;g[H>>2]=E;F=ea(T(ea(ea(E*E)+ea(ea(z*z)+ea(D*D)))));if(F>ea(0.0)){C=ea(ea(1.0)/F);g[o>>2]=ea(z*C);g[G>>2]=ea(D*C);g[H>>2]=ea(E*C)}C=ea(g[a+12>>2]);E=ea(g[a+16>>2]);D=ea(g[a+20>>2]);z=ea(g[a+24>>2]);B=ea(C+C);A=ea(E+E);I=ea(D+D);J=ea(C*B);C=ea(E*A);K=ea(D*I);L=ea(B*E);E=ea(B*D);M=ea(B*z);B=ea(A*D);D=ea(A*z);A=ea(I*z);z=ea(L+A);I=ea(E-D);g[p>>2]=ea(ea(ea(1.0)-C)-K);g[p+4>>2]=z;g[p+8>>2]=I;I=ea(ea(1.0)-J);J=ea(I-K);K=ea(B+M);g[p+12>>2]=ea(L-A);g[p+16>>2]=J;g[p+20>>2]=K;K=ea(B-M);M=ea(I-C);g[p+24>>2]=ea(E+D);g[p+28>>2]=K;g[p+32>>2]=M;H=a+68|0;G=a+80|0;wLa(q,H,G,p,o,F);AOa(r,q,b+40|0,y);y=r+48|0;g[y>>2]=ea(ea(g[y>>2])+j);y=r+52|0;g[y>>2]=ea(ea(g[y>>2])+j);y=r+56|0;g[y>>2]=ea(ea(g[y>>2])+j);g[s>>2]=ea(g[G>>2]);g[s+4>>2]=ea(g[a+84>>2]);g[s+8>>2]=ea(g[a+88>>2]);F=ea(ea(g[H>>2])+j);M=ea(ea(g[a+72>>2])+j);K=ea(ea(g[a+76>>2])+j);g[t>>2]=F;g[t+4>>2]=M;g[t+8>>2]=K;H=(d|0)!=0;if(H)N=ea(g[a+8>>2]);else N=ea(0.0);a=(e|0)!=0;if(a)O=ea(g[b+8>>2]);else O=ea(0.0);K=N>O?N:O;if(H)P=ea(g[(c[d+60>>2]|0)+4>>2]);else P=ea(1.0);if(!a){Q=ea(1.0);R=P<Q;S=R?P:Q;U=ea(K*S);V=u+4|0;c[V>>2]=2;c[u>>2]=500312;W=u+12|0;g[W>>2]=U;X=u+16|0;c[X>>2]=x;Y=u+20|0;c[Y>>2]=k;Z=u+24|0;c[Z>>2]=n;_=u+28|0;c[_>>2]=l;$=u+32|0;c[$>>2]=m;aa=u+36|0;c[aa>>2]=h;ba=u+40|0;c[ba>>2]=s;ca=u+44|0;c[ca>>2]=t;da=u+8|0;g[da>>2]=ea(3402823469999999843913219.0e14);fa=w+76|0;ga=c[fa>>2]|0;ha=ga+16|0;ia=c[ha>>2]|0;c[v>>2]=ia;ja=ga+32|0;ka=v+4|0;c[ka>>2]=ja;la=ga+20|0;ma=ea(g[la>>2]);na=v+8|0;g[na>>2]=ma;vQa(r,1,v,u,1);oa=ea(g[da>>2]);i=f;return ea(oa)}Q=ea(g[(c[e+60>>2]|0)+4>>2]);R=P<Q;S=R?P:Q;U=ea(K*S);V=u+4|0;c[V>>2]=2;c[u>>2]=500312;W=u+12|0;g[W>>2]=U;X=u+16|0;c[X>>2]=x;Y=u+20|0;c[Y>>2]=k;Z=u+24|0;c[Z>>2]=n;_=u+28|0;c[_>>2]=l;$=u+32|0;c[$>>2]=m;aa=u+36|0;c[aa>>2]=h;ba=u+40|0;c[ba>>2]=s;ca=u+44|0;c[ca>>2]=t;da=u+8|0;g[da>>2]=ea(3402823469999999843913219.0e14);fa=w+76|0;ga=c[fa>>2]|0;ha=ga+16|0;ia=c[ha>>2]|0;c[v>>2]=ia;ja=ga+32|0;ka=v+4|0;c[ka>>2]=ja;la=ga+20|0;ma=ea(g[la>>2]);na=v+8|0;g[na>>2]=ma;vQa(r,1,v,u,1);oa=ea(g[da>>2]);i=f;return ea(oa)}function jza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0;f=i;i=i+448|0;k=f+12|0;l=f+56|0;m=f+392|0;n=f;o=f+376|0;p=f+400|0;q=f+424|0;r=f+84|0;s=f+72|0;t=f+32|0;u=f+44|0;v=c[b>>2]|0;c[k+12>>2]=c[v+40>>2];c[k+16>>2]=v+36;g[k+4>>2]=ea(ea(1.0)/ea(g[v+44>>2]));g[k>>2]=ea(ea(1.0)/ea(g[v+48>>2]));g[k+8>>2]=ea(ea(1.0)/ea(g[v+52>>2]));aLa(l);fLa(l,64,f+120|0,1);c[m>>2]=500288;c[m+4>>2]=l;v=l+4|0;if(c[v>>2]|0)c[v>>2]=0;w=ea(g[a+56>>2]);x=ea(w-ea(g[a+28>>2]));w=ea(g[a+60>>2]);y=ea(w-ea(g[a+32>>2]));w=ea(g[a+64>>2]);z=ea(w-ea(g[a+36>>2]));g[n>>2]=x;g[n+4>>2]=y;g[n+8>>2]=z;A=b+12|0;w=ea(g[b+56>>2]);B=ea(w-ea(g[b+28>>2]));w=ea(g[b+60>>2]);C=ea(w-ea(g[b+32>>2]));w=ea(g[b+64>>2]);D=ea(w-ea(g[b+36>>2]));g[o>>2]=B;g[o+4>>2]=C;g[o+8>>2]=D;w=ea(x-B);B=ea(y-C);C=ea(z-D);D=ea(w*ea(.5));z=ea(B*ea(.5));y=ea(C*ea(.5));x=ea(S(ea(D)));E=ea(S(ea(z)));F=ea(S(ea(y)));G=a+68|0;H=ea(x+ea(g[G>>2]));I=a+72|0;x=ea(E+ea(g[I>>2]));J=a+76|0;E=ea(H+j);H=ea(x+j);x=ea(ea(F+ea(g[J>>2]))+j);K=a+80|0;j=ea(D+ea(g[K>>2]));L=a+84|0;D=ea(z+ea(g[L>>2]));M=a+88|0;z=ea(y+ea(g[M>>2]));y=ea(D-H);F=ea(z-x);N=ea(E+j);O=ea(H+D);D=ea(x+z);g[p>>2]=ea(j-E);g[p+4>>2]=y;g[p+8>>2]=F;g[p+12>>2]=N;g[p+16>>2]=O;g[p+20>>2]=D;KRa(k,h,p,1,m)|0;g[q>>2]=ea(g[K>>2]);g[q+4>>2]=ea(g[L>>2]);g[q+8>>2]=ea(g[M>>2]);D=ea(g[G>>2]);O=ea(g[I>>2]);N=ea(g[J>>2]);J=(d|0)!=0;if(J)P=ea(g[a+8>>2]);else P=ea(0.0);a=(e|0)!=0;if(a)Q=ea(g[b+8>>2]);else Q=ea(0.0);if(J)R=ea(g[(c[d+60>>2]|0)+4>>2]);else R=ea(1.0);if(a)U=ea(g[(c[e+60>>2]|0)+4>>2]);else U=ea(1.0);F=ea((P>Q?P:Q)*(R<U?R:U));e=c[v>>2]|0;v=c[l+8>>2]|0;if(!e){V=ea(3402823469999999843913219.0e14);dLa(l);i=f;return ea(V)}a=r+12|0;d=r+16|0;J=r+4|0;b=r+20|0;I=r+8|0;G=r+24|0;M=r+28|0;L=r+32|0;U=ea(D*ea(1.10000002));D=ea(O*ea(1.10000002));O=ea(N*ea(1.10000002));K=s+4|0;m=s+8|0;p=t+4|0;h=t+8|0;W=u+4|0;X=u+8|0;Y=0;N=ea(3402823469999999843913219.0e14);while(1){LRa(k,A,r,0,0,c[v+(Y<<2)>>2]|0,1,1)|0;R=ea(g[a>>2]);Q=ea(g[r>>2]);P=ea(R-Q);y=ea(g[d>>2]);E=ea(g[J>>2]);j=ea(y-E);z=ea(g[b>>2]);x=ea(g[I>>2]);H=ea(z-x);Z=ea(g[G>>2]);_=ea(Z-Q);$=ea(g[M>>2]);aa=ea($-E);ba=ea(g[L>>2]);ca=ea(ba-x);da=ea(ea(j*ca)-ea(H*aa));fa=ea(ea(H*_)-ea(P*ca));ca=ea(ea(P*aa)-ea(j*_));_=ea(-da);j=ea(-fa);aa=ea(-ca);P=ea(T(ea(ea(ca*ca)+ea(ea(da*da)+ea(fa*fa)))));if(P>ea(0.0)){fa=ea(ea(1.0)/P);ga=ea(fa*_);ha=ea(fa*j);ia=ea(fa*aa)}else{ga=_;ha=j;ia=aa}if(!(ea(ea(C*ia)+ea(ea(B*ha)+ea(w*ga)))>=F))ja=N;else{ka=Q>ea(8507058669999999534545717.0e13);aa=ka?ea(8507058669999999534545717.0e13):Q;ka=E>ea(8507058669999999534545717.0e13);j=ka?ea(8507058669999999534545717.0e13):E;ka=x>ea(8507058669999999534545717.0e13);_=ka?ea(8507058669999999534545717.0e13):x;ka=Q<ea(-8507058669999999534545717.0e13);fa=ka?ea(-8507058669999999534545717.0e13):Q;ka=E<ea(-8507058669999999534545717.0e13);Q=ka?ea(-8507058669999999534545717.0e13):E;ka=x<ea(-8507058669999999534545717.0e13);E=ka?ea(-8507058669999999534545717.0e13):x;x=aa<R?aa:R;aa=j<y?j:y;j=_<z?_:z;_=fa>R?fa:R;R=Q>y?Q:y;y=E>z?E:z;z=x<Z?x:Z;x=aa<$?aa:$;aa=j<ba?j:ba;j=_>Z?_:Z;Z=R>$?R:$;$=y>ba?y:ba;g[s>>2]=U;g[K>>2]=D;g[m>>2]=O;ba=ea(ea(x+Z)*ea(.5));y=ea(ea(aa+$)*ea(.5));g[t>>2]=ea(ea(z+j)*ea(.5));g[p>>2]=ba;g[h>>2]=y;y=ea(ea(ea(ea(Z-x)*ea(.5))+ea(.00999999977))*ea(1.10000002));x=ea(ea(ea(ea($-aa)*ea(.5))+ea(.00999999977))*ea(1.10000002));g[u>>2]=ea(ea(ea(ea(j-z)*ea(.5))+ea(.00999999977))*ea(1.10000002));g[W>>2]=y;g[X>>2]=x;x=ea(Yra(q,s,t,u,n,o));ja=N<x?N:x}Y=Y+1|0;if((Y|0)==(e|0)){V=ja;break}else N=ja}dLa(l);i=f;return ea(V)}function kza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im;p=i;i=i+544|0;o=p+224|0;e=p+496|0;d=p+288|0;r=p+16|0;s=p+508|0;t=p+320|0;u=p+520|0;v=p+464|0;w=p+208|0;x=p+160|0;y=p;z=p+176|0;A=p+304|0;B=p+192|0;C=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;b=C+40|0;D=ea(g[b>>2]);C=r+64|0;c[r+80>>2]=4;E=r+20|0;F=r+36|0;g[r+48>>2]=ea(0.0);G=r+52|0;c[G+0>>2]=c[e+0>>2];c[G+4>>2]=c[e+4>>2];c[G+8>>2]=c[e+8>>2];G=r+96|0;H=r+112|0;c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];g[r+128>>2]=D;I=r+132|0;c[I+0>>2]=c[s+0>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];c[G+0>>2]=c[d+0>>2];c[G+4>>2]=c[d+4>>2];c[G+8>>2]=c[d+8>>2];c[G+12>>2]=c[d+12>>2];c[H+0>>2]=c[d+0>>2];c[H+4>>2]=c[d+4>>2];c[H+8>>2]=c[d+8>>2];c[H+12>>2]=c[d+12>>2];g[r+16>>2]=D;c[E+0>>2]=c[s+0>>2];c[E+4>>2]=c[s+4>>2];c[E+8>>2]=c[s+8>>2];g[r+32>>2]=D;c[F+0>>2]=c[s+0>>2];c[F+4>>2]=c[s+4>>2];c[F+8>>2]=c[s+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[C+0>>2]=c[o+0>>2];c[C+4>>2]=c[o+4>>2];c[C+8>>2]=c[o+8>>2];c[C+12>>2]=c[o+12>>2];C=a+40|0;D=ea(g[C>>2]);a=t+64|0;c[t+80>>2]=4;s=t+20|0;F=t+36|0;g[t+48>>2]=ea(0.0);E=t+52|0;c[E+0>>2]=c[e+0>>2];c[E+4>>2]=c[e+4>>2];c[E+8>>2]=c[e+8>>2];e=t+96|0;E=t+112|0;c[t+0>>2]=c[d+0>>2];c[t+4>>2]=c[d+4>>2];c[t+8>>2]=c[d+8>>2];c[t+12>>2]=c[d+12>>2];g[t+128>>2]=D;H=t+132|0;c[H+0>>2]=c[u+0>>2];c[H+4>>2]=c[u+4>>2];c[H+8>>2]=c[u+8>>2];c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[E+0>>2]=c[d+0>>2];c[E+4>>2]=c[d+4>>2];c[E+8>>2]=c[d+8>>2];c[E+12>>2]=c[d+12>>2];g[t+16>>2]=D;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];g[t+32>>2]=D;c[F+0>>2]=c[u+0>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];D=ea(g[f>>2]);J=ea(g[f+4>>2]);K=ea(g[f+8>>2]);L=ea(g[f+12>>2]);a=j+16|0;M=ea(g[a>>2]);N=ea(g[a+4>>2]);O=ea(g[a+8>>2]);P=ea(g[h>>2]);Q=ea(g[h+4>>2]);R=ea(g[h+8>>2]);S=ea(g[h+12>>2]);a=k+16|0;T=ea(g[a>>2]);U=ea(g[a+4>>2]);V=ea(g[a+8>>2]);g[v>>2]=P;a=v+4|0;g[a>>2]=Q;k=v+8|0;g[k>>2]=R;j=v+12|0;g[j>>2]=S;g[v+16>>2]=T;g[v+20>>2]=U;g[v+24>>2]=V;g[v+28>>2]=ea(0.0);W=ea(-P);P=ea(-Q);Q=ea(-R);R=ea(M-T);X=ea(N-U);Y=ea(O-V);Z=ea(ea(S*S)+ea(-.5));_=ea(ea(ea(R*W)+ea(X*P))+ea(Y*Q));$=ea(ea(ea(_*P)+ea(ea(Z*X)+ea(S*ea(ea(R*Q)-ea(Y*W)))))*ea(2.0));aa=ea(ea(ea(ea(Z*Y)+ea(S*ea(ea(X*W)-ea(R*P))))+ea(_*Q))*ea(2.0));ba=ea(ea(L*S)-ea(ea(ea(D*W)+ea(J*P))+ea(K*Q)));ca=ea(ea(ea(K*P)-ea(J*Q))+ea(ea(L*W)+ea(D*S)));da=ea(ea(ea(D*Q)-ea(K*W))+ea(ea(L*P)+ea(J*S)));fa=ea(ea(ea(J*W)-ea(D*P))+ea(ea(K*S)+ea(L*Q)));g[o+48>>2]=ea(ea(ea(_*W)+ea(ea(Z*R)+ea(S*ea(ea(Y*P)-ea(X*Q)))))*ea(2.0));g[o+52>>2]=$;g[o+56>>2]=aa;g[o+60>>2]=ea(0.0);aa=ea(ca+ca);$=ea(da+da);Q=ea(fa+fa);X=ea(da*$);P=ea(fa*Q);Y=ea(da*aa);da=ea(fa*aa);S=ea(ba*aa);R=ea(fa*$);fa=ea(ba*$);$=ea(ba*Q);Q=ea(ea(1.0)-ea(ca*aa));aa=ea(Y+$);ca=ea(da-fa);ba=ea(Y-$);$=ea(Q-P);Y=ea(R+S);Z=ea(da+fa);fa=ea(R-S);S=ea(Q-X);g[o>>2]=ea(ea(ea(1.0)-X)-P);g[o+4>>2]=aa;g[o+8>>2]=ca;g[o+12>>2]=ea(0.0);g[o+16>>2]=ba;g[o+20>>2]=$;g[o+24>>2]=Y;g[o+28>>2]=ea(0.0);g[o+32>>2]=Z;g[o+36>>2]=fa;g[o+40>>2]=S;g[o+44>>2]=ea(0.0);g[w>>2]=q;q=ea(g[f+16>>2]);S=ea(g[f+20>>2]);fa=ea(g[f+24>>2]);Z=ea(g[h+16>>2]);Y=ea(g[h+20>>2]);$=ea(g[h+24>>2]);ba=ea(q-M);M=ea(S-N);N=ea(fa-O);g[x>>2]=ba;g[x+4>>2]=M;g[x+8>>2]=N;g[x+12>>2]=ea(0.0);O=ea(ea(Z-T)-ba);ba=ea(ea(Y-U)-M);M=ea(ea($-V)-N);N=ea(g[v>>2]);V=ea(g[a>>2]);$=ea(g[k>>2]);U=ea(g[j>>2]);Y=ea(ea(U*U)+ea(-.5));T=ea(ea(ea(O*N)+ea(ba*V))+ea(M*$));Z=ea(ea(ea(V*T)+ea(ea(ba*Y)-ea(U*ea(ea(O*$)-ea(N*M)))))*ea(2.0));fa=ea(ea(ea($*T)+ea(ea(M*Y)-ea(U*ea(ea(ba*N)-ea(O*V)))))*ea(2.0));g[y>>2]=ea(ea(ea(N*T)+ea(ea(O*Y)-ea(U*ea(ea(M*V)-ea(ba*$)))))*ea(2.0));g[y+4>>2]=Z;g[y+8>>2]=fa;g[y+12>>2]=ea(0.0);fa=ea(g[b>>2]);if(!(G1a(r,t,o,v,x,w,d,y,z,A,B,ea(ea(fa+ea(g[C>>2]))+l))|0)){ga=ea(3402823469999999843913219.0e14);i=p;return ea(ga)}l=ea(g[z>>2]);fa=ea(g[A>>2]);Z=ea(g[A+4>>2]);$=ea(g[A+8>>2]);g[m>>2]=fa;g[m+4>>2]=Z;g[m+8>>2]=$;$=ea(g[B>>2]);Z=ea(g[B+4>>2]);fa=ea(g[B+8>>2]);g[n>>2]=$;g[n+4>>2]=Z;g[n+8>>2]=fa;ga=l;i=p;return ea(ga)}function lza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im;p=i;i=i+560|0;o=p+48|0;e=p+80|0;d=p+208|0;r=p;s=p+144|0;t=p+224|0;u=p+544|0;v=p+384|0;w=p+32|0;x=p+112|0;y=p+64|0;z=p+128|0;A=p+96|0;B=p+368|0;C=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;D=ea(g[a+40>>2]);E=ea(g[a+44>>2]);F=ea(g[a+48>>2]);G=ea(g[f>>2]);H=ea(g[f+4>>2]);I=ea(g[f+8>>2]);J=ea(g[f+12>>2]);a=j+16|0;K=ea(g[a>>2]);L=ea(g[a+4>>2]);M=ea(g[a+8>>2]);N=ea(g[h>>2]);O=ea(g[h+4>>2]);P=ea(g[h+8>>2]);Q=ea(g[h+12>>2]);a=k+16|0;R=ea(g[a>>2]);S=ea(g[a+4>>2]);T=ea(g[a+8>>2]);g[r>>2]=N;a=r+4|0;g[a>>2]=O;k=r+8|0;g[k>>2]=P;j=r+12|0;g[j>>2]=Q;g[r+16>>2]=R;g[r+20>>2]=S;g[r+24>>2]=T;g[r+28>>2]=ea(0.0);U=ea(-N);N=ea(-O);O=ea(-P);P=ea(K-R);V=ea(L-S);W=ea(M-T);X=ea(ea(Q*Q)+ea(-.5));Y=ea(ea(ea(P*U)+ea(V*N))+ea(W*O));Z=ea(ea(ea(Y*N)+ea(ea(X*V)+ea(Q*ea(ea(P*O)-ea(W*U)))))*ea(2.0));_=ea(ea(ea(ea(X*W)+ea(Q*ea(ea(V*U)-ea(P*N))))+ea(Y*O))*ea(2.0));$=ea(ea(J*Q)-ea(ea(ea(G*U)+ea(H*N))+ea(I*O)));aa=ea(ea(ea(I*N)-ea(H*O))+ea(ea(J*U)+ea(G*Q)));ba=ea(ea(ea(G*O)-ea(I*U))+ea(ea(J*N)+ea(H*Q)));ca=ea(ea(ea(H*U)-ea(G*N))+ea(ea(I*Q)+ea(J*O)));g[s+48>>2]=ea(ea(ea(Y*U)+ea(ea(X*P)+ea(Q*ea(ea(W*N)-ea(V*O)))))*ea(2.0));g[s+52>>2]=Z;g[s+56>>2]=_;g[s+60>>2]=ea(0.0);_=ea(aa+aa);Z=ea(ba+ba);O=ea(ca+ca);V=ea(ba*Z);N=ea(ca*O);W=ea(ba*_);ba=ea(ca*_);Q=ea($*_);P=ea(ca*Z);ca=ea($*Z);Z=ea($*O);O=ea(ea(1.0)-ea(aa*_));_=ea(W+Z);aa=ea(ba-ca);$=ea(W-Z);Z=ea(O-N);W=ea(P+Q);X=ea(ba+ca);ca=ea(P-Q);Q=ea(O-V);g[s>>2]=ea(ea(ea(1.0)-V)-N);g[s+4>>2]=_;g[s+8>>2]=aa;g[s+12>>2]=ea(0.0);g[s+16>>2]=$;g[s+20>>2]=Z;g[s+24>>2]=W;g[s+28>>2]=ea(0.0);g[s+32>>2]=X;g[s+36>>2]=ca;g[s+40>>2]=Q;g[s+44>>2]=ea(0.0);b=C+40|0;Q=ea(g[b>>2]);C=t+64|0;c[t+80>>2]=4;da=t+20|0;fa=t+36|0;g[t+48>>2]=ea(0.0);ga=t+52|0;c[ga+0>>2]=c[e+0>>2];c[ga+4>>2]=c[e+4>>2];c[ga+8>>2]=c[e+8>>2];ga=t+96|0;ha=t+112|0;c[t+0>>2]=c[d+0>>2];c[t+4>>2]=c[d+4>>2];c[t+8>>2]=c[d+8>>2];c[t+12>>2]=c[d+12>>2];g[t+128>>2]=Q;ia=t+132|0;c[ia+0>>2]=c[u+0>>2];c[ia+4>>2]=c[u+4>>2];c[ia+8>>2]=c[u+8>>2];c[ga+0>>2]=c[d+0>>2];c[ga+4>>2]=c[d+4>>2];c[ga+8>>2]=c[d+8>>2];c[ga+12>>2]=c[d+12>>2];c[ha+0>>2]=c[d+0>>2];c[ha+4>>2]=c[d+4>>2];c[ha+8>>2]=c[d+8>>2];c[ha+12>>2]=c[d+12>>2];g[t+16>>2]=Q;c[da+0>>2]=c[u+0>>2];c[da+4>>2]=c[u+4>>2];c[da+8>>2]=c[u+8>>2];g[t+32>>2]=Q;c[fa+0>>2]=c[u+0>>2];c[fa+4>>2]=c[u+4>>2];c[fa+8>>2]=c[u+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[C+0>>2]=c[o+0>>2];c[C+4>>2]=c[o+4>>2];c[C+8>>2]=c[o+8>>2];c[C+12>>2]=c[o+12>>2];C=v+64|0;c[v+0>>2]=c[d+0>>2];c[v+4>>2]=c[d+4>>2];c[v+8>>2]=c[d+8>>2];c[v+12>>2]=c[d+12>>2];c[v+80>>2]=3;u=v+20|0;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];fa=v+36|0;g[v+48>>2]=ea(0.0);da=v+52|0;c[da+0>>2]=c[o+0>>2];c[da+4>>2]=c[o+4>>2];c[da+8>>2]=c[o+8>>2];c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[C+0>>2]=c[e+0>>2];c[C+4>>2]=c[e+4>>2];c[C+8>>2]=c[e+8>>2];c[C+12>>2]=c[e+12>>2];g[v+144>>2]=D;g[v+148>>2]=E;g[v+152>>2]=F;g[v+156>>2]=ea(0.0);Q=!(D<=E)?E:D;ca=!(Q<=F)?F:Q;Q=!(D>=E)?E:D;D=ea(ca*ea(.150000006));E=ea((!(Q>=F)?F:Q)*ea(.0299999993));Q=D>E?D:E;g[v+16>>2]=ca>Q?Q:ca;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];g[v+32>>2]=ea(ca*ea(.0500000007));c[fa+0>>2]=c[e+0>>2];c[fa+4>>2]=c[e+4>>2];c[fa+8>>2]=c[e+8>>2];g[w>>2]=q;q=ea(g[f+16>>2]);ca=ea(g[f+20>>2]);Q=ea(g[f+24>>2]);E=ea(g[h+16>>2]);D=ea(g[h+20>>2]);F=ea(g[h+24>>2]);X=ea(q-K);K=ea(ca-L);L=ea(Q-M);g[x>>2]=X;g[x+4>>2]=K;g[x+8>>2]=L;g[x+12>>2]=ea(0.0);M=ea(ea(E-R)-X);X=ea(ea(D-S)-K);K=ea(ea(F-T)-L);L=ea(g[r>>2]);T=ea(g[a>>2]);F=ea(g[k>>2]);S=ea(g[j>>2]);D=ea(ea(S*S)+ea(-.5));R=ea(ea(ea(M*L)+ea(X*T))+ea(K*F));E=ea(ea(ea(T*R)+ea(ea(X*D)-ea(S*ea(ea(M*F)-ea(L*K)))))*ea(2.0));Q=ea(ea(ea(F*R)+ea(ea(K*D)-ea(S*ea(ea(X*L)-ea(M*T)))))*ea(2.0));g[y>>2]=ea(ea(ea(L*R)+ea(ea(M*D)-ea(S*ea(ea(K*T)-ea(X*F)))))*ea(2.0));g[y+4>>2]=E;g[y+8>>2]=Q;g[y+12>>2]=ea(0.0);if(!(H1a(t,v,s,r,x,w,d,y,z,A,B,ea(ea(g[b>>2])+l))|0)){ja=ea(3402823469999999843913219.0e14);i=p;return ea(ja)}l=ea(g[z>>2]);Q=ea(g[A>>2]);E=ea(g[A+4>>2]);F=ea(g[A+8>>2]);g[m>>2]=Q;g[m+4>>2]=E;g[m+8>>2]=F;F=ea(g[B>>2]);E=ea(g[B+4>>2]);Q=ea(g[B+8>>2]);g[n>>2]=F;g[n+4>>2]=E;g[n+8>>2]=Q;ja=l;i=p;return ea(ja)}function mza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=Im;p=i;i=i+560|0;o=p+272|0;e=p+512|0;d=p+112|0;r=p+524|0;s=p+536|0;t=p+336|0;u=p+16|0;v=p+368|0;w=p+128|0;x=p+80|0;y=p+96|0;z=p+320|0;A=p+304|0;B=p+288|0;C=p;D=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;b=D+40|0;E=ea(g[b>>2]);F=ea(g[D+44>>2]);D=a+40|0;G=ea(g[D>>2]);H=ea(g[a+44>>2]);I=ea(g[f>>2]);J=ea(g[f+4>>2]);K=ea(g[f+8>>2]);L=ea(g[f+12>>2]);a=j+16|0;M=ea(g[a>>2]);N=ea(g[a+4>>2]);O=ea(g[a+8>>2]);P=ea(g[h>>2]);Q=ea(g[h+4>>2]);R=ea(g[h+8>>2]);S=ea(g[h+12>>2]);a=k+16|0;T=ea(g[a>>2]);U=ea(g[a+4>>2]);V=ea(g[a+8>>2]);g[t>>2]=P;a=t+4|0;g[a>>2]=Q;k=t+8|0;g[k>>2]=R;j=t+12|0;g[j>>2]=S;g[t+16>>2]=T;g[t+20>>2]=U;g[t+24>>2]=V;g[t+28>>2]=ea(0.0);W=ea(-P);P=ea(-Q);Q=ea(-R);R=ea(M-T);X=ea(N-U);Y=ea(O-V);Z=ea(ea(S*S)+ea(-.5));_=ea(ea(ea(R*W)+ea(X*P))+ea(Y*Q));$=ea(ea(ea(_*P)+ea(ea(Z*X)+ea(S*ea(ea(R*Q)-ea(Y*W)))))*ea(2.0));aa=ea(ea(ea(ea(Z*Y)+ea(S*ea(ea(X*W)-ea(R*P))))+ea(_*Q))*ea(2.0));ba=ea(ea(L*S)-ea(ea(ea(I*W)+ea(J*P))+ea(K*Q)));ca=ea(ea(ea(K*P)-ea(J*Q))+ea(ea(L*W)+ea(I*S)));da=ea(ea(ea(I*Q)-ea(K*W))+ea(ea(L*P)+ea(J*S)));fa=ea(ea(ea(J*W)-ea(I*P))+ea(ea(K*S)+ea(L*Q)));g[u+48>>2]=ea(ea(ea(_*W)+ea(ea(Z*R)+ea(S*ea(ea(Y*P)-ea(X*Q)))))*ea(2.0));g[u+52>>2]=$;g[u+56>>2]=aa;g[u+60>>2]=ea(0.0);aa=ea(ca+ca);$=ea(da+da);Q=ea(fa+fa);X=ea(da*$);P=ea(fa*Q);Y=ea(da*aa);da=ea(fa*aa);S=ea(ba*aa);R=ea(fa*$);fa=ea(ba*$);$=ea(ba*Q);Q=ea(ea(1.0)-ea(ca*aa));aa=ea(Y+$);ca=ea(da-fa);ba=ea(Y-$);$=ea(Q-P);Y=ea(R+S);Z=ea(da+fa);fa=ea(R-S);S=ea(Q-X);g[u>>2]=ea(ea(ea(1.0)-X)-P);g[u+4>>2]=aa;g[u+8>>2]=ca;g[u+12>>2]=ea(0.0);g[u+16>>2]=ba;g[u+20>>2]=$;g[u+24>>2]=Y;g[u+28>>2]=ea(0.0);g[u+32>>2]=Z;g[u+36>>2]=fa;g[u+40>>2]=S;g[u+44>>2]=ea(0.0);S=ea(F*ea(0.0));ga=v+64|0;c[v+0>>2]=c[d+0>>2];c[v+4>>2]=c[d+4>>2];c[v+8>>2]=c[d+8>>2];c[v+12>>2]=c[d+12>>2];c[v+80>>2]=4;ha=v+20|0;ia=v+36|0;g[v+48>>2]=ea(0.0);ja=v+52|0;c[ja+0>>2]=c[e+0>>2];c[ja+4>>2]=c[e+4>>2];c[ja+8>>2]=c[e+8>>2];g[v+128>>2]=E;ja=v+132|0;c[ja+0>>2]=c[r+0>>2];c[ja+4>>2]=c[r+4>>2];c[ja+8>>2]=c[r+8>>2];fa=ea(g[d>>2]);Z=ea(g[d+4>>2]);Y=ea(g[d+8>>2]);$=ea(S+Z);ba=ea(S+Y);g[v+96>>2]=ea(F+fa);g[v+100>>2]=$;g[v+104>>2]=ba;g[v+108>>2]=ea(0.0);ba=ea(Z-S);$=ea(Y-S);g[v+112>>2]=ea(fa-F);g[v+116>>2]=ba;g[v+120>>2]=$;g[v+124>>2]=ea(0.0);g[v+16>>2]=E;c[ha+0>>2]=c[r+0>>2];c[ha+4>>2]=c[r+4>>2];c[ha+8>>2]=c[r+8>>2];g[v+32>>2]=E;c[ia+0>>2]=c[r+0>>2];c[ia+4>>2]=c[r+4>>2];c[ia+8>>2]=c[r+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[ga+0>>2]=c[o+0>>2];c[ga+4>>2]=c[o+4>>2];c[ga+8>>2]=c[o+8>>2];c[ga+12>>2]=c[o+12>>2];E=ea(H*ea(0.0));ga=w+64|0;c[w+0>>2]=c[d+0>>2];c[w+4>>2]=c[d+4>>2];c[w+8>>2]=c[d+8>>2];c[w+12>>2]=c[d+12>>2];c[w+80>>2]=4;r=w+20|0;ia=w+36|0;g[w+48>>2]=ea(0.0);ha=w+52|0;c[ha+0>>2]=c[e+0>>2];c[ha+4>>2]=c[e+4>>2];c[ha+8>>2]=c[e+8>>2];g[w+128>>2]=G;e=w+132|0;c[e+0>>2]=c[s+0>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];$=ea(E+Z);ba=ea(E+Y);g[w+96>>2]=ea(H+fa);g[w+100>>2]=$;g[w+104>>2]=ba;g[w+108>>2]=ea(0.0);ba=ea(Z-E);Z=ea(Y-E);g[w+112>>2]=ea(fa-H);g[w+116>>2]=ba;g[w+120>>2]=Z;g[w+124>>2]=ea(0.0);g[w+16>>2]=G;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];g[w+32>>2]=G;c[ia+0>>2]=c[s+0>>2];c[ia+4>>2]=c[s+4>>2];c[ia+8>>2]=c[s+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[ga+0>>2]=c[o+0>>2];c[ga+4>>2]=c[o+4>>2];c[ga+8>>2]=c[o+8>>2];c[ga+12>>2]=c[o+12>>2];g[x>>2]=q;q=ea(g[f+16>>2]);G=ea(g[f+20>>2]);Z=ea(g[f+24>>2]);ba=ea(g[h+16>>2]);H=ea(g[h+20>>2]);fa=ea(g[h+24>>2]);E=ea(q-M);M=ea(G-N);N=ea(Z-O);g[y>>2]=E;g[y+4>>2]=M;g[y+8>>2]=N;g[y+12>>2]=ea(0.0);O=ea(ea(ba-T)-E);E=ea(ea(H-U)-M);M=ea(ea(fa-V)-N);N=ea(g[t>>2]);V=ea(g[a>>2]);fa=ea(g[k>>2]);U=ea(g[j>>2]);H=ea(ea(U*U)+ea(-.5));T=ea(ea(ea(O*N)+ea(E*V))+ea(M*fa));ba=ea(ea(ea(V*T)+ea(ea(E*H)-ea(U*ea(ea(O*fa)-ea(N*M)))))*ea(2.0));Z=ea(ea(ea(fa*T)+ea(ea(M*H)-ea(U*ea(ea(E*N)-ea(O*V)))))*ea(2.0));g[z>>2]=ea(ea(ea(N*T)+ea(ea(O*H)-ea(U*ea(ea(M*V)-ea(E*fa)))))*ea(2.0));g[z+4>>2]=ba;g[z+8>>2]=Z;g[z+12>>2]=ea(0.0);Z=ea(g[b>>2]);if(!(G1a(v,w,u,t,y,x,d,z,A,B,C,ea(ea(Z+ea(g[D>>2]))+l))|0)){ka=ea(3402823469999999843913219.0e14);i=p;return ea(ka)}l=ea(g[A>>2]);Z=ea(g[B>>2]);ba=ea(g[B+4>>2]);fa=ea(g[B+8>>2]);g[m>>2]=Z;g[m+4>>2]=ba;g[m+8>>2]=fa;fa=ea(g[C>>2]);ba=ea(g[C+4>>2]);Z=ea(g[C+8>>2]);g[n>>2]=fa;g[n+4>>2]=ba;g[n+8>>2]=Z;ka=l;i=p;return ea(ka)}function nza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im;p=i;i=i+544|0;o=p+16|0;e=p;d=p+112|0;r=p+528|0;s=p+176|0;t=p+336|0;u=p+496|0;v=p+144|0;w=p+128|0;x=p+80|0;y=p+96|0;z=p+320|0;A=p+160|0;B=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;b=B+40|0;C=ea(g[b>>2]);D=ea(g[B+44>>2]);E=ea(g[a+40>>2]);F=ea(g[a+44>>2]);G=ea(g[a+48>>2]);H=ea(D*ea(0.0));a=s+64|0;c[s+0>>2]=c[d+0>>2];c[s+4>>2]=c[d+4>>2];c[s+8>>2]=c[d+8>>2];c[s+12>>2]=c[d+12>>2];c[s+80>>2]=4;B=s+20|0;I=s+36|0;g[s+48>>2]=ea(0.0);J=s+52|0;c[J+0>>2]=c[e+0>>2];c[J+4>>2]=c[e+4>>2];c[J+8>>2]=c[e+8>>2];g[s+128>>2]=C;J=s+132|0;c[J+0>>2]=c[r+0>>2];c[J+4>>2]=c[r+4>>2];c[J+8>>2]=c[r+8>>2];K=ea(H+ea(0.0));g[s+96>>2]=ea(D+ea(0.0));g[s+100>>2]=K;g[s+104>>2]=K;g[s+108>>2]=ea(0.0);K=ea(ea(0.0)-H);g[s+112>>2]=ea(ea(0.0)-D);g[s+116>>2]=K;g[s+120>>2]=K;g[s+124>>2]=ea(0.0);g[s+16>>2]=C;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];g[s+32>>2]=C;c[I+0>>2]=c[r+0>>2];c[I+4>>2]=c[r+4>>2];c[I+8>>2]=c[r+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];a=t+64|0;c[t+0>>2]=c[d+0>>2];c[t+4>>2]=c[d+4>>2];c[t+8>>2]=c[d+8>>2];c[t+12>>2]=c[d+12>>2];c[t+80>>2]=3;r=t+20|0;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];I=t+36|0;g[t+48>>2]=ea(0.0);B=t+52|0;c[B+0>>2]=c[o+0>>2];c[B+4>>2]=c[o+4>>2];c[B+8>>2]=c[o+8>>2];c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];g[t+144>>2]=E;g[t+148>>2]=F;g[t+152>>2]=G;g[t+156>>2]=ea(0.0);C=!(E<=F)?F:E;K=!(C<=G)?G:C;C=!(E>=F)?F:E;E=ea(K*ea(.150000006));F=ea((!(C>=G)?G:C)*ea(.0299999993));C=E>F?E:F;g[t+16>>2]=K>C?C:K;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];g[t+32>>2]=ea(K*ea(.0500000007));c[I+0>>2]=c[e+0>>2];c[I+4>>2]=c[e+4>>2];c[I+8>>2]=c[e+8>>2];K=ea(g[f>>2]);C=ea(g[f+4>>2]);F=ea(g[f+8>>2]);E=ea(g[f+12>>2]);e=j+16|0;G=ea(g[e>>2]);D=ea(g[e+4>>2]);H=ea(g[e+8>>2]);L=ea(g[h>>2]);M=ea(g[h+4>>2]);N=ea(g[h+8>>2]);O=ea(g[h+12>>2]);e=k+16|0;P=ea(g[e>>2]);Q=ea(g[e+4>>2]);R=ea(g[e+8>>2]);g[u>>2]=L;e=u+4|0;g[e>>2]=M;k=u+8|0;g[k>>2]=N;j=u+12|0;g[j>>2]=O;g[u+16>>2]=P;g[u+20>>2]=Q;g[u+24>>2]=R;g[u+28>>2]=ea(0.0);S=ea(-L);L=ea(-M);M=ea(-N);N=ea(G-P);T=ea(D-Q);U=ea(H-R);V=ea(ea(O*O)+ea(-.5));W=ea(ea(ea(N*S)+ea(T*L))+ea(U*M));X=ea(ea(ea(W*L)+ea(ea(V*T)+ea(O*ea(ea(N*M)-ea(U*S)))))*ea(2.0));Y=ea(ea(ea(ea(V*U)+ea(O*ea(ea(T*S)-ea(N*L))))+ea(W*M))*ea(2.0));Z=ea(ea(E*O)-ea(ea(ea(K*S)+ea(C*L))+ea(F*M)));_=ea(ea(ea(F*L)-ea(C*M))+ea(ea(E*S)+ea(K*O)));$=ea(ea(ea(K*M)-ea(F*S))+ea(ea(E*L)+ea(C*O)));aa=ea(ea(ea(C*S)-ea(K*L))+ea(ea(F*O)+ea(E*M)));g[o+48>>2]=ea(ea(ea(W*S)+ea(ea(V*N)+ea(O*ea(ea(U*L)-ea(T*M)))))*ea(2.0));g[o+52>>2]=X;g[o+56>>2]=Y;g[o+60>>2]=ea(0.0);Y=ea(_+_);X=ea($+$);M=ea(aa+aa);T=ea($*X);L=ea(aa*M);U=ea($*Y);$=ea(aa*Y);O=ea(Z*Y);N=ea(aa*X);aa=ea(Z*X);X=ea(Z*M);M=ea(ea(1.0)-ea(_*Y));Y=ea(U+X);_=ea($-aa);Z=ea(U-X);X=ea(M-L);U=ea(N+O);V=ea($+aa);aa=ea(N-O);O=ea(M-T);g[o>>2]=ea(ea(ea(1.0)-T)-L);g[o+4>>2]=Y;g[o+8>>2]=_;g[o+12>>2]=ea(0.0);g[o+16>>2]=Z;g[o+20>>2]=X;g[o+24>>2]=U;g[o+28>>2]=ea(0.0);g[o+32>>2]=V;g[o+36>>2]=aa;g[o+40>>2]=O;g[o+44>>2]=ea(0.0);g[v>>2]=q;q=ea(g[f+16>>2]);O=ea(g[f+20>>2]);aa=ea(g[f+24>>2]);V=ea(g[h+16>>2]);U=ea(g[h+20>>2]);X=ea(g[h+24>>2]);Z=ea(q-G);G=ea(O-D);D=ea(aa-H);g[w>>2]=Z;g[w+4>>2]=G;g[w+8>>2]=D;g[w+12>>2]=ea(0.0);H=ea(ea(V-P)-Z);Z=ea(ea(U-Q)-G);G=ea(ea(X-R)-D);D=ea(g[u>>2]);R=ea(g[e>>2]);X=ea(g[k>>2]);Q=ea(g[j>>2]);U=ea(ea(Q*Q)+ea(-.5));P=ea(ea(ea(H*D)+ea(Z*R))+ea(G*X));V=ea(ea(ea(R*P)+ea(ea(Z*U)-ea(Q*ea(ea(H*X)-ea(D*G)))))*ea(2.0));aa=ea(ea(ea(X*P)+ea(ea(G*U)-ea(Q*ea(ea(Z*D)-ea(H*R)))))*ea(2.0));g[x>>2]=ea(ea(ea(D*P)+ea(ea(H*U)-ea(Q*ea(ea(G*R)-ea(Z*X)))))*ea(2.0));g[x+4>>2]=V;g[x+8>>2]=aa;g[x+12>>2]=ea(0.0);if(!(H1a(s,t,o,u,w,v,d,x,y,z,A,ea(ea(g[b>>2])+l))|0)){ba=ea(3402823469999999843913219.0e14);i=p;return ea(ba)}l=ea(g[y>>2]);aa=ea(g[z>>2]);V=ea(g[z+4>>2]);X=ea(g[z+8>>2]);g[m>>2]=aa;g[m+4>>2]=V;g[m+8>>2]=X;X=ea(g[A>>2]);V=ea(g[A+4>>2]);aa=ea(g[A+8>>2]);g[n>>2]=X;g[n+4>>2]=V;g[n+8>>2]=aa;ba=l;i=p;return ea(ba)}function oza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im;p=i;i=i+608|0;o=p+32|0;e=p+256|0;d=p+384|0;r=p+592|0;s=p+368|0;t=p+400|0;u=p+416|0;v=p+560|0;w=p+16|0;x=p+336|0;y=p+240|0;z=p+352|0;A=p+320|0;B=p;C=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;b=C+40|0;D=ea(g[b>>2]);E=ea(g[C+44>>2]);F=ea(g[a+40>>2]);G=ea(g[a+44>>2]);H=ea(g[a+48>>2]);g[s>>2]=F;g[s+4>>2]=G;g[s+8>>2]=H;g[s+12>>2]=ea(0.0);H=ea(g[a+52>>2]);G=ea(g[a+56>>2]);F=ea(g[a+60>>2]);I=ea(g[a+64>>2]);g[t>>2]=H;g[t+4>>2]=G;g[t+8>>2]=F;g[t+12>>2]=I;C=c[a+72>>2]|0;I=ea(E*ea(0.0));a=u+64|0;c[u+0>>2]=c[d+0>>2];c[u+4>>2]=c[d+4>>2];c[u+8>>2]=c[d+8>>2];c[u+12>>2]=c[d+12>>2];c[u+80>>2]=4;J=u+20|0;K=u+36|0;g[u+48>>2]=ea(0.0);L=u+52|0;c[L+0>>2]=c[o+0>>2];c[L+4>>2]=c[o+4>>2];c[L+8>>2]=c[o+8>>2];g[u+128>>2]=D;L=u+132|0;c[L+0>>2]=c[r+0>>2];c[L+4>>2]=c[r+4>>2];c[L+8>>2]=c[r+8>>2];F=ea(I+ea(0.0));g[u+96>>2]=ea(E+ea(0.0));g[u+100>>2]=F;g[u+104>>2]=F;g[u+108>>2]=ea(0.0);F=ea(g[d>>2]);G=ea(g[d+4>>2]);H=ea(G-I);G=ea(ea(g[d+8>>2])-I);g[u+112>>2]=ea(F-E);g[u+116>>2]=H;g[u+120>>2]=G;g[u+124>>2]=ea(0.0);g[u+16>>2]=D;c[J+0>>2]=c[r+0>>2];c[J+4>>2]=c[r+4>>2];c[J+8>>2]=c[r+8>>2];g[u+32>>2]=D;c[K+0>>2]=c[r+0>>2];c[K+4>>2]=c[r+4>>2];c[K+8>>2]=c[r+8>>2];c[e+0>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];z1a(o,C,d,s,t);D=ea(g[f>>2]);G=ea(g[f+4>>2]);H=ea(g[f+8>>2]);E=ea(g[f+12>>2]);t=j+16|0;F=ea(g[t>>2]);I=ea(g[t+4>>2]);M=ea(g[t+8>>2]);N=ea(g[h>>2]);O=ea(g[h+4>>2]);P=ea(g[h+8>>2]);Q=ea(g[h+12>>2]);t=k+16|0;R=ea(g[t>>2]);S=ea(g[t+4>>2]);T=ea(g[t+8>>2]);g[v>>2]=N;t=v+4|0;g[t>>2]=O;k=v+8|0;g[k>>2]=P;j=v+12|0;g[j>>2]=Q;g[v+16>>2]=R;g[v+20>>2]=S;g[v+24>>2]=T;g[v+28>>2]=ea(0.0);U=ea(-N);N=ea(-O);O=ea(-P);P=ea(F-R);V=ea(I-S);W=ea(M-T);X=ea(ea(Q*Q)+ea(-.5));Y=ea(ea(ea(P*U)+ea(V*N))+ea(W*O));Z=ea(ea(ea(Y*N)+ea(ea(X*V)+ea(Q*ea(ea(P*O)-ea(W*U)))))*ea(2.0));_=ea(ea(ea(ea(X*W)+ea(Q*ea(ea(V*U)-ea(P*N))))+ea(Y*O))*ea(2.0));$=ea(ea(E*Q)-ea(ea(ea(D*U)+ea(G*N))+ea(H*O)));aa=ea(ea(ea(H*N)-ea(G*O))+ea(ea(E*U)+ea(D*Q)));ba=ea(ea(ea(D*O)-ea(H*U))+ea(ea(E*N)+ea(G*Q)));ca=ea(ea(ea(G*U)-ea(D*N))+ea(ea(H*Q)+ea(E*O)));g[e+48>>2]=ea(ea(ea(Y*U)+ea(ea(X*P)+ea(Q*ea(ea(W*N)-ea(V*O)))))*ea(2.0));g[e+52>>2]=Z;g[e+56>>2]=_;g[e+60>>2]=ea(0.0);_=ea(aa+aa);Z=ea(ba+ba);O=ea(ca+ca);V=ea(ba*Z);N=ea(ca*O);W=ea(ba*_);ba=ea(ca*_);Q=ea($*_);P=ea(ca*Z);ca=ea($*Z);Z=ea($*O);O=ea(ea(1.0)-ea(aa*_));_=ea(W+Z);aa=ea(ba-ca);$=ea(W-Z);Z=ea(O-N);W=ea(P+Q);X=ea(ba+ca);ca=ea(P-Q);Q=ea(O-V);g[e>>2]=ea(ea(ea(1.0)-V)-N);g[e+4>>2]=_;g[e+8>>2]=aa;g[e+12>>2]=ea(0.0);g[e+16>>2]=$;g[e+20>>2]=Z;g[e+24>>2]=W;g[e+28>>2]=ea(0.0);g[e+32>>2]=X;g[e+36>>2]=ca;g[e+40>>2]=Q;g[e+44>>2]=ea(0.0);g[w>>2]=q;q=ea(g[f+16>>2]);Q=ea(g[f+20>>2]);ca=ea(g[f+24>>2]);X=ea(g[h+16>>2]);W=ea(g[h+20>>2]);Z=ea(g[h+24>>2]);$=ea(q-F);F=ea(Q-I);I=ea(ca-M);g[x>>2]=$;g[x+4>>2]=F;g[x+8>>2]=I;g[x+12>>2]=ea(0.0);M=ea(ea(X-R)-$);$=ea(ea(W-S)-F);F=ea(ea(Z-T)-I);I=ea(g[v>>2]);T=ea(g[t>>2]);Z=ea(g[k>>2]);S=ea(g[j>>2]);W=ea(ea(S*S)+ea(-.5));R=ea(ea(ea(M*I)+ea($*T))+ea(F*Z));X=ea(ea(ea(T*R)+ea(ea($*W)-ea(S*ea(ea(M*Z)-ea(I*F)))))*ea(2.0));ca=ea(ea(ea(Z*R)+ea(ea(F*W)-ea(S*ea(ea($*I)-ea(M*T)))))*ea(2.0));g[y>>2]=ea(ea(ea(I*R)+ea(ea(M*W)-ea(S*ea(ea(F*T)-ea($*Z)))))*ea(2.0));g[y+4>>2]=X;g[y+8>>2]=ca;g[y+12>>2]=ea(0.0);if(!(I1a(u,o,e,v,x,w,d,y,z,A,B,ea(ea(g[b>>2])+l))|0)){da=ea(3402823469999999843913219.0e14);i=p;return ea(da)}l=ea(g[z>>2]);ca=ea(g[A>>2]);X=ea(g[A+4>>2]);Z=ea(g[A+8>>2]);g[m>>2]=ca;g[m+4>>2]=X;g[m+8>>2]=Z;Z=ea(g[B>>2]);X=ea(g[B+4>>2]);ca=ea(g[B+8>>2]);g[n>>2]=Z;g[n+4>>2]=X;g[n+8>>2]=ca;da=l;i=p;return ea(da)}function pza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im;p=i;i=i+544|0;o=p+192|0;e=p+528|0;d=p+304|0;r=p+16|0;s=p+320|0;t=p+480|0;u=p+512|0;v=p+288|0;w=p+272|0;x=p+176|0;y=p;z=p+256|0;A=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;B=ea(g[A+40>>2]);C=ea(g[A+44>>2]);D=ea(g[A+48>>2]);E=ea(g[a+40>>2]);F=ea(g[a+44>>2]);G=ea(g[a+48>>2]);a=r+64|0;c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];c[r+80>>2]=3;A=r+20|0;c[A+0>>2]=c[e+0>>2];c[A+4>>2]=c[e+4>>2];c[A+8>>2]=c[e+8>>2];b=r+36|0;g[r+48>>2]=ea(0.0);H=r+52|0;c[H+0>>2]=c[e+0>>2];c[H+4>>2]=c[e+4>>2];c[H+8>>2]=c[e+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];g[r+144>>2]=B;g[r+148>>2]=C;g[r+152>>2]=D;g[r+156>>2]=ea(0.0);I=!(B<=C)?C:B;J=!(I<=D)?D:I;I=!(B>=C)?C:B;B=ea(J*ea(.150000006));C=ea((!(I>=D)?D:I)*ea(.0299999993));I=B>C?B:C;g[r+16>>2]=J>I?I:J;c[A+0>>2]=c[e+0>>2];c[A+4>>2]=c[e+4>>2];c[A+8>>2]=c[e+8>>2];g[r+32>>2]=ea(J*ea(.0500000007));c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=s+64|0;c[s+0>>2]=c[d+0>>2];c[s+4>>2]=c[d+4>>2];c[s+8>>2]=c[d+8>>2];c[s+12>>2]=c[d+12>>2];c[s+80>>2]=3;A=s+20|0;c[A+0>>2]=c[e+0>>2];c[A+4>>2]=c[e+4>>2];c[A+8>>2]=c[e+8>>2];a=s+36|0;g[s+48>>2]=ea(0.0);H=s+52|0;c[H+0>>2]=c[e+0>>2];c[H+4>>2]=c[e+4>>2];c[H+8>>2]=c[e+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];c[b+12>>2]=c[o+12>>2];g[s+144>>2]=E;g[s+148>>2]=F;g[s+152>>2]=G;g[s+156>>2]=ea(0.0);J=!(E<=F)?F:E;I=!(J<=G)?G:J;J=!(E>=F)?F:E;E=ea(I*ea(.150000006));F=ea((!(J>=G)?G:J)*ea(.0299999993));J=E>F?E:F;g[s+16>>2]=I>J?J:I;c[A+0>>2]=c[e+0>>2];c[A+4>>2]=c[e+4>>2];c[A+8>>2]=c[e+8>>2];g[s+32>>2]=ea(I*ea(.0500000007));c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];I=ea(g[f>>2]);J=ea(g[f+4>>2]);F=ea(g[f+8>>2]);E=ea(g[f+12>>2]);a=j+16|0;G=ea(g[a>>2]);C=ea(g[a+4>>2]);B=ea(g[a+8>>2]);D=ea(g[h>>2]);K=ea(g[h+4>>2]);L=ea(g[h+8>>2]);M=ea(g[h+12>>2]);a=k+16|0;N=ea(g[a>>2]);O=ea(g[a+4>>2]);P=ea(g[a+8>>2]);g[t>>2]=D;a=t+4|0;g[a>>2]=K;k=t+8|0;g[k>>2]=L;j=t+12|0;g[j>>2]=M;g[t+16>>2]=N;g[t+20>>2]=O;g[t+24>>2]=P;g[t+28>>2]=ea(0.0);Q=ea(-D);D=ea(-K);K=ea(-L);L=ea(G-N);R=ea(C-O);S=ea(B-P);T=ea(ea(M*M)+ea(-.5));U=ea(ea(ea(L*Q)+ea(R*D))+ea(S*K));V=ea(ea(ea(U*D)+ea(ea(T*R)+ea(M*ea(ea(L*K)-ea(S*Q)))))*ea(2.0));W=ea(ea(ea(ea(T*S)+ea(M*ea(ea(R*Q)-ea(L*D))))+ea(U*K))*ea(2.0));X=ea(ea(E*M)-ea(ea(ea(I*Q)+ea(J*D))+ea(F*K)));Y=ea(ea(ea(F*D)-ea(J*K))+ea(ea(E*Q)+ea(I*M)));Z=ea(ea(ea(I*K)-ea(F*Q))+ea(ea(E*D)+ea(J*M)));_=ea(ea(ea(J*Q)-ea(I*D))+ea(ea(F*M)+ea(E*K)));g[o+48>>2]=ea(ea(ea(U*Q)+ea(ea(T*L)+ea(M*ea(ea(S*D)-ea(R*K)))))*ea(2.0));g[o+52>>2]=V;g[o+56>>2]=W;g[o+60>>2]=ea(0.0);W=ea(Y+Y);V=ea(Z+Z);K=ea(_+_);R=ea(Z*V);D=ea(_*K);S=ea(Z*W);Z=ea(_*W);M=ea(X*W);L=ea(_*V);_=ea(X*V);V=ea(X*K);K=ea(ea(1.0)-ea(Y*W));W=ea(S+V);Y=ea(Z-_);X=ea(S-V);V=ea(K-D);S=ea(L+M);T=ea(Z+_);_=ea(L-M);M=ea(K-R);g[o>>2]=ea(ea(ea(1.0)-R)-D);g[o+4>>2]=W;g[o+8>>2]=Y;g[o+12>>2]=ea(0.0);g[o+16>>2]=X;g[o+20>>2]=V;g[o+24>>2]=S;g[o+28>>2]=ea(0.0);g[o+32>>2]=T;g[o+36>>2]=_;g[o+40>>2]=M;g[o+44>>2]=ea(0.0);g[u>>2]=q;q=ea(g[f+16>>2]);M=ea(g[f+20>>2]);_=ea(g[f+24>>2]);T=ea(g[h+16>>2]);S=ea(g[h+20>>2]);V=ea(g[h+24>>2]);X=ea(q-G);G=ea(M-C);C=ea(_-B);g[v>>2]=X;g[v+4>>2]=G;g[v+8>>2]=C;g[v+12>>2]=ea(0.0);B=ea(ea(T-N)-X);X=ea(ea(S-O)-G);G=ea(ea(V-P)-C);C=ea(g[t>>2]);P=ea(g[a>>2]);V=ea(g[k>>2]);O=ea(g[j>>2]);S=ea(ea(O*O)+ea(-.5));N=ea(ea(ea(B*C)+ea(X*P))+ea(G*V));T=ea(ea(ea(P*N)+ea(ea(X*S)-ea(O*ea(ea(B*V)-ea(C*G)))))*ea(2.0));_=ea(ea(ea(V*N)+ea(ea(G*S)-ea(O*ea(ea(X*C)-ea(B*P)))))*ea(2.0));g[w>>2]=ea(ea(ea(C*N)+ea(ea(B*S)-ea(O*ea(ea(G*P)-ea(X*V)))))*ea(2.0));g[w+4>>2]=T;g[w+8>>2]=_;g[w+12>>2]=ea(0.0);if(!(J1a(r,s,o,t,v,u,d,w,x,y,z,l)|0)){$=ea(3402823469999999843913219.0e14);i=p;return ea($)}l=ea(g[x>>2]);_=ea(g[y>>2]);T=ea(g[y+4>>2]);V=ea(g[y+8>>2]);g[m>>2]=_;g[m+4>>2]=T;g[m+8>>2]=V;V=ea(g[z>>2]);T=ea(g[z+4>>2]);_=ea(g[z+8>>2]);g[n>>2]=V;g[n+4>>2]=T;g[n+8>>2]=_;$=l;i=p;return ea($)}function qza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im;p=i;i=i+608|0;o=p+368|0;e=p+144|0;d=p+80|0;r=p+64|0;s=p+128|0;t=p+208|0;u=p+576|0;v=p+32|0;w=p+16|0;x=p+96|0;y=p+48|0;z=p+112|0;A=p;B=c[a>>2]|0;a=c[b>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;C=ea(g[a+40>>2]);D=ea(g[a+44>>2]);E=ea(g[a+48>>2]);g[r>>2]=C;g[r+4>>2]=D;g[r+8>>2]=E;g[r+12>>2]=ea(0.0);E=ea(g[a+52>>2]);D=ea(g[a+56>>2]);C=ea(g[a+60>>2]);F=ea(g[a+64>>2]);g[s>>2]=E;g[s+4>>2]=D;g[s+8>>2]=C;g[s+12>>2]=F;F=ea(g[B+40>>2]);C=ea(g[B+44>>2]);D=ea(g[B+48>>2]);B=c[a+72>>2]|0;a=t+64|0;c[t+0>>2]=c[d+0>>2];c[t+4>>2]=c[d+4>>2];c[t+8>>2]=c[d+8>>2];c[t+12>>2]=c[d+12>>2];c[t+80>>2]=3;b=t+20|0;c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];G=t+36|0;g[t+48>>2]=ea(0.0);H=t+52|0;c[H+0>>2]=c[e+0>>2];c[H+4>>2]=c[e+4>>2];c[H+8>>2]=c[e+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];g[t+144>>2]=F;g[t+148>>2]=C;g[t+152>>2]=D;g[t+156>>2]=ea(0.0);E=!(F<=C)?C:F;I=!(E<=D)?D:E;E=!(F>=C)?C:F;F=ea(I*ea(.150000006));C=ea((!(E>=D)?D:E)*ea(.0299999993));E=F>C?F:C;g[t+16>>2]=I>E?E:I;c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];g[t+32>>2]=ea(I*ea(.0500000007));c[G+0>>2]=c[o+0>>2];c[G+4>>2]=c[o+4>>2];c[G+8>>2]=c[o+8>>2];z1a(o,B,d,r,s);I=ea(g[f>>2]);E=ea(g[f+4>>2]);C=ea(g[f+8>>2]);F=ea(g[f+12>>2]);s=j+16|0;D=ea(g[s>>2]);J=ea(g[s+4>>2]);K=ea(g[s+8>>2]);L=ea(g[h>>2]);M=ea(g[h+4>>2]);N=ea(g[h+8>>2]);O=ea(g[h+12>>2]);s=k+16|0;P=ea(g[s>>2]);Q=ea(g[s+4>>2]);R=ea(g[s+8>>2]);g[u>>2]=L;s=u+4|0;g[s>>2]=M;k=u+8|0;g[k>>2]=N;j=u+12|0;g[j>>2]=O;g[u+16>>2]=P;g[u+20>>2]=Q;g[u+24>>2]=R;g[u+28>>2]=ea(0.0);S=ea(-L);L=ea(-M);M=ea(-N);N=ea(D-P);T=ea(J-Q);U=ea(K-R);V=ea(ea(O*O)+ea(-.5));W=ea(ea(ea(N*S)+ea(T*L))+ea(U*M));X=ea(ea(ea(W*L)+ea(ea(V*T)+ea(O*ea(ea(N*M)-ea(U*S)))))*ea(2.0));Y=ea(ea(ea(ea(V*U)+ea(O*ea(ea(T*S)-ea(N*L))))+ea(W*M))*ea(2.0));Z=ea(ea(F*O)-ea(ea(ea(I*S)+ea(E*L))+ea(C*M)));_=ea(ea(ea(C*L)-ea(E*M))+ea(ea(F*S)+ea(I*O)));$=ea(ea(ea(I*M)-ea(C*S))+ea(ea(F*L)+ea(E*O)));aa=ea(ea(ea(E*S)-ea(I*L))+ea(ea(C*O)+ea(F*M)));g[e+48>>2]=ea(ea(ea(W*S)+ea(ea(V*N)+ea(O*ea(ea(U*L)-ea(T*M)))))*ea(2.0));g[e+52>>2]=X;g[e+56>>2]=Y;g[e+60>>2]=ea(0.0);Y=ea(_+_);X=ea($+$);M=ea(aa+aa);T=ea($*X);L=ea(aa*M);U=ea($*Y);$=ea(aa*Y);O=ea(Z*Y);N=ea(aa*X);aa=ea(Z*X);X=ea(Z*M);M=ea(ea(1.0)-ea(_*Y));Y=ea(U+X);_=ea($-aa);Z=ea(U-X);X=ea(M-L);U=ea(N+O);V=ea($+aa);aa=ea(N-O);O=ea(M-T);g[e>>2]=ea(ea(ea(1.0)-T)-L);g[e+4>>2]=Y;g[e+8>>2]=_;g[e+12>>2]=ea(0.0);g[e+16>>2]=Z;g[e+20>>2]=X;g[e+24>>2]=U;g[e+28>>2]=ea(0.0);g[e+32>>2]=V;g[e+36>>2]=aa;g[e+40>>2]=O;g[e+44>>2]=ea(0.0);g[v>>2]=q;q=ea(g[f+16>>2]);O=ea(g[f+20>>2]);aa=ea(g[f+24>>2]);V=ea(g[h+16>>2]);U=ea(g[h+20>>2]);X=ea(g[h+24>>2]);Z=ea(q-D);D=ea(O-J);J=ea(aa-K);g[w>>2]=Z;g[w+4>>2]=D;g[w+8>>2]=J;g[w+12>>2]=ea(0.0);K=ea(ea(V-P)-Z);Z=ea(ea(U-Q)-D);D=ea(ea(X-R)-J);J=ea(g[u>>2]);R=ea(g[s>>2]);X=ea(g[k>>2]);Q=ea(g[j>>2]);U=ea(ea(Q*Q)+ea(-.5));P=ea(ea(ea(K*J)+ea(Z*R))+ea(D*X));V=ea(ea(ea(R*P)+ea(ea(Z*U)-ea(Q*ea(ea(K*X)-ea(J*D)))))*ea(2.0));aa=ea(ea(ea(X*P)+ea(ea(D*U)-ea(Q*ea(ea(Z*J)-ea(K*R)))))*ea(2.0));g[x>>2]=ea(ea(ea(J*P)+ea(ea(K*U)-ea(Q*ea(ea(D*R)-ea(Z*X)))))*ea(2.0));g[x+4>>2]=V;g[x+8>>2]=aa;g[x+12>>2]=ea(0.0);if(!(K1a(t,o,e,u,w,v,d,x,y,z,A,l)|0)){ba=ea(3402823469999999843913219.0e14);i=p;return ea(ba)}l=ea(g[y>>2]);aa=ea(g[z>>2]);V=ea(g[z+4>>2]);X=ea(g[z+8>>2]);g[m>>2]=aa;g[m+4>>2]=V;g[m+8>>2]=X;X=ea(g[A>>2]);V=ea(g[A+4>>2]);aa=ea(g[A+8>>2]);g[n>>2]=X;g[n+4>>2]=V;g[n+8>>2]=aa;ba=l;i=p;return ea(ba)}function rza(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im;p=i;i=i+688|0;o=p+640|0;e=p+416|0;d=p+96|0;r=p+80|0;s=p+48|0;t=p+208|0;u=p+432|0;v=p+656|0;w=p+112|0;x=p+32|0;y=p+16|0;z=p+176|0;A=p;B=p+64|0;C=p+192|0;D=c[a>>2]|0;a=c[b>>2]|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;E=ea(g[D+40>>2]);F=ea(g[D+44>>2]);G=ea(g[D+48>>2]);g[e>>2]=E;g[e+4>>2]=F;g[e+8>>2]=G;g[e+12>>2]=ea(0.0);G=ea(g[D+52>>2]);F=ea(g[D+56>>2]);E=ea(g[D+60>>2]);H=ea(g[D+64>>2]);g[d>>2]=G;g[d+4>>2]=F;g[d+8>>2]=E;g[d+12>>2]=H;H=ea(g[a+40>>2]);E=ea(g[a+44>>2]);F=ea(g[a+48>>2]);g[r>>2]=H;g[r+4>>2]=E;g[r+8>>2]=F;g[r+12>>2]=ea(0.0);F=ea(g[a+52>>2]);E=ea(g[a+56>>2]);H=ea(g[a+60>>2]);G=ea(g[a+64>>2]);g[s>>2]=F;g[s+4>>2]=E;g[s+8>>2]=H;g[s+12>>2]=G;b=c[a+72>>2]|0;z1a(t,c[D+72>>2]|0,o,e,d);z1a(u,b,o,r,s);G=ea(g[f>>2]);H=ea(g[f+4>>2]);E=ea(g[f+8>>2]);F=ea(g[f+12>>2]);s=j+16|0;I=ea(g[s>>2]);J=ea(g[s+4>>2]);K=ea(g[s+8>>2]);L=ea(g[h>>2]);M=ea(g[h+4>>2]);N=ea(g[h+8>>2]);O=ea(g[h+12>>2]);s=k+16|0;P=ea(g[s>>2]);Q=ea(g[s+4>>2]);R=ea(g[s+8>>2]);g[v>>2]=L;s=v+4|0;g[s>>2]=M;k=v+8|0;g[k>>2]=N;j=v+12|0;g[j>>2]=O;g[v+16>>2]=P;g[v+20>>2]=Q;g[v+24>>2]=R;g[v+28>>2]=ea(0.0);S=ea(-L);L=ea(-M);M=ea(-N);N=ea(I-P);T=ea(J-Q);U=ea(K-R);V=ea(ea(O*O)+ea(-.5));W=ea(ea(ea(N*S)+ea(T*L))+ea(U*M));X=ea(ea(ea(W*L)+ea(ea(V*T)+ea(O*ea(ea(N*M)-ea(U*S)))))*ea(2.0));Y=ea(ea(ea(ea(V*U)+ea(O*ea(ea(T*S)-ea(N*L))))+ea(W*M))*ea(2.0));Z=ea(ea(F*O)-ea(ea(ea(G*S)+ea(H*L))+ea(E*M)));_=ea(ea(ea(E*L)-ea(H*M))+ea(ea(F*S)+ea(G*O)));$=ea(ea(ea(G*M)-ea(E*S))+ea(ea(F*L)+ea(H*O)));aa=ea(ea(ea(H*S)-ea(G*L))+ea(ea(E*O)+ea(F*M)));g[w+48>>2]=ea(ea(ea(W*S)+ea(ea(V*N)+ea(O*ea(ea(U*L)-ea(T*M)))))*ea(2.0));g[w+52>>2]=X;g[w+56>>2]=Y;g[w+60>>2]=ea(0.0);Y=ea(_+_);X=ea($+$);M=ea(aa+aa);T=ea($*X);L=ea(aa*M);U=ea($*Y);$=ea(aa*Y);O=ea(Z*Y);N=ea(aa*X);aa=ea(Z*X);X=ea(Z*M);M=ea(ea(1.0)-ea(_*Y));Y=ea(U+X);_=ea($-aa);Z=ea(U-X);X=ea(M-L);U=ea(N+O);V=ea($+aa);aa=ea(N-O);O=ea(M-T);g[w>>2]=ea(ea(ea(1.0)-T)-L);g[w+4>>2]=Y;g[w+8>>2]=_;g[w+12>>2]=ea(0.0);g[w+16>>2]=Z;g[w+20>>2]=X;g[w+24>>2]=U;g[w+28>>2]=ea(0.0);g[w+32>>2]=V;g[w+36>>2]=aa;g[w+40>>2]=O;g[w+44>>2]=ea(0.0);g[x>>2]=q;q=ea(g[f+16>>2]);O=ea(g[f+20>>2]);aa=ea(g[f+24>>2]);V=ea(g[h+16>>2]);U=ea(g[h+20>>2]);X=ea(g[h+24>>2]);Z=ea(q-I);I=ea(O-J);J=ea(aa-K);g[y>>2]=Z;g[y+4>>2]=I;g[y+8>>2]=J;g[y+12>>2]=ea(0.0);K=ea(ea(V-P)-Z);Z=ea(ea(U-Q)-I);I=ea(ea(X-R)-J);J=ea(g[v>>2]);R=ea(g[s>>2]);X=ea(g[k>>2]);Q=ea(g[j>>2]);U=ea(ea(Q*Q)+ea(-.5));P=ea(ea(ea(K*J)+ea(Z*R))+ea(I*X));V=ea(ea(ea(R*P)+ea(ea(Z*U)-ea(Q*ea(ea(K*X)-ea(J*I)))))*ea(2.0));aa=ea(ea(ea(X*P)+ea(ea(I*U)-ea(Q*ea(ea(Z*J)-ea(K*R)))))*ea(2.0));g[z>>2]=ea(ea(ea(J*P)+ea(ea(K*U)-ea(Q*ea(ea(I*R)-ea(Z*X)))))*ea(2.0));g[z+4>>2]=V;g[z+8>>2]=aa;g[z+12>>2]=ea(0.0);if(!(L1a(t,u,w,v,y,x,o,z,A,B,C,l)|0)){ba=ea(3402823469999999843913219.0e14);i=p;return ea(ba)}l=ea(g[A>>2]);aa=ea(g[B>>2]);V=ea(g[B+4>>2]);X=ea(g[B+8>>2]);g[m>>2]=aa;g[m+4>>2]=V;g[m+8>>2]=X;X=ea(g[C>>2]);V=ea(g[C+4>>2]);aa=ea(g[C+8>>2]);g[n>>2]=X;g[n+4>>2]=V;g[n+8>>2]=aa;ba=l;i=p;return ea(ba)}function sza(a,b,c,d,e,f,g,h,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);h=i;o=ea(M1a(a,b,c,d,e,f,j,k,l,m,n));i=h;return ea(o)}function tza(a,b,c,d,e,f,g,h,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);h=i;o=ea(N1a(a,b,c,d,e,f,j,k,l,m,n));i=h;return ea(o)}function uza(a){a=a|0;var b=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im;b=i;i=i+528|0;f=b+384|0;h=b+336|0;j=b+288|0;k=b+144|0;l=b;m=e[a+24>>1]|0;n=a+m|0;o=(e[a+8>>1]|0)+-1|0;if(o){p=j+4|0;q=j+8|0;r=j+16|0;s=j+20|0;t=j+24|0;u=j+32|0;v=j+36|0;w=j+40|0;x=h+4|0;y=h+8|0;z=h+12|0;A=h+16|0;B=h+20|0;C=h+24|0;D=h+28|0;E=h+32|0;F=h+36|0;G=h+40|0;H=h+44|0;I=f+16|0;J=f+32|0;K=f+48|0;L=f+64|0;M=f+80|0;N=f+96|0;O=f+112|0;P=f+128|0;Q=k+16|0;R=k+32|0;S=k+48|0;T=k+64|0;U=k+80|0;V=k+96|0;W=k+112|0;X=k+128|0;Y=o;do{o=d[a+Y+64>>0]|0;Z=n+(Y*400|0)|0;O1a(f,Z);_=n+(Y*400|0)+240|0;P1a(j,f,_,_);$=ea(g[j>>2]);aa=ea(g[p>>2]);ba=ea(g[q>>2]);ca=ea(g[r>>2]);da=ea(g[s>>2]);fa=ea(g[t>>2]);ga=ea(g[u>>2]);ha=ea(g[v>>2]);ia=ea(g[w>>2]);ja=ea(ea(da*ia)-ea(fa*ha));ka=ea(ea(fa*ga)-ea(ca*ia));fa=ea(ea(ca*ha)-ea(da*ga));la=ea(ea(1.0)/ea(ea(ea(-ea(aa*ka))-ea($*ja))-ea(ba*fa)));ma=ea(la*ka);ka=ea(fa*la);fa=ea(la*ea(ea($*ia)-ea(ba*ga)));ba=ea(la*ea(ea(aa*ga)-ea($*ha)));ha=ea(ea(ea($*da)-ea(aa*ca))*la);g[h>>2]=ea(la*ja);g[x>>2]=ma;g[y>>2]=ka;g[z>>2]=ea(0.0);g[A>>2]=ma;g[B>>2]=fa;g[C>>2]=ba;g[D>>2]=ea(0.0);g[E>>2]=ka;g[F>>2]=ba;g[G>>2]=ha;g[H>>2]=ea(0.0);c[Z+0>>2]=c[f+0>>2];c[Z+4>>2]=c[f+4>>2];c[Z+8>>2]=c[f+8>>2];c[Z+12>>2]=c[f+12>>2];Z=n+(Y*400|0)+16|0;c[Z+0>>2]=c[I+0>>2];c[Z+4>>2]=c[I+4>>2];c[Z+8>>2]=c[I+8>>2];c[Z+12>>2]=c[I+12>>2];Z=n+(Y*400|0)+32|0;c[Z+0>>2]=c[J+0>>2];c[Z+4>>2]=c[J+4>>2];c[Z+8>>2]=c[J+8>>2];c[Z+12>>2]=c[J+12>>2];Z=n+(Y*400|0)+48|0;c[Z+0>>2]=c[K+0>>2];c[Z+4>>2]=c[K+4>>2];c[Z+8>>2]=c[K+8>>2];c[Z+12>>2]=c[K+12>>2];Z=n+(Y*400|0)+64|0;c[Z+0>>2]=c[L+0>>2];c[Z+4>>2]=c[L+4>>2];c[Z+8>>2]=c[L+8>>2];c[Z+12>>2]=c[L+12>>2];Z=n+(Y*400|0)+80|0;c[Z+0>>2]=c[M+0>>2];c[Z+4>>2]=c[M+4>>2];c[Z+8>>2]=c[M+8>>2];c[Z+12>>2]=c[M+12>>2];Z=n+(Y*400|0)+96|0;c[Z+0>>2]=c[N+0>>2];c[Z+4>>2]=c[N+4>>2];c[Z+8>>2]=c[N+8>>2];c[Z+12>>2]=c[N+12>>2];Z=n+(Y*400|0)+112|0;c[Z+0>>2]=c[O+0>>2];c[Z+4>>2]=c[O+4>>2];c[Z+8>>2]=c[O+8>>2];c[Z+12>>2]=c[O+12>>2];Z=n+(Y*400|0)+128|0;c[Z+0>>2]=c[P+0>>2];c[Z+4>>2]=c[P+4>>2];c[Z+8>>2]=c[P+8>>2];c[Z+12>>2]=c[P+12>>2];Z=n+(o*400|0)|0;_=n+(Y*400|0)+144|0;Q1a(k,Z,h,_,_);c[Z+0>>2]=c[k+0>>2];c[Z+4>>2]=c[k+4>>2];c[Z+8>>2]=c[k+8>>2];c[Z+12>>2]=c[k+12>>2];Z=n+(o*400|0)+16|0;c[Z+0>>2]=c[Q+0>>2];c[Z+4>>2]=c[Q+4>>2];c[Z+8>>2]=c[Q+8>>2];c[Z+12>>2]=c[Q+12>>2];Z=n+(o*400|0)+32|0;c[Z+0>>2]=c[R+0>>2];c[Z+4>>2]=c[R+4>>2];c[Z+8>>2]=c[R+8>>2];c[Z+12>>2]=c[R+12>>2];Z=n+(o*400|0)+48|0;c[Z+0>>2]=c[S+0>>2];c[Z+4>>2]=c[S+4>>2];c[Z+8>>2]=c[S+8>>2];c[Z+12>>2]=c[S+12>>2];Z=n+(o*400|0)+64|0;c[Z+0>>2]=c[T+0>>2];c[Z+4>>2]=c[T+4>>2];c[Z+8>>2]=c[T+8>>2];c[Z+12>>2]=c[T+12>>2];Z=n+(o*400|0)+80|0;c[Z+0>>2]=c[U+0>>2];c[Z+4>>2]=c[U+4>>2];c[Z+8>>2]=c[U+8>>2];c[Z+12>>2]=c[U+12>>2];Z=n+(o*400|0)+96|0;c[Z+0>>2]=c[V+0>>2];c[Z+4>>2]=c[V+4>>2];c[Z+8>>2]=c[V+8>>2];c[Z+12>>2]=c[V+12>>2];Z=n+(o*400|0)+112|0;c[Z+0>>2]=c[W+0>>2];c[Z+4>>2]=c[W+4>>2];c[Z+8>>2]=c[W+8>>2];c[Z+12>>2]=c[W+12>>2];Z=n+(o*400|0)+128|0;c[Z+0>>2]=c[X+0>>2];c[Z+4>>2]=c[X+4>>2];c[Z+8>>2]=c[X+8>>2];c[Z+12>>2]=c[X+12>>2];Z=n+(Y*400|0)+336|0;o=h+0|0;_=Z+48|0;do{c[Z>>2]=c[o>>2];Z=Z+4|0;o=o+4|0}while((Z|0)<(_|0));Y=Y+-1|0}while((Y|0)!=0)}O1a(l,n);c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];n=a+(m+16)|0;Y=l+16|0;c[n+0>>2]=c[Y+0>>2];c[n+4>>2]=c[Y+4>>2];c[n+8>>2]=c[Y+8>>2];c[n+12>>2]=c[Y+12>>2];Y=a+(m+32)|0;n=l+32|0;c[Y+0>>2]=c[n+0>>2];c[Y+4>>2]=c[n+4>>2];c[Y+8>>2]=c[n+8>>2];c[Y+12>>2]=c[n+12>>2];n=a+(m+48)|0;Y=l+48|0;c[n+0>>2]=c[Y+0>>2];c[n+4>>2]=c[Y+4>>2];c[n+8>>2]=c[Y+8>>2];c[n+12>>2]=c[Y+12>>2];Y=a+(m+64)|0;n=l+64|0;c[Y+0>>2]=c[n+0>>2];c[Y+4>>2]=c[n+4>>2];c[Y+8>>2]=c[n+8>>2];c[Y+12>>2]=c[n+12>>2];n=a+(m+80)|0;Y=l+80|0;c[n+0>>2]=c[Y+0>>2];c[n+4>>2]=c[Y+4>>2];c[n+8>>2]=c[Y+8>>2];c[n+12>>2]=c[Y+12>>2];Y=a+(m+96)|0;n=l+96|0;c[Y+0>>2]=c[n+0>>2];c[Y+4>>2]=c[n+4>>2];c[Y+8>>2]=c[n+8>>2];c[Y+12>>2]=c[n+12>>2];n=a+(m+112)|0;Y=l+112|0;c[n+0>>2]=c[Y+0>>2];c[n+4>>2]=c[Y+4>>2];c[n+8>>2]=c[Y+8>>2];c[n+12>>2]=c[Y+12>>2];Y=a+(m+128)|0;m=l+128|0;c[Y+0>>2]=c[m+0>>2];c[Y+4>>2]=c[m+4>>2];c[Y+8>>2]=c[m+8>>2];c[Y+12>>2]=c[m+12>>2];i=b;return}function vza(a,f,h){a=a|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0;j=i;i=i+64|0;k=j+32|0;l=j;m=a+(e[a+24>>1]|0)|0;n=a+8|0;PEi(h|0,0,(e[n>>1]|0)<<5|0)|0;o=b[n>>1]|0;if((o&65535)>1){p=o&65535;do{p=p+-1|0;o=d[a+p+64>>0]|0;q=f+(p<<4)|0;r=ea(g[q>>2]);s=f+(p<<4)+4|0;t=ea(g[s>>2]);u=f+(p<<4)+8|0;v=ea(g[u>>2]);w=ea(g[m+(p*400|0)+240>>2]);x=ea(g[m+(p*400|0)+244>>2]);y=ea(g[m+(p*400|0)+248>>2]);z=ea(g[h+(p<<5)>>2]);A=ea(g[h+(p<<5)+4>>2]);B=ea(g[h+(p<<5)+8>>2]);C=ea(ea(ea(w*z)+ea(x*A))+ea(y*B));y=ea(g[m+(p*400|0)+256>>2]);x=ea(g[m+(p*400|0)+260>>2]);w=ea(g[m+(p*400|0)+264>>2]);D=ea(g[h+(p<<5)+16>>2]);E=ea(g[h+(p<<5)+20>>2]);F=ea(g[h+(p<<5)+24>>2]);G=ea(C+ea(ea(ea(y*D)+ea(x*E))+ea(w*F)));w=ea(g[m+(p*400|0)+272>>2]);x=ea(g[m+(p*400|0)+276>>2]);y=ea(ea(ea(z*w)+ea(A*x))+ea(B*ea(g[m+(p*400|0)+280>>2])));x=ea(g[m+(p*400|0)+288>>2]);w=ea(g[m+(p*400|0)+292>>2]);C=ea(y+ea(ea(ea(D*x)+ea(E*w))+ea(F*ea(g[m+(p*400|0)+296>>2]))));w=ea(g[m+(p*400|0)+304>>2]);x=ea(g[m+(p*400|0)+308>>2]);y=ea(ea(ea(z*w)+ea(A*x))+ea(B*ea(g[m+(p*400|0)+312>>2])));B=ea(g[m+(p*400|0)+320>>2]);x=ea(g[m+(p*400|0)+324>>2]);A=ea(r-G);G=ea(t-C);C=ea(v-ea(y+ea(ea(ea(D*B)+ea(E*x))+ea(F*ea(g[m+(p*400|0)+328>>2])))));g[q>>2]=A;g[s>>2]=G;g[u>>2]=C;g[f+(p<<4)+12>>2]=ea(0.0);F=ea(g[m+(p*400|0)+144>>2]);x=ea(g[m+(p*400|0)+148>>2]);E=ea(g[m+(p*400|0)+152>>2]);B=ea(g[m+(p*400|0)+176>>2]);D=ea(g[m+(p*400|0)+180>>2]);y=ea(g[m+(p*400|0)+184>>2]);v=ea(g[m+(p*400|0)+208>>2]);t=ea(g[m+(p*400|0)+212>>2]);r=ea(ea(A*F)+ea(ea(G*B)+ea(C*v)));v=ea(ea(A*x)+ea(ea(G*D)+ea(C*t)));t=ea(ea(A*E)+ea(ea(G*y)+ea(C*ea(g[m+(p*400|0)+216>>2]))));y=ea(g[m+(p*400|0)+160>>2]);E=ea(g[m+(p*400|0)+164>>2]);D=ea(g[m+(p*400|0)+168>>2]);x=ea(g[m+(p*400|0)+192>>2]);B=ea(g[m+(p*400|0)+196>>2]);F=ea(g[m+(p*400|0)+200>>2]);w=ea(g[m+(p*400|0)+224>>2]);z=ea(g[m+(p*400|0)+228>>2]);H=ea(ea(A*y)+ea(ea(G*x)+ea(C*w)));w=ea(ea(A*E)+ea(ea(G*B)+ea(C*z)));z=ea(ea(A*D)+ea(ea(G*F)+ea(C*ea(g[m+(p*400|0)+232>>2]))));u=h+(o<<5)|0;C=ea(g[u>>2]);s=h+(o<<5)+4|0;F=ea(g[s>>2]);q=h+(o<<5)+8|0;G=ea(C-r);r=ea(F-v);v=ea(ea(g[q>>2])-t);I=h+(o<<5)+16|0;t=ea(g[I>>2]);J=h+(o<<5)+20|0;F=ea(g[J>>2]);K=h+(o<<5)+24|0;C=ea(t-H);H=ea(F-w);w=ea(ea(g[K>>2])-z);g[u>>2]=G;g[s>>2]=r;g[q>>2]=v;g[h+(o<<5)+12>>2]=ea(0.0);g[I>>2]=C;g[J>>2]=H;g[K>>2]=w;g[h+(o<<5)+28>>2]=ea(0.0)}while(p>>>0>1)}R1a(k,m,h);c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];p=h+16|0;o=k+16|0;c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];c[p+12>>2]=c[o+12>>2];if((e[n>>1]|0)<=1){i=j;return}o=l+4|0;p=l+8|0;k=l+16|0;K=l+20|0;J=l+24|0;I=1;do{q=d[a+I+64>>0]|0;w=ea(g[f+(I<<4)>>2]);H=ea(g[f+(I<<4)+4>>2]);C=ea(g[f+(I<<4)+8>>2]);v=ea(w*ea(g[m+(I*400|0)+336>>2]));r=ea(v+ea(H*ea(g[m+(I*400|0)+352>>2])));v=ea(r+ea(C*ea(g[m+(I*400|0)+368>>2])));r=ea(w*ea(g[m+(I*400|0)+340>>2]));G=ea(r+ea(H*ea(g[m+(I*400|0)+356>>2])));r=ea(G+ea(C*ea(g[m+(I*400|0)+372>>2])));G=ea(w*ea(g[m+(I*400|0)+344>>2]));w=ea(G+ea(H*ea(g[m+(I*400|0)+360>>2])));H=ea(w+ea(C*ea(g[m+(I*400|0)+376>>2])));C=ea(g[m+(I*400|0)+144>>2]);w=ea(g[m+(I*400|0)+148>>2]);G=ea(g[m+(I*400|0)+152>>2]);z=ea(g[h+(q<<5)>>2]);F=ea(g[h+(q<<5)+4>>2]);t=ea(g[h+(q<<5)+8>>2]);D=ea(ea(ea(C*z)+ea(w*F))+ea(G*t));G=ea(g[m+(I*400|0)+160>>2]);w=ea(g[m+(I*400|0)+164>>2]);C=ea(g[m+(I*400|0)+168>>2]);A=ea(g[h+(q<<5)+16>>2]);B=ea(g[h+(q<<5)+20>>2]);E=ea(g[h+(q<<5)+24>>2]);x=ea(D+ea(ea(ea(G*A)+ea(w*B))+ea(C*E)));C=ea(g[m+(I*400|0)+176>>2]);w=ea(g[m+(I*400|0)+180>>2]);G=ea(ea(ea(z*C)+ea(F*w))+ea(t*ea(g[m+(I*400|0)+184>>2])));w=ea(g[m+(I*400|0)+192>>2]);C=ea(g[m+(I*400|0)+196>>2]);D=ea(G+ea(ea(ea(A*w)+ea(B*C))+ea(E*ea(g[m+(I*400|0)+200>>2]))));C=ea(g[m+(I*400|0)+208>>2]);w=ea(g[m+(I*400|0)+212>>2]);G=ea(ea(ea(z*C)+ea(F*w))+ea(t*ea(g[m+(I*400|0)+216>>2])));t=ea(g[m+(I*400|0)+224>>2]);w=ea(g[m+(I*400|0)+228>>2]);F=ea(v-x);x=ea(r-D);D=ea(H-ea(G+ea(ea(ea(A*t)+ea(B*w))+ea(E*ea(g[m+(I*400|0)+232>>2])))));q=h+(I<<5)|0;R1a(l,m+(I*400|0)|0,q);E=ea(g[m+(I*400|0)+240>>2]);w=ea(g[m+(I*400|0)+244>>2]);B=ea(g[m+(I*400|0)+248>>2]);t=ea(g[m+(I*400|0)+272>>2]);A=ea(g[m+(I*400|0)+276>>2]);G=ea(g[m+(I*400|0)+280>>2]);H=ea(g[m+(I*400|0)+304>>2]);r=ea(g[m+(I*400|0)+308>>2]);v=ea(ea(F*E)+ea(ea(x*t)+ea(D*H)));H=ea(ea(F*w)+ea(ea(x*A)+ea(D*r)));r=ea(ea(F*B)+ea(ea(x*G)+ea(D*ea(g[m+(I*400|0)+312>>2]))));G=ea(g[m+(I*400|0)+256>>2]);B=ea(g[m+(I*400|0)+260>>2]);A=ea(g[m+(I*400|0)+264>>2]);w=ea(g[m+(I*400|0)+288>>2]);t=ea(g[m+(I*400|0)+292>>2]);E=ea(g[m+(I*400|0)+296>>2]);C=ea(g[m+(I*400|0)+320>>2]);z=ea(g[m+(I*400|0)+324>>2]);y=ea(ea(F*G)+ea(ea(x*w)+ea(D*C)));C=ea(ea(F*B)+ea(ea(x*t)+ea(D*z)));z=ea(ea(F*A)+ea(ea(x*E)+ea(D*ea(g[m+(I*400|0)+328>>2]))));D=ea(g[l>>2]);E=ea(g[o>>2]);x=ea(D-v);v=ea(E-H);H=ea(ea(g[p>>2])-r);r=ea(g[k>>2]);E=ea(g[K>>2]);D=ea(r-y);y=ea(E-C);C=ea(ea(g[J>>2])-z);g[q>>2]=x;g[h+(I<<5)+4>>2]=v;g[h+(I<<5)+8>>2]=H;g[h+(I<<5)+12>>2]=ea(0.0);g[h+(I<<5)+16>>2]=D;g[h+(I<<5)+20>>2]=y;g[h+(I<<5)+24>>2]=C;g[h+(I<<5)+28>>2]=ea(0.0);I=I+1|0}while(I>>>0<(e[n>>1]|0)>>>0);i=j;return}function wza(a,c,d){a=a|0;c=c|0;d=d|0;var f=0,h=0,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=Im;f=i;i=i+2048|0;h=f;vza(a,d,h);d=a+8|0;if(!(b[d>>1]|0)){i=f;return}else j=0;do{a=c+(j<<5)|0;k=ea(g[a>>2]);l=c+(j<<5)+4|0;m=ea(g[l>>2]);n=c+(j<<5)+8|0;o=ea(g[n>>2]);p=ea(g[h+(j<<5)>>2]);q=ea(g[h+(j<<5)+4>>2]);r=ea(m-q);q=ea(o-ea(g[h+(j<<5)+8>>2]));g[a>>2]=ea(k-p);g[l>>2]=r;g[n>>2]=q;g[c+(j<<5)+12>>2]=ea(0.0);n=c+(j<<5)+16|0;q=ea(g[n>>2]);l=c+(j<<5)+20|0;r=ea(g[l>>2]);a=c+(j<<5)+24|0;p=ea(g[a>>2]);k=ea(g[h+(j<<5)+16>>2]);o=ea(g[h+(j<<5)+20>>2]);m=ea(r-o);o=ea(p-ea(g[h+(j<<5)+24>>2]));g[n>>2]=ea(q-k);g[l>>2]=m;g[a>>2]=o;g[c+(j<<5)+28>>2]=ea(0.0);j=j+1|0}while(j>>>0<(e[d>>1]|0)>>>0);i=f;return}function xza(a,f,h,j,k){a=a|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=Im,rb=Im,sb=0,tb=0,ub=0,vb=Im,wb=Im,xb=Im,yb=0,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=0,Fb=0,Gb=0,Hb=Im,Ib=Im,Jb=Im,Kb=0,Lb=0,Mb=0,Nb=Im,Ob=Im,Pb=Im,Qb=0,Rb=0,Sb=0,Tb=Im,Ub=Im,Vb=Im;l=i;i=i+656|0;m=l+16|0;n=l+224|0;o=l+32|0;p=l+320|0;q=l+512|0;r=l;s=l+80|0;t=l+368|0;u=a+26|0;v=a+((e[u>>1]|0)+144)|0;w=a+8|0;x=e[w>>1]|0;y=a+((x*432|0)+(e[a+24>>1]|0))|0;z=a+(e[a+10>>1]|0)|0;A=k+8|0;B=c[A>>2]|0;C=(c[k>>2]|0)+B|0;k=x*144|0;c[A>>2]=B+k;YEi(C|0,f|0,k|0)|0;k=(e[w>>1]|0)+-1|0;if(!k){D=b[u>>1]|0;E=D&65535;F=a+E|0;O1a(t,C);c[F+0>>2]=c[t+0>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2];c[F+12>>2]=c[t+12>>2];G=E+16|0;H=a+G|0;I=t+16|0;c[H+0>>2]=c[I+0>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];c[H+12>>2]=c[I+12>>2];J=E+32|0;K=a+J|0;L=t+32|0;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];M=E+48|0;N=a+M|0;O=t+48|0;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];c[N+12>>2]=c[O+12>>2];P=E+64|0;Q=a+P|0;R=t+64|0;c[Q+0>>2]=c[R+0>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];c[Q+12>>2]=c[R+12>>2];S=E+80|0;T=a+S|0;U=t+80|0;c[T+0>>2]=c[U+0>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];c[T+12>>2]=c[U+12>>2];V=E+96|0;W=a+V|0;X=t+96|0;c[W+0>>2]=c[X+0>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];c[W+12>>2]=c[X+12>>2];Y=E+112|0;Z=a+Y|0;_=t+112|0;c[Z+0>>2]=c[_+0>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];c[Z+12>>2]=c[_+12>>2];$=E+128|0;aa=a+$|0;ba=t+128|0;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];c[aa+12>>2]=c[ba+12>>2];i=l;return}w=o+4|0;f=o+8|0;B=o+16|0;A=o+20|0;x=o+24|0;ca=o+32|0;da=o+36|0;fa=o+40|0;ga=p+4|0;ha=p+8|0;ia=p+12|0;ja=p+16|0;ka=p+20|0;la=p+24|0;ma=p+28|0;na=p+32|0;oa=p+36|0;pa=p+40|0;qa=p+44|0;ra=q+4|0;sa=q+8|0;ta=q+16|0;ua=q+20|0;va=q+24|0;wa=q+32|0;xa=q+36|0;ya=q+40|0;za=q+48|0;Aa=q+52|0;Ba=q+56|0;Ca=q+64|0;Da=q+68|0;Ea=q+72|0;Fa=q+80|0;Ga=q+84|0;Ha=q+88|0;Ia=q+96|0;Ja=q+100|0;Ka=q+104|0;La=q+112|0;Ma=q+116|0;Na=q+120|0;Oa=q+128|0;Pa=q+132|0;Qa=q+136|0;Ra=k;do{k=C+(Ra*144|0)|0;P1a(o,k,y+(Ra*96|0)|0,n);Sa=ea(g[h+(Ra<<2)>>2]);Ta=ea(g[j+(Ra*48|0)>>2]);Ua=ea(g[j+(Ra*48|0)+4>>2]);Va=ea(g[j+(Ra*48|0)+8>>2]);Wa=ea(g[o>>2]);Xa=ea(g[w>>2]);Ya=ea(ea(Sa*Ta)+Wa);Wa=ea(ea(Sa*Ua)+Xa);Xa=ea(ea(Sa*Va)+ea(g[f>>2]));Va=ea(g[j+(Ra*48|0)+16>>2]);Ua=ea(g[j+(Ra*48|0)+20>>2]);Ta=ea(g[j+(Ra*48|0)+24>>2]);Za=ea(g[B>>2]);_a=ea(g[A>>2]);$a=ea(ea(Sa*Va)+Za);Za=ea(ea(Sa*Ua)+_a);_a=ea(ea(Sa*Ta)+ea(g[x>>2]));Ta=ea(g[j+(Ra*48|0)+32>>2]);Ua=ea(g[j+(Ra*48|0)+36>>2]);Va=ea(g[j+(Ra*48|0)+40>>2]);ab=ea(g[ca>>2]);bb=ea(g[da>>2]);cb=ea(ea(Sa*Ta)+ab);ab=ea(ea(Sa*Ua)+bb);bb=ea(ea(Sa*Va)+ea(g[fa>>2]));Va=ea(ea(Za*bb)-ea(_a*ab));Sa=ea(ea(_a*cb)-ea($a*bb));_a=ea(ea($a*ab)-ea(Za*cb));Ua=ea(ea(1.0)/ea(ea(Xa*_a)+ea(ea(Ya*Va)+ea(Wa*Sa))));Ta=ea(Ua*Sa);Sa=ea(Ua*_a);_a=ea(Ua*ea(ea(Ya*bb)-ea(Xa*cb)));Xa=ea(Ua*ea(ea(Wa*cb)-ea(Ya*ab)));ab=ea(ea(ea(Ya*Za)-ea(Wa*$a))*Ua);g[p>>2]=ea(Ua*Va);g[ga>>2]=Ta;g[ha>>2]=Sa;g[ia>>2]=ea(0.0);g[ja>>2]=Ta;g[ka>>2]=_a;g[la>>2]=Xa;g[ma>>2]=ea(0.0);g[na>>2]=Sa;g[oa>>2]=Xa;g[pa>>2]=ab;g[qa>>2]=ea(0.0);db=v+(Ra*160|0)+96|0;eb=p+0|0;fb=db+48|0;do{c[db>>2]=c[eb>>2];db=db+4|0;eb=eb+4|0}while((db|0)<(fb|0));eb=d[a+Ra+64>>0]|0;db=z+(Ra<<5)|0;c[r+0>>2]=c[db+0>>2];c[r+4>>2]=c[db+4>>2];c[r+8>>2]=c[db+8>>2];c[r+12>>2]=c[db+12>>2];Q1a(s,k,p,n,v+(Ra*160|0)|0);c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];S1a(q,m,s);db=C+(eb*144|0)|0;ab=ea(g[db>>2]);fb=C+(eb*144|0)+4|0;Xa=ea(g[fb>>2]);gb=C+(eb*144|0)+8|0;Sa=ea(g[gb>>2]);_a=ea(g[q>>2]);Ta=ea(g[ra>>2]);Va=ea(ab+_a);_a=ea(Xa+Ta);Ta=ea(Sa+ea(g[sa>>2]));hb=C+(eb*144|0)+16|0;Sa=ea(g[hb>>2]);ib=C+(eb*144|0)+20|0;Xa=ea(g[ib>>2]);jb=C+(eb*144|0)+24|0;ab=ea(g[jb>>2]);Ua=ea(g[ta>>2]);$a=ea(g[ua>>2]);Wa=ea(Sa+Ua);Ua=ea(Xa+$a);$a=ea(ab+ea(g[va>>2]));kb=C+(eb*144|0)+32|0;ab=ea(g[kb>>2]);lb=C+(eb*144|0)+36|0;Xa=ea(g[lb>>2]);mb=C+(eb*144|0)+40|0;Sa=ea(g[mb>>2]);Za=ea(g[wa>>2]);Ya=ea(g[xa>>2]);cb=ea(ab+Za);Za=ea(Xa+Ya);Ya=ea(Sa+ea(g[ya>>2]));nb=C+(eb*144|0)+48|0;Sa=ea(g[nb>>2]);ob=C+(eb*144|0)+52|0;Xa=ea(g[ob>>2]);pb=C+(eb*144|0)+56|0;ab=ea(g[pb>>2]);bb=ea(g[za>>2]);qb=ea(g[Aa>>2]);rb=ea(Sa+bb);bb=ea(Xa+qb);qb=ea(ab+ea(g[Ba>>2]));sb=C+(eb*144|0)+64|0;ab=ea(g[sb>>2]);tb=C+(eb*144|0)+68|0;Xa=ea(g[tb>>2]);ub=C+(eb*144|0)+72|0;Sa=ea(g[ub>>2]);vb=ea(g[Ca>>2]);wb=ea(g[Da>>2]);xb=ea(ab+vb);vb=ea(Xa+wb);wb=ea(Sa+ea(g[Ea>>2]));yb=C+(eb*144|0)+80|0;Sa=ea(g[yb>>2]);zb=C+(eb*144|0)+84|0;Xa=ea(g[zb>>2]);Ab=C+(eb*144|0)+88|0;ab=ea(g[Ab>>2]);Bb=ea(g[Fa>>2]);Cb=ea(g[Ga>>2]);Db=ea(Sa+Bb);Bb=ea(Xa+Cb);Cb=ea(ab+ea(g[Ha>>2]));Eb=C+(eb*144|0)+96|0;ab=ea(g[Eb>>2]);Fb=C+(eb*144|0)+100|0;Xa=ea(g[Fb>>2]);Gb=C+(eb*144|0)+104|0;Sa=ea(g[Gb>>2]);Hb=ea(g[Ia>>2]);Ib=ea(g[Ja>>2]);Jb=ea(ab+Hb);Hb=ea(Xa+Ib);Ib=ea(Sa+ea(g[Ka>>2]));Kb=C+(eb*144|0)+112|0;Sa=ea(g[Kb>>2]);Lb=C+(eb*144|0)+116|0;Xa=ea(g[Lb>>2]);Mb=C+(eb*144|0)+120|0;ab=ea(g[Mb>>2]);Nb=ea(g[La>>2]);Ob=ea(g[Ma>>2]);Pb=ea(Sa+Nb);Nb=ea(Xa+Ob);Ob=ea(ab+ea(g[Na>>2]));Qb=C+(eb*144|0)+128|0;ab=ea(g[Qb>>2]);Rb=C+(eb*144|0)+132|0;Xa=ea(g[Rb>>2]);Sb=C+(eb*144|0)+136|0;Sa=ea(g[Sb>>2]);Tb=ea(g[Oa>>2]);Ub=ea(g[Pa>>2]);Vb=ea(ab+Tb);Tb=ea(Xa+Ub);Ub=ea(Sa+ea(g[Qa>>2]));g[db>>2]=Va;g[fb>>2]=_a;g[gb>>2]=Ta;g[C+(eb*144|0)+12>>2]=ea(0.0);g[hb>>2]=Wa;g[ib>>2]=Ua;g[jb>>2]=$a;g[C+(eb*144|0)+28>>2]=ea(0.0);g[kb>>2]=cb;g[lb>>2]=Za;g[mb>>2]=Ya;g[C+(eb*144|0)+44>>2]=ea(0.0);g[nb>>2]=rb;g[ob>>2]=bb;g[pb>>2]=qb;g[C+(eb*144|0)+60>>2]=ea(0.0);g[sb>>2]=xb;g[tb>>2]=vb;g[ub>>2]=wb;g[C+(eb*144|0)+76>>2]=ea(0.0);g[yb>>2]=Db;g[zb>>2]=Bb;g[Ab>>2]=Cb;g[C+(eb*144|0)+92>>2]=ea(0.0);g[Eb>>2]=Jb;g[Fb>>2]=Hb;g[Gb>>2]=Ib;g[C+(eb*144|0)+108>>2]=ea(0.0);g[Kb>>2]=Pb;g[Lb>>2]=Nb;g[Mb>>2]=Ob;g[C+(eb*144|0)+124>>2]=ea(0.0);g[Qb>>2]=Vb;g[Rb>>2]=Tb;g[Sb>>2]=Ub;g[C+(eb*144|0)+140>>2]=ea(0.0);Ra=Ra+-1|0}while((Ra|0)!=0);D=b[u>>1]|0;E=D&65535;F=a+E|0;O1a(t,C);c[F+0>>2]=c[t+0>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2];c[F+12>>2]=c[t+12>>2];G=E+16|0;H=a+G|0;I=t+16|0;c[H+0>>2]=c[I+0>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];c[H+12>>2]=c[I+12>>2];J=E+32|0;K=a+J|0;L=t+32|0;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];M=E+48|0;N=a+M|0;O=t+48|0;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];c[N+12>>2]=c[O+12>>2];P=E+64|0;Q=a+P|0;R=t+64|0;c[Q+0>>2]=c[R+0>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];c[Q+12>>2]=c[R+12>>2];S=E+80|0;T=a+S|0;U=t+80|0;c[T+0>>2]=c[U+0>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];c[T+12>>2]=c[U+12>>2];V=E+96|0;W=a+V|0;X=t+96|0;c[W+0>>2]=c[X+0>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];c[W+12>>2]=c[X+12>>2];Y=E+112|0;Z=a+Y|0;_=t+112|0;c[Z+0>>2]=c[_+0>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];c[Z+12>>2]=c[_+12>>2];$=E+128|0;aa=a+$|0;ba=t+128|0;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];c[aa+12>>2]=c[ba+12>>2];i=l;return}function yza(a,f){a=a|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0;h=i;i=i+5248|0;j=h+64|0;k=h+2144|0;l=h+4192|0;m=h+5216|0;n=h+32|0;o=h;p=h+2112|0;q=a+26|0;r=b[q>>1]|0;s=a+((r&65535)+144)|0;t=a+8|0;u=b[t>>1]|0;v=u&65535;w=a+((v*432|0)+(e[a+24>>1]|0))|0;x=a+(e[a+10>>1]|0)|0;PEi(j|0,0,v<<5|0)|0;if((u&65535)>1){u=m+4|0;y=m+8|0;z=m+16|0;A=m+20|0;B=m+24|0;C=v;do{C=C+-1|0;v=d[a+C+64>>0]|0;T1a(m,s+(C*160|0)|0,x+(C<<5)|0,l+(C<<4)|0,j+(C<<5)|0,f+(C<<4)|0);D=j+(v<<5)|0;E=ea(g[D>>2]);F=j+(v<<5)+4|0;G=ea(g[F>>2]);H=j+(v<<5)+8|0;I=ea(g[H>>2]);J=ea(g[m>>2]);K=ea(g[u>>2]);L=ea(G+K);K=ea(I+ea(g[y>>2]));g[D>>2]=ea(E+J);g[F>>2]=L;g[H>>2]=K;g[j+(v<<5)+12>>2]=ea(0.0);H=j+(v<<5)+16|0;K=ea(g[H>>2]);F=j+(v<<5)+20|0;L=ea(g[F>>2]);D=j+(v<<5)+24|0;J=ea(g[D>>2]);E=ea(g[z>>2]);I=ea(g[A>>2]);G=ea(L+I);I=ea(J+ea(g[B>>2]));g[H>>2]=ea(K+E);g[F>>2]=G;g[D>>2]=I;g[j+(v<<5)+28>>2]=ea(0.0)}while(C>>>0>1);M=b[q>>1]|0}else M=r;I=ea(g[j>>2]);G=ea(g[j+4>>2]);E=ea(-I);I=ea(-G);G=ea(-ea(g[j+8>>2]));K=ea(g[j+16>>2]);J=ea(g[j+20>>2]);L=ea(-K);K=ea(-J);J=ea(-ea(g[j+24>>2]));g[o>>2]=E;g[o+4>>2]=I;g[o+8>>2]=G;g[o+12>>2]=ea(0.0);g[o+16>>2]=L;g[o+20>>2]=K;g[o+24>>2]=J;g[o+28>>2]=ea(0.0);R1a(n,a+(M&65535)|0,o);c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];o=k+16|0;M=n+16|0;c[o+0>>2]=c[M+0>>2];c[o+4>>2]=c[M+4>>2];c[o+8>>2]=c[M+8>>2];c[o+12>>2]=c[M+12>>2];M=b[t>>1]|0;if((M&65535)>1){o=p+16|0;n=1;do{j=k+(n<<5)|0;U1a(p,s+(n*160|0)|0,x+(n<<5)|0,l+(n<<4)|0,k+((d[a+n+64>>0]|0)<<5)|0,w+(n*96|0)|0);c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];j=k+(n<<5)+16|0;c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];n=n+1|0;j=b[t>>1]|0}while(n>>>0<(j&65535)>>>0);N=j}else N=M;M=a+128|0;if(!(N<<16>>16)){i=h;return}else O=0;do{N=M+(O<<5)|0;J=ea(g[N>>2]);a=M+(O<<5)+4|0;K=ea(g[a>>2]);n=M+(O<<5)+8|0;L=ea(g[n>>2]);G=ea(g[k+(O<<5)>>2]);I=ea(g[k+(O<<5)+4>>2]);E=ea(K+I);I=ea(L+ea(g[k+(O<<5)+8>>2]));g[N>>2]=ea(J+G);g[a>>2]=E;g[n>>2]=I;g[M+(O<<5)+12>>2]=ea(0.0);n=M+(O<<5)+16|0;I=ea(g[n>>2]);a=M+(O<<5)+20|0;E=ea(g[a>>2]);N=M+(O<<5)+24|0;G=ea(g[N>>2]);J=ea(g[k+(O<<5)+16>>2]);L=ea(g[k+(O<<5)+20>>2]);K=ea(E+L);L=ea(G+ea(g[k+(O<<5)+24>>2]));g[n>>2]=ea(I+J);g[a>>2]=K;g[N>>2]=L;g[M+(O<<5)+28>>2]=ea(0.0);O=O+1|0}while(O>>>0<(e[t>>1]|0)>>>0);i=h;return}function zza(a,f,h){a=a|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0;j=i;i=i+3200|0;k=j+1152|0;l=j+128|0;m=j+96|0;n=j+64|0;o=j+32|0;p=j;q=a+26|0;r=b[q>>1]|0;s=a+((r&65535)+144)|0;t=a+8|0;u=b[t>>1]|0;v=u&65535;w=a+((v*432|0)+(e[a+24>>1]|0))|0;x=a+(e[a+10>>1]|0)|0;if((u&65535)>1){u=m+4|0;y=m+8|0;z=m+16|0;A=m+20|0;B=m+24|0;C=v;do{C=C+-1|0;v=d[a+C+64>>0]|0;V1a(m,s+(C*160|0)|0,x+(C<<5)|0,l+(C<<4)|0,f+(C<<5)|0,w+(C*96|0)|0);D=f+(v<<5)|0;E=ea(g[D>>2]);F=f+(v<<5)+4|0;G=ea(g[F>>2]);H=f+(v<<5)+8|0;I=ea(g[H>>2]);J=ea(g[m>>2]);K=ea(g[u>>2]);L=ea(G+K);K=ea(I+ea(g[y>>2]));g[D>>2]=ea(E+J);g[F>>2]=L;g[H>>2]=K;g[f+(v<<5)+12>>2]=ea(0.0);H=f+(v<<5)+16|0;K=ea(g[H>>2]);F=f+(v<<5)+20|0;L=ea(g[F>>2]);D=f+(v<<5)+24|0;J=ea(g[D>>2]);E=ea(g[z>>2]);I=ea(g[A>>2]);G=ea(L+I);I=ea(J+ea(g[B>>2]));g[H>>2]=ea(K+E);g[F>>2]=G;g[D>>2]=I;g[f+(v<<5)+28>>2]=ea(0.0)}while(C>>>0>1);M=b[q>>1]|0}else M=r;I=ea(g[f>>2]);G=ea(g[f+4>>2]);E=ea(-I);I=ea(-G);G=ea(-ea(g[f+8>>2]));K=ea(g[f+16>>2]);J=ea(g[f+20>>2]);L=ea(-K);K=ea(-J);J=ea(-ea(g[f+24>>2]));g[o>>2]=E;g[o+4>>2]=I;g[o+8>>2]=G;g[o+12>>2]=ea(0.0);g[o+16>>2]=L;g[o+20>>2]=K;g[o+24>>2]=J;g[o+28>>2]=ea(0.0);R1a(n,a+(M&65535)|0,o);c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];o=k+16|0;M=n+16|0;c[o+0>>2]=c[M+0>>2];c[o+4>>2]=c[M+4>>2];c[o+8>>2]=c[M+8>>2];c[o+12>>2]=c[M+12>>2];M=b[t>>1]|0;if((M&65535)>1){o=p+16|0;n=1;do{f=k+(n<<5)|0;U1a(p,s+(n*160|0)|0,x+(n<<5)|0,l+(n<<4)|0,k+((d[a+n+64>>0]|0)<<5)|0,w+(n*96|0)|0);c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];f=k+(n<<5)+16|0;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];n=n+1|0;f=b[t>>1]|0}while(n>>>0<(f&65535)>>>0);N=f}else N=M;if(!(N<<16>>16)){i=j;return}else O=0;do{N=h+(O<<5)|0;J=ea(g[N>>2]);M=h+(O<<5)+4|0;K=ea(g[M>>2]);n=h+(O<<5)+8|0;L=ea(g[n>>2]);G=ea(g[k+(O<<5)>>2]);I=ea(g[k+(O<<5)+4>>2]);E=ea(K+I);I=ea(L+ea(g[k+(O<<5)+8>>2]));g[N>>2]=ea(J+G);g[M>>2]=E;g[n>>2]=I;g[h+(O<<5)+12>>2]=ea(0.0);n=h+(O<<5)+16|0;I=ea(g[n>>2]);M=h+(O<<5)+20|0;E=ea(g[M>>2]);N=h+(O<<5)+24|0;G=ea(g[N>>2]);J=ea(g[k+(O<<5)+16>>2]);L=ea(g[k+(O<<5)+20>>2]);K=ea(E+L);L=ea(G+ea(g[k+(O<<5)+24>>2]));g[n>>2]=ea(I+J);g[M>>2]=K;g[N>>2]=L;g[h+(O<<5)+28>>2]=ea(0.0);O=O+1|0}while(O>>>0<(e[t>>1]|0)>>>0);i=j;return}function Aza(b,f,h,j,k,l,m){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0;n=i;i=i+1440|0;o=n+1184|0;p=n+96|0;q=n+64|0;r=n+1152|0;s=n;t=n+1120|0;u=n+32|0;v=b+26|0;w=b+((e[v>>1]|0)+144)|0;x=b+(((e[b+8>>1]|0)*432|0)+(e[b+24>>1]|0))|0;y=b+(e[b+10>>1]|0)|0;a:do if((f|0)==(k|0))z=f;else{A=f;B=k;while(1){C=B;while(1){if(A>>>0>=C>>>0)break;D=d[b+C+64>>0]|0;if((A|0)==(D|0)){z=A;break a}else C=D}A=d[b+A+64>>0]|0;if((A|0)==(C|0)){z=C;break}else B=C}}while(0);E=ea(g[h>>2]);F=ea(g[h+4>>2]);G=ea(-E);E=ea(-F);F=ea(-ea(g[h+8>>2]));H=ea(g[h+16>>2]);I=ea(g[h+20>>2]);J=ea(-H);H=ea(-I);I=ea(-ea(g[h+24>>2]));K=ea(g[l>>2]);L=ea(g[l+4>>2]);M=ea(-K);K=ea(-L);L=ea(-ea(g[l+8>>2]));N=ea(g[l+16>>2]);O=ea(g[l+20>>2]);P=ea(-N);N=ea(-O);O=ea(-ea(g[l+24>>2]));if((z|0)==(f|0)){Q=I;R=H;S=J;T=F;U=E;V=G;W=0}else{l=f;X=E;E=F;F=G;G=J;J=H;H=I;f=0;while(1){I=ea(g[y+(l<<5)+16>>2]);Y=ea(g[y+(l<<5)+20>>2]);Z=ea(g[y+(l<<5)+24>>2]);_=ea(G+ea(ea(X*Z)-ea(E*Y)));$=ea(J+ea(ea(E*I)-ea(F*Z)));Z=ea(H+ea(ea(F*Y)-ea(X*I)));g[p+(l<<4)>>2]=_;g[p+(l<<4)+4>>2]=$;g[p+(l<<4)+8>>2]=Z;g[p+(l<<4)+12>>2]=ea(0.0);I=ea(g[w+(l*160|0)>>2]);Y=ea(g[w+(l*160|0)+4>>2]);aa=ea(g[w+(l*160|0)+8>>2]);ba=ea(g[w+(l*160|0)+32>>2]);ca=ea(g[w+(l*160|0)+36>>2]);da=ea(g[w+(l*160|0)+40>>2]);fa=ea(g[w+(l*160|0)+64>>2]);ga=ea(g[w+(l*160|0)+68>>2]);ha=ea(ea(I*_)+ea(ea($*ba)+ea(Z*fa)));fa=ea(ea(Y*_)+ea(ea($*ca)+ea(Z*ga)));ga=ea(ea(_*aa)+ea(ea($*da)+ea(Z*ea(g[w+(l*160|0)+72>>2]))));da=ea(g[w+(l*160|0)+16>>2]);aa=ea(g[w+(l*160|0)+20>>2]);ca=ea(g[w+(l*160|0)+24>>2]);Y=ea(g[w+(l*160|0)+48>>2]);ba=ea(g[w+(l*160|0)+52>>2]);I=ea(g[w+(l*160|0)+56>>2]);ia=ea(g[w+(l*160|0)+80>>2]);ja=ea(g[w+(l*160|0)+84>>2]);ka=ea(F-ha);ha=ea(X-fa);fa=ea(E-ga);ga=ea(G-ea(ea(_*da)+ea(ea($*Y)+ea(Z*ia))));ia=ea(J-ea(ea(_*aa)+ea(ea($*ba)+ea(Z*ja))));ja=ea(H-ea(ea(_*ca)+ea(ea($*I)+ea(Z*ea(g[w+(l*160|0)+88>>2])))));Z=ea(g[y+(l<<5)>>2]);I=ea(g[y+(l<<5)+4>>2]);$=ea(g[y+(l<<5)+8>>2]);ca=ea(ga+ea(ea(fa*I)-ea(ha*$)));ga=ea(ia+ea(ea(ka*$)-ea(fa*Z)));$=ea(ja+ea(ea(ha*Z)-ea(ka*I)));h=f+1|0;c[o+(f<<2)>>2]=l;l=d[b+l+64>>0]|0;if((l|0)==(z|0)){Q=$;R=ga;S=ca;T=fa;U=ha;V=ka;W=h;break}else{X=ha;E=fa;F=ka;G=ca;J=ga;H=$;f=h}}}if((z|0)==(k|0)){la=O;ma=N;na=P;oa=L;pa=K;qa=M;ra=W}else{f=k;H=K;K=L;L=M;M=P;P=N;N=O;k=W;while(1){O=ea(g[y+(f<<5)+16>>2]);J=ea(g[y+(f<<5)+20>>2]);G=ea(g[y+(f<<5)+24>>2]);F=ea(M+ea(ea(H*G)-ea(K*J)));E=ea(P+ea(ea(K*O)-ea(L*G)));G=ea(N+ea(ea(L*J)-ea(H*O)));g[p+(f<<4)>>2]=F;g[p+(f<<4)+4>>2]=E;g[p+(f<<4)+8>>2]=G;g[p+(f<<4)+12>>2]=ea(0.0);O=ea(g[w+(f*160|0)>>2]);J=ea(g[w+(f*160|0)+4>>2]);X=ea(g[w+(f*160|0)+8>>2]);$=ea(g[w+(f*160|0)+32>>2]);ga=ea(g[w+(f*160|0)+36>>2]);ca=ea(g[w+(f*160|0)+40>>2]);ka=ea(g[w+(f*160|0)+64>>2]);fa=ea(g[w+(f*160|0)+68>>2]);ha=ea(ea(O*F)+ea(ea(E*$)+ea(G*ka)));ka=ea(ea(J*F)+ea(ea(E*ga)+ea(G*fa)));fa=ea(ea(F*X)+ea(ea(E*ca)+ea(G*ea(g[w+(f*160|0)+72>>2]))));ca=ea(g[w+(f*160|0)+16>>2]);X=ea(g[w+(f*160|0)+20>>2]);ga=ea(g[w+(f*160|0)+24>>2]);J=ea(g[w+(f*160|0)+48>>2]);$=ea(g[w+(f*160|0)+52>>2]);O=ea(g[w+(f*160|0)+56>>2]);I=ea(g[w+(f*160|0)+80>>2]);Z=ea(g[w+(f*160|0)+84>>2]);ja=ea(L-ha);ha=ea(H-ka);ka=ea(K-fa);fa=ea(M-ea(ea(F*ca)+ea(ea(E*J)+ea(G*I))));I=ea(P-ea(ea(F*X)+ea(ea(E*$)+ea(G*Z))));Z=ea(N-ea(ea(F*ga)+ea(ea(E*O)+ea(G*ea(g[w+(f*160|0)+88>>2])))));G=ea(g[y+(f<<5)>>2]);O=ea(g[y+(f<<5)+4>>2]);E=ea(g[y+(f<<5)+8>>2]);ga=ea(fa+ea(ea(ka*O)-ea(ha*E)));fa=ea(I+ea(ea(ja*E)-ea(ka*G)));E=ea(Z+ea(ea(ha*G)-ea(ja*O)));l=k+1|0;c[o+(k<<2)>>2]=f;f=d[b+f+64>>0]|0;if((f|0)==(z|0)){la=E;ma=fa;na=ga;oa=ka;pa=ha;qa=ja;ra=l;break}else{H=ha;K=ka;L=ja;M=ga;P=fa;N=E;k=l}}}N=ea(V+qa);qa=ea(U+pa);pa=ea(T+oa);oa=ea(S+na);na=ea(R+ma);ma=ea(Q+la);if(!z){sa=ma;ta=na;ua=oa;va=pa;wa=qa;xa=N;ya=ra}else{la=qa;qa=pa;pa=N;N=oa;oa=na;na=ma;k=z;z=ra;while(1){ma=ea(g[y+(k<<5)+16>>2]);Q=ea(g[y+(k<<5)+20>>2]);R=ea(g[y+(k<<5)+24>>2]);S=ea(N+ea(ea(la*R)-ea(qa*Q)));T=ea(oa+ea(ea(qa*ma)-ea(pa*R)));R=ea(na+ea(ea(pa*Q)-ea(la*ma)));g[p+(k<<4)>>2]=S;g[p+(k<<4)+4>>2]=T;g[p+(k<<4)+8>>2]=R;g[p+(k<<4)+12>>2]=ea(0.0);ma=ea(g[w+(k*160|0)>>2]);Q=ea(g[w+(k*160|0)+4>>2]);U=ea(g[w+(k*160|0)+8>>2]);V=ea(g[w+(k*160|0)+32>>2]);P=ea(g[w+(k*160|0)+36>>2]);M=ea(g[w+(k*160|0)+40>>2]);L=ea(g[w+(k*160|0)+64>>2]);K=ea(g[w+(k*160|0)+68>>2]);H=ea(ea(ma*S)+ea(ea(T*V)+ea(R*L)));L=ea(ea(Q*S)+ea(ea(T*P)+ea(R*K)));K=ea(ea(S*U)+ea(ea(T*M)+ea(R*ea(g[w+(k*160|0)+72>>2]))));M=ea(g[w+(k*160|0)+16>>2]);U=ea(g[w+(k*160|0)+20>>2]);P=ea(g[w+(k*160|0)+24>>2]);Q=ea(g[w+(k*160|0)+48>>2]);V=ea(g[w+(k*160|0)+52>>2]);ma=ea(g[w+(k*160|0)+56>>2]);E=ea(g[w+(k*160|0)+80>>2]);fa=ea(g[w+(k*160|0)+84>>2]);ga=ea(pa-H);H=ea(la-L);L=ea(qa-K);K=ea(N-ea(ea(S*M)+ea(ea(T*Q)+ea(R*E))));E=ea(oa-ea(ea(S*U)+ea(ea(T*V)+ea(R*fa))));fa=ea(na-ea(ea(S*P)+ea(ea(T*ma)+ea(R*ea(g[w+(k*160|0)+88>>2])))));R=ea(g[y+(k<<5)>>2]);ma=ea(g[y+(k<<5)+4>>2]);T=ea(g[y+(k<<5)+8>>2]);P=ea(K+ea(ea(L*ma)-ea(H*T)));K=ea(E+ea(ea(ga*T)-ea(L*R)));T=ea(fa+ea(ea(H*R)-ea(ga*ma)));f=z+1|0;c[o+(z<<2)>>2]=k;l=a[b+k+64>>0]|0;if(!(l<<24>>24)){sa=T;ta=K;ua=P;va=L;wa=H;xa=ga;ya=f;break}else{la=H;qa=L;pa=ga;N=P;oa=K;na=T;k=l&255;z=f}}}z=b+(e[v>>1]|0)|0;na=ea(-wa);wa=ea(-va);va=ea(-ua);ua=ea(-ta);ta=ea(-sa);g[r>>2]=ea(-xa);g[r+4>>2]=na;g[r+8>>2]=wa;g[r+12>>2]=ea(0.0);g[r+16>>2]=va;g[r+20>>2]=ua;g[r+24>>2]=ta;g[r+28>>2]=ea(0.0);R1a(q,z,r);if(ya>>>0>ra>>>0){r=q+16|0;z=s+16|0;v=ya;do{v=v+-1|0;ya=c[o+(v<<2)>>2]|0;U1a(s,w+(ya*160|0)|0,y+(ya<<5)|0,p+(ya<<4)|0,q,x+(ya*96|0)|0);c[q+0>>2]=c[s+0>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];c[q+12>>2]=c[s+12>>2];c[r+0>>2]=c[z+0>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2]}while(v>>>0>ra>>>0);za=r}else za=q+16|0;c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];c[m+12>>2]=c[q+12>>2];r=m+16|0;c[r+0>>2]=c[za+0>>2];c[r+4>>2]=c[za+4>>2];c[r+8>>2]=c[za+8>>2];c[r+12>>2]=c[za+12>>2];if(ra>>>0>W>>>0){v=t+16|0;z=ra;do{z=z+-1|0;ra=c[o+(z<<2)>>2]|0;U1a(t,w+(ra*160|0)|0,y+(ra<<5)|0,p+(ra<<4)|0,m,x+(ra*96|0)|0);c[m+0>>2]=c[t+0>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];c[m+12>>2]=c[t+12>>2];c[r+0>>2]=c[v+0>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];c[r+12>>2]=c[v+12>>2]}while(z>>>0>W>>>0)};c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];q=j+16|0;c[q+0>>2]=c[za+0>>2];c[q+4>>2]=c[za+4>>2];c[q+8>>2]=c[za+8>>2];c[q+12>>2]=c[za+12>>2];if(!W){i=n;return}za=u+16|0;z=W;do{z=z+-1|0;W=c[o+(z<<2)>>2]|0;U1a(u,w+(W*160|0)|0,y+(W<<5)|0,p+(W<<4)|0,j,x+(W*96|0)|0);c[j+0>>2]=c[u+0>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];c[q+0>>2]=c[za+0>>2];c[q+4>>2]=c[za+4>>2];c[q+8>>2]=c[za+8>>2];c[q+12>>2]=c[za+12>>2]}while((z|0)!=0);i=n;return}function Bza(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=f+48|0;h=f+32|0;j=f;k=d+16|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];W1a(j,a,b,h,g);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];g=e+16|0;e=j+16|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];i=f;return}function Cza(a,b,f,h,j,k,l){a=a|0;b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0,P=Im,Q=0,R=Im,S=0,T=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0;m=i;i=i+96|0;n=m+80|0;o=m+64|0;p=m+32|0;q=m+16|0;r=m;s=a+((e[a+26>>1]|0)+144)|0;t=a+(e[a+10>>1]|0)|0;if((d[a+j+64>>0]|0|0)==(b|0)){u=ea(g[k>>2]);v=ea(g[k+4>>2]);w=ea(-u);u=ea(-v);v=ea(-ea(g[k+8>>2]));x=ea(g[k+16>>2]);y=ea(g[k+20>>2]);z=ea(g[k+24>>2]);A=ea(-x);B=ea(-y);C=ea(-z);D=t+(j<<5)+16|0;E=ea(g[D>>2]);F=t+(j<<5)+20|0;G=ea(g[F>>2]);H=t+(j<<5)+24|0;I=ea(g[H>>2]);J=ea(ea(ea(I*u)-ea(G*v))-x);x=ea(ea(ea(E*v)-ea(I*w))-y);y=ea(ea(ea(G*w)-ea(E*u))-z);K=s+(j*160|0)|0;z=ea(g[K>>2]);L=s+(j*160|0)+4|0;E=ea(g[L>>2]);M=s+(j*160|0)+8|0;G=ea(g[M>>2]);N=s+(j*160|0)+32|0;I=ea(g[N>>2]);O=s+(j*160|0)+36|0;P=ea(g[O>>2]);Q=s+(j*160|0)+40|0;R=ea(g[Q>>2]);S=s+(j*160|0)+64|0;T=ea(g[S>>2]);U=s+(j*160|0)+68|0;V=ea(g[U>>2]);W=s+(j*160|0)+72|0;X=ea(w-ea(ea(z*J)+ea(ea(x*I)+ea(y*T))));T=ea(u-ea(ea(E*J)+ea(ea(x*P)+ea(y*V))));V=ea(v-ea(ea(G*J)+ea(ea(x*R)+ea(y*ea(g[W>>2])))));Y=s+(j*160|0)+16|0;R=ea(g[Y>>2]);Z=s+(j*160|0)+20|0;G=ea(g[Z>>2]);_=s+(j*160|0)+24|0;v=ea(g[_>>2]);$=s+(j*160|0)+48|0;P=ea(g[$>>2]);aa=s+(j*160|0)+52|0;E=ea(g[aa>>2]);ba=s+(j*160|0)+56|0;u=ea(g[ba>>2]);ca=s+(j*160|0)+80|0;I=ea(g[ca>>2]);da=s+(j*160|0)+84|0;z=ea(g[da>>2]);fa=s+(j*160|0)+88|0;w=ea(A-ea(ea(J*R)+ea(ea(x*P)+ea(y*I))));I=ea(B-ea(ea(J*G)+ea(ea(x*E)+ea(y*z))));z=ea(C-ea(ea(J*v)+ea(ea(x*u)+ea(y*ea(g[fa>>2])))));ga=t+(j<<5)|0;u=ea(g[ga>>2]);ha=t+(j<<5)+4|0;v=ea(g[ha>>2]);ia=t+(j<<5)+8|0;C=ea(g[ia>>2]);E=ea(w+ea(ea(V*v)-ea(T*C)));w=ea(I+ea(ea(X*C)-ea(V*u)));C=ea(z+ea(ea(T*u)-ea(X*v)));v=ea(g[f>>2]);u=ea(g[f+4>>2]);z=ea(v-X);X=ea(u-T);T=ea(ea(g[f+8>>2])-V);V=ea(g[f+16>>2]);u=ea(g[f+20>>2]);v=ea(V-E);E=ea(u-w);w=ea(ea(g[f+24>>2])-C);g[q>>2]=z;g[q+4>>2]=X;g[q+8>>2]=T;g[q+12>>2]=ea(0.0);g[r>>2]=v;g[r+4>>2]=E;g[r+8>>2]=w;g[r+12>>2]=ea(0.0);c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];W1a(p,a,b,o,n);c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];n=h+16|0;o=p+16|0;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];w=ea(g[h+16>>2]);E=ea(g[h+20>>2]);v=ea(g[h+24>>2]);T=ea(g[h>>2]);X=ea(g[h+4>>2]);z=ea(g[h+8>>2]);C=ea(g[ga>>2]);u=ea(g[ha>>2]);V=ea(g[ia>>2]);I=ea(T-ea(ea(v*u)-ea(E*V)));T=ea(X-ea(ea(w*V)-ea(v*C)));V=ea(z-ea(ea(E*C)-ea(w*u)));u=ea(g[K>>2]);C=ea(g[L>>2]);z=ea(ea(V*ea(g[M>>2]))+ea(ea(u*I)+ea(C*T)));C=ea(g[N>>2]);u=ea(g[O>>2]);X=ea(ea(ea(I*C)+ea(T*u))+ea(V*ea(g[Q>>2])));u=ea(g[S>>2]);C=ea(g[U>>2]);G=ea(ea(ea(I*u)+ea(T*C))+ea(V*ea(g[W>>2])));C=ea(g[Y>>2]);u=ea(g[Z>>2]);B=ea(ea(ea(w*C)+ea(E*u))+ea(v*ea(g[_>>2])));u=ea(g[$>>2]);C=ea(g[aa>>2]);P=ea(ea(ea(w*u)+ea(E*C))+ea(v*ea(g[ba>>2])));C=ea(g[ca>>2]);u=ea(g[da>>2]);R=ea(z+B);B=ea(X+P);P=ea(G+ea(ea(ea(w*C)+ea(E*u))+ea(v*ea(g[fa>>2]))));u=ea(J*ea(g[s+(j*160|0)+96>>2]));C=ea(u+ea(x*ea(g[s+(j*160|0)+112>>2])));u=ea(C+ea(y*ea(g[s+(j*160|0)+128>>2])));C=ea(J*ea(g[s+(j*160|0)+100>>2]));G=ea(C+ea(x*ea(g[s+(j*160|0)+116>>2])));C=ea(G+ea(y*ea(g[s+(j*160|0)+132>>2])));G=ea(J*ea(g[s+(j*160|0)+104>>2]));J=ea(G+ea(x*ea(g[s+(j*160|0)+120>>2])));x=ea(R+u);u=ea(B+C);C=ea(P+ea(J+ea(y*ea(g[s+(j*160|0)+136>>2]))));y=ea(g[D>>2]);J=ea(g[F>>2]);P=ea(g[H>>2]);B=ea(T-ea(ea(x*P)-ea(y*C)));T=ea(V-ea(ea(u*y)-ea(x*J)));y=ea(w-x);x=ea(E-u);E=ea(v-C);g[l>>2]=ea(I-ea(ea(J*C)-ea(u*P)));g[l+4>>2]=B;g[l+8>>2]=T;g[l+12>>2]=ea(0.0);g[l+16>>2]=y;g[l+20>>2]=x;g[l+24>>2]=E;g[l+28>>2]=ea(0.0);i=m;return}else{Aza(a,b,f,h,j,k,l);i=m;return}}function Dza(a,b,c){a=a|0;b=b|0;c=c|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;f=i;h=b+(e[b+10>>1]|0)|0;j=b+8|0;if((e[j>>1]|0)>1)k=1;else{i=f;return}do{l=d[b+k+64>>0]|0;m=ea(g[c+(l<<5)>>2]);n=ea(g[c+(l<<5)+4>>2]);o=ea(g[c+(l<<5)+8>>2]);p=ea(g[c+(l<<5)+16>>2]);q=ea(g[c+(l<<5)+20>>2]);r=ea(g[c+(l<<5)+24>>2]);s=ea(g[c+(k<<5)>>2]);t=ea(g[c+(k<<5)+4>>2]);u=ea(g[c+(k<<5)+8>>2]);v=ea(g[c+(k<<5)+16>>2]);w=ea(g[c+(k<<5)+20>>2]);x=ea(g[c+(k<<5)+24>>2]);y=ea(g[h+(k<<5)+16>>2]);z=ea(g[h+(k<<5)+20>>2]);A=ea(g[h+(k<<5)+24>>2]);B=ea(g[h+(k<<5)>>2]);C=ea(g[h+(k<<5)+4>>2]);D=ea(y+B);B=ea(z+C);C=ea(A+ea(g[h+(k<<5)+8>>2]));E=ea(ea(n+ea(ea(r*D)-ea(p*C)))-ea(t+ea(ea(x*y)-ea(v*A))));t=ea(ea(o+ea(ea(p*B)-ea(q*D)))-ea(u+ea(ea(v*z)-ea(w*y))));g[a+(k<<4)>>2]=ea(ea(m+ea(ea(q*C)-ea(r*B)))-ea(s+ea(ea(w*A)-ea(x*z))));g[a+(k<<4)+4>>2]=E;g[a+(k<<4)+8>>2]=t;g[a+(k<<4)+12>>2]=ea(0.0);k=k+1|0}while(k>>>0<(e[j>>1]|0)>>>0);i=f;return}function Eza(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+1024|0;f=d;g=c[a>>2]|0;h=g+128|0;Uza(g);j=g+8|0;if(b[j>>1]|0){k=a+8|0;a=0;do{l=c[k>>2]|0;m=l+(a<<5)|0;n=h+(a<<5)|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];n=l+(a<<5)+16|0;l=h+(a<<5)+16|0;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];a=a+1|0}while(a>>>0<(e[j>>1]|0)>>>0)}Dza(f,g,h);wza(g,h,f);i=d;return}function Fza(a,b,f,h,j,k,l){a=a|0;b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=Im,Ub=0,Vb=Im,Wb=0,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=0,ac=0,bc=0,cc=Im,dc=Im,ec=Im,fc=0,gc=0,hc=0,ic=Im,jc=Im,kc=Im,lc=0,mc=0,nc=0,oc=Im,pc=Im,qc=Im,rc=0,sc=0,tc=0,uc=Im,vc=Im,wc=Im,xc=0,yc=0,zc=0,Ac=Im,Bc=Im,Cc=Im,Dc=0,Ec=0,Fc=0,Gc=Im,Hc=Im,Ic=Im,Jc=0,Kc=0,Lc=0,Mc=Im,Nc=Im,Oc=Im,Pc=0,Qc=0,Rc=0,Sc=Im,Tc=Im,Uc=Im,Vc=0;m=i;i=i+2208|0;n=m;o=m+320|0;p=m+2192|0;q=m+1680|0;r=m+16|0;s=m+1536|0;t=m+176|0;u=m+160|0;v=m+1392|0;w=m+1344|0;if(!k){i=m;return}x=j>>>0>1;if(x){y=1;do{g[o+(y<<4)>>2]=ea(g[h+(y<<2)>>2]);z=o+(y<<4)+4|0;c[z+0>>2]=c[p+0>>2];c[z+4>>2]=c[p+4>>2];c[z+8>>2]=c[p+8>>2];y=y+1|0}while((y|0)!=(j|0))}y=c[l>>2]|0;p=l+8|0;l=c[p>>2]|0;h=y+l|0;z=j*144|0;A=l+z|0;l=y+A|0;c[p>>2]=A+z;A=a+(((e[a+8>>1]|0)*432|0)+(e[a+24>>1]|0))|0;p=a+(e[a+10>>1]|0)|0;if(j){y=0;do{B=q+(y<<3)|0;c[B>>2]=d[a+y+64>>0];c[B+4>>2]=0;y=y+1|0}while((y|0)!=(j|0))}y=k+-1|0;k=u+4|0;a=u+8|0;B=u+12|0;C=t+4|0;D=t+8|0;E=t+16|0;F=t+20|0;G=t+24|0;H=t+32|0;I=t+36|0;J=t+40|0;K=t+48|0;L=t+52|0;M=t+56|0;N=t+64|0;O=t+68|0;P=t+72|0;Q=t+80|0;R=t+84|0;S=t+88|0;T=t+96|0;U=t+100|0;V=t+104|0;W=t+112|0;X=t+116|0;Y=t+120|0;Z=t+128|0;_=t+132|0;$=t+136|0;aa=r+4|0;ba=r+8|0;ca=r+12|0;da=r+16|0;fa=r+20|0;ga=r+24|0;ha=r+28|0;ia=r+32|0;ja=r+36|0;ka=r+40|0;la=r+44|0;ma=r+48|0;na=r+52|0;oa=r+56|0;pa=r+60|0;qa=r+64|0;ra=r+68|0;sa=r+72|0;ta=r+76|0;ua=r+80|0;va=r+84|0;wa=r+88|0;xa=r+92|0;ya=r+96|0;za=r+100|0;Aa=r+104|0;Ba=r+108|0;Ca=r+112|0;Da=r+116|0;Ea=r+120|0;Fa=r+124|0;Ga=r+128|0;Ha=r+132|0;Ia=r+136|0;Ja=r+140|0;Ka=v+4|0;La=v+8|0;Ma=v+16|0;Na=v+20|0;Oa=v+24|0;Pa=v+32|0;Qa=v+36|0;Ra=v+40|0;Sa=v+48|0;Ta=v+52|0;Ua=v+56|0;Va=v+64|0;Wa=v+68|0;Xa=v+72|0;Ya=v+80|0;Za=v+84|0;_a=v+88|0;$a=v+96|0;ab=v+100|0;bb=v+104|0;cb=v+112|0;db=v+116|0;eb=v+120|0;fb=v+128|0;gb=v+132|0;hb=v+136|0;ib=s+4|0;jb=s+8|0;kb=s+16|0;lb=s+20|0;mb=s+24|0;nb=s+32|0;ob=s+36|0;pb=s+40|0;qb=s+48|0;rb=s+52|0;sb=s+56|0;tb=s+64|0;ub=s+68|0;vb=s+72|0;wb=s+80|0;xb=s+84|0;yb=s+88|0;zb=s+96|0;Ab=s+100|0;Bb=s+104|0;Cb=s+112|0;Db=s+116|0;Eb=s+120|0;Fb=s+128|0;Gb=s+132|0;Hb=s+136|0;Ib=r+16|0;Jb=r+32|0;Kb=r+48|0;Lb=r+64|0;Mb=r+80|0;Nb=r+96|0;Ob=r+112|0;Pb=r+128|0;if(x)Qb=y;else{x=y;while(1){YEi(h|0,b|0,z|0)|0;if(!x)break;else x=x+-1|0}i=m;return}while(1){YEi(h|0,b|0,z|0)|0;x=j;while(1){y=x+-1|0;Rb=o+(y<<4)|0;c[n+0>>2]=c[Rb+0>>2];c[n+4>>2]=c[Rb+4>>2];c[n+8>>2]=c[Rb+8>>2];c[n+12>>2]=c[Rb+12>>2];X1a(r,h+(y*144|0)|0,A+(y*96|0)|0,f+(y*48|0)|0,n);Rb=c[q+(y<<3)>>2]|0;Sb=p+(y<<5)|0;c[n+0>>2]=c[Sb+0>>2];c[n+4>>2]=c[Sb+4>>2];c[n+8>>2]=c[Sb+8>>2];c[n+12>>2]=c[Sb+12>>2];S1a(s,n,r);Sb=h+(Rb*144|0)|0;Tb=ea(g[Sb>>2]);Ub=h+(Rb*144|0)+4|0;Vb=ea(g[Ub>>2]);Wb=h+(Rb*144|0)+8|0;Xb=ea(g[Wb>>2]);Yb=ea(g[s>>2]);Zb=ea(g[ib>>2]);_b=ea(Tb+Yb);Yb=ea(Vb+Zb);Zb=ea(Xb+ea(g[jb>>2]));$b=h+(Rb*144|0)+16|0;Xb=ea(g[$b>>2]);ac=h+(Rb*144|0)+20|0;Vb=ea(g[ac>>2]);bc=h+(Rb*144|0)+24|0;Tb=ea(g[bc>>2]);cc=ea(g[kb>>2]);dc=ea(g[lb>>2]);ec=ea(Xb+cc);cc=ea(Vb+dc);dc=ea(Tb+ea(g[mb>>2]));fc=h+(Rb*144|0)+32|0;Tb=ea(g[fc>>2]);gc=h+(Rb*144|0)+36|0;Vb=ea(g[gc>>2]);hc=h+(Rb*144|0)+40|0;Xb=ea(g[hc>>2]);ic=ea(g[nb>>2]);jc=ea(g[ob>>2]);kc=ea(Tb+ic);ic=ea(Vb+jc);jc=ea(Xb+ea(g[pb>>2]));lc=h+(Rb*144|0)+48|0;Xb=ea(g[lc>>2]);mc=h+(Rb*144|0)+52|0;Vb=ea(g[mc>>2]);nc=h+(Rb*144|0)+56|0;Tb=ea(g[nc>>2]);oc=ea(g[qb>>2]);pc=ea(g[rb>>2]);qc=ea(Xb+oc);oc=ea(Vb+pc);pc=ea(Tb+ea(g[sb>>2]));rc=h+(Rb*144|0)+64|0;Tb=ea(g[rc>>2]);sc=h+(Rb*144|0)+68|0;Vb=ea(g[sc>>2]);tc=h+(Rb*144|0)+72|0;Xb=ea(g[tc>>2]);uc=ea(g[tb>>2]);vc=ea(g[ub>>2]);wc=ea(Tb+uc);uc=ea(Vb+vc);vc=ea(Xb+ea(g[vb>>2]));xc=h+(Rb*144|0)+80|0;Xb=ea(g[xc>>2]);yc=h+(Rb*144|0)+84|0;Vb=ea(g[yc>>2]);zc=h+(Rb*144|0)+88|0;Tb=ea(g[zc>>2]);Ac=ea(g[wb>>2]);Bc=ea(g[xb>>2]);Cc=ea(Xb+Ac);Ac=ea(Vb+Bc);Bc=ea(Tb+ea(g[yb>>2]));Dc=h+(Rb*144|0)+96|0;Tb=ea(g[Dc>>2]);Ec=h+(Rb*144|0)+100|0;Vb=ea(g[Ec>>2]);Fc=h+(Rb*144|0)+104|0;Xb=ea(g[Fc>>2]);Gc=ea(g[zb>>2]);Hc=ea(g[Ab>>2]);Ic=ea(Tb+Gc);Gc=ea(Vb+Hc);Hc=ea(Xb+ea(g[Bb>>2]));Jc=h+(Rb*144|0)+112|0;Xb=ea(g[Jc>>2]);Kc=h+(Rb*144|0)+116|0;Vb=ea(g[Kc>>2]);Lc=h+(Rb*144|0)+120|0;Tb=ea(g[Lc>>2]);Mc=ea(g[Cb>>2]);Nc=ea(g[Db>>2]);Oc=ea(Xb+Mc);Mc=ea(Vb+Nc);Nc=ea(Tb+ea(g[Eb>>2]));Pc=h+(Rb*144|0)+128|0;Tb=ea(g[Pc>>2]);Qc=h+(Rb*144|0)+132|0;Vb=ea(g[Qc>>2]);Rc=h+(Rb*144|0)+136|0;Xb=ea(g[Rc>>2]);Sc=ea(g[Fb>>2]);Tc=ea(g[Gb>>2]);Uc=ea(Tb+Sc);Sc=ea(Vb+Tc);Tc=ea(Xb+ea(g[Hb>>2]));g[Sb>>2]=_b;g[Ub>>2]=Yb;g[Wb>>2]=Zb;g[h+(Rb*144|0)+12>>2]=ea(0.0);g[$b>>2]=ec;g[ac>>2]=cc;g[bc>>2]=dc;g[h+(Rb*144|0)+28>>2]=ea(0.0);g[fc>>2]=kc;g[gc>>2]=ic;g[hc>>2]=jc;g[h+(Rb*144|0)+44>>2]=ea(0.0);g[lc>>2]=qc;g[mc>>2]=oc;g[nc>>2]=pc;g[h+(Rb*144|0)+60>>2]=ea(0.0);g[rc>>2]=wc;g[sc>>2]=uc;g[tc>>2]=vc;g[h+(Rb*144|0)+76>>2]=ea(0.0);g[xc>>2]=Cc;g[yc>>2]=Ac;g[zc>>2]=Bc;g[h+(Rb*144|0)+92>>2]=ea(0.0);g[Dc>>2]=Ic;g[Ec>>2]=Gc;g[Fc>>2]=Hc;g[h+(Rb*144|0)+108>>2]=ea(0.0);g[Jc>>2]=Oc;g[Kc>>2]=Mc;g[Lc>>2]=Nc;g[h+(Rb*144|0)+124>>2]=ea(0.0);g[Pc>>2]=Uc;g[Qc>>2]=Sc;g[Rc>>2]=Tc;g[h+(Rb*144|0)+140>>2]=ea(0.0);Rb=l+(y*144|0)|0;c[Rb+0>>2]=c[r+0>>2];c[Rb+4>>2]=c[r+4>>2];c[Rb+8>>2]=c[r+8>>2];c[Rb+12>>2]=c[r+12>>2];Rb=l+(y*144|0)+16|0;c[Rb+0>>2]=c[Ib+0>>2];c[Rb+4>>2]=c[Ib+4>>2];c[Rb+8>>2]=c[Ib+8>>2];c[Rb+12>>2]=c[Ib+12>>2];Rb=l+(y*144|0)+32|0;c[Rb+0>>2]=c[Jb+0>>2];c[Rb+4>>2]=c[Jb+4>>2];c[Rb+8>>2]=c[Jb+8>>2];c[Rb+12>>2]=c[Jb+12>>2];Rb=l+(y*144|0)+48|0;c[Rb+0>>2]=c[Kb+0>>2];c[Rb+4>>2]=c[Kb+4>>2];c[Rb+8>>2]=c[Kb+8>>2];c[Rb+12>>2]=c[Kb+12>>2];Rb=l+(y*144|0)+64|0;c[Rb+0>>2]=c[Lb+0>>2];c[Rb+4>>2]=c[Lb+4>>2];c[Rb+8>>2]=c[Lb+8>>2];c[Rb+12>>2]=c[Lb+12>>2];Rb=l+(y*144|0)+80|0;c[Rb+0>>2]=c[Mb+0>>2];c[Rb+4>>2]=c[Mb+4>>2];c[Rb+8>>2]=c[Mb+8>>2];c[Rb+12>>2]=c[Mb+12>>2];Rb=l+(y*144|0)+96|0;c[Rb+0>>2]=c[Nb+0>>2];c[Rb+4>>2]=c[Nb+4>>2];c[Rb+8>>2]=c[Nb+8>>2];c[Rb+12>>2]=c[Nb+12>>2];Rb=l+(y*144|0)+112|0;c[Rb+0>>2]=c[Ob+0>>2];c[Rb+4>>2]=c[Ob+4>>2];c[Rb+8>>2]=c[Ob+8>>2];c[Rb+12>>2]=c[Ob+12>>2];Rb=l+(y*144|0)+128|0;c[Rb+0>>2]=c[Pb+0>>2];c[Rb+4>>2]=c[Pb+4>>2];c[Rb+8>>2]=c[Pb+8>>2];c[Rb+12>>2]=c[Pb+12>>2];if(y>>>0>1)x=y;else{Vc=1;break}}do{x=A+(Vc*96|0)|0;Tc=ea(g[p+(Vc<<5)>>2]);Sc=ea(g[p+(Vc<<5)+4>>2]);Uc=ea(-Sc);Sc=ea(-ea(g[p+(Vc<<5)+8>>2]));g[u>>2]=ea(-Tc);g[k>>2]=Uc;g[a>>2]=Sc;g[B>>2]=ea(0.0);y=h+((c[q+(Vc<<3)>>2]|0)*144|0)|0;c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];c[n+12>>2]=c[u+12>>2];S1a(t,n,y);Sc=ea(g[t>>2]);Uc=ea(g[C>>2]);Tc=ea(g[D>>2]);Nc=ea(g[l+(Vc*144|0)>>2]);Mc=ea(g[l+(Vc*144|0)+4>>2]);Oc=ea(Sc-Nc);Nc=ea(Uc-Mc);Mc=ea(Tc-ea(g[l+(Vc*144|0)+8>>2]));Tc=ea(g[E>>2]);Uc=ea(g[F>>2]);Sc=ea(g[G>>2]);Hc=ea(g[l+(Vc*144|0)+16>>2]);Gc=ea(g[l+(Vc*144|0)+20>>2]);Ic=ea(Tc-Hc);Hc=ea(Uc-Gc);Gc=ea(Sc-ea(g[l+(Vc*144|0)+24>>2]));Sc=ea(g[H>>2]);Uc=ea(g[I>>2]);Tc=ea(g[J>>2]);Bc=ea(g[l+(Vc*144|0)+32>>2]);Ac=ea(g[l+(Vc*144|0)+36>>2]);Cc=ea(Sc-Bc);Bc=ea(Uc-Ac);Ac=ea(Tc-ea(g[l+(Vc*144|0)+40>>2]));Tc=ea(g[K>>2]);Uc=ea(g[L>>2]);Sc=ea(g[M>>2]);vc=ea(g[l+(Vc*144|0)+48>>2]);uc=ea(g[l+(Vc*144|0)+52>>2]);wc=ea(Tc-vc);vc=ea(Uc-uc);uc=ea(Sc-ea(g[l+(Vc*144|0)+56>>2]));Sc=ea(g[N>>2]);Uc=ea(g[O>>2]);Tc=ea(g[P>>2]);pc=ea(g[l+(Vc*144|0)+64>>2]);oc=ea(g[l+(Vc*144|0)+68>>2]);qc=ea(Sc-pc);pc=ea(Uc-oc);oc=ea(Tc-ea(g[l+(Vc*144|0)+72>>2]));Tc=ea(g[Q>>2]);Uc=ea(g[R>>2]);Sc=ea(g[S>>2]);jc=ea(g[l+(Vc*144|0)+80>>2]);ic=ea(g[l+(Vc*144|0)+84>>2]);kc=ea(Tc-jc);jc=ea(Uc-ic);ic=ea(Sc-ea(g[l+(Vc*144|0)+88>>2]));Sc=ea(g[T>>2]);Uc=ea(g[U>>2]);Tc=ea(g[V>>2]);dc=ea(g[l+(Vc*144|0)+96>>2]);cc=ea(g[l+(Vc*144|0)+100>>2]);ec=ea(Sc-dc);dc=ea(Uc-cc);cc=ea(Tc-ea(g[l+(Vc*144|0)+104>>2]));Tc=ea(g[W>>2]);Uc=ea(g[X>>2]);Sc=ea(g[Y>>2]);Zb=ea(g[l+(Vc*144|0)+112>>2]);Yb=ea(g[l+(Vc*144|0)+116>>2]);_b=ea(Tc-Zb);Zb=ea(Uc-Yb);Yb=ea(Sc-ea(g[l+(Vc*144|0)+120>>2]));Sc=ea(g[Z>>2]);Uc=ea(g[_>>2]);Tc=ea(g[$>>2]);Xb=ea(g[l+(Vc*144|0)+128>>2]);Vb=ea(g[l+(Vc*144|0)+132>>2]);Tb=ea(Sc-Xb);Xb=ea(Uc-Vb);Vb=ea(Tc-ea(g[l+(Vc*144|0)+136>>2]));g[r>>2]=Oc;g[aa>>2]=Nc;g[ba>>2]=Mc;g[ca>>2]=ea(0.0);g[da>>2]=Ic;g[fa>>2]=Hc;g[ga>>2]=Gc;g[ha>>2]=ea(0.0);g[ia>>2]=Cc;g[ja>>2]=Bc;g[ka>>2]=Ac;g[la>>2]=ea(0.0);g[ma>>2]=wc;g[na>>2]=vc;g[oa>>2]=uc;g[pa>>2]=ea(0.0);g[qa>>2]=qc;g[ra>>2]=pc;g[sa>>2]=oc;g[ta>>2]=ea(0.0);g[ua>>2]=kc;g[va>>2]=jc;g[wa>>2]=ic;g[xa>>2]=ea(0.0);g[ya>>2]=ec;g[za>>2]=dc;g[Aa>>2]=cc;g[Ba>>2]=ea(0.0);g[Ca>>2]=_b;g[Da>>2]=Zb;g[Ea>>2]=Yb;g[Fa>>2]=ea(0.0);g[Ga>>2]=Tb;g[Ha>>2]=Xb;g[Ia>>2]=Vb;g[Ja>>2]=ea(0.0);y=f+(Vc*48|0)|0;Rb=o+(Vc<<4)|0;c[n+0>>2]=c[Rb+0>>2];c[n+4>>2]=c[Rb+4>>2];c[n+8>>2]=c[Rb+8>>2];c[n+12>>2]=c[Rb+12>>2];X1a(v,r,x,y,n);Rb=h+(Vc*144|0)|0;Y1a(w,Rb,r,x);x=y+0|0;y=w+0|0;Rc=x+48|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(Rc|0));Vb=ea(g[Rb>>2]);y=h+(Vc*144|0)+4|0;Xb=ea(g[y>>2]);x=h+(Vc*144|0)+8|0;Tb=ea(g[x>>2]);Yb=ea(g[v>>2]);Zb=ea(g[Ka>>2]);_b=ea(Vb+Yb);Yb=ea(Xb+Zb);Zb=ea(Tb+ea(g[La>>2]));Rc=h+(Vc*144|0)+16|0;Tb=ea(g[Rc>>2]);Qc=h+(Vc*144|0)+20|0;Xb=ea(g[Qc>>2]);Pc=h+(Vc*144|0)+24|0;Vb=ea(g[Pc>>2]);cc=ea(g[Ma>>2]);dc=ea(g[Na>>2]);ec=ea(Tb+cc);cc=ea(Xb+dc);dc=ea(Vb+ea(g[Oa>>2]));Lc=h+(Vc*144|0)+32|0;Vb=ea(g[Lc>>2]);Kc=h+(Vc*144|0)+36|0;Xb=ea(g[Kc>>2]);Jc=h+(Vc*144|0)+40|0;Tb=ea(g[Jc>>2]);ic=ea(g[Pa>>2]);jc=ea(g[Qa>>2]);kc=ea(Vb+ic);ic=ea(Xb+jc);jc=ea(Tb+ea(g[Ra>>2]));Fc=h+(Vc*144|0)+48|0;Tb=ea(g[Fc>>2]);Ec=h+(Vc*144|0)+52|0;Xb=ea(g[Ec>>2]);Dc=h+(Vc*144|0)+56|0;Vb=ea(g[Dc>>2]);oc=ea(g[Sa>>2]);pc=ea(g[Ta>>2]);qc=ea(Tb+oc);oc=ea(Xb+pc);pc=ea(Vb+ea(g[Ua>>2]));zc=h+(Vc*144|0)+64|0;Vb=ea(g[zc>>2]);yc=h+(Vc*144|0)+68|0;Xb=ea(g[yc>>2]);xc=h+(Vc*144|0)+72|0;Tb=ea(g[xc>>2]);uc=ea(g[Va>>2]);vc=ea(g[Wa>>2]);wc=ea(Vb+uc);uc=ea(Xb+vc);vc=ea(Tb+ea(g[Xa>>2]));tc=h+(Vc*144|0)+80|0;Tb=ea(g[tc>>2]);sc=h+(Vc*144|0)+84|0;Xb=ea(g[sc>>2]);rc=h+(Vc*144|0)+88|0;Vb=ea(g[rc>>2]);Ac=ea(g[Ya>>2]);Bc=ea(g[Za>>2]);Cc=ea(Tb+Ac);Ac=ea(Xb+Bc);Bc=ea(Vb+ea(g[_a>>2]));nc=h+(Vc*144|0)+96|0;Vb=ea(g[nc>>2]);mc=h+(Vc*144|0)+100|0;Xb=ea(g[mc>>2]);lc=h+(Vc*144|0)+104|0;Tb=ea(g[lc>>2]);Gc=ea(g[$a>>2]);Hc=ea(g[ab>>2]);Ic=ea(Vb+Gc);Gc=ea(Xb+Hc);Hc=ea(Tb+ea(g[bb>>2]));hc=h+(Vc*144|0)+112|0;Tb=ea(g[hc>>2]);gc=h+(Vc*144|0)+116|0;Xb=ea(g[gc>>2]);fc=h+(Vc*144|0)+120|0;Vb=ea(g[fc>>2]);Mc=ea(g[cb>>2]);Nc=ea(g[db>>2]);Oc=ea(Tb+Mc);Mc=ea(Xb+Nc);Nc=ea(Vb+ea(g[eb>>2]));bc=h+(Vc*144|0)+128|0;Vb=ea(g[bc>>2]);ac=h+(Vc*144|0)+132|0;Xb=ea(g[ac>>2]);$b=h+(Vc*144|0)+136|0;Tb=ea(g[$b>>2]);Tc=ea(g[fb>>2]);Uc=ea(g[gb>>2]);Sc=ea(Vb+Tc);Tc=ea(Xb+Uc);Uc=ea(Tb+ea(g[hb>>2]));g[Rb>>2]=_b;g[y>>2]=Yb;g[x>>2]=Zb;g[h+(Vc*144|0)+12>>2]=ea(0.0);g[Rc>>2]=ec;g[Qc>>2]=cc;g[Pc>>2]=dc;g[h+(Vc*144|0)+28>>2]=ea(0.0);g[Lc>>2]=kc;g[Kc>>2]=ic;g[Jc>>2]=jc;g[h+(Vc*144|0)+44>>2]=ea(0.0);g[Fc>>2]=qc;g[Ec>>2]=oc;g[Dc>>2]=pc;g[h+(Vc*144|0)+60>>2]=ea(0.0);g[zc>>2]=wc;g[yc>>2]=uc;g[xc>>2]=vc;g[h+(Vc*144|0)+76>>2]=ea(0.0);g[tc>>2]=Cc;g[sc>>2]=Ac;g[rc>>2]=Bc;g[h+(Vc*144|0)+92>>2]=ea(0.0);g[nc>>2]=Ic;g[mc>>2]=Gc;g[lc>>2]=Hc;g[h+(Vc*144|0)+108>>2]=ea(0.0);g[hc>>2]=Oc;g[gc>>2]=Mc;g[fc>>2]=Nc;g[h+(Vc*144|0)+124>>2]=ea(0.0);g[bc>>2]=Sc;g[ac>>2]=Tc;g[$b>>2]=Uc;g[h+(Vc*144|0)+140>>2]=ea(0.0);Vc=Vc+1|0}while((Vc|0)!=(j|0));if(!Qb)break;else Qb=Qb+-1|0}i=m;return}function Gza(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=(a*176|0)+272+(a*96|0)+((a<<2)+60&-64)|0;c[b>>2]=f;c[d>>2]=f+(a<<5)+(a*496|0);c[e>>2]=a*608;return}function Hza(f,h,j,k,l,m,n){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0;n=i;i=i+32|0;o=n;p=j&65535;q=(p<<4)+128+((p<<2)+60&524224)+(p<<6)|0;r=q+(p<<5)|0;PEi(f|0,0,q|0)|0;s=f+10|0;b[s>>1]=q;b[f+26>>1]=r;b[f+24>>1]=(p*160|0)+144+r;r=f+8|0;b[r>>1]=j;q=(j&65535)>1;if(q){t=1;do{a[f+t+64>>0]=c[h+(t<<5)+28>>2];t=t+1|0}while((t|0)!=(p|0))}t=f+32|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[o+28>>2]=0;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];t=f+48|0;u=o+16|0;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];u=f+128|0;PEi(l|0,0,p*144|0)|0;t=u+((e[r>>1]|0)*80|0)|0;if(j<<16>>16){j=0;do{r=c[h+(j<<5)+20>>2]|0;g[k+(j*28|0)>>2]=ea(g[r>>2]);g[k+(j*28|0)+4>>2]=ea(g[r+4>>2]);g[k+(j*28|0)+8>>2]=ea(g[r+8>>2]);g[k+(j*28|0)+12>>2]=ea(g[r+12>>2]);g[k+(j*28|0)+16>>2]=ea(g[r+16>>2]);g[k+(j*28|0)+20>>2]=ea(g[r+20>>2]);g[k+(j*28|0)+24>>2]=ea(g[r+24>>2]);v=ea(g[r+64>>2]);w=ea(g[r+68>>2]);x=ea(g[r+72>>2]);y=ea(g[r+80>>2]);z=ea(g[r+84>>2]);A=ea(g[r+88>>2]);g[u+(j<<5)>>2]=v;g[u+(j<<5)+4>>2]=w;g[u+(j<<5)+8>>2]=x;g[u+(j<<5)+12>>2]=ea(0.0);g[u+(j<<5)+16>>2]=y;g[u+(j<<5)+20>>2]=z;g[u+(j<<5)+24>>2]=A;g[u+(j<<5)+28>>2]=ea(0.0);Iza(l+(j*144|0)|0,r,r);g[t+(j<<2)>>2]=ea(g[r+76>>2]);if(j)Jza(m+(j*84|0)|0,k+((c[h+(j<<5)+28>>2]|0)*28|0)|0,r,c[h+(j<<5)+24>>2]|0);j=j+1|0}while((j|0)!=(p|0))}j=f+(e[s>>1]|0)|0;if(q)B=1;else{i=n;return}do{q=d[f+B+64>>0]|0;s=k+(B*28|0)+16|0;A=ea(g[s>>2]);z=ea(A-ea(g[k+(q*28|0)+16>>2]));h=k+(B*28|0)+20|0;A=ea(g[h>>2]);y=ea(A-ea(g[k+(q*28|0)+20>>2]));t=k+(B*28|0)+24|0;A=ea(g[t>>2]);x=ea(A-ea(g[k+(q*28|0)+24>>2]));g[j+(B<<5)>>2]=z;g[j+(B<<5)+4>>2]=y;g[j+(B<<5)+8>>2]=x;x=ea(g[m+(B*84|0)+44>>2]);y=ea(x-ea(g[s>>2]));x=ea(g[m+(B*84|0)+48>>2]);z=ea(x-ea(g[h>>2]));x=ea(g[m+(B*84|0)+52>>2]);A=ea(x-ea(g[t>>2]));g[j+(B<<5)+16>>2]=y;g[j+(B<<5)+20>>2]=z;g[j+(B<<5)+24>>2]=A;B=B+1|0}while((B|0)!=(p|0));i=n;return}function Iza(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im;d=ea(g[c>>2]);e=ea(g[c+4>>2]);f=ea(g[c+8>>2]);h=ea(g[c+12>>2]);i=ea(d+d);j=ea(e+e);k=ea(f+f);l=ea(e*j);m=ea(f*k);n=ea(i*e);e=ea(i*f);o=ea(i*h);p=ea(j*f);f=ea(j*h);j=ea(k*h);h=ea(ea(ea(1.0)-l)-m);k=ea(n+j);q=ea(e-f);r=ea(n-j);j=ea(ea(1.0)-ea(d*i));i=ea(j-m);m=ea(p+o);d=ea(e+f);f=ea(p-o);o=ea(j-l);l=ea(ea(1.0)/ea(g[b+124>>2]));g[a>>2]=l;g[a+20>>2]=l;g[a+40>>2]=l;l=ea(ea(1.0)/ea(g[b+112>>2]));j=ea(ea(1.0)/ea(g[b+116>>2]));p=ea(ea(1.0)/ea(g[b+120>>2]));e=ea(r*ea(0.0));n=ea(i*ea(0.0));s=ea(m*ea(0.0));t=ea(d*ea(0.0));u=ea(f*ea(0.0));v=ea(o*ea(0.0));w=ea(t+ea(e+ea(h*l)));x=ea(u+ea(n+ea(k*l)));y=ea(v+ea(s+ea(q*l)));l=ea(h*ea(0.0));z=ea(k*ea(0.0));A=ea(q*ea(0.0));B=ea(t+ea(l+ea(r*j)));t=ea(u+ea(z+ea(i*j)));u=ea(v+ea(A+ea(m*j)));j=ea(ea(l+e)+ea(d*p));e=ea(ea(z+n)+ea(f*p));n=ea(ea(A+s)+ea(o*p));p=ea(ea(ea(h*w)+ea(r*B))+ea(d*j));s=ea(ea(ea(k*x)+ea(i*t))+ea(f*e));A=ea(ea(ea(q*y)+ea(m*u))+ea(o*n));z=ea(ea(ea(ea(ea(h*x)+ea(r*t))+ea(d*e))+ea(ea(ea(k*w)+ea(i*B))+ea(f*j)))*ea(.5));l=ea(ea(ea(ea(ea(h*y)+ea(r*u))+ea(d*n))+ea(ea(ea(q*w)+ea(m*B))+ea(o*j)))*ea(.5));j=ea(ea(s+s)*ea(.5));s=ea(ea(ea(ea(ea(k*y)+ea(i*u))+ea(f*n))+ea(ea(ea(q*x)+ea(m*t))+ea(o*e)))*ea(.5));e=ea(ea(A+A)*ea(.5));g[a+96>>2]=ea(ea(p+p)*ea(.5));g[a+100>>2]=z;g[a+104>>2]=l;g[a+108>>2]=ea(0.0);g[a+112>>2]=z;g[a+116>>2]=j;g[a+120>>2]=s;g[a+124>>2]=ea(0.0);g[a+128>>2]=l;g[a+132>>2]=s;g[a+136>>2]=e;g[a+140>>2]=ea(0.0);return}function Jza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im;e=i;f=ea(ea(g[d+16>>2])*ea(2.0));h=ea(ea(g[d+20>>2])*ea(2.0));j=ea(ea(g[d+24>>2])*ea(2.0));k=ea(g[b+12>>2]);l=ea(ea(k*k)+ea(-.5));m=ea(g[b>>2]);n=ea(f*m);o=ea(g[b+4>>2]);p=ea(n+ea(h*o));n=ea(g[b+8>>2]);q=ea(p+ea(j*n));p=ea(ea(m*q)+ea(ea(f*l)+ea(k*ea(ea(j*o)-ea(h*n)))));r=ea(ea(o*q)+ea(ea(h*l)+ea(k*ea(ea(f*n)-ea(j*m)))));s=ea(ea(ea(j*l)+ea(k*ea(ea(h*m)-ea(f*o))))+ea(n*q));q=ea(ea(g[b+16>>2])+p);p=ea(ea(g[b+20>>2])+r);r=ea(ea(g[b+24>>2])+s);s=ea(g[d>>2]);f=ea(k*s);h=ea(g[d+12>>2]);l=ea(f+ea(m*h));f=ea(g[d+8>>2]);j=ea(l+ea(o*f));l=ea(g[d+4>>2]);t=ea(ea(ea(n*s)+ea(ea(o*h)+ea(k*l)))-ea(m*f));u=ea(ea(ea(m*l)+ea(ea(n*h)+ea(k*f)))-ea(o*s));v=ea(ea(ea(ea(k*h)-ea(m*s))-ea(o*l))-ea(n*f));g[a>>2]=ea(j-ea(n*l));b=a+4|0;g[b>>2]=t;w=a+8|0;g[w>>2]=u;x=a+12|0;g[x>>2]=v;y=a+16|0;g[y>>2]=q;z=a+20|0;g[z>>2]=p;A=a+24|0;g[A>>2]=r;r=ea(ea(g[d+44>>2])*ea(2.0));p=ea(ea(g[d+48>>2])*ea(2.0));q=ea(ea(g[d+52>>2])*ea(2.0));v=ea(g[c+12>>2]);u=ea(ea(v*v)+ea(-.5));t=ea(g[c>>2]);l=ea(r*t);n=ea(g[c+4>>2]);j=ea(l+ea(p*n));l=ea(g[c+8>>2]);f=ea(j+ea(q*l));j=ea(ea(t*f)+ea(ea(r*u)+ea(v*ea(ea(q*n)-ea(p*l)))));o=ea(ea(n*f)+ea(ea(p*u)+ea(v*ea(ea(r*l)-ea(q*t)))));s=ea(ea(ea(q*u)+ea(v*ea(ea(p*t)-ea(r*n))))+ea(l*f));f=ea(ea(g[c+16>>2])+j);j=ea(ea(g[c+20>>2])+o);o=ea(ea(g[c+24>>2])+s);s=ea(g[d+28>>2]);r=ea(v*s);p=ea(g[d+40>>2]);u=ea(r+ea(t*p));r=ea(g[d+36>>2]);q=ea(u+ea(n*r));u=ea(g[d+32>>2]);m=ea(q-ea(l*u));q=ea(ea(ea(l*s)+ea(ea(n*p)+ea(v*u)))-ea(t*r));h=ea(ea(ea(t*u)+ea(ea(l*p)+ea(v*r)))-ea(n*s));k=ea(ea(ea(ea(v*p)-ea(t*s))-ea(n*u))-ea(l*r));d=a+28|0;g[d>>2]=m;c=a+32|0;g[c>>2]=q;B=a+36|0;g[B>>2]=h;C=a+40|0;g[C>>2]=k;g[a+44>>2]=f;g[a+48>>2]=j;g[a+52>>2]=o;r=ea(-ea(g[a>>2]));l=ea(-ea(g[b>>2]));u=ea(-ea(g[w>>2]));n=ea(g[x>>2]);s=ea(f-ea(g[y>>2]));f=ea(j-ea(g[z>>2]));j=ea(s*ea(2.0));s=ea(f*ea(2.0));f=ea(ea(o-ea(g[A>>2]))*ea(2.0));o=ea(ea(n*n)+ea(-.5));t=ea(ea(ea(j*r)+ea(s*l))+ea(f*u));p=ea(ea(t*r)+ea(ea(o*j)+ea(n*ea(ea(f*l)-ea(s*u)))));v=ea(ea(t*l)+ea(ea(o*s)+ea(n*ea(ea(j*u)-ea(f*r)))));D=ea(ea(ea(o*f)+ea(n*ea(ea(s*r)-ea(j*l))))+ea(t*u));t=ea(ea(ea(ea(n*m)+ea(k*r))+ea(h*l))-ea(q*u));j=ea(ea(ea(m*u)+ea(ea(k*l)+ea(n*q)))-ea(h*r));s=ea(ea(ea(q*r)+ea(ea(k*u)+ea(n*h)))-ea(m*l));f=ea(ea(ea(ea(n*k)-ea(m*r))-ea(q*l))-ea(h*u));A=a+56|0;g[A>>2]=t;z=a+60|0;g[z>>2]=j;y=a+64|0;g[y>>2]=s;x=a+68|0;g[x>>2]=f;g[a+72>>2]=p;g[a+76>>2]=v;g[a+80>>2]=D;if(!(f<ea(0.0))){i=e;return}D=ea(-j);j=ea(-s);s=ea(-f);g[A>>2]=ea(-t);g[z>>2]=D;g[y>>2]=j;g[x>>2]=s;s=ea(-ea(g[d>>2]));j=ea(-ea(g[c>>2]));D=ea(-ea(g[B>>2]));t=ea(-k);g[d>>2]=s;g[c>>2]=j;g[B>>2]=D;g[C>>2]=t;i=e;return}function Kza(a,d,f,h,j,k,l){a=a|0;d=ea(d);f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=0,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0;m=i;i=i+3696|0;n=m+1088|0;o=m+3136|0;p=m+3392|0;q=m+64|0;r=m+3684|0;s=m+3672|0;t=m+3660|0;u=m+3648|0;v=m;w=m+32|0;x=c[a+4>>2]|0;y=b[a+36>>1]|0;z=c[a>>2]|0;A=c[a+12>>2]|0;B=c[a+28>>2]|0;C=e[a+38>>1]|0;D=y&65535;E=B+(D*144|0)|0;F=D*240|0;G=k+8|0;H=c[G>>2]|0;I=k;J=c[I>>2]|0;K=c[I+4>>2]|0;I=e[268352]|e[268353]<<16;if((H|0)==0|(I&16711680|0)==0)Hza(z,x,y,A,B,E,e[a+32>>1]|0);else{Dn[c[(c[H>>2]|0)+8>>2]&511](H,I&65535,J,K);Hza(z,x,y,A,B,E,e[a+32>>1]|0);Dn[c[(c[H>>2]|0)+12>>2]&511](H,I&65535,J,K)}L=ea(ea(1.0)/d);K=z+128|0;J=c[G>>2]|0;I=k;H=c[I>>2]|0;M=c[I+4>>2]|0;I=e[268356]|e[268357]<<16;N=(J|0)==0|(I&16711680|0)==0;if(!N)Dn[c[(c[J>>2]|0)+8>>2]&511](J,I&65535,H,M);O=z+24|0;PEi(z+(e[O>>1]|0)|0,0,D*400|0)|0;Lza(z,B,A,E,L);uza(z);Dza(n,z,K);P=z+(e[O>>1]|0)|0;O=(y&65535)>1;if(O){Q=1;do{R=n+(Q<<4)|0;L=ea(g[R>>2]);S=n+(Q<<4)+4|0;T=ea(g[S>>2]);U=n+(Q<<4)+8|0;V=ea(g[U>>2]);W=ea(g[P+(Q*400|0)+384>>2]);X=ea(g[P+(Q*400|0)+388>>2]);Y=ea(T+X);X=ea(V+ea(g[P+(Q*400|0)+392>>2]));g[R>>2]=ea(L+W);g[S>>2]=Y;g[U>>2]=X;g[n+(Q<<4)+12>>2]=ea(0.0);Q=Q+1|0}while((Q|0)!=(D|0))}wza(z,K,n);if(!N)Dn[c[(c[J>>2]|0)+12>>2]&511](J,I&65535,H,M);M=c[G>>2]|0;H=k;I=c[H>>2]|0;J=c[H+4>>2]|0;H=e[268360]|e[268361]<<16;if((M|0)==0|(H&16711680|0)==0){PEi(z+(e[z+26>>1]|0)|0,0,(D*160|0)+144|0)|0;Mza(z,x)}else{Dn[c[(c[M>>2]|0)+8>>2]&511](M,H&65535,I,J);PEi(z+(e[z+26>>1]|0)|0,0,(D*160|0)+144|0)|0;Mza(z,x);Dn[c[(c[M>>2]|0)+12>>2]&511](M,H&65535,I,J)}J=c[G>>2]|0;I=k;H=c[I>>2]|0;M=c[I+4>>2]|0;I=e[268364]|e[268365]<<16;N=(J|0)==0|(I&16711680|0)==0;if(!N)Dn[c[(c[J>>2]|0)+8>>2]&511](J,I&65535,H,M);Q=a+24|0;P=c[Q>>2]|0;if((c[P+4>>2]|0)<0)Z=P;else{PEi(c[a+16>>2]|0,0,D*48|0)|0;Z=c[Q>>2]|0}if((c[Z>>2]|0)>=0)PEi(c[a+20>>2]|0,0,D*48|0)|0;if(O){O=1;do{Z=c[x+(O<<5)+24>>2]|0;X=ea(ea(ea(g[Z+88>>2])*d)+ea(1.0));Y=ea(X+ea(ea(ea(g[Z+84>>2])*d)*d));g[o+(O<<2)>>2]=ea(ea(ea(1.0)/ea(g[Z+100>>2]))*Y);g[p+(O<<2)>>2]=ea(ea(ea(1.0)/ea(g[Z+104>>2]))*Y);O=O+1|0}while((O|0)!=(D|0))}O=c[G>>2]|0;Z=k;P=c[Z>>2]|0;U=c[Z+4>>2]|0;Z=e[268368]|e[268369]<<16;S=(O|0)==0|(Z&16711680|0)==0;if(!S)Dn[c[(c[O>>2]|0)+8>>2]&511](O,Z&65535,P,U);R=a+20|0;_=c[R>>2]|0;$=c[c[Q>>2]>>2]&65535;c[r>>2]=B;c[r+4>>2]=C;c[r+8>>2]=F;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];Fza(z,B,_,o,D,$,n);$=a+16|0;_=c[$>>2]|0;r=c[(c[Q>>2]|0)+4>>2]&65535;c[s>>2]=B;c[s+4>>2]=C;c[s+8>>2]=F;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];Fza(z,B,_,p,D,r,n);if(!S)Dn[c[(c[O>>2]|0)+12>>2]&511](O,Z&65535,P,U);U=c[G>>2]|0;P=k;Z=c[P>>2]|0;O=c[P+4>>2]|0;P=e[268372]|e[268373]<<16;if((U|0)==0|(P&16711680|0)==0){S=c[R>>2]|0;c[t>>2]=B;c[t+4>>2]=C;c[t+8>>2]=F;c[n+0>>2]=c[t+0>>2];c[n+4>>2]=c[t+4>>2];c[n+8>>2]=c[t+8>>2];xza(z,B,o,S,n)}else{Dn[c[(c[U>>2]|0)+8>>2]&511](U,P&65535,Z,O);S=c[R>>2]|0;c[t>>2]=B;c[t+4>>2]=C;c[t+8>>2]=F;c[n+0>>2]=c[t+0>>2];c[n+4>>2]=c[t+4>>2];c[n+8>>2]=c[t+8>>2];xza(z,B,o,S,n);Dn[c[(c[U>>2]|0)+12>>2]&511](U,P&65535,Z,O)}O=c[G>>2]|0;Z=k;P=c[Z>>2]|0;U=c[Z+4>>2]|0;Z=e[268376]|e[268377]<<16;if((O|0)==0|(Z&16711680|0)==0)Nza(z,q,x,A,E,c[R>>2]|0,d);else{Dn[c[(c[O>>2]|0)+8>>2]&511](O,Z&65535,P,U);Nza(z,q,x,A,E,c[R>>2]|0,d);Dn[c[(c[O>>2]|0)+12>>2]&511](O,Z&65535,P,U)}U=c[G>>2]|0;P=k;Z=c[P>>2]|0;O=c[P+4>>2]|0;P=e[268380]|e[268381]<<16;if((U|0)==0|(P&16711680|0)==0)yza(z,q);else{Dn[c[(c[U>>2]|0)+8>>2]&511](U,P&65535,Z,O);yza(z,q);Dn[c[(c[U>>2]|0)+12>>2]&511](U,P&65535,Z,O)}O=c[G>>2]|0;Z=k;P=c[Z>>2]|0;U=c[Z+4>>2]|0;Z=e[268372]|e[268373]<<16;if((O|0)==0|(Z&16711680|0)==0){q=c[$>>2]|0;c[u>>2]=B;c[u+4>>2]=C;c[u+8>>2]=F;c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];xza(z,B,p,q,n)}else{Dn[c[(c[O>>2]|0)+8>>2]&511](O,Z&65535,P,U);q=c[$>>2]|0;c[u>>2]=B;c[u+4>>2]=C;c[u+8>>2]=F;c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];xza(z,B,p,q,n);Dn[c[(c[O>>2]|0)+12>>2]&511](O,Z&65535,P,U)}if(!N)Dn[c[(c[J>>2]|0)+12>>2]&511](J,I&65535,H,M);M=c[G>>2]|0;H=k;I=c[H>>2]|0;J=c[H+4>>2]|0;H=e[268384]|e[268385]<<16;N=(M|0)==0|(H&16711680|0)==0;if(!N)Dn[c[(c[M>>2]|0)+8>>2]&511](M,H&65535,I,J);if(y<<16>>16){y=v+4|0;U=v+8|0;P=v+12|0;Z=v+16|0;O=v+20|0;q=v+24|0;p=v+28|0;u=w+4|0;F=w+8|0;C=w+16|0;$=w+20|0;R=w+24|0;A=0;do{S=c[x+(A<<5)+16>>2]|0;Y=ea(g[S>>2]);X=ea(g[S+4>>2]);W=ea(g[S+8>>2]);L=ea(g[S+16>>2]);V=ea(g[S+20>>2]);T=ea(g[S+24>>2]);g[v>>2]=Y;g[y>>2]=X;g[U>>2]=W;g[P>>2]=ea(0.0);g[Z>>2]=L;g[O>>2]=V;g[q>>2]=T;g[p>>2]=ea(0.0);R1a(w,B+(A*144|0)|0,v);T=ea(g[w>>2]);V=ea(g[u>>2]);L=ea(g[F>>2]);W=ea(g[C>>2]);X=ea(g[$>>2]);Y=ea(-ea(V*d));V=ea(-ea(L*d));L=ea(-ea(W*d));W=ea(-ea(X*d));X=ea(-ea(ea(g[R>>2])*d));g[n+(A<<5)>>2]=ea(-ea(T*d));g[n+(A<<5)+4>>2]=Y;g[n+(A<<5)+8>>2]=V;g[n+(A<<5)+12>>2]=ea(0.0);g[n+(A<<5)+16>>2]=L;g[n+(A<<5)+20>>2]=W;g[n+(A<<5)+24>>2]=X;g[n+(A<<5)+28>>2]=ea(0.0);A=A+1|0}while((A|0)!=(D|0))}zza(z,n,K);if(!N)Dn[c[(c[M>>2]|0)+12>>2]&511](M,H&65535,I,J);YEi(c[a+8>>2]|0,K|0,D<<5|0)|0;D=z+16|0;c[D>>2]=0;c[D+4>>2]=0;b[z+12>>1]=0;b[z+14>>1]=0;c[z+28>>2]=0;D=c[G>>2]|0;G=k;k=c[G>>2]|0;K=c[G+4>>2]|0;G=e[268388]|e[268389]<<16;J=(D|0)==0|(G&16711680|0)==0;if(!J)Dn[c[(c[D>>2]|0)+8>>2]&511](D,G&65535,k,K);I=Oza(z,e[a+34>>1]|0,f,h,x,E,d,j,l)|0;if(J){i=m;return I|0}Dn[c[(c[D>>2]|0)+12>>2]&511](D,G&65535,k,K);i=m;return I|0}function Lza(a,f,h,j,k){a=a|0;f=f|0;h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;l=i;i=i+48|0;m=l;n=b[a+8>>1]|0;o=e[a+24>>1]|0;p=a+o|0;c[p+0>>2]=c[f+0>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2];c[p+12>>2]=c[f+12>>2];q=a+(o+16)|0;r=f+16|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=a+(o+32)|0;q=f+32|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=a+(o+48)|0;r=f+48|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=a+(o+64)|0;q=f+64|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=a+(o+80)|0;r=f+80|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=a+(o+96)|0;q=f+96|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=a+(o+112)|0;r=f+112|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=a+(o+128)|0;o=f+128|0;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);g[m+16>>2]=ea(1.0);g[m+20>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m+28>>2]=ea(0.0);g[m+32>>2]=ea(1.0);if((n&65535)<=1){i=l;return}o=n&65535;n=1;do{r=p+(n*400|0)|0;q=f+(n*144|0)|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=p+(n*400|0)+16|0;r=f+(n*144|0)+16|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=p+(n*400|0)+32|0;q=f+(n*144|0)+32|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=p+(n*400|0)+48|0;r=f+(n*144|0)+48|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=p+(n*400|0)+64|0;q=f+(n*144|0)+64|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=p+(n*400|0)+80|0;r=f+(n*144|0)+80|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=p+(n*400|0)+96|0;q=f+(n*144|0)+96|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=p+(n*400|0)+112|0;r=f+(n*144|0)+112|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=p+(n*400|0)+128|0;q=f+(n*144|0)+128|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=d[a+n+64>>0]|0;s=ea(g[j+(n*84|0)+44>>2]);t=ea(s-ea(g[h+(q*28|0)+16>>2]));u=ea(g[j+(n*84|0)+48>>2]);v=ea(u-ea(g[h+(q*28|0)+20>>2]));w=ea(g[j+(n*84|0)+52>>2]);x=ea(w-ea(g[h+(q*28|0)+24>>2]));y=ea(s-ea(g[h+(n*28|0)+16>>2]));z=ea(u-ea(g[h+(n*28|0)+20>>2]));A=ea(w-ea(g[h+(n*28|0)+24>>2]));B=ea(g[j+(n*84|0)+16>>2]);C=ea(ea(g[j+(n*84|0)+20>>2])-u);u=ea(ea(g[j+(n*84|0)+24>>2])-w);w=ea(C*ea(.990000009));q=0;do{C=ea(g[m+(q*12|0)>>2]);D=ea(g[m+(q*12|0)+4>>2]);E=ea(g[m+(q*12|0)+8>>2]);F=ea(ea(v*E)-ea(x*D));G=ea(ea(x*C)-ea(t*E));H=ea(ea(t*D)-ea(v*C));g[p+(n*400|0)+(q<<5)+144>>2]=C;g[p+(n*400|0)+(q<<5)+148>>2]=D;g[p+(n*400|0)+(q<<5)+152>>2]=E;g[p+(n*400|0)+(q<<5)+156>>2]=ea(0.0);g[p+(n*400|0)+(q<<5)+160>>2]=F;g[p+(n*400|0)+(q<<5)+164>>2]=G;g[p+(n*400|0)+(q<<5)+168>>2]=H;g[p+(n*400|0)+(q<<5)+172>>2]=ea(0.0);H=ea(-D);G=ea(-E);F=ea(-ea(ea(z*E)-ea(A*D)));I=ea(-ea(ea(A*C)-ea(y*E)));E=ea(-ea(ea(y*D)-ea(z*C)));g[p+(n*400|0)+(q<<5)+240>>2]=ea(-C);g[p+(n*400|0)+(q<<5)+244>>2]=H;g[p+(n*400|0)+(q<<5)+248>>2]=G;g[p+(n*400|0)+(q<<5)+252>>2]=ea(0.0);g[p+(n*400|0)+(q<<5)+256>>2]=F;g[p+(n*400|0)+(q<<5)+260>>2]=I;g[p+(n*400|0)+(q<<5)+264>>2]=E;g[p+(n*400|0)+(q<<5)+268>>2]=ea(0.0);q=q+1|0}while((q|0)!=3);z=ea(w*k);y=ea(ea(u*ea(.990000009))*k);g[p+(n*400|0)+384>>2]=ea(ea(ea(B-s)*ea(.990000009))*k);g[p+(n*400|0)+388>>2]=z;g[p+(n*400|0)+392>>2]=y;g[p+(n*400|0)+396>>2]=ea(0.0);n=n+1|0}while((n|0)!=(o|0));i=l;return}function Mza(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;f=i;h=b[a+8>>1]|0;j=h&65535;k=e[a+26>>1]|0;l=a+(k+144)|0;m=a+((e[a+24>>1]|0)+(j*432|0))|0;n=a+(e[a+10>>1]|0)|0;o=d;p=c[o+4>>2]|0;q=a+(k+288)|0;c[q>>2]=c[o>>2];c[q+4>>2]=p;p=a+(k+296)|0;c[p>>2]=1;c[p+4>>2]=0;if((h&65535)>1)r=1;else{i=f;return}do{h=d+(r<<5)|0;p=c[h+4>>2]|0;k=l+(r*160|0)+144|0;c[k>>2]=c[h>>2];c[k+4>>2]=p;p=d+(r<<5)+8|0;k=c[p+4>>2]|0;h=l+(r*160|0)+152|0;c[h>>2]=c[p>>2];c[h+4>>2]=k;s=ea(g[n+(r<<5)+16>>2]);t=ea(g[n+(r<<5)+20>>2]);u=ea(g[n+(r<<5)+24>>2]);v=ea(t*ea(0.0));w=ea(u*ea(0.0));x=ea(s*ea(0.0));y=ea(ea(u-x)+ea(0.0));z=ea(ea(x-t)+ea(0.0));g[m+(r*96|0)>>2]=ea(ea(v-w)+ea(0.0));g[m+(r*96|0)+4>>2]=y;g[m+(r*96|0)+8>>2]=z;g[m+(r*96|0)+12>>2]=ea(0.0);g[m+(r*96|0)+16>>2]=ea(1.0);g[m+(r*96|0)+20>>2]=ea(0.0);g[m+(r*96|0)+24>>2]=ea(0.0);g[m+(r*96|0)+28>>2]=ea(0.0);z=ea(ea(w-x)+ea(0.0));y=ea(ea(s-v)+ea(0.0));g[m+(r*96|0)+32>>2]=ea(ea(v-u)+ea(0.0));g[m+(r*96|0)+36>>2]=z;g[m+(r*96|0)+40>>2]=y;g[m+(r*96|0)+44>>2]=ea(0.0);g[m+(r*96|0)+48>>2]=ea(0.0);g[m+(r*96|0)+52>>2]=ea(1.0);g[m+(r*96|0)+56>>2]=ea(0.0);g[m+(r*96|0)+60>>2]=ea(0.0);y=ea(ea(w-s)+ea(0.0));s=ea(ea(x-v)+ea(0.0));g[m+(r*96|0)+64>>2]=ea(ea(t-w)+ea(0.0));g[m+(r*96|0)+68>>2]=y;g[m+(r*96|0)+72>>2]=s;g[m+(r*96|0)+76>>2]=ea(0.0);g[m+(r*96|0)+80>>2]=ea(0.0);g[m+(r*96|0)+84>>2]=ea(0.0);g[m+(r*96|0)+88>>2]=ea(1.0);g[m+(r*96|0)+92>>2]=ea(0.0);r=r+1|0}while((r|0)!=(j|0));i=f;return}function Nza(a,d,e,f,h,j,k){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0.0,F=Im,G=Im,H=Im,I=0.0,J=Im,K=Im,L=Im,M=Im;f=i;l=b[a+8>>1]|0;m=a+128|0;if((l&65535)<=1){i=f;return}a=l&65535;l=1;do{n=c[e+(l<<5)+28>>2]|0;o=c[e+(l<<5)+24>>2]|0;p=ea(g[m+(l<<5)+24>>2]);q=ea(g[m+(l<<5)+20>>2]);r=ea(g[m+(l<<5)+16>>2]);s=ea(g[m+(n<<5)+24>>2]);t=ea(g[m+(n<<5)+20>>2]);u=ea(r-ea(g[m+(n<<5)+16>>2]));r=ea(q-t);t=ea(p-s);s=ea(-ea(g[h+(l*84|0)+56>>2]));p=ea(-ea(g[h+(l*84|0)+60>>2]));q=ea(-ea(g[h+(l*84|0)+64>>2]));v=ea(g[h+(l*84|0)+68>>2]);w=ea(g[o+68>>2]);x=ea(w*s);y=ea(g[o+56>>2]);z=ea(x+ea(v*y));x=ea(g[o+60>>2]);A=ea(z+ea(x*q));z=ea(g[o+64>>2]);B=ea(A-ea(z*p));A=ea(ea(ea(ea(w*p)+ea(v*x))+ea(z*s))-ea(y*q));C=ea(ea(ea(y*p)+ea(ea(w*q)+ea(v*z)))-ea(x*s));D=ea(ea(ea(ea(v*w)-ea(y*s))-ea(x*p))-ea(z*q));q=ea(ea(ea(B*B)+ea(A*A))+ea(C*C));z=ea(T(ea(q)));E=+z;if(E<1.0e-12){F=ea(0.0);G=ea(0.0);H=ea(0.0)}else{if(D<ea(0.0))I=+$(+(+ea(-z)),+(+ea(-D)));else I=+$(+E,+(+D));D=ea(I);if(q>ea(0.0)){q=ea(ea(1.0)/z);J=ea(ea(B*q)*ea(2.0));K=ea(ea(A*q)*ea(2.0));L=ea(ea(C*q)*ea(2.0))}else{J=ea(0.0);K=ea(0.0);L=ea(0.0)}F=ea(ea(D*J)*ea(2.0));G=ea(ea(D*K)*ea(2.0));H=ea(ea(D*L)*ea(2.0))}D=ea(g[h+(l*84|0)+12>>2]);q=ea(ea(D*D)+ea(-.5));C=ea(g[h+(l*84|0)>>2]);A=ea(F*C);B=ea(g[h+(l*84|0)+4>>2]);z=ea(A+ea(G*B));A=ea(g[h+(l*84|0)+8>>2]);p=ea(z+ea(H*A));z=ea(ea(C*p)+ea(ea(F*q)+ea(D*ea(ea(H*B)-ea(G*A)))));x=ea(ea(B*p)+ea(ea(G*q)+ea(D*ea(ea(F*A)-ea(H*C)))));s=ea(ea(ea(H*q)+ea(D*ea(ea(G*C)-ea(F*B))))+ea(A*p));p=ea(ea(g[o+72>>2])*ea(2.0));y=ea(ea(g[o+76>>2])*ea(2.0));w=ea(ea(g[o+80>>2])*ea(2.0));v=ea(ea(ea(C*p)+ea(B*y))+ea(A*w));M=ea(ea(ea(C*v)+ea(ea(q*p)+ea(D*ea(ea(B*w)-ea(A*y)))))-u);u=ea(ea(ea(B*v)+ea(ea(q*y)+ea(D*ea(ea(A*p)-ea(C*w)))))-r);r=ea(ea(ea(ea(q*w)+ea(D*ea(ea(C*y)-ea(B*p))))+ea(A*v))-t);t=ea(g[o+84>>2]);v=ea(t*z);z=ea(t*x);x=ea(t*s);s=ea(g[o+88>>2]);t=ea(ea(v+ea(s*M))*k);M=ea(ea(z+ea(s*u))*k);u=ea(ea(x+ea(s*r))*k);r=ea(ea(1.0)/ea(g[o+100>>2]));s=ea(r*t);t=ea(r*M);M=ea(r*u);u=ea(ea(g[j+(l*48|0)>>2])*s);r=ea(u+ea(ea(g[j+(l*48|0)+16>>2])*t));u=ea(ea(ea(g[j+(l*48|0)+32>>2])*M)+r);r=ea(ea(g[j+(l*48|0)+4>>2])*s);x=ea(r+ea(ea(g[j+(l*48|0)+20>>2])*t));r=ea(ea(M*ea(g[j+(l*48|0)+36>>2]))+x);x=ea(s*ea(g[j+(l*48|0)+8>>2]));s=ea(x+ea(t*ea(g[j+(l*48|0)+24>>2])));t=ea(s+ea(M*ea(g[j+(l*48|0)+40>>2])));g[d+(l<<4)>>2]=u;g[d+(l<<4)+4>>2]=r;g[d+(l<<4)+8>>2]=t;g[d+(l<<4)+12>>2]=ea(0.0);l=l+1|0}while((l|0)!=(a|0));i=f;return}function Oza(d,f,h,j,k,l,m,n,o){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=0;p=i;i=i+160|0;q=p;r=p+32|0;s=p+96|0;t=p+112|0;u=p+68|0;v=p+64|0;w=p+80|0;x=p+124|0;y=p+136|0;c[n>>2]=0;z=b[d+8>>1]|0;A=ea(ea(1.0)/m);if((z&65535)<=1){B=0;i=p;return B|0}C=z&65535;D=s+4|0;E=s+8|0;F=s+12|0;G=t+4|0;I=t+8|0;J=w+4|0;K=w+8|0;L=f&65535;f=u+4|0;M=u+8|0;N=x+4|0;O=x+8|0;P=q+16|0;Q=q+20|0;R=q+24|0;S=q+28|0;U=r+4|0;V=r+8|0;W=r+12|0;X=r+16|0;Y=r+20|0;Z=r+24|0;_=r+28|0;$=ea(m*m);aa=y+4|0;ba=y+8|0;ca=h+4|0;da=h+8|0;fa=0;ga=1;while(1){ha=c[k+(ga<<5)+24>>2]|0;ia=ga;ga=ga+1|0;if(ga>>>0<C>>>0){ja=c[k+(ga<<5)+24>>2]|0;ka=ja;la=VEi(ka|0,0,6)|0;ma=H;na=_Ei(ka|0,0,171,0)|0;ka=VEi(na|0,H|0,6)|0;na=H;oa=ZEi(1,0,la|0,ma|0)|0;ma=_Ei(oa|0,H|0,ka|0,na|0)|0;na=ma;ma=H;ka=ja;while(1){na=_Ei(na|0,ma|0,-1,-1)|0;ma=H;if((na|0)==0&(ma|0)==0)break;else ka=ka+64|0}ka=l+(ga*84|0)|0;ma=ka;na=VEi(ma|0,0,6)|0;ja=H;oa=_Ei(ma|0,0,83,0)|0;ma=VEi(oa|0,H|0,6)|0;oa=H;la=ZEi(1,0,na|0,ja|0)|0;ja=_Ei(la|0,H|0,ma|0,oa|0)|0;oa=ja;ja=H;ma=ka;while(1){oa=_Ei(oa|0,ja|0,-1,-1)|0;ja=H;if((oa|0)==0&(ja|0)==0)break;else ma=ma+64|0}}ma=ha+144|0;if((a[ma>>0]|0)==0?(a[ha+120>>0]|0)==0:0)pa=fa;else{qa=ea(g[l+(ia*84|0)+56>>2]);ja=qa!=ea(0.0);ra=ea(g[l+(ia*84|0)+68>>2]);if(ja){sa=ea(ea(1.0)/ea(T(ea(ea(ea(qa*qa)+ea(0.0))+ea(ra*ra)))));ta=ea(qa*sa);ua=ea(sa*ea(0.0));va=ea(ra*sa)}else{ta=ea(0.0);ua=ea(0.0);va=ea(1.0)}sa=ea(-ta);wa=ea(-ua);xa=ea(ea(ra*sa)+ea(va*qa));ya=ea(g[l+(ia*84|0)+60>>2]);za=ea(ya*wa);Aa=ea(xa+za);xa=ea(g[l+(ia*84|0)+64>>2]);Ba=ea(xa*wa);Ca=ea(ra*wa);Da=ea(qa*wa);wa=ea(ea(ea(Ca+ea(va*ya))+ea(xa*sa))-Da);Ea=ea(ea(Da+ea(Ca+ea(va*xa)))-ea(ya*sa));ya=ea(ea(ea(ea(va*ra)-ea(qa*sa))-za)-Ba);g[s>>2]=ea(Aa-Ba);g[D>>2]=wa;g[E>>2]=Ea;g[F>>2]=ya;ya=ea(g[ha+148>>2]);Ea=ea(g[ha+152>>2]);wa=ea(g[ha+156>>2]);g[t>>2]=ya;g[G>>2]=Ea;g[I>>2]=wa;g[v>>2]=ea(0.0);if((a[ha+120>>0]|0)!=0?SUa(t,s,u,v)|0:0)if(ea(g[ha+124>>2])>ea(0.0)){Fa=1;Ga=1}else{Fa=1;Ga=ea(g[ha+128>>2])>ea(0.0)}else{Fa=0;Ga=0}wa=ea(g[l+(ia*84|0)+40>>2]);Ea=ea(ea(wa*wa)+ea(-.5));ya=ea(g[l+(ia*84|0)+28>>2]);Ba=ea(ya*ea(2.0));Aa=ea(g[l+(ia*84|0)+32>>2]);za=ea(Aa*ea(0.0));sa=ea(Ba+za);Ba=ea(g[l+(ia*84|0)+36>>2]);qa=ea(Ba*ea(0.0));ra=ea(sa+qa);sa=ea(Ea*ea(0.0));xa=ea(ya*ea(0.0));Ca=ea(ea(Aa*ra)+ea(sa+ea(wa*ea(ea(Ba*ea(2.0))-xa))));Da=ea(ea(sa+ea(wa*ea(xa-ea(Aa*ea(2.0)))))+ea(Ba*ra));g[w>>2]=ea(ea(ya*ra)+ea(ea(Ea*ea(2.0))+ea(wa*ea(za-qa))));g[J>>2]=Ca;g[K>>2]=Da;Da=ea(ta/ea(va+ea(1.0)));if(!(a[ma>>0]|0)){Ha=0;Ia=0}else{Ca=ea(g[ha+164>>2]);qa=ea(g[ha+168>>2]);ma=Da<ea(ea(Ca+qa)/ea(ea(1.0)-ea(Ca*qa)));Ca=ea(g[ha+160>>2]);Ha=Da>ea(ea(Ca-qa)/ea(ea(Ca*qa)+ea(1.0)));Ia=ma}ma=(Ga&1)+(Fa&1)+(Ia&1)+(Ha&1)|0;ja=ma&255;if(!(ja<<24>>24))pa=fa;else{oa=fa+1|0;c[j+(fa<<5)>>2]=d;ka=k+(ia<<5)+28|0;b[j+(fa<<5)+8>>1]=c[ka>>2];b[j+(fa<<5)+10>>1]=L;c[j+(fa<<5)+4>>2]=d;b[j+(fa<<5)+12>>1]=ia;b[j+(fa<<5)+14>>1]=L;la=ma&255;ma=la*176|0;na=j+(fa<<5)+26|0;b[na>>1]=(ma+48|0)>>>4;Ja=ma+79&131056;do if(Ja>>>0>16384)Ka=QAa(c[h>>2]|0,Ja)|0;else{ma=c[ca>>2]|0;if((ma|0)!=0?(La=c[da>>2]|0,Ma=La+Ja|0,Ma>>>0<=16384):0){c[da>>2]=Ma;Ka=ma+La|0;break}La=SAa(c[h>>2]|0,o)|0;c[ca>>2]=La;c[da>>2]=Ja;Ka=La}while(0);Ja=j+(fa<<5)+16|0;c[Ja>>2]=Ka;c[j+(fa<<5)+20>>2]=0;La=Ka+48|0;a[Ka>>0]=4;a[Ka+1>>0]=ja;a[Ka+2>>0]=0;g[Ka+32>>2]=ea(1.0);g[Ka+36>>2]=ea(1.0);g[Ka+40>>2]=ea(-1.0);g[Ka+44>>2]=ea(-1.0);if(Fa){qa=ea(ea(g[u>>2])*ea(2.0));Ca=ea(ea(g[f>>2])*ea(2.0));za=ea(ea(g[M>>2])*ea(2.0));wa=ea(g[l+(ia*84|0)+12>>2]);Ea=ea(ea(wa*wa)+ea(-.5));ra=ea(g[l+(ia*84|0)>>2]);ya=ea(qa*ra);Ba=ea(g[l+(ia*84|0)+4>>2]);Aa=ea(ya+ea(Ca*Ba));ya=ea(g[l+(ia*84|0)+8>>2]);xa=ea(Aa+ea(za*ya));Aa=ea(ea(Ba*xa)+ea(ea(Ca*Ea)+ea(wa*ea(ea(qa*ya)-ea(za*ra)))));sa=ea(ea(ea(za*Ea)+ea(wa*ea(ea(Ca*ra)-ea(qa*Ba))))+ea(ya*xa));g[x>>2]=ea(ea(ra*xa)+ea(ea(qa*Ea)+ea(wa*ea(ea(za*Ba)-ea(Ca*ya)))));g[N>>2]=Aa;g[O>>2]=sa;Rza(d,k,ia,La,x,ea(g[v>>2]),A);if(Ga){sa=ea(g[J>>2]);Aa=ea(g[O>>2]);ya=ea(sa*Aa);Ca=ea(g[K>>2]);Ba=ea(g[N>>2]);za=ea(ya-ea(Ca*Ba));ya=ea(g[x>>2]);wa=ea(Ca*ya);Ca=ea(g[w>>2]);Ea=ea(wa-ea(Aa*Ca));Aa=ea(ea(Ba*Ca)-ea(sa*ya));ya=ea(ea(Aa*Aa)+ea(ea(za*za)+ea(Ea*Ea)));if(ya>ea(0.0)){sa=ea(ea(1.0)/ea(T(ea(ya))));Na=ea(za*sa);Oa=ea(Ea*sa);Pa=ea(Aa*sa)}else{Na=ea(0.0);Oa=ea(0.0);Pa=ea(0.0)}sa=ea(g[ha+124>>2]);Aa=ea(g[ha+128>>2]);g[Ka+224>>2]=ea(0.0);g[Ka+228>>2]=ea(0.0);g[Ka+232>>2]=ea(0.0);g[Ka+240>>2]=ea(0.0);g[Ka+244>>2]=ea(0.0);g[Ka+248>>2]=ea(0.0);g[Ka+256>>2]=Na;g[Ka+260>>2]=Oa;g[Ka+264>>2]=Pa;g[Ka+272>>2]=Na;g[Ka+276>>2]=Oa;g[Ka+280>>2]=Pa;g[Ka+320>>2]=ea(-3402823469999999843913219.0e14);g[Ka+324>>2]=ea(3402823469999999843913219.0e14);c[Ka+332>>2]=0;g[Ka+328>>2]=ea(0.0);ma=c[ka>>2]|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;g[P>>2]=Na;g[Q>>2]=Oa;g[R>>2]=Pa;g[S>>2]=ea(0.0);Ea=ea(-Na);za=ea(-Oa);ya=ea(-Pa);g[r>>2]=ea(-0.0);g[U>>2]=ea(-0.0);g[V>>2]=ea(-0.0);g[W>>2]=ea(0.0);g[X>>2]=Ea;g[Y>>2]=za;g[Z>>2]=ya;g[_>>2]=ea(0.0);Cza(d,ma,q,Ka+336|0,ia,r,Ka+368|0);ya=ea(Na*ea(g[Ka+352>>2]));za=ea(ya+ea(Oa*ea(g[Ka+356>>2])));ya=ea(za+ea(Pa*ea(g[Ka+360>>2])));za=ea(Na*ea(g[Ka+384>>2]));Ea=ea(za+ea(Oa*ea(g[Ka+388>>2])));za=ea(ea(1.0)/ea(ya-ea(Ea+ea(Pa*ea(g[Ka+392>>2])))));Ea=ea(ea($*sa)+ea(Aa*m));Aa=ea(ea(1.0)/ea(Ea+ea(1.0)));g[Ka+252>>2]=ea(0.0);g[Ka+236>>2]=ea(0.0);g[Ka+268>>2]=ea(-ea(Ea*ea(za*Aa)));g[Ka+284>>2]=ea(ea(1.0)-Aa);Qa=2}else Qa=1}else Qa=0;if(Ha){Rza(d,k,ia,La+(Qa*176|0)|0,w,ea(ea(ea(g[ha+160>>2])-Da)*ea(4.0)),A);Ra=Qa+1|0}else Ra=Qa;if(Ia){Aa=ea(-ea(g[w>>2]));za=ea(-ea(g[J>>2]));Ea=ea(-ea(g[K>>2]));g[y>>2]=Aa;g[aa>>2]=za;g[ba>>2]=Ea;Rza(d,k,ia,La+(Ra*176|0)|0,y,ea(ea(ea(g[ha+164>>2])-Da)*ea(-4.0)),A)}a[(c[Ja>>2]|0)+(e[na>>1]<<4)>>0]=0;c[n>>2]=(c[n>>2]|0)+la;pa=oa}}if((ga&65535)<<16>>16==z<<16>>16){B=pa;break}else fa=pa}i=p;return B|0}function Pza(a,b,d,f,h,j,k){a=a|0;b=b|0;d=d|0;f=ea(f);h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im;l=i;i=i+304|0;m=l+280|0;n=l+24|0;o=l+12|0;p=l;q=b&65535;r=q*240|0;s=r+(q<<5)|0;t=j+s|0;u=q*48|0;v=s+u|0;Hza(a,d,b,j+r|0,j,j+(q*144|0)|0,0);PEi(a+(e[a+26>>1]|0)|0,0,(q*160|0)+144|0)|0;Mza(a,d);g[n>>2]=ea(0.0);if((b&65535)>1){w=ea(ea(1.0)/f);b=1;do{g[n+(b<<2)>>2]=w;b=b+1|0}while((b|0)!=(q|0))}PEi(t|0,0,u|0)|0;c[o>>2]=j;c[o+4>>2]=k;c[o+8>>2]=v;c[m+0>>2]=c[o+0>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];Fza(a,j,t,n,q,h&65535,m);c[p>>2]=j;c[p+4>>2]=k;c[p+8>>2]=v;c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];xza(a,j,n,t,m);i=l;return}function Qza(a,d){a=a|0;d=ea(d);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,U=0,X=0,Y=Im,Z=Im,_=Im,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=Im,oa=Im,pa=Im,qa=0.0,ra=Im,sa=Im,ta=Im,ua=0;f=i;i=i+1024|0;h=f;j=c[a>>2]|0;k=c[a+24>>2]|0;l=c[a+4>>2]|0;m=c[a+12>>2]|0;n=c[a+8>>2]|0;o=b[j+8>>1]|0;p=o&65535;Uza(j);q=j+128|0;Dza(h,j,q);wza(j,q,h);r=c[a+28>>2]|0;s=e[a+36>>1]|0;a=s<<5;t=o<<16>>16==0;if(!t){u=0;do{v=m+(u*28|0)|0;g[r+(u*28|0)>>2]=ea(g[v>>2]);w=m+(u*28|0)+4|0;g[r+(u*28|0)+4>>2]=ea(g[w>>2]);x=m+(u*28|0)+8|0;g[r+(u*28|0)+8>>2]=ea(g[x>>2]);y=m+(u*28|0)+12|0;g[r+(u*28|0)+12>>2]=ea(g[y>>2]);z=m+(u*28|0)+16|0;g[r+(u*28|0)+16>>2]=ea(g[z>>2]);A=m+(u*28|0)+20|0;g[r+(u*28|0)+20>>2]=ea(g[A>>2]);B=m+(u*28|0)+24|0;g[r+(u*28|0)+24>>2]=ea(g[B>>2]);C=ea(ea(g[n+(u<<5)>>2])*d);D=ea(ea(g[n+(u<<5)+4>>2])*d);E=ea(ea(g[n+(u<<5)+8>>2])*d);F=ea(C+ea(g[z>>2]));C=ea(D+ea(g[A>>2]));D=ea(E+ea(g[B>>2]));E=ea(ea(g[n+(u<<5)+16>>2])*d);G=ea(ea(g[n+(u<<5)+20>>2])*d);H=ea(ea(g[n+(u<<5)+24>>2])*d);I=ea(ea(ea(E*E)+ea(G*G))+ea(H*H));if(+I<1.0e-24){J=ea(1.0);K=ea(0.0);L=ea(0.0);M=ea(0.0)}else{N=ea(T(ea(I)));I=ea(ea(1.0)/N);O=ea(N*ea(.5));N=ea(+W(+O));J=ea(+V(+O));K=ea(N*ea(E*I));L=ea(N*ea(G*I));M=ea(N*ea(H*I))}I=ea(g[v>>2]);H=ea(J*I);N=ea(g[y>>2]);G=ea(H+ea(K*N));H=ea(g[x>>2]);E=ea(G+ea(L*H));G=ea(g[w>>2]);O=ea(ea(ea(M*I)+ea(ea(L*N)+ea(J*G)))-ea(K*H));P=ea(ea(ea(K*G)+ea(ea(M*N)+ea(J*H)))-ea(L*I));Q=ea(ea(ea(ea(J*N)-ea(K*I))-ea(L*G))-ea(M*H));g[v>>2]=ea(E-ea(M*G));g[w>>2]=O;g[x>>2]=P;g[y>>2]=Q;g[z>>2]=F;g[A>>2]=C;g[B>>2]=D;u=u+1|0}while((u|0)!=(p|0))}M=ea(ea(1.0)/d);u=r+a|0;B=r+((s*144|0)+a)|0;a=k+8|0;do if(c[a>>2]|0){s=(o&65535)>1;A=k+16|0;z=p*144|0;y=l+20|0;x=j+24|0;w=p<<5;v=0;R=0;while(1){if(s){S=1;L=ea(-3402823469999999843913219.0e14);while(1){U=c[l+(S<<5)+24>>2]|0;X=c[l+(S<<5)+28>>2]|0;K=ea(ea(g[U+16>>2])*ea(2.0));J=ea(ea(g[U+20>>2])*ea(2.0));D=ea(ea(g[U+24>>2])*ea(2.0));C=ea(g[m+(X*28|0)+12>>2]);F=ea(ea(C*C)+ea(-.5));Q=ea(g[m+(X*28|0)>>2]);P=ea(K*Q);O=ea(g[m+(X*28|0)+4>>2]);G=ea(P+ea(J*O));P=ea(g[m+(X*28|0)+8>>2]);E=ea(G+ea(D*P));G=ea(ea(Q*E)+ea(ea(K*F)+ea(C*ea(ea(D*O)-ea(J*P)))));H=ea(ea(O*E)+ea(ea(J*F)+ea(C*ea(ea(K*P)-ea(D*Q)))));I=ea(ea(ea(D*F)+ea(C*ea(ea(J*Q)-ea(K*O))))+ea(P*E));E=ea(ea(g[m+(X*28|0)+16>>2])+G);G=ea(ea(g[m+(X*28|0)+20>>2])+H);H=ea(ea(g[m+(X*28|0)+24>>2])+I);I=ea(ea(g[U+44>>2])*ea(2.0));P=ea(ea(g[U+48>>2])*ea(2.0));O=ea(ea(g[U+52>>2])*ea(2.0));K=ea(g[m+(S*28|0)+12>>2]);Q=ea(ea(K*K)+ea(-.5));J=ea(g[m+(S*28|0)>>2]);C=ea(I*J);F=ea(g[m+(S*28|0)+4>>2]);D=ea(C+ea(P*F));C=ea(g[m+(S*28|0)+8>>2]);N=ea(D+ea(O*C));D=ea(ea(J*N)+ea(ea(I*Q)+ea(K*ea(ea(O*F)-ea(P*C)))));Y=ea(ea(F*N)+ea(ea(P*Q)+ea(K*ea(ea(I*C)-ea(O*J)))));Z=ea(ea(ea(O*Q)+ea(K*ea(ea(P*J)-ea(I*F))))+ea(C*N));N=ea(ea(g[m+(S*28|0)+16>>2])+D);D=ea(ea(g[m+(S*28|0)+20>>2])+Y);Y=ea(E-N);N=ea(G-D);D=ea(H-ea(ea(g[m+(S*28|0)+24>>2])+Z));Z=ea(T(ea(ea(D*D)+ea(ea(Y*Y)+ea(N*N)))));N=L>Z?L:Z;S=S+1|0;if((S|0)==(p|0)){_=N;break}else L=N}}else _=ea(-3402823469999999843913219.0e14);if(_<=ea(g[A>>2])){aa=19;break}PEi(u|0,0,z|0)|0;Iza(u,c[y>>2]|0,m);if(s){S=1;do{U=m+(S*28|0)|0;Iza(u+(S*144|0)|0,c[l+(S<<5)+20>>2]|0,U);Jza(B+(S*84|0)|0,m+((c[l+(S<<5)+28>>2]|0)*28|0)|0,U,c[l+(S<<5)+24>>2]|0);S=S+1|0}while((S|0)!=(p|0))}Lza(j,u,m,B,M);uza(j);S=j+(e[x>>1]|0)|0;if(s){U=1;do{X=h+(U<<4)|0;ba=S+(U*400|0)+384|0;c[X+0>>2]=c[ba+0>>2];c[X+4>>2]=c[ba+4>>2];c[X+8>>2]=c[ba+8>>2];c[X+12>>2]=c[ba+12>>2];U=U+1|0}while((U|0)!=(p|0))}PEi(n|0,0,w|0)|0;wza(j,n,h);if(!t){U=0;do{L=ea(ea(g[n+(U<<5)>>2])*d);N=ea(ea(g[n+(U<<5)+4>>2])*d);Z=ea(ea(g[n+(U<<5)+8>>2])*d);S=m+(U*28|0)+16|0;Y=ea(L+ea(g[S>>2]));ba=m+(U*28|0)+20|0;L=ea(N+ea(g[ba>>2]));X=m+(U*28|0)+24|0;N=ea(Z+ea(g[X>>2]));Z=ea(ea(g[n+(U<<5)+16>>2])*d);D=ea(ea(g[n+(U<<5)+20>>2])*d);H=ea(ea(g[n+(U<<5)+24>>2])*d);G=ea(ea(ea(Z*Z)+ea(D*D))+ea(H*H));if(+G<1.0e-24){ca=ea(1.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0)}else{E=ea(T(ea(G)));G=ea(ea(1.0)/E);C=ea(E*ea(.5));E=ea(+W(+C));ca=ea(+V(+C));da=ea(E*ea(Z*G));fa=ea(E*ea(D*G));ga=ea(E*ea(H*G))}ha=m+(U*28|0)|0;G=ea(g[ha>>2]);H=ea(ca*G);ia=m+(U*28|0)+12|0;E=ea(g[ia>>2]);D=ea(H+ea(da*E));ja=m+(U*28|0)+8|0;H=ea(g[ja>>2]);Z=ea(D+ea(fa*H));ka=m+(U*28|0)+4|0;D=ea(g[ka>>2]);C=ea(ea(ea(ga*G)+ea(ea(fa*E)+ea(ca*D)))-ea(da*H));F=ea(ea(ea(da*D)+ea(ea(ga*E)+ea(ca*H)))-ea(fa*G));I=ea(ea(ea(ea(ca*E)-ea(da*G))-ea(fa*D))-ea(ga*H));g[ha>>2]=ea(Z-ea(ga*D));g[ka>>2]=C;g[ja>>2]=F;g[ia>>2]=I;g[S>>2]=Y;g[ba>>2]=L;g[X>>2]=N;U=U+1|0}while((U|0)!=(p|0))}v=v+1|0;if(v>>>0>=(c[a>>2]|0)>>>0)break;else R=1}if((aa|0)==19?!R:0)break;if(t){i=f;return}else la=0;do{N=ea(g[m+(la*28|0)+16>>2]);L=ea(N-ea(g[r+(la*28|0)+16>>2]));N=ea(g[m+(la*28|0)+20>>2]);Y=ea(N-ea(g[r+(la*28|0)+20>>2]));N=ea(g[m+(la*28|0)+24>>2]);I=ea(M*Y);Y=ea(M*ea(N-ea(g[r+(la*28|0)+24>>2])));g[n+(la<<5)>>2]=ea(M*L);g[n+(la<<5)+4>>2]=I;g[n+(la<<5)+8>>2]=Y;g[n+(la<<5)+12>>2]=ea(0.0);Y=ea(-ea(g[r+(la*28|0)>>2]));I=ea(-ea(g[r+(la*28|0)+4>>2]));L=ea(-ea(g[r+(la*28|0)+8>>2]));N=ea(g[r+(la*28|0)+12>>2]);F=ea(g[m+(la*28|0)+12>>2]);C=ea(F*Y);D=ea(g[m+(la*28|0)>>2]);Z=ea(C+ea(N*D));C=ea(g[m+(la*28|0)+4>>2]);H=ea(Z+ea(C*L));Z=ea(g[m+(la*28|0)+8>>2]);G=ea(H-ea(Z*I));H=ea(ea(ea(ea(F*I)+ea(N*C))+ea(Z*Y))-ea(D*L));E=ea(ea(ea(D*I)+ea(ea(F*L)+ea(N*Z)))-ea(C*Y));J=ea(ea(ea(ea(N*F)-ea(D*Y))-ea(C*I))-ea(Z*L));L=ea(ea(ea(G*G)+ea(H*H))+ea(E*E));Z=ea(T(ea(L)));ma=+Z;if(ma<1.0e-12){na=ea(0.0);oa=ea(0.0);pa=ea(0.0)}else{if(J<ea(0.0))qa=+$(+(+ea(-Z)),+(+ea(-J)));else qa=+$(+ma,+(+J));J=ea(qa);if(L>ea(0.0)){L=ea(ea(1.0)/Z);ra=ea(ea(G*L)*ea(2.0));sa=ea(ea(H*L)*ea(2.0));ta=ea(ea(E*L)*ea(2.0))}else{ra=ea(0.0);sa=ea(0.0);ta=ea(0.0)}na=ea(J*ra);oa=ea(J*sa);pa=ea(J*ta)}J=ea(M*oa);L=ea(M*pa);g[n+(la<<5)+16>>2]=ea(M*na);g[n+(la<<5)+20>>2]=J;g[n+(la<<5)+24>>2]=L;g[n+(la<<5)+28>>2]=ea(0.0);la=la+1|0}while((la|0)!=(p|0))}while(0);if(t){i=f;return}else ua=0;do{t=c[l+(ua<<5)+20>>2]|0;g[t>>2]=ea(g[m+(ua*28|0)>>2]);g[t+4>>2]=ea(g[m+(ua*28|0)+4>>2]);g[t+8>>2]=ea(g[m+(ua*28|0)+8>>2]);g[t+12>>2]=ea(g[m+(ua*28|0)+12>>2]);g[t+16>>2]=ea(g[m+(ua*28|0)+16>>2]);g[t+20>>2]=ea(g[m+(ua*28|0)+20>>2]);g[t+24>>2]=ea(g[m+(ua*28|0)+24>>2]);na=ea(g[q+(ua<<5)>>2]);M=ea(g[q+(ua<<5)+4>>2]);pa=ea(g[q+(ua<<5)+8>>2]);g[t+64>>2]=na;g[t+68>>2]=M;g[t+72>>2]=pa;pa=ea(g[q+(ua<<5)+16>>2]);M=ea(g[q+(ua<<5)+20>>2]);na=ea(g[q+(ua<<5)+24>>2]);g[t+80>>2]=pa;g[t+84>>2]=M;g[t+88>>2]=na;na=ea(g[n+(ua<<5)>>2]);M=ea(g[n+(ua<<5)+4>>2]);pa=ea(g[n+(ua<<5)+8>>2]);t=c[l+(ua<<5)+16>>2]|0;g[t>>2]=na;g[t+4>>2]=M;g[t+8>>2]=pa;pa=ea(g[n+(ua<<5)+16>>2]);M=ea(g[n+(ua<<5)+20>>2]);na=ea(g[n+(ua<<5)+24>>2]);g[t+16>>2]=pa;g[t+20>>2]=M;g[t+24>>2]=na;ua=ua+1|0}while((ua|0)!=(p|0));i=f;return}function Rza(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im,C=0,D=Im,E=0,F=0;k=i;i=i+80|0;l=k+32|0;m=k;g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);g[e+16>>2]=ea(0.0);g[e+20>>2]=ea(0.0);g[e+24>>2]=ea(0.0);g[e+32>>2]=ea(g[f>>2]);n=f+4|0;g[e+36>>2]=ea(g[n>>2]);o=f+8|0;g[e+40>>2]=ea(g[o>>2]);g[e+48>>2]=ea(g[f>>2]);g[e+52>>2]=ea(g[n>>2]);g[e+56>>2]=ea(g[o>>2]);g[e+96>>2]=ea(0.0);g[e+100>>2]=ea(3402823469999999843913219.0e14);c[e+108>>2]=0;g[e+104>>2]=ea(0.0);p=c[b+(d<<5)+28>>2]|0;q=ea(g[f>>2]);r=ea(g[n>>2]);s=ea(g[o>>2]);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[l+16>>2]=q;g[l+20>>2]=r;g[l+24>>2]=s;g[l+28>>2]=ea(0.0);t=ea(-q);q=ea(-r);r=ea(-s);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[m+16>>2]=t;g[m+20>>2]=q;g[m+24>>2]=r;g[m+28>>2]=ea(0.0);Cza(a,p,l,e+112|0,d,m,e+144|0);r=ea(g[f>>2]);q=ea(r*ea(g[e+128>>2]));t=ea(g[n>>2]);s=ea(q+ea(t*ea(g[e+132>>2])));q=ea(g[o>>2]);u=ea(s+ea(q*ea(g[e+136>>2])));s=ea(r*ea(g[e+160>>2]));r=ea(s+ea(t*ea(g[e+164>>2])));t=ea(u-ea(r+ea(q*ea(g[e+168>>2]))));if(!(t<ea(0.0))){v=ea(ea(1.0)/t);w=ea(v*h);x=ea(w*j);y=ea(-x);z=e+12|0;g[z>>2]=y;A=h>ea(0.0);B=A?y:ea(0.0);C=e+28|0;g[C>>2]=B;D=ea(-v);E=e+44|0;g[E>>2]=D;F=e+60|0;g[F>>2]=ea(1.0);i=k;return}dKa(bKa()|0,2,500328,1198,500432,k+64|0);v=ea(ea(1.0)/t);w=ea(v*h);x=ea(w*j);y=ea(-x);z=e+12|0;g[z>>2]=y;A=h>ea(0.0);B=A?y:ea(0.0);C=e+28|0;g[C>>2]=B;D=ea(-v);E=e+44|0;g[E>>2]=D;F=e+60|0;g[F>>2]=ea(1.0);i=k;return}function Sza(b,d,f,h){b=b|0;d=d|0;f=f|0;h=h|0;var j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0;j=i;k=ea(g[f>>2]);l=ea(g[f+4>>2]);m=ea(-k);k=ea(-l);l=ea(-ea(g[f+8>>2]));n=ea(g[h>>2]);o=ea(g[h+4>>2]);p=ea(-n);n=ea(-o);o=ea(-ea(g[h+8>>2]));h=b+((e[b+26>>1]|0)+144)|0;f=b+(e[b+10>>1]|0)|0;q=b+128+((e[b+8>>1]|0)<<6)|0;if(!d){r=l;s=k;t=m;u=o;v=n;w=p}else{x=k;k=l;l=m;m=p;p=n;n=o;y=d;while(1){o=ea(g[f+(y<<5)+16>>2]);z=ea(g[f+(y<<5)+20>>2]);A=ea(g[f+(y<<5)+24>>2]);B=ea(m+ea(ea(x*A)-ea(k*z)));C=ea(p+ea(ea(k*o)-ea(l*A)));A=ea(n+ea(ea(l*z)-ea(x*o)));o=ea(g[h+(y*160|0)>>2]);z=ea(g[h+(y*160|0)+4>>2]);D=ea(g[h+(y*160|0)+8>>2]);E=ea(g[h+(y*160|0)+32>>2]);F=ea(g[h+(y*160|0)+36>>2]);G=ea(g[h+(y*160|0)+40>>2]);H=ea(g[h+(y*160|0)+64>>2]);I=ea(g[h+(y*160|0)+68>>2]);J=ea(l-ea(ea(o*B)+ea(ea(C*E)+ea(A*H))));H=ea(x-ea(ea(z*B)+ea(ea(C*F)+ea(A*I))));I=ea(k-ea(ea(D*B)+ea(ea(C*G)+ea(A*ea(g[h+(y*160|0)+72>>2])))));G=ea(g[h+(y*160|0)+16>>2]);D=ea(g[h+(y*160|0)+20>>2]);F=ea(g[h+(y*160|0)+24>>2]);z=ea(g[h+(y*160|0)+48>>2]);E=ea(g[h+(y*160|0)+52>>2]);o=ea(g[h+(y*160|0)+56>>2]);K=ea(g[h+(y*160|0)+80>>2]);L=ea(g[h+(y*160|0)+84>>2]);M=ea(m-ea(ea(B*G)+ea(ea(C*z)+ea(A*K))));K=ea(p-ea(ea(B*D)+ea(ea(C*E)+ea(A*L))));L=ea(n-ea(ea(B*F)+ea(ea(C*o)+ea(A*ea(g[h+(y*160|0)+88>>2])))));o=ea(g[f+(y<<5)>>2]);F=ea(g[f+(y<<5)+4>>2]);E=ea(g[f+(y<<5)+8>>2]);D=ea(M+ea(ea(I*F)-ea(H*E)));M=ea(K+ea(ea(J*E)-ea(I*o)));E=ea(L+ea(ea(H*o)-ea(J*F)));N=q+(y<<4)|0;F=ea(g[N>>2]);O=q+(y<<4)+4|0;o=ea(g[O>>2]);P=q+(y<<4)+8|0;L=ea(C+o);o=ea(A+ea(g[P>>2]));g[N>>2]=ea(B+F);g[O>>2]=L;g[P>>2]=o;g[q+(y<<4)+12>>2]=ea(0.0);P=a[b+y+64>>0]|0;if(!(P<<24>>24)){r=I;s=H;t=J;u=E;v=M;w=D;break}else{x=H;k=I;l=J;m=D;p=M;n=E;y=P&255}}}y=b+32|0;n=ea(g[y>>2]);q=b+36|0;p=ea(g[q>>2]);f=b+40|0;m=ea(s+p);p=ea(r+ea(g[f>>2]));g[y>>2]=ea(t+n);g[q>>2]=m;g[f>>2]=p;g[b+44>>2]=ea(0.0);f=b+48|0;p=ea(g[f>>2]);q=b+52|0;m=ea(g[q>>2]);y=b+56|0;n=ea(v+m);m=ea(u+ea(g[y>>2]));g[f>>2]=ea(w+p);g[q>>2]=n;g[y>>2]=m;g[b+60>>2]=ea(0.0);y=h+(d*160|0)+152|0;d=b+16|0;b=d;h=c[b+4>>2]|c[y+4>>2];q=d;c[q>>2]=c[b>>2]|c[y>>2];c[q+4>>2]=h;i=j;return}function Tza(a,b,f){a=a|0;b=b|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0;h=i;i=i+2384|0;j=h+2128|0;k=h+48|0;l=h+32|0;m=h+2112|0;n=h;o=h+2096|0;p=h+16|0;q=e[b+26>>1]|0;r=b+(q+144)|0;s=b+(e[b+10>>1]|0)|0;t=b+128|0;u=r+(f*160|0)+152|0;v=c[u>>2]|0;w=c[u+4>>2]|0;u=b+16|0;x=u;y=c[x>>2]&v;z=c[x+4>>2]&w;if((y|0)==0&(z|0)==0){A=t+(f<<5)|0;c[a+0>>2]=c[A+0>>2];c[a+4>>2]=c[A+4>>2];c[a+8>>2]=c[A+8>>2];c[a+12>>2]=c[A+12>>2];B=a+16|0;C=t+(f<<5)+16|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];i=h;return}x=ZEi(0,0,y|0,z|0)|0;D=ZEi(0,0,y&x|0,z&H|0)|0;z=v&D;D=w&H;w=e[b+8>>1]|0;v=t+(w<<5)|0;x=t+(w<<6)|0;if((z&1|0)==0&0==0){E=ea(0.0);F=ea(0.0);G=ea(0.0);I=ea(0.0);J=ea(0.0);K=ea(0.0);L=z;M=D;N=0;O=0;P=0}else{w=b+32|0;Q=ea(g[b+32>>2]);R=ea(g[b+36>>2]);S=ea(-Q);Q=ea(-R);R=ea(-ea(g[b+40>>2]));y=b+48|0;T=ea(g[b+48>>2]);U=ea(g[b+52>>2]);V=ea(-T);T=ea(-U);U=ea(-ea(g[b+56>>2]));W=ea(ea(g[b+q>>2])*S);X=ea(W+ea(ea(g[b+(q+16)>>2])*Q));W=ea(X+ea(ea(g[b+(q+32)>>2])*R));X=ea(ea(g[b+(q+4)>>2])*S);Y=ea(X+ea(ea(g[b+(q+20)>>2])*Q));X=ea(Y+ea(ea(g[b+(q+36)>>2])*R));Y=ea(ea(g[b+(q+8)>>2])*S);Z=ea(Y+ea(ea(g[b+(q+24)>>2])*Q));Y=ea(Z+ea(ea(g[b+(q+40)>>2])*R));Z=ea(g[b+(q+48)>>2]);_=ea(Z*V);$=ea(g[b+(q+64)>>2]);aa=ea(_+ea($*T));_=ea(g[b+(q+80)>>2]);ba=ea(aa+ea(_*U));aa=ea(g[b+(q+52)>>2]);ca=ea(aa*V);fa=ea(g[b+(q+68)>>2]);ga=ea(ca+ea(fa*T));ca=ea(g[b+(q+84)>>2]);ha=ea(ga+ea(ca*U));ga=ea(g[b+(q+56)>>2]);ia=ea(ga*V);ja=ea(g[b+(q+72)>>2]);ka=ea(ia+ea(ja*T));ia=ea(g[b+(q+88)>>2]);la=ea(W+ba);ba=ea(X+ha);ha=ea(Y+ea(ka+ea(ia*U)));ka=ea(ea(ea(Z*S)+ea(aa*Q))+ea(ga*R));ga=ea(ea(ea($*S)+ea(fa*Q))+ea(ja*R));ja=ea(ea(ea(_*S)+ea(ca*Q))+ea(ia*R));R=ea(ea(g[b+(q+96)>>2])*V);ia=ea(R+ea(ea(g[b+(q+112)>>2])*T));R=ea(ia+ea(ea(g[b+(q+128)>>2])*U));ia=ea(ea(g[b+(q+100)>>2])*V);Q=ea(ia+ea(ea(g[b+(q+116)>>2])*T));ia=ea(Q+ea(ea(g[b+(q+132)>>2])*U));Q=ea(ea(g[b+(q+104)>>2])*V);V=ea(Q+ea(ea(g[b+(q+120)>>2])*T));T=ea(ka+R);R=ea(ga+ia);ia=ea(ja+ea(V+ea(ea(g[b+(q+136)>>2])*U)));U=ea(g[t>>2]);ma=b+132|0;V=ea(g[ma>>2]);na=b+136|0;ja=ea(ba+V);V=ea(ha+ea(g[na>>2]));g[t>>2]=ea(la+U);g[ma>>2]=ja;g[na>>2]=V;g[b+140>>2]=ea(0.0);na=b+144|0;V=ea(g[na>>2]);ma=t+20|0;ja=ea(g[ma>>2]);oa=b+152|0;U=ea(R+ja);ja=ea(ia+ea(g[oa>>2]));g[na>>2]=ea(T+V);g[ma>>2]=U;g[oa>>2]=ja;g[b+156>>2]=ea(0.0);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[w+0>>2]=c[l+0>>2];c[w+4>>2]=c[l+4>>2];c[w+8>>2]=c[l+8>>2];c[w+12>>2]=c[l+12>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[y+0>>2]=c[m+0>>2];c[y+4>>2]=c[m+4>>2];c[y+8>>2]=c[m+8>>2];c[y+12>>2]=c[m+12>>2];c[j>>2]=0;g[k>>2]=la;g[k+4>>2]=ba;g[k+8>>2]=ha;g[k+12>>2]=ea(0.0);g[k+16>>2]=T;g[k+20>>2]=R;g[k+24>>2]=ia;g[k+28>>2]=ea(0.0);m=b+(q+288)|0;q=c[m>>2]|0;y=c[m+4>>2]|0;m=_Ei(z|0,D|0,-1,-1)|0;E=ha;F=ba;G=la;I=ia;J=R;K=T;L=m;M=H;N=q;O=y;P=1}if((L|0)==0&(M|0)==0){pa=N;qa=O}else{y=L;L=M;T=G;G=F;F=E;E=K;K=J;J=I;M=N;N=O;O=P;while(1){P=c[425648+((da(y&0-y,125613361)|0)>>>27<<2)>>2]|0;q=(c[425648+((da(L&0-L,125613361)|0)>>>27<<2)>>2]|0)+32|0;m=(y|0)!=0?P:q;q=_Ei(y|0,L|0,-1,-1)|0;y=q&y;L=H&L;q=v+(m<<5)|0;I=ea(g[q>>2]);R=ea(g[v+(m<<5)+4>>2]);ia=ea(T+I);I=ea(G+R);R=ea(F+ea(g[v+(m<<5)+8>>2]));P=v+(m<<5)+16|0;la=ea(g[P>>2]);ba=ea(g[v+(m<<5)+20>>2]);ha=ea(E+la);la=ea(K+ba);ba=ea(J+ea(g[v+(m<<5)+24>>2]));l=x+(m<<4)|0;ja=ea(g[l>>2]);U=ea(g[x+(m<<4)+4>>2]);V=ea(g[x+(m<<4)+8>>2]);ga=ea(ja*ea(g[r+(m*160|0)+96>>2]));ka=ea(ga+ea(U*ea(g[r+(m*160|0)+112>>2])));ga=ea(ka+ea(V*ea(g[r+(m*160|0)+128>>2])));ka=ea(ja*ea(g[r+(m*160|0)+100>>2]));Q=ea(ka+ea(U*ea(g[r+(m*160|0)+116>>2])));ka=ea(Q+ea(V*ea(g[r+(m*160|0)+132>>2])));Q=ea(ja*ea(g[r+(m*160|0)+104>>2]));ja=ea(Q+ea(U*ea(g[r+(m*160|0)+120>>2])));U=ea(ja+ea(V*ea(g[r+(m*160|0)+136>>2])));V=ea(g[s+(m<<5)>>2]);ja=ea(g[s+(m<<5)+4>>2]);Q=ea(g[s+(m<<5)+8>>2]);ca=ea(ia+ea(ea(la*Q)-ea(ba*ja)));ia=ea(I+ea(ea(ba*V)-ea(ha*Q)));Q=ea(R+ea(ea(ha*ja)-ea(la*V)));V=ea(g[r+(m*160|0)>>2]);ja=ea(g[r+(m*160|0)+4>>2]);R=ea(ea(Q*ea(g[r+(m*160|0)+8>>2]))+ea(ea(V*ca)+ea(ja*ia)));ja=ea(g[r+(m*160|0)+32>>2]);V=ea(g[r+(m*160|0)+36>>2]);I=ea(ea(ea(ca*ja)+ea(ia*V))+ea(Q*ea(g[r+(m*160|0)+40>>2])));V=ea(g[r+(m*160|0)+64>>2]);ja=ea(g[r+(m*160|0)+68>>2]);S=ea(ea(ea(ca*V)+ea(ia*ja))+ea(Q*ea(g[r+(m*160|0)+72>>2])));ja=ea(g[r+(m*160|0)+16>>2]);V=ea(g[r+(m*160|0)+20>>2]);_=ea(ea(ea(ha*ja)+ea(la*V))+ea(ba*ea(g[r+(m*160|0)+24>>2])));V=ea(g[r+(m*160|0)+48>>2]);ja=ea(g[r+(m*160|0)+52>>2]);fa=ea(ea(ea(ha*V)+ea(la*ja))+ea(ba*ea(g[r+(m*160|0)+56>>2])));ja=ea(g[r+(m*160|0)+80>>2]);V=ea(g[r+(m*160|0)+84>>2]);$=ea(ga+ea(R+_));_=ea(ka+ea(I+fa));fa=ea(U+ea(S+ea(ea(ea(ha*ja)+ea(la*V))+ea(ba*ea(g[r+(m*160|0)+88>>2])))));V=ea(g[s+(m<<5)+16>>2]);ja=ea(g[s+(m<<5)+20>>2]);S=ea(g[s+(m<<5)+24>>2]);T=ea(ca-ea(ea(ja*fa)-ea(_*S)));G=ea(ia-ea(ea($*S)-ea(V*fa)));F=ea(Q-ea(ea(_*V)-ea($*ja)));E=ea(ha-$);K=ea(la-_);J=ea(ba-fa);w=t+(m<<5)|0;fa=ea(g[w>>2]);oa=t+(m<<5)+4|0;ba=ea(g[oa>>2]);ma=t+(m<<5)+8|0;_=ea(ba+G);ba=ea(F+ea(g[ma>>2]));g[w>>2]=ea(fa+T);g[oa>>2]=_;g[ma>>2]=ba;g[t+(m<<5)+12>>2]=ea(0.0);ma=t+(m<<5)+16|0;ba=ea(g[ma>>2]);oa=t+(m<<5)+20|0;_=ea(g[oa>>2]);w=t+(m<<5)+24|0;fa=ea(K+_);_=ea(J+ea(g[w>>2]));g[ma>>2]=ea(E+ba);g[oa>>2]=fa;g[w>>2]=_;g[t+(m<<5)+28>>2]=ea(0.0);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[P+0>>2]=c[o+0>>2];c[P+4>>2]=c[o+4>>2];c[P+8>>2]=c[o+8>>2];c[P+12>>2]=c[o+12>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[l+12>>2]=c[p+12>>2];c[j+(m<<2)>>2]=O;l=r+(m*160|0)+144|0;m=c[l>>2]|M;P=c[l+4>>2]|N;g[k+(O<<5)>>2]=T;g[k+(O<<5)+4>>2]=G;g[k+(O<<5)+8>>2]=F;g[k+(O<<5)+12>>2]=ea(0.0);g[k+(O<<5)+16>>2]=E;g[k+(O<<5)+20>>2]=K;g[k+(O<<5)+24>>2]=J;g[k+(O<<5)+28>>2]=ea(0.0);if((y|0)==0&(L|0)==0){pa=m;qa=P;break}else{M=m;N=P;O=O+1|0}}}O=~z;z=~D;D=pa&O;N=qa&z;if(!((D|0)==0&(N|0)==0)){M=D;D=N;do{N=c[425648+((da(M&0-M,125613361)|0)>>>27<<2)>>2]|0;L=(c[425648+((da(D&0-D,125613361)|0)>>>27<<2)>>2]|0)+32|0;y=(M|0)!=0?N:L;L=c[j+((d[b+y+64>>0]|0)<<2)>>2]|0;N=v+(y<<5)|0;J=ea(g[N>>2]);r=v+(y<<5)+4|0;K=ea(g[r>>2]);p=v+(y<<5)+8|0;E=ea(g[p>>2]);F=ea(g[k+(L<<5)>>2]);G=ea(g[k+(L<<5)+4>>2]);T=ea(K+G);G=ea(E+ea(g[k+(L<<5)+8>>2]));g[N>>2]=ea(J+F);g[r>>2]=T;g[p>>2]=G;g[v+(y<<5)+12>>2]=ea(0.0);p=v+(y<<5)+16|0;G=ea(g[p>>2]);r=v+(y<<5)+20|0;T=ea(g[r>>2]);N=v+(y<<5)+24|0;F=ea(g[N>>2]);J=ea(g[k+(L<<5)+16>>2]);E=ea(g[k+(L<<5)+20>>2]);K=ea(T+E);E=ea(F+ea(g[k+(L<<5)+24>>2]));g[p>>2]=ea(G+J);g[r>>2]=K;g[N>>2]=E;g[v+(y<<5)+28>>2]=ea(0.0);y=_Ei(M|0,D|0,-1,-1)|0;M=y&M;D=H&D}while(!((M|0)==0&(D|0)==0))}D=u;M=(c[D+4>>2]|qa)&z;z=u;c[z>>2]=(c[D>>2]|pa)&O;c[z+4>>2]=M;A=t+(f<<5)|0;c[a+0>>2]=c[A+0>>2];c[a+4>>2]=c[A+4>>2];c[a+8>>2]=c[A+8>>2];c[a+12>>2]=c[A+12>>2];B=a+16|0;C=t+(f<<5)+16|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];i=h;return}function Uza(a){a=a|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+176|0;f=d+144|0;h=d+112|0;j=d+80|0;k=d+48|0;l=d+16|0;m=d;n=e[a+26>>1]|0;o=a+(n+144)|0;p=a+8|0;q=a+(((e[p>>1]|0)*432|0)+(e[a+24>>1]|0))|0;r=a+(e[a+10>>1]|0)|0;s=a+32|0;t=ea(g[s>>2]);u=ea(g[a+36>>2]);v=ea(-t);t=ea(-u);u=ea(-ea(g[a+40>>2]));w=ea(g[a+48>>2]);x=ea(g[a+52>>2]);y=ea(-w);w=ea(-x);x=ea(-ea(g[a+56>>2]));g[h>>2]=v;g[h+4>>2]=t;g[h+8>>2]=u;g[h+12>>2]=ea(0.0);g[h+16>>2]=y;g[h+20>>2]=w;g[h+24>>2]=x;g[h+28>>2]=ea(0.0);R1a(f,a+n|0,h);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];s=a+48|0;h=j+16|0;c[s+0>>2]=c[h+0>>2];c[s+4>>2]=c[h+4>>2];c[s+8>>2]=c[h+8>>2];c[s+12>>2]=c[h+12>>2];h=a+128|0;x=ea(g[h>>2]);s=a+132|0;w=ea(g[s>>2]);j=a+136|0;y=ea(g[j>>2]);u=ea(g[f>>2]);t=ea(g[f+4>>2]);v=ea(g[f+8>>2]);z=ea(w+t);w=ea(y+v);g[h>>2]=ea(x+u);g[s>>2]=z;g[j>>2]=w;g[a+140>>2]=ea(0.0);j=a+144|0;w=ea(g[j>>2]);s=h+20|0;z=ea(g[s>>2]);A=a+152|0;x=ea(g[A>>2]);y=ea(g[f+16>>2]);B=ea(g[f+20>>2]);C=ea(g[f+24>>2]);D=ea(z+B);z=ea(x+C);g[j>>2]=ea(w+y);g[s>>2]=D;g[A>>2]=z;g[a+156>>2]=ea(0.0);A=a+(n+288)|0;n=c[A>>2]|0;s=c[A+4>>2]|0;if(!((n|0)==0&(s|0)==0)){A=s;s=n;do{n=c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|0;j=(c[425648+((da(A&0-A,125613361)|0)>>>27<<2)>>2]|0)+32|0;f=(s|0)!=0?n:j;j=h+((e[p>>1]|0)<<5)|0;n=j+(f<<5)|0;z=ea(g[n>>2]);E=j+(f<<5)+4|0;D=ea(g[E>>2]);F=j+(f<<5)+8|0;w=ea(D+t);D=ea(ea(g[F>>2])+v);g[n>>2]=ea(z+u);g[E>>2]=w;g[F>>2]=D;g[j+(f<<5)+12>>2]=ea(0.0);F=j+(f<<5)+16|0;D=ea(g[F>>2]);E=j+(f<<5)+20|0;w=ea(g[E>>2]);n=j+(f<<5)+24|0;z=ea(w+B);w=ea(ea(g[n>>2])+C);g[F>>2]=ea(D+y);g[E>>2]=z;g[n>>2]=w;g[j+(f<<5)+28>>2]=ea(0.0);f=_Ei(s|0,A|0,-1,-1)|0;s=f&s;A=H&A}while(!((s|0)==0&(A|0)==0))}A=b[p>>1]|0;if((A&65535)<=1){G=a+16|0;I=G;J=I;c[J>>2]=0;K=I+4|0;L=K;c[L>>2]=0;i=d;return}s=l+16|0;f=k+4|0;j=k+8|0;n=k+16|0;E=k+20|0;F=k+24|0;M=A&65535;A=1;do{Z1a(k,o+(A*160|0)|0,r+(A<<5)|0,h+(M<<6)+(A<<4)|0,h+(M<<5)+(A<<5)|0,q+(A*96|0)|0);N=h+((e[p>>1]|0)<<5)|0;O=N+(A<<5)|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0;c[O+0>>2]=c[l+0>>2];c[O+4>>2]=c[l+4>>2];c[O+8>>2]=c[l+8>>2];c[O+12>>2]=c[l+12>>2];O=N+(A<<5)+16|0;c[O+0>>2]=c[s+0>>2];c[O+4>>2]=c[s+4>>2];c[O+8>>2]=c[s+8>>2];c[O+12>>2]=c[s+12>>2];O=h+((e[p>>1]|0)<<6)+(A<<4)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[O+0>>2]=c[m+0>>2];c[O+4>>2]=c[m+4>>2];c[O+8>>2]=c[m+8>>2];c[O+12>>2]=c[m+12>>2];O=h+(A<<5)|0;y=ea(g[O>>2]);N=h+(A<<5)+4|0;C=ea(g[N>>2]);P=h+(A<<5)+8|0;B=ea(g[P>>2]);u=ea(g[k>>2]);v=ea(g[f>>2]);t=ea(g[j>>2]);w=ea(C+v);C=ea(B+t);g[O>>2]=ea(y+u);g[N>>2]=w;g[P>>2]=C;g[h+(A<<5)+12>>2]=ea(0.0);P=h+(A<<5)+16|0;C=ea(g[P>>2]);N=h+(A<<5)+20|0;w=ea(g[N>>2]);O=h+(A<<5)+24|0;y=ea(g[O>>2]);B=ea(g[n>>2]);z=ea(g[E>>2]);D=ea(g[F>>2]);x=ea(w+z);w=ea(y+D);g[P>>2]=ea(C+B);g[N>>2]=x;g[O>>2]=w;g[h+(A<<5)+28>>2]=ea(0.0);O=o+(A*160|0)+144|0;N=c[O>>2]|0;P=c[O+4>>2]|0;if(!((N|0)==0&(P|0)==0)){O=N;N=P;do{P=c[425648+((da(O&0-O,125613361)|0)>>>27<<2)>>2]|0;Q=(c[425648+((da(N&0-N,125613361)|0)>>>27<<2)>>2]|0)+32|0;R=(O|0)!=0?P:Q;Q=h+((e[p>>1]|0)<<5)|0;P=Q+(R<<5)|0;w=ea(g[P>>2]);S=Q+(R<<5)+4|0;x=ea(g[S>>2]);T=Q+(R<<5)+8|0;C=ea(x+v);x=ea(ea(g[T>>2])+t);g[P>>2]=ea(w+u);g[S>>2]=C;g[T>>2]=x;g[Q+(R<<5)+12>>2]=ea(0.0);T=Q+(R<<5)+16|0;x=ea(g[T>>2]);S=Q+(R<<5)+20|0;C=ea(g[S>>2]);P=Q+(R<<5)+24|0;w=ea(C+z);C=ea(ea(g[P>>2])+D);g[T>>2]=ea(x+B);g[S>>2]=w;g[P>>2]=C;g[Q+(R<<5)+28>>2]=ea(0.0);R=_Ei(O|0,N|0,-1,-1)|0;O=R&O;N=H&N}while(!((O|0)==0&(N|0)==0))}A=A+1|0;M=e[p>>1]|0}while(A>>>0<M>>>0);G=a+16|0;I=G;J=I;c[J>>2]=0;K=I+4|0;L=K;c[L>>2]=0;i=d;return}function Vza(){return}function Wza(){return}function Xza(d,e,f,h,j,k,l,m,n,o){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=0,R=Im,T=0,U=Im,V=0,W=Im,X=0,Y=0,Z=Im,_=0,$=0,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=0,ua=0,va=0,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;e=i;i=i+16|0;d=e;g[d>>2]=l;p=h+8|0;q=c[p>>2]|0;q=f+384|0;r=f+4480|0;c[r>>2]=0;s=c[p>>2]|0;if(s){l=ea(g[s>>2]);t=ea(g[s+4>>2]);u=ea(g[s+8>>2]);v=ea(g[s+12>>2]);w=ea(g[s+16>>2]);x=ea(g[s+20>>2]);y=ea(g[s+24>>2]);z=ea(g[s+28>>2]);A=ea(g[s+32>>2]);B=ea(g[s+36>>2]);C=ea(g[s+40>>2]);D=ea(g[s+44>>2]);E=ea(g[s+48>>2]);F=ea(g[s+52>>2]);G=b[s+56>>1]|0;H=a[s+58>>0]|0;I=a[s+59>>0]|0;J=c[s+60>>2]|0;K=s+64|0;c[p>>2]=0;s=h+12|0;b[s>>1]=0;L=ea(-ea(g[k>>2]));M=k+4|0;N=ea(-ea(g[M>>2]));O=k+8|0;P=ea(-ea(g[O>>2]));Q=k+12|0;R=ea(g[Q>>2]);T=j+16|0;U=ea(g[T>>2]);V=k+16|0;W=ea(U-ea(g[V>>2]));X=j+20|0;U=ea(g[X>>2]);Y=k+20|0;Z=ea(U-ea(g[Y>>2]));_=j+24|0;U=ea(g[_>>2]);$=k+24|0;aa=ea(W*ea(2.0));W=ea(Z*ea(2.0));Z=ea(ea(U-ea(g[$>>2]))*ea(2.0));U=ea(ea(R*R)+ea(-.5));ba=ea(ea(ea(aa*L)+ea(W*N))+ea(Z*P));ca=ea(ea(ba*L)+ea(ea(U*aa)+ea(R*ea(ea(Z*N)-ea(W*P)))));fa=ea(ea(ba*N)+ea(ea(U*W)+ea(R*ea(ea(aa*P)-ea(Z*L)))));ga=ea(ea(ea(U*Z)+ea(R*ea(ea(W*L)-ea(aa*N))))+ea(ba*P));ba=ea(g[j>>2]);ha=j+12|0;aa=ea(g[ha>>2]);ia=j+8|0;W=ea(g[ia>>2]);ja=j+4|0;Z=ea(g[ja>>2]);U=ea(-z);ka=ea(-A);la=ea(-B);ma=ea(ea(w-D)*ea(2.0));na=ea(ea(x-E)*ea(2.0));oa=ea(ea(y-F)*ea(2.0));pa=ea(ea(C*C)+ea(-.5));qa=ea(ea(ea(ma*U)+ea(na*ka))+ea(oa*la));ra=ea(ea(ea(pa*oa)+ea(C*ea(ea(na*U)-ea(ma*ka))))+ea(qa*la));sa=ea(S(ea(ca-ea(ea(qa*U)+ea(ea(pa*ma)+ea(C*ea(ea(oa*ka)-ea(na*la))))))));ca=ea(S(ea(fa-ea(ea(qa*ka)+ea(ea(pa*na)+ea(C*ea(ea(ma*la)-ea(oa*U))))))));oa=sa>ca?sa:ca;ca=ea(S(ea(ga-ra)));if((oa>ca?oa:ca)<ea(ea(g[f+8780>>2])*ea(.00999999977))?(ca=ea(ea(ea(ea(v*C)-ea(l*U))-ea(t*ka))-ea(u*la)),oa=ea(ea(ea(t*U)+ea(ea(v*la)+ea(u*C)))-ea(l*ka)),ra=ea(ea(ea(ea(R*aa)-ea(ba*L))-ea(Z*N))-ea(W*P)),ga=ea(ea(ea(Z*L)+ea(ea(aa*P)+ea(R*W)))-ea(ba*N)),sa=ea(S(ea(ea(ea(ea(ea(R*ba)+ea(aa*L))+ea(W*N))-ea(Z*P))-ea(ea(ea(u*ka)+ea(ea(v*U)+ea(l*C)))-ea(t*la))))),ma=ea(S(ea(ea(ea(ea(ba*P)+ea(ea(aa*N)+ea(R*Z)))-ea(W*L))-ea(ea(ea(l*la)+ea(ea(v*ka)+ea(t*C)))-ea(u*U))))),U=sa>ma?sa:ma,ma=ea(S(ea(ga-oa))),oa=U>ma?U:ma,ma=ea(S(ea(ra-ca))),(oa>ma?oa:ma)<ea(.00999999977)):0){ta=G&65535;ua=J+79|0;va=ua&65520;b[s>>1]=va;ua=tAa(f+356|0,va)|0;va=(ua|0)==0|(ua|0)!=(-1|0)?ua:0;c[p>>2]=va;c[r>>2]=ta;if(G<<16>>16){ma=ea(g[k>>2]);oa=ea(ma+ma);ca=ea(g[M>>2]);ra=ea(ca+ca);U=ea(g[O>>2]);ga=ea(U+U);sa=ea(g[Q>>2]);ka=ea(oa*sa);la=ea(ra*sa);L=ea(sa*ga);sa=ea(ma*ra);W=ea(ma*ga);Z=ea(ca*ra);ra=ea(ca*ga);ca=ea(U*ga);ga=ea(ea(ea(1.0)-Z)-ca);U=ea(sa+L);R=ea(W-la);N=ea(sa-L);L=ea(ea(1.0)-ea(ma*oa));oa=ea(L-ca);ca=ea(ra+ka);ma=ea(W+la);la=ea(ra-ka);ka=ea(L-Z);Z=ea(g[V>>2]);L=ea(g[Y>>2]);ra=ea(g[$>>2]);W=ea(g[j>>2]);sa=ea(W+W);aa=ea(g[ja>>2]);P=ea(aa+aa);ba=ea(g[ia>>2]);na=ea(ba+ba);qa=ea(g[ha>>2]);fa=ea(sa*qa);wa=ea(P*qa);xa=ea(qa*na);qa=ea(W*P);ya=ea(W*na);za=ea(aa*P);P=ea(aa*na);aa=ea(ba*na);na=ea(ea(ea(1.0)-za)-aa);ba=ea(qa+xa);Aa=ea(ya-wa);Ba=ea(qa-xa);xa=ea(ea(1.0)-ea(W*sa));sa=ea(xa-aa);aa=ea(P+fa);W=ea(ya+wa);wa=ea(P-fa);fa=ea(xa-za);za=ea(g[T>>2]);xa=ea(g[X>>2]);P=ea(g[_>>2]);ua=I<<24>>24==0;Ca=ta+-1|0;ya=ea(ea(v*v)+ea(-.5));Ca=H<<24>>24==0;Da=K;Ea=q;Fa=0;Ga=0;while(1){if((Fa|0)==0|ua){Ha=Da;Ia=Da+12|0}else{Ha=Ga;Ia=Da}Ja=Ia+16|0;qa=ea(g[Ia+12>>2]);Ka=ea(g[Ia>>2]);La=ea(g[Ia+4>>2]);Ma=ea(g[Ia+8>>2]);Na=ea(ea(Ka-w)*ea(2.0));Oa=ea(ea(La-x)*ea(2.0));Pa=ea(ea(Ma-y)*ea(2.0));Qa=ea(ea(ea(l*Na)+ea(t*Oa))+ea(u*Pa));Ra=ea(ea(l*Qa)+ea(ea(ya*Na)-ea(v*ea(ea(t*Pa)-ea(u*Oa)))));Sa=ea(ea(t*Qa)+ea(ea(ya*Oa)-ea(v*ea(ea(u*Na)-ea(l*Pa)))));Ta=ea(ea(ea(ya*Pa)-ea(v*ea(ea(l*Oa)-ea(t*Na))))+ea(u*Qa));Qa=ea(za+ea(ea(W*Ta)+ea(ea(na*Ra)+ea(Ba*Sa))));Na=ea(xa+ea(ea(wa*Ta)+ea(ea(ba*Ra)+ea(sa*Sa))));Oa=ea(P+ea(ea(fa*Ta)+ea(ea(Aa*Ra)+ea(aa*Sa))));Sa=ea(ea(Ka-D)*ea(2.0));Ka=ea(ea(La-E)*ea(2.0));La=ea(ea(Ma-F)*ea(2.0));Ma=ea(ea(ea(z*Sa)+ea(A*Ka))+ea(B*La));Ra=ea(ea(z*Ma)+ea(ea(pa*Sa)-ea(C*ea(ea(A*La)-ea(B*Ka)))));Ta=ea(ea(A*Ma)+ea(ea(pa*Ka)-ea(C*ea(ea(B*Sa)-ea(z*La)))));Pa=ea(ea(ea(pa*La)-ea(C*ea(ea(z*Ka)-ea(A*Sa))))+ea(B*Ma));Ma=ea(Z+ea(ea(ma*Pa)+ea(ea(ga*Ra)+ea(N*Ta))));Sa=ea(L+ea(ea(la*Pa)+ea(ea(U*Ra)+ea(oa*Ta))));Ka=ea(ra+ea(ea(ka*Pa)+ea(ea(R*Ra)+ea(ca*Ta))));Ta=ea(Qa-Ma);Ra=ea(Na-Sa);Pa=ea(Oa-Ka);g[Ea>>2]=ea(g[Ha>>2]);Ua=Ha+4|0;g[Ea+4>>2]=ea(g[Ua>>2]);Va=Ha+8|0;g[Ea+8>>2]=ea(g[Va>>2]);La=ea(ea(Na+Sa)*ea(.5));Sa=ea(ea(Oa+Ka)*ea(.5));g[Ea+16>>2]=ea(ea(Qa+Ma)*ea(.5));g[Ea+20>>2]=La;g[Ea+24>>2]=Sa;Sa=ea(ea(g[Ha>>2])*Ta);Ta=ea(Sa+ea(ea(g[Ua>>2])*Ra));g[Ea+12>>2]=ea(qa+ea(ea(ea(g[Va>>2])*Pa)+Ta));if(Ca){c[Ea+48>>2]=-1;c[Ea+52>>2]=-1;Wa=Ja}else{c[Ea+48>>2]=c[Ja>>2];c[Ea+52>>2]=c[Ia+20>>2];Wa=Ia+24|0}Fa=Fa+1|0;if((Fa|0)==(ta|0))break;else{Da=Wa;Ea=Ea+64|0;Ga=Ha}}}if(!va){i=e;return}g[va>>2]=l;g[va+4>>2]=t;g[va+8>>2]=u;g[va+12>>2]=v;g[va+16>>2]=w;g[va+20>>2]=x;g[va+24>>2]=y;g[va+28>>2]=z;g[va+32>>2]=A;g[va+36>>2]=B;g[va+40>>2]=C;g[va+44>>2]=D;g[va+48>>2]=E;g[va+52>>2]=F;b[va+56>>1]=G;a[va+58>>0]=H;a[va+59>>0]=I;c[va+60>>2]=J;YEi(va+64|0,K|0,J|0)|0;i=e;return}else{Xa=ja;Ya=ia;Za=ha;_a=T;$a=X;ab=_;bb=k;cb=M;db=O;eb=Q;fb=V;gb=Y;hb=$;ib=j;jb=s;kb=I}}else{c[p>>2]=0;I=h+12|0;b[I>>1]=0;Xa=j+4|0;Ya=j+8|0;Za=j+12|0;_a=j+16|0;$a=j+20|0;ab=j+24|0;bb=k;cb=k+4|0;db=k+8|0;eb=k+12|0;fb=k+16|0;gb=k+20|0;hb=k+24|0;ib=j;jb=I;kb=0}gn[m&127](n,o,j,k,d,h,q)|0;F=ea(g[ib>>2]);E=ea(g[Xa>>2]);D=ea(g[Ya>>2]);C=ea(g[Za>>2]);B=ea(g[_a>>2]);A=ea(g[$a>>2]);z=ea(g[ab>>2]);y=ea(g[bb>>2]);x=ea(g[cb>>2]);w=ea(g[db>>2]);v=ea(g[eb>>2]);u=ea(g[fb>>2]);t=ea(g[gb>>2]);l=ea(g[hb>>2]);hb=c[r>>2]|0;if(!hb){b[jb>>1]=64;r=tAa(f+356|0,64)|0;c[p>>2]=r;gb=r;if((gb|0)==-1){c[p>>2]=0;i=e;return}else if(!gb){i=e;return}else{g[r>>2]=F;g[r+4>>2]=E;g[r+8>>2]=D;g[r+12>>2]=C;g[r+16>>2]=B;g[r+20>>2]=A;g[r+24>>2]=z;g[r+28>>2]=y;g[r+32>>2]=x;g[r+36>>2]=w;g[r+40>>2]=v;g[r+44>>2]=u;g[r+48>>2]=t;g[r+52>>2]=l;b[r+56>>1]=0;a[r+58>>0]=0;a[r+59>>0]=kb;c[r+60>>2]=0;i=e;return}}if((c[f+432>>2]|0)==-1)lb=(c[f+436>>2]|0)!=-1;else lb=1;r=hb&65535;kb=lb&1;ca=ea(g[q>>2]);q=f+388|0;R=ea(g[q>>2]);gb=f+392|0;ka=ea(g[gb>>2]);a:do if(hb>>>0>1){fb=1;while(1){if(ea(g[f+(fb<<6)+384>>2])!=ca)break;if(ea(g[f+(fb<<6)+388>>2])!=R)break;if(ea(g[f+(fb<<6)+392>>2])!=ka)break;fb=fb+1|0;if(fb>>>0>=hb>>>0){mb=31;break a}}nb=0;ob=da(lb?36:28,hb)|0;pb=1}else mb=31;while(0);if((mb|0)==31){nb=1;ob=(da(lb?24:16,hb)|0)+12|0;pb=0}mb=f+356|0;fb=ob+79&65520;b[jb>>1]=fb;eb=tAa(mb,fb)|0;fb=(eb|0)==0|(eb|0)!=(-1|0)?eb:0;c[p>>2]=fb;if(!fb){b[jb>>1]=64;jb=tAa(mb,64)|0;c[p>>2]=jb;mb=jb;if((mb|0)==-1){c[p>>2]=0;i=e;return}else if(!mb){i=e;return}else{g[jb>>2]=F;g[jb+4>>2]=E;g[jb+8>>2]=D;g[jb+12>>2]=C;g[jb+16>>2]=B;g[jb+20>>2]=A;g[jb+24>>2]=z;g[jb+28>>2]=y;g[jb+32>>2]=x;g[jb+36>>2]=w;g[jb+40>>2]=v;g[jb+44>>2]=u;g[jb+48>>2]=t;g[jb+52>>2]=l;b[jb+56>>1]=0;a[jb+58>>0]=kb;a[jb+59>>0]=nb;c[jb+60>>2]=0;i=e;return}}g[fb>>2]=F;g[fb+4>>2]=E;g[fb+8>>2]=D;g[fb+12>>2]=C;g[fb+16>>2]=B;g[fb+20>>2]=A;g[fb+24>>2]=z;g[fb+28>>2]=y;g[fb+32>>2]=x;g[fb+36>>2]=w;g[fb+40>>2]=v;g[fb+44>>2]=u;g[fb+48>>2]=t;g[fb+52>>2]=l;b[fb+56>>1]=r;a[fb+58>>0]=kb;a[fb+59>>0]=nb;c[fb+60>>2]=ob;ob=fb+64|0;if(pb)if(lb){pb=ob;fb=0;while(1){g[pb>>2]=ea(g[f+(fb<<6)+384>>2]);g[pb+4>>2]=ea(g[f+(fb<<6)+388>>2]);g[pb+8>>2]=ea(g[f+(fb<<6)+392>>2]);g[pb+12>>2]=ea(g[f+(fb<<6)+400>>2]);g[pb+16>>2]=ea(g[f+(fb<<6)+404>>2]);g[pb+20>>2]=ea(g[f+(fb<<6)+408>>2]);g[pb+24>>2]=ea(g[f+(fb<<6)+396>>2]);c[pb+28>>2]=c[f+(fb<<6)+432>>2];c[pb+32>>2]=c[f+(fb<<6)+436>>2];fb=fb+1|0;if((fb|0)==(hb|0))break;else pb=pb+36|0}i=e;return}else{pb=ob;fb=0;while(1){g[pb>>2]=ea(g[f+(fb<<6)+384>>2]);g[pb+4>>2]=ea(g[f+(fb<<6)+388>>2]);g[pb+8>>2]=ea(g[f+(fb<<6)+392>>2]);g[pb+12>>2]=ea(g[f+(fb<<6)+400>>2]);g[pb+16>>2]=ea(g[f+(fb<<6)+404>>2]);g[pb+20>>2]=ea(g[f+(fb<<6)+408>>2]);g[pb+24>>2]=ea(g[f+(fb<<6)+396>>2]);fb=fb+1|0;if((fb|0)==(hb|0))break;else pb=pb+28|0}i=e;return}if(lb){lb=ob;pb=0;while(1){if(!pb){g[lb>>2]=ea(g[f+384>>2]);g[lb+4>>2]=ea(g[q>>2]);g[lb+8>>2]=ea(g[gb>>2]);qb=lb+12|0}else qb=lb;g[qb>>2]=ea(g[f+(pb<<6)+400>>2]);g[qb+4>>2]=ea(g[f+(pb<<6)+404>>2]);g[qb+8>>2]=ea(g[f+(pb<<6)+408>>2]);g[qb+12>>2]=ea(g[f+(pb<<6)+396>>2]);c[qb+16>>2]=c[f+(pb<<6)+432>>2];c[qb+20>>2]=c[f+(pb<<6)+436>>2];pb=pb+1|0;if((pb|0)==(hb|0))break;else lb=qb+24|0}i=e;return}else{qb=ob;ob=0;while(1){if(!ob){g[qb>>2]=ea(g[f+384>>2]);g[qb+4>>2]=ea(g[q>>2]);g[qb+8>>2]=ea(g[gb>>2]);rb=qb+12|0}else rb=qb;g[rb>>2]=ea(g[f+(ob<<6)+400>>2]);g[rb+4>>2]=ea(g[f+(ob<<6)+404>>2]);g[rb+8>>2]=ea(g[f+(ob<<6)+408>>2]);g[rb+12>>2]=ea(g[f+(ob<<6)+396>>2]);ob=ob+1|0;if((ob|0)==(hb|0))break;else qb=rb+16|0}i=e;return}}function Yza(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=ea(i);j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);return ea(3402823469999999843913219.0e14)}function Zza(a,d,e){a=a|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;h=a+8724|0;j=c[h>>2]|0;k=c[a+4480>>2]|0;l=k-d|0;if((j|0)==32){m=0;i=f;return m|0}if((k|0)!=(d|0)){k=a+(j*12|0)+4496|0;n=j+1|0;o=c[a+(d<<6)+432>>2]|0;p=c[a+(d<<6)+436>>2]&65535;b[k>>1]=d;b[a+(j*12|0)+4498>>1]=1;b[a+(j*12|0)+4500>>1]=0;b[a+(j*12|0)+4504>>1]=o;b[a+(j*12|0)+4506>>1]=o>>>16;b[a+(j*12|0)+4502>>1]=p;if(l>>>0>1){p=n;o=1;q=k;k=1;r=0;while(1){s=k+d|0;t=r+d|0;u=c[a+(s<<6)+432>>2]|0;if(((u|0)==(c[a+(t<<6)+432>>2]|0)?(c[a+(s<<6)+436>>2]|0)==(c[a+(t<<6)+436>>2]|0):0)?(v=ea(g[a+(s<<6)+384>>2]),w=ea(v*ea(g[a+(t<<6)+384>>2])),v=ea(g[a+(s<<6)+388>>2]),x=ea(w+ea(v*ea(g[a+(t<<6)+388>>2]))),v=ea(g[a+(s<<6)+392>>2]),ea(x+ea(v*ea(g[a+(t<<6)+392>>2])))>=e):0){y=p;z=o+1<<16>>16;A=q;B=r}else{if((p|0)==64){m=0;C=14;break}b[q+2>>1]=o;t=a+(p*12|0)+4496|0;D=c[a+(s<<6)+436>>2]&65535;b[t>>1]=s;b[a+(p*12|0)+4498>>1]=1;b[a+(p*12|0)+4500>>1]=0;b[a+(p*12|0)+4504>>1]=u;b[a+(p*12|0)+4506>>1]=u>>>16;b[a+(p*12|0)+4502>>1]=D;y=p+1|0;z=1;A=t;B=k}k=k+1|0;if(k>>>0>=l>>>0)break;else{p=y;o=z;q=A;r=B}}if((C|0)==14){i=f;return m|0}if(z<<16>>16==1)E=y;else{b[A+2>>1]=z;E=y}}else E=n}else E=j;c[h>>2]=E;m=1;i=f;return m|0}function _za(a,d,e,f){a=a|0;d=d|0;e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;j=a+1792|0;k=c[j>>2]|0;l=c[d+4096>>2]|0;m=l-f|0;if((k|0)==32){n=0;i=h;return n|0}if((l|0)!=(f|0)){l=a+(k*12|0)|0;o=k+1|0;p=c[d+(f<<6)+48>>2]|0;q=c[d+(f<<6)+52>>2]&65535;b[l>>1]=f;b[a+(k*12|0)+2>>1]=1;b[a+(k*12|0)+4>>1]=0;b[a+(k*12|0)+8>>1]=p;b[a+(k*12|0)+10>>1]=p>>>16;b[a+(k*12|0)+6>>1]=q;if(m>>>0>1){q=f+-1|0;p=o;r=1;s=l;l=1;while(1){t=l+f|0;u=q+l|0;v=ea(g[d+(t<<6)>>2]);w=ea(v*ea(g[d+(u<<6)>>2]));v=ea(g[d+(t<<6)+4>>2]);x=ea(w+ea(v*ea(g[d+(u<<6)+4>>2])));v=ea(g[d+(t<<6)+8>>2]);if((ea(x+ea(v*ea(g[d+(u<<6)+8>>2])))>=e?(c[d+(t<<6)+48>>2]|0)==(c[d+(u<<6)+48>>2]|0):0)?(c[d+(t<<6)+52>>2]|0)==(c[d+(u<<6)+52>>2]|0):0){y=p;z=r+1<<16>>16;A=s}else{if((p|0)==64){n=0;B=15;break}b[s+2>>1]=r;u=a+(p*12|0)|0;C=c[d+(t<<6)+48>>2]|0;D=c[d+(t<<6)+52>>2]&65535;b[u>>1]=t;b[a+(p*12|0)+2>>1]=1;b[a+(p*12|0)+4>>1]=0;b[a+(p*12|0)+8>>1]=C;b[a+(p*12|0)+10>>1]=C>>>16;b[a+(p*12|0)+6>>1]=D;y=p+1|0;z=1;A=u}l=l+1|0;if(l>>>0>=m>>>0)break;else{p=y;r=z;s=A}}if((B|0)==15){i=h;return n|0}if(z<<16>>16==1)E=y;else{b[A+2>>1]=z;E=y}}else E=o}else E=k;c[j>>2]=E;n=1;i=h;return n|0}function $za(d,f,h,j,k,l,m){d=d|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=Im,S=Im,T=Im,U=0,V=0,W=0,X=0;n=i;o=d+4232|0;p=c[o>>2]|0;if((p+1|0)>>>0>m>>>0){q=m;do{c[d+(q<<2)+3968>>2]=65535;c[d+(q<<2)+3840>>2]=0;q=q+1|0;r=c[o>>2]|0}while(q>>>0<(r+1|0)>>>0);s=r}else s=p;p=d+4228|0;q=c[p>>2]|0;if(q>>>0<=l>>>0){t=0;i=n;return t|0}r=h+12|0;u=h+4|0;v=h+8|0;w=j+12|0;x=j+4|0;y=j+8|0;z=q;q=s;s=l;l=0;while(1){A=e[d+(s*12|0)>>1]|0;B=ea(g[f+(A<<6)>>2]);C=ea(g[f+(A<<6)+4>>2]);D=ea(B*ea(2.0));B=ea(C*ea(2.0));C=ea(ea(g[f+(A<<6)+8>>2])*ea(2.0));E=ea(g[r>>2]);F=ea(ea(E*E)+ea(-.5));G=ea(g[h>>2]);H=ea(D*G);I=ea(g[u>>2]);J=ea(H+ea(B*I));H=ea(g[v>>2]);K=ea(J+ea(C*H));J=ea(ea(G*K)+ea(ea(D*F)-ea(E*ea(ea(C*I)-ea(B*H)))));L=ea(ea(I*K)+ea(ea(B*F)-ea(E*ea(ea(D*H)-ea(C*G)))));M=ea(ea(ea(C*F)-ea(E*ea(ea(B*G)-ea(D*I))))+ea(H*K));a:do if(q>>>0>m>>>0){A=d+(s*12|0)+8|0;N=d+(s*12|0)+10|0;O=m;while(1){K=ea(J*ea(g[d+(O*96|0)+792>>2]));H=ea(K+ea(L*ea(g[d+(O*96|0)+796>>2])));if((!(ea(H+ea(M*ea(g[d+(O*96|0)+800>>2])))<k)?(b[d+(O*96|0)+788>>1]|0)==(b[A>>1]|0):0)?(b[d+(O*96|0)+786>>1]|0)==(b[N>>1]|0):0){P=O;break a}Q=O+1|0;if(Q>>>0<q>>>0)O=Q;else{P=Q;break}}}else P=m;while(0);if((P|0)==(q|0))if(!(l|(q|0)==32)){b[d+(q<<2)+4100>>1]=-1;b[d+(c[o>>2]<<2)+4102>>1]=-1;O=c[o>>2]|0;c[o>>2]=O+1;H=ea(g[w>>2]);K=ea(ea(H*H)+ea(-.5));I=ea(g[j>>2]);G=ea(D*I);E=ea(g[x>>2]);F=ea(G+ea(B*E));G=ea(g[y>>2]);R=ea(F+ea(C*G));F=ea(ea(I*R)+ea(ea(D*K)-ea(H*ea(ea(C*E)-ea(B*G)))));S=ea(ea(E*R)+ea(ea(B*K)-ea(H*ea(ea(D*G)-ea(C*I)))));T=ea(ea(ea(C*K)-ea(H*ea(ea(B*I)-ea(D*E))))+ea(G*R));N=b[d+(s*12|0)+8>>1]|0;A=b[d+(s*12|0)+10>>1]|0;Q=b[d+(s*12|0)+6>>1]|0;g[d+(O*96|0)+792>>2]=J;g[d+(O*96|0)+796>>2]=L;g[d+(O*96|0)+800>>2]=M;g[d+(O*96|0)+804>>2]=F;g[d+(O*96|0)+808>>2]=S;g[d+(O*96|0)+812>>2]=T;b[d+(O*96|0)+784>>1]=0;a[d+(O*96|0)+768>>0]=0;b[d+(O*96|0)+788>>1]=N;b[d+(O*96|0)+786>>1]=A;b[d+(O*96|0)+790>>1]=Q;Q=q+1|0;if(Q>>>0<32){c[d+(Q<<2)+3840>>2]=0;c[d+(Q<<2)+3968>>2]=65535;U=0;V=15}else{U=0;V=15}}else{W=z;X=1}else{U=l;V=15}if((V|0)==15){V=0;Q=d+(P<<2)+3968|0;b[d+(s*12|0)+4>>1]=c[Q>>2];c[Q>>2]=s;Q=d+(P<<2)+3840|0;c[Q>>2]=(c[Q>>2]|0)+(e[d+(s*12|0)+2>>1]|0);W=c[p>>2]|0;X=U}Q=s+1|0;if(Q>>>0>=W>>>0){t=X;break}z=W;q=c[o>>2]|0;s=Q;l=X}i=n;return t|0}function aAa(a,d,f,h,j,k,l,m){a=a|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=i;f=a+1796|0;n=c[f>>2]|0;o=a+1792|0;p=c[o>>2]|0;if(p>>>0>l>>>0){q=p;r=n;s=l;t=0}else{u=n;v=0;c[f>>2]=u;i=h;return v|0}while(1){n=e[a+(s*12|0)>>1]|0;w=ea(g[d+(n<<6)>>2]);x=ea(g[d+(n<<6)+4>>2]);y=ea(g[d+(n<<6)+8>>2]);n=a+(s*12|0)+2|0;l=e[n>>1]|0;p=da(l,k)|0;a:do if(r>>>0>m>>>0){z=a+(s*12|0)+8|0;A=a+(s*12|0)+10|0;B=m;while(1){C=ea(w*ea(g[a+(B*20|0)+768>>2]));D=ea(C+ea(x*ea(g[a+(B*20|0)+772>>2])));if((!(ea(D+ea(y*ea(g[a+(B*20|0)+776>>2])))<j)?(b[a+(B*20|0)+780>>1]|0)==(b[z>>1]|0):0)?(b[a+(B*20|0)+782>>1]|0)==(b[A>>1]|0):0){E=B;break a}F=B+1|0;if(F>>>0<r>>>0)B=F;else{E=F;break}}}else E=m;while(0);if((E|0)==(r|0))if(t|(r|0)==32){G=q;H=r;I=1}else{b[a+(r*20|0)+784>>1]=p&255;g[a+(r*20|0)+768>>2]=w;g[a+(r*20|0)+772>>2]=x;g[a+(r*20|0)+776>>2]=y;c[a+(r<<2)+1408>>2]=e[n>>1];b[a+(r*20|0)+780>>1]=b[a+(s*12|0)+8>>1]|0;b[a+(r*20|0)+782>>1]=b[a+(s*12|0)+10>>1]|0;b[a+(r*20|0)+786>>1]=b[a+(s*12|0)+6>>1]|0;b[a+(r<<2)+1664>>1]=-1;b[a+(r<<2)+1666>>1]=-1;b[a+(s*12|0)+4>>1]=-1;J=a+(E<<2)+1536|0;K=r+1|0;L=0;M=12}else{B=a+(E*20|0)+784|0;b[B>>1]=(e[B>>1]|0)+(p&255);B=a+(E<<2)+1408|0;c[B>>2]=(c[B>>2]|0)+l;B=a+(E<<2)+1536|0;b[a+(s*12|0)+4>>1]=c[B>>2];J=B;K=r;L=t;M=12}if((M|0)==12){M=0;c[J>>2]=s;G=c[o>>2]|0;H=K;I=L}s=s+1|0;if(s>>>0>=G>>>0){u=H;v=I;break}else{q=G;r=H;t=I}}c[f>>2]=u;i=h;return v|0}function bAa(a,d,f,h,j,k,l){a=a|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=0;m=i;i=i+32|0;n=m;o=a+4232|0;p=c[o>>2]|0;if(p>>>0<=k>>>0){i=m;return}q=f+12|0;r=f+4|0;s=f+8|0;t=f+16|0;u=f+20|0;v=f+24|0;w=n+4|0;x=n+8|0;y=h+16|0;z=h+20|0;A=h+24|0;B=h+12|0;C=h+4|0;D=h+8|0;E=n+12|0;F=n+16|0;G=n+20|0;H=p;p=k;while(1){k=a+(p*96|0)+784|0;I=b[k>>1]|0;if(I<<16>>16!=2?(J=c[a+(p<<2)+3968>>2]|0,(J|0)!=65535):0){if(I<<16>>16==1){j=ea(ea(g[a+(p*96|0)+816>>2])*ea(2.0));K=ea(ea(g[a+(p*96|0)+820>>2])*ea(2.0));L=ea(ea(g[a+(p*96|0)+824>>2])*ea(2.0));M=ea(g[q>>2]);N=ea(ea(M*M)+ea(-.5));O=ea(g[f>>2]);P=ea(j*O);Q=ea(g[r>>2]);R=ea(P+ea(K*Q));P=ea(g[s>>2]);S=ea(R+ea(L*P));R=ea(ea(O*S)+ea(ea(j*N)+ea(M*ea(ea(L*Q)-ea(K*P)))));T=ea(ea(Q*S)+ea(ea(K*N)+ea(M*ea(ea(j*P)-ea(L*O)))));U=ea(ea(ea(L*N)+ea(M*ea(ea(K*O)-ea(j*Q))))+ea(P*S));S=ea(ea(g[t>>2])+R);R=ea(ea(g[u>>2])+T);T=ea(ea(g[v>>2])+U);g[n>>2]=S;g[w>>2]=R;g[x>>2]=T;V=1}else V=0;I=a+(p<<2)+4102|0;W=a+(p<<2)+4100|0;X=V;Y=J;T=ea(0.0);while(1){J=a+(Y*12|0)+2|0;if(!(b[J>>1]|0)){Z=X;_=T}else{$=a+(Y*12|0)|0;aa=X;ba=0;R=T;while(1){ca=(e[$>>1]|0)+(ba&65535)|0;da=d+(ca<<6)+16|0;do if(ea(g[d+(ca<<6)+12>>2])<l){fa=aa&65535;if(!fa){b[W>>1]=ca;g[n>>2]=ea(g[da>>2]);g[w>>2]=ea(g[d+(ca<<6)+20>>2]);g[x>>2]=ea(g[d+(ca<<6)+24>>2]);ga=aa+1<<16>>16;ha=R;break}else if((fa|0)!=1){S=ea(g[da>>2]);U=ea(S-ea(g[n>>2]));P=ea(g[d+(ca<<6)+20>>2]);Q=ea(P-ea(g[w>>2]));j=ea(g[d+(ca<<6)+24>>2]);O=ea(j-ea(g[x>>2]));K=ea(ea(ea(U*U)+ea(Q*Q))+ea(O*O));O=ea(S-ea(g[E>>2]));Q=ea(P-ea(g[F>>2]));U=ea(j-ea(g[G>>2]));M=ea(ea(ea(O*O)+ea(Q*Q))+ea(U*U));if(K>M){if(!(K>R)){ga=aa;ha=R;break}b[I>>1]=ca;g[E>>2]=S;g[F>>2]=P;g[G>>2]=j;ga=aa;ha=K;break}else{if(!(M>R)){ga=aa;ha=R;break}b[W>>1]=ca;g[n>>2]=S;g[w>>2]=P;g[x>>2]=j;ga=aa;ha=M;break}}else{M=ea(g[da>>2]);j=ea(M-ea(g[n>>2]));P=ea(g[d+(ca<<6)+20>>2]);S=ea(P-ea(g[w>>2]));K=ea(g[d+(ca<<6)+24>>2]);U=ea(K-ea(g[x>>2]));Q=ea(ea(ea(j*j)+ea(S*S))+ea(U*U));if(!(Q>ea(.000625000044))){ga=aa;ha=Q;break}b[I>>1]=ca;g[E>>2]=M;g[F>>2]=P;g[G>>2]=K;ga=aa+1<<16>>16;ha=Q;break}}else{ga=aa;ha=R}while(0);ba=ba+1<<16>>16;if((ba&65535)>=(e[J>>1]|0)){Z=ga;_=ha;break}else{aa=ga;R=ha}}}aa=b[a+(Y*12|0)+4>>1]|0;if(aa<<16>>16==-1)break;else{X=Z;Y=aa&65535;T=_}}Y=b[k>>1]|0;if((Y&65535)<(Z&65535)){X=Z&65535;I=Y&65535;do{T=ea(g[n+(I*12|0)>>2]);R=ea(T-ea(g[t>>2]));Q=ea(g[n+(I*12|0)+4>>2]);K=ea(Q-ea(g[u>>2]));P=ea(g[n+(I*12|0)+8>>2]);M=ea(R*ea(2.0));R=ea(K*ea(2.0));K=ea(ea(P-ea(g[v>>2]))*ea(2.0));U=ea(g[q>>2]);S=ea(ea(U*U)+ea(-.5));j=ea(g[f>>2]);O=ea(M*j);N=ea(g[r>>2]);L=ea(O+ea(R*N));O=ea(g[s>>2]);ia=ea(L+ea(K*O));L=ea(ea(N*ia)+ea(ea(R*S)-ea(U*ea(ea(M*O)-ea(K*j)))));ja=ea(ea(ea(K*S)-ea(U*ea(ea(R*j)-ea(M*N))))+ea(O*ia));g[a+(p*96|0)+(I*12|0)+816>>2]=ea(ea(j*ia)+ea(ea(M*S)-ea(U*ea(ea(K*N)-ea(R*O)))));g[a+(p*96|0)+(I*12|0)+820>>2]=L;g[a+(p*96|0)+(I*12|0)+824>>2]=ja;ja=ea(T-ea(g[y>>2]));T=ea(Q-ea(g[z>>2]));Q=ea(ja*ea(2.0));ja=ea(T*ea(2.0));T=ea(ea(P-ea(g[A>>2]))*ea(2.0));P=ea(g[B>>2]);L=ea(ea(P*P)+ea(-.5));O=ea(g[h>>2]);R=ea(Q*O);N=ea(g[C>>2]);K=ea(R+ea(ja*N));R=ea(g[D>>2]);U=ea(K+ea(T*R));K=ea(ea(N*U)+ea(ea(ja*L)-ea(P*ea(ea(Q*R)-ea(T*O)))));S=ea(ea(ea(T*L)-ea(P*ea(ea(ja*O)-ea(Q*N))))+ea(R*U));g[a+(p*96|0)+(I*12|0)+840>>2]=ea(ea(O*U)+ea(ea(Q*L)-ea(P*ea(ea(T*N)-ea(ja*R)))));g[a+(p*96|0)+(I*12|0)+844>>2]=K;g[a+(p*96|0)+(I*12|0)+848>>2]=S;I=I+1|0}while((I|0)!=(X|0))}if(!(Z<<16>>16)){g[a+(p*96|0)+840>>2]=ea(0.0);g[a+(p*96|0)+844>>2]=ea(0.0);g[a+(p*96|0)+848>>2]=ea(0.0);g[a+(p*96|0)+816>>2]=ea(0.0);g[a+(p*96|0)+820>>2]=ea(0.0);g[a+(p*96|0)+824>>2]=ea(0.0)}b[k>>1]=Z;ka=c[o>>2]|0}else ka=H;p=p+1|0;if(p>>>0>=ka>>>0)break;else H=ka}i=m;return}function cAa(a){a=a|0;c[a+4>>2]=0;c[a+8>>2]=0;return}function dAa(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=0;return}function eAa(a,f,g,h){a=a|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;if((e[a+68>>1]|0)<2){k=c[g+4480>>2]|0;if(!k){i=j;return 1}l=a+34|0;m=0;do{b[h+(m<<2)+(f<<1)>>1]=b[l>>1]|0;m=m+1|0}while(m>>>0<k>>>0);i=j;return 1}else{k=c[a+64>>2]|0;m=c[g+4480>>2]|0;if(!m){i=j;return 1}l=c[(c[a+60>>2]|0)+20>>2]|0;a=0;do{n=c[g+(a<<6)+432+(f<<2)>>2]|0;o=n>>>1;b[h+(a<<2)+(f<<1)>>1]=b[k+(((d[((n&1|0)==0?l+(o<<2)+2|0:l+(o<<2)+3|0)>>0]|0)&127)<<1)>>1]|0;a=a+1|0}while(a>>>0<m>>>0);i=j;return 1}return 0}function fAa(a,f,g,h){a=a|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;if((e[f+68>>1]|0)<2){k=c[g+4480>>2]|0;if(!k){i=j;return 1}l=a+34|0;m=f+34|0;n=0;do{b[h+(n<<2)>>1]=b[l>>1]|0;b[h+(n<<2)+2>>1]=b[m>>1]|0;n=n+1|0}while(n>>>0<k>>>0);i=j;return 1}else{k=c[f+64>>2]|0;n=c[g+4480>>2]|0;if(!n){i=j;return 1}m=a+34|0;a=c[(c[f+60>>2]|0)+20>>2]|0;f=0;do{b[h+(f<<2)>>1]=b[m>>1]|0;l=c[g+(f<<6)+436>>2]|0;o=l>>>1;b[h+(f<<2)+2>>1]=b[k+(((d[((l&1|0)==0?a+(o<<2)+2|0:a+(o<<2)+3|0)>>0]|0)&127)<<1)>>1]|0;f=f+1|0}while(f>>>0<n>>>0);i=j;return 1}return 0}function gAa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;j=c[f+4480>>2]|0;k=(j|0)==0;if((e[a+88>>1]|0)<2){if(k){i=h;return 1}l=a+34|0;m=0;do{b[g+(m<<2)+(d<<1)>>1]=b[l>>1]|0;m=m+1|0}while(m>>>0<j>>>0);i=h;return 1}else{if(k){i=h;return 1}k=c[a+80>>2]|0;m=c[a+84>>2]|0;a=0;do{b[g+(a<<2)+(d<<1)>>1]=b[m+((e[k+(c[f+(a<<6)+432+(d<<2)>>2]<<1)>>1]|0)<<1)>>1]|0;a=a+1|0}while(a>>>0<j>>>0);i=h;return 1}return 0}function hAa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=c[f+4480>>2]|0;k=(j|0)==0;if((e[d+88>>1]|0)<2){if(k){i=h;return 1}l=a+34|0;m=d+34|0;n=0;do{b[g+(n<<2)>>1]=b[l>>1]|0;b[g+(n<<2)+2>>1]=b[m>>1]|0;n=n+1|0}while(n>>>0<j>>>0);i=h;return 1}else{if(k){i=h;return 1}k=a+34|0;a=c[d+80>>2]|0;n=c[d+84>>2]|0;d=0;do{b[g+(d<<2)>>1]=b[k>>1]|0;b[g+(d<<2)+2>>1]=b[n+((e[a+(c[f+(d<<6)+436>>2]<<1)>>1]|0)<<1)>>1]|0;d=d+1|0}while(d>>>0<j>>>0);i=h;return 1}return 0}function iAa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=c[e+4480>>2]|0;if(!h){i=g;return 1}e=a+34|0;a=0;do{b[f+(a<<2)+(d<<1)>>1]=b[e>>1]|0;a=a+1|0}while(a>>>0<h>>>0);i=g;return 1}function jAa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=c[e+4480>>2]|0;if(!h){i=g;return 1}e=a+34|0;a=d+34|0;d=0;do{b[f+(d<<2)>>1]=b[e>>1]|0;b[f+(d<<2)+2>>1]=b[a>>1]|0;d=d+1|0}while(d>>>0<h>>>0);i=g;return 1}function kAa(d,f,h,j,k,l,m,n){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0;l=i;i=i+320|0;o=l+32|0;p=l;q=l+60|0;r=l+64|0;if(h>>>0>=j>>>0){s=0;t=0;u=c[m>>2]|0;v=u+t|0;c[m>>2]=v;w=c[n>>2]|0;x=w+s|0;c[n>>2]=x;i=l;return}y=o+4|0;z=o+8|0;A=o+12|0;B=o+16|0;C=o+20|0;D=o+24|0;E=p+4|0;F=p+8|0;G=p+12|0;H=p+16|0;I=p+20|0;J=p+24|0;K=d+4480|0;L=d+8769|0;M=d+384|0;N=h;h=0;O=0;while(1){P=c[f+(N*12|0)>>2]|0;Q=c[P+72>>2]|0;R=c[P+76>>2]|0;S=c[Q+36>>2]|0;T=c[R+36>>2]|0;U=c[P+64>>2]|0;V=c[P+68>>2]|0;W=e[P+22>>1]|0;X=W&32;Y=W&64;W=(T|0)<(S|0);Z=W?R:Q;_=W?Q:R;R=W?T:S;Q=W?S:T;T=W?V:U;S=W?U:V;V=d+(R*28|0)+(Q<<2)+104|0;c[V>>2]=(c[V>>2]|0)+1;if(!((W?Y:X)|0)){$=ea(ea(g[Z+16>>2])*ea(2.0));aa=ea(ea(g[Z+20>>2])*ea(2.0));ba=ea(ea(g[Z+24>>2])*ea(2.0));ca=ea(g[T+12>>2]);da=ea(ea(ca*ca)+ea(-.5));fa=ea(g[T>>2]);ga=ea($*fa);ha=ea(g[T+4>>2]);ia=ea(ga+ea(aa*ha));ga=ea(g[T+8>>2]);ja=ea(ia+ea(ba*ga));ia=ea(ea(fa*ja)+ea(ea($*da)+ea(ca*ea(ea(ba*ha)-ea(aa*ga)))));ka=ea(ea(ha*ja)+ea(ea(aa*da)+ea(ca*ea(ea($*ga)-ea(ba*fa)))));la=ea(ea(ea(ba*da)+ea(ca*ea(ea(aa*fa)-ea($*ha))))+ea(ga*ja));ja=ea(ea(g[T+16>>2])+ia);ia=ea(ea(g[T+20>>2])+ka);ka=ea(ea(g[T+24>>2])+la);la=ea(g[Z>>2]);$=ea(ca*la);aa=ea(g[Z+12>>2]);da=ea($+ea(fa*aa));$=ea(g[Z+8>>2]);ba=ea(da+ea(ha*$));da=ea(g[Z+4>>2]);ma=ka;na=ia;oa=ja;pa=ea(ea(ea(ea(ca*aa)-ea(fa*la))-ea(ha*da))-ea(ga*$));qa=ea(ea(ea(fa*da)+ea(ea(ga*aa)+ea(ca*$)))-ea(ha*la));ra=ea(ea(ea(ga*la)+ea(ea(ha*aa)+ea(ca*da)))-ea(fa*$));sa=ea(ba-ea(ga*da))}else{da=ea(g[T+48>>2]);ga=ea(g[T+52>>2]);ba=ea(da*ea(-2.0));da=ea(ga*ea(-2.0));ga=ea(ea(g[T+56>>2])*ea(-2.0));$=ea(g[T+44>>2]);fa=ea(ea($*$)+ea(-.5));ca=ea(g[T+32>>2]);aa=ea(ba*ca);ha=ea(g[T+36>>2]);la=ea(aa+ea(da*ha));aa=ea(g[T+40>>2]);ja=ea(la+ea(ga*aa));la=ea(-ca);ia=ea(-ha);ka=ea(-aa);ta=ea(ea(ea(ca*ja)+ea(ea(ba*fa)-ea($*ea(ea(ga*ha)-ea(da*aa)))))*ea(2.0));ua=ea(ea(ea(ha*ja)+ea(ea(da*fa)-ea($*ea(ea(ba*aa)-ea(ga*ca)))))*ea(2.0));va=ea(ea(ea(ea(ga*fa)-ea($*ea(ea(da*ca)-ea(ba*ha))))+ea(aa*ja))*ea(2.0));ja=ea(g[T+12>>2]);aa=ea(ea(ja*ja)+ea(-.5));ha=ea(g[T>>2]);ba=ea(ha*ta);ca=ea(g[T+4>>2]);da=ea(ba+ea(ca*ua));ba=ea(g[T+8>>2]);fa=ea(ea(ba*va)+da);da=ea(ea(ha*fa)+ea(ea(aa*ta)+ea(ja*ea(ea(ca*va)-ea(ba*ua)))));ga=ea(ea(ca*fa)+ea(ea(aa*ua)+ea(ja*ea(ea(ba*ta)-ea(ha*va)))));wa=ea(ea(ea(aa*va)+ea(ja*ea(ea(ha*ua)-ea(ca*ta))))+ea(ba*fa));fa=ea(ea(g[T+16>>2])+da);da=ea(ea(g[T+20>>2])+ga);ga=ea(ea(g[T+24>>2])+wa);wa=ea(ea(ea(ea(ja*la)+ea($*ha))+ea(ca*ka))-ea(ba*ia));ta=ea(ea(ea(ba*la)+ea(ea(ja*ia)+ea($*ca)))-ea(ha*ka));ua=ea(ea(ea(ha*ia)+ea(ea(ja*ka)+ea($*ba)))-ea(ca*la));va=ea(ea(ea(ea($*ja)-ea(ha*la))-ea(ca*ia))-ea(ba*ka));ka=ea(ea(g[Z+16>>2])*ea(2.0));ba=ea(ea(g[Z+20>>2])*ea(2.0));ia=ea(ea(g[Z+24>>2])*ea(2.0));ca=ea(ea(va*va)+ea(-.5));la=ea(ea(ea(wa*ka)+ea(ta*ba))+ea(ua*ia));ha=ea(fa+ea(ea(wa*la)+ea(ea(ca*ka)+ea(va*ea(ea(ta*ia)-ea(ua*ba))))));fa=ea(da+ea(ea(ta*la)+ea(ea(ca*ba)+ea(va*ea(ea(ua*ka)-ea(wa*ia))))));da=ea(ga+ea(ea(ea(ca*ia)+ea(va*ea(ea(wa*ba)-ea(ta*ka))))+ea(ua*la)));la=ea(g[Z>>2]);ka=ea(va*la);ba=ea(g[Z+12>>2]);ia=ea(ka+ea(wa*ba));ka=ea(g[Z+8>>2]);ca=ea(ia+ea(ta*ka));ia=ea(g[Z+4>>2]);ma=da;na=fa;oa=ha;pa=ea(ea(ea(ea(va*ba)-ea(wa*la))-ea(ta*ia))-ea(ua*ka));qa=ea(ea(ea(wa*ia)+ea(ea(ua*ba)+ea(va*ka)))-ea(ta*la));ra=ea(ea(ea(ua*la)+ea(ea(ta*ba)+ea(va*ia)))-ea(wa*ka));sa=ea(ca-ea(ua*ia))}g[o>>2]=sa;g[y>>2]=ra;g[z>>2]=qa;g[A>>2]=pa;g[B>>2]=oa;g[C>>2]=na;g[D>>2]=ma;if(!((W?X:Y)|0)){ia=ea(ea(g[_+16>>2])*ea(2.0));ua=ea(ea(g[_+20>>2])*ea(2.0));ca=ea(ea(g[_+24>>2])*ea(2.0));ka=ea(g[S+12>>2]);wa=ea(ea(ka*ka)+ea(-.5));va=ea(g[S>>2]);ba=ea(ia*va);ta=ea(g[S+4>>2]);la=ea(ba+ea(ua*ta));ba=ea(g[S+8>>2]);ha=ea(la+ea(ca*ba));la=ea(ea(va*ha)+ea(ea(ia*wa)+ea(ka*ea(ea(ca*ta)-ea(ua*ba)))));fa=ea(ea(ta*ha)+ea(ea(ua*wa)+ea(ka*ea(ea(ia*ba)-ea(ca*va)))));da=ea(ea(ea(ca*wa)+ea(ka*ea(ea(ua*va)-ea(ia*ta))))+ea(ba*ha));ha=ea(ea(g[S+16>>2])+la);la=ea(ea(g[S+20>>2])+fa);fa=ea(ea(g[S+24>>2])+da);da=ea(g[_>>2]);ia=ea(ka*da);ua=ea(g[_+12>>2]);wa=ea(ia+ea(va*ua));ia=ea(g[_+8>>2]);ca=ea(wa+ea(ta*ia));wa=ea(g[_+4>>2]);xa=fa;ya=la;za=ha;Aa=ea(ea(ea(ea(ka*ua)-ea(va*da))-ea(ta*wa))-ea(ba*ia));Ba=ea(ea(ea(va*wa)+ea(ea(ba*ua)+ea(ka*ia)))-ea(ta*da));Ca=ea(ea(ea(ba*da)+ea(ea(ta*ua)+ea(ka*wa)))-ea(va*ia));Da=ea(ca-ea(ba*wa))}else{wa=ea(g[S+48>>2]);ba=ea(g[S+52>>2]);ca=ea(wa*ea(-2.0));wa=ea(ba*ea(-2.0));ba=ea(ea(g[S+56>>2])*ea(-2.0));ia=ea(g[S+44>>2]);va=ea(ea(ia*ia)+ea(-.5));ka=ea(g[S+32>>2]);ua=ea(ca*ka);ta=ea(g[S+36>>2]);da=ea(ua+ea(wa*ta));ua=ea(g[S+40>>2]);ha=ea(da+ea(ba*ua));da=ea(-ka);la=ea(-ta);fa=ea(-ua);ga=ea(ea(ea(ka*ha)+ea(ea(ca*va)-ea(ia*ea(ea(ba*ta)-ea(wa*ua)))))*ea(2.0));ja=ea(ea(ea(ta*ha)+ea(ea(wa*va)-ea(ia*ea(ea(ca*ua)-ea(ba*ka)))))*ea(2.0));$=ea(ea(ea(ea(ba*va)-ea(ia*ea(ea(wa*ka)-ea(ca*ta))))+ea(ua*ha))*ea(2.0));ha=ea(g[S+12>>2]);ua=ea(ea(ha*ha)+ea(-.5));ta=ea(g[S>>2]);ca=ea(ta*ga);ka=ea(g[S+4>>2]);wa=ea(ca+ea(ka*ja));ca=ea(g[S+8>>2]);va=ea(ea(ca*$)+wa);wa=ea(ea(ta*va)+ea(ea(ua*ga)+ea(ha*ea(ea(ka*$)-ea(ca*ja)))));ba=ea(ea(ka*va)+ea(ea(ua*ja)+ea(ha*ea(ea(ca*ga)-ea(ta*$)))));aa=ea(ea(ea(ua*$)+ea(ha*ea(ea(ta*ja)-ea(ka*ga))))+ea(ca*va));va=ea(ea(g[S+16>>2])+wa);wa=ea(ea(g[S+20>>2])+ba);ba=ea(ea(g[S+24>>2])+aa);aa=ea(ea(ea(ea(ha*da)+ea(ia*ta))+ea(ka*fa))-ea(ca*la));ga=ea(ea(ea(ca*da)+ea(ea(ha*la)+ea(ia*ka)))-ea(ta*fa));ja=ea(ea(ea(ta*la)+ea(ea(ha*fa)+ea(ia*ca)))-ea(ka*da));$=ea(ea(ea(ea(ia*ha)-ea(ta*da))-ea(ka*la))-ea(ca*fa));fa=ea(ea(g[_+16>>2])*ea(2.0));ca=ea(ea(g[_+20>>2])*ea(2.0));la=ea(ea(g[_+24>>2])*ea(2.0));ka=ea(ea($*$)+ea(-.5));da=ea(ea(ea(aa*fa)+ea(ga*ca))+ea(ja*la));ta=ea(va+ea(ea(aa*da)+ea(ea(ka*fa)+ea($*ea(ea(ga*la)-ea(ja*ca))))));va=ea(wa+ea(ea(ga*da)+ea(ea(ka*ca)+ea($*ea(ea(ja*fa)-ea(aa*la))))));wa=ea(ba+ea(ea(ea(ka*la)+ea($*ea(ea(aa*ca)-ea(ga*fa))))+ea(ja*da)));da=ea(g[_>>2]);fa=ea($*da);ca=ea(g[_+12>>2]);la=ea(fa+ea(aa*ca));fa=ea(g[_+8>>2]);ka=ea(la+ea(ga*fa));la=ea(g[_+4>>2]);xa=wa;ya=va;za=ta;Aa=ea(ea(ea(ea($*ca)-ea(aa*da))-ea(ga*la))-ea(ja*fa));Ba=ea(ea(ea(aa*la)+ea(ea(ja*ca)+ea($*fa)))-ea(ga*da));Ca=ea(ea(ea(ja*da)+ea(ea(ga*ca)+ea($*la)))-ea(aa*fa));Da=ea(ka-ea(ja*la))}g[p>>2]=Da;g[E>>2]=Ca;g[F>>2]=Ba;g[G>>2]=Aa;g[H>>2]=za;g[I>>2]=ya;g[J>>2]=xa;S=P+98|0;Y=e[S>>1]&2;c[K>>2]=0;b[S>>1]=0;b[P+20>>1]=0;c[P+24>>2]=0;c[P>>2]=0;b[P+16>>1]=0;c[P+4>>2]=0;c[P+28>>2]=0;c[P+32>>2]=0;X=c[500600+(R*28|0)+(Q<<2)>>2]|0;if((a[L>>0]|0)!=0?(a[500544+(R*7|0)+Q>>0]|0)!=0:0){la=ea(g[Z+28>>2]);Xza(R,Q,d,P+44|0,o,p,ea(la+ea(g[_+28>>2])),X,Z+36|0,_+36|0)}else{la=ea(g[Z+28>>2]);g[q>>2]=ea(la+ea(g[_+28>>2]));gn[X&127](Z+36|0,_+36|0,o,p,q,P+44|0,M)|0}kn[c[501232+(R*28|0)+(Q<<2)>>2]&511](Z,_,d,r)|0;if(W?(c[K>>2]|0)!=0:0){W=0;do{_=d+(W<<6)+384|0;la=ea(-ea(g[_>>2]));Z=d+(W<<6)+388|0;ja=ea(-ea(g[Z>>2]));Q=d+(W<<6)+392|0;ka=ea(-ea(g[Q>>2]));g[_>>2]=la;g[Z>>2]=ja;g[Q>>2]=ka;Q=d+(W<<6)+432|0;Z=d+(W<<6)+436|0;_=c[Q>>2]|0;c[Q>>2]=c[Z>>2];c[Z>>2]=_;_=r+(W<<2)|0;Z=r+(W<<2)+2|0;Q=b[_>>1]|0;b[_>>1]=b[Z>>1]|0;b[Z>>1]=Q;W=W+1|0}while(W>>>0<(c[K>>2]|0)>>>0)}yAa(P,d,r)|0;do if((Y|0)!=(e[S>>1]&2|0)){W=c[f+(N*12|0)+4>>2]|0;Q=k+(W>>>5<<2)|0;c[Q>>2]=1<<(W&31)|c[Q>>2];if(!Y){Ea=h+1|0;Fa=O;break}else{Ea=h;Fa=O+1|0;break}}else{Ea=h;Fa=O}while(0);N=N+1|0;if((N|0)==(j|0)){s=Ea;t=Fa;break}else{h=Ea;O=Fa}}u=c[m>>2]|0;v=u+t|0;c[m>>2]=v;w=c[n>>2]|0;x=w+s|0;c[n>>2]=x;i=l;return}function lAa(f,h,j,k,l,m,n,o){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=0,Ua=0,Va=0;m=i;i=i+320|0;p=m+32|0;q=m;r=m+60|0;s=m+64|0;if(j>>>0>=k>>>0){t=0;u=0;v=c[n>>2]|0;w=v+u|0;c[n>>2]=w;x=c[o>>2]|0;y=x+t|0;c[o>>2]=y;i=m;return}z=f+4496|0;A=p+4|0;B=p+8|0;C=p+12|0;D=p+16|0;E=p+20|0;F=p+24|0;G=q+4|0;I=q+8|0;J=q+12|0;K=q+16|0;L=q+20|0;M=q+24|0;N=f+4480|0;O=f+384|0;P=f+4548|0;Q=z+53|0;R=f+356|0;S=z|1;T=j;j=0;U=0;while(1){V=c[h+(T*12|0)>>2]|0;W=c[V+72>>2]|0;X=c[V+76>>2]|0;Y=c[W+36>>2]|0;Z=c[X+36>>2]|0;_=c[V+64>>2]|0;$=c[V+68>>2]|0;aa=e[V+22>>1]|0;ba=aa&32;ca=aa&64;aa=V+44|0;da=c[aa>>2]|0;if(!(da&1)){fa=c[aa>>2]|0;ga=VEi(fa|0,0,6)|0;ha=H;ia=_Ei(fa|0,0,127,0)|0;ja=VEi(ia|0,H|0,6)|0;ia=H;ka=ZEi(1,0,ga|0,ha|0)|0;ha=_Ei(ka|0,H|0,ja|0,ia|0)|0;ia=ha;ha=H;ja=fa;while(1){ia=_Ei(ia|0,ha|0,-1,-1)|0;ha=H;if((ia|0)==0&(ha|0)==0)break;else ja=ja+64|0}ja=c[aa>>2]|0;ha=VEi(ja|0,0,6)|0;ia=H;fa=_Ei(ja|0,0,255,0)|0;ka=VEi(fa|0,H|0,6)|0;fa=H;ga=ZEi(1,0,ha|0,ia|0)|0;ia=_Ei(ga|0,H|0,ka|0,fa|0)|0;fa=ia;ia=H;ka=ja;while(1){fa=_Ei(fa|0,ia|0,-1,-1)|0;ia=H;if((fa|0)==0&(ia|0)==0){la=0;break}else ka=ka+64|0}}else{_1a(z,da&-2);c[aa>>2]=S;la=1}ka=(Z|0)<(Y|0);ia=ka?X:W;fa=ka?W:X;ja=ka?Z:Y;ga=ka?Y:Z;ha=ka?$:_;ma=ka?_:$;na=f+(ja*28|0)+(ga<<2)+104|0;c[na>>2]=(c[na>>2]|0)+1;if(!((ka?ca:ba)|0)){oa=ea(ea(g[ia+16>>2])*ea(2.0));pa=ea(ea(g[ia+20>>2])*ea(2.0));qa=ea(ea(g[ia+24>>2])*ea(2.0));ra=ea(g[ha+12>>2]);sa=ea(ea(ra*ra)+ea(-.5));ta=ea(g[ha>>2]);ua=ea(oa*ta);va=ea(g[ha+4>>2]);wa=ea(ua+ea(pa*va));ua=ea(g[ha+8>>2]);xa=ea(wa+ea(qa*ua));wa=ea(ea(ta*xa)+ea(ea(oa*sa)+ea(ra*ea(ea(qa*va)-ea(pa*ua)))));ya=ea(ea(va*xa)+ea(ea(pa*sa)+ea(ra*ea(ea(oa*ua)-ea(qa*ta)))));za=ea(ea(ea(qa*sa)+ea(ra*ea(ea(pa*ta)-ea(oa*va))))+ea(ua*xa));xa=ea(ea(g[ha+16>>2])+wa);wa=ea(ea(g[ha+20>>2])+ya);ya=ea(ea(g[ha+24>>2])+za);za=ea(g[ia>>2]);oa=ea(ra*za);pa=ea(g[ia+12>>2]);sa=ea(oa+ea(ta*pa));oa=ea(g[ia+8>>2]);qa=ea(sa+ea(va*oa));sa=ea(g[ia+4>>2]);Aa=ya;Ba=wa;Ca=xa;Da=ea(ea(ea(ea(ra*pa)-ea(ta*za))-ea(va*sa))-ea(ua*oa));Ea=ea(ea(ea(ta*sa)+ea(ea(ua*pa)+ea(ra*oa)))-ea(va*za));Fa=ea(ea(ea(ua*za)+ea(ea(va*pa)+ea(ra*sa)))-ea(ta*oa));Ga=ea(qa-ea(ua*sa))}else{sa=ea(g[ha+48>>2]);ua=ea(g[ha+52>>2]);qa=ea(sa*ea(-2.0));sa=ea(ua*ea(-2.0));ua=ea(ea(g[ha+56>>2])*ea(-2.0));oa=ea(g[ha+44>>2]);ta=ea(ea(oa*oa)+ea(-.5));ra=ea(g[ha+32>>2]);pa=ea(qa*ra);va=ea(g[ha+36>>2]);za=ea(pa+ea(sa*va));pa=ea(g[ha+40>>2]);xa=ea(za+ea(ua*pa));za=ea(-ra);wa=ea(-va);ya=ea(-pa);Ha=ea(ea(ea(ra*xa)+ea(ea(qa*ta)-ea(oa*ea(ea(ua*va)-ea(sa*pa)))))*ea(2.0));Ia=ea(ea(ea(va*xa)+ea(ea(sa*ta)-ea(oa*ea(ea(qa*pa)-ea(ua*ra)))))*ea(2.0));Ja=ea(ea(ea(ea(ua*ta)-ea(oa*ea(ea(sa*ra)-ea(qa*va))))+ea(pa*xa))*ea(2.0));xa=ea(g[ha+12>>2]);pa=ea(ea(xa*xa)+ea(-.5));va=ea(g[ha>>2]);qa=ea(va*Ha);ra=ea(g[ha+4>>2]);sa=ea(qa+ea(ra*Ia));qa=ea(g[ha+8>>2]);ta=ea(ea(qa*Ja)+sa);sa=ea(ea(va*ta)+ea(ea(pa*Ha)+ea(xa*ea(ea(ra*Ja)-ea(qa*Ia)))));ua=ea(ea(ra*ta)+ea(ea(pa*Ia)+ea(xa*ea(ea(qa*Ha)-ea(va*Ja)))));Ka=ea(ea(ea(pa*Ja)+ea(xa*ea(ea(va*Ia)-ea(ra*Ha))))+ea(qa*ta));ta=ea(ea(g[ha+16>>2])+sa);sa=ea(ea(g[ha+20>>2])+ua);ua=ea(ea(g[ha+24>>2])+Ka);Ka=ea(ea(ea(ea(xa*za)+ea(oa*va))+ea(ra*ya))-ea(qa*wa));Ha=ea(ea(ea(qa*za)+ea(ea(xa*wa)+ea(oa*ra)))-ea(va*ya));Ia=ea(ea(ea(va*wa)+ea(ea(xa*ya)+ea(oa*qa)))-ea(ra*za));Ja=ea(ea(ea(ea(oa*xa)-ea(va*za))-ea(ra*wa))-ea(qa*ya));ya=ea(ea(g[ia+16>>2])*ea(2.0));qa=ea(ea(g[ia+20>>2])*ea(2.0));wa=ea(ea(g[ia+24>>2])*ea(2.0));ra=ea(ea(Ja*Ja)+ea(-.5));za=ea(ea(ea(Ka*ya)+ea(Ha*qa))+ea(Ia*wa));va=ea(ta+ea(ea(Ka*za)+ea(ea(ra*ya)+ea(Ja*ea(ea(Ha*wa)-ea(Ia*qa))))));ta=ea(sa+ea(ea(Ha*za)+ea(ea(ra*qa)+ea(Ja*ea(ea(Ia*ya)-ea(Ka*wa))))));sa=ea(ua+ea(ea(ea(ra*wa)+ea(Ja*ea(ea(Ka*qa)-ea(Ha*ya))))+ea(Ia*za)));za=ea(g[ia>>2]);ya=ea(Ja*za);qa=ea(g[ia+12>>2]);wa=ea(ya+ea(Ka*qa));ya=ea(g[ia+8>>2]);ra=ea(wa+ea(Ha*ya));wa=ea(g[ia+4>>2]);Aa=sa;Ba=ta;Ca=va;Da=ea(ea(ea(ea(Ja*qa)-ea(Ka*za))-ea(Ha*wa))-ea(Ia*ya));Ea=ea(ea(ea(Ka*wa)+ea(ea(Ia*qa)+ea(Ja*ya)))-ea(Ha*za));Fa=ea(ea(ea(Ia*za)+ea(ea(Ha*qa)+ea(Ja*wa)))-ea(Ka*ya));Ga=ea(ra-ea(Ia*wa))}g[p>>2]=Ga;g[A>>2]=Fa;g[B>>2]=Ea;g[C>>2]=Da;g[D>>2]=Ca;g[E>>2]=Ba;g[F>>2]=Aa;if(!((ka?ba:ca)|0)){wa=ea(ea(g[fa+16>>2])*ea(2.0));Ia=ea(ea(g[fa+20>>2])*ea(2.0));ra=ea(ea(g[fa+24>>2])*ea(2.0));ya=ea(g[ma+12>>2]);Ka=ea(ea(ya*ya)+ea(-.5));Ja=ea(g[ma>>2]);qa=ea(wa*Ja);Ha=ea(g[ma+4>>2]);za=ea(qa+ea(Ia*Ha));qa=ea(g[ma+8>>2]);va=ea(za+ea(ra*qa));za=ea(ea(Ja*va)+ea(ea(wa*Ka)+ea(ya*ea(ea(ra*Ha)-ea(Ia*qa)))));ta=ea(ea(Ha*va)+ea(ea(Ia*Ka)+ea(ya*ea(ea(wa*qa)-ea(ra*Ja)))));sa=ea(ea(ea(ra*Ka)+ea(ya*ea(ea(Ia*Ja)-ea(wa*Ha))))+ea(qa*va));va=ea(ea(g[ma+16>>2])+za);za=ea(ea(g[ma+20>>2])+ta);ta=ea(ea(g[ma+24>>2])+sa);sa=ea(g[fa>>2]);wa=ea(ya*sa);Ia=ea(g[fa+12>>2]);Ka=ea(wa+ea(Ja*Ia));wa=ea(g[fa+8>>2]);ra=ea(Ka+ea(Ha*wa));Ka=ea(g[fa+4>>2]);La=ta;Ma=za;Na=va;Oa=ea(ea(ea(ea(ya*Ia)-ea(Ja*sa))-ea(Ha*Ka))-ea(qa*wa));Pa=ea(ea(ea(Ja*Ka)+ea(ea(qa*Ia)+ea(ya*wa)))-ea(Ha*sa));Qa=ea(ea(ea(qa*sa)+ea(ea(Ha*Ia)+ea(ya*Ka)))-ea(Ja*wa));Ra=ea(ra-ea(qa*Ka))}else{Ka=ea(g[ma+48>>2]);qa=ea(g[ma+52>>2]);ra=ea(Ka*ea(-2.0));Ka=ea(qa*ea(-2.0));qa=ea(ea(g[ma+56>>2])*ea(-2.0));wa=ea(g[ma+44>>2]);Ja=ea(ea(wa*wa)+ea(-.5));ya=ea(g[ma+32>>2]);Ia=ea(ra*ya);Ha=ea(g[ma+36>>2]);sa=ea(Ia+ea(Ka*Ha));Ia=ea(g[ma+40>>2]);va=ea(sa+ea(qa*Ia));sa=ea(-ya);za=ea(-Ha);ta=ea(-Ia);ua=ea(ea(ea(ya*va)+ea(ea(ra*Ja)-ea(wa*ea(ea(qa*Ha)-ea(Ka*Ia)))))*ea(2.0));xa=ea(ea(ea(Ha*va)+ea(ea(Ka*Ja)-ea(wa*ea(ea(ra*Ia)-ea(qa*ya)))))*ea(2.0));oa=ea(ea(ea(ea(qa*Ja)-ea(wa*ea(ea(Ka*ya)-ea(ra*Ha))))+ea(Ia*va))*ea(2.0));va=ea(g[ma+12>>2]);Ia=ea(ea(va*va)+ea(-.5));Ha=ea(g[ma>>2]);ra=ea(Ha*ua);ya=ea(g[ma+4>>2]);Ka=ea(ra+ea(ya*xa));ra=ea(g[ma+8>>2]);Ja=ea(ea(ra*oa)+Ka);Ka=ea(ea(Ha*Ja)+ea(ea(Ia*ua)+ea(va*ea(ea(ya*oa)-ea(ra*xa)))));qa=ea(ea(ya*Ja)+ea(ea(Ia*xa)+ea(va*ea(ea(ra*ua)-ea(Ha*oa)))));pa=ea(ea(ea(Ia*oa)+ea(va*ea(ea(Ha*xa)-ea(ya*ua))))+ea(ra*Ja));Ja=ea(ea(g[ma+16>>2])+Ka);Ka=ea(ea(g[ma+20>>2])+qa);qa=ea(ea(g[ma+24>>2])+pa);pa=ea(ea(ea(ea(va*sa)+ea(wa*Ha))+ea(ya*ta))-ea(ra*za));ua=ea(ea(ea(ra*sa)+ea(ea(va*za)+ea(wa*ya)))-ea(Ha*ta));xa=ea(ea(ea(Ha*za)+ea(ea(va*ta)+ea(wa*ra)))-ea(ya*sa));oa=ea(ea(ea(ea(wa*va)-ea(Ha*sa))-ea(ya*za))-ea(ra*ta));ta=ea(ea(g[fa+16>>2])*ea(2.0));ra=ea(ea(g[fa+20>>2])*ea(2.0));za=ea(ea(g[fa+24>>2])*ea(2.0));ya=ea(ea(oa*oa)+ea(-.5));sa=ea(ea(ea(pa*ta)+ea(ua*ra))+ea(xa*za));Ha=ea(Ja+ea(ea(pa*sa)+ea(ea(ya*ta)+ea(oa*ea(ea(ua*za)-ea(xa*ra))))));Ja=ea(Ka+ea(ea(ua*sa)+ea(ea(ya*ra)+ea(oa*ea(ea(xa*ta)-ea(pa*za))))));Ka=ea(qa+ea(ea(ea(ya*za)+ea(oa*ea(ea(pa*ra)-ea(ua*ta))))+ea(xa*sa)));sa=ea(g[fa>>2]);ta=ea(oa*sa);ra=ea(g[fa+12>>2]);za=ea(ta+ea(pa*ra));ta=ea(g[fa+8>>2]);ya=ea(za+ea(ua*ta));za=ea(g[fa+4>>2]);La=Ka;Ma=Ja;Na=Ha;Oa=ea(ea(ea(ea(oa*ra)-ea(pa*sa))-ea(ua*za))-ea(xa*ta));Pa=ea(ea(ea(pa*za)+ea(ea(xa*ra)+ea(oa*ta)))-ea(ua*sa));Qa=ea(ea(ea(xa*sa)+ea(ea(ua*ra)+ea(oa*za)))-ea(pa*ta));Ra=ea(ya-ea(xa*za))}g[q>>2]=Ra;g[G>>2]=Qa;g[I>>2]=Pa;g[J>>2]=Oa;g[K>>2]=Na;g[L>>2]=Ma;g[M>>2]=La;ma=V+98|0;ha=e[ma>>1]&2;c[N>>2]=0;b[ma>>1]=0;b[V+20>>1]=0;c[V+24>>2]=0;c[V>>2]=0;b[V+16>>1]=0;c[V+4>>2]=0;c[V+28>>2]=0;c[V+32>>2]=0;na=c[500800+(ja*28|0)+(ga<<2)>>2]|0;za=ea(g[ia+28>>2]);g[r>>2]=ea(za+ea(g[fa+28>>2]));gn[na&127](ia+36|0,fa+36|0,p,q,r,aa,O)|0;kn[c[501232+(ja*28|0)+(ga<<2)>>2]&511](ia,fa,f,s)|0;if(ka?(c[N>>2]|0)!=0:0){ka=0;do{fa=f+(ka<<6)+384|0;za=ea(-ea(g[fa>>2]));ia=f+(ka<<6)+388|0;xa=ea(-ea(g[ia>>2]));ga=f+(ka<<6)+392|0;ya=ea(-ea(g[ga>>2]));g[fa>>2]=za;g[ia>>2]=xa;g[ga>>2]=ya;ga=f+(ka<<6)+432|0;ia=f+(ka<<6)+436|0;fa=c[ga>>2]|0;c[ga>>2]=c[ia>>2];c[ia>>2]=fa;fa=s+(ka<<2)|0;ia=s+(ka<<2)+2|0;ga=b[fa>>1]|0;b[fa>>1]=b[ia>>1]|0;b[ia>>1]=ga;ka=ka+1|0}while(ka>>>0<(c[N>>2]|0)>>>0)}yAa(V,f,s)|0;if(la){ka=(d[P>>0]<<4)+48+((d[Q>>0]|0)*48|0)|0;ca=tAa(R,ka)|0;c[ca+32>>2]=d[P>>0];c[ca+0>>2]=c[z+0>>2];c[ca+4>>2]=c[z+4>>2];c[ca+8>>2]=c[z+8>>2];c[ca+12>>2]=c[z+12>>2];c[ca+16>>2]=c[z+16>>2];c[ca+20>>2]=c[z+20>>2];c[ca+24>>2]=c[z+24>>2];c[ca+28>>2]=c[z+28>>2];if(a[P>>0]|0){ba=0;$=ca+48|0;while(1){_=$+16|0;Z=d[z+ba+48>>0]|0;Y=z+(Z*400|0)+448|0;c[$>>2]=c[Y>>2];if(!(c[Y>>2]|0))Sa=16;else{X=0;do{ya=ea(g[z+(Z*400|0)+(X<<6)+64>>2]);xa=ea(g[z+(Z*400|0)+(X<<6)+68>>2]);za=ea(g[z+(Z*400|0)+(X<<6)+72>>2]);W=_+(X*48|0)|0;g[W>>2]=ya;g[W+4>>2]=xa;g[W+8>>2]=za;g[W+12>>2]=ea(0.0);za=ea(g[z+(Z*400|0)+(X<<6)+80>>2]);xa=ea(g[z+(Z*400|0)+(X<<6)+84>>2]);ya=ea(g[z+(Z*400|0)+(X<<6)+88>>2]);W=_+(X*48|0)+16|0;g[W>>2]=za;g[W+4>>2]=xa;g[W+8>>2]=ya;g[W+12>>2]=ea(0.0);aFi(_+(X*48|0)+32|0,z+(Z*400|0)+(X<<6)+96|0,16)|0;c[_+(X*48|0)+12>>2]=c[z+(Z*400|0)+(X<<6)+112>>2];X=X+1|0;Ta=c[Y>>2]|0}while(X>>>0<Ta>>>0);Sa=(Ta*48|0)+16|0}ba=ba+1|0;if(ba>>>0>=(d[P>>0]|0)>>>0)break;else $=$+Sa|0}}c[aa>>2]=ca|1;b[V+56>>1]=ka}do if((ha|0)!=(e[ma>>1]&2|0)){$=c[h+(T*12|0)+4>>2]|0;ba=l+($>>>5<<2)|0;c[ba>>2]=1<<($&31)|c[ba>>2];if(!ha){Ua=j+1|0;Va=U;break}else{Ua=j;Va=U+1|0;break}}else{Ua=j;Va=U}while(0);T=T+1|0;if((T|0)==(k|0)){t=Ua;u=Va;break}else{j=Ua;U=Va}}v=c[n>>2]|0;w=v+u|0;c[n>>2]=w;x=c[o>>2]|0;y=x+t|0;c[o>>2]=y;i=m;return}function mAa(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;j=c[d+32>>2]|0;if(j){k=d+28|0;l=c[k>>2]|0;m=b[d+22>>1]|0;n=m&65535;do if((n&1|0)==0?(a[f+8770>>0]|0)==0:0){if((n&32|0)!=0?(c[(c[d+64>>2]|0)+92>>2]|0)!=2139095039:0){o=8;break}if((m&64)!=0?(c[(c[d+68>>2]|0)+92>>2]|0)!=2139095039:0)o=8;else p=0}else o=8;while(0);if((o|0)==8)p=e[d+20>>1]<<2;o=j+15|0;m=o&-16;n=f+332|0;q=(o|15)+p&-16;do if(q>>>0>16384)r=QAa(c[n>>2]|0,q)|0;else{o=f+336|0;s=c[o>>2]|0;t=f+340|0;if((s|0)!=0?(u=c[t>>2]|0,v=u+q|0,v>>>0<=16384):0){c[t>>2]=v;r=s+u|0;break}u=TAa(c[n>>2]|0)|0;c[o>>2]=u;c[t>>2]=q;r=u}while(0);YEi(r|0,l|0,j|0)|0;if(!p){j=d+98|0;b[j>>1]=e[j>>1]&65519}else PEi(r+m|0,0,p|0)|0;c[k>>2]=r}r=d+44|0;if(c[r>>2]&1){k=d+56|0;p=b[k>>1]|0;if(!(p<<16>>16)){i=h;return}m=tAa(f+356|0,p&65535)|0;YEi(m|0,c[r>>2]&-16|0,e[k>>1]|0)|0;c[r>>2]=m|1;i=h;return}if(!g){i=h;return}g=d+56|0;m=b[g>>1]|0;if(!(m<<16>>16)){i=h;return}r=d+52|0;d=c[r>>2]|0;k=tAa(f+356|0,(m&65535)+15&65520)|0;YEi(k|0,d|0,e[g>>1]|0)|0;c[r>>2]=k;i=h;return}function nAa(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im;h=i;i=i+320|0;j=h+32|0;k=h;l=h+60|0;m=h+64|0;n=e[f+22>>1]|0;if(!(n&32))o=0;else o=(a[(c[f+64>>2]|0)+29>>0]&1)==0;if(!(n&64))p=0;else p=(a[(c[f+68>>2]|0)+29>>0]&1)==0;n=a[f+96>>0]|0;q=n&255;r=a[f+97>>0]|0;s=r&255;if(!(o|p)){p=(r&255)<(n&255);if(!(a[d+8769>>0]|0))t=0;else t=(a[(p?q:s)+(500544+((p?s:q)*7|0))>>0]|0)!=0;mAa(f,d,t);i=h;return}t=c[f+72>>2]|0;p=c[f+76>>2]|0;o=c[f+100>>2]|0;u=c[f+104>>2]|0;v=(r&255)<(n&255);n=v?s:q;r=v?q:s;s=v?p:t;q=v?t:p;p=v?u:o;t=v?o:u;u=d+(n*28|0)+(r<<2)+104|0;c[u>>2]=(c[u>>2]|0)+1;u=c[500600+(n*28|0)+(r<<2)>>2]|0;o=d+4480|0;c[o>>2]=0;b[f+98>>1]=0;b[f+20>>1]=0;c[f+24>>2]=0;c[f>>2]=0;b[f+16>>1]=0;c[f+4>>2]=0;c[f+28>>2]=0;c[f+32>>2]=0;w=c[(c[d+8764>>2]|0)+16>>2]|0;g[j>>2]=ea(g[w+(p*28|0)>>2]);g[j+4>>2]=ea(g[w+(p*28|0)+4>>2]);g[j+8>>2]=ea(g[w+(p*28|0)+8>>2]);g[j+12>>2]=ea(g[w+(p*28|0)+12>>2]);g[j+16>>2]=ea(g[w+(p*28|0)+16>>2]);g[j+20>>2]=ea(g[w+(p*28|0)+20>>2]);g[j+24>>2]=ea(g[w+(p*28|0)+24>>2]);g[k>>2]=ea(g[w+(t*28|0)>>2]);g[k+4>>2]=ea(g[w+(t*28|0)+4>>2]);g[k+8>>2]=ea(g[w+(t*28|0)+8>>2]);g[k+12>>2]=ea(g[w+(t*28|0)+12>>2]);g[k+16>>2]=ea(g[w+(t*28|0)+16>>2]);g[k+20>>2]=ea(g[w+(t*28|0)+20>>2]);g[k+24>>2]=ea(g[w+(t*28|0)+24>>2]);x=ea(g[s+28>>2]);y=ea(x+ea(g[q+28>>2]));g[l>>2]=y;if((a[d+8769>>0]|0)!=0?(a[500544+(n*7|0)+r>>0]|0)!=0:0)Xza(n,r,d,f+44|0,j,k,y,u,s+36|0,q+36|0);else gn[u&127](s+36|0,q+36|0,j,k,l,f+44|0,d+384|0)|0;kn[c[501232+(n*28|0)+(r<<2)>>2]&511](s,q,d,m)|0;if(v?(c[o>>2]|0)!=0:0){v=0;do{q=d+(v<<6)+384|0;y=ea(-ea(g[q>>2]));s=d+(v<<6)+388|0;x=ea(-ea(g[s>>2]));r=d+(v<<6)+392|0;z=ea(-ea(g[r>>2]));g[q>>2]=y;g[s>>2]=x;g[r>>2]=z;r=d+(v<<6)+432|0;s=d+(v<<6)+436|0;q=c[r>>2]|0;c[r>>2]=c[s>>2];c[s>>2]=q;q=m+(v<<2)|0;s=m+(v<<2)+2|0;r=b[q>>1]|0;b[q>>1]=b[s>>1]|0;b[s>>1]=r;v=v+1|0}while(v>>>0<(c[o>>2]|0)>>>0)}yAa(f,d,m)|0;i=h;return}function oAa(f,h){f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,I=0,J=0;j=i;i=i+320|0;k=j+32|0;l=j;m=j+60|0;n=j+64|0;o=e[h+22>>1]|0;if(!(o&32))p=0;else p=(a[(c[h+64>>2]|0)+29>>0]&1)==0;if(!(o&64))q=0;else q=(a[(c[h+68>>2]|0)+29>>0]&1)==0;o=a[h+96>>0]|0;r=o&255;s=a[h+97>>0]|0;t=s&255;if(!(p|q)){mAa(h,f,0);i=j;return}q=f+4496|0;p=c[h+72>>2]|0;u=c[h+76>>2]|0;v=h+44|0;w=c[v>>2]|0;if(!(w&1)){x=c[v>>2]|0;y=VEi(x|0,0,6)|0;z=H;A=_Ei(x|0,0,127,0)|0;B=VEi(A|0,H|0,6)|0;A=H;C=ZEi(1,0,y|0,z|0)|0;z=_Ei(C|0,H|0,B|0,A|0)|0;A=z;z=H;B=x;while(1){A=_Ei(A|0,z|0,-1,-1)|0;z=H;if((A|0)==0&(z|0)==0)break;else B=B+64|0}B=c[v>>2]|0;z=VEi(B|0,0,6)|0;A=H;x=_Ei(B|0,0,255,0)|0;C=VEi(x|0,H|0,6)|0;x=H;y=ZEi(1,0,z|0,A|0)|0;A=_Ei(y|0,H|0,C|0,x|0)|0;x=A;A=H;C=B;while(1){x=_Ei(x|0,A|0,-1,-1)|0;A=H;if((x|0)==0&(A|0)==0){D=0;break}else C=C+64|0}}else{_1a(q,w&-2);c[v>>2]=q|1;D=1}w=c[h+100>>2]|0;C=c[(c[f+8764>>2]|0)+16>>2]|0;g[k>>2]=ea(g[C+(w*28|0)>>2]);g[k+4>>2]=ea(g[C+(w*28|0)+4>>2]);g[k+8>>2]=ea(g[C+(w*28|0)+8>>2]);g[k+12>>2]=ea(g[C+(w*28|0)+12>>2]);g[k+16>>2]=ea(g[C+(w*28|0)+16>>2]);g[k+20>>2]=ea(g[C+(w*28|0)+20>>2]);g[k+24>>2]=ea(g[C+(w*28|0)+24>>2]);w=c[h+104>>2]|0;g[l>>2]=ea(g[C+(w*28|0)>>2]);g[l+4>>2]=ea(g[C+(w*28|0)+4>>2]);g[l+8>>2]=ea(g[C+(w*28|0)+8>>2]);g[l+12>>2]=ea(g[C+(w*28|0)+12>>2]);g[l+16>>2]=ea(g[C+(w*28|0)+16>>2]);g[l+20>>2]=ea(g[C+(w*28|0)+20>>2]);g[l+24>>2]=ea(g[C+(w*28|0)+24>>2]);E=ea(g[p+28>>2]);g[m>>2]=ea(E+ea(g[u+28>>2]));w=(s&255)<(o&255);o=w?t:r;s=w?r:t;t=w?u:p;r=w?p:u;u=f+(o*28|0)+(s<<2)+104|0;c[u>>2]=(c[u>>2]|0)+1;u=c[500800+(o*28|0)+(s<<2)>>2]|0;p=f+4480|0;c[p>>2]=0;b[h+98>>1]=0;b[h+20>>1]=0;c[h+24>>2]=0;c[h>>2]=0;b[h+16>>1]=0;c[h+4>>2]=0;c[h+28>>2]=0;c[h+32>>2]=0;gn[u&127](t+36|0,r+36|0,w?l:k,w?k:l,m,v,f+384|0)|0;kn[c[501232+(o*28|0)+(s<<2)>>2]&511](t,r,f,n)|0;if(w?(c[p>>2]|0)!=0:0){w=0;do{r=f+(w<<6)+384|0;E=ea(-ea(g[r>>2]));t=f+(w<<6)+388|0;F=ea(-ea(g[t>>2]));s=f+(w<<6)+392|0;G=ea(-ea(g[s>>2]));g[r>>2]=E;g[t>>2]=F;g[s>>2]=G;s=f+(w<<6)+432|0;t=f+(w<<6)+436|0;r=c[s>>2]|0;c[s>>2]=c[t>>2];c[t>>2]=r;r=n+(w<<2)|0;t=n+(w<<2)+2|0;s=b[r>>1]|0;b[r>>1]=b[t>>1]|0;b[t>>1]=s;w=w+1|0}while(w>>>0<(c[p>>2]|0)>>>0)}if(D){D=f+4548|0;p=(d[D>>0]<<4)+48+((d[q+53>>0]|0)*48|0)|0;w=tAa(f+356|0,p)|0;c[w+32>>2]=d[D>>0];c[w+0>>2]=c[q+0>>2];c[w+4>>2]=c[q+4>>2];c[w+8>>2]=c[q+8>>2];c[w+12>>2]=c[q+12>>2];c[w+16>>2]=c[q+16>>2];c[w+20>>2]=c[q+20>>2];c[w+24>>2]=c[q+24>>2];c[w+28>>2]=c[q+28>>2];if(a[D>>0]|0){s=0;t=w+48|0;while(1){r=t+16|0;o=d[q+s+48>>0]|0;m=q+(o*400|0)+448|0;c[t>>2]=c[m>>2];if(!(c[m>>2]|0))I=16;else{l=0;do{G=ea(g[q+(o*400|0)+(l<<6)+64>>2]);F=ea(g[q+(o*400|0)+(l<<6)+68>>2]);E=ea(g[q+(o*400|0)+(l<<6)+72>>2]);k=r+(l*48|0)|0;g[k>>2]=G;g[k+4>>2]=F;g[k+8>>2]=E;g[k+12>>2]=ea(0.0);E=ea(g[q+(o*400|0)+(l<<6)+80>>2]);F=ea(g[q+(o*400|0)+(l<<6)+84>>2]);G=ea(g[q+(o*400|0)+(l<<6)+88>>2]);k=r+(l*48|0)+16|0;g[k>>2]=E;g[k+4>>2]=F;g[k+8>>2]=G;g[k+12>>2]=ea(0.0);aFi(r+(l*48|0)+32|0,q+(o*400|0)+(l<<6)+96|0,16)|0;c[r+(l*48|0)+12>>2]=c[q+(o*400|0)+(l<<6)+112>>2];l=l+1|0;J=c[m>>2]|0}while(l>>>0<J>>>0);I=(J*48|0)+16|0}s=s+1|0;if(s>>>0>=(d[D>>0]|0)>>>0)break;else t=t+I|0}}c[v>>2]=w|1;b[h+56>>1]=p}yAa(h,f,n)|0;i=j;return}function pAa(a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;C=i;c[z>>2]=0;c[A>>2]=0;B=(g|0)==0?0:g+16|0;kAa(B,l,0,m,x,y,z,A);kAa(B,n,0,o,x,y,z,A);kAa(B,p,0,q,x,y,z,A);kAa(B,r,0,s,x,y,z,A);kAa(B,t,0,u,x,y,z,A);kAa(B,v,0,w,x,y,z,A);i=C;return}function qAa(a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;w=i;c[t>>2]=0;c[u>>2]=0;v=(e|0)==0?0:e+16|0;lAa(v,j,0,k,r,s,t,u);lAa(v,l,0,m,r,s,t,u);lAa(v,n,0,o,r,s,t,u);lAa(v,p,0,q,r,s,t,u);i=w;return}function rAa(a){a=a|0;c[a+8>>2]=0;c[a+12>>2]=0;return}function sAa(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=0;c[a+12>>2]=0;return}function tAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+15&-16;if(e>>>0>16384){f=-1;i=d;return f|0}b=a+8|0;g=c[b>>2]|0;h=a+12|0;if((g|0)!=0?(j=c[h>>2]|0,(j+e|0)>>>0<=16384):0){k=g;l=j}else{j=WAa(c[a>>2]|0)|0;c[b>>2]=j;c[h>>2]=0;if(!j){f=0;i=d;return f|0}else{k=j;l=0}}c[a+12>>2]=l+e;f=k+l|0;i=d;return f|0}function uAa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=ea(r);s=ea(s);t=ea(t);u=ea(u);v=v|0;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;w=i;i=i+144|0;x=w+16|0;y=w+96|0;z=w+124|0;A=w+128|0;B=w+12|0;C=w;D=w+84|0;E=j&1;j=f+384|0;b[k+26>>1]=0;F=f+4480|0;c[F>>2]=0;G=d+40|0;g[y>>2]=ea(0.0);g[y+4>>2]=ea(0.0);g[y+8>>2]=ea(0.0);g[y+12>>2]=ea(1.0);g[y+16>>2]=ea(0.0);g[y+20>>2]=ea(0.0);g[y+24>>2]=ea(0.0);H=d+22|0;I=b[H>>1]|0;J=(I&32)==0?y:p;p=(I&64)==0?y:q;q=c[d+28>>2]|0;do if(q){y=c[d+32>>2]|0;g[x>>2]=ea(0.0);g[x+4>>2]=ea(0.0);g[x+8>>2]=ea(0.0);c[x+36>>2]=y;I=x+40|0;c[I>>2]=0;K=x+44|0;c[K>>2]=0;L=x+12|0;c[L>>2]=q;if(!y){M=0;N=0;O=0;P=0;Q=0;R=1}else{S=b[q+2>>1]|0;T=S&65535;U=T&2;V=(U|0)!=0;W=T&1;if(V)X=72;else X=W<<3|16;M=V?4:32;N=X;O=q+(U<<3|4)|0;P=(W|0)!=0;Q=V;R=(S&4)!=0}S=Q&1;c[x+60>>2]=S;c[x+56>>2]=P&1;c[x+64>>2]=R&1;c[x+48>>2]=M;c[x+52>>2]=N;V=x+24|0;c[V>>2]=O;W=x+28|0;c[W>>2]=O;U=x+16|0;c[U>>2]=O;if(!R){if(Q){Y=ea(g[q+4>>2]);Z=ea(g[q+8>>2]);_=ea(g[q+12>>2]);$=Y;aa=_;ba=Z;ca=ea(g[q+16>>2]);fa=S}else{$=ea(1.0);aa=ea(1.0);ba=ea(1.0);ca=ea(1.0);fa=0}S=O;if((S-q|0)>>>0>=y>>>0){c[F>>2]=0;break}T=x+32|0;ga=(fa|0)==0;ha=E;ia=O;ja=0;ka=0;la=O;ma=q;na=S;S=0;while(1){c[V>>2]=la;if((na-ma|0)>>>0<y>>>0){oa=e[la>>1]|0;c[I>>2]=oa;c[W>>2]=la+((da(N,oa)|0)+M);pa=la+M|0;c[U>>2]=pa;c[K>>2]=0;qa=pa;ra=0;sa=oa}else{c[W>>2]=la;qa=ia;ra=ja;sa=ka}ta=ha;oa=ra;pa=qa;ua=S;a:while(1){va=f+(ua<<6)+384|0;if(!ga){wa=pa;xa=oa;while(1){if(xa>>>0>=sa>>>0){ya=wa;za=xa;break a}xa=xa+1|0;c[K>>2]=xa;c[T>>2]=wa;Aa=wa+N|0;c[U>>2]=Aa;Ba=ea(g[(c[T>>2]|0)+48>>2]);if(Ba!=ea(0.0))break;else wa=Aa}if(ga){Ca=Aa;Da=xa;Ea=va;Fa=Ba;Ga=24}else{wa=c[T>>2]|0;Ha=wa+24|0;Ia=va;Ja=wa;Ka=Ba;La=Aa;Ma=xa}}else{if(oa>>>0>=sa>>>0){ya=pa;za=oa;break}wa=oa+1|0;c[K>>2]=wa;c[T>>2]=pa;Na=pa+N|0;c[U>>2]=Na;Ca=Na;Da=wa;Ea=va;Fa=ea(3402823469999999843913219.0e14);Ga=24}if((Ga|0)==24){Ga=0;Ha=(c[V>>2]|0)+4|0;Ia=Ea;Ja=c[T>>2]|0;Ka=Fa;La=Ca;Ma=Da}g[Ia>>2]=ea(g[Ha>>2]);g[Ia+4>>2]=ea(g[Ha+4>>2]);g[Ia+8>>2]=ea(g[Ha+8>>2]);g[f+(ua<<6)+400>>2]=ea(g[Ja>>2]);g[f+(ua<<6)+404>>2]=ea(g[Ja+4>>2]);g[f+(ua<<6)+408>>2]=ea(g[Ja+8>>2]);g[f+(ua<<6)+396>>2]=ea(g[Ja+12>>2]);if(ga){wa=c[V>>2]|0;c[f+(ua<<6)+432>>2]=(e[wa+30>>1]|0)<<16|(e[wa+28>>1]|0);c[f+(ua<<6)+436>>2]=e[(c[V>>2]|0)+2>>1];g[f+(ua<<6)+412>>2]=Ka;g[f+(ua<<6)+428>>2]=ea(g[(c[V>>2]|0)+16>>2]);g[f+(ua<<6)+440>>2]=ea(g[(c[V>>2]|0)+20>>2]);g[f+(ua<<6)+444>>2]=ea(g[(c[V>>2]|0)+24>>2]);Oa=x}else{c[f+(ua<<6)+432>>2]=(e[Ja+66>>1]|0)<<16|(e[Ja+64>>1]|0);c[f+(ua<<6)+436>>2]=c[Ja+68>>2];g[f+(ua<<6)+412>>2]=Ka;g[f+(ua<<6)+428>>2]=ea(g[Ja+52>>2]);g[f+(ua<<6)+440>>2]=ea(g[Ja+56>>2]);g[f+(ua<<6)+444>>2]=ea(g[Ja+60>>2]);Oa=Ja+36|0}g[f+(ua<<6)+416>>2]=ea(g[Oa>>2]);wa=Oa+4|0;g[f+(ua<<6)+420>>2]=ea(g[wa>>2]);Na=Oa+8|0;g[f+(ua<<6)+424>>2]=ea(g[Na>>2]);if(!ga)if(ea(g[Oa>>2])==ea(0.0)?ea(g[wa>>2])==ea(0.0):0)Pa=ea(g[Na>>2])!=ea(0.0);else Pa=1;else Pa=0;ta=(Pa&1|ta&1)&255;oa=Ma;pa=La;ua=ua+1|0}la=c[W>>2]|0;ma=c[L>>2]|0;na=la;if((na-ma|0)>>>0>=y>>>0)break;else{ha=ta;ia=ya;ja=za;ka=sa;S=ua}}c[F>>2]=ua;S=(ta&1)!=0;if(ua){ka=f+4496|0;ja=f+8728|0;c[ja>>2]=0;c[f+8724>>2]=0;if(!S?(b[H>>1]&4)==0:0)$1a(ka,c[G>>2]|0,c[d+36>>2]|0,J,p,u)|0;Zza(f,0,ea(.999000012))|0;$za(ka,j,J,p,ea(.999000012),0,0)|0;bAa(ka,j,J,p,u,0,t);c[z>>2]=0;c[A>>2]=0;c[B>>2]=0;c[x>>2]=0;a2a(d,f,h,A,x,z,B);ia=c[A>>2]|0;ha=(ia|0)==0;if(ha)Qa=0;else{y=f+316|0;ma=ia+31&-16;do if(ma>>>0>16384)Ra=QAa(c[y>>2]|0,ma)|0;else{na=f+320|0;la=c[na>>2]|0;L=f+324|0;if((la|0)!=0?(W=c[L>>2]|0,ga=W+ma|0,ga>>>0<=16384):0){c[L>>2]=ga;Ra=la+W|0;break}W=SAa(c[y>>2]|0,v)|0;c[na>>2]=W;c[L>>2]=ma;Ra=W}while(0);Qa=(Ra|0)==0|(Ra|0)!=(-1|0)?Ra:0}ma=c[x>>2]|0;y=(ma|0)==0;if(!y?!((ia|0)!=0&(Qa|0)==0):0){do if(ma>>>0>16384)Sa=-1;else{W=f+348|0;L=c[W>>2]|0;na=f+352|0;if((L|0)!=0?(la=c[na>>2]|0,(la+ma|0)>>>0<=16384):0){Ta=L;Ua=la}else{la=VAa(c[f+344>>2]|0)|0;c[W>>2]=la;c[na>>2]=0;if(!la){Sa=0;break}else{Ta=la;Ua=0}}c[na>>2]=Ua+ma;Sa=Ta+Ua|0}while(0);Va=(Sa|0)==0|(Sa|0)!=(-1|0)?Sa:0}else Va=0;if((Qa|0)==0&(ha^1)){ma=f+8776|0;c[ma>>2]=(c[ma>>2]|0)+ia;Wa=0;Xa=0}else{ma=f+8776|0;c[ma>>2]=(c[ma>>2]|0)+ia;Wa=y|(Va|0)!=0;Xa=ha?0:Qa}c[G>>2]=0;c[d>>2]=0;ma=d+20|0;b[ma>>1]=0;na=d+36|0;c[na>>2]=0;la=d+4|0;c[la>>2]=0;W=d+16|0;b[W>>1]=(e[W>>1]|0)+(c[B>>2]|0);if(!Wa){Ya=0;i=w;return Ya|0}c[G>>2]=Va;c[d>>2]=Xa;b[ma>>1]=ua;c[na>>2]=c[z>>2];c[la>>2]=ia;if((Va|0)!=0?(la=c[ja>>2]|0,(la|0)!=0):0){na=la;la=Va;ma=0;while(1){if(!(c[f+(ma<<2)+8336>>2]|0)){Za=na;_a=la}else{a[la>>0]=a[f+(ma*96|0)+5264>>0]|0;b[la+16>>1]=b[f+(ma*96|0)+5280>>1]|0;g[la+24>>2]=ea(g[f+(ma*96|0)+5288>>2]);g[la+28>>2]=ea(g[f+(ma*96|0)+5292>>2]);g[la+32>>2]=ea(g[f+(ma*96|0)+5296>>2]);g[la+36>>2]=ea(g[f+(ma*96|0)+5300>>2]);g[la+40>>2]=ea(g[f+(ma*96|0)+5304>>2]);g[la+44>>2]=ea(g[f+(ma*96|0)+5308>>2]);g[la+48>>2]=ea(g[f+(ma*96|0)+5312>>2]);g[la+52>>2]=ea(g[f+(ma*96|0)+5316>>2]);g[la+56>>2]=ea(g[f+(ma*96|0)+5320>>2]);g[la+60>>2]=ea(g[f+(ma*96|0)+5324>>2]);g[la+64>>2]=ea(g[f+(ma*96|0)+5328>>2]);g[la+68>>2]=ea(g[f+(ma*96|0)+5332>>2]);g[la+72>>2]=ea(g[f+(ma*96|0)+5336>>2]);g[la+76>>2]=ea(g[f+(ma*96|0)+5340>>2]);g[la+80>>2]=ea(g[f+(ma*96|0)+5344>>2]);g[la+84>>2]=ea(g[f+(ma*96|0)+5348>>2]);g[la+88>>2]=ea(g[f+(ma*96|0)+5352>>2]);g[la+92>>2]=ea(g[f+(ma*96|0)+5356>>2]);b[la+20>>1]=b[f+(ma*96|0)+5284>>1]|0;b[la+18>>1]=b[f+(ma*96|0)+5282>>1]|0;b[la+22>>1]=b[f+(ma*96|0)+5286>>1]|0;Za=c[ja>>2]|0;_a=la+96|0}ma=ma+1|0;if(ma>>>0>=Za>>>0)break;else{na=Za;la=_a}}}if(!Xa){Ya=1;i=w;return Ya|0}if(!(b[H>>1]&24))Bwa(d,j,ka,J,p,S,Xa,l,m,n,o,r,s,$,aa,ba,ca);else{la=b[k+8>>1]|0;c[C>>2]=l;c[C+4>>2]=n;b[C+8>>1]=la;la=b[k+12>>1]|0;c[D>>2]=m;c[D+4>>2]=o;b[D+8>>1]=la;zwa(d,j,ka,J,p,S,Xa,C,D,n,o,r,s,$,aa,ba,ca)}c[Xa+(c[A>>2]|0)>>2]=0;Ya=1;i=w;return Ya|0}}}while(0);c[G>>2]=0;c[d+36>>2]=0;b[d+20>>1]=0;c[k+16>>2]=0;Ya=1;i=w;return Ya|0}function vAa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=ea(q);r=ea(r);s=ea(s);t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=0,Ua=0,Va=0,Wa=Im,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0;u=i;i=i+480|0;v=u+160|0;w=u+128|0;x=u+64|0;y=u+112|0;z=u+16|0;A=u;B=u+408|0;C=u+384|0;D=u+392|0;E=u+32|0;F=u+48|0;G=u+96|0;H=u+80|0;b[(c[h>>2]|0)+26>>1]=0;I=h+4|0;b[(c[I>>2]|0)+26>>1]=0;J=h+8|0;b[(c[J>>2]|0)+26>>1]=0;K=h+12|0;b[(c[K>>2]|0)+26>>1]=0;L=f+384|0;M=f+4480|0;c[M>>2]=0;g[w>>2]=ea(0.0);g[w+4>>2]=ea(0.0);g[w+8>>2]=ea(0.0);g[w+12>>2]=ea(1.0);g[w+16>>2]=ea(0.0);g[w+20>>2]=ea(0.0);g[w+24>>2]=ea(0.0);N=f+4496|0;O=f+8728|0;c[O>>2]=0;P=f+8724|0;c[P>>2]=0;Q=B+4|0;R=B+8|0;S=B+36|0;T=B+40|0;U=B+44|0;V=B+12|0;W=B+60|0;X=B+56|0;Y=B+64|0;Z=B+48|0;_=B+52|0;$=B+24|0;aa=B+28|0;ba=B+16|0;ca=B+32|0;fa=0;ga=0;while(1){ha=d+(fa<<2)|0;ia=c[ha>>2]|0;ja=b[ia+22>>1]|0;if(!(ja&32)){c[v+(fa*56|0)+28>>2]=w;ka=ja;la=ia}else{c[v+(fa*56|0)+28>>2]=c[n+(fa<<2)>>2];ia=c[ha>>2]|0;ka=b[ia+22>>1]|0;la=ia}if(!(ka&64)){c[v+(fa*56|0)+32>>2]=w;ma=la}else{c[v+(fa*56|0)+32>>2]=c[o+(fa<<2)>>2];ma=c[ha>>2]|0}c[v+(fa*56|0)>>2]=ma;ia=v+(fa*56|0)+12|0;c[ia>>2]=ga;c[v+(fa*56|0)+36>>2]=c[j+(fa<<2)>>2];c[v+(fa*56|0)+40>>2]=c[k+(fa<<2)>>2];c[v+(fa*56|0)+44>>2]=c[l+(fa<<2)>>2];c[v+(fa*56|0)+48>>2]=c[m+(fa<<2)>>2];ja=c[ha>>2]|0;if(((e[ja+20>>1]|0)+ga|0)>>>0>64){na=1;oa=82;break}pa=c[ja+28>>2]|0;qa=c[ja+32>>2]|0;g[B>>2]=ea(0.0);g[Q>>2]=ea(0.0);g[R>>2]=ea(0.0);c[S>>2]=qa;c[T>>2]=0;c[U>>2]=0;c[V>>2]=pa;if(!qa){ra=0;sa=0;ta=0;ua=0;va=0;wa=1}else{ja=b[pa+2>>1]|0;xa=ja&65535;ya=xa&2;za=(ya|0)!=0;Aa=xa&1;if(za)Ba=72;else Ba=Aa<<3|16;ra=za?4:32;sa=Ba;ta=pa+(ya<<3|4)|0;ua=(Aa|0)!=0;va=za;wa=(ja&4)!=0}c[W>>2]=va&1;c[X>>2]=ua&1;c[Y>>2]=wa&1;c[Z>>2]=ra;c[_>>2]=sa;c[$>>2]=ta;c[aa>>2]=ta;c[ba>>2]=ta;if(!wa){if(va){g[x+(fa<<2)>>2]=ea(g[pa+4>>2]);g[y+(fa<<2)>>2]=ea(g[pa+8>>2]);g[z+(fa<<2)>>2]=ea(g[pa+12>>2]);Ca=ea(g[pa+16>>2])}else{g[x+(fa<<2)>>2]=ea(1.0);g[y+(fa<<2)>>2]=ea(1.0);g[z+(fa<<2)>>2]=ea(1.0);Ca=ea(1.0)}g[A+(fa<<2)>>2]=Ca;ja=ta;if((ja-pa|0)>>>0<qa>>>0){za=ta;Aa=pa;pa=ja;ja=ta;ya=0;xa=0;Da=ga;Ea=0;while(1){c[$>>2]=za;if((pa-Aa|0)>>>0<qa>>>0){Fa=e[za>>1]|0;c[T>>2]=Fa;c[aa>>2]=za+((da(sa,Fa)|0)+ra);Ga=za+ra|0;c[ba>>2]=Ga;c[U>>2]=0;Ha=Fa;Ia=Ga;Ja=0}else{c[aa>>2]=za;Ha=xa;Ia=ja;Ja=ya}Ga=Ja;Fa=Ia;Ka=Da;La=Ea;a:while(1){Ma=f+(Ka<<6)+384|0;if(va){Na=Ga;Oa=Fa;while(1){if(Na>>>0>=Ha>>>0){Pa=Oa;Qa=Na;break a}Na=Na+1|0;c[U>>2]=Na;c[ca>>2]=Oa;Ra=Oa+sa|0;c[ba>>2]=Ra;Sa=ea(g[(c[ca>>2]|0)+48>>2]);if(Sa!=ea(0.0))break;else Oa=Ra}if(va){Oa=c[ca>>2]|0;Ta=Oa+24|0;Ua=Ma;Va=Oa;Wa=Sa;Xa=Ra;Ya=Na}else{Za=Ra;_a=Na;$a=Ma;ab=Sa;oa=32}}else{if(Ga>>>0>=Ha>>>0){Pa=Fa;Qa=Ga;break}Oa=Ga+1|0;c[U>>2]=Oa;c[ca>>2]=Fa;bb=Fa+sa|0;c[ba>>2]=bb;Za=bb;_a=Oa;$a=Ma;ab=ea(3402823469999999843913219.0e14);oa=32}if((oa|0)==32){oa=0;Ta=(c[$>>2]|0)+4|0;Ua=$a;Va=c[ca>>2]|0;Wa=ab;Xa=Za;Ya=_a}g[Ua>>2]=ea(g[Ta>>2]);g[Ua+4>>2]=ea(g[Ta+4>>2]);g[Ua+8>>2]=ea(g[Ta+8>>2]);g[f+(Ka<<6)+400>>2]=ea(g[Va>>2]);g[f+(Ka<<6)+404>>2]=ea(g[Va+4>>2]);g[f+(Ka<<6)+408>>2]=ea(g[Va+8>>2]);g[f+(Ka<<6)+396>>2]=ea(g[Va+12>>2]);if(va){c[f+(Ka<<6)+432>>2]=(e[Va+66>>1]|0)<<16|(e[Va+64>>1]|0);c[f+(Ka<<6)+436>>2]=c[Va+68>>2];g[f+(Ka<<6)+412>>2]=Wa;g[f+(Ka<<6)+428>>2]=ea(g[Va+52>>2]);g[f+(Ka<<6)+440>>2]=ea(g[Va+56>>2]);g[f+(Ka<<6)+444>>2]=ea(g[Va+60>>2]);cb=Va+36|0}else{Oa=c[$>>2]|0;c[f+(Ka<<6)+432>>2]=(e[Oa+30>>1]|0)<<16|(e[Oa+28>>1]|0);c[f+(Ka<<6)+436>>2]=e[(c[$>>2]|0)+2>>1];g[f+(Ka<<6)+412>>2]=Wa;g[f+(Ka<<6)+428>>2]=ea(g[(c[$>>2]|0)+16>>2]);g[f+(Ka<<6)+440>>2]=ea(g[(c[$>>2]|0)+20>>2]);g[f+(Ka<<6)+444>>2]=ea(g[(c[$>>2]|0)+24>>2]);cb=B}g[f+(Ka<<6)+416>>2]=ea(g[cb>>2]);Oa=cb+4|0;g[f+(Ka<<6)+420>>2]=ea(g[Oa>>2]);bb=cb+8|0;g[f+(Ka<<6)+424>>2]=ea(g[bb>>2]);if(va)if(ea(g[cb>>2])==ea(0.0)?ea(g[Oa>>2])==ea(0.0):0)db=ea(g[bb>>2])!=ea(0.0);else db=1;else db=0;Ga=Ya;Fa=Xa;Ka=Ka+1|0;La=La|db}za=c[aa>>2]|0;Aa=c[V>>2]|0;pa=za;if((pa-Aa|0)>>>0>=qa>>>0){eb=Ka;fb=La;break}else{ja=Pa;ya=Qa;xa=Ha;Da=Ka;Ea=La}}}else{eb=ga;fb=0}}else{eb=ga;fb=0}Ea=c[ia>>2]|0;c[M>>2]=eb;if((eb|0)==(Ea|0)){na=1;oa=82;break}c[v+(fa*56|0)+16>>2]=eb-Ea;a[v+(fa*56|0)+52>>0]=fb&1;Ea=v+(fa*56|0)+4|0;c[Ea>>2]=c[O>>2];if((!fb?(Da=c[ha>>2]|0,(b[Da+22>>1]&4)==0):0)?!($1a(N,c[Da+40>>2]|0,c[Da+36>>2]|0,c[v+(fa*56|0)+28>>2]|0,c[v+(fa*56|0)+32>>2]|0,s)|0):0){na=1;oa=82;break}Da=v+(fa*56|0)+20|0;c[Da>>2]=c[P>>2];if(!(Zza(f,c[ia>>2]|0,ea(.999000012))|0)){na=1;oa=82;break}xa=c[Da>>2]|0;c[v+(fa*56|0)+24>>2]=(c[P>>2]|0)-xa;Da=v+(fa*56|0)+28|0;ya=v+(fa*56|0)+32|0;if($za(N,L,c[Da>>2]|0,c[ya>>2]|0,ea(.999000012),xa,c[Ea>>2]|0)|0){na=1;oa=82;break}bAa(N,L,c[Da>>2]|0,c[ya>>2]|0,s,c[Ea>>2]|0,r);ya=c[O>>2]|0;Da=c[Ea>>2]|0;if(ya>>>0>Da>>>0){Ea=ya;xa=ya;while(1){ja=xa;xa=xa+-1|0;if((c[f+(xa<<2)+8464>>2]|0)==65535){if(ja>>>0<Ea>>>0){qa=ja;do{ja=qa+-1|0;c[f+(ja<<2)+8464>>2]=c[f+(qa<<2)+8464>>2];c[f+(ja<<2)+8336>>2]=c[f+(qa<<2)+8336>>2];qa=qa+1|0;ja=c[O>>2]|0}while(qa>>>0<ja>>>0);gb=ja}else gb=Ea;qa=gb+-1|0;c[O>>2]=qa;hb=qa}else hb=Ea;if(xa>>>0<=Da>>>0){ib=hb;break}else Ea=hb}}else ib=ya;c[v+(fa*56|0)+8>>2]=ib-Da;fa=fa+1|0;if(fa>>>0>=4){oa=2;break}else ga=eb}if((oa|0)==2){eb=f+348|0;ga=f+352|0;fa=f+344|0;ib=0;do{hb=d+(ib<<2)|0;O=v+(ib*56|0)+4|0;gb=c[O>>2]|0;L=v+(ib*56|0)+8|0;N=(c[L>>2]|0)+gb|0;if(gb>>>0<N>>>0){P=gb;gb=0;do{gb=((c[f+(P<<2)+8464>>2]|0)!=65535&1)+gb|0;P=P+1|0}while((P|0)!=(N|0));N=gb*96|0;if(!N){jb=1;kb=0;lb=gb}else{do if(N>>>0>16384)mb=-1;else{P=c[eb>>2]|0;if((P|0)!=0?(Da=c[ga>>2]|0,(Da+N|0)>>>0<=16384):0){nb=P;ob=Da}else{Da=VAa(c[fa>>2]|0)|0;c[eb>>2]=Da;c[ga>>2]=0;if(!Da){mb=0;break}else{nb=Da;ob=0}}c[ga>>2]=ob+N;mb=nb+ob|0}while(0);jb=0;kb=(mb|0)==0|(mb|0)!=(-1|0)?mb:0;lb=gb}}else{jb=1;kb=0;lb=0}c[(c[hb>>2]|0)+40>>2]=0;N=c[hb>>2]|0;c[N+36>>2]=0;if(!(jb|(kb|0)!=0)){na=0;oa=82;break}c[N+40>>2]=kb;c[(c[hb>>2]|0)+36>>2]=lb;if((kb|0)!=0?(N=c[L>>2]|0,(N|0)!=0):0){Da=N;N=kb;P=0;while(1){ya=(c[O>>2]|0)+P|0;if((c[f+(ya<<2)+8464>>2]|0)==65535){pb=Da;qb=N}else{a[N>>0]=a[f+(ya*96|0)+5264>>0]|0;b[N+16>>1]=b[f+(ya*96|0)+5280>>1]|0;g[N+24>>2]=ea(g[f+(ya*96|0)+5288>>2]);g[N+28>>2]=ea(g[f+(ya*96|0)+5292>>2]);g[N+32>>2]=ea(g[f+(ya*96|0)+5296>>2]);g[N+36>>2]=ea(g[f+(ya*96|0)+5300>>2]);g[N+40>>2]=ea(g[f+(ya*96|0)+5304>>2]);g[N+44>>2]=ea(g[f+(ya*96|0)+5308>>2]);g[N+48>>2]=ea(g[f+(ya*96|0)+5312>>2]);g[N+52>>2]=ea(g[f+(ya*96|0)+5316>>2]);g[N+56>>2]=ea(g[f+(ya*96|0)+5320>>2]);g[N+60>>2]=ea(g[f+(ya*96|0)+5324>>2]);g[N+64>>2]=ea(g[f+(ya*96|0)+5328>>2]);g[N+68>>2]=ea(g[f+(ya*96|0)+5332>>2]);g[N+72>>2]=ea(g[f+(ya*96|0)+5336>>2]);g[N+76>>2]=ea(g[f+(ya*96|0)+5340>>2]);g[N+80>>2]=ea(g[f+(ya*96|0)+5344>>2]);g[N+84>>2]=ea(g[f+(ya*96|0)+5348>>2]);g[N+88>>2]=ea(g[f+(ya*96|0)+5352>>2]);g[N+92>>2]=ea(g[f+(ya*96|0)+5356>>2]);b[N+20>>1]=b[f+(ya*96|0)+5284>>1]|0;b[N+18>>1]=b[f+(ya*96|0)+5282>>1]|0;b[N+22>>1]=b[f+(ya*96|0)+5286>>1]|0;pb=c[L>>2]|0;qb=N+96|0}P=P+1|0;if(P>>>0>=pb>>>0)break;else{Da=pb;N=qb}}}ib=ib+1|0}while(ib>>>0<4);if((oa|0)==82){i=u;return na|0}c[C>>2]=0;ib=f+316|0;wAa(v,C,D,f);qb=c[C>>2]|0;if(qb){if((qb+16|0)>>>0>16384){na=1;i=u;return na|0}C=qb+31&-16;do if(C>>>0>16384)rb=QAa(c[ib>>2]|0,C)|0;else{pb=f+320|0;kb=c[pb>>2]|0;lb=f+324|0;if((kb|0)!=0?(jb=c[lb>>2]|0,mb=jb+C|0,mb>>>0<=16384):0){c[lb>>2]=mb;rb=kb+jb|0;break}jb=SAa(c[ib>>2]|0,t)|0;c[pb>>2]=jb;c[lb>>2]=C;rb=jb}while(0);C=f+8776|0;c[C>>2]=(c[C>>2]|0)+qb;if((rb|0)==0|(rb|0)==(-1|0)&(rb|0)!=0){na=0;i=u;return na|0}else{sb=rb;tb=qb}}else{sb=0;tb=0}qb=tb>>>4&65535;c[c[d>>2]>>2]=sb;rb=c[d>>2]|0;c[rb+4>>2]=tb;C=rb+16|0;b[C>>1]=(e[C>>1]|0)+(c[D>>2]|0);c[(c[h>>2]|0)+16>>2]=sb;C=c[h>>2]|0;b[C+26>>1]=qb;rb=c[d>>2]|0;if(!(b[rb+98>>1]&16)){ub=0;vb=0}else{ub=(c[rb+28>>2]|0)+((c[rb+32>>2]|0)+15&-16)|0;vb=b[rb+20>>1]|0}c[C+20>>2]=ub;b[(c[h>>2]|0)+24>>1]=vb;vb=d+4|0;c[c[vb>>2]>>2]=sb;h=c[vb>>2]|0;c[h+4>>2]=tb;ub=h+16|0;b[ub>>1]=(e[ub>>1]|0)+(c[D+4>>2]|0);c[(c[I>>2]|0)+16>>2]=sb;ub=c[I>>2]|0;b[ub+26>>1]=qb;h=c[vb>>2]|0;if(!(b[h+98>>1]&16)){wb=0;xb=0}else{wb=(c[h+28>>2]|0)+((c[h+32>>2]|0)+15&-16)|0;xb=b[h+20>>1]|0}c[ub+20>>2]=wb;b[(c[I>>2]|0)+24>>1]=xb;xb=d+8|0;c[c[xb>>2]>>2]=sb;I=c[xb>>2]|0;c[I+4>>2]=tb;wb=I+16|0;b[wb>>1]=(e[wb>>1]|0)+(c[D+8>>2]|0);c[(c[J>>2]|0)+16>>2]=sb;wb=c[J>>2]|0;b[wb+26>>1]=qb;I=c[xb>>2]|0;if(!(b[I+98>>1]&16)){yb=0;zb=0}else{yb=(c[I+28>>2]|0)+((c[I+32>>2]|0)+15&-16)|0;zb=b[I+20>>1]|0}c[wb+20>>2]=yb;b[(c[J>>2]|0)+24>>1]=zb;zb=d+12|0;c[c[zb>>2]>>2]=sb;d=c[zb>>2]|0;c[d+4>>2]=tb;J=d+16|0;b[J>>1]=(e[J>>1]|0)+(c[D+12>>2]|0);c[(c[K>>2]|0)+16>>2]=sb;D=c[K>>2]|0;b[D+26>>1]=qb;qb=c[zb>>2]|0;if(!(b[qb+98>>1]&16)){Ab=0;Bb=0}else{Ab=(c[qb+28>>2]|0)+((c[qb+32>>2]|0)+15&-16)|0;Bb=b[qb+20>>1]|0}c[D+20>>2]=Ab;b[(c[K>>2]|0)+24>>1]=Bb;r=ea(g[x>>2]);s=ea(g[x+4>>2]);Wa=ea(g[x+8>>2]);ab=ea(g[x+12>>2]);g[E>>2]=r;g[E+4>>2]=s;g[E+8>>2]=Wa;g[E+12>>2]=ab;ab=ea(g[z>>2]);Wa=ea(g[z+4>>2]);s=ea(g[z+8>>2]);r=ea(g[z+12>>2]);g[F>>2]=ab;g[F+4>>2]=Wa;g[F+8>>2]=s;g[F+12>>2]=r;r=ea(g[y>>2]);s=ea(g[y+4>>2]);Wa=ea(g[y+8>>2]);ab=ea(g[y+12>>2]);g[G>>2]=r;g[G+4>>2]=s;g[G+8>>2]=Wa;g[G+12>>2]=ab;ab=ea(g[A>>2]);Wa=ea(g[A+4>>2]);s=ea(g[A+8>>2]);r=ea(g[A+12>>2]);g[H>>2]=ab;g[H+4>>2]=Wa;g[H+8>>2]=s;g[H+12>>2]=r;Cwa(v,f,sb,p,q,E,F,G,H);c[sb+tb>>2]=0;na=2;i=u;return na|0}else if((oa|0)==82){i=u;return na|0}return 0}function wAa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;i=i+256|0;j=h+128|0;k=h;l=j+0|0;m=l+128|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=k+0|0;m=l+128|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=0;m=0;do{n=c[a+(l*56|0)+8>>2]|0;if(!n){o=0;p=0}else{q=c[a+(l*56|0)+4>>2]|0;r=0;s=0;while(1){t=q+s|0;if(!(b[g+(t*96|0)+5286>>1]&1))u=(b[g+(t*96|0)+5280>>1]|0)!=0;else u=0;v=c[g+(t<<2)+8336>>2]|0;if(v){w=j+(s<<2)|0;x=c[w>>2]|0;c[w>>2]=v>>>0<x>>>0?x:v;x=v+r|0;if(u){v=e[g+(t*96|0)+5280>>1]<<1;t=k+(s<<2)|0;w=c[t>>2]|0;c[t>>2]=v>>>0<w>>>0?w:v;y=v+x|0}else y=x}else y=r;s=s+1|0;if(s>>>0>=n>>>0){o=n;p=y;break}else r=y}}m=o>>>0<m>>>0?m:o;c[f+(l<<2)>>2]=p;l=l+1|0}while((l|0)!=4);if(!m){z=0;A=0}else{l=0;p=0;f=0;while(1){o=(c[j+(l<<2)>>2]|0)+p|0;y=(c[k+(l<<2)>>2]|0)+f|0;l=l+1|0;if(l>>>0>=m>>>0){z=o;A=y;break}else{p=o;f=y}}}f=m*144|0;if(!((b[(c[a+56>>2]|0)+22>>1]|b[(c[a>>2]|0)+22>>1]|b[(c[a+112>>2]|0)+22>>1]|b[(c[a+168>>2]|0)+22>>1])&64)){B=(A*240|0)+(z*176|0)|0;C=f|15;D=C+B|0;E=D&-16;c[d>>2]=E;i=h;return}else{B=(A*336|0)+(z*272|0)|0;C=f|15;D=C+B|0;E=D&-16;c[d>>2]=E;i=h;return}}function xAa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=0,ba=Im,ca=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=0,La=Im,Ma=Im,Na=0,Oa=0,Pa=0,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=0,Wa=0,Xa=Im,Ya=Im,Za=0,_a=0,$a=0,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=0,gb=0;x=i;i=i+96|0;y=x;z=x+16|0;A=x+44|0;B=x+72|0;C=x+80|0;D=x+24|0;E=x+56|0;F=x+8|0;G=x+32|0;if(!f){b[j>>1]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;b[o>>1]=e[o>>1]&65519;H=0;i=x;return H|0}I=f<<1;J=I>>>0>1024;K=y+4|0;a[K>>0]=J&1;if(J){J=sKa(x+92|0,I,501464,1205)|0;c[y>>2]=J;L=J}else{J=i;i=i+((1*I|0)+15&-16)|0;c[y>>2]=J;L=J}J=d+48|0;if((c[J>>2]|0)==-1)M=(c[d+52>>2]|0)!=-1;else M=1;I=(r^1)&q;q=d+4|0;N=d+8|0;O=s+2|0;if(f>>>0>1){P=ea(g[N>>2]);Q=ea(g[q>>2]);R=ea(g[d>>2]);S=Q;Q=P;T=1;U=b[s>>1]|0;V=b[O>>1]|0;W=1;X=0;Y=f;while(1){P=ea(g[d+(T<<6)>>2]);Z=ea(R*P);_=ea(g[d+(T<<6)+4>>2]);$=ea(Z+ea(S*_));Z=ea(g[d+(T<<6)+8>>2]);aa=s+(T<<2)|0;if((!(ea($+ea(Q*Z))<ea(.999000012))?(b[aa>>1]|0)==U<<16>>16:0)?(b[s+(T<<2)+2>>1]|0)==V<<16>>16:0){ba=Q;ca=S;fa=R;ga=U;ha=V;ia=W;ja=X;ka=Y}else{b[L+(W+-1<<1)>>1]=T;if(w)la=((T-X|0)>>>0>1&1)+Y|0;else la=Y;ba=Z;ca=_;fa=P;ga=b[aa>>1]|0;ha=b[s+(T<<2)+2>>1]|0;ia=W+1|0;ja=T;ka=la}T=T+1|0;if((T|0)==(f|0)){ma=ia;na=ja;oa=ka;break}else{R=fa;S=ca;Q=ba;U=ga;V=ha;W=ia;X=ja;Y=ka}}}else{ma=1;na=0;oa=f}if(w){ka=((f-na|0)>>>0>1&1)+oa|0;if(!n){pa=ka;qa=0}else{pa=ka;qa=(ka-f<<2)+n|0}}else{pa=oa;qa=n}b[L+(ma+-1<<1)>>1]=f;if(I)ra=72;else ra=M?24:16;f=da(ra,pa)|0;ra=(I?20:4)+t+(I?4:ma<<5)+f|0;f=ra+15&-16;n=f+qa|0;do if(u){oa=h+316|0;ka=n+15&-16;if(ka>>>0>16384){sa=QAa(c[oa>>2]|0,ka)|0;break}na=h+320|0;Y=c[na>>2]|0;ja=h+324|0;if((Y|0)!=0?(X=c[ja>>2]|0,ia=X+ka|0,ia>>>0<=16384):0){c[ja>>2]=ia;sa=Y+X|0;break}X=SAa(c[oa>>2]|0,v+300|0)|0;c[na>>2]=X;c[ja>>2]=ka;sa=X}else{X=h+332|0;ka=n+15&-16;if(ka>>>0>16384){sa=QAa(c[X>>2]|0,ka)|0;break}ja=h+336|0;na=c[ja>>2]|0;oa=h+340|0;if((na|0)!=0?(Y=c[oa>>2]|0,ia=Y+ka|0,ia>>>0<=16384):0){c[oa>>2]=ia;sa=na+Y|0;break}Y=TAa(c[X>>2]|0)|0;c[ja>>2]=Y;c[oa>>2]=ka;sa=Y}while(0);c[k>>2]=sa;if(!sa){b[j>>1]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;b[o>>1]=e[o>>1]&65519;ta=0}else{k=h+8772|0;c[k>>2]=(c[k>>2]|0)+ra;c[l>>2]=ra;l=b[s>>1]|0;k=b[O>>1]|0;O=c[p>>2]|0;h=O+((l&65535)<<5)|0;n=O+((k&65535)<<5)|0;ba=ea(iva(h,n));hva(z,ea(1.0),ea(1.0));jva(A,z,h,n);Q=ea(g[A>>2]);ca=ea(g[A+4>>2]);n=c[A+8>>2]|0;b[sa+(t+2)>>1]=(I?2:0)|(r?4:0)|M&1;r=pa&65535;b[sa+t>>1]=r;pa=sa+(t+4)|0;do if(I){g[pa>>2]=ea(1.0);g[sa+(t+8)>>2]=ea(1.0);g[sa+(t+12)>>2]=ea(1.0);g[sa+(t+16)>>2]=ea(1.0);if(ma){A=sa+(t+20)|0;h=sa+(t+22)|0;z=d+52|0;O=C+4|0;v=C+8|0;u=0;S=ba;fa=ca;Y=n;ka=l;oa=k;ja=sa+(t+24)|0;X=0;R=Q;while(1){na=b[s+(X<<2)>>1]|0;ia=b[s+(X<<2)+2>>1]|0;if(na<<16>>16==ka<<16>>16?ia<<16>>16==oa<<16>>16:0){ua=S;va=fa;wa=Y;xa=ka;ya=oa;za=R}else{W=c[p>>2]|0;ha=W+((na&65535)<<5)|0;V=W+((ia&65535)<<5)|0;P=ea(iva(ha,V));hva(B,ea(1.0),ea(1.0));jva(C,B,ha,V);_=ea(g[C>>2]);Z=ea(g[O>>2]);ua=P;va=Z;wa=c[v>>2]|0;xa=na;ya=ia;za=_}b[A>>1]=r;b[h>>1]=wa;V=L+(u<<1)|0;ha=e[V>>1]|0;if(w?(W=ha-X|0,W>>>0>1):0){_=ea(ea(1.0)/ea(W>>>0));if(X>>>0<ha>>>0){Z=ea(0.0);P=ea(0.0);$=ea(0.0);Aa=ea(0.0);W=X;while(1){Ba=ea(Z+ea(g[d+(W<<6)+16>>2]));Ca=ea(P+ea(g[d+(W<<6)+20>>2]));Da=ea($+ea(g[d+(W<<6)+24>>2]));Ea=ea(Aa+ea(g[d+(W<<6)+12>>2]));W=W+1|0;if((W|0)==(ha|0)){Fa=Da;Ga=Ca;Ha=Ba;Ia=Ea;break}else{Z=Ba;P=Ca;$=Da;Aa=Ea}}}else{Fa=ea(0.0);Ga=ea(0.0);Ha=ea(0.0);Ia=ea(0.0)}Aa=ea(_*Ga);$=ea(_*Fa);g[ja>>2]=ea(_*Ha);g[ja+4>>2]=Aa;g[ja+8>>2]=$;g[ja+12>>2]=ea(_*Ia);c[ja+16>>2]=c[J>>2];c[ja+20>>2]=c[z>>2];g[ja+24>>2]=ea(g[d>>2]);g[ja+28>>2]=ea(g[q>>2]);g[ja+32>>2]=ea(g[N>>2]);g[ja+48>>2]=ea(3402823469999999843913219.0e14);g[ja+36>>2]=ea(0.0);g[ja+40>>2]=ea(0.0);g[ja+44>>2]=ea(0.0);g[ja+52>>2]=za;g[ja+56>>2]=va;g[ja+60>>2]=ua;c[ja+68>>2]=wa;b[ja+64>>1]=na;b[ja+66>>1]=ia;Ja=ja+72|0}else Ja=ja;if(X>>>0<ha>>>0){W=ha-X|0;ga=X;U=Ja;while(1){g[U>>2]=ea(g[d+(ga<<6)+16>>2]);g[U+4>>2]=ea(g[d+(ga<<6)+20>>2]);g[U+8>>2]=ea(g[d+(ga<<6)+24>>2]);g[U+12>>2]=ea(g[d+(ga<<6)+12>>2]);c[U+16>>2]=c[d+(ga<<6)+48>>2];c[U+20>>2]=c[d+(ga<<6)+52>>2];g[U+24>>2]=ea(g[d+(ga<<6)>>2]);g[U+28>>2]=ea(g[d+(ga<<6)+4>>2]);g[U+32>>2]=ea(g[d+(ga<<6)+8>>2]);g[U+48>>2]=ea(3402823469999999843913219.0e14);g[U+36>>2]=ea(0.0);g[U+40>>2]=ea(0.0);g[U+44>>2]=ea(0.0);g[U+52>>2]=za;g[U+56>>2]=va;g[U+60>>2]=ua;c[U+68>>2]=wa;b[U+64>>1]=na;b[U+66>>1]=ia;ga=ga+1|0;if((ga|0)==(ha|0))break;else U=U+72|0}Ka=Ja+(W*72|0)|0}else Ka=Ja;u=u+1|0;if((u|0)==(ma|0))break;else{S=ua;fa=va;Y=wa;ka=xa;oa=ya;ja=Ka;X=e[V>>1]|0;R=za}}}}else{X=(ma|0)==0;if(M){if(X)break;ja=d+52|0;oa=E+4|0;ka=E+8|0;Y=0;R=ba;u=pa;fa=ca;z=n;h=l;A=k;v=0;S=Q;while(1){O=b[s+(v<<2)>>1]|0;U=b[s+(v<<2)+2>>1]|0;if(O<<16>>16==h<<16>>16?U<<16>>16==A<<16>>16:0){La=R;Ma=fa;Na=z;Oa=h;Pa=A;Qa=S}else{ha=c[p>>2]|0;ga=ha+((O&65535)<<5)|0;ia=ha+((U&65535)<<5)|0;_=ea(iva(ga,ia));hva(D,ea(1.0),ea(1.0));jva(E,D,ga,ia);$=ea(g[E>>2]);Aa=ea(g[oa>>2]);La=_;Ma=Aa;Na=c[ka>>2]|0;Oa=O;Pa=U;Qa=$}ia=u+32|0;ga=L+(Y<<1)|0;ha=e[ga>>1]|0;g[u+4>>2]=ea(g[d+(v<<6)>>2]);g[u+8>>2]=ea(g[d+(v<<6)+4>>2]);g[u+12>>2]=ea(g[d+(v<<6)+8>>2]);na=ha-v|0;T=na&65535;b[u>>1]=T;g[u+16>>2]=Qa;g[u+20>>2]=Ma;g[u+24>>2]=La;b[u+2>>1]=Na;b[u+28>>1]=O;b[u+30>>1]=U;if(na>>>0>1&w){b[u>>1]=T+1<<16>>16;$=ea(ea(1.0)/ea(na>>>0));if(v>>>0<ha>>>0){Aa=ea(0.0);_=ea(0.0);P=ea(0.0);Z=ea(0.0);na=v;while(1){Ea=ea(Aa+ea(g[d+(na<<6)+16>>2]));Da=ea(_+ea(g[d+(na<<6)+20>>2]));Ca=ea(P+ea(g[d+(na<<6)+24>>2]));Ba=ea(Z+ea(g[d+(na<<6)+12>>2]));na=na+1|0;if((na|0)==(ha|0)){Ra=Ca;Sa=Da;Ta=Ea;Ua=Ba;break}else{Aa=Ea;_=Da;P=Ca;Z=Ba}}}else{Ra=ea(0.0);Sa=ea(0.0);Ta=ea(0.0);Ua=ea(0.0)}Z=ea($*Sa);P=ea($*Ra);g[ia>>2]=ea($*Ta);g[u+36>>2]=Z;g[u+40>>2]=P;g[u+44>>2]=ea($*Ua);c[u+48>>2]=c[J>>2];c[u+52>>2]=c[ja>>2];Va=u+56|0}else Va=ia;if(v>>>0<ha>>>0){na=Va+((ha-v|0)*24|0)|0;V=v;W=Va;while(1){g[W>>2]=ea(g[d+(V<<6)+16>>2]);g[W+4>>2]=ea(g[d+(V<<6)+20>>2]);g[W+8>>2]=ea(g[d+(V<<6)+24>>2]);g[W+12>>2]=ea(g[d+(V<<6)+12>>2]);c[W+16>>2]=c[d+(V<<6)+48>>2];c[W+20>>2]=c[d+(V<<6)+52>>2];V=V+1|0;if((V|0)==(ha|0))break;else W=W+24|0}Wa=na}else Wa=Va;Y=Y+1|0;if((Y|0)==(ma|0))break;else{R=La;u=Wa;fa=Ma;z=Na;h=Oa;A=Pa;v=e[ga>>1]|0;S=Qa}}}else{if(X)break;v=G+4|0;A=G+8|0;h=0;S=ba;z=pa;fa=ca;u=n;Y=l;ja=k;ka=0;R=Q;while(1){oa=b[s+(ka<<2)>>1]|0;W=b[s+(ka<<2)+2>>1]|0;if(oa<<16>>16==Y<<16>>16?W<<16>>16==ja<<16>>16:0){Xa=S;Ya=fa;Za=u;_a=Y;$a=ja;ab=R}else{ha=c[p>>2]|0;V=ha+((oa&65535)<<5)|0;ia=ha+((W&65535)<<5)|0;$=ea(iva(V,ia));hva(F,ea(1.0),ea(1.0));jva(G,F,V,ia);P=ea(g[G>>2]);Z=ea(g[v>>2]);Xa=$;Ya=Z;Za=c[A>>2]|0;_a=oa;$a=W;ab=P}ia=z+32|0;V=L+(h<<1)|0;ha=e[V>>1]|0;g[z+4>>2]=ea(g[d+(ka<<6)>>2]);g[z+8>>2]=ea(g[d+(ka<<6)+4>>2]);g[z+12>>2]=ea(g[d+(ka<<6)+8>>2]);T=ha-ka|0;U=T&65535;b[z>>1]=U;g[z+16>>2]=ab;g[z+20>>2]=Ya;g[z+24>>2]=Xa;b[z+28>>1]=oa;b[z+30>>1]=W;b[z+2>>1]=Za;if(T>>>0>1&w){b[z>>1]=U+1<<16>>16;P=ea(ea(1.0)/ea(T>>>0));if(ka>>>0<ha>>>0){Z=ea(0.0);$=ea(0.0);_=ea(0.0);Aa=ea(0.0);T=ka;while(1){Ba=ea(Z+ea(g[d+(T<<6)+16>>2]));Ca=ea($+ea(g[d+(T<<6)+20>>2]));Da=ea(_+ea(g[d+(T<<6)+24>>2]));Ea=ea(Aa+ea(g[d+(T<<6)+12>>2]));T=T+1|0;if((T|0)==(ha|0)){bb=Da;cb=Ca;db=Ba;eb=Ea;break}else{Z=Ba;$=Ca;_=Da;Aa=Ea}}}else{bb=ea(0.0);cb=ea(0.0);db=ea(0.0);eb=ea(0.0)}Aa=ea(P*cb);_=ea(P*bb);g[ia>>2]=ea(P*db);g[z+36>>2]=Aa;g[z+40>>2]=_;g[z+44>>2]=ea(P*eb);fb=z+48|0}else fb=ia;if(ka>>>0<ha>>>0){T=fb+((ha<<4)-(ka<<4))|0;ga=ka;na=fb;while(1){g[na>>2]=ea(g[d+(ga<<6)+16>>2]);g[na+4>>2]=ea(g[d+(ga<<6)+20>>2]);g[na+8>>2]=ea(g[d+(ga<<6)+24>>2]);g[na+12>>2]=ea(g[d+(ga<<6)+12>>2]);ga=ga+1|0;if((ga|0)==(ha|0))break;else na=na+16|0}gb=T}else gb=fb;h=h+1|0;if((h|0)==(ma|0))break;else{S=Xa;z=gb;fa=Ya;u=Za;Y=_a;ja=$a;ka=e[V>>1]|0;R=ab}}}}while(0);if(qa){$a=sa+f|0;b[o>>1]=e[o>>1]|16;c[m>>2]=$a;PEi($a|0,0,qa|0)|0}b[j>>1]=r;ta=ra}if(!(a[K>>0]|0)){H=ta;i=x;return H|0}tKa(y,c[y>>2]|0);H=ta;i=x;return H|0}function yAa(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+16|0;j=h;k=d+98|0;l=f+4480|0;m=c[l>>2]|0;n=(m|0)==0;o=(n?1:2)|e[k>>1]&65516;p=d+40|0;q=c[p>>2]|0;if(!((q|0)!=0|n^1)){b[k>>1]=o;r=1;i=h;return r|0}s=b[d+22>>1]|0;t=d+20|0;b[t>>1]=m;u=(s&130)==0;v=u|n;n=v?(u?m:0):m;b[k>>1]=v?o&65515:o|4;o=(n|0)==0;c[p>>2]=o?0:q;q=n<<2;p=s&65535;do if((p&1|0)==0?(a[f+8770>>0]|0)==0:0)if(p&256){if((p&32|0)!=0?(c[(c[d+64>>2]|0)+92>>2]|0)!=2139095039:0){w=0;break}if(s&64)w=(c[(c[d+68>>2]|0)+92>>2]|0)==2139095039;else w=1}else w=1;else w=0;while(0);if(xAa(f+384|0,n,f,t,d+28|0,d+32|0,j,o|w?0:q,k,c[d+80>>2]|0,(s&128)!=0,0,g,0,0,0,(a[f+8771>>0]|0)!=0)|0){r=1;i=h;return r|0}r=(c[l>>2]|0)==0;i=h;return r|0}function zAa(a,d,f,g,h,j){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+256|0;k=d+128|0;l=d;m=k+0|0;n=m+128|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));m=l+0|0;n=m+128|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));m=0;n=0;do{o=c[a+(m*56|0)+8>>2]|0;if(!o){p=0;q=0}else{r=c[a+(m*56|0)+4>>2]|0;s=0;t=0;while(1){u=r+t|0;v=c[f+(u<<2)+1408>>2]|0;if(v){w=(b[f+(u*20|0)+786>>1]&1)==0;x=k+(t<<2)|0;y=c[x>>2]|0;c[x>>2]=v>>>0<y>>>0?y:v;y=v+s|0;if(w){w=e[f+(u*20|0)+784>>1]|0;u=l+(t<<2)|0;v=c[u>>2]|0;c[u>>2]=w>>>0<v>>>0?v:w;z=w+y|0}else z=y}else z=s;t=t+1|0;if(t>>>0>=o>>>0){p=o;q=z;break}else s=z}}n=p>>>0<n>>>0?n:p;c[h+(m<<2)>>2]=q;m=m+1|0}while((m|0)!=4);if(!n){A=0;B=0}else{m=0;q=0;h=0;while(1){p=(c[k+(m<<2)>>2]|0)+q|0;z=(c[l+(m<<2)>>2]|0)+h|0;m=m+1|0;if(m>>>0>=n>>>0){A=p;B=z;break}else{q=p;h=z}}}c[j>>2]=A;j=n*176|0;n=B+A|0;if(!((b[(c[a+56>>2]|0)+22>>1]|b[(c[a>>2]|0)+22>>1]|b[(c[a+112>>2]|0)+22>>1]|b[(c[a+168>>2]|0)+22>>1])&64)){C=n*192|0;D=C+j|0;c[g>>2]=D;i=d;return}else{C=n*288|0;D=C+j|0;c[g>>2]=D;i=d;return}}function AAa(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=ea(q);r=ea(r);s=ea(s);t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=Im,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=Im,Ua=0,Va=0,Wa=0,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;v=i;i=i+2288|0;w=v+1968|0;x=v+1936|0;y=v+64|0;z=v+1920|0;A=v+1904|0;B=v;C=v+48|0;D=v+2216|0;E=v+2192|0;F=v+2200|0;G=v+2196|0;H=v+16|0;I=v+1888|0;J=v+1872|0;K=v+32|0;b[(c[h>>2]|0)+26>>1]=0;L=h+4|0;b[(c[L>>2]|0)+26>>1]=0;M=h+8|0;b[(c[M>>2]|0)+26>>1]=0;N=h+12|0;b[(c[N>>2]|0)+26>>1]=0;O=f+384|0;P=f+4480|0;c[P>>2]=0;g[x>>2]=ea(0.0);g[x+4>>2]=ea(0.0);g[x+8>>2]=ea(0.0);g[x+12>>2]=ea(1.0);g[x+16>>2]=ea(0.0);g[x+20>>2]=ea(0.0);g[x+24>>2]=ea(0.0);Q=y+1792|0;R=y+1796|0;S=(u|0)==1?1:2;u=D+4|0;T=D+8|0;U=D+36|0;V=D+40|0;W=D+44|0;X=D+12|0;Y=D+60|0;Z=D+56|0;_=D+64|0;$=D+48|0;aa=D+52|0;ba=D+24|0;ca=D+28|0;fa=D+16|0;ga=D+32|0;ha=Q;c[ha>>2]=0;c[ha+4>>2]=0;ha=0;ia=0;while(1){ja=d+(ha<<2)|0;ka=c[ja>>2]|0;la=b[ka+22>>1]|0;if(!(la&32)){c[w+(ha*56|0)+28>>2]=x;ma=ka;na=la}else{c[w+(ha*56|0)+28>>2]=c[n+(ha<<2)>>2];la=c[ja>>2]|0;ma=la;na=b[la+22>>1]|0}if(!(na&64)){c[w+(ha*56|0)+32>>2]=x;oa=ma}else{c[w+(ha*56|0)+32>>2]=c[o+(ha<<2)>>2];oa=c[ja>>2]|0}c[w+(ha*56|0)>>2]=oa;la=w+(ha*56|0)+12|0;c[la>>2]=ia;c[w+(ha*56|0)+36>>2]=c[j+(ha<<2)>>2];c[w+(ha*56|0)+40>>2]=c[k+(ha<<2)>>2];c[w+(ha*56|0)+44>>2]=c[l+(ha<<2)>>2];c[w+(ha*56|0)+48>>2]=c[m+(ha<<2)>>2];ka=c[ja>>2]|0;if(((e[ka+20>>1]|0)+ia|0)>>>0>64){pa=1;qa=55;break}ja=c[ka+28>>2]|0;ra=c[ka+32>>2]|0;g[D>>2]=ea(0.0);g[u>>2]=ea(0.0);g[T>>2]=ea(0.0);c[U>>2]=ra;c[V>>2]=0;c[W>>2]=0;c[X>>2]=ja;if(!ra){sa=0;ta=0;ua=0;va=0;wa=0;xa=1}else{ka=b[ja+2>>1]|0;ya=ka&65535;za=ya&2;Aa=(za|0)!=0;Ba=ya&1;if(Aa)Ca=72;else Ca=Ba<<3|16;sa=Aa?4:32;ta=Ca;ua=ja+(za<<3|4)|0;va=(Ba|0)!=0;wa=Aa;xa=(ka&4)!=0}c[Y>>2]=wa&1;c[Z>>2]=va&1;c[_>>2]=xa&1;c[$>>2]=sa;c[aa>>2]=ta;c[ba>>2]=ua;c[ca>>2]=ua;c[fa>>2]=ua;if(!xa){if(wa){g[z+(ha<<2)>>2]=ea(g[ja+4>>2]);g[A+(ha<<2)>>2]=ea(g[ja+8>>2]);g[B+(ha<<2)>>2]=ea(g[ja+12>>2]);Da=ea(g[ja+16>>2])}else{g[z+(ha<<2)>>2]=ea(1.0);g[A+(ha<<2)>>2]=ea(1.0);g[B+(ha<<2)>>2]=ea(1.0);Da=ea(1.0)}g[C+(ha<<2)>>2]=Da;ka=ua;if((ka-ja|0)>>>0<ra>>>0){Aa=ua;Ba=ja;ja=ka;ka=ua;za=0;ya=0;Ea=ia;Fa=0;while(1){c[ba>>2]=Aa;if((ja-Ba|0)>>>0<ra>>>0){Ga=e[Aa>>1]|0;c[V>>2]=Ga;c[ca>>2]=Aa+((da(ta,Ga)|0)+sa);Ha=Aa+sa|0;c[fa>>2]=Ha;c[W>>2]=0;Ia=Ga;Ja=Ha;Ka=0}else{c[ca>>2]=Aa;Ia=ya;Ja=ka;Ka=za}Ha=Ka;Ga=Ja;La=Ea;Ma=Fa;a:while(1){Na=f+(La<<6)+384|0;if(wa){Oa=Ha;Pa=Ga;while(1){if(Oa>>>0>=Ia>>>0){Qa=Pa;Ra=Oa;break a}Oa=Oa+1|0;c[W>>2]=Oa;c[ga>>2]=Pa;Sa=Pa+ta|0;c[fa>>2]=Sa;Ta=ea(g[(c[ga>>2]|0)+48>>2]);if(Ta!=ea(0.0))break;else Pa=Sa}if(wa){Pa=c[ga>>2]|0;Ua=Pa+24|0;Va=Na;Wa=Pa;Xa=Ta;Ya=Sa;Za=Oa}else{_a=Sa;$a=Oa;ab=Na;bb=Ta;qa=31}}else{if(Ha>>>0>=Ia>>>0){Qa=Ga;Ra=Ha;break}Pa=Ha+1|0;c[W>>2]=Pa;c[ga>>2]=Ga;cb=Ga+ta|0;c[fa>>2]=cb;_a=cb;$a=Pa;ab=Na;bb=ea(3402823469999999843913219.0e14);qa=31}if((qa|0)==31){qa=0;Ua=(c[ba>>2]|0)+4|0;Va=ab;Wa=c[ga>>2]|0;Xa=bb;Ya=_a;Za=$a}g[Va>>2]=ea(g[Ua>>2]);g[Va+4>>2]=ea(g[Ua+4>>2]);g[Va+8>>2]=ea(g[Ua+8>>2]);g[f+(La<<6)+400>>2]=ea(g[Wa>>2]);g[f+(La<<6)+404>>2]=ea(g[Wa+4>>2]);g[f+(La<<6)+408>>2]=ea(g[Wa+8>>2]);g[f+(La<<6)+396>>2]=ea(g[Wa+12>>2]);if(wa){c[f+(La<<6)+432>>2]=(e[Wa+66>>1]|0)<<16|(e[Wa+64>>1]|0);c[f+(La<<6)+436>>2]=c[Wa+68>>2];g[f+(La<<6)+412>>2]=Xa;g[f+(La<<6)+428>>2]=ea(g[Wa+52>>2]);g[f+(La<<6)+440>>2]=ea(g[Wa+56>>2]);g[f+(La<<6)+444>>2]=ea(g[Wa+60>>2]);db=Wa+36|0}else{Pa=c[ba>>2]|0;c[f+(La<<6)+432>>2]=(e[Pa+30>>1]|0)<<16|(e[Pa+28>>1]|0);c[f+(La<<6)+436>>2]=e[(c[ba>>2]|0)+2>>1];g[f+(La<<6)+412>>2]=Xa;g[f+(La<<6)+428>>2]=ea(g[(c[ba>>2]|0)+16>>2]);g[f+(La<<6)+440>>2]=ea(g[(c[ba>>2]|0)+20>>2]);g[f+(La<<6)+444>>2]=ea(g[(c[ba>>2]|0)+24>>2]);db=D}g[f+(La<<6)+416>>2]=ea(g[db>>2]);Pa=db+4|0;g[f+(La<<6)+420>>2]=ea(g[Pa>>2]);cb=db+8|0;g[f+(La<<6)+424>>2]=ea(g[cb>>2]);if(wa)if(ea(g[db>>2])==ea(0.0)?ea(g[Pa>>2])==ea(0.0):0)eb=ea(g[cb>>2])!=ea(0.0);else eb=1;else eb=0;Ha=Za;Ga=Ya;La=La+1|0;Ma=Ma|eb}Aa=c[ca>>2]|0;Ba=c[X>>2]|0;ja=Aa;if((ja-Ba|0)>>>0>=ra>>>0){fb=La;gb=Ma;break}else{ka=Qa;za=Ra;ya=Ia;Ea=La;Fa=Ma}}}else{fb=ia;gb=0}}else{fb=ia;gb=0}Fa=c[la>>2]|0;c[P>>2]=fb;if((fb|0)==(Fa|0)){pa=1;qa=55;break}c[w+(ha*56|0)+16>>2]=fb-Fa;a[w+(ha*56|0)+52>>0]=gb&1;Ea=c[R>>2]|0;c[w+(ha*56|0)+4>>2]=Ea;ya=c[Q>>2]|0;c[w+(ha*56|0)+20>>2]=ya;_za(y,O,ea(.999000012),Fa)|0;if(aAa(y,O,c[w+(ha*56|0)+28>>2]|0,c[w+(ha*56|0)+32>>2]|0,ea(.999000012),S,ya,Ea)|0){pa=1;qa=55;break}c[w+(ha*56|0)+24>>2]=(c[Q>>2]|0)-ya;c[w+(ha*56|0)+8>>2]=(c[R>>2]|0)-Ea;ha=ha+1|0;if(ha>>>0>=4){qa=43;break}else ia=fb}if((qa|0)==43){c[E>>2]=0;c[G>>2]=0;fb=f+316|0;zAa(w,f,y,E,F,G);ia=c[E>>2]|0;if(ia){if((ia+16|0)>>>0>16384){pa=1;i=v;return pa|0}E=ia+31&-16;do if(E>>>0>16384)hb=QAa(c[fb>>2]|0,E)|0;else{ha=f+320|0;R=c[ha>>2]|0;Q=f+324|0;if((R|0)!=0?(O=c[Q>>2]|0,gb=O+E|0,gb>>>0<=16384):0){c[Q>>2]=gb;hb=R+O|0;break}O=SAa(c[fb>>2]|0,t)|0;c[ha>>2]=O;c[Q>>2]=E;hb=O}while(0);if((hb|0)==0|(hb|0)==(-1|0)&(hb|0)!=0){pa=0;i=v;return pa|0}else{ib=hb;jb=ia}}else{ib=0;jb=0}ia=jb>>>4&65535;c[c[d>>2]>>2]=ib;c[(c[h>>2]|0)+16>>2]=ib;hb=c[d>>2]|0;c[hb+4>>2]=jb;E=hb+16|0;b[E>>1]=(e[E>>1]|0)+(c[F>>2]|0);E=c[h>>2]|0;b[E+26>>1]=ia;if(!(b[hb+98>>1]&16)){kb=0;lb=0}else{kb=(c[hb+28>>2]|0)+((c[hb+32>>2]|0)+15&-16)|0;lb=b[hb+20>>1]|0}c[E+20>>2]=kb;b[(c[h>>2]|0)+24>>1]=lb;lb=d+4|0;c[c[lb>>2]>>2]=ib;c[(c[L>>2]|0)+16>>2]=ib;h=c[lb>>2]|0;c[h+4>>2]=jb;lb=h+16|0;b[lb>>1]=(e[lb>>1]|0)+(c[F+4>>2]|0);lb=c[L>>2]|0;b[lb+26>>1]=ia;if(!(b[h+98>>1]&16)){mb=0;nb=0}else{mb=(c[h+28>>2]|0)+((c[h+32>>2]|0)+15&-16)|0;nb=b[h+20>>1]|0}c[lb+20>>2]=mb;b[(c[L>>2]|0)+24>>1]=nb;nb=d+8|0;c[c[nb>>2]>>2]=ib;c[(c[M>>2]|0)+16>>2]=ib;L=c[nb>>2]|0;c[L+4>>2]=jb;nb=L+16|0;b[nb>>1]=(e[nb>>1]|0)+(c[F+8>>2]|0);nb=c[M>>2]|0;b[nb+26>>1]=ia;if(!(b[L+98>>1]&16)){ob=0;pb=0}else{ob=(c[L+28>>2]|0)+((c[L+32>>2]|0)+15&-16)|0;pb=b[L+20>>1]|0}c[nb+20>>2]=ob;b[(c[M>>2]|0)+24>>1]=pb;pb=d+12|0;c[c[pb>>2]>>2]=ib;c[(c[N>>2]|0)+16>>2]=ib;d=c[pb>>2]|0;c[d+4>>2]=jb;pb=d+16|0;b[pb>>1]=(e[pb>>1]|0)+(c[F+12>>2]|0);F=c[N>>2]|0;b[F+26>>1]=ia;if(!(b[d+98>>1]&16)){qb=0;rb=0}else{qb=(c[d+28>>2]|0)+((c[d+32>>2]|0)+15&-16)|0;rb=b[d+20>>1]|0}c[F+20>>2]=qb;b[(c[N>>2]|0)+24>>1]=rb;Xa=ea(g[z>>2]);bb=ea(g[z+4>>2]);Ta=ea(g[z+8>>2]);Da=ea(g[z+12>>2]);g[H>>2]=Xa;g[H+4>>2]=bb;g[H+8>>2]=Ta;g[H+12>>2]=Da;Da=ea(g[B>>2]);Ta=ea(g[B+4>>2]);bb=ea(g[B+8>>2]);Xa=ea(g[B+12>>2]);g[I>>2]=Da;g[I+4>>2]=Ta;g[I+8>>2]=bb;g[I+12>>2]=Xa;Xa=ea(g[A>>2]);bb=ea(g[A+4>>2]);Ta=ea(g[A+8>>2]);Da=ea(g[A+12>>2]);g[J>>2]=Xa;g[J+4>>2]=bb;g[J+8>>2]=Ta;g[J+12>>2]=Da;Da=ea(g[C>>2]);Ta=ea(g[C+4>>2]);bb=ea(g[C+8>>2]);Xa=ea(g[C+12>>2]);g[K>>2]=Da;g[K+4>>2]=Ta;g[K+8>>2]=bb;g[K+12>>2]=Xa;C=Dwa(w,f,ib,p,q,y,S,c[G>>2]|0,jb,H,I,J,K)|0;c[ib+jb>>2]=0;c[ib+(jb+4)>>2]=C<<31>>31;pa=2;i=v;return pa|0}else if((qa|0)==55){i=v;return pa|0}return 0}function BAa(a,d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);r=ea(r);s=ea(s);t=ea(t);u=u|0;v=v|0;var w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=0,ya=0,za=0,Aa=Im,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;f=i;i=i+1936|0;w=f+1900|0;x=f+1832|0;y=f;z=f+1820|0;A=f+1808|0;B=h&1;b[j+26>>1]=0;h=d+384|0;C=d+4480|0;c[C>>2]=0;D=a+40|0;g[w>>2]=ea(0.0);g[w+4>>2]=ea(0.0);g[w+8>>2]=ea(0.0);g[w+12>>2]=ea(1.0);g[w+16>>2]=ea(0.0);g[w+20>>2]=ea(0.0);g[w+24>>2]=ea(0.0);E=a+22|0;F=b[E>>1]|0;G=(F&32)==0?w:o;o=(F&64)==0?w:p;p=c[a+28>>2]|0;do if(p){w=c[a+32>>2]|0;g[x>>2]=ea(0.0);g[x+4>>2]=ea(0.0);g[x+8>>2]=ea(0.0);c[x+36>>2]=w;F=x+40|0;c[F>>2]=0;H=x+44|0;c[H>>2]=0;I=x+12|0;c[I>>2]=p;if(!w){J=0;K=0;L=0;M=0;N=0;O=1}else{P=b[p+2>>1]|0;Q=P&65535;R=Q&2;S=(R|0)!=0;T=Q&1;if(S)U=72;else U=T<<3|16;J=S?4:32;K=U;L=p+(R<<3|4)|0;M=(T|0)!=0;N=S;O=(P&4)!=0}P=N&1;c[x+60>>2]=P;c[x+56>>2]=M&1;c[x+64>>2]=O&1;c[x+48>>2]=J;c[x+52>>2]=K;S=x+24|0;c[S>>2]=L;T=x+28|0;c[T>>2]=L;R=x+16|0;c[R>>2]=L;if(!O){if(N){t=ea(g[p+4>>2]);s=ea(g[p+8>>2]);V=ea(g[p+12>>2]);W=t;X=V;Y=s;Z=ea(g[p+16>>2]);_=P}else{W=ea(1.0);X=ea(1.0);Y=ea(1.0);Z=ea(1.0);_=0}P=L;if((P-p|0)>>>0>=w>>>0){c[C>>2]=0;break}Q=x+32|0;$=(_|0)==0;aa=B;ba=L;ca=0;fa=0;ga=L;ha=p;ia=P;P=0;while(1){c[S>>2]=ga;if((ia-ha|0)>>>0<w>>>0){ja=e[ga>>1]|0;c[F>>2]=ja;c[T>>2]=ga+((da(K,ja)|0)+J);ka=ga+J|0;c[R>>2]=ka;c[H>>2]=0;la=ka;ma=0;na=ja}else{c[T>>2]=ga;la=ba;ma=ca;na=fa}oa=aa;ja=ma;ka=la;pa=P;a:while(1){qa=d+(pa<<6)+384|0;if(!$){ra=ka;sa=ja;while(1){if(sa>>>0>=na>>>0){ta=ra;ua=sa;break a}sa=sa+1|0;c[H>>2]=sa;c[Q>>2]=ra;va=ra+K|0;c[R>>2]=va;wa=ea(g[(c[Q>>2]|0)+48>>2]);if(wa!=ea(0.0))break;else ra=va}if($){xa=va;ya=sa;za=qa;Aa=wa;Ba=24}else{ra=c[Q>>2]|0;Ca=ra+24|0;Da=qa;Ea=ra;Fa=wa;Ga=va;Ha=sa}}else{if(ja>>>0>=na>>>0){ta=ka;ua=ja;break}ra=ja+1|0;c[H>>2]=ra;c[Q>>2]=ka;Ia=ka+K|0;c[R>>2]=Ia;xa=Ia;ya=ra;za=qa;Aa=ea(3402823469999999843913219.0e14);Ba=24}if((Ba|0)==24){Ba=0;Ca=(c[S>>2]|0)+4|0;Da=za;Ea=c[Q>>2]|0;Fa=Aa;Ga=xa;Ha=ya}g[Da>>2]=ea(g[Ca>>2]);g[Da+4>>2]=ea(g[Ca+4>>2]);g[Da+8>>2]=ea(g[Ca+8>>2]);g[d+(pa<<6)+400>>2]=ea(g[Ea>>2]);g[d+(pa<<6)+404>>2]=ea(g[Ea+4>>2]);g[d+(pa<<6)+408>>2]=ea(g[Ea+8>>2]);g[d+(pa<<6)+396>>2]=ea(g[Ea+12>>2]);if($){ra=c[S>>2]|0;c[d+(pa<<6)+432>>2]=(e[ra+30>>1]|0)<<16|(e[ra+28>>1]|0);c[d+(pa<<6)+436>>2]=e[(c[S>>2]|0)+2>>1];g[d+(pa<<6)+412>>2]=Fa;g[d+(pa<<6)+428>>2]=ea(g[(c[S>>2]|0)+16>>2]);g[d+(pa<<6)+440>>2]=ea(g[(c[S>>2]|0)+20>>2]);g[d+(pa<<6)+444>>2]=ea(g[(c[S>>2]|0)+24>>2]);Ja=x}else{c[d+(pa<<6)+432>>2]=(e[Ea+66>>1]|0)<<16|(e[Ea+64>>1]|0);c[d+(pa<<6)+436>>2]=c[Ea+68>>2];g[d+(pa<<6)+412>>2]=Fa;g[d+(pa<<6)+428>>2]=ea(g[Ea+52>>2]);g[d+(pa<<6)+440>>2]=ea(g[Ea+56>>2]);g[d+(pa<<6)+444>>2]=ea(g[Ea+60>>2]);Ja=Ea+36|0}g[d+(pa<<6)+416>>2]=ea(g[Ja>>2]);ra=Ja+4|0;g[d+(pa<<6)+420>>2]=ea(g[ra>>2]);Ia=Ja+8|0;g[d+(pa<<6)+424>>2]=ea(g[Ia>>2]);if(!$)if(ea(g[Ja>>2])==ea(0.0)?ea(g[ra>>2])==ea(0.0):0)Ka=ea(g[Ia>>2])!=ea(0.0);else Ka=1;else Ka=0;oa=(Ka&1|oa&1)&255;ja=Ha;ka=Ga;pa=pa+1|0}ga=c[T>>2]|0;ha=c[I>>2]|0;ia=ga;if((ia-ha|0)>>>0>=w>>>0)break;else{aa=oa;ba=ta;ca=ua;fa=na;P=pa}}c[C>>2]=pa;P=(oa&1)!=0;if(pa){c[y+1792>>2]=0;fa=y+1796|0;c[fa>>2]=0;_za(y,h,ea(.999000012),0)|0;ca=(v|0)==1?1:2;aAa(y,h,G,o,ea(.999000012),ca,0,0)|0;ba=b[E>>1]|0;aa=c[fa>>2]|0;if(aa)if(!(ba&24)){fa=0;w=0;ha=0;while(1){ia=c[y+(w<<2)+1408>>2]|0;if(ia){ga=ia+fa|0;I=ha+80+(ia*80|0)+((ia<<2)+12&-16)|0;if(!(b[y+(w*20|0)+786>>1]&1)){ia=e[y+(w*20|0)+784>>1]|0;La=ia+ga|0;Ma=(ia*96|0)+I|0}else{La=ga;Ma=I}}else{La=fa;Ma=ha}w=w+1|0;if((w|0)==(aa|0)){Na=La;Oa=Ma;break}else{fa=La;ha=Ma}}}else{ha=0;fa=0;w=0;while(1){I=c[y+(fa<<2)+1408>>2]|0;if(I){ga=I+ha|0;ia=w+80+(I*112|0)+((I<<2)+12&-16)|0;if(!(b[y+(fa*20|0)+786>>1]&1)){I=e[y+(fa*20|0)+784>>1]|0;Pa=I+ga|0;Qa=(I<<7)+ia|0}else{Pa=ga;Qa=ia}}else{Pa=ha;Qa=w}fa=fa+1|0;if((fa|0)==(aa|0)){Na=Pa;Oa=Qa;break}else{ha=Pa;w=Qa}}}else{Na=0;Oa=0}w=(ba&130)==0?0:Oa+15&-16;ha=(w|0)==0;if(ha){Ra=0;Sa=0}else{aa=d+316|0;fa=w+31&-16;do if(fa>>>0>16384)Ta=QAa(c[aa>>2]|0,fa)|0;else{ia=d+320|0;ga=c[ia>>2]|0;I=d+324|0;if((ga|0)!=0?(T=c[I>>2]|0,$=T+fa|0,$>>>0<=16384):0){c[I>>2]=$;Ta=ga+T|0;break}T=SAa(c[aa>>2]|0,u)|0;c[ia>>2]=T;c[I>>2]=fa;Ta=T}while(0);fa=(Ta|0)==0|(Ta|0)==(-1|0)&(Ta|0)!=0;Ra=fa?0:Ta;Sa=(Ta|0)!=0&(fa^1)}c[D>>2]=0;c[a>>2]=0;fa=a+20|0;b[fa>>1]=0;c[a+36>>2]=0;aa=a+4|0;c[aa>>2]=0;ba=a+16|0;b[ba>>1]=(e[ba>>1]|0)+Na;if(!(ha|Sa)){Ua=0;i=f;return Ua|0}c[a>>2]=Ra;b[fa>>1]=pa;c[aa>>2]=w;if(!Ra){Ua=1;i=f;return Ua|0}if(!(b[E>>1]&24))Va=Ewa(a,h,y,G,o,P,Ra,k,l,m,n,q,r,ca,W,X,Y,Z)|0;else{aa=b[j+8>>1]|0;c[z>>2]=k;c[z+4>>2]=m;b[z+8>>1]=aa;aa=b[j+12>>1]|0;c[A>>2]=l;c[A+4>>2]=n;b[A+8>>1]=aa;Va=Awa(a,h,y,G,o,P,Ra,q,r,z,A,ca,W,X,Y,Z)|0}c[Ra+w>>2]=0;c[Ra+(w|4)>>2]=Va<<31>>31;Ua=1;i=f;return Ua|0}}}while(0);c[D>>2]=0;c[a+36>>2]=0;b[a+20>>1]=0;Ua=1;i=f;return Ua|0}function CAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(qTa()|0)>>2]|0;if(e){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,e,j?544576:544544,544464,111)|0;c[a>>2]=h;if(h)mTa(h)}else c[a>>2]=0;h=a+4|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;c[a+32>>2]=0;c[a+36>>2]=0;c[a+40>>2]=0;c[a+44>>2]=0;c[a+48>>2]=0;c[a+52>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;c[a+64>>2]=0;c[a+68>>2]=0;c[a+72>>2]=0;c[a+76>>2]=0;c[a+80>>2]=0;c[a+84>>2]=0;h=a+152|0;j=a+168|0;e=a+88|0;f=e+60|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j>>2]=b;c[a+172>>2]=0;c[a+176>>2]=0;i=d;return}function DAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+144>>2]=d;c[a+148>>2]=b;d=b>>>0<64?64:b;if((c[a+12>>2]&2147483647)>>>0<d>>>0)b2a(a+4|0,d);if((c[a+108>>2]&2147483632)>>>0<16)c2a(a+100|0,16);if((c[a+48>>2]&2147483647)>>>0<d>>>0)b2a(a+40|0,d);if((c[a+60>>2]&2147483647)>>>0<d>>>0)b2a(a+52|0,d);if((c[a+72>>2]&2147483647)>>>0<d>>>0)b2a(a+64|0,d);if((c[a+84>>2]&2147483647)>>>0<d>>>0)b2a(a+76|0,d);if((c[a+120>>2]&2147483647)>>>0>=d>>>0){EAa(a,b);i=e;return}b2a(a+112|0,d);EAa(a,b);i=e;return}function EAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;oTa(c[a>>2]|0);g=c[a+152>>2]|0;if(g>>>0>=b>>>0){h=c[a>>2]|0;pTa(h);i=d;return}j=a+112|0;k=a+120|0;l=a+116|0;m=a+140|0;n=g;do{g=UJa(e,16384,501568,100)|0;c[f>>2]=g;o=c[l>>2]|0;if((c[k>>2]&2147483647)>>>0>o>>>0){p=(c[j>>2]|0)+(o<<2)|0;if(p)c[p>>2]=g;c[l>>2]=o+1}else d2a(j,f)|0;c[m>>2]=(c[m>>2]|0)+1;n=n+1|0}while((n|0)!=(b|0));h=c[a>>2]|0;pTa(h);i=d;return}function FAa(a){a=a|0;return c[a+152>>2]|0}function GAa(a){a=a|0;return c[a+156>>2]|0}function HAa(a){a=a|0;return c[a+172>>2]|0}function IAa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;oTa(c[a>>2]|0);e=a+116|0;f=c[e>>2]|0;if(!f){g=c[a>>2]|0;pTa(g);i=b;return}h=a+112|0;j=a+140|0;k=f;do{f=k+-1|0;l=c[(c[h>>2]|0)+(f<<2)>>2]|0;c[e>>2]=f;VJa(d,l);c[j>>2]=(c[j>>2]|0)+-1;k=c[e>>2]|0}while((k|0)!=0);g=c[a>>2]|0;pTa(g);i=b;return}function JAa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;e=a+128|0;RAa(a,a+((1-(c[e>>2]|0)|0)*12|0)+40|0,0);f=c[e>>2]|0;c[e>>2]=1-f;RAa(a,a+(f*12|0)+40|0,0);c[e>>2]=1-(c[e>>2]|0);e=a+124|0;RAa(a,a+((1-(c[e>>2]|0)|0)*12|0)+64|0,0);f=c[e>>2]|0;c[e>>2]=1-f;RAa(a,a+(f*12|0)+64|0,0);c[e>>2]=1-(c[e>>2]|0);MAa(a);e=a+136|0;RAa(a,a+((1-(c[e>>2]|0)|0)*12|0)+16|0,0);f=c[e>>2]|0;c[e>>2]=1-f;RAa(a,a+(f*12|0)+16|0,0);c[e>>2]=1-(c[e>>2]|0);e=a+116|0;f=c[e>>2]|0;if(f){g=a+112|0;h=f;do{f=h+-1|0;j=c[(c[g>>2]|0)+(f<<2)>>2]|0;c[e>>2]=f;VJa(d,j);h=c[e>>2]|0}while((h|0)!=0)}h=c[a+120>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+112>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+108>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+100>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+96>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+88>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+84>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+76>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+72>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+64>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+60>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+52>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+48>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+40>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+36>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+28>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+24>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+16>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=c[a+12>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[a+4>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}nTa(c[a>>2]|0);h=c[a>>2]|0;if(!h){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,h);i=b;return}function KAa(a){a=a|0;var b=0,d=0;b=i;d=a+128|0;RAa(a,a+((1-(c[d>>2]|0)|0)*12|0)+40|0,0);c[d>>2]=1-(c[d>>2]|0);i=b;return}function LAa(a){a=a|0;var b=0,d=0;b=i;d=a+124|0;RAa(a,a+((1-(c[d>>2]|0)|0)*12|0)+64|0,0);c[d>>2]=1-(c[d>>2]|0);i=b;return}function MAa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+16|0;d=b+5|0;e=b;f=b+4|0;oTa(c[a>>2]|0);c[a+176>>2]=0;c[a+172>>2]=0;g=a+8|0;h=c[g>>2]|0;if(h){j=a+4|0;k=a+168|0;l=a+112|0;m=a+120|0;n=a+116|0;o=a+152|0;p=a+88|0;q=a+96|0;r=a+92|0;s=h;do{h=s+-1|0;t=c[(c[j>>2]|0)+(h<<2)>>2]|0;c[g>>2]=h;c[e>>2]=t;h=c[k>>2]|0;u=c[h+16>>2]|0;do if(u>>>0<=t>>>0?(u+(c[h+20>>2]|0)|0)>>>0>t>>>0:0){v=c[r>>2]|0;if((c[q>>2]&2147483647)>>>0<=v>>>0){d2a(p,e)|0;break}w=(c[p>>2]|0)+(v<<2)|0;if(w)c[w>>2]=t;c[r>>2]=v+1}else x=12;while(0);if((x|0)==12){x=0;h=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0>h>>>0){u=(c[l>>2]|0)+(h<<2)|0;if(u)c[u>>2]=t;c[n>>2]=h+1}else d2a(l,e)|0;c[o>>2]=(c[o>>2]|0)+-1}s=c[g>>2]|0}while((s|0)!=0)}s=a+104|0;if(c[s>>2]|0){g=a+100|0;o=0;do{VJa(f,c[(c[g>>2]|0)+(o<<2)>>2]|0);o=o+1|0}while(o>>>0<(c[s>>2]|0)>>>0)}c[s>>2]=0;c[a+92>>2]=0;s=a+160|0;o=c[s>>2]|0;if(!o){y=c[a>>2]|0;pTa(y);i=b;return}g=c[a+168>>2]|0;f=c[g+16>>2]|0;if(f>>>0<=o>>>0?(f+(c[g+20>>2]|0)|0)>>>0>o>>>0:0){oTa(c[g>>2]|0);f=g+8|0;e=c[f>>2]|0;l=g+4|0;n=c[l>>2]|0;m=e;while(1){x=m+-1|0;z=n+(x<<2)|0;if((c[z>>2]|0)>>>0<o>>>0)m=x;else break}if(m>>>0<e>>>0){n=m;m=z;while(1){if(m)c[m>>2]=c[(c[l>>2]|0)+(n<<2)>>2];n=n+1|0;if((n|0)==(e|0))break;else m=m+4|0}}c[f>>2]=e+-1;pTa(c[g>>2]|0)}else VJa(d,o);c[s>>2]=0;c[a+164>>2]=0;y=c[a>>2]|0;pTa(y);i=b;return}function NAa(a){a=a|0;var b=0,d=0;b=i;d=a+136|0;RAa(a,a+((1-(c[d>>2]|0)|0)*12|0)+16|0,0);c[d>>2]=1-(c[d>>2]|0);i=b;return}function OAa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=c[a+168>>2]|0;oTa(c[e>>2]|0);f=e+4|0;g=e+8|0;h=c[g>>2]|0;j=c[f>>2]|0;k=c[j+(h+-1<<2)>>2]|0;l=e+16|0;m=c[l>>2]|0;n=k-m|0;if((k|0)==(m|0))o=0;else{if((c[e+12>>2]&2147483647)>>>0>h>>>0){k=j+(h<<2)|0;if(k)c[k>>2]=m;c[g>>2]=h+1}else m0a(f,l)|0;o=c[l>>2]|0}pTa(c[e>>2]|0);e=a+160|0;c[e>>2]=o;o=n>>>14;n=a+164|0;c[n>>2]=o;l=a+88|0;c[d>>2]=0;e2a(l,o,d);d=c[n>>2]|0;if(!d){i=b;return}n=0;do{c[(c[l>>2]|0)+(n<<2)>>2]=(c[e>>2]|0)+(n<<14);n=n+1|0}while(n>>>0<d>>>0);i=b;return}function PAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;l=g+12|0;oTa(c[a>>2]|0);if(!((d|0)==0|(e|0)==0)){m=(c[d>>2]|0)+1|0;n=c[e>>2]|0;c[e>>2]=m>>>0<n>>>0?n:m;c[d>>2]=(c[d>>2]|0)+1}if(f?(f=a+92|0,d=c[f>>2]|0,(d|0)!=0):0){m=d+-1|0;d=c[(c[a+88>>2]|0)+(m<<2)>>2]|0;c[f>>2]=m;c[h>>2]=d;m=b+4|0;f=c[m>>2]|0;if((c[b+8>>2]&2147483647)>>>0<=f>>>0){d2a(b,h)|0;o=c[h>>2]|0;p=c[a>>2]|0;pTa(p);i=g;return o|0}h=(c[b>>2]|0)+(f<<2)|0;if(h)c[h>>2]=d;c[m>>2]=f+1;o=d;p=c[a>>2]|0;pTa(p);i=g;return o|0}d=a+116|0;f=c[d>>2]|0;if(f){m=f+-1|0;f=c[(c[a+112>>2]|0)+(m<<2)>>2]|0;c[d>>2]=m;c[j>>2]=f;m=b+4|0;d=c[m>>2]|0;if((c[b+8>>2]&2147483647)>>>0>d>>>0){h=(c[b>>2]|0)+(d<<2)|0;if(h)c[h>>2]=f;c[m>>2]=d+1;q=f}else{d2a(b,j)|0;q=c[j>>2]|0}j=a+152|0;f=(c[j>>2]|0)+1|0;d=a+156|0;m=c[d>>2]|0;c[d>>2]=f>>>0<m>>>0?m:f;c[j>>2]=f;o=q;p=c[a>>2]|0;pTa(p);i=g;return o|0}q=a+140|0;f=c[q>>2]|0;if((f|0)==(c[a+144>>2]|0)){o=0;p=c[a>>2]|0;pTa(p);i=g;return o|0}c[q>>2]=f+1;f=UJa(l,16384,501568,235)|0;c[k>>2]=f;if(!f){c[q>>2]=(c[q>>2]|0)+-1;o=f;p=c[a>>2]|0;pTa(p);i=g;return o|0}q=b+4|0;l=c[q>>2]|0;if((c[b+8>>2]&2147483647)>>>0>l>>>0){j=(c[b>>2]|0)+(l<<2)|0;if(j)c[j>>2]=f;c[q>>2]=l+1;r=f}else{d2a(b,k)|0;r=c[k>>2]|0}k=a+152|0;b=(c[k>>2]|0)+1|0;f=a+156|0;l=c[f>>2]|0;c[f>>2]=b>>>0<l>>>0?l:b;c[k>>2]=b;o=r;p=c[a>>2]|0;pTa(p);i=g;return o|0}function QAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=UJa(d+4|0,b,501568,251)|0;c[e>>2]=f;if(!f){g=0;i=d;return g|0}oTa(c[a>>2]|0);b=a+100|0;h=a+104|0;j=c[h>>2]|0;if((c[a+108>>2]&2147483647)>>>0>j>>>0){k=(c[b>>2]|0)+(j<<2)|0;if(k)c[k>>2]=f;c[h>>2]=j+1;l=f}else{m0a(b,e)|0;l=c[e>>2]|0}pTa(c[a>>2]|0);g=l;i=d;return g|0}function RAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;oTa(c[a>>2]|0);g=b+4|0;h=a+152|0;c[h>>2]=(c[h>>2]|0)-(c[g>>2]|0);if(d)c[d>>2]=(c[d>>2]|0)-(c[g>>2]|0);d=c[g>>2]|0;if(!d){j=c[a>>2]|0;pTa(j);i=e;return}h=a+112|0;k=a+116|0;l=a+120|0;m=d;do{d=m+-1|0;n=c[(c[b>>2]|0)+(d<<2)>>2]|0;c[g>>2]=d;c[f>>2]=n;d=c[k>>2]|0;o=d+1|0;if((c[l>>2]&2147483647)>>>0>d>>>0){p=(c[h>>2]|0)+(d<<2)|0;if(p)c[p>>2]=n;c[k>>2]=o}else d2a(h,f)|0;m=c[g>>2]|0}while((m|0)!=0);j=c[a>>2]|0;pTa(j);i=e;return}function SAa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=PAa(a,b,a+176|0,a+172|0,1)|0;i=c;return d|0}function TAa(a){a=a|0;var b=0,d=0;b=i;d=PAa(a,a+((c[a+136>>2]|0)*12|0)+16|0,0,0,1)|0;i=b;return d|0}function UAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;oTa(c[a>>2]|0);f=b+4|0;g=c[f>>2]|0;if(!g){h=c[a>>2]|0;pTa(h);i=d;return}j=a+168|0;k=a+112|0;l=a+120|0;m=a+116|0;n=a+152|0;o=a+88|0;p=a+96|0;q=a+92|0;r=g;do{g=r+-1|0;s=c[(c[b>>2]|0)+(g<<2)>>2]|0;c[f>>2]=g;c[e>>2]=s;g=c[j>>2]|0;t=c[g+16>>2]|0;do if(t>>>0<=s>>>0?(t+(c[g+20>>2]|0)|0)>>>0>s>>>0:0){u=c[q>>2]|0;if((c[p>>2]&2147483647)>>>0<=u>>>0){d2a(o,e)|0;break}v=(c[o>>2]|0)+(u<<2)|0;if(v)c[v>>2]=s;c[q>>2]=u+1}else w=10;while(0);if((w|0)==10){w=0;g=c[m>>2]|0;if((c[l>>2]&2147483647)>>>0>g>>>0){t=(c[k>>2]|0)+(g<<2)|0;if(t)c[t>>2]=s;c[m>>2]=g+1}else d2a(k,e)|0;c[n>>2]=(c[n>>2]|0)+-1}r=c[f>>2]|0}while((r|0)!=0);h=c[a>>2]|0;pTa(h);i=d;return}function VAa(a){a=a|0;var b=0,d=0;b=i;d=PAa(a,a+((c[a+128>>2]|0)*12|0)+40|0,0,0,0)|0;i=b;return d|0}function WAa(a){a=a|0;var b=0,d=0;b=i;d=PAa(a,a+((c[a+124>>2]|0)*12|0)+64|0,0,0,0)|0;i=b;return d|0}function XAa(b,d,e,f,h,j,k){b=b|0;d=ea(d);e=ea(e);f=ea(f);h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=i;m=h;n=c[m+4>>2]|0;o=b;c[o>>2]=c[m>>2];c[o+4>>2]=n;g[b+8>>2]=ea(g[h+8>>2]);g[b+12>>2]=ea(g[h+12>>2]);g[b+16>>2]=ea(g[h+16>>2]);g[b+20>>2]=ea(g[h+20>>2]);g[b+24>>2]=ea(g[h+24>>2]);g[b+28>>2]=ea(g[h+28>>2]);c[b+32>>2]=c[h+32>>2];g[b+36>>2]=ea(g[h+36>>2]);g[b+40>>2]=ea(g[h+40>>2]);g[b+44>>2]=ea(g[h+44>>2]);g[b+48>>2]=ea(g[h+48>>2]);g[b+52>>2]=ea(g[h+52>>2]);g[b+56>>2]=ea(g[h+56>>2]);g[b+60>>2]=ea(g[h+60>>2]);g[b+64>>2]=ea(g[h+64>>2]);g[b+68>>2]=ea(g[h+68>>2]);g[b+72>>2]=ea(g[h+72>>2]);g[b+76>>2]=ea(g[h+76>>2]);g[b+80>>2]=ea(g[h+80>>2]);g[b+84>>2]=ea(g[h+84>>2]);g[b+88>>2]=ea(g[h+88>>2]);g[b+92>>2]=ea(g[h+92>>2]);g[b+96>>2]=ea(g[h+96>>2]);c[b+100>>2]=c[h+100>>2];c[b+300>>2]=0;c[b+304>>2]=0;c[b+308>>2]=0;c[b+312>>2]=j;c[b+316>>2]=j;c[b+320>>2]=0;c[b+324>>2]=0;c[b+332>>2]=j;c[b+336>>2]=0;c[b+340>>2]=0;dAa(b+344|0,j);sAa(b+356|0,j);c[b+8736>>2]=0;c[b+8740>>2]=0;c[b+8744>>2]=0;c[b+8760>>2]=0;a[b+8768>>0]=0;a[b+8769>>0]=0;a[b+8770>>0]=k&1;a[b+8771>>0]=0;g[b+8780>>2]=f;g[b+8784>>2]=e;g[b+4484>>2]=d;PEi(b+104|0,0,196)|0;c[b+8772>>2]=0;c[b+8776>>2]=0;i=l;return}function YAa(a){a=a|0;var b=0;b=i;PEi(a+104|0,0,196)|0;c[a+8772>>2]=0;c[a+8776>>2]=0;i=b;return}function ZAa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8744>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+8736>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+308>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+300>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function _Aa(){var a=0,b=0;a=i;i=i+16|0;b=UJa(a,892,501792,84)|0;c[125472]=b;if(!b){i=a;return}f2a(b);i=a;return}function $Aa(){var a=0,b=0,d=0;a=i;i=i+16|0;b=c[125472]|0;if(!b){i=a;return}g2a(b+596|0);h2a(b+300|0);i2a(b+4|0);nTa(c[b>>2]|0);d=c[b>>2]|0;if(d){b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,d)}VJa(a,c[125472]|0);c[125472]=0;i=a;return}function aBa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;c[b>>2]=502312;c[b+4>>2]=0;c[b+8>>2]=1;c[b+12>>2]=2147483647;f=b+56|0;h=b+80|0;j=b+16|0;k=j+64|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));g[h>>2]=ea(.75);c[b+84>>2]=-1;c[b+88>>2]=0;c[b+92>>2]=0;j2a(f,64);c[b+96>>2]=f;f=b+100|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[b+124>>2]=ea(.75);c[b+128>>2]=-1;c[b+132>>2]=0;c[b+136>>2]=0;j2a(f,64);c[b+140>>2]=f;DBa(b+144|0,0);c[b+7744>>2]=0;c[b+7748>>2]=100;c[b+7756>>2]=0;bCa(b+7760|0);c[b+7796>>2]=0;c[b+7800>>2]=0;c[b+7804>>2]=0;a[b+7808>>0]=d&1;j=b+7809|0;k=j+15|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));i=e;return}function bBa(a){a=a|0;var b=0;b=i;i=i+16|0;cBa(a);VJa(b,a);i=b;return}function cBa(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=502312;dBa(a);d=c[a+7820>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+7812>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+7804>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+7796>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}dCa(a+7760|0);EBa(a+144|0);d=a+100|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+56|0;a=c[e>>2]|0;if(!a){i=b;return}VJa(e,a);i=b;return}function dBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d;f=d+4|0;FBa(b+144|0);g=b+56|0;h=c[b+76>>2]|0;if((h|0)!=0?(j=b+92|0,(c[j>>2]|0)!=0):0){PEi(c[b+68>>2]|0,-1,h<<2|0)|0;h=b+72|0;k=c[h>>2]|0;l=k+-1|0;m=b+64|0;n=c[m>>2]|0;if(!l){o=k;p=n}else{k=n;n=0;while(1){q=n+1|0;r=c[m>>2]|0;c[r+(n<<2)>>2]=q;if((q|0)==(l|0))break;else{k=r;n=q}}o=c[h>>2]|0;p=r}c[p+(o+-1<<2)>>2]=-1;c[b+84>>2]=0;c[j>>2]=0}j=b+100|0;o=c[b+120>>2]|0;if((o|0)!=0?(p=b+136|0,(c[p>>2]|0)!=0):0){PEi(c[b+112>>2]|0,-1,o<<2|0)|0;o=b+116|0;r=c[o>>2]|0;h=r+-1|0;n=b+108|0;k=c[n>>2]|0;if(!h){s=r;t=k}else{r=k;k=0;while(1){l=k+1|0;u=c[n>>2]|0;c[u+(k<<2)>>2]=l;if((l|0)==(h|0))break;else{r=u;k=l}}s=c[o>>2]|0;t=u}c[t+(s+-1<<2)>>2]=-1;c[b+128>>2]=0;c[p>>2]=0}c[b+96>>2]=g;c[b+140>>2]=j;j=b+7796|0;c[e>>2]=0;xUa(j,0,e);yUa(j,c[b+7800>>2]|0);j=b+44|0;VJa(f,c[j>>2]|0);c[j>>2]=0;c[b+24>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+32>>2]=0;c[b+36>>2]=0;j=b+40|0;f=c[j>>2]|0;if(f){sBa(f);VJa(e,f)}c[j>>2]=0;j=b+4|0;f=c[j>>2]|0;if(!f){c[j>>2]=0;v=b+48|0;c[v>>2]=0;w=b+7744|0;c[w>>2]=0;x=b+7816|0;c[x>>2]=0;y=b+7811|0;a[y>>0]=0;i=d;return}sBa(f);VJa(e,f);c[j>>2]=0;v=b+48|0;c[v>>2]=0;w=b+7744|0;c[w>>2]=0;x=b+7816|0;c[x>>2]=0;y=b+7811|0;a[y>>0]=0;i=d;return}function eBa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h+4|0;k=h;a[b+7809>>0]=1;if(!(a[b+7808>>0]|0)){l=b+4|0;m=c[l>>2]|0;if(m){sBa(m);VJa(j,m)}c[l>>2]=0}l=b+7760|0;a:do if(!g)n=0;else{m=0;while(1){o=gCa(l,e+(m*24|0)|0,f+(m<<3)|0)|0;c[d+(m<<2)>>2]=o;if((o|0)==-1){n=m;break a}o=m+1|0;if(o>>>0<g>>>0)m=o;else{n=o;break}}}while(0);if(!(c[b+4>>2]|0)){p=(n|0)==(g|0);i=h;return p|0}a[b+7810>>0]=1;if(!n){p=(n|0)==(g|0);i=h;return p|0}l=b+96|0;m=b+144|0;b=0;do{c[k>>2]=c[d+(b<<2)>>2];o=k2a(c[l>>2]|0,k,j)|0;if(!((a[j>>0]|0)!=0|(o|0)==0))c[o>>2]=c[k>>2];IBa(m,f+(b<<3)|0,e+(b*24|0)|0)|0;b=b+1|0}while((b|0)!=(n|0));p=(n|0)==(g|0);i=h;return p|0}function fBa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+16|0;j=h;a[b+7809>>0]=1;if(!(a[b+7808>>0]|0)){k=b+4|0;l=c[k>>2]|0;if(l){sBa(l);VJa(j,l)}c[k>>2]=0}k=(f|0)==0;if(!k){l=c[b+7780>>2]|0;j=c[b+7772>>2]|0;m=0;do{n=c[l+(c[d+(m<<2)>>2]<<2)>>2]|0;g[j+(n*24|0)>>2]=ea(g[e+(m*24|0)>>2]);g[j+(n*24|0)+4>>2]=ea(g[e+(m*24|0)+4>>2]);g[j+(n*24|0)+8>>2]=ea(g[e+(m*24|0)+8>>2]);g[j+(n*24|0)+12>>2]=ea(g[e+(m*24|0)+12>>2]);g[j+(n*24|0)+16>>2]=ea(g[e+(m*24|0)+16>>2]);g[j+(n*24|0)+20>>2]=ea(g[e+(m*24|0)+20>>2]);m=m+1|0}while((m|0)!=(f|0))}m=b+4|0;if(!(c[m>>2]|0)){i=h;return}a[b+7810>>0]=1;if(k){i=h;return}k=b+7780|0;j=b+7800|0;l=b+7796|0;n=b+144|0;o=b+7776|0;b=0;do{p=c[(c[k>>2]|0)+(c[d+(b<<2)>>2]<<2)>>2]|0;if((c[j>>2]|0)>>>0>p>>>0?(q=c[(c[l>>2]|0)+(p<<2)>>2]|0,(q|0)!=-1):0)xBa(c[m>>2]|0,q);else KBa(n,e+(b*24|0)|0,(c[o>>2]|0)+(p<<3)|0)|0;b=b+1|0}while((b|0)!=(f|0));i=h;return}function gBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f;a[b+7809>>0]=1;if(!(a[b+7808>>0]|0)){k=b+4|0;l=c[k>>2]|0;if(l){sBa(l);VJa(g,l)}c[k>>2]=0}if(e){k=b+7760|0;l=b+7780|0;g=b+7776|0;m=b+4|0;n=b+7810|0;o=b+7796|0;p=b+7800|0;q=b+76|0;r=b+120|0;s=b+112|0;t=b+104|0;u=b+108|0;v=b+136|0;w=b+132|0;x=b+128|0;y=b+7811|0;z=b+7812|0;A=j+4|0;B=b+7820|0;C=b+7816|0;D=b+144|0;E=b+68|0;F=b+60|0;G=b+64|0;H=b+92|0;I=b+88|0;J=b+84|0;K=0;do{L=c[d+(K<<2)>>2]|0;M=(c[l>>2]|0)+(L<<2)|0;N=(c[g>>2]|0)+(c[M>>2]<<3)|0;O=c[N+4>>2]|0;P=h;c[P>>2]=c[N>>2];c[P+4>>2]=O;O=c[M>>2]|0;M=hCa(k,L)|0;P=c[m>>2]|0;do if(P){a[n>>0]=1;if((c[p>>2]|0)>>>0>O>>>0?(N=c[(c[o>>2]|0)+(O<<2)>>2]|0,(N|0)!=-1):0)xBa(P,N);N=c[q>>2]|0;a:do if((N|0)!=0?(Q=L+~(L<<15)|0,R=(Q>>>10^Q)*9|0,Q=R>>>6^R,R=Q+~(Q<<11)|0,Q=(c[E>>2]|0)+((N+-1&(R>>>16^R))<<2)|0,R=c[Q>>2]|0,(R|0)!=-1):0){S=c[F>>2]|0;T=R;R=Q;while(1){if((c[S+(T<<2)>>2]|0)==(L|0))break;Q=(c[G>>2]|0)+(T<<2)|0;U=c[Q>>2]|0;if((U|0)==-1){V=18;break a}else{T=U;R=Q}}if((T|0)!=-1){S=(c[G>>2]|0)+(T<<2)|0;c[R>>2]=c[S>>2];c[H>>2]=(c[H>>2]|0)+-1;c[I>>2]=(c[I>>2]|0)+1;c[S>>2]=c[J>>2];c[J>>2]=T;V=25}else V=18}else V=18;while(0);b:do if(((V|0)==18?(V=0,N=c[r>>2]|0,(N|0)!=0):0)?(S=L+~(L<<15)|0,Q=(S>>>10^S)*9|0,S=Q>>>6^Q,Q=S+~(S<<11)|0,S=(c[s>>2]|0)+((N+-1&(Q>>>16^Q))<<2)|0,Q=c[S>>2]|0,(Q|0)!=-1):0){N=c[t>>2]|0;U=Q;Q=S;while(1){if((c[N+(U<<2)>>2]|0)==(L|0))break;S=(c[u>>2]|0)+(U<<2)|0;W=c[S>>2]|0;if((W|0)==-1)break b;else{U=W;Q=S}}if((U|0)!=-1){N=(c[u>>2]|0)+(U<<2)|0;c[Q>>2]=c[N>>2];c[v>>2]=(c[v>>2]|0)+-1;c[w>>2]=(c[w>>2]|0)+1;c[N>>2]=c[x>>2];c[x>>2]=U;V=25}}while(0);if((V|0)==25){V=0;JBa(D,h)|0}BBa(o,O,M,c[m>>2]|0);if(a[y>>0]|0){c[j>>2]=O;c[A>>2]=M;N=c[C>>2]|0;if((c[B>>2]&2147483647)>>>0<=N>>>0){l2a(z,j)|0;break}T=(c[z>>2]|0)+(N<<3)|0;if(!T)X=N;else{N=j;R=c[N+4>>2]|0;S=T;c[S>>2]=c[N>>2];c[S+4>>2]=R;X=c[C>>2]|0}c[C>>2]=X+1}}while(0);K=K+1|0}while((K|0)!=(e|0))}if(c[b+7764>>2]|0){i=f;return}dBa(b);i=f;return}function hBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im;f=i;i=i+416|0;h=f+192|0;j=f+396|0;k=f+384|0;l=f+160|0;m=f+32|0;n=f;o=b+4|0;p=c[o>>2]|0;do if(p){q=c[d+144>>2]|0;r=c[q>>2]|0;if((r|0)==3)if(ea(S(ea(g[d+68>>2])))<ea(.999998986)){m2a(h,d+56|0,d,ea(1.00999999));if(n2a(0,c[b+7776>>2]|0,c[o>>2]|0,h,e)|0)break;else s=0;i=f;return s|0}else{t=ea(g[d+120>>2]);u=ea(g[d+132>>2]);v=ea(t+u);w=ea(g[d+124>>2]);x=ea(g[d+136>>2]);y=ea(w+x);z=ea(g[d+128>>2]);A=ea(g[d+140>>2]);B=ea(y*ea(.5));y=ea(ea(z+A)*ea(.5));g[l>>2]=ea(v*ea(.5));g[l+4>>2]=B;g[l+8>>2]=y;g[l+12>>2]=ea(0.0);y=ea(ea(x-w)*ea(.5));w=ea(ea(A-z)*ea(.5));g[l+16>>2]=ea(ea(u-t)*ea(.5));g[l+20>>2]=y;g[l+24>>2]=w;g[l+28>>2]=ea(0.0);if(r2a(0,c[b+7776>>2]|0,p,l,e)|0)break;else s=0;i=f;return s|0}else if((r|0)==2){w=ea(g[d+56>>2]);y=ea(w*ea(2.0));t=ea(g[d+68>>2]);u=ea(t*ea(2.0));z=ea(ea(w*y)+ea(ea(t*u)+ea(-1.0)));t=ea(g[d+64>>2]);w=ea(t*u);A=ea(g[d+60>>2]);x=ea(w+ea(y*A));w=ea(ea(y*t)-ea(u*A));A=ea(g[q+8>>2]);u=ea(A*z);t=ea(A*x);y=ea(A*w);B=ea(ea(g[d+72>>2])-u);u=ea(ea(g[d+76>>2])-t);t=ea(ea(g[d+80>>2])-y);g[h>>2]=B;g[h+4>>2]=u;g[h+8>>2]=t;g[j>>2]=z;g[j+4>>2]=x;g[j+8>>2]=w;w=ea(A*ea(2.0));A=ea(ea(g[q+4>>2])*ea(1.00999999));g[k>>2]=A;g[k+4>>2]=A;g[k+8>>2]=A;o2a(m,h,j,w,k);if(p2a(0,c[b+7776>>2]|0,c[o>>2]|0,m,e)|0)break;else s=0;i=f;return s|0}else if((r|0)==4){m2a(h,d+56|0,d,ea(1.00999999));if(n2a(0,c[b+7776>>2]|0,c[o>>2]|0,h,e)|0)break;else s=0;i=f;return s|0}else if(!r){w=ea(g[d+160>>2]);A=ea(g[d+148>>2]);x=ea(g[d+152>>2]);z=ea(g[d+156>>2]);g[n>>2]=A;g[n+4>>2]=x;g[n+8>>2]=z;g[n+12>>2]=ea(0.0);g[n+16>>2]=ea(w*w);if(q2a(0,c[b+7776>>2]|0,p,n,e)|0)break;else s=0;i=f;return s|0}else break}while(0);if(!(a[b+7808>>0]|0)){s=1;i=f;return s|0}if((c[b+92>>2]|0)==0?(c[b+136>>2]|0)==0:0){s=1;i=f;return s|0}s=OBa(b+144|0,d,e)|0;i=f;return s|0}function iBa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0;j=i;i=i+32|0;k=j+12|0;l=j;m=c[b+4>>2]|0;if((m|0)!=0?(n=ea(g[d+132>>2]),o=ea(g[d+120>>2]),p=ea(n-o),q=ea(g[d+136>>2]),r=ea(g[d+124>>2]),s=ea(q-r),t=ea(g[d+140>>2]),u=ea(g[d+128>>2]),v=ea(s*ea(.5)),s=ea(ea(t-u)*ea(.5)),g[k>>2]=ea(p*ea(.5)),g[k+4>>2]=v,g[k+8>>2]=s,w=c[b+7776>>2]|0,s=ea(ea(r+q)*ea(.5)),q=ea(ea(u+t)*ea(.5)),g[l>>2]=ea(ea(o+n)*ea(.5)),g[l+4>>2]=s,g[l+8>>2]=q,!(s2a(0,w,m,l,e,f,k,h)|0)):0){x=0;i=j;return x|0}if(!(a[b+7808>>0]|0)){x=1;i=j;return x|0}if((c[b+92>>2]|0)==0?(c[b+136>>2]|0)==0:0){x=1;i=j;return x|0}x=NBa(b+144|0,d,e,f,h)|0;i=j;return x|0}function jBa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j;l=c[b+4>>2]|0;if((l|0)!=0?(m=c[b+7776>>2]|0,g[k>>2]=ea(0.0),g[k+4>>2]=ea(0.0),g[k+8>>2]=ea(0.0),!(t2a(0,m,l,d,e,f,k,h)|0)):0){n=0;i=j;return n|0}if(!(a[b+7808>>0]|0)){n=1;i=j;return n|0}if((c[b+92>>2]|0)==0?(c[b+136>>2]|0)==0:0){n=1;i=j;return n|0}n=MBa(b+144|0,d,e,f,h)|0;i=j;return n|0}function kBa(b){b=b|0;var c=0;c=i;dBa(b);a[b+7809>>0]=1;i=c;return}function lBa(a,b){a=a|0;b=b|0;c[a+7748>>2]=b+-3;c[a+7756>>2]=0;return}function mBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+48|0;e=d+33|0;f=d;g=b+7809|0;if(!(a[g>>0]|0)){i=d;return}a[g>>0]=0;g=b+4|0;if(!(c[g>>2]|0))nBa(b)|0;if(!(a[b+7808>>0]|0)){i=d;return}h=b+7744|0;if((c[h>>2]|0)==3){j=b+44|0;VJa(d+32|0,c[j>>2]|0);c[j>>2]=0;c[h>>2]=0;h=c[b+52>>2]|0;j=c[b+7748>>2]|0;if(h>>>0<=j>>>0){if(h>>>0<j>>>0){j=b+7756|0;c[j>>2]=(c[j>>2]|0)+-1}}else{j=b+7756|0;c[j>>2]=(c[j>>2]|0)+1}j=c[g>>2]|0;if(j){sBa(j);VJa(e,j)}j=b+40|0;e=c[j>>2]|0;c[g>>2]=e;c[j>>2]=0;j=b+7796|0;h=b+7764|0;k=c[h>>2]|0;l=c[b+48>>2]|0;ABa(j,k>>>0<l>>>0?l:k,e);e=b+7812|0;k=b+7816|0;if((c[k>>2]|0)>0){l=c[e>>2]|0;do{BBa(j,c[l>>2]|0,c[l+4>>2]|0,c[g>>2]|0);l=l+8|0}while(l>>>0<((c[e>>2]|0)+(c[k>>2]<<3)|0)>>>0)}c[k>>2]=0;a[b+7811>>0]=0;k=c[h>>2]|0;h=f+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h>>2]=k;c[f+20>>2]=c[b+7772>>2];c[f+4>>2]=2;c[f>>2]=1;k=c[g>>2]|0;wBa(k,f,c[k>>2]|0)|0;k=b+140|0;f=c[k>>2]|0;h=f+12|0;a:do if(c[f+16>>2]|0){e=c[h>>2]|0;l=c[e>>2]|0;if((l|0)==-1){j=c[f+20>>2]|0;m=0;while(1){n=m+1|0;if((n|0)==(j|0)){o=j;p=-1;break a}q=c[e+(n<<2)>>2]|0;if((q|0)==-1)m=n;else{o=n;p=q;break}}}else{o=0;p=l}}else{o=0;p=-1}while(0);m=f+4|0;e=b+144|0;j=b+7780|0;q=b+7776|0;n=f+8|0;r=f+20|0;f=o;o=p;b:while(1){p=o;do{if((p|0)==-1)break b;JBa(e,(c[q>>2]|0)+(c[(c[j>>2]|0)+(c[(c[m>>2]|0)+(p<<2)>>2]<<2)>>2]<<3)|0)|0;p=c[(c[n>>2]|0)+(p<<2)>>2]|0}while((p|0)!=-1);p=c[r>>2]|0;l=f;while(1){s=l+1|0;if((s|0)==(p|0)){f=p;o=-1;continue b}t=c[(c[h>>2]|0)+(s<<2)>>2]|0;if((t|0)==-1)l=s;else{f=s;o=t;continue b}}}a[b+7810>>0]=(c[(c[b+96>>2]|0)+36>>2]|0)!=0&1;o=c[k>>2]|0;k=c[o+20>>2]|0;if((k|0)!=0?(f=o+36|0,(c[f>>2]|0)!=0):0){PEi(c[o+12>>2]|0,-1,k<<2|0)|0;k=o+16|0;h=c[k>>2]|0;r=h+-1|0;n=o+8|0;m=c[n>>2]|0;if(!r){u=h;v=m}else{h=m;m=0;while(1){j=m+1|0;w=c[n>>2]|0;c[w+(m<<2)>>2]=j;if((j|0)==(r|0))break;else{h=w;m=j}}u=c[k>>2]|0;v=w}c[v+(u+-1<<2)>>2]=-1;c[o+28>>2]=0;c[f>>2]=0}}else{f=c[g>>2]|0;if((f|0)!=0?(g=c[b+7764>>2]|0,(g|0)!=0):0)yBa(f,g,c[b+7772>>2]|0,c[f>>2]|0)}LBa(b+144|0);i=d;return}function nBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d;f=b+4|0;g=c[f>>2]|0;if(g){sBa(g);VJa(d+32|0,g)}c[f>>2]=0;g=c[b+7764>>2]|0;if(!g){h=1;i=d;return h|0}j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,548,m?502448:544544,502368,788)|0;rBa(l);c[f>>2]=l;m=e+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m>>2]=g;c[e+20>>2]=c[b+7772>>2];c[e+4>>2]=2;c[e>>2]=1;m=uBa(l,e)|0;if(!(a[b+7808>>0]|0)){h=m;i=d;return h|0}e=c[b+48>>2]|0;ABa(b+7796|0,g>>>0<e>>>0?e:g,c[f>>2]|0);h=m;i=d;return h|0}function oBa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;iCa(b+7760|0,d);f=c[b+4>>2]|0;if(f)zBa(f,d);if(!(a[b+7808>>0]|0)){i=e;return}PBa(b+144|0,d);i=e;return}function pBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+112|0;h=f+84|0;j=f+56|0;k=f+28|0;l=f;m=c[b+4>>2]|0;if(m){g[h>>2]=ea(0.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);g[h+12>>2]=ea(1.0);g[h+16>>2]=ea(0.0);g[h+20>>2]=ea(0.0);g[h+24>>2]=ea(0.0);FKa(d,h)|0;DKa(d,e)|0;e=c[m+4>>2]|0;u2a(e,e,d)}g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(1.0);g[j+16>>2]=ea(0.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);FKa(d,j)|0;DKa(d,-1)|0;j=b+68|0;a:do if(c[b+72>>2]|0){e=c[j>>2]|0;m=c[e>>2]|0;if((m|0)==-1){h=c[b+76>>2]|0;n=0;while(1){o=n+1|0;if((o|0)==(h|0)){p=h;q=-1;break a}r=c[e+(o<<2)>>2]|0;if((r|0)==-1)n=o;else{p=o;q=r;break}}}else{p=0;q=m}}else{p=0;q=-1}while(0);n=b+60|0;e=b+7780|0;h=b+7772|0;r=k+4|0;o=k+8|0;s=k+12|0;t=k+16|0;u=k+20|0;v=k+24|0;w=b+64|0;x=b+76|0;y=p;p=q;b:while(1){q=p;do{if((q|0)==-1)break b;z=c[(c[e>>2]|0)+(c[(c[n>>2]|0)+(q<<2)>>2]<<2)>>2]|0;A=c[h>>2]|0;g[k>>2]=ea(g[A+(z*24|0)>>2]);g[r>>2]=ea(g[A+(z*24|0)+4>>2]);g[o>>2]=ea(g[A+(z*24|0)+8>>2]);g[s>>2]=ea(g[A+(z*24|0)+12>>2]);g[t>>2]=ea(g[A+(z*24|0)+16>>2]);g[u>>2]=ea(g[A+(z*24|0)+20>>2]);a[v>>0]=1;HKa(d,k)|0;q=c[(c[w>>2]|0)+(q<<2)>>2]|0}while((q|0)!=-1);q=c[x>>2]|0;m=y;while(1){z=m+1|0;if((z|0)==(q|0)){y=q;p=-1;continue b}A=c[(c[j>>2]|0)+(z<<2)>>2]|0;if((A|0)==-1)m=z;else{y=z;p=A;continue b}}}p=b+112|0;c:do if(c[b+116>>2]|0){y=c[p>>2]|0;j=c[y>>2]|0;if((j|0)==-1){x=c[b+120>>2]|0;w=0;while(1){k=w+1|0;if((k|0)==(x|0)){B=x;C=-1;break c}v=c[y+(k<<2)>>2]|0;if((v|0)==-1)w=k;else{B=k;C=v;break}}}else{B=0;C=j}}else{B=0;C=-1}while(0);w=b+104|0;y=l+4|0;x=l+8|0;v=l+12|0;k=l+16|0;u=l+20|0;t=l+24|0;s=b+108|0;o=b+120|0;b=B;B=C;d:while(1){C=B;do{if((C|0)==-1)break d;r=c[(c[e>>2]|0)+(c[(c[w>>2]|0)+(C<<2)>>2]<<2)>>2]|0;n=c[h>>2]|0;g[l>>2]=ea(g[n+(r*24|0)>>2]);g[y>>2]=ea(g[n+(r*24|0)+4>>2]);g[x>>2]=ea(g[n+(r*24|0)+8>>2]);g[v>>2]=ea(g[n+(r*24|0)+12>>2]);g[k>>2]=ea(g[n+(r*24|0)+16>>2]);g[u>>2]=ea(g[n+(r*24|0)+20>>2]);a[t>>0]=1;HKa(d,l)|0;C=c[(c[s>>2]|0)+(C<<2)>>2]|0}while((C|0)!=-1);C=c[o>>2]|0;j=b;while(1){r=j+1|0;if((r|0)==(C|0)){b=C;B=-1;continue d}n=c[(c[p>>2]|0)+(r<<2)>>2]|0;if((n|0)==-1)j=r;else{b=r;B=n;continue d}}}i=f;return}function qBa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+1|0;f=d;if(!(a[b+7810>>0]|0)){h=1;i=d;return h|0}j=b+7744|0;k=c[j>>2]|0;do if((k|0)==2){l=b+52|0;c[l>>2]=(c[l>>2]|0)+1;if(!(vBa(c[b+40>>2]|0,b+8|0,1,(((c[b+7752>>2]|0)>>>0)/((c[b+7748>>2]|0)>>>0)|0)+1|0)|0)){c[j>>2]=3;m=3;break}else{m=c[j>>2]|0;break}}else if(!k){l=c[b+7764>>2]|0;if(!l){h=1;i=d;return h|0}n=b+40|0;o=c[n>>2]|0;if(o){sBa(o);VJa(e,o)}o=mKa()|0;p=c[(c[o>>2]|0)+8>>2]|0;q=pKa()|0;r=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[p&255](o,548,r?502448:544544,502368,677)|0;rBa(q);c[n>>2]=q;q=b+48|0;c[q>>2]=l;n=UJa(f,l*24|0,502368,680)|0;c[b+44>>2]=n;r=c[b+7772>>2]|0;o=0;do{g[n+(o*24|0)>>2]=ea(g[r+(o*24|0)>>2]);g[n+(o*24|0)+4>>2]=ea(g[r+(o*24|0)+4>>2]);g[n+(o*24|0)+8>>2]=ea(g[r+(o*24|0)+8>>2]);g[n+(o*24|0)+12>>2]=ea(g[r+(o*24|0)+12>>2]);g[n+(o*24|0)+16>>2]=ea(g[r+(o*24|0)+16>>2]);g[n+(o*24|0)+20>>2]=ea(g[r+(o*24|0)+20>>2]);o=o+1|0}while((o|0)!=(l|0));l=b+96|0;o=b+140|0;r=c[l>>2]|0;c[l>>2]=c[o>>2];c[o>>2]=r;c[b+24>>2]=0;c[b+20>>2]=0;c[b+32>>2]=0;c[b+36>>2]=0;c[b+16>>2]=c[q>>2];c[b+28>>2]=n;c[b+12>>2]=2;c[b+8>>2]=1;a[b+7811>>0]=1;c[j>>2]=1;m=1}else if((k|0)==1){vBa(c[b+40>>2]|0,b+8|0,0,0)|0;c[j>>2]=2;c[b+52>>2]=0;r=c[b+16>>2]|0;o=r;l=0;while(1){o=o>>>1;p=l;l=l+1|0;if(!o){s=p;break}if(l>>>0>=32){s=-1;break}}l=da(r,s)|0;o=c[(c[b+4>>2]|0)+540>>2]|0;if(l>>>0>o<<1>>>0|l>>>0<o>>>1>>>0){c[b+7756>>2]=0;c[b+7752>>2]=l;t=0;u=l}else{c[b+7752>>2]=o;t=c[b+7756>>2]|0;u=o}o=(da(r,t)|0)+u|0;c[b+7752>>2]=(o|0)<0?0:o;m=2}else m=k;while(0);a[b+7809>>0]=1;h=(m|0)==3;i=d;return h|0}function rBa(a){a=a|0;c[a+536>>2]=0;c[a+540>>2]=0;c[a+544>>2]=0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function sBa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;tBa(a);d=a+8|0;VJa(b,c[d>>2]|0);c[d>>2]=0;i=b;return}function tBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+544|0;g=c[f>>2]|0;if(g){h=c[g+8>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[g>>2]|0,(h|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,h)}VJa(d,g)}c[f>>2]=0;f=a+4|0;g=c[f>>2]|0;if(g)VJa(d,g+-8|0);c[f>>2]=0;VJa(e,c[a>>2]|0);c[a>>2]=0;PEi(c[a+8>>2]|0,0,c[a+12>>2]<<2|0)|0;c[a+16>>2]=0;c[a+20>>2]=0;i=b;return}function uBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;if(!b){e=0;i=d;return e|0}f=b+8|0;if(!(c[f>>2]|0)){e=0;i=d;return e|0}tBa(a);g=b+24|0;c[g>>2]=1;c[b+28>>2]=0;h=UJa(d,c[f>>2]<<2,502704,468)|0;c[a>>2]=h;if(!(c[f>>2]|0))j=-1;else{k=0;do{c[h+(k<<2)>>2]=k;k=k+1|0;l=c[f>>2]|0}while(k>>>0<l>>>0);j=(l<<1)+-1|0}l=j*24|0;k=mKa()|0;h=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[h&255](k,j>>>0>178956970|l>>>0>4294967287?-1:l+8|0,n?502912:544544,502704,474)|0;c[m+4>>2]=j;n=m+8|0;m=n+(j*24|0)|0;j=n;do{l=j+16|0;c[l>>2]=0;c[l+4>>2]=0;j=j+24|0}while((j|0)!=(m|0));m=a+4|0;c[m>>2]=n;c[b+12>>2]=n;n=c[m>>2]|0;m=n+16|0;j=m;l=c[j>>2]&2;k=c[j+4>>2]&-256;j=cFi(c[f>>2]|0,0,2)|0;c[125696]=0;f=m;c[f>>2]=l|j|1;c[f+4>>2]=k|H;v2a(n,b,c[a>>2]|0);c[a+536>>2]=c[g>>2];c[a+540>>2]=c[b+16>>2];e=1;i=d;return e|0}function vBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;f=i;i=i+80|0;h=f+16|0;j=f;l=f+40|0;m=f+32|0;n=f+48|0;o=f+72|0;if((d|0)==1){p=a+544|0;q=c[p>>2]|0;r=c[q+4>>2]|0;if(!r){c[a+536>>2]=c[b+24>>2];c[a+540>>2]=c[b+16>>2];if(q){s=c[q+8>>2]|0;if((s&2147483647|0)!=0&(s|0)>-1?(s=c[q>>2]|0,(s|0)!=0):0){t=mKa()|0;In[c[(c[t>>2]|0)+12>>2]&4095](t,s)}VJa(h,q)}c[p>>2]=0;u=0;i=f;return u|0}if(!e){u=1;i=f;return u|0}s=b+20|0;t=n+4|0;v=n+8|0;w=n+12|0;x=n+16|0;y=n+20|0;z=j+4|0;A=j+8|0;B=j+12|0;C=h+4|0;D=h+8|0;E=h+12|0;F=b+12|0;G=m+4|0;I=l+4|0;J=b+16|0;K=q;q=r;r=0;while(1){L=K+4|0;if(!q){u=1;M=39;break}N=K+12|0;O=c[N>>2]|0;P=c[K>>2]|0;Q=c[P+(O<<3)>>2]|0;R=O+1|0;c[N>>2]=R;S=c[P+(O<<3)+4>>2]|0;if((R|0)==(q|0)){c[L>>2]=0;c[N>>2]=0}N=c[a>>2]|0;R=Q+16|0;O=R;P=c[O>>2]|0;T=c[O+4>>2]|0;O=VEi(P|0,T|0,21)|0;U=O&524287;O=VEi(P|0,T|0,2)|0;V=O&524287;O=c[N+(U<<2)>>2]|0;W=c[s>>2]|0;X=ea(g[W+(O*24|0)>>2]);Y=ea(g[W+(O*24|0)+4>>2]);Z=ea(g[W+(O*24|0)+8>>2]);_=ea(g[W+(O*24|0)+12>>2]);$=ea(g[W+(O*24|0)+16>>2]);aa=ea(g[W+(O*24|0)+20>>2]);if(V>>>0>1){ba=X;ca=_;da=Z;fa=aa;ga=Y;ha=$;O=1;while(1){ia=c[N+(O+U<<2)>>2]|0;ja=ea(g[W+(ia*24|0)>>2]);ka=ea(g[W+(ia*24|0)+4>>2]);la=ea(g[W+(ia*24|0)+8>>2]);ma=ba<ja?ba:ja;ja=ga<ka?ga:ka;ka=da<la?da:la;la=ea(g[W+(ia*24|0)+12>>2]);na=ea(g[W+(ia*24|0)+16>>2]);oa=ea(g[W+(ia*24|0)+20>>2]);pa=ca>la?ca:la;la=ha>na?ha:na;na=fa>oa?fa:oa;O=O+1|0;if((O|0)==(V|0)){qa=ma;ra=pa;sa=ka;ta=na;ua=ja;va=la;break}else{ba=ma;ca=pa;da=ka;fa=na;ga=ja;ha=la}}}else{qa=X;ra=_;sa=Z;ta=aa;ua=Y;va=$}g[n>>2]=qa;g[t>>2]=ua;g[v>>2]=sa;g[w>>2]=ra;g[x>>2]=va;g[y>>2]=ta;V=R;c[V>>2]=P|1;c[V+4>>2]=T;x2a(Q,n,b,N)|0;V=qa>ea(-9999999940000000065998519.0e8);ha=V?qa:ea(-9999999940000000065998519.0e8);V=ua>ea(-9999999940000000065998519.0e8);ga=V?ua:ea(-9999999940000000065998519.0e8);V=sa>ea(-9999999940000000065998519.0e8);fa=V?sa:ea(-9999999940000000065998519.0e8);V=ra<ea(9999999940000000065998519.0e8);da=V?ra:ea(9999999940000000065998519.0e8);V=va<ea(9999999940000000065998519.0e8);ca=V?va:ea(9999999940000000065998519.0e8);V=ta<ea(9999999940000000065998519.0e8);ba=V?ta:ea(9999999940000000065998519.0e8);la=ea(ea(da+ha)*ea(.5));ja=ea(ea(ca+ga)*ea(.5));na=ea(ea(ba+fa)*ea(.5));ka=ea(ea(da-ha)*ea(.5));ha=ea(ea(ca-ga)*ea(.5));ga=ea(ea(ba-fa)*ea(.5));fa=ea(la*ea(.0000999999974));ba=ea(ja*ea(.0000999999974));ca=ea(na*ea(.0000999999974));da=ea(-fa);pa=ea(-ba);ma=ea(-ca);oa=ea(ka+ea((fa>da?fa:da)+ea(.0000999999974)));da=ea(ha+ea((ba>pa?ba:pa)+ea(.0000999999974)));pa=ea(ga+ea((ca>ma?ca:ma)+ea(.0000999999974)));ma=da>pa?da:pa;ca=ea((oa>ma?oa:ma)*ea(.00392158423));ma=ea(ea(ca+ea(ca*ea(.0000999999974)))*ea(1.0e4));V=(g[k>>2]=ma,c[k>>2]|0);ma=ea(ea(1.0)/ca);O=~~ea(ea(ma*oa)+ea(1.0));W=~~ea(ea(ma*da)+ea(1.0));U=~~ea(ea(ma*pa)+ea(1.0));ia=la==ea(0.0);wa=ja==ea(0.0);xa=na==ea(0.0);g[j>>2]=ea(2.3509887e-38);g[z>>2]=ea(2.3509887e-38);g[A>>2]=ea(2.3509887e-38);g[B>>2]=ea(0.0);g[h>>2]=la;g[C>>2]=ja;g[D>>2]=na;g[E>>2]=ea(0.0);na=ea(g[(ia?j:h)>>2]);ja=ea(g[(wa?j:h)+4>>2]);la=ea(g[(xa?j:h)+8>>2]);xa=(g[k>>2]=na,c[k>>2]|0);wa=(g[k>>2]=ja,c[k>>2]|0);ia=U|(g[k>>2]=la,c[k>>2]|0)&-256;U=O|xa&-256|0;xa=W|wa&-256|0;wa=ia|0;c[Q>>2]=U;c[Q+4>>2]=xa;c[Q+8>>2]=wa;wa=R;xa=c[wa>>2]|0;U=c[wa+4>>2]|0;wa=cFi(V>>>8|0,0,40)|0;V=R;c[V>>2]=wa|xa;c[V+4>>2]=H|U&255;V=c[F>>2]|0;do if((xa&1|0)==0&0==0){wa=VEi(xa|0,U|0,21)|0;ia=wa&524287;wa=(ia|0)==0;W=wa?V:V+((ia+1|0)*24|0)|0;do if(!wa){c[l>>2]=V+(ia*24|0);c[I>>2]=Q;O=c[L>>2]|0;if((c[K+8>>2]&2147483647)>>>0<=O>>>0){w2a(K,l)|0;break}ya=(c[K>>2]|0)+(O<<3)|0;if(!ya)za=O;else{O=l;Aa=c[O+4>>2]|0;Ba=ya;c[Ba>>2]=c[O>>2];c[Ba+4>>2]=Aa;za=c[L>>2]|0}c[L>>2]=za+1}while(0);if((W|0)!=(V|0)){c[m>>2]=W;c[G>>2]=Q;ia=c[L>>2]|0;if((c[K+8>>2]&2147483647)>>>0<=ia>>>0){w2a(K,m)|0;break}wa=(c[K>>2]|0)+(ia<<3)|0;if(!wa)Ca=ia;else{ia=m;Aa=c[ia+4>>2]|0;Ba=wa;c[Ba>>2]=c[ia>>2];c[Ba+4>>2]=Aa;Ca=c[L>>2]|0}c[L>>2]=Ca+1}}while(0);L=R;Q=c[L>>2]|0;U=c[L+4>>2]|0;L=VEi(Q|0,U|0,2)|0;xa=L&524287;c[J>>2]=xa+(c[J>>2]|0);L=cFi((S-V|0)/24|0|0,0,2)|0;N=R;c[N>>2]=L|Q&-2097149;c[N+4>>2]=H|U;U=xa+r|0;if(U>>>0>=e>>>0){u=1;M=39;break}xa=c[p>>2]|0;K=xa;q=c[xa+4>>2]|0;r=U}if((M|0)==39){i=f;return u|0}}else if(!d){if(!b){u=-1;i=f;return u|0}d=b+8|0;if(!(c[d>>2]|0)){u=-1;i=f;return u|0}tBa(a);c[b+24>>2]=1;c[b+28>>2]=0;M=UJa(o,c[d>>2]<<2,502704,556)|0;c[a>>2]=M;if(!(c[d>>2]|0))Da=-1;else{o=0;do{c[M+(o<<2)>>2]=o;o=o+1|0;Ea=c[d>>2]|0}while(o>>>0<Ea>>>0);Da=(Ea<<1)+-1|0}Ea=Da*24|0;o=mKa()|0;M=c[(c[o>>2]|0)+8>>2]|0;r=pKa()|0;q=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[M&255](o,Da>>>0>178956970|Ea>>>0>4294967287?-1:Ea+8|0,q?502912:544544,502704,563)|0;c[r+4>>2]=Da;q=r+8|0;r=q+(Da*24|0)|0;Da=q;do{Ea=Da+16|0;c[Ea>>2]=0;c[Ea+4>>2]=0;Da=Da+24|0}while((Da|0)!=(r|0));r=a+4|0;c[r>>2]=q;c[b+12>>2]=q;q=(c[r>>2]|0)+16|0;b=q;Da=c[b>>2]&2;Ea=c[b+4>>2]&-256;b=cFi(c[d>>2]|0,0,2)|0;d=q;c[d>>2]=Da|b|1;c[d+4>>2]=Ea|H;Ea=mKa()|0;d=c[(c[Ea>>2]|0)+8>>2]|0;b=pKa()|0;Da=mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0;b=Bn[d&255](Ea,16,Da?502792:544544,502704,571)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[a+544>>2]=b;a=c[r>>2]|0;c[h>>2]=a;c[h+4>>2]=a;w2a(b,h)|0;u=0;i=f;return u|0}else{u=-1;i=f;return u|0}return 0}function wBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=Im,K=Im,L=Im,M=Im,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im;e=i;i=i+32|0;f=e+16|0;h=e;if(!b){j=0;i=e;return j|0}l=c[b+20>>2]|0;b=c[a+536>>2]|0;if(!b){j=1;i=e;return j|0}m=a+4|0;a=h+4|0;n=h+8|0;o=h+12|0;p=f+4|0;q=f+8|0;r=f+12|0;s=h+4|0;t=h+8|0;u=h+12|0;v=f+4|0;w=f+8|0;x=f+12|0;y=b;while(1){b=y+-1|0;z=c[m>>2]|0;A=z+(b*24|0)|0;B=(b|0)==0;C=z+(b*24|0)+16|0;D=C;E=c[D>>2]|0;F=c[D+4>>2]|0;if((E&1|0)==0&0==0){D=c[m>>2]|0;G=VEi(E|0,F|0,21)|0;I=G&524287;G=(I|0)==0?D:D+((I+1|0)*24|0)|0;J=ea(g[G>>2]);K=ea(g[G+4>>2]);L=ea(g[G+8>>2]);M=ea((c[k>>2]=c[G+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));G=(g[k>>2]=J,c[k>>2]|0);N=(g[k>>2]=K,c[k>>2]|0);O=ea(ea(G&255|0)*M);P=ea(ea(N&255|0)*M);Q=ea(ea((g[k>>2]=L,c[k>>2]|0)&255|0)*M);M=ea(g[D+(I*24|0)>>2]);R=ea(g[D+(I*24|0)+4>>2]);S=ea(g[D+(I*24|0)+8>>2]);T=ea((c[k>>2]=c[D+(I*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));I=(g[k>>2]=M,c[k>>2]|0);D=(g[k>>2]=R,c[k>>2]|0);U=ea(ea(I&255|0)*T);V=ea(ea(D&255|0)*T);W=ea(ea((g[k>>2]=S,c[k>>2]|0)&255|0)*T);T=ea(M-U);X=ea(R-V);Y=ea(S-W);Z=ea(J-O);_=ea(K-P);$=ea(L-Q);aa=T<Z?T:Z;Z=X<_?X:_;_=Y<$?Y:$;$=ea(M+U);U=ea(R+V);V=ea(S+W);W=ea(J+O);O=ea(K+P);P=ea(L+Q);Q=$>W?$:W;W=U>O?U:O;O=V>P?V:P;D=aa>ea(-9999999940000000065998519.0e8);P=D?aa:ea(-9999999940000000065998519.0e8);D=Z>ea(-9999999940000000065998519.0e8);aa=D?Z:ea(-9999999940000000065998519.0e8);D=_>ea(-9999999940000000065998519.0e8);Z=D?_:ea(-9999999940000000065998519.0e8);D=Q<ea(9999999940000000065998519.0e8);_=D?Q:ea(9999999940000000065998519.0e8);D=W<ea(9999999940000000065998519.0e8);Q=D?W:ea(9999999940000000065998519.0e8);D=O<ea(9999999940000000065998519.0e8);W=D?O:ea(9999999940000000065998519.0e8);O=ea(ea(P+_)*ea(.5));V=ea(ea(aa+Q)*ea(.5));U=ea(ea(Z+W)*ea(.5));$=ea(ea(_-P)*ea(.5));P=ea(ea(Q-aa)*ea(.5));aa=ea(ea(W-Z)*ea(.5));Z=ea(O*ea(.0000999999974));W=ea(V*ea(.0000999999974));Q=ea(U*ea(.0000999999974));_=ea(-Z);L=ea(-W);K=ea(-Q);J=ea($+ea((Z>_?Z:_)+ea(.0000999999974)));_=ea(P+ea((W>L?W:L)+ea(.0000999999974)));L=ea(aa+ea((Q>K?Q:K)+ea(.0000999999974)));K=_>L?_:L;Q=ea((J>K?J:K)*ea(.00392158423));K=ea(ea(Q+ea(Q*ea(.0000999999974)))*ea(1.0e4));D=(g[k>>2]=K,c[k>>2]|0);K=ea(ea(1.0)/Q);I=~~ea(ea(K*J)+ea(1.0));N=~~ea(ea(K*_)+ea(1.0));G=~~ea(ea(K*L)+ea(1.0));ba=O==ea(0.0);ca=V==ea(0.0);da=U==ea(0.0);g[h>>2]=ea(2.3509887e-38);g[a>>2]=ea(2.3509887e-38);g[n>>2]=ea(2.3509887e-38);g[o>>2]=ea(0.0);g[f>>2]=O;g[p>>2]=V;g[q>>2]=U;g[r>>2]=ea(0.0);U=ea(g[(ba?h:f)>>2]);V=ea(g[(ca?h:f)+4>>2]);O=ea(g[(da?h:f)+8>>2]);da=(g[k>>2]=U,c[k>>2]|0);ca=(g[k>>2]=V,c[k>>2]|0);ba=G|(g[k>>2]=O,c[k>>2]|0)&-256;G=I|da&-256|0;da=N|ca&-256|0;ca=ba|0;c[A>>2]=G;c[z+(b*24|0)+4>>2]=da;c[z+(b*24|0)+8>>2]=ca;ca=C;da=c[ca>>2]|0;G=c[ca+4>>2]&255;ca=cFi(D>>>8|0,0,40)|0;D=C;c[D>>2]=ca|da;c[D+4>>2]=H|G}else{if((E&2|0)==0&0==0){fa=ea(2499999990000000085741769.0e8);ga=ea(2499999990000000085741769.0e8);ha=ea(2499999990000000085741769.0e8);ia=ea(-2499999990000000085741769.0e8);ja=ea(-2499999990000000085741769.0e8);ka=ea(-2499999990000000085741769.0e8)}else{G=VEi(E|0,F|0,21)|0;F=c[d+((G&524287)<<2)>>2]|0;O=ea(g[l+(F*24|0)>>2]);V=ea(g[l+(F*24|0)+4>>2]);U=ea(g[l+(F*24|0)+8>>2]);L=ea(g[l+(F*24|0)+12>>2]);K=ea(g[l+(F*24|0)+16>>2]);fa=O;ga=V;ha=U;ia=L;ja=K;ka=ea(g[l+(F*24|0)+20>>2])}F=fa>ea(-9999999940000000065998519.0e8);K=F?fa:ea(-9999999940000000065998519.0e8);F=ga>ea(-9999999940000000065998519.0e8);L=F?ga:ea(-9999999940000000065998519.0e8);F=ha>ea(-9999999940000000065998519.0e8);U=F?ha:ea(-9999999940000000065998519.0e8);F=ia<ea(9999999940000000065998519.0e8);V=F?ia:ea(9999999940000000065998519.0e8);F=ja<ea(9999999940000000065998519.0e8);O=F?ja:ea(9999999940000000065998519.0e8);F=ka<ea(9999999940000000065998519.0e8);_=F?ka:ea(9999999940000000065998519.0e8);J=ea(ea(K+V)*ea(.5));Q=ea(ea(L+O)*ea(.5));aa=ea(ea(U+_)*ea(.5));W=ea(ea(V-K)*ea(.5));K=ea(ea(O-L)*ea(.5));L=ea(ea(_-U)*ea(.5));U=ea(J*ea(.0000999999974));_=ea(Q*ea(.0000999999974));O=ea(aa*ea(.0000999999974));V=ea(-U);P=ea(-_);Z=ea(-O);$=ea(W+ea((U>V?U:V)+ea(.0000999999974)));V=ea(K+ea((_>P?_:P)+ea(.0000999999974)));P=ea(L+ea((O>Z?O:Z)+ea(.0000999999974)));Z=V>P?V:P;O=ea(($>Z?$:Z)*ea(.00392158423));Z=ea(ea(O+ea(O*ea(.0000999999974)))*ea(1.0e4));F=(g[k>>2]=Z,c[k>>2]|0);Z=ea(ea(1.0)/O);G=~~ea(ea(Z*$)+ea(1.0));E=~~ea(ea(Z*V)+ea(1.0));D=~~ea(ea(Z*P)+ea(1.0));da=J==ea(0.0);ca=Q==ea(0.0);ba=aa==ea(0.0);g[h>>2]=ea(2.3509887e-38);g[s>>2]=ea(2.3509887e-38);g[t>>2]=ea(2.3509887e-38);g[u>>2]=ea(0.0);g[f>>2]=J;g[v>>2]=Q;g[w>>2]=aa;g[x>>2]=ea(0.0);aa=ea(g[(da?h:f)>>2]);Q=ea(g[(ca?h:f)+4>>2]);J=ea(g[(ba?h:f)+8>>2]);ba=(g[k>>2]=aa,c[k>>2]|0);ca=(g[k>>2]=Q,c[k>>2]|0);da=D|(g[k>>2]=J,c[k>>2]|0)&-256;D=G|ba&-256|0;ba=E|ca&-256|0;ca=da|0;c[A>>2]=D;c[z+(b*24|0)+4>>2]=ba;c[z+(b*24|0)+8>>2]=ca;ca=C;z=c[ca>>2]|0;ba=c[ca+4>>2]&255;ca=cFi(F>>>8|0,0,40)|0;F=C;c[F>>2]=ca|z;c[F+4>>2]=H|ba}if(B){j=1;break}else y=b}i=e;return j|0}function xBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=a+8|0;if(!(c[e>>2]|0)){f=c[a+536>>2]|0;g=a+12|0;c[g>>2]=((f&31|0)!=0&1)+(f>>>5);VJa(d+1|0,0);f=UJa(d,c[g>>2]<<2,502704,62)|0;c[e>>2]=f;PEi(f|0,0,c[g>>2]<<2|0)|0}g=a+4|0;f=a+16|0;h=a+20|0;j=(c[g>>2]|0)+(b*24|0)|0;while(1){b=c[g>>2]|0;k=(j-b|0)/24|0;l=k>>>5;m=(c[e>>2]|0)+(l<<2)|0;n=c[m>>2]|0;o=1<<(k&31);if(n&o){p=8;break}c[m>>2]=n|o;o=c[f>>2]|0;c[f>>2]=o>>>0<l>>>0?l:o;o=c[h>>2]|0;if(o>>>0<128){c[a+(o<<2)+24>>2]=k;q=c[h>>2]|0;r=c[g>>2]|0}else{q=o;r=b}c[h>>2]=q+1;b=j+16|0;o=VEi(c[b>>2]|0,c[b+4>>2]|0,2)|0;b=j;j=r+((o&524287)*24|0)|0;if((b|0)==(j|0)){p=8;break}}if((p|0)==8){i=d;return}}function yBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im;b=i;i=i+5280|0;f=b+4176|0;h=b+64|0;j=b+4224|0;l=b+4160|0;m=b+4240|0;n=b+4244|0;o=b+48|0;p=b+32|0;q=b;r=b+16|0;s=a+8|0;t=c[s>>2]|0;if(!t){i=b;return}c[m>>2]=0;c[n>>2]=0;u=o+4|0;v=o+8|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;w=p+4|0;x=p+8|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;y=a+20|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;z=c[y>>2]|0;c[y>>2]=0;if(z>>>0<129){y=z<<2;A=i;i=i+((1*y|0)+15&-16)|0;B=i;i=i+((1*y|0)+15&-16)|0;EMa(f);JMa(f,A,B,h,b+4248|0)|0;B=c[(HMa(f,a+24|0,z,0)|0)+8>>2]|0;if(z){A=z+-1|0;y=a+4|0;C=0;do{D=c[a+(c[B+(A-C<<2)>>2]<<2)+24>>2]|0;E=(c[s>>2]|0)+(D>>>5<<2)|0;c[E>>2]=c[E>>2]&~(1<<(D&31));y2a(c[y>>2]|0,D,d,e,m,n,j,l,o,p,q,r);C=C+1|0}while((C|0)!=(z|0))}}else{z=a+16|0;C=c[z>>2]|0;y=C+1|0;if(y){A=a+4|0;a=C;C=y;while(1){if(c[t+(a<<2)>>2]|0){y=31;B=C<<5;while(1){B=B+-1|0;D=(c[s>>2]|0)+(B>>>5<<2)|0;E=c[D>>2]|0;F=1<<(B&31);if(E&F){c[D>>2]=E&~F;y2a(c[A>>2]|0,B,d,e,m,n,j,l,o,p,q,r)}if(!y)break;else y=y+-1|0}}if(!a)break;else{y=a;a=a+-1|0;C=y}}}c[z>>2]=0}z=c[m>>2]|0;if(z){G=ea(g[l>>2]);I=ea(g[l+4>>2]);J=ea(g[l+8>>2]);g[z>>2]=G;g[z+4>>2]=I;g[z+8>>2]=J;m=z+16|0;z=m;C=c[z>>2]|0;a=c[z+4>>2]&255;z=cFi((c[j+4>>2]|0)>>>8|0,0,40)|0;r=m;c[r>>2]=z|C;c[r+4>>2]=H|a}if(!(c[n>>2]|0)){i=b;return}J=ea(g[o>>2]);I=ea(g[u>>2]);G=ea(g[v>>2]);K=ea(g[p>>2]);L=ea(g[w>>2]);M=ea(g[x>>2]);x=J>ea(-9999999940000000065998519.0e8);N=x?J:ea(-9999999940000000065998519.0e8);x=I>ea(-9999999940000000065998519.0e8);J=x?I:ea(-9999999940000000065998519.0e8);x=G>ea(-9999999940000000065998519.0e8);I=x?G:ea(-9999999940000000065998519.0e8);x=K<ea(9999999940000000065998519.0e8);G=x?K:ea(9999999940000000065998519.0e8);x=L<ea(9999999940000000065998519.0e8);K=x?L:ea(9999999940000000065998519.0e8);x=M<ea(9999999940000000065998519.0e8);L=x?M:ea(9999999940000000065998519.0e8);M=ea(ea(N+G)*ea(.5));O=ea(ea(J+K)*ea(.5));P=ea(ea(I+L)*ea(.5));Q=ea(ea(G-N)*ea(.5));N=ea(ea(K-J)*ea(.5));J=ea(ea(L-I)*ea(.5));I=ea(M*ea(.0000999999974));L=ea(O*ea(.0000999999974));K=ea(P*ea(.0000999999974));G=ea(-I);R=ea(-L);S=ea(-K);T=ea(Q+ea((I>G?I:G)+ea(.0000999999974)));G=ea(N+ea((L>R?L:R)+ea(.0000999999974)));R=ea(J+ea((K>S?K:S)+ea(.0000999999974)));S=G>R?G:R;K=ea((T>S?T:S)*ea(.00392158423));S=ea(ea(K+ea(K*ea(.0000999999974)))*ea(1.0e4));g[j>>2]=S;g[j+4>>2]=S;g[j+8>>2]=S;g[j+12>>2]=ea(0.0);J=ea(ea(1.0)/K);j=~~ea(ea(J*T)+ea(1.0));x=~~ea(ea(J*G)+ea(1.0));w=~~ea(ea(J*R)+ea(1.0));p=M==ea(0.0);v=O==ea(0.0);u=P==ea(0.0);g[h>>2]=ea(2.3509887e-38);g[h+4>>2]=ea(2.3509887e-38);g[h+8>>2]=ea(2.3509887e-38);g[h+12>>2]=ea(0.0);g[f>>2]=M;g[f+4>>2]=O;g[f+8>>2]=P;g[f+12>>2]=ea(0.0);P=ea(g[(p?h:f)>>2]);O=ea(g[(v?h:f)+4>>2]);M=ea(g[(u?h:f)+8>>2]);f=(g[k>>2]=P,c[k>>2]|0);h=(g[k>>2]=O,c[k>>2]|0);u=w|(g[k>>2]=M,c[k>>2]|0)&-256;w=j|f&-256|0;f=x|h&-256|0;h=u|0;c[l>>2]=w;c[l+4>>2]=f;c[l+8>>2]=h;g[l+12>>2]=ea(0.0);l=c[n>>2]|0;c[l>>2]=w;c[l+4>>2]=f;c[l+8>>2]=h;h=l+16|0;l=h;f=c[l>>2]|0;w=c[l+4>>2]&255;l=cFi((g[k>>2]=S,c[k>>2]|0)>>>8|0,0,40)|0;n=h;c[n>>2]=l|f;c[n+4>>2]=H|w;i=b;return}function zBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+32|0;e=d+16|0;f=d;h=a+536|0;j=c[h>>2]|0;if(!j){i=d;return}l=a+4|0;a=b+4|0;m=b+8|0;n=f+4|0;o=f+8|0;p=f+12|0;q=e+4|0;r=e+8|0;s=e+12|0;t=j;j=0;do{u=c[l>>2]|0;v=j;j=j+1|0;w=ea(g[b>>2]);x=ea(g[a>>2]);y=ea(g[m>>2]);z=u+(v*24|0)|0;A=ea(g[z>>2]);B=u+(v*24|0)+4|0;C=ea(g[B>>2]);D=u+(v*24|0)+8|0;E=ea(g[D>>2]);F=u+(v*24|0)+16|0;G=ea((c[k>>2]=c[F+4>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));v=(g[k>>2]=A,c[k>>2]|0);u=(g[k>>2]=C,c[k>>2]|0);I=ea(ea(v&255|0)*G);J=ea(ea(u&255|0)*G);K=ea(ea((g[k>>2]=E,c[k>>2]|0)&255|0)*G);G=ea(A-w);w=ea(C-x);x=ea(E-y);y=ea(G-I);E=ea(w-J);C=ea(x-K);A=ea(G+I);I=ea(w+J);J=ea(x+K);u=y>ea(-9999999940000000065998519.0e8);K=u?y:ea(-9999999940000000065998519.0e8);u=E>ea(-9999999940000000065998519.0e8);y=u?E:ea(-9999999940000000065998519.0e8);u=C>ea(-9999999940000000065998519.0e8);E=u?C:ea(-9999999940000000065998519.0e8);u=A<ea(9999999940000000065998519.0e8);C=u?A:ea(9999999940000000065998519.0e8);u=I<ea(9999999940000000065998519.0e8);A=u?I:ea(9999999940000000065998519.0e8);u=J<ea(9999999940000000065998519.0e8);I=u?J:ea(9999999940000000065998519.0e8);J=ea(ea(K+C)*ea(.5));x=ea(ea(y+A)*ea(.5));w=ea(ea(E+I)*ea(.5));G=ea(ea(C-K)*ea(.5));K=ea(ea(A-y)*ea(.5));y=ea(ea(I-E)*ea(.5));E=ea(J*ea(.0000999999974));I=ea(x*ea(.0000999999974));A=ea(w*ea(.0000999999974));C=ea(-E);L=ea(-I);M=ea(-A);N=ea(G+ea((E>C?E:C)+ea(.0000999999974)));C=ea(K+ea((I>L?I:L)+ea(.0000999999974)));L=ea(y+ea((A>M?A:M)+ea(.0000999999974)));M=C>L?C:L;A=ea((N>M?N:M)*ea(.00392158423));M=ea(ea(A+ea(A*ea(.0000999999974)))*ea(1.0e4));u=(g[k>>2]=M,c[k>>2]|0);M=ea(ea(1.0)/A);v=~~ea(ea(M*N)+ea(1.0));O=~~ea(ea(M*C)+ea(1.0));P=~~ea(ea(M*L)+ea(1.0));Q=J==ea(0.0);R=x==ea(0.0);S=w==ea(0.0);g[f>>2]=ea(2.3509887e-38);g[n>>2]=ea(2.3509887e-38);g[o>>2]=ea(2.3509887e-38);g[p>>2]=ea(0.0);g[e>>2]=J;g[q>>2]=x;g[r>>2]=w;g[s>>2]=ea(0.0);w=ea(g[(Q?f:e)>>2]);x=ea(g[(R?f:e)+4>>2]);J=ea(g[(S?f:e)+8>>2]);S=(g[k>>2]=w,c[k>>2]|0);R=(g[k>>2]=x,c[k>>2]|0);Q=P|(g[k>>2]=J,c[k>>2]|0)&-256;P=v|S&-256|0;S=O|R&-256|0;R=Q|0;c[z>>2]=P;c[B>>2]=S;c[D>>2]=R;R=F;D=c[R>>2]|0;S=c[R+4>>2]&255;R=cFi(u>>>8|0,0,40)|0;u=F;c[u>>2]=R|D;c[u+4>>2]=H|S;t=c[h>>2]|0}while(j>>>0<t>>>0);i=d;return}function ABa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;if(!b){c[f>>2]=0;xUa(a,0,f);yUa(a,c[a+4>>2]|0);i=e;return}g=a+8|0;h=c[g>>2]&2147483647;j=(b>>>2)+b|0;if((j>>>0<h>>>1>>>0&(h-j|0)>>>0>1024?0:h)>>>0<b>>>0){c[f>>2]=0;xUa(a,0,f);f=a+4|0;yUa(a,c[f>>2]|0);if((c[g>>2]&2147483647)>>>0<j>>>0){yUa(a,j);k=f}else k=f}else k=a+4|0;c[k>>2]=b;PEi(c[a>>2]|0,-1,b<<2|0)|0;b=c[d+536>>2]|0;k=c[d+4>>2]|0;if(!b){i=e;return}f=0;do{j=k+(f*24|0)+16|0;g=c[j>>2]|0;if(!((g&1|0)==0&0==0)?(h=c[d>>2]|0,l=VEi(g|0,c[j+4>>2]|0,21)|0,j=h+((l&524287)<<2)|0,(j|0)!=0):0)c[(c[a>>2]|0)+(c[j>>2]<<2)>>2]=f;f=f+1|0}while((f|0)!=(b|0));i=e;return}function BBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=c[a+4>>2]|0;if(g>>>0>b>>>0)h=c[(c[a>>2]|0)+(b<<2)>>2]|0;else h=-1;if(g>>>0>d>>>0)j=c[(c[a>>2]|0)+(d<<2)>>2]|0;else j=-1;g=c[e+4>>2]|0;if((h|0)!=-1){k=c[e>>2]|0;l=g+(h*24|0)+16|0;m=l;n=c[m>>2]|0;o=c[m+4>>2]|0;m=VEi(n|0,o|0,21)|0;p=l;c[p>>2]=n&-3;c[p+4>>2]=o;c[k+((m&524287)<<2)>>2]=-1;c[(c[a>>2]|0)+(b<<2)>>2]=-1}if((j|0)==-1|(h|0)==(j|0)){i=f;return}h=c[e>>2]|0;e=g+(j*24|0)+16|0;g=VEi(c[e>>2]|0,c[e+4>>2]|0,21)|0;c[h+((g&524287)<<2)>>2]=b;g=c[a>>2]|0;c[g+(b<<2)>>2]=j;c[g+(d<<2)>>2]=-1;i=f;return}function CBa(a,b,e,f,h,j,k,l,m,n){a=a|0;b=ea(b);e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,S=0,T=0,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=0,$=0,aa=0,ba=0;o=i;i=i+160|0;p=o+80|0;q=o;r=(n|0)==1?2:1;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;g[p>>2]=ea(8507058669999999534545717.0e13);g[p+4>>2]=ea(8507058669999999534545717.0e13);g[p+8>>2]=ea(8507058669999999534545717.0e13);g[p+12>>2]=ea(0.0);g[q>>2]=ea(-8507058669999999534545717.0e13);g[q+4>>2]=ea(-8507058669999999534545717.0e13);g[q+8>>2]=ea(-8507058669999999534545717.0e13);g[q+12>>2]=ea(0.0);g[p+16>>2]=ea(8507058669999999534545717.0e13);g[p+20>>2]=ea(8507058669999999534545717.0e13);g[p+24>>2]=ea(8507058669999999534545717.0e13);g[p+28>>2]=ea(0.0);g[q+16>>2]=ea(-8507058669999999534545717.0e13);g[q+20>>2]=ea(-8507058669999999534545717.0e13);g[q+24>>2]=ea(-8507058669999999534545717.0e13);g[q+28>>2]=ea(0.0);g[p+32>>2]=ea(8507058669999999534545717.0e13);g[p+36>>2]=ea(8507058669999999534545717.0e13);g[p+40>>2]=ea(8507058669999999534545717.0e13);g[p+44>>2]=ea(0.0);g[q+32>>2]=ea(-8507058669999999534545717.0e13);g[q+36>>2]=ea(-8507058669999999534545717.0e13);g[q+40>>2]=ea(-8507058669999999534545717.0e13);g[q+44>>2]=ea(0.0);g[p+48>>2]=ea(8507058669999999534545717.0e13);g[p+52>>2]=ea(8507058669999999534545717.0e13);g[p+56>>2]=ea(8507058669999999534545717.0e13);g[p+60>>2]=ea(0.0);g[q+48>>2]=ea(-8507058669999999534545717.0e13);g[q+52>>2]=ea(-8507058669999999534545717.0e13);g[q+56>>2]=ea(-8507058669999999534545717.0e13);g[q+60>>2]=ea(0.0);g[p+64>>2]=ea(8507058669999999534545717.0e13);g[p+68>>2]=ea(8507058669999999534545717.0e13);g[p+72>>2]=ea(8507058669999999534545717.0e13);g[p+76>>2]=ea(0.0);g[q+64>>2]=ea(-8507058669999999534545717.0e13);g[q+68>>2]=ea(-8507058669999999534545717.0e13);g[q+72>>2]=ea(-8507058669999999534545717.0e13);g[q+76>>2]=ea(0.0);n=(f|0)==0;if(n){s=a+4|0;t=a+8|0;u=a+12|0;v=a;w=0;x=0;y=0;z=0}else{A=m?16:0;m=0;do{B=h+(m<<5)|0;C=ea(g[B>>2]);D=ea(g[B+4>>2]);E=ea(g[B+8>>2]);F=ea(g[B+12>>2]);G=h+(m<<5)+16|0;H=ea(g[G>>2]);I=ea(g[G+4>>2]);J=ea(g[G+8>>2]);K=ea(g[G+12>>2]);L=ea(C-H);M=ea(D-I);N=ea(E-J);O=ea(F-K);P=ea(C+H);H=ea(D+I);I=ea(E+J);J=ea(F+K);K=ea(g[B+(r<<2)>>2]);F=ea(g[G+(r<<2)>>2]);G=d[503328+((ea(K-F)>e&1)<<2|A|(ea(K+F)<e&1)<<3|L>b|(P<b&1)<<1)>>0]|0;B=p+(G<<4)|0;F=ea(g[B>>2]);Q=B+4|0;K=ea(g[Q>>2]);R=B+8|0;E=ea(g[R>>2]);S=B+12|0;D=ea(g[S>>2]);T=q+(G<<4)|0;C=ea(g[T>>2]);U=T+4|0;V=ea(g[U>>2]);W=T+8|0;X=ea(g[W>>2]);Y=T+12|0;Z=ea(g[Y>>2]);g[B>>2]=F<L?F:L;g[Q>>2]=K<M?K:M;g[R>>2]=E<N?E:N;g[S>>2]=D<O?D:O;g[T>>2]=C>P?C:P;g[U>>2]=V>H?V:H;g[W>>2]=X>I?X:I;g[Y>>2]=Z>J?Z:J;c[h+(m<<5)+12>>2]=G;Y=a+(G<<2)|0;c[Y>>2]=(c[Y>>2]|0)+1;m=m+1|0}while((m|0)!=(f|0));m=a+4|0;A=a+8|0;r=a+12|0;s=m;t=A;u=r;v=a;w=c[a>>2]|0;x=c[m>>2]|0;y=c[A>>2]|0;z=c[r>>2]|0}r=a+20|0;c[r>>2]=0;A=a+24|0;c[A>>2]=w;m=x+w|0;Y=a+28|0;c[Y>>2]=m;G=y+m|0;m=a+32|0;c[m>>2]=G;W=a+36|0;c[W>>2]=z+G;if(n){_=w;$=x;aa=y;ba=z}else{z=0;do{y=c[h+(z<<5)+12>>2]|0;x=a+(y<<2)+20|0;w=c[x>>2]|0;c[x>>2]=w+1;x=h+(z<<5)|0;b=ea(g[x>>2]);e=ea(g[x+4>>2]);J=ea(g[x+8>>2]);x=y|0;y=k+(w<<5)|0;g[y>>2]=b;g[y+4>>2]=e;g[y+8>>2]=J;c[y+12>>2]=x;x=h+(z<<5)+16|0;J=ea(g[x>>2]);e=ea(g[x+4>>2]);b=ea(g[x+8>>2]);Z=ea(g[x+12>>2]);x=k+(w<<5)+16|0;g[x>>2]=J;g[x+4>>2]=e;g[x+8>>2]=b;g[x+12>>2]=Z;x=j+(z<<3)|0;y=c[x+4>>2]|0;n=l+(w<<3)|0;c[n>>2]=c[x>>2];c[n+4>>2]=y;z=z+1|0}while((z|0)!=(f|0));_=c[v>>2]|0;$=c[s>>2]|0;aa=c[t>>2]|0;ba=c[u>>2]|0}c[r>>2]=0;c[A>>2]=_;A=$+_|0;c[Y>>2]=A;Y=aa+A|0;c[m>>2]=Y;c[W>>2]=ba+Y;Y=0;do{ba=p+(Y<<4)|0;Z=ea(g[ba>>2]);b=ea(g[ba+4>>2]);e=ea(g[ba+8>>2]);ba=q+(Y<<4)|0;J=ea(g[ba>>2]);I=ea(g[ba+4>>2]);X=ea(g[ba+8>>2]);H=ea(ea(b+I)*ea(.5));V=ea(ea(e+X)*ea(.5));P=ea(ea(J-Z)*ea(.5));C=ea(ea(I-b)*ea(.5));b=ea(ea(X-e)*ea(.5));g[a+(Y<<5)+48>>2]=ea(ea(Z+J)*ea(.5));g[a+(Y<<5)+52>>2]=H;g[a+(Y<<5)+56>>2]=V;g[a+(Y<<5)+64>>2]=P;g[a+(Y<<5)+68>>2]=C;g[a+(Y<<5)+72>>2]=b;Y=Y+1|0}while((Y|0)!=5);i=o;return}function DBa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;f=b+544|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;g[b+568>>2]=ea(.75);c[b+572>>2]=-1;c[b+576>>2]=0;c[b+580>>2]=0;z2a(f,64);c[b+584>>2]=0;c[b+588>>2]=0;c[b+592>>2]=0;g[b+688>>2]=ea(0.0);g[b+692>>2]=ea(0.0);g[b+696>>2]=ea(0.0);g[b+704>>2]=ea(-8507058669999999534545717.0e13);g[b+708>>2]=ea(-8507058669999999534545717.0e13);g[b+712>>2]=ea(-8507058669999999534545717.0e13);g[b+720>>2]=ea(0.0);g[b+724>>2]=ea(0.0);g[b+728>>2]=ea(0.0);g[b+736>>2]=ea(-8507058669999999534545717.0e13);g[b+740>>2]=ea(-8507058669999999534545717.0e13);g[b+744>>2]=ea(-8507058669999999534545717.0e13);g[b+752>>2]=ea(0.0);g[b+756>>2]=ea(0.0);g[b+760>>2]=ea(0.0);g[b+768>>2]=ea(-8507058669999999534545717.0e13);g[b+772>>2]=ea(-8507058669999999534545717.0e13);g[b+776>>2]=ea(-8507058669999999534545717.0e13);g[b+784>>2]=ea(0.0);g[b+788>>2]=ea(0.0);g[b+792>>2]=ea(0.0);g[b+800>>2]=ea(-8507058669999999534545717.0e13);g[b+804>>2]=ea(-8507058669999999534545717.0e13);g[b+808>>2]=ea(-8507058669999999534545717.0e13);g[b+816>>2]=ea(0.0);g[b+820>>2]=ea(0.0);g[b+824>>2]=ea(0.0);g[b+832>>2]=ea(-8507058669999999534545717.0e13);g[b+836>>2]=ea(-8507058669999999534545717.0e13);g[b+840>>2]=ea(-8507058669999999534545717.0e13);f=b+864|0;h=b+1984|0;j=f;do{g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(0.0);g[j+56>>2]=ea(0.0);g[j+64>>2]=ea(-8507058669999999534545717.0e13);g[j+68>>2]=ea(-8507058669999999534545717.0e13);g[j+72>>2]=ea(-8507058669999999534545717.0e13);g[j+80>>2]=ea(0.0);g[j+84>>2]=ea(0.0);g[j+88>>2]=ea(0.0);g[j+96>>2]=ea(-8507058669999999534545717.0e13);g[j+100>>2]=ea(-8507058669999999534545717.0e13);g[j+104>>2]=ea(-8507058669999999534545717.0e13);g[j+112>>2]=ea(0.0);g[j+116>>2]=ea(0.0);g[j+120>>2]=ea(0.0);g[j+128>>2]=ea(-8507058669999999534545717.0e13);g[j+132>>2]=ea(-8507058669999999534545717.0e13);g[j+136>>2]=ea(-8507058669999999534545717.0e13);g[j+144>>2]=ea(0.0);g[j+148>>2]=ea(0.0);g[j+152>>2]=ea(0.0);g[j+160>>2]=ea(-8507058669999999534545717.0e13);g[j+164>>2]=ea(-8507058669999999534545717.0e13);g[j+168>>2]=ea(-8507058669999999534545717.0e13);g[j+176>>2]=ea(0.0);g[j+180>>2]=ea(0.0);g[j+184>>2]=ea(0.0);g[j+192>>2]=ea(-8507058669999999534545717.0e13);g[j+196>>2]=ea(-8507058669999999534545717.0e13);g[j+200>>2]=ea(-8507058669999999534545717.0e13);j=j+224|0}while((j|0)!=(h|0));h=b+640|0;j=b+1984|0;k=b+7584|0;l=j;do{g[l+48>>2]=ea(0.0);g[l+52>>2]=ea(0.0);g[l+56>>2]=ea(0.0);g[l+64>>2]=ea(-8507058669999999534545717.0e13);g[l+68>>2]=ea(-8507058669999999534545717.0e13);g[l+72>>2]=ea(-8507058669999999534545717.0e13);g[l+80>>2]=ea(0.0);g[l+84>>2]=ea(0.0);g[l+88>>2]=ea(0.0);g[l+96>>2]=ea(-8507058669999999534545717.0e13);g[l+100>>2]=ea(-8507058669999999534545717.0e13);g[l+104>>2]=ea(-8507058669999999534545717.0e13);g[l+112>>2]=ea(0.0);g[l+116>>2]=ea(0.0);g[l+120>>2]=ea(0.0);g[l+128>>2]=ea(-8507058669999999534545717.0e13);g[l+132>>2]=ea(-8507058669999999534545717.0e13);g[l+136>>2]=ea(-8507058669999999534545717.0e13);g[l+144>>2]=ea(0.0);g[l+148>>2]=ea(0.0);g[l+152>>2]=ea(0.0);g[l+160>>2]=ea(-8507058669999999534545717.0e13);g[l+164>>2]=ea(-8507058669999999534545717.0e13);g[l+168>>2]=ea(-8507058669999999534545717.0e13);g[l+176>>2]=ea(0.0);g[l+180>>2]=ea(0.0);g[l+184>>2]=ea(0.0);g[l+192>>2]=ea(-8507058669999999534545717.0e13);g[l+196>>2]=ea(-8507058669999999534545717.0e13);g[l+200>>2]=ea(-8507058669999999534545717.0e13);l=l+224|0}while((l|0)!=(k|0));a[b+7584>>0]=1;a[b+7585>>0]=d&1^1;g[b+608>>2]=ea(0.0);g[b+612>>2]=ea(0.0);g[b+616>>2]=ea(0.0);g[b+624>>2]=ea(-8507058669999999534545717.0e13);g[b+628>>2]=ea(-8507058669999999534545717.0e13);g[b+632>>2]=ea(-8507058669999999534545717.0e13);d=h+0|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=f+0|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+1088|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+1312|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+1536|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+1760|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=j+0|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+2208|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+2432|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+2656|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+2880|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+3104|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+3328|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+3552|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+3776|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+4e3|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+4224|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+4448|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+4672|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+4896|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+5120|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+5344|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+5568|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+5792|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+6016|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+6240|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+6464|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+6688|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+6912|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+7136|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));d=b+7360|0;h=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(h|0));i=e;return}function EBa(a){a=a|0;var b=0,d=0;b=i;FBa(a);d=a+544|0;a=c[d>>2]|0;if(!a){i=b;return}VJa(d,a);i=b;return}function FBa(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;a[b+7584>>0]=1;c[b>>2]=0;c[b+4>>2]=0;if(a[b+7585>>0]|0){e=b+8|0;VJa(d+4|0,c[e>>2]|0);c[e>>2]=0;e=b+12|0;VJa(d+3|0,c[e>>2]|0);c[e>>2]=0;e=b+16|0;VJa(d+2|0,c[e>>2]|0);c[e>>2]=0}e=b+20|0;VJa(d+1|0,c[e>>2]|0);c[e>>2]=0;e=b+24|0;VJa(d,c[e>>2]|0);c[e>>2]=0;c[b+584>>2]=0;c[b+588>>2]=0;i=d;return}function GBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;c[a+584>>2]=b;e=a+588|0;f=c[e>>2]|0;if(!(f>>>0<b>>>0|f>>>1>>>0>b>>>0)){i=d;return}f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;f=(b>>>16|b)+1|0;c[e>>2]=f;e=a+24|0;VJa(d+3|0,c[e>>2]|0);b=a+20|0;VJa(d+2|0,c[b>>2]|0);c[b>>2]=UJa(d+1|0,f<<5,503184,523)|0;c[e>>2]=UJa(d,(f<<3)+15&-16,503184,524)|0;i=d;return}function HBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=a+4|0;e=c[d>>2]|0;f=(e|0)==0?32:e<<1;c[d>>2]=f;d=UJa(b+5|0,f*24|0,503184,540)|0;e=UJa(b+4|0,f<<3,503184,541)|0;g=UJa(b+3|0,f<<2,503184,542)|0;f=a+8|0;h=c[f>>2]|0;if(h){YEi(d|0,h|0,(c[a>>2]|0)*24|0)|0;VJa(b+2|0,c[f>>2]|0)}h=a+12|0;j=c[h>>2]|0;if(j){YEi(e|0,j|0,c[a>>2]<<3|0)|0;VJa(b+1|0,c[h>>2]|0)}j=a+16|0;k=c[j>>2]|0;if(!k){c[f>>2]=d;c[h>>2]=e;c[j>>2]=g;i=b;return}YEi(g|0,k|0,c[a>>2]<<2|0)|0;VJa(b,c[j>>2]|0);c[f>>2]=d;c[h>>2]=e;c[j>>2]=g;i=b;return}
function IBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;h=f+8|0;j=f;k=b+7584|0;if(!(a[k>>0]|0)){l=b+28|0;m=c[l>>2]|0;if(m>>>0<16){c[l>>2]=m+1;n=d;o=c[n+4>>2]|0;p=b+(m<<3)+32|0;c[p>>2]=c[n>>2];c[p+4>>2]=o;g[b+(m*24|0)+160>>2]=ea(g[e>>2]);g[b+(m*24|0)+164>>2]=ea(g[e+4>>2]);g[b+(m*24|0)+168>>2]=ea(g[e+8>>2]);g[b+(m*24|0)+172>>2]=ea(g[e+12>>2]);g[b+(m*24|0)+176>>2]=ea(g[e+16>>2]);g[b+(m*24|0)+180>>2]=ea(g[e+20>>2]);i=f;return 1}m=b+4|0;o=b+12|0;p=b+8|0;n=b+16|0;q=b+544|0;r=0;do{s=b+(r<<3)+32|0;t=c[b>>2]|0;if((t|0)==(c[m>>2]|0)){HBa(b);u=c[b>>2]|0}else u=t;c[b>>2]=u+1;t=s;v=c[t+4>>2]|0;w=(c[o>>2]|0)+(u<<3)|0;c[w>>2]=c[t>>2];c[w+4>>2]=v;v=c[p>>2]|0;g[v+(u*24|0)>>2]=ea(g[b+(r*24|0)+160>>2]);g[v+(u*24|0)+4>>2]=ea(g[b+(r*24|0)+164>>2]);g[v+(u*24|0)+8>>2]=ea(g[b+(r*24|0)+168>>2]);g[v+(u*24|0)+12>>2]=ea(g[b+(r*24|0)+172>>2]);g[v+(u*24|0)+16>>2]=ea(g[b+(r*24|0)+176>>2]);g[v+(u*24|0)+20>>2]=ea(g[b+(r*24|0)+180>>2]);c[(c[n>>2]|0)+(u<<2)>>2]=-1;v=s;s=c[v+4>>2]|0;w=j;c[w>>2]=c[v>>2];c[w+4>>2]=s;s=A2a(q,j,h)|0;if(!((a[h>>0]|0)!=0|(s|0)==0)){w=j;v=c[w+4>>2]|0;t=s;c[t>>2]=c[w>>2];c[t+4>>2]=v;c[s+8>>2]=u}r=r+1|0}while(r>>>0<(c[l>>2]|0)>>>0);c[l>>2]=0;a[k>>0]=1}k=c[b>>2]|0;if((k|0)==(c[b+4>>2]|0)){HBa(b);x=c[b>>2]|0}else x=k;c[b>>2]=x+1;k=d;l=c[k+4>>2]|0;r=(c[b+12>>2]|0)+(x<<3)|0;c[r>>2]=c[k>>2];c[r+4>>2]=l;l=c[b+8>>2]|0;g[l+(x*24|0)>>2]=ea(g[e>>2]);g[l+(x*24|0)+4>>2]=ea(g[e+4>>2]);g[l+(x*24|0)+8>>2]=ea(g[e+8>>2]);g[l+(x*24|0)+12>>2]=ea(g[e+12>>2]);g[l+(x*24|0)+16>>2]=ea(g[e+16>>2]);g[l+(x*24|0)+20>>2]=ea(g[e+20>>2]);c[(c[b+16>>2]|0)+(x<<2)>>2]=-1;e=d;d=c[e+4>>2]|0;l=j;c[l>>2]=c[e>>2];c[l+4>>2]=d;d=A2a(b+544|0,j,h)|0;if((a[h>>0]|0)!=0|(d|0)==0){i=f;return 1}h=j;j=c[h+4>>2]|0;b=d;c[b>>2]=c[h>>2];c[b+4>>2]=j;c[d+8>>2]=x;i=f;return 1}function JBa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;f=b+564|0;h=c[f>>2]|0;a:do if((h|0)!=0?(j=c[d>>2]|0,k=c[d+4>>2]|0,l=_Ei(j|0,k|0,-1,~j|0)|0,m=H,n=VEi(l|0,m|0,22)|0,o=n^l,l=H^m,m=cFi(o|0,l|0,13)|0,n=_Ei(o|0,l|0,~m|0,~H|0)|0,m=H,l=VEi(n|0,m|0,8)|0,o=gFi(l^n|0,H^m|0,9,0)|0,m=H,n=VEi(o|0,m|0,15)|0,l=n^o,o=H^m,m=cFi(l|0,o|0,27)|0,n=_Ei(l|0,o|0,~m|0,~H|0)|0,m=H,o=VEi(n|0,m|0,31)|0,H^m,m=b+556|0,l=c[(c[m>>2]|0)+(((o^n)&h+-1)<<2)>>2]|0,(l|0)!=-1):0){n=b+548|0;o=c[n>>2]|0;p=b+552|0;q=l;while(1){if((c[o+(q*12|0)>>2]|0)==(j|0)?(c[o+(q*12|0)+4>>2]|0)==(k|0):0)break;l=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((l|0)==-1)break a;else q=l}if(o+(q*12|0)|0){k=c[o+(q*12|0)+8>>2]|0;j=b+16|0;l=c[(c[j>>2]|0)+(k<<2)>>2]|0;B2a(b+544|0,d)|0;r=(c[b>>2]|0)+-1|0;c[b>>2]=r;if((k|0)!=(r|0)){s=c[b+12>>2]|0;t=s+(r<<3)|0;u=c[b+8>>2]|0;g[u+(k*24|0)>>2]=ea(g[u+(r*24|0)>>2]);g[u+(k*24|0)+4>>2]=ea(g[u+(r*24|0)+4>>2]);g[u+(k*24|0)+8>>2]=ea(g[u+(r*24|0)+8>>2]);g[u+(k*24|0)+12>>2]=ea(g[u+(r*24|0)+12>>2]);g[u+(k*24|0)+16>>2]=ea(g[u+(r*24|0)+16>>2]);g[u+(k*24|0)+20>>2]=ea(g[u+(r*24|0)+20>>2]);u=t;v=c[u+4>>2]|0;w=s+(k<<3)|0;c[w>>2]=c[u>>2];c[w+4>>2]=v;v=c[j>>2]|0;c[v+(k<<2)>>2]=c[v+(c[b>>2]<<2)>>2];v=c[f>>2]|0;j=c[t>>2]|0;t=c[s+(r<<3)+4>>2]|0;r=_Ei(j|0,t|0,-1,~j|0)|0;s=H;w=VEi(r|0,s|0,22)|0;u=w^r;r=H^s;s=cFi(u|0,r|0,13)|0;w=_Ei(u|0,r|0,~s|0,~H|0)|0;s=H;r=VEi(w|0,s|0,8)|0;u=gFi(r^w|0,H^s|0,9,0)|0;s=H;w=VEi(u|0,s|0,15)|0;r=w^u;u=H^s;s=cFi(r|0,u|0,27)|0;w=_Ei(r|0,u|0,~s|0,~H|0)|0;s=H;u=VEi(w|0,s|0,31)|0;s=c[n>>2]|0;r=(c[m>>2]|0)+(((u^w)&v+-1)<<2)|0;while(1){x=c[r>>2]|0;if((c[s+(x*12|0)>>2]|0)==(j|0)?(c[s+(x*12|0)+4>>2]|0)==(t|0):0)break;r=(c[p>>2]|0)+(x<<2)|0}c[s+(x*12|0)+8>>2]=k}if(a[b+7584>>0]|0){y=1;i=e;return y|0}p=c[b+20>>2]|0;g[p+(l<<5)>>2]=ea(0.0);g[p+(l<<5)+4>>2]=ea(0.0);g[p+(l<<5)+8>>2]=ea(0.0);g[p+(l<<5)+16>>2]=ea(-8507058669999999534545717.0e13);g[p+(l<<5)+20>>2]=ea(-8507058669999999534545717.0e13);g[p+(l<<5)+24>>2]=ea(-8507058669999999534545717.0e13);y=1;i=e;return y|0}}while(0);x=b+28|0;f=c[x>>2]|0;if(!f){y=0;i=e;return y|0}h=c[d>>2]|0;p=d+4|0;d=0;while(1){z=b+(d<<3)+32|0;if((c[z>>2]|0)==(h|0)?(c[b+(d<<3)+36>>2]|0)==(c[p>>2]|0):0)break;r=d+1|0;if(r>>>0<f>>>0)d=r;else{y=0;A=22;break}}if((A|0)==22){i=e;return y|0}A=f+-1|0;c[x>>2]=A;g[b+(d*24|0)+160>>2]=ea(g[b+(A*24|0)+160>>2]);g[b+(d*24|0)+164>>2]=ea(g[b+(A*24|0)+164>>2]);g[b+(d*24|0)+168>>2]=ea(g[b+(A*24|0)+168>>2]);g[b+(d*24|0)+172>>2]=ea(g[b+(A*24|0)+172>>2]);g[b+(d*24|0)+176>>2]=ea(g[b+(A*24|0)+176>>2]);g[b+(d*24|0)+180>>2]=ea(g[b+(A*24|0)+180>>2]);A=b+(c[x>>2]<<3)+32|0;x=c[A+4>>2]|0;b=z;c[b>>2]=c[A>>2];c[b+4>>2]=x;y=1;i=e;return y|0}function KBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if(!(JBa(a,c)|0)){e=0;i=d;return e|0}IBa(a,c,b)|0;e=1;i=d;return e|0}function LBa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;d=i;i=i+10352|0;e=d+8192|0;f=d+8288|0;h=d;j=d+10339|0;l=d+10337|0;m=d+10338|0;n=d+10340|0;o=d+10341|0;p=b+7584|0;if(!(a[p>>0]|0)){i=d;return}a[p>>0]=0;p=c[b>>2]|0;if(!p){c[b+584>>2]=0;i=d;return}q=UJa(d+10336|0,p<<2,503184,1015)|0;r=c[b+12>>2]|0;s=0;do{t=r+(s<<3)|0;c[q+(s<<2)>>2]=c[t>>2];c[t>>2]=s;s=s+1|0}while((s|0)!=(p|0));s=p>>>0>256;if(s){r=UJa(j,p<<3,503184,1030)|0;u=UJa(l,p<<5,503184,1031)|0;v=r}else{u=h;v=f}f=c[b+8>>2]|0;h=b+12|0;r=c[h>>2]|0;l=p+-1|0;j=f+(l*24|0)|0;w=ea(g[j>>2]);x=ea(g[j+4>>2]);y=ea(g[j+8>>2]);j=f+(l*24|0)+12|0;z=ea(g[j>>2]);A=ea(g[j+4>>2]);B=ea(g[j+8>>2]);if(!l){C=z;D=w;E=B;F=y;G=x;H=A}else{I=z;z=w;w=B;B=y;y=x;x=A;j=0;while(1){t=f+(j*24|0)|0;A=ea(g[t>>2]);J=ea(g[t+4>>2]);K=ea(g[t+8>>2]);L=ea(g[t+12>>2]);M=z<A?z:A;A=y<J?y:J;J=B<K?B:K;t=f+(j*24|0)+12|0;K=ea(g[t+4>>2]);N=ea(g[t+8>>2]);O=I>L?I:L;L=x>K?x:K;K=w>N?w:N;j=j+1|0;if((j|0)==(l|0)){C=O;D=M;E=K;F=J;G=A;H=L;break}else{I=O;z=M;w=K;B=J;y=A;x=L}}}x=ea(ea(H+G)*ea(.5));y=ea(ea(E+F)*ea(.5));B=ea(ea(C-D)*ea(.5));w=ea(ea(H-G)*ea(.5));G=ea(ea(E-F)*ea(.5));l=b+608|0;g[l>>2]=ea(ea(C+D)*ea(.5));g[b+612>>2]=x;g[b+616>>2]=y;g[b+624>>2]=B;g[b+628>>2]=w;g[b+632>>2]=G;j=ea(S(ea(w)))<ea(S(ea(G)));t=j?1:2;j=0;do{g[v+(j<<2)>>2]=ea(g[f+(j*24|0)+(t<<2)>>2]);j=j+1|0}while((j|0)!=(p|0));KMa(e);j=0;P=c[(OMa(e,v,p)|0)+8>>2]|0;while(1){Q=c[P>>2]|0;R=f+(Q*24|0)|0;G=ea(g[R>>2]);w=ea(g[R+4>>2]);B=ea(g[R+8>>2]);y=ea(g[R+12>>2]);R=f+(Q*24|0)+12|0;x=ea(g[R+4>>2]);D=ea(g[R+8>>2]);C=ea(ea(w+x)*ea(.5));F=ea(ea(B+D)*ea(.5));E=ea(ea(y+ea(0.0))*ea(.5));H=ea(ea(y-G)*ea(.5));z=ea(ea(x-w)*ea(.5));w=ea(ea(D-B)*ea(.5));B=ea(ea(ea(0.0)-y)*ea(.5));R=u+(j<<5)|0;g[R>>2]=ea(ea(G+y)*ea(.5));g[R+4>>2]=C;g[R+8>>2]=F;g[R+12>>2]=E;R=u+(j<<5)+16|0;g[R>>2]=H;g[R+4>>2]=z;g[R+8>>2]=w;g[R+12>>2]=B;R=r+(Q<<3)|0;Q=c[R+4>>2]|0;U=v+(j<<3)|0;c[U>>2]=c[R>>2];c[U+4>>2]=Q;j=j+1|0;if((j|0)==(p|0))break;else P=P+4|0}MMa(e);P=b+592|0;c[P>>2]=t;GBa(b,p);t=b+20|0;j=b+24|0;r=c[P>>2]|0;B=ea(g[l>>2]);f=b+640|0;CBa(f,B,ea(g[l+(((r|0)==1?2:1)<<2)>>2]),p,u,v,c[t>>2]|0,c[j>>2]|0,0,r);r=c[t>>2]|0;l=c[j>>2]|0;Q=c[P>>2]|0;U=(Q|0)==1?2:1;R=0;do{V=c[b+(R<<2)+640>>2]|0;if(!V){W=b+(R*224|0)+864|0;X=W+40|0;do{c[W>>2]=0;W=W+4|0}while((W|0)<(X|0))}else{Y=c[b+(R<<2)+660>>2]|0;Z=r+(Y<<5)|0;_=l+(Y<<3)|0;Y=b+(R<<5)+688|0;B=ea(g[Y>>2]);CBa(b+(R*224|0)+864|0,B,ea(g[Y+(U<<2)>>2]),V,Z,_,u,v,(R|0)==4,Q);YEi(Z|0,u|0,V<<5|0)|0;YEi(_|0,v|0,V<<3|0)|0}R=R+1|0}while((R|0)!=5);$=0;do{R=c[t>>2]|0;Q=c[b+($<<2)+660>>2]|0;U=c[j>>2]|0;l=c[P>>2]|0;r=(l|0)==1?2:1;_=0;do{Z=c[b+($*224|0)+(_<<2)+864>>2]|0;if(!Z){W=b+($*1120|0)+(_*224|0)+1984|0;X=W+40|0;do{c[W>>2]=0;W=W+4|0}while((W|0)<(X|0))}else{Y=(c[b+($*224|0)+(_<<2)+884>>2]|0)+Q|0;aa=R+(Y<<5)|0;ba=U+(Y<<3)|0;Y=b+($*224|0)+(_<<5)+912|0;B=ea(g[Y>>2]);CBa(b+($*1120|0)+(_*224|0)+1984|0,B,ea(g[Y+(r<<2)>>2]),Z,aa,ba,u,v,(_|0)==4,l);YEi(aa|0,u|0,Z<<5|0)|0;YEi(ba|0,v|0,Z<<3|0)|0}_=_+1|0}while((_|0)!=5);$=$+1|0}while(($|0)!=5);$=c[t>>2]|0;t=0;do{W=c[P>>2]|0;B=ea(g[$+(t<<5)+(W<<2)>>2]);w=ea(g[$+(t<<5)+16+(W<<2)>>2]);z=ea(B-w);W=(g[k>>2]=z,c[k>>2]|0);z=ea(B+w);X=(g[k>>2]=z,c[k>>2]|0);c[$+(t<<5)+12>>2]=(W|0)<0?~W:W|-2147483648;c[$+(t<<5)+28>>2]=(X|0)<0?~X:X|-2147483648;t=t+1|0}while((t|0)!=(p|0));if(s){VJa(m,u);VJa(n,v)}v=c[j>>2]|0;j=c[h>>2]|0;h=c[b+16>>2]|0;if(!h){n=0;do{u=v+(n<<3)|0;m=c[u>>2]|0;s=c[q+(m<<2)>>2]|0;c[u>>2]=s;c[j+(m<<3)>>2]=s;n=n+1|0}while((n|0)!=(p|0))}else{n=0;do{s=v+(n<<3)|0;m=c[s>>2]|0;u=c[q+(m<<2)>>2]|0;c[s>>2]=u;c[j+(m<<3)>>2]=u;c[h+(m<<2)>>2]=n;n=n+1|0}while((n|0)!=(p|0))}VJa(o,q);g[e>>2]=ea(1.0);g[e+4>>2]=ea(1.0);g[e+8>>2]=ea(1.0);g[e+12>>2]=ea(1.0);g[e+16>>2]=ea(1.0);g[e+20>>2]=ea(-1.0);g[e+24>>2]=ea(1.0);g[e+28>>2]=ea(-1.0);g[e+32>>2]=ea(1.0);g[e+36>>2]=ea(1.0);g[e+40>>2]=ea(-1.0);g[e+44>>2]=ea(-1.0);g[e+48>>2]=ea(-1.0);g[e+52>>2]=ea(1.0);g[e+56>>2]=ea(1.0);g[e+60>>2]=ea(-1.0);g[e+64>>2]=ea(1.0);g[e+68>>2]=ea(-1.0);g[e+72>>2]=ea(-1.0);g[e+76>>2]=ea(-1.0);g[e+80>>2]=ea(1.0);g[e+84>>2]=ea(-1.0);g[e+88>>2]=ea(-1.0);g[e+92>>2]=ea(-1.0);z=ea(1.0);w=ea(1.0);B=ea(1.0);q=0;while(1){H=ea(T(ea(ea(ea(z*z)+ea(w*w))+ea(B*B))));if(H>ea(0.0)){E=ea(ea(1.0)/H);g[e+(q*12|0)>>2]=ea(z*E);g[e+(q*12|0)+4>>2]=ea(w*E);g[e+(q*12|0)+8>>2]=ea(B*E)}o=q+1|0;if((o|0)==8)break;E=ea(g[e+(o*12|0)>>2]);H=ea(g[e+(o*12|0)+4>>2]);z=E;w=H;B=ea(g[e+(o*12|0)+8>>2]);q=o}C2a(f,e);C2a(b+864|0,e);C2a(b+1088|0,e);C2a(b+1312|0,e);C2a(b+1536|0,e);C2a(b+1760|0,e);C2a(b+1984|0,e);C2a(b+2208|0,e);C2a(b+2432|0,e);C2a(b+2656|0,e);C2a(b+2880|0,e);C2a(b+3104|0,e);C2a(b+3328|0,e);C2a(b+3552|0,e);C2a(b+3776|0,e);C2a(b+4e3|0,e);C2a(b+4224|0,e);C2a(b+4448|0,e);C2a(b+4672|0,e);C2a(b+4896|0,e);C2a(b+5120|0,e);C2a(b+5344|0,e);C2a(b+5568|0,e);C2a(b+5792|0,e);C2a(b+6016|0,e);C2a(b+6240|0,e);C2a(b+6464|0,e);C2a(b+6688|0,e);C2a(b+6912|0,e);C2a(b+7136|0,e);C2a(b+7360|0,e);i=d;return}function MBa(a,b,d,f,h){a=a|0;b=b|0;d=d|0;f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=Im,Ma=0,Na=0,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=Im,Ta=0,Ua=Im,Va=0,Wa=0,Xa=Im,Ya=0,Za=0;j=i;i=i+144|0;l=j;m=j+132|0;n=j+128|0;o=ea(g[f>>2]);if(o==ea(3402823469999999843913219.0e14)){p=ea(g[a+608>>2]);q=ea(g[a+624>>2]);r=ea(p-q);s=ea(g[a+612>>2]);t=ea(g[a+628>>2]);u=ea(s-t);v=ea(g[a+616>>2]);w=ea(g[a+632>>2]);x=ea(v-w);y=ea(ea(p+q)+ea(0.0));q=ea(ea(s+t)+ea(0.0));t=ea(ea(v+w)+ea(0.0));z=a+28|0;A=c[z>>2]|0;if(!A){B=r;C=y;D=u;E=q;F=x;G=t}else{w=ea(8507058669999999534545717.0e13);v=ea(8507058669999999534545717.0e13);s=ea(8507058669999999534545717.0e13);p=ea(-8507058669999999534545717.0e13);H=ea(-8507058669999999534545717.0e13);I=ea(-8507058669999999534545717.0e13);J=0;do{K=ea(g[a+(J*24|0)+160>>2]);w=w<K?w:K;K=ea(g[a+(J*24|0)+164>>2]);v=v<K?v:K;K=ea(g[a+(J*24|0)+168>>2]);s=s<K?s:K;K=ea(g[a+(J*24|0)+172>>2]);p=p>K?p:K;K=ea(g[a+(J*24|0)+176>>2]);H=H>K?H:K;K=ea(g[a+(J*24|0)+180>>2]);I=I>K?I:K;J=J+1|0}while((J|0)!=(A|0));K=ea(p+ea(0.0));p=ea(H+ea(0.0));H=ea(I+ea(0.0));B=r<w?r:w;C=y>K?y:K;D=u<v?u:v;E=q>p?q:p;F=x<s?x:s;G=t>H?t:H}H=ea(g[b>>2]);t=ea(g[b+4>>2]);s=ea(g[b+8>>2]);x=ea(g[d>>2]);p=ea(g[d+4>>2]);q=ea(g[d+8>>2]);v=ea(ea(C-B)*ea(.5));u=ea(ea(E-D)*ea(.5));K=ea(ea(G-F)*ea(.5));y=ea(ea(ea(ea(ea(B+C)*ea(.5))*x)+ea(ea(ea(D+E)*ea(.5))*p))+ea(ea(ea(F+G)*ea(.5))*q));G=ea(T(ea(ea(K*K)+ea(ea(u*u)+ea(v*v)))));v=ea(ea(ea(H*x)+ea(t*p))+ea(s*q));q=ea(G*ea(2.0));s=ea(S(ea(ea(y-G)-v)));p=ea(S(ea(ea(G+y)-v)));v=ea(ea(q*ea(2.0))+(s<p?s:p));g[f>>2]=v;L=z;M=v}else{L=a+28|0;M=o}g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);o2a(l,b,d,M,m);m=c[L>>2]|0;a:do if(m){z=l+4|0;A=l+8|0;J=l+32|0;N=l+36|0;O=l+40|0;P=l+16|0;Q=l+20|0;R=l+24|0;U=l+80|0;V=l+84|0;W=l+64|0;X=l+68|0;Y=l+96|0;Z=l+100|0;_=l+112|0;$=l+116|0;aa=l+72|0;ba=l+88|0;ca=l+120|0;da=l+104|0;fa=m;ga=0;while(1){M=ea(g[a+(ga*24|0)+160>>2]);o=ea(g[a+(ga*24|0)+172>>2]);v=ea(M+o);p=ea(g[a+(ga*24|0)+164>>2]);s=ea(g[a+(ga*24|0)+176>>2]);q=ea(p+s);y=ea(g[a+(ga*24|0)+168>>2]);G=ea(g[a+(ga*24|0)+180>>2]);t=ea(v*ea(.5));v=ea(q*ea(.5));q=ea(ea(y+G)*ea(.5));x=ea(ea(o-M)*ea(.5));M=ea(ea(s-p)*ea(.5));p=ea(ea(G-y)*ea(.5));y=ea(t+x);G=ea(v+M);s=ea(t-x);o=ea(v-M);H=ea(g[l>>2]);u=ea(g[z>>2]);K=ea(H-t);t=ea(u-v);v=ea(ea(g[A>>2])-q);u=ea(g[J>>2]);H=ea(g[N>>2]);F=ea(g[O>>2]);E=ea(g[P>>2]);D=ea(g[Q>>2]);C=ea(ea(t*E)-ea(K*u));u=ea(ea(v*D)-ea(t*H));H=ea(ea(K*ea(g[R>>2]))-ea(v*F));F=ea(g[U>>2]);v=ea(g[V>>2]);K=ea(g[W>>2]);t=ea(ea(x*F)+ea(M*K));K=ea(ea(M*v)+ea(p*ea(g[X>>2])));v=ea(g[Y>>2]);M=ea(g[Z>>2]);F=ea(g[_>>2]);D=ea(g[$>>2]);E=ea(-C);B=ea(-u);w=ea(-H);if(t>=(C>E?C:E)&(F>=s&y>=v)&(K>=(u>B?u:B)&(D>=o&G>=M))?(M=ea(g[aa>>2]),G=ea(p*ea(g[ba>>2])),o=ea(x*M),M=ea(o+G),G=ea(g[ca>>2]),o=ea(q-p),x=ea(q+p),M>=(H>w?H:w)&(G>=o?x>=ea(g[da>>2]):0)):0){if(!(kn[c[c[h>>2]>>2]&511](h,f,a+(ga<<3)+32|0,1)|0)){ha=0;break}ia=c[L>>2]|0}else ia=fa;ga=ga+1|0;if(ga>>>0>=ia>>>0)break a;else fa=ia}i=j;return ha|0}while(0);if(!(c[a+584>>2]|0)){ha=1;i=j;return ha|0}x=ea(g[a+608>>2]);o=ea(g[a+612>>2]);G=ea(g[a+616>>2]);w=ea(g[a+624>>2]);H=ea(g[a+628>>2]);M=ea(g[a+632>>2]);p=ea(x+w);q=ea(o+H);D=ea(x-w);B=ea(o-H);u=ea(g[l>>2]);ia=l+4|0;K=ea(g[ia>>2]);L=l+8|0;v=ea(u-x);x=ea(K-o);o=ea(ea(g[L>>2])-G);m=l+32|0;K=ea(g[m>>2]);fa=l+36|0;u=ea(g[fa>>2]);ga=l+40|0;y=ea(g[ga>>2]);da=l+16|0;s=ea(g[da>>2]);ca=l+20|0;F=ea(g[ca>>2]);ba=l+24|0;E=ea(ea(x*s)-ea(v*K));K=ea(ea(o*F)-ea(x*u));u=ea(ea(v*ea(g[ba>>2]))-ea(o*y));aa=l+80|0;y=ea(g[aa>>2]);$=l+84|0;o=ea(g[$>>2]);_=l+64|0;v=ea(g[_>>2]);Z=l+68|0;x=ea(ea(w*y)+ea(H*v));v=ea(ea(H*o)+ea(M*ea(g[Z>>2])));Y=l+96|0;o=ea(g[Y>>2]);X=l+100|0;H=ea(g[X>>2]);W=l+112|0;y=ea(g[W>>2]);V=l+116|0;F=ea(g[V>>2]);s=ea(-E);C=ea(-K);t=ea(-u);if(!(x>=(E>s?E:s)&(y>=D&p>=o)&(v>=(K>C?K:C)&(F>=B&q>=H)))){ha=1;i=j;return ha|0}U=l+72|0;R=l+88|0;H=ea(g[U>>2]);q=ea(M*ea(g[R>>2]));B=ea(w*H);Q=l+120|0;P=l+104|0;H=ea(B+q);q=ea(g[Q>>2]);B=ea(G-M);w=ea(G+M);if(!(H>=(u>t?u:t)&(q>=B?w>=ea(g[P>>2]):0))){ha=1;i=j;return ha|0}O=c[a+592>>2]|0;w=ea(g[f>>2]);N=b+(O<<2)|0;B=ea(g[N>>2]);b=d+(O<<2)|0;q=ea(B+ea(w*ea(g[b>>2])));O=(g[k>>2]=B<q?B:q,c[k>>2]|0);J=(g[k>>2]=B>q?B:q,c[k>>2]|0);g[n>>2]=w;A=(c[d+4>>2]|0)>>>31<<1|(c[d>>2]|0)>>>31<<2|(c[d+8>>2]|0)>>>31;d=a+20|0;z=a+24|0;ja=l+108|0;ka=l+124|0;q=w;la=0;ma=e[a+(A<<1)+848>>1]|0;na=(J|0)<0?~J:J|-2147483648;J=(O|0)<0?~O:O|-2147483648;b:while(1){O=ma&7;ma=ma>>>3;if(((c[a+(O<<2)+640>>2]|0)!=0?(w=ea(g[a+(O<<5)+688>>2]),B=ea(g[a+(O<<5)+692>>2]),t=ea(g[a+(O<<5)+696>>2]),u=ea(g[a+(O<<5)+704>>2]),H=ea(g[a+(O<<5)+708>>2]),M=ea(g[a+(O<<5)+712>>2]),G=ea(w+u),F=ea(B+H),C=ea(w-u),K=ea(B-H),v=ea(g[l>>2]),o=ea(g[ia>>2]),p=ea(v-w),w=ea(o-B),B=ea(ea(g[L>>2])-t),o=ea(g[m>>2]),v=ea(g[fa>>2]),D=ea(g[ga>>2]),y=ea(g[da>>2]),s=ea(g[ca>>2]),E=ea(ea(w*y)-ea(p*o)),o=ea(ea(B*s)-ea(w*v)),v=ea(ea(p*ea(g[ba>>2]))-ea(B*D)),D=ea(g[aa>>2]),B=ea(g[$>>2]),p=ea(g[_>>2]),w=ea(ea(u*D)+ea(H*p)),p=ea(ea(H*B)+ea(M*ea(g[Z>>2]))),B=ea(g[Y>>2]),H=ea(g[X>>2]),D=ea(g[W>>2]),s=ea(g[V>>2]),y=ea(-E),x=ea(-o),r=ea(-v),w>=(E>y?E:y)&(D>=C&G>=B)&(p>=(o>x?o:x)&(s>=K&F>=H))):0)?(H=ea(g[U>>2]),F=ea(M*ea(g[R>>2])),K=ea(u*H),H=ea(K+F),F=ea(g[Q>>2]),K=ea(t-M),u=ea(t+M),H>=(v>r?v:r)&(F>=K?u>=ea(g[P>>2]):0)):0){oa=a+(O<<2)+660|0;u=q;pa=0;qa=e[a+(O*224|0)+(A<<1)+1072>>1]|0;ra=na;sa=J;while(1){ta=qa&7;qa=qa>>>3;if(((c[a+(O*224|0)+(ta<<2)+864>>2]|0)!=0?(K=ea(g[a+(O*224|0)+(ta<<5)+912>>2]),F=ea(g[a+(O*224|0)+(ta<<5)+916>>2]),r=ea(g[a+(O*224|0)+(ta<<5)+920>>2]),v=ea(g[a+(O*224|0)+(ta<<5)+928>>2]),H=ea(g[a+(O*224|0)+(ta<<5)+932>>2]),M=ea(g[a+(O*224|0)+(ta<<5)+936>>2]),t=ea(K+v),s=ea(F+H),x=ea(K-v),o=ea(F-H),p=ea(g[l>>2]),B=ea(g[ia>>2]),G=ea(p-K),K=ea(B-F),F=ea(ea(g[L>>2])-r),B=ea(g[m>>2]),p=ea(g[fa>>2]),C=ea(g[ga>>2]),D=ea(g[da>>2]),y=ea(g[ca>>2]),E=ea(ea(K*D)-ea(G*B)),B=ea(ea(F*y)-ea(K*p)),p=ea(ea(G*ea(g[ba>>2]))-ea(F*C)),C=ea(g[aa>>2]),F=ea(g[$>>2]),G=ea(g[_>>2]),K=ea(ea(v*C)+ea(H*G)),G=ea(ea(H*F)+ea(M*ea(g[Z>>2]))),F=ea(g[Y>>2]),H=ea(g[X>>2]),C=ea(g[W>>2]),y=ea(g[V>>2]),D=ea(-E),w=ea(-B),I=ea(-p),K>=(E>D?E:D)&(C>=x&t>=F)&(G>=(B>w?B:w)&(y>=o&s>=H))):0)?(H=ea(g[U>>2]),s=ea(M*ea(g[R>>2])),o=ea(v*H),H=ea(o+s),s=ea(g[Q>>2]),o=ea(r-M),v=ea(r+M),H>=(p>I?p:I)&(s>=o?v>=ea(g[P>>2]):0)):0){ua=(c[a+(O*224|0)+(ta<<2)+884>>2]|0)+(c[oa>>2]|0)|0;v=u;va=0;wa=e[a+(O*1120|0)+(ta*224|0)+(A<<1)+2192>>1]|0;xa=ra;ya=sa;while(1){za=wa&7;wa=wa>>>3;Aa=c[a+(O*1120|0)+(ta*224|0)+(za<<2)+1984>>2]|0;c:do if(((Aa|0)!=0?(o=ea(g[a+(O*1120|0)+(ta*224|0)+(za<<5)+2032>>2]),s=ea(g[a+(O*1120|0)+(ta*224|0)+(za<<5)+2036>>2]),I=ea(g[a+(O*1120|0)+(ta*224|0)+(za<<5)+2040>>2]),p=ea(g[a+(O*1120|0)+(ta*224|0)+(za<<5)+2048>>2]),H=ea(g[a+(O*1120|0)+(ta*224|0)+(za<<5)+2052>>2]),M=ea(g[a+(O*1120|0)+(ta*224|0)+(za<<5)+2056>>2]),r=ea(o+p),y=ea(s+H),w=ea(o-p),B=ea(s-H),G=ea(g[l>>2]),F=ea(g[ia>>2]),t=ea(G-o),o=ea(F-s),s=ea(ea(g[L>>2])-I),F=ea(g[m>>2]),G=ea(g[fa>>2]),x=ea(g[ga>>2]),C=ea(g[da>>2]),D=ea(g[ca>>2]),E=ea(ea(o*C)-ea(t*F)),F=ea(ea(s*D)-ea(o*G)),G=ea(ea(t*ea(g[ba>>2]))-ea(s*x)),x=ea(g[aa>>2]),s=ea(g[$>>2]),t=ea(g[_>>2]),o=ea(ea(p*x)+ea(H*t)),t=ea(ea(H*s)+ea(M*ea(g[Z>>2]))),s=ea(g[Y>>2]),H=ea(g[X>>2]),x=ea(g[W>>2]),D=ea(g[V>>2]),C=ea(-E),K=ea(-F),Ba=ea(-G),o>=(E>C?E:C)&(x>=w&r>=s)&(t>=(F>K?F:K)&(D>=B&y>=H))):0)?(H=ea(g[U>>2]),y=ea(M*ea(g[R>>2])),B=ea(p*H),H=ea(B+y),y=ea(g[Q>>2]),B=ea(I-M),p=ea(I+M),H>=(G>Ba?G:Ba)&(y>=B?p>=ea(g[P>>2]):0)):0){Ca=ua+(c[a+(O*1120|0)+(ta*224|0)+(za<<2)+2004>>2]|0)|0;Da=c[d>>2]|0;Ea=Da+(Ca+Aa<<5)|0;p=v;Fa=Da+(Ca<<5)|0;Da=(c[z>>2]|0)+(Ca<<3)|0;Ca=xa;Ga=ya;while(1){B=p;Ha=Fa;Ia=Da;d:while(1){Ja=Ha;Ha=Ha+32|0;Ka=Ia;Ia=Ia+8|0;do if((c[Ja+28>>2]|0)>>>0>=Ga>>>0){if((c[Ja+12>>2]|0)>>>0>Ca>>>0){La=B;Ma=Ca;Na=Ga;break c}y=ea(g[Ja>>2]);Ba=ea(g[Ja+4>>2]);G=ea(g[Ja+8>>2]);H=ea(g[Ja+16>>2]);M=ea(g[Ja+20>>2]);I=ea(g[Ja+24>>2]);D=ea(y+H);K=ea(Ba+M);F=ea(y-H);t=ea(Ba-M);s=ea(g[l>>2]);r=ea(g[ia>>2]);w=ea(s-y);y=ea(r-Ba);Ba=ea(ea(g[L>>2])-G);r=ea(g[m>>2]);s=ea(g[fa>>2]);x=ea(g[ga>>2]);C=ea(g[da>>2]);E=ea(g[ca>>2]);o=ea(ea(y*C)-ea(w*r));r=ea(ea(Ba*E)-ea(y*s));s=ea(ea(w*ea(g[ba>>2]))-ea(Ba*x));x=ea(g[aa>>2]);Ba=ea(g[$>>2]);w=ea(g[_>>2]);y=ea(ea(H*x)+ea(M*w));w=ea(ea(M*Ba)+ea(I*ea(g[Z>>2])));Ba=ea(g[Y>>2]);M=ea(g[X>>2]);x=ea(g[W>>2]);E=ea(g[V>>2]);C=ea(-o);Oa=ea(-r);Pa=ea(-s);if(!(y>=(o>C?o:C)&(x>=F&D>=Ba)&(w>=(r>Oa?r:Oa)&(E>=t&K>=M)))){Qa=B;break}M=ea(g[U>>2]);K=ea(I*ea(g[R>>2]));t=ea(H*M);M=ea(t+K);K=ea(g[Q>>2]);t=ea(G-I);H=ea(G+I);if(!(M>=(s>Pa?s:Pa)&(K>=t?H>=ea(g[P>>2]):0))){Qa=B;break}if(!(kn[c[c[h>>2]>>2]&511](h,n,Ka,1)|0)){ha=0;Ra=43;break b}Sa=ea(g[n>>2]);if(Sa<B)break d;else Qa=Sa}else Qa=B;while(0);if((Ha|0)==(Ea|0)){La=Qa;Ma=Ca;Na=Ga;break c}else B=Qa}B=ea(g[N>>2]);H=ea(B+ea(Sa*ea(g[b>>2])));Ka=(g[k>>2]=B<H?B:H,c[k>>2]|0);Ja=(g[k>>2]=B>H?B:H,c[k>>2]|0);H=ea(g[da>>2]);B=ea(g[ca>>2]);t=ea(g[ba>>2]);K=ea(g[l>>2]);Pa=ea(g[ia>>2]);s=ea(g[L>>2]);M=ea(ea(Sa*H)+K);H=ea(ea(Sa*B)+Pa);B=ea(ea(Sa*t)+s);g[Y>>2]=K<M?K:M;g[X>>2]=Pa<H?Pa:H;g[P>>2]=s<B?s:B;g[ja>>2]=ea(0.0);g[W>>2]=K>M?K:M;g[V>>2]=Pa>H?Pa:H;g[Q>>2]=s>B?s:B;g[ka>>2]=ea(0.0);Ta=(Ka|0)<0?~Ka:Ka|-2147483648;Ka=(Ja|0)<0?~Ja:Ja|-2147483648;if((Ha|0)==(Ea|0)){La=Sa;Ma=Ka;Na=Ta;break}else{p=Sa;Fa=Ha;Da=Ia;Ca=Ka;Ga=Ta}}}else{La=v;Ma=xa;Na=ya}while(0);va=va+1|0;if(va>>>0>=5){Ua=La;Va=Ma;Wa=Na;break}else{v=La;xa=Ma;ya=Na}}}else{Ua=u;Va=ra;Wa=sa}pa=pa+1|0;if(pa>>>0>=5){Xa=Ua;Ya=Va;Za=Wa;break}else{u=Ua;ra=Va;sa=Wa}}}else{Xa=q;Ya=na;Za=J}la=la+1|0;if(la>>>0>=5)break;else{q=Xa;na=Ya;J=Za}}if((Ra|0)==43){i=j;return ha|0}g[f>>2]=Xa;ha=1;i=j;return ha|0}function NBa(a,b,d,f,h){a=a|0;b=b|0;d=d|0;f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=Im,U=0,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=0,Ua=0,Va=Im,Wa=0,Xa=Im,Ya=0,Za=Im,_a=0,$a=0,ab=Im,bb=0,cb=0;j=i;i=i+176|0;l=j;m=j+156|0;n=j+152|0;o=j+140|0;p=j+128|0;q=ea(g[b+132>>2]);r=ea(g[b+120>>2]);s=ea(q-r);t=ea(g[b+136>>2]);u=ea(g[b+124>>2]);v=ea(t-u);w=ea(g[b+140>>2]);x=ea(g[b+128>>2]);y=ea(s*ea(.5));s=ea(v*ea(.5));v=ea(ea(w-x)*ea(.5));z=ea(ea(q+r)*ea(.5));r=ea(ea(t+u)*ea(.5));u=ea(ea(w+x)*ea(.5));g[o>>2]=z;g[o+4>>2]=r;g[o+8>>2]=u;g[p>>2]=y;g[p+4>>2]=s;g[p+8>>2]=v;x=ea(g[f>>2]);if(x==ea(3402823469999999843913219.0e14)){w=ea(g[a+608>>2]);t=ea(g[a+624>>2]);q=ea(w-t);A=ea(g[a+612>>2]);B=ea(g[a+628>>2]);C=ea(A-B);D=ea(g[a+616>>2]);E=ea(g[a+632>>2]);F=ea(q-y);q=ea(C-s);C=ea(ea(D-E)-v);G=ea(ea(w+t)+y);t=ea(ea(A+B)+s);B=ea(ea(D+E)+v);b=a+28|0;H=c[b>>2]|0;if(!H){I=F;J=G;K=q;L=t;M=C;N=B}else{E=ea(8507058669999999534545717.0e13);D=ea(8507058669999999534545717.0e13);A=ea(8507058669999999534545717.0e13);w=ea(-8507058669999999534545717.0e13);O=ea(-8507058669999999534545717.0e13);P=ea(-8507058669999999534545717.0e13);Q=0;do{R=ea(g[a+(Q*24|0)+160>>2]);E=E<R?E:R;R=ea(g[a+(Q*24|0)+164>>2]);D=D<R?D:R;R=ea(g[a+(Q*24|0)+168>>2]);A=A<R?A:R;R=ea(g[a+(Q*24|0)+172>>2]);w=w>R?w:R;R=ea(g[a+(Q*24|0)+176>>2]);O=O>R?O:R;R=ea(g[a+(Q*24|0)+180>>2]);P=P>R?P:R;Q=Q+1|0}while((Q|0)!=(H|0));R=ea(E-y);E=ea(D-s);D=ea(A-v);A=ea(y+w);w=ea(s+O);O=ea(v+P);I=F<R?F:R;J=G>A?G:A;K=q<E?q:E;L=t>w?t:w;M=C<D?C:D;N=B>O?B:O}O=ea(g[d>>2]);B=ea(g[d+4>>2]);D=ea(g[d+8>>2]);C=ea(ea(J-I)*ea(.5));w=ea(ea(L-K)*ea(.5));t=ea(ea(N-M)*ea(.5));E=ea(ea(ea(ea(ea(I+J)*ea(.5))*O)+ea(ea(ea(K+L)*ea(.5))*B))+ea(ea(ea(M+N)*ea(.5))*D));N=ea(T(ea(ea(t*t)+ea(ea(w*w)+ea(C*C)))));C=ea(ea(ea(z*O)+ea(r*B))+ea(u*D));D=ea(N*ea(2.0));u=ea(S(ea(ea(E-N)-C)));B=ea(S(ea(ea(N+E)-C)));C=ea(ea(D*ea(2.0))+(u<B?u:B));g[f>>2]=C;U=b;V=C}else{U=a+28|0;V=x}g[m>>2]=y;g[m+4>>2]=s;g[m+8>>2]=v;o2a(l,o,d,V,m);m=c[U>>2]|0;a:do if(m){b=l+48|0;H=l+52|0;Q=l+56|0;W=l+4|0;X=l+8|0;Y=l+32|0;Z=l+36|0;_=l+40|0;$=l+16|0;aa=l+20|0;ba=l+24|0;ca=l+80|0;da=l+84|0;fa=l+64|0;ga=l+68|0;ha=l+96|0;ia=l+100|0;ja=l+112|0;ka=l+116|0;la=l+72|0;ma=l+88|0;na=l+120|0;oa=l+104|0;pa=m;qa=0;while(1){V=ea(g[a+(qa*24|0)+160>>2]);v=ea(g[a+(qa*24|0)+172>>2]);s=ea(V+v);y=ea(g[a+(qa*24|0)+164>>2]);x=ea(g[a+(qa*24|0)+176>>2]);C=ea(y+x);B=ea(g[a+(qa*24|0)+168>>2]);u=ea(g[a+(qa*24|0)+180>>2]);D=ea(s*ea(.5));s=ea(C*ea(.5));C=ea(ea(B+u)*ea(.5));E=ea(ea(v-V)*ea(.5));V=ea(ea(x-y)*ea(.5));y=ea(ea(u-B)*ea(.5));B=ea(g[b>>2]);u=ea(g[H>>2]);x=ea(E+B);B=ea(V+u);u=ea(y+ea(g[Q>>2]));y=ea(D+x);V=ea(s+B);E=ea(D-x);v=ea(s-B);N=ea(g[l>>2]);r=ea(g[W>>2]);O=ea(N-D);D=ea(r-s);s=ea(ea(g[X>>2])-C);r=ea(g[Y>>2]);N=ea(g[Z>>2]);z=ea(g[_>>2]);w=ea(g[$>>2]);t=ea(g[aa>>2]);M=ea(ea(D*w)-ea(O*r));r=ea(ea(s*t)-ea(D*N));N=ea(ea(O*ea(g[ba>>2]))-ea(s*z));z=ea(g[ca>>2]);s=ea(g[da>>2]);O=ea(g[fa>>2]);D=ea(ea(x*z)+ea(B*O));O=ea(ea(B*s)+ea(u*ea(g[ga>>2])));s=ea(g[ha>>2]);B=ea(g[ia>>2]);z=ea(g[ja>>2]);t=ea(g[ka>>2]);w=ea(-M);L=ea(-r);K=ea(-N);if(D>=(M>w?M:w)&(z>=E&y>=s)&(O>=(r>L?r:L)&(t>=v&V>=B))?(B=ea(g[la>>2]),V=ea(u*ea(g[ma>>2])),v=ea(x*B),B=ea(v+V),V=ea(g[na>>2]),v=ea(C-u),x=ea(C+u),B>=(N>K?N:K)&(V>=v?x>=ea(g[oa>>2]):0)):0){if(!(kn[c[c[h>>2]>>2]&511](h,f,a+(qa<<3)+32|0,1)|0)){ra=0;break}sa=c[U>>2]|0}else sa=pa;qa=qa+1|0;if(qa>>>0>=sa>>>0)break a;else pa=sa}i=j;return ra|0}while(0);if(!(c[a+584>>2]|0)){ra=1;i=j;return ra|0}x=ea(g[a+608>>2]);v=ea(g[a+612>>2]);V=ea(g[a+616>>2]);K=ea(g[a+624>>2]);N=ea(g[a+628>>2]);B=ea(g[a+632>>2]);sa=l+48|0;u=ea(g[sa>>2]);U=l+52|0;C=ea(g[U>>2]);m=l+56|0;t=ea(K+u);u=ea(N+C);C=ea(B+ea(g[m>>2]));B=ea(x+t);N=ea(v+u);K=ea(x-t);L=ea(v-u);r=ea(g[l>>2]);pa=l+4|0;O=ea(g[pa>>2]);qa=l+8|0;s=ea(r-x);x=ea(O-v);v=ea(ea(g[qa>>2])-V);oa=l+32|0;O=ea(g[oa>>2]);na=l+36|0;r=ea(g[na>>2]);ma=l+40|0;y=ea(g[ma>>2]);la=l+16|0;E=ea(g[la>>2]);ka=l+20|0;z=ea(g[ka>>2]);ja=l+24|0;w=ea(ea(x*E)-ea(s*O));O=ea(ea(v*z)-ea(x*r));r=ea(ea(s*ea(g[ja>>2]))-ea(v*y));ia=l+80|0;y=ea(g[ia>>2]);ha=l+84|0;v=ea(g[ha>>2]);ga=l+64|0;s=ea(g[ga>>2]);fa=l+68|0;x=ea(ea(t*y)+ea(u*s));s=ea(ea(u*v)+ea(C*ea(g[fa>>2])));da=l+96|0;v=ea(g[da>>2]);ca=l+100|0;u=ea(g[ca>>2]);ba=l+112|0;y=ea(g[ba>>2]);aa=l+116|0;z=ea(g[aa>>2]);E=ea(-w);M=ea(-O);D=ea(-r);if(!(x>=(w>E?w:E)&(y>=K&B>=v)&(s>=(O>M?O:M)&(z>=L&N>=u)))){ra=1;i=j;return ra|0}$=l+72|0;_=l+88|0;u=ea(g[$>>2]);N=ea(C*ea(g[_>>2]));L=ea(t*u);Z=l+120|0;Y=l+104|0;u=ea(L+N);N=ea(g[Z>>2]);L=ea(V-C);t=ea(V+C);if(!(u>=(r>D?r:D)&(N>=L?t>=ea(g[Y>>2]):0))){ra=1;i=j;return ra|0}X=c[a+592>>2]|0;t=ea(g[f>>2]);L=ea(g[p+(X<<2)>>2]);N=ea(g[o+(X<<2)>>2]);o=d+(X<<2)|0;D=ea(N+ea(t*ea(g[o>>2])));r=ea((N<D?N:D)-L);X=(g[k>>2]=r,c[k>>2]|0);r=ea(L+(N>D?N:D));p=(g[k>>2]=r,c[k>>2]|0);g[n>>2]=t;W=(c[d+4>>2]|0)>>>31<<1|(c[d>>2]|0)>>>31<<2|(c[d+8>>2]|0)>>>31;d=a+20|0;Q=a+24|0;H=l+108|0;b=l+124|0;r=t;ta=0;ua=e[a+(W<<1)+848>>1]|0;va=(p|0)<0?~p:p|-2147483648;p=(X|0)<0?~X:X|-2147483648;b:while(1){X=ua&7;ua=ua>>>3;if(((c[a+(X<<2)+640>>2]|0)!=0?(t=ea(g[a+(X<<5)+688>>2]),D=ea(g[a+(X<<5)+692>>2]),u=ea(g[a+(X<<5)+696>>2]),C=ea(g[a+(X<<5)+704>>2]),V=ea(g[a+(X<<5)+708>>2]),z=ea(g[a+(X<<5)+712>>2]),M=ea(g[sa>>2]),O=ea(g[U>>2]),s=ea(C+M),M=ea(V+O),O=ea(z+ea(g[m>>2])),z=ea(t+s),V=ea(D+M),C=ea(t-s),v=ea(D-M),B=ea(g[l>>2]),K=ea(g[pa>>2]),y=ea(B-t),t=ea(K-D),D=ea(ea(g[qa>>2])-u),K=ea(g[oa>>2]),B=ea(g[na>>2]),E=ea(g[ma>>2]),w=ea(g[la>>2]),x=ea(g[ka>>2]),J=ea(ea(t*w)-ea(y*K)),K=ea(ea(D*x)-ea(t*B)),B=ea(ea(y*ea(g[ja>>2]))-ea(D*E)),E=ea(g[ia>>2]),D=ea(g[ha>>2]),y=ea(g[ga>>2]),t=ea(ea(s*E)+ea(M*y)),y=ea(ea(M*D)+ea(O*ea(g[fa>>2]))),D=ea(g[da>>2]),M=ea(g[ca>>2]),E=ea(g[ba>>2]),x=ea(g[aa>>2]),w=ea(-J),I=ea(-K),q=ea(-B),t>=(J>w?J:w)&(E>=C&z>=D)&(y>=(K>I?K:I)&(x>=v&V>=M))):0)?(M=ea(g[$>>2]),V=ea(O*ea(g[_>>2])),v=ea(s*M),M=ea(v+V),V=ea(g[Z>>2]),v=ea(u-O),s=ea(u+O),M>=(B>q?B:q)&(V>=v?s>=ea(g[Y>>2]):0)):0){wa=a+(X<<2)+660|0;s=r;xa=0;ya=e[a+(X*224|0)+(W<<1)+1072>>1]|0;za=va;Aa=p;while(1){Ba=ya&7;ya=ya>>>3;if(((c[a+(X*224|0)+(Ba<<2)+864>>2]|0)!=0?(v=ea(g[a+(X*224|0)+(Ba<<5)+912>>2]),V=ea(g[a+(X*224|0)+(Ba<<5)+916>>2]),q=ea(g[a+(X*224|0)+(Ba<<5)+920>>2]),B=ea(g[a+(X*224|0)+(Ba<<5)+928>>2]),M=ea(g[a+(X*224|0)+(Ba<<5)+932>>2]),O=ea(g[a+(X*224|0)+(Ba<<5)+936>>2]),u=ea(g[sa>>2]),x=ea(g[U>>2]),I=ea(B+u),u=ea(M+x),x=ea(O+ea(g[m>>2])),O=ea(v+I),M=ea(V+u),B=ea(v-I),K=ea(V-u),y=ea(g[l>>2]),D=ea(g[pa>>2]),z=ea(y-v),v=ea(D-V),V=ea(ea(g[qa>>2])-q),D=ea(g[oa>>2]),y=ea(g[na>>2]),C=ea(g[ma>>2]),E=ea(g[la>>2]),w=ea(g[ka>>2]),J=ea(ea(v*E)-ea(z*D)),D=ea(ea(V*w)-ea(v*y)),y=ea(ea(z*ea(g[ja>>2]))-ea(V*C)),C=ea(g[ia>>2]),V=ea(g[ha>>2]),z=ea(g[ga>>2]),v=ea(ea(I*C)+ea(u*z)),z=ea(ea(u*V)+ea(x*ea(g[fa>>2]))),V=ea(g[da>>2]),u=ea(g[ca>>2]),C=ea(g[ba>>2]),w=ea(g[aa>>2]),E=ea(-J),t=ea(-D),A=ea(-y),v>=(J>E?J:E)&(C>=B&O>=V)&(z>=(D>t?D:t)&(w>=K&M>=u))):0)?(u=ea(g[$>>2]),M=ea(x*ea(g[_>>2])),K=ea(I*u),u=ea(K+M),M=ea(g[Z>>2]),K=ea(q-x),I=ea(q+x),u>=(y>A?y:A)&(M>=K?I>=ea(g[Y>>2]):0)):0){Ca=(c[a+(X*224|0)+(Ba<<2)+884>>2]|0)+(c[wa>>2]|0)|0;I=s;Da=0;Ea=e[a+(X*1120|0)+(Ba*224|0)+(W<<1)+2192>>1]|0;Fa=za;Ga=Aa;while(1){Ha=Ea&7;Ea=Ea>>>3;Ia=c[a+(X*1120|0)+(Ba*224|0)+(Ha<<2)+1984>>2]|0;c:do if(((Ia|0)!=0?(K=ea(g[a+(X*1120|0)+(Ba*224|0)+(Ha<<5)+2032>>2]),M=ea(g[a+(X*1120|0)+(Ba*224|0)+(Ha<<5)+2036>>2]),A=ea(g[a+(X*1120|0)+(Ba*224|0)+(Ha<<5)+2040>>2]),y=ea(g[a+(X*1120|0)+(Ba*224|0)+(Ha<<5)+2048>>2]),u=ea(g[a+(X*1120|0)+(Ba*224|0)+(Ha<<5)+2052>>2]),x=ea(g[a+(X*1120|0)+(Ba*224|0)+(Ha<<5)+2056>>2]),q=ea(g[sa>>2]),w=ea(g[U>>2]),t=ea(y+q),q=ea(u+w),w=ea(x+ea(g[m>>2])),x=ea(K+t),u=ea(M+q),y=ea(K-t),D=ea(M-q),z=ea(g[l>>2]),V=ea(g[pa>>2]),O=ea(z-K),K=ea(V-M),M=ea(ea(g[qa>>2])-A),V=ea(g[oa>>2]),z=ea(g[na>>2]),B=ea(g[ma>>2]),C=ea(g[la>>2]),E=ea(g[ka>>2]),J=ea(ea(K*C)-ea(O*V)),V=ea(ea(M*E)-ea(K*z)),z=ea(ea(O*ea(g[ja>>2]))-ea(M*B)),B=ea(g[ia>>2]),M=ea(g[ha>>2]),O=ea(g[ga>>2]),K=ea(ea(t*B)+ea(q*O)),O=ea(ea(q*M)+ea(w*ea(g[fa>>2]))),M=ea(g[da>>2]),q=ea(g[ca>>2]),B=ea(g[ba>>2]),E=ea(g[aa>>2]),C=ea(-J),v=ea(-V),G=ea(-z),K>=(J>C?J:C)&(B>=y&x>=M)&(O>=(V>v?V:v)&(E>=D&u>=q))):0)?(q=ea(g[$>>2]),u=ea(w*ea(g[_>>2])),D=ea(t*q),q=ea(D+u),u=ea(g[Z>>2]),D=ea(A-w),t=ea(A+w),q>=(z>G?z:G)&(u>=D?t>=ea(g[Y>>2]):0)):0){Ja=Ca+(c[a+(X*1120|0)+(Ba*224|0)+(Ha<<2)+2004>>2]|0)|0;Ka=c[d>>2]|0;La=Ka+(Ja+Ia<<5)|0;t=I;Ma=Ka+(Ja<<5)|0;Ka=(c[Q>>2]|0)+(Ja<<3)|0;Ja=Fa;Na=Ga;while(1){D=t;Oa=Ma;Pa=Ka;d:while(1){Qa=Oa;Oa=Oa+32|0;Ra=Pa;Pa=Pa+8|0;do if((c[Qa+28>>2]|0)>>>0>=Na>>>0){if((c[Qa+12>>2]|0)>>>0>Ja>>>0){Sa=D;Ta=Ja;Ua=Na;break c}u=ea(g[Qa>>2]);G=ea(g[Qa+4>>2]);z=ea(g[Qa+8>>2]);q=ea(g[Qa+16>>2]);w=ea(g[Qa+20>>2]);A=ea(g[Qa+24>>2]);E=ea(g[sa>>2]);v=ea(g[U>>2]);V=ea(q+E);E=ea(w+v);v=ea(A+ea(g[m>>2]));A=ea(u+V);w=ea(G+E);q=ea(u-V);O=ea(G-E);M=ea(g[l>>2]);x=ea(g[pa>>2]);y=ea(M-u);u=ea(x-G);G=ea(ea(g[qa>>2])-z);x=ea(g[oa>>2]);M=ea(g[na>>2]);B=ea(g[ma>>2]);C=ea(g[la>>2]);J=ea(g[ka>>2]);K=ea(ea(u*C)-ea(y*x));x=ea(ea(G*J)-ea(u*M));M=ea(ea(y*ea(g[ja>>2]))-ea(G*B));B=ea(g[ia>>2]);G=ea(g[ha>>2]);y=ea(g[ga>>2]);u=ea(ea(V*B)+ea(E*y));y=ea(ea(E*G)+ea(v*ea(g[fa>>2])));G=ea(g[da>>2]);E=ea(g[ca>>2]);B=ea(g[ba>>2]);J=ea(g[aa>>2]);C=ea(-K);R=ea(-x);F=ea(-M);if(!(u>=(K>C?K:C)&(B>=q&A>=G)&(y>=(x>R?x:R)&(J>=O&w>=E)))){Va=D;break}E=ea(g[$>>2]);w=ea(v*ea(g[_>>2]));O=ea(V*E);E=ea(O+w);w=ea(g[Z>>2]);O=ea(z-v);V=ea(z+v);if(!(E>=(M>F?M:F)&(w>=O?V>=ea(g[Y>>2]):0))){Va=D;break}if(!(kn[c[c[h>>2]>>2]&511](h,n,Ra,1)|0)){ra=0;Wa=43;break b}Xa=ea(g[n>>2]);if(Xa<D)break d;else Va=Xa}else Va=D;while(0);if((Oa|0)==(La|0)){Sa=Va;Ta=Ja;Ua=Na;break c}else D=Va}D=ea(N+ea(Xa*ea(g[o>>2])));V=ea((N<D?N:D)-L);Ra=(g[k>>2]=V,c[k>>2]|0);V=ea(L+(N>D?N:D));Qa=(g[k>>2]=V,c[k>>2]|0);V=ea(g[la>>2]);D=ea(g[ka>>2]);O=ea(g[ja>>2]);w=ea(g[l>>2]);F=ea(g[pa>>2]);M=ea(g[qa>>2]);E=ea(ea(Xa*V)+w);V=ea(ea(Xa*D)+F);D=ea(ea(Xa*O)+M);g[da>>2]=w<E?w:E;g[ca>>2]=F<V?F:V;g[Y>>2]=M<D?M:D;g[H>>2]=ea(0.0);g[ba>>2]=w>E?w:E;g[aa>>2]=F>V?F:V;g[Z>>2]=M>D?M:D;g[b>>2]=ea(0.0);Ya=(Ra|0)<0?~Ra:Ra|-2147483648;Ra=(Qa|0)<0?~Qa:Qa|-2147483648;if((Oa|0)==(La|0)){Sa=Xa;Ta=Ra;Ua=Ya;break}else{t=Xa;Ma=Oa;Ka=Pa;Ja=Ra;Na=Ya}}}else{Sa=I;Ta=Fa;Ua=Ga}while(0);Da=Da+1|0;if(Da>>>0>=5){Za=Sa;_a=Ta;$a=Ua;break}else{I=Sa;Fa=Ta;Ga=Ua}}}else{Za=s;_a=za;$a=Aa}xa=xa+1|0;if(xa>>>0>=5){ab=Za;bb=_a;cb=$a;break}else{s=Za;za=_a;Aa=$a}}}else{ab=r;bb=va;cb=p}ta=ta+1|0;if(ta>>>0>=5)break;else{r=ab;va=bb;p=cb}}if((Wa|0)==43){i=j;return ra|0}g[f>>2]=ab;ra=1;i=j;return ra|0}function OBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=0;e=i;i=i+528|0;f=e+320|0;h=e+504|0;j=e+480|0;k=e+176|0;l=e+464|0;m=e;n=e+32|0;o=e+516|0;p=c[c[b+144>>2]>>2]|0;if((p|0)==4){q=ea(ea(g[b+4>>2])*ea(1.00999999));r=ea(ea(g[b+8>>2])*ea(1.00999999));s=ea(ea(g[b+12>>2])*ea(1.00999999));g[o>>2]=q;g[o+4>>2]=r;g[o+8>>2]=s;D2a(n,b+84|0,b+72|0,o);t=E2a(0,a,n,d,b+120|0)|0;i=e;return t|0}else if(!p){s=ea(g[b+148>>2]);r=ea(g[b+152>>2]);q=ea(g[b+156>>2]);g[m>>2]=s;g[m+4>>2]=r;g[m+8>>2]=q;g[m+12>>2]=ea(0.0);q=ea(g[b+160>>2]);g[m+16>>2]=ea(q*q);t=G2a(0,a,m,d,b+120|0)|0;i=e;return t|0}else if((p|0)==2){q=ea(ea(g[b+4>>2])*ea(1.00999999));r=ea(ea(g[b+8>>2])*ea(1.00999999));s=ea(ea(g[b+12>>2])*ea(1.00999999));g[l>>2]=q;g[l+4>>2]=r;g[l+8>>2]=s;D2a(k,b+84|0,b+72|0,l);t=E2a(0,a,k,d,b+120|0)|0;i=e;return t|0}else if((p|0)==3){p=b+120|0;if(ea(S(ea(g[b+68>>2])))<ea(.999998986)){s=ea(ea(g[b+4>>2])*ea(1.00999999));r=ea(ea(g[b+8>>2])*ea(1.00999999));q=ea(ea(g[b+12>>2])*ea(1.00999999));g[h>>2]=s;g[h+4>>2]=r;g[h+8>>2]=q;D2a(f,b+84|0,b+72|0,h);t=E2a(0,a,f,d,p)|0;i=e;return t|0}else{g[j>>2]=ea(g[p>>2]);g[j+4>>2]=ea(g[b+124>>2]);g[j+8>>2]=ea(g[b+128>>2]);g[j+12>>2]=ea(g[b+132>>2]);g[j+16>>2]=ea(g[b+136>>2]);g[j+20>>2]=ea(g[b+140>>2]);t=F2a(0,a,j,d,p)|0;i=e;return t|0}}else{t=1;i=e;return t|0}return 0}function PBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=Im,m=0,n=0,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0;d=i;e=a+28|0;f=b+4|0;h=b+8|0;if(c[e>>2]|0){j=0;do{l=ea(g[b>>2]);m=a+(j*24|0)+160|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+(j*24|0)+164|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+(j*24|0)+168|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[b>>2]);m=a+(j*24|0)+172|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+(j*24|0)+176|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+(j*24|0)+180|0;g[m>>2]=ea(ea(g[m>>2])-l);j=j+1|0}while(j>>>0<(c[e>>2]|0)>>>0)}e=c[a>>2]|0;l=ea(g[b>>2]);j=a+608|0;g[j>>2]=ea(ea(g[j>>2])-l);l=ea(g[f>>2]);m=a+612|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+616|0;g[m>>2]=ea(ea(g[m>>2])-l);m=a+592|0;n=c[m>>2]|0;l=ea(g[j+(n<<2)>>2]);o=ea(g[a+624+(n<<2)>>2]);p=ea(l-o);j=(g[k>>2]=p,c[k>>2]|0);p=ea(l+o);q=(g[k>>2]=p,c[k>>2]|0);c[a+620>>2]=(j|0)<0?~j:j|-2147483648;c[a+636>>2]=(q|0)<0?~q:q|-2147483648;if(e){q=c[a+8>>2]|0;j=0;do{p=ea(g[b>>2]);r=q+(j*24|0)|0;g[r>>2]=ea(ea(g[r>>2])-p);p=ea(g[f>>2]);r=q+(j*24|0)+4|0;g[r>>2]=ea(ea(g[r>>2])-p);p=ea(g[h>>2]);r=q+(j*24|0)+8|0;g[r>>2]=ea(ea(g[r>>2])-p);p=ea(g[b>>2]);r=q+(j*24|0)+12|0;g[r>>2]=ea(ea(g[r>>2])-p);p=ea(g[f>>2]);r=q+(j*24|0)+16|0;g[r>>2]=ea(ea(g[r>>2])-p);p=ea(g[h>>2]);r=q+(j*24|0)+20|0;g[r>>2]=ea(ea(g[r>>2])-p);j=j+1|0}while((j|0)!=(e|0))}e=a+584|0;a:do if(c[e>>2]|0){j=c[a+20>>2]|0;q=n;r=0;while(1){p=ea(g[b>>2]);s=j+(r<<5)|0;g[s>>2]=ea(ea(g[s>>2])-p);p=ea(g[f>>2]);t=j+(r<<5)+4|0;g[t>>2]=ea(ea(g[t>>2])-p);p=ea(g[h>>2]);t=j+(r<<5)+8|0;g[t>>2]=ea(ea(g[t>>2])-p);p=ea(g[s+(q<<2)>>2]);o=ea(g[j+(r<<5)+16+(q<<2)>>2]);l=ea(p-o);s=(g[k>>2]=l,c[k>>2]|0);l=ea(p+o);t=(g[k>>2]=l,c[k>>2]|0);c[j+(r<<5)+12>>2]=(s|0)<0?~s:s|-2147483648;c[j+(r<<5)+28>>2]=(t|0)<0?~t:t|-2147483648;t=r+1|0;if(t>>>0>=(c[e>>2]|0)>>>0)break a;q=c[m>>2]|0;r=t}}while(0);l=ea(g[b>>2]);m=a+688|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+692|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+696|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[b>>2]);m=a+720|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+724|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+728|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[b>>2]);m=a+752|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+756|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+760|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[b>>2]);m=a+784|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+788|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+792|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[b>>2]);m=a+816|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[f>>2]);m=a+820|0;g[m>>2]=ea(ea(g[m>>2])-l);l=ea(g[h>>2]);m=a+824|0;g[m>>2]=ea(ea(g[m>>2])-l);m=0;do{l=ea(g[b>>2]);e=a+(m*224|0)+912|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(m*224|0)+916|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(m*224|0)+920|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(m*224|0)+944|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(m*224|0)+948|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(m*224|0)+952|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(m*224|0)+976|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(m*224|0)+980|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(m*224|0)+984|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(m*224|0)+1008|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(m*224|0)+1012|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(m*224|0)+1016|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(m*224|0)+1040|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(m*224|0)+1044|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(m*224|0)+1048|0;g[e>>2]=ea(ea(g[e>>2])-l);m=m+1|0}while((m|0)!=5);u=0;do{m=0;do{l=ea(g[b>>2]);e=a+(u*1120|0)+(m*224|0)+2032|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(u*1120|0)+(m*224|0)+2036|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(u*1120|0)+(m*224|0)+2040|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(u*1120|0)+(m*224|0)+2064|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(u*1120|0)+(m*224|0)+2068|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(u*1120|0)+(m*224|0)+2072|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(u*1120|0)+(m*224|0)+2096|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(u*1120|0)+(m*224|0)+2100|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(u*1120|0)+(m*224|0)+2104|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(u*1120|0)+(m*224|0)+2128|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(u*1120|0)+(m*224|0)+2132|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(u*1120|0)+(m*224|0)+2136|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[b>>2]);e=a+(u*1120|0)+(m*224|0)+2160|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[f>>2]);e=a+(u*1120|0)+(m*224|0)+2164|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(g[h>>2]);e=a+(u*1120|0)+(m*224|0)+2168|0;g[e>>2]=ea(ea(g[e>>2])-l);m=m+1|0}while((m|0)!=5);u=u+1|0}while((u|0)!=5);i=d;return}function QBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+64|0;h=f+28|0;j=f;g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(1.0);g[j+16>>2]=ea(0.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);FKa(d,j)|0;DKa(d,e)|0;k=ea(g[b+608>>2]);l=ea(g[b+624>>2]);m=ea(k-l);n=ea(g[b+612>>2]);o=ea(g[b+628>>2]);p=ea(n-o);q=ea(g[b+616>>2]);r=ea(g[b+632>>2]);s=ea(q-r);t=ea(k+l);l=ea(n+o);o=ea(q+r);g[h>>2]=m;g[h+4>>2]=p;g[h+8>>2]=s;g[h+12>>2]=t;g[h+16>>2]=l;g[h+20>>2]=o;a[h+24>>0]=1;HKa(d,h)|0;e=h+4|0;j=h+8|0;u=h+12|0;v=h+16|0;w=h+20|0;x=h+24|0;y=h+4|0;z=h+8|0;A=h+12|0;B=h+16|0;C=h+20|0;D=h+24|0;E=h+4|0;F=h+8|0;G=h+12|0;H=h+16|0;I=h+20|0;J=h+24|0;K=0;do{if(c[b+(K<<2)+640>>2]|0){o=ea(g[b+(K<<5)+688>>2]);l=ea(g[b+(K<<5)+704>>2]);t=ea(o-l);s=ea(g[b+(K<<5)+692>>2]);p=ea(g[b+(K<<5)+708>>2]);m=ea(s-p);r=ea(g[b+(K<<5)+696>>2]);q=ea(g[b+(K<<5)+712>>2]);n=ea(r-q);k=ea(o+l);l=ea(s+p);p=ea(r+q);g[h>>2]=t;g[e>>2]=m;g[j>>2]=n;g[u>>2]=k;g[v>>2]=l;g[w>>2]=p;a[x>>0]=1;HKa(d,h)|0;L=0;do{if(c[b+(K*224|0)+(L<<2)+864>>2]|0){p=ea(g[b+(K*224|0)+(L<<5)+912>>2]);l=ea(g[b+(K*224|0)+(L<<5)+928>>2]);k=ea(p-l);n=ea(g[b+(K*224|0)+(L<<5)+916>>2]);m=ea(g[b+(K*224|0)+(L<<5)+932>>2]);t=ea(n-m);q=ea(g[b+(K*224|0)+(L<<5)+920>>2]);r=ea(g[b+(K*224|0)+(L<<5)+936>>2]);s=ea(q-r);o=ea(p+l);l=ea(n+m);m=ea(q+r);g[h>>2]=k;g[y>>2]=t;g[z>>2]=s;g[A>>2]=o;g[B>>2]=l;g[C>>2]=m;a[D>>0]=1;HKa(d,h)|0;M=0;do{if(c[b+(K*1120|0)+(L*224|0)+(M<<2)+1984>>2]|0){m=ea(g[b+(K*1120|0)+(L*224|0)+(M<<5)+2032>>2]);l=ea(g[b+(K*1120|0)+(L*224|0)+(M<<5)+2048>>2]);o=ea(m-l);s=ea(g[b+(K*1120|0)+(L*224|0)+(M<<5)+2036>>2]);t=ea(g[b+(K*1120|0)+(L*224|0)+(M<<5)+2052>>2]);k=ea(s-t);r=ea(g[b+(K*1120|0)+(L*224|0)+(M<<5)+2040>>2]);q=ea(g[b+(K*1120|0)+(L*224|0)+(M<<5)+2056>>2]);n=ea(r-q);p=ea(m+l);l=ea(s+t);t=ea(r+q);g[h>>2]=o;g[E>>2]=k;g[F>>2]=n;g[G>>2]=p;g[H>>2]=l;g[I>>2]=t;a[J>>0]=1;HKa(d,h)|0}M=M+1|0}while((M|0)!=5)}L=L+1|0}while((L|0)!=5)}K=K+1|0}while((K|0)!=5);i=f;return}function RBa(a){a=a|0;var b=0;b=i;c[a>>2]=503272;DBa(a+16|0,1);bCa(a+7616|0);i=b;return}function SBa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;c[a>>2]=503272;dCa(a+7616|0);FBa(a+16|0);d=a+560|0;e=c[d>>2]|0;if(e)VJa(d,e);VJa(b,a);i=b;return}function TBa(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=503272;dCa(a+7616|0);FBa(a+16|0);d=a+560|0;a=c[d>>2]|0;if(!a){i=b;return}VJa(d,a);i=b;return}function UBa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=b+7616|0;a:do if(!g)k=0;else{l=b+7600|0;m=0;while(1){n=gCa(j,e+(m*24|0)|0,f+(m<<3)|0)|0;c[d+(m<<2)>>2]=n;if((n|0)==-1){k=m;break a}a[l>>0]=1;n=m+1|0;if(n>>>0<g>>>0)m=n;else{k=n;break}}}while(0);d=c[b+7628>>2]|0;f=c[b+7632>>2]|0;c[b+16>>2]=c[b+7620>>2];c[b+24>>2]=d;c[b+28>>2]=f;c[b+32>>2]=0;i=h;return (k|0)==(g|0)|0}function VBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if(e){g=b+7616|0;h=0;do{hCa(g,c[d+(h<<2)>>2]|0)|0;h=h+1|0}while((h|0)!=(e|0))}e=c[b+7628>>2]|0;h=c[b+7632>>2]|0;c[b+16>>2]=c[b+7620>>2];c[b+24>>2]=e;c[b+28>>2]=h;c[b+32>>2]=0;a[b+7600>>0]=1;i=f;return}function WBa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;if(!f)j=c[b+7628>>2]|0;else{k=c[b+7636>>2]|0;l=c[b+7628>>2]|0;m=0;do{n=c[k+(c[d+(m<<2)>>2]<<2)>>2]|0;g[l+(n*24|0)>>2]=ea(g[e+(m*24|0)>>2]);g[l+(n*24|0)+4>>2]=ea(g[e+(m*24|0)+4>>2]);g[l+(n*24|0)+8>>2]=ea(g[e+(m*24|0)+8>>2]);g[l+(n*24|0)+12>>2]=ea(g[e+(m*24|0)+12>>2]);g[l+(n*24|0)+16>>2]=ea(g[e+(m*24|0)+16>>2]);g[l+(n*24|0)+20>>2]=ea(g[e+(m*24|0)+20>>2]);m=m+1|0}while((m|0)!=(f|0));j=l}l=c[b+7632>>2]|0;c[b+16>>2]=c[b+7620>>2];c[b+24>>2]=j;c[b+28>>2]=l;c[b+32>>2]=0;a[b+7600>>0]=1;i=h;return}function XBa(a){a=a|0;var b=0;b=i;LBa(a+16|0);i=b;return}function YBa(a,b){a=a|0;b=b|0;var c=0;c=i;PBa(a+16|0,b);i=c;return}function ZBa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(a[b+7600>>0]|0){h=1;i=g;return h|0}h=NBa(b+16|0,c,d,e,f)|0;i=g;return h|0}function _Ba(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;if(a[b+7600>>0]|0){f=1;i=e;return f|0}f=OBa(b+16|0,c,d)|0;i=e;return f|0}function $Ba(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(a[b+7600>>0]|0){h=1;i=g;return h|0}h=MBa(b+16|0,c,d,e,f)|0;i=g;return h|0}function aCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;QBa(a+16|0,b,c);i=d;return}function bCa(a){a=a|0;var b=0;c[a>>2]=503368;b=a+4|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[a+32>>2]=-1;return}function cCa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=503368;d=a+12|0;VJa(b+3|0,c[d>>2]|0);c[d>>2]=0;d=a+16|0;VJa(b+2|0,c[d>>2]|0);c[d>>2]=0;d=a+20|0;VJa(b+1|0,c[d>>2]|0);c[d>>2]=0;VJa(b,c[a+24>>2]|0);ACi(a);i=b;return}function dCa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=503368;d=a+12|0;VJa(b+3|0,c[d>>2]|0);c[d>>2]=0;d=a+16|0;VJa(b+2|0,c[d>>2]|0);c[d>>2]=0;d=a+20|0;VJa(b+1|0,c[d>>2]|0);c[d>>2]=0;d=a+24|0;VJa(b,c[d>>2]|0);c[d>>2]=0;i=b;return}function eCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=UJa(d+1|0,b*24|0,503384,75)|0;f=UJa(d+4|0,b<<3,503384,76)|0;g=b<<2;h=UJa(d+9|0,g,503384,77)|0;j=UJa(d,g,503384,78)|0;if((e|0)==0|(f|0)==0|(h|0)==0|(j|0)==0){VJa(d+8|0,e);VJa(d+10|0,f);VJa(d+11|0,h);VJa(d+6|0,j);i=d;return}g=a+12|0;k=c[g>>2]|0;if(k)YEi(e|0,k|0,(c[a+4>>2]|0)*24|0)|0;k=a+16|0;l=c[k>>2]|0;if(l)YEi(f|0,l|0,c[a+4>>2]<<3|0)|0;l=a+24|0;m=c[l>>2]|0;if(m)YEi(h|0,m|0,c[a+4>>2]<<2|0)|0;m=a+20|0;n=c[m>>2]|0;if(!n)o=a+8|0;else{p=a+8|0;YEi(j|0,n|0,c[p>>2]<<2|0)|0;o=p}c[o>>2]=b;VJa(d+5|0,c[g>>2]|0);c[g>>2]=0;VJa(d+2|0,c[k>>2]|0);c[k>>2]=0;VJa(d+3|0,c[m>>2]|0);c[m>>2]=0;VJa(d+7|0,c[l>>2]|0);c[g>>2]=e;c[k>>2]=f;c[m>>2]=j;c[l>>2]=h;i=d;return}function fCa(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]|0)>>>0>=b>>>0){i=d;return}eCa(a,b);i=d;return}function gCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=a+4|0;h=c[f>>2]|0;j=a+8|0;k=c[j>>2]|0;if((h|0)==(k|0)){l=h<<1;eCa(a,l>>>0<64?64:l);m=c[j>>2]|0;n=c[f>>2]|0}else{m=k;n=h}if((n|0)==(m|0)){o=-1;i=e;return o|0}c[f>>2]=n+1;f=c[a+12>>2]|0;g[f+(n*24|0)>>2]=ea(g[b>>2]);g[f+(n*24|0)+4>>2]=ea(g[b+4>>2]);g[f+(n*24|0)+8>>2]=ea(g[b+8>>2]);g[f+(n*24|0)+12>>2]=ea(g[b+12>>2]);g[f+(n*24|0)+16>>2]=ea(g[b+16>>2]);g[f+(n*24|0)+20>>2]=ea(g[b+20>>2]);b=d;d=c[b+4>>2]|0;f=(c[a+16>>2]|0)+(n<<3)|0;c[f>>2]=c[b>>2];c[f+4>>2]=d;d=a+32|0;f=c[d>>2]|0;if((f|0)==-1){b=a+28|0;m=c[b>>2]|0;c[b>>2]=m+1;p=c[a+20>>2]|0;q=m}else{m=c[a+20>>2]|0;c[d>>2]=c[m+(f<<2)>>2];p=m;q=f}c[(c[a+24>>2]|0)+(n<<2)>>2]=q;c[p+(q<<2)>>2]=n;o=q;i=e;return o|0}function hCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=a+20|0;f=c[e>>2]|0;h=c[f+(b<<2)>>2]|0;j=a+4|0;k=(c[j>>2]|0)+-1|0;c[j>>2]=k;if((k|0)==(h|0)){l=f;m=a+32|0;n=c[m>>2]|0;o=l+(b<<2)|0;c[o>>2]=n;c[m>>2]=b;i=d;return k|0}f=a+24|0;j=c[(c[f>>2]|0)+(k<<2)>>2]|0;p=c[a+12>>2]|0;g[p+(h*24|0)>>2]=ea(g[p+(k*24|0)>>2]);g[p+(h*24|0)+4>>2]=ea(g[p+(k*24|0)+4>>2]);g[p+(h*24|0)+8>>2]=ea(g[p+(k*24|0)+8>>2]);g[p+(h*24|0)+12>>2]=ea(g[p+(k*24|0)+12>>2]);g[p+(h*24|0)+16>>2]=ea(g[p+(k*24|0)+16>>2]);g[p+(h*24|0)+20>>2]=ea(g[p+(k*24|0)+20>>2]);p=c[a+16>>2]|0;q=p+(k<<3)|0;r=c[q+4>>2]|0;s=p+(h<<3)|0;c[s>>2]=c[q>>2];c[s+4>>2]=r;c[(c[f>>2]|0)+(h<<2)>>2]=j;f=c[e>>2]|0;c[f+(j<<2)>>2]=h;l=f;m=a+32|0;n=c[m>>2]|0;o=l+(b<<2)|0;c[o>>2]=n;c[m>>2]=b;i=d;return k|0}function iCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0;d=i;e=c[a+4>>2]|0;if(!e){i=d;return}f=c[a+12>>2]|0;a=b+4|0;h=b+8|0;j=0;do{k=ea(g[b>>2]);l=f+(j*24|0)|0;g[l>>2]=ea(ea(g[l>>2])-k);k=ea(g[a>>2]);l=f+(j*24|0)+4|0;g[l>>2]=ea(ea(g[l>>2])-k);k=ea(g[h>>2]);l=f+(j*24|0)+8|0;g[l>>2]=ea(ea(g[l>>2])-k);k=ea(g[b>>2]);l=f+(j*24|0)+12|0;g[l>>2]=ea(ea(g[l>>2])-k);k=ea(g[a>>2]);l=f+(j*24|0)+16|0;g[l>>2]=ea(ea(g[l>>2])-k);k=ea(g[h>>2]);l=f+(j*24|0)+20|0;g[l>>2]=ea(ea(g[l>>2])-k);j=j+1|0}while(j>>>0<e>>>0);i=d;return}function jCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;c[a>>2]=DMa()|0;c[a+4>>2]=MNa()|0;c[a+8>>2]=uMa()|0;c[a+28>>2]=0;c[a+32>>2]=0;c[a+40>>2]=0;c[a+44>>2]=0;c[a+52>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;c[a+76>>2]=b;b=a+80|0;f=c[(qTa()|0)>>2]|0;if(f){g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](g,f,k?544576:544544,544464,111)|0;c[b>>2]=j;if(j)mTa(j)}else c[b>>2]=0;b=d+116|0;j=a+64|0;c[j>>2]=c[b>>2];k=d+120|0;f=a+68|0;c[f>>2]=c[k>>2];c[a+20>>2]=0;c[a+24>>2]=0;g=a+12|0;c[g>>2]=kCa(c[b>>2]|0)|0;b=kCa(c[k>>2]|0)|0;k=a+16|0;c[k>>2]=b;h=c[d+124>>2]|0;c[a+72>>2]=h;l=c[g>>2]|0;if((l|0)!=0?(c[j>>2]|0)==1:0){lBa(l,h);m=c[k>>2]|0}else m=b;if(!m){n=d+56|0;o=c[n>>2]|0;p=d+60|0;q=c[p>>2]|0;mCa(a,o,q);i=e;return}if((c[f>>2]|0)!=1){n=d+56|0;o=c[n>>2]|0;p=d+60|0;q=c[p>>2]|0;mCa(a,o,q);i=e;return}lBa(m,h);n=d+56|0;o=c[n>>2]|0;p=d+60|0;q=c[p>>2]|0;mCa(a,o,q);i=e;return}function kCa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;if(!a){d=mKa()|0;e=c[(c[d>>2]|0)+8>>2]|0;f=pKa()|0;g=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=Bn[e&255](d,7664,g?503672:544544,503464,80)|0;RBa(f);h=f;i=b;return h|0}else if((a|0)==1){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;d=pKa()|0;e=mo[c[(c[d>>2]|0)+24>>2]&4095](d)|0;d=Bn[g&255](f,7824,e?503792:544544,503464,81)|0;aBa(d,1);h=d;i=b;return h|0}else if((a|0)==2){a=mKa()|0;d=c[(c[a>>2]|0)+8>>2]|0;e=pKa()|0;f=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;e=Bn[d&255](a,7824,f?503792:544544,503464,79)|0;aBa(e,0);h=e;i=b;return h|0}else{h=0;i=b;return h|0}return 0}function lCa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+72>>2]=b;e=c[a+12>>2]|0;if((e|0)!=0?(c[a+64>>2]|0)==1:0)lBa(e,b);e=c[a+16>>2]|0;if(!e){i=d;return}if((c[a+68>>2]|0)!=1){i=d;return}lBa(e,b);i=d;return}function mCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+32|0;g=c[f>>2]|0;if(g<<5>>>0<b>>>0?(h=(b+31|0)>>>5,h>>>0>(g&2147483647)>>>0):0){g=a+36|0;j=UJa(g,h<<2,543784,339)|0;k=a+28|0;l=c[k>>2]|0;if((l|0)!=0?(YEi(j|0,l|0,c[f>>2]<<2|0)|0,(c[f>>2]|0)>-1):0)VJa(g,c[k>>2]|0);g=c[f>>2]|0;PEi(j+((g&2147483647)<<2)|0,0,h-g<<2|0)|0;c[k>>2]=j;c[f>>2]=h}h=a+44|0;f=c[h>>2]|0;if(f<<5>>>0<d>>>0?(j=(d+31|0)>>>5,j>>>0>(f&2147483647)>>>0):0){f=a+48|0;k=UJa(f,j<<2,543784,339)|0;g=a+40|0;l=c[g>>2]|0;if((l|0)!=0?(YEi(k|0,l|0,c[h>>2]<<2|0)|0,(c[h>>2]|0)>-1):0)VJa(f,c[g>>2]|0);f=c[h>>2]|0;PEi(k+((f&2147483647)<<2)|0,0,j-f<<2|0)|0;c[g>>2]=k;c[h>>2]=j}j=c[a+12>>2]|0;if(j)In[c[(c[j>>2]|0)+32>>2]&4095](j,b);b=c[a+16>>2]|0;if(!b){i=e;return}In[c[(c[b>>2]|0)+32>>2]&4095](b,d);i=e;return}function nCa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+12|0;e=c[d>>2]|0;if(e)ko[c[(c[e>>2]|0)+44>>2]&4095](e);c[d>>2]=0;d=a+16|0;e=c[d>>2]|0;if(e)ko[c[(c[e>>2]|0)+44>>2]&4095](e);c[d>>2]=0;d=a+80|0;nTa(c[d>>2]|0);e=c[d>>2]|0;if(e){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+60>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+52>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+40>>2]|0;if((e|0)!=0?(c[a+44>>2]|0)>-1:0)VJa(a+48|0,e);e=c[a+28>>2]|0;if(!e){i=b;return}if((c[a+32>>2]|0)<=-1){i=b;return}VJa(a+36|0,e);i=b;return}function oCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=b;g=f&1;h=(c[a+(g*12|0)+28>>2]|0)+(f>>>7<<2)|0;j=c[h>>2]|0;k=1<<(f>>>2&31);if(j&k){i=d;return}c[h>>2]=j|k;k=a+52|0;j=a+56|0;h=c[j>>2]|0;if((c[a+60>>2]&2147483647)>>>0>h>>>0){f=(c[k>>2]|0)+(h<<2)|0;if(f)c[f>>2]=b;c[j>>2]=h+1}else H2a(k,e)|0;e=a+(g<<2)+20|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}function pCa(a,b,d,f,h){a=a|0;b=b|0;d=d|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;j=i;i=i+64|0;k=j+56|0;l=j+32|0;m=j+8|0;n=j;o=b+32|0;b=d+(c[427044+((e[d+4>>1]|0)<<2)>>2]|0)|0;c[k>>2]=o;c[k+4>>2]=b;if(!h){BCa(m,o,b);g[l>>2]=ea(g[m>>2]);g[l+4>>2]=ea(g[m+4>>2]);g[l+8>>2]=ea(g[m+8>>2]);g[l+12>>2]=ea(g[m+12>>2]);g[l+16>>2]=ea(g[m+16>>2]);g[l+20>>2]=ea(g[m+20>>2])}else{p=ea(g[h+12>>2]);q=ea(g[h>>2]);r=ea(p-q);s=ea(g[h+16>>2]);t=ea(g[h+4>>2]);u=ea(s-t);v=ea(g[h+20>>2]);w=ea(g[h+8>>2]);x=ea(ea(r*ea(.5))*ea(.00999999977));r=ea(ea(u*ea(.5))*ea(.00999999977));u=ea(ea(ea(v-w)*ea(.5))*ea(.00999999977));y=ea(t-r);t=ea(w-u);w=ea(p+x);p=ea(s+r);r=ea(v+u);g[l>>2]=ea(q-x);g[l+4>>2]=y;g[l+8>>2]=t;g[l+12>>2]=w;g[l+16>>2]=p;g[l+20>>2]=r}h=f&1;f=c[a+(h<<2)+12>>2]|0;Bn[c[c[f>>2]>>2]&255](f,n,l,k,1)|0;k=a+(h<<2)+20|0;c[k>>2]=(c[k>>2]|0)+1;k=a+(h*12|0)+28|0;l=a+(h*12|0)+32|0;f=c[l>>2]|0;m=c[n>>2]|0;if(f<<5>>>0>m>>>0){z=m;A=z&31;B=1<<A;C=~B;D=z>>>5;E=c[k>>2]|0;F=E+(D<<2)|0;G=c[F>>2]|0;H=G&C;c[F>>2]=H;I=c[n>>2]|0;J=I<<2;K=h|J;L=K|2;M=L;i=j;return M|0}b=f<<6>>>0<1024?32:f<<1&134217726;if(b>>>0<=(f&2147483647)>>>0){z=m;A=z&31;B=1<<A;C=~B;D=z>>>5;E=c[k>>2]|0;F=E+(D<<2)|0;G=c[F>>2]|0;H=G&C;c[F>>2]=H;I=c[n>>2]|0;J=I<<2;K=h|J;L=K|2;M=L;i=j;return M|0}m=a+(h*12|0)+36|0;a=UJa(m,b<<2,543784,339)|0;f=c[k>>2]|0;if((f|0)!=0?(YEi(a|0,f|0,c[l>>2]<<2|0)|0,(c[l>>2]|0)>-1):0)VJa(m,c[k>>2]|0);m=c[l>>2]|0;PEi(a+((m&2147483647)<<2)|0,0,b-m<<2|0)|0;c[k>>2]=a;c[l>>2]=b;z=c[n>>2]|0;A=z&31;B=1<<A;C=~B;D=z>>>5;E=c[k>>2]|0;F=E+(D<<2)|0;G=c[F>>2]|0;H=G&C;c[F>>2]=H;I=c[n>>2]|0;J=I<<2;K=h|J;L=K|2;M=L;i=j;return M|0}function qCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=b;c[e>>2]=f>>>2;b=c[a+((f&1)<<2)+12>>2]|0;f=_n[c[(c[b>>2]|0)+28>>2]&4095](b,e)|0;i=d;return f|0}function rCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=b;g=f&1;h=f>>>2;c[e>>2]=h;j=(c[a+(g*12|0)+28>>2]|0)+(f>>>7<<2)|0;f=c[j>>2]|0;k=1<<(h&31);if((f&k|0)!=0?(c[j>>2]=f&~k,k=a+56|0,f=c[k>>2]|0,(f|0)!=0):0){j=c[a+52>>2]|0;h=0;while(1){l=h+1|0;if((c[j+(h<<2)>>2]|0)==(b|0)){m=h;break}if(l>>>0<f>>>0)h=l;else{m=l;break}}if((m|0)!=(f|0)){h=f+-1|0;c[k>>2]=h;c[j+(m<<2)>>2]=c[j+(h<<2)>>2]}}h=a+(g<<2)+20|0;c[h>>2]=(c[h>>2]|0)+1;h=c[a+(g<<2)+12>>2]|0;co[c[(c[h>>2]|0)+4>>2]&2047](h,e,1);i=d;return}function sCa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+64|0;e=d+48|0;f=d+24|0;g=d+16|0;h=d;c[g>>2]=0;c[g+4>>2]=0;dea((c[a+76>>2]|0)+16|0,g);j=Bfa(g)|0;if(j){k=j;j=0;while(1){l=(Zba(k)|0)+20|0;m=b[l+4>>1]|0;if(m<<16>>16==1)n=l;else n=c[l>>2]|0;o=l+8|0;if((b[l+12>>1]|0)==1)p=o;else p=c[o>>2]|0;if(!(m<<16>>16))q=j;else{o=m&65535;m=0;l=j;while(1){r=c[p+(m<<2)>>2]|0;if(!r)s=l;else{c[h+(l<<2)>>2]=r;s=l+1|0}if((s|0)==4){r=0;do{t=c[h+(r<<2)>>2]|0;u=t&1;v=t>>>2;if(!(1<<(v&31)&c[(c[a+(u*12|0)+28>>2]|0)+(t>>>7<<2)>>2])){c[e>>2]=v;v=a+(u<<2)+12|0;t=c[v>>2]|0;w=_n[c[(c[t>>2]|0)+28>>2]&4095](t,e)|0;BCa(f,c[w>>2]|0,c[w+4>>2]|0);w=a+(u<<2)+20|0;c[w>>2]=(c[w>>2]|0)+1;w=c[v>>2]|0;Dn[c[(c[w>>2]|0)+8>>2]&511](w,e,f,1)}r=r+1|0}while((r|0)!=4);x=0}else x=s;r=m+1|0;if((r|0)==(o|0)){q=x;break}else{m=r;l=x}}}k=Bfa(g)|0;if(!k)break;else j=q}if(q){j=0;do{k=c[h+(j<<2)>>2]|0;g=k&1;x=k>>>2;if(!(1<<(x&31)&c[(c[a+(g*12|0)+28>>2]|0)+(k>>>7<<2)>>2])){c[e>>2]=x;x=a+(g<<2)+12|0;k=c[x>>2]|0;s=_n[c[(c[k>>2]|0)+28>>2]&4095](k,e)|0;BCa(f,c[s>>2]|0,c[s+4>>2]|0);s=a+(g<<2)+20|0;c[s>>2]=(c[s>>2]|0)+1;s=c[x>>2]|0;Dn[c[(c[s>>2]|0)+8>>2]&511](s,e,f,1)}j=j+1|0}while((j|0)!=(q|0))}}tCa(a);q=a+12|0;j=c[q>>2]|0;if((c[a+64>>2]|0)==1){qBa(j)|0;y=c[q>>2]|0}else y=j;ko[c[(c[y>>2]|0)+12>>2]&4095](y);y=a+16|0;j=c[y>>2]|0;if((c[a+68>>2]|0)!=1){z=j;A=c[z>>2]|0;B=A+12|0;C=c[B>>2]|0;ko[C&4095](z);i=d;return}qBa(j)|0;z=c[y>>2]|0;A=c[z>>2]|0;B=A+12|0;C=c[B>>2]|0;ko[C&4095](z);i=d;return}function tCa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+24|0;e=b;f=a+56|0;g=c[f>>2]|0;if(!g){c[f>>2]=0;i=b;return}h=a+52|0;j=0;do{k=c[(c[h>>2]|0)+(j<<2)>>2]|0;l=k&1;m=k>>>2;n=(c[a+(l*12|0)+28>>2]|0)+(k>>>7<<2)|0;c[n>>2]=c[n>>2]&~(1<<(m&31));c[d>>2]=m;m=a+(l<<2)+12|0;n=c[m>>2]|0;k=_n[c[(c[n>>2]|0)+28>>2]&4095](n,d)|0;BCa(e,c[k>>2]|0,c[k+4>>2]|0);k=a+(l<<2)+20|0;c[k>>2]=(c[k>>2]|0)+1;k=c[m>>2]|0;Dn[c[(c[k>>2]|0)+8>>2]&511](k,d,e,1);j=j+1|0}while((j|0)!=(g|0));c[f>>2]=0;i=b;return}function uCa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+76>>2]|0;e=c[d+1200>>2]|0;f=d+1192|0;d=c[f>>2]|0;g=c[f+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,135,d,g);f=a+80|0;oTa(c[f>>2]|0);tCa(a);h=c[a+12>>2]|0;if(h)ko[c[(c[h>>2]|0)+12>>2]&4095](h);h=c[a+16>>2]|0;if(h)ko[c[(c[h>>2]|0)+12>>2]&4095](h);pTa(c[f>>2]|0);Dn[c[(c[e>>2]|0)+12>>2]&511](e,135,d,g);i=b;return}function vCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[a+76>>2]|0;g=c[f+1200>>2]|0;h=f+1192|0;f=c[h>>2]|0;j=c[h+4>>2]|0;Dn[c[(c[g>>2]|0)+8>>2]&511](g,111,f,j);h=a+80|0;oTa(c[h>>2]|0);if((b?(b=a+12|0,k=c[b>>2]|0,(k|0)!=0):0)?(c[a+64>>2]|0)==1:0){kBa(k);k=c[b>>2]|0;ko[c[(c[k>>2]|0)+12>>2]&4095](k)}if((d?(d=a+16|0,k=c[d>>2]|0,(k|0)!=0):0)?(c[a+68>>2]|0)==1:0){kBa(k);k=c[d>>2]|0;ko[c[(c[k>>2]|0)+12>>2]&4095](k)}pTa(c[h>>2]|0);Dn[c[(c[g>>2]|0)+12>>2]&511](g,111,f,j);i=e;return}function wCa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+12>>2]|0;In[c[(c[e>>2]|0)+36>>2]&4095](e,b);e=c[a+16>>2]|0;In[c[(c[e>>2]|0)+36>>2]&4095](e,b);i=d;return}function xCa(a){a=a|0;var b=0,d=0;b=i;d=P3(c[a+76>>2]|0)|0;i=b;return d|0}function yCa(a,b){a=a|0;b=b|0;return}function zCa(a,b,d){a=a|0;b=b|0;d=d|0;var f=0;f=i;ACa(a,b+32|0,d+(c[427044+((e[d+4>>1]|0)<<2)>>2]|0)|0);i=f;return}function ACa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;f=i;i=i+32|0;h=f;j=e+4|0;k=c[j>>2]|0;l=k>>>24&15;if(!(a[(c[450992+(l<<2)>>2]|0)+e+10>>0]|0)){if(!(k&64))m=e+32|0;else{k=e+8|0;n=c[k>>2]|0;if(!n){o=s4(c[e>>2]|0,l)|0;c[k>>2]=o;p=o}else p=n;m=p+96|0}p=c[d+4>>2]|0;if(!(p&4))q=d+48|0;else{n=d+8|0;o=c[n>>2]|0;if(!o){k=s4(c[d>>2]|0,p>>>24&15)|0;c[n>>2]=k;r=k}else r=o;q=r+64|0}s=ea(ea(g[q+16>>2])*ea(2.0));t=ea(ea(g[q+20>>2])*ea(2.0));u=ea(ea(g[q+24>>2])*ea(2.0));v=ea(g[m+12>>2]);w=ea(ea(v*v)+ea(-.5));x=ea(g[m>>2]);y=ea(s*x);z=ea(g[m+4>>2]);A=ea(y+ea(t*z));y=ea(g[m+8>>2]);B=ea(A+ea(u*y));A=ea(ea(x*B)+ea(ea(s*w)+ea(v*ea(ea(u*z)-ea(t*y)))));C=ea(ea(z*B)+ea(ea(t*w)+ea(v*ea(ea(s*y)-ea(u*x)))));D=ea(ea(ea(u*w)+ea(v*ea(ea(t*x)-ea(s*z))))+ea(y*B));B=ea(ea(g[m+16>>2])+A);A=ea(ea(g[m+20>>2])+C);C=ea(ea(g[m+24>>2])+D);D=ea(g[q>>2]);s=ea(v*D);t=ea(g[q+12>>2]);w=ea(s+ea(x*t));s=ea(g[q+8>>2]);u=ea(w+ea(z*s));w=ea(g[q+4>>2]);E=ea(ea(ea(y*D)+ea(ea(z*t)+ea(v*w)))-ea(x*s));F=ea(ea(ea(x*w)+ea(ea(y*t)+ea(v*s)))-ea(z*D));G=ea(ea(ea(ea(v*t)-ea(x*D))-ea(z*w))-ea(y*s));g[b>>2]=ea(u-ea(y*w));g[b+4>>2]=E;g[b+8>>2]=F;g[b+12>>2]=G;g[b+16>>2]=B;g[b+20>>2]=A;g[b+24>>2]=C;i=f;return}q=e+236|0;if(!(c[q>>2]&4096))H=e+60|0;else{m=e+8|0;r=c[m>>2]|0;if(!r){o=s4(c[e>>2]|0,l)|0;c[m>>2]=o;I=o}else I=r;H=I+268|0}do if(!(a[H>>0]&1)){I=e+176|0;C=ea(g[I>>2]);A=ea(g[I+4>>2]);B=ea(g[I+8>>2]);G=ea(g[I+12>>2]);F=ea(g[I+16>>2]);E=ea(g[I+20>>2]);J=G;K=C;L=A;M=B;N=F;O=E;P=ea(g[I+24>>2])}else{if(!(c[q>>2]&8192)){if((c[j>>2]&-1073741824|0)!=-1073741824?l9(e+16|0,h)|0:0)Q=26}else{I=e+8|0;r=c[I>>2]|0;if(!r){o=s4(c[e>>2]|0,(c[j>>2]|0)>>>24&15)|0;c[I>>2]=o;R=o}else R=r;g[h>>2]=ea(g[R+192>>2]);g[h+4>>2]=ea(g[R+196>>2]);g[h+8>>2]=ea(g[R+200>>2]);g[h+12>>2]=ea(g[R+204>>2]);g[h+16>>2]=ea(g[R+208>>2]);g[h+20>>2]=ea(g[R+212>>2]);g[h+24>>2]=ea(g[R+216>>2]);Q=26}if((Q|0)==26){if(!(c[q>>2]&4096))S=e+60|0;else{r=e+8|0;o=c[r>>2]|0;if(!o){I=s4(c[e>>2]|0,(c[j>>2]|0)>>>24&15)|0;c[r>>2]=I;T=I}else T=o;S=T+268|0}if(a[S>>0]&2){E=ea(g[h>>2]);F=ea(g[h+4>>2]);B=ea(g[h+8>>2]);A=ea(g[h+12>>2]);C=ea(g[h+16>>2]);G=ea(g[h+20>>2]);J=A;K=E;L=F;M=B;N=C;O=G;P=ea(g[h+24>>2]);break}}o=e+176|0;G=ea(g[o>>2]);C=ea(g[o+4>>2]);B=ea(g[o+8>>2]);F=ea(g[o+12>>2]);E=ea(g[o+16>>2]);A=ea(g[o+20>>2]);J=F;K=G;L=C;M=B;N=E;O=A;P=ea(g[o+24>>2])}while(0);if(!(c[q>>2]&512))U=e+64|0;else{q=e+8|0;h=c[q>>2]|0;if(!h){S=s4(c[e>>2]|0,(c[j>>2]|0)>>>24&15)|0;c[q>>2]=S;V=S}else V=h;U=V+144|0}A=ea(g[U+16>>2]);E=ea(g[U+20>>2]);B=ea(A*ea(-2.0));A=ea(E*ea(-2.0));E=ea(ea(g[U+24>>2])*ea(-2.0));C=ea(g[U+12>>2]);G=ea(ea(C*C)+ea(-.5));F=ea(g[U>>2]);w=ea(B*F);y=ea(g[U+4>>2]);u=ea(w+ea(A*y));w=ea(g[U+8>>2]);s=ea(u+ea(E*w));u=ea(-F);z=ea(-y);D=ea(-w);x=ea(ea(ea(F*s)+ea(ea(B*G)-ea(C*ea(ea(E*y)-ea(A*w)))))*ea(2.0));t=ea(ea(ea(y*s)+ea(ea(A*G)-ea(C*ea(ea(B*w)-ea(E*F)))))*ea(2.0));v=ea(ea(ea(ea(E*G)-ea(C*ea(ea(A*F)-ea(B*y))))+ea(w*s))*ea(2.0));s=ea(ea(J*J)+ea(-.5));w=ea(ea(M*v)+ea(ea(K*x)+ea(L*t)));y=ea(N+ea(ea(K*w)+ea(ea(s*x)+ea(J*ea(ea(L*v)-ea(M*t))))));N=ea(O+ea(ea(L*w)+ea(ea(s*t)+ea(J*ea(ea(M*x)-ea(K*v))))));O=ea(P+ea(ea(ea(s*v)+ea(J*ea(ea(K*t)-ea(L*x))))+ea(M*w)));w=ea(ea(ea(ea(K*C)+ea(J*u))+ea(L*D))-ea(M*z));x=ea(ea(ea(M*u)+ea(ea(L*C)+ea(J*z)))-ea(K*D));t=ea(ea(ea(K*z)+ea(ea(M*C)+ea(J*D)))-ea(L*u));v=ea(ea(ea(ea(J*C)-ea(K*u))-ea(L*z))-ea(M*D));U=c[d+4>>2]|0;if(!(U&4))W=d+48|0;else{V=d+8|0;h=c[V>>2]|0;if(!h){S=s4(c[d>>2]|0,U>>>24&15)|0;c[V>>2]=S;X=S}else X=h;W=X+64|0}D=ea(ea(g[W+16>>2])*ea(2.0));M=ea(ea(g[W+20>>2])*ea(2.0));z=ea(ea(g[W+24>>2])*ea(2.0));L=ea(ea(v*v)+ea(-.5));u=ea(ea(ea(w*D)+ea(x*M))+ea(t*z));K=ea(y+ea(ea(w*u)+ea(ea(L*D)+ea(v*ea(ea(x*z)-ea(t*M))))));y=ea(N+ea(ea(x*u)+ea(ea(L*M)+ea(v*ea(ea(t*D)-ea(w*z))))));N=ea(O+ea(ea(ea(L*z)+ea(v*ea(ea(w*M)-ea(x*D))))+ea(t*u)));u=ea(g[W>>2]);D=ea(v*u);M=ea(g[W+12>>2]);z=ea(D+ea(w*M));D=ea(g[W+8>>2]);L=ea(z+ea(x*D));z=ea(g[W+4>>2]);O=ea(ea(ea(t*u)+ea(ea(x*M)+ea(v*z)))-ea(w*D));C=ea(ea(ea(w*z)+ea(ea(t*M)+ea(v*D)))-ea(x*u));J=ea(ea(ea(ea(v*M)-ea(w*u))-ea(x*z))-ea(t*D));g[b>>2]=ea(L-ea(t*z));g[b+4>>2]=O;g[b+8>>2]=C;g[b+12>>2]=J;g[b+16>>2]=K;g[b+20>>2]=y;g[b+24>>2]=N;i=f;return}function BCa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,T=Im,U=Im,V=Im,W=0,X=Im,Y=0,Z=Im,_=Im,$=0,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;f=i;i=i+96|0;h=f+32|0;j=f;k=f+64|0;l=e+4|0;m=a[(c[450992+(((c[l>>2]|0)>>>24&15)<<2)>>2]|0)+e+10>>0]|0;n=d+4|0;o=c[n>>2]|0;if(!(o&1)){p=d+84|0;q=o}else{r=d+8|0;s=c[r>>2]|0;if(!s){t=s4(c[d>>2]|0,o>>>24&15)|0;c[r>>2]=t;u=c[n>>2]|0;v=t}else{u=o;v=s}p=v;q=u}if(!(q&4))w=d+48|0;else{u=d+8|0;v=c[u>>2]|0;if(!v){s=s4(c[d>>2]|0,q>>>24&15)|0;c[u>>2]=s;x=s}else x=v;w=x+64|0}if(!(m<<24>>24)){m=c[l>>2]|0;if(!(m&64))y=e+32|0;else{x=e+8|0;v=c[x>>2]|0;if(!v){s=s4(c[e>>2]|0,m>>>24&15)|0;c[x>>2]=s;z=s}else z=v;y=z+96|0}A=ea(g[y+16>>2]);B=ea(g[y+20>>2]);C=ea(g[y+24>>2]);D=ea(g[y>>2]);E=ea(g[y+4>>2]);F=ea(g[y+8>>2]);G=ea(g[y+12>>2]);H=ea(g[w+16>>2]);I=ea(g[w+20>>2]);J=ea(g[w+24>>2]);K=ea(g[w>>2]);L=ea(g[w+4>>2]);M=ea(g[w+8>>2]);N=ea(g[w+12>>2]);O=ea(ea(G*N)-ea(ea(ea(D*K)+ea(E*L))+ea(F*M)));P=ea(ea(D*N)+ea(ea(G*K)+ea(ea(E*M)-ea(F*L))));Q=ea(ea(E*N)+ea(ea(G*L)+ea(ea(F*K)-ea(D*M))));R=ea(ea(F*N)+ea(ea(G*M)+ea(ea(D*L)-ea(E*K))));K=ea(ea(G*G)+ea(-.5));L=ea(ea(ea(D*H)+ea(E*I))+ea(F*J));M=ea(B+ea(ea(ea(E*L)+ea(ea(I*K)+ea(G*ea(ea(F*H)-ea(D*J)))))*ea(2.0)));B=ea(C+ea(ea(ea(ea(K*J)+ea(G*ea(ea(D*I)-ea(E*H))))+ea(F*L))*ea(2.0)));g[h+16>>2]=ea(A+ea(ea(ea(D*L)+ea(ea(H*K)+ea(G*ea(ea(E*J)-ea(F*I)))))*ea(2.0)));g[h+20>>2]=M;g[h+24>>2]=B;g[h>>2]=P;g[h+4>>2]=Q;g[h+8>>2]=R;g[h+12>>2]=O;oMa(p,k,h,ea(0.0),0);S=k+12|0;T=ea(g[S>>2]);U=ea(g[k>>2]);V=ea(T-U);W=k+16|0;X=ea(g[W>>2]);Y=k+4|0;Z=ea(g[Y>>2]);_=ea(X-Z);$=k+20|0;aa=ea(g[$>>2]);ba=k+8|0;ca=ea(g[ba>>2]);da=ea(aa-ca);fa=ea(V*ea(.5));ga=ea(_*ea(.5));ha=ea(da*ea(.5));ia=ea(fa*ea(.00999999977));ja=ea(ga*ea(.00999999977));ka=ea(ha*ea(.00999999977));la=ea(U-ia);ma=ea(Z-ja);na=ea(ca-ka);oa=ea(T+ia);pa=ea(X+ja);qa=ea(aa+ka);g[b>>2]=la;ra=b+4|0;g[ra>>2]=ma;sa=b+8|0;g[sa>>2]=na;ta=b+12|0;g[ta>>2]=oa;ua=b+16|0;g[ua>>2]=pa;va=b+20|0;g[va>>2]=qa;i=f;return}y=e+236|0;if(!(c[y>>2]&4096))wa=e+60|0;else{z=e+8|0;v=c[z>>2]|0;if(!v){s=s4(c[e>>2]|0,(c[l>>2]|0)>>>24&15)|0;c[z>>2]=s;xa=s}else xa=v;wa=xa+268|0}do if((a[wa>>0]&3)==3){if(!(c[y>>2]&8192)){if((c[l>>2]&-1073741824|0)==-1073741824){ya=30;break}if(l9(e+16|0,j)|0){za=j;break}else{ya=30;break}}xa=e+8|0;v=c[xa>>2]|0;if(!v){s=s4(c[e>>2]|0,(c[l>>2]|0)>>>24&15)|0;c[xa>>2]=s;Aa=s}else Aa=v;g[j>>2]=ea(g[Aa+192>>2]);g[j+4>>2]=ea(g[Aa+196>>2]);g[j+8>>2]=ea(g[Aa+200>>2]);g[j+12>>2]=ea(g[Aa+204>>2]);g[j+16>>2]=ea(g[Aa+208>>2]);g[j+20>>2]=ea(g[Aa+212>>2]);g[j+24>>2]=ea(g[Aa+216>>2]);za=j}else ya=30;while(0);if((ya|0)==30)za=e+176|0;if(!(c[y>>2]&512))Ba=e+64|0;else{y=e+8|0;ya=c[y>>2]|0;if(!ya){j=s4(c[e>>2]|0,(c[l>>2]|0)>>>24&15)|0;c[y>>2]=j;Ca=j}else Ca=ya;Ba=Ca+144|0}BZa(za,w,Ba,h);oMa(p,k,h,ea(0.0),0);S=k+12|0;T=ea(g[S>>2]);U=ea(g[k>>2]);V=ea(T-U);W=k+16|0;X=ea(g[W>>2]);Y=k+4|0;Z=ea(g[Y>>2]);_=ea(X-Z);$=k+20|0;aa=ea(g[$>>2]);ba=k+8|0;ca=ea(g[ba>>2]);da=ea(aa-ca);fa=ea(V*ea(.5));ga=ea(_*ea(.5));ha=ea(da*ea(.5));ia=ea(fa*ea(.00999999977));ja=ea(ga*ea(.00999999977));ka=ea(ha*ea(.00999999977));la=ea(U-ia);ma=ea(Z-ja);na=ea(ca-ka);oa=ea(T+ia);pa=ea(X+ja);qa=ea(aa+ka);g[b>>2]=la;ra=b+4|0;g[ra>>2]=ma;sa=b+8|0;g[sa>>2]=na;ta=b+12|0;g[ta>>2]=oa;ua=b+16|0;g[ua>>2]=pa;va=b+20|0;g[va>>2]=qa;i=f;return}function CCa(a){a=a|0;return a|0}function DCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a>>2]|0;f=b+8|0;c[f>>2]=e;g=c[a+4>>2]|0;a=g;c[b+12>>2]=a;if(!g){h=0;j=e}else{e=Zba((c[450992+(((c[a+4>>2]|0)>>>24&15)<<2)>>2]|0)+g|0)|0;h=e;j=c[f>>2]|0}c[b>>2]=h;if(!j){k=0;l=b+4|0;c[l>>2]=k;i=d;return}k=dfa(j+16|0)|0;l=b+4|0;c[l>>2]=k;i=d;return}function ECa(a,b){a=a|0;b=b|0;return (c[a+(b>>>5<<2)>>2]&1<<(b&31)|0)!=0|0}function FCa(a){a=a|0;return c[a>>2]|0}function GCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=a+4|0;f=a+8|0;h=c[b>>2]|0;j=0;while(1){k=j>>>5;l=1<<j;m=a+(k<<2)|0;n=c[m>>2]|0;o=(n&l|0)!=0;if(!(c[e+(k<<2)>>2]&l))if(o){k=h+-1|0;c[m>>2]=n&~l;p=ea(k>>>0);if(p>ea(0.0))q=ea(ea(1.0)/p);else q=ea(0.0);g[f>>2]=q;r=k}else r=h;else if(o)r=h;else{o=h+1|0;c[m>>2]=n|l;g[f>>2]=ea(ea(1.0)/ea(o>>>0));r=o}c[b>>2]=r;j=j+1|0;if((j|0)==20)break;else h=r}i=d;return}function HCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+64|0;YEi(a|0,b|0,c[e>>2]<<3|0)|0;c[a+64>>2]=c[e>>2];e=a+80|0;f=b+80|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];g[a+104>>2]=ea(ea(1.0)/ea(g[f>>2]));g[a+108>>2]=ea(ea(1.0)/ea(g[b+88>>2]));i=d;return}function ICa(a,b){a=a|0;b=b|0;var c=0;c=i;YEi(a+112|0,b|0,144)|0;i=c;return}function JCa(a,b){a=a|0;b=b|0;var d=0;d=a+256|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function KCa(a,b){a=a|0;b=b|0;var c=0;c=i;YEi(a+272|0,b|0,256)|0;i=c;return}function LCa(b){b=b|0;var d=0,e=0;d=i;a[b+64>>0]=0;a[b+65>>0]=0;a[b+66>>0]=0;c[b+68>>2]=1;c[b+72>>2]=1;g[b+76>>2]=ea(360.0);g[b+80>>2]=ea(0.0);g[b+84>>2]=ea(0.0);e=b+0|0;b=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(b|0));i=d;return}function MCa(a,b,c){a=a|0;b=b|0;c=ea(c);g[a+(b<<2)>>2]=c;return}function NCa(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+(b<<2)>>2]);return ea(c)}function OCa(a){a=a|0;var b=0,c=0;b=i;c=gFa(a)|0;i=b;return c|0}function PCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=hFa(a,b,c,d,1)|0;i=e;return f|0}function QCa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;jFa(a,b,c,d,e,f);i=g;return}function RCa(a,b){a=a|0;b=b|0;var d=0;d=a+528|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];c[d+24>>2]=c[b+24>>2];c[d+28>>2]=c[b+28>>2];return}function SCa(a,b){a=a|0;b=b|0;var d=0;d=a+560|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function TCa(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=(b+3|0)>>>2;e=UJa(c,(OCa(d)|0)+800|0,503912,91)|0;if(e)PDa(e);PCa(e,e+800|0,d,b)|0;a[e+113>>0]=0;i=c;return e|0}function UCa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;QCa(a,b,d,e,4,g);g=f+64|0;YEi(a+224|0,f|0,c[g>>2]<<3|0)|0;c[a+288>>2]=c[g>>2];g=a+304|0;e=f+80|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];YEi(a+336|0,f+112|0,416)|0;e=a+752|0;a=f+528|0;f=e+48|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(f|0));i=h;return}function VCa(a,b){a=a|0;b=b|0;var d=0;d=a+528|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function WCa(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=(b+3|0)>>>2;e=UJa(c,(OCa(d)|0)+768|0,504e3,79)|0;if(e)QDa(e);PCa(e,e+768|0,d,b)|0;a[e+113>>0]=1;i=c;return e|0}function XCa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;QCa(a,b,d,e,g,0);g=f+64|0;YEi(a+224|0,f|0,c[g>>2]<<3|0)|0;c[a+288>>2]=c[g>>2];g=a+304|0;e=f+80|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];YEi(a+336|0,f+112|0,416)|0;e=a+752|0;a=f+528|0;c[e+0>>2]=c[a+0>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];i=h;return}function YCa(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=(b+3|0)>>>2;f=UJa(d,(OCa(e)|0)+768|0,504088,62)|0;if(f)RDa(f);PCa(f,f+768|0,e,b)|0;a[f+113>>0]=2;c[f+752>>2]=0;i=d;return f|0}function ZCa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;QCa(a,b,d,e,g,0);g=f+64|0;YEi(a+224|0,f|0,c[g>>2]<<3|0)|0;c[a+288>>2]=c[g>>2];g=a+304|0;e=f+80|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];YEi(a+336|0,f+112|0,416)|0;i=h;return}function _Ca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;b=i;i=i+1120|0;d=b+1056|0;e=b+864|0;f=b+64|0;g=b+448|0;h=b+512|0;j=b+128|0;k=b+160|0;l=b+192|0;m=b+224|0;n=b+256|0;o=b+288|0;p=b+320|0;q=b+352|0;r=b+832|0;s=b+896|0;t=b+960|0;u=b+1024|0;v=b+1088|0;w=b+544|0;x=b+576|0;y=b+608|0;z=b+640|0;A=b+672|0;B=b+704|0;C=b+736|0;D=b+96|0;E=b+32|0;F=b;G=b+768|0;H=b+384|0;I=b+800|0;J=b+416|0;K=b+928|0;L=b+480|0;M=b+992|0;c[d+0>>2]=c[128594];c[d+4>>2]=c[128595];c[d+8>>2]=c[128596];c[d+12>>2]=c[128597];c[d+16>>2]=c[128598];c[d+20>>2]=c[128599];c[d+24>>2]=c[128600];c[d+28>>2]=c[128601];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[128606];c[e+4>>2]=c[128607];c[e+8>>2]=c[128608];c[e+12>>2]=c[128609];c[e+16>>2]=c[128610];c[e+20>>2]=c[128611];c[e+24>>2]=c[128612];c[e+28>>2]=c[128613];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[128618];c[f+4>>2]=c[128619];c[f+8>>2]=c[128620];c[f+12>>2]=c[128621];c[f+16>>2]=c[128622];c[f+20>>2]=c[128623];c[f+24>>2]=c[128624];c[f+28>>2]=c[128625];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[128626];c[g+4>>2]=c[128627];c[g+8>>2]=c[128628];c[g+12>>2]=c[128629];c[g+16>>2]=c[128630];c[g+20>>2]=c[128631];c[g+24>>2]=c[128632];c[g+28>>2]=c[128633];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[128586];c[h+4>>2]=c[128587];c[h+8>>2]=c[128588];c[h+12>>2]=c[128589];c[h+16>>2]=c[128590];c[h+20>>2]=c[128591];c[h+24>>2]=c[128592];c[h+28>>2]=c[128593];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[126054];c[j+4>>2]=c[126055];c[j+8>>2]=c[126056];c[j+12>>2]=c[126057];c[j+16>>2]=c[126058];c[j+20>>2]=c[126059];c[j+24>>2]=c[126060];c[j+28>>2]=c[126061];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[126068];c[k+4>>2]=c[126069];c[k+8>>2]=c[126070];c[k+12>>2]=c[126071];c[k+16>>2]=c[126072];c[k+20>>2]=c[126073];c[k+24>>2]=c[126074];c[k+28>>2]=c[126075];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[126086];c[l+4>>2]=c[126087];c[l+8>>2]=c[126088];c[l+12>>2]=c[126089];c[l+16>>2]=c[126090];c[l+20>>2]=c[126091];c[l+24>>2]=c[126092];c[l+28>>2]=c[126093];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[126098];c[m+4>>2]=c[126099];c[m+8>>2]=c[126100];c[m+12>>2]=c[126101];c[m+16>>2]=c[126102];c[m+20>>2]=c[126103];c[m+24>>2]=c[126104];c[m+28>>2]=c[126105];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[126110];c[n+4>>2]=c[126111];c[n+8>>2]=c[126112];c[n+12>>2]=c[126113];c[n+16>>2]=c[126114];c[n+20>>2]=c[126115];c[n+24>>2]=c[126116];c[n+28>>2]=c[126117];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[126122];c[o+4>>2]=c[126123];c[o+8>>2]=c[126124];c[o+12>>2]=c[126125];c[o+16>>2]=c[126126];c[o+20>>2]=c[126127];c[o+24>>2]=c[126128];c[o+28>>2]=c[126129];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[126138];c[p+4>>2]=c[126139];c[p+8>>2]=c[126140];c[p+12>>2]=c[126141];c[p+16>>2]=c[126142];c[p+20>>2]=c[126143];c[p+24>>2]=c[126144];c[p+28>>2]=c[126145];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[126156];c[q+4>>2]=c[126157];c[q+8>>2]=c[126158];c[q+12>>2]=c[126159];c[q+16>>2]=c[126160];c[q+20>>2]=c[126161];c[q+24>>2]=c[126162];c[q+28>>2]=c[126163];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[126176];c[r+4>>2]=c[126177];c[r+8>>2]=c[126178];c[r+12>>2]=c[126179];c[r+16>>2]=c[126180];c[r+20>>2]=c[126181];c[r+24>>2]=c[126182];c[r+28>>2]=c[126183];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[126188];c[s+4>>2]=c[126189];c[s+8>>2]=c[126190];c[s+12>>2]=c[126191];c[s+16>>2]=c[126192];c[s+20>>2]=c[126193];c[s+24>>2]=c[126194];c[s+28>>2]=c[126195];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t+0>>2]=c[126200];c[t+4>>2]=c[126201];c[t+8>>2]=c[126202];c[t+12>>2]=c[126203];c[t+16>>2]=c[126204];c[t+20>>2]=c[126205];c[t+24>>2]=c[126206];c[t+28>>2]=c[126207];xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[126214];c[u+4>>2]=c[126215];c[u+8>>2]=c[126216];c[u+12>>2]=c[126217];c[u+16>>2]=c[126218];c[u+20>>2]=c[126219];c[u+24>>2]=c[126220];c[u+28>>2]=c[126221];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[126224];c[v+4>>2]=c[126225];c[v+8>>2]=c[126226];c[v+12>>2]=c[126227];c[v+16>>2]=c[126228];c[v+20>>2]=c[126229];c[v+24>>2]=c[126230];c[v+28>>2]=c[126231];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;c[w+0>>2]=c[126236];c[w+4>>2]=c[126237];c[w+8>>2]=c[126238];c[w+12>>2]=c[126239];c[w+16>>2]=c[126240];c[w+20>>2]=c[126241];c[w+24>>2]=c[126242];c[w+28>>2]=c[126243];xo[c[c[a>>2]>>2]&2047](a,w,32)|0;c[x+0>>2]=c[126248];c[x+4>>2]=c[126249];c[x+8>>2]=c[126250];c[x+12>>2]=c[126251];c[x+16>>2]=c[126252];c[x+20>>2]=c[126253];c[x+24>>2]=c[126254];c[x+28>>2]=c[126255];xo[c[c[a>>2]>>2]&2047](a,x,32)|0;c[y+0>>2]=c[126260];c[y+4>>2]=c[126261];c[y+8>>2]=c[126262];c[y+12>>2]=c[126263];c[y+16>>2]=c[126264];c[y+20>>2]=c[126265];c[y+24>>2]=c[126266];c[y+28>>2]=c[126267];xo[c[c[a>>2]>>2]&2047](a,y,32)|0;c[z+0>>2]=c[126270];c[z+4>>2]=c[126271];c[z+8>>2]=c[126272];c[z+12>>2]=c[126273];c[z+16>>2]=c[126274];c[z+20>>2]=c[126275];c[z+24>>2]=c[126276];c[z+28>>2]=c[126277];xo[c[c[a>>2]>>2]&2047](a,z,32)|0;c[A+0>>2]=c[126284];c[A+4>>2]=c[126285];c[A+8>>2]=c[126286];c[A+12>>2]=c[126287];c[A+16>>2]=c[126288];c[A+20>>2]=c[126289];c[A+24>>2]=c[126290];c[A+28>>2]=c[126291];xo[c[c[a>>2]>>2]&2047](a,A,32)|0;c[B+0>>2]=c[126296];c[B+4>>2]=c[126297];c[B+8>>2]=c[126298];c[B+12>>2]=c[126299];c[B+16>>2]=c[126300];c[B+20>>2]=c[126301];c[B+24>>2]=c[126302];c[B+28>>2]=c[126303];xo[c[c[a>>2]>>2]&2047](a,B,32)|0;c[C+0>>2]=c[126308];c[C+4>>2]=c[126309];c[C+8>>2]=c[126310];c[C+12>>2]=c[126311];c[C+16>>2]=c[126312];c[C+20>>2]=c[126313];c[C+24>>2]=c[126314];c[C+28>>2]=c[126315];xo[c[c[a>>2]>>2]&2047](a,C,32)|0;c[D+0>>2]=c[126322];c[D+4>>2]=c[126323];c[D+8>>2]=c[126324];c[D+12>>2]=c[126325];c[D+16>>2]=c[126326];c[D+20>>2]=c[126327];c[D+24>>2]=c[126328];c[D+28>>2]=c[126329];xo[c[c[a>>2]>>2]&2047](a,D,32)|0;c[E+0>>2]=c[126332];c[E+4>>2]=c[126333];c[E+8>>2]=c[126334];c[E+12>>2]=c[126335];c[E+16>>2]=c[126336];c[E+20>>2]=c[126337];c[E+24>>2]=c[126338];c[E+28>>2]=c[126339];xo[c[c[a>>2]>>2]&2047](a,E,32)|0;c[F+0>>2]=c[126346];c[F+4>>2]=c[126347];c[F+8>>2]=c[126348];c[F+12>>2]=c[126349];c[F+16>>2]=c[126350];c[F+20>>2]=c[126351];c[F+24>>2]=c[126352];c[F+28>>2]=c[126353];xo[c[c[a>>2]>>2]&2047](a,F,32)|0;c[G+0>>2]=c[126358];c[G+4>>2]=c[126359];c[G+8>>2]=c[126360];c[G+12>>2]=c[126361];c[G+16>>2]=c[126362];c[G+20>>2]=c[126363];c[G+24>>2]=c[126364];c[G+28>>2]=c[126365];xo[c[c[a>>2]>>2]&2047](a,G,32)|0;c[H+0>>2]=c[126370];c[H+4>>2]=c[126371];c[H+8>>2]=c[126372];c[H+12>>2]=c[126373];c[H+16>>2]=c[126374];c[H+20>>2]=c[126375];c[H+24>>2]=c[126376];c[H+28>>2]=c[126377];xo[c[c[a>>2]>>2]&2047](a,H,32)|0;c[I+0>>2]=c[126384];c[I+4>>2]=c[126385];c[I+8>>2]=c[126386];c[I+12>>2]=c[126387];c[I+16>>2]=c[126388];c[I+20>>2]=c[126389];c[I+24>>2]=c[126390];c[I+28>>2]=c[126391];xo[c[c[a>>2]>>2]&2047](a,I,32)|0;c[J+0>>2]=c[126394];c[J+4>>2]=c[126395];c[J+8>>2]=c[126396];c[J+12>>2]=c[126397];c[J+16>>2]=c[126398];c[J+20>>2]=c[126399];c[J+24>>2]=c[126400];c[J+28>>2]=c[126401];xo[c[c[a>>2]>>2]&2047](a,J,32)|0;c[K+0>>2]=c[126404];c[K+4>>2]=c[126405];c[K+8>>2]=c[126406];c[K+12>>2]=c[126407];c[K+16>>2]=c[126408];c[K+20>>2]=c[126409];c[K+24>>2]=c[126410];c[K+28>>2]=c[126411];xo[c[c[a>>2]>>2]&2047](a,K,32)|0;c[L+0>>2]=c[126414];c[L+4>>2]=c[126415];c[L+8>>2]=c[126416];c[L+12>>2]=c[126417];c[L+16>>2]=c[126418];c[L+20>>2]=c[126419];c[L+24>>2]=c[126420];c[L+28>>2]=c[126421];xo[c[c[a>>2]>>2]&2047](a,L,32)|0;c[M+0>>2]=c[126426];c[M+4>>2]=c[126427];c[M+8>>2]=c[126428];c[M+12>>2]=c[126429];c[M+16>>2]=c[126430];c[M+20>>2]=c[126431];c[M+24>>2]=c[126432];c[M+28>>2]=c[126433];xo[c[c[a>>2]>>2]&2047](a,M,32)|0;i=b;return}function $Ca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+448|0;d=b+192|0;e=b+160|0;f=b+352|0;g=b+288|0;h=b+256|0;j=b+320|0;k=b+384|0;l=b+416|0;m=b+64|0;n=b+32|0;o=b+224|0;p=b+96|0;q=b;r=b+128|0;c[d+0>>2]=c[126440];c[d+4>>2]=c[126441];c[d+8>>2]=c[126442];c[d+12>>2]=c[126443];c[d+16>>2]=c[126444];c[d+20>>2]=c[126445];c[d+24>>2]=c[126446];c[d+28>>2]=c[126447];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[126454];c[e+4>>2]=c[126455];c[e+8>>2]=c[126456];c[e+12>>2]=c[126457];c[e+16>>2]=c[126458];c[e+20>>2]=c[126459];c[e+24>>2]=c[126460];c[e+28>>2]=c[126461];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[126468];c[f+4>>2]=c[126469];c[f+8>>2]=c[126470];c[f+12>>2]=c[126471];c[f+16>>2]=c[126472];c[f+20>>2]=c[126473];c[f+24>>2]=c[126474];c[f+28>>2]=c[126475];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[126480];c[g+4>>2]=c[126481];c[g+8>>2]=c[126482];c[g+12>>2]=c[126483];c[g+16>>2]=c[126484];c[g+20>>2]=c[126485];c[g+24>>2]=c[126486];c[g+28>>2]=c[126487];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[126494];c[h+4>>2]=c[126495];c[h+8>>2]=c[126496];c[h+12>>2]=c[126497];c[h+16>>2]=c[126498];c[h+20>>2]=c[126499];c[h+24>>2]=c[126500];c[h+28>>2]=c[126501];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[126506];c[j+4>>2]=c[126507];c[j+8>>2]=c[126508];c[j+12>>2]=c[126509];c[j+16>>2]=c[126510];c[j+20>>2]=c[126511];c[j+24>>2]=c[126512];c[j+28>>2]=c[126513];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[126518];c[k+4>>2]=c[126519];c[k+8>>2]=c[126520];c[k+12>>2]=c[126521];c[k+16>>2]=c[126522];c[k+20>>2]=c[126523];c[k+24>>2]=c[126524];c[k+28>>2]=c[126525];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[126530];c[l+4>>2]=c[126531];c[l+8>>2]=c[126532];c[l+12>>2]=c[126533];c[l+16>>2]=c[126534];c[l+20>>2]=c[126535];c[l+24>>2]=c[126536];c[l+28>>2]=c[126537];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[126542];c[m+4>>2]=c[126543];c[m+8>>2]=c[126544];c[m+12>>2]=c[126545];c[m+16>>2]=c[126546];c[m+20>>2]=c[126547];c[m+24>>2]=c[126548];c[m+28>>2]=c[126549];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[126556];c[n+4>>2]=c[126557];c[n+8>>2]=c[126558];c[n+12>>2]=c[126559];c[n+16>>2]=c[126560];c[n+20>>2]=c[126561];c[n+24>>2]=c[126562];c[n+28>>2]=c[126563];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[126564];c[o+4>>2]=c[126565];c[o+8>>2]=c[126566];c[o+12>>2]=c[126567];c[o+16>>2]=c[126568];c[o+20>>2]=c[126569];c[o+24>>2]=c[126570];c[o+28>>2]=c[126571];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[126572];c[p+4>>2]=c[126573];c[p+8>>2]=c[126574];c[p+12>>2]=c[126575];c[p+16>>2]=c[126576];c[p+20>>2]=c[126577];c[p+24>>2]=c[126578];c[p+28>>2]=c[126579];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q>>2]=517936;c[q+4>>2]=506320;c[q+8>>2]=0;c[q+12>>2]=224;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=1;c[q+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[126588];c[r+4>>2]=c[126589];c[r+8>>2]=c[126590];c[r+12>>2]=c[126591];c[r+16>>2]=c[126592];c[r+20>>2]=c[126593];c[r+24>>2]=c[126594];c[r+28>>2]=c[126595];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;i=b;return}function aDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+576|0;d=b+256|0;e=b+192|0;f=b+352|0;g=b+480|0;h=b+96|0;j=b+320|0;k=b+384|0;l=b+448|0;m=b+512|0;n=b+544|0;o=b+64|0;p=b+32|0;q=b;r=b+288|0;s=b+128|0;t=b+160|0;u=b+416|0;v=b+224|0;c[d+0>>2]=c[126604];c[d+4>>2]=c[126605];c[d+8>>2]=c[126606];c[d+12>>2]=c[126607];c[d+16>>2]=c[126608];c[d+20>>2]=c[126609];c[d+24>>2]=c[126610];c[d+28>>2]=c[126611];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[126616];c[e+4>>2]=c[126617];c[e+8>>2]=c[126618];c[e+12>>2]=c[126619];c[e+16>>2]=c[126620];c[e+20>>2]=c[126621];c[e+24>>2]=c[126622];c[e+28>>2]=c[126623];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[126630];c[f+4>>2]=c[126631];c[f+8>>2]=c[126632];c[f+12>>2]=c[126633];c[f+16>>2]=c[126634];c[f+20>>2]=c[126635];c[f+24>>2]=c[126636];c[f+28>>2]=c[126637];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[126644];c[g+4>>2]=c[126645];c[g+8>>2]=c[126646];c[g+12>>2]=c[126647];c[g+16>>2]=c[126648];c[g+20>>2]=c[126649];c[g+24>>2]=c[126650];c[g+28>>2]=c[126651];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[126656];c[h+4>>2]=c[126657];c[h+8>>2]=c[126658];c[h+12>>2]=c[126659];c[h+16>>2]=c[126660];c[h+20>>2]=c[126661];c[h+24>>2]=c[126662];c[h+28>>2]=c[126663];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[126668];c[j+4>>2]=c[126669];c[j+8>>2]=c[126670];c[j+12>>2]=c[126671];c[j+16>>2]=c[126672];c[j+20>>2]=c[126673];c[j+24>>2]=c[126674];c[j+28>>2]=c[126675];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[126680];c[k+4>>2]=c[126681];c[k+8>>2]=c[126682];c[k+12>>2]=c[126683];c[k+16>>2]=c[126684];c[k+20>>2]=c[126685];c[k+24>>2]=c[126686];c[k+28>>2]=c[126687];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[126690];c[l+4>>2]=c[126691];c[l+8>>2]=c[126692];c[l+12>>2]=c[126693];c[l+16>>2]=c[126694];c[l+20>>2]=c[126695];c[l+24>>2]=c[126696];c[l+28>>2]=c[126697];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[126698];c[m+4>>2]=c[126699];c[m+8>>2]=c[126700];c[m+12>>2]=c[126701];c[m+16>>2]=c[126702];c[m+20>>2]=c[126703];c[m+24>>2]=c[126704];c[m+28>>2]=c[126705];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[126714];c[n+4>>2]=c[126715];c[n+8>>2]=c[126716];c[n+12>>2]=c[126717];c[n+16>>2]=c[126718];c[n+20>>2]=c[126719];c[n+24>>2]=c[126720];c[n+28>>2]=c[126721];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[126726];c[o+4>>2]=c[126727];c[o+8>>2]=c[126728];c[o+12>>2]=c[126729];c[o+16>>2]=c[126730];c[o+20>>2]=c[126731];c[o+24>>2]=c[126732];c[o+28>>2]=c[126733];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[126738];c[p+4>>2]=c[126739];c[p+8>>2]=c[126740];c[p+12>>2]=c[126741];c[p+16>>2]=c[126742];c[p+20>>2]=c[126743];c[p+24>>2]=c[126744];c[p+28>>2]=c[126745];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[126750];c[q+4>>2]=c[126751];c[q+8>>2]=c[126752];c[q+12>>2]=c[126753];c[q+16>>2]=c[126754];c[q+20>>2]=c[126755];c[q+24>>2]=c[126756];c[q+28>>2]=c[126757];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[126762];c[r+4>>2]=c[126763];c[r+8>>2]=c[126764];c[r+12>>2]=c[126765];c[r+16>>2]=c[126766];c[r+20>>2]=c[126767];c[r+24>>2]=c[126768];c[r+28>>2]=c[126769];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[126776];c[s+4>>2]=c[126777];c[s+8>>2]=c[126778];c[s+12>>2]=c[126779];c[s+16>>2]=c[126780];c[s+20>>2]=c[126781];c[s+24>>2]=c[126782];c[s+28>>2]=c[126783];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t>>2]=507080;c[t+4>>2]=505512;c[t+8>>2]=0;c[t+12>>2]=576;c[t+16>>2]=0;c[t+20>>2]=0;c[t+24>>2]=1;c[t+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[126786];c[u+4>>2]=c[126787];c[u+8>>2]=c[126788];c[u+12>>2]=c[126789];c[u+16>>2]=c[126790];c[u+20>>2]=c[126791];c[u+24>>2]=c[126792];c[u+28>>2]=c[126793];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[126800];c[v+4>>2]=c[126801];c[v+8>>2]=c[126802];c[v+12>>2]=c[126803];c[v+16>>2]=c[126804];c[v+20>>2]=c[126805];c[v+24>>2]=c[126806];c[v+28>>2]=c[126807];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;i=b;return}function bDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+576|0;d=b+256|0;e=b+192|0;f=b+352|0;g=b+480|0;h=b+96|0;j=b+320|0;k=b+384|0;l=b+448|0;m=b+512|0;n=b+544|0;o=b+64|0;p=b+32|0;q=b;r=b+288|0;s=b+128|0;t=b+160|0;u=b+416|0;v=b+224|0;$Ca(a);cDa(a);_Ca(a);c[d+0>>2]=c[126892];c[d+4>>2]=c[126893];c[d+8>>2]=c[126894];c[d+12>>2]=c[126895];c[d+16>>2]=c[126896];c[d+20>>2]=c[126897];c[d+24>>2]=c[126898];c[d+28>>2]=c[126899];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e>>2]=515832;c[e+4>>2]=506320;c[e+8>>2]=0;c[e+12>>2]=144;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=1;c[e+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[126904];c[f+4>>2]=c[126905];c[f+8>>2]=c[126906];c[f+12>>2]=c[126907];c[f+16>>2]=c[126908];c[f+20>>2]=c[126909];c[f+24>>2]=c[126910];c[f+28>>2]=c[126911];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[126916];c[g+4>>2]=c[126917];c[g+8>>2]=c[126918];c[g+12>>2]=c[126919];c[g+16>>2]=c[126920];c[g+20>>2]=c[126921];c[g+24>>2]=c[126922];c[g+28>>2]=c[126923];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[126928];c[h+4>>2]=c[126929];c[h+8>>2]=c[126930];c[h+12>>2]=c[126931];c[h+16>>2]=c[126932];c[h+20>>2]=c[126933];c[h+24>>2]=c[126934];c[h+28>>2]=c[126935];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[126936];c[j+4>>2]=c[126937];c[j+8>>2]=c[126938];c[j+12>>2]=c[126939];c[j+16>>2]=c[126940];c[j+20>>2]=c[126941];c[j+24>>2]=c[126942];c[j+28>>2]=c[126943];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[126944];c[k+4>>2]=c[126945];c[k+8>>2]=c[126946];c[k+12>>2]=c[126947];c[k+16>>2]=c[126948];c[k+20>>2]=c[126949];c[k+24>>2]=c[126950];c[k+28>>2]=c[126951];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[126952];c[l+4>>2]=c[126953];c[l+8>>2]=c[126954];c[l+12>>2]=c[126955];c[l+16>>2]=c[126956];c[l+20>>2]=c[126957];c[l+24>>2]=c[126958];c[l+28>>2]=c[126959];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[126952];c[m+4>>2]=c[126953];c[m+8>>2]=c[126954];c[m+12>>2]=c[126955];c[m+16>>2]=c[126956];c[m+20>>2]=c[126957];c[m+24>>2]=c[126958];c[m+28>>2]=c[126959];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[126952];c[n+4>>2]=c[126953];c[n+8>>2]=c[126954];c[n+12>>2]=c[126955];c[n+16>>2]=c[126956];c[n+20>>2]=c[126957];c[n+24>>2]=c[126958];c[n+28>>2]=c[126959];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[126960];c[o+4>>2]=c[126961];c[o+8>>2]=c[126962];c[o+12>>2]=c[126963];c[o+16>>2]=c[126964];c[o+20>>2]=c[126965];c[o+24>>2]=c[126966];c[o+28>>2]=c[126967];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[126960];c[p+4>>2]=c[126961];c[p+8>>2]=c[126962];c[p+12>>2]=c[126963];c[p+16>>2]=c[126964];c[p+20>>2]=c[126965];c[p+24>>2]=c[126966];c[p+28>>2]=c[126967];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[126960];c[q+4>>2]=c[126961];c[q+8>>2]=c[126962];c[q+12>>2]=c[126963];c[q+16>>2]=c[126964];c[q+20>>2]=c[126965];c[q+24>>2]=c[126966];c[q+28>>2]=c[126967];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[126960];c[r+4>>2]=c[126961];c[r+8>>2]=c[126962];c[r+12>>2]=c[126963];c[r+16>>2]=c[126964];c[r+20>>2]=c[126965];c[r+24>>2]=c[126966];c[r+28>>2]=c[126967];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[126968];c[s+4>>2]=c[126969];c[s+8>>2]=c[126970];c[s+12>>2]=c[126971];c[s+16>>2]=c[126972];c[s+20>>2]=c[126973];c[s+24>>2]=c[126974];c[s+28>>2]=c[126975];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t+0>>2]=c[126968];c[t+4>>2]=c[126969];c[t+8>>2]=c[126970];c[t+12>>2]=c[126971];c[t+16>>2]=c[126972];c[t+20>>2]=c[126973];c[t+24>>2]=c[126974];c[t+28>>2]=c[126975];xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[126968];c[u+4>>2]=c[126969];c[u+8>>2]=c[126970];c[u+12>>2]=c[126971];c[u+16>>2]=c[126972];c[u+20>>2]=c[126973];c[u+24>>2]=c[126974];c[u+28>>2]=c[126975];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[126968];c[v+4>>2]=c[126969];c[v+8>>2]=c[126970];c[v+12>>2]=c[126971];c[v+16>>2]=c[126972];c[v+20>>2]=c[126973];c[v+24>>2]=c[126974];c[v+28>>2]=c[126975];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;i=b;return}function cDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+288|0;d=b+224|0;e=b+128|0;f=b+32|0;g=b+64|0;h=b+256|0;j=b;k=b+96|0;l=b+192|0;m=b+160|0;mDa(a);oDa(a);c[d+0>>2]=c[127472];c[d+4>>2]=c[127473];c[d+8>>2]=c[127474];c[d+12>>2]=c[127475];c[d+16>>2]=c[127476];c[d+20>>2]=c[127477];c[d+24>>2]=c[127478];c[d+28>>2]=c[127479];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e>>2]=506320;c[e+4>>2]=543872;c[e+8>>2]=0;c[e+12>>2]=128;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=1;c[e+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[127484];c[f+4>>2]=c[127485];c[f+8>>2]=c[127486];c[f+12>>2]=c[127487];c[f+16>>2]=c[127488];c[f+20>>2]=c[127489];c[f+24>>2]=c[127490];c[f+28>>2]=c[127491];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[127496];c[g+4>>2]=c[127497];c[g+8>>2]=c[127498];c[g+12>>2]=c[127499];c[g+16>>2]=c[127500];c[g+20>>2]=c[127501];c[g+24>>2]=c[127502];c[g+28>>2]=c[127503];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[127506];c[h+4>>2]=c[127507];c[h+8>>2]=c[127508];c[h+12>>2]=c[127509];c[h+16>>2]=c[127510];c[h+20>>2]=c[127511];c[h+24>>2]=c[127512];c[h+28>>2]=c[127513];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[127520];c[j+4>>2]=c[127521];c[j+8>>2]=c[127522];c[j+12>>2]=c[127523];c[j+16>>2]=c[127524];c[j+20>>2]=c[127525];c[j+24>>2]=c[127526];c[j+28>>2]=c[127527];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[127536];c[k+4>>2]=c[127537];c[k+8>>2]=c[127538];c[k+12>>2]=c[127539];c[k+16>>2]=c[127540];c[k+20>>2]=c[127541];c[k+24>>2]=c[127542];c[k+28>>2]=c[127543];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[127544];c[l+4>>2]=c[127545];c[l+8>>2]=c[127546];c[l+12>>2]=c[127547];c[l+16>>2]=c[127548];c[l+20>>2]=c[127549];c[l+24>>2]=c[127550];c[l+28>>2]=c[127551];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[127552];c[m+4>>2]=c[127553];c[m+8>>2]=c[127554];c[m+12>>2]=c[127555];c[m+16>>2]=c[127556];c[m+20>>2]=c[127557];c[m+24>>2]=c[127558];c[m+28>>2]=c[127559];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;i=b;return}function dDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+44|0;f=gFa(c[e>>2]|0)|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+40>>2]|0,f);f=c[e>>2]<<4;In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+128>>2]|0,f);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+132>>2]|0,f);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+136>>2]|0,f);i=d;return}function eDa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=gFa(c[a+44>>2]|0)|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+40>>2]|0,e);i=d;return}function fDa(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a>>2]|0;if(!f)g=0;else{b[f+6>>1]=2;c[f>>2]=514104;g=f}c[a>>2]=f+144;f=g+44|0;a=gFa(c[f>>2]|0)|0;h=d+4|0;j=(c[h>>2]|0)+15&-16;c[h>>2]=j+a;hFa(g,j,c[f>>2]|0,c[g+48>>2]|0,0)|0;j=(c[h>>2]|0)+15&-16;a=c[f>>2]<<4;c[h>>2]=j+a;c[g+128>>2]=j;j=c[h>>2]|0;c[h>>2]=j+a;c[g+132>>2]=j;j=c[h>>2]|0;c[h>>2]=j+a;c[g+136>>2]=j;lFa(g,d);i=e;return g|0}function gDa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+96|0;d=b+64|0;e=b+32|0;f=b;$Ca(a);cDa(a);_Ca(a);aDa(a);c[d+0>>2]=c[126976];c[d+4>>2]=c[126977];c[d+8>>2]=c[126978];c[d+12>>2]=c[126979];c[d+16>>2]=c[126980];c[d+20>>2]=c[126981];c[d+24>>2]=c[126982];c[d+28>>2]=c[126983];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e>>2]=515808;c[e+4>>2]=517936;c[e+8>>2]=0;c[e+12>>2]=800;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=1;c[e+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[126988];c[f+4>>2]=c[126989];c[f+8>>2]=c[126990];c[f+12>>2]=c[126991];c[f+16>>2]=c[126992];c[f+20>>2]=c[126993];c[f+24>>2]=c[126994];c[f+28>>2]=c[126995];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;i=b;return}function hDa(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a>>2]|0;if(!f)g=0;else{b[f+6>>1]=2;c[f>>2]=514224;g=f}c[a>>2]=f+800;f=g+44|0;a=gFa(c[f>>2]|0)|0;h=d+4|0;j=(c[h>>2]|0)+15&-16;c[h>>2]=j+a;hFa(g,j,c[f>>2]|0,c[g+48>>2]|0,0)|0;lFa(g,d);i=e;return g|0}function iDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+352|0;d=b+288|0;e=b+128|0;f=b;g=b+224|0;h=b+256|0;j=b+320|0;k=b+96|0;l=b+192|0;m=b+160|0;n=b+64|0;o=b+32|0;c[d+0>>2]=c[126816];c[d+4>>2]=c[126817];c[d+8>>2]=c[126818];c[d+12>>2]=c[126819];c[d+16>>2]=c[126820];c[d+20>>2]=c[126821];c[d+24>>2]=c[126822];c[d+28>>2]=c[126823];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[126828];c[e+4>>2]=c[126829];c[e+8>>2]=c[126830];c[e+12>>2]=c[126831];c[e+16>>2]=c[126832];c[e+20>>2]=c[126833];c[e+24>>2]=c[126834];c[e+28>>2]=c[126835];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[126840];c[f+4>>2]=c[126841];c[f+8>>2]=c[126842];c[f+12>>2]=c[126843];c[f+16>>2]=c[126844];c[f+20>>2]=c[126845];c[f+24>>2]=c[126846];c[f+28>>2]=c[126847];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[126854];c[g+4>>2]=c[126855];c[g+8>>2]=c[126856];c[g+12>>2]=c[126857];c[g+16>>2]=c[126858];c[g+20>>2]=c[126859];c[g+24>>2]=c[126860];c[g+28>>2]=c[126861];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[126862];c[h+4>>2]=c[126863];c[h+8>>2]=c[126864];c[h+12>>2]=c[126865];c[h+16>>2]=c[126866];c[h+20>>2]=c[126867];c[h+24>>2]=c[126868];c[h+28>>2]=c[126869];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[126876];c[j+4>>2]=c[126877];c[j+8>>2]=c[126878];c[j+12>>2]=c[126879];c[j+16>>2]=c[126880];c[j+20>>2]=c[126881];c[j+24>>2]=c[126882];c[j+28>>2]=c[126883];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k>>2]=507480;c[k+4>>2]=505512;c[k+8>>2]=0;c[k+12>>2]=544;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=1;c[k+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[126884];c[l+4>>2]=c[126885];c[l+8>>2]=c[126886];c[l+12>>2]=c[126887];c[l+16>>2]=c[126888];c[l+20>>2]=c[126889];c[l+24>>2]=c[126890];c[l+28>>2]=c[126891];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[126996];c[m+4>>2]=c[126997];c[m+8>>2]=c[126998];c[m+12>>2]=c[126999];c[m+16>>2]=c[127e3];c[m+20>>2]=c[127001];c[m+24>>2]=c[127002];c[m+28>>2]=c[127003];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n>>2]=515784;c[n+4>>2]=517936;c[n+8>>2]=0;c[n+12>>2]=768;c[n+16>>2]=0;c[n+20>>2]=0;c[n+24>>2]=1;c[n+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[127004];c[o+4>>2]=c[127005];c[o+8>>2]=c[127006];c[o+12>>2]=c[127007];c[o+16>>2]=c[127008];c[o+20>>2]=c[127009];c[o+24>>2]=c[127010];c[o+28>>2]=c[127011];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;i=b;return}function jDa(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a>>2]|0;if(!f)g=0;else{b[f+6>>1]=2;c[f>>2]=514184;g=f}c[a>>2]=f+768;f=g+44|0;a=gFa(c[f>>2]|0)|0;h=d+4|0;j=(c[h>>2]|0)+15&-16;c[h>>2]=j+a;hFa(g,j,c[f>>2]|0,c[g+48>>2]|0,0)|0;lFa(g,d);i=e;return g|0}function kDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+160|0;d=b+128|0;e=b+96|0;f=b+64|0;g=b+32|0;h=b;c[d+0>>2]=c[127012];c[d+4>>2]=c[127013];c[d+8>>2]=c[127014];c[d+12>>2]=c[127015];c[d+16>>2]=c[127016];c[d+20>>2]=c[127017];c[d+24>>2]=c[127018];c[d+28>>2]=c[127019];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e>>2]=515760;c[e+4>>2]=517936;c[e+8>>2]=0;c[e+12>>2]=768;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=1;c[e+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[127020];c[f+4>>2]=c[127021];c[f+8>>2]=c[127022];c[f+12>>2]=c[127023];c[f+16>>2]=c[127024];c[f+20>>2]=c[127025];c[f+24>>2]=c[127026];c[f+28>>2]=c[127027];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[127032];c[g+4>>2]=c[127033];c[g+8>>2]=c[127034];c[g+12>>2]=c[127035];c[g+16>>2]=c[127036];c[g+20>>2]=c[127037];c[g+24>>2]=c[127038];c[g+28>>2]=c[127039];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[127040];c[h+4>>2]=c[127041];c[h+8>>2]=c[127042];c[h+12>>2]=c[127043];c[h+16>>2]=c[127044];c[h+20>>2]=c[127045];c[h+24>>2]=c[127046];c[h+28>>2]=c[127047];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;i=b;return}function lDa(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;f=c[a>>2]|0;if(!f){h=0;j=0}else{b[f+6>>1]=2;c[f>>2]=514144;g[f+304>>2]=ea(1.0);g[f+308>>2]=ea(500.0);g[f+312>>2]=ea(600.0);g[f+316>>2]=ea(.150000006);g[f+320>>2]=ea(2.0);g[f+324>>2]=ea(.349999994);g[f+224>>2]=ea(0.0);g[f+228>>2]=ea(.800000011);g[f+232>>2]=ea(.330000013);g[f+236>>2]=ea(1.0);g[f+240>>2]=ea(1.0);g[f+244>>2]=ea(.800000011);c[f+288>>2]=3;g[f+328>>2]=ea(1.0);g[f+332>>2]=ea(.00166666671);g[f+464>>2]=ea(4.0);c[f+468>>2]=7;g[f+472>>2]=ea(.5);g[f+336>>2]=ea(-4.0);g[f+340>>2]=ea(0.0);g[f+344>>2]=ea(4.0);g[f+348>>2]=ea(2.0);g[f+352>>2]=ea(1.5);g[f+356>>2]=ea(1.10000002);g[f+360>>2]=ea(1.0);k=f+364|0;l=k+100|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));g[f+480>>2]=ea(10.0);c[f+484>>2]=1;c[f+488>>2]=5;k=0;do{g[f+(k<<2)+496>>2]=ea(.649999976);g[f+(k<<2)+624>>2]=ea(.5);k=k+1|0}while((k|0)!=32);g[f+500>>2]=ea(.150000006);g[f+624>>2]=ea(2.0);h=c[a>>2]|0;j=f}c[a>>2]=h+768;h=j+44|0;a=gFa(c[h>>2]|0)|0;f=d+4|0;k=(c[f>>2]|0)+15&-16;c[f>>2]=k+a;hFa(j,k,c[h>>2]|0,c[j+48>>2]|0,0)|0;lFa(j,d);i=e;return j|0}function mDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+576|0;d=b+256|0;e=b+192|0;f=b+352|0;g=b+480|0;h=b+96|0;j=b+320|0;k=b+384|0;l=b+448|0;m=b+512|0;n=b+544|0;o=b+64|0;p=b+32|0;q=b;r=b+288|0;s=b+128|0;t=b+160|0;u=b+416|0;v=b+224|0;nDa(a);c[d+0>>2]=c[127056];c[d+4>>2]=c[127057];c[d+8>>2]=c[127058];c[d+12>>2]=c[127059];c[d+16>>2]=c[127060];c[d+20>>2]=c[127061];c[d+24>>2]=c[127062];c[d+28>>2]=c[127063];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[127070];c[e+4>>2]=c[127071];c[e+8>>2]=c[127072];c[e+12>>2]=c[127073];c[e+16>>2]=c[127074];c[e+20>>2]=c[127075];c[e+24>>2]=c[127076];c[e+28>>2]=c[127077];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[127086];c[f+4>>2]=c[127087];c[f+8>>2]=c[127088];c[f+12>>2]=c[127089];c[f+16>>2]=c[127090];c[f+20>>2]=c[127091];c[f+24>>2]=c[127092];c[f+28>>2]=c[127093];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[127100];c[g+4>>2]=c[127101];c[g+8>>2]=c[127102];c[g+12>>2]=c[127103];c[g+16>>2]=c[127104];c[g+20>>2]=c[127105];c[g+24>>2]=c[127106];c[g+28>>2]=c[127107];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[127116];c[h+4>>2]=c[127117];c[h+8>>2]=c[127118];c[h+12>>2]=c[127119];c[h+16>>2]=c[127120];c[h+20>>2]=c[127121];c[h+24>>2]=c[127122];c[h+28>>2]=c[127123];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[127128];c[j+4>>2]=c[127129];c[j+8>>2]=c[127130];c[j+12>>2]=c[127131];c[j+16>>2]=c[127132];c[j+20>>2]=c[127133];c[j+24>>2]=c[127134];c[j+28>>2]=c[127135];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[127414];c[k+4>>2]=c[127415];c[k+8>>2]=c[127416];c[k+12>>2]=c[127417];c[k+16>>2]=c[127418];c[k+20>>2]=c[127419];c[k+24>>2]=c[127420];c[k+28>>2]=c[127421];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[127142];c[l+4>>2]=c[127143];c[l+8>>2]=c[127144];c[l+12>>2]=c[127145];c[l+16>>2]=c[127146];c[l+20>>2]=c[127147];c[l+24>>2]=c[127148];c[l+28>>2]=c[127149];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[127156];c[m+4>>2]=c[127157];c[m+8>>2]=c[127158];c[m+12>>2]=c[127159];c[m+16>>2]=c[127160];c[m+20>>2]=c[127161];c[m+24>>2]=c[127162];c[m+28>>2]=c[127163];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[127174];c[n+4>>2]=c[127175];c[n+8>>2]=c[127176];c[n+12>>2]=c[127177];c[n+16>>2]=c[127178];c[n+20>>2]=c[127179];c[n+24>>2]=c[127180];c[n+28>>2]=c[127181];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[127186];c[o+4>>2]=c[127187];c[o+8>>2]=c[127188];c[o+12>>2]=c[127189];c[o+16>>2]=c[127190];c[o+20>>2]=c[127191];c[o+24>>2]=c[127192];c[o+28>>2]=c[127193];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[127198];c[p+4>>2]=c[127199];c[p+8>>2]=c[127200];c[p+12>>2]=c[127201];c[p+16>>2]=c[127202];c[p+20>>2]=c[127203];c[p+24>>2]=c[127204];c[p+28>>2]=c[127205];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[127214];c[q+4>>2]=c[127215];c[q+8>>2]=c[127216];c[q+12>>2]=c[127217];c[q+16>>2]=c[127218];c[q+20>>2]=c[127219];c[q+24>>2]=c[127220];c[q+28>>2]=c[127221];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[127230];c[r+4>>2]=c[127231];c[r+8>>2]=c[127232];c[r+12>>2]=c[127233];c[r+16>>2]=c[127234];c[r+20>>2]=c[127235];c[r+24>>2]=c[127236];c[r+28>>2]=c[127237];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[127246];c[s+4>>2]=c[127247];c[s+8>>2]=c[127248];c[s+12>>2]=c[127249];c[s+16>>2]=c[127250];c[s+20>>2]=c[127251];c[s+24>>2]=c[127252];c[s+28>>2]=c[127253];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t+0>>2]=c[127262];c[t+4>>2]=c[127263];c[t+8>>2]=c[127264];c[t+12>>2]=c[127265];c[t+16>>2]=c[127266];c[t+20>>2]=c[127267];c[t+24>>2]=c[127268];c[t+28>>2]=c[127269];xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[127276];c[u+4>>2]=c[127277];c[u+8>>2]=c[127278];c[u+12>>2]=c[127279];c[u+16>>2]=c[127280];c[u+20>>2]=c[127281];c[u+24>>2]=c[127282];c[u+28>>2]=c[127283];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[127284];c[v+4>>2]=c[127285];c[v+8>>2]=c[127286];c[v+12>>2]=c[127287];c[v+16>>2]=c[127288];c[v+20>>2]=c[127289];c[v+24>>2]=c[127290];c[v+28>>2]=c[127291];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;i=b;return}function nDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;b=i;i=i+1568|0;d=b+1504|0;e=b+1440|0;f=b+1312|0;g=b+672|0;h=b+736|0;j=b+704|0;k=b+160|0;l=b+192|0;m=b+224|0;n=b+256|0;o=b+288|0;p=b+320|0;q=b+352|0;r=b+384|0;s=b+416|0;t=b+448|0;u=b+480|0;v=b+512|0;w=b+544|0;x=b+576|0;y=b+1280|0;z=b+1344|0;A=b+1408|0;B=b+1472|0;C=b+1536|0;D=b+768|0;E=b+800|0;F=b+832|0;G=b+864|0;H=b+896|0;I=b+928|0;J=b+960|0;K=b+992|0;L=b+1024|0;M=b+1056|0;N=b+1088|0;O=b+1120|0;P=b+1152|0;Q=b+1184|0;R=b+128|0;S=b+64|0;T=b;U=b+96|0;V=b+1216|0;W=b+32|0;X=b+608|0;Y=b+1248|0;Z=b+640|0;_=b+1376|0;c[d+0>>2]=c[127766];c[d+4>>2]=c[127767];c[d+8>>2]=c[127768];c[d+12>>2]=c[127769];c[d+16>>2]=c[127770];c[d+20>>2]=c[127771];c[d+24>>2]=c[127772];c[d+28>>2]=c[127773];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[127778];c[e+4>>2]=c[127779];c[e+8>>2]=c[127780];c[e+12>>2]=c[127781];c[e+16>>2]=c[127782];c[e+20>>2]=c[127783];c[e+24>>2]=c[127784];c[e+28>>2]=c[127785];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[127792];c[f+4>>2]=c[127793];c[f+8>>2]=c[127794];c[f+12>>2]=c[127795];c[f+16>>2]=c[127796];c[f+20>>2]=c[127797];c[f+24>>2]=c[127798];c[f+28>>2]=c[127799];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[127804];c[g+4>>2]=c[127805];c[g+8>>2]=c[127806];c[g+12>>2]=c[127807];c[g+16>>2]=c[127808];c[g+20>>2]=c[127809];c[g+24>>2]=c[127810];c[g+28>>2]=c[127811];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[127816];c[h+4>>2]=c[127817];c[h+8>>2]=c[127818];c[h+12>>2]=c[127819];c[h+16>>2]=c[127820];c[h+20>>2]=c[127821];c[h+24>>2]=c[127822];c[h+28>>2]=c[127823];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[127828];c[j+4>>2]=c[127829];c[j+8>>2]=c[127830];c[j+12>>2]=c[127831];c[j+16>>2]=c[127832];c[j+20>>2]=c[127833];c[j+24>>2]=c[127834];c[j+28>>2]=c[127835];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[127840];c[k+4>>2]=c[127841];c[k+8>>2]=c[127842];c[k+12>>2]=c[127843];c[k+16>>2]=c[127844];c[k+20>>2]=c[127845];c[k+24>>2]=c[127846];c[k+28>>2]=c[127847];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[127854];c[l+4>>2]=c[127855];c[l+8>>2]=c[127856];c[l+12>>2]=c[127857];c[l+16>>2]=c[127858];c[l+20>>2]=c[127859];c[l+24>>2]=c[127860];c[l+28>>2]=c[127861];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[127868];c[m+4>>2]=c[127869];c[m+8>>2]=c[127870];c[m+12>>2]=c[127871];c[m+16>>2]=c[127872];c[m+20>>2]=c[127873];c[m+24>>2]=c[127874];c[m+28>>2]=c[127875];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[127882];c[n+4>>2]=c[127883];c[n+8>>2]=c[127884];c[n+12>>2]=c[127885];c[n+16>>2]=c[127886];c[n+20>>2]=c[127887];c[n+24>>2]=c[127888];c[n+28>>2]=c[127889];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[127894];c[o+4>>2]=c[127895];c[o+8>>2]=c[127896];c[o+12>>2]=c[127897];c[o+16>>2]=c[127898];c[o+20>>2]=c[127899];c[o+24>>2]=c[127900];c[o+28>>2]=c[127901];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[127902];c[p+4>>2]=c[127903];c[p+8>>2]=c[127904];c[p+12>>2]=c[127905];c[p+16>>2]=c[127906];c[p+20>>2]=c[127907];c[p+24>>2]=c[127908];c[p+28>>2]=c[127909];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[127916];c[q+4>>2]=c[127917];c[q+8>>2]=c[127918];c[q+12>>2]=c[127919];c[q+16>>2]=c[127920];c[q+20>>2]=c[127921];c[q+24>>2]=c[127922];c[q+28>>2]=c[127923];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[127926];c[r+4>>2]=c[127927];c[r+8>>2]=c[127928];c[r+12>>2]=c[127929];c[r+16>>2]=c[127930];c[r+20>>2]=c[127931];c[r+24>>2]=c[127932];c[r+28>>2]=c[127933];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[127936];c[s+4>>2]=c[127937];c[s+8>>2]=c[127938];c[s+12>>2]=c[127939];c[s+16>>2]=c[127940];c[s+20>>2]=c[127941];c[s+24>>2]=c[127942];c[s+28>>2]=c[127943];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t+0>>2]=c[127946];c[t+4>>2]=c[127947];c[t+8>>2]=c[127948];c[t+12>>2]=c[127949];c[t+16>>2]=c[127950];c[t+20>>2]=c[127951];c[t+24>>2]=c[127952];c[t+28>>2]=c[127953];xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[127954];c[u+4>>2]=c[127955];c[u+8>>2]=c[127956];c[u+12>>2]=c[127957];c[u+16>>2]=c[127958];c[u+20>>2]=c[127959];c[u+24>>2]=c[127960];c[u+28>>2]=c[127961];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[127966];c[v+4>>2]=c[127967];c[v+8>>2]=c[127968];c[v+12>>2]=c[127969];c[v+16>>2]=c[127970];c[v+20>>2]=c[127971];c[v+24>>2]=c[127972];c[v+28>>2]=c[127973];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;c[w+0>>2]=c[127978];c[w+4>>2]=c[127979];c[w+8>>2]=c[127980];c[w+12>>2]=c[127981];c[w+16>>2]=c[127982];c[w+20>>2]=c[127983];c[w+24>>2]=c[127984];c[w+28>>2]=c[127985];xo[c[c[a>>2]>>2]&2047](a,w,32)|0;c[x+0>>2]=c[127992];c[x+4>>2]=c[127993];c[x+8>>2]=c[127994];c[x+12>>2]=c[127995];c[x+16>>2]=c[127996];c[x+20>>2]=c[127997];c[x+24>>2]=c[127998];c[x+28>>2]=c[127999];xo[c[c[a>>2]>>2]&2047](a,x,32)|0;c[y+0>>2]=c[128004];c[y+4>>2]=c[128005];c[y+8>>2]=c[128006];c[y+12>>2]=c[128007];c[y+16>>2]=c[128008];c[y+20>>2]=c[128009];c[y+24>>2]=c[128010];c[y+28>>2]=c[128011];xo[c[c[a>>2]>>2]&2047](a,y,32)|0;c[z+0>>2]=c[128016];c[z+4>>2]=c[128017];c[z+8>>2]=c[128018];c[z+12>>2]=c[128019];c[z+16>>2]=c[128020];c[z+20>>2]=c[128021];c[z+24>>2]=c[128022];c[z+28>>2]=c[128023];xo[c[c[a>>2]>>2]&2047](a,z,32)|0;c[A+0>>2]=c[128028];c[A+4>>2]=c[128029];c[A+8>>2]=c[128030];c[A+12>>2]=c[128031];c[A+16>>2]=c[128032];c[A+20>>2]=c[128033];c[A+24>>2]=c[128034];c[A+28>>2]=c[128035];xo[c[c[a>>2]>>2]&2047](a,A,32)|0;c[B+0>>2]=c[128036];c[B+4>>2]=c[128037];c[B+8>>2]=c[128038];c[B+12>>2]=c[128039];c[B+16>>2]=c[128040];c[B+20>>2]=c[128041];c[B+24>>2]=c[128042];c[B+28>>2]=c[128043];xo[c[c[a>>2]>>2]&2047](a,B,32)|0;c[C+0>>2]=c[128044];c[C+4>>2]=c[128045];c[C+8>>2]=c[128046];c[C+12>>2]=c[128047];c[C+16>>2]=c[128048];c[C+20>>2]=c[128049];c[C+24>>2]=c[128050];c[C+28>>2]=c[128051];xo[c[c[a>>2]>>2]&2047](a,C,32)|0;c[D+0>>2]=c[128058];c[D+4>>2]=c[128059];c[D+8>>2]=c[128060];c[D+12>>2]=c[128061];c[D+16>>2]=c[128062];c[D+20>>2]=c[128063];c[D+24>>2]=c[128064];c[D+28>>2]=c[128065];xo[c[c[a>>2]>>2]&2047](a,D,32)|0;c[E+0>>2]=c[128070];c[E+4>>2]=c[128071];c[E+8>>2]=c[128072];c[E+12>>2]=c[128073];c[E+16>>2]=c[128074];c[E+20>>2]=c[128075];c[E+24>>2]=c[128076];c[E+28>>2]=c[128077];xo[c[c[a>>2]>>2]&2047](a,E,32)|0;c[F+0>>2]=c[128082];c[F+4>>2]=c[128083];c[F+8>>2]=c[128084];c[F+12>>2]=c[128085];c[F+16>>2]=c[128086];c[F+20>>2]=c[128087];c[F+24>>2]=c[128088];c[F+28>>2]=c[128089];xo[c[c[a>>2]>>2]&2047](a,F,32)|0;c[G+0>>2]=c[128100];c[G+4>>2]=c[128101];c[G+8>>2]=c[128102];c[G+12>>2]=c[128103];c[G+16>>2]=c[128104];c[G+20>>2]=c[128105];c[G+24>>2]=c[128106];c[G+28>>2]=c[128107];xo[c[c[a>>2]>>2]&2047](a,G,32)|0;c[H+0>>2]=c[128116];c[H+4>>2]=c[128117];c[H+8>>2]=c[128118];c[H+12>>2]=c[128119];c[H+16>>2]=c[128120];c[H+20>>2]=c[128121];c[H+24>>2]=c[128122];c[H+28>>2]=c[128123];xo[c[c[a>>2]>>2]&2047](a,H,32)|0;c[I+0>>2]=c[128130];c[I+4>>2]=c[128131];c[I+8>>2]=c[128132];c[I+12>>2]=c[128133];c[I+16>>2]=c[128134];c[I+20>>2]=c[128135];c[I+24>>2]=c[128136];c[I+28>>2]=c[128137];xo[c[c[a>>2]>>2]&2047](a,I,32)|0;c[J+0>>2]=c[128138];c[J+4>>2]=c[128139];c[J+8>>2]=c[128140];c[J+12>>2]=c[128141];c[J+16>>2]=c[128142];c[J+20>>2]=c[128143];c[J+24>>2]=c[128144];c[J+28>>2]=c[128145];xo[c[c[a>>2]>>2]&2047](a,J,32)|0;c[K+0>>2]=c[128158];c[K+4>>2]=c[128159];c[K+8>>2]=c[128160];c[K+12>>2]=c[128161];c[K+16>>2]=c[128162];c[K+20>>2]=c[128163];c[K+24>>2]=c[128164];c[K+28>>2]=c[128165];xo[c[c[a>>2]>>2]&2047](a,K,32)|0;c[L+0>>2]=c[128176];c[L+4>>2]=c[128177];c[L+8>>2]=c[128178];c[L+12>>2]=c[128179];c[L+16>>2]=c[128180];c[L+20>>2]=c[128181];c[L+24>>2]=c[128182];c[L+28>>2]=c[128183];xo[c[c[a>>2]>>2]&2047](a,L,32)|0;c[M+0>>2]=c[128194];c[M+4>>2]=c[128195];c[M+8>>2]=c[128196];c[M+12>>2]=c[128197];c[M+16>>2]=c[128198];c[M+20>>2]=c[128199];c[M+24>>2]=c[128200];c[M+28>>2]=c[128201];xo[c[c[a>>2]>>2]&2047](a,M,32)|0;c[N+0>>2]=c[128202];c[N+4>>2]=c[128203];c[N+8>>2]=c[128204];c[N+12>>2]=c[128205];c[N+16>>2]=c[128206];c[N+20>>2]=c[128207];c[N+24>>2]=c[128208];c[N+28>>2]=c[128209];xo[c[c[a>>2]>>2]&2047](a,N,32)|0;c[O+0>>2]=c[128210];c[O+4>>2]=c[128211];c[O+8>>2]=c[128212];c[O+12>>2]=c[128213];c[O+16>>2]=c[128214];c[O+20>>2]=c[128215];c[O+24>>2]=c[128216];c[O+28>>2]=c[128217];xo[c[c[a>>2]>>2]&2047](a,O,32)|0;c[P+0>>2]=c[128222];c[P+4>>2]=c[128223];c[P+8>>2]=c[128224];c[P+12>>2]=c[128225];c[P+16>>2]=c[128226];c[P+20>>2]=c[128227];c[P+24>>2]=c[128228];c[P+28>>2]=c[128229];xo[c[c[a>>2]>>2]&2047](a,P,32)|0;c[Q+0>>2]=c[128232];c[Q+4>>2]=c[128233];c[Q+8>>2]=c[128234];c[Q+12>>2]=c[128235];c[Q+16>>2]=c[128236];c[Q+20>>2]=c[128237];c[Q+24>>2]=c[128238];c[Q+28>>2]=c[128239];xo[c[c[a>>2]>>2]&2047](a,Q,32)|0;c[R+0>>2]=c[128242];c[R+4>>2]=c[128243];c[R+8>>2]=c[128244];c[R+12>>2]=c[128245];c[R+16>>2]=c[128246];c[R+20>>2]=c[128247];c[R+24>>2]=c[128248];c[R+28>>2]=c[128249];xo[c[c[a>>2]>>2]&2047](a,R,32)|0;c[S+0>>2]=c[128258];c[S+4>>2]=c[128259];c[S+8>>2]=c[128260];c[S+12>>2]=c[128261];c[S+16>>2]=c[128262];c[S+20>>2]=c[128263];c[S+24>>2]=c[128264];c[S+28>>2]=c[128265];xo[c[c[a>>2]>>2]&2047](a,S,32)|0;c[T+0>>2]=c[128274];c[T+4>>2]=c[128275];c[T+8>>2]=c[128276];c[T+12>>2]=c[128277];c[T+16>>2]=c[128278];c[T+20>>2]=c[128279];c[T+24>>2]=c[128280];c[T+28>>2]=c[128281];xo[c[c[a>>2]>>2]&2047](a,T,32)|0;c[U+0>>2]=c[128290];c[U+4>>2]=c[128291];c[U+8>>2]=c[128292];c[U+12>>2]=c[128293];c[U+16>>2]=c[128294];c[U+20>>2]=c[128295];c[U+24>>2]=c[128296];c[U+28>>2]=c[128297];xo[c[c[a>>2]>>2]&2047](a,U,32)|0;c[V+0>>2]=c[128304];c[V+4>>2]=c[128305];c[V+8>>2]=c[128306];c[V+12>>2]=c[128307];c[V+16>>2]=c[128308];c[V+20>>2]=c[128309];c[V+24>>2]=c[128310];c[V+28>>2]=c[128311];xo[c[c[a>>2]>>2]&2047](a,V,32)|0;c[W+0>>2]=c[128316];c[W+4>>2]=c[128317];c[W+8>>2]=c[128318];c[W+12>>2]=c[128319];c[W+16>>2]=c[128320];c[W+20>>2]=c[128321];c[W+24>>2]=c[128322];c[W+28>>2]=c[128323];xo[c[c[a>>2]>>2]&2047](a,W,32)|0;c[X+0>>2]=c[128330];c[X+4>>2]=c[128331];c[X+8>>2]=c[128332];c[X+12>>2]=c[128333];c[X+16>>2]=c[128334];c[X+20>>2]=c[128335];c[X+24>>2]=c[128336];c[X+28>>2]=c[128337];xo[c[c[a>>2]>>2]&2047](a,X,32)|0;c[Y+0>>2]=c[128346];c[Y+4>>2]=c[128347];c[Y+8>>2]=c[128348];c[Y+12>>2]=c[128349];c[Y+16>>2]=c[128350];c[Y+20>>2]=c[128351];c[Y+24>>2]=c[128352];c[Y+28>>2]=c[128353];xo[c[c[a>>2]>>2]&2047](a,Y,32)|0;c[Z+0>>2]=c[128358];c[Z+4>>2]=c[128359];c[Z+8>>2]=c[128360];c[Z+12>>2]=c[128361];c[Z+16>>2]=c[128362];c[Z+20>>2]=c[128363];c[Z+24>>2]=c[128364];c[Z+28>>2]=c[128365];xo[c[c[a>>2]>>2]&2047](a,Z,32)|0;c[_+0>>2]=c[128366];c[_+4>>2]=c[128367];c[_+8>>2]=c[128368];c[_+12>>2]=c[128369];c[_+16>>2]=c[128370];c[_+20>>2]=c[128371];c[_+24>>2]=c[128372];c[_+28>>2]=c[128373];xo[c[c[a>>2]>>2]&2047](a,_,32)|0;i=b;return}function oDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+704|0;d=b+320|0;e=b+416|0;f=b+32|0;g=b+608|0;h=b+288|0;j=b+128|0;k=b+160|0;l=b+448|0;m=b+512|0;n=b+576|0;o=b+640|0;p=b+672|0;q=b+352|0;r=b+384|0;s=b+64|0;t=b;u=b+192|0;v=b+224|0;w=b+480|0;x=b+96|0;y=b+256|0;z=b+544|0;pDa(a);qDa(a);c[d+0>>2]=c[127300];c[d+4>>2]=c[127301];c[d+8>>2]=c[127302];c[d+12>>2]=c[127303];c[d+16>>2]=c[127304];c[d+20>>2]=c[127305];c[d+24>>2]=c[127306];c[d+28>>2]=c[127307];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[127314];c[e+4>>2]=c[127315];c[e+8>>2]=c[127316];c[e+12>>2]=c[127317];c[e+16>>2]=c[127318];c[e+20>>2]=c[127319];c[e+24>>2]=c[127320];c[e+28>>2]=c[127321];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[127324];c[f+4>>2]=c[127325];c[f+8>>2]=c[127326];c[f+12>>2]=c[127327];c[f+16>>2]=c[127328];c[f+20>>2]=c[127329];c[f+24>>2]=c[127330];c[f+28>>2]=c[127331];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[127332];c[g+4>>2]=c[127333];c[g+8>>2]=c[127334];c[g+12>>2]=c[127335];c[g+16>>2]=c[127336];c[g+20>>2]=c[127337];c[g+24>>2]=c[127338];c[g+28>>2]=c[127339];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[127346];c[h+4>>2]=c[127347];c[h+8>>2]=c[127348];c[h+12>>2]=c[127349];c[h+16>>2]=c[127350];c[h+20>>2]=c[127351];c[h+24>>2]=c[127352];c[h+28>>2]=c[127353];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[127364];c[j+4>>2]=c[127365];c[j+8>>2]=c[127366];c[j+12>>2]=c[127367];c[j+16>>2]=c[127368];c[j+20>>2]=c[127369];c[j+24>>2]=c[127370];c[j+28>>2]=c[127371];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[127378];c[k+4>>2]=c[127379];c[k+8>>2]=c[127380];c[k+12>>2]=c[127381];c[k+16>>2]=c[127382];c[k+20>>2]=c[127383];c[k+24>>2]=c[127384];c[k+28>>2]=c[127385];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[127390];c[l+4>>2]=c[127391];c[l+8>>2]=c[127392];c[l+12>>2]=c[127393];c[l+16>>2]=c[127394];c[l+20>>2]=c[127395];c[l+24>>2]=c[127396];c[l+28>>2]=c[127397];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[127398];c[m+4>>2]=c[127399];c[m+8>>2]=c[127400];c[m+12>>2]=c[127401];c[m+16>>2]=c[127402];c[m+20>>2]=c[127403];c[m+24>>2]=c[127404];c[m+28>>2]=c[127405];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[127406];c[n+4>>2]=c[127407];c[n+8>>2]=c[127408];c[n+12>>2]=c[127409];c[n+16>>2]=c[127410];c[n+20>>2]=c[127411];c[n+24>>2]=c[127412];c[n+28>>2]=c[127413];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[127414];c[o+4>>2]=c[127415];c[o+8>>2]=c[127416];c[o+12>>2]=c[127417];c[o+16>>2]=c[127418];c[o+20>>2]=c[127419];c[o+24>>2]=c[127420];c[o+28>>2]=c[127421];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[127422];c[p+4>>2]=c[127423];c[p+8>>2]=c[127424];c[p+12>>2]=c[127425];c[p+16>>2]=c[127426];c[p+20>>2]=c[127427];c[p+24>>2]=c[127428];c[p+28>>2]=c[127429];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[127430];c[q+4>>2]=c[127431];c[q+8>>2]=c[127432];c[q+12>>2]=c[127433];c[q+16>>2]=c[127434];c[q+20>>2]=c[127435];c[q+24>>2]=c[127436];c[q+28>>2]=c[127437];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[127440];c[r+4>>2]=c[127441];c[r+8>>2]=c[127442];c[r+12>>2]=c[127443];c[r+16>>2]=c[127444];c[r+20>>2]=c[127445];c[r+24>>2]=c[127446];c[r+28>>2]=c[127447];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[127440];c[s+4>>2]=c[127441];c[s+8>>2]=c[127442];c[s+12>>2]=c[127443];c[s+16>>2]=c[127444];c[s+20>>2]=c[127445];c[s+24>>2]=c[127446];c[s+28>>2]=c[127447];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t+0>>2]=c[127440];c[t+4>>2]=c[127441];c[t+8>>2]=c[127442];c[t+12>>2]=c[127443];c[t+16>>2]=c[127444];c[t+20>>2]=c[127445];c[t+24>>2]=c[127446];c[t+28>>2]=c[127447];xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[127440];c[u+4>>2]=c[127441];c[u+8>>2]=c[127442];c[u+12>>2]=c[127443];c[u+16>>2]=c[127444];c[u+20>>2]=c[127445];c[u+24>>2]=c[127446];c[u+28>>2]=c[127447];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[127448];c[v+4>>2]=c[127449];c[v+8>>2]=c[127450];c[v+12>>2]=c[127451];c[v+16>>2]=c[127452];c[v+20>>2]=c[127453];c[v+24>>2]=c[127454];c[v+28>>2]=c[127455];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;c[w+0>>2]=c[127448];c[w+4>>2]=c[127449];c[w+8>>2]=c[127450];c[w+12>>2]=c[127451];c[w+16>>2]=c[127452];c[w+20>>2]=c[127453];c[w+24>>2]=c[127454];c[w+28>>2]=c[127455];xo[c[c[a>>2]>>2]&2047](a,w,32)|0;c[x+0>>2]=c[127448];c[x+4>>2]=c[127449];c[x+8>>2]=c[127450];c[x+12>>2]=c[127451];c[x+16>>2]=c[127452];c[x+20>>2]=c[127453];c[x+24>>2]=c[127454];c[x+28>>2]=c[127455];xo[c[c[a>>2]>>2]&2047](a,x,32)|0;c[y+0>>2]=c[127448];c[y+4>>2]=c[127449];c[y+8>>2]=c[127450];c[y+12>>2]=c[127451];c[y+16>>2]=c[127452];c[y+20>>2]=c[127453];c[y+24>>2]=c[127454];c[y+28>>2]=c[127455];xo[c[c[a>>2]>>2]&2047](a,y,32)|0;c[z+0>>2]=c[127464];c[z+4>>2]=c[127465];c[z+8>>2]=c[127466];c[z+12>>2]=c[127467];c[z+16>>2]=c[127468];c[z+20>>2]=c[127469];c[z+24>>2]=c[127470];c[z+28>>2]=c[127471];xo[c[c[a>>2]>>2]&2047](a,z,32)|0;i=b;return}function pDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+352|0;d=b+288|0;e=b+128|0;f=b;g=b+224|0;h=b+256|0;j=b+320|0;k=b+96|0;l=b+192|0;m=b+160|0;n=b+64|0;o=b+32|0;c[d+0>>2]=c[128374];c[d+4>>2]=c[128375];c[d+8>>2]=c[128376];c[d+12>>2]=c[128377];c[d+16>>2]=c[128378];c[d+20>>2]=c[128379];c[d+24>>2]=c[128380];c[d+28>>2]=c[128381];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[128386];c[e+4>>2]=c[128387];c[e+8>>2]=c[128388];c[e+12>>2]=c[128389];c[e+16>>2]=c[128390];c[e+20>>2]=c[128391];c[e+24>>2]=c[128392];c[e+28>>2]=c[128393];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[128400];c[f+4>>2]=c[128401];c[f+8>>2]=c[128402];c[f+12>>2]=c[128403];c[f+16>>2]=c[128404];c[f+20>>2]=c[128405];c[f+24>>2]=c[128406];c[f+28>>2]=c[128407];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[128414];c[g+4>>2]=c[128415];c[g+8>>2]=c[128416];c[g+12>>2]=c[128417];c[g+16>>2]=c[128418];c[g+20>>2]=c[128419];c[g+24>>2]=c[128420];c[g+28>>2]=c[128421];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[128430];c[h+4>>2]=c[128431];c[h+8>>2]=c[128432];c[h+12>>2]=c[128433];c[h+16>>2]=c[128434];c[h+20>>2]=c[128435];c[h+24>>2]=c[128436];c[h+28>>2]=c[128437];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[128444];c[j+4>>2]=c[128445];c[j+8>>2]=c[128446];c[j+12>>2]=c[128447];c[j+16>>2]=c[128448];c[j+20>>2]=c[128449];c[j+24>>2]=c[128450];c[j+28>>2]=c[128451];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[128460];c[k+4>>2]=c[128461];c[k+8>>2]=c[128462];c[k+12>>2]=c[128463];c[k+16>>2]=c[128464];c[k+20>>2]=c[128465];c[k+24>>2]=c[128466];c[k+28>>2]=c[128467];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[128474];c[l+4>>2]=c[128475];c[l+8>>2]=c[128476];c[l+12>>2]=c[128477];c[l+16>>2]=c[128478];c[l+20>>2]=c[128479];c[l+24>>2]=c[128480];c[l+28>>2]=c[128481];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[128492];c[m+4>>2]=c[128493];c[m+8>>2]=c[128494];c[m+12>>2]=c[128495];c[m+16>>2]=c[128496];c[m+20>>2]=c[128497];c[m+24>>2]=c[128498];c[m+28>>2]=c[128499];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[128508];c[n+4>>2]=c[128509];c[n+8>>2]=c[128510];c[n+12>>2]=c[128511];c[n+16>>2]=c[128512];c[n+20>>2]=c[128513];c[n+24>>2]=c[128514];c[n+28>>2]=c[128515];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[128516];c[o+4>>2]=c[128517];c[o+8>>2]=c[128518];c[o+12>>2]=c[128519];c[o+16>>2]=c[128520];c[o+20>>2]=c[128521];c[o+24>>2]=c[128522];c[o+28>>2]=c[128523];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;i=b;return}function qDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+640|0;d=b+288|0;e=b+192|0;f=b+160|0;g=b+544|0;h=b+256|0;j=b+128|0;k=b+384|0;l=b+448|0;m=b+512|0;n=b+576|0;o=b+608|0;p=b+320|0;q=b+64|0;r=b;s=b+32|0;t=b+352|0;u=b+416|0;v=b+224|0;w=b+480|0;x=b+96|0;c[d+0>>2]=c[127566];c[d+4>>2]=c[127567];c[d+8>>2]=c[127568];c[d+12>>2]=c[127569];c[d+16>>2]=c[127570];c[d+20>>2]=c[127571];c[d+24>>2]=c[127572];c[d+28>>2]=c[127573];xo[c[c[a>>2]>>2]&2047](a,d,32)|0;c[e+0>>2]=c[127610];c[e+4>>2]=c[127611];c[e+8>>2]=c[127612];c[e+12>>2]=c[127613];c[e+16>>2]=c[127614];c[e+20>>2]=c[127615];c[e+24>>2]=c[127616];c[e+28>>2]=c[127617];xo[c[c[a>>2]>>2]&2047](a,e,32)|0;c[f+0>>2]=c[127618];c[f+4>>2]=c[127619];c[f+8>>2]=c[127620];c[f+12>>2]=c[127621];c[f+16>>2]=c[127622];c[f+20>>2]=c[127623];c[f+24>>2]=c[127624];c[f+28>>2]=c[127625];xo[c[c[a>>2]>>2]&2047](a,f,32)|0;c[g+0>>2]=c[127582];c[g+4>>2]=c[127583];c[g+8>>2]=c[127584];c[g+12>>2]=c[127585];c[g+16>>2]=c[127586];c[g+20>>2]=c[127587];c[g+24>>2]=c[127588];c[g+28>>2]=c[127589];xo[c[c[a>>2]>>2]&2047](a,g,32)|0;c[h+0>>2]=c[127638];c[h+4>>2]=c[127639];c[h+8>>2]=c[127640];c[h+12>>2]=c[127641];c[h+16>>2]=c[127642];c[h+20>>2]=c[127643];c[h+24>>2]=c[127644];c[h+28>>2]=c[127645];xo[c[c[a>>2]>>2]&2047](a,h,32)|0;c[j+0>>2]=c[127602];c[j+4>>2]=c[127603];c[j+8>>2]=c[127604];c[j+12>>2]=c[127605];c[j+16>>2]=c[127606];c[j+20>>2]=c[127607];c[j+24>>2]=c[127608];c[j+28>>2]=c[127609];xo[c[c[a>>2]>>2]&2047](a,j,32)|0;c[k+0>>2]=c[127610];c[k+4>>2]=c[127611];c[k+8>>2]=c[127612];c[k+12>>2]=c[127613];c[k+16>>2]=c[127614];c[k+20>>2]=c[127615];c[k+24>>2]=c[127616];c[k+28>>2]=c[127617];xo[c[c[a>>2]>>2]&2047](a,k,32)|0;c[l+0>>2]=c[127618];c[l+4>>2]=c[127619];c[l+8>>2]=c[127620];c[l+12>>2]=c[127621];c[l+16>>2]=c[127622];c[l+20>>2]=c[127623];c[l+24>>2]=c[127624];c[l+28>>2]=c[127625];xo[c[c[a>>2]>>2]&2047](a,l,32)|0;c[m+0>>2]=c[127630];c[m+4>>2]=c[127631];c[m+8>>2]=c[127632];c[m+12>>2]=c[127633];c[m+16>>2]=c[127634];c[m+20>>2]=c[127635];c[m+24>>2]=c[127636];c[m+28>>2]=c[127637];xo[c[c[a>>2]>>2]&2047](a,m,32)|0;c[n+0>>2]=c[127638];c[n+4>>2]=c[127639];c[n+8>>2]=c[127640];c[n+12>>2]=c[127641];c[n+16>>2]=c[127642];c[n+20>>2]=c[127643];c[n+24>>2]=c[127644];c[n+28>>2]=c[127645];xo[c[c[a>>2]>>2]&2047](a,n,32)|0;c[o+0>>2]=c[127652];c[o+4>>2]=c[127653];c[o+8>>2]=c[127654];c[o+12>>2]=c[127655];c[o+16>>2]=c[127656];c[o+20>>2]=c[127657];c[o+24>>2]=c[127658];c[o+28>>2]=c[127659];xo[c[c[a>>2]>>2]&2047](a,o,32)|0;c[p+0>>2]=c[127664];c[p+4>>2]=c[127665];c[p+8>>2]=c[127666];c[p+12>>2]=c[127667];c[p+16>>2]=c[127668];c[p+20>>2]=c[127669];c[p+24>>2]=c[127670];c[p+28>>2]=c[127671];xo[c[c[a>>2]>>2]&2047](a,p,32)|0;c[q+0>>2]=c[127678];c[q+4>>2]=c[127679];c[q+8>>2]=c[127680];c[q+12>>2]=c[127681];c[q+16>>2]=c[127682];c[q+20>>2]=c[127683];c[q+24>>2]=c[127684];c[q+28>>2]=c[127685];xo[c[c[a>>2]>>2]&2047](a,q,32)|0;c[r+0>>2]=c[127692];c[r+4>>2]=c[127693];c[r+8>>2]=c[127694];c[r+12>>2]=c[127695];c[r+16>>2]=c[127696];c[r+20>>2]=c[127697];c[r+24>>2]=c[127698];c[r+28>>2]=c[127699];xo[c[c[a>>2]>>2]&2047](a,r,32)|0;c[s+0>>2]=c[127700];c[s+4>>2]=c[127701];c[s+8>>2]=c[127702];c[s+12>>2]=c[127703];c[s+16>>2]=c[127704];c[s+20>>2]=c[127705];c[s+24>>2]=c[127706];c[s+28>>2]=c[127707];xo[c[c[a>>2]>>2]&2047](a,s,32)|0;c[t>>2]=509824;c[t+4>>2]=510832;c[t+8>>2]=0;c[t+12>>2]=368;c[t+16>>2]=0;c[t+20>>2]=0;c[t+24>>2]=1;c[t+28>>2]=0;xo[c[c[a>>2]>>2]&2047](a,t,32)|0;c[u+0>>2]=c[127716];c[u+4>>2]=c[127717];c[u+8>>2]=c[127718];c[u+12>>2]=c[127719];c[u+16>>2]=c[127720];c[u+20>>2]=c[127721];c[u+24>>2]=c[127722];c[u+28>>2]=c[127723];xo[c[c[a>>2]>>2]&2047](a,u,32)|0;c[v+0>>2]=c[127732];c[v+4>>2]=c[127733];c[v+8>>2]=c[127734];c[v+12>>2]=c[127735];c[v+16>>2]=c[127736];c[v+20>>2]=c[127737];c[v+24>>2]=c[127738];c[v+28>>2]=c[127739];xo[c[c[a>>2]>>2]&2047](a,v,32)|0;c[w+0>>2]=c[127744];c[w+4>>2]=c[127745];c[w+8>>2]=c[127746];c[w+12>>2]=c[127747];c[w+16>>2]=c[127748];c[w+20>>2]=c[127749];c[w+24>>2]=c[127750];c[w+28>>2]=c[127751];xo[c[c[a>>2]>>2]&2047](a,w,32)|0;c[x+0>>2]=c[127752];c[x+4>>2]=c[127753];c[x+8>>2]=c[127754];c[x+12>>2]=c[127755];c[x+16>>2]=c[127756];c[x+20>>2]=c[127757];c[x+24>>2]=c[127758];c[x+28>>2]=c[127759];xo[c[c[a>>2]>>2]&2047](a,x,32)|0;i=b;return}function rDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=(b+3|0)>>>2;f=e<<4;g=UJa(d,(e*48|0)+144+(gFa(e)|0)|0,514536,63)|0;if(g)ODa(g);h=hFa(g,g+144|0,e,b,1)|0;c[g+128>>2]=h;b=g+132|0;c[b>>2]=h+f;j=g+136|0;c[j>>2]=h+(e<<5);PEi(h|0,0,f|0)|0;PEi(c[b>>2]|0,0,f|0)|0;PEi(c[j>>2]|0,0,f|0)|0;a[g+113>>0]=3;i=d;return g|0}function sDa(a){a=a|0;var b=0;b=i;iFa(a);i=b;return}function tDa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;jFa(a,b,d,e,0,c[e+40>>2]|0);i=f;return}function uDa(a,b,d){a=a|0;b=b|0;d=ea(d);g[(c[a+136>>2]|0)+(b<<2)>>2]=d;return}function vDa(a,b,d){a=a|0;b=b|0;d=ea(d);g[(c[a+132>>2]|0)+(b<<2)>>2]=d;return}function wDa(a,b,d){a=a|0;b=b|0;d=ea(d);g[(c[a+128>>2]|0)+(b<<2)>>2]=d;return}function xDa(a,b){a=a|0;b=b|0;var d=Im;d=ea(g[(c[a+136>>2]|0)+(b<<2)>>2]);return ea(d)}function yDa(a,b){a=a|0;b=b|0;var d=Im;d=ea(g[(c[a+132>>2]|0)+(b<<2)>>2]);return ea(d)}function zDa(a,b){a=a|0;b=b|0;var d=Im;d=ea(g[(c[a+128>>2]|0)+(b<<2)>>2]);return ea(d)}function ADa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;gKa();eEa(mo[c[(c[a>>2]|0)+32>>2]&4095](a)|0);gEa(b);if(!b){i=d;return 1}a=c[(c[b>>2]|0)+16>>2]|0;e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;e=Bn[c[(c[f>>2]|0)+8>>2]&255](f,8,514624,514648,65)|0;f=pKa()|0;c[e+4>>2]=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;c[e>>2]=515432;co[a&2047](b,513,e);e=c[(c[b>>2]|0)+16>>2]|0;a=pKa()|0;f=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0;a=Bn[c[(c[f>>2]|0)+8>>2]&255](f,8,514624,514648,66)|0;f=pKa()|0;c[a+4>>2]=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;c[a>>2]=515648;co[e&2047](b,515,a);a=c[(c[b>>2]|0)+16>>2]|0;e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;e=Bn[c[(c[f>>2]|0)+8>>2]&255](f,8,514624,514648,67)|0;f=pKa()|0;c[e+4>>2]=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;c[e>>2]=515688;co[a&2047](b,514,e);e=c[(c[b>>2]|0)+16>>2]|0;a=pKa()|0;f=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0;a=Bn[c[(c[f>>2]|0)+8>>2]&255](f,8,514624,514648,68)|0;f=pKa()|0;c[a+4>>2]=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;c[a>>2]=515728;co[e&2047](b,512,a);a=c[c[b>>2]>>2]|0;e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;e=Bn[c[(c[f>>2]|0)+8>>2]&255](f,8,514736,514648,70)|0;if(!e)g=0;else{c[e>>2]=515088;c[e+4>>2]=515808;g=e}co[a&2047](b,513,g);g=c[c[b>>2]>>2]|0;a=pKa()|0;e=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0;a=Bn[c[(c[e>>2]|0)+8>>2]&255](e,8,514736,514648,71)|0;if(!a)h=0;else{c[a>>2]=515016;c[a+4>>2]=515760;h=a}co[g&2047](b,515,h);h=c[c[b>>2]>>2]|0;g=pKa()|0;a=mo[c[(c[g>>2]|0)+20>>2]&4095](g)|0;g=Bn[c[(c[a>>2]|0)+8>>2]&255](a,8,514736,514648,72)|0;if(!g)j=0;else{c[g>>2]=514944;c[g+4>>2]=515832;j=g}co[h&2047](b,512,j);j=c[c[b>>2]>>2]|0;h=pKa()|0;g=mo[c[(c[h>>2]|0)+20>>2]&4095](h)|0;h=Bn[c[(c[g>>2]|0)+8>>2]&255](g,8,514736,514648,73)|0;if(!h)k=0;else{c[h>>2]=514872;c[h+4>>2]=515784;k=h}co[j&2047](b,514,k);In[c[(c[b>>2]|0)+8>>2]&4095](b,3494);In[c[(c[b>>2]|0)+8>>2]&4095](b,3495);In[c[(c[b>>2]|0)+8>>2]&4095](b,3496);In[c[(c[b>>2]|0)+8>>2]&4095](b,3497);i=d;return 1}function BDa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;hKa();fEa();if((hEa()|0)!=(a|0)){dKa(bKa()|0,4,514648,91,514768,b);i=b;return}if(!a){i=b;return}d=_n[c[(c[a>>2]|0)+4>>2]&4095](a,513)|0;if(d){ko[c[(c[d>>2]|0)+32>>2]&4095](d);e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=_n[c[(c[a>>2]|0)+4>>2]&4095](a,515)|0;if(d){ko[c[(c[d>>2]|0)+32>>2]&4095](d);f=pKa()|0;e=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=_n[c[(c[a>>2]|0)+4>>2]&4095](a,512)|0;if(d){ko[c[(c[d>>2]|0)+32>>2]&4095](d);e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=_n[c[(c[a>>2]|0)+4>>2]&4095](a,514)|0;if(d){ko[c[(c[d>>2]|0)+32>>2]&4095](d);f=pKa()|0;e=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=_n[c[(c[a>>2]|0)+20>>2]&4095](a,513)|0;if(d){e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=_n[c[(c[a>>2]|0)+20>>2]&4095](a,515)|0;if(d){f=pKa()|0;e=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=_n[c[(c[a>>2]|0)+20>>2]&4095](a,512)|0;if(d){e=pKa()|0;f=mo[c[(c[e>>2]|0)+20>>2]&4095](e)|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=_n[c[(c[a>>2]|0)+20>>2]&4095](a,514)|0;if(!d){i=b;return}a=pKa()|0;f=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d);i=b;return}function CDa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+608|0;l=e+588|0;m=e+584|0;n=e+580|0;o=e+576|0;p=e;do if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515464,p)|0?(q=c[p>>2]|0,c[o>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)?(r=AEi(q,o,10)|0,q=H,!((r|0)==0&(q|0)==0)):0){s=xo[c[(c[k>>2]|0)+40>>2]&2047](k,r,q)|0;if(!s){uU(2,515464,517784,130)|0;break}if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515584,l)|0?(q=c[l>>2]|0,c[n>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)?(r=CEi(q,n,10)|0,(r|0)!=0):0){if((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515600,l)|0?(q=c[l>>2]|0,c[m>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)t=CEi(q,m,10)|0;else t=0;q=EEa(r)|0;ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520016)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];I2a(l,f,q,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);g[p+80>>2]=ea(1.0);g[p+84>>2]=ea(500.0);g[p+88>>2]=ea(600.0);g[p+92>>2]=ea(.150000006);g[p+96>>2]=ea(2.0);g[p+100>>2]=ea(.349999994);g[p>>2]=ea(0.0);g[p+4>>2]=ea(.800000011);g[p+8>>2]=ea(.330000013);g[p+12>>2]=ea(1.0);g[p+16>>2]=ea(1.0);g[p+20>>2]=ea(.800000011);c[p+64>>2]=3;g[p+104>>2]=ea(1.0);g[p+108>>2]=ea(.00166666671);g[p+240>>2]=ea(4.0);c[p+244>>2]=7;g[p+248>>2]=ea(.5);g[p+112>>2]=ea(-4.0);g[p+116>>2]=ea(0.0);g[p+120>>2]=ea(4.0);g[p+124>>2]=ea(2.0);g[p+128>>2]=ea(1.5);g[p+132>>2]=ea(1.10000002);g[p+136>>2]=ea(1.0);u=p+140|0;v=u+100|0;do{c[u>>2]=0;u=u+4|0}while((u|0)<(v|0));g[p+256>>2]=ea(10.0);c[p+260>>2]=1;c[p+264>>2]=5;u=0;do{g[p+(u<<2)+272>>2]=ea(.649999976);g[p+(u<<2)+400>>2]=ea(.5);u=u+1|0}while((u|0)!=32);g[p+276>>2]=ea(.150000006);g[p+400>>2]=ea(2.0);g[p+528>>2]=ea(.449999988);g[p+532>>2]=ea(.5);g[p+536>>2]=ea(.5);g[p+540>>2]=ea(1.29999995);g[p+544>>2]=ea(1.29999995);g[p+548>>2]=ea(1.29999995);c[p+552>>2]=0;g[p+560>>2]=ea(1.0);g[p+564>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(0.0);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520480)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,515624)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);u=c[j>>2]|0;v=(b[s+4>>1]|0)==5?s:0;w=TCa(r)|0;UCa(w,u,(b[v+4>>1]|0)==5?v:0,q,p,t);c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];K2a(l,f,w,h,k);v=c[w+72>>2]|0;u=q+36|0;x=c[u>>2]|0;if(x){y=x;x=0;while(1){z=c[(c[v+(x*208|0)+192>>2]|0)+352>>2]|0;if(!z)A=y;else{Dn[c[c[k>>2]>>2]&511](k,z,0,0);A=c[u>>2]|0}x=x+1|0;if(x>>>0>=A>>>0)break;else y=A}}if(q)KEa(q);c[d>>2]=515808;c[d+4>>2]=w;y=d+8|0;c[y>>2]=w;c[y+4>>2]=0;i=e;return}c[d>>2]=3653512;c[d+4>>2]=0;y=d+8|0;c[y>>2]=0;c[y+4>>2]=0;i=e;return}while(0);uU(3,515464,515488,98)|0;c[d>>2]=3653512;c[d+4>>2]=0;A=d+8|0;c[A>>2]=0;c[A+4>>2]=0;i=e;return}function DDa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+144|0;b=h;j=h+16|0;k=c[d+104>>2]|0;l=k;if(!k){m=0;n=0}else{if(!(_n[c[(c[e>>2]|0)+8>>2]&4095](e,k)|0))uU(2,515464,517656,52)|0;o=_n[c[(c[e>>2]|0)+52>>2]&4095](e,k)|0;p=H;q=(o|0)==0&(p|0)==0;m=q?l:o;n=q?0:p}p=c[(c[f>>2]|0)+12>>2]|0;c[b>>2]=517768;c[b+4>>2]=k;k=b+8|0;c[k>>2]=m;c[k+4>>2]=n;co[p&2047](f,515464,b);p=c[d+48>>2]|0;n=j+0|0;k=n+128|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(k|0));c[b>>2]=p;TUa(j,0,515888,b)|0;if(a[j>>0]|0){p=c[c[g>>2]>>2]|0;m=SEi(j|0)|0;xo[p&2047](g,j,m)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;m=g+20|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515584,c[m>>2]|0);p=g+16|0;c[p>>2]=0;q=g+12|0;c[q>>2]=0;o=c[d+108>>2]|0;n=j+0|0;k=n+128|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(k|0));c[b>>2]=o;TUa(j,0,515888,b)|0;if(a[j>>0]|0){o=c[c[g>>2]>>2]|0;n=SEi(j|0)|0;xo[o&2047](g,j,n)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515600,c[m>>2]|0);c[p>>2]=0;c[q>>2]=0;c[b>>2]=c[g+8>>2];q=b+4|0;c[q>>2]=0;c[b+8>>2]=0;p=b+12|0;c[p>>2]=0;L2a(b,d,f,g,e);e=c[p>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=h;return}e=c[q>>2]|0;if(!e){i=h;return}q=c[c[b>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=h;return}function EDa(a,b){a=a|0;b=b|0;return 0}function FDa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+608|0;l=e+588|0;m=e+584|0;n=e+580|0;o=e+576|0;p=e;do if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515464,p)|0?(q=c[p>>2]|0,c[o>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)?(r=AEi(q,o,10)|0,q=H,!((r|0)==0&(q|0)==0)):0){s=xo[c[(c[k>>2]|0)+40>>2]&2047](k,r,q)|0;if(!s){uU(2,515464,517784,130)|0;break}if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515584,l)|0?(q=c[l>>2]|0,c[n>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)?(r=CEi(q,n,10)|0,(r|0)!=0):0){if((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515600,l)|0?(q=c[l>>2]|0,c[m>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)t=CEi(q,m,10)|0;else t=0;q=EEa(r)|0;ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520016)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];I2a(l,f,q,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);g[p+80>>2]=ea(1.0);g[p+84>>2]=ea(500.0);g[p+88>>2]=ea(600.0);g[p+92>>2]=ea(.150000006);g[p+96>>2]=ea(2.0);g[p+100>>2]=ea(.349999994);g[p>>2]=ea(0.0);g[p+4>>2]=ea(.800000011);g[p+8>>2]=ea(.330000013);g[p+12>>2]=ea(1.0);g[p+16>>2]=ea(1.0);g[p+20>>2]=ea(.800000011);c[p+64>>2]=3;g[p+104>>2]=ea(1.0);g[p+108>>2]=ea(.00166666671);g[p+240>>2]=ea(4.0);c[p+244>>2]=7;g[p+248>>2]=ea(.5);g[p+112>>2]=ea(-4.0);g[p+116>>2]=ea(0.0);g[p+120>>2]=ea(4.0);g[p+124>>2]=ea(2.0);g[p+128>>2]=ea(1.5);g[p+132>>2]=ea(1.10000002);g[p+136>>2]=ea(1.0);u=p+140|0;v=u+100|0;do{c[u>>2]=0;u=u+4|0}while((u|0)<(v|0));g[p+256>>2]=ea(10.0);c[p+260>>2]=1;c[p+264>>2]=5;u=0;do{g[p+(u<<2)+272>>2]=ea(.649999976);g[p+(u<<2)+400>>2]=ea(.5);u=u+1|0}while((u|0)!=32);g[p+276>>2]=ea(.150000006);g[p+400>>2]=ea(2.0);g[p+528>>2]=ea(.449999988);g[p+532>>2]=ea(.5);g[p+536>>2]=ea(.5);g[p+540>>2]=ea(1.29999995);g[p+544>>2]=ea(1.29999995);g[p+548>>2]=ea(1.29999995);c[p+552>>2]=0;g[p+560>>2]=ea(1.0);g[p+564>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(0.0);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520480)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,515624)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);u=c[j>>2]|0;v=(b[s+4>>1]|0)==5?s:0;w=YCa(r)|0;ZCa(w,u,(b[v+4>>1]|0)==5?v:0,q,p,r-t|0);c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];M2a(l,f,w,h,k);v=c[w+72>>2]|0;u=q+36|0;x=c[u>>2]|0;if(x){y=x;x=0;while(1){z=c[(c[v+(x*208|0)+192>>2]|0)+352>>2]|0;if(!z)A=y;else{Dn[c[c[k>>2]>>2]&511](k,z,0,0);A=c[u>>2]|0}x=x+1|0;if(x>>>0>=A>>>0)break;else y=A}}if(q)KEa(q);c[d>>2]=515760;c[d+4>>2]=w;y=d+8|0;c[y>>2]=w;c[y+4>>2]=0;i=e;return}c[d>>2]=3653512;c[d+4>>2]=0;y=d+8|0;c[y>>2]=0;c[y+4>>2]=0;i=e;return}while(0);uU(3,515464,515488,98)|0;c[d>>2]=3653512;c[d+4>>2]=0;A=d+8|0;c[A>>2]=0;c[A+4>>2]=0;i=e;return}function GDa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+144|0;b=h;j=h+16|0;k=c[d+104>>2]|0;l=k;if(!k){m=0;n=0}else{if(!(_n[c[(c[e>>2]|0)+8>>2]&4095](e,k)|0))uU(2,515464,517656,52)|0;o=_n[c[(c[e>>2]|0)+52>>2]&4095](e,k)|0;p=H;q=(o|0)==0&(p|0)==0;m=q?l:o;n=q?0:p}p=c[(c[f>>2]|0)+12>>2]|0;c[b>>2]=517768;c[b+4>>2]=k;k=b+8|0;c[k>>2]=m;c[k+4>>2]=n;co[p&2047](f,515464,b);p=c[d+48>>2]|0;n=j+0|0;k=n+128|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(k|0));c[b>>2]=p;TUa(j,0,515888,b)|0;if(a[j>>0]|0){p=c[c[g>>2]>>2]|0;m=SEi(j|0)|0;xo[p&2047](g,j,m)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;m=g+20|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515584,c[m>>2]|0);p=g+16|0;c[p>>2]=0;q=g+12|0;c[q>>2]=0;o=c[d+108>>2]|0;n=j+0|0;k=n+128|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(k|0));c[b>>2]=o;TUa(j,0,515888,b)|0;if(!(a[j>>0]|0)){a[b>>0]=0;r=c[g>>2]|0;s=c[r>>2]|0;xo[s&2047](g,b,1)|0;t=c[f>>2]|0;u=t+8|0;v=c[u>>2]|0;w=c[m>>2]|0;co[v&2047](f,515600,w);c[p>>2]=0;c[q>>2]=0;N2a(d,f,g,e);i=h;return}o=c[c[g>>2]>>2]|0;n=SEi(j|0)|0;xo[o&2047](g,j,n)|0;a[b>>0]=0;r=c[g>>2]|0;s=c[r>>2]|0;xo[s&2047](g,b,1)|0;t=c[f>>2]|0;u=t+8|0;v=c[u>>2]|0;w=c[m>>2]|0;co[v&2047](f,515600,w);c[p>>2]=0;c[q>>2]=0;N2a(d,f,g,e);i=h;return}function HDa(a,b){a=a|0;b=b|0;return 0}function IDa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+1152|0;l=e+1132|0;m=e+1128|0;n=e+1124|0;o=e+1120|0;p=e+544|0;q=e;do if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515464,p)|0?(r=c[p>>2]|0,c[o>>2]=r,(r|0)!=0):0)?(a[r>>0]|0)!=0:0)?(s=AEi(r,o,10)|0,r=H,!((s|0)==0&(r|0)==0)):0){t=xo[c[(c[k>>2]|0)+40>>2]&2047](k,s,r)|0;if(!t){uU(2,515464,517784,130)|0;break}if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515584,l)|0?(r=c[l>>2]|0,c[n>>2]=r,(r|0)!=0):0)?(a[r>>0]|0)!=0:0)?(s=CEi(r,n,10)|0,(s|0)!=0):0){if((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515600,l)|0?(r=c[l>>2]|0,c[m>>2]=r,(r|0)!=0):0)?(a[r>>0]|0)!=0:0)u=CEi(r,m,10)|0;else u=0;r=EEa(s)|0;ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520016)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];I2a(l,f,r,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);g[p+80>>2]=ea(1.0);g[p+84>>2]=ea(500.0);g[p+88>>2]=ea(600.0);g[p+92>>2]=ea(.150000006);g[p+96>>2]=ea(2.0);g[p+100>>2]=ea(.349999994);g[p>>2]=ea(0.0);g[p+4>>2]=ea(.800000011);g[p+8>>2]=ea(.330000013);g[p+12>>2]=ea(1.0);g[p+16>>2]=ea(1.0);g[p+20>>2]=ea(.800000011);c[p+64>>2]=3;g[p+104>>2]=ea(1.0);g[p+108>>2]=ea(.00166666671);g[p+240>>2]=ea(4.0);c[p+244>>2]=7;g[p+248>>2]=ea(.5);g[p+112>>2]=ea(-4.0);g[p+116>>2]=ea(0.0);g[p+120>>2]=ea(4.0);g[p+124>>2]=ea(2.0);g[p+128>>2]=ea(1.5);g[p+132>>2]=ea(1.10000002);g[p+136>>2]=ea(1.0);v=p+140|0;w=v+100|0;do{c[v>>2]=0;v=v+4|0}while((v|0)<(w|0));g[p+256>>2]=ea(10.0);c[p+260>>2]=1;c[p+264>>2]=5;x=0;do{g[p+(x<<2)+272>>2]=ea(.649999976);g[p+(x<<2)+400>>2]=ea(.5);x=x+1|0}while((x|0)!=32);g[p+276>>2]=ea(.150000006);g[p+400>>2]=ea(2.0);g[p+528>>2]=ea(.449999988);g[p+532>>2]=ea(.5);g[p+536>>2]=ea(.5);g[p+540>>2]=ea(1.29999995);g[p+544>>2]=ea(1.29999995);g[p+548>>2]=ea(1.29999995);c[p+552>>2]=0;g[p+560>>2]=ea(1.0);g[p+564>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(0.0);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520480)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);g[q+80>>2]=ea(1.0);g[q+84>>2]=ea(500.0);g[q+88>>2]=ea(600.0);g[q+92>>2]=ea(.150000006);g[q+96>>2]=ea(2.0);g[q+100>>2]=ea(.349999994);g[q>>2]=ea(0.0);g[q+4>>2]=ea(.800000011);g[q+8>>2]=ea(.330000013);g[q+12>>2]=ea(1.0);g[q+16>>2]=ea(1.0);g[q+20>>2]=ea(.800000011);c[q+64>>2]=3;g[q+104>>2]=ea(1.0);g[q+108>>2]=ea(.00166666671);g[q+240>>2]=ea(4.0);c[q+244>>2]=7;g[q+248>>2]=ea(.5);g[q+112>>2]=ea(-4.0);g[q+116>>2]=ea(0.0);g[q+120>>2]=ea(4.0);g[q+124>>2]=ea(2.0);g[q+128>>2]=ea(1.5);g[q+132>>2]=ea(1.10000002);g[q+136>>2]=ea(1.0);v=q+140|0;w=v+100|0;do{c[v>>2]=0;v=v+4|0}while((v|0)<(w|0));g[q+256>>2]=ea(10.0);c[q+260>>2]=1;c[q+264>>2]=5;v=0;do{g[q+(v<<2)+272>>2]=ea(.649999976);g[q+(v<<2)+400>>2]=ea(.5);v=v+1|0}while((v|0)!=32);g[q+276>>2]=ea(.150000006);g[q+400>>2]=ea(2.0);c[q+528>>2]=0;c[q+532>>2]=0;g[q+536>>2]=ea(0.0);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,515624)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);v=c[j>>2]|0;w=(b[t+4>>1]|0)==5?t:0;x=WCa(s)|0;XCa(x,v,(b[w+4>>1]|0)==5?w:0,r,q,s-u|0);c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];O2a(l,f,x,h,k);w=c[x+72>>2]|0;v=r+36|0;y=c[v>>2]|0;if(y){z=y;y=0;while(1){A=c[(c[w+(y*208|0)+192>>2]|0)+352>>2]|0;if(!A)B=z;else{Dn[c[c[k>>2]>>2]&511](k,A,0,0);B=c[v>>2]|0}y=y+1|0;if(y>>>0>=B>>>0)break;else z=B}}if(r)KEa(r);c[d>>2]=515784;c[d+4>>2]=x;z=d+8|0;c[z>>2]=x;c[z+4>>2]=0;i=e;return}c[d>>2]=3653512;c[d+4>>2]=0;z=d+8|0;c[z>>2]=0;c[z+4>>2]=0;i=e;return}while(0);uU(3,515464,515488,98)|0;c[d>>2]=3653512;c[d+4>>2]=0;B=d+8|0;c[B>>2]=0;c[B+4>>2]=0;i=e;return}function JDa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+144|0;b=h;j=h+16|0;k=c[d+104>>2]|0;l=k;if(!k){m=0;n=0}else{if(!(_n[c[(c[e>>2]|0)+8>>2]&4095](e,k)|0))uU(2,515464,517656,52)|0;o=_n[c[(c[e>>2]|0)+52>>2]&4095](e,k)|0;p=H;q=(o|0)==0&(p|0)==0;m=q?l:o;n=q?0:p}p=c[(c[f>>2]|0)+12>>2]|0;c[b>>2]=517768;c[b+4>>2]=k;k=b+8|0;c[k>>2]=m;c[k+4>>2]=n;co[p&2047](f,515464,b);p=c[d+48>>2]|0;n=j+0|0;k=n+128|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(k|0));c[b>>2]=p;TUa(j,0,515888,b)|0;if(a[j>>0]|0){p=c[c[g>>2]>>2]|0;m=SEi(j|0)|0;xo[p&2047](g,j,m)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;m=g+20|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515584,c[m>>2]|0);p=g+16|0;c[p>>2]=0;q=g+12|0;c[q>>2]=0;o=c[d+108>>2]|0;n=j+0|0;k=n+128|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(k|0));c[b>>2]=o;TUa(j,0,515888,b)|0;if(a[j>>0]|0){o=c[c[g>>2]>>2]|0;n=SEi(j|0)|0;xo[o&2047](g,j,n)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515600,c[m>>2]|0);c[p>>2]=0;c[q>>2]=0;c[b>>2]=c[g+8>>2];q=b+4|0;c[q>>2]=0;c[b+8>>2]=0;p=b+12|0;c[p>>2]=0;P2a(b,d,f,g,e);e=c[p>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=h;return}e=c[q>>2]|0;if(!e){i=h;return}q=c[c[b>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=h;return}function KDa(a,b){a=a|0;b=b|0;return 0}function LDa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+608|0;l=e+588|0;m=e+584|0;n=e+580|0;o=e+576|0;p=e;do if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515464,p)|0?(q=c[p>>2]|0,c[o>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)?(r=AEi(q,o,10)|0,q=H,!((r|0)==0&(q|0)==0)):0){s=xo[c[(c[k>>2]|0)+40>>2]&2047](k,r,q)|0;if(!s){uU(2,515464,517784,130)|0;break}if(((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515584,l)|0?(q=c[l>>2]|0,c[n>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)?(r=CEi(q,n,10)|0,(r|0)!=0):0){if((xo[c[(c[f>>2]|0)+8>>2]&2047](f,515600,l)|0?(q=c[l>>2]|0,c[m>>2]=q,(q|0)!=0):0)?(a[q>>0]|0)!=0:0)CEi(q,m,10)|0;q=EEa(r)|0;ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520016)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];I2a(l,f,q,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);g[p+80>>2]=ea(1.0);g[p+84>>2]=ea(500.0);g[p+88>>2]=ea(600.0);g[p+92>>2]=ea(.150000006);g[p+96>>2]=ea(2.0);g[p+100>>2]=ea(.349999994);g[p>>2]=ea(0.0);g[p+4>>2]=ea(.800000011);g[p+8>>2]=ea(.330000013);g[p+12>>2]=ea(1.0);g[p+16>>2]=ea(1.0);g[p+20>>2]=ea(.800000011);c[p+64>>2]=3;g[p+104>>2]=ea(1.0);g[p+108>>2]=ea(.00166666671);g[p+240>>2]=ea(4.0);c[p+244>>2]=7;g[p+248>>2]=ea(.5);g[p+112>>2]=ea(-4.0);g[p+116>>2]=ea(0.0);g[p+120>>2]=ea(4.0);g[p+124>>2]=ea(2.0);g[p+128>>2]=ea(1.5);g[p+132>>2]=ea(1.10000002);g[p+136>>2]=ea(1.0);t=p+140|0;u=t+100|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));g[p+256>>2]=ea(10.0);c[p+260>>2]=1;c[p+264>>2]=5;t=0;do{g[p+(t<<2)+272>>2]=ea(.649999976);g[p+(t<<2)+400>>2]=ea(.5);t=t+1|0}while((t|0)!=32);g[p+276>>2]=ea(.150000006);g[p+400>>2]=ea(2.0);g[p+528>>2]=ea(.449999988);g[p+532>>2]=ea(.5);g[p+536>>2]=ea(.5);g[p+540>>2]=ea(1.29999995);g[p+544>>2]=ea(1.29999995);g[p+548>>2]=ea(1.29999995);c[p+552>>2]=0;g[p+560>>2]=ea(1.0);g[p+564>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(0.0);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,520480)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);ko[c[(c[f>>2]|0)+44>>2]&4095](f);if(_n[c[(c[f>>2]|0)+16>>2]&4095](f,515624)|0){c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];J2a(l,f,p,h,k)}ko[c[(c[f>>2]|0)+48>>2]&4095](f);t=c[j>>2]|0;u=(b[s+4>>1]|0)==5?s:0;v=rDa(r)|0;tDa(v,t,(b[u+4>>1]|0)==5?u:0,q);c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];Q2a(l,f,v,h,k);u=c[v+72>>2]|0;t=q+36|0;w=c[t>>2]|0;if(w){x=w;w=0;while(1){y=c[(c[u+(w*208|0)+192>>2]|0)+352>>2]|0;if(!y)z=x;else{Dn[c[c[k>>2]>>2]&511](k,y,0,0);z=c[t>>2]|0}w=w+1|0;if(w>>>0>=z>>>0)break;else x=z}}if(q)KEa(q);c[d>>2]=515832;c[d+4>>2]=v;x=d+8|0;c[x>>2]=v;c[x+4>>2]=0;i=e;return}c[d>>2]=3653512;c[d+4>>2]=0;x=d+8|0;c[x>>2]=0;c[x+4>>2]=0;i=e;return}while(0);uU(3,515464,515488,98)|0;c[d>>2]=3653512;c[d+4>>2]=0;z=d+8|0;c[z>>2]=0;c[z+4>>2]=0;i=e;return}function MDa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+240|0;b=h;j=h+80|0;k=h+48|0;l=h+32|0;m=c[d+104>>2]|0;n=m;if(!m){o=0;p=0}else{if(!(_n[c[(c[e>>2]|0)+8>>2]&4095](e,m)|0))uU(2,515464,517656,52)|0;q=_n[c[(c[e>>2]|0)+52>>2]&4095](e,m)|0;r=H;s=(q|0)==0&(r|0)==0;o=s?n:q;p=s?0:r}r=c[(c[f>>2]|0)+12>>2]|0;c[b>>2]=517768;c[b+4>>2]=m;m=b+8|0;c[m>>2]=o;c[m+4>>2]=p;co[r&2047](f,515464,b);r=c[d+48>>2]|0;p=j+0|0;m=p+128|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(m|0));c[b>>2]=r;TUa(j,0,515888,b)|0;if(a[j>>0]|0){r=c[c[g>>2]>>2]|0;o=SEi(j|0)|0;xo[r&2047](g,j,o)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;o=g+20|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515584,c[o>>2]|0);r=g+16|0;c[r>>2]=0;s=g+12|0;c[s>>2]=0;q=c[d+108>>2]|0;p=j+0|0;m=p+128|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(m|0));c[b>>2]=q;TUa(j,0,515888,b)|0;if(a[j>>0]|0){q=c[c[g>>2]>>2]|0;p=SEi(j|0)|0;xo[q&2047](g,j,p)|0}a[b>>0]=0;xo[c[c[g>>2]>>2]&2047](g,b,1)|0;co[c[(c[f>>2]|0)+8>>2]&2047](f,515600,c[o>>2]|0);c[r>>2]=0;c[s>>2]=0;c[l>>2]=c[g+8>>2];s=l+4|0;c[s>>2]=0;c[l+8>>2]=0;r=l+12|0;c[r>>2]=0;OHa(j);c[b>>2]=l;c[b+4>>2]=f;c[b+8>>2]=d;c[b+12>>2]=g;c[b+16>>2]=e;c[b+20>>2]=0;c[b+24>>2]=0;R2a(j,b,0)|0;c[k>>2]=l;c[k+4>>2]=f;c[k+8>>2]=d;c[k+12>>2]=g;c[k+16>>2]=e;c[k+20>>2]=0;c[k+24>>2]=0;S2a(j,k,0)|0;k=c[r>>2]|0;if(!((k&2147483647|0)!=0&(k|0)>-1)){i=h;return}k=c[s>>2]|0;if(!k){i=h;return}s=c[c[l>>2]>>2]|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,k);i=h;return}function NDa(a,b){a=a|0;b=b|0;return 0}function ODa(a){a=a|0;b[a+4>>1]=512;b[a+6>>1]=3;g[a+8>>2]=ea(0.0);g[a+12>>2]=ea(.230800003);g[a+16>>2]=ea(3.0);g[a+20>>2]=ea(3.0);g[a+24>>2]=ea(.333333343);c[a>>2]=514104;return}function PDa(a){a=a|0;var d=0,e=0,f=0;d=i;b[a+4>>1]=513;b[a+6>>1]=3;g[a+8>>2]=ea(0.0);g[a+12>>2]=ea(.230800003);g[a+16>>2]=ea(3.0);g[a+20>>2]=ea(3.0);g[a+24>>2]=ea(.333333343);c[a>>2]=517904;LCa(a+128|0);c[a>>2]=514224;g[a+304>>2]=ea(1.0);g[a+308>>2]=ea(500.0);g[a+312>>2]=ea(600.0);g[a+316>>2]=ea(.150000006);g[a+320>>2]=ea(2.0);g[a+324>>2]=ea(.349999994);g[a+224>>2]=ea(0.0);g[a+228>>2]=ea(.800000011);g[a+232>>2]=ea(.330000013);g[a+236>>2]=ea(1.0);g[a+240>>2]=ea(1.0);g[a+244>>2]=ea(.800000011);c[a+288>>2]=3;g[a+328>>2]=ea(1.0);g[a+332>>2]=ea(.00166666671);g[a+464>>2]=ea(4.0);c[a+468>>2]=7;g[a+472>>2]=ea(.5);g[a+336>>2]=ea(-4.0);g[a+340>>2]=ea(0.0);g[a+344>>2]=ea(4.0);g[a+348>>2]=ea(2.0);g[a+352>>2]=ea(1.5);g[a+356>>2]=ea(1.10000002);g[a+360>>2]=ea(1.0);e=a+364|0;f=e+100|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[a+480>>2]=ea(10.0);c[a+484>>2]=1;c[a+488>>2]=5;e=0;do{g[a+(e<<2)+496>>2]=ea(.649999976);g[a+(e<<2)+624>>2]=ea(.5);e=e+1|0}while((e|0)!=32);g[a+500>>2]=ea(.150000006);g[a+624>>2]=ea(2.0);g[a+752>>2]=ea(.449999988);g[a+756>>2]=ea(.5);g[a+760>>2]=ea(.5);g[a+764>>2]=ea(1.29999995);g[a+768>>2]=ea(1.29999995);g[a+772>>2]=ea(1.29999995);c[a+776>>2]=0;g[a+784>>2]=ea(1.0);g[a+788>>2]=ea(0.0);g[a+792>>2]=ea(0.0);g[a+796>>2]=ea(0.0);i=d;return}function QDa(d){d=d|0;var e=0,f=0,h=0;e=i;b[d+4>>1]=514;b[d+6>>1]=3;g[d+8>>2]=ea(0.0);g[d+12>>2]=ea(.230800003);g[d+16>>2]=ea(3.0);g[d+20>>2]=ea(3.0);g[d+24>>2]=ea(.333333343);c[d>>2]=517904;LCa(d+128|0);c[d>>2]=514184;g[d+304>>2]=ea(1.0);g[d+308>>2]=ea(500.0);g[d+312>>2]=ea(600.0);g[d+316>>2]=ea(.150000006);g[d+320>>2]=ea(2.0);g[d+324>>2]=ea(.349999994);g[d+224>>2]=ea(0.0);g[d+228>>2]=ea(.800000011);g[d+232>>2]=ea(.330000013);g[d+236>>2]=ea(1.0);g[d+240>>2]=ea(1.0);g[d+244>>2]=ea(.800000011);c[d+288>>2]=3;g[d+328>>2]=ea(1.0);g[d+332>>2]=ea(.00166666671);g[d+464>>2]=ea(4.0);c[d+468>>2]=7;g[d+472>>2]=ea(.5);g[d+336>>2]=ea(-4.0);g[d+340>>2]=ea(0.0);g[d+344>>2]=ea(4.0);g[d+348>>2]=ea(2.0);g[d+352>>2]=ea(1.5);g[d+356>>2]=ea(1.10000002);g[d+360>>2]=ea(1.0);f=d+364|0;h=f+100|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));g[d+480>>2]=ea(10.0);c[d+484>>2]=1;c[d+488>>2]=5;f=0;do{g[d+(f<<2)+496>>2]=ea(.649999976);g[d+(f<<2)+624>>2]=ea(.5);f=f+1|0}while((f|0)!=32);g[d+500>>2]=ea(.150000006);g[d+624>>2]=ea(2.0);f=d+752|0;a[f>>0]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=0;c[d+756>>2]=0;g[d+760>>2]=ea(0.0);i=e;return}function RDa(a){a=a|0;var d=0,e=0,f=0;d=i;b[a+4>>1]=515;b[a+6>>1]=3;g[a+8>>2]=ea(0.0);g[a+12>>2]=ea(.230800003);g[a+16>>2]=ea(3.0);g[a+20>>2]=ea(3.0);g[a+24>>2]=ea(.333333343);c[a>>2]=517904;LCa(a+128|0);c[a>>2]=514144;g[a+304>>2]=ea(1.0);g[a+308>>2]=ea(500.0);g[a+312>>2]=ea(600.0);g[a+316>>2]=ea(.150000006);g[a+320>>2]=ea(2.0);g[a+324>>2]=ea(.349999994);g[a+224>>2]=ea(0.0);g[a+228>>2]=ea(.800000011);g[a+232>>2]=ea(.330000013);g[a+236>>2]=ea(1.0);g[a+240>>2]=ea(1.0);g[a+244>>2]=ea(.800000011);c[a+288>>2]=3;g[a+328>>2]=ea(1.0);g[a+332>>2]=ea(.00166666671);g[a+464>>2]=ea(4.0);c[a+468>>2]=7;g[a+472>>2]=ea(.5);g[a+336>>2]=ea(-4.0);g[a+340>>2]=ea(0.0);g[a+344>>2]=ea(4.0);g[a+348>>2]=ea(2.0);g[a+352>>2]=ea(1.5);g[a+356>>2]=ea(1.10000002);g[a+360>>2]=ea(1.0);e=a+364|0;f=e+100|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[a+480>>2]=ea(10.0);c[a+484>>2]=1;c[a+488>>2]=5;e=0;do{g[a+(e<<2)+496>>2]=ea(.649999976);g[a+(e<<2)+624>>2]=ea(.5);e=e+1|0}while((e|0)!=32);g[a+500>>2]=ea(.150000006);g[a+624>>2]=ea(2.0);c[a+752>>2]=0;i=d;return}function SDa(a){a=a|0;var b=0;g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(.300000012);g[a+12>>2]=ea(.100000001);b=a+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+48>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+56>>2]=ea(.300000012);g[a+60>>2]=ea(.100000001);b=a+64|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+80>>2]=ea(1.0);g[a+84>>2]=ea(1.0);g[a+96>>2]=ea(0.0);g[a+100>>2]=ea(0.0);g[a+104>>2]=ea(.300000012);g[a+108>>2]=ea(.100000001);b=a+112|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+128>>2]=ea(1.0);g[a+132>>2]=ea(1.0);g[a+144>>2]=ea(0.0);g[a+148>>2]=ea(0.0);g[a+152>>2]=ea(.300000012);g[a+156>>2]=ea(.100000001);b=a+160|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+176>>2]=ea(1.0);g[a+180>>2]=ea(1.0);g[a+192>>2]=ea(0.0);g[a+196>>2]=ea(0.0);g[a+200>>2]=ea(20.0);g[a+204>>2]=ea(0.0);g[a+208>>2]=ea(.25);g[a+212>>2]=ea(1500.0);b=a+216|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;g[a+240>>2]=ea(0.0);g[a+244>>2]=ea(0.0);g[a+248>>2]=ea(20.0);g[a+252>>2]=ea(0.0);g[a+256>>2]=ea(.25);g[a+260>>2]=ea(1500.0);b=a+264|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;g[a+288>>2]=ea(0.0);g[a+292>>2]=ea(0.0);g[a+296>>2]=ea(20.0);g[a+300>>2]=ea(0.0);g[a+304>>2]=ea(.25);g[a+308>>2]=ea(1500.0);b=a+312|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;g[a+336>>2]=ea(0.0);g[a+340>>2]=ea(0.0);g[a+344>>2]=ea(20.0);g[a+348>>2]=ea(0.0);g[a+352>>2]=ea(.25);g[a+356>>2]=ea(1500.0);b=a+360|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;g[a+384>>2]=ea(2.0);g[a+388>>2]=ea(17.9049301);g[a+392>>2]=ea(1.0e3);g[a+396>>2]=ea(5.72957754);c[a+424>>2]=0;g[a+400>>2]=ea(0.0);g[a+404>>2]=ea(1.0);g[a+408>>2]=ea(.100000001);g[a+412>>2]=ea(1.0);g[a+416>>2]=ea(1.0);g[a+420>>2]=ea(1.0);g[a+428>>2]=ea(.00100000005);g[a+432>>2]=ea(10.0);g[a+436>>2]=ea(1.11111116);g[a+448>>2]=ea(2.0);g[a+452>>2]=ea(17.9049301);g[a+456>>2]=ea(1.0e3);g[a+460>>2]=ea(5.72957754);c[a+488>>2]=0;g[a+464>>2]=ea(0.0);g[a+468>>2]=ea(1.0);g[a+472>>2]=ea(.100000001);g[a+476>>2]=ea(1.0);g[a+480>>2]=ea(1.0);g[a+484>>2]=ea(1.0);g[a+492>>2]=ea(.00100000005);g[a+496>>2]=ea(10.0);g[a+500>>2]=ea(1.11111116);g[a+512>>2]=ea(2.0);g[a+516>>2]=ea(17.9049301);g[a+520>>2]=ea(1.0e3);g[a+524>>2]=ea(5.72957754);c[a+552>>2]=0;g[a+528>>2]=ea(0.0);g[a+532>>2]=ea(1.0);g[a+536>>2]=ea(.100000001);g[a+540>>2]=ea(1.0);g[a+544>>2]=ea(1.0);g[a+548>>2]=ea(1.0);g[a+556>>2]=ea(.00100000005);g[a+560>>2]=ea(10.0);g[a+564>>2]=ea(1.11111116);g[a+576>>2]=ea(2.0);g[a+580>>2]=ea(17.9049301);g[a+584>>2]=ea(1.0e3);g[a+588>>2]=ea(5.72957754);c[a+616>>2]=0;g[a+592>>2]=ea(0.0);g[a+596>>2]=ea(1.0);g[a+600>>2]=ea(.100000001);g[a+604>>2]=ea(1.0);g[a+608>>2]=ea(1.0);g[a+612>>2]=ea(1.0);g[a+620>>2]=ea(.00100000005);g[a+624>>2]=ea(10.0);g[a+628>>2]=ea(1.11111116);b=a+864|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;b=a+880|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;b=a+896|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;b=a+912|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+640>>2]=ea(0.0);g[a+644>>2]=ea(0.0);g[a+648>>2]=ea(0.0);g[a+688>>2]=ea(0.0);g[a+692>>2]=ea(0.0);g[a+696>>2]=ea(0.0);g[a+736>>2]=ea(0.0);g[a+740>>2]=ea(0.0);g[a+744>>2]=ea(0.0);g[a+784>>2]=ea(0.0);g[a+788>>2]=ea(0.0);g[a+792>>2]=ea(0.0);g[a+832>>2]=ea(1520.0);g[a+848>>2]=ea(.000657894765);g[a+652>>2]=ea(0.0);g[a+656>>2]=ea(0.0);g[a+660>>2]=ea(0.0);g[a+700>>2]=ea(0.0);g[a+704>>2]=ea(0.0);g[a+708>>2]=ea(0.0);g[a+748>>2]=ea(0.0);g[a+752>>2]=ea(0.0);g[a+756>>2]=ea(0.0);g[a+796>>2]=ea(0.0);g[a+800>>2]=ea(0.0);g[a+804>>2]=ea(0.0);g[a+836>>2]=ea(1520.0);g[a+852>>2]=ea(.000657894765);g[a+664>>2]=ea(0.0);g[a+668>>2]=ea(0.0);g[a+672>>2]=ea(0.0);g[a+712>>2]=ea(0.0);g[a+716>>2]=ea(0.0);g[a+720>>2]=ea(0.0);g[a+760>>2]=ea(0.0);g[a+764>>2]=ea(0.0);g[a+768>>2]=ea(0.0);g[a+808>>2]=ea(0.0);g[a+812>>2]=ea(0.0);g[a+816>>2]=ea(0.0);g[a+840>>2]=ea(1520.0);g[a+856>>2]=ea(.000657894765);g[a+676>>2]=ea(0.0);g[a+680>>2]=ea(0.0);g[a+684>>2]=ea(0.0);g[a+724>>2]=ea(0.0);g[a+728>>2]=ea(0.0);g[a+732>>2]=ea(0.0);g[a+772>>2]=ea(0.0);g[a+776>>2]=ea(0.0);g[a+780>>2]=ea(0.0);g[a+820>>2]=ea(0.0);g[a+824>>2]=ea(0.0);g[a+828>>2]=ea(0.0);g[a+844>>2]=ea(1520.0);g[a+860>>2]=ea(.000657894765);return}function TDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im;e=i;f=a+(b*48|0)+0|0;h=d+0|0;j=f+48|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(j|0));k=ea(g[d+8>>2]);h=k>ea(0.0);g[a+(b*48|0)+32>>2]=ea(ea(1.0)/(h?k:ea(1.0)));k=ea(g[d+12>>2]);d=k>ea(0.0);g[a+(b*48|0)+36>>2]=ea(ea(1.0)/(d?k:ea(1.0)));k=ea(g[a+(b*48|0)+200>>2]);l=ea(k+ea(g[a+(b*48|0)+16>>2]));g[a+(b<<2)+832>>2]=l;g[a+(b<<2)+848>>2]=ea(ea(1.0)/l);i=e;return}function UDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im;e=i;f=a+(b*48|0)+192|0;h=f+0|0;j=d+0|0;d=h+48|0;do{c[h>>2]=c[j>>2];h=h+4|0;j=j+4|0}while((h|0)<(d|0));g[a+(b*48|0)+228>>2]=ea(ea(1.0)/ea(g[f>>2]));g[a+(b*48|0)+232>>2]=ea(ea(1.0)/ea(g[a+(b*48|0)+204>>2]));k=ea(g[a+(b*48|0)+200>>2]);l=ea(k+ea(g[a+(b*48|0)+16>>2]));g[a+(b<<2)+832>>2]=l;g[a+(b<<2)+848>>2]=ea(ea(1.0)/l);i=e;return}function VDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im;e=i;f=a+(b<<6)+384|0;h=d+0|0;d=f+64|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(d|0));g[a+(b<<6)+428>>2]=ea(ea(1.0)/ea(g[a+(b<<6)+392>>2]));j=ea(g[a+(b<<6)+408>>2]);g[a+(b<<6)+432>>2]=ea(ea(1.0)/ea(j-ea(g[a+(b<<6)+400>>2])));g[a+(b<<6)+436>>2]=ea(ea(1.0)/ea(ea(g[a+(b<<6)+416>>2])-j));i=e;return}function WDa(a,b,c){a=a|0;b=b|0;c=c|0;g[a+(b*12|0)+640>>2]=ea(g[c>>2]);g[a+(b*12|0)+644>>2]=ea(g[c+4>>2]);g[a+(b*12|0)+648>>2]=ea(g[c+8>>2]);return}function XDa(a,b,c){a=a|0;b=b|0;c=c|0;g[a+(b*12|0)+688>>2]=ea(g[c>>2]);g[a+(b*12|0)+692>>2]=ea(g[c+4>>2]);g[a+(b*12|0)+696>>2]=ea(g[c+8>>2]);return}function YDa(a,b,c){a=a|0;b=b|0;c=c|0;g[a+(b*12|0)+736>>2]=ea(g[c>>2]);g[a+(b*12|0)+740>>2]=ea(g[c+4>>2]);g[a+(b*12|0)+744>>2]=ea(g[c+8>>2]);return}function ZDa(a,b,c){a=a|0;b=b|0;c=c|0;g[a+(b*12|0)+784>>2]=ea(g[c>>2]);g[a+(b*12|0)+788>>2]=ea(g[c+4>>2]);g[a+(b*12|0)+792>>2]=ea(g[c+8>>2]);return}function _Da(b,c,d){b=b|0;c=c|0;d=d|0;a[b+c+928>>0]=d;return}function $Da(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+(b<<4)+864|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];return}function aEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=((da(a<<2,b)|0)+47&-16)+((b<<3)+30&-32)|0;f=UJa(d,e,517952,55)|0;PEi(f|0,0,e|0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+20>>2]=0;c[f+24>>2]=a;c[f+12>>2]=0;c[f+16>>2]=b;i=d;return f|0}function bEa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;j=a+24|0;k=c[j>>2]|0;l=a+16|0;m=c[l>>2]|0;PEi(a|0,0,((da(k<<2,m)|0)+47&-16)+((m<<3)+30&-32)|0)|0;c[j>>2]=k;c[l>>2]=m;m=a+32|0;c[a>>2]=m;l=da(d,b)|0;k=(l<<2)+15&-16;j=m+k|0;n=a+4|0;c[n>>2]=j;o=m+(k+((d<<2)+15&-16))|0;k=a+8|0;c[k>>2]=o;a:do if(d){m=o;p=j;q=0;while(1){c[m+(q<<2)>>2]=c[f+(q<<2)>>2];c[p+(q<<2)>>2]=c[e+(q<<2)>>2];r=q+1|0;if((r|0)==(d|0))break a;m=c[k>>2]|0;p=c[n>>2]|0;q=r}}while(0);if(!l){s=a+20|0;c[s>>2]=b;t=a+12|0;c[t>>2]=d;i=h;return}n=c[a>>2]|0;k=0;do{g[n+(k<<2)>>2]=ea(1.0);k=k+1|0}while((k|0)!=(l|0));s=a+20|0;c[s>>2]=b;t=a+12|0;c[t>>2]=d;i=h;return}function cEa(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function dEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im;e=ea(g[(c[a>>2]|0)+((da(c[a+20>>2]|0,b)|0)+d<<2)>>2]);return ea(e)}function eEa(a){a=a|0;var b=Im;b=ea(ea(g[a>>2])*ea(5.0));g[129512]=b;g[129514]=ea(ea(1.0)/b);g[129516]=ea(g[a>>2]);g[129518]=ea(ea(g[a>>2])*ea(.200000003));g[129520]=ea(g[a>>2]);return}function fEa(){g[129512]=ea(0.0);g[129514]=ea(0.0);g[129516]=ea(0.0);g[129518]=ea(0.0);g[129520]=ea(0.0);return}function gEa(a){a=a|0;c[129522]=a;return}function hEa(){var a=0;a=c[129522]|0;c[129522]=0;return a|0}function iEa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;j=i;i=i+4592|0;k=j+4560|0;l=j+2240|0;m=j+2120|0;n=j+2132|0;o=j+4572|0;p=j;q=j+2144|0;r=j+4464|0;s=j+2252|0;if((a|0)==3){t=((f+1|0)>>>0)%3|0;u=((f+2|0)>>>0)%3|0;c[p+2116>>2]=3;c[q+92>>2]=3;g[p>>2]=ea(g[b+(t<<2)>>2]);v=b+12|0;g[p+4>>2]=ea(g[v+(t<<2)>>2]);w=b+24|0;g[p+8>>2]=ea(g[w+(t<<2)>>2]);g[p+92>>2]=ea(g[b+(u<<2)>>2]);g[p+96>>2]=ea(g[v+(u<<2)>>2]);g[p+100>>2]=ea(g[w+(u<<2)>>2]);g[p+184>>2]=ea(1.0);g[p+188>>2]=ea(1.0);g[p+192>>2]=ea(1.0);g[q>>2]=ea(ea(g[d+(t<<2)>>2])*e);g[q+4>>2]=ea(ea(g[d+(u<<2)>>2])*e);g[q+8>>2]=e;c[r+92>>2]=3;c[s+2208>>2]=0;T2a(s,p);U2a(s,q,r);g[h>>2]=ea(g[r>>2]);g[h+4>>2]=ea(g[r+4>>2]);g[h+8>>2]=ea(g[r+8>>2]);i=j;return}else if((a|0)==1){g[h>>2]=e;i=j;return}else if((a|0)==2){x=ea(g[b>>2]);g[k>>2]=x;u=k+4|0;y=ea(g[b+4>>2]);g[u>>2]=y;t=k+8|0;z=ea(g[b+8>>2]);g[t>>2]=z;g[k+(f<<2)>>2]=ea(0.0);A=ea(g[b+12>>2]);B=ea(A-x);C=ea(g[b+16>>2]);D=ea(C-y);E=ea(g[b+20>>2]);F=ea(E-z);g[l>>2]=B;w=l+4|0;g[w>>2]=D;v=l+8|0;g[v>>2]=F;g[l+(f<<2)>>2]=ea(0.0);F=ea(g[l>>2]);D=ea(F*F);B=ea(g[w>>2]);G=ea(D+ea(B*B));D=ea(g[v>>2]);H=ea(T(ea(G+ea(D*D))));if(H>ea(0.0)){G=ea(ea(1.0)/H);H=ea(F*G);g[l>>2]=H;I=ea(B*G);g[w>>2]=I;J=ea(D*G);g[v>>2]=J;K=H;L=I;M=J}else{K=F;L=B;M=D}g[m>>2]=ea(g[d>>2]);v=m+4|0;g[v>>2]=ea(g[d+4>>2]);w=m+8|0;g[w>>2]=ea(g[d+8>>2]);g[m+(f<<2)>>2]=ea(0.0);D=ea(g[m>>2]);B=ea(g[k>>2]);F=ea(D-B);D=ea(g[v>>2]);J=ea(g[u>>2]);I=ea(D-J);D=ea(g[w>>2]);H=ea(g[t>>2]);G=ea(ea(ea(F*K)+ea(I*L))+ea(ea(D-H)*M));D=ea(B+ea(K*G));B=ea(J+ea(L*G));J=ea(H+ea(M*G));g[n>>2]=x;t=n+4|0;g[t>>2]=y;w=n+8|0;g[w>>2]=z;g[n+(f<<2)>>2]=ea(0.0);g[o>>2]=A;u=o+4|0;g[u>>2]=C;v=o+8|0;g[v>>2]=E;g[o+(f<<2)>>2]=ea(0.0);E=ea(ea(g[n>>2])-D);C=ea(ea(g[t>>2])-B);A=ea(ea(ea(E*K)+ea(C*L))+ea(ea(ea(g[w>>2])-J)*M));C=ea(ea(g[o>>2])-D);D=ea(ea(g[u>>2])-B);B=ea(ea(ea(K*C)+ea(L*D))+ea(M*ea(ea(g[v>>2])-J)));J=ea(ea(B*e)/ea(B-A));A=ea(e-J);g[h>>2]=J;g[h+4>>2]=A;i=j;return}else{if(a>>>0<=3){i=j;return}v=((f+1|0)>>>0)%3|0;u=((f+2|0)>>>0)%3|0;A=ea(e/ea(a>>>0));f=a+3|0;c[p+2116>>2]=f;c[q+92>>2]=f;o=0;do{w=b+(o*12|0)|0;g[p+(o<<2)>>2]=ea(g[w+(v<<2)>>2]);g[p+(o<<2)+92>>2]=ea(g[w+(u<<2)>>2]);g[p+(o<<2)+184>>2]=ea(1.0);o=o+1|0}while((o|0)!=(a|0));if(a>>>0<4294967293){o=a;do{g[p+(o<<2)>>2]=ea(0.0);g[p+(o<<2)+92>>2]=ea(0.0);g[p+(o<<2)+184>>2]=ea(0.0);o=o+1|0}while(o>>>0<f>>>0)}g[q>>2]=ea(ea(g[d+(v<<2)>>2])*e);g[q+4>>2]=ea(ea(g[d+(u<<2)>>2])*e);g[q+8>>2]=e;d=a+1|0;o=a+2|0;e=ea(A*ea(2.0));w=a<<2;t=0;do{n=t+3|0;PEi(p+(n*92|0)|0,0,w|0)|0;g[p+(n*92|0)+(t<<2)>>2]=ea(2.0);k=b+(t*12|0)|0;g[p+(n*92|0)+(a<<2)>>2]=ea(g[k+(v<<2)>>2]);g[p+(n*92|0)+(d<<2)>>2]=ea(g[k+(u<<2)>>2]);g[p+(n*92|0)+(o<<2)>>2]=ea(1.0);g[q+(n<<2)>>2]=e;t=t+1|0}while((t|0)!=(a|0));c[r+92>>2]=f;c[s+2208>>2]=0;T2a(s,p);U2a(s,q,r);YEi(h|0,r|0,a<<2|0)|0;i=j;return}}function jEa(b,d,e){b=ea(b);d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im;f=i;h=e+65|0;do if(((a[h>>0]|0)!=0?(j=e+68|0,k=c[j>>2]|0,((c[d+132>>2]|0)+-1|0)!=(k|0)):0)?(l=e+72|0,(k|0)==(c[l>>2]|0)):0){if(!k){g[e+80>>2]=ea(0.0);c[l>>2]=2;c[j>>2]=1;break}g[e+80>>2]=ea(0.0);if((k|0)==1){c[l>>2]=2;c[j>>2]=1;break}else{c[l>>2]=k+1;c[j>>2]=1;break}}while(0);j=e+66|0;k=e+68|0;l=c[k>>2]|0;do if(a[j>>0]|0)if(l){m=e+72|0;if((l|0)==(c[m>>2]|0)){if((l|0)==2){g[e+80>>2]=ea(0.0);c[m>>2]=0;c[k>>2]=1;n=1;break}g[e+80>>2]=ea(0.0);if((l|0)==1){c[m>>2]=0;c[k>>2]=1;n=1;break}else{c[m>>2]=l+-1;c[k>>2]=1;n=1;break}}else n=l}else n=0;else n=l;while(0);l=c[e+72>>2]|0;if((n|0)==(l|0)){i=f;return}n=e+80|0;o=ea(g[n>>2]);if(o>ea(g[d+136>>2])){c[e+68>>2]=l;g[n>>2]=ea(0.0);a[j>>0]=0;a[h>>0]=0;i=f;return}else{g[n>>2]=ea(o+b);i=f;return}}function kEa(b,c,d,e,f,h,j){b=ea(b);c=ea(c);d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=Im,m=Im,n=0,o=0,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=0;k=i;l=ea(S(ea(b)));m=ea(S(ea(c)));n=(d|0)==0;if(!n){o=0;p=ea(0.0);while(1){if(!(a[e+o>>0]|0))q=p;else q=ea(p+ea(1.0));o=o+2|0;if(o>>>0>=d>>>0)break;else p=q}if(q>ea(0.0))r=ea(ea(1.0)/q);else r=ea(0.0);o=d>>>0>1;if(o){s=1;q=ea(0.0);while(1){if(!(a[e+s>>0]|0))t=q;else t=ea(q+ea(1.0));s=s+2|0;if(s>>>0>=d>>>0)break;else q=t}if(t>ea(0.0)){u=r;v=ea(ea(1.0)/t);w=o}else{u=r;v=ea(0.0);w=o}}else{u=r;v=ea(0.0);w=0}}else{u=ea(0.0);v=ea(0.0);w=0}r=ea(l+m);if(r>ea(.00100000005)){t=ea(ea(ea(l-m)*ea(.5))/r);r=ea(t+ea(.5));m=ea(ea(.5)-t);o=b<=ea(-0.0);t=o?ea(0.0):ea(1.0);o=b>=ea(0.0);b=o?t:ea(-1.0);o=c<=ea(-0.0);t=o?ea(0.0):ea(1.0);o=c>=ea(0.0);x=m;y=r;z=b;A=o?t:ea(-1.0)}else{x=ea(.5);y=ea(.5);z=ea(1.0);A=ea(1.0)}t=ea(u*y);y=ea(v*x);x=ea(u*ea(.5));u=ea(v*ea(.5));if(!n){n=0;do{if(a[e+n>>0]|0){g[f+(n<<2)>>2]=x;g[h+(n<<2)>>2]=t;g[j+(n<<2)>>2]=z}n=n+2|0}while(n>>>0<d>>>0)}if(w)B=1;else{i=k;return}do{if(a[e+B>>0]|0){g[f+(B<<2)>>2]=u;g[h+(B<<2)>>2]=y;g[j+(B<<2)>>2]=A}B=B+2|0}while(B>>>0<d>>>0);i=k;return}function lEa(a,b,c,d,e,f,h,j,k,l,m,n,o,p,q,r,s){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=ea(f);h=ea(h);j=ea(j);k=ea(k);l=ea(l);m=ea(m);n=ea(n);o=ea(o);p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=Im;t=i;g[p>>2]=ea(0.0);g[q>>2]=ea(0.0);g[r>>2]=ea(0.0);g[s>>2]=ea(0.0);if(d==ea(0.0)&c==ea(0.0)&e==ea(0.0)){i=t;return}j=ea(ea(g[a+4>>2])*k);k=ea(l*ea(3.0));l=ea(k/ea(g[a>>2]));k=ea(ea(l-ea(l*ea(l*ea(.333330005))))+ea(l*ea(l*ea(l*ea(.0370370001)))));u=k>ea(1.0);l=ea(j*(u?ea(1.0):k));k=ea(ea(g[a+8>>2])*n);j=ea(+X(+(+ea(d-ea(ea(ea(ea(g[a+12>>2])*n)*e)/l)))));e=ea(b*m);m=ea(ea(T(ea(ea(ea(k*ea(k*c))*c)+ea(j*ea(l*ea(j*l))))))/e);k=ea(m*ea(m*ea(.333330005)));b=ea(m*ea(m*ea(m*ea(.0370370001))));n=ea(ea(m-k)+b);u=n>ea(1.0);d=u?ea(1.0):n;n=ea(ea(ea(m-ea(m*m))+ea(m*k))-ea(m*b));if(!(m<=ea(6.28318548)))v=ea(1.0);else{b=ea(l*ea(ea(g[a+44>>2])*o));v=ea(ea(ea(b+ea(1.0))-ea(ea(+V(+ea(m*ea(.5))))*ea(ea(1.0)-b)))*ea(.5))}b=ea(j*v);m=ea(e/ea(T(ea(ea(c*c)+ea(j*ea(v*b))))));v=ea(ea(d*c)*m);c=ea(-ea(ea(d*b)*m));d=ea(ea(n*b)*m);g[p>>2]=ea(-ea(v*h));g[q>>2]=v;g[r>>2]=c;g[s>>2]=d;i=t;return}function mEa(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,T=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=0,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=0,Bb=0,Cb=0,Db=Im,Eb=Im,Fb=Im,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=0,Wb=Im,Xb=Im,Yb=Im,Zb=0,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=0,tc=Im,uc=0,vc=Im;k=i;i=i+2448|0;l=k+116|0;m=k+64|0;n=k+144|0;o=k+216|0;p=k+96|0;q=k+32|0;r=k+48|0;s=k+176|0;t=k+200|0;u=k+280|0;v=k+328|0;w=k+376|0;x=k+128|0;y=k+16|0;z=k;A=k+2440|0;B=k+160|0;C=k+80|0;D=k+192|0;E=k+28|0;F=k+112|0;G=k+12|0;if(c[129524]|0){H=c[518096+(d<<2)>>2]|0;g[H>>2]=ea(0.0);I=c[518096+(d+1<<2)>>2]|0;g[I>>2]=ea(0.0);J=c[518096+(d+2<<2)>>2]|0;g[J>>2]=ea(0.0);K=c[518096+(d+3<<2)>>2]|0;g[K>>2]=ea(0.0);g[H+4>>2]=ea(0.0);g[I+4>>2]=ea(0.0);g[J+4>>2]=ea(0.0);g[K+4>>2]=ea(0.0);g[H+8>>2]=ea(0.0);g[I+8>>2]=ea(0.0);g[J+8>>2]=ea(0.0);g[K+8>>2]=ea(0.0);g[H+12>>2]=ea(0.0);g[I+12>>2]=ea(0.0);g[J+12>>2]=ea(0.0);g[K+12>>2]=ea(0.0);g[H+28>>2]=ea(0.0);g[I+28>>2]=ea(0.0);g[J+28>>2]=ea(0.0);g[K+28>>2]=ea(0.0);g[H+36>>2]=ea(0.0);g[I+36>>2]=ea(0.0);g[J+36>>2]=ea(0.0);g[K+36>>2]=ea(0.0);g[H+24>>2]=ea(0.0);g[I+24>>2]=ea(0.0);g[J+24>>2]=ea(0.0);g[K+24>>2]=ea(0.0);g[H+32>>2]=ea(0.0);g[I+32>>2]=ea(0.0);g[J+32>>2]=ea(0.0);g[K+32>>2]=ea(0.0);g[H+20>>2]=ea(0.0);g[I+20>>2]=ea(0.0);g[J+20>>2]=ea(0.0);g[K+20>>2]=ea(0.0)}L=ea(g[f>>2]);M=ea(g[f+4>>2]);N=ea(g[f+24>>2]);O=ea(g[f+20>>2]);K=a[f+28>>0]|0;P=ea(g[f+32>>2]);J=h+72|0;I=c[J>>2]|0;H=c[h+76>>2]|0;Q=c[h+80>>2]|0;R=c[h+84>>2]|0;T=ea(ea(1.0)*ea(2.0));U=ea(ea(0.0)*ea(2.0));V=ea(ea(0.0)*ea(2.0));W=h+32|0;X=ea(g[W>>2]);Y=ea(ea(X*X)+ea(-.5));Z=h+20|0;$=ea(g[Z>>2]);aa=ea(T*$);ba=h+24|0;ca=ea(g[ba>>2]);da=ea(aa+ea(U*ca));fa=h+28|0;aa=ea(g[fa>>2]);ga=ea(da+ea(V*aa));da=ea(ea(ca*ga)+ea(ea(U*Y)+ea(X*ea(ea(T*aa)-ea(V*$)))));ha=ea(ea(ea(V*Y)+ea(X*ea(ea(U*$)-ea(T*ca))))+ea(aa*ga));g[l>>2]=ea(ea($*ga)+ea(ea(T*Y)+ea(X*ea(ea(V*ca)-ea(U*aa)))));g[l+4>>2]=da;g[l+8>>2]=ha;ia=c[h+12>>2]|0;ja=c[h+8>>2]|0;ka=c[h+4>>2]|0;la=c[h+16>>2]|0;ma=K<<24>>24==0;K=(a[h>>0]|0)!=0;na=c[H+196>>2]|0;oa=h+88|0;pa=(c[oa>>2]|0)==0;if(!na){if(!pa){qa=H+80|0;ra=H+176|0;sa=H+160|0;ta=H+144|0;ua=0;do{va=e[ra+(ua<<1)>>1]|0;c[m+(ua<<2)>>2]=va;wa=sa+(ua<<2)|0;g[n+(ua<<2)>>2]=ea(g[wa>>2]);ha=ea(g[qa+(ua<<4)>>2]);g[o+(ua<<4)>>2]=ha;xa=qa+(ua<<4)+4|0;g[o+(ua<<4)+4>>2]=ea(g[xa>>2]);ya=qa+(ua<<4)+8|0;g[o+(ua<<4)+8>>2]=ea(g[ya>>2]);za=qa+(ua<<4)+12|0;g[o+(ua<<4)+12>>2]=ea(g[za>>2]);Aa=ta+(ua<<2)|0;g[p+(ua<<2)>>2]=ea(g[Aa>>2]);c[q+(ua<<2)>>2]=0;c[r+(ua<<2)>>2]=0;c[s+(ua<<2)>>2]=0;c[t+(ua<<2)>>2]=-1;g[u+(ua*12|0)>>2]=ea(0.0);g[u+(ua*12|0)+4>>2]=ea(0.0);g[u+(ua*12|0)+8>>2]=ea(0.0);g[v+(ua*12|0)>>2]=ea(0.0);g[v+(ua*12|0)+4>>2]=ea(0.0);g[v+(ua*12|0)+8>>2]=ea(0.0);c[j+(ua<<2)+888>>2]=va;g[j+(ua<<4)+904>>2]=ha;g[j+(ua<<4)+908>>2]=ea(g[xa>>2]);g[j+(ua<<4)+912>>2]=ea(g[ya>>2]);g[j+(ua<<4)+916>>2]=ea(g[za>>2]);g[j+(ua<<2)+968>>2]=ea(g[wa>>2]);g[j+(ua<<2)+984>>2]=ea(g[Aa>>2]);ua=ua+1|0}while(ua>>>0<(c[oa>>2]|0)>>>0)}}else if(!pa){pa=f+40|0;ua=w+2060|0;ta=w+4|0;qa=w+8|0;sa=0;do{ra=a[na+(sa*80|0)+77>>0]|0;Aa=ra&255;wa=m+(sa<<2)|0;if(!(ra<<24>>24)){c[wa>>2]=0;g[n+(sa<<2)>>2]=ea(0.0);ra=o+(sa<<4)|0;c[ra+0>>2]=0;c[ra+4>>2]=0;c[ra+8>>2]=0;c[ra+12>>2]=0;g[p+(sa<<2)>>2]=ea(0.0);c[q+(sa<<2)>>2]=0;c[r+(sa<<2)>>2]=0;c[s+(sa<<2)>>2]=0;c[t+(sa<<2)>>2]=-1;g[u+(sa*12|0)>>2]=ea(0.0);g[u+(sa*12|0)+4>>2]=ea(0.0);g[u+(sa*12|0)+8>>2]=ea(0.0);g[v+(sa*12|0)>>2]=ea(0.0);g[v+(sa*12|0)+4>>2]=ea(0.0);g[v+(sa*12|0)+8>>2]=ea(0.0);c[j+(sa<<2)+888>>2]=0;ra=j+(sa<<4)+904|0;c[ra+0>>2]=0;c[ra+4>>2]=0;c[ra+8>>2]=0;c[ra+12>>2]=0;g[j+(sa<<2)+968>>2]=ea(0.0);g[j+(sa<<2)+984>>2]=ea(0.0)}else{c[wa>>2]=Aa;wa=na+(sa*80|0)+40|0;ha=ea(g[wa>>2]);g[n+(sa<<2)>>2]=ha;ra=na+(sa*80|0)+16|0;da=ea(g[ra>>2]);za=na+(sa*80|0)+20|0;aa=ea(g[za>>2]);ya=na+(sa*80|0)+24|0;U=ea(g[ya>>2]);xa=na+(sa*80|0)+28|0;ca=ea(g[xa>>2]);va=na+(sa*80|0)+32|0;V=ea(g[va>>2]);Ba=na+(sa*80|0)+36|0;X=ea(g[Ba>>2]);Y=ea(-ea(ea(ea(da*ca)+ea(aa*V))+ea(U*X)));g[o+(sa<<4)>>2]=ca;g[o+(sa<<4)+4>>2]=V;g[o+(sa<<4)+8>>2]=X;g[o+(sa<<4)+12>>2]=Y;if(ha!=ea(0.0)){Ca=c[na+(sa*80|0)+4>>2]|0;Da=_n[c[(c[Ca>>2]|0)+108>>2]&4095](Ca,c[na+(sa*80|0)+8>>2]|0)|0}else Da=0;Ca=c[pa>>2]|0;V2a(w,Ca);a:do if((Da|0)!=0?(Ea=c[w+((Da>>>(c[ua>>2]|0)&255)<<2)+12>>2]|0,(Ea|0)!=-1):0){Fa=c[ta>>2]|0;Ga=Ea;while(1){if((c[Fa+(Ga<<2)>>2]|0)==(Da|0))break;Ea=c[w+(Ga<<2)+1036>>2]|0;if((Ea|0)==-1){Ha=0;break a}else Ga=Ea}Ha=c[(c[qa>>2]|0)+(Ga<<2)>>2]|0}else Ha=0;while(0);ha=ea(dEa(Ca,Ha,c[(c[J>>2]|0)+(sa<<6)+424>>2]|0));g[p+(sa<<2)>>2]=ha;c[q+(sa<<2)>>2]=c[na+(sa*80|0)+4>>2];c[r+(sa<<2)>>2]=c[na+(sa*80|0)>>2];c[s+(sa<<2)>>2]=Da;c[t+(sa<<2)>>2]=Ha;g[u+(sa*12|0)>>2]=ea(g[ra>>2]);g[u+(sa*12|0)+4>>2]=ea(g[za>>2]);g[u+(sa*12|0)+8>>2]=ea(g[ya>>2]);g[v+(sa*12|0)>>2]=ea(g[xa>>2]);g[v+(sa*12|0)+4>>2]=ea(g[va>>2]);g[v+(sa*12|0)+8>>2]=ea(g[Ba>>2]);c[j+(sa<<2)+888>>2]=Aa;g[j+(sa<<4)+904>>2]=ca;g[j+(sa<<4)+908>>2]=V;g[j+(sa<<4)+912>>2]=X;g[j+(sa<<4)+916>>2]=Y;g[j+(sa<<2)+968>>2]=ea(g[wa>>2]);g[j+(sa<<2)+984>>2]=ha}sa=sa+1|0}while(sa>>>0<(c[oa>>2]|0)>>>0)}oa=x+4|0;sa=x+8|0;Ha=h+36|0;Da=h+40|0;na=h+44|0;J=y+4|0;qa=y+8|0;w=h+48|0;ta=h+52|0;ua=h+56|0;pa=h+64|0;Fa=h+68|0;Ea=h+60|0;h=f+8|0;Ia=f+12|0;Ja=f+16|0;f=j+484|0;Ka=j+488|0;La=j+492|0;Ma=j+496|0;Na=j+500|0;Oa=j+504|0;Pa=R+8|0;Qa=R+4|0;Ra=R+12|0;Sa=R+16|0;Ta=B+4|0;Ua=B+8|0;Va=C+4|0;Wa=C+8|0;Xa=Q+16|0;Ya=z+4|0;Za=z+8|0;_a=0;do{$a=j+(_a<<2)+508|0;g[$a>>2]=ea(g[H+(_a<<2)+48>>2]);ab=j+(_a<<2)+524|0;g[ab>>2]=ea(g[H+(_a<<2)+64>>2]);bb=I+(_a*48|0)+12|0;if(c[129524]|0){ha=ea(-ea(g[bb>>2]));g[c[518096+(_a+d<<2)>>2]>>2]=ha}cb=j+(_a<<2)+292|0;g[cb>>2]=ea(-ea(g[bb>>2]));db=j+_a+652|0;a[db>>0]=0;eb=j+(_a<<2)+636|0;g[eb>>2]=ea(0.0);fb=j+_a+768|0;a[fb>>0]=0;gb=j+(_a<<2)+752|0;g[gb>>2]=ea(0.0);hb=j+_a+884|0;a[hb>>0]=0;ib=j+(_a<<2)+868|0;g[ib>>2]=ea(0.0);jb=j+_a+112|0;a[jb>>0]=1;kb=a[la+_a>>0]|0;lb=c[m+(_a<<2)>>2]|0;ha=ea(g[n+(_a<<2)>>2]);U=ea(g[o+(_a<<4)>>2]);aa=ea(g[o+(_a<<4)+4>>2]);da=ea(g[o+(_a<<4)+8>>2]);g[x>>2]=U;g[oa>>2]=aa;g[sa>>2]=da;mb=I+(_a*48|0)+192|0;aa=ea(g[mb>>2]);nb=I+(_a*48|0)+8|0;U=ea(g[nb>>2]);ob=I+(_a*12|0)+640|0;T=ea(ea(g[ob>>2])*ea(2.0));pb=I+(_a*12|0)+644|0;ga=ea(ea(g[pb>>2])*ea(2.0));qb=I+(_a*12|0)+648|0;$=ea(ea(g[qb>>2])*ea(2.0));rb=ea(g[W>>2]);sb=ea(ea(rb*rb)+ea(-.5));tb=ea(g[Z>>2]);ub=ea(T*tb);vb=ea(g[ba>>2]);wb=ea(ub+ea(ga*vb));ub=ea(g[fa>>2]);xb=ea(wb+ea($*ub));wb=ea(ea(tb*xb)+ea(ea(T*sb)+ea(rb*ea(ea($*vb)-ea(ga*ub)))));yb=ea(ea(vb*xb)+ea(ea(ga*sb)+ea(rb*ea(ea(T*ub)-ea($*tb)))));zb=ea(ea(ea($*sb)+ea(rb*ea(ea(ga*tb)-ea(T*vb))))+ea(ub*xb));Ab=I+(_a*12|0)+784|0;xb=ea(ea(g[Ab>>2])*ea(2.0));Bb=I+(_a*12|0)+788|0;T=ea(ea(g[Bb>>2])*ea(2.0));Cb=I+(_a*12|0)+792|0;ga=ea(ea(g[Cb>>2])*ea(2.0));$=ea(ea(ea(tb*xb)+ea(vb*T))+ea(ub*ga));Db=ea(ea(tb*$)+ea(ea(sb*xb)+ea(rb*ea(ea(vb*ga)-ea(ub*T)))));Eb=ea(ea(vb*$)+ea(ea(sb*T)+ea(rb*ea(ea(ub*xb)-ea(tb*ga)))));Fb=ea(ea(ea(sb*ga)+ea(rb*ea(ea(tb*T)-ea(vb*xb))))+ea(ub*$));$=ea(ea(g[Ha>>2])+Db);Db=ea(ea(g[Da>>2])+Eb);Eb=ea(aa+U);ub=ea($-ea(Eb*wb));$=ea(Db-ea(Eb*yb));Db=ea(ea(ea(g[na>>2])+Fb)-ea(Eb*zb));do if(((lb|0)!=0&kb<<24>>24!=0&ha!=ea(0.0)?(Eb=ea(g[x>>2]),Fb=ea(wb*Eb),xb=ea(g[oa>>2]),vb=ea(Fb+ea(yb*xb)),Fb=ea(ea(da*zb)+vb),Fb<ea(0.0)):0)?(T=ea(g[p+(_a<<2)>>2]),tb=ea(ea(aa*ea(2.0))+U),rb=ea(tb-ea(ea(-ea(ea(ea(da*Db)+ea(ea(ub*Eb)+ea($*xb)))+ea(g[o+(_a<<4)+12>>2])))/Fb)),rb>ea(-ea(g[bb>>2]))):0){c[j+(_a<<2)+132>>2]=c[q+(_a<<2)>>2];Gb=c[r+(_a<<2)>>2]|0;c[j+(_a<<2)+116>>2]=Gb;c[j+(_a<<2)+148>>2]=c[s+(_a<<2)>>2];c[j+(_a<<2)+164>>2]=c[t+(_a<<2)>>2];Hb=u+(_a*12|0)|0;g[j+(_a*12|0)+180>>2]=ea(g[Hb>>2]);Ib=u+(_a*12|0)+4|0;g[j+(_a*12|0)+184>>2]=ea(g[Ib>>2]);Jb=u+(_a*12|0)+8|0;g[j+(_a*12|0)+188>>2]=ea(g[Jb>>2]);g[j+(_a*12|0)+228>>2]=ea(g[v+(_a*12|0)>>2]);g[j+(_a*12|0)+232>>2]=ea(g[v+(_a*12|0)+4>>2]);g[j+(_a*12|0)+236>>2]=ea(g[v+(_a*12|0)+8>>2]);a[jb>>0]=0;g[eb>>2]=ea(rb-ea(g[nb>>2]));a[db>>0]=rb>ea(g[nb>>2])&1;g[j+(_a*12|0)+540>>2]=ea(g[Ab>>2]);g[j+(_a*12|0)+544>>2]=ea(g[Bb>>2]);g[j+(_a*12|0)+548>>2]=ea(g[Cb>>2]);g[j+(_a*12|0)+588>>2]=ea(g[ob>>2]);g[j+(_a*12|0)+592>>2]=ea(g[pb>>2]);g[j+(_a*12|0)+596>>2]=ea(g[qb>>2]);Fb=ea(g[nb>>2]);ga=rb<Fb?rb:Fb;g[cb>>2]=ga;Kb=c[129524]|0;if(Kb)g[c[518096+(_a+d<<2)>>2]>>2]=ga;Fb=ea(tb-ga);tb=ea(ub+ea(wb*Fb));rb=ea($+ea(yb*Fb));sb=ea(Db+ea(zb*Fb));g[y>>2]=tb;g[J>>2]=rb;g[qa>>2]=sb;Fb=ea(tb-ea(g[Ha>>2]));tb=ea(rb-ea(g[Da>>2]));rb=ea(sb-ea(g[na>>2]));sb=ea(g[w>>2]);Lb=ea(g[ta>>2]);Mb=ea(g[ua>>2]);Nb=ea(g[pa>>2]);Ob=ea(rb*Nb);Pb=ea(g[Fa>>2]);Qb=ea(Ob-ea(tb*Pb));Ob=ea(Fb*Pb);Pb=ea(g[Ea>>2]);Rb=ea(sb+Qb);Qb=ea(Lb+ea(Ob-ea(rb*Pb)));rb=ea(Mb+ea(ea(tb*Pb)-ea(Fb*Nb)));if((Gb|0)!=0?(b[Gb+4>>1]|0)==5:0){pU(z,Gb,y);Nb=ea(g[z>>2]);Fb=ea(g[Ya>>2]);Pb=ea(g[Za>>2]);tb=ea(Rb-Nb);Mb=ea(Qb-Fb);Ob=ea(rb-Pb);Sb=tb;Tb=Mb;Ub=Ob;Vb=c[129524]|0;Wb=Nb;Xb=Fb;Yb=Pb;Zb=Gb}else{Sb=Rb;Tb=Qb;Ub=rb;Vb=Kb;Wb=ea(0.0);Xb=ea(0.0);Yb=ea(0.0);Zb=0}rb=ea(ea(zb*Ub)+ea(ea(yb*Tb)+ea(wb*Sb)));Qb=ea(wb*ea(g[h>>2]));Rb=ea(Qb+ea(yb*ea(g[Ia>>2])));Qb=ea(Rb+ea(zb*ea(g[Ja>>2])));Kb=Qb<ea(0.0);Rb=Kb?ea(0.0):Qb;Qb=ea(ea(g[I+(_a*48|0)+16>>2])*Rb);Rb=ea(ea(ga*ea(g[I+(_a*48|0)>>2]))+Qb);Qb=ea(ea(rb*ea(g[I+(_a*48|0)+4>>2]))+Rb);Kb=Qb>ea(0.0);Rb=Kb?Qb:ea(0.0);g[j+(_a<<2)+308>>2]=Rb;if(Vb)g[(c[518096+(_a+d<<2)>>2]|0)+4>>2]=Rb;Qb=ea(Rb*ea(-1.0));Rb=ea(zb*Qb);rb=ea(ea(ea(wb*Qb)*Eb)+ea(ea(yb*Qb)*xb));Pb=ea(g[sa>>2]);Fb=ea(rb+ea(Rb*Pb));Rb=ea(Eb*Fb);rb=ea(xb*Fb);Nb=ea(Pb*Fb);Fb=ea(ea(g[I+(_a*12|0)+688>>2])*ea(2.0));Ob=ea(ea(g[I+(_a*12|0)+692>>2])*ea(2.0));Mb=ea(ea(g[I+(_a*12|0)+696>>2])*ea(2.0));tb=ea(g[W>>2]);Lb=ea(ea(tb*tb)+ea(-.5));sb=ea(g[Z>>2]);_b=ea(Fb*sb);$b=ea(g[ba>>2]);ac=ea(_b+ea(Ob*$b));_b=ea(g[fa>>2]);bc=ea(ac+ea(Mb*_b));ac=ea(ea(sb*bc)+ea(ea(Fb*Lb)+ea(tb*ea(ea(Mb*$b)-ea(Ob*_b)))));cc=ea(ea($b*bc)+ea(ea(Ob*Lb)+ea(tb*ea(ea(Fb*_b)-ea(Mb*sb)))));dc=ea(ea(ea(Mb*Lb)+ea(tb*ea(ea(Ob*sb)-ea(Fb*$b))))+ea(_b*bc));bc=ea(ea(Nb*cc)-ea(rb*dc));_b=ea(ea(Rb*dc)-ea(Nb*ac));dc=ea(ea(rb*ac)-ea(Rb*cc));g[f>>2]=ea(Rb+ea(g[f>>2]));g[Ka>>2]=ea(rb+ea(g[Ka>>2]));g[La>>2]=ea(Nb+ea(g[La>>2]));g[Ma>>2]=ea(ea(g[Ma>>2])+bc);g[Na>>2]=ea(ea(g[Na>>2])+_b);g[Oa>>2]=ea(ea(g[Oa>>2])+dc);dc=ea(Qb*ea(vb+ea(zb*Pb)));vb=ea(Eb*ea(g[h>>2]));Eb=ea(vb+ea(xb*ea(g[Ia>>2])));xb=ea(Eb+ea(Pb*ea(g[Ja>>2])));Kb=xb<ea(0.0);Eb=Kb?xb:ea(0.0);xb=ea(dc-ea(ea(g[I+(_a*48|0)+200>>2])*Eb));if((Zb|0)!=0?(In[c[(c[Zb>>2]|0)+204>>2]&4095](A,Zb),(a[A>>0]&1)==0):0){c[j+(_a<<2)+1e3>>2]=Zb;Eb=ea(-xb);dc=ea(ea(g[x>>2])*Eb);vb=ea(L*ea(ea(g[oa>>2])*Eb));Qb=ea(L*ea(Pb*Eb));g[j+(_a*12|0)+1016>>2]=ea(L*dc);g[j+(_a*12|0)+1020>>2]=vb;g[j+(_a*12|0)+1024>>2]=Qb;g[j+(_a*12|0)+1064>>2]=ea(g[Hb>>2]);g[j+(_a*12|0)+1068>>2]=ea(g[Ib>>2]);g[j+(_a*12|0)+1072>>2]=ea(g[Jb>>2])}Qb=ea(N*xb);vb=ea(Qb*ea(g[I+(_a<<2)+848>>2]));Qb=ea(g[R>>2]);do if(!(Qb>=vb))if(!(ea(g[Pa>>2])<=vb)){dc=ea(g[Qa>>2]);Eb=ea(g[Ra>>2]);ec=ea(dc+ea(ea(g[Sa>>2])*ea(ea(vb-Qb)*ea(Eb-dc))));break}else{ec=ea(g[Ra>>2]);break}else ec=ea(g[Qa>>2]);while(0);Qb=ea(O*ec);Ga=I+(_a<<2)+832|0;dc=ea(Qb*ea(g[Ga>>2]));if(c[129524]|0){Jb=c[518096+(_a+d<<2)>>2]|0;g[Jb+8>>2]=dc;g[Jb+12>>2]=ec}W2a(l,x,ea(g[ia+(_a<<2)>>2]),B,C);Qb=ea(g[B>>2]);g[j+(_a*12|0)+324>>2]=Qb;Eb=ea(g[Ta>>2]);g[j+(_a*12|0)+328>>2]=Eb;Pb=ea(g[Ua>>2]);g[j+(_a*12|0)+332>>2]=Pb;_b=ea(g[C>>2]);g[j+(_a*12|0)+372>>2]=_b;bc=ea(g[Va>>2]);g[j+(_a*12|0)+376>>2]=bc;Nb=ea(g[Wa>>2]);g[j+(_a*12|0)+380>>2]=Nb;rb=ea(ea(ea(Sb*Qb)+ea(Tb*Eb))+ea(Ub*Pb));Rb=ea(ea(ea(Sb*_b)+ea(Tb*bc))+ea(Ub*Nb));g[j+(_a<<2)+452>>2]=rb;cc=ea(g[H+(_a<<2)>>2]);ac=ea(g[mb>>2]);$b=ea(S(ea(rb)));Fb=ea(cc*ac);sb=ea(S(ea(Fb)));Ob=ea(+_(+(+ea(Rb/ea($b+ea(g[129516]))))));do if(!(rb==ea(0.0)&cc==ea(0.0))){Jb=(a[ka+_a>>0]|a[ja+_a>>0])<<24>>24!=0;tb=ea(Fb-rb);if(ma){Lb=$b>sb?$b:sb;if(Jb){fc=ea(tb/ea(Lb+ea(ea(g[129520])*ea(.100000001))));break}else{fc=ea(tb/(Lb<P?P:Lb));break}}else if(Jb){fc=ea(tb/ea($b+ea(ea(g[129520])*ea(.100000001))));break}else{Lb=$b>sb?$b:sb;fc=ea(tb/(Lb<P?P:Lb));break}}else fc=ea(0.0);while(0);Jb=j+(_a<<2)+420|0;g[Jb>>2]=fc;Ib=j+(_a<<2)+436|0;g[Ib>>2]=Ob;sb=ea(g[I+(_a*48|0)+20>>2]);if(ga>ea(0.0)){Fb=ea(ga*ea(g[I+(_a*48|0)+24>>2]));gc=ea(sb+ea(Fb*ea(g[I+(_a*48|0)+32>>2])))}else{Fb=ea(ga*ea(g[I+(_a*48|0)+28>>2]));gc=ea(sb-ea(Fb*ea(g[I+(_a*48|0)+36>>2])))}Fb=ea(g[I+(_a<<6)+404>>2]);sb=ea(g[I+(_a<<6)+408>>2]);Lb=ea(g[I+(_a<<6)+412>>2]);tb=ea(g[I+(_a<<6)+420>>2]);Mb=ea(g[I+(_a<<6)+436>>2]);hc=ea(S(ea(fc)));if(!(hc<sb))if(hc<ea(g[I+(_a<<6)+416>>2]))ic=ea(Lb+ea(Mb*ea(ea(tb-Lb)*ea(hc-sb))));else ic=tb;else{tb=ea(g[I+(_a<<6)+432>>2]);ic=ea(Fb+ea(tb*ea(ea(Lb-Fb)*ea(hc-ea(g[I+(_a<<6)+400>>2])))))}hc=ea(T*ic);Hb=j+(_a<<2)+276|0;g[Hb>>2]=hc;if(ea(T*dc)>ea(0.0)){Fb=ea(ea(g[I+(_a*12|0)+736>>2])*ea(2.0));Lb=ea(ea(g[I+(_a*12|0)+740>>2])*ea(2.0));tb=ea(ea(g[I+(_a*12|0)+744>>2])*ea(2.0));sb=ea(g[W>>2]);Mb=ea(ea(sb*sb)+ea(-.5));jc=ea(g[Z>>2]);kc=ea(Fb*jc);lc=ea(g[ba>>2]);mc=ea(kc+ea(Lb*lc));kc=ea(g[fa>>2]);nc=ea(mc+ea(tb*kc));mc=ea(ea(jc*nc)+ea(ea(Fb*Mb)+ea(sb*ea(ea(tb*lc)-ea(Lb*kc)))));oc=ea(ea(lc*nc)+ea(ea(Lb*Mb)+ea(sb*ea(ea(Fb*kc)-ea(tb*jc)))));pc=ea(ea(ea(tb*Mb)+ea(sb*ea(ea(Lb*jc)-ea(Fb*lc))))+ea(kc*nc));Kb=I+(_a*48|0)+228|0;nc=ea(g[$a>>2]);kc=ea(g[129518]);do if($b<kc){if(!(ea(S(ea(cc)))<ea(kc*ea(g[Kb>>2])))|K){qc=ea(0.0);break}qc=ea(M+nc)}else qc=ea(0.0);while(0);if(qc>ea(1.0)|(cc!=ea(0.0)|!($b<kc)|K)^1){rc=ea(rb*ea(.00999999977));sc=1}else{rc=ea(0.0);sc=0}nc=ea(rc+ea(ea(ea(Wb*Qb)+ea(Xb*Eb))+ea(Yb*Pb)));g[$a>>2]=qc;a[fb>>0]=sc;g[gb>>2]=nc;g[j+(_a*12|0)+704>>2]=Qb;g[j+(_a*12|0)+708>>2]=Eb;g[j+(_a*12|0)+712>>2]=Pb;g[j+(_a*12|0)+656>>2]=mc;g[j+(_a*12|0)+660>>2]=oc;g[j+(_a*12|0)+664>>2]=pc;nc=sc<<24>>24!=0?ea(0.0):fc;g[Jb>>2]=nc;T=ea(S(ea(Rb)));do if(!(T<ea(g[129518]))|K){tc=ea(0.0);uc=0;vc=ea(0.0)}else{ga=ea(M+ea(g[ab>>2]));if(!(qc>ea(0.0)&ga>ea(1.0))){tc=ea(0.0);uc=0;vc=ga;break}tc=ea(Rb*ea(.100000001));uc=1;vc=ga}while(0);Rb=ea(tc+ea(ea(ea(Wb*_b)+ea(Xb*bc))+ea(Yb*Nb)));g[ab>>2]=vc;a[hb>>0]=uc;g[ib>>2]=Rb;g[j+(_a*12|0)+820>>2]=_b;g[j+(_a*12|0)+824>>2]=bc;g[j+(_a*12|0)+828>>2]=Nb;g[j+(_a*12|0)+772>>2]=mc;g[j+(_a*12|0)+776>>2]=oc;g[j+(_a*12|0)+780>>2]=pc;Rb=uc<<24>>24!=0?ea(0.0):Ob;g[Ib>>2]=Rb;g[D>>2]=ea(0.0);g[E>>2]=ea(0.0);g[F>>2]=ea(0.0);g[G>>2]=ea(0.0);T=ea(O*ea(g[Ga>>2]));rb=ea(g[Kb>>2]);Ho[c[Xa>>2]&1](c[Q+(_a<<2)>>2]|0,hc,nc,Rb,gc,cc,ac,rb,T,ec,dc,O,N,D,E,F,G);g[j+(_a<<2)+468>>2]=ea(g[D>>2]);T=ea(g[E>>2]);rb=ea(T*Qb);Rb=ea(T*Eb);kc=ea(T*Pb);T=ea(g[F>>2]);$b=ea(rb+ea(T*_b));rb=ea(Rb+ea(T*bc));Rb=ea(kc+ea(T*Nb));T=ea(ea(oc*Rb)-ea(pc*rb));kc=ea(ea(pc*$b)-ea(mc*Rb));ga=ea(ea(mc*rb)-ea(oc*$b));g[f>>2]=ea($b+ea(g[f>>2]));g[Ka>>2]=ea(rb+ea(g[Ka>>2]));g[La>>2]=ea(Rb+ea(g[La>>2]));g[Ma>>2]=ea(T+ea(g[Ma>>2]));g[Na>>2]=ea(kc+ea(g[Na>>2]));g[Oa>>2]=ea(ga+ea(g[Oa>>2]));if(!(c[129524]|0))break;ga=ea(ea(vb*ea(S(ea(g[E>>2]))))/xb);Gb=c[518096+(_a+d<<2)>>2]|0;g[Gb+28>>2]=ga;g[Gb+36>>2]=ea(ea(vb*ea(S(ea(g[F>>2]))))/xb);g[Gb+40>>2]=ea(ea(vb*ea(g[G>>2]))/xb);g[Gb+24>>2]=ea(g[Jb>>2]);g[Gb+32>>2]=ea(g[Ib>>2]);g[Gb+20>>2]=ea(g[Hb>>2])}}while(0);_a=_a+1|0}while((_a|0)!=4);i=k;return}function nEa(d,e,f,h,i){d=d|0;e=e|0;f=f|0;h=h|0;i=i|0;if(c[i+196>>2]|0)a[i+200>>0]=1;b[i+176>>1]=c[d>>2];g[i+80>>2]=ea(g[e>>2]);g[i+84>>2]=ea(g[e+4>>2]);g[i+88>>2]=ea(g[e+8>>2]);g[i+92>>2]=ea(g[e+12>>2]);g[i+160>>2]=ea(g[f>>2]);g[i+144>>2]=ea(g[h>>2]);b[i+178>>1]=c[d+4>>2];g[i+96>>2]=ea(g[e+16>>2]);g[i+100>>2]=ea(g[e+20>>2]);g[i+104>>2]=ea(g[e+24>>2]);g[i+108>>2]=ea(g[e+28>>2]);g[i+164>>2]=ea(g[f+4>>2]);g[i+148>>2]=ea(g[h+4>>2]);b[i+180>>1]=c[d+8>>2];g[i+112>>2]=ea(g[e+32>>2]);g[i+116>>2]=ea(g[e+36>>2]);g[i+120>>2]=ea(g[e+40>>2]);g[i+124>>2]=ea(g[e+44>>2]);g[i+168>>2]=ea(g[f+8>>2]);g[i+152>>2]=ea(g[h+8>>2]);b[i+182>>1]=c[d+12>>2];g[i+128>>2]=ea(g[e+48>>2]);g[i+132>>2]=ea(g[e+52>>2]);g[i+136>>2]=ea(g[e+56>>2]);g[i+140>>2]=ea(g[e+60>>2]);g[i+172>>2]=ea(g[f+12>>2]);g[i+156>>2]=ea(g[h+12>>2]);return}function oEa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=0,p=0,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=Im,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=0,$=Im,aa=0,ba=Im,ca=0,da=Im,fa=0,ga=0;e=i;i=i+4528|0;f=e+2408|0;h=e+2312|0;j=e+2216|0;k=e;l=ea(g[b>>2]);m=ea(g[b+12>>2]);n=ea(g[b+16>>2]);o=c[b+20>>2]|0;p=c[b+24>>2]|0;q=ea(g[b+28>>2]);r=ea(g[b+32>>2]);s=c[b+36>>2]|0;t=c[b+40>>2]|0;u=c[b+44>>2]|0;v=c[b+48>>2]|0;w=c[b+52>>2]|0;x=c[b+64>>2]|0;y=c[b+68>>2]|0;b=c[d+4>>2]|0;z=c[d>>2]|0;A=ea(m*n);B=ea(n*A);c[f+2116>>2]=5;c[h+92>>2]=5;c[j+92>>2]=5;d=b+76|0;C=ea(g[d>>2]);D=ea(g[t>>2]);E=ea(g[t+4>>2]);F=ea(g[t+8>>2]);G=ea(g[t+12>>2]);c[j+0>>2]=c[z+0>>2];c[j+4>>2]=c[z+4>>2];c[j+8>>2]=c[z+8>>2];c[j+12>>2]=c[z+12>>2];H=D;b=0;while(1){I=ea(l*ea(g[x+(b*48|0)+232>>2]));J=ea(g[s+(b<<2)>>2]);K=ea(J*ea(B*I));g[f+(b*92|0)>>2]=ea(D*K);g[f+(b*92|0)+4>>2]=ea(K*E);g[f+(b*92|0)+8>>2]=ea(K*F);g[f+(b*92|0)+12>>2]=ea(K*G);L=ea(ea(K*H)+ea(1.0));g[f+(b*92|0)+(b<<2)>>2]=ea(L+ea(I*ea(g[x+(b*48|0)+208>>2])));g[f+(b*92|0)+16>>2]=ea(-ea(J*ea(A*I)));J=ea(g[z+(b<<2)>>2]);L=ea(g[u+(b<<2)>>2]);g[h+(b<<2)>>2]=ea(J+ea(I*ea(L+ea(g[w+(b<<2)>>2]))));M=b+1|0;if((M|0)==4)break;H=ea(g[t+(M<<2)>>2]);b=M}H=ea(l*ea(g[y+104>>2]));l=ea(-ea(n*ea(m*H)));g[f+368>>2]=ea(D*l);g[f+372>>2]=ea(E*l);g[f+376>>2]=ea(F*l);g[f+380>>2]=ea(G*l);g[f+384>>2]=ea(ea(ea(m+r)*H)+ea(1.0));g[h+16>>2]=ea(C+ea(q*H));b=j+16|0;g[b>>2]=C;if((o|0)==1){c[k+2208>>2]=0;T2a(k,f);U2a(k,h,j)}else X2a(0,p,ea(1.00000001e-10),f,h,j);if(a[v>>0]|0){C=ea(g[z>>2]);H=ea(g[j>>2]);if(!(ea(C*H)<=ea(0.0))){N=H;O=10}else P=ea(0.0)}else{N=ea(g[j>>2]);O=10}if((O|0)==10)P=N;g[j>>2]=P;if(a[v+1>>0]|0){N=ea(g[z+4>>2]);H=ea(g[j+4>>2]);if(!(ea(N*H)<=ea(0.0))){Q=H;O=14}else R=ea(0.0)}else{Q=ea(g[j+4>>2]);O=14}if((O|0)==14)R=Q;g[j+4>>2]=R;if(a[v+2>>0]|0){Q=ea(g[z+8>>2]);H=ea(g[j+8>>2]);if(!(ea(Q*H)<=ea(0.0))){S=H;O=18}else T=ea(0.0)}else{S=ea(g[j+8>>2]);O=18}if((O|0)==18)T=S;g[j+8>>2]=T;if(a[v+3>>0]|0){v=z+12|0;S=ea(g[v>>2]);H=ea(g[j+12>>2]);if(!(ea(S*H)<=ea(0.0))){U=v;V=H}else{W=v;X=ea(0.0);Y=j+12|0;g[Y>>2]=X;Z=ea(g[b>>2]);_=y+88|0;$=ea(g[_>>2]);aa=Z<ea(0.0);ba=aa?ea(0.0):Z;ca=ba>$;da=ca?$:ba;g[z>>2]=P;fa=z+4|0;g[fa>>2]=R;ga=z+8|0;g[ga>>2]=T;g[W>>2]=X;g[d>>2]=da;i=e;return}}else{U=z+12|0;V=ea(g[j+12>>2])}W=U;X=V;Y=j+12|0;g[Y>>2]=X;Z=ea(g[b>>2]);_=y+88|0;$=ea(g[_>>2]);aa=Z<ea(0.0);ba=aa?ea(0.0):Z;ca=ba>$;da=ca?$:ba;g[z>>2]=P;fa=z+4|0;g[fa>>2]=R;ga=z+8|0;g[ga>>2]=T;g[W>>2]=X;g[d>>2]=da;i=e;return}function pEa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=0,p=0,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=0;e=i;i=i+4528|0;f=e+2408|0;h=e+2312|0;j=e+2216|0;k=e;l=ea(g[b>>2]);m=ea(g[b+12>>2]);n=ea(g[b+16>>2]);o=c[b+20>>2]|0;p=c[b+24>>2]|0;q=ea(g[b+28>>2]);r=ea(g[b+32>>2]);s=c[b+36>>2]|0;t=c[b+40>>2]|0;u=c[b+44>>2]|0;v=c[b+48>>2]|0;w=c[b+52>>2]|0;x=c[b+60>>2]|0;y=c[b+64>>2]|0;z=c[b+68>>2]|0;b=c[d+4>>2]|0;A=c[d>>2]|0;B=ea(m*n);C=ea(n*B);d=x+1|0;c[f+2116>>2]=d;c[h+92>>2]=d;c[j+92>>2]=d;d=b+76|0;D=ea(g[d>>2]);b=(x|0)==0;if(!b){E=0;do{F=E>>>2;G=E&3;H=ea(l*ea(g[y+(F*944|0)+(G*48|0)+232>>2]));I=ea(g[s+(E<<2)>>2]);J=ea(I*ea(C*H));K=0;do{g[f+(E*92|0)+(K<<2)>>2]=ea(J*ea(g[t+(K<<2)>>2]));K=K+1|0}while((K|0)!=(x|0));L=ea(ea(J*ea(g[t+(E<<2)>>2]))+ea(1.0));g[f+(E*92|0)+(E<<2)>>2]=ea(L+ea(H*ea(g[y+(F*944|0)+(G*48|0)+208>>2])));g[f+(E*92|0)+(x<<2)>>2]=ea(-ea(I*ea(B*H)));L=ea(g[A+(F*208|0)+(G<<2)>>2]);M=ea(g[u+(E<<2)>>2]);g[h+(E<<2)>>2]=ea(L+ea(H*ea(M+ea(g[w+(E<<2)>>2]))));g[j+(E<<2)>>2]=L;E=E+1|0}while((E|0)!=(x|0));B=ea(l*ea(g[z+104>>2]));C=ea(n*ea(m*B));if(b)N=B;else{E=0;do{g[f+(x*92|0)+(E<<2)>>2]=ea(-ea(C*ea(g[t+(E<<2)>>2])));E=E+1|0}while((E|0)!=(x|0));N=B}}else N=ea(l*ea(g[z+104>>2]));g[f+(x*92|0)+(x<<2)>>2]=ea(ea(ea(m+r)*N)+ea(1.0));g[h+(x<<2)>>2]=ea(D+ea(q*N));E=j+(x<<2)|0;g[E>>2]=D;if((o|0)==1){c[k+2208>>2]=0;T2a(k,f);U2a(k,h,j)}else X2a(0,p,ea(1.00000001e-10),f,h,j);if(!b){h=0;do{if(a[v+h>>0]|0){D=ea(g[A+((h>>>2)*208|0)+((h&3)<<2)>>2]);N=ea(g[j+(h<<2)>>2]);if(!(ea(D*N)<=ea(0.0))){O=N;P=15}else Q=ea(0.0)}else{O=ea(g[j+(h<<2)>>2]);P=15}if((P|0)==15){P=0;Q=O}g[j+(h<<2)>>2]=Q;h=h+1|0}while((h|0)!=(x|0))}Q=ea(g[E>>2]);O=ea(g[z+88>>2]);z=Q<ea(0.0);N=z?ea(0.0):Q;Q=N>O?O:N;g[E>>2]=Q;if(b){g[d>>2]=Q;i=e;return}else R=0;do{g[A+((R>>>2)*208|0)+((R&3)<<2)>>2]=ea(g[j+(R<<2)>>2]);R=R+1|0}while((R|0)!=(x|0));g[d>>2]=Q;i=e;return}function qEa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im;h=i;i=i+4736|0;j=h+96|0;k=h+2376|0;l=h+176|0;m=h+2456|0;n=h+2616|0;o=h;p=h+256|0;q=h+2536|0;r=ea(g[b>>2]);s=ea(g[b+12>>2]);t=ea(g[b+16>>2]);u=ea(g[b+28>>2]);v=ea(g[b+32>>2]);w=c[b+36>>2]|0;x=c[b+40>>2]|0;y=c[b+44>>2]|0;z=c[b+48>>2]|0;A=c[b+52>>2]|0;B=c[b+56>>2]|0;C=c[b+60>>2]|0;D=c[b+64>>2]|0;E=c[b+68>>2]|0;b=c[f>>2]|0;F=c[f+4>>2]|0;G=ea(s*t);H=ea(t*G);f=B+-1|0;I=(f|0)==0;if(!I){J=0;do{K=J<<2;g[j+(K<<2)>>2]=ea(g[D+(J*944|0)+232>>2]);L=K|1;g[j+(L<<2)>>2]=ea(g[D+(J*944|0)+280>>2]);M=K|2;g[j+(M<<2)>>2]=ea(g[D+(J*944|0)+328>>2]);N=K|3;g[j+(N<<2)>>2]=ea(g[D+(J*944|0)+376>>2]);g[k+(K<<2)>>2]=ea(g[D+(J*944|0)+208>>2]);g[k+(L<<2)>>2]=ea(g[D+(J*944|0)+256>>2]);g[k+(M<<2)>>2]=ea(g[D+(J*944|0)+304>>2]);g[k+(N<<2)>>2]=ea(g[D+(J*944|0)+352>>2]);g[m+(K<<2)>>2]=ea(g[D+(J*944|0)+228>>2]);g[m+(L<<2)>>2]=ea(g[D+(J*944|0)+276>>2]);g[m+(M<<2)>>2]=ea(g[D+(J*944|0)+324>>2]);g[m+(N<<2)>>2]=ea(g[D+(J*944|0)+372>>2]);g[l+(K<<2)>>2]=ea(g[b+(J*208|0)>>2]);g[l+(L<<2)>>2]=ea(g[b+(J*208|0)+4>>2]);g[l+(M<<2)>>2]=ea(g[b+(J*208|0)+8>>2]);g[l+(N<<2)>>2]=ea(g[b+(J*208|0)+12>>2]);J=J+1|0}while((J|0)!=(f|0))}J=(C-(B<<2)|0)==-4;if(!J){N=f<<2;M=B<<2;L=C+4-M|0;YEi(l+(M+-4<<2)|0,b+(f*208|0)|0,L<<2|0)|0;M=0;do{K=M+N|0;g[j+(K<<2)>>2]=ea(g[D+(f*944|0)+(M*48|0)+232>>2]);g[k+(K<<2)>>2]=ea(g[D+(f*944|0)+(M*48|0)+208>>2]);g[m+(K<<2)>>2]=ea(g[D+(f*944|0)+(M*48|0)+228>>2]);M=M+1|0}while((M|0)!=(L|0))}O=ea(g[D+192>>2]);P=ea(g[D+240>>2]);D=C+1|0;L=n+2116|0;c[L>>2]=D;c[o+92>>2]=D;M=(C|0)==0;if(!M){N=0;do{Q=ea(r*ea(g[j+(N<<2)>>2]));R=ea(g[w+(N<<2)>>2]);S=ea(g[e+(N<<2)>>2]);T=ea(S*ea(R*ea(H*Q)));K=0;do{U=ea(T*ea(g[x+(K<<2)>>2]));g[n+(N*92|0)+(K<<2)>>2]=ea(U*ea(g[e+(K<<2)>>2]));K=K+1|0}while((K|0)!=(C|0));U=ea(ea(ea(T*ea(g[x+(N<<2)>>2]))*S)+ea(1.0));g[n+(N*92|0)+(N<<2)>>2]=ea(U+ea(Q*ea(g[k+(N<<2)>>2])));g[n+(N*92|0)+(C<<2)>>2]=ea(-ea(S*ea(R*ea(G*Q))));U=ea(g[l+(N<<2)>>2]);V=ea(g[y+(N<<2)>>2]);g[o+(N<<2)>>2]=ea(U+ea(Q*ea(V+ea(g[A+(N<<2)>>2]))));N=N+1|0}while((N|0)!=(C|0))}N=F+76|0;G=ea(g[N>>2]);H=ea(r*ea(g[E+104>>2]));r=ea(t*ea(s*H));if(!M){F=0;do{t=ea(r*ea(g[x+(F<<2)>>2]));g[n+(C*92|0)+(F<<2)>>2]=ea(-ea(t*ea(g[e+(F<<2)>>2])));F=F+1|0}while((F|0)!=(C|0))}g[n+(C*92|0)+(C<<2)>>2]=ea(ea(ea(s+v)*H)+ea(1.0));g[o+(C<<2)>>2]=ea(G+ea(u*H));c[p+2116>>2]=D;F=(D|0)==0;do if(!F){e=C>>>0>2;x=0;do{H=ea(g[n+(x*92|0)>>2]);u=ea(g[n+(x*92|0)+4>>2]);if(e){A=2;G=H;v=u;while(1){s=ea(O*ea(g[n+(x*92|0)+(A<<2)>>2]));r=ea(G+ea(s*ea(g[m+(A<<2)>>2])));y=A|1;s=ea(P*ea(g[n+(x*92|0)+(y<<2)>>2]));t=ea(v+ea(s*ea(g[m+(y<<2)>>2])));A=A+2|0;if(A>>>0>=C>>>0){W=r;X=t;break}else{G=r;v=t}}}else{W=H;X=u}g[p+(x*92|0)>>2]=W;g[p+(x*92|0)+4>>2]=X;g[p+(x*92|0)+8>>2]=ea(g[n+(x*92|0)+(C<<2)>>2]);x=x+1|0}while((x|0)!=(D|0));c[L>>2]=3;if(!F){x=0;Q=ea(0.0);do{R=ea(g[p+(x*92|0)>>2]);Q=ea(Q+ea(R*R));x=x+1|0}while((x|0)!=(D|0));g[n>>2]=Q;if(F){g[n+4>>2]=ea(0.0);Y=ea(0.0);Z=Q;_=56;break}else{x=0;R=ea(0.0);while(1){S=ea(g[p+(x*92|0)>>2]);T=ea(R+ea(S*ea(g[p+(x*92|0)+4>>2])));x=x+1|0;if((x|0)==(D|0)){$=T;aa=Q;_=54;break}else R=T}}}else _=20}else{c[L>>2]=3;_=20}while(0);if((_|0)==20){g[n>>2]=ea(0.0);$=ea(0.0);aa=ea(0.0);_=54}do if((_|0)==54){g[n+4>>2]=$;if(!F){L=0;X=ea(0.0);do{W=ea(g[p+(L*92|0)>>2]);X=ea(X+ea(W*ea(g[p+(L*92|0)+8>>2])));L=L+1|0}while((L|0)!=(D|0));g[n+8>>2]=X;if(F){g[n+92>>2]=ea(0.0);ba=$;ca=aa;da=X;fa=ea(0.0);_=62;break}else{L=0;W=ea(0.0);while(1){P=ea(g[p+(L*92|0)+4>>2]);O=ea(W+ea(P*ea(g[p+(L*92|0)>>2])));L=L+1|0;if((L|0)==(D|0)){ga=O;ha=X;ia=aa;ja=$;_=60;break}else W=O}}}else{Y=$;Z=aa;_=56}}while(0);if((_|0)==56){g[n+8>>2]=ea(0.0);ga=ea(0.0);ha=ea(0.0);ia=Z;ja=Y;_=60}do if((_|0)==60){g[n+92>>2]=ga;if(!F){L=0;Y=ea(0.0);do{Z=ea(g[p+(L*92|0)+4>>2]);Y=ea(Y+ea(Z*Z));L=L+1|0}while((L|0)!=(D|0));g[n+96>>2]=Y;if(F){g[n+100>>2]=ea(0.0);ka=ea(0.0);la=ga;ma=ja;na=ia;oa=ha;pa=Y;_=68;break}else{L=0;Z=ea(0.0);while(1){aa=ea(g[p+(L*92|0)+4>>2]);$=ea(Z+ea(aa*ea(g[p+(L*92|0)+8>>2])));L=L+1|0;if((L|0)==(D|0)){qa=$;ra=Y;sa=ha;ta=ia;ua=ja;va=ga;_=66;break}else Z=$}}}else{ba=ja;ca=ia;da=ha;fa=ga;_=62}}while(0);if((_|0)==62){g[n+96>>2]=ea(0.0);qa=ea(0.0);ra=ea(0.0);sa=da;ta=ca;ua=ba;va=fa;_=66}do if((_|0)==66){g[n+100>>2]=qa;if(!F){L=0;fa=ea(0.0);do{ba=ea(g[p+(L*92|0)+8>>2]);fa=ea(fa+ea(ba*ea(g[p+(L*92|0)>>2])));L=L+1|0}while((L|0)!=(D|0));g[n+184>>2]=fa;if(F){g[n+188>>2]=ea(0.0);wa=ea(0.0);xa=qa;ya=va;za=ua;Aa=ta;Ba=sa;Ca=ra;Da=fa;_=74;break}else{L=0;ba=ea(0.0);while(1){ca=ea(g[p+(L*92|0)+8>>2]);da=ea(ba+ea(ca*ea(g[p+(L*92|0)+4>>2])));L=L+1|0;if((L|0)==(D|0)){Ea=da;Fa=fa;Ga=ra;Ha=sa;Ia=ta;Ja=ua;Ka=va;La=qa;_=72;break}else ba=da}}}else{ka=qa;la=va;ma=ua;na=ta;oa=sa;pa=ra;_=68}}while(0);if((_|0)==68){g[n+184>>2]=ea(0.0);Ea=ea(0.0);Fa=ea(0.0);Ga=pa;Ha=oa;Ia=na;Ja=ma;Ka=la;La=ka;_=72}if((_|0)==72){g[n+188>>2]=Ea;if(!F){L=0;ka=ea(0.0);do{la=ea(g[p+(L*92|0)+8>>2]);ka=ea(ka+ea(la*la));L=L+1|0}while((L|0)!=(D|0));g[n+192>>2]=ka;if(!F){L=0;la=ea(0.0);do{ma=ea(g[p+(L*92|0)>>2]);la=ea(la+ea(ma*ea(g[o+(L<<2)>>2])));L=L+1|0}while((L|0)!=(D|0));if(!F){L=0;ma=ea(0.0);do{na=ea(g[p+(L*92|0)+4>>2]);ma=ea(ma+ea(na*ea(g[o+(L<<2)>>2])));L=L+1|0}while((L|0)!=(D|0));if(F){Ma=Ja;Na=ka;Oa=Ha;Pa=Ea;Qa=La;Ra=Ga;Sa=Ia;Ta=Fa;Ua=Ka;Va=la;Wa=ma;Xa=ea(0.0)}else{F=0;na=ea(0.0);while(1){oa=ea(g[p+(F*92|0)+8>>2]);pa=ea(na+ea(oa*ea(g[o+(F<<2)>>2])));F=F+1|0;if((F|0)==(D|0)){Ma=Ja;Na=ka;Oa=Ha;Pa=Ea;Qa=La;Ra=Ga;Sa=Ia;Ta=Fa;Ua=Ka;Va=la;Wa=ma;Xa=pa;break}else na=pa}}}else{Ma=Ja;Na=ka;Oa=Ha;Pa=Ea;Qa=La;Ra=Ga;Sa=Ia;Ta=Fa;Ua=Ka;Va=la;Wa=ea(0.0);Xa=ea(0.0)}}else{Ma=Ja;Na=ka;Oa=Ha;Pa=Ea;Qa=La;Ra=Ga;Sa=Ia;Ta=Fa;Ua=Ka;Va=ea(0.0);Wa=ea(0.0);Xa=ea(0.0)}}else{wa=Ea;xa=La;ya=Ka;za=Ja;Aa=Ia;Ba=Ha;Ca=Ga;Da=Fa;_=74}}if((_|0)==74){g[n+192>>2]=ea(0.0);Ma=za;Na=ea(0.0);Oa=Ba;Pa=wa;Qa=xa;Ra=Ca;Sa=Aa;Ta=Da;Ua=ya;Va=ea(0.0);Wa=ea(0.0);Xa=ea(0.0)}ya=ea(ea(Ra*Na)-ea(Qa*Pa));Da=ea(ea(Ua*Na)-ea(Qa*Ta));Aa=ea(ea(Ua*Pa)-ea(Ra*Ta));Ca=ea(ea(Oa*Aa)+ea(ea(Sa*ya)-ea(Ma*Da)));if(Ca==ea(0.0)){i=h;return}xa=ea(ea(1.0)/Ca);Ca=ea(xa*ea(ea(ea(ya*Va)-ea(ea(ea(Ma*Na)-ea(Oa*Pa))*Wa))+ea(ea(ea(Ma*Qa)-ea(Oa*Ra))*Xa)));ya=ea(xa*ea(ea(ea(ea(ea(Sa*Na)-ea(Oa*Ta))*Wa)-ea(Da*Va))-ea(ea(ea(Sa*Qa)-ea(Oa*Ua))*Xa)));Oa=ea(xa*ea(ea(ea(Aa*Va)-ea(ea(ea(Sa*Pa)-ea(Ma*Ta))*Wa))+ea(ea(ea(Sa*Ra)-ea(Ma*Ua))*Xa)));Xa=ea(g[E+88>>2]);E=Oa<ea(0.0);Ua=E?ea(0.0):Oa;Oa=Ua>Xa?Xa:Ua;g[q>>2]=Ca;g[q+4>>2]=ya;if(C>>>0>2){E=2;do{g[q+(E<<2)>>2]=Ca;g[q+((E|1)<<2)>>2]=ya;E=E+2|0}while(E>>>0<C>>>0)}if(!M){M=0;do{E=q+(M<<2)|0;if((a[z+M>>0]|0)!=0?(ya=ea(g[E>>2]),ea(ya*ea(g[l+(M<<2)>>2]))<=ea(0.0)):0)g[E>>2]=ea(0.0);M=M+1|0}while((M|0)!=(C|0))}if(!I){I=0;do{M=I<<2;if(!(a[d+M>>0]|0))Ya=ea(0.0);else Ya=ea(g[q+(M<<2)>>2]);g[b+(I*208|0)>>2]=Ya;l=M|1;if(!(a[d+l>>0]|0))Za=ea(0.0);else Za=ea(g[q+(l<<2)>>2]);g[b+(I*208|0)+4>>2]=Za;l=M|2;if(!(a[d+l>>0]|0))_a=ea(0.0);else _a=ea(g[q+(l<<2)>>2]);g[b+(I*208|0)+8>>2]=_a;l=M|3;if(!(a[d+l>>0]|0))$a=ea(0.0);else $a=ea(g[q+(l<<2)>>2]);g[b+(I*208|0)+12>>2]=$a;I=I+1|0}while((I|0)!=(f|0))}if(!J){J=f<<2;I=C+4-(B<<2)|0;B=0;do{C=B+J|0;if(!(a[d+C>>0]|0))ab=ea(0.0);else ab=ea(g[q+(C<<2)>>2]);g[b+(f*208|0)+(B<<2)>>2]=ab;B=B+1|0}while((B|0)!=(I|0))}g[N>>2]=Oa;i=h;return}function rEa(b,c,d,e,f,h,i,j){b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;i=i|0;j=j|0;var k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=0,u=Im;k=ea(ea(g[i+232>>2])*b);l=ea(ea(g[i+280>>2])*b);m=ea(ea(g[i+328>>2])*b);n=ea(ea(g[i+376>>2])*b);b=ea(g[j>>2]);o=ea(g[f>>2]);p=ea(o+ea(g[e>>2]));o=ea(b+ea(k*ea(p+ea(g[c>>2]))));p=ea(o/ea(ea(k*ea(g[h>>2]))+ea(1.0)));i=j+4|0;k=ea(g[i>>2]);o=ea(g[f+4>>2]);q=ea(o+ea(g[e+4>>2]));o=ea(k+ea(l*ea(q+ea(g[c+4>>2]))));q=ea(o/ea(ea(l*ea(g[h+4>>2]))+ea(1.0)));r=j+8|0;l=ea(g[r>>2]);o=ea(g[f+8>>2]);s=ea(o+ea(g[e+8>>2]));o=ea(l+ea(m*ea(s+ea(g[c+8>>2]))));s=ea(o/ea(ea(m*ea(g[h+8>>2]))+ea(1.0)));t=j+12|0;m=ea(g[t>>2]);o=ea(g[f+12>>2]);u=ea(o+ea(g[e+12>>2]));o=ea(m+ea(n*ea(u+ea(g[c+12>>2]))));u=ea(o/ea(ea(n*ea(g[h+12>>2]))+ea(1.0)));h=(a[d>>0]|0)==0|!(ea(b*p)<=ea(0.0));b=h?p:ea(0.0);h=(a[d+1>>0]|0)==0|!(ea(q*k)<=ea(0.0));k=h?q:ea(0.0);h=(a[d+2>>0]|0)==0|!(ea(s*l)<=ea(0.0));l=h?s:ea(0.0);h=(a[d+3>>0]|0)==0|!(ea(u*m)<=ea(0.0));m=h?u:ea(0.0);g[j>>2]=b;g[i>>2]=k;g[r>>2]=l;g[t>>2]=m;return}function sEa(a,b,c,d,e,f,h){a=ea(a);b=ea(b);c=ea(c);d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im;j=i;k=ea(g[h>>2]);l=ea(ea(g[f+232>>2])*a);m=ea(g[f+208>>2]);n=ea(g[d>>2]);o=ea(ea(k+ea(l*ea(n+ea(g[e>>2]))))/ea(ea(m*l)+ea(1.0)));l=ea(g[f+212>>2]);if(ea(ea(l*b)+ea(ea(g[f+216>>2])*c))!=ea(0.0)){p=ea(k*o)<=ea(0.0);q=p?ea(0.0):o}else q=o;g[h>>2]=q;p=h+4|0;q=ea(g[p>>2]);o=ea(ea(g[f+280>>2])*a);k=ea(g[f+256>>2]);l=ea(g[d+4>>2]);m=ea(ea(q+ea(o*ea(l+ea(g[e+4>>2]))))/ea(ea(k*o)+ea(1.0)));o=ea(g[f+260>>2]);if(ea(ea(o*b)+ea(ea(g[f+264>>2])*c))!=ea(0.0)){r=ea(q*m)<=ea(0.0);s=r?ea(0.0):m}else s=m;g[p>>2]=s;p=h+8|0;s=ea(g[p>>2]);m=ea(ea(g[f+328>>2])*a);q=ea(g[f+304>>2]);o=ea(g[d+8>>2]);k=ea(ea(s+ea(m*ea(o+ea(g[e+8>>2]))))/ea(ea(q*m)+ea(1.0)));m=ea(g[f+308>>2]);if(ea(ea(m*b)+ea(ea(g[f+312>>2])*c))!=ea(0.0)){r=ea(s*k)<=ea(0.0);t=r?ea(0.0):k}else t=k;g[p>>2]=t;p=h+12|0;t=ea(g[p>>2]);k=ea(ea(g[f+376>>2])*a);a=ea(g[f+352>>2]);s=ea(g[d+12>>2]);m=ea(ea(t+ea(k*ea(s+ea(g[e+12>>2]))))/ea(ea(a*k)+ea(1.0)));k=ea(g[f+356>>2]);if(!(ea(ea(k*b)+ea(ea(g[f+360>>2])*c))!=ea(0.0))){u=m;g[p>>2]=u;i=j;return}f=ea(t*m)<=ea(0.0);u=f?ea(0.0):m;g[p>>2]=u;i=j;return}function tEa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im;h=i;j=ea(g[e+16>>2]);k=ea(g[e+20>>2]);l=ea(g[e+24>>2]);if(!d){i=h;return}m=ea(ea(ea(ea(0.0)*ea(0.0))-ea(ea(0.0)*ea(1.0)))*ea(2.0));n=ea(ea(ea(ea(0.0)*ea(0.0))-ea(ea(0.0)*ea(1.0)))*ea(2.0));o=ea(ea(ea(ea(1.0)*ea(1.0))-ea(ea(0.0)*ea(0.0)))*ea(2.0));e=0;do{p=ea(g[c+(e*148|0)+76>>2]);q=ea(g[a+(e*48|0)+20>>2]);if(p>ea(0.0)){r=ea(p*ea(g[a+(e*48|0)+24>>2]));s=ea(q+ea(r*ea(g[a+(e*48|0)+32>>2])))}else{r=ea(p*ea(g[a+(e*48|0)+28>>2]));s=ea(q-ea(r*ea(g[a+(e*48|0)+36>>2])))}r=ea(j+ea(g[a+(e*12|0)+784>>2]));q=ea(k+ea(g[a+(e*12|0)+788>>2]));t=ea(l+ea(g[a+(e*12|0)+792>>2]));u=ea(p*ea(g[a+(e*12|0)+640>>2]));v=ea(p*ea(g[a+(e*12|0)+644>>2]));w=ea(r-u);u=ea(q-v);v=ea(t-ea(p*ea(g[a+(e*12|0)+648>>2])));p=ea(ea(g[c+(e*148|0)+116>>2])*ea(.5));t=ea(+W(+p));q=ea(+V(+p));p=ea(t*ea(0.0));r=ea(t*ea(1.0));x=ea(t*ea(0.0));t=ea(ea(q*q)+ea(-.5));y=ea(ea(ea(m*p)+ea(n*r))+ea(o*x));z=ea(s*ea(.5));A=ea(+W(+z));B=ea(+V(+z));z=ea(A*ea(ea(p*y)+ea(ea(m*t)+ea(q*ea(ea(o*r)-ea(n*x))))));C=ea(A*ea(ea(r*y)+ea(ea(n*t)+ea(q*ea(ea(m*x)-ea(o*p))))));D=ea(A*ea(ea(ea(o*t)+ea(q*ea(ea(n*p)-ea(m*r))))+ea(x*y)));y=ea(ea(ea(x*C)+ea(ea(p*B)+ea(q*z)))-ea(r*D));t=ea(ea(ea(p*D)+ea(ea(r*B)+ea(q*C)))-ea(x*z));A=ea(ea(ea(r*z)+ea(ea(x*B)+ea(q*D)))-ea(p*C));E=ea(ea(ea(ea(q*B)-ea(p*z))-ea(r*C))-ea(x*D));D=ea(ea(1.0)*ea(2.0));x=ea(ea(0.0)*ea(2.0));C=ea(ea(0.0)*ea(2.0));r=ea(ea(E*E)+ea(-.5));z=ea(ea(C*A)+ea(ea(D*y)+ea(x*t)));p=ea(ea(g[b+(e<<2)+32>>2])*ea(.5));B=ea(+W(+p));q=ea(+V(+p));p=ea(B*ea(ea(y*z)+ea(ea(D*r)+ea(E*ea(ea(C*t)-ea(x*A))))));F=ea(B*ea(ea(t*z)+ea(ea(x*r)+ea(E*ea(ea(D*A)-ea(C*y))))));G=ea(B*ea(ea(ea(C*r)+ea(E*ea(ea(x*y)-ea(D*t))))+ea(A*z)));z=ea(ea(ea(y*G)+ea(ea(q*t)+ea(E*F)))-ea(A*p));D=ea(ea(ea(t*p)+ea(ea(q*A)+ea(E*G)))-ea(y*F));x=ea(ea(ea(ea(q*E)-ea(y*p))-ea(t*F))-ea(A*G));g[f+(e*28|0)>>2]=ea(ea(ea(A*F)+ea(ea(q*y)+ea(E*p)))-ea(t*G));g[f+(e*28|0)+4>>2]=z;g[f+(e*28|0)+8>>2]=D;g[f+(e*28|0)+12>>2]=x;g[f+(e*28|0)+16>>2]=w;g[f+(e*28|0)+20>>2]=u;g[f+(e*28|0)+24>>2]=v;e=e+1|0}while((e|0)!=(d|0));i=h;return}function uEa(d,e,f,h,j,k,l,m){d=ea(d);e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=Im,wi=Im,xi=Im,yi=Im,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=Im;n=i;i=i+7728|0;o=n+7136|0;p=n+1896|0;q=n+16|0;r=n+256|0;s=n+412|0;t=n+4168|0;u=n+84|0;v=n+112|0;w=n+140|0;x=n+152|0;y=n+164|0;z=n+176|0;A=n+204|0;B=n+232|0;C=n+244|0;D=n+3020|0;E=n+3036|0;F=n+4152|0;G=n+7128|0;H=n+7712|0;I=n+512|0;J=n+556|0;K=n+568|0;L=n+584|0;M=n+600|0;N=n+604|0;O=n+696|0;P=n+1808|0;Q=n+1824|0;R=n+72|0;T=n;U=n+56|0;V=n+3016|0;W=n+280|0;X=n+3032|0;Y=n+80|0;Z=n+296|0;_=n+3040|0;$=n+408|0;aa=k+8|0;ba=k+44|0;ca=c[ba>>2]|0;if(!ca)da=0;else{fa=c[k+72>>2]|0;ga=0;do{ha=ga<<2;ia=c[518096+(ha<<2)>>2]|0;if(ia){g[ia+16>>2]=ea(g[fa+(ga*208|0)>>2]);ja=ea(g[fa+(ga*208|0)+4>>2]);g[(c[518096+((ha|1)<<2)>>2]|0)+16>>2]=ja;ja=ea(g[fa+(ga*208|0)+8>>2]);g[(c[518096+((ha|2)<<2)>>2]|0)+16>>2]=ja;ja=ea(g[fa+(ga*208|0)+12>>2]);g[(c[518096+((ha|3)<<2)>>2]|0)+16>>2]=ja}ga=ga+1|0}while(ga>>>0<ca>>>0);da=ca}ca=k+128|0;ga=k+204|0;if(0)hi();fa=c[k+40>>2]|0;ha=k+72|0;ia=c[ha>>2]|0;ka=c[k+48>>2]|0;la=4-(da<<2)|0;ma=c[k+288>>2]|0;YEi(o|0,k+224|0,ma<<3|0)|0;na=o+64|0;c[na>>2]=ma;ma=o+80|0;oa=k+304|0;c[ma+0>>2]=c[oa+0>>2];c[ma+4>>2]=c[oa+4>>2];c[ma+8>>2]=c[oa+8>>2];c[ma+12>>2]=c[oa+12>>2];c[ma+16>>2]=c[oa+16>>2];c[ma+20>>2]=c[oa+20>>2];c[ma+24>>2]=c[oa+24>>2];c[ma+28>>2]=c[oa+28>>2];oa=o+112|0;YEi(oa|0,k+336|0,416)|0;ma=o+528|0;pa=ma+0|0;qa=k+752|0;ra=pa+48|0;do{c[pa>>2]=c[qa>>2];pa=pa+4|0;qa=qa+4|0}while((pa|0)<(ra|0));qa=c[k+104>>2]|0;g[p>>2]=ea(0.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[p+12>>2]=ea(1.0);sa=p+60|0;pa=p+16|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(1.0);sa=p+116|0;pa=p+72|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+120>>2]=ea(0.0);g[p+124>>2]=ea(1.0);sa=p+172|0;pa=p+128|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+176>>2]=ea(0.0);g[p+180>>2]=ea(1.0);sa=p+228|0;pa=p+184|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+232>>2]=ea(0.0);g[p+236>>2]=ea(1.0);sa=p+284|0;pa=p+240|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+288>>2]=ea(0.0);g[p+292>>2]=ea(1.0);sa=p+340|0;pa=p+296|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+344>>2]=ea(0.0);g[p+348>>2]=ea(1.0);sa=p+396|0;pa=p+352|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+400>>2]=ea(0.0);g[p+404>>2]=ea(1.0);sa=p+452|0;pa=p+408|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+456>>2]=ea(0.0);g[p+460>>2]=ea(1.0);sa=p+508|0;pa=p+464|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+512>>2]=ea(0.0);g[p+516>>2]=ea(1.0);sa=p+564|0;pa=p+520|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(1.0);sa=p+620|0;pa=p+576|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+624>>2]=ea(0.0);g[p+628>>2]=ea(1.0);sa=p+676|0;pa=p+632|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+680>>2]=ea(0.0);g[p+684>>2]=ea(1.0);sa=p+732|0;pa=p+688|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+736>>2]=ea(0.0);g[p+740>>2]=ea(1.0);sa=p+788|0;pa=p+744|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+792>>2]=ea(0.0);g[p+796>>2]=ea(1.0);sa=p+844|0;pa=p+800|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+848>>2]=ea(0.0);g[p+852>>2]=ea(1.0);sa=p+900|0;pa=p+856|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+904>>2]=ea(0.0);g[p+908>>2]=ea(1.0);sa=p+956|0;pa=p+912|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+960>>2]=ea(0.0);g[p+964>>2]=ea(1.0);sa=p+1012|0;pa=p+968|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+1016>>2]=ea(0.0);g[p+1020>>2]=ea(1.0);sa=p+1068|0;pa=p+1024|0;ra=pa+44|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));g[sa>>2]=ea(0.0);g[p+1072>>2]=ea(0.0);g[p+1076>>2]=ea(1.0);pa=p+1080|0;ra=pa+40|0;do{c[pa>>2]=0;pa=pa+4|0}while((pa|0)<(ra|0));pa=la+ka|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;b[q+32>>1]=0;c[q+4>>2]=ka;c[q>>2]=p;if((((!(ea(NCa(ca,3))!=ea(0.0))?!(ea(NCa(ca,4))!=ea(0.0)):0)?!(ea(NCa(ca,0))!=ea(0.0)):0)?(a[k+194>>0]|0)==0:0)?(a[k+193>>0]|0)==0:0)ta=0;else ta=1;a:do if(mo[c[(c[qa>>2]|0)+256>>2]&4095](qa)|0){if(ta){a[q+33>>0]=1;break}p=c[ba>>2]|0;la=c[ha>>2]|0;b:do if(p){ra=0;c:while(1){sa=ra<<2;ua=la+(ra*208|0)+196|0;va=0;do{if(((!(_Ea(aa,va+sa|0)|0)?(wa=c[ua>>2]|0,(a[wa+(va*80|0)+77>>0]|0)!=0):0)?(xa=c[wa+(va*80|0)>>2]|0,(xa|0)!=0):0)?(b[xa+4>>1]|0)==5:0)break c;va=va+1|0}while(va>>>0<4);ra=ra+1|0;if(ra>>>0>=p>>>0)break b}a[q+33>>0]=1;break a}while(0);p=k+88|0;if(c[p>>2]|0){la=0;do{cFa(ha,la,ea(0.0));la=la+1|0}while(la>>>0<(c[p>>2]|0)>>>0)}g[ga>>2]=ea(0.0);if(!m){i=n;return}a[m+32>>0]=1;i=n;return}while(0);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r>>2]=ka>>>0<4?ka:4;ha=da+-1|0;if(ha>>>0>1){ba=1;do{c[r+(ba<<2)>>2]=4;ba=ba+1|0}while((ba|0)!=(ha|0))}c[r+(ha<<2)>>2]=pa;pa=(da|0)==0;if(!pa){ha=c[k+76>>2]|0;ba=0;do{ta=ba<<2;c[s+(ba*20|0)>>2]=c[(c[ha>>2]|0)+(ta<<2)>>2];c[s+(ba*20|0)+4>>2]=c[(c[ha>>2]|0)+((ta|1)<<2)>>2];c[s+(ba*20|0)+8>>2]=c[(c[ha>>2]|0)+((ta|2)<<2)>>2];c[s+(ba*20|0)+12>>2]=c[(c[ha>>2]|0)+((ta|3)<<2)>>2];c[s+(ba*20|0)+16>>2]=c[ha+4>>2];ba=ba+1|0}while((ba|0)!=(da|0));if(!pa){ba=0;do{ha=c[(c[ia+(ba*208|0)+192>>2]|0)+352>>2]|0;ko[c[(c[ha>>2]|0)+36>>2]&4095](ha);ba=ba+1|0}while((ba|0)!=(da|0))}}ba=t+2960|0;ha=t;do{PEi(ha|0,0,136)|0;a[ha+28>>0]=1;c[ha+44>>2]=-1;g[ha+120>>2]=ea(0.0);g[ha+124>>2]=ea(0.0);g[ha+128>>2]=ea(0.0);g[ha+132>>2]=ea(1.0);g[ha+136>>2]=ea(0.0);g[ha+140>>2]=ea(0.0);g[ha+144>>2]=ea(0.0);ha=ha+148|0}while((ha|0)!=(ba|0));In[c[(c[qa>>2]|0)+124>>2]&4095](z,qa);ja=ea(g[z>>2]);g[u>>2]=ja;ya=ea(g[z+4>>2]);g[u+4>>2]=ya;za=ea(g[z+8>>2]);g[u+8>>2]=za;Aa=ea(g[z+12>>2]);g[u+12>>2]=Aa;Ba=ea(g[z+16>>2]);g[u+16>>2]=Ba;Ca=ea(g[z+20>>2]);g[u+20>>2]=Ca;Da=ea(g[z+24>>2]);g[u+24>>2]=Da;In[c[(c[qa>>2]|0)+84>>2]&4095](A,qa);Ea=ea(Ba*ea(2.0));Ba=ea(Ca*ea(2.0));Ca=ea(Da*ea(2.0));Da=ea(g[A+12>>2]);Fa=ea(ea(Da*Da)+ea(-.5));Ga=ea(g[A>>2]);Ha=ea(Ea*Ga);Ia=ea(g[A+4>>2]);Ja=ea(Ha+ea(Ba*Ia));Ha=ea(g[A+8>>2]);Ka=ea(Ja+ea(Ca*Ha));Ja=ea(ea(Ga*Ka)+ea(ea(Ea*Fa)+ea(Da*ea(ea(Ca*Ia)-ea(Ba*Ha)))));La=ea(ea(Ia*Ka)+ea(ea(Ba*Fa)+ea(Da*ea(ea(Ea*Ha)-ea(Ca*Ga)))));Ma=ea(ea(ea(Ca*Fa)+ea(Da*ea(ea(Ba*Ga)-ea(Ea*Ia))))+ea(Ha*Ka));Ka=ea(ea(g[A+16>>2])+Ja);Ja=ea(ea(g[A+20>>2])+La);La=ea(ea(g[A+24>>2])+Ma);Ma=ea(ea(ea(ea(Da*ja)+ea(Ga*Aa))+ea(Ia*za))-ea(Ha*ya));Ea=ea(ea(ea(Ha*ja)+ea(ea(Ia*Aa)+ea(Da*ya)))-ea(Ga*za));Ba=ea(ea(ea(Ga*ya)+ea(ea(Ha*Aa)+ea(Da*za)))-ea(Ia*ja));Fa=ea(ea(ea(ea(Da*Aa)-ea(Ga*ja))-ea(Ia*ya))-ea(Ha*za));g[v>>2]=Ma;A=v+4|0;g[A>>2]=Ea;z=v+8|0;g[z>>2]=Ba;ba=v+12|0;g[ba>>2]=Fa;ha=v+16|0;g[ha>>2]=Ka;ta=v+20|0;g[ta>>2]=Ja;p=v+24|0;g[p>>2]=La;La=ea(ea(1.0)/ea(Kn[c[(c[qa>>2]|0)+132>>2]&255](qa)));In[c[(c[qa>>2]|0)+144>>2]&4095](B,qa);Ja=ea(ea(1.0)/ea(g[B>>2]));Ka=ea(ea(1.0)/ea(g[B+4>>2]));za=ea(ea(1.0)/ea(g[B+8>>2]));g[w>>2]=Ja;g[w+4>>2]=Ka;g[w+8>>2]=za;In[c[(c[qa>>2]|0)+152>>2]&4095](C,qa);za=ea(g[C>>2]);g[x>>2]=za;Ka=ea(g[C+4>>2]);B=x+4|0;g[B>>2]=Ka;Ja=ea(g[C+8>>2]);C=x+8|0;g[C>>2]=Ja;In[c[(c[qa>>2]|0)+160>>2]&4095](D,qa);Ha=ea(g[D>>2]);g[y>>2]=Ha;ya=ea(g[D+4>>2]);la=y+4|0;g[la>>2]=ya;Ia=ea(g[D+8>>2]);D=y+8|0;g[D>>2]=Ia;ja=ea(g[ca>>2]);ra=k+196|0;do if(!(a[k+192>>0]|0))Na=ja;else{va=c[ra>>2]|0;ua=c[k+200>>2]|0;Ga=(ua|0)!=(va|0)&(va|0)==1?ea(0.0):ja;sa=k+212|0;Aa=ea(g[sa>>2]);if((ua|0)==(va|0)?Aa>ea(g[o+400>>2]):0){Da=ea(g[ga>>2]);Ca=ea(Da*ea(g[o+108>>2]));ua=(va|0)!=0?Ca>ea(g[o+(va<<2)+272>>2]):0;xa=va>>>0>2?Ca<ea(g[o+(va<<2)+400>>2]):0;if(!(ua|xa)){Na=Ga;break}a[k+193>>0]=ua&1;a[k+194>>0]=xa&1;g[sa>>2]=ea(0.0);Na=Ga;break}g[sa>>2]=ea(Aa+d);Na=Ga}while(0);jEa(d,oa,ca);oa=c[ra>>2]|0;ra=(oa|0)==1;if(ra)Oa=ea(0.0);else Oa=ea(g[o+256>>2]);sa=c[o+260>>2]|0;xa=c[o+264>>2]|0;ja=ea(g[o+(oa<<2)+112>>2]);Ga=ea(ja*ea(g[o+240>>2]));oa=0==0;if(!oa)g[8]=Ga;ja=ea(g[k+132>>2]);Aa=ea(g[k+136>>2]);Ca=ea(g[k+140>>2]);Da=ea(g[k+144>>2]);Pa=ea(Da-Ca);if(Na>ea(0.0)&ja==ea(0.0))Qa=Aa==ea(0.0);else Qa=0;if(!oa){g[3]=Na;g[4]=ja;g[5]=Aa;g[6]=Ca;g[7]=Da}c[E>>2]=0;ua=c[k+52>>2]|0;if(ua&1)a[E>>0]=1;if(ua&2)a[E+1>>0]=1;if(ua&4)a[E+2>>0]=1;if(ua&8)a[E+3>>0]=1;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;ua=c[o+552>>2]|0;do if(Aa>ea(0.0))if(!ua){Ra=1;break}else if((ua|0)==3){Ra=4;break}else{Ra=ua;break}else Ra=ua;while(0);Da=ea(g[ma>>2]);Ca=ea(g[o+532>>2]);Sa=ea(g[o+536>>2]);Ta=ea(ea(1.0)-Da);Ua=ea(ea(1.0)-Ca);Va=ea(ea(1.0)-Sa);switch(Ra|0){case 4:case 1:{g[F>>2]=Ca;g[F+4>>2]=Ua;g[F+8>>2]=ea(0.0);g[F+12>>2]=ea(0.0);Wa=Ca;Xa=Ua;Ya=ea(0.0);Za=ea(0.0);break}case 5:case 2:{g[F>>2]=ea(0.0);g[F+4>>2]=ea(0.0);g[F+8>>2]=Sa;g[F+12>>2]=Va;Wa=ea(0.0);Xa=ea(0.0);Ya=Sa;Za=Va;break}case 3:case 0:{_a=ea(Da*Ca);g[F>>2]=_a;Ca=ea(Da*Ua);g[F+4>>2]=Ca;Ua=ea(Ta*Sa);g[F+8>>2]=Ua;Sa=ea(Ta*Va);g[F+12>>2]=Sa;Wa=_a;Xa=Ca;Ya=Ua;Za=Sa;break}default:{Wa=ea(0.0);Xa=ea(0.0);Ya=ea(0.0);Za=ea(0.0)}}if(!oa){Sa=ea(g[ga>>2]);Ua=ea(ea(ea(g[ia>>2])*Wa)+ea(0.0));Wa=ea(Ua+ea(ea(g[ia+4>>2])*Xa));Xa=ea(Wa+ea(ea(g[ia+8>>2])*Ya));g[2]=ea(ea(Ga*ea(Xa+ea(ea(g[ia+12>>2])*Za)))-Sa)}c[G>>2]=0;if(Qa){a[G>>0]=ea(g[F>>2])!=ea(0.0)&1;a[G+1>>0]=ea(g[F+4>>2])!=ea(0.0)&1;a[G+2>>0]=ea(g[F+8>>2])!=ea(0.0)&1;a[G+3>>0]=ea(g[F+12>>2])!=ea(0.0)&1};c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;Y2a(o,fa,Pa,H);if(pa){$a=Ha;ab=ya;bb=Ia;cb=Fa;db=Ma;eb=Ea;fb=Ba;gb=za;hb=Ka;ib=Ja}else{pa=0;do{oa=pa<<2;Ra=t+(oa*148|0)|0;if(!(c[ia+(pa*208|0)+196>>2]|0)){ua=t+((oa|1)*148|0)|0;va=t+((oa|2)*148|0)|0;wa=t+((oa|3)*148|0)|0;c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;c[Ra+12>>2]=0;c[Ra+16>>2]=0;c[Ra+20>>2]=0;c[Ra+24>>2]=0;c[ua+0>>2]=0;c[ua+4>>2]=0;c[ua+8>>2]=0;c[ua+12>>2]=0;c[ua+16>>2]=0;c[ua+20>>2]=0;c[ua+24>>2]=0;c[va+0>>2]=0;c[va+4>>2]=0;c[va+8>>2]=0;c[va+12>>2]=0;c[va+16>>2]=0;c[va+20>>2]=0;c[va+24>>2]=0;c[wa+0>>2]=0;c[wa+4>>2]=0;c[wa+8>>2]=0;c[wa+12>>2]=0;c[wa+16>>2]=0;c[wa+20>>2]=0;c[wa+24>>2]=0}else{g[Ra>>2]=ea(g[ia+(pa*208|0)+80>>2]);g[t+(oa*148|0)+4>>2]=ea(g[ia+(pa*208|0)+84>>2]);g[t+(oa*148|0)+8>>2]=ea(g[ia+(pa*208|0)+88>>2]);g[t+(oa*148|0)+12>>2]=ea(g[ia+(pa*208|0)+128>>2]);g[t+(oa*148|0)+16>>2]=ea(g[ia+(pa*208|0)+132>>2]);g[t+(oa*148|0)+20>>2]=ea(g[ia+(pa*208|0)+136>>2]);g[t+(oa*148|0)+24>>2]=ea(g[ia+(pa*208|0)+176>>2]);Ra=oa|1;g[t+(Ra*148|0)>>2]=ea(g[ia+(pa*208|0)+92>>2]);g[t+(Ra*148|0)+4>>2]=ea(g[ia+(pa*208|0)+96>>2]);g[t+(Ra*148|0)+8>>2]=ea(g[ia+(pa*208|0)+100>>2]);g[t+(Ra*148|0)+12>>2]=ea(g[ia+(pa*208|0)+140>>2]);g[t+(Ra*148|0)+16>>2]=ea(g[ia+(pa*208|0)+144>>2]);g[t+(Ra*148|0)+20>>2]=ea(g[ia+(pa*208|0)+148>>2]);g[t+(Ra*148|0)+24>>2]=ea(g[ia+(pa*208|0)+180>>2]);Ra=oa|2;g[t+(Ra*148|0)>>2]=ea(g[ia+(pa*208|0)+104>>2]);g[t+(Ra*148|0)+4>>2]=ea(g[ia+(pa*208|0)+108>>2]);g[t+(Ra*148|0)+8>>2]=ea(g[ia+(pa*208|0)+112>>2]);g[t+(Ra*148|0)+12>>2]=ea(g[ia+(pa*208|0)+152>>2]);g[t+(Ra*148|0)+16>>2]=ea(g[ia+(pa*208|0)+156>>2]);g[t+(Ra*148|0)+20>>2]=ea(g[ia+(pa*208|0)+160>>2]);g[t+(Ra*148|0)+24>>2]=ea(g[ia+(pa*208|0)+184>>2]);Ra=oa|3;g[t+(Ra*148|0)>>2]=ea(g[ia+(pa*208|0)+116>>2]);g[t+(Ra*148|0)+4>>2]=ea(g[ia+(pa*208|0)+120>>2]);g[t+(Ra*148|0)+8>>2]=ea(g[ia+(pa*208|0)+124>>2]);g[t+(Ra*148|0)+12>>2]=ea(g[ia+(pa*208|0)+164>>2]);g[t+(Ra*148|0)+16>>2]=ea(g[ia+(pa*208|0)+168>>2]);g[t+(Ra*148|0)+20>>2]=ea(g[ia+(pa*208|0)+172>>2]);g[t+(Ra*148|0)+24>>2]=ea(g[ia+(pa*208|0)+188>>2])}pa=pa+1|0}while((pa|0)!=(da|0));Ja=ea(g[x>>2]);Ka=ea(g[B>>2]);za=ea(g[C>>2]);Ba=ea(g[y>>2]);Ea=ea(g[la>>2]);Ma=ea(g[D>>2]);Fa=ea(g[ba>>2]);Ia=ea(g[v>>2]);ya=ea(g[A>>2]);$a=Ba;ab=Ea;bb=Ma;cb=Fa;db=Ia;eb=ya;fb=ea(g[z>>2]);gb=Ja;hb=Ka;ib=za}za=ea(ea(0.0)*ea(2.0));Ka=ea(ea(0.0)*ea(2.0));Ja=ea(ea(1.0)*ea(2.0));ya=ea(ea(cb*cb)+ea(-.5));Ia=ea(ea(ea(za*db)+ea(Ka*eb))+ea(Ja*fb));Fa=ea(S(ea(ea(ib*ea(ea(ea(Ja*ya)+ea(cb*ea(ea(Ka*db)-ea(za*eb))))+ea(fb*Ia)))+ea(ea(gb*ea(ea(db*Ia)+ea(ea(za*ya)+ea(cb*ea(ea(Ja*eb)-ea(Ka*fb))))))+ea(hb*ea(ea(eb*Ia)+ea(ea(Ka*ya)+ea(cb*ea(ea(za*fb)-ea(Ja*db))))))))));db=ea(g[k+56>>2]);pa=Fa<db?c[k+60>>2]|0:c[k+64>>2]|0;db=ea(ea(1.0)/ea(pa>>>0));Fa=ea(db*d);Ja=ea(ea(1.0)/d);d=ea(g[k+68>>2]);g[I>>2]=db;g[I+4>>2]=Fa;g[I+8>>2]=ea(g[e>>2]);g[I+12>>2]=ea(g[e+4>>2]);g[I+16>>2]=ea(g[e+8>>2]);g[I+20>>2]=f;g[I+24>>2]=h;a[I+28>>0]=0;g[I+32>>2]=d;c[I+36>>2]=qa;c[I+40>>2]=j;if(!pa)jb=gb;else{j=J+4|0;qa=J+8|0;e=K+4|0;Ra=K+8|0;d=ea(-ja);oa=fa+212|0;wa=fa+216|0;va=ia+4|0;ua=fa+260|0;kb=fa+264|0;lb=L+4|0;mb=M+1|0;nb=ia+8|0;ob=fa+308|0;pb=fa+312|0;qb=L+8|0;rb=M+2|0;sb=ia+12|0;tb=fa+356|0;ub=fa+360|0;vb=L+12|0;wb=M+3|0;xb=Qa&1;Qa=N+4|0;yb=N+8|0;zb=N+12|0;Ab=N+16|0;Bb=N+20|0;Cb=N+24|0;Db=N+28|0;Eb=N+32|0;Fb=N+36|0;Gb=N+40|0;Hb=N+44|0;Ib=N+48|0;Jb=N+52|0;Kb=N+56|0;Lb=N+60|0;Mb=N+64|0;Nb=N+68|0;Ob=N+72|0;Pb=N+76|0;Qb=N+80|0;Rb=N+84|0;Sb=N+88|0;Tb=c[r>>2]|0;Ub=O+112|0;Vb=O+164|0;Wb=O+113|0;Xb=O+168|0;Yb=O+114|0;Zb=O+172|0;_b=O+115|0;$b=O+176|0;ac=O+508|0;bc=O+512|0;cc=O+516|0;dc=O+520|0;ec=O+524|0;fc=O+528|0;gc=O+532|0;hc=O+536|0;ic=pa+-1|0;jc=O+888|0;kc=O+968|0;lc=O+984|0;mc=ia+196|0;nc=ia+80|0;oc=ia+176|0;pc=ia+160|0;qc=ia+144|0;rc=O+904|0;sc=O+908|0;tc=ia+84|0;uc=O+912|0;vc=ia+88|0;wc=O+916|0;xc=ia+92|0;yc=O+892|0;zc=ia+178|0;Ac=O+920|0;Bc=ia+96|0;Cc=O+924|0;Dc=ia+100|0;Ec=O+928|0;Fc=ia+104|0;Gc=O+932|0;Hc=ia+108|0;Ic=O+972|0;Jc=ia+164|0;Kc=O+988|0;Lc=ia+148|0;Mc=O+896|0;Nc=ia+180|0;Oc=O+936|0;Pc=ia+112|0;Qc=O+940|0;Rc=ia+116|0;Sc=O+944|0;Tc=ia+120|0;Uc=O+948|0;Vc=ia+124|0;Wc=O+976|0;Xc=ia+168|0;Yc=O+992|0;Zc=ia+152|0;_c=O+900|0;$c=ia+182|0;ad=O+952|0;bd=ia+128|0;cd=O+956|0;dd=ia+132|0;ed=O+960|0;fd=ia+136|0;gd=O+964|0;hd=ia+140|0;id=O+980|0;jd=ia+172|0;kd=O+996|0;ld=ia+156|0;md=ia+200|0;nd=O+484|0;od=O+488|0;pd=O+492|0;qd=O+496|0;rd=O+500|0;sd=O+504|0;td=ia+192|0;ud=O+540|0;vd=O+544|0;wd=O+548|0;xd=O+552|0;yd=O+556|0;zd=O+560|0;Ad=O+564|0;Bd=O+568|0;Cd=O+572|0;Dd=O+576|0;Ed=O+580|0;Fd=O+584|0;Gd=O+588|0;Hd=O+592|0;Id=O+596|0;Jd=O+600|0;Kd=O+604|0;Ld=O+608|0;Md=O+612|0;Nd=O+616|0;Od=O+620|0;Pd=O+624|0;Qd=O+628|0;Rd=O+632|0;Sd=O+636|0;Td=O+656|0;Ud=O+660|0;Vd=O+664|0;Wd=O+668|0;Xd=O+672|0;Yd=O+676|0;Zd=O+680|0;_d=O+684|0;$d=O+688|0;ae=O+692|0;be=O+696|0;ce=O+700|0;de=O+704|0;ee=O+708|0;fe=O+712|0;ge=O+716|0;he=O+720|0;ie=O+724|0;je=O+728|0;ke=O+732|0;le=O+736|0;me=O+740|0;ne=O+744|0;oe=O+748|0;pe=O+752|0;qe=O+772|0;re=O+776|0;se=O+780|0;te=O+784|0;ue=O+788|0;ve=O+792|0;we=O+796|0;xe=O+800|0;ye=O+804|0;ze=O+808|0;Ae=O+812|0;Be=O+816|0;Ce=O+820|0;De=O+824|0;Ee=O+828|0;Fe=O+832|0;Ge=O+836|0;He=O+840|0;Ie=O+844|0;Je=O+848|0;Ke=O+852|0;Le=O+856|0;Me=O+860|0;Ne=O+864|0;Oe=O+868|0;Pe=c[r>>2]|0;Qe=(Pe|0)==0;Re=o+84|0;Se=o+108|0;Te=o+4|0;Ue=o+92|0;Ve=o+96|0;We=o+100|0;Xe=Q+4|0;Ye=Q+8|0;Ze=Q+12|0;_e=Q+16|0;$e=Q+20|0;af=Q+24|0;bf=Q+28|0;cf=Q+32|0;df=Q+36|0;ef=Q+40|0;ff=Q+44|0;gf=Q+48|0;hf=Q+52|0;jf=O+468|0;kf=Q+56|0;lf=Q+60|0;mf=Q+64|0;nf=Q+68|0;of=R+4|0;h=ea(Oa*Ga);pf=da>>>0>1;qf=T+4|0;rf=T+8|0;sf=T+12|0;tf=W+4|0;uf=X+1|0;vf=W+8|0;wf=X+2|0;xf=W+12|0;yf=X+3|0;zf=Z+4|0;Af=Z+8|0;Bf=Z+12|0;Cf=Z+16|0;Df=Z+20|0;Ef=Z+24|0;Ff=Z+28|0;Gf=Z+32|0;Hf=Z+36|0;If=Z+40|0;Jf=Z+44|0;Kf=Z+48|0;Lf=Z+52|0;Mf=Z+56|0;Nf=Z+60|0;Of=Z+64|0;Pf=Z+68|0;Qf=Z+72|0;Rf=Z+76|0;Sf=Z+80|0;Tf=Z+84|0;Uf=Z+88|0;Vf=_+112|0;Wf=_+164|0;Xf=_+113|0;Yf=_+168|0;Zf=_+114|0;_f=_+172|0;$f=_+115|0;ag=_+176|0;bg=_+508|0;cg=_+512|0;dg=_+516|0;eg=_+520|0;fg=_+524|0;gg=_+528|0;hg=_+532|0;ig=_+536|0;jg=_+888|0;kg=_+968|0;lg=_+984|0;mg=_+904|0;ng=_+908|0;og=_+912|0;pg=_+916|0;qg=_+892|0;rg=_+920|0;sg=_+924|0;tg=_+928|0;ug=_+932|0;vg=_+972|0;wg=_+988|0;xg=_+896|0;yg=_+936|0;zg=_+940|0;Ag=_+944|0;Bg=_+948|0;Cg=_+976|0;Dg=_+992|0;Eg=_+900|0;Fg=_+952|0;Gg=_+956|0;Hg=_+960|0;Ig=_+964|0;Jg=_+980|0;Kg=_+996|0;Lg=_+484|0;Mg=_+488|0;Ng=_+492|0;Og=_+496|0;Pg=_+500|0;Qg=_+504|0;Rg=_+540|0;Sg=_+544|0;Tg=_+548|0;Ug=_+552|0;Vg=_+556|0;Wg=_+560|0;Xg=_+564|0;Yg=_+568|0;Zg=_+572|0;_g=_+576|0;$g=_+580|0;ah=_+584|0;bh=_+588|0;ch=_+592|0;dh=_+596|0;eh=_+600|0;fh=_+604|0;gh=_+608|0;hh=_+612|0;ih=_+616|0;jh=_+620|0;kh=_+624|0;lh=_+628|0;mh=_+632|0;nh=_+636|0;oh=_+656|0;ph=_+660|0;qh=_+664|0;rh=_+668|0;sh=_+672|0;th=_+676|0;uh=_+680|0;vh=_+684|0;wh=_+688|0;xh=_+692|0;yh=_+696|0;zh=_+700|0;Ah=_+704|0;Bh=_+708|0;Ch=_+712|0;Dh=_+716|0;Eh=_+720|0;Fh=_+724|0;Gh=_+728|0;Hh=_+732|0;Ih=_+736|0;Jh=_+740|0;Kh=_+744|0;Lh=_+748|0;Mh=_+752|0;Nh=_+772|0;Oh=_+776|0;Ph=_+780|0;Qh=_+784|0;Rh=_+788|0;Sh=_+792|0;Th=_+796|0;Uh=_+800|0;Vh=_+804|0;Wh=_+808|0;Xh=_+812|0;Yh=_+816|0;Zh=_+820|0;_h=_+824|0;$h=_+828|0;ai=_+832|0;bi=_+836|0;ci=_+840|0;di=_+844|0;ei=_+848|0;fi=_+852|0;gi=_+856|0;ii=_+860|0;ji=_+864|0;ki=_+868|0;li=_+468|0;mi=Y+3|0;ni=Y+2|0;oi=Y+1|0;pi=0;do{g[J>>2]=ea(0.0);g[j>>2]=ea(0.0);g[qa>>2]=ea(0.0);g[K>>2]=ea(0.0);g[e>>2]=ea(0.0);g[Ra>>2]=ea(0.0);c[L+0>>2]=0;c[L+4>>2]=0;c[L+8>>2]=0;c[L+12>>2]=0;c[M>>2]=0;f=ea(g[ia>>2]);qi=f<=ea(-0.0);db=qi?ea(0.0):ea(1.0);qi=f>=ea(0.0);f=qi?db:ea(-1.0);db=ea(f*d);fb=ea(ea(g[oa>>2])*db);db=ea(Aa*f);g[L>>2]=ea(fb-ea(ea(g[wa>>2])*db));db=ea(ja*ea(g[oa>>2]));a[M>>0]=ea(db+ea(Aa*ea(g[wa>>2])))!=ea(0.0)&1;db=ea(g[va>>2]);qi=db<=ea(-0.0);fb=qi?ea(0.0):ea(1.0);qi=db>=ea(0.0);db=qi?fb:ea(-1.0);fb=ea(db*d);f=ea(ea(g[ua>>2])*fb);fb=ea(Aa*db);g[lb>>2]=ea(f-ea(ea(g[kb>>2])*fb));fb=ea(ja*ea(g[ua>>2]));a[mb>>0]=ea(fb+ea(Aa*ea(g[kb>>2])))!=ea(0.0)&1;fb=ea(g[nb>>2]);qi=fb<=ea(-0.0);f=qi?ea(0.0):ea(1.0);qi=fb>=ea(0.0);fb=qi?f:ea(-1.0);f=ea(fb*d);db=ea(ea(g[ob>>2])*f);f=ea(Aa*fb);g[qb>>2]=ea(db-ea(ea(g[pb>>2])*f));f=ea(ja*ea(g[ob>>2]));a[rb>>0]=ea(f+ea(Aa*ea(g[pb>>2])))!=ea(0.0)&1;f=ea(g[sb>>2]);qi=f<=ea(-0.0);db=qi?ea(0.0):ea(1.0);qi=f>=ea(0.0);f=qi?db:ea(-1.0);db=ea(f*d);fb=ea(ea(g[tb>>2])*db);db=ea(Aa*f);g[vb>>2]=ea(fb-ea(ea(g[ub>>2])*db));db=ea(ja*ea(g[tb>>2]));a[wb>>0]=ea(db+ea(Aa*ea(g[ub>>2])))!=ea(0.0)&1;a[N>>0]=xb;c[Qa>>2]=G;c[yb>>2]=M;c[zb>>2]=H;c[Ab>>2]=E;g[Bb>>2]=ea(g[v>>2]);g[Cb>>2]=ea(g[A>>2]);g[Db>>2]=ea(g[z>>2]);g[Eb>>2]=ea(g[ba>>2]);g[Fb>>2]=ea(g[ha>>2]);g[Gb>>2]=ea(g[ta>>2]);g[Hb>>2]=ea(g[p>>2]);g[Ib>>2]=ea(g[x>>2]);g[Jb>>2]=ea(g[B>>2]);g[Kb>>2]=ea(g[C>>2]);g[Lb>>2]=ea(g[y>>2]);g[Mb>>2]=ea(g[la>>2]);g[Nb>>2]=ea(g[D>>2]);c[Ob>>2]=fa;c[Pb>>2]=ia;c[Qb>>2]=s;c[Rb>>2]=aa;c[Sb>>2]=Tb;PEi(O|0,0,1112)|0;a[Ub>>0]=1;c[Vb>>2]=-1;a[Wb>>0]=1;c[Xb>>2]=-1;a[Yb>>0]=1;c[Zb>>2]=-1;a[_b>>0]=1;c[$b>>2]=-1;mEa(0,I,N,O);qi=c[Pb>>2]|0;ri=qi+48|0;db=ea(g[ac>>2]);si=db!=ea(g[ri>>2]);g[ri>>2]=si?db:ea(0.0);db=ea(g[bc>>2]);si=qi+52|0;ri=db!=ea(g[si>>2]);g[si>>2]=ri?db:ea(0.0);db=ea(g[cc>>2]);ri=qi+56|0;si=db!=ea(g[ri>>2]);g[ri>>2]=si?db:ea(0.0);db=ea(g[dc>>2]);si=qi+60|0;ri=db!=ea(g[si>>2]);g[si>>2]=ri?db:ea(0.0);ri=qi+64|0;db=ea(g[ec>>2]);si=db!=ea(g[ri>>2]);g[ri>>2]=si?db:ea(0.0);db=ea(g[fc>>2]);si=qi+68|0;ri=db!=ea(g[si>>2]);g[si>>2]=ri?db:ea(0.0);db=ea(g[gc>>2]);ri=qi+72|0;si=db!=ea(g[ri>>2]);g[ri>>2]=si?db:ea(0.0);db=ea(g[hc>>2]);si=qi+76|0;qi=db!=ea(g[si>>2]);g[si>>2]=qi?db:ea(0.0);qi=(ic|0)==(pi|0);if(qi){if(c[mc>>2]|0)a[md>>0]=1;b[oc>>1]=c[jc>>2];g[nc>>2]=ea(g[rc>>2]);g[tc>>2]=ea(g[sc>>2]);g[vc>>2]=ea(g[uc>>2]);g[xc>>2]=ea(g[wc>>2]);g[pc>>2]=ea(g[kc>>2]);g[qc>>2]=ea(g[lc>>2]);b[zc>>1]=c[yc>>2];g[Bc>>2]=ea(g[Ac>>2]);g[Dc>>2]=ea(g[Cc>>2]);g[Fc>>2]=ea(g[Ec>>2]);g[Hc>>2]=ea(g[Gc>>2]);g[Jc>>2]=ea(g[Ic>>2]);g[Lc>>2]=ea(g[Kc>>2]);b[Nc>>1]=c[Mc>>2];g[Pc>>2]=ea(g[Oc>>2]);g[Rc>>2]=ea(g[Qc>>2]);g[Tc>>2]=ea(g[Sc>>2]);g[Vc>>2]=ea(g[Uc>>2]);g[Xc>>2]=ea(g[Wc>>2]);g[Zc>>2]=ea(g[Yc>>2]);b[$c>>1]=c[_c>>2];g[bd>>2]=ea(g[ad>>2]);g[dd>>2]=ea(g[cd>>2]);g[fd>>2]=ea(g[ed>>2]);g[hd>>2]=ea(g[gd>>2]);g[jd>>2]=ea(g[id>>2]);g[ld>>2]=ea(g[kd>>2])}db=ea(g[nd>>2]);g[J>>2]=ea(db+ea(g[J>>2]));db=ea(g[od>>2]);g[j>>2]=ea(db+ea(g[j>>2]));db=ea(g[pd>>2]);g[qa>>2]=ea(db+ea(g[qa>>2]));db=ea(g[qd>>2]);g[K>>2]=ea(db+ea(g[K>>2]));db=ea(g[rd>>2]);g[e>>2]=ea(db+ea(g[e>>2]));db=ea(g[sd>>2]);g[Ra>>2]=ea(db+ea(g[Ra>>2]));si=c[td>>2]|0;g[si+4>>2]=ea(g[ud>>2]);g[si+8>>2]=ea(g[vd>>2]);g[si+12>>2]=ea(g[wd>>2]);g[si+16>>2]=ea(g[xd>>2]);g[si+20>>2]=ea(g[yd>>2]);g[si+24>>2]=ea(g[zd>>2]);g[si+28>>2]=ea(g[Ad>>2]);g[si+32>>2]=ea(g[Bd>>2]);g[si+36>>2]=ea(g[Cd>>2]);g[si+40>>2]=ea(g[Dd>>2]);g[si+44>>2]=ea(g[Ed>>2]);g[si+48>>2]=ea(g[Fd>>2]);g[si+52>>2]=ea(g[Gd>>2]);g[si+56>>2]=ea(g[Hd>>2]);g[si+60>>2]=ea(g[Id>>2]);g[si+64>>2]=ea(g[Jd>>2]);g[si+68>>2]=ea(g[Kd>>2]);g[si+72>>2]=ea(g[Ld>>2]);g[si+76>>2]=ea(g[Md>>2]);g[si+80>>2]=ea(g[Nd>>2]);g[si+84>>2]=ea(g[Od>>2]);g[si+88>>2]=ea(g[Pd>>2]);g[si+92>>2]=ea(g[Qd>>2]);g[si+96>>2]=ea(g[Rd>>2]);ri=si+100|0;c[ri+0>>2]=c[Sd+0>>2];c[ri+4>>2]=c[Sd+4>>2];c[ri+8>>2]=c[Sd+8>>2];c[ri+12>>2]=c[Sd+12>>2];c[ri+16>>2]=c[Sd+16>>2];g[si+120>>2]=ea(g[Td>>2]);g[si+124>>2]=ea(g[Ud>>2]);g[si+128>>2]=ea(g[Vd>>2]);g[si+132>>2]=ea(g[Wd>>2]);g[si+136>>2]=ea(g[Xd>>2]);g[si+140>>2]=ea(g[Yd>>2]);g[si+144>>2]=ea(g[Zd>>2]);g[si+148>>2]=ea(g[_d>>2]);g[si+152>>2]=ea(g[$d>>2]);g[si+156>>2]=ea(g[ae>>2]);g[si+160>>2]=ea(g[be>>2]);g[si+164>>2]=ea(g[ce>>2]);g[si+168>>2]=ea(g[de>>2]);g[si+172>>2]=ea(g[ee>>2]);g[si+176>>2]=ea(g[fe>>2]);g[si+180>>2]=ea(g[ge>>2]);g[si+184>>2]=ea(g[he>>2]);g[si+188>>2]=ea(g[ie>>2]);g[si+192>>2]=ea(g[je>>2]);g[si+196>>2]=ea(g[ke>>2]);g[si+200>>2]=ea(g[le>>2]);g[si+204>>2]=ea(g[me>>2]);g[si+208>>2]=ea(g[ne>>2]);g[si+212>>2]=ea(g[oe>>2]);ri=si+216|0;c[ri+0>>2]=c[pe+0>>2];c[ri+4>>2]=c[pe+4>>2];c[ri+8>>2]=c[pe+8>>2];c[ri+12>>2]=c[pe+12>>2];c[ri+16>>2]=c[pe+16>>2];g[si+236>>2]=ea(g[qe>>2]);g[si+240>>2]=ea(g[re>>2]);g[si+244>>2]=ea(g[se>>2]);g[si+248>>2]=ea(g[te>>2]);g[si+252>>2]=ea(g[ue>>2]);g[si+256>>2]=ea(g[ve>>2]);g[si+260>>2]=ea(g[we>>2]);g[si+264>>2]=ea(g[xe>>2]);g[si+268>>2]=ea(g[ye>>2]);g[si+272>>2]=ea(g[ze>>2]);g[si+276>>2]=ea(g[Ae>>2]);g[si+280>>2]=ea(g[Be>>2]);g[si+284>>2]=ea(g[Ce>>2]);g[si+288>>2]=ea(g[De>>2]);g[si+292>>2]=ea(g[Ee>>2]);g[si+296>>2]=ea(g[Fe>>2]);g[si+300>>2]=ea(g[Ge>>2]);g[si+304>>2]=ea(g[He>>2]);g[si+308>>2]=ea(g[Ie>>2]);g[si+312>>2]=ea(g[Je>>2]);g[si+316>>2]=ea(g[Ke>>2]);g[si+320>>2]=ea(g[Le>>2]);g[si+324>>2]=ea(g[Me>>2]);g[si+328>>2]=ea(g[Ne>>2]);ri=si+332|0;c[ri+0>>2]=c[Oe+0>>2];c[ri+4>>2]=c[Oe+4>>2];c[ri+8>>2]=c[Oe+8>>2];c[ri+12>>2]=c[Oe+12>>2];c[ri+16>>2]=c[Oe+16>>2];Z2a(O,c[zb>>2]|0,t,Pe);ri=c[q>>2]|0;if(!Qe){si=0;do{c[ri+(si*56|0)+28>>2]=c[O+(si<<2)+1e3>>2];db=ea(g[O+(si*12|0)+1016>>2]);ti=ri+(si*56|0)+32|0;g[ti>>2]=ea(db+ea(g[ti>>2]));db=ea(g[O+(si*12|0)+1020>>2]);ti=ri+(si*56|0)+36|0;g[ti>>2]=ea(db+ea(g[ti>>2]));db=ea(g[O+(si*12|0)+1024>>2]);ti=ri+(si*56|0)+40|0;g[ti>>2]=ea(db+ea(g[ti>>2]));g[ri+(si*56|0)+44>>2]=ea(g[O+(si*12|0)+1064>>2]);g[ri+(si*56|0)+48>>2]=ea(g[O+(si*12|0)+1068>>2]);g[ri+(si*56|0)+52>>2]=ea(g[O+(si*12|0)+1072>>2]);si=si+1|0}while((si|0)!=(Pe|0))};c[P+0>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;c[P+12>>2]=0;_2a(ma,Aa,ia,P);db=ea(g[ga>>2]);fb=ea(Na*ea(g[Re>>2]));f=ea(db*ea(g[Se>>2]));si=c[na>>2]|0;do if((si|0)==1)ui=89;else if(si){db=ea(g[o>>2]);if(db>f){ui=89;break}ri=1;za=db;db=ea(g[Te>>2]);while(1){ti=ri<<1;vi=ea(g[o+(ti<<2)>>2]);wi=ea(g[o+((ti|1)<<2)>>2]);ri=ri+1|0;if(za<=f&vi>f){ui=93;break}if(ri>>>0>=si>>>0){ui=94;break}else{za=vi;db=wi}}if((ui|0)==93){ui=0;xi=ea(db+ea(ea(ea(f-za)*ea(wi-db))/ea(vi-za)));break}else if((ui|0)==94){ui=0;xi=ea(g[o+(((si<<1)+-2|1)<<2)>>2]);break}}else xi=ea(0.0);while(0);if((ui|0)==89){ui=0;xi=ea(g[Te>>2])}f=ea(fb*xi);if(0)g[1]=f;cb=ea(g[Ue>>2]);ya=ea(g[We>>2]);Ka=ea(g[Ve>>2]);Ia=ra?ya:Ka;Ka=ea(Ia+ea(Na*ea(cb-Ia)));g[Q>>2]=Fa;g[Xe>>2]=ja;g[Ye>>2]=Aa;g[Ze>>2]=Oa;g[_e>>2]=Ga;c[$e>>2]=sa;c[af>>2]=xa;g[bf>>2]=f;g[cf>>2]=Ka;c[df>>2]=P;c[ef>>2]=F;c[ff>>2]=L;c[gf>>2]=M;c[hf>>2]=jf;c[kf>>2]=1;c[lf>>2]=4;c[mf>>2]=fa;c[nf>>2]=o;c[R>>2]=ia;c[of>>2]=ca;oEa(Q,R);si=0;do{Ka=ea(g[ia+(si<<2)>>2]);Ia=ea(g[O+(si<<2)+292>>2]);do if(Ia>ea(-ea(g[fa+(si*48|0)+12>>2]))){if(a[M+si>>0]|0){yi=Ka;break}if(!(ea(f*ea(h*ea(g[P+(si<<2)>>2])))==ea(0.0))){yi=Ka;break}cb=ea(g[O+(si<<2)+452>>2]);ya=ea(S(ea(cb)));if(!(ya<ea(g[129512]))){yi=Ka;break}eb=ea(g[fa+(si*48|0)+228>>2]);Ma=ea(ya*ea(g[129514]));yi=ea(ea(Ka*Ma)+ea(ea(cb*eb)*ea(ea(1.0)-Ma)))}else yi=Ka;while(0);ri=ia+(si<<2)+32|0;Ka=ea(ea(g[ri>>2])+ea(Fa*yi));Ia=ea(Ka+ea(-31.4159279));za=ea(Ka+ea(31.4159279));ti=ea(ea(-31.4159279)-Ka)>=ea(0.0);zi=Ia>=ea(0.0);g[ri>>2]=zi?Ia:ti?za:Ka;g[ia+(si<<2)+16>>2]=yi;si=si+1|0}while((si|0)!=4);if(pf){f=ea(g[v>>2]);fb=ea(g[A>>2]);Ka=ea(g[z>>2]);za=ea(g[ba>>2]);Ia=ea(g[ha>>2]);db=ea(g[ta>>2]);Ma=ea(g[p>>2]);eb=ea(g[x>>2]);cb=ea(g[B>>2]);ya=ea(g[C>>2]);Ea=ea(g[y>>2]);Ba=ea(g[la>>2]);Ha=ea(g[D>>2]);Pa=ea(g[J>>2]);Sa=ea(g[j>>2]);Za=ea(g[qa>>2]);Xa=ea(g[K>>2]);Ya=ea(g[e>>2]);Wa=Pa;Pa=Sa;Sa=Za;Za=Xa;Xa=Ya;Ya=ea(g[Ra>>2]);si=1;do{ti=fa+(si*944|0)|0;Ua=ea(g[fa+(si*944|0)+224>>2]);Ca=ea(g[fa+(si*944|0)+272>>2]);_a=ea(g[fa+(si*944|0)+320>>2]);Va=ea(g[fa+(si*944|0)+368>>2]);g[T>>2]=Ua;g[qf>>2]=Ca;g[rf>>2]=_a;g[sf>>2]=Va;c[U+0>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;c[U+12>>2]=0;c[V>>2]=0;c[W+0>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;c[X>>2]=0;zi=ia+(si*208|0)|0;Va=ea(g[zi>>2]);ri=Va<=ea(-0.0);_a=ri?ea(0.0):ea(1.0);ri=Va>=ea(0.0);Va=ri?_a:ea(-1.0);_a=ea(Va*d);Ca=ea(g[fa+(si*944|0)+212>>2]);Ua=ea(Ca*_a);_a=ea(Aa*Va);Va=ea(g[fa+(si*944|0)+216>>2]);g[W>>2]=ea(Ua-ea(Va*_a));a[X>>0]=ea(ea(ja*Ca)+ea(Aa*Va))!=ea(0.0)&1;Va=ea(g[ia+(si*208|0)+4>>2]);ri=Va<=ea(-0.0);Ca=ri?ea(0.0):ea(1.0);ri=Va>=ea(0.0);Va=ri?Ca:ea(-1.0);Ca=ea(Va*d);_a=ea(g[fa+(si*944|0)+260>>2]);Ua=ea(_a*Ca);Ca=ea(Aa*Va);Va=ea(g[fa+(si*944|0)+264>>2]);g[tf>>2]=ea(Ua-ea(Va*Ca));a[uf>>0]=ea(ea(ja*_a)+ea(Aa*Va))!=ea(0.0)&1;Va=ea(g[ia+(si*208|0)+8>>2]);ri=Va<=ea(-0.0);_a=ri?ea(0.0):ea(1.0);ri=Va>=ea(0.0);Va=ri?_a:ea(-1.0);_a=ea(Va*d);Ca=ea(g[fa+(si*944|0)+308>>2]);Ua=ea(Ca*_a);_a=ea(Aa*Va);Va=ea(g[fa+(si*944|0)+312>>2]);g[vf>>2]=ea(Ua-ea(Va*_a));a[wf>>0]=ea(ea(ja*Ca)+ea(Aa*Va))!=ea(0.0)&1;Va=ea(g[ia+(si*208|0)+12>>2]);ri=Va<=ea(-0.0);Ca=ri?ea(0.0):ea(1.0);ri=Va>=ea(0.0);Va=ri?Ca:ea(-1.0);Ca=ea(Va*d);_a=ea(g[fa+(si*944|0)+356>>2]);Ua=ea(_a*Ca);Ca=ea(Aa*Va);Va=ea(g[fa+(si*944|0)+360>>2]);g[xf>>2]=ea(Ua-ea(Va*Ca));a[yf>>0]=ea(ea(ja*_a)+ea(Aa*Va))!=ea(0.0)&1;c[Y>>2]=0;ri=si<<2;Ai=c[k+((si>>>3&134217727)<<2)+52>>2]|0;Bi=ri&28;if(Ai&1<<Bi)a[Y>>0]=1;if(Ai&1<<(Bi|1))a[oi>>0]=1;if(Ai&1<<(Bi|2))a[ni>>0]=1;if(Ai&1<<(Bi|3))a[mi>>0]=1;a[Z>>0]=xb;c[zf>>2]=V;c[Af>>2]=X;c[Bf>>2]=T;c[Cf>>2]=Y;g[Df>>2]=f;g[Ef>>2]=fb;g[Ff>>2]=Ka;g[Gf>>2]=za;g[Hf>>2]=Ia;g[If>>2]=db;g[Jf>>2]=Ma;g[Kf>>2]=eb;g[Lf>>2]=cb;g[Mf>>2]=ya;g[Nf>>2]=Ea;g[Of>>2]=Ba;g[Pf>>2]=Ha;c[Qf>>2]=ti;c[Rf>>2]=zi;c[Sf>>2]=s+(si*20|0);c[Tf>>2]=aa;Bi=r+(si<<2)|0;c[Uf>>2]=c[Bi>>2];PEi(_|0,0,1112)|0;a[Vf>>0]=1;c[Wf>>2]=-1;a[Xf>>0]=1;c[Yf>>2]=-1;a[Zf>>0]=1;c[_f>>2]=-1;a[$f>>0]=1;c[ag>>2]=-1;mEa(ri,I,Z,_);Ai=c[Rf>>2]|0;Ci=Ai+48|0;Va=ea(g[bg>>2]);Di=Va!=ea(g[Ci>>2]);g[Ci>>2]=Di?Va:ea(0.0);Va=ea(g[cg>>2]);Di=Ai+52|0;Ci=Va!=ea(g[Di>>2]);g[Di>>2]=Ci?Va:ea(0.0);Va=ea(g[dg>>2]);Ci=Ai+56|0;Di=Va!=ea(g[Ci>>2]);g[Ci>>2]=Di?Va:ea(0.0);Va=ea(g[eg>>2]);Di=Ai+60|0;Ci=Va!=ea(g[Di>>2]);g[Di>>2]=Ci?Va:ea(0.0);Ci=Ai+64|0;Va=ea(g[fg>>2]);Di=Va!=ea(g[Ci>>2]);g[Ci>>2]=Di?Va:ea(0.0);Va=ea(g[gg>>2]);Di=Ai+68|0;Ci=Va!=ea(g[Di>>2]);g[Di>>2]=Ci?Va:ea(0.0);Va=ea(g[hg>>2]);Ci=Ai+72|0;Di=Va!=ea(g[Ci>>2]);g[Ci>>2]=Di?Va:ea(0.0);Va=ea(g[ig>>2]);Di=Ai+76|0;Ai=Va!=ea(g[Di>>2]);g[Di>>2]=Ai?Va:ea(0.0);if(qi){if(c[ia+(si*208|0)+196>>2]|0)a[ia+(si*208|0)+200>>0]=1;b[ia+(si*208|0)+176>>1]=c[jg>>2];g[ia+(si*208|0)+80>>2]=ea(g[mg>>2]);g[ia+(si*208|0)+84>>2]=ea(g[ng>>2]);g[ia+(si*208|0)+88>>2]=ea(g[og>>2]);g[ia+(si*208|0)+92>>2]=ea(g[pg>>2]);g[ia+(si*208|0)+160>>2]=ea(g[kg>>2]);g[ia+(si*208|0)+144>>2]=ea(g[lg>>2]);b[ia+(si*208|0)+178>>1]=c[qg>>2];g[ia+(si*208|0)+96>>2]=ea(g[rg>>2]);g[ia+(si*208|0)+100>>2]=ea(g[sg>>2]);g[ia+(si*208|0)+104>>2]=ea(g[tg>>2]);g[ia+(si*208|0)+108>>2]=ea(g[ug>>2]);g[ia+(si*208|0)+164>>2]=ea(g[vg>>2]);g[ia+(si*208|0)+148>>2]=ea(g[wg>>2]);b[ia+(si*208|0)+180>>1]=c[xg>>2];g[ia+(si*208|0)+112>>2]=ea(g[yg>>2]);g[ia+(si*208|0)+116>>2]=ea(g[zg>>2]);g[ia+(si*208|0)+120>>2]=ea(g[Ag>>2]);g[ia+(si*208|0)+124>>2]=ea(g[Bg>>2]);g[ia+(si*208|0)+168>>2]=ea(g[Cg>>2]);g[ia+(si*208|0)+152>>2]=ea(g[Dg>>2]);b[ia+(si*208|0)+182>>1]=c[Eg>>2];g[ia+(si*208|0)+128>>2]=ea(g[Fg>>2]);g[ia+(si*208|0)+132>>2]=ea(g[Gg>>2]);g[ia+(si*208|0)+136>>2]=ea(g[Hg>>2]);g[ia+(si*208|0)+140>>2]=ea(g[Ig>>2]);g[ia+(si*208|0)+172>>2]=ea(g[Jg>>2]);g[ia+(si*208|0)+156>>2]=ea(g[Kg>>2])}Wa=ea(ea(g[Lg>>2])+Wa);Pa=ea(ea(g[Mg>>2])+Pa);Sa=ea(ea(g[Ng>>2])+Sa);Za=ea(ea(g[Og>>2])+Za);Xa=ea(ea(g[Pg>>2])+Xa);Ya=ea(ea(g[Qg>>2])+Ya);Ai=c[ia+(si*208|0)+192>>2]|0;g[Ai+4>>2]=ea(g[Rg>>2]);g[Ai+8>>2]=ea(g[Sg>>2]);g[Ai+12>>2]=ea(g[Tg>>2]);g[Ai+16>>2]=ea(g[Ug>>2]);g[Ai+20>>2]=ea(g[Vg>>2]);g[Ai+24>>2]=ea(g[Wg>>2]);g[Ai+28>>2]=ea(g[Xg>>2]);g[Ai+32>>2]=ea(g[Yg>>2]);g[Ai+36>>2]=ea(g[Zg>>2]);g[Ai+40>>2]=ea(g[_g>>2]);g[Ai+44>>2]=ea(g[$g>>2]);g[Ai+48>>2]=ea(g[ah>>2]);g[Ai+52>>2]=ea(g[bh>>2]);g[Ai+56>>2]=ea(g[ch>>2]);g[Ai+60>>2]=ea(g[dh>>2]);g[Ai+64>>2]=ea(g[eh>>2]);g[Ai+68>>2]=ea(g[fh>>2]);g[Ai+72>>2]=ea(g[gh>>2]);g[Ai+76>>2]=ea(g[hh>>2]);g[Ai+80>>2]=ea(g[ih>>2]);g[Ai+84>>2]=ea(g[jh>>2]);g[Ai+88>>2]=ea(g[kh>>2]);g[Ai+92>>2]=ea(g[lh>>2]);g[Ai+96>>2]=ea(g[mh>>2]);Di=Ai+100|0;c[Di+0>>2]=c[nh+0>>2];c[Di+4>>2]=c[nh+4>>2];c[Di+8>>2]=c[nh+8>>2];c[Di+12>>2]=c[nh+12>>2];c[Di+16>>2]=c[nh+16>>2];g[Ai+120>>2]=ea(g[oh>>2]);g[Ai+124>>2]=ea(g[ph>>2]);g[Ai+128>>2]=ea(g[qh>>2]);g[Ai+132>>2]=ea(g[rh>>2]);g[Ai+136>>2]=ea(g[sh>>2]);g[Ai+140>>2]=ea(g[th>>2]);g[Ai+144>>2]=ea(g[uh>>2]);g[Ai+148>>2]=ea(g[vh>>2]);g[Ai+152>>2]=ea(g[wh>>2]);g[Ai+156>>2]=ea(g[xh>>2]);g[Ai+160>>2]=ea(g[yh>>2]);g[Ai+164>>2]=ea(g[zh>>2]);g[Ai+168>>2]=ea(g[Ah>>2]);g[Ai+172>>2]=ea(g[Bh>>2]);g[Ai+176>>2]=ea(g[Ch>>2]);g[Ai+180>>2]=ea(g[Dh>>2]);g[Ai+184>>2]=ea(g[Eh>>2]);g[Ai+188>>2]=ea(g[Fh>>2]);g[Ai+192>>2]=ea(g[Gh>>2]);g[Ai+196>>2]=ea(g[Hh>>2]);g[Ai+200>>2]=ea(g[Ih>>2]);g[Ai+204>>2]=ea(g[Jh>>2]);g[Ai+208>>2]=ea(g[Kh>>2]);g[Ai+212>>2]=ea(g[Lh>>2]);Di=Ai+216|0;c[Di+0>>2]=c[Mh+0>>2];c[Di+4>>2]=c[Mh+4>>2];c[Di+8>>2]=c[Mh+8>>2];c[Di+12>>2]=c[Mh+12>>2];c[Di+16>>2]=c[Mh+16>>2];g[Ai+236>>2]=ea(g[Nh>>2]);g[Ai+240>>2]=ea(g[Oh>>2]);g[Ai+244>>2]=ea(g[Ph>>2]);g[Ai+248>>2]=ea(g[Qh>>2]);g[Ai+252>>2]=ea(g[Rh>>2]);g[Ai+256>>2]=ea(g[Sh>>2]);g[Ai+260>>2]=ea(g[Th>>2]);g[Ai+264>>2]=ea(g[Uh>>2]);g[Ai+268>>2]=ea(g[Vh>>2]);g[Ai+272>>2]=ea(g[Wh>>2]);g[Ai+276>>2]=ea(g[Xh>>2]);g[Ai+280>>2]=ea(g[Yh>>2]);g[Ai+284>>2]=ea(g[Zh>>2]);g[Ai+288>>2]=ea(g[_h>>2]);g[Ai+292>>2]=ea(g[$h>>2]);g[Ai+296>>2]=ea(g[ai>>2]);g[Ai+300>>2]=ea(g[bi>>2]);g[Ai+304>>2]=ea(g[ci>>2]);g[Ai+308>>2]=ea(g[di>>2]);g[Ai+312>>2]=ea(g[ei>>2]);g[Ai+316>>2]=ea(g[fi>>2]);g[Ai+320>>2]=ea(g[gi>>2]);g[Ai+324>>2]=ea(g[ii>>2]);g[Ai+328>>2]=ea(g[ji>>2]);Di=Ai+332|0;c[Di+0>>2]=c[ki+0>>2];c[Di+4>>2]=c[ki+4>>2];c[Di+8>>2]=c[ki+8>>2];c[Di+12>>2]=c[ki+12>>2];c[Di+16>>2]=c[ki+16>>2];Di=c[Bi>>2]|0;Z2a(_,c[Bf>>2]|0,t+(ri*148|0)|0,Di);Bi=c[q>>2]|0;if(Di){Ai=0;do{Ci=Ai+ri|0;c[Bi+(Ci*56|0)+28>>2]=c[_+(Ai<<2)+1e3>>2];Va=ea(g[_+(Ai*12|0)+1016>>2]);Ei=Bi+(Ci*56|0)+32|0;g[Ei>>2]=ea(Va+ea(g[Ei>>2]));Va=ea(g[_+(Ai*12|0)+1020>>2]);Ei=Bi+(Ci*56|0)+36|0;g[Ei>>2]=ea(Va+ea(g[Ei>>2]));Va=ea(g[_+(Ai*12|0)+1024>>2]);Ei=Bi+(Ci*56|0)+40|0;g[Ei>>2]=ea(Va+ea(g[Ei>>2]));g[Bi+(Ci*56|0)+44>>2]=ea(g[_+(Ai*12|0)+1064>>2]);g[Bi+(Ci*56|0)+48>>2]=ea(g[_+(Ai*12|0)+1068>>2]);g[Bi+(Ci*56|0)+52>>2]=ea(g[_+(Ai*12|0)+1072>>2]);Ai=Ai+1|0}while((Ai|0)!=(Di|0))}sEa(Fa,ja,Aa,li,W,ti,zi);Di=0;do{Va=ea(g[ia+(si*208|0)+(Di<<2)>>2]);_a=ea(g[_+(Di<<2)+292>>2]);do if(_a>ea(-ea(g[fa+(si*944|0)+(Di*48|0)+12>>2]))){if(a[X+Di>>0]|0){Fi=Va;break}if(!(ea(ea(ea(g[U+(Di<<2)>>2])*ea(0.0))*ea(0.0))==ea(0.0))){Fi=Va;break}Ca=ea(g[_+(Di<<2)+452>>2]);Ua=ea(S(ea(Ca)));if(!(Ua<ea(g[129512]))){Fi=Va;break}Ta=ea(g[fa+(si*944|0)+(Di*48|0)+228>>2]);Da=ea(Ua*ea(g[129514]));Fi=ea(ea(Va*Da)+ea(ea(Ca*Ta)*ea(ea(1.0)-Da)))}else Fi=Va;while(0);Ai=ia+(si*208|0)+(Di<<2)+32|0;Va=ea(ea(g[Ai>>2])+ea(Fa*Fi));_a=ea(Va+ea(-31.4159279));Da=ea(Va+ea(31.4159279));Bi=ea(ea(-31.4159279)-Va)>=ea(0.0);ri=_a>=ea(0.0);g[Ai>>2]=ri?_a:Bi?Da:Va;g[ia+(si*208|0)+(Di<<2)+16>>2]=Fi;Di=Di+1|0}while((Di|0)!=4);si=si+1|0}while((si|0)!=(da|0));g[J>>2]=Wa;g[j>>2]=Pa;g[qa>>2]=Sa;g[K>>2]=Za;g[e>>2]=Xa;g[Ra>>2]=Ya}$2a(La,w,J,K,Fa,x,y,v);pi=pi+1|0}while((pi|0)!=(pa|0));jb=ea(g[x>>2])}x=q+8|0;if(!0){g[x>>2]=jb;g[q+12>>2]=ea(g[B>>2]);g[q+16>>2]=ea(g[C>>2]);g[q+20>>2]=ea(g[y>>2]);g[q+24>>2]=ea(g[la>>2]);g[q+28>>2]=ea(g[D>>2])}else{Fa=ea(jb-gb);gb=ea(ea(g[B>>2])-hb);hb=ea(Ja*gb);gb=ea(Ja*ea(ea(g[C>>2])-ib));g[x>>2]=ea(Ja*Fa);g[q+12>>2]=hb;g[q+16>>2]=gb;gb=ea(ea(g[y>>2])-$a);$a=ea(ea(g[la>>2])-ab);ab=ea(Ja*$a);$a=ea(Ja*ea(ea(g[D>>2])-bb));g[q+20>>2]=ea(Ja*gb);g[q+24>>2]=ab;g[q+28>>2]=$a}g[Z>>2]=ea(0.0);D=Z+4|0;g[D>>2]=ea(0.0);la=Z+8|0;g[la>>2]=ea(0.0);y=Z+12|0;g[y>>2]=ea(1.0);C=Z+16|0;B=Z+20|0;pa=Z+24|0;pi=Z+28|0;v=Z+32|0;K=Z+36|0;J=Z+40|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[C+16>>2]=0;c[C+20>>2]=0;g[J>>2]=ea(1.0);w=Z+44|0;Ra=Z+48|0;e=Z+52|0;qa=Z+56|0;j=Z+60|0;U=Z+64|0;X=Z+68|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[X>>2]=ea(1.0);W=Z+72|0;li=Z+76|0;Bf=Z+80|0;ki=Z+84|0;ji=Z+88|0;ii=Z+92|0;gi=Z+96|0;c[W+0>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;c[W+12>>2]=0;c[W+16>>2]=0;c[W+20>>2]=0;g[gi>>2]=ea(1.0);fi=Z+100|0;g[fi>>2]=ea(0.0);ei=Z+104|0;g[ei>>2]=ea(0.0);di=Z+108|0;g[di>>2]=ea(0.0);tEa(fa,ia,t,c[r>>2]|0,u,Z);$a=ea(g[Z>>2]);g[t+120>>2]=$a;g[t+124>>2]=ea(g[D>>2]);g[t+128>>2]=ea(g[la>>2]);g[t+132>>2]=ea(g[y>>2]);g[t+136>>2]=ea(g[C>>2]);g[t+140>>2]=ea(g[B>>2]);g[t+144>>2]=ea(g[pa>>2]);g[t+268>>2]=ea(g[pi>>2]);g[t+272>>2]=ea(g[v>>2]);g[t+276>>2]=ea(g[K>>2]);g[t+280>>2]=ea(g[J>>2]);g[t+284>>2]=ea(g[w>>2]);g[t+288>>2]=ea(g[Ra>>2]);g[t+292>>2]=ea(g[e>>2]);g[t+416>>2]=ea(g[qa>>2]);g[t+420>>2]=ea(g[j>>2]);g[t+424>>2]=ea(g[U>>2]);g[t+428>>2]=ea(g[X>>2]);g[t+432>>2]=ea(g[W>>2]);g[t+436>>2]=ea(g[li>>2]);g[t+440>>2]=ea(g[Bf>>2]);g[t+564>>2]=ea(g[ki>>2]);g[t+568>>2]=ea(g[ji>>2]);g[t+572>>2]=ea(g[ii>>2]);g[t+576>>2]=ea(g[gi>>2]);g[t+580>>2]=ea(g[fi>>2]);g[t+584>>2]=ea(g[ei>>2]);g[t+588>>2]=ea(g[di>>2]);Z=c[q>>2]|0;g[Z>>2]=$a;g[Z+4>>2]=ea(g[D>>2]);g[Z+8>>2]=ea(g[la>>2]);g[Z+12>>2]=ea(g[y>>2]);g[Z+16>>2]=ea(g[C>>2]);g[Z+20>>2]=ea(g[B>>2]);g[Z+24>>2]=ea(g[pa>>2]);g[Z+56>>2]=ea(g[pi>>2]);g[Z+60>>2]=ea(g[v>>2]);g[Z+64>>2]=ea(g[K>>2]);g[Z+68>>2]=ea(g[J>>2]);g[Z+72>>2]=ea(g[w>>2]);g[Z+76>>2]=ea(g[Ra>>2]);g[Z+80>>2]=ea(g[e>>2]);g[Z+112>>2]=ea(g[qa>>2]);g[Z+116>>2]=ea(g[j>>2]);g[Z+120>>2]=ea(g[U>>2]);g[Z+124>>2]=ea(g[X>>2]);g[Z+128>>2]=ea(g[W>>2]);g[Z+132>>2]=ea(g[li>>2]);g[Z+136>>2]=ea(g[Bf>>2]);g[Z+168>>2]=ea(g[ki>>2]);g[Z+172>>2]=ea(g[ji>>2]);g[Z+176>>2]=ea(g[ii>>2]);g[Z+180>>2]=ea(g[gi>>2]);g[Z+184>>2]=ea(g[fi>>2]);g[Z+188>>2]=ea(g[ei>>2]);g[Z+192>>2]=ea(g[di>>2]);if(da>>>0>1){di=_+4|0;Z=_+8|0;ei=_+12|0;fi=_+16|0;gi=_+20|0;ii=_+24|0;ji=_+28|0;ki=_+32|0;Bf=_+36|0;li=_+40|0;W=_+44|0;X=_+48|0;U=_+52|0;j=_+56|0;qa=_+60|0;e=_+64|0;Ra=_+68|0;w=_+72|0;J=_+76|0;K=_+80|0;v=_+84|0;pi=_+88|0;pa=_+92|0;B=_+96|0;C=_+100|0;y=_+104|0;la=_+108|0;D=1;do{g[_>>2]=ea(0.0);g[di>>2]=ea(0.0);g[Z>>2]=ea(0.0);g[ei>>2]=ea(1.0);c[fi+0>>2]=0;c[fi+4>>2]=0;c[fi+8>>2]=0;c[fi+12>>2]=0;c[fi+16>>2]=0;c[fi+20>>2]=0;g[li>>2]=ea(1.0);c[W+0>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;c[W+12>>2]=0;c[W+16>>2]=0;c[W+20>>2]=0;g[Ra>>2]=ea(1.0);c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[B>>2]=ea(1.0);g[C>>2]=ea(0.0);g[y>>2]=ea(0.0);g[la>>2]=ea(0.0);ci=D<<2;tEa(fa+(D*944|0)|0,ia+(D*208|0)|0,t+(ci*148|0)|0,c[r+(D<<2)>>2]|0,u,_);$a=ea(g[_>>2]);g[t+(ci*148|0)+120>>2]=$a;g[t+(ci*148|0)+124>>2]=ea(g[di>>2]);g[t+(ci*148|0)+128>>2]=ea(g[Z>>2]);g[t+(ci*148|0)+132>>2]=ea(g[ei>>2]);g[t+(ci*148|0)+136>>2]=ea(g[fi>>2]);g[t+(ci*148|0)+140>>2]=ea(g[gi>>2]);g[t+(ci*148|0)+144>>2]=ea(g[ii>>2]);bi=ci|1;g[t+(bi*148|0)+120>>2]=ea(g[ji>>2]);g[t+(bi*148|0)+124>>2]=ea(g[ki>>2]);g[t+(bi*148|0)+128>>2]=ea(g[Bf>>2]);g[t+(bi*148|0)+132>>2]=ea(g[li>>2]);g[t+(bi*148|0)+136>>2]=ea(g[W>>2]);g[t+(bi*148|0)+140>>2]=ea(g[X>>2]);g[t+(bi*148|0)+144>>2]=ea(g[U>>2]);ai=ci|2;g[t+(ai*148|0)+120>>2]=ea(g[j>>2]);g[t+(ai*148|0)+124>>2]=ea(g[qa>>2]);g[t+(ai*148|0)+128>>2]=ea(g[e>>2]);g[t+(ai*148|0)+132>>2]=ea(g[Ra>>2]);g[t+(ai*148|0)+136>>2]=ea(g[w>>2]);g[t+(ai*148|0)+140>>2]=ea(g[J>>2]);g[t+(ai*148|0)+144>>2]=ea(g[K>>2]);$h=ci|3;g[t+($h*148|0)+120>>2]=ea(g[v>>2]);g[t+($h*148|0)+124>>2]=ea(g[pi>>2]);g[t+($h*148|0)+128>>2]=ea(g[pa>>2]);g[t+($h*148|0)+132>>2]=ea(g[B>>2]);g[t+($h*148|0)+136>>2]=ea(g[C>>2]);g[t+($h*148|0)+140>>2]=ea(g[y>>2]);g[t+($h*148|0)+144>>2]=ea(g[la>>2]);_h=c[q>>2]|0;g[_h+(ci*56|0)>>2]=$a;g[_h+(ci*56|0)+4>>2]=ea(g[di>>2]);g[_h+(ci*56|0)+8>>2]=ea(g[Z>>2]);g[_h+(ci*56|0)+12>>2]=ea(g[ei>>2]);g[_h+(ci*56|0)+16>>2]=ea(g[fi>>2]);g[_h+(ci*56|0)+20>>2]=ea(g[gi>>2]);g[_h+(ci*56|0)+24>>2]=ea(g[ii>>2]);g[_h+(bi*56|0)>>2]=ea(g[ji>>2]);g[_h+(bi*56|0)+4>>2]=ea(g[ki>>2]);g[_h+(bi*56|0)+8>>2]=ea(g[Bf>>2]);g[_h+(bi*56|0)+12>>2]=ea(g[li>>2]);g[_h+(bi*56|0)+16>>2]=ea(g[W>>2]);g[_h+(bi*56|0)+20>>2]=ea(g[X>>2]);g[_h+(bi*56|0)+24>>2]=ea(g[U>>2]);g[_h+(ai*56|0)>>2]=ea(g[j>>2]);g[_h+(ai*56|0)+4>>2]=ea(g[qa>>2]);g[_h+(ai*56|0)+8>>2]=ea(g[e>>2]);g[_h+(ai*56|0)+12>>2]=ea(g[Ra>>2]);g[_h+(ai*56|0)+16>>2]=ea(g[w>>2]);g[_h+(ai*56|0)+20>>2]=ea(g[J>>2]);g[_h+(ai*56|0)+24>>2]=ea(g[K>>2]);g[_h+($h*56|0)>>2]=ea(g[v>>2]);g[_h+($h*56|0)+4>>2]=ea(g[pi>>2]);g[_h+($h*56|0)+8>>2]=ea(g[pa>>2]);g[_h+($h*56|0)+12>>2]=ea(g[B>>2]);g[_h+($h*56|0)+16>>2]=ea(g[C>>2]);g[_h+($h*56|0)+20>>2]=ea(g[y>>2]);g[_h+($h*56|0)+24>>2]=ea(g[la>>2]);D=D+1|0}while((D|0)!=(da|0))}do if(l){da=c[l>>2]|0;if(!da)break;YEi(da|0,t|0,ka*148|0)|0}while(0);if(!m){c[$>>2]=k;zEa(q,1,$);i=n;return}else{YEi(c[m>>2]|0,c[q>>2]|0,ka*56|0)|0;g[m+8>>2]=ea(g[x>>2]);g[m+12>>2]=ea(g[q+12>>2]);g[m+16>>2]=ea(g[q+16>>2]);g[m+20>>2]=ea(g[q+20>>2]);g[m+24>>2]=ea(g[q+24>>2]);g[m+28>>2]=ea(g[q+28>>2]);x=b[q+32>>1]|0;a[m+32>>0]=x;a[m+33>>0]=(x&65535)>>>8;i=n;return}}function vEa(d,e,f,h,j,k,l,m){d=ea(d);e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=Im,cc=0,dc=Im,ec=Im,fc=Im;n=i;i=i+11216|0;o=n+10608|0;p=n+3416|0;q=n+3376|0;r=n+10564|0;s=n+10436|0;t=n+216|0;u=n+3176|0;v=n+3204|0;w=n+3232|0;x=n+3244|0;y=n+4836|0;z=n+10408|0;A=n+10536|0;B=n+10584|0;C=n+10596|0;D=n+4628|0;E=n+11152|0;F=n+4648|0;G=n+4664|0;H=n+11172|0;I=n+128|0;J=n+4744|0;K=n+3256|0;L=n+4824|0;M=n+112|0;N=n;O=n+11192|0;P=n+4848|0;Q=n+4536|0;R=n+3304|0;T=n+208|0;U=n+4640|0;V=k+8|0;W=k+44|0;X=c[W>>2]|0;if(!X)Y=0;else{Z=c[k+72>>2]|0;_=0;do{$=_<<2;aa=c[518096+($<<2)>>2]|0;if(aa){g[aa+16>>2]=ea(g[Z+(_*208|0)>>2]);ba=ea(g[Z+(_*208|0)+4>>2]);g[(c[518096+(($|1)<<2)>>2]|0)+16>>2]=ba;ba=ea(g[Z+(_*208|0)+8>>2]);g[(c[518096+(($|2)<<2)>>2]|0)+16>>2]=ba;ba=ea(g[Z+(_*208|0)+12>>2]);g[(c[518096+(($|3)<<2)>>2]|0)+16>>2]=ba}_=_+1|0}while(_>>>0<X>>>0);Y=X}X=k+128|0;_=k+204|0;if(0)hi();Z=c[k+40>>2]|0;$=k+72|0;aa=c[$>>2]|0;ca=c[k+48>>2]|0;da=4-(Y<<2)|0;fa=c[k+288>>2]|0;YEi(o|0,k+224|0,fa<<3|0)|0;ga=o+64|0;c[ga>>2]=fa;fa=o+80|0;ha=k+304|0;c[fa+0>>2]=c[ha+0>>2];c[fa+4>>2]=c[ha+4>>2];c[fa+8>>2]=c[ha+8>>2];c[fa+12>>2]=c[ha+12>>2];c[fa+16>>2]=c[ha+16>>2];c[fa+20>>2]=c[ha+20>>2];c[fa+24>>2]=c[ha+24>>2];c[fa+28>>2]=c[ha+28>>2];ha=o+112|0;YEi(ha|0,k+336|0,416)|0;fa=o+528|0;ia=k+752|0;c[fa+0>>2]=c[ia+0>>2];c[fa+4>>2]=c[ia+4>>2];c[fa+8>>2]=c[ia+8>>2];c[fa+12>>2]=c[ia+12>>2];ia=c[k+104>>2]|0;g[p>>2]=ea(0.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[p+12>>2]=ea(1.0);ja=p+60|0;ka=p+16|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(1.0);ja=p+116|0;ka=p+72|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+120>>2]=ea(0.0);g[p+124>>2]=ea(1.0);ja=p+172|0;ka=p+128|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+176>>2]=ea(0.0);g[p+180>>2]=ea(1.0);ja=p+228|0;ka=p+184|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+232>>2]=ea(0.0);g[p+236>>2]=ea(1.0);ja=p+284|0;ka=p+240|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+288>>2]=ea(0.0);g[p+292>>2]=ea(1.0);ja=p+340|0;ka=p+296|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+344>>2]=ea(0.0);g[p+348>>2]=ea(1.0);ja=p+396|0;ka=p+352|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+400>>2]=ea(0.0);g[p+404>>2]=ea(1.0);ja=p+452|0;ka=p+408|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+456>>2]=ea(0.0);g[p+460>>2]=ea(1.0);ja=p+508|0;ka=p+464|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+512>>2]=ea(0.0);g[p+516>>2]=ea(1.0);ja=p+564|0;ka=p+520|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(1.0);ja=p+620|0;ka=p+576|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+624>>2]=ea(0.0);g[p+628>>2]=ea(1.0);ja=p+676|0;ka=p+632|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+680>>2]=ea(0.0);g[p+684>>2]=ea(1.0);ja=p+732|0;ka=p+688|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+736>>2]=ea(0.0);g[p+740>>2]=ea(1.0);ja=p+788|0;ka=p+744|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+792>>2]=ea(0.0);g[p+796>>2]=ea(1.0);ja=p+844|0;ka=p+800|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+848>>2]=ea(0.0);g[p+852>>2]=ea(1.0);ja=p+900|0;ka=p+856|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+904>>2]=ea(0.0);g[p+908>>2]=ea(1.0);ja=p+956|0;ka=p+912|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+960>>2]=ea(0.0);g[p+964>>2]=ea(1.0);ja=p+1012|0;ka=p+968|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+1016>>2]=ea(0.0);g[p+1020>>2]=ea(1.0);ja=p+1068|0;ka=p+1024|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+1072>>2]=ea(0.0);g[p+1076>>2]=ea(1.0);ka=p+1080|0;la=ka+40|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));ja=da+ca|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;b[q+32>>1]=0;c[q+4>>2]=ca;c[q>>2]=p;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r>>2]=ca>>>0<4?ca:4;p=Y+-1|0;if(p>>>0>1){da=1;do{c[r+(da<<2)>>2]=4;da=da+1|0}while((da|0)!=(p|0))}c[r+(p<<2)>>2]=ja;if((((!(ea(NCa(X,3))!=ea(0.0))?!(ea(NCa(X,4))!=ea(0.0)):0)?!(ea(NCa(X,0))!=ea(0.0)):0)?(a[k+194>>0]|0)==0:0)?(a[k+193>>0]|0)==0:0)ma=0;else ma=1;a:do if(mo[c[(c[ia>>2]|0)+256>>2]&4095](ia)|0){if(ma){a[q+33>>0]=1;break}ja=c[W>>2]|0;p=c[$>>2]|0;b:do if(ja){da=0;c:while(1){na=da<<2;oa=p+(da*208|0)+196|0;pa=0;do{if(((!(_Ea(V,pa+na|0)|0)?(qa=c[oa>>2]|0,(a[qa+(pa*80|0)+77>>0]|0)!=0):0)?(ra=c[qa+(pa*80|0)>>2]|0,(ra|0)!=0):0)?(b[ra+4>>1]|0)==5:0)break c;pa=pa+1|0}while(pa>>>0<4);da=da+1|0;if(da>>>0>=ja>>>0)break b}a[q+33>>0]=1;break a}while(0);g[_>>2]=ea(0.0);ja=k+88|0;if(c[ja>>2]|0){p=0;do{cFa($,p,ea(0.0));p=p+1|0}while(p>>>0<(c[ja>>2]|0)>>>0)}g[_>>2]=ea(0.0);if(!m){i=n;return}a[m+32>>0]=1;i=n;return}while(0);$=(Y|0)==0;if(!$){W=c[k+76>>2]|0;ma=0;do{ja=ma<<2;c[s+(ma*20|0)>>2]=c[(c[W>>2]|0)+(ja<<2)>>2];c[s+(ma*20|0)+4>>2]=c[(c[W>>2]|0)+((ja|1)<<2)>>2];c[s+(ma*20|0)+8>>2]=c[(c[W>>2]|0)+((ja|2)<<2)>>2];c[s+(ma*20|0)+12>>2]=c[(c[W>>2]|0)+((ja|3)<<2)>>2];c[s+(ma*20|0)+16>>2]=c[W+4>>2];ma=ma+1|0}while((ma|0)!=(Y|0));if(!$){ma=0;do{W=c[(c[aa+(ma*208|0)+192>>2]|0)+352>>2]|0;ko[c[(c[W>>2]|0)+36>>2]&4095](W);ma=ma+1|0}while((ma|0)!=(Y|0))}}ma=t+2960|0;W=t;do{PEi(W|0,0,136)|0;a[W+28>>0]=1;c[W+44>>2]=-1;g[W+120>>2]=ea(0.0);g[W+124>>2]=ea(0.0);g[W+128>>2]=ea(0.0);g[W+132>>2]=ea(1.0);g[W+136>>2]=ea(0.0);g[W+140>>2]=ea(0.0);g[W+144>>2]=ea(0.0);W=W+148|0}while((W|0)!=(ma|0));In[c[(c[ia>>2]|0)+124>>2]&4095](z,ia);ba=ea(g[z>>2]);g[u>>2]=ba;sa=ea(g[z+4>>2]);g[u+4>>2]=sa;ta=ea(g[z+8>>2]);g[u+8>>2]=ta;ua=ea(g[z+12>>2]);g[u+12>>2]=ua;va=ea(g[z+16>>2]);g[u+16>>2]=va;wa=ea(g[z+20>>2]);g[u+20>>2]=wa;xa=ea(g[z+24>>2]);g[u+24>>2]=xa;In[c[(c[ia>>2]|0)+84>>2]&4095](A,ia);ya=ea(va*ea(2.0));va=ea(wa*ea(2.0));wa=ea(xa*ea(2.0));xa=ea(g[A+12>>2]);za=ea(ea(xa*xa)+ea(-.5));Aa=ea(g[A>>2]);Ba=ea(ya*Aa);Ca=ea(g[A+4>>2]);Da=ea(Ba+ea(va*Ca));Ba=ea(g[A+8>>2]);Ea=ea(Da+ea(wa*Ba));Da=ea(ea(Aa*Ea)+ea(ea(ya*za)+ea(xa*ea(ea(wa*Ca)-ea(va*Ba)))));Fa=ea(ea(Ca*Ea)+ea(ea(va*za)+ea(xa*ea(ea(ya*Ba)-ea(wa*Aa)))));Ga=ea(ea(ea(wa*za)+ea(xa*ea(ea(va*Aa)-ea(ya*Ca))))+ea(Ba*Ea));Ea=ea(ea(g[A+16>>2])+Da);Da=ea(ea(g[A+20>>2])+Fa);Fa=ea(ea(g[A+24>>2])+Ga);Ga=ea(ea(ea(ea(xa*ba)+ea(Aa*ua))+ea(Ca*ta))-ea(Ba*sa));ya=ea(ea(ea(Ba*ba)+ea(ea(Ca*ua)+ea(xa*sa)))-ea(Aa*ta));va=ea(ea(ea(Aa*sa)+ea(ea(Ba*ua)+ea(xa*ta)))-ea(Ca*ba));za=ea(ea(ea(ea(xa*ua)-ea(Aa*ba))-ea(Ca*sa))-ea(Ba*ta));g[v>>2]=Ga;A=v+4|0;g[A>>2]=ya;z=v+8|0;g[z>>2]=va;ma=v+12|0;g[ma>>2]=za;W=v+16|0;g[W>>2]=Ea;ja=v+20|0;g[ja>>2]=Da;p=v+24|0;g[p>>2]=Fa;Fa=ea(ea(1.0)/ea(Kn[c[(c[ia>>2]|0)+132>>2]&255](ia)));In[c[(c[ia>>2]|0)+144>>2]&4095](B,ia);Da=ea(ea(1.0)/ea(g[B>>2]));Ea=ea(ea(1.0)/ea(g[B+4>>2]));ta=ea(ea(1.0)/ea(g[B+8>>2]));g[w>>2]=Da;g[w+4>>2]=Ea;g[w+8>>2]=ta;In[c[(c[ia>>2]|0)+152>>2]&4095](C,ia);ta=ea(g[C>>2]);g[x>>2]=ta;Ea=ea(g[C+4>>2]);B=x+4|0;g[B>>2]=Ea;Da=ea(g[C+8>>2]);C=x+8|0;g[C>>2]=Da;In[c[(c[ia>>2]|0)+160>>2]&4095](D,ia);Ba=ea(g[D>>2]);g[y>>2]=Ba;sa=ea(g[D+4>>2]);da=y+4|0;g[da>>2]=sa;Ca=ea(g[D+8>>2]);D=y+8|0;g[D>>2]=Ca;ba=ea(g[X>>2]);pa=k+196|0;do if(!(a[k+192>>0]|0))Ha=ba;else{oa=c[pa>>2]|0;na=c[k+200>>2]|0;Aa=(na|0)!=(oa|0)&(oa|0)==1?ea(0.0):ba;ra=k+212|0;ua=ea(g[ra>>2]);if((na|0)==(oa|0)?ua>ea(g[o+400>>2]):0){xa=ea(g[_>>2]);wa=ea(xa*ea(g[o+108>>2]));na=(oa|0)!=0?wa>ea(g[o+(oa<<2)+272>>2]):0;qa=oa>>>0>2?wa<ea(g[o+(oa<<2)+400>>2]):0;if(!(na|qa)){Ha=Aa;break}a[k+193>>0]=na&1;a[k+194>>0]=qa&1;g[ra>>2]=ea(0.0);Ha=Aa;break}g[ra>>2]=ea(ua+d);Ha=Aa}while(0);jEa(d,ha,X);ha=c[pa>>2]|0;pa=(ha|0)==1;if(pa)Ia=ea(0.0);else Ia=ea(g[o+256>>2]);ra=c[o+260>>2]|0;qa=c[o+264>>2]|0;ba=ea(g[o+(ha<<2)+112>>2]);Aa=ea(ba*ea(g[o+240>>2]));ha=0==0;if(!ha)g[8]=Aa;ba=ea(g[k+132>>2]);ua=ea(g[k+136>>2]);wa=ea(g[k+140>>2]);xa=ea(g[k+144>>2]);Ja=ea(xa-wa);if(Ha>ea(0.0)&ba==ea(0.0))Ka=ua==ea(0.0);else Ka=0;if(!ha){g[3]=Ha;g[4]=ba;g[5]=ua;g[6]=wa;g[7]=xa}ka=E+0|0;la=ka+20|0;do{a[ka>>0]=0;ka=ka+1|0}while((ka|0)<(la|0));if(!$){ha=0;do{na=ha<<2;oa=c[k+((ha>>>3&134217727)<<2)+52>>2]|0;La=na&28;if(oa&1<<La)a[E+na>>0]=1;if(oa&1<<(La|1))a[E+(na|1)>>0]=1;if(oa&1<<(La|2))a[E+(na|2)>>0]=1;if(oa&1<<(La|3))a[E+(na|3)>>0]=1;ha=ha+1|0}while((ha|0)!=(Y|0))};c[F+0>>2]=c[fa+0>>2];c[F+4>>2]=c[fa+4>>2];c[F+8>>2]=c[fa+8>>2];c[F+12>>2]=c[fa+12>>2];xa=ea(g[F+8>>2]);ka=G+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));fa=(ca|0)==0;if(fa)Ma=0;else{ha=0;do{na=ECa(F,ha)|0;g[G+(ha<<2)>>2]=na?xa:ea(0.0);ha=ha+1|0}while((ha|0)!=(ca|0));Ma=0}wa=ea(g[_>>2]);if(Ma){if($)Na=ea(0.0);else{Oa=ea(0.0);ha=0;while(1){Pa=ea(g[aa+(ha*208|0)>>2]);na=ha<<2;Qa=ea(Oa+ea(Pa*ea(g[G+(na<<2)>>2])));Pa=ea(g[aa+(ha*208|0)+4>>2]);Ra=ea(Qa+ea(Pa*ea(g[G+((na|1)<<2)>>2])));Pa=ea(g[aa+(ha*208|0)+8>>2]);Qa=ea(Ra+ea(Pa*ea(g[G+((na|2)<<2)>>2])));Pa=ea(g[aa+(ha*208|0)+12>>2]);Ra=ea(Qa+ea(Pa*ea(g[G+((na|3)<<2)>>2])));ha=ha+1|0;if((ha|0)==(Y|0)){Na=Ra;break}else Oa=Ra}}g[Ma+8>>2]=ea(ea(Aa*Na)-wa)}ka=H+0|0;la=ka+20|0;do{a[ka>>0]=0;ka=ka+1|0}while((ka|0)<(la|0));if(!($|Ka^1)){Ma=0;do{ha=Ma<<2;a[H+ha>>0]=ea(g[G+(ha<<2)>>2])!=ea(0.0)&1;na=ha|1;a[H+na>>0]=ea(g[G+(na<<2)>>2])!=ea(0.0)&1;na=ha|2;a[H+na>>0]=ea(g[G+(na<<2)>>2])!=ea(0.0)&1;na=ha|3;a[H+na>>0]=ea(g[G+(na<<2)>>2])!=ea(0.0)&1;Ma=Ma+1|0}while((Ma|0)!=(Y|0))}ka=I+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));if(!fa){Ma=0;do{na=NEa(V,Ma)|0;wa=ea(g[na+28>>2]);g[I+(Ma<<2)>>2]=ea(ea(Ja*wa)+ea(g[na+32>>2]));Ma=Ma+1|0}while((Ma|0)!=(ca|0));ka=J+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));if(fa)Sa=J;else{fa=0;do{Ma=ECa(F,fa)|0;g[J+(fa<<2)>>2]=Ma?xa:ea(0.0);fa=fa+1|0}while((fa|0)!=(ca|0));Sa=J}}else{ka=J+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));Sa=J}if($){Ta=Ba;Ua=sa;Va=Ca;Wa=za;Xa=Ga;Ya=ya;Za=va;_a=ta;$a=Ea;ab=Da}else{fa=0;do{F=fa<<2;Ma=t+(F*148|0)|0;if(!(c[aa+(fa*208|0)+196>>2]|0)){na=t+((F|1)*148|0)|0;ha=t+((F|2)*148|0)|0;La=t+((F|3)*148|0)|0;c[Ma+0>>2]=0;c[Ma+4>>2]=0;c[Ma+8>>2]=0;c[Ma+12>>2]=0;c[Ma+16>>2]=0;c[Ma+20>>2]=0;c[Ma+24>>2]=0;c[na+0>>2]=0;c[na+4>>2]=0;c[na+8>>2]=0;c[na+12>>2]=0;c[na+16>>2]=0;c[na+20>>2]=0;c[na+24>>2]=0;c[ha+0>>2]=0;c[ha+4>>2]=0;c[ha+8>>2]=0;c[ha+12>>2]=0;c[ha+16>>2]=0;c[ha+20>>2]=0;c[ha+24>>2]=0;c[La+0>>2]=0;c[La+4>>2]=0;c[La+8>>2]=0;c[La+12>>2]=0;c[La+16>>2]=0;c[La+20>>2]=0;c[La+24>>2]=0}else{g[Ma>>2]=ea(g[aa+(fa*208|0)+80>>2]);g[t+(F*148|0)+4>>2]=ea(g[aa+(fa*208|0)+84>>2]);g[t+(F*148|0)+8>>2]=ea(g[aa+(fa*208|0)+88>>2]);g[t+(F*148|0)+12>>2]=ea(g[aa+(fa*208|0)+128>>2]);g[t+(F*148|0)+16>>2]=ea(g[aa+(fa*208|0)+132>>2]);g[t+(F*148|0)+20>>2]=ea(g[aa+(fa*208|0)+136>>2]);g[t+(F*148|0)+24>>2]=ea(g[aa+(fa*208|0)+176>>2]);Ma=F|1;g[t+(Ma*148|0)>>2]=ea(g[aa+(fa*208|0)+92>>2]);g[t+(Ma*148|0)+4>>2]=ea(g[aa+(fa*208|0)+96>>2]);g[t+(Ma*148|0)+8>>2]=ea(g[aa+(fa*208|0)+100>>2]);g[t+(Ma*148|0)+12>>2]=ea(g[aa+(fa*208|0)+140>>2]);g[t+(Ma*148|0)+16>>2]=ea(g[aa+(fa*208|0)+144>>2]);g[t+(Ma*148|0)+20>>2]=ea(g[aa+(fa*208|0)+148>>2]);g[t+(Ma*148|0)+24>>2]=ea(g[aa+(fa*208|0)+180>>2]);Ma=F|2;g[t+(Ma*148|0)>>2]=ea(g[aa+(fa*208|0)+104>>2]);g[t+(Ma*148|0)+4>>2]=ea(g[aa+(fa*208|0)+108>>2]);g[t+(Ma*148|0)+8>>2]=ea(g[aa+(fa*208|0)+112>>2]);g[t+(Ma*148|0)+12>>2]=ea(g[aa+(fa*208|0)+152>>2]);g[t+(Ma*148|0)+16>>2]=ea(g[aa+(fa*208|0)+156>>2]);g[t+(Ma*148|0)+20>>2]=ea(g[aa+(fa*208|0)+160>>2]);g[t+(Ma*148|0)+24>>2]=ea(g[aa+(fa*208|0)+184>>2]);Ma=F|3;g[t+(Ma*148|0)>>2]=ea(g[aa+(fa*208|0)+116>>2]);g[t+(Ma*148|0)+4>>2]=ea(g[aa+(fa*208|0)+120>>2]);g[t+(Ma*148|0)+8>>2]=ea(g[aa+(fa*208|0)+124>>2]);g[t+(Ma*148|0)+12>>2]=ea(g[aa+(fa*208|0)+164>>2]);g[t+(Ma*148|0)+16>>2]=ea(g[aa+(fa*208|0)+168>>2]);g[t+(Ma*148|0)+20>>2]=ea(g[aa+(fa*208|0)+172>>2]);g[t+(Ma*148|0)+24>>2]=ea(g[aa+(fa*208|0)+188>>2])}fa=fa+1|0}while((fa|0)!=(Y|0));Da=ea(g[x>>2]);Ea=ea(g[B>>2]);ta=ea(g[C>>2]);va=ea(g[y>>2]);ya=ea(g[da>>2]);Ga=ea(g[D>>2]);za=ea(g[ma>>2]);Ca=ea(g[v>>2]);sa=ea(g[A>>2]);Ta=va;Ua=ya;Va=Ga;Wa=za;Xa=Ca;Ya=sa;Za=ea(g[z>>2]);_a=Da;$a=Ea;ab=ta}ta=ea(ea(0.0)*ea(2.0));Ea=ea(ea(0.0)*ea(2.0));Da=ea(ea(1.0)*ea(2.0));sa=ea(ea(Wa*Wa)+ea(-.5));Ca=ea(ea(ea(ta*Xa)+ea(Ea*Ya))+ea(Da*Za));za=ea(S(ea(ea(ab*ea(ea(ea(Da*sa)+ea(Wa*ea(ea(Ea*Xa)-ea(ta*Ya))))+ea(Za*Ca)))+ea(ea(_a*ea(ea(Xa*Ca)+ea(ea(ta*sa)+ea(Wa*ea(ea(Da*Ya)-ea(Ea*Za))))))+ea($a*ea(ea(Ya*Ca)+ea(ea(Ea*sa)+ea(Wa*ea(ea(ta*Za)-ea(Da*Xa))))))))));Xa=ea(g[k+56>>2]);fa=za<Xa?c[k+60>>2]|0:c[k+64>>2]|0;Xa=ea(ea(1.0)/ea(fa>>>0));za=ea(Xa*d);Da=ea(ea(1.0)/d);d=ea(g[k+68>>2]);g[K>>2]=Xa;g[K+4>>2]=za;g[K+8>>2]=ea(g[e>>2]);g[K+12>>2]=ea(g[e+4>>2]);g[K+16>>2]=ea(g[e+8>>2]);g[K+20>>2]=f;g[K+24>>2]=h;a[K+28>>0]=0;g[K+32>>2]=d;c[K+36>>2]=ia;c[K+40>>2]=j;if(!fa)bb=_a;else{j=L+4|0;ia=L+8|0;e=M+4|0;Ma=M+8|0;F=o+84|0;La=o+108|0;ha=o+4|0;na=o+92|0;oa=o+96|0;cb=o+100|0;db=R+4|0;eb=R+8|0;fb=R+12|0;gb=R+16|0;hb=R+20|0;ib=R+24|0;jb=R+28|0;kb=R+32|0;lb=R+36|0;mb=R+40|0;nb=R+44|0;ob=R+48|0;pb=R+52|0;qb=R+56|0;rb=R+60|0;sb=R+64|0;tb=R+68|0;ub=T+4|0;d=ea(Ia*Aa);vb=Ka&1;Ka=Q+4|0;wb=Q+8|0;xb=Q+12|0;yb=Q+16|0;zb=Q+20|0;Ab=Q+24|0;Bb=Q+28|0;Cb=Q+32|0;Db=Q+36|0;Eb=Q+40|0;Fb=Q+44|0;Gb=Q+48|0;Hb=Q+52|0;Ib=Q+56|0;Jb=Q+60|0;Kb=Q+64|0;Lb=Q+68|0;Mb=Q+72|0;Nb=Q+76|0;Ob=Q+80|0;Pb=Q+84|0;Qb=Q+88|0;Rb=fa+-1|0;h=ea(-ba);Sb=0;do{g[L>>2]=ea(0.0);g[j>>2]=ea(0.0);g[ia>>2]=ea(0.0);g[M>>2]=ea(0.0);g[e>>2]=ea(0.0);g[Ma>>2]=ea(0.0);ka=N+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));ka=O+0|0;la=ka+20|0;do{a[ka>>0]=0;ka=ka+1|0}while((ka|0)<(la|0));if(!$){Tb=0;do{Ub=Tb<<2;f=ea(g[aa+(Tb*208|0)>>2]);Vb=f<=ea(-0.0);Xa=Vb?ea(0.0):ea(1.0);Vb=f>=ea(0.0);f=Vb?Xa:ea(-1.0);Xa=ea(f*h);Vb=Z+(Tb*944|0)+212|0;Za=ea(ea(g[Vb>>2])*Xa);Xa=ea(ua*f);Wb=Z+(Tb*944|0)+216|0;g[N+(Ub<<2)>>2]=ea(Za-ea(ea(g[Wb>>2])*Xa));Xa=ea(ba*ea(g[Vb>>2]));a[O+Ub>>0]=ea(Xa+ea(ua*ea(g[Wb>>2])))!=ea(0.0)&1;Xa=ea(g[aa+(Tb*208|0)+4>>2]);Wb=Xa<=ea(-0.0);Za=Wb?ea(0.0):ea(1.0);Wb=Xa>=ea(0.0);Xa=Wb?Za:ea(-1.0);Za=ea(Xa*h);Wb=Z+(Tb*944|0)+260|0;f=ea(ea(g[Wb>>2])*Za);Za=ea(ua*Xa);Vb=Z+(Tb*944|0)+264|0;Xb=Ub|1;g[N+(Xb<<2)>>2]=ea(f-ea(ea(g[Vb>>2])*Za));Za=ea(ba*ea(g[Wb>>2]));a[O+Xb>>0]=ea(Za+ea(ua*ea(g[Vb>>2])))!=ea(0.0)&1;Za=ea(g[aa+(Tb*208|0)+8>>2]);Vb=Za<=ea(-0.0);f=Vb?ea(0.0):ea(1.0);Vb=Za>=ea(0.0);Za=Vb?f:ea(-1.0);f=ea(Za*h);Vb=Z+(Tb*944|0)+308|0;Xa=ea(ea(g[Vb>>2])*f);f=ea(ua*Za);Xb=Z+(Tb*944|0)+312|0;Wb=Ub|2;g[N+(Wb<<2)>>2]=ea(Xa-ea(ea(g[Xb>>2])*f));f=ea(ba*ea(g[Vb>>2]));a[O+Wb>>0]=ea(f+ea(ua*ea(g[Xb>>2])))!=ea(0.0)&1;f=ea(g[aa+(Tb*208|0)+12>>2]);Xb=f<=ea(-0.0);Xa=Xb?ea(0.0):ea(1.0);Xb=f>=ea(0.0);f=Xb?Xa:ea(-1.0);Xa=ea(f*h);Xb=Z+(Tb*944|0)+356|0;Za=ea(ea(g[Xb>>2])*Xa);Xa=ea(ua*f);Wb=Z+(Tb*944|0)+360|0;Vb=Ub|3;g[N+(Vb<<2)>>2]=ea(Za-ea(ea(g[Wb>>2])*Xa));Xa=ea(ba*ea(g[Xb>>2]));a[O+Vb>>0]=ea(Xa+ea(ua*ea(g[Wb>>2])))!=ea(0.0)&1;Tb=Tb+1|0}while((Tb|0)!=(Y|0))}PEi(P|0,0,1112)|0;a[P+112>>0]=1;c[P+164>>2]=-1;a[P+113>>0]=1;c[P+168>>2]=-1;a[P+114>>0]=1;c[P+172>>2]=-1;a[P+115>>0]=1;c[P+176>>2]=-1;PEi(P+1112|0,0,1112)|0;a[P+1224>>0]=1;c[P+1276>>2]=-1;a[P+1225>>0]=1;c[P+1280>>2]=-1;a[P+1226>>0]=1;c[P+1284>>2]=-1;a[P+1227>>0]=1;c[P+1288>>2]=-1;PEi(P+2224|0,0,1112)|0;a[P+2336>>0]=1;c[P+2388>>2]=-1;a[P+2337>>0]=1;c[P+2392>>2]=-1;a[P+2338>>0]=1;c[P+2396>>2]=-1;a[P+2339>>0]=1;c[P+2400>>2]=-1;PEi(P+3336|0,0,1112)|0;a[P+3448>>0]=1;c[P+3500>>2]=-1;a[P+3449>>0]=1;c[P+3504>>2]=-1;a[P+3450>>0]=1;c[P+3508>>2]=-1;a[P+3451>>0]=1;c[P+3512>>2]=-1;PEi(P+4448|0,0,1112)|0;a[P+4560>>0]=1;c[P+4612>>2]=-1;a[P+4561>>0]=1;c[P+4616>>2]=-1;a[P+4562>>0]=1;c[P+4620>>2]=-1;a[P+4563>>0]=1;c[P+4624>>2]=-1;do if(!$){Xa=ea(g[v>>2]);Za=ea(g[A>>2]);f=ea(g[z>>2]);ta=ea(g[ma>>2]);Wa=ea(g[W>>2]);sa=ea(g[ja>>2]);Ea=ea(g[p>>2]);Ca=ea(g[x>>2]);Ya=ea(g[B>>2]);Ga=ea(g[C>>2]);ya=ea(g[y>>2]);va=ea(g[da>>2]);Ba=ea(g[D>>2]);Tb=(Rb|0)==(Sb|0);xa=ea(g[L>>2]);Ja=ea(g[j>>2]);wa=ea(g[ia>>2]);Na=ea(g[M>>2]);Oa=ea(g[e>>2]);Ra=xa;xa=Ja;Ja=wa;wa=Na;Na=Oa;Oa=ea(g[Ma>>2]);Wb=0;do{a[Q>>0]=vb;Vb=Wb<<2;c[Ka>>2]=H+Vb;c[wb>>2]=O+Vb;c[xb>>2]=I+(Vb<<2);c[yb>>2]=E+Vb;g[zb>>2]=Xa;g[Ab>>2]=Za;g[Bb>>2]=f;g[Cb>>2]=ta;g[Db>>2]=Wa;g[Eb>>2]=sa;g[Fb>>2]=Ea;g[Gb>>2]=Ca;g[Hb>>2]=Ya;g[Ib>>2]=Ga;g[Jb>>2]=ya;g[Kb>>2]=va;g[Lb>>2]=Ba;c[Mb>>2]=Z+(Wb*944|0);Xb=aa+(Wb*208|0)|0;c[Nb>>2]=Xb;c[Ob>>2]=s+(Wb*20|0);c[Pb>>2]=V;Ub=c[r+(Wb<<2)>>2]|0;c[Qb>>2]=Ub;Yb=P+(Wb*1112|0)|0;mEa(Vb,K,Q,Yb);Zb=c[Nb>>2]|0;_b=Zb+48|0;Pa=ea(g[P+(Wb*1112|0)+508>>2]);$b=Pa!=ea(g[_b>>2]);g[_b>>2]=$b?Pa:ea(0.0);Pa=ea(g[P+(Wb*1112|0)+512>>2]);$b=Zb+52|0;_b=Pa!=ea(g[$b>>2]);g[$b>>2]=_b?Pa:ea(0.0);Pa=ea(g[P+(Wb*1112|0)+516>>2]);_b=Zb+56|0;$b=Pa!=ea(g[_b>>2]);g[_b>>2]=$b?Pa:ea(0.0);Pa=ea(g[P+(Wb*1112|0)+520>>2]);$b=Zb+60|0;_b=Pa!=ea(g[$b>>2]);g[$b>>2]=_b?Pa:ea(0.0);_b=Zb+64|0;Pa=ea(g[P+(Wb*1112|0)+524>>2]);$b=Pa!=ea(g[_b>>2]);g[_b>>2]=$b?Pa:ea(0.0);Pa=ea(g[P+(Wb*1112|0)+528>>2]);$b=Zb+68|0;_b=Pa!=ea(g[$b>>2]);g[$b>>2]=_b?Pa:ea(0.0);Pa=ea(g[P+(Wb*1112|0)+532>>2]);_b=Zb+72|0;$b=Pa!=ea(g[_b>>2]);g[_b>>2]=$b?Pa:ea(0.0);Pa=ea(g[P+(Wb*1112|0)+536>>2]);$b=Zb+76|0;Zb=Pa!=ea(g[$b>>2]);g[$b>>2]=Zb?Pa:ea(0.0);if(Tb)nEa(P+(Wb*1112|0)+888|0,P+(Wb*1112|0)+904|0,P+(Wb*1112|0)+968|0,P+(Wb*1112|0)+984|0,Xb);Ra=ea(ea(g[P+(Wb*1112|0)+484>>2])+Ra);xa=ea(ea(g[P+(Wb*1112|0)+488>>2])+xa);Ja=ea(ea(g[P+(Wb*1112|0)+492>>2])+Ja);wa=ea(ea(g[P+(Wb*1112|0)+496>>2])+wa);Na=ea(ea(g[P+(Wb*1112|0)+500>>2])+Na);Oa=ea(ea(g[P+(Wb*1112|0)+504>>2])+Oa);a3a((c[aa+(Wb*208|0)+192>>2]|0)+4|0,P+(Wb*1112|0)+540|0)|0;Z2a(Yb,c[xb>>2]|0,t+(Vb*148|0)|0,Ub);Yb=c[q>>2]|0;if(Ub){Xb=0;do{Zb=Xb+Vb|0;c[Yb+(Zb*56|0)+28>>2]=c[P+(Wb*1112|0)+(Xb<<2)+1e3>>2];Pa=ea(g[P+(Wb*1112|0)+(Xb*12|0)+1016>>2]);$b=Yb+(Zb*56|0)+32|0;g[$b>>2]=ea(Pa+ea(g[$b>>2]));Pa=ea(g[P+(Wb*1112|0)+(Xb*12|0)+1020>>2]);$b=Yb+(Zb*56|0)+36|0;g[$b>>2]=ea(Pa+ea(g[$b>>2]));Pa=ea(g[P+(Wb*1112|0)+(Xb*12|0)+1024>>2]);$b=Yb+(Zb*56|0)+40|0;g[$b>>2]=ea(Pa+ea(g[$b>>2]));g[Yb+(Zb*56|0)+44>>2]=ea(g[P+(Wb*1112|0)+(Xb*12|0)+1064>>2]);g[Yb+(Zb*56|0)+48>>2]=ea(g[P+(Wb*1112|0)+(Xb*12|0)+1068>>2]);g[Yb+(Zb*56|0)+52>>2]=ea(g[P+(Wb*1112|0)+(Xb*12|0)+1072>>2]);Xb=Xb+1|0}while((Xb|0)!=(Ub|0))}Wb=Wb+1|0}while((Wb|0)!=(Y|0));g[L>>2]=Ra;g[j>>2]=xa;g[ia>>2]=Ja;g[M>>2]=wa;g[e>>2]=Na;g[Ma>>2]=Oa;if($)break;else ac=0;do{Wb=ac<<2;g[Q+(Wb<<2)>>2]=ea(g[P+(ac*1112|0)+468>>2]);g[Q+((Wb|1)<<2)>>2]=ea(g[P+(ac*1112|0)+472>>2]);g[Q+((Wb|2)<<2)>>2]=ea(g[P+(ac*1112|0)+476>>2]);g[Q+((Wb|3)<<2)>>2]=ea(g[P+(ac*1112|0)+480>>2]);ac=ac+1|0}while((ac|0)!=(Y|0))}while(0);Oa=ea(g[_>>2]);Na=ea(Ha*ea(g[F>>2]));wa=ea(Oa*ea(g[La>>2]));Wb=c[ga>>2]|0;do if(!Wb)bc=ea(0.0);else if((Wb|0)!=1){Oa=ea(g[o>>2]);if(Oa>wa){cc=97;break}Tb=1;Ja=Oa;Oa=ea(g[ha>>2]);while(1){Ub=Tb<<1;dc=ea(g[o+(Ub<<2)>>2]);ec=ea(g[o+((Ub|1)<<2)>>2]);Tb=Tb+1|0;if(Ja<=wa&dc>wa){cc=101;break}if(Tb>>>0>=Wb>>>0){cc=102;break}else{Ja=dc;Oa=ec}}if((cc|0)==101){cc=0;bc=ea(Oa+ea(ea(ea(wa-Ja)*ea(ec-Oa))/ea(dc-Ja)));break}else if((cc|0)==102){cc=0;bc=ea(g[o+(((Wb<<1)+-2|1)<<2)>>2]);break}}else cc=97;while(0);if((cc|0)==97){cc=0;bc=ea(g[ha>>2])}wa=ea(Na*bc);if(0)g[1]=wa;xa=ea(g[na>>2]);Ra=ea(g[cb>>2]);Ba=ea(g[oa>>2]);va=pa?Ra:Ba;Ba=ea(va+ea(Ha*ea(xa-va)));g[R>>2]=za;g[db>>2]=ba;g[eb>>2]=ua;g[fb>>2]=Ia;g[gb>>2]=Aa;c[hb>>2]=ra;c[ib>>2]=qa;g[jb>>2]=wa;g[kb>>2]=Ba;c[lb>>2]=Sa;c[mb>>2]=G;c[nb>>2]=N;c[ob>>2]=O;c[pb>>2]=Q;c[qb>>2]=Y;c[rb>>2]=ca;c[sb>>2]=Z;c[tb>>2]=o;c[T>>2]=aa;c[ub>>2]=X;pEa(R,T);if(!$){Wb=0;do{Tb=Wb<<2;Ub=0;do{Ba=ea(g[aa+(Wb*208|0)+(Ub<<2)>>2]);va=ea(g[P+(Wb*1112|0)+(Ub<<2)+292>>2]);do if(va>ea(-ea(g[Z+(Wb*944|0)+(Ub*48|0)+12>>2]))){Xb=Ub+Tb|0;if(a[O+Xb>>0]|0){fc=Ba;break}if(!(ea(wa*ea(d*ea(g[J+(Xb<<2)>>2])))==ea(0.0))){fc=Ba;break}xa=ea(g[P+(Wb*1112|0)+(Ub<<2)+452>>2]);Ra=ea(S(ea(xa)));if(!(Ra<ea(g[129512]))){fc=Ba;break}ya=ea(g[Z+(Wb*944|0)+(Ub*48|0)+228>>2]);Ga=ea(Ra*ea(g[129514]));fc=ea(ea(Ba*Ga)+ea(ea(xa*ya)*ea(ea(1.0)-Ga)))}else fc=Ba;while(0);Xb=aa+(Wb*208|0)+(Ub<<2)+32|0;Ba=ea(ea(g[Xb>>2])+ea(za*fc));va=ea(Ba+ea(-31.4159279));Ga=ea(Ba+ea(31.4159279));Yb=ea(ea(-31.4159279)-Ba)>=ea(0.0);Vb=va>=ea(0.0);g[Xb>>2]=Vb?va:Yb?Ga:Ba;g[aa+(Wb*208|0)+(Ub<<2)+16>>2]=fc;Ub=Ub+1|0}while((Ub|0)!=4);Wb=Wb+1|0}while((Wb|0)!=(Y|0))}$2a(Fa,w,L,M,za,x,y,v);Sb=Sb+1|0}while((Sb|0)!=(fa|0));bb=ea(g[x>>2])}x=q+8|0;if(!0){g[x>>2]=bb;g[q+12>>2]=ea(g[B>>2]);g[q+16>>2]=ea(g[C>>2]);g[q+20>>2]=ea(g[y>>2]);g[q+24>>2]=ea(g[da>>2]);g[q+28>>2]=ea(g[D>>2])}else{za=ea(bb-_a);_a=ea(ea(g[B>>2])-$a);$a=ea(Da*_a);_a=ea(Da*ea(ea(g[C>>2])-ab));g[x>>2]=ea(Da*za);g[q+12>>2]=$a;g[q+16>>2]=_a;_a=ea(ea(g[y>>2])-Ta);Ta=ea(ea(g[da>>2])-Ua);Ua=ea(Da*Ta);Ta=ea(Da*ea(ea(g[D>>2])-Va));g[q+20>>2]=ea(Da*_a);g[q+24>>2]=Ua;g[q+28>>2]=Ta}g[N>>2]=ea(0.0);D=N+4|0;g[D>>2]=ea(0.0);da=N+8|0;g[da>>2]=ea(0.0);y=N+12|0;g[y>>2]=ea(1.0);C=N+16|0;B=N+20|0;fa=N+24|0;Sb=N+28|0;v=N+32|0;M=N+36|0;L=N+40|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[C+16>>2]=0;c[C+20>>2]=0;g[L>>2]=ea(1.0);w=N+44|0;J=N+48|0;O=N+52|0;$=N+56|0;T=N+60|0;R=N+64|0;X=N+68|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[X>>2]=ea(1.0);ub=N+72|0;o=N+76|0;tb=N+80|0;sb=N+84|0;rb=N+88|0;qb=N+92|0;Q=N+96|0;c[ub+0>>2]=0;c[ub+4>>2]=0;c[ub+8>>2]=0;c[ub+12>>2]=0;c[ub+16>>2]=0;c[ub+20>>2]=0;g[Q>>2]=ea(1.0);pb=N+100|0;g[pb>>2]=ea(0.0);ob=N+104|0;g[ob>>2]=ea(0.0);nb=N+108|0;g[nb>>2]=ea(0.0);tEa(Z,aa,t,c[r>>2]|0,u,N);Ta=ea(g[N>>2]);g[t+120>>2]=Ta;g[t+124>>2]=ea(g[D>>2]);g[t+128>>2]=ea(g[da>>2]);g[t+132>>2]=ea(g[y>>2]);g[t+136>>2]=ea(g[C>>2]);g[t+140>>2]=ea(g[B>>2]);g[t+144>>2]=ea(g[fa>>2]);g[t+268>>2]=ea(g[Sb>>2]);g[t+272>>2]=ea(g[v>>2]);g[t+276>>2]=ea(g[M>>2]);g[t+280>>2]=ea(g[L>>2]);g[t+284>>2]=ea(g[w>>2]);g[t+288>>2]=ea(g[J>>2]);g[t+292>>2]=ea(g[O>>2]);g[t+416>>2]=ea(g[$>>2]);g[t+420>>2]=ea(g[T>>2]);g[t+424>>2]=ea(g[R>>2]);g[t+428>>2]=ea(g[X>>2]);g[t+432>>2]=ea(g[ub>>2]);g[t+436>>2]=ea(g[o>>2]);g[t+440>>2]=ea(g[tb>>2]);g[t+564>>2]=ea(g[sb>>2]);g[t+568>>2]=ea(g[rb>>2]);g[t+572>>2]=ea(g[qb>>2]);g[t+576>>2]=ea(g[Q>>2]);g[t+580>>2]=ea(g[pb>>2]);g[t+584>>2]=ea(g[ob>>2]);g[t+588>>2]=ea(g[nb>>2]);N=c[q>>2]|0;g[N>>2]=Ta;g[N+4>>2]=ea(g[D>>2]);g[N+8>>2]=ea(g[da>>2]);g[N+12>>2]=ea(g[y>>2]);g[N+16>>2]=ea(g[C>>2]);g[N+20>>2]=ea(g[B>>2]);g[N+24>>2]=ea(g[fa>>2]);g[N+56>>2]=ea(g[Sb>>2]);g[N+60>>2]=ea(g[v>>2]);g[N+64>>2]=ea(g[M>>2]);g[N+68>>2]=ea(g[L>>2]);g[N+72>>2]=ea(g[w>>2]);g[N+76>>2]=ea(g[J>>2]);g[N+80>>2]=ea(g[O>>2]);g[N+112>>2]=ea(g[$>>2]);g[N+116>>2]=ea(g[T>>2]);g[N+120>>2]=ea(g[R>>2]);g[N+124>>2]=ea(g[X>>2]);g[N+128>>2]=ea(g[ub>>2]);g[N+132>>2]=ea(g[o>>2]);g[N+136>>2]=ea(g[tb>>2]);g[N+168>>2]=ea(g[sb>>2]);g[N+172>>2]=ea(g[rb>>2]);g[N+176>>2]=ea(g[qb>>2]);g[N+180>>2]=ea(g[Q>>2]);g[N+184>>2]=ea(g[pb>>2]);g[N+188>>2]=ea(g[ob>>2]);g[N+192>>2]=ea(g[nb>>2]);if(Y>>>0>1){nb=P+4|0;N=P+8|0;ob=P+12|0;pb=P+16|0;Q=P+20|0;qb=P+24|0;rb=P+28|0;sb=P+32|0;tb=P+36|0;o=P+40|0;ub=P+44|0;X=P+48|0;R=P+52|0;T=P+56|0;$=P+60|0;O=P+64|0;J=P+68|0;w=P+72|0;L=P+76|0;M=P+80|0;v=P+84|0;Sb=P+88|0;fa=P+92|0;B=P+96|0;C=P+100|0;y=P+104|0;da=P+108|0;D=1;do{g[P>>2]=ea(0.0);g[nb>>2]=ea(0.0);g[N>>2]=ea(0.0);g[ob>>2]=ea(1.0);c[pb+0>>2]=0;c[pb+4>>2]=0;c[pb+8>>2]=0;c[pb+12>>2]=0;c[pb+16>>2]=0;c[pb+20>>2]=0;g[o>>2]=ea(1.0);c[ub+0>>2]=0;c[ub+4>>2]=0;c[ub+8>>2]=0;c[ub+12>>2]=0;c[ub+16>>2]=0;c[ub+20>>2]=0;g[J>>2]=ea(1.0);c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[B>>2]=ea(1.0);g[C>>2]=ea(0.0);g[y>>2]=ea(0.0);g[da>>2]=ea(0.0);G=D<<2;tEa(Z+(D*944|0)|0,aa+(D*208|0)|0,t+(G*148|0)|0,c[r+(D<<2)>>2]|0,u,P);Ta=ea(g[P>>2]);g[t+(G*148|0)+120>>2]=Ta;g[t+(G*148|0)+124>>2]=ea(g[nb>>2]);g[t+(G*148|0)+128>>2]=ea(g[N>>2]);g[t+(G*148|0)+132>>2]=ea(g[ob>>2]);g[t+(G*148|0)+136>>2]=ea(g[pb>>2]);g[t+(G*148|0)+140>>2]=ea(g[Q>>2]);g[t+(G*148|0)+144>>2]=ea(g[qb>>2]);mb=G|1;g[t+(mb*148|0)+120>>2]=ea(g[rb>>2]);g[t+(mb*148|0)+124>>2]=ea(g[sb>>2]);g[t+(mb*148|0)+128>>2]=ea(g[tb>>2]);g[t+(mb*148|0)+132>>2]=ea(g[o>>2]);g[t+(mb*148|0)+136>>2]=ea(g[ub>>2]);g[t+(mb*148|0)+140>>2]=ea(g[X>>2]);g[t+(mb*148|0)+144>>2]=ea(g[R>>2]);Sa=G|2;g[t+(Sa*148|0)+120>>2]=ea(g[T>>2]);g[t+(Sa*148|0)+124>>2]=ea(g[$>>2]);g[t+(Sa*148|0)+128>>2]=ea(g[O>>2]);g[t+(Sa*148|0)+132>>2]=ea(g[J>>2]);g[t+(Sa*148|0)+136>>2]=ea(g[w>>2]);g[t+(Sa*148|0)+140>>2]=ea(g[L>>2]);g[t+(Sa*148|0)+144>>2]=ea(g[M>>2]);lb=G|3;g[t+(lb*148|0)+120>>2]=ea(g[v>>2]);g[t+(lb*148|0)+124>>2]=ea(g[Sb>>2]);g[t+(lb*148|0)+128>>2]=ea(g[fa>>2]);g[t+(lb*148|0)+132>>2]=ea(g[B>>2]);g[t+(lb*148|0)+136>>2]=ea(g[C>>2]);g[t+(lb*148|0)+140>>2]=ea(g[y>>2]);g[t+(lb*148|0)+144>>2]=ea(g[da>>2]);kb=c[q>>2]|0;g[kb+(G*56|0)>>2]=Ta;g[kb+(G*56|0)+4>>2]=ea(g[nb>>2]);g[kb+(G*56|0)+8>>2]=ea(g[N>>2]);g[kb+(G*56|0)+12>>2]=ea(g[ob>>2]);g[kb+(G*56|0)+16>>2]=ea(g[pb>>2]);g[kb+(G*56|0)+20>>2]=ea(g[Q>>2]);g[kb+(G*56|0)+24>>2]=ea(g[qb>>2]);g[kb+(mb*56|0)>>2]=ea(g[rb>>2]);g[kb+(mb*56|0)+4>>2]=ea(g[sb>>2]);g[kb+(mb*56|0)+8>>2]=ea(g[tb>>2]);g[kb+(mb*56|0)+12>>2]=ea(g[o>>2]);g[kb+(mb*56|0)+16>>2]=ea(g[ub>>2]);g[kb+(mb*56|0)+20>>2]=ea(g[X>>2]);g[kb+(mb*56|0)+24>>2]=ea(g[R>>2]);g[kb+(Sa*56|0)>>2]=ea(g[T>>2]);g[kb+(Sa*56|0)+4>>2]=ea(g[$>>2]);g[kb+(Sa*56|0)+8>>2]=ea(g[O>>2]);g[kb+(Sa*56|0)+12>>2]=ea(g[J>>2]);g[kb+(Sa*56|0)+16>>2]=ea(g[w>>2]);g[kb+(Sa*56|0)+20>>2]=ea(g[L>>2]);g[kb+(Sa*56|0)+24>>2]=ea(g[M>>2]);g[kb+(lb*56|0)>>2]=ea(g[v>>2]);g[kb+(lb*56|0)+4>>2]=ea(g[Sb>>2]);g[kb+(lb*56|0)+8>>2]=ea(g[fa>>2]);g[kb+(lb*56|0)+12>>2]=ea(g[B>>2]);g[kb+(lb*56|0)+16>>2]=ea(g[C>>2]);g[kb+(lb*56|0)+20>>2]=ea(g[y>>2]);g[kb+(lb*56|0)+24>>2]=ea(g[da>>2]);D=D+1|0}while((D|0)!=(Y|0))}do if(l){Y=c[l>>2]|0;if(!Y)break;YEi(Y|0,t|0,ca*148|0)|0}while(0);if(!m){c[U>>2]=k;zEa(q,1,U);i=n;return}else{YEi(c[m>>2]|0,c[q>>2]|0,ca*56|0)|0;g[m+8>>2]=ea(g[x>>2]);g[m+12>>2]=ea(g[q+12>>2]);g[m+16>>2]=ea(g[q+16>>2]);g[m+20>>2]=ea(g[q+20>>2]);g[m+24>>2]=ea(g[q+24>>2]);g[m+28>>2]=ea(g[q+28>>2]);x=b[q+32>>1]|0;a[m+32>>0]=x;a[m+33>>0]=(x&65535)>>>8;i=n;return}}function wEa(d,e,f,h,j,k,l,m){d=ea(d);e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=Im,Tb=Im,Ub=Im,Vb=0,Wb=0,Xb=0,Yb=0,Zb=Im,_b=0,$b=0,ac=Im,bc=Im,cc=Im,dc=Im;n=i;i=i+11296|0;o=n+3480|0;p=n+9968|0;q=n+3312|0;r=n+3448|0;s=n+3348|0;t=n+112|0;u=n+3072|0;v=n+3100|0;w=n+3128|0;x=n+3140|0;y=n+4256|0;z=n+4344|0;A=n+9936|0;B=n+11088|0;C=n+11208|0;D=n+3468|0;E=n+11220|0;F=n+11232|0;G=n+4016|0;H=n+4096|0;I=n+32|0;J=n+11252|0;K=n+4176|0;L=n+3152|0;M=n;N=n+12|0;O=n+3200|0;P=n+11272|0;Q=n+4376|0;R=n+11116|0;T=n+4272|0;U=n+24|0;V=n+4008|0;W=k+8|0;X=k+44|0;Y=c[X>>2]|0;if(!Y)Z=0;else{_=c[k+72>>2]|0;$=0;do{aa=$<<2;ba=c[518096+(aa<<2)>>2]|0;if(ba){g[ba+16>>2]=ea(g[_+($*208|0)>>2]);ca=ea(g[_+($*208|0)+4>>2]);g[(c[518096+((aa|1)<<2)>>2]|0)+16>>2]=ca;ca=ea(g[_+($*208|0)+8>>2]);g[(c[518096+((aa|2)<<2)>>2]|0)+16>>2]=ca;ca=ea(g[_+($*208|0)+12>>2]);g[(c[518096+((aa|3)<<2)>>2]|0)+16>>2]=ca}$=$+1|0}while($>>>0<Y>>>0);Z=Y}Y=k+128|0;$=k+204|0;if(0)hi();_=c[k+40>>2]|0;aa=k+72|0;ba=c[aa>>2]|0;da=c[k+48>>2]|0;fa=4-(Z<<2)|0;ga=c[k+288>>2]|0;YEi(o|0,k+224|0,ga<<3|0)|0;ha=o+64|0;c[ha>>2]=ga;ga=o+80|0;ia=k+304|0;c[ga+0>>2]=c[ia+0>>2];c[ga+4>>2]=c[ia+4>>2];c[ga+8>>2]=c[ia+8>>2];c[ga+12>>2]=c[ia+12>>2];c[ga+16>>2]=c[ia+16>>2];c[ga+20>>2]=c[ia+20>>2];c[ga+24>>2]=c[ia+24>>2];c[ga+28>>2]=c[ia+28>>2];ia=o+112|0;YEi(ia|0,k+336|0,416)|0;ga=c[k+104>>2]|0;g[p>>2]=ea(0.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[p+12>>2]=ea(1.0);ja=p+60|0;ka=p+16|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(1.0);ja=p+116|0;ka=p+72|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+120>>2]=ea(0.0);g[p+124>>2]=ea(1.0);ja=p+172|0;ka=p+128|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+176>>2]=ea(0.0);g[p+180>>2]=ea(1.0);ja=p+228|0;ka=p+184|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+232>>2]=ea(0.0);g[p+236>>2]=ea(1.0);ja=p+284|0;ka=p+240|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+288>>2]=ea(0.0);g[p+292>>2]=ea(1.0);ja=p+340|0;ka=p+296|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+344>>2]=ea(0.0);g[p+348>>2]=ea(1.0);ja=p+396|0;ka=p+352|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+400>>2]=ea(0.0);g[p+404>>2]=ea(1.0);ja=p+452|0;ka=p+408|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+456>>2]=ea(0.0);g[p+460>>2]=ea(1.0);ja=p+508|0;ka=p+464|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+512>>2]=ea(0.0);g[p+516>>2]=ea(1.0);ja=p+564|0;ka=p+520|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+568>>2]=ea(0.0);g[p+572>>2]=ea(1.0);ja=p+620|0;ka=p+576|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+624>>2]=ea(0.0);g[p+628>>2]=ea(1.0);ja=p+676|0;ka=p+632|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+680>>2]=ea(0.0);g[p+684>>2]=ea(1.0);ja=p+732|0;ka=p+688|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+736>>2]=ea(0.0);g[p+740>>2]=ea(1.0);ja=p+788|0;ka=p+744|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+792>>2]=ea(0.0);g[p+796>>2]=ea(1.0);ja=p+844|0;ka=p+800|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+848>>2]=ea(0.0);g[p+852>>2]=ea(1.0);ja=p+900|0;ka=p+856|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+904>>2]=ea(0.0);g[p+908>>2]=ea(1.0);ja=p+956|0;ka=p+912|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+960>>2]=ea(0.0);g[p+964>>2]=ea(1.0);ja=p+1012|0;ka=p+968|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+1016>>2]=ea(0.0);g[p+1020>>2]=ea(1.0);ja=p+1068|0;ka=p+1024|0;la=ka+44|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));g[ja>>2]=ea(0.0);g[p+1072>>2]=ea(0.0);g[p+1076>>2]=ea(1.0);ka=p+1080|0;la=ka+40|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));ja=fa+da|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;b[q+32>>1]=0;c[q+4>>2]=da;c[q>>2]=p;if((((!(ea(NCa(Y,3))!=ea(0.0))?!(ea(NCa(Y,4))!=ea(0.0)):0)?!(ea(NCa(Y,0))!=ea(0.0)):0)?(a[k+194>>0]|0)==0:0)?(a[k+193>>0]|0)==0:0)ma=0;else ma=1;a:do if(mo[c[(c[ga>>2]|0)+256>>2]&4095](ga)|0){if(ma){a[q+33>>0]=1;break}p=c[X>>2]|0;fa=c[aa>>2]|0;b:do if(p){na=0;c:while(1){oa=na<<2;pa=fa+(na*208|0)+196|0;qa=0;do{if(((!(_Ea(W,qa+oa|0)|0)?(ra=c[pa>>2]|0,(a[ra+(qa*80|0)+77>>0]|0)!=0):0)?(sa=c[ra+(qa*80|0)>>2]|0,(sa|0)!=0):0)?(b[sa+4>>1]|0)==5:0)break c;qa=qa+1|0}while(qa>>>0<4);na=na+1|0;if(na>>>0>=p>>>0)break b}a[q+33>>0]=1;break a}while(0);p=k+88|0;if(c[p>>2]|0){fa=0;do{cFa(aa,fa,ea(0.0));fa=fa+1|0}while(fa>>>0<(c[p>>2]|0)>>>0)}g[$>>2]=ea(0.0);if(!m){i=n;return}a[m+32>>0]=1;i=n;return}while(0);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r>>2]=da>>>0<4?da:4;aa=Z+-1|0;if(aa>>>0>1){X=1;do{c[r+(X<<2)>>2]=4;X=X+1|0}while((X|0)!=(aa|0))}c[r+(aa<<2)>>2]=ja;ja=(Z|0)==0;if(!ja){aa=c[k+76>>2]|0;X=0;do{ma=X<<2;c[s+(X*20|0)>>2]=c[(c[aa>>2]|0)+(ma<<2)>>2];c[s+(X*20|0)+4>>2]=c[(c[aa>>2]|0)+((ma|1)<<2)>>2];c[s+(X*20|0)+8>>2]=c[(c[aa>>2]|0)+((ma|2)<<2)>>2];c[s+(X*20|0)+12>>2]=c[(c[aa>>2]|0)+((ma|3)<<2)>>2];c[s+(X*20|0)+16>>2]=c[aa+4>>2];X=X+1|0}while((X|0)!=(Z|0));if(!ja){X=0;do{aa=c[(c[ba+(X*208|0)+192>>2]|0)+352>>2]|0;ko[c[(c[aa>>2]|0)+36>>2]&4095](aa);X=X+1|0}while((X|0)!=(Z|0))}}X=t+2960|0;aa=t;do{PEi(aa|0,0,136)|0;a[aa+28>>0]=1;c[aa+44>>2]=-1;g[aa+120>>2]=ea(0.0);g[aa+124>>2]=ea(0.0);g[aa+128>>2]=ea(0.0);g[aa+132>>2]=ea(1.0);g[aa+136>>2]=ea(0.0);g[aa+140>>2]=ea(0.0);g[aa+144>>2]=ea(0.0);aa=aa+148|0}while((aa|0)!=(X|0));In[c[(c[ga>>2]|0)+124>>2]&4095](z,ga);g[u>>2]=ea(g[z>>2]);g[u+4>>2]=ea(g[z+4>>2]);g[u+8>>2]=ea(g[z+8>>2]);g[u+12>>2]=ea(g[z+12>>2]);g[u+16>>2]=ea(g[z+16>>2]);g[u+20>>2]=ea(g[z+20>>2]);g[u+24>>2]=ea(g[z+24>>2]);In[c[(c[ga>>2]|0)+84>>2]&4095](A,ga);In[c[(c[ga>>2]|0)+124>>2]&4095](B,ga);ca=ea(ea(g[B+16>>2])*ea(2.0));ta=ea(ea(g[B+20>>2])*ea(2.0));ua=ea(ea(g[B+24>>2])*ea(2.0));va=ea(g[A+12>>2]);wa=ea(ea(va*va)+ea(-.5));xa=ea(g[A>>2]);ya=ea(ca*xa);za=ea(g[A+4>>2]);Aa=ea(ya+ea(ta*za));ya=ea(g[A+8>>2]);Ba=ea(Aa+ea(ua*ya));Aa=ea(ea(xa*Ba)+ea(ea(ca*wa)+ea(va*ea(ea(ua*za)-ea(ta*ya)))));Ca=ea(ea(za*Ba)+ea(ea(ta*wa)+ea(va*ea(ea(ca*ya)-ea(ua*xa)))));Da=ea(ea(ea(ua*wa)+ea(va*ea(ea(ta*xa)-ea(ca*za))))+ea(ya*Ba));Ba=ea(ea(g[A+16>>2])+Aa);Aa=ea(ea(g[A+20>>2])+Ca);Ca=ea(ea(g[A+24>>2])+Da);Da=ea(g[B>>2]);ca=ea(va*Da);ta=ea(g[B+12>>2]);wa=ea(ca+ea(xa*ta));ca=ea(g[B+8>>2]);ua=ea(wa+ea(za*ca));wa=ea(g[B+4>>2]);Ea=ea(ua-ea(ya*wa));ua=ea(ea(ea(ya*Da)+ea(ea(za*ta)+ea(va*wa)))-ea(xa*ca));Fa=ea(ea(ea(xa*wa)+ea(ea(ya*ta)+ea(va*ca)))-ea(za*Da));Ga=ea(ea(ea(ea(va*ta)-ea(xa*Da))-ea(za*wa))-ea(ya*ca));g[v>>2]=Ea;B=v+4|0;g[B>>2]=ua;A=v+8|0;g[A>>2]=Fa;z=v+12|0;g[z>>2]=Ga;X=v+16|0;g[X>>2]=Ba;aa=v+20|0;g[aa>>2]=Aa;ma=v+24|0;g[ma>>2]=Ca;Ca=ea(ea(1.0)/ea(Kn[c[(c[ga>>2]|0)+132>>2]&255](ga)));In[c[(c[ga>>2]|0)+144>>2]&4095](C,ga);Aa=ea(ea(1.0)/ea(g[C>>2]));Ba=ea(ea(1.0)/ea(g[C+4>>2]));ca=ea(ea(1.0)/ea(g[C+8>>2]));g[w>>2]=Aa;g[w+4>>2]=Ba;g[w+8>>2]=ca;In[c[(c[ga>>2]|0)+152>>2]&4095](D,ga);ca=ea(g[D>>2]);g[x>>2]=ca;Ba=ea(g[D+4>>2]);C=x+4|0;g[C>>2]=Ba;Aa=ea(g[D+8>>2]);D=x+8|0;g[D>>2]=Aa;In[c[(c[ga>>2]|0)+160>>2]&4095](E,ga);ya=ea(g[E>>2]);g[y>>2]=ya;wa=ea(g[E+4>>2]);p=y+4|0;g[p>>2]=wa;za=ea(g[E+8>>2]);E=y+8|0;g[E>>2]=za;Da=ea(g[Y>>2]);xa=ea(g[k+132>>2]);ta=ea(g[k+136>>2]);va=ea(g[k+140>>2]);Ha=ea(g[k+144>>2]);if(0){g[3]=Da;g[4]=xa;g[5]=ta;g[6]=va;g[7]=Ha}fa=ea(Da*ea(ea(S(ea(va)))+ea(S(ea(Ha)))))>ea(0.0);na=(a[k+192>>0]|0)!=0;if((c[k+752>>2]|0)==1){if(na)if(!(!(ea(va*Ha)>=ea(0.0))?!(va==ea(0.0)&Ha==ea(0.0)):0))Ia=46}else if(((na^1|ea(xa*Ha)>ea(0.0))^1)&!(ea(ta*va)>ea(0.0)))Ia=46;do if((Ia|0)==46){na=c[k+196>>2]|0;qa=k+212|0;Ja=ea(g[qa>>2]);if((c[k+200>>2]|0)==(na|0)?Ja>ea(g[o+400>>2]):0){Ka=ea(g[$>>2]);La=ea(Ka*ea(g[o+108>>2]));pa=(na|0)!=0?La>ea(g[o+(na<<2)+272>>2]):0;oa=na>>>0>2?La<ea(g[o+(na<<2)+400>>2]):0;if(!(pa|oa))break;a[k+193>>0]=pa&1;a[k+194>>0]=oa&1;g[qa>>2]=ea(0.0);break}g[qa>>2]=ea(Ja+d)}while(0);jEa(d,ia,Y);ia=c[k+196>>2]|0;qa=(ia|0)==1;if(qa)Ma=ea(0.0);else Ma=ea(g[o+256>>2]);Ja=ea(g[o+(ia<<2)+112>>2]);La=ea(Ja*ea(g[o+240>>2]));if(0)g[8]=La;ka=F+0|0;la=ka+20|0;do{a[ka>>0]=0;ka=ka+1|0}while((ka|0)<(la|0));if(!ja){ia=0;do{oa=ia<<2;pa=c[k+((ia>>>3&134217727)<<2)+52>>2]|0;na=oa&28;if(pa&1<<na)a[F+oa>>0]=1;if(pa&1<<(na|1))a[F+(oa|1)>>0]=1;if(pa&1<<(na|2))a[F+(oa|2)>>0]=1;if(pa&1<<(na|3))a[F+(oa|3)>>0]=1;ia=ia+1|0}while((ia|0)!=(Z|0))}ka=G+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));ka=H+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));ka=I+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));kEa(va,Ha,da,F,G,H,I);ka=J+0|0;la=ka+20|0;do{a[ka>>0]=0;ka=ka+1|0}while((ka|0)<(la|0));if(!(ja|fa^1)){ia=0;do{oa=ia<<2;a[J+oa>>0]=ea(g[G+(oa<<2)>>2])!=ea(0.0)&1;na=oa|1;a[J+na>>0]=ea(g[G+(na<<2)>>2])!=ea(0.0)&1;na=oa|2;a[J+na>>0]=ea(g[G+(na<<2)>>2])!=ea(0.0)&1;na=oa|3;a[J+na>>0]=ea(g[G+(na<<2)>>2])!=ea(0.0)&1;ia=ia+1|0}while((ia|0)!=(Z|0))}if(0){Ha=ea(g[$>>2]);va=ea(g[ba>>2]);Ja=ea(ea(va*ea(g[G>>2]))+ea(0.0));va=ea(g[ba+4>>2]);Ka=ea(Ja+ea(va*ea(g[G+4>>2])));va=ea(g[ba+8>>2]);Ja=ea(Ka+ea(va*ea(g[G+8>>2])));va=ea(g[ba+12>>2]);g[2]=ea(ea(La*ea(Ja+ea(va*ea(g[G+12>>2]))))-Ha)}ka=K+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));if(ja){Na=ya;Oa=wa;Pa=za;Qa=Ga;Ra=Ea;Sa=ua;Ta=Fa;Ua=ca;Va=Ba;Wa=Aa}else{ia=0;do{na=ia<<2;oa=t+(na*148|0)|0;if(!(c[ba+(ia*208|0)+196>>2]|0)){pa=t+((na|1)*148|0)|0;sa=t+((na|2)*148|0)|0;ra=t+((na|3)*148|0)|0;c[oa+0>>2]=0;c[oa+4>>2]=0;c[oa+8>>2]=0;c[oa+12>>2]=0;c[oa+16>>2]=0;c[oa+20>>2]=0;c[oa+24>>2]=0;c[pa+0>>2]=0;c[pa+4>>2]=0;c[pa+8>>2]=0;c[pa+12>>2]=0;c[pa+16>>2]=0;c[pa+20>>2]=0;c[pa+24>>2]=0;c[sa+0>>2]=0;c[sa+4>>2]=0;c[sa+8>>2]=0;c[sa+12>>2]=0;c[sa+16>>2]=0;c[sa+20>>2]=0;c[sa+24>>2]=0;c[ra+0>>2]=0;c[ra+4>>2]=0;c[ra+8>>2]=0;c[ra+12>>2]=0;c[ra+16>>2]=0;c[ra+20>>2]=0;c[ra+24>>2]=0}else{g[oa>>2]=ea(g[ba+(ia*208|0)+80>>2]);g[t+(na*148|0)+4>>2]=ea(g[ba+(ia*208|0)+84>>2]);g[t+(na*148|0)+8>>2]=ea(g[ba+(ia*208|0)+88>>2]);g[t+(na*148|0)+12>>2]=ea(g[ba+(ia*208|0)+128>>2]);g[t+(na*148|0)+16>>2]=ea(g[ba+(ia*208|0)+132>>2]);g[t+(na*148|0)+20>>2]=ea(g[ba+(ia*208|0)+136>>2]);g[t+(na*148|0)+24>>2]=ea(g[ba+(ia*208|0)+176>>2]);oa=na|1;g[t+(oa*148|0)>>2]=ea(g[ba+(ia*208|0)+92>>2]);g[t+(oa*148|0)+4>>2]=ea(g[ba+(ia*208|0)+96>>2]);g[t+(oa*148|0)+8>>2]=ea(g[ba+(ia*208|0)+100>>2]);g[t+(oa*148|0)+12>>2]=ea(g[ba+(ia*208|0)+140>>2]);g[t+(oa*148|0)+16>>2]=ea(g[ba+(ia*208|0)+144>>2]);g[t+(oa*148|0)+20>>2]=ea(g[ba+(ia*208|0)+148>>2]);g[t+(oa*148|0)+24>>2]=ea(g[ba+(ia*208|0)+180>>2]);oa=na|2;g[t+(oa*148|0)>>2]=ea(g[ba+(ia*208|0)+104>>2]);g[t+(oa*148|0)+4>>2]=ea(g[ba+(ia*208|0)+108>>2]);g[t+(oa*148|0)+8>>2]=ea(g[ba+(ia*208|0)+112>>2]);g[t+(oa*148|0)+12>>2]=ea(g[ba+(ia*208|0)+152>>2]);g[t+(oa*148|0)+16>>2]=ea(g[ba+(ia*208|0)+156>>2]);g[t+(oa*148|0)+20>>2]=ea(g[ba+(ia*208|0)+160>>2]);g[t+(oa*148|0)+24>>2]=ea(g[ba+(ia*208|0)+184>>2]);oa=na|3;g[t+(oa*148|0)>>2]=ea(g[ba+(ia*208|0)+116>>2]);g[t+(oa*148|0)+4>>2]=ea(g[ba+(ia*208|0)+120>>2]);g[t+(oa*148|0)+8>>2]=ea(g[ba+(ia*208|0)+124>>2]);g[t+(oa*148|0)+12>>2]=ea(g[ba+(ia*208|0)+164>>2]);g[t+(oa*148|0)+16>>2]=ea(g[ba+(ia*208|0)+168>>2]);g[t+(oa*148|0)+20>>2]=ea(g[ba+(ia*208|0)+172>>2]);g[t+(oa*148|0)+24>>2]=ea(g[ba+(ia*208|0)+188>>2])}ia=ia+1|0}while((ia|0)!=(Z|0));Aa=ea(g[x>>2]);Ba=ea(g[C>>2]);ca=ea(g[D>>2]);Fa=ea(g[y>>2]);ua=ea(g[p>>2]);Ea=ea(g[E>>2]);Ga=ea(g[z>>2]);za=ea(g[v>>2]);wa=ea(g[B>>2]);Na=Fa;Oa=ua;Pa=Ea;Qa=Ga;Ra=za;Sa=wa;Ta=ea(g[A>>2]);Ua=Aa;Va=Ba;Wa=ca}ca=ea(ea(0.0)*ea(2.0));Ba=ea(ea(0.0)*ea(2.0));Aa=ea(ea(1.0)*ea(2.0));wa=ea(ea(Qa*Qa)+ea(-.5));za=ea(ea(ea(ca*Ra)+ea(Ba*Sa))+ea(Aa*Ta));Ga=ea(S(ea(ea(Wa*ea(ea(ea(Aa*wa)+ea(Qa*ea(ea(Ba*Ra)-ea(ca*Sa))))+ea(Ta*za)))+ea(ea(Ua*ea(ea(Ra*za)+ea(ea(ca*wa)+ea(Qa*ea(ea(Aa*Sa)-ea(Ba*Ta))))))+ea(Va*ea(ea(Sa*za)+ea(ea(Ba*wa)+ea(Qa*ea(ea(ca*Ta)-ea(Aa*Ra))))))))));Ra=ea(g[k+56>>2]);ia=Ga<Ra?c[k+60>>2]|0:c[k+64>>2]|0;Ra=ea(ea(1.0)/ea(ia>>>0));Ga=ea(Ra*d);Aa=ea(ea(1.0)/d);d=ea(g[k+68>>2]);g[L>>2]=Ra;g[L+4>>2]=Ga;g[L+8>>2]=ea(g[e>>2]);g[L+12>>2]=ea(g[e+4>>2]);g[L+16>>2]=ea(g[e+8>>2]);g[L+20>>2]=f;g[L+24>>2]=h;a[L+28>>0]=1;g[L+32>>2]=d;c[L+36>>2]=ga;c[L+40>>2]=j;if(!ia)Xa=Ua;else{j=M+4|0;ga=M+8|0;e=N+4|0;oa=N+8|0;na=o+84|0;ra=o+108|0;sa=o+4|0;pa=o+92|0;Ya=o+96|0;Za=o+100|0;_a=T+4|0;$a=T+8|0;ab=T+12|0;bb=T+16|0;cb=T+20|0;db=T+24|0;eb=T+28|0;fb=T+32|0;gb=T+36|0;hb=T+40|0;ib=T+44|0;jb=T+48|0;kb=T+52|0;lb=T+56|0;mb=T+60|0;nb=T+64|0;ob=T+68|0;pb=U+4|0;d=ea(Ma*La);qb=fa&1;fa=R+4|0;rb=R+8|0;sb=R+12|0;tb=R+16|0;ub=R+20|0;vb=R+24|0;wb=R+28|0;xb=R+32|0;yb=R+36|0;zb=R+40|0;Ab=R+44|0;Bb=R+48|0;Cb=R+52|0;Db=R+56|0;Eb=R+60|0;Fb=R+64|0;Gb=R+68|0;Hb=R+72|0;Ib=R+76|0;Jb=R+80|0;Kb=R+84|0;Lb=R+88|0;Mb=ia+-1|0;h=ea(-xa);f=ea(-ta);Nb=0;do{g[M>>2]=ea(0.0);g[j>>2]=ea(0.0);g[ga>>2]=ea(0.0);g[N>>2]=ea(0.0);g[e>>2]=ea(0.0);g[oa>>2]=ea(0.0);ka=O+0|0;la=ka+80|0;do{c[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));ka=P+0|0;la=ka+20|0;do{a[ka>>0]=0;ka=ka+1|0}while((ka|0)<(la|0));if(!ja){Ob=0;do{Pb=Ob<<2;Ra=ea(g[ba+(Ob*208|0)>>2]);Qb=Ra<=ea(-0.0);Ta=Qb?ea(0.0):ea(1.0);Qb=Ra>=ea(0.0);Ra=ea((Qb?Ta:ea(-1.0))*h);Qb=_+(Ob*944|0)+212|0;g[O+(Pb<<2)>>2]=ea(ea(g[Qb>>2])*Ra);a[P+Pb>>0]=ea(xa*ea(g[Qb>>2]))!=ea(0.0)&1;Ra=ea(g[ba+(Ob*208|0)+4>>2]);Qb=Ra<=ea(-0.0);Ta=Qb?ea(0.0):ea(1.0);Qb=Ra>=ea(0.0);Ra=ea((Qb?Ta:ea(-1.0))*f);Qb=_+(Ob*944|0)+260|0;Rb=Pb|1;g[O+(Rb<<2)>>2]=ea(ea(g[Qb>>2])*Ra);a[P+Rb>>0]=ea(ta*ea(g[Qb>>2]))!=ea(0.0)&1;Ra=ea(g[ba+(Ob*208|0)+8>>2]);Qb=Ra<=ea(-0.0);Ta=Qb?ea(0.0):ea(1.0);Qb=Ra>=ea(0.0);Ra=ea((Qb?Ta:ea(-1.0))*h);Qb=_+(Ob*944|0)+308|0;Rb=Pb|2;g[O+(Rb<<2)>>2]=ea(ea(g[Qb>>2])*Ra);a[P+Rb>>0]=ea(xa*ea(g[Qb>>2]))!=ea(0.0)&1;Ra=ea(g[ba+(Ob*208|0)+12>>2]);Qb=Ra<=ea(-0.0);Ta=Qb?ea(0.0):ea(1.0);Qb=Ra>=ea(0.0);Ra=ea((Qb?Ta:ea(-1.0))*f);Qb=_+(Ob*944|0)+356|0;Rb=Pb|3;g[O+(Rb<<2)>>2]=ea(ea(g[Qb>>2])*Ra);a[P+Rb>>0]=ea(ta*ea(g[Qb>>2]))!=ea(0.0)&1;Ob=Ob+1|0}while((Ob|0)!=(Z|0))}PEi(Q|0,0,1112)|0;a[Q+112>>0]=1;c[Q+164>>2]=-1;a[Q+113>>0]=1;c[Q+168>>2]=-1;a[Q+114>>0]=1;c[Q+172>>2]=-1;a[Q+115>>0]=1;c[Q+176>>2]=-1;PEi(Q+1112|0,0,1112)|0;a[Q+1224>>0]=1;c[Q+1276>>2]=-1;a[Q+1225>>0]=1;c[Q+1280>>2]=-1;a[Q+1226>>0]=1;c[Q+1284>>2]=-1;a[Q+1227>>0]=1;c[Q+1288>>2]=-1;PEi(Q+2224|0,0,1112)|0;a[Q+2336>>0]=1;c[Q+2388>>2]=-1;a[Q+2337>>0]=1;c[Q+2392>>2]=-1;a[Q+2338>>0]=1;c[Q+2396>>2]=-1;a[Q+2339>>0]=1;c[Q+2400>>2]=-1;PEi(Q+3336|0,0,1112)|0;a[Q+3448>>0]=1;c[Q+3500>>2]=-1;a[Q+3449>>0]=1;c[Q+3504>>2]=-1;a[Q+3450>>0]=1;c[Q+3508>>2]=-1;a[Q+3451>>0]=1;c[Q+3512>>2]=-1;PEi(Q+4448|0,0,1112)|0;a[Q+4560>>0]=1;c[Q+4612>>2]=-1;a[Q+4561>>0]=1;c[Q+4616>>2]=-1;a[Q+4562>>0]=1;c[Q+4620>>2]=-1;a[Q+4563>>0]=1;c[Q+4624>>2]=-1;do if(!ja){Ra=ea(g[v>>2]);Ta=ea(g[B>>2]);ca=ea(g[A>>2]);Qa=ea(g[z>>2]);wa=ea(g[X>>2]);Ba=ea(g[aa>>2]);za=ea(g[ma>>2]);Sa=ea(g[x>>2]);Ea=ea(g[C>>2]);ua=ea(g[D>>2]);Fa=ea(g[y>>2]);ya=ea(g[p>>2]);Ha=ea(g[E>>2]);Ob=(Mb|0)==(Nb|0);va=ea(0.0);Ja=ea(0.0);Ka=ea(0.0);Sb=ea(0.0);Tb=ea(0.0);Ub=ea(0.0);Qb=0;do{a[R>>0]=qb;Rb=Qb<<2;c[fa>>2]=J+Rb;c[rb>>2]=P+Rb;c[sb>>2]=K+(Rb<<2);c[tb>>2]=F+Rb;g[ub>>2]=Ra;g[vb>>2]=Ta;g[wb>>2]=ca;g[xb>>2]=Qa;g[yb>>2]=wa;g[zb>>2]=Ba;g[Ab>>2]=za;g[Bb>>2]=Sa;g[Cb>>2]=Ea;g[Db>>2]=ua;g[Eb>>2]=Fa;g[Fb>>2]=ya;g[Gb>>2]=Ha;c[Hb>>2]=_+(Qb*944|0);Pb=ba+(Qb*208|0)|0;c[Ib>>2]=Pb;c[Jb>>2]=s+(Qb*20|0);c[Kb>>2]=W;Vb=c[r+(Qb<<2)>>2]|0;c[Lb>>2]=Vb;Wb=Q+(Qb*1112|0)|0;mEa(Rb,L,R,Wb);Xb=c[Ib>>2]|0;Yb=Xb+48|0;Zb=ea(g[Q+(Qb*1112|0)+508>>2]);_b=Zb!=ea(g[Yb>>2]);g[Yb>>2]=_b?Zb:ea(0.0);Zb=ea(g[Q+(Qb*1112|0)+512>>2]);_b=Xb+52|0;Yb=Zb!=ea(g[_b>>2]);g[_b>>2]=Yb?Zb:ea(0.0);Zb=ea(g[Q+(Qb*1112|0)+516>>2]);Yb=Xb+56|0;_b=Zb!=ea(g[Yb>>2]);g[Yb>>2]=_b?Zb:ea(0.0);Zb=ea(g[Q+(Qb*1112|0)+520>>2]);_b=Xb+60|0;Yb=Zb!=ea(g[_b>>2]);g[_b>>2]=Yb?Zb:ea(0.0);Yb=Xb+64|0;Zb=ea(g[Q+(Qb*1112|0)+524>>2]);_b=Zb!=ea(g[Yb>>2]);g[Yb>>2]=_b?Zb:ea(0.0);Zb=ea(g[Q+(Qb*1112|0)+528>>2]);_b=Xb+68|0;Yb=Zb!=ea(g[_b>>2]);g[_b>>2]=Yb?Zb:ea(0.0);Zb=ea(g[Q+(Qb*1112|0)+532>>2]);Yb=Xb+72|0;_b=Zb!=ea(g[Yb>>2]);g[Yb>>2]=_b?Zb:ea(0.0);Zb=ea(g[Q+(Qb*1112|0)+536>>2]);_b=Xb+76|0;Xb=Zb!=ea(g[_b>>2]);g[_b>>2]=Xb?Zb:ea(0.0);if(Ob)nEa(Q+(Qb*1112|0)+888|0,Q+(Qb*1112|0)+904|0,Q+(Qb*1112|0)+968|0,Q+(Qb*1112|0)+984|0,Pb);va=ea(ea(g[Q+(Qb*1112|0)+484>>2])+va);Ja=ea(ea(g[Q+(Qb*1112|0)+488>>2])+Ja);Ka=ea(ea(g[Q+(Qb*1112|0)+492>>2])+Ka);Sb=ea(ea(g[Q+(Qb*1112|0)+496>>2])+Sb);Tb=ea(ea(g[Q+(Qb*1112|0)+500>>2])+Tb);Ub=ea(ea(g[Q+(Qb*1112|0)+504>>2])+Ub);a3a((c[ba+(Qb*208|0)+192>>2]|0)+4|0,Q+(Qb*1112|0)+540|0)|0;Z2a(Wb,c[sb>>2]|0,t+(Rb*148|0)|0,Vb);Wb=c[q>>2]|0;if(Vb){Pb=0;do{Xb=Pb+Rb|0;c[Wb+(Xb*56|0)+28>>2]=c[Q+(Qb*1112|0)+(Pb<<2)+1e3>>2];Zb=ea(g[Q+(Qb*1112|0)+(Pb*12|0)+1016>>2]);_b=Wb+(Xb*56|0)+32|0;g[_b>>2]=ea(Zb+ea(g[_b>>2]));Zb=ea(g[Q+(Qb*1112|0)+(Pb*12|0)+1020>>2]);_b=Wb+(Xb*56|0)+36|0;g[_b>>2]=ea(Zb+ea(g[_b>>2]));Zb=ea(g[Q+(Qb*1112|0)+(Pb*12|0)+1024>>2]);_b=Wb+(Xb*56|0)+40|0;g[_b>>2]=ea(Zb+ea(g[_b>>2]));g[Wb+(Xb*56|0)+44>>2]=ea(g[Q+(Qb*1112|0)+(Pb*12|0)+1064>>2]);g[Wb+(Xb*56|0)+48>>2]=ea(g[Q+(Qb*1112|0)+(Pb*12|0)+1068>>2]);g[Wb+(Xb*56|0)+52>>2]=ea(g[Q+(Qb*1112|0)+(Pb*12|0)+1072>>2]);Pb=Pb+1|0}while((Pb|0)!=(Vb|0))}Qb=Qb+1|0}while((Qb|0)!=(Z|0));g[M>>2]=va;g[j>>2]=Ja;g[ga>>2]=Ka;g[N>>2]=Sb;g[e>>2]=Tb;g[oa>>2]=Ub;if(ja)break;else $b=0;do{Qb=$b<<2;g[R+(Qb<<2)>>2]=ea(g[Q+($b*1112|0)+468>>2]);g[R+((Qb|1)<<2)>>2]=ea(g[Q+($b*1112|0)+472>>2]);g[R+((Qb|2)<<2)>>2]=ea(g[Q+($b*1112|0)+476>>2]);g[R+((Qb|3)<<2)>>2]=ea(g[Q+($b*1112|0)+480>>2]);$b=$b+1|0}while(($b|0)!=(Z|0))}while(0);Ub=ea(g[$>>2]);Tb=ea(Da*ea(g[na>>2]));Sb=ea(Ub*ea(g[ra>>2]));Qb=c[ha>>2]|0;do if((Qb|0)==1)Ia=90;else if(Qb){Ub=ea(g[o>>2]);if(Ub>Sb){Ia=90;break}Ob=1;Ka=Ub;Ub=ea(g[sa>>2]);while(1){Vb=Ob<<1;ac=ea(g[o+(Vb<<2)>>2]);bc=ea(g[o+((Vb|1)<<2)>>2]);Ob=Ob+1|0;if(Ka<=Sb&ac>Sb){Ia=94;break}if(Ob>>>0>=Qb>>>0){Ia=95;break}else{Ka=ac;Ub=bc}}if((Ia|0)==94){Ia=0;cc=ea(Ub+ea(ea(ea(Sb-Ka)*ea(bc-Ub))/ea(ac-Ka)));break}else if((Ia|0)==95){Ia=0;cc=ea(g[o+(((Qb<<1)+-2|1)<<2)>>2]);break}}else cc=ea(0.0);while(0);if((Ia|0)==90){Ia=0;cc=ea(g[sa>>2])}Sb=ea(Tb*cc);if(0)g[1]=Sb;Ja=ea(g[pa>>2]);va=ea(g[Za>>2]);Ha=ea(g[Ya>>2]);ya=qa?va:Ha;Ha=ea(ya+ea(Da*ea(Ja-ya)));g[T>>2]=Ga;g[_a>>2]=ea(0.0);g[$a>>2]=ea(0.0);g[ab>>2]=Ma;g[bb>>2]=La;c[cb>>2]=1;c[db>>2]=0;g[eb>>2]=Sb;g[fb>>2]=Ha;c[gb>>2]=H;c[hb>>2]=G;c[ib>>2]=O;c[jb>>2]=P;c[kb>>2]=R;c[lb>>2]=Z;c[mb>>2]=da;c[nb>>2]=_;c[ob>>2]=o;c[U>>2]=ba;c[pb>>2]=Y;qEa(T,F,I,U);if(!ja){Qb=0;do{Ob=0;do{Ha=ea(g[ba+(Qb*208|0)+(Ob<<2)>>2]);ya=ea(g[Q+(Qb*1112|0)+(Ob<<2)+292>>2]);do if(ya>ea(-ea(g[_+(Qb*944|0)+(Ob*48|0)+12>>2]))){if(a[P+Ob>>0]|0){dc=Ha;break}if(!(ea(Sb*ea(d*ea(g[H+(Ob<<2)>>2])))==ea(0.0))){dc=Ha;break}Ja=ea(g[Q+(Qb*1112|0)+(Ob<<2)+452>>2]);va=ea(S(ea(Ja)));if(!(va<ea(g[129512]))){dc=Ha;break}Fa=ea(g[_+(Qb*944|0)+(Ob*48|0)+228>>2]);ua=ea(va*ea(g[129514]));dc=ea(ea(Ha*ua)+ea(ea(Ja*Fa)*ea(ea(1.0)-ua)))}else dc=Ha;while(0);Vb=ba+(Qb*208|0)+(Ob<<2)+32|0;Ha=ea(ea(g[Vb>>2])+ea(Ga*dc));ya=ea(Ha+ea(-31.4159279));ua=ea(Ha+ea(31.4159279));Pb=ea(ea(-31.4159279)-Ha)>=ea(0.0);Wb=ya>=ea(0.0);g[Vb>>2]=Wb?ya:Pb?ua:Ha;g[ba+(Qb*208|0)+(Ob<<2)+16>>2]=dc;Ob=Ob+1|0}while((Ob|0)!=4);Qb=Qb+1|0}while((Qb|0)!=(Z|0))}$2a(Ca,w,M,N,Ga,x,y,v);Nb=Nb+1|0}while((Nb|0)!=(ia|0));Xa=ea(g[x>>2])}x=q+8|0;if(!0){g[x>>2]=Xa;g[q+12>>2]=ea(g[C>>2]);g[q+16>>2]=ea(g[D>>2]);g[q+20>>2]=ea(g[y>>2]);g[q+24>>2]=ea(g[p>>2]);g[q+28>>2]=ea(g[E>>2])}else{Ga=ea(Xa-Ua);Ua=ea(ea(g[C>>2])-Va);Va=ea(Aa*Ua);Ua=ea(Aa*ea(ea(g[D>>2])-Wa));g[x>>2]=ea(Aa*Ga);g[q+12>>2]=Va;g[q+16>>2]=Ua;Ua=ea(ea(g[y>>2])-Na);Na=ea(ea(g[p>>2])-Oa);Oa=ea(Aa*Na);Na=ea(Aa*ea(ea(g[E>>2])-Pa));g[q+20>>2]=ea(Aa*Ua);g[q+24>>2]=Oa;g[q+28>>2]=Na}g[O>>2]=ea(0.0);E=O+4|0;g[E>>2]=ea(0.0);p=O+8|0;g[p>>2]=ea(0.0);y=O+12|0;g[y>>2]=ea(1.0);D=O+16|0;C=O+20|0;ia=O+24|0;Nb=O+28|0;v=O+32|0;N=O+36|0;M=O+40|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[D+16>>2]=0;c[D+20>>2]=0;g[M>>2]=ea(1.0);w=O+44|0;H=O+48|0;P=O+52|0;ja=O+56|0;U=O+60|0;I=O+64|0;F=O+68|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[F>>2]=ea(1.0);T=O+72|0;Y=O+76|0;pb=O+80|0;o=O+84|0;ob=O+88|0;nb=O+92|0;mb=O+96|0;c[T+0>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;c[T+12>>2]=0;c[T+16>>2]=0;c[T+20>>2]=0;g[mb>>2]=ea(1.0);lb=O+100|0;g[lb>>2]=ea(0.0);R=O+104|0;g[R>>2]=ea(0.0);kb=O+108|0;g[kb>>2]=ea(0.0);tEa(_,ba,t,c[r>>2]|0,u,O);Na=ea(g[O>>2]);g[t+120>>2]=Na;g[t+124>>2]=ea(g[E>>2]);g[t+128>>2]=ea(g[p>>2]);g[t+132>>2]=ea(g[y>>2]);g[t+136>>2]=ea(g[D>>2]);g[t+140>>2]=ea(g[C>>2]);g[t+144>>2]=ea(g[ia>>2]);g[t+268>>2]=ea(g[Nb>>2]);g[t+272>>2]=ea(g[v>>2]);g[t+276>>2]=ea(g[N>>2]);g[t+280>>2]=ea(g[M>>2]);g[t+284>>2]=ea(g[w>>2]);g[t+288>>2]=ea(g[H>>2]);g[t+292>>2]=ea(g[P>>2]);g[t+416>>2]=ea(g[ja>>2]);g[t+420>>2]=ea(g[U>>2]);g[t+424>>2]=ea(g[I>>2]);g[t+428>>2]=ea(g[F>>2]);g[t+432>>2]=ea(g[T>>2]);g[t+436>>2]=ea(g[Y>>2]);g[t+440>>2]=ea(g[pb>>2]);g[t+564>>2]=ea(g[o>>2]);g[t+568>>2]=ea(g[ob>>2]);g[t+572>>2]=ea(g[nb>>2]);g[t+576>>2]=ea(g[mb>>2]);g[t+580>>2]=ea(g[lb>>2]);g[t+584>>2]=ea(g[R>>2]);g[t+588>>2]=ea(g[kb>>2]);O=c[q>>2]|0;g[O>>2]=Na;g[O+4>>2]=ea(g[E>>2]);g[O+8>>2]=ea(g[p>>2]);g[O+12>>2]=ea(g[y>>2]);g[O+16>>2]=ea(g[D>>2]);g[O+20>>2]=ea(g[C>>2]);g[O+24>>2]=ea(g[ia>>2]);g[O+56>>2]=ea(g[Nb>>2]);g[O+60>>2]=ea(g[v>>2]);g[O+64>>2]=ea(g[N>>2]);g[O+68>>2]=ea(g[M>>2]);g[O+72>>2]=ea(g[w>>2]);g[O+76>>2]=ea(g[H>>2]);g[O+80>>2]=ea(g[P>>2]);g[O+112>>2]=ea(g[ja>>2]);g[O+116>>2]=ea(g[U>>2]);g[O+120>>2]=ea(g[I>>2]);g[O+124>>2]=ea(g[F>>2]);g[O+128>>2]=ea(g[T>>2]);g[O+132>>2]=ea(g[Y>>2]);g[O+136>>2]=ea(g[pb>>2]);g[O+168>>2]=ea(g[o>>2]);g[O+172>>2]=ea(g[ob>>2]);g[O+176>>2]=ea(g[nb>>2]);g[O+180>>2]=ea(g[mb>>2]);g[O+184>>2]=ea(g[lb>>2]);g[O+188>>2]=ea(g[R>>2]);g[O+192>>2]=ea(g[kb>>2]);if(Z>>>0>1){kb=Q+4|0;O=Q+8|0;R=Q+12|0;lb=Q+16|0;mb=Q+20|0;nb=Q+24|0;ob=Q+28|0;o=Q+32|0;pb=Q+36|0;Y=Q+40|0;T=Q+44|0;F=Q+48|0;I=Q+52|0;U=Q+56|0;ja=Q+60|0;P=Q+64|0;H=Q+68|0;w=Q+72|0;M=Q+76|0;N=Q+80|0;v=Q+84|0;Nb=Q+88|0;ia=Q+92|0;C=Q+96|0;D=Q+100|0;y=Q+104|0;p=Q+108|0;E=1;do{g[Q>>2]=ea(0.0);g[kb>>2]=ea(0.0);g[O>>2]=ea(0.0);g[R>>2]=ea(1.0);c[lb+0>>2]=0;c[lb+4>>2]=0;c[lb+8>>2]=0;c[lb+12>>2]=0;c[lb+16>>2]=0;c[lb+20>>2]=0;g[Y>>2]=ea(1.0);c[T+0>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;c[T+12>>2]=0;c[T+16>>2]=0;c[T+20>>2]=0;g[H>>2]=ea(1.0);c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[C>>2]=ea(1.0);g[D>>2]=ea(0.0);g[y>>2]=ea(0.0);g[p>>2]=ea(0.0);jb=E<<2;tEa(_+(E*944|0)|0,ba+(E*208|0)|0,t+(jb*148|0)|0,c[r+(E<<2)>>2]|0,u,Q);Na=ea(g[Q>>2]);g[t+(jb*148|0)+120>>2]=Na;g[t+(jb*148|0)+124>>2]=ea(g[kb>>2]);g[t+(jb*148|0)+128>>2]=ea(g[O>>2]);g[t+(jb*148|0)+132>>2]=ea(g[R>>2]);g[t+(jb*148|0)+136>>2]=ea(g[lb>>2]);g[t+(jb*148|0)+140>>2]=ea(g[mb>>2]);g[t+(jb*148|0)+144>>2]=ea(g[nb>>2]);ib=jb|1;g[t+(ib*148|0)+120>>2]=ea(g[ob>>2]);g[t+(ib*148|0)+124>>2]=ea(g[o>>2]);g[t+(ib*148|0)+128>>2]=ea(g[pb>>2]);g[t+(ib*148|0)+132>>2]=ea(g[Y>>2]);g[t+(ib*148|0)+136>>2]=ea(g[T>>2]);g[t+(ib*148|0)+140>>2]=ea(g[F>>2]);g[t+(ib*148|0)+144>>2]=ea(g[I>>2]);G=jb|2;g[t+(G*148|0)+120>>2]=ea(g[U>>2]);g[t+(G*148|0)+124>>2]=ea(g[ja>>2]);g[t+(G*148|0)+128>>2]=ea(g[P>>2]);g[t+(G*148|0)+132>>2]=ea(g[H>>2]);g[t+(G*148|0)+136>>2]=ea(g[w>>2]);g[t+(G*148|0)+140>>2]=ea(g[M>>2]);g[t+(G*148|0)+144>>2]=ea(g[N>>2]);hb=jb|3;g[t+(hb*148|0)+120>>2]=ea(g[v>>2]);g[t+(hb*148|0)+124>>2]=ea(g[Nb>>2]);g[t+(hb*148|0)+128>>2]=ea(g[ia>>2]);g[t+(hb*148|0)+132>>2]=ea(g[C>>2]);g[t+(hb*148|0)+136>>2]=ea(g[D>>2]);g[t+(hb*148|0)+140>>2]=ea(g[y>>2]);g[t+(hb*148|0)+144>>2]=ea(g[p>>2]);gb=c[q>>2]|0;g[gb+(jb*56|0)>>2]=Na;g[gb+(jb*56|0)+4>>2]=ea(g[kb>>2]);g[gb+(jb*56|0)+8>>2]=ea(g[O>>2]);g[gb+(jb*56|0)+12>>2]=ea(g[R>>2]);g[gb+(jb*56|0)+16>>2]=ea(g[lb>>2]);g[gb+(jb*56|0)+20>>2]=ea(g[mb>>2]);g[gb+(jb*56|0)+24>>2]=ea(g[nb>>2]);g[gb+(ib*56|0)>>2]=ea(g[ob>>2]);g[gb+(ib*56|0)+4>>2]=ea(g[o>>2]);g[gb+(ib*56|0)+8>>2]=ea(g[pb>>2]);g[gb+(ib*56|0)+12>>2]=ea(g[Y>>2]);g[gb+(ib*56|0)+16>>2]=ea(g[T>>2]);g[gb+(ib*56|0)+20>>2]=ea(g[F>>2]);g[gb+(ib*56|0)+24>>2]=ea(g[I>>2]);g[gb+(G*56|0)>>2]=ea(g[U>>2]);g[gb+(G*56|0)+4>>2]=ea(g[ja>>2]);g[gb+(G*56|0)+8>>2]=ea(g[P>>2]);g[gb+(G*56|0)+12>>2]=ea(g[H>>2]);g[gb+(G*56|0)+16>>2]=ea(g[w>>2]);g[gb+(G*56|0)+20>>2]=ea(g[M>>2]);g[gb+(G*56|0)+24>>2]=ea(g[N>>2]);g[gb+(hb*56|0)>>2]=ea(g[v>>2]);g[gb+(hb*56|0)+4>>2]=ea(g[Nb>>2]);g[gb+(hb*56|0)+8>>2]=ea(g[ia>>2]);g[gb+(hb*56|0)+12>>2]=ea(g[C>>2]);g[gb+(hb*56|0)+16>>2]=ea(g[D>>2]);g[gb+(hb*56|0)+20>>2]=ea(g[y>>2]);g[gb+(hb*56|0)+24>>2]=ea(g[p>>2]);E=E+1|0}while((E|0)!=(Z|0))}if((l|0)!=0?(Z=c[l>>2]|0,(Z|0)!=0):0)YEi(Z|0,t|0,da*148|0)|0;if(!m){c[V>>2]=k;zEa(q,1,V);i=n;return}else{YEi(c[m>>2]|0,c[q>>2]|0,da*56|0)|0;g[m+8>>2]=ea(g[x>>2]);g[m+12>>2]=ea(g[q+12>>2]);g[m+16>>2]=ea(g[q+16>>2]);g[m+20>>2]=ea(g[q+20>>2]);g[m+24>>2]=ea(g[q+24>>2]);g[m+28>>2]=ea(g[q+28>>2]);x=b[q+32>>1]|0;a[m+32>>0]=x;a[m+33>>0]=(x&65535)>>>8;i=n;return}}function xEa(d,e,f,h,j,k,l,m){d=ea(d);e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=Im,Vd=0,Wd=0,Xd=Im,Yd=Im,Zd=Im,_d=Im,$d=Im;n=i;i=i+5776|0;o=n+3240|0;p=n+3200|0;q=n+5596|0;r=n+5644|0;s=n+240|0;t=n+40|0;u=n+68|0;v=n+96|0;w=n+108|0;x=n+4444|0;y=n+5568|0;z=n+5616|0;A=n+5744|0;B=n+5756|0;C=n+4360|0;D=n+4372|0;E=n+4416|0;F=n+4428|0;G=n+20|0;H=n+24|0;I=n+4440|0;J=n+120|0;K=n+128|0;L=n+4456|0;M=n;N=n+16|0;O=k+8|0;P=k+44|0;Q=c[P>>2]|0;if(!Q){R=k+72|0;T=0;U=R;V=R;W=c[R>>2]|0}else{R=c[k+72>>2]|0;X=0;do{Y=X<<2;Z=c[518096+(Y<<2)>>2]|0;if(Z){g[Z+16>>2]=ea(g[R+(X*208|0)>>2]);_=ea(g[R+(X*208|0)+4>>2]);g[(c[518096+((Y|1)<<2)>>2]|0)+16>>2]=_;_=ea(g[R+(X*208|0)+8>>2]);g[(c[518096+((Y|2)<<2)>>2]|0)+16>>2]=_;_=ea(g[R+(X*208|0)+12>>2]);g[(c[518096+((Y|3)<<2)>>2]|0)+16>>2]=_}X=X+1|0}while(X>>>0<Q>>>0);X=k+72|0;T=Q;U=X;V=X;W=R}R=c[k+40>>2]|0;X=c[k+48>>2]|0;Q=4-(T<<2)|0;Y=c[k+104>>2]|0;g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(1.0);Z=o+60|0;$=o+16|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+64>>2]=ea(0.0);g[o+68>>2]=ea(1.0);Z=o+116|0;$=o+72|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+120>>2]=ea(0.0);g[o+124>>2]=ea(1.0);Z=o+172|0;$=o+128|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+176>>2]=ea(0.0);g[o+180>>2]=ea(1.0);Z=o+228|0;$=o+184|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+232>>2]=ea(0.0);g[o+236>>2]=ea(1.0);Z=o+284|0;$=o+240|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+288>>2]=ea(0.0);g[o+292>>2]=ea(1.0);Z=o+340|0;$=o+296|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+344>>2]=ea(0.0);g[o+348>>2]=ea(1.0);Z=o+396|0;$=o+352|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+400>>2]=ea(0.0);g[o+404>>2]=ea(1.0);Z=o+452|0;$=o+408|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+456>>2]=ea(0.0);g[o+460>>2]=ea(1.0);Z=o+508|0;$=o+464|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+512>>2]=ea(0.0);g[o+516>>2]=ea(1.0);Z=o+564|0;$=o+520|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+568>>2]=ea(0.0);g[o+572>>2]=ea(1.0);Z=o+620|0;$=o+576|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+624>>2]=ea(0.0);g[o+628>>2]=ea(1.0);Z=o+676|0;$=o+632|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+680>>2]=ea(0.0);g[o+684>>2]=ea(1.0);Z=o+732|0;$=o+688|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+736>>2]=ea(0.0);g[o+740>>2]=ea(1.0);Z=o+788|0;$=o+744|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+792>>2]=ea(0.0);g[o+796>>2]=ea(1.0);Z=o+844|0;$=o+800|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+848>>2]=ea(0.0);g[o+852>>2]=ea(1.0);Z=o+900|0;$=o+856|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+904>>2]=ea(0.0);g[o+908>>2]=ea(1.0);Z=o+956|0;$=o+912|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+960>>2]=ea(0.0);g[o+964>>2]=ea(1.0);Z=o+1012|0;$=o+968|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+1016>>2]=ea(0.0);g[o+1020>>2]=ea(1.0);Z=o+1068|0;$=o+1024|0;aa=$+44|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));g[Z>>2]=ea(0.0);g[o+1072>>2]=ea(0.0);g[o+1076>>2]=ea(1.0);$=o+1080|0;aa=$+40|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(aa|0));$=Q+X|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=0;c[p+28>>2]=0;b[p+32>>1]=0;c[p+4>>2]=X;c[p>>2]=o;o=(X|0)==0;a:do if(o)ba=0;else{Q=0;while(1){if(ea(yDa(k,Q))!=ea(0.0)){ba=1;break a}if(ea(zDa(k,Q))!=ea(0.0)){ba=1;break a}Q=Q+1|0;if(Q>>>0>=X>>>0){ba=0;break}}}while(0);b:do if(mo[c[(c[Y>>2]|0)+256>>2]&4095](Y)|0){if(ba){a[p+33>>0]=1;break}Q=c[P>>2]|0;aa=c[U>>2]|0;c:do if(Q){Z=0;d:while(1){ca=Z<<2;da=aa+(Z*208|0)+196|0;fa=0;do{if(((!(_Ea(O,fa+ca|0)|0)?(ga=c[da>>2]|0,(a[ga+(fa*80|0)+77>>0]|0)!=0):0)?(ha=c[ga+(fa*80|0)>>2]|0,(ha|0)!=0):0)?(b[ha+4>>1]|0)==5:0)break d;fa=fa+1|0}while(fa>>>0<4);Z=Z+1|0;if(Z>>>0>=Q>>>0)break c}a[p+33>>0]=1;break b}while(0);Q=k+88|0;if(c[Q>>2]|0){aa=0;do{cFa(V,aa,ea(0.0));aa=aa+1|0}while(aa>>>0<(c[Q>>2]|0)>>>0)}if(!m){i=n;return}a[m+32>>0]=1;i=n;return}while(0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q>>2]=X>>>0<4?X:4;V=T+-1|0;if(V>>>0>1){U=1;do{c[q+(U<<2)>>2]=4;U=U+1|0}while((U|0)!=(V|0))}c[q+(V<<2)>>2]=$;$=(T|0)==0;if(!$){V=c[k+76>>2]|0;U=0;do{P=U<<2;c[r+(U*20|0)>>2]=c[(c[V>>2]|0)+(P<<2)>>2];c[r+(U*20|0)+4>>2]=c[(c[V>>2]|0)+((P|1)<<2)>>2];c[r+(U*20|0)+8>>2]=c[(c[V>>2]|0)+((P|2)<<2)>>2];c[r+(U*20|0)+12>>2]=c[(c[V>>2]|0)+((P|3)<<2)>>2];c[r+(U*20|0)+16>>2]=c[V+4>>2];U=U+1|0}while((U|0)!=(T|0));if(!$){U=0;do{V=c[(c[W+(U*208|0)+192>>2]|0)+352>>2]|0;ko[c[(c[V>>2]|0)+36>>2]&4095](V);U=U+1|0}while((U|0)!=(T|0))}}U=s+2960|0;V=s;do{PEi(V|0,0,136)|0;a[V+28>>0]=1;c[V+44>>2]=-1;g[V+120>>2]=ea(0.0);g[V+124>>2]=ea(0.0);g[V+128>>2]=ea(0.0);g[V+132>>2]=ea(1.0);g[V+136>>2]=ea(0.0);g[V+140>>2]=ea(0.0);g[V+144>>2]=ea(0.0);V=V+148|0}while((V|0)!=(U|0));In[c[(c[Y>>2]|0)+124>>2]&4095](y,Y);_=ea(g[y>>2]);g[t>>2]=_;ia=ea(g[y+4>>2]);g[t+4>>2]=ia;ja=ea(g[y+8>>2]);g[t+8>>2]=ja;ka=ea(g[y+12>>2]);g[t+12>>2]=ka;la=ea(g[y+16>>2]);g[t+16>>2]=la;ma=ea(g[y+20>>2]);g[t+20>>2]=ma;na=ea(g[y+24>>2]);g[t+24>>2]=na;In[c[(c[Y>>2]|0)+84>>2]&4095](z,Y);oa=ea(la*ea(2.0));la=ea(ma*ea(2.0));ma=ea(na*ea(2.0));na=ea(g[z+12>>2]);pa=ea(ea(na*na)+ea(-.5));qa=ea(g[z>>2]);ra=ea(oa*qa);sa=ea(g[z+4>>2]);ta=ea(ra+ea(la*sa));ra=ea(g[z+8>>2]);ua=ea(ta+ea(ma*ra));ta=ea(ea(qa*ua)+ea(ea(oa*pa)+ea(na*ea(ea(ma*sa)-ea(la*ra)))));va=ea(ea(sa*ua)+ea(ea(la*pa)+ea(na*ea(ea(oa*ra)-ea(ma*qa)))));wa=ea(ea(ea(ma*pa)+ea(na*ea(ea(la*qa)-ea(oa*sa))))+ea(ra*ua));ua=ea(ea(g[z+16>>2])+ta);ta=ea(ea(g[z+20>>2])+va);va=ea(ea(g[z+24>>2])+wa);wa=ea(ea(ea(ea(na*_)+ea(qa*ka))+ea(sa*ja))-ea(ra*ia));oa=ea(ea(ea(ra*_)+ea(ea(sa*ka)+ea(na*ia)))-ea(qa*ja));la=ea(ea(ea(qa*ia)+ea(ea(ra*ka)+ea(na*ja)))-ea(sa*_));pa=ea(ea(ea(ea(na*ka)-ea(qa*_))-ea(sa*ia))-ea(ra*ja));g[u>>2]=wa;z=u+4|0;g[z>>2]=oa;y=u+8|0;g[y>>2]=la;U=u+12|0;g[U>>2]=pa;V=u+16|0;g[V>>2]=ua;P=u+20|0;g[P>>2]=ta;ba=u+24|0;g[ba>>2]=va;va=ea(ea(1.0)/ea(Kn[c[(c[Y>>2]|0)+132>>2]&255](Y)));In[c[(c[Y>>2]|0)+148>>2]&4095](A,Y);g[v>>2]=ea(g[A>>2]);g[v+4>>2]=ea(g[A+4>>2]);g[v+8>>2]=ea(g[A+8>>2]);In[c[(c[Y>>2]|0)+152>>2]&4095](B,Y);ta=ea(g[B>>2]);g[w>>2]=ta;ua=ea(g[B+4>>2]);A=w+4|0;g[A>>2]=ua;ja=ea(g[B+8>>2]);B=w+8|0;g[B>>2]=ja;In[c[(c[Y>>2]|0)+160>>2]&4095](C,Y);ra=ea(g[C>>2]);g[x>>2]=ra;ia=ea(g[C+4>>2]);Q=x+4|0;g[Q>>2]=ia;sa=ea(g[C+8>>2]);C=x+8|0;g[C>>2]=sa;if(!o){o=c[k+132>>2]|0;aa=c[k+136>>2]|0;Z=0;_=ea(0.0);qa=ea(0.0);do{ka=ea(S(ea(g[o+(Z<<2)>>2])));_=ka>_?ka:_;ka=ea(S(ea(g[aa+(Z<<2)>>2])));qa=ka>qa?ka:qa;Z=Z+1|0}while((Z|0)!=(X|0));if(_>ea(0.0))xa=qa==ea(0.0);else xa=0}else xa=0;if($){ya=ra;za=ia;Aa=sa;Ba=pa;Ca=wa;Da=oa;Ea=la;Fa=ta;Ga=ua;Ha=ja}else{Z=0;do{aa=Z<<2;o=s+(aa*148|0)|0;if(!(c[W+(Z*208|0)+196>>2]|0)){fa=s+((aa|1)*148|0)|0;da=s+((aa|2)*148|0)|0;ca=s+((aa|3)*148|0)|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[fa+0>>2]=0;c[fa+4>>2]=0;c[fa+8>>2]=0;c[fa+12>>2]=0;c[fa+16>>2]=0;c[fa+20>>2]=0;c[fa+24>>2]=0;c[da+0>>2]=0;c[da+4>>2]=0;c[da+8>>2]=0;c[da+12>>2]=0;c[da+16>>2]=0;c[da+20>>2]=0;c[da+24>>2]=0;c[ca+0>>2]=0;c[ca+4>>2]=0;c[ca+8>>2]=0;c[ca+12>>2]=0;c[ca+16>>2]=0;c[ca+20>>2]=0;c[ca+24>>2]=0}else{g[o>>2]=ea(g[W+(Z*208|0)+80>>2]);g[s+(aa*148|0)+4>>2]=ea(g[W+(Z*208|0)+84>>2]);g[s+(aa*148|0)+8>>2]=ea(g[W+(Z*208|0)+88>>2]);g[s+(aa*148|0)+12>>2]=ea(g[W+(Z*208|0)+128>>2]);g[s+(aa*148|0)+16>>2]=ea(g[W+(Z*208|0)+132>>2]);g[s+(aa*148|0)+20>>2]=ea(g[W+(Z*208|0)+136>>2]);g[s+(aa*148|0)+24>>2]=ea(g[W+(Z*208|0)+176>>2]);o=aa|1;g[s+(o*148|0)>>2]=ea(g[W+(Z*208|0)+92>>2]);g[s+(o*148|0)+4>>2]=ea(g[W+(Z*208|0)+96>>2]);g[s+(o*148|0)+8>>2]=ea(g[W+(Z*208|0)+100>>2]);g[s+(o*148|0)+12>>2]=ea(g[W+(Z*208|0)+140>>2]);g[s+(o*148|0)+16>>2]=ea(g[W+(Z*208|0)+144>>2]);g[s+(o*148|0)+20>>2]=ea(g[W+(Z*208|0)+148>>2]);g[s+(o*148|0)+24>>2]=ea(g[W+(Z*208|0)+180>>2]);o=aa|2;g[s+(o*148|0)>>2]=ea(g[W+(Z*208|0)+104>>2]);g[s+(o*148|0)+4>>2]=ea(g[W+(Z*208|0)+108>>2]);g[s+(o*148|0)+8>>2]=ea(g[W+(Z*208|0)+112>>2]);g[s+(o*148|0)+12>>2]=ea(g[W+(Z*208|0)+152>>2]);g[s+(o*148|0)+16>>2]=ea(g[W+(Z*208|0)+156>>2]);g[s+(o*148|0)+20>>2]=ea(g[W+(Z*208|0)+160>>2]);g[s+(o*148|0)+24>>2]=ea(g[W+(Z*208|0)+184>>2]);o=aa|3;g[s+(o*148|0)>>2]=ea(g[W+(Z*208|0)+116>>2]);g[s+(o*148|0)+4>>2]=ea(g[W+(Z*208|0)+120>>2]);g[s+(o*148|0)+8>>2]=ea(g[W+(Z*208|0)+124>>2]);g[s+(o*148|0)+12>>2]=ea(g[W+(Z*208|0)+164>>2]);g[s+(o*148|0)+16>>2]=ea(g[W+(Z*208|0)+168>>2]);g[s+(o*148|0)+20>>2]=ea(g[W+(Z*208|0)+172>>2]);g[s+(o*148|0)+24>>2]=ea(g[W+(Z*208|0)+188>>2])}Z=Z+1|0}while((Z|0)!=(T|0));ja=ea(g[w>>2]);ua=ea(g[A>>2]);ta=ea(g[B>>2]);la=ea(g[x>>2]);oa=ea(g[Q>>2]);wa=ea(g[C>>2]);pa=ea(g[U>>2]);sa=ea(g[u>>2]);ia=ea(g[z>>2]);ya=la;za=oa;Aa=wa;Ba=pa;Ca=sa;Da=ia;Ea=ea(g[y>>2]);Fa=ja;Ga=ua;Ha=ta}ta=ea(ea(0.0)*ea(2.0));ua=ea(ea(0.0)*ea(2.0));ja=ea(ea(1.0)*ea(2.0));ia=ea(ea(Ba*Ba)+ea(-.5));sa=ea(ea(ea(ta*Ca)+ea(ua*Da))+ea(ja*Ea));pa=ea(S(ea(ea(Ha*ea(ea(ea(ja*ia)+ea(Ba*ea(ea(ua*Ca)-ea(ta*Da))))+ea(Ea*sa)))+ea(ea(Fa*ea(ea(Ca*sa)+ea(ea(ta*ia)+ea(Ba*ea(ea(ja*Da)-ea(ua*Ea))))))+ea(Ga*ea(ea(Da*sa)+ea(ea(ua*ia)+ea(Ba*ea(ea(ta*Ea)-ea(ja*Ca))))))))));Ca=ea(g[k+56>>2]);Z=pa<Ca?c[k+60>>2]|0:c[k+64>>2]|0;Ca=ea(ea(1.0)/ea(Z>>>0));pa=ea(Ca*d);ja=ea(ea(1.0)/d);d=ea(g[k+68>>2]);g[D>>2]=Ca;g[D+4>>2]=pa;g[D+8>>2]=ea(g[e>>2]);g[D+12>>2]=ea(g[e+4>>2]);g[D+16>>2]=ea(g[e+8>>2]);g[D+20>>2]=f;g[D+24>>2]=h;a[D+28>>0]=0;g[D+32>>2]=d;c[D+36>>2]=Y;c[D+40>>2]=j;if(!Z)Ia=Fa;else{j=E+4|0;Y=E+8|0;e=F+4|0;o=F+8|0;aa=k+136|0;ca=k+128|0;da=k+132|0;fa=H+4|0;ha=I+1|0;ga=H+8|0;Ja=I+2|0;Ka=H+12|0;La=I+3|0;Ma=J+1|0;Na=J+2|0;Oa=J+3|0;Pa=xa&1;Qa=K+4|0;Ra=K+8|0;Sa=K+12|0;Ta=K+16|0;Ua=K+20|0;Va=K+24|0;Wa=K+28|0;Xa=K+32|0;Ya=K+36|0;Za=K+40|0;_a=K+44|0;$a=K+48|0;ab=K+52|0;bb=K+56|0;cb=K+60|0;db=K+64|0;eb=K+68|0;fb=K+72|0;gb=K+76|0;hb=K+80|0;ib=K+84|0;jb=K+88|0;kb=L+112|0;lb=L+164|0;mb=L+113|0;nb=L+168|0;ob=L+114|0;pb=L+172|0;qb=L+115|0;rb=L+176|0;sb=L+508|0;tb=L+512|0;ub=L+516|0;vb=L+520|0;wb=L+524|0;xb=L+528|0;yb=L+532|0;zb=L+536|0;Ab=Z+-1|0;Bb=L+888|0;Cb=L+968|0;Db=L+984|0;Eb=L+904|0;Fb=L+908|0;Gb=L+912|0;Hb=L+916|0;Ib=L+892|0;Jb=L+920|0;Kb=L+924|0;Lb=L+928|0;Mb=L+932|0;Nb=L+972|0;Ob=L+988|0;Pb=L+896|0;Qb=L+936|0;Rb=L+940|0;Sb=L+944|0;Tb=L+948|0;Ub=L+976|0;Vb=L+992|0;Wb=L+900|0;Xb=L+952|0;Yb=L+956|0;Zb=L+960|0;_b=L+964|0;$b=L+980|0;ac=L+996|0;bc=L+484|0;cc=L+488|0;dc=L+492|0;ec=L+496|0;fc=L+500|0;gc=L+504|0;hc=L+540|0;ic=L+544|0;jc=L+548|0;kc=L+552|0;lc=L+556|0;mc=L+560|0;nc=L+564|0;oc=L+568|0;pc=L+572|0;qc=L+576|0;rc=L+580|0;sc=L+584|0;tc=L+588|0;uc=L+592|0;vc=L+596|0;wc=L+600|0;xc=L+604|0;yc=L+608|0;zc=L+612|0;Ac=L+616|0;Bc=L+620|0;Cc=L+624|0;Dc=L+628|0;Ec=L+632|0;Fc=L+636|0;Gc=L+656|0;Hc=L+660|0;Ic=L+664|0;Jc=L+668|0;Kc=L+672|0;Lc=L+676|0;Mc=L+680|0;Nc=L+684|0;Oc=L+688|0;Pc=L+692|0;Qc=L+696|0;Rc=L+700|0;Sc=L+704|0;Tc=L+708|0;Uc=L+712|0;Vc=L+716|0;Wc=L+720|0;Xc=L+724|0;Yc=L+728|0;Zc=L+732|0;_c=L+736|0;$c=L+740|0;ad=L+744|0;bd=L+748|0;cd=L+752|0;dd=L+772|0;ed=L+776|0;fd=L+780|0;gd=L+784|0;hd=L+788|0;id=L+792|0;jd=L+796|0;kd=L+800|0;ld=L+804|0;md=L+808|0;nd=L+812|0;od=L+816|0;pd=L+820|0;qd=L+824|0;rd=L+828|0;sd=L+832|0;td=L+836|0;ud=L+840|0;vd=L+844|0;wd=L+848|0;xd=L+852|0;yd=L+856|0;zd=L+860|0;Ad=L+864|0;Bd=L+868|0;Cd=M+4|0;Dd=M+8|0;Ed=M+12|0;Fd=L+468|0;Gd=G+3|0;Hd=G+2|0;Id=G+1|0;Jd=0;do{g[E>>2]=ea(0.0);g[j>>2]=ea(0.0);g[Y>>2]=ea(0.0);g[F>>2]=ea(0.0);g[e>>2]=ea(0.0);g[o>>2]=ea(0.0);if(!$){d=ea(g[u>>2]);h=ea(g[z>>2]);f=ea(g[y>>2]);Ca=ea(g[U>>2]);Ea=ea(g[V>>2]);ta=ea(g[P>>2]);Ba=ea(g[ba>>2]);ia=ea(g[w>>2]);ua=ea(g[A>>2]);sa=ea(g[B>>2]);Da=ea(g[x>>2]);wa=ea(g[Q>>2]);oa=ea(g[C>>2]);Kd=(Ab|0)==(Jd|0);la=ea(0.0);ra=ea(0.0);qa=ea(0.0);_=ea(0.0);ka=ea(0.0);na=ea(0.0);Ld=0;do{Md=Ld<<2;Nd=c[aa>>2]|0;Od=(c[ca>>2]|0)+(Md<<2)|0;Pd=c[da>>2]|0;Qd=Pd+(Md<<2)|0;c[G>>2]=0;Rd=c[k+((Ld>>>3&134217727)<<2)+52>>2]|0;Sd=Md&28;if(Rd&1<<Sd)a[G>>0]=1;if(Rd&1<<(Sd|1))a[Id>>0]=1;if(Rd&1<<(Sd|2))a[Hd>>0]=1;if(Rd&1<<(Sd|3))a[Gd>>0]=1;Sd=R+(Ld*944|0)|0;Rd=W+(Ld*208|0)|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[I>>2]=0;ma=ea(g[Rd>>2]);Td=ma<=ea(-0.0);Ud=Td?ea(0.0):ea(1.0);Td=ma>=ea(0.0);ma=Td?Ud:ea(-1.0);Ud=ea(g[Nd+(Md<<2)>>2]);g[H>>2]=ea(-ea(Ud*ma));a[I>>0]=Ud!=ea(0.0)&1;Ud=ea(g[W+(Ld*208|0)+4>>2]);Td=Ud<=ea(-0.0);ma=Td?ea(0.0):ea(1.0);Td=Ud>=ea(0.0);Ud=Td?ma:ea(-1.0);Td=Md|1;ma=ea(g[Nd+(Td<<2)>>2]);g[fa>>2]=ea(-ea(ma*Ud));a[ha>>0]=ma!=ea(0.0)&1;ma=ea(g[W+(Ld*208|0)+8>>2]);Vd=ma<=ea(-0.0);Ud=Vd?ea(0.0):ea(1.0);Vd=ma>=ea(0.0);ma=Vd?Ud:ea(-1.0);Vd=Md|2;Ud=ea(g[Nd+(Vd<<2)>>2]);g[ga>>2]=ea(-ea(Ud*ma));a[Ja>>0]=Ud!=ea(0.0)&1;Ud=ea(g[W+(Ld*208|0)+12>>2]);Wd=Ud<=ea(-0.0);ma=Wd?ea(0.0):ea(1.0);Wd=Ud>=ea(0.0);Ud=Wd?ma:ea(-1.0);Wd=Md|3;ma=ea(g[Nd+(Wd<<2)>>2]);g[Ka>>2]=ea(-ea(ma*Ud));a[La>>0]=ma!=ea(0.0)&1;c[J>>2]=0;if(xa){a[J>>0]=ea(g[Qd>>2])!=ea(0.0)&1;a[Ma>>0]=ea(g[Pd+(Td<<2)>>2])!=ea(0.0)&1;a[Na>>0]=ea(g[Pd+(Vd<<2)>>2])!=ea(0.0)&1;a[Oa>>0]=ea(g[Pd+(Wd<<2)>>2])!=ea(0.0)&1}a[K>>0]=Pa;c[Qa>>2]=J;c[Ra>>2]=I;c[Sa>>2]=Od;c[Ta>>2]=G;g[Ua>>2]=d;g[Va>>2]=h;g[Wa>>2]=f;g[Xa>>2]=Ca;g[Ya>>2]=Ea;g[Za>>2]=ta;g[_a>>2]=Ba;g[$a>>2]=ia;g[ab>>2]=ua;g[bb>>2]=sa;g[cb>>2]=Da;g[db>>2]=wa;g[eb>>2]=oa;c[fb>>2]=Sd;c[gb>>2]=Rd;c[hb>>2]=r+(Ld*20|0);c[ib>>2]=O;Od=q+(Ld<<2)|0;c[jb>>2]=c[Od>>2];PEi(L|0,0,1112)|0;a[kb>>0]=1;c[lb>>2]=-1;a[mb>>0]=1;c[nb>>2]=-1;a[ob>>0]=1;c[pb>>2]=-1;a[qb>>0]=1;c[rb>>2]=-1;mEa(Md,D,K,L);Wd=c[gb>>2]|0;Vd=Wd+48|0;ma=ea(g[sb>>2]);Td=ma!=ea(g[Vd>>2]);g[Vd>>2]=Td?ma:ea(0.0);ma=ea(g[tb>>2]);Td=Wd+52|0;Vd=ma!=ea(g[Td>>2]);g[Td>>2]=Vd?ma:ea(0.0);ma=ea(g[ub>>2]);Vd=Wd+56|0;Td=ma!=ea(g[Vd>>2]);g[Vd>>2]=Td?ma:ea(0.0);ma=ea(g[vb>>2]);Td=Wd+60|0;Vd=ma!=ea(g[Td>>2]);g[Td>>2]=Vd?ma:ea(0.0);Vd=Wd+64|0;ma=ea(g[wb>>2]);Td=ma!=ea(g[Vd>>2]);g[Vd>>2]=Td?ma:ea(0.0);ma=ea(g[xb>>2]);Td=Wd+68|0;Vd=ma!=ea(g[Td>>2]);g[Td>>2]=Vd?ma:ea(0.0);ma=ea(g[yb>>2]);Vd=Wd+72|0;Td=ma!=ea(g[Vd>>2]);g[Vd>>2]=Td?ma:ea(0.0);ma=ea(g[zb>>2]);Td=Wd+76|0;Wd=ma!=ea(g[Td>>2]);g[Td>>2]=Wd?ma:ea(0.0);if(Kd){if(c[W+(Ld*208|0)+196>>2]|0)a[W+(Ld*208|0)+200>>0]=1;b[W+(Ld*208|0)+176>>1]=c[Bb>>2];g[W+(Ld*208|0)+80>>2]=ea(g[Eb>>2]);g[W+(Ld*208|0)+84>>2]=ea(g[Fb>>2]);g[W+(Ld*208|0)+88>>2]=ea(g[Gb>>2]);g[W+(Ld*208|0)+92>>2]=ea(g[Hb>>2]);g[W+(Ld*208|0)+160>>2]=ea(g[Cb>>2]);g[W+(Ld*208|0)+144>>2]=ea(g[Db>>2]);b[W+(Ld*208|0)+178>>1]=c[Ib>>2];g[W+(Ld*208|0)+96>>2]=ea(g[Jb>>2]);g[W+(Ld*208|0)+100>>2]=ea(g[Kb>>2]);g[W+(Ld*208|0)+104>>2]=ea(g[Lb>>2]);g[W+(Ld*208|0)+108>>2]=ea(g[Mb>>2]);g[W+(Ld*208|0)+164>>2]=ea(g[Nb>>2]);g[W+(Ld*208|0)+148>>2]=ea(g[Ob>>2]);b[W+(Ld*208|0)+180>>1]=c[Pb>>2];g[W+(Ld*208|0)+112>>2]=ea(g[Qb>>2]);g[W+(Ld*208|0)+116>>2]=ea(g[Rb>>2]);g[W+(Ld*208|0)+120>>2]=ea(g[Sb>>2]);g[W+(Ld*208|0)+124>>2]=ea(g[Tb>>2]);g[W+(Ld*208|0)+168>>2]=ea(g[Ub>>2]);g[W+(Ld*208|0)+152>>2]=ea(g[Vb>>2]);b[W+(Ld*208|0)+182>>1]=c[Wb>>2];g[W+(Ld*208|0)+128>>2]=ea(g[Xb>>2]);g[W+(Ld*208|0)+132>>2]=ea(g[Yb>>2]);g[W+(Ld*208|0)+136>>2]=ea(g[Zb>>2]);g[W+(Ld*208|0)+140>>2]=ea(g[_b>>2]);g[W+(Ld*208|0)+172>>2]=ea(g[$b>>2]);g[W+(Ld*208|0)+156>>2]=ea(g[ac>>2])}la=ea(ea(g[bc>>2])+la);ra=ea(ea(g[cc>>2])+ra);qa=ea(ea(g[dc>>2])+qa);_=ea(ea(g[ec>>2])+_);ka=ea(ea(g[fc>>2])+ka);na=ea(ea(g[gc>>2])+na);Wd=c[W+(Ld*208|0)+192>>2]|0;g[Wd+4>>2]=ea(g[hc>>2]);g[Wd+8>>2]=ea(g[ic>>2]);g[Wd+12>>2]=ea(g[jc>>2]);g[Wd+16>>2]=ea(g[kc>>2]);g[Wd+20>>2]=ea(g[lc>>2]);g[Wd+24>>2]=ea(g[mc>>2]);g[Wd+28>>2]=ea(g[nc>>2]);g[Wd+32>>2]=ea(g[oc>>2]);g[Wd+36>>2]=ea(g[pc>>2]);g[Wd+40>>2]=ea(g[qc>>2]);g[Wd+44>>2]=ea(g[rc>>2]);g[Wd+48>>2]=ea(g[sc>>2]);g[Wd+52>>2]=ea(g[tc>>2]);g[Wd+56>>2]=ea(g[uc>>2]);g[Wd+60>>2]=ea(g[vc>>2]);g[Wd+64>>2]=ea(g[wc>>2]);g[Wd+68>>2]=ea(g[xc>>2]);g[Wd+72>>2]=ea(g[yc>>2]);g[Wd+76>>2]=ea(g[zc>>2]);g[Wd+80>>2]=ea(g[Ac>>2]);g[Wd+84>>2]=ea(g[Bc>>2]);g[Wd+88>>2]=ea(g[Cc>>2]);g[Wd+92>>2]=ea(g[Dc>>2]);g[Wd+96>>2]=ea(g[Ec>>2]);Td=Wd+100|0;c[Td+0>>2]=c[Fc+0>>2];c[Td+4>>2]=c[Fc+4>>2];c[Td+8>>2]=c[Fc+8>>2];c[Td+12>>2]=c[Fc+12>>2];c[Td+16>>2]=c[Fc+16>>2];g[Wd+120>>2]=ea(g[Gc>>2]);g[Wd+124>>2]=ea(g[Hc>>2]);g[Wd+128>>2]=ea(g[Ic>>2]);g[Wd+132>>2]=ea(g[Jc>>2]);g[Wd+136>>2]=ea(g[Kc>>2]);g[Wd+140>>2]=ea(g[Lc>>2]);g[Wd+144>>2]=ea(g[Mc>>2]);g[Wd+148>>2]=ea(g[Nc>>2]);g[Wd+152>>2]=ea(g[Oc>>2]);g[Wd+156>>2]=ea(g[Pc>>2]);g[Wd+160>>2]=ea(g[Qc>>2]);g[Wd+164>>2]=ea(g[Rc>>2]);g[Wd+168>>2]=ea(g[Sc>>2]);g[Wd+172>>2]=ea(g[Tc>>2]);g[Wd+176>>2]=ea(g[Uc>>2]);g[Wd+180>>2]=ea(g[Vc>>2]);g[Wd+184>>2]=ea(g[Wc>>2]);g[Wd+188>>2]=ea(g[Xc>>2]);g[Wd+192>>2]=ea(g[Yc>>2]);g[Wd+196>>2]=ea(g[Zc>>2]);g[Wd+200>>2]=ea(g[_c>>2]);g[Wd+204>>2]=ea(g[$c>>2]);g[Wd+208>>2]=ea(g[ad>>2]);g[Wd+212>>2]=ea(g[bd>>2]);Td=Wd+216|0;c[Td+0>>2]=c[cd+0>>2];c[Td+4>>2]=c[cd+4>>2];c[Td+8>>2]=c[cd+8>>2];c[Td+12>>2]=c[cd+12>>2];c[Td+16>>2]=c[cd+16>>2];g[Wd+236>>2]=ea(g[dd>>2]);g[Wd+240>>2]=ea(g[ed>>2]);g[Wd+244>>2]=ea(g[fd>>2]);g[Wd+248>>2]=ea(g[gd>>2]);g[Wd+252>>2]=ea(g[hd>>2]);g[Wd+256>>2]=ea(g[id>>2]);g[Wd+260>>2]=ea(g[jd>>2]);g[Wd+264>>2]=ea(g[kd>>2]);g[Wd+268>>2]=ea(g[ld>>2]);g[Wd+272>>2]=ea(g[md>>2]);g[Wd+276>>2]=ea(g[nd>>2]);g[Wd+280>>2]=ea(g[od>>2]);g[Wd+284>>2]=ea(g[pd>>2]);g[Wd+288>>2]=ea(g[qd>>2]);g[Wd+292>>2]=ea(g[rd>>2]);g[Wd+296>>2]=ea(g[sd>>2]);g[Wd+300>>2]=ea(g[td>>2]);g[Wd+304>>2]=ea(g[ud>>2]);g[Wd+308>>2]=ea(g[vd>>2]);g[Wd+312>>2]=ea(g[wd>>2]);g[Wd+316>>2]=ea(g[xd>>2]);g[Wd+320>>2]=ea(g[yd>>2]);g[Wd+324>>2]=ea(g[zd>>2]);g[Wd+328>>2]=ea(g[Ad>>2]);Td=Wd+332|0;c[Td+0>>2]=c[Bd+0>>2];c[Td+4>>2]=c[Bd+4>>2];c[Td+8>>2]=c[Bd+8>>2];c[Td+12>>2]=c[Bd+12>>2];c[Td+16>>2]=c[Bd+16>>2];Td=c[Od>>2]|0;Z2a(L,c[Sa>>2]|0,s+(Md*148|0)|0,Td);Od=c[p>>2]|0;if(Td){Wd=0;do{Vd=Wd+Md|0;c[Od+(Vd*56|0)+28>>2]=c[L+(Wd<<2)+1e3>>2];ma=ea(g[L+(Wd*12|0)+1016>>2]);Nd=Od+(Vd*56|0)+32|0;g[Nd>>2]=ea(ma+ea(g[Nd>>2]));ma=ea(g[L+(Wd*12|0)+1020>>2]);Nd=Od+(Vd*56|0)+36|0;g[Nd>>2]=ea(ma+ea(g[Nd>>2]));ma=ea(g[L+(Wd*12|0)+1024>>2]);Nd=Od+(Vd*56|0)+40|0;g[Nd>>2]=ea(ma+ea(g[Nd>>2]));g[Od+(Vd*56|0)+44>>2]=ea(g[L+(Wd*12|0)+1064>>2]);g[Od+(Vd*56|0)+48>>2]=ea(g[L+(Wd*12|0)+1068>>2]);g[Od+(Vd*56|0)+52>>2]=ea(g[L+(Wd*12|0)+1072>>2]);Wd=Wd+1|0}while((Wd|0)!=(Td|0))}g[M>>2]=ea(g[R+(Ld*944|0)+208>>2]);g[Cd>>2]=ea(g[R+(Ld*944|0)+256>>2]);g[Dd>>2]=ea(g[R+(Ld*944|0)+304>>2]);g[Ed>>2]=ea(g[R+(Ld*944|0)+352>>2]);rEa(pa,H,I,Qd,Fd,M,Sd,Rd);Td=0;do{ma=ea(g[W+(Ld*208|0)+(Td<<2)>>2]);Ud=ea(g[L+(Td<<2)+292>>2]);do if(Ud>ea(-ea(g[R+(Ld*944|0)+(Td*48|0)+12>>2]))){if(a[I+Td>>0]|0){Xd=ma;break}if(!(ea(g[Pd+(Td+Md<<2)>>2])==ea(0.0))){Xd=ma;break}Yd=ea(g[L+(Td<<2)+452>>2]);Zd=ea(S(ea(Yd)));if(!(Zd<ea(g[129512]))){Xd=ma;break}_d=ea(g[R+(Ld*944|0)+(Td*48|0)+228>>2]);$d=ea(Zd*ea(g[129514]));Xd=ea(ea(ma*$d)+ea(ea(Yd*_d)*ea(ea(1.0)-$d)))}else Xd=ma;while(0);Wd=W+(Ld*208|0)+(Td<<2)+32|0;ma=ea(ea(g[Wd>>2])+ea(pa*Xd));Ud=ea(ma+ea(-31.4159279));$d=ea(ma+ea(31.4159279));Od=ea(ea(-31.4159279)-ma)>=ea(0.0);Vd=Ud>=ea(0.0);g[Wd>>2]=Vd?Ud:Od?$d:ma;g[W+(Ld*208|0)+(Td<<2)+16>>2]=Xd;Td=Td+1|0}while((Td|0)!=4);Ld=Ld+1|0}while((Ld|0)!=(T|0));g[E>>2]=la;g[j>>2]=ra;g[Y>>2]=qa;g[F>>2]=_;g[e>>2]=ka;g[o>>2]=na}$2a(va,v,E,F,pa,w,x,u);Jd=Jd+1|0}while((Jd|0)!=(Z|0));Ia=ea(g[w>>2])}w=p+8|0;if(!0){g[w>>2]=Ia;g[p+12>>2]=ea(g[A>>2]);g[p+16>>2]=ea(g[B>>2]);g[p+20>>2]=ea(g[x>>2]);g[p+24>>2]=ea(g[Q>>2]);g[p+28>>2]=ea(g[C>>2])}else{pa=ea(Ia-Fa);Fa=ea(ea(g[A>>2])-Ga);Ga=ea(ja*Fa);Fa=ea(ja*ea(ea(g[B>>2])-Ha));g[w>>2]=ea(ja*pa);g[p+12>>2]=Ga;g[p+16>>2]=Fa;Fa=ea(ea(g[x>>2])-ya);ya=ea(ea(g[Q>>2])-za);za=ea(ja*ya);ya=ea(ja*ea(ea(g[C>>2])-Aa));g[p+20>>2]=ea(ja*Fa);g[p+24>>2]=za;g[p+28>>2]=ya}g[K>>2]=ea(0.0);C=K+4|0;g[C>>2]=ea(0.0);Q=K+8|0;g[Q>>2]=ea(0.0);x=K+12|0;g[x>>2]=ea(1.0);B=K+16|0;A=K+20|0;Z=K+24|0;Jd=K+28|0;u=K+32|0;F=K+36|0;E=K+40|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[B+16>>2]=0;c[B+20>>2]=0;g[E>>2]=ea(1.0);v=K+44|0;o=K+48|0;e=K+52|0;Y=K+56|0;j=K+60|0;I=K+64|0;M=K+68|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;g[M>>2]=ea(1.0);Fd=K+72|0;H=K+76|0;Ed=K+80|0;Dd=K+84|0;Cd=K+88|0;Sa=K+92|0;Bd=K+96|0;c[Fd+0>>2]=0;c[Fd+4>>2]=0;c[Fd+8>>2]=0;c[Fd+12>>2]=0;c[Fd+16>>2]=0;c[Fd+20>>2]=0;g[Bd>>2]=ea(1.0);Ad=K+100|0;g[Ad>>2]=ea(0.0);zd=K+104|0;g[zd>>2]=ea(0.0);yd=K+108|0;g[yd>>2]=ea(0.0);tEa(R,W,s,c[q>>2]|0,t,K);ya=ea(g[K>>2]);g[s+120>>2]=ya;g[s+124>>2]=ea(g[C>>2]);g[s+128>>2]=ea(g[Q>>2]);g[s+132>>2]=ea(g[x>>2]);g[s+136>>2]=ea(g[B>>2]);g[s+140>>2]=ea(g[A>>2]);g[s+144>>2]=ea(g[Z>>2]);g[s+268>>2]=ea(g[Jd>>2]);g[s+272>>2]=ea(g[u>>2]);g[s+276>>2]=ea(g[F>>2]);g[s+280>>2]=ea(g[E>>2]);g[s+284>>2]=ea(g[v>>2]);g[s+288>>2]=ea(g[o>>2]);g[s+292>>2]=ea(g[e>>2]);g[s+416>>2]=ea(g[Y>>2]);g[s+420>>2]=ea(g[j>>2]);g[s+424>>2]=ea(g[I>>2]);g[s+428>>2]=ea(g[M>>2]);g[s+432>>2]=ea(g[Fd>>2]);g[s+436>>2]=ea(g[H>>2]);g[s+440>>2]=ea(g[Ed>>2]);g[s+564>>2]=ea(g[Dd>>2]);g[s+568>>2]=ea(g[Cd>>2]);g[s+572>>2]=ea(g[Sa>>2]);g[s+576>>2]=ea(g[Bd>>2]);g[s+580>>2]=ea(g[Ad>>2]);g[s+584>>2]=ea(g[zd>>2]);g[s+588>>2]=ea(g[yd>>2]);K=c[p>>2]|0;g[K>>2]=ya;g[K+4>>2]=ea(g[C>>2]);g[K+8>>2]=ea(g[Q>>2]);g[K+12>>2]=ea(g[x>>2]);g[K+16>>2]=ea(g[B>>2]);g[K+20>>2]=ea(g[A>>2]);g[K+24>>2]=ea(g[Z>>2]);g[K+56>>2]=ea(g[Jd>>2]);g[K+60>>2]=ea(g[u>>2]);g[K+64>>2]=ea(g[F>>2]);g[K+68>>2]=ea(g[E>>2]);g[K+72>>2]=ea(g[v>>2]);g[K+76>>2]=ea(g[o>>2]);g[K+80>>2]=ea(g[e>>2]);g[K+112>>2]=ea(g[Y>>2]);g[K+116>>2]=ea(g[j>>2]);g[K+120>>2]=ea(g[I>>2]);g[K+124>>2]=ea(g[M>>2]);g[K+128>>2]=ea(g[Fd>>2]);g[K+132>>2]=ea(g[H>>2]);g[K+136>>2]=ea(g[Ed>>2]);g[K+168>>2]=ea(g[Dd>>2]);g[K+172>>2]=ea(g[Cd>>2]);g[K+176>>2]=ea(g[Sa>>2]);g[K+180>>2]=ea(g[Bd>>2]);g[K+184>>2]=ea(g[Ad>>2]);g[K+188>>2]=ea(g[zd>>2]);g[K+192>>2]=ea(g[yd>>2]);if(T>>>0>1){yd=L+4|0;K=L+8|0;zd=L+12|0;Ad=L+16|0;Bd=L+20|0;Sa=L+24|0;Cd=L+28|0;Dd=L+32|0;Ed=L+36|0;H=L+40|0;Fd=L+44|0;M=L+48|0;I=L+52|0;j=L+56|0;Y=L+60|0;e=L+64|0;o=L+68|0;v=L+72|0;E=L+76|0;F=L+80|0;u=L+84|0;Jd=L+88|0;Z=L+92|0;A=L+96|0;B=L+100|0;x=L+104|0;Q=L+108|0;C=1;do{g[L>>2]=ea(0.0);g[yd>>2]=ea(0.0);g[K>>2]=ea(0.0);g[zd>>2]=ea(1.0);c[Ad+0>>2]=0;c[Ad+4>>2]=0;c[Ad+8>>2]=0;c[Ad+12>>2]=0;c[Ad+16>>2]=0;c[Ad+20>>2]=0;g[H>>2]=ea(1.0);c[Fd+0>>2]=0;c[Fd+4>>2]=0;c[Fd+8>>2]=0;c[Fd+12>>2]=0;c[Fd+16>>2]=0;c[Fd+20>>2]=0;g[o>>2]=ea(1.0);c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;g[A>>2]=ea(1.0);g[B>>2]=ea(0.0);g[x>>2]=ea(0.0);g[Q>>2]=ea(0.0);xd=C<<2;tEa(R+(C*944|0)|0,W+(C*208|0)|0,s+(xd*148|0)|0,c[q+(C<<2)>>2]|0,t,L);ya=ea(g[L>>2]);g[s+(xd*148|0)+120>>2]=ya;g[s+(xd*148|0)+124>>2]=ea(g[yd>>2]);g[s+(xd*148|0)+128>>2]=ea(g[K>>2]);g[s+(xd*148|0)+132>>2]=ea(g[zd>>2]);g[s+(xd*148|0)+136>>2]=ea(g[Ad>>2]);g[s+(xd*148|0)+140>>2]=ea(g[Bd>>2]);g[s+(xd*148|0)+144>>2]=ea(g[Sa>>2]);wd=xd|1;g[s+(wd*148|0)+120>>2]=ea(g[Cd>>2]);g[s+(wd*148|0)+124>>2]=ea(g[Dd>>2]);g[s+(wd*148|0)+128>>2]=ea(g[Ed>>2]);g[s+(wd*148|0)+132>>2]=ea(g[H>>2]);g[s+(wd*148|0)+136>>2]=ea(g[Fd>>2]);g[s+(wd*148|0)+140>>2]=ea(g[M>>2]);g[s+(wd*148|0)+144>>2]=ea(g[I>>2]);vd=xd|2;g[s+(vd*148|0)+120>>2]=ea(g[j>>2]);g[s+(vd*148|0)+124>>2]=ea(g[Y>>2]);g[s+(vd*148|0)+128>>2]=ea(g[e>>2]);g[s+(vd*148|0)+132>>2]=ea(g[o>>2]);g[s+(vd*148|0)+136>>2]=ea(g[v>>2]);g[s+(vd*148|0)+140>>2]=ea(g[E>>2]);g[s+(vd*148|0)+144>>2]=ea(g[F>>2]);ud=xd|3;g[s+(ud*148|0)+120>>2]=ea(g[u>>2]);g[s+(ud*148|0)+124>>2]=ea(g[Jd>>2]);g[s+(ud*148|0)+128>>2]=ea(g[Z>>2]);g[s+(ud*148|0)+132>>2]=ea(g[A>>2]);g[s+(ud*148|0)+136>>2]=ea(g[B>>2]);g[s+(ud*148|0)+140>>2]=ea(g[x>>2]);g[s+(ud*148|0)+144>>2]=ea(g[Q>>2]);td=c[p>>2]|0;g[td+(xd*56|0)>>2]=ya;g[td+(xd*56|0)+4>>2]=ea(g[yd>>2]);g[td+(xd*56|0)+8>>2]=ea(g[K>>2]);g[td+(xd*56|0)+12>>2]=ea(g[zd>>2]);g[td+(xd*56|0)+16>>2]=ea(g[Ad>>2]);g[td+(xd*56|0)+20>>2]=ea(g[Bd>>2]);g[td+(xd*56|0)+24>>2]=ea(g[Sa>>2]);g[td+(wd*56|0)>>2]=ea(g[Cd>>2]);g[td+(wd*56|0)+4>>2]=ea(g[Dd>>2]);g[td+(wd*56|0)+8>>2]=ea(g[Ed>>2]);g[td+(wd*56|0)+12>>2]=ea(g[H>>2]);g[td+(wd*56|0)+16>>2]=ea(g[Fd>>2]);g[td+(wd*56|0)+20>>2]=ea(g[M>>2]);g[td+(wd*56|0)+24>>2]=ea(g[I>>2]);g[td+(vd*56|0)>>2]=ea(g[j>>2]);g[td+(vd*56|0)+4>>2]=ea(g[Y>>2]);g[td+(vd*56|0)+8>>2]=ea(g[e>>2]);g[td+(vd*56|0)+12>>2]=ea(g[o>>2]);g[td+(vd*56|0)+16>>2]=ea(g[v>>2]);g[td+(vd*56|0)+20>>2]=ea(g[E>>2]);g[td+(vd*56|0)+24>>2]=ea(g[F>>2]);g[td+(ud*56|0)>>2]=ea(g[u>>2]);g[td+(ud*56|0)+4>>2]=ea(g[Jd>>2]);g[td+(ud*56|0)+8>>2]=ea(g[Z>>2]);g[td+(ud*56|0)+12>>2]=ea(g[A>>2]);g[td+(ud*56|0)+16>>2]=ea(g[B>>2]);g[td+(ud*56|0)+20>>2]=ea(g[x>>2]);g[td+(ud*56|0)+24>>2]=ea(g[Q>>2]);C=C+1|0}while((C|0)!=(T|0))}if((l|0)!=0?(T=c[l>>2]|0,(T|0)!=0):0)YEi(T|0,s|0,X*148|0)|0;if(!m){c[N>>2]=k;zEa(p,1,N);i=n;return}else{YEi(c[m>>2]|0,c[p>>2]|0,X*56|0)|0;g[m+8>>2]=ea(g[w>>2]);g[m+12>>2]=ea(g[p+12>>2]);g[m+16>>2]=ea(g[p+16>>2]);g[m+20>>2]=ea(g[p+20>>2]);g[m+24>>2]=ea(g[p+24>>2]);g[m+28>>2]=ea(g[p+28>>2]);w=b[p+32>>1]|0;a[m+32>>0]=w;a[m+33>>0]=(w&65535)>>>8;i=n;return}}function yEa(a,b,e,f,h,j,k){a=ea(a);b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0;l=i;m=518096|0;n=m+80|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));o=ea(g[b>>2]);p=ea(o*o);o=ea(g[b+4>>2]);q=ea(p+ea(o*o));o=ea(g[b+8>>2]);p=ea(T(ea(q+ea(o*o))));o=ea(ea(1.0)/p);if(!f){i=l;return}m=(j|0)==0;n=(k|0)==0;r=0;do{s=c[h+(r<<2)>>2]|0;if(m)t=0;else t=j+(r<<3)|0;if(n)u=0;else u=k+(r*36|0)|0;v=d[s+113>>0]|0;if((v|0)==3)xEa(a,b,p,o,e,s,t,u);else if(!v)uEa(a,b,p,o,e,s,t,u);else if((v|0)==1)vEa(a,b,p,o,e,s,t,u);else if((v|0)==2)wEa(a,b,p,o,e,s,t,u);r=r+1|0}while((r|0)!=(f|0));i=l;return}function zEa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;f=i;i=i+656|0;h=f+136|0;j=f+132|0;k=f+112|0;l=f;if(!d){i=f;return}m=l+4|0;n=l+8|0;o=l+12|0;p=l+16|0;q=l+20|0;r=l+24|0;s=l+28|0;t=l+32|0;u=l+36|0;v=l+40|0;w=l+44|0;x=l+48|0;y=l+52|0;z=l+56|0;A=l+60|0;B=l+64|0;C=l+68|0;D=l+72|0;E=l+76|0;F=l+80|0;G=l+84|0;H=l+88|0;I=l+92|0;J=l+96|0;K=l+100|0;L=l+104|0;M=l+108|0;N=0;do{O=c[e+(N<<2)>>2]|0;P=c[O+104>>2]|0;Q=b+(N*36|0)|0;if(!(a[b+(N*36|0)+32>>0]|0)){if(a[b+(N*36|0)+33>>0]|0)ko[c[(c[P>>2]|0)+284>>2]&4095](P);if(!0){co[c[(c[P>>2]|0)+156>>2]&2047](P,b+(N*36|0)+8|0,0);co[c[(c[P>>2]|0)+164>>2]&2047](P,b+(N*36|0)+20|0,0)}else{Dn[c[(c[P>>2]|0)+168>>2]&511](P,b+(N*36|0)+8|0,3,0);Dn[c[(c[P>>2]|0)+172>>2]&511](P,b+(N*36|0)+20|0,3,0)}R=c[O+48>>2]|0;S=c[O+44>>2]|0;T=R+4-(S<<2)|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k>>2]=R>>>0<4?R:4;U=S+-1|0;if(U>>>0>1){V=1;do{c[k+(V<<2)>>2]=4;V=V+1|0}while((V|0)!=(U|0))}c[k+(U<<2)>>2]=T;if(S){V=O+40|0;W=0;do{X=W<<2;Y=c[Q>>2]|0;g[l>>2]=ea(g[Y+(X*56|0)>>2]);g[m>>2]=ea(g[Y+(X*56|0)+4>>2]);g[n>>2]=ea(g[Y+(X*56|0)+8>>2]);g[o>>2]=ea(g[Y+(X*56|0)+12>>2]);g[p>>2]=ea(g[Y+(X*56|0)+16>>2]);g[q>>2]=ea(g[Y+(X*56|0)+20>>2]);g[r>>2]=ea(g[Y+(X*56|0)+24>>2]);Z=X|1;g[s>>2]=ea(g[Y+(Z*56|0)>>2]);g[t>>2]=ea(g[Y+(Z*56|0)+4>>2]);g[u>>2]=ea(g[Y+(Z*56|0)+8>>2]);g[v>>2]=ea(g[Y+(Z*56|0)+12>>2]);g[w>>2]=ea(g[Y+(Z*56|0)+16>>2]);g[x>>2]=ea(g[Y+(Z*56|0)+20>>2]);g[y>>2]=ea(g[Y+(Z*56|0)+24>>2]);Z=X|2;g[z>>2]=ea(g[Y+(Z*56|0)>>2]);g[A>>2]=ea(g[Y+(Z*56|0)+4>>2]);g[B>>2]=ea(g[Y+(Z*56|0)+8>>2]);g[C>>2]=ea(g[Y+(Z*56|0)+12>>2]);g[D>>2]=ea(g[Y+(Z*56|0)+16>>2]);g[E>>2]=ea(g[Y+(Z*56|0)+20>>2]);g[F>>2]=ea(g[Y+(Z*56|0)+24>>2]);Z=X|3;g[G>>2]=ea(g[Y+(Z*56|0)>>2]);g[H>>2]=ea(g[Y+(Z*56|0)+4>>2]);g[I>>2]=ea(g[Y+(Z*56|0)+8>>2]);g[J>>2]=ea(g[Y+(Z*56|0)+12>>2]);g[K>>2]=ea(g[Y+(Z*56|0)+16>>2]);g[L>>2]=ea(g[Y+(Z*56|0)+20>>2]);g[M>>2]=ea(g[Y+(Z*56|0)+24>>2]);Z=c[V>>2]|0;Y=c[k+(W<<2)>>2]|0;kn[c[(c[P>>2]|0)+108>>2]&511](P,h,128,0)|0;if(Y){X=0;do{_=a[Z+(W*944|0)+X+928>>0]|0;$=_<<24>>24==-1;aa=$?-1:_&255;if(!$){if((aa|0)<128)ba=c[h+(aa<<2)>>2]|0;else{kn[c[(c[P>>2]|0)+108>>2]&511](P,j,1,aa)|0;ba=c[j>>2]|0}In[c[(c[ba>>2]|0)+68>>2]&4095](ba,l+(X*28|0)|0)}X=X+1|0}while((X|0)!=(Y|0))}W=W+1|0}while((W|0)!=(S|0))}if(R){S=0;do{W=c[Q>>2]|0;P=c[W+(S*56|0)+28>>2]|0;if(P)oU(P,W+(S*56|0)+32|0,W+(S*56|0)+44|0,0,1);S=S+1|0}while((S|0)!=(R|0))}}N=N+1|0}while((N|0)!=(d|0));i=f;return}function AEa(a,b,c,d,e,f,g){a=ea(a);b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;yEa(a,b,c,d,e,f,g);i=h;return}function BEa(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=0;m=i;i=i+96|0;n=m+52|0;o=m+24|0;p=m+12|0;q=m;r=m+80|0;In[c[(c[l>>2]|0)+84>>2]&4095](n,l);In[c[(c[l>>2]|0)+124>>2]&4095](o,l);s=ea(ea(g[o+16>>2])*ea(2.0));t=ea(ea(g[o+20>>2])*ea(2.0));u=ea(ea(g[o+24>>2])*ea(2.0));v=ea(g[n+12>>2]);w=ea(ea(v*v)+ea(-.5));x=ea(g[n>>2]);y=ea(s*x);z=ea(g[n+4>>2]);A=ea(y+ea(t*z));y=ea(g[n+8>>2]);B=ea(A+ea(u*y));A=ea(ea(x*B)+ea(ea(s*w)+ea(v*ea(ea(u*z)-ea(t*y)))));C=ea(ea(z*B)+ea(ea(t*w)+ea(v*ea(ea(s*y)-ea(u*x)))));D=ea(ea(ea(u*w)+ea(v*ea(ea(t*x)-ea(s*z))))+ea(y*B));B=ea(ea(g[n+16>>2])+A);A=ea(ea(g[n+20>>2])+C);C=ea(ea(g[n+24>>2])+D);D=ea(g[o>>2]);s=ea(v*D);t=ea(g[o+12>>2]);w=ea(s+ea(x*t));s=ea(g[o+8>>2]);u=ea(w+ea(z*s));w=ea(g[o+4>>2]);E=ea(u-ea(y*w));u=ea(ea(ea(y*D)+ea(ea(z*t)+ea(v*w)))-ea(x*s));F=ea(ea(ea(x*w)+ea(ea(y*t)+ea(v*s)))-ea(z*D));G=ea(ea(ea(ea(v*t)-ea(x*D))-ea(z*w))-ea(y*s));if(!k){i=m;return}s=ea(ea(G*G)+ea(-.5));o=q+4|0;n=q+8|0;l=p+4|0;H=p+8|0;I=f+80|0;J=f+128|0;K=f+176|0;f=0;do{y=ea(g[e+(f*12|0)+784>>2]);w=ea(g[e+(f*12|0)+788>>2]);z=ea(g[e+(f*12|0)+792>>2]);D=ea(g[e+(f*48|0)+12>>2]);x=ea(g[e+(f*48|0)+8>>2]);t=ea(g[e+(f*48|0)+192>>2]);if(!(a[j+f>>0]|0)){v=ea(ea(g[129520])*ea(9.99999974e-06));L=ea(0.0);M=ea(0.0);N=ea(0.0);O=v;P=v;Q=v}else{L=y;M=w;N=z;O=x;P=D;Q=t}t=ea(ea(g[e+(f*12|0)+640>>2])*ea(2.0));D=ea(ea(g[e+(f*12|0)+644>>2])*ea(2.0));x=ea(ea(g[e+(f*12|0)+648>>2])*ea(2.0));z=ea(ea(ea(E*t)+ea(u*D))+ea(F*x));w=ea(ea(E*z)+ea(ea(s*t)+ea(G*ea(ea(u*x)-ea(F*D)))));y=ea(ea(u*z)+ea(ea(s*D)+ea(G*ea(ea(F*t)-ea(E*x)))));v=ea(ea(ea(s*x)+ea(G*ea(ea(E*D)-ea(u*t))))+ea(F*z));g[q>>2]=w;g[o>>2]=y;g[n>>2]=v;z=ea(L*ea(2.0));t=ea(M*ea(2.0));D=ea(N*ea(2.0));x=ea(ea(F*D)+ea(ea(u*t)+ea(E*z)));R=ea(A+ea(ea(u*x)+ea(ea(s*t)+ea(G*ea(ea(F*z)-ea(E*D))))));S=ea(C+ea(ea(ea(s*D)+ea(G*ea(ea(E*t)-ea(u*z))))+ea(F*x)));T=ea(O+Q);U=ea(T*y);V=ea(T*v);W=ea(ea(B+ea(ea(ea(s*z)+ea(G*ea(ea(u*D)-ea(F*t))))+ea(E*x)))-ea(T*w));g[p>>2]=W;x=ea(R-U);g[l>>2]=x;U=ea(S-V);g[H>>2]=U;V=ea(Q+ea(Q+ea(T+P)));g[I+(f*12|0)>>2]=W;g[I+(f*12|0)+4>>2]=x;g[I+(f*12|0)+8>>2]=U;g[J+(f*12|0)>>2]=w;g[J+(f*12|0)+4>>2]=y;g[J+(f*12|0)+8>>2]=v;g[K+(f<<2)>>2]=V;X=c[(c[d>>2]|0)+44>>2]|0;b[r>>1]=15;Lo[X&1](d,p,q,V,0,r,h+(f*20|0)|0,0,0);f=f+1|0}while((f|0)!=(k|0));i=m;return}function CEa(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+96|0;l=k+8|0;m=k+4|0;n=k;if(g){o=0;do{a[h+(o*80|0)+77>>0]=0;o=o+1|0}while((o|0)!=(g|0))};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;a[l+18>>0]=0;o=l+20|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;a[l+38>>0]=0;o=l+40|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;a[l+58>>0]=0;o=l+60|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;a[l+78>>0]=0;b[l+16>>1]=7;b[l+36>>1]=7;b[l+56>>1]=7;b[l+76>>1]=7;if(!e){p=c[d>>2]|0;q=c[p>>2]|0;ko[q&4095](d);i=k;return}o=l+40|0;r=l+20|0;s=(j|0)==0;t=h+(g*80|0)|0;g=n+3|0;u=n+2|0;v=n+1|0;w=l+60|0;x=m+3|0;y=m+2|0;z=m+1|0;A=0;B=h;while(1){h=c[f+(A<<2)>>2]|0;C=c[h+40>>2]|0;D=c[h+72>>2]|0;E=c[h+48>>2]|0;F=E>>>2;G=F<<2;H=E-G|0;I=c[h+104>>2]|0;if(!F)J=B;else{K=j+A|0;L=0;M=B;while(1){c[m>>2]=0;N=c[h+((L>>>3&134217727)<<2)+52>>2]|0;O=L<<2&28;if(N&1<<O)a[m>>0]=1;if(N&1<<(O|1))a[z>>0]=1;if(N&1<<(O|2))a[y>>0]=1;if(N&1<<(O|3))a[x>>0]=1;O=D+(L*208|0)|0;N=D+(L*208|0)+196|0;c[N>>2]=0;if(!s?(a[K>>0]|0)==0:0)P=M;else{Q=M+320|0;if(t>>>0<Q>>>0)P=Q;else{R=C+(L*944|0)+864|0;c[l+0>>2]=c[R+0>>2];c[l+4>>2]=c[R+4>>2];c[l+8>>2]=c[R+8>>2];c[l+12>>2]=c[R+12>>2];R=C+(L*944|0)+880|0;c[r+0>>2]=c[R+0>>2];c[r+4>>2]=c[R+4>>2];c[r+8>>2]=c[R+8>>2];c[r+12>>2]=c[R+12>>2];R=C+(L*944|0)+896|0;c[o+0>>2]=c[R+0>>2];c[o+4>>2]=c[R+4>>2];c[o+8>>2]=c[R+8>>2];c[o+12>>2]=c[R+12>>2];R=C+(L*944|0)+912|0;c[w+0>>2]=c[R+0>>2];c[w+4>>2]=c[R+4>>2];c[w+8>>2]=c[R+8>>2];c[w+12>>2]=c[R+12>>2];c[N>>2]=M;BEa(d,C+(L*944|0)|0,O,l,m,4,I);P=Q}}L=L+1|0;if(L>>>0>=F>>>0){J=P;break}else M=P}}do if((E|0)!=(G|0)){c[n>>2]=0;M=c[h+(E>>>5<<2)+52>>2]|0;L=G&28;if(M&1<<L)a[n>>0]=1;if(M&1<<(L|1))a[v>>0]=1;if(M&1<<(L|2))a[u>>0]=1;if(M&1<<(L|3))a[g>>0]=1;L=D+(F*208|0)|0;M=D+(F*208|0)+196|0;c[M>>2]=0;if(!s?(a[j+A>>0]|0)==0:0){S=J;break}K=J+(H*80|0)|0;if(t>>>0<K>>>0)S=K;else{Q=C+(F*944|0)+864|0;c[l+0>>2]=c[Q+0>>2];c[l+4>>2]=c[Q+4>>2];c[l+8>>2]=c[Q+8>>2];c[l+12>>2]=c[Q+12>>2];if(H>>>0>1?(Q=C+(F*944|0)+880|0,c[r+0>>2]=c[Q+0>>2],c[r+4>>2]=c[Q+4>>2],c[r+8>>2]=c[Q+8>>2],c[r+12>>2]=c[Q+12>>2],H>>>0>2):0){Q=C+(F*944|0)+896|0;c[o+0>>2]=c[Q+0>>2];c[o+4>>2]=c[Q+4>>2];c[o+8>>2]=c[Q+8>>2];c[o+12>>2]=c[Q+12>>2]}c[M>>2]=J;BEa(d,C+(F*944|0)|0,L,l,n,H,I);S=K}}else S=J;while(0);A=A+1|0;if((A|0)==(e|0))break;else B=S}p=c[d>>2]|0;q=c[p>>2]|0;ko[q&4095](d);i=k;return}function DEa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;CEa(a,b,c,d,e,f);i=g;return}function EEa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+48|0;e=d+16|0;f=d;h=(b+3|0)>>>2;j=UJa(d+32|0,(h*944|0)+64|0,518176,66)|0;k=j+64|0;l=j+32|0;c[l>>2]=k;c[j+36>>2]=h;c[j+40>>2]=b;a:do if(h){m=k;n=0;while(1){o=m+(n*944|0)|0;if(o)SDa(o);o=n+1|0;if(o>>>0>=h>>>0)break a;m=c[l>>2]|0;n=o}}while(0);if(j){g[j>>2]=ea(0.0);g[j+4>>2]=ea(.230800003);g[j+8>>2]=ea(3.0);g[j+12>>2]=ea(3.0);g[j+16>>2]=ea(.333333343)}k=j+44|0;a[k>>0]=0;a[k+1>>0]=0;a[k+2>>0]=0;a[k+3>>0]=0;if(b){k=0;do{n=j+(k>>>5<<2)+44|0;c[n>>2]=c[n>>2]|1<<(k&31);n=k>>>2;m=k&3;_Da((c[l>>2]|0)+(n*944|0)|0,m,k);c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;$Da((c[l>>2]|0)+(n*944|0)|0,m,e);k=k+1|0}while((k|0)!=(b|0))}if(h<<2>>>0<=b>>>0){p=j+48|0;g[p>>2]=ea(5.0);q=j+52|0;c[q>>2]=3;r=j+56|0;c[r>>2]=1;s=j+60|0;g[s>>2]=ea(4.0);i=d;return j|0}k=h<<2;h=b;do{b=j+(h>>>5<<2)+44|0;c[b>>2]=c[b>>2]&~(1<<(h&31));b=h>>>2;e=h&3;_Da((c[l>>2]|0)+(b*944|0)|0,e,-1);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;$Da((c[l>>2]|0)+(b*944|0)|0,e,f);h=h+1|0}while((h|0)!=(k|0));p=j+48|0;g[p>>2]=ea(5.0);q=j+52|0;c[q>>2]=3;r=j+56|0;c[r>>2]=1;s=j+60|0;g[s>>2]=ea(4.0);i=d;return j|0}function FEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;_Da((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function GEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;$Da((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function HEa(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=Im,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+48|0;e=d;f=a+40|0;h=c[f>>2]|0;j=ea(ea(ea(1.0)/ea(h>>>0))*b);if(!h){i=d;return}h=a+32|0;a=e+16|0;b=ea(j*ea(93.3155975));k=ea(ea(j*ea(1.24000001))*ea(9.65999984));l=e+4|0;m=0;do{n=m>>>2;o=c[h>>2]|0;p=m&3;q=e+0|0;r=o+(n*944|0)+(p*48|0)+0|0;s=q+48|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));g[a>>2]=j;g[e>>2]=b;g[l>>2]=k;TDa(o+(n*944|0)|0,p,e);m=m+1|0}while(m>>>0<(c[f>>2]|0)>>>0);i=d;return}function IEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)*48|0)|0}function JEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;TDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function KEa(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function LEa(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;h=e+36|0;if(!(c[h>>2]|0)){c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];c[b+16>>2]=c[e+16>>2];c[b+20>>2]=c[e+20>>2];c[b+24>>2]=c[e+24>>2];c[b+28>>2]=c[e+28>>2];j=e+48|0;k=ea(g[j>>2]);l=b+48|0;g[l>>2]=k;m=e+52|0;n=c[m>>2]|0;o=b+52|0;c[o>>2]=n;p=e+56|0;q=c[p>>2]|0;r=b+56|0;c[r>>2]=q;s=e+60|0;t=ea(g[s>>2]);u=b+60|0;g[u>>2]=t;v=b+44|0;w=e+44|0;x=d[w>>0]|d[w+1>>0]<<8|d[w+2>>0]<<16|d[w+3>>0]<<24;a[v>>0]=x;a[v+1>>0]=x>>8;a[v+2>>0]=x>>16;a[v+3>>0]=x>>24;i=f;return b|0}y=b+32|0;z=e+32|0;A=0;do{B=c[y>>2]|0;C=c[z>>2]|0;YEi(B+(A*944|0)|0,C+(A*944|0)|0,640)|0;g[B+(A*944|0)+640>>2]=ea(g[C+(A*944|0)+640>>2]);g[B+(A*944|0)+644>>2]=ea(g[C+(A*944|0)+644>>2]);g[B+(A*944|0)+648>>2]=ea(g[C+(A*944|0)+648>>2]);g[B+(A*944|0)+652>>2]=ea(g[C+(A*944|0)+652>>2]);g[B+(A*944|0)+656>>2]=ea(g[C+(A*944|0)+656>>2]);g[B+(A*944|0)+660>>2]=ea(g[C+(A*944|0)+660>>2]);g[B+(A*944|0)+664>>2]=ea(g[C+(A*944|0)+664>>2]);g[B+(A*944|0)+668>>2]=ea(g[C+(A*944|0)+668>>2]);g[B+(A*944|0)+672>>2]=ea(g[C+(A*944|0)+672>>2]);g[B+(A*944|0)+676>>2]=ea(g[C+(A*944|0)+676>>2]);g[B+(A*944|0)+680>>2]=ea(g[C+(A*944|0)+680>>2]);g[B+(A*944|0)+684>>2]=ea(g[C+(A*944|0)+684>>2]);g[B+(A*944|0)+688>>2]=ea(g[C+(A*944|0)+688>>2]);g[B+(A*944|0)+692>>2]=ea(g[C+(A*944|0)+692>>2]);g[B+(A*944|0)+696>>2]=ea(g[C+(A*944|0)+696>>2]);g[B+(A*944|0)+700>>2]=ea(g[C+(A*944|0)+700>>2]);g[B+(A*944|0)+704>>2]=ea(g[C+(A*944|0)+704>>2]);g[B+(A*944|0)+708>>2]=ea(g[C+(A*944|0)+708>>2]);g[B+(A*944|0)+712>>2]=ea(g[C+(A*944|0)+712>>2]);g[B+(A*944|0)+716>>2]=ea(g[C+(A*944|0)+716>>2]);g[B+(A*944|0)+720>>2]=ea(g[C+(A*944|0)+720>>2]);g[B+(A*944|0)+724>>2]=ea(g[C+(A*944|0)+724>>2]);g[B+(A*944|0)+728>>2]=ea(g[C+(A*944|0)+728>>2]);g[B+(A*944|0)+732>>2]=ea(g[C+(A*944|0)+732>>2]);g[B+(A*944|0)+736>>2]=ea(g[C+(A*944|0)+736>>2]);g[B+(A*944|0)+740>>2]=ea(g[C+(A*944|0)+740>>2]);g[B+(A*944|0)+744>>2]=ea(g[C+(A*944|0)+744>>2]);g[B+(A*944|0)+748>>2]=ea(g[C+(A*944|0)+748>>2]);g[B+(A*944|0)+752>>2]=ea(g[C+(A*944|0)+752>>2]);g[B+(A*944|0)+756>>2]=ea(g[C+(A*944|0)+756>>2]);g[B+(A*944|0)+760>>2]=ea(g[C+(A*944|0)+760>>2]);g[B+(A*944|0)+764>>2]=ea(g[C+(A*944|0)+764>>2]);g[B+(A*944|0)+768>>2]=ea(g[C+(A*944|0)+768>>2]);g[B+(A*944|0)+772>>2]=ea(g[C+(A*944|0)+772>>2]);g[B+(A*944|0)+776>>2]=ea(g[C+(A*944|0)+776>>2]);g[B+(A*944|0)+780>>2]=ea(g[C+(A*944|0)+780>>2]);g[B+(A*944|0)+784>>2]=ea(g[C+(A*944|0)+784>>2]);g[B+(A*944|0)+788>>2]=ea(g[C+(A*944|0)+788>>2]);g[B+(A*944|0)+792>>2]=ea(g[C+(A*944|0)+792>>2]);g[B+(A*944|0)+796>>2]=ea(g[C+(A*944|0)+796>>2]);g[B+(A*944|0)+800>>2]=ea(g[C+(A*944|0)+800>>2]);g[B+(A*944|0)+804>>2]=ea(g[C+(A*944|0)+804>>2]);g[B+(A*944|0)+808>>2]=ea(g[C+(A*944|0)+808>>2]);g[B+(A*944|0)+812>>2]=ea(g[C+(A*944|0)+812>>2]);g[B+(A*944|0)+816>>2]=ea(g[C+(A*944|0)+816>>2]);g[B+(A*944|0)+820>>2]=ea(g[C+(A*944|0)+820>>2]);g[B+(A*944|0)+824>>2]=ea(g[C+(A*944|0)+824>>2]);g[B+(A*944|0)+828>>2]=ea(g[C+(A*944|0)+828>>2]);D=B+(A*944|0)+832|0;B=C+(A*944|0)+832|0;C=D+112|0;do{c[D>>2]=c[B>>2];D=D+4|0;B=B+4|0}while((D|0)<(C|0));A=A+1|0}while(A>>>0<(c[h>>2]|0)>>>0);c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];c[b+16>>2]=c[e+16>>2];c[b+20>>2]=c[e+20>>2];c[b+24>>2]=c[e+24>>2];c[b+28>>2]=c[e+28>>2];j=e+48|0;k=ea(g[j>>2]);l=b+48|0;g[l>>2]=k;m=e+52|0;n=c[m>>2]|0;o=b+52|0;c[o>>2]=n;p=e+56|0;q=c[p>>2]|0;r=b+56|0;c[r>>2]=q;s=e+60|0;t=ea(g[s>>2]);u=b+60|0;g[u>>2]=t;v=b+44|0;w=e+44|0;x=d[w>>0]|d[w+1>>0]<<8|d[w+2>>0]<<16|d[w+3>>0]<<24;a[v>>0]=x;a[v+1>>0]=x>>8;a[v+2>>0]=x>>16;a[v+3>>0]=x>>24;i=f;return b|0}function MEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;UDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function NEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)*48|0)+192|0}function OEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;VDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function PEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)<<6)+384|0}function QEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;WDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function REa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)*12|0)+640|0}function SEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;XDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function TEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)*12|0)+688|0}function UEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;YDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function VEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)*12|0)+736|0}function WEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;ZDa((c[a+32>>2]|0)+((b>>>2)*944|0)|0,b&3,d);i=e;return}function XEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)*12|0)+784|0}function YEa(b,d){b=b|0;d=d|0;var e=0;e=a[(d&3)+((c[b+32>>2]|0)+((d>>>2)*944|0))+928>>0]|0;return (e<<24>>24==-1?-1:e&255)|0}function ZEa(a,b){a=a|0;b=b|0;return (c[a+32>>2]|0)+((b>>>2)*944|0)+((b&3)<<4)+864|0}function _Ea(a,b){a=a|0;b=b|0;return (c[a+(b>>>5<<2)+44>>2]&1<<(b&31)|0)==0|0}function $Ea(a,b){a=a|0;b=b|0;var d=Im;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];d=ea(g[a+8>>2]);g[a+16>>2]=ea(ea(1.0)/ea(d-ea(g[a>>2])));return}function aFa(a,b){a=a|0;b=ea(b);g[a+60>>2]=b;return}function bFa(a,b){a=a|0;b=b|0;c[(c[a+4>>2]|0)+4>>2]=b;return}function cFa(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0;e=b>>>2;f=c[a>>2]|0;a=b&3;g[f+(e*208|0)+(a<<2)>>2]=d;g[f+(e*208|0)+(a<<2)+16>>2]=d;return}function dFa(a,b){a=a|0;b=b|0;var d=Im;d=ea(g[(c[a>>2]|0)+((b>>>2)*208|0)+((b&3)<<2)+16>>2]);return ea(d)}function eFa(a,b,d){a=a|0;b=b|0;d=ea(d);g[(c[a>>2]|0)+((b>>>2)*208|0)+((b&3)<<2)+32>>2]=d;return}function fFa(a,b){a=a|0;b=b|0;var d=Im;d=ea(g[(c[a>>2]|0)+((b>>>2)*208|0)+((b&3)<<2)+32>>2]);return ea(d)}function gFa(a){a=a|0;return (a*1152|16)+(a*368|0)+(a<<5)|0}function hFa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+32|0;k=j+16|0;l=j;c[b+44>>2]=e;c[b+84>>2]=e;c[b+48>>2]=f;c[b+64>>2]=1;c[b+60>>2]=3;g[b+56>>2]=ea(5.0);c[b+88>>2]=f;a[b+112>>0]=e;m=b+40|0;c[m>>2]=d;n=b+72|0;c[n>>2]=d+(e*944|0);o=e*1152|0;p=d+o|0;q=b+76|0;c[q>>2]=p;r=o|16;c[p>>2]=d+r;p=e<<4;o=r+p|0;s=b+80|0;c[s>>2]=d+o;t=(e|0)==0;if(!t){u=0;v=d+(o+p)|0;while(1){c[(c[n>>2]|0)+(u*208|0)+192>>2]=v;u=u+1|0;if((u|0)==(e|0))break;else v=v+368|0}}if(h){if(!t){v=0;do{u=(c[m>>2]|0)+(v*944|0)|0;if(u)SDa(u);v=v+1|0}while((v|0)!=(e|0));if(!t){v=0;do{u=c[n>>2]|0;p=u+(v*208|0)|0;if(p){c[u+(v*208|0)+196>>2]=0;a[u+(v*208|0)+200>>0]=0;PEi(p|0,0,192)|0}v=v+1|0}while((v|0)!=(e|0));v=e<<2;if(!v)w=0;else{p=e<<2;u=0;do{c[(c[c[q>>2]>>2]|0)+(u<<2)>>2]=0;c[(c[s>>2]|0)+(u<<2)>>2]=0;u=u+1|0}while((u|0)!=(p|0));w=v}}else x=10}else x=10;if((x|0)==10)w=e<<2;if(f){x=0;do{c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;v=x>>>2;p=x&3;$Da((c[m>>2]|0)+(v*944|0)|0,p,k);_Da((c[m>>2]|0)+(v*944|0)|0,p,x);x=x+1|0}while((x|0)!=(f|0))}if(w>>>0>f>>>0){w=e<<2;x=f;do{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;f=x>>>2;k=x&3;$Da((c[m>>2]|0)+(f*944|0)|0,k,l);_Da((c[m>>2]|0)+(f*944|0)|0,k,-1);x=x+1|0}while((x|0)!=(w|0))}g[b+8>>2]=ea(0.0);g[b+12>>2]=ea(.230800003);g[b+16>>2]=ea(3.0);g[b+20>>2]=ea(3.0);g[b+24>>2]=ea(.333333343)}if(!t)if(h){h=0;do{t=c[(c[n>>2]|0)+(h*208|0)+192>>2]|0;if(t){c[t>>2]=518296;c[t+352>>2]=0;c[t+356>>2]=b}h=h+1|0}while((h|0)!=(e|0))}else{h=0;do{t=c[(c[n>>2]|0)+(h*208|0)+192>>2]|0;if(t){w=c[t+352>>2]|0;c[t>>2]=518296;c[t+352>>2]=w;c[t+356>>2]=b}h=h+1|0}while((h|0)!=(e|0))}h=c[q>>2]|0;if(!h){y=e*400|0;z=y+r|0;A=d+z|0;i=j;return A|0}c[h+4>>2]=1;y=e*400|0;z=y+r|0;A=d+z|0;i=j;return A|0}function iFa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+44>>2]|0;if(!d){i=b;return}e=a+72|0;a=0;do{f=c[(c[(c[e>>2]|0)+(a*208|0)+192>>2]|0)+352>>2]|0;if(f)ko[c[c[f>>2]>>2]&4095](f);a=a+1|0}while((a|0)!=(d|0));i=b;return}function jFa(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im;h=i;i=i+64|0;k=h+32|0;l=h+4|0;m=h;c[b+108>>2]=j;LEa(b+8|0,f)|0;j=b+104|0;c[j>>2]=e;n=c[f+36>>2]|0;o=(n|0)==0;if(!o){p=b+72|0;q=0;do{c[(c[p>>2]|0)+(q*208|0)+196>>2]=0;q=q+1|0}while((q|0)!=(n|0));if(!o){o=b+72|0;q=f+32|0;p=0;do{r=c[(c[o>>2]|0)+(p*208|0)+192>>2]|0;s=c[q>>2]|0;t=0;do{g[r+(t*12|0)+4>>2]=ea(g[s+(p*944|0)+(t*12|0)+688>>2]);g[r+(t*12|0)+8>>2]=ea(g[s+(p*944|0)+(t*12|0)+692>>2]);g[r+(t*12|0)+12>>2]=ea(g[s+(p*944|0)+(t*12|0)+696>>2]);g[r+(t*12|0)+52>>2]=ea(g[s+(p*944|0)+(t*12|0)+640>>2]);g[r+(t*12|0)+56>>2]=ea(g[s+(p*944|0)+(t*12|0)+644>>2]);g[r+(t*12|0)+60>>2]=ea(g[s+(p*944|0)+(t*12|0)+648>>2]);g[r+(t<<2)+100>>2]=ea(0.0);a[r+t+116>>0]=0;g[r+(t*12|0)+120>>2]=ea(0.0);g[r+(t*12|0)+124>>2]=ea(0.0);g[r+(t*12|0)+128>>2]=ea(0.0);g[r+(t*12|0)+168>>2]=ea(0.0);g[r+(t*12|0)+172>>2]=ea(0.0);g[r+(t*12|0)+176>>2]=ea(0.0);g[r+(t<<2)+216>>2]=ea(0.0);a[r+t+232>>0]=0;g[r+(t*12|0)+236>>2]=ea(0.0);g[r+(t*12|0)+240>>2]=ea(0.0);g[r+(t*12|0)+244>>2]=ea(0.0);g[r+(t*12|0)+284>>2]=ea(0.0);g[r+(t*12|0)+288>>2]=ea(0.0);g[r+(t*12|0)+292>>2]=ea(0.0);g[r+(t<<2)+332>>2]=ea(0.0);a[r+t+348>>0]=0;t=t+1|0}while((t|0)!=4);t=Km[c[(c[d>>2]|0)+136>>2]&127](d,e,0,r,518264,348)|0;c[r+352>>2]=t;ko[c[(c[t>>2]|0)+36>>2]&4095](t);p=p+1|0}while((p|0)!=(n|0))}}n=f+40|0;f=c[n>>2]|0;if(!f)u=0;else{p=b+40|0;e=b+76|0;d=0;do{c[(c[c[e>>2]>>2]|0)+(d<<2)>>2]=(c[p>>2]|0)+((d>>>2)*944|0)+((d&3)<<6)+384;d=d+1|0}while(d>>>0<f>>>0);u=f}f=b+44|0;if(u>>>0<c[f>>2]<<2>>>0){d=u;do{p=b+(d>>>5<<2)+52|0;c[p>>2]=c[p>>2]&~(1<<(d&31));d=d+1|0}while(d>>>0<c[f>>2]<<2>>>0);v=c[n>>2]|0}else v=u;if(!v){i=h;return}u=b+40|0;b=l+4|0;f=k+4|0;d=l+8|0;p=k+8|0;e=l+12|0;q=k+12|0;o=l+16|0;t=k+16|0;s=l+20|0;w=k+20|0;x=l+24|0;y=k+24|0;z=v;v=0;while(1){A=v>>>2;B=v&3;C=a[(c[u>>2]|0)+(A*944|0)+B+928>>0]|0;if(C<<24>>24==-1)D=z;else{E=c[j>>2]|0;In[c[(c[E>>2]|0)+124>>2]&4095](k,E);g[l>>2]=ea(g[k>>2]);g[b>>2]=ea(g[f>>2]);g[d>>2]=ea(g[p>>2]);g[e>>2]=ea(g[q>>2]);F=ea(g[t>>2]);g[o>>2]=F;G=ea(g[w>>2]);g[s>>2]=G;H=ea(g[y>>2]);g[x>>2]=H;E=c[u>>2]|0;g[o>>2]=ea(ea(g[E+(A*944|0)+(B*12|0)+784>>2])+F);g[s>>2]=ea(ea(g[E+(A*944|0)+(B*12|0)+788>>2])+G);g[x>>2]=ea(ea(g[E+(A*944|0)+(B*12|0)+792>>2])+H);B=c[j>>2]|0;kn[c[(c[B>>2]|0)+108>>2]&511](B,m,1,C&255)|0;C=c[m>>2]|0;In[c[(c[C>>2]|0)+68>>2]&4095](C,l);D=c[n>>2]|0}v=v+1|0;if(v>>>0>=D>>>0)break;else z=D}i=h;return}function kFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;In[c[(c[b>>2]|0)+8>>2]&4095](b,c[a+104>>2]|0);e=a+44|0;if(!(c[e>>2]|0)){i=d;return}f=a+72|0;a=0;do{In[c[(c[b>>2]|0)+8>>2]&4095](b,c[(c[(c[f>>2]|0)+(a*208|0)+192>>2]|0)+352>>2]|0);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=d;return}function lFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+104|0;f=c[e>>2]|0;if(f)c[e>>2]=xo[c[c[b>>2]>>2]&2047](b,-2147483648,f)|0;f=a+44|0;if(c[f>>2]|0){e=a+72|0;g=0;do{h=c[(c[e>>2]|0)+(g*208|0)+192>>2]|0;j=h+352|0;k=c[j>>2]|0;if(!k)l=0;else l=xo[c[c[b>>2]>>2]&2047](b,-2147483648,k)|0;co[c[(c[l>>2]|0)+76>>2]&2047](l,h,518264);c[j>>2]=l;g=g+1|0}while(g>>>0<(c[f>>2]|0)>>>0)}f=c[a+48>>2]|0;if(!f){i=d;return}g=a+40|0;l=a+76|0;a=0;do{c[(c[c[l>>2]>>2]|0)+(a<<2)>>2]=(c[g>>2]|0)+((a>>>2)*944|0)+((a&3)<<6)+384;a=a+1|0}while(a>>>0<f>>>0);i=d;return}function mFa(a,b){a=a|0;b=b|0;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function nFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;var g=0;g=i;iEa(a,b,c,d,e,f);i=g;return}function oFa(a){a=a|0;var b=Im;b=ea(g[a+104>>2]);return ea(b)}function pFa(a){a=a|0;var b=Im;b=ea(g[a+108>>2]);return ea(b)}function qFa(a){a=a|0;var b=0;b=i;c[a>>2]=518352;c[a+4>>2]=516;c[a+8>>2]=152;c[a+12>>2]=518368;c[a+16>>2]=517;c[a+20>>2]=153;QHa(a+24|0);c[a+48>>2]=518336;c[a+52>>2]=519;c[a+56>>2]=154;c[a+60>>2]=128;c[a+64>>2]=518384;c[a+68>>2]=520;c[a+72>>2]=155;c[a+76>>2]=129;c[a+80>>2]=518400;c[a+84>>2]=521;c[a+88>>2]=156;c[a+92>>2]=130;c[a+96>>2]=518416;c[a+100>>2]=522;c[a+104>>2]=157;c[a+108>>2]=131;c[a+112>>2]=518448;c[a+116>>2]=523;c[a+120>>2]=158;c[a+124>>2]=132;c[a+128>>2]=518488;c[a+132>>2]=524;c[a+136>>2]=159;c[a+140>>2]=133;i=b;return}function rFa(a,b,c){a=a|0;b=b|0;c=ea(c);g[a+(b<<2)>>2]=c;return}function sFa(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+(b<<2)>>2]);return ea(c)}function tFa(a){a=a|0;c[a>>2]=518536;c[a+4>>2]=527;c[a+8>>2]=28;c[a+12>>2]=37;c[a+16>>2]=518552;c[a+20>>2]=528;c[a+24>>2]=160;c[a+28>>2]=134;c[a+32>>2]=518568;c[a+36>>2]=529;c[a+40>>2]=3510;c[a+44>>2]=2609;c[a+48>>2]=518584;c[a+52>>2]=530;c[a+56>>2]=161;c[a+60>>2]=135;return}function uFa(a,b){a=a|0;b=ea(b);g[a+128>>2]=b;return}function vFa(a){a=a|0;var b=Im;b=ea(g[a+128>>2]);return ea(b)}function wFa(a,b,c){a=a|0;b=b|0;c=ea(c);g[a+(b<<2)>>2]=c;return}function xFa(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+(b<<2)>>2]);return ea(c)}function yFa(a,b,c){a=a|0;b=b|0;c=ea(c);g[a+(b<<2)+128>>2]=c;return}function zFa(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+(b<<2)+128>>2]);return ea(c)}function AFa(a){a=a|0;c[a>>2]=518600;c[a+4>>2]=533;c[a+8>>2]=162;c[a+12>>2]=136;c[a+16>>2]=518608;c[a+20>>2]=534;c[a+24>>2]=29;c[a+28>>2]=38;c[a+32>>2]=518624;c[a+36>>2]=535;c[a+40>>2]=30;c[a+44>>2]=39;return}function BFa(a){a=a|0;c[a>>2]=518640;c[a+4>>2]=538;c[a+8>>2]=163;c[a+12>>2]=137;c[a+16>>2]=518656;c[a+20>>2]=539;c[a+24>>2]=164;c[a+28>>2]=138;c[a+32>>2]=518680;c[a+36>>2]=540;c[a+40>>2]=165;c[a+44>>2]=139;c[a+48>>2]=518704;c[a+52>>2]=541;c[a+56>>2]=166;c[a+60>>2]=140;c[a+64>>2]=518720;c[a+68>>2]=542;c[a+72>>2]=167;c[a+76>>2]=141;c[a+80>>2]=518736;c[a+84>>2]=543;c[a+88>>2]=168;c[a+92>>2]=142;c[a+96>>2]=518752;c[a+100>>2]=544;c[a+104>>2]=3511;c[a+108>>2]=2610;return}function CFa(a,b){a=a|0;b=b|0;var c=0;c=i;GCa(a,b);i=c;return}function DFa(a){a=a|0;var b=0,c=0;b=i;c=FCa(a)|0;i=b;return c|0}function EFa(a){a=a|0;c[a>>2]=518760;c[a+4>>2]=547;c[a+8>>2]=3512;c[a+12>>2]=2611;return}function FFa(a){a=a|0;c[a>>2]=518784;c[a+4>>2]=550;c[a+8>>2]=169;c[a+12>>2]=143;c[a+16>>2]=518800;c[a+20>>2]=551;c[a+24>>2]=170;c[a+28>>2]=144;c[a+32>>2]=518816;c[a+36>>2]=552;c[a+40>>2]=171;c[a+44>>2]=145;c[a+48>>2]=518832;c[a+52>>2]=553;c[a+56>>2]=172;c[a+60>>2]=146;return}function GFa(a){a=a|0;c[a>>2]=518848;c[a+4>>2]=556;c[a+8>>2]=173;c[a+12>>2]=147;c[a+16>>2]=518864;c[a+20>>2]=557;c[a+24>>2]=3513;c[a+28>>2]=2612;c[a+32>>2]=518880;c[a+36>>2]=558;c[a+40>>2]=3514;c[a+44>>2]=2613;return}function HFa(a){a=a|0;var b=Im;b=ea(g[a+16>>2]);return ea(b)}function IFa(a){a=a|0;c[a>>2]=518904;c[a+4>>2]=561;c[a+8>>2]=174;c[a+12>>2]=518920;c[a+16>>2]=562;c[a+20>>2]=175;c[a+24>>2]=148;c[a+28>>2]=518944;c[a+32>>2]=563;c[a+36>>2]=176;c[a+40>>2]=149;c[a+44>>2]=518976;c[a+48>>2]=564;c[a+52>>2]=177;c[a+56>>2]=150;c[a+60>>2]=519e3;c[a+64>>2]=565;c[a+68>>2]=178;c[a+72>>2]=151;return}function JFa(a){a=a|0;var b=Im;b=ea(g[a+36>>2]);return ea(b)}function KFa(a){a=a|0;var b=Im;b=ea(g[a+40>>2]);return ea(b)}function LFa(a){a=a|0;c[a>>2]=519032;c[a+4>>2]=568;c[a+8>>2]=179;c[a+12>>2]=518352;c[a+16>>2]=569;c[a+20>>2]=180;c[a+24>>2]=519048;c[a+28>>2]=570;c[a+32>>2]=181;c[a+36>>2]=152;c[a+40>>2]=519056;c[a+44>>2]=571;c[a+48>>2]=182;c[a+52>>2]=153;c[a+56>>2]=518344;c[a+60>>2]=572;c[a+64>>2]=183;c[a+68>>2]=154;c[a+72>>2]=518336;c[a+76>>2]=573;c[a+80>>2]=184;c[a+84>>2]=155;c[a+88>>2]=519064;c[a+92>>2]=574;c[a+96>>2]=185;c[a+100>>2]=156;c[a+104>>2]=519080;c[a+108>>2]=575;c[a+112>>2]=186;c[a+116>>2]=157;c[a+120>>2]=519096;c[a+124>>2]=576;c[a+128>>2]=187;c[a+132>>2]=158;c[a+136>>2]=519120;c[a+140>>2]=577;c[a+144>>2]=188;c[a+148>>2]=159;c[a+152>>2]=519136;c[a+156>>2]=578;c[a+160>>2]=189;c[a+164>>2]=160;return}function MFa(a){a=a|0;var b=Im;b=ea(g[a+32>>2]);return ea(b)}function NFa(a){a=a|0;var b=Im;b=ea(g[a+36>>2]);return ea(b)}function OFa(a,b){a=a|0;b=ea(b);var c=Im,d=0;c=ea(g[a>>2]);d=a+16|0;g[a>>2]=ea(c*ea(b/ea(g[d>>2])));g[d>>2]=b;return}function PFa(a){a=a|0;c[a>>2]=519152;c[a+4>>2]=581;c[a+8>>2]=190;c[a+12>>2]=519176;c[a+16>>2]=582;c[a+20>>2]=191;c[a+24>>2]=519192;c[a+28>>2]=583;c[a+32>>2]=161;c[a+36>>2]=519224;c[a+40>>2]=584;c[a+44>>2]=192;c[a+48>>2]=162;c[a+52>>2]=519240;c[a+56>>2]=585;c[a+60>>2]=193;c[a+64>>2]=163;c[a+68>>2]=519264;c[a+72>>2]=586;c[a+76>>2]=194;c[a+80>>2]=164;c[a+84>>2]=519280;c[a+88>>2]=587;c[a+92>>2]=195;c[a+96>>2]=165;c[a+100>>2]=519296;c[a+104>>2]=588;c[a+108>>2]=196;c[a+112>>2]=166;c[a+116>>2]=519312;c[a+120>>2]=589;c[a+124>>2]=197;c[a+128>>2]=167;c[a+132>>2]=519328;c[a+136>>2]=590;c[a+140>>2]=198;c[a+144>>2]=168;c[a+148>>2]=519352;c[a+152>>2]=591;c[a+156>>2]=199;c[a+160>>2]=169;return}function QFa(a){a=a|0;var b=Im;b=ea(g[a+44>>2]);return ea(b)}function RFa(a){a=a|0;var b=Im;b=ea(g[a+48>>2]);return ea(b)}function SFa(a){a=a|0;var b=Im;b=ea(g[a+52>>2]);return ea(b)}function TFa(a){a=a|0;var b=0;b=i;c[a>>2]=519376;c[a+4>>2]=594;c[a+8>>2]=200;c[a+12>>2]=519424;c[a+16>>2]=595;c[a+20>>2]=201;c[a+24>>2]=519464;c[a+28>>2]=596;c[a+32>>2]=202;c[a+36>>2]=519504;c[a+40>>2]=597;c[a+44>>2]=203;c[a+48>>2]=170;c[a+52>>2]=519520;c[a+56>>2]=598;c[a+60>>2]=204;c[a+64>>2]=171;c[a+68>>2]=519536;c[a+72>>2]=599;c[a+76>>2]=205;c[a+80>>2]=172;c[a+84>>2]=519576;c[a+88>>2]=600;c[a+92>>2]=206;c[a+96>>2]=173;c[a+100>>2]=518752;c[a+104>>2]=601;c[a+108>>2]=3515;c[a+112>>2]=2614;PHa(a+116|0);i=b;return}function UFa(a,b){a=a|0;b=ea(b);var c=0;c=i;HEa(a,b);i=c;return}function VFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+0|0;a=(IEa(b,d)|0)+0|0;d=f+48|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(d|0));i=e;return}function WFa(a){a=a|0;return c[a+40>>2]|0}function XFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JEa(a,b,c);i=d;return}function YFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+0|0;a=(NEa(b,d)|0)+0|0;d=f+48|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(d|0));i=e;return}function ZFa(a){a=a|0;return c[a+40>>2]|0}function _Fa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;MEa(a,b,c);i=d;return}function $Fa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+0|0;a=(PEa(b,d)|0)+0|0;d=f+64|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(d|0));i=e;return}function aGa(a){a=a|0;return c[a+40>>2]|0}function bGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;OEa(a,b,c);i=d;return}function cGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=REa(b,c)|0;g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);i=d;return}function dGa(a){a=a|0;return c[a+40>>2]|0}function eGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;QEa(a,b,c);i=d;return}function fGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=TEa(b,c)|0;g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);i=d;return}function gGa(a){a=a|0;return c[a+40>>2]|0}function hGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;SEa(a,b,c);i=d;return}function iGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=VEa(b,c)|0;g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);i=d;return}function jGa(a){a=a|0;return c[a+40>>2]|0}function kGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;UEa(a,b,c);i=d;return}function lGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=XEa(b,c)|0;g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);i=d;return}function mGa(a){a=a|0;return c[a+40>>2]|0}function nGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;WEa(a,b,c);i=d;return}function oGa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=YEa(a,b)|0;i=c;return d|0}function pGa(a){a=a|0;return c[a+40>>2]|0}function qGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;FEa(a,b,c);i=d;return}function rGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ZEa(b,d)|0;c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function sGa(a){a=a|0;return c[a+40>>2]|0}function tGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GEa(a,b,c);i=d;return}function uGa(a,b){a=a|0;b=b|0;var c=0;c=i;$Ea(a,b);i=c;return}function vGa(a,b){a=a|0;b=b|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];return}function wGa(a,b){a=a|0;b=ea(b);var c=0;c=i;aFa(a,b);i=c;return}function xGa(a){a=a|0;c[a>>2]=519608;c[a+4>>2]=609;c[a+8>>2]=174;c[a+12>>2]=519624;c[a+16>>2]=610;c[a+20>>2]=1790;c[a+24>>2]=1791;c[a+32>>2]=3516;c[a+36>>2]=519640;c[a+40>>2]=611;c[a+44>>2]=1792;c[a+48>>2]=1793;c[a+56>>2]=3517;c[a+60>>2]=519656;c[a+64>>2]=612;c[a+68>>2]=1794;c[a+72>>2]=1795;c[a+80>>2]=3518;c[a+84>>2]=519672;c[a+88>>2]=613;c[a+92>>2]=1796;c[a+96>>2]=1797;c[a+104>>2]=3519;c[a+108>>2]=519696;c[a+112>>2]=614;c[a+116>>2]=1798;c[a+120>>2]=1799;c[a+128>>2]=3520;c[a+132>>2]=519720;c[a+136>>2]=615;c[a+140>>2]=1800;c[a+144>>2]=1801;c[a+152>>2]=3521;c[a+156>>2]=519744;c[a+160>>2]=616;c[a+164>>2]=1802;c[a+168>>2]=1803;c[a+176>>2]=3522;c[a+180>>2]=519768;c[a+184>>2]=617;c[a+188>>2]=1804;c[a+192>>2]=2593;c[a+200>>2]=3523;c[a+204>>2]=519792;c[a+208>>2]=618;c[a+212>>2]=1805;c[a+216>>2]=1806;c[a+224>>2]=3524;c[a+228>>2]=519816;c[a+232>>2]=619;c[a+236>>2]=2615;c[a+240>>2]=2616;c[a+244>>2]=519840;c[a+248>>2]=620;c[a+252>>2]=175;return}function yGa(a,b){a=a|0;b=b|0;var c=0;c=i;bFa(a,b);i=c;return}function zGa(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(dFa(a,b));i=c;return ea(d)}function AGa(a){a=a|0;return c[a+16>>2]|0}function BGa(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;cFa(a,b,c);i=d;return}function CGa(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(fFa(a,b));i=c;return ea(d)}function DGa(a){a=a|0;return c[a+16>>2]|0}function EGa(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;eFa(a,b,c);i=d;return}function FGa(a){a=a|0;return c[a>>2]|0}function GGa(a){a=a|0;c[a>>2]=519864;c[a+4>>2]=623;c[a+8>>2]=2617;c[a+12>>2]=519888;c[a+16>>2]=624;c[a+20>>2]=31;c[a+24>>2]=40;c[a+32>>2]=3525;c[a+36>>2]=519912;c[a+40>>2]=625;c[a+44>>2]=32;c[a+48>>2]=41;c[a+56>>2]=3526;c[a+60>>2]=519936;c[a+64>>2]=626;c[a+68>>2]=3527;return}function HGa(a){a=a|0;return d[a+113>>0]|0|0}function IGa(a){a=a|0;return c[a+104>>2]|0}function JGa(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function KGa(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(NCa(a,b));i=c;return ea(d)}function LGa(a){a=a|0;return 16}function MGa(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;MCa(a,b,c);i=d;return}function NGa(b,c){b=b|0;c=c|0;a[b+65>>0]=c&1;return}function OGa(b){b=b|0;return (a[b+65>>0]|0)!=0|0}function PGa(b,c){b=b|0;c=c|0;a[b+66>>0]=c&1;return}function QGa(b){b=b|0;return (a[b+66>>0]|0)!=0|0}function RGa(b,c){b=b|0;c=c|0;a[b+64>>0]=c&1;return}function SGa(b){b=b|0;return (a[b+64>>0]|0)!=0|0}function TGa(a,b){a=a|0;b=b|0;c[a+68>>2]=b;return}function UGa(a){a=a|0;return c[a+68>>2]|0}function VGa(a,b){a=a|0;b=b|0;c[a+72>>2]=b;return}function WGa(a){a=a|0;return c[a+72>>2]|0}function XGa(a,b){a=a|0;b=ea(b);g[a+76>>2]=b;return}function YGa(a){a=a|0;var b=Im;b=ea(g[a+76>>2]);return ea(b)}function ZGa(a,b){a=a|0;b=b|0;c[a+72>>2]=b;return}function _Ga(a){a=a|0;return c[a+72>>2]|0}function $Ga(a,b){a=a|0;b=ea(b);g[a+80>>2]=b;return}function aHa(a){a=a|0;var b=Im;b=ea(g[a+80>>2]);return ea(b)}function bHa(a,b){a=a|0;b=ea(b);g[a+84>>2]=b;return}function cHa(a){a=a|0;var b=Im;b=ea(g[a+84>>2]);return ea(b)}function dHa(a){a=a|0;c[a>>2]=520048;c[a+4>>2]=636;c[a+8>>2]=33;c[a+12>>2]=42;c[a+20>>2]=3528;c[a+24>>2]=520064;c[a+28>>2]=637;c[a+32>>2]=3529;c[a+36>>2]=2618;c[a+40>>2]=520072;c[a+44>>2]=638;c[a+48>>2]=3530;c[a+52>>2]=2619;c[a+56>>2]=520088;c[a+60>>2]=639;c[a+64>>2]=3531;c[a+68>>2]=2620;c[a+72>>2]=520104;c[a+76>>2]=640;c[a+80>>2]=3532;c[a+84>>2]=2621;c[a+88>>2]=520120;c[a+92>>2]=641;c[a+96>>2]=3533;c[a+100>>2]=2622;c[a+104>>2]=520136;c[a+108>>2]=642;c[a+112>>2]=207;c[a+116>>2]=176;c[a+120>>2]=520160;c[a+124>>2]=643;c[a+128>>2]=3534;c[a+132>>2]=2623;c[a+136>>2]=520176;c[a+140>>2]=644;c[a+144>>2]=208;c[a+148>>2]=177;c[a+152>>2]=520192;c[a+156>>2]=645;c[a+160>>2]=209;c[a+164>>2]=178;c[a+168>>2]=520216;c[a+172>>2]=646;c[a+176>>2]=3535;c[a+180>>2]=2624;c[a+184>>2]=520232;c[a+188>>2]=647;c[a+192>>2]=3536;c[a+196>>2]=2625;c[a+200>>2]=520248;c[a+204>>2]=648;c[a+208>>2]=3537;c[a+212>>2]=2626;c[a+216>>2]=520272;c[a+220>>2]=649;c[a+224>>2]=3538;c[a+228>>2]=2627;c[a+232>>2]=520288;c[a+236>>2]=650;c[a+240>>2]=3539;c[a+244>>2]=2628;c[a+248>>2]=520304;c[a+252>>2]=651;c[a+256>>2]=210;c[a+260>>2]=179;c[a+264>>2]=520320;c[a+268>>2]=652;c[a+272>>2]=211;c[a+276>>2]=180;c[a+280>>2]=520336;c[a+284>>2]=653;c[a+288>>2]=212;c[a+292>>2]=181;return}function eHa(a,b){a=a|0;b=b|0;var c=0;c=i;HCa(a,b);i=c;return}function fHa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+64>>2]|0;YEi(a|0,b|0,e<<3|0)|0;c[a+64>>2]=e;e=a+80|0;a=b+80|0;c[e+0>>2]=c[a+0>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[e+16>>2]=c[a+16>>2];c[e+20>>2]=c[a+20>>2];c[e+24>>2]=c[a+24>>2];c[e+28>>2]=c[a+28>>2];i=d;return}function gHa(a,b){a=a|0;b=b|0;var c=0;c=i;ICa(a,b);i=c;return}function hHa(a,b){a=a|0;b=b|0;var c=0;c=i;YEi(a|0,b+112|0,144)|0;i=c;return}function iHa(a,b){a=a|0;b=b|0;var c=0;c=i;JCa(a,b);i=c;return}function jHa(a,b){a=a|0;b=b|0;var d=0;d=b+256|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function kHa(a,b){a=a|0;b=b|0;var c=0;c=i;KCa(a,b);i=c;return}function lHa(a,b){a=a|0;b=b|0;var c=0;c=i;YEi(a|0,b+272|0,256)|0;i=c;return}function mHa(a){a=a|0;c[a>>2]=520360;c[a+4>>2]=656;c[a+8>>2]=2629;c[a+12>>2]=2630;c[a+16>>2]=520376;c[a+20>>2]=657;c[a+24>>2]=2631;c[a+28>>2]=2632;c[a+32>>2]=520392;c[a+36>>2]=658;c[a+40>>2]=2633;c[a+44>>2]=2634;c[a+48>>2]=520408;c[a+52>>2]=659;c[a+56>>2]=2635;c[a+60>>2]=2636;return}function nHa(a,b){a=a|0;b=b|0;var c=0;c=i;RCa(a,b);i=c;return}function oHa(a,b){a=a|0;b=b|0;var d=0;d=b+528|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[a+28>>2]=c[d+28>>2];return}function pHa(a,b){a=a|0;b=b|0;var c=0;c=i;SCa(a,b);i=c;return}function qHa(a,b){a=a|0;b=b|0;var d=0;d=b+560|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function rHa(a){a=a|0;c[a>>2]=520360;c[a+4>>2]=656;c[a+8>>2]=2629;c[a+12>>2]=2630;c[a+16>>2]=520376;c[a+20>>2]=657;c[a+24>>2]=2631;c[a+28>>2]=2632;c[a+32>>2]=520392;c[a+36>>2]=658;c[a+40>>2]=2633;c[a+44>>2]=2634;c[a+48>>2]=520408;c[a+52>>2]=659;c[a+56>>2]=2635;c[a+60>>2]=2636;c[a+64>>2]=520424;c[a+68>>2]=662;c[a+72>>2]=2637;c[a+76>>2]=2638;c[a+80>>2]=520440;c[a+84>>2]=663;c[a+88>>2]=2639;c[a+92>>2]=2640;return}function sHa(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function tHa(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function uHa(a){a=a|0;c[a>>2]=519952;c[a+4>>2]=629;c[a+8>>2]=3540;c[a+12>>2]=519968;c[a+16>>2]=630;c[a+20>>2]=3541;c[a+24>>2]=519992;c[a+28>>2]=631;c[a+32>>2]=3542;c[a+36>>2]=520016;c[a+40>>2]=632;c[a+44>>2]=2641;c[a+48>>2]=2642;c[a+52>>2]=520032;c[a+56>>2]=633;c[a+60>>2]=2643;c[a+64>>2]=2644;c[a+68>>2]=519992;c[a+72>>2]=666;c[a+76>>2]=3543;c[a+80>>2]=520464;c[a+84>>2]=667;c[a+88>>2]=2645;c[a+92>>2]=2646;c[a+96>>2]=519992;c[a+100>>2]=670;c[a+104>>2]=3544;c[a+108>>2]=520480;c[a+112>>2]=671;c[a+116>>2]=2647;c[a+120>>2]=2648;return}function vHa(a,b){a=a|0;b=b|0;c[a+752>>2]=b;return}function wHa(a){a=a|0;return c[a+752>>2]|0}function xHa(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function yHa(a){a=a|0;c[a>>2]=519952;c[a+4>>2]=629;c[a+8>>2]=3540;c[a+12>>2]=519968;c[a+16>>2]=630;c[a+20>>2]=3541;c[a+24>>2]=519992;c[a+28>>2]=631;c[a+32>>2]=3542;c[a+36>>2]=520016;c[a+40>>2]=632;c[a+44>>2]=2641;c[a+48>>2]=2642;c[a+52>>2]=520032;c[a+56>>2]=633;c[a+60>>2]=2643;c[a+64>>2]=2644;c[a+68>>2]=519992;c[a+72>>2]=666;c[a+76>>2]=3543;c[a+80>>2]=520464;c[a+84>>2]=667;c[a+88>>2]=2645;c[a+92>>2]=2646;c[a+96>>2]=520496;c[a+100>>2]=674;c[a+104>>2]=3545;c[a+108>>2]=2649;c[a+112>>2]=519992;c[a+116>>2]=675;c[a+120>>2]=3546;c[a+124>>2]=520480;c[a+128>>2]=676;c[a+132>>2]=2650;c[a+136>>2]=2651;return}function zHa(a,b){a=a|0;b=b|0;var c=0;c=i;VCa(a,b);i=c;return}function AHa(a,b){a=a|0;b=b|0;var d=0;d=b+528|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function BHa(a){a=a|0;c[a>>2]=520360;c[a+4>>2]=656;c[a+8>>2]=2629;c[a+12>>2]=2630;c[a+16>>2]=520376;c[a+20>>2]=657;c[a+24>>2]=2631;c[a+28>>2]=2632;c[a+32>>2]=520392;c[a+36>>2]=658;c[a+40>>2]=2633;c[a+44>>2]=2634;c[a+48>>2]=520408;c[a+52>>2]=659;c[a+56>>2]=2635;c[a+60>>2]=2636;c[a+64>>2]=520424;c[a+68>>2]=679;c[a+72>>2]=2652;c[a+76>>2]=2653;return}function CHa(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function DHa(a){a=a|0;c[a>>2]=519952;c[a+4>>2]=629;c[a+8>>2]=3540;c[a+12>>2]=519968;c[a+16>>2]=630;c[a+20>>2]=3541;c[a+24>>2]=519992;c[a+28>>2]=631;c[a+32>>2]=3542;c[a+36>>2]=520016;c[a+40>>2]=632;c[a+44>>2]=2641;c[a+48>>2]=2642;c[a+52>>2]=520032;c[a+56>>2]=633;c[a+60>>2]=2643;c[a+64>>2]=2644;c[a+68>>2]=519992;c[a+72>>2]=666;c[a+76>>2]=3543;c[a+80>>2]=520464;c[a+84>>2]=667;c[a+88>>2]=2645;c[a+92>>2]=2646;c[a+96>>2]=519992;c[a+100>>2]=682;c[a+104>>2]=3547;c[a+108>>2]=520480;c[a+112>>2]=683;c[a+116>>2]=2654;c[a+120>>2]=2655;return}function EHa(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(xDa(a,b));i=c;return ea(d)}function FHa(a){a=a|0;return c[a+48>>2]|0}function GHa(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;uDa(a,b,c);i=d;return}function HHa(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(yDa(a,b));i=c;return ea(d)}function IHa(a){a=a|0;return c[a+48>>2]|0}function JHa(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;vDa(a,b,c);i=d;return}function KHa(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(zDa(a,b));i=c;return ea(d)}function LHa(a){a=a|0;return c[a+48>>2]|0}function MHa(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;wDa(a,b,c);i=d;return}function NHa(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function OHa(a){a=a|0;c[a>>2]=519952;c[a+4>>2]=629;c[a+8>>2]=3540;c[a+12>>2]=519968;c[a+16>>2]=630;c[a+20>>2]=3541;c[a+24>>2]=519992;c[a+28>>2]=631;c[a+32>>2]=3542;c[a+36>>2]=520016;c[a+40>>2]=632;c[a+44>>2]=2641;c[a+48>>2]=2642;c[a+52>>2]=520032;c[a+56>>2]=633;c[a+60>>2]=2643;c[a+64>>2]=2644;c[a+68>>2]=520512;c[a+72>>2]=686;c[a+76>>2]=34;c[a+80>>2]=43;c[a+88>>2]=3548;c[a+92>>2]=520528;c[a+96>>2]=687;c[a+100>>2]=35;c[a+104>>2]=44;c[a+112>>2]=3549;c[a+116>>2]=520544;c[a+120>>2]=688;c[a+124>>2]=36;c[a+128>>2]=45;c[a+136>>2]=3550;c[a+140>>2]=519992;c[a+144>>2]=689;c[a+148>>2]=3551;return}function PHa(a){a=a|0;c[a>>2]=520560;c[a+4>>2]=602;c[a+8>>2]=8;c[a+12>>2]=13;c[a+16>>2]=3;c[a+20>>2]=2;return}function QHa(a){a=a|0;c[a>>2]=520584;c[a+4>>2]=518;c[a+8>>2]=37;c[a+12>>2]=46;c[a+20>>2]=3552;return}function RHa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+4|0;a=c[d>>2]|0;if(a)VJa(b,a+-4|0);c[d>>2]=0;i=b;return}function SHa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+4>>2]|0;if(!d){e=0;i=b;return e|0}f=c[a>>2]|0;if(!f){e=0;i=b;return e|0}else{g=0;h=0}while(1){a=(c[d+(h*12|0)>>2]&536870911|0)==536870911;j=((c[d+(h*12|0)+4>>2]&536870911|0)==536870911?(a?2:1):a&1)+g+((c[d+(h*12|0)+8>>2]&536870911|0)==536870911&1)|0;h=h+1|0;if(h>>>0>=f>>>0){e=j;break}else g=j}i=b;return e|0}function THa(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;return}function UHa(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=i;i=i+112|0;j=h;k=h+68|0;l=h+104|0;m=h+56|0;n=h+32|0;o=h+8|0;p=c[f>>2]|0;if(!p){q=0;i=h;return q|0}c[d>>2]=p;r=p*12|0;s=mKa()|0;t=c[(c[s>>2]|0)+8>>2]|0;u=pKa()|0;v=mo[c[(c[u>>2]|0)+24>>2]&4095](u)|0;u=Bn[t&255](s,p>>>0>357913941|r>>>0>4294967291?-1:r+4|0,v?520768:544544,520600,821)|0;c[u>>2]=p;p=d+4|0;c[p>>2]=u+4;u=(c[d>>2]|0)*3|0;v=u*12|0;r=mKa()|0;s=c[(c[r>>2]|0)+8>>2]|0;t=pKa()|0;w=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;t=Bn[s&255](r,u>>>0>357913941|v>>>0>4294967291?-1:v+4|0,w?520680:544544,520600,823)|0;c[t>>2]=u;u=t+4|0;if(!(c[d>>2]|0)){x=0;y=c[p>>2]|0}else{w=c[f+4>>2]|0;v=(w|0)==0;r=f+8|0;s=c[p>>2]|0;z=0;A=0;while(1){if(v){B=c[r>>2]|0;if(B){C=e[B+(A*3<<1)>>1]|0;B=c[r>>2]|0;if(B){D=A*3|0;E=e[B+(D+1<<1)>>1]|0;B=c[r>>2]|0;if(!B){F=C;G=E;H=2}else{F=C;G=E;H=e[B+(D+2<<1)>>1]|0}}else{F=C;G=1;H=2}}else{F=0;G=1;H=2}}else{F=c[w+(A*3<<2)>>2]|0;G=c[w+((A*3|0)+1<<2)>>2]|0;H=c[w+((A*3|0)+2<<2)>>2]|0}c[s+(A*12|0)>>2]=-1;c[s+(A*12|0)+4>>2]=-1;c[s+(A*12|0)+8>>2]=-1;C=u+(z*12|0)|0;if(F>>>0<G>>>0){c[C>>2]=F;c[u+(z*12|0)+4>>2]=G;c[u+(z*12|0)+8>>2]=A}else{c[C>>2]=G;c[u+(z*12|0)+4>>2]=F;c[u+(z*12|0)+8>>2]=A}C=z+1|0;D=u+(C*12|0)|0;if(F>>>0<H>>>0){c[D>>2]=F;c[u+(C*12|0)+4>>2]=H;c[u+(C*12|0)+8>>2]=A}else{c[D>>2]=H;c[u+(C*12|0)+4>>2]=F;c[u+(C*12|0)+8>>2]=A}C=z+2|0;D=u+(C*12|0)|0;if(G>>>0<H>>>0){c[D>>2]=G;c[u+(C*12|0)+4>>2]=H;c[u+(C*12|0)+8>>2]=A}else{c[D>>2]=H;c[u+(C*12|0)+4>>2]=G;c[u+(C*12|0)+8>>2]=A}C=z+3|0;A=A+1|0;if(A>>>0>=(c[d>>2]|0)>>>0){x=C;y=s;break}else z=C}}KMa(k);z=x>>>0>1073741823?-1:x<<2;if(!z)I=0;else{s=mKa()|0;A=c[(c[s>>2]|0)+8>>2]|0;G=pKa()|0;H=mo[c[(c[G>>2]|0)+24>>2]&4095](G)|0;I=Bn[A&255](s,z,H?541832:544544,520600,736)|0}if(!x)NMa(k,I,0,0)|0;else{H=0;do{c[I+(H<<2)>>2]=c[u+(H*12|0)>>2];H=H+1|0}while((H|0)!=(x|0));NMa(k,I,x,0)|0;H=0;do{c[I+(H<<2)>>2]=c[u+(H*12|0)+4>>2];H=H+1|0}while((H|0)!=(x|0))}NMa(k,I,x,0)|0;VJa(l,I);I=c[k+8>>2]|0;l=c[I>>2]|0;H=m+4|0;z=x;x=0;s=c[u+(l*12|0)>>2]|0;A=c[u+(l*12|0)+4>>2]|0;l=I;a:while(1){I=z;J=x;G=l;while(1){F=I;I=I+-1|0;if(!F){K=37;break a}F=G;G=G+4|0;w=c[F>>2]|0;L=c[u+(w*12|0)+8>>2]|0;M=c[u+(w*12|0)>>2]|0;N=c[u+(w*12|0)+4>>2]|0;if(!((M|0)==(s|0)&(N|0)==(A|0)))break;w=J+1|0;c[m+(J<<2)>>2]=L;if((w|0)==3){K=33;break a}else J=w}if((J|0)==2?!(y5a(c[m>>2]|0,c[H>>2]|0,s,A,y,f)|0):0){K=46;break}c[m>>2]=L;z=I;x=1;s=M;A=N;l=G}if((K|0)==33){dKa(bKa()|0,8,520600,766,520880,j);MMa(k);VJa(j,t);q=0;i=h;return q|0}else if((K|0)==37){if((J|0)==2){J=y5a(c[m>>2]|0,c[H>>2]|0,s,A,y,f)|0;MMa(k);VJa(j,t);if(!J){q=0;i=h;return q|0}}else{MMa(k);VJa(j,t)}J=c[f+12>>2]|0;if(!J){q=1;i=h;return q|0}c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;b[n+12>>1]=0;c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];a[n+12>>0]=1;c[n+16>>2]=J;g[n+20>>2]=ea(g[f+16>>2]);oIa(o);if(kIa(o,n)|0?(c[d>>2]|0)!=0:0){n=c[o+12>>2]|0;f=c[p>>2]|0;p=0;do{J=f+(p*12|0)|0;y=c[J>>2]|0;c[J>>2]=(c[n+(p*12|0)>>2]|0)>-1?y&-536870913:y|536870912;y=f+(p*12|0)+4|0;J=c[y>>2]|0;c[y>>2]=(c[n+(p*12|0)+8>>2]|0)>-1?J&-536870913:J|536870912;J=f+(p*12|0)+8|0;y=c[J>>2]|0;c[J>>2]=(c[n+(p*12|0)+4>>2]|0)>-1?y&-536870913:y|536870912;p=p+1|0}while(p>>>0<(c[d>>2]|0)>>>0)}jIa(o);q=1;i=h;return q|0}else if((K|0)==46){MMa(k);VJa(j,t);q=0;i=h;return q|0}return 0}function VHa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+4|0;a=b+0|0;b=e+44|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));i=d;return}function WHa(a){a=a|0;return a+4|0}function XHa(a){a=a|0;var b=0,d=0;b=i;d=c[a+4>>2]|0;if(d>>>0<5){i=b;return (22>>>(d&31)&1)!=0|0}else{i=b;return 0}return 0}function YHa(a){a=a|0;var b=0;b=i;if(a)ko[c[(c[a>>2]|0)+48>>2]&4095](a);hKa();i=b;return}function ZHa(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+240|0;f=e;g=c[d+8>>2]|0;if(g>>>0<3){h=0;i=e;return h|0}j=(c[d+16>>2]|0)==0;if(!(j^1|((g>>>0)%3|0|0)==0)){h=0;i=e;return h|0}if((c[d+32>>2]|0)!=0?(c[d+28>>2]|0)>>>0<2:0){h=0;i=e;return h|0}if(g>>>0>65535?(b[d+24>>1]&2)!=0:0){h=0;i=e;return h|0}if(!(c[d+4>>2]|0)){h=0;i=e;return h|0}if((c[d>>2]|0)>>>0<12){h=0;i=e;return h|0}if(!j?(c[d+12>>2]|0)>>>0<((b[d+24>>1]&2)!=0?6:12)>>>0:0){h=0;i=e;return h|0}UQa(f);c[f>>2]=521896;c[f+8>>2]=521976;j=BIa(f,d,a+4|0,1)|0;XQa(f);h=j;i=e;return h|0}function _Ha(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;i=i+16|0;if(ea(g[d+36>>2])!=ea(.00100000005))dKa(bKa()|0,2,521088,137,521168,f);h=c[d+8>>2]|0;if(h>>>0<3){j=0;i=f;return j|0}k=(c[d+16>>2]|0)==0;if(!(k^1|((h>>>0)%3|0|0)==0)){j=0;i=f;return j|0}if((c[d+32>>2]|0)!=0?(c[d+28>>2]|0)>>>0<2:0){j=0;i=f;return j|0}if(h>>>0>65535?(b[d+24>>1]&2)!=0:0){j=0;i=f;return j|0}if(!(c[d+4>>2]|0)){j=0;i=f;return j|0}if((c[d>>2]|0)>>>0<12){j=0;i=f;return j|0}if(!k?(c[d+12>>2]|0)>>>0<((b[d+24>>1]&2)!=0?6:12)>>>0:0){j=0;i=f;return j|0}j=BIa(e,d,a+4|0,0)|0;i=f;return j|0}function $Ha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,240,j?521760:544544,521088,158)|0;UQa(h);c[h>>2]=521896;c[h+8>>2]=521976;if(!h){k=0;i=e;return k|0}if(_Ha(a,b,h)|0){DIa(h,d,mo[c[(c[a>>2]|0)+12>>2]&4095](a)|0)|0;ko[c[(c[h>>2]|0)+16>>2]&4095](h);k=1;i=e;return k|0}else{ko[c[(c[h>>2]|0)+16>>2]&4095](h);k=0;i=e;return k|0}return 0}function aIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,240,j?521760:544544,521088,183)|0;UQa(h);c[h>>2]=521896;c[h+8>>2]=521976;if(!h){k=0;i=e;return k|0}if(!(_Ha(a,b,h)|0)){ko[c[(c[h>>2]|0)+16>>2]&4095](h);k=0;i=e;return k|0}if(_n[c[c[d>>2]>>2]&4095](d,h)|0){k=h;i=e;return k|0}else{ko[c[(c[h>>2]|0)+16>>2]&4095](h);k=0;i=e;return k|0}return 0}function bIa(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+288|0;k=j;l=j+232|0;m=j+200|0;n=j+176|0;o=j+172|0;p=(h|0)!=0;if(p)c[h>>2]=2;q=c[e+8>>2]|0;a:do if(q>>>0>=3){if(q>>>0>65535?(b[e+48>>1]&2)!=0:0)break;if((c[e+4>>2]|0)!=0?(c[e>>2]|0)>>>0>=12:0){do if(!(c[e+16>>2]|0)){if(!(c[e+28>>2]|0)){r=b[e+48>>1]|0;if(!(r&4))break a;else{s=r;break}}if((c[e+32>>2]|0)>>>0<4)break a;if(!(c[e+40>>2]|0))break a;r=b[e+48>>1]|0;if((c[e+36>>2]|0)>>>0<((r&2)!=0?2:4)>>>0)break a;if((c[e+24>>2]|0)>>>0<20)break a;else s=r}else{if((c[e+20>>2]|0)>>>0<2)break a;r=b[e+48>>1]|0;if((c[e+12>>2]|0)>>>0<((r&2)!=0?6:12)>>>0)break a;else s=r}while(0);r=b[e+50>>1]|0;if((r+-4<<16>>16&65535)<253){t=l+0|0;u=e+0|0;v=t+48|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));u=l+48|0;b[u>>1]=s;b[l+50>>1]=r;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[m+16>>2]=ea(.00100000005);t=m+28|0;c[t>>2]=4096;v=m+20|0;g[v>>2]=ea(.00999999977);a[n>>0]=1;w=n+4|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;hJa(o);x=c[u>>2]|0;y=x>>>16;z=y&65535;do if(x&4){A=(x&16|0)==0;c[m>>2]=5;B=l+8|0;c[m+4>>2]=c[B>>2];C=l+4|0;c[m+8>>2]=c[C>>2];c[m+12>>2]=c[l>>2];if(x&8){D=ea(g[d+8>>2]);g[v>>2]=D;if(D<=ea(0.0)){dKa(bKa()|0,4,521088,237,521352,k);E=0;break}}else g[v>>2]=ea(0.0);if(!A){D=ea(g[d+12>>2]);g[m+24>>2]=D;if(D<=ea(0.0)){dKa(bKa()|0,4,521088,243,521432,k);E=0;break}}else g[m+24>>2]=ea(0.0);if((z+-4<<16>>16&65535)<252)c[t>>2]=y;A=rJa(o,m,n)|0;if(!A){F=c[w>>2]|0;c[B>>2]=F;c[l>>2]=12;c[C>>2]=c[n+8>>2];c[l+20>>2]=c[n+12>>2];c[l+16>>2]=c[n+20>>2];c[l+12>>2]=12;b[u>>1]=b[u>>1]&-5;G=F;H=35;break}else if((A|0)!=3){E=0;break}if(p){c[h>>2]=1;E=0}else E=0}else{G=c[l+8>>2]|0;H=35}while(0);do if((H|0)==35){if(G>>>0>255){dKa(bKa()|0,32,521088,278,521512,k);sJa(o,n)|0;E=0;break}VIa(k);if(_Ia(k,l,c[d+4>>2]|0)|0){u=cJa(k,f,mo[c[(c[d>>2]|0)+12>>2]&4095](d)|0)|0;sJa(o,n)|0;if(u&p){c[h>>2]=0;I=1}else I=u}else{sJa(o,n)|0;I=0}YIa(k);E=I}while(0);iJa(o);J=E;i=j;return J|0}}}while(0);dKa(bKa()|0,4,521088,217,521272,k);J=0;i=j;return J|0}function cIa(d,f,g,h,j,k,l,m,n){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+176|0;o=d;p=f+8|0;q=c[p>>2]|0;r=i;i=i+((1*(q*12|0)|0)+15&-16)|0;s=c[f>>2]|0;if(q){t=q;q=r;u=c[f+4>>2]|0;while(1){t=t+-1|0;v=q+0|0;w=u+0|0;x=v+12|0;do{a[v>>0]=a[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));if(!t)break;else{q=q+12|0;u=u+s|0}}}s=f+12|0;u=f+20|0;q=c[u>>2]|0;t=i;i=i+((1*(q*12|0)|0)+15&-16)|0;if(!(b[f+24>>1]&2)){y=c[s>>2]|0;if(q){z=q;A=t;B=c[f+16>>2]|0;while(1){z=z+-1|0;v=A+0|0;w=B+0|0;x=v+12|0;do{a[v>>0]=a[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));if(!z)break;else{A=A+12|0;B=B+y|0}}}}else{y=t+(q*3<<2)|0;if(t>>>0<y>>>0){q=t;B=c[f+16>>2]|0;while(1){c[q>>2]=e[B>>1];c[q+4>>2]=e[B+2>>1];c[q+8>>2]=e[B+4>>1];q=q+12|0;if(q>>>0>=y>>>0)break;else B=B+(c[s>>2]|0)|0}}}VIa(o);s=eJa(o,p,r,u,t,g,h,j,k,l,m,n)|0;YIa(o);i=d;return s|0}function dIa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;if((c[d+4>>2]|0)>>>0<2){h=0;i=f;return h|0}if((c[d>>2]|0)>>>0<2){h=0;i=f;return h|0}if((c[d+8>>2]|0)!=1){h=0;i=f;return h|0}if((c[d+12>>2]|0)>>>0<4){h=0;i=f;return h|0}if(ea(g[d+24>>2])<ea(0.0)){h=0;i=f;return h|0}j=b[d+28>>1]|0;if((j&1)<<16>>16!=j<<16>>16){h=0;i=f;return h|0}j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,116,m?537856:544544,521088,348)|0;eRa(l,0);if(!l){h=0;i=f;return h|0}if(sRa(l,d,0)|0){d=zIa(l,e,mo[c[(c[a>>2]|0)+12>>2]&4095](a)|0)|0;jRa(l,0);ko[c[(c[l>>2]|0)+16>>2]&4095](l);h=d;i=f;return h|0}else{jRa(l,0);ko[c[(c[l>>2]|0)+16>>2]&4095](l);h=0;i=f;return h|0}return 0}function eIa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;a=i;if((c[d+4>>2]|0)>>>0<2){f=0;i=a;return f|0}if((c[d>>2]|0)>>>0<2){f=0;i=a;return f|0}if((c[d+8>>2]|0)!=1){f=0;i=a;return f|0}if((c[d+12>>2]|0)>>>0<4){f=0;i=a;return f|0}if(ea(g[d+24>>2])<ea(0.0)){f=0;i=a;return f|0}h=b[d+28>>1]|0;if((h&1)<<16>>16!=h<<16>>16){f=0;i=a;return f|0}h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,116,l?537856:544544,521088,383)|0;eRa(k,0);if(!k){f=0;i=a;return f|0}if(!(sRa(k,d,1)|0)){jRa(k,0);ko[c[(c[k>>2]|0)+16>>2]&4095](k);f=0;i=a;return f|0}if(_n[c[c[e>>2]>>2]&4095](e,k)|0){f=k;i=a;return f|0}else{jRa(k,0);ko[c[(c[k>>2]|0)+16>>2]&4095](k);f=0;i=a;return f|0}return 0}function fIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;gKa();a=mKa()|0;e=c[(c[a>>2]|0)+8>>2]|0;f=pKa()|0;g=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=Bn[e&255](a,48,g?521656:544544,521088,413)|0;c[f>>2]=521600;g=f+4|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];c[g+20>>2]=c[d+20>>2];c[g+24>>2]=c[d+24>>2];c[f+32>>2]=c[d+28>>2];g=f+36|0;a=d+32|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];i=b;return f|0}function gIa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+4>>2]=b;c[a>>2]=d;return}function hIa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+16|0;VJa(b+1|0,c[d>>2]|0);c[d>>2]=0;d=a+12|0;VJa(b,c[d>>2]|0);c[d>>2]=0;i=b;return}function iIa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+64|0;e=d+12|0;f=d+49|0;h=d;j=d+48|0;k=a+16|0;VJa(e,c[k>>2]|0);c[k>>2]=0;l=a+12|0;VJa(d+50|0,c[l>>2]|0);c[l>>2]=0;m=c[a>>2]|0;n=m>>>0>1073741823?-1:m<<2;if(!n){o=0;p=m}else{m=mKa()|0;q=c[(c[m>>2]|0)+8>>2]|0;r=pKa()|0;s=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[q&255](m,n,s?541832:544544,522008,74)|0;o=r;p=c[a>>2]|0}c[k>>2]=o;o=p>>>0>1073741823?-1:p<<2;if(!o){t=p;u=0}else{p=mKa()|0;r=c[(c[p>>2]|0)+8>>2]|0;s=pKa()|0;n=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;s=Bn[r&255](p,o,n?526520:544544,522008,76)|0;t=c[a>>2]|0;u=s}if(t){s=c[a+4>>2]|0;n=0;do{g[u+(n<<2)>>2]=ea(g[s+(n*12|0)>>2]);n=n+1|0}while(n>>>0<t>>>0)}KMa(e);NMa(e,u,c[a>>2]|0,1)|0;t=c[a>>2]|0;if(!t)v=0;else{n=c[a+4>>2]|0;s=0;do{g[u+(s<<2)>>2]=ea(g[n+(s*12|0)+4>>2]);s=s+1|0}while(s>>>0<t>>>0);v=t}NMa(e,u,v,1)|0;v=c[a>>2]|0;if(!v)w=0;else{t=c[a+4>>2]|0;s=0;do{g[u+(s<<2)>>2]=ea(g[t+(s*12|0)+8>>2]);s=s+1|0}while(s>>>0<v>>>0);w=v}v=c[(NMa(e,u,w,1)|0)+8>>2]|0;VJa(f,u);u=a+8|0;c[u>>2]=0;c[h+0>>2]=-1;c[h+4>>2]=-1;c[h+8>>2]=-1;f=UJa(j,(c[a>>2]|0)*12|0,522008,97)|0;c[l>>2]=f;j=c[a>>2]|0;if(j){w=c[a+4>>2]|0;a=c[k>>2]|0;s=j;j=h;h=v;do{s=s+-1|0;v=c[h>>2]|0;h=h+4|0;t=j;j=w+(v*12|0)|0;n=w+(v*12|0)+4|0;if(((c[j>>2]|0)==(c[t>>2]|0)?(c[n>>2]|0)==(c[t+4>>2]|0):0)?(c[w+(v*12|0)+8>>2]|0)==(c[t+8>>2]|0):0)x=c[u>>2]|0;else{t=c[u>>2]|0;o=t+1|0;c[u>>2]=o;g[f+(t*12|0)>>2]=ea(g[w+(v*12|0)>>2]);g[f+(t*12|0)+4>>2]=ea(g[n>>2]);g[f+(t*12|0)+8>>2]=ea(g[w+(v*12|0)+8>>2]);x=o}c[a+(v<<2)>>2]=x+-1}while((s|0)!=0)}if(!b){MMa(e);i=d;return 1}c[b+8>>2]=c[k>>2];c[b+4>>2]=c[u>>2];c[b>>2]=c[l>>2];MMa(e);i=d;return 1}function jIa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+20|0;VJa(b+3|0,c[d>>2]|0);c[d>>2]=0;d=a+16|0;VJa(b+2|0,c[d>>2]|0);c[d>>2]=0;d=a+4|0;VJa(b+1|0,c[d>>2]|0);c[d>>2]=0;d=a+12|0;VJa(b,c[d>>2]|0);c[d>>2]=0;i=b;return}function kIa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+2|0;h=e+1|0;j=e;k=d+16|0;if(!(c[k>>2]|0)){l=(a[d+13>>0]|0)!=0;if(!(a[d+12>>0]|0))m=l;else{n=l;o=3}}else{n=1;o=3}if((o|0)==3)if(lIa(b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0)m=n;else{p=0;i=e;return p|0}if(m?!(mIa(b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0):0){p=0;i=e;return p|0}m=c[k>>2]|0;if((m|0)!=0?!(nIa(b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,m,ea(g[d+20>>2]))|0):0){p=0;i=e;return p|0}if(!(a[d+12>>0]|0)){m=b+12|0;VJa(f,c[m>>2]|0);c[m>>2]=0}if(a[d+13>>0]|0){p=1;i=e;return p|0}d=b+16|0;VJa(h,c[d>>2]|0);c[d>>2]=0;d=b+20|0;VJa(j,c[d>>2]|0);c[d>>2]=0;p=1;i=e;return p|0}function lIa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=i;i=i+48|0;j=h;k=h+39|0;l=h+38|0;m=h+37|0;n=h+36|0;if((d|0)!=0?(o=(f|0)!=0,p=(g|0)==0,!(p&(o^1))):0){q=a+12|0;if(c[q>>2]|0){r=1;i=h;return r|0}s=d>>>0>357913941?-1:d*12|0;if(!s)t=0;else{u=mKa()|0;v=c[(c[u>>2]|0)+8>>2]|0;w=pKa()|0;x=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;t=Bn[v&255](u,s,x?522648:544544,522096,152)|0}c[q>>2]=t;t=d*3|0;x=t>>>0>1073741823?-1:t<<2;if(!x){y=0;z=0;A=0}else{s=mKa()|0;u=c[(c[s>>2]|0)+8>>2]|0;v=pKa()|0;w=mo[c[(c[v>>2]|0)+24>>2]&4095](v)|0;v=Bn[u&255](s,x,w?541832:544544,522096,153)|0;w=mKa()|0;s=c[(c[w>>2]|0)+8>>2]|0;u=pKa()|0;B=mo[c[(c[u>>2]|0)+24>>2]&4095](u)|0;y=v;z=v;A=Bn[s&255](w,x,B?541832:544544,522096,154)|0}B=t>>>0>536870911?-1:t<<3;if(!B)C=0;else{x=mKa()|0;w=c[(c[x>>2]|0)+8>>2]|0;s=pKa()|0;v=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;C=Bn[w&255](x,B,v?522536:544544,522096,155)|0}if(o){o=0;do{v=o*3|0;B=c[f+(v<<2)>>2]|0;x=c[f+(v+1<<2)>>2]|0;w=c[f+(v+2<<2)>>2]|0;s=z+(v<<2)|0;if(B>>>0<x>>>0){c[s>>2]=B;c[A+(v<<2)>>2]=x}else{c[s>>2]=x;c[A+(v<<2)>>2]=B}s=v+1|0;u=z+(s<<2)|0;if(x>>>0<w>>>0){c[u>>2]=x;c[A+(s<<2)>>2]=w}else{c[u>>2]=w;c[A+(s<<2)>>2]=x}x=v+2|0;v=z+(x<<2)|0;if(w>>>0<B>>>0){c[v>>2]=w;c[A+(x<<2)>>2]=B}else{c[v>>2]=B;c[A+(x<<2)>>2]=w}o=o+1|0}while((o|0)!=(d|0))}else{o=0;do{f=o*3|0;if(!p){w=b[g+(f<<1)>>1]|0;x=w&65535;B=b[g+(f+1<<1)>>1]|0;v=B&65535;s=e[g+(f+2<<1)>>1]|0;u=z+(f<<2)|0;if((w&65535)<(B&65535)){D=x;E=u;F=v;G=s;H=25}else{c[u>>2]=v;c[A+(f<<2)>>2]=x;I=v;J=s;K=x}}else{D=0;E=z+(f<<2)|0;F=1;G=2;H=25}if((H|0)==25){H=0;c[E>>2]=D;c[A+(f<<2)>>2]=F;I=F;J=G;K=D}x=f+1|0;s=z+(x<<2)|0;if(I>>>0<J>>>0){c[s>>2]=I;c[A+(x<<2)>>2]=J}else{c[s>>2]=J;c[A+(x<<2)>>2]=I}x=f+2|0;f=z+(x<<2)|0;if(J>>>0<K>>>0){c[f>>2]=J;c[A+(x<<2)>>2]=K}else{c[f>>2]=K;c[A+(x<<2)>>2]=J}o=o+1|0}while((o|0)!=(d|0))}KMa(j);o=c[(NMa(NMa(j,A,t,0)|0,z,t,0)|0)+8>>2]|0;c[a>>2]=0;c[a+8>>2]=d;if(!t)L=0;else{d=c[q>>2]|0;q=-1;J=-1;K=0;do{I=c[o+(K<<2)>>2]|0;D=q;q=c[z+(I<<2)>>2]|0;G=J;J=c[A+(I<<2)>>2]|0;F=c[a>>2]|0;if((q|0)==(D|0)&(J|0)==(G|0))M=F;else{c[C+(F<<3)>>2]=q;c[C+(c[a>>2]<<3)+4>>2]=J;F=(c[a>>2]|0)+1|0;c[a>>2]=F;M=F}c[d+(((I>>>0)/3|0)*12|0)+(((I>>>0)%3|0)<<2)>>2]=M+-1;K=K+1|0}while((K|0)!=(t|0));L=c[a>>2]<<3}t=UJa(k,L,522096,209)|0;c[a+4>>2]=t;YEi(t|0,C|0,c[a>>2]<<3|0)|0;VJa(l,C);VJa(m,A);VJa(n,y);MMa(j);r=1;i=h;return r|0}dKa(bKa()|0,8,522096,145,522176,j);r=0;i=h;return r|0}function mIa(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h;if(!(lIa(a,d,f,g)|0)){k=0;i=h;return k|0}g=UJa(h+1|0,c[a>>2]<<3,522096,242)|0;f=a+16|0;c[f>>2]=g;PEi(g|0,0,c[a>>2]<<3|0)|0;g=(d|0)==0;if(g)l=c[f>>2]|0;else{m=c[a+12>>2]|0;n=c[f>>2]|0;o=0;do{p=n+(c[m+(o*12|0)>>2]<<3)+2|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;p=n+(c[m+(o*12|0)+4>>2]<<3)+2|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;p=n+(c[m+(o*12|0)+8>>2]<<3)+2|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;o=o+1|0}while((o|0)!=(d|0));l=n}c[l+4>>2]=0;n=c[a>>2]|0;if(n>>>0>1){o=0;m=1;do{o=(e[l+(m+-1<<3)+2>>1]|0)+o|0;c[l+(m<<3)+4>>2]=o;m=m+1|0;p=c[a>>2]|0}while(m>>>0<p>>>0);q=p}else q=n;n=q+-1|0;q=UJa(j,(e[l+(n<<3)+2>>1]|0)+(c[l+(n<<3)+4>>2]|0)<<2,522096,261)|0;c[a+20>>2]=q;if(g)r=c[f>>2]|0;else{g=c[a+12>>2]|0;n=c[f>>2]|0;f=0;do{l=n+(c[g+(f*12|0)>>2]<<3)+4|0;j=c[l>>2]|0;c[l>>2]=j+1;c[q+(j<<2)>>2]=f;j=n+(c[g+(f*12|0)+4>>2]<<3)+4|0;l=c[j>>2]|0;c[j>>2]=l+1;c[q+(l<<2)>>2]=f;l=n+(c[g+(f*12|0)+8>>2]<<3)+4|0;j=c[l>>2]|0;c[l>>2]=j+1;c[q+(j<<2)>>2]=f;f=f+1|0}while((f|0)!=(d|0));r=n}c[r+4>>2]=0;if((c[a>>2]|0)>>>0>1){s=0;t=1}else{k=1;i=h;return k|0}do{s=(e[r+(t+-1<<3)+2>>1]|0)+s|0;c[r+(t<<3)+4>>2]=s;t=t+1|0}while(t>>>0<(c[a>>2]|0)>>>0);k=1;i=h;return k|0}function nIa(d,f,h,j,k,l){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=0,Db=0,Eb=0,Fb=0;m=i;i=i+32|0;n=m;o=m+19|0;p=m+18|0;q=m+17|0;r=m+4|0;s=m+16|0;if((k|0)!=0?(t=(h|0)!=0,u=(j|0)==0,!(u&(t^1))):0){v=c[d>>2]|0;if(!v){dKa(bKa()|0,8,522096,323,522272,n);w=0;i=m;return w|0}x=c[d+4>>2]|0;if(!x){dKa(bKa()|0,8,522096,330,522328,n);w=0;i=m;return w|0}y=d+16|0;z=c[y>>2]|0;if(!z){dKa(bKa()|0,8,522096,337,522392,n);w=0;i=m;return w|0}A=c[d+20>>2]|0;if(!A){dKa(bKa()|0,8,522096,344,522464,n);w=0;i=m;return w|0}B=UJa(o,v,522096,349)|0;o=v;v=B;C=z;z=x;while(1){o=o+-1|0;x=b[C+2>>1]|0;D=x&65535;a:do if(x<<16>>16!=1){E=c[C+4>>2]|0;F=(c[A+(E<<2)>>2]|0)*3|0;if(x<<16>>16==2){G=(c[A+(E+1<<2)>>2]|0)*3|0;if(t){H=c[h+(F<<2)>>2]|0;I=c[h+(F+1<<2)>>2]|0;J=c[h+(F+2<<2)>>2]|0;K=c[h+(G<<2)>>2]|0;L=c[h+(G+1<<2)>>2]|0;M=c[h+(G+2<<2)>>2]|0}else{H=e[j+(F<<1)>>1]|0;I=e[j+(F+1<<1)>>1]|0;J=e[j+(F+2<<1)>>1]|0;K=e[j+(G<<1)>>1]|0;L=e[j+(G+1<<1)>>1]|0;M=e[j+(G+2<<1)>>1]|0}G=c[z>>2]|0;N=c[z+4>>2]|0;do if((G|0)==(H|0))if((N|0)!=(I|0))if((N|0)==(J|0))O=I;else P=29;else O=J;else{if((G|0)==(I|0)){if((N|0)==(H|0)){O=J;break}if((N|0)==(J|0)){O=H;break}else{P=29;break}}if((G|0)==(J|0))if((N|0)!=(I|0))if((N|0)==(H|0))O=I;else P=29;else O=H;else P=29}while(0);if((P|0)==29){P=0;O=-1}Q=ea(g[k+(L*12|0)>>2]);R=ea(g[k+(K*12|0)>>2]);U=ea(Q-R);Q=ea(g[k+(L*12|0)+4>>2]);V=ea(g[k+(K*12|0)+4>>2]);W=ea(Q-V);Q=ea(g[k+(L*12|0)+8>>2]);X=ea(g[k+(K*12|0)+8>>2]);Y=ea(Q-X);Q=ea(ea(g[k+(M*12|0)>>2])-R);Z=ea(ea(g[k+(M*12|0)+4>>2])-V);_=ea(ea(g[k+(M*12|0)+8>>2])-X);aa=ea(ea(W*_)-ea(Y*Z));ba=ea(ea(Y*Q)-ea(U*_));_=ea(ea(U*Z)-ea(W*Q));Q=ea(ea(_*_)+ea(ea(aa*aa)+ea(ba*ba)));if(Q>ea(0.0)){W=ea(ea(1.0)/ea(T(ea(Q))));ca=ea(aa*W);da=ea(ba*W);fa=ea(_*W)}else{ca=ea(0.0);da=ea(0.0);fa=ea(0.0)}W=ea(ea(ea(ca*R)+ea(da*V))+ea(fa*X));X=ea(ca*ea(g[k+(O*12|0)>>2]));V=ea(X+ea(da*ea(g[k+(O*12|0)+4>>2])));N=ea(ea(V+ea(fa*ea(g[k+(O*12|0)+8>>2])))-W)<ea(0.0);W=ea(g[k+(H*12|0)>>2]);V=ea(g[k+(H*12|0)+4>>2]);X=ea(g[k+(H*12|0)+8>>2]);R=ea(g[k+(I*12|0)>>2]);Z=ea(g[k+(I*12|0)+4>>2]);U=ea(g[k+(I*12|0)+8>>2]);Y=ea(g[k+(J*12|0)>>2]);ga=ea(g[k+(J*12|0)+4>>2]);ha=ea(R-W);R=ea(Z-V);Z=ea(U-X);U=ea(Y-W);W=ea(ga-V);V=ea(ea(g[k+(J*12|0)+8>>2])-X);X=ea(ea(R*V)-ea(Z*W));ga=ea(ea(Z*U)-ea(ha*V));V=ea(ea(ha*W)-ea(R*U));U=ea(T(ea(ea(V*V)+ea(ea(X*X)+ea(ga*ga)))));G=U>ea(0.0);if(N){if(G){R=ea(ea(1.0)/U);ia=ea(X*R);ja=ea(ga*R);ka=ea(V*R)}else{ia=X;ja=ga;ka=V}R=ea(T(ea(Q)));if(R>ea(0.0)){W=ea(ea(1.0)/R);la=ea(aa*W);ma=ea(ba*W);na=ea(_*W)}else{la=aa;ma=ba;na=_}W=ea(ea(ja*na)-ea(ka*ma));R=ea(ea(ka*la)-ea(ia*na));ha=ea(ea(ia*ma)-ea(ja*la));oa=ea(S(ea(+$(+(+ea(T(ea(ea(ha*ha)+ea(ea(W*W)+ea(R*R)))))),+(+ea(ea(ka*na)+ea(ea(ja*ma)+ea(ia*la))))))))>l;break}else{if(G){R=ea(ea(1.0)/U);pa=ea(X*R);qa=ea(ga*R);ra=ea(V*R)}else{pa=X;qa=ga;ra=V}V=ea(T(ea(Q)));if(V>ea(0.0)){Q=ea(ea(1.0)/V);sa=ea(aa*Q);ta=ea(ba*Q);ua=ea(_*Q)}else{sa=aa;ta=ba;ua=_}oa=ea(ea(ra*ua)+ea(ea(qa*ta)+ea(pa*sa)))<ea(-.999000012);break}}if(t){va=c[h+(F<<2)>>2]|0;wa=c[h+(F+1<<2)>>2]|0;xa=c[h+(F+2<<2)>>2]|0}else{va=e[j+(F<<1)>>1]|0;wa=e[j+(F+1<<1)>>1]|0;xa=e[j+(F+2<<1)>>1]|0}if((x&65535)>1){G=k+(va*12|0)|0;N=k+(va*12|0)+4|0;ya=k+(va*12|0)+8|0;za=k+(wa*12|0)|0;Aa=k+(wa*12|0)+4|0;Ba=k+(wa*12|0)+8|0;Ca=k+(xa*12|0)|0;Da=k+(xa*12|0)+4|0;Ea=k+(xa*12|0)+8|0;Fa=0;Ga=0;Ha=0;Ia=1;Ja=0;Ka=0;La=1;while(1){Ma=(c[A+(E+Ia<<2)>>2]|0)*3|0;if(t){Na=c[h+(Ma<<2)>>2]|0;Oa=c[h+(Ma+1<<2)>>2]|0;Pa=c[h+(Ma+2<<2)>>2]|0}else{Na=e[j+(Ma<<1)>>1]|0;Oa=e[j+(Ma+1<<1)>>1]|0;Pa=e[j+(Ma+2<<1)>>1]|0}if(((Na|0)==(va|0)|(Na|0)==(wa|0)|(Na|0)==(xa|0)?(Oa|0)==(va|0)|(Oa|0)==(wa|0)|(Oa|0)==(xa|0):0)?(Pa|0)==(va|0)|(Pa|0)==(wa|0)|(Pa|0)==(xa|0):0){_=ea(g[G>>2]);ba=ea(g[N>>2]);aa=ea(g[ya>>2]);Q=ea(g[za>>2]);V=ea(g[Aa>>2]);ga=ea(g[Ba>>2]);X=ea(g[Ca>>2]);R=ea(g[Da>>2]);U=ea(g[Ea>>2]);W=ea(g[k+(Na*12|0)>>2]);ha=ea(g[k+(Na*12|0)+4>>2]);Z=ea(g[k+(Na*12|0)+8>>2]);Y=ea(g[k+(Oa*12|0)>>2]);Qa=ea(g[k+(Oa*12|0)+4>>2]);Ra=ea(g[k+(Oa*12|0)+8>>2]);Sa=ea(g[k+(Pa*12|0)>>2]);Ta=ea(g[k+(Pa*12|0)+4>>2]);Ua=ea(g[k+(Pa*12|0)+8>>2]);Va=ea(Q-_);Q=ea(V-ba);V=ea(ga-aa);ga=ea(X-_);_=ea(R-ba);ba=ea(U-aa);aa=ea(ea(Q*ba)-ea(V*_));U=ea(ea(V*ga)-ea(Va*ba));ba=ea(ea(Va*_)-ea(Q*ga));ga=ea(T(ea(ea(ba*ba)+ea(ea(aa*aa)+ea(U*U)))));if(ga>ea(0.0)){Q=ea(ea(1.0)/ga);Wa=ea(aa*Q);Xa=ea(U*Q);Ya=ea(ba*Q)}else{Wa=aa;Xa=U;Ya=ba}ba=ea(Y-W);Y=ea(Qa-ha);Qa=ea(Ra-Z);Ra=ea(Sa-W);W=ea(Ta-ha);ha=ea(Ua-Z);Z=ea(ea(Y*ha)-ea(Qa*W));Ua=ea(ea(Qa*Ra)-ea(ba*ha));ha=ea(ea(ba*W)-ea(Y*Ra));Ra=ea(T(ea(ea(ha*ha)+ea(ea(Z*Z)+ea(Ua*Ua)))));if(Ra>ea(0.0)){Y=ea(ea(1.0)/Ra);Za=ea(Z*Y);_a=ea(Ua*Y);$a=ea(ha*Y)}else{Za=Z;_a=Ua;$a=ha}ab=Fa;bb=Ga;cb=Ha;db=ea(ea(Ya*$a)+ea(ea(Xa*_a)+ea(Wa*Za)))<ea(-.999000012)|Ja;eb=Ka;fb=La}else P=54;do if((P|0)==54){P=0;if((La|0)!=2){ab=Na;bb=Oa;cb=Pa;db=Ja;eb=Ka;fb=La+1|0;break}if(!((Na|0)==(Fa|0)|(Na|0)==(Ga|0)|(Na|0)==(Ha|0))){oa=1;break a}if(!((Oa|0)==(Fa|0)|(Oa|0)==(Ga|0)|(Oa|0)==(Ha|0))){oa=1;break a}if(!((Pa|0)==(Fa|0)|(Pa|0)==(Ga|0)|(Pa|0)==(Ha|0))){oa=1;break a}ha=ea(g[k+(Fa*12|0)>>2]);Ua=ea(g[k+(Fa*12|0)+4>>2]);Z=ea(g[k+(Fa*12|0)+8>>2]);Y=ea(g[k+(Ga*12|0)>>2]);Ra=ea(g[k+(Ga*12|0)+4>>2]);W=ea(g[k+(Ga*12|0)+8>>2]);ba=ea(g[k+(Ha*12|0)>>2]);Qa=ea(g[k+(Ha*12|0)+4>>2]);Ta=ea(g[k+(Ha*12|0)+8>>2]);Sa=ea(g[k+(Na*12|0)>>2]);U=ea(g[k+(Na*12|0)+4>>2]);aa=ea(g[k+(Na*12|0)+8>>2]);Q=ea(g[k+(Oa*12|0)>>2]);ga=ea(g[k+(Oa*12|0)+4>>2]);_=ea(g[k+(Oa*12|0)+8>>2]);Va=ea(g[k+(Pa*12|0)>>2]);V=ea(g[k+(Pa*12|0)+4>>2]);R=ea(g[k+(Pa*12|0)+8>>2]);X=ea(Y-ha);Y=ea(Ra-Ua);Ra=ea(W-Z);W=ea(ba-ha);ha=ea(Qa-Ua);Ua=ea(Ta-Z);Z=ea(ea(Y*Ua)-ea(Ra*ha));Ta=ea(ea(Ra*W)-ea(X*Ua));Ua=ea(ea(X*ha)-ea(Y*W));W=ea(T(ea(ea(Ua*Ua)+ea(ea(Z*Z)+ea(Ta*Ta)))));if(W>ea(0.0)){Y=ea(ea(1.0)/W);gb=ea(Z*Y);hb=ea(Ta*Y);ib=ea(Ua*Y)}else{gb=Z;hb=Ta;ib=Ua}Ua=ea(Q-Sa);Q=ea(ga-U);ga=ea(_-aa);_=ea(Va-Sa);Sa=ea(V-U);U=ea(R-aa);aa=ea(ea(Q*U)-ea(ga*Sa));R=ea(ea(ga*_)-ea(Ua*U));U=ea(ea(Ua*Sa)-ea(Q*_));_=ea(T(ea(ea(U*U)+ea(ea(aa*aa)+ea(R*R)))));if(_>ea(0.0)){Q=ea(ea(1.0)/_);jb=ea(aa*Q);kb=ea(R*Q);lb=ea(U*Q)}else{jb=aa;kb=R;lb=U}ab=Fa;bb=Ga;cb=Ha;db=Ja;eb=ea(ea(ib*lb)+ea(ea(hb*kb)+ea(gb*jb)))<ea(-.999000012)|Ka;fb=2}while(0);Ia=Ia+1|0;if(Ia>>>0>=D>>>0)break;else{Fa=ab;Ga=bb;Ha=cb;Ja=db;Ka=eb;La=fb}}La=(fb|0)==1;if((fb|0)==2){if(db|eb){U=ea(g[k+(ab*12|0)>>2]);R=ea(g[k+(ab*12|0)+4>>2]);aa=ea(g[k+(ab*12|0)+8>>2]);Q=ea(g[k+(va*12|0)>>2]);_=ea(g[k+(va*12|0)+4>>2]);Sa=ea(g[k+(va*12|0)+8>>2]);Ua=ea(g[k+(wa*12|0)>>2]);ga=ea(g[k+(wa*12|0)+4>>2]);V=ea(g[k+(wa*12|0)+8>>2]);Va=ea(g[k+(xa*12|0)>>2]);Ta=ea(g[k+(xa*12|0)+4>>2]);Z=ea(g[k+(xa*12|0)+8>>2]);Y=ea(g[k+(bb*12|0)>>2]);W=ea(g[k+(bb*12|0)+4>>2]);ha=ea(g[k+(bb*12|0)+8>>2]);X=ea(g[k+(cb*12|0)>>2]);Ra=ea(g[k+(cb*12|0)+4>>2]);Qa=ea(g[k+(cb*12|0)+8>>2]);ba=ea(Ua-Q);Ua=ea(ga-_);ga=ea(V-Sa);V=ea(Va-Q);Q=ea(Ta-_);_=ea(Z-Sa);Sa=ea(ea(Ua*_)-ea(ga*Q));Z=ea(ea(ga*V)-ea(ba*_));_=ea(ea(ba*Q)-ea(Ua*V));V=ea(T(ea(ea(_*_)+ea(ea(Sa*Sa)+ea(Z*Z)))));if(V>ea(0.0)){Ua=ea(ea(1.0)/V);mb=ea(Sa*Ua);nb=ea(Z*Ua);ob=ea(_*Ua)}else{mb=Sa;nb=Z;ob=_}_=ea(Y-U);Y=ea(W-R);W=ea(ha-aa);ha=ea(X-U);U=ea(Ra-R);R=ea(Qa-aa);aa=ea(ea(Y*R)-ea(W*U));Qa=ea(ea(W*ha)-ea(_*R));R=ea(ea(_*U)-ea(Y*ha));ha=ea(T(ea(ea(R*R)+ea(ea(aa*aa)+ea(Qa*Qa)))));if(ha>ea(0.0)){Y=ea(ea(1.0)/ha);pb=ea(aa*Y);qb=ea(Qa*Y);rb=ea(R*Y)}else{pb=aa;qb=Qa;rb=R}R=ea(ea(nb*rb)-ea(ob*qb));Qa=ea(ea(ob*pb)-ea(mb*rb));aa=ea(ea(mb*qb)-ea(nb*pb));oa=ea(S(ea(+$(+(+ea(T(ea(ea(aa*aa)+ea(ea(R*R)+ea(Qa*Qa)))))),+(+ea(ea(ob*rb)+ea(ea(nb*qb)+ea(mb*pb))))))))>l|La;break}Ka=c[z>>2]|0;Ja=c[z+4>>2]|0;do if((Ka|0)==(va|0))if((Ja|0)!=(wa|0))if((Ja|0)==(xa|0))sb=wa;else P=86;else sb=xa;else{if((Ka|0)==(wa|0)){if((Ja|0)==(va|0)){sb=xa;break}if((Ja|0)==(xa|0)){sb=va;break}else{P=86;break}}if((Ka|0)==(xa|0))if((Ja|0)!=(wa|0))if((Ja|0)==(va|0))sb=wa;else P=86;else sb=va;else P=86}while(0);if((P|0)==86){P=0;sb=-1}Qa=ea(g[k+(bb*12|0)>>2]);R=ea(g[k+(ab*12|0)>>2]);aa=ea(Qa-R);Qa=ea(g[k+(bb*12|0)+4>>2]);Y=ea(g[k+(ab*12|0)+4>>2]);ha=ea(Qa-Y);Qa=ea(g[k+(bb*12|0)+8>>2]);U=ea(g[k+(ab*12|0)+8>>2]);_=ea(Qa-U);Qa=ea(ea(g[k+(cb*12|0)>>2])-R);W=ea(ea(g[k+(cb*12|0)+4>>2])-Y);Ra=ea(ea(g[k+(cb*12|0)+8>>2])-U);X=ea(ea(ha*Ra)-ea(_*W));Z=ea(ea(_*Qa)-ea(aa*Ra));Ra=ea(ea(aa*W)-ea(ha*Qa));Qa=ea(ea(Ra*Ra)+ea(ea(X*X)+ea(Z*Z)));if(Qa>ea(0.0)){ha=ea(ea(1.0)/ea(T(ea(Qa))));tb=ea(X*ha);ub=ea(Z*ha);vb=ea(Ra*ha)}else{tb=ea(0.0);ub=ea(0.0);vb=ea(0.0)}ha=ea(ea(ea(tb*R)+ea(ub*Y))+ea(vb*U));U=ea(tb*ea(g[k+(sb*12|0)>>2]));Y=ea(U+ea(ub*ea(g[k+(sb*12|0)+4>>2])));if(ea(ea(Y+ea(vb*ea(g[k+(sb*12|0)+8>>2])))-ha)<ea(0.0)){ha=ea(g[k+(va*12|0)>>2]);Y=ea(g[k+(va*12|0)+4>>2]);U=ea(g[k+(va*12|0)+8>>2]);R=ea(g[k+(wa*12|0)>>2]);W=ea(g[k+(wa*12|0)+4>>2]);aa=ea(g[k+(wa*12|0)+8>>2]);_=ea(g[k+(xa*12|0)>>2]);Sa=ea(g[k+(xa*12|0)+4>>2]);Ua=ea(R-ha);R=ea(W-Y);W=ea(aa-U);aa=ea(_-ha);ha=ea(Sa-Y);Y=ea(ea(g[k+(xa*12|0)+8>>2])-U);U=ea(ea(R*Y)-ea(W*ha));Sa=ea(ea(W*aa)-ea(Ua*Y));Y=ea(ea(Ua*ha)-ea(R*aa));aa=ea(T(ea(ea(Y*Y)+ea(ea(U*U)+ea(Sa*Sa)))));if(aa>ea(0.0)){R=ea(ea(1.0)/aa);wb=ea(U*R);xb=ea(Sa*R);yb=ea(Y*R)}else{wb=U;xb=Sa;yb=Y}Y=ea(T(ea(Qa)));if(Y>ea(0.0)){Qa=ea(ea(1.0)/Y);zb=ea(X*Qa);Ab=ea(Z*Qa);Bb=ea(Ra*Qa)}else{zb=X;Ab=Z;Bb=Ra}Ra=ea(ea(xb*Bb)-ea(yb*Ab));Z=ea(ea(yb*zb)-ea(wb*Bb));X=ea(ea(wb*Ab)-ea(xb*zb));oa=ea(S(ea(+$(+(+ea(T(ea(ea(X*X)+ea(ea(Ra*Ra)+ea(Z*Z)))))),+(+ea(ea(yb*Bb)+ea(ea(xb*Ab)+ea(wb*zb))))))))>l|La}else oa=La}else oa=1}else oa=1}else oa=1;while(0);a[v>>0]=oa&1;if(!o)break;else{v=v+1|0;C=C+8|0;z=z+8|0}}z=d+8|0;if(c[z>>2]|0){C=c[d+12>>2]|0;v=0;do{o=C+(v*12|0)|0;oa=c[o>>2]|0;if((oa|0)>=0?(a[B+(oa&268435455)>>0]|0)!=0:0)c[o>>2]=oa|-2147483648;oa=C+(v*12|0)+4|0;o=c[oa>>2]|0;if((o|0)>=0?(a[B+(o&268435455)>>0]|0)!=0:0)c[oa>>2]=o|-2147483648;o=C+(v*12|0)+8|0;oa=c[o>>2]|0;if((oa|0)>=0?(a[B+(oa&268435455)>>0]|0)!=0:0)c[o>>2]=oa|-2147483648;v=v+1|0}while(v>>>0<(c[z>>2]|0)>>>0)}v=c[d>>2]|0;if(v){C=0;do{if(a[B+C>>0]|0){oa=(c[y>>2]|0)+(C<<3)|0;b[oa>>1]=e[oa>>1]|1}C=C+1|0}while(C>>>0<v>>>0)}VJa(p,B);if(f)if(t){B=0;p=0;while(1){v=p*3|0;C=c[h+(v<<2)>>2]|0;y=c[h+(v+1<<2)>>2]|0;oa=c[h+(v+2<<2)>>2]|0;v=C>>>0>B>>>0?C:B;C=y>>>0>v>>>0?y:v;v=oa>>>0>C>>>0?oa:C;p=p+1|0;if((p|0)==(f|0)){Cb=v;break}else B=v}}else{B=0;p=0;while(1){v=p*3|0;C=e[j+(v<<1)>>1]|0;oa=e[j+(v+1<<1)>>1]|0;y=e[j+(v+2<<1)>>1]|0;v=C>>>0>B>>>0?C:B;C=oa>>>0>v>>>0?oa:v;v=y>>>0>C>>>0?y:C;p=p+1|0;if((p|0)==(f|0)){Cb=v;break}else B=v}}else Cb=0;B=Cb+1|0;Cb=UJa(q,B,522096,651)|0;PEi(Cb|0,0,B|0)|0;B=c[z>>2]|0;if(B){q=r+4|0;f=r+8|0;p=c[d+12>>2]|0;v=0;do{if(!t){if(!u){C=v*3|0;c[r>>2]=e[j+(C<<1)>>1];c[q>>2]=e[j+(C+1<<1)>>1];c[f>>2]=e[j+(C+2<<1)>>1]}}else{C=v*3|0;c[r>>2]=c[h+(C<<2)>>2];c[q>>2]=c[h+(C+1<<2)>>2];c[f>>2]=c[h+(C+2<<2)>>2]}if((c[p+(v*12|0)>>2]|0)<0){a[Cb+(c[r+4>>2]|0)>>0]=1;a[Cb+(c[r>>2]|0)>>0]=1}if((c[p+(v*12|0)+4>>2]|0)<0){a[Cb+(c[r+8>>2]|0)>>0]=1;a[Cb+(c[r+4>>2]|0)>>0]=1}if((c[p+(v*12|0)+8>>2]|0)<0){a[Cb+(c[r+8>>2]|0)>>0]=1;a[Cb+(c[r>>2]|0)>>0]=1}v=v+1|0}while(v>>>0<B>>>0);if(B){B=c[d+12>>2]|0;d=0;v=0;r=0;p=0;while(1){if(!t)if(u){Db=r;Eb=v;Fb=d}else{f=p*3|0;Db=e[j+(f<<1)>>1]|0;Eb=e[j+(f+1<<1)>>1]|0;Fb=e[j+(f+2<<1)>>1]|0}else{f=p*3|0;Db=c[h+(f<<2)>>2]|0;Eb=c[h+(f+1<<2)>>2]|0;Fb=c[h+(f+2<<2)>>2]|0}f=B+(p*12|0)|0;q=c[f>>2]|0;if((q&1073741824|0)==0?(a[Cb+Db>>0]|0)!=0:0)c[f>>2]=q|1073741824;q=B+(p*12|0)+4|0;f=c[q>>2]|0;if((f&1073741824|0)==0?(a[Cb+Eb>>0]|0)!=0:0)c[q>>2]=f|1073741824;f=B+(p*12|0)+8|0;q=c[f>>2]|0;if((q&1073741824|0)==0?(a[Cb+Fb>>0]|0)!=0:0)c[f>>2]=q|1073741824;p=p+1|0;if(p>>>0>=(c[z>>2]|0)>>>0)break;else{d=Fb;v=Eb;r=Db}}}}VJa(s,Cb);w=1;i=m;return w|0}dKa(bKa()|0,8,522096,316,522224,n);w=0;i=m;return w|0}function oIa(a){a=a|0;c[a>>2]=0;c[a+12>>2]=0;c[a+4>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function pIa(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=d;return}function qIa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+4|0;a=c[d>>2]|0;if(a){jIa(a);VJa(b,a)}c[d>>2]=0;i=b;return}function rIa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+2|0;h=f+1|0;j=f;k=c[d>>2]|0;l=k+4|0;m=c[l>>2]|0;if(!m){i=f;return}n=UJa(f+3|0,m*12|0,522776,62)|0;m=k+12|0;if(c[l>>2]|0){k=0;do{o=n+(k*12|0)|0;p=(c[m>>2]|0)+((c[e+(k<<2)>>2]|0)*12|0)|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];k=k+1|0}while(k>>>0<(c[l>>2]|0)>>>0)}VJa(g,c[m>>2]|0);c[m>>2]=n;if(c[(c[d>>2]|0)+160>>2]|0){n=c[l>>2]|0;m=n>>>0>2147483647?-1:n<<1;if(!m){q=n;r=0}else{n=mKa()|0;g=c[(c[n>>2]|0)+8>>2]|0;k=pKa()|0;p=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[g&255](n,m,p?541936:544544,522776,70)|0;q=c[l>>2]|0;r=k}k=c[(c[d>>2]|0)+160>>2]|0;if(q){p=0;do{b[r+(p<<1)>>1]=b[k+(c[e+(p<<2)>>2]<<1)>>1]|0;p=p+1|0}while(p>>>0<q>>>0)}VJa(h,k);c[(c[d>>2]|0)+160>>2]=0;c[(c[d>>2]|0)+160>>2]=r}if(a[(c[d+8>>2]|0)+12>>0]|0){i=f;return}r=c[l>>2]|0;k=r>>>0>1073741823?-1:r<<2;if(!k){s=r;t=0}else{r=mKa()|0;h=c[(c[r>>2]|0)+8>>2]|0;q=pKa()|0;p=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[h&255](r,k,p?541832:544544,522776,79)|0;s=c[l>>2]|0;t=q}q=c[(c[d>>2]|0)+164>>2]|0;if(s){s=0;do{p=c[e+(s<<2)>>2]|0;if(!q)u=p;else u=c[q+(p<<2)>>2]|0;c[t+(s<<2)>>2]=u;s=s+1|0}while(s>>>0<(c[l>>2]|0)>>>0)}VJa(j,q);c[(c[d>>2]|0)+164>>2]=0;c[(c[d>>2]|0)+164>>2]=t;i=f;return}function sIa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im;d=i;i=i+32|0;e=d+8|0;f=d;gQa(c[b>>2]|0);h=c[b>>2]|0;c[e>>2]=0;c[e+4>>2]=0;j=e+8|0;c[j>>2]=0;k=h+4|0;l=c[k>>2]|0;c[f>>2]=523216;c[f+4>>2]=l;l=(a[h+156>>0]&2)==0;m=c[h+12>>2]|0;n=c[b+8>>2]|0;o=ea(g[n+40>>2]);AIa(h+32|0,c[h+8>>2]|0,c[h>>2]|0,l?0:m,l?m:0,c[k>>2]|0,e,f,o,c[n+32>>2]|0);rIa(b,c[e>>2]|0);b=c[j>>2]|0;if(!((b&2147483647|0)!=0&(b|0)>-1)){i=d;return 1}b=c[e>>2]|0;if(!b){i=d;return 1}e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,b);i=d;return 1}function tIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;VJa(b,c[(c[a>>2]|0)+164>>2]|0);c[(c[a>>2]|0)+164>>2]=0;d=c[a>>2]|0;e=d+4|0;f=c[e>>2]|0;g=f>>>0>1073741823?-1:f<<2;if(!g){h=d;j=0;k=f}else{f=mKa()|0;d=c[(c[f>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[d&255](f,g,m?541832:544544,522776,145)|0;h=c[a>>2]|0;j=l;k=c[e>>2]|0}c[h+164>>2]=j;if(!k){i=b;return}k=c[(c[a>>2]|0)+164>>2]|0;a=0;do{c[k+(a<<2)>>2]=a;a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=b;return}function uIa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0;f=i;i=i+32|0;h=f;j=f+4|0;k=f+27|0;l=f+26|0;m=f+25|0;n=f+24|0;o=c[d>>2]|0;p=d+8|0;q=c[p>>2]|0;if(c[q+28>>2]&1){r=ea(g[q+36>>2]);if(r==ea(0.0)){dKa(bKa()|0,2,522776,164,522872,h);s=ea(0.0)}else s=r}else s=ea(0.0);q=o+8|0;t=o+4|0;u=o+12|0;xIa(j,c[o>>2]|0,c[q>>2]|0,c[t>>2]|0,c[u>>2]|0,s);v=j+4|0;w=c[v>>2]|0;if(!w){x=0;yIa(j);i=f;return x|0}if(e){if((c[j>>2]|0)!=(c[o>>2]|0)){x=0;yIa(j);i=f;return x|0}if((w|0)!=(c[t>>2]|0)){x=0;yIa(j);i=f;return x|0}}VJa(k,c[(c[d>>2]|0)+164>>2]|0);c[(c[d>>2]|0)+164>>2]=0;k=j+16|0;if((c[k>>2]|0)!=0?(a[(c[p>>2]|0)+12>>0]|0)==0:0){w=c[v>>2]|0;e=w>>>0>1073741823?-1:w<<2;if(!e)y=0;else{z=mKa()|0;A=c[(c[z>>2]|0)+8>>2]|0;B=pKa()|0;C=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;y=Bn[A&255](z,e,C?541832:544544,522776,193)|0}c[(c[d>>2]|0)+164>>2]=y;YEi(c[(c[d>>2]|0)+164>>2]|0,c[k>>2]|0,w<<2|0)|0;k=c[d>>2]|0;if(c[k+160>>2]|0){y=w>>>0>2147483647?-1:w<<1;if(!y){D=k;E=0}else{k=mKa()|0;C=c[(c[k>>2]|0)+8>>2]|0;e=pKa()|0;z=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;e=Bn[C&255](k,y,z?541936:544544,522776,199)|0;D=c[d>>2]|0;E=e}if(!w)F=c[D+160>>2]|0;else{e=c[D+164>>2]|0;z=c[D+160>>2]|0;D=0;do{b[E+(D<<1)>>1]=b[z+(c[e+(D<<2)>>2]<<1)>>1]|0;D=D+1|0}while((D|0)!=(w|0));F=z}VJa(l,F);c[(c[d>>2]|0)+160>>2]=0;c[(c[d>>2]|0)+160>>2]=E}}E=c[o>>2]|0;if((E|0)==(c[j>>2]|0))G=E;else{VJa(m,c[q>>2]|0);c[q>>2]=0;hQa(c[d>>2]|0,c[j>>2]|0)|0;G=c[o>>2]|0}YEi(c[q>>2]|0,c[j+8>>2]|0,G*12|0)|0;G=c[t>>2]|0;if((G|0)==(c[v>>2]|0))H=G;else{VJa(n,c[u>>2]|0);c[u>>2]=0;iQa(c[d>>2]|0,c[v>>2]|0,1)|0;H=c[t>>2]|0}s=ea(g[(c[p>>2]|0)+16>>2]);r=ea(s*ea(s*ea(25.0e4)));p=c[q>>2]|0;if(!H){x=1;yIa(j);i=f;return x|0}H=c[j+12>>2]|0;q=c[u>>2]|0;u=0;v=0;while(1){d=v*3|0;n=c[H+(d<<2)>>2]|0;G=c[H+(d+1<<2)>>2]|0;o=c[H+(d+2<<2)>>2]|0;c[q+(v*12|0)>>2]=n;c[q+(v*12|0)+4>>2]=G;c[q+(v*12|0)+8>>2]=o;s=ea(g[p+(n*12|0)>>2]);I=ea(g[p+(G*12|0)>>2]);J=ea(s-I);K=ea(g[p+(n*12|0)+4>>2]);L=ea(g[p+(G*12|0)+4>>2]);M=ea(K-L);N=ea(g[p+(n*12|0)+8>>2]);O=ea(g[p+(G*12|0)+8>>2]);P=ea(N-O);if((!(ea(ea(ea(J*J)+ea(M*M))+ea(P*P))>=r)?(P=ea(g[p+(o*12|0)>>2]),M=ea(I-P),I=ea(g[p+(o*12|0)+4>>2]),J=ea(L-I),L=ea(g[p+(o*12|0)+8>>2]),Q=ea(O-L),!(ea(ea(ea(M*M)+ea(J*J))+ea(Q*Q))>=r)):0)?(Q=ea(P-s),s=ea(I-K),K=ea(L-N),!(ea(ea(ea(Q*Q)+ea(s*s))+ea(K*K))>=r)):0)R=u;else R=1;v=v+1|0;if(v>>>0>=(c[t>>2]|0)>>>0)break;else u=R}if(!R){x=1;yIa(j);i=f;return x|0}dKa(bKa()|0,2,522776,249,522936,h);x=1;yIa(j);i=f;return x|0}function vIa(b,f,g){b=b|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+16|0;VJa(h+5|0,c[(c[b>>2]|0)+152>>2]|0);c[(c[b>>2]|0)+152>>2]=0;VJa(h+4|0,c[(c[b>>2]|0)+168>>2]|0);c[(c[b>>2]|0)+168>>2]=0;j=c[b>>2]|0;k=c[j+4>>2]|0;if(!k){l=j;m=0}else{j=mKa()|0;n=c[(c[j>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;o=Bn[n&255](j,k,p?543296:544544,522776,267)|0;l=c[b>>2]|0;m=o}c[l+152>>2]=m;m=c[(c[b>>2]|0)+152>>2]|0;if(!(g|f)){PEi(m|0,56,k|0)|0;i=h;return}PEi(m|0,0,k|0)|0;m=c[(c[b>>2]|0)+12>>2]|0;if(k>>>0>1073741823){dKa(bKa()|0,4,522776,280,523032,h);i=h;return}wIa(b);g=b+4|0;l=c[g>>2]|0;if((l|0)!=0?(o=c[l+8>>2]|0,!((o|0)==0?1:(o|0)!=(c[(c[b>>2]|0)+4>>2]|0))):0){o=l;l=0;do{p=c[o+12>>2]|0;if((c[p+(l*12|0)>>2]|0)<=-1){j=(c[(c[b>>2]|0)+152>>2]|0)+l|0;a[j>>0]=d[j>>0]|0|8}if((c[p+(l*12|0)+4>>2]|0)<=-1){j=(c[(c[b>>2]|0)+152>>2]|0)+l|0;a[j>>0]=d[j>>0]|0|16}if((c[p+(l*12|0)+8>>2]|0)<=-1){p=(c[(c[b>>2]|0)+152>>2]|0)+l|0;a[p>>0]=d[p>>0]|0|32}l=l+1|0;o=c[g>>2]|0}while(l>>>0<(c[o+8>>2]|0)>>>0)}if(!f){i=h;return}f=k*3|0;o=f>>>0>1073741823?-1:f<<2;if(!o)q=0;else{f=mKa()|0;l=c[(c[f>>2]|0)+8>>2]|0;p=pKa()|0;j=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;q=Bn[l&255](f,o,j?541832:544544,522776,304)|0}c[(c[b>>2]|0)+168>>2]=q;PEi(c[(c[b>>2]|0)+168>>2]|0,-1,k*12|0)|0;k=c[g>>2]|0;g=c[k>>2]|0;q=c[k+20>>2]|0;if(!g){i=h;return}j=g;g=c[k+16>>2]|0;o=c[k+4>>2]|0;while(1){j=j+-1|0;if((e[g+2>>1]|0)>1){k=c[g+4>>2]|0;f=c[q+(k<<2)>>2]|0;l=c[q+(k+1<<2)>>2]|0;k=c[o>>2]|0;p=c[o+4>>2]|0;n=c[m+(f*12|0)>>2]|0;r=(n|0)==(k|0);if(r?(c[m+(f*12|0)+4>>2]|0)==(p|0):0)s=0;else t=24;do if((t|0)==24){t=0;u=(n|0)==(p|0);if(u?(c[m+(f*12|0)+4>>2]|0)==(k|0):0){s=0;break}if(r?(c[m+(f*12|0)+8>>2]|0)==(p|0):0){s=2;break}if(u?(c[m+(f*12|0)+8>>2]|0)==(k|0):0){s=2;break}u=c[m+(f*12|0)+4>>2]|0;if((u|0)==(k|0)?(c[m+(f*12|0)+8>>2]|0)==(p|0):0){s=1;break}if((u|0)==(p|0)?(c[m+(f*12|0)+8>>2]|0)==(k|0):0){s=1;break}s=255}while(0);r=c[m+(l*12|0)>>2]|0;n=(r|0)==(k|0);if(n?(c[m+(l*12|0)+4>>2]|0)==(p|0):0)v=0;else t=37;do if((t|0)==37){t=0;u=(r|0)==(p|0);if(u?(c[m+(l*12|0)+4>>2]|0)==(k|0):0){v=0;break}if(n?(c[m+(l*12|0)+8>>2]|0)==(p|0):0){v=2;break}if(u?(c[m+(l*12|0)+8>>2]|0)==(k|0):0){v=2;break}u=c[m+(l*12|0)+4>>2]|0;if((u|0)==(k|0)?(c[m+(l*12|0)+8>>2]|0)==(p|0):0){v=1;break}if((u|0)==(p|0)?(c[m+(l*12|0)+8>>2]|0)==(k|0):0){v=1;break}v=255}while(0);k=c[(c[b>>2]|0)+168>>2]|0;c[k+(s+(f*3|0)<<2)>>2]=l;c[k+(v+(l*3|0)<<2)>>2]=f}if(!j)break;else{g=g+8|0;o=o+8|0}}i=h;return}function wIa(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;h=f+16|0;c[h>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;b[f+12>>1]=0;g[f+20>>2]=ea(.100000001);j=c[d>>2]|0;c[f>>2]=c[j+4>>2];if(!(a[j+156>>0]&2)){c[f+4>>2]=c[j+12>>2];c[f+8>>2]=0}else{c[f+4>>2]=0;c[f+8>>2]=c[j+12>>2]}a[f+12>>0]=1;a[f+13>>0]=1;c[h>>2]=c[j+8>>2];j=mKa()|0;h=c[(c[j>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[h&255](j,24,l?523080:544544,522776,370)|0;oIa(k);l=d+4|0;c[l>>2]=k;if(kIa(k,f)|0){i=e;return}f=c[l>>2]|0;if(f){jIa(f);VJa(e+24|0,f)}c[l>>2]=0;i=e;return}function xIa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0;j=i;i=i+16|0;l=j+8|0;m=j+9|0;n=j+3|0;o=j+6|0;p=j+5|0;q=j+2|0;r=b*12|0;s=UJa(j,r,523232,78)|0;t=UJa(j+4|0,e*12|0,523232,81)|0;u=UJa(j+7|0,e<<2,523232,83)|0;if(h!=ea(0.0)){v=b<<2;w=UJa(j+1|0,v,523232,88)|0;x=ea(ea(1.0)/h);if(!b){y=v;z=w}else{A=0;do{c[w+(A<<2)>>2]=A;h=ea(R(ea(ea(x*ea(g[d+(A*12|0)>>2]))+ea(.5))));B=ea(R(ea(ea(x*ea(g[d+(A*12|0)+4>>2]))+ea(.5))));C=ea(R(ea(ea(x*ea(g[d+(A*12|0)+8>>2]))+ea(.5))));g[s+(A*12|0)>>2]=h;g[s+(A*12|0)+4>>2]=B;g[s+(A*12|0)+8>>2]=C;A=A+1|0}while((A|0)!=(b|0));y=v;z=w}}else{YEi(s|0,d|0,r|0)|0;y=b<<2;z=0}r=e>>>0<b>>>0?b:e;w=r>>>1|r;v=w>>>2|w;w=v>>>4|v;v=w>>>8|w;w=v>>>16|v;v=w+1|0;A=UJa(l,v+r<<2,523232,107)|0;r=v<<2;PEi(A|0,-1,r|0)|0;l=UJa(m,y,523232,112)|0;PEi(l|0,-1,y|0)|0;y=e*3|0;if(y){m=0;do{D=c[f+(m<<2)>>2]|0;if(D>>>0<b>>>0)c[l+(D<<2)>>2]=0;m=m+1|0}while((m|0)!=(y|0))}if(b)if(!z){y=0;m=0;while(1){D=l+(y<<2)|0;a:do if((c[D>>2]|0)==-1)E=m;else{F=c[s+(y*12|0)>>2]|0;G=s+(y*12|0)+4|0;H=c[G>>2]|0;I=s+(y*12|0)+8|0;J=c[I>>2]|0;K=(H*11|0)+F+(da(J,-17)|0)&2147483647;L=A+(((K>>>12^K^K>>>22)&w)<<2)|0;K=c[L>>2]|0;x=(c[k>>2]=F,ea(g[k>>2]));C=(c[k>>2]=H,ea(g[k>>2]));B=(c[k>>2]=J,ea(g[k>>2]));b:do if((K|0)!=-1){J=K;while(1){if((!(ea(g[s+(J*12|0)>>2])!=x)?!(ea(g[s+(J*12|0)+4>>2])!=C):0)?!(ea(g[s+(J*12|0)+8>>2])!=B):0)break;H=c[A+(J+v<<2)>>2]|0;if((H|0)==-1)break b;else J=H}c[D>>2]=J;E=m;break a}while(0);c[D>>2]=m;g[s+(m*12|0)>>2]=x;g[s+(m*12|0)+4>>2]=ea(g[G>>2]);g[s+(m*12|0)+8>>2]=ea(g[I>>2]);c[A+(m+v<<2)>>2]=c[L>>2];c[L>>2]=m;E=m+1|0}while(0);y=y+1|0;if((y|0)==(b|0)){M=E;break}else m=E}}else{E=0;m=0;while(1){y=l+(E<<2)|0;c:do if((c[y>>2]|0)==-1)N=m;else{D=c[s+(E*12|0)>>2]|0;K=s+(E*12|0)+4|0;H=c[K>>2]|0;F=s+(E*12|0)+8|0;O=c[F>>2]|0;P=(H*11|0)+D+(da(O,-17)|0)&2147483647;Q=A+(((P>>>12^P^P>>>22)&w)<<2)|0;P=c[Q>>2]|0;B=(c[k>>2]=D,ea(g[k>>2]));C=(c[k>>2]=H,ea(g[k>>2]));h=(c[k>>2]=O,ea(g[k>>2]));d:do if((P|0)!=-1){O=P;while(1){if((!(ea(g[s+(O*12|0)>>2])!=B)?!(ea(g[s+(O*12|0)+4>>2])!=C):0)?!(ea(g[s+(O*12|0)+8>>2])!=h):0)break;H=c[A+(O+v<<2)>>2]|0;if((H|0)==-1)break d;else O=H}c[y>>2]=O;N=m;break c}while(0);c[y>>2]=m;g[s+(m*12|0)>>2]=B;g[s+(m*12|0)+4>>2]=ea(g[K>>2]);g[s+(m*12|0)+8>>2]=ea(g[F>>2]);c[z+(m<<2)>>2]=E;c[A+(m+v<<2)>>2]=c[Q>>2];c[Q>>2]=m;N=m+1|0}while(0);E=E+1|0;if((E|0)==(b|0)){M=N;break}else m=N}}else M=0;if(!e)S=0;else{N=f;f=0;m=0;while(1){E=c[N>>2]|0;y=c[N+4>>2]|0;P=c[N+8>>2]|0;N=N+12|0;if((E>>>0<b>>>0&y>>>0<b>>>0&P>>>0<b>>>0?(h=ea(g[d+(E*12|0)>>2]),C=ea(h-ea(g[d+(y*12|0)>>2])),x=ea(g[d+(E*12|0)+4>>2]),T=ea(x-ea(g[d+(y*12|0)+4>>2])),U=ea(g[d+(E*12|0)+8>>2]),V=ea(U-ea(g[d+(y*12|0)+8>>2])),W=ea(h-ea(g[d+(P*12|0)>>2])),h=ea(x-ea(g[d+(P*12|0)+4>>2])),x=ea(U-ea(g[d+(P*12|0)+8>>2])),U=ea(ea(T*x)-ea(V*h)),X=ea(ea(V*W)-ea(C*x)),x=ea(ea(C*h)-ea(T*W)),!(ea(ea(x*x)+ea(ea(U*U)+ea(X*X)))==ea(0.0))):0)?(L=c[l+(E<<2)>>2]|0,E=c[l+(y<<2)>>2]|0,y=c[l+(P<<2)>>2]|0,!((L|0)==(E|0)|(E|0)==(y|0)|(y|0)==(L|0))):0){P=m*3|0;c[t+(P<<2)>>2]=L;c[t+(P+1<<2)>>2]=E;c[t+(P+2<<2)>>2]=y;Y=m+1|0}else Y=m;f=f+1|0;if((f|0)==(e|0)){S=Y;break}else m=Y}}VJa(n,l);PEi(A|0,-1,r|0)|0;if(!S){Z=1;_=0}else{r=0;l=1;n=0;while(1){Y=t+(r*12|0)|0;m=c[Y>>2]|0;e=c[t+(r*12|0)+4>>2]|0;f=c[t+(r*12|0)+8>>2]|0;b=m-e-f^f>>>13;N=e-f-b^b<<8;y=f-b-N^N>>>13;P=b-N-y^y>>>12;b=N-y-P^P<<16;N=y-P-b^b>>>5;y=P-b-N^N>>>3;P=b-N-y^y<<10;b=A+(((N-y-P^P>>>15)&w)<<2)|0;P=c[b>>2]|0;e:do if((P|0)==-1)$=41;else{y=P;while(1){if(((c[t+(y*12|0)>>2]|0)==(m|0)?(c[t+(y*12|0)+4>>2]|0)==(e|0):0)?(c[t+(y*12|0)+8>>2]|0)==(f|0):0){aa=l;ba=n;break e}y=c[A+(y+v<<2)>>2]|0;if((y|0)==-1){$=41;break}}}while(0);if(($|0)==41){$=0;c[u+(n<<2)>>2]=r;f=t+(n*12|0)|0;c[f+0>>2]=c[Y+0>>2];c[f+4>>2]=c[Y+4>>2];c[f+8>>2]=c[Y+8>>2];c[A+(n+v<<2)>>2]=c[b>>2];c[b>>2]=n;aa=(r|0)==(n|0)&l;ba=n+1|0}r=r+1|0;if((r|0)==(S|0)){Z=aa;_=ba;break}else{l=aa;n=ba}}}VJa(o,A);if(z){if(M){A=0;do{o=c[z+(A<<2)>>2]|0;g[s+(A*12|0)>>2]=ea(g[d+(o*12|0)>>2]);g[s+(A*12|0)+4>>2]=ea(g[d+(o*12|0)+4>>2]);g[s+(A*12|0)+8>>2]=ea(g[d+(o*12|0)+8>>2]);A=A+1|0}while((A|0)!=(M|0))}VJa(p,z)}c[a>>2]=M;c[a+4>>2]=_;c[a+8>>2]=s;c[a+12>>2]=t;if(Z){VJa(q,u);c[a+16>>2]=0;i=j;return}else{c[a+16>>2]=u;i=j;return}}function yIa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+16|0;VJa(b+2|0,c[d>>2]|0);c[d>>2]=0;d=a+12|0;VJa(b+1|0,c[d>>2]|0);c[d>>2]=0;d=a+8|0;VJa(b,c[d>>2]|0);c[d>>2]=0;i=b;return}function zIa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;if(!(_Ma(72,70,72,70,0,e,d)|0)){h=0;i=f;return h|0}VMa(c[a+16>>2]|0,e,d);VMa(c[a+20>>2]|0,e,d);WMa(ea(g[a+24>>2]),e,d);WMa(ea(g[a+28>>2]),e,d);WMa(ea(g[a+32>>2]),e,d);WMa(ea(g[a+40>>2]),e,d);WMa(ea(g[a+44>>2]),e,d);UMa(b[a+48>>1]|0,e,d);VMa(c[a+52>>2]|0,e,d);WMa(ea(g[a+56>>2]),e,d);WMa(ea(g[a+60>>2]),e,d);WMa(ea(g[a+64>>2]),e,d);WMa(ea(g[a+68>>2]),e,d);WMa(ea(g[a+72>>2]),e,d);WMa(ea(g[a+76>>2]),e,d);VMa(c[a+80>>2]|0,e,d);VMa(c[a+84>>2]|0,e,d);VMa(c[a+88>>2]|0,e,d);VMa(c[a+92>>2]|0,e,d);VMa(c[a+96>>2]|0,e,d);j=a+100|0;VMa(c[j>>2]|0,e,d);WMa(ea(g[a+104>>2]),e,d);WMa(ea(g[a+108>>2]),e,d);if(!(c[j>>2]|0)){h=1;i=f;return h|0}k=a+36|0;a=0;do{l=c[k>>2]|0;UMa(b[l+(a<<2)>>1]|0,e,d);xo[c[c[d>>2]>>2]&2047](d,l+(a<<2)+2|0,1)|0;xo[c[c[d>>2]>>2]&2047](d,l+(a<<2)+3|0,1)|0;a=a+1|0}while(a>>>0<(c[j>>2]|0)>>>0);h=1;i=f;return h|0}function AIa(a,b,d,f,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;d=i;i=i+368|0;o=d+176|0;p=d+280|0;q=d+160|0;r=d+272|0;s=d+68|0;t=d+64|0;u=d+148|0;v=d+116|0;w=d+120|0;x=d+132|0;y=d+136|0;z=d+276|0;A=d+284|0;B=d+336|0;C=d+340|0;D=d+232|0;E=d+236|0;F=d+248|0;G=d+256|0;H=d+264|0;I=d+80|0;J=d+88|0;K=d;L=d+296|0;M=d+308|0;N=d+352|0;O=d+164|0;P=d+32|0;c[O>>2]=0;Q=O+4|0;c[Q>>2]=0;R=O+8|0;c[R>>2]=0;S=(j|0)==0;if(!S){z5a(O,j);T=P+4|0;U=P+8|0;V=P+12|0;W=P+16|0;X=P+20|0;Y=P+24|0;Z=P+28|0;if(!f){_=ea(3402823469999999843913219.0e14);$=ea(-3402823469999999843913219.0e14);aa=ea(3402823469999999843913219.0e14);ba=ea(-3402823469999999843913219.0e14);ca=ea(3402823469999999843913219.0e14);da=ea(-3402823469999999843913219.0e14);fa=0;while(1){ga=fa*3|0;ha=c[h+(ga<<2)>>2]|0;ia=c[h+(ga+1<<2)>>2]|0;ja=c[h+(ga+2<<2)>>2]|0;ka=ea(g[b+(ha*12|0)>>2]);la=ea(g[b+(ha*12|0)+4>>2]);ma=ea(g[b+(ha*12|0)+8>>2]);na=ea(g[b+(ia*12|0)>>2]);oa=ea(g[b+(ia*12|0)+4>>2]);pa=ea(g[b+(ia*12|0)+8>>2]);qa=ea(g[b+(ja*12|0)>>2]);ra=ea(g[b+(ja*12|0)+4>>2]);sa=ea(g[b+(ja*12|0)+8>>2]);ta=ka<na?ka:na;ua=la<oa?la:oa;va=ma<pa?ma:pa;wa=ea((ta<qa?ta:qa)+ea(-.000500000024));ta=ea((ua<ra?ua:ra)+ea(-.000500000024));ua=ea((va<sa?va:sa)+ea(-.000500000024));va=ka>na?ka:na;na=la>oa?la:oa;oa=ma>pa?ma:pa;pa=ea((va>qa?va:qa)+ea(.000500000024));qa=ea((na>ra?na:ra)+ea(.000500000024));ra=ea((oa>sa?oa:sa)+ea(.000500000024));sa=_<wa?_:wa;oa=ca<ta?ca:ta;na=aa<ua?aa:ua;va=$>pa?$:pa;ma=da>qa?da:qa;la=ba>ra?ba:ra;g[P>>2]=wa;g[T>>2]=ta;g[U>>2]=ua;g[V>>2]=ea(0.0);g[W>>2]=pa;g[X>>2]=qa;g[Y>>2]=ra;g[Z>>2]=ea(0.0);ja=c[Q>>2]|0;if((c[R>>2]&2147483647)>>>0>ja>>>0){ia=(c[O>>2]|0)+(ja<<5)|0;if(ia){c[ia+0>>2]=c[P+0>>2];c[ia+4>>2]=c[P+4>>2];c[ia+8>>2]=c[P+8>>2];c[ia+12>>2]=c[P+12>>2];c[ia+16>>2]=c[P+16>>2];c[ia+20>>2]=c[P+20>>2];c[ia+24>>2]=c[P+24>>2];c[ia+28>>2]=c[P+28>>2]}c[Q>>2]=ja+1}else A5a(O,P)|0;fa=fa+1|0;if((fa|0)==(j|0)){xa=sa;ya=va;za=na;Aa=la;Ba=oa;Ca=ma;break}else{_=sa;$=va;aa=na;ba=la;ca=oa;da=ma}}}else{da=ea(3402823469999999843913219.0e14);ca=ea(-3402823469999999843913219.0e14);ba=ea(3402823469999999843913219.0e14);aa=ea(-3402823469999999843913219.0e14);$=ea(3402823469999999843913219.0e14);_=ea(-3402823469999999843913219.0e14);fa=0;while(1){h=fa*3|0;ja=e[f+(h<<1)>>1]|0;ia=e[f+(h+1<<1)>>1]|0;ha=e[f+(h+2<<1)>>1]|0;ma=ea(g[b+(ja*12|0)>>2]);oa=ea(g[b+(ja*12|0)+4>>2]);la=ea(g[b+(ja*12|0)+8>>2]);na=ea(g[b+(ia*12|0)>>2]);va=ea(g[b+(ia*12|0)+4>>2]);sa=ea(g[b+(ia*12|0)+8>>2]);ra=ea(g[b+(ha*12|0)>>2]);qa=ea(g[b+(ha*12|0)+4>>2]);pa=ea(g[b+(ha*12|0)+8>>2]);ua=ma<na?ma:na;ta=oa<va?oa:va;wa=la<sa?la:sa;ka=ea((ua<ra?ua:ra)+ea(-.000500000024));ua=ea((ta<qa?ta:qa)+ea(-.000500000024));ta=ea((wa<pa?wa:pa)+ea(-.000500000024));wa=ma>na?ma:na;na=oa>va?oa:va;va=la>sa?la:sa;sa=ea((wa>ra?wa:ra)+ea(.000500000024));ra=ea((na>qa?na:qa)+ea(.000500000024));qa=ea((va>pa?va:pa)+ea(.000500000024));pa=da<ka?da:ka;va=$<ua?$:ua;na=ba<ta?ba:ta;wa=ca>sa?ca:sa;la=_>ra?_:ra;oa=aa>qa?aa:qa;g[P>>2]=ka;g[T>>2]=ua;g[U>>2]=ta;g[V>>2]=ea(0.0);g[W>>2]=sa;g[X>>2]=ra;g[Y>>2]=qa;g[Z>>2]=ea(0.0);ha=c[Q>>2]|0;if((c[R>>2]&2147483647)>>>0>ha>>>0){ia=(c[O>>2]|0)+(ha<<5)|0;if(ia){c[ia+0>>2]=c[P+0>>2];c[ia+4>>2]=c[P+4>>2];c[ia+8>>2]=c[P+8>>2];c[ia+12>>2]=c[P+12>>2];c[ia+16>>2]=c[P+16>>2];c[ia+20>>2]=c[P+20>>2];c[ia+24>>2]=c[P+24>>2];c[ia+28>>2]=c[P+28>>2]}c[Q>>2]=ha+1}else A5a(O,P)|0;fa=fa+1|0;if((fa|0)==(j|0)){xa=pa;ya=wa;za=na;Aa=oa;Ba=va;Ca=la;break}else{da=pa;ca=wa;ba=na;aa=oa;$=va;_=la}}}}else{xa=ea(3402823469999999843913219.0e14);ya=ea(-3402823469999999843913219.0e14);za=ea(3402823469999999843913219.0e14);Aa=ea(-3402823469999999843913219.0e14);Ba=ea(3402823469999999843913219.0e14);Ca=ea(-3402823469999999843913219.0e14)}fa=c[O>>2]|0;c[p>>2]=0;xUa(k,0,p);p=j+1|0;P=k+8|0;if((c[P>>2]&2147483647)>>>0<p>>>0)yUa(k,p);c[q>>2]=0;p=k+4|0;if(!S){Q=0;do{Z=c[p>>2]|0;if((c[P>>2]&2147483647)>>>0>Z>>>0){Y=(c[k>>2]|0)+(Z<<2)|0;if(!Y)Da=Z;else{c[Y>>2]=Q;Da=c[p>>2]|0}c[p>>2]=Da+1;Ea=Q}else{cUa(k,q)|0;Ea=c[q>>2]|0}Q=Ea+1|0;c[q>>2]=Q}while(Q>>>0<j>>>0)}c[r>>2]=-1412567295;Q=c[p>>2]|0;if((c[P>>2]&2147483647)>>>0>Q>>>0){P=(c[k>>2]|0)+(Q<<2)|0;if(!P)Fa=Q;else{c[P>>2]=-1412567295;Fa=c[p>>2]|0}c[p>>2]=Fa+1}else cUa(k,r)|0;c[s>>2]=0;r=s+4|0;c[r>>2]=0;Fa=s+8|0;c[Fa>>2]=0;P=j<<1;if(P)B5a(s,P);c[t>>2]=0;if(!n){c[v>>2]=0;c[u>>2]=0;c[u+4>>2]=0;n=u+8|0;c[n>>2]=0;xUa(u,j,v);c[x>>2]=0;c[w>>2]=0;c[w+4>>2]=0;v=w+8|0;c[v>>2]=0;xUa(w,j,x);c[z>>2]=0;c[y>>2]=0;c[y+4>>2]=0;x=y+8|0;c[x>>2]=0;xUa(y,j,z);c[B>>2]=0;c[A>>2]=0;z=A+4|0;c[z>>2]=0;Q=A+8|0;c[Q>>2]=0;xUa(A,j,B);c[D>>2]=0;c[C>>2]=0;B=C+4|0;c[B>>2]=0;q=C+8|0;c[q>>2]=0;xUa(C,j,D);c[F>>2]=0;c[E>>2]=0;D=E+4|0;c[D>>2]=0;Ea=E+8|0;c[Ea>>2]=0;xUa(E,j,F);F=c[A>>2]|0;A=j<<2;YEi(F|0,c[k>>2]|0,A|0)|0;Da=c[C>>2]|0;YEi(Da|0,c[k>>2]|0,A|0)|0;C=c[E>>2]|0;YEi(C|0,c[k>>2]|0,A|0)|0;A=c[z>>2]|0;c[G>>2]=0;c[G+4>>2]=fa;C5a(F,A,G,o);if(S){G=c[B>>2]|0;c[H>>2]=1;c[H+4>>2]=fa;C5a(Da,G,H,o)}else{G=c[u>>2]|0;A=0;do{c[G+(c[F+(A<<2)>>2]<<2)>>2]=A;A=A+1|0}while((A|0)!=(j|0));A=c[B>>2]|0;c[H>>2]=1;c[H+4>>2]=fa;C5a(Da,A,H,o);H=c[w>>2]|0;A=0;do{c[H+(c[Da+(A<<2)>>2]<<2)>>2]=A;A=A+1|0}while((A|0)!=(j|0))}A=c[D>>2]|0;c[I>>2]=2;c[I+4>>2]=fa;C5a(C,A,I,o);I=c[y>>2]|0;if(!S){S=0;do{c[I+(c[C+(S<<2)>>2]<<2)>>2]=S;S=S+1|0}while((S|0)!=(j|0))}S=c[k>>2]|0;y=c[u>>2]|0;u=c[w>>2]|0;c[o>>2]=S;c[o+8>>2]=fa;c[o+20>>2]=F;c[o+24>>2]=Da;c[o+28>>2]=C;c[o+32>>2]=y;c[o+36>>2]=u;c[o+40>>2]=I;c[o+48>>2]=j;w=j>>>0>1073741823?-1:j<<2;A=o+12|0;c[A>>2]=zCi(w)|0;D=o+16|0;c[D>>2]=zCi(w)|0;H=P|1;P=o+4|0;c[P>>2]=zCi(H>>>0>1073741823?-1:H<<2)|0;H=o+44|0;c[H>>2]=zCi(w)|0;w=m<ea(0.0);B=~~ea(m*ea(15.0))>>>0;G=w?0:B;c[o+52>>2]=G>>>0<14?G:14;D5a(o,S,j,s,t,0,0);S=c[A>>2]|0;if(S)BCi(S);c[A>>2]=0;A=c[D>>2]|0;if(A)BCi(A);c[D>>2]=0;D=c[P>>2]|0;if(D)BCi(D);c[P>>2]=0;P=c[H>>2]|0;if(P)BCi(P);P=c[Ea>>2]|0;if(!((P|0)<0|(P&2147483647|0)==0|(C|0)==0)){P=mKa()|0;In[c[(c[P>>2]|0)+12>>2]&4095](P,C)}C=c[q>>2]|0;if(!((C|0)<0|(C&2147483647|0)==0|(Da|0)==0)){C=mKa()|0;In[c[(c[C>>2]|0)+12>>2]&4095](C,Da)}Da=c[Q>>2]|0;if(!((Da|0)<0|(Da&2147483647|0)==0|(F|0)==0)){Da=mKa()|0;In[c[(c[Da>>2]|0)+12>>2]&4095](Da,F)}F=c[x>>2]|0;if(!((F|0)<0|(F&2147483647|0)==0|(I|0)==0)){F=mKa()|0;In[c[(c[F>>2]|0)+12>>2]&4095](F,I)}I=c[v>>2]|0;if(!((I|0)<0|(I&2147483647|0)==0|(u|0)==0)){I=mKa()|0;In[c[(c[I>>2]|0)+12>>2]&4095](I,u)}u=c[n>>2]|0;if(!((u|0)<0|(u&2147483647|0)==0|(y|0)==0)){u=mKa()|0;In[c[(c[u>>2]|0)+12>>2]&4095](u,y)}}else{E5a(J,c[k>>2]|0,fa,j,m);F5a(J,c[k>>2]|0,(c[p>>2]|0)+-1|0,s,t,K,0);K=c[J+20>>2]|0;if((K&2147483647|0)!=0&(K|0)>-1?(K=c[J+12>>2]|0,(K|0)!=0):0){J=mKa()|0;In[c[(c[J>>2]|0)+12>>2]&4095](J,K)}}c[p>>2]=(c[p>>2]|0)+-1;c[L>>2]=0;p=L+4|0;c[p>>2]=0;K=L+8|0;c[K>>2]=0;J=c[r>>2]|0;if(!J)Ga=0;else{G5a(L,J);r=c[s>>2]|0;k=M+24|0;j=M+8|0;fa=M+4|0;y=M+20|0;u=M+16|0;n=M+12|0;I=-1;v=0;while(1){F=r+(v<<5)+28|0;x=c[k>>2]|0;c[k>>2]=(c[F>>2]|0)>0?x|1:x&-2;x=c[r+(v<<5)+24>>2]|0;do if((x|0)!=-1){g[M>>2]=ea(g[r+(v<<5)>>2]);g[fa>>2]=ea(g[r+(v<<5)+4>>2]);g[j>>2]=ea(g[r+(v<<5)+8>>2]);g[n>>2]=ea(g[r+(v<<5)+12>>2]);g[u>>2]=ea(g[r+(v<<5)+16>>2]);g[y>>2]=ea(g[r+(v<<5)+20>>2]);if((c[F>>2]|0)>0){c[k>>2]=x;Dn[c[(c[l>>2]|0)+8>>2]&511](l,k,x,c[F>>2]|0);Ha=I;break}else{c[k>>2]=x*28;Ha=I;break}}else{Da=(I|0)==-1?c[p>>2]|0:I;g[j>>2]=ea(3402823469999999843913219.0e14);g[fa>>2]=ea(3402823469999999843913219.0e14);g[M>>2]=ea(3402823469999999843913219.0e14);g[y>>2]=ea(-3402823469999999843913219.0e14);g[u>>2]=ea(-3402823469999999843913219.0e14);g[n>>2]=ea(-3402823469999999843913219.0e14);c[k>>2]=Da*28|1;Ha=Da}while(0);x=c[p>>2]|0;if((c[K>>2]&2147483647)>>>0>x>>>0){F=(c[L>>2]|0)+(x*28|0)|0;if(F){c[F+0>>2]=c[M+0>>2];c[F+4>>2]=c[M+4>>2];c[F+8>>2]=c[M+8>>2];c[F+12>>2]=c[M+12>>2];c[F+16>>2]=c[M+16>>2];c[F+20>>2]=c[M+20>>2];c[F+24>>2]=c[M+24>>2]}c[p>>2]=x+1}else H5a(L,M)|0;v=v+1|0;if((v|0)==(J|0))break;else I=Ha}Ga=c[p>>2]|0}g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);c[a+76>>2]=Ga;p=Ga>>>2;Ga=a+80|0;c[Ga>>2]=p;Ha=UJa(N,(p*112|0)+131|0,523480,862)|0;if(!Ha)Ia=0;else{p=Ha+131&-128;c[p+-4>>2]=p-Ha;Ia=p}c[a+92>>2]=Ia;g[a>>2]=xa;g[a+4>>2]=Ba;g[a+8>>2]=za;g[a+12>>2]=ea(0.0);g[a+16>>2]=ya;g[a+20>>2]=Ca;g[a+24>>2]=Aa;g[a+28>>2]=ea(0.0);m=ea(ea(Ca-Ba)*ea(.0000152590219));Ba=ea(ea(Aa-za)*ea(.0000152590219));g[a+48>>2]=ea(ea(ya-xa)*ea(.0000152590219));g[a+52>>2]=m;g[a+56>>2]=Ba;g[a+60>>2]=ea(0.0);c[a+64>>2]=4;c[a+72>>2]=c[t>>2];c[a+88>>2]=0;c[a+68>>2]=1;if(c[Ga>>2]|0){a=c[L>>2]|0;t=0;do{p=t<<2;g[Ia+(t*112|0)+48>>2]=ea(g[a+(p*28|0)+12>>2]);g[Ia+(t*112|0)+64>>2]=ea(g[a+(p*28|0)+16>>2]);g[Ia+(t*112|0)+80>>2]=ea(g[a+(p*28|0)+20>>2]);g[Ia+(t*112|0)>>2]=ea(g[a+(p*28|0)>>2]);g[Ia+(t*112|0)+16>>2]=ea(g[a+(p*28|0)+4>>2]);g[Ia+(t*112|0)+32>>2]=ea(g[a+(p*28|0)+8>>2]);c[Ia+(t*112|0)+96>>2]=c[a+(p*28|0)+24>>2];Ha=p|1;g[Ia+(t*112|0)+52>>2]=ea(g[a+(Ha*28|0)+12>>2]);g[Ia+(t*112|0)+68>>2]=ea(g[a+(Ha*28|0)+16>>2]);g[Ia+(t*112|0)+84>>2]=ea(g[a+(Ha*28|0)+20>>2]);g[Ia+(t*112|0)+4>>2]=ea(g[a+(Ha*28|0)>>2]);g[Ia+(t*112|0)+20>>2]=ea(g[a+(Ha*28|0)+4>>2]);g[Ia+(t*112|0)+36>>2]=ea(g[a+(Ha*28|0)+8>>2]);c[Ia+(t*112|0)+100>>2]=c[a+(Ha*28|0)+24>>2];Ha=p|2;g[Ia+(t*112|0)+56>>2]=ea(g[a+(Ha*28|0)+12>>2]);g[Ia+(t*112|0)+72>>2]=ea(g[a+(Ha*28|0)+16>>2]);g[Ia+(t*112|0)+88>>2]=ea(g[a+(Ha*28|0)+20>>2]);g[Ia+(t*112|0)+8>>2]=ea(g[a+(Ha*28|0)>>2]);g[Ia+(t*112|0)+24>>2]=ea(g[a+(Ha*28|0)+4>>2]);g[Ia+(t*112|0)+40>>2]=ea(g[a+(Ha*28|0)+8>>2]);c[Ia+(t*112|0)+104>>2]=c[a+(Ha*28|0)+24>>2];Ha=p|3;g[Ia+(t*112|0)+60>>2]=ea(g[a+(Ha*28|0)+12>>2]);g[Ia+(t*112|0)+76>>2]=ea(g[a+(Ha*28|0)+16>>2]);g[Ia+(t*112|0)+92>>2]=ea(g[a+(Ha*28|0)+20>>2]);g[Ia+(t*112|0)+12>>2]=ea(g[a+(Ha*28|0)>>2]);g[Ia+(t*112|0)+28>>2]=ea(g[a+(Ha*28|0)+4>>2]);g[Ia+(t*112|0)+44>>2]=ea(g[a+(Ha*28|0)+8>>2]);c[Ia+(t*112|0)+108>>2]=c[a+(Ha*28|0)+24>>2];t=t+1|0}while(t>>>0<(c[Ga>>2]|0)>>>0)}Ga=c[K>>2]|0;if((Ga&2147483647|0)!=0&(Ga|0)>-1?(Ga=c[L>>2]|0,(Ga|0)!=0):0){L=mKa()|0;In[c[(c[L>>2]|0)+12>>2]&4095](L,Ga)}Ga=c[Fa>>2]|0;if((Ga&2147483647|0)!=0&(Ga|0)>-1?(Ga=c[s>>2]|0,(Ga|0)!=0):0){s=mKa()|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,Ga)}Ga=c[R>>2]|0;if(!((Ga&2147483647|0)!=0&(Ga|0)>-1)){i=d;return}Ga=c[O>>2]|0;if(!Ga){i=d;return}O=mKa()|0;In[c[(c[O>>2]|0)+12>>2]&4095](O,Ga);i=d;return}function BIa(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0.0,E=Im,F=Im,G=Im;l=i;i=i+80|0;m=l;n=l+24|0;o=l+64|0;p=l+8|0;q=c[e+8>>2]|0;do if(q>>>0>=3?(r=(c[e+16>>2]|0)==0,r^1|((q>>>0)%3|0|0)==0):0){if((c[e+32>>2]|0)!=0?(c[e+28>>2]|0)>>>0<2:0)break;if(q>>>0>65535?(b[e+24>>1]&2)!=0:0)break;if((c[e+4>>2]|0)!=0?(c[e>>2]|0)>>>0>=12:0){s=b[e+24>>1]|0;if(!r?(c[e+12>>2]|0)>>>0<((s&2)!=0?6:12)>>>0:0)break;c[n+0>>2]=c[e+0>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];r=n+24|0;b[r>>1]=s;t=n+28|0;u=e+28|0;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=d+16|0;g[d+192>>2]=ea(g[e+36>>2]);t=n+16|0;if(!(c[t>>2]|0)){b[r>>1]=s&-3;c[n+12>>2]=12;s=c[n+8>>2]|0;c[n+20>>2]=(s>>>0)/3|0;r=s>>>0>1073741823?-1:s<<2;if(!r)v=0;else{w=mKa()|0;x=c[(c[w>>2]|0)+8>>2]|0;y=pKa()|0;z=mo[c[(c[y>>2]|0)+24>>2]&4095](y)|0;v=Bn[x&255](w,r,z?541832:544544,524120,73)|0}if(s){z=0;do{c[v+(z<<2)>>2]=z;z=z+1|0}while(z>>>0<s>>>0)}c[t>>2]=v;A=v}else A=0;if(!(CIa(d,n,f,j)|0)){B=0;i=l;return B|0}VJa(o,A);s=f+40|0;C=ea(g[s>>2]);if(C<ea(0.0)|C>ea(1.0)){z=bKa()|0;D=+ea(g[s>>2]);h[k>>3]=D;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];dKa(z,2,524120,92,524272,m)}pIa(p,u,f);sIa(p)|0;z=d+144|0;vLa(z,c[d+16>>2]|0,c[d+24>>2]|0);s=d+156|0;C=ea(S(ea(g[s>>2])));E=ea(S(ea(g[z>>2])));F=C>E?C:E;r=F<ea(0.0);E=r?ea(0.0):F;F=ea(S(ea(g[s+4>>2])));C=ea(S(ea(g[z+4>>2])));G=F>C?F:C;C=E>G?E:G;G=ea(S(ea(g[s+8>>2])));E=ea(S(ea(g[z+8>>2])));F=G>E?G:E;g[d+36>>2]=ea((C>F?C:F)*ea(2.38418579e-07));vIa(p,(a[f+13>>0]|0)!=0,(c[f+28>>2]&16|0)==0);qIa(p);B=1;i=l;return B|0}}while(0);dKa(bKa()|0,4,524120,51,524216,m);B=0;i=l;return B|0}function CIa(b,f,g,h){b=b|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+32|0;k=j;l=j+16|0;m=j+4|0;n=b+16|0;eQa(n);o=hQa(n,c[f+8>>2]|0)|0;p=iQa(n,c[f+20>>2]|0,1)|0;q=c[n>>2]|0;r=c[f>>2]|0;if(q){s=q;q=o;o=c[f+4>>2]|0;while(1){s=s+-1|0;t=q+0|0;u=o+0|0;v=t+12|0;do{a[t>>0]=a[u>>0]|0;t=t+1|0;u=u+1|0}while((t|0)<(v|0));if(!s)break;else{q=q+12|0;o=o+r|0}}}r=b+20|0;b=p+((c[r>>2]|0)*12|0)|0;o=f+12|0;q=c[f+16>>2]|0;s=e[f+24>>1]|0;u=s&1;t=p>>>0<b>>>0;if(!(s&2)){if(t){s=u+1|0;v=2-u|0;w=p;x=q;while(1){c[w>>2]=c[x>>2];c[w+4>>2]=c[x+(s<<2)>>2];c[w+8>>2]=c[x+(v<<2)>>2];w=w+12|0;if(w>>>0>=b>>>0)break;else x=x+(c[o>>2]|0)|0}}}else if(t){t=u+1|0;x=2-u|0;u=p;p=q;while(1){c[u>>2]=e[p>>1];c[u+4>>2]=e[p+(t<<1)>>1];c[u+8>>2]=e[p+(x<<1)>>1];u=u+12|0;if(u>>>0>=b>>>0)break;else p=p+(c[o>>2]|0)|0}}o=f+32|0;if((c[o>>2]|0)!=0?(p=jQa(n)|0,b=c[r>>2]|0,r=c[f+28>>2]|0,(b|0)!=0):0){f=b;b=p;p=c[o>>2]|0;while(1){f=f+-1|0;o=d[p>>0]|d[p+1>>0]<<8;a[b>>0]=o;a[b+1>>0]=o>>8;if(!f)break;else{b=b+2|0;p=p+r|0}}}if(!((c[g+28>>2]&8|0)==0|h)){if(a[g+12>>0]|0){y=1;i=j;return y|0}pIa(m,n,g);tIa(m);qIa(m);y=1;i=j;return y|0}pIa(l,n,g);if(uIa(l,h)|0){qIa(l);y=1;i=j;return y|0}if(h){qIa(l);y=0;i=j;return y|0}else{dKa(bKa()|0,32,524120,279,524360,k);qIa(l);y=0;i=j;return y|0}return 0}function DIa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;h=f;if(!(_Ma(77,69,83,72,12,e,d)|0)){j=0;i=f;return j|0}k=b+176|0;l=(c[k>>2]|0)!=0&1;m=b+180|0;n=(c[m>>2]|0)==0?l:l|2;l=b+184|0;o=(c[l>>2]|0)==0?n:n|16;n=c[b+28>>2]|0;p=b+20|0;q=c[p>>2]|0;if(q){r=0;s=0;do{t=c[n+(r*12|0)>>2]|0;u=t>>>0>s>>>0?t:s;t=c[n+(r*12|0)+4>>2]|0;v=t>>>0>u>>>0?t:u;u=c[n+(r*12|0)+8>>2]|0;s=u>>>0>v>>>0?u:v;r=r+1|0}while(r>>>0<q>>>0);if(s>>>0>=256)w=s>>>0<65536?o|8:o;else x=5}else x=5;if((x|0)==5)w=o|4;VMa(w,e,d);WMa(ea(g[b+192>>2]),e,d);o=b+16|0;VMa(c[o>>2]|0,e,d);VMa(c[p>>2]|0,e,d);ZMa(c[b+24>>2]|0,(c[o>>2]|0)*3|0,e,d);do if(!(w&4)){o=(c[p>>2]|0)*3|0;if(!(w&8)){ZMa(n,o,e,d);break}if(o){o=0;do{UMa(c[n+(o<<2)>>2]&65535,e,d);o=o+1|0}while(o>>>0<((c[p>>2]|0)*3|0)>>>0)}}else if((c[p>>2]|0)*3|0){o=0;do{a[h>>0]=c[n+(o<<2)>>2];xo[c[c[d>>2]>>2]&2047](d,h,1)|0;o=o+1|0}while(o>>>0<((c[p>>2]|0)*3|0)>>>0)}while(0);h=c[k>>2]|0;if(h)YMa(h,c[p>>2]|0,e,d);h=c[m>>2]|0;if(h){k=cNa(h,c[p>>2]|0)|0;VMa(k,e,d);eNa(k,c[p>>2]|0,c[m>>2]|0,d,e)}m=c[l>>2]|0;if(m)ZMa(m,(c[p>>2]|0)*3|0,e,d);IQa(b+48|0,d)|0;WMa(ea(g[b+36>>2]),e,d);WMa(ea(g[b+144>>2]),e,d);WMa(ea(g[b+148>>2]),e,d);WMa(ea(g[b+152>>2]),e,d);WMa(ea(g[b+156>>2]),e,d);WMa(ea(g[b+160>>2]),e,d);WMa(ea(g[b+164>>2]),e,d);m=b+168|0;if(!(c[m>>2]|0)){VMa(0,e,d);j=1;i=f;return j|0}else{VMa(c[p>>2]|0,e,d);xo[c[c[d>>2]>>2]&2047](d,c[m>>2]|0,c[p>>2]|0)|0;j=1;i=f;return j|0}return 0}function EIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=e;c[a+4>>2]=d;c[a>>2]=b;return}function FIa(a){a=a|0;return}function GIa(b,f,g,h,j){b=b|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+32|0;l=k;if(!($Ma(83,85,80,77,0,g,f)|0)){m=0;i=k;return m|0}if(!($Ma(71,65,85,83,0,g,f)|0)){m=0;i=k;return m|0}n=b+4|0;VMa(e[c[n>>2]>>1]|0,g,f);VMa(e[(c[n>>2]|0)+2>>1]|0,g,f);o=c[n>>2]|0;xo[c[c[f>>2]>>2]&2047](f,c[o+4>>2]|0,(e[o+2>>1]|0)<<1)|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l>>2]=d[(c[b>>2]|0)+38>>0];c[l+4>>2]=h;c[l+8>>2]=j;a[l+16>>0]=1;IIa(b,l)|0;m=HIa(b,f,g)|0;i=k;return m|0}function HIa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f;if(!($Ma(86,65,76,69,2,e,d)|0)){h=0;i=f;return h|0}j=a+4|0;VMa(c[(c[j>>2]|0)+8>>2]|0,e,d);VMa(c[(c[j>>2]|0)+12>>2]|0,e,d);a=c[j>>2]|0;k=c[a+8>>2]|0;l=k>>>0>2147483647?-1:k<<1;if(!l){m=k;n=a;o=0}else{a=mKa()|0;k=c[(c[a>>2]|0)+8>>2]|0;p=pKa()|0;q=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[k&255](a,l,q?541936:544544,524392,299)|0;q=c[j>>2]|0;m=c[q+8>>2]|0;n=q;o=p}if(!m)r=0;else{p=c[n+16>>2]|0;n=0;do{b[o+(n<<1)>>1]=b[p+(n<<2)>>1]|0;n=n+1|0}while(n>>>0<m>>>0);r=m}m=dNa(o,r)|0;VMa(m&65535,e,d);gNa(m,c[(c[j>>2]|0)+8>>2]|0,o,d,e);VJa(g,o);o=c[j>>2]|0;xo[c[c[d>>2]>>2]&2047](d,c[o+20>>2]|0,c[o+12>>2]|0)|0;h=1;i=f;return h|0}function IIa(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+24|0;k=h;l=c[f>>2]|0;m=d+4|0;d=c[m>>2]|0;c[d+8>>2]=l;n=l>>>0>1073741823?-1:l<<2;if(!n){o=d;p=0}else{d=mKa()|0;l=c[(c[d>>2]|0)+8>>2]|0;q=pKa()|0;r=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[l&255](d,n,r?524488:544544,524392,226)|0;o=c[m>>2]|0;p=q}c[o+16>>2]=p;p=c[m>>2]|0;PEi(c[p+16>>2]|0,0,c[p+8>>2]<<2|0)|0;oIa(j);c[k+16>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;b[k+12>>1]=0;g[k+20>>2]=ea(.100000001);c[k>>2]=c[f+4>>2];c[k+4>>2]=c[f+8>>2];c[k+8>>2]=c[f+12>>2];a[k+12>>0]=1;if(!(kIa(j,k)|0)){s=0;jIa(j);i=h;return s|0}k=c[j>>2]|0;if(k){p=c[j+4>>2]|0;o=c[(c[m>>2]|0)+16>>2]|0;q=0;do{r=o+(c[p+(q<<3)>>2]<<2)|0;b[r>>1]=(b[r>>1]|0)+1<<16>>16;r=o+(c[p+(q<<3)+4>>2]<<2)|0;b[r>>1]=(b[r>>1]|0)+1<<16>>16;q=q+1|0}while(q>>>0<k>>>0)}if(!(a[f+16>>0]|0)){s=1;jIa(j);i=h;return s|0}eOa(c[m>>2]|0);f=c[m>>2]|0;k=(c[f+8>>2]|0)+-1|0;q=c[f+16>>2]|0;p=(e[q+(k<<2)>>1]|0)+(e[q+(k<<2)+2>>1]|0)|0;c[f+12>>2]=p;if(!p){t=f;u=0}else{f=mKa()|0;k=c[(c[f>>2]|0)+8>>2]|0;q=pKa()|0;o=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[k&255](f,p,o?543296:544544,524392,269)|0;t=c[m>>2]|0;u=q}c[t+20>>2]=u;if(c[j>>2]|0){u=j+4|0;t=0;do{q=c[u>>2]|0;o=c[q+(t<<3)>>2]|0;p=c[q+(t<<3)+4>>2]|0;q=c[m>>2]|0;f=(c[q+16>>2]|0)+(o<<2)+2|0;k=b[f>>1]|0;b[f>>1]=k+1<<16>>16;a[(c[q+20>>2]|0)+(k&65535)>>0]=p;k=c[m>>2]|0;q=(c[k+16>>2]|0)+(p<<2)+2|0;p=b[q>>1]|0;b[q>>1]=p+1<<16>>16;a[(c[k+20>>2]|0)+(p&65535)>>0]=o;t=t+1|0}while(t>>>0<(c[j>>2]|0)>>>0)}eOa(c[m>>2]|0);s=1;jIa(j);i=h;return s|0}function JIa(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=0,na=0;h=i;j=da(f*6|0,f)|0;k=d+4|0;l=c[k>>2]|0;b[l>>1]=f;m=j&65535;b[l+2>>1]=m;if(!(m<<16>>16)){n=l;o=0}else{l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;p=pKa()|0;q=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[m&255](l,j<<1&131068,q?543296:544544,524392,61)|0;n=c[k>>2]|0;o=p}c[n+4>>2]=o;r=ea(ea((f+-1|0)>>>0)*ea(.5));o=(f|0)==0;n=d+8|0;s=ea(0.0);t=ea(0.0);u=ea(0.0);p=0;while(1){if(o){v=t;w=s;x=u}else{q=da(p,f)|0;j=(p|0)==0;y=j?ea(-1.0):ea(1.0);z=(p|0)==2?ea(-1.0):ea(1.0);A=(p|0)==4?ea(-1.0):ea(1.0);B=s;C=t;D=u;l=0;while(1){E=ea(ea(1.0)-ea(ea(l>>>0)/r));a:do if(j){m=0;do{F=(da(m+q|0,f)|0)+l|0;G=ea(ea(1.0)-ea(ea(m>>>0)/r));H=ea(T(ea(ea(E*E)+ea(ea(G*G)+ea(y*y)))));if(H>ea(0.0)){I=ea(ea(1.0)/H);J=ea(y*I);K=ea(G*I);L=ea(E*I)}else{J=y;K=G;L=E}M=a[(c[d>>2]|0)+38>>0]|0;N=c[n>>2]|0;if(!(M<<24>>24)){O=0;P=0}else{Q=M&255;M=0;R=0;S=0;G=ea(3402823469999999843913219.0e14);I=ea(3402823469999999843913219.0e14);while(1){H=ea(J*ea(g[N+(S*12|0)>>2]));U=ea(H+ea(K*ea(g[N+(S*12|0)+4>>2])));H=ea(U+ea(L*ea(g[N+(S*12|0)+8>>2])));V=H<I;M=V?S:M;U=ea(-H);W=G>U;R=W?S:R;S=S+1|0;if((S|0)==(Q|0))break;else{G=W?U:G;I=V?H:I}}O=M&255;P=R&255}a[(c[(c[k>>2]|0)+4>>2]|0)+F>>0]=O;Q=c[k>>2]|0;a[(c[Q+4>>2]|0)+((e[Q+2>>1]|0)+F)>>0]=P;m=m+1|0}while((m|0)!=(f|0));X=J;Y=K;Z=L}else{I=B;G=C;H=D;m=0;while(1){Q=(da(m+q|0,f)|0)+l|0;switch(p|0){case 1:case 0:{_=y;$=ea(ea(1.0)-ea(ea(m>>>0)/r));aa=E;break}case 3:case 2:{_=E;$=z;aa=ea(ea(1.0)-ea(ea(m>>>0)/r));break}case 5:case 4:{_=ea(ea(1.0)-ea(ea(m>>>0)/r));$=E;aa=A;break}default:{_=I;$=G;aa=H}}U=ea(T(ea(ea(aa*aa)+ea(ea($*$)+ea(_*_)))));if(U>ea(0.0)){ba=ea(ea(1.0)/U);ca=ea(_*ba);fa=ea($*ba);ga=ea(aa*ba)}else{ca=_;fa=$;ga=aa}S=a[(c[d>>2]|0)+38>>0]|0;N=c[n>>2]|0;if(!(S<<24>>24)){ha=0;ia=0}else{V=S&255;S=0;W=0;ja=0;ba=ea(3402823469999999843913219.0e14);U=ea(3402823469999999843913219.0e14);while(1){ka=ea(ca*ea(g[N+(ja*12|0)>>2]));la=ea(ka+ea(fa*ea(g[N+(ja*12|0)+4>>2])));ka=ea(la+ea(ga*ea(g[N+(ja*12|0)+8>>2])));ma=ka<U;S=ma?ja:S;la=ea(-ka);na=ba>la;W=na?ja:W;ja=ja+1|0;if((ja|0)==(V|0))break;else{ba=na?la:ba;U=ma?ka:U}}ha=S&255;ia=W&255}a[(c[(c[k>>2]|0)+4>>2]|0)+Q>>0]=ha;V=c[k>>2]|0;a[(c[V+4>>2]|0)+((e[V+2>>1]|0)+Q)>>0]=ia;m=m+1|0;if((m|0)==(f|0)){X=ca;Y=fa;Z=ga;break a}else{I=ca;G=fa;H=ga}}}while(0);l=l+1|0;if((l|0)==(f|0)){v=Y;w=X;x=Z;break}else{B=X;C=Y;D=Z}}}p=p+1|0;if((p|0)==6)break;else{s=w;t=v;u=x}}i=h;return 1}function KIa(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=b;b=a+24|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;return}function LIa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+28|0;VJa(b+2|0,c[d>>2]|0);c[d>>2]=0;d=a+36|0;VJa(b+4|0,c[d>>2]|0);c[d>>2]=0;VJa(b+5|0,c[a>>2]|0);c[a>>2]=0;d=a+4|0;VJa(b+6|0,c[d>>2]|0);c[d>>2]=0;d=a+8|0;VJa(b+1|0,c[d>>2]|0);c[d>>2]=0;d=a+12|0;VJa(b,c[d>>2]|0);c[d>>2]=0;d=a+16|0;VJa(b+3|0,c[d>>2]|0);c[d>>2]=0;i=b;return}function MIa(f,h,j,k,l,m,n){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=0,U=0,V=Im,W=Im;o=i;i=i+32|0;p=o;q=o+8|0;r=o+27|0;s=o+25|0;t=o+24|0;u=o+4|0;v=f+4|0;w=f+8|0;x=f+32|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[x>>2]=k;k=f+20|0;a[(c[k>>2]|0)+38>>0]=h;h=UJa(o+26|0,(d[(c[k>>2]|0)+38>>0]|0)*12|0,524600,948)|0;c[f>>2]=h;YEi(h|0,j|0,(d[(c[k>>2]|0)+38>>0]|0)*12|0)|0;j=(n|0)==0;if((l|0)!=0&j){h=c[x>>2]|0;y=h>>>0>357913941?-1:h*12|0;if(!y){z=0;A=h}else{h=mKa()|0;B=c[(c[h>>2]|0)+8>>2]|0;C=pKa()|0;D=mo[c[(c[C>>2]|0)+24>>2]&4095](C)|0;C=Bn[B&255](h,y,D?525472:544544,524600,954)|0;z=C;A=c[x>>2]|0}c[f+36>>2]=z;if(A){A=0;do{C=A*3|0;c[z+(A*12|0)>>2]=c[l+(C<<2)>>2];c[z+(A*12|0)+4>>2]=c[l+(C+1<<2)>>2];c[z+(A*12|0)+8>>2]=c[l+(C+2<<2)>>2];A=A+1|0}while(A>>>0<(c[x>>2]|0)>>>0)}}aLa(q);if(!j?(j=(m|0)==0,!j):0){A=q+4|0;z=q+8|0;C=0;do{D=n+(C*20|0)+16|0;y=b[D>>1]|0;h=c[A>>2]|0;if((h|0)==(c[q>>2]|0)){gLa(q,1)|0;E=c[A>>2]|0;F=b[D>>1]|0}else{E=h;F=y}c[A>>2]=E+1;h=c[z>>2]|0;c[h+(E<<2)>>2]=y&65535;if(!(F<<16>>16))G=h;else{y=n+(C*20|0)+18|0;B=F;H=h;h=0;while(1){I=c[l+((e[y>>1]|0)+h<<2)>>2]|0;J=c[A>>2]|0;if((J|0)==(c[q>>2]|0)){gLa(q,1)|0;K=c[A>>2]|0;L=c[z>>2]|0;M=b[D>>1]|0}else{K=J;L=H;M=B}c[A>>2]=K+1;c[L+(K<<2)>>2]=I;h=h+1|0;if(h>>>0>=(M&65535)>>>0){G=L;break}else{B=M;H=L}}}C=C+1|0}while((C|0)!=(m|0));if(!(j|(G|0)==0)){a[(c[k>>2]|0)+39>>0]=0;VJa(r,c[w>>2]|0);c[w>>2]=0;VJa(s,c[v>>2]|0);c[v>>2]=0;if(m>>>0>255){dKa(bKa()|0,32,524600,1005,524696,p);N=0;dLa(q);i=o;return N|0}a[(c[k>>2]|0)+39>>0]=m;c[v>>2]=UJa(t,(d[(c[k>>2]|0)+39>>0]|0)*20|0,524600,1011)|0;t=G;s=0;r=0;while(1){j=c[t>>2]|0;s=j+s|0;r=r+1|0;if((r|0)==(m|0))break;else t=t+(j+1<<2)|0}if(!s)O=0;else{t=mKa()|0;r=c[(c[t>>2]|0)+8>>2]|0;j=pKa()|0;C=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;O=Bn[r&255](t,s,C?543296:544544,524600,1026)|0}c[w>>2]=O;C=O;s=c[v>>2]|0;t=G;G=O;O=0;while(1){b[s+(O*20|0)+16>>1]=G-C;r=c[t>>2]|0;a[s+(O*20|0)+18>>0]=r;if(r){j=0;do{L=j;j=j+1|0;a[G+L>>0]=c[t+(j<<2)>>2]}while((j|0)!=(r|0))}j=c[v>>2]|0;P=ea(g[n+(O*20|0)>>2]);Q=ea(g[n+(O*20|0)+4>>2]);R=ea(g[n+(O*20|0)+8>>2]);S=ea(g[n+(O*20|0)+12>>2]);g[j+(O*20|0)>>2]=P;g[j+(O*20|0)+4>>2]=Q;g[j+(O*20|0)+8>>2]=R;g[j+(O*20|0)+12>>2]=S;L=O+1|0;if((L|0)==(m|0))break;C=c[w>>2]|0;s=j;t=t+(r+1<<2)|0;G=G+r|0;O=L}if(NIa(f,m,1)|0)T=0;else{N=0;dLa(q);i=o;return N|0}do{O=a[(c[k>>2]|0)+38>>0]|0;G=c[v>>2]|0;if(!(O<<24>>24))U=-1;else{S=ea(g[G+(T*20|0)>>2]);R=ea(g[G+(T*20|0)+4>>2]);Q=ea(g[G+(T*20|0)+8>>2]);t=c[f>>2]|0;s=0;w=-1;P=ea(3402823469999999843913219.0e14);while(1){V=ea(ea(g[t>>2])*S);W=ea(V+ea(ea(g[t+4>>2])*R));V=ea(W+ea(ea(g[t+8>>2])*Q));C=V<P;n=C?s:w;s=s+1<<24>>24;if((s&255)>=(O&255)){U=n;break}else{t=t+12|0;w=n;P=C?V:P}}}a[G+(T*20|0)+19>>0]=U;T=T+1|0}while((T|0)!=(m|0));if(!(OIa(f)|0)){N=0;dLa(q);i=o;return N|0}N=PIa(f)|0;dLa(q);i=o;return N|0}}m=c[f+36>>2]|0;c[u>>2]=d[(c[k>>2]|0)+38>>0];I5a(x,m,u,c[f>>2]|0);a[(c[k>>2]|0)+38>>0]=c[u>>2];u=a[(c[k>>2]|0)+38>>0]|0;k=c[f>>2]|0;c[p>>2]=c[x>>2];if(!(J5a(p,m,0)|0)){N=0;dLa(q);i=o;return N|0}if(!(K5a(u&255,k,c[p>>2]|0,m,0)|0)){N=0;dLa(q);i=o;return N|0}if(!(QIa(f)|0)){N=0;dLa(q);i=o;return N|0}N=PIa(f)|0;dLa(q);i=o;return N|0}function NIa(b,f,g){b=b|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;i=i+16|0;j=h;k=h+4|0;l=b+20|0;m=c[l>>2]|0;n=a[m+38>>0]|0;if(!(n<<24>>24)){o=0;p=m}else{m=mKa()|0;q=c[(c[m>>2]|0)+8>>2]|0;r=pKa()|0;s=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[q&255](m,(n&255)*3|0,s?543296:544544,524600,1699)|0;o=r;p=c[l>>2]|0}r=b+16|0;c[r>>2]=o;if(!(a[p+38>>0]|0)){t=1;i=h;return t|0}p=k+1|0;o=k+2|0;s=b+4|0;n=b+8|0;a:do if(f){b=0;while(1){m=c[s>>2]|0;q=0;u=0;while(1){v=a[m+(u*20|0)+18>>0]|0;b:do if(!(v<<24>>24))w=q;else{x=e[m+(u*20|0)+16>>1]|0;y=c[n>>2]|0;z=0;while(1){if((b|0)==(d[y+(x+z)>>0]|0))break;z=z+1|0;if(z>>>0>=(v&255)>>>0){w=q;break b}}a[k+q>>0]=u;w=q+1|0}while(0);u=u+1|0;if((w|0)==3)break;if(u>>>0>=f>>>0){A=6;break}else q=w}if((A|0)==6?(A=0,(w|0)!=3):0)break a;q=b*3|0;a[(c[r>>2]|0)+q>>0]=a[k>>0]|0;a[(c[r>>2]|0)+(q+1)>>0]=a[p>>0]|0;a[(c[r>>2]|0)+(q+2)>>0]=a[o>>0]|0;b=b+1|0;if(b>>>0>=(d[(c[l>>2]|0)+38>>0]|0)>>>0){t=1;break}}i=h;return t|0}while(0);o=bKa()|0;if(g)dKa(o,128,524600,1744,525048,j);else dKa(o,128,524600,1742,524936,j);if(!(a[(c[l>>2]|0)+38>>0]|0)){t=0;i=h;return t|0}else B=0;do{j=B*3|0;a[(c[r>>2]|0)+j>>0]=-1;a[(c[r>>2]|0)+(j+1)>>0]=-1;a[(c[r>>2]|0)+(j+2)>>0]=-1;B=B+1|0}while(B>>>0<(d[(c[l>>2]|0)+38>>0]|0)>>>0);t=0;i=h;return t|0}function OIa(b){b=b|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0;f=i;i=i+32|0;h=f;j=f+18|0;k=f+17|0;l=f+16|0;m=f+4|0;n=b+20|0;o=c[n>>2]|0;p=a[o+39>>0]|0;if(!(p<<24>>24)){q=0;i=f;return q|0}r=b+4|0;s=c[r>>2]|0;if(!s){q=0;i=f;return q|0}else{t=0;u=0}do{v=a[s+(u*20|0)+18>>0]|0;if((v&255)<3){w=4;break}t=t+-2+(v&255)|0;u=u+1|0}while(u>>>0<(p&255)>>>0);if((w|0)==4){dKa(bKa()|0,32,524600,1126,524768,h);q=0;i=f;return q|0}h=t>>>0>357913941?-1:t*12|0;if(!h){x=0;y=o;z=p}else{p=mKa()|0;o=c[(c[p>>2]|0)+8>>2]|0;w=pKa()|0;u=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;w=Bn[o&255](p,h,u?525472:544544,524600,1132)|0;u=c[n>>2]|0;x=w;y=u;z=a[u+39>>0]|0}u=c[b+8>>2]|0;w=c[b>>2]|0;n=y+39|0;if(!(z<<24>>24))A=0;else{z=c[r>>2]|0;r=x;y=0;h=0;while(1){p=e[z+(h*20|0)+16>>1]|0;o=u+p|0;s=d[z+(h*20|0)+18>>0]|0;v=s+-2|0;B=r;C=y;D=0;a:while(1){E=B+4|0;F=B+8|0;G=D;do{if(G>>>0>=v>>>0)break a;H=d[o>>0]|0;c[B>>2]=H;I=G;G=G+1|0;J=d[u+(((G>>>0)%(s>>>0)|0)+p)>>0]|0;c[E>>2]=J;K=d[u+((((I+2|0)>>>0)%(s>>>0)|0)+p)>>0]|0;c[F>>2]=K;L=ea(g[w+(J*12|0)>>2]);M=ea(g[w+(H*12|0)>>2]);N=ea(L-M);L=ea(g[w+(J*12|0)+4>>2]);O=ea(g[w+(H*12|0)+4>>2]);P=ea(L-O);L=ea(g[w+(J*12|0)+8>>2]);Q=ea(g[w+(H*12|0)+8>>2]);R=ea(L-Q);L=ea(ea(g[w+(K*12|0)>>2])-M);M=ea(ea(g[w+(K*12|0)+4>>2])-O);O=ea(ea(g[w+(K*12|0)+8>>2])-Q);Q=ea(ea(P*O)-ea(R*M));S=ea(ea(R*L)-ea(N*O));O=ea(ea(N*M)-ea(P*L))}while(!(ea(ea(O*O)+ea(ea(Q*Q)+ea(S*S)))!=ea(0.0)));B=B+12|0;C=C+1|0;D=G}h=h+1|0;if(h>>>0>=(d[n>>0]|0)>>>0){A=C;break}else{r=B;y=C}}}y=b+36|0;VJa(j,c[y>>2]|0);c[y>>2]=0;do if((t|0)==(A|0))U=x;else{j=A>>>0>357913941?-1:A*12|0;if((j|0)!=0?(r=mKa()|0,n=c[(c[r>>2]|0)+8>>2]|0,h=pKa()|0,u=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0,h=Bn[n&255](r,j,u?525472:544544,524600,1193)|0,(h|0)!=0):0){YEi(h|0,x|0,A*12|0)|0;VJa(l,x);U=h;break}VJa(k,x);q=0;i=f;return q|0}while(0);c[y>>2]=U;U=b+32|0;c[U>>2]=A;RIa(b,m)|0;b=c[U>>2]|0;if(!b){q=1;i=f;return q|0}A=c[y>>2]|0;S=ea(g[m>>2]);Q=ea(g[m+4>>2]);O=ea(g[m+8>>2]);m=b;b=0;while(1){y=c[A+(b*12|0)>>2]|0;x=A+(b*12|0)+4|0;k=c[x>>2]|0;l=A+(b*12|0)+8|0;t=c[l>>2]|0;L=ea(g[w+(k*12|0)>>2]);P=ea(g[w+(y*12|0)>>2]);M=ea(L-P);L=ea(g[w+(k*12|0)+4>>2]);N=ea(g[w+(y*12|0)+4>>2]);R=ea(L-N);L=ea(g[w+(k*12|0)+8>>2]);V=ea(g[w+(y*12|0)+8>>2]);W=ea(L-V);L=ea(ea(g[w+(t*12|0)>>2])-P);X=ea(ea(g[w+(t*12|0)+4>>2])-N);Y=ea(ea(g[w+(t*12|0)+8>>2])-V);Z=ea(ea(R*Y)-ea(W*X));_=ea(ea(W*L)-ea(M*Y));Y=ea(ea(M*X)-ea(R*L));L=ea(ea(Y*Y)+ea(ea(Z*Z)+ea(_*_)));if(L>ea(0.0)){R=ea(ea(1.0)/ea(T(ea(L))));$=ea(Z*R);aa=ea(_*R);ba=ea(Y*R)}else{$=ea(0.0);aa=ea(0.0);ba=ea(0.0)}if(ea(ea(ea(ea($*S)+ea(aa*Q))+ea(ba*O))-ea(ea(ea($*P)+ea(aa*N))+ea(ba*V)))>ea(0.0)){c[l>>2]=k;c[x>>2]=t;ca=c[U>>2]|0}else ca=m;b=b+1|0;if(b>>>0>=ca>>>0){q=1;break}else m=ca}i=f;return q|0}function PIa(b){b=b|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+112|0;h=f+8|0;j=f;k=c[b>>2]|0;l=c[b+8>>2]|0;m=c[b+4>>2]|0;if(!k){n=0;i=f;return n|0}if((c[b+36>>2]|0)==0|(m|0)==0){n=0;i=f;return n|0}o=c[b+20>>2]|0;b=o+39|0;if((d[b>>0]|0)<4){n=0;i=f;return n|0}p=o+38|0;q=a[p>>0]|0;if(!(q<<24>>24)){r=ea(-3402823469999999843913219.0e14);s=ea(-3402823469999999843913219.0e14);t=ea(-3402823469999999843913219.0e14)}else{u=q&255;v=ea(-3402823469999999843913219.0e14);w=ea(-3402823469999999843913219.0e14);x=ea(-3402823469999999843913219.0e14);q=0;do{y=ea(g[k+(q*12|0)>>2]);z=ea(g[k+(q*12|0)+4>>2]);A=ea(g[k+(q*12|0)+8>>2]);B=ea(S(ea(y)));v=B>v?B:v;B=ea(S(ea(z)));w=B>w?B:w;B=ea(S(ea(A)));x=B>x?B:x;q=q+1|0}while(q>>>0<u>>>0);r=ea(x+ea(.0199999996));s=ea(w+ea(.0199999996));t=ea(v+ea(.0199999996))}u=j;c[u>>2]=0;c[u+4>>2]=0;g[h>>2]=t;g[h+4>>2]=s;g[h+8>>2]=r;v=ea(-s);w=ea(-r);g[h+12>>2]=t;g[h+16>>2]=v;g[h+20>>2]=w;g[h+24>>2]=t;g[h+28>>2]=s;g[h+32>>2]=w;g[h+36>>2]=t;g[h+40>>2]=v;g[h+44>>2]=r;x=ea(-t);g[h+48>>2]=x;g[h+52>>2]=s;g[h+56>>2]=r;g[h+60>>2]=x;g[h+64>>2]=v;g[h+68>>2]=r;g[h+72>>2]=x;g[h+76>>2]=s;g[h+80>>2]=w;g[h+84>>2]=x;g[h+88>>2]=v;g[h+92>>2]=w;a:do if(a[b>>0]|0){u=a[p>>0]|0;q=u<<24>>24==0;C=0;b:while(1){D=m+(C*20|0)|0;E=m+(C*20|0)+4|0;F=m+(C*20|0)+8|0;G=m+(C*20|0)+12|0;H=0;do{I=j+H|0;if((a[I>>0]|0)==0?(w=ea(g[h+(H*12|0)>>2]),v=ea(w*ea(g[D>>2])),w=ea(g[h+(H*12|0)+4>>2]),x=ea(v+ea(w*ea(g[E>>2]))),w=ea(g[h+(H*12|0)+8>>2]),v=ea(x+ea(w*ea(g[F>>2]))),ea(ea(g[G>>2])+v)>=ea(0.0)):0)a[I>>0]=1;H=H+1|0}while((H|0)!=8);c:do if(!q){H=a[m+(C*20|0)+18>>0]|0;I=H&255;J=m+(C*20|0)+16|0;if(!(H<<24>>24)){H=0;while(1){v=ea(g[k+(H*12|0)>>2]);w=ea(v*ea(g[D>>2]));v=ea(g[k+(H*12|0)+4>>2]);x=ea(w+ea(v*ea(g[E>>2])));v=ea(g[k+(H*12|0)+8>>2]);w=ea(x+ea(v*ea(g[F>>2])));if(ea(ea(g[G>>2])+w)>ea(.0199999996)){n=0;K=27;break b}H=H+1|0;if(H>>>0>=(d[o+38>>0]|0)>>>0)break c}}else L=0;do{H=e[J>>1]|0;M=L&255;N=0;while(1){if((a[l+(H+N)>>0]|0)==M<<24>>24)break;N=N+1|0;if(N>>>0>=I>>>0){K=18;break}}if((K|0)==18?(K=0,w=ea(g[k+(L*12|0)>>2]),v=ea(w*ea(g[D>>2])),w=ea(g[k+(L*12|0)+4>>2]),x=ea(v+ea(w*ea(g[E>>2]))),w=ea(g[k+(L*12|0)+8>>2]),v=ea(x+ea(w*ea(g[F>>2]))),ea(ea(g[G>>2])+v)>ea(.0199999996)):0){n=0;K=27;break b}L=L+1|0}while(L>>>0<(u&255)>>>0)}while(0);C=C+1|0;if(C>>>0>=(d[o+39>>0]|0)>>>0){O=0;break a}}if((K|0)==27){i=f;return n|0}}else O=0;while(0);while(1){if(!(a[j+O>>0]|0)){n=0;K=27;break}O=O+1|0;if(O>>>0>=8){n=1;K=27;break}}if((K|0)==27){i=f;return n|0}return 0}function QIa(e){e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=Im,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0;f=i;i=i+80|0;h=f;j=f+8|0;k=f+40|0;l=f+56|0;m=f+24|0;n=f+78|0;o=f+73|0;p=f+28|0;q=f+75|0;r=e+20|0;a[(c[r>>2]|0)+39>>0]=0;s=e+8|0;VJa(f+72|0,c[s>>2]|0);c[s>>2]=0;t=e+16|0;VJa(f+76|0,c[t>>2]|0);c[t>>2]=0;t=e+4|0;VJa(f+74|0,c[t>>2]|0);c[t>>2]=0;aLa(j);aLa(k);aLa(l);if(!(L5a(m,j,e,k,l)|0)){u=0;dLa(l);dLa(k);dLa(j);i=f;return u|0}v=a[(c[r>>2]|0)+38>>0]|0;w=c[l+4>>2]|0;if(!w){x=c[m>>2]|0;y=v;z=c[e>>2]|0}else{A=(v&255)-w|0;w=A&255;v=UJa(f+77|0,(A&255)*12|0,524600,1447)|0;A=a[(c[r>>2]|0)+38>>0]|0;if(A<<24>>24){B=mKa()|0;C=c[(c[B>>2]|0)+8>>2]|0;D=pKa()|0;E=mo[c[(c[D>>2]|0)+24>>2]&4095](D)|0;D=Bn[C&255](B,A&255,E?543296:544544,524600,1448)|0;if(!(a[(c[r>>2]|0)+38>>0]|0))F=D;else{E=0;A=0;B=0;while(1){if(eLa(l,E,0)|0){a[D+E>>0]=-1;G=A}else{C=A&255;H=c[e>>2]|0;g[v+(C*12|0)>>2]=ea(g[H+(E*12|0)>>2]);g[v+(C*12|0)+4>>2]=ea(g[H+(E*12|0)+4>>2]);g[v+(C*12|0)+8>>2]=ea(g[H+(E*12|0)+8>>2]);a[D+E>>0]=A;G=A+1<<24>>24}H=B+1<<24>>24;if((H&255)<(d[(c[r>>2]|0)+38>>0]|0)){E=H&255;A=G;B=H}else{F=D;break}}}}else F=0;D=c[m>>2]|0;if(!D)I=0;else{B=D;D=c[j+8>>2]|0;G=0;while(1){A=c[D>>2]|0;if(!A)J=B;else{E=0;do{E=E+1|0;H=D+(E<<2)|0;c[H>>2]=d[F+(c[H>>2]|0)>>0]}while((E|0)!=(A|0));J=c[m>>2]|0}G=G+1|0;if(G>>>0>=J>>>0){I=J;break}else{B=J;D=D+(A+1<<2)|0}}}VJa(n,F);x=I;y=w;z=v}if(x>>>0>255){dKa(bKa()|0,32,524600,1486,524872,h);u=0;dLa(l);dLa(k);dLa(j);i=f;return u|0}a[(c[r>>2]|0)+39>>0]=x;h=UJa(o,(d[(c[r>>2]|0)+39>>0]|0)*20|0,524600,1492)|0;c[t>>2]=h;PEi(h|0,0,(d[(c[r>>2]|0)+39>>0]|0)*20|0)|0;RIa(e,p)|0;h=c[j+4>>2]|0;if((h|0)==(x|0))K=0;else{o=mKa()|0;v=c[(c[o>>2]|0)+8>>2]|0;w=pKa()|0;I=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;K=Bn[v&255](o,h-x|0,I?543296:544544,524600,1503)|0}c[s>>2]=K;a:do if(!x)L=0;else{I=(z|0)==0;h=p+4|0;o=p+8|0;v=e+36|0;w=K;F=c[t>>2]|0;n=c[j+8>>2]|0;D=K;J=c[k+8>>2]|0;B=0;while(1){b[F+(B*20|0)+16>>1]=D-w;G=c[n>>2]|0;a[F+(B*20|0)+18>>0]=G;b:do if(G){E=0;H=0;while(1){C=H;while(1){C=C+1|0;M=c[n+(C<<2)>>2]|0;if((M|0)!=255)break;N=(c[t>>2]|0)+(B*20|0)+18|0;a[N>>0]=(a[N>>0]|0)+-1<<24>>24;if(C>>>0>=G>>>0)break b}a[D+E>>0]=M;if(C>>>0<G>>>0){E=E+1|0;H=C}else break}}while(0);H=c[t>>2]|0;E=a[H+(B*20|0)+18>>0]|0;N=E&255;O=(D|0)==0;P=E<<24>>24==0|O;if(!(P|I)){Q=d[D+(N+-1)>>0]|0;R=ea(g[z+(Q*12|0)+4>>2]);S=ea(g[z+(Q*12|0)+8>>2]);U=R;R=S;S=ea(0.0);V=ea(g[z+(Q*12|0)>>2]);W=ea(0.0);X=ea(0.0);Y=ea(0.0);Z=ea(0.0);_=ea(0.0);Q=0;do{$=d[D+Q>>0]|0;aa=U;U=ea(g[z+($*12|0)+4>>2]);ba=ea(aa-U);ca=R;R=ea(g[z+($*12|0)+8>>2]);S=ea(S+ea(ba*ea(ca+R)));ba=ea(ca-R);ca=V;V=ea(g[z+($*12|0)>>2]);W=ea(W+ea(ba*ea(ca+V)));X=ea(X+ea(ea(aa+U)*ea(ca-V)));Y=ea(Y+V);Z=ea(Z+U);_=ea(_+R);Q=Q+1|0}while((Q|0)!=(N|0));Q=H+(B*20|0)|0;g[Q>>2]=S;$=H+(B*20|0)+4|0;g[$>>2]=W;da=H+(B*20|0)+8|0;g[da>>2]=X;R=ea(T(ea(ea(X*X)+ea(ea(S*S)+ea(W*W)))));if(R>ea(0.0)){U=ea(ea(1.0)/R);R=ea(S*U);g[Q>>2]=R;V=ea(W*U);g[$>>2]=V;ca=ea(X*U);g[da>>2]=ca;fa=R;ga=V;ha=ca}else{fa=S;ga=W;ha=X}g[H+(B*20|0)+12>>2]=ea(ea(-ea(ea(_*ha)+ea(ea(Z*ga)+ea(Y*fa))))/ea(E&255))}da=c[J>>2]|0;$=J+4|0;if(da){Q=c[v>>2]|0;ia=c[e>>2]|0;ja=$;ka=0;la=0;while(1){ma=c[ja>>2]|0;na=c[Q+(ma*12|0)>>2]|0;oa=c[Q+(ma*12|0)+4>>2]|0;pa=c[Q+(ma*12|0)+8>>2]|0;ca=ea(g[ia+(oa*12|0)>>2]);V=ea(g[ia+(na*12|0)>>2]);R=ea(ca-V);ca=ea(g[ia+(oa*12|0)+4>>2]);U=ea(g[ia+(na*12|0)+4>>2]);aa=ea(ca-U);ca=ea(g[ia+(oa*12|0)+8>>2]);ba=ea(g[ia+(na*12|0)+8>>2]);qa=ea(ca-ba);ca=ea(ea(g[ia+(pa*12|0)>>2])-V);V=ea(ea(g[ia+(pa*12|0)+4>>2])-U);U=ea(ea(g[ia+(pa*12|0)+8>>2])-ba);ba=ea(ea(aa*U)-ea(qa*V));ra=ea(ea(qa*ca)-ea(R*U));U=ea(ea(R*V)-ea(aa*ca));ca=ea(ea(U*U)+ea(ea(ba*ba)+ea(ra*ra)));if(ca>ea(0.0)){aa=ea(ea(1.0)/ea(T(ea(ca))));sa=ea(ba*aa);ta=ea(ra*aa);ua=ea(U*aa)}else{sa=ea(0.0);ta=ea(0.0);ua=ea(0.0)}if((la|0)==0?(aa=ea(sa*ea(g[H+(B*20|0)>>2])),U=ea(aa+ea(ta*ea(g[H+(B*20|0)+4>>2]))),ea(U+ea(ua*ea(g[H+(B*20|0)+8>>2])))<ea(0.0)):0)va=1;else va=ka;la=la+1|0;if((la|0)==(da|0))break;else{ja=ja+4|0;ka=va}}ka=J+(da+1<<2)|0;if((va?(ja=H+(B*20|0)|0,Y=ea(-ea(g[ja>>2])),la=H+(B*20|0)+4|0,Z=ea(-ea(g[la>>2])),ia=H+(B*20|0)+8|0,_=ea(-ea(g[ia>>2])),g[ja>>2]=Y,g[la>>2]=Z,g[ia>>2]=_,ia=H+(B*20|0)+12|0,g[ia>>2]=ea(-ea(g[ia>>2])),!P):0)?(ia=N>>>1,(ia|0)!=0):0){la=N+-1|0;ja=0;do{Q=D+ja|0;E=D+(la-ja)|0;pa=a[Q>>0]|0;a[Q>>0]=a[E>>0]|0;a[E>>0]=pa;ja=ja+1|0}while(ja>>>0<ia>>>0);wa=c[t>>2]|0;xa=ka}else{wa=H;xa=ka}}else{wa=H;xa=$}ia=(c[r>>2]|0)+38|0;ja=a[ia>>0]|0;la=wa+(B*20|0)|0;if(!(ja<<24>>24)){_=ea(g[wa+(B*20|0)+4>>2]);Z=ea(g[wa+(B*20|0)+8>>2]);Y=ea(g[wa+(B*20|0)+12>>2]);ya=ea(g[la>>2]);za=_;Aa=Z;Ba=Y}else{N=c[e>>2]|0;Y=ea(g[wa+(B*20|0)+4>>2]);Z=ea(g[wa+(B*20|0)+8>>2]);P=wa+(B*20|0)+12|0;_=ea(g[P>>2]);X=ea(g[la>>2]);W=_;la=ja;ja=0;while(1){_=ea(X*ea(g[N+(ja*12|0)>>2]));S=ea(_+ea(Y*ea(g[N+(ja*12|0)+4>>2])));_=ea(-ea(S+ea(Z*ea(g[N+(ja*12|0)+8>>2]))));if(W>_){g[P>>2]=_;Ca=a[ia>>0]|0;Da=_}else{Ca=la;Da=W}ja=ja+1|0;if(ja>>>0>=(Ca&255)>>>0){ya=X;za=Y;Aa=Z;Ba=Da;break}else{W=Da;la=Ca}}}W=ea(ea(g[p>>2])*ya);Z=ea(W+ea(ea(g[h>>2])*za));if(ea(Ba+ea(Z+ea(ea(g[o>>2])*Aa)))>ea(0.0)){la=a[wa+(B*20|0)+18>>0]|0;ja=la&255;if(!(la<<24>>24==0|O)?(la=ja>>>1,(la|0)!=0):0){ia=ja+-1|0;ja=0;do{P=D+ja|0;N=D+(ia-ja)|0;$=a[P>>0]|0;a[P>>0]=a[N>>0]|0;a[N>>0]=$;ja=ja+1|0}while(ja>>>0<la>>>0);la=c[t>>2]|0;Z=ea(g[la+(B*20|0)+4>>2]);W=ea(g[la+(B*20|0)+8>>2]);Ea=la;Fa=Z;Ga=W;Ha=ea(g[la+(B*20|0)+12>>2])}else{Ea=wa;Fa=za;Ga=Aa;Ha=Ba}la=Ea+(B*20|0)|0;W=ea(-Fa);Z=ea(-Ga);g[la>>2]=ea(-ea(g[la>>2]));g[Ea+(B*20|0)+4>>2]=W;g[Ea+(B*20|0)+8>>2]=Z;g[Ea+(B*20|0)+12>>2]=ea(-Ha);Ia=Ea}else Ia=wa;la=B+1|0;ja=c[m>>2]|0;if(la>>>0>=ja>>>0){L=ja;break a}w=c[s>>2]|0;F=Ia;n=n+(G+1<<2)|0;D=D+(d[Ia+(B*20|0)+18>>0]|0)|0;J=xa;B=la}}while(0);xa=c[e>>2]|0;if((z|0)!=(xa|0)){YEi(xa|0,z|0,(y&255)*12|0)|0;VJa(q,z);a[(c[r>>2]|0)+38>>0]=y}if(!(NIa(e,L,0)|0)){u=0;dLa(l);dLa(k);dLa(j);i=f;return u|0}if(L){y=0;do{z=a[(c[r>>2]|0)+38>>0]|0;q=c[t>>2]|0;if(!(z<<24>>24))Ja=-1;else{Ha=ea(g[q+(y*20|0)>>2]);Ga=ea(g[q+(y*20|0)+4>>2]);Fa=ea(g[q+(y*20|0)+8>>2]);xa=c[e>>2]|0;Ia=0;Ba=ea(3402823469999999843913219.0e14);s=-1;while(1){Aa=ea(ea(g[xa>>2])*Ha);za=ea(Aa+ea(ea(g[xa+4>>2])*Ga));Aa=ea(za+ea(ea(g[xa+8>>2])*Fa));m=Aa<Ba;wa=m?Ia:s;Ia=Ia+1<<24>>24;if((Ia&255)>=(z&255)){Ja=wa;break}else{xa=xa+12|0;Ba=m?Aa:Ba;s=wa}}}a[q+(y*20|0)+19>>0]=Ja;y=y+1|0}while(y>>>0<L>>>0)}u=OIa(e)|0;dLa(l);dLa(k);dLa(j);i=f;return u|0}function RIa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im;e=i;f=c[b>>2]|0;if((f|0)==0?1:(a[(c[b+20>>2]|0)+38>>0]|0)==0){h=0;i=e;return h|0}g[d>>2]=ea(0.0);j=d+4|0;g[j>>2]=ea(0.0);k=d+8|0;g[k>>2]=ea(0.0);l=c[b+32>>2]|0;if(!l){m=ea(0.0);n=ea(0.0);o=ea(0.0);p=ea(0.0)}else{q=c[b+36>>2]|0;r=ea(0.0);s=ea(0.0);t=ea(0.0);u=ea(0.0);b=0;while(1){v=c[q+(b*12|0)>>2]|0;w=c[q+(b*12|0)+4>>2]|0;x=c[q+(b*12|0)+8>>2]|0;y=ea(g[f+(v*12|0)>>2]);z=ea(g[f+(w*12|0)>>2]);A=ea(y-z);B=ea(g[f+(v*12|0)+4>>2]);C=ea(g[f+(w*12|0)+4>>2]);D=ea(B-C);E=ea(g[f+(v*12|0)+8>>2]);F=ea(g[f+(w*12|0)+8>>2]);G=ea(E-F);H=ea(g[f+(x*12|0)>>2]);I=ea(y-H);J=ea(g[f+(x*12|0)+4>>2]);K=ea(B-J);L=ea(g[f+(x*12|0)+8>>2]);M=ea(E-L);N=ea(ea(D*M)-ea(G*K));O=ea(ea(G*I)-ea(A*M));M=ea(ea(A*K)-ea(D*I));I=ea(ea(T(ea(ea(M*M)+ea(ea(N*N)+ea(O*O)))))*ea(.5));O=ea(ea(ea(ea(B+C)+J)*ea(.333333343))*I);J=ea(I*ea(ea(ea(E+F)+L)*ea(.333333343)));L=ea(r+ea(ea(ea(ea(y+z)+H)*ea(.333333343))*I));g[d>>2]=L;H=ea(O+s);g[j>>2]=H;O=ea(J+t);g[k>>2]=O;J=ea(u+I);b=b+1|0;if(b>>>0>=l>>>0){m=L;n=H;o=O;p=J;break}else{r=L;s=H;t=O;u=J}}}u=ea(ea(1.0)/p);g[d>>2]=ea(u*m);g[j>>2]=ea(u*n);g[k>>2]=ea(u*o);h=1;i=e;return h|0}function SIa(b,f,h){b=b|0;f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=0;j=i;i=i+32|0;l=j;if(!($Ma(67,76,72,76,7,h,f)|0)){m=0;i=j;return m|0}if(!($Ma(67,86,72,76,7,h,f)|0)){m=0;i=j;return m|0}if(!(TIa(b)|0)){m=0;i=j;return m|0}n=b+20|0;VMa(d[(c[n>>2]|0)+38>>0]|0,h,f);VMa(e[(c[n>>2]|0)+36>>1]|0,h,f);o=a[(c[n>>2]|0)+39>>0]|0;if(!(o<<24>>24)){QIa(b)|0;p=a[(c[n>>2]|0)+39>>0]|0}else p=o;VMa(p&255,h,f);p=a[(c[n>>2]|0)+39>>0]|0;if(!(p<<24>>24))q=0;else{o=c[b+4>>2]|0;r=p&255;p=0;s=0;while(1){t=(d[o+(s*20|0)+18>>0]|0)+p|0;s=s+1|0;if(s>>>0>=r>>>0){q=t;break}else p=t}}VMa(q,h,f);ZMa(c[b>>2]|0,(d[(c[n>>2]|0)+38>>0]|0)*3|0,h,f);p=c[n>>2]|0;if(!(a[p+39>>0]|0)){u=f;v=p}else{p=b+4|0;r=l+4|0;s=l+8|0;o=l+12|0;t=l+16|0;w=l+3|0;x=l+1|0;y=l+2|0;z=r+3|0;A=r+1|0;B=r+2|0;C=s+3|0;D=s+1|0;E=s+2|0;F=o+3|0;G=o+1|0;H=o+2|0;I=t+1|0;J=0;do{K=c[p>>2]|0;L=ea(g[K+(J*20|0)>>2]);g[l>>2]=L;M=ea(g[K+(J*20|0)+4>>2]);g[r>>2]=M;N=ea(g[K+(J*20|0)+8>>2]);g[s>>2]=N;O=ea(g[K+(J*20|0)+12>>2]);g[o>>2]=O;P=K+(J*20|0)+16|0;K=e[P>>1]|e[P+2>>1]<<16;c[t>>2]=K;P=(g[k>>2]=L,c[k>>2]|0);Q=(g[k>>2]=M,c[k>>2]|0);R=(g[k>>2]=N,c[k>>2]|0);S=(g[k>>2]=O,c[k>>2]|0);if(h){a[l>>0]=P>>>24;a[w>>0]=P;a[x>>0]=P>>>16;a[y>>0]=P>>>8;a[r>>0]=Q>>>24;a[z>>0]=Q;a[A>>0]=Q>>>16;a[B>>0]=Q>>>8;a[s>>0]=R>>>24;a[C>>0]=R;a[D>>0]=R>>>16;a[E>>0]=R>>>8;a[o>>0]=S>>>24;a[F>>0]=S;a[G>>0]=S>>>16;a[H>>0]=S>>>8;a[t>>0]=K>>>8;a[I>>0]=K}xo[c[c[f>>2]>>2]&2047](f,l,20)|0;J=J+1|0;K=c[n>>2]|0}while(J>>>0<(d[K+39>>0]|0)>>>0);u=f;v=K}J=c[c[u>>2]>>2]|0;if(!q){T=J;U=v}else{v=b+8|0;l=J;J=0;do{xo[l&2047](f,(c[v>>2]|0)+J|0,1)|0;J=J+1|0;l=c[c[u>>2]>>2]|0}while((J|0)!=(q|0));T=l;U=c[n>>2]|0}xo[T&2047](f,c[b+12>>2]|0,e[U+36>>1]<<1)|0;xo[c[c[u>>2]>>2]&2047](f,c[b+16>>2]|0,(d[(c[n>>2]|0)+38>>0]|0)*3|0)|0;m=1;i=j;return m|0}function TIa(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;g=i;i=i+64|0;h=g;j=g+4|0;k=g+44|0;l=g+42|0;m=g+41|0;n=g+40|0;o=g+43|0;p=g+45|0;q=g+46|0;r=g+47|0;s=g+48|0;t=g+49|0;u=g+50|0;v=f+20|0;w=a[(c[v>>2]|0)+39>>0]|0;if(!(w<<24>>24)){QIa(f)|0;x=a[(c[v>>2]|0)+39>>0]|0;if(!(x<<24>>24)){y=1;z=0;A=0}else{B=x;C=3}}else{B=w;C=3}if((C|0)==3){w=c[f+4>>2]|0;x=B&255;D=0;E=0;while(1){F=(d[w+(E*20|0)+18>>0]|0)+D|0;E=E+1|0;if((E|0)==(x|0)){y=0;z=B;A=F;break}else D=F}}D=A>>>0>1073741823?-1:A<<2;B=(D|0)==0;if(B){G=0;H=0;I=0;J=0;K=0;L=0;M=0}else{x=mKa()|0;E=c[(c[x>>2]|0)+8>>2]|0;w=pKa()|0;F=mo[c[(c[w>>2]|0)+24>>2]&4095](w)|0;w=Bn[E&255](x,D,F?541832:544544,524600,1789)|0;F=mKa()|0;x=c[(c[F>>2]|0)+8>>2]|0;E=pKa()|0;N=mo[c[(c[E>>2]|0)+24>>2]&4095](E)|0;E=Bn[x&255](F,D,N?541832:544544,524600,1790)|0;N=mKa()|0;F=c[(c[N>>2]|0)+8>>2]|0;x=pKa()|0;O=mo[c[(c[x>>2]|0)+24>>2]&4095](x)|0;x=Bn[F&255](N,D,O?541832:544544,524600,1791)|0;O=mKa()|0;N=c[(c[O>>2]|0)+8>>2]|0;F=pKa()|0;P=mo[c[(c[F>>2]|0)+24>>2]&4095](F)|0;G=x;H=Bn[N&255](O,D,P?541832:544544,524600,1792)|0;I=x;J=E;K=w;L=E;M=w}if(!y){y=z&255;z=c[f+4>>2]|0;w=c[f+8>>2]|0;E=M;x=L;P=G;O=H;N=0;while(1){F=a[z+(N*20|0)+18>>0]|0;Q=F&255;R=e[z+(N*20|0)+16>>1]|0;if(!(F<<24>>24)){S=E;T=x;U=P;V=O}else{F=O+(Q<<2)|0;W=x+(Q<<2)|0;X=E;Y=x;Z=P;_=O;$=0;while(1){aa=a[w+($+R)>>0]|0;ba=aa&255;ca=$;$=$+1|0;da=a[w+((($|0)==(Q|0)?0:$)+R)>>0]|0;ea=da&255;fa=(aa&255)>(da&255);c[X>>2]=fa?ea:ba;c[Y>>2]=fa?ba:ea;c[Z>>2]=N;c[_>>2]=ca;if(($|0)==(Q|0))break;else{X=X+4|0;Y=Y+4|0;Z=Z+4|0;_=_+4|0}}S=E+(Q<<2)|0;T=W;U=P+(Q<<2)|0;V=F}N=N+1|0;if((N|0)==(y|0))break;else{E=S;x=T;P=U;O=V}}}KMa(j);V=c[(NMa(NMa(j,L,A,0)|0,M,A,0)|0)+8>>2]|0;b[(c[v>>2]|0)+36>>1]=0;if(B){ga=0;ha=0;ia=0;ja=0;ka=0}else{B=mKa()|0;O=c[(c[B>>2]|0)+8>>2]|0;U=pKa()|0;P=mo[c[(c[U>>2]|0)+24>>2]&4095](U)|0;U=Bn[O&255](B,D,P?541832:544544,524600,1829)|0;P=mKa()|0;B=c[(c[P>>2]|0)+8>>2]|0;O=pKa()|0;T=mo[c[(c[O>>2]|0)+24>>2]&4095](O)|0;O=Bn[B&255](P,D,T?541832:544544,524600,1830)|0;T=mKa()|0;P=c[(c[T>>2]|0)+8>>2]|0;B=pKa()|0;x=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;ga=U;ha=O;ia=Bn[P&255](T,D,x?541832:544544,524600,1831)|0;ja=O;ka=U}U=(A|0)==0;if(!U){O=(c[v>>2]|0)+36|0;x=-1;D=-1;T=0;while(1){P=c[V+(T<<2)>>2]|0;B=c[G+(P<<2)>>2]|0;S=c[H+(P<<2)>>2]|0;E=c[M+(P<<2)>>2]|0;y=c[L+(P<<2)>>2]|0;P=b[O>>1]|0;if((E|0)==(x|0)&(y|0)==(D|0)){la=P;ma=x;na=D}else{N=P+1<<16>>16;b[O>>1]=N;la=N;ma=E;na=y}c[ga+(T<<2)>>2]=B;c[ha+(T<<2)>>2]=S;c[ia+(T<<2)>>2]=(la&65535)+-1;T=T+1|0;if((T|0)==(A|0))break;else{x=ma;D=na}}}na=c[(NMa(NMa(j,ha,A,0)|0,ga,A,0)|0)+8>>2]|0;ha=f+28|0;VJa(k,c[ha>>2]|0);c[ha>>2]=0;k=A>>>0>2147483647?-1:A<<1;if(!k)oa=0;else{D=mKa()|0;ma=c[(c[D>>2]|0)+8>>2]|0;x=pKa()|0;T=mo[c[(c[x>>2]|0)+24>>2]&4095](x)|0;oa=Bn[ma&255](D,k,T?541936:544544,524600,1863)|0}c[ha>>2]=oa;if(!U){T=0;do{b[oa+(T<<1)>>1]=c[ia+(c[na+(T<<2)>>2]<<2)>>2];T=T+1|0}while((T|0)!=(A|0))}VJa(l,H);VJa(m,I);VJa(n,J);VJa(o,K);K=f+24|0;VJa(p,c[K>>2]|0);c[K>>2]=0;p=b[(c[v>>2]|0)+36>>1]|0;if(!(p<<16>>16)){pa=0;qa=0}else{o=mKa()|0;J=c[(c[o>>2]|0)+8>>2]|0;n=pKa()|0;I=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[J&255](o,(p&65535)<<3,I?525352:544544,524600,1876)|0;pa=n;qa=b[(c[v>>2]|0)+36>>1]|0}c[K>>2]=pa;PEi(pa|0,0,(qa&65535)<<3|0)|0;if(U)ra=c[K>>2]|0;else{qa=c[K>>2]|0;pa=c[ha>>2]|0;n=0;while(1){I=qa+(e[pa>>1]<<3)+2|0;b[I>>1]=(b[I>>1]|0)+1<<16>>16;n=n+1|0;if((n|0)==(A|0)){ra=qa;break}else pa=pa+2|0}}pa=b[(c[v>>2]|0)+36>>1]|0;do if(pa<<16>>16){qa=0;while(1){if((b[ra+(qa<<3)+2>>1]|0)!=2){C=35;break}qa=qa+1|0;if(qa>>>0>=(pa&65535)>>>0){C=36;break}}if((C|0)==35){dKa(bKa()|0,32,524600,1892,525272,h);sa=0;MMa(j);i=g;return sa|0}else if((C|0)==36){c[ra+4>>2]=0;qa=pa&65535;if((pa&65535)>1){ta=0;ua=1}else{va=qa;break}do{ta=(e[ra+(ua+-1<<3)+2>>1]|0)+ta|0;c[ra+(ua<<3)+4>>2]=ta;ua=ua+1|0}while(ua>>>0<qa>>>0);va=qa}}else{c[ra+4>>2]=0;va=0}while(0);ua=va+-1|0;va=(e[ra+(ua<<3)+2>>1]|0)+(c[ra+(ua<<3)+4>>2]|0)|0;ua=f+12|0;VJa(q,c[ua>>2]|0);c[ua>>2]=0;if(!va)wa=0;else{q=mKa()|0;f=c[(c[q>>2]|0)+8>>2]|0;ra=pKa()|0;ta=mo[c[(c[ra>>2]|0)+24>>2]&4095](ra)|0;wa=Bn[f&255](q,va,ta?543296:544544,524600,1905)|0}c[ua>>2]=wa;a:do if(!U){ta=wa;va=c[ha>>2]|0;q=0;while(1){f=c[ga+(c[na+(q<<2)>>2]<<2)>>2]&255;ra=(c[K>>2]|0)+(e[va>>1]<<3)+4|0;pa=c[ra>>2]|0;c[ra>>2]=pa+1;a[ta+pa>>0]=f;f=q+1|0;if((f|0)==(A|0))break a;ta=c[ua>>2]|0;va=va+2|0;q=f}}while(0);ua=c[K>>2]|0;c[ua+4>>2]=0;A=b[(c[v>>2]|0)+36>>1]|0;if((A&65535)>1){v=A&65535;A=0;na=1;do{A=(e[ua+(na+-1<<3)+2>>1]|0)+A|0;c[ua+(na<<3)+4>>2]=A;na=na+1|0}while(na>>>0<v>>>0)}VJa(r,ia);VJa(s,ja);VJa(t,ka);VJa(u,c[K>>2]|0);c[K>>2]=0;sa=1;MMa(j);i=g;return sa|0}function UIa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+16|0;k=j+4|0;l=j;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;m=b+32|0;c[m>>2]=c[g>>2];g=b+20|0;a[(c[g>>2]|0)+38>>0]=c[e>>2];e=UJa(j+8|0,(d[(c[g>>2]|0)+38>>0]|0)*12|0,524600,1664)|0;c[b>>2]=e;YEi(e|0,f|0,(d[(c[g>>2]|0)+38>>0]|0)*12|0)|0;f=c[m>>2]|0;e=f>>>0>357913941?-1:f*12|0;if(!e){n=0;o=f}else{f=mKa()|0;p=c[(c[f>>2]|0)+8>>2]|0;q=pKa()|0;r=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[p&255](f,e,r?525472:544544,524600,1667)|0;n=q;o=c[m>>2]|0}c[b+36>>2]=n;if(o){o=0;do{q=o*3|0;c[n+(o*12|0)>>2]=c[h+(q<<2)>>2];c[n+(o*12|0)+4>>2]=c[h+(q+1<<2)>>2];c[n+(o*12|0)+8>>2]=c[h+(q+2<<2)>>2];o=o+1|0}while(o>>>0<(c[m>>2]|0)>>>0)}c[l>>2]=d[(c[g>>2]|0)+38>>0];I5a(m,n,l,c[b>>2]|0);a[(c[g>>2]|0)+38>>0]=c[l>>2];l=a[(c[g>>2]|0)+38>>0]|0;g=c[b>>2]|0;c[k>>2]=c[m>>2];if(!(J5a(k,n,0)|0)){s=0;i=j;return s|0}if(!(K5a(l&255,g,c[k>>2]|0,n,0)|0)){s=0;i=j;return s|0}if(!(QIa(b)|0)){s=0;i=j;return s|0}s=PIa(b)|0;i=j;return s|0}function VIa(a){a=a|0;var b=0;b=i;mOa(a);c[a>>2]=525664;c[a+8>>2]=525740;KIa(a+132|0,a+16|0);i=b;return}function WIa(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=525664;c[a+8>>2]=525740;LIa(a+132|0);pOa(a);VJa(b,a);i=b;return}function XIa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+-8|0;c[d>>2]=525664;c[d+8>>2]=525740;LIa(d+132|0);pOa(d);VJa(b,d);i=b;return}function YIa(a){a=a|0;var b=0;b=i;c[a>>2]=525664;c[a+8>>2]=525740;LIa(a+132|0);pOa(a);i=b;return}function ZIa(a){a=a|0;var b=0,d=0;b=i;d=a+-8|0;c[d>>2]=525664;c[d+8>>2]=525740;LIa(d+132|0);pOa(d);i=b;return}function _Ia(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;j=c[e+8>>2]|0;a:do if(j>>>0>=3){if(j>>>0>65535?(b[e+48>>1]&2)!=0:0)break;if((c[e+4>>2]|0)!=0?(c[e>>2]|0)>>>0>=12:0){do if(!(c[e+16>>2]|0)){if(!(c[e+28>>2]|0))if(!(b[e+48>>1]&4))break a;else break;if((c[e+32>>2]|0)>>>0<4)break a;if(!(c[e+40>>2]|0))break a;if((c[e+36>>2]|0)>>>0<((b[e+48>>1]&2)!=0?2:4)>>>0)break a;if((c[e+24>>2]|0)>>>0<20)break a}else{if((c[e+20>>2]|0)>>>0<2)break a;if((c[e+12>>2]|0)>>>0<((b[e+48>>1]&2)!=0?6:12)>>>0)break a}while(0);if(((b[e+50>>1]|0)+-4<<16>>16&65535)<253){if(!($Ia(a,e)|0)){k=0;i=g;return k|0}l=a+54|0;vLa(a+16|0,d[l>>0]|0,c[a+132>>2]|0);m=d[l>>0]|0;switch(f|0){case 4:case 2:case 1:{n=128;break}case 0:{n=32;break}case 3:{n=32;break}default:n=0}if(m>>>0>n>>>0)aJa(a)|0;bJa(a);k=1;i=g;return k|0}}}while(0);dKa(bKa()|0,4,525752,73,525848,h);k=0;i=g;return k|0}function $Ia(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=g+8|0;l=c[k>>2]|0;m=i;i=i+((1*(l*12|0)|0)+15&-16)|0;n=c[g>>2]|0;if(l){o=l;l=m;p=c[g+4>>2]|0;while(1){o=o+-1|0;q=l+0|0;r=p+0|0;s=q+12|0;do{a[q>>0]=a[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));if(!o)break;else{l=l+12|0;p=p+n|0}}}n=g+12|0;p=c[g+16>>2]|0;a:do if(p){l=c[g+20>>2]|0;o=i;i=i+((1*(l*12|0)|0)+15&-16)|0;if(!(b[g+48>>1]&2)){t=c[n>>2]|0;if(!l){u=o;break}else{v=l;w=o;x=p}while(1){v=v+-1|0;q=w+0|0;r=x+0|0;s=q+12|0;do{a[q>>0]=a[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));if(!v){u=o;break a}else{w=w+12|0;x=x+t|0}}}t=o+(l*3<<2)|0;if(o>>>0<t>>>0){y=o;z=p;while(1){c[y>>2]=e[z>>1];c[y+4>>2]=e[z+2>>1];c[y+8>>2]=e[z+4>>1];y=y+12|0;if(y>>>0>=t>>>0){u=o;break}else z=z+(c[n>>2]|0)|0}}else u=o}else u=0;while(0);n=g+36|0;p=c[g+40>>2]|0;b:do if(p){x=c[g+44>>2]|0;w=i;i=i+((1*(x<<2)|0)+15&-16)|0;if(!(b[g+48>>1]&2)){v=c[n>>2]|0;if(!x){A=w;break}else{B=x;C=w;D=p}while(1){B=B+-1|0;z=d[D>>0]|d[D+1>>0]<<8|d[D+2>>0]<<16|d[D+3>>0]<<24;a[C>>0]=z;a[C+1>>0]=z>>8;a[C+2>>0]=z>>16;a[C+3>>0]=z>>24;if(!B){A=w;break b}else{C=C+4|0;D=D+v|0}}}v=w+(x<<2)|0;if(w>>>0<v>>>0){o=w;z=p;while(1){c[o>>2]=e[z>>1];c[o+4>>2]=e[z+2>>1];c[o+8>>2]=e[z+4>>1];o=o+12|0;if(o>>>0>=v>>>0){A=w;break}else z=z+(c[n>>2]|0)|0}}else A=w}else A=u;while(0);u=c[g+28>>2]|0;n=g+32|0;if(u){p=c[n>>2]|0;D=i;i=i+((1*(p*20|0)|0)+15&-16)|0;C=c[g+24>>2]|0;if(!p)E=D;else{B=p;p=D;z=u;while(1){B=B+-1|0;q=p+0|0;r=z+0|0;s=q+20|0;do{a[q>>0]=a[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));if(!B){E=D;break}else{p=p+20|0;z=z+C|0}}}}else E=0;if(MIa(f+132|0,c[k>>2]|0,m,c[g+20>>2]|0,A,c[n>>2]|0,E)|0){dJa(f);F=1;i=h;return F|0}else{dKa(bKa()|0,32,525752,266,526088,j);F=0;i=h;return F|0}return 0}function aJa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;e=a+84|0;f=c[e>>2]|0;if(f){dOa(f);VJa(b+12|0,f)}f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,28,j?540136:544544,525752,340)|0;cOa(h);c[e>>2]=h;EIa(d,a+16|0,h,c[a+132>>2]|0);JIa(d,16)|0;i=b;return 1}function bJa(b){b=b|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=Im;e=i;i=i+16|0;f=e;h=c[b+136>>2]|0;j=c[b+132>>2]|0;k=b+64|0;g[k>>2]=ea(3402823469999999843913219.0e14);l=b+55|0;m=a[l>>0]|0;if(!(m<<24>>24))n=ea(3402823469999999843913219.0e14);else{o=ea(g[b+40>>2]);p=ea(g[b+44>>2]);q=ea(g[b+48>>2]);r=ea(3402823469999999843913219.0e14);s=0;while(1){t=ea(o*ea(g[h+(s*20|0)>>2]));u=ea(t+ea(p*ea(g[h+(s*20|0)+4>>2])));t=ea(u+ea(q*ea(g[h+(s*20|0)+8>>2])));u=ea(S(ea(ea(g[h+(s*20|0)+12>>2])+t)));if(u<r){g[k>>2]=u;v=u}else v=r;s=s+1|0;if(s>>>0>=(m&255)>>>0){n=v;break}else r=v}}m=a[b+54>>0]|0;s=m&255;if(!(m<<24>>24)){w=ea(-3402823469999999843913219.0e14);x=ea(-3402823469999999843913219.0e14);y=ea(-3402823469999999843913219.0e14);z=ea(3402823469999999843913219.0e14);A=ea(3402823469999999843913219.0e14);B=ea(3402823469999999843913219.0e14)}else{v=ea(-3402823469999999843913219.0e14);r=ea(-3402823469999999843913219.0e14);q=ea(-3402823469999999843913219.0e14);p=ea(3402823469999999843913219.0e14);o=ea(3402823469999999843913219.0e14);u=ea(3402823469999999843913219.0e14);m=0;while(1){t=ea(g[j+(m*12|0)>>2]);C=t<p?t:p;D=t>v?t:v;t=ea(g[j+(m*12|0)+4>>2]);E=t<o?t:o;F=t>r?t:r;t=ea(g[j+(m*12|0)+8>>2]);G=t<u?t:u;H=t>q?t:q;m=m+1|0;if((m|0)==(s|0)){w=D;x=F;y=H;z=C;A=E;B=G;break}else{v=D;r=F;q=H;p=C;o=E;u=G}}}u=ea(w-z);z=ea(x-A);A=ea(y-B);g[f>>2]=u;g[f+4>>2]=z;g[f+8>>2]=A;B=ea(n/ea(1.73205078));s=z>u&1;m=A>ea(g[f+(s<<2)>>2]);j=m?2:s;A=ea(ea(g[f+(j<<2)>>2])*ea(.5));u=ea(ea(A-B)*ea(.0009765625));f=b+76|0;g[f>>2]=B;s=b+72|0;g[s>>2]=B;m=b+68|0;g[m>>2]=B;I=b+(j<<2)+68|0;g[I>>2]=A;J=b+40|0;z=A;K=0;while(1){if(M5a(J,m,d[l>>0]|0,h)|0)break;z=ea(z-u);g[I>>2]=z;K=K+1|0;if(K>>>0>=1024){L=11;break}}if((L|0)==11){g[f>>2]=B;g[s>>2]=B;g[m>>2]=B;i=e;return}z=ea(ea(ea(g[k>>2])-B)*ea(.0009765625));k=1<<j&3;j=b+(k<<2)+68|0;s=b+((1<<k&3)<<2)+68|0;B=ea(g[s>>2]);k=0;while(1){M=ea(g[j>>2]);g[j>>2]=ea(z+M);u=ea(z+ea(g[s>>2]));g[s>>2]=u;k=k+1|0;if(!(M5a(J,m,d[l>>0]|0,h)|0))break;if(k>>>0>=1024){L=16;break}else B=u}if((L|0)==16){i=e;return}g[j>>2]=M;g[s>>2]=B;i=e;return}function cJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;if(!(_Ma(67,86,88,77,13,d,b)|0)){h=0;i=e;return h|0}VMa(0,d,b);j=a+132|0;if(!(SIa(j,b,d)|0)){h=0;i=e;return h|0}WMa(ea(0.0),d,b);k=a+16|0;WMa(ea(g[k>>2]),d,b);WMa(ea(g[a+20>>2]),d,b);WMa(ea(g[a+24>>2]),d,b);WMa(ea(g[a+28>>2]),d,b);WMa(ea(g[a+32>>2]),d,b);WMa(ea(g[a+36>>2]),d,b);WMa(ea(g[a+88>>2]),d,b);ZMa(a+92|0,9,d,b);ZMa(a+40|0,3,d,b);l=a+84|0;if(!(c[l>>2]|0))WMa(ea(-1.0),d,b);else{WMa(ea(1.0),d,b);EIa(f,k,c[l>>2]|0,c[j>>2]|0);GIa(f,b,d,c[a+164>>2]|0,c[a+168>>2]|0)|0}WMa(ea(g[a+64>>2]),d,b);WMa(ea(g[a+68>>2]),d,b);WMa(ea(g[a+72>>2]),d,b);WMa(ea(g[a+76>>2]),d,b);h=1;i=e;return h|0}function dJa(d){d=d|0;var e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0.0,I=0.0,J=0.0;e=i;i=i+224|0;f=e+168|0;j=e;l=e+184|0;m=e+172|0;n=d+88|0;if(!(ea(g[n>>2])<=ea(0.0))){i=e;return};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;b[l+24>>1]=0;o=a[d+54>>0]|0;p=o&255;c[l+8>>2]=p;c[l+20>>2]=c[d+164>>2];c[l>>2]=12;c[l+12>>2]=12;q=c[d+132>>2]|0;c[l+4>>2]=q;c[l+16>>2]=c[d+168>>2];g[m>>2]=ea(0.0);r=m+4|0;g[r>>2]=ea(0.0);s=m+8|0;g[s>>2]=ea(0.0);if(!(o<<24>>24)){t=ea(0.0);u=ea(0.0);v=ea(0.0)}else{w=ea(0.0);x=ea(0.0);y=ea(0.0);o=0;while(1){z=ea(ea(g[q+(o*12|0)>>2])+w);g[m>>2]=z;A=ea(ea(g[q+(o*12|0)+4>>2])+x);g[r>>2]=A;B=ea(ea(g[q+(o*12|0)+8>>2])+y);g[s>>2]=B;o=o+1|0;if(o>>>0>=p>>>0){t=z;u=A;v=B;break}else{w=z;x=A;y=B}}}y=ea(ea(1.0)/ea(p|0));g[m>>2]=ea(y*t);g[r>>2]=ea(y*u);g[s>>2]=ea(y*v);if(((((((((((((fJa(l,ea(1.0),j,m)|0?(m=d+92|0,v=ea(+h[j+24>>3]),g[m>>2]=v,y=ea(+h[j+48>>3]),g[m+4>>2]=y,u=ea(+h[j+72>>3]),g[m+8>>2]=u,l=m+12|0,t=ea(+h[j+32>>3]),g[l>>2]=t,x=ea(+h[j+56>>3]),g[l+4>>2]=x,w=ea(+h[j+80>>3]),g[l+8>>2]=w,l=m+24|0,B=ea(+h[j+40>>3]),g[l>>2]=B,A=ea(+h[j+64>>3]),g[l+4>>2]=A,z=ea(+h[j+88>>3]),g[l+8>>2]=z,C=ea(g[j>>2]),g[d+40>>2]=C,D=ea(g[j+4>>2]),g[d+44>>2]=D,E=ea(g[j+8>>2]),g[d+48>>2]=E,((g[k>>2]=v,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(l=d+96|0,((g[k>>2]=y,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(s=d+100|0,((g[k>>2]=u,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(r=d+104|0,((g[k>>2]=t,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(p=d+108|0,((g[k>>2]=x,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(o=d+112|0,((g[k>>2]=w,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(q=d+116|0,((g[k>>2]=B,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(F=d+120|0,((g[k>>2]=A,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?(G=d+124|0,((g[k>>2]=z,c[k>>2]|0)&2139095040)>>>0<2139095040):0)?((g[k>>2]=C,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?((g[k>>2]=D,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?((g[k>>2]=E,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?(d=j+16|0,H=+h[d>>3],E=ea(H),((g[k>>2]=E,c[k>>2]|0)&2139095040)>>>0<2139095040):0){if(H<0.0){dKa(bKa()|0,2,525752,182,525904,f);I=-+h[d>>3];h[d>>3]=I;E=ea(-ea(g[m>>2]));D=ea(-ea(g[l>>2]));C=ea(-ea(g[s>>2]));z=ea(-ea(g[r>>2]));A=ea(-ea(g[p>>2]));B=ea(-ea(g[o>>2]));w=ea(-ea(g[q>>2]));x=ea(-ea(g[F>>2]));t=ea(-ea(g[G>>2]));g[m>>2]=E;g[l>>2]=D;g[s>>2]=C;g[r>>2]=z;g[p>>2]=A;g[o>>2]=B;g[q>>2]=w;g[F>>2]=x;g[G>>2]=t;J=I}else J=H;g[n>>2]=ea(J);i=e;return}dKa(bKa()|0,32,525752,191,526032,f);i=e;return}function eJa(a,e,f,h,j,k,l,m,n,o,p,q){a=a|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0;r=i;i=i+16|0;s=a+132|0;if(!(UIa(s,e,f,h,j)|0)){dKa(bKa()|0,32,525752,283,526240,r);t=0;i=r;return t|0}j=c[a+152>>2]|0;c[l>>2]=d[j+38>>0];c[p>>2]=d[j+39>>0];j=Bn[c[(c[k>>2]|0)+8>>2]&255](k,(c[l>>2]|0)*12|0,526368,525752,290)|0;c[m>>2]=j;YEi(j|0,c[s>>2]|0,(c[l>>2]|0)*12|0)|0;c[n>>2]=0;if(!(c[p>>2]|0))u=0;else{l=c[a+136>>2]|0;s=0;j=0;do{s=s+(d[l+(j*20|0)+18>>0]|0)|0;c[n>>2]=s;j=j+1|0}while(j>>>0<(c[p>>2]|0)>>>0);u=s<<2}s=Bn[c[(c[k>>2]|0)+8>>2]&255](k,u,526376,525752,299)|0;c[o>>2]=s;if(c[n>>2]|0){o=c[a+140>>2]|0;u=0;do{c[s+(u<<2)>>2]=d[o+u>>0];u=u+1|0}while(u>>>0<(c[n>>2]|0)>>>0)}n=Bn[c[(c[k>>2]|0)+8>>2]&255](k,(c[p>>2]|0)*20|0,526384,525752,305)|0;c[q>>2]=n;q=c[p>>2]|0;if(!q){t=1;i=r;return t|0}p=c[a+136>>2]|0;a=0;do{g[n+(a*20|0)>>2]=ea(g[p+(a*20|0)>>2]);g[n+(a*20|0)+4>>2]=ea(g[p+(a*20|0)+4>>2]);g[n+(a*20|0)+8>>2]=ea(g[p+(a*20|0)+8>>2]);g[n+(a*20|0)+12>>2]=ea(g[p+(a*20|0)+12>>2]);b[n+(a*20|0)+16>>1]=d[p+(a*20|0)+18>>0]|0;b[n+(a*20|0)+18>>1]=b[p+(a*20|0)+16>>1]|0;a=a+1|0}while(a>>>0<q>>>0);t=1;i=r;return t|0}function fJa(a,d,f,j){a=a|0;d=ea(d);f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0;k=i;l=c[a+16>>2]|0;m=c[a+20>>2]|0;a:do if(m){n=a+24|0;o=b[n>>1]|0;p=c[a+4>>2]|0;q=c[a>>2]|0;d=ea(g[j>>2]);r=j+4|0;s=ea(g[r>>2]);t=ea(g[j+8>>2]);u=c[a+12>>2]|0;if(!(o&1)){v=o;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=1;H=l;while(1){if(!(v&2)){I=c[H>>2]|0;J=c[H+4>>2]|0;K=c[H+8>>2]|0}else{I=e[H>>1]|0;J=e[H+2>>1]|0;K=e[H+4>>1]|0}L=da(I,q)|0;M=ea(ea(g[p+L>>2])-d);N=ea(ea(g[p+(L+4)>>2])-s);O=ea(ea(g[p+(L+8)>>2])-t);L=da(J,q)|0;P=ea(ea(g[p+L>>2])-d);Q=ea(ea(g[p+(L+4)>>2])-s);R=ea(ea(g[p+(L+8)>>2])-t);L=da(K,q)|0;S=ea(ea(g[p+L>>2])-d);T=ea(ea(g[p+(L+4)>>2])-s);U=+M;V=+N;W=+O;X=+P;Y=+Q;Z=+R;_=+S;$=+T;aa=+ea(ea(g[p+(L+8)>>2])-t);ba=X-U;ca=Y-V;fa=Z-W;ga=_-U;ha=$-V;ia=aa-W;ja=ca*ia-fa*ha;ka=fa*ga-ba*ia;ia=ba*ha-ca*ga;ga=U+X;ca=ga+_;ha=U*U;ba=ha+X*ga;ga=ba+_*ca;fa=V+Y;la=fa+$;ma=V*V;na=ma+Y*fa;fa=na+$*la;oa=W+Z;pa=oa+aa;qa=W*W;ra=qa+Z*oa;oa=ra+aa*pa;sa=w+ca*ja;ta=x+ga*ja;ua=y+fa*ka;va=z+ia*oa;wa=A+ja*(U*ha+X*ba+_*ga);ba=B+ka*(V*ma+Y*na+$*fa);na=C+ia*(W*qa+Z*ra+aa*oa);ra=D+ja*($*(ga+_*(_+ca))+(V*(ga+U*(U+ca))+Y*(ga+X*(X+ca))));ca=E+ka*(aa*(fa+$*($+la))+(W*(fa+V*(V+la))+Z*(fa+Y*(Y+la))));la=F+ia*(_*(oa+aa*(aa+pa))+(U*(oa+W*(W+pa))+X*(oa+Z*(Z+pa))));if(G>>>0>=m>>>0){xa=j;ya=r;za=sa;Aa=ta;Ba=ua;Ca=va;Da=wa;Ea=ba;Fa=na;Ga=ra;Ha=ca;Ia=la;break a}v=b[n>>1]|0;w=sa;x=ta;y=ua;z=va;A=wa;B=ba;C=na;D=ra;E=ca;F=la;G=G+1|0;H=H+u|0}}else{F=0.0;E=0.0;D=0.0;C=0.0;B=0.0;A=0.0;z=0.0;y=0.0;x=0.0;w=0.0;H=o;G=1;v=l;while(1){if(!(H&2)){Ja=c[v>>2]|0;Ka=c[v+4>>2]|0;La=c[v+8>>2]|0}else{Ja=e[v>>1]|0;Ka=e[v+2>>1]|0;La=e[v+4>>1]|0}L=da(Ja,q)|0;T=ea(ea(g[p+L>>2])-d);S=ea(ea(g[p+(L+4)>>2])-s);R=ea(ea(g[p+(L+8)>>2])-t);L=da(La,q)|0;Q=ea(ea(g[p+L>>2])-d);P=ea(ea(g[p+(L+4)>>2])-s);O=ea(ea(g[p+(L+8)>>2])-t);L=da(Ka,q)|0;N=ea(ea(g[p+L>>2])-d);M=ea(ea(g[p+(L+4)>>2])-s);la=+T;ca=+S;ra=+R;na=+Q;ba=+P;wa=+O;va=+N;ua=+M;ta=+ea(ea(g[p+(L+8)>>2])-t);sa=na-la;pa=ba-ca;Z=wa-ra;oa=va-la;X=ua-ca;W=ta-ra;U=pa*W-Z*X;aa=Z*oa-sa*W;W=sa*X-pa*oa;oa=la+na;pa=oa+va;X=la*la;sa=X+na*oa;oa=sa+va*pa;Z=ca+ba;_=Z+ua;ia=ca*ca;Y=ia+ba*Z;Z=Y+ua*_;fa=ra+wa;V=fa+ta;$=ra*ra;ka=$+wa*fa;fa=ka+ta*V;ga=F+pa*U;ja=E+oa*U;qa=D+Z*aa;ma=C+W*fa;ha=B+U*(la*X+na*sa+va*oa);sa=A+aa*(ca*ia+ba*Y+ua*Z);Y=z+W*(ra*$+wa*ka+ta*fa);ka=y+U*(ua*(oa+va*(va+pa))+(ca*(oa+la*(la+pa))+ba*(oa+na*(na+pa))));pa=x+aa*(ta*(Z+ua*(ua+_))+(ra*(Z+ca*(ca+_))+wa*(Z+ba*(ba+_))));_=w+W*(va*(fa+ta*(ta+V))+(la*(fa+ra*(ra+V))+na*(fa+wa*(wa+V))));if(G>>>0>=m>>>0){xa=j;ya=r;za=ga;Aa=ja;Ba=qa;Ca=ma;Da=ha;Ea=sa;Fa=Y;Ga=ka;Ha=pa;Ia=_;break a}F=ga;E=ja;D=qa;C=ma;B=ha;A=sa;z=Y;y=ka;x=pa;w=_;H=b[n>>1]|0;G=G+1|0;v=v+u|0}}}else{xa=j;ya=j+4|0;za=0.0;Aa=0.0;Ba=0.0;Ca=0.0;Da=0.0;Ea=0.0;Fa=0.0;Ga=0.0;Ha=0.0;Ia=0.0}while(0);w=za*.1666666716337204;za=Da*.01666666753590107;Da=Ea*.01666666753590107;Ea=Fa*.01666666753590107;Fa=Ga*.008333333767950535;Ga=Ha*.008333333767950535;Ha=Ia*.008333333767950535;h[f+16>>3]=w;t=ea(Aa*.0416666679084301/w);g[f>>2]=t;s=ea(Ba*.0416666679084301/w);m=f+4|0;g[m>>2]=s;d=ea(Ca*.0416666679084301/w);Ka=f+8|0;g[Ka>>2]=d;Ca=Ea+Da;La=f+24|0;h[La>>3]=Ca;Ba=Ea+za;Ja=f+56|0;h[Ja>>3]=Ba;Ea=Da+za;l=f+88|0;h[l>>3]=Ea;za=-Fa;K=f+48|0;h[K>>3]=za;J=f+32|0;h[J>>3]=za;za=-Ga;I=f+80|0;h[I>>3]=za;a=f+64|0;h[a>>3]=za;za=-Ha;u=f+72|0;h[u>>3]=za;v=f+40|0;h[v>>3]=za;M=ea(s*s);N=ea(d*d);O=ea(M+N);h[f+96>>3]=Ca-w*+O;P=ea(t*t);Q=ea(P+N);h[f+128>>3]=Ba-w*+Q;N=ea(P+M);h[f+160>>3]=Ea-w*+N;za=+t;Da=+s;Aa=w*za*Da-Fa;h[f+120>>3]=Aa;h[f+104>>3]=Aa;Aa=+d;Ia=w*Da*Aa-Ga;h[f+152>>3]=Ia;h[f+136>>3]=Ia;Ia=za*(w*Aa)-Ha;h[f+144>>3]=Ia;h[f+112>>3]=Ia;M=ea(g[xa>>2]);xa=M==ea(0.0);P=ea(g[ya>>2]);ya=xa&P==ea(0.0);R=ea(g[j+8>>2]);if(ya&R==ea(0.0)){i=k;return 1}S=ea(t+M);M=ea(s+P);P=ea(d+R);R=ea(M*M);T=ea(P*P);h[La>>3]=Ca-w*+ea(O-ea(R+T));O=ea(S*S);h[Ja>>3]=Ba-w*+ea(Q-ea(O+T));h[l>>3]=Ea-w*+ea(N-ea(O+R));Ea=w*+ea(ea(t*s)-ea(S*M))-Fa;h[K>>3]=Ea;h[J>>3]=Ea;Ea=w*+ea(ea(s*d)-ea(M*P))-Ga;h[I>>3]=Ea;h[a>>3]=Ea;Ea=w*+ea(ea(t*d)-ea(S*P))-Ha;h[u>>3]=Ea;h[v>>3]=Ea;g[f>>2]=S;g[m>>2]=M;g[Ka>>2]=P;i=k;return 1}function gJa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+2|0;j=g+1|0;k=a+4|0;c[k>>2]=0;l=a+8|0;c[l>>2]=0;c[a>>2]=0;if(((d|0)!=0?(c[l>>2]=d,l=UJa(g,d*12|0,526608,153)|0,c[a>>2]=l,(c[k>>2]|0)>0):0)?(c[l+0>>2]=c[0],c[l+4>>2]=c[1],c[l+8>>2]=c[2],(c[k>>2]|0)>1):0){l=1;do{m=(c[a>>2]|0)+(l*12|0)|0;n=0+(l*12|0)|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];l=l+1|0}while((l|0)<(c[k>>2]|0))}l=a+16|0;c[l>>2]=0;n=a+20|0;c[n>>2]=0;m=a+12|0;c[m>>2]=0;if(((e|0)!=0?(c[n>>2]=e,n=UJa(j,e<<2,526608,153)|0,c[m>>2]=n,(c[l>>2]|0)>0):0)?(b[n>>1]=0,b[n+2>>1]=0>>>16,(c[l>>2]|0)>1):0){n=1;do{j=(c[m>>2]|0)+(n<<2)|0;o=c[0+(n<<2)>>2]|0;b[j>>1]=o;b[j+2>>1]=o>>>16;n=n+1|0}while((n|0)<(c[l>>2]|0))}n=a+28|0;c[n>>2]=0;m=a+32|0;c[m>>2]=0;o=a+24|0;c[o>>2]=0;if(!f){c[k>>2]=d;c[l>>2]=e;c[n>>2]=f;i=g;return}c[m>>2]=f;m=UJa(h,f<<4,526608,153)|0;c[o>>2]=m;if((c[n>>2]|0)<=0){c[k>>2]=d;c[l>>2]=e;c[n>>2]=f;i=g;return};c[m+0>>2]=c[0];c[m+4>>2]=c[1];c[m+8>>2]=c[2];c[m+12>>2]=c[3];if((c[n>>2]|0)>1)p=1;else{c[k>>2]=d;c[l>>2]=e;c[n>>2]=f;i=g;return}do{m=(c[o>>2]|0)+(p<<4)|0;h=0+(p<<4)|0;c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];p=p+1|0}while((p|0)<(c[n>>2]|0));c[k>>2]=d;c[l>>2]=e;c[n>>2]=f;i=g;return}function hJa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=UJa(b,12,526432,1420)|0;c[a>>2]=d;if(!d){i=b;return}c[d+4>>2]=0;c[d+8>>2]=0;c[d>>2]=0;i=b;return}function iJa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=c[a>>2]|0;e=c[d>>2]|0;if(e){VJa(b+1|0,e);c[d>>2]=0}c[d+4>>2]=0;c[d+8>>2]=0;c[d>>2]=0;VJa(b,c[a>>2]|0);i=b;return}function jJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;f=d+12|0;g=b+12|0;h=c[c[a>>2]>>2]|0;a=0;do{j=a;a=a+1|0;k=c[b+(((a|0)==3?0:a)<<2)>>2]|0;l=c[b+(((j+2|0)%3|0)<<2)>>2]|0;j=0;while(1){m=j;j=j+1|0;n=(j|0)==3?0:j;o=(m+2|0)%3|0;p=c[d+(m<<2)>>2]|0;if((p|0)==(l|0)?(c[d+(n<<2)>>2]|0)==(k|0):0){q=5;break}if((p|0)==(k|0)?(c[d+(n<<2)>>2]|0)==(l|0):0){q=9;break}if((j|0)>=3){r=526424;break}}if((q|0)==5){q=0;r=f+(o<<2)|0}else if((q|0)==9){q=0;r=f+(o<<2)|0}j=c[r>>2]|0;n=0;while(1){p=n;n=n+1|0;m=(n|0)==3?0:n;s=(p+2|0)%3|0;t=c[b+(p<<2)>>2]|0;if((t|0)==(k|0)?(c[b+(m<<2)>>2]|0)==(l|0):0){q=13;break}if((t|0)==(l|0)?(c[b+(m<<2)>>2]|0)==(k|0):0){q=17;break}if((n|0)>=3){u=526424;break}}if((q|0)==13){q=0;u=g+(s<<2)|0}else if((q|0)==17){q=0;u=g+(s<<2)|0}n=c[h+(c[u>>2]<<2)>>2]|0;m=0;while(1){t=m;m=m+1|0;p=(m|0)==3?0:m;v=(t+2|0)%3|0;w=c[n+(t<<2)>>2]|0;if((w|0)==(l|0)?(c[n+(p<<2)>>2]|0)==(k|0):0){q=21;break}if((w|0)==(k|0)?(c[n+(p<<2)>>2]|0)==(l|0):0){q=25;break}if((m|0)>=3){x=526424;break}}if((q|0)==21){q=0;x=n+12+(v<<2)|0}else if((q|0)==25){q=0;x=n+12+(v<<2)|0}c[x>>2]=j;m=0;while(1){p=m;m=m+1|0;w=(m|0)==3?0:m;y=(p+2|0)%3|0;t=c[b+(p<<2)>>2]|0;if((t|0)==(k|0)?(c[b+(w<<2)>>2]|0)==(l|0):0){q=29;break}if((t|0)==(l|0)?(c[b+(w<<2)>>2]|0)==(k|0):0){q=33;break}if((m|0)>=3){z=526424;break}}if((q|0)==29){q=0;z=g+(y<<2)|0}else if((q|0)==33){q=0;z=g+(y<<2)|0}m=c[z>>2]|0;j=0;while(1){n=j;j=j+1|0;w=(j|0)==3?0:j;A=(n+2|0)%3|0;t=c[d+(n<<2)>>2]|0;if((t|0)==(l|0)?(c[d+(w<<2)>>2]|0)==(k|0):0){q=37;break}if((t|0)==(k|0)?(c[d+(w<<2)>>2]|0)==(l|0):0){q=41;break}if((j|0)>=3){B=526424;break}}if((q|0)==37){q=0;B=f+(A<<2)|0}else if((q|0)==41){q=0;B=f+(A<<2)|0}j=c[h+(c[B>>2]<<2)>>2]|0;w=0;while(1){t=w;w=w+1|0;n=(w|0)==3?0:w;C=(t+2|0)%3|0;p=c[j+(t<<2)>>2]|0;if((p|0)==(k|0)?(c[j+(n<<2)>>2]|0)==(l|0):0){q=45;break}if((p|0)==(l|0)?(c[j+(n<<2)>>2]|0)==(k|0):0){q=49;break}if((w|0)>=3){D=526424;break}}if((q|0)==45){q=0;D=j+12+(C<<2)|0}else if((q|0)==49){q=0;D=j+12+(C<<2)|0}c[D>>2]=m}while((a|0)!=3);i=e;return}function kJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[b+4>>2]|0;j=c[b+8>>2]|0;k=c[(c[a>>2]|0)+4>>2]|0;l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,36,o?526696:544544,526432,1475)|0;N5a(n,d,h,j,c[a>>2]|0);o=n+12|0;l=b+12|0;m=k+1|0;p=k+2|0;c[o>>2]=c[l>>2];c[n+16>>2]=m;c[n+20>>2]=p;q=c[(c[c[a>>2]>>2]|0)+(c[l>>2]<<2)>>2]|0;r=0;while(1){s=r;r=r+1|0;t=(r|0)==3?0:r;u=(s+2|0)%3|0;v=c[q+(s<<2)>>2]|0;if((v|0)==(h|0)?(c[q+(t<<2)>>2]|0)==(j|0):0){w=4;break}if((v|0)==(j|0)?(c[q+(t<<2)>>2]|0)==(h|0):0){w=8;break}if((r|0)>=3){x=526424;break}}if((w|0)==4)x=q+12+(u<<2)|0;else if((w|0)==8)x=q+12+(u<<2)|0;c[x>>2]=k;x=mKa()|0;u=c[(c[x>>2]|0)+8>>2]|0;q=pKa()|0;r=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[u&255](x,36,r?526696:544544,526432,1482)|0;N5a(q,d,j,g,c[a>>2]|0);r=q+12|0;x=l+4|0;c[r>>2]=c[x>>2];c[q+16>>2]=p;c[q+20>>2]=k;u=c[(c[c[a>>2]>>2]|0)+(c[x>>2]<<2)>>2]|0;x=0;while(1){t=x;x=x+1|0;v=(x|0)==3?0:x;y=(t+2|0)%3|0;s=c[u+(t<<2)>>2]|0;if((s|0)==(j|0)?(c[u+(v<<2)>>2]|0)==(g|0):0){w=12;break}if((s|0)==(g|0)?(c[u+(v<<2)>>2]|0)==(j|0):0){w=16;break}if((x|0)>=3){z=526424;break}}if((w|0)==12)z=u+12+(y<<2)|0;else if((w|0)==16)z=u+12+(y<<2)|0;c[z>>2]=m;z=mKa()|0;y=c[(c[z>>2]|0)+8>>2]|0;u=pKa()|0;x=mo[c[(c[u>>2]|0)+24>>2]&4095](u)|0;u=Bn[y&255](z,36,x?526696:544544,526432,1489)|0;N5a(u,d,g,h,c[a>>2]|0);x=u+12|0;z=l+8|0;c[x>>2]=c[z>>2];c[u+16>>2]=k;c[u+20>>2]=m;m=c[c[a>>2]>>2]|0;k=c[m+(c[z>>2]<<2)>>2]|0;z=0;while(1){l=z;z=z+1|0;y=(z|0)==3?0:z;A=(l+2|0)%3|0;j=c[k+(l<<2)>>2]|0;if((j|0)==(g|0)?(c[k+(y<<2)>>2]|0)==(h|0):0){w=20;break}if((j|0)==(h|0)?(c[k+(y<<2)>>2]|0)==(g|0):0){w=24;break}if((z|0)>=3){B=526424;break}}if((w|0)==20)B=k+12+(A<<2)|0;else if((w|0)==24)B=k+12+(A<<2)|0;c[B>>2]=p;p=c[m+(c[o>>2]<<2)>>2]|0;if(!(((c[p>>2]|0)!=(d|0)?(c[p+4>>2]|0)!=(d|0):0)?(c[p+8>>2]|0)!=(d|0):0)){jJa(a,n,p);c[(c[c[a>>2]>>2]|0)+(c[n+24>>2]<<2)>>2]=0;if(n)VJa(f,n);c[(c[c[a>>2]>>2]|0)+(c[p+24>>2]<<2)>>2]=0;if(p)VJa(f,p)}p=c[(c[c[a>>2]>>2]|0)+(c[r>>2]<<2)>>2]|0;if(!(((c[p>>2]|0)!=(d|0)?(c[p+4>>2]|0)!=(d|0):0)?(c[p+8>>2]|0)!=(d|0):0)){jJa(a,q,p);c[(c[c[a>>2]>>2]|0)+(c[q+24>>2]<<2)>>2]=0;if(q)VJa(f,q);c[(c[c[a>>2]>>2]|0)+(c[p+24>>2]<<2)>>2]=0;if(p)VJa(f,p)}p=c[(c[c[a>>2]>>2]|0)+(c[x>>2]<<2)>>2]|0;if(!(((c[p>>2]|0)!=(d|0)?(c[p+4>>2]|0)!=(d|0):0)?(c[p+8>>2]|0)!=(d|0):0)){jJa(a,u,p);c[(c[c[a>>2]>>2]|0)+(c[u+24>>2]<<2)>>2]=0;if(u)VJa(f,u);c[(c[c[a>>2]>>2]|0)+(c[p+24>>2]<<2)>>2]=0;if(p)VJa(f,p)}c[(c[c[a>>2]>>2]|0)+(c[b+24>>2]<<2)>>2]=0;if(!b){i=e;return}VJa(f,b);i=e;return}function lJa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=Im,da=Im,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0,Ka=0,La=Im,Ma=Im,Na=Im,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im;h=i;i=i+160|0;j=h;k=h+64|0;l=h+40|0;m=h+100|0;n=h+124|0;o=h+148|0;p=h+149|0;q=h+150|0;r=h+151|0;s=h+36|0;t=h+112|0;u=h+52|0;v=h+136|0;if((d|0)<4){w=1;i=h;return w|0}x=(e|0)==0;y=ea(g[b>>2]);z=ea(g[b+4>>2]);A=ea(g[b+8>>2]);B=d<<2;C=UJa(h+152|0,B,526608,153)|0;c[s>>2]=C;D=t+4|0;c[D>>2]=0;E=t+8|0;c[E>>2]=d;F=UJa(h+153|0,B,526608,153)|0;c[t>>2]=F;B=C;C=d;G=F;F=d;H=y;I=z;J=A;K=y;y=z;z=A;L=0;M=0;while(1){do if((L|0)==(C|0)){N=(C|0)==0?16:C<<1;c[E>>2]=N;O=UJa(q,N<<2,526608,153)|0;c[t>>2]=O;if((C|0)<=0){if(!G){P=O;Q=N;break}}else{R=0;do{c[O+(R<<2)>>2]=c[G+(R<<2)>>2];R=R+1|0}while((R|0)!=(C|0))}VJa(r,G);P=O;Q=N}else{P=G;Q=C}while(0);c[P+(L<<2)>>2]=1;L=L+1|0;do if((M|0)==(F|0)){R=(M|0)==0?16:M<<1;S=c[s>>2]|0;U=UJa(o,R<<2,526608,153)|0;c[s>>2]=U;if((M|0)<=0){if(!S){V=U;W=R;break}}else{X=0;do{c[U+(X<<2)>>2]=c[S+(X<<2)>>2];X=X+1|0}while((X|0)!=(M|0))}VJa(p,S);V=U;W=R}else{V=B;W=F}while(0);c[V+(M<<2)>>2]=0;A=ea(g[b+(M*12|0)>>2]);Y=ea(g[b+(M*12|0)+4>>2]);Z=ea(g[b+(M*12|0)+8>>2]);M=M+1|0;H=H<A?H:A;I=I<Y?I:Y;J=J<Z?J:Z;K=K>A?K:A;y=y>Y?y:Y;z=z>Z?z:Z;if((M|0)==(d|0))break;else{B=V;C=Q;G=P;F=W}}c[D>>2]=d;Z=ea(K-H);H=ea(y-I);I=ea(z-J);J=ea(ea(T(ea(ea(I*I)+ea(ea(H*H)+ea(Z*Z)))))*ea(.00100000005));W=f!=ea(0.0);if(W)_=ea(f*ea(2.0));else _=ea(ea(J*J)*ea(.100000001));F=j;c[F>>2]=0;c[F+4>>2]=0;g[j>>2]=ea(1.0);g[j+4>>2]=ea(.0199999996);g[j+8>>2]=ea(.00999999977);g[j+12>>2]=ea(-.0199999996);g[j+16>>2]=ea(1.0);g[j+20>>2]=ea(-.00999999977);g[j+24>>2]=ea(.00999999977);g[j+28>>2]=ea(.0199999996);g[j+32>>2]=ea(1.0);if(I>Z&I>H){$=2;aa=0;ba=1}else{F=H>Z&H>I;$=F&1;aa=F?2:1;ba=F?0:2}F=k+16|0;P=k+20|0;G=k+24|0;Q=k+28|0;C=k+32|0;B=j+($*12|0)|0;$=k+0|0;M=$+36|0;do{c[$>>2]=0;$=$+4|0}while(($|0)<(M|0));c[k+0>>2]=c[B+0>>2];c[k+4>>2]=c[B+4>>2];c[k+8>>2]=c[B+8>>2];B=O5a(b,d,k,t)|0;I=ea(g[k>>2]);$=k+4|0;H=ea(g[$>>2]);M=k+8|0;Z=ea(-H);H=ea(-ea(g[M>>2]));g[l>>2]=ea(-I);g[l+4>>2]=Z;g[l+8>>2]=H;p=O5a(b,d,l,t)|0;l=b+(B*12|0)|0;H=ea(g[l>>2]);o=b+(B*12|0)+4|0;Z=ea(g[o>>2]);L=b+(B*12|0)+8|0;I=ea(g[L>>2]);r=b+(p*12|0)|0;f=ea(g[r>>2]);q=b+(p*12|0)+4|0;z=ea(g[q>>2]);X=b+(p*12|0)+8|0;y=ea(H-f);f=ea(Z-z);z=ea(I-ea(g[X>>2]));g[k>>2]=y;g[$>>2]=f;g[M>>2]=z;if((B|0)!=(p|0)?!(y==ea(0.0)&f==ea(0.0)&z==ea(0.0)):0){N=k+12|0;I=ea(g[j+(aa*12|0)>>2]);Z=ea(g[j+(aa*12|0)+4>>2]);H=ea(g[j+(aa*12|0)+8>>2]);K=ea(ea(z*Z)-ea(f*H));Y=ea(ea(y*H)-ea(z*I));H=ea(ea(f*I)-ea(y*Z));aa=k+12|0;g[aa>>2]=K;g[F>>2]=Y;g[P>>2]=H;O=k+24|0;Z=ea(g[j+(ba*12|0)>>2]);I=ea(g[j+(ba*12|0)+4>>2]);A=ea(g[j+(ba*12|0)+8>>2]);ca=ea(ea(z*I)-ea(f*A));da=ea(ea(y*A)-ea(z*Z));z=ea(ea(f*Z)-ea(y*I));g[G>>2]=ca;g[Q>>2]=da;g[C>>2]=z;ba=ea(T(ea(ea(H*H)+ea(ea(K*K)+ea(Y*Y)))))>ea(T(ea(ea(z*z)+ea(ea(ca*ca)+ea(da*da)))));fa=ba?N:O;da=ea(g[fa>>2]);ba=fa+4|0;ca=ea(g[ba>>2]);ga=fa+8|0;z=ea(g[ga>>2]);Y=ea(T(ea(ea(ea(da*da)+ea(ca*ca))+ea(z*z))));if(Y==ea(0.0)){Ec(526896)|0;K=ea(g[fa>>2]);H=ea(g[ba>>2]);ha=K;ia=H;ja=ea(g[ga>>2]);ka=ea(.100000001)}else{ha=da;ia=ca;ja=z;ka=Y}Y=ea(ea(1.0)/ka);ka=ea(ia*Y);ia=ea(ja*Y);g[aa>>2]=ea(ha*Y);g[F>>2]=ka;g[P>>2]=ia;ga=O5a(b,d,N,t)|0;if((ga|0)==(B|0)|(ga|0)==(p|0)){ia=ea(g[N>>2]);ka=ea(g[F>>2]);Y=ea(-ka);ka=ea(-ea(g[P>>2]));g[m>>2]=ea(-ia);g[m+4>>2]=Y;g[m+8>>2]=ka;la=O5a(b,d,m,t)|0}else la=ga;if(!((la|0)==(B|0)|(la|0)==(p|0))){ga=b+(la*12|0)|0;ka=ea(g[ga>>2]);m=b+(la*12|0)+4|0;Y=ea(g[m>>2]);N=b+(la*12|0)+8|0;ia=ea(g[N>>2]);ha=ea(g[l>>2]);ja=ea(g[o>>2]);z=ea(ka-ha);ha=ea(Y-ja);ja=ea(ia-ea(g[L>>2]));g[aa>>2]=z;g[F>>2]=ha;g[P>>2]=ja;ia=ea(g[k>>2]);Y=ea(g[$>>2]);ka=ea(g[M>>2]);ca=ea(ea(ha*ka)-ea(ja*Y));da=ea(ea(ja*ia)-ea(z*ka));ka=ea(ea(z*Y)-ea(ha*ia));ia=ea(T(ea(ea(ka*ka)+ea(ea(ca*ca)+ea(da*da)))));if(ia==ea(0.0)){Ec(526896)|0;ma=ea(.100000001)}else ma=ia;ia=ea(ea(1.0)/ma);ma=ea(da*ia);da=ea(ka*ia);g[G>>2]=ea(ca*ia);g[Q>>2]=ma;g[C>>2]=da;G=O5a(b,d,O,t)|0;if(!((G|0)==(B|0)|(G|0)==(p|0)|(G|0)==(la|0))?(da=ea(g[r>>2]),ma=ea(g[q>>2]),ia=ea(g[X>>2]),ca=ea(g[l>>2]),ka=ea(g[o>>2]),ha=ea(g[L>>2]),Y=ea(da-ca),da=ea(ma-ka),ma=ea(ia-ha),ia=ea(g[ga>>2]),z=ea(g[m>>2]),ja=ea(ia-ca),ia=ea(z-ka),z=ea(ea(g[N>>2])-ha),H=ea(ea(da*z)-ea(ma*ia)),K=ea(ea(ma*ja)-ea(Y*z)),z=ea(ea(Y*ia)-ea(da*ja)),ja=ea(T(ea(ea(z*z)+ea(ea(H*H)+ea(K*K))))),!(ja<ea(9.99999968e-21)&ja>ea(-9.99999968e-21))):0){if(ja==ea(0.0)){Ec(526896)|0;da=ea(g[l>>2]);ia=ea(g[o>>2]);na=da;oa=ia;pa=ea(g[L>>2]);qa=ea(.100000001)}else{na=ca;oa=ka;pa=ha;qa=ja}ja=ea(ea(1.0)/qa);qa=ea(H*ja);H=ea(K*ja);K=ea(z*ja);ja=ea(g[b+(G*12|0)>>2]);z=ea(g[b+(G*12|0)+4>>2]);ha=ea(ea(ea(qa*ea(ja-na))+ea(H*ea(z-oa)))+ea(K*ea(ea(g[b+(G*12|0)+8>>2])-pa)));if(ha>ea(9.99999968e-21)|ha<ea(-9.99999968e-21))ra=G;else sa=33}else sa=33;if((sa|0)==33){ha=ea(g[O>>2]);pa=ea(g[Q>>2]);K=ea(-pa);pa=ea(-ea(g[C>>2]));g[n>>2]=ea(-ha);g[n+4>>2]=K;g[n+8>>2]=pa;ra=O5a(b,d,n,t)|0}if(!((ra|0)==(B|0)|(ra|0)==(p|0)|(ra|0)==(la|0))){pa=ea(g[b+(ra*12|0)>>2]);K=ea(g[b+(ra*12|0)+4>>2]);ha=ea(g[b+(ra*12|0)+8>>2]);oa=ea(g[l>>2]);z=ea(g[o>>2]);H=ea(g[L>>2]);na=ea(pa-oa);pa=ea(K-z);K=ea(ha-H);ha=ea(g[r>>2]);ja=ea(g[q>>2]);qa=ea(ha-oa);ha=ea(ja-z);ja=ea(ea(g[X>>2])-H);ka=ea(g[ga>>2]);ca=ea(g[m>>2]);ia=ea(ka-oa);oa=ea(ca-z);z=ea(ea(g[N>>2])-H);N=ea(ea(K*ea(ea(qa*oa)-ea(ha*ia)))+ea(ea(na*ea(ea(ha*z)-ea(ja*oa)))+ea(pa*ea(ea(ja*ia)-ea(qa*z)))))<ea(0.0);ta=B;ua=p;va=N?ra:la;wa=N?la:ra}else{ta=-1;ua=-1;va=-1;wa=-1}}else{ta=-1;ua=-1;va=-1;wa=-1}}else{ta=-1;ua=-1;va=-1;wa=-1}a:do if((ta|0)==-1){xa=1;ya=V}else{z=ea(g[b+(ta*12|0)>>2]);qa=ea(g[b+(ta*12|0)+4>>2]);ia=ea(g[b+(ta*12|0)+8>>2]);ja=ea(g[b+(ua*12|0)>>2]);pa=ea(g[b+(ua*12|0)+4>>2]);oa=ea(z+ja);ja=ea(qa+pa);pa=ea(ia+ea(g[b+(ua*12|0)+8>>2]));ia=ea(g[b+(va*12|0)>>2]);qa=ea(g[b+(va*12|0)+4>>2]);z=ea(oa+ia);ia=ea(ja+qa);qa=ea(pa+ea(g[b+(va*12|0)+8>>2]));pa=ea(g[b+(wa*12|0)>>2]);ja=ea(g[b+(wa*12|0)+4>>2]);oa=ea(ea(z+pa)*ea(.25));pa=ea(ea(ia+ja)*ea(.25));ja=ea(ea(qa+ea(g[b+(wa*12|0)+8>>2]))*ea(.25));ra=mKa()|0;la=c[(c[ra>>2]|0)+8>>2]|0;N=pKa()|0;p=mo[c[(c[N>>2]|0)+24>>2]&4095](N)|0;N=Bn[la&255](ra,36,p?526696:544544,526432,1610)|0;N5a(N,va,wa,ua,c[a>>2]|0);c[N+12>>2]=2;c[N+16>>2]=3;c[N+20>>2]=1;p=mKa()|0;ra=c[(c[p>>2]|0)+8>>2]|0;la=pKa()|0;B=mo[c[(c[la>>2]|0)+24>>2]&4095](la)|0;la=Bn[ra&255](p,36,B?526696:544544,526432,1611)|0;N5a(la,wa,va,ta,c[a>>2]|0);c[la+12>>2]=3;c[la+16>>2]=2;c[la+20>>2]=0;B=mKa()|0;p=c[(c[B>>2]|0)+8>>2]|0;ra=pKa()|0;m=mo[c[(c[ra>>2]|0)+24>>2]&4095](ra)|0;ra=Bn[p&255](B,36,m?526696:544544,526432,1612)|0;N5a(ra,ta,ua,wa,c[a>>2]|0);c[ra+12>>2]=0;c[ra+16>>2]=1;c[ra+20>>2]=3;m=mKa()|0;B=c[(c[m>>2]|0)+8>>2]|0;p=pKa()|0;ga=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[B&255](m,36,ga?526696:544544,526432,1613)|0;N5a(p,ua,ta,va,c[a>>2]|0);c[p+12>>2]=1;c[p+16>>2]=0;c[p+20>>2]=2;ga=c[s>>2]|0;c[ga+(wa<<2)>>2]=1;c[ga+(va<<2)>>2]=1;c[ga+(ua<<2)>>2]=1;c[ga+(ta<<2)>>2]=1;m=c[a>>2]|0;b:do if((c[m+4>>2]|0)>0){B=u+4|0;X=u+8|0;if(W){za=m;Aa=0}else{q=m;r=0;while(1){L=c[(c[q>>2]|0)+(r<<2)>>2]|0;o=c[L>>2]|0;l=c[L+4>>2]|0;n=c[L+8>>2]|0;qa=ea(g[b+(o*12|0)>>2]);ia=ea(g[b+(o*12|0)+4>>2]);z=ea(g[b+(o*12|0)+8>>2]);ha=ea(g[b+(l*12|0)>>2]);na=ea(g[b+(l*12|0)+4>>2]);K=ea(g[b+(l*12|0)+8>>2]);H=ea(g[b+(n*12|0)>>2]);ca=ea(g[b+(n*12|0)+4>>2]);ka=ea(ha-qa);qa=ea(na-ia);ia=ea(K-z);z=ea(H-ha);ha=ea(ca-na);na=ea(ea(g[b+(n*12|0)+8>>2])-K);K=ea(ea(qa*na)-ea(ia*ha));ca=ea(ea(ia*z)-ea(ka*na));na=ea(ea(ka*ha)-ea(qa*z));z=ea(T(ea(ea(na*na)+ea(ea(K*K)+ea(ca*ca)))));if(z==ea(0.0)){Ba=ea(0.0);Ca=ea(0.0);Da=ea(1.0)}else{qa=ea(ea(1.0)/z);Ba=ea(na*qa);Ca=ea(ca*qa);Da=ea(K*qa)}g[u>>2]=Da;g[B>>2]=Ca;g[X>>2]=Ba;n=O5a(b,d,u,t)|0;c[L+28>>2]=n;l=c[L>>2]|0;qa=ea(g[b+(n*12|0)>>2]);K=ea(g[b+(n*12|0)+4>>2]);ca=ea(g[b+(n*12|0)+8>>2]);na=ea(g[b+(l*12|0)>>2]);z=ea(g[b+(l*12|0)+4>>2]);ha=ea(qa-na);na=ea(K-z);z=ea(ca-ea(g[b+(l*12|0)+8>>2]));ca=ea(g[u>>2]);K=ea(g[B>>2]);g[L+32>>2]=ea(ea(ea(ha*ca)+ea(na*K))+ea(z*ea(g[X>>2])));r=r+1|0;L=c[a>>2]|0;if((r|0)>=(c[L+4>>2]|0)){Ea=L;break b}else q=L}}while(1){q=c[(c[za>>2]|0)+(Aa<<2)>>2]|0;r=c[q>>2]|0;R=q+4|0;U=c[R>>2]|0;S=q+8|0;L=c[S>>2]|0;z=ea(g[b+(r*12|0)>>2]);K=ea(g[b+(r*12|0)+4>>2]);na=ea(g[b+(r*12|0)+8>>2]);ca=ea(g[b+(U*12|0)>>2]);ha=ea(g[b+(U*12|0)+4>>2]);qa=ea(g[b+(U*12|0)+8>>2]);ka=ea(g[b+(L*12|0)>>2]);ia=ea(g[b+(L*12|0)+4>>2]);H=ea(ca-z);z=ea(ha-K);K=ea(qa-na);na=ea(ka-ca);ca=ea(ia-ha);ha=ea(ea(g[b+(L*12|0)+8>>2])-qa);qa=ea(ea(z*ha)-ea(K*ca));ia=ea(ea(K*na)-ea(H*ha));ha=ea(ea(H*ca)-ea(z*na));na=ea(T(ea(ea(ha*ha)+ea(ea(qa*qa)+ea(ia*ia)))));if(na==ea(0.0)){Fa=ea(0.0);Ga=ea(0.0);Ha=ea(1.0)}else{z=ea(ea(1.0)/na);Fa=ea(ha*z);Ga=ea(ia*z);Ha=ea(qa*z)}g[u>>2]=Ha;g[B>>2]=Ga;g[X>>2]=Fa;L=O5a(b,d,u,t)|0;c[q+28>>2]=L;U=c[q>>2]|0;z=ea(g[b+(L*12|0)>>2]);qa=ea(g[b+(L*12|0)+4>>2]);ia=ea(g[b+(L*12|0)+8>>2]);L=b+(U*12|0)|0;ha=ea(g[L>>2]);r=b+(U*12|0)+4|0;na=ea(g[r>>2]);l=b+(U*12|0)+8|0;ca=ea(z-ha);ha=ea(qa-na);na=ea(ia-ea(g[l>>2]));ia=ea(g[u>>2]);qa=ea(g[B>>2]);g[q+32>>2]=ea(ea(ea(ca*ia)+ea(ha*qa))+ea(na*ea(g[X>>2])));q=c[R>>2]|0;na=ea(g[b+(q*12|0)>>2]);qa=ea(g[b+(q*12|0)+4>>2]);ha=ea(g[b+(q*12|0)+8>>2]);ia=ea(g[L>>2]);ca=ea(g[r>>2]);z=ea(na-ia);ia=ea(qa-ca);ca=ea(ha-ea(g[l>>2]));l=c[S>>2]|0;H=ea(g[b+(l*12|0)>>2]);K=ea(g[b+(l*12|0)+4>>2]);ka=ea(H-na);na=ea(K-qa);qa=ea(ea(g[b+(l*12|0)+8>>2])-ha);ha=ea(ea(ia*qa)-ea(ca*na));K=ea(ea(ca*ka)-ea(z*qa));qa=ea(ea(z*na)-ea(ia*ka));if(ea(T(ea(ea(qa*qa)+ea(ea(ha*ha)+ea(K*K)))))<_)break;Aa=Aa+1|0;l=c[a>>2]|0;if((Aa|0)>=(c[l+4>>2]|0)){Ea=l;break b}else za=l}c[(c[c[a>>2]>>2]|0)+(c[N+24>>2]<<2)>>2]=0;if(N)VJa(j,N);c[(c[c[a>>2]>>2]|0)+(c[la+24>>2]<<2)>>2]=0;if(la)VJa(j,la);c[(c[c[a>>2]>>2]|0)+(c[ra+24>>2]<<2)>>2]=0;if(ra)VJa(j,ra);c[(c[c[a>>2]>>2]|0)+(c[p+24>>2]<<2)>>2]=0;if(!p){xa=3;ya=ga;break a}VJa(j,p);xa=3;ya=ga;break a}else Ea=m;while(0);m=x?999999996:e+-4|0;c:do if((m|0)>0){p=v+4|0;ra=v+8|0;K=ea(J*ea(.00999999977));la=m;N=Ea;while(1){X=N+4|0;B=c[X>>2]|0;if((B|0)<=0){Ia=la;break c}l=0;S=0;r=0;while(1){Ja=c[N>>2]|0;L=c[Ja+(S<<2)>>2]|0;if(l)if((L|0)!=0?(ha=ea(g[r+32>>2]),ha<ea(g[L+32>>2])):0)sa=61;else Ka=r;else sa=61;if((sa|0)==61){sa=0;Ka=L}S=S+1|0;l=(Ka|0)!=0;if((S|0)==(B|0))break;else r=Ka}if(!l){Ia=la;break c}r=ea(g[Ka+32>>2])>J;B=r?Ka:0;if(!B){Ia=la;break c}r=c[B+28>>2]|0;c[ga+(r<<2)>>2]=1;B=c[X>>2]|0;d:do if(B){S=b+(r*12|0)|0;L=b+(r*12|0)+4|0;q=b+(r*12|0)+8|0;R=B;U=Ja;n=N;while(1){o=R+-1|0;C=c[U+(o<<2)>>2]|0;if(C){Q=c[C>>2]|0;O=c[C+4>>2]|0;G=c[C+8>>2]|0;ha=ea(g[b+(Q*12|0)>>2]);qa=ea(g[b+(Q*12|0)+4>>2]);ka=ea(g[b+(Q*12|0)+8>>2]);ia=ea(g[b+(O*12|0)>>2]);na=ea(g[b+(O*12|0)+4>>2]);z=ea(g[b+(O*12|0)+8>>2]);ca=ea(g[b+(G*12|0)>>2]);H=ea(g[b+(G*12|0)+4>>2]);da=ea(ia-ha);Y=ea(na-qa);ma=ea(z-ka);I=ea(ca-ia);ia=ea(H-na);na=ea(ea(g[b+(G*12|0)+8>>2])-z);z=ea(ea(Y*na)-ea(ma*ia));H=ea(ea(ma*I)-ea(da*na));na=ea(ea(da*ia)-ea(Y*I));I=ea(T(ea(ea(na*na)+ea(ea(z*z)+ea(H*H)))));if(I==ea(0.0)){La=ea(1.0);Ma=ea(0.0);Na=ea(0.0)}else{Y=ea(ea(1.0)/I);La=ea(z*Y);Ma=ea(H*Y);Na=ea(na*Y)}Y=ea(g[S>>2]);na=ea(g[L>>2]);if(ea(ea(ea(La*ea(Y-ha))+ea(Ma*ea(na-qa)))+ea(Na*ea(ea(g[q>>2])-ka)))>K){kJa(a,C,r);Oa=c[a>>2]|0}else Oa=n}else Oa=n;if(!o)break;R=o;U=c[Oa>>2]|0;n=Oa}n=c[Oa+4>>2]|0;if(!n)Pa=Oa;else{U=n;n=Oa;while(1){R=U+-1|0;q=c[n>>2]|0;L=c[q+(R<<2)>>2]|0;do if(!L){Qa=n;Ra=R}else{S=c[L>>2]|0;do if((S|0)!=(r|0)){o=c[L+4>>2]|0;if((o|0)==(r|0)){Sa=r;break}if((c[L+8>>2]|0)==(r|0))Sa=o;else{Pa=n;break d}}else Sa=c[L+4>>2]|0;while(0);o=c[L+8>>2]|0;ka=ea(g[b+(S*12|0)>>2]);qa=ea(g[b+(S*12|0)+4>>2]);na=ea(g[b+(S*12|0)+8>>2]);ha=ea(g[b+(Sa*12|0)>>2]);Y=ea(g[b+(Sa*12|0)+4>>2]);H=ea(g[b+(Sa*12|0)+8>>2]);z=ea(g[b+(o*12|0)>>2]);I=ea(g[b+(o*12|0)+4>>2]);ia=ea(ha-ka);da=ea(Y-qa);ma=ea(H-na);ca=ea(z-ha);ha=ea(I-Y);Y=ea(ea(g[b+(o*12|0)+8>>2])-H);H=ea(ea(da*Y)-ea(ma*ha));I=ea(ea(ma*ca)-ea(ia*Y));Y=ea(ea(ia*ha)-ea(da*ca));ca=ea(T(ea(ea(Y*Y)+ea(ea(H*H)+ea(I*I)))));if(ca==ea(0.0)){Ta=ea(1.0);Ua=ea(0.0);Va=ea(0.0)}else{da=ea(ea(1.0)/ca);Ta=ea(H*da);Ua=ea(I*da);Va=ea(Y*da)}if(!(ca<_?1:ea(ea(ea(ja-na)*Va)+ea(ea(ea(pa-qa)*Ua)+ea(ea(oa-ka)*Ta)))>K)){Qa=n;Ra=R;break}kJa(a,c[q+(c[L+12>>2]<<2)>>2]|0,r);o=c[a>>2]|0;Qa=o;Ra=c[o+4>>2]|0}while(0);if(!Ra){Pa=Qa;break}else{U=Ra;n=Qa}}}}else Pa=N;while(0);r=c[Pa+4>>2]|0;e:do if(r){B=r;X=Pa;while(1){l=B+-1|0;n=c[(c[X>>2]|0)+(l<<2)>>2]|0;do if(n){U=n+28|0;if((c[U>>2]|0)>-1)break e;L=c[n>>2]|0;q=c[n+4>>2]|0;R=c[n+8>>2]|0;ka=ea(g[b+(L*12|0)>>2]);qa=ea(g[b+(L*12|0)+4>>2]);na=ea(g[b+(L*12|0)+8>>2]);ca=ea(g[b+(q*12|0)>>2]);da=ea(g[b+(q*12|0)+4>>2]);Y=ea(g[b+(q*12|0)+8>>2]);I=ea(g[b+(R*12|0)>>2]);H=ea(g[b+(R*12|0)+4>>2]);ha=ea(ca-ka);ka=ea(da-qa);qa=ea(Y-na);na=ea(I-ca);ca=ea(H-da);da=ea(ea(g[b+(R*12|0)+8>>2])-Y);Y=ea(ea(ka*da)-ea(qa*ca));H=ea(ea(qa*na)-ea(ha*da));da=ea(ea(ha*ca)-ea(ka*na));na=ea(T(ea(ea(da*da)+ea(ea(Y*Y)+ea(H*H)))));if(na==ea(0.0)){Wa=ea(0.0);Xa=ea(0.0);Ya=ea(1.0)}else{ka=ea(ea(1.0)/na);Wa=ea(da*ka);Xa=ea(H*ka);Ya=ea(Y*ka)}g[v>>2]=Ya;g[p>>2]=Xa;g[ra>>2]=Wa;R=O5a(b,d,v,t)|0;c[U>>2]=R;if(!(c[ga+(R<<2)>>2]|0)){q=c[n>>2]|0;ka=ea(g[b+(R*12|0)>>2]);Y=ea(g[b+(R*12|0)+4>>2]);H=ea(g[b+(R*12|0)+8>>2]);da=ea(g[b+(q*12|0)>>2]);na=ea(g[b+(q*12|0)+4>>2]);ca=ea(ka-da);da=ea(Y-na);na=ea(H-ea(g[b+(q*12|0)+8>>2]));H=ea(g[v>>2]);Y=ea(g[p>>2]);g[n+32>>2]=ea(ea(ea(ca*H)+ea(da*Y))+ea(na*ea(g[ra>>2])));break}else{c[U>>2]=-1;break}}while(0);if(!l)break e;B=l;X=c[a>>2]|0}}while(0);r=la+-1|0;if((r|0)<=0){Ia=r;break c}la=r;N=c[a>>2]|0}}else Ia=m;while(0);xa=(Ia|0)==0?2:0;ya=ga}while(0);Ia=c[t>>2]|0;if(Ia){VJa(j,Ia);c[t>>2]=0}c[D>>2]=0;c[E>>2]=0;c[t>>2]=0;if(ya){VJa(j,ya);c[s>>2]=0}c[s>>2]=0;w=xa;i=h;return w|0}function mJa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=Im,ob=Im,pb=Im,qb=Im,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;j=i;i=i+32|0;k=j+15|0;l=j+16|0;m=j+13|0;n=j+12|0;o=j+17|0;p=j+18|0;q=j+14|0;r=j+4|0;s=j;t=j+8|0;c[r>>2]=0;u=c[a>>2]|0;v=c[u+4>>2]|0;if((v|0)>0){w=0;x=u;y=v;z=0;A=0;while(1){B=c[x>>2]|0;C=c[B+(A<<2)>>2]|0;if(C){D=c[C>>2]|0;E=c[C+4>>2]|0;F=c[C+8>>2]|0;G=ea(g[b+(D*12|0)>>2]);H=ea(g[b+(D*12|0)+4>>2]);I=ea(g[b+(D*12|0)+8>>2]);J=ea(g[b+(E*12|0)>>2]);K=ea(g[b+(E*12|0)+4>>2]);L=ea(g[b+(E*12|0)+8>>2]);M=ea(g[b+(F*12|0)>>2]);N=ea(g[b+(F*12|0)+4>>2]);O=ea(J-G);P=ea(K-H);Q=ea(L-I);R=ea(M-J);J=ea(N-K);K=ea(ea(g[b+(F*12|0)+8>>2])-L);L=ea(ea(P*K)-ea(Q*J));N=ea(ea(Q*R)-ea(O*K));K=ea(ea(O*J)-ea(P*R));R=ea(T(ea(ea(K*K)+ea(ea(L*L)+ea(N*N)))));if(R==ea(0.0)){S=ea(1.0);U=ea(0.0);V=ea(0.0)}else{P=ea(ea(1.0)/R);S=ea(L*P);U=ea(N*P);V=ea(K*P)}P=ea(-ea(ea(ea(S*G)+ea(U*H))+ea(V*I)));if((y|0)>0){C=-1;W=-1;X=-1;Y=E;Z=E;_=E;$=E;aa=E;ba=0;while(1){ca=c[B+(ba<<2)>>2]|0;if((ca|0)==0|(A|0)==(ba|0)){da=Y;fa=Z;ga=_;ha=$;ia=aa;ja=X;ka=W;la=C}else{ma=c[ca>>2]|0;if((ma|0)!=(D|0)){na=(ma|0)==(E|0)&1;if((ma|0)==(F|0)){oa=E;pa=E;qa=E;ra=E;sa=E;ta=na;ua=12}else{va=E;wa=E;xa=E;ya=E;za=E;Aa=na;Ba=0}}else{oa=aa;pa=$;qa=_;ra=Z;sa=Y;ta=1;ua=12}if((ua|0)==12){ua=0;va=oa;wa=pa;xa=qa;ya=ra;za=sa;Aa=ta;Ba=1}if((ma|0)!=(F|0))if((ma|0)==(za|0)){Ca=ma;Da=ma;Ea=ma;Fa=ma;Ga=ma;ua=15}else{Ha=za;Ia=za;Ja=za;Ka=za;La=za;Ma=0}else{Ca=za;Da=ya;Ea=xa;Fa=wa;Ga=va;ua=15}if((ua|0)==15){ua=0;Ha=Da;Ia=Ca;Ja=Ea;Ka=Fa;La=Ga;Ma=1}ma=c[ca+4>>2]|0;if((ma|0)!=(D|0)){na=Aa+((ma|0)==(Ha|0)&1)|0;if((ma|0)==(F|0)){Na=Ha;Oa=Ha;Pa=Ha;Qa=na;ua=95}else{Ra=Ha;Sa=Ha;Ta=Ha;Ua=na;Va=Ba}}else{Na=La;Oa=Ka;Pa=Ja;Qa=Aa+1|0;ua=95}if((ua|0)==95){ua=0;Ra=Pa;Sa=Na;Ta=Oa;Ua=Qa;Va=Ba+1|0}if((ma|0)!=(F|0))if((ma|0)==(Ra|0)){Wa=ma;Xa=ma;Ya=ma;ua=98}else{Za=Ra;_a=Ra;$a=Ra;ab=Ma}else{Wa=Ra;Xa=Ta;Ya=Sa;ua=98}if((ua|0)==98){ua=0;Za=Xa;_a=Wa;$a=Ya;ab=Ma+1|0}ma=c[ca+8>>2]|0;if((ma|0)!=(D|0)){ca=Ua+((ma|0)==(Za|0)&1)|0;if((ma|0)==(F|0)){bb=Za;cb=ca;ua=102}else{db=Za;eb=ca;fb=Va}}else{bb=$a;cb=Ua+1|0;ua=102}if((ua|0)==102){ua=0;db=bb;eb=cb;fb=Va+1|0}if((ma|0)!=(F|0))if((ma|0)==(db|0)){gb=ma;ua=105}else{hb=db;ib=ab}else{gb=db;ua=105}if((ua|0)==105){ua=0;hb=gb;ib=ab+1|0}da=Ia;fa=Ha;ga=_a;ha=Za;ia=hb;ja=(ib|0)==2?ba:X;ka=(fb|0)==2?ba:W;la=(eb|0)==2?ba:C}ba=ba+1|0;if((ba|0)>=(y|0)){jb=la;kb=ka;lb=ja;mb=A;nb=S;ob=U;pb=V;qb=P;break}else{C=la;W=ka;X=ja;Y=da;Z=fa;_=ga;$=ha;aa=ia}}}else{jb=-1;kb=-1;lb=-1;mb=A;nb=S;ob=U;pb=V;qb=P}}else{jb=-1;kb=-1;lb=-1;mb=-1;nb=ea(0.0);ob=ea(0.0);pb=ea(0.0);qb=ea(0.0)}do if((A|0)==(w|0)){aa=(A|0)==0?16:A<<1;$=UJa(k,aa*52|0,526608,153)|0;c[r>>2]=$;if((A|0)>0){_=$+0|0;Z=z+0|0;Y=_+52|0;do{c[_>>2]=c[Z>>2];_=_+4|0;Z=Z+4|0}while((_|0)<(Y|0));if((A|0)>1){X=1;do{_=$+(X*52|0)+0|0;Z=z+(X*52|0)+0|0;Y=_+52|0;do{c[_>>2]=c[Z>>2];_=_+4|0;Z=Z+4|0}while((_|0)<(Y|0));X=X+1|0}while((X|0)!=(A|0));rb=z}else ua=23}else ua=23;if((ua|0)==23){ua=0;if(!z){sb=aa;tb=$;break}rb=z}VJa(l,rb);sb=aa;tb=$}else{sb=w;tb=z}while(0);X=A+1|0;g[tb+(A*52|0)>>2]=nb;g[tb+(A*52|0)+4>>2]=ob;g[tb+(A*52|0)+8>>2]=pb;g[tb+(A*52|0)+12>>2]=qb;c[tb+(A*52|0)+16>>2]=jb;c[tb+(A*52|0)+20>>2]=kb;c[tb+(A*52|0)+24>>2]=lb;c[tb+(A*52|0)+28>>2]=-1;g[tb+(A*52|0)+32>>2]=ea(-3402823469999999843913219.0e14);c[tb+(A*52|0)+36>>2]=-1;c[tb+(A*52|0)+40>>2]=-1;c[tb+(A*52|0)+44>>2]=-1;c[tb+(A*52|0)+48>>2]=mb;Z=c[a>>2]|0;_=c[Z+4>>2]|0;if((X|0)<(_|0)){w=sb;x=Z;y=_;z=tb;A=X}else{ub=X;vb=tb;wb=Z;xb=_;break}}}else{ub=0;vb=0;wb=u;xb=v}if((d|0)>0){v=wb+4|0;wb=xb;xb=0;while(1){if((wb|0)>0){u=b+(xb*12|0)|0;tb=b+(xb*12|0)+4|0;A=b+(xb*12|0)+8|0;z=wb;y=0;while(1){if(((c[vb+(y*52|0)+48>>2]|0)!=-1?(qb=ea(g[u>>2]),pb=ea(qb*ea(g[vb+(y*52|0)>>2])),qb=ea(g[tb>>2]),ob=ea(pb+ea(qb*ea(g[vb+(y*52|0)+4>>2]))),qb=ea(g[A>>2]),pb=ea(ob+ea(qb*ea(g[vb+(y*52|0)+8>>2]))),qb=ea(ea(g[vb+(y*52|0)+12>>2])+pb),qb>ea(0.0)):0)?(x=vb+(y*52|0)+32|0,qb>ea(g[x>>2])):0){g[x>>2]=qb;c[vb+(y*52|0)+28>>2]=xb;yb=c[v>>2]|0}else yb=z;y=y+1|0;if((y|0)>=(yb|0)){zb=yb;break}else z=yb}}else zb=wb;xb=xb+1|0;if((xb|0)==(d|0))break;else wb=zb}}zb=(ub|0)>0;if(zb){wb=c[r>>2]|0;d=0;do{if((c[wb+(d*52|0)+48>>2]|0)!=-1?(c[wb+(d*52|0)+28>>2]|0)>-1:0){qb=ea(ea(g[wb+(d*52|0)+32>>2])+h);xb=wb+(d*52|0)+12|0;g[xb>>2]=ea(ea(g[xb>>2])-qb)}d=d+1|0}while((d|0)!=(ub|0));c[s>>2]=0;c[t>>2]=0;if(zb){zb=c[r>>2]|0;d=0;wb=0;xb=0;yb=0;v=0;vb=0;b=0;while(1){z=c[zb+(vb*52|0)+48>>2]|0;a:do if((z|0)==-1){Ab=d;Bb=v;Cb=yb;Db=xb;Eb=wb;Fb=b}else{y=c[(c[c[a>>2]>>2]|0)+(z<<2)>>2]|0;A=zb+(vb*52|0)|0;tb=zb+(vb*52|0)+4|0;u=zb+(vb*52|0)+8|0;x=zb+(vb*52|0)+12|0;sb=v;w=xb;mb=c[s>>2]|0;lb=d;kb=wb;jb=yb;rb=0;l=b;while(1){ua=(jb|0)>0;k=rb;while(1){Gb=c[zb+(vb*52|0)+(k<<2)+16>>2]|0;k=k+1|0;Hb=c[zb+(vb*52|0)+(((k|0)%3|0)<<2)+16>>2]|0;ia=c[c[a>>2]>>2]|0;ha=c[ia+(Gb<<2)>>2]|0;ga=c[ia+(Hb<<2)>>2]|0;ia=c[ha>>2]|0;fa=-1;da=-1;ja=-1;ka=0;while(1){la=c[y+(ka<<2)>>2]|0;if((la|0)==(ia|0)){eb=(ia|0)==(c[ga>>2]|0);fb=(ia|0)==(c[ga+4>>2]|0);ib=(ia|0)==(c[ga+8>>2]|0);Ib=ib?0:fb?0:eb?0:fa;Jb=ib?2:fb?1:eb?0:da;Kb=ib?ka:fb?ka:eb?ka:ja}else{Ib=fa;Jb=da;Kb=ja}if((la|0)==(c[ha+4>>2]|0)){eb=(la|0)==(c[ga>>2]|0);fb=(la|0)==(c[ga+4>>2]|0);ib=(la|0)==(c[ga+8>>2]|0);Lb=ib?1:fb?1:eb?1:Ib;Mb=ib?2:fb?1:eb?0:Jb;Nb=ib?ka:fb?ka:eb?ka:Kb}else{Lb=Ib;Mb=Jb;Nb=Kb}if((la|0)==(c[ha+8>>2]|0)){eb=(la|0)==(c[ga>>2]|0);fb=(la|0)==(c[ga+4>>2]|0);ib=(la|0)==(c[ga+8>>2]|0);Ob=ib?2:fb?2:eb?2:Lb;Pb=ib?2:fb?1:eb?0:Mb;Qb=ib?ka:fb?ka:eb?ka:Nb}else{Ob=Lb;Pb=Mb;Qb=Nb}ka=ka+1|0;if((ka|0)==3)break;else{fa=Ob;da=Pb;ja=Qb}}b:do if(ua){ja=c[y+(Qb<<2)>>2]|0;da=0;while(1){if((c[mb+(da<<2)>>2]|0)==(ja|0)){Rb=da;break b}da=da+1|0;if((da|0)>=(jb|0)){Rb=-1;break}}}else Rb=-1;while(0);h=ea(g[A>>2]);qb=ea(g[tb>>2]);pb=ea(g[u>>2]);ob=ea(g[zb+(Gb*52|0)>>2]);nb=ea(g[zb+(Gb*52|0)+4>>2]);V=ea(g[zb+(Gb*52|0)+8>>2]);U=ea(g[zb+(Hb*52|0)>>2]);S=ea(g[zb+(Hb*52|0)+4>>2]);P=ea(g[zb+(Hb*52|0)+8>>2]);I=ea(h*nb);H=ea(qb*V);G=ea(pb*ob);K=ea(h*V);N=ea(qb*ob);L=ea(pb*nb);R=ea(ea(ea(ea(ea(G*S)+ea(ea(H*U)+ea(I*P)))-ea(K*S))-ea(N*P))-ea(L*U));J=ea(ea(ea(nb*P)-ea(V*S))/R);O=ea(ea(ea(pb*S)-ea(qb*P))/R);Q=ea(ea(H-L)/R);L=ea(ea(ea(V*U)-ea(ob*P))/R);H=ea(ea(ea(h*P)-ea(pb*U))/R);M=ea(ea(G-K)/R);K=ea(ea(ea(ob*S)-ea(nb*U))/R);G=ea(ea(ea(qb*U)-ea(h*S))/R);Sb=ea(ea(I-N)/R);R=ea(g[x>>2]);N=ea(g[zb+(Gb*52|0)+12>>2]);I=ea(g[zb+(Hb*52|0)+12>>2]);Tb=ea(-R);Ub=ea(-N);Vb=ea(-I);Wb=ea(ea(ea(J*Tb)+ea(O*Ub))+ea(Q*Vb));Xb=ea(ea(ea(L*Tb)+ea(H*Ub))+ea(M*Vb));Yb=ea(ea(ea(K*Tb)+ea(G*Ub))+ea(Sb*Vb));if((Rb|0)==-1)break;da=lb+(Rb*12|0)|0;Vb=ea(g[da>>2]);Sb=ea(h*Vb);ja=lb+(Rb*12|0)+4|0;h=ea(g[ja>>2]);Ub=ea(Sb+ea(qb*h));fa=lb+(Rb*12|0)+8|0;qb=ea(g[fa>>2]);if(!((!(ea(R+ea(Ub+ea(pb*qb)))<ea(-.0199999996))?!(ea(N+ea(ea(ea(ob*Vb)+ea(nb*h))+ea(V*qb)))<ea(-.0199999996)):0)?!(ea(I+ea(ea(ea(U*Vb)+ea(S*h))+ea(P*qb)))<ea(-.0199999996)):0)){g[da>>2]=Wb;g[ja>>2]=Xb;g[fa>>2]=Yb}c[zb+(vb*52|0)+(Qb<<2)+36>>2]=Rb;c[zb+(Gb*52|0)+(Ob<<2)+36>>2]=Rb;c[zb+(Hb*52|0)+(Pb<<2)+36>>2]=Rb;if((k|0)>=3){Ab=lb;Bb=sb;Cb=jb;Db=w;Eb=kb;Fb=l;break a}}c[zb+(vb*52|0)+(Qb<<2)+36>>2]=l;c[zb+(Gb*52|0)+(Ob<<2)+36>>2]=l;c[zb+(Hb*52|0)+(Pb<<2)+36>>2]=l;do if((kb|0)==(w|0)){fa=(kb|0)==0?16:kb<<1;ja=UJa(m,fa*12|0,526608,153)|0;c[t>>2]=ja;if((kb|0)>0?(c[ja+0>>2]=c[lb+0>>2],c[ja+4>>2]=c[lb+4>>2],c[ja+8>>2]=c[lb+8>>2],(kb|0)>1):0){da=1;do{ka=ja+(da*12|0)|0;ga=lb+(da*12|0)|0;c[ka+0>>2]=c[ga+0>>2];c[ka+4>>2]=c[ga+4>>2];c[ka+8>>2]=c[ga+8>>2];da=da+1|0}while((da|0)!=(kb|0));Zb=lb}else{if(!lb){_b=ja;$b=fa;break}Zb=lb}VJa(n,Zb);_b=ja;$b=fa}else{_b=lb;$b=w}while(0);da=kb+1|0;g[_b+(kb*12|0)>>2]=Wb;g[_b+(kb*12|0)+4>>2]=Xb;g[_b+(kb*12|0)+8>>2]=Yb;ga=c[y+(Qb<<2)>>2]|0;do if((jb|0)==(sb|0)){ka=(jb|0)==0?16:jb<<1;ha=c[s>>2]|0;ia=UJa(o,ka<<2,526608,153)|0;c[s>>2]=ia;if(!ua){if(!ha){ac=ia;bc=ka;break}}else{eb=0;do{c[ia+(eb<<2)>>2]=c[ha+(eb<<2)>>2];eb=eb+1|0}while((eb|0)!=(jb|0))}VJa(p,ha);ac=ia;bc=ka}else{ac=c[s>>2]|0;bc=sb}while(0);ua=jb+1|0;c[ac+(jb<<2)>>2]=ga;eb=l+1|0;if((k|0)<3){sb=bc;w=$b;mb=ac;lb=_b;kb=da;jb=ua;rb=k;l=eb}else{Ab=_b;Bb=bc;Cb=ua;Db=$b;Eb=da;Fb=eb;break}}}while(0);vb=vb+1|0;if((vb|0)==(ub|0)){cc=Ab;dc=Fb;break}else{d=Ab;wb=Eb;xb=Db;yb=Cb;v=Bb;b=Fb}}}else{cc=0;dc=0}}else{c[s>>2]=0;c[t>>2]=0;cc=0;dc=0}c[f>>2]=dc;c[e>>2]=cc;c[t>>2]=0;cc=c[a>>2]|0;e=cc+4|0;if((c[e>>2]|0)>0){dc=cc;f=0;while(1){Fb=c[dc>>2]|0;b=c[Fb+(f<<2)>>2]|0;if(!b)ec=dc;else{c[Fb+(c[b+24>>2]<<2)>>2]=0;VJa(q,b);ec=c[a>>2]|0}f=f+1|0;b=ec+4|0;if((f|0)>=(c[b>>2]|0)){fc=ec;gc=b;break}else dc=ec}}else{fc=cc;gc=e}e=c[fc>>2]|0;if(e){VJa(q,e);c[fc>>2]=0}c[fc+8>>2]=0;c[gc>>2]=0;gc=c[t>>2]|0;if(gc){VJa(q,gc);c[t>>2]=0}c[t>>2]=0;t=c[s>>2]|0;if(t){VJa(q,t);c[s>>2]=0}c[s>>2]=0;s=c[r>>2]|0;if(!s){i=j;return 0}VJa(q,s);c[r>>2]=0;i=j;return 0}function nJa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;l=i;i=i+16|0;m=l+11|0;n=l+10|0;o=l+9|0;p=l+8|0;q=l+4|0;r=l;s=lJa(a,b,d,j,k)|0;if((s&-3|0)==1){t=s;i=l;return t|0}if((s|0)!=2){c[r>>2]=0;s=c[a>>2]|0;if((c[s+4>>2]|0)>0){j=s;s=0;u=0;v=0;w=0;while(1){x=c[(c[j>>2]|0)+(w<<2)>>2]|0;if(x){y=c[x>>2]|0;do if((s|0)==(u|0)){x=(s|0)==0?16:s<<1;z=UJa(m,x<<2,526608,153)|0;c[r>>2]=z;if((s|0)<=0){if(!v){A=z;B=x;break}}else{C=0;do{c[z+(C<<2)>>2]=c[v+(C<<2)>>2];C=C+1|0}while((C|0)!=(s|0))}VJa(p,v);A=z;B=x}else{A=v;B=u}while(0);C=s+1|0;c[A+(s<<2)>>2]=y;D=c[(c[(c[c[a>>2]>>2]|0)+(w<<2)>>2]|0)+4>>2]|0;do if((C|0)==(B|0)){E=(B|0)==0?16:B<<1;F=c[r>>2]|0;G=UJa(m,E<<2,526608,153)|0;c[r>>2]=G;if((B|0)<=0){if(!F){H=G;I=E;break}}else{J=0;do{c[G+(J<<2)>>2]=c[F+(J<<2)>>2];J=J+1|0}while((J|0)!=(B|0))}VJa(p,F);H=G;I=E}else{H=A;I=B}while(0);y=s+2|0;c[H+(C<<2)>>2]=D;J=c[(c[(c[c[a>>2]>>2]|0)+(w<<2)>>2]|0)+8>>2]|0;do if((y|0)==(I|0)){x=(I|0)==0?16:I<<1;z=UJa(m,x<<2,526608,153)|0;c[r>>2]=z;if((I|0)<=0){if(!H){K=z;L=x;break}}else{M=0;do{c[z+(M<<2)>>2]=c[H+(M<<2)>>2];M=M+1|0}while((M|0)!=(I|0))}VJa(p,H);K=z;L=x}else{K=H;L=I}while(0);c[K+(y<<2)>>2]=J;D=c[c[a>>2]>>2]|0;C=c[D+(w<<2)>>2]|0;M=s+3|0;c[D+(c[C+24>>2]<<2)>>2]=0;if(!C){N=K;O=L;P=M}else{VJa(n,C);N=K;O=L;P=M}}else{N=v;O=u;P=s}w=w+1|0;j=c[a>>2]|0;if((w|0)>=(c[j+4>>2]|0)){Q=P;R=N;break}else{s=P;u=O;v=N}}}else{Q=0;R=0}c[f>>2]=(Q|0)/3|0;c[e>>2]=R;c[r>>2]=0;R=c[a>>2]|0;Q=c[R>>2]|0;if(Q){VJa(n,Q);c[R>>2]=0}c[R+8>>2]=0;c[R+4>>2]=0;c[r>>2]=0;t=0;i=l;return t|0}mJa(a,b,d,g,h,ea(0.0))|0;d=lJa(a,c[g>>2]|0,c[h>>2]|0,256,k)|0;if((d&-3|0)==1){t=d;i=l;return t|0}c[q>>2]=0;d=c[a>>2]|0;if((c[d+4>>2]|0)>0){h=d;d=0;g=0;b=0;r=0;while(1){R=c[(c[h>>2]|0)+(r<<2)>>2]|0;if(R){Q=c[R>>2]|0;do if((d|0)==(g|0)){R=(d|0)==0?16:d<<1;N=UJa(n,R<<2,526608,153)|0;c[q>>2]=N;if((d|0)<=0){if(!b){S=N;T=R;break}}else{v=0;do{c[N+(v<<2)>>2]=c[b+(v<<2)>>2];v=v+1|0}while((v|0)!=(d|0))}VJa(o,b);S=N;T=R}else{S=b;T=g}while(0);J=d+1|0;c[S+(d<<2)>>2]=Q;y=c[(c[(c[c[a>>2]>>2]|0)+(r<<2)>>2]|0)+4>>2]|0;do if((J|0)==(T|0)){v=(T|0)==0?16:T<<1;x=c[q>>2]|0;z=UJa(n,v<<2,526608,153)|0;c[q>>2]=z;if((T|0)<=0){if(!x){U=z;V=v;break}}else{O=0;do{c[z+(O<<2)>>2]=c[x+(O<<2)>>2];O=O+1|0}while((O|0)!=(T|0))}VJa(o,x);U=z;V=v}else{U=S;V=T}while(0);Q=d+2|0;c[U+(J<<2)>>2]=y;O=c[(c[(c[c[a>>2]>>2]|0)+(r<<2)>>2]|0)+8>>2]|0;do if((Q|0)==(V|0)){R=(V|0)==0?16:V<<1;N=UJa(n,R<<2,526608,153)|0;c[q>>2]=N;if((V|0)<=0){if(!U){W=N;X=R;break}}else{u=0;do{c[N+(u<<2)>>2]=c[U+(u<<2)>>2];u=u+1|0}while((u|0)!=(V|0))}VJa(o,U);W=N;X=R}else{W=U;X=V}while(0);c[W+(Q<<2)>>2]=O;y=c[c[a>>2]>>2]|0;J=c[y+(r<<2)>>2]|0;u=d+3|0;c[y+(c[J+24>>2]<<2)>>2]=0;if(!J){Y=W;Z=X;_=u}else{VJa(m,J);Y=W;Z=X;_=u}}else{Y=b;Z=g;_=d}r=r+1|0;h=c[a>>2]|0;if((r|0)>=(c[h+4>>2]|0)){$=_;aa=Y;break}else{d=_;g=Z;b=Y}}}else{$=0;aa=0}c[f>>2]=($|0)/3|0;c[e>>2]=aa;c[q>>2]=0;aa=c[a>>2]|0;a=c[aa>>2]|0;if(a){VJa(m,a);c[aa>>2]=0}c[aa+8>>2]=0;c[aa+4>>2]=0;c[q>>2]=0;t=2;i=l;return t|0}function oJa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=0,Xa=0,Ya=0,Za=Im,_a=Im,$a=Im,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;e=i;i=i+32|0;j=e+22|0;k=e+24|0;l=e+23|0;m=e+21|0;n=e+26|0;o=e+20|0;p=e;q=e+25|0;r=e+16|0;c[r>>2]=0;s=f+4|0;c[s>>2]=0;t=c[a>>2]|0;a:do if((c[t+4>>2]|0)>0){u=+ea(h*ea(.0174532924));v=(d|0)>1;w=0;x=t;y=0;z=0;A=0;while(1){B=c[(c[x>>2]|0)+(A<<2)>>2]|0;if(!B){C=w;D=x;E=z;F=y}else{G=c[B>>2]|0;H=c[B+4>>2]|0;I=c[B+8>>2]|0;J=ea(g[b+(G*12|0)>>2]);K=ea(g[b+(G*12|0)+4>>2]);L=ea(g[b+(G*12|0)+8>>2]);M=ea(g[b+(H*12|0)>>2]);N=ea(g[b+(H*12|0)+4>>2]);O=ea(g[b+(H*12|0)+8>>2]);P=ea(g[b+(I*12|0)>>2]);Q=ea(g[b+(I*12|0)+4>>2]);R=ea(M-J);J=ea(N-K);K=ea(O-L);L=ea(P-M);M=ea(Q-N);N=ea(ea(g[b+(I*12|0)+8>>2])-O);O=ea(ea(J*N)-ea(K*M));Q=ea(ea(K*L)-ea(R*N));N=ea(ea(R*M)-ea(J*L));L=ea(T(ea(ea(N*N)+ea(ea(O*O)+ea(Q*Q)))));if(L==ea(0.0)){S=ea(0.0);U=ea(0.0);W=ea(1.0)}else{J=ea(ea(1.0)/L);S=ea(Q*J);U=ea(N*J);W=ea(O*J)}I=B+12|0;H=B+24|0;G=w;X=z;Y=y;Z=0;while(1){_=c[I+(Z<<2)>>2]|0;if((_|0)>=(c[H>>2]|0)){$=c[(c[c[a>>2]>>2]|0)+(_<<2)>>2]|0;_=c[$>>2]|0;aa=c[$+4>>2]|0;ba=c[$+8>>2]|0;J=ea(g[b+(_*12|0)>>2]);O=ea(g[b+(_*12|0)+4>>2]);N=ea(g[b+(_*12|0)+8>>2]);Q=ea(g[b+(aa*12|0)>>2]);L=ea(g[b+(aa*12|0)+4>>2]);M=ea(g[b+(aa*12|0)+8>>2]);R=ea(g[b+(ba*12|0)>>2]);K=ea(g[b+(ba*12|0)+4>>2]);P=ea(Q-J);J=ea(L-O);O=ea(M-N);N=ea(R-Q);Q=ea(K-L);L=ea(ea(g[b+(ba*12|0)+8>>2])-M);M=ea(ea(J*L)-ea(O*Q));K=ea(ea(O*N)-ea(P*L));L=ea(ea(P*Q)-ea(J*N));N=ea(T(ea(ea(L*L)+ea(ea(M*M)+ea(K*K)))));if(N==ea(0.0)){ca=ea(0.0);da=ea(0.0);fa=ea(1.0)}else{J=ea(ea(1.0)/N);ca=ea(K*J);da=ea(L*J);fa=ea(M*J)}if(!(+ea(ea(U*da)+ea(ea(S*ca)+ea(W*fa)))>=+V(+u))){ba=c[B+(((Z+2|0)%3|0)<<2)>>2]|0;aa=Z+1|0;_=c[B+(((aa|0)==3?0:aa)<<2)>>2]|0;J=ea(g[b+(ba*12|0)>>2]);M=ea(g[b+(ba*12|0)+4>>2]);L=ea(g[b+(ba*12|0)+8>>2]);K=ea(g[b+(_*12|0)>>2]);N=ea(g[b+(_*12|0)+4>>2]);Q=ea(J-K);K=ea(M-N);N=ea(L-ea(g[b+(_*12|0)+8>>2]));if(Q!=ea(0.0)|K!=ea(0.0)|N!=ea(0.0)){ga=ea(ea(ea(ca*N)-ea(da*K))+ea(ea(U*K)-ea(S*N)));ha=ea(ea(ea(da*Q)-ea(fa*N))+ea(ea(W*N)-ea(U*Q)));ia=ea(ea(ea(fa*K)-ea(ca*Q))+ea(ea(S*Q)-ea(W*K)))}else{ga=ea(W+fa);ha=ea(S+ca);ia=ea(U+da)}if(ga==ea(0.0)&ha==ea(0.0)&ia==ea(0.0)){ja=1;ka=Y;break a}K=ea(T(ea(ea(ia*ia)+ea(ea(ha*ha)+ea(ga*ga)))));if(K==ea(0.0)){Ec(526896)|0;la=ea(.100000001)}else la=K;K=ea(ea(1.0)/la);Q=ea(ga*K);N=ea(ha*K);L=ea(ia*K);if(v){_=1;ba=0;while(1){K=ea(g[b+(_*12|0)>>2]);M=ea(g[b+(_*12|0)+4>>2]);J=ea(ea(ea(Q*K)+ea(N*M))+ea(L*ea(g[b+(_*12|0)+8>>2])));M=ea(g[b+(ba*12|0)>>2]);K=ea(g[b+(ba*12|0)+4>>2]);aa=J>ea(ea(ea(Q*M)+ea(N*K))+ea(L*ea(g[b+(ba*12|0)+8>>2])));$=aa?_:ba;_=_+1|0;if((_|0)==(d|0)){ma=$;break}else ba=$}}else ma=0;K=ea(g[b+(ma*12|0)>>2]);M=ea(g[b+(ma*12|0)+4>>2]);J=ea(-ea(ea(ea(Q*K)+ea(N*M))+ea(L*ea(g[b+(ma*12|0)+8>>2]))));do if((X|0)==(G|0)){ba=(X|0)==0?16:X<<1;_=UJa(j,ba<<4,526608,153)|0;c[r>>2]=_;if((X|0)>0?(c[_+0>>2]=c[Y+0>>2],c[_+4>>2]=c[Y+4>>2],c[_+8>>2]=c[Y+8>>2],c[_+12>>2]=c[Y+12>>2],(X|0)>1):0){$=1;do{aa=_+($<<4)|0;na=Y+($<<4)|0;c[aa+0>>2]=c[na+0>>2];c[aa+4>>2]=c[na+4>>2];c[aa+8>>2]=c[na+8>>2];c[aa+12>>2]=c[na+12>>2];$=$+1|0}while(($|0)!=(X|0));oa=Y}else{if(!Y){pa=ba;qa=_;break}oa=Y}VJa(k,oa);pa=ba;qa=_}else{pa=G;qa=Y}while(0);g[qa+(X<<4)>>2]=Q;g[qa+(X<<4)+4>>2]=N;g[qa+(X<<4)+8>>2]=L;g[qa+(X<<4)+12>>2]=J;ra=pa;sa=qa;ta=X+1|0}else{ra=G;sa=Y;ta=X}}else{ra=G;sa=Y;ta=X}Z=Z+1|0;if((Z|0)>=3)break;else{G=ra;X=ta;Y=sa}}C=ra;D=c[a>>2]|0;E=ta;F=sa}A=A+1|0;ua=c[D+4>>2]|0;if((A|0)>=(ua|0))break;else{w=C;x=D;y=F;z=E}}if((ua|0)>0){z=D;y=ua;x=0;while(1){w=c[z>>2]|0;A=c[w+(x<<2)>>2]|0;v=x;x=x+1|0;b:do if((A|0)!=0&(x|0)<(y|0)){Y=A;X=w;G=x;while(1){do if((Y|0)!=0?(Z=c[X+(G<<2)>>2]|0,(Z|0)!=0):0){B=c[Y>>2]|0;H=c[Y+4>>2]|0;I=c[Y+8>>2]|0;M=ea(g[b+(B*12|0)>>2]);K=ea(g[b+(B*12|0)+4>>2]);P=ea(g[b+(B*12|0)+8>>2]);O=ea(g[b+(H*12|0)>>2]);R=ea(g[b+(H*12|0)+4>>2]);va=ea(g[b+(H*12|0)+8>>2]);wa=ea(g[b+(I*12|0)>>2]);xa=ea(g[b+(I*12|0)+4>>2]);ya=ea(g[b+(I*12|0)+8>>2]);za=ea(O-M);Aa=ea(R-K);Ba=ea(va-P);Ca=ea(wa-O);Da=ea(xa-R);Ea=ea(ya-va);Fa=ea(ea(Aa*Ea)-ea(Ba*Da));Ga=ea(ea(Ba*Ca)-ea(za*Ea));Ea=ea(ea(za*Da)-ea(Aa*Ca));Ca=ea(T(ea(ea(Ea*Ea)+ea(ea(Fa*Fa)+ea(Ga*Ga)))));if(Ca==ea(0.0)){Ha=ea(1.0);Ia=ea(0.0);Ja=ea(0.0)}else{Aa=ea(ea(1.0)/Ca);Ha=ea(Fa*Aa);Ia=ea(Ga*Aa);Ja=ea(Ea*Aa)}I=c[Z>>2]|0;H=c[Z+4>>2]|0;B=c[Z+8>>2]|0;Aa=ea(g[b+(I*12|0)>>2]);Ea=ea(g[b+(I*12|0)+4>>2]);Ga=ea(g[b+(I*12|0)+8>>2]);Fa=ea(g[b+(H*12|0)>>2]);Ca=ea(g[b+(H*12|0)+4>>2]);Da=ea(g[b+(H*12|0)+8>>2]);za=ea(g[b+(B*12|0)>>2]);Ba=ea(g[b+(B*12|0)+4>>2]);Ka=ea(g[b+(B*12|0)+8>>2]);La=ea(Fa-Aa);Ma=ea(Ca-Ea);Na=ea(Da-Ga);Oa=ea(za-Fa);Pa=ea(Ba-Ca);Qa=ea(Ka-Da);Ra=ea(ea(Ma*Qa)-ea(Na*Pa));Sa=ea(ea(Na*Oa)-ea(La*Qa));Qa=ea(ea(La*Pa)-ea(Ma*Oa));Oa=ea(T(ea(ea(Qa*Qa)+ea(ea(Ra*Ra)+ea(Sa*Sa)))));if(Oa==ea(0.0)){Ta=ea(1.0);Ua=ea(0.0);Va=ea(0.0)}else{Ma=ea(ea(1.0)/Oa);Ta=ea(Ra*Ma);Ua=ea(Sa*Ma);Va=ea(Qa*Ma)}if(ea(ea(Ja*Va)+ea(ea(Ia*Ua)+ea(Ha*Ta)))>ea(.99862951)){Ma=ea(M-O);O=ea(K-R);R=ea(P-va);va=ea(wa-M);M=ea(xa-K);K=ea(ya-P);P=ea(ea(O*K)-ea(R*M));ya=ea(ea(R*va)-ea(Ma*K));K=ea(ea(Ma*M)-ea(O*va));va=ea(Aa-Fa);Fa=ea(Ea-Ca);Ca=ea(Ga-Da);Da=ea(za-Aa);Aa=ea(Ba-Ea);Ea=ea(Ka-Ga);Ga=ea(ea(Fa*Ea)-ea(Ca*Aa));Ka=ea(ea(Ca*Da)-ea(va*Ea));Ea=ea(ea(va*Aa)-ea(Fa*Da));if(ea(ea(K*K)+ea(ea(P*P)+ea(ya*ya)))<ea(ea(Ea*Ea)+ea(ea(Ga*Ga)+ea(Ka*Ka)))){c[X+(c[Y+24>>2]<<2)>>2]=0;VJa(l,Y);break}else{c[X+(c[Z+24>>2]<<2)>>2]=0;VJa(l,Z);break}}}while(0);_=G+1|0;ba=c[a>>2]|0;Z=c[ba+4>>2]|0;if((_|0)>=(Z|0)){Wa=Z;Xa=ba;break b}Z=c[ba>>2]|0;Y=c[Z+(v<<2)>>2]|0;X=Z;G=_}}else{Wa=y;Xa=z}while(0);if((x|0)>=(Wa|0))break;else{z=Xa;y=Wa}}if((Wa|0)>0){y=f+8|0;z=Xa;x=0;while(1){v=c[(c[z>>2]|0)+(x<<2)>>2]|0;if(!v)Ya=z;else{w=c[v>>2]|0;A=c[v+4>>2]|0;G=c[v+8>>2]|0;J=ea(g[b+(w*12|0)>>2]);L=ea(g[b+(w*12|0)+4>>2]);N=ea(g[b+(w*12|0)+8>>2]);Q=ea(g[b+(A*12|0)>>2]);Ka=ea(g[b+(A*12|0)+4>>2]);Ga=ea(g[b+(A*12|0)+8>>2]);Ea=ea(g[b+(G*12|0)>>2]);ya=ea(g[b+(G*12|0)+4>>2]);P=ea(Q-J);K=ea(Ka-L);Da=ea(Ga-N);Fa=ea(Ea-Q);Q=ea(ya-Ka);Ka=ea(ea(g[b+(G*12|0)+8>>2])-Ga);Ga=ea(ea(K*Ka)-ea(Da*Q));ya=ea(ea(Da*Fa)-ea(P*Ka));Ka=ea(ea(P*Q)-ea(K*Fa));Fa=ea(T(ea(ea(Ka*Ka)+ea(ea(Ga*Ga)+ea(ya*ya)))));if(Fa==ea(0.0)){Za=ea(1.0);_a=ea(0.0);$a=ea(0.0)}else{K=ea(ea(1.0)/Fa);Za=ea(Ga*K);_a=ea(ya*K);$a=ea(Ka*K)}K=ea(-ea(ea(ea(Za*J)+ea(_a*L))+ea($a*N)));G=c[s>>2]|0;do if((G|0)==(c[y>>2]|0)){A=(G|0)==0?16:G<<1;w=c[f>>2]|0;c[y>>2]=A;v=UJa(l,A<<4,526608,153)|0;c[f>>2]=v;A=c[s>>2]|0;if((A|0)>0){c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];v=c[s>>2]|0;if((v|0)>1){X=1;do{Y=(c[f>>2]|0)+(X<<4)|0;_=w+(X<<4)|0;c[Y+0>>2]=c[_+0>>2];c[Y+4>>2]=c[_+4>>2];c[Y+8>>2]=c[_+8>>2];c[Y+12>>2]=c[_+12>>2];X=X+1|0}while((X|0)<(c[s>>2]|0));ab=w}else{bb=v;cb=57}}else{bb=A;cb=57}if((cb|0)==57){cb=0;if(!w){db=bb;break}ab=w}VJa(m,ab);db=c[s>>2]|0}else db=G;while(0);c[s>>2]=db+1;G=c[f>>2]|0;g[G+(db<<4)>>2]=Za;g[G+(db<<4)+4>>2]=_a;g[G+(db<<4)+8>>2]=$a;g[G+(db<<4)+12>>2]=K;Ya=c[a>>2]|0}x=x+1|0;if((x|0)>=(c[Ya+4>>2]|0)){eb=Ya;break}else z=Ya}}else eb=Xa}else eb=D;if((E|0)>0){z=f+8|0;x=0;do{y=c[s>>2]|0;c:do if((y|0)>0){G=c[f>>2]|0;N=ea(g[F+(x<<4)>>2]);L=ea(g[F+(x<<4)+4>>2]);J=ea(g[F+(x<<4)+8>>2]);X=0;while(1){Ka=ea(g[G+(X<<4)>>2]);ya=ea(g[G+(X<<4)+4>>2]);_=X+1|0;if(ea(ea(ea(N*Ka)+ea(L*ya))+ea(J*ea(g[G+(X<<4)+8>>2])))>ea(.99862951)){fb=X;break c}if((_|0)<(y|0))X=_;else{fb=_;break}}}else fb=0;while(0);if((fb|0)==(y|0)){aFi(p|0,F+(x<<4)|0,16)|0;do if((y|0)==(c[z>>2]|0)){X=(y|0)==0?16:y<<1;G=c[f>>2]|0;c[z>>2]=X;w=UJa(n,X<<4,526608,153)|0;c[f>>2]=w;X=c[s>>2]|0;if((X|0)>0){c[w+0>>2]=c[G+0>>2];c[w+4>>2]=c[G+4>>2];c[w+8>>2]=c[G+8>>2];c[w+12>>2]=c[G+12>>2];w=c[s>>2]|0;if((w|0)>1){A=1;do{v=(c[f>>2]|0)+(A<<4)|0;_=G+(A<<4)|0;c[v+0>>2]=c[_+0>>2];c[v+4>>2]=c[_+4>>2];c[v+8>>2]=c[_+8>>2];c[v+12>>2]=c[_+12>>2];A=A+1|0}while((A|0)<(c[s>>2]|0));gb=G}else{hb=w;cb=74}}else{hb=X;cb=74}if((cb|0)==74){cb=0;if(!G){ib=hb;break}gb=G}VJa(o,gb);ib=c[s>>2]|0}else ib=y;while(0);c[s>>2]=ib+1;y=(c[f>>2]|0)+(ib<<4)|0;c[y+0>>2]=c[p+0>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];c[y+12>>2]=c[p+12>>2]}x=x+1|0}while((x|0)!=(E|0));jb=c[a>>2]|0;cb=65}else{jb=eb;cb=65}}else{jb=t;cb=65}while(0);if((cb|0)==65){cb=jb+4|0;if((c[cb>>2]|0)>0){t=jb;jb=0;while(1){eb=c[t>>2]|0;E=c[eb+(jb<<2)>>2]|0;if(!E)kb=t;else{c[eb+(c[E+24>>2]<<2)>>2]=0;VJa(q,E);kb=c[a>>2]|0}jb=jb+1|0;E=kb+4|0;if((jb|0)>=(c[E>>2]|0)){lb=E;break}else t=kb}}else lb=cb;c[lb>>2]=0;ja=0;ka=c[r>>2]|0}if(!ka){i=e;return ja|0}VJa(q,ka);c[r>>2]=0;i=e;return ja|0}function pJa(f,h,j,k,l,m,n,o,p,q,r,s){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=ea(q);r=r|0;s=ea(s);var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=Im,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=0,Ua=0,Va=Im,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=Im,cb=Im,db=Im,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=Im,cc=Im,dc=Im,ec=Im,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=Im,dd=Im,ed=Im,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0;t=i;i=i+8304|0;u=t+8292|0;v=t;w=t+16|0;x=t+7257|0;y=t+7258|0;z=t+8289|0;A=t+7259|0;B=t+8293|0;C=t+8291|0;D=t+8290|0;E=t+7256|0;F=t+6232|0;G=t+7264|0;H=t+2136|0;I=t+32|0;J=t+4184|0;K=t+2092|0;L=t+2104|0;M=t+2120|0;N=t+8288|0;O=t+2080|0;P=t+2116|0;if(!j){Q=1;i=t;return Q|0}R=O+4|0;c[R>>2]=0;S=O+8|0;c[S>>2]=0;c[O>>2]=0;U=lJa(f,h,j,r,s)|0;do if((U&-3|0)!=1){if((U|0)==2){mJa(f,h,j,l,m,p)|0;r=lJa(f,c[l>>2]|0,c[m>>2]|0,256,s)|0;if((r&-3|0)==1){V=r;break}c[P>>2]=0;r=c[f>>2]|0;if((c[r+4>>2]|0)>0){W=r;r=0;X=0;Y=0;Z=0;while(1){_=c[(c[W>>2]|0)+(Z<<2)>>2]|0;if(_){$=c[_>>2]|0;do if((r|0)==(X|0)){_=(r|0)==0?16:r<<1;aa=UJa(v,_<<2,526608,153)|0;c[P>>2]=aa;if((r|0)<=0){if(!Y){ba=aa;ca=_;break}}else{da=0;do{c[aa+(da<<2)>>2]=c[Y+(da<<2)>>2];da=da+1|0}while((da|0)!=(r|0))}VJa(w,Y);ba=aa;ca=_}else{ba=Y;ca=X}while(0);da=r+1|0;c[ba+(r<<2)>>2]=$;fa=c[(c[(c[c[f>>2]>>2]|0)+(Z<<2)>>2]|0)+4>>2]|0;do if((da|0)==(ca|0)){ga=(ca|0)==0?16:ca<<1;ha=c[P>>2]|0;ia=UJa(v,ga<<2,526608,153)|0;c[P>>2]=ia;if((ca|0)<=0){if(!ha){ja=ia;ka=ga;break}}else{la=0;do{c[ia+(la<<2)>>2]=c[ha+(la<<2)>>2];la=la+1|0}while((la|0)!=(ca|0))}VJa(w,ha);ja=ia;ka=ga}else{ja=ba;ka=ca}while(0);$=r+2|0;c[ja+(da<<2)>>2]=fa;la=c[(c[(c[c[f>>2]>>2]|0)+(Z<<2)>>2]|0)+8>>2]|0;do if(($|0)==(ka|0)){_=(ka|0)==0?16:ka<<1;aa=UJa(v,_<<2,526608,153)|0;c[P>>2]=aa;if((ka|0)<=0){if(!ja){ma=aa;na=_;break}}else{oa=0;do{c[aa+(oa<<2)>>2]=c[ja+(oa<<2)>>2];oa=oa+1|0}while((oa|0)!=(ka|0))}VJa(w,ja);ma=aa;na=_}else{ma=ja;na=ka}while(0);c[ma+($<<2)>>2]=la;fa=c[c[f>>2]>>2]|0;da=c[fa+(Z<<2)>>2]|0;oa=r+3|0;c[fa+(c[da+24>>2]<<2)>>2]=0;if(!da){pa=ma;qa=na;ra=oa}else{VJa(u,da);pa=ma;qa=na;ra=oa}}else{pa=Y;qa=X;ra=r}Z=Z+1|0;W=c[f>>2]|0;if((Z|0)>=(c[W+4>>2]|0)){sa=ra;ta=pa;break}else{r=ra;X=qa;Y=pa}}}else{sa=0;ta=0}c[o>>2]=(sa|0)/3|0;c[n>>2]=ta;c[P>>2]=0;Y=c[f>>2]|0;X=c[Y>>2]|0;if(X){VJa(u,X);c[Y>>2]=0}c[Y+8>>2]=0;c[Y+4>>2]=0;c[P>>2]=0;V=2;break}if((oJa(f,h,j,0,O,q)|0)!=1?(Y=c[O>>2]|0,X=c[R>>2]|0,(j|0)>=4):0){r=(X|0)>(k|0);c[K+0>>2]=c[h+0>>2];c[K+4>>2]=c[h+4>>2];c[K+8>>2]=c[h+8>>2];c[L+0>>2]=c[h+0>>2];c[L+4>>2]=c[h+4>>2];c[L+8>>2]=c[h+8>>2];W=K+4|0;Z=K+8|0;oa=L+4|0;da=L+8|0;ua=ea(g[K>>2]);va=ea(g[W>>2]);wa=ea(g[Z>>2]);xa=ea(g[L>>2]);ya=ea(g[oa>>2]);za=xa;xa=ya;ya=ea(g[da>>2]);Aa=ua;ua=va;va=wa;fa=0;do{wa=ea(g[h+(fa*12|0)>>2]);Ba=ea(g[h+(fa*12|0)+4>>2]);Ca=ea(g[h+(fa*12|0)+8>>2]);Aa=Aa<wa?Aa:wa;ua=ua<Ba?ua:Ba;va=va<Ca?va:Ca;za=za>wa?za:wa;xa=xa>Ba?xa:Ba;ya=ya>Ca?ya:Ca;fa=fa+1|0}while((fa|0)!=(j|0));fa=r?k:X;g[K>>2]=Aa;g[W>>2]=ua;g[Z>>2]=va;g[L>>2]=za;g[oa>>2]=xa;g[da>>2]=ya;Ca=ea(za-Aa);Ba=ea(xa-ua);wa=ea(ya-va);Da=ea(T(ea(ea(ea(Ca*Ca)+ea(Ba*Ba))+ea(wa*wa))));ga=(X|0)>0;if(ga){ia=0;do{ha=Y+(ia<<4)+12|0;g[ha>>2]=ea(ea(g[ha>>2])-p);ia=ia+1|0}while((ia|0)!=(X|0))}g[131604]=ea(Da*ea(.00100000005));ia=M+4|0;r=M+8|0;va=ea(Da*ea(.5));ha=0;do{g[M>>2]=ea(0.0);g[ia>>2]=ea(0.0);g[r>>2]=ea(0.0);Ea=(ha&1|0)!=0;g[M+(((ha|0)/2|0)<<2)>>2]=Ea?ea(1.0):ea(-1.0);a:do if(ga){ya=ea(g[M>>2]);ua=ea(g[ia>>2]);xa=ea(g[r>>2]);Fa=0;while(1){Aa=ea(g[Y+(Fa<<4)>>2]);za=ea(g[Y+(Fa<<4)+4>>2]);if(ea(ea(ea(ya*Aa)+ea(ua*za))+ea(xa*ea(g[Y+(Fa<<4)+8>>2])))>ea(.99862951))break;Fa=Fa+1|0;if((Fa|0)>=(X|0))break a}Fa=Ea?L:K;za=ea(va*ya);Aa=ea(va*ua);wa=ea(va*xa);g[Fa>>2]=ea(za+ea(g[Fa>>2]));_=Fa+4|0;g[_>>2]=ea(Aa+ea(g[_>>2]));_=Fa+8|0;g[_>>2]=ea(wa+ea(g[_>>2]))}while(0);ha=ha+1|0}while((ha|0)!=6);va=ea(g[K>>2]);Da=ea(g[W>>2]);wa=ea(g[Z>>2]);Aa=ea(g[L>>2]);za=ea(g[oa>>2]);Ba=ea(g[da>>2]);ha=mKa()|0;r=c[(c[ha>>2]|0)+8>>2]|0;ia=pKa()|0;Ea=mo[c[(c[ia>>2]|0)+24>>2]&4095](ia)|0;ia=Bn[r&255](ha,36,Ea?526792:544544,526432,687)|0;gJa(ia,8,24,6);Ea=c[ia>>2]|0;g[Ea>>2]=ea(0.0);g[Ea+4>>2]=ea(0.0);g[Ea+8>>2]=ea(0.0);Ea=c[ia>>2]|0;g[Ea+12>>2]=ea(0.0);g[Ea+16>>2]=ea(0.0);g[Ea+20>>2]=ea(1.0);Ea=c[ia>>2]|0;g[Ea+24>>2]=ea(0.0);g[Ea+28>>2]=ea(1.0);g[Ea+32>>2]=ea(0.0);Ea=c[ia>>2]|0;g[Ea+36>>2]=ea(0.0);g[Ea+40>>2]=ea(1.0);g[Ea+44>>2]=ea(1.0);Ea=c[ia>>2]|0;g[Ea+48>>2]=ea(1.0);g[Ea+52>>2]=ea(0.0);g[Ea+56>>2]=ea(0.0);Ea=c[ia>>2]|0;g[Ea+60>>2]=ea(1.0);g[Ea+64>>2]=ea(0.0);g[Ea+68>>2]=ea(1.0);Ea=c[ia>>2]|0;g[Ea+72>>2]=ea(1.0);g[Ea+76>>2]=ea(1.0);g[Ea+80>>2]=ea(0.0);Ea=c[ia>>2]|0;g[Ea+84>>2]=ea(1.0);g[Ea+88>>2]=ea(1.0);g[Ea+92>>2]=ea(1.0);Ea=ia+24|0;ha=c[Ea>>2]|0;g[ha>>2]=ea(-1.0);g[ha+4>>2]=ea(0.0);g[ha+8>>2]=ea(0.0);g[ha+12>>2]=ea(0.0);ha=c[Ea>>2]|0;g[ha+16>>2]=ea(1.0);g[ha+20>>2]=ea(0.0);g[ha+24>>2]=ea(0.0);g[ha+28>>2]=ea(-1.0);ha=c[Ea>>2]|0;g[ha+32>>2]=ea(0.0);g[ha+36>>2]=ea(-1.0);g[ha+40>>2]=ea(0.0);g[ha+44>>2]=ea(0.0);ha=c[Ea>>2]|0;g[ha+48>>2]=ea(0.0);g[ha+52>>2]=ea(1.0);g[ha+56>>2]=ea(0.0);g[ha+60>>2]=ea(-1.0);ha=c[Ea>>2]|0;g[ha+64>>2]=ea(0.0);g[ha+68>>2]=ea(0.0);g[ha+72>>2]=ea(-1.0);g[ha+76>>2]=ea(0.0);ha=c[Ea>>2]|0;g[ha+80>>2]=ea(0.0);g[ha+84>>2]=ea(0.0);g[ha+88>>2]=ea(1.0);g[ha+92>>2]=ea(-1.0);ha=ia+12|0;r=c[ha>>2]|0;b[r>>1]=11;b[r+2>>1]=11>>>16;r=(c[ha>>2]|0)+4|0;b[r>>1]=23;b[r+2>>1]=65559>>>16;r=(c[ha>>2]|0)+8|0;b[r>>1]=15;b[r+2>>1]=196623>>>16;r=(c[ha>>2]|0)+12|0;b[r>>1]=16;b[r+2>>1]=131088>>>16;r=(c[ha>>2]|0)+16|0;b[r>>1]=13;b[r+2>>1]=17170445>>>16;r=(c[ha>>2]|0)+20|0;b[r>>1]=21;b[r+2>>1]=17235989>>>16;r=(c[ha>>2]|0)+24|0;b[r>>1]=9;b[r+2>>1]=17104905>>>16;r=(c[ha>>2]|0)+28|0;b[r>>1]=18;b[r+2>>1]=17039378>>>16;r=(c[ha>>2]|0)+32|0;b[r>>1]=19;b[r+2>>1]=33554451>>>16;r=(c[ha>>2]|0)+36|0;b[r>>1]=6;b[r+2>>1]=33816582>>>16;r=(c[ha>>2]|0)+40|0;b[r>>1]=20;b[r+2>>1]=33882132>>>16;r=(c[ha>>2]|0)+44|0;b[r>>1]=0;b[r+2>>1]=33619968>>>16;r=(c[ha>>2]|0)+48|0;b[r>>1]=22;b[r+2>>1]=50528278>>>16;r=(c[ha>>2]|0)+52|0;b[r>>1]=4;b[r+2>>1]=50790404>>>16;r=(c[ha>>2]|0)+56|0;b[r>>1]=17;b[r+2>>1]=50724881>>>16;r=(c[ha>>2]|0)+60|0;b[r>>1]=2;b[r+2>>1]=50462722>>>16;r=(c[ha>>2]|0)+64|0;b[r>>1]=3;b[r+2>>1]=67108867>>>16;r=(c[ha>>2]|0)+68|0;b[r>>1]=14;b[r+2>>1]=67239950>>>16;r=(c[ha>>2]|0)+72|0;b[r>>1]=7;b[r+2>>1]=67502087>>>16;r=(c[ha>>2]|0)+76|0;b[r>>1]=8;b[r+2>>1]=67371016>>>16;r=(c[ha>>2]|0)+80|0;b[r>>1]=10;b[r+2>>1]=83951626>>>16;r=(c[ha>>2]|0)+84|0;b[r>>1]=5;b[r+2>>1]=84213765>>>16;r=(c[ha>>2]|0)+88|0;b[r>>1]=12;b[r+2>>1]=84344844>>>16;r=(c[ha>>2]|0)+92|0;b[r>>1]=1;b[r+2>>1]=84082689>>>16;r=c[ia>>2]|0;g[r>>2]=va;g[r+4>>2]=Da;g[r+8>>2]=wa;r=c[ia>>2]|0;g[r+12>>2]=va;g[r+16>>2]=Da;g[r+20>>2]=Ba;r=c[ia>>2]|0;g[r+24>>2]=va;g[r+28>>2]=za;g[r+32>>2]=wa;r=c[ia>>2]|0;g[r+36>>2]=va;g[r+40>>2]=za;g[r+44>>2]=Ba;r=c[ia>>2]|0;g[r+48>>2]=Aa;g[r+52>>2]=Da;g[r+56>>2]=wa;r=c[ia>>2]|0;g[r+60>>2]=Aa;g[r+64>>2]=Da;g[r+68>>2]=Ba;r=c[ia>>2]|0;g[r+72>>2]=Aa;g[r+76>>2]=za;g[r+80>>2]=wa;r=c[ia>>2]|0;g[r+84>>2]=Aa;g[r+88>>2]=za;g[r+92>>2]=Ba;r=c[Ea>>2]|0;g[r>>2]=ea(-1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=va;r=c[Ea>>2]|0;va=ea(-Aa);g[r+16>>2]=ea(1.0);g[r+20>>2]=ea(0.0);g[r+24>>2]=ea(0.0);g[r+28>>2]=va;r=c[Ea>>2]|0;g[r+32>>2]=ea(0.0);g[r+36>>2]=ea(-1.0);g[r+40>>2]=ea(0.0);g[r+44>>2]=Da;r=c[Ea>>2]|0;Da=ea(-za);g[r+48>>2]=ea(0.0);g[r+52>>2]=ea(1.0);g[r+56>>2]=ea(0.0);g[r+60>>2]=Da;r=c[Ea>>2]|0;g[r+64>>2]=ea(0.0);g[r+68>>2]=ea(0.0);g[r+72>>2]=ea(-1.0);g[r+76>>2]=wa;r=c[Ea>>2]|0;wa=ea(-Ba);g[r+80>>2]=ea(0.0);g[r+84>>2]=ea(0.0);g[r+88>>2]=ea(1.0);g[r+92>>2]=wa;b:do if((fa|0)!=0&ga){r=I+2048|0;Ea=fa;ha=ia;c:while(1){la=ha+4|0;$=c[la>>2]|0;_=($|0)>0;wa=ea(g[131604]);Fa=ha+28|0;aa=ha+24|0;Ga=ha+16|0;Ha=ha+12|0;Ia=0;Ba=ea(0.0);Ja=-1;while(1){if(_){Ka=c[ha>>2]|0;Da=ea(g[Y+(Ia<<4)>>2]);za=ea(g[Y+(Ia<<4)+4>>2]);va=ea(g[Y+(Ia<<4)+8>>2]);Aa=ea(g[Y+(Ia<<4)+12>>2]);Ca=ea(0.0);La=ea(0.0);Ma=0;while(1){Na=ea(g[Ka+(Ma*12|0)>>2]);Oa=ea(g[Ka+(Ma*12|0)+4>>2]);Pa=ea(Aa+ea(ea(ea(Da*Na)+ea(za*Oa))+ea(va*ea(g[Ka+(Ma*12|0)+8>>2]))));Oa=Ca>Pa?Ca:Pa;Na=La<Pa?La:Pa;Ma=Ma+1|0;if((Ma|0)==($|0)){Qa=Oa;Ra=Na;break}else{Ca=Oa;La=Na}}}else{Qa=ea(0.0);Ra=ea(0.0)}La=ea(Qa-Ra);Ca=ea(Qa/(La<wa?ea(1.0):La));if(!(Ca<=Ba)){Ma=c[Fa>>2]|0;if((Ma|0)>0){Ka=c[aa>>2]|0;La=ea(g[Y+(Ia<<4)>>2]);Sa=Y+(Ia<<4)+8|0;Ta=Y+(Ia<<4)+12|0;va=ea(g[Y+(Ia<<4)+4>>2]);za=Ca;Ua=0;while(1){Da=ea(g[Ka+(Ua<<4)>>2]);Aa=ea(g[Ka+(Ua<<4)+4>>2]);Na=ea(g[Sa>>2]);Oa=ea(g[Ka+(Ua<<4)+8>>2]);if(La==Da&va==Aa&Na==Oa?(Pa=ea(g[Ta>>2]),Pa==ea(g[Ka+(Ua<<4)+12>>2])):0)Va=ea(0.0);else Wa=43;d:do if((Wa|0)==43){Wa=0;if(ea(ea(ea(La*Da)+ea(va*Aa))+ea(Na*Oa))>ea(.99862951)){Xa=c[Ga>>2]|0;if((Xa|0)<=0){Va=za;break}Ya=c[Ha>>2]|0;Za=0;while(1){if((d[Ya+(Za<<2)+3>>0]|0)==(Ua|0)?(_a=d[Ya+(Za<<2)+2>>0]|0,$a=c[ha>>2]|0,Pa=ea(g[$a+(_a*12|0)>>2]),ab=ea(g[$a+(_a*12|0)+4>>2]),bb=ea(ea(ea(La*Pa)+ea(va*ab))+ea(Na*ea(g[$a+(_a*12|0)+8>>2]))),ea(ea(g[Ta>>2])+bb)<ea(0.0)):0){Va=ea(0.0);break d}Za=Za+1|0;if((Za|0)>=(Xa|0)){Va=za;break}}}else Va=za}while(0);Ua=Ua+1|0;if((Ua|0)==(Ma|0)){cb=Va;break}else za=Va}}else cb=Ca;if(cb>Ba){db=cb;eb=Ia}else{db=Ba;eb=Ja}}else{db=Ba;eb=Ja}Ia=Ia+1|0;if((Ia|0)==(X|0))break;else{Ba=db;Ja=eb}}Ea=Ea+-1|0;Ja=db>ea(.00999999977);Ia=Ja?eb:-1;if((Ia|0)>-1)fb=I;else{gb=ha;break b}do{c[fb+0>>2]=0;c[fb+4>>2]=0;c[fb+8>>2]=0;c[fb+12>>2]=0;fb=fb+16|0}while((fb|0)!=(r|0));Ja=Y+(Ia<<4)|0;$=c[la>>2]|0;e:do if(($|0)>0){_=c[ha>>2]|0;Ma=Y+(Ia<<4)+4|0;Ua=Y+(Ia<<4)+8|0;Ta=Y+(Ia<<4)+12|0;Ba=ea(g[Ja>>2]);xa=ea(g[Ma>>2]);ua=ea(g[Ua>>2]);ya=ea(g[Ta>>2]);za=ea(-wa);Ka=0;Sa=0;Xa=1;Za=0;while(1){va=ea(g[_+(Ka*12|0)>>2]);La=ea(g[_+(Ka*12|0)+4>>2]);Na=ea(ya+ea(ea(ea(Ba*va)+ea(xa*La))+ea(ua*ea(g[_+(Ka*12|0)+8>>2]))));do if(Na>wa){hb=2;Wa=59}else{Ya=Na<za&1;if(!Ya){hb=0;Wa=59;break}else if((Ya|0)!=1){ib=0;break e}a[G+(Ka<<2)+2>>0]=Za;a[G+(Ka<<2)+3>>0]=-1;jb=1;kb=Za+1<<16>>16}while(0);if((Wa|0)==59){Wa=0;a[G+(Ka<<2)+2>>0]=-1;a[G+(Ka<<2)+3>>0]=-1;jb=hb;kb=Za}a[G+(Ka<<2)>>0]=jb;Sa=jb|Sa;Ka=Xa&65535;if((Ka|0)>=($|0))break;else{Xa=Xa+1<<16>>16;Za=kb}}if(Sa&2){f:do if((c[Fa>>2]|0)>0){Za=0;Xa=0;Ka=0;_=0;Ya=0;_a=0;$a=0;lb=0;mb=kb;while(1){nb=lb&255;ob=Za;pb=Ka;qb=Xa;rb=255;sb=_a;tb=-1;ub=0;vb=$a;wb=mb;xb=-1;yb=-1;while(1){zb=sb+1|0;Ab=c[Ha>>2]|0;if((zb|0)<(c[Ga>>2]|0)?(d[Ab+(zb<<2)+3>>0]|0)==(Ya|0):0){Bb=zb;Cb=tb}else{Bb=_a;Cb=zb}zb=Ab+(sb<<2)|0;Db=b[zb>>1]|0;Eb=Ab+(sb<<2)+2|0;Fb=d[Eb>>0]|0;Gb=a[G+(Fb<<2)>>0]|0;ub=Gb&255|ub;Hb=Ab+(Bb<<2)+2|0;Ib=(a[G+(d[Hb>>0]<<2)>>0]|0)==1;do if(Gb<<24>>24==1){b[F+(sb<<1)>>1]=vb;Jb=vb&65535;a[H+(Jb<<2)+2>>0]=a[G+(Fb<<2)+2>>0]|0;a[H+(Jb<<2)+3>>0]=nb;Kb=b[zb>>1]|0;Lb=(Kb|0)<(sb|0);if(Ib){if(Lb){b[H+(Jb<<2)>>1]=b[F+(Kb<<1)>>1]|0;b[H+(b[F+(b[zb>>1]<<1)>>1]<<2)>>1]=vb}Mb=ob;Nb=qb;Ob=pb;Pb=rb;Qb=vb+1<<16>>16;Rb=wb;Sb=xb;Tb=yb;break}do if(Lb){b[H+(Jb<<2)>>1]=b[F+(Kb<<1)>>1]|0;b[H+(b[F+(b[zb>>1]<<1)>>1]<<2)>>1]=vb;Ub=ob;Vb=qb;Wb=pb;Xb=wb;Yb=a[H+(b[F+(b[zb>>1]<<1)>>1]<<2)+2>>0]|0}else{Zb=d[Hb>>0]|0;if(a[G+(Zb<<2)>>0]|0){_b=d[Ab+(sb<<2)+3>>0]|0;$b=c[aa>>2]|0;ac=d[Ab+(Db<<2)+3>>0]|0;za=ea(g[$b+(_b<<4)>>2]);ua=ea(g[$b+(_b<<4)+4>>2]);xa=ea(g[$b+(_b<<4)+8>>2]);Ba=ea(g[$b+(ac<<4)>>2]);ya=ea(g[$b+(ac<<4)+4>>2]);Ca=ea(g[$b+(ac<<4)+8>>2]);Na=ea(g[Ja>>2]);La=ea(g[Ma>>2]);va=ea(g[Ua>>2]);Oa=ea(za*ya);Aa=ea(ua*Ca);Da=ea(xa*Ba);bb=ea(za*Ca);ab=ea(ua*Ba);Pa=ea(xa*ya);bc=ea(ea(ea(ea(ea(Da*La)+ea(ea(Aa*Na)+ea(Oa*va)))-ea(bb*La))-ea(ab*va))-ea(Pa*Na));cc=ea(ea(ea(ya*va)-ea(Ca*La))/bc);dc=ea(ea(ea(xa*La)-ea(ua*va))/bc);ec=ea(ea(Aa-Pa)/bc);Pa=ea(ea(ea(Ca*Na)-ea(Ba*va))/bc);Ca=ea(ea(ea(za*va)-ea(xa*Na))/bc);xa=ea(ea(Da-bb)/bc);bb=ea(ea(ea(Ba*La)-ea(ya*Na))/bc);ya=ea(ea(ea(ua*Na)-ea(za*La))/bc);La=ea(ea(Oa-ab)/bc);bc=ea(g[$b+(_b<<4)+12>>2]);ab=ea(g[$b+(ac<<4)+12>>2]);Oa=ea(-bc);bc=ea(-ab);ab=ea(-ea(g[Ta>>2]));za=ea(ea(ea(cc*Oa)+ea(dc*bc))+ea(ec*ab));ec=ea(ea(ea(Pa*Oa)+ea(Ca*bc))+ea(xa*ab));xa=ea(ea(ea(bb*Oa)+ea(ya*bc))+ea(La*ab));do if((pb|0)==(ob|0)){ac=(ob|0)==0?16:ob<<1;$b=UJa(u,ac*12|0,526608,153)|0;do if((ob|0)>0){c[$b+0>>2]=c[qb+0>>2];c[$b+4>>2]=c[qb+4>>2];c[$b+8>>2]=c[qb+8>>2];if((ob|0)>1)fc=1;else{Wa=87;break}do{_b=$b+(fc*12|0)|0;gc=qb+(fc*12|0)|0;c[_b+0>>2]=c[gc+0>>2];c[_b+4>>2]=c[gc+4>>2];c[_b+8>>2]=c[gc+8>>2];fc=fc+1|0}while((fc|0)!=(ob|0));hc=qb}else Wa=87;while(0);if((Wa|0)==87){Wa=0;if(!qb){ic=ac;jc=$b;break}hc=qb}VJa(x,hc);ic=ac;jc=$b}else{ic=ob;jc=qb}while(0);g[jc+(pb*12|0)>>2]=za;g[jc+(pb*12|0)+4>>2]=ec;g[jc+(pb*12|0)+8>>2]=xa;Ub=ic;Vb=jc;Wb=pb+1|0;Xb=wb+1<<16>>16;Yb=wb&255;break}gc=a[G+(Zb<<2)+2>>0]|0;if(gc<<24>>24!=-1){Ub=ob;Vb=qb;Wb=pb;Xb=wb;Yb=gc;break}gc=(c[ha>>2]|0)+(Zb*12|0)|0;c[w+0>>2]=c[gc+0>>2];c[w+4>>2]=c[gc+4>>2];c[w+8>>2]=c[gc+8>>2];do if((pb|0)==(ob|0)){gc=(ob|0)==0?16:ob<<1;_b=UJa(A,gc*12|0,526608,153)|0;do if((ob|0)>0){c[_b+0>>2]=c[qb+0>>2];c[_b+4>>2]=c[qb+4>>2];c[_b+8>>2]=c[qb+8>>2];if((ob|0)>1)kc=1;else{Wa=79;break}do{lc=_b+(kc*12|0)|0;mc=qb+(kc*12|0)|0;c[lc+0>>2]=c[mc+0>>2];c[lc+4>>2]=c[mc+4>>2];c[lc+8>>2]=c[mc+8>>2];kc=kc+1|0}while((kc|0)!=(ob|0));nc=qb}else Wa=79;while(0);if((Wa|0)==79){Wa=0;if(!qb){oc=gc;pc=_b;break}nc=qb}VJa(B,nc);oc=gc;pc=_b}else{oc=ob;pc=qb}while(0);Zb=pc+(pb*12|0)|0;c[Zb+0>>2]=c[w+0>>2];c[Zb+4>>2]=c[w+4>>2];c[Zb+8>>2]=c[w+8>>2];Zb=wb&255;a[G+(d[Hb>>0]<<2)+2>>0]=Zb;Ub=oc;Vb=pc;Wb=pb+1|0;Xb=wb+1<<16>>16;Yb=Zb}while(0);Kb=vb+1<<16>>16;if(xb<<24>>24==-1?1:xb<<24>>24==Yb<<24>>24){Mb=Ub;Nb=Vb;Ob=Wb;Pb=rb;Qb=Kb;Rb=Xb;Sb=xb;Tb=Yb;break}Jb=Kb&65535;a[H+(Jb<<2)+2>>0]=Yb;a[H+(Jb<<2)+3>>0]=nb;b[H+(Jb<<2)>>1]=255;Mb=Ub;Nb=Vb;Ob=Wb;Pb=Jb;Qb=vb+2<<16>>16;Rb=Xb;Sb=xb;Tb=Yb}else{if(!Ib){Mb=ob;Nb=qb;Ob=pb;Pb=rb;Qb=vb;Rb=wb;Sb=xb;Tb=yb;break}do if((Db|0)<(sb|0)){Jb=b[F+(Db<<1)>>1]|0;Kb=Jb+1|0;Lb=a[H+(Jb<<2)+3>>0]|0;if((Kb|0)<(vb&65535|0)?(a[H+(Kb<<2)+3>>0]|0)==Lb<<24>>24:0)qc=Kb;else{rc=Jb;Wa=97}g:do if((Wa|0)==97)while(1){Wa=0;Jb=rc+-1|0;if((Jb|0)<=0){qc=Jb;break g}if((a[H+(rc+-2<<2)+3>>0]|0)==Lb<<24>>24){rc=Jb;Wa=97}else{qc=Jb;break}}while(0);sc=ob;tc=qb;uc=pb;vc=wb;wc=a[H+(qc<<2)+2>>0]|0}else{if(Gb<<24>>24){Lb=d[Ab+(sb<<2)+3>>0]|0;_b=c[aa>>2]|0;gc=d[Ab+(Db<<2)+3>>0]|0;xa=ea(g[_b+(Lb<<4)>>2]);ec=ea(g[_b+(Lb<<4)+4>>2]);za=ea(g[_b+(Lb<<4)+8>>2]);ab=ea(g[_b+(gc<<4)>>2]);La=ea(g[_b+(gc<<4)+4>>2]);bc=ea(g[_b+(gc<<4)+8>>2]);ya=ea(g[Ja>>2]);Oa=ea(g[Ma>>2]);bb=ea(g[Ua>>2]);Ca=ea(xa*La);Pa=ea(ec*bc);dc=ea(za*ab);cc=ea(xa*bc);Na=ea(ec*ab);ua=ea(za*La);Ba=ea(ea(ea(ea(ea(dc*Oa)+ea(ea(Pa*ya)+ea(Ca*bb)))-ea(cc*Oa))-ea(Na*bb))-ea(ua*ya));Da=ea(ea(ea(La*bb)-ea(bc*Oa))/Ba);va=ea(ea(ea(za*Oa)-ea(ec*bb))/Ba);Aa=ea(ea(Pa-ua)/Ba);ua=ea(ea(ea(bc*ya)-ea(ab*bb))/Ba);bc=ea(ea(ea(xa*bb)-ea(za*ya))/Ba);za=ea(ea(dc-cc)/Ba);cc=ea(ea(ea(ab*Oa)-ea(La*ya))/Ba);La=ea(ea(ea(ec*ya)-ea(xa*Oa))/Ba);Oa=ea(ea(Ca-Na)/Ba);Ba=ea(g[_b+(Lb<<4)+12>>2]);Na=ea(g[_b+(gc<<4)+12>>2]);Ca=ea(-Ba);Ba=ea(-Na);Na=ea(-ea(g[Ta>>2]));xa=ea(ea(ea(Da*Ca)+ea(va*Ba))+ea(Aa*Na));Aa=ea(ea(ea(ua*Ca)+ea(bc*Ba))+ea(za*Na));za=ea(ea(ea(cc*Ca)+ea(La*Ba))+ea(Oa*Na));do if((pb|0)==(ob|0)){gc=(ob|0)==0?16:ob<<1;_b=UJa(C,gc*12|0,526608,153)|0;do if((ob|0)>0){c[_b+0>>2]=c[qb+0>>2];c[_b+4>>2]=c[qb+4>>2];c[_b+8>>2]=c[qb+8>>2];if((ob|0)>1)xc=1;else{Wa=114;break}do{Lb=_b+(xc*12|0)|0;Jb=qb+(xc*12|0)|0;c[Lb+0>>2]=c[Jb+0>>2];c[Lb+4>>2]=c[Jb+4>>2];c[Lb+8>>2]=c[Jb+8>>2];xc=xc+1|0}while((xc|0)!=(ob|0));yc=qb}else Wa=114;while(0);if((Wa|0)==114){Wa=0;if(!qb){zc=gc;Ac=_b;break}yc=qb}VJa(D,yc);zc=gc;Ac=_b}else{zc=ob;Ac=qb}while(0);g[Ac+(pb*12|0)>>2]=xa;g[Ac+(pb*12|0)+4>>2]=Aa;g[Ac+(pb*12|0)+8>>2]=za;sc=zc;tc=Ac;uc=pb+1|0;vc=wb+1<<16>>16;wc=wb&255;break}Jb=a[G+(Fb<<2)+2>>0]|0;if(Jb<<24>>24!=-1){sc=ob;tc=qb;uc=pb;vc=wb;wc=Jb;break}Jb=(c[ha>>2]|0)+(Fb*12|0)|0;c[v+0>>2]=c[Jb+0>>2];c[v+4>>2]=c[Jb+4>>2];c[v+8>>2]=c[Jb+8>>2];do if((pb|0)==(ob|0)){Jb=(ob|0)==0?16:ob<<1;Lb=UJa(y,Jb*12|0,526608,153)|0;do if((ob|0)>0){c[Lb+0>>2]=c[qb+0>>2];c[Lb+4>>2]=c[qb+4>>2];c[Lb+8>>2]=c[qb+8>>2];if((ob|0)>1)Bc=1;else{Wa=106;break}do{Kb=Lb+(Bc*12|0)|0;Zb=qb+(Bc*12|0)|0;c[Kb+0>>2]=c[Zb+0>>2];c[Kb+4>>2]=c[Zb+4>>2];c[Kb+8>>2]=c[Zb+8>>2];Bc=Bc+1|0}while((Bc|0)!=(ob|0));Cc=qb}else Wa=106;while(0);if((Wa|0)==106){Wa=0;if(!qb){Dc=Jb;Ec=Lb;break}Cc=qb}VJa(z,Cc);Dc=Jb;Ec=Lb}else{Dc=ob;Ec=qb}while(0);_b=Ec+(pb*12|0)|0;c[_b+0>>2]=c[v+0>>2];c[_b+4>>2]=c[v+4>>2];c[_b+8>>2]=c[v+8>>2];_b=wb&255;a[G+(d[Eb>>0]<<2)+2>>0]=_b;sc=Dc;tc=Ec;uc=pb+1|0;vc=wb+1<<16>>16;wc=_b}while(0);if(yb<<24>>24==-1?1:wc<<24>>24==yb<<24>>24){Fc=rb;Gc=vb}else{_b=vb&65535;a[H+(_b<<2)+2>>0]=yb;a[H+(_b<<2)+3>>0]=nb;b[H+(_b<<2)>>1]=255;Fc=_b;Gc=vb+1<<16>>16}_b=Gc&65535;a[H+(_b<<2)+2>>0]=wc;a[H+(_b<<2)+3>>0]=nb;b[F+(sb<<1)>>1]=Gc;gc=b[zb>>1]|0;if((gc|0)<(sb|0)){b[H+(_b<<2)>>1]=b[F+(gc<<1)>>1]|0;b[H+(b[F+(b[zb>>1]<<1)>>1]<<2)>>1]=Gc}Mb=sc;Nb=tc;Ob=uc;Pb=Fc;Qb=Gc+1<<16>>16;Rb=vc;Sb=wc;Tb=yb}while(0);if((Bb|0)==(_a|0))break;else{ob=Mb;pb=Ob;qb=Nb;rb=Pb;sb=Bb;tb=Cb;vb=Qb;wb=Rb;xb=Sb;yb=Tb}}if(!(ub&1))Hc=lb;else{yb=I+((lb&65535)<<4)|0;xb=(c[aa>>2]|0)+(Ya<<4)|0;c[yb+0>>2]=c[xb+0>>2];c[yb+4>>2]=c[xb+4>>2];c[yb+8>>2]=c[xb+8>>2];c[yb+12>>2]=c[xb+12>>2];Hc=lb+1<<16>>16}if((Pb|0)==255)Ic=_;else{b[J+(_<<2)>>1]=Pb&255;a[J+(_<<2)+2>>0]=Sb;a[J+(_<<2)+3>>0]=Tb;Ic=_+1|0}Ya=Ya+1|0;if((Ya|0)>=(c[Fa>>2]|0))break;else{Za=Mb;Xa=Nb;Ka=Ob;_=Ic;_a=Cb;$a=Qb;lb=Hc;mb=Rb}}if((Ic|0)>0){mb=I+((Hc&65535)<<4)|0;c[mb+0>>2]=c[Ja+0>>2];c[mb+4>>2]=c[Ja+4>>2];c[mb+8>>2]=c[Ja+8>>2];c[mb+12>>2]=c[Ja+12>>2];Jc=1;Kc=Hc+1<<16>>16}else{Jc=0;Kc=Hc}mb=Ic+-1|0;if((mb|0)>0){lb=0;$a=0;while(1){_a=a[J+(lb<<2)+3>>0]|0;_=lb+1|0;Ka=J+(_<<2)|0;if(_a<<24>>24!=(a[J+(_<<2)+2>>0]|0)){_=lb+2|0;if((_|0)<(Ic|0))Lc=_;else{Mc=0;Nc=Nb;break f}while(1){_=Lc+1|0;if(_a<<24>>24==(a[J+(Lc<<2)+2>>0]|0))break;if((_|0)<(Ic|0))Lc=_;else{Mc=0;Nc=Nb;break f}}_a=J+(Lc<<2)|0;ub=e[Ka>>1]|e[Ka+2>>1]<<16;_=e[_a>>1]|e[_a+2>>1]<<16;b[Ka>>1]=_;b[Ka+2>>1]=_>>>16;b[_a>>1]=ub;b[_a+2>>1]=ub>>>16}$a=$a+1<<16>>16;lb=$a&65535;if((lb|0)>=(mb|0)){Oc=Jc;Pc=Nb;Qc=Ic;Rc=Qb;Sc=Kc;Tc=Rb;Wa=141;break}}}else{Oc=Jc;Pc=Nb;Qc=Ic;Rc=Qb;Sc=Kc;Tc=Rb;Wa=141}}else{Oc=0;Pc=0;Qc=0;Rc=0;Sc=0;Tc=kb;Wa=141}while(0);if((Wa|0)==141){Wa=0;if(!(Tc<<16>>16)){Mc=0;Nc=Pc}else{Ta=mKa()|0;Ua=c[(c[Ta>>2]|0)+8>>2]|0;Ma=pKa()|0;Sa=mo[c[(c[Ma>>2]|0)+24>>2]&4095](Ma)|0;Ma=Bn[Ua&255](Ta,36,Sa?526792:544544,526432,1145)|0;Sa=Tc&65535;Ta=Rc&65535;Ua=Sc&65535;gJa(Ma,Sa,Qc+Ta|0,Ua);mb=c[la>>2]|0;if((mb|0)>0){lb=mb;mb=0;$a=0;ub=0;while(1){if((a[G+(mb<<2)>>0]|0)==1){_a=(c[Ma>>2]|0)+(ub*12|0)|0;_=(c[ha>>2]|0)+(mb*12|0)|0;c[_a+0>>2]=c[_+0>>2];c[_a+4>>2]=c[_+4>>2];c[_a+8>>2]=c[_+8>>2];Uc=c[la>>2]|0;Vc=ub+1|0}else{Uc=lb;Vc=ub}$a=$a+1<<16>>16;mb=$a&65535;if((mb|0)>=(Uc|0)){Wc=Vc;break}else{lb=Uc;ub=Vc}}}else Wc=0;if((Wc|0)<(Sa|0)){ub=0;lb=Wc;while(1){mb=(c[Ma>>2]|0)+(lb*12|0)|0;lb=lb+1|0;$a=Pc+((ub&65535)*12|0)|0;c[mb+0>>2]=c[$a+0>>2];c[mb+4>>2]=c[$a+4>>2];c[mb+8>>2]=c[$a+8>>2];if((lb|0)==(Sa|0))break;else ub=ub+1<<16>>16}}if(Oc){ub=Ua+255&255;Sa=Ma+12|0;lb=0;$a=0;do{mb=lb+Ta|0;a[(c[Sa>>2]|0)+(mb<<2)+3>>0]=ub;_=b[J+(lb<<2)>>1]|0;_a=c[Sa>>2]|0;b[_a+(mb<<2)>>1]=_;b[H+((_&65535)<<2)>>1]=mb;a[_a+(mb<<2)+2>>0]=a[J+(lb<<2)+2>>0]|0;$a=$a+1<<16>>16;lb=$a&65535}while((lb|0)<(Qc|0));Xc=Sa}else Xc=Ma+12|0;YEi(c[Xc>>2]|0,H|0,Ta<<2|0)|0;YEi(c[Ma+24>>2]|0,I|0,Ua<<4|0)|0;Mc=Ma;Nc=Pc}}if(!Nc)ib=Mc;else{VJa(E,Nc);ib=Mc}}else Wa=64}else Wa=64;while(0);if((Wa|0)==64){Wa=0;Ja=mKa()|0;$=c[(c[Ja>>2]|0)+8>>2]|0;Ia=pKa()|0;Sa=mo[c[(c[Ia>>2]|0)+24>>2]&4095](Ia)|0;Ia=Bn[$&255](Ja,36,Sa?526792:544544,526432,589)|0;gJa(Ia,c[la>>2]|0,c[Ga>>2]|0,c[Fa>>2]|0);YEi(c[Ia>>2]|0,c[ha>>2]|0,(c[la>>2]|0)*12|0)|0;YEi(c[Ia+12>>2]|0,c[Ha>>2]|0,c[Ga>>2]<<2|0)|0;YEi(c[Ia+24>>2]|0,c[aa>>2]|0,c[Fa>>2]<<4|0)|0;ib=Ia}if(!ib){gb=ha;break b}Yc=ib+16|0;Ia=c[Yc>>2]|0;Zc=ib+12|0;Sa=0;Ja=0;while(1){if((Ja|0)>=(Ia|0))break;$=c[Zc>>2]|0;lb=a[$+(Ja<<2)+3>>0]|0;$a=(a[$+(Sa<<2)+3>>0]|0)==lb<<24>>24?Sa:Ja;ub=Ja;Ja=Ja+1|0;if((Ja|0)<(Ia|0)?(a[$+(Ja<<2)+3>>0]|0)==lb<<24>>24:0)_c=Ja;else _c=$a;lb=b[$+(ub<<2)>>1]|0;if(lb<<16>>16==255|lb<<16>>16==-1){Wa=180;break c}if((a[$+(lb<<16>>16<<2)+2>>0]|0)!=(a[$+(_c<<2)+2>>0]|0)){Wa=180;break c}else Sa=$a}h:do if((Ia|0)>0){Ja=c[Zc>>2]|0;$a=c[ib+24>>2]|0;$=c[ib>>2]|0;wa=ea(g[131604]);za=ea(-wa);lb=Sa;ub=0;while(1){mb=a[Ja+(ub<<2)+3>>0]|0;_a=mb&255;_=d[Ja+(ub<<2)+2>>0]|0;Aa=ea(g[$+(_*12|0)>>2]);xa=ea(g[$+(_*12|0)+4>>2]);Na=ea(g[$+(_*12|0)+8>>2]);Oa=ea(g[$a+(_a<<4)>>2]);Ba=ea(g[$a+(_a<<4)+4>>2]);La=ea(g[$a+(_a<<4)+8>>2]);Ca=ea(ea(ea(Aa*Oa)+ea(xa*Ba))+ea(Na*La));cc=ea(ea(g[$a+(_a<<4)+12>>2])+Ca);if(cc>wa|cc<za){$c=$a;break c}_a=lb;lb=(a[Ja+(lb<<2)+3>>0]|0)==mb<<24>>24?lb:ub;_a=ub;ub=ub+1|0;_=(ub|0)<(Ia|0);if(_?(a[Ja+(ub<<2)+3>>0]|0)==mb<<24>>24:0)ad=ub;else ad=lb;Xa=ad+1|0;if((Xa|0)<(Ia|0)?(a[Ja+(Xa<<2)+3>>0]|0)==mb<<24>>24:0)bd=Xa;else bd=lb;if((_a|0)==(bd|0))if(_){lb=lb;ub=ub;continue}else break h;_a=d[Ja+(ad<<2)+2>>0]|0;Xa=d[Ja+(bd<<2)+2>>0]|0;cc=ea(g[$+(_a*12|0)>>2]);Ca=ea(g[$+(_a*12|0)+4>>2]);bc=ea(g[$+(_a*12|0)+8>>2]);ua=ea(g[$+(Xa*12|0)>>2]);va=ea(g[$+(Xa*12|0)+4>>2]);Da=ea(cc-Aa);Aa=ea(Ca-xa);xa=ea(bc-Na);Na=ea(ua-cc);cc=ea(va-Ca);Ca=ea(ea(g[$+(Xa*12|0)+8>>2])-bc);bc=ea(ea(Aa*Ca)-ea(xa*cc));va=ea(ea(xa*Na)-ea(Da*Ca));Ca=ea(ea(Da*cc)-ea(Aa*Na));Na=ea(T(ea(ea(Ca*Ca)+ea(ea(bc*bc)+ea(va*va)))));if(Na==ea(0.0)){cd=ea(1.0);dd=ea(0.0);ed=ea(0.0)}else{Aa=ea(ea(1.0)/Na);cd=ea(bc*Aa);dd=ea(va*Aa);ed=ea(Ca*Aa)}fd=ea(ea(La*ed)+ea(ea(Ba*dd)+ea(Oa*cd)))<=ea(0.0);if(fd|_^1)break}if(fd){$c=$a;break c}}while(0);if(ha){Ia=c[aa>>2]|0;if(Ia){VJa(J,Ia);c[aa>>2]=0}c[Fa>>2]=0;c[ha+32>>2]=0;c[aa>>2]=0;Ia=c[Ha>>2]|0;if(Ia){VJa(J,Ia);c[Ha>>2]=0}c[Ga>>2]=0;c[ha+20>>2]=0;c[Ha>>2]=0;Ia=c[ha>>2]|0;if(Ia){VJa(J,Ia);c[ha>>2]=0}c[la>>2]=0;c[ha+8>>2]=0;c[ha>>2]=0;VJa(J,ha)}if(!Ea){gb=ib;break b}else ha=ib}if((Wa|0)==180)$c=c[ib+24>>2]|0;Ea=ib+24|0;if($c){VJa(v,$c);c[Ea>>2]=0}c[ib+28>>2]=0;c[ib+32>>2]=0;c[Ea>>2]=0;Ea=c[Zc>>2]|0;if(Ea){VJa(v,Ea);c[Zc>>2]=0}c[Yc>>2]=0;c[ib+20>>2]=0;c[Zc>>2]=0;Ea=c[ib>>2]|0;if(Ea){VJa(v,Ea);c[ib>>2]=0}c[ib+4>>2]=0;c[ib+8>>2]=0;c[ib>>2]=0;VJa(v,ib);gb=ha}else gb=ia;while(0);ia=gb+28|0;Y=gb+16|0;X=UJa(N,(c[ia>>2]|0)+1+(c[Y>>2]|0)<<2,526432,2123)|0;c[n>>2]=X;c[o>>2]=1;c[X>>2]=-1;fa=c[Y>>2]|0;if((fa|0)>0){ga=gb+12|0;da=fa;fa=0;oa=0;while(1){Z=fa+1|0;if((Z|0)<(da|0)){W=c[ga>>2]|0;Ea=a[W+(fa<<2)+3>>0]|0;r=Z;Z=1;while(1){Ia=Z+1|0;if(Ea<<24>>24!=(a[W+(r<<2)+3>>0]|0)){gd=Z;break}r=Ia+fa|0;if((r|0)>=(da|0)){gd=Ia;break}else Z=Ia}Z=c[o>>2]|0;c[o>>2]=Z+1;c[X+(Z<<2)>>2]=gd;if(!gd)hd=fa;else{id=W;jd=gd;Wa=205}}else{Z=c[o>>2]|0;c[o>>2]=Z+1;c[X+(Z<<2)>>2]=1;id=c[ga>>2]|0;jd=1;Wa=205}if((Wa|0)==205){Wa=0;Z=fa;r=jd;while(1){r=r+-1|0;Ea=d[id+(Z<<2)+2>>0]|0;ha=c[o>>2]|0;c[o>>2]=ha+1;c[X+(ha<<2)>>2]=Ea;if(!r)break;else Z=Z+1|0}hd=jd+fa|0}Z=oa+1|0;da=c[Y>>2]|0;if((hd|0)>=(da|0)){kd=Z;break}else{fa=hd;oa=Z}}}else kd=0;c[X>>2]=kd;oa=c[gb>>2]|0;c[l>>2]=oa;fa=gb+4|0;c[m>>2]=c[fa>>2];if((c[fa>>2]|0)>0?(aFi(oa|0,c[gb>>2]|0,12)|0,(c[fa>>2]|0)>1):0){oa=1;do{aFi((c[l>>2]|0)+(oa*12|0)|0,(c[gb>>2]|0)+(oa*12|0)|0,12)|0;oa=oa+1|0}while((oa|0)<(c[fa>>2]|0));oa=gb+8|0;c[oa>>2]=0;c[fa>>2]=0;c[gb>>2]=0;ld=oa}else{oa=gb+8|0;c[oa>>2]=0;c[fa>>2]=0;c[gb>>2]=0;if(!gb){V=0;break}else ld=oa}oa=gb+24|0;X=c[oa>>2]|0;if(X){VJa(v,X);c[oa>>2]=0}c[ia>>2]=0;c[gb+32>>2]=0;c[oa>>2]=0;oa=gb+12|0;X=c[oa>>2]|0;if(X){VJa(v,X);c[oa>>2]=0}c[Y>>2]=0;c[gb+20>>2]=0;c[oa>>2]=0;oa=c[gb>>2]|0;if(oa){VJa(v,oa);c[gb>>2]=0}c[fa>>2]=0;c[ld>>2]=0;c[gb>>2]=0;VJa(v,gb);V=0}else V=1}else V=U;while(0);U=c[O>>2]|0;if(U){VJa(E,U);c[O>>2]=0}c[R>>2]=0;c[S>>2]=0;c[O>>2]=0;Q=V;i=t;return Q|0}function qJa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=ea(h);var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;j=i;i=i+32|0;k=j+25|0;l=j+24|0;m=j;n=j+8|0;o=j+20|0;p=j+16|0;q=j+4|0;r=j+12|0;s=j+26|0;if(g==ea(0.0)){t=nJa(a,d,b,q,r,o,p,f,h)|0;if((t&-3|0)==1){u=t;i=j;return u|0}v=c[r>>2]|0;c[e+4>>2]=v*3;c[e+8>>2]=v;c[e+16>>2]=c[q>>2];if((t|0)==2){c[e+12>>2]=c[o>>2];c[e>>2]=c[p>>2];u=0;i=j;return u|0}else if(!t){c[e+12>>2]=d;c[e>>2]=b;u=0;i=j;return u|0}else{u=0;i=j;return u|0}}t=pJa(a,d,b,35,o,p,n,m,g,ea(120.0),f,h)|0;if((t&-3|0)==1){f=c[a>>2]|0;a=c[f>>2]|0;if(a){VJa(k,a);c[f>>2]=0}c[f+8>>2]=0;c[f+4>>2]=0;u=t;i=j;return u|0}c[e+12>>2]=c[o>>2];c[e>>2]=c[p>>2];if((t|0)==2){t=c[m>>2]|0;c[e+4>>2]=t*3;c[e+8>>2]=t;c[e+16>>2]=c[n>>2];u=0;i=j;return u|0}t=c[n>>2]|0;m=c[t>>2]|0;if((m|0)>0){p=0;o=0;f=0;a=0;b=1;while(1){d=b+1|0;q=c[t+(b<<2)>>2]|0;if((q|0)>2){v=t+(d<<2)|0;r=o+-2|0;w=p;x=f;y=o;z=2;while(1){A=c[v>>2]|0;B=c[t+(z+b<<2)>>2]|0;C=c[t+(z+d<<2)>>2]|0;do if((y|0)==(w|0)){D=(y|0)==0?16:y<<1;E=UJa(k,D*12|0,526608,153)|0;if((y|0)>0?(c[E+0>>2]=c[x+0>>2],c[E+4>>2]=c[x+4>>2],c[E+8>>2]=c[x+8>>2],(y|0)>1):0){F=1;do{G=E+(F*12|0)|0;H=x+(F*12|0)|0;c[G+0>>2]=c[H+0>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];F=F+1|0}while((F|0)!=(y|0));I=x}else{if(!x){J=D;K=E;break}I=x}VJa(l,I);J=D;K=E}else{J=w;K=x}while(0);c[K+(y*12|0)>>2]=A;c[K+(y*12|0)+4>>2]=B;c[K+(y*12|0)+8>>2]=C;z=z+1|0;if((z|0)==(q|0))break;else{w=J;x=K;y=y+1|0}}L=J;M=r+q|0;N=K}else{L=p;M=o;N=f}a=a+1|0;if((a|0)==(m|0)){O=M;P=N;break}else{p=L;o=M;f=N;b=q+d|0}}}else{O=0;P=0}VJa(s,t);c[n>>2]=0;c[e+4>>2]=O*3;c[e+8>>2]=O;c[e+16>>2]=P;u=0;i=j;return u|0}function rJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,T=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=Im,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=0,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=Im,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;f=i;i=i+32|0;h=f+22|0;j=f+24|0;k=f;l=f+21|0;m=f+20|0;n=f+23|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;o=d+4|0;p=c[o>>2]|0;q=UJa(f+25|0,p>>>0<8?96:p*12|0,526432,2595)|0;p=c[o>>2]|0;o=c[d+12>>2]|0;r=ea(g[d+16>>2]);if(p){s=c[d+8>>2]|0;t=ea(3402823469999999843913219.0e14);u=ea(-3402823469999999843913219.0e14);v=ea(3402823469999999843913219.0e14);w=ea(-3402823469999999843913219.0e14);x=ea(3402823469999999843913219.0e14);y=ea(-3402823469999999843913219.0e14);z=0;A=s;while(1){B=ea(g[A>>2]);t=B<t?B:t;u=B>u?B:u;B=ea(g[A+4>>2]);v=B<v?B:v;w=B>w?B:w;B=ea(g[A+8>>2]);x=B<x?B:x;y=B>y?B:y;z=z+1|0;if((z|0)==(p|0))break;else A=A+o|0}B=ea(u-t);u=ea(w-v);w=ea(y-x);y=ea(t+ea(B*ea(.5)));t=ea(v+ea(u*ea(.5)));v=ea(x+ea(w*ea(.5)));A=B<ea(9.99999997e-07);z=u<ea(9.99999997e-07);C=w<ea(9.99999997e-07);do if(A|z|C|p>>>0<3){D=B>ea(9.99999997e-07)&B<ea(3402823469999999843913219.0e14);x=D?B:ea(3402823469999999843913219.0e14);D=u>ea(9.99999997e-07)&u<x;E=D?u:x;D=w>ea(9.99999997e-07)&w<E;x=D?w:E;if(!(x==ea(3402823469999999843913219.0e14))){if(A)F=ea(x*ea(.0500000007));else F=B;if(z)G=ea(x*ea(.0500000007));else G=u;if(C){H=F;I=G;J=ea(x*ea(.0500000007))}else{H=F;I=G;J=w}}else{H=ea(.00999999977);I=ea(.00999999977);J=ea(.00999999977)}x=ea(y-H);E=ea(y+H);K=ea(t-I);L=ea(t+I);M=ea(v-J);N=ea(v+J);g[q>>2]=x;g[q+4>>2]=K;g[q+8>>2]=M;g[q+12>>2]=E;g[q+16>>2]=K;g[q+20>>2]=M;g[q+24>>2]=E;g[q+28>>2]=L;g[q+32>>2]=M;g[q+36>>2]=x;g[q+40>>2]=L;g[q+44>>2]=M;g[q+48>>2]=x;g[q+52>>2]=K;g[q+56>>2]=N;g[q+60>>2]=E;g[q+64>>2]=K;g[q+68>>2]=N;g[q+72>>2]=E;g[q+76>>2]=L;g[q+80>>2]=N;g[q+84>>2]=x;g[q+88>>2]=L;g[q+92>>2]=N;O=ea(1.0);P=8;Q=ea(1.0);R=ea(1.0);T=35}else{N=ea(ea(1.0)/B);L=ea(ea(1.0)/u);x=ea(ea(1.0)/w);E=ea(y*N);K=ea(t*L);M=ea(v*x);D=0;U=0;V=s;while(1){W=ea(g[V>>2]);X=ea(g[V+4>>2]);Y=ea(N*W);W=ea(L*X);X=ea(x*ea(g[V+8>>2]));V=V+o|0;if(D){Z=0;while(1){_=Z*3|0;$=q+(_<<2)|0;aa=ea(g[$>>2]);ba=q+(_+1<<2)|0;ca=q+(_+2<<2)|0;da=ea(g[ca>>2]);if(ea(S(ea(aa-Y)))<r?(fa=ea(S(ea(da-X))),ga=ea(g[ba>>2]),fa<r?ea(S(ea(ga-W)))<r:0):0){T=17;break}_=Z+1|0;if(_>>>0<D>>>0)Z=_;else{ha=_;break}}if((T|0)==17){T=0;fa=ea(Y-E);ia=ea(W-K);ja=ea(X-M);ka=ea(aa-E);la=ea(ga-K);ma=ea(da-M);if(ea(ea(ja*ja)+ea(ea(fa*fa)+ea(ia*ia)))>ea(ea(ma*ma)+ea(ea(ka*ka)+ea(la*la)))){g[$>>2]=Y;g[ba>>2]=W;g[ca>>2]=X;ha=Z}else ha=Z}if((ha|0)==(D|0)){na=D;T=21}else oa=D}else{na=0;T=21}if((T|0)==21){T=0;_=na*3|0;g[q+(_<<2)>>2]=Y;g[q+(_+1<<2)>>2]=W;g[q+(_+2<<2)>>2]=X;oa=na+1|0}U=U+1|0;if((U|0)==(p|0))break;else D=oa}if(!oa){pa=ea(-3402823469999999843913219.0e14);qa=ea(3402823469999999843913219.0e14);ra=ea(-3402823469999999843913219.0e14);sa=ea(3402823469999999843913219.0e14);ta=ea(-3402823469999999843913219.0e14);ua=ea(3402823469999999843913219.0e14);va=0}else{M=ea(3402823469999999843913219.0e14);K=ea(-3402823469999999843913219.0e14);E=ea(3402823469999999843913219.0e14);x=ea(-3402823469999999843913219.0e14);L=ea(3402823469999999843913219.0e14);N=ea(-3402823469999999843913219.0e14);D=0;while(1){U=D*3|0;la=ea(g[q+(U<<2)>>2]);ka=la<M?la:M;ma=la>K?la:K;la=ea(g[q+(U+1<<2)>>2]);ia=la<E?la:E;fa=la>x?la:x;la=ea(g[q+(U+2<<2)>>2]);ja=la<L?la:L;wa=la>N?la:N;D=D+1|0;if((D|0)==(oa|0)){pa=ma;qa=ka;ra=fa;sa=ia;ta=wa;ua=ja;va=oa;break}else{M=ka;K=ma;E=ia;x=fa;L=ja;N=wa}}}N=ea(pa-qa);L=ea(ra-sa);x=ea(ta-ua);D=N<ea(9.99999997e-07);U=L<ea(9.99999997e-07);V=x<ea(9.99999997e-07);if(!(D|U|V|va>>>0<3))if(!va){xa=0;break}else{O=B;P=va;Q=w;R=u;T=35;break}E=ea(qa+ea(N*ea(.5)));K=ea(sa+ea(L*ea(.5)));M=ea(ua+ea(x*ea(.5)));_=N>=ea(9.99999997e-07)&N<ea(3402823469999999843913219.0e14);wa=_?N:ea(3402823469999999843913219.0e14);_=L>=ea(9.99999997e-07)&L<wa;ja=_?L:wa;_=x>=ea(9.99999997e-07)&x<ja;wa=_?x:ja;if(!(wa==ea(3402823469999999843913219.0e14))){if(D)ya=ea(wa*ea(.0500000007));else ya=N;if(U)za=ea(wa*ea(.0500000007));else za=L;if(V){Aa=ya;Ba=za;Ca=ea(wa*ea(.0500000007))}else{Aa=ya;Ba=za;Ca=x}}else{Aa=ea(.00999999977);Ba=ea(.00999999977);Ca=ea(.00999999977)}x=ea(E-Aa);wa=ea(E+Aa);E=ea(K-Ba);L=ea(K+Ba);K=ea(M-Ca);N=ea(M+Ca);g[q>>2]=x;g[q+4>>2]=E;g[q+8>>2]=K;g[q+12>>2]=wa;g[q+16>>2]=E;g[q+20>>2]=K;g[q+24>>2]=wa;g[q+28>>2]=L;g[q+32>>2]=K;g[q+36>>2]=x;g[q+40>>2]=L;g[q+44>>2]=K;g[q+48>>2]=x;g[q+52>>2]=E;g[q+56>>2]=N;g[q+60>>2]=wa;g[q+64>>2]=E;g[q+68>>2]=N;g[q+72>>2]=wa;g[q+76>>2]=L;g[q+80>>2]=N;g[q+84>>2]=x;g[q+88>>2]=L;g[q+92>>2]=N;O=B;P=8;Q=w;R=u;T=35}while(0);if((T|0)==35){T=0;do{va=T*3|0;oa=q+(va<<2)|0;g[oa>>2]=ea(O*ea(g[oa>>2]));oa=q+(va+1<<2)|0;g[oa>>2]=ea(R*ea(g[oa>>2]));oa=q+(va+2<<2)|0;g[oa>>2]=ea(Q*ea(g[oa>>2]));T=T+1|0}while((T|0)!=(P|0));xa=P}if(!(c[d>>2]&4))Da=ea(0.0);else Da=ea(g[d+20>>2]);Q=ea(g[d+24>>2]);P=qJa(b,xa,q,k,c[d+28>>2]|0,Da,Q)|0;if(!P){xa=c[k>>2]|0;b=UJa(l,xa*12|0,526432,2626)|0;l=k+12|0;T=c[l>>2]|0;oa=k+16|0;va=c[oa>>2]|0;p=k+4|0;na=c[p>>2]|0;ha=xa>>>0>1073741823?-1:xa<<2;if(!ha)Ea=0;else{ca=mKa()|0;ba=c[(c[ca>>2]|0)+8>>2]|0;$=pKa()|0;o=mo[c[(c[$>>2]|0)+24>>2]&4095]($)|0;Ea=Bn[ba&255](ca,ha,o?541832:544544,526432,2287)|0}PEi(Ea|0,0,xa<<2|0)|0;if(!na)Fa=0;else{xa=0;o=0;while(1){ha=va+(o<<2)|0;ca=c[ha>>2]|0;ba=Ea+(ca<<2)|0;$=c[ba>>2]|0;if(!$){c[ha>>2]=xa;s=ca*3|0;ca=xa*3|0;g[b+(ca<<2)>>2]=ea(g[T+(s<<2)>>2]);g[b+(ca+1<<2)>>2]=ea(g[T+(s+1<<2)>>2]);g[b+(ca+2<<2)>>2]=ea(g[T+(s+2<<2)>>2]);s=xa+1|0;c[ba>>2]=s;Ga=s}else{c[ha>>2]=$+-1;Ga=xa}o=o+1|0;if((o|0)==(na|0)){Fa=Ga;break}else xa=Ga}}VJa(h,Ea);do if(c[d>>2]&1){a[e>>0]=0;c[e+4>>2]=Fa;Ea=Fa*3|0;Ga=Ea>>>0>1073741823?-1:Ea<<2;if(!Ga)Ha=0;else{Ea=mKa()|0;xa=c[(c[Ea>>2]|0)+8>>2]|0;o=pKa()|0;$=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;Ha=Bn[xa&255](Ea,Ga,$?526520:544544,526432,2635)|0}$=e+8|0;c[$>>2]=Ha;Ga=k+8|0;c[e+12>>2]=c[Ga>>2];c[e+16>>2]=na;Ea=na>>>0>1073741823?-1:na<<2;if(!Ea){Ia=0;Ja=Ha}else{xa=mKa()|0;o=c[(c[xa>>2]|0)+8>>2]|0;ha=pKa()|0;s=mo[c[(c[ha>>2]|0)+24>>2]&4095](ha)|0;ha=Bn[o&255](xa,Ea,s?541832:544544,526432,2639)|0;Ia=ha;Ja=c[$>>2]|0}$=e+20|0;c[$>>2]=Ia;YEi(Ja|0,b|0,Fa*12|0)|0;if(!(c[d>>2]&2)){ha=c[oa>>2]|0;YEi(c[$>>2]|0,ha|0,c[p>>2]<<2|0)|0;Ka=T;La=ha;break}if(!(c[Ga>>2]|0)){Ka=T;La=va}else{ha=c[oa>>2]|0;s=c[$>>2]|0;$=0;Ea=ha;while(1){c[s>>2]=c[Ea+8>>2];c[s+4>>2]=c[Ea+4>>2];c[s+8>>2]=c[Ea>>2];$=$+1|0;if($>>>0>=(c[Ga>>2]|0)>>>0){Ka=T;La=ha;break}else{s=s+12|0;Ea=Ea+12|0}}}}else{a[e>>0]=1;c[e+4>>2]=Fa;Ea=Fa*3|0;s=Ea>>>0>1073741823?-1:Ea<<2;if(!s)Ma=0;else{Ea=mKa()|0;ha=c[(c[Ea>>2]|0)+8>>2]|0;Ga=pKa()|0;$=mo[c[(c[Ga>>2]|0)+24>>2]&4095](Ga)|0;Ma=Bn[ha&255](Ea,s,$?526520:544544,526432,2666)|0}$=e+8|0;c[$>>2]=Ma;s=k+8|0;Ea=c[s>>2]|0;c[e+12>>2]=Ea;ha=Ea+na|0;c[e+16>>2]=ha;Ea=ha>>>0>1073741823?-1:ha<<2;if(!Ea){Na=0;Oa=Ma}else{ha=mKa()|0;Ga=c[(c[ha>>2]|0)+8>>2]|0;xa=pKa()|0;o=mo[c[(c[xa>>2]|0)+24>>2]&4095](xa)|0;xa=Bn[Ga&255](ha,Ea,o?541832:544544,526432,2669)|0;Na=xa;Oa=c[$>>2]|0}$=e+20|0;c[$>>2]=Na;YEi(Oa|0,b|0,Fa*12|0)|0;if(!(c[s>>2]|0))Pa=c[oa>>2]|0;else{xa=c[oa>>2]|0;o=c[$>>2]|0;$=0;Ea=xa;while(1){c[o>>2]=3;if(!(c[d>>2]&2)){c[o+4>>2]=c[Ea>>2];c[o+8>>2]=c[Ea+4>>2];c[o+12>>2]=c[Ea+8>>2]}else{c[o+4>>2]=c[Ea+8>>2];c[o+8>>2]=c[Ea+4>>2];c[o+12>>2]=c[Ea>>2]}$=$+1|0;if($>>>0>=(c[s>>2]|0)>>>0){Pa=xa;break}else{o=o+16|0;Ea=Ea+12|0}}}Ka=c[l>>2]|0;La=Pa}while(0);Pa=(Ka|0)==(q|0)?0:q;VJa(h,La);VJa(j,Ka);c[k>>2]=0;c[p>>2]=0;p=l;c[p>>2]=0;c[p+4>>2]=0;if(!b){Qa=0;Ra=Pa}else{VJa(m,b);Qa=0;Ra=Pa}}else{Qa=P;Ra=q}}else{Qa=1;Ra=q}if(!Ra){i=f;return Qa|0}VJa(n,Ra);i=f;return Qa|0}function sJa(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=b+8|0;e=c[d>>2]|0;if(e){VJa(a+1|0,e);c[d>>2]=0}d=b+20|0;b=c[d>>2]|0;if(!b){i=a;return 0}VJa(a,b);c[d>>2]=0;i=a;return 0}function tJa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+8|0;h=f;In[c[(c[d>>2]|0)+8>>2]&4095](h,d);d=h;h=c[d>>2]|0;j=c[d+4>>2]|0;if(!a)k=0;else k=mo[c[(c[a>>2]|0)+16>>2]&4095](a)|0;a=Bn[c[(c[k>>2]|0)+8>>2]&255](k,288,527016,526928,149)|0;if(!a){l=0;m=l+116|0;i=f;return m|0}d=g;c[d>>2]=h;c[d+4>>2]=j;P5a(a,k,b,e,g);l=a;m=l+116|0;i=f;return m|0}function uJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,100,j?528008:544544,527512,211)|0;vJa(h,a,b,d);i=e;return h|0}function vJa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;c[a>>2]=527600;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[a+40>>2]=ea(.75);c[a+44>>2]=-1;c[a+48>>2]=0;c[a+52>>2]=0;Q5a(e,64);c[a+56>>2]=0;e=a+60|0;d=c[(qTa()|0)>>2]|0;if(!d){c[e>>2]=0;h=a+64|0;j=h+0|0;k=j+36|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=f;return}b=mKa()|0;l=c[(c[b>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[l&255](b,d,n?544576:544544,544464,111)|0;c[e>>2]=m;if(!m){h=a+64|0;j=h+0|0;k=j+36|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=f;return}mTa(m);h=a+64|0;j=h+0|0;k=j+36|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=f;return}function wJa(a,b){a=a|0;b=b|0;return}function xJa(a){a=a|0;var b=0;b=i;i=i+16|0;yJa(a);VJa(b,a);i=b;return}function yJa(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=527600;d=c[a+96>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+88>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+84>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+76>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+72>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+64>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+60|0;nTa(c[d>>2]|0);e=c[d>>2]|0;if(e){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=a+16|0;a=c[e>>2]|0;if(!a){i=b;return}VJa(e,a);i=b;return}function zJa(a){a=a|0;var b=0;b=i;if(!a){i=b;return}ko[c[(c[a>>2]|0)+68>>2]&4095](a);i=b;return}function AJa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(gTa(b+16|0)|0){i=d;return}e=c[a+4>>2]|0;if(!e){ko[c[(c[b>>2]|0)+28>>2]&4095](b);i=d;return}else{In[c[c[e>>2]>>2]&4095](e,b);i=d;return}}function BJa(a,b){a=a|0;b=b|0;a=i;fTa(b+16|0)|0;i=a;return}function CJa(a,b){a=a|0;b=b|0;return}function DJa(a,b,c){a=a|0;b=b|0;c=c|0;return}function EJa(a,b,c){a=a|0;b=b|0;c=c|0;return}function FJa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;c[a+80>>2]=0;c[a+68>>2]=0;d=c[a+36>>2]|0;if(!d){e=a+56|0;c[e>>2]=0;i=b;return}f=a+52|0;if(!(c[f>>2]|0)){e=a+56|0;c[e>>2]=0;i=b;return}PEi(c[a+28>>2]|0,-1,d<<2|0)|0;d=a+32|0;g=c[d>>2]|0;h=g+-1|0;j=a+24|0;k=c[j>>2]|0;if(!h){l=g;m=k}else{g=k;k=0;while(1){n=k+1|0;o=c[j>>2]|0;c[o+(k<<2)>>2]=n;if((n|0)==(h|0))break;else{g=o;k=n}}l=c[d>>2]|0;m=o}c[m+(l+-1<<2)>>2]=-1;c[a+44>>2]=0;c[f>>2]=0;e=a+56|0;c[e>>2]=0;i=b;return}function GJa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b;e=a+8|0;f=c[e>>2]|0;if(f)ko[c[c[f>>2]>>2]&4095](f);if(!(c[a+56>>2]|0)){i=b;return}c[d>>2]=0;f=a+80|0;if(!(c[f>>2]|0))g=a+92|0;else{h=a+76|0;j=a+88|0;k=a+96|0;l=a+92|0;m=0;do{n=c[h>>2]|0;do if((c[n+(m*20|0)+8>>2]|0)!=3?(gTa(n+(m*20|0)+4|0)|0)==0:0){o=c[l>>2]|0;if((c[k>>2]&2147483647)>>>0<=o>>>0){R5a(j,d)|0;p=c[d>>2]|0;break}q=(c[j>>2]|0)+(o<<2)|0;if(q)c[q>>2]=m;c[l>>2]=o+1;p=m}else p=m;while(0);m=p+1|0;c[d>>2]=m}while(m>>>0<(c[f>>2]|0)>>>0);g=l}if(!(c[g>>2]|0)){c[g>>2]=0;i=b;return}l=a+88|0;f=0;m=0;do{f=f|(HJa(a,c[(c[l>>2]|0)+(m<<2)>>2]|0,f)|0);m=m+1|0}while(m>>>0<(c[g>>2]|0)>>>0);c[g>>2]=0;g=c[e>>2]|0;if((g|0)==0|f^1){i=b;return}ko[c[(c[g>>2]|0)+12>>2]&4095](g);i=b;return}function HJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=a+60|0;oTa(c[g>>2]|0);h=c[a+76>>2]|0;j=h+(b*20|0)+8|0;k=c[j>>2]|0;if((k|0)==3){dKa(bKa()|0,2,527512,793,527712,f);l=0;m=c[g>>2]|0;pTa(m);i=e;return l|0}else if((k|0)==1){dKa(bKa()|0,2,527512,817,527736,f);n=d}else if((k|0)==2)n=OJa(a,b,d)|0|d;else if(!k){k=c[a+4>>2]|0;In[c[c[k>>2]>>2]&4095](k,c[h+(b*20|0)>>2]|0);n=d}else{dKa(bKa()|0,2,527512,829,527760,f);n=OJa(a,b,d)|0|d}c[j>>2]=3;l=n;m=c[g>>2]|0;pTa(m);i=e;return l|0}function IJa(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;if(!d){i=b;return}ko[c[(c[d>>2]|0)+24>>2]&4095](d);i=b;return}function JJa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+60|0;oTa(c[f>>2]|0);g=c[b+36>>2]|0;a:do if(g){h=a[d>>0]|0;if(!(h<<24>>24))j=5381;else{k=h;h=5381;l=d;while(1){m=h*33^k<<24>>24;l=l+1|0;k=a[l>>0]|0;if(!(k<<24>>24)){j=m;break}else h=m}}h=c[(c[b+28>>2]|0)+((j&g+-1)<<2)>>2]|0;if((h|0)!=-1){k=c[b+20>>2]|0;l=b+24|0;m=h;while(1){n=k+(m<<3)|0;if(!(HEi(c[n>>2]|0,d)|0))break;h=c[(c[l>>2]|0)+(m<<2)>>2]|0;if((h|0)==-1){o=8;break a}else m=h}pTa(c[f>>2]|0);if(n){p=c[k+(m<<3)+4>>2]|0;i=e;return p|0}}else o=8}else o=8;while(0);if((o|0)==8)pTa(c[f>>2]|0);p=kn[c[(c[b>>2]|0)+48>>2]&511](b,0,d,2)|0;i=e;return p|0}function KJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+60|0;oTa(c[e>>2]|0);f=c[(c[a+76>>2]|0)+(b*20|0)>>2]|0;pTa(c[e>>2]|0);i=d;return f|0}function LJa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g;c[j>>2]=e;l=(d|0)!=0;if(l){c[d+8>>2]=b;ko[c[(c[d>>2]|0)+32>>2]&4095](d)}m=b+60|0;oTa(c[m>>2]|0);n=c[b+36>>2]|0;a:do if(n){o=a[e>>0]|0;if(!(o<<24>>24))p=5381;else{q=o;o=5381;r=e;while(1){s=o*33^q<<24>>24;r=r+1|0;q=a[r>>0]|0;if(!(q<<24>>24)){p=s;break}else o=s}}o=c[(c[b+28>>2]|0)+((p&n+-1)<<2)>>2]|0;if((o|0)!=-1){q=c[b+20>>2]|0;r=b+24|0;s=o;while(1){t=q+(s<<3)|0;if(!(HEi(c[t>>2]|0,e)|0))break;o=c[(c[r>>2]|0)+(s<<2)>>2]|0;if((o|0)==-1)break a;else s=o}if(t){r=c[q+(s<<3)+4>>2]|0;if(!l){u=r;v=c[m>>2]|0;pTa(v);i=g;return u|0}o=b+76|0;c[(c[o>>2]|0)+(r*20|0)>>2]=d;c[(c[o>>2]|0)+(r*20|0)+8>>2]=f;c[d+12>>2]=r;u=r;v=c[m>>2]|0;pTa(v);i=g;return u|0}}}while(0);fTa(b+56|0)|0;t=b+76|0;e=b+80|0;n=c[e>>2]|0;p=S5a(b+16|0,j,h)|0;if((a[h>>0]|0)!=0|(p|0)==0)w=p+4|0;else{c[p>>2]=c[j>>2];j=p+4|0;c[j>>2]=0;w=j}c[w>>2]=n;if(l)c[d+12>>2]=n;c[k+4>>2]=1;c[k+12>>2]=-1;c[k+16>>2]=-1;c[k>>2]=d;c[k+8>>2]=f;f=c[e>>2]|0;if((c[b+84>>2]&2147483647)>>>0<=f>>>0){T5a(t,k)|0;u=n;v=c[m>>2]|0;pTa(v);i=g;return u|0}b=(c[t>>2]|0)+(f*20|0)|0;if(!b)x=f;else{c[b+0>>2]=c[k+0>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];c[b+16>>2]=c[k+16>>2];x=c[e>>2]|0}c[e>>2]=x+1;u=n;v=c[m>>2]|0;pTa(v);i=g;return u|0}function MJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;fTa(a+56|0)|0;c[b+8>>2]=a;ko[c[(c[b>>2]|0)+32>>2]&4095](b);g=a+60|0;oTa(c[g>>2]|0);h=a+76|0;j=a+80|0;k=b+12|0;c[k>>2]=c[j>>2];c[f+4>>2]=1;c[f+12>>2]=-1;c[f+16>>2]=-1;c[f>>2]=b;c[f+8>>2]=d;d=c[j>>2]|0;if((c[a+84>>2]&2147483647)>>>0<=d>>>0){T5a(h,f)|0;l=c[k>>2]|0;m=c[g>>2]|0;pTa(m);i=e;return l|0}a=(c[h>>2]|0)+(d*20|0)|0;if(!a)n=d;else{c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];c[a+16>>2]=c[f+16>>2];n=c[j>>2]|0}c[j>>2]=n+1;l=c[k>>2]|0;m=c[g>>2]|0;pTa(m);i=e;return l|0}function NJa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+60|0;oTa(c[e>>2]|0);if(OJa(a,c[b+12>>2]|0,0)|0){b=c[a+8>>2]|0;ko[c[(c[b>>2]|0)+12>>2]&4095](b)}pTa(c[e>>2]|0);i=d;return}function OJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+76|0;h=c[g>>2]|0;j=c[h+(d*20|0)+12>>2]|0;k=c[h+(d*20|0)>>2]|0;if(!k)l=0;else l=c[k+16>>2]|0;if((j|0)==-1){m=e;n=b+56|0;gTa(n)|0;i=f;return m|0}k=b+64|0;if(!l){d=e;o=h;p=j;while(1){q=c[k>>2]|0;r=q+(p<<3)|0;if(!(gTa(o+((c[r>>2]|0)*20|0)+4|0)|0))s=d|(HJa(b,c[r>>2]|0,d)|0);else s=d;r=c[q+(p<<3)+4>>2]|0;if((r|0)==-1){m=s;break}d=s;o=c[g>>2]|0;p=r}n=b+56|0;gTa(n)|0;i=f;return m|0}else{t=e;u=h;v=j;w=0}while(1){j=c[k>>2]|0;h=j+(v<<3)|0;e=c[h>>2]|0;p=c[u+(e*20|0)>>2]|0;do if((p|0)!=0?(c[u+(e*20|0)+8>>2]|0)==1:0){o=p+16|0;if(c[o>>2]|0){a[p+20>>0]=1;x=w;break}if(w){a[p+20>>0]=1;x=1;break}else{c[o>>2]=l;x=1;break}}else x=w;while(0);if(!(gTa(u+(e*20|0)+4|0)|0))y=t|(HJa(b,c[h>>2]|0,t)|0);else y=t;p=c[j+(v<<3)+4>>2]|0;if((p|0)==-1){m=y;break}t=y;u=c[g>>2]|0;v=p;w=x}n=b+56|0;gTa(n)|0;i=f;return m|0}function PJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=a+60|0;oTa(c[g>>2]|0);h=c[b+12>>2]|0;b=a+76|0;j=c[b>>2]|0;k=a+64|0;l=a+68|0;m=c[l>>2]|0;c[f>>2]=d;c[f+4>>2]=-1;if((c[a+72>>2]&2147483647)>>>0>m>>>0){a=(c[k>>2]|0)+(m<<3)|0;if(!a)n=m;else{o=f;p=c[o+4>>2]|0;q=a;c[q>>2]=c[o>>2];c[q+4>>2]=p;n=c[l>>2]|0}c[l>>2]=n+1}else U5a(k,f)|0;f=j+(h*20|0)+16|0;n=c[f>>2]|0;if((n|0)==-1){c[f>>2]=m;c[j+(h*20|0)+12>>2]=m;r=c[b>>2]|0;s=r+(d*20|0)+4|0;fTa(s)|0;t=c[g>>2]|0;pTa(t);i=e;return}else{c[(c[k>>2]|0)+(n<<3)+4>>2]=m;c[f>>2]=m;r=c[b>>2]|0;s=r+(d*20|0)+4|0;fTa(s)|0;t=c[g>>2]|0;pTa(t);i=e;return}}function QJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;g=a+60|0;oTa(c[g>>2]|0);h=a+76|0;j=c[h>>2]|0;k=a+64|0;l=b+12|0;b=a+68|0;m=c[b>>2]|0;c[f>>2]=c[l>>2];c[f+4>>2]=-1;if((c[a+72>>2]&2147483647)>>>0>m>>>0){a=(c[k>>2]|0)+(m<<3)|0;if(!a)n=m;else{o=f;p=c[o+4>>2]|0;q=a;c[q>>2]=c[o>>2];c[q+4>>2]=p;n=c[b>>2]|0}c[b>>2]=n+1}else U5a(k,f)|0;f=j+(d*20|0)+16|0;n=c[f>>2]|0;if((n|0)==-1){c[f>>2]=m;c[j+(d*20|0)+12>>2]=m;r=c[l>>2]|0;s=c[h>>2]|0;t=s+(r*20|0)+4|0;fTa(t)|0;u=c[g>>2]|0;pTa(u);i=e;return}else{c[(c[k>>2]|0)+(n<<3)+4>>2]=m;c[f>>2]=m;r=c[l>>2]|0;s=c[h>>2]|0;t=s+(r*20|0)+4|0;fTa(t)|0;u=c[g>>2]|0;pTa(u);i=e;return}}function RJa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+60|0;oTa(c[e>>2]|0);fTa((c[a+76>>2]|0)+(b*20|0)+4|0)|0;pTa(c[e>>2]|0);i=d;return}function SJa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+60|0;oTa(c[e>>2]|0);if((gTa((c[a+76>>2]|0)+(b*20|0)+4|0)|0)==0?HJa(a,b,0)|0:0){b=c[a+8>>2]|0;ko[c[(c[b>>2]|0)+12>>2]&4095](b)}pTa(c[e>>2]|0);i=d;return}function TJa(a,b){a=a|0;b=b|0;return c[(c[a+76>>2]|0)+(b*20|0)+4>>2]|0}function UJa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;if(!b){f=0;i=a;return f|0}g=mKa()|0;f=Bn[c[(c[g>>2]|0)+8>>2]&255](g,b,3653512,d,e)|0;i=a;return f|0}function VJa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!b){i=a;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,b);i=a;return}function WJa(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;return}function XJa(a){a=a|0;var b=0,d=0;b=i;d=(bKa()|0)+48|0;oTa(c[d>>2]|0);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;pTa(c[d>>2]|0);i=b;return}function YJa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(bKa()|0)+48|0;oTa(c[h>>2]|0);j=c[a>>2]|0;if(j)En[c[(c[j>>2]|0)+8>>2]&127](j,b,d,e,f);j=c[a+4>>2]|0;if(!j){k=c[h>>2]|0;pTa(k);i=g;return}En[c[(c[j>>2]|0)+8>>2]&127](j,b,d,e,f);k=c[h>>2]|0;pTa(k);i=g;return}function ZJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=(bKa()|0)+48|0;oTa(c[e>>2]|0);f=a+12|0;g=c[f>>2]&2147483647^2147483647;h=(da(g&0-g,125613361)|0)>>>27;g=c[425648+(h<<2)>>2]|0;if(h&30){j=-1;k=c[e>>2]|0;pTa(k);i=d;return j|0}c[a+(g<<2)>>2]=b;c[f>>2]=c[f>>2]|1<<g;f=a+8|0;c[f>>2]=(c[f>>2]|0)+1;j=g;k=c[e>>2]|0;pTa(k);i=d;return j|0}function _Ja(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;c[b>>2]=528256;h=b+4|0;c[h>>2]=d;c[b+8>>2]=528912;c[b+12>>2]=e;c[b+36>>2]=0;a[b+40>>0]=0;c[b+44>>2]=-1;e=b+48|0;d=c[(qTa()|0)>>2]|0;if(d){j=c[132074]|0;k=j+8|0;l=c[(c[k>>2]|0)+8>>2]|0;m=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[l&255](k,d,m?544576:544544,544464,111)|0;c[e>>2]=j;if(j)mTa(j)}else c[e>>2]=0;e=b+52|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+76>>2]=ea(.75);c[b+80>>2]=-1;c[b+84>>2]=0;c[b+88>>2]=0;V5a(e,64);e=b+92|0;j=c[(qTa()|0)>>2]|0;if(j){m=c[132074]|0;d=m+8|0;k=c[(c[d>>2]|0)+8>>2]|0;l=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;m=Bn[k&255](d,j,l?544576:544544,544464,111)|0;c[e>>2]=m;if(m)mTa(m)}else c[e>>2]=0;c[b+96>>2]=0;c[b+100>>2]=0;c[b+104>>2]=0;e=b+108|0;m=c[(qTa()|0)>>2]|0;if(!m){c[e>>2]=0;n=b+116|0;WJa(n);o=c[h>>2]|0;ZJa(n,o)|0;i=f;return}l=c[132074]|0;j=l+8|0;d=c[(c[j>>2]|0)+8>>2]|0;k=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[d&255](j,m,k?544576:544544,544464,111)|0;c[e>>2]=l;if(!l){n=b+116|0;WJa(n);o=c[h>>2]|0;ZJa(n,o)|0;i=f;return}mTa(l);n=b+116|0;WJa(n);o=c[h>>2]|0;ZJa(n,o)|0;i=f;return}function $Ja(a){a=a|0;var b=0;b=i;aKa(a);ACi(a);i=b;return}function aKa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b;e=b+4|0;c[a>>2]=528256;f=a+96|0;g=a+100|0;h=c[g>>2]|0;if(h){j=h;h=0;while(1){k=c[(c[f>>2]|0)+(h<<2)>>2]|0;if(!k)l=j;else{m=k;do{k=m;m=c[m>>2]|0;VJa(e,k)}while((m|0)!=0);l=c[g>>2]|0}h=h+1|0;if(h>>>0>=l>>>0)break;else j=l}}c[d>>2]=0;W5a(f,0,d);X5a(f,c[g>>2]|0);XJa(a+116|0);g=a+108|0;nTa(c[g>>2]|0);d=c[g>>2]|0;if(d){g=(c[132074]|0)+8|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,d)}d=c[a+104>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1)VJa(f,c[f>>2]|0);f=a+92|0;nTa(c[f>>2]|0);d=c[f>>2]|0;if(d){f=(c[132074]|0)+8|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}d=c[a+52>>2]|0;if(d){f=c[132074]|0;g=mo[c[(c[f>>2]|0)+20>>2]&4095](f)|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,d)}d=a+48|0;nTa(c[d>>2]|0);a=c[d>>2]|0;if(!a){i=b;return}d=(c[132074]|0)+8|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function bKa(){return c[132074]|0}function cKa(a){a=a|0;return c[a+12>>2]|0}function dKa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;c[j>>2]=g;eKa(a,b,d,e,f,j);i=h;return}function eKa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+176|0;j=h+2|0;k=h+1|0;l=h;if(!(c[a+44>>2]&b)){i=h;return}m=a+48|0;oTa(c[m>>2]|0);if((uEi(j,161,f,g)|0)<0){n=161;o=0;while(1){VJa(k,o);n=n<<1;p=c[132074]|0;q=p+8|0;r=c[(c[q>>2]|0)+8>>2]|0;s=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[r&255](q,n|1,s?528936:544544,528312,139)|0;if(!((uEi(p,n,f,g)|0)<0&(n|0)<1e6)){t=p;u=p;break}else o=p}}else{t=0;u=j}YJa(a+116|0,b,u,d,e);VJa(l,t);pTa(c[m>>2]|0);i=h;return}function fKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;if((a|0)!=50528512){g=zCi(256)|0;c[f>>2]=50528512;c[f+4>>2]=a;TUa(g,0,528392,f)|0;En[c[(c[b>>2]|0)+8>>2]&127](b,4,g,528312,155);h=0;i=e;return h|0}if(c[132074]|0){En[c[(c[b>>2]|0)+8>>2]&127](b,8,528536,528312,186);h=0;i=e;return h|0}g=Bn[c[(c[d>>2]|0)+8>>2]&255](d,132,528464,528312,165)|0;c[132074]=g;if(!g){En[c[(c[b>>2]|0)+8>>2]&127](b,32,528488,528312,181);h=0;i=e;return h|0}else{_Ja(g,b,d);c[132120]=1;d=c[132076]|0;c[132076]=(d|0)==-1?1:d+1|0;h=c[132074]|0;i=e;return h|0}return 0}function gKa(){var a=0,b=0;a=i;i=i+16|0;b=c[132120]|0;if(!b){dKa(c[132074]|0,8,528312,220,528728,a);i=a;return}else{c[132120]=b+1;i=a;return}}function hKa(){var a=0,b=0;a=i;i=i+16|0;b=c[132120]|0;if(!b){dKa(c[132074]|0,8,528312,234,528776,a);i=a;return}else{c[132120]=b+-1;i=a;return}}function iKa(a){a=a|0;var b=0,d=0;a=i;i=i+16|0;b=c[132074]|0;if((c[132120]|0)==1){d=c[b+12>>2]|0;ko[c[(c[b>>2]|0)+32>>2]&4095](b);In[c[(c[d>>2]|0)+12>>2]&4095](d,c[132074]|0);c[132074]=0;c[132120]=0;i=a;return}else{dKa(b,8,528312,206,528616,a);i=a;return}}function jKa(a){a=a|0;return c[a+4>>2]|0}function kKa(a,b){a=a|0;b=b|0;c[a+44>>2]=b;return}function lKa(a){a=a|0;return c[a+44>>2]|0}function mKa(){return (c[132074]|0)+8|0}function nKa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=c[a+4>>2]|0;k=Bn[c[(c[j>>2]|0)+8>>2]&255](j,b,d,e,f)|0;if(!k)dKa(c[132074]|0,64,528312,268,528824,h);if(k&15){dKa(c[132074]|0,64,528312,282,528856,h);l=0;i=g;return l|0}h=c[a+28>>2]|0;if(!h){l=k;i=g;return l|0}else m=0;do{j=c[a+(m<<2)+8>>2]|0;rn[c[(c[j>>2]|0)+8>>2]&127](j,b,d,e,f,k);m=m+1|0}while((m|0)!=(h|0));l=k;i=g;return l|0}function oKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=fKa(a,c,b)|0;i=d;return e|0}function pKa(){return c[132074]|0}function qKa(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=0,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0;c=i;d=ea(g[b>>2]);e=ea(d*d);d=ea(g[b+4>>2]);f=ea(e+ea(d*d));d=ea(g[b+8>>2]);e=ea(f+ea(d*d));d=ea(g[b+12>>2]);f=ea(d*d);d=ea(g[b+16>>2]);h=ea(f+ea(d*d));d=ea(g[b+20>>2]);f=ea(h+ea(d*d));d=ea(g[b+24>>2]);h=ea(d*d);d=ea(g[b+28>>2]);j=ea(h+ea(d*d));d=ea(g[b+32>>2]);h=ea(j+ea(d*d));g[a>>2]=e;g[a+4>>2]=f;g[a+8>>2]=h;k=f>e&1;l=k^1;m=h>ea(g[a+(l<<2)>>2]);n=m?2:l;l=(k^3)-n|0;h=ea(g[a+(k<<2)>>2]);m=h<ea(g[a+(n<<2)>>2]);o=m?n:k;p=m?k:n;n=a+(o<<2)|0;h=ea(g[n>>2]);e=ea(ea(1.0)/ea(T(ea(h))));f=ea(h*e);k=b+(o*12|0)|0;h=ea(e*ea(g[k>>2]));g[k>>2]=h;m=b+(o*12|0)+4|0;d=ea(e*ea(g[m>>2]));g[m>>2]=d;q=b+(o*12|0)+8|0;j=ea(e*ea(g[q>>2]));g[q>>2]=j;o=b+(p*12|0)|0;e=ea(g[o>>2]);r=ea(h*e);s=b+(p*12|0)+4|0;t=ea(g[s>>2]);u=ea(r+ea(d*t));v=b+(p*12|0)+8|0;r=ea(g[v>>2]);w=ea(u+ea(j*r));x=b+(l*12|0)|0;u=ea(h*ea(g[x>>2]));y=b+(l*12|0)+4|0;z=ea(u+ea(d*ea(g[y>>2])));A=b+(l*12|0)+8|0;u=ea(z+ea(j*ea(g[A>>2])));g[n>>2]=ea(f+ea(ea(S(ea(w)))+ea(S(ea(u)))));f=ea(w*d);d=ea(w*j);g[o>>2]=ea(e-ea(w*h));g[s>>2]=ea(t-f);g[v>>2]=ea(r-d);d=ea(u*ea(g[k>>2]));r=ea(u*ea(g[m>>2]));f=ea(u*ea(g[q>>2]));u=ea(ea(g[x>>2])-d);g[x>>2]=u;d=ea(ea(g[y>>2])-r);g[y>>2]=d;r=ea(ea(g[A>>2])-f);g[A>>2]=r;f=ea(g[o>>2]);t=ea(f*f);h=ea(g[s>>2]);w=ea(t+ea(h*h));t=ea(g[v>>2]);e=ea(T(ea(w+ea(t*t))));if(e>ea(0.0)){w=ea(ea(1.0)/e);j=ea(f*w);g[o>>2]=j;z=ea(h*w);g[s>>2]=z;B=ea(t*w);g[v>>2]=B;w=ea(g[x>>2]);C=ea(g[y>>2]);D=j;E=w;F=z;G=C;H=B;I=ea(g[A>>2])}else{D=f;E=u;F=h;G=d;H=t;I=r}r=ea(ea(ea(D*E)+ea(F*G))+ea(H*I));g[a+(p<<2)>>2]=ea(e+ea(S(ea(r))));e=ea(r*F);F=ea(r*H);H=ea(E-ea(D*r));g[x>>2]=H;r=ea(G-e);g[y>>2]=r;e=ea(I-F);g[A>>2]=e;F=ea(T(ea(ea(e*e)+ea(ea(H*H)+ea(r*r)))));if(!(F>ea(0.0))){J=a+(l<<2)|0;g[J>>2]=F;i=c;return}I=ea(ea(1.0)/F);g[x>>2]=ea(H*I);g[y>>2]=ea(r*I);g[A>>2]=ea(e*I);J=a+(l<<2)|0;g[J>>2]=F;i=c;return}function rKa(a,b,c,d){a=a|0;b=ea(b);c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;e=i;f=ea(g[c>>2]);h=ea(g[d>>2]);j=ea(f*h);k=ea(g[c+4>>2]);l=ea(g[d+4>>2]);m=ea(j+ea(k*l));j=ea(g[c+8>>2]);n=ea(g[d+8>>2]);o=ea(m+ea(j*n));m=ea(g[c+12>>2]);p=ea(g[d+12>>2]);q=ea(o+ea(m*p));if(q<ea(0.0)){r=ea(-q);s=ea(-1.0)}else{r=q;s=ea(1.0)}q=ea(ea(1.0)-ea(r*r));if(!(q>=ea(1.00000002e-16))){g[a>>2]=f;g[a+4>>2]=k;g[a+8>>2]=j;g[a+12>>2]=m;i=e;return}else{o=ea(T(ea(q)));q=ea(+$(+(+o),+(+r)));r=ea(ea(1.0)/o);o=ea(r*ea(+W(+ea(ea(ea(1.0)-b)*q))));t=ea(s*ea(r*ea(+W(+ea(q*b)))));b=ea(ea(o*k)+ea(t*l));l=ea(ea(o*j)+ea(t*n));n=ea(ea(o*m)+ea(t*p));g[a>>2]=ea(ea(o*f)+ea(t*h));g[a+4>>2]=b;g[a+8>>2]=l;g[a+12>>2]=n;i=e;return}}function sKa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;if(!b){g=0;i=f;return g|0}h=b+3|0;j=h>>>1|h;h=j>>>2|j;j=h>>>4|h;h=j>>>8|j;j=c[482792+((da(h>>>16|h,130329821)|0)>>>27<<2)>>2]|0;h=j>>>0<8?8:j;if(h>>>0<17){j=(bKa()|0)+108|0;oTa(c[j>>2]|0);k=c[(bKa()|0)+96>>2]|0;l=k+(h+-8<<2)|0;m=k+(h+-5<<2)|0;k=bKa()|0;n=(c[k+96>>2]|0)+(c[k+100>>2]<<2)|0;k=m>>>0<n>>>0?m:n;a:do if(l>>>0<k>>>0){n=l;while(1){o=c[n>>2]|0;m=n+4|0;if(o)break;if(m>>>0<k>>>0)n=m;else{p=7;break a}}c[n>>2]=c[o>>2];q=(n-(c[(bKa()|0)+96>>2]|0)>>2)+8|0;r=o}else p=7;while(0);if((p|0)==7){q=h;r=UJa(a,2<<h,d,e)|0}pTa(c[j>>2]|0);s=q;t=r}else{s=h;t=UJa(a,b+4|0,d,e)|0}c[t>>2]=s;g=t+4|0;i=f;return g|0}function tKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;if(!b){i=d;return}f=b+-4|0;b=c[f>>2]|0;if(b>>>0>16){VJa(a,f);i=d;return}a=(bKa()|0)+108|0;oTa(c[a>>2]|0);g=b+-8|0;if((c[(bKa()|0)+100>>2]|0)>>>0<=g>>>0){h=(bKa()|0)+96|0;c[e>>2]=0;W5a(h,b+-7|0,e)}c[f>>2]=c[(c[(bKa()|0)+96>>2]|0)+(g<<2)>>2];c[(c[(bKa()|0)+96>>2]|0)+(g<<2)>>2]=f;pTa(c[a>>2]|0);i=d;return}function uKa(a,b){a=a|0;b=b|0;var d=0,e=0;b=536560;d=c[b+4>>2]|0;e=a;c[e>>2]=c[b>>2];c[e+4>>2]=d;return}function vKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=0,l=Im,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im;e=i;f=ea(g[c>>2]);h=ea(g[b>>2]);j=ea(f-h);k=c+4|0;l=ea(g[k>>2]);m=b+4|0;n=ea(g[m>>2]);o=ea(l-n);p=c+8|0;q=ea(g[p>>2]);r=b+8|0;s=ea(g[r>>2]);t=ea(q-s);u=ea(T(ea(ea(ea(j*j)+ea(o*o))+ea(t*t))));if(!d){v=f;w=h;x=l;y=n;z=q;A=s}else{g[d>>2]=ea(u*ea(.5));s=ea(g[c>>2]);q=ea(g[b>>2]);n=ea(g[k>>2]);l=ea(g[m>>2]);h=ea(g[p>>2]);v=s;w=q;x=n;y=l;z=h;A=ea(g[r>>2])}h=ea(ea(v+w)*ea(.5));w=ea(ea(x+y)*ea(.5));y=ea(ea(z+A)*ea(.5));if(u<ea(9.99999997e-07)){B=ea(0.0);C=ea(0.0);D=ea(0.0);E=ea(1.0);g[a>>2]=B;F=a+4|0;g[F>>2]=C;G=a+8|0;g[G>>2]=D;H=a+12|0;g[H>>2]=E;I=a+16|0;g[I>>2]=h;J=a+20|0;g[J>>2]=w;K=a+24|0;g[K>>2]=y;i=e;return}A=ea(ea(1.0)/u);u=ea(j*A);j=ea(o*A);o=ea(t*A);A=ea(j*ea(0.0));t=ea(o*ea(0.0));z=ea(t+ea(u+A));if(!(z>ea(-1.0)))if(ea(S(ea(1.0)))<ea(.100000001)){L=ea(0.0);M=ea(0.0);N=ea(-0.0);O=ea(0.0)}else{L=ea(0.0);M=ea(-1.0);N=ea(0.0);O=ea(0.0)}else{x=ea(u*ea(0.0));L=ea(t-A);M=ea(x-o);N=ea(j-x);O=ea(z+ea(1.0))}z=ea(ea(1.0)/ea(T(ea(ea(O*O)+ea(ea(N*N)+ea(ea(M*M)+ea(L*L)))))));B=ea(L*z);C=ea(M*z);D=ea(N*z);E=ea(O*z);g[a>>2]=B;F=a+4|0;g[F>>2]=C;G=a+8|0;g[G>>2]=D;H=a+12|0;g[H>>2]=E;I=a+16|0;g[I>>2]=h;J=a+20|0;g[J>>2]=w;K=a+24|0;g[K>>2]=y;i=e;return}function wKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=Im,ra=Im,sa=Im,ta=Im;d=i;i=i+64|0;e=d+40|0;f=d;h=ea(g[b>>2]);j=ea(g[b+4>>2]);k=ea(g[b+8>>2]);l=ea(g[b+12>>2]);m=ea(g[b+16>>2]);n=ea(g[b+20>>2]);o=ea(g[b+24>>2]);p=ea(g[b+28>>2]);q=ea(g[b+32>>2]);b=f+4|0;r=f+8|0;s=f+12|0;t=f+16|0;u=f+20|0;v=f+24|0;w=f+28|0;x=f+32|0;y=e+4|0;z=e+8|0;A=e+12|0;B=e+4|0;C=e+8|0;D=e+12|0;E=ea(0.0);F=ea(0.0);G=ea(0.0);H=ea(1.0);I=0;while(1){J=ea(E+E);K=ea(F+F);L=ea(G+G);M=ea(F*K);N=ea(G*L);O=ea(F*J);P=ea(G*J);Q=ea(H*J);R=ea(G*K);U=ea(H*K);K=ea(H*L);L=ea(ea(ea(1.0)-M)-N);V=ea(K+O);W=ea(P-U);X=ea(O-K);K=ea(ea(1.0)-ea(E*J));J=ea(K-N);N=ea(R+Q);O=ea(U+P);P=ea(R-Q);Q=ea(K-M);M=ea(ea(ea(L*h)+ea(V*j))+ea(W*k));K=ea(ea(ea(X*h)+ea(J*j))+ea(N*k));R=ea(ea(ea(O*h)+ea(P*j))+ea(Q*k));U=ea(ea(ea(L*l)+ea(V*m))+ea(W*n));Y=ea(ea(ea(X*l)+ea(J*m))+ea(N*n));Z=ea(ea(ea(O*l)+ea(P*m))+ea(Q*n));_=ea(ea(ea(L*o)+ea(V*p))+ea(W*q));$=ea(ea(ea(X*o)+ea(J*p))+ea(N*q));aa=ea(ea(ea(O*o)+ea(P*p))+ea(Q*q));ba=ea(ea(ea(L*M)+ea(V*U))+ea(W*_));ca=ea(ea(ea(L*K)+ea(V*Y))+ea(W*$));da=ea(ea(ea(L*R)+ea(V*Z))+ea(W*aa));W=ea(ea(ea(X*M)+ea(J*U))+ea(N*_));fa=ea(ea(ea(X*K)+ea(J*Y))+ea(N*$));V=ea(ea(ea(X*R)+ea(J*Z))+ea(N*aa));N=ea(ea(ea(O*M)+ea(P*U))+ea(Q*_));_=ea(ea(ea(O*K)+ea(P*Y))+ea(Q*$));ga=ea(ea(ea(O*R)+ea(P*Z))+ea(Q*aa));g[f>>2]=ba;g[b>>2]=ca;g[r>>2]=da;g[s>>2]=W;g[t>>2]=fa;g[u>>2]=V;g[v>>2]=N;g[w>>2]=_;g[x>>2]=ga;_=ea(S(ea(V)));V=ea(S(ea(da)));da=ea(S(ea(ca)));if(_>V&_>da)ha=0;else ha=V>da?1:2;ia=ha+1+(ha>>>1)|0;ja=ia&3;ka=ia+1+(ja>>>1)&3;ia=f+(ja*12|0)|0;da=ea(g[ia+(ka<<2)>>2]);if(da==ea(0.0)){la=H;ma=G;na=F;oa=E;pa=10;break}V=ea(g[ia+(ja<<2)>>2]);_=ea(V-ea(g[f+(ka*12|0)+(ka<<2)>>2]));V=ea(da*ea(2.0));if(+ea(S(ea(_)))>+ea(S(ea(V)))*2.0e6){la=H;ma=G;na=F;oa=E;pa=10;break}da=ea(_/V);V=ea(S(ea(da)));if(V>ea(1.0e3)){_=ea(ea(1.0)/ea(da*ea(4.0)));g[e>>2]=ea(0.0);g[y>>2]=ea(0.0);g[z>>2]=ea(0.0);g[A>>2]=ea(1.0);g[e+(ha<<2)>>2]=_;_=ea(g[e>>2]);ca=ea(g[y>>2]);N=ea(g[z>>2]);qa=_;ra=ea(g[A>>2]);sa=N;ta=ca}else{ca=ea(ea(1.0)/ea(V+ea(T(ea(ea(da*da)+ea(1.0))))));V=ea(ea(1.0)/ea(T(ea(ea(ca*ca)+ea(1.0)))));ca=ea(T(ea(ea(ea(1.0)-V)*ea(.5))));ka=da>=ea(0.0);da=ea((ka?ea(1.0):ea(-1.0))*ca);ca=ea(T(ea(ea(V+ea(1.0))*ea(.5))));g[e>>2]=ea(0.0);g[B>>2]=ea(0.0);g[C>>2]=ea(0.0);g[D>>2]=ca;g[e+(ha<<2)>>2]=da;da=ea(g[e>>2]);ca=ea(g[B>>2]);V=ea(g[C>>2]);qa=da;ra=ea(g[D>>2]);sa=V;ta=ca}ca=ea(ea(ea(F*sa)+ea(ea(E*ra)+ea(H*qa)))-ea(G*ta));V=ea(ea(ea(ea(F*ra)+ea(H*ta))+ea(G*qa))-ea(E*sa));da=ea(ea(ea(E*ta)+ea(ea(G*ra)+ea(H*sa)))-ea(F*qa));N=ea(ea(ea(ea(H*ra)-ea(E*qa))-ea(F*ta))-ea(G*sa));_=ea(ea(1.0)/ea(T(ea(ea(N*N)+ea(ea(da*da)+ea(ea(V*V)+ea(ca*ca)))))));W=ea(_*ca);ca=ea(_*V);V=ea(da*_);da=ea(_*N);I=I+1|0;if(I>>>0>=24){la=da;ma=V;na=ca;oa=W;pa=10;break}else{E=W;F=ca;G=V;H=da}}if((pa|0)==10){g[c>>2]=oa;g[c+4>>2]=na;g[c+8>>2]=ma;g[c+12>>2]=la;g[a>>2]=ba;g[a+4>>2]=fa;g[a+8>>2]=ga;i=d;return}}function xKa(d){d=d|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=d+4|0;if((e[h>>1]|0)>1?(a[d+6>>0]|0)!=0:0){VJa(g,c[d>>2]|0);c[d>>2]=0}b[h>>1]=0;c[d>>2]=0;i=f;return}function yKa(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g+10|0;j=g+9|0;k=g;l=g+8|0;m=d+4|0;n=b[m>>1]|0;if(n<<16>>16==1)o=d;else if(!(n<<16>>16)){a[d+7>>0]=1;c[d>>2]=f;b[m>>1]=1;i=g;return}else o=c[d>>2]|0;p=(n&65535)+1|0;q=p<<2;r=q>>>0>1024;s=k+4|0;a[s>>0]=r&1;if(r){r=sKa(l,q,536872,83)|0;c[k>>2]=r;t=b[m>>1]|0;u=r}else{r=i;i=i+((4*p|0)+15&-16)|0;c[k>>2]=r;t=n;u=r}YEi(u|0,o|0,(t&65535)<<2|0)|0;t=b[m>>1]|0;o=t&65535;c[(c[k>>2]|0)+(o<<2)>>2]=f;f=c[k>>2]|0;if(!((t&65535)<2|(o|0)==(p|0))?(a[d+6>>0]|0)!=0:0){VJa(h,c[d>>2]|0);c[d>>2]=0}h=d+7|0;if(p>>>0>1){a[h>>0]=0;if((e[m>>1]|0)==(p|0))v=c[d>>2]|0;else{o=UJa(j,q,536872,64)|0;c[d>>2]=o;a[d+6>>0]=1;v=o}YEi(v|0,f|0,q|0)|0}else{a[h>>0]=1;c[d>>2]=c[f>>2]}b[m>>1]=p;if(!(a[s>>0]|0)){i=g;return}tKa(k,c[k>>2]|0);i=g;return}function zKa(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b[a+4>>1]|0;g=f&65535;if(f<<16>>16!=1)if(!(f<<16>>16))h=-1;else{j=c[a>>2]|0;k=4}else{j=a;k=4}a:do if((k|0)==4){a=0;while(1){if((c[j+(a<<2)>>2]|0)==(d|0)){h=a;break a}a=a+1|0;if(a>>>0>=g>>>0){h=-1;break}}}while(0);i=e;return h|0}function AKa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=d+4|0;j=b[h>>1]|0;if(j<<16>>16!=1){k=c[d>>2]|0;if((j&65535)>2){l=j+-1<<16>>16;b[h>>1]=l;c[k+(e<<2)>>2]=c[k+((l&65535)<<2)>>2];i=f;return}if(j<<16>>16==2){j=c[k+(1-e<<2)>>2]|0;if(a[d+6>>0]|0){VJa(g,k);c[d>>2]=0}a[d+7>>0]=1;c[d>>2]=j;b[h>>1]=1;i=f;return}}b[h>>1]=0;c[d>>2]=0;i=f;return}function BKa(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;f=a+4|0;if((e[f>>1]|0)<=1){i=d;return}In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a>>2]|0,(e[f>>1]|0)<<2);i=d;return}function CKa(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+32>>2]=0;return a|0}function DKa(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return a|0}function EKa(a,b){a=a|0;b=b|0;g[a+36>>2]=ea(g[b>>2]);g[a+40>>2]=ea(g[b+4>>2]);g[a+44>>2]=ea(g[b+8>>2]);g[a+48>>2]=ea(g[b+12>>2]);g[a+52>>2]=ea(g[b+16>>2]);g[a+56>>2]=ea(g[b+20>>2]);g[a+60>>2]=ea(g[b+24>>2]);g[a+64>>2]=ea(g[b+28>>2]);g[a+68>>2]=ea(g[b+32>>2]);g[a+72>>2]=ea(g[b+36>>2]);g[a+76>>2]=ea(g[b+40>>2]);g[a+80>>2]=ea(g[b+44>>2]);g[a+84>>2]=ea(g[b+48>>2]);g[a+88>>2]=ea(g[b+52>>2]);g[a+92>>2]=ea(g[b+56>>2]);g[a+96>>2]=ea(g[b+60>>2]);return a|0}function FKa(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(g[b+12>>2]);h=ea(c+c);i=ea(d+d);j=ea(e+e);k=ea(d*i);l=ea(e*j);m=ea(h*d);d=ea(h*e);n=ea(h*f);o=ea(i*e);e=ea(i*f);i=ea(j*f);f=ea(ea(ea(1.0)-k)-l);j=ea(m+i);p=ea(d-e);q=ea(m-i);i=ea(ea(1.0)-ea(c*h));h=ea(i-l);l=ea(o+n);c=ea(d+e);e=ea(o-n);n=ea(i-k);k=ea(g[b+16>>2]);i=ea(g[b+20>>2]);o=ea(g[b+24>>2]);g[a+36>>2]=f;g[a+40>>2]=j;g[a+44>>2]=p;g[a+48>>2]=ea(0.0);g[a+52>>2]=q;g[a+56>>2]=h;g[a+60>>2]=l;g[a+64>>2]=ea(0.0);g[a+68>>2]=c;g[a+72>>2]=e;g[a+76>>2]=n;g[a+80>>2]=ea(0.0);g[a+84>>2]=k;g[a+88>>2]=i;g[a+92>>2]=o;g[a+96>>2]=ea(1.0);return a|0}function GKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+176|0;e=d+160|0;f=d+128|0;h=d+96|0;j=d+48|0;k=d;l=ea(g[b>>2]);m=b+4|0;n=ea(g[m>>2]);o=b+8|0;p=ea(g[o>>2]);q=ea(l*ea(g[a+36>>2]));r=ea(l*ea(g[a+40>>2]));s=ea(l*ea(g[a+44>>2]));l=ea(n*ea(g[a+52>>2]));t=ea(n*ea(g[a+56>>2]));u=ea(q+l);l=ea(r+t);t=ea(s+ea(n*ea(g[a+60>>2])));n=ea(p*ea(g[a+68>>2]));s=ea(p*ea(g[a+72>>2]));r=ea(u+n);n=ea(l+s);s=ea(t+ea(p*ea(g[a+76>>2])));p=ea(g[a+84>>2]);t=ea(g[a+88>>2]);l=ea(r+p);p=ea(n+t);t=ea(s+ea(g[a+92>>2]));g[b>>2]=l;g[m>>2]=p;g[o>>2]=t;v=a+32|0;w=(c[v>>2]|0)+1|0;c[v>>2]=w;a:do switch(c[a>>2]|0){case 2:{if(w>>>0>1){x=c[a+100>>2]|0;y=x+16|0;s=ea(g[a+8>>2]);g[h>>2]=s;n=ea(g[a+12>>2]);g[h+4>>2]=n;r=ea(g[a+16>>2]);g[h+8>>2]=r;z=c[a+4>>2]|0;c[h+12>>2]=z;g[h+16>>2]=l;g[h+20>>2]=p;g[h+24>>2]=t;c[h+28>>2]=z;A=x+20|0;B=c[A>>2]|0;if((c[x+24>>2]&2147483647)>>>0<=B>>>0){Z5a(y,h)|0;C=33;break a}x=c[y>>2]|0;y=x+(B<<5)|0;if(!y)D=B;else{g[y>>2]=s;g[x+(B<<5)+4>>2]=n;g[x+(B<<5)+8>>2]=r;c[x+(B<<5)+12>>2]=z;g[x+(B<<5)+16>>2]=l;g[x+(B<<5)+20>>2]=p;g[x+(B<<5)+24>>2]=t;c[x+(B<<5)+28>>2]=z;D=c[A>>2]|0}c[A>>2]=D+1;C=33}else C=33;break}case 0:{A=c[a+100>>2]|0;z=A+4|0;g[e>>2]=l;g[e+4>>2]=p;g[e+8>>2]=t;B=c[a+4>>2]|0;c[e+12>>2]=B;x=A+8|0;y=c[x>>2]|0;if((c[A+12>>2]&2147483647)>>>0<=y>>>0){Y5a(z,e)|0;C=33;break a}A=c[z>>2]|0;z=A+(y<<4)|0;if(!z)E=y;else{g[z>>2]=l;g[A+(y<<4)+4>>2]=p;g[A+(y<<4)+8>>2]=t;c[A+(y<<4)+12>>2]=B;E=c[x>>2]|0}c[x>>2]=E+1;C=33;break}case 4:{if(w>>>0>2){x=c[a+100>>2]|0;B=x+28|0;y=(w&1|0)!=0;A=a+8|0;z=a+20|0;F=y?A:z;G=y?z:A;r=ea(g[F>>2]);g[k>>2]=r;n=ea(g[F+4>>2]);g[k+4>>2]=n;s=ea(g[F+8>>2]);g[k+8>>2]=s;F=c[a+4>>2]|0;c[k+12>>2]=F;u=ea(g[G>>2]);g[k+16>>2]=u;q=ea(g[G+4>>2]);g[k+20>>2]=q;H=ea(g[G+8>>2]);g[k+24>>2]=H;c[k+28>>2]=F;g[k+32>>2]=l;g[k+36>>2]=p;g[k+40>>2]=t;c[k+44>>2]=F;G=x+32|0;A=c[G>>2]|0;if((c[x+36>>2]&2147483647)>>>0<=A>>>0){_5a(B,k)|0;C=33;break a}x=c[B>>2]|0;B=x+(A*48|0)|0;if(!B)I=A;else{g[B>>2]=r;g[x+(A*48|0)+4>>2]=n;g[x+(A*48|0)+8>>2]=s;c[x+(A*48|0)+12>>2]=F;g[x+(A*48|0)+16>>2]=u;g[x+(A*48|0)+20>>2]=q;g[x+(A*48|0)+24>>2]=H;c[x+(A*48|0)+28>>2]=F;g[x+(A*48|0)+32>>2]=l;g[x+(A*48|0)+36>>2]=p;g[x+(A*48|0)+40>>2]=t;c[x+(A*48|0)+44>>2]=F;I=c[G>>2]|0}c[G>>2]=I+1;C=33}else C=33;break}case 1:{if((w|0)==2){G=c[a+100>>2]|0;F=G+16|0;A=a+8|0;H=ea(g[A>>2]);g[f>>2]=H;x=a+12|0;q=ea(g[x>>2]);g[f+4>>2]=q;B=a+16|0;u=ea(g[B>>2]);g[f+8>>2]=u;z=c[a+4>>2]|0;c[f+12>>2]=z;g[f+16>>2]=l;g[f+20>>2]=p;g[f+24>>2]=t;c[f+28>>2]=z;y=G+20|0;J=c[y>>2]|0;if((c[G+24>>2]&2147483647)>>>0>J>>>0){G=c[F>>2]|0;K=G+(J<<5)|0;if(!K)L=J;else{g[K>>2]=H;g[G+(J<<5)+4>>2]=q;g[G+(J<<5)+8>>2]=u;c[G+(J<<5)+12>>2]=z;g[G+(J<<5)+16>>2]=l;g[G+(J<<5)+20>>2]=p;g[G+(J<<5)+24>>2]=t;c[G+(J<<5)+28>>2]=z;L=c[y>>2]|0}c[y>>2]=L+1}else Z5a(F,f)|0;c[v>>2]=0;M=x;N=B;O=A}else C=33;break}case 3:{if((w|0)==3){A=c[a+100>>2]|0;B=A+28|0;u=ea(g[a+20>>2]);g[j>>2]=u;q=ea(g[a+24>>2]);g[j+4>>2]=q;H=ea(g[a+28>>2]);g[j+8>>2]=H;x=c[a+4>>2]|0;c[j+12>>2]=x;F=a+8|0;s=ea(g[F>>2]);g[j+16>>2]=s;y=a+12|0;n=ea(g[y>>2]);g[j+20>>2]=n;z=a+16|0;r=ea(g[z>>2]);g[j+24>>2]=r;c[j+28>>2]=x;g[j+32>>2]=l;g[j+36>>2]=p;g[j+40>>2]=t;c[j+44>>2]=x;J=A+32|0;G=c[J>>2]|0;if((c[A+36>>2]&2147483647)>>>0>G>>>0){A=c[B>>2]|0;K=A+(G*48|0)|0;if(!K)P=G;else{g[K>>2]=u;g[A+(G*48|0)+4>>2]=q;g[A+(G*48|0)+8>>2]=H;c[A+(G*48|0)+12>>2]=x;g[A+(G*48|0)+16>>2]=s;g[A+(G*48|0)+20>>2]=n;g[A+(G*48|0)+24>>2]=r;c[A+(G*48|0)+28>>2]=x;g[A+(G*48|0)+32>>2]=l;g[A+(G*48|0)+36>>2]=p;g[A+(G*48|0)+40>>2]=t;c[A+(G*48|0)+44>>2]=x;P=c[J>>2]|0}c[J>>2]=P+1}else _5a(B,j)|0;c[v>>2]=0;M=y;N=z;O=F}else C=33;break}default:{Q=w;C=34}}while(0);if((C|0)==33){Q=c[v>>2]|0;C=34}do if((C|0)==34){v=a+8|0;if(Q>>>0<=1){M=a+12|0;N=a+16|0;O=v;break}g[a+20>>2]=ea(g[v>>2]);w=a+12|0;g[a+24>>2]=ea(g[w>>2]);j=a+16|0;g[a+28>>2]=ea(g[j>>2]);g[v>>2]=ea(g[b>>2]);g[w>>2]=ea(g[m>>2]);g[j>>2]=ea(g[o>>2]);i=d;return a|0}while(0);g[O>>2]=ea(g[b>>2]);g[M>>2]=ea(g[m>>2]);g[N>>2]=ea(g[o>>2]);i=d;return a|0}function HKa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=Im,O=0,P=Im;e=i;i=i+368|0;f=e+168|0;h=e+156|0;j=e+132|0;k=e+324|0;l=e+300|0;m=e+48|0;n=e+60|0;o=e+72|0;p=e+84|0;q=e+96|0;r=e+108|0;s=e+264|0;t=e+288|0;u=e+312|0;v=e+336|0;w=e+348|0;x=e+180|0;y=e+192|0;z=e+204|0;A=e+216|0;B=e+228|0;C=e+240|0;D=e+36|0;E=e+24|0;F=e;G=e+12|0;H=e+252|0;I=e+120|0;J=e+276|0;K=e+144|0;if(!(a[d+24>>0]|0)){c[b>>2]=4;c[b+32>>2]=0;L=ea(g[d>>2]);M=d+4|0;N=ea(g[M>>2]);O=d+8|0;P=ea(g[O>>2]);g[x>>2]=L;g[x+4>>2]=N;g[x+8>>2]=P;GKa(b,x)|0;P=ea(g[d>>2]);x=d+16|0;N=ea(g[x>>2]);L=ea(g[O>>2]);g[y>>2]=P;g[y+4>>2]=N;g[y+8>>2]=L;GKa(b,y)|0;y=d+12|0;L=ea(g[y>>2]);N=ea(g[M>>2]);P=ea(g[O>>2]);g[z>>2]=L;g[z+4>>2]=N;g[z+8>>2]=P;GKa(b,z)|0;P=ea(g[y>>2]);N=ea(g[x>>2]);L=ea(g[O>>2]);g[A>>2]=P;g[A+4>>2]=N;g[A+8>>2]=L;GKa(b,A)|0;L=ea(g[y>>2]);N=ea(g[x>>2]);A=d+20|0;P=ea(g[A>>2]);g[B>>2]=L;g[B+4>>2]=N;g[B+8>>2]=P;GKa(b,B)|0;P=ea(g[d>>2]);N=ea(g[x>>2]);L=ea(g[O>>2]);g[C>>2]=P;g[C+4>>2]=N;g[C+8>>2]=L;GKa(b,C)|0;L=ea(g[d>>2]);N=ea(g[x>>2]);P=ea(g[A>>2]);g[D>>2]=L;g[D+4>>2]=N;g[D+8>>2]=P;GKa(b,D)|0;P=ea(g[d>>2]);N=ea(g[M>>2]);L=ea(g[O>>2]);g[E>>2]=P;g[E+4>>2]=N;g[E+8>>2]=L;GKa(b,E)|0;L=ea(g[d>>2]);N=ea(g[M>>2]);P=ea(g[A>>2]);g[F>>2]=L;g[F+4>>2]=N;g[F+8>>2]=P;GKa(b,F)|0;P=ea(g[y>>2]);N=ea(g[M>>2]);L=ea(g[O>>2]);g[G>>2]=P;g[G+4>>2]=N;g[G+8>>2]=L;GKa(b,G)|0;L=ea(g[y>>2]);N=ea(g[M>>2]);P=ea(g[A>>2]);g[H>>2]=L;g[H+4>>2]=N;g[H+8>>2]=P;GKa(b,H)|0;P=ea(g[y>>2]);N=ea(g[x>>2]);L=ea(g[A>>2]);g[I>>2]=P;g[I+4>>2]=N;g[I+8>>2]=L;GKa(b,I)|0;L=ea(g[d>>2]);N=ea(g[M>>2]);P=ea(g[A>>2]);g[J>>2]=L;g[J+4>>2]=N;g[J+8>>2]=P;GKa(b,J)|0;P=ea(g[d>>2]);N=ea(g[x>>2]);L=ea(g[A>>2]);g[K>>2]=P;g[K+4>>2]=N;g[K+8>>2]=L;GKa(b,K)|0;i=e;return b|0}else{c[b>>2]=2;K=b+32|0;c[K>>2]=0;L=ea(g[d>>2]);A=d+4|0;N=ea(g[A>>2]);x=d+8|0;P=ea(g[x>>2]);g[f>>2]=L;g[f+4>>2]=N;g[f+8>>2]=P;GKa(b,f)|0;f=d+12|0;P=ea(g[f>>2]);N=ea(g[A>>2]);L=ea(g[x>>2]);g[h>>2]=P;g[h+4>>2]=N;g[h+8>>2]=L;GKa(b,h)|0;L=ea(g[f>>2]);h=d+16|0;N=ea(g[h>>2]);P=ea(g[x>>2]);g[j>>2]=L;g[j+4>>2]=N;g[j+8>>2]=P;GKa(b,j)|0;P=ea(g[d>>2]);N=ea(g[h>>2]);L=ea(g[x>>2]);g[k>>2]=P;g[k+4>>2]=N;g[k+8>>2]=L;GKa(b,k)|0;L=ea(g[d>>2]);N=ea(g[A>>2]);P=ea(g[x>>2]);g[l>>2]=L;g[l+4>>2]=N;g[l+8>>2]=P;GKa(b,l)|0;P=ea(g[d>>2]);N=ea(g[A>>2]);l=d+20|0;L=ea(g[l>>2]);g[m>>2]=P;g[m+4>>2]=N;g[m+8>>2]=L;GKa(b,m)|0;L=ea(g[f>>2]);N=ea(g[A>>2]);P=ea(g[l>>2]);g[n>>2]=L;g[n+4>>2]=N;g[n+8>>2]=P;GKa(b,n)|0;P=ea(g[f>>2]);N=ea(g[h>>2]);L=ea(g[l>>2]);g[o>>2]=P;g[o+4>>2]=N;g[o+8>>2]=L;GKa(b,o)|0;L=ea(g[d>>2]);N=ea(g[h>>2]);P=ea(g[l>>2]);g[p>>2]=L;g[p+4>>2]=N;g[p+8>>2]=P;GKa(b,p)|0;P=ea(g[d>>2]);N=ea(g[A>>2]);L=ea(g[l>>2]);g[q>>2]=P;g[q+4>>2]=N;g[q+8>>2]=L;GKa(b,q)|0;c[b>>2]=1;c[K>>2]=0;L=ea(g[f>>2]);N=ea(g[A>>2]);P=ea(g[x>>2]);g[r>>2]=L;g[r+4>>2]=N;g[r+8>>2]=P;GKa(b,r)|0;P=ea(g[f>>2]);N=ea(g[A>>2]);L=ea(g[l>>2]);g[s>>2]=P;g[s+4>>2]=N;g[s+8>>2]=L;GKa(b,s)|0;L=ea(g[f>>2]);N=ea(g[h>>2]);P=ea(g[x>>2]);g[t>>2]=L;g[t+4>>2]=N;g[t+8>>2]=P;GKa(b,t)|0;P=ea(g[f>>2]);N=ea(g[h>>2]);L=ea(g[l>>2]);g[u>>2]=P;g[u+4>>2]=N;g[u+8>>2]=L;GKa(b,u)|0;L=ea(g[d>>2]);N=ea(g[h>>2]);P=ea(g[x>>2]);g[v>>2]=L;g[v+4>>2]=N;g[v+8>>2]=P;GKa(b,v)|0;P=ea(g[d>>2]);N=ea(g[h>>2]);L=ea(g[l>>2]);g[w>>2]=P;g[w+4>>2]=N;g[w+8>>2]=L;GKa(b,w)|0;i=e;return b|0}return 0}function IKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0;d=i;i=i+96|0;e=d+12|0;f=d+48|0;h=d+24|0;j=d+60|0;k=d+84|0;l=d;m=d+36|0;n=d+72|0;o=b+12|0;p=ea(g[o>>2]);q=ea(g[b>>2]);r=ea(p-q);s=b+16|0;t=ea(g[s>>2]);u=ea(g[b+4>>2]);v=ea(t-u);w=b+20|0;x=ea(g[w>>2]);y=ea(g[b+8>>2]);z=ea(x-y);A=ea(T(ea(ea(ea(r*r)+ea(v*v))+ea(z*z))));if(A>ea(0.0)){B=ea(ea(1.0)/A);C=ea(r*B);D=ea(z*B);E=ea(v*B)}else{C=r;D=z;E=v}if(ea(S(ea(C)))<ea(.707106769)){F=ea(0.0);G=ea(-D);H=E}else{F=ea(-E);G=C;H=ea(0.0)}v=ea(T(ea(ea(H*H)+ea(ea(G*G)+ea(F*F)))));if(v>ea(0.0)){z=ea(ea(1.0)/v);I=ea(H*z);J=ea(G*z);K=ea(F*z)}else{I=H;J=G;K=F}F=ea(ea(E*I)-ea(D*J));G=ea(ea(D*K)-ea(C*I));H=ea(ea(C*J)-ea(E*K));z=ea(g[b+24>>2]);v=ea(z*ea(.25));r=ea(K*v);K=ea(J*v);J=ea(I*v);I=ea(v*ea(1.73205078));v=ea(F*I);F=ea(G*I);G=ea(H*I);I=ea(p-ea(C*z));C=ea(t-ea(E*z));E=ea(x-ea(D*z));c[a>>2]=1;b=a+32|0;c[b>>2]=0;g[e>>2]=q;g[e+4>>2]=u;g[e+8>>2]=y;L=GKa(a,e)|0;g[f>>2]=ea(g[o>>2]);g[f+4>>2]=ea(g[s>>2]);g[f+8>>2]=ea(g[w>>2]);GKa(L,f)|0;c[a>>2]=4;c[b>>2]=0;g[h>>2]=ea(g[o>>2]);g[h+4>>2]=ea(g[s>>2]);g[h+8>>2]=ea(g[w>>2]);GKa(a,h)|0;y=ea(r+ea(I+r));u=ea(K+ea(K+C));q=ea(J+ea(J+E));g[j>>2]=y;g[j+4>>2]=u;g[j+8>>2]=q;GKa(a,j)|0;z=ea(I-r);r=ea(C-K);K=ea(E-J);J=ea(r-F);E=ea(K-G);g[k>>2]=ea(z-v);g[k+4>>2]=J;g[k+8>>2]=E;GKa(a,k)|0;E=ea(F+r);r=ea(G+K);g[l>>2]=ea(z+v);g[l+4>>2]=E;g[l+8>>2]=r;GKa(a,l)|0;g[m>>2]=ea(g[o>>2]);g[m+4>>2]=ea(g[s>>2]);g[m+8>>2]=ea(g[w>>2]);GKa(a,m)|0;g[n>>2]=y;g[n+4>>2]=u;g[n+8>>2]=q;GKa(a,n)|0;i=d;return a|0}function JKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=0,m=Im,n=Im,o=0,p=0;d=i;i=i+96|0;e=d+56|0;f=d+28|0;h=d;j=ea(g[b>>2]);k=ea(j*j);l=b+4|0;m=ea(g[l>>2]);n=ea(k+ea(m*m));o=b+8|0;m=ea(g[o>>2]);k=ea(ea(T(ea(n+ea(m*m))))*ea(.150000006));p=a+4|0;c[p>>2]=c[b+12>>2];g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);g[e+12>>2]=ea(j+ea(0.0));g[e+16>>2]=ea(0.0);g[e+20>>2]=ea(0.0);g[e+24>>2]=k;IKa(a,e)|0;c[p>>2]=c[b+16>>2];j=ea(ea(g[l>>2])+ea(0.0));c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;g[f+16>>2]=j;g[f+20>>2]=ea(0.0);g[f+24>>2]=k;IKa(a,f)|0;c[p>>2]=c[b+20>>2];j=ea(ea(g[o>>2])+ea(0.0));c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;g[h+20>>2]=j;g[h+24>>2]=k;IKa(a,h)|0;i=d;return a|0}function KKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=Im,l=Im,m=0,n=0,o=Im,p=0,q=Im;d=i;i=i+32|0;e=d+12|0;f=d;h=ea(ea(6.28318548)/ea((c[b>>2]|0)>>>0));c[a>>2]=2;c[a+32>>2]=0;j=b+4|0;k=ea(g[j>>2]);if(!(c[b>>2]|0))l=k;else{m=e+4|0;n=e+8|0;o=k;k=ea(0.0);p=0;while(1){q=ea(o*ea(+V(+k)));g[e>>2]=ea(o*ea(+W(+k)));g[m>>2]=q;g[n>>2]=ea(0.0);GKa(a,e)|0;p=p+1|0;k=ea(h+k);q=ea(g[j>>2]);if(p>>>0>=(c[b>>2]|0)>>>0){l=q;break}else o=q}}g[f>>2]=ea(0.0);g[f+4>>2]=l;g[f+8>>2]=ea(0.0);GKa(a,f)|0;i=d;return a|0}function LKa(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0;f=i;i=i+48|0;h=f+16|0;j=f;k=ea(g[e>>2]);l=ea(g[e+4>>2]);m=ea(g[e+8>>2]);n=ea(g[e+12>>2]);o=ea(g[e+16>>2]);p=ea(g[e+20>>2]);q=ea(g[e+24>>2]);r=ea(g[e+28>>2]);s=ea(g[e+32>>2]);t=ea(g[e+36>>2]);u=ea(g[e+40>>2]);v=ea(g[e+44>>2]);w=ea(-d);x=ea(k*w);y=ea(l*w);z=ea(m*w);w=ea(n*ea(0.0));A=ea(o*ea(0.0));B=ea(p*ea(0.0));C=ea(x+w);D=ea(y+A);E=ea(z+B);F=ea(q*ea(0.0));G=ea(r*ea(0.0));H=ea(s*ea(0.0));I=ea(ea(C+F)+t);J=ea(ea(D+G)+u);K=ea(ea(E+H)+v);e=a+36|0;g[e>>2]=k;L=a+40|0;g[L>>2]=l;M=a+44|0;g[M>>2]=m;N=a+48|0;g[N>>2]=ea(0.0);O=a+52|0;g[O>>2]=n;P=a+56|0;g[P>>2]=o;Q=a+60|0;g[Q>>2]=p;R=a+64|0;g[R>>2]=ea(0.0);S=a+68|0;g[S>>2]=q;T=a+72|0;g[T>>2]=r;U=a+76|0;g[U>>2]=s;X=a+80|0;g[X>>2]=ea(0.0);Y=a+84|0;g[Y>>2]=I;Z=a+88|0;g[Z>>2]=J;_=a+92|0;g[_>>2]=K;$=a+96|0;g[$>>2]=ea(0.0);c[a>>2]=2;aa=a+32|0;c[aa>>2]=0;ba=h+4|0;ca=h+8|0;da=ea(3.14159274);fa=0;do{ga=ea(ea(+V(+da))*b);g[h>>2]=ea(ea(+W(+da))*b);g[ba>>2]=ga;g[ca>>2]=ea(0.0);GKa(a,h)|0;fa=fa+1|0;da=ea(da+ea(.0314159282))}while((fa|0)!=100);da=ea(b*ea(1.74845553e-07));g[j>>2]=da;g[j+4>>2]=b;g[j+8>>2]=ea(0.0);GKa(a,j)|0;ga=ea(-q);ha=ea(-r);ia=ea(-s);g[e>>2]=k;g[L>>2]=l;g[M>>2]=m;g[N>>2]=ea(0.0);g[O>>2]=ga;g[P>>2]=ha;g[Q>>2]=ia;g[R>>2]=ea(-0.0);g[S>>2]=n;g[T>>2]=o;g[U>>2]=p;g[X>>2]=ea(0.0);g[Y>>2]=I;g[Z>>2]=J;g[_>>2]=K;g[$>>2]=ea(0.0);c[a>>2]=2;c[aa>>2]=0;fa=h+4|0;ca=h+8|0;ja=ea(3.14159274);ba=0;do{ka=ea(ea(+V(+ja))*b);g[h>>2]=ea(ea(+W(+ja))*b);g[fa>>2]=ka;g[ca>>2]=ea(0.0);GKa(a,h)|0;ba=ba+1|0;ja=ea(ja+ea(.0314159282))}while((ba|0)!=100);g[j>>2]=da;g[j+4>>2]=b;g[j+8>>2]=ea(0.0);GKa(a,j)|0;da=ea(-n);ja=ea(-o);ka=ea(-p);g[e>>2]=da;g[L>>2]=ja;g[M>>2]=ka;g[N>>2]=ea(-0.0);g[O>>2]=ga;g[P>>2]=ha;g[Q>>2]=ia;g[R>>2]=ea(-0.0);g[S>>2]=k;g[T>>2]=l;g[U>>2]=m;g[X>>2]=ea(0.0);g[Y>>2]=I;g[Z>>2]=J;g[_>>2]=K;g[$>>2]=ea(0.0);c[a>>2]=2;c[aa>>2]=0;ba=h+4|0;ca=h+8|0;K=ea(0.0);fa=0;do{J=ea(ea(+V(+K))*b);g[h>>2]=ea(ea(+W(+K))*b);g[ba>>2]=J;g[ca>>2]=ea(0.0);GKa(a,h)|0;fa=fa+1|0;K=ea(K+ea(.0628318563))}while((fa|0)!=100);g[j>>2]=ea(0.0);g[j+4>>2]=b;g[j+8>>2]=ea(0.0);GKa(a,j)|0;K=ea(k*d);J=ea(l*d);I=ea(m*d);d=ea(K+w);w=ea(J+A);A=ea(I+B);B=ea(ea(d+F)+t);la=ea(ea(w+G)+u);ma=ea(ea(A+H)+v);g[e>>2]=k;g[L>>2]=l;g[M>>2]=m;g[N>>2]=ea(0.0);g[O>>2]=n;g[P>>2]=o;g[Q>>2]=p;g[R>>2]=ea(0.0);g[S>>2]=q;g[T>>2]=r;g[U>>2]=s;g[X>>2]=ea(0.0);g[Y>>2]=B;g[Z>>2]=la;g[_>>2]=ma;g[$>>2]=ea(0.0);c[a>>2]=2;c[aa>>2]=0;fa=h+4|0;ca=h+8|0;na=ea(0.0);ba=0;do{oa=ea(ea(+V(+na))*b);g[h>>2]=ea(ea(+W(+na))*b);g[fa>>2]=oa;g[ca>>2]=ea(0.0);GKa(a,h)|0;ba=ba+1|0;na=ea(na+ea(.0314159282))}while((ba|0)!=100);na=ea(b*ea(-8.74227765e-08));oa=ea(b*ea(-1.0));g[j>>2]=na;g[j+4>>2]=oa;g[j+8>>2]=ea(0.0);GKa(a,j)|0;g[e>>2]=k;g[L>>2]=l;g[M>>2]=m;g[N>>2]=ea(0.0);g[O>>2]=ga;g[P>>2]=ha;g[Q>>2]=ia;g[R>>2]=ea(-0.0);g[S>>2]=n;g[T>>2]=o;g[U>>2]=p;g[X>>2]=ea(0.0);g[Y>>2]=B;g[Z>>2]=la;g[_>>2]=ma;g[$>>2]=ea(0.0);c[a>>2]=2;c[aa>>2]=0;ba=h+4|0;ca=h+8|0;pa=ea(0.0);fa=0;do{qa=ea(ea(+V(+pa))*b);g[h>>2]=ea(ea(+W(+pa))*b);g[ba>>2]=qa;g[ca>>2]=ea(0.0);GKa(a,h)|0;fa=fa+1|0;pa=ea(pa+ea(.0314159282))}while((fa|0)!=100);g[j>>2]=na;g[j+4>>2]=oa;g[j+8>>2]=ea(0.0);GKa(a,j)|0;g[e>>2]=da;g[L>>2]=ja;g[M>>2]=ka;g[N>>2]=ea(-0.0);g[O>>2]=ga;g[P>>2]=ha;g[Q>>2]=ia;g[R>>2]=ea(-0.0);g[S>>2]=k;g[T>>2]=l;g[U>>2]=m;g[X>>2]=ea(0.0);g[Y>>2]=B;g[Z>>2]=la;g[_>>2]=ma;g[$>>2]=ea(0.0);c[a>>2]=2;c[aa>>2]=0;aa=h+4|0;fa=h+8|0;ma=ea(0.0);ca=0;do{la=ea(ea(+V(+ma))*b);g[h>>2]=ea(ea(+W(+ma))*b);g[aa>>2]=la;g[fa>>2]=ea(0.0);GKa(a,h)|0;ca=ca+1|0;ma=ea(ma+ea(.0628318563))}while((ca|0)!=100);g[j>>2]=ea(0.0);g[j+4>>2]=b;g[j+8>>2]=ea(0.0);GKa(a,j)|0;g[e>>2]=k;g[L>>2]=l;g[M>>2]=m;g[N>>2]=ea(0.0);g[O>>2]=n;g[P>>2]=o;g[Q>>2]=p;g[R>>2]=ea(0.0);g[S>>2]=q;g[T>>2]=r;g[U>>2]=s;g[X>>2]=ea(0.0);g[Y>>2]=t;g[Z>>2]=u;g[_>>2]=v;g[$>>2]=ea(0.0);m=ea(n*b);l=ea(o*b);k=ea(p*b);ma=ea(ea(ea(x+m)+F)+t);la=ea(ea(ea(y+l)+G)+u);B=ea(ea(ea(z+k)+H)+v);ia=ea(ea(ea(K+m)+F)+t);m=ea(ea(ea(J+l)+G)+u);l=ea(ea(ea(I+k)+H)+v);$=a+100|0;_=c[$>>2]|0;Z=_+16|0;Y=a+4|0;g[h>>2]=ma;g[h+4>>2]=la;g[h+8>>2]=B;X=c[Y>>2]|0;c[h+12>>2]=X;g[h+16>>2]=ia;g[h+20>>2]=m;g[h+24>>2]=l;c[h+28>>2]=X;U=_+20|0;T=c[U>>2]|0;if((c[_+24>>2]&2147483647)>>>0>T>>>0){_=c[Z>>2]|0;S=_+(T<<5)|0;if(!S)ra=T;else{g[S>>2]=ma;g[_+(T<<5)+4>>2]=la;g[_+(T<<5)+8>>2]=B;c[_+(T<<5)+12>>2]=X;g[_+(T<<5)+16>>2]=ia;g[_+(T<<5)+20>>2]=m;g[_+(T<<5)+24>>2]=l;c[_+(T<<5)+28>>2]=X;ra=c[U>>2]|0}c[U>>2]=ra+1}else Z5a(Z,h)|0;l=ea(-b);m=ea(n*l);n=ea(o*l);o=ea(p*l);p=ea(ea(ea(x+m)+F)+t);x=ea(ea(ea(y+n)+G)+u);y=ea(ea(ea(z+o)+H)+v);z=ea(ea(ea(K+m)+F)+t);F=ea(ea(ea(J+n)+G)+u);G=ea(ea(ea(I+o)+H)+v);Z=c[$>>2]|0;ra=Z+16|0;g[h>>2]=p;g[h+4>>2]=x;g[h+8>>2]=y;U=c[Y>>2]|0;c[h+12>>2]=U;g[h+16>>2]=z;g[h+20>>2]=F;g[h+24>>2]=G;c[h+28>>2]=U;X=Z+20|0;T=c[X>>2]|0;if((c[Z+24>>2]&2147483647)>>>0>T>>>0){Z=c[ra>>2]|0;_=Z+(T<<5)|0;if(!_)sa=T;else{g[_>>2]=p;g[Z+(T<<5)+4>>2]=x;g[Z+(T<<5)+8>>2]=y;c[Z+(T<<5)+12>>2]=U;g[Z+(T<<5)+16>>2]=z;g[Z+(T<<5)+20>>2]=F;g[Z+(T<<5)+24>>2]=G;c[Z+(T<<5)+28>>2]=U;sa=c[X>>2]|0}c[X>>2]=sa+1}else Z5a(ra,h)|0;G=ea(q*b);F=ea(r*b);z=ea(s*b);b=ea(ea(C+G)+t);y=ea(ea(D+F)+u);x=ea(ea(E+z)+v);p=ea(ea(d+G)+t);G=ea(ea(w+F)+u);F=ea(ea(A+z)+v);ra=c[$>>2]|0;sa=ra+16|0;g[h>>2]=b;g[h+4>>2]=y;g[h+8>>2]=x;X=c[Y>>2]|0;c[h+12>>2]=X;g[h+16>>2]=p;g[h+20>>2]=G;g[h+24>>2]=F;c[h+28>>2]=X;U=ra+20|0;T=c[U>>2]|0;if((c[ra+24>>2]&2147483647)>>>0>T>>>0){ra=c[sa>>2]|0;Z=ra+(T<<5)|0;if(!Z)ta=T;else{g[Z>>2]=b;g[ra+(T<<5)+4>>2]=y;g[ra+(T<<5)+8>>2]=x;c[ra+(T<<5)+12>>2]=X;g[ra+(T<<5)+16>>2]=p;g[ra+(T<<5)+20>>2]=G;g[ra+(T<<5)+24>>2]=F;c[ra+(T<<5)+28>>2]=X;ta=c[U>>2]|0}c[U>>2]=ta+1}else Z5a(sa,h)|0;F=ea(q*l);q=ea(r*l);r=ea(s*l);l=ea(ea(C+F)+t);C=ea(ea(D+q)+u);D=ea(ea(E+r)+v);E=ea(ea(d+F)+t);t=ea(ea(w+q)+u);u=ea(ea(A+r)+v);sa=c[$>>2]|0;$=sa+16|0;g[h>>2]=l;g[h+4>>2]=C;g[h+8>>2]=D;ta=c[Y>>2]|0;c[h+12>>2]=ta;g[h+16>>2]=E;g[h+20>>2]=t;g[h+24>>2]=u;c[h+28>>2]=ta;Y=sa+20|0;U=c[Y>>2]|0;if((c[sa+24>>2]&2147483647)>>>0<=U>>>0){Z5a($,h)|0;i=f;return a|0}h=c[$>>2]|0;$=h+(U<<5)|0;if(!$)ua=U;else{g[$>>2]=l;g[h+(U<<5)+4>>2]=C;g[h+(U<<5)+8>>2]=D;c[h+(U<<5)+12>>2]=ta;g[h+(U<<5)+16>>2]=E;g[h+(U<<5)+20>>2]=t;g[h+(U<<5)+24>>2]=u;c[h+(U<<5)+28>>2]=ta;ua=c[Y>>2]|0}c[Y>>2]=ua+1;i=f;return a|0}function MKa(a,b,d,e){a=a|0;b=ea(b);d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im;f=i;i=i+48|0;h=f+24|0;j=f;k=FKa(a,d)|0;l=ea(b*ea(1.5));g[h>>2]=l;g[h+4>>2]=l;g[h+8>>2]=l;c[h+12>>2]=-2004353024;c[h+16>>2]=-2013231104;c[h+20>>2]=-2013265784;JKa(k,h)|0;h=FKa(a,e)|0;g[j>>2]=b;g[j+4>>2]=b;g[j+8>>2]=b;c[j+12>>2]=-65536;c[j+16>>2]=-16711936;c[j+20>>2]=-16776961;JKa(h,j)|0;i=f;return}function NKa(a,b,d,e,f,h){a=a|0;b=ea(b);d=d|0;e=e|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im;e=i;i=i+96|0;j=e+64|0;k=e+36|0;l=e+8|0;m=e;n=ea(g[d>>2]);o=ea(n*ea(2.0));p=ea(g[d+12>>2]);q=ea(p*ea(2.0));r=ea(ea(n*o)+ea(ea(p*q)+ea(-1.0)));s=ea(g[d+8>>2]);t=ea(s*q);u=ea(g[d+4>>2]);v=ea(r*f);r=ea(ea(t+ea(o*u))*f);t=ea(ea(ea(o*s)-ea(q*u))*f);w=d+16|0;f=ea(ea(g[w>>2])+v);x=d+20|0;v=ea(ea(g[x>>2])+r);y=d+24|0;r=ea(ea(g[y>>2])+t);t=ea(p*ea(0.0));q=ea(n*ea(.707106769));o=ea(u*ea(0.0));z=ea(s*ea(.707106769));A=ea(p*ea(.707106769));p=ea(u*ea(.707106769));u=ea(s*ea(0.0));s=ea(n*ea(0.0));n=ea(ea(u+ea(A+p))-s);B=ea(ea(q+ea(t+z))-o);C=ea(ea(ea(A-s)-p)-u);g[j>>2]=ea(ea(ea(q+t)+o)-z);g[j+4>>2]=n;g[j+8>>2]=B;g[j+12>>2]=C;g[j+16>>2]=f;g[j+20>>2]=v;g[j+24>>2]=r;DKa(a,h?-65536:-8355712)|0;g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(1.0);g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);FKa(a,k)|0;C=ea(g[w>>2]);g[l>>2]=C;B=ea(g[x>>2]);g[l+4>>2]=B;n=ea(g[y>>2]);g[l+8>>2]=n;z=ea(B+v);B=ea(n+r);g[l+12>>2]=ea(C+f);g[l+16>>2]=z;g[l+20>>2]=B;g[l+24>>2]=ea(ea(T(ea(ea(ea(f*f)+ea(v*v))+ea(r*r))))*ea(.150000006));IKa(a,l)|0;l=FKa(a,j)|0;r=ea(b*ea(.300000012));c[m>>2]=20;g[m+4>>2]=r;KKa(l,m)|0;i=e;return}function OKa(a,b,c,d,e,f){a=a|0;b=ea(b);c=c|0;d=ea(d);e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im;h=i;i=i+64|0;j=h+48|0;k=h+36|0;l=h+24|0;m=h+12|0;n=h;o=FKa(a,c)|0;DKa(o,f?-65536:-8355712)|0;f=CKa(a,1)|0;g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);o=GKa(f,j)|0;p=ea(b*ea(0.0));q=ea(ea(+V(+d))*b);r=ea(ea(+W(+d))*b);g[k>>2]=p;g[k+4>>2]=q;g[k+8>>2]=r;j=GKa(o,k)|0;g[l>>2]=ea(0.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);k=GKa(j,l)|0;r=ea(ea(+V(+e))*b);q=ea(ea(+W(+e))*b);g[m>>2]=p;g[m+4>>2]=r;g[m+8>>2]=q;GKa(k,m)|0;CKa(a,2)|0;q=ea(ea(e-d)/ea(20.0));m=n+4|0;k=n+8|0;e=d;l=0;do{d=ea(ea(+V(+e))*b);r=ea(ea(+W(+e))*b);g[n>>2]=p;g[m>>2]=d;g[k>>2]=r;GKa(a,n)|0;l=l+1|0;e=ea(q+e)}while((l|0)!=21);i=h;return}function PKa(a,b,c,d,e,f){a=a|0;b=ea(b);c=c|0;d=ea(d);e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0;h=i;i=i+48|0;j=h+36|0;k=h+24|0;l=h+12|0;m=h;n=FKa(a,c)|0;DKa(n,f?-65536:-8355712)|0;CKa(a,1)|0;f=j+4|0;n=j+8|0;c=k+4|0;o=k+8|0;p=l+4|0;q=l+8|0;r=m+4|0;s=m+8|0;t=ea(0.0);u=ea(0.0);v=ea(0.0);w=0;do{x=ea(ea(w>>>0)*ea(.196349546));y=ea(ea(+W(+x))*e);z=ea(ea(+V(+x))*d);x=ea(ea(z*z)+ea(ea(y*y)+ea(0.0)));A=ea(ea(1.0)/ea(x+ea(1.0)));B=ea(A*ea(0.0));C=ea(A*ea(y*ea(-2.0)));y=ea(ea(z*ea(2.0))*A);z=ea(A*ea(ea(1.0)-x));x=ea(ea(z*z)+ea(-.5));A=ea(C*ea(0.0));D=ea(y*ea(0.0));E=ea(D+ea(ea(B*ea(2.0))+A));F=ea(x*ea(0.0));G=ea(B*ea(0.0));H=t;t=ea(ea(ea(B*E)+ea(ea(ea(A-D)*z)+ea(x*ea(2.0))))*b);x=u;u=ea(ea(ea(C*E)+ea(ea(ea(ea(y*ea(2.0))-G)*z)+F))*b);D=v;v=ea(ea(ea(y*E)+ea(ea(ea(G-ea(C*ea(2.0)))*z)+F))*b);g[j>>2]=H;g[f>>2]=x;g[n>>2]=D;I=GKa(a,j)|0;g[k>>2]=t;g[c>>2]=u;g[o>>2]=v;J=GKa(I,k)|0;g[l>>2]=ea(0.0);g[p>>2]=ea(0.0);g[q>>2]=ea(0.0);I=GKa(J,l)|0;g[m>>2]=t;g[r>>2]=u;g[s>>2]=v;GKa(I,m)|0;w=w+1|0}while((w|0)!=33);i=h;return}function QKa(a,b,c,d,e){a=a|0;b=ea(b);c=c|0;d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0;f=i;i=i+80|0;h=f+60|0;j=f+48|0;k=f+36|0;l=f+24|0;m=f+12|0;n=f;o=FKa(a,c)|0;DKa(o,e?-65536:-8355712)|0;p=ea(+W(+(+d)));CKa(a,2)|0;d=ea(p*b);e=h+4|0;o=h+8|0;c=0;do{p=ea(ea(c>>>0)*ea(.196349546));q=ea(ea(+V(+p))*b);r=ea(ea(+W(+p))*b);g[h>>2]=d;g[e>>2]=q;g[o>>2]=r;GKa(a,h)|0;c=c+1|0}while((c|0)!=33);CKa(a,2)|0;r=ea(-d);c=j+4|0;h=j+8|0;o=0;do{q=ea(ea(o>>>0)*ea(.196349546));p=ea(ea(+V(+q))*b);s=ea(ea(+W(+q))*b);g[j>>2]=r;g[c>>2]=p;g[h>>2]=s;GKa(a,j)|0;o=o+1|0}while((o|0)!=33);CKa(a,1)|0;o=k+4|0;j=k+8|0;h=l+4|0;c=l+8|0;e=m+4|0;t=m+8|0;u=n+4|0;v=n+8|0;w=0;do{g[k>>2]=ea(0.0);g[o>>2]=ea(0.0);g[j>>2]=ea(0.0);x=GKa(a,k)|0;s=ea(ea(w>>>0)*ea(.196349546));p=ea(ea(+V(+s))*b);q=ea(ea(+W(+s))*b);g[l>>2]=r;g[h>>2]=p;g[c>>2]=q;GKa(x,l)|0;g[m>>2]=ea(0.0);g[e>>2]=ea(0.0);g[t>>2]=ea(0.0);x=GKa(a,m)|0;g[n>>2]=d;g[u>>2]=p;g[v>>2]=q;GKa(x,n)|0;w=w+1|0}while((w|0)!=32);i=f;return}function RKa(a,b){a=a|0;b=b|0;var c=0,d=Im,e=0,f=Im,h=0,j=0,k=Im,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;c=i;d=ea(g[b>>2]);e=b+12|0;f=ea(d+ea(g[e>>2]));h=b+4|0;d=ea(g[h>>2]);j=b+16|0;k=ea(d+ea(g[j>>2]));l=b+8|0;d=ea(g[l>>2]);m=b+20|0;n=ea(k*ea(.5));k=ea(ea(d+ea(g[m>>2]))*ea(.5));g[a+36>>2]=ea(f*ea(.5));g[a+40>>2]=n;g[a+44>>2]=k;k=ea(g[e>>2]);n=ea(k-ea(g[b>>2]));k=ea(g[j>>2]);f=ea(k-ea(g[h>>2]));k=ea(g[m>>2]);d=ea(k-ea(g[l>>2]));k=ea(T(ea(ea(ea(n*n)+ea(f*f))+ea(d*d))));o=ea(ea(1.0)/k);p=ea(n*o);n=ea(f*o);f=ea(d*o);g[a>>2]=p;g[a+4>>2]=n;g[a+8>>2]=f;l=b+24|0;g[a+48>>2]=ea(ea(k*ea(.5))+ea(g[l>>2]));g[a+52>>2]=ea(g[l>>2]);g[a+56>>2]=ea(g[l>>2]);l=a+12|0;b=a+24|0;m=ea(S(ea(n)))>ea(S(ea(p)))&1;k=ea(S(ea(f)));h=k>ea(S(ea(g[a+(m<<2)>>2])));j=h?2:m;if(!j){k=ea(-n);g[l>>2]=k;g[a+16>>2]=p;g[a+20>>2]=ea(0.0);g[b>>2]=ea(-ea(f*p));g[a+28>>2]=ea(-ea(f*n));g[a+32>>2]=ea(ea(p*p)+ea(n*n));q=ea(0.0);r=k;s=p}else if((j|0)==1){g[l>>2]=ea(0.0);k=ea(-f);g[a+16>>2]=k;g[a+20>>2]=n;g[b>>2]=ea(ea(n*n)+ea(f*f));g[a+28>>2]=ea(-ea(p*n));g[a+32>>2]=ea(-ea(p*f));q=n;r=ea(0.0);s=k}else{g[l>>2]=f;g[a+16>>2]=ea(0.0);k=ea(-p);g[a+20>>2]=k;g[b>>2]=ea(-ea(n*p));g[a+28>>2]=ea(ea(f*f)+ea(p*p));g[a+32>>2]=ea(-ea(n*f));q=k;r=f;s=ea(0.0)}f=ea(T(ea(ea(ea(r*r)+ea(s*s))+ea(q*q))));if(!(f>ea(0.0))){i=c;return}k=ea(ea(1.0)/f);g[l>>2]=ea(r*k);g[a+16>>2]=ea(s*k);g[a+20>>2]=ea(q*k);i=c;return}function SKa(){return 536952}function TKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im;h=ea(g[c>>2]);i=ea(h*ea(g[d>>2]));j=ea(h*ea(g[d+4>>2]));k=ea(h*ea(g[d+8>>2]));h=ea(g[c+4>>2]);l=ea(h*ea(g[e>>2]));m=ea(h*ea(g[e+4>>2]));n=ea(h*ea(g[e+8>>2]));h=ea(g[c+8>>2]);o=ea(h*ea(g[f>>2]));p=ea(h*ea(g[f+4>>2]));q=ea(h*ea(g[f+8>>2]));h=ea(ea(g[b>>2])-i);f=b+4|0;r=ea(ea(g[f>>2])-j);c=b+8|0;s=ea(ea(g[c>>2])-k);e=a+84|0;g[e>>2]=h;d=a+88|0;g[d>>2]=r;t=a+92|0;g[t>>2]=s;u=a+48|0;g[u>>2]=h;v=a+52|0;g[v>>2]=r;w=a+56|0;g[w>>2]=s;x=a+36|0;g[x>>2]=h;y=a+40|0;g[y>>2]=r;z=a+44|0;g[z>>2]=s;g[a>>2]=h;A=a+4|0;g[A>>2]=r;B=a+8|0;g[B>>2]=s;C=ea(i+ea(g[b>>2]));i=ea(j+ea(g[f>>2]));j=ea(k+ea(g[c>>2]));k=ea(l+o);D=ea(m+p);E=ea(n+q);g[a>>2]=ea(h-k);g[A>>2]=ea(r-D);g[B>>2]=ea(s-E);g[a+12>>2]=ea(C-k);g[a+16>>2]=ea(i-D);g[a+20>>2]=ea(j-E);g[a+72>>2]=ea(k+C);g[a+76>>2]=ea(D+i);g[a+80>>2]=ea(E+j);g[e>>2]=ea(k+h);g[d>>2]=ea(D+r);g[t>>2]=ea(E+s);E=ea(l-o);o=ea(m-p);p=ea(n-q);g[a+24>>2]=ea(E+C);g[a+28>>2]=ea(o+i);g[a+32>>2]=ea(p+j);g[x>>2]=ea(E+h);g[y>>2]=ea(o+r);g[z>>2]=ea(p+s);g[u>>2]=ea(h-E);g[v>>2]=ea(r-o);g[w>>2]=ea(s-p);g[a+60>>2]=ea(C-E);g[a+64>>2]=ea(i-o);g[a+68>>2]=ea(j-p);return}function UKa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+48|0;h=f+8|0;j=f+4|0;k=f;l=f+44|0;m=d+4|0;c[m>>2]=0;if(!b){n=0;i=f;return n|0}o=c[e>>2]|0;e=UJa(f+45|0,b<<2,536976,157)|0;p=0;do{g[e+(p<<2)>>2]=ea(g[a+(p*24|0)+(o<<2)>>2]);p=p+1|0}while((p|0)!=(b|0));KMa(h);p=c[(OMa(h,e,b)|0)+8>>2]|0;q=p+(b<<2)|0;a:do if((b|0)>0){r=d+8|0;s=p;t=p;while(1){u=c[t>>2]|0;t=t+4|0;c[j>>2]=u;v=e+(u<<2)|0;w=s;while(1){if(w>>>0>=q>>>0){x=w;break}y=w+4|0;z=ea(g[e+(c[w>>2]<<2)>>2]);if(z<ea(g[v>>2]))w=y;else{x=y;break}}w=x>>>0<q>>>0;if(w){A=u;B=x}else break a;while(1){v=B+4|0;y=c[B>>2]|0;c[k>>2]=y;z=ea(g[e+(y<<2)>>2]);C=a+(A*24|0)+12|0;if(!(z<=ea(g[C+(o<<2)>>2])))break;do if(((((((A|0)!=(y|0)?(z=ea(g[a+(y*24|0)>>2]),!(z>ea(g[C>>2]))):0)?(z=ea(g[a+(A*24|0)>>2]),!(z>ea(g[a+(y*24|0)+12>>2]))):0)?(z=ea(g[a+(y*24|0)+4>>2]),!(z>ea(g[a+(A*24|0)+16>>2]))):0)?(z=ea(g[a+(A*24|0)+4>>2]),!(z>ea(g[a+(y*24|0)+16>>2]))):0)?(z=ea(g[a+(y*24|0)+8>>2]),!(z>ea(g[a+(A*24|0)+20>>2]))):0)?(z=ea(g[a+(A*24|0)+8>>2]),!(z>ea(g[a+(y*24|0)+20>>2]))):0){D=c[m>>2]|0;if((c[r>>2]&2147483647)>>>0>D>>>0){E=(c[d>>2]|0)+(D<<2)|0;if(!E)F=D;else{c[E>>2]=A;F=c[m>>2]|0}E=F+1|0;c[m>>2]=E;G=E}else{cUa(d,j)|0;G=c[m>>2]|0}if((c[r>>2]&2147483647)>>>0<=G>>>0){cUa(d,k)|0;break}E=(c[d>>2]|0)+(G<<2)|0;if(!E)H=G;else{c[E>>2]=y;H=c[m>>2]|0}c[m>>2]=H+1}while(0);if(v>>>0>=q>>>0)break;A=c[j>>2]|0;B=v}if(!(w&t>>>0<q>>>0))break;else s=x}}while(0);VJa(l,e);MMa(h);n=1;i=f;return n|0}function VKa(a,c,d,f,h,j,k,l){a=a|0;c=c|0;d=d|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;m=i;i=i+128|0;n=m;o=m+124|0;p=m+60|0;q=m+112|0;r=m+126|0;s=m+84|0;t=m+72|0;l=ea(g[d>>2]);u=d+12|0;if((l==ea(g[u>>2])?(v=d+4|0,l=ea(g[v>>2]),l==ea(g[d+16>>2])):0)?(w=d+8|0,l=ea(g[w>>2]),l==ea(g[d+20>>2])):0){g[n+36>>2]=ea(g[c+16>>2]);x=n+40|0;g[x>>2]=ea(g[c+20>>2]);y=n+44|0;g[y>>2]=ea(g[c+24>>2]);g[n+48>>2]=ea(g[a+4>>2]);g[n+52>>2]=ea(g[a+8>>2]);g[n+56>>2]=ea(g[a+12>>2]);l=ea(g[c>>2]);z=ea(g[c+4>>2]);A=ea(g[c+8>>2]);B=ea(g[c+12>>2]);C=ea(l+l);D=ea(z+z);E=ea(A+A);F=ea(z*D);G=ea(A*E);H=ea(C*z);z=ea(C*A);I=ea(C*B);J=ea(D*A);A=ea(D*B);D=ea(E*B);B=ea(H+D);E=ea(z-A);K=ea(H-D);D=ea(ea(1.0)-ea(l*C));C=ea(D-G);l=ea(J+I);H=ea(z+A);A=ea(J-I);I=ea(D-F);g[n>>2]=ea(ea(ea(1.0)-F)-G);L=n+4|0;g[L>>2]=B;M=n+8|0;g[M>>2]=E;N=n+12|0;g[N>>2]=K;O=n+16|0;g[O>>2]=C;P=n+20|0;g[P>>2]=l;Q=n+24|0;g[Q>>2]=H;R=n+28|0;g[R>>2]=A;S=n+32|0;g[S>>2]=I;I=ea(g[d+24>>2]);T=j+40|0;U=j+28|0;b[o>>1]=b[k>>1]|0;if(!(SOa(n,I,d,f,h,T,U,o)|0)){V=0;i=m;return V|0}I=ea(-ea(g[U>>2]));o=j+32|0;A=ea(-ea(g[o>>2]));W=j+36|0;H=ea(-ea(g[W>>2]));g[U>>2]=I;g[o>>2]=A;g[W>>2]=H;W=j+12|0;b[W>>1]=6;if(!(b[k>>1]&1)){V=1;i=m;return V|0}H=ea(g[T>>2]);A=ea(H*ea(g[f>>2]));I=ea(H*ea(g[f+4>>2]));l=ea(H*ea(g[f+8>>2]));H=ea(A+ea(g[d>>2]));A=ea(I+ea(g[v>>2]));I=ea(l+ea(g[w>>2]));g[p>>2]=H;g[p+4>>2]=A;g[p+8>>2]=I;w=n+36|0;ea(HOa(p,w,n+48|0,n,q));I=ea(g[q>>2]);A=ea(I*ea(g[n>>2]));H=ea(I*ea(g[L>>2]));l=ea(I*ea(g[M>>2]));M=q+4|0;I=ea(g[M>>2]);C=ea(I*ea(g[N>>2]));K=ea(I*ea(g[O>>2]));E=ea(A+C);C=ea(H+K);K=ea(l+ea(I*ea(g[P>>2])));P=q+8|0;I=ea(g[P>>2]);l=ea(I*ea(g[Q>>2]));H=ea(I*ea(g[R>>2]));A=ea(E+l);l=ea(C+H);H=ea(K+ea(I*ea(g[S>>2])));g[q>>2]=A;g[M>>2]=l;g[P>>2]=H;I=ea(A+ea(g[w>>2]));A=ea(l+ea(g[x>>2]));l=ea(H+ea(g[y>>2]));g[j+16>>2]=I;g[j+20>>2]=A;g[j+24>>2]=l;b[W>>1]=e[W>>1]|0|1;V=1;i=m;return V|0}W=a+4|0;y=j+16|0;x=j+40|0;b[r>>1]=b[k>>1]|0;if(!(VOa(d,c,W,f,h,y,x,j+28|0,r)|0)){V=0;i=m;return V|0}r=j+12|0;b[r>>1]=6;if(!(b[k>>1]&1)){V=1;i=m;return V|0}h=ea(g[x>>2]);if(!(h!=ea(0.0))){V=1;i=m;return V|0}l=ea(g[d>>2]);A=ea(g[d+4>>2]);I=ea(g[d+8>>2]);H=ea(g[u>>2]);K=ea(g[d+16>>2]);C=ea(g[d+20>>2]);g[s+24>>2]=ea(g[d+24>>2]);E=ea(h*ea(g[f>>2]));B=ea(h*ea(g[f+4>>2]));G=ea(h*ea(g[f+8>>2]));g[s>>2]=ea(E+l);g[s+4>>2]=ea(B+A);g[s+8>>2]=ea(G+I);g[s+12>>2]=ea(E+H);g[s+16>>2]=ea(B+K);g[s+20>>2]=ea(G+C);f=c+16|0;g[n+36>>2]=ea(g[f>>2]);d=c+20|0;g[n+40>>2]=ea(g[d>>2]);u=c+24|0;g[n+44>>2]=ea(g[u>>2]);g[n+48>>2]=ea(g[W>>2]);g[n+52>>2]=ea(g[a+8>>2]);g[n+56>>2]=ea(g[a+12>>2]);C=ea(g[c>>2]);a=c+4|0;G=ea(g[a>>2]);W=c+8|0;K=ea(g[W>>2]);x=c+12|0;B=ea(g[x>>2]);H=ea(C+C);E=ea(G+G);I=ea(K+K);A=ea(G*E);l=ea(K*I);h=ea(H*G);G=ea(H*K);F=ea(H*B);D=ea(E*K);K=ea(E*B);E=ea(I*B);B=ea(h+E);I=ea(G-K);J=ea(h-E);E=ea(ea(1.0)-ea(C*H));H=ea(E-l);C=ea(D+F);h=ea(G+K);K=ea(D-F);F=ea(E-A);g[n>>2]=ea(ea(ea(1.0)-A)-l);g[n+4>>2]=B;g[n+8>>2]=I;g[n+12>>2]=J;g[n+16>>2]=H;g[n+20>>2]=C;g[n+24>>2]=h;g[n+28>>2]=K;g[n+32>>2]=F;ea(LOa(s,s+12|0,n+36|0,n+48|0,n,0,t));F=ea(ea(g[t>>2])*ea(2.0));n=t+4|0;K=ea(ea(g[n>>2])*ea(2.0));s=t+8|0;h=ea(ea(g[s>>2])*ea(2.0));C=ea(g[x>>2]);H=ea(ea(C*C)+ea(-.5));J=ea(g[c>>2]);I=ea(F*J);B=ea(g[a>>2]);l=ea(I+ea(K*B));I=ea(g[W>>2]);A=ea(l+ea(h*I));l=ea(ea(J*A)+ea(ea(F*H)+ea(C*ea(ea(h*B)-ea(K*I)))));E=ea(ea(B*A)+ea(ea(K*H)+ea(C*ea(ea(F*I)-ea(h*J)))));D=ea(ea(ea(h*H)+ea(C*ea(ea(K*J)-ea(F*B))))+ea(I*A));g[t>>2]=l;g[n>>2]=E;g[s>>2]=D;A=ea(l+ea(g[f>>2]));l=ea(E+ea(g[d>>2]));E=ea(D+ea(g[u>>2]));g[y>>2]=A;g[j+20>>2]=l;g[j+24>>2]=E;b[r>>1]=e[r>>1]|0|1;V=1;i=m;return V|0}function WKa(a,c,d,f,h,j,k,l){a=a|0;c=c|0;d=d|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im;m=i;i=i+112|0;n=m+48|0;o=m+36|0;p=m+24|0;q=m+108|0;r=m+12|0;s=m;t=d+36|0;u=ea(g[t>>2]);v=ea(u-ea(g[c+16>>2]));w=d+40|0;u=ea(g[w>>2]);x=ea(u-ea(g[c+20>>2]));y=d+44|0;u=ea(g[y>>2]);z=ea(u-ea(g[c+24>>2]));g[n>>2]=ea(g[d>>2]);c=n+4|0;g[c>>2]=ea(g[d+4>>2]);A=n+8|0;g[A>>2]=ea(g[d+8>>2]);B=n+12|0;g[B>>2]=ea(g[d+12>>2]);C=n+16|0;g[C>>2]=ea(g[d+16>>2]);D=n+20|0;g[D>>2]=ea(g[d+20>>2]);E=n+24|0;g[E>>2]=ea(g[d+24>>2]);F=n+28|0;g[F>>2]=ea(g[d+28>>2]);G=n+32|0;g[G>>2]=ea(g[d+32>>2]);g[n+36>>2]=v;g[n+40>>2]=x;g[n+44>>2]=z;g[n+48>>2]=ea(g[d+48>>2]);g[n+52>>2]=ea(g[d+52>>2]);g[n+56>>2]=ea(g[d+56>>2]);z=ea(ea(g[a+4>>2])+l);g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);l=ea(-ea(g[f>>2]));a=f+4|0;x=ea(-ea(g[a>>2]));d=f+8|0;v=ea(-ea(g[d>>2]));g[p>>2]=l;g[p+4>>2]=x;g[p+8>>2]=v;H=j+40|0;b[q>>1]=b[k>>1]|0;if(!(SOa(n,z,o,p,h,H,j+28|0,q)|0)){I=0;i=m;return I|0}q=j+12|0;b[q>>1]=6;if(!(b[k>>1]&1)){I=1;i=m;return I|0}h=ea(g[H>>2]);z=ea(g[f>>2]);v=ea(g[a>>2]);x=ea(h*z);z=ea(h*v);v=ea(h*ea(g[d>>2]));h=ea(-z);l=ea(-v);g[r>>2]=ea(-x);g[r+4>>2]=h;g[r+8>>2]=l;ea(HOa(r,n+36|0,n+48|0,n,s));l=ea(g[s>>2]);h=ea(l*ea(g[n>>2]));u=ea(l*ea(g[c>>2]));J=ea(l*ea(g[A>>2]));l=ea(g[s+4>>2]);K=ea(l*ea(g[B>>2]));L=ea(l*ea(g[C>>2]));M=ea(h+K);K=ea(u+L);L=ea(J+ea(l*ea(g[D>>2])));l=ea(g[s+8>>2]);J=ea(l*ea(g[E>>2]));u=ea(l*ea(g[F>>2]));h=ea(M+J);J=ea(K+u);u=ea(L+ea(l*ea(g[G>>2])));l=ea(h+ea(g[t>>2]));h=ea(J+ea(g[w>>2]));J=ea(z+h);h=ea(v+ea(u+ea(g[y>>2])));g[j+16>>2]=ea(x+l);g[j+20>>2]=J;g[j+24>>2]=h;b[q>>1]=e[q>>1]|0|1;I=1;i=m;return I|0}function XKa(a,c,d,f,h,j,k,l){a=a|0;c=c|0;d=d|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;m=i;i=i+176|0;n=m+32|0;o=m+72|0;p=m+60|0;q=m+48|0;r=m+144|0;s=m;t=m+172|0;u=m+132|0;l=ea(g[c>>2]);v=ea(g[c+4>>2]);w=ea(g[c+8>>2]);x=ea(g[c+12>>2]);y=ea(g[d+36>>2]);z=c+16|0;A=ea(y-ea(g[z>>2]));y=ea(g[d+40>>2]);B=c+20|0;C=ea(y-ea(g[B>>2]));y=ea(g[d+44>>2]);D=c+24|0;E=ea(y-ea(g[D>>2]));g[o>>2]=ea(g[d>>2]);c=o+4|0;g[c>>2]=ea(g[d+4>>2]);F=o+8|0;g[F>>2]=ea(g[d+8>>2]);G=o+12|0;g[G>>2]=ea(g[d+12>>2]);H=o+16|0;g[H>>2]=ea(g[d+16>>2]);I=o+20|0;g[I>>2]=ea(g[d+20>>2]);J=o+24|0;g[J>>2]=ea(g[d+24>>2]);K=o+28|0;g[K>>2]=ea(g[d+28>>2]);L=o+32|0;g[L>>2]=ea(g[d+32>>2]);M=o+36|0;g[M>>2]=A;N=o+40|0;g[N>>2]=C;O=o+44|0;g[O>>2]=E;g[o+48>>2]=ea(g[d+48>>2]);g[o+52>>2]=ea(g[d+52>>2]);g[o+56>>2]=ea(g[d+56>>2]);E=ea(-ea(g[f>>2]));d=f+4|0;C=ea(-ea(g[d>>2]));P=f+8|0;A=ea(-ea(g[P>>2]));g[q>>2]=E;g[q+4>>2]=C;g[q+8>>2]=A;A=ea(l*ea(2.0));C=ea(x*ea(2.0));E=ea(ea(l*A)+ea(ea(x*C)+ea(-1.0)));x=ea(ea(A*v)+ea(w*C));l=ea(ea(A*w)-ea(v*C));C=ea(g[a+8>>2]);v=ea(E*C);E=ea(x*C);x=ea(l*C);C=ea(E+ea(0.0));l=ea(x+ea(0.0));g[r>>2]=ea(v+ea(0.0));g[r+4>>2]=C;g[r+8>>2]=l;l=ea(ea(0.0)-E);E=ea(ea(0.0)-x);g[r+12>>2]=ea(ea(0.0)-v);g[r+16>>2]=l;g[r+20>>2]=E;g[r+24>>2]=ea(g[a+4>>2]);UUa(n,o);g[s>>2]=ea(g[n>>2]);g[s+4>>2]=ea(g[n+4>>2]);g[s+8>>2]=ea(g[n+8>>2]);g[s+12>>2]=ea(g[n+12>>2]);g[s+16>>2]=ea(g[M>>2]);g[s+20>>2]=ea(g[N>>2]);g[s+24>>2]=ea(g[O>>2]);n=o+48|0;a=j+16|0;Q=j+40|0;b[t>>1]=b[k>>1]|0;if(!(VOa(r,s,n,q,h,a,Q,p,t)|0)){R=0;i=m;return R|0}h=ea(-ea(g[p>>2]));E=ea(-ea(g[p+4>>2]));l=ea(-ea(g[p+8>>2]));g[j+28>>2]=h;g[j+32>>2]=E;g[j+36>>2]=l;p=j+12|0;b[p>>1]=6;if(!(b[k>>1]&1)){R=1;i=m;return R|0}l=ea(g[Q>>2]);if(!(l!=ea(0.0))){R=1;i=m;return R|0}Q=o+36|0;E=ea(l*ea(g[f>>2]));h=ea(l*ea(g[d>>2]));v=ea(l*ea(g[P>>2]));g[Q>>2]=ea(E+ea(g[Q>>2]));g[N>>2]=ea(h+ea(g[N>>2]));g[O>>2]=ea(v+ea(g[O>>2]));ea(LOa(r,r+12|0,Q,n,o,0,u));v=ea(g[u>>2]);h=ea(v*ea(g[o>>2]));E=ea(v*ea(g[c>>2]));l=ea(v*ea(g[F>>2]));v=ea(g[u+4>>2]);x=ea(v*ea(g[G>>2]));C=ea(v*ea(g[H>>2]));w=ea(h+x);x=ea(E+C);C=ea(l+ea(v*ea(g[I>>2])));v=ea(g[u+8>>2]);l=ea(v*ea(g[J>>2]));E=ea(v*ea(g[K>>2]));h=ea(w+l);l=ea(x+E);E=ea(C+ea(v*ea(g[L>>2])));v=ea(h+ea(g[M>>2]));h=ea(l+ea(g[N>>2]));l=ea(E+ea(g[O>>2]));E=ea(v+ea(g[z>>2]));v=ea(h+ea(g[B>>2]));h=ea(l+ea(g[D>>2]));g[a>>2]=E;g[j+20>>2]=v;g[j+24>>2]=h;b[p>>1]=e[p>>1]|0|1;R=1;i=m;return R|0}function YKa(a,c,d,e,f,h,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0;l=i;i=i+128|0;m=l+60|0;n=l;o=l+120|0;k=ea(g[d+36>>2]);p=c+16|0;q=ea(k-ea(g[p>>2]));k=ea(g[d+40>>2]);r=c+20|0;s=ea(k-ea(g[r>>2]));k=ea(g[d+44>>2]);t=c+24|0;u=ea(k-ea(g[t>>2]));g[m>>2]=ea(g[d>>2]);g[m+4>>2]=ea(g[d+4>>2]);g[m+8>>2]=ea(g[d+8>>2]);g[m+12>>2]=ea(g[d+12>>2]);g[m+16>>2]=ea(g[d+16>>2]);g[m+20>>2]=ea(g[d+20>>2]);g[m+24>>2]=ea(g[d+24>>2]);g[m+28>>2]=ea(g[d+28>>2]);g[m+32>>2]=ea(g[d+32>>2]);g[m+36>>2]=q;g[m+40>>2]=s;g[m+44>>2]=u;g[m+48>>2]=ea(g[d+48>>2]);g[m+52>>2]=ea(g[d+52>>2]);g[m+56>>2]=ea(g[d+56>>2]);g[n+36>>2]=ea(0.0);g[n+40>>2]=ea(0.0);g[n+44>>2]=ea(0.0);g[n+48>>2]=ea(g[a+4>>2]);g[n+52>>2]=ea(g[a+8>>2]);g[n+56>>2]=ea(g[a+12>>2]);u=ea(g[c>>2]);s=ea(g[c+4>>2]);q=ea(g[c+8>>2]);k=ea(g[c+12>>2]);v=ea(u+u);w=ea(s+s);x=ea(q+q);y=ea(s*w);z=ea(q*x);A=ea(v*s);s=ea(v*q);B=ea(v*k);C=ea(w*q);q=ea(w*k);w=ea(x*k);k=ea(A+w);x=ea(s-q);D=ea(A-w);w=ea(ea(1.0)-ea(u*v));v=ea(w-z);u=ea(C+B);A=ea(s+q);q=ea(C-B);B=ea(w-y);g[n>>2]=ea(ea(ea(1.0)-y)-z);g[n+4>>2]=k;g[n+8>>2]=x;g[n+12>>2]=D;g[n+16>>2]=v;g[n+20>>2]=u;g[n+24>>2]=A;g[n+28>>2]=q;g[n+32>>2]=B;c=h+16|0;b[o>>1]=b[j>>1]|0;if(!(ROa(m,n,e,f,c,h+28|0,h+40|0,o)|0)){E=0;i=l;return E|0}f=ea(g[p>>2]);g[c>>2]=ea(f+ea(g[c>>2]));f=ea(g[r>>2]);r=h+20|0;g[r>>2]=ea(f+ea(g[r>>2]));f=ea(g[t>>2]);t=h+24|0;g[t>>2]=ea(f+ea(g[t>>2]));b[h+12>>1]=7;E=1;i=l;return E|0}function ZKa(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0;n=i;i=i+208|0;o=n+108|0;p=n+48|0;q=n+24|0;r=n;wLa(p,f+48|0,f+36|0,f,h,j);UUa(o,p);m=ea(g[o>>2]);s=ea(g[o+4>>2]);t=ea(g[o+8>>2]);u=ea(g[o+12>>2]);v=ea(g[p+36>>2]);w=ea(g[p+40>>2]);x=ea(g[p+44>>2]);y=ea(m+m);z=ea(s+s);A=ea(t+t);B=ea(s*z);C=ea(t*A);D=ea(y*s);s=ea(y*t);E=ea(y*u);F=ea(z*t);t=ea(z*u);z=ea(A*u);u=ea(ea(ea(1.0)-B)-C);A=ea(D+z);G=ea(s-t);H=ea(D-z);z=ea(ea(1.0)-ea(m*y));y=ea(z-C);C=ea(F+E);m=ea(s+t);t=ea(F-E);E=ea(z-B);B=ea(g[p+48>>2]);z=ea(u*B);u=ea(A*B);A=ea(G*B);B=ea(g[p+52>>2]);G=ea(H*B);H=ea(y*B);y=ea(C*B);B=ea(g[p+56>>2]);C=ea(ea(ea(S(ea(z)))+ea(S(ea(G))))+ea(S(ea(m*B))));m=ea(ea(ea(S(ea(u)))+ea(S(ea(H))))+ea(S(ea(t*B))));t=ea(ea(ea(S(ea(A)))+ea(S(ea(y))))+ea(S(ea(E*B))));B=ea(w-m);E=ea(x-t);y=ea(v+C);A=ea(w+m);m=ea(x+t);g[q>>2]=ea(v-C);g[q+4>>2]=B;g[q+8>>2]=E;g[q+12>>2]=y;g[q+16>>2]=A;g[q+20>>2]=m;g[k+40>>2]=ea(3402823469999999843913219.0e14);c[o>>2]=537064;p=o+96|0;b[p>>1]=0;c[r+12>>2]=c[d+4>>2];c[r+16>>2]=d;g[r+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[r>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[r+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));g[o+20>>2]=ea(g[f>>2]);g[o+24>>2]=ea(g[f+4>>2]);g[o+28>>2]=ea(g[f+8>>2]);g[o+32>>2]=ea(g[f+12>>2]);g[o+36>>2]=ea(g[f+16>>2]);g[o+40>>2]=ea(g[f+20>>2]);g[o+44>>2]=ea(g[f+24>>2]);g[o+48>>2]=ea(g[f+28>>2]);g[o+52>>2]=ea(g[f+32>>2]);g[o+56>>2]=ea(g[f+36>>2]);g[o+60>>2]=ea(g[f+40>>2]);g[o+64>>2]=ea(g[f+44>>2]);g[o+68>>2]=ea(g[f+48>>2]);g[o+72>>2]=ea(g[f+52>>2]);g[o+76>>2]=ea(g[f+56>>2]);g[o+80>>2]=ea(g[h>>2]);g[o+84>>2]=ea(g[h+4>>2]);g[o+88>>2]=ea(g[h+8>>2]);g[o+92>>2]=j;h=b[l>>1]|0;b[p>>1]=h;c[o+4>>2]=r;p=o+16|0;a[p>>0]=0;c[o+8>>2]=e;c[o+12>>2]=k;if(a[d+20>>0]&2){I=1;J=o+98|0;a[J>>0]=I;KRa(r,e,q,1,o)|0;K=a[p>>0]|0;L=K<<24>>24!=0;i=n;return L|0}I=(h&65535)>>>7&1;J=o+98|0;a[J>>0]=I;KRa(r,e,q,1,o)|0;K=a[p>>0]|0;L=K<<24>>24!=0;i=n;return L|0}function _Ka(a,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=q|0;var r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0;r=i;i=i+112|0;s=r+48|0;t=r;u=r+108|0;g[s+36>>2]=ea(g[f+16>>2]);g[s+40>>2]=ea(g[f+20>>2]);g[s+44>>2]=ea(g[f+24>>2]);g[s+48>>2]=ea(g[e+4>>2]);g[s+52>>2]=ea(g[e+8>>2]);g[s+56>>2]=ea(g[e+12>>2]);p=ea(g[f>>2]);v=ea(g[f+4>>2]);w=ea(g[f+8>>2]);x=ea(g[f+12>>2]);y=ea(p+p);z=ea(v+v);A=ea(w+w);B=ea(v*z);C=ea(w*A);D=ea(y*v);v=ea(y*w);E=ea(y*x);F=ea(z*w);w=ea(z*x);z=ea(A*x);x=ea(D+z);A=ea(v-w);G=ea(D-z);z=ea(ea(1.0)-ea(p*y));y=ea(z-C);p=ea(F+E);D=ea(v+w);w=ea(F-E);E=ea(z-B);g[s>>2]=ea(ea(ea(1.0)-B)-C);g[s+4>>2]=x;g[s+8>>2]=A;g[s+12>>2]=G;g[s+16>>2]=y;g[s+20>>2]=p;g[s+24>>2]=D;g[s+28>>2]=w;g[s+32>>2]=E;c[t>>2]=0;c[t+4>>2]=0;f=t+8|0;c[f>>2]=-1;b[t+12>>1]=0;e=t+16|0;H=t+40|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[H>>2]=ea(3402823469999999843913219.0e14);b[u>>1]=b[q>>1]|0;q=a6a(a,d,s,h,j,t,u,0,o)|0;if(!q){i=r;return q|0}g[k>>2]=ea(g[e>>2]);g[k+4>>2]=ea(g[t+20>>2]);g[k+8>>2]=ea(g[t+24>>2]);g[l>>2]=ea(g[t+28>>2]);g[l+4>>2]=ea(g[t+32>>2]);g[l+8>>2]=ea(g[t+36>>2]);g[m>>2]=ea(g[H>>2]);c[n>>2]=c[f>>2];i=r;return q|0}function $Ka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=Im,j=Im,k=0,l=0,m=Im,n=0,o=0,p=Im,q=0;c=i;i=i+48|0;d=c+24|0;e=c+12|0;f=c;h=ea(g[a>>2]);j=ea(h+ea(g[a+12>>2]));k=a+4|0;h=ea(g[k>>2]);l=a+16|0;m=ea(h+ea(g[l>>2]));n=a+8|0;h=ea(g[n>>2]);o=a+20|0;p=ea(m*ea(.5));m=ea(ea(h+ea(g[o>>2]))*ea(.5));g[b+36>>2]=ea(j*ea(.5));g[b+40>>2]=p;g[b+44>>2]=m;q=a+12|0;m=ea(g[a>>2]);p=ea(m-ea(g[q>>2]));m=ea(g[k>>2]);j=ea(m-ea(g[l>>2]));m=ea(g[n>>2]);h=ea(m-ea(g[o>>2]));m=ea(T(ea(ea(ea(p*p)+ea(j*j))+ea(h*h))));o=a+24|0;g[b+48>>2]=ea(ea(g[o>>2])+ea(m*ea(.5)));g[b+52>>2]=ea(g[o>>2]);g[b+56>>2]=ea(g[o>>2]);if(m==ea(0.0)){g[b>>2]=ea(1.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(1.0);g[b+20>>2]=ea(0.0);g[b+24>>2]=ea(0.0);g[b+28>>2]=ea(0.0);g[b+32>>2]=ea(1.0);i=c;return}else{b6a(a,q,d,e,f);g[b>>2]=ea(g[d>>2]);g[b+4>>2]=ea(g[d+4>>2]);g[b+8>>2]=ea(g[d+8>>2]);g[b+12>>2]=ea(g[e>>2]);g[b+16>>2]=ea(g[e+4>>2]);g[b+20>>2]=ea(g[e+8>>2]);g[b+24>>2]=ea(g[f>>2]);g[b+28>>2]=ea(g[f+4>>2]);g[b+32>>2]=ea(g[f+8>>2]);i=c;return}}function aLa(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a+12>>2]=ea(2.0);return}function bLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g[a+12>>2]=ea(2.0);iLa(a,c[b+4>>2]|0)|0;YEi(c[f>>2]|0,c[b+8>>2]|0,c[a>>2]<<2|0)|0;c[e>>2]=c[a>>2];i=d;return}function cLa(a,b){a=a|0;b=b|0;var d=0;d=i;iLa(a,c[b+4>>2]|0)|0;YEi(c[a+8>>2]|0,c[b+8>>2]|0,c[a>>2]<<2|0)|0;c[a+4>>2]=c[a>>2];i=d;return}function dLa(a){a=a|0;var b=0;b=i;hLa(a)|0;i=b;return}function eLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[a+4>>2]|0;a:do if(f){g=c[a+8>>2]|0;h=0;while(1){j=h+1|0;if((c[g+(h<<2)>>2]|0)==(b|0))break;if(j>>>0<f>>>0)h=j;else{k=0;break a}}if(!d)k=1;else{c[d>>2]=h;k=1}}else k=0;while(0);i=e;return k|0}function fLa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;h=f;j=a+8|0;k=c[j>>2]|0;l=a+12|0;if((k|0)!=0?(c[l>>2]|0)>-1:0){VJa(h,k);c[j>>2]=0}c[a+4>>2]=0;c[a>>2]=b;c[j>>2]=d;if(e){g[l>>2]=ea(-ea(g[l>>2]));i=f;return}else{c[l>>2]=-1;i=f;return}}function gLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,l=Im,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=a+12|0;f=c[e>>2]|0;h=(c[k>>2]=f,ea(g[k>>2]));if((f|0)==-1){j=0;i=d;return j|0}l=ea(S(ea(h)));f=h>ea(0.0);m=c[a>>2]|0;if(!m)n=2;else n=~~ea(l*ea(m>>>0))>>>0;m=a+4|0;o=c[m>>2]|0;p=o+b|0;b=n>>>0<p>>>0?p:n;c[a>>2]=b;n=b>>>0>1073741823?-1:b<<2;if(!n){q=o;r=0}else{o=mKa()|0;b=c[(c[o>>2]|0)+8>>2]|0;p=pKa()|0;s=mo[c[(c[p>>2]|0)+24>>2]&4095](p)|0;p=Bn[b&255](o,n,s?541832:544544,537080,89)|0;q=c[m>>2]|0;r=p}if(q)YEi(r|0,c[a+8>>2]|0,q<<2|0)|0;q=a+8|0;if(f){VJa(d,c[q>>2]|0);c[q>>2]=0}c[q>>2]=r;g[e>>2]=l;j=1;i=d;return j|0}function hLa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;if((c[a+12>>2]|0)>-1){e=a+8|0;f=c[e>>2]|0;if(f){VJa(d,f);c[e>>2]=0}c[a>>2]=0}c[a+4>>2]=0;i=b;return a|0}function iLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;if((c[a+12>>2]|0)>-1){f=a+8|0;g=c[f>>2]|0;if(g){VJa(e,g);c[f>>2]=0}c[a>>2]=0}c[a+4>>2]=0;if(!b){h=0;i=d;return h|0}c[a>>2]=b;f=b>>>0>1073741823?-1:b<<2;if(!f)j=0;else{b=mKa()|0;g=c[(c[b>>2]|0)+8>>2]|0;e=pKa()|0;k=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;j=Bn[g&255](b,f,k?541832:544544,537080,144)|0}c[a+8>>2]=j;h=1;i=d;return h|0}function jLa(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);g[a>>2]=c;g[a+4>>2]=d;g[a+8>>2]=e;g[a+12>>2]=ea(0.0);e=ea(g[b+12>>2]);d=ea(g[b+16>>2]);c=ea(g[b+20>>2]);g[a+16>>2]=e;g[a+20>>2]=d;g[a+24>>2]=c;g[a+28>>2]=ea(0.0);c=ea(g[b+24>>2]);d=ea(g[b+28>>2]);e=ea(g[b+32>>2]);g[a+32>>2]=c;g[a+36>>2]=d;g[a+40>>2]=e;g[a+44>>2]=ea(0.0);e=ea(g[b+36>>2]);d=ea(g[b+40>>2]);c=ea(g[b+44>>2]);g[a+48>>2]=e;g[a+52>>2]=d;g[a+56>>2]=c;g[a+60>>2]=ea(0.0);return}function kLa(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=ea(g[b>>2]);d=ea(c+c);e=ea(g[b+4>>2]);f=ea(e+e);h=ea(g[b+8>>2]);i=ea(h+h);j=ea(g[b+12>>2]);k=ea(d*j);l=ea(f*j);m=ea(j*i);j=ea(c*f);n=ea(c*i);o=ea(e*f);f=ea(e*i);e=ea(h*i);i=ea(ea(ea(1.0)-o)-e);h=ea(j+m);p=ea(n-l);q=ea(j-m);m=ea(ea(1.0)-ea(c*d));d=ea(m-e);e=ea(f+k);c=ea(n+l);l=ea(f-k);k=ea(m-o);o=ea(g[b+16>>2]);m=ea(g[b+20>>2]);f=ea(g[b+24>>2]);g[a>>2]=i;g[a+4>>2]=h;g[a+8>>2]=p;g[a+12>>2]=ea(0.0);g[a+16>>2]=q;g[a+20>>2]=d;g[a+24>>2]=e;g[a+28>>2]=ea(0.0);g[a+32>>2]=c;g[a+36>>2]=l;g[a+40>>2]=k;g[a+44>>2]=ea(0.0);g[a+48>>2]=o;g[a+52>>2]=m;g[a+56>>2]=f;g[a+60>>2]=ea(0.0);return}function lLa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;var l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+160|0;h=k+88|0;l=k+80|0;m=k+16|0;n=k+8|0;o=k;if((f&1073741824|0)==0&0==0){if((f&8192|0)==0&0==0){i=k;return}}else{j=ea(g[a+4>>2]);p=ea(g[d+36>>2]);q=ea(p-j);r=ea(g[d+40>>2]);s=ea(r-j);t=ea(g[d+44>>2]);u=ea(t-j);v=ea(j+r);r=ea(j+t);if(q>ea(g[e+12>>2])){i=k;return}q=ea(j+p);if(ea(g[e>>2])>q){i=k;return}if(s>ea(g[e+16>>2])){i=k;return}if(ea(g[e+4>>2])>v){i=k;return}if(u>ea(g[e+20>>2])){i=k;return}if(ea(g[e+8>>2])>r|(f&8192|0)==0&0==0){i=k;return}}r=ea(g[d>>2]);u=ea(g[d+4>>2]);v=ea(g[d+8>>2]);g[h>>2]=r;f=h+4|0;g[f>>2]=u;e=h+8|0;g[e>>2]=v;w=h+12|0;g[w>>2]=ea(0.0);v=ea(g[d+12>>2]);u=ea(g[d+16>>2]);r=ea(g[d+20>>2]);x=h+16|0;g[x>>2]=v;y=h+20|0;g[y>>2]=u;z=h+24|0;g[z>>2]=r;A=h+28|0;g[A>>2]=ea(0.0);r=ea(g[d+24>>2]);u=ea(g[d+28>>2]);v=ea(g[d+32>>2]);B=h+32|0;g[B>>2]=r;C=h+36|0;g[C>>2]=u;D=h+40|0;g[D>>2]=v;E=h+44|0;g[E>>2]=ea(0.0);v=ea(g[d+36>>2]);u=ea(g[d+40>>2]);r=ea(g[d+44>>2]);d=h+48|0;g[d>>2]=v;F=h+52|0;g[F>>2]=u;G=h+56|0;g[G>>2]=r;H=h+60|0;g[H>>2]=ea(0.0);I=EKa(DKa(b,-65281)|0,h)|0;J=a+4|0;r=ea(g[J>>2]);c[l>>2]=100;g[l+4>>2]=r;KKa(I,l)|0;g[m>>2]=ea(g[h>>2]);h=m+4|0;g[h>>2]=ea(g[f>>2]);f=m+8|0;g[f>>2]=ea(g[e>>2]);e=m+12|0;g[e>>2]=ea(g[w>>2]);r=ea(g[x>>2]);u=ea(g[y>>2]);v=ea(g[z>>2]);s=ea(g[A>>2]);A=m+32|0;q=ea(g[B>>2]);B=m+36|0;p=ea(g[C>>2]);C=m+40|0;j=ea(g[D>>2]);D=m+44|0;t=ea(g[E>>2]);g[m+48>>2]=ea(g[d>>2]);g[m+52>>2]=ea(g[F>>2]);g[m+56>>2]=ea(g[G>>2]);g[m+60>>2]=ea(g[H>>2]);g[A>>2]=r;g[B>>2]=u;g[C>>2]=v;g[D>>2]=s;s=ea(-p);p=ea(-j);j=ea(-t);g[m+16>>2]=ea(-q);g[m+20>>2]=s;g[m+24>>2]=p;g[m+28>>2]=j;H=EKa(DKa(b,-65281)|0,m)|0;j=ea(g[J>>2]);c[n>>2]=100;g[n+4>>2]=j;KKa(H,n)|0;j=ea(g[m>>2]);p=ea(g[h>>2]);s=ea(g[f>>2]);q=ea(g[e>>2]);t=ea(g[A>>2]);v=ea(g[B>>2]);u=ea(g[C>>2]);r=ea(g[D>>2]);g[A>>2]=j;g[B>>2]=p;g[C>>2]=s;g[D>>2]=q;q=ea(-v);v=ea(-u);u=ea(-r);g[m>>2]=ea(-t);g[h>>2]=q;g[f>>2]=v;g[e>>2]=u;e=EKa(DKa(b,-65281)|0,m)|0;u=ea(g[J>>2]);c[o>>2]=100;g[o+4>>2]=u;KKa(e,o)|0;i=k;return}function mLa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;var l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;k=i;i=i+80|0;h=k+8|0;e=k;if((f&8192|0)==0&0==0){i=k;return}j=ea(g[d>>2]);l=ea(g[d+4>>2]);m=ea(g[d+8>>2]);n=ea(g[d+12>>2]);o=ea(g[d+16>>2]);p=ea(g[d+20>>2]);q=ea(g[d+24>>2]);r=ea(g[d+28>>2]);s=ea(g[d+32>>2]);t=ea(g[d+36>>2]);u=ea(g[d+40>>2]);v=ea(g[d+44>>2]);g[h+48>>2]=t;g[h+52>>2]=u;g[h+56>>2]=v;g[h+60>>2]=ea(0.0);v=ea(-r);r=ea(-s);g[h+16>>2]=ea(-q);g[h+20>>2]=v;g[h+24>>2]=r;g[h+28>>2]=ea(-0.0);g[h+32>>2]=j;g[h+36>>2]=l;g[h+40>>2]=m;g[h+44>>2]=ea(0.0);m=ea(-o);o=ea(-p);g[h>>2]=ea(-n);g[h+4>>2]=m;g[h+8>>2]=o;g[h+12>>2]=ea(-0.0);d=e+4|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(4.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(16.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(36.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(64.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(100.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(144.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(196.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(256.0);KKa(f,e)|0;f=EKa(DKa(b,-65281)|0,h)|0;c[e>>2]=100;g[d>>2]=ea(324.0);KKa(f,e)|0;i=k;return}function nLa(a,b,c,d,e,f,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;var k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;j=i;if((e&1073741824|0)==0&0==0){if((e&8192|0)==0&0==0){i=j;return}}else{h=ea(g[c+36>>2]);k=ea(g[c+40>>2]);l=ea(g[c+44>>2]);m=ea(g[a+8>>2]);n=ea(-m);o=ea(g[a+4>>2]);p=ea(h+ea(n-o));n=ea(k+ea(0.0));k=ea(l+ea(0.0));if(p>ea(g[d+12>>2])){i=j;return}p=ea(h+ea(m+o));if(ea(g[d>>2])>p){i=j;return}if(n>ea(g[d+16>>2])){i=j;return}if(ea(g[d+4>>2])>n){i=j;return}if(k>ea(g[d+20>>2])){i=j;return}if(ea(g[d+8>>2])>k|(e&8192|0)==0&0==0){i=j;return}}DKa(b,-65281)|0;k=ea(g[a+4>>2]);LKa(b,k,ea(g[a+8>>2]),c)|0;i=j;return}function oLa(b,c,d,e,f,h,j,k){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;var l=0,m=Im,n=Im,o=Im,p=Im,q=Im;k=i;i=i+96|0;h=k+32|0;l=k;if((f&1073741824|0)==0&0==0){if((f&8192|0)==0&0==0){i=k;return}}else{j=ea(g[d+36>>2]);m=ea(g[d+40>>2]);n=ea(g[d+44>>2]);o=ea(g[b+8>>2]);p=ea(g[b+12>>2]);if(j>ea(g[e+12>>2])){i=k;return}j=ea(g[b+4>>2]);if(ea(g[e>>2])>j){i=k;return}if(m>ea(g[e+16>>2])){i=k;return}if(ea(g[e+4>>2])>o){i=k;return}if(n>ea(g[e+20>>2])){i=k;return}if(ea(g[e+8>>2])>p|(f&8192|0)==0&0==0){i=k;return}}p=ea(g[d>>2]);n=ea(g[d+4>>2]);o=ea(g[d+8>>2]);g[h>>2]=p;g[h+4>>2]=n;g[h+8>>2]=o;g[h+12>>2]=ea(0.0);o=ea(g[d+12>>2]);n=ea(g[d+16>>2]);p=ea(g[d+20>>2]);g[h+16>>2]=o;g[h+20>>2]=n;g[h+24>>2]=p;g[h+28>>2]=ea(0.0);p=ea(g[d+24>>2]);n=ea(g[d+28>>2]);o=ea(g[d+32>>2]);g[h+32>>2]=p;g[h+36>>2]=n;g[h+40>>2]=o;g[h+44>>2]=ea(0.0);o=ea(g[d+36>>2]);n=ea(g[d+40>>2]);p=ea(g[d+44>>2]);g[h+48>>2]=o;g[h+52>>2]=n;g[h+56>>2]=p;g[h+60>>2]=ea(0.0);d=EKa(DKa(c,-65281)|0,h)|0;p=ea(g[b+4>>2]);n=ea(-p);o=ea(g[b+8>>2]);m=ea(-o);j=ea(g[b+12>>2]);q=ea(-j);g[l>>2]=n;g[l+4>>2]=m;g[l+8>>2]=q;g[l+12>>2]=p;g[l+16>>2]=o;g[l+20>>2]=j;a[l+24>>0]=1;HKa(d,l)|0;i=k;return}function pLa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);j=j|0;var k=0;k=i;yOa(c[a+32>>2]|0,b,d,e,f,g,h,j);i=k;return}function qLa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);j=j|0;var k=0;k=i;dRa(c[a+36>>2]|0,b,d,a+4|0,e,f,g,h,j);i=k;return}function rLa(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;m=i;i=i+240|0;k=m+48|0;n=m+112|0;o=m+216|0;p=m+140|0;q=m+32|0;r=m;s=m+235|0;t=m+176|0;u=m+233|0;v=m+232|0;w=m+236|0;x=c[d+4>>2]|0;if((j&8192|0)==0&0==0){i=m;return}g[k>>2]=ea(1.0);y=k+4|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[k+20>>2]=ea(1.0);y=k+24|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[k+40>>2]=ea(1.0);y=k+44|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[k+60>>2]=ea(1.0);y=d+8|0;z=d+12|0;A=d+16|0;B=x+16|0;C=x+20|0;D=da(c[C>>2]|0,c[B>>2]|0)|0;E=D<<1;DKa(EKa(e,k)|0,-256)|0;if(!((j&1073741824|0)==0&0==0)){l=ea(g[h+12>>2]);F=ea(g[h>>2]);G=ea(l+F);H=ea(g[h+16>>2]);I=ea(g[h+4>>2]);J=ea(H+I);K=ea(g[h+20>>2]);L=ea(g[h+8>>2]);M=ea(G*ea(.5));G=ea(J*ea(.5));J=ea(ea(K+L)*ea(.5));N=ea(ea(l-F)*ea(.5));F=ea(ea(H-I)*ea(.5));I=ea(ea(K-L)*ea(.5));g[n>>2]=ea(0.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(1.0);g[n+16>>2]=M;g[n+20>>2]=G;g[n+24>>2]=J;c[o>>2]=3;g[o+4>>2]=N;g[o+8>>2]=F;g[o+12>>2]=I;g[p>>2]=ea(g[f>>2]);g[p+4>>2]=ea(g[f+4>>2]);g[p+8>>2]=ea(g[f+8>>2]);g[p+12>>2]=ea(g[f+12>>2]);g[p+16>>2]=ea(g[f+16>>2]);g[p+20>>2]=ea(g[f+20>>2]);g[p+24>>2]=ea(g[f+24>>2]);g[p+28>>2]=ea(g[f+28>>2]);g[p+32>>2]=ea(g[f+32>>2]);UUa(q,p);g[r>>2]=ea(g[q>>2]);g[r+4>>2]=ea(g[q+4>>2]);g[r+8>>2]=ea(g[q+8>>2]);g[r+12>>2]=ea(g[q+12>>2]);g[r+16>>2]=ea(g[f+36>>2]);g[r+20>>2]=ea(g[f+40>>2]);g[r+24>>2]=ea(g[f+44>>2]);q=UJa(m+234|0,D<<3,537168,314)|0;a[s>>0]=0;p=tQa(o,n,d,r,q,E,0,s)|0;s=e+100|0;n=c[s>>2]|0;o=c[n+20>>2]|0;c6a(n+16|0,o+(p*3|0)|0);if(p){n=t+4|0;h=t+8|0;j=t+12|0;k=t+16|0;O=t+20|0;P=t+24|0;Q=t+28|0;R=t+32|0;S=0;T=(c[(c[s>>2]|0)+16>>2]|0)+(o<<5)|0;while(1){o=c[q+(S<<2)>>2]|0;rQa(d,r,o,t,0,0);s=c[543248+(((((_n[c[(c[x>>2]|0)+68>>2]&4095](x,o)|0)&65535)%48|0)&65535)<<2)>>2]|0;I=ea(g[t>>2]);F=ea(g[n>>2]);N=ea(g[h>>2]);J=ea(g[j>>2]);G=ea(g[k>>2]);M=ea(g[O>>2]);g[T>>2]=I;g[T+4>>2]=F;g[T+8>>2]=N;c[T+12>>2]=s;g[T+16>>2]=J;g[T+20>>2]=G;g[T+24>>2]=M;c[T+28>>2]=s;M=ea(g[j>>2]);G=ea(g[k>>2]);J=ea(g[O>>2]);N=ea(g[P>>2]);F=ea(g[Q>>2]);I=ea(g[R>>2]);g[T+32>>2]=M;g[T+36>>2]=G;g[T+40>>2]=J;c[T+44>>2]=s;g[T+48>>2]=N;g[T+52>>2]=F;g[T+56>>2]=I;c[T+60>>2]=s;I=ea(g[P>>2]);F=ea(g[Q>>2]);N=ea(g[R>>2]);J=ea(g[t>>2]);G=ea(g[n>>2]);M=ea(g[h>>2]);g[T+64>>2]=I;g[T+68>>2]=F;g[T+72>>2]=N;c[T+76>>2]=s;g[T+80>>2]=J;g[T+84>>2]=G;g[T+88>>2]=M;c[T+92>>2]=s;S=S+1|0;if((S|0)==(p|0))break;else T=T+96|0}}VJa(u,q);i=m;return}q=UJa(v,D*12|0,537168,345)|0;if(D){v=c[C>>2]|0;u=c[x+36>>2]|0;T=f+4|0;p=f+8|0;S=f+12|0;h=f+16|0;n=f+20|0;t=f+24|0;R=f+28|0;Q=f+32|0;P=f+36|0;O=f+40|0;k=f+44|0;j=0;do{M=ea(((j>>>0)/(v>>>0)|0)>>>0);G=ea(b[u+(j<<2)>>1]|0);J=ea(((j>>>0)%(v>>>0)|0)>>>0);N=ea(M*ea(g[z>>2]));M=ea(G*ea(g[y>>2]));G=ea(J*ea(g[A>>2]));J=ea(N*ea(g[f>>2]));F=ea(N*ea(g[T>>2]));I=ea(N*ea(g[p>>2]));N=ea(M*ea(g[S>>2]));L=ea(M*ea(g[h>>2]));K=ea(J+N);N=ea(F+L);L=ea(I+ea(M*ea(g[n>>2])));M=ea(G*ea(g[t>>2]));I=ea(G*ea(g[R>>2]));F=ea(K+M);M=ea(N+I);I=ea(L+ea(G*ea(g[Q>>2])));G=ea(F+ea(g[P>>2]));F=ea(M+ea(g[O>>2]));M=ea(I+ea(g[k>>2]));g[q+(j*12|0)>>2]=G;g[q+(j*12|0)+4>>2]=F;g[q+(j*12|0)+8>>2]=M;j=j+1|0}while((j|0)!=(D|0))}j=e+100|0;e=c[j>>2]|0;k=c[e+20>>2]|0;c6a(e+16|0,k+(D*6|0)|0);if(E){E=x+36|0;e=D<<1;D=0;O=(c[(c[j>>2]|0)+16>>2]|0)+(k<<5)|0;while(1){k=D>>>1;j=c[C>>2]|0;if(((k>>>0)/(j>>>0)|0)>>>0<((c[B>>2]|0)+-1|0)>>>0?((k>>>0)%(j>>>0)|0)>>>0<(j+-1|0)>>>0:0){P=(D&1|0)==0;Q=c[E>>2]|0;if(P)U=Q+(k<<2)+2|0;else U=Q+(k<<2)+3|0;if((a[U>>0]&127)!=127){do if((a[Q+(k<<2)+2>>0]|0)<0)if(P){V=j+k|0;W=k;X=k+1+j|0;break}else{R=k+1|0;V=R;W=j+R|0;X=k;break}else{R=k+1|0;if(P){V=k;W=R;X=j+k|0;break}else{V=j+R|0;W=j+k|0;X=R;break}}while(0);k=c[543248+(((((_n[c[(c[x>>2]|0)+68>>2]&4095](x,D)|0)&65535)%48|0)&65535)<<2)>>2]|0;j=q+(V*12|0)|0;M=ea(g[j>>2]);P=q+(V*12|0)+4|0;F=ea(g[P>>2]);Q=q+(V*12|0)+8|0;G=ea(g[Q>>2]);R=q+(W*12|0)|0;I=ea(g[R>>2]);t=q+(W*12|0)+4|0;L=ea(g[t>>2]);n=q+(W*12|0)+8|0;N=ea(g[n>>2]);g[O>>2]=M;g[O+4>>2]=F;g[O+8>>2]=G;c[O+12>>2]=k;g[O+16>>2]=I;g[O+20>>2]=L;g[O+24>>2]=N;c[O+28>>2]=k;N=ea(g[R>>2]);L=ea(g[t>>2]);I=ea(g[n>>2]);n=q+(X*12|0)|0;G=ea(g[n>>2]);t=q+(X*12|0)+4|0;F=ea(g[t>>2]);R=q+(X*12|0)+8|0;M=ea(g[R>>2]);g[O+32>>2]=N;g[O+36>>2]=L;g[O+40>>2]=I;c[O+44>>2]=k;g[O+48>>2]=G;g[O+52>>2]=F;g[O+56>>2]=M;c[O+60>>2]=k;M=ea(g[n>>2]);F=ea(g[t>>2]);G=ea(g[R>>2]);I=ea(g[j>>2]);L=ea(g[P>>2]);N=ea(g[Q>>2]);g[O+64>>2]=M;g[O+68>>2]=F;g[O+72>>2]=G;c[O+76>>2]=k;g[O+80>>2]=I;g[O+84>>2]=L;g[O+88>>2]=N;c[O+92>>2]=k;Y=O+96|0}else Y=O}else Y=O;D=D+1|0;if((D|0)==(e|0))break;else O=Y}}VJa(w,q);i=m;return}function sLa(a,b){a=a|0;b=b|0;var c=Im,d=0,e=Im,f=0,h=Im,i=0,j=0;c=ea(g[a>>2]);d=a+4|0;e=ea(g[d>>2]);f=a+8|0;h=ea(g[f>>2]);g[b>>2]=c;g[b+4>>2]=e;g[b+8>>2]=h;i=a+12|0;h=ea(g[i>>2]);e=ea(g[d>>2]);c=ea(g[f>>2]);g[b+12>>2]=h;g[b+16>>2]=e;g[b+20>>2]=c;c=ea(g[i>>2]);j=a+16|0;e=ea(g[j>>2]);h=ea(g[f>>2]);g[b+24>>2]=c;g[b+28>>2]=e;g[b+32>>2]=h;h=ea(g[a>>2]);e=ea(g[j>>2]);c=ea(g[f>>2]);g[b+36>>2]=h;g[b+40>>2]=e;g[b+44>>2]=c;c=ea(g[a>>2]);e=ea(g[d>>2]);f=a+20|0;h=ea(g[f>>2]);g[b+48>>2]=c;g[b+52>>2]=e;g[b+56>>2]=h;h=ea(g[i>>2]);e=ea(g[d>>2]);c=ea(g[f>>2]);g[b+60>>2]=h;g[b+64>>2]=e;g[b+68>>2]=c;c=ea(g[i>>2]);e=ea(g[j>>2]);h=ea(g[f>>2]);g[b+72>>2]=c;g[b+76>>2]=e;g[b+80>>2]=h;h=ea(g[a>>2]);e=ea(g[j>>2]);c=ea(g[f>>2]);g[b+84>>2]=h;g[b+88>>2]=e;g[b+92>>2]=c;return}function tLa(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im;c=ea(g[b>>2]);d=ea(c*ea(2.0));e=ea(g[b+12>>2]);f=ea(e*ea(2.0));h=ea(ea(c*d)+ea(ea(e*f)+ea(-1.0)));e=ea(g[b+8>>2]);c=ea(e*f);i=ea(g[b+4>>2]);j=ea(c+ea(d*i));c=ea(ea(d*e)-ea(f*i));i=ea(ea(g[b+16>>2])*h);f=ea(i+ea(ea(g[b+20>>2])*j));i=ea(-ea(f+ea(c*ea(g[b+24>>2]))));g[a>>2]=h;g[a+4>>2]=j;g[a+8>>2]=c;g[a+12>>2]=i;return}function uLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=i;i=i+64|0;e=d+16|0;f=d;h=ea(g[b+12>>2]);j=ea(g[b>>2]);k=ea(h-j);h=ea(g[b+16>>2]);l=ea(g[b+4>>2]);m=ea(h-l);h=ea(g[b+20>>2]);n=ea(g[b+8>>2]);o=ea(h-n);h=ea(ea(m*ea(.5))+l);l=ea(ea(o*ea(.5))+n);g[a+16>>2]=ea(ea(k*ea(.5))+j);g[a+20>>2]=h;g[a+24>>2]=l;l=ea(T(ea(ea(ea(k*k)+ea(m*m))+ea(o*o))));if(l>ea(0.0)){h=ea(ea(1.0)/l);p=ea(k*h);q=ea(o*h);r=ea(m*h)}else{p=k;q=o;r=m}m=ea(l*ea(.5));g[c>>2]=m;if(!(m>ea(1.1920929e-07))){g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+12>>2]=ea(1.0);i=d;return}if(ea(S(ea(p)))<ea(.707106769)){s=ea(0.0);t=ea(-q);u=r}else{s=ea(-r);t=p;u=ea(0.0)}m=ea(T(ea(ea(u*u)+ea(ea(t*t)+ea(s*s)))));if(m>ea(0.0)){l=ea(ea(1.0)/m);v=ea(u*l);w=ea(t*l);x=ea(s*l)}else{v=u;w=t;x=s}s=ea(ea(r*v)-ea(q*w));t=ea(ea(q*x)-ea(p*v));u=ea(ea(p*w)-ea(r*x));g[e>>2]=p;g[e+4>>2]=r;g[e+8>>2]=q;g[e+12>>2]=x;g[e+16>>2]=w;g[e+20>>2]=v;g[e+24>>2]=s;g[e+28>>2]=t;g[e+32>>2]=u;UUa(f,e);g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);g[a+12>>2]=ea(g[f+12>>2]);i=d;return}function vLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;d=i;g[a>>2]=ea(8507058669999999534545717.0e13);e=a+4|0;g[e>>2]=ea(8507058669999999534545717.0e13);f=a+8|0;g[f>>2]=ea(8507058669999999534545717.0e13);h=a+12|0;g[h>>2]=ea(-8507058669999999534545717.0e13);j=a+16|0;g[j>>2]=ea(-8507058669999999534545717.0e13);k=a+20|0;g[k>>2]=ea(-8507058669999999534545717.0e13);if(!b){i=d;return}else{l=b;m=c;n=ea(8507058669999999534545717.0e13);o=ea(8507058669999999534545717.0e13);p=ea(8507058669999999534545717.0e13);q=ea(-8507058669999999534545717.0e13);r=ea(-8507058669999999534545717.0e13);s=ea(-8507058669999999534545717.0e13)}while(1){l=l+-1|0;t=ea(g[m>>2]);n=n<t?n:t;c=m+4|0;t=ea(g[c>>2]);o=o<t?o:t;b=m+8|0;t=ea(g[b>>2]);p=p<t?p:t;g[a>>2]=n;g[e>>2]=o;g[f>>2]=p;t=ea(g[m>>2]);q=q>t?q:t;t=ea(g[c>>2]);r=r>t?r:t;t=ea(g[b>>2]);s=s>t?s:t;g[h>>2]=q;g[j>>2]=r;g[k>>2]=s;if(!l)break;else m=m+12|0}i=d;return}function wLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im;h=i;i=i+16|0;j=h;k=e+4|0;l=ea(g[k>>2]);m=ea(g[d>>2]);n=ea(g[e>>2]);o=ea(m*n);p=d+4|0;m=ea(o+ea(l*ea(g[p>>2])));q=d+8|0;o=ea(g[q>>2]);r=e+8|0;s=ea(g[r>>2]);t=ea(S(ea(m+ea(o*s))));g[j>>2]=t;u=d+12|0;o=ea(ea(g[u>>2])*n);v=d+16|0;m=ea(o+ea(ea(g[v>>2])*l));w=d+20|0;o=ea(S(ea(m+ea(ea(g[w>>2])*s))));g[j+4>>2]=o;x=d+24|0;m=ea(ea(g[x>>2])*n);y=d+28|0;z=ea(m+ea(ea(g[y>>2])*l));A=d+32|0;m=ea(S(ea(z+ea(ea(g[A>>2])*s))));g[j+8>>2]=m;B=o>t;C=m>(B?o:t);D=C?0:B&1^1;B=C?1:2;t=ea(g[j+(B<<2)>>2]);C=t<ea(g[j+(D<<2)>>2]);j=C?B:D;t=ea(g[d+(j*12|0)>>2]);o=ea(g[d+(j*12|0)+4>>2]);m=ea(g[d+(j*12|0)+8>>2]);z=ea(ea(ea(t*n)+ea(o*l))+ea(m*s));E=ea(t-ea(n*z));t=ea(o-ea(z*l));o=ea(m-ea(z*s));z=ea(T(ea(ea(ea(E*E)+ea(t*t))+ea(o*o))));if(z>ea(0.0)){m=ea(ea(1.0)/z);F=ea(o*m);G=ea(t*m);H=ea(E*m)}else{F=o;G=t;H=E}E=ea(ea(F*l)-ea(G*s));t=ea(ea(H*s)-ea(F*n));s=ea(ea(G*n)-ea(H*l));g[a>>2]=n;l=ea(g[k>>2]);g[a+4>>2]=l;o=ea(g[r>>2]);g[a+8>>2]=o;g[a+12>>2]=H;g[a+16>>2]=G;g[a+20>>2]=F;g[a+24>>2]=E;g[a+28>>2]=t;g[a+32>>2]=s;m=ea(g[e>>2]);z=ea(H*m);I=ea(g[k>>2]);J=ea(z+ea(G*I));z=ea(g[r>>2]);K=ea(ea(J+ea(F*z))*f);J=ea(ea(ea(ea(E*m)+ea(t*I))+ea(s*z))*f);j=b+4|0;D=b+8|0;B=a+48|0;z=ea(f*ea(.5));s=ea(ea(g[d>>2])*n);I=ea(s+ea(ea(g[p>>2])*l));s=ea(S(ea(I+ea(ea(g[q>>2])*o))));I=ea(z+ea(s*ea(g[b>>2])));s=ea(n*ea(g[u>>2]));z=ea(s+ea(l*ea(g[v>>2])));s=ea(S(ea(z+ea(o*ea(g[w>>2])))));z=ea(I+ea(s*ea(g[j>>2])));s=ea(n*ea(g[x>>2]));n=ea(s+ea(l*ea(g[y>>2])));l=ea(S(ea(n+ea(o*ea(g[A>>2])))));g[B>>2]=ea(z+ea(l*ea(g[D>>2])));l=ea(K*ea(.5));K=ea(ea(g[d>>2])*H);z=ea(K+ea(ea(g[p>>2])*G));K=ea(S(ea(z+ea(ea(g[q>>2])*F))));z=ea(l+ea(K*ea(g[b>>2])));K=ea(H*ea(g[u>>2]));l=ea(K+ea(G*ea(g[v>>2])));K=ea(S(ea(l+ea(F*ea(g[w>>2])))));l=ea(z+ea(K*ea(g[j>>2])));K=ea(H*ea(g[x>>2]));H=ea(K+ea(G*ea(g[y>>2])));G=ea(S(ea(H+ea(F*ea(g[A>>2])))));g[B+4>>2]=ea(l+ea(G*ea(g[D>>2])));G=ea(J*ea(.5));J=ea(g[d>>2]);l=ea(g[a+24>>2]);F=ea(J*l);J=ea(g[p>>2]);H=ea(g[a+28>>2]);K=ea(F+ea(J*H));J=ea(g[q>>2]);F=ea(g[a+32>>2]);z=ea(S(ea(K+ea(J*F))));J=ea(G+ea(z*ea(g[b>>2])));z=ea(l*ea(g[u>>2]));G=ea(z+ea(H*ea(g[v>>2])));z=ea(S(ea(G+ea(F*ea(g[w>>2])))));G=ea(J+ea(z*ea(g[j>>2])));z=ea(l*ea(g[x>>2]));l=ea(z+ea(H*ea(g[y>>2])));H=ea(S(ea(l+ea(F*ea(g[A>>2])))));g[B+8>>2]=ea(G+ea(H*ea(g[D>>2])));H=ea(ea(g[e>>2])*f);G=ea(ea(g[k>>2])*f);F=ea(H*ea(.5));H=ea(G*ea(.5));G=ea(ea(ea(g[r>>2])*f)*ea(.5));f=ea(F+ea(g[c>>2]));F=ea(H+ea(g[c+4>>2]));H=ea(G+ea(g[c+8>>2]));g[a+36>>2]=f;g[a+40>>2]=F;g[a+44>>2]=H;i=h;return}function xLa(a,d,e,f,h,j,k,l,m){a=a|0;d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im;n=i;i=i+128|0;o=n+60|0;p=n+120|0;q=n+88|0;r=n+116|0;s=n+122|0;t=n;u=n+118|0;v=n+124|0;w=n+126|0;x=c[e>>2]|0;if((x|0)==2){y=ea(g[f>>2]);z=ea(y*ea(2.0));A=ea(g[f+12>>2]);B=ea(A*ea(2.0));C=ea(ea(y*z)+ea(ea(A*B)+ea(-1.0)));A=ea(g[f+8>>2]);y=ea(A*B);D=ea(g[f+4>>2]);E=ea(y+ea(z*D));y=ea(ea(z*A)-ea(B*D));D=ea(g[e+8>>2]);B=ea(D*C);C=ea(D*E);E=ea(D*y);y=ea(g[f+16>>2]);D=ea(y+B);A=ea(g[f+20>>2]);z=ea(A+C);F=ea(g[f+24>>2]);G=ea(E+F);g[q>>2]=D;g[q+4>>2]=z;g[q+8>>2]=G;G=ea(A-C);C=ea(F-E);g[q+12>>2]=ea(y-B);g[q+16>>2]=G;g[q+20>>2]=C;g[q+24>>2]=ea(g[e+4>>2]);H=b[l>>1]|0;I=c[h>>2]|0;if(!(H&256)){J=c[539312+(I<<2)>>2]|0;b[s>>1]=H;K=Pm[J&31](h,j,q,a,d,k,s,m)|0;i=n;return K|0}else{s=c[539340+(I<<2)>>2]|0;b[r>>1]=H;K=Pm[s&31](h,j,q,a,d,k,r,m)|0;i=n;return K|0}}else if(!x){C=ea(g[e+4>>2]);G=ea(g[f+16>>2]);g[o>>2]=G;B=ea(g[f+20>>2]);g[o+4>>2]=B;y=ea(g[f+24>>2]);g[o+8>>2]=y;g[o+12>>2]=G;g[o+16>>2]=B;g[o+20>>2]=y;g[o+24>>2]=C;r=c[539312+(c[h>>2]<<2)>>2]|0;b[p>>1]=b[l>>1]|0;K=Pm[r&31](h,j,o,a,d,k,p,m)|0;i=n;return K|0}else if((x|0)==4){p=c[539424+(c[h>>2]<<2)>>2]|0;b[w>>1]=b[l>>1]|0;K=Cn[p&7](h,j,e,f,a,d,k,w,m)|0;i=n;return K|0}else if((x|0)==3){g[t+36>>2]=ea(g[f+16>>2]);g[t+40>>2]=ea(g[f+20>>2]);g[t+44>>2]=ea(g[f+24>>2]);g[t+48>>2]=ea(g[e+4>>2]);g[t+52>>2]=ea(g[e+8>>2]);g[t+56>>2]=ea(g[e+12>>2]);C=ea(g[f>>2]);y=ea(g[f+4>>2]);B=ea(g[f+8>>2]);G=ea(g[f+12>>2]);E=ea(C+C);F=ea(y+y);A=ea(B+B);z=ea(y*F);D=ea(B*A);L=ea(E*y);y=ea(E*B);M=ea(E*G);N=ea(F*B);B=ea(F*G);F=ea(A*G);G=ea(L+F);A=ea(y-B);O=ea(L-F);F=ea(ea(1.0)-ea(C*E));E=ea(F-D);C=ea(N+M);L=ea(y+B);B=ea(N-M);M=ea(F-z);g[t>>2]=ea(ea(ea(1.0)-z)-D);g[t+4>>2]=G;g[t+8>>2]=A;g[t+12>>2]=O;g[t+16>>2]=E;g[t+20>>2]=C;g[t+24>>2]=L;g[t+28>>2]=B;g[t+32>>2]=M;f=b[l>>1]|0;l=c[h>>2]|0;if(!(f&256)){e=c[539368+(l<<2)>>2]|0;b[v>>1]=f;K=Pm[e&31](h,j,t,a,d,k,v,m)|0;i=n;return K|0}else{v=c[539396+(l<<2)>>2]|0;b[u>>1]=f;K=Pm[v&31](h,j,t,a,d,k,u,m)|0;i=n;return K|0}}else{K=0;i=n;return K|0}return 0}function yLa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[a>>2]|0;h=c[d>>2]|0;if((g|0)>(h|0)){j=Bn[c[538728+(h*28|0)+(g<<2)>>2]&255](d,e,a,b,0)|0;i=f;return j|0}else{j=Bn[c[538728+(g*28|0)+(h<<2)>>2]&255](a,b,d,e,0)|0;i=f;return j|0}return 0}function zLa(a,d,e,f,g,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=i;i=i+16|0;n=m;o=c[539080+(c[e>>2]<<2)>>2]|0;b[n>>1]=b[h>>1]|0;h=po[o&7](e,f,a,d,g,n,j,k,l,0,0)|0;i=m;return h|0}function ALa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;f=i;i=i+80|0;h=f+24|0;j=f;c[h>>2]=-1;CLa(h,b);oMa(h,j,d,ea(0.0),0);k=ea(g[j>>2]);l=ea(g[j+12>>2]);m=ea(k+l);n=ea(g[j+4>>2]);o=ea(g[j+16>>2]);p=ea(n+o);q=ea(g[j+8>>2]);r=ea(g[j+20>>2]);s=ea(m*ea(.5));m=ea(p*ea(.5));p=ea(ea(q+r)*ea(.5));t=ea(ea(ea(l-k)*ea(.5))*e);k=ea(ea(ea(o-n)*ea(.5))*e);n=ea(ea(ea(r-q)*ea(.5))*e);e=ea(m-k);q=ea(p-n);r=ea(s+t);o=ea(m+k);k=ea(p+n);g[a>>2]=ea(s-t);g[a+4>>2]=e;g[a+8>>2]=q;g[a+12>>2]=r;g[a+16>>2]=o;g[a+20>>2]=k;i=f;return}function BLa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im;j=i;k=c[d>>2]|0;l=c[f>>2]|0;if((k|0)<=(l|0)){m=Km[c[537248+(k*28|0)+(l<<2)>>2]&127](a,b,d,e,f,h)|0;i=j;return m|0}if(!(Km[c[537248+(l*28|0)+(k<<2)>>2]&127](a,b,f,h,d,e)|0)){m=0;i=j;return m|0}n=ea(-ea(g[a>>2]));e=a+4|0;o=ea(-ea(g[e>>2]));d=a+8|0;p=ea(-ea(g[d>>2]));g[a>>2]=n;g[e>>2]=o;g[d>>2]=p;m=1;i=j;return m|0}function CLa(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;switch(c[e>>2]|0){case 5:{c[b>>2]=5;g[b+4>>2]=ea(g[e+4>>2]);g[b+8>>2]=ea(g[e+8>>2]);g[b+12>>2]=ea(g[e+12>>2]);g[b+16>>2]=ea(g[e+16>>2]);g[b+20>>2]=ea(g[e+20>>2]);g[b+24>>2]=ea(g[e+24>>2]);g[b+28>>2]=ea(g[e+28>>2]);h=e+32|0;j=h;k=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;j=h+4|0;h=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;j=b+32|0;l=j;a[l>>0]=k;a[l+1>>0]=k>>8;a[l+2>>0]=k>>16;a[l+3>>0]=k>>24;k=j+4|0;a[k>>0]=h;a[k+1>>0]=h>>8;a[k+2>>0]=h>>16;a[k+3>>0]=h>>24;k=h;c[b+40>>2]=k+16;c[b+44>>2]=c[k+176>>2];k=b+48|0;c[k>>2]=0;c[k+4>>2]=0;i=f;return}case 3:{c[b>>2]=3;g[b+4>>2]=ea(g[e+4>>2]);g[b+8>>2]=ea(g[e+8>>2]);g[b+12>>2]=ea(g[e+12>>2]);i=f;return}case 4:{c[b>>2]=4;g[b+4>>2]=ea(g[e+4>>2]);g[b+8>>2]=ea(g[e+8>>2]);g[b+12>>2]=ea(g[e+12>>2]);g[b+16>>2]=ea(g[e+16>>2]);g[b+20>>2]=ea(g[e+20>>2]);g[b+24>>2]=ea(g[e+24>>2]);g[b+28>>2]=ea(g[e+28>>2]);k=c[e+32>>2]|0;c[b+32>>2]=k;c[b+36>>2]=k+16;i=f;return}case 6:{c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];c[b+16>>2]=c[e+16>>2];c[b+20>>2]=c[e+20>>2];c[b+24>>2]=(c[b+4>>2]|0)+16;k=b+28|0;c[k>>2]=0;c[k+4>>2]=0;i=f;return}case 0:{k=e;h=c[k+4>>2]|0;j=b;c[j>>2]=c[k>>2];c[j+4>>2]=h;g[b+8>>2]=ea(0.0);i=f;return}case 2:{c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];i=f;return}case 1:{c[b>>2]=1;i=f;return}default:{i=f;return}}}function DLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;e=i;i=i+16|0;f=e;h=ea(g[c+12>>2]);j=ea(h+ea(g[d+24>>2]));if(ea(IOa(d,d+12|0,c,f))>ea(j*j)){k=0;i=e;return k|0}h=ea(g[f>>2]);l=ea(g[d+12>>2]);m=ea(g[d>>2]);n=ea(l-m);l=ea(g[d+16>>2]);o=ea(g[d+4>>2]);p=ea(l-o);l=ea(g[d+20>>2]);q=ea(g[d+8>>2]);r=ea(m+ea(h*n));n=ea(o+ea(h*p));p=ea(q+ea(h*ea(l-q)));q=ea(ea(g[c>>2])-r);r=ea(ea(g[c+4>>2])-n);n=ea(ea(g[c+8>>2])-p);p=ea(ea(ea(q*q)+ea(r*r))+ea(n*n));l=ea(T(ea(p)));if(p<ea(9.99999997e-07)){g[a>>2]=ea(1.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0)}else{p=ea(ea(1.0)/l);h=ea(r*p);r=ea(n*p);g[a>>2]=ea(q*p);g[a+4>>2]=h;g[a+8>>2]=r}r=ea(j-l);a=r>ea(0.0);g[b>>2]=a?r:ea(0.0);k=1;i=e;return k|0}function ELa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=0;e=i;i=i+16|0;f=e;h=ea(g[c+12>>2]);UUa(f,d);j=ea(g[f>>2]);k=ea(g[f+4>>2]);l=ea(g[f+8>>2]);m=ea(g[f+12>>2]);n=ea(g[d+36>>2]);o=ea(g[d+40>>2]);p=ea(g[d+44>>2]);q=ea(ea(g[c>>2])-n);n=ea(ea(g[c+4>>2])-o);o=ea(ea(g[c+8>>2])-p);p=ea(q*ea(2.0));r=ea(n*ea(2.0));s=ea(o*ea(2.0));t=ea(ea(m*m)+ea(-.5));u=ea(ea(ea(j*p)+ea(k*r))+ea(l*s));v=ea(ea(j*u)+ea(ea(t*p)-ea(m*ea(ea(k*s)-ea(l*r)))));w=ea(ea(k*u)+ea(ea(t*r)-ea(m*ea(ea(l*p)-ea(j*s)))));x=ea(ea(ea(t*s)-ea(m*ea(ea(j*r)-ea(k*p))))+ea(l*u));u=ea(g[d+48>>2]);p=ea(-u);if(!(v<p))if(v>u){y=u;z=1}else{y=v;z=0}else{y=p;z=1}p=ea(g[d+52>>2]);v=ea(-p);if(!(w<v))if(w>p){A=p;B=1}else{A=w;B=z}else{A=v;B=1}v=ea(g[d+56>>2]);w=ea(-v);if(!(x<w)){d=x>v;if(d|B){C=d?v:x;D=9}else{r=ea(u-ea(S(ea(y))));u=ea(p-ea(S(ea(A))));p=ea(v-ea(S(ea(x))));do if(u<r)if(u<p){d=A>ea(0.0);g[b>>2]=ea(-u);E=ea(0.0);F=ea(0.0);G=d?ea(2.0):ea(-2.0);break}else{d=x>ea(0.0);v=d?ea(1.0):ea(-1.0);g[b>>2]=ea(-p);E=v;F=ea(0.0);G=ea(0.0);break}else if(r<p){d=y>ea(0.0);g[b>>2]=ea(-r);E=ea(0.0);F=d?ea(2.0):ea(-2.0);G=ea(0.0);break}else{d=x>ea(0.0);v=d?ea(1.0):ea(-1.0);g[b>>2]=ea(-p);E=v;F=ea(0.0);G=ea(0.0);break}while(0);p=ea(E*ea(2.0));E=ea(ea(l*p)+ea(ea(k*G)+ea(j*F)));x=ea(ea(k*E)+ea(ea(t*G)+ea(m*ea(ea(l*F)-ea(j*p)))));r=ea(ea(ea(t*p)+ea(m*ea(ea(j*G)-ea(k*F))))+ea(l*E));g[a>>2]=ea(ea(ea(t*F)+ea(m*ea(ea(k*p)-ea(l*G))))+ea(j*E));g[a+4>>2]=x;g[a+8>>2]=r;H=ea(g[b>>2])}}else{C=w;D=9}do if((D|0)==9){w=ea(y*ea(2.0));r=ea(A*ea(2.0));x=ea(C*ea(2.0));E=ea(ea(ea(j*w)+ea(k*r))+ea(l*x));G=ea(q-ea(ea(j*E)+ea(ea(t*w)+ea(m*ea(ea(k*x)-ea(l*r))))));p=ea(n-ea(ea(k*E)+ea(ea(t*r)+ea(m*ea(ea(l*w)-ea(j*x))))));F=ea(o-ea(ea(ea(m*ea(ea(j*r)-ea(k*w)))+ea(t*x))+ea(l*E)));g[a>>2]=G;d=a+4|0;g[d>>2]=p;B=a+8|0;g[B>>2]=F;E=ea(ea(F*F)+ea(ea(G*G)+ea(p*p)));p=ea(h+ea(0.0));if(E>ea(p*p)){I=0;i=e;return I|0}else{p=ea(ea(1.0)/ea(T(ea(E))));g[b>>2]=p;g[a>>2]=ea(p*ea(g[a>>2]));g[d>>2]=ea(p*ea(g[d>>2]));g[B>>2]=ea(p*ea(g[B>>2]));H=ea(E*ea(g[b>>2]));break}}while(0);l=ea(H-h);h=ea(-l);a=l<ea(-0.0);g[b>>2]=a?h:ea(0.0);I=1;i=e;return I|0}function FLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;e=i;i=i+16|0;f=e+4|0;h=e;j=ea(NOa(c,d,f,h));k=ea(g[c+24>>2]);l=ea(k+ea(g[d+24>>2]));if(j>ea(l*l)){m=0;i=e;return m|0}j=ea(g[f>>2]);k=ea(g[c+12>>2]);n=ea(g[c>>2]);o=ea(k-n);k=ea(g[c+16>>2]);p=ea(g[c+4>>2]);q=ea(k-p);k=ea(g[c+20>>2]);r=ea(g[c+8>>2]);s=ea(n+ea(j*o));o=ea(p+ea(j*q));q=ea(r+ea(j*ea(k-r)));r=ea(g[h>>2]);k=ea(g[d+12>>2]);j=ea(g[d>>2]);p=ea(k-j);k=ea(g[d+16>>2]);n=ea(g[d+4>>2]);t=ea(k-n);k=ea(g[d+20>>2]);u=ea(g[d+8>>2]);v=ea(s-ea(j+ea(r*p)));p=ea(o-ea(n+ea(r*t)));t=ea(q-ea(u+ea(r*ea(k-u))));u=ea(ea(ea(v*v)+ea(p*p))+ea(t*t));k=ea(T(ea(u)));if(u<ea(9.99999997e-07)){g[a>>2]=ea(1.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0)}else{u=ea(ea(1.0)/k);r=ea(p*u);p=ea(t*u);g[a>>2]=ea(v*u);g[a+4>>2]=r;g[a+8>>2]=p}p=ea(l-k);a=p>ea(0.0);g[b>>2]=a?p:ea(0.0);m=1;i=e;return m|0}function GLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im;e=i;i=i+32|0;f=e+20|0;h=e+16|0;j=e+12|0;k=e;l=d+36|0;m=ea(LOa(c,c+12|0,l,d+48|0,d,j,k));n=c+24|0;o=ea(g[n>>2]);if(m>ea(o*o)){p=0;i=e;return p|0}if(m!=ea(0.0)?(q=ea(g[j>>2]),r=ea(g[c+12>>2]),s=ea(g[c>>2]),t=ea(r-s),r=ea(g[c+16>>2]),u=ea(g[c+4>>2]),v=ea(r-u),r=ea(g[c+20>>2]),w=ea(g[c+8>>2]),x=ea(s+ea(q*t)),t=ea(u+ea(q*v)),v=ea(w+ea(q*ea(r-w))),w=ea(g[k>>2]),r=ea(w*ea(g[d>>2])),q=ea(w*ea(g[d+4>>2])),u=ea(w*ea(g[d+8>>2])),j=k+4|0,w=ea(g[j>>2]),s=ea(w*ea(g[d+12>>2])),y=ea(w*ea(g[d+16>>2])),z=ea(r+s),s=ea(q+y),y=ea(u+ea(w*ea(g[d+20>>2]))),A=k+8|0,w=ea(g[A>>2]),u=ea(w*ea(g[d+24>>2])),q=ea(w*ea(g[d+28>>2])),r=ea(z+u),u=ea(s+q),q=ea(y+ea(w*ea(g[d+32>>2]))),w=ea(r+ea(g[l>>2])),r=ea(u+ea(g[d+40>>2])),u=ea(q+ea(g[d+44>>2])),g[k>>2]=w,g[j>>2]=r,g[A>>2]=u,q=ea(x-w),w=ea(t-r),r=ea(v-u),u=ea(T(ea(ea(r*r)+ea(ea(q*q)+ea(w*w))))),u!=ea(0.0)):0){v=ea(ea(1.0)/u);u=ea(w*v);w=ea(r*v);g[a>>2]=ea(q*v);g[a+4>>2]=u;g[a+8>>2]=w;w=ea(ea(g[n>>2])-ea(T(ea(m))));n=w>ea(0.0);g[b>>2]=n?w:ea(0.0);p=1;i=e;return p|0}w=ea(0.0);m=ea(0.0);u=ea(0.0);v=ea(3402823469999999843913219.0e14);n=0;while(1){A=d+(n*12|0)|0;q=ea(g[A>>2]);j=d+(n*12|0)+4|0;r=ea(g[j>>2]);k=d+(n*12|0)+8|0;if(!(d6a(q,r,ea(g[k>>2]),c,o,d,f)|0)){p=0;B=28;break}r=ea(g[f>>2]);if(r<v){q=ea(g[A>>2]);t=ea(g[j>>2]);C=ea(g[k>>2]);D=t;E=q;F=r}else{C=u;D=m;E=w;F=v}n=n+1|0;if(n>>>0>=3)break;else{w=E;m=D;u=C;v=F}}if((B|0)==28){i=e;return p|0}n=c+12|0;v=ea(g[n>>2]);u=ea(v-ea(g[c>>2]));f=c+16|0;v=ea(g[f>>2]);k=c+4|0;m=ea(v-ea(g[k>>2]));j=c+20|0;v=ea(g[j>>2]);A=c+8|0;w=ea(v-ea(g[A>>2]));v=ea(ea(ea(u*u)+ea(m*m))+ea(w*w));if(v>ea(0.0)){r=ea(ea(1.0)/ea(T(ea(v))));G=ea(m*r);H=ea(w*r);I=ea(u*r)}else{G=ea(0.0);H=ea(0.0);I=ea(0.0)}r=E;E=D;D=C;C=F;l=0;while(1){F=ea(g[d+(l*12|0)+8>>2]);u=ea(G*F);w=ea(g[d+(l*12|0)+4>>2]);m=ea(u-ea(H*w));u=ea(g[d+(l*12|0)>>2]);v=ea(ea(H*u)-ea(I*F));F=ea(ea(I*w)-ea(G*u));if((!(+ea(S(ea(m)))>1.0e-06)?!(+ea(S(ea(v)))>1.0e-06):0)?!(+ea(S(ea(F)))>1.0e-06):0){J=r;K=E;L=D;M=C}else{u=ea(ea(F*F)+ea(ea(m*m)+ea(v*v)));if(u>ea(0.0)){w=ea(ea(1.0)/ea(T(ea(u))));N=ea(m*w);O=ea(v*w);P=ea(F*w)}else{N=ea(0.0);O=ea(0.0);P=ea(0.0)}if(!(d6a(N,O,P,c,o,d,h)|0)){p=0;B=28;break}w=ea(g[h>>2]);if(w<C){J=N;K=O;L=P;M=w}else{J=r;K=E;L=D;M=C}}l=l+1|0;if(l>>>0>=3)break;else{r=J;E=K;D=L;C=M}}if((B|0)==28){i=e;return p|0}C=ea(g[c>>2]);D=ea(C+ea(g[n>>2]));C=ea(g[k>>2]);E=ea(C+ea(g[f>>2]));C=ea(g[A>>2]);r=ea(D*ea(.5));D=ea(E*ea(.5));E=ea(ea(C+ea(g[j>>2]))*ea(.5));C=ea(g[d+36>>2]);P=ea(g[d+40>>2]);if(ea(ea(ea(J*ea(r-C))+ea(K*ea(D-P)))+ea(L*ea(E-ea(g[d+44>>2]))))<ea(0.0)){Q=ea(-J);R=ea(-K);U=ea(-L)}else{Q=J;R=K;U=L}if(b){d=M>ea(0.0);g[b>>2]=d?M:ea(0.0)}if(!a){p=1;i=e;return p|0}g[a>>2]=Q;g[a+4>>2]=R;g[a+8>>2]=U;p=1;i=e;return p|0}function HLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=Im;e=i;i=i+32|0;f=e+16|0;h=e+12|0;j=e;g[h>>2]=ea(3402823469999999843913219.0e14);if(!(e6a(f,h,c,c,d)|0)){k=0;i=e;return k|0}if(!(e6a(f,h,c+12|0,c,d)|0)){k=0;i=e;return k|0}if(!(e6a(f,h,c+24|0,c,d)|0)){k=0;i=e;return k|0}if(!(e6a(f,h,d,c,d)|0)){k=0;i=e;return k|0}if(!(e6a(f,h,d+12|0,c,d)|0)){k=0;i=e;return k|0}if(!(e6a(f,h,d+24|0,c,d)|0)){k=0;i=e;return k|0}l=j+4|0;m=j+8|0;n=0;a:do{o=d+(n*12|0)+8|0;p=d+(n*12|0)+4|0;q=d+(n*12|0)|0;r=0;do{s=ea(g[c+(r*12|0)+4>>2]);t=ea(g[o>>2]);u=ea(s*t);v=ea(g[c+(r*12|0)+8>>2]);w=ea(g[p>>2]);x=ea(u-ea(v*w));u=ea(g[q>>2]);y=ea(v*u);v=ea(g[c+(r*12|0)>>2]);z=ea(y-ea(t*v));t=ea(ea(w*v)-ea(s*u));g[j>>2]=x;g[l>>2]=z;g[m>>2]=t;if(!((!(+ea(S(ea(x)))>1.0e-06)?!(+ea(S(ea(z)))>1.0e-06):0)?!(+ea(S(ea(t)))>1.0e-06):0)){u=ea(ea(ea(x*x)+ea(z*z))+ea(t*t));if(u>ea(0.0)){s=ea(ea(1.0)/ea(T(ea(u))));A=ea(x*s);B=ea(z*s);C=ea(t*s)}else{A=ea(0.0);B=ea(0.0);C=ea(0.0)}g[j>>2]=A;g[l>>2]=B;g[m>>2]=C;if(!(e6a(f,h,j,c,d)|0)){k=0;D=20;break a}}r=r+1|0}while(r>>>0<3);n=n+1|0}while(n>>>0<3);if((D|0)==20){i=e;return k|0}C=ea(g[d+36>>2]);B=ea(g[d+40>>2]);A=ea(g[d+44>>2]);s=ea(g[c+36>>2]);t=ea(g[c+40>>2]);z=ea(C-s);s=ea(B-t);t=ea(A-ea(g[c+44>>2]));A=ea(g[f>>2]);B=ea(z*A);c=f+4|0;z=ea(g[c>>2]);C=ea(B+ea(s*z));d=f+8|0;s=ea(g[d>>2]);if(ea(C+ea(t*s))<ea(0.0)){t=ea(-A);C=ea(-z);B=ea(-s);g[f>>2]=t;g[c>>2]=C;g[d>>2]=B;E=t;F=C;G=B}else{E=A;F=z;G=s}s=ea(-F);F=ea(-G);g[a>>2]=ea(-E);g[a+4>>2]=s;g[a+8>>2]=F;F=ea(g[h>>2]);h=F>ea(0.0);g[b>>2]=h?F:ea(0.0);k=1;i=e;return k|0}function ILa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=0,U=0;k=i;i=i+576|0;l=k+544|0;m=k+480|0;n=k+16|0;o=k+496|0;p=k+512|0;q=k+528|0;r=k+464|0;s=k+448|0;t=k+32|0;u=k+384|0;v=k+240|0;w=k+556|0;x=ea(g[e>>2]);y=ea(g[e+4>>2]);z=ea(g[e+8>>2]);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;A=ea(g[h>>2]);B=ea(g[h+4>>2]);C=ea(g[h+8>>2]);g[r>>2]=A;g[r+4>>2]=B;g[r+8>>2]=C;g[r+12>>2]=ea(0.0);e=h+12|0;C=ea(g[e>>2]);B=ea(g[e+4>>2]);A=ea(g[e+8>>2]);D=ea(g[e+12>>2]);g[s>>2]=C;g[s+4>>2]=B;g[s+8>>2]=A;g[s+12>>2]=D;z1a(t,f+16|0,n,r,s);D=ea(g[j>>2]);A=ea(-D);s=j+4|0;B=ea(g[s>>2]);C=ea(-B);r=j+8|0;E=ea(g[r>>2]);F=ea(-E);f=j+12|0;G=ea(g[f>>2]);e=j+16|0;H=ea(x-ea(g[e>>2]));h=j+20|0;x=ea(y-ea(g[h>>2]));I=j+24|0;y=ea(H*ea(2.0));H=ea(x*ea(2.0));x=ea(ea(z-ea(g[I>>2]))*ea(2.0));z=ea(ea(G*G)+ea(-.5));J=ea(ea(ea(y*A)+ea(H*C))+ea(x*F));K=ea(ea(J*C)+ea(ea(z*H)+ea(G*ea(ea(y*F)-ea(x*A)))));L=ea(ea(ea(z*x)+ea(G*ea(ea(H*A)-ea(y*C))))+ea(J*F));M=ea(G*ea(0.0));N=ea(B*ea(-0.0));O=ea(E*ea(-0.0));P=ea(ea(N+ea(M-D))-O);Q=ea(D*ea(-0.0));D=ea(ea(O+ea(M-B))-Q);B=ea(ea(Q+ea(M-E))-N);E=ea(ea(ea(G-Q)-N)-O);g[u+48>>2]=ea(ea(J*A)+ea(ea(z*y)+ea(G*ea(ea(x*C)-ea(H*F)))));g[u+52>>2]=K;g[u+56>>2]=L;g[u+60>>2]=ea(0.0);L=ea(P+P);K=ea(D+D);F=ea(B+B);H=ea(D*K);C=ea(B*F);x=ea(D*L);D=ea(B*L);G=ea(E*L);y=ea(B*K);B=ea(E*K);K=ea(E*F);F=ea(ea(1.0)-ea(P*L));L=ea(x+K);P=ea(D-B);E=ea(x-K);K=ea(F-C);x=ea(y+G);z=ea(D+B);B=ea(y-G);G=ea(F-H);g[u>>2]=ea(ea(ea(1.0)-H)-C);g[u+4>>2]=L;g[u+8>>2]=P;g[u+12>>2]=ea(0.0);g[u+16>>2]=E;g[u+20>>2]=K;g[u+24>>2]=x;g[u+28>>2]=ea(0.0);g[u+32>>2]=z;g[u+36>>2]=B;g[u+40>>2]=G;g[u+44>>2]=ea(0.0);R=v+64|0;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+80>>2]=4;S=v+20|0;T=v+36|0;g[v+48>>2]=ea(0.0);U=v+52|0;c[U+0>>2]=c[l+0>>2];c[U+4>>2]=c[l+4>>2];c[U+8>>2]=c[l+8>>2];g[v+128>>2]=ea(0.0);l=v+132|0;c[l+0>>2]=c[w+0>>2];c[l+4>>2]=c[w+4>>2];c[l+8>>2]=c[w+8>>2];G=ea(g[n>>2]);B=ea(g[n+4>>2]);z=ea(g[n+8>>2]);x=ea(B+B);K=ea(z+z);g[v+96>>2]=ea(G+G);g[v+100>>2]=x;g[v+104>>2]=K;g[v+108>>2]=ea(0.0);K=ea(B-B);B=ea(z-z);g[v+112>>2]=ea(G-G);g[v+116>>2]=K;g[v+120>>2]=B;g[v+124>>2]=ea(0.0);g[v+16>>2]=ea(0.0);c[S+0>>2]=c[w+0>>2];c[S+4>>2]=c[w+4>>2];c[S+8>>2]=c[w+8>>2];g[v+32>>2]=ea(0.0);c[T+0>>2]=c[w+0>>2];c[T+4>>2]=c[w+4>>2];c[T+8>>2]=c[w+8>>2];c[m+0>>2]=-1;c[m+4>>2]=-1;c[m+8>>2]=-1;c[m+12>>2]=-1;c[R+0>>2]=c[m+0>>2];c[R+4>>2]=c[m+4>>2];c[R+8>>2]=c[m+8>>2];c[R+12>>2]=c[m+12>>2];m=(uPa(v,t,u,k,o,p,q)|0)==1;if(m){g[d>>2]=ea(0.0);i=k;return m|0}else{g[d>>2]=ea(g[q>>2]);B=ea(g[p>>2]);K=ea(g[p+4>>2]);G=ea(g[p+8>>2]);g[a>>2]=B;p=a+4|0;g[p>>2]=K;q=a+8|0;g[q>>2]=G;G=ea(g[o>>2]);K=ea(g[o+4>>2]);B=ea(g[o+8>>2]);g[b>>2]=G;o=b+4|0;g[o>>2]=K;d=b+8|0;g[d>>2]=B;B=ea(ea(g[a>>2])*ea(2.0));K=ea(ea(g[p>>2])*ea(2.0));G=ea(ea(g[q>>2])*ea(2.0));z=ea(g[f>>2]);x=ea(ea(z*z)+ea(-.5));E=ea(g[j>>2]);P=ea(B*E);L=ea(g[s>>2]);C=ea(P+ea(K*L));P=ea(g[r>>2]);H=ea(C+ea(G*P));C=ea(ea(L*H)+ea(ea(K*x)+ea(z*ea(ea(B*P)-ea(G*E)))));F=ea(ea(ea(G*x)+ea(z*ea(ea(K*E)-ea(B*L))))+ea(P*H));g[a>>2]=ea(ea(E*H)+ea(ea(B*x)+ea(z*ea(ea(G*L)-ea(K*P)))));g[p>>2]=C;g[q>>2]=F;F=ea(ea(g[b>>2])*ea(2.0));C=ea(ea(g[o>>2])*ea(2.0));P=ea(ea(g[d>>2])*ea(2.0));K=ea(g[f>>2]);L=ea(ea(K*K)+ea(-.5));G=ea(g[j>>2]);z=ea(F*G);x=ea(g[s>>2]);B=ea(z+ea(C*x));z=ea(g[r>>2]);H=ea(B+ea(P*z));B=ea(ea(G*H)+ea(ea(F*L)+ea(K*ea(ea(P*x)-ea(C*z)))));E=ea(ea(x*H)+ea(ea(C*L)+ea(K*ea(ea(F*z)-ea(P*G)))));y=ea(ea(ea(P*L)+ea(K*ea(ea(C*G)-ea(F*x))))+ea(z*H));H=ea(ea(g[e>>2])+B);B=ea(ea(g[h>>2])+E);E=ea(ea(g[I>>2])+y);g[b>>2]=H;g[o>>2]=B;g[d>>2]=E;i=k;return m|0}return 0}function JLa(a,b,e,f,h){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;j=i;i=i+16|0;k=j+12|0;l=c[f+32>>2]|0;if(!(ILa(a,j,k,e,l,f+4|0,h)|0)){m=ea(g[k>>2]);n=ea(g[e+12>>2]);if(m>ea(n*n)){o=0;i=j;return o|0}p=ea(n-ea(T(ea(m))));k=p>ea(0.0);g[b>>2]=k?p:ea(0.0);p=ea(-ea(g[a>>2]));k=a+4|0;m=ea(-ea(g[k>>2]));f=a+8|0;n=ea(-ea(g[f>>2]));g[a>>2]=p;g[k>>2]=m;g[f>>2]=n;o=1;i=j;return o|0}n=ea(g[e>>2]);m=ea(n-ea(g[h+16>>2]));n=ea(g[e+4>>2]);p=ea(n-ea(g[h+20>>2]));n=ea(g[e+8>>2]);q=ea(m*ea(2.0));m=ea(p*ea(2.0));p=ea(ea(n-ea(g[h+24>>2]))*ea(2.0));f=h+12|0;n=ea(g[f>>2]);r=ea(ea(n*n)+ea(-.5));s=ea(g[h>>2]);t=ea(q*s);k=h+4|0;u=ea(g[k>>2]);v=ea(t+ea(m*u));w=h+8|0;t=ea(g[w>>2]);x=ea(v+ea(p*t));v=ea(ea(s*x)+ea(ea(q*r)-ea(n*ea(ea(p*u)-ea(m*t)))));y=ea(ea(u*x)+ea(ea(m*r)-ea(n*ea(ea(q*t)-ea(p*s)))));z=ea(ea(ea(p*r)-ea(n*ea(ea(m*s)-ea(q*u))))+ea(t*x));A=a+4|0;B=a+8|0;x=ea(-3402823469999999843913219.0e14);C=d[l+55>>0]|0;D=c[l+56>>2]|0;a:while(1){l=C;E=D;do{F=l;l=l+-1|0;if(!F)break a;F=E;E=E+20|0;G=ea(g[F>>2]);t=ea(v*G);H=ea(g[F+4>>2]);u=ea(t+ea(y*H));I=ea(g[F+8>>2]);t=ea(u+ea(z*I));J=ea(ea(g[F+12>>2])+t)}while(!(J>x));t=ea(G*ea(2.0));u=ea(H*ea(2.0));q=ea(I*ea(2.0));s=ea(g[f>>2]);m=ea(ea(s*s)+ea(-.5));n=ea(g[h>>2]);r=ea(t*n);p=ea(g[k>>2]);K=ea(r+ea(u*p));r=ea(g[w>>2]);L=ea(K+ea(q*r));K=ea(ea(p*L)+ea(ea(u*m)+ea(s*ea(ea(t*r)-ea(q*n)))));M=ea(ea(ea(q*m)+ea(s*ea(ea(u*n)-ea(t*p))))+ea(r*L));g[a>>2]=ea(ea(n*L)+ea(ea(t*m)+ea(s*ea(ea(q*p)-ea(u*r)))));g[A>>2]=K;g[B>>2]=M;x=J;C=l;D=E}J=ea(ea(g[e+12>>2])-x);e=J>ea(0.0);g[b>>2]=e?J:ea(0.0);o=1;i=j;return o|0}function KLa(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0;k=i;i=i+624|0;l=k+544|0;m=k+384|0;n=k+528|0;o=k+448|0;p=k+496|0;q=k+512|0;r=k+176|0;s=k+464|0;t=k+16|0;u=k;v=k+32|0;w=ea(g[e+12>>2]);x=ea(w-ea(g[e>>2]));w=ea(g[e+16>>2]);y=ea(w-ea(g[e+4>>2]));w=ea(g[e+20>>2]);z=ea(w-ea(g[e+8>>2]));w=ea(ea(T(ea(ea(ea(x*x)+ea(y*y))+ea(z*z))))*ea(.5));z=ea(g[e+24>>2]);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;e=(c[h+32>>2]|0)+16|0;A=h+4|0;y=ea(g[A>>2]);B=h+8|0;x=ea(g[B>>2]);C=h+12|0;D=ea(g[C>>2]);g[p>>2]=y;g[p+4>>2]=x;g[p+8>>2]=D;g[p+12>>2]=ea(0.0);E=h+16|0;D=ea(g[E>>2]);x=ea(g[E+4>>2]);y=ea(g[E+8>>2]);F=ea(g[E+12>>2]);g[q>>2]=D;g[q+4>>2]=x;g[q+8>>2]=y;g[q+12>>2]=F;z1a(r,e,o,p,q);F=ea(g[f>>2]);y=ea(g[f+4>>2]);x=ea(g[f+8>>2]);D=ea(g[f+12>>2]);q=f+16|0;G=ea(g[q>>2]);H=ea(g[q+4>>2]);I=ea(g[q+8>>2]);J=ea(g[j>>2]);K=ea(g[j+4>>2]);L=ea(g[j+8>>2]);M=ea(g[j+12>>2]);q=j+16|0;N=ea(g[q>>2]);O=ea(g[q+4>>2]);P=ea(g[q+8>>2]);g[s>>2]=J;g[s+4>>2]=K;g[s+8>>2]=L;g[s+12>>2]=M;g[s+16>>2]=N;g[s+20>>2]=O;g[s+24>>2]=P;g[s+28>>2]=ea(0.0);Q=ea(-J);J=ea(-K);K=ea(-L);L=ea(G-N);N=ea(H-O);O=ea(I-P);P=ea(ea(M*M)+ea(-.5));I=ea(ea(ea(L*Q)+ea(N*J))+ea(O*K));H=ea(ea(ea(I*Q)+ea(ea(P*L)+ea(M*ea(ea(O*J)-ea(N*K)))))*ea(2.0));G=ea(ea(ea(I*J)+ea(ea(P*N)+ea(M*ea(ea(L*K)-ea(O*Q)))))*ea(2.0));R=ea(ea(ea(ea(P*O)+ea(M*ea(ea(N*Q)-ea(L*J))))+ea(I*K))*ea(2.0));I=ea(ea(D*M)-ea(ea(ea(F*Q)+ea(y*J))+ea(x*K)));L=ea(ea(ea(x*J)-ea(y*K))+ea(ea(D*Q)+ea(F*M)));N=ea(ea(ea(F*K)-ea(x*Q))+ea(ea(D*J)+ea(y*M)));O=ea(ea(ea(y*Q)-ea(F*J))+ea(ea(x*M)+ea(D*K)));K=ea(L+L);D=ea(N+N);M=ea(O+O);x=ea(N*D);J=ea(O*M);F=ea(N*K);N=ea(O*K);Q=ea(I*K);y=ea(O*D);O=ea(I*D);D=ea(I*M);M=ea(ea(1.0)-ea(L*K));K=ea(ea(ea(1.0)-x)-J);L=ea(F+D);I=ea(N-O);P=ea(F-D);D=ea(M-J);J=ea(y+Q);F=ea(N+O);O=ea(y-Q);Q=ea(M-x);c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];g[u>>2]=ea(0.0);x=ea(w*ea(0.0));M=ea(ea(x*F)+ea(ea(x*P)+ea(w*K)));K=ea(ea(x*O)+ea(ea(w*L)+ea(x*D)));D=ea(ea(ea(w*I)+ea(x*J))+ea(x*Q));o=v+64|0;g[v>>2]=H;g[v+4>>2]=G;g[v+8>>2]=R;g[v+12>>2]=ea(0.0);c[v+80>>2]=4;q=v+20|0;j=v+36|0;g[v+48>>2]=ea(0.0);f=v+52|0;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];g[v+128>>2]=z;f=v+132|0;c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];Q=ea(G+K);x=ea(R+D);g[v+96>>2]=ea(H+M);g[v+100>>2]=Q;g[v+104>>2]=x;g[v+108>>2]=ea(0.0);x=ea(G-K);K=ea(R-D);g[v+112>>2]=ea(H-M);g[v+116>>2]=x;g[v+120>>2]=K;g[v+124>>2]=ea(0.0);g[v+16>>2]=z;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];g[v+32>>2]=z;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[m+0>>2]=-1;c[m+4>>2]=-1;c[m+8>>2]=-1;c[m+12>>2]=-1;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];if(ea(g[A>>2])==ea(1.0)?ea(g[B>>2])==ea(1.0):0)S=ea(g[C>>2])==ea(1.0);else S=0;HSa(r,S,l);c[m+32>>2]=s;c[m+36>>2]=r+96;c[m+40>>2]=r+144;a[m+44>>0]=S&1;if(S){c[m>>2]=537488;c[m+48>>2]=r}else{c[m>>2]=537456;c[m+48>>2]=r}r=zSa(v,l,m,u,t)|0;if(!r){i=k;return r|0}z=ea(g[u>>2]);u=z>ea(0.0);g[d>>2]=u?z:ea(0.0);z=ea(g[t>>2]);K=ea(g[t+4>>2]);x=ea(g[t+8>>2]);g[b>>2]=z;g[b+4>>2]=K;g[b+8>>2]=x;i=k;return r|0}function LLa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=Im,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=0;j=i;i=i+1072|0;k=j+624|0;l=j+708|0;m=j+928|0;n=j+448|0;o=j+496|0;p=j+1e3|0;q=j+240|0;r=j+288|0;s=j+272|0;t=j+224|0;u=j+16|0;v=j+560|0;w=j+592|0;x=j;y=j+256|0;z=j+696|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;UUa(k,e);A=ea(g[k>>2]);B=ea(g[k+4>>2]);C=ea(g[k+8>>2]);D=ea(g[k+12>>2]);E=ea(g[e+36>>2]);F=ea(g[e+40>>2]);G=ea(g[e+44>>2]);H=e+48|0;I=ea(g[H>>2]);J=e+52|0;K=ea(g[J>>2]);L=e+56|0;M=ea(g[L>>2]);e=r+64|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];c[r+80>>2]=3;N=r+20|0;c[N+0>>2]=c[l+0>>2];c[N+4>>2]=c[l+4>>2];c[N+8>>2]=c[l+8>>2];O=r+36|0;g[r+48>>2]=ea(0.0);P=r+52|0;c[P+0>>2]=c[l+0>>2];c[P+4>>2]=c[l+4>>2];c[P+8>>2]=c[l+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];g[r+144>>2]=I;g[r+148>>2]=K;g[r+152>>2]=M;g[r+156>>2]=ea(0.0);Q=!(I<=K)?K:I;R=!(Q<=M)?M:Q;Q=!(I>=K)?K:I;I=ea(R*ea(.150000006));K=ea((!(Q>=M)?M:Q)*ea(.0299999993));Q=I>K?I:K;g[r+16>>2]=R>Q?Q:R;c[N+0>>2]=c[l+0>>2];c[N+4>>2]=c[l+4>>2];c[N+8>>2]=c[l+8>>2];g[r+32>>2]=ea(R*ea(.0500000007));c[O+0>>2]=c[k+0>>2];c[O+4>>2]=c[k+4>>2];c[O+8>>2]=c[k+8>>2];O=(c[f+32>>2]|0)+16|0;N=f+4|0;R=ea(g[N>>2]);Q=ea(g[N+4>>2]);K=ea(g[N+8>>2]);g[s>>2]=R;g[s+4>>2]=Q;g[s+8>>2]=K;g[s+12>>2]=ea(0.0);e=f+16|0;K=ea(g[e>>2]);Q=ea(g[e+4>>2]);R=ea(g[e+8>>2]);I=ea(g[e+12>>2]);g[t>>2]=K;g[t+4>>2]=Q;g[t+8>>2]=R;g[t+12>>2]=I;z1a(u,O,q,s,t);I=ea(g[h>>2]);R=ea(g[h+4>>2]);Q=ea(g[h+8>>2]);K=ea(g[h+12>>2]);t=h+16|0;M=ea(g[t>>2]);S=ea(g[t+4>>2]);T=ea(g[t+8>>2]);g[v>>2]=A;g[v+4>>2]=B;g[v+8>>2]=C;g[v+12>>2]=D;g[v+16>>2]=E;g[v+20>>2]=F;g[v+24>>2]=G;g[v+28>>2]=ea(0.0);g[w>>2]=I;g[w+4>>2]=R;g[w+8>>2]=Q;g[w+12>>2]=K;g[w+16>>2]=M;g[w+20>>2]=S;g[w+24>>2]=T;g[w+28>>2]=ea(0.0);c[x+0>>2]=c[q+0>>2];c[x+4>>2]=c[q+4>>2];c[x+8>>2]=c[q+8>>2];c[x+12>>2]=c[q+12>>2];g[y>>2]=ea(0.0);if(ea(g[N>>2])==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0)U=ea(g[f+12>>2])==ea(1.0);else U=0;g[z>>2]=ea(g[H>>2]);g[z+4>>2]=ea(g[J>>2]);g[z+8>>2]=ea(g[L>>2]);FSa(l,z);GSa(l,k);c[k+32>>2]=544264;HSa(u,U,m);g[n>>2]=ea(1.0);l=n+4|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[n+20>>2]=ea(1.0);l=n+24|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[n+40>>2]=ea(1.0);g[n+44>>2]=ea(0.0);c[o+32>>2]=v;c[o+36>>2]=n;c[o+40>>2]=n;a[o+44>>0]=1;c[o>>2]=537520;c[o+48>>2]=r;c[p+32>>2]=w;c[p+36>>2]=u+96;c[p+40>>2]=u+144;a[p+44>>0]=U&1;if(U){c[p>>2]=537488;c[p+48>>2]=u}else{c[p>>2]=537456;c[p+48>>2]=u}u=uSa(k,m,o,p,y,x)|0;if(!u){i=j;return u|0}T=ea(g[y>>2]);y=T>ea(0.0);g[d>>2]=y?T:ea(0.0);T=ea(g[x>>2]);S=ea(g[x+4>>2]);M=ea(g[x+8>>2]);g[b>>2]=T;g[b+4>>2]=S;g[b+8>>2]=M;i=j;return u|0}function MLa(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=0;k=i;i=i+864|0;l=k+792|0;m=k+592|0;n=k+664|0;o=k+728|0;p=k+352|0;q=k+368|0;r=k+256|0;s=k+384|0;t=k+288|0;u=k+240|0;v=k;w=k+304|0;x=k+208|0;y=k+336|0;z=k+272|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;A=(c[e+32>>2]|0)+16|0;B=e+4|0;C=ea(g[B>>2]);D=e+8|0;E=ea(g[D>>2]);F=e+12|0;G=ea(g[F>>2]);g[q>>2]=C;g[q+4>>2]=E;g[q+8>>2]=G;g[q+12>>2]=ea(0.0);H=e+16|0;G=ea(g[H>>2]);E=ea(g[H+4>>2]);C=ea(g[H+8>>2]);I=ea(g[H+12>>2]);g[r>>2]=G;g[r+4>>2]=E;g[r+8>>2]=C;g[r+12>>2]=I;z1a(s,A,p,q,r);r=(c[h+32>>2]|0)+16|0;q=h+4|0;I=ea(g[q>>2]);A=h+8|0;C=ea(g[A>>2]);H=h+12|0;E=ea(g[H>>2]);g[t>>2]=I;g[t+4>>2]=C;g[t+8>>2]=E;g[t+12>>2]=ea(0.0);e=h+16|0;E=ea(g[e>>2]);C=ea(g[e+4>>2]);I=ea(g[e+8>>2]);G=ea(g[e+12>>2]);g[u>>2]=E;g[u+4>>2]=C;g[u+8>>2]=I;g[u+12>>2]=G;z1a(v,r,p,t,u);G=ea(g[f>>2]);I=ea(g[f+4>>2]);C=ea(g[f+8>>2]);E=ea(g[f+12>>2]);u=f+16|0;J=ea(g[u>>2]);K=ea(g[u+4>>2]);L=ea(g[u+8>>2]);M=ea(g[j>>2]);N=ea(g[j+4>>2]);O=ea(g[j+8>>2]);P=ea(g[j+12>>2]);u=j+16|0;Q=ea(g[u>>2]);R=ea(g[u+4>>2]);S=ea(g[u+8>>2]);g[w>>2]=G;g[w+4>>2]=I;g[w+8>>2]=C;g[w+12>>2]=E;g[w+16>>2]=J;g[w+20>>2]=K;g[w+24>>2]=L;g[w+28>>2]=ea(0.0);g[x>>2]=M;g[x+4>>2]=N;g[x+8>>2]=O;g[x+12>>2]=P;g[x+16>>2]=Q;g[x+20>>2]=R;g[x+24>>2]=S;g[x+28>>2]=ea(0.0);c[y+0>>2]=c[p+0>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];c[y+12>>2]=c[p+12>>2];g[z>>2]=ea(0.0);if(ea(g[B>>2])==ea(1.0)?ea(g[D>>2])==ea(1.0):0)T=ea(g[F>>2])==ea(1.0);else T=0;if(ea(g[q>>2])==ea(1.0)?ea(g[A>>2])==ea(1.0):0)U=ea(g[H>>2])==ea(1.0);else U=0;HSa(s,T,l);HSa(v,U,m);c[n+32>>2]=w;c[n+36>>2]=s+96;c[n+40>>2]=s+144;a[n+44>>0]=T&1;if(T){c[n>>2]=537488;c[n+48>>2]=s}else{c[n>>2]=537456;c[n+48>>2]=s}c[o+32>>2]=x;c[o+36>>2]=v+96;c[o+40>>2]=v+144;a[o+44>>0]=U&1;if(U){c[o>>2]=537488;c[o+48>>2]=v}else{c[o>>2]=537456;c[o+48>>2]=v}v=uSa(l,m,n,o,z,y)|0;if(!v){i=k;return v|0}S=ea(g[z>>2]);z=S>ea(0.0);g[d>>2]=z?S:ea(0.0);S=ea(g[y>>2]);R=ea(g[y+4>>2]);Q=ea(g[y+8>>2]);g[b>>2]=S;g[b+4>>2]=R;g[b+8>>2]=Q;i=k;return v|0}function NLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=Im,p=Im,q=0;e=i;i=i+96|0;f=e;TKa(f,d+36|0,d+48|0,d,d+12|0,d+24|0);h=ea(g[f>>2]);j=ea(g[c>>2]);k=ea(h*j);h=ea(g[f+4>>2]);d=c+4|0;l=ea(g[d>>2]);m=ea(k+ea(h*l));h=ea(g[f+8>>2]);n=c+8|0;k=ea(g[n>>2]);o=ea(m+ea(h*k));h=ea(g[c+12>>2]);m=ea(h+o);o=ea(ea(g[f+12>>2])*j);p=ea(o+ea(ea(g[f+16>>2])*l));o=ea(h+ea(p+ea(ea(g[f+20>>2])*k)));p=m<o?m:o;o=ea(ea(g[f+24>>2])*j);m=ea(o+ea(ea(g[f+28>>2])*l));o=ea(h+ea(m+ea(ea(g[f+32>>2])*k)));m=p<o?p:o;o=ea(ea(g[f+36>>2])*j);p=ea(o+ea(ea(g[f+40>>2])*l));o=ea(h+ea(p+ea(ea(g[f+44>>2])*k)));p=m<o?m:o;o=ea(ea(g[f+48>>2])*j);m=ea(o+ea(ea(g[f+52>>2])*l));o=ea(h+ea(m+ea(ea(g[f+56>>2])*k)));m=p<o?p:o;o=ea(ea(g[f+60>>2])*j);p=ea(o+ea(ea(g[f+64>>2])*l));o=ea(h+ea(p+ea(ea(g[f+68>>2])*k)));p=m<o?m:o;o=ea(ea(g[f+72>>2])*j);m=ea(o+ea(ea(g[f+76>>2])*l));o=ea(h+ea(m+ea(ea(g[f+80>>2])*k)));m=p<o?p:o;o=ea(ea(g[f+84>>2])*j);j=ea(o+ea(ea(g[f+88>>2])*l));l=ea(h+ea(j+ea(ea(g[f+92>>2])*k)));k=m<l?m:l;if(k>ea(0.0)){q=0;i=e;return q|0}l=ea(-ea(g[c>>2]));m=ea(-ea(g[d>>2]));j=ea(-ea(g[n>>2]));g[a>>2]=l;g[a+4>>2]=m;g[a+8>>2]=j;j=ea(-k);a=k<ea(-0.0);g[b>>2]=a?j:ea(0.0);q=1;i=e;return q|0}function OLa(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0;k=i;l=c[h+32>>2]|0;h=a[l+54>>0]|0;m=c[l+56>>2]|0;n=d[l+55>>0]|0;l=m+(n*20|0)|0;o=ea(ea(g[l>>2])*ea(2.0));p=ea(ea(g[m+(n*20|0)+4>>2])*ea(2.0));q=ea(ea(g[m+(n*20|0)+8>>2])*ea(2.0));r=ea(g[j+12>>2]);s=ea(ea(r*r)+ea(-.5));t=ea(g[j>>2]);u=ea(o*t);v=ea(g[j+4>>2]);w=ea(u+ea(p*v));u=ea(g[j+8>>2]);x=ea(w+ea(q*u));w=ea(ea(t*x)+ea(ea(o*s)+ea(r*ea(ea(q*v)-ea(p*u)))));y=ea(ea(v*x)+ea(ea(p*s)+ea(r*ea(ea(o*u)-ea(q*t)))));z=ea(ea(ea(q*s)+ea(r*ea(ea(p*t)-ea(o*v))))+ea(u*x));x=ea(g[j+16>>2]);o=ea(x+w);w=ea(g[j+20>>2]);p=ea(w+y);y=ea(g[j+24>>2]);q=ea(y+z);z=ea(g[f>>2]);A=ea(z*o);o=ea(g[f+4>>2]);B=ea(A+ea(o*p));p=ea(g[f+8>>2]);A=ea(ea(q*p)+B);B=ea(g[f+12>>2]);q=ea(B+A);if((h&255)>1){f=h&255;A=q;h=1;while(1){C=ea(ea(g[l+(h*12|0)>>2])*ea(2.0));D=ea(ea(g[l+(h*12|0)+4>>2])*ea(2.0));E=ea(ea(g[l+(h*12|0)+8>>2])*ea(2.0));F=ea(ea(ea(C*t)+ea(D*v))+ea(E*u));G=ea(B+ea(ea(ea(y+ea(ea(ea(E*s)+ea(r*ea(ea(D*t)-ea(C*v))))+ea(u*F)))*p)+ea(ea(z*ea(x+ea(ea(t*F)+ea(ea(C*s)+ea(r*ea(ea(E*v)-ea(D*u)))))))+ea(o*ea(w+ea(ea(v*F)+ea(ea(D*s)+ea(r*ea(ea(C*u)-ea(E*t))))))))));E=A<G?A:G;h=h+1|0;if((h|0)==(f|0)){H=E;break}else A=E}}else H=q;if(H>ea(0.0)){I=0;i=k;return I|0}q=ea(-o);o=ea(-p);g[b>>2]=ea(-z);g[b+4>>2]=q;g[b+8>>2]=o;o=ea(-H);b=H<ea(-0.0);g[e>>2]=b?o:ea(0.0);I=1;i=k;return I|0}function PLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0;h=i;i=i+4288|0;j=h+4144|0;k=h+4208|0;l=h+4216|0;m=h+4272|0;n=h;o=h+4112|0;p=h+4200|0;c[j>>2]=-1;q=ea(g[d+12>>2]);c[k>>2]=0;g[k+4>>2]=q;CLa(j,k);c[l>>2]=-1;CLa(l,e);c[m>>2]=0;e=n+4096|0;c[e>>2]=0;g[n+4100>>2]=ea(0.0);g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(1.0);g[o+16>>2]=ea(g[d>>2]);g[o+20>>2]=ea(g[d+4>>2]);g[o+24>>2]=ea(g[d+8>>2]);g[p>>2]=ea(0.0);if(!(ZNa(j,l,o,f,p,m,n)|0)){r=0;i=h;return r|0}if(!(f6a(a,b,c[e>>2]|0,n)|0)){r=0;i=h;return r|0}r=(c[e>>2]|0)!=0;i=h;return r|0}function QLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0;h=i;i=i+4288|0;j=h+4116|0;k=h+4120|0;l=h+4160|0;m=h+4148|0;n=h+4224|0;o=h+4112|0;p=h;q=h+4216|0;vKa(k,d,d+12|0,j);c[l>>2]=-1;r=ea(g[d+24>>2]);s=ea(g[j>>2]);c[m>>2]=2;g[m+4>>2]=r;g[m+8>>2]=s;CLa(l,m);c[n>>2]=-1;CLa(n,e);c[o>>2]=0;e=p+4096|0;c[e>>2]=0;g[p+4100>>2]=ea(0.0);g[q>>2]=ea(0.0);if(!(NNa(l,n,k,f,q,o,p)|0)){t=0;i=h;return t|0}if(!(f6a(a,b,c[e>>2]|0,p)|0)){t=0;i=h;return t|0}t=(c[e>>2]|0)!=0;i=h;return t|0}function RLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0;h=i;i=i+4304|0;j=h+4116|0;k=h+4144|0;l=h+4176|0;m=h+4160|0;n=h+4240|0;o=h+4112|0;p=h;q=h+4232|0;UUa(k,d);g[j>>2]=ea(g[k>>2]);g[j+4>>2]=ea(g[k+4>>2]);g[j+8>>2]=ea(g[k+8>>2]);g[j+12>>2]=ea(g[k+12>>2]);g[j+16>>2]=ea(g[d+36>>2]);g[j+20>>2]=ea(g[d+40>>2]);g[j+24>>2]=ea(g[d+44>>2]);c[l>>2]=-1;r=ea(g[d+48>>2]);s=ea(g[d+52>>2]);t=ea(g[d+56>>2]);c[m>>2]=3;g[m+4>>2]=r;g[m+8>>2]=s;g[m+12>>2]=t;CLa(l,m);c[n>>2]=-1;CLa(n,e);c[o>>2]=0;e=p+4096|0;c[e>>2]=0;g[p+4100>>2]=ea(0.0);g[q>>2]=ea(0.0);if(!(UNa(l,n,j,f,q,o,p)|0)){u=0;i=h;return u|0}if(!(f6a(a,b,c[e>>2]|0,p)|0)){u=0;i=h;return u|0}u=(c[e>>2]|0)!=0;i=h;return u|0}function SLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0;h=i;i=i+4288|0;j=h+4144|0;k=h+4208|0;l=h+4216|0;m=h+4272|0;n=h;o=h+4112|0;p=h+4200|0;c[j>>2]=-1;q=ea(g[d+12>>2]);c[k>>2]=0;g[k+4>>2]=q;CLa(j,k);c[l>>2]=-1;CLa(l,e);c[m>>2]=0;e=n+4096|0;c[e>>2]=0;g[n+4100>>2]=ea(0.0);g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(1.0);g[o+16>>2]=ea(g[d>>2]);g[o+20>>2]=ea(g[d+4>>2]);g[o+24>>2]=ea(g[d+8>>2]);g[p>>2]=ea(0.0);if(!(_Na(j,l,o,f,p,m,n)|0)){r=0;i=h;return r|0}if(!(f6a(a,b,c[e>>2]|0,n)|0)){r=0;i=h;return r|0}r=(c[e>>2]|0)!=0;i=h;return r|0}function TLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0;h=i;i=i+4288|0;j=h+4116|0;k=h+4120|0;l=h+4160|0;m=h+4148|0;n=h+4224|0;o=h+4112|0;p=h;q=h+4216|0;vKa(k,d,d+12|0,j);c[l>>2]=-1;r=ea(g[d+24>>2]);s=ea(g[j>>2]);c[m>>2]=2;g[m+4>>2]=r;g[m+8>>2]=s;CLa(l,m);c[n>>2]=-1;CLa(n,e);c[o>>2]=0;e=p+4096|0;c[e>>2]=0;g[p+4100>>2]=ea(0.0);g[q>>2]=ea(0.0);if(!(ONa(l,n,k,f,q,o,p)|0)){t=0;i=h;return t|0}if(!(f6a(a,b,c[e>>2]|0,p)|0)){t=0;i=h;return t|0}t=(c[e>>2]|0)!=0;i=h;return t|0}function ULa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0;h=i;i=i+4304|0;j=h+4116|0;k=h+4144|0;l=h+4176|0;m=h+4160|0;n=h+4240|0;o=h+4112|0;p=h;q=h+4232|0;UUa(k,d);g[j>>2]=ea(g[k>>2]);g[j+4>>2]=ea(g[k+4>>2]);g[j+8>>2]=ea(g[k+8>>2]);g[j+12>>2]=ea(g[k+12>>2]);g[j+16>>2]=ea(g[d+36>>2]);g[j+20>>2]=ea(g[d+40>>2]);g[j+24>>2]=ea(g[d+44>>2]);c[l>>2]=-1;r=ea(g[d+48>>2]);s=ea(g[d+52>>2]);t=ea(g[d+56>>2]);c[m>>2]=3;g[m+4>>2]=r;g[m+8>>2]=s;g[m+12>>2]=t;CLa(l,m);c[n>>2]=-1;CLa(n,e);c[o>>2]=0;e=p+4096|0;c[e>>2]=0;g[p+4100>>2]=ea(0.0);g[q>>2]=ea(0.0);if(!(WNa(l,n,j,f,q,o,p)|0)){u=0;i=h;return u|0}if(!(f6a(a,b,c[e>>2]|0,p)|0)){u=0;i=h;return u|0}u=(c[e>>2]|0)!=0;i=h;return u|0}function VLa(a){a=a|0;var b=0;b=i;i=i+16|0;WLa(a);VJa(b,a);i=b;return}function WLa(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=537552;d=c[a+52>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+44>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+40>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+32>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+28>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+20>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+16>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+8>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+4|0;nTa(c[d>>2]|0);a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function XLa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;if(c[d>>2]|0){e=a+8|0;do{f=c[c[e>>2]>>2]|0;ko[c[c[f>>2]>>2]&4095](f)}while((c[d>>2]|0)!=0)}d=a+24|0;if(c[d>>2]|0){e=a+20|0;do{f=c[c[e>>2]>>2]|0;ko[c[c[f>>2]>>2]&4095](f)}while((c[d>>2]|0)!=0)}d=a+36|0;if(c[d>>2]|0){e=a+32|0;do{f=c[c[e>>2]>>2]|0;ko[c[c[f>>2]>>2]&4095](f)}while((c[d>>2]|0)!=0)}if(!a){i=b;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);i=b;return}function YLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=a+8|0;h=d?a+4|0:0;c[f>>2]=b;if(!b){i=e;return}if(d)oTa(c[h>>2]|0);j=a+12|0;k=c[j>>2]|0;l=a+16|0;if(!k)if((c[l>>2]&2147483584)>>>0<64){g6a(g,64);m=c[j>>2]|0}else m=0;else m=k;if((c[l>>2]&2147483647)>>>0>m>>>0){l=(c[g>>2]|0)+(m<<2)|0;if(l)c[l>>2]=b;c[j>>2]=m+1}else h6a(g,f)|0;if(!d){i=e;return}pTa(c[h>>2]|0);i=e;return}function ZLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,240,h?538344:544544,537560,123)|0;UQa(g);if(!g){j=0;i=d;return j|0}c[g+224>>2]=a;if($Qa(g,b)|0){YLa(a,g,1);j=g;i=d;return j|0}a=g+8|0;if(gTa(g+12|0)|0){j=0;i=d;return j|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);j=0;i=d;return j|0}function _La(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=a+12|0;g=c[f>>2]|0;a:do if(!g)h=0;else{j=c[a+8>>2]|0;k=0;while(1){l=j+(k<<2)|0;k=k+1|0;if((c[l>>2]|0)==(b|0))break;if(k>>>0>=g>>>0){h=0;break a}}k=g+-1|0;c[f>>2]=k;c[l>>2]=c[j+(k<<2)>>2];h=1}while(0);pTa(c[e>>2]|0);i=d;return h|0}function $La(a){a=a|0;return c[a+12>>2]|0}function aMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[a+12>>2]|0)-e|0;h=(g|0)<0?0:g;j=h>>>0<d>>>0?h:d;if(!j){i=f;return j|0}h=a+8|0;a=~d;d=(g|0)>0?~g:-1;g=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[h>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(g|0));i=f;return j|0}function bMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=a+20|0;h=d?a+4|0:0;c[f>>2]=b;if(!b){i=e;return}if(d)oTa(c[h>>2]|0);j=a+24|0;k=c[j>>2]|0;l=a+28|0;if(!k)if((c[l>>2]&2147483584)>>>0<64){i6a(g,64);m=c[j>>2]|0}else m=0;else m=k;if((c[l>>2]&2147483647)>>>0>m>>>0){l=(c[g>>2]|0)+(m<<2)|0;if(l)c[l>>2]=b;c[j>>2]=m+1}else j6a(g,f)|0;if(!d){i=e;return}pTa(c[h>>2]|0);i=e;return}function cMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,132,h?538104:544544,537560,182)|0;mOa(g);if(!g){j=0;i=d;return j|0}c[g+128>>2]=a;if(sOa(g,b)|0){bMa(a,g,1);j=g;i=d;return j|0}a=g+8|0;if(gTa(g+12|0)|0){j=0;i=d;return j|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);j=0;i=d;return j|0}function dMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=a+24|0;g=c[f>>2]|0;a:do if(!g)h=0;else{j=c[a+20>>2]|0;k=0;while(1){l=j+(k<<2)|0;k=k+1|0;if((c[l>>2]|0)==(b|0))break;if(k>>>0>=g>>>0){h=0;break a}}k=g+-1|0;c[f>>2]=k;c[l>>2]=c[j+(k<<2)>>2];h=1}while(0);pTa(c[e>>2]|0);i=d;return h|0}function eMa(a){a=a|0;return c[a+24>>2]|0}function fMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[a+24>>2]|0)-e|0;h=(g|0)<0?0:g;j=h>>>0<d>>>0?h:d;if(!j){i=f;return j|0}h=a+20|0;a=~d;d=(g|0)>0?~g:-1;g=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[h>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(g|0));i=f;return j|0}function gMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=a+32|0;h=d?a+4|0:0;c[f>>2]=b;if(!b){i=e;return}if(d)oTa(c[h>>2]|0);j=a+36|0;k=c[j>>2]|0;l=a+40|0;if(!k)if((c[l>>2]&2147483584)>>>0<64){k6a(g,64);m=c[j>>2]|0}else m=0;else m=k;if((c[l>>2]&2147483647)>>>0>m>>>0){l=(c[g>>2]|0)+(m<<2)|0;if(l)c[l>>2]=b;c[j>>2]=m+1}else l6a(g,f)|0;if(!d){i=e;return}pTa(c[h>>2]|0);i=e;return}function hMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,116,h?537856:544544,537560,243)|0;eRa(g,a);if(!g){j=0;i=d;return j|0}if(sRa(g,b,1)|0){gMa(a,g,1);j=g;i=d;return j|0}a=g+8|0;if(gTa(g+12|0)|0){j=0;i=d;return j|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);j=0;i=d;return j|0}function iMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,116,h?537856:544544,537560,259)|0;eRa(g,a);if(!g){j=0;i=d;return j|0}if(rRa(g,b)|0){gMa(a,g,1);j=g;i=d;return j|0}a=g+8|0;if(gTa(g+12|0)|0){j=0;i=d;return j|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);j=0;i=d;return j|0}function jMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+4|0;oTa(c[e>>2]|0);f=a+36|0;g=c[f>>2]|0;a:do if(!g)h=0;else{j=c[a+32>>2]|0;k=0;while(1){l=j+(k<<2)|0;k=k+1|0;if((c[l>>2]|0)==(b|0))break;if(k>>>0>=g>>>0){h=0;break a}}k=g+-1|0;c[f>>2]=k;c[l>>2]=c[j+(k<<2)>>2];h=1}while(0);pTa(c[e>>2]|0);i=d;return h|0}function kMa(a){a=a|0;return c[a+36>>2]|0}function lMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(c[a+36>>2]|0)-e|0;h=(g|0)<0?0:g;j=h>>>0<d>>>0?h:d;if(!j){i=f;return j|0}h=a+32|0;a=~d;d=(g|0)>0?~g:-1;g=~(d>>>0<a>>>0?a:d);d=0;do{c[b+(d<<2)>>2]=c[(c[h>>2]|0)+(d+e<<2)>>2];d=d+1|0}while((d|0)!=(g|0));i=f;return j|0}function mMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=a+44|0;c[e>>2]=b;g=a+48|0;h=c[g>>2]|0;if((c[a+52>>2]&2147483647)>>>0<=h>>>0){m6a(f,e)|0;i=d;return}e=(c[f>>2]|0)+(h<<2)|0;if(e)c[e>>2]=b;c[g>>2]=h+1;i=d;return}function nMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[a+48>>2]|0;if(!g){i=f;return}h=a+44|0;a=0;do{j=c[(c[h>>2]|0)+(a<<2)>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,b,d,e);a=a+1|0}while((a|0)!=(g|0));i=f;return}function oMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0;h=i;i=i+112|0;j=h+32|0;k=h+68|0;l=h+56|0;m=h+80|0;n=h+4|0;o=h+44|0;p=h+92|0;switch(c[a>>2]|0){case 0:{q=ea(ea(g[a+4>>2])+e);r=d+16|0;s=ea(ea(g[r>>2])-q);t=d+20|0;u=ea(ea(g[t>>2])-q);v=d+24|0;w=ea(ea(g[v>>2])-q);g[b>>2]=s;g[b+4>>2]=u;g[b+8>>2]=w;w=ea(q+ea(g[r>>2]));u=ea(q+ea(g[t>>2]));s=ea(q+ea(g[v>>2]));g[b+12>>2]=w;g[b+16>>2]=u;g[b+20>>2]=s;i=h;return}case 2:{s=ea(g[d>>2]);u=ea(s*ea(2.0));w=ea(g[d+12>>2]);q=ea(w*ea(2.0));x=ea(ea(s*u)+ea(ea(w*q)+ea(-1.0)));w=ea(g[d+8>>2]);s=ea(w*q);y=ea(g[d+4>>2]);z=ea(s+ea(u*y));s=ea(ea(u*w)-ea(q*y));y=ea(g[a+8>>2]);q=ea(g[a+4>>2]);w=ea(ea(ea(ea(S(ea(x)))*y)+q)+e);x=ea(ea(ea(ea(S(ea(z)))*y)+q)+e);z=ea(ea(ea(ea(S(ea(s)))*y)+q)+e);v=d+16|0;q=ea(ea(g[v>>2])-w);t=d+20|0;y=ea(ea(g[t>>2])-x);r=d+24|0;s=ea(ea(g[r>>2])-z);g[b>>2]=q;g[b+4>>2]=y;g[b+8>>2]=s;s=ea(ea(g[v>>2])+w);w=ea(ea(g[t>>2])+x);x=ea(ea(g[r>>2])+z);g[b+12>>2]=s;g[b+16>>2]=w;g[b+20>>2]=x;i=h;return}case 1:{n6a(b,d,e);i=h;return}case 5:{if(!f)o6a(d,(c[a+40>>2]|0)+128|0,a+4|0,l,m);else o6a(d,f,a+4|0,l,m);x=ea(g[l>>2]);w=ea(g[m>>2]);s=ea(x-w);z=ea(g[l+4>>2]);y=ea(g[m+4>>2]);q=ea(z-y);u=ea(g[l+8>>2]);A=ea(g[m+8>>2]);B=ea(q-e);q=ea(ea(u-A)-e);g[b>>2]=ea(s-e);g[b+4>>2]=B;g[b+8>>2]=q;q=ea(ea(z+y)+e);y=ea(ea(u+A)+e);g[b+12>>2]=ea(ea(x+w)+e);g[b+16>>2]=q;g[b+20>>2]=y;i=h;return}case 3:{y=ea(g[d>>2]);q=ea(g[d+4>>2]);w=ea(g[d+8>>2]);x=ea(g[d+12>>2]);A=ea(y+y);u=ea(q+q);z=ea(w+w);B=ea(q*u);s=ea(w*z);C=ea(A*q);q=ea(A*w);D=ea(A*x);E=ea(u*w);w=ea(u*x);u=ea(z*x);x=ea(ea(ea(1.0)-B)-s);z=ea(C+u);F=ea(q-w);G=ea(C-u);u=ea(ea(1.0)-ea(y*A));A=ea(u-s);s=ea(E+D);y=ea(q+w);w=ea(E-D);D=ea(u-B);B=ea(g[a+4>>2]);u=ea(g[a+8>>2]);E=ea(g[a+12>>2]);q=ea(ea(ea(S(ea(B*x)))+ea(S(ea(G*u))))+ea(S(ea(y*E))));y=ea(ea(ea(S(ea(B*z)))+ea(S(ea(A*u))))+ea(S(ea(w*E))));w=ea(ea(ea(S(ea(B*F)))+ea(S(ea(s*u))))+ea(S(ea(D*E))));m=d+16|0;E=ea(ea(g[m>>2])-q);l=d+20|0;r=d+24|0;D=ea(ea(ea(g[l>>2])-y)-e);u=ea(ea(ea(g[r>>2])-w)-e);g[b>>2]=ea(E-e);g[b+4>>2]=D;g[b+8>>2]=u;u=ea(q+ea(g[m>>2]));q=ea(ea(y+ea(g[l>>2]))+e);y=ea(ea(w+ea(g[r>>2]))+e);g[b+12>>2]=ea(u+e);g[b+16>>2]=q;g[b+20>>2]=y;i=h;return}case 4:{if(!f)o6a(d,c[a+36>>2]|0,a+4|0,j,k);else o6a(d,f,a+4|0,j,k);y=ea(g[j>>2]);q=ea(g[k>>2]);u=ea(y-q);w=ea(g[j+4>>2]);D=ea(g[k+4>>2]);E=ea(w-D);s=ea(g[j+8>>2]);F=ea(g[k+8>>2]);B=ea(E-e);E=ea(ea(s-F)-e);g[b>>2]=ea(u-e);g[b+4>>2]=B;g[b+8>>2]=E;E=ea(ea(w+D)+e);D=ea(ea(s+F)+e);g[b+12>>2]=ea(ea(y+q)+e);g[b+16>>2]=E;g[b+20>>2]=D;i=h;return}case 6:{D=ea(g[a+12>>2]);E=ea(g[a+8>>2]);q=ea(g[a+16>>2]);g[n>>2]=D;g[n+4>>2]=E;g[n+8>>2]=q;g[n+12>>2]=ea(0.0);g[n+16>>2]=ea(0.0);g[n+20>>2]=ea(0.0);g[n+24>>2]=ea(1.0);if(!f){k=c[a+24>>2]|0;o6a(d,k+40|0,n,o,p);H=k}else{o6a(d,f,n,o,p);H=c[a+24>>2]|0}q=ea(g[H+24>>2]);E=ea(g[o>>2]);D=ea(g[p>>2]);y=ea(E-D);F=ea(g[o+4>>2]);s=ea(g[p+4>>2]);w=ea(F-s);B=ea(g[o+8>>2]);u=ea(g[p+8>>2]);A=ea(w-e);w=ea(ea(B-u)-e);g[b>>2]=ea(y-e);p=b+4|0;g[p>>2]=A;g[b+8>>2]=w;w=ea(ea(F+s)+e);s=ea(ea(B+u)+e);g[b+12>>2]=ea(ea(E+D)+e);o=b+16|0;g[o>>2]=w;g[b+20>>2]=s;if(q<ea(0.0)){g[p>>2]=ea(q+A);i=h;return}else{g[o>>2]=ea(q+w);i=h;return}break}default:{dKa(bKa()|0,32,538592,314,538672,h);i=h;return}}}function pMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im;h=i;i=i+64|0;j=h+32|0;k=h+4|0;switch(c[a>>2]|0){case 0:{g[b>>2]=ea(g[e+16>>2]);g[b+4>>2]=ea(g[e+20>>2]);g[b+8>>2]=ea(g[e+24>>2]);l=a+4|0;m=ea(g[l>>2]);g[d>>2]=m;g[d+4>>2]=m;g[d+8>>2]=m;n=ea(ea(g[l>>2])*ea(.75));i=h;return ea(n)}case 2:{g[b>>2]=ea(g[e+16>>2]);g[b+4>>2]=ea(g[e+20>>2]);g[b+8>>2]=ea(g[e+24>>2]);m=ea(g[e>>2]);o=ea(m*ea(2.0));p=ea(g[e+12>>2]);q=ea(p*ea(2.0));r=ea(ea(m*o)+ea(ea(p*q)+ea(-1.0)));p=ea(g[e+8>>2]);m=ea(p*q);s=ea(g[e+4>>2]);t=ea(m+ea(o*s));m=ea(ea(o*p)-ea(q*s));l=a+8|0;u=a+4|0;g[d>>2]=ea(ea(ea(S(ea(r)))*ea(g[l>>2]))+ea(g[u>>2]));g[d+4>>2]=ea(ea(ea(S(ea(t)))*ea(g[l>>2]))+ea(g[u>>2]));g[d+8>>2]=ea(ea(ea(S(ea(m)))*ea(g[l>>2]))+ea(g[u>>2]));n=ea(ea(g[u>>2])*ea(.75));i=h;return ea(n)}case 1:{n6a(j,e,ea(0.0));m=ea(g[j>>2]);t=ea(g[j+12>>2]);r=ea(m+t);s=ea(g[j+4>>2]);q=ea(g[j+16>>2]);p=ea(s+q);o=ea(g[j+8>>2]);v=ea(g[j+20>>2]);w=ea(p*ea(.5));p=ea(ea(o+v)*ea(.5));g[b>>2]=ea(r*ea(.5));g[b+4>>2]=w;g[b+8>>2]=p;p=ea(ea(q-s)*ea(.5));s=ea(ea(v-o)*ea(.5));g[d>>2]=ea(ea(t-m)*ea(.5));g[d+4>>2]=p;g[d+8>>2]=s;n=ea(3402823469999999843913219.0e14);i=h;return ea(n)}case 6:{s=ea(g[a+12>>2]);p=ea(g[a+8>>2]);m=ea(g[a+16>>2]);g[k>>2]=s;g[k+4>>2]=p;g[k+8>>2]=m;g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(1.0);if(!f){o6a(e,(c[a+24>>2]|0)+40|0,k,b,d);n=ea(0.0);i=h;return ea(n)}else{o6a(e,f,k,b,d);n=ea(0.0);i=h;return ea(n)}break}case 3:{m=ea(g[e>>2]);p=ea(g[e+4>>2]);s=ea(g[e+8>>2]);t=ea(g[e+12>>2]);o=ea(m+m);v=ea(p+p);q=ea(s+s);w=ea(p*v);r=ea(s*q);x=ea(o*p);p=ea(o*s);y=ea(o*t);z=ea(v*s);s=ea(v*t);v=ea(q*t);t=ea(ea(ea(1.0)-w)-r);q=ea(x+v);A=ea(p-s);B=ea(x-v);v=ea(ea(1.0)-ea(m*o));o=ea(v-r);r=ea(z+y);m=ea(p+s);s=ea(z-y);y=ea(v-w);k=a+4|0;w=ea(g[k>>2]);j=a+8|0;v=ea(g[j>>2]);u=a+12|0;z=ea(g[u>>2]);p=ea(w*q);q=ea(w*A);A=ea(o*v);o=ea(r*v);r=ea(s*z);s=ea(y*z);g[d>>2]=ea(ea(ea(S(ea(w*t)))+ea(S(ea(B*v))))+ea(S(ea(m*z))));g[d+4>>2]=ea(ea(ea(S(ea(p)))+ea(S(ea(A))))+ea(S(ea(r))));g[d+8>>2]=ea(ea(ea(S(ea(q)))+ea(S(ea(o))))+ea(S(ea(s))));g[b>>2]=ea(g[e+16>>2]);g[b+4>>2]=ea(g[e+20>>2]);g[b+8>>2]=ea(g[e+24>>2]);s=ea(g[k>>2]);o=ea(g[j>>2]);q=s<o?s:o;o=ea(g[u>>2]);n=ea((q<o?q:o)*ea(.75));i=h;return ea(n)}case 4:{u=c[a+36>>2]|0;if(!f)o6a(e,u,a+4|0,b,d);else o6a(e,f,a+4|0,b,d);o=ea(g[a+12>>2]);q=ea(g[a+4>>2]);s=ea(g[a+8>>2]);r=q<s?q:s;n=ea(ea(ea(g[u+48>>2])*(o<r?o:r))*ea(.75));i=h;return ea(n)}case 5:{if(!f){o6a(e,(c[a+40>>2]|0)+128|0,a+4|0,b,d);n=ea(0.0);i=h;return ea(n)}else{o6a(e,f,a+4|0,b,d);n=ea(0.0);i=h;return ea(n)}break}default:{dKa(bKa()|0,32,538592,449,538672,h);n=ea(3402823469999999843913219.0e14);i=h;return ea(n)}}return ea(0.0)}function qMa(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=0;c=i;d=ea(g[a>>2]);e=ea(d-ea(g[b+36>>2]));d=ea(g[a+4>>2]);f=ea(d-ea(g[b+40>>2]));d=ea(g[a+8>>2]);h=ea(d-ea(g[b+44>>2]));d=ea(g[b>>2]);j=ea(e*d);k=ea(g[b+4>>2]);l=ea(j+ea(f*k));j=ea(g[b+8>>2]);m=ea(l+ea(h*j));l=ea(g[b+12>>2]);n=ea(e*l);o=ea(g[b+16>>2]);p=ea(n+ea(f*o));n=ea(g[b+20>>2]);q=ea(p+ea(h*n));p=ea(g[b+24>>2]);r=ea(e*p);s=ea(g[b+28>>2]);t=ea(r+ea(f*s));r=ea(g[b+32>>2]);u=ea(t+ea(h*r));t=ea(g[b+48>>2]);v=ea(-t);if(!(m<v))if(m>t){w=t;x=1}else{w=m;x=0}else{w=v;x=1}v=ea(g[b+52>>2]);m=ea(-v);if(!(q<m))if(q>v){y=v;z=1}else{y=q;z=x}else{y=m;z=1}m=ea(g[b+56>>2]);q=ea(-m);if(!(u<q)){b=u>m;if(b|z){A=b?m:u;B=9}}else{A=q;B=9}if((B|0)==9?(q=ea(e-ea(ea(ea(w*d)+ea(y*l))+ea(A*p))),p=ea(f-ea(ea(ea(w*k)+ea(y*o))+ea(A*s))),s=ea(h-ea(ea(ea(w*j)+ea(y*n))+ea(A*r))),r=ea(ea(ea(q*q)+ea(p*p))+ea(s*s)),s=ea(g[a+12>>2]),r>ea(s*s)):0){C=0;i=c;return C|0}C=1;i=c;return C|0}function rMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0;f=i;i=i+512|0;h=f+492|0;j=f+64|0;k=f+16|0;l=f+480|0;m=f+256|0;n=f;o=f+272|0;p=f+96|0;q=f+32|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;r=ea(g[a+12>>2]);s=ea(g[d>>2]);t=ea(g[d+4>>2]);u=ea(g[d+8>>2]);g[m>>2]=s;g[m+4>>2]=t;g[m+8>>2]=u;g[m+12>>2]=ea(0.0);v=d+12|0;u=ea(g[v>>2]);t=ea(g[v+4>>2]);s=ea(g[v+8>>2]);w=ea(g[v+12>>2]);g[n>>2]=u;g[n+4>>2]=t;g[n+8>>2]=s;g[n+12>>2]=w;w=ea(g[a>>2]);s=ea(g[a+4>>2]);t=ea(g[a+8>>2]);u=ea(-ea(g[e>>2]));x=ea(-ea(g[e+4>>2]));y=ea(-ea(g[e+8>>2]));z=ea(g[e+12>>2]);A=ea(w-ea(g[e+16>>2]));w=ea(s-ea(g[e+20>>2]));s=ea(A*ea(2.0));A=ea(w*ea(2.0));w=ea(ea(t-ea(g[e+24>>2]))*ea(2.0));t=ea(ea(z*z)+ea(-.5));B=ea(ea(ea(s*u)+ea(A*x))+ea(w*y));C=ea(ea(B*u)+ea(ea(t*s)+ea(z*ea(ea(w*x)-ea(A*y)))));D=ea(ea(B*x)+ea(ea(t*A)+ea(z*ea(ea(s*y)-ea(w*u)))));E=ea(ea(ea(t*w)+ea(z*ea(ea(A*u)-ea(s*x))))+ea(B*y));z1a(o,b+16|0,k,m,n);n=p+64|0;c[p+80>>2]=4;m=p+20|0;k=p+36|0;g[p+48>>2]=ea(0.0);b=p+52|0;c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];g[p>>2]=C;g[p+4>>2]=D;g[p+8>>2]=E;g[p+12>>2]=ea(0.0);g[p+128>>2]=r;h=p+132|0;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];g[p+96>>2]=C;g[p+100>>2]=D;g[p+104>>2]=E;g[p+108>>2]=ea(0.0);g[p+112>>2]=C;g[p+116>>2]=D;g[p+120>>2]=E;g[p+124>>2]=ea(0.0);g[p+16>>2]=r;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];g[p+32>>2]=r;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[j+0>>2]=-1;c[j+4>>2]=-1;c[j+8>>2]=-1;c[j+12>>2]=-1;c[n+0>>2]=c[j+0>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];c[n+12>>2]=c[j+12>>2];if((wPa(p,o,f+80|0,f+240|0,f+48|0,q)|0)==1){F=1;i=f;return F|0}E=ea(r*r);F=E>=ea(g[q>>2]);i=f;return F|0}function sMa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0;h=i;i=i+512|0;j=h+492|0;k=h+64|0;l=h+16|0;m=h+480|0;n=h+256|0;o=h;p=h+272|0;q=h+96|0;r=h+32|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;s=ea(g[a+8>>2]);t=ea(g[a+4>>2]);u=ea(g[e>>2]);v=ea(g[e+4>>2]);w=ea(g[e+8>>2]);g[n>>2]=u;g[n+4>>2]=v;g[n+8>>2]=w;g[n+12>>2]=ea(0.0);a=e+12|0;w=ea(g[a>>2]);v=ea(g[a+4>>2]);u=ea(g[a+8>>2]);x=ea(g[a+12>>2]);g[o>>2]=w;g[o+4>>2]=v;g[o+8>>2]=u;g[o+12>>2]=x;x=ea(-ea(g[f>>2]));u=ea(-ea(g[f+4>>2]));v=ea(-ea(g[f+8>>2]));w=ea(g[f+12>>2]);y=ea(g[b+16>>2]);z=ea(y-ea(g[f+16>>2]));y=ea(g[b+20>>2]);A=ea(y-ea(g[f+20>>2]));y=ea(g[b+24>>2]);B=ea(z*ea(2.0));z=ea(A*ea(2.0));A=ea(ea(y-ea(g[f+24>>2]))*ea(2.0));y=ea(ea(w*w)+ea(-.5));C=ea(ea(ea(B*x)+ea(z*u))+ea(A*v));D=ea(ea(C*x)+ea(ea(y*B)+ea(w*ea(ea(A*u)-ea(z*v)))));E=ea(ea(C*u)+ea(ea(y*z)+ea(w*ea(ea(B*v)-ea(A*x)))));F=ea(ea(ea(y*A)+ea(w*ea(ea(z*x)-ea(B*u))))+ea(C*v));C=ea(g[b>>2]);B=ea(w*C);z=ea(g[b+12>>2]);A=ea(B+ea(z*x));B=ea(g[b+8>>2]);y=ea(A+ea(B*u));A=ea(g[b+4>>2]);G=ea(y-ea(A*v));y=ea(ea(ea(C*v)+ea(ea(z*u)+ea(w*A)))-ea(B*x));H=ea(ea(ea(A*x)+ea(ea(z*v)+ea(w*B)))-ea(C*u));I=ea(ea(ea(ea(w*z)-ea(C*x))-ea(A*u))-ea(B*v));v=ea(G+G);B=ea(y+y);u=ea(H+H);A=ea(y*B);x=ea(H*u);C=ea(v*y);y=ea(v*H);z=ea(v*I);w=ea(H*B);H=ea(I*B);B=ea(I*u);u=ea(ea(1.0)-ea(G*v));v=ea(ea(ea(1.0)-A)-x);G=ea(C+B);I=ea(y-H);J=ea(C-B);B=ea(u-x);x=ea(z+w);C=ea(y+H);H=ea(w-z);z=ea(u-A);z1a(p,d+16|0,l,n,o);A=ea(s*ea(0.0));u=ea(ea(A*C)+ea(ea(A*J)+ea(s*v)));v=ea(ea(ea(s*G)+ea(A*B))+ea(A*H));H=ea(ea(A*z)+ea(ea(s*I)+ea(A*x)));o=q+64|0;g[q>>2]=D;g[q+4>>2]=E;g[q+8>>2]=F;g[q+12>>2]=ea(0.0);c[q+80>>2]=4;n=q+20|0;l=q+36|0;g[q+48>>2]=ea(0.0);d=q+52|0;c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];g[q+128>>2]=t;j=q+132|0;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];x=ea(E+v);A=ea(F+H);g[q+96>>2]=ea(D+u);g[q+100>>2]=x;g[q+104>>2]=A;g[q+108>>2]=ea(0.0);A=ea(E-v);v=ea(F-H);g[q+112>>2]=ea(D-u);g[q+116>>2]=A;g[q+120>>2]=v;g[q+124>>2]=ea(0.0);g[q+16>>2]=t;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];g[q+32>>2]=t;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[k+0>>2]=-1;c[k+4>>2]=-1;c[k+8>>2]=-1;c[k+12>>2]=-1;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];if((wPa(q,p,h+80|0,h+240|0,h+48|0,r)|0)==1){K=1;i=h;return K|0}v=ea(t*t);K=v>=ea(g[r>>2]);i=h;return K|0}function tMa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;h=i;i=i+592|0;j=h+16|0;k=h+576|0;l=h+64|0;m=h+256|0;n=h+272|0;o=h+304|0;p=h+368|0;q=h+96|0;r=h+80|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;s=ea(g[e>>2]);t=ea(g[e+4>>2]);u=ea(g[e+8>>2]);g[m>>2]=s;v=m+4|0;g[v>>2]=t;w=m+8|0;g[w>>2]=u;g[m+12>>2]=ea(0.0);x=e+12|0;u=ea(g[x>>2]);t=ea(g[x+4>>2]);s=ea(g[x+8>>2]);y=ea(g[x+12>>2]);g[n>>2]=u;g[n+4>>2]=t;g[n+8>>2]=s;g[n+12>>2]=y;y=ea(g[a+4>>2]);s=ea(g[a+8>>2]);t=ea(g[a+12>>2]);u=ea(-ea(g[f>>2]));z=ea(-ea(g[f+4>>2]));A=ea(-ea(g[f+8>>2]));B=ea(g[f+12>>2]);C=ea(g[b+16>>2]);D=ea(C-ea(g[f+16>>2]));C=ea(g[b+20>>2]);E=ea(C-ea(g[f+20>>2]));C=ea(g[b+24>>2]);F=ea(D*ea(2.0));D=ea(E*ea(2.0));E=ea(ea(C-ea(g[f+24>>2]))*ea(2.0));C=ea(ea(B*B)+ea(-.5));G=ea(ea(ea(F*u)+ea(D*z))+ea(E*A));H=ea(ea(G*u)+ea(ea(C*F)+ea(B*ea(ea(E*z)-ea(D*A)))));I=ea(ea(G*z)+ea(ea(C*D)+ea(B*ea(ea(F*A)-ea(E*u)))));J=ea(ea(ea(C*E)+ea(B*ea(ea(D*u)-ea(F*z))))+ea(G*A));G=ea(g[b>>2]);F=ea(B*G);D=ea(g[b+12>>2]);E=ea(F+ea(D*u));F=ea(g[b+8>>2]);C=ea(E+ea(F*z));E=ea(g[b+4>>2]);K=ea(C-ea(E*A));C=ea(ea(ea(G*A)+ea(ea(D*z)+ea(B*E)))-ea(F*u));L=ea(ea(ea(E*u)+ea(ea(D*A)+ea(B*F)))-ea(G*z));M=ea(ea(ea(ea(B*D)-ea(G*u))-ea(E*z))-ea(F*A));g[o+48>>2]=H;g[o+52>>2]=I;g[o+56>>2]=J;g[o+60>>2]=ea(0.0);J=ea(K+K);I=ea(C+C);H=ea(L+L);A=ea(C*I);F=ea(L*H);z=ea(J*C);C=ea(J*L);E=ea(J*M);u=ea(L*I);L=ea(M*I);I=ea(M*H);H=ea(ea(1.0)-ea(K*J));J=ea(z+I);K=ea(C-L);M=ea(z-I);I=ea(H-F);z=ea(E+u);G=ea(C+L);L=ea(u-E);E=ea(H-A);g[o>>2]=ea(ea(ea(1.0)-A)-F);g[o+4>>2]=J;g[o+8>>2]=K;g[o+12>>2]=ea(0.0);g[o+16>>2]=M;g[o+20>>2]=I;g[o+24>>2]=z;g[o+28>>2]=ea(0.0);g[o+32>>2]=G;g[o+36>>2]=L;g[o+40>>2]=E;g[o+44>>2]=ea(0.0);z1a(p,d+16|0,l,m,n);n=q+64|0;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];c[q+12>>2]=c[l+12>>2];c[q+80>>2]=3;l=q+20|0;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];b=q+36|0;g[q+48>>2]=ea(0.0);f=q+52|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[n+0>>2]=c[j+0>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];c[n+12>>2]=c[j+12>>2];g[q+144>>2]=y;g[q+148>>2]=s;g[q+152>>2]=t;g[q+156>>2]=ea(0.0);E=!(y<=s)?s:y;L=!(E<=t)?t:E;E=!(y>=s)?s:y;y=ea(L*ea(.150000006));s=ea((!(E>=t)?t:E)*ea(.0299999993));E=y>s?y:s;g[q+16>>2]=L>E?E:L;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];g[q+32>>2]=ea(L*ea(.0500000007));c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];E=ea(g[d+68>>2]);s=ea(g[d+72>>2]);y=ea(g[d+76>>2]);t=ea(g[m>>2]);G=ea(g[v>>2]);z=ea(E*t);t=ea(s*G);G=ea(y*ea(g[w>>2]));y=!(z<=t)?t:z;z=ea(ea(L*ea(.00999999977))+ea((!(y<=G)?G:y)*ea(.00999999977)));g[r>>2]=ea(z*z);w=(yPa(q,p,o,r,h+32|0,h+48|0,h+288|0,h)|0)==1;i=h;return w|0}function uMa(){return 538728}function vMa(){c[134688]=196;c[134695]=197;c[134702]=198;c[134709]=199;c[134716]=200;c[134723]=201;c[134730]=202;return}function wMa(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=0,H=Im,I=Im,J=0,K=0,L=0,M=Im,N=0,O=0;o=i;i=i+80|0;n=o+24|0;m=o+48|0;k=o+60|0;p=o+72|0;q=o+12|0;r=o;s=o+36|0;t=ea(g[e>>2]);u=d+16|0;v=ea(t-ea(g[u>>2]));t=ea(g[e+4>>2]);w=d+20|0;x=ea(t-ea(g[w>>2]));t=ea(g[e+8>>2]);e=d+24|0;y=ea(v*ea(2.0));v=ea(x*ea(2.0));x=ea(ea(t-ea(g[e>>2]))*ea(2.0));z=d+12|0;t=ea(g[z>>2]);A=ea(ea(t*t)+ea(-.5));B=ea(g[d>>2]);C=ea(y*B);D=d+4|0;E=ea(g[D>>2]);F=ea(C+ea(v*E));G=d+8|0;C=ea(g[G>>2]);H=ea(F+ea(x*C));F=ea(ea(E*H)+ea(ea(v*A)-ea(t*ea(ea(y*C)-ea(x*B)))));I=ea(ea(ea(x*A)-ea(t*ea(ea(v*B)-ea(y*E))))+ea(C*H));g[n>>2]=ea(ea(B*H)+ea(ea(y*A)-ea(t*ea(ea(x*E)-ea(v*C)))));g[n+4>>2]=F;g[n+8>>2]=I;I=ea(ea(g[f>>2])*ea(2.0));J=f+4|0;F=ea(ea(g[J>>2])*ea(2.0));K=f+8|0;v=ea(ea(g[K>>2])*ea(2.0));x=ea(ea(ea(I*B)+ea(F*E))+ea(v*C));y=ea(ea(E*x)+ea(ea(F*A)-ea(t*ea(ea(I*C)-ea(v*B)))));H=ea(ea(ea(v*A)-ea(t*ea(ea(F*B)-ea(I*E))))+ea(C*x));g[m>>2]=ea(ea(B*x)+ea(ea(I*A)-ea(t*ea(ea(v*E)-ea(F*C)))));g[m+4>>2]=y;g[m+8>>2]=H;H=ea(g[a+4>>2]);g[q>>2]=H;y=ea(g[a+8>>2]);g[q+4>>2]=y;C=ea(g[a+12>>2]);g[q+8>>2]=C;F=ea(-y);y=ea(-C);g[r>>2]=ea(-H);g[r+4>>2]=F;g[r+8>>2]=y;a=PPa(r,q,n,m,k,p)|0;y=ea(g[p>>2]);if((a|0)==0|y>h){L=0;i=o;return L|0}g[l+40>>2]=y;c[l+8>>2]=-1;g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);p=b[j>>1]|0;if((p&1)!=0&y!=ea(0.0)){h=ea(ea(g[k>>2])*ea(2.0));F=ea(ea(g[k+4>>2])*ea(2.0));H=ea(ea(g[k+8>>2])*ea(2.0));C=ea(g[z>>2]);E=ea(ea(C*C)+ea(-.5));v=ea(g[d>>2]);t=ea(h*v);A=ea(g[D>>2]);I=ea(t+ea(F*A));t=ea(g[G>>2]);x=ea(I+ea(H*t));I=ea(ea(v*x)+ea(ea(h*E)+ea(C*ea(ea(H*A)-ea(F*t)))));B=ea(ea(A*x)+ea(ea(F*E)+ea(C*ea(ea(h*t)-ea(H*v)))));M=ea(ea(ea(H*E)+ea(C*ea(ea(F*v)-ea(h*A))))+ea(t*x));x=ea(ea(g[u>>2])+I);I=ea(ea(g[w>>2])+B);B=ea(ea(g[e>>2])+M);g[l+16>>2]=x;g[l+20>>2]=I;g[l+24>>2]=B;N=5}else N=4;do if(p&2){e=(N&65535|2)&65535;if(y==ea(0.0)){B=ea(-ea(g[f>>2]));I=ea(-ea(g[J>>2]));x=ea(-ea(g[K>>2]));g[l+28>>2]=B;g[l+32>>2]=I;g[l+36>>2]=x;O=e;break}else{w=a+-1|0;g[s>>2]=ea(0.0);u=s+4|0;g[u>>2]=ea(0.0);j=s+8|0;g[j>>2]=ea(0.0);m=ea(g[k+(w<<2)>>2])>ea(0.0);g[s+(w<<2)>>2]=m?ea(1.0):ea(-1.0);x=ea(ea(g[s>>2])*ea(2.0));I=ea(ea(g[u>>2])*ea(2.0));B=ea(ea(g[j>>2])*ea(2.0));M=ea(g[z>>2]);t=ea(ea(M*M)+ea(-.5));A=ea(g[d>>2]);h=ea(x*A);v=ea(g[D>>2]);F=ea(h+ea(I*v));h=ea(g[G>>2]);C=ea(F+ea(B*h));F=ea(ea(v*C)+ea(ea(I*t)+ea(M*ea(ea(x*h)-ea(B*A)))));E=ea(ea(ea(B*t)+ea(M*ea(ea(I*A)-ea(x*v))))+ea(h*C));g[l+28>>2]=ea(ea(A*C)+ea(ea(x*t)+ea(M*ea(ea(B*v)-ea(I*h)))));g[l+32>>2]=F;g[l+36>>2]=E;O=e;break}}else{g[l+28>>2]=ea(0.0);g[l+32>>2]=ea(0.0);g[l+36>>2]=ea(0.0);O=N}while(0);b[l+12>>1]=O;L=1;i=o;return L|0}function xMa(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=Im,s=Im,t=Im,u=Im;o=i;n=d+16|0;m=l+40|0;k=l+16|0;if(!(UPa(e,f,h,n,ea(g[a+4>>2]),m,k)|0)){p=0;i=o;return p|0}c[l+8>>2]=-1;g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);h=ea(g[m>>2]);m=h!=ea(0.0);a=m?5:4;if(!(b[j>>1]&2)){g[l+28>>2]=ea(0.0);g[l+32>>2]=ea(0.0);g[l+36>>2]=ea(0.0);q=a}else{j=l+28|0;if(!(h==ea(0.0))){h=ea(g[k>>2]);r=ea(h-ea(g[n>>2]));h=ea(g[l+20>>2]);s=ea(h-ea(g[d+20>>2]));h=ea(g[l+24>>2]);t=ea(h-ea(g[d+24>>2]));g[j>>2]=r;d=l+32|0;g[d>>2]=s;n=l+36|0;g[n>>2]=t;h=ea(T(ea(ea(t*t)+ea(ea(r*r)+ea(s*s)))));if(h>ea(0.0)){u=ea(ea(1.0)/h);g[j>>2]=ea(r*u);g[d>>2]=ea(s*u);g[n>>2]=ea(t*u)}}else{u=ea(-ea(g[f>>2]));t=ea(-ea(g[f+4>>2]));s=ea(-ea(g[f+8>>2]));g[j>>2]=u;g[l+32>>2]=t;g[l+36>>2]=s}q=(a&65535|2)&65535}b[l+12>>1]=q;p=1;i=o;return p|0}function yMa(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;o=i;i=i+48|0;n=o+16|0;m=o+8|0;k=o;p=ea(g[d>>2]);q=ea(p*ea(2.0));r=ea(g[d+12>>2]);s=ea(r*ea(2.0));t=ea(ea(p*q)+ea(ea(r*s)+ea(-1.0)));r=ea(g[d+8>>2]);p=ea(r*s);u=ea(g[d+4>>2]);v=ea(p+ea(q*u));p=ea(ea(q*r)-ea(s*u));u=ea(g[a+8>>2]);s=ea(u*t);t=ea(u*v);v=ea(u*p);p=ea(g[d+16>>2]);u=ea(p+s);r=ea(g[d+20>>2]);q=ea(r+t);w=ea(g[d+24>>2]);x=ea(v+w);g[n>>2]=u;d=n+4|0;g[d>>2]=q;y=n+8|0;g[y>>2]=x;x=ea(r-t);t=ea(w-v);z=n+12|0;g[z>>2]=ea(p-s);A=n+16|0;g[A>>2]=x;B=n+20|0;g[B>>2]=t;g[n+24>>2]=ea(g[a+4>>2]);a=TPa(e,f,n,m)|0;if((a|0)==1)C=ea(g[m>>2]);else if(a){t=ea(g[m>>2]);a=t<ea(-9.99999997e-07);x=ea(g[m+4>>2]);if(a&x<ea(-9.99999997e-07)){D=0;i=o;return D|0}s=t<x?t:x;if(s<ea(0.0))C=ea(0.0);else C=s}else{D=0;i=o;return D|0}if(C>h){D=0;i=o;return D|0}a=C!=ea(0.0);m=a?5:4;a=l+16|0;h=ea(C*ea(g[f>>2]));E=f+4|0;s=ea(C*ea(g[E>>2]));F=f+8|0;x=ea(C*ea(g[F>>2]));t=ea(h+ea(g[e>>2]));h=ea(s+ea(g[e+4>>2]));s=ea(x+ea(g[e+8>>2]));g[a>>2]=t;e=l+20|0;g[e>>2]=h;G=l+24|0;g[G>>2]=s;g[l+40>>2]=C;c[l+8>>2]=-1;g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);do if(b[j>>1]&2){H=(m&65535|2)&65535;if(C==ea(0.0)){s=ea(-ea(g[f>>2]));h=ea(-ea(g[E>>2]));t=ea(-ea(g[F>>2]));g[l+28>>2]=s;g[l+32>>2]=h;g[l+36>>2]=t;I=H;break}ea(IOa(n,n+12|0,a,k));t=ea(g[k>>2]);h=ea(g[z>>2]);s=ea(g[n>>2]);x=ea(h-s);h=ea(g[A>>2]);p=ea(g[d>>2]);v=ea(h-p);h=ea(g[B>>2]);w=ea(g[y>>2]);r=ea(s+ea(t*x));x=ea(p+ea(t*v));v=ea(w+ea(t*ea(h-w)));J=l+28|0;K=l+32|0;L=l+36|0;w=ea(ea(g[a>>2])-r);r=ea(ea(g[e>>2])-x);x=ea(ea(g[G>>2])-v);g[J>>2]=w;g[K>>2]=r;g[L>>2]=x;v=ea(T(ea(ea(x*x)+ea(ea(w*w)+ea(r*r)))));if(v>ea(0.0)){h=ea(ea(1.0)/v);g[J>>2]=ea(w*h);g[K>>2]=ea(r*h);g[L>>2]=ea(x*h);I=H}else I=H}else{g[l+28>>2]=ea(0.0);g[l+32>>2]=ea(0.0);g[l+36>>2]=ea(0.0);I=m}while(0);b[l+12>>1]=I;D=1;i=o;return D|0}function zMa(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0.0,z=Im,A=Im,B=Im,C=Im;o=i;i=i+16|0;n=o;tLa(n,d);p=ea(g[f>>2]);q=ea(g[n>>2]);r=ea(p*q);s=ea(g[f+4>>2]);t=ea(g[n+4>>2]);u=ea(r+ea(s*t));r=ea(g[f+8>>2]);v=ea(g[n+8>>2]);w=ea(u+ea(r*v));if(w>=ea(0.0)){x=0;i=o;return x|0}y=+w;if(y>-1.0e-07&y<1.0e-07){x=0;i=o;return x|0}u=ea(g[e>>2]);z=ea(q*u);A=ea(g[e+4>>2]);B=ea(z+ea(t*A));z=ea(g[e+8>>2]);C=ea(B+ea(v*z));B=ea(ea(-ea(ea(g[n+12>>2])+C))/w);w=ea(A+ea(s*B));s=ea(z+ea(r*B));g[l+16>>2]=ea(u+ea(p*B));g[l+20>>2]=w;g[l+24>>2]=s;if(B<ea(0.0)|B>h){x=0;i=o;return x|0}g[l+40>>2]=B;c[l+8>>2]=-1;g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);n=l+12|0;b[n>>1]=5;e=l+28|0;g[e>>2]=ea(0.0);f=l+32|0;g[f>>2]=ea(0.0);d=l+36|0;g[d>>2]=ea(0.0);if(!(b[j>>1]&2)){x=1;i=o;return x|0}g[e>>2]=q;g[f>>2]=t;g[d>>2]=v;b[n>>1]=7;x=1;i=o;return x|0}function AMa(d,e,f,h,j,k,l,m,n,o,p){d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=0,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,U=Im,V=0,W=Im,X=0,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=0,oa=0,pa=Im,qa=Im,ra=Im,sa=Im,ta=0,ua=0;p=i;i=i+112|0;o=p+56|0;n=p+28|0;l=p;q=c[d+32>>2]|0;r=d+4|0;s=ea(ea(1.0)/ea(g[r>>2]));t=d+8|0;u=ea(ea(1.0)/ea(g[t>>2]));v=d+12|0;w=ea(ea(1.0)/ea(g[v>>2]));g[n>>2]=s;g[n+4>>2]=u;g[n+8>>2]=w;x=d+16|0;g[n+12>>2]=ea(g[x>>2]);y=d+20|0;g[n+16>>2]=ea(g[y>>2]);z=d+24|0;g[n+20>>2]=ea(g[z>>2]);A=d+28|0;g[n+24>>2]=ea(g[A>>2]);d=e+16|0;w=ea(g[d>>2]);B=e+20|0;u=ea(g[B>>2]);C=e+24|0;s=ea(w*ea(-2.0));w=ea(u*ea(-2.0));u=ea(ea(g[C>>2])*ea(-2.0));D=e+12|0;E=ea(g[D>>2]);F=ea(ea(E*E)+ea(-.5));G=ea(g[e>>2]);H=ea(s*G);I=e+4|0;J=ea(g[I>>2]);K=ea(H+ea(w*J));L=e+8|0;H=ea(g[L>>2]);M=ea(K+ea(u*H));K=ea(ea(G*M)+ea(ea(s*F)-ea(E*ea(ea(u*J)-ea(w*H)))));N=ea(ea(J*M)+ea(ea(w*F)-ea(E*ea(ea(s*H)-ea(u*G)))));O=ea(ea(ea(u*F)-ea(E*ea(ea(w*G)-ea(s*J))))+ea(H*M));M=ea(-J);J=ea(-H);g[l>>2]=ea(-G);g[l+4>>2]=M;g[l+8>>2]=J;g[l+12>>2]=E;g[l+16>>2]=K;g[l+20>>2]=N;g[l+24>>2]=O;r6a(o,n,l);l=a[q+55>>0]|0;O=ea(g[f>>2]);N=ea(g[o>>2]);K=ea(O*N);n=o+4|0;E=ea(g[n>>2]);J=ea(O*E);P=o+8|0;M=ea(g[P>>2]);G=ea(O*M);O=ea(g[f+4>>2]);Q=o+12|0;H=ea(g[Q>>2]);s=ea(O*H);R=o+16|0;w=ea(g[R>>2]);F=ea(O*w);S=o+20|0;u=ea(g[S>>2]);U=ea(K+s);s=ea(J+F);F=ea(G+ea(O*u));O=ea(g[f+8>>2]);f=o+24|0;G=ea(g[f>>2]);J=ea(O*G);V=o+28|0;K=ea(g[V>>2]);W=ea(O*K);X=o+32|0;Y=ea(g[X>>2]);Z=ea(U+J);J=ea(s+W);W=ea(F+ea(O*Y));O=ea(Z+ea(g[o+36>>2]));Z=ea(J+ea(g[o+40>>2]));J=ea(W+ea(g[o+44>>2]));W=ea(g[h>>2]);F=ea(N*W);N=ea(E*W);E=ea(M*W);_=h+4|0;W=ea(g[_>>2]);M=ea(F+ea(H*W));H=ea(N+ea(w*W));w=ea(E+ea(u*W));$=h+8|0;W=ea(g[$>>2]);u=ea(M+ea(G*W));G=ea(H+ea(K*W));K=ea(w+ea(Y*W));if(l<<24>>24){aa=l&255;l=0;ba=0;ca=0;W=ea(3402823469999999843913219.0e14);Y=ea(-3402823469999999843913219.0e14);da=1;fa=c[q+56>>2]|0;a:while(1){aa=aa+-1|0;q=fa;fa=fa+20|0;w=ea(g[q>>2]);H=ea(O*w);M=ea(g[q+4>>2]);E=ea(H+ea(Z*M));H=ea(g[q+8>>2]);N=ea(E+ea(J*H));E=ea(ea(g[q+12>>2])+N);N=ea(ea(ea(u*w)+ea(G*M))+ea(K*H));H=ea(ea(-E)/N);ga=E>ea(0.0);da=da&(ga^1);do if(!(N>ea(1.00000001e-07))){if(!(N<ea(-1.00000001e-07)))if(ga){ha=0;ia=22;break a}else{ja=l;ka=ba;la=W;ma=Y;break}if(H>Y){ja=ca;ka=q;la=W;ma=H}else{ja=l;ka=ba;la=W;ma=Y}}else{ja=l;ka=ba;la=W<H?W:H;ma=Y}while(0);if(!aa)break;else{l=ja;ba=ka;ca=ca+1|0;W=la;Y=ma}}if((ia|0)==22){i=p;return ha|0}if(!da){if(!(ma<la&ma>ea(0.0)&ma<ea(j+ea(-9.99999974e-06)))){ha=0;i=p;return ha|0}da=b[k>>1]|0;if(!(da&1)){na=da;oa=4}else{j=ea(O+ea(u*ma));u=ea(Z+ea(G*ma));G=ea(J+ea(K*ma));K=ea(g[x>>2]);J=ea(g[y>>2]);Z=ea(g[z>>2]);O=ea(g[A>>2]);la=ea(K+K);Y=ea(J+J);W=ea(Z+Z);H=ea(J*Y);N=ea(Z*W);E=ea(la*J);J=ea(la*Z);M=ea(la*O);w=ea(Y*Z);Z=ea(Y*O);Y=ea(W*O);O=ea(ea(ea(1.0)-H)-N);W=ea(E+Y);F=ea(J-Z);s=ea(E-Y);Y=ea(ea(1.0)-ea(K*la));la=ea(Y-N);N=ea(w+M);K=ea(J+Z);Z=ea(w-M);M=ea(Y-H);H=ea(g[r>>2]);Y=ea(H*O);w=ea(H*s);J=ea(H*K);H=ea(g[t>>2]);E=ea(W*H);U=ea(la*H);pa=ea(Z*H);H=ea(g[v>>2]);qa=ea(F*H);ra=ea(N*H);sa=ea(M*H);H=ea(ea(ea(G*ea(ea(ea(K*Y)+ea(Z*E))+ea(M*qa)))+ea(ea(j*ea(ea(ea(O*Y)+ea(W*E))+ea(F*qa)))+ea(u*ea(ea(ea(s*Y)+ea(la*E))+ea(N*qa)))))*ea(2.0));qa=ea(ea(ea(G*ea(ea(ea(K*w)+ea(Z*U))+ea(M*ra)))+ea(ea(j*ea(ea(ea(O*w)+ea(W*U))+ea(F*ra)))+ea(u*ea(ea(ea(s*w)+ea(la*U))+ea(N*ra)))))*ea(2.0));ra=ea(ea(ea(G*ea(ea(ea(K*J)+ea(Z*pa))+ea(M*sa)))+ea(ea(j*ea(ea(ea(O*J)+ea(W*pa))+ea(F*sa)))+ea(u*ea(ea(ea(s*J)+ea(la*pa))+ea(N*sa)))))*ea(2.0));sa=ea(g[D>>2]);N=ea(ea(sa*sa)+ea(-.5));pa=ea(g[e>>2]);la=ea(pa*H);J=ea(g[I>>2]);s=ea(la+ea(J*qa));la=ea(g[L>>2]);u=ea(ea(la*ra)+s);s=ea(ea(pa*u)+ea(ea(N*H)+ea(sa*ea(ea(J*ra)-ea(la*qa)))));F=ea(ea(J*u)+ea(ea(N*qa)+ea(sa*ea(ea(la*H)-ea(pa*ra)))));W=ea(ea(ea(N*ra)+ea(sa*ea(ea(pa*qa)-ea(J*H))))+ea(la*u));u=ea(ea(g[d>>2])+s);s=ea(ea(g[B>>2])+F);F=ea(ea(g[C>>2])+W);g[m+16>>2]=u;g[m+20>>2]=s;g[m+24>>2]=F;na=b[k>>1]|0;oa=5}g[m+40>>2]=ma;c[m+8>>2]=ja;g[m+44>>2]=ea(0.0);g[m+48>>2]=ea(0.0);ja=m+28|0;g[ja>>2]=ea(0.0);C=m+32|0;g[C>>2]=ea(0.0);B=m+36|0;g[B>>2]=ea(0.0);if(na&2){na=(oa&65535|2)&65535;ma=ea(g[o>>2]);F=ea(g[ka>>2]);s=ea(ma*F);ma=ea(g[n>>2]);u=ea(g[ka+4>>2]);W=ea(s+ea(ma*u));ma=ea(g[P>>2]);s=ea(g[ka+8>>2]);la=ea(W+ea(ma*s));ma=ea(F*ea(g[Q>>2]));W=ea(ma+ea(u*ea(g[R>>2])));ma=ea(W+ea(s*ea(g[S>>2])));W=ea(F*ea(g[f>>2]));F=ea(W+ea(u*ea(g[V>>2])));u=ea(F+ea(s*ea(g[X>>2])));g[ja>>2]=la;g[C>>2]=ma;g[B>>2]=u;s=ea(T(ea(ea(u*u)+ea(ea(la*la)+ea(ma*ma)))));if(s>ea(0.0)){F=ea(ea(1.0)/s);g[ja>>2]=ea(la*F);g[C>>2]=ea(ma*F);g[B>>2]=ea(u*F);ta=na}else ta=na}else ta=oa;b[m+12>>1]=ta;ha=1;i=p;return ha|0}}g[m+40>>2]=ea(0.0);c[m+8>>2]=-1;g[m+44>>2]=ea(0.0);g[m+48>>2]=ea(0.0);ta=m+28|0;if(!(b[k>>1]&2)){g[ta>>2]=ea(0.0);g[m+32>>2]=ea(0.0);g[m+36>>2]=ea(0.0);ua=4}else{F=ea(-ea(g[h>>2]));u=ea(-ea(g[_>>2]));ma=ea(-ea(g[$>>2]));g[ta>>2]=F;g[m+32>>2]=u;g[m+36>>2]=ma;ua=6}b[m+12>>1]=ua;ha=1;i=p;return ha|0}function BMa(d,e,f,h,j,k,l,m,n,o,p){d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=0,ba=0;q=i;i=i+240|0;r=q+28|0;s=q+140|0;t=q+40|0;u=q+152|0;v=q+212|0;w=q;x=q+88|0;y=q+200|0;z=c[d+36>>2]|0;A=d+4|0;B=ea(g[A>>2]);C=B==ea(1.0);D=ea(g[d+8>>2]);if(C&D==ea(1.0)?ea(g[d+12>>2])==ea(1.0):0){E=ea(g[f>>2]);F=ea(E-ea(g[e+16>>2]));E=ea(g[f+4>>2]);G=ea(E-ea(g[e+20>>2]));E=ea(g[f+8>>2]);H=ea(F*ea(2.0));F=ea(G*ea(2.0));G=ea(ea(E-ea(g[e+24>>2]))*ea(2.0));E=ea(g[e+12>>2]);I=ea(ea(E*E)+ea(-.5));J=ea(g[e>>2]);K=ea(H*J);L=ea(g[e+4>>2]);M=ea(K+ea(F*L));K=ea(g[e+8>>2]);N=ea(M+ea(G*K));M=ea(ea(L*N)+ea(ea(F*I)-ea(E*ea(ea(H*K)-ea(G*J)))));O=ea(ea(ea(G*I)-ea(E*ea(ea(F*J)-ea(H*L))))+ea(K*N));g[r>>2]=ea(ea(J*N)+ea(ea(H*I)-ea(E*ea(ea(G*L)-ea(F*K)))));g[r+4>>2]=M;g[r+8>>2]=O;O=ea(ea(g[h>>2])*ea(2.0));M=ea(ea(g[h+4>>2])*ea(2.0));F=ea(ea(g[h+8>>2])*ea(2.0));G=ea(ea(ea(O*J)+ea(M*L))+ea(F*K));H=ea(ea(L*G)+ea(ea(M*I)-ea(E*ea(ea(O*K)-ea(F*J)))));N=ea(ea(ea(F*I)-ea(E*ea(ea(M*J)-ea(O*L))))+ea(K*G));g[s>>2]=ea(ea(J*G)+ea(ea(O*I)-ea(E*ea(ea(F*L)-ea(M*K)))));g[s+4>>2]=H;g[s+8>>2]=N;P=0}else{N=ea(ea(1.0)/B);B=ea(ea(1.0)/D);D=ea(ea(1.0)/ea(g[d+12>>2]));g[v>>2]=N;g[v+4>>2]=B;g[v+8>>2]=D;g[v+12>>2]=ea(g[d+16>>2]);g[v+16>>2]=ea(g[d+20>>2]);g[v+20>>2]=ea(g[d+24>>2]);g[v+24>>2]=ea(g[d+28>>2]);D=ea(g[e+16>>2]);B=ea(g[e+20>>2]);N=ea(D*ea(-2.0));D=ea(B*ea(-2.0));B=ea(ea(g[e+24>>2])*ea(-2.0));H=ea(g[e+12>>2]);K=ea(ea(H*H)+ea(-.5));M=ea(g[e>>2]);L=ea(N*M);F=ea(g[e+4>>2]);E=ea(L+ea(D*F));L=ea(g[e+8>>2]);I=ea(E+ea(B*L));E=ea(ea(M*I)+ea(ea(N*K)-ea(H*ea(ea(B*F)-ea(D*L)))));O=ea(ea(F*I)+ea(ea(D*K)-ea(H*ea(ea(N*L)-ea(B*M)))));G=ea(ea(ea(B*K)-ea(H*ea(ea(D*M)-ea(N*F))))+ea(L*I));I=ea(-F);F=ea(-L);g[w>>2]=ea(-M);g[w+4>>2]=I;g[w+8>>2]=F;g[w+12>>2]=H;g[w+16>>2]=E;g[w+20>>2]=O;g[w+24>>2]=G;r6a(u,v,w);G=ea(g[u>>2]);g[t>>2]=G;O=ea(g[u+4>>2]);g[t+4>>2]=O;E=ea(g[u+8>>2]);g[t+8>>2]=E;H=ea(g[u+12>>2]);g[t+12>>2]=H;F=ea(g[u+16>>2]);g[t+16>>2]=F;I=ea(g[u+20>>2]);g[t+20>>2]=I;M=ea(g[u+24>>2]);g[t+24>>2]=M;L=ea(g[u+28>>2]);g[t+28>>2]=L;N=ea(g[u+32>>2]);g[t+32>>2]=N;D=ea(g[u+36>>2]);g[t+36>>2]=D;K=ea(g[u+40>>2]);g[t+40>>2]=K;B=ea(g[u+44>>2]);g[t+44>>2]=B;J=ea(g[f>>2]);Q=ea(J*G);R=ea(J*O);S=ea(J*E);J=ea(g[f+4>>2]);T=ea(Q+ea(J*H));Q=ea(R+ea(J*F));R=ea(S+ea(J*I));J=ea(g[f+8>>2]);S=ea(ea(Q+ea(J*L))+K);K=ea(B+ea(R+ea(J*N)));g[r>>2]=ea(ea(T+ea(J*M))+D);g[r+4>>2]=S;g[r+8>>2]=K;K=ea(g[h>>2]);S=ea(K*G);G=ea(K*O);O=ea(K*E);E=ea(g[h+4>>2]);K=ea(S+ea(E*H));H=ea(G+ea(E*F));F=ea(O+ea(E*I));I=ea(g[h+8>>2]);E=ea(H+ea(I*L));L=ea(F+ea(I*N));g[s>>2]=ea(K+ea(I*M));g[s+4>>2]=E;g[s+8>>2]=L;P=t}t=a[d+32>>0]&2;if((o|0)!=0|l>>>0>1)U=2;else U=n&1^1;n=b[k>>1]|0;c[x+4>>2]=U;c[x>>2]=539120;c[x+8>>2]=m;m=x+12|0;c[m>>2]=0;c[x+16>>2]=l;c[x+20>>2]=A;c[x+24>>2]=e;c[x+28>>2]=P;c[x+32>>2]=n&65535;c[x+36>>2]=o;c[x+40>>2]=p;c[x+44>>2]=h;a[x+48>>0]=(t&255)>>>1;a[x+49>>0]=0;if(t<<24>>24){V=1;W=z+32|0;X=c[W>>2]|0;c[y>>2]=X;Y=z+48|0;Z=y+4|0;c[Z>>2]=Y;_=z+36|0;$=ea(g[_>>2]);aa=y+8|0;g[aa>>2]=$;xQa(r,s,j,V,y,x,0);ba=c[m>>2]|0;i=q;return ba|0}V=(n&128)!=0;W=z+32|0;X=c[W>>2]|0;c[y>>2]=X;Y=z+48|0;Z=y+4|0;c[Z>>2]=Y;_=z+36|0;$=ea(g[_>>2]);aa=y+8|0;g[aa>>2]=$;xQa(r,s,j,V,y,x,0);ba=c[m>>2]|0;i=q;return ba|0}function CMa(d,f,h,j,k,l,m,n,o,p,q){d=d|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=0,U=0,V=Im,W=Im,X=Im,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=0,da=0;q=i;i=i+80|0;p=q+64|0;o=q+44|0;m=q+24|0;r=q+12|0;s=q;t=d+4|0;u=c[t>>2]|0;v=n+12|0;b[v>>1]=0;w=f+16|0;x=ea(g[w>>2]);y=f+20|0;z=ea(g[y>>2]);A=f+24|0;B=ea(x*ea(-2.0));x=ea(z*ea(-2.0));z=ea(ea(g[A>>2])*ea(-2.0));C=f+12|0;D=ea(g[C>>2]);E=ea(ea(D*D)+ea(-.5));F=ea(g[f>>2]);G=ea(B*F);H=f+4|0;I=ea(g[H>>2]);J=ea(G+ea(x*I));K=f+8|0;G=ea(g[K>>2]);L=ea(J+ea(z*G));J=ea(ea(F*L)+ea(ea(B*E)-ea(D*ea(ea(z*I)-ea(x*G)))));M=ea(ea(I*L)+ea(ea(x*E)-ea(D*ea(ea(B*G)-ea(z*F)))));N=ea(ea(ea(z*E)-ea(D*ea(ea(x*F)-ea(B*I))))+ea(G*L));L=ea(-F);F=ea(-I);I=ea(-G);G=ea(ea(g[h>>2])*ea(2.0));B=ea(ea(g[h+4>>2])*ea(2.0));x=ea(ea(g[h+8>>2])*ea(2.0));z=ea(ea(ea(G*L)+ea(B*F))+ea(x*I));O=ea(J+ea(ea(z*L)+ea(ea(E*G)+ea(D*ea(ea(x*F)-ea(B*I))))));J=ea(M+ea(ea(z*F)+ea(ea(E*B)+ea(D*ea(ea(G*I)-ea(x*L))))));M=ea(N+ea(ea(ea(E*x)+ea(D*ea(ea(B*L)-ea(G*F))))+ea(z*I)));g[p>>2]=O;h=p+4|0;g[h>>2]=J;P=p+8|0;g[P>>2]=M;z=ea(ea(g[j>>2])*ea(2.0));G=ea(ea(g[j+4>>2])*ea(2.0));B=ea(ea(g[j+8>>2])*ea(2.0));x=ea(ea(ea(z*L)+ea(G*F))+ea(B*I));N=ea(ea(x*L)+ea(ea(E*z)+ea(D*ea(ea(B*F)-ea(G*I)))));Q=ea(ea(x*F)+ea(ea(E*G)+ea(D*ea(ea(z*I)-ea(B*L)))));R=ea(ea(ea(E*B)+ea(D*ea(ea(G*L)-ea(z*F))))+ea(x*I));j=c[t>>2]|0;c[t>>2]=u;S=o+12|0;c[S>>2]=u;c[o+16>>2]=d;u=o+4|0;g[u>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[o>>2]=ea(ea(1.0)/ea(g[d+12>>2]));U=o+8|0;g[U>>2]=ea(ea(1.0)/ea(g[d+16>>2]));d=m+16|0;a[d>>0]=0;I=ea(T(ea(ea(R*R)+ea(ea(N*N)+ea(Q*Q)))));if(I<ea(9.99999968e-21)){V=N;W=Q;X=R}else{x=ea(ea(1.0)/I);V=ea(N*x);W=ea(Q*x);X=ea(R*x)}Y=k<ea(1.0e10);x=Y?k:ea(1.0e10);k=ea(ea(x*W)+J);J=ea(ea(x*X)+M);g[r>>2]=ea(O+ea(x*V));g[r+4>>2]=k;g[r+8>>2]=J;s6a(o,p,r,m,0);if(!(a[d>>0]|0)){Z=0;_=j;c[t>>2]=_;i=q;return Z|0}c[n+8>>2]=c[m+12>>2];J=ea(g[m>>2]);k=ea(g[m+8>>2]);V=ea(g[o>>2]);x=ea(J*V);O=ea(g[U>>2]);M=ea(k*O);t6a(s,c[S>>2]|0,x,M,V,ea(g[u>>2]),O);O=ea(ea(g[s>>2])*ea(2.0));V=ea(ea(g[s+4>>2])*ea(2.0));M=ea(ea(g[s+8>>2])*ea(2.0));x=ea(g[C>>2]);X=ea(ea(x*x)+ea(-.5));W=ea(g[f>>2]);I=ea(O*W);F=ea(g[H>>2]);z=ea(I+ea(V*F));I=ea(g[K>>2]);L=ea(z+ea(M*I));z=ea(ea(W*L)+ea(ea(O*X)+ea(x*ea(ea(M*F)-ea(V*I)))));G=ea(ea(F*L)+ea(ea(V*X)+ea(x*ea(ea(O*I)-ea(M*W)))));D=ea(ea(ea(M*X)+ea(x*ea(ea(V*W)-ea(O*F))))+ea(I*L));L=ea(T(ea(ea(D*D)+ea(ea(z*z)+ea(G*G)))));if(L>ea(0.0)){I=ea(ea(1.0)/L);$=ea(z*I);aa=ea(G*I);ba=ea(D*I)}else{$=z;aa=G;ba=D}s=b[l>>1]|0;if(!(s&2))ca=s;else{g[n+28>>2]=$;g[n+32>>2]=aa;g[n+36>>2]=ba;b[v>>1]=e[v>>1]|2;ca=b[l>>1]|0}if(!(ca&4))da=ca;else{ba=ea(J-ea(g[p>>2]));aa=ea(g[m+4>>2]);$=ea(aa-ea(g[h>>2]));g[n+40>>2]=ea(ea(ea(N*ba)+ea(Q*$))+ea(R*ea(k-ea(g[P>>2]))));b[v>>1]=e[v>>1]|4;da=b[l>>1]|0}if(!(da&1)){Z=1;_=j;c[t>>2]=_;i=q;return Z|0}R=ea(J*ea(2.0));J=ea(ea(g[m+4>>2])*ea(2.0));$=ea(k*ea(2.0));k=ea(g[C>>2]);Q=ea(ea(k*k)+ea(-.5));ba=ea(g[f>>2]);N=ea(R*ba);aa=ea(g[H>>2]);D=ea(N+ea(J*aa));N=ea(g[K>>2]);G=ea(D+ea($*N));D=ea(ea(ba*G)+ea(ea(R*Q)+ea(k*ea(ea($*aa)-ea(J*N)))));z=ea(ea(aa*G)+ea(ea(J*Q)+ea(k*ea(ea(R*N)-ea($*ba)))));I=ea(ea(ea($*Q)+ea(k*ea(ea(J*ba)-ea(R*aa))))+ea(N*G));G=ea(ea(g[w>>2])+D);D=ea(ea(g[y>>2])+z);z=ea(ea(g[A>>2])+I);g[n+16>>2]=G;g[n+20>>2]=D;g[n+24>>2]=z;b[v>>1]=e[v>>1]|1;Z=1;_=j;c[t>>2]=_;i=q;return Z|0}function DMa(){return 539080}function EMa(b){b=b|0;var d=0;c[b>>2]=539144;d=b+4|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;a[b+32>>0]=1;c[d>>2]=-2147483648;return}function FMa(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function GMa(a){a=a|0;return}function HMa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;if((b|0)==0|(e|0)==0|(e|0)<0){i=g;return a|0}h=a+24|0;c[h>>2]=(c[h>>2]|0)+1;h=(f|0)==1;j=a+16|0;PEi(c[j>>2]|0,0,4096)|0;k=b+(e<<2)|0;l=c[j>>2]|0;m=a+4|0;n=(c[m>>2]|0)<0;if(h){a:do if(n){if((k|0)!=(b|0)){o=c[b>>2]|0;p=b;do{q=o;o=c[p>>2]|0;if(o>>>0<q>>>0){r=p;break a}q=p;p=p+4|0;s=l+((o&255)<<2)|0;c[s>>2]=(c[s>>2]|0)+1;s=l+((d[q+1>>0]|0|256)<<2)|0;c[s>>2]=(c[s>>2]|0)+1;s=l+((d[q+2>>0]|0|512)<<2)|0;c[s>>2]=(c[s>>2]|0)+1;s=l+((d[q+3>>0]|0|768)<<2)|0;c[s>>2]=(c[s>>2]|0)+1}while((p|0)!=(k|0))}p=a+28|0;c[p>>2]=(c[p>>2]|0)+1;p=c[a+8>>2]|0;o=0;do{c[p+(o<<2)>>2]=o;o=o+1|0}while((o|0)!=(e|0));i=g;return a|0}else{o=c[a+8>>2]|0;b:do if((k|0)!=(b|0)){p=c[b+(c[o>>2]<<2)>>2]|0;s=p;q=o;t=p;p=b;while(1){if(s>>>0<t>>>0){r=p;break a}u=q+4|0;v=l+((d[p>>0]|0)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;v=l+((d[p+1>>0]|0|256)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;v=l+((d[p+2>>0]|0|512)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;v=p+4|0;w=l+((d[p+3>>0]|0|768)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;if((v|0)==(k|0))break b;w=s;s=c[b+(c[u>>2]<<2)>>2]|0;q=u;p=v;t=w}}while(0);o=a+28|0;c[o>>2]=(c[o>>2]|0)+1;i=g;return a|0}while(0);if((r|0)!=(k|0)){o=r;do{r=l+((d[o>>0]|0)<<2)|0;c[r>>2]=(c[r>>2]|0)+1;r=l+((d[o+1>>0]|0|256)<<2)|0;c[r>>2]=(c[r>>2]|0)+1;r=l+((d[o+2>>0]|0|512)<<2)|0;c[r>>2]=(c[r>>2]|0)+1;r=l+((d[o+3>>0]|0|768)<<2)|0;o=o+4|0;c[r>>2]=(c[r>>2]|0)+1}while((o|0)!=(k|0))}}else{c:do if(n){d:do if((k|0)!=(b|0)){o=c[b>>2]|0;r=o;t=o;o=b;while(1){if((r|0)<(t|0)){x=o;break c}p=o+4|0;q=l+((r&255)<<2)|0;c[q>>2]=(c[q>>2]|0)+1;q=l+((d[o+1>>0]|0|256)<<2)|0;c[q>>2]=(c[q>>2]|0)+1;q=l+((d[o+2>>0]|0|512)<<2)|0;c[q>>2]=(c[q>>2]|0)+1;q=l+((d[o+3>>0]|0|768)<<2)|0;c[q>>2]=(c[q>>2]|0)+1;if((p|0)==(k|0))break d;q=r;r=c[p>>2]|0;o=p;t=q}}while(0);t=a+28|0;c[t>>2]=(c[t>>2]|0)+1;t=c[a+8>>2]|0;o=0;do{c[t+(o<<2)>>2]=o;o=o+1|0}while((o|0)!=(e|0));i=g;return a|0}else{o=c[a+8>>2]|0;e:do if((k|0)!=(b|0)){t=c[b+(c[o>>2]<<2)>>2]|0;r=t;q=o;p=t;t=b;while(1){if((r|0)<(p|0)){x=t;break c}s=q+4|0;w=l+((d[t>>0]|0)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;w=l+((d[t+1>>0]|0|256)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;w=l+((d[t+2>>0]|0|512)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;w=t+4|0;v=l+((d[t+3>>0]|0|768)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;if((w|0)==(k|0))break e;v=r;r=c[b+(c[s>>2]<<2)>>2]|0;q=s;t=w;p=v}}while(0);o=a+28|0;c[o>>2]=(c[o>>2]|0)+1;i=g;return a|0}while(0);if((x|0)!=(k|0)){n=x;do{x=l+((d[n>>0]|0)<<2)|0;c[x>>2]=(c[x>>2]|0)+1;x=l+((d[n+1>>0]|0|256)<<2)|0;c[x>>2]=(c[x>>2]|0)+1;x=l+((d[n+2>>0]|0|512)<<2)|0;c[x>>2]=(c[x>>2]|0)+1;x=l+((d[n+3>>0]|0|768)<<2)|0;n=n+4|0;c[x>>2]=(c[x>>2]|0)+1}while((n|0)!=(k|0))}}if(!f){f=0;k=128;while(1){n=(c[l+(k+768<<2)>>2]|0)+f|0;k=k+1|0;if((k|0)==256){y=n;break}else f=n}}else y=0;f=a+20|0;k=a+12|0;n=a+8|0;x=l;l=0;while(1){o=l<<8;if(!((x+(o<<2)|0)==0?1:(c[x+((d[b+l>>0]|0|o)<<2)>>2]|0)==(e|0))){p=c[f>>2]|0;t=c[k>>2]|0;if((l|0)!=3|h){c[p>>2]=t;q=t;r=1;do{q=q+(c[x+(r+-1+o<<2)>>2]<<2)|0;c[p+(r<<2)>>2]=q;r=r+1|0}while((r|0)!=256)}else{r=t+(y<<2)|0;c[p>>2]=r;q=r;r=1;do{q=q+(c[x+(r+-1+o<<2)>>2]<<2)|0;c[p+(r<<2)>>2]=q;r=r+1|0}while((r|0)!=128);r=c[k>>2]|0;c[p+512>>2]=r;q=r;r=129;do{q=q+(c[x+(r+-1+o<<2)>>2]<<2)|0;c[p+(r<<2)>>2]=q;r=r+1|0}while((r|0)!=256)}if((c[m>>2]|0)<0){r=0;do{q=p+((d[b+((r<<2)+l)>>0]|0)<<2)|0;o=c[q>>2]|0;c[q>>2]=o+4;c[o>>2]=r;r=r+1|0}while((r|0)!=(e|0));c[m>>2]=c[m>>2]&2147483647}else{r=c[n>>2]|0;o=r+(e<<2)|0;q=r;do{r=c[q>>2]|0;q=q+4|0;t=p+((d[b+((r<<2)+l)>>0]|0)<<2)|0;v=c[t>>2]|0;c[t>>2]=v+4;c[v>>2]=r}while((q|0)!=(o|0))}o=c[n>>2]|0;c[n>>2]=c[k>>2];c[k>>2]=o}o=l+1|0;if((o|0)==4)break;x=c[j>>2]|0;l=o}i=g;return a|0}function IMa(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;h=i;if((e|0)==0|(f|0)==0|(f|0)<0){i=h;return b|0}j=b+24|0;c[j>>2]=(c[j>>2]|0)+1;j=b+16|0;PEi(c[j>>2]|0,0,4096)|0;l=e+(f<<2)|0;m=c[j>>2]|0;n=b+4|0;a:do if((c[n>>2]|0)<0){if((l|0)!=(e|0)){o=ea(g[e>>2]);p=e;do{q=o;o=ea(g[p>>2]);if(o<q){r=p;break a}s=p;p=p+4|0;t=m+(((g[k>>2]=o,c[k>>2]|0)&255)<<2)|0;c[t>>2]=(c[t>>2]|0)+1;t=m+((d[s+1>>0]|0|256)<<2)|0;c[t>>2]=(c[t>>2]|0)+1;t=m+((d[s+2>>0]|0|512)<<2)|0;c[t>>2]=(c[t>>2]|0)+1;t=m+((d[s+3>>0]|0|768)<<2)|0;c[t>>2]=(c[t>>2]|0)+1}while((p|0)!=(l|0))}p=b+28|0;c[p>>2]=(c[p>>2]|0)+1;p=c[b+8>>2]|0;t=0;do{c[p+(t<<2)>>2]=t;t=t+1|0}while((t|0)!=(f|0));i=h;return b|0}else{t=c[b+8>>2]|0;b:do if((l|0)!=(e|0)){o=ea(g[e+(c[t>>2]<<2)>>2]);q=o;p=t;u=o;s=e;while(1){if(q<u){r=s;break a}v=p+4|0;w=m+((d[s>>0]|0)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;w=m+((d[s+1>>0]|0|256)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;w=m+((d[s+2>>0]|0|512)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;w=s+4|0;x=m+((d[s+3>>0]|0|768)<<2)|0;c[x>>2]=(c[x>>2]|0)+1;if((w|0)==(l|0))break b;o=q;q=ea(g[e+(c[v>>2]<<2)>>2]);p=v;s=w;u=o}}while(0);t=b+28|0;c[t>>2]=(c[t>>2]|0)+1;i=h;return b|0}while(0);if((r|0)==(l|0)){y=0;z=128}else{t=r;do{r=m+((d[t>>0]|0)<<2)|0;c[r>>2]=(c[r>>2]|0)+1;r=m+((d[t+1>>0]|0|256)<<2)|0;c[r>>2]=(c[r>>2]|0)+1;r=m+((d[t+2>>0]|0|512)<<2)|0;c[r>>2]=(c[r>>2]|0)+1;r=m+((d[t+3>>0]|0|768)<<2)|0;t=t+4|0;c[r>>2]=(c[r>>2]|0)+1}while((t|0)!=(l|0));y=0;z=128}do{y=(c[m+(z+768<<2)>>2]|0)+y|0;z=z+1|0}while((z|0)!=256);z=b+20|0;l=b+12|0;t=b+8|0;r=f+-1|0;s=m;m=0;while(1){p=m<<8;w=a[e+m>>0]|0;if((c[s+((w&255|p)<<2)>>2]|0)==(f|0))A=0;else A=s+(p<<2)|0;p=(A|0)!=0;do if((m|0)!=3){if(p){v=c[z>>2]|0;x=c[l>>2]|0;c[v>>2]=x;B=x;x=1;do{B=B+(c[A+(x+-1<<2)>>2]<<2)|0;c[v+(x<<2)>>2]=B;x=x+1|0}while((x|0)!=256);if((c[n>>2]|0)<0){x=0;do{B=v+((d[e+((x<<2)+m)>>0]|0)<<2)|0;C=c[B>>2]|0;c[B>>2]=C+4;c[C>>2]=x;x=x+1|0}while((x|0)!=(f|0));c[n>>2]=c[n>>2]&2147483647}else{x=c[t>>2]|0;C=x+(f<<2)|0;B=x;do{x=c[B>>2]|0;B=B+4|0;D=v+((d[e+((x<<2)+m)>>0]|0)<<2)|0;E=c[D>>2]|0;c[D>>2]=E+4;c[E>>2]=x}while((B|0)!=(C|0))}C=c[t>>2]|0;c[t>>2]=c[l>>2];c[l>>2]=C}}else{if(!p){if(w<<24>>24>=0)break;if((c[n>>2]|0)<0){C=c[l>>2]|0;B=0;do{c[C+(B<<2)>>2]=r-B;B=B+1|0}while((B|0)!=(f|0));c[n>>2]=c[n>>2]&2147483647}else{B=c[t>>2]|0;C=c[l>>2]|0;v=0;do{c[C+(v<<2)>>2]=c[B+(r-v<<2)>>2];v=v+1|0}while((v|0)!=(f|0))}v=c[t>>2]|0;c[t>>2]=c[l>>2];c[l>>2]=v;break}v=c[z>>2]|0;B=(c[l>>2]|0)+(y<<2)|0;c[v>>2]=B;C=B;B=1;do{C=C+(c[A+(B+-1<<2)>>2]<<2)|0;c[v+(B<<2)>>2]=C;B=B+1|0}while((B|0)!=128);c[v+1020>>2]=c[l>>2];B=0;do{C=255-B|0;c[v+(254-B<<2)>>2]=(c[v+(C<<2)>>2]|0)+(c[A+(C<<2)>>2]<<2);B=B+1|0}while((B|0)!=127);F=128;do{B=v+(F<<2)|0;c[B>>2]=(c[B>>2]|0)+(c[A+(F<<2)>>2]<<2);F=F+1|0}while((F|0)!=256);if((c[n>>2]|0)<0){B=0;do{C=c[e+(B<<2)>>2]|0;x=v+(C>>>24<<2)|0;E=c[x>>2]|0;if((C|0)>-1){c[x>>2]=E+4;c[E>>2]=B}else{C=E+-4|0;c[x>>2]=C;c[C>>2]=B}B=B+1|0}while((B|0)!=(f|0));c[n>>2]=c[n>>2]&2147483647}else{B=c[t>>2]|0;C=0;do{x=c[B+(C<<2)>>2]|0;E=c[e+(x<<2)>>2]|0;D=v+(E>>>24<<2)|0;G=c[D>>2]|0;if((E|0)>-1){c[D>>2]=G+4;c[G>>2]=x}else{E=G+-4|0;c[D>>2]=E;c[E>>2]=x}C=C+1|0}while((C|0)!=(f|0))}C=c[t>>2]|0;c[t>>2]=c[l>>2];c[l>>2]=C}while(0);w=m+1|0;if((w|0)==4)break;s=c[j>>2]|0;m=w}i=h;return b|0}function JMa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;if((d|0)==0|(e|0)==0|(f|0)==0|(g|0)==0){j=0;i=h;return j|0}c[b+8>>2]=d;c[b+12>>2]=e;c[b+16>>2]=f;c[b+20>>2]=g;a[b+32>>0]=0;g=b+4|0;c[g>>2]=c[g>>2]|-2147483648;j=1;i=h;return j|0}function KMa(a){a=a|0;var b=0;b=i;EMa(a);c[a>>2]=539160;i=b;return}function LMa(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;c[b>>2]=539160;if(!(a[b+32>>0]|0)){ACi(b);i=d;return}e=b+12|0;VJa(d+1|0,c[e>>2]|0);c[e>>2]=0;e=b+8|0;VJa(d,c[e>>2]|0);c[e>>2]=0;ACi(b);i=d;return}function MMa(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;c[b>>2]=539160;if(!(a[b+32>>0]|0)){i=d;return}e=b+12|0;VJa(d+1|0,c[e>>2]|0);c[e>>2]=0;e=b+8|0;VJa(d,c[e>>2]|0);c[e>>2]=0;i=d;return}function NMa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+5136|0;h=g+5123|0;j=g+5122|0;k=g+5121|0;l=g+5120|0;m=g+1024|0;n=g;if((d|0)==0|(e|0)==0|(e|0)<0){i=g;return b|0}o=b+4|0;p=c[o>>2]&2147483647;if((p|0)!=(e|0)){if(p>>>0<e>>>0?(a[b+32>>0]|0)!=0:0){p=b+12|0;VJa(h,c[p>>2]|0);c[p>>2]=0;h=b+8|0;VJa(j,c[h>>2]|0);c[h>>2]=0;j=e<<2;c[h>>2]=UJa(k,j,539168,70)|0;c[p>>2]=UJa(l,j,539168,71)|0}c[o>>2]=e|-2147483648}c[b+16>>2]=m;c[b+20>>2]=n;HMa(b,d,e,f)|0;i=g;return b|0}function OMa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+5136|0;g=f+5123|0;h=f+5122|0;j=f+5121|0;k=f+5120|0;l=f+1024|0;m=f;if((d|0)==0|(e|0)==0|(e|0)<0){i=f;return b|0}n=b+4|0;o=c[n>>2]&2147483647;if((o|0)!=(e|0)){if(o>>>0<e>>>0?(a[b+32>>0]|0)!=0:0){o=b+12|0;VJa(g,c[o>>2]|0);c[o>>2]=0;g=b+8|0;VJa(h,c[g>>2]|0);c[g>>2]=0;h=e<<2;c[g>>2]=UJa(j,h,539168,70)|0;c[o>>2]=UJa(k,h,539168,71)|0}c[n>>2]=e|-2147483648}c[b+16>>2]=l;c[b+20>>2]=m;IMa(b,d,e)|0;i=f;return b|0}function PMa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h+3|0;k=h+2|0;l=h+1|0;m=h;a[j>>0]=b;a[k>>0]=d;a[l>>0]=e;a[m>>0]=f;xo[c[c[g>>2]>>2]&2047](g,j,1)|0;xo[c[c[g>>2]>>2]&2047](g,k,1)|0;xo[c[c[g>>2]>>2]&2047](g,l,1)|0;xo[c[c[g>>2]>>2]&2047](g,m,1)|0;i=h;return}function QMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;xo[c[c[f>>2]>>2]&2047](f,a,1)|0;xo[c[c[f>>2]>>2]&2047](f,b,1)|0;xo[c[c[f>>2]>>2]&2047](f,d,1)|0;xo[c[c[f>>2]>>2]&2047](f,e,1)|0;i=g;return}function RMa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;xo[c[c[e>>2]>>2]&2047](e,g,2)|0;if(!d){h=b[g>>1]|0;i=f;return h|0}d=b[g>>1]|0;a[g>>0]=(d&65535)>>>8;a[g+1>>0]=d;h=b[g>>1]|0;i=f;return h|0}function SMa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;xo[c[c[d>>2]>>2]&2047](d,f,4)|0;if(!b){g=c[f>>2]|0;i=e;return g|0}b=c[f>>2]|0;a[f>>0]=b>>>24;a[f+3>>0]=b;a[f+1>>0]=b>>>16;a[f+2>>0]=(b&65535)>>>8;g=c[f>>2]|0;i=e;return g|0}function TMa(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;xo[c[c[d>>2]>>2]&2047](d,f,4)|0;if(!b){h=ea(g[f>>2]);i=e;return ea(h)}b=c[f>>2]|0;a[f>>0]=b>>>24;a[f+3>>0]=b;a[f+1>>0]=b>>>16;a[f+2>>0]=(b&65535)>>>8;h=ea(g[f>>2]);i=e;return ea(h)}function UMa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g;b[h>>1]=d;if(e){a[h>>0]=(d&65535)>>>8;a[h+1>>0]=d;j=h}else j=h;xo[c[c[f>>2]>>2]&2047](f,j,2)|0;i=g;return}function VMa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;c[g>>2]=b;if(d){a[g>>0]=b>>>24;a[g+3>>0]=b;a[g+1>>0]=b>>>16;a[g+2>>0]=b>>>8;h=g}else h=g;xo[c[c[e>>2]>>2]&2047](e,h,4)|0;i=f;return}function WMa(b,d,e){b=ea(b);d=d|0;e=e|0;var f=0,h=0,j=0,l=0;f=i;i=i+16|0;h=f;g[h>>2]=b;j=(g[k>>2]=b,c[k>>2]|0);if(d){a[h>>0]=j>>>24;a[h+3>>0]=j;a[h+1>>0]=j>>>16;a[h+2>>0]=j>>>8;l=h}else l=h;xo[c[c[e>>2]>>2]&2047](e,l,4)|0;i=f;return}function XMa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;xo[c[c[f>>2]>>2]&2047](f,b,d<<2)|0;if((d|0)==0|e^1){i=g;return 1}else h=0;do{e=b+(h<<2)|0;f=a[e>>0]|0;j=e+3|0;a[e>>0]=a[j>>0]|0;a[j>>0]=f;f=e+1|0;j=a[f>>0]|0;k=e+2|0;a[f>>0]=a[k>>0]|0;a[k>>0]=j;h=h+1|0}while((h|0)!=(d|0));i=g;return 1}function YMa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h;k=e+-1|0;if(!e){i=h;return}e=j+1|0;if(f){f=d;l=k;while(1){m=b[f>>1]|0;b[j>>1]=m;a[j>>0]=(m&65535)>>>8;a[e>>0]=m;xo[c[c[g>>2]>>2]&2047](g,j,2)|0;if(!l)break;else{f=f+2|0;l=l+-1|0}}i=h;return}else{l=d;d=k;while(1){b[j>>1]=b[l>>1]|0;xo[c[c[g>>2]>>2]&2047](g,j,2)|0;if(!d)break;else{l=l+2|0;d=d+-1|0}}i=h;return}}function ZMa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0;h=i;i=i+16|0;j=h;l=d+-1|0;if(!d){i=h;return}d=j+3|0;m=j+1|0;n=j+2|0;if(e){e=b;o=l;while(1){p=ea(g[e>>2]);g[j>>2]=p;q=(g[k>>2]=p,c[k>>2]|0);a[j>>0]=q>>>24;a[d>>0]=q;a[m>>0]=q>>>16;a[n>>0]=q>>>8;xo[c[c[f>>2]>>2]&2047](f,j,4)|0;if(!o)break;else{e=e+4|0;o=o+-1|0}}i=h;return}else{o=b;b=l;while(1){g[j>>2]=ea(g[o>>2]);xo[c[c[f>>2]>>2]&2047](f,j,4)|0;if(!b)break;else{o=o+4|0;b=b+-1|0}}i=h;return}}function _Ma(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+16|0;l=k;m=k+6|0;n=k+5|0;o=k+4|0;a[l>>0]=78;a[m>>0]=88;a[n>>0]=83;a[o>>0]=h&1^1;xo[c[c[j>>2]>>2]&2047](j,l,1)|0;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;a[l>>0]=b;a[m>>0]=d;a[n>>0]=e;a[o>>0]=f;xo[c[c[j>>2]>>2]&2047](j,l,1)|0;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;c[l>>2]=g;if(!h){p=c[j>>2]|0;q=c[p>>2]|0;xo[q&2047](j,l,4)|0;i=k;return 1}a[l>>0]=g>>>24;a[l+3>>0]=g;a[l+1>>0]=g>>>16;a[l+2>>0]=g>>>8;p=c[j>>2]|0;q=c[p>>2]|0;xo[q&2047](j,l,4)|0;i=k;return 1}function $Ma(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+16|0;l=k;m=k+6|0;n=k+5|0;o=k+4|0;a[l>>0]=73;a[m>>0]=67;a[n>>0]=69;a[o>>0]=h&1^1;xo[c[c[j>>2]>>2]&2047](j,l,1)|0;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;a[l>>0]=b;a[m>>0]=d;a[n>>0]=e;a[o>>0]=f;xo[c[c[j>>2]>>2]&2047](j,l,1)|0;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;c[l>>2]=g;if(!h){p=c[j>>2]|0;q=c[p>>2]|0;xo[q&2047](j,l,4)|0;i=k;return 1}a[l>>0]=g>>>24;a[l+3>>0]=g;a[l+1>>0]=g>>>16;a[l+2>>0]=g>>>8;p=c[j>>2]|0;q=c[p>>2]|0;xo[q&2047](j,l,4)|0;i=k;return 1}function aNa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+16|0;l=k;m=k+7|0;n=k+6|0;o=k+5|0;p=k+4|0;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;xo[c[c[j>>2]>>2]&2047](j,p,1)|0;if(!((a[m>>0]|0)==78&(a[n>>0]|0)==88&(a[o>>0]|0)==83)){q=0;i=k;return q|0}a[h>>0]=a[p>>0]&1^1;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;xo[c[c[j>>2]>>2]&2047](j,p,1)|0;if(!(((a[m>>0]|0)==b<<24>>24?(a[n>>0]|0)==d<<24>>24:0)&(a[o>>0]|0)==e<<24>>24&(a[p>>0]|0)==f<<24>>24)){q=0;i=k;return q|0}f=(a[h>>0]|0)==0;xo[c[c[j>>2]>>2]&2047](j,l,4)|0;if(!f){f=c[l>>2]|0;a[l>>0]=f>>>24;a[l+3>>0]=f;a[l+1>>0]=f>>>16;a[l+2>>0]=(f&65535)>>>8}c[g>>2]=c[l>>2];q=1;i=k;return q|0}function bNa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+16|0;l=k;m=k+7|0;n=k+6|0;o=k+5|0;p=k+4|0;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;xo[c[c[j>>2]>>2]&2047](j,p,1)|0;if(!((a[m>>0]|0)==73&(a[n>>0]|0)==67&(a[o>>0]|0)==69)){q=0;i=k;return q|0}a[h>>0]=a[p>>0]&1^1;xo[c[c[j>>2]>>2]&2047](j,m,1)|0;xo[c[c[j>>2]>>2]&2047](j,n,1)|0;xo[c[c[j>>2]>>2]&2047](j,o,1)|0;xo[c[c[j>>2]>>2]&2047](j,p,1)|0;if((a[m>>0]|0)!=(b&255|0)){q=0;i=k;return q|0}if((a[n>>0]|0)!=(d&255|0)){q=0;i=k;return q|0}if((a[o>>0]|0)!=(e&255|0)){q=0;i=k;return q|0}if((a[p>>0]|0)!=(f&255|0)){q=0;i=k;return q|0}f=(a[h>>0]|0)==0;xo[c[c[j>>2]>>2]&2047](j,l,4)|0;if(!f){f=c[l>>2]|0;a[l>>0]=f>>>24;a[l+3>>0]=f;a[l+1>>0]=f>>>16;a[l+2>>0]=(f&65535)>>>8}c[g>>2]=c[l>>2];q=1;i=k;return q|0}function cNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b){e=0;i=d;return e|0}else{f=b;g=a;h=0}while(1){f=f+-1|0;a=c[g>>2]|0;b=a>>>0>h>>>0?a:h;if(!f){e=b;break}else{g=g+4|0;h=b}}i=d;return e|0}function dNa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!c){e=0;i=d;return e|0}else{f=c;g=a;h=0}while(1){f=f+-1|0;a=b[g>>1]|0;c=(a&65535)>(h&65535)?a:h;if(!f){e=c;break}else{g=g+2|0;h=c}}i=d;return e|0}function eNa(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=0;l=i;i=i+16|0;m=l;n=l+4|0;if(d>>>0<256){if(!e){i=l;return}o=0;do{a[n>>0]=c[f+(o<<2)>>2];xo[c[c[h>>2]>>2]&2047](h,n,1)|0;o=o+1|0}while((o|0)!=(e|0));i=l;return}if(d>>>0<65536){if(!e){i=l;return}d=m+1|0;if(j){o=0;do{n=c[f+(o<<2)>>2]|0;p=n&65535;b[m>>1]=p;a[m>>0]=(p&65535)>>>8;a[d>>0]=n;xo[c[c[h>>2]>>2]&2047](h,m,2)|0;o=o+1|0}while((o|0)!=(e|0));i=l;return}else{o=0;do{b[m>>1]=c[f+(o<<2)>>2];xo[c[c[h>>2]>>2]&2047](h,m,2)|0;o=o+1|0}while((o|0)!=(e|0));i=l;return}}else{o=e+-1|0;if(!e){i=l;return}e=m+3|0;d=m+1|0;n=m+2|0;if(j){j=f;p=o;while(1){q=ea(g[j>>2]);g[m>>2]=q;r=(g[k>>2]=q,c[k>>2]|0);a[m>>0]=r>>>24;a[e>>0]=r;a[d>>0]=r>>>16;a[n>>0]=r>>>8;xo[c[c[h>>2]>>2]&2047](h,m,4)|0;if(!p)break;else{j=j+4|0;p=p+-1|0}}i=l;return}else{p=f;f=o;while(1){g[m>>2]=ea(g[p>>2]);xo[c[c[h>>2]>>2]&2047](h,m,4)|0;if(!f)break;else{p=p+4|0;f=f+-1|0}}i=l;return}}}function fNa(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;i=i+16|0;m=l;n=l+2|0;if(f>>>0<256){if(!g){i=l;return}o=0;do{xo[c[c[j>>2]>>2]&2047](j,n,1)|0;c[h+(o<<2)>>2]=d[n>>0];o=o+1|0}while((o|0)!=(g|0));i=l;return}if(f>>>0>=65536){xo[c[c[j>>2]>>2]&2047](j,h,g<<2)|0;if((g|0)==0|k^1){i=l;return}else p=0;do{f=h+(p<<2)|0;o=a[f>>0]|0;n=f+3|0;a[f>>0]=a[n>>0]|0;a[n>>0]=o;o=f+1|0;n=a[o>>0]|0;q=f+2|0;a[o>>0]=a[q>>0]|0;a[q>>0]=n;p=p+1|0}while((p|0)!=(g|0));i=l;return}if(!g){i=l;return}p=m+1|0;if(k){k=0;do{xo[c[c[j>>2]>>2]&2047](j,m,2)|0;n=b[m>>1]|0;a[m>>0]=(n&65535)>>>8;a[p>>0]=n;c[h+(k<<2)>>2]=e[m>>1];k=k+1|0}while((k|0)!=(g|0));i=l;return}else{k=0;do{xo[c[c[j>>2]>>2]&2047](j,m,2)|0;c[h+(k<<2)>>2]=e[m>>1];k=k+1|0}while((k|0)!=(g|0));i=l;return}}function gNa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j;l=j+2|0;m=(e|0)==0;if((d&65535)<256){if(m){i=j;return}d=0;do{a[l>>0]=b[f+(d<<1)>>1];xo[c[c[g>>2]>>2]&2047](g,l,1)|0;d=d+1|0}while((d|0)!=(e|0));i=j;return}if(m){i=j;return}m=k+1|0;d=0;do{l=b[f+(d<<1)>>1]|0;b[k>>1]=l;if(h){a[k>>0]=(l&65535)>>>8;a[m>>0]=l}xo[c[c[g>>2]>>2]&2047](g,k,2)|0;d=d+1|0}while((d|0)!=(e|0));i=j;return}function hNa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;if((e&65535)<256){e=i;i=i+((1*f|0)+15&-16)|0;xo[c[c[h>>2]>>2]&2047](h,e,f)|0;if(!f){i=k;return}else l=0;do{b[g+(l<<1)>>1]=d[e+l>>0]|0;l=l+1|0}while((l|0)!=(f|0));i=k;return}l=f<<1;e=i;i=i+((1*l|0)+15&-16)|0;xo[c[c[h>>2]>>2]&2047](h,e,l)|0;l=(f|0)==0;if(!(l|j^1)){j=0;do{h=e+(j<<1)|0;m=a[h>>0]|0;n=h+1|0;a[h>>0]=a[n>>0]|0;a[n>>0]=m;j=j+1|0}while((j|0)!=(f|0))}if(l){i=k;return}YEi(g|0,e|0,f<<1|0)|0;i=k;return}function iNa(b,d,e,f,h,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=0,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=Im,ma=0,na=Im,oa=0,pa=Im,qa=Im,ra=0,sa=Im,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=Im,Ba=0,Ca=Im,Da=0;r=i;i=i+208|0;s=r+144|0;t=r+196|0;u=r+184|0;v=r+172|0;w=r+160|0;x=r;y=ea(g[q>>2]);z=q+4|0;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];if(!h){A=y;B=0;g[q>>2]=A;c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];i=r;return B|0}C=x+64|0;D=x+80|0;E=x+16|0;F=x+20|0;G=x+32|0;H=x+36|0;I=x+48|0;J=x+52|0;K=x+96|0;L=x+100|0;M=x+104|0;N=x+108|0;O=x+112|0;P=x+116|0;Q=x+120|0;R=x+124|0;S=x+128|0;U=x+132|0;V=x+136|0;W=x+140|0;X=k+44|0;Y=m+4|0;Z=m+8|0;_=m+12|0;$=b+4|0;aa=b+8|0;if(e){ba=y;e=0;ca=0;while(1){c[l>>2]=0;c[D>>2]=7;g[I>>2]=ea(0.0);c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[C+0>>2]=c[s+0>>2];c[C+4>>2]=c[s+4>>2];c[C+8>>2]=c[s+8>>2];c[C+12>>2]=c[s+12>>2];g[E>>2]=ea(.0199999996);c[F+0>>2]=c[v+0>>2];c[F+4>>2]=c[v+4>>2];c[F+8>>2]=c[v+8>>2];g[G>>2]=ea(3402823469999999843913219.0e14);c[H+0>>2]=c[t+0>>2];c[H+4>>2]=c[t+4>>2];c[H+8>>2]=c[t+8>>2];da=ea(g[f+(ca*40|0)>>2]);fa=ea(g[f+(ca*40|0)+4>>2]);ga=ea(g[f+(ca*40|0)+8>>2]);g[K>>2]=da;g[L>>2]=fa;g[M>>2]=ga;g[N>>2]=ea(0.0);ga=ea(g[f+(ca*40|0)+12>>2]);fa=ea(g[f+(ca*40|0)+16>>2]);da=ea(g[f+(ca*40|0)+20>>2]);g[O>>2]=ga;g[P>>2]=fa;g[Q>>2]=da;g[R>>2]=ea(0.0);da=ea(g[f+(ca*40|0)+24>>2]);fa=ea(g[f+(ca*40|0)+28>>2]);ga=ea(g[f+(ca*40|0)+32>>2]);g[S>>2]=da;g[U>>2]=fa;g[V>>2]=ga;g[W>>2]=ea(0.0);ha=ca+j|0;mSa(x,ha,b,d,a[f+(ca*40|0)+36>>0]|0,k,l)|0;ia=c[l>>2]|0;if(ia){ga=ea(g[X>>2]);if(ia>>>0>1){fa=ga;ja=0;ka=1;while(1){da=ea(g[k+(ka<<6)+44>>2]);if(fa>da){c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];la=da;ma=ka}else{la=fa;ma=ja}ka=ka+1|0;if((ka|0)==(ia|0)){na=la;oa=ma;break}else{fa=la;ja=ma}}}else{na=ga;oa=0}if(ba>na){c[p>>2]=ha;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];fa=ea(g[k+(oa<<6)+32>>2]);da=ea(g[k+(oa<<6)+36>>2]);pa=ea(g[k+(oa<<6)+40>>2]);g[m>>2]=fa;g[Y>>2]=da;g[Z>>2]=pa;g[_>>2]=ea(0.0);ja=k+(oa<<6)+16|0;c[n+0>>2]=c[ja+0>>2];c[n+4>>2]=c[ja+4>>2];c[n+8>>2]=c[ja+8>>2];c[n+12>>2]=c[ja+12>>2];ja=k+(oa<<6)|0;c[o+0>>2]=c[ja+0>>2];c[o+4>>2]=c[ja+4>>2];c[o+8>>2]=c[ja+8>>2];c[o+12>>2]=c[ja+12>>2];qa=na;ra=1}else{qa=ba;ra=1}}else{qa=ba;ra=e}ca=ca+1|0;if((ca|0)==(h|0)){A=qa;B=ra;break}else{ba=qa;e=ra}}g[q>>2]=A;c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];i=r;return B|0}else{sa=y;ta=0;ua=0}while(1){c[l>>2]=0;c[D>>2]=7;g[I>>2]=ea(0.0);c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[C+0>>2]=c[s+0>>2];c[C+4>>2]=c[s+4>>2];c[C+8>>2]=c[s+8>>2];c[C+12>>2]=c[s+12>>2];g[E>>2]=ea(.0199999996);c[F+0>>2]=c[v+0>>2];c[F+4>>2]=c[v+4>>2];c[F+8>>2]=c[v+8>>2];g[G>>2]=ea(3402823469999999843913219.0e14);c[H+0>>2]=c[t+0>>2];c[H+4>>2]=c[t+4>>2];c[H+8>>2]=c[t+8>>2];y=ea(g[f+(ua*40|0)>>2]);qa=ea(g[f+(ua*40|0)+4>>2]);ba=ea(g[f+(ua*40|0)+8>>2]);g[K>>2]=y;g[L>>2]=qa;g[M>>2]=ba;g[N>>2]=ea(0.0);na=ea(g[f+(ua*40|0)+12>>2]);la=ea(g[f+(ua*40|0)+16>>2]);pa=ea(g[f+(ua*40|0)+20>>2]);g[O>>2]=na;g[P>>2]=la;g[Q>>2]=pa;g[R>>2]=ea(0.0);da=ea(g[f+(ua*40|0)+24>>2]);fa=ea(g[f+(ua*40|0)+28>>2]);va=ea(g[f+(ua*40|0)+32>>2]);g[S>>2]=da;g[U>>2]=fa;g[V>>2]=va;g[W>>2]=ea(0.0);wa=ea(na-y);na=ea(la-qa);la=ea(pa-ba);pa=ea(da-y);da=ea(fa-qa);fa=ea(va-ba);va=ea(ea(na*fa)-ea(la*da));xa=ea(ea(la*pa)-ea(wa*fa));fa=ea(ea(wa*da)-ea(na*pa));pa=ea(ea(1.0)/ea(T(ea(ea(fa*fa)+ea(ea(va*va)+ea(xa*xa))))));na=ea(g[$>>2]);da=ea(na-qa);qa=ea(ea(g[b>>2])-y);if(!(ea(ea(ea(ea(pa*xa)*da)+ea(ea(pa*va)*qa))+ea(ea(fa*pa)*ea(ea(g[aa>>2])-ba)))<ea(0.0))?(ra=ua+j|0,mSa(x,ra,b,d,a[f+(ua*40|0)+36>>0]|0,k,l)|0,e=c[l>>2]|0,(e|0)!=0):0){ba=ea(g[X>>2]);if(e>>>0>1){pa=ba;ca=0;oa=1;while(1){fa=ea(g[k+(oa<<6)+44>>2]);if(pa>fa){c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];ya=fa;za=oa}else{ya=pa;za=ca}oa=oa+1|0;if((oa|0)==(e|0)){Aa=ya;Ba=za;break}else{pa=ya;ca=za}}}else{Aa=ba;Ba=0}if(sa>Aa){c[p>>2]=ra;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];pa=ea(g[k+(Ba<<6)+32>>2]);ga=ea(g[k+(Ba<<6)+36>>2]);fa=ea(g[k+(Ba<<6)+40>>2]);g[m>>2]=pa;g[Y>>2]=ga;g[Z>>2]=fa;g[_>>2]=ea(0.0);ca=k+(Ba<<6)+16|0;c[n+0>>2]=c[ca+0>>2];c[n+4>>2]=c[ca+4>>2];c[n+8>>2]=c[ca+8>>2];c[n+12>>2]=c[ca+12>>2];ca=k+(Ba<<6)|0;c[o+0>>2]=c[ca+0>>2];c[o+4>>2]=c[ca+4>>2];c[o+8>>2]=c[ca+8>>2];c[o+12>>2]=c[ca+12>>2];Ca=Aa;Da=1}else{Ca=sa;Da=1}}else{Ca=sa;Da=ta}ua=ua+1|0;if((ua|0)==(h|0)){A=Ca;B=Da;break}else{sa=Ca;ta=Da}}g[q>>2]=A;c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];i=r;return B|0}function jNa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=Im,la=0,ma=0,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=0;l=i;i=i+6144|0;m=l+80|0;n=l+4240|0;o=l+32|0;p=l+4256|0;q=l+6096|0;r=l+64|0;s=l;t=l+16|0;u=l+4236|0;v=l+48|0;w=l+6112|0;x=l+4176|0;y=l+4244|0;z=l+4816|0;A=b+36|0;B=c[(c[A>>2]|0)+168>>2]|0;c[n>>2]=0;g[o>>2]=ea(f*ea(1.14999998));i_a(p,d,b+4|0);aLa(q);fLa(q,128,l+4304|0,1);C=r+4|0;D=r+8|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;E=t+4|0;F=t+8|0;G=t+12|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[u>>2]=268435455;H=q+4|0;I=e+96|0;J=e+100|0;K=e+104|0;L=e+108|0;M=w+4|0;N=w+8|0;O=e+112|0;P=e+116|0;Q=e+120|0;R=e+124|0;S=w+12|0;U=w+16|0;V=w+20|0;W=w+24|0;X=q+8|0;Y=v+4|0;Z=e+128|0;_=k+40|0;$=k+16|0;aa=k+20|0;ba=k+24|0;ca=k+28|0;da=k+32|0;fa=k+36|0;ga=k+8|0;k=e+4|0;ha=e+8|0;ia=e+12|0;h=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=0;ma=0;while(1){if(c[H>>2]|0)c[H>>2]=0;na=ea(g[I>>2]);oa=ea(g[J>>2]);pa=ea(g[K>>2]);g[w>>2]=na;g[M>>2]=oa;g[N>>2]=pa;pa=ea(g[O>>2]);oa=ea(g[P>>2]);na=ea(g[Q>>2]);g[S>>2]=pa;g[U>>2]=oa;g[V>>2]=na;g[W>>2]=f;$Ka(w,x);u6a(b,d,x,q);qa=c[H>>2]|0;if(!qa){ra=h;sa=ja;ta=ka;ua=la;break}va=c[X>>2]|0;g[v>>2]=ea(3402823469999999843913219.0e14);c[Y+0>>2]=c[y+0>>2];c[Y+4>>2]=c[y+4>>2];c[Y+8>>2]=c[y+8>>2];wa=(qa+31|0)>>>5;if(!wa){ra=h;sa=ja;ta=ka;ua=la;break}xa=0;ya=0;za=~qa;while(1){Aa=za>>>0>4294967263?~za:32;Ba=xa<<5;Ca=qa-Ba|0;Da=Ca>>>0<32?Ca:32;if(Da){Ca=0;do{Ea=c[va+(Ca+Ba<<2)>>2]|0;v6a(c[A>>2]|0,z+(Ca*40|0)|0,Ea,p,0,0);a[z+(Ca*40|0)+36>>0]=a[B+Ea>>0]|0;Ca=Ca+1|0}while((Ca|0)!=(Aa|0))}ya=iNa(e,o,j,z,Da,Ba,m,n,t,r,s,u,v)|0|ya;xa=xa+1|0;if(xa>>>0>=wa>>>0)break;else za=za+32|0}if(!ya){ra=h;sa=ja;ta=ka;ua=la;break}Fa=c[va+(c[u>>2]<<2)>>2]|0;c[u>>2]=Fa;na=ea(g[v>>2]);oa=ea(na-ea(g[Z>>2]));if(!(oa<=ea(0.0))){Ga=12;break}na=ea(g[e>>2]);pa=ea(g[k>>2]);Ha=ea(g[ha>>2]);Ia=ea(g[t>>2]);Ja=ea(g[E>>2]);Ka=ea(oa*Ia);Ia=ea(oa*Ja);Ja=ea(oa*ea(g[F>>2]));oa=ea(h-Ka);La=ea(ja-Ia);Ma=ea(ka-Ja);Na=ea(na-Ka);Ka=ea(pa-Ia);Ia=ea(Ha-Ja);Ja=ea(Na-na);na=ea(Ka-pa);pa=ea(Ia-Ha);g[e>>2]=Na;g[k>>2]=Ka;g[ha>>2]=Ia;g[ia>>2]=ea(0.0);Ia=ea(g[I>>2]);Ka=ea(g[J>>2]);Na=ea(na+Ka);Ka=ea(pa+ea(g[K>>2]));g[I>>2]=ea(Ja+Ia);g[J>>2]=Na;g[K>>2]=Ka;g[L>>2]=ea(0.0);Ka=ea(g[O>>2]);Na=ea(g[P>>2]);Ia=ea(na+Na);Na=ea(pa+ea(g[Q>>2]));g[O>>2]=ea(Ja+Ka);g[P>>2]=Ia;g[Q>>2]=Na;g[R>>2]=ea(0.0);za=ma+1|0;if(za>>>0<4){h=oa;ja=La;ka=Ma;la=1;ma=za}else{ra=oa;sa=La;ta=Ma;ua=1;break}}if((Ga|0)==12)if(!ma){g[_>>2]=ea(0.0);f=ea(g[r>>2]);Ma=ea(g[C>>2]);La=ea(g[D>>2]);g[$>>2]=f;g[aa>>2]=Ma;g[ba>>2]=La;La=ea(g[t>>2]);Ma=ea(g[E>>2]);f=ea(g[F>>2]);g[ca>>2]=La;g[da>>2]=Ma;g[fa>>2]=f;c[ga>>2]=Fa;Oa=1;dLa(q);i=l;return Oa|0}else{ra=h;sa=ja;ta=ka;ua=1}ka=ea(T(ea(ea(ta*ta)+ea(ea(sa*sa)+ea(ra*ra)))));ja=ea(ea(1.0)/ka);h=ea(ra*ja);ra=ea(sa*ja);sa=ea(ta*ja);g[t>>2]=h;g[E>>2]=ra;g[F>>2]=sa;g[G>>2]=ea(0.0);if(!ua){Oa=0;dLa(q);i=l;return Oa|0}g[_>>2]=ea(-ka);ka=ea(g[r>>2]);ja=ea(g[C>>2]);ta=ea(g[D>>2]);g[$>>2]=ka;g[aa>>2]=ja;g[ba>>2]=ta;g[ca>>2]=h;g[da>>2]=ra;g[fa>>2]=sa;c[ga>>2]=c[u>>2];Oa=1;dLa(q);i=l;return Oa|0}function kNa(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;m=i;i=i+6160|0;n=m+5544|0;o=m+48|0;p=m+5616|0;q=m+4160|0;r=m+5600|0;s=m+4176|0;t=m+4144|0;u=m;v=m+16|0;w=m+4196|0;x=m+32|0;y=m+5620|0;z=m+5480|0;A=m+5576|0;B=m+5560|0;C=m+4200|0;c[p>>2]=0;g[q>>2]=ea(f*ea(1.00999999));aLa(r);fLa(r,128,m+5648|0,1);c[s+12>>2]=c[b+4>>2];c[s+16>>2]=b;g[s+4>>2]=ea(ea(1.0)/ea(g[b+8>>2]));g[s>>2]=ea(ea(1.0)/ea(g[b+12>>2]));g[s+8>>2]=ea(ea(1.0)/ea(g[b+16>>2]));b=t+4|0;D=t+8|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;E=v+4|0;F=v+8|0;G=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[w>>2]=268435455;H=r+4|0;I=e+96|0;J=e+100|0;K=e+104|0;L=e+108|0;M=y+4|0;N=y+8|0;O=e+112|0;P=e+116|0;Q=e+120|0;R=e+124|0;U=y+12|0;V=y+16|0;W=y+20|0;X=y+24|0;Y=n+4|0;Z=n+8|0;_=n+12|0;$=z+36|0;aa=z+40|0;ba=z+44|0;ca=z+48|0;da=z+52|0;fa=z+56|0;ga=A+4|0;ha=A+8|0;ia=A+12|0;ja=A+16|0;ka=A+20|0;la=n+4|0;ma=r+8|0;na=x+4|0;oa=e+128|0;pa=l+40|0;qa=l+16|0;ra=l+20|0;sa=l+24|0;ta=l+28|0;ua=l+32|0;va=l+36|0;wa=l+8|0;l=e+4|0;xa=e+8|0;ya=e+12|0;h=ea(0.0);za=ea(0.0);Aa=ea(0.0);Ba=0;Ca=0;while(1){if(c[H>>2]|0)c[H>>2]=0;Da=ea(g[I>>2]);Ea=ea(g[J>>2]);Fa=ea(g[K>>2]);g[y>>2]=Da;g[M>>2]=Ea;g[N>>2]=Fa;Fa=ea(g[O>>2]);Ea=ea(g[P>>2]);Da=ea(g[Q>>2]);g[U>>2]=Fa;g[V>>2]=Ea;g[W>>2]=Da;g[X>>2]=f;$Ka(y,z);UUa(n,z);Da=ea(g[n>>2]);Ea=ea(g[Y>>2]);Fa=ea(g[Z>>2]);Ga=ea(g[_>>2]);Ha=ea(g[$>>2]);Ia=ea(g[aa>>2]);Ja=ea(g[ba>>2]);Ka=ea(Da+Da);La=ea(Ea+Ea);Ma=ea(Fa+Fa);Na=ea(Ea*La);Oa=ea(Fa*Ma);Pa=ea(Ka*Ea);Ea=ea(Ka*Fa);Qa=ea(Ka*Ga);Ra=ea(La*Fa);Fa=ea(La*Ga);La=ea(Ma*Ga);Ga=ea(ea(ea(1.0)-Na)-Oa);Ma=ea(Pa+La);Sa=ea(Ea-Fa);Ta=ea(Pa-La);La=ea(ea(1.0)-ea(Da*Ka));Ka=ea(La-Oa);Oa=ea(Ra+Qa);Da=ea(Ea+Fa);Fa=ea(Ra-Qa);Qa=ea(La-Na);Na=ea(g[ca>>2]);La=ea(Ga*Na);Ga=ea(Ma*Na);Ma=ea(Sa*Na);Na=ea(g[da>>2]);Sa=ea(Ta*Na);Ta=ea(Ka*Na);Ka=ea(Oa*Na);Na=ea(g[fa>>2]);Oa=ea(ea(ea(S(ea(La)))+ea(S(ea(Sa))))+ea(S(ea(Da*Na))));Da=ea(ea(ea(S(ea(Ga)))+ea(S(ea(Ta))))+ea(S(ea(Fa*Na))));Fa=ea(ea(ea(S(ea(Ma)))+ea(S(ea(Ka))))+ea(S(ea(Qa*Na))));Na=ea(Ia-Da);Qa=ea(Ja-Fa);Ka=ea(Ha+Oa);Ma=ea(Ia+Da);Da=ea(Ja+Fa);g[A>>2]=ea(Ha-Oa);g[ga>>2]=Na;g[ha>>2]=Qa;g[ia>>2]=Ka;g[ja>>2]=Ma;g[ka>>2]=Da;c[n>>2]=539272;c[la>>2]=r;KRa(s,d,A,k,n)|0;Ua=c[H>>2]|0;if(!Ua){Va=h;Wa=za;Xa=Aa;Ya=Ba;break}Za=c[ma>>2]|0;g[x>>2]=ea(3402823469999999843913219.0e14);c[na+0>>2]=c[B+0>>2];c[na+4>>2]=c[B+4>>2];c[na+8>>2]=c[B+8>>2];_a=(Ua+31|0)>>>5;if(!_a){Va=h;Wa=za;Xa=Aa;Ya=Ba;break}$a=0;ab=0;bb=~Ua;while(1){cb=bb>>>0>4294967263?~bb:32;db=$a<<5;eb=Ua-db|0;fb=eb>>>0<32?eb:32;if(fb){eb=0;do{LRa(s,d,C+(eb*40|0)|0,0,0,c[Za+(eb+db<<2)>>2]|0,1,1)|0;a[C+(eb*40|0)+36>>0]=56;eb=eb+1|0}while((eb|0)!=(cb|0))}ab=iNa(e,q,j,C,fb,db,o,p,v,t,u,w,x)|0|ab;$a=$a+1|0;if($a>>>0>=_a>>>0)break;else bb=bb+32|0}if(!ab){Va=h;Wa=za;Xa=Aa;Ya=Ba;break}gb=c[Za+(c[w>>2]<<2)>>2]|0;c[w>>2]=gb;Da=ea(g[x>>2]);Ma=ea(Da-ea(g[oa>>2]));if(!(Ma<=ea(0.0))){hb=12;break}Da=ea(g[e>>2]);Ka=ea(g[l>>2]);Qa=ea(g[xa>>2]);Na=ea(g[v>>2]);Oa=ea(g[E>>2]);Ha=ea(Ma*Na);Na=ea(Ma*Oa);Oa=ea(Ma*ea(g[F>>2]));Ma=ea(h-Ha);Fa=ea(za-Na);Ja=ea(Aa-Oa);Ia=ea(Da-Ha);Ha=ea(Ka-Na);Na=ea(Qa-Oa);Oa=ea(Ia-Da);Da=ea(Ha-Ka);Ka=ea(Na-Qa);g[e>>2]=Ia;g[l>>2]=Ha;g[xa>>2]=Na;g[ya>>2]=ea(0.0);Na=ea(g[I>>2]);Ha=ea(g[J>>2]);Ia=ea(Da+Ha);Ha=ea(Ka+ea(g[K>>2]));g[I>>2]=ea(Oa+Na);g[J>>2]=Ia;g[K>>2]=Ha;g[L>>2]=ea(0.0);Ha=ea(g[O>>2]);Ia=ea(g[P>>2]);Na=ea(Da+Ia);Ia=ea(Ka+ea(g[Q>>2]));g[O>>2]=ea(Oa+Ha);g[P>>2]=Na;g[Q>>2]=Ia;g[R>>2]=ea(0.0);bb=Ca+1|0;if(bb>>>0<4){h=Ma;za=Fa;Aa=Ja;Ba=1;Ca=bb}else{Va=Ma;Wa=Fa;Xa=Ja;Ya=1;break}}if((hb|0)==12)if(!Ca){g[pa>>2]=ea(0.0);f=ea(g[t>>2]);Ja=ea(g[b>>2]);Fa=ea(g[D>>2]);g[qa>>2]=f;g[ra>>2]=Ja;g[sa>>2]=Fa;Fa=ea(g[v>>2]);Ja=ea(g[E>>2]);f=ea(g[F>>2]);g[ta>>2]=Fa;g[ua>>2]=Ja;g[va>>2]=f;c[wa>>2]=gb;ib=1;dLa(r);i=m;return ib|0}else{Va=h;Wa=za;Xa=Aa;Ya=1}Aa=ea(T(ea(ea(Xa*Xa)+ea(ea(Wa*Wa)+ea(Va*Va)))));za=ea(ea(1.0)/Aa);h=ea(Va*za);Va=ea(Wa*za);Wa=ea(Xa*za);g[v>>2]=h;g[E>>2]=Va;g[F>>2]=Wa;g[G>>2]=ea(0.0);if(!Ya){ib=0;dLa(r);i=m;return ib|0}g[pa>>2]=ea(-Aa);Aa=ea(g[t>>2]);za=ea(g[b>>2]);Xa=ea(g[D>>2]);g[qa>>2]=Aa;g[ra>>2]=za;g[sa>>2]=Xa;g[ta>>2]=h;g[ua>>2]=Va;g[va>>2]=Wa;c[wa>>2]=c[w>>2];ib=1;dLa(r);i=m;return ib|0}function lNa(b,d,f,h,j,k,l,m){b=b|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=ea(k);l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=0,db=0,eb=0,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=0,mb=0,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=Im,_b=0,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=0,gc=0,hc=0,ic=0,jc=Im,kc=0,lc=Im,mc=0,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=0,vc=0,wc=0,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=0,Ec=0;n=i;i=i+6768|0;o=n+4192|0;p=n+4496|0;q=n+4832|0;r=n+96|0;s=n+4844|0;t=n+4728|0;u=n+4848|0;v=n+80|0;w=n+4336|0;x=n+4760|0;y=n+4508|0;z=n;A=n+4912|0;B=n+48|0;C=n+4744|0;D=n+4272|0;E=n+4208|0;F=n+4960|0;G=n+4976|0;H=c[b+36>>2]|0;I=c[H+168>>2]|0;c[s>>2]=0;aLa(t);fLa(t,128,n+6256|0,1);g[u>>2]=ea(g[f>>2]);J=u+4|0;g[J>>2]=ea(g[f+4>>2]);K=u+8|0;g[K>>2]=ea(g[f+8>>2]);L=u+12|0;g[L>>2]=ea(g[f+12>>2]);M=u+16|0;g[M>>2]=ea(g[f+16>>2]);N=u+20|0;g[N>>2]=ea(g[f+20>>2]);O=u+24|0;g[O>>2]=ea(g[f+24>>2]);P=u+28|0;g[P>>2]=ea(g[f+28>>2]);Q=u+32|0;g[Q>>2]=ea(g[f+32>>2]);R=u+36|0;g[R>>2]=ea(g[f+36>>2]);S=u+40|0;g[S>>2]=ea(g[f+40>>2]);U=u+44|0;g[U>>2]=ea(g[f+44>>2]);k=ea(g[f+48>>2]);V=ea(g[f+52>>2]);W=ea(g[f+56>>2]);X=ea(g[h>>2]);Y=ea(g[h+4>>2]);Z=ea(g[h+8>>2]);_=ea(g[h+12>>2]);$=h+16|0;aa=ea(g[$>>2]);ba=ea(g[$+4>>2]);ca=ea(g[$+8>>2]);da=!(k<=V)?V:k;fa=!(da<=W)?W:da;da=ea(fa*ea(.150000006));ga=ea(da+j);g[v>>2]=ga;g[u+48>>2]=ea(k+ga);g[u+52>>2]=ea(V+ga);g[u+56>>2]=ea(W+ga);$=w+64|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+80>>2]=3;h=w+20|0;c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];ha=w+36|0;g[w+48>>2]=ea(0.0);ia=w+52|0;c[ia+0>>2]=c[p+0>>2];c[ia+4>>2]=c[p+4>>2];c[ia+8>>2]=c[p+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[$+0>>2]=c[o+0>>2];c[$+4>>2]=c[o+4>>2];c[$+8>>2]=c[o+8>>2];c[$+12>>2]=c[o+12>>2];g[w+144>>2]=k;g[w+148>>2]=V;g[w+152>>2]=W;g[w+156>>2]=ea(0.0);ga=!(k>=V)?V:k;k=ea((!(ga>=W)?W:ga)*ea(.0299999993));ga=da>k?da:k;g[w+16>>2]=fa>ga?ga:fa;c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];g[w+32>>2]=ea(fa*ea(.0500000007));c[ha+0>>2]=c[o+0>>2];c[ha+4>>2]=c[o+4>>2];c[ha+8>>2]=c[o+8>>2];fa=ea(g[R>>2]);ga=ea(g[S>>2]);k=ea(g[U>>2]);FSa(y,f+48|0);GSa(y,x);g[z>>2]=ea(1.0);y=z+4|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[z+20>>2]=ea(1.0);y=z+24|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[z+40>>2]=ea(1.0);g[z+44>>2]=ea(0.0);i_a(A,d,b+4|0);g[B>>2]=X;y=B+4|0;g[y>>2]=Y;f=B+8|0;g[f>>2]=Z;ha=B+12|0;g[ha>>2]=_;h=B+16|0;g[h>>2]=aa;$=B+20|0;g[$>>2]=ba;ia=B+24|0;g[ia>>2]=ca;ja=B+28|0;g[ja>>2]=ea(0.0);ka=t+4|0;la=D+32|0;ma=D+36|0;na=D+40|0;oa=D+44|0;pa=D+48|0;qa=D+16|0;ca=ea(g[A>>2]);ba=ea(g[A+4>>2]);aa=ea(g[A+8>>2]);_=ea(g[A+12>>2]);Z=ea(g[A+16>>2]);Y=ea(g[A+20>>2]);X=ea(g[A+24>>2]);da=ea(g[A+28>>2]);W=ea(g[A+32>>2]);V=ea(g[A+36>>2]);j=ea(g[A+40>>2]);ra=ea(g[A+44>>2]);A=E+48|0;sa=E+52|0;ta=E+56|0;ua=E+60|0;va=E+4|0;wa=E+8|0;xa=E+12|0;ya=E+16|0;za=E+20|0;Aa=E+24|0;Ba=E+28|0;Ca=E+32|0;Da=E+36|0;Ea=E+40|0;Fa=E+44|0;Ga=t+8|0;Ha=m+40|0;Ia=m+16|0;Ja=m+20|0;Ka=m+24|0;La=m+28|0;Ma=m+32|0;Na=m+36|0;Oa=m+8|0;m=r+44|0;Pa=H+172|0;Qa=H+28|0;Ra=H+24|0;Sa=fa;fa=ga;ga=k;k=ea(0.0);Ta=ea(0.0);Ua=ea(0.0);H=268435455;Va=ea(0.0);Wa=ea(0.0);Xa=ea(0.0);Ya=ea(0.0);Za=ea(0.0);_a=ea(0.0);$a=ea(0.0);ab=ea(0.0);bb=ea(0.0);cb=0;db=0;while(1){if(c[ka>>2]|0)c[ka>>2]=0;u6a(b,d,u,t);eb=c[ka>>2]|0;if(!eb){fb=k;gb=Ta;hb=Ua;ib=Va;jb=Wa;kb=Xa;lb=H;mb=cb;break}g[h>>2]=Sa;g[$>>2]=fa;g[ia>>2]=ga;g[ja>>2]=ea(0.0);c[la>>2]=B;c[ma>>2]=z;c[na>>2]=z;a[oa>>0]=1;c[D>>2]=537520;c[pa>>2]=w;c[qa+0>>2]=0;c[qa+4>>2]=0;c[qa+8>>2]=0;c[qa+12>>2]=0;nb=ea(g[u>>2]);ob=ea(g[J>>2]);pb=ea(g[K>>2]);qb=ea(g[L>>2]);rb=ea(g[M>>2]);sb=ea(g[N>>2]);tb=ea(g[O>>2]);ub=ea(g[P>>2]);vb=ea(g[Q>>2]);wb=ea(g[R>>2]);xb=ea(g[S>>2]);yb=ea(-wb);wb=ea(-xb);xb=ea(-ea(g[U>>2]));zb=ea(ea(ea(nb*ca)+ea(ob*ba))+ea(pb*aa));Ab=ea(ea(ea(qb*ca)+ea(rb*ba))+ea(sb*aa));Bb=ea(ea(ea(tb*ca)+ea(ub*ba))+ea(vb*aa));Cb=ea(ea(ea(nb*_)+ea(ob*Z))+ea(pb*Y));Db=ea(ea(ea(qb*_)+ea(rb*Z))+ea(sb*Y));Eb=ea(ea(ea(tb*_)+ea(ub*Z))+ea(vb*Y));Fb=ea(ea(ea(nb*X)+ea(ob*da))+ea(pb*W));Gb=ea(ea(ea(qb*X)+ea(rb*da))+ea(sb*W));Hb=ea(ea(ea(tb*X)+ea(ub*da))+ea(vb*W));Ib=ea(ea(ea(ea(qb*yb)+ea(rb*wb))+ea(sb*xb))+ea(ea(ea(qb*V)+ea(rb*j))+ea(sb*ra)));sb=ea(ea(ea(ea(tb*yb)+ea(ub*wb))+ea(vb*xb))+ea(ea(ea(tb*V)+ea(ub*j))+ea(vb*ra)));g[A>>2]=ea(ea(ea(ea(nb*yb)+ea(ob*wb))+ea(pb*xb))+ea(ea(ea(nb*V)+ea(ob*j))+ea(pb*ra)));g[sa>>2]=Ib;g[ta>>2]=sb;g[ua>>2]=ea(0.0);g[E>>2]=zb;g[va>>2]=Ab;g[wa>>2]=Bb;g[xa>>2]=ea(0.0);g[ya>>2]=Cb;g[za>>2]=Db;g[Aa>>2]=Eb;g[Ba>>2]=ea(0.0);g[Ca>>2]=Fb;g[Da>>2]=Gb;g[Ea>>2]=Hb;g[Fa>>2]=ea(0.0);Jb=c[Ga>>2]|0;c[C+0>>2]=c[F+0>>2];c[C+4>>2]=c[F+4>>2];c[C+8>>2]=c[F+8>>2];Kb=(eb+31|0)>>>5;if(!Kb){fb=k;gb=Ta;hb=Ua;ib=Va;jb=Wa;kb=Xa;lb=H;mb=cb;break}Hb=ea(3402823469999999843913219.0e14);Lb=H;Gb=Ya;Fb=Za;Eb=_a;Db=$a;Cb=ab;Bb=bb;Mb=0;Nb=0;Ob=~eb;while(1){Pb=Ob>>>0>4294967263?~Ob:32;Qb=Mb<<5;Rb=eb-Qb|0;Sb=Rb>>>0<32?Rb:32;Rb=(Sb|0)==0;if(!Rb){Tb=0;do{Ub=c[Jb+(Tb+Qb<<2)>>2]|0;Vb=c[Qa>>2]|0;if(!(a[Pa>>0]&2)){Wb=c[Vb+(Ub*12|0)>>2]|0;Xb=c[Vb+(Ub*12|0)+4>>2]|0;Yb=c[Vb+(Ub*12|0)+8>>2]|0}else{Wb=e[Vb+(Ub*6|0)>>1]|0;Xb=e[Vb+(Ub*6|0)+2>>1]|0;Yb=e[Vb+(Ub*6|0)+4>>1]|0}Vb=c[Ra>>2]|0;g[G+(Tb*40|0)>>2]=ea(g[Vb+(Wb*12|0)>>2]);g[G+(Tb*40|0)+4>>2]=ea(g[Vb+(Wb*12|0)+4>>2]);g[G+(Tb*40|0)+8>>2]=ea(g[Vb+(Wb*12|0)+8>>2]);g[G+(Tb*40|0)+12>>2]=ea(g[Vb+(Xb*12|0)>>2]);g[G+(Tb*40|0)+16>>2]=ea(g[Vb+(Xb*12|0)+4>>2]);g[G+(Tb*40|0)+20>>2]=ea(g[Vb+(Xb*12|0)+8>>2]);g[G+(Tb*40|0)+24>>2]=ea(g[Vb+(Yb*12|0)>>2]);g[G+(Tb*40|0)+28>>2]=ea(g[Vb+(Yb*12|0)+4>>2]);g[G+(Tb*40|0)+32>>2]=ea(g[Vb+(Yb*12|0)+8>>2]);a[G+(Tb*40|0)+36>>0]=a[I+Ub>>0]|0;Tb=Tb+1|0}while((Tb|0)!=(Pb|0));c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];if(Rb){Zb=Hb;_b=Lb;$b=Gb;ac=Fb;bc=Eb;cc=Db;dc=Cb;ec=Bb;fc=0}else{Ab=Hb;zb=Bb;sb=Cb;Ib=Db;pb=Eb;ob=Fb;nb=Gb;Pb=Lb;Tb=0;Ub=0;while(1){c[s>>2]=0;Vb=Ub+Qb|0;fSa(x,D,G+(Ub*40|0)|0,Vb,a[G+(Ub*40|0)+36>>0]|0,v,l,B,E,r,s)|0;gc=c[s>>2]|0;if(gc){xb=ea(g[m>>2]);if(gc>>>0>1){wb=xb;hc=0;ic=1;while(1){yb=ea(g[r+(ic<<6)+44>>2]);if(wb>yb){c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];jc=yb;kc=ic}else{jc=wb;kc=hc}ic=ic+1|0;if((ic|0)==(gc|0)){lc=jc;mc=kc;break}else{wb=jc;hc=kc}}}else{lc=xb;mc=0}if(Ab>lc){c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];wb=ea(g[r+(mc<<6)+32>>2]);yb=ea(g[r+(mc<<6)+36>>2]);vb=ea(g[r+(mc<<6)+40>>2]);ub=ea(g[r+(mc<<6)+16>>2]);tb=ea(g[r+(mc<<6)+20>>2]);nc=lc;oc=ea(g[r+(mc<<6)+24>>2]);pc=tb;qc=ub;rc=vb;sc=yb;tc=wb;uc=Vb;vc=1}else{nc=Ab;oc=zb;pc=sb;qc=Ib;rc=pb;sc=ob;tc=nb;uc=Pb;vc=1}}else{nc=Ab;oc=zb;pc=sb;qc=Ib;rc=pb;sc=ob;tc=nb;uc=Pb;vc=Tb}Ub=Ub+1|0;if((Ub|0)==(Sb|0)){Zb=nc;_b=uc;$b=tc;ac=sc;bc=rc;cc=qc;dc=pc;ec=oc;fc=vc;break}else{Ab=nc;zb=oc;sb=pc;Ib=qc;pb=rc;ob=sc;nb=tc;Pb=uc;Tb=vc}}}}else{c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];Zb=Hb;_b=Lb;$b=Gb;ac=Fb;bc=Eb;cc=Db;dc=Cb;ec=Bb;fc=0};c[C+0>>2]=c[q+0>>2];c[C+4>>2]=c[q+4>>2];c[C+8>>2]=c[q+8>>2];Nb=fc|Nb;Mb=Mb+1|0;if(Mb>>>0>=Kb>>>0)break;else{Hb=Zb;Lb=_b;Gb=$b;Fb=ac;Eb=bc;Db=cc;Cb=dc;Bb=ec;Ob=Ob+32|0}}if(!Nb){fb=k;gb=Ta;hb=Ua;ib=Va;jb=Wa;kb=Xa;lb=_b;mb=cb;break}wc=c[Jb+(_b<<2)>>2]|0;Bb=ea(g[B>>2]);Cb=ea(g[y>>2]);Db=ea(g[f>>2]);Eb=ea(g[ha>>2]);Fb=ea(ea(Eb*Eb)+ea(-.5));Gb=ea(ea(ea($b*Bb)+ea(ac*Cb))+ea(bc*Db));xc=ea(ea(ea(Bb*Gb)+ea(ea(Eb*ea(ea(bc*Cb)-ea(ac*Db)))+ea($b*Fb)))*ea(2.0));yc=ea(ea(ea(Cb*Gb)+ea(ea(Eb*ea(ea($b*Db)-ea(bc*Bb)))+ea(ac*Fb)))*ea(2.0));zc=ea(ea(ea(Db*Gb)+ea(ea(Eb*ea(ea(ac*Bb)-ea($b*Cb)))+ea(bc*Fb)))*ea(2.0));Gb=ea(g[h>>2]);Hb=ea(g[$>>2]);nb=ea(ea(ea(cc*Bb)+ea(dc*Cb))+ea(ec*Db));Ac=ea(Gb+ea(ea(ea(Bb*nb)+ea(ea(Eb*ea(ea(ec*Cb)-ea(dc*Db)))+ea(cc*Fb)))*ea(2.0)));Bc=ea(Hb+ea(ea(ea(Cb*nb)+ea(ea(Eb*ea(ea(cc*Db)-ea(ec*Bb)))+ea(dc*Fb)))*ea(2.0)));Cc=ea(ea(g[ia>>2])+ea(ea(ea(Db*nb)+ea(ea(Eb*ea(ea(dc*Bb)-ea(cc*Cb)))+ea(ec*Fb)))*ea(2.0)));if(!(Zb<=ea(0.0))){Dc=25;break}Fb=ea(Zb*xc);Cb=ea(Zb*yc);Bb=ea(Zb*zc);Eb=ea(k-Fb);nb=ea(Ta-Cb);Db=ea(Ua-Bb);Sa=ea(Sa-Fb);fa=ea(fa-Cb);ga=ea(ga-Bb);g[R>>2]=Sa;g[S>>2]=fa;g[U>>2]=ga;Ob=db+1|0;if(Ob>>>0>=4){fb=Eb;gb=nb;hb=Db;ib=Ac;jb=Bc;kb=Cc;lb=wc;mb=1;break}else{k=Eb;Ta=nb;Ua=Db;H=wc;Va=Ac;Wa=Bc;Xa=Cc;Ya=$b;Za=ac;_a=bc;$a=cc;ab=dc;bb=ec;cb=1;db=Ob}}if((Dc|0)==25)if(!db){g[Ha>>2]=ea(0.0);g[Ia>>2]=Ac;g[Ja>>2]=Bc;g[Ka>>2]=Cc;g[La>>2]=xc;g[Ma>>2]=yc;g[Na>>2]=zc;c[Oa>>2]=wc;Ec=1;dLa(t);i=n;return Ec|0}else{fb=k;gb=Ta;hb=Ua;ib=Ac;jb=Bc;kb=Cc;lb=wc;mb=1}Cc=ea(T(ea(ea(hb*hb)+ea(ea(gb*gb)+ea(fb*fb)))));Bc=ea(ea(1.0)/Cc);if(!mb){Ec=0;dLa(t);i=n;return Ec|0}Ac=ea(hb*Bc);hb=ea(gb*Bc);gb=ea(fb*Bc);g[Ha>>2]=ea(-Cc);g[Ia>>2]=ib;g[Ja>>2]=jb;g[Ka>>2]=kb;g[La>>2]=gb;g[Ma>>2]=hb;g[Na>>2]=Ac;c[Oa>>2]=lb;Ec=1;dLa(t);i=n;return Ec|0}function mNa(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=Im,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=Im,kb=Im,lb=Im,mb=0,nb=0,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=0,Nb=0,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=Im,dc=0,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=Im,rc=0,sc=Im,tc=0,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=0,Cc=0,Dc=0,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=0,Lc=0;n=i;i=i+6752|0;o=n+4480|0;p=n+4528|0;q=n+4948|0;r=n+256|0;s=n+4884|0;t=n+4624|0;u=n+4496|0;v=n+4888|0;w=n+80|0;x=n+96|0;y=n+4552|0;z=n+4664|0;A=n;B=n+48|0;C=n+4516|0;D=n+4640|0;E=n+4416|0;F=n+4352|0;G=n+4540|0;H=n+4960|0;c[s>>2]=0;aLa(t);fLa(t,128,n+6240|0,1);c[u+12>>2]=c[b+4>>2];c[u+16>>2]=b;g[u+4>>2]=ea(ea(1.0)/ea(g[b+8>>2]));g[u>>2]=ea(ea(1.0)/ea(g[b+12>>2]));g[u+8>>2]=ea(ea(1.0)/ea(g[b+16>>2]));g[v>>2]=ea(g[e>>2]);b=v+4|0;g[b>>2]=ea(g[e+4>>2]);I=v+8|0;g[I>>2]=ea(g[e+8>>2]);J=v+12|0;g[J>>2]=ea(g[e+12>>2]);K=v+16|0;g[K>>2]=ea(g[e+16>>2]);L=v+20|0;g[L>>2]=ea(g[e+20>>2]);M=v+24|0;g[M>>2]=ea(g[e+24>>2]);N=v+28|0;g[N>>2]=ea(g[e+28>>2]);O=v+32|0;g[O>>2]=ea(g[e+32>>2]);P=v+36|0;g[P>>2]=ea(g[e+36>>2]);Q=v+40|0;g[Q>>2]=ea(g[e+40>>2]);R=v+44|0;g[R>>2]=ea(g[e+44>>2]);U=v+48|0;j=ea(g[e+48>>2]);V=v+52|0;W=ea(g[e+52>>2]);X=v+56|0;Y=ea(g[e+56>>2]);Z=ea(g[f>>2]);_=ea(g[f+4>>2]);$=ea(g[f+8>>2]);aa=ea(g[f+12>>2]);ba=f+16|0;ca=ea(g[ba>>2]);da=ea(g[ba+4>>2]);fa=ea(g[ba+8>>2]);ga=!(j<=W)?W:j;ha=!(ga<=Y)?Y:ga;ga=ea(ha*ea(.150000006));ia=ea(ga+h);g[w>>2]=ia;g[U>>2]=ea(j+ia);g[V>>2]=ea(W+ia);g[X>>2]=ea(Y+ia);ba=x+64|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[x+80>>2]=3;f=x+20|0;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];ja=x+36|0;g[x+48>>2]=ea(0.0);ka=x+52|0;c[ka+0>>2]=c[q+0>>2];c[ka+4>>2]=c[q+4>>2];c[ka+8>>2]=c[q+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[ba+0>>2]=c[o+0>>2];c[ba+4>>2]=c[o+4>>2];c[ba+8>>2]=c[o+8>>2];c[ba+12>>2]=c[o+12>>2];g[x+144>>2]=j;g[x+148>>2]=W;g[x+152>>2]=Y;g[x+156>>2]=ea(0.0);ia=!(j>=W)?W:j;j=ea((!(ia>=Y)?Y:ia)*ea(.0299999993));ia=ga>j?ga:j;g[x+16>>2]=ha>ia?ia:ha;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];g[x+32>>2]=ea(ha*ea(.0500000007));c[ja+0>>2]=c[p+0>>2];c[ja+4>>2]=c[p+4>>2];c[ja+8>>2]=c[p+8>>2];ha=ea(g[P>>2]);ia=ea(g[Q>>2]);j=ea(g[R>>2]);FSa(z,e+48|0);GSa(z,y);g[A>>2]=ea(1.0);z=A+4|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;g[A+20>>2]=ea(1.0);z=A+24|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;g[A+40>>2]=ea(1.0);g[A+44>>2]=ea(0.0);ga=ea(g[d>>2]);Y=ea(ga+ga);W=ea(g[d+4>>2]);h=ea(W+W);la=ea(g[d+8>>2]);ma=ea(la+la);na=ea(g[d+12>>2]);oa=ea(Y*na);pa=ea(h*na);qa=ea(na*ma);na=ea(ga*h);ra=ea(ga*ma);sa=ea(W*h);h=ea(W*ma);W=ea(la*ma);ma=ea(ea(ea(1.0)-sa)-W);la=ea(na+qa);ta=ea(ra-pa);ua=ea(na-qa);qa=ea(ea(1.0)-ea(ga*Y));Y=ea(qa-W);W=ea(h+oa);ga=ea(ra+pa);pa=ea(h-oa);oa=ea(qa-sa);sa=ea(g[d+16>>2]);qa=ea(g[d+20>>2]);h=ea(g[d+24>>2]);g[B>>2]=Z;z=B+4|0;g[z>>2]=_;e=B+8|0;g[e>>2]=$;ja=B+12|0;g[ja>>2]=aa;f=B+16|0;g[f>>2]=ca;ba=B+20|0;g[ba>>2]=da;ka=B+24|0;g[ka>>2]=fa;va=B+28|0;g[va>>2]=ea(0.0);wa=t+4|0;xa=o+4|0;ya=o+8|0;za=o+12|0;Aa=D+4|0;Ba=D+8|0;Ca=D+12|0;Da=D+16|0;Ea=D+20|0;Fa=o+4|0;Ga=E+32|0;Ha=E+36|0;Ia=E+40|0;Ja=E+44|0;Ka=E+48|0;La=E+16|0;Ma=F+48|0;Na=F+52|0;Oa=F+56|0;Pa=F+60|0;Qa=F+4|0;Ra=F+8|0;Sa=F+12|0;Ta=F+16|0;Ua=F+20|0;Va=F+24|0;Wa=F+28|0;Xa=F+32|0;Ya=F+36|0;Za=F+40|0;_a=F+44|0;$a=t+8|0;ab=m+40|0;bb=m+16|0;cb=m+20|0;db=m+24|0;eb=m+28|0;fb=m+32|0;gb=m+36|0;hb=m+8|0;m=r+44|0;fa=ha;ha=ia;ia=j;j=ea(0.0);da=ea(0.0);ca=ea(0.0);ib=268435455;aa=ea(0.0);$=ea(0.0);_=ea(0.0);Z=ea(0.0);ra=ea(0.0);na=ea(0.0);jb=ea(0.0);kb=ea(0.0);lb=ea(0.0);mb=0;nb=0;while(1){if(c[wa>>2]|0)c[wa>>2]=0;UUa(o,v);ob=ea(g[o>>2]);pb=ea(g[xa>>2]);qb=ea(g[ya>>2]);rb=ea(g[za>>2]);sb=ea(g[P>>2]);tb=ea(g[Q>>2]);ub=ea(g[R>>2]);vb=ea(ob+ob);wb=ea(pb+pb);xb=ea(qb+qb);yb=ea(pb*wb);zb=ea(qb*xb);Ab=ea(vb*pb);pb=ea(vb*qb);Bb=ea(vb*rb);Cb=ea(wb*qb);qb=ea(wb*rb);wb=ea(xb*rb);rb=ea(ea(ea(1.0)-yb)-zb);xb=ea(Ab+wb);Db=ea(pb-qb);Eb=ea(Ab-wb);wb=ea(ea(1.0)-ea(ob*vb));vb=ea(wb-zb);zb=ea(Cb+Bb);ob=ea(pb+qb);qb=ea(Cb-Bb);Bb=ea(wb-yb);yb=ea(g[U>>2]);wb=ea(rb*yb);rb=ea(xb*yb);xb=ea(Db*yb);yb=ea(g[V>>2]);Db=ea(Eb*yb);Eb=ea(vb*yb);vb=ea(zb*yb);yb=ea(g[X>>2]);zb=ea(ea(ea(S(ea(wb)))+ea(S(ea(Db))))+ea(S(ea(ob*yb))));ob=ea(ea(ea(S(ea(rb)))+ea(S(ea(Eb))))+ea(S(ea(qb*yb))));qb=ea(ea(ea(S(ea(xb)))+ea(S(ea(vb))))+ea(S(ea(Bb*yb))));yb=ea(tb-ob);Bb=ea(ub-qb);vb=ea(sb+zb);xb=ea(tb+ob);ob=ea(ub+qb);g[D>>2]=ea(sb-zb);g[Aa>>2]=yb;g[Ba>>2]=Bb;g[Ca>>2]=vb;g[Da>>2]=xb;g[Ea>>2]=ob;c[o>>2]=539272;c[Fa>>2]=t;KRa(u,d,D,l,o)|0;Fb=c[wa>>2]|0;if(!Fb){Gb=j;Hb=da;Ib=ca;Jb=aa;Kb=$;Lb=_;Mb=ib;Nb=mb;break}g[f>>2]=fa;g[ba>>2]=ha;g[ka>>2]=ia;g[va>>2]=ea(0.0);c[Ga>>2]=B;c[Ha>>2]=A;c[Ia>>2]=A;a[Ja>>0]=1;c[E>>2]=537520;c[Ka>>2]=x;c[La+0>>2]=0;c[La+4>>2]=0;c[La+8>>2]=0;c[La+12>>2]=0;ob=ea(g[v>>2]);xb=ea(g[b>>2]);vb=ea(g[I>>2]);Bb=ea(g[J>>2]);yb=ea(g[K>>2]);zb=ea(g[L>>2]);sb=ea(g[M>>2]);qb=ea(g[N>>2]);ub=ea(g[O>>2]);tb=ea(g[P>>2]);Eb=ea(g[Q>>2]);rb=ea(-tb);tb=ea(-Eb);Eb=ea(-ea(g[R>>2]));Db=ea(ea(ea(ma*ob)+ea(la*xb))+ea(ta*vb));wb=ea(ea(ea(ma*Bb)+ea(la*yb))+ea(ta*zb));Cb=ea(ea(ea(ma*sb)+ea(la*qb))+ea(ta*ub));pb=ea(ea(ea(ua*ob)+ea(Y*xb))+ea(W*vb));Ab=ea(ea(ea(ua*Bb)+ea(Y*yb))+ea(W*zb));Ob=ea(ea(ea(ua*sb)+ea(Y*qb))+ea(W*ub));Pb=ea(ea(ea(ga*ob)+ea(pa*xb))+ea(oa*vb));Qb=ea(ea(ea(ga*Bb)+ea(pa*yb))+ea(oa*zb));Rb=ea(ea(ea(ga*sb)+ea(pa*qb))+ea(oa*ub));Sb=ea(ea(ea(ea(sa*Bb)+ea(qa*yb))+ea(h*zb))+ea(ea(ea(Bb*rb)+ea(yb*tb))+ea(zb*Eb)));zb=ea(ea(ea(ea(sa*sb)+ea(qa*qb))+ea(h*ub))+ea(ea(ea(sb*rb)+ea(qb*tb))+ea(ub*Eb)));g[Ma>>2]=ea(ea(ea(ea(sa*ob)+ea(qa*xb))+ea(h*vb))+ea(ea(ea(ob*rb)+ea(xb*tb))+ea(vb*Eb)));g[Na>>2]=Sb;g[Oa>>2]=zb;g[Pa>>2]=ea(0.0);g[F>>2]=Db;g[Qa>>2]=wb;g[Ra>>2]=Cb;g[Sa>>2]=ea(0.0);g[Ta>>2]=pb;g[Ua>>2]=Ab;g[Va>>2]=Ob;g[Wa>>2]=ea(0.0);g[Xa>>2]=Pb;g[Ya>>2]=Qb;g[Za>>2]=Rb;g[_a>>2]=ea(0.0);Tb=c[$a>>2]|0;c[C+0>>2]=c[G+0>>2];c[C+4>>2]=c[G+4>>2];c[C+8>>2]=c[G+8>>2];Ub=(Fb+31|0)>>>5;if(!Ub){Gb=j;Hb=da;Ib=ca;Jb=aa;Kb=$;Lb=_;Mb=ib;Nb=mb;break}Rb=ea(3402823469999999843913219.0e14);Vb=ib;Qb=Z;Pb=ra;Ob=na;Ab=jb;pb=kb;Cb=lb;Wb=0;Xb=0;Yb=~Fb;while(1){Zb=Yb>>>0>4294967263?~Yb:32;_b=Wb<<5;$b=Fb-_b|0;ac=$b>>>0<32?$b:32;$b=(ac|0)==0;if(!$b){bc=0;do{LRa(u,d,H+(bc*40|0)|0,0,0,c[Tb+(bc+_b<<2)>>2]|0,0,0)|0;a[H+(bc*40|0)+36>>0]=56;bc=bc+1|0}while((bc|0)!=(Zb|0));c[o+0>>2]=c[C+0>>2];c[o+4>>2]=c[C+4>>2];c[o+8>>2]=c[C+8>>2];if($b){cc=Rb;dc=Vb;ec=Qb;fc=Pb;gc=Ob;hc=Ab;ic=pb;jc=Cb;kc=0}else{wb=Rb;Db=Cb;zb=pb;Sb=Ab;Eb=Ob;vb=Pb;tb=Qb;Zb=Vb;bc=0;lc=0;while(1){c[s>>2]=0;mc=lc+_b|0;fSa(y,E,H+(lc*40|0)|0,mc,a[H+(lc*40|0)+36>>0]|0,w,k,B,F,r,s)|0;nc=c[s>>2]|0;if(nc){xb=ea(g[m>>2]);if(nc>>>0>1){rb=xb;oc=0;pc=1;while(1){ob=ea(g[r+(pc<<6)+44>>2]);if(rb>ob){c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];qc=ob;rc=pc}else{qc=rb;rc=oc}pc=pc+1|0;if((pc|0)==(nc|0)){sc=qc;tc=rc;break}else{rb=qc;oc=rc}}}else{sc=xb;tc=0}if(wb>sc){c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];rb=ea(g[r+(tc<<6)+32>>2]);ob=ea(g[r+(tc<<6)+36>>2]);ub=ea(g[r+(tc<<6)+40>>2]);qb=ea(g[r+(tc<<6)+16>>2]);sb=ea(g[r+(tc<<6)+20>>2]);uc=sc;vc=ea(g[r+(tc<<6)+24>>2]);wc=sb;xc=qb;yc=ub;zc=ob;Ac=rb;Bc=mc;Cc=1}else{uc=wb;vc=Db;wc=zb;xc=Sb;yc=Eb;zc=vb;Ac=tb;Bc=Zb;Cc=1}}else{uc=wb;vc=Db;wc=zb;xc=Sb;yc=Eb;zc=vb;Ac=tb;Bc=Zb;Cc=bc}lc=lc+1|0;if((lc|0)==(ac|0)){cc=uc;dc=Bc;ec=Ac;fc=zc;gc=yc;hc=xc;ic=wc;jc=vc;kc=Cc;break}else{wb=uc;Db=vc;zb=wc;Sb=xc;Eb=yc;vb=zc;tb=Ac;Zb=Bc;bc=Cc}}}}else{c[o+0>>2]=c[C+0>>2];c[o+4>>2]=c[C+4>>2];c[o+8>>2]=c[C+8>>2];cc=Rb;dc=Vb;ec=Qb;fc=Pb;gc=Ob;hc=Ab;ic=pb;jc=Cb;kc=0};c[C+0>>2]=c[o+0>>2];c[C+4>>2]=c[o+4>>2];c[C+8>>2]=c[o+8>>2];Xb=kc|Xb;Wb=Wb+1|0;if(Wb>>>0>=Ub>>>0)break;else{Rb=cc;Vb=dc;Qb=ec;Pb=fc;Ob=gc;Ab=hc;pb=ic;Cb=jc;Yb=Yb+32|0}}if(!Xb){Gb=j;Hb=da;Ib=ca;Jb=aa;Kb=$;Lb=_;Mb=dc;Nb=mb;break}Dc=c[Tb+(dc<<2)>>2]|0;Cb=ea(g[B>>2]);pb=ea(g[z>>2]);Ab=ea(g[e>>2]);Ob=ea(g[ja>>2]);Pb=ea(ea(Ob*Ob)+ea(-.5));Qb=ea(ea(ea(ec*Cb)+ea(fc*pb))+ea(gc*Ab));Ec=ea(ea(ea(Cb*Qb)+ea(ea(Ob*ea(ea(gc*pb)-ea(fc*Ab)))+ea(ec*Pb)))*ea(2.0));Fc=ea(ea(ea(pb*Qb)+ea(ea(Ob*ea(ea(ec*Ab)-ea(gc*Cb)))+ea(fc*Pb)))*ea(2.0));Gc=ea(ea(ea(Ab*Qb)+ea(ea(Ob*ea(ea(fc*Cb)-ea(ec*pb)))+ea(gc*Pb)))*ea(2.0));Qb=ea(g[f>>2]);Rb=ea(g[ba>>2]);tb=ea(ea(ea(hc*Cb)+ea(ic*pb))+ea(jc*Ab));Hc=ea(Qb+ea(ea(ea(Cb*tb)+ea(ea(Ob*ea(ea(jc*pb)-ea(ic*Ab)))+ea(hc*Pb)))*ea(2.0)));Ic=ea(Rb+ea(ea(ea(pb*tb)+ea(ea(Ob*ea(ea(hc*Ab)-ea(jc*Cb)))+ea(ic*Pb)))*ea(2.0)));Jc=ea(ea(g[ka>>2])+ea(ea(ea(Ab*tb)+ea(ea(Ob*ea(ea(ic*Cb)-ea(hc*pb)))+ea(jc*Pb)))*ea(2.0)));if(!(cc<=ea(0.0))){Kc=22;break}Pb=ea(cc*Ec);pb=ea(cc*Fc);Cb=ea(cc*Gc);Ob=ea(j-Pb);tb=ea(da-pb);Ab=ea(ca-Cb);fa=ea(fa-Pb);ha=ea(ha-pb);ia=ea(ia-Cb);g[P>>2]=fa;g[Q>>2]=ha;g[R>>2]=ia;Yb=nb+1|0;if(Yb>>>0>=4){Gb=Ob;Hb=tb;Ib=Ab;Jb=Hc;Kb=Ic;Lb=Jc;Mb=Dc;Nb=1;break}else{j=Ob;da=tb;ca=Ab;ib=Dc;aa=Hc;$=Ic;_=Jc;Z=ec;ra=fc;na=gc;jb=hc;kb=ic;lb=jc;mb=1;nb=Yb}}if((Kc|0)==22)if(!nb){g[ab>>2]=ea(0.0);g[bb>>2]=Hc;g[cb>>2]=Ic;g[db>>2]=Jc;g[eb>>2]=Ec;g[fb>>2]=Fc;g[gb>>2]=Gc;c[hb>>2]=Dc;Lc=1;dLa(t);i=n;return Lc|0}else{Gb=j;Hb=da;Ib=ca;Jb=Hc;Kb=Ic;Lb=Jc;Mb=Dc;Nb=1}Jc=ea(T(ea(ea(Ib*Ib)+ea(ea(Hb*Hb)+ea(Gb*Gb)))));Ic=ea(ea(1.0)/Jc);if(!Nb){Lc=0;dLa(t);i=n;return Lc|0}Hc=ea(Ib*Ic);Ib=ea(Hb*Ic);Hb=ea(Gb*Ic);g[ab>>2]=ea(-Jc);g[bb>>2]=Jb;g[cb>>2]=Kb;g[db>>2]=Lb;g[eb>>2]=Hb;g[fb>>2]=Ib;g[gb>>2]=Hc;c[hb>>2]=Mb;Lc=1;dLa(t);i=n;return Lc|0}function nNa(b,d,f,h,j,k,l,m){b=b|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=ea(k);l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=0,ob=0,pb=0,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=0,xb=0,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=Im,pc=0,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=0,xc=0,yc=0,zc=0,Ac=Im,Bc=0,Cc=Im,Dc=0,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=0,Mc=0,Nc=0,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=0,Vc=0;n=i;i=i+6240|0;o=n+4688|0;p=n+4740|0;q=n+4728|0;r=n+432|0;s=n+4684|0;t=n+4752|0;u=n+4840|0;v=n+384|0;w=n+208|0;x=n+240|0;y=n;z=n+416|0;A=n+320|0;B=n+224|0;C=n+4824|0;D=n+4912|0;E=n+4552|0;F=n+4540|0;G=n+4700|0;H=n+4624|0;I=n+256|0;J=n+4528|0;K=n+4960|0;L=c[b+36>>2]|0;M=c[f+32>>2]|0;N=c[L+168>>2]|0;c[s>>2]=0;O=b+4|0;if(ea(g[O>>2])==ea(1.0)?ea(g[b+8>>2])==ea(1.0):0)P=ea(g[b+12>>2])==ea(1.0);else P=0;g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);g[t+16>>2]=ea(1.0);g[t+20>>2]=ea(0.0);g[t+24>>2]=ea(0.0);g[t+28>>2]=ea(0.0);g[t+32>>2]=ea(1.0);g[t+36>>2]=ea(1.0);g[t+40>>2]=ea(0.0);g[t+44>>2]=ea(0.0);g[t+48>>2]=ea(0.0);g[t+52>>2]=ea(1.0);g[t+56>>2]=ea(0.0);g[t+60>>2]=ea(0.0);g[t+64>>2]=ea(0.0);g[t+68>>2]=ea(1.0);if(!P)J0a(t,O,b+16|0);t=M+16|0;P=f+4|0;k=ea(g[P>>2]);if(k==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0)Q=ea(g[f+12>>2])==ea(1.0);else Q=0;g[u>>2]=ea(1.0);R=u+4|0;g[R>>2]=ea(0.0);S=u+8|0;g[S>>2]=ea(0.0);U=u+12|0;g[U>>2]=ea(0.0);V=u+16|0;g[V>>2]=ea(1.0);W=u+20|0;g[W>>2]=ea(0.0);X=u+24|0;g[X>>2]=ea(0.0);Y=u+28|0;g[Y>>2]=ea(0.0);Z=u+32|0;g[Z>>2]=ea(1.0);g[u+36>>2]=ea(1.0);g[u+40>>2]=ea(0.0);g[u+44>>2]=ea(0.0);g[u+48>>2]=ea(0.0);g[u+52>>2]=ea(1.0);g[u+56>>2]=ea(0.0);g[u+60>>2]=ea(0.0);g[u+64>>2]=ea(0.0);g[u+68>>2]=ea(1.0);if(Q){_=k;$=ea(1.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=ea(1.0);fa=ea(0.0);ga=ea(0.0);ha=ea(0.0);ia=ea(1.0)}else{J0a(u,P,f+16|0);k=ea(g[u>>2]);ja=ea(g[R>>2]);ka=ea(g[S>>2]);la=ea(g[U>>2]);ma=ea(g[V>>2]);na=ea(g[W>>2]);oa=ea(g[X>>2]);pa=ea(g[Y>>2]);qa=ea(g[Z>>2]);_=ea(g[P>>2]);$=k;aa=ja;ba=ka;ca=la;da=ma;fa=na;ga=oa;ha=pa;ia=qa}qa=ea(g[M+40>>2]);pa=ea(qa*$);$=ea(qa*aa);aa=ea(qa*ba);ba=ea(g[M+44>>2]);qa=ea(pa+ea(ba*ca));ca=ea($+ea(ba*da));da=ea(aa+ea(ba*fa));fa=ea(g[M+48>>2]);ba=ea(qa+ea(fa*ga));ga=ea(ca+ea(fa*ha));ha=ea(da+ea(fa*ia));ia=ea(g[h>>2]);fa=ea(g[h+4>>2]);da=ea(g[h+8>>2]);ca=ea(g[h+12>>2]);P=h+16|0;qa=ea(g[P>>2]);aa=ea(g[P+4>>2]);$=ea(g[P+8>>2]);g[v>>2]=ia;Z=v+4|0;g[Z>>2]=fa;Y=v+8|0;g[Y>>2]=da;X=v+12|0;g[X>>2]=ca;W=v+16|0;g[W>>2]=qa;V=v+20|0;g[V>>2]=aa;U=v+24|0;g[U>>2]=$;S=v+28|0;g[S>>2]=ea(0.0);ca=ea(g[f+8>>2]);da=ea(g[f+12>>2]);g[w>>2]=_;R=w+4|0;g[R>>2]=ca;u=w+8|0;g[u>>2]=da;g[w+12>>2]=ea(0.0);ra=f+16|0;da=ea(g[ra>>2]);ca=ea(g[ra+4>>2]);_=ea(g[ra+8>>2]);fa=ea(g[ra+12>>2]);g[x>>2]=da;g[x+4>>2]=ca;g[x+8>>2]=_;g[x+12>>2]=fa;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;z1a(y,t,z,w,x);fa=ea(g[M+68>>2]);_=ea(g[M+72>>2]);ca=ea(g[M+76>>2]);da=ea(g[w>>2]);ia=ea(g[R>>2]);pa=ea(fa*da);da=ea(_*ia);ia=ea(ca*ea(g[u>>2]));ca=!(pa<=da)?da:pa;pa=ea(ea((!(ca<=ia)?ia:ca)*ea(.25))+j);g[B>>2]=pa;aLa(C);u=i;i=i+512|0;fLa(C,128,u,1);i_a(D,d,O);HSa(y,Q,E);g[G>>2]=ea(g[h>>2]);O=G+4|0;g[O>>2]=ea(g[h+4>>2]);u=G+8|0;g[u>>2]=ea(g[h+8>>2]);R=G+12|0;g[R>>2]=ea(g[h+12>>2]);w=G+16|0;g[w>>2]=ea(g[P>>2]);P=G+20|0;g[P>>2]=ea(g[h+20>>2]);x=G+24|0;g[x>>2]=ea(g[h+24>>2]);h=C+4|0;z=y+96|0;t=y+144|0;ra=A+32|0;sa=A+36|0;ta=A+40|0;ua=A+44|0;va=Q&1;wa=A+48|0;xa=A+16|0;ya=A+20|0;za=A+24|0;Aa=A+28|0;Ba=H+48|0;Ca=H+52|0;Da=H+56|0;j=ea(g[D>>2]);ca=ea(g[D+4>>2]);ia=ea(g[D+8>>2]);da=ea(g[D+12>>2]);_=ea(g[D+16>>2]);fa=ea(g[D+20>>2]);oa=ea(g[D+24>>2]);na=ea(g[D+28>>2]);ma=ea(g[D+32>>2]);la=ea(g[D+36>>2]);ka=ea(g[D+40>>2]);ja=ea(g[D+44>>2]);D=I+48|0;Ea=I+52|0;Fa=I+56|0;Ga=I+60|0;Ha=I+4|0;Ia=I+8|0;Ja=I+12|0;Ka=I+16|0;La=I+20|0;Ma=I+24|0;Na=I+28|0;Oa=I+32|0;Pa=I+36|0;Qa=I+40|0;Ra=I+44|0;Sa=C+8|0;Ta=m+40|0;Ua=m+16|0;Va=m+20|0;Wa=m+24|0;Xa=m+28|0;Ya=m+32|0;Za=m+36|0;_a=m+8|0;m=r+44|0;$a=L+172|0;ab=L+28|0;bb=L+24|0;k=qa;qa=aa;aa=$;$=ea(0.0);cb=ea(0.0);db=ea(0.0);eb=ea(0.0);fb=ea(0.0);gb=ea(0.0);L=268435455;hb=ea(0.0);ib=ea(0.0);jb=ea(0.0);kb=ea(0.0);lb=ea(0.0);mb=ea(0.0);nb=0;ob=0;while(1){if(c[h>>2]|0)c[h>>2]=0;g[w>>2]=k;g[P>>2]=qa;g[x>>2]=aa;g[W>>2]=k;g[V>>2]=qa;g[U>>2]=aa;g[S>>2]=ea(0.0);c[ra>>2]=v;c[sa>>2]=z;c[ta>>2]=t;a[ua>>0]=va;c[A>>2]=Q?537488|0:537456|0;c[wa>>2]=y;g[xa>>2]=ba;g[ya>>2]=ga;g[za>>2]=ha;g[Aa>>2]=ea(0.0);BOa(H,f,M,G);g[Ba>>2]=ea(pa+ea(g[Ba>>2]));g[Ca>>2]=ea(pa+ea(g[Ca>>2]));g[Da>>2]=ea(pa+ea(g[Da>>2]));u6a(b,d,H,C);pb=c[h>>2]|0;if(!pb){qb=$;rb=cb;sb=db;tb=eb;ub=fb;vb=gb;wb=L;xb=nb;break}yb=ea(g[w>>2]);zb=ea(g[P>>2]);Ab=ea(yb*ea(-2.0));yb=ea(zb*ea(-2.0));zb=ea(ea(g[x>>2])*ea(-2.0));Bb=ea(g[R>>2]);Cb=ea(ea(Bb*Bb)+ea(-.5));Db=ea(g[G>>2]);Eb=ea(Ab*Db);Fb=ea(g[O>>2]);Gb=ea(Eb+ea(yb*Fb));Eb=ea(g[u>>2]);Hb=ea(Gb+ea(zb*Eb));Gb=ea(-Db);Ib=ea(-Fb);Jb=ea(-Eb);Kb=ea(Gb-Db);Lb=ea(Ib-Fb);Mb=ea(Jb-Eb);Nb=ea(Bb*Kb);Ob=ea(Bb*Lb);Pb=ea(Bb*Mb);Qb=ea(Lb*Gb);Rb=ea(Mb*Gb);Sb=ea(Lb*Ib);Lb=ea(Mb*Ib);Ib=ea(Mb*Jb);Jb=ea(ea(ea(1.0)-Sb)-Ib);Mb=ea(Qb+Pb);Tb=ea(Rb-Ob);Ub=ea(Qb-Pb);Pb=ea(ea(1.0)-ea(Kb*Gb));Gb=ea(Pb-Ib);Ib=ea(Nb+Lb);Kb=ea(Ob+Rb);Rb=ea(Lb-Nb);Nb=ea(Pb-Sb);Sb=ea(ea(ia*Kb)+ea(ea(j*Jb)+ea(ca*Ub)));Pb=ea(ea(ia*Rb)+ea(ea(j*Mb)+ea(ca*Gb)));Lb=ea(ea(ia*Nb)+ea(ea(j*Tb)+ea(ca*Ib)));Ob=ea(ea(ea(Jb*da)+ea(Ub*_))+ea(Kb*fa));Qb=ea(ea(ea(Mb*da)+ea(Gb*_))+ea(Rb*fa));Vb=ea(ea(ea(Tb*da)+ea(Ib*_))+ea(Nb*fa));Wb=ea(ea(ea(Jb*oa)+ea(Ub*na))+ea(Kb*ma));Xb=ea(ea(ea(Mb*oa)+ea(Gb*na))+ea(Rb*ma));Yb=ea(ea(ea(Tb*oa)+ea(Ib*na))+ea(Nb*ma));Zb=ea(ea(ea(Fb*Hb)+ea(ea(yb*Cb)-ea(Bb*ea(ea(Ab*Eb)-ea(zb*Db)))))+ea(ea(ea(Mb*la)+ea(Gb*ka))+ea(Rb*ja)));Rb=ea(ea(ea(ea(zb*Cb)-ea(Bb*ea(ea(yb*Db)-ea(Ab*Fb))))+ea(Eb*Hb))+ea(ea(ea(Tb*la)+ea(Ib*ka))+ea(Nb*ja)));g[D>>2]=ea(ea(ea(Db*Hb)+ea(ea(Ab*Cb)-ea(Bb*ea(ea(zb*Fb)-ea(yb*Eb)))))+ea(ea(ea(Jb*la)+ea(Ub*ka))+ea(Kb*ja)));g[Ea>>2]=Zb;g[Fa>>2]=Rb;g[Ga>>2]=ea(0.0);g[I>>2]=Sb;g[Ha>>2]=Pb;g[Ia>>2]=Lb;g[Ja>>2]=ea(0.0);g[Ka>>2]=Ob;g[La>>2]=Qb;g[Ma>>2]=Vb;g[Na>>2]=ea(0.0);g[Oa>>2]=Wb;g[Pa>>2]=Xb;g[Qa>>2]=Yb;g[Ra>>2]=ea(0.0);_b=c[Sa>>2]|0;c[F+0>>2]=c[J+0>>2];c[F+4>>2]=c[J+4>>2];c[F+8>>2]=c[J+8>>2];$b=(pb+31|0)>>>5;if(!$b){qb=$;rb=cb;sb=db;tb=eb;ub=fb;vb=gb;wb=L;xb=nb;break}Yb=ea(3402823469999999843913219.0e14);ac=L;Xb=hb;Wb=ib;Vb=jb;Qb=kb;Ob=lb;Lb=mb;bc=0;cc=0;dc=~pb;while(1){ec=dc>>>0>4294967263?~dc:32;fc=bc<<5;gc=pb-fc|0;hc=gc>>>0<32?gc:32;gc=(hc|0)==0;if(!gc){ic=0;do{jc=c[_b+(ic+fc<<2)>>2]|0;kc=c[ab>>2]|0;if(!(a[$a>>0]&2)){lc=c[kc+(jc*12|0)>>2]|0;mc=c[kc+(jc*12|0)+4>>2]|0;nc=c[kc+(jc*12|0)+8>>2]|0}else{lc=e[kc+(jc*6|0)>>1]|0;mc=e[kc+(jc*6|0)+2>>1]|0;nc=e[kc+(jc*6|0)+4>>1]|0}kc=c[bb>>2]|0;g[K+(ic*40|0)>>2]=ea(g[kc+(lc*12|0)>>2]);g[K+(ic*40|0)+4>>2]=ea(g[kc+(lc*12|0)+4>>2]);g[K+(ic*40|0)+8>>2]=ea(g[kc+(lc*12|0)+8>>2]);g[K+(ic*40|0)+12>>2]=ea(g[kc+(mc*12|0)>>2]);g[K+(ic*40|0)+16>>2]=ea(g[kc+(mc*12|0)+4>>2]);g[K+(ic*40|0)+20>>2]=ea(g[kc+(mc*12|0)+8>>2]);g[K+(ic*40|0)+24>>2]=ea(g[kc+(nc*12|0)>>2]);g[K+(ic*40|0)+28>>2]=ea(g[kc+(nc*12|0)+4>>2]);g[K+(ic*40|0)+32>>2]=ea(g[kc+(nc*12|0)+8>>2]);a[K+(ic*40|0)+36>>0]=a[N+jc>>0]|0;ic=ic+1|0}while((ic|0)!=(ec|0));c[q+0>>2]=c[F+0>>2];c[q+4>>2]=c[F+4>>2];c[q+8>>2]=c[F+8>>2];if(gc){oc=Yb;pc=ac;qc=Xb;rc=Wb;sc=Vb;tc=Qb;uc=Ob;vc=Lb;wc=0}else{Pb=Yb;Sb=Lb;Rb=Ob;Zb=Qb;Kb=Vb;Ub=Wb;Jb=Xb;ec=ac;ic=0;jc=0;while(1){c[s>>2]=0;kc=jc+fc|0;fSa(E,A,K+(jc*40|0)|0,kc,a[K+(jc*40|0)+36>>0]|0,B,l,v,I,r,s)|0;xc=c[s>>2]|0;if(xc){Eb=ea(g[m>>2]);if(xc>>>0>1){yb=Eb;yc=0;zc=1;while(1){Fb=ea(g[r+(zc<<6)+44>>2]);if(yb>Fb){c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];Ac=Fb;Bc=zc}else{Ac=yb;Bc=yc}zc=zc+1|0;if((zc|0)==(xc|0)){Cc=Ac;Dc=Bc;break}else{yb=Ac;yc=Bc}}}else{Cc=Eb;Dc=0}if(Pb>Cc){c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];yb=ea(g[r+(Dc<<6)+32>>2]);Fb=ea(g[r+(Dc<<6)+36>>2]);zb=ea(g[r+(Dc<<6)+40>>2]);Bb=ea(g[r+(Dc<<6)+16>>2]);Cb=ea(g[r+(Dc<<6)+20>>2]);Ec=Cc;Fc=ea(g[r+(Dc<<6)+24>>2]);Gc=Cb;Hc=Bb;Ic=zb;Jc=Fb;Kc=yb;Lc=kc;Mc=1}else{Ec=Pb;Fc=Sb;Gc=Rb;Hc=Zb;Ic=Kb;Jc=Ub;Kc=Jb;Lc=ec;Mc=1}}else{Ec=Pb;Fc=Sb;Gc=Rb;Hc=Zb;Ic=Kb;Jc=Ub;Kc=Jb;Lc=ec;Mc=ic}jc=jc+1|0;if((jc|0)==(hc|0)){oc=Ec;pc=Lc;qc=Kc;rc=Jc;sc=Ic;tc=Hc;uc=Gc;vc=Fc;wc=Mc;break}else{Pb=Ec;Sb=Fc;Rb=Gc;Zb=Hc;Kb=Ic;Ub=Jc;Jb=Kc;ec=Lc;ic=Mc}}}}else{c[q+0>>2]=c[F+0>>2];c[q+4>>2]=c[F+4>>2];c[q+8>>2]=c[F+8>>2];oc=Yb;pc=ac;qc=Xb;rc=Wb;sc=Vb;tc=Qb;uc=Ob;vc=Lb;wc=0};c[F+0>>2]=c[q+0>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];cc=wc|cc;bc=bc+1|0;if(bc>>>0>=$b>>>0)break;else{Yb=oc;ac=pc;Xb=qc;Wb=rc;Vb=sc;Qb=tc;Ob=uc;Lb=vc;dc=dc+32|0}}if(!cc){qb=$;rb=cb;sb=db;tb=eb;ub=fb;vb=gb;wb=pc;xb=nb;break}Nc=c[_b+(pc<<2)>>2]|0;Lb=ea(g[v>>2]);Ob=ea(g[Z>>2]);Qb=ea(g[Y>>2]);Vb=ea(g[X>>2]);Wb=ea(ea(Vb*Vb)+ea(-.5));Xb=ea(ea(ea(qc*Lb)+ea(rc*Ob))+ea(sc*Qb));Oc=ea(ea(ea(Lb*Xb)+ea(ea(Vb*ea(ea(sc*Ob)-ea(rc*Qb)))+ea(qc*Wb)))*ea(2.0));Pc=ea(ea(ea(Ob*Xb)+ea(ea(Vb*ea(ea(qc*Qb)-ea(sc*Lb)))+ea(rc*Wb)))*ea(2.0));Qc=ea(ea(ea(Qb*Xb)+ea(ea(Vb*ea(ea(rc*Lb)-ea(qc*Ob)))+ea(sc*Wb)))*ea(2.0));Xb=ea(g[W>>2]);Yb=ea(g[V>>2]);Jb=ea(ea(ea(tc*Lb)+ea(uc*Ob))+ea(vc*Qb));Rc=ea(Xb+ea(ea(ea(Lb*Jb)+ea(ea(Vb*ea(ea(vc*Ob)-ea(uc*Qb)))+ea(tc*Wb)))*ea(2.0)));Sc=ea(Yb+ea(ea(ea(Ob*Jb)+ea(ea(Vb*ea(ea(tc*Qb)-ea(vc*Lb)))+ea(uc*Wb)))*ea(2.0)));Tc=ea(ea(g[U>>2])+ea(ea(ea(Qb*Jb)+ea(ea(Vb*ea(ea(uc*Lb)-ea(tc*Ob)))+ea(vc*Wb)))*ea(2.0)));if(!(oc<=ea(0.0))){Uc=35;break}Wb=ea(oc*Oc);Ob=ea(oc*Pc);Lb=ea(oc*Qc);Vb=ea($-Wb);Jb=ea(cb-Ob);Qb=ea(db-Lb);k=ea(k-Wb);qa=ea(qa-Ob);aa=ea(aa-Lb);dc=ob+1|0;if(dc>>>0>=2){qb=Vb;rb=Jb;sb=Qb;tb=Rc;ub=Sc;vb=Tc;wb=Nc;xb=1;break}else{$=Vb;cb=Jb;db=Qb;eb=Rc;fb=Sc;gb=Tc;L=Nc;hb=qc;ib=rc;jb=sc;kb=tc;lb=uc;mb=vc;nb=1;ob=dc}}if((Uc|0)==35)if(!ob){g[Ta>>2]=ea(0.0);g[Ua>>2]=Rc;g[Va>>2]=Sc;g[Wa>>2]=Tc;g[Xa>>2]=Oc;g[Ya>>2]=Pc;g[Za>>2]=Qc;c[_a>>2]=Nc;Vc=1;dLa(C);i=n;return Vc|0}else{qb=$;rb=cb;sb=db;tb=Rc;ub=Sc;vb=Tc;wb=Nc;xb=1}Tc=ea(T(ea(ea(sb*sb)+ea(ea(rb*rb)+ea(qb*qb)))));Sc=ea(ea(1.0)/Tc);if(!xb){Vc=0;dLa(C);i=n;return Vc|0}Rc=ea(sb*Sc);sb=ea(rb*Sc);rb=ea(qb*Sc);g[Ta>>2]=ea(-Tc);g[Ua>>2]=tb;g[Va>>2]=ub;g[Wa>>2]=vb;g[Xa>>2]=rb;g[Ya>>2]=sb;g[Za>>2]=Rc;c[_a>>2]=wb;Vc=1;dLa(C);i=n;return Vc|0}function oNa(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=Im,vb=0,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=0,Eb=0,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=0,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=0,Wb=0,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=Im,zc=0,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=Im,Nc=0,Oc=Im,Pc=0,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=0,Yc=0,Zc=0,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=0,fd=0;n=i;i=i+6176|0;o=n+4528|0;p=n+4748|0;q=n+4760|0;r=n+4772|0;s=n+4144|0;t=n;u=n+4608|0;v=n+4616|0;w=n+4096|0;x=n+4288|0;y=n+4512|0;z=n+4304|0;A=n+4224|0;B=n+4128|0;C=n+4792|0;D=n+4808|0;E=n+4568|0;F=n+4540|0;G=n+4688|0;H=n+4584|0;I=n+4160|0;J=n+4880|0;K=n+4896|0;c[r+12>>2]=c[b+4>>2];c[r+16>>2]=b;g[r+4>>2]=ea(ea(1.0)/ea(g[b+8>>2]));g[r>>2]=ea(ea(1.0)/ea(g[b+12>>2]));g[r+8>>2]=ea(ea(1.0)/ea(g[b+16>>2]));c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[u>>2]=0;b=c[e+32>>2]|0;L=b+16|0;M=e+4|0;j=ea(g[M>>2]);if(j==ea(1.0)?ea(g[e+8>>2])==ea(1.0):0)N=ea(g[e+12>>2])==ea(1.0);else N=0;g[v>>2]=ea(1.0);O=v+4|0;g[O>>2]=ea(0.0);P=v+8|0;g[P>>2]=ea(0.0);Q=v+12|0;g[Q>>2]=ea(0.0);R=v+16|0;g[R>>2]=ea(1.0);U=v+20|0;g[U>>2]=ea(0.0);V=v+24|0;g[V>>2]=ea(0.0);W=v+28|0;g[W>>2]=ea(0.0);X=v+32|0;g[X>>2]=ea(1.0);g[v+36>>2]=ea(1.0);g[v+40>>2]=ea(0.0);g[v+44>>2]=ea(0.0);g[v+48>>2]=ea(0.0);g[v+52>>2]=ea(1.0);g[v+56>>2]=ea(0.0);g[v+60>>2]=ea(0.0);g[v+64>>2]=ea(0.0);g[v+68>>2]=ea(1.0);if(N){Y=ea(1.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0);aa=ea(1.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(1.0);ga=j}else{J0a(v,M,e+16|0);j=ea(g[v>>2]);ha=ea(g[O>>2]);ia=ea(g[P>>2]);ja=ea(g[Q>>2]);ka=ea(g[R>>2]);la=ea(g[U>>2]);ma=ea(g[V>>2]);na=ea(g[W>>2]);oa=ea(g[X>>2]);Y=j;Z=ha;_=ia;$=ja;aa=ka;ba=la;ca=ma;da=na;fa=oa;ga=ea(g[M>>2])}oa=ea(g[b+40>>2]);na=ea(oa*Y);Y=ea(oa*Z);Z=ea(oa*_);_=ea(g[b+44>>2]);oa=ea(na+ea(_*$));$=ea(Y+ea(_*aa));aa=ea(Z+ea(_*ba));ba=ea(g[b+48>>2]);_=ea(oa+ea(ba*ca));ca=ea($+ea(ba*da));da=ea(aa+ea(ba*fa));fa=ea(g[f>>2]);ba=ea(g[f+4>>2]);aa=ea(g[f+8>>2]);$=ea(g[f+12>>2]);M=f+16|0;oa=ea(g[M>>2]);Z=ea(g[M+4>>2]);Y=ea(g[M+8>>2]);g[w>>2]=fa;X=w+4|0;g[X>>2]=ba;W=w+8|0;g[W>>2]=aa;V=w+12|0;g[V>>2]=$;U=w+16|0;g[U>>2]=oa;R=w+20|0;g[R>>2]=Z;Q=w+24|0;g[Q>>2]=Y;P=w+28|0;g[P>>2]=ea(0.0);$=ea(g[e+8>>2]);aa=ea(g[e+12>>2]);g[x>>2]=ga;O=x+4|0;g[O>>2]=$;v=x+8|0;g[v>>2]=aa;g[x+12>>2]=ea(0.0);pa=e+16|0;aa=ea(g[pa>>2]);$=ea(g[pa+4>>2]);ga=ea(g[pa+8>>2]);ba=ea(g[pa+12>>2]);g[y>>2]=aa;g[y+4>>2]=$;g[y+8>>2]=ga;g[y+12>>2]=ba;z1a(z,L,s,x,y);ba=ea(g[b+68>>2]);ga=ea(g[b+72>>2]);$=ea(g[b+76>>2]);aa=ea(g[x>>2]);fa=ea(g[O>>2]);na=ea(ba*aa);aa=ea(ga*fa);fa=ea($*ea(g[v>>2]));$=!(na<=aa)?aa:na;na=ea(ea((!($<=fa)?fa:$)*ea(.25))+h);g[B>>2]=na;aLa(C);v=i;i=i+512|0;fLa(C,128,v,1);h=ea(g[s>>2]);$=ea(g[s+4>>2]);fa=ea(g[s+8>>2]);HSa(z,N,D);g[F>>2]=ea(g[f>>2]);s=F+4|0;g[s>>2]=ea(g[f+4>>2]);v=F+8|0;g[v>>2]=ea(g[f+8>>2]);O=F+12|0;g[O>>2]=ea(g[f+12>>2]);x=F+16|0;g[x>>2]=ea(g[M>>2]);M=F+20|0;g[M>>2]=ea(g[f+20>>2]);y=F+24|0;g[y>>2]=ea(g[f+24>>2]);aa=ea(g[d>>2]);ga=ea(aa+aa);ba=ea(g[d+4>>2]);ma=ea(ba+ba);la=ea(g[d+8>>2]);ka=ea(la+la);ja=ea(g[d+12>>2]);ia=ea(ga*ja);ha=ea(ma*ja);j=ea(ja*ka);ja=ea(aa*ma);qa=ea(aa*ka);ra=ea(ba*ma);ma=ea(ba*ka);ba=ea(la*ka);ka=ea(ea(ea(1.0)-ra)-ba);la=ea(ja+j);sa=ea(qa-ha);ta=ea(ja-j);j=ea(ea(1.0)-ea(aa*ga));ga=ea(j-ba);ba=ea(ma+ia);aa=ea(qa+ha);ha=ea(ma-ia);ia=ea(j-ra);ra=ea(g[d+16>>2]);j=ea(g[d+20>>2]);ma=ea(g[d+24>>2]);f=C+4|0;L=z+96|0;pa=z+144|0;ua=A+32|0;va=A+36|0;wa=A+40|0;xa=A+44|0;ya=N&1;za=A+48|0;Aa=A+16|0;Ba=A+20|0;Ca=A+24|0;Da=A+28|0;Ea=G+48|0;Fa=G+52|0;Ga=G+56|0;Ha=G+4|0;Ia=G+8|0;Ja=G+12|0;Ka=G+16|0;La=G+20|0;Ma=G+24|0;Na=G+28|0;Oa=G+32|0;Pa=G+36|0;Qa=G+40|0;Ra=G+44|0;Sa=H+4|0;Ta=H+8|0;Ua=H+12|0;Va=H+16|0;Wa=H+20|0;Xa=o+4|0;Ya=I+48|0;Za=I+52|0;_a=I+56|0;$a=I+60|0;ab=I+4|0;bb=I+8|0;cb=I+12|0;db=I+16|0;eb=I+20|0;fb=I+24|0;gb=I+28|0;hb=I+32|0;ib=I+36|0;jb=I+40|0;kb=I+44|0;lb=C+8|0;mb=m+40|0;nb=m+16|0;ob=m+20|0;pb=m+24|0;qb=m+28|0;rb=m+32|0;sb=m+36|0;tb=m+8|0;m=t+44|0;qa=oa;oa=Z;Z=Y;Y=h;ja=$;ub=fa;vb=268435455;wb=h;xb=$;yb=fa;zb=h;Ab=$;Bb=fa;Cb=h;h=$;$=fa;Db=0;Eb=0;while(1){if(c[f>>2]|0)c[f>>2]=0;g[x>>2]=qa;g[M>>2]=oa;g[y>>2]=Z;g[U>>2]=qa;g[R>>2]=oa;g[Q>>2]=Z;g[P>>2]=ea(0.0);c[ua>>2]=w;c[va>>2]=L;c[wa>>2]=pa;a[xa>>0]=ya;c[A>>2]=N?537488|0:537456|0;c[za>>2]=z;g[Aa>>2]=_;g[Ba>>2]=ca;g[Ca>>2]=da;g[Da>>2]=ea(0.0);BOa(G,e,b,F);fa=ea(na+ea(g[Ea>>2]));g[Ea>>2]=fa;Fb=ea(na+ea(g[Fa>>2]));g[Fa>>2]=Fb;Gb=ea(na+ea(g[Ga>>2]));g[Ga>>2]=Gb;Hb=ea(fa*ea(g[G>>2]));Ib=ea(fa*ea(g[Ha>>2]));Jb=ea(fa*ea(g[Ia>>2]));fa=ea(Fb*ea(g[Ja>>2]));Kb=ea(Fb*ea(g[Ka>>2]));Lb=ea(Fb*ea(g[La>>2]));Fb=ea(Gb*ea(g[Ma>>2]));Mb=ea(Gb*ea(g[Na>>2]));Nb=ea(ea(ea(S(ea(Hb)))+ea(S(ea(fa))))+ea(S(ea(Fb))));Fb=ea(ea(ea(S(ea(Ib)))+ea(S(ea(Kb))))+ea(S(ea(Mb))));Mb=ea(ea(ea(S(ea(Jb)))+ea(S(ea(Lb))))+ea(S(ea(Gb*ea(g[Oa>>2])))));Gb=ea(g[Pa>>2]);Lb=ea(Gb-Nb);Jb=ea(g[Qa>>2]);Kb=ea(Jb-Fb);Ib=ea(g[Ra>>2]);fa=ea(Ib-Mb);Hb=ea(Nb+Gb);Gb=ea(Fb+Jb);Jb=ea(Mb+Ib);g[H>>2]=Lb;g[Sa>>2]=Kb;g[Ta>>2]=fa;g[Ua>>2]=Hb;g[Va>>2]=Gb;g[Wa>>2]=Jb;c[o>>2]=539272;c[Xa>>2]=C;KRa(r,d,H,l,o)|0;Ob=c[f>>2]|0;if(!Ob){Pb=Y;Qb=ja;Rb=ub;Sb=wb;Tb=xb;Ub=yb;Vb=vb;Wb=Db;break}Jb=ea(g[x>>2]);Gb=ea(g[M>>2]);Hb=ea(Jb*ea(-2.0));Jb=ea(Gb*ea(-2.0));Gb=ea(ea(g[y>>2])*ea(-2.0));fa=ea(g[O>>2]);Kb=ea(ea(fa*fa)+ea(-.5));Lb=ea(g[F>>2]);Ib=ea(Hb*Lb);Mb=ea(g[s>>2]);Fb=ea(Ib+ea(Jb*Mb));Ib=ea(g[v>>2]);Nb=ea(Fb+ea(Gb*Ib));Fb=ea(-Lb);Xb=ea(-Mb);Yb=ea(-Ib);Zb=ea(Fb-Lb);_b=ea(Xb-Mb);$b=ea(Yb-Ib);ac=ea(fa*Zb);bc=ea(fa*_b);cc=ea(fa*$b);dc=ea(_b*Fb);ec=ea($b*Fb);fc=ea(_b*Xb);_b=ea($b*Xb);Xb=ea($b*Yb);Yb=ea(ea(ea(1.0)-fc)-Xb);$b=ea(dc+cc);gc=ea(ec-bc);hc=ea(dc-cc);cc=ea(ea(1.0)-ea(Zb*Fb));Fb=ea(cc-Xb);Xb=ea(ac+_b);Zb=ea(bc+ec);ec=ea(_b-ac);ac=ea(cc-fc);fc=ea(ea(sa*Zb)+ea(ea(ka*Yb)+ea(la*hc)));cc=ea(ea(sa*ec)+ea(ea(ka*$b)+ea(la*Fb)));_b=ea(ea(sa*ac)+ea(ea(ka*gc)+ea(la*Xb)));bc=ea(ea(ba*Zb)+ea(ea(ta*Yb)+ea(ga*hc)));dc=ea(ea(ba*ec)+ea(ea(ta*$b)+ea(ga*Fb)));ic=ea(ea(ba*ac)+ea(ea(ta*gc)+ea(ga*Xb)));jc=ea(ea(ia*Zb)+ea(ea(aa*Yb)+ea(ha*hc)));kc=ea(ea(ia*ec)+ea(ea(aa*$b)+ea(ha*Fb)));lc=ea(ea(ia*ac)+ea(ea(aa*gc)+ea(ha*Xb)));mc=ea(ea(ea(Mb*Nb)+ea(ea(Jb*Kb)-ea(fa*ea(ea(Hb*Ib)-ea(Gb*Lb)))))+ea(ea(ma*ec)+ea(ea(ra*$b)+ea(j*Fb))));Fb=ea(ea(ea(ea(Gb*Kb)-ea(fa*ea(ea(Jb*Lb)-ea(Hb*Mb))))+ea(Ib*Nb))+ea(ea(ma*ac)+ea(ea(ra*gc)+ea(j*Xb))));g[Ya>>2]=ea(ea(ea(Lb*Nb)+ea(ea(Hb*Kb)-ea(fa*ea(ea(Gb*Mb)-ea(Jb*Ib)))))+ea(ea(ma*Zb)+ea(ea(ra*Yb)+ea(j*hc))));g[Za>>2]=mc;g[_a>>2]=Fb;g[$a>>2]=ea(0.0);g[I>>2]=fc;g[ab>>2]=cc;g[bb>>2]=_b;g[cb>>2]=ea(0.0);g[db>>2]=bc;g[eb>>2]=dc;g[fb>>2]=ic;g[gb>>2]=ea(0.0);g[hb>>2]=jc;g[ib>>2]=kc;g[jb>>2]=lc;g[kb>>2]=ea(0.0);nc=c[lb>>2]|0;c[E+0>>2]=c[J+0>>2];c[E+4>>2]=c[J+4>>2];c[E+8>>2]=c[J+8>>2];oc=(Ob+31|0)>>>5;if(!oc){Pb=Y;Qb=ja;Rb=ub;Sb=wb;Tb=xb;Ub=yb;Vb=vb;Wb=Db;break}lc=ea(3402823469999999843913219.0e14);pc=vb;kc=zb;jc=Ab;ic=Bb;dc=Cb;bc=h;_b=$;qc=0;rc=0;sc=~Ob;while(1){tc=sc>>>0>4294967263?~sc:32;uc=qc<<5;vc=Ob-uc|0;wc=vc>>>0<32?vc:32;vc=(wc|0)==0;if(!vc){xc=0;do{LRa(r,d,K+(xc*40|0)|0,0,0,c[nc+(xc+uc<<2)>>2]|0,0,0)|0;a[K+(xc*40|0)+36>>0]=56;xc=xc+1|0}while((xc|0)!=(tc|0));c[o+0>>2]=c[E+0>>2];c[o+4>>2]=c[E+4>>2];c[o+8>>2]=c[E+8>>2];if(vc){yc=lc;zc=pc;Ac=kc;Bc=jc;Cc=ic;Dc=dc;Ec=bc;Fc=_b;Gc=0}else{cc=lc;fc=_b;Fb=bc;mc=dc;hc=ic;Yb=jc;Zb=kc;tc=pc;xc=0;Hc=0;while(1){c[u>>2]=0;Ic=Hc+uc|0;fSa(D,A,K+(Hc*40|0)|0,Ic,a[K+(Hc*40|0)+36>>0]|0,B,k,w,I,t,u)|0;Jc=c[u>>2]|0;if(Jc){Ib=ea(g[m>>2]);if(Jc>>>0>1){Jb=Ib;Kc=0;Lc=1;while(1){Mb=ea(g[t+(Lc<<6)+44>>2]);if(Jb>Mb){c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];Mc=Mb;Nc=Lc}else{Mc=Jb;Nc=Kc}Lc=Lc+1|0;if((Lc|0)==(Jc|0)){Oc=Mc;Pc=Nc;break}else{Jb=Mc;Kc=Nc}}}else{Oc=Ib;Pc=0}if(cc>Oc){c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];Jb=ea(g[t+(Pc<<6)+32>>2]);Mb=ea(g[t+(Pc<<6)+36>>2]);Gb=ea(g[t+(Pc<<6)+40>>2]);fa=ea(g[t+(Pc<<6)+16>>2]);Kb=ea(g[t+(Pc<<6)+20>>2]);Qc=Oc;Rc=ea(g[t+(Pc<<6)+24>>2]);Sc=Kb;Tc=fa;Uc=Gb;Vc=Mb;Wc=Jb;Xc=Ic;Yc=1}else{Qc=cc;Rc=fc;Sc=Fb;Tc=mc;Uc=hc;Vc=Yb;Wc=Zb;Xc=tc;Yc=1}}else{Qc=cc;Rc=fc;Sc=Fb;Tc=mc;Uc=hc;Vc=Yb;Wc=Zb;Xc=tc;Yc=xc}Hc=Hc+1|0;if((Hc|0)==(wc|0)){yc=Qc;zc=Xc;Ac=Wc;Bc=Vc;Cc=Uc;Dc=Tc;Ec=Sc;Fc=Rc;Gc=Yc;break}else{cc=Qc;fc=Rc;Fb=Sc;mc=Tc;hc=Uc;Yb=Vc;Zb=Wc;tc=Xc;xc=Yc}}}}else{c[o+0>>2]=c[E+0>>2];c[o+4>>2]=c[E+4>>2];c[o+8>>2]=c[E+8>>2];yc=lc;zc=pc;Ac=kc;Bc=jc;Cc=ic;Dc=dc;Ec=bc;Fc=_b;Gc=0};c[E+0>>2]=c[o+0>>2];c[E+4>>2]=c[o+4>>2];c[E+8>>2]=c[o+8>>2];rc=Gc|rc;qc=qc+1|0;if(qc>>>0>=oc>>>0)break;else{lc=yc;pc=zc;kc=Ac;jc=Bc;ic=Cc;dc=Dc;bc=Ec;_b=Fc;sc=sc+32|0}}if(!rc){Pb=Y;Qb=ja;Rb=ub;Sb=wb;Tb=xb;Ub=yb;Vb=zc;Wb=Db;break}Zc=c[nc+(zc<<2)>>2]|0;_b=ea(g[w>>2]);bc=ea(g[X>>2]);dc=ea(g[W>>2]);ic=ea(g[V>>2]);jc=ea(ea(ic*ic)+ea(-.5));kc=ea(ea(ea(Ac*_b)+ea(Bc*bc))+ea(Cc*dc));_c=ea(ea(ea(_b*kc)+ea(ea(ic*ea(ea(Cc*bc)-ea(Bc*dc)))+ea(Ac*jc)))*ea(2.0));$c=ea(ea(ea(bc*kc)+ea(ea(ic*ea(ea(Ac*dc)-ea(Cc*_b)))+ea(Bc*jc)))*ea(2.0));ad=ea(ea(ea(dc*kc)+ea(ea(ic*ea(ea(Bc*_b)-ea(Ac*bc)))+ea(Cc*jc)))*ea(2.0));kc=ea(g[U>>2]);lc=ea(g[R>>2]);Zb=ea(ea(ea(Dc*_b)+ea(Ec*bc))+ea(Fc*dc));bd=ea(kc+ea(ea(ea(_b*Zb)+ea(ea(ic*ea(ea(Fc*bc)-ea(Ec*dc)))+ea(Dc*jc)))*ea(2.0)));cd=ea(lc+ea(ea(ea(bc*Zb)+ea(ea(ic*ea(ea(Dc*dc)-ea(Fc*_b)))+ea(Ec*jc)))*ea(2.0)));dd=ea(ea(g[Q>>2])+ea(ea(ea(dc*Zb)+ea(ea(ic*ea(ea(Ec*_b)-ea(Dc*bc)))+ea(Fc*jc)))*ea(2.0)));if(!(yc<=ea(0.0))){ed=27;break}jc=ea(yc*_c);bc=ea(yc*$c);_b=ea(yc*ad);ic=ea(Y-jc);Zb=ea(ja-bc);dc=ea(ub-_b);qa=ea(qa-jc);oa=ea(oa-bc);Z=ea(Z-_b);sc=Eb+1|0;if(sc>>>0>=2){Pb=ic;Qb=Zb;Rb=dc;Sb=bd;Tb=cd;Ub=dd;Vb=Zc;Wb=1;break}else{Y=ic;ja=Zb;ub=dc;vb=Zc;wb=bd;xb=cd;yb=dd;zb=Ac;Ab=Bc;Bb=Cc;Cb=Dc;h=Ec;$=Fc;Db=1;Eb=sc}}if((ed|0)==27)if(!Eb){g[mb>>2]=ea(0.0);g[nb>>2]=bd;g[ob>>2]=cd;g[pb>>2]=dd;g[qb>>2]=_c;g[rb>>2]=$c;g[sb>>2]=ad;c[tb>>2]=Zc;fd=1;dLa(C);i=n;return fd|0}else{Pb=Y;Qb=ja;Rb=ub;Sb=bd;Tb=cd;Ub=dd;Vb=Zc;Wb=1}dd=ea(T(ea(ea(Rb*Rb)+ea(ea(Qb*Qb)+ea(Pb*Pb)))));cd=ea(ea(1.0)/dd);if(!Wb){fd=0;dLa(C);i=n;return fd|0}bd=ea(Rb*cd);Rb=ea(Qb*cd);Qb=ea(Pb*cd);g[mb>>2]=ea(-dd);g[nb>>2]=Sb;g[ob>>2]=Tb;g[pb>>2]=Ub;g[qb>>2]=Qb;g[rb>>2]=Rb;g[sb>>2]=bd;c[tb>>2]=Vb;fd=1;dLa(C);i=n;return fd|0}function pNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=0,h=Im,i=0,j=Im,k=0,l=Im,m=Im,n=Im;d=ea(g[b>>2]);e=ea(d-ea(g[a>>2]));d=ea(g[b+4>>2]);f=a+4|0;h=ea(d-ea(g[f>>2]));d=ea(g[b+8>>2]);i=a+8|0;j=ea(d-ea(g[i>>2]));d=ea(ea(ea(e*e)+ea(h*h))+ea(j*j));k=a+12|0;l=ea(g[k>>2]);m=ea(l+ea(g[b+12>>2]));l=ea(T(ea(d)));d=ea(ea(1.0)/l);n=ea(e*d);e=ea(h*d);h=ea(j*d);g[c+28>>2]=n;g[c+32>>2]=e;g[c+36>>2]=h;g[c+40>>2]=ea(l-m);m=ea(g[k>>2]);l=ea(m*n);n=ea(m*e);e=ea(m*h);h=ea(l+ea(g[a>>2]));l=ea(n+ea(g[f>>2]));n=ea(e+ea(g[i>>2]));g[c+16>>2]=h;g[c+20>>2]=l;g[c+24>>2]=n;return 1}function qNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+16|0;e=d;f=a+12|0;h=ea(g[f>>2]);j=ea(h+ea(g[b+24>>2]));ea(IOa(b,b+12|0,a,e));h=ea(g[e>>2]);k=ea(g[b+12>>2]);l=ea(g[b>>2]);m=ea(k-l);k=ea(g[b+16>>2]);n=ea(g[b+4>>2]);o=ea(k-n);k=ea(g[b+20>>2]);p=ea(g[b+8>>2]);q=ea(l+ea(h*m));m=ea(n+ea(h*o));o=ea(p+ea(h*ea(k-p)));p=ea(q-ea(g[a>>2]));b=a+4|0;q=ea(m-ea(g[b>>2]));e=a+8|0;m=ea(o-ea(g[e>>2]));o=ea(T(ea(ea(ea(p*p)+ea(q*q))+ea(m*m))));k=ea(ea(1.0)/o);h=ea(p*k);p=ea(q*k);q=ea(m*k);g[c+28>>2]=h;g[c+32>>2]=p;g[c+36>>2]=q;g[c+40>>2]=ea(o-j);j=ea(g[f>>2]);o=ea(j*h);h=ea(j*p);p=ea(j*q);q=ea(o+ea(g[a>>2]));o=ea(h+ea(g[b>>2]));h=ea(p+ea(g[e>>2]));g[c+16>>2]=q;g[c+20>>2]=o;g[c+24>>2]=h;i=d;return 1}function rNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=Im,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;d=i;i=i+16|0;e=d+4|0;f=d;ea(NOa(a,b,e,f));h=ea(g[a+24>>2]);j=b+24|0;k=ea(h+ea(g[j>>2]));h=ea(g[e>>2]);l=ea(g[a+12>>2]);m=ea(g[a>>2]);n=ea(l-m);l=ea(g[a+16>>2]);o=ea(g[a+4>>2]);p=ea(l-o);l=ea(g[a+20>>2]);q=ea(g[a+8>>2]);r=ea(m+ea(h*n));n=ea(o+ea(h*p));p=ea(q+ea(h*ea(l-q)));q=ea(g[f>>2]);l=ea(g[b+12>>2]);h=ea(g[b>>2]);o=ea(l-h);l=ea(g[b+16>>2]);m=ea(g[b+4>>2]);s=ea(l-m);l=ea(g[b+20>>2]);t=ea(g[b+8>>2]);u=ea(h+ea(q*o));o=ea(m+ea(q*s));s=ea(t+ea(q*ea(l-t)));t=ea(r-u);r=ea(n-o);n=ea(p-s);p=ea(T(ea(ea(ea(t*t)+ea(r*r))+ea(n*n))));l=ea(ea(1.0)/p);q=ea(t*l);t=ea(l*r);r=ea(l*n);g[c+28>>2]=q;g[c+32>>2]=t;g[c+36>>2]=r;g[c+40>>2]=ea(p-k);k=ea(g[j>>2]);p=ea(o+ea(k*t));t=ea(s+ea(k*r));g[c+16>>2]=ea(u+ea(k*q));g[c+20>>2]=p;g[c+24>>2]=t;i=d;return 1}function sNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=0,j=Im,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;d=ea(g[b>>2]);e=ea(g[a>>2]);f=ea(d*e);h=ea(g[b+4>>2]);i=a+4|0;j=ea(g[i>>2]);k=ea(f+ea(h*j));f=ea(g[b+8>>2]);l=a+8|0;m=ea(g[l>>2]);n=ea(k+ea(f*m));k=ea(g[a+12>>2]);o=ea(k+n);n=ea(g[b+12>>2]);p=ea(e*n);q=ea(g[b+16>>2]);r=ea(p+ea(j*q));j=ea(g[b+20>>2]);p=ea(k+ea(r+ea(m*j)));if(o<p){s=d;t=h;u=f;v=o}else{s=n;t=q;u=j;v=p}g[c+28>>2]=e;p=ea(g[i>>2]);g[c+32>>2]=p;j=ea(g[l>>2]);g[c+36>>2]=j;g[c+40>>2]=ea(v-ea(g[b+24>>2]));q=ea(t-ea(v*p));p=ea(u-ea(v*j));g[c+16>>2]=ea(s-ea(v*e));g[c+20>>2]=q;g[c+24>>2]=p;return 1}function tNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+96|0;e=d;TKa(e,b+36|0,b+48|0,b,b+12|0,b+24|0);f=ea(g[e>>2]);h=ea(g[a>>2]);j=ea(f*h);f=ea(g[e+4>>2]);b=a+4|0;k=ea(g[b>>2]);l=ea(j+ea(f*k));f=ea(g[e+8>>2]);m=a+8|0;j=ea(g[m>>2]);n=ea(l+ea(f*j));f=ea(g[a+12>>2]);l=ea(f+n);n=ea(ea(g[e+12>>2])*h);o=ea(n+ea(ea(g[e+16>>2])*k));n=ea(f+ea(o+ea(ea(g[e+20>>2])*j)));p=l>n;o=p?n:l;l=ea(ea(g[e+24>>2])*h);n=ea(l+ea(ea(g[e+28>>2])*k));l=ea(f+ea(n+ea(ea(g[e+32>>2])*j)));q=o>l;n=q?l:o;o=ea(ea(g[e+36>>2])*h);l=ea(o+ea(ea(g[e+40>>2])*k));o=ea(f+ea(l+ea(ea(g[e+44>>2])*j)));r=n>o;l=r?o:n;n=ea(ea(g[e+48>>2])*h);o=ea(n+ea(ea(g[e+52>>2])*k));n=ea(f+ea(o+ea(ea(g[e+56>>2])*j)));s=l>n;o=s?n:l;l=ea(ea(g[e+60>>2])*h);n=ea(l+ea(ea(g[e+64>>2])*k));l=ea(f+ea(n+ea(ea(g[e+68>>2])*j)));t=o>l;n=t?l:o;o=ea(ea(g[e+72>>2])*h);l=ea(o+ea(ea(g[e+76>>2])*k));o=ea(f+ea(l+ea(ea(g[e+80>>2])*j)));u=n>o;l=u?o:n;n=ea(ea(g[e+84>>2])*h);h=ea(n+ea(ea(g[e+88>>2])*k));k=ea(f+ea(h+ea(ea(g[e+92>>2])*j)));v=l>k;w=v?7:u?6:t?5:s?4:r?3:q?2:p&1;j=v?k:l;g[c+28>>2]=ea(g[a>>2]);g[c+32>>2]=ea(g[b>>2]);g[c+36>>2]=ea(g[m>>2]);g[c+40>>2]=j;l=ea(j*ea(g[a>>2]));k=ea(j*ea(g[b>>2]));h=ea(j*ea(g[m>>2]));j=ea(ea(g[e+(w*12|0)>>2])-l);l=ea(ea(g[e+(w*12|0)+4>>2])-k);k=ea(ea(g[e+(w*12|0)+8>>2])-h);g[c+16>>2]=j;g[c+20>>2]=l;g[c+24>>2]=k;i=d;return 1}function uNa(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,T=0,U=Im,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im;j=i;i=i+80|0;k=j;l=c[e+32>>2]|0;J0a(k,e+4|0,e+16|0);e=a[l+54>>0]|0;m=c[l+56>>2]|0;n=d[l+55>>0]|0;l=m+(n*20|0)|0;o=ea(g[l>>2]);p=ea(o*ea(g[k>>2]));q=k+4|0;r=ea(o*ea(g[q>>2]));s=ea(g[k+8>>2]);t=ea(o*s);o=ea(g[m+(n*20|0)+4>>2]);u=ea(g[k+12>>2]);v=ea(o*u);w=ea(g[k+16>>2]);x=ea(o*w);y=ea(g[k+20>>2]);z=ea(p+v);v=ea(r+x);x=ea(t+ea(o*y));o=ea(g[m+(n*20|0)+8>>2]);t=ea(g[k+24>>2]);r=ea(o*t);p=ea(g[k+28>>2]);A=ea(o*p);B=ea(g[k+32>>2]);C=ea(ea(z+r)*ea(2.0));r=ea(ea(v+A)*ea(2.0));A=ea(ea(x+ea(o*B))*ea(2.0));o=ea(g[f+12>>2]);x=ea(ea(o*o)+ea(-.5));v=ea(g[f>>2]);z=ea(C*v);D=ea(g[f+4>>2]);E=ea(z+ea(r*D));z=ea(g[f+8>>2]);F=ea(E+ea(A*z));E=ea(ea(v*F)+ea(ea(C*x)+ea(o*ea(ea(A*D)-ea(r*z)))));G=ea(ea(D*F)+ea(ea(r*x)+ea(o*ea(ea(C*z)-ea(v*A)))));H=ea(ea(ea(A*x)+ea(o*ea(ea(r*v)-ea(C*D))))+ea(z*F));F=ea(g[f+16>>2]);C=ea(F+E);E=ea(g[f+20>>2]);r=ea(E+G);G=ea(g[f+24>>2]);A=ea(G+H);H=ea(g[b>>2]);I=ea(H*C);f=b+4|0;J=ea(g[f>>2]);K=ea(I+ea(J*r));n=b+8|0;I=ea(g[n>>2]);L=ea(ea(A*I)+K);K=ea(g[b+12>>2]);M=ea(K+L);if((e&255)<=1){N=A;O=r;P=C;Q=M;R=h+28|0;g[R>>2]=H;S=ea(g[f>>2]);T=h+32|0;g[T>>2]=S;U=ea(g[n>>2]);V=h+36|0;g[V>>2]=U;W=h+40|0;g[W>>2]=Q;X=ea(g[b>>2]);Y=ea(Q*X);Z=ea(g[f>>2]);_=ea(Q*Z);$=ea(g[n>>2]);aa=ea(Q*$);ba=ea(P-Y);ca=ea(O-_);da=ea(N-aa);fa=h+16|0;g[fa>>2]=ba;ga=h+20|0;g[ga>>2]=ca;ha=h+24|0;g[ha>>2]=da;i=j;return 1}L=ea(g[k>>2]);ia=ea(g[q>>2]);q=e&255;ja=C;C=r;r=A;A=M;e=1;while(1){M=ea(g[l+(e*12|0)>>2]);ka=ea(M*L);la=ea(M*ia);ma=ea(M*s);M=ea(g[l+(e*12|0)+4>>2]);na=ea(ka+ea(M*u));ka=ea(la+ea(M*w));la=ea(ma+ea(M*y));M=ea(g[l+(e*12|0)+8>>2]);ma=ea(ea(na+ea(M*t))*ea(2.0));na=ea(ea(ka+ea(M*p))*ea(2.0));ka=ea(ea(la+ea(M*B))*ea(2.0));M=ea(ea(ea(ma*v)+ea(na*D))+ea(ka*z));la=ea(F+ea(ea(v*M)+ea(ea(ma*x)+ea(o*ea(ea(ka*D)-ea(na*z))))));oa=ea(E+ea(ea(D*M)+ea(ea(na*x)+ea(o*ea(ea(ma*z)-ea(v*ka))))));pa=ea(G+ea(ea(ea(ka*x)+ea(o*ea(ea(na*v)-ea(ma*D))))+ea(z*M)));M=ea(K+ea(ea(pa*I)+ea(ea(H*la)+ea(J*oa))));if(A>M){qa=pa;ra=oa;sa=la;ta=M}else{qa=r;ra=C;sa=ja;ta=A}e=e+1|0;if((e|0)==(q|0)){N=qa;O=ra;P=sa;Q=ta;break}else{ja=sa;C=ra;r=qa;A=ta}}R=h+28|0;g[R>>2]=H;S=ea(g[f>>2]);T=h+32|0;g[T>>2]=S;U=ea(g[n>>2]);V=h+36|0;g[V>>2]=U;W=h+40|0;g[W>>2]=Q;X=ea(g[b>>2]);Y=ea(Q*X);Z=ea(g[f>>2]);_=ea(Q*Z);$=ea(g[n>>2]);aa=ea(Q*$);ba=ea(P-Y);ca=ea(O-_);da=ea(N-aa);fa=h+16|0;g[fa>>2]=ba;ga=h+20|0;g[ga>>2]=ca;ha=h+24|0;g[ha>>2]=da;i=j;return 1}function vNa(a,c,d,e,f,h,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0;l=i;i=i+64|0;m=l+32|0;n=l+16|0;o=l+48|0;p=l;q=ea(ea(g[a+4>>2])+k);g[m>>2]=ea(g[c+16>>2]);g[m+4>>2]=ea(g[c+20>>2]);g[m+8>>2]=ea(g[c+24>>2]);g[m+12>>2]=q;q=ea(-ea(g[e>>2]));k=ea(-ea(g[e+4>>2]));r=ea(-ea(g[e+8>>2]));g[n>>2]=q;g[n+4>>2]=k;g[n+8>>2]=r;e=h+40|0;b[o>>1]=b[j>>1]|0;if(!(YOa(m,d,n,f,e,h+16|0,h+28|0,o)|0)){s=0;i=l;return s|0}if(!(b[j>>1]&512)){j=h+12|0;if(ea(g[e>>2])!=ea(0.0)){b[j>>1]=7;s=1;i=l;return s|0}else{b[j>>1]=6;s=1;i=l;return s|0}}b[h+12>>1]=7;if(!(ea(g[e>>2])==ea(0.0))){s=1;i=l;return s|0}f=ea(g[d>>2]);if((f==ea(g[d+12>>2])?(r=ea(g[d+4>>2]),r==ea(g[d+16>>2])):0)?(k=ea(g[d+8>>2]),k==ea(g[d+20>>2])):0){q=ea(g[d+24>>2]);g[p>>2]=f;g[p+4>>2]=r;g[p+8>>2]=k;g[p+12>>2]=q;s=pNa(m,p,h)|0;i=l;return s|0}s=qNa(m,d,h)|0;i=l;return s|0}function wNa(a,d,f,h,j,k,l,m){a=a|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0.0;a=i;i=i+48|0;n=a+24|0;o=a;tLa(n,d);p=ea(ea(g[f+24>>2])+m);c[k+8>>2]=-1;m=ea(g[f>>2]);g[o>>2]=m;q=ea(g[f+4>>2]);g[o+4>>2]=q;r=ea(g[f+8>>2]);g[o+8>>2]=r;s=ea(g[f+12>>2]);g[o+12>>2]=s;t=ea(g[f+16>>2]);g[o+16>>2]=t;u=ea(g[f+20>>2]);g[o+20>>2]=u;v=ea(g[n>>2]);w=ea(g[n+4>>2]);x=ea(g[n+8>>2]);y=ea(ea(ea(m*v)+ea(q*w))+ea(r*x));d=y<ea(3402823469999999843913219.0e14);r=d?y:ea(3402823469999999843913219.0e14);y=ea(ea(ea(s*v)+ea(t*w))+ea(u*x));d=y<r;u=d?y:r;z=d&1;d=e[l>>1]|0;if(!(d&512)){if((d&16|0)==0?u<=ea(p-ea(g[n+12>>2])):0){b[k+12>>1]=6;g[k+40>>2]=ea(0.0);r=ea(-ea(g[h>>2]));y=ea(-ea(g[h+4>>2]));t=ea(-ea(g[h+8>>2]));g[k+28>>2]=r;g[k+32>>2]=y;g[k+36>>2]=t;A=1;i=a;return A|0}}else if(u<=ea(p-ea(g[n+12>>2]))){b[k+12>>1]=7;A=sNa(n,f,k)|0;i=a;return A|0}u=ea(p*v);t=ea(p*w);y=ea(p*x);p=ea(ea(g[o+(z*12|0)>>2])-u);u=ea(ea(g[o+(z*12|0)+4>>2])-t);t=ea(ea(g[o+(z*12|0)+8>>2])-y);y=ea(ea(g[h>>2])*v);z=h+4|0;r=ea(y+ea(ea(g[z>>2])*w));o=h+8|0;y=ea(r+ea(ea(g[o>>2])*x));B=+y;if(B>-1.0e-07&B<1.0e-07){A=0;i=a;return A|0}r=ea(ea(ea(p*v)+ea(u*w))+ea(t*x));s=ea(ea(-ea(r+ea(g[n+12>>2])))/y);g[k+40>>2]=s;y=ea(g[h>>2]);r=ea(g[z>>2]);q=ea(u+ea(s*r));r=ea(t+ea(s*ea(g[o>>2])));g[k+16>>2]=ea(p+ea(s*y));g[k+20>>2]=q;g[k+24>>2]=r;if(!(s>ea(0.0))|!(s<=j)){A=0;i=a;return A|0}g[k+28>>2]=v;g[k+32>>2]=w;g[k+36>>2]=x;b[k+12>>1]=7;A=1;i=a;return A|0}
function xNa(a,c,d,e,f,h,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0;l=i;i=i+48|0;m=l+12|0;n=l+40|0;o=l;p=ea(g[c>>2]);q=ea(p*ea(2.0));r=ea(g[c+12>>2]);s=ea(r*ea(2.0));t=ea(ea(p*q)+ea(ea(r*s)+ea(-1.0)));r=ea(g[c+8>>2]);p=ea(r*s);u=ea(g[c+4>>2]);v=ea(p+ea(q*u));p=ea(ea(q*r)-ea(s*u));u=ea(g[a+8>>2]);s=ea(u*t);t=ea(u*v);v=ea(u*p);p=ea(g[c+16>>2]);u=ea(p+s);r=ea(g[c+20>>2]);q=ea(r+t);w=ea(g[c+24>>2]);x=ea(v+w);g[m>>2]=u;g[m+4>>2]=q;g[m+8>>2]=x;x=ea(r-t);t=ea(w-v);g[m+12>>2]=ea(p-s);g[m+16>>2]=x;g[m+20>>2]=t;g[m+24>>2]=ea(ea(g[a+4>>2])+k);a=b[j>>1]|0;k=ea(-ea(g[e>>2]));t=ea(-ea(g[e+4>>2]));x=ea(-ea(g[e+8>>2]));g[o>>2]=k;g[o+4>>2]=t;g[o+8>>2]=x;e=h+40|0;if(!(WOa(d,m,o,f,e,h+16|0,h+28|0,a&65535,n)|0)){y=0;i=l;return y|0}o=b[n>>1]|0;n=h+12|0;b[n>>1]=o;if((a&512)==0?1:ea(g[e>>2])!=ea(0.0)){y=1;i=l;return y|0}b[n>>1]=o&65535|1;y=rNa(d,m,h)|0;i=l;return y|0}function yNa(a,e,f,h,j,k,l,m){a=a|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=0,ma=Im,na=Im,oa=Im;n=i;i=i+544|0;o=n+288|0;p=n+192|0;q=n+496|0;r=n+500|0;s=n+504|0;t=n+272|0;u=n+176|0;v=n+532|0;w=n+208|0;x=n+160|0;y=n;z=n+224|0;A=n+256|0;B=n+144|0;C=n+240|0;D=(c[a+32>>2]|0)+16|0;c[q>>2]=d[D+39>>0];g[r>>2]=ea(0.0);uLa(s,f,r);c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[u>>2]=ea(0.0);E=ea(g[h>>2]);F=h+4|0;G=ea(g[F>>2]);H=h+8|0;I=ea(g[H>>2]);J=ea(g[s>>2]);K=ea(g[s+4>>2]);L=ea(g[s+8>>2]);M=ea(g[s+12>>2]);N=s+16|0;O=ea(g[N>>2]);P=ea(g[N+4>>2]);Q=ea(g[N+8>>2]);R=ea(g[e>>2]);S=ea(g[e+4>>2]);U=ea(g[e+8>>2]);V=ea(g[e+12>>2]);N=e+16|0;W=ea(g[N>>2]);X=ea(g[N+4>>2]);Y=ea(g[N+8>>2]);Z=ea(-R);_=ea(-S);$=ea(-U);aa=ea(O-W);O=ea(P-X);P=ea(Q-Y);Q=ea(ea(V*V)+ea(-.5));ba=ea(ea(ea(aa*Z)+ea(O*_))+ea(P*$));ca=ea(ea(ea(ba*Z)+ea(ea(Q*aa)+ea(V*ea(ea(P*_)-ea(O*$)))))*ea(2.0));da=ea(ea(ea(ba*_)+ea(ea(Q*O)+ea(V*ea(ea(aa*$)-ea(P*Z)))))*ea(2.0));fa=ea(ea(ea(ea(Q*P)+ea(V*ea(ea(O*Z)-ea(aa*_))))+ea(ba*$))*ea(2.0));ba=ea(ea(M*V)-ea(ea(ea(J*Z)+ea(K*_))+ea(L*$)));aa=ea(ea(ea(L*_)-ea(K*$))+ea(ea(M*Z)+ea(J*V)));O=ea(ea(ea(J*$)-ea(L*Z))+ea(ea(M*_)+ea(K*V)));P=ea(ea(ea(K*Z)-ea(J*_))+ea(ea(L*V)+ea(M*$)));$=ea(aa+aa);M=ea(O+O);L=ea(P+P);_=ea(O*M);J=ea(P*L);Z=ea(O*$);O=ea(P*$);K=ea(ba*$);ga=ea(P*M);P=ea(ba*M);M=ea(ba*L);L=ea(ea(1.0)-ea(aa*$));$=ea(ea(ea(1.0)-_)-J);aa=ea(Z+M);ba=ea(O-P);ha=ea(Z-M);M=ea(L-J);J=ea(ga+K);Z=ea(O+P);P=ea(ga-K);K=ea(L-_);_=ea(g[r>>2]);r=f+24|0;L=ea(g[r>>2]);ga=ea(g[a+4>>2]);O=ea(g[a+8>>2]);ia=ea(g[a+12>>2]);g[w>>2]=ga;g[w+4>>2]=O;g[w+8>>2]=ia;g[w+12>>2]=ea(0.0);ia=ea(g[a+16>>2]);O=ea(g[a+20>>2]);ga=ea(g[a+24>>2]);ja=ea(g[a+28>>2]);g[x>>2]=ia;g[x+4>>2]=O;g[x+8>>2]=ga;g[x+12>>2]=ja;ja=ea(_*ea(0.0));ga=ea(ea(ja*Z)+ea(ea(ja*ha)+ea(_*$)));$=ea(ea(ja*P)+ea(ea(_*aa)+ea(ja*M)));M=ea(ea(ea(_*ba)+ea(ja*J))+ea(ja*K));f=y+64|0;g[y>>2]=ca;g[y+4>>2]=da;g[y+8>>2]=fa;g[y+12>>2]=ea(0.0);c[y+80>>2]=4;N=y+20|0;s=y+36|0;g[y+48>>2]=ea(0.0);ka=y+52|0;c[ka+0>>2]=c[o+0>>2];c[ka+4>>2]=c[o+4>>2];c[ka+8>>2]=c[o+8>>2];g[y+128>>2]=L;ka=y+132|0;c[ka+0>>2]=c[v+0>>2];c[ka+4>>2]=c[v+4>>2];c[ka+8>>2]=c[v+8>>2];K=ea(da+$);ja=ea(fa+M);g[y+96>>2]=ea(ca+ga);g[y+100>>2]=K;g[y+104>>2]=ja;g[y+108>>2]=ea(0.0);ja=ea(da-$);$=ea(fa-M);g[y+112>>2]=ea(ca-ga);g[y+116>>2]=ja;g[y+120>>2]=$;g[y+124>>2]=ea(0.0);g[y+16>>2]=L;c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];g[y+32>>2]=L;c[s+0>>2]=c[v+0>>2];c[s+4>>2]=c[v+4>>2];c[s+8>>2]=c[v+8>>2];c[p+0>>2]=-1;c[p+4>>2]=-1;c[p+8>>2]=-1;c[p+12>>2]=-1;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];z1a(o,D,t,w,x);L=ea(-ea(E*j));$=ea(-ea(G*j));ja=ea(-ea(I*j));ga=ea(ea(ea(R*L)+ea(S*$))+ea(U*ja));ca=ea(ea(ea(S*ga)+ea(ea(Q*$)-ea(V*ea(ea(U*L)-ea(R*ja)))))*ea(2.0));M=ea(ea(ea(U*ga)+ea(ea(Q*ja)-ea(V*ea(ea(R*$)-ea(S*L)))))*ea(2.0));g[z>>2]=ea(ea(ea(R*ga)+ea(ea(Q*L)-ea(V*ea(ea(S*ja)-ea(U*$)))))*ea(2.0));g[z+4>>2]=ca;g[z+8>>2]=M;g[z+12>>2]=ea(0.0);x=(b[l>>1]&512)!=0;if(!(DPa(y,o,u,t,z,A,C,B,ea(ea(g[r>>2])+m),x)|0)){la=0;i=n;return la|0}r=k+12|0;b[r>>1]=6;m=ea(g[u>>2]);M=ea(g[A>>2]);do if(m>=M)if(x){b[r>>1]=7;ca=ea(g[C>>2]);$=ea(g[C+4>>2]);ja=ea(g[C+8>>2]);L=ea(ea(ea(R*ca)+ea(S*$))+ea(U*ja));ga=ea(ea(ea(R*L)+ea(ea(Q*ca)+ea(V*ea(ea(S*ja)-ea(U*$)))))*ea(2.0));fa=ea(ea(ea(S*L)+ea(ea(Q*$)+ea(V*ea(ea(U*ca)-ea(R*ja)))))*ea(2.0));da=ea(ea(ea(ea(Q*ja)+ea(V*ea(ea(R*$)-ea(S*ca))))+ea(U*L))*ea(2.0));L=ea(ea(1.0)/ea(T(ea(ea(da*da)+ea(ea(ga*ga)+ea(fa*fa))))));ca=ea(L*ga);ga=ea(L*fa);fa=ea(L*da);da=ea(g[B>>2]);L=ea(g[B+4>>2]);$=ea(g[B+8>>2]);ja=ea(ea(ea(R*da)+ea(S*L))+ea(U*$));K=ea(ea(W+ea(ea(ea(R*ja)+ea(ea(Q*da)+ea(V*ea(ea(S*$)-ea(U*L)))))*ea(2.0)))-ea(M*ca));J=ea(ea(X+ea(ea(ea(S*ja)+ea(ea(Q*L)+ea(V*ea(ea(U*da)-ea(R*$)))))*ea(2.0)))-ea(M*ga));ba=ea(ea(Y+ea(ea(ea(ea(Q*$)+ea(V*ea(ea(R*L)-ea(S*da))))+ea(U*ja))*ea(2.0)))-ea(M*fa));g[k+28>>2]=ca;g[k+32>>2]=ga;g[k+36>>2]=fa;g[k+16>>2]=K;g[k+20>>2]=J;g[k+24>>2]=ba;g[k+40>>2]=M;ma=K;na=J;oa=ba;break}else{g[k+40>>2]=ea(0.0);ba=ea(-ea(g[h>>2]));J=ea(-ea(g[F>>2]));K=ea(-ea(g[H>>2]));g[k+28>>2]=ba;g[k+32>>2]=J;g[k+36>>2]=K;K=ea(g[k+16>>2]);J=ea(g[k+20>>2]);ma=K;na=J;oa=ea(g[k+24>>2]);break}else{b[r>>1]=7;J=ea(g[B>>2]);K=ea(g[B+4>>2]);ba=ea(g[B+8>>2]);fa=ea(ea(ea(R*J)+ea(S*K))+ea(U*ba));ga=ea(W+ea(ea(ea(R*fa)+ea(ea(Q*J)+ea(V*ea(ea(S*ba)-ea(U*K)))))*ea(2.0)));ca=ea(X+ea(ea(ea(S*fa)+ea(ea(Q*K)+ea(V*ea(ea(U*J)-ea(R*ba)))))*ea(2.0)));ja=ea(Y+ea(ea(ea(ea(Q*ba)+ea(V*ea(ea(R*K)-ea(S*J))))+ea(U*fa))*ea(2.0)));fa=ea(M*j);J=ea(g[C>>2]);K=ea(g[C+4>>2]);ba=ea(g[C+8>>2]);da=ea(ea(ea(R*J)+ea(S*K))+ea(U*ba));L=ea(ea(ea(R*da)+ea(ea(Q*J)+ea(V*ea(ea(S*ba)-ea(U*K)))))*ea(2.0));$=ea(ea(ea(S*da)+ea(ea(Q*K)+ea(V*ea(ea(U*J)-ea(R*ba)))))*ea(2.0));_=ea(ea(ea(ea(Q*ba)+ea(V*ea(ea(R*K)-ea(S*J))))+ea(U*da))*ea(2.0));da=ea(ea(1.0)/ea(T(ea(ea(_*_)+ea(ea(L*L)+ea($*$))))));J=ea(da*$);$=ea(da*_);_=ea(ea(E*fa)+ga);ga=ea(ea(G*fa)+ca);ca=ea(ea(I*fa)+ja);g[k+28>>2]=ea(da*L);g[k+32>>2]=J;g[k+36>>2]=$;g[k+16>>2]=_;g[k+20>>2]=ga;g[k+24>>2]=ca;g[k+40>>2]=fa;ma=_;na=ga;oa=ca}while(0);I=ea(g[h>>2]);G=ea(g[F>>2]);c[k+8>>2]=w6a(a,D,q,e,ma,na,oa,I,G,ea(g[H>>2]))|0;la=1;i=n;return la|0}function zNa(a,d,f,h,j,k,l,m){a=a|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=Im,H=Im,I=Im,J=Im;a=i;i=i+112|0;n=a+96|0;o=a;c[k+8>>2]=-1;tLa(n,d);d=n+12|0;g[d>>2]=ea(ea(g[d>>2])-m);TKa(o,f+36|0,f+48|0,f,f+12|0,f+24|0);m=ea(g[n>>2]);p=n+4|0;q=ea(g[p>>2]);r=n+8|0;s=ea(g[r>>2]);t=ea(ea(g[o>>2])*m);u=ea(t+ea(ea(g[o+4>>2])*q));t=ea(u+ea(ea(g[o+8>>2])*s));v=t<ea(3402823469999999843913219.0e14);u=v?t:ea(3402823469999999843913219.0e14);t=ea(ea(g[o+12>>2])*m);w=ea(t+ea(ea(g[o+16>>2])*q));t=ea(w+ea(ea(g[o+20>>2])*s));v=t<u;w=v?t:u;u=ea(ea(g[o+24>>2])*m);t=ea(u+ea(ea(g[o+28>>2])*q));u=ea(t+ea(ea(g[o+32>>2])*s));x=u<w;t=x?u:w;w=ea(ea(g[o+36>>2])*m);u=ea(w+ea(ea(g[o+40>>2])*q));w=ea(u+ea(ea(g[o+44>>2])*s));y=w<t;u=y?w:t;t=ea(ea(g[o+48>>2])*m);w=ea(t+ea(ea(g[o+52>>2])*q));t=ea(w+ea(ea(g[o+56>>2])*s));z=t<u;w=z?t:u;u=ea(ea(g[o+60>>2])*m);t=ea(u+ea(ea(g[o+64>>2])*q));u=ea(t+ea(ea(g[o+68>>2])*s));A=u<w;t=A?u:w;w=ea(ea(g[o+72>>2])*m);u=ea(w+ea(ea(g[o+76>>2])*q));w=ea(u+ea(ea(g[o+80>>2])*s));B=w<t;u=B?w:t;t=ea(ea(g[o+84>>2])*m);m=ea(t+ea(ea(g[o+88>>2])*q));q=ea(m+ea(ea(g[o+92>>2])*s));C=q<u;s=C?q:u;D=C?7:B?6:A?5:z?4:y?3:x?2:v&1;v=e[l>>1]|0;if(!(v&512)){if((v&16|0)==0?s<=ea(-ea(g[d>>2])):0){b[k+12>>1]=6;g[k+40>>2]=ea(0.0);u=ea(-ea(g[h>>2]));q=ea(-ea(g[h+4>>2]));m=ea(-ea(g[h+8>>2]));g[k+28>>2]=u;g[k+32>>2]=q;g[k+36>>2]=m;E=1;i=a;return E|0}}else if(s<=ea(-ea(g[d>>2]))){b[k+12>>1]=7;E=tNa(n,f,k)|0;i=a;return E|0}s=ea(g[h>>2]);m=ea(g[n>>2]);q=ea(s*m);n=h+4|0;s=ea(g[n>>2]);u=ea(g[p>>2]);t=ea(q+ea(s*u));p=h+8|0;s=ea(g[p>>2]);q=ea(g[r>>2]);w=ea(t+ea(s*q));F=+w;if(F>-1.0e-07&F<1.0e-07){E=0;i=a;return E|0}s=ea(g[o+(D*12|0)>>2]);t=ea(m*s);G=ea(g[o+(D*12|0)+4>>2]);H=ea(t+ea(u*G));t=ea(g[o+(D*12|0)+8>>2]);I=ea(H+ea(q*t));H=ea(ea(-ea(ea(g[d>>2])+I))/w);g[k+40>>2]=H;w=ea(g[h>>2]);I=ea(g[n>>2]);J=ea(ea(H*I)+G);G=ea(ea(H*ea(g[p>>2]))+t);g[k+16>>2]=ea(ea(H*w)+s);g[k+20>>2]=J;g[k+24>>2]=G;if(!(H>ea(0.0))|!(H<=j)){E=0;i=a;return E|0}g[k+28>>2]=m;g[k+32>>2]=u;g[k+36>>2]=q;b[k+12>>1]=7;E=1;i=a;return E|0}function ANa(a,e,f,h,j,k,l,m){a=a|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im;n=i;i=i+576|0;o=n+48|0;p=n+560|0;q=n+572|0;r=n+16|0;s=n+464|0;t=n+480|0;u=n+544|0;v=n+432|0;w=n+272|0;x=n+32|0;y=n;z=n+448|0;A=n+256|0;UUa(o,f);B=ea(g[o>>2]);C=ea(g[o+4>>2]);D=ea(g[o+8>>2]);E=ea(g[o+12>>2]);F=ea(g[f+36>>2]);G=ea(g[f+40>>2]);H=ea(g[f+44>>2]);I=(c[a+32>>2]|0)+16|0;c[q>>2]=d[I+39>>0];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;g[s>>2]=ea(0.0);J=ea(g[e>>2]);K=ea(g[e+4>>2]);L=ea(g[e+8>>2]);M=ea(g[e+12>>2]);N=e+16|0;O=ea(g[N>>2]);P=ea(g[N+4>>2]);Q=ea(g[N+8>>2]);R=ea(-J);S=ea(-K);U=ea(-L);V=ea(F-O);F=ea(G-P);G=ea(H-Q);H=ea(ea(M*M)+ea(-.5));W=ea(ea(ea(V*R)+ea(F*S))+ea(G*U));X=ea(ea(ea(W*S)+ea(ea(H*F)+ea(M*ea(ea(V*U)-ea(G*R)))))*ea(2.0));Y=ea(ea(ea(ea(H*G)+ea(M*ea(ea(F*R)-ea(V*S))))+ea(W*U))*ea(2.0));Z=ea(ea(E*M)-ea(ea(ea(B*R)+ea(C*S))+ea(D*U)));_=ea(ea(ea(D*S)-ea(C*U))+ea(ea(E*R)+ea(B*M)));$=ea(ea(ea(B*U)-ea(D*R))+ea(ea(E*S)+ea(C*M)));aa=ea(ea(ea(C*R)-ea(B*S))+ea(ea(D*M)+ea(E*U)));g[t+48>>2]=ea(ea(ea(W*R)+ea(ea(H*V)+ea(M*ea(ea(G*S)-ea(F*U)))))*ea(2.0));g[t+52>>2]=X;g[t+56>>2]=Y;g[t+60>>2]=ea(0.0);Y=ea(_+_);X=ea($+$);U=ea(aa+aa);F=ea($*X);S=ea(aa*U);G=ea($*Y);$=ea(aa*Y);V=ea(Z*Y);R=ea(aa*X);aa=ea(Z*X);X=ea(Z*U);U=ea(ea(1.0)-ea(_*Y));Y=ea(G+X);_=ea($-aa);Z=ea(G-X);X=ea(U-S);G=ea(R+V);W=ea($+aa);aa=ea(R-V);V=ea(U-F);g[t>>2]=ea(ea(ea(1.0)-F)-S);g[t+4>>2]=Y;g[t+8>>2]=_;g[t+12>>2]=ea(0.0);g[t+16>>2]=Z;g[t+20>>2]=X;g[t+24>>2]=G;g[t+28>>2]=ea(0.0);g[t+32>>2]=W;g[t+36>>2]=aa;g[t+40>>2]=V;g[t+44>>2]=ea(0.0);V=ea(g[f+48>>2]);aa=ea(g[f+52>>2]);W=ea(g[f+56>>2]);G=ea(g[a+4>>2]);X=ea(g[a+8>>2]);Z=ea(g[a+12>>2]);g[u>>2]=G;g[u+4>>2]=X;g[u+8>>2]=Z;g[u+12>>2]=ea(0.0);Z=ea(g[a+16>>2]);X=ea(g[a+20>>2]);G=ea(g[a+24>>2]);_=ea(g[a+28>>2]);g[v>>2]=Z;g[v+4>>2]=X;g[v+8>>2]=G;g[v+12>>2]=_;f=w+64|0;c[w+0>>2]=c[r+0>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];c[w+12>>2]=c[r+12>>2];c[w+80>>2]=3;N=w+20|0;c[N+0>>2]=c[p+0>>2];c[N+4>>2]=c[p+4>>2];c[N+8>>2]=c[p+8>>2];ba=w+36|0;g[w+48>>2]=ea(0.0);ca=w+52|0;c[ca+0>>2]=c[p+0>>2];c[ca+4>>2]=c[p+4>>2];c[ca+8>>2]=c[p+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];g[w+144>>2]=V;g[w+148>>2]=aa;g[w+152>>2]=W;g[w+156>>2]=ea(0.0);_=!(V<=aa)?aa:V;G=!(_<=W)?W:_;_=!(V>=aa)?aa:V;V=ea(G*ea(.150000006));aa=ea((!(_>=W)?W:_)*ea(.0299999993));_=V>aa?V:aa;g[w+16>>2]=G>_?_:G;c[N+0>>2]=c[p+0>>2];c[N+4>>2]=c[p+4>>2];c[N+8>>2]=c[p+8>>2];g[w+32>>2]=ea(G*ea(.0500000007));c[ba+0>>2]=c[o+0>>2];c[ba+4>>2]=c[o+4>>2];c[ba+8>>2]=c[o+8>>2];z1a(o,I,r,u,v);G=ea(g[h>>2]);v=h+4|0;_=ea(g[v>>2]);u=h+8|0;aa=ea(g[u>>2]);V=ea(-ea(G*j));W=ea(-ea(_*j));X=ea(-ea(aa*j));Z=ea(ea(ea(J*V)+ea(K*W))+ea(L*X));Y=ea(ea(ea(K*Z)+ea(ea(H*W)-ea(M*ea(ea(L*V)-ea(J*X)))))*ea(2.0));S=ea(ea(ea(ea(H*X)-ea(M*ea(ea(J*W)-ea(K*V))))+ea(L*Z))*ea(2.0));g[x>>2]=ea(ea(ea(J*Z)+ea(ea(H*V)-ea(M*ea(ea(K*X)-ea(L*W)))))*ea(2.0));g[x+4>>2]=Y;g[x+8>>2]=S;g[x+12>>2]=ea(0.0);ba=(b[l>>1]&512)!=0;if(!(LPa(w,o,t,s,r,x,y,A,z,m,ba)|0)){da=0;i=n;return da|0}m=ea(g[z>>2]);S=ea(g[z+4>>2]);Y=ea(g[z+8>>2]);W=ea(ea(ea(J*m)+ea(K*S))+ea(L*Y));X=ea(O+ea(ea(ea(J*W)+ea(ea(H*m)+ea(M*ea(ea(K*Y)-ea(L*S)))))*ea(2.0)));O=ea(P+ea(ea(ea(K*W)+ea(ea(H*S)+ea(M*ea(ea(L*m)-ea(J*Y)))))*ea(2.0)));P=ea(Q+ea(ea(ea(ea(H*Y)+ea(M*ea(ea(J*S)-ea(K*m))))+ea(L*W))*ea(2.0)));z=k+12|0;b[z>>1]=6;W=ea(g[s>>2]);m=ea(g[y>>2]);do if(W>=m)if(ba){b[z>>1]=7;S=ea(g[A>>2]);Y=ea(g[A+4>>2]);Q=ea(g[A+8>>2]);V=ea(ea(ea(J*S)+ea(K*Y))+ea(L*Q));Z=ea(ea(ea(J*V)+ea(ea(H*S)+ea(M*ea(ea(K*Q)-ea(L*Y)))))*ea(2.0));F=ea(ea(ea(K*V)+ea(ea(H*Y)+ea(M*ea(ea(L*S)-ea(J*Q)))))*ea(2.0));U=ea(ea(ea(ea(H*Q)+ea(M*ea(ea(J*Y)-ea(K*S))))+ea(L*V))*ea(2.0));V=ea(ea(1.0)/ea(T(ea(ea(U*U)+ea(ea(Z*Z)+ea(F*F))))));S=ea(V*Z);Z=ea(V*F);F=ea(V*U);U=ea(X-ea(m*S));V=ea(O-ea(m*Z));Y=ea(P-ea(m*F));g[k+28>>2]=S;g[k+32>>2]=Z;g[k+36>>2]=F;g[k+16>>2]=U;g[k+20>>2]=V;g[k+24>>2]=Y;g[k+40>>2]=m;fa=U;ga=V;ha=Y;break}else{g[k+40>>2]=ea(0.0);Y=ea(-ea(g[h>>2]));V=ea(-ea(g[v>>2]));U=ea(-ea(g[u>>2]));g[k+28>>2]=Y;g[k+32>>2]=V;g[k+36>>2]=U;U=ea(g[k+16>>2]);V=ea(g[k+20>>2]);fa=U;ga=V;ha=ea(g[k+24>>2]);break}else{b[z>>1]=7;V=ea(g[A>>2]);U=ea(g[A+4>>2]);Y=ea(g[A+8>>2]);F=ea(ea(ea(J*V)+ea(K*U))+ea(L*Y));Z=ea(ea(ea(J*F)+ea(ea(H*V)+ea(M*ea(ea(K*Y)-ea(L*U)))))*ea(2.0));S=ea(ea(ea(K*F)+ea(ea(H*U)+ea(M*ea(ea(L*V)-ea(J*Y)))))*ea(2.0));Q=ea(ea(ea(ea(H*Y)+ea(M*ea(ea(J*U)-ea(K*V))))+ea(L*F))*ea(2.0));F=ea(ea(1.0)/ea(T(ea(ea(Q*Q)+ea(ea(Z*Z)+ea(S*S))))));V=ea(F*S);S=ea(F*Q);Q=ea(m*j);U=ea(X+ea(G*Q));Y=ea(O+ea(_*Q));R=ea(P+ea(aa*Q));g[k+28>>2]=ea(F*Z);g[k+32>>2]=V;g[k+36>>2]=S;g[k+16>>2]=U;g[k+20>>2]=Y;g[k+24>>2]=R;g[k+40>>2]=Q;fa=U;ga=Y;ha=R}while(0);aa=ea(g[h>>2]);P=ea(g[v>>2]);c[k+8>>2]=w6a(a,I,q,e,fa,ga,ha,aa,P,ea(g[u>>2]))|0;da=1;i=n;return da|0}function BNa(a,c,d,e,f,h,j,k,l,m,n,o,p){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;q=i;i=i+160|0;r=q+120|0;s=q+60|0;t=q;u=q+150|0;v=q+148|0;w=ea(g[e>>2]);x=ea(w*ea(2.0));y=ea(g[e+12>>2]);z=ea(y*ea(2.0));A=ea(ea(w*x)+ea(ea(y*z)+ea(-1.0)));y=ea(g[e+8>>2]);w=ea(y*z);B=ea(g[e+4>>2]);C=ea(w+ea(x*B));w=ea(ea(x*y)-ea(z*B));B=ea(g[d+8>>2]);z=ea(B*A);A=ea(B*C);C=ea(B*w);w=ea(g[e+16>>2]);B=ea(w+z);y=ea(g[e+20>>2]);x=ea(y+A);D=ea(g[e+24>>2]);E=ea(C+D);g[r>>2]=B;g[r+4>>2]=x;g[r+8>>2]=E;E=ea(y-A);A=ea(D-C);g[r+12>>2]=ea(w-z);g[r+16>>2]=E;g[r+20>>2]=A;g[r+24>>2]=ea(ea(g[d+4>>2])+o);$Ka(r,s);wLa(t,s+48|0,s+36|0,s,f,h);b[u>>1]=0;b[v>>1]=b[p>>1]|0;p=XOa(a,c,r,f,h,j,u,m,l,k,n,v,0,t)|0;i=q;return p|0}function CNa(a,d,e,f,h,j,k,l,m){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=0;n=i;i=i+528|0;o=n+496|0;p=n+432|0;q=n+480|0;r=n;s=n+448|0;t=n+464|0;u=n+508|0;v=n+416|0;w=n+208|0;x=n+32|0;y=n+192|0;z=n+16|0;A=n+176|0;B=(c[e+32>>2]|0)+16|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;g[r>>2]=ea(0.0);C=e+4|0;D=ea(g[C>>2]);E=ea(g[C+4>>2]);F=ea(g[C+8>>2]);g[s>>2]=D;g[s+4>>2]=E;g[s+8>>2]=F;g[s+12>>2]=ea(0.0);C=e+16|0;F=ea(g[C>>2]);E=ea(g[C+4>>2]);D=ea(g[C+8>>2]);G=ea(g[C+12>>2]);g[t>>2]=F;g[t+4>>2]=E;g[t+8>>2]=D;g[t+12>>2]=G;C=a+4|0;G=ea(g[C>>2]);a=d+16|0;D=ea(g[a>>2]);E=ea(g[a+4>>2]);F=ea(g[a+8>>2]);H=ea(g[f>>2]);I=ea(g[f+4>>2]);J=ea(g[f+8>>2]);K=ea(g[f+12>>2]);a=f+16|0;L=ea(g[a>>2]);M=ea(g[a+4>>2]);N=ea(g[a+8>>2]);O=ea(-H);P=ea(-I);Q=ea(-J);R=ea(D-L);D=ea(E-M);E=ea(F-N);F=ea(ea(K*K)+ea(-.5));S=ea(ea(ea(R*O)+ea(D*P))+ea(E*Q));U=ea(ea(ea(S*O)+ea(ea(F*R)+ea(K*ea(ea(E*P)-ea(D*Q)))))*ea(2.0));V=ea(ea(ea(S*P)+ea(ea(F*D)+ea(K*ea(ea(R*Q)-ea(E*O)))))*ea(2.0));W=ea(ea(ea(ea(F*E)+ea(K*ea(ea(D*O)-ea(R*P))))+ea(S*Q))*ea(2.0));Q=ea(g[h>>2]);a=h+4|0;S=ea(g[a>>2]);f=h+8|0;P=ea(Q*j);Q=ea(S*j);S=ea(ea(g[f>>2])*j);R=ea(ea(ea(H*P)+ea(I*Q))+ea(J*S));O=ea(ea(ea(I*R)+ea(ea(F*Q)-ea(K*ea(ea(J*P)-ea(H*S)))))*ea(2.0));D=ea(ea(ea(ea(F*S)-ea(K*ea(ea(H*Q)-ea(I*P))))+ea(J*R))*ea(2.0));g[v>>2]=ea(ea(ea(H*R)+ea(ea(F*P)-ea(K*ea(ea(I*S)-ea(J*Q)))))*ea(2.0));g[v+4>>2]=O;g[v+8>>2]=D;g[v+12>>2]=ea(0.0);z1a(w,B,q,s,t);t=x+64|0;c[x+80>>2]=4;s=x+20|0;B=x+36|0;g[x+48>>2]=ea(0.0);d=x+52|0;c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];g[x>>2]=U;g[x+4>>2]=V;g[x+8>>2]=W;g[x+12>>2]=ea(0.0);g[x+128>>2]=G;o=x+132|0;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];g[x+96>>2]=U;g[x+100>>2]=V;g[x+104>>2]=W;g[x+108>>2]=ea(0.0);g[x+112>>2]=U;g[x+116>>2]=V;g[x+120>>2]=W;g[x+124>>2]=ea(0.0);g[x+16>>2]=G;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];g[x+32>>2]=G;c[B+0>>2]=c[u+0>>2];c[B+4>>2]=c[u+4>>2];c[B+8>>2]=c[u+8>>2];c[p+0>>2]=-1;c[p+4>>2]=-1;c[p+8>>2]=-1;c[p+12>>2]=-1;c[t+0>>2]=c[p+0>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];p=(b[l>>1]&512)!=0;if(!(DPa(x,w,r,q,v,y,A,z,ea(ea(g[C>>2])+m),p)|0)){X=0;i=n;return X|0}c[k+8>>2]=-1;m=ea(g[z>>2]);G=ea(g[z+4>>2]);W=ea(g[z+8>>2]);V=ea(ea(ea(H*m)+ea(I*G))+ea(J*W));U=ea(L+ea(ea(ea(H*V)+ea(ea(F*m)+ea(K*ea(ea(I*W)-ea(J*G)))))*ea(2.0)));L=ea(M+ea(ea(ea(I*V)+ea(ea(F*G)+ea(K*ea(ea(J*m)-ea(H*W)))))*ea(2.0)));M=ea(N+ea(ea(ea(ea(F*W)+ea(K*ea(ea(H*G)-ea(I*m))))+ea(J*V))*ea(2.0)));z=k+12|0;b[z>>1]=6;V=ea(g[r>>2]);m=ea(g[y>>2]);if(!(V>=m)){b[z>>1]=7;V=ea(g[A>>2]);G=ea(g[A+4>>2]);W=ea(g[A+8>>2]);N=ea(ea(ea(H*V)+ea(I*G))+ea(J*W));D=ea(ea(ea(H*N)+ea(ea(F*V)+ea(K*ea(ea(I*W)-ea(J*G)))))*ea(2.0));O=ea(ea(ea(I*N)+ea(ea(F*G)+ea(K*ea(ea(J*V)-ea(H*W)))))*ea(2.0));Q=ea(ea(ea(ea(F*W)+ea(K*ea(ea(H*G)-ea(I*V))))+ea(J*N))*ea(2.0));N=ea(ea(1.0)/ea(T(ea(ea(Q*Q)+ea(ea(D*D)+ea(O*O))))));V=ea(-ea(N*O));O=ea(-ea(N*Q));Q=ea(m*j);g[k+28>>2]=ea(-ea(N*D));g[k+32>>2]=V;g[k+36>>2]=O;g[k+16>>2]=U;g[k+20>>2]=L;g[k+24>>2]=M;g[k+40>>2]=Q;X=1;i=n;return X|0}if(p){b[z>>1]=7;Q=ea(g[A>>2]);O=ea(g[A+4>>2]);V=ea(g[A+8>>2]);D=ea(ea(ea(H*Q)+ea(I*O))+ea(J*V));N=ea(ea(ea(H*D)+ea(ea(F*Q)+ea(K*ea(ea(I*V)-ea(J*O)))))*ea(2.0));j=ea(ea(ea(I*D)+ea(ea(F*O)+ea(K*ea(ea(J*Q)-ea(H*V)))))*ea(2.0));G=ea(ea(ea(ea(F*V)+ea(K*ea(ea(H*O)-ea(I*Q))))+ea(J*D))*ea(2.0));D=ea(ea(1.0)/ea(T(ea(ea(G*G)+ea(ea(N*N)+ea(j*j))))));J=ea(-ea(D*j));j=ea(-ea(D*G));g[k+28>>2]=ea(-ea(D*N));g[k+32>>2]=J;g[k+36>>2]=j;g[k+16>>2]=U;g[k+20>>2]=L;g[k+24>>2]=M;g[k+40>>2]=m;X=1;i=n;return X|0}else{g[k+40>>2]=ea(0.0);m=ea(-ea(g[h>>2]));M=ea(-ea(g[a>>2]));L=ea(-ea(g[f>>2]));g[k+28>>2]=m;g[k+32>>2]=M;g[k+36>>2]=L;X=1;i=n;return X|0}return 0}function DNa(d,e,f,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im;d=i;i=i+96|0;o=d+16|0;p=d;q=c[f+32>>2]|0;c[l+8>>2]=-1;r=c[q+56>>2]|0;s=a[q+55>>0]|0;t=a[q+54>>0]|0;q=(b[m>>1]&512)==0;J0a(o,f+4|0,f+16|0);tLa(p,e);e=p+12|0;u=ea(ea(g[e>>2])-n);g[e>>2]=u;e=l+40|0;g[e>>2]=k;if(!(t<<24>>24)){v=0;i=d;return v|0}m=h+12|0;w=h+4|0;x=h+8|0;y=h+16|0;z=h+20|0;A=h+24|0;B=j+4|0;C=j+8|0;D=l+12|0;E=l+16|0;F=l+20|0;G=l+24|0;H=l+28|0;I=l+32|0;J=l+36|0;n=ea(g[o>>2]);K=ea(g[o+4>>2]);L=ea(g[o+8>>2]);M=ea(g[o+12>>2]);N=ea(g[o+16>>2]);O=ea(g[o+20>>2]);P=ea(g[o+24>>2]);Q=ea(g[o+28>>2]);R=ea(g[o+32>>2]);S=ea(g[p>>2]);T=ea(g[p+4>>2]);U=ea(g[p+8>>2]);o=t&255;V=k;t=r+((s&255)*20|0)|0;s=0;a:while(1){r=o+-1|0;k=ea(g[m>>2]);W=ea(ea(k*k)+ea(-.5));X=ea(g[h>>2]);Y=ea(g[w>>2]);Z=ea(g[x>>2]);_=ea(g[y>>2]);$=ea(g[z>>2]);aa=ea(g[A>>2]);ba=ea(g[j>>2]);ca=ea(ba*S);da=ea(g[B>>2]);fa=ea(ca+ea(da*T));ca=ea(g[C>>2]);ga=ea(fa+ea(ca*U));ha=+ga;if(ha>-1.0e-07&ha<1.0e-07){ia=r;ja=4;break}else{ka=r;la=t}while(1){r=la;la=la+12|0;fa=ea(g[r>>2]);ma=ea(fa*n);na=ea(fa*K);oa=ea(fa*L);fa=ea(g[r+4>>2]);pa=ea(ma+ea(fa*M));ma=ea(na+ea(fa*N));na=ea(oa+ea(fa*O));fa=ea(g[r+8>>2]);oa=ea(ea(pa+ea(fa*P))*ea(2.0));pa=ea(ea(ma+ea(fa*Q))*ea(2.0));ma=ea(ea(na+ea(fa*R))*ea(2.0));fa=ea(ea(ea(oa*X)+ea(pa*Y))+ea(ma*Z));na=ea(_+ea(ea(X*fa)+ea(ea(oa*W)+ea(k*ea(ea(ma*Y)-ea(pa*Z))))));qa=ea($+ea(ea(Y*fa)+ea(ea(pa*W)+ea(k*ea(ea(oa*Z)-ea(X*ma))))));ra=ea(aa+ea(ea(ea(ma*W)+ea(k*ea(ea(pa*X)-ea(oa*Y))))+ea(Z*fa)));fa=ea(ea(ea(ea(S*na)+ea(qa*T))+ea(ra*U))+u);sa=ea(ea(-fa)/ga);ta=ea(na+ea(ba*sa));ua=ea(qa+ea(da*sa));va=ea(ra+ea(ca*sa));if(fa<=ea(0.0)){ja=9;break a}if(!(!(sa>ea(0.0))|!(sa<=V)))break;if(!ka){v=s;ja=12;break a}else ka=ka+-1|0}g[e>>2]=sa;b[D>>1]=7;g[E>>2]=ta;g[F>>2]=ua;g[G>>2]=va;g[H>>2]=S;g[I>>2]=T;g[J>>2]=U;if(!ka){v=1;ja=12;break}else{o=ka;V=sa;t=la;s=1}}if((ja|0)==4){while(1){ja=0;if(!ia){v=s;break}else{ia=ia+-1|0;ja=4}}i=d;return v|0}else if((ja|0)==9)if(q){g[e>>2]=ea(0.0);b[D>>1]=6;sa=ea(-ea(g[j>>2]));V=ea(-ea(g[B>>2]));U=ea(-ea(g[C>>2]));g[H>>2]=sa;g[I>>2]=V;g[J>>2]=U;v=1;i=d;return v|0}else{b[D>>1]=7;v=uNa(p,f,h,l)|0;i=d;return v|0}else if((ja|0)==12){i=d;return v|0}return 0}function ENa(a,d,e,f,h,j,k,l,m){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0;n=i;i=i+48|0;o=n+12|0;p=n;q=n+40|0;r=ea(g[d>>2]);s=ea(r*ea(2.0));t=ea(g[d+12>>2]);u=ea(t*ea(2.0));v=ea(ea(r*s)+ea(ea(t*u)+ea(-1.0)));t=ea(g[d+8>>2]);r=ea(t*u);w=ea(g[d+4>>2]);x=ea(r+ea(s*w));r=ea(ea(s*t)-ea(u*w));w=ea(g[a+8>>2]);u=ea(w*v);v=ea(w*x);x=ea(w*r);r=ea(g[d+16>>2]);w=ea(r+u);t=ea(g[d+20>>2]);s=ea(t+v);y=ea(g[d+24>>2]);z=ea(x+y);g[o>>2]=w;g[o+4>>2]=s;g[o+8>>2]=z;z=ea(t-v);v=ea(y-x);g[o+12>>2]=ea(r-u);g[o+16>>2]=z;g[o+20>>2]=v;g[o+24>>2]=ea(g[a+4>>2]);v=ea(-ea(g[h>>2]));a=h+4|0;z=ea(-ea(g[a>>2]));d=h+8|0;u=ea(-ea(g[d>>2]));g[p>>2]=v;g[p+4>>2]=z;g[p+8>>2]=u;b[q>>1]=b[l>>1]|0;if(!(yNa(e,f,o,p,j,k,q,m)|0)){A=0;i=n;return A|0}m=ea(g[k+40>>2]);j=ea(m*ea(g[h>>2]));u=ea(m*ea(g[a>>2]));z=ea(m*ea(g[d>>2]));d=k+16|0;g[d>>2]=ea(j+ea(g[d>>2]));d=k+20|0;g[d>>2]=ea(u+ea(g[d>>2]));d=k+24|0;g[d>>2]=ea(z+ea(g[d>>2]));d=k+28|0;z=ea(-ea(g[d>>2]));a=k+32|0;u=ea(-ea(g[a>>2]));h=k+36|0;j=ea(-ea(g[h>>2]));g[d>>2]=z;g[a>>2]=u;g[h>>2]=j;c[k+8>>2]=-1;A=1;i=n;return A|0}function FNa(a,d,e,f,h,j,k,l,m){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0;n=i;i=i+80|0;o=n+12|0;p=n;q=n+72|0;g[o+36>>2]=ea(g[d+16>>2]);g[o+40>>2]=ea(g[d+20>>2]);g[o+44>>2]=ea(g[d+24>>2]);g[o+48>>2]=ea(g[a+4>>2]);g[o+52>>2]=ea(g[a+8>>2]);g[o+56>>2]=ea(g[a+12>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);t=ea(g[d+8>>2]);u=ea(g[d+12>>2]);v=ea(r+r);w=ea(s+s);x=ea(t+t);y=ea(s*w);z=ea(t*x);A=ea(v*s);s=ea(v*t);B=ea(v*u);C=ea(w*t);t=ea(w*u);w=ea(x*u);u=ea(A+w);x=ea(s-t);D=ea(A-w);w=ea(ea(1.0)-ea(r*v));v=ea(w-z);r=ea(C+B);A=ea(s+t);t=ea(C-B);B=ea(w-y);g[o>>2]=ea(ea(ea(1.0)-y)-z);g[o+4>>2]=u;g[o+8>>2]=x;g[o+12>>2]=D;g[o+16>>2]=v;g[o+20>>2]=r;g[o+24>>2]=A;g[o+28>>2]=t;g[o+32>>2]=B;B=ea(-ea(g[h>>2]));d=h+4|0;t=ea(-ea(g[d>>2]));a=h+8|0;A=ea(-ea(g[a>>2]));g[p>>2]=B;g[p+4>>2]=t;g[p+8>>2]=A;b[q>>1]=b[l>>1]|0;if(!(ANa(e,f,o,p,j,k,q,m)|0)){E=0;i=n;return E|0}m=ea(g[k+40>>2]);j=ea(m*ea(g[h>>2]));A=ea(m*ea(g[d>>2]));t=ea(m*ea(g[a>>2]));a=k+16|0;g[a>>2]=ea(j+ea(g[a>>2]));a=k+20|0;g[a>>2]=ea(A+ea(g[a>>2]));a=k+24|0;g[a>>2]=ea(t+ea(g[a>>2]));a=k+28|0;t=ea(-ea(g[a>>2]));d=k+32|0;A=ea(-ea(g[d>>2]));h=k+36|0;j=ea(-ea(g[h>>2]));g[a>>2]=t;g[d>>2]=A;g[h>>2]=j;c[k+8>>2]=-1;E=1;i=n;return E|0}function GNa(a,e,f,h,j,k,l,m,n){a=a|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im;o=i;i=i+656|0;p=o+640|0;q=o+304|0;r=o+576|0;s=o;t=o+560|0;u=o+592|0;v=o+608|0;w=o+624|0;x=o+16|0;y=o+336|0;z=o+96|0;A=o+544|0;B=o+320|0;C=o+80|0;D=c[a+32>>2]|0;E=(c[f+32>>2]|0)+16|0;c[p>>2]=d[E+39>>0];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;g[r>>2]=ea(0.0);F=ea(g[a+4>>2]);G=ea(g[a+8>>2]);H=ea(g[a+12>>2]);g[s>>2]=F;g[s+4>>2]=G;g[s+8>>2]=H;g[s+12>>2]=ea(0.0);H=ea(g[a+16>>2]);G=ea(g[a+20>>2]);F=ea(g[a+24>>2]);I=ea(g[a+28>>2]);g[t>>2]=H;g[t+4>>2]=G;g[t+8>>2]=F;g[t+12>>2]=I;a=f+4|0;I=ea(g[a>>2]);F=ea(g[a+4>>2]);G=ea(g[a+8>>2]);g[u>>2]=I;g[u+4>>2]=F;g[u+8>>2]=G;g[u+12>>2]=ea(0.0);a=f+16|0;G=ea(g[a>>2]);F=ea(g[a+4>>2]);I=ea(g[a+8>>2]);H=ea(g[a+12>>2]);g[v>>2]=G;g[v+4>>2]=F;g[v+8>>2]=I;g[v+12>>2]=H;H=ea(g[e>>2]);I=ea(g[e+4>>2]);F=ea(g[e+8>>2]);G=ea(g[e+12>>2]);a=e+16|0;J=ea(g[a>>2]);K=ea(g[a+4>>2]);L=ea(g[a+8>>2]);M=ea(g[h>>2]);N=ea(g[h+4>>2]);O=ea(g[h+8>>2]);P=ea(g[h+12>>2]);a=h+16|0;Q=ea(g[a>>2]);R=ea(g[a+4>>2]);S=ea(g[a+8>>2]);U=ea(g[j>>2]);a=j+4|0;V=ea(g[a>>2]);h=j+8|0;W=ea(U*k);U=ea(V*k);V=ea(ea(g[h>>2])*k);X=ea(ea(P*P)+ea(-.5));Y=ea(ea(ea(M*W)+ea(N*U))+ea(O*V));Z=ea(ea(ea(N*Y)+ea(ea(X*U)-ea(P*ea(ea(O*W)-ea(M*V)))))*ea(2.0));_=ea(ea(ea(ea(X*V)-ea(P*ea(ea(M*U)-ea(N*W))))+ea(O*Y))*ea(2.0));g[w>>2]=ea(ea(ea(M*Y)+ea(ea(X*W)-ea(P*ea(ea(N*V)-ea(O*U)))))*ea(2.0));g[w+4>>2]=Z;g[w+8>>2]=_;g[w+12>>2]=ea(0.0);_=ea(-M);Z=ea(-N);U=ea(-O);V=ea(J-Q);J=ea(K-R);K=ea(L-S);L=ea(ea(ea(V*_)+ea(J*Z))+ea(K*U));W=ea(ea(ea(L*Z)+ea(ea(X*J)+ea(P*ea(ea(V*U)-ea(K*_)))))*ea(2.0));Y=ea(ea(ea(ea(X*K)+ea(P*ea(ea(J*_)-ea(V*Z))))+ea(L*U))*ea(2.0));$=ea(ea(G*P)-ea(ea(ea(H*_)+ea(I*Z))+ea(F*U)));aa=ea(ea(ea(F*Z)-ea(I*U))+ea(ea(G*_)+ea(H*P)));ba=ea(ea(ea(H*U)-ea(F*_))+ea(ea(G*Z)+ea(I*P)));ca=ea(ea(ea(I*_)-ea(H*Z))+ea(ea(F*P)+ea(G*U)));g[x+48>>2]=ea(ea(ea(L*_)+ea(ea(X*V)+ea(P*ea(ea(K*Z)-ea(J*U)))))*ea(2.0));g[x+52>>2]=W;g[x+56>>2]=Y;g[x+60>>2]=ea(0.0);Y=ea(aa+aa);W=ea(ba+ba);U=ea(ca+ca);J=ea(ba*W);Z=ea(ca*U);K=ea(ba*Y);ba=ea(ca*Y);V=ea($*Y);_=ea(ca*W);ca=ea($*W);W=ea($*U);U=ea(ea(1.0)-ea(aa*Y));Y=ea(K+W);aa=ea(ba-ca);$=ea(K-W);W=ea(U-Z);K=ea(_+V);L=ea(ba+ca);ca=ea(_-V);V=ea(U-J);g[x>>2]=ea(ea(ea(1.0)-J)-Z);g[x+4>>2]=Y;g[x+8>>2]=aa;g[x+12>>2]=ea(0.0);g[x+16>>2]=$;g[x+20>>2]=W;g[x+24>>2]=K;g[x+28>>2]=ea(0.0);g[x+32>>2]=L;g[x+36>>2]=ca;g[x+40>>2]=V;g[x+44>>2]=ea(0.0);z1a(y,D+16|0,q,s,t);z1a(z,E,q,u,v);v=(b[m>>1]&512)!=0;if(!(MPa(y,z,x,r,q,w,A,C,B,n,v)|0)){da=0;i=o;return da|0}w=l+12|0;b[w>>1]=6;n=ea(g[r>>2]);V=ea(g[A>>2]);do if(n>=V)if(v){b[w>>1]=7;ca=ea(g[B>>2]);L=ea(g[B+4>>2]);K=ea(g[B+8>>2]);W=ea(ea(ea(M*ca)+ea(N*L))+ea(O*K));$=ea(Q+ea(ea(ea(M*W)+ea(ea(X*ca)+ea(P*ea(ea(N*K)-ea(O*L)))))*ea(2.0)));aa=ea(R+ea(ea(ea(N*W)+ea(ea(X*L)+ea(P*ea(ea(O*ca)-ea(M*K)))))*ea(2.0)));Y=ea(S+ea(ea(ea(ea(X*K)+ea(P*ea(ea(M*L)-ea(N*ca))))+ea(O*W))*ea(2.0)));W=ea(g[C>>2]);ca=ea(g[C+4>>2]);L=ea(g[C+8>>2]);K=ea(ea(ea(M*W)+ea(N*ca))+ea(O*L));Z=ea(ea(ea(M*K)+ea(ea(X*W)+ea(P*ea(ea(N*L)-ea(O*ca)))))*ea(2.0));J=ea(ea(ea(N*K)+ea(ea(X*ca)+ea(P*ea(ea(O*W)-ea(M*L)))))*ea(2.0));U=ea(ea(ea(ea(X*L)+ea(P*ea(ea(M*ca)-ea(N*W))))+ea(O*K))*ea(2.0));K=ea(ea(1.0)/ea(T(ea(ea(U*U)+ea(ea(Z*Z)+ea(J*J))))));W=ea(-ea(K*J));J=ea(-ea(K*U));g[l+28>>2]=ea(-ea(K*Z));g[l+32>>2]=W;g[l+36>>2]=J;g[l+16>>2]=$;g[l+20>>2]=aa;g[l+24>>2]=Y;g[l+40>>2]=V;fa=$;ga=aa;ha=Y;break}else{g[l+40>>2]=ea(0.0);Y=ea(-ea(g[j>>2]));aa=ea(-ea(g[a>>2]));$=ea(-ea(g[h>>2]));g[l+28>>2]=Y;g[l+32>>2]=aa;g[l+36>>2]=$;$=ea(g[l+16>>2]);aa=ea(g[l+20>>2]);fa=$;ga=aa;ha=ea(g[l+24>>2]);break}else{b[w>>1]=7;aa=ea(g[B>>2]);$=ea(g[B+4>>2]);Y=ea(g[B+8>>2]);J=ea(ea(ea(M*aa)+ea(N*$))+ea(O*Y));W=ea(Q+ea(ea(ea(M*J)+ea(ea(X*aa)+ea(P*ea(ea(N*Y)-ea(O*$)))))*ea(2.0)));Z=ea(R+ea(ea(ea(N*J)+ea(ea(X*$)+ea(P*ea(ea(O*aa)-ea(M*Y)))))*ea(2.0)));K=ea(S+ea(ea(ea(ea(X*Y)+ea(P*ea(ea(M*$)-ea(N*aa))))+ea(O*J))*ea(2.0)));J=ea(g[C>>2]);aa=ea(g[C+4>>2]);$=ea(g[C+8>>2]);Y=ea(ea(ea(M*J)+ea(N*aa))+ea(O*$));U=ea(ea(ea(M*Y)+ea(ea(X*J)+ea(P*ea(ea(N*$)-ea(O*aa)))))*ea(2.0));ca=ea(ea(ea(N*Y)+ea(ea(X*aa)+ea(P*ea(ea(O*J)-ea(M*$)))))*ea(2.0));L=ea(ea(ea(ea(X*$)+ea(P*ea(ea(M*aa)-ea(N*J))))+ea(O*Y))*ea(2.0));Y=ea(ea(1.0)/ea(T(ea(ea(L*L)+ea(ea(U*U)+ea(ca*ca))))));J=ea(-ea(Y*ca));ca=ea(-ea(Y*L));L=ea(V*k);g[l+28>>2]=ea(-ea(Y*U));g[l+32>>2]=J;g[l+36>>2]=ca;g[l+16>>2]=W;g[l+20>>2]=Z;g[l+24>>2]=K;g[l+40>>2]=L;fa=W;ga=Z;ha=K}while(0);k=ea(g[j>>2]);V=ea(g[a>>2]);c[l+8>>2]=w6a(f,E,p,e,fa,ga,ha,k,V,ea(g[h>>2]))|0;da=1;i=o;return da|0}function HNa(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0;m=i;i=i+480|0;n=m+416|0;o=m+64|0;p=m+16|0;q=m+32|0;r=m+432|0;s=m+436|0;t=m+464|0;u=m+224|0;v=m+80|0;w=m+384|0;x=m+48|0;y=m;z=m+400|0;g[p>>2]=ea(0.0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;A=ea(g[a+4>>2]);B=ea(g[a+8>>2]);C=ea(g[a+12>>2]);D=ea(g[f>>2]);a=f+4|0;E=ea(g[a>>2]);F=f+8|0;G=ea(g[F>>2]);g[r>>2]=ea(0.0);uLa(s,e,r);H=ea(g[s>>2]);I=ea(g[s+4>>2]);J=ea(g[s+8>>2]);K=ea(g[s+12>>2]);L=s+16|0;M=ea(g[L>>2]);N=ea(g[L+4>>2]);O=ea(g[L+8>>2]);P=ea(g[d>>2]);Q=ea(g[d+4>>2]);R=ea(g[d+8>>2]);S=ea(g[d+12>>2]);L=d+16|0;T=ea(g[L>>2]);U=ea(g[L+4>>2]);V=ea(g[L+8>>2]);W=ea(-P);X=ea(-Q);Y=ea(-R);Z=ea(M-T);M=ea(N-U);N=ea(O-V);O=ea(ea(S*S)+ea(-.5));_=ea(ea(ea(Z*W)+ea(M*X))+ea(N*Y));$=ea(ea(ea(_*W)+ea(ea(O*Z)+ea(S*ea(ea(N*X)-ea(M*Y)))))*ea(2.0));aa=ea(ea(ea(_*X)+ea(ea(O*M)+ea(S*ea(ea(Z*Y)-ea(N*W)))))*ea(2.0));ba=ea(ea(ea(ea(O*N)+ea(S*ea(ea(M*W)-ea(Z*X))))+ea(_*Y))*ea(2.0));_=ea(ea(K*S)-ea(ea(ea(H*W)+ea(I*X))+ea(J*Y)));Z=ea(ea(ea(J*X)-ea(I*Y))+ea(ea(K*W)+ea(H*S)));M=ea(ea(ea(H*Y)-ea(J*W))+ea(ea(K*X)+ea(I*S)));N=ea(ea(ea(I*W)-ea(H*X))+ea(ea(J*S)+ea(K*Y)));Y=ea(Z+Z);K=ea(M+M);J=ea(N+N);X=ea(M*K);H=ea(N*J);W=ea(M*Y);M=ea(N*Y);I=ea(_*Y);ca=ea(N*K);N=ea(_*K);K=ea(_*J);J=ea(ea(1.0)-ea(Z*Y));Y=ea(ea(ea(1.0)-X)-H);Z=ea(W+K);_=ea(M-N);da=ea(W-K);K=ea(J-H);H=ea(ca+I);W=ea(M+N);N=ea(ca-I);I=ea(J-X);X=ea(g[r>>2]);r=e+24|0;J=ea(g[r>>2]);e=u+64|0;c[u+0>>2]=c[q+0>>2];c[u+4>>2]=c[q+4>>2];c[u+8>>2]=c[q+8>>2];c[u+12>>2]=c[q+12>>2];c[u+80>>2]=3;L=u+20|0;c[L+0>>2]=c[n+0>>2];c[L+4>>2]=c[n+4>>2];c[L+8>>2]=c[n+8>>2];d=u+36|0;g[u+48>>2]=ea(0.0);s=u+52|0;c[s+0>>2]=c[n+0>>2];c[s+4>>2]=c[n+4>>2];c[s+8>>2]=c[n+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[e+0>>2]=c[o+0>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];g[u+144>>2]=A;g[u+148>>2]=B;g[u+152>>2]=C;g[u+156>>2]=ea(0.0);ca=!(A<=B)?B:A;M=!(ca<=C)?C:ca;ca=!(A>=B)?B:A;A=ea(M*ea(.150000006));B=ea((!(ca>=C)?C:ca)*ea(.0299999993));ca=A>B?A:B;g[u+16>>2]=M>ca?ca:M;c[L+0>>2]=c[n+0>>2];c[L+4>>2]=c[n+4>>2];c[L+8>>2]=c[n+8>>2];g[u+32>>2]=ea(M*ea(.0500000007));c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];M=ea(X*ea(0.0));ca=ea(ea(M*W)+ea(ea(M*da)+ea(X*Y)));Y=ea(ea(M*N)+ea(ea(X*Z)+ea(M*K)));K=ea(ea(ea(X*_)+ea(M*H))+ea(M*I));d=v+64|0;g[v>>2]=$;g[v+4>>2]=aa;g[v+8>>2]=ba;g[v+12>>2]=ea(0.0);c[v+80>>2]=4;L=v+20|0;e=v+36|0;g[v+48>>2]=ea(0.0);s=v+52|0;c[s+0>>2]=c[o+0>>2];c[s+4>>2]=c[o+4>>2];c[s+8>>2]=c[o+8>>2];g[v+128>>2]=J;o=v+132|0;c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];I=ea(aa+Y);M=ea(ba+K);g[v+96>>2]=ea($+ca);g[v+100>>2]=I;g[v+104>>2]=M;g[v+108>>2]=ea(0.0);M=ea(aa-Y);Y=ea(ba-K);g[v+112>>2]=ea($-ca);g[v+116>>2]=M;g[v+120>>2]=Y;g[v+124>>2]=ea(0.0);g[v+16>>2]=J;c[L+0>>2]=c[t+0>>2];c[L+4>>2]=c[t+4>>2];c[L+8>>2]=c[t+8>>2];g[v+32>>2]=J;c[e+0>>2]=c[t+0>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[n+0>>2]=-1;c[n+4>>2]=-1;c[n+8>>2]=-1;c[n+12>>2]=-1;c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];c[d+12>>2]=c[n+12>>2];J=ea(-ea(D*h));Y=ea(-ea(E*h));M=ea(-ea(G*h));ca=ea(ea(ea(P*J)+ea(Q*Y))+ea(R*M));$=ea(ea(ea(Q*ca)+ea(ea(O*Y)-ea(S*ea(ea(R*J)-ea(P*M)))))*ea(2.0));K=ea(ea(ea(R*ca)+ea(ea(O*M)-ea(S*ea(ea(P*Y)-ea(Q*J)))))*ea(2.0));g[w>>2]=ea(ea(ea(P*ca)+ea(ea(O*J)-ea(S*ea(ea(Q*M)-ea(R*Y)))))*ea(2.0));g[w+4>>2]=$;g[w+8>>2]=K;g[w+12>>2]=ea(0.0);n=(b[k>>1]&512)!=0;g[x>>2]=ea(3402823469999999843913219.0e14);if(!(CPa(v,u,p,q,w,x,z,y,ea(ea(g[r>>2])+l),n)|0)){fa=0;i=m;return fa|0}r=j+12|0;b[r>>1]=6;l=ea(g[p>>2]);K=ea(g[x>>2]);if(!(l>=K)){b[r>>1]=7;l=ea(g[y>>2]);$=ea(g[y+4>>2]);Y=ea(g[y+8>>2]);M=ea(ea(ea(P*l)+ea(Q*$))+ea(R*Y));J=ea(T+ea(ea(ea(P*M)+ea(ea(O*l)+ea(S*ea(ea(Q*Y)-ea(R*$)))))*ea(2.0)));ca=ea(U+ea(ea(ea(Q*M)+ea(ea(O*$)+ea(S*ea(ea(R*l)-ea(P*Y)))))*ea(2.0)));ba=ea(V+ea(ea(ea(ea(O*Y)+ea(S*ea(ea(P*$)-ea(Q*l))))+ea(R*M))*ea(2.0)));M=ea(g[z>>2]);l=ea(g[z+4>>2]);$=ea(g[z+8>>2]);Y=ea(ea(ea(P*M)+ea(Q*l))+ea(R*$));aa=ea(ea(ea(Q*Y)+ea(ea(O*l)+ea(S*ea(ea(R*M)-ea(P*$)))))*ea(2.0));I=ea(ea(ea(ea(O*$)+ea(S*ea(ea(P*l)-ea(Q*M))))+ea(R*Y))*ea(2.0));H=ea(K*h);h=ea(ea(D*H)+J);J=ea(ea(E*H)+ca);ca=ea(ea(G*H)+ba);g[j+28>>2]=ea(ea(ea(P*Y)+ea(ea(O*M)+ea(S*ea(ea(Q*$)-ea(R*l)))))*ea(2.0));g[j+32>>2]=aa;g[j+36>>2]=I;g[j+16>>2]=h;g[j+20>>2]=J;g[j+24>>2]=ca;g[j+40>>2]=H;fa=1;i=m;return fa|0}if(n){b[r>>1]=7;H=ea(g[y>>2]);ca=ea(g[y+4>>2]);J=ea(g[y+8>>2]);h=ea(ea(ea(P*H)+ea(Q*ca))+ea(R*J));I=ea(T+ea(ea(ea(P*h)+ea(ea(O*H)+ea(S*ea(ea(Q*J)-ea(R*ca)))))*ea(2.0)));T=ea(U+ea(ea(ea(Q*h)+ea(ea(O*ca)+ea(S*ea(ea(R*H)-ea(P*J)))))*ea(2.0)));U=ea(V+ea(ea(ea(ea(O*J)+ea(S*ea(ea(P*ca)-ea(Q*H))))+ea(R*h))*ea(2.0)));h=ea(g[z>>2]);H=ea(g[z+4>>2]);ca=ea(g[z+8>>2]);J=ea(ea(ea(P*h)+ea(Q*H))+ea(R*ca));V=ea(ea(ea(P*J)+ea(ea(O*h)+ea(S*ea(ea(Q*ca)-ea(R*H)))))*ea(2.0));aa=ea(ea(ea(Q*J)+ea(ea(O*H)+ea(S*ea(ea(R*h)-ea(P*ca)))))*ea(2.0));l=ea(ea(ea(ea(O*ca)+ea(S*ea(ea(P*H)-ea(Q*h))))+ea(R*J))*ea(2.0));J=ea(T-ea(K*aa));T=ea(U-ea(K*l));g[j+16>>2]=ea(I-ea(K*V));g[j+20>>2]=J;g[j+24>>2]=T;g[j+28>>2]=V;g[j+32>>2]=aa;g[j+36>>2]=l;g[j+40>>2]=K;fa=1;i=m;return fa|0}else{g[j+40>>2]=ea(0.0);K=ea(-ea(g[f>>2]));l=ea(-ea(g[a>>2]));aa=ea(-ea(g[F>>2]));g[j+28>>2]=K;g[j+32>>2]=l;g[j+36>>2]=aa;fa=1;i=m;return fa|0}return 0}function INa(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0;m=i;i=i+448|0;n=m;o=m+192|0;p=m+16|0;q=m+32|0;r=m+432|0;s=m+272|0;t=m+48|0;u=m+224|0;v=m+208|0;w=m+240|0;x=m+256|0;g[p>>2]=ea(0.0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;y=ea(g[e+48>>2]);z=ea(g[e+52>>2]);A=ea(g[e+56>>2]);B=ea(g[f>>2]);C=f+4|0;D=ea(g[C>>2]);E=f+8|0;F=ea(g[E>>2]);G=a+4|0;H=ea(g[G>>2]);UUa(n,e);I=ea(g[n>>2]);J=ea(g[n+4>>2]);K=ea(g[n+8>>2]);L=ea(g[n+12>>2]);M=ea(g[e+36>>2]);N=ea(g[e+40>>2]);O=ea(g[e+44>>2]);e=d+16|0;P=ea(g[e>>2]);Q=ea(g[e+4>>2]);R=ea(-I);S=ea(-J);T=ea(-K);U=ea(P-M);P=ea(Q-N);Q=ea(ea(g[e+8>>2])-O);V=ea(ea(L*L)+ea(-.5));W=ea(ea(ea(U*R)+ea(P*S))+ea(Q*T));X=ea(ea(ea(W*R)+ea(ea(V*U)+ea(L*ea(ea(Q*S)-ea(P*T)))))*ea(2.0));Y=ea(ea(ea(W*S)+ea(ea(V*P)+ea(L*ea(ea(U*T)-ea(Q*R)))))*ea(2.0));Z=ea(ea(ea(ea(V*Q)+ea(L*ea(ea(P*R)-ea(U*S))))+ea(W*T))*ea(2.0));e=s+64|0;c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];c[s+12>>2]=c[q+12>>2];c[s+80>>2]=3;d=s+20|0;c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];a=s+36|0;g[s+48>>2]=ea(0.0);_=s+52|0;c[_+0>>2]=c[n+0>>2];c[_+4>>2]=c[n+4>>2];c[_+8>>2]=c[n+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[e+0>>2]=c[o+0>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];g[s+144>>2]=y;g[s+148>>2]=z;g[s+152>>2]=A;g[s+156>>2]=ea(0.0);T=!(y<=z)?z:y;W=!(T<=A)?A:T;T=!(y>=z)?z:y;y=ea(W*ea(.150000006));z=ea((!(T>=A)?A:T)*ea(.0299999993));T=y>z?y:z;g[s+16>>2]=W>T?T:W;c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];g[s+32>>2]=ea(W*ea(.0500000007));c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];a=t+64|0;c[t+80>>2]=4;d=t+20|0;e=t+36|0;g[t+48>>2]=ea(0.0);_=t+52|0;c[_+0>>2]=c[o+0>>2];c[_+4>>2]=c[o+4>>2];c[_+8>>2]=c[o+8>>2];g[t>>2]=X;g[t+4>>2]=Y;g[t+8>>2]=Z;g[t+12>>2]=ea(0.0);g[t+128>>2]=H;o=t+132|0;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];g[t+96>>2]=X;g[t+100>>2]=Y;g[t+104>>2]=Z;g[t+108>>2]=ea(0.0);g[t+112>>2]=X;g[t+116>>2]=Y;g[t+120>>2]=Z;g[t+124>>2]=ea(0.0);g[t+16>>2]=H;c[d+0>>2]=c[r+0>>2];c[d+4>>2]=c[r+4>>2];c[d+8>>2]=c[r+8>>2];g[t+32>>2]=H;c[e+0>>2]=c[r+0>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[n+0>>2]=-1;c[n+4>>2]=-1;c[n+8>>2]=-1;c[n+12>>2]=-1;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];H=ea(B*h);B=ea(D*h);D=ea(F*h);F=ea(ea(ea(H*I)+ea(B*J))+ea(D*K));Z=ea(ea(ea(J*F)+ea(ea(B*V)-ea(L*ea(ea(H*K)-ea(D*I)))))*ea(2.0));Y=ea(ea(ea(K*F)+ea(ea(D*V)-ea(L*ea(ea(B*I)-ea(H*J)))))*ea(2.0));g[u>>2]=ea(ea(ea(I*F)+ea(ea(H*V)-ea(L*ea(ea(D*J)-ea(B*K)))))*ea(2.0));g[u+4>>2]=Z;g[u+8>>2]=Y;g[u+12>>2]=ea(0.0);n=(b[k>>1]&512)!=0;if(!(CPa(t,s,p,q,u,v,x,w,ea(ea(g[G>>2])+l),n)|0)){$=0;i=m;return $|0}G=j+12|0;b[G>>1]=6;l=ea(g[p>>2]);Y=ea(g[v>>2]);if(!(l>=Y)){b[G>>1]=7;l=ea(g[w>>2]);Z=ea(g[w+4>>2]);B=ea(g[w+8>>2]);D=ea(ea(ea(I*l)+ea(J*Z))+ea(K*B));H=ea(M+ea(ea(ea(I*D)+ea(ea(V*l)+ea(L*ea(ea(J*B)-ea(K*Z)))))*ea(2.0)));F=ea(N+ea(ea(ea(J*D)+ea(ea(V*Z)+ea(L*ea(ea(K*l)-ea(I*B)))))*ea(2.0)));X=ea(O+ea(ea(ea(ea(V*B)+ea(L*ea(ea(I*Z)-ea(J*l))))+ea(K*D))*ea(2.0)));D=ea(g[x>>2]);l=ea(g[x+4>>2]);Z=ea(g[x+8>>2]);B=ea(ea(ea(I*D)+ea(J*l))+ea(K*Z));W=ea(-ea(ea(ea(J*B)+ea(ea(V*l)+ea(L*ea(ea(K*D)-ea(I*Z)))))*ea(2.0)));T=ea(-ea(ea(ea(ea(V*Z)+ea(L*ea(ea(I*l)-ea(J*D))))+ea(K*B))*ea(2.0)));z=ea(Y*h);g[j+28>>2]=ea(-ea(ea(ea(I*B)+ea(ea(V*D)+ea(L*ea(ea(J*Z)-ea(K*l)))))*ea(2.0)));g[j+32>>2]=W;g[j+36>>2]=T;g[j+16>>2]=H;g[j+20>>2]=F;g[j+24>>2]=X;g[j+40>>2]=z;$=1;i=m;return $|0}if(n){b[G>>1]=7;z=ea(g[w>>2]);X=ea(g[w+4>>2]);F=ea(g[w+8>>2]);H=ea(ea(ea(I*z)+ea(J*X))+ea(K*F));T=ea(M+ea(ea(ea(I*H)+ea(ea(V*z)+ea(L*ea(ea(J*F)-ea(K*X)))))*ea(2.0)));M=ea(N+ea(ea(ea(J*H)+ea(ea(V*X)+ea(L*ea(ea(K*z)-ea(I*F)))))*ea(2.0)));N=ea(O+ea(ea(ea(ea(V*F)+ea(L*ea(ea(I*X)-ea(J*z))))+ea(K*H))*ea(2.0)));H=ea(g[x>>2]);z=ea(g[x+4>>2]);X=ea(g[x+8>>2]);F=ea(ea(ea(I*H)+ea(J*z))+ea(K*X));O=ea(-ea(ea(ea(J*F)+ea(ea(V*z)+ea(L*ea(ea(K*H)-ea(I*X)))))*ea(2.0)));W=ea(-ea(ea(ea(ea(V*X)+ea(L*ea(ea(I*z)-ea(J*H))))+ea(K*F))*ea(2.0)));g[j+28>>2]=ea(-ea(ea(ea(I*F)+ea(ea(V*H)+ea(L*ea(ea(J*X)-ea(K*z)))))*ea(2.0)));g[j+32>>2]=O;g[j+36>>2]=W;g[j+16>>2]=T;g[j+20>>2]=M;g[j+24>>2]=N;g[j+40>>2]=Y;$=1;i=m;return $|0}else{g[j+40>>2]=ea(0.0);Y=ea(-ea(g[f>>2]));N=ea(-ea(g[C>>2]));M=ea(-ea(g[E>>2]));g[j+28>>2]=Y;g[j+32>>2]=N;g[j+36>>2]=M;$=1;i=m;return $|0}return 0}function JNa(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0;m=i;i=i+448|0;n=m;o=m+192|0;p=m+432|0;q=m+32|0;r=m+256|0;s=m+272|0;t=m+48|0;u=m+224|0;v=m+208|0;w=m+240|0;x=m+16|0;y=ea(g[a+8>>2]);z=a+4|0;A=ea(g[z>>2]);g[q>>2]=ea(0.0);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;B=ea(g[e+48>>2]);C=ea(g[e+52>>2]);D=ea(g[e+56>>2]);E=ea(g[f>>2]);a=f+4|0;F=ea(g[a>>2]);G=f+8|0;H=ea(g[G>>2]);UUa(n,e);I=ea(g[n>>2]);J=ea(g[n+4>>2]);K=ea(g[n+8>>2]);L=ea(g[n+12>>2]);M=ea(g[e+36>>2]);N=ea(g[e+40>>2]);O=ea(g[e+44>>2]);P=ea(g[d>>2]);Q=ea(g[d+4>>2]);R=ea(g[d+8>>2]);S=ea(g[d+12>>2]);e=d+16|0;T=ea(g[e>>2]);U=ea(g[e+4>>2]);V=ea(-I);W=ea(-J);X=ea(-K);Y=ea(T-M);T=ea(U-N);U=ea(ea(g[e+8>>2])-O);Z=ea(ea(L*L)+ea(-.5));_=ea(ea(ea(Y*V)+ea(T*W))+ea(U*X));$=ea(ea(ea(_*V)+ea(ea(Z*Y)+ea(L*ea(ea(U*W)-ea(T*X)))))*ea(2.0));aa=ea(ea(ea(_*W)+ea(ea(Z*T)+ea(L*ea(ea(Y*X)-ea(U*V)))))*ea(2.0));ba=ea(ea(ea(ea(Z*U)+ea(L*ea(ea(T*V)-ea(Y*W))))+ea(_*X))*ea(2.0));_=ea(ea(L*S)-ea(ea(ea(P*V)+ea(Q*W))+ea(R*X)));Y=ea(ea(ea(R*W)-ea(Q*X))+ea(ea(L*P)+ea(S*V)));T=ea(ea(ea(P*X)-ea(R*V))+ea(ea(L*Q)+ea(S*W)));U=ea(ea(ea(Q*V)-ea(P*W))+ea(ea(L*R)+ea(S*X)));X=ea(Y+Y);S=ea(T+T);R=ea(U+U);W=ea(T*S);P=ea(U*R);V=ea(T*X);T=ea(U*X);Q=ea(_*X);ca=ea(U*S);U=ea(_*S);S=ea(_*R);R=ea(ea(1.0)-ea(Y*X));X=ea(ea(ea(1.0)-W)-P);Y=ea(V+S);_=ea(T-U);da=ea(V-S);S=ea(R-P);P=ea(ca+Q);V=ea(T+U);U=ea(ca-Q);Q=ea(R-W);e=s+64|0;c[s+0>>2]=c[r+0>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];c[s+12>>2]=c[r+12>>2];c[s+80>>2]=3;d=s+20|0;c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];fa=s+36|0;g[s+48>>2]=ea(0.0);ga=s+52|0;c[ga+0>>2]=c[n+0>>2];c[ga+4>>2]=c[n+4>>2];c[ga+8>>2]=c[n+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[e+0>>2]=c[o+0>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];g[s+144>>2]=B;g[s+148>>2]=C;g[s+152>>2]=D;g[s+156>>2]=ea(0.0);W=!(B<=C)?C:B;R=!(W<=D)?D:W;W=!(B>=C)?C:B;B=ea(R*ea(.150000006));C=ea((!(W>=D)?D:W)*ea(.0299999993));W=B>C?B:C;g[s+16>>2]=R>W?W:R;c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];g[s+32>>2]=ea(R*ea(.0500000007));c[fa+0>>2]=c[o+0>>2];c[fa+4>>2]=c[o+4>>2];c[fa+8>>2]=c[o+8>>2];R=ea(y*ea(0.0));W=ea(ea(R*V)+ea(ea(R*da)+ea(y*X)));X=ea(ea(R*U)+ea(ea(y*Y)+ea(R*S)));S=ea(ea(ea(y*_)+ea(R*P))+ea(R*Q));fa=t+64|0;g[t>>2]=$;g[t+4>>2]=aa;g[t+8>>2]=ba;g[t+12>>2]=ea(0.0);c[t+80>>2]=4;d=t+20|0;e=t+36|0;g[t+48>>2]=ea(0.0);ga=t+52|0;c[ga+0>>2]=c[o+0>>2];c[ga+4>>2]=c[o+4>>2];c[ga+8>>2]=c[o+8>>2];g[t+128>>2]=A;o=t+132|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];Q=ea(aa+X);R=ea(ba+S);g[t+96>>2]=ea($+W);g[t+100>>2]=Q;g[t+104>>2]=R;g[t+108>>2]=ea(0.0);R=ea(aa-X);X=ea(ba-S);g[t+112>>2]=ea($-W);g[t+116>>2]=R;g[t+120>>2]=X;g[t+124>>2]=ea(0.0);g[t+16>>2]=A;c[d+0>>2]=c[p+0>>2];c[d+4>>2]=c[p+4>>2];c[d+8>>2]=c[p+8>>2];g[t+32>>2]=A;c[e+0>>2]=c[p+0>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[n+0>>2]=-1;c[n+4>>2]=-1;c[n+8>>2]=-1;c[n+12>>2]=-1;c[fa+0>>2]=c[n+0>>2];c[fa+4>>2]=c[n+4>>2];c[fa+8>>2]=c[n+8>>2];c[fa+12>>2]=c[n+12>>2];A=ea(E*h);E=ea(F*h);F=ea(H*h);H=ea(ea(ea(A*I)+ea(E*J))+ea(F*K));X=ea(ea(ea(J*H)+ea(ea(E*Z)-ea(L*ea(ea(A*K)-ea(F*I)))))*ea(2.0));R=ea(ea(ea(K*H)+ea(ea(F*Z)-ea(L*ea(ea(E*I)-ea(A*J)))))*ea(2.0));g[u>>2]=ea(ea(ea(I*H)+ea(ea(A*Z)-ea(L*ea(ea(F*J)-ea(E*K)))))*ea(2.0));g[u+4>>2]=X;g[u+8>>2]=R;g[u+12>>2]=ea(0.0);n=(b[k>>1]&512)!=0;if(!(CPa(t,s,q,r,u,v,x,w,ea(ea(g[z>>2])+l),n)|0)){ha=0;i=m;return ha|0}z=j+12|0;b[z>>1]=6;l=ea(g[q>>2]);R=ea(g[v>>2]);if(!(l>=R)){b[z>>1]=7;l=ea(g[w>>2]);X=ea(g[w+4>>2]);E=ea(g[w+8>>2]);F=ea(ea(ea(I*l)+ea(J*X))+ea(K*E));A=ea(M+ea(ea(ea(I*F)+ea(ea(Z*l)+ea(L*ea(ea(J*E)-ea(K*X)))))*ea(2.0)));H=ea(N+ea(ea(ea(J*F)+ea(ea(Z*X)+ea(L*ea(ea(K*l)-ea(I*E)))))*ea(2.0)));W=ea(O+ea(ea(ea(ea(Z*E)+ea(L*ea(ea(I*X)-ea(J*l))))+ea(K*F))*ea(2.0)));F=ea(g[x>>2]);l=ea(g[x+4>>2]);X=ea(g[x+8>>2]);E=ea(ea(ea(I*F)+ea(J*l))+ea(K*X));$=ea(R*h);h=ea(-ea(ea(ea(J*E)+ea(ea(Z*l)+ea(L*ea(ea(K*F)-ea(I*X)))))*ea(2.0)));S=ea(-ea(ea(ea(ea(Z*X)+ea(L*ea(ea(I*l)-ea(J*F))))+ea(K*E))*ea(2.0)));g[j+28>>2]=ea(-ea(ea(ea(I*E)+ea(ea(Z*F)+ea(L*ea(ea(J*X)-ea(K*l)))))*ea(2.0)));g[j+32>>2]=h;g[j+36>>2]=S;g[j+16>>2]=A;g[j+20>>2]=H;g[j+24>>2]=W;g[j+40>>2]=$;ha=1;i=m;return ha|0}if(n){b[z>>1]=7;$=ea(g[w>>2]);W=ea(g[w+4>>2]);H=ea(g[w+8>>2]);A=ea(ea(ea(I*$)+ea(J*W))+ea(K*H));S=ea(M+ea(ea(ea(I*A)+ea(ea(Z*$)+ea(L*ea(ea(J*H)-ea(K*W)))))*ea(2.0)));M=ea(N+ea(ea(ea(J*A)+ea(ea(Z*W)+ea(L*ea(ea(K*$)-ea(I*H)))))*ea(2.0)));N=ea(O+ea(ea(ea(ea(Z*H)+ea(L*ea(ea(I*W)-ea(J*$))))+ea(K*A))*ea(2.0)));A=ea(g[x>>2]);$=ea(g[x+4>>2]);W=ea(g[x+8>>2]);H=ea(ea(ea(I*A)+ea(J*$))+ea(K*W));O=ea(-ea(ea(ea(J*H)+ea(ea(Z*$)+ea(L*ea(ea(K*A)-ea(I*W)))))*ea(2.0)));h=ea(-ea(ea(ea(ea(Z*W)+ea(L*ea(ea(I*$)-ea(J*A))))+ea(K*H))*ea(2.0)));g[j+28>>2]=ea(-ea(ea(ea(I*H)+ea(ea(Z*A)+ea(L*ea(ea(J*W)-ea(K*$)))))*ea(2.0)));g[j+32>>2]=O;g[j+36>>2]=h;g[j+16>>2]=S;g[j+20>>2]=M;g[j+24>>2]=N;g[j+40>>2]=R;ha=1;i=m;return ha|0}else{g[j+40>>2]=ea(0.0);R=ea(-ea(g[f>>2]));N=ea(-ea(g[a>>2]));M=ea(-ea(g[G>>2]));g[j+28>>2]=R;g[j+32>>2]=N;g[j+36>>2]=M;ha=1;i=m;return ha|0}return 0}function KNa(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0;m=i;i=i+512|0;n=m;o=m+496|0;p=m+16|0;q=m+32|0;r=m+272|0;s=m+336|0;t=m+48|0;u=m+240|0;v=m+224|0;w=m+256|0;x=m+208|0;g[p>>2]=ea(0.0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;y=ea(g[a+4>>2]);z=ea(g[a+8>>2]);A=ea(g[a+12>>2]);B=ea(g[e+48>>2]);C=ea(g[e+52>>2]);D=ea(g[e+56>>2]);E=ea(g[f>>2]);a=f+4|0;F=ea(g[a>>2]);G=f+8|0;H=ea(g[G>>2]);UUa(n,e);I=ea(g[n>>2]);J=ea(g[n+4>>2]);K=ea(g[n+8>>2]);L=ea(g[n+12>>2]);M=ea(g[e+36>>2]);N=ea(g[e+40>>2]);O=ea(g[e+44>>2]);P=ea(g[d>>2]);Q=ea(g[d+4>>2]);R=ea(g[d+8>>2]);S=ea(g[d+12>>2]);e=d+16|0;U=ea(g[e>>2]);V=ea(g[e+4>>2]);W=ea(-I);X=ea(-J);Y=ea(-K);Z=ea(U-M);U=ea(V-N);V=ea(ea(g[e+8>>2])-O);_=ea(ea(L*L)+ea(-.5));$=ea(ea(ea(Z*W)+ea(U*X))+ea(V*Y));aa=ea(ea(ea($*X)+ea(ea(_*U)+ea(L*ea(ea(Z*Y)-ea(V*W)))))*ea(2.0));ba=ea(ea(ea(ea(_*V)+ea(L*ea(ea(U*W)-ea(Z*X))))+ea($*Y))*ea(2.0));ca=ea(ea(L*S)-ea(ea(ea(P*W)+ea(Q*X))+ea(R*Y)));da=ea(ea(ea(R*X)-ea(Q*Y))+ea(ea(L*P)+ea(S*W)));fa=ea(ea(ea(P*Y)-ea(R*W))+ea(ea(L*Q)+ea(S*X)));ga=ea(ea(ea(Q*W)-ea(P*X))+ea(ea(L*R)+ea(S*Y)));g[r+48>>2]=ea(ea(ea($*W)+ea(ea(_*Z)+ea(L*ea(ea(V*X)-ea(U*Y)))))*ea(2.0));g[r+52>>2]=aa;g[r+56>>2]=ba;g[r+60>>2]=ea(0.0);ba=ea(da+da);aa=ea(fa+fa);Y=ea(ga+ga);U=ea(fa*aa);X=ea(ga*Y);V=ea(fa*ba);fa=ea(ga*ba);Z=ea(ca*ba);W=ea(ga*aa);ga=ea(ca*aa);aa=ea(ca*Y);Y=ea(ea(1.0)-ea(da*ba));ba=ea(V+aa);da=ea(fa-ga);ca=ea(V-aa);aa=ea(Y-X);V=ea(W+Z);$=ea(fa+ga);ga=ea(W-Z);Z=ea(Y-U);g[r>>2]=ea(ea(ea(1.0)-U)-X);g[r+4>>2]=ba;g[r+8>>2]=da;g[r+12>>2]=ea(0.0);g[r+16>>2]=ca;g[r+20>>2]=aa;g[r+24>>2]=V;g[r+28>>2]=ea(0.0);g[r+32>>2]=$;g[r+36>>2]=ga;g[r+40>>2]=Z;g[r+44>>2]=ea(0.0);e=s+64|0;c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];c[s+12>>2]=c[q+12>>2];c[s+80>>2]=3;d=s+20|0;c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];ha=s+36|0;g[s+48>>2]=ea(0.0);ia=s+52|0;c[ia+0>>2]=c[o+0>>2];c[ia+4>>2]=c[o+4>>2];c[ia+8>>2]=c[o+8>>2];c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[e+0>>2]=c[n+0>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];g[s+144>>2]=y;g[s+148>>2]=z;g[s+152>>2]=A;g[s+156>>2]=ea(0.0);Z=!(y<=z)?z:y;ga=!(Z<=A)?A:Z;Z=!(y>=z)?z:y;y=ea(ga*ea(.150000006));z=ea((!(Z>=A)?A:Z)*ea(.0299999993));Z=y>z?y:z;g[s+16>>2]=ga>Z?Z:ga;c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];g[s+32>>2]=ea(ga*ea(.0500000007));c[ha+0>>2]=c[n+0>>2];c[ha+4>>2]=c[n+4>>2];c[ha+8>>2]=c[n+8>>2];ha=t+64|0;c[t+0>>2]=c[q+0>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];c[t+12>>2]=c[q+12>>2];c[t+80>>2]=3;d=t+20|0;c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];e=t+36|0;g[t+48>>2]=ea(0.0);ia=t+52|0;c[ia+0>>2]=c[o+0>>2];c[ia+4>>2]=c[o+4>>2];c[ia+8>>2]=c[o+8>>2];c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[ha+0>>2]=c[n+0>>2];c[ha+4>>2]=c[n+4>>2];c[ha+8>>2]=c[n+8>>2];c[ha+12>>2]=c[n+12>>2];g[t+144>>2]=B;g[t+148>>2]=C;g[t+152>>2]=D;g[t+156>>2]=ea(0.0);ga=!(B<=C)?C:B;Z=!(ga<=D)?D:ga;ga=!(B>=C)?C:B;B=ea(Z*ea(.150000006));C=ea((!(ga>=D)?D:ga)*ea(.0299999993));ga=B>C?B:C;g[t+16>>2]=Z>ga?ga:Z;c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];g[t+32>>2]=ea(Z*ea(.0500000007));c[e+0>>2]=c[n+0>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];Z=ea(E*h);E=ea(F*h);F=ea(H*h);H=ea(ea(ea(Z*I)+ea(E*J))+ea(F*K));ga=ea(ea(ea(J*H)+ea(ea(E*_)-ea(L*ea(ea(Z*K)-ea(F*I)))))*ea(2.0));C=ea(ea(ea(K*H)+ea(ea(F*_)-ea(L*ea(ea(E*I)-ea(Z*J)))))*ea(2.0));g[u>>2]=ea(ea(ea(I*H)+ea(ea(Z*_)-ea(L*ea(ea(F*J)-ea(E*K)))))*ea(2.0));g[u+4>>2]=ga;g[u+8>>2]=C;g[u+12>>2]=ea(0.0);n=(b[k>>1]&512)!=0;if(!(KPa(s,t,r,p,q,u,v,x,w,l,n)|0)){ja=0;i=m;return ja|0}u=j+12|0;b[u>>1]=6;l=ea(g[p>>2]);C=ea(g[v>>2]);if(!(l>=C)){b[u>>1]=7;l=ea(g[w>>2]);ga=ea(g[w+4>>2]);E=ea(g[w+8>>2]);F=ea(ea(ea(I*l)+ea(J*ga))+ea(K*E));Z=ea(M+ea(ea(ea(I*F)+ea(ea(_*l)+ea(L*ea(ea(J*E)-ea(K*ga)))))*ea(2.0)));H=ea(N+ea(ea(ea(J*F)+ea(ea(_*ga)+ea(L*ea(ea(K*l)-ea(I*E)))))*ea(2.0)));B=ea(O+ea(ea(ea(ea(_*E)+ea(L*ea(ea(I*ga)-ea(J*l))))+ea(K*F))*ea(2.0)));F=ea(g[x>>2]);l=ea(g[x+4>>2]);ga=ea(g[x+8>>2]);E=ea(ea(ea(I*F)+ea(J*l))+ea(K*ga));D=ea(ea(ea(I*E)+ea(ea(_*F)+ea(L*ea(ea(J*ga)-ea(K*l)))))*ea(2.0));z=ea(ea(ea(J*E)+ea(ea(_*l)+ea(L*ea(ea(K*F)-ea(I*ga)))))*ea(2.0));y=ea(ea(ea(ea(_*ga)+ea(L*ea(ea(I*l)-ea(J*F))))+ea(K*E))*ea(2.0));E=ea(ea(1.0)/ea(T(ea(ea(y*y)+ea(ea(D*D)+ea(z*z))))));F=ea(C*h);h=ea(-ea(E*z));z=ea(-ea(E*y));g[j+28>>2]=ea(-ea(E*D));g[j+32>>2]=h;g[j+36>>2]=z;g[j+16>>2]=Z;g[j+20>>2]=H;g[j+24>>2]=B;g[j+40>>2]=F;ja=1;i=m;return ja|0}if(n){b[u>>1]=7;F=ea(g[w>>2]);B=ea(g[w+4>>2]);H=ea(g[w+8>>2]);Z=ea(ea(ea(I*F)+ea(J*B))+ea(K*H));z=ea(M+ea(ea(ea(I*Z)+ea(ea(_*F)+ea(L*ea(ea(J*H)-ea(K*B)))))*ea(2.0)));M=ea(N+ea(ea(ea(J*Z)+ea(ea(_*B)+ea(L*ea(ea(K*F)-ea(I*H)))))*ea(2.0)));N=ea(O+ea(ea(ea(ea(_*H)+ea(L*ea(ea(I*B)-ea(J*F))))+ea(K*Z))*ea(2.0)));Z=ea(g[x>>2]);F=ea(g[x+4>>2]);B=ea(g[x+8>>2]);H=ea(ea(ea(I*Z)+ea(J*F))+ea(K*B));O=ea(ea(ea(I*H)+ea(ea(_*Z)+ea(L*ea(ea(J*B)-ea(K*F)))))*ea(2.0));h=ea(ea(ea(J*H)+ea(ea(_*F)+ea(L*ea(ea(K*Z)-ea(I*B)))))*ea(2.0));D=ea(ea(ea(ea(_*B)+ea(L*ea(ea(I*F)-ea(J*Z))))+ea(K*H))*ea(2.0));H=ea(ea(1.0)/ea(T(ea(ea(D*D)+ea(ea(O*O)+ea(h*h))))));K=ea(-ea(H*h));h=ea(-ea(H*D));g[j+28>>2]=ea(-ea(H*O));g[j+32>>2]=K;g[j+36>>2]=h;g[j+16>>2]=z;g[j+20>>2]=M;g[j+24>>2]=N;g[j+40>>2]=C;ja=1;i=m;return ja|0}else{g[j+40>>2]=ea(0.0);C=ea(-ea(g[f>>2]));N=ea(-ea(g[a>>2]));M=ea(-ea(g[G>>2]));g[j+28>>2]=C;g[j+32>>2]=N;g[j+36>>2]=M;ja=1;i=m;return ja|0}return 0}function LNa(a,b,d,e,f,h,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=0,jb=0;p=i;i=i+464|0;q=p+48|0;r=p+64|0;s=p+432|0;t=p+444|0;u=p+256|0;v=p;w=p+272|0;x=p+224|0;y=p+80|0;z=p+240|0;A=p+32|0;B=p+16|0;if(!a){C=0;i=p;return C|0}D=e+16|0;E=ea(g[D>>2]);F=ea(g[e+20>>2]);G=ea(g[e+24>>2]);H=ea(g[d+4>>2]);I=ea(g[d+8>>2]);J=ea(g[d+12>>2]);K=ea(g[e>>2]);L=ea(g[e+4>>2]);M=ea(g[e+8>>2]);N=ea(g[e+12>>2]);O=ea(K+K);P=ea(L+L);Q=ea(M+M);R=ea(L*P);S=ea(M*Q);U=ea(O*L);L=ea(O*M);V=ea(O*N);W=ea(P*M);M=ea(P*N);P=ea(Q*N);N=ea(ea(ea(1.0)-R)-S);Q=ea(U+P);X=ea(L-M);Y=ea(U-P);P=ea(ea(1.0)-ea(K*O));O=ea(P-S);S=ea(W+V);K=ea(L+M);M=ea(W-V);V=ea(P-R);R=ea(-E);E=ea(-F);F=ea(-G);G=ea(ea(X*F)+ea(ea(N*R)+ea(Q*E)));P=ea(ea(S*F)+ea(ea(Y*R)+ea(O*E)));W=ea(ea(V*F)+ea(ea(K*R)+ea(M*E)));E=ea(g[f>>2]);R=ea(E*N);F=ea(E*Y);L=ea(E*K);E=ea(g[f+4>>2]);U=ea(R+ea(E*Q));R=ea(F+ea(E*O));F=ea(L+ea(E*M));E=ea(g[f+8>>2]);L=ea(U+ea(X*E));U=ea(R+ea(S*E));R=ea(F+ea(V*E));E=ea(L*h);F=ea(U*h);Z=ea(R*h);g[u>>2]=ea(0.0);c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;_=ea(-L);$=ea(-U);aa=ea(-R);ba=ea(ea(ea(J*(R>aa?R:aa))+ea(ea(H*(L>_?L:_))+ea(I*(U>$?U:$))))+o);f=w+64|0;c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[w+80>>2]=3;d=w+20|0;c[d+0>>2]=c[s+0>>2];c[d+4>>2]=c[s+4>>2];c[d+8>>2]=c[s+8>>2];ca=w+36|0;g[w+48>>2]=ea(0.0);da=w+52|0;c[da+0>>2]=c[s+0>>2];c[da+4>>2]=c[s+4>>2];c[da+8>>2]=c[s+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];g[w+144>>2]=H;g[w+148>>2]=I;g[w+152>>2]=J;g[w+156>>2]=ea(0.0);$=!(H<=I)?I:H;_=!($<=J)?J:$;$=!(H>=I)?I:H;H=ea(_*ea(.150000006));I=ea((!($>=J)?J:$)*ea(.0299999993));$=H>I?H:I;g[w+16>>2]=_>$?$:_;c[d+0>>2]=c[s+0>>2];c[d+4>>2]=c[s+4>>2];c[d+8>>2]=c[s+8>>2];g[w+32>>2]=ea(_*ea(.0500000007));c[ca+0>>2]=c[q+0>>2];c[ca+4>>2]=c[q+4>>2];c[ca+8>>2]=c[q+8>>2];g[x>>2]=E;ca=x+4|0;g[ca>>2]=F;d=x+8|0;g[d>>2]=Z;f=x+12|0;g[f>>2]=ea(0.0);Z=ea(g[e>>2]);F=ea(g[e+4>>2]);E=ea(g[e+8>>2]);_=ea(g[e+12>>2]);$=ea(g[D>>2]);I=ea(g[D+4>>2]);H=ea(g[D+8>>2]);if(!n)fa=0;else fa=c[n>>2]|0;n=y+64|0;D=y+80|0;e=y+16|0;da=y+20|0;ga=y+32|0;ha=y+36|0;ia=y+48|0;ja=y+52|0;ka=y+4|0;la=y+8|0;ma=y+12|0;na=y+96|0;oa=y+100|0;pa=y+104|0;qa=y+108|0;ra=y+112|0;sa=y+116|0;ta=y+120|0;ua=y+124|0;va=y+128|0;wa=y+132|0;xa=y+136|0;ya=y+140|0;za=A+4|0;Aa=A+8|0;Ba=B+4|0;Ca=B+8|0;J=h;h=ea(0.0);aa=ea(0.0);Da=ea(0.0);Ea=ea(0.0);Fa=ea(0.0);Ga=ea(0.0);Ha=0;Ia=0;Ja=0;while(1){if(!Ha)Ka=fa;else Ka=(Ha|0)==(fa|0)?0:Ha;La=ea(g[b+(Ka*36|0)>>2]);Ma=ea(g[b+(Ka*36|0)+4>>2]);Na=ea(g[b+(Ka*36|0)+8>>2]);Oa=ea(g[b+(Ka*36|0)+12>>2]);Pa=ea(g[b+(Ka*36|0)+16>>2]);Qa=ea(g[b+(Ka*36|0)+20>>2]);Ra=ea(g[b+(Ka*36|0)+24>>2]);Sa=ea(g[b+(Ka*36|0)+28>>2]);Ta=ea(g[b+(Ka*36|0)+32>>2]);Ua=ea(G+ea(ea(ea(N*La)+ea(Q*Ma))+ea(X*Na)));Va=ea(P+ea(ea(ea(Y*La)+ea(O*Ma))+ea(S*Na)));Wa=ea(W+ea(ea(ea(K*La)+ea(M*Ma))+ea(V*Na)));Na=ea(G+ea(ea(ea(N*Oa)+ea(Q*Pa))+ea(X*Qa)));Ma=ea(P+ea(ea(ea(Y*Oa)+ea(O*Pa))+ea(S*Qa)));La=ea(W+ea(ea(ea(K*Oa)+ea(M*Pa))+ea(V*Qa)));Qa=ea(G+ea(ea(ea(N*Ra)+ea(Q*Sa))+ea(X*Ta)));Pa=ea(P+ea(ea(ea(Y*Ra)+ea(O*Sa))+ea(S*Ta)));Oa=ea(W+ea(ea(ea(K*Ra)+ea(M*Sa))+ea(V*Ta)));Ta=ea(Qa-Na);Sa=ea(Pa-Ma);Ra=ea(Oa-La);Xa=ea(Ua-Na);Ya=ea(Va-Ma);Za=ea(Wa-La);_a=ea(ea(Za*Sa)-ea(Ya*Ra));$a=ea(ea(Xa*Ra)-ea(Za*Ta));Za=ea(ea(Ya*Ta)-ea(Xa*Sa));Sa=ea(g[x>>2]);Xa=ea(g[ca>>2]);Ta=ea(ea(ea(g[d>>2])*Za)+ea(ea(Sa*_a)+ea(Xa*$a)));if((!(Ta>=ea(g[u>>2]))?(Ta=ea(ea(R*Wa)+ea(ea(L*Ua)+ea(U*Va))),$a=ea(ea(R*La)+ea(ea(L*Na)+ea(U*Ma))),Xa=ea(ea(R*Oa)+ea(ea(L*Qa)+ea(U*Pa))),_a=$a>Xa?Xa:$a,!((Ta>_a?_a:Ta)>ea(ba+J))):0)?(c[D>>2]=7,g[ia>>2]=ea(0.0),c[ja+0>>2]=c[q+0>>2],c[ja+4>>2]=c[q+4>>2],c[ja+8>>2]=c[q+8>>2],c[r+0>>2]=0,c[r+4>>2]=0,c[r+8>>2]=0,c[r+12>>2]=0,c[n+0>>2]=c[r+0>>2],c[n+4>>2]=c[r+4>>2],c[n+8>>2]=c[r+8>>2],c[n+12>>2]=c[r+12>>2],Ta=ea(ea(ea(Va+Ma)+Pa)*ea(.333332986)),_a=ea(ea(ea(Wa+La)+Oa)*ea(.333332986)),g[y>>2]=ea(ea(ea(Ua+Na)+Qa)*ea(.333332986)),g[ka>>2]=Ta,g[la>>2]=_a,g[ma>>2]=ea(0.0),g[na>>2]=Ua,g[oa>>2]=Va,g[pa>>2]=Wa,g[qa>>2]=ea(0.0),g[ra>>2]=Na,g[sa>>2]=Ma,g[ta>>2]=La,g[ua>>2]=ea(0.0),g[va>>2]=Qa,g[wa>>2]=Pa,g[xa>>2]=Oa,g[ya>>2]=ea(0.0),g[e>>2]=ea(0.0),c[da+0>>2]=c[s+0>>2],c[da+4>>2]=c[s+4>>2],c[da+8>>2]=c[s+8>>2],g[ga>>2]=ea(3402823469999999843913219.0e14),c[ha+0>>2]=c[t+0>>2],c[ha+4>>2]=c[t+4>>2],c[ha+8>>2]=c[t+8>>2],APa(y,w,u,v,x,z,B,A,o,0)|0):0){Oa=ea(g[u>>2]);Pa=ea(g[z>>2]);if(Oa>=Pa){ab=12;break}Oa=ea(J*Pa);Pa=ea(U*Oa);Qa=ea(R*Oa);g[x>>2]=ea(L*Oa);g[ca>>2]=Pa;g[d>>2]=Qa;g[f>>2]=ea(0.0);Qa=ea(g[A>>2]);Pa=ea(g[za>>2]);La=ea(g[Aa>>2]);Ma=ea(g[B>>2]);Na=ea(g[Ba>>2]);bb=Ma;cb=Na;db=ea(g[Ca>>2]);eb=Qa;fb=Pa;gb=La;hb=Oa;ib=Ka;jb=1}else{bb=h;cb=aa;db=Da;eb=Ea;fb=Fa;gb=Ga;hb=J;ib=Ia;jb=Ja}Ha=Ha+1|0;if(Ha>>>0>=a>>>0)break;else{J=hb;h=bb;aa=cb;Da=db;Ea=eb;Fa=fb;Ga=gb;Ia=ib;Ja=jb}}if((ab|0)==12){Ga=ea(g[B>>2]);Fa=ea(g[Ba>>2]);Ea=ea(g[Ca>>2]);Da=ea(ea(_*_)+ea(-.5));aa=ea(ea(ea(Z*Ga)+ea(F*Fa))+ea(E*Ea));h=ea(ea(ea(Z*aa)+ea(ea(Da*Ga)+ea(_*ea(ea(F*Ea)-ea(E*Fa)))))*ea(2.0));J=ea(ea(ea(F*aa)+ea(ea(Da*Fa)+ea(_*ea(ea(E*Ga)-ea(Z*Ea)))))*ea(2.0));L=ea(ea(ea(ea(Da*Ea)+ea(_*ea(ea(Z*Fa)-ea(F*Ga))))+ea(E*aa))*ea(2.0));aa=ea(ea(1.0)/ea(T(ea(ea(L*L)+ea(ea(h*h)+ea(J*J))))));Ga=ea(-ea(aa*h));h=ea(-ea(aa*J));J=ea(-ea(aa*L));L=ea(g[A>>2]);aa=ea(g[za>>2]);Fa=ea(g[Aa>>2]);Ea=ea(ea(ea(Z*L)+ea(F*aa))+ea(E*Fa));R=ea($+ea(ea(ea(Z*Ea)+ea(ea(Da*L)+ea(_*ea(ea(F*Fa)-ea(E*aa)))))*ea(2.0)));U=ea(I+ea(ea(ea(F*Ea)+ea(ea(Da*aa)+ea(_*ea(ea(E*L)-ea(Z*Fa)))))*ea(2.0)));o=ea(H+ea(ea(ea(ea(Da*Fa)+ea(_*ea(ea(Z*aa)-ea(F*L))))+ea(E*Ea))*ea(2.0)));g[l>>2]=ea(0.0);c[m>>2]=Ka;g[k>>2]=Ga;g[k+4>>2]=h;g[k+8>>2]=J;g[j>>2]=R;g[j+4>>2]=U;g[j+8>>2]=o;C=1;i=p;return C|0}if(!jb){C=0;i=p;return C|0}c[m>>2]=ib;o=ea(ea(_*_)+ea(-.5));U=ea(ea(E*db)+ea(ea(F*cb)+ea(Z*bb)));R=ea(ea(ea(ea(o*bb)+ea(_*ea(ea(F*db)-ea(E*cb))))+ea(Z*U))*ea(2.0));J=ea(ea(ea(F*U)+ea(ea(o*cb)+ea(_*ea(ea(E*bb)-ea(Z*db)))))*ea(2.0));h=ea(ea(ea(ea(o*db)+ea(_*ea(ea(Z*cb)-ea(F*bb))))+ea(E*U))*ea(2.0));U=ea(ea(1.0)/ea(T(ea(ea(h*h)+ea(ea(R*R)+ea(J*J))))));bb=ea(-ea(J*U));J=ea(-ea(h*U));h=ea(ea(E*gb)+ea(ea(F*fb)+ea(Z*eb)));cb=ea($+ea(ea(ea(ea(o*eb)+ea(_*ea(ea(F*gb)-ea(E*fb))))+ea(Z*h))*ea(2.0)));$=ea(I+ea(ea(ea(F*h)+ea(ea(o*fb)+ea(_*ea(ea(E*eb)-ea(Z*gb)))))*ea(2.0)));I=ea(H+ea(ea(ea(ea(o*gb)+ea(_*ea(ea(Z*fb)-ea(F*eb))))+ea(E*h))*ea(2.0)));g[k>>2]=ea(-ea(R*U));g[k+4>>2]=bb;g[k+8>>2]=J;g[j>>2]=cb;g[j+4>>2]=$;g[j+8>>2]=I;g[l>>2]=hb;C=1;i=p;return C|0}function MNa(){return 539312}function NNa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0;j=i;i=i+1104|0;l=j+1024|0;m=j+1e3|0;n=j+972|0;o=j+72|0;p=j+12|0;q=j;r=d+4|0;if(ea(g[r>>2])==ea(1.0)?ea(g[d+8>>2])==ea(1.0):0)s=ea(g[d+12>>2])==ea(1.0);else s=0;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);g[l+16>>2]=ea(1.0);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(0.0);g[l+28>>2]=ea(0.0);g[l+32>>2]=ea(1.0);g[l+36>>2]=ea(1.0);g[l+40>>2]=ea(0.0);g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);g[l+52>>2]=ea(1.0);g[l+56>>2]=ea(0.0);g[l+60>>2]=ea(0.0);g[l+64>>2]=ea(0.0);g[l+68>>2]=ea(1.0);if(!s)J0a(l,r,d+16|0);t=ea(g[e>>2]);u=ea(t*ea(2.0));v=ea(g[e+12>>2]);w=ea(v*ea(2.0));x=ea(ea(t*u)+ea(ea(v*w)+ea(-1.0)));v=ea(g[e+8>>2]);t=ea(v*w);y=ea(g[e+4>>2]);z=ea(t+ea(u*y));t=ea(ea(u*v)-ea(w*y));y=ea(g[b+8>>2]);w=ea(y*x);x=ea(y*z);z=ea(y*t);t=ea(g[e+16>>2]);y=ea(t+w);v=ea(g[e+20>>2]);u=ea(v+x);A=ea(g[e+24>>2]);B=ea(z+A);C=ea(t-w);w=ea(v-x);x=ea(A-z);e=b+4|0;z=ea(g[e>>2]);A=ea(z+ea(g[h>>2]));z=ea(g[f+16>>2]);v=ea(y-z);y=ea(g[f+20>>2]);t=ea(u-y);u=ea(g[f+24>>2]);D=ea(v*ea(2.0));v=ea(t*ea(2.0));t=ea(ea(B-u)*ea(2.0));B=ea(g[f+12>>2]);E=ea(ea(B*B)+ea(-.5));F=ea(g[f>>2]);G=ea(D*F);H=ea(g[f+4>>2]);I=ea(G+ea(v*H));G=ea(g[f+8>>2]);J=ea(I+ea(t*G));I=ea(ea(F*J)+ea(ea(D*E)-ea(B*ea(ea(t*H)-ea(v*G)))));K=ea(ea(H*J)+ea(ea(v*E)-ea(B*ea(ea(D*G)-ea(t*F)))));L=ea(ea(ea(t*E)-ea(B*ea(ea(v*F)-ea(D*H))))+ea(G*J));J=ea(ea(C-z)*ea(2.0));z=ea(ea(w-y)*ea(2.0));y=ea(ea(x-u)*ea(2.0));u=ea(ea(ea(J*F)+ea(z*H))+ea(y*G));x=ea(ea(F*u)+ea(ea(J*E)-ea(B*ea(ea(y*H)-ea(z*G)))));w=ea(ea(H*u)+ea(ea(z*E)-ea(B*ea(ea(J*G)-ea(y*F)))));C=ea(ea(ea(y*E)-ea(B*ea(ea(z*F)-ea(J*H))))+ea(G*u));g[m>>2]=I;g[m+4>>2]=K;g[m+8>>2]=L;g[m+12>>2]=x;g[m+16>>2]=w;g[m+20>>2]=C;g[n>>2]=I;g[n+4>>2]=K;g[n+8>>2]=L;g[n+12>>2]=x;g[n+16>>2]=w;g[n+20>>2]=C;g[n+24>>2]=A;b=c[d+40>>2]|0;C=ea(g[h>>2]);w=ea(g[e>>2]);c[o+4>>2]=2;c[o>>2]=539504;c[o+8>>2]=k;c[o+12>>2]=f;c[o+16>>2]=m;g[o+20>>2]=A;g[o+24>>2]=C;g[o+28>>2]=w;c[o+32>>2]=d;c[o+36>>2]=l;a[o+40>>0]=s&1;d=o+892|0;c[d>>2]=0;c[o+896>>2]=b;RKa(p,n);if(!s)x6a(l,p+36|0,p+48|0,p);c[q>>2]=c[b+16>>2];c[q+4>>2]=b+32;g[q+8>>2]=ea(g[b+20>>2]);vQa(p,1,q,o,1);if(!(c[d>>2]|0)){M=k+4096|0;N=c[M>>2]|0;O=(N|0)!=0;i=j;return O|0}y6a(o+8|0,o+44|0)|0;c[d>>2]=0;M=k+4096|0;N=c[M>>2]|0;O=(N|0)!=0;i=j;return O|0}function ONa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=0,x=0,y=Im,z=Im,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=Im,L=0,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=0,T=Im,U=Im,V=Im;h=i;i=i+160|0;k=h+136|0;l=h+112|0;m=h+80|0;n=h+56|0;o=h+32|0;p=h;q=ea(g[d>>2]);r=ea(q*ea(2.0));s=d+12|0;t=ea(g[s>>2]);u=ea(t*ea(2.0));v=ea(ea(q*r)+ea(ea(t*u)+ea(-1.0)));w=d+8|0;t=ea(g[w>>2]);q=ea(t*u);x=d+4|0;y=ea(g[x>>2]);z=ea(q+ea(r*y));q=ea(ea(r*t)-ea(u*y));A=a+8|0;y=ea(g[A>>2]);u=ea(y*v);v=ea(y*z);z=ea(y*q);B=d+16|0;q=ea(g[B>>2]);y=ea(q+u);C=d+20|0;t=ea(g[C>>2]);r=ea(t+v);D=d+24|0;E=ea(g[D>>2]);F=ea(z+E);G=ea(q-u);u=ea(t-v);v=ea(E-z);H=a+4|0;z=ea(g[H>>2]);E=ea(z+ea(g[f>>2]));a=e+16|0;z=ea(g[a>>2]);t=ea(y-z);I=e+20|0;y=ea(g[I>>2]);q=ea(r-y);J=e+24|0;r=ea(g[J>>2]);K=ea(t*ea(2.0));t=ea(q*ea(2.0));q=ea(ea(F-r)*ea(2.0));L=e+12|0;F=ea(g[L>>2]);M=ea(ea(F*F)+ea(-.5));N=ea(g[e>>2]);O=ea(K*N);P=e+4|0;Q=ea(g[P>>2]);R=ea(O+ea(t*Q));S=e+8|0;O=ea(g[S>>2]);T=ea(R+ea(q*O));R=ea(ea(Q*T)+ea(ea(t*M)-ea(F*ea(ea(K*O)-ea(q*N)))));U=ea(ea(ea(q*M)-ea(F*ea(ea(t*N)-ea(K*Q))))+ea(O*T));V=ea(ea(G-z)*ea(2.0));z=ea(ea(u-y)*ea(2.0));y=ea(ea(v-r)*ea(2.0));r=ea(ea(ea(V*N)+ea(z*Q))+ea(y*O));v=ea(ea(N*r)+ea(ea(V*M)-ea(F*ea(ea(y*Q)-ea(z*O)))));u=ea(ea(Q*r)+ea(ea(z*M)-ea(F*ea(ea(V*O)-ea(y*N)))));G=ea(ea(ea(y*M)-ea(F*ea(ea(z*N)-ea(V*Q))))+ea(O*r));g[k>>2]=ea(ea(N*T)+ea(ea(K*M)-ea(F*ea(ea(q*Q)-ea(t*O)))));g[k+4>>2]=R;g[k+8>>2]=U;g[k+12>>2]=v;g[k+16>>2]=u;g[k+20>>2]=G;c[l+12>>2]=c[b+4>>2];c[l+16>>2]=b;g[l+4>>2]=ea(ea(1.0)/ea(g[b+8>>2]));g[l>>2]=ea(ea(1.0)/ea(g[b+12>>2]));g[l+8>>2]=ea(ea(1.0)/ea(g[b+16>>2]));G=ea(g[f>>2]);u=ea(g[H>>2]);c[m>>2]=539464;c[m+4>>2]=j;c[m+8>>2]=e;c[m+12>>2]=k;g[m+16>>2]=E;g[m+20>>2]=G;g[m+24>>2]=u;c[m+28>>2]=l;u=ea(E+ea(g[A>>2]));A=n+12|0;g[A>>2]=u;k=n+16|0;g[k>>2]=E;H=n+20|0;g[H>>2]=E;G=ea(-E);g[n>>2]=ea(-u);f=n+4|0;g[f>>2]=G;b=n+8|0;g[b>>2]=G;G=ea(-ea(g[e>>2]));u=ea(-ea(g[P>>2]));E=ea(-ea(g[S>>2]));v=ea(g[L>>2]);U=ea(g[B>>2]);R=ea(U-ea(g[a>>2]));U=ea(g[C>>2]);O=ea(U-ea(g[I>>2]));U=ea(g[D>>2]);t=ea(R*ea(2.0));R=ea(O*ea(2.0));O=ea(ea(U-ea(g[J>>2]))*ea(2.0));U=ea(ea(v*v)+ea(-.5));Q=ea(ea(ea(t*G)+ea(R*u))+ea(O*E));q=ea(ea(Q*G)+ea(ea(U*t)+ea(v*ea(ea(O*u)-ea(R*E)))));F=ea(ea(Q*u)+ea(ea(U*R)+ea(v*ea(ea(t*E)-ea(O*G)))));M=ea(ea(ea(U*O)+ea(v*ea(ea(R*G)-ea(t*u))))+ea(Q*E));Q=ea(g[d>>2]);t=ea(v*Q);R=ea(g[s>>2]);O=ea(t+ea(R*G));t=ea(g[w>>2]);U=ea(O+ea(t*u));O=ea(g[x>>2]);K=ea(ea(ea(Q*E)+ea(ea(R*u)+ea(v*O)))-ea(t*G));T=ea(ea(ea(O*G)+ea(ea(R*E)+ea(v*t)))-ea(Q*u));N=ea(ea(ea(ea(v*R)-ea(Q*G))-ea(O*u))-ea(t*E));g[p>>2]=ea(U-ea(O*E));g[p+4>>2]=K;g[p+8>>2]=T;g[p+12>>2]=N;g[p+16>>2]=q;g[p+20>>2]=F;g[p+24>>2]=M;e_a(o,p,n);g[n>>2]=ea(g[o>>2]);g[f>>2]=ea(g[o+4>>2]);g[b>>2]=ea(g[o+8>>2]);g[A>>2]=ea(g[o+12>>2]);g[k>>2]=ea(g[o+16>>2]);g[H>>2]=ea(g[o+20>>2]);KRa(l,e,n,0,m)|0;i=h;return (c[j+4096>>2]|0)!=0|0}function PNa(b,d,e,f,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;o=ea(o);p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=0,U=0;s=i;c[b>>2]=d;c[b+1284>>2]=0;t=b+1156|0;u=t+128|0;do{a[t>>0]=255;t=t+1|0}while((t|0)<(u|0));c[b+2056>>2]=0;t=b+1928|0;u=t+128|0;do{a[t>>0]=255;t=t+1|0}while((t|0)<(u|0));v=ea(g[e>>2]);w=ea(v+v);x=ea(g[e+4>>2]);y=ea(x+x);z=ea(g[e+8>>2]);A=ea(z+z);B=ea(g[e+12>>2]);C=ea(w*B);D=ea(y*B);E=ea(B*A);B=ea(v*w);w=ea(v*y);F=ea(v*A);v=ea(x*y);y=ea(x*A);x=ea(z*A);t=b+2060|0;g[t>>2]=ea(ea(ea(1.0)-v)-x);u=b+2064|0;g[u>>2]=ea(w+E);G=b+2068|0;g[G>>2]=ea(F-D);H=b+2072|0;g[H>>2]=ea(w-E);E=ea(ea(1.0)-B);I=b+2076|0;g[I>>2]=ea(E-x);J=b+2080|0;g[J>>2]=ea(y+C);K=b+2084|0;g[K>>2]=ea(F+D);L=b+2088|0;g[L>>2]=ea(y-C);M=b+2092|0;g[M>>2]=ea(E-v);N=b+2096|0;g[N>>2]=ea(0.0);O=b+2100|0;g[O>>2]=ea(0.0);P=b+2104|0;g[P>>2]=ea(0.0);v=ea(g[e+16>>2]);g[N>>2]=v;E=ea(g[e+20>>2]);g[O>>2]=E;C=ea(g[e+24>>2]);g[P>>2]=C;y=ea(g[f>>2]);D=ea(y+y);F=ea(g[f+4>>2]);x=ea(F+F);B=ea(g[f+8>>2]);w=ea(B+B);A=ea(g[f+12>>2]);z=ea(D*A);Q=ea(x*A);R=ea(A*w);A=ea(y*D);D=ea(y*x);S=ea(y*w);y=ea(F*x);x=ea(F*w);F=ea(B*w);g[b+2108>>2]=ea(ea(ea(1.0)-y)-F);g[b+2112>>2]=ea(D+R);g[b+2116>>2]=ea(S-Q);g[b+2120>>2]=ea(D-R);R=ea(ea(1.0)-A);g[b+2124>>2]=ea(R-F);g[b+2128>>2]=ea(x+z);g[b+2132>>2]=ea(S+Q);g[b+2136>>2]=ea(x-z);g[b+2140>>2]=ea(R-y);P=b+2144|0;g[P>>2]=ea(0.0);e=b+2148|0;g[e>>2]=ea(0.0);O=b+2152|0;g[O>>2]=ea(0.0);g[P>>2]=ea(g[f+16>>2]);g[e>>2]=ea(g[f+20>>2]);g[O>>2]=ea(g[f+24>>2]);f=b+2180|0;c[f>>2]=h;O=b+2184|0;c[O>>2]=j;c[b+2188>>2]=k;c[b+2192>>2]=l;g[b+2196>>2]=m;a[b+2201>>0]=n&1;g[b+2204>>2]=o;c[b+2208>>2]=p;c[b+2212>>2]=q;c[b+2216>>2]=r;r=d+4|0;if(!(c[r>>2]|0)){T=h;U=j}else{c[r>>2]=0;T=c[f>>2]|0;U=c[O>>2]|0}a[b+2220>>0]=0;o=ea(g[T>>2]);m=ea(o*ea(g[t>>2]));y=ea(o*ea(g[u>>2]));R=ea(o*ea(g[G>>2]));G=T+4|0;o=ea(g[G>>2]);z=ea(o*ea(g[H>>2]));x=ea(o*ea(g[I>>2]));Q=ea(m+z);z=ea(y+x);x=ea(R+ea(o*ea(g[J>>2])));J=T+8|0;o=ea(g[J>>2]);R=ea(o*ea(g[K>>2]));y=ea(o*ea(g[L>>2]));m=ea(ea(z+y)+E);E=ea(ea(x+ea(o*ea(g[M>>2])))+C);g[b+2156>>2]=ea(ea(Q+R)+v);g[b+2160>>2]=m;g[b+2164>>2]=E;E=ea(g[T>>2]);m=ea(E*ea(g[U>>2]));v=ea(E*ea(g[U+4>>2]));R=ea(E*ea(g[U+8>>2]));E=ea(g[G>>2]);Q=ea(E*ea(g[U+12>>2]));C=ea(E*ea(g[U+16>>2]));o=ea(m+Q);Q=ea(v+C);C=ea(R+ea(E*ea(g[U+20>>2])));E=ea(g[J>>2]);R=ea(E*ea(g[U+24>>2]));v=ea(E*ea(g[U+28>>2]));m=ea(o+R);R=ea(Q+v);v=ea(C+ea(E*ea(g[U+32>>2])));E=ea(m+ea(g[U+36>>2]));m=ea(R+ea(g[U+40>>2]));R=ea(v+ea(g[U+44>>2]));g[b+2168>>2]=E;g[b+2172>>2]=m;g[b+2176>>2]=R;i=s;return}function QNa(b,f,h,j,l,m,n){b=b|0;f=f|0;h=h|0;j=j|0;l=l|0;m=ea(m);n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0;o=i;i=i+304|0;p=o+12|0;q=o+64|0;r=o+184|0;s=o;t=o+172|0;u=o+200|0;v=o+248|0;w=o+88|0;x=o+80|0;y=o+24|0;z=o+28|0;A=o+136|0;B=b+2188|0;C=c[B>>2]|0;D=ea(g[j>>2]);E=ea(D*ea(g[C>>2]));F=ea(D*ea(g[C+4>>2]));G=ea(D*ea(g[C+8>>2]));D=ea(g[j+4>>2]);H=ea(D*ea(g[C+12>>2]));I=ea(D*ea(g[C+16>>2]));J=ea(E+H);H=ea(F+I);I=ea(G+ea(D*ea(g[C+20>>2])));D=ea(g[j+8>>2]);G=ea(D*ea(g[C+24>>2]));F=ea(D*ea(g[C+28>>2]));E=ea(J+G);G=ea(H+F);F=ea(I+ea(D*ea(g[C+32>>2])));D=ea(E+ea(g[C+36>>2]));E=ea(G+ea(g[C+40>>2]));G=ea(F+ea(g[C+44>>2]));F=ea(ea(g[b+2168>>2])-D);D=ea(ea(g[b+2172>>2])-E);E=ea(ea(g[b+2176>>2])-G);G=ea(g[l>>2]);I=ea(F*G);C=l+4|0;F=ea(g[C>>2]);H=ea(I+ea(D*F));j=l+8|0;D=ea(g[j>>2]);if(ea(H+ea(E*D))<ea(0.0)){E=ea(-G);H=ea(-F);I=ea(-D);g[l>>2]=E;g[C>>2]=H;g[j>>2]=I;K=E;L=H;M=I}else{K=G;L=F;M=D}N=b+2180|0;O=c[N>>2]|0;P=c[O+68>>2]|0;Q=b+2192|0;R=c[Q>>2]|0;U=b+2184|0;V=c[U>>2]|0;D=ea(-K);K=ea(-L);L=ea(-M);M=ea(ea(g[V>>2])*D);F=ea(M+ea(ea(g[V+4>>2])*K));M=ea(F+ea(ea(g[V+8>>2])*L));F=ea(ea(g[V+12>>2])*D);G=ea(F+ea(ea(g[V+16>>2])*K));F=ea(G+ea(ea(g[V+20>>2])*L));G=ea(ea(g[V+24>>2])*D);D=ea(G+ea(ea(g[V+28>>2])*K));K=ea(D+ea(ea(g[V+32>>2])*L));g[p>>2]=M;g[p+4>>2]=F;g[p+8>>2]=K;V=xo[P&2047](O,R,p)|0;p=c[(c[N>>2]|0)+24>>2]|0;R=p+(V*20|0)|0;O=b+2201|0;if(!(a[O>>0]|0)){P=c[Q>>2]|0;K=ea(g[p+(V*20|0)+12>>2]);F=ea(g[P+36>>2]);M=ea(g[R>>2]);L=ea(F*M);F=ea(g[P+40>>2]);D=ea(g[p+(V*20|0)+4>>2]);G=ea(L+ea(F*D));F=ea(g[P+44>>2]);L=ea(g[p+(V*20|0)+8>>2]);I=ea(G+ea(F*L));F=ea(M*ea(g[P+48>>2]));G=ea(F+ea(D*ea(g[P+52>>2])));F=ea(G+ea(L*ea(g[P+56>>2])));G=ea(M*ea(g[P+60>>2]));M=ea(G+ea(D*ea(g[P+64>>2])));D=ea(M+ea(L*ea(g[P+68>>2])));L=ea(ea(1.0)/ea(T(ea(ea(ea(I*I)+ea(F*F))+ea(D*D)))));M=ea(I*L);I=ea(F*L);F=ea(D*L);g[q>>2]=M;g[q+4>>2]=I;g[q+8>>2]=F;g[q+12>>2]=ea(K*L);W=M;X=I;Y=F}else{P=c[R>>2]|0;c[q>>2]=P;R=c[p+(V*20|0)+4>>2]|0;c[q+4>>2]=R;Z=c[p+(V*20|0)+8>>2]|0;c[q+8>>2]=Z;c[q+12>>2]=c[p+(V*20|0)+12>>2];F=(c[k>>2]=P,ea(g[k>>2]));I=(c[k>>2]=R,ea(g[k>>2]));W=F;X=I;Y=(c[k>>2]=Z,ea(g[k>>2]))}Z=c[U>>2]|0;I=ea(W*ea(g[Z>>2]));F=ea(W*ea(g[Z+4>>2]));M=ea(W*ea(g[Z+8>>2]));W=ea(X*ea(g[Z+12>>2]));L=ea(X*ea(g[Z+16>>2]));K=ea(I+W);W=ea(F+L);L=ea(M+ea(X*ea(g[Z+20>>2])));X=ea(Y*ea(g[Z+24>>2]));M=ea(Y*ea(g[Z+28>>2]));F=ea(K+X);X=ea(W+M);M=ea(L+ea(Y*ea(g[Z+32>>2])));g[r>>2]=F;g[r+4>>2]=X;g[r+8>>2]=M;Y=ea(g[l>>2]);L=ea(F*Y);F=ea(g[C>>2]);W=ea(L+ea(X*F));X=ea(g[j>>2]);L=ea(S(ea(W+ea(M*X))));j=c[B>>2]|0;M=ea(g[f>>2]);W=ea(M*ea(g[j>>2]));K=ea(M*ea(g[j+4>>2]));I=ea(M*ea(g[j+8>>2]));M=ea(g[f+4>>2]);D=ea(M*ea(g[j+12>>2]));G=ea(M*ea(g[j+16>>2]));H=ea(W+D);D=ea(K+G);G=ea(I+ea(M*ea(g[j+20>>2])));M=ea(g[f+8>>2]);I=ea(M*ea(g[j+24>>2]));K=ea(M*ea(g[j+28>>2]));W=ea(H+I);I=ea(D+K);K=ea(G+ea(M*ea(g[j+32>>2])));g[s>>2]=W;g[s+4>>2]=I;g[s+8>>2]=K;j=L>ea(S(ea(ea(ea(W*Y)+ea(I*F))+ea(K*X))));K=ea(-m);C=m<=ea(-0.0);m=C?K:ea(0.0);K=ea(m+ea(g[b+2204>>2]));m=ea(Y*K);Y=ea(F*K);F=ea(X*K);g[t>>2]=m;g[t+4>>2]=Y;g[t+8>>2]=F;C=c[U>>2]|0;g[u>>2]=ea(g[C>>2]);g[u+4>>2]=ea(g[C+4>>2]);g[u+8>>2]=ea(g[C+8>>2]);g[u+12>>2]=ea(g[C+12>>2]);g[u+16>>2]=ea(g[C+16>>2]);g[u+20>>2]=ea(g[C+20>>2]);g[u+24>>2]=ea(g[C+24>>2]);g[u+28>>2]=ea(g[C+28>>2]);g[u+32>>2]=ea(g[C+32>>2]);X=ea(g[C+36>>2]);U=u+36|0;g[U>>2]=X;I=ea(g[C+40>>2]);l=u+40|0;g[l>>2]=I;W=ea(g[C+44>>2]);C=u+44|0;g[C>>2]=W;Z=c[b+2208>>2]|0;L=ea(g[Z>>2]);M=ea(g[Z+4>>2]);G=ea(g[Z+8>>2]);D=ea(g[Z+12>>2]);H=ea(X-m);g[U>>2]=H;m=ea(I-Y);g[l>>2]=m;Y=ea(W-F);g[C>>2]=Y;C=c[b+2212>>2]|0;F=ea(g[C>>2]);W=ea(-F);I=ea(g[C+4>>2]);X=ea(-I);E=ea(g[C+8>>2]);J=ea(-E);_=ea(g[C+12>>2]);$=ea(g[C+16>>2]);aa=ea(H-$);ba=ea(g[C+20>>2]);ca=ea(m-ba);da=ea(g[C+24>>2]);fa=ea(aa*ea(2.0));aa=ea(ca*ea(2.0));ca=ea(ea(Y-da)*ea(2.0));ga=ea(ea(_*_)+ea(-.5));ha=ea(ea(ea(fa*W)+ea(aa*X))+ea(ca*J));ia=ea(ea(ha*W)+ea(ea(ga*fa)+ea(_*ea(ea(ca*X)-ea(aa*J)))));ja=ea(ea(ha*X)+ea(ea(ga*aa)+ea(_*ea(ea(fa*J)-ea(ca*W)))));ka=ea(ea(ea(ga*ca)+ea(_*ea(ea(aa*W)-ea(fa*X))))+ea(ha*J));ha=ea(ea(ea(G*X)+ea(ea(D*W)+ea(L*_)))-ea(M*J));fa=ea(ea(ea(L*J)+ea(ea(D*X)+ea(M*_)))-ea(G*W));aa=ea(ea(ea(M*W)+ea(ea(D*J)+ea(G*_)))-ea(L*X));ca=ea(D*_);ga=ea(ea(ea(ca-ea(L*W))-ea(M*X))-ea(G*J));J=ea(-L);L=ea(-M);M=ea(-G);G=ea(ea($-H)*ea(2.0));H=ea(ea(ba-m)*ea(2.0));m=ea(ea(da-Y)*ea(2.0));Y=ea(ea(D*D)+ea(-.5));da=ea(ea(ea(G*J)+ea(H*L))+ea(m*M));ba=ea(ea(da*J)+ea(ea(Y*G)+ea(D*ea(ea(m*L)-ea(H*M)))));$=ea(ea(da*L)+ea(ea(Y*H)+ea(D*ea(ea(G*M)-ea(m*J)))));X=ea(ea(ea(Y*m)+ea(D*ea(ea(H*J)-ea(G*L))))+ea(da*M));da=ea(ea(ea(E*L)+ea(ea(D*F)+ea(_*J)))-ea(I*M));G=ea(ea(ea(F*M)+ea(ea(D*I)+ea(_*L)))-ea(E*J));H=ea(ea(ea(I*J)+ea(ea(D*E)+ea(_*M)))-ea(F*L));_=ea(ea(ea(ca-ea(F*J))-ea(I*L))-ea(E*M));M=ea(ha+ha);E=ea(fa+fa);L=ea(aa+aa);I=ea(ga*M);J=ea(ga*E);F=ea(ga*L);ga=ea(ha*M);M=ea(ha*E);ca=ea(ha*L);ha=ea(fa*E);E=ea(fa*L);fa=ea(aa*L);g[v>>2]=ea(ea(ea(1.0)-ha)-fa);g[v+4>>2]=ea(M+F);g[v+8>>2]=ea(ca-J);g[v+12>>2]=ea(M-F);F=ea(ea(1.0)-ga);g[v+16>>2]=ea(F-fa);g[v+20>>2]=ea(E+I);g[v+24>>2]=ea(ca+J);g[v+28>>2]=ea(E-I);g[v+32>>2]=ea(F-ha);g[v+36>>2]=ia;g[v+40>>2]=ja;g[v+44>>2]=ka;ka=ea(da+da);ja=ea(G+G);ia=ea(H+H);ha=ea(_*ka);F=ea(_*ja);I=ea(_*ia);_=ea(da*ka);ka=ea(da*ja);E=ea(da*ia);da=ea(G*ja);ja=ea(G*ia);G=ea(H*ia);g[w>>2]=ea(ea(ea(1.0)-da)-G);g[w+4>>2]=ea(ka+I);g[w+8>>2]=ea(E-F);g[w+12>>2]=ea(ka-I);I=ea(ea(1.0)-_);g[w+16>>2]=ea(I-G);g[w+20>>2]=ea(ja+ha);g[w+24>>2]=ea(E+F);g[w+28>>2]=ea(ja-ha);g[w+32>>2]=ea(I-da);g[w+36>>2]=ba;g[w+40>>2]=$;g[w+44>>2]=X;C=a[O>>0]|0;O=p+(V*20|0)+18|0;if(!(C<<24>>24)){l=a[O>>0]|0;U=i;i=i+((1*((l&255)*12|0)|0)+15&-16)|0;Z=i;i=i+((1*(l&255)|0)+15&-16)|0;la=U;ma=Z}else{la=0;ma=0}Z=c[N>>2]|0;iOa(x,y,la,ma,C<<24>>24!=0,c[Z+28>>2]|0,(c[Z+32>>2]|0)+(e[p+(V*20|0)+16>>1]|0)|0,d[O>>0]|0,c[Q>>2]|0);XNa(z,q);XNa(A,f);if(j){if(YNa(d[O>>0]|0,c[x>>2]|0,c[y>>2]|0,u,q,z,3,h,539520,c[B>>2]|0,f,A,r,v,w,-1,n,c[b+2216>>2]|0,1,t,K)|0){na=1;i=o;return na|0}}else if(YNa(3,h,539520,c[B>>2]|0,f,A,d[O>>0]|0,c[x>>2]|0,c[y>>2]|0,u,q,z,s,w,v,-1,n,c[b+2216>>2]|0,0,t,K)|0){na=1;i=o;return na|0}na=0;i=o;return na|0}function RNa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=0,C=Im,D=0,E=Im,F=Im,G=0,H=Im,I=Im,J=0,K=Im,L=Im,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0;j=i;i=i+80|0;k=j+56|0;l=j+32|0;m=j+20|0;n=j+16|0;o=j+72|0;p=j;q=j+48|0;r=j+8|0;s=d+12|0;t=ea(g[s>>2]);u=ea(g[d>>2]);v=ea(t-u);w=d+16|0;x=ea(g[w>>2]);y=d+4|0;z=ea(g[y>>2]);A=ea(x-z);B=d+20|0;C=ea(g[B>>2]);D=d+8|0;E=ea(g[D>>2]);F=ea(C-E);G=d+24|0;H=ea(g[G>>2]);I=ea(H-u);J=d+28|0;K=ea(g[J>>2]);L=ea(K-z);M=d+32|0;N=ea(g[M>>2]);O=ea(N-E);P=ea(ea(A*O)-ea(F*L));Q=ea(ea(F*I)-ea(v*O));O=ea(ea(v*L)-ea(A*I));I=ea(ea(O*O)+ea(ea(P*P)+ea(Q*Q)));if(I>ea(0.0)){A=ea(ea(1.0)/ea(T(ea(I))));R=ea(P*A);S=ea(Q*A);U=ea(O*A)}else{R=ea(0.0);S=ea(0.0);U=ea(0.0)}g[k>>2]=R;g[k+4>>2]=S;g[k+8>>2]=U;A=ea(ea(ea(R*u)+ea(S*z))+ea(U*E));g[k+12>>2]=ea(-A);O=ea(ea(g[b+2156>>2])*R);R=ea(O+ea(ea(g[b+2160>>2])*S));if(ea(ea(R+ea(ea(g[b+2164>>2])*U))-A)<ea(0.0)){V=0;i=j;return V|0}A=ea(ea(ea(u+t)+H)*ea(.333333343));H=ea(ea(ea(z+x)+K)*ea(.333333343));K=ea(ea(ea(E+C)+N)*ea(.333333343));g[l>>2]=A;g[l+4>>2]=H;g[l+8>>2]=K;W=b+2108|0;N=ea(A*ea(g[W>>2]));C=ea(A*ea(g[b+2112>>2]));E=ea(A*ea(g[b+2116>>2]));A=ea(H*ea(g[b+2120>>2]));x=ea(H*ea(g[b+2124>>2]));z=ea(N+A);A=ea(C+x);x=ea(E+ea(H*ea(g[b+2128>>2])));H=ea(K*ea(g[b+2132>>2]));E=ea(K*ea(g[b+2136>>2]));C=ea(z+H);H=ea(A+E);E=ea(x+ea(K*ea(g[b+2140>>2])));K=ea(C+ea(g[b+2144>>2]));C=ea(H+ea(g[b+2148>>2]));H=ea(E+ea(g[b+2152>>2]));E=ea(g[b+2196>>2]);if(!(z6a(c[b+2180>>2]|0,f,d,k,K,C,H,c[b+2188>>2]|0,b+2060|0,W,c[b+2192>>2]|0,E,m,n,o,(a[b+2201>>0]|0)!=0)|0)){V=0;i=j;return V|0}if(!(a[o>>0]|0)){o=c[b>>2]|0;W=o+4|0;f=c[W>>2]|0;if((f+17|0)>>>0>(c[o>>2]|0)>>>0){gLa(o,17)|0;X=c[W>>2]|0}else X=f;f=c[o+8>>2]|0;c[W>>2]=X+17;c[f+(X<<2)>>2]=e;g[f+(X+1<<2)>>2]=ea(g[d>>2]);g[f+(X+2<<2)>>2]=ea(g[y>>2]);g[f+(X+3<<2)>>2]=ea(g[D>>2]);g[f+(X+4<<2)>>2]=ea(g[s>>2]);g[f+(X+5<<2)>>2]=ea(g[w>>2]);g[f+(X+6<<2)>>2]=ea(g[B>>2]);g[f+(X+7<<2)>>2]=ea(g[G>>2]);g[f+(X+8<<2)>>2]=ea(g[J>>2]);g[f+(X+9<<2)>>2]=ea(g[M>>2]);c[f+(X+10<<2)>>2]=c[h>>2];c[f+(X+11<<2)>>2]=c[h+4>>2];c[f+(X+12<<2)>>2]=c[h+8>>2];g[f+(X+13<<2)>>2]=ea(g[m>>2]);g[f+(X+14<<2)>>2]=ea(g[m+4>>2]);g[f+(X+15<<2)>>2]=ea(g[m+8>>2]);g[f+(X+16<<2)>>2]=ea(g[n>>2]);V=1;i=j;return V|0}if(!(QNa(b,k,d,l,m,ea(g[n>>2]),e)|0)){V=1;i=j;return V|0}a[b+2220>>0]=1;e=b+4|0;n=c[h>>2]|0;m=h+4|0;l=c[m>>2]|0;d=n>>>0<l>>>0;c[p>>2]=d?n:l;c[p+4>>2]=d?l:n;A6a(e,p)|0;p=c[h>>2]|0;n=h+8|0;l=c[n>>2]|0;d=p>>>0<l>>>0;c[q>>2]=d?p:l;c[q+4>>2]=d?l:p;A6a(e,q)|0;q=c[m>>2]|0;p=c[n>>2]|0;l=q>>>0<p>>>0;c[r>>2]=l?q:p;c[r+4>>2]=l?p:q;A6a(e,r)|0;r=c[h>>2]|0;h=b+2056|0;e=c[h>>2]|0;if((e|0)==128){V=1;i=j;return V|0}q=b+(r&127)+1928|0;p=a[q>>0]|0;a:do if(p<<24>>24==-1){a[q>>0]=e;Y=14}else{l=p&255;d=p;while(1){if((c[b+(l<<2)+1288>>2]|0)==(r|0)){Z=e;break a}k=a[b+l+1800>>0]|0;if(k<<24>>24==-1)break;else{l=k&255;d=k}}a[b+(d&255)+1800>>0]=e;Y=14}while(0);if((Y|0)==14){a[b+(c[h>>2]|0)+1800>>0]=-1;e=c[h>>2]|0;c[h>>2]=e+1;c[b+(e<<2)+1288>>2]=r;Z=c[h>>2]|0}r=c[m>>2]|0;if((Z|0)==128){V=1;i=j;return V|0}m=b+(r&127)+1928|0;e=a[m>>0]|0;b:do if(e<<24>>24==-1){a[m>>0]=Z;Y=22}else{p=e&255;q=e;while(1){if((c[b+(p<<2)+1288>>2]|0)==(r|0)){_=Z;break b}l=a[b+p+1800>>0]|0;if(l<<24>>24==-1)break;else{p=l&255;q=l}}a[b+(q&255)+1800>>0]=Z;Y=22}while(0);if((Y|0)==22){a[b+(c[h>>2]|0)+1800>>0]=-1;Z=c[h>>2]|0;c[h>>2]=Z+1;c[b+(Z<<2)+1288>>2]=r;_=c[h>>2]|0}r=c[n>>2]|0;if((_|0)==128){V=1;i=j;return V|0}n=b+(r&127)+1928|0;Z=a[n>>0]|0;do if(Z<<24>>24!=-1){e=Z&255;m=Z;while(1){if((c[b+(e<<2)+1288>>2]|0)==(r|0)){V=1;Y=34;break}p=a[b+e+1800>>0]|0;if(p<<24>>24==-1){Y=29;break}else{e=p&255;m=p}}if((Y|0)==29){a[b+(m&255)+1800>>0]=_;break}else if((Y|0)==34){i=j;return V|0}}else a[n>>0]=_;while(0);a[b+(c[h>>2]|0)+1800>>0]=-1;_=c[h>>2]|0;c[h>>2]=_+1;c[b+(_<<2)+1288>>2]=r;V=1;i=j;return V|0}function SNa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=0,K=0,L=Im,M=Im,N=0,O=0,P=Im,Q=Im,R=0,U=0,V=Im,W=0,X=Im,Y=Im,Z=Im,_=0,$=Im,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im;d=i;i=i+48|0;e=d+24|0;f=d+12|0;h=d;j=c[b>>2]|0;k=c[j+4>>2]|0;if(!k){i=d;return}l=(k>>>0)/17|0;m=c[j+8>>2]|0;if(k>>>0<=16){i=d;return}k=b+2156|0;j=b+2160|0;n=b+2164|0;o=e+4|0;p=e+8|0;q=e+12|0;r=f+4|0;s=f+8|0;t=h+4|0;u=h+8|0;v=b+2220|0;w=0;do{x=c[m+(w*68|0)>>2]|0;y=c[m+(w*68|0)+40>>2]|0;z=c[m+(w*68|0)+44>>2]|0;A=c[m+(w*68|0)+48>>2]|0;B=m+(w*68|0)+4|0;C=ea(g[k>>2]);D=ea(g[j>>2]);E=ea(g[n>>2]);F=m+(w*68|0)+16|0;G=ea(g[F>>2]);H=ea(g[B>>2]);I=ea(G-H);J=m+(w*68|0)+20|0;G=ea(g[J>>2]);K=m+(w*68|0)+8|0;L=ea(g[K>>2]);M=ea(G-L);N=m+(w*68|0)+24|0;G=ea(g[N>>2]);O=m+(w*68|0)+12|0;P=ea(g[O>>2]);Q=ea(G-P);R=m+(w*68|0)+28|0;G=ea(ea(g[R>>2])-H);U=m+(w*68|0)+32|0;V=ea(ea(g[U>>2])-L);W=m+(w*68|0)+36|0;X=ea(ea(g[W>>2])-P);Y=ea(H-C);C=ea(L-D);D=ea(P-E);E=ea(ea(ea(I*I)+ea(M*M))+ea(Q*Q));P=ea(ea(ea(I*G)+ea(M*V))+ea(Q*X));L=ea(ea(ea(G*G)+ea(V*V))+ea(X*X));H=ea(ea(ea(Y*I)+ea(C*M))+ea(D*Q));Z=ea(ea(ea(Y*G)+ea(C*V))+ea(D*X));D=ea(ea(E*L)-ea(P*P));C=ea(ea(P*Z)-ea(H*L));Y=ea(ea(H*P)-ea(E*Z));_=C<ea(0.0);do if(!(ea(C+Y)<=ea(S(ea(D))))){if(_){$=ea(H+P);aa=ea(L+Z);if(aa>$){ba=!(ea(aa-$)>=ea(L+ea(E-ea(P*ea(2.0)))));ca=ba?4:1;da=29;break}if(aa<=ea(0.0)){da=38;break}ba=!(Z>=ea(0.0));ca=ba?5:0;da=29;break}if(!(Y<ea(0.0))){aa=ea(ea(ea(L+Z)-P)-H);if(aa<=ea(0.0)){da=38;break}ba=!(aa>=ea(L+ea(E-ea(P*ea(2.0)))));ca=ba?4:1;da=29;break}aa=ea(P+Z);$=ea(E+H);if($>aa){ba=!(ea($-aa)>=ea(L+ea(E-ea(P*ea(2.0)))));ca=ba?4:2;da=29;break}if(!($<=ea(0.0))){ba=!(H>=ea(0.0));ca=ba?3:0;da=29}else da=34}else{ba=Y<ea(0.0);if(!_){if(!ba){fa=D==ea(0.0);ca=fa?0:6;da=29;break}if(H>=ea(0.0)){da=30;break}fa=!(E<=ea(-H));ca=fa?3:1;da=29;break}if(!ba){if(Z>=ea(0.0)){da=30;break}ba=!(L<=ea(-Z));ca=ba?5:2;da=29;break}if(H<ea(0.0)){ba=!(E<=ea(-H));ca=ba?3:1;da=29;break}if(!(Z>=ea(0.0))){ba=!(L<=ea(-Z));ca=ba?5:2;da=29}else da=30}while(0);a:do if((da|0)==29){da=0;switch(ca|0){case 5:{_=y>>>0<A>>>0;ba=_?y:A;fa=_?A:y;_=ba<<16|fa;ga=_+~(_<<15)|0;_=(ga>>>10^ga)*9|0;ga=_>>>6^_;_=ga+~(ga<<11)|0;ga=a[b+((_>>>16^_)&127)+1156>>0]|0;if(ga<<24>>24==-1){da=57;break a}_=ga&255;while(1){if((c[b+(_<<3)+4>>2]|0)==(ba|0)?(c[b+(_<<3)+8>>2]|0)==(fa|0):0)break a;ga=a[b+_+1028>>0]|0;if(ga<<24>>24==-1){da=57;break}else _=ga&255}break}case 6:{da=57;break a;break}case 0:{da=30;break a;break}case 1:{da=34;break a;break}case 2:{da=38;break a;break}case 3:{_=y>>>0<z>>>0;fa=_?y:z;ba=_?z:y;_=fa<<16|ba;ga=_+~(_<<15)|0;_=(ga>>>10^ga)*9|0;ga=_>>>6^_;_=ga+~(ga<<11)|0;ga=a[b+((_>>>16^_)&127)+1156>>0]|0;if(ga<<24>>24==-1){da=57;break a}_=ga&255;while(1){if((c[b+(_<<3)+4>>2]|0)==(fa|0)?(c[b+(_<<3)+8>>2]|0)==(ba|0):0)break a;ga=a[b+_+1028>>0]|0;if(ga<<24>>24==-1){da=57;break}else _=ga&255}break}case 4:{_=z>>>0<A>>>0;ba=_?z:A;fa=_?A:z;_=ba<<16|fa;ga=_+~(_<<15)|0;_=(ga>>>10^ga)*9|0;ga=_>>>6^_;_=ga+~(ga<<11)|0;ga=a[b+((_>>>16^_)&127)+1156>>0]|0;if(ga<<24>>24==-1){da=57;break a}_=ga&255;while(1){if((c[b+(_<<3)+4>>2]|0)==(ba|0)?(c[b+(_<<3)+8>>2]|0)==(fa|0):0)break a;ga=a[b+_+1028>>0]|0;if(ga<<24>>24==-1){da=57;break}else _=ga&255}break}default:break a}}while(0);b:do if((da|0)==30){da=0;_=a[b+(y&127)+1928>>0]|0;if(_<<24>>24==-1)da=57;else{fa=_&255;while(1){if((c[b+(fa<<2)+1288>>2]|0)==(y|0))break b;_=a[b+fa+1800>>0]|0;if(_<<24>>24==-1){da=57;break}else fa=_&255}}}else if((da|0)==34){da=0;fa=a[b+(z&127)+1928>>0]|0;if(fa<<24>>24==-1)da=57;else{_=fa&255;while(1){if((c[b+(_<<2)+1288>>2]|0)==(z|0))break b;fa=a[b+_+1800>>0]|0;if(fa<<24>>24==-1){da=57;break}else _=fa&255}}}else if((da|0)==38){da=0;_=a[b+(A&127)+1928>>0]|0;if(_<<24>>24==-1)da=57;else{fa=_&255;while(1){if((c[b+(fa<<2)+1288>>2]|0)==(A|0))break b;_=a[b+fa+1800>>0]|0;if(_<<24>>24==-1){da=57;break}else fa=_&255}}}while(0);if((da|0)==57){da=0;Z=ea(ea(M*X)-ea(Q*V));L=ea(ea(Q*G)-ea(I*X));H=ea(ea(I*V)-ea(M*G));E=ea(ea(H*H)+ea(ea(Z*Z)+ea(L*L)));if(E>ea(0.0)){D=ea(ea(1.0)/ea(T(ea(E))));ha=ea(Z*D);ia=ea(L*D);ja=ea(H*D)}else{ha=ea(0.0);ia=ea(0.0);ja=ea(0.0)}g[e>>2]=ha;g[o>>2]=ia;g[p>>2]=ja;D=ea(ha*ea(g[B>>2]));H=ea(D+ea(ia*ea(g[K>>2])));g[q>>2]=ea(-ea(H+ea(ja*ea(g[O>>2]))));H=ea(g[B>>2]);D=ea(H+ea(g[F>>2]));H=ea(g[K>>2]);L=ea(H+ea(g[J>>2]));H=ea(g[O>>2]);Z=ea(H+ea(g[N>>2]));H=ea(D+ea(g[R>>2]));D=ea(L+ea(g[U>>2]));L=ea(D*ea(.333333343));D=ea(ea(Z+ea(g[W>>2]))*ea(.333333343));g[f>>2]=ea(H*ea(.333333343));g[r>>2]=L;g[s>>2]=D;g[h>>2]=ea(g[m+(w*68|0)+52>>2]);g[t>>2]=ea(g[m+(w*68|0)+56>>2]);g[u>>2]=ea(g[m+(w*68|0)+60>>2]);if(QNa(b,e,B,f,h,ea(g[m+(w*68|0)+64>>2]),x)|0)a[v>>0]=1}w=w+1|0}while(w>>>0<l>>>0);i=d;return}function TNa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+240|0;j=f+168|0;k=f+96|0;l=f+72|0;m=f;n=b+4|0;if(ea(g[n>>2])==ea(1.0)?ea(g[b+8>>2])==ea(1.0):0)o=ea(g[b+12>>2])==ea(1.0);else o=0;g[j>>2]=ea(1.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);g[j+16>>2]=ea(1.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);g[j+32>>2]=ea(1.0);g[j+36>>2]=ea(1.0);g[j+40>>2]=ea(0.0);g[j+44>>2]=ea(0.0);g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(1.0);g[j+56>>2]=ea(0.0);g[j+60>>2]=ea(0.0);g[j+64>>2]=ea(0.0);g[j+68>>2]=ea(1.0);if(!o)J0a(j,n,b+16|0);g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(1.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=ea(1.0);g[k+40>>2]=ea(0.0);g[k+44>>2]=ea(0.0);g[k+48>>2]=ea(0.0);g[k+52>>2]=ea(1.0);g[k+56>>2]=ea(0.0);g[k+60>>2]=ea(0.0);g[k+64>>2]=ea(0.0);g[k+68>>2]=ea(1.0);n=jOa(a,k,l,m)|0;a=B6a(m,l,b,c,d,ea(g[e>>2]),h,k,j,n,o)|0;i=f;return a|0}function UNa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;f=i;i=i+464|0;j=f+392|0;k=f+168|0;l=f+144|0;m=f+72|0;n=f;o=a+4|0;FOa(k,o);GOa(k,j);p=ea(g[o>>2]);q=ea(-p);r=ea(g[a+8>>2]);s=ea(-r);t=ea(g[a+12>>2]);u=ea(-t);g[l>>2]=q;g[l+4>>2]=s;g[l+8>>2]=u;g[l+12>>2]=p;g[l+16>>2]=r;g[l+20>>2]=t;a=b+4|0;if(ea(g[a>>2])==ea(1.0)?ea(g[b+8>>2])==ea(1.0):0)v=ea(g[b+12>>2])==ea(1.0);else v=0;g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);g[m+16>>2]=ea(1.0);g[m+20>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m+28>>2]=ea(0.0);g[m+32>>2]=ea(1.0);g[m+36>>2]=ea(1.0);g[m+40>>2]=ea(0.0);g[m+44>>2]=ea(0.0);g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(1.0);g[m+56>>2]=ea(0.0);g[m+60>>2]=ea(0.0);g[m+64>>2]=ea(0.0);g[m+68>>2]=ea(1.0);if(!v)J0a(m,a,b+16|0);g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);g[n+16>>2]=ea(1.0);g[n+20>>2]=ea(0.0);g[n+24>>2]=ea(0.0);g[n+28>>2]=ea(0.0);g[n+32>>2]=ea(1.0);g[n+36>>2]=ea(1.0);g[n+40>>2]=ea(0.0);g[n+44>>2]=ea(0.0);g[n+48>>2]=ea(0.0);g[n+52>>2]=ea(1.0);g[n+56>>2]=ea(0.0);g[n+60>>2]=ea(0.0);g[n+64>>2]=ea(0.0);g[n+68>>2]=ea(1.0);a=B6a(j,l,b,c,d,ea(g[e>>2]),h,n,m,1,v)|0;i=f;return a|0}function VNa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im;f=i;i=i+176|0;j=f+96|0;k=f+72|0;l=f;g[j>>2]=ea(1.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);g[j+16>>2]=ea(1.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);g[j+32>>2]=ea(1.0);g[j+36>>2]=ea(1.0);g[j+40>>2]=ea(0.0);g[j+44>>2]=ea(0.0);g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(1.0);g[j+56>>2]=ea(0.0);g[j+60>>2]=ea(0.0);g[j+64>>2]=ea(0.0);g[j+68>>2]=ea(1.0);m=jOa(a,j,k,l)|0;n=ea(g[e>>2]);g[k>>2]=ea(ea(g[k>>2])-n);e=k+4|0;g[e>>2]=ea(ea(g[e>>2])-n);e=k+8|0;g[e>>2]=ea(ea(g[e>>2])-n);e=k+12|0;g[e>>2]=ea(n+ea(g[e>>2]));e=k+16|0;g[e>>2]=ea(n+ea(g[e>>2]));e=k+20|0;g[e>>2]=ea(n+ea(g[e>>2]));e=C6a(l,k,b,c,d,n,h,j,m)|0;i=f;return e|0}function WNa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;f=i;i=i+400|0;j=f+320|0;k=f+96|0;l=f+72|0;m=f;n=a+4|0;FOa(k,n);GOa(k,j);o=ea(g[e>>2]);p=ea(o+ea(g[n>>2]));q=ea(o+ea(g[a+8>>2]));r=ea(o+ea(g[a+12>>2]));s=ea(-q);t=ea(-r);g[l>>2]=ea(-p);g[l+4>>2]=s;g[l+8>>2]=t;g[l+12>>2]=p;g[l+16>>2]=q;g[l+20>>2]=r;g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);g[m+16>>2]=ea(1.0);g[m+20>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m+28>>2]=ea(0.0);g[m+32>>2]=ea(1.0);g[m+36>>2]=ea(1.0);g[m+40>>2]=ea(0.0);g[m+44>>2]=ea(0.0);g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(1.0);g[m+56>>2]=ea(0.0);g[m+60>>2]=ea(0.0);g[m+64>>2]=ea(0.0);g[m+68>>2]=ea(1.0);a=C6a(j,l,b,c,d,o,h,m,1)|0;i=f;return a|0}function XNa(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=0,q=Im;c=i;d=ea(g[b+8>>2]);if(!(ea(S(ea(d)))<=ea(.999899983))){e=ea(ea(0.0)-ea(g[b>>2]));f=ea(ea(1.0)-ea(g[b+4>>2]));h=ea(ea(0.0)-d);j=ea(ea(2.0)/ea(ea(h*h)+ea(ea(e*e)+ea(f*f))));k=ea(j*ea(ea(h*ea(-1.0))+ea(ea(e*ea(0.0))+f)));l=ea(j*e);m=ea(k*e);n=ea(ea(m*ea(0.0))-ea(l*e));o=a+12|0;g[o>>2]=ea(m-ea(l*f));p=a+24|0;g[p>>2]=ea(ea(m*ea(-1.0))+ea(ea(0.0)-ea(l*h)));g[a>>2]=ea(n+ea(1.0));n=ea(j*f);l=ea(k*f);g[a+4>>2]=ea(ea(l*ea(0.0))-ea(n*e));m=ea(l+ea(ea(-1.0)-ea(n*f)));g[p+4>>2]=ea(ea(l*ea(-1.0))+ea(ea(1.0)-ea(n*h)));g[o+4>>2]=ea(m+ea(1.0));m=ea(j*h);j=ea(k*h);g[a+8>>2]=ea(ea(j*ea(0.0))+ea(ea(0.0)-ea(m*e)));g[o+8>>2]=ea(j+ea(ea(1.0)-ea(m*f)));g[p+8>>2]=ea(ea(ea(j*ea(-1.0))+ea(ea(-1.0)-ea(m*h)))+ea(1.0));i=c;return}else{h=ea(g[b+4>>2]);m=ea(-h);j=ea(g[b>>2]);f=ea(ea(1.0)/ea(d+ea(1.0)));e=ea(f*m);k=ea(f*ea(0.0));n=ea(j*e);l=ea(e*ea(0.0));q=ea(j*k);g[a>>2]=ea(d+ea(e*m));b=a+12|0;g[b>>2]=n;p=a+24|0;g[p>>2]=ea(j+l);g[a+4>>2]=ea(n+ea(0.0));g[b+4>>2]=ea(d+ea(j*ea(j*f)));g[p+4>>2]=ea(h+q);g[a+8>>2]=ea(l-j);g[b+8>>2]=ea(q-h);g[p+8>>2]=ea(d+ea(k*ea(0.0)));i=c;return}}function YNa(b,e,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=ea(z);var A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=Im,va=0,wa=0,xa=0,ya=Im,za=0,Aa=0,Ba=0,Ca=Im,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=Im,$a=Im,ab=0,bb=Im,cb=Im,db=0,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=0,kb=0,lb=Im,mb=Im,nb=Im,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0;A=i;i=i+128|0;B=A+64|0;C=A+48|0;D=A+52|0;E=A+56|0;F=A+60|0;G=A;H=A+32|0;I=A+24|0;J=A+12|0;K=ea(g[r>>2]);if(x){L=ea(-K);M=ea(g[r+4>>2]);N=ea(-M);O=ea(g[r+8>>2]);P=L;Q=N;R=ea(-O);T=M;U=O}else{O=ea(g[r+4>>2]);M=ea(g[r+8>>2]);P=K;Q=O;R=M;T=O;U=M}r=i;i=i+((1*((b>>>0<l>>>0?l:b)*12|0)|0)+15&-16)|0;V=i;i=i+((1*b|0)+15&-16)|0;W=i;i=i+((1*b|0)+15&-16)|0;X=i;i=i+((1*l|0)+15&-16)|0;Y=i;i=i+((1*l|0)+15&-16)|0;Z=w+4096|0;_=c[Z>>2]|0;g[C>>2]=ea(0.0);g[D>>2]=ea(0.0);g[E>>2]=ea(0.0);g[F>>2]=ea(0.0);M=ea(ea(g[o>>2])*K);$=o+4|0;O=ea(M+ea(ea(g[$>>2])*T));aa=o+8|0;M=ea(O+ea(ea(g[aa>>2])*U));ba=o+12|0;O=ea(K*ea(g[ba>>2]));ca=o+16|0;N=ea(O+ea(T*ea(g[ca>>2])));da=o+20|0;O=ea(N+ea(U*ea(g[da>>2])));fa=o+24|0;N=ea(K*ea(g[fa>>2]));ga=o+28|0;K=ea(N+ea(T*ea(g[ga>>2])));ha=o+32|0;T=ea(-M);M=ea(-O);O=ea(-ea(K+ea(U*ea(g[ha>>2]))));U=ea(g[s>>2]);ia=q+4|0;ja=s+4|0;K=ea(g[ja>>2]);ka=q+8|0;la=s+8|0;N=ea(g[la>>2]);ma=q+12|0;na=q+16|0;oa=q+20|0;L=ea(g[q+24>>2]);pa=ea(U*L);U=ea(g[q+28>>2]);qa=ea(pa+ea(K*U));K=ea(g[q+32>>2]);pa=ea(qa+ea(N*K));ra=s+12|0;N=ea(g[ra>>2]);sa=s+16|0;qa=ea(g[sa>>2]);ta=s+20|0;ua=ea(ea(ea(L*N)+ea(U*qa))+ea(K*ea(g[ta>>2])));va=s+24|0;qa=ea(g[va>>2]);wa=s+28|0;N=ea(g[wa>>2]);xa=s+32|0;ya=ea(ea(ea(L*qa)+ea(U*N))+ea(K*ea(g[xa>>2])));za=s+36|0;N=ea(g[za>>2]);Aa=s+40|0;qa=ea(g[Aa>>2]);Ba=s+44|0;Ca=ea(ea(ea(L*N)+ea(U*qa))+ea(K*ea(g[Ba>>2])));K=ea(ea(g[p>>2])*T);qa=ea(K+ea(ea(g[p+4>>2])*M));K=ea(qa+ea(ea(g[p+8>>2])*O));if(!(l>>>0<=2|!(+K>=1.0e-07))){qa=ea(ea(1.0)/K);K=ea(g[p+12>>2]);U=ea(-K);D6a(C,D,E,F,r,l,m,n,q);if(!b){Da=0;Ea=0}else{N=ea(g[C>>2]);L=ea(g[D>>2]);Fa=ea(g[E>>2]);Ga=ea(g[F>>2]);p=h+4|0;Ha=h+8|0;Ia=h+12|0;Ja=h+16|0;Ka=h+20|0;La=h+24|0;Ma=h+28|0;Na=h+32|0;Oa=h+36|0;Pa=h+40|0;Qa=h+44|0;Ra=y+4|0;Sa=y+8|0;Ta=0;Ua=0;Va=0;Wa=0;while(1){Xa=f+Ua|0;Ya=d[Xa>>0]|0;Za=e+(Ya*12|0)|0;_a=ea(g[Za>>2]);$a=ea(pa*_a);ab=e+(Ya*12|0)+4|0;bb=ea(g[ab>>2]);cb=ea($a+ea(ua*bb));db=e+(Ya*12|0)+8|0;$a=ea(g[db>>2]);eb=ea(Ca+ea(cb+ea(ya*$a)));cb=ea(_a*ea(g[s>>2]));fb=ea(_a*ea(g[ja>>2]));gb=ea(_a*ea(g[la>>2]));_a=ea(bb*ea(g[ra>>2]));hb=ea(bb*ea(g[sa>>2]));ib=ea(cb+_a);_a=ea(fb+hb);hb=ea(gb+ea(bb*ea(g[ta>>2])));bb=ea($a*ea(g[va>>2]));gb=ea($a*ea(g[wa>>2]));fb=ea(ib+bb);bb=ea(_a+gb);gb=ea(hb+ea($a*ea(g[xa>>2])));$a=ea(fb+ea(g[za>>2]));fb=ea(bb+ea(g[Aa>>2]));bb=ea(qa*ea(K+eb));hb=ea($a-ea(bb*T));$a=ea(fb-ea(bb*M));fb=ea(ea(gb+ea(g[Ba>>2]))-ea(bb*O));gb=ea(hb*ea(g[q>>2]));_a=ea(gb+ea($a*ea(g[ia>>2])));gb=ea(_a+ea(fb*ea(g[ka>>2])));_a=ea(hb*ea(g[ma>>2]));hb=ea(_a+ea($a*ea(g[na>>2])));Ya=E6a(r,l,ea(gb-N),ea(ea(hb+ea(fb*ea(g[oa>>2])))-L),Fa,Ga,W+Ua|0)|0;a[V+Ua>>0]=Ya&1;if(Ya){Ya=Ta+1|0;if(eb<U){jb=c[Z>>2]|0;if(jb>>>0<=63?(c[Z>>2]=jb+1,kb=w+(jb<<6)|0,(kb|0)!=0):0){a[B+Va>>0]=a[Xa>>0]|0;g[kb>>2]=P;g[w+(jb<<6)+4>>2]=Q;g[w+(jb<<6)+8>>2]=R;eb=ea(g[Za>>2]);fb=ea(eb*ea(g[h>>2]));hb=ea(eb*ea(g[p>>2]));gb=ea(eb*ea(g[Ha>>2]));eb=ea(g[ab>>2]);$a=ea(eb*ea(g[Ia>>2]));_a=ea(eb*ea(g[Ja>>2]));ib=ea(fb+$a);$a=ea(hb+_a);_a=ea(gb+ea(eb*ea(g[Ka>>2])));eb=ea(g[db>>2]);gb=ea(eb*ea(g[La>>2]));hb=ea(eb*ea(g[Ma>>2]));fb=ea(ib+gb);gb=ea($a+hb);hb=ea(_a+ea(eb*ea(g[Na>>2])));eb=ea(fb+ea(g[Oa>>2]));fb=ea(gb+ea(g[Pa>>2]));gb=ea(hb+ea(g[Qa>>2]));if(x){hb=ea(g[y>>2]);_a=ea(g[Ra>>2]);lb=hb;mb=_a;nb=ea(g[Sa>>2])}else{lb=ea(0.0);mb=ea(0.0);nb=ea(0.0)}_a=ea(fb+mb);fb=ea(gb+nb);g[w+(jb<<6)+16>>2]=ea(eb+lb);g[w+(jb<<6)+20>>2]=_a;g[w+(jb<<6)+24>>2]=fb;g[w+(jb<<6)+12>>2]=ea(bb+z);c[w+(jb<<6)+48>>2]=u;c[w+(jb<<6)+52>>2]=v;ob=Ya;pb=Va+1|0;qb=1}else{ob=Ya;pb=Va;qb=1}}else{ob=Ya;pb=Va;qb=Wa}}else{ob=Ta;pb=Va;qb=Wa}Ua=Ua+1|0;if((Ua|0)==(b|0))break;else{Ta=ob;Va=pb;Wa=qb}}Da=ob;Ea=(qb&1)!=0}}else{PEi(V|0,0,b|0)|0;PEi(W|0,0,b|0)|0;Da=0;Ea=0}F6a(w,_,Da,k,e,B);if((Da|0)==(b|0)){rb=Ea;i=A;return rb|0}Da=c[Z>>2]|0;lb=ea(g[k>>2]);nb=ea(g[t>>2]);mb=ea(lb*nb);U=ea(g[k+4>>2]);_=t+4|0;Ga=ea(g[_>>2]);Fa=ea(mb+ea(U*Ga));mb=ea(g[k+8>>2]);qb=t+8|0;L=ea(g[qb>>2]);N=ea(Fa+ea(mb*L));Fa=ea(g[k+12>>2]);O=ea(nb*Fa);M=ea(g[k+16>>2]);T=ea(O+ea(Ga*M));O=ea(g[k+20>>2]);K=ea(T+ea(L*O));T=ea(g[k+24>>2]);qa=ea(nb*T);nb=ea(g[k+28>>2]);ya=ea(qa+ea(Ga*nb));Ga=ea(g[k+32>>2]);qa=ea(ya+ea(L*Ga));ob=t+12|0;L=ea(g[ob>>2]);ya=ea(lb*L);Wa=t+16|0;Ca=ea(g[Wa>>2]);ua=ea(ya+ea(U*Ca));pb=t+20|0;ya=ea(g[pb>>2]);pa=ea(ua+ea(mb*ya));ua=ea(ea(ea(Fa*L)+ea(M*Ca))+ea(O*ya));bb=ea(ea(ea(T*L)+ea(nb*Ca))+ea(Ga*ya));Va=t+24|0;ya=ea(g[Va>>2]);Ca=ea(lb*ya);Ta=t+28|0;L=ea(g[Ta>>2]);fb=ea(Ca+ea(U*L));Ua=t+32|0;Ca=ea(g[Ua>>2]);_a=ea(fb+ea(mb*Ca));fb=ea(ea(ea(Fa*ya)+ea(M*L))+ea(O*Ca));eb=ea(ea(ea(T*ya)+ea(nb*L))+ea(Ga*Ca));Sa=t+36|0;Ca=ea(g[Sa>>2]);L=ea(lb*Ca);Ra=t+40|0;lb=ea(g[Ra>>2]);ya=ea(L+ea(U*lb));Qa=t+44|0;U=ea(g[Qa>>2]);L=ea(ya+ea(mb*U));mb=ea(ea(ea(Fa*Ca)+ea(M*lb))+ea(O*U));O=ea(ea(ea(T*Ca)+ea(nb*lb))+ea(Ga*U));if(b>>>0>2){U=ea(g[j+12>>2]);Ga=ea(-U);D6a(C,D,E,F,r,b,e,f,k);if(l){lb=ea(g[C>>2]);nb=ea(g[D>>2]);Ca=ea(g[E>>2]);T=ea(g[F>>2]);F=o+36|0;E=o+40|0;D=o+44|0;C=y+4|0;k=y+8|0;if(x){Pa=0;Oa=0;Na=0;Ma=Ea;while(1){La=n+Oa|0;Ka=d[La>>0]|0;Ja=m+(Ka*12|0)|0;M=ea(g[Ja>>2]);Fa=ea(N*M);Ia=m+(Ka*12|0)+4|0;ya=ea(g[Ia>>2]);gb=ea(Fa+ea(pa*ya));Ha=m+(Ka*12|0)+8|0;Fa=ea(g[Ha>>2]);Ka=E6a(r,b,ea(ea(L+ea(gb+ea(_a*Fa)))-lb),ea(ea(mb+ea(ea(ea(K*M)+ea(ua*ya))+ea(fb*Fa)))-nb),Ca,T,Y+Oa|0)|0;a[X+Oa>>0]=Ka&1;if(Ka){Ka=Pa+1|0;Fa=ea(qa*ea(g[Ja>>2]));ya=ea(Fa+ea(bb*ea(g[Ia>>2])));Fa=ea(O+ea(ya+ea(eb*ea(g[Ha>>2]))));if(Fa<Ga){p=c[Z>>2]|0;if(p>>>0<=63?(c[Z>>2]=p+1,oa=w+(p<<6)|0,(oa|0)!=0):0){a[B+Na>>0]=a[La>>0]|0;g[oa>>2]=P;g[w+(p<<6)+4>>2]=Q;g[w+(p<<6)+8>>2]=R;ya=ea(g[Ja>>2]);M=ea(ya*ea(g[o>>2]));gb=ea(ya*ea(g[$>>2]));hb=ea(ya*ea(g[aa>>2]));ya=ea(g[Ia>>2]);$a=ea(ya*ea(g[ba>>2]));ib=ea(ya*ea(g[ca>>2]));cb=ea(M+$a);$a=ea(gb+ib);ib=ea(hb+ea(ya*ea(g[da>>2])));ya=ea(g[Ha>>2]);hb=ea(ya*ea(g[fa>>2]));gb=ea(ya*ea(g[ga>>2]));M=ea(cb+hb);hb=ea($a+gb);gb=ea(ib+ea(ya*ea(g[ha>>2])));ya=ea(M+ea(g[F>>2]));M=ea(hb+ea(g[E>>2]));hb=ea(M+ea(0.0));M=ea(ea(gb+ea(g[D>>2]))+ea(0.0));g[w+(p<<6)+16>>2]=ea(ya+ea(0.0));g[w+(p<<6)+20>>2]=hb;g[w+(p<<6)+24>>2]=M;g[w+(p<<6)+12>>2]=ea(ea(U+Fa)+z);c[w+(p<<6)+48>>2]=u;c[w+(p<<6)+52>>2]=v;sb=Ka;tb=Na+1|0;ub=1}else{sb=Ka;tb=Na;ub=1}}else{sb=Ka;tb=Na;ub=Ma}}else{sb=Pa;tb=Na;ub=Ma}Oa=Oa+1|0;if((Oa|0)==(l|0)){vb=sb;wb=ub;break}else{Pa=sb;Na=tb;Ma=ub}}}else{ub=0;Ma=0;tb=0;Na=Ea;while(1){sb=n+Ma|0;Pa=d[sb>>0]|0;Oa=m+(Pa*12|0)|0;Fa=ea(g[Oa>>2]);M=ea(N*Fa);Ka=m+(Pa*12|0)+4|0;hb=ea(g[Ka>>2]);ya=ea(M+ea(pa*hb));p=m+(Pa*12|0)+8|0;M=ea(g[p>>2]);Pa=E6a(r,b,ea(ea(L+ea(ya+ea(_a*M)))-lb),ea(ea(mb+ea(ea(ea(K*Fa)+ea(ua*hb))+ea(fb*M)))-nb),Ca,T,Y+Ma|0)|0;a[X+Ma>>0]=Pa&1;if(Pa){Pa=ub+1|0;M=ea(qa*ea(g[Oa>>2]));hb=ea(M+ea(bb*ea(g[Ka>>2])));M=ea(O+ea(hb+ea(eb*ea(g[p>>2]))));if(M<Ga){Ha=c[Z>>2]|0;if(Ha>>>0<=63?(c[Z>>2]=Ha+1,Ia=w+(Ha<<6)|0,(Ia|0)!=0):0){a[B+tb>>0]=a[sb>>0]|0;g[Ia>>2]=P;g[w+(Ha<<6)+4>>2]=Q;g[w+(Ha<<6)+8>>2]=R;hb=ea(g[Oa>>2]);Fa=ea(hb*ea(g[o>>2]));ya=ea(hb*ea(g[$>>2]));gb=ea(hb*ea(g[aa>>2]));hb=ea(g[Ka>>2]);ib=ea(hb*ea(g[ba>>2]));$a=ea(hb*ea(g[ca>>2]));cb=ea(Fa+ib);ib=ea(ya+$a);$a=ea(gb+ea(hb*ea(g[da>>2])));hb=ea(g[p>>2]);gb=ea(hb*ea(g[fa>>2]));ya=ea(hb*ea(g[ga>>2]));Fa=ea(cb+gb);gb=ea(ib+ya);ya=ea($a+ea(hb*ea(g[ha>>2])));hb=ea(Fa+ea(g[F>>2]));Fa=ea(gb+ea(g[E>>2]));gb=ea(ya+ea(g[D>>2]));ya=ea(g[y>>2]);$a=ea(g[C>>2]);ib=ea(Fa+$a);$a=ea(gb+ea(g[k>>2]));g[w+(Ha<<6)+16>>2]=ea(hb+ya);g[w+(Ha<<6)+20>>2]=ib;g[w+(Ha<<6)+24>>2]=$a;g[w+(Ha<<6)+12>>2]=ea(ea(U+M)+z);c[w+(Ha<<6)+48>>2]=u;c[w+(Ha<<6)+52>>2]=v;xb=Pa;yb=tb+1|0;zb=1}else{xb=Pa;yb=tb;zb=1}}else{xb=Pa;yb=tb;zb=Na}}else{xb=ub;yb=tb;zb=Na}Ma=Ma+1|0;if((Ma|0)==(l|0)){vb=xb;wb=zb;break}else{ub=xb;tb=yb;Na=zb}}}}else{vb=0;wb=Ea}F6a(w,Da,vb,q,m,B);if((vb|0)==(l|0)){rb=wb;i=A;return rb|0}else Ab=wb}else{PEi(X|0,0,l|0)|0;PEi(Y|0,0,l|0)|0;Ab=Ea}if(!l){rb=Ab;i=A;return rb|0}U=ea(g[t>>2]);Ga=ea(g[_>>2]);eb=ea(g[qb>>2]);O=ea(g[ob>>2]);bb=ea(g[Wa>>2]);qa=ea(g[pb>>2]);T=ea(g[Va>>2]);Ca=ea(g[Ta>>2]);nb=ea(g[Ua>>2]);fb=ea(g[Sa>>2]);ua=ea(g[Ra>>2]);K=ea(g[Qa>>2]);Qa=0;do{Ra=d[n+Qa>>0]|0;mb=ea(g[m+(Ra*12|0)>>2]);lb=ea(mb*U);_a=ea(mb*Ga);L=ea(mb*eb);mb=ea(g[m+(Ra*12|0)+4>>2]);pa=ea(lb+ea(mb*O));lb=ea(_a+ea(mb*bb));_a=ea(L+ea(mb*qa));mb=ea(g[m+(Ra*12|0)+8>>2]);L=ea(ea(lb+ea(mb*Ca))+ua);lb=ea(ea(_a+ea(mb*nb))+K);g[r+(Qa*12|0)>>2]=ea(ea(pa+ea(mb*T))+fb);g[r+(Qa*12|0)+4>>2]=L;g[r+(Qa*12|0)+8>>2]=lb;Qa=Qa+1|0}while((Qa|0)!=(l|0));if(b>>>0<2|l>>>0<2){rb=Ab;i=A;return rb|0}Qa=G+4|0;m=G+8|0;n=j+8|0;Ra=j+4|0;Sa=H+4|0;Ua=H+8|0;Ta=H+12|0;Va=(b|0)==0;pb=h+4|0;Wa=h+8|0;ob=J+4|0;qb=h+12|0;_=h+16|0;t=h+20|0;Ea=J+8|0;wb=h+24|0;vb=h+28|0;B=h+32|0;q=h+36|0;Da=h+40|0;zb=h+44|0;Na=y+4|0;yb=y+8|0;tb=0;xb=Ab;a:while(1){Ab=tb;while(1){Bb=Ab+1|0;Cb=Bb>>>0>=l>>>0?0:Bb;if(!((a[X+Ab>>0]|0)!=0?(a[X+Cb>>0]|0)!=0:0))Db=45;if((Db|0)==45?(Db=0,(a[Y+Cb>>0]&a[Y+Ab>>0])<<24>>24==0):0)break;if(Bb>>>0<l>>>0)Ab=Bb;else{rb=xb;Db=71;break a}}ub=r+(Ab*12|0)|0;Ma=r+(Cb*12|0)|0;fb=ea(g[Ma>>2]);T=ea(g[ub>>2]);K=ea(fb-T);fb=ea(g[r+(Cb*12|0)+4>>2]);nb=ea(g[r+(Ab*12|0)+4>>2]);ua=ea(fb-nb);fb=ea(g[r+(Cb*12|0)+8>>2]);Ca=ea(g[r+(Ab*12|0)+8>>2]);qa=ea(fb-Ca);g[G>>2]=K;g[Qa>>2]=ua;g[m>>2]=qa;fb=ea(g[n>>2]);bb=ea(ua*fb);O=ea(g[Ra>>2]);eb=ea(bb-ea(qa*O));bb=ea(g[j>>2]);Ga=ea(ea(qa*bb)-ea(fb*K));fb=ea(ea(O*K)-ea(ua*bb));bb=ea(-ea(ea(ea(eb*T)+ea(Ga*nb))+ea(fb*Ca)));g[H>>2]=eb;g[Sa>>2]=Ga;g[Ua>>2]=fb;g[Ta>>2]=bb;bb=ea(S(ea(eb)));eb=ea(S(ea(Ga)));Ga=ea(S(ea(fb)));if(!(eb>bb&eb>Ga))if(Ga>bb){Eb=0;Fb=1}else{Eb=1;Fb=2}else{Eb=2;Fb=0}bb=ea(g[G+(Eb<<2)>>2]);Ga=ea(bb*ea(g[j+(Fb<<2)>>2]));bb=ea(g[G+(Fb<<2)>>2]);eb=ea(ea(1.0)/ea(Ga-ea(bb*ea(g[j+(Eb<<2)>>2]))));b:do if(!Va)if(x){k=0;C=xb;while(1){D=k;while(1){E=D;D=D+1|0;F=D>>>0>=b>>>0?0:D;if(!((a[V+E>>0]|0)!=0?(a[V+F>>0]|0)!=0:0))Db=54;if(((Db|0)==54?(Db=0,(a[W+F>>0]&a[W+E>>0])<<24>>24==0):0)?G6a(G,H,ub,Ma,j,e+((d[f+E>>0]|0)*12|0)|0,e+((d[f+F>>0]|0)*12|0)|0,I,J,Eb,Fb,eb)|0:0)break;if(D>>>0>=b>>>0){Gb=C;break b}}F=c[Z>>2]|0;if(F>>>0<=63?(c[Z>>2]=F+1,E=w+(F<<6)|0,(E|0)!=0):0){g[E>>2]=P;g[w+(F<<6)+4>>2]=Q;g[w+(F<<6)+8>>2]=R;bb=ea(g[J>>2]);Ga=ea(bb*ea(g[h>>2]));fb=ea(bb*ea(g[pb>>2]));Ca=ea(bb*ea(g[Wa>>2]));bb=ea(g[ob>>2]);nb=ea(bb*ea(g[qb>>2]));T=ea(bb*ea(g[_>>2]));ua=ea(Ga+nb);nb=ea(fb+T);T=ea(Ca+ea(bb*ea(g[t>>2])));bb=ea(g[Ea>>2]);Ca=ea(bb*ea(g[wb>>2]));fb=ea(bb*ea(g[vb>>2]));Ga=ea(ua+Ca);Ca=ea(nb+fb);fb=ea(T+ea(bb*ea(g[B>>2])));bb=ea(Ga+ea(g[q>>2]));Ga=ea(Ca+ea(g[Da>>2]));Ca=ea(Ga+ea(0.0));Ga=ea(ea(fb+ea(g[zb>>2]))+ea(0.0));g[w+(F<<6)+16>>2]=ea(bb+ea(0.0));g[w+(F<<6)+20>>2]=Ca;g[w+(F<<6)+24>>2]=Ga;g[w+(F<<6)+12>>2]=ea(z-ea(g[I>>2]));c[w+(F<<6)+48>>2]=u;c[w+(F<<6)+52>>2]=v}if(D>>>0<b>>>0){k=D;C=1}else{Gb=1;break}}}else{C=0;k=xb;while(1){F=C;while(1){E=F;F=F+1|0;ha=F>>>0>=b>>>0?0:F;if(!((a[V+E>>0]|0)!=0?(a[V+ha>>0]|0)!=0:0))Db=65;if(((Db|0)==65?(Db=0,(a[W+ha>>0]&a[W+E>>0])<<24>>24==0):0)?G6a(G,H,ub,Ma,j,e+((d[f+E>>0]|0)*12|0)|0,e+((d[f+ha>>0]|0)*12|0)|0,I,J,Eb,Fb,eb)|0:0)break;if(F>>>0>=b>>>0){Gb=k;break b}}D=c[Z>>2]|0;if(D>>>0<=63?(c[Z>>2]=D+1,ha=w+(D<<6)|0,(ha|0)!=0):0){g[ha>>2]=P;g[w+(D<<6)+4>>2]=Q;g[w+(D<<6)+8>>2]=R;Ga=ea(g[J>>2]);Ca=ea(Ga*ea(g[h>>2]));bb=ea(Ga*ea(g[pb>>2]));fb=ea(Ga*ea(g[Wa>>2]));Ga=ea(g[ob>>2]);T=ea(Ga*ea(g[qb>>2]));nb=ea(Ga*ea(g[_>>2]));ua=ea(Ca+T);T=ea(bb+nb);nb=ea(fb+ea(Ga*ea(g[t>>2])));Ga=ea(g[Ea>>2]);fb=ea(Ga*ea(g[wb>>2]));bb=ea(Ga*ea(g[vb>>2]));Ca=ea(ua+fb);fb=ea(T+bb);bb=ea(nb+ea(Ga*ea(g[B>>2])));Ga=ea(Ca+ea(g[q>>2]));Ca=ea(fb+ea(g[Da>>2]));fb=ea(bb+ea(g[zb>>2]));bb=ea(g[y>>2]);nb=ea(g[Na>>2]);T=ea(Ca+nb);nb=ea(fb+ea(g[yb>>2]));g[w+(D<<6)+16>>2]=ea(Ga+bb);g[w+(D<<6)+20>>2]=T;g[w+(D<<6)+24>>2]=nb;g[w+(D<<6)+12>>2]=ea(z-ea(g[I>>2]));c[w+(D<<6)+48>>2]=u;c[w+(D<<6)+52>>2]=v}if(F>>>0<b>>>0){C=F;k=1}else{Gb=1;break}}}else Gb=xb;while(0);if(Bb>>>0<l>>>0){tb=Bb;xb=Gb}else{rb=Gb;Db=71;break}}if((Db|0)==71){i=A;return rb|0}return 0}function ZNa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=0,fa=0,ga=0;j=i;i=i+6768|0;l=j+16|0;m=j+6668|0;n=j+88|0;o=j+6680|0;p=j+6752|0;q=j;r=j+6632|0;s=j+6692|0;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);g[l+16>>2]=ea(1.0);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(0.0);g[l+28>>2]=ea(0.0);g[l+32>>2]=ea(1.0);g[l+36>>2]=ea(1.0);g[l+40>>2]=ea(0.0);g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(0.0);g[l+52>>2]=ea(1.0);g[l+56>>2]=ea(0.0);g[l+60>>2]=ea(0.0);g[l+64>>2]=ea(0.0);g[l+68>>2]=ea(1.0);t=d+4|0;if((ea(g[t>>2])==ea(1.0)?ea(g[d+8>>2])==ea(1.0):0)?ea(g[d+12>>2])==ea(1.0):0)u=1;else{J0a(l,t,d+16|0);u=0}v=ea(g[e+16>>2]);w=ea(v-ea(g[f+16>>2]));v=ea(g[e+20>>2]);x=ea(v-ea(g[f+20>>2]));v=ea(g[e+24>>2]);y=ea(w*ea(2.0));w=ea(x*ea(2.0));x=ea(ea(v-ea(g[f+24>>2]))*ea(2.0));v=ea(g[f+12>>2]);z=ea(ea(v*v)+ea(-.5));A=ea(g[f>>2]);B=ea(y*A);C=ea(g[f+4>>2]);D=ea(B+ea(w*C));B=ea(g[f+8>>2]);E=ea(D+ea(x*B));D=ea(ea(A*E)+ea(ea(y*z)-ea(v*ea(ea(x*C)-ea(w*B)))));F=ea(ea(C*E)+ea(ea(w*z)-ea(v*ea(ea(y*B)-ea(x*A)))));G=ea(ea(ea(x*z)-ea(v*ea(ea(w*A)-ea(y*C))))+ea(B*E));g[m>>2]=D;g[m+4>>2]=F;g[m+8>>2]=G;E=ea(g[b+4>>2]);B=ea(E+ea(g[h>>2]));h=c[d+40>>2]|0;c[n+4>>2]=2;c[n>>2]=539632;c[n+8>>2]=539616;c[n+12>>2]=b;c[n+16>>2]=e;c[n+20>>2]=f;c[n+24>>2]=k;c[n+28>>2]=m;g[n+32>>2]=B;c[n+36>>2]=0;c[n+5288>>2]=0;m=n+5224|0;f=m+64|0;do{c[m>>2]=-1;m=m+4|0}while((m|0)<(f|0));c[n+5676>>2]=0;m=n+5612|0;f=m+64|0;do{c[m>>2]=-1;m=m+4|0}while((m|0)<(f|0));c[n+5680>>2]=h;c[n+5684>>2]=l;a[n+5688>>0]=u&1;m=n+6540|0;c[m>>2]=0;c[o>>2]=c[h+16>>2];c[o+4>>2]=h+32;g[o+8>>2]=ea(g[h+20>>2]);g[p>>2]=D;h=p+4|0;g[h>>2]=F;f=p+8|0;g[f>>2]=G;g[q>>2]=B;e=q+4|0;g[e>>2]=B;b=q+8|0;g[b>>2]=B;g[r>>2]=ea(1.0);d=r+4|0;g[d>>2]=ea(0.0);t=r+8|0;g[t>>2]=ea(0.0);H=r+12|0;g[H>>2]=ea(0.0);I=r+16|0;g[I>>2]=ea(1.0);J=r+20|0;g[J>>2]=ea(0.0);K=r+24|0;g[K>>2]=ea(0.0);L=r+28|0;g[L>>2]=ea(0.0);M=r+32|0;g[M>>2]=ea(1.0);if(u){N=ea(1.0);O=ea(0.0);P=ea(0.0);Q=ea(0.0);R=ea(1.0);S=ea(0.0);T=ea(0.0);U=ea(0.0);V=ea(1.0);W=D;X=F;Y=G;Z=B;_=B;$=B}else{x6a(l,p,q,r);B=ea(g[r>>2]);G=ea(g[d>>2]);F=ea(g[t>>2]);D=ea(g[H>>2]);E=ea(g[I>>2]);C=ea(g[J>>2]);y=ea(g[K>>2]);A=ea(g[L>>2]);w=ea(g[M>>2]);v=ea(g[p>>2]);z=ea(g[h>>2]);x=ea(g[f>>2]);aa=ea(g[q>>2]);ba=ea(g[e>>2]);N=B;O=G;P=F;Q=D;R=E;S=C;T=y;U=A;V=w;W=v;X=z;Y=x;Z=aa;_=ba;$=ea(g[b>>2])}g[s>>2]=N;g[s+4>>2]=O;g[s+8>>2]=P;g[s+12>>2]=Q;g[s+16>>2]=R;g[s+20>>2]=S;g[s+24>>2]=T;g[s+28>>2]=U;g[s+32>>2]=V;g[s+36>>2]=W;g[s+40>>2]=X;g[s+44>>2]=Y;g[s+48>>2]=Z;g[s+52>>2]=_;g[s+56>>2]=$;vQa(s,1,o,n,1);if(!(c[m>>2]|0)){ca=n+8|0;I6a(ca);da=k+4096|0;fa=c[da>>2]|0;ga=(fa|0)!=0;i=j;return ga|0}else{o=n+8|0;H6a(o,n+5692|0);c[m>>2]=0;ca=o;I6a(ca);da=k+4096|0;fa=c[da>>2]|0;ga=(fa|0)!=0;i=j;return ga|0}return 0}function _Na(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;h=i;i=i+5744|0;k=h+5716|0;l=h+5704|0;m=h+5680|0;n=h;c[k+12>>2]=c[b+4>>2];c[k+16>>2]=b;g[k+4>>2]=ea(ea(1.0)/ea(g[b+8>>2]));g[k>>2]=ea(ea(1.0)/ea(g[b+12>>2]));g[k+8>>2]=ea(ea(1.0)/ea(g[b+16>>2]));o=ea(g[d+16>>2]);p=ea(o-ea(g[e+16>>2]));o=ea(g[d+20>>2]);q=ea(o-ea(g[e+20>>2]));o=ea(g[d+24>>2]);r=ea(p*ea(2.0));p=ea(q*ea(2.0));q=ea(ea(o-ea(g[e+24>>2]))*ea(2.0));o=ea(g[e+12>>2]);s=ea(ea(o*o)+ea(-.5));t=ea(g[e>>2]);u=ea(r*t);v=ea(g[e+4>>2]);w=ea(u+ea(p*v));u=ea(g[e+8>>2]);x=ea(w+ea(q*u));w=ea(ea(t*x)+ea(ea(r*s)-ea(o*ea(ea(q*v)-ea(p*u)))));y=ea(ea(v*x)+ea(ea(p*s)-ea(o*ea(ea(r*u)-ea(q*t)))));z=ea(ea(ea(q*s)-ea(o*ea(ea(p*t)-ea(r*v))))+ea(u*x));g[l>>2]=w;g[l+4>>2]=y;g[l+8>>2]=z;x=ea(g[a+4>>2]);u=ea(x+ea(g[f>>2]));x=ea(y-u);v=ea(z-u);r=ea(w+u);t=ea(u+y);y=ea(u+z);g[m>>2]=ea(w-u);g[m+4>>2]=x;g[m+8>>2]=v;g[m+12>>2]=r;g[m+16>>2]=t;g[m+20>>2]=y;c[n>>2]=539584;c[n+4>>2]=539616;c[n+8>>2]=a;c[n+12>>2]=d;c[n+16>>2]=e;c[n+20>>2]=j;c[n+24>>2]=l;g[n+28>>2]=u;c[n+32>>2]=0;c[n+5284>>2]=0;l=n+5220|0;d=l+64|0;do{c[l>>2]=-1;l=l+4|0}while((l|0)<(d|0));c[n+5672>>2]=0;l=n+5608|0;d=l+64|0;do{c[l>>2]=-1;l=l+4|0}while((l|0)<(d|0));c[n+5676>>2]=k;KRa(k,e,m,0,n)|0;I6a(n+4|0);i=h;return (c[j+4096>>2]|0)!=0|0}function $Na(a,b){a=ea(a);b=ea(b);var c=0,d=0,e=0;c=i;do if(a==ea(0.0))if(b==ea(0.0))d=0;else{e=b==ea(1.0);d=e?2:5}else{e=b==ea(0.0);if(a==ea(1.0)){d=e?1:7;break}if(e)d=3;else{e=!(ea(a+b)>=ea(.999899983));d=e?6:4}}while(0);i=c;return d|0}function aOa(a,b,c){a=a|0;b=ea(b);c=ea(c);var d=0,e=0,f=0,g=0,h=0;d=i;do if(b==ea(0.0))if(c==ea(0.0))e=9;else{f=c==ea(1.0);g=f?2:5;e=8}else{f=c==ea(0.0);if(b==ea(1.0)){g=f?1:7;e=8;break}if(f)e=12;else{f=!(ea(b+c)>=ea(.999899983));g=f?6:4;e=8}}while(0);a:do if((e|0)==8)switch(g|0){case 5:{i=d;return (a&32)==0|0}case 2:{h=(a&48)==0;break a;break}case 1:{h=(a&24)==0;break a;break}case 0:{e=9;break a;break}case 3:{e=12;break a;break}case 4:{h=(a&16)==0;break a;break}case 6:{h=1;break a;break}default:{h=0;break a}}while(0);if((e|0)==9)h=(a&40)==0;else if((e|0)==12)h=(a&8)==0;i=d;return h|0}function bOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=0,m=Im,n=Im,o=0;d=i;e=c[a>>2]|0;f=a+(e*12|0)+4|0;a:do if((e|0)>0){h=ea(g[b>>2]);j=ea(g[b+4>>2]);k=ea(g[b+8>>2]);l=a+4|0;while(1){m=ea(h*ea(g[l>>2]));n=ea(m+ea(j*ea(g[l+4>>2])));if(ea(S(ea(n+ea(k*ea(g[l+8>>2])))))>ea(.999899983)){o=0;break}l=l+12|0;if(l>>>0>=f>>>0)break a}i=d;return o|0}while(0);if(e>>>0>=256){o=0;i=d;return o|0}c[a>>2]=e+1;g[a+(e*12|0)+4>>2]=ea(g[b>>2]);g[a+(e*12|0)+8>>2]=ea(g[b+4>>2]);g[a+(e*12|0)+12>>2]=ea(g[b+8>>2]);o=1;i=d;return o|0}function cOa(a){a=a|0;var c=0,d=0;c=i;d=a+0|0;a=d+28|0;do{b[d>>1]=0;d=d+2|0}while((d|0)<(a|0));i=c;return}function dOa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;VJa(b+3|0,c[a+4>>2]|0);d=c[a+24>>2]|0;if(!d){VJa(b+1|0,c[a+16>>2]|0);VJa(b,c[a+20>>2]|0);i=b;return}else{VJa(b+2|0,d);i=b;return}}function eOa(a){a=a|0;var d=0,f=0,g=0,h=0,j=0;d=i;f=c[a+16>>2]|0;b[f+2>>1]=0;g=c[a+8>>2]|0;if(g>>>0>1){h=0;j=1}else{i=d;return}do{h=(e[f+(j+-1<<2)>>1]|0)+(h&65535)|0;b[f+(j<<2)+2>>1]=h;j=j+1|0}while(j>>>0<g>>>0);i=d;return}function fOa(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g+6|0;if(!(bNa(86,65,76,69,g,h,f)|0)){j=0;i=g;return j|0}k=d+8|0;c[k>>2]=SMa((a[h>>0]|0)!=0,f)|0;l=d+12|0;c[l>>2]=SMa((a[h>>0]|0)!=0,f)|0;m=d+24|0;VJa(g+5|0,c[m>>2]|0);n=(c[k>>2]<<2)+12&-16;o=UJa(g+4|0,n+(c[l>>2]|0)|0,539648,97)|0;c[m>>2]=o;m=d+16|0;c[m>>2]=o;p=d+20|0;c[p>>2]=o+n;n=(SMa((a[h>>0]|0)!=0,f)|0)&65535;hNa(n,c[k>>2]|0,o,f,(a[h>>0]|0)!=0);h=c[k>>2]|0;if(h){n=c[m>>2]|0;d=0;do{q=h-d+-1|0;b[n+(q<<2)>>1]=b[o+(q<<1)>>1]|0;d=d+1|0}while(d>>>0<h>>>0)}xo[c[c[f>>2]>>2]&2047](f,c[p>>2]|0,c[l>>2]|0)|0;l=c[m>>2]|0;b[l+2>>1]=0;m=c[k>>2]|0;if(m>>>0>1){r=0;s=1}else{j=1;i=g;return j|0}do{r=(e[l+(s+-1<<2)>>1]|0)+(r&65535)|0;b[l+(s<<2)+2>>1]=r;s=s+1|0}while((s|0)!=(m|0));j=1;i=g;return j|0}function gOa(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=g+5|0;if(!(bNa(83,85,80,77,h,j,f)|0)){k=0;i=g;return k|0}if(!(bNa(71,65,85,83,h,j,f)|0)){k=0;i=g;return k|0}b[d>>1]=SMa((a[j>>0]|0)!=0,f)|0;h=SMa((a[j>>0]|0)!=0,f)|0;j=d+2|0;b[j>>1]=h;l=UJa(g+4|0,h<<1&131070,539648,159)|0;c[d+4>>2]=l;xo[c[c[f>>2]>>2]&2047](f,l,e[j>>1]<<1)|0;k=fOa(d,f)|0;i=g;return k|0}function hOa(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;f=a+4|0;if(c[f>>2]|0){In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[f>>2]|0,(e[a+2>>1]|0)<<1)}f=a+16|0;if(!(c[f>>2]|0)){i=d;return}In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[f>>2]|0,((c[a+8>>2]<<2)+12&-16)+(c[a+12>>2]|0)|0);i=d;return}function iOa(b,e,f,h,j,k,l,m,n){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;o=i;if(j){c[b>>2]=k;c[e>>2]=l;i=o;return}c[e>>2]=h;c[b>>2]=f;if(!m){i=o;return}f=n+4|0;h=n+8|0;j=n+12|0;p=n+16|0;q=n+20|0;r=n+24|0;s=n+28|0;t=n+32|0;u=0;do{a[(c[e>>2]|0)+u>>0]=u;v=c[b>>2]|0;w=d[l+u>>0]|0;x=ea(g[k+(w*12|0)>>2]);y=ea(x*ea(g[n>>2]));z=ea(x*ea(g[f>>2]));A=ea(x*ea(g[h>>2]));x=ea(g[k+(w*12|0)+4>>2]);B=ea(x*ea(g[j>>2]));C=ea(x*ea(g[p>>2]));D=ea(y+B);B=ea(z+C);C=ea(A+ea(x*ea(g[q>>2])));x=ea(g[k+(w*12|0)+8>>2]);A=ea(x*ea(g[r>>2]));z=ea(x*ea(g[s>>2]));y=ea(B+z);z=ea(C+ea(x*ea(g[t>>2])));g[v+(u*12|0)>>2]=ea(D+A);g[v+(u*12|0)+4>>2]=y;g[v+(u*12|0)+8>>2]=z;u=u+1|0}while((u|0)!=(m|0));i=o;return}function jOa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0;f=i;h=a+4|0;if((ea(g[h>>2])==ea(1.0)?ea(g[a+8>>2])==ea(1.0):0)?ea(g[a+12>>2])==ea(1.0):0){j=a+36|0;k=c[j>>2]|0;l=ea(g[k>>2]);m=ea(g[k+12>>2]);n=ea(l+m);o=ea(g[k+4>>2]);p=ea(g[k+16>>2]);q=ea(o+p);r=ea(g[k+8>>2]);s=ea(g[k+20>>2]);t=ea(n*ea(.5));n=ea(q*ea(.5));q=ea(ea(r+s)*ea(.5));u=ea(g[b>>2]);v=ea(t*u);w=ea(g[b+4>>2]);x=ea(t*w);y=ea(g[b+8>>2]);z=ea(t*y);t=ea(g[b+12>>2]);A=ea(n*t);B=ea(g[b+16>>2]);C=ea(n*B);D=ea(g[b+20>>2]);E=ea(v+A);A=ea(x+C);C=ea(z+ea(n*D));n=ea(g[b+24>>2]);z=ea(q*n);x=ea(g[b+28>>2]);v=ea(q*x);F=ea(g[b+32>>2]);G=ea(E+z);z=ea(A+v);v=ea(C+ea(q*F));q=ea(ea(m-l)*ea(.5));l=ea(ea(p-o)*ea(.5));o=ea(ea(s-r)*ea(.5));r=ea(ea(ea(S(ea(q*u)))+ea(S(ea(l*t))))+ea(S(ea(o*n))));n=ea(ea(ea(S(ea(q*w)))+ea(S(ea(l*B))))+ea(S(ea(o*x))));x=ea(ea(ea(S(ea(q*y)))+ea(S(ea(l*D))))+ea(S(ea(o*F))));F=ea(z-n);o=ea(v-x);D=ea(G+r);l=ea(z+n);n=ea(v+x);g[d>>2]=ea(G-r);g[d+4>>2]=F;g[d+8>>2]=o;g[d+12>>2]=D;g[d+16>>2]=l;g[d+20>>2]=n;EOa(e,c[j>>2]|0,b);H=1;i=f;return H|0}J0a(b,h,a+16|0);h=a+36|0;a=c[h>>2]|0;n=ea(g[a>>2]);l=ea(g[a+12>>2]);D=ea(n+l);o=ea(g[a+4>>2]);F=ea(g[a+16>>2]);r=ea(o+F);G=ea(g[a+8>>2]);x=ea(g[a+20>>2]);v=ea(D*ea(.5));D=ea(r*ea(.5));r=ea(ea(G+x)*ea(.5));z=ea(g[b>>2]);y=ea(v*z);q=ea(g[b+4>>2]);B=ea(v*q);w=ea(g[b+8>>2]);t=ea(v*w);v=ea(g[b+12>>2]);u=ea(D*v);s=ea(g[b+16>>2]);p=ea(D*s);m=ea(g[b+20>>2]);C=ea(y+u);u=ea(B+p);p=ea(t+ea(D*m));D=ea(g[b+24>>2]);t=ea(r*D);B=ea(g[b+28>>2]);y=ea(r*B);A=ea(g[b+32>>2]);E=ea(C+t);t=ea(u+y);y=ea(p+ea(r*A));r=ea(ea(l-n)*ea(.5));n=ea(ea(F-o)*ea(.5));o=ea(ea(x-G)*ea(.5));G=ea(ea(ea(S(ea(r*z)))+ea(S(ea(n*v))))+ea(S(ea(o*D))));D=ea(ea(ea(S(ea(r*q)))+ea(S(ea(n*s))))+ea(S(ea(o*B))));B=ea(ea(ea(S(ea(r*w)))+ea(S(ea(n*m))))+ea(S(ea(o*A))));A=ea(t-D);o=ea(y-B);m=ea(E+G);n=ea(t+D);D=ea(y+B);g[d>>2]=ea(E-G);g[d+4>>2]=A;g[d+8>>2]=o;g[d+12>>2]=m;g[d+16>>2]=n;g[d+20>>2]=D;EOa(e,c[h>>2]|0,b);b=e+40|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;H=0;i=f;return H|0}function kOa(b,c,d,f,h){b=b|0;c=c|0;d=d|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=0;j=i;if(!d){k=0;i=j;return k|0}else{l=f;m=d;n=0}a:while(1){m=m+-1|0;d=e[l+16>>1]|0;f=a[l+18>>0]|0;o=f&255;if(!(f<<24>>24))p=n;else{f=l+4|0;q=l+8|0;r=o;s=o+-1|0;o=0;t=n;while(1){r=r+-1|0;u=a[h+(s+d)>>0]|0;v=a[h+(o+d)>>0]|0;w=(v&255)<(u&255);x=w?v:u;y=w?u:v;b:do if(!t)z=10;else{v=0;while(1){if((a[c+(v<<4)>>0]|0)==x<<24>>24?(a[c+(v<<4)+1>>0]|0)==y<<24>>24:0)break;u=v+1|0;if(u>>>0<t>>>0)v=u;else{z=10;break b}}A=ea(g[l>>2]);u=c+(v<<4)+4|0;g[u>>2]=ea(A+ea(g[u>>2]));A=ea(g[f>>2]);u=c+(v<<4)+8|0;g[u>>2]=ea(A+ea(g[u>>2]));A=ea(g[q>>2]);u=c+(v<<4)+12|0;g[u>>2]=ea(A+ea(g[u>>2]));B=t}while(0);if((z|0)==10){z=0;if((t|0)==(b|0)){k=b;z=13;break a}a[c+(t<<4)>>0]=x;a[c+(t<<4)+1>>0]=y;g[c+(t<<4)+4>>2]=ea(g[l>>2]);g[c+(t<<4)+8>>2]=ea(g[f>>2]);g[c+(t<<4)+12>>2]=ea(g[q>>2]);B=t+1|0}if(!r){p=B;break}else{u=o;o=o+1|0;t=B;s=u}}}l=l+20|0;if(!m){k=p;z=13;break}else n=p}if((z|0)==13){i=j;return k|0}return 0}function lOa(a,e,f){a=a|0;e=e|0;f=f|0;var h=0,j=0,k=0;h=i;if((d[a+55>>0]|0)>>>0<=e>>>0){j=0;i=h;return j|0}k=c[a+56>>2]|0;g[f>>2]=ea(g[k+(e*20|0)>>2]);g[f+4>>2]=ea(g[k+(e*20|0)+4>>2]);g[f+8>>2]=ea(g[k+(e*20|0)+8>>2]);g[f+12>>2]=ea(g[k+(e*20|0)+12>>2]);b[f+16>>1]=d[k+(e*20|0)+18>>0]|0;b[f+18>>1]=b[k+(e*20|0)+16>>1]|0;j=1;i=h;return j|0}function mOa(a){a=a|0;var d=0,e=0;d=i;b[a+4>>1]=2;b[a+6>>1]=3;c[a>>2]=540264;e=a+8|0;c[e>>2]=434952;c[a+12>>2]=1;c[a>>2]=539744;c[e>>2]=539820;c[a+80>>2]=0;c[a+84>>2]=0;g[a+88>>2]=ea(0.0);g[a+92>>2]=ea(1.0);g[a+96>>2]=ea(0.0);g[a+100>>2]=ea(0.0);g[a+104>>2]=ea(0.0);g[a+108>>2]=ea(1.0);g[a+112>>2]=ea(0.0);g[a+116>>2]=ea(0.0);g[a+120>>2]=ea(0.0);g[a+124>>2]=ea(1.0);g[a+16>>2]=ea(8507058669999999534545717.0e13);g[a+20>>2]=ea(8507058669999999534545717.0e13);g[a+24>>2]=ea(8507058669999999534545717.0e13);g[a+28>>2]=ea(-8507058669999999534545717.0e13);g[a+32>>2]=ea(-8507058669999999534545717.0e13);g[a+36>>2]=ea(-8507058669999999534545717.0e13);e=a+40|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));i=d;return}function nOa(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+1|0;c[a>>2]=539744;c[a+8>>2]=539820;if(!(b[a+6>>1]&1)){VJa(e,a);i=d;return}f=a+56|0;VJa(d,c[f>>2]|0);c[f>>2]=0;f=a+84|0;g=c[f>>2]|0;if(g){dOa(g);VJa(e,g)}c[f>>2]=0;VJa(e,a);i=d;return}function oOa(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+1|0;f=a+-8|0;c[f>>2]=539744;c[f+8>>2]=539820;if(!(b[f+6>>1]&1)){VJa(e,f);i=d;return}a=f+56|0;VJa(d,c[a>>2]|0);c[a>>2]=0;a=f+84|0;g=c[a>>2]|0;if(g){dOa(g);VJa(e,g)}c[a>>2]=0;VJa(e,f);i=d;return}function pOa(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;c[a>>2]=539744;c[a+8>>2]=539820;if(!(b[a+6>>1]&1)){i=d;return}e=a+56|0;VJa(d,c[e>>2]|0);c[e>>2]=0;e=a+84|0;a=c[e>>2]|0;if(a){dOa(a);VJa(d+1|0,a)}c[e>>2]=0;i=d;return}function qOa(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=a+-8|0;c[e>>2]=539744;c[e+8>>2]=539820;if(!(b[e+6>>1]&1)){i=d;return}a=e+56|0;VJa(d,c[a>>2]|0);c[a>>2]=0;a=e+84|0;e=c[a>>2]|0;if(e){dOa(e);VJa(d+1|0,e)}c[a>>2]=0;i=d;return}function rOa(a,b){a=a|0;b=b|0;var f=0,g=0,h=0,j=0;f=i;In[c[(c[b>>2]|0)+12>>2]&4095](b,16);g=((d[a+55>>0]|0)*20|0)+(c[a+80>>2]&2147483647)+((d[a+54>>0]|0)*15|0)+((e[a+52>>1]|0)<<1)|0;h=g&3;if(!h)j=g;else j=g+4-h|0;co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+56>>2]|0,j);j=a+84|0;if(!(c[j>>2]|0)){i=f;return}In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[j>>2]|0,28);hOa(c[j>>2]|0,b);i=f;return}function sOa(f,h){f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;j=i;i=i+80|0;k=j;l=j+64|0;m=j+8|0;n=j+24|0;o=j+65|0;p=j+32|0;if(!(aNa(67,86,88,77,n,o,h)|0)){q=0;i=j;return q|0}if((c[n>>2]|0)>>>0<13){dKa(bKa()|0,32,539832,236,539920,k);q=0;i=j;return q|0}SMa((a[o>>0]|0)!=0,h)|0;if(!(bNa(67,76,72,76,k,l,h)|0)){q=0;i=j;return q|0}if(!(bNa(67,86,72,76,k,l,h)|0)){q=0;i=j;return q|0}XMa(m,4,(a[l>>0]|0)!=0,h)|0;n=c[m>>2]|0;r=f+54|0;a[r>>0]=n;s=c[m+4>>2]|0;t=f+52|0;b[t>>1]=s;u=c[m+8>>2]|0;v=f+55|0;a[v>>0]=u;w=c[m+12>>2]|0;m=w+((n&255)*15|0)+(s<<1&131070)+((u&255)*20|0)|0;u=m&3;if(!u)x=m;else x=m+4-u|0;u=f+56|0;VJa(j+66|0,c[u>>2]|0);c[f+80>>2]=w;m=UJa(j+67|0,x,539832,175)|0;c[u>>2]=m;x=(d[v>>0]|0)*20|0;s=d[r>>0]|0;n=(s*12|0)+x|0;y=m+n|0;z=n+(e[t>>1]<<1)|0;n=m+z|0;A=s*3|0;s=m+(z+A)|0;XMa(m+x|0,A,(a[l>>0]|0)!=0,h)|0;if((c[k>>2]|0)>>>0<6)RMa((a[l>>0]|0)!=0,h)|0;xo[c[c[h>>2]>>2]&2047](h,c[u>>2]|0,(d[v>>0]|0)*20|0)|0;if((a[l>>0]|0)!=0?(a[v>>0]|0)!=0:0){l=0;do{A=c[u>>2]|0;x=A+(l*20|0)|0;B=a[x>>0]|0;C=x+3|0;a[x>>0]=a[C>>0]|0;a[C>>0]=B;B=x+1|0;C=a[B>>0]|0;D=x+2|0;a[B>>0]=a[D>>0]|0;a[D>>0]=C;C=A+(l*20|0)+4|0;D=a[C>>0]|0;B=C+3|0;a[C>>0]=a[B>>0]|0;a[B>>0]=D;D=C+1|0;B=a[D>>0]|0;x=C+2|0;a[D>>0]=a[x>>0]|0;a[x>>0]=B;B=A+(l*20|0)+8|0;x=a[B>>0]|0;D=B+3|0;a[B>>0]=a[D>>0]|0;a[D>>0]=x;x=B+1|0;D=a[x>>0]|0;C=B+2|0;a[x>>0]=a[C>>0]|0;a[C>>0]=D;D=A+(l*20|0)+12|0;C=a[D>>0]|0;x=D+3|0;a[D>>0]=a[x>>0]|0;a[x>>0]=C;C=D+1|0;x=a[C>>0]|0;B=D+2|0;a[C>>0]=a[B>>0]|0;a[B>>0]=x;x=A+(l*20|0)+16|0;A=a[x>>0]|0;B=x+1|0;a[x>>0]=a[B>>0]|0;a[B>>0]=A;l=l+1|0}while(l>>>0<(d[v>>0]|0)>>>0)}xo[c[c[h>>2]>>2]&2047](h,s,w)|0;xo[c[c[h>>2]>>2]&2047](h,y,e[t>>1]<<1)|0;if((c[k>>2]|0)>>>0<7){if(a[r>>0]|0){t=z|1;y=z+2|0;w=0;do{s=w*3|0;a[m+(s+z)>>0]=-1;a[m+(s+t)>>0]=-1;a[m+(y+s)>>0]=-1;w=w+1|0}while(w>>>0<(d[r>>0]|0)>>>0)}}else xo[c[c[h>>2]>>2]&2047](h,n,(d[r>>0]|0)*3|0)|0;XMa(p,8,(a[o>>0]|0)!=0,h)|0;E=ea(g[p+4>>2]);F=ea(g[p+8>>2]);G=ea(g[p+12>>2]);H=ea(g[p+16>>2]);I=ea(g[p+20>>2]);J=ea(g[p+24>>2]);g[f+16>>2]=E;g[f+20>>2]=F;g[f+24>>2]=G;g[f+28>>2]=H;g[f+32>>2]=I;g[f+36>>2]=J;J=ea(g[p+28>>2]);g[f+88>>2]=J;if(J!=ea(-1.0)){XMa(f+92|0,9,(a[o>>0]|0)!=0,h)|0;XMa(f+40|0,3,(a[o>>0]|0)!=0,h)|0}if(ea(TMa((a[o>>0]|0)!=0,h))!=ea(-1.0)){p=f+84|0;r=c[p>>2]|0;if(r){dOa(r);VJa(k,r)}c[p>>2]=0;r=mKa()|0;k=c[(c[r>>2]|0)+8>>2]|0;n=pKa()|0;w=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[k&255](r,28,w?540136:544544,539832,269)|0;cOa(n);c[p>>2]=n;if(n){gOa(n,h)|0;c[f+60>>2]=c[p>>2]}}g[f+64>>2]=ea(TMa((a[o>>0]|0)!=0,h));g[f+68>>2]=ea(TMa((a[o>>0]|0)!=0,h));g[f+72>>2]=ea(TMa((a[o>>0]|0)!=0,h));g[f+76>>2]=ea(TMa((a[o>>0]|0)!=0,h));q=1;i=j;return q|0}function tOa(a){a=a|0;var d=0,e=0;d=i;nMa(c[a+128>>2]|0,a,2,0);e=a+6|0;b[e>>1]=b[e>>1]&-3;e=a+8|0;if(gTa(a+12|0)|0){i=d;return}ko[c[(c[e>>2]|0)+8>>2]&4095](e);i=d;return}function uOa(a){a=a|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=((d[a+55>>0]|0)*20|0)+(c[a+80>>2]&2147483647)+((d[a+54>>0]|0)*15|0)+((e[a+52>>1]|0)<<1)|0;j=h&3;if(!j)k=h;else k=h+4-j|0;j=a+128|0;if((k|0)!=0?!(dMa(c[j>>2]|0,a)|0):0){dKa(bKa()|0,8,539832,316,540080,g);i=f;return}g=c[j>>2]|0;j=c[a>>2]|0;if(!(b[a+6>>1]&1))ko[c[j+12>>2]&4095](a);else ko[c[j+16>>2]&4095](a);nMa(g,a,2,1);i=f;return}function vOa(a){a=a|0;var b=0;b=i;uOa(a+-8|0);i=b;return}function wOa(a){a=a|0;return c[a+12>>2]|0}function xOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;g[b>>2]=ea(g[a+88>>2]);g[c>>2]=ea(g[a+92>>2]);g[c+4>>2]=ea(g[a+96>>2]);g[c+8>>2]=ea(g[a+100>>2]);g[c+12>>2]=ea(g[a+104>>2]);g[c+16>>2]=ea(g[a+108>>2]);g[c+20>>2]=ea(g[a+112>>2]);g[c+24>>2]=ea(g[a+116>>2]);g[c+28>>2]=ea(g[a+120>>2]);g[c+32>>2]=ea(g[a+124>>2]);g[d>>2]=ea(g[a+40>>2]);g[d+4>>2]=ea(g[a+44>>2]);g[d+8>>2]=ea(g[a+48>>2]);return}function yOa(f,h,j,k,l,m,n,o){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=0;o=i;i=i+96|0;m=o+64|0;p=o;a:do if(!((l&1073741824|0)==0&0==0)?(q=c[f+56>>2]|0,r=a[f+55>>0]|0,s=r&255,t=q+(s*20|0)|0,r<<24>>24!=0):0){r=j+36|0;u=j+40|0;v=j+44|0;w=k+12|0;x=k+4|0;y=k+16|0;z=k+8|0;A=k+20|0;B=0;C=q+(s*20|0)+(((e[f+52>>1]|0)<<1)+((d[f+54>>0]|0)*15|0))|0;b:while(1){D=a[q+(B*20|0)+18>>0]|0;E=D&255;if((D&255)>1){n=ea(g[r>>2]);F=ea(g[u>>2]);G=ea(g[v>>2]);H=ea(g[k>>2]);D=1;do{I=d[C+D>>0]|0;J=ea(n+ea(g[t+(I*12|0)>>2]));K=ea(F+ea(g[t+(I*12|0)+4>>2]));L=ea(G+ea(g[t+(I*12|0)+8>>2]));if(J<H){M=33;break b}if(J>ea(g[w>>2])){M=33;break b}if(K<ea(g[x>>2])){M=33;break b}if(K>ea(g[y>>2])){M=33;break b}if(L<ea(g[z>>2])){M=33;break b}D=D+1|0;if(L>ea(g[A>>2])){M=33;break b}}while(D>>>0<E>>>0)}B=B+1|0;if(B>>>0>=s>>>0)break a;else C=C+E|0}if((M|0)==33){i=o;return}}while(0);if((l&8192|0)==0&0==0){i=o;return}l=f+56|0;M=c[l>>2]|0;k=a[f+55>>0]|0;C=k&255;s=M+(C*20|0)|0;B=a[f+54>>0]|0;A=b[f+52>>1]|0;jLa(p,j);DKa(EKa(h,p)|0,-65281)|0;if(!(k<<24>>24)){i=o;return}k=p+4|0;j=p+8|0;f=p+16|0;z=p+20|0;y=p+24|0;x=p+32|0;w=p+36|0;t=p+40|0;v=p+48|0;u=p+52|0;r=p+56|0;q=h+100|0;D=h+4|0;h=m+4|0;I=m+8|0;N=m+12|0;O=m+16|0;P=m+20|0;Q=m+24|0;R=m+28|0;S=m+4|0;T=m+8|0;U=m+12|0;V=m+16|0;W=m+20|0;X=m+24|0;Y=m+28|0;Z=0;_=M+(C*20|0)+(((A&65535)<<1)+((B&255)*15|0))|0;while(1){B=a[(c[l>>2]|0)+(Z*20|0)+18>>0]|0;A=B&255;M=d[_>>0]|0;H=ea(g[s+(M*12|0)>>2]);G=ea(g[s+(M*12|0)+4>>2]);F=ea(g[s+(M*12|0)+8>>2]);n=ea(g[p>>2]);L=ea(H*n);K=ea(g[k>>2]);J=ea(H*K);$=ea(g[j>>2]);aa=ea(H*$);ba=ea(g[f>>2]);ca=ea(G*ba);da=ea(g[z>>2]);fa=ea(G*da);ga=ea(g[y>>2]);ha=ea(L+ca);ca=ea(J+fa);fa=ea(aa+ea(G*ga));aa=ea(g[x>>2]);J=ea(F*aa);L=ea(g[w>>2]);ia=ea(F*L);ja=ea(g[t>>2]);ka=ea(ha+J);J=ea(ca+ia);ia=ea(fa+ea(F*ja));fa=ea(g[v>>2]);ca=ea(g[u>>2]);ha=ea(g[r>>2]);la=ea(ka+fa);ka=ea(J+ca);J=ea(ia+ha);if((B&255)>1){ia=n;ma=K;na=$;oa=ba;pa=da;qa=ga;ra=aa;sa=L;ta=ja;ua=fa;va=ca;wa=ha;xa=la;ya=ka;za=J;B=1;while(1){M=d[_+B>>0]|0;Aa=ea(g[s+(M*12|0)>>2]);Ba=ea(g[s+(M*12|0)+4>>2]);Ca=ea(g[s+(M*12|0)+8>>2]);Da=ea(ea(ea(ea(Aa*ia)+ea(Ba*oa))+ea(Ca*ra))+ua);Ea=ea(ea(ea(ea(Aa*ma)+ea(Ba*pa))+ea(Ca*sa))+va);Fa=ea(ea(ea(ea(Aa*na)+ea(Ba*qa))+ea(Ca*ta))+wa);M=c[q>>2]|0;Ga=M+16|0;g[m>>2]=xa;g[S>>2]=ya;g[T>>2]=za;Ha=c[D>>2]|0;c[U>>2]=Ha;g[V>>2]=Da;g[W>>2]=Ea;g[X>>2]=Fa;c[Y>>2]=Ha;Ia=M+20|0;Ja=c[Ia>>2]|0;if((c[M+24>>2]&2147483647)>>>0>Ja>>>0){M=c[Ga>>2]|0;Ka=M+(Ja<<5)|0;if(!Ka)La=Ja;else{g[Ka>>2]=xa;g[M+(Ja<<5)+4>>2]=ya;g[M+(Ja<<5)+8>>2]=za;c[M+(Ja<<5)+12>>2]=Ha;g[M+(Ja<<5)+16>>2]=Da;g[M+(Ja<<5)+20>>2]=Ea;g[M+(Ja<<5)+24>>2]=Fa;c[M+(Ja<<5)+28>>2]=Ha;La=c[Ia>>2]|0}c[Ia>>2]=La+1}else Z5a(Ga,m)|0;Ga=B+1|0;if((Ga|0)==(A|0))break;Ca=ea(g[p>>2]);Ba=ea(g[k>>2]);Aa=ea(g[j>>2]);Ma=ea(g[f>>2]);Na=ea(g[z>>2]);Oa=ea(g[y>>2]);Pa=ea(g[x>>2]);Qa=ea(g[w>>2]);Ra=ea(g[t>>2]);Sa=ea(g[v>>2]);Ta=ea(g[u>>2]);ia=Ca;ma=Ba;na=Aa;oa=Ma;pa=Na;qa=Oa;ra=Pa;sa=Qa;ta=Ra;ua=Sa;va=Ta;wa=ea(g[r>>2]);xa=Da;ya=Ea;za=Fa;B=Ga}B=d[_>>0]|0;za=ea(g[s+(B*12|0)>>2]);ya=ea(g[s+(B*12|0)+4>>2]);xa=ea(g[s+(B*12|0)+8>>2]);wa=ea(g[p>>2]);va=ea(g[k>>2]);ua=ea(g[j>>2]);ta=ea(g[f>>2]);sa=ea(g[z>>2]);ra=ea(g[y>>2]);qa=ea(g[x>>2]);pa=ea(g[w>>2]);oa=ea(g[t>>2]);na=ea(g[v>>2]);ma=ea(g[u>>2]);Ua=Fa;Va=Ea;Wa=Da;Xa=za;Ya=wa;Za=va;_a=ua;$a=ya;ab=ta;bb=sa;cb=ra;db=xa;eb=qa;fb=pa;gb=oa;hb=na;ib=ma;jb=ea(g[r>>2])}else{Ua=J;Va=ka;Wa=la;Xa=H;Ya=n;Za=K;_a=$;$a=G;ab=ba;bb=da;cb=ga;db=F;eb=aa;fb=L;gb=ja;hb=fa;ib=ca;jb=ha}ma=ea(ea(ea(ea(Xa*Ya)+ea($a*ab))+ea(db*eb))+hb);na=ea(ea(ea(ea(Xa*Za)+ea($a*bb))+ea(db*fb))+ib);oa=ea(ea(ea(ea(Xa*_a)+ea($a*cb))+ea(db*gb))+jb);B=c[q>>2]|0;Ga=B+16|0;g[m>>2]=Wa;g[h>>2]=Va;g[I>>2]=Ua;Ia=c[D>>2]|0;c[N>>2]=Ia;g[O>>2]=ma;g[P>>2]=na;g[Q>>2]=oa;c[R>>2]=Ia;Ha=B+20|0;Ja=c[Ha>>2]|0;if((c[B+24>>2]&2147483647)>>>0>Ja>>>0){B=c[Ga>>2]|0;M=B+(Ja<<5)|0;if(!M)kb=Ja;else{g[M>>2]=Wa;g[B+(Ja<<5)+4>>2]=Va;g[B+(Ja<<5)+8>>2]=Ua;c[B+(Ja<<5)+12>>2]=Ia;g[B+(Ja<<5)+16>>2]=ma;g[B+(Ja<<5)+20>>2]=na;g[B+(Ja<<5)+24>>2]=oa;c[B+(Ja<<5)+28>>2]=Ia;kb=c[Ha>>2]|0}c[Ha>>2]=kb+1}else Z5a(Ga,m)|0;Ga=Z+1|0;if((Ga|0)==(C|0))break;Z=Ga;_=_+A|0}i=o;return}function zOa(a,b,c,d,e,f,h,j){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0,ha=Im,ia=0,ja=Im,ka=0,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;k=i;i=i+64|0;l=k+48|0;m=k+36|0;n=k;o=ea(g[b>>2]);p=ea(g[b+12>>2]);q=ea(o+p);r=ea(g[b+4>>2]);s=ea(g[b+16>>2]);t=ea(r+s);u=ea(g[b+8>>2]);v=ea(g[b+20>>2]);w=ea(ea(q*ea(.5))*ea(2.0));q=ea(ea(t*ea(.5))*ea(2.0));t=ea(ea(ea(u+v)*ea(.5))*ea(2.0));x=ea(g[d+12>>2]);y=ea(ea(x*x)+ea(-.5));z=ea(g[d>>2]);A=ea(w*z);B=ea(g[d+4>>2]);C=ea(A+ea(q*B));A=ea(g[d+8>>2]);D=ea(C+ea(t*A));C=ea(ea(z*D)+ea(ea(w*y)+ea(x*ea(ea(t*B)-ea(q*A)))));E=ea(ea(B*D)+ea(ea(q*y)+ea(x*ea(ea(w*A)-ea(z*t)))));F=ea(ea(ea(t*y)+ea(x*ea(ea(q*z)-ea(w*B))))+ea(A*D));D=ea(ea(g[d+16>>2])+C);C=ea(ea(g[d+20>>2])+E);E=ea(ea(g[d+24>>2])+F);d=l+4|0;b=l+8|0;F=ea(ea(s-r)*ea(.5));r=ea(ea(v-u)*ea(.5));G=m+4|0;H=m+8|0;g[m>>2]=ea(ea(ea(p-o)*ea(.5))+c);g[G>>2]=ea(F+c);g[H>>2]=ea(r+c);c=ea(D-ea(g[f+36>>2]));D=ea(C-ea(g[f+40>>2]));C=ea(E-ea(g[f+44>>2]));E=ea(g[f>>2]);r=ea(c*E);F=ea(g[f+4>>2]);o=ea(r+ea(D*F));r=ea(g[f+8>>2]);p=ea(o+ea(C*r));o=ea(g[f+12>>2]);u=ea(c*o);v=ea(g[f+16>>2]);s=ea(u+ea(D*v));u=ea(g[f+20>>2]);A=ea(s+ea(C*u));s=ea(g[f+24>>2]);B=ea(c*s);c=ea(g[f+28>>2]);w=ea(B+ea(D*c));D=ea(g[f+32>>2]);B=ea(w+ea(C*D));g[l>>2]=p;g[d>>2]=A;g[b>>2]=B;C=ea(g[e>>2]);w=ea(g[e+4>>2]);z=ea(g[e+8>>2]);q=ea(g[e+12>>2]);x=ea(g[e+16>>2]);y=ea(g[e+20>>2]);t=ea(g[e+24>>2]);I=ea(g[e+28>>2]);J=ea(g[e+32>>2]);K=ea(ea(ea(E*C)+ea(F*w))+ea(r*z));L=ea(ea(ea(o*C)+ea(v*w))+ea(u*z));M=ea(ea(ea(s*C)+ea(c*w))+ea(D*z));z=ea(ea(ea(E*q)+ea(F*x))+ea(r*y));w=ea(ea(ea(o*q)+ea(v*x))+ea(u*y));C=ea(ea(ea(s*q)+ea(c*x))+ea(D*y));y=ea(ea(ea(E*t)+ea(F*I))+ea(r*J));r=ea(ea(ea(o*t)+ea(v*I))+ea(u*J));u=ea(ea(ea(s*t)+ea(c*I))+ea(D*J));g[n>>2]=K;e=n+4|0;g[e>>2]=L;f=n+8|0;g[f>>2]=M;N=n+12|0;g[N>>2]=z;O=n+16|0;g[O>>2]=w;P=n+20|0;g[P>>2]=C;Q=n+24|0;g[Q>>2]=y;R=n+28|0;g[R>>2]=r;S=n+32|0;g[S>>2]=u;if(j){T=p;U=A;V=B;W=K;X=L;Y=M;Z=z;_=w;$=C;aa=y;ba=r;ca=u;da=a+36|0;g[da>>2]=T;fa=a+40|0;g[fa>>2]=U;ga=a+44|0;g[ga>>2]=V;ha=ea(g[m>>2]);ia=a+48|0;g[ia>>2]=ha;ja=ea(g[G>>2]);ka=a+52|0;g[ka>>2]=ja;la=ea(g[H>>2]);ma=a+56|0;g[ma>>2]=la;g[a>>2]=W;na=a+4|0;g[na>>2]=X;oa=a+8|0;g[oa>>2]=Y;pa=a+12|0;g[pa>>2]=Z;qa=a+16|0;g[qa>>2]=_;ra=a+20|0;g[ra>>2]=$;sa=a+24|0;g[sa>>2]=aa;ta=a+28|0;g[ta>>2]=ba;ua=a+32|0;g[ua>>2]=ca;i=k;return}x6a(h,l,m,n);u=ea(g[l>>2]);r=ea(g[d>>2]);y=ea(g[b>>2]);C=ea(g[n>>2]);w=ea(g[e>>2]);z=ea(g[f>>2]);M=ea(g[N>>2]);L=ea(g[O>>2]);K=ea(g[P>>2]);B=ea(g[Q>>2]);A=ea(g[R>>2]);T=u;U=r;V=y;W=C;X=w;Y=z;Z=M;_=L;$=K;aa=B;ba=A;ca=ea(g[S>>2]);da=a+36|0;g[da>>2]=T;fa=a+40|0;g[fa>>2]=U;ga=a+44|0;g[ga>>2]=V;ha=ea(g[m>>2]);ia=a+48|0;g[ia>>2]=ha;ja=ea(g[G>>2]);ka=a+52|0;g[ka>>2]=ja;la=ea(g[H>>2]);ma=a+56|0;g[ma>>2]=la;g[a>>2]=W;na=a+4|0;g[na>>2]=X;oa=a+8|0;g[oa>>2]=Y;pa=a+12|0;g[pa>>2]=Z;qa=a+16|0;g[qa>>2]=_;ra=a+20|0;g[ra>>2]=$;sa=a+24|0;g[sa>>2]=aa;ta=a+28|0;g[ta>>2]=ba;ua=a+32|0;g[ua>>2]=ca;i=k;return}function AOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im;e=i;i=i+144|0;f=e+96|0;h=e+60|0;j=e;k=ea(g[c>>2]);l=ea(g[c+4>>2]);m=ea(g[c+8>>2]);n=ea(g[c+12>>2]);o=ea(k+k);p=ea(l+l);q=ea(m+m);r=ea(l*p);s=ea(m*q);t=ea(o*l);l=ea(o*m);u=ea(o*n);v=ea(p*m);m=ea(p*n);p=ea(q*n);n=ea(ea(ea(1.0)-r)-s);q=ea(t+p);w=ea(l-m);x=ea(t-p);p=ea(ea(1.0)-ea(k*o));o=ea(p-s);s=ea(v+u);k=ea(l+m);m=ea(v-u);u=ea(p-r);r=ea(g[d+12>>2]);p=ea(g[d+16>>2]);v=ea(g[d+20>>2]);l=ea(g[d+24>>2]);t=ea(r+r);y=ea(p+p);z=ea(v+v);A=ea(p*y);B=ea(v*z);C=ea(t*p);p=ea(t*v);D=ea(t*l);E=ea(y*v);v=ea(y*l);y=ea(z*l);l=ea(ea(ea(1.0)-A)-B);z=ea(C+y);F=ea(p-v);G=ea(C-y);y=ea(ea(1.0)-ea(r*t));t=ea(y-B);B=ea(E+D);r=ea(p+v);v=ea(E-D);D=ea(y-A);A=ea(g[d>>2]);y=ea(A*l);E=ea(A*G);p=ea(A*r);A=ea(g[d+4>>2]);C=ea(z*A);H=ea(t*A);I=ea(v*A);A=ea(g[d+8>>2]);J=ea(F*A);K=ea(B*A);L=ea(D*A);A=ea(ea(ea(l*y)+ea(z*C))+ea(F*J));M=ea(ea(ea(l*E)+ea(z*H))+ea(F*K));N=ea(ea(ea(l*p)+ea(z*I))+ea(F*L));F=ea(ea(ea(G*y)+ea(t*C))+ea(B*J));z=ea(ea(ea(G*E)+ea(t*H))+ea(B*K));l=ea(ea(ea(G*p)+ea(t*I))+ea(B*L));B=ea(ea(ea(r*y)+ea(v*C))+ea(D*J));J=ea(ea(ea(r*E)+ea(v*H))+ea(D*K));K=ea(ea(ea(r*p)+ea(v*I))+ea(D*L));L=ea(ea(m*N)+ea(ea(q*A)+ea(o*M)));D=ea(ea(u*N)+ea(ea(w*A)+ea(s*M)));I=ea(ea(k*l)+ea(ea(n*F)+ea(x*z)));v=ea(ea(m*l)+ea(ea(q*F)+ea(o*z)));p=ea(ea(u*l)+ea(ea(w*F)+ea(s*z)));z=ea(ea(k*K)+ea(ea(n*B)+ea(x*J)));F=ea(ea(m*K)+ea(ea(q*B)+ea(o*J)));o=ea(ea(u*K)+ea(ea(w*B)+ea(s*J)));g[h>>2]=ea(ea(k*N)+ea(ea(n*A)+ea(x*M)));g[h+4>>2]=L;g[h+8>>2]=D;g[h+12>>2]=I;g[h+16>>2]=v;g[h+20>>2]=p;g[h+24>>2]=z;g[h+28>>2]=F;g[h+32>>2]=o;F0a(f,h);o=ea(-ea(g[c+16>>2]));F=ea(-ea(g[c+20>>2]));z=ea(-ea(g[c+24>>2]));p=ea(g[f>>2]);v=ea(p*o);I=ea(g[f+4>>2]);D=ea(I*o);L=ea(g[f+8>>2]);M=ea(L*o);o=ea(g[f+12>>2]);x=ea(o*F);A=ea(g[f+16>>2]);n=ea(A*F);N=ea(g[f+20>>2]);k=ea(v+x);x=ea(D+n);n=ea(M+ea(N*F));F=ea(g[f+24>>2]);M=ea(F*z);D=ea(g[f+28>>2]);v=ea(D*z);J=ea(g[f+32>>2]);s=ea(k+M);M=ea(x+v);v=ea(n+ea(J*z));g[f>>2]=p;g[f+4>>2]=I;g[f+8>>2]=L;g[f+12>>2]=o;g[f+16>>2]=A;g[f+20>>2]=N;g[f+24>>2]=F;g[f+28>>2]=D;g[f+32>>2]=J;g[f+36>>2]=s;g[f+40>>2]=M;g[f+44>>2]=v;J6a(j,f,b);g[a>>2]=ea(g[j>>2]);g[a+4>>2]=ea(g[j+4>>2]);g[a+8>>2]=ea(g[j+8>>2]);g[a+12>>2]=ea(g[j+12>>2]);g[a+16>>2]=ea(g[j+16>>2]);g[a+20>>2]=ea(g[j+20>>2]);g[a+24>>2]=ea(g[j+24>>2]);g[a+28>>2]=ea(g[j+28>>2]);g[a+32>>2]=ea(g[j+32>>2]);g[a+36>>2]=ea(g[j+36>>2]);g[a+40>>2]=ea(g[j+40>>2]);g[a+44>>2]=ea(g[j+44>>2]);g[a+48>>2]=ea(g[j+48>>2]);g[a+52>>2]=ea(g[j+52>>2]);g[a+56>>2]=ea(g[j+56>>2]);i=e;return}function BOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=i;i=i+80|0;f=e+60|0;h=e;j=ea(g[c+16>>2]);k=ea(g[c+20>>2]);l=ea(g[c+24>>2]);m=ea(g[c+28>>2]);n=ea(g[c+32>>2]);o=ea(g[c+36>>2]);p=ea(ea(j+m)*ea(.5));q=ea(ea(k+n)*ea(.5));r=ea(ea(l+o)*ea(.5));s=ea(ea(m-j)*ea(.5));j=ea(ea(n-k)*ea(.5));k=ea(ea(o-l)*ea(.5));c=b+4|0;l=ea(g[c>>2]);if(l==ea(1.0)){o=ea(g[b+8>>2]);if(o==ea(1.0)?ea(g[b+12>>2])==ea(1.0):0){n=ea(g[d>>2]);m=ea(n+n);t=ea(g[d+4>>2]);u=ea(t+t);v=ea(g[d+8>>2]);w=ea(v+v);x=ea(g[d+12>>2]);y=ea(m*x);z=ea(u*x);A=ea(x*w);x=ea(n*u);B=ea(n*w);C=ea(t*u);u=ea(t*w);t=ea(v*w);w=ea(ea(ea(1.0)-C)-t);v=ea(x+A);D=ea(B-z);E=ea(x-A);A=ea(ea(1.0)-ea(n*m));m=ea(A-t);t=ea(u+y);n=ea(B+z);z=ea(u-y);y=ea(A-C);C=ea(g[d+16>>2]);A=ea(g[d+20>>2]);u=ea(g[d+24>>2]);g[a+48>>2]=s;g[a+52>>2]=j;g[a+56>>2]=k;B=ea(A+ea(ea(r*z)+ea(ea(p*v)+ea(q*m))));A=ea(u+ea(ea(r*y)+ea(ea(p*D)+ea(q*t))));g[a+36>>2]=ea(C+ea(ea(r*n)+ea(ea(p*w)+ea(q*E))));g[a+40>>2]=B;g[a+44>>2]=A;A=ea(E*ea(0.0));B=ea(m*ea(0.0));C=ea(t*ea(0.0));u=ea(n*ea(0.0));x=ea(z*ea(0.0));F=ea(y*ea(0.0));G=ea(x+ea(v+B));H=ea(F+ea(D+C));I=ea(w*ea(0.0));J=ea(v*ea(0.0));v=ea(D*ea(0.0));D=ea(u+ea(E+I));E=ea(x+ea(m+J));m=ea(F+ea(t+v));t=ea(n+ea(I+A));I=ea(z+ea(J+B));B=ea(y+ea(v+C));g[a>>2]=ea(u+ea(w+A));g[a+4>>2]=G;g[a+8>>2]=H;g[a+12>>2]=D;g[a+16>>2]=E;g[a+20>>2]=m;g[a+24>>2]=t;g[a+28>>2]=I;g[a+32>>2]=B;i=e;return}else K=o}else K=ea(g[c+4>>2]);o=ea(g[d>>2]);B=ea(g[d+4>>2]);I=ea(g[d+8>>2]);t=ea(g[d+12>>2]);m=ea(o+o);E=ea(B+B);D=ea(I+I);H=ea(B*E);G=ea(I*D);A=ea(m*B);B=ea(m*I);w=ea(m*t);u=ea(E*I);I=ea(E*t);E=ea(D*t);t=ea(ea(ea(1.0)-H)-G);D=ea(A+E);C=ea(B-I);v=ea(A-E);E=ea(ea(1.0)-ea(o*m));m=ea(E-G);G=ea(u+w);o=ea(B+I);I=ea(u-w);w=ea(E-H);H=ea(g[b+16>>2]);E=ea(g[b+20>>2]);u=ea(g[b+24>>2]);B=ea(g[b+28>>2]);A=ea(H+H);y=ea(E+E);J=ea(u+u);z=ea(E*y);n=ea(u*J);F=ea(A*E);E=ea(A*u);x=ea(A*B);L=ea(y*u);u=ea(y*B);y=ea(J*B);B=ea(ea(ea(1.0)-z)-n);J=ea(F+y);M=ea(E-u);N=ea(F-y);y=ea(ea(1.0)-ea(H*A));A=ea(y-n);n=ea(L+x);H=ea(E+u);u=ea(L-x);x=ea(y-z);z=ea(l*B);y=ea(l*N);L=ea(l*H);l=ea(J*K);E=ea(A*K);F=ea(u*K);K=ea(g[c+8>>2]);O=ea(M*K);P=ea(n*K);Q=ea(x*K);K=ea(ea(ea(B*z)+ea(J*l))+ea(M*O));R=ea(ea(ea(B*y)+ea(J*E))+ea(M*P));S=ea(ea(ea(B*L)+ea(J*F))+ea(M*Q));M=ea(ea(ea(N*z)+ea(A*l))+ea(n*O));J=ea(ea(ea(N*y)+ea(A*E))+ea(n*P));B=ea(ea(ea(N*L)+ea(A*F))+ea(n*Q));n=ea(ea(ea(H*z)+ea(u*l))+ea(x*O));O=ea(ea(ea(H*y)+ea(u*E))+ea(x*P));P=ea(ea(ea(H*L)+ea(u*F))+ea(x*Q));Q=ea(ea(o*S)+ea(ea(t*K)+ea(v*R)));x=ea(ea(I*S)+ea(ea(D*K)+ea(m*R)));F=ea(ea(w*S)+ea(ea(C*K)+ea(G*R)));R=ea(ea(o*B)+ea(ea(t*M)+ea(v*J)));K=ea(ea(I*B)+ea(ea(D*M)+ea(m*J)));S=ea(ea(w*B)+ea(ea(C*M)+ea(G*J)));J=ea(ea(o*P)+ea(ea(t*n)+ea(v*O)));v=ea(ea(I*P)+ea(ea(D*n)+ea(m*O)));m=ea(ea(w*P)+ea(ea(C*n)+ea(G*O)));O=ea(g[d+16>>2]);G=ea(g[d+20>>2]);n=ea(g[d+24>>2]);C=ea(s*ea(0.0));P=ea(ea(C*v)+ea(ea(s*x)+ea(C*K)));w=ea(ea(C*m)+ea(ea(s*F)+ea(C*S)));g[h>>2]=ea(ea(C*J)+ea(ea(s*Q)+ea(C*R)));d=h+4|0;g[d>>2]=P;c=h+8|0;g[c>>2]=w;w=ea(j*ea(0.0));P=ea(ea(w*v)+ea(ea(w*x)+ea(j*K)));C=ea(ea(w*m)+ea(ea(w*F)+ea(j*S)));b=h+12|0;g[b>>2]=ea(ea(w*J)+ea(ea(w*Q)+ea(j*R)));T=h+16|0;g[T>>2]=P;U=h+20|0;g[U>>2]=C;C=ea(k*ea(0.0));P=ea(ea(k*v)+ea(ea(C*x)+ea(C*K)));j=ea(ea(k*m)+ea(ea(C*F)+ea(C*S)));V=h+24|0;g[V>>2]=ea(ea(k*J)+ea(ea(C*Q)+ea(C*R)));W=h+28|0;g[W>>2]=P;X=h+32|0;g[X>>2]=j;j=ea(G+ea(ea(r*v)+ea(ea(p*x)+ea(q*K))));K=ea(n+ea(ea(r*m)+ea(ea(p*F)+ea(q*S))));Y=h+36|0;g[Y>>2]=ea(O+ea(ea(r*J)+ea(ea(p*Q)+ea(q*R))));Z=h+40|0;g[Z>>2]=j;_=h+44|0;g[_>>2]=K;qKa(f,h);K=ea(g[f>>2]);g[h+48>>2]=K;j=ea(g[f+4>>2]);g[h+52>>2]=j;R=ea(g[f+8>>2]);g[h+56>>2]=R;g[a>>2]=ea(g[h>>2]);g[a+4>>2]=ea(g[d>>2]);g[a+8>>2]=ea(g[c>>2]);g[a+12>>2]=ea(g[b>>2]);g[a+16>>2]=ea(g[T>>2]);g[a+20>>2]=ea(g[U>>2]);g[a+24>>2]=ea(g[V>>2]);g[a+28>>2]=ea(g[W>>2]);g[a+32>>2]=ea(g[X>>2]);g[a+36>>2]=ea(g[Y>>2]);g[a+40>>2]=ea(g[Z>>2]);g[a+44>>2]=ea(g[_>>2]);g[a+48>>2]=K;g[a+52>>2]=j;g[a+56>>2]=R;i=e;return}function COa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,l=0,m=0,n=0,o=0;e=i;f=ea(S(ea(g[a>>2])));h=ea(S(ea(g[a+4>>2])));j=ea(S(ea(g[a+8>>2])));if(!(h>f&h>j))if(j>f){l=2;m=0;n=1}else{l=0;m=1;n=2}else{l=1;m=2;n=0}f=ea(g[a+(l<<2)>>2]);j=ea(ea(1.0)/ea(S(ea(f))));o=(g[k>>2]=f,c[k>>2]|0)>>>31;g[b>>2]=ea(j*ea(g[a+(m<<2)>>2]));g[d>>2]=ea(j*ea(g[a+(n<<2)>>2]));i=e;return o|l<<1|0}function DOa(a,e,f,h){a=a|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=0;j=i;i=i+32|0;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;l=c[h+16>>2]|0;m=c[h+20>>2]|0;h=c[a>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[f+(h*12|0)>>2]));p=ea(g[e+4>>2]);q=ea(o+ea(p*ea(g[f+(h*12|0)+4>>2])));o=ea(g[e+8>>2]);e=h;r=ea(q+ea(o*ea(g[f+(h*12|0)+8>>2])));while(1){h=b[l+(e<<2)>>1]|0;s=b[l+(e<<2)+2>>1]|0;c[a>>2]=e;if(!(h<<16>>16)){t=10;break}u=h;q=r;h=e;v=m+(s&65535)|0;a:while(1){s=u;w=v;while(1){s=s+-1<<16>>16;x=w;w=w+1|0;y=d[x>>0]|0;x=k+(y>>>5<<2)|0;z=c[x>>2]|0;A=1<<(y&31);if((A&z|0)==0?(c[x>>2]=A|z,B=ea(n*ea(g[f+(y*12|0)>>2])),C=ea(B+ea(p*ea(g[f+(y*12|0)+4>>2]))),D=ea(C+ea(o*ea(g[f+(y*12|0)+8>>2]))),D>q):0)break;if(!(s<<16>>16)){E=q;F=h;break a}}if(!(s<<16>>16)){E=D;F=y;break}else{u=s;q=D;h=y;v=w}}if((F|0)==(e|0)){t=10;break}else{e=F;r=E}}if((t|0)==10){i=j;return}}function EOa(a,b,f){a=a|0;b=b|0;f=f|0;var h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=0,q=0;h=ea(g[b+24>>2]);i=ea(h*ea(g[f>>2]));j=ea(h*ea(g[f+4>>2]));k=ea(h*ea(g[f+8>>2]));h=ea(g[b+28>>2]);l=ea(h*ea(g[f+12>>2]));m=ea(h*ea(g[f+16>>2]));n=ea(i+l);l=ea(j+m);m=ea(k+ea(h*ea(g[f+20>>2])));h=ea(g[b+32>>2]);k=ea(h*ea(g[f+24>>2]));j=ea(h*ea(g[f+28>>2]));i=ea(l+j);j=ea(m+ea(h*ea(g[f+32>>2])));g[a>>2]=ea(n+k);g[a+4>>2]=i;g[a+8>>2]=j;f=b+38|0;c[a+12>>2]=d[f>>0];o=b+39|0;c[a+16>>2]=d[o>>0];p=e[b+36>>1]|0;c[a+20>>2]=p;q=b+40|0;c[a+24>>2]=c[q>>2];c[a+28>>2]=(c[q>>2]|0)+((d[o>>0]|0)*20|0);c[a+32>>2]=(c[q>>2]|0)+((d[o>>0]|0)*20|0)+((p<<1)+((d[f>>0]|0)*15|0));c[a+36>>2]=(c[q>>2]|0)+((d[o>>0]|0)*20|0)+((d[f>>0]|0)*12|0);f=a+40|0;o=b+48|0;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];o=b+44|0;c[a+56>>2]=c[o>>2];c[a+64>>2]=(c[o>>2]|0)==0?99:100;c[a+68>>2]=1729;c[a+60>>2]=2656;return}function FOa(d,e){d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=0;c[d>>2]=e;f=ea(g[e>>2]);h=ea(-f);i=ea(g[e+4>>2]);j=ea(-i);k=ea(g[e+8>>2]);l=ea(-k);g[d+4>>2]=h;g[d+8>>2]=j;g[d+12>>2]=l;g[d+16>>2]=f;g[d+20>>2]=j;g[d+24>>2]=l;g[d+28>>2]=f;g[d+32>>2]=i;g[d+36>>2]=l;g[d+40>>2]=h;g[d+44>>2]=i;g[d+48>>2]=l;g[d+52>>2]=h;g[d+56>>2]=j;g[d+60>>2]=k;g[d+64>>2]=f;g[d+68>>2]=j;g[d+72>>2]=k;g[d+76>>2]=f;g[d+80>>2]=i;g[d+84>>2]=k;g[d+88>>2]=h;g[d+92>>2]=i;g[d+96>>2]=k;a[d+118>>0]=4;b[d+116>>1]=0;a[d+138>>0]=4;b[d+136>>1]=4;a[d+158>>0]=4;b[d+156>>1]=8;a[d+178>>0]=4;b[d+176>>1]=12;a[d+198>>0]=4;b[d+196>>1]=16;a[d+218>>0]=4;b[d+216>>1]=20;g[d+120>>2]=ea(1.0);g[d+124>>2]=ea(0.0);g[d+128>>2]=ea(0.0);g[d+132>>2]=ea(-ea(g[e>>2]));g[d+160>>2]=ea(-1.0);g[d+164>>2]=ea(0.0);g[d+168>>2]=ea(0.0);e=c[d>>2]|0;g[d+172>>2]=ea(-ea(g[e>>2]));a[d+139>>0]=0;a[d+179>>0]=1;g[d+180>>2]=ea(0.0);g[d+184>>2]=ea(1.0);g[d+188>>2]=ea(0.0);m=e+4|0;g[d+192>>2]=ea(-ea(g[m>>2]));g[d+200>>2]=ea(0.0);g[d+204>>2]=ea(-1.0);g[d+208>>2]=ea(0.0);g[d+212>>2]=ea(-ea(g[m>>2]));a[d+199>>0]=0;a[d+219>>0]=2;g[d+140>>2]=ea(0.0);g[d+144>>2]=ea(0.0);g[d+148>>2]=ea(1.0);m=e+8|0;g[d+152>>2]=ea(-ea(g[m>>2]));g[d+100>>2]=ea(0.0);g[d+104>>2]=ea(0.0);g[d+108>>2]=ea(-1.0);g[d+112>>2]=ea(-ea(g[m>>2]));a[d+159>>0]=0;a[d+119>>0]=4;return}function GOa(a,b){a=a|0;b=b|0;var d=0;g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);c[b+12>>2]=8;c[b+16>>2]=6;c[b+24>>2]=a+100;c[b+20>>2]=0;c[b+28>>2]=a+4;c[b+32>>2]=540448;d=b+36|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[b+56>>2]=c[a>>2];c[b+64>>2]=101;c[b+68>>2]=1730;c[b+60>>2]=0;return}function HOa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;f=i;h=ea(g[a>>2]);j=ea(h-ea(g[b>>2]));h=ea(g[a+4>>2]);k=ea(h-ea(g[b+4>>2]));h=ea(g[a+8>>2]);l=ea(h-ea(g[b+8>>2]));h=ea(j*ea(g[d>>2]));m=ea(h+ea(k*ea(g[d+4>>2])));h=ea(m+ea(l*ea(g[d+8>>2])));m=ea(j*ea(g[d+12>>2]));n=ea(m+ea(k*ea(g[d+16>>2])));m=ea(n+ea(l*ea(g[d+20>>2])));n=ea(j*ea(g[d+24>>2]));j=ea(n+ea(k*ea(g[d+28>>2])));k=ea(j+ea(l*ea(g[d+32>>2])));l=ea(g[c>>2]);j=ea(-l);if(!(h<j))if(h>l){n=ea(h-l);o=l;p=ea(ea(n*n)+ea(0.0))}else{o=h;p=ea(0.0)}else{n=ea(h+l);o=j;p=ea(ea(n*n)+ea(0.0))}n=ea(g[c+4>>2]);j=ea(-n);if(!(m<j))if(m>n){l=ea(m-n);q=n;r=ea(p+ea(l*l))}else{q=m;r=p}else{l=ea(m+n);q=j;r=ea(p+ea(l*l))}l=ea(g[c+8>>2]);p=ea(-l);if(!(k<p))if(k>l){j=ea(k-l);s=l;t=ea(r+ea(j*j))}else{s=k;t=r}else{j=ea(k+l);s=p;t=ea(r+ea(j*j))}if(!e){i=f;return ea(t)}g[e>>2]=o;g[e+4>>2]=q;g[e+8>>2]=s;i=f;return ea(t)}function IOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;e=i;f=ea(g[c>>2]);h=ea(g[a>>2]);j=ea(f-h);f=ea(g[c+4>>2]);k=ea(g[a+4>>2]);l=ea(f-k);f=ea(g[c+8>>2]);m=ea(g[a+8>>2]);n=ea(f-m);f=ea(ea(g[b>>2])-h);h=ea(ea(g[b+4>>2])-k);k=ea(ea(g[b+8>>2])-m);m=ea(ea(ea(j*f)+ea(l*h))+ea(n*k));do if(!(m<=ea(0.0))){o=ea(ea(ea(f*f)+ea(h*h))+ea(k*k));if(!(m>=o)){p=ea(m/o);q=ea(j-ea(f*p));r=ea(l-ea(h*p));s=ea(n-ea(k*p));t=p;break}else{q=ea(j-f);r=ea(l-h);s=ea(n-k);t=ea(1.0);break}}else{q=j;r=l;s=n;t=ea(0.0)}while(0);if(!d){u=ea(q*q);v=ea(r*r);w=ea(v+u);x=ea(s*s);y=ea(x+w);i=e;return ea(y)}g[d>>2]=t;u=ea(q*q);v=ea(r*r);w=ea(v+u);x=ea(s*s);y=ea(x+w);i=e;return ea(y)}function JOa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=Im,l=Im,m=Im,n=0,o=Im,p=0,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im;j=i;k=ea(g[d>>2]);l=ea(g[c>>2]);m=ea(k-l);n=d+4|0;o=ea(g[n>>2]);p=c+4|0;q=ea(g[p>>2]);r=ea(o-q);s=d+8|0;t=ea(g[s>>2]);u=c+8|0;v=ea(g[u>>2]);w=ea(t-v);x=ea(g[e>>2]);y=ea(x-l);z=e+4|0;A=ea(g[z>>2]);B=ea(A-q);C=e+8|0;D=ea(g[C>>2]);E=ea(D-v);F=ea(g[b>>2]);G=ea(F-l);l=ea(g[b+4>>2]);H=ea(l-q);q=ea(g[b+8>>2]);I=ea(q-v);v=ea(ea(ea(m*G)+ea(r*H))+ea(w*I));J=ea(ea(ea(y*G)+ea(B*H))+ea(E*I));if(!(!(v<=ea(0.0))|!(J<=ea(0.0)))){g[f>>2]=ea(0.0);g[h>>2]=ea(0.0);g[a>>2]=ea(g[c>>2]);g[a+4>>2]=ea(g[p>>2]);g[a+8>>2]=ea(g[u>>2]);i=j;return}I=ea(F-k);k=ea(l-o);o=ea(q-t);t=ea(ea(ea(m*I)+ea(r*k))+ea(w*o));H=ea(ea(ea(y*I)+ea(B*k))+ea(E*o));if(!(!(t>=ea(0.0))|!(H<=t))){g[f>>2]=ea(1.0);g[h>>2]=ea(0.0);g[a>>2]=ea(g[d>>2]);g[a+4>>2]=ea(g[n>>2]);g[a+8>>2]=ea(g[s>>2]);i=j;return}o=ea(ea(v*H)-ea(t*J));if(!(!(o<=ea(0.0))|!(v>=ea(0.0))|!(t<=ea(0.0)))){k=ea(v/ea(v-t));g[f>>2]=k;g[h>>2]=ea(0.0);I=ea(m*k);G=ea(r*k);K=ea(w*k);k=ea(ea(g[c>>2])+I);I=ea(G+ea(g[p>>2]));G=ea(K+ea(g[u>>2]));g[a>>2]=k;g[a+4>>2]=I;g[a+8>>2]=G;i=j;return}G=ea(F-x);x=ea(l-A);A=ea(q-D);D=ea(ea(ea(m*G)+ea(r*x))+ea(w*A));q=ea(ea(ea(y*G)+ea(B*x))+ea(E*A));if(!(!(q>=ea(0.0))|!(D<=q))){g[f>>2]=ea(0.0);g[h>>2]=ea(1.0);g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[z>>2]);g[a+8>>2]=ea(g[C>>2]);i=j;return}A=ea(ea(D*J)-ea(v*q));if(!(!(A<=ea(0.0))|!(J>=ea(0.0))|!(q<=ea(0.0)))){v=ea(J/ea(J-q));g[f>>2]=ea(0.0);g[h>>2]=v;J=ea(y*v);x=ea(B*v);G=ea(E*v);v=ea(ea(g[c>>2])+J);J=ea(x+ea(g[p>>2]));x=ea(G+ea(g[u>>2]));g[a>>2]=v;g[a+4>>2]=J;g[a+8>>2]=x;i=j;return}x=ea(ea(t*q)-ea(D*H));if((x<=ea(0.0)?(J=ea(H-t),J>=ea(0.0)):0)?(t=ea(D-q),t>=ea(0.0)):0){q=ea(J/ea(J+t));g[f>>2]=ea(ea(1.0)-q);g[h>>2]=q;t=ea(g[e>>2]);J=ea(g[d>>2]);D=ea(t-J);t=ea(g[z>>2]);H=ea(g[n>>2]);v=ea(t-H);t=ea(g[C>>2]);G=ea(g[s>>2]);l=ea(H+ea(q*v));v=ea(G+ea(q*ea(t-G)));g[a>>2]=ea(J+ea(q*D));g[a+4>>2]=l;g[a+8>>2]=v;i=j;return}v=ea(ea(1.0)/ea(o+ea(x+A)));x=ea(A*v);A=ea(o*v);g[f>>2]=x;g[h>>2]=A;v=ea(m*x);m=ea(r*x);r=ea(w*x);x=ea(ea(g[c>>2])+v);v=ea(ea(g[p>>2])+m);m=ea(ea(B*A)+v);v=ea(ea(E*A)+ea(r+ea(g[u>>2])));g[a>>2]=ea(ea(y*A)+x);g[a+4>>2]=m;g[a+8>>2]=v;i=j;return}function KOa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=Im,A=0,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=Im,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=Im,fa=0,ga=Im,ha=0,ia=0;l=i;i=i+96|0;m=l+12|0;n=l+48|0;o=l+24|0;p=l+60|0;q=l+84|0;r=l;s=l+36|0;t=l+72|0;u=ea(g[e>>2]);v=e+4|0;w=ea(g[v>>2]);x=e+8|0;y=ea(g[x>>2]);z=ea(g[d>>2]);A=d+4|0;B=ea(g[A>>2]);C=d+8|0;D=ea(g[C>>2]);E=ea(u-z);F=ea(w-B);G=ea(y-D);H=ea(g[f>>2]);I=f+4|0;J=ea(g[I>>2]);K=f+8|0;L=ea(g[K>>2]);M=ea(H-z);N=ea(J-B);O=ea(L-D);P=ea(H-u);Q=ea(J-w);R=ea(L-y);S=ea(g[b>>2]);T=b+4|0;U=ea(g[T>>2]);V=b+8|0;W=ea(g[V>>2]);X=ea(S-z);Y=ea(U-B);Z=ea(W-D);_=ea(S-u);$=ea(U-w);aa=ea(W-y);ba=ea(S-H);H=ea(U-J);J=ea(W-L);L=ea(ea(ea(E*X)+ea(F*Y))+ea(G*Z));W=ea(ea(ea(M*X)+ea(N*Y))+ea(O*Z));Z=ea(ea(ea(E*_)+ea(F*$))+ea(G*aa));Y=ea(ea(ea(M*_)+ea(N*$))+ea(O*aa));aa=ea(ea(ea(E*ba)+ea(F*H))+ea(G*J));$=ea(ea(ea(M*ba)+ea(N*H))+ea(O*J));J=ea(Y-Z);H=ea(aa-$);if(L<ea(0.0)&W<ea(0.0)){g[h>>2]=ea(0.0);ca=h+4|0;c[ca+0>>2]=c[m+0>>2];c[ca+4>>2]=c[m+4>>2];c[ca+8>>2]=c[m+8>>2];g[j>>2]=ea(0.0);ca=j+4|0;c[ca+0>>2]=c[m+0>>2];c[ca+4>>2]=c[m+4>>2];c[ca+8>>2]=c[m+8>>2];ba=ea(g[b>>2]);_=ea(g[T>>2]);X=ea(g[V>>2]);U=ea(g[d>>2]);S=ea(g[A>>2]);da=ea(ba-U);U=ea(_-S);S=ea(X-ea(g[C>>2]));c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];g[a>>2]=ea(ea(ea(da*da)+ea(U*U))+ea(S*S));i=l;return}if(!(!(Z>=ea(0.0))|!(Z>=Y))){g[h>>2]=ea(1.0);d=h+4|0;c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];g[j>>2]=ea(0.0);d=j+4|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];S=ea(g[b>>2]);U=ea(g[T>>2]);da=ea(g[V>>2]);X=ea(g[e>>2]);_=ea(g[v>>2]);ba=ea(S-X);X=ea(U-_);_=ea(da-ea(g[x>>2]));c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];g[a>>2]=ea(ea(ea(ba*ba)+ea(X*X))+ea(_*_));i=l;return}if(!(!($>=ea(0.0))|!($>=aa))){g[h>>2]=ea(0.0);e=h+4|0;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];g[j>>2]=ea(1.0);e=j+4|0;c[e+0>>2]=c[n+0>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];_=ea(g[b>>2]);X=ea(g[T>>2]);ba=ea(g[V>>2]);da=ea(g[f>>2]);U=ea(g[I>>2]);S=ea(_-da);da=ea(X-U);U=ea(ba-ea(g[K>>2]));c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];g[a>>2]=ea(ea(ea(S*S)+ea(da*da))+ea(U*U));i=l;return}U=ea(ea(L*Y)-ea(Z*W));if(!(L>=ea(0.0)))fa=1;else fa=!(Z<ea(0.0));if(!(!(U<ea(0.0))|fa)){da=ea(L/ea(L-Z));S=ea(z+ea(E*da));ba=ea(ea(F*da)+B);X=ea(ea(G*da)+D);g[h>>2]=da;fa=h+4|0;c[fa+0>>2]=c[o+0>>2];c[fa+4>>2]=c[o+4>>2];c[fa+8>>2]=c[o+8>>2];g[j>>2]=ea(0.0);o=j+4|0;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];da=ea(g[b>>2]);_=ea(g[T>>2]);ga=ea(da-S);da=ea(_-ba);_=ea(ea(g[V>>2])-X);g[k>>2]=S;g[k+4>>2]=ba;g[k+8>>2]=X;g[k+12>>2]=ea(0.0);g[a>>2]=ea(ea(ea(ga*ga)+ea(da*da))+ea(_*_));i=l;return}_=ea(ea(Z*$)-ea(aa*Y));if(!(Y>=Z))ha=1;else ha=!(aa>=$);if(!(!(_<ea(0.0))|ha)){Z=ea(J/ea(J+H));H=ea(u+ea(P*Z));P=ea(ea(Q*Z)+w);w=ea(ea(R*Z)+y);g[h>>2]=ea(ea(1.0)-Z);ha=h+4|0;c[ha+0>>2]=c[q+0>>2];c[ha+4>>2]=c[q+4>>2];c[ha+8>>2]=c[q+8>>2];g[j>>2]=Z;q=j+4|0;c[q+0>>2]=c[p+0>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];Z=ea(g[b>>2]);y=ea(g[T>>2]);R=ea(Z-H);Z=ea(y-P);y=ea(ea(g[V>>2])-w);g[k>>2]=H;g[k+4>>2]=P;g[k+8>>2]=w;g[k+12>>2]=ea(0.0);g[a>>2]=ea(ea(ea(R*R)+ea(Z*Z))+ea(y*y));i=l;return}y=ea(ea(aa*W)-ea(L*$));if(!(W>=ea(0.0)))ia=1;else ia=!($<ea(0.0));if(!(y<ea(0.0))|ia){L=ea(ea(1.0)/ea(_+ea(y+U)));_=ea(y*L);y=ea(U*L);L=ea(z+ea(ea(E*_)+ea(M*y)));E=ea(B+ea(ea(F*_)+ea(N*y)));F=ea(D+ea(ea(G*_)+ea(O*y)));g[h>>2]=_;ia=h+4|0;c[ia+0>>2]=c[s+0>>2];c[ia+4>>2]=c[s+4>>2];c[ia+8>>2]=c[s+8>>2];g[j>>2]=y;s=j+4|0;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];g[k>>2]=L;g[k+4>>2]=E;g[k+8>>2]=F;g[k+12>>2]=ea(0.0);y=ea(g[b>>2]);_=ea(g[T>>2]);G=ea(y-L);L=ea(_-E);E=ea(ea(g[V>>2])-F);g[a>>2]=ea(ea(ea(G*G)+ea(L*L))+ea(E*E));i=l;return}else{E=ea(W/ea(W-$));$=ea(z+ea(M*E));M=ea(ea(N*E)+B);B=ea(ea(O*E)+D);g[h>>2]=ea(0.0);t=h+4|0;c[t+0>>2]=c[m+0>>2];c[t+4>>2]=c[m+4>>2];c[t+8>>2]=c[m+8>>2];g[j>>2]=E;m=j+4|0;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];E=ea(g[b>>2]);D=ea(g[T>>2]);O=ea(E-$);E=ea(D-M);D=ea(ea(g[V>>2])-B);g[k>>2]=$;g[k+4>>2]=M;g[k+8>>2]=B;g[k+12>>2]=ea(0.0);g[a>>2]=ea(ea(ea(O*O)+ea(E*E))+ea(D*D));i=l;return}}function LOa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=Im,K=Im,L=0,M=Im,N=Im,O=0,P=Im,Q=Im,R=0,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im;j=i;i=i+48|0;k=j+32|0;l=j+20|0;m=j+8|0;n=j+4|0;o=j;p=ea(g[b>>2]);q=ea(g[a>>2]);r=ea(p-q);p=ea(g[b+4>>2]);s=ea(g[a+4>>2]);t=ea(p-s);p=ea(g[b+8>>2]);u=ea(g[a+8>>2]);v=ea(p-u);p=ea(g[c>>2]);w=ea(g[c+4>>2]);x=ea(q-p);p=ea(s-w);w=ea(u-ea(g[c+8>>2]));u=ea(g[e>>2]);s=ea(x*u);q=ea(g[e+4>>2]);y=ea(s+ea(p*q));s=ea(g[e+8>>2]);z=ea(y+ea(w*s));y=ea(g[e+12>>2]);A=ea(x*y);B=ea(g[e+16>>2]);C=ea(A+ea(p*B));A=ea(g[e+20>>2]);D=ea(C+ea(w*A));C=ea(g[e+24>>2]);E=ea(x*C);x=ea(g[e+28>>2]);F=ea(E+ea(p*x));p=ea(g[e+32>>2]);E=ea(F+ea(w*p));g[l>>2]=z;G=l+4|0;g[G>>2]=D;H=l+8|0;g[H>>2]=E;w=ea(ea(ea(r*u)+ea(t*q))+ea(v*s));s=ea(ea(ea(r*y)+ea(t*B))+ea(v*A));A=ea(ea(ea(r*C)+ea(t*x))+ea(v*p));g[m>>2]=w;g[m+4>>2]=s;g[m+8>>2]=A;if(w<ea(0.0)){p=ea(-z);g[l>>2]=p;v=ea(-w);g[m>>2]=v;I=1;J=p;K=v}else{I=0;J=z;K=w}if(s<ea(0.0)){w=ea(-D);g[l+4>>2]=w;z=ea(-s);g[m+4>>2]=z;L=1;M=w;N=z}else{L=0;M=D;N=s}if(A<ea(0.0)){s=ea(-E);g[l+8>>2]=s;D=ea(-A);g[m+8>>2]=D;O=1;P=s;Q=D}else{O=0;P=E;Q=A}g[n>>2]=ea(0.0);R=N>ea(0.0);S=Q>ea(0.0);do if(K>ea(0.0)){if(R){if(!S){R6a(0,1,2,l,m,d,o,n);break}A=ea(J-ea(g[d>>2]));E=ea(M-ea(g[d+4>>2]));D=ea(P-ea(g[d+8>>2]));g[k>>2]=A;g[k+4>>2]=E;g[k+8>>2]=D;if(!(ea(N*A)>=ea(K*E)))if(!(ea(Q*E)>=ea(N*D))){Q6a(2,0,1,l,m,d,k,o,n);break}else{Q6a(1,2,0,l,m,d,k,o,n);break}else if(!(ea(Q*A)>=ea(K*D))){Q6a(2,0,1,l,m,d,k,o,n);break}else{Q6a(0,1,2,l,m,d,k,o,n);break}}if(S){R6a(0,2,1,l,m,d,o,n);break}D=ea(g[d>>2]);g[o>>2]=ea(ea(D-J)/K);g[l>>2]=D;T=l+4|0;D=ea(g[d+4>>2]);A=ea(-D);if(!(M<A))if(M>D){E=ea(M-D);s=ea(ea(E*E)+ea(0.0));g[n>>2]=s;g[T>>2]=D;U=s}else U=ea(0.0);else{s=ea(M+D);D=ea(ea(s*s)+ea(0.0));g[n>>2]=D;g[T>>2]=A;U=D}T=l+8|0;D=ea(g[d+8>>2]);A=ea(-D);if(P<A){s=ea(P+D);g[n>>2]=ea(U+ea(s*s));g[T>>2]=A;break}if(P>D){A=ea(P-D);g[n>>2]=ea(U+ea(A*A));g[T>>2]=D}}else{if(R){if(S){R6a(1,2,0,l,m,d,o,n);break}D=ea(g[d+4>>2]);g[o>>2]=ea(ea(D-M)/N);g[l+4>>2]=D;D=ea(g[d>>2]);A=ea(-D);if(!(J<A))if(J>D){s=ea(J-D);E=ea(ea(s*s)+ea(0.0));g[n>>2]=E;g[l>>2]=D;V=E}else V=ea(0.0);else{E=ea(J+D);D=ea(ea(E*E)+ea(0.0));g[n>>2]=D;g[l>>2]=A;V=D}T=l+8|0;D=ea(g[d+8>>2]);A=ea(-D);if(P<A){E=ea(P+D);g[n>>2]=ea(V+ea(E*E));g[T>>2]=A;break}if(!(P>D))break;A=ea(P-D);g[n>>2]=ea(V+ea(A*A));g[T>>2]=D;break}if(S){D=ea(g[d+8>>2]);g[o>>2]=ea(ea(D-P)/Q);g[l+8>>2]=D;D=ea(g[d>>2]);A=ea(-D);if(!(J<A))if(J>D){E=ea(J-D);s=ea(ea(E*E)+ea(0.0));g[n>>2]=s;g[l>>2]=D;W=s}else W=ea(0.0);else{s=ea(J+D);D=ea(ea(s*s)+ea(0.0));g[n>>2]=D;g[l>>2]=A;W=D}T=l+4|0;D=ea(g[d+4>>2]);A=ea(-D);if(M<A){s=ea(M+D);g[n>>2]=ea(W+ea(s*s));g[T>>2]=A;break}if(!(M>D))break;A=ea(M-D);g[n>>2]=ea(W+ea(A*A));g[T>>2]=D;break}D=ea(g[d>>2]);A=ea(-D);if(!(J<A))if(J>D){s=ea(J-D);E=ea(ea(s*s)+ea(0.0));g[n>>2]=E;g[l>>2]=D;X=E}else X=ea(0.0);else{E=ea(J+D);D=ea(ea(E*E)+ea(0.0));g[n>>2]=D;g[l>>2]=A;X=D}D=ea(g[d+4>>2]);A=ea(-D);if(!(M<A))if(M>D){E=ea(M-D);s=ea(X+ea(E*E));g[n>>2]=s;g[G>>2]=D;Y=s}else Y=X;else{s=ea(M+D);D=ea(X+ea(s*s));g[n>>2]=D;g[G>>2]=A;Y=D}D=ea(g[d+8>>2]);A=ea(-D);if(!(P<A)){if(P>D){s=ea(P-D);g[n>>2]=ea(Y+ea(s*s));g[H>>2]=D}}else{s=ea(P+D);g[n>>2]=ea(Y+ea(s*s));g[H>>2]=A}g[o>>2]=ea(0.0)}while(0);if(I<<24>>24)g[l>>2]=ea(-ea(g[l>>2]));if(L<<24>>24){L=l+4|0;g[L>>2]=ea(-ea(g[L>>2]))}if(!(O<<24>>24))Z=ea(g[H>>2]);else{H=l+8|0;Y=ea(-ea(g[H>>2]));g[H>>2]=Y;Z=Y}Y=ea(g[l>>2]);P=ea(g[G>>2]);X=ea(g[n>>2]);M=ea(g[o>>2]);if(!(M>=ea(0.0))){if(f)g[f>>2]=ea(0.0);_=ea(HOa(a,c,d,e,h));i=j;return ea(_)}a=(f|0)!=0;if(!(M<=ea(1.0))){if(a)g[f>>2]=ea(1.0);_=ea(HOa(b,c,d,e,h));i=j;return ea(_)}if(a)g[f>>2]=M;if(!h){_=X;i=j;return ea(_)}g[h>>2]=Y;g[h+4>>2]=P;g[h+8>>2]=Z;_=X;i=j;return ea(_)}function MOa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im;h=i;j=ea(g[a>>2]);k=ea(j-ea(g[c>>2]));j=ea(g[a+4>>2]);l=ea(j-ea(g[c+4>>2]));j=ea(g[a+8>>2]);m=ea(j-ea(g[c+8>>2]));j=ea(g[b>>2]);n=ea(j*j);o=ea(g[b+4>>2]);p=ea(n+ea(o*o));n=ea(g[b+8>>2]);q=ea(p+ea(n*n));p=ea(g[d>>2]);r=ea(j*p);s=ea(g[d+4>>2]);t=ea(r+ea(o*s));r=ea(g[d+8>>2]);u=ea(t+ea(n*r));t=ea(-u);v=ea(ea(ea(p*p)+ea(s*s))+ea(r*r));w=ea(ea(ea(k*j)+ea(l*o))+ea(m*n));n=ea(ea(ea(k*k)+ea(l*l))+ea(m*m));o=ea(S(ea(ea(q*v)-ea(u*u))));do if(!(o>=ea(.00999999977))){if(u<ea(-0.0)){if(w>=ea(0.0)){x=ea(0.0);y=n;z=ea(0.0);break}j=ea(-w);if(q>=j){A=ea(j/q);x=A;y=ea(n+ea(w*A));z=ea(0.0);break}A=ea(ea(ea(k*p)+ea(l*s))+ea(m*r));j=ea(q+w);if(!(j<=u)){B=ea(ea(-j)/t);x=ea(1.0);y=ea(ea(n+ea(q+ea(w*ea(2.0))))+ea(B*ea(ea(ea(ea(-A)-u)*ea(2.0))+ea(v*B))));z=B;break}else{x=ea(1.0);y=ea(ea(n+ea(q+v))+ea(ea(ea(w-u)-A)*ea(2.0)));z=ea(1.0);break}}A=ea(-w);if(q<=A){x=ea(1.0);y=ea(n+ea(q+ea(w*ea(2.0))));z=ea(0.0);break}if(w<=ea(0.0)){B=ea(A/q);x=B;y=ea(n+ea(w*B));z=ea(0.0);break}B=ea(ea(ea(k*p)+ea(l*s))+ea(m*r));if(!(w>=u)){j=ea(A/t);x=ea(0.0);y=ea(n+ea(j*ea(ea(B*ea(-2.0))+ea(v*j))));z=j;break}else{x=ea(0.0);y=ea(n+ea(v+ea(B*ea(-2.0))));z=ea(1.0);break}}else{B=ea(ea(ea(k*p)+ea(l*s))+ea(m*r));j=ea(-B);A=ea(ea(u*B)-ea(w*v));C=ea(ea(w*t)-ea(q*j));if(!(A>=ea(0.0))){if(!(C>=ea(0.0))){if(w<ea(0.0)){D=ea(-w);if(!(q<=D)){E=ea(D/q);x=E;y=ea(n+ea(w*E));z=ea(0.0);break}else{x=ea(1.0);y=ea(n+ea(q+ea(w*ea(2.0))));z=ea(0.0);break}}if(B<=ea(-0.0)){x=ea(0.0);y=n;z=ea(0.0);break}if(!(B>=v)){E=ea(B/v);x=ea(0.0);y=ea(n+ea(E*j));z=E;break}else{x=ea(0.0);y=ea(n+ea(v+ea(B*ea(-2.0))));z=ea(1.0);break}}if(C<=o){if(B<=ea(-0.0)){x=ea(0.0);y=n;z=ea(0.0);break}if(!(B>=v)){E=ea(B/v);x=ea(0.0);y=ea(n+ea(E*j));z=E;break}else{x=ea(0.0);y=ea(n+ea(v+ea(B*ea(-2.0))));z=ea(1.0);break}}E=ea(w-u);if(E<ea(0.0)){D=ea(-E);if(!(q<=D)){F=ea(D/q);x=F;y=ea(n+ea(ea(B*ea(-2.0))+ea(v+ea(E*F))));z=ea(1.0);break}else{x=ea(1.0);y=ea(ea(n+ea(q+v))+ea(ea(E-B)*ea(2.0)));z=ea(1.0);break}}if(B<=ea(-0.0)){x=ea(0.0);y=n;z=ea(0.0);break}if(!(B>=v)){E=ea(B/v);x=ea(0.0);y=ea(n+ea(E*j));z=E;break}else{x=ea(0.0);y=ea(n+ea(v+ea(B*ea(-2.0))));z=ea(1.0);break}}d=!(C>=ea(0.0));if(A<=o){if(d){if(w>=ea(0.0)){x=ea(0.0);y=n;z=ea(0.0);break}E=ea(-w);if(!(q<=E)){F=ea(E/q);x=F;y=ea(n+ea(w*F));z=ea(0.0);break}else{x=ea(1.0);y=ea(n+ea(q+ea(w*ea(2.0))));z=ea(0.0);break}}if(C<=o){F=ea(ea(1.0)/o);E=ea(A*F);A=ea(C*F);x=E;y=ea(n+ea(ea(E*ea(ea(w*ea(2.0))+ea(ea(q*E)+ea(A*t))))+ea(A*ea(ea(B*ea(-2.0))+ea(ea(E*t)+ea(v*A))))));z=A;break}A=ea(w-u);if(A>=ea(0.0)){x=ea(0.0);y=ea(n+ea(v+ea(B*ea(-2.0))));z=ea(1.0);break}E=ea(-A);if(!(q<=E)){F=ea(E/q);x=F;y=ea(n+ea(ea(B*ea(-2.0))+ea(v+ea(A*F))));z=ea(1.0);break}else{x=ea(1.0);y=ea(ea(n+ea(q+v))+ea(ea(A-B)*ea(2.0)));z=ea(1.0);break}}if(d){A=ea(-w);if(q>A){if(w>=ea(0.0)){x=ea(0.0);y=n;z=ea(0.0);break}F=ea(A/q);x=F;y=ea(n+ea(w*F));z=ea(0.0);break}F=ea(j-u);if(F>=ea(0.0)){x=ea(1.0);y=ea(n+ea(q+ea(w*ea(2.0))));z=ea(0.0);break}A=ea(-F);if(!(v<=A)){E=ea(A/v);x=ea(1.0);y=ea(n+ea(ea(w*ea(2.0))+ea(q+ea(F*E))));z=E;break}else{x=ea(1.0);y=ea(ea(n+ea(q+v))+ea(ea(w+F)*ea(2.0)));z=ea(1.0);break}}if(C<=o){C=ea(j-u);if(C>=ea(0.0)){x=ea(1.0);y=ea(n+ea(q+ea(w*ea(2.0))));z=ea(0.0);break}F=ea(-C);if(!(v<=F)){E=ea(F/v);x=ea(1.0);y=ea(n+ea(ea(w*ea(2.0))+ea(q+ea(C*E))));z=E;break}else{x=ea(1.0);y=ea(ea(n+ea(q+v))+ea(ea(w+C)*ea(2.0)));z=ea(1.0);break}}C=ea(w-u);E=ea(-C);if(q>=E)if(!(C>=ea(0.0))){F=ea(E/q);x=F;y=ea(n+ea(ea(B*ea(-2.0))+ea(v+ea(C*F))));z=ea(1.0);break}else{x=ea(0.0);y=ea(n+ea(v+ea(B*ea(-2.0))));z=ea(1.0);break}B=ea(j-u);if(B>=ea(0.0)){x=ea(1.0);y=ea(n+ea(q+ea(w*ea(2.0))));z=ea(0.0);break}j=ea(-B);if(!(v<=j)){F=ea(j/v);x=ea(1.0);y=ea(n+ea(ea(w*ea(2.0))+ea(q+ea(B*F))));z=F;break}else{x=ea(1.0);y=ea(ea(n+ea(q+v))+ea(ea(w+B)*ea(2.0)));z=ea(1.0);break}}while(0);if(e)g[e>>2]=x;if(!f){G=y<ea(0.0);H=G?ea(0.0):y;i=h;return ea(H)}g[f>>2]=z;G=y<ea(0.0);H=G?ea(0.0):y;i=h;return ea(H)}function NOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=0,L=0,M=Im,N=Im;e=i;f=ea(g[a>>2]);h=ea(g[a+4>>2]);j=ea(g[a+8>>2]);k=ea(g[b>>2]);l=ea(g[b+4>>2]);m=ea(g[b+8>>2]);n=ea(ea(g[a+12>>2])-f);o=ea(ea(g[a+16>>2])-h);p=ea(ea(g[a+20>>2])-j);q=ea(ea(g[b+12>>2])-k);r=ea(ea(g[b+16>>2])-l);s=ea(ea(g[b+20>>2])-m);t=ea(f+ea(n*ea(.5)));f=ea(h+ea(o*ea(.5)));h=ea(j+ea(p*ea(.5)));j=ea(T(ea(ea(ea(n*n)+ea(o*o))+ea(p*p))));b=j!=ea(0.0);if(b){u=ea(ea(1.0)/j);v=ea(n*u);w=ea(o*u);x=ea(p*u);y=ea(j*ea(.5));z=u}else{v=n;w=o;x=p;y=j;z=ea(0.0)}j=ea(k+ea(q*ea(.5)));k=ea(l+ea(r*ea(.5)));l=ea(m+ea(s*ea(.5)));m=ea(T(ea(ea(ea(q*q)+ea(r*r))+ea(s*s))));a=m!=ea(0.0);if(a){p=ea(ea(1.0)/m);A=ea(q*p);B=ea(r*p);C=ea(s*p);D=ea(m*ea(.5));E=p}else{A=q;B=r;C=s;D=m;E=ea(0.0)}m=ea(t-j);j=ea(f-k);k=ea(h-l);l=ea(ea(x*C)+ea(ea(w*B)+ea(v*A)));h=ea(-l);f=ea(ea(k*x)+ea(ea(j*w)+ea(m*v)));v=ea(ea(k*C)+ea(ea(j*B)+ea(m*A)));A=ea(ea(ea(m*m)+ea(j*j))+ea(k*k));k=ea(S(ea(ea(1.0)-ea(l*l))));do if(k>=ea(9.99999997e-07)){j=ea(ea(l*v)-f);m=ea(v+ea(f*h));B=ea(y*k);C=ea(D*k);if(!(j>=ea(-B))){if(!(m>=ea(-C))){w=ea(-D);x=ea(f+ea(D*l));t=ea(-x);if(y<t){F=ea(ea(ea(ea(v*ea(-2.0))-D)*w)+ea(y*ea(y-ea(x*ea(-2.0)))));G=y;H=w;break}s=ea(-y);if(x<=y){F=ea(ea(ea(ea(v*ea(-2.0))-D)*w)+ea(x*t));G=t;H=w;break}t=ea(ea(y*l)-v);x=ea(-t);if(t>D){F=ea(ea(ea(ea(f*ea(2.0))-y)*s)+ea(ea(w-ea(t*ea(-2.0)))*w));G=s;H=w;break}if(!(D>=x)){F=ea(ea(ea(ea(f*ea(2.0))-y)*s)+ea(D*ea(D-ea(t*ea(-2.0)))));G=s;H=D;break}else{F=ea(ea(ea(ea(f*ea(2.0))-y)*s)+ea(t*x));G=s;H=x;break}}if(m<=C){x=ea(-y);s=ea(ea(y*l)-v);t=ea(-s);w=ea(-D);if(s>D){F=ea(ea(ea(ea(f*ea(2.0))-y)*x)+ea(ea(w-ea(s*ea(-2.0)))*w));G=x;H=w;break}if(!(D>=t)){F=ea(ea(ea(ea(f*ea(2.0))-y)*x)+ea(D*ea(D-ea(s*ea(-2.0)))));G=x;H=D;break}else{F=ea(ea(ea(ea(f*ea(2.0))-y)*x)+ea(s*t));G=x;H=t;break}}t=ea(f+ea(D*h));x=ea(-t);if(y<x){F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(y*ea(y-ea(t*ea(-2.0)))));G=y;H=D;break}s=ea(-y);if(t<=y){F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(t*x));G=x;H=D;break}x=ea(ea(y*l)-v);t=ea(-x);w=ea(-D);if(x>D){F=ea(ea(ea(ea(f*ea(2.0))-y)*s)+ea(ea(w-ea(x*ea(-2.0)))*w));G=s;H=w;break}if(!(D>=t)){F=ea(ea(ea(ea(f*ea(2.0))-y)*s)+ea(D*ea(D-ea(x*ea(-2.0)))));G=s;H=D;break}else{F=ea(ea(ea(ea(f*ea(2.0))-y)*s)+ea(x*t));G=s;H=t;break}}I=m>=ea(-C);if(j<=B){if(!I){B=ea(-D);t=ea(f+ea(D*l));s=ea(-t);x=ea(-y);if(t>y){F=ea(ea(ea(ea(v*ea(-2.0))-D)*B)+ea(ea(x-ea(t*ea(-2.0)))*x));G=x;H=B;break}if(!(y>=s)){F=ea(ea(ea(ea(v*ea(-2.0))-D)*B)+ea(y*ea(y-ea(t*ea(-2.0)))));G=y;H=B;break}else{F=ea(ea(ea(ea(v*ea(-2.0))-D)*B)+ea(t*s));G=s;H=B;break}}if(m<=C){B=ea(ea(1.0)/k);s=ea(j*B);j=ea(m*B);F=ea(ea(s*ea(ea(f*ea(2.0))+ea(s+ea(j*h))))+ea(j*ea(ea(v*ea(-2.0))+ea(j+ea(s*h)))));G=s;H=j;break}j=ea(f+ea(D*h));s=ea(-j);B=ea(-y);if(j>y){F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(ea(B-ea(j*ea(-2.0)))*B));G=B;H=D;break}if(!(y>=s)){F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(y*ea(y-ea(j*ea(-2.0)))));G=y;H=D;break}else{F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(j*s));G=s;H=D;break}}if(!I){s=ea(-D);j=ea(f+ea(D*l));B=ea(-j);t=ea(-y);if(j>y){F=ea(ea(ea(ea(v*ea(-2.0))-D)*s)+ea(ea(t-ea(j*ea(-2.0)))*t));G=t;H=s;break}if(y>=B){F=ea(ea(ea(ea(v*ea(-2.0))-D)*s)+ea(j*B));G=B;H=s;break}B=ea(ea(y*h)-v);j=ea(-B);if(D<j){F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(D*ea(D-ea(B*ea(-2.0)))));G=y;H=D;break}if(!(B<=D)){F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(ea(s-ea(B*ea(-2.0)))*s));G=y;H=s;break}else{F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(B*j));G=y;H=j;break}}if(m<=C){C=ea(ea(y*h)-v);m=ea(-C);j=ea(-D);if(C>D){F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(ea(j-ea(C*ea(-2.0)))*j));G=y;H=j;break}if(!(D>=m)){F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(D*ea(D-ea(C*ea(-2.0)))));G=y;H=D;break}else{F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(C*m));G=y;H=m;break}}m=ea(f+ea(D*h));C=ea(-m);j=ea(-y);if(m>y){F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(ea(j-ea(m*ea(-2.0)))*j));G=j;H=D;break}if(y>=C){F=ea(ea(D*ea(D+ea(v*ea(-2.0))))+ea(m*C));G=C;H=D;break}C=ea(ea(y*h)-v);m=ea(-C);j=ea(-D);if(C>D){F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(ea(j-ea(C*ea(-2.0)))*j));G=y;H=j;break}if(!(D>=m)){F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(D*ea(D-ea(C*ea(-2.0)))));G=y;H=D;break}else{F=ea(ea(y*ea(y+ea(f*ea(2.0))))+ea(C*m));G=y;H=m;break}}else{m=ea(y+D);I=l<ea(-0.0);C=I?ea(-1.0):ea(1.0);j=ea(-f);if(!(f>m))if(m<j)J=m;else J=j;else J=ea(-m);j=ea(ea(D*ea(f*C))/m);F=ea(J*ea(ea(f*ea(2.0))+J));G=ea(J+ea(C*j));H=j}while(0);J=ea(A+F);I=(c|0)==0;if(!I)g[c>>2]=G;K=(d|0)==0;if(!K)g[d>>2]=H;L=J<ea(0.0);H=L?ea(0.0):J;if(!I){if(b)M=ea(z*ea(y+ea(g[c>>2])));else M=ea(0.0);g[c>>2]=M}if(K){i=e;return ea(H)}if(a)N=ea(E*ea(D+ea(g[d>>2])));else N=ea(0.0);g[d>>2]=N;i=e;return ea(H)}function OOa(a,b,d,e,f,h,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im;q=i;i=i+64|0;r=q+48|0;s=q+32|0;t=q+16|0;u=q;v=ea(g[d>>2]);w=ea(g[d+4>>2]);x=ea(g[d+8>>2]);y=ea(g[b>>2]);z=ea(g[b+4>>2]);A=ea(g[b+8>>2]);B=ea(g[f>>2]);C=ea(g[f+4>>2]);D=ea(g[f+8>>2]);E=ea(g[j>>2]);F=ea(g[j+4>>2]);G=ea(g[j+8>>2]);H=ea(g[l>>2]);I=ea(g[l+4>>2]);J=ea(g[l+8>>2]);K=ea(g[n>>2]);L=ea(g[n+4>>2]);M=ea(g[n+8>>2]);N=ea(g[e>>2]);O=ea(g[e+4>>2]);P=ea(g[e+8>>2]);Q=ea(g[h>>2]);R=ea(g[h+4>>2]);S=ea(g[h+8>>2]);T=ea(g[k>>2]);U=ea(g[k+4>>2]);V=ea(g[k+8>>2]);W=ea(g[m>>2]);X=ea(g[m+4>>2]);Y=ea(g[m+8>>2]);Z=ea(y-N);_=ea(y-Q);$=ea(y-T);aa=ea(y-W);ba=ea(z-O);ca=ea(z-R);da=ea(z-U);fa=ea(z-X);ga=ea(A-P);ha=ea(A-S);ia=ea(A-V);ja=ea(A-Y);ka=ea(ea(ea(v*v)+ea(w*w))+ea(x*x));la=ea(ea(D*D)+ea(ea(B*B)+ea(C*C)));ma=ea(ea(G*G)+ea(ea(E*E)+ea(F*F)));na=ea(ea(J*J)+ea(ea(H*H)+ea(I*I)));oa=ea(ea(M*M)+ea(ea(K*K)+ea(L*L)));pa=ea(ea(x*D)+ea(ea(v*B)+ea(w*C)));qa=ea(ea(x*G)+ea(ea(v*E)+ea(w*F)));ra=ea(ea(x*J)+ea(ea(v*H)+ea(w*I)));sa=ea(ea(x*M)+ea(ea(v*K)+ea(w*L)));ta=ea(ea(x*ga)+ea(ea(v*Z)+ea(w*ba)));ua=ea(ea(x*ha)+ea(ea(v*_)+ea(w*ca)));va=ea(ea(x*ia)+ea(ea(v*$)+ea(w*da)));wa=ea(ea(x*ja)+ea(ea(v*aa)+ea(w*fa)));xa=ea(ea(D*ga)+ea(ea(B*Z)+ea(C*ba)));ba=ea(ea(G*ha)+ea(ea(E*_)+ea(F*ca)));ca=ea(ea(J*ia)+ea(ea(H*$)+ea(I*da)));da=ea(ea(M*ja)+ea(ea(K*aa)+ea(L*fa)));fa=ea(ea(1.0)/ka);aa=ea(ea(1.0)/la);ja=ea(ea(1.0)/ma);$=ea(ea(1.0)/na);ia=ea(ea(1.0)/oa);_=ea(ea(la*ka)-ea(pa*pa));ha=ea(ea(ma*ka)-ea(qa*qa));Z=ea(ea(na*ka)-ea(ra*ra));ga=ea(ea(oa*ka)-ea(sa*sa));ya=ea(ea(ea(pa*xa)-ea(la*ta))/_);la=ea(ea(ea(qa*ba)-ea(ma*ua))/ha);ma=ea(ea(ea(ra*ca)-ea(na*va))/Z);na=ea(ea(ea(sa*da)-ea(oa*wa))/ga);m=ya<ea(1.0);oa=m?ya:ea(1.0);m=la<ea(1.0);ya=m?la:ea(1.0);m=ma<ea(1.0);la=m?ma:ea(1.0);m=na<ea(1.0);ma=m?na:ea(1.0);m=oa>ea(0.0);na=m?oa:ea(0.0);m=ya>ea(0.0);oa=m?ya:ea(0.0);m=la>ea(0.0);ya=m?la:ea(0.0);m=ma>ea(0.0);la=m?ma:ea(0.0);m=_<=ea(1.1920929e-07);k=ha<=ea(1.1920929e-07);h=Z<=ea(1.1920929e-07);e=ga<=ea(1.1920929e-07);g[s>>2]=ea(.5);g[s+4>>2]=ea(.5);g[s+8>>2]=ea(.5);g[s+12>>2]=ea(.5);g[r>>2]=na;g[r+4>>2]=oa;g[r+8>>2]=ya;g[r+12>>2]=la;la=ea(g[(m?s:r)>>2]);ya=ea(g[(k?s:r)+4>>2]);oa=ea(g[(h?s:r)+8>>2]);na=ea(aa*ea(xa+ea(pa*la)));la=ea(ja*ea(ba+ea(qa*ya)));ya=ea($*ea(ca+ea(ra*oa)));oa=ea(ia*ea(da+ea(sa*ea(g[(e?s:r)+12>>2]))));r=na<ea(1.0);da=r?na:ea(1.0);r=la<ea(1.0);na=r?la:ea(1.0);r=ya<ea(1.0);la=r?ya:ea(1.0);r=oa<ea(1.0);ya=r?oa:ea(1.0);r=da>ea(0.0);oa=r?da:ea(0.0);r=na>ea(0.0);da=r?na:ea(0.0);r=la>ea(0.0);na=r?la:ea(0.0);r=ya>ea(0.0);la=r?ya:ea(0.0);ya=ea(fa*ea(ea(pa*oa)-ta));ta=ea(fa*ea(ea(qa*da)-ua));ua=ea(fa*ea(ea(ra*na)-va));va=ea(fa*ea(ea(sa*la)-wa));r=ka<=ea(1.1920929e-07);c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;s=ya<ea(1.0);ka=s?ya:ea(1.0);s=ta<ea(1.0);ya=s?ta:ea(1.0);s=ua<ea(1.0);ta=s?ua:ea(1.0);s=va<ea(1.0);ua=s?va:ea(1.0);s=ka>ea(0.0);va=s?ka:ea(0.0);s=ya>ea(0.0);ka=s?ya:ea(0.0);s=ta>ea(0.0);ya=s?ta:ea(0.0);s=ua>ea(0.0);ta=s?ua:ea(0.0);g[t>>2]=va;g[t+4>>2]=ka;g[t+8>>2]=ya;g[t+12>>2]=ta;s=r?u:t;ta=ea(g[s>>2]);ya=ea(g[s+4>>2]);ka=ea(g[s+8>>2]);va=ea(g[s+12>>2]);g[o>>2]=ta;g[o+4>>2]=ya;g[o+8>>2]=ka;g[o+12>>2]=va;g[p>>2]=oa;g[p+4>>2]=da;g[p+8>>2]=na;g[p+12>>2]=la;ua=ea(ea(y+ea(v*ta))-ea(N+ea(B*oa)));B=ea(ea(y+ea(v*ya))-ea(Q+ea(E*da)));E=ea(ea(y+ea(v*ka))-ea(T+ea(H*na)));H=ea(ea(y+ea(v*va))-ea(W+ea(K*la)));K=ea(ea(z+ea(w*ta))-ea(O+ea(C*oa)));C=ea(ea(z+ea(w*ya))-ea(R+ea(F*da)));F=ea(ea(z+ea(w*ka))-ea(U+ea(I*na)));I=ea(ea(z+ea(w*va))-ea(X+ea(L*la)));L=ea(ea(A+ea(x*ta))-ea(P+ea(D*oa)));oa=ea(ea(A+ea(x*ya))-ea(S+ea(G*da)));da=ea(ea(A+ea(x*ka))-ea(V+ea(J*na)));na=ea(ea(A+ea(x*va))-ea(Y+ea(M*la)));la=ea(ea(B*B)+ea(ea(C*C)+ea(oa*oa)));oa=ea(ea(E*E)+ea(ea(F*F)+ea(da*da)));da=ea(ea(H*H)+ea(ea(I*I)+ea(na*na)));g[a>>2]=ea(ea(ua*ua)+ea(ea(K*K)+ea(L*L)));g[a+4>>2]=la;g[a+8>>2]=oa;g[a+12>>2]=da;i=q;return}function POa(a,b,c,d,e,f,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=0,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=Im,S=Im,T=Im,U=Im,V=0,W=Im,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=0,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=0,Oa=0,Pa=Im,Qa=Im,Ra=Im;k=i;i=i+112|0;l=k+32|0;m=k+20|0;n=k+76|0;o=k+60|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+92|0;t=k+8|0;u=k+4|0;v=k+44|0;w=k+12|0;x=k;y=k+16|0;z=ea(g[b>>2]);A=ea(z*z);B=b+4|0;C=ea(g[B>>2]);D=ea(A+ea(C*C));E=b+8|0;A=ea(g[E>>2]);F=ea(D+ea(A*A));if(F<ea(9.99999996e-13)){if(f)g[f>>2]=ea(0.0);D=ea(g[d>>2]);G=ea(g[c>>2]);H=ea(D+G);D=ea(g[d+4>>2]);I=ea(g[c+4>>2]);J=ea(D+I);D=ea(g[d+8>>2]);K=ea(g[c+8>>2]);L=ea(D+K);g[l>>2]=H;g[l+4>>2]=J;g[l+8>>2]=L;L=ea(G+ea(g[e>>2]));G=ea(I+ea(g[e+4>>2]));I=ea(K+ea(g[e+8>>2]));g[m>>2]=L;g[m+4>>2]=G;g[m+8>>2]=I;JOa(p,a,c,l,m,n,o);if(h)g[h>>2]=ea(g[n>>2]);if(j)g[j>>2]=ea(g[o>>2]);I=ea(g[p>>2]);G=ea(I-ea(g[a>>2]));I=ea(g[p+4>>2]);L=ea(I-ea(g[a+4>>2]));I=ea(g[p+8>>2]);K=ea(I-ea(g[a+8>>2]));M=ea(ea(ea(G*G)+ea(L*L))+ea(K*K));i=k;return ea(M)}K=ea(g[c>>2]);L=ea(g[a>>2]);G=ea(K-L);N=c+4|0;I=ea(g[N>>2]);O=a+4|0;J=ea(g[O>>2]);H=ea(I-J);P=c+8|0;D=ea(g[P>>2]);Q=a+8|0;R=ea(g[Q>>2]);S=ea(D-R);T=ea(g[d>>2]);U=ea(z*T);V=d+4|0;W=ea(g[V>>2]);X=ea(U+ea(C*W));Y=d+8|0;U=ea(g[Y>>2]);Z=ea(X+ea(A*U));X=ea(-Z);_=ea(g[e>>2]);$=ea(z*_);aa=e+4|0;ba=ea(g[aa>>2]);ca=ea($+ea(C*ba));da=e+8|0;$=ea(g[da>>2]);fa=ea(ca+ea(A*$));ca=ea(-fa);ga=ea(ea(ea(T*T)+ea(W*W))+ea(U*U));ha=ea(ea(ea(T*_)+ea(W*ba))+ea(U*$));ia=ea(ea(ea(_*_)+ea(ba*ba))+ea($*$));ja=ea(ea(ga*ia)-ea(ha*ha));ka=ea(ea(ha*ca)-ea(ia*X));la=ea(ea(ha*X)-ea(ga*ca));ma=ea(ea(W*$)-ea(U*ba));na=ea(ea(U*_)-ea(T*$));oa=ea(ea(T*ba)-ea(W*_));pa=ea(ea(A*oa)+ea(ea(z*ma)+ea(C*na)));do if(!(+ea(pa*pa)>=+F*1.0e-06*+ea(ea(oa*oa)+ea(ea(ma*ma)+ea(na*na))))){g[q>>2]=K;qa=q+4|0;g[qa>>2]=I;ra=q+8|0;g[ra>>2]=D;g[r>>2]=T;sa=r+4|0;g[sa>>2]=W;ta=r+8|0;g[ta>>2]=U;ua=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);g[r>>2]=ea(g[e>>2]);g[sa>>2]=ea(g[aa>>2]);g[ta>>2]=ea(g[da>>2]);va=ea(MOa(a,b,q,r,w,y));g[x>>2]=ea(0.0);if(va<ua){g[t>>2]=ea(g[w>>2]);g[u>>2]=ea(0.0);g[v>>2]=ea(g[y>>2]);wa=va}else wa=ua;ua=ea(g[c>>2]);va=ea(g[d>>2]);xa=ea(ua+va);ua=ea(g[N>>2]);ya=ea(g[V>>2]);za=ea(ua+ya);ua=ea(g[P>>2]);Aa=ea(g[Y>>2]);Ba=ea(ua+Aa);g[q>>2]=xa;g[qa>>2]=za;g[ra>>2]=Ba;Ba=ea(ea(g[e>>2])-va);va=ea(ea(g[aa>>2])-ya);ya=ea(ea(g[da>>2])-Aa);g[r>>2]=Ba;g[sa>>2]=va;g[ta>>2]=ya;ya=ea(MOa(a,b,q,r,w,y));va=ea(g[y>>2]);Ba=ea(ea(1.0)-va);g[x>>2]=Ba;if(ya<wa){g[t>>2]=ea(g[w>>2]);g[u>>2]=Ba;g[v>>2]=va;Ca=ya}else Ca=wa;ya=ea(g[d>>2]);va=ea(g[c>>2]);Ba=ea(ya+va);ya=ea(g[V>>2]);Aa=ea(g[N>>2]);za=ea(ya+Aa);ya=ea(g[Y>>2]);xa=ea(g[P>>2]);ua=ea(ya+xa);g[l>>2]=Ba;g[l+4>>2]=za;g[l+8>>2]=ua;ua=ea(va+ea(g[e>>2]));va=ea(Aa+ea(g[aa>>2]));Aa=ea(xa+ea(g[da>>2]));g[m>>2]=ua;g[m+4>>2]=va;g[m+8>>2]=Aa;JOa(p,a,c,l,m,n,o);Aa=ea(g[n>>2]);g[x>>2]=Aa;va=ea(g[o>>2]);g[y>>2]=va;ua=ea(g[p>>2]);xa=ea(g[a>>2]);za=ea(ua-xa);ua=ea(g[p+4>>2]);Ba=ea(g[O>>2]);ya=ea(ua-Ba);ua=ea(g[p+8>>2]);Da=ea(g[Q>>2]);Ea=ea(ua-Da);ua=ea(ea(ea(za*za)+ea(ya*ya))+ea(Ea*Ea));g[w>>2]=ea(0.0);if(ua<Ca){g[t>>2]=ea(0.0);g[u>>2]=Aa;g[v>>2]=va;Fa=ua}else Fa=Ca;ua=ea(xa+ea(g[b>>2]));xa=ea(Ba+ea(g[B>>2]));Ba=ea(Da+ea(g[E>>2]));g[s>>2]=ua;ta=s+4|0;g[ta>>2]=xa;sa=s+8|0;g[sa>>2]=Ba;Ba=ea(g[d>>2]);xa=ea(g[c>>2]);ua=ea(Ba+xa);Ba=ea(g[V>>2]);Da=ea(g[N>>2]);va=ea(Ba+Da);Ba=ea(g[Y>>2]);Aa=ea(g[P>>2]);Ea=ea(Ba+Aa);g[l>>2]=ua;g[l+4>>2]=va;g[l+8>>2]=Ea;Ea=ea(xa+ea(g[e>>2]));xa=ea(Da+ea(g[aa>>2]));Da=ea(Aa+ea(g[da>>2]));g[m>>2]=Ea;g[m+4>>2]=xa;g[m+8>>2]=Da;JOa(p,s,c,l,m,n,o);Da=ea(g[n>>2]);g[x>>2]=Da;xa=ea(g[o>>2]);g[y>>2]=xa;Ea=ea(g[p>>2]);Aa=ea(Ea-ea(g[s>>2]));Ea=ea(g[p+4>>2]);va=ea(Ea-ea(g[ta>>2]));Ea=ea(g[p+8>>2]);ua=ea(Ea-ea(g[sa>>2]));Ea=ea(ea(ea(Aa*Aa)+ea(va*va))+ea(ua*ua));g[w>>2]=ea(1.0);if(Ea<Fa){g[t>>2]=ea(1.0);g[u>>2]=Da;g[v>>2]=xa;Ga=Ea}else Ga=Fa}else{Ea=ea(ea(F*ia)-ea(fa*fa));xa=ea(ea(Z*fa)-ea(F*ha));Da=ea(ea(F*ga)-ea(Z*Z));ua=ea(ea(1.0)/ea(ea(la*ca)+ea(ea(F*ja)+ea(ka*X))));va=ea(ea(ea(ea(z*G)+ea(C*H))+ea(A*S))*ua);Aa=ea(-ea(ea(ea(ea(G*T)+ea(H*W))+ea(S*U))*ua));Ba=ea(-ea(ea(ea(ea(G*_)+ea(H*ba))+ea(S*$))*ua));ua=ea(ea(la*Ba)+ea(ea(ja*va)+ea(ka*Aa)));g[t>>2]=ua;ya=ea(ea(xa*Ba)+ea(ea(ka*va)+ea(Ea*Aa)));g[u>>2]=ya;Ea=ea(ea(Da*Ba)+ea(ea(la*va)+ea(xa*Aa)));g[v>>2]=Ea;if(ua<ea(0.0)){sa=ya<ea(0.0);if(!(ea(Ea+ya)<=ea(1.0))){if(sa){g[q>>2]=K;ta=q+4|0;g[ta>>2]=I;ra=q+8|0;g[ra>>2]=D;g[r>>2]=_;qa=r+4|0;g[qa>>2]=ba;Ha=r+8|0;g[Ha>>2]=$;Aa=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(0.0);xa=ea(g[c>>2]);va=ea(g[d>>2]);Ba=ea(xa+va);xa=ea(g[N>>2]);Da=ea(g[V>>2]);za=ea(xa+Da);xa=ea(g[P>>2]);Ia=ea(g[Y>>2]);Ja=ea(xa+Ia);g[q>>2]=Ba;g[ta>>2]=za;g[ra>>2]=Ja;Ja=ea(ea(g[e>>2])-va);va=ea(ea(g[aa>>2])-Da);Da=ea(ea(g[da>>2])-Ia);g[r>>2]=Ja;g[qa>>2]=va;g[Ha>>2]=Da;Da=ea(MOa(a,b,q,r,w,y));va=ea(g[y>>2]);Ja=ea(ea(1.0)-va);g[x>>2]=Ja;if(Da<Aa){g[t>>2]=ea(g[w>>2]);g[u>>2]=Ja;g[v>>2]=va;Ka=Da}else Ka=Aa;Aa=ea(g[d>>2]);Da=ea(g[c>>2]);va=ea(Aa+Da);Aa=ea(g[V>>2]);Ja=ea(g[N>>2]);Ia=ea(Aa+Ja);Aa=ea(g[Y>>2]);za=ea(g[P>>2]);Ba=ea(Aa+za);g[l>>2]=va;g[l+4>>2]=Ia;g[l+8>>2]=Ba;Ba=ea(Da+ea(g[e>>2]));Da=ea(Ja+ea(g[aa>>2]));Ja=ea(za+ea(g[da>>2]));g[m>>2]=Ba;g[m+4>>2]=Da;g[m+8>>2]=Ja;JOa(p,a,c,l,m,n,o);Ja=ea(g[n>>2]);g[x>>2]=Ja;Da=ea(g[o>>2]);g[y>>2]=Da;Ba=ea(g[p>>2]);za=ea(Ba-ea(g[a>>2]));Ba=ea(g[p+4>>2]);Ia=ea(Ba-ea(g[O>>2]));Ba=ea(g[p+8>>2]);va=ea(Ba-ea(g[Q>>2]));Ba=ea(ea(ea(za*za)+ea(Ia*Ia))+ea(va*va));g[w>>2]=ea(0.0);if(!(Ba<Ka)){Ga=Ka;break}g[t>>2]=ea(0.0);g[u>>2]=Ja;g[v>>2]=Da;Ga=Ba;break}if(!(Ea<ea(0.0))){Ba=ea(I+W);Da=ea(D+U);g[q>>2]=ea(K+T);g[q+4>>2]=Ba;g[q+8>>2]=Da;Da=ea(ba-W);Ba=ea($-U);g[r>>2]=ea(_-T);g[r+4>>2]=Da;g[r+8>>2]=Ba;Ba=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(ea(1.0)-ea(g[v>>2]));Da=ea(g[d>>2]);Ja=ea(g[c>>2]);va=ea(Da+Ja);Da=ea(g[V>>2]);Ia=ea(g[N>>2]);za=ea(Da+Ia);Da=ea(g[Y>>2]);Aa=ea(g[P>>2]);xa=ea(Da+Aa);g[l>>2]=va;g[l+4>>2]=za;g[l+8>>2]=xa;xa=ea(Ja+ea(g[e>>2]));Ja=ea(Ia+ea(g[aa>>2]));Ia=ea(Aa+ea(g[da>>2]));g[m>>2]=xa;g[m+4>>2]=Ja;g[m+8>>2]=Ia;JOa(p,a,c,l,m,n,o);Ia=ea(g[n>>2]);g[x>>2]=Ia;Ja=ea(g[o>>2]);g[y>>2]=Ja;xa=ea(g[p>>2]);Aa=ea(xa-ea(g[a>>2]));xa=ea(g[p+4>>2]);za=ea(xa-ea(g[O>>2]));xa=ea(g[p+8>>2]);va=ea(xa-ea(g[Q>>2]));xa=ea(ea(ea(Aa*Aa)+ea(za*za))+ea(va*va));g[w>>2]=ea(0.0);if(!(xa<Ba)){Ga=Ba;break}g[t>>2]=ea(0.0);g[u>>2]=Ia;g[v>>2]=Ja;Ga=xa;break}g[q>>2]=K;Ha=q+4|0;g[Ha>>2]=I;qa=q+8|0;g[qa>>2]=D;g[r>>2]=T;ra=r+4|0;g[ra>>2]=W;ta=r+8|0;g[ta>>2]=U;xa=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);Ja=ea(g[c>>2]);Ia=ea(g[d>>2]);Ba=ea(Ja+Ia);Ja=ea(g[N>>2]);va=ea(g[V>>2]);za=ea(Ja+va);Ja=ea(g[P>>2]);Aa=ea(g[Y>>2]);Da=ea(Ja+Aa);g[q>>2]=Ba;g[Ha>>2]=za;g[qa>>2]=Da;Da=ea(ea(g[e>>2])-Ia);Ia=ea(ea(g[aa>>2])-va);va=ea(ea(g[da>>2])-Aa);g[r>>2]=Da;g[ra>>2]=Ia;g[ta>>2]=va;va=ea(MOa(a,b,q,r,w,y));Ia=ea(g[y>>2]);Da=ea(ea(1.0)-Ia);g[x>>2]=Da;if(va<xa){g[t>>2]=ea(g[w>>2]);g[u>>2]=Da;g[v>>2]=Ia;La=va}else La=xa;xa=ea(g[d>>2]);va=ea(g[c>>2]);Ia=ea(xa+va);xa=ea(g[V>>2]);Da=ea(g[N>>2]);Aa=ea(xa+Da);xa=ea(g[Y>>2]);za=ea(g[P>>2]);Ba=ea(xa+za);g[l>>2]=Ia;g[l+4>>2]=Aa;g[l+8>>2]=Ba;Ba=ea(va+ea(g[e>>2]));va=ea(Da+ea(g[aa>>2]));Da=ea(za+ea(g[da>>2]));g[m>>2]=Ba;g[m+4>>2]=va;g[m+8>>2]=Da;JOa(p,a,c,l,m,n,o);Da=ea(g[n>>2]);g[x>>2]=Da;va=ea(g[o>>2]);g[y>>2]=va;Ba=ea(g[p>>2]);za=ea(Ba-ea(g[a>>2]));Ba=ea(g[p+4>>2]);Aa=ea(Ba-ea(g[O>>2]));Ba=ea(g[p+8>>2]);Ia=ea(Ba-ea(g[Q>>2]));Ba=ea(ea(ea(za*za)+ea(Aa*Aa))+ea(Ia*Ia));g[w>>2]=ea(0.0);if(!(Ba<La)){Ga=La;break}g[t>>2]=ea(0.0);g[u>>2]=Da;g[v>>2]=va;Ga=Ba;break}else{ta=Ea<ea(0.0);if(!sa){if(!ta){Ba=ea(W+I);va=ea(U+D);g[l>>2]=ea(T+K);g[l+4>>2]=Ba;g[l+8>>2]=va;va=ea(I+ba);Ba=ea(D+$);g[m>>2]=ea(K+_);g[m+4>>2]=va;g[m+8>>2]=Ba;JOa(p,a,c,l,m,n,o);g[u>>2]=ea(g[n>>2]);g[v>>2]=ea(g[o>>2]);Ba=ea(g[p>>2]);va=ea(Ba-ea(g[a>>2]));Ba=ea(g[p+4>>2]);Da=ea(Ba-ea(g[O>>2]));Ba=ea(g[p+8>>2]);Ia=ea(Ba-ea(g[Q>>2]));Ba=ea(ea(ea(va*va)+ea(Da*Da))+ea(Ia*Ia));g[t>>2]=ea(0.0);Ga=Ba;break}g[q>>2]=K;g[q+4>>2]=I;g[q+8>>2]=D;g[r>>2]=T;g[r+4>>2]=W;g[r+8>>2]=U;Ba=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);Ia=ea(g[d>>2]);Da=ea(g[c>>2]);va=ea(Ia+Da);Ia=ea(g[V>>2]);Aa=ea(g[N>>2]);za=ea(Ia+Aa);Ia=ea(g[Y>>2]);xa=ea(g[P>>2]);Ja=ea(Ia+xa);g[l>>2]=va;g[l+4>>2]=za;g[l+8>>2]=Ja;Ja=ea(Da+ea(g[e>>2]));Da=ea(Aa+ea(g[aa>>2]));Aa=ea(xa+ea(g[da>>2]));g[m>>2]=Ja;g[m+4>>2]=Da;g[m+8>>2]=Aa;JOa(p,a,c,l,m,n,o);Aa=ea(g[n>>2]);g[x>>2]=Aa;Da=ea(g[o>>2]);g[y>>2]=Da;Ja=ea(g[p>>2]);xa=ea(Ja-ea(g[a>>2]));Ja=ea(g[p+4>>2]);za=ea(Ja-ea(g[O>>2]));Ja=ea(g[p+8>>2]);va=ea(Ja-ea(g[Q>>2]));Ja=ea(ea(ea(xa*xa)+ea(za*za))+ea(va*va));g[w>>2]=ea(0.0);if(!(Ja<Ba)){Ga=Ba;break}g[t>>2]=ea(0.0);g[u>>2]=Aa;g[v>>2]=Da;Ga=Ja;break}g[q>>2]=K;sa=q+4|0;g[sa>>2]=I;ra=q+8|0;g[ra>>2]=D;g[r>>2]=_;qa=r+4|0;g[qa>>2]=ba;Ha=r+8|0;g[Ha>>2]=$;Ja=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(0.0);if(!ta){Da=ea(g[d>>2]);Aa=ea(g[c>>2]);Ba=ea(Da+Aa);Da=ea(g[V>>2]);va=ea(g[N>>2]);za=ea(Da+va);Da=ea(g[Y>>2]);xa=ea(g[P>>2]);Ia=ea(Da+xa);g[l>>2]=Ba;g[l+4>>2]=za;g[l+8>>2]=Ia;Ia=ea(Aa+ea(g[e>>2]));Aa=ea(va+ea(g[aa>>2]));va=ea(xa+ea(g[da>>2]));g[m>>2]=Ia;g[m+4>>2]=Aa;g[m+8>>2]=va;JOa(p,a,c,l,m,n,o);va=ea(g[n>>2]);g[x>>2]=va;Aa=ea(g[o>>2]);g[y>>2]=Aa;Ia=ea(g[p>>2]);xa=ea(Ia-ea(g[a>>2]));Ia=ea(g[p+4>>2]);za=ea(Ia-ea(g[O>>2]));Ia=ea(g[p+8>>2]);Ba=ea(Ia-ea(g[Q>>2]));Ia=ea(ea(ea(xa*xa)+ea(za*za))+ea(Ba*Ba));g[w>>2]=ea(0.0);if(!(Ia<Ja)){Ga=Ja;break}g[t>>2]=ea(0.0);g[u>>2]=va;g[v>>2]=Aa;Ga=Ia;break}g[q>>2]=ea(g[c>>2]);g[sa>>2]=ea(g[N>>2]);g[ra>>2]=ea(g[P>>2]);g[r>>2]=ea(g[d>>2]);g[qa>>2]=ea(g[V>>2]);g[Ha>>2]=ea(g[Y>>2]);Ia=ea(MOa(a,b,q,r,w,x));g[y>>2]=ea(0.0);if(Ia<Ja){g[t>>2]=ea(g[w>>2]);g[u>>2]=ea(g[x>>2]);g[v>>2]=ea(0.0);Ma=Ia}else Ma=Ja;Ja=ea(g[d>>2]);Ia=ea(g[c>>2]);Aa=ea(Ja+Ia);Ja=ea(g[V>>2]);va=ea(g[N>>2]);Ba=ea(Ja+va);Ja=ea(g[Y>>2]);za=ea(g[P>>2]);xa=ea(Ja+za);g[l>>2]=Aa;g[l+4>>2]=Ba;g[l+8>>2]=xa;xa=ea(Ia+ea(g[e>>2]));Ia=ea(va+ea(g[aa>>2]));va=ea(za+ea(g[da>>2]));g[m>>2]=xa;g[m+4>>2]=Ia;g[m+8>>2]=va;JOa(p,a,c,l,m,n,o);va=ea(g[n>>2]);g[x>>2]=va;Ia=ea(g[o>>2]);g[y>>2]=Ia;xa=ea(g[p>>2]);za=ea(xa-ea(g[a>>2]));xa=ea(g[p+4>>2]);Ba=ea(xa-ea(g[O>>2]));xa=ea(g[p+8>>2]);Aa=ea(xa-ea(g[Q>>2]));xa=ea(ea(ea(za*za)+ea(Ba*Ba))+ea(Aa*Aa));g[w>>2]=ea(0.0);if(!(xa<Ma)){Ga=Ma;break}g[t>>2]=ea(0.0);g[u>>2]=va;g[v>>2]=Ia;Ga=xa;break}}Ha=ea(Ea+ya)<=ea(1.0);qa=ya<ea(0.0);if(ua<=ea(1.0)){if(Ha){ra=Ea<ea(0.0);if(!qa){if(!ra){Ga=ea(0.0);break}g[q>>2]=K;g[q+4>>2]=I;g[q+8>>2]=D;g[r>>2]=T;g[r+4>>2]=W;g[r+8>>2]=U;ua=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);Ga=ua;break}g[q>>2]=K;sa=q+4|0;g[sa>>2]=I;ta=q+8|0;g[ta>>2]=D;g[r>>2]=_;Na=r+4|0;g[Na>>2]=ba;Oa=r+8|0;g[Oa>>2]=$;ua=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(0.0);if(!ra){Ga=ua;break}g[q>>2]=ea(g[c>>2]);g[sa>>2]=ea(g[N>>2]);g[ta>>2]=ea(g[P>>2]);g[r>>2]=ea(g[d>>2]);g[Na>>2]=ea(g[V>>2]);g[Oa>>2]=ea(g[Y>>2]);ya=ea(MOa(a,b,q,r,w,x));g[y>>2]=ea(0.0);if(!(ya<ua)){Ga=ua;break}g[t>>2]=ea(g[w>>2]);g[u>>2]=ea(g[x>>2]);g[v>>2]=ea(0.0);Ga=ya;break}if(qa){g[q>>2]=K;Oa=q+4|0;g[Oa>>2]=I;Na=q+8|0;g[Na>>2]=D;g[r>>2]=_;ta=r+4|0;g[ta>>2]=ba;sa=r+8|0;g[sa>>2]=$;ya=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(0.0);ua=ea(g[c>>2]);xa=ea(g[d>>2]);Ia=ea(ua+xa);ua=ea(g[N>>2]);va=ea(g[V>>2]);Aa=ea(ua+va);ua=ea(g[P>>2]);Ba=ea(g[Y>>2]);za=ea(ua+Ba);g[q>>2]=Ia;g[Oa>>2]=Aa;g[Na>>2]=za;za=ea(ea(g[e>>2])-xa);xa=ea(ea(g[aa>>2])-va);va=ea(ea(g[da>>2])-Ba);g[r>>2]=za;g[ta>>2]=xa;g[sa>>2]=va;va=ea(MOa(a,b,q,r,w,y));xa=ea(g[y>>2]);za=ea(ea(1.0)-xa);g[x>>2]=za;if(!(va<ya)){Ga=ya;break}g[t>>2]=ea(g[w>>2]);g[u>>2]=za;g[v>>2]=xa;Ga=va;break}if(!(Ea<ea(0.0))){va=ea(I+W);xa=ea(D+U);g[q>>2]=ea(K+T);g[q+4>>2]=va;g[q+8>>2]=xa;xa=ea(ba-W);va=ea($-U);g[r>>2]=ea(_-T);g[r+4>>2]=xa;g[r+8>>2]=va;va=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(ea(1.0)-ea(g[v>>2]));Ga=va;break}g[q>>2]=K;sa=q+4|0;g[sa>>2]=I;ta=q+8|0;g[ta>>2]=D;g[r>>2]=T;Na=r+4|0;g[Na>>2]=W;Oa=r+8|0;g[Oa>>2]=U;va=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);xa=ea(g[c>>2]);za=ea(g[d>>2]);ya=ea(xa+za);xa=ea(g[N>>2]);Ba=ea(g[V>>2]);Aa=ea(xa+Ba);xa=ea(g[P>>2]);Ia=ea(g[Y>>2]);ua=ea(xa+Ia);g[q>>2]=ya;g[sa>>2]=Aa;g[ta>>2]=ua;ua=ea(ea(g[e>>2])-za);za=ea(ea(g[aa>>2])-Ba);Ba=ea(ea(g[da>>2])-Ia);g[r>>2]=ua;g[Na>>2]=za;g[Oa>>2]=Ba;Ba=ea(MOa(a,b,q,r,w,y));za=ea(g[y>>2]);ua=ea(ea(1.0)-za);g[x>>2]=ua;if(!(Ba<va)){Ga=va;break}g[t>>2]=ea(g[w>>2]);g[u>>2]=ua;g[v>>2]=za;Ga=Ba;break}if(Ha){Ha=Ea<ea(0.0);if(!qa){if(!Ha){Ba=ea(J+C);za=ea(R+A);g[s>>2]=ea(L+z);Oa=s+4|0;g[Oa>>2]=Ba;Na=s+8|0;g[Na>>2]=za;za=ea(W+I);Ba=ea(U+D);g[l>>2]=ea(T+K);g[l+4>>2]=za;g[l+8>>2]=Ba;Ba=ea(I+ba);za=ea(D+$);g[m>>2]=ea(K+_);g[m+4>>2]=Ba;g[m+8>>2]=za;JOa(p,s,c,l,m,n,o);g[u>>2]=ea(g[n>>2]);g[v>>2]=ea(g[o>>2]);za=ea(g[p>>2]);Ba=ea(za-ea(g[s>>2]));za=ea(g[p+4>>2]);ua=ea(za-ea(g[Oa>>2]));za=ea(g[p+8>>2]);va=ea(za-ea(g[Na>>2]));za=ea(ea(ea(Ba*Ba)+ea(ua*ua))+ea(va*va));g[t>>2]=ea(1.0);Ga=za;break}g[q>>2]=K;g[q+4>>2]=I;g[q+8>>2]=D;g[r>>2]=T;g[r+4>>2]=W;g[r+8>>2]=U;za=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);va=ea(g[a>>2]);ua=ea(va+ea(g[b>>2]));va=ea(g[O>>2]);Ba=ea(va+ea(g[B>>2]));va=ea(g[Q>>2]);Ia=ea(va+ea(g[E>>2]));g[s>>2]=ua;Na=s+4|0;g[Na>>2]=Ba;Oa=s+8|0;g[Oa>>2]=Ia;Ia=ea(g[d>>2]);Ba=ea(g[c>>2]);ua=ea(Ia+Ba);Ia=ea(g[V>>2]);va=ea(g[N>>2]);Aa=ea(Ia+va);Ia=ea(g[Y>>2]);ya=ea(g[P>>2]);xa=ea(Ia+ya);g[l>>2]=ua;g[l+4>>2]=Aa;g[l+8>>2]=xa;xa=ea(Ba+ea(g[e>>2]));Ba=ea(va+ea(g[aa>>2]));va=ea(ya+ea(g[da>>2]));g[m>>2]=xa;g[m+4>>2]=Ba;g[m+8>>2]=va;JOa(p,s,c,l,m,n,o);va=ea(g[n>>2]);g[x>>2]=va;Ba=ea(g[o>>2]);g[y>>2]=Ba;xa=ea(g[p>>2]);ya=ea(xa-ea(g[s>>2]));xa=ea(g[p+4>>2]);Aa=ea(xa-ea(g[Na>>2]));xa=ea(g[p+8>>2]);ua=ea(xa-ea(g[Oa>>2]));xa=ea(ea(ea(ya*ya)+ea(Aa*Aa))+ea(ua*ua));g[w>>2]=ea(1.0);if(!(xa<za)){Ga=za;break}g[t>>2]=ea(1.0);g[u>>2]=va;g[v>>2]=Ba;Ga=xa;break}g[q>>2]=K;Oa=q+4|0;g[Oa>>2]=I;Na=q+8|0;g[Na>>2]=D;g[r>>2]=_;ta=r+4|0;g[ta>>2]=ba;sa=r+8|0;g[sa>>2]=$;xa=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(0.0);if(!Ha){Ba=ea(g[a>>2]);va=ea(Ba+ea(g[b>>2]));Ba=ea(g[O>>2]);za=ea(Ba+ea(g[B>>2]));Ba=ea(g[Q>>2]);ua=ea(Ba+ea(g[E>>2]));g[s>>2]=va;Ha=s+4|0;g[Ha>>2]=za;ra=s+8|0;g[ra>>2]=ua;ua=ea(g[d>>2]);za=ea(g[c>>2]);va=ea(ua+za);ua=ea(g[V>>2]);Ba=ea(g[N>>2]);Aa=ea(ua+Ba);ua=ea(g[Y>>2]);ya=ea(g[P>>2]);Ia=ea(ua+ya);g[l>>2]=va;g[l+4>>2]=Aa;g[l+8>>2]=Ia;Ia=ea(za+ea(g[e>>2]));za=ea(Ba+ea(g[aa>>2]));Ba=ea(ya+ea(g[da>>2]));g[m>>2]=Ia;g[m+4>>2]=za;g[m+8>>2]=Ba;JOa(p,s,c,l,m,n,o);Ba=ea(g[n>>2]);g[x>>2]=Ba;za=ea(g[o>>2]);g[y>>2]=za;Ia=ea(g[p>>2]);ya=ea(Ia-ea(g[s>>2]));Ia=ea(g[p+4>>2]);Aa=ea(Ia-ea(g[Ha>>2]));Ia=ea(g[p+8>>2]);va=ea(Ia-ea(g[ra>>2]));Ia=ea(ea(ea(ya*ya)+ea(Aa*Aa))+ea(va*va));g[w>>2]=ea(1.0);if(!(Ia<xa)){Ga=xa;break}g[t>>2]=ea(1.0);g[u>>2]=Ba;g[v>>2]=za;Ga=Ia;break}g[q>>2]=ea(g[c>>2]);g[Oa>>2]=ea(g[N>>2]);g[Na>>2]=ea(g[P>>2]);g[r>>2]=ea(g[d>>2]);g[ta>>2]=ea(g[V>>2]);g[sa>>2]=ea(g[Y>>2]);Ia=ea(MOa(a,b,q,r,w,x));g[y>>2]=ea(0.0);if(Ia<xa){g[t>>2]=ea(g[w>>2]);g[u>>2]=ea(g[x>>2]);g[v>>2]=ea(0.0);Pa=Ia}else Pa=xa;xa=ea(g[a>>2]);Ia=ea(xa+ea(g[b>>2]));xa=ea(g[O>>2]);za=ea(xa+ea(g[B>>2]));xa=ea(g[Q>>2]);Ba=ea(xa+ea(g[E>>2]));g[s>>2]=Ia;sa=s+4|0;g[sa>>2]=za;ta=s+8|0;g[ta>>2]=Ba;Ba=ea(g[d>>2]);za=ea(g[c>>2]);Ia=ea(Ba+za);Ba=ea(g[V>>2]);xa=ea(g[N>>2]);va=ea(Ba+xa);Ba=ea(g[Y>>2]);Aa=ea(g[P>>2]);ya=ea(Ba+Aa);g[l>>2]=Ia;g[l+4>>2]=va;g[l+8>>2]=ya;ya=ea(za+ea(g[e>>2]));za=ea(xa+ea(g[aa>>2]));xa=ea(Aa+ea(g[da>>2]));g[m>>2]=ya;g[m+4>>2]=za;g[m+8>>2]=xa;JOa(p,s,c,l,m,n,o);xa=ea(g[n>>2]);g[x>>2]=xa;za=ea(g[o>>2]);g[y>>2]=za;ya=ea(g[p>>2]);Aa=ea(ya-ea(g[s>>2]));ya=ea(g[p+4>>2]);va=ea(ya-ea(g[sa>>2]));ya=ea(g[p+8>>2]);Ia=ea(ya-ea(g[ta>>2]));ya=ea(ea(ea(Aa*Aa)+ea(va*va))+ea(Ia*Ia));g[w>>2]=ea(1.0);if(!(ya<Pa)){Ga=Pa;break}g[t>>2]=ea(1.0);g[u>>2]=xa;g[v>>2]=za;Ga=ya;break}else{if(qa){g[q>>2]=K;qa=q+4|0;g[qa>>2]=I;ta=q+8|0;g[ta>>2]=D;g[r>>2]=_;sa=r+4|0;g[sa>>2]=ba;Na=r+8|0;g[Na>>2]=$;ya=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(0.0);za=ea(g[c>>2]);xa=ea(g[d>>2]);Ia=ea(za+xa);za=ea(g[N>>2]);va=ea(g[V>>2]);Aa=ea(za+va);za=ea(g[P>>2]);Ba=ea(g[Y>>2]);ua=ea(za+Ba);g[q>>2]=Ia;g[qa>>2]=Aa;g[ta>>2]=ua;ua=ea(ea(g[e>>2])-xa);xa=ea(ea(g[aa>>2])-va);va=ea(ea(g[da>>2])-Ba);g[r>>2]=ua;g[sa>>2]=xa;g[Na>>2]=va;va=ea(MOa(a,b,q,r,w,y));xa=ea(g[y>>2]);ua=ea(ea(1.0)-xa);g[x>>2]=ua;if(va<ya){g[t>>2]=ea(g[w>>2]);g[u>>2]=ua;g[v>>2]=xa;Qa=va}else Qa=ya;ya=ea(g[a>>2]);va=ea(ya+ea(g[b>>2]));ya=ea(g[O>>2]);xa=ea(ya+ea(g[B>>2]));ya=ea(g[Q>>2]);ua=ea(ya+ea(g[E>>2]));g[s>>2]=va;Na=s+4|0;g[Na>>2]=xa;sa=s+8|0;g[sa>>2]=ua;ua=ea(g[d>>2]);xa=ea(g[c>>2]);va=ea(ua+xa);ua=ea(g[V>>2]);ya=ea(g[N>>2]);Ba=ea(ua+ya);ua=ea(g[Y>>2]);Aa=ea(g[P>>2]);Ia=ea(ua+Aa);g[l>>2]=va;g[l+4>>2]=Ba;g[l+8>>2]=Ia;Ia=ea(xa+ea(g[e>>2]));xa=ea(ya+ea(g[aa>>2]));ya=ea(Aa+ea(g[da>>2]));g[m>>2]=Ia;g[m+4>>2]=xa;g[m+8>>2]=ya;JOa(p,s,c,l,m,n,o);ya=ea(g[n>>2]);g[x>>2]=ya;xa=ea(g[o>>2]);g[y>>2]=xa;Ia=ea(g[p>>2]);Aa=ea(Ia-ea(g[s>>2]));Ia=ea(g[p+4>>2]);Ba=ea(Ia-ea(g[Na>>2]));Ia=ea(g[p+8>>2]);va=ea(Ia-ea(g[sa>>2]));Ia=ea(ea(ea(Aa*Aa)+ea(Ba*Ba))+ea(va*va));g[w>>2]=ea(1.0);if(!(Ia<Qa)){Ga=Qa;break}g[t>>2]=ea(1.0);g[u>>2]=ya;g[v>>2]=xa;Ga=Ia;break}if(!(Ea<ea(0.0))){Ea=ea(I+W);Ia=ea(D+U);g[q>>2]=ea(K+T);g[q+4>>2]=Ea;g[q+8>>2]=Ia;Ia=ea(ba-W);Ea=ea($-U);g[r>>2]=ea(_-T);g[r+4>>2]=Ia;g[r+8>>2]=Ea;Ea=ea(MOa(a,b,q,r,t,v));g[u>>2]=ea(ea(1.0)-ea(g[v>>2]));Ia=ea(g[a>>2]);xa=ea(Ia+ea(g[b>>2]));Ia=ea(g[O>>2]);ya=ea(Ia+ea(g[B>>2]));Ia=ea(g[Q>>2]);va=ea(Ia+ea(g[E>>2]));g[s>>2]=xa;sa=s+4|0;g[sa>>2]=ya;Na=s+8|0;g[Na>>2]=va;va=ea(g[d>>2]);ya=ea(g[c>>2]);xa=ea(va+ya);va=ea(g[V>>2]);Ia=ea(g[N>>2]);Ba=ea(va+Ia);va=ea(g[Y>>2]);Aa=ea(g[P>>2]);ua=ea(va+Aa);g[l>>2]=xa;g[l+4>>2]=Ba;g[l+8>>2]=ua;ua=ea(ya+ea(g[e>>2]));ya=ea(Ia+ea(g[aa>>2]));Ia=ea(Aa+ea(g[da>>2]));g[m>>2]=ua;g[m+4>>2]=ya;g[m+8>>2]=Ia;JOa(p,s,c,l,m,n,o);Ia=ea(g[n>>2]);g[x>>2]=Ia;ya=ea(g[o>>2]);g[y>>2]=ya;ua=ea(g[p>>2]);Aa=ea(ua-ea(g[s>>2]));ua=ea(g[p+4>>2]);Ba=ea(ua-ea(g[sa>>2]));ua=ea(g[p+8>>2]);xa=ea(ua-ea(g[Na>>2]));ua=ea(ea(ea(Aa*Aa)+ea(Ba*Ba))+ea(xa*xa));g[w>>2]=ea(1.0);if(!(ua<Ea)){Ga=Ea;break}g[t>>2]=ea(1.0);g[u>>2]=Ia;g[v>>2]=ya;Ga=ua;break}g[q>>2]=K;Na=q+4|0;g[Na>>2]=I;sa=q+8|0;g[sa>>2]=D;g[r>>2]=T;ta=r+4|0;g[ta>>2]=W;qa=r+8|0;g[qa>>2]=U;ua=ea(MOa(a,b,q,r,t,u));g[v>>2]=ea(0.0);ya=ea(g[c>>2]);Ia=ea(g[d>>2]);Ea=ea(ya+Ia);ya=ea(g[N>>2]);xa=ea(g[V>>2]);Ba=ea(ya+xa);ya=ea(g[P>>2]);Aa=ea(g[Y>>2]);va=ea(ya+Aa);g[q>>2]=Ea;g[Na>>2]=Ba;g[sa>>2]=va;va=ea(ea(g[e>>2])-Ia);Ia=ea(ea(g[aa>>2])-xa);xa=ea(ea(g[da>>2])-Aa);g[r>>2]=va;g[ta>>2]=Ia;g[qa>>2]=xa;xa=ea(MOa(a,b,q,r,w,y));Ia=ea(g[y>>2]);va=ea(ea(1.0)-Ia);g[x>>2]=va;if(xa<ua){g[t>>2]=ea(g[w>>2]);g[u>>2]=va;g[v>>2]=Ia;Ra=xa}else Ra=ua;ua=ea(g[a>>2]);xa=ea(ua+ea(g[b>>2]));ua=ea(g[O>>2]);Ia=ea(ua+ea(g[B>>2]));ua=ea(g[Q>>2]);va=ea(ua+ea(g[E>>2]));g[s>>2]=xa;qa=s+4|0;g[qa>>2]=Ia;ta=s+8|0;g[ta>>2]=va;va=ea(g[d>>2]);Ia=ea(g[c>>2]);xa=ea(va+Ia);va=ea(g[V>>2]);ua=ea(g[N>>2]);Aa=ea(va+ua);va=ea(g[Y>>2]);Ba=ea(g[P>>2]);Ea=ea(va+Ba);g[l>>2]=xa;g[l+4>>2]=Aa;g[l+8>>2]=Ea;Ea=ea(Ia+ea(g[e>>2]));Ia=ea(ua+ea(g[aa>>2]));ua=ea(Ba+ea(g[da>>2]));g[m>>2]=Ea;g[m+4>>2]=Ia;g[m+8>>2]=ua;JOa(p,s,c,l,m,n,o);ua=ea(g[n>>2]);g[x>>2]=ua;Ia=ea(g[o>>2]);g[y>>2]=Ia;Ea=ea(g[p>>2]);Ba=ea(Ea-ea(g[s>>2]));Ea=ea(g[p+4>>2]);Aa=ea(Ea-ea(g[qa>>2]));Ea=ea(g[p+8>>2]);xa=ea(Ea-ea(g[ta>>2]));Ea=ea(ea(ea(Ba*Ba)+ea(Aa*Aa))+ea(xa*xa));g[w>>2]=ea(1.0);if(!(Ea<Ra)){Ga=Ra;break}g[t>>2]=ea(1.0);g[u>>2]=ua;g[v>>2]=Ia;Ga=Ea;break}}while(0);if(f)g[f>>2]=ea(g[t>>2]);if(h)g[h>>2]=ea(g[u>>2]);if(j)g[j>>2]=ea(g[v>>2]);v=Ga<ea(0.0);M=v?ea(0.0):Ga;i=k;return ea(M)}function QOa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,da=Im,fa=0,ga=Im,ha=Im,ia=0,ja=Im,ka=0,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=Im,ua=0,va=Im,wa=0,xa=Im,ya=Im,za=Im,Aa=Im,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=Im,La=0,Ma=0,Na=Im,Oa=Im,Pa=0,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=0,gb=0;l=i;i=i+672|0;m=l+320|0;n=l+288|0;o=l+16|0;p=l;q=l+592|0;r=l+32|0;s=l+80|0;t=l+96|0;u=l+112|0;v=l+128|0;w=l+144|0;x=l+160|0;y=l+176|0;z=l+192|0;A=l+208|0;B=l+224|0;C=l+512|0;D=l+544|0;E=l+576|0;F=l+608|0;G=l+624|0;H=l+640|0;I=l+336|0;J=l+352|0;K=l+368|0;L=l+384|0;M=l+400|0;N=l+416|0;O=l+432|0;P=l+448|0;Q=l+464|0;R=l+48|0;S=l+656|0;U=l+240|0;V=l+496|0;W=l+64|0;X=l+256|0;Y=l+528|0;Z=l+272|0;_=l+560|0;$=l+304|0;aa=l+480|0;ba=ea(g[d>>2]);ca=d+4|0;da=ea(g[ca>>2]);fa=d+8|0;ga=ea(g[fa>>2]);ha=ea(g[b>>2]);ia=b+4|0;ja=ea(g[ia>>2]);ka=b+8|0;la=ea(g[ka>>2]);ma=ea(da-ja);na=ea(ga-la);g[U>>2]=ea(ba-ha);oa=U+4|0;g[oa>>2]=ma;pa=U+8|0;g[pa>>2]=na;g[U+12>>2]=ea(0.0);na=ea(g[f>>2]);qa=f+4|0;ma=ea(g[qa>>2]);ra=f+8|0;sa=ea(g[ra>>2]);ta=ea(g[e>>2]);ua=e+4|0;va=ea(g[ua>>2]);wa=e+8|0;xa=ea(g[wa>>2]);ya=ea(na-ta);za=ea(ma-va);Aa=ea(sa-xa);g[V>>2]=ya;Ba=V+4|0;g[Ba>>2]=za;Ca=V+8|0;g[Ca>>2]=Aa;g[V+12>>2]=ea(0.0);Da=ea(g[h>>2]);Ea=ea(g[h+4>>2]);Fa=ea(g[h+8>>2]);Ga=ea(Da-ta);Ha=ea(Ea-va);Ia=ea(Fa-xa);g[W>>2]=Ga;h=W+4|0;g[h>>2]=Ha;Ja=W+8|0;g[Ja>>2]=Ia;g[W+12>>2]=ea(0.0);Ka=ea(Ea-ma);ma=ea(Fa-sa);g[X>>2]=ea(Da-na);La=X+4|0;g[La>>2]=Ka;Ma=X+8|0;g[Ma>>2]=ma;g[X+12>>2]=ea(0.0);ma=ea(ea(ea(ya*ya)+ea(za*za))+ea(Aa*Aa));Ka=ea(ea(ea(ya*Ga)+ea(za*Ha))+ea(Aa*Ia));na=ea(ea(ea(Ga*Ga)+ea(Ha*Ha))+ea(Ia*Ia));Da=ea(ea(1.0)/ea(ea(ma*na)-ea(Ka*Ka)));sa=ea(ea(za*Ia)-ea(Aa*Ha));Fa=ea(ea(Aa*Ga)-ea(ya*Ia));Ea=ea(ea(ya*Ha)-ea(za*Ga));Na=ea(ea(1.0)/ea(T(ea(ea(Ea*Ea)+ea(ea(sa*sa)+ea(Fa*Fa))))));Oa=ea(sa*Na);sa=ea(Fa*Na);Fa=ea(Ea*Na);Na=ea(ea(ea(la-xa)*Fa)+ea(ea(ea(ha-ta)*Oa)+ea(ea(ja-va)*sa)));ja=ea(Na*Na);ha=ea(ea(ea(ga-xa)*Fa)+ea(ea(ea(ba-ta)*Oa)+ea(ea(da-va)*sa)));va=ea(ha*ha);if(ea(Na*ha)<ea(0.0)?(da=ea(g[U>>2]),ta=ea(g[oa>>2]),ba=ea(g[pa>>2]),xa=ea(-ea(Na*ea(ea(1.0)/ea(ea(ea(Oa*da)+ea(sa*ta))+ea(Fa*ba))))),ga=ea(g[b>>2]),la=ea(g[ia>>2]),Ea=ea(ea(da*xa)+ga),ga=ea(ea(ta*xa)+la),la=ea(ea(ba*xa)+ea(g[ka>>2])),xa=ea(g[e>>2]),ba=ea(g[ua>>2]),ta=ea(Ea-xa),xa=ea(ga-ba),ba=ea(la-ea(g[wa>>2])),da=ea(ea(ea(ta*ya)+ea(xa*za))+ea(ba*Aa)),Aa=ea(ea(ea(ta*Ga)+ea(xa*Ha))+ea(ba*Ia)),Ia=ea(Da*ea(ea(na*da)-ea(Ka*Aa))),ba=ea(Da*ea(ea(ma*Aa)-ea(Ka*da))),ea(Ia+ba)<ea(1.0)&(ba<=ea(1.0)&ba>=ea(0.0))&(Ia<=ea(1.0)&Ia>=ea(0.0))):0){g[k>>2]=Ea;g[k+4>>2]=ga;g[k+8>>2]=la;g[k+12>>2]=ea(0.0);c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];g[a>>2]=ea(0.0);Pa=a+4|0;c[Pa+0>>2]=c[S+0>>2];c[Pa+4>>2]=c[S+4>>2];c[Pa+8>>2]=c[S+8>>2];i=l;return}OOa(_,b,U,e,V,f,X,e,W,e,V,Y,Z);la=ea(g[Y>>2]);ga=ea(g[Y+4>>2]);Ea=ea(g[Y+8>>2]);Ia=ea(g[Z>>2]);ba=ea(g[Z+4>>2]);da=ea(g[Z+8>>2]);Aa=ea(g[_>>2]);Ha=ea(g[_+4>>2]);xa=ea(g[_+8>>2]);Ga=ea(g[U>>2]);ta=ea(g[oa>>2]);za=ea(g[pa>>2]);ya=ea(g[b>>2]);Qa=ea(g[ia>>2]);Ra=ea(g[ka>>2]);Sa=ea(ea(la*Ga)+ya);Ta=ea(ea(la*ta)+Qa);Ua=ea(ea(la*za)+Ra);la=ea(g[V>>2]);Va=ea(g[Ba>>2]);Wa=ea(g[Ca>>2]);Xa=ea(g[e>>2]);Ya=ea(g[ua>>2]);Za=ea(g[wa>>2]);_a=ea(ea(Ia*la)+Xa);la=ea(ea(Ia*Va)+Ya);Va=ea(ea(Ia*Wa)+Za);Wa=ea(ea(ga*Ga)+ya);Ia=ea(ea(ga*ta)+Qa);$a=ea(ea(ga*za)+Ra);ga=ea(g[X>>2]);ab=ea(g[La>>2]);bb=ea(g[Ma>>2]);cb=ea(g[f>>2]);db=ea(g[qa>>2]);eb=ea(ea(ba*ga)+cb);cb=ea(ea(ba*ab)+db);db=ea(ea(ba*bb)+ea(g[ra>>2]));bb=ea(ea(Ea*Ga)+ya);ya=ea(ea(Ea*ta)+Qa);Qa=ea(ea(Ea*za)+Ra);Ra=ea(g[W>>2]);za=ea(g[h>>2]);Ea=ea(ea(da*Ra)+Xa);Xa=ea(ea(da*za)+Ya);Ya=ea(ea(da*ea(g[Ja>>2]))+Za);if(Ha>Aa)fb=(xa>Aa)<<31>>31;else fb=0;if(!(Aa>=Ha))gb=1;else gb=!(xa>Ha);ra=(fb|0)==0;Za=ra?(gb?xa:Ha):Aa;g[n>>2]=Wa;g[n+4>>2]=Ia;g[n+8>>2]=$a;g[n+12>>2]=ea(0.0);g[m>>2]=bb;g[m+4>>2]=ya;g[m+8>>2]=Qa;g[m+12>>2]=ea(0.0);Qa=ea(g[(gb?m:n)>>2]);ya=ea(g[(gb?m:n)+4>>2]);bb=ea(g[(gb?m:n)+8>>2]);g[p>>2]=Sa;g[p+4>>2]=Ta;g[p+8>>2]=Ua;g[p+12>>2]=ea(0.0);g[o>>2]=Qa;g[o+4>>2]=ya;g[o+8>>2]=bb;g[o+12>>2]=ea(0.0);bb=ea(g[(ra?o:p)>>2]);n=(fb|0)==0;ya=ea(g[(n?o:p)+4>>2]);m=(fb|0)==0;Qa=ea(g[(m?o:p)+8>>2]);g[r>>2]=eb;g[r+4>>2]=cb;g[r+8>>2]=db;g[r+12>>2]=ea(0.0);g[q>>2]=Ea;g[q+4>>2]=Xa;g[q+8>>2]=Ya;g[q+12>>2]=ea(0.0);Ya=ea(g[(gb?q:r)>>2]);Xa=ea(g[(gb?q:r)+4>>2]);Ea=ea(g[(gb?q:r)+8>>2]);g[t>>2]=_a;g[t+4>>2]=la;g[t+8>>2]=Va;g[t+12>>2]=ea(0.0);g[s>>2]=Ya;g[s+4>>2]=Xa;g[s+8>>2]=Ea;g[s+12>>2]=ea(0.0);Ea=ea(g[(ra?s:t)>>2]);Xa=ea(g[(n?s:t)+4>>2]);Ya=ea(g[(m?s:t)+8>>2]);Va=ea(g[b>>2]);la=ea(g[ia>>2]);_a=ea(Va-ea(Oa*Na));Va=ea(la-ea(sa*Na));la=ea(ea(g[ka>>2])-ea(Fa*Na));c[$+0>>2]=c[b+0>>2];c[$+4>>2]=c[b+4>>2];c[$+8>>2]=c[b+8>>2];c[$+12>>2]=c[b+12>>2];Na=ea(g[e>>2]);db=ea(g[ua>>2]);cb=ea(g[wa>>2]);eb=ea(_a-Na);Ua=ea(Va-db);Ta=ea(la-cb);Sa=ea(g[V>>2]);$a=ea(g[Ba>>2]);Ia=ea(g[Ca>>2]);Wa=ea(ea(ea(eb*Sa)+ea(Ua*$a))+ea(Ta*Ia));Aa=ea(g[W>>2]);Ha=ea(g[h>>2]);xa=ea(g[Ja>>2]);da=ea(ea(ea(eb*Aa)+ea(Ua*Ha))+ea(Ta*xa));Ta=ea(Da*ea(ea(na*Wa)-ea(Ka*da)));Ua=ea(Da*ea(ea(ma*da)-ea(Ka*Wa)));Ja=ea(Ta+Ua)<ea(1.0)&(Ua<=ea(1.0)&Ua>=ea(0.0))&(Ta<=ea(1.0)&Ta>=ea(0.0));Ta=ea(g[d>>2]);Ua=ea(g[ca>>2]);Wa=ea(Ta-ea(Oa*ha));Oa=ea(Ua-ea(sa*ha));sa=ea(ea(g[fa>>2])-ea(Fa*ha));c[aa+0>>2]=c[d+0>>2];c[aa+4>>2]=c[d+4>>2];c[aa+8>>2]=c[d+8>>2];c[aa+12>>2]=c[d+12>>2];ha=ea(Wa-Na);Na=ea(Oa-db);db=ea(sa-cb);cb=ea(ea(ea(ha*Sa)+ea(Na*$a))+ea(db*Ia));Ia=ea(ea(ea(ha*Aa)+ea(Na*Ha))+ea(db*xa));xa=ea(Da*ea(ea(na*cb)-ea(Ka*Ia)));na=ea(Da*ea(ea(ma*Ia)-ea(Ka*cb)));fa=ea(xa+na)<ea(1.0)&(na<=ea(1.0)&na>=ea(0.0))&(xa<=ea(1.0)&xa>=ea(0.0));ca=Za>ja;c[v+0>>2]=c[$+0>>2];c[v+4>>2]=c[$+4>>2];c[v+8>>2]=c[$+8>>2];c[v+12>>2]=c[$+12>>2];g[u>>2]=bb;g[u+4>>2]=ya;g[u+8>>2]=Qa;g[u+12>>2]=ea(0.0);h=ca?v:u;xa=ea(g[h>>2]);na=ea(g[h+4>>2]);cb=ea(g[h+8>>2]);g[x>>2]=_a;g[x+4>>2]=Va;g[x+8>>2]=la;g[x+12>>2]=ea(0.0);g[w>>2]=Ea;g[w+4>>2]=Xa;g[w+8>>2]=Ya;g[w+12>>2]=ea(0.0);h=ca?x:w;Ka=ea(g[h>>2]);Ia=ea(g[h+4>>2]);ma=ea(g[h+8>>2]);h=Za>va;c[z+0>>2]=c[d+0>>2];c[z+4>>2]=c[d+4>>2];c[z+8>>2]=c[d+8>>2];c[z+12>>2]=c[d+12>>2];g[y>>2]=bb;g[y+4>>2]=ya;g[y+8>>2]=Qa;g[y+12>>2]=ea(0.0);d=h?z:y;Za=ea(g[d>>2]);Da=ea(g[d+4>>2]);db=ea(g[d+8>>2]);g[B>>2]=Wa;g[B+4>>2]=Oa;g[B+8>>2]=sa;g[B+12>>2]=ea(0.0);g[A>>2]=Ea;g[A+4>>2]=Xa;g[A+8>>2]=Ya;g[A+12>>2]=ea(0.0);d=h?B:A;Ha=ea(g[d>>2]);Na=ea(g[d+4>>2]);Aa=ea(g[d+8>>2]);d=va>ja;c[D+0>>2]=c[$+0>>2];c[D+4>>2]=c[$+4>>2];c[D+8>>2]=c[$+8>>2];c[D+12>>2]=c[$+12>>2];c[C+0>>2]=c[aa+0>>2];c[C+4>>2]=c[aa+4>>2];c[C+8>>2]=c[aa+8>>2];c[C+12>>2]=c[aa+12>>2];aa=d?D:C;ja=ea(g[aa>>2]);va=ea(g[aa+4>>2]);ha=ea(g[aa+8>>2]);g[F>>2]=_a;g[F+4>>2]=Va;g[F+8>>2]=la;g[F+12>>2]=ea(0.0);g[E>>2]=Wa;g[E+4>>2]=Oa;g[E+8>>2]=sa;g[E+12>>2]=ea(0.0);aa=d?F:E;sa=ea(g[aa>>2]);Oa=ea(g[aa+4>>2]);Wa=ea(g[aa+8>>2]);aa=fa^1;E=Ja^1|aa;F=Ja^1|aa;d=Ja^1|aa;g[H>>2]=Za;g[H+4>>2]=Da;g[H+8>>2]=db;g[H+12>>2]=ea(0.0);g[G>>2]=bb;g[G+4>>2]=ya;g[G+8>>2]=Qa;g[G+12>>2]=ea(0.0);aa=fa?H:G;Qa=ea(g[aa>>2]);ya=ea(g[aa+4>>2]);bb=ea(g[aa+8>>2]);g[J>>2]=xa;g[J+4>>2]=na;g[J+8>>2]=cb;g[J+12>>2]=ea(0.0);g[I>>2]=Qa;g[I+4>>2]=ya;g[I+8>>2]=bb;g[I+12>>2]=ea(0.0);aa=Ja?J:I;bb=ea(g[aa>>2]);ya=ea(g[aa+4>>2]);Qa=ea(g[aa+8>>2]);g[L>>2]=ja;g[L+4>>2]=va;g[L+8>>2]=ha;g[L+12>>2]=ea(0.0);g[K>>2]=bb;g[K+4>>2]=ya;g[K+8>>2]=Qa;g[K+12>>2]=ea(0.0);Qa=ea(g[(F?K:L)>>2]);ya=ea(g[(d?K:L)+4>>2]);bb=ea(g[(E?K:L)+8>>2]);g[N>>2]=Ha;g[N+4>>2]=Na;g[N+8>>2]=Aa;g[N+12>>2]=ea(0.0);g[M>>2]=Ea;g[M+4>>2]=Xa;g[M+8>>2]=Ya;g[M+12>>2]=ea(0.0);L=fa?N:M;Ya=ea(g[L>>2]);Xa=ea(g[L+4>>2]);Ea=ea(g[L+8>>2]);g[P>>2]=Ka;g[P+4>>2]=Ia;g[P+8>>2]=ma;g[P+12>>2]=ea(0.0);g[O>>2]=Ya;g[O+4>>2]=Xa;g[O+8>>2]=Ea;g[O+12>>2]=ea(0.0);L=Ja?P:O;Ea=ea(g[L>>2]);Xa=ea(g[L+4>>2]);Ya=ea(g[L+8>>2]);g[R>>2]=sa;g[R+4>>2]=Oa;g[R+8>>2]=Wa;g[R+12>>2]=ea(0.0);g[Q>>2]=Ea;g[Q+4>>2]=Xa;g[Q+8>>2]=Ya;g[Q+12>>2]=ea(0.0);Ya=ea(g[(F?Q:R)>>2]);Xa=ea(g[(d?Q:R)+4>>2]);Ea=ea(g[(E?Q:R)+8>>2]);Wa=ea(Ya-Qa);Oa=ea(Xa-ya);sa=ea(Ea-bb);g[j>>2]=Qa;g[j+4>>2]=ya;g[j+8>>2]=bb;g[j+12>>2]=ea(0.0);g[k>>2]=Ya;g[k+4>>2]=Xa;g[k+8>>2]=Ea;g[k+12>>2]=ea(0.0);g[a>>2]=ea(ea(ea(Wa*Wa)+ea(Oa*Oa))+ea(sa*sa));i=l;return}function ROa(a,c,e,f,h,j,k,l){a=a|0;c=c|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=Im,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=Im,ya=0,za=Im,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=Im,Ia=0,Ja=Im,Ka=0,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=0;m=i;i=i+672|0;n=m+368|0;o=m+480|0;p=m+144|0;q=m+636|0;r=m+360|0;s=m+316|0;t=m+320|0;u=m+576|0;v=m+600|0;w=m+624|0;x=m+648|0;y=m+660|0;z=m+464|0;A=m+468|0;B=m+160|0;C=m;D=m+332|0;E=m+344|0;F=m+588|0;G=m+304|0;H=m+356|0;I=m+612|0;if(!(b[l>>1]&16)){l=a+48|0;J=a+36|0;K=c+48|0;L=c+36|0;if(NPa(l,J,a,K,L,c,1)|0){g[k>>2]=ea(0.0);M=ea(-ea(g[e>>2]));N=ea(-ea(g[e+4>>2]));O=ea(-ea(g[e+8>>2]));g[j>>2]=M;g[j+4>>2]=N;g[j+8>>2]=O;g[h>>2]=ea(g[J>>2]);g[h+4>>2]=ea(g[a+40>>2]);g[h+8>>2]=ea(g[a+44>>2]);P=1;i=m;return P|0}else{Q=l;R=L;S=K;U=J}}else{Q=a+48|0;R=c+36|0;S=c+48|0;U=a+36|0}TKa(n,U,Q,a,a+12|0,a+24|0);TKa(o,R,S,c,c+12|0,c+24|0);O=ea(g[Q>>2]);N=ea(-O);M=ea(g[a+52>>2]);V=ea(-M);W=ea(g[a+56>>2]);X=ea(-W);g[p>>2]=N;g[p+4>>2]=V;g[p+8>>2]=X;g[q>>2]=O;g[q+4>>2]=M;g[q+8>>2]=W;W=ea(g[a>>2]);Q=a+4|0;M=ea(g[Q>>2]);R=a+8|0;O=ea(g[R>>2]);U=a+12|0;X=ea(g[U>>2]);J=a+16|0;V=ea(g[J>>2]);K=a+20|0;N=ea(g[K>>2]);L=a+24|0;Y=ea(g[L>>2]);l=a+28|0;Z=ea(g[l>>2]);_=a+32|0;$=ea(g[_>>2]);aa=ea(g[a+36>>2]);ba=ea(g[a+40>>2]);ca=ea(-aa);aa=ea(-ba);ba=ea(-ea(g[a+44>>2]));da=ea(ea(ea(W*ca)+ea(M*aa))+ea(O*ba));fa=ea(ea(ea(X*ca)+ea(V*aa))+ea(N*ba));ga=ea(ea(ea(Y*ca)+ea(Z*aa))+ea($*ba));ba=ea(g[e>>2]);aa=ea(W*ba);ca=ea(X*ba);ha=ea(Y*ba);ia=e+4|0;ba=ea(g[ia>>2]);ja=ea(aa+ea(M*ba));aa=ea(ca+ea(V*ba));ca=ea(ha+ea(Z*ba));ka=e+8|0;ba=ea(g[ka>>2]);la=t+4|0;ma=t+8|0;ha=ea(-ea(ja+ea(O*ba)));ja=ea(-ea(aa+ea(N*ba)));aa=ea(-ea(ca+ea($*ba)));na=u+4|0;oa=u+8|0;pa=j+4|0;qa=j+8|0;ra=h+4|0;sa=h+8|0;ba=f;ta=-1;ua=0;while(1){va=o+(ua*12|0)|0;f=ea(g[va>>2]);ca=ea(W*f);wa=ea(X*f);xa=ea(Y*f);ya=o+(ua*12|0)+4|0;f=ea(g[ya>>2]);za=ea(ca+ea(M*f));ca=ea(wa+ea(V*f));wa=ea(xa+ea(Z*f));Aa=o+(ua*12|0)+8|0;f=ea(g[Aa>>2]);xa=ea(fa+ea(ca+ea(N*f)));ca=ea(ga+ea(wa+ea($*f)));g[t>>2]=ea(da+ea(za+ea(O*f)));g[la>>2]=xa;g[ma>>2]=ca;g[u>>2]=ha;g[na>>2]=ja;g[oa>>2]=aa;Ba=QPa(p,q,t,u,r,s)|0;if((Ba|0)!=-1?(ca=ea(g[r>>2]),!(ca<ea(0.0)|!(ca<=ba))):0){xa=ea(g[540592+(Ba*12|0)>>2]);f=ea(xa*ea(g[a>>2]));za=ea(xa*ea(g[Q>>2]));wa=ea(xa*ea(g[R>>2]));xa=ea(g[540596+(Ba*12|0)>>2]);Ca=ea(xa*ea(g[U>>2]));Da=ea(xa*ea(g[J>>2]));Ea=ea(f+Ca);Ca=ea(za+Da);Da=ea(wa+ea(xa*ea(g[K>>2])));xa=ea(g[540600+(Ba*12|0)>>2]);wa=ea(xa*ea(g[L>>2]));za=ea(xa*ea(g[l>>2]));f=ea(Ca+za);za=ea(Da+ea(xa*ea(g[_>>2])));g[j>>2]=ea(Ea+wa);g[pa>>2]=f;g[qa>>2]=za;g[h>>2]=ea(g[va>>2]);g[ra>>2]=ea(g[ya>>2]);g[sa>>2]=ea(g[Aa>>2]);Fa=ca;Ga=0}else{Fa=ba;Ga=ta}ua=ua+1|0;if((ua|0)==8)break;else{ba=Fa;ta=Ga}}ba=ea(g[S>>2]);aa=ea(-ba);ja=ea(g[c+52>>2]);ha=ea(-ja);O=ea(g[c+56>>2]);da=ea(-O);g[v>>2]=aa;g[v+4>>2]=ha;g[v+8>>2]=da;g[w>>2]=ba;g[w+4>>2]=ja;g[w+8>>2]=O;O=ea(g[c>>2]);S=c+4|0;ja=ea(g[S>>2]);ta=c+8|0;ba=ea(g[ta>>2]);ua=c+12|0;da=ea(g[ua>>2]);r=c+16|0;ha=ea(g[r>>2]);s=c+20|0;aa=ea(g[s>>2]);u=c+24|0;$=ea(g[u>>2]);t=c+28|0;ga=ea(g[t>>2]);q=c+32|0;N=ea(g[q>>2]);fa=ea(g[c+36>>2]);Z=ea(g[c+40>>2]);V=ea(-fa);fa=ea(-Z);Z=ea(-ea(g[c+44>>2]));M=ea(ea(ea(O*V)+ea(ja*fa))+ea(ba*Z));Y=ea(ea(ea(da*V)+ea(ha*fa))+ea(aa*Z));X=ea(ea(ea($*V)+ea(ga*fa))+ea(N*Z));Z=ea(g[e>>2]);fa=ea(O*Z);V=ea(da*Z);W=ea($*Z);Z=ea(g[ia>>2]);ca=ea(fa+ea(ja*Z));fa=ea(V+ea(ha*Z));V=ea(W+ea(ga*Z));Z=ea(g[ka>>2]);W=ea(fa+ea(aa*Z));fa=ea(V+ea(N*Z));g[x>>2]=ea(ca+ea(ba*Z));g[x+4>>2]=W;g[x+8>>2]=fa;p=A+4|0;oa=A+8|0;fa=Fa;na=Ga;Ga=0;while(1){ma=n+(Ga*12|0)|0;Fa=ea(g[ma>>2]);W=ea(O*Fa);Z=ea(da*Fa);ca=ea($*Fa);la=n+(Ga*12|0)+4|0;Fa=ea(g[la>>2]);V=ea(W+ea(ja*Fa));W=ea(Z+ea(ha*Fa));Z=ea(ca+ea(ga*Fa));Aa=n+(Ga*12|0)+8|0;Fa=ea(g[Aa>>2]);ca=ea(Y+ea(W+ea(aa*Fa)));W=ea(X+ea(Z+ea(N*Fa)));g[A>>2]=ea(M+ea(V+ea(ba*Fa)));g[p>>2]=ca;g[oa>>2]=W;ya=QPa(v,w,A,x,y,z)|0;if((ya|0)!=-1?(W=ea(g[y>>2]),!(W<ea(0.0)|!(W<=fa))):0){ca=ea(-ea(g[540592+(ya*12|0)>>2]));Fa=ea(-ea(g[540596+(ya*12|0)>>2]));V=ea(-ea(g[540600+(ya*12|0)>>2]));Z=ea(ea(g[c>>2])*ca);za=ea(ea(g[S>>2])*ca);f=ea(ea(g[ta>>2])*ca);ca=ea(ea(g[ua>>2])*Fa);wa=ea(ea(g[r>>2])*Fa);Ea=ea(Z+ca);ca=ea(za+wa);wa=ea(f+ea(ea(g[s>>2])*Fa));Fa=ea(ea(g[u>>2])*V);f=ea(ea(g[t>>2])*V);za=ea(ca+f);f=ea(wa+ea(ea(g[q>>2])*V));g[j>>2]=ea(Ea+Fa);g[pa>>2]=za;g[qa>>2]=f;f=ea(g[e>>2]);za=ea(g[ia>>2]);Fa=ea(W*f);f=ea(W*za);za=ea(W*ea(g[ka>>2]));Ea=ea(Fa+ea(g[ma>>2]));Fa=ea(f+ea(g[la>>2]));f=ea(za+ea(g[Aa>>2]));g[h>>2]=Ea;g[ra>>2]=Fa;g[sa>>2]=f;Ha=W;Ia=1}else{Ha=fa;Ia=na}Ga=Ga+1|0;if((Ga|0)==8)break;else{fa=Ha;na=Ia}}na=SKa()|0;Ga=SKa()|0;fa=ea(g[a>>2]);ba=ea(g[Q>>2]);M=ea(g[R>>2]);N=ea(g[U>>2]);X=ea(g[J>>2]);aa=ea(g[K>>2]);Y=ea(g[L>>2]);ga=ea(g[l>>2]);ha=ea(g[_>>2]);_=0;do{ja=ea(g[540896+(_*12|0)>>2]);$=ea(ja*fa);da=ea(ja*ba);O=ea(ja*M);ja=ea(g[540900+(_*12|0)>>2]);W=ea($+ea(ja*N));$=ea(da+ea(ja*X));da=ea(O+ea(ja*aa));ja=ea(g[540904+(_*12|0)>>2]);O=ea($+ea(ja*ga));$=ea(da+ea(ja*ha));g[B+(_*12|0)>>2]=ea(W+ea(ja*Y));g[B+(_*12|0)+4>>2]=O;g[B+(_*12|0)+8>>2]=$;_=_+1|0}while((_|0)!=12);Y=ea(g[c>>2]);ha=ea(g[S>>2]);ga=ea(g[ta>>2]);aa=ea(g[ua>>2]);X=ea(g[r>>2]);N=ea(g[s>>2]);M=ea(g[u>>2]);ba=ea(g[t>>2]);fa=ea(g[q>>2]);q=0;do{$=ea(g[540896+(q*12|0)>>2]);O=ea($*Y);ja=ea($*ha);W=ea($*ga);$=ea(g[540900+(q*12|0)>>2]);da=ea(O+ea($*aa));O=ea(ja+ea($*X));ja=ea(W+ea($*N));$=ea(g[540904+(q*12|0)>>2]);W=ea(O+ea($*ba));O=ea(ja+ea($*fa));g[C+(q*12|0)>>2]=ea(da+ea($*M));g[C+(q*12|0)+4>>2]=W;g[C+(q*12|0)+8>>2]=O;q=q+1|0}while((q|0)!=12);q=D+4|0;t=D+8|0;u=E+4|0;s=E+8|0;r=F+4|0;ua=F+8|0;ta=G+4|0;S=G+8|0;c=I+4|0;_=I+8|0;M=Ha;l=Ia;Ia=0;while(1){Ha=ea(g[B+(Ia*12|0)>>2]);fa=ea(g[e>>2]);ba=ea(Ha*fa);N=ea(g[B+(Ia*12|0)+4>>2]);X=ea(g[ia>>2]);aa=ea(ba+ea(N*X));ba=ea(g[B+(Ia*12|0)+8>>2]);ga=ea(g[ka>>2]);a:do if(!(ea(aa+ea(ba*ga))>=ea(0.0))){Ja=M;Ka=l}else{L=Ia<<1;K=d[na+L>>0]|0;ha=ea(g[n+(K*12|0)>>2]);g[D>>2]=ha;Y=ea(g[n+(K*12|0)+4>>2]);g[q>>2]=Y;O=ea(g[n+(K*12|0)+8>>2]);g[t>>2]=O;K=d[na+(L|1)>>0]|0;W=ea(g[n+(K*12|0)>>2]);g[E>>2]=W;$=ea(g[n+(K*12|0)+4>>2]);g[u>>2]=$;da=ea(g[n+(K*12|0)+8>>2]);g[s>>2]=da;ja=ea(W-ha);f=ea($-Y);Fa=ea(da-O);Ea=ea(T(ea(ea(ea(ja*ja)+ea(f*f))+ea(Fa*Fa))));if(Ea>ea(0.0)){za=ea(ea(.00999999977)/Ea);Ea=ea(ja*za);ja=ea(f*za);f=ea(Fa*za);g[D>>2]=ea(ha-Ea);g[q>>2]=ea(Y-ja);g[t>>2]=ea(O-f);g[E>>2]=ea(Ea+W);g[u>>2]=ea(ja+$);g[s>>2]=ea(f+da);La=fa;Ma=X;Na=ga;Oa=M;Pa=l;Qa=0}else{La=fa;Ma=X;Na=ga;Oa=M;Pa=l;Qa=0}while(1){da=ea(g[C+(Qa*12|0)>>2]);f=ea(da*La);$=ea(g[C+(Qa*12|0)+4>>2]);ja=ea(f+ea($*Ma));f=ea(g[C+(Qa*12|0)+8>>2]);if(!(ea(ja+ea(f*Na))>=ea(0.0))?!(ea(ea(ea(da*Ha)+ea($*N))+ea(f*ba))>=ea(0.0)):0){K=Qa<<1;L=d[Ga+K>>0]|0;f=ea(g[o+(L*12|0)>>2]);g[F>>2]=f;$=ea(g[o+(L*12|0)+4>>2]);g[r>>2]=$;da=ea(g[o+(L*12|0)+8>>2]);g[ua>>2]=da;L=d[Ga+(K|1)>>0]|0;ja=ea(g[o+(L*12|0)>>2]);g[G>>2]=ja;W=ea(g[o+(L*12|0)+4>>2]);g[ta>>2]=W;Ea=ea(g[o+(L*12|0)+8>>2]);g[S>>2]=Ea;O=ea(ja-f);Y=ea(W-$);ha=ea(Ea-da);za=ea(T(ea(ea(ea(O*O)+ea(Y*Y))+ea(ha*ha))));if(za>ea(0.0)){Fa=ea(ea(.00999999977)/za);za=ea(O*Fa);O=ea(Y*Fa);Y=ea(ha*Fa);g[F>>2]=ea(f-za);g[r>>2]=ea($-O);g[ua>>2]=ea(da-Y);g[G>>2]=ea(za+ja);g[ta>>2]=ea(O+W);g[S>>2]=ea(Y+Ea)}if(OPa(D,E,e,F,G,H,I)|0?(Ea=ea(g[H>>2]),Ea<=Oa):0){Y=ea(g[e>>2]);W=ea(g[ia>>2]);O=ea(Ea*Y);Y=ea(Ea*W);W=ea(Ea*ea(g[ka>>2]));ja=ea(O+ea(g[I>>2]));O=ea(Y+ea(g[c>>2]));Y=ea(W+ea(g[_>>2]));g[h>>2]=ja;g[ra>>2]=O;g[sa>>2]=Y;Y=ea(g[D>>2]);O=ea(Y-ea(g[E>>2]));Y=ea(g[q>>2]);ja=ea(Y-ea(g[u>>2]));Y=ea(g[t>>2]);W=ea(Y-ea(g[s>>2]));Y=ea(g[F>>2]);za=ea(Y-ea(g[G>>2]));Y=ea(g[r>>2]);da=ea(Y-ea(g[ta>>2]));Y=ea(g[ua>>2]);$=ea(Y-ea(g[S>>2]));Y=ea(ea(ja*$)-ea(W*da));f=ea(ea(W*za)-ea(O*$));$=ea(ea(O*da)-ea(ja*za));g[j>>2]=Y;g[pa>>2]=f;g[qa>>2]=$;za=ea(T(ea(ea($*$)+ea(ea(Y*Y)+ea(f*f)))));if(za>ea(0.0)){ja=ea(ea(1.0)/za);za=ea(Y*ja);g[j>>2]=za;da=ea(f*ja);g[pa>>2]=da;O=ea($*ja);g[qa>>2]=O;Ra=za;Sa=da;Ta=O}else{Ra=Y;Sa=f;Ta=$}$=ea(Ra*ea(g[e>>2]));f=ea($+ea(Sa*ea(g[ia>>2])));if(ea(f+ea(Ta*ea(g[ka>>2])))>ea(0.0)){f=ea(-Sa);$=ea(-Ta);g[j>>2]=ea(-Ra);g[pa>>2]=f;g[qa>>2]=$;Ua=Ea;Va=2}else{Ua=Ea;Va=2}}else{Ua=Oa;Va=Pa}}else{Ua=Oa;Va=Pa}L=Qa+1|0;if((L|0)==12){Ja=Ua;Ka=Va;break a}Ea=ea(g[e>>2]);$=ea(g[ia>>2]);La=Ea;Ma=$;Na=ea(g[ka>>2]);Oa=Ua;Pa=Va;Qa=L}}while(0);Ia=Ia+1|0;if((Ia|0)==12)break;else{M=Ja;l=Ka}}if((Ka|0)==-1){P=0;i=m;return P|0}g[k>>2]=Ja;P=1;i=m;return P|0}function SOa(a,c,e,f,h,j,k,l){a=a|0;c=ea(c);e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=0,ua=Im,va=0;m=i;i=i+416|0;n=m+64|0;o=m+112|0;p=m+248|0;q=m+288|0;r=m+220|0;s=m+236|0;t=m+276|0;u=m+296|0;v=m+356|0;w=m+4|0;x=m+208|0;y=m+80|0;z=m;A=m+84|0;B=m+224|0;C=m+96|0;if(!(b[l>>1]&16)){g[n>>2]=ea(g[e>>2]);l=e+4|0;g[n+4>>2]=ea(g[l>>2]);D=e+8|0;g[n+8>>2]=ea(g[D>>2]);g[n+12>>2]=c;if(qMa(n,a)|0){g[j>>2]=ea(0.0);E=ea(-ea(g[f>>2]));F=ea(-ea(g[f+4>>2]));G=ea(-ea(g[f+8>>2]));g[k>>2]=E;g[k+4>>2]=F;g[k+8>>2]=G;H=1;i=m;return H|0}else{I=l;J=D;K=e}}else{I=e+4|0;J=e+8|0;K=e}TKa(o,a+36|0,a+48|0,a,a+12|0,a+24|0);D=p+4|0;l=p+8|0;n=p+12|0;L=p+16|0;M=p+20|0;N=p+24|0;O=f+4|0;P=f+8|0;Q=s+4|0;R=s+8|0;S=p+12|0;U=k+4|0;V=k+8|0;W=q+4|0;G=h;X=0;Y=SKa()|0;Z=0;while(1){_=d[Y>>0]|0;$=d[Y+1>>0]|0;Y=Y+2|0;g[p>>2]=ea(g[o+(_*12|0)>>2]);g[D>>2]=ea(g[o+(_*12|0)+4>>2]);g[l>>2]=ea(g[o+(_*12|0)+8>>2]);g[n>>2]=ea(g[o+($*12|0)>>2]);g[L>>2]=ea(g[o+($*12|0)+4>>2]);g[M>>2]=ea(g[o+($*12|0)+8>>2]);g[N>>2]=c;$=TPa(e,f,p,q)|0;if($){h=ea(g[q>>2]);if(($|0)==1)aa=h;else{F=ea(g[W>>2]);aa=h<F?h:F}g[r>>2]=aa;if(!(!(aa>=ea(0.0))|!(aa<=G))){F=ea(g[f>>2]);h=ea(g[O>>2]);E=ea(aa*F);F=ea(aa*h);h=ea(aa*ea(g[P>>2]));ba=ea(E+ea(g[K>>2]));E=ea(F+ea(g[I>>2]));F=ea(h+ea(g[J>>2]));g[s>>2]=ba;g[Q>>2]=E;g[R>>2]=F;ea(IOa(p,S,s,r));F=ea(g[r>>2]);E=ea(g[n>>2]);ba=ea(g[p>>2]);h=ea(E-ba);E=ea(g[L>>2]);ca=ea(g[D>>2]);da=ea(E-ca);E=ea(g[M>>2]);fa=ea(g[l>>2]);ga=ea(ba+ea(F*h));h=ea(ca+ea(F*da));da=ea(fa+ea(F*ea(E-fa)));fa=ea(ga-ea(g[s>>2]));ga=ea(h-ea(g[Q>>2]));h=ea(da-ea(g[R>>2]));g[k>>2]=fa;g[U>>2]=ga;g[V>>2]=h;da=ea(T(ea(ea(h*h)+ea(ea(fa*fa)+ea(ga*ga)))));if(da>ea(0.0)){E=ea(ea(1.0)/da);g[k>>2]=ea(fa*E);g[U>>2]=ea(ga*E);g[V>>2]=ea(h*E);ha=aa;ia=1}else{ha=aa;ia=1}}else{ha=G;ia=X}}else{ha=G;ia=X}Z=Z+1|0;if((Z|0)==12)break;else{G=ha;X=ia}}G=ea(g[a>>2]);X=a+4|0;aa=ea(g[X>>2]);Z=a+8|0;E=ea(g[Z>>2]);R=a+12|0;h=ea(g[R>>2]);Q=a+16|0;ga=ea(g[Q>>2]);s=a+20|0;fa=ea(g[s>>2]);l=a+24|0;da=ea(g[l>>2]);M=a+28|0;F=ea(g[M>>2]);D=a+32|0;ca=ea(g[D>>2]);L=a+36|0;ba=ea(g[L>>2]);p=a+40|0;ja=ea(g[p>>2]);n=a+44|0;ka=ea(g[n>>2]);la=ea(ea(g[K>>2])-ba);ma=ea(ea(g[I>>2])-ja);na=ea(ea(g[J>>2])-ka);oa=ea(ea(ea(h*la)+ea(ga*ma))+ea(fa*na));pa=ea(ea(ea(da*la)+ea(F*ma))+ea(ca*na));g[t>>2]=ea(ea(ea(G*la)+ea(aa*ma))+ea(E*na));g[t+4>>2]=oa;g[t+8>>2]=pa;g[u>>2]=G;g[u+4>>2]=aa;g[u+8>>2]=E;g[u+12>>2]=h;g[u+16>>2]=ga;g[u+20>>2]=fa;g[u+24>>2]=da;g[u+28>>2]=F;g[u+32>>2]=ca;g[u+36>>2]=ba;g[u+40>>2]=ja;g[u+44>>2]=ka;pa=ea(g[a+48>>2]);J=u+52|0;oa=ea(g[a+52>>2]);g[J>>2]=oa;I=u+56|0;na=ea(g[a+56>>2]);g[I>>2]=na;g[v>>2]=G;g[v+4>>2]=aa;g[v+8>>2]=E;g[v+12>>2]=h;g[v+16>>2]=ga;g[v+20>>2]=fa;g[v+24>>2]=da;g[v+28>>2]=F;g[v+32>>2]=ca;g[v+36>>2]=ba;g[v+40>>2]=ja;g[v+44>>2]=ka;g[v+48>>2]=pa;K=v+52|0;r=v+56|0;g[r>>2]=na;ka=ea(g[a>>2]);g[w>>2]=ka;ja=ea(g[X>>2]);g[w+4>>2]=ja;ba=ea(g[Z>>2]);g[w+8>>2]=ba;ca=ea(g[R>>2]);g[w+12>>2]=ca;F=ea(g[Q>>2]);g[w+16>>2]=F;da=ea(g[s>>2]);g[w+20>>2]=da;fa=ea(g[l>>2]);g[w+24>>2]=fa;ga=ea(g[M>>2]);g[w+28>>2]=ga;h=ea(g[D>>2]);g[w+32>>2]=h;g[w+36>>2]=ea(g[L>>2]);g[w+40>>2]=ea(g[p>>2]);g[w+44>>2]=ea(g[n>>2]);g[w+48>>2]=pa;n=w+52|0;g[n>>2]=oa;p=w+56|0;L=u+48|0;E=ea(pa+c);g[L>>2]=E;u=v+48|0;g[K>>2]=ea(oa+c);v=w+48|0;g[p>>2]=ea(na+c);c=ea(g[f>>2]);na=ea(ka*c);ka=ea(g[O>>2]);oa=ea(na+ea(ja*ka));ja=ea(g[P>>2]);na=ea(ea(ea(c*ca)+ea(ka*F))+ea(ja*da));da=ea(ea(ea(c*fa)+ea(ka*ga))+ea(ja*h));g[x>>2]=ea(oa+ea(ba*ja));g[x+4>>2]=na;g[x+8>>2]=da;da=ea(-E);E=ea(-ea(g[J>>2]));na=ea(-ea(g[I>>2]));g[A>>2]=da;g[A+4>>2]=E;g[A+8>>2]=na;I=QPa(A,L,t,x,y,z)|0;if((I|0)!=-1?(na=ea(g[y>>2]),!(!(na>=ea(0.0))|!(na<=ha))):0){E=ea(g[540592+(I*12|0)>>2]);da=ea(E*ea(g[a>>2]));ja=ea(E*ea(g[X>>2]));ba=ea(E*ea(g[Z>>2]));E=ea(g[540596+(I*12|0)>>2]);oa=ea(E*ea(g[R>>2]));h=ea(E*ea(g[Q>>2]));ga=ea(da+oa);oa=ea(ja+h);h=ea(ba+ea(E*ea(g[s>>2])));E=ea(g[540600+(I*12|0)>>2]);ba=ea(E*ea(g[l>>2]));ja=ea(E*ea(g[M>>2]));da=ea(oa+ja);ja=ea(h+ea(E*ea(g[D>>2])));g[k>>2]=ea(ga+ba);g[U>>2]=da;g[V>>2]=ja;qa=na;ra=1}else{qa=ha;ra=ia}ha=ea(-ea(g[u>>2]));na=ea(-ea(g[K>>2]));ja=ea(-ea(g[r>>2]));g[B>>2]=ha;g[B+4>>2]=na;g[B+8>>2]=ja;r=QPa(B,u,t,x,y,z)|0;if((r|0)!=-1?(ja=ea(g[y>>2]),!(!(ja>=ea(0.0))|!(ja<=qa))):0){na=ea(g[540592+(r*12|0)>>2]);ha=ea(na*ea(g[a>>2]));da=ea(na*ea(g[X>>2]));ba=ea(na*ea(g[Z>>2]));na=ea(g[540596+(r*12|0)>>2]);ga=ea(na*ea(g[R>>2]));E=ea(na*ea(g[Q>>2]));h=ea(ha+ga);ga=ea(da+E);E=ea(ba+ea(na*ea(g[s>>2])));na=ea(g[540600+(r*12|0)>>2]);ba=ea(na*ea(g[l>>2]));da=ea(na*ea(g[M>>2]));ha=ea(ga+da);da=ea(E+ea(na*ea(g[D>>2])));g[k>>2]=ea(h+ba);g[U>>2]=ha;g[V>>2]=da;sa=ja;ta=1}else{sa=qa;ta=ra}qa=ea(-ea(g[v>>2]));ja=ea(-ea(g[n>>2]));da=ea(-ea(g[p>>2]));g[C>>2]=qa;g[C+4>>2]=ja;g[C+8>>2]=da;p=QPa(C,v,t,x,y,z)|0;if((p|0)!=-1?(da=ea(g[y>>2]),!(!(da>=ea(0.0))|!(da<=sa))):0){ja=ea(g[540592+(p*12|0)>>2]);qa=ea(ja*ea(g[a>>2]));ha=ea(ja*ea(g[X>>2]));ba=ea(ja*ea(g[Z>>2]));ja=ea(g[540596+(p*12|0)>>2]);h=ea(ja*ea(g[R>>2]));na=ea(ja*ea(g[Q>>2]));E=ea(qa+h);h=ea(ha+na);na=ea(ba+ea(ja*ea(g[s>>2])));ja=ea(g[540600+(p*12|0)>>2]);ba=ea(ja*ea(g[l>>2]));ha=ea(ja*ea(g[M>>2]));qa=ea(h+ha);ha=ea(na+ea(ja*ea(g[D>>2])));g[k>>2]=ea(E+ba);g[U>>2]=qa;g[V>>2]=ha;ua=da;va=1}else{ua=sa;va=ta}g[j>>2]=ua;H=va;i=m;return H|0}function TOa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=Im,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=Im,fa=0,ga=Im,ha=Im,ia=0,ja=0,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=0,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=Im,Ba=0,Ca=Im,Da=0,Ea=0,Fa=Im,Ga=0,Ha=Im,Ia=Im,Ja=0,Ka=0,La=Im,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=Im,Ta=Im,Ua=0,Va=Im,Wa=Im,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=0,db=Im,eb=Im,fb=Im,gb=Im;m=i;i=i+32|0;n=m+12|0;o=m;p=ea(g[a+12>>2]);q=ea(g[a>>2]);r=ea(p-q);s=ea(g[a+16>>2]);t=ea(g[a+4>>2]);u=ea(s-t);v=ea(g[a+20>>2]);w=ea(g[a+8>>2]);x=ea(v-w);y=ea(g[a+24>>2]);z=ea(y-q);A=ea(g[a+28>>2]);B=ea(A-t);C=ea(g[a+32>>2]);D=ea(C-w);E=ea(ea(u*D)-ea(x*B));F=ea(ea(x*z)-ea(r*D));D=ea(ea(r*B)-ea(u*z));z=ea(g[f>>2]);u=ea(z*E);G=f+4|0;B=ea(g[G>>2]);r=ea(u+ea(B*F));H=f+8|0;u=ea(g[H>>2]);if(ea(ea(D*u)+r)>=ea(0.0)){I=0;i=m;return I|0}r=ea(ea(ea(p+q)+y)*ea(.333333343));x=ea(ea(ea(s+t)+A)*ea(.333333343));J=ea(ea(ea(v+w)+C)*ea(.333333343));K=ea(q+ea(ea(q-r)*ea(.0199999996)));q=ea(t+ea(ea(t-x)*ea(.0199999996)));t=ea(w+ea(ea(w-J)*ea(.0199999996)));w=ea(p+ea(ea(p-r)*ea(.0199999996)));p=ea(s+ea(ea(s-x)*ea(.0199999996)));s=ea(v+ea(ea(v-J)*ea(.0199999996)));v=ea(y+ea(ea(y-r)*ea(.0199999996)));r=ea(A+ea(ea(A-x)*ea(.0199999996)));x=ea(C+ea(ea(C-J)*ea(.0199999996)));J=ea(g[l>>2]);C=ea(-z);A=ea(-B);y=ea(-u);L=ea(-ea(g[h>>2]));M=ea(-ea(g[h+4>>2]));N=ea(-ea(g[h+8>>2]));O=ea(w-K);w=ea(p-q);p=ea(s-t);s=ea(v-K);v=ea(r-q);r=ea(x-t);x=ea(ea(B*r)-ea(u*v));P=ea(ea(u*s)-ea(z*r));Q=ea(ea(z*v)-ea(B*s));R=ea(ea(p*Q)+ea(ea(O*x)+ea(w*P)));if(R!=ea(0.0))T=ea(ea(1.0)/R);else T=ea(0.0);if(R>=ea(9.99999974e-06)){U=ea(0.0);V=J;h=-1;W=0;X=0;while(1){Y=ea(E*ea(g[540664+(X*12|0)>>2]));Z=ea(Y+ea(F*ea(g[540668+(X*12|0)>>2])));if(!(ea(Z+ea(D*ea(g[540672+(X*12|0)>>2])))>=ea(0.0))){Z=ea(g[d+(X*12|0)>>2]);Y=ea(g[d+(X*12|0)+4>>2]);_=ea(Z-K);Z=ea(Y-q);Y=ea(ea(g[d+(X*12|0)+8>>2])-t);$=ea(ea(ea(x*_)+ea(P*Z))+ea(Q*Y));if(!($<ea(0.0)|$>R)?(aa=ea(ea(p*Z)-ea(w*Y)),ba=ea(ea(O*Y)-ea(p*_)),Y=ea(ea(w*_)-ea(O*Z)),Z=ea(ea(ea(aa*z)+ea(ba*B))+ea(Y*u)),!(Z<ea(0.0)|ea($+Z)>R)):0){ca=0;da=ea(T*ea(ea(r*Y)+ea(ea(s*aa)+ea(v*ba))))}else{ca=1;da=U}fa=ca|da<ea(0.0)|da>V;ga=da;ha=fa?V:da;ia=fa?h:0;ja=fa?W:X}else{ga=U;ha=V;ia=h;ja=W}X=X+1|0;if((X|0)==8)break;else{U=ga;V=ha;h=ia;W=ja}}if(!ia){V=ea(ha*z);z=ea(ha*B);B=ea(ha*u);u=ea(V+ea(g[d+(ja*12|0)>>2]));V=ea(z+ea(g[d+(ja*12|0)+4>>2]));z=ea(B+ea(g[d+(ja*12|0)+8>>2]));g[j>>2]=u;g[j+4>>2]=V;g[j+8>>2]=z;g[k>>2]=E;g[k+4>>2]=F;g[k+8>>2]=D;ka=ha;la=0}else{ka=ha;la=ia}}else{ka=J;la=-1}ia=ea(S(ea(A)))<ea(1.1920929e-07);ja=ea(S(ea(y)))<ea(1.1920929e-07);d=b+12|0;W=b+4|0;h=b+16|0;X=b+8|0;ca=b+20|0;fa=k+4|0;ma=k+8|0;na=j+4|0;oa=j+8|0;if(ea(S(ea(C)))<ea(1.1920929e-07)){C=ka;pa=la;qa=0;while(1){ra=a+(qa*12|0)|0;y=ea(g[ra>>2]);do if(!(y<ea(g[b>>2]))?!(y>ea(g[d>>2])):0){if(ia){A=ea(g[a+(qa*12|0)+4>>2]);if(A<ea(g[W>>2])){sa=C;ta=pa;break}if(A>ea(g[h>>2])){sa=C;ta=pa;break}}if(ja){A=ea(g[a+(qa*12|0)+8>>2]);J=ea(g[X>>2]);if(A<J){sa=C;ta=pa;break}ha=ea(g[ca>>2]);if(A>ha){sa=C;ta=pa;break}else{ua=J;va=A;wa=ha}}else{ha=ea(g[X>>2]);A=ea(g[a+(qa*12|0)+8>>2]);ua=ha;va=A;wa=ea(g[ca>>2])}A=ea(g[W>>2]);xa=a+(qa*12|0)+4|0;ha=ea(g[xa>>2]);J=ea(ea(A-ha)*M);A=ea(ea(ea(g[h>>2])-ha)*M);ha=ea(ea(ua-va)*N);D=ea(ea(wa-va)*N);ya=J>A;F=ya?A:J;E=ya?J:A;za=ha>D;A=za?D:ha;J=za?ha:D;if(ia){Aa=ea(3402823469999999843913219.0e14);Ba=-1;Ca=ea(-3402823469999999843913219.0e14)}else{Da=F>ea(-3402823469999999843913219.0e14);D=Da?F:ea(-3402823469999999843913219.0e14);Ea=E>ea(3402823469999999843913219.0e14);Aa=Ea?ea(3402823469999999843913219.0e14):E;Ba=Da?(ya?4:1):-1;Ca=D}if(ja){Fa=Aa;Ga=Ba;Ha=Ca}else{ya=A>Ca;Fa=Aa<J?Aa:J;Ga=ya?(za?5:2):Ba;Ha=ya?A:Ca}ya=Ha>Fa|Fa<ea(1.1920929e-07);za=ya?-1:Ga;if((za|0)!=-1?!(Ha<ea(0.0)|!(Ha<=C)):0){g[k>>2]=ea(g[540592+(za*12|0)>>2]);g[fa>>2]=ea(g[540596+(za*12|0)>>2]);g[ma>>2]=ea(g[540600+(za*12|0)>>2]);g[j>>2]=ea(g[ra>>2]);g[na>>2]=ea(g[xa>>2]);g[oa>>2]=ea(g[a+(qa*12|0)+8>>2]);sa=Ha;ta=1}else{sa=C;ta=pa}}else{sa=C;ta=pa}while(0);qa=qa+1|0;if((qa|0)==3){Ia=sa;Ja=ta;break}else{C=sa;pa=ta}}}else{sa=ka;ta=la;la=0;while(1){if(ia){ka=ea(g[a+(la*12|0)+4>>2]);if(!(ka<ea(g[W>>2]))?!(ka>ea(g[h>>2])):0)Ka=35;else{La=sa;Ma=ta}}else Ka=35;do if((Ka|0)==35){Ka=0;if(ja){ka=ea(g[a+(la*12|0)+8>>2]);C=ea(g[X>>2]);if(ka<C){La=sa;Ma=ta;break}Ha=ea(g[ca>>2]);if(ka>Ha){La=sa;Ma=ta;break}else{Na=C;Oa=ka;Pa=Ha}}else{Ha=ea(g[X>>2]);ka=ea(g[a+(la*12|0)+8>>2]);Na=Ha;Oa=ka;Pa=ea(g[ca>>2])}ka=ea(g[b>>2]);pa=a+(la*12|0)|0;Ha=ea(g[pa>>2]);C=ea(ea(ka-Ha)*L);ka=ea(ea(ea(g[d>>2])-Ha)*L);Ha=ea(g[W>>2]);qa=a+(la*12|0)+4|0;Fa=ea(g[qa>>2]);Ca=ea(ea(Ha-Fa)*M);Ha=ea(ea(ea(g[h>>2])-Fa)*M);Fa=ea(ea(Na-Oa)*N);Aa=ea(ea(Pa-Oa)*N);Ga=C>ka;Ba=Ga?3:0;va=Ga?C:ka;wa=Ga?ka:C;Ga=Ca>Ha;C=Ga?Ha:Ca;ka=Ga?Ca:Ha;ra=Fa>Aa;Ha=ra?Aa:Fa;Ca=ra?Fa:Aa;if(ia){Qa=va;Ra=Ba;Sa=wa}else{xa=C>wa;Qa=va<ka?va:ka;Ra=xa?(Ga?4:1):Ba;Sa=xa?C:wa}if(ja){Ta=Qa;Ua=Ra;Va=Sa}else{xa=Ha>Sa;Ta=Qa<Ca?Qa:Ca;Ua=xa?(ra?5:2):Ra;Va=xa?Ha:Sa}xa=Va>Ta|Ta<ea(1.1920929e-07);ra=xa?-1:Ua;if((ra|0)!=-1?!(Va<ea(0.0)|!(Va<=sa)):0){g[k>>2]=ea(g[540592+(ra*12|0)>>2]);g[fa>>2]=ea(g[540596+(ra*12|0)>>2]);g[ma>>2]=ea(g[540600+(ra*12|0)>>2]);g[j>>2]=ea(g[pa>>2]);g[na>>2]=ea(g[qa>>2]);g[oa>>2]=ea(g[a+(la*12|0)+8>>2]);La=Va;Ma=1}else{La=sa;Ma=ta}}while(0);la=la+1|0;if((la|0)==3){Ia=La;Ja=Ma;break}else{sa=La;ta=Ma}}}Ma=n+4|0;ta=n+8|0;la=o+4|0;Ua=o+8|0;La=Ia;Ra=Ja;Ja=0;while(1){a:do if((c[e+(Ja*68|0)+64>>2]|0)<0){Wa=La;Xa=Ra}else{Ia=ea(g[e+(Ja*68|0)+16>>2]);g[n>>2]=Ia;sa=ea(g[e+(Ja*68|0)+20>>2]);g[Ma>>2]=sa;Va=ea(g[e+(Ja*68|0)+24>>2]);g[ta>>2]=Va;Ta=ea(g[e+(Ja*68|0)+28>>2]);Sa=ea(g[e+(Ja*68|0)+32>>2]);Qa=ea(g[e+(Ja*68|0)+36>>2]);ja=e+(Ja*68|0)+60|0;ia=e+(Ja*68|0)|0;h=e+(Ja*68|0)+4|0;W=e+(Ja*68|0)+8|0;d=e+(Ja*68|0)+12|0;b=e+(Ja*68|0)+44|0;ca=e+(Ja*68|0)+48|0;X=c[e+(Ja*68|0)+52>>2]|0;Ka=c[e+(Ja*68|0)+56>>2]|0;N=La;qa=Ra;pa=0;while(1){Oa=ea(g[ja>>2]);Pa=ea(g[ia>>2]);Na=ea(g[h>>2]);M=ea(g[W>>2]);L=ea(g[d>>2]);ra=pa;while(1){xa=ra;ra=ra+1|0;Ba=(ra|0)==3?0:ra;Ya=ea(g[a+(xa*12|0)>>2]);Za=ea(g[a+(xa*12|0)+4>>2]);_a=ea(g[a+(xa*12|0)+8>>2]);$a=ea(g[a+(Ba*12|0)>>2]);ab=ea(g[a+(Ba*12|0)+4>>2]);bb=ea(g[a+(Ba*12|0)+8>>2]);Ha=ea(L+ea(ea(ea(Ya*Pa)+ea(Za*Na))+ea(_a*M)));if(!(ea(Ha*ea(L+ea(ea(ea($a*Pa)+ea(ab*Na))+ea(bb*M))))>ea(0.0))?(Ca=ea($a-Ya),wa=ea(ab-Za),C=ea(bb-_a),ka=ea(ea(ea(Ca*Pa)+ea(wa*Na))+ea(C*M)),!(ka==ea(0.0))):0){va=ea(Ha/ka);ka=ea(Ya-ea(Ca*va));Ca=ea(Za-ea(wa*va));wa=ea(_a-ea(C*va));g[o>>2]=ka;g[la>>2]=Ca;g[Ua>>2]=wa;cb=e+(Ja*68|0)+40|0;va=ea(g[cb+(X<<2)>>2]);C=ea(g[o+(Ka<<2)>>2]);Ha=ea(va*ea(C-ea(g[n+(Ka<<2)>>2])));C=ea(g[cb+(Ka<<2)>>2]);va=ea(g[o+(X<<2)>>2]);db=ea(Oa*ea(Ha-ea(C*ea(va-ea(g[n+(X<<2)>>2])))));if(!(db<ea(0.0))?(va=ea(g[f>>2]),C=ea(g[G>>2]),Ha=ea(db*C),C=ea(db*ea(g[H>>2])),eb=ea(ka-ea(db*va)),g[o>>2]=eb,fb=ea(Ca-Ha),g[la>>2]=fb,gb=ea(wa-C),g[Ua>>2]=gb,!(db<=N?!(ea(ea(ea(ea(Ta-eb)*ea(Ia-eb))+ea(ea(Sa-fb)*ea(sa-fb)))+ea(ea(Qa-gb)*ea(Va-gb)))<ea(0.0)):1)):0)break;if(ra>>>0<3){ra=ra;continue}else{Wa=N;Xa=qa;break a}}if(ra>>>0>=3){Wa=N;Xa=qa;break a}}Oa=ea(Ya-$a);M=ea(Za-ab);Na=ea(_a-bb);Pa=ea(g[b>>2]);L=ea(Pa*Na);C=ea(g[ca>>2]);wa=ea(L-ea(M*C));L=ea(Oa*C);C=ea(g[cb>>2]);Ha=ea(L-ea(Na*C));Na=ea(ea(M*C)-ea(Oa*Pa));g[k>>2]=wa;g[fa>>2]=Ha;g[ma>>2]=Na;Na=ea(db*ea(g[f>>2]));Ha=ea(db*ea(g[G>>2]));wa=ea(Ha+fb);Ha=ea(ea(db*ea(g[H>>2]))+gb);g[j>>2]=ea(Na+eb);g[na>>2]=wa;g[oa>>2]=Ha;if(ra>>>0<3){N=db;qa=2;pa=ra}else{Wa=db;Xa=2;break}}}while(0);Ja=Ja+1|0;if((Ja|0)==12)break;else{La=Wa;Ra=Xa}}if((Xa|0)==-1){I=0;i=m;return I|0}g[l>>2]=Wa;I=1;i=m;return I|0}function UOa(b,c,e,f,h,j,k){b=b|0;c=c|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=Im,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=Im,I=Im,J=0,K=Im,L=0,M=Im;l=i;i=i+16|0;m=l+8|0;n=l+4|0;o=l;p=b+12|0;q=ea(g[p>>2]);r=ea(g[b>>2]);s=ea(q-r);q=ea(g[b+16>>2]);t=ea(g[b+4>>2]);u=ea(q-t);q=ea(g[b+20>>2]);v=ea(g[b+8>>2]);w=ea(q-v);x=b+24|0;q=ea(ea(g[x>>2])-r);r=ea(ea(g[b+28>>2])-t);t=ea(ea(g[b+32>>2])-v);v=ea(ea(u*t)-ea(w*r));y=ea(ea(w*q)-ea(s*t));t=ea(ea(s*r)-ea(u*q));if(!k?(q=ea(v*ea(g[e>>2])),u=ea(q+ea(y*ea(g[e+4>>2]))),ea(u+ea(t*ea(g[e+8>>2])))>=ea(0.0)):0){z=0;i=l;return z|0}a[m>>0]=1;g[j>>2]=h;g[n>>2]=ea(-3402823469999999843913219.0e14);g[o>>2]=ea(3402823469999999843913219.0e14);u=ea(g[c>>2]);k=c+4|0;q=ea(g[k>>2]);A=c+8|0;if(!(S6a(b,u,q,ea(g[A>>2]),e,v,y,t,m,n,o)|0)){z=0;i=l;return z|0}t=ea(g[f>>2]);y=ea(g[b>>2]);v=ea(g[p>>2]);q=ea(g[x>>2]);u=y<v?y:v;r=y>v?y:v;v=ea(g[c>>2]);s=ea(ea(-v)-(r>q?r:q));r=ea(v-(u<q?u:q));if(!(s<=ea(0.0)))B=0;else B=r>=ea(0.0);C=d[m>>0]&(B&1);a[m>>0]=C;do if(ea(S(ea(g[e>>2])))<ea(9.99999997e-07)){if(!B){z=0;i=l;return z|0}}else{q=ea(t*ea(-1.0));u=ea(q*s);v=ea(q*r);q=u<v?u:v;w=u>v?u:v;v=ea(g[o>>2]);if(q>v){z=0;i=l;return z|0}u=ea(g[n>>2]);if(w<u){z=0;i=l;return z|0}else{g[o>>2]=w<v?w:v;g[n>>2]=q>u?q:u;break}}while(0);r=ea(g[f+4>>2]);s=ea(g[b+4>>2]);t=ea(g[p+4>>2]);u=ea(g[x+4>>2]);q=s<t?s:t;v=s>t?s:t;t=ea(g[c+4>>2]);w=ea(ea(-t)-(v>u?v:u));v=ea(t-(q<u?q:u));if(!(w<=ea(0.0)))D=0;else D=v>=ea(0.0);B=D&1&C;a[m>>0]=B;do if(ea(S(ea(g[e+4>>2])))<ea(9.99999997e-07)){if(!D){z=0;i=l;return z|0}}else{u=ea(r*ea(-1.0));q=ea(u*w);t=ea(u*v);u=q<t?q:t;E=q>t?q:t;t=ea(g[o>>2]);if(u>t){z=0;i=l;return z|0}q=ea(g[n>>2]);if(E<q){z=0;i=l;return z|0}else{g[o>>2]=E<t?E:t;g[n>>2]=u>q?u:q;break}}while(0);v=ea(g[f+8>>2]);w=ea(g[b+8>>2]);r=ea(g[p+8>>2]);q=ea(g[x+8>>2]);u=w<r?w:r;t=w>r?w:r;r=ea(g[c+8>>2]);E=ea(ea(-r)-(t>q?t:q));t=ea(r-(u<q?u:q));if(!(E<=ea(0.0)))F=0;else F=t>=ea(0.0);a[m>>0]=F&1&B;do if(ea(S(ea(g[e+8>>2])))<ea(9.99999997e-07))if(F){G=y;H=s;I=w;J=0}else{z=0;i=l;return z|0}else{q=ea(v*ea(-1.0));u=ea(q*E);r=ea(q*t);q=u<r?u:r;K=u>r?u:r;r=ea(g[o>>2]);if(q>r){z=0;i=l;return z|0}u=ea(g[n>>2]);if(K<u){z=0;i=l;return z|0}else{g[o>>2]=K<r?K:r;g[n>>2]=q>u?q:u;G=y;H=s;I=w;J=0;break}}while(0);while(1){F=J+1|0;B=J>>>0>1?0:F;w=ea(ea(g[b+(B*12|0)>>2])-G);s=ea(ea(g[b+(B*12|0)+4>>2])-H);y=ea(ea(g[b+(B*12|0)+8>>2])-I);t=ea(ea(y*y)+ea(0.0));E=ea(s*s);if(ea(E+t)>=ea(9.99999997e-07)?(v=ea(-y),u=ea(g[c>>2]),q=ea(g[k>>2]),(S6a(b,u,q,ea(g[A>>2]),e,ea(0.0),v,s,m,n,o)|0)==0):0){z=0;L=37;break}v=ea(w*w);if(ea(v+t)>=ea(9.99999997e-07)?(t=ea(-w),q=ea(g[c>>2]),u=ea(g[k>>2]),(S6a(b,q,u,ea(g[A>>2]),e,y,ea(0.0),t,m,n,o)|0)==0):0){z=0;L=37;break}if(ea(ea(v+E)+ea(0.0))>=ea(9.99999997e-07)?(E=ea(-s),s=ea(g[c>>2]),v=ea(g[k>>2]),(S6a(b,s,v,ea(g[A>>2]),e,E,w,ea(0.0),m,n,o)|0)==0):0){z=0;L=37;break}if(F>>>0>=3){L=33;break}w=ea(g[b+(F*12|0)>>2]);E=ea(g[b+(F*12|0)+4>>2]);G=w;H=E;I=ea(g[b+(F*12|0)+8>>2]);J=F}if((L|0)==33){I=ea(g[n>>2]);if(I>h?1:ea(g[o>>2])<ea(0.0)){z=0;i=l;return z|0}if(I<=ea(0.0))if(!(a[m>>0]|0)){z=0;i=l;return z|0}else M=ea(0.0);else M=I;g[j>>2]=M;z=1;i=l;return z|0}else if((L|0)==37){i=l;return z|0}return 0}function VOa(e,f,h,j,k,l,m,n,o){e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im,ra=Im,sa=0;p=i;i=i+976|0;q=p+536|0;r=p+392|0;s=p+8|0;t=p+344|0;u=p+512|0;v=p;w=p+970|0;x=p+492|0;y=p+488|0;z=p+504|0;A=p+968|0;B=p+380|0;if((b[o>>1]&16)==0?(C=ea(g[f>>2]),D=ea(g[f+4>>2]),E=ea(g[f+8>>2]),F=ea(g[f+12>>2]),G=ea(C+C),H=ea(D+D),I=ea(E+E),J=ea(C*G),C=ea(D*H),K=ea(E*I),L=ea(G*D),D=ea(G*E),M=ea(G*F),G=ea(H*E),E=ea(H*F),H=ea(I*F),F=ea(L+H),I=ea(D-E),g[t>>2]=ea(ea(ea(1.0)-C)-K),g[t+4>>2]=F,g[t+8>>2]=I,I=ea(ea(1.0)-J),J=ea(I-K),K=ea(G+M),g[t+12>>2]=ea(L-H),g[t+16>>2]=J,g[t+20>>2]=K,K=ea(G-M),M=ea(I-C),g[t+24>>2]=ea(D+E),g[t+28>>2]=K,g[t+32>>2]=M,M=ea(LOa(e,e+12|0,f+16|0,h,t,0,0)),K=ea(g[e+24>>2]),M<ea(K*K)):0){g[m>>2]=ea(0.0);K=ea(-ea(g[j>>2]));M=ea(-ea(g[j+4>>2]));E=ea(-ea(g[j+8>>2]));g[n>>2]=K;g[n+4>>2]=M;g[n+8>>2]=E;N=1;i=p;return N|0}t=e+12|0;E=ea(g[t>>2]);M=ea(E-ea(g[e>>2]));o=e+16|0;E=ea(g[o>>2]);O=e+4|0;K=ea(E-ea(g[O>>2]));P=e+20|0;E=ea(g[P>>2]);Q=e+8|0;D=ea(M*ea(.5));M=ea(K*ea(.5));K=ea(ea(E-ea(g[Q>>2]))*ea(.5));E=ea(g[h>>2]);C=ea(-E);I=ea(g[h+4>>2]);G=ea(-I);J=ea(g[h+8>>2]);H=ea(-J);g[u>>2]=C;g[u+4>>2]=G;g[u+8>>2]=H;g[u+12>>2]=E;g[u+16>>2]=I;g[u+20>>2]=J;h=v+4|0;a[h>>0]=1;R=sKa(w,3024,540760,230)|0;c[v>>2]=R;sLa(u,r);if(!f){u=0;do{w=u*3|0;S=d[540856+w>>0]|0;J=ea(g[r+(S*12|0)>>2]);I=ea(g[r+(S*12|0)+4>>2]);E=ea(g[r+(S*12|0)+8>>2]);S=d[w+540857>>0]|0;H=ea(g[r+(S*12|0)>>2]);G=ea(g[r+(S*12|0)+4>>2]);C=ea(g[r+(S*12|0)+8>>2]);S=d[w+540858>>0]|0;L=ea(g[r+(S*12|0)>>2]);F=ea(g[r+(S*12|0)+4>>2]);T=ea(g[r+(S*12|0)+8>>2]);g[q+(u*36|0)>>2]=J;g[q+(u*36|0)+4>>2]=I;g[q+(u*36|0)+8>>2]=E;g[q+(u*36|0)+12>>2]=H;g[q+(u*36|0)+16>>2]=G;g[q+(u*36|0)+20>>2]=C;g[q+(u*36|0)+24>>2]=L;g[q+(u*36|0)+28>>2]=F;g[q+(u*36|0)+32>>2]=T;u=u+1|0}while((u|0)!=12)}else{T=ea(g[f+12>>2]);F=ea(ea(T*T)+ea(-.5));L=ea(g[f>>2]);C=ea(g[f+4>>2]);G=ea(g[f+8>>2]);H=ea(g[f+16>>2]);E=ea(g[f+20>>2]);I=ea(g[f+24>>2]);f=0;do{u=f*3|0;S=d[540856+u>>0]|0;J=ea(g[r+(S*12|0)>>2]);U=ea(g[r+(S*12|0)+4>>2]);V=ea(g[r+(S*12|0)+8>>2]);S=d[u+540857>>0]|0;W=ea(g[r+(S*12|0)>>2]);X=ea(g[r+(S*12|0)+4>>2]);Y=ea(g[r+(S*12|0)+8>>2]);S=d[u+540858>>0]|0;Z=ea(g[r+(S*12|0)>>2]);_=ea(g[r+(S*12|0)+4>>2]);$=ea(J*ea(2.0));J=ea(U*ea(2.0));U=ea(V*ea(2.0));V=ea(ea(ea($*L)+ea(J*C))+ea(U*G));aa=ea(E+ea(ea(C*V)+ea(ea(J*F)+ea(T*ea(ea($*G)-ea(U*L))))));ba=ea(I+ea(ea(ea(U*F)+ea(T*ea(ea(J*L)-ea($*C))))+ea(G*V)));ca=ea(W*ea(2.0));W=ea(X*ea(2.0));X=ea(Y*ea(2.0));Y=ea(ea(ea(ca*L)+ea(W*C))+ea(X*G));da=ea(H+ea(ea(L*Y)+ea(ea(ca*F)+ea(T*ea(ea(X*C)-ea(W*G))))));fa=ea(E+ea(ea(C*Y)+ea(ea(W*F)+ea(T*ea(ea(ca*G)-ea(X*L))))));ga=ea(I+ea(ea(ea(X*F)+ea(T*ea(ea(W*L)-ea(ca*C))))+ea(G*Y)));Y=ea(Z*ea(2.0));Z=ea(_*ea(2.0));_=ea(ea(g[r+(S*12|0)+8>>2])*ea(2.0));ca=ea(ea(ea(Y*L)+ea(Z*C))+ea(_*G));W=ea(H+ea(ea(L*ca)+ea(ea(Y*F)+ea(T*ea(ea(_*C)-ea(Z*G))))));X=ea(E+ea(ea(C*ca)+ea(ea(Z*F)+ea(T*ea(ea(Y*G)-ea(_*L))))));ha=ea(I+ea(ea(ea(_*F)+ea(T*ea(ea(Z*L)-ea(Y*C))))+ea(G*ca)));g[q+(f*36|0)>>2]=ea(H+ea(ea(L*V)+ea(ea($*F)+ea(T*ea(ea(U*C)-ea(J*G))))));g[q+(f*36|0)+4>>2]=aa;g[q+(f*36|0)+8>>2]=ba;g[q+(f*36|0)+12>>2]=da;g[q+(f*36|0)+16>>2]=fa;g[q+(f*36|0)+20>>2]=ga;g[q+(f*36|0)+24>>2]=W;g[q+(f*36|0)+28>>2]=X;g[q+(f*36|0)+32>>2]=ha;f=f+1|0}while((f|0)!=12)}f=j+4|0;r=j+8|0;S=R;R=s;u=0;while(1){G=ea(g[q+(u*36|0)+12>>2]);C=ea(g[q+(u*36|0)>>2]);T=ea(G-C);F=ea(g[q+(u*36|0)+16>>2]);L=ea(g[q+(u*36|0)+4>>2]);H=ea(F-L);I=ea(g[q+(u*36|0)+20>>2]);E=ea(g[q+(u*36|0)+8>>2]);ha=ea(I-E);X=ea(g[q+(u*36|0)+24>>2]);W=ea(X-C);ga=ea(g[q+(u*36|0)+28>>2]);fa=ea(ga-L);da=ea(g[q+(u*36|0)+32>>2]);ba=ea(da-E);aa=ea(ea(H*ba)-ea(ha*fa));J=ea(ea(ha*W)-ea(T*ba));ba=ea(ea(T*fa)-ea(H*W));W=ea(ea(g[j>>2])*aa);H=ea(W+ea(ea(g[f>>2])*J));if(ea(ea(ba*ea(g[r>>2]))+H)>ea(0.0)){ia=R;ja=S}else{H=ea(D+C);W=ea(M+L);fa=ea(K+E);T=ea(D+G);ha=ea(M+F);U=ea(K+I);$=ea(D+X);V=ea(M+ga);ca=ea(K+da);Y=ea(C-D);C=ea(L-M);L=ea(E-K);E=ea(G-D);G=ea(F-M);F=ea(I-K);I=ea(X-D);X=ea(ga-M);ga=ea(da-K);if(!(ea(ea(K*ba)+ea(ea(D*aa)+ea(M*J)))>=ea(0.0))){g[S>>2]=Y;g[S+4>>2]=C;g[S+8>>2]=L;g[S+12>>2]=E;g[S+16>>2]=G;g[S+20>>2]=F;g[S+24>>2]=I;g[S+28>>2]=X;g[S+32>>2]=ga}else{g[S>>2]=H;g[S+4>>2]=W;g[S+8>>2]=fa;g[S+12>>2]=T;g[S+16>>2]=ha;g[S+20>>2]=U;g[S+24>>2]=$;g[S+28>>2]=V;g[S+32>>2]=ca}c[R>>2]=u;g[S+36>>2]=E;g[S+40>>2]=G;g[S+44>>2]=F;w=S+48|0;g[w>>2]=T;ka=S+52|0;g[ka>>2]=ha;la=S+56|0;g[la>>2]=U;ma=S+60|0;g[ma>>2]=$;na=S+64|0;g[na>>2]=V;oa=S+68|0;g[oa>>2]=ca;J=ea(T-E);aa=ea(ha-G);ba=ea(U-F);da=ea($-E);Z=ea(V-G);_=ea(ca-F);pa=ea(ea(aa*_)-ea(ba*Z));qa=ea(ea(ba*da)-ea(J*_));ba=ea(ea(J*Z)-ea(aa*da));aa=ea(pa*ea(g[j>>2]));pa=ea(aa+ea(qa*ea(g[f>>2])));if(ea(ea(ba*ea(g[r>>2]))+pa)>ea(0.0)){g[w>>2]=$;g[ka>>2]=V;g[la>>2]=ca;g[ma>>2]=T;g[na>>2]=ha;g[oa>>2]=U}c[R+4>>2]=u;g[S+72>>2]=E;g[S+76>>2]=G;g[S+80>>2]=F;oa=S+84|0;g[oa>>2]=$;na=S+88|0;g[na>>2]=V;ma=S+92|0;g[ma>>2]=ca;la=S+96|0;g[la>>2]=I;ka=S+100|0;g[ka>>2]=X;w=S+104|0;g[w>>2]=ga;pa=ea(I-E);ba=ea(X-G);qa=ea(ga-F);aa=ea(ea(Z*qa)-ea(ba*_));J=ea(ea(pa*_)-ea(da*qa));qa=ea(ea(da*ba)-ea(pa*Z));Z=ea(aa*ea(g[j>>2]));aa=ea(Z+ea(J*ea(g[f>>2])));if(ea(ea(qa*ea(g[r>>2]))+aa)>ea(0.0)){g[oa>>2]=I;g[na>>2]=X;g[ma>>2]=ga;g[la>>2]=$;g[ka>>2]=V;g[w>>2]=ca}c[R+8>>2]=u;g[S+108>>2]=Y;g[S+112>>2]=C;g[S+116>>2]=L;w=S+120|0;g[w>>2]=I;ka=S+124|0;g[ka>>2]=X;la=S+128|0;g[la>>2]=ga;ma=S+132|0;g[ma>>2]=$;na=S+136|0;g[na>>2]=V;oa=S+140|0;g[oa>>2]=ca;aa=ea(I-Y);qa=ea(X-C);J=ea(ga-L);Z=ea($-Y);pa=ea(V-C);ba=ea(ca-L);da=ea(ea(qa*ba)-ea(pa*J));_=ea(ea(Z*J)-ea(aa*ba));J=ea(ea(aa*pa)-ea(Z*qa));qa=ea(da*ea(g[j>>2]));da=ea(qa+ea(_*ea(g[f>>2])));if(ea(ea(J*ea(g[r>>2]))+da)>ea(0.0)){g[w>>2]=$;g[ka>>2]=V;g[la>>2]=ca;g[ma>>2]=I;g[na>>2]=X;g[oa>>2]=ga}c[R+12>>2]=u;g[S+144>>2]=Y;g[S+148>>2]=C;g[S+152>>2]=L;oa=S+156|0;g[oa>>2]=$;na=S+160|0;g[na>>2]=V;ma=S+164|0;g[ma>>2]=ca;la=S+168|0;g[la>>2]=H;ka=S+172|0;g[ka>>2]=W;w=S+176|0;g[w>>2]=fa;ga=ea(H-Y);X=ea(W-C);I=ea(fa-L);da=ea(ea(I*pa)-ea(X*ba));J=ea(ea(ga*ba)-ea(I*Z));I=ea(ea(X*Z)-ea(ga*pa));pa=ea(da*ea(g[j>>2]));da=ea(pa+ea(J*ea(g[f>>2])));if(ea(ea(I*ea(g[r>>2]))+da)>ea(0.0)){g[oa>>2]=H;g[na>>2]=W;g[ma>>2]=fa;g[la>>2]=$;g[ka>>2]=V;g[w>>2]=ca}c[R+16>>2]=u;g[S+180>>2]=H;g[S+184>>2]=W;g[S+188>>2]=fa;w=S+192|0;g[w>>2]=T;ka=S+196|0;g[ka>>2]=ha;la=S+200|0;g[la>>2]=U;ma=S+204|0;g[ma>>2]=E;na=S+208|0;g[na>>2]=G;oa=S+212|0;g[oa>>2]=F;ca=ea(T-H);V=ea(ha-W);$=ea(U-fa);da=ea(E-H);I=ea(G-W);J=ea(F-fa);pa=ea(ea(V*J)-ea(I*$));ga=ea(ea(da*$)-ea(ca*J));$=ea(ea(ca*I)-ea(da*V));V=ea(pa*ea(g[j>>2]));pa=ea(V+ea(ga*ea(g[f>>2])));if(ea(ea($*ea(g[r>>2]))+pa)>ea(0.0)){g[w>>2]=E;g[ka>>2]=G;g[la>>2]=F;g[ma>>2]=T;g[na>>2]=ha;g[oa>>2]=U}c[R+20>>2]=u;g[S+216>>2]=H;g[S+220>>2]=W;g[S+224>>2]=fa;oa=S+228|0;g[oa>>2]=E;na=S+232|0;g[na>>2]=G;ma=S+236|0;g[ma>>2]=F;la=S+240|0;g[la>>2]=Y;ka=S+244|0;g[ka>>2]=C;w=S+248|0;g[w>>2]=L;U=ea(Y-H);H=ea(C-W);W=ea(L-fa);fa=ea(ea(I*W)-ea(H*J));ha=ea(ea(U*J)-ea(da*W));W=ea(ea(da*H)-ea(U*I));I=ea(fa*ea(g[j>>2]));fa=ea(I+ea(ha*ea(g[f>>2])));if(ea(ea(W*ea(g[r>>2]))+fa)>ea(0.0)){g[oa>>2]=Y;g[na>>2]=C;g[ma>>2]=L;g[la>>2]=E;g[ka>>2]=G;g[w>>2]=F}c[R+24>>2]=u;ia=R+28|0;ja=S+252|0}u=u+1|0;if((u|0)==12)break;else{S=ja;R=ia}}b[A>>1]=0;R=c[v>>2]|0;M=ea(g[e>>2]);D=ea(M+ea(g[t>>2]));M=ea(g[O>>2]);K=ea(M+ea(g[o>>2]));M=ea(g[Q>>2]);F=ea(K*ea(.5));K=ea(ea(M+ea(g[P>>2]))*ea(.5));g[B>>2]=ea(D*ea(.5));g[B+4>>2]=F;g[B+8>>2]=K;if($Oa(ia-s>>2,R,B,ea(g[e+24>>2]),j,k,0,l,x,y,z,A,0)|0){K=ea(g[y>>2]);g[n>>2]=ea(g[x>>2]);g[n+4>>2]=ea(g[x+4>>2]);g[n+8>>2]=ea(g[x+8>>2]);ra=K;sa=1}else{ra=k;sa=0}if(a[h>>0]|0)tKa(v,R);g[m>>2]=ra;N=sa;i=p;return N|0}function WOa(a,c,d,f,h,j,k,l,m){a=a|0;c=c|0;d=d|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=0,C=Im,D=0,E=Im,F=Im,G=0,H=Im,I=0,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=Im,W=Im,X=0,Y=Im,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=Im,za=0,Aa=Im,Ba=0,Ca=Im,Da=Im,Ea=0,Fa=Im,Ga=Im;n=i;i=i+176|0;o=n+160|0;p=n+48|0;q=n+40|0;r=n+24|0;s=n+12|0;t=n;u=a+24|0;v=ea(g[u>>2]);w=c+24|0;x=ea(v+ea(g[w>>2]));v=ea(g[c>>2]);y=c+12|0;z=ea(g[y>>2]);A=ea(v+z);B=c+4|0;C=ea(g[B>>2]);D=c+16|0;E=ea(g[D>>2]);F=ea(C+E);G=c+8|0;H=ea(g[G>>2]);I=c+20|0;J=ea(g[I>>2]);K=ea(F*ea(.5));F=ea(ea(H+J)*ea(.5));g[o>>2]=ea(A*ea(.5));L=o+4|0;g[L>>2]=K;M=o+8|0;g[M>>2]=F;a:do if(!(l&16)){F=ea(g[a>>2]);N=a+12|0;if((F==ea(g[N>>2])?(F=ea(g[a+4>>2]),F==ea(g[a+16>>2])):0)?(F=ea(g[a+8>>2]),F==ea(g[a+20>>2])):0){if(!(ea(IOa(c,c+12|0,a,0))<ea(x*x))){O=a;P=N;Q=c;break}}else R=7;do if((R|0)==7)if(v==z&C==E&H==J)if(ea(IOa(a,a+12|0,c,0))<ea(x*x))break;else{O=a;P=N;Q=c;break a}else if(ea(NOa(a,c,0,0))<ea(x*x))break;else{O=a;P=N;Q=c;break a}while(0);g[h>>2]=ea(0.0);F=ea(-ea(g[d>>2]));K=ea(-ea(g[d+4>>2]));A=ea(-ea(g[d+8>>2]));g[k>>2]=F;g[k+4>>2]=K;g[k+8>>2]=A;b[m>>1]=6;S=1;i=n;return S|0}else{O=a;P=a+12|0;Q=c}while(0);J=ea(g[y>>2]);H=ea(J-ea(g[c>>2]));J=ea(g[D>>2]);E=ea(J-ea(g[B>>2]));J=ea(g[I>>2]);C=ea(H*ea(.5));H=ea(E*ea(.5));E=ea(ea(J-ea(g[G>>2]))*ea(.5));J=ea(g[O>>2]);z=ea(J-C);N=a+4|0;v=ea(g[N>>2]);A=ea(v-H);U=a+8|0;K=ea(g[U>>2]);F=ea(K-E);V=ea(g[P>>2]);W=ea(V-C);X=a+16|0;Y=ea(g[X>>2]);Z=ea(Y-H);_=a+20|0;$=ea(g[_>>2]);aa=ea($-E);ba=ea(C+J);J=ea(H+v);v=ea(E+K);K=ea(C+V);V=ea(H+Y);Y=ea(E+$);$=ea(K-ba);E=ea(V-J);H=ea(Y-v);C=ea(W-ba);ca=ea(Z-J);da=ea(aa-v);fa=ea(ea(E*da)-ea(ca*H));ga=ea(ea(C*H)-ea($*da));da=ea(ea($*ca)-ea(C*E));E=ea(T(ea(ea(da*da)+ea(ea(fa*fa)+ea(ga*ga)))));if(E>ea(0.0)){C=ea(ea(1.0)/E);ha=ea(fa*C);ia=ea(ga*C);ja=ea(da*C)}else{ha=fa;ia=ga;ja=da}da=ea(g[d>>2]);ga=ea(ha*da);a=d+4|0;fa=ea(g[a>>2]);C=ea(ga+ea(ia*fa));ka=d+8|0;ga=ea(g[ka>>2]);E=ea(x*ha);ha=ea(x*ia);ia=ea(x*ja);if(!(ea(C+ea(ja*ga))>=ea(0.0))){la=ea(z+E);ma=ea(W+E);na=ea(A+ha);oa=ea(Z+ha);pa=ea(F+ia);qa=ea(aa+ia);ra=ea(K+E);sa=ea(V+ha);ta=ea(Y+ia)}else{la=ea(K-E);ma=ea(W-E);na=ea(V-ha);oa=ea(Z-ha);pa=ea(Y-ia);qa=ea(aa-ia);ra=ea(z-E);sa=ea(A-ha);ta=ea(F-ia)}ia=ea(la-ma);la=ea(na-oa);na=ea(pa-qa);pa=ea(ra-ma);ra=ea(sa-oa);sa=ea(ta-qa);ta=ea(ea(sa*fa)-ea(ra*ga));ha=ea(ea(pa*ga)-ea(sa*da));E=ea(ea(ra*da)-ea(pa*fa));ja=ea(ea(na*E)+ea(ea(ia*ta)+ea(la*ha)));if((!(ja<ea(9.99999974e-06))?(C=ea(g[M>>2]),ca=ea(g[L>>2]),$=ea(ea(g[o>>2])-ma),ma=ea(ca-oa),oa=ea(C-qa),qa=ea(ea(E*oa)+ea(ea(ha*ma)+ea(ta*$))),!(qa<ea(0.0)|qa>ja)):0)?(qa=ea(ea(na*ma)-ea(la*oa)),ta=ea(ea(ia*oa)-ea(na*$)),na=ea(ea(la*$)-ea(ia*ma)),ma=ea(ea(ga*na)+ea(ea(da*qa)+ea(fa*ta))),!(ma<ea(0.0)|ma>ja)):0){ma=ea(ea(ea(sa*na)+ea(ea(pa*qa)+ea(ra*ta)))*ea(ea(1.0)/ja));L=ma>=ea(0.0)&ma<f;ja=L?ma:f;if(L)ua=ja;else{va=ja;R=20}}else{va=f;R=20}do if((R|0)==20){g[p>>2]=z;g[p+4>>2]=A;g[p+8>>2]=F;g[p+12>>2]=W;g[p+16>>2]=Z;g[p+20>>2]=aa;g[p+24>>2]=x;g[p+28>>2]=W;g[p+32>>2]=Z;g[p+36>>2]=aa;g[p+40>>2]=K;g[p+44>>2]=V;g[p+48>>2]=Y;g[p+52>>2]=x;g[p+56>>2]=K;g[p+60>>2]=V;g[p+64>>2]=Y;g[p+68>>2]=ba;g[p+72>>2]=J;g[p+76>>2]=v;g[p+80>>2]=x;g[p+84>>2]=z;g[p+88>>2]=A;g[p+92>>2]=F;g[p+96>>2]=ba;g[p+100>>2]=J;g[p+104>>2]=v;g[p+108>>2]=x;L=q+4|0;M=TPa(o,d,p,q)|0;if(!M){wa=va;xa=0}else{f=ea(g[q>>2]);if((M|0)==1)ya=f;else{ja=ea(g[L>>2]);ya=f<ja?f:ja}M=!(ya>=ea(0.0));za=!(ya<=va);wa=M|za?va:ya;xa=(M|za)^1}za=TPa(o,d,p+28|0,q)|0;if(!za){Aa=wa;Ba=xa}else{ja=ea(g[q>>2]);if((za|0)==1)Ca=ja;else{f=ea(g[L>>2]);Ca=ja<f?ja:f}za=!(Ca>=ea(0.0));M=!(Ca<=wa);Aa=za|M?wa:Ca;Ba=xa|(za|M)^1}M=TPa(o,d,p+56|0,q)|0;if(!M){Da=Aa;Ea=Ba}else{f=ea(g[q>>2]);if((M|0)==1)Fa=f;else{ja=ea(g[L>>2]);Fa=f<ja?f:ja}M=!(Fa>=ea(0.0));za=!(Fa<=Aa);Da=M|za?Aa:Fa;Ea=Ba|(M|za)^1}za=TPa(o,d,p+84|0,q)|0;if(!za){if(Ea){ua=Da;break}else S=0;i=n;return S|0}ja=ea(g[q>>2]);if((za|0)==1)Ga=ja;else{f=ea(g[L>>2]);Ga=ja<f?ja:f}L=!(Ga>=ea(0.0));za=!(Ga<=Da);if(Ea|(L|za)^1)ua=L|za?Da:Ga;else{S=0;i=n;return S|0}}while(0);b[m>>1]=4;if(l&3){Ga=ea(g[d>>2]);Da=ea(g[a>>2]);Fa=ea(ua*Ga);Ga=ea(ua*Da);Da=ea(ua*ea(g[ka>>2]));Aa=ea(ea(g[O>>2])-Fa);Ca=ea(ea(g[N>>2])-Ga);wa=ea(ea(g[U>>2])-Da);ya=ea(ea(g[P>>2])-Fa);Fa=ea(ea(g[X>>2])-Ga);Ga=ea(ya-Aa);ya=ea(Fa-Ca);Fa=ea(ea(ea(g[_>>2])-Da)-wa);Da=ea(g[y>>2]);va=ea(Da-ea(g[c>>2]));Da=ea(g[D>>2]);x=ea(Da-ea(g[B>>2]));Da=ea(g[I>>2]);v=ea(Da-ea(g[G>>2]));g[r>>2]=va;G=r+4|0;g[G>>2]=x;I=r+8|0;g[I>>2]=v;T6a(s,t,Aa,Ca,wa,Ga,ya,Fa,Q,r);if(l&2){wa=ea(g[s>>2]);Ca=ea(wa-ea(g[t>>2]));B=s+4|0;wa=ea(g[B>>2]);D=t+4|0;Aa=ea(wa-ea(g[D>>2]));c=s+8|0;wa=ea(g[c>>2]);y=t+8|0;v=ea(wa-ea(g[y>>2]));g[k>>2]=Ca;ka=k+4|0;g[ka>>2]=Aa;a=k+8|0;g[a>>2]=v;wa=ea(T(ea(ea(v*v)+ea(ea(Ca*Ca)+ea(Aa*Aa)))));if(wa>ea(0.0)){x=ea(ea(1.0)/wa);g[k>>2]=ea(Ca*x);g[ka>>2]=ea(Aa*x);g[a>>2]=ea(v*x)}if(wa<ea(.00100000005)){wa=ea(g[G>>2]);x=ea(Fa*wa);v=ea(g[I>>2]);Aa=ea(x-ea(ya*v));x=ea(Ga*v);v=ea(g[r>>2]);Ca=ea(x-ea(Fa*v));Fa=ea(ea(ya*v)-ea(Ga*wa));g[k>>2]=Aa;g[ka>>2]=Ca;g[a>>2]=Fa;wa=ea(T(ea(ea(Fa*Fa)+ea(ea(Aa*Aa)+ea(Ca*Ca)))));if(wa>ea(0.0)){Ga=ea(ea(1.0)/wa);g[k>>2]=ea(Aa*Ga);g[ka>>2]=ea(Ca*Ga);g[a>>2]=ea(Fa*Ga)}if(wa<ea(.00100000005)?(wa=ea(g[P>>2]),Ga=ea(g[O>>2]),Fa=ea(wa-Ga),wa=ea(g[X>>2]),Ca=ea(g[N>>2]),Aa=ea(wa-Ca),wa=ea(g[_>>2]),v=ea(g[U>>2]),T6a(s,t,Ga,Ca,v,Fa,Aa,ea(wa-v),Q,r),v=ea(g[s>>2]),wa=ea(v-ea(g[t>>2])),v=ea(g[B>>2]),Aa=ea(v-ea(g[D>>2])),v=ea(g[c>>2]),Fa=ea(v-ea(g[y>>2])),g[k>>2]=wa,g[ka>>2]=Aa,g[a>>2]=Fa,v=ea(T(ea(ea(Fa*Fa)+ea(ea(wa*wa)+ea(Aa*Aa))))),v>ea(0.0)):0){Ca=ea(ea(1.0)/v);g[k>>2]=ea(wa*Ca);g[ka>>2]=ea(Aa*Ca);g[a>>2]=ea(Fa*Ca)}}b[m>>1]=e[m>>1]|0|2}if(l&1){Ca=ea(g[w>>2]);Fa=ea(g[s>>2]);Aa=ea(g[s+4>>2]);wa=ea(Ca*Fa);Fa=ea(Ca*Aa);Aa=ea(Ca*ea(g[s+8>>2]));v=ea(g[u>>2]);Ga=ea(g[t>>2]);ya=ea(g[t+4>>2]);x=ea(ea(1.0)/ea(Ca+v));Ca=ea(x*ea(Fa+ea(v*ya)));ya=ea(x*ea(Aa+ea(v*ea(g[t+8>>2]))));g[j>>2]=ea(ea(wa+ea(v*Ga))*x);g[j+4>>2]=Ca;g[j+8>>2]=ya;b[m>>1]=e[m>>1]|0|1}}g[h>>2]=ua;S=1;i=n;return S|0}function XOa(a,d,e,f,h,j,k,l,m,n,o,p,q,r){a=a|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=0,P=Im,Q=Im,R=0,U=Im,V=0,W=Im,X=Im,Y=0,Z=Im,_=0,$=Im,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=Im,Kc=0,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=Im,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=Im,_d=Im,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=Im,je=Im,ke=Im;s=i;i=i+624|0;t=s+272|0;u=s+260|0;v=s+288|0;w=s+276|0;x=s+248|0;y=s+564|0;z=s+312|0;A=s+164|0;B=s+128|0;C=s+576|0;D=s+300|0;E=s+32|0;F=s+48|0;G=s;H=s+16|0;I=s+96|0;J=s+80|0;K=s+64|0;L=s+112|0;if(!a){M=0;i=s;return M|0}N=ea(g[e>>2]);O=e+12|0;P=ea(g[O>>2]);Q=ea(N+P);R=e+4|0;U=ea(g[R>>2]);V=e+16|0;W=ea(g[V>>2]);X=ea(U+W);Y=e+8|0;Z=ea(g[Y>>2]);_=e+20|0;$=ea(g[_>>2]);aa=ea(X*ea(.5));X=ea(ea(Z+$)*ea(.5));g[u>>2]=ea(Q*ea(.5));ba=u+4|0;g[ba>>2]=aa;ca=u+8|0;g[ca>>2]=X;do if(!(b[p>>1]&16)){X=ea(W-U);aa=ea($-Z);g[v>>2]=ea(P-N);g[v+4>>2]=X;g[v+8>>2]=aa;aa=ea(g[e+24>>2]);X=ea(aa*aa);da=w+4|0;fa=w+8|0;ga=x+4|0;ha=x+8|0;ia=f+4|0;ja=f+8|0;a:do if(q){ka=0;while(1){la=d+(ka*36|0)|0;aa=ea(g[d+(ka*36|0)+12>>2]);Q=ea(g[la>>2]);ma=ea(aa-Q);aa=ea(g[d+(ka*36|0)+16>>2]);na=ea(g[d+(ka*36|0)+4>>2]);oa=ea(aa-na);aa=ea(g[d+(ka*36|0)+20>>2]);pa=ea(g[d+(ka*36|0)+8>>2]);qa=ea(aa-pa);g[w>>2]=ma;g[da>>2]=oa;g[fa>>2]=qa;qa=ea(ea(g[d+(ka*36|0)+24>>2])-Q);Q=ea(ea(g[d+(ka*36|0)+28>>2])-na);na=ea(ea(g[d+(ka*36|0)+32>>2])-pa);g[x>>2]=qa;g[ga>>2]=Q;g[ha>>2]=na;if(ea(POa(e,v,la,w,x,0,0,0))<=X){ra=ka;break a}ka=ka+1|0;if(ka>>>0>=a>>>0){sa=10;break}}}else{ka=0;while(1){la=d+(ka*36|0)|0;na=ea(g[d+(ka*36|0)+12>>2]);Q=ea(g[la>>2]);qa=ea(na-Q);na=ea(g[d+(ka*36|0)+16>>2]);pa=ea(g[d+(ka*36|0)+4>>2]);oa=ea(na-pa);na=ea(g[d+(ka*36|0)+20>>2]);ma=ea(g[d+(ka*36|0)+8>>2]);aa=ea(na-ma);na=ea(ea(g[d+(ka*36|0)+24>>2])-Q);Q=ea(ea(g[d+(ka*36|0)+28>>2])-pa);pa=ea(ea(g[d+(ka*36|0)+32>>2])-ma);ma=ea(ea(qa*Q)-ea(oa*na));ta=ea(ea(aa*na)-ea(qa*pa));ua=ea(ea(oa*pa)-ea(aa*Q));va=ea(ua*ea(g[f>>2]));ua=ea(va+ea(ta*ea(g[ia>>2])));if(!(ea(ua+ea(ma*ea(g[ja>>2])))>ea(0.0))?(g[w>>2]=qa,g[da>>2]=oa,g[fa>>2]=aa,g[x>>2]=na,g[ga>>2]=Q,g[ha>>2]=pa,ea(POa(e,v,la,w,x,0,0,0))<=X):0){ra=ka;break a}ka=ka+1|0;if(ka>>>0>=a>>>0){sa=10;break}}}while(0);if((sa|0)==10){X=ea(g[e>>2]);pa=ea(g[O>>2]);Q=ea(g[R>>2]);na=ea(g[V>>2]);aa=ea(g[Y>>2]);wa=X;xa=pa;ya=Q;za=na;Aa=aa;Ba=ea(g[_>>2]);break}c[o>>2]=ra;g[l>>2]=ea(0.0);aa=ea(-ea(g[f>>2]));na=ea(-ea(g[ia>>2]));Q=ea(-ea(g[ja>>2]));g[m>>2]=aa;g[m+4>>2]=na;g[m+8>>2]=Q;b[k>>1]=6;M=1;i=s;return M|0}else{wa=N;xa=P;ya=U;za=W;Aa=Z;Ba=$}while(0);$=ea(ea(wa-xa)*ea(.5));xa=ea(ea(ya-za)*ea(.5));za=ea(ea(Aa-Ba)*ea(.5));Ba=ea(T(ea(ea(ea($*$)+ea(xa*xa))+ea(za*za))));if(Ba!=ea(0.0)){Aa=ea(ea(1.0)/Ba);ya=ea($*Aa);wa=ea(xa*Aa);Z=ea(za*Aa);Aa=ea(g[f>>2]);W=ea(ya*Aa);ra=f+4|0;ya=ea(g[ra>>2]);U=ea(W+ea(wa*ya));x=f+8|0;wa=ea(g[x>>2]);if(ea(S(ea(U+ea(Z*wa))))<ea(.999989986)){c[o>>2]=-1;if(!j)Ca=0;else Ca=c[j>>2]|0;Z=ea(g[e+24>>2]);U=ea(ea(g[u>>2])*Aa);W=ea(U+ea(ea(g[ba>>2])*ya));U=ea(W+ea(ea(g[ca>>2])*wa));w=(r|0)==0;v=z+4|0;p=z+8|0;ha=z+12|0;ga=z+16|0;fa=z+20|0;da=z+24|0;ka=z+28|0;la=z+32|0;Da=A+4|0;Ea=A+8|0;Fa=z+36|0;Ga=z+40|0;Ha=z+44|0;Ia=z+48|0;Ja=z+52|0;Ka=z+56|0;La=z+60|0;Ma=z+64|0;Na=z+68|0;Oa=A+12|0;Pa=A+16|0;Qa=A+20|0;Ra=z+72|0;Sa=z+76|0;Ta=z+80|0;Ua=z+84|0;Va=z+88|0;Wa=z+92|0;Xa=z+96|0;Ya=z+100|0;Za=z+104|0;_a=A+24|0;$a=A+28|0;ab=A+32|0;bb=z+108|0;cb=z+112|0;db=z+116|0;eb=z+120|0;fb=z+124|0;gb=z+128|0;hb=z+132|0;ib=z+136|0;jb=z+140|0;kb=A+36|0;lb=A+40|0;mb=A+44|0;nb=z+144|0;ob=z+148|0;pb=z+152|0;qb=z+156|0;rb=z+160|0;sb=z+164|0;tb=z+168|0;ub=z+172|0;vb=z+176|0;wb=A+48|0;xb=A+52|0;yb=A+56|0;zb=z+180|0;Ab=z+184|0;Bb=z+188|0;Cb=z+192|0;Db=z+196|0;Eb=z+200|0;Fb=z+204|0;Gb=z+208|0;Hb=z+212|0;Ib=A+60|0;Jb=A+64|0;Kb=A+68|0;Lb=z+216|0;Mb=z+220|0;Nb=z+224|0;Ob=z+228|0;Pb=z+232|0;Qb=z+236|0;Rb=z+240|0;Sb=z+244|0;Tb=z+248|0;Ub=A+72|0;Vb=A+76|0;Wb=A+80|0;Xb=B+4|0;Yb=B+8|0;Zb=B+12|0;_b=B+16|0;$b=B+20|0;ac=B+24|0;bc=B+28|0;cc=B+32|0;dc=r+36|0;ec=r+40|0;fc=r+44|0;gc=r+4|0;hc=r+8|0;ic=r+12|0;jc=r+16|0;kc=r+20|0;lc=r+24|0;mc=r+28|0;nc=r+32|0;oc=C+4|0;pc=C+8|0;qc=C+12|0;rc=C+16|0;sc=C+20|0;tc=C+24|0;uc=C+28|0;vc=C+32|0;wc=D+4|0;xc=D+8|0;yc=r+48|0;W=ea(0.0);P=h;zc=0;while(1){if(!zc)Ac=Ca;else Ac=(zc|0)==(Ca|0)?0:zc;Bc=d+(Ac*36|0)+12|0;N=ea(g[Bc>>2]);Cc=d+(Ac*36|0)|0;Q=ea(g[Cc>>2]);na=ea(N-Q);Dc=d+(Ac*36|0)+16|0;aa=ea(g[Dc>>2]);Ec=d+(Ac*36|0)+4|0;pa=ea(g[Ec>>2]);X=ea(aa-pa);Fc=d+(Ac*36|0)+20|0;oa=ea(g[Fc>>2]);Gc=d+(Ac*36|0)+8|0;qa=ea(g[Gc>>2]);ma=ea(oa-qa);Hc=d+(Ac*36|0)+24|0;ua=ea(g[Hc>>2]);ta=ea(ua-Q);Ic=d+(Ac*36|0)+28|0;va=ea(g[Ic>>2]);Jc=ea(va-pa);Kc=d+(Ac*36|0)+32|0;Lc=ea(g[Kc>>2]);Mc=ea(Lc-qa);Nc=ea(ea(X*Mc)-ea(ma*Jc));Oc=ea(ea(ma*ta)-ea(na*Mc));Mc=ea(ea(na*Jc)-ea(X*ta));if(!q?(ta=ea(Nc*ea(g[f>>2])),X=ea(ta+ea(Oc*ea(g[ra>>2]))),ea(X+ea(Mc*ea(g[x>>2])))>ea(0.0)):0){Pc=P;Qc=W}else sa=22;b:do if((sa|0)==22){sa=0;if(w){Rc=Q;Sc=pa;Tc=qa;Uc=N;Vc=aa;Wc=oa;Xc=ua;Yc=va;Zc=Lc}else{X=ea(g[dc>>2]);ta=ea(Q-X);Jc=ea(g[ec>>2]);na=ea(pa-Jc);ma=ea(g[fc>>2]);_c=ea(qa-ma);$c=ea(g[r>>2]);ad=ea(ta*$c);bd=ea(g[gc>>2]);cd=ea(ad+ea(na*bd));ad=ea(g[hc>>2]);dd=ea(cd+ea(_c*ad));cd=ea(g[ic>>2]);ed=ea(ta*cd);fd=ea(g[jc>>2]);gd=ea(ed+ea(na*fd));ed=ea(g[kc>>2]);hd=ea(gd+ea(_c*ed));gd=ea(g[lc>>2]);id=ea(ta*gd);ta=ea(g[mc>>2]);jd=ea(id+ea(na*ta));na=ea(g[nc>>2]);id=ea(jd+ea(_c*na));g[C>>2]=dd;g[oc>>2]=hd;g[pc>>2]=id;id=ea(N-X);hd=ea(aa-Jc);dd=ea(oa-ma);_c=ea(ea(ea(id*cd)+ea(hd*fd))+ea(dd*ed));jd=ea(ea(ea(id*gd)+ea(hd*ta))+ea(dd*na));g[qc>>2]=ea(ea(ea(id*$c)+ea(hd*bd))+ea(dd*ad));g[rc>>2]=_c;g[sc>>2]=jd;jd=ea(ua-X);X=ea(va-Jc);Jc=ea(Lc-ma);ma=ea(ea(ea(jd*cd)+ea(X*fd))+ea(Jc*ed));ed=ea(ea(ea(jd*gd)+ea(X*ta))+ea(Jc*na));g[tc>>2]=ea(ea(ea(jd*$c)+ea(X*bd))+ea(Jc*ad));g[uc>>2]=ma;g[vc>>2]=ed;g[D>>2]=ea(0.0);g[wc>>2]=ea(0.0);g[xc>>2]=ea(0.0);if(!(XPa(D,yc,C,qc,tc)|0)){Pc=P;Qc=W;break}ed=ea(g[Cc>>2]);ma=ea(g[Ec>>2]);ad=ea(g[Gc>>2]);Jc=ea(g[Bc>>2]);bd=ea(g[Dc>>2]);X=ea(g[Fc>>2]);$c=ea(g[Hc>>2]);jd=ea(g[Ic>>2]);Rc=ed;Sc=ma;Tc=ad;Uc=Jc;Vc=bd;Wc=X;Xc=$c;Yc=jd;Zc=ea(g[Kc>>2])}jd=ea($+Rc);$c=ea(xa+Sc);X=ea(za+Tc);bd=ea($+Uc);Jc=ea(xa+Vc);ad=ea(za+Wc);ma=ea($+Xc);ed=ea(xa+Yc);na=ea(za+Zc);ta=ea(Rc-$);gd=ea(Sc-xa);fd=ea(Tc-za);cd=ea(Uc-$);_c=ea(Vc-xa);dd=ea(Wc-za);hd=ea(Xc-$);id=ea(Yc-xa);kd=ea(Zc-za);if(!(ea(ea(za*Mc)+ea(ea($*Nc)+ea(xa*Oc)))>=ea(0.0))){g[z>>2]=ta;g[v>>2]=gd;g[p>>2]=fd;g[ha>>2]=cd;g[ga>>2]=_c;g[fa>>2]=dd;g[da>>2]=hd;g[ka>>2]=id;g[la>>2]=kd;ld=ea(cd-ta);md=ea(_c-gd);nd=ea(dd-fd);od=ea(hd-ta);pd=ea(id-gd);qd=ea(kd-fd);rd=ea(ea(ld*pd)-ea(md*od));sd=ea(ea(nd*od)-ea(ld*qd));td=ea(ea(md*qd)-ea(nd*pd))}else{g[z>>2]=jd;g[v>>2]=$c;g[p>>2]=X;g[ha>>2]=bd;g[ga>>2]=Jc;g[fa>>2]=ad;g[da>>2]=ma;g[ka>>2]=ed;g[la>>2]=na;pd=ea(bd-jd);nd=ea(Jc-$c);qd=ea(ad-X);md=ea(ma-jd);ld=ea(ed-$c);od=ea(na-X);rd=ea(ea(pd*ld)-ea(nd*md));sd=ea(ea(qd*md)-ea(pd*od));td=ea(ea(nd*od)-ea(qd*ld))}g[A>>2]=td;g[Da>>2]=sd;g[Ea>>2]=rd;g[Fa>>2]=cd;g[Ga>>2]=_c;g[Ha>>2]=dd;g[Ia>>2]=bd;g[Ja>>2]=Jc;g[Ka>>2]=ad;g[La>>2]=ma;g[Ma>>2]=ed;g[Na>>2]=na;ld=ea(bd-cd);qd=ea(Jc-_c);od=ea(ad-dd);nd=ea(ma-cd);pd=ea(ed-_c);md=ea(na-dd);ud=ea(ea(qd*md)-ea(od*pd));vd=ea(ea(od*nd)-ea(ld*md));od=ea(ea(ld*pd)-ea(qd*nd));qd=ea(g[f>>2]);ld=ea(qd*ud);wd=ea(g[ra>>2]);xd=ea(ld+ea(wd*vd));ld=ea(g[x>>2]);if(ea(ea(od*ld)+xd)>ea(0.0)){g[Ia>>2]=ma;g[Ja>>2]=ed;g[Ka>>2]=na;g[La>>2]=bd;g[Ma>>2]=Jc;g[Na>>2]=ad;yd=ea(-ud);zd=ea(-vd);Ad=ea(-od)}else{yd=ud;zd=vd;Ad=od}g[Oa>>2]=yd;g[Pa>>2]=zd;g[Qa>>2]=Ad;g[Ra>>2]=cd;g[Sa>>2]=_c;g[Ta>>2]=dd;g[Ua>>2]=ma;g[Va>>2]=ed;g[Wa>>2]=na;g[Xa>>2]=hd;g[Ya>>2]=id;g[Za>>2]=kd;od=ea(hd-cd);vd=ea(id-_c);ud=ea(kd-dd);xd=ea(ea(pd*ud)-ea(md*vd));Bd=ea(ea(md*od)-ea(nd*ud));ud=ea(ea(nd*vd)-ea(pd*od));if(ea(ea(ud*ld)+ea(ea(qd*xd)+ea(wd*Bd)))>ea(0.0)){g[Ua>>2]=hd;g[Va>>2]=id;g[Wa>>2]=kd;g[Xa>>2]=ma;g[Ya>>2]=ed;g[Za>>2]=na;Cd=ea(-xd);Dd=ea(-Bd);Ed=ea(-ud)}else{Cd=xd;Dd=Bd;Ed=ud}g[_a>>2]=Cd;g[$a>>2]=Dd;g[ab>>2]=Ed;g[bb>>2]=ta;g[cb>>2]=gd;g[db>>2]=fd;g[eb>>2]=hd;g[fb>>2]=id;g[gb>>2]=kd;g[hb>>2]=ma;g[ib>>2]=ed;g[jb>>2]=na;ud=ea(hd-ta);Bd=ea(id-gd);xd=ea(kd-fd);od=ea(ma-ta);pd=ea(ed-gd);vd=ea(na-fd);nd=ea(ea(Bd*vd)-ea(xd*pd));md=ea(ea(xd*od)-ea(ud*vd));xd=ea(ea(ud*pd)-ea(Bd*od));if(ea(ea(xd*ld)+ea(ea(qd*nd)+ea(wd*md)))>ea(0.0)){g[eb>>2]=ma;g[fb>>2]=ed;g[gb>>2]=na;g[hb>>2]=hd;g[ib>>2]=id;g[jb>>2]=kd;Fd=ea(-nd);Gd=ea(-md);Hd=ea(-xd)}else{Fd=nd;Gd=md;Hd=xd}g[kb>>2]=Fd;g[lb>>2]=Gd;g[mb>>2]=Hd;g[nb>>2]=ta;g[ob>>2]=gd;g[pb>>2]=fd;g[qb>>2]=ma;g[rb>>2]=ed;g[sb>>2]=na;g[tb>>2]=jd;g[ub>>2]=$c;g[vb>>2]=X;xd=ea(jd-ta);md=ea($c-gd);nd=ea(X-fd);kd=ea(ea(pd*nd)-ea(vd*md));id=ea(ea(vd*xd)-ea(od*nd));nd=ea(ea(od*md)-ea(pd*xd));if(ea(ea(nd*ld)+ea(ea(qd*kd)+ea(wd*id)))>ea(0.0)){g[qb>>2]=jd;g[rb>>2]=$c;g[sb>>2]=X;g[tb>>2]=ma;g[ub>>2]=ed;g[vb>>2]=na;Id=ea(-kd);Jd=ea(-id);Kd=ea(-nd)}else{Id=kd;Jd=id;Kd=nd}g[wb>>2]=Id;g[xb>>2]=Jd;g[yb>>2]=Kd;g[zb>>2]=jd;g[Ab>>2]=$c;g[Bb>>2]=X;g[Cb>>2]=bd;g[Db>>2]=Jc;g[Eb>>2]=ad;g[Fb>>2]=cd;g[Gb>>2]=_c;g[Hb>>2]=dd;nd=ea(bd-jd);id=ea(Jc-$c);kd=ea(ad-X);na=ea(cd-jd);ed=ea(_c-$c);ma=ea(dd-X);xd=ea(ea(id*ma)-ea(kd*ed));pd=ea(ea(kd*na)-ea(nd*ma));kd=ea(ea(nd*ed)-ea(id*na));if(ea(ea(kd*ld)+ea(ea(qd*xd)+ea(wd*pd)))>ea(0.0)){g[Cb>>2]=cd;g[Db>>2]=_c;g[Eb>>2]=dd;g[Fb>>2]=bd;g[Gb>>2]=Jc;g[Hb>>2]=ad;Ld=ea(-xd);Md=ea(-pd);Nd=ea(-kd)}else{Ld=xd;Md=pd;Nd=kd}g[Ib>>2]=Ld;g[Jb>>2]=Md;g[Kb>>2]=Nd;g[Lb>>2]=jd;g[Mb>>2]=$c;g[Nb>>2]=X;g[Ob>>2]=cd;g[Pb>>2]=_c;g[Qb>>2]=dd;g[Rb>>2]=ta;g[Sb>>2]=gd;g[Tb>>2]=fd;kd=ea(ta-jd);jd=ea(gd-$c);$c=ea(fd-X);X=ea(ea(ed*$c)-ea(ma*jd));pd=ea(ea(ma*kd)-ea(na*$c));$c=ea(ea(na*jd)-ea(ed*kd));if(ea(ea($c*ld)+ea(ea(qd*X)+ea(wd*pd)))>ea(0.0)){g[Ob>>2]=ta;g[Pb>>2]=gd;g[Qb>>2]=fd;g[Rb>>2]=cd;g[Sb>>2]=_c;g[Tb>>2]=dd;Od=ea(-X);Pd=ea(-pd);Qd=ea(-$c)}else{Od=X;Pd=pd;Qd=$c}g[Ub>>2]=Od;g[Vb>>2]=Pd;g[Wb>>2]=Qd;$c=ea(T(ea(ea(Mc*Mc)+ea(ea(Nc*Nc)+ea(Oc*Oc)))));if($c>ea(0.0)){pd=ea(ea(1.0)/$c);Rd=ea(Nc*pd);Sd=ea(Oc*pd);Td=ea(Mc*pd)}else{Rd=Nc;Sd=Oc;Td=Mc}pd=qd;qd=sd;$c=wd;wd=rd;X=ld;ld=P;dd=W;Ud=0;while(1){Vd=z+(Ud*36|0)|0;Wd=A+(Ud*12|0)|0;_c=ea(g[Wd>>2]);Xd=A+(Ud*12|0)+4|0;Yd=A+(Ud*12|0)+8|0;do if(ea(ea(ea(_c*pd)+ea(qd*$c))+ea(wd*X))>ea(0.0)){Zd=ld;_d=dd}else{if(!(U6a(u,f,ld,Z,Vd)|0)){Zd=ld;_d=dd;break}cd=ea(pd*ea(g[Vd>>2]));$d=z+(Ud*36|0)+4|0;fd=ea(cd+ea($c*ea(g[$d>>2])));ae=z+(Ud*36|0)+8|0;cd=ea(fd+ea(X*ea(g[ae>>2])));be=z+(Ud*36|0)+12|0;fd=ea(pd*ea(g[be>>2]));ce=z+(Ud*36|0)+16|0;gd=ea(fd+ea($c*ea(g[ce>>2])));de=z+(Ud*36|0)+20|0;fd=ea(gd+ea(X*ea(g[de>>2])));ee=z+(Ud*36|0)+24|0;gd=ea(pd*ea(g[ee>>2]));fe=z+(Ud*36|0)+28|0;ta=ea(gd+ea($c*ea(g[fe>>2])));ge=z+(Ud*36|0)+32|0;gd=ea(ta+ea(X*ea(g[ge>>2])));ta=cd<fd?cd:fd;if((ta<gd?ta:gd)>ea(ea(Z+ea(U+ld))+ea(.00999999977))){Zd=ld;_d=dd;break}if(cd<U&fd<U&gd<U){Zd=ld;_d=dd;break}gd=ea(T(ea(ea(ea(_c*_c)+ea(qd*qd))+ea(wd*wd))));if(gd==ea(0.0)){Zd=ld;_d=dd;break}fd=ea(ea(1.0)/gd);g[Wd>>2]=ea(_c*fd);g[Xd>>2]=ea(fd*qd);g[Yd>>2]=ea(fd*wd);g[t>>2]=ea(1.0e4);he=(_Oa(Vd,Wd,u,Z,f,t)|0)^1;fd=ea(g[t>>2]);if(fd>h|he){Zd=ld;_d=dd;break}gd=ea(Rd*ea(g[f>>2]));cd=ea(gd+ea(Sd*ea(g[ra>>2])));gd=ea(ea(cd+ea(Td*ea(g[x>>2])))*ea(.00999999977));cd=ea(fd+gd);g[t>>2]=cd;if(cd>ld){Zd=ld;_d=dd;break}c[o>>2]=Ac;g[B>>2]=ea(g[Vd>>2]);g[Xb>>2]=ea(g[$d>>2]);g[Yb>>2]=ea(g[ae>>2]);g[Zb>>2]=ea(g[be>>2]);g[_b>>2]=ea(g[ce>>2]);g[$b>>2]=ea(g[de>>2]);g[ac>>2]=ea(g[ee>>2]);g[bc>>2]=ea(g[fe>>2]);g[cc>>2]=ea(g[ge>>2]);Zd=cd;_d=gd}while(0);Vd=Ud+1|0;if((Vd|0)==7){Pc=Zd;Qc=_d;break b}_c=ea(g[f>>2]);gd=ea(g[A+(Vd*12|0)+4>>2]);cd=ea(g[ra>>2]);fd=ea(g[A+(Vd*12|0)+8>>2]);pd=_c;qd=gd;$c=cd;wd=fd;X=ea(g[x>>2]);ld=Zd;dd=_d;Ud=Vd}}while(0);zc=zc+1|0;if((zc|0)==(a|0))break;else{W=Qc;P=Pc}}if((c[o>>2]|0)==-1){M=0;i=s;return M|0}P=ea(Pc-Qc);g[l>>2]=P;aPa(n,m,u,f,P,B);B=c[o>>2]|0;if((B|0)==-1){M=1;i=s;return M|0}P=ea(g[l>>2]);Qc=ea(P*ea(g[f>>2]));Pc=ea(P*ea(g[ra>>2]));W=ea(P*ea(g[x>>2]));P=ea(Qc+ea(g[e>>2]));_d=ea(Pc+ea(g[R>>2]));Zd=ea(W+ea(g[Y>>2]));g[G>>2]=P;g[G+4>>2]=_d;g[G+8>>2]=Zd;g[G+12>>2]=ea(0.0);Zd=ea(Qc+ea(g[O>>2]));Qc=ea(Pc+ea(g[V>>2]));Pc=ea(W+ea(g[_>>2]));g[H>>2]=Zd;g[H+4>>2]=Qc;g[H+8>>2]=Pc;g[H+12>>2]=ea(0.0);Pc=ea(g[d+(B*36|0)>>2]);Qc=ea(g[d+(B*36|0)+4>>2]);Zd=ea(g[d+(B*36|0)+8>>2]);g[I>>2]=Pc;g[I+4>>2]=Qc;g[I+8>>2]=Zd;g[I+12>>2]=ea(0.0);Zd=ea(g[d+(B*36|0)+12>>2]);Qc=ea(g[d+(B*36|0)+16>>2]);Pc=ea(g[d+(B*36|0)+20>>2]);g[J>>2]=Zd;g[J+4>>2]=Qc;g[J+8>>2]=Pc;g[J+12>>2]=ea(0.0);Pc=ea(g[d+(B*36|0)+24>>2]);Qc=ea(g[d+(B*36|0)+28>>2]);Zd=ea(g[d+(B*36|0)+32>>2]);g[K>>2]=Pc;g[K+4>>2]=Qc;g[K+8>>2]=Zd;g[K+12>>2]=ea(0.0);QOa(L,G,H,I,J,K,E,F);Zd=ea(g[F>>2]);Qc=ea(g[F+4>>2]);Pc=ea(g[F+8>>2]);g[n>>2]=Zd;g[n+4>>2]=Qc;g[n+8>>2]=Pc;b[k>>1]=7;M=1;i=s;return M|0}else{ie=Aa;je=ya;ke=wa}}else{wa=ea(g[f>>2]);ya=ea(g[f+4>>2]);ie=wa;je=ya;ke=ea(g[f+8>>2])}ya=ea(Ba*ie);ie=ea(Ba*je);je=ea(Ba*ke);ke=ea(ya+ea(g[u>>2]));ya=ea(ie+ea(g[ba>>2]));ie=ea(je+ea(g[ca>>2]));g[y>>2]=ke;g[y+4>>2]=ya;g[y+8>>2]=ie;M=$Oa(a,d,y,ea(g[e+24>>2]),f,h,j,n,m,l,o,k,q)|0;i=s;return M|0}function YOa(a,c,d,e,f,h,j,k){a=a|0;c=c|0;d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=Im,G=Im,H=Im,I=Im;l=i;i=i+64|0;m=l+44|0;n=l+16|0;o=l+8|0;p=l;q=c+24|0;r=ea(g[q>>2]);s=a+12|0;t=ea(r+ea(g[s>>2]));if((b[k>>1]&16)==0?ea(IOa(c,c+12|0,a,0))<ea(t*t):0){g[f>>2]=ea(0.0);r=ea(-ea(g[d>>2]));u=ea(-ea(g[d+4>>2]));v=ea(-ea(g[d+8>>2]));g[j>>2]=r;g[j+4>>2]=u;g[j+8>>2]=v;w=1;i=l;return w|0}v=ea(g[c>>2]);u=ea(g[c+12>>2]);r=ea(g[c+4>>2]);x=ea(g[c+16>>2]);if(v==u&r==x?(y=ea(g[c+8>>2]),y==ea(g[c+20>>2])):0){y=ea(g[s>>2]);z=ea(g[q>>2]);A=ea(g[d>>2]);B=ea(g[d+4>>2]);C=ea(-ea(B*e));B=ea(-ea(ea(g[d+8>>2])*e));g[m>>2]=ea(-ea(A*e));g[m+4>>2]=C;g[m+8>>2]=B;if(!(ZOa(a,y,c,z,m,f,j)|0)){w=0;i=l;return w|0}g[f>>2]=ea(ea(g[f>>2])*e);z=ea(g[s>>2]);y=ea(z*ea(g[j>>2]));B=ea(z*ea(g[j+4>>2]));C=ea(z*ea(g[j+8>>2]));z=ea(y+ea(g[a>>2]));y=ea(B+ea(g[a+4>>2]));B=ea(C+ea(g[a+8>>2]));g[h>>2]=z;g[h+4>>2]=y;g[h+8>>2]=B;w=1;i=l;return w|0}g[n>>2]=v;s=n+4|0;g[s>>2]=r;m=n+8|0;g[m>>2]=ea(g[c+8>>2]);k=n+12|0;g[k>>2]=u;D=n+16|0;g[D>>2]=x;E=n+20|0;g[E>>2]=ea(g[c+20>>2]);g[n+24>>2]=t;c=TPa(a,d,n,o)|0;if(!c){w=0;i=l;return w|0}t=ea(g[o>>2]);if((c|0)==1)F=t;else{x=ea(g[o+4>>2]);F=t<x?t:x}g[p>>2]=F;if(!(F>=ea(0.0))|!(F<=e)){w=0;i=l;return w|0}g[f>>2]=F;e=ea(g[d>>2]);x=ea(g[d+4>>2]);t=ea(F*e);e=ea(F*x);x=ea(F*ea(g[d+8>>2]));g[n>>2]=ea(ea(g[n>>2])-t);g[s>>2]=ea(ea(g[s>>2])-e);g[m>>2]=ea(ea(g[m>>2])-x);g[k>>2]=ea(ea(g[k>>2])-t);g[D>>2]=ea(ea(g[D>>2])-e);g[E>>2]=ea(ea(g[E>>2])-x);ea(IOa(n,n+12|0,a,p));x=ea(g[p>>2]);e=ea(g[k>>2]);t=ea(g[n>>2]);F=ea(e-t);e=ea(g[D>>2]);u=ea(g[s>>2]);r=ea(e-u);e=ea(g[E>>2]);v=ea(g[m>>2]);B=ea(t+ea(x*F));F=ea(u+ea(x*r));r=ea(v+ea(x*ea(e-v)));g[h>>2]=B;m=h+4|0;g[m>>2]=F;E=h+8|0;g[E>>2]=r;v=ea(B-ea(g[a>>2]));B=ea(F-ea(g[a+4>>2]));F=ea(r-ea(g[a+8>>2]));g[j>>2]=v;a=j+4|0;g[a>>2]=B;s=j+8|0;g[s>>2]=F;r=ea(T(ea(ea(F*F)+ea(ea(v*v)+ea(B*B)))));if(r>ea(0.0)){e=ea(ea(1.0)/r);r=ea(v*e);g[j>>2]=r;x=ea(B*e);g[a>>2]=x;u=ea(F*e);g[s>>2]=u;G=r;H=x;I=u}else{G=v;H=B;I=F}F=ea(g[q>>2]);B=ea(F*G);G=ea(F*H);H=ea(F*I);g[h>>2]=ea(ea(g[h>>2])-B);g[m>>2]=ea(ea(g[m>>2])-G);g[E>>2]=ea(ea(g[E>>2])-H);w=1;i=l;return w|0}function ZOa(a,b,c,d,e,f,h){a=a|0;b=ea(b);c=c|0;d=ea(d);e=e|0;f=f|0;h=h|0;var j=0,k=Im,l=Im,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=Im,H=Im,I=Im;j=i;k=ea(g[c>>2]);l=ea(k+ea(g[e>>2]));m=c+4|0;n=ea(g[m>>2]);o=e+4|0;p=ea(n+ea(g[o>>2]));q=c+8|0;r=ea(g[q>>2]);s=e+8|0;t=ea(r+ea(g[s>>2]));u=ea(g[a>>2]);v=a+4|0;w=ea(g[v>>2]);x=a+8|0;y=ea(g[x>>2]);z=ea(k-u);A=ea(n-w);B=ea(r-y);C=ea(ea(l-k)-ea(u-u));u=ea(ea(p-n)-ea(w-w));w=ea(ea(t-r)-ea(y-y));y=ea(b+d);d=ea(ea(ea(C*C)+ea(u*u))+ea(w*w));b=ea(ea(ea(ea(z*C)+ea(A*u))+ea(B*w))*ea(2.0));w=ea(ea(ea(ea(z*z)+ea(A*A))+ea(B*B))-ea(y*y));if(!(w<=ea(0.0)|d==ea(0.0))){y=ea(ea(b*b)-ea(w*ea(d*ea(4.0))));if(!(y>=ea(0.0))){D=0;i=j;return D|0}w=ea(T(ea(y)));y=ea(ea(1.0)/ea(d*ea(2.0)));d=ea(ea(w-b)*y);B=ea(ea(ea(-b)-w)*y);E=d>B;y=E?B:d;g[f>>2]=y;if((E?d:B)<ea(0.0)|y>ea(1.0)){D=0;i=j;return D|0}if(y==ea(0.0))F=6;else{B=ea(g[e>>2]);d=ea(g[o>>2]);w=ea(y*B);B=ea(y*d);d=ea(y*ea(g[s>>2]));y=ea(w+ea(g[c>>2]));w=ea(B+ea(g[m>>2]));B=ea(d+ea(g[q>>2]));d=ea(y-ea(g[a>>2]));y=ea(w-ea(g[v>>2]));w=ea(B-ea(g[x>>2]));g[h>>2]=d;g[h+4>>2]=y;g[h+8>>2]=w;G=d;H=y;I=w}}else{g[f>>2]=ea(0.0);F=6}if((F|0)==6){w=ea(-ea(g[e>>2]));y=ea(-ea(g[o>>2]));d=ea(-ea(g[s>>2]));g[h>>2]=w;g[h+4>>2]=y;g[h+8>>2]=d;G=w;H=y;I=d}d=ea(T(ea(ea(ea(G*G)+ea(H*H))+ea(I*I))));if(!(d>ea(0.0))){D=1;i=j;return D|0}y=ea(ea(1.0)/d);g[h>>2]=ea(G*y);g[h+4>>2]=ea(H*y);g[h+8>>2]=ea(I*y);D=1;i=j;return D|0}function _Oa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im;h=i;i=i+48|0;j=h+36|0;k=h+8|0;l=h;m=ea(ea(g[b>>2])*d);n=ea(ea(g[b+4>>2])*d);o=ea(ea(g[b+8>>2])*d);p=ea(g[e>>2]);q=ea(m*p);r=ea(g[e+4>>2]);s=ea(q+ea(n*r));q=ea(g[e+8>>2]);if(!(ea(s+ea(o*q))>=ea(0.0))){t=o;u=n;v=m}else{t=ea(-o);u=ea(-n);v=ea(-m)}m=ea(g[a>>2]);n=ea(g[a+4>>2]);o=ea(g[a+8>>2]);s=ea(g[a+12>>2]);w=ea(g[a+16>>2]);x=ea(g[a+20>>2]);y=ea(g[a+24>>2]);z=ea(g[a+28>>2]);A=ea(g[a+32>>2]);B=ea(s-m);C=ea(w-n);D=ea(x-o);E=ea(y-m);F=ea(z-n);G=ea(A-o);H=ea(ea(G*r)-ea(F*q));I=ea(ea(E*q)-ea(G*p));J=ea(ea(F*p)-ea(E*r));K=ea(ea(D*J)+ea(ea(B*H)+ea(C*I)));if(K>ea(-9.99999974e-06)&K<ea(9.99999974e-06)){L=0;i=h;return L|0}M=ea(g[c+8>>2]);N=ea(g[c+4>>2]);O=ea(ea(1.0)/K);K=ea(ea(ea(g[c>>2])-v)-m);v=ea(ea(N-u)-n);u=ea(ea(M-t)-o);t=ea(O*ea(ea(J*u)+ea(ea(I*v)+ea(H*K))));H=ea(ea(D*v)-ea(C*u));I=ea(ea(B*u)-ea(D*K));u=ea(ea(C*K)-ea(B*v));v=ea(O*ea(ea(q*u)+ea(ea(p*H)+ea(r*I))));b=t<ea(0.0);P=v<ea(0.0);Q=ea(t+v)>ea(1.0);if(!(b|t>ea(1.0)|P|Q)){r=ea(O*ea(ea(G*u)+ea(ea(E*H)+ea(F*I))));if(r<ea(0.0)){L=0;i=h;return L|0}g[f>>2]=r;L=1;i=h;return L|0}do if(b){if(P){r=ea(ea(ea(1.0)-t)-v);I=ea(ea(ea(t*s)+ea(v*y))+ea(r*m));H=ea(ea(ea(t*w)+ea(v*z))+ea(r*n));u=ea(ea(ea(t*x)+ea(v*A))+ea(r*o));r=ea(m-s);O=ea(n-w);p=ea(o-x);if(ea(ea(ea(r*ea(I-s))+ea(O*ea(H-w)))+ea(p*ea(u-x)))<ea(ea(ea(r*r)+ea(O*O))+ea(p*p))){R=1;S=0;break}p=ea(m-y);O=ea(n-z);r=ea(o-A);if(ea(ea(ea(p*ea(I-y))+ea(O*ea(H-z)))+ea(r*ea(u-A)))<ea(ea(ea(p*p)+ea(O*O))+ea(r*r))){R=2;S=0;break}else{T=0;U=17;break}}if(Q){r=ea(ea(ea(1.0)-t)-v);O=ea(ea(ea(t*s)+ea(v*y))+ea(r*m));p=ea(ea(ea(t*w)+ea(v*z))+ea(r*n));u=ea(ea(ea(t*x)+ea(v*A))+ea(r*o));if(!(ea(ea(ea(E*ea(O-m))+ea(F*ea(p-n)))+ea(G*ea(u-o)))<ea(ea(ea(E*E)+ea(F*F))+ea(G*G)))){r=ea(y-s);H=ea(z-w);I=ea(A-x);if(ea(ea(ea(r*ea(O-s))+ea(H*ea(p-w)))+ea(I*ea(u-x)))<ea(ea(ea(r*r)+ea(H*H))+ea(I*I))){R=1;S=2}else{T=2;U=17}}else{R=0;S=2}}else{R=2;S=0}}else{V=P^1;if(!(V|Q^1)){I=ea(ea(ea(1.0)-t)-v);H=ea(ea(ea(t*s)+ea(v*y))+ea(I*m));r=ea(ea(ea(t*w)+ea(v*z))+ea(I*n));u=ea(ea(ea(t*x)+ea(v*A))+ea(I*o));if(!(ea(ea(ea(B*ea(H-m))+ea(C*ea(r-n)))+ea(D*ea(u-o)))<ea(ea(ea(B*B)+ea(C*C))+ea(D*D)))){I=ea(s-y);p=ea(w-z);O=ea(x-A);if(ea(ea(ea(I*ea(H-y))+ea(p*ea(r-z)))+ea(O*ea(u-A)))<ea(ea(ea(I*I)+ea(p*p))+ea(O*O))){R=2;S=1}else{T=1;U=17}}else{R=0;S=1}}else{R=P?1:2;S=V&1}}while(0);if((U|0)==17){if(!(UPa(c,e,ea(3402823469999999843913219.0e14),a+(T*12|0)|0,d,j,0)|0)){L=0;i=h;return L|0}g[f>>2]=ea(g[j>>2]);L=1;i=h;return L|0}g[k>>2]=ea(g[a+(S*12|0)>>2]);g[k+4>>2]=ea(g[a+(S*12|0)+4>>2]);g[k+8>>2]=ea(g[a+(S*12|0)+8>>2]);g[k+12>>2]=ea(g[a+(R*12|0)>>2]);g[k+16>>2]=ea(g[a+(R*12|0)+4>>2]);g[k+20>>2]=ea(g[a+(R*12|0)+8>>2]);g[k+24>>2]=d;R=TPa(c,e,k,l)|0;if(!R){L=0;i=h;return L|0}d=ea(g[l>>2]);if((R|0)==1)W=d;else{A=ea(g[l+4>>2]);W=d<A?d:A}if(!(W>=ea(0.0))){L=0;i=h;return L|0}g[f>>2]=W;L=1;i=h;return L|0}function $Oa(a,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=Im,fa=0;r=i;i=i+48|0;s=r+36|0;t=r+24|0;u=r+12|0;v=r;if(!a){w=0;i=r;return w|0}if(!k)x=0;else x=c[k>>2]|0;y=ea(g[e>>2]);z=ea(y*ea(g[h>>2]));y=ea(g[e+4>>2]);k=h+4|0;A=ea(z+ea(y*ea(g[k>>2])));y=ea(g[e+8>>2]);B=h+8|0;z=ea(A+ea(y*ea(g[B>>2])));C=t+4|0;D=t+8|0;if(q){y=j;A=ea(0.0);q=0;E=-1;while(1){if(!q)F=x;else F=(q|0)==(x|0)?0:q;G=d+(F*36|0)|0;if(((((U6a(e,h,y,f,G)|0?(H=ea(g[G>>2]),I=ea(g[h>>2]),J=ea(H*I),K=ea(g[d+(F*36|0)+4>>2]),L=ea(g[k>>2]),M=ea(J+ea(K*L)),J=ea(g[d+(F*36|0)+8>>2]),N=ea(g[B>>2]),O=ea(M+ea(J*N)),M=ea(g[d+(F*36|0)+12>>2]),P=ea(I*M),Q=ea(g[d+(F*36|0)+16>>2]),R=ea(P+ea(L*Q)),P=ea(g[d+(F*36|0)+20>>2]),S=ea(R+ea(N*P)),R=ea(g[d+(F*36|0)+24>>2]),U=ea(I*R),I=ea(g[d+(F*36|0)+28>>2]),V=ea(U+ea(L*I)),L=ea(g[d+(F*36|0)+32>>2]),U=ea(V+ea(N*L)),N=O<S?O:S,!((N<U?N:U)>ea(ea(ea(z+y)+f)+ea(.00999999977)))):0)?!(O<z&S<z&U<z):0)?(U=ea(M-H),M=ea(Q-K),Q=ea(P-J),P=ea(R-H),H=ea(I-K),K=ea(L-J),J=ea(ea(M*K)-ea(Q*H)),L=ea(ea(Q*P)-ea(U*K)),K=ea(ea(U*H)-ea(M*P)),g[t>>2]=J,g[C>>2]=L,g[D>>2]=K,P=ea(T(ea(ea(K*K)+ea(ea(J*J)+ea(L*L))))),!(ea(P*ea(.5))==ea(0.0))):0)?(M=ea(ea(1.0)/P),g[t>>2]=ea(M*J),g[C>>2]=ea(M*L),g[D>>2]=ea(M*K),g[s>>2]=ea(1.0e4),W=(_Oa(G,t,e,f,h,s)|0)^1,K=ea(g[s>>2]),!(K>j|W)):0)?(M=ea(g[t>>2]),L=ea(M*ea(g[h>>2])),M=ea(g[C>>2]),J=ea(L+ea(M*ea(g[k>>2]))),M=ea(g[D>>2]),L=ea(ea(J+ea(M*ea(g[B>>2])))*ea(.00999999977)),M=ea(K+L),g[s>>2]=M,!(M>y)):0){X=M;Y=L;Z=F}else{X=y;Y=A;Z=E}q=q+1|0;if((q|0)==(a|0)){_=Y;$=Z;aa=X;break}else{y=X;A=Y;E=Z}}}else{Y=j;A=ea(0.0);Z=0;E=-1;while(1){if(!Z)ba=x;else ba=(Z|0)==(x|0)?0:Z;q=d+(ba*36|0)|0;if((((((U6a(e,h,Y,f,q)|0?(X=ea(g[q>>2]),y=ea(g[h>>2]),L=ea(X*y),M=ea(g[d+(ba*36|0)+4>>2]),K=ea(g[k>>2]),J=ea(L+ea(M*K)),L=ea(g[d+(ba*36|0)+8>>2]),P=ea(g[B>>2]),H=ea(J+ea(L*P)),J=ea(g[d+(ba*36|0)+12>>2]),U=ea(y*J),Q=ea(g[d+(ba*36|0)+16>>2]),I=ea(U+ea(K*Q)),U=ea(g[d+(ba*36|0)+20>>2]),R=ea(I+ea(P*U)),I=ea(g[d+(ba*36|0)+24>>2]),S=ea(y*I),O=ea(g[d+(ba*36|0)+28>>2]),N=ea(S+ea(K*O)),S=ea(g[d+(ba*36|0)+32>>2]),V=ea(N+ea(P*S)),N=H<R?H:R,!((N<V?N:V)>ea(ea(ea(z+Y)+f)+ea(.00999999977)))):0)?!(H<z&R<z&V<z):0)?(V=ea(J-X),J=ea(Q-M),Q=ea(U-L),U=ea(I-X),X=ea(O-M),M=ea(S-L),L=ea(ea(J*M)-ea(Q*X)),S=ea(ea(Q*U)-ea(V*M)),M=ea(ea(V*X)-ea(J*U)),g[t>>2]=L,g[C>>2]=S,g[D>>2]=M,U=ea(T(ea(ea(M*M)+ea(ea(L*L)+ea(S*S))))),!(ea(U*ea(.5))==ea(0.0))):0)?!(ea(ea(ea(L*y)+ea(S*K))+ea(M*P))>ea(0.0)):0)?(P=ea(ea(1.0)/U),g[t>>2]=ea(P*L),g[C>>2]=ea(P*S),g[D>>2]=ea(P*M),g[s>>2]=ea(1.0e4),F=(_Oa(q,t,e,f,h,s)|0)^1,M=ea(g[s>>2]),!(M>j|F)):0)?(P=ea(g[t>>2]),S=ea(P*ea(g[h>>2])),P=ea(g[C>>2]),L=ea(S+ea(P*ea(g[k>>2]))),P=ea(g[D>>2]),S=ea(ea(L+ea(P*ea(g[B>>2])))*ea(.00999999977)),P=ea(M+S),g[s>>2]=P,!(P>Y)):0){ca=P;da=S;fa=ba}else{ca=Y;da=A;fa=E}Z=Z+1|0;if((Z|0)==(a|0)){_=da;$=fa;aa=ca;break}else{Y=ca;A=da;E=fa}}}if(($|0)==-1){w=0;i=r;return w|0}da=ea(aa-_);aPa(u,v,e,h,da,d+($*36|0)|0);g[l>>2]=ea(g[u>>2]);g[l+4>>2]=ea(g[u+4>>2]);g[l+8>>2]=ea(g[u+8>>2]);g[m>>2]=ea(g[v>>2]);g[m+4>>2]=ea(g[v+4>>2]);g[m+8>>2]=ea(g[v+8>>2]);g[n>>2]=da;c[o>>2]=$;b[p>>1]=7;w=1;i=r;return w|0}function aPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;h=i;i=i+32|0;j=h+20|0;k=h;l=ea(ea(g[d>>2])*e);m=ea(ea(g[d+4>>2])*e);n=ea(ea(g[d+8>>2])*e);e=ea(l+ea(g[c>>2]));l=ea(m+ea(g[c+4>>2]));m=ea(n+ea(g[c+8>>2]));g[j>>2]=e;c=j+4|0;g[c>>2]=l;d=j+8|0;g[d>>2]=m;JOa(k,j,f,f+12|0,f+24|0,h+16|0,h+12|0);m=ea(g[k>>2]);g[a>>2]=m;l=ea(g[k+4>>2]);g[a+4>>2]=l;e=ea(g[k+8>>2]);g[a+8>>2]=e;n=ea(ea(g[j>>2])-m);m=ea(ea(g[c>>2])-l);l=ea(ea(g[d>>2])-e);g[b>>2]=n;d=b+4|0;g[d>>2]=m;c=b+8|0;g[c>>2]=l;e=ea(T(ea(ea(l*l)+ea(ea(n*n)+ea(m*m)))));if(e>ea(0.0)){o=ea(ea(1.0)/e);g[b>>2]=ea(n*o);g[d>>2]=ea(m*o);g[c>>2]=ea(l*o)}if(!(e<ea(.00100000005))){i=h;return}e=ea(g[f+12>>2]);o=ea(g[f>>2]);l=ea(e-o);e=ea(g[f+16>>2]);m=ea(g[f+4>>2]);n=ea(e-m);e=ea(g[f+20>>2]);p=ea(g[f+8>>2]);q=ea(e-p);e=ea(ea(g[f+24>>2])-o);o=ea(ea(g[f+28>>2])-m);m=ea(ea(g[f+32>>2])-p);p=ea(ea(n*m)-ea(q*o));r=ea(ea(q*e)-ea(l*m));m=ea(ea(l*o)-ea(n*e));g[b>>2]=p;g[d>>2]=r;g[c>>2]=m;e=ea(T(ea(ea(m*m)+ea(ea(p*p)+ea(r*r)))));if(!(e>ea(0.0))){i=h;return}n=ea(ea(1.0)/e);g[b>>2]=ea(p*n);g[d>>2]=ea(r*n);g[c>>2]=ea(m*n);i=h;return}function bPa(a,b,e,f,h,j){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=0,C=Im,D=Im,E=0,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0;k=i;i=i+1360|0;l=k+368|0;m=k+192|0;n=k+1328|0;o=k+1340|0;p=k+16|0;q=k;r=k+352|0;s=k+160|0;t=k+176|0;u=k+1304|0;v=k+1208|0;w=k+392|0;x=k+384|0;y=b+48|0;z=ea(g[y>>2]);A=ea(-z);B=b+52|0;C=ea(g[B>>2]);D=ea(-C);E=b+56|0;F=ea(g[E>>2]);G=ea(-F);g[u>>2]=A;g[u+4>>2]=D;g[u+8>>2]=G;g[u+12>>2]=z;g[u+16>>2]=C;g[u+20>>2]=F;sLa(u,v);H=f+4|0;I=f+8|0;J=l+4|0;K=l+8|0;L=SKa()|0;M=0;do{N=d[L>>0]|0;F=ea(g[v+(N*12|0)>>2]);C=ea(g[v+(N*12|0)+4>>2]);z=ea(g[v+(N*12|0)+8>>2]);N=d[L+1>>0]|0;L=L+2|0;G=ea(g[v+(N*12|0)>>2]);D=ea(g[v+(N*12|0)+4>>2]);A=ea(g[v+(N*12|0)+8>>2]);O=ea(G-F);P=ea(D-C);Q=ea(A-z);R=ea(T(ea(ea(ea(O*O)+ea(P*P))+ea(Q*Q))));if(R>ea(0.0)){U=ea(ea(.00999999977)/R);R=ea(O*U);O=ea(P*U);P=ea(Q*U);V=ea(G+R);W=ea(F-R);X=ea(D+O);Y=ea(C-O);Z=ea(A+P);_=ea(z-P)}else{V=G;W=F;X=D;Y=C;Z=A;_=z}z=ea(g[540896+(M*12|0)>>2]);A=ea(g[f>>2]);C=ea(z*A);z=ea(g[540900+(M*12|0)>>2]);D=ea(g[H>>2]);F=ea(C+ea(z*D));z=ea(g[540904+(M*12|0)>>2]);C=ea(g[I>>2]);g[w+(M*68|0)+64>>2]=ea(F+ea(z*C));z=ea(V-W);F=ea(X-Y);G=ea(Z-_);g[l>>2]=z;g[J>>2]=F;g[K>>2]=G;P=ea(ea(F*C)-ea(G*D));O=ea(ea(G*A)-ea(z*C));C=ea(ea(z*D)-ea(F*A));g[w+(M*68|0)>>2]=P;g[w+(M*68|0)+4>>2]=O;g[w+(M*68|0)+8>>2]=C;g[w+(M*68|0)+12>>2]=ea(-ea(ea(_*C)+ea(ea(W*P)+ea(Y*O))));A=ea(S(ea(P)));P=ea(S(ea(O)));O=ea(S(ea(C)));if(!(P>A&P>O))if(O>A){$=0;aa=1}else{$=1;aa=2}else{$=2;aa=0}A=ea(g[l+($<<2)>>2]);O=ea(A*ea(g[f+(aa<<2)>>2]));A=ea(g[l+(aa<<2)>>2]);g[w+(M*68|0)+60>>2]=ea(ea(1.0)/ea(O-ea(A*ea(g[f+($<<2)>>2]))));g[w+(M*68|0)+16>>2]=W;g[w+(M*68|0)+20>>2]=Y;g[w+(M*68|0)+24>>2]=_;g[w+(M*68|0)+28>>2]=V;g[w+(M*68|0)+32>>2]=X;g[w+(M*68|0)+36>>2]=Z;g[w+(M*68|0)+40>>2]=z;g[w+(M*68|0)+44>>2]=F;g[w+(M*68|0)+48>>2]=G;c[w+(M*68|0)+52>>2]=$;c[w+(M*68|0)+56>>2]=aa;M=M+1|0}while((M|0)!=12);g[x>>2]=ea(3402823469999999843913219.0e14);if(TOa(j,u,v,w,f,h,a+16|0,a+28|0,x)|0){i=k;return}x=a+40|0;Z=ea(g[x>>2]);X=ea(g[e>>2]);V=ea(Z*X);h=e+4|0;_=ea(g[h>>2]);Y=ea(Z*_);f=e+8|0;W=ea(g[f>>2]);G=ea(V-ea(X*ea(.100000001)));X=ea(Y-ea(_*ea(.100000001)));_=ea(ea(Z*W)-ea(W*ea(.100000001)));W=ea(ea(g[j>>2])-G);Z=ea(ea(g[j+4>>2])-X);Y=ea(ea(g[j+8>>2])-_);V=ea(ea(g[j+12>>2])-G);F=ea(ea(g[j+16>>2])-X);z=ea(ea(g[j+20>>2])-_);A=ea(ea(g[j+24>>2])-G);G=ea(ea(g[j+28>>2])-X);X=ea(ea(g[j+32>>2])-_);j=p+64|0;c[p+80>>2]=7;w=p+20|0;v=p+36|0;g[p+48>>2]=ea(0.0);u=p+52|0;c[u+0>>2]=c[n+0>>2];c[u+4>>2]=c[n+4>>2];c[u+8>>2]=c[n+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];_=ea(ea(ea(Z+F)+G)*ea(.333332986));O=ea(ea(ea(Y+z)+X)*ea(.333332986));g[p>>2]=ea(ea(ea(W+V)+A)*ea(.333332986));g[p+4>>2]=_;g[p+8>>2]=O;g[p+12>>2]=ea(0.0);g[p+96>>2]=W;g[p+100>>2]=Z;g[p+104>>2]=Y;g[p+108>>2]=ea(0.0);g[p+112>>2]=V;g[p+116>>2]=F;g[p+120>>2]=z;g[p+124>>2]=ea(0.0);g[p+128>>2]=A;g[p+132>>2]=G;g[p+136>>2]=X;g[p+140>>2]=ea(0.0);g[p+16>>2]=ea(0.0);c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];g[p+32>>2]=ea(3402823469999999843913219.0e14);c[v+0>>2]=c[m+0>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];X=ea(g[y>>2]);G=ea(g[B>>2]);A=ea(g[E>>2]);E=m+64|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+80>>2]=3;B=m+20|0;c[B+0>>2]=c[o+0>>2];c[B+4>>2]=c[o+4>>2];c[B+8>>2]=c[o+8>>2];y=m+36|0;g[m+48>>2]=ea(0.0);v=m+52|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[E+0>>2]=c[l+0>>2];c[E+4>>2]=c[l+4>>2];c[E+8>>2]=c[l+8>>2];c[E+12>>2]=c[l+12>>2];g[m+144>>2]=X;g[m+148>>2]=G;g[m+152>>2]=A;g[m+156>>2]=ea(0.0);z=!(X<=G)?G:X;F=!(z<=A)?A:z;z=!(X>=G)?G:X;X=ea(F*ea(.150000006));G=ea((!(z>=A)?A:z)*ea(.0299999993));z=X>G?X:G;g[m+16>>2]=F>z?z:F;c[B+0>>2]=c[o+0>>2];c[B+4>>2]=c[o+4>>2];c[B+8>>2]=c[o+8>>2];g[m+32>>2]=ea(F*ea(.0500000007));c[y+0>>2]=c[n+0>>2];c[y+4>>2]=c[n+4>>2];c[y+8>>2]=c[n+8>>2];g[m+96>>2]=ea(1.0);n=m+100|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[m+116>>2]=ea(1.0);n=m+120|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[m+136>>2]=ea(1.0);g[m+140>>2]=ea(0.0);if(!(xPa(p,m,q,r,s,t)|0)){F=ea(g[r>>2]);z=ea(g[r+4>>2]);G=ea(g[r+8>>2]);X=ea(g[s>>2]);A=ea(g[s+4>>2]);V=ea(g[s+8>>2]);Y=ea(g[x>>2]);Z=ea(Y*ea(g[e>>2]));W=ea(Y*ea(g[h>>2]));O=ea(z+W);W=ea(G+ea(Y*ea(g[f>>2])));g[a+16>>2]=ea(F+Z);g[a+20>>2]=O;g[a+24>>2]=W;W=ea(-A);A=ea(-V);g[a+28>>2]=ea(-X);g[a+32>>2]=W;g[a+36>>2]=A;i=k;return}else{g[a+16>>2]=ea(g[b+36>>2]);g[a+20>>2]=ea(g[b+40>>2]);g[a+24>>2]=ea(g[b+44>>2]);A=ea(-ea(g[e>>2]));W=ea(-ea(g[h>>2]));X=ea(-ea(g[f>>2]));g[a+28>>2]=A;g[a+32>>2]=W;g[a+36>>2]=X;i=k;return}}function cPa(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;q=i;i=i+7152|0;r=q+6816|0;s=q+7136|0;t=q+6864|0;u=q+6960|0;v=q+7024|0;w=q+7104|0;x=q+7120|0;y=q+6944|0;z=q+6928|0;A=q+6832|0;B=q+7088|0;C=q;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;D=k&255;c[s>>2]=D;E=ea(g[b+32>>2]);F=ea(g[e+32>>2]);G=ea((E>F?F:E)*ea(.100000001));E=ea(G*G);c[y+0>>2]=c[r+0>>2];c[y+4>>2]=c[r+4>>2];c[y+8>>2]=c[r+8>>2];c[y+12>>2]=c[r+12>>2];c[z+0>>2]=c[r+0>>2];c[z+4>>2]=c[r+4>>2];c[z+8>>2]=c[r+8>>2];c[z+12>>2]=c[r+12>>2];if(!(k<<24>>24)){In[c[(c[f>>2]|0)+16>>2]&4095](q+6848|0,f);g[w>>2]=ea(1.0);g[w+4>>2]=ea(0.0);g[w+8>>2]=ea(0.0);g[w+12>>2]=ea(0.0);H=1;I=ea(3402823469999999843913219.0e14)}else{k=0;do{rn[c[(c[f>>2]|0)+8>>2]&127](f,d[h+k>>0]|0,d[j+k>>0]|0,t+(k<<4)|0,u+(k<<4)|0,v+(k<<4)|0);k=k+1|0}while((k|0)!=(D|0));k=c[s>>2]|0;j=D+-1|0;G=ea(g[t+(j<<4)>>2]);F=ea(g[t+(j<<4)+4>>2]);J=ea(g[t+(j<<4)+8>>2]);K=ea(g[t+(j<<4)+12>>2]);L=ea(g[u+(j<<4)>>2]);M=ea(g[u+(j<<4)+4>>2]);N=ea(g[u+(j<<4)+8>>2]);O=ea(g[u+(j<<4)+12>>2]);P=ea(G-L);Q=ea(F-M);R=ea(J-N);g[x>>2]=P;g[x+4>>2]=Q;g[x+8>>2]=R;g[x+12>>2]=ea(0.0);do if((k|0)==4)pPa(A,v,t,u,s,y,z);else if((k|0)==1){g[y>>2]=G;g[y+4>>2]=F;g[y+8>>2]=J;g[y+12>>2]=K;g[z>>2]=L;g[z+4>>2]=M;g[z+8>>2]=N;g[z+12>>2]=O;c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2]}else if((k|0)==3)V6a(A,v,v+16|0,x,v,t,u,s,y,z);else if((k|0)==2){S=ea(g[v>>2]);T=ea(g[v+4>>2]);U=ea(g[v+8>>2]);V=ea(P-S);W=ea(Q-T);X=ea(R-U);Y=ea(ea(ea(V*V)+ea(W*W))+ea(X*X));if(Y==ea(0.0)){c[s>>2]=1;c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[z+0>>2]=c[u+0>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];c[z+12>>2]=c[u+12>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];break}else{Z=ea(ea(ea(-ea(T*W))-ea(S*V))-ea(U*X));X=ea(g[t>>2]);U=ea(g[t+4>>2]);V=ea(g[t+8>>2]);S=ea(G-X);W=ea(F-U);T=ea(J-V);_=ea(g[u>>2]);$=ea(g[u+4>>2]);aa=ea(g[u+8>>2]);ba=ea(L-_);ca=ea(M-$);da=ea(N-aa);fa=ea(Z/Y);j=fa>ea(1.0);Y=j?ea(1.0):fa;j=Y>ea(0.0);fa=j?Y:ea(0.0);Y=ea(X+ea(S*fa));S=ea(U+ea(W*fa));W=ea(V+ea(T*fa));T=ea(_+ea(ba*fa));ba=ea($+ea(ca*fa));ca=ea(aa+ea(da*fa));g[y>>2]=Y;g[y+4>>2]=S;g[y+8>>2]=W;g[y+12>>2]=ea(0.0);g[z>>2]=T;g[z+4>>2]=ba;g[z+8>>2]=ca;g[z+12>>2]=ea(0.0);fa=ea(S-ba);ba=ea(W-ca);g[A>>2]=ea(Y-T);g[A+4>>2]=fa;g[A+8>>2]=ba;g[A+12>>2]=ea(0.0);break}}else{c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2]}while(0);c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];N=ea(g[w>>2]);M=ea(g[w+4>>2]);L=ea(g[w+8>>2]);J=ea(ea(ea(N*N)+ea(M*M))+ea(L*L));H=J>E;I=J}if(!H){c[C>>2]=0;ga=C+6672|0;c[ga>>2]=0;ha=C+6804|0;a[ha>>0]=0;ia=C+6805|0;a[ia>>0]=0;ja=C+6806|0;a[ja>>0]=0;ka=c[s>>2]|0;la=dPa(C,b,e,f,0,t,u,ka,l,m,n,o,p)|0;i=q;return la|0}H=w+4|0;A=w+8|0;x=v+4|0;k=v+8|0;j=t+4|0;D=t+8|0;h=u+4|0;r=u+8|0;ma=y+4|0;na=y+8|0;oa=y+12|0;pa=z+4|0;qa=z+8|0;ra=z+12|0;sa=B+4|0;ta=B+8|0;ua=B+12|0;va=v+16|0;J=I;do{wa=c[s>>2]|0;En[c[(c[f>>2]|0)+12>>2]&127](f,w,t+(wa<<4)|0,u+(wa<<4)|0,v+(wa<<4)|0);wa=c[s>>2]|0;c[s>>2]=wa+1;xa=v+(wa<<4)|0;ya=t+(wa<<4)|0;za=u+(wa<<4)|0;do if((wa|0)==2)V6a(B,v,va,xa,v,t,u,s,y,z);else if((wa|0)==1){I=ea(g[v>>2]);L=ea(g[x>>2]);M=ea(g[k>>2]);N=ea(g[xa>>2]);F=ea(g[v+20>>2]);G=ea(N-I);N=ea(F-L);F=ea(ea(g[v+24>>2])-M);R=ea(ea(ea(G*G)+ea(N*N))+ea(F*F));if(R==ea(0.0)){c[s>>2]=1;c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[z+0>>2]=c[u+0>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];c[z+12>>2]=c[u+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];break}else{Q=ea(ea(ea(-ea(L*N))-ea(I*G))-ea(M*F));F=ea(g[ya>>2]);M=ea(g[t+20>>2]);G=ea(g[t+24>>2]);I=ea(g[t>>2]);N=ea(g[j>>2]);L=ea(g[D>>2]);P=ea(F-I);F=ea(M-N);M=ea(G-L);G=ea(g[za>>2]);O=ea(g[u+20>>2]);K=ea(g[u+24>>2]);ba=ea(g[u>>2]);fa=ea(g[h>>2]);T=ea(g[r>>2]);Y=ea(G-ba);G=ea(O-fa);O=ea(K-T);K=ea(Q/R);Aa=K>ea(1.0);R=Aa?ea(1.0):K;Aa=R>ea(0.0);K=Aa?R:ea(0.0);R=ea(I+ea(P*K));P=ea(N+ea(F*K));F=ea(L+ea(M*K));M=ea(ba+ea(Y*K));Y=ea(fa+ea(G*K));G=ea(T+ea(O*K));g[y>>2]=R;g[ma>>2]=P;g[na>>2]=F;g[oa>>2]=ea(0.0);g[z>>2]=M;g[pa>>2]=Y;g[qa>>2]=G;g[ra>>2]=ea(0.0);K=ea(P-Y);Y=ea(F-G);g[B>>2]=ea(R-M);g[sa>>2]=K;g[ta>>2]=Y;g[ua>>2]=ea(0.0);break}}else if(!wa){c[y+0>>2]=c[ya+0>>2];c[y+4>>2]=c[ya+4>>2];c[y+8>>2]=c[ya+8>>2];c[y+12>>2]=c[ya+12>>2];c[z+0>>2]=c[za+0>>2];c[z+4>>2]=c[za+4>>2];c[z+8>>2]=c[za+8>>2];c[z+12>>2]=c[za+12>>2];c[B+0>>2]=c[xa+0>>2];c[B+4>>2]=c[xa+4>>2];c[B+8>>2]=c[xa+8>>2];c[B+12>>2]=c[xa+12>>2]}else if((wa|0)==3)pPa(B,v,t,u,s,y,z);else{c[B+0>>2]=c[xa+0>>2];c[B+4>>2]=c[xa+4>>2];c[B+8>>2]=c[xa+8>>2];c[B+12>>2]=c[xa+12>>2]}while(0);c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];Y=ea(g[w>>2]);K=ea(g[H>>2]);M=ea(g[A>>2]);R=J;J=ea(ea(ea(Y*Y)+ea(K*K))+ea(M*M))}while(J>E&R>J);c[C>>2]=0;ga=C+6672|0;c[ga>>2]=0;ha=C+6804|0;a[ha>>0]=0;ia=C+6805|0;a[ia>>0]=0;ja=C+6806|0;a[ja>>0]=0;ka=c[s>>2]|0;la=dPa(C,b,e,f,0,t,u,ka,l,m,n,o,p)|0;i=q;return la|0}function dPa(b,d,e,f,h,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im;h=i;i=i+272|0;r=h+16|0;s=h+176|0;t=h+256|0;u=h+80|0;v=h+128|0;w=h+160|0;x=h+192|0;y=h+224|0;z=h+32|0;A=h+240|0;B=h+260|0;C=h+48|0;D=h;E=h+64|0;F=h+144|0;G=h+208|0;H=h+112|0;I=h+96|0;g[r>>2]=ea(0.0);g[s>>2]=ea(3402823469999999843913219.0e14);J=b+272|0;c[J+0>>2]=c[j+0>>2];c[J+4>>2]=c[j+4>>2];c[J+8>>2]=c[j+8>>2];c[J+12>>2]=c[j+12>>2];J=b+288|0;K=j+16|0;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];c[J+12>>2]=c[K+12>>2];K=b+304|0;J=j+32|0;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];c[K+12>>2]=c[J+12>>2];J=b+320|0;K=j+48|0;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];c[J+12>>2]=c[K+12>>2];K=b+1296|0;c[K+0>>2]=c[k+0>>2];c[K+4>>2]=c[k+4>>2];c[K+8>>2]=c[k+8>>2];c[K+12>>2]=c[k+12>>2];K=b+1312|0;J=k+16|0;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];c[K+12>>2]=c[J+12>>2];J=b+1328|0;K=k+32|0;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];c[J+12>>2]=c[K+12>>2];K=b+1344|0;J=k+48|0;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];c[K+12>>2]=c[J+12>>2];c[t>>2]=0;c[b>>2]=0;do if((l|0)==4){J=ePa(b,0,1,2,r,s)|0;K=ePa(b,0,3,1,r,s)|0;k=ePa(b,0,2,3,r,s)|0;j=ePa(b,1,3,2,r,s)|0;if((J|0)==0|(K|0)==0|(k|0)==0|(j|0)==0){L=4;i=h;return L|0}if(!(c[b>>2]|0)){L=4;i=h;return L|0}else{c[J+40>>2]=K;a[J+52>>0]=2;c[K+48>>2]=J;a[K+54>>0]=0;c[J+44>>2]=j;a[J+53>>0]=2;c[j+48>>2]=J;a[j+54>>0]=1;c[J+48>>2]=k;a[J+54>>0]=0;c[k+40>>2]=J;a[k+52>>0]=2;c[K+40>>2]=k;a[K+52>>0]=2;c[k+48>>2]=K;a[k+54>>0]=0;c[K+44>>2]=j;a[K+53>>0]=0;c[j+40>>2]=K;a[j+52>>0]=1;c[k+44>>2]=j;a[k+53>>0]=1;c[j+44>>2]=k;a[j+53>>0]=1;c[t>>2]=4;M=ea(g[s>>2]);break}}else if((l|0)==3)if(gPa(b,0,0,f,t)|0)M=ea(3402823469999999843913219.0e14);else{L=4;i=h;return L|0}else if((l|0)==2)if(fPa(b,d,e,f,t)|0)M=ea(3402823469999999843913219.0e14);else{L=4;i=h;return L|0}else if((l|0)==1){L=4;i=h;return L|0}else M=ea(3402823469999999843913219.0e14);while(0);c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];c[u+12>>2]=c[s+12>>2];s=b+6676|0;l=b+6806|0;r=b+4|0;j=b+6416|0;k=b+6672|0;K=y+4|0;J=y+8|0;N=y+12|0;O=x+4|0;P=x+8|0;Q=u+4|0;R=b+6420|0;T=b+6804|0;U=b+6805|0;V=M;a:while(1){W=a[l>>0]|0;if(W<<24>>24){X=W;Y=W&255;do{Y=Y+-1|0;W=a[b+Y+6740>>0]|0;Z=a[T>>0]|0;if((W&255|0)==((Z&255)+-1|0))a[T>>0]=Z+-1<<24>>24;else{Z=a[U>>0]|0;a[U>>0]=Z+1<<24>>24;a[b+(Z&255)+6676>>0]=W}X=X+-1<<24>>24}while(X<<24>>24!=0)}a[l>>0]=0;X=(c[b>>2]|0)+-1|0;c[b>>2]=X;_=c[r>>2]|0;Y=c[b+(X<<2)+4>>2]|0;b:do if((X|0)>1){W=c[Y+12>>2]|0;Z=1;$=0;while(1){aa=Z+1|0;ba=(((aa|0)<(X|0)?(c[(c[b+(aa<<2)+4>>2]|0)+12>>2]|0)>>>0<(c[(c[b+(Z<<2)+4>>2]|0)+12>>2]|0)>>>0:0)&1)+Z|0;aa=c[b+(ba<<2)+4>>2]|0;if((c[aa+12>>2]|0)>>>0>=W>>>0){ca=$;break b}c[b+($<<2)+4>>2]=aa;Z=ba<<1|1;if((Z|0)>=(X|0)){ca=ba;break}else $=ba}}else ca=0;while(0);c[b+(ca<<2)+4>>2]=Y;a[_+59>>0]=0;X=_+58|0;if(!(a[X>>0]|0)){M=ea(g[_+12>>2]);da=ea(g[_>>2]);fa=ea(g[_+4>>2]);ga=ea(g[_+8>>2]);$=c[(c[f>>2]|0)+12>>2]|0;ha=ea(-fa);ia=ea(-ga);g[y>>2]=ea(-da);g[K>>2]=ha;g[J>>2]=ia;g[N>>2]=ea(0.0);En[$&127](f,y,v,w,x);$=c[t>>2]|0;ia=ea(g[x>>2]);ha=ea(g[O>>2]);ja=ea(g[P>>2]);ka=ea(ea(ea(da*ia)+ea(fa*ha))+ea(ga*ja));ga=ea(ka*ka);Z=ga<ea(9.99999997e-07);ka=ea((Z?ea(9.99999997e-07):ga)/M);ga=V>ka?ka:V;Z=_+16|0;if(ea(S(ea(M-ga)))<=ea(9.99999997e-07)){la=21;break}ka=ea(g[Z+4>>2]);fa=ea(ha*ka);ka=ea(ia*ea(g[Z>>2]));ia=ea(ja*ea(g[Z+8>>2]));ja=ea(fa+ka);if(ea(S(ea(ea(ja+ia)-ea(g[_+28>>2]))))<=ea(9.99999997e-07)){la=21;break}Z=b+($<<4)+272|0;c[Z+0>>2]=c[v+0>>2];c[Z+4>>2]=c[v+4>>2];c[Z+8>>2]=c[v+8>>2];c[Z+12>>2]=c[v+12>>2];Z=b+($<<4)+1296|0;c[Z+0>>2]=c[w+0>>2];c[Z+4>>2]=c[w+4>>2];c[Z+8>>2]=c[w+8>>2];c[Z+12>>2]=c[w+12>>2];c[t>>2]=$+1;g[u>>2]=ea(ga+ea(9.99999905e-09));c[Q+0>>2]=c[B+0>>2];c[Q+4>>2]=c[B+4>>2];c[Q+8>>2]=c[B+8>>2];g[C>>2]=ea(M+ea(-9.99999905e-09));c[k>>2]=0;a[X>>0]=1;X6a(c[_+40>>2]|0,a[_+52>>0]|0,x,j,s);X6a(c[_+44>>2]|0,a[_+53>>0]|0,x,j,s);X6a(c[_+48>>2]|0,a[_+54>>0]|0,x,j,s);if(!(c[k>>2]|0)){L=4;la=41;break}X=c[j>>2]|0;Z=c[R>>2]|0;W=ePa(b,a[X+(c[601072+(Z<<2)>>2]|0)+55>>0]|0,a[X+Z+55>>0]|0,$,C,u)|0;if(!W){la=24;break}Z=c[j>>2]|0;X=c[R>>2]|0;c[W+40>>2]=Z;a[W+52>>0]=X;c[Z+(X<<2)+40>>2]=W;a[Z+X+52>>0]=0;X=c[k>>2]|0;if(X>>>0>1){Z=1;ba=W;while(1){aa=b+(Z<<3)+6416|0;ma=c[aa>>2]|0;na=b+(Z<<3)+6420|0;oa=c[na>>2]|0;pa=ePa(b,a[ma+(c[601072+(oa<<2)>>2]|0)+55>>0]|0,a[ma+oa+55>>0]|0,$,C,u)|0;if(!pa){la=33;break a}oa=c[aa>>2]|0;aa=c[na>>2]|0;c[pa+40>>2]=oa;a[pa+52>>0]=aa;c[oa+(aa<<2)+40>>2]=pa;a[oa+aa+52>>0]=0;na=pa+55|0;if((a[na>>0]|0)==(a[oa+(c[601072+(aa<<2)>>2]|0)+55>>0]|0))qa=(a[pa+56>>0]|0)==(a[oa+aa+55>>0]|0);else qa=0;c[pa+48>>2]=ba;a[pa+54>>0]=1;c[ba+44>>2]=pa;a[ba+53>>0]=2;if((a[pa+57>>0]|0)==(a[ba+57>>0]|0))ra=(a[na>>0]|0)==(a[ba+56>>0]|0);else ra=0;Z=Z+1|0;if(ra&1^1|qa&1^1){la=33;break a}if(Z>>>0>=X>>>0){sa=pa;break}else ba=pa}}else sa=W;c[W+48>>2]=sa;a[W+54>>0]=1;c[sa+44>>2]=W;a[sa+53>>0]=2;ta=ga}else ta=V;ba=a[_+60>>0]|0;X=a[T>>0]|0;if((ba&255|0)==((X&255)+-1|0))a[T>>0]=X+-1<<24>>24;else{X=a[U>>0]|0;a[U>>0]=X+1<<24>>24;a[b+(X&255)+6676>>0]=ba}if((c[b>>2]|0)<=0){la=40;break}ba=ta>=ea(g[(c[r>>2]|0)+12>>2]);if(ba&(c[t>>2]|0)!=64)V=ta;else{la=40;break}}if((la|0)==21){ta=ea(g[_+32>>2]);V=ea(g[_+36>>2]);t=a[_+55>>0]|0;M=ea(g[b+(t<<4)+272>>2]);ia=ea(g[b+(t<<4)+276>>2]);ja=ea(g[b+(t<<4)+280>>2]);r=a[_+56>>0]|0;ka=ea(g[b+(r<<4)+272>>2]);fa=ea(g[b+(r<<4)+276>>2]);ha=ea(g[b+(r<<4)+280>>2]);U=a[_+57>>0]|0;da=ea(g[b+(U<<4)+272>>2]);ua=ea(g[b+(U<<4)+276>>2]);va=ea(g[b+(U<<4)+280>>2]);wa=ea(g[b+(t<<4)+1296>>2]);xa=ea(g[b+(t<<4)+1300>>2]);ya=ea(g[b+(t<<4)+1304>>2]);za=ea(g[b+(r<<4)+1296>>2]);Aa=ea(g[b+(r<<4)+1300>>2]);Ba=ea(g[b+(r<<4)+1304>>2]);Ca=ea(g[b+(U<<4)+1296>>2]);Da=ea(g[b+(U<<4)+1300>>2]);Ea=ea(ta*ea(za-wa));za=ea(ta*ea(Aa-xa));Aa=ea(ta*ea(Ba-ya));Ba=ea(V*ea(Ca-wa));Ca=ea(V*ea(Da-xa));Da=ea(V*ea(ea(g[b+(U<<4)+1304>>2])-ya));Fa=ea(ia+ea(ea(ta*ea(fa-ia))+ea(V*ea(ua-ia))));ia=ea(ja+ea(ea(ta*ea(ha-ja))+ea(V*ea(va-ja))));g[z>>2]=ea(M+ea(ea(ta*ea(ka-M))+ea(V*ea(da-M))));g[z+4>>2]=Fa;g[z+8>>2]=ia;g[z+12>>2]=ea(0.0);ia=ea(xa+ea(za+Ca));Ca=ea(ya+ea(Aa+Da));g[A>>2]=ea(wa+ea(Ea+Ba));g[A+4>>2]=ia;g[A+8>>2]=Ca;g[A+12>>2]=ea(0.0);W6a(z,A,d,e,m,n,o,p,q);L=6;i=h;return L|0}else if((la|0)==24){Ca=ea(g[_+32>>2]);ia=ea(g[_+36>>2]);A=a[_+55>>0]|0;Ba=ea(g[b+(A<<4)+272>>2]);Ea=ea(g[b+(A<<4)+276>>2]);wa=ea(g[b+(A<<4)+280>>2]);z=a[_+56>>0]|0;Da=ea(g[b+(z<<4)+272>>2]);Aa=ea(g[b+(z<<4)+276>>2]);ya=ea(g[b+(z<<4)+280>>2]);U=a[_+57>>0]|0;za=ea(g[b+(U<<4)+272>>2]);xa=ea(g[b+(U<<4)+276>>2]);Fa=ea(g[b+(U<<4)+280>>2]);M=ea(g[b+(A<<4)+1296>>2]);da=ea(g[b+(A<<4)+1300>>2]);V=ea(g[b+(A<<4)+1304>>2]);ka=ea(g[b+(z<<4)+1296>>2]);ta=ea(g[b+(z<<4)+1300>>2]);ja=ea(g[b+(z<<4)+1304>>2]);va=ea(g[b+(U<<4)+1296>>2]);ha=ea(g[b+(U<<4)+1300>>2]);ua=ea(Ca*ea(ka-M));ka=ea(Ca*ea(ta-da));ta=ea(Ca*ea(ja-V));ja=ea(ia*ea(va-M));va=ea(ia*ea(ha-da));ha=ea(ia*ea(ea(g[b+(U<<4)+1304>>2])-V));fa=ea(Ea+ea(ea(Ca*ea(Aa-Ea))+ea(ia*ea(xa-Ea))));Ea=ea(wa+ea(ea(Ca*ea(ya-wa))+ea(ia*ea(Fa-wa))));g[D>>2]=ea(Ba+ea(ea(Ca*ea(Da-Ba))+ea(ia*ea(za-Ba))));g[D+4>>2]=fa;g[D+8>>2]=Ea;g[D+12>>2]=ea(0.0);Ea=ea(da+ea(ka+va));va=ea(V+ea(ta+ha));g[E>>2]=ea(M+ea(ua+ja));g[E+4>>2]=Ea;g[E+8>>2]=va;g[E+12>>2]=ea(0.0);W6a(D,E,d,e,m,n,o,p,q);L=5;i=h;return L|0}else if((la|0)==33){va=ea(g[_+32>>2]);Ea=ea(g[_+36>>2]);E=a[_+55>>0]|0;ja=ea(g[b+(E<<4)+272>>2]);ua=ea(g[b+(E<<4)+276>>2]);M=ea(g[b+(E<<4)+280>>2]);D=a[_+56>>0]|0;ha=ea(g[b+(D<<4)+272>>2]);ta=ea(g[b+(D<<4)+276>>2]);V=ea(g[b+(D<<4)+280>>2]);U=a[_+57>>0]|0;ka=ea(g[b+(U<<4)+272>>2]);da=ea(g[b+(U<<4)+276>>2]);fa=ea(g[b+(U<<4)+280>>2]);Ba=ea(g[b+(E<<4)+1296>>2]);za=ea(g[b+(E<<4)+1300>>2]);ia=ea(g[b+(E<<4)+1304>>2]);Da=ea(g[b+(D<<4)+1296>>2]);Ca=ea(g[b+(D<<4)+1300>>2]);wa=ea(g[b+(D<<4)+1304>>2]);Fa=ea(g[b+(U<<4)+1296>>2]);ya=ea(g[b+(U<<4)+1300>>2]);xa=ea(va*ea(Da-Ba));Da=ea(va*ea(Ca-za));Ca=ea(va*ea(wa-ia));wa=ea(Ea*ea(Fa-Ba));Fa=ea(Ea*ea(ya-za));ya=ea(Ea*ea(ea(g[b+(U<<4)+1304>>2])-ia));Aa=ea(ua+ea(ea(va*ea(ta-ua))+ea(Ea*ea(da-ua))));ua=ea(M+ea(ea(va*ea(V-M))+ea(Ea*ea(fa-M))));g[F>>2]=ea(ja+ea(ea(va*ea(ha-ja))+ea(Ea*ea(ka-ja))));g[F+4>>2]=Aa;g[F+8>>2]=ua;g[F+12>>2]=ea(0.0);ua=ea(za+ea(Da+Fa));Fa=ea(ia+ea(Ca+ya));g[G>>2]=ea(Ba+ea(xa+wa));g[G+4>>2]=ua;g[G+8>>2]=Fa;g[G+12>>2]=ea(0.0);W6a(F,G,d,e,m,n,o,p,q);L=5;i=h;return L|0}else if((la|0)==40){Fa=ea(g[_+32>>2]);ua=ea(g[_+36>>2]);G=a[_+55>>0]|0;wa=ea(g[b+(G<<4)+272>>2]);xa=ea(g[b+(G<<4)+276>>2]);Ba=ea(g[b+(G<<4)+280>>2]);F=a[_+56>>0]|0;ya=ea(g[b+(F<<4)+272>>2]);Ca=ea(g[b+(F<<4)+276>>2]);ia=ea(g[b+(F<<4)+280>>2]);U=a[_+57>>0]|0;Da=ea(g[b+(U<<4)+272>>2]);za=ea(g[b+(U<<4)+276>>2]);Aa=ea(g[b+(U<<4)+280>>2]);ja=ea(g[b+(G<<4)+1296>>2]);ka=ea(g[b+(G<<4)+1300>>2]);Ea=ea(g[b+(G<<4)+1304>>2]);ha=ea(g[b+(F<<4)+1296>>2]);va=ea(g[b+(F<<4)+1300>>2]);M=ea(g[b+(F<<4)+1304>>2]);fa=ea(g[b+(U<<4)+1296>>2]);V=ea(g[b+(U<<4)+1300>>2]);da=ea(Fa*ea(ha-ja));ha=ea(Fa*ea(va-ka));va=ea(Fa*ea(M-Ea));M=ea(ua*ea(fa-ja));fa=ea(ua*ea(V-ka));V=ea(ua*ea(ea(g[b+(U<<4)+1304>>2])-Ea));ta=ea(xa+ea(ea(Fa*ea(Ca-xa))+ea(ua*ea(za-xa))));xa=ea(Ba+ea(ea(Fa*ea(ia-Ba))+ea(ua*ea(Aa-Ba))));g[H>>2]=ea(wa+ea(ea(Fa*ea(ya-wa))+ea(ua*ea(Da-wa))));g[H+4>>2]=ta;g[H+8>>2]=xa;g[H+12>>2]=ea(0.0);xa=ea(ka+ea(ha+fa));fa=ea(Ea+ea(va+V));g[I>>2]=ea(ja+ea(da+M));g[I+4>>2]=xa;g[I+8>>2]=fa;g[I+12>>2]=ea(0.0);W6a(H,I,d,e,m,n,o,p,q);L=5;i=h;return L|0}else if((la|0)==41){i=h;return L|0}return 0}function ePa(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;i=i+32|0;l=k+16|0;m=k;n=b+6804|0;o=a[n>>0]|0;p=b+6805|0;q=a[p>>0]|0;r=q&255;if(((o&255)-r|0)>>>0>=64){s=0;i=k;return s|0}if(!(q<<24>>24)){a[n>>0]=o+1<<24>>24;t=o}else{a[p>>0]=q+-1<<24>>24;t=a[b+(r+255&255)+6676>>0]|0}r=t&255;q=b+(r<<6)+2320|0;p=b+(r<<6)+2332|0;c[p>>2]=0;g[b+(r<<6)+2352>>2]=ea(0.0);g[b+(r<<6)+2356>>2]=ea(0.0);a[b+(r<<6)+2378>>0]=0;o=b+(r<<6)+2379|0;a[o>>0]=0;a[b+(r<<6)+2375>>0]=d;a[b+(r<<6)+2376>>0]=e;a[b+(r<<6)+2377>>0]=f;c[b+(r<<6)+2368>>2]=0;c[b+(r<<6)+2364>>2]=0;c[b+(r<<6)+2360>>2]=0;a[b+(r<<6)+2374>>0]=-1;a[b+(r<<6)+2373>>0]=-1;a[b+(r<<6)+2372>>0]=-1;a[b+(r<<6)+2380>>0]=t;Y6a(m,q,d,e,f,b+272|0,b+1296|0,h,j,l);if(((c[m>>2]|0)==-1?(c[m+4>>2]|0)==-1:0)&(c[m+8>>2]|0)==-1?(c[m+12>>2]|0)==-1:0){m=c[b>>2]|0;a:do if(!m)u=0;else{j=c[p>>2]|0;h=m;while(1){f=h;h=h+-1>>1;e=c[b+(h<<2)+4>>2]|0;if((c[e+12>>2]|0)>>>0<=j>>>0){u=f;break a}c[b+(f<<2)+4>>2]=e;if(!h){u=0;break}}}while(0);c[b+(u<<2)+4>>2]=q;c[b>>2]=(c[b>>2]|0)+1;v=1}else v=0;a[o>>0]=v;s=(c[l>>2]|0)!=0?q:0;i=k;return s|0}function fPa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=Im;d=i;i=i+96|0;b=d+80|0;h=d+48|0;j=d+16|0;k=ea(g[a+272>>2]);l=ea(g[a+276>>2]);m=ea(g[a+280>>2]);n=ea(g[a+1296>>2]);o=ea(g[a+1300>>2]);p=ea(k-n);n=ea(l-o);o=ea(m-ea(g[a+1304>>2]));m=ea(g[a+288>>2]);l=ea(g[a+292>>2]);k=ea(g[a+296>>2]);q=ea(g[a+1312>>2]);r=ea(g[a+1316>>2]);s=ea(p-ea(m-q));q=ea(n-ea(l-r));r=ea(o-ea(k-ea(g[a+1320>>2])));k=ea(ea(1.0)/ea(T(ea(ea(ea(s*s)+ea(q*q))+ea(r*r)))));o=ea(s*k);s=ea(q*k);q=ea(r*k);k=ea(ea(q*q)+ea(ea(o*o)+ea(s*s)));r=ea(q*k);l=ea(s*k);n=ea(r-l);m=ea(o*k);k=ea(m-r);r=ea(l-m);m=ea(ea(1.0)/ea(T(ea(ea(r*r)+ea(ea(n*n)+ea(k*k))))));l=ea(m*n);n=ea(m*k);k=ea(m*r);r=ea(ea(q*l)-ea(o*k));m=ea(ea(o*n)-ea(s*l));g[b>>2]=ea(ea(s*k)-ea(q*n));t=b+4|0;g[t>>2]=r;u=b+8|0;g[u>>2]=m;g[b+12>>2]=ea(0.0);En[c[(c[e>>2]|0)+12>>2]&127](e,b,a+272|0,a+1296|0,d+64|0);m=ea(o*ea(.866025388));o=ea(s*ea(.866025388));s=ea(q*ea(.866025388));q=ea(g[b>>2]);r=ea(g[t>>2]);n=ea(g[u>>2]);k=ea(ea(ea(m*q)+ea(o*r))+ea(s*n));l=ea(ea(ea(m*k)+ea(ea(q*ea(-.25))+ea(ea(ea(o*n)-ea(s*r))*ea(-.5))))*ea(2.0));p=ea(ea(ea(o*k)+ea(ea(r*ea(-.25))+ea(ea(ea(s*q)-ea(m*n))*ea(-.5))))*ea(2.0));v=ea(ea(ea(ea(n*ea(-.25))+ea(ea(ea(m*r)-ea(o*q))*ea(-.5)))+ea(s*k))*ea(2.0));k=ea(ea(1.0)/ea(T(ea(ea(v*v)+ea(ea(l*l)+ea(p*p))))));q=ea(k*p);p=ea(k*v);g[h>>2]=ea(k*l);u=h+4|0;g[u>>2]=q;t=h+8|0;g[t>>2]=p;g[h+12>>2]=ea(0.0);En[c[(c[e>>2]|0)+12>>2]&127](e,h,a+288|0,a+1312|0,d+32|0);p=ea(g[h>>2]);q=ea(g[u>>2]);l=ea(g[t>>2]);k=ea(ea(ea(m*p)+ea(o*q))+ea(s*l));v=ea(ea(ea(m*k)+ea(ea(p*ea(-.25))+ea(ea(ea(o*l)-ea(s*q))*ea(-.5))))*ea(2.0));r=ea(ea(ea(o*k)+ea(ea(q*ea(-.25))+ea(ea(ea(s*p)-ea(m*l))*ea(-.5))))*ea(2.0));n=ea(ea(ea(ea(l*ea(-.25))+ea(ea(ea(m*q)-ea(o*p))*ea(-.5)))+ea(s*k))*ea(2.0));k=ea(ea(1.0)/ea(T(ea(ea(n*n)+ea(ea(v*v)+ea(r*r))))));s=ea(k*r);r=ea(k*n);g[j>>2]=ea(k*v);g[j+4>>2]=s;g[j+8>>2]=r;g[j+12>>2]=ea(0.0);En[c[(c[e>>2]|0)+12>>2]&127](e,j,a+304|0,a+1328|0,d);j=gPa(a,0,0,e,f)|0;i=d;return j|0}function gPa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=0,J=Im,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=0,R=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=0,$=Im,aa=0,ba=0,ca=Im,da=0,fa=Im,ga=0,ha=Im,ia=0,ja=Im,ka=0,la=0,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0,Ga=0;d=i;i=i+208|0;b=d+176|0;h=d+144|0;j=d+80|0;k=d+64|0;l=d+128|0;m=d+160|0;n=d+192|0;o=d+32|0;p=d+16|0;q=d+96|0;r=d+48|0;s=d+112|0;t=d;u=a+272|0;v=ea(g[u>>2]);w=a+276|0;x=ea(g[w>>2]);y=a+280|0;z=ea(g[y>>2]);A=a+284|0;B=ea(g[A>>2]);C=a+1296|0;D=ea(g[C>>2]);E=a+1300|0;F=ea(g[E>>2]);G=a+1304|0;H=ea(g[G>>2]);I=a+1308|0;J=ea(g[I>>2]);K=a+288|0;L=ea(g[K>>2]);M=a+292|0;N=ea(g[M>>2]);O=a+296|0;P=ea(g[O>>2]);Q=a+300|0;R=ea(g[Q>>2]);U=a+1312|0;V=ea(g[U>>2]);W=a+1316|0;X=ea(g[W>>2]);Y=a+1320|0;Z=ea(g[Y>>2]);_=a+1324|0;$=ea(g[_>>2]);aa=a+304|0;ba=a+304|0;ca=ea(g[ba>>2]);da=a+308|0;fa=ea(g[da>>2]);ga=a+312|0;ha=ea(g[ga>>2]);ia=a+316|0;ja=ea(g[ia>>2]);ka=a+1328|0;la=a+1328|0;ma=ea(g[la>>2]);na=a+1332|0;oa=ea(g[na>>2]);pa=a+1336|0;qa=ea(g[pa>>2]);ra=a+1340|0;sa=ea(g[ra>>2]);ta=ea(v-D);ua=ea(x-F);va=ea(z-H);g[j>>2]=ta;g[j+4>>2]=ua;g[j+8>>2]=va;g[j+12>>2]=ea(0.0);wa=ea(L-V);xa=ea(N-X);ya=ea(P-Z);g[k>>2]=wa;g[k+4>>2]=xa;g[k+8>>2]=ya;g[k+12>>2]=ea(0.0);za=ea(ca-ma);Aa=ea(fa-oa);Ba=ea(ha-qa);g[l>>2]=za;g[l+4>>2]=Aa;g[l+8>>2]=Ba;g[l+12>>2]=ea(0.0);Ca=ea(wa-ta);wa=ea(xa-ua);xa=ea(ya-va);ya=ea(za-ta);za=ea(Aa-ua);Aa=ea(Ba-va);Ba=ea(ea(wa*Aa)-ea(xa*za));Da=ea(ea(xa*ya)-ea(Ca*Aa));Aa=ea(ea(Ca*za)-ea(wa*ya));ya=ea(ea(1.0)/ea(T(ea(ea(Aa*Aa)+ea(ea(Ba*Ba)+ea(Da*Da))))));wa=ea(ya*Ba);Ba=ea(ya*Da);Da=ea(Aa*ya);g[m>>2]=wa;Ea=m+4|0;g[Ea>>2]=Ba;Fa=m+8|0;g[Fa>>2]=Da;g[m+12>>2]=ea(0.0);ya=ea(-Ba);Aa=ea(-Da);g[n>>2]=ea(-wa);g[n+4>>2]=ya;g[n+8>>2]=Aa;g[n+12>>2]=ea(0.0);Aa=ea(ea(ea(wa*ta)+ea(Ba*ua))+ea(Da*va));va=ea(-Aa);En[c[(c[e>>2]|0)+12>>2]&127](e,m,o,p,q);Da=ea(g[m>>2]);ua=ea(g[Ea>>2]);Ba=ea(g[Fa>>2]);ta=ea(g[q>>2]);wa=ea(g[q+4>>2]);ya=ea(ea(ea(ea(Da*ta)+ea(ua*wa))+ea(Ba*ea(g[q+8>>2])))-Aa);if(!(!(ea(S(ea(ya)))>=ea(.0000999999974))|!(ea(ya*va)>=ea(0.0)))){Z6a(b,j,k,l,q);if((((c[b>>2]|0)==0?(c[b+4>>2]|0)==0:0)?(c[b+8>>2]|0)==0:0)?(c[b+12>>2]|0)==0:0){b=a+320|0;c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];c[b+12>>2]=c[o+12>>2];b=a+1344|0;c[b+0>>2]=c[p+0>>2];c[b+4>>2]=c[p+4>>2];c[b+8>>2]=c[p+8>>2];c[b+12>>2]=c[p+12>>2];if(!(hPa(a)|0)){Ga=0;i=d;return Ga|0}c[f>>2]=4;Ga=1;i=d;return Ga|0};c[aa+0>>2]=c[o+0>>2];c[aa+4>>2]=c[o+4>>2];c[aa+8>>2]=c[o+8>>2];c[aa+12>>2]=c[o+12>>2];c[ka+0>>2]=c[p+0>>2];c[ka+4>>2]=c[p+4>>2];c[ka+8>>2]=c[p+8>>2];c[ka+12>>2]=c[p+12>>2];if(jPa(a,j,k,q,e,f)|0){Ga=1;i=d;return Ga|0}g[K>>2]=ca;g[M>>2]=fa;g[O>>2]=ha;g[Q>>2]=ja;g[U>>2]=ma;g[W>>2]=oa;g[Y>>2]=qa;g[_>>2]=sa;if(jPa(a,j,l,q,e,f)|0){Ga=1;i=d;return Ga|0}g[u>>2]=L;g[w>>2]=N;g[y>>2]=P;g[A>>2]=R;g[C>>2]=V;g[E>>2]=X;g[G>>2]=Z;g[I>>2]=$;if(jPa(a,k,l,q,e,f)|0){Ga=1;i=d;return Ga|0}}En[c[(c[e>>2]|0)+12>>2]&127](e,n,r,s,t);ya=ea(g[m>>2]);Ba=ea(g[Ea>>2]);wa=ea(g[Fa>>2]);ua=ea(g[t>>2]);ta=ea(g[t+4>>2]);Da=ea(ea(ea(ea(ya*ua)+ea(Ba*ta))+ea(wa*ea(g[t+8>>2])))-Aa);if(!(!(ea(S(ea(Da)))>=ea(.0000999999974))|!(ea(Da*va)>=ea(0.0)))){g[u>>2]=v;g[w>>2]=x;g[y>>2]=z;g[A>>2]=B;g[K>>2]=L;g[M>>2]=N;g[O>>2]=P;g[Q>>2]=R;g[ba>>2]=ca;g[da>>2]=fa;g[ga>>2]=ha;g[ia>>2]=ja;g[C>>2]=D;g[E>>2]=F;g[G>>2]=H;g[I>>2]=J;g[U>>2]=V;g[W>>2]=X;g[Y>>2]=Z;g[_>>2]=$;g[la>>2]=ma;g[na>>2]=oa;g[pa>>2]=qa;g[ra>>2]=sa;Z6a(h,j,k,l,t);if((((c[h>>2]|0)==0?(c[h+4>>2]|0)==0:0)?(c[h+8>>2]|0)==0:0)?(c[h+12>>2]|0)==0:0){h=a+320|0;c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[h+12>>2]=c[r+12>>2];h=a+1344|0;c[h+0>>2]=c[s+0>>2];c[h+4>>2]=c[s+4>>2];c[h+8>>2]=c[s+8>>2];c[h+12>>2]=c[s+12>>2];if(!(hPa(a)|0)){Ga=0;i=d;return Ga|0}c[f>>2]=4;Ga=1;i=d;return Ga|0};c[aa+0>>2]=c[r+0>>2];c[aa+4>>2]=c[r+4>>2];c[aa+8>>2]=c[r+8>>2];c[aa+12>>2]=c[r+12>>2];c[ka+0>>2]=c[s+0>>2];c[ka+4>>2]=c[s+4>>2];c[ka+8>>2]=c[s+8>>2];c[ka+12>>2]=c[s+12>>2];if(jPa(a,j,k,t,e,f)|0){Ga=1;i=d;return Ga|0}g[K>>2]=ca;g[M>>2]=fa;g[O>>2]=ha;g[Q>>2]=ja;g[U>>2]=ma;g[W>>2]=oa;g[Y>>2]=qa;g[_>>2]=sa;if(jPa(a,j,l,t,e,f)|0){Ga=1;i=d;return Ga|0}g[u>>2]=L;g[w>>2]=N;g[y>>2]=P;g[A>>2]=R;g[C>>2]=V;g[E>>2]=X;g[G>>2]=Z;g[I>>2]=$;if(jPa(a,k,l,t,e,f)|0){Ga=1;i=d;return Ga|0}}if(!(Aa==ea(-0.0))){Ga=0;i=d;return Ga|0}g[u>>2]=v;g[w>>2]=x;g[y>>2]=z;g[A>>2]=B;g[K>>2]=L;g[M>>2]=N;g[O>>2]=P;g[Q>>2]=R;g[ba>>2]=ca;g[da>>2]=fa;g[ga>>2]=ha;g[ia>>2]=ja;g[C>>2]=D;g[E>>2]=F;g[G>>2]=H;g[I>>2]=J;g[U>>2]=V;g[W>>2]=X;g[Y>>2]=Z;g[_>>2]=$;g[la>>2]=ma;g[na>>2]=oa;g[pa>>2]=qa;g[ra>>2]=sa;ra=a+320|0;c[ra+0>>2]=c[o+0>>2];c[ra+4>>2]=c[o+4>>2];c[ra+8>>2]=c[o+8>>2];c[ra+12>>2]=c[o+12>>2];o=a+1344|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];p=a+336|0;c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];r=a+1360|0;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];if(!(iPa(a)|0)){Ga=0;i=d;return Ga|0}c[f>>2]=5;Ga=1;i=d;return Ga|0}function hPa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d;g[e>>2]=ea(0.0);g[f>>2]=ea(3402823469999999843913219.0e14);h=ePa(b,0,1,2,e,f)|0;j=ePa(b,0,3,1,e,f)|0;k=ePa(b,0,2,3,e,f)|0;l=ePa(b,1,3,2,e,f)|0;if((h|0)==0|(j|0)==0|(k|0)==0|(l|0)==0){i=d;return 0}if(!(c[b>>2]|0)){i=d;return 0}else{c[h+40>>2]=j;a[h+52>>0]=2;c[j+48>>2]=h;a[j+54>>0]=0;c[h+44>>2]=l;a[h+53>>0]=2;c[l+48>>2]=h;a[l+54>>0]=1;c[h+48>>2]=k;a[h+54>>0]=0;c[k+40>>2]=h;a[k+52>>0]=2;c[j+40>>2]=k;a[j+52>>0]=2;c[k+48>>2]=j;a[k+54>>0]=0;c[j+44>>2]=l;a[j+53>>0]=0;c[l+40>>2]=j;a[l+52>>0]=1;c[k+44>>2]=l;a[k+53>>0]=1;c[l+44>>2]=k;a[l+53>>0]=1;i=d;return 1}return 0}function iPa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+16|0;f=d;g[e>>2]=ea(0.0);g[f>>2]=ea(3402823469999999843913219.0e14);h=ePa(b,0,3,2,e,f)|0;j=ePa(b,1,3,0,e,f)|0;k=ePa(b,2,3,1,e,f)|0;l=ePa(b,2,4,0,e,f)|0;m=ePa(b,0,4,1,e,f)|0;n=ePa(b,1,4,2,e,f)|0;if((h|0)==0|(j|0)==0|(k|0)==0|(l|0)==0|(m|0)==0|(n|0)==0){i=d;return 0}if(!(c[b>>2]|0)){i=d;return 0}else{c[h+40>>2]=j;a[h+52>>0]=1;c[j+44>>2]=h;a[j+53>>0]=0;c[h+44>>2]=k;a[h+53>>0]=0;c[k+40>>2]=h;a[k+52>>0]=1;c[h+48>>2]=l;a[h+54>>0]=2;c[l+48>>2]=h;a[l+54>>0]=2;c[j+40>>2]=k;a[j+52>>0]=1;c[k+44>>2]=j;a[k+53>>0]=0;c[j+48>>2]=m;a[j+54>>0]=2;c[m+48>>2]=j;a[m+54>>0]=2;c[k+48>>2]=n;a[k+54>>0]=2;c[n+48>>2]=k;a[n+54>>0]=2;c[l+40>>2]=n;a[l+52>>0]=1;c[n+44>>2]=l;a[n+53>>0]=0;c[l+44>>2]=m;a[l+53>>0]=0;c[m+40>>2]=l;a[m+52>>0]=1;c[m+44>>2]=n;a[m+53>>0]=0;c[n+40>>2]=m;a[n+52>>0]=1;i=d;return 1}return 0}function jPa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0;j=i;i=i+160|0;k=j;l=j+64|0;m=j+112|0;n=j+16|0;o=j+128|0;p=j+144|0;q=j+48|0;r=j+96|0;s=j+80|0;t=j+32|0;u=ea(g[d>>2]);v=ea(g[d+4>>2]);w=ea(g[d+8>>2]);x=ea(g[b>>2]);y=b+4|0;z=ea(g[y>>2]);A=b+8|0;B=ea(g[A>>2]);C=ea(u-x);u=ea(v-z);v=ea(w-B);w=ea(g[e>>2]);D=ea(g[e+4>>2]);E=ea(w-x);x=ea(D-z);z=ea(ea(g[e+8>>2])-B);B=ea(ea(u*z)-ea(v*x));D=ea(ea(v*E)-ea(C*z));z=ea(ea(C*x)-ea(u*E));E=ea(ea(1.0)/ea(T(ea(ea(z*z)+ea(ea(B*B)+ea(D*D))))));u=ea(E*B);B=ea(E*D);D=ea(z*E);g[m>>2]=u;F=m+4|0;g[F>>2]=B;G=m+8|0;g[G>>2]=D;g[m+12>>2]=ea(0.0);E=ea(-B);B=ea(-D);g[n>>2]=ea(-u);g[n+4>>2]=E;g[n+8>>2]=B;g[n+12>>2]=ea(0.0);En[c[(c[f>>2]|0)+12>>2]&127](f,m,o,p,q);B=ea(g[m>>2]);E=ea(g[F>>2]);u=ea(g[G>>2]);D=ea(g[b>>2]);z=ea(g[y>>2]);x=ea(ea(ea(B*D)+ea(E*z))+ea(u*ea(g[A>>2])));z=ea(-x);D=ea(g[q>>2]);C=ea(g[q+4>>2]);v=ea(ea(ea(ea(B*D)+ea(E*C))+ea(u*ea(g[q+8>>2])))-x);if((((ea(S(ea(v)))>=ea(1.1920929e-07)&ea(v*z)>ea(0.0)?(Z6a(k,b,d,e,q),(c[k>>2]|0)==0):0)?(c[k+4>>2]|0)==0:0)?(c[k+8>>2]|0)==0:0)?(c[k+12>>2]|0)==0:0){k=a+320|0;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=a+1344|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];if(!(hPa(a)|0)){H=0;i=j;return H|0}c[h>>2]=4;H=1;i=j;return H|0}En[c[(c[f>>2]|0)+12>>2]&127](f,n,r,s,t);v=ea(g[m>>2]);u=ea(g[F>>2]);C=ea(g[G>>2]);E=ea(g[t>>2]);D=ea(g[t+4>>2]);B=ea(ea(ea(ea(v*E)+ea(u*D))+ea(C*ea(g[t+8>>2])))-x);if(!(ea(S(ea(B)))>=ea(1.1920929e-07)&ea(B*z)>ea(0.0))){H=0;i=j;return H|0}Z6a(l,b,d,e,t);if(c[l>>2]|0){H=0;i=j;return H|0}if(c[l+4>>2]|0){H=0;i=j;return H|0}if(c[l+8>>2]|0){H=0;i=j;return H|0}if(c[l+12>>2]|0){H=0;i=j;return H|0}l=a+320|0;c[l+0>>2]=c[r+0>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];r=a+1344|0;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];if(!(hPa(a)|0)){H=0;i=j;return H|0}c[h>>2]=4;H=1;i=j;return H|0}function kPa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;n=i;i=i+16|0;o=n;a[o+4>>0]=0;c[o>>2]=541240;c[o+8>>2]=b;c[o+12>>2]=d;p=cPa(b,d,o,j,k,a[l>>0]|0,e,f,g,h,m)|0;i=n;return p|0}function lPa(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0;o=i;i=i+32|0;p=o;a[p+4>>0]=0;c[p>>2]=541112;c[p+8>>2]=b;c[p+12>>2]=d;c[p+16>>2]=e;e=cPa(b,d,p,k,l,a[m>>0]|0,f,g,h,j,n)|0;i=o;return e|0}function mPa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=Im,ha=0,ia=0;m=i;i=i+528|0;n=m+448|0;o=m+80|0;p=m+488|0;q=m+128|0;r=m+48|0;s=m+64|0;t=m+192|0;u=m+224|0;v=m+304|0;w=m+384|0;x=m+144|0;y=m+500|0;z=m+32|0;A=m;B=m+16|0;C=m+504|0;D=m+208|0;E=m+112|0;F=m+288|0;G=m+368|0;H=m+176|0;I=m+160|0;J=m+96|0;K=m+476|0;L=m+464|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[y>>2]=0;M=ea(g[f>>2]);N=ea(g[f+4>>2]);O=ea(g[f+8>>2]);P=ea(ea(ea(M*M)+ea(N*N))+ea(O*O))>ea(0.0);c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);f=P?o:n;O=ea(g[f>>2]);N=ea(g[f+4>>2]);M=ea(g[f+8>>2]);g[z>>2]=O;f=z+4|0;g[f>>2]=N;n=z+8|0;g[n>>2]=M;g[z+12>>2]=ea(0.0);Q=ea(g[a+32>>2]);R=ea(g[b+32>>2]);S=ea((Q>R?R:Q)*ea(.00999999977));c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];c[D+0>>2]=c[x+0>>2];c[D+4>>2]=c[x+4>>2];c[D+8>>2]=c[x+8>>2];c[D+12>>2]=c[x+12>>2];c[E+0>>2]=c[x+0>>2];c[E+4>>2]=c[x+4>>2];c[E+8>>2]=c[x+8>>2];c[E+12>>2]=c[x+12>>2];x=G+4|0;b=G+8|0;a=G+12|0;o=F+4|0;P=F+8|0;U=H+4|0;V=H+8|0;W=I+4|0;X=I+8|0;Y=I+12|0;Q=O;O=N;N=M;M=ea(3402823469999999843913219.0e14);while(1){c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];Z=c[(c[d>>2]|0)+4>>2]|0;R=ea(-O);_=ea(-N);g[G>>2]=ea(-Q);g[x>>2]=R;g[b>>2]=_;g[a>>2]=ea(0.0);co[Z&2047](F,d,G);co[c[(c[e>>2]|0)+4>>2]&2047](H,e,z);_=ea(g[F>>2]);R=ea(g[o>>2]);$=ea(g[P>>2]);aa=ea(g[H>>2]);ba=ea(g[U>>2]);ca=ea(_-aa);aa=ea(R-ba);ba=ea($-ea(g[V>>2]));g[I>>2]=ca;g[W>>2]=aa;g[X>>2]=ba;g[Y>>2]=ea(0.0);Z=c[y>>2]|0;da=v+(Z<<4)|0;c[da+0>>2]=c[F+0>>2];c[da+4>>2]=c[F+4>>2];c[da+8>>2]=c[F+8>>2];c[da+12>>2]=c[F+12>>2];da=w+(Z<<4)|0;c[da+0>>2]=c[H+0>>2];c[da+4>>2]=c[H+4>>2];c[da+8>>2]=c[H+8>>2];c[da+12>>2]=c[H+12>>2];c[y>>2]=Z+1;da=u+(Z<<4)|0;c[da+0>>2]=c[I+0>>2];c[da+4>>2]=c[I+4>>2];c[da+8>>2]=c[I+8>>2];c[da+12>>2]=c[I+12>>2];$=ea(g[z>>2]);R=ea(g[f>>2]);if(ea(M*ea(.000224999996))>ea(M-ea(ea(ea($*ca)+ea(R*aa))+ea(ea(g[n>>2])*ba)))){fa=3;break}if(!Z){c[A+0>>2]=c[F+0>>2];c[A+4>>2]=c[F+4>>2];c[A+8>>2]=c[F+8>>2];c[A+12>>2]=c[F+12>>2];c[B+0>>2]=c[H+0>>2];c[B+4>>2]=c[H+4>>2];c[B+8>>2]=c[H+8>>2];c[B+12>>2]=c[H+12>>2];c[J+0>>2]=c[I+0>>2];c[J+4>>2]=c[I+4>>2];c[J+8>>2]=c[I+8>>2];c[J+12>>2]=c[I+12>>2]}else if((Z|0)==2){c[p+0>>2]=c[135316];c[p+4>>2]=c[135317];c[p+8>>2]=c[135318];sPa(J,u,v,w,p,y,A,B)}else if((Z|0)==1)rPa(J,u,I,v,F,w,H,y,A,B);else if((Z|0)==3)tPa(J,u,v,w,y,A,B);else{c[J+0>>2]=c[I+0>>2];c[J+4>>2]=c[I+4>>2];c[J+8>>2]=c[I+8>>2];c[J+12>>2]=c[I+12>>2]};c[z+0>>2]=c[J+0>>2];c[z+4>>2]=c[J+4>>2];c[z+8>>2]=c[J+8>>2];c[z+12>>2]=c[J+12>>2];Q=ea(g[z>>2]);O=ea(g[f>>2]);N=ea(g[n>>2]);ga=ea(ea(ea(Q*Q)+ea(O*O))+ea(N*N));c[C+0>>2]=c[K+0>>2];c[C+4>>2]=c[K+4>>2];c[C+8>>2]=c[K+8>>2];ha=M>ga;if(!(ga>S)|ha^1){fa=11;break}else M=ga}if((fa|0)==3){S=ea(g[B>>2]);N=ea(g[B+4>>2]);O=ea(g[B+8>>2]);Q=ea(g[A>>2]);ba=ea(g[A+4>>2]);aa=ea(S-Q);Q=ea(N-ba);ba=ea(O-ea(g[A+8>>2]));O=ea(ea(1.0)/ea(T(ea(ea(ea(aa*aa)+ea(Q*Q))+ea(ba*ba)))));N=ea(aa*O);aa=ea(Q*O);Q=ea(ba*O);c[h+0>>2]=c[A+0>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[h+12>>2]=c[A+12>>2];c[j+0>>2]=c[B+0>>2];c[j+4>>2]=c[B+4>>2];c[j+8>>2]=c[B+8>>2];c[j+12>>2]=c[B+12>>2];g[l>>2]=M;K=l+4|0;c[K+0>>2]=c[C+0>>2];c[K+4>>2]=c[C+4>>2];c[K+8>>2]=c[C+8>>2];g[k>>2]=N;g[k+4>>2]=aa;g[k+8>>2]=Q;g[k+12>>2]=ea(0.0);ia=0;i=m;return ia|0}else if((fa|0)==11){c[r+0>>2]=c[A+0>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[q+0>>2]=c[D+0>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];c[q+12>>2]=c[D+12>>2];D=ha?r:q;Q=ea(g[D>>2]);aa=ea(g[D+4>>2]);N=ea(g[D+8>>2]);g[A>>2]=Q;g[A+4>>2]=aa;g[A+8>>2]=N;g[A+12>>2]=ea(0.0);c[t+0>>2]=c[B+0>>2];c[t+4>>2]=c[B+4>>2];c[t+8>>2]=c[B+8>>2];c[t+12>>2]=c[B+12>>2];c[s+0>>2]=c[E+0>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];c[s+12>>2]=c[E+12>>2];E=ha?t:s;O=ea(g[E>>2]);ba=ea(g[E+4>>2]);S=ea(g[E+8>>2]);g[B>>2]=O;g[B+4>>2]=ba;g[B+8>>2]=S;g[B+12>>2]=ea(0.0);c[h+0>>2]=c[A+0>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[h+12>>2]=c[A+12>>2];c[j+0>>2]=c[B+0>>2];c[j+4>>2]=c[B+4>>2];c[j+8>>2]=c[B+8>>2];c[j+12>>2]=c[B+12>>2];R=ea(O-Q);Q=ea(ba-aa);aa=ea(S-N);N=ea(ea(1.0)/ea(T(ea(ea(ea(R*R)+ea(Q*Q))+ea(aa*aa)))));S=ea(Q*N);Q=ea(aa*N);g[k>>2]=ea(R*N);g[k+4>>2]=S;g[k+8>>2]=Q;g[k+12>>2]=ea(0.0);g[l>>2]=ha?ga:M;k=l+4|0;c[k+0>>2]=c[L+0>>2];c[k+4>>2]=c[L+4>>2];c[k+8>>2]=c[L+8>>2];ia=ha?1:3;i=m;return ia|0}return 0}function nPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;m=i;n=_6a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function oPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;m=i;n=d7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function pPa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0,Ga=0,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=0,Oa=0,Pa=0,Qa=0;k=i;i=i+480|0;l=k+448|0;m=k+128|0;n=k+144|0;o=k+176|0;p=k+48|0;q=k+64|0;r=k+240|0;s=k+320|0;t=k+464|0;u=k+432|0;v=k+192|0;w=k+208|0;x=k+468|0;y=k;z=k+16|0;A=k+224|0;B=k+472|0;C=k+160|0;D=k+384|0;E=k+416|0;F=k+476|0;G=k+304|0;H=k+32|0;I=k+400|0;J=c[f>>2]|0;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];K=b+16|0;c[m+0>>2]=c[K+0>>2];c[m+4>>2]=c[K+4>>2];c[m+8>>2]=c[K+8>>2];c[m+12>>2]=c[K+12>>2];L=b+32|0;c[n+0>>2]=c[L+0>>2];c[n+4>>2]=c[L+4>>2];c[n+8>>2]=c[L+8>>2];c[n+12>>2]=c[L+12>>2];M=b+48|0;c[o+0>>2]=c[M+0>>2];c[o+4>>2]=c[M+4>>2];c[o+8>>2]=c[M+8>>2];c[o+12>>2]=c[M+12>>2];N=ea(g[o>>2]);O=ea(g[o+4>>2]);P=ea(g[o+8>>2]);Q=ea(g[l>>2]);R=ea(g[l+4>>2]);S=ea(N-Q);Q=ea(O-R);R=ea(P-ea(g[l+8>>2]));T=ea(g[m>>2]);U=ea(g[m+4>>2]);V=ea(N-T);T=ea(O-U);U=ea(P-ea(g[m+8>>2]));W=ea(g[n>>2]);X=ea(g[n+4>>2]);Y=ea(N-W);W=ea(O-X);X=ea(P-ea(g[n+8>>2]));P=ea(ea(ea(S*S)+ea(Q*Q))+ea(R*R));R=ea(ea(ea(V*V)+ea(T*T))+ea(U*U));U=ea(ea(ea(Y*Y)+ea(W*W))+ea(X*X));X=R>U?U:R;if((P>X?X:P)<ea(1.1920929e-07)){c[f>>2]=3;V6a(a,l,m,n,b,d,e,f,h,j);i=k;return}Z6a(p,l,m,n,o);o=c[p>>2]|0;n=c[p+4>>2]|0;m=c[p+8>>2]|0;l=p+12|0;if((n|o|m|0)==0&(c[l>>2]|0)==0){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=k;return};c[q+0>>2]=c[b+0>>2];c[q+4>>2]=c[b+4>>2];c[q+8>>2]=c[b+8>>2];c[q+12>>2]=c[b+12>>2];p=q+16|0;c[p+0>>2]=c[K+0>>2];c[p+4>>2]=c[K+4>>2];c[p+8>>2]=c[K+8>>2];c[p+12>>2]=c[K+12>>2];Z=q+32|0;c[Z+0>>2]=c[L+0>>2];c[Z+4>>2]=c[L+4>>2];c[Z+8>>2]=c[L+8>>2];c[Z+12>>2]=c[L+12>>2];_=q+48|0;c[_+0>>2]=c[M+0>>2];c[_+4>>2]=c[M+4>>2];c[_+8>>2]=c[M+8>>2];c[_+12>>2]=c[M+12>>2];c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];M=r+16|0;$=d+16|0;c[M+0>>2]=c[$+0>>2];c[M+4>>2]=c[$+4>>2];c[M+8>>2]=c[$+8>>2];c[M+12>>2]=c[$+12>>2];M=r+32|0;aa=d+32|0;c[M+0>>2]=c[aa+0>>2];c[M+4>>2]=c[aa+4>>2];c[M+8>>2]=c[aa+8>>2];c[M+12>>2]=c[aa+12>>2];M=r+48|0;ba=d+48|0;c[M+0>>2]=c[ba+0>>2];c[M+4>>2]=c[ba+4>>2];c[M+8>>2]=c[ba+8>>2];c[M+12>>2]=c[ba+12>>2];c[s+0>>2]=c[e+0>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];c[s+12>>2]=c[e+12>>2];ba=s+16|0;M=e+16|0;c[ba+0>>2]=c[M+0>>2];c[ba+4>>2]=c[M+4>>2];c[ba+8>>2]=c[M+8>>2];c[ba+12>>2]=c[M+12>>2];ba=s+32|0;ca=e+32|0;c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];ba=s+48|0;da=e+48|0;c[ba+0>>2]=c[da+0>>2];c[ba+4>>2]=c[da+4>>2];c[ba+8>>2]=c[da+8>>2];c[ba+12>>2]=c[da+12>>2];if((o|0)==-1){c[t>>2]=3;m7a(w,q,p,Z,t,u,v);P=ea(g[w>>2]);X=ea(g[w+4>>2]);R=ea(g[w+8>>2]);U=ea(g[w+12>>2]);W=ea(ea(ea(P*P)+ea(X*X))+ea(R*R));Y=ea(g[u>>2]);fa=W;ga=U;ha=R;ia=X;ja=P;ka=Y;la=ea(g[v>>2]);ma=c[t>>2]|0}else{fa=ea(3402823469999999843913219.0e14);ga=ea(0.0);ha=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=J}if((n|0)==-1?(c[x>>2]=3,m7a(A,q,Z,_,x,y,z),Y=ea(g[A>>2]),P=ea(g[A+4>>2]),X=ea(g[A+8>>2]),R=ea(ea(ea(Y*Y)+ea(P*P))+ea(X*X)),fa>R):0){U=ea(g[A+12>>2]);W=ea(g[y>>2]);na=R;oa=U;pa=X;qa=P;ra=Y;sa=W;ta=ea(g[z>>2]);ua=2;va=3;wa=c[x>>2]|0}else{na=fa;oa=ga;pa=ha;qa=ia;ra=ja;sa=ka;ta=la;ua=1;va=2;wa=ma}if((m|0)==-1?(c[B>>2]=3,m7a(E,q,_,p,B,C,D),la=ea(g[E>>2]),ka=ea(g[E+4>>2]),ja=ea(g[E+8>>2]),ia=ea(ea(ea(la*la)+ea(ka*ka))+ea(ja*ja)),na>ia):0){ha=ea(g[E+12>>2]);ga=ea(g[C>>2]);xa=ia;ya=ha;za=ja;Aa=ka;Ba=la;Ca=ga;Da=ea(g[D>>2]);Ea=3;Fa=1;Ga=c[B>>2]|0}else{xa=na;ya=oa;za=pa;Aa=qa;Ba=ra;Ca=sa;Da=ta;Ea=ua;Fa=va;Ga=wa}if((c[l>>2]|0)==-1?(c[F>>2]=3,m7a(I,p,_,Z,F,G,H),ta=ea(g[I>>2]),sa=ea(g[I+4>>2]),ra=ea(g[I+8>>2]),xa>ea(ea(ea(ta*ta)+ea(sa*sa))+ea(ra*ra))):0){xa=ea(g[I+12>>2]);qa=ea(g[G>>2]);Ha=ea(g[H>>2]);Ia=qa;Ja=ta;Ka=sa;La=ra;Ma=xa;Na=1;Oa=3;Pa=2;Qa=c[F>>2]|0}else{Ha=Da;Ia=Ca;Ja=Ba;Ka=Aa;La=za;Ma=ya;Na=0;Oa=Ea;Pa=Fa;Qa=Ga}Ga=r+(Na<<4)|0;c[d+0>>2]=c[Ga+0>>2];c[d+4>>2]=c[Ga+4>>2];c[d+8>>2]=c[Ga+8>>2];c[d+12>>2]=c[Ga+12>>2];d=r+(Oa<<4)|0;c[$+0>>2]=c[d+0>>2];c[$+4>>2]=c[d+4>>2];c[$+8>>2]=c[d+8>>2];c[$+12>>2]=c[d+12>>2];$=r+(Pa<<4)|0;c[aa+0>>2]=c[$+0>>2];c[aa+4>>2]=c[$+4>>2];c[aa+8>>2]=c[$+8>>2];c[aa+12>>2]=c[$+12>>2];aa=s+(Na<<4)|0;c[e+0>>2]=c[aa+0>>2];c[e+4>>2]=c[aa+4>>2];c[e+8>>2]=c[aa+8>>2];c[e+12>>2]=c[aa+12>>2];e=s+(Oa<<4)|0;c[M+0>>2]=c[e+0>>2];c[M+4>>2]=c[e+4>>2];c[M+8>>2]=c[e+8>>2];c[M+12>>2]=c[e+12>>2];M=s+(Pa<<4)|0;c[ca+0>>2]=c[M+0>>2];c[ca+4>>2]=c[M+4>>2];c[ca+8>>2]=c[M+8>>2];c[ca+12>>2]=c[M+12>>2];ca=q+(Na<<4)|0;c[b+0>>2]=c[ca+0>>2];c[b+4>>2]=c[ca+4>>2];c[b+8>>2]=c[ca+8>>2];c[b+12>>2]=c[ca+12>>2];ca=q+(Oa<<4)|0;c[K+0>>2]=c[ca+0>>2];c[K+4>>2]=c[ca+4>>2];c[K+8>>2]=c[ca+8>>2];c[K+12>>2]=c[ca+12>>2];ca=q+(Pa<<4)|0;c[L+0>>2]=c[ca+0>>2];c[L+4>>2]=c[ca+4>>2];c[L+8>>2]=c[ca+8>>2];c[L+12>>2]=c[ca+12>>2];ya=ea(g[d>>2]);za=ea(g[r+(Oa<<4)+4>>2]);Aa=ea(g[r+(Oa<<4)+8>>2]);Ba=ea(g[Ga>>2]);Ca=ea(g[r+(Na<<4)+4>>2]);Da=ea(g[r+(Na<<4)+8>>2]);xa=ea(ya-Ba);ya=ea(za-Ca);za=ea(Aa-Da);Aa=ea(g[$>>2]);ra=ea(g[r+(Pa<<4)+4>>2]);sa=ea(Aa-Ba);Aa=ea(ra-Ca);ra=ea(ea(g[r+(Pa<<4)+8>>2])-Da);ta=ea(g[e>>2]);qa=ea(g[s+(Oa<<4)+4>>2]);pa=ea(g[s+(Oa<<4)+8>>2]);oa=ea(g[aa>>2]);na=ea(g[s+(Na<<4)+4>>2]);ga=ea(g[s+(Na<<4)+8>>2]);la=ea(ta-oa);ta=ea(qa-na);qa=ea(pa-ga);pa=ea(g[M>>2]);ka=ea(g[s+(Pa<<4)+4>>2]);ja=ea(pa-oa);pa=ea(ka-na);ka=ea(ea(g[s+(Pa<<4)+8>>2])-ga);ha=ea(Ca+ea(ea(Ia*ya)+ea(Ha*Aa)));Aa=ea(Da+ea(ea(Ia*za)+ea(Ha*ra)));g[h>>2]=ea(Ba+ea(ea(Ia*xa)+ea(Ha*sa)));g[h+4>>2]=ha;g[h+8>>2]=Aa;g[h+12>>2]=ea(0.0);Aa=ea(na+ea(ea(Ia*ta)+ea(Ha*pa)));pa=ea(ga+ea(ea(Ia*qa)+ea(Ha*ka)));g[j>>2]=ea(oa+ea(ea(Ia*la)+ea(Ha*ja)));g[j+4>>2]=Aa;g[j+8>>2]=pa;g[j+12>>2]=ea(0.0);c[f>>2]=Qa;g[a>>2]=Ja;g[a+4>>2]=Ka;g[a+8>>2]=La;g[a+12>>2]=Ma;i=k;return}function qPa(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=0,Wa=0;p=i;i=i+432|0;q=p+48|0;r=p+192|0;s=p+16|0;t=p+64|0;u=p+176|0;v=p+208|0;w=p+288|0;x=p+96|0;y=p+368|0;z=p+392|0;A=p+352|0;B=p+160|0;C=p+412|0;D=p+272|0;E=p+416|0;F=p;G=p+408|0;H=p+32|0;I=p+384|0;J=p+80|0;K=c[m>>2]|0;c[q+0>>2]=c[b+0>>2];c[q+4>>2]=c[b+4>>2];c[q+8>>2]=c[b+8>>2];c[q+12>>2]=c[b+12>>2];L=b+16|0;c[r+0>>2]=c[L+0>>2];c[r+4>>2]=c[L+4>>2];c[r+8>>2]=c[L+8>>2];c[r+12>>2]=c[L+12>>2];M=b+32|0;c[s+0>>2]=c[M+0>>2];c[s+4>>2]=c[M+4>>2];c[s+8>>2]=c[M+8>>2];c[s+12>>2]=c[M+12>>2];c[t+0>>2]=c[j+0>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];c[t+12>>2]=c[j+12>>2];N=ea(g[t>>2]);O=ea(g[t+4>>2]);P=ea(g[t+8>>2]);Q=ea(g[q>>2]);R=ea(g[q+4>>2]);S=ea(N-Q);Q=ea(O-R);R=ea(P-ea(g[q+8>>2]));T=ea(g[r>>2]);U=ea(g[r+4>>2]);V=ea(N-T);T=ea(O-U);U=ea(P-ea(g[r+8>>2]));W=ea(g[s>>2]);X=ea(g[s+4>>2]);Y=ea(N-W);W=ea(O-X);X=ea(P-ea(g[s+8>>2]));P=ea(ea(ea(S*S)+ea(Q*Q))+ea(R*R));R=ea(ea(ea(V*V)+ea(T*T))+ea(U*U));U=ea(ea(ea(Y*Y)+ea(W*W))+ea(X*X));X=R>U?U:R;if((P>X?X:P)<ea(1.1920929e-07)){c[m>>2]=3;V6a(a,q,r,s,b,d,e,m,n,o);i=p;return}Z6a(u,q,r,s,t);t=c[u>>2]|0;s=c[u+4>>2]|0;r=c[u+8>>2]|0;q=u+12|0;if((s|t|r|0)==0&(c[q>>2]|0)==0){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=p;return};c[v+0>>2]=c[b+0>>2];c[v+4>>2]=c[b+4>>2];c[v+8>>2]=c[b+8>>2];c[v+12>>2]=c[b+12>>2];u=v+16|0;c[u+0>>2]=c[L+0>>2];c[u+4>>2]=c[L+4>>2];c[u+8>>2]=c[L+8>>2];c[u+12>>2]=c[L+12>>2];Z=v+32|0;c[Z+0>>2]=c[M+0>>2];c[Z+4>>2]=c[M+4>>2];c[Z+8>>2]=c[M+8>>2];c[Z+12>>2]=c[M+12>>2];_=v+48|0;c[_+0>>2]=c[j+0>>2];c[_+4>>2]=c[j+4>>2];c[_+8>>2]=c[j+8>>2];c[_+12>>2]=c[j+12>>2];c[w+0>>2]=c[d+0>>2];c[w+4>>2]=c[d+4>>2];c[w+8>>2]=c[d+8>>2];c[w+12>>2]=c[d+12>>2];j=w+16|0;$=d+16|0;c[j+0>>2]=c[$+0>>2];c[j+4>>2]=c[$+4>>2];c[j+8>>2]=c[$+8>>2];c[j+12>>2]=c[$+12>>2];j=w+32|0;aa=d+32|0;c[j+0>>2]=c[aa+0>>2];c[j+4>>2]=c[aa+4>>2];c[j+8>>2]=c[aa+8>>2];c[j+12>>2]=c[aa+12>>2];j=w+48|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[x+0>>2]=c[e+0>>2];c[x+4>>2]=c[e+4>>2];c[x+8>>2]=c[e+8>>2];c[x+12>>2]=c[e+12>>2];k=x+16|0;j=e+16|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=x+32|0;ba=e+32|0;c[k+0>>2]=c[ba+0>>2];c[k+4>>2]=c[ba+4>>2];c[k+8>>2]=c[ba+8>>2];c[k+12>>2]=c[ba+12>>2];k=x+48|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];l=c[f>>2]|0;c[y>>2]=l;k=f+4|0;ca=c[k>>2]|0;c[y+4>>2]=ca;da=f+8|0;c[y+8>>2]=c[da>>2];c[y+12>>2]=c[f+12>>2];fa=c[h>>2]|0;c[z>>2]=fa;ga=h+4|0;ha=c[ga>>2]|0;c[z+4>>2]=ha;ia=h+8|0;c[z+8>>2]=c[ia>>2];c[z+12>>2]=c[h+12>>2];if((t|0)==-1){c[C>>2]=3;m7a(D,v,u,Z,C,A,B);P=ea(g[D>>2]);X=ea(g[D+4>>2]);R=ea(g[D+8>>2]);U=ea(g[D+12>>2]);W=ea(ea(ea(P*P)+ea(X*X))+ea(R*R));Y=ea(g[A>>2]);ja=W;ka=U;la=R;ma=X;na=P;oa=Y;pa=ea(g[B>>2]);qa=c[C>>2]|0}else{ja=ea(3402823469999999843913219.0e14);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=K}if((s|0)==-1?(c[E>>2]=3,m7a(F,v,Z,_,E,A,B),Y=ea(g[F>>2]),P=ea(g[F+4>>2]),X=ea(g[F+8>>2]),R=ea(ea(ea(Y*Y)+ea(P*P))+ea(X*X)),ja>R):0){U=ea(g[F+12>>2]);W=ea(g[A>>2]);ra=R;sa=U;ta=X;ua=P;va=Y;wa=W;xa=ea(g[B>>2]);ya=2;za=3;Aa=c[E>>2]|0}else{ra=ja;sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=pa;ya=1;za=2;Aa=qa}if((r|0)==-1?(c[G>>2]=3,m7a(H,v,_,u,G,A,B),pa=ea(g[H>>2]),oa=ea(g[H+4>>2]),na=ea(g[H+8>>2]),ma=ea(ea(ea(pa*pa)+ea(oa*oa))+ea(na*na)),ra>ma):0){la=ea(g[H+12>>2]);ka=ea(g[A>>2]);Ba=ma;Ca=la;Da=na;Ea=oa;Fa=pa;Ga=ka;Ha=ea(g[B>>2]);Ia=3;Ja=1;Ka=c[G>>2]|0}else{Ba=ra;Ca=sa;Da=ta;Ea=ua;Fa=va;Ga=wa;Ha=xa;Ia=ya;Ja=za;Ka=Aa}if((c[q>>2]|0)==-1?(c[I>>2]=3,m7a(J,u,_,Z,I,A,B),xa=ea(g[J>>2]),wa=ea(g[J+4>>2]),va=ea(g[J+8>>2]),Ba>ea(ea(ea(xa*xa)+ea(wa*wa))+ea(va*va))):0){Ba=ea(g[J+12>>2]);ua=ea(g[A>>2]);La=ca;Ma=ha;Na=ea(g[B>>2]);Oa=ua;Pa=xa;Qa=wa;Ra=va;Sa=Ba;Ta=1;Ua=3;Va=2;Wa=c[I>>2]|0}else{La=l;Ma=fa;Na=Ha;Oa=Ga;Pa=Fa;Qa=Ea;Ra=Da;Sa=Ca;Ta=0;Ua=Ia;Va=Ja;Wa=Ka}Ka=w+(Ta<<4)|0;c[d+0>>2]=c[Ka+0>>2];c[d+4>>2]=c[Ka+4>>2];c[d+8>>2]=c[Ka+8>>2];c[d+12>>2]=c[Ka+12>>2];d=w+(Ua<<4)|0;c[$+0>>2]=c[d+0>>2];c[$+4>>2]=c[d+4>>2];c[$+8>>2]=c[d+8>>2];c[$+12>>2]=c[d+12>>2];$=w+(Va<<4)|0;c[aa+0>>2]=c[$+0>>2];c[aa+4>>2]=c[$+4>>2];c[aa+8>>2]=c[$+8>>2];c[aa+12>>2]=c[$+12>>2];aa=x+(Ta<<4)|0;c[e+0>>2]=c[aa+0>>2];c[e+4>>2]=c[aa+4>>2];c[e+8>>2]=c[aa+8>>2];c[e+12>>2]=c[aa+12>>2];e=x+(Ua<<4)|0;c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];j=x+(Va<<4)|0;c[ba+0>>2]=c[j+0>>2];c[ba+4>>2]=c[j+4>>2];c[ba+8>>2]=c[j+8>>2];c[ba+12>>2]=c[j+12>>2];ba=v+(Ta<<4)|0;c[b+0>>2]=c[ba+0>>2];c[b+4>>2]=c[ba+4>>2];c[b+8>>2]=c[ba+8>>2];c[b+12>>2]=c[ba+12>>2];ba=v+(Ua<<4)|0;c[L+0>>2]=c[ba+0>>2];c[L+4>>2]=c[ba+4>>2];c[L+8>>2]=c[ba+8>>2];c[L+12>>2]=c[ba+12>>2];ba=v+(Va<<4)|0;c[M+0>>2]=c[ba+0>>2];c[M+4>>2]=c[ba+4>>2];c[M+8>>2]=c[ba+8>>2];c[M+12>>2]=c[ba+12>>2];c[f>>2]=La;c[k>>2]=c[y+(Ua<<2)>>2];c[da>>2]=c[y+(Va<<2)>>2];c[h>>2]=Ma;c[ga>>2]=c[z+(Ua<<2)>>2];c[ia>>2]=c[z+(Va<<2)>>2];Ca=ea(g[d>>2]);Da=ea(g[w+(Ua<<4)+4>>2]);Ea=ea(g[w+(Ua<<4)+8>>2]);Fa=ea(g[Ka>>2]);Ga=ea(g[w+(Ta<<4)+4>>2]);Ha=ea(g[w+(Ta<<4)+8>>2]);Ba=ea(Ca-Fa);Ca=ea(Da-Ga);Da=ea(Ea-Ha);Ea=ea(g[$>>2]);va=ea(g[w+(Va<<4)+4>>2]);wa=ea(Ea-Fa);Ea=ea(va-Ga);va=ea(ea(g[w+(Va<<4)+8>>2])-Ha);xa=ea(g[e>>2]);ua=ea(g[x+(Ua<<4)+4>>2]);ta=ea(g[x+(Ua<<4)+8>>2]);sa=ea(g[aa>>2]);ra=ea(g[x+(Ta<<4)+4>>2]);ka=ea(g[x+(Ta<<4)+8>>2]);pa=ea(xa-sa);xa=ea(ua-ra);ua=ea(ta-ka);ta=ea(g[j>>2]);oa=ea(g[x+(Va<<4)+4>>2]);na=ea(ta-sa);ta=ea(oa-ra);oa=ea(ea(g[x+(Va<<4)+8>>2])-ka);la=ea(Ga+ea(ea(Oa*Ca)+ea(Na*Ea)));Ea=ea(Ha+ea(ea(Oa*Da)+ea(Na*va)));g[n>>2]=ea(Fa+ea(ea(Oa*Ba)+ea(Na*wa)));g[n+4>>2]=la;g[n+8>>2]=Ea;g[n+12>>2]=ea(0.0);Ea=ea(ra+ea(ea(Oa*xa)+ea(Na*ta)));ta=ea(ka+ea(ea(Oa*ua)+ea(Na*oa)));g[o>>2]=ea(sa+ea(ea(Oa*pa)+ea(Na*na)));g[o+4>>2]=Ea;g[o+8>>2]=ta;g[o+12>>2]=ea(0.0);c[m>>2]=Wa;g[a>>2]=Pa;g[a+4>>2]=Qa;g[a+8>>2]=Ra;g[a+12>>2]=Sa;i=p;return}function rPa(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=Im;n=i;i=i+32|0;o=n+16|0;p=n;q=ea(g[b>>2]);r=ea(g[b+4>>2]);s=ea(g[b+8>>2]);t=ea(g[b+12>>2]);u=ea(g[d>>2]);v=ea(g[d+4>>2]);w=ea(g[d+8>>2]);x=ea(g[d+12>>2]);y=ea(g[e>>2]);z=ea(g[e+4>>2]);A=ea(g[e+8>>2]);B=ea(g[e+12>>2]);C=ea(g[f>>2]);D=ea(g[f+4>>2]);E=ea(g[f+8>>2]);F=ea(g[h>>2]);G=ea(g[h+4>>2]);H=ea(g[h+8>>2]);I=ea(g[h+12>>2]);J=ea(g[j>>2]);K=ea(g[j+4>>2]);h=p+4|0;f=p+8|0;e=p+12|0;d=o+4|0;b=o+8|0;L=o+12|0;M=p+4|0;N=p+8|0;O=p+12|0;P=o+4|0;Q=o+8|0;R=o+12|0;S=t;t=x;x=B;B=I;I=q;q=u;u=r;r=v;v=s;s=w;w=y;y=C;C=z;z=D;D=A;A=E;E=F;F=J;J=G;G=K;K=H;H=ea(g[j+8>>2]);while(1){T=ea(ea(I+q)*ea(.5));U=ea(ea(u+r)*ea(.5));V=ea(ea(v+s)*ea(.5));W=ea(ea(w+y)*ea(.5));X=ea(ea(C+z)*ea(.5));Y=ea(ea(D+A)*ea(.5));Z=ea(ea(E+F)*ea(.5));_=ea(ea(J+G)*ea(.5));$=ea(ea(K+H)*ea(.5));aa=ea(T-I);ba=ea(U-u);ca=ea(V-v);da=ea(ea(ca*ca)+ea(ea(ba*ba)+ea(aa*aa)));if(da<ea(1.0e4))break;fa=ea(ea(ea(ea(-ea(u*ba))-ea(I*aa))-ea(v*ca))/da);j=fa>ea(1.0);ga=j?ea(1.0):fa;j=ga>ea(0.0);fa=j?ga:ea(0.0);j=da!=ea(0.0);da=j?fa:ea(0.0);g[p>>2]=I;g[h>>2]=u;g[f>>2]=v;g[e>>2]=S;fa=ea(u+ea(ba*da));ba=ea(v+ea(ca*da));g[o>>2]=ea(I+ea(aa*da));g[d>>2]=fa;g[b>>2]=ba;g[L>>2]=ea(0.0);ha=j?o:p;ba=ea(g[ha>>2]);fa=ea(g[ha+4>>2]);da=ea(g[ha+8>>2]);aa=ea(ea(ea(ba*ba)+ea(fa*fa))+ea(da*da));da=ea(T-q);fa=ea(U-r);ba=ea(V-s);ca=ea(ea(ba*ba)+ea(ea(fa*fa)+ea(da*da)));ga=ea(ea(ea(ea(-ea(r*fa))-ea(q*da))-ea(s*ba))/ca);ha=ga>ea(1.0);ia=ha?ea(1.0):ga;ha=ia>ea(0.0);ga=ha?ia:ea(0.0);ha=ca!=ea(0.0);ca=ha?ga:ea(0.0);g[p>>2]=q;g[M>>2]=r;g[N>>2]=s;g[O>>2]=t;ga=ea(r+ea(fa*ca));fa=ea(s+ea(ba*ca));g[o>>2]=ea(q+ea(da*ca));g[P>>2]=ga;g[Q>>2]=fa;g[R>>2]=ea(0.0);j=ha?o:p;fa=ea(g[j>>2]);ga=ea(g[j+4>>2]);ca=ea(g[j+8>>2]);j=aa>ea(ea(ea(fa*fa)+ea(ga*ga))+ea(ca*ca));ca=j?ea(0.0):S;ga=j?t:ea(0.0);fa=j?ea(0.0):x;aa=j?ea(0.0):B;S=ca;t=ga;x=fa;B=aa;I=j?T:I;q=j?q:T;u=j?U:u;r=j?r:U;v=j?V:v;s=j?s:V;w=j?W:w;y=j?y:W;C=j?X:C;z=j?z:X;D=j?Y:D;A=j?A:Y;E=j?Z:E;F=j?F:Z;J=j?_:J;G=j?G:_;K=j?$:K;H=j?H:$}t=ea(q-I);q=ea(r-u);r=ea(s-v);s=ea(ea(r*r)+ea(ea(q*q)+ea(t*t)));if(s==ea(0.0)){c[k>>2]=1;g[l>>2]=w;g[l+4>>2]=C;g[l+8>>2]=D;g[l+12>>2]=x;g[m>>2]=E;g[m+4>>2]=J;g[m+8>>2]=K;g[m+12>>2]=B;g[a>>2]=I;g[a+4>>2]=u;g[a+8>>2]=v;g[a+12>>2]=S;i=n;return}else{S=ea(y-w);y=ea(z-C);z=ea(A-D);A=ea(F-E);F=ea(G-J);G=ea(H-K);H=ea(ea(ea(ea(-ea(u*q))-ea(I*t))-ea(v*r))/s);k=H>ea(1.0);s=k?ea(1.0):H;k=s>ea(0.0);H=k?s:ea(0.0);s=ea(w+ea(S*H));S=ea(C+ea(y*H));y=ea(D+ea(z*H));z=ea(E+ea(A*H));A=ea(J+ea(F*H));F=ea(K+ea(G*H));g[l>>2]=s;g[l+4>>2]=S;g[l+8>>2]=y;g[l+12>>2]=ea(0.0);g[m>>2]=z;g[m+4>>2]=A;g[m+8>>2]=F;g[m+12>>2]=ea(0.0);H=ea(S-A);A=ea(y-F);g[a>>2]=ea(s-z);g[a+4>>2]=H;g[a+8>>2]=A;g[a+12>>2]=ea(0.0);i=n;return}}function sPa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=0,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im;l=i;c[h>>2]=3;m=c[f>>2]|0;n=c[f+4>>2]|0;o=c[f+8>>2]|0;f=b+(m<<4)|0;p=ea(g[f>>2]);q=b+(m<<4)+4|0;r=ea(g[q>>2]);s=b+(m<<4)+8|0;t=ea(g[s>>2]);u=b+(n<<4)|0;v=ea(g[u>>2]);w=b+(n<<4)+4|0;x=ea(g[w>>2]);y=b+(n<<4)+8|0;z=ea(g[y>>2]);A=b+(o<<4)|0;B=ea(g[A>>2]);C=b+(o<<4)+4|0;D=ea(g[C>>2]);E=b+(o<<4)+8|0;F=ea(g[E>>2]);G=ea(v-p);H=ea(x-r);I=ea(z-t);J=ea(B-p);K=ea(D-r);L=ea(F-t);M=ea(v-B);N=ea(x-D);O=ea(z-F);P=ea(ea(ea(J*J)+ea(K*K))+ea(L*L));Q=ea(ea(ea(M*M)+ea(N*N))+ea(O*O));if((P>Q?Q:P)<=ea(1.1920929e-07)){c[h>>2]=2;n7a(a,f,u,d+(m<<4)|0,d+(n<<4)|0,e+(m<<4)|0,e+(n<<4)|0,h,j,k);i=l;return}P=ea(-p);p=ea(-r);r=ea(-t);t=ea(-v);v=ea(-x);x=ea(-z);z=ea(-B);B=ea(-D);D=ea(-F);F=ea(ea(ea(G*P)+ea(H*p))+ea(I*r));Q=ea(ea(ea(J*P)+ea(K*p))+ea(L*r));r=ea(ea(ea(G*t)+ea(H*v))+ea(I*x));p=ea(ea(ea(J*t)+ea(K*v))+ea(L*x));x=ea(ea(ea(G*z)+ea(H*B))+ea(I*D));I=ea(ea(ea(J*z)+ea(K*B))+ea(L*D));D=ea(ea(r*I)-ea(x*p));L=ea(ea(x*Q)-ea(F*I));B=ea(ea(F*p)-ea(r*Q));if(!(!(F<=ea(0.0))|!(Q<=ea(0.0)))){b=d+(m<<4)|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];b=e+(m<<4)|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=l;return}if(!(!(r>=ea(0.0))|!(r>=p))){b=d+(n<<4)|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];b=e+(n<<4)|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];i=l;return}if(!(!(I>=ea(0.0))|!(I>=x))){b=d+(o<<4)|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];b=e+(o<<4)|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[a+0>>2]=c[A+0>>2];c[a+4>>2]=c[A+4>>2];c[a+8>>2]=c[A+8>>2];c[a+12>>2]=c[A+12>>2];i=l;return}b=!(B<=ea(0.0));if(!(F>=ea(0.0)))R=1;else R=!(r<=ea(0.0));if(!(b|R)){rPa(a,f,u,d+(m<<4)|0,d+(n<<4)|0,e+(m<<4)|0,e+(n<<4)|0,h,j,k);i=l;return}R=!(D<=ea(0.0));if(!(p>=r))S=1;else S=!(x>=I);if(!(R|S)){rPa(a,u,A,d+(n<<4)|0,d+(o<<4)|0,e+(n<<4)|0,e+(o<<4)|0,h,j,k);i=l;return}S=!(L<=ea(0.0));if(!(Q>=ea(0.0)))U=1;else U=!(I<=ea(0.0));if(!(S|U)){rPa(a,f,A,d+(m<<4)|0,d+(o<<4)|0,e+(m<<4)|0,e+(o<<4)|0,h,j,k);i=l;return}c[h>>2]=3;I=ea(g[f>>2]);Q=ea(g[q>>2]);L=ea(g[s>>2]);x=ea(g[u>>2]);r=ea(g[w>>2]);p=ea(g[y>>2]);D=ea(g[A>>2]);F=ea(g[C>>2]);B=ea(g[E>>2]);K=ea(g[d+(m<<4)>>2]);z=ea(g[d+(m<<4)+4>>2]);J=ea(g[d+(m<<4)+8>>2]);H=ea(g[d+(n<<4)>>2]);G=ea(g[d+(n<<4)+4>>2]);v=ea(g[d+(n<<4)+8>>2]);t=ea(g[d+(o<<4)>>2]);P=ea(g[d+(o<<4)+4>>2]);O=ea(g[d+(o<<4)+8>>2]);N=ea(g[e+(m<<4)>>2]);M=ea(g[e+(m<<4)+4>>2]);V=ea(g[e+(m<<4)+8>>2]);W=ea(g[e+(n<<4)>>2]);X=ea(g[e+(n<<4)+4>>2]);Y=ea(g[e+(n<<4)+8>>2]);Z=ea(g[e+(o<<4)>>2]);_=ea(g[e+(o<<4)+4>>2]);$=L;L=Q;Q=I;I=p;p=r;r=x;x=B;B=F;F=D;D=J;J=z;z=K;K=v;v=G;G=H;H=O;O=P;P=t;t=V;V=M;M=N;N=Y;Y=X;X=W;W=ea(g[e+(o<<4)+8>>2]);aa=_;_=Z;a:while(1){ba=r;ca=p;da=I;fa=F;ga=B;ha=x;ia=G;ja=v;ka=K;la=X;ma=Y;na=N;oa=P;pa=O;qa=H;ra=_;sa=aa;ta=W;while(1){ua=ea(ba-Q);va=ea(ca-L);wa=ea(da-$);xa=ea(fa-Q);ya=ea(ga-L);za=ea(ha-$);Z=ea(fa-ba);Aa=ea(ga-ca);Ba=ea(ha-da);Ca=ea(ea(wa*wa)+ea(ea(va*va)+ea(ua*ua)));Da=ea(ea(za*za)+ea(ea(ya*ya)+ea(xa*xa)));Ea=ea(ea(Ba*Ba)+ea(ea(Aa*Aa)+ea(Z*Z)));o=Da>Ea;Z=o?Da:Ea;Aa=o?Ea:Da;Ba=ea(ea(va*za)-ea(wa*ya));Fa=ea(ea(wa*xa)-ea(ua*za));Ga=ea(ea(ua*ya)-ea(va*xa));Ha=ea(T(ea(ea(Ga*Ga)+ea(ea(Ba*Ba)+ea(Fa*Fa)))));if(Ha<ea(100.0)?ea(ea(T(ea(Ca>Z?Ca:Z)))/ea(T(ea(Ca>Aa?Aa:Ca))))<ea(4.0):0)break a;Aa=ea(ea(1.0)/Ha);Ia=ea(Ba*Aa);Ja=ea(Fa*Aa);Ka=ea(Ga*Aa);if(!(!(Ca>=Da)|!(Ca>=Ea))){La=25;break}if(Da>=Ea){La=27;break}Ea=ea(ea(ba+fa)*ea(.5));Da=ea(ea(ca+ga)*ea(.5));Ca=ea(ea(da+ha)*ea(.5));Aa=ea(ea(ia+oa)*ea(.5));Ga=ea(ea(ja+pa)*ea(.5));Fa=ea(ea(ka+qa)*ea(.5));Ba=ea(ea(la+ra)*ea(.5));Ha=ea(ea(ma+sa)*ea(.5));Z=ea(ea(na+ta)*ea(.5));Ma=ea(Ea-Q);Na=ea(Da-L);Oa=ea(Ca-$);Pa=ea(ea(Na*Ka)-ea(Oa*Ja));Qa=ea(ea(Oa*Ia)-ea(Ma*Ka));Oa=ea(ea(Ma*Ja)-ea(Na*Ia));Na=ea(ea(1.0)/ea(T(ea(ea(Oa*Oa)+ea(ea(Pa*Pa)+ea(Qa*Qa))))));Ma=ea(Pa*Na);Pa=ea(Qa*Na);Qa=ea(Oa*Na);Na=ea(ea(Ca*Qa)+ea(ea(Ea*Ma)+ea(Da*Pa)));o=ea(Na*ea(ea(ea(da*Qa)+ea(ea(ba*Ma)+ea(ca*Pa)))-Na))<ea(-0.0);ba=o?ba:Ea;ca=o?ca:Da;da=o?da:Ca;fa=o?Ea:fa;ga=o?Da:ga;ha=o?Ca:ha;ia=o?ia:Aa;ja=o?ja:Ga;ka=o?ka:Fa;la=o?la:Ba;ma=o?ma:Ha;na=o?na:Z;oa=o?Aa:oa;pa=o?Ga:pa;qa=o?Fa:qa;ra=o?Ba:ra;sa=o?Ha:sa;ta=o?Z:ta}if((La|0)==25){La=0;Z=ea(ea(Q+ba)*ea(.5));Ha=ea(ea(L+ca)*ea(.5));Ba=ea(ea($+da)*ea(.5));Fa=ea(ea(z+ia)*ea(.5));Ga=ea(ea(J+ja)*ea(.5));Aa=ea(ea(D+ka)*ea(.5));Ca=ea(ea(M+la)*ea(.5));Da=ea(ea(V+ma)*ea(.5));Ea=ea(ea(t+na)*ea(.5));Na=ea(Z-fa);Pa=ea(Ha-ga);Ma=ea(Ba-ha);Qa=ea(ea(Pa*Ka)-ea(Ma*Ja));Oa=ea(ea(Ma*Ia)-ea(Na*Ka));Ma=ea(ea(Na*Ja)-ea(Pa*Ia));Pa=ea(ea(1.0)/ea(T(ea(ea(Ma*Ma)+ea(ea(Qa*Qa)+ea(Oa*Oa))))));Na=ea(Qa*Pa);Qa=ea(Oa*Pa);Oa=ea(Ma*Pa);Pa=ea(ea(Ba*Oa)+ea(ea(Z*Na)+ea(Ha*Qa)));o=ea(Pa*ea(ea(ea($*Oa)+ea(ea(Q*Na)+ea(L*Qa)))-Pa))<ea(-0.0);$=o?$:Ba;L=o?L:Ha;Q=o?Q:Z;I=o?Ba:da;p=o?Ha:ca;r=o?Z:ba;x=ha;B=ga;F=fa;D=o?D:Aa;J=o?J:Ga;z=o?z:Fa;K=o?Aa:ka;v=o?Ga:ja;G=o?Fa:ia;H=qa;O=pa;P=oa;t=o?t:Ea;V=o?V:Da;M=o?M:Ca;N=o?Ea:na;Y=o?Da:ma;X=o?Ca:la;W=ta;aa=sa;_=ra;continue}else if((La|0)==27){La=0;Ca=ea(ea(Q+fa)*ea(.5));Da=ea(ea(L+ga)*ea(.5));Ea=ea(ea($+ha)*ea(.5));Fa=ea(ea(z+oa)*ea(.5));Ga=ea(ea(J+pa)*ea(.5));Aa=ea(ea(D+qa)*ea(.5));Z=ea(ea(M+ra)*ea(.5));Ha=ea(ea(V+sa)*ea(.5));Ba=ea(ea(t+ta)*ea(.5));Pa=ea(Ca-ba);Qa=ea(Da-ca);Na=ea(Ea-da);Oa=ea(ea(Qa*Ka)-ea(Na*Ja));Ma=ea(ea(Na*Ia)-ea(Pa*Ka));Na=ea(ea(Pa*Ja)-ea(Qa*Ia));Qa=ea(ea(1.0)/ea(T(ea(ea(Na*Na)+ea(ea(Oa*Oa)+ea(Ma*Ma))))));Pa=ea(Oa*Qa);Oa=ea(Ma*Qa);Ma=ea(Na*Qa);Qa=ea(ea(Ea*Ma)+ea(ea(Ca*Pa)+ea(Da*Oa)));o=ea(Qa*ea(ea(ea($*Ma)+ea(ea(Q*Pa)+ea(L*Oa)))-Qa))<ea(-0.0);$=o?$:Ea;L=o?L:Da;Q=o?Q:Ca;I=da;p=ca;r=ba;x=o?Ea:ha;B=o?Da:ga;F=o?Ca:fa;D=o?D:Aa;J=o?J:Ga;z=o?z:Fa;K=ka;v=ja;G=ia;H=o?Aa:qa;O=o?Ga:pa;P=o?Fa:oa;t=o?t:Ba;V=o?V:Ha;M=o?M:Z;N=na;Y=ma;X=la;W=o?Ba:ta;aa=o?Ha:sa;_=o?Z:ra;continue}}_=ea(-Q);Q=ea(-L);L=ea(-$);$=ea(-ba);ba=ea(-ca);ca=ea(-da);da=ea(-fa);fa=ea(-ga);ga=ea(-ha);ha=ea(ea(wa*L)+ea(ea(va*Q)+ea(ua*_)));aa=ea(ea(za*L)+ea(ea(ya*Q)+ea(xa*_)));_=ea(ea(wa*ca)+ea(ea(va*ba)+ea(ua*$)));Q=ea(ea(za*ca)+ea(ea(ya*ba)+ea(xa*$)));$=ea(ea(wa*ga)+ea(ea(va*fa)+ea(ua*da)));ua=ea(ea(za*ga)+ea(ea(ya*fa)+ea(xa*da)));da=ea(ea($*aa)-ea(ha*ua));xa=ea(ea(ha*Q)-ea(_*aa));aa=ea(ea(1.0)/ea(ea(ea(_*ua)-ea($*Q))+ea(da+xa)));Q=ea(da*aa);da=ea(xa*aa);aa=ea(z+ea(ea(ea(ia-z)*Q)+ea(ea(oa-z)*da)));z=ea(J+ea(ea(ea(ja-J)*Q)+ea(ea(pa-J)*da)));J=ea(D+ea(ea(ea(ka-D)*Q)+ea(ea(qa-D)*da)));D=ea(M+ea(ea(ea(la-M)*Q)+ea(ea(ra-M)*da)));M=ea(V+ea(ea(ea(ma-V)*Q)+ea(ea(sa-V)*da)));V=ea(t+ea(ea(ea(na-t)*Q)+ea(ea(ta-t)*da)));g[j>>2]=aa;g[j+4>>2]=z;g[j+8>>2]=J;g[j+12>>2]=ea(0.0);g[k>>2]=D;g[k+4>>2]=M;g[k+8>>2]=V;g[k+12>>2]=ea(0.0);da=ea(z-M);M=ea(J-V);g[a>>2]=ea(aa-D);g[a+4>>2]=da;g[a+8>>2]=M;g[a+12>>2]=ea(0.0);i=l;return}function tPa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=0,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0;k=i;i=i+448|0;l=k+352|0;m=k+192|0;n=k+16|0;o=k+64|0;p=k+412|0;q=k+208|0;r=k+288|0;s=k+96|0;t=k+80|0;u=k+32|0;v=k+48|0;w=k+368|0;x=k+380|0;y=k+272|0;z=k+428|0;A=k+408|0;B=k;C=k+384|0;D=k+440|0;E=k+160|0;F=k+396|0;G=k+424|0;H=k+176|0;I=c[f>>2]|0;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];J=b+16|0;c[m+0>>2]=c[J+0>>2];c[m+4>>2]=c[J+4>>2];c[m+8>>2]=c[J+8>>2];c[m+12>>2]=c[J+12>>2];K=b+32|0;c[n+0>>2]=c[K+0>>2];c[n+4>>2]=c[K+4>>2];c[n+8>>2]=c[K+8>>2];c[n+12>>2]=c[K+12>>2];L=b+48|0;c[o+0>>2]=c[L+0>>2];c[o+4>>2]=c[L+4>>2];c[o+8>>2]=c[L+8>>2];c[o+12>>2]=c[L+12>>2];M=ea(g[o>>2]);N=ea(g[o+4>>2]);O=ea(g[o+8>>2]);P=ea(g[l>>2]);Q=ea(g[l+4>>2]);R=ea(M-P);P=ea(N-Q);Q=ea(O-ea(g[l+8>>2]));S=ea(g[m>>2]);T=ea(g[m+4>>2]);U=ea(M-S);S=ea(N-T);T=ea(O-ea(g[m+8>>2]));V=ea(g[n>>2]);W=ea(g[n+4>>2]);X=ea(M-V);V=ea(N-W);W=ea(O-ea(g[n+8>>2]));O=ea(ea(ea(R*R)+ea(P*P))+ea(Q*Q));Q=ea(ea(ea(U*U)+ea(S*S))+ea(T*T));T=ea(ea(ea(X*X)+ea(V*V))+ea(W*W));W=Q>T?T:Q;if((O>W?W:O)<ea(1.1920929e-07)){c[f>>2]=3;c[p+0>>2]=c[135316];c[p+4>>2]=c[135317];c[p+8>>2]=c[135318];sPa(a,b,d,e,p,f,h,j);i=k;return};c[q+0>>2]=c[b+0>>2];c[q+4>>2]=c[b+4>>2];c[q+8>>2]=c[b+8>>2];c[q+12>>2]=c[b+12>>2];p=q+16|0;c[p+0>>2]=c[J+0>>2];c[p+4>>2]=c[J+4>>2];c[p+8>>2]=c[J+8>>2];c[p+12>>2]=c[J+12>>2];p=q+32|0;c[p+0>>2]=c[K+0>>2];c[p+4>>2]=c[K+4>>2];c[p+8>>2]=c[K+8>>2];c[p+12>>2]=c[K+12>>2];p=q+48|0;c[p+0>>2]=c[L+0>>2];c[p+4>>2]=c[L+4>>2];c[p+8>>2]=c[L+8>>2];c[p+12>>2]=c[L+12>>2];c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];L=r+16|0;p=d+16|0;c[L+0>>2]=c[p+0>>2];c[L+4>>2]=c[p+4>>2];c[L+8>>2]=c[p+8>>2];c[L+12>>2]=c[p+12>>2];L=r+32|0;Y=d+32|0;c[L+0>>2]=c[Y+0>>2];c[L+4>>2]=c[Y+4>>2];c[L+8>>2]=c[Y+8>>2];c[L+12>>2]=c[Y+12>>2];L=r+48|0;Z=d+48|0;c[L+0>>2]=c[Z+0>>2];c[L+4>>2]=c[Z+4>>2];c[L+8>>2]=c[Z+8>>2];c[L+12>>2]=c[Z+12>>2];c[s+0>>2]=c[e+0>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];c[s+12>>2]=c[e+12>>2];Z=s+16|0;L=e+16|0;c[Z+0>>2]=c[L+0>>2];c[Z+4>>2]=c[L+4>>2];c[Z+8>>2]=c[L+8>>2];c[Z+12>>2]=c[L+12>>2];Z=s+32|0;_=e+32|0;c[Z+0>>2]=c[_+0>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];c[Z+12>>2]=c[_+12>>2];Z=s+48|0;$=e+48|0;c[Z+0>>2]=c[$+0>>2];c[Z+4>>2]=c[$+4>>2];c[Z+8>>2]=c[$+8>>2];c[Z+12>>2]=c[$+12>>2];Z6a(t,l,m,n,o);o=c[t>>2]|0;n=c[t+4>>2]|0;m=c[t+8>>2]|0;l=t+12|0;if((n|o|m|0)==0&(c[l>>2]|0)==0){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=k;return}if((o|0)==-1){c[w+0>>2]=c[135316];c[w+4>>2]=c[135317];c[w+8>>2]=c[135318];c[x>>2]=3;sPa(y,q,r,s,w,x,u,v);O=ea(g[y>>2]);W=ea(g[y+4>>2]);Q=ea(g[y+8>>2]);T=ea(g[y+12>>2]);V=ea(ea(ea(O*O)+ea(W*W))+ea(Q*Q));y=c[w>>2]|0;o=c[w+4>>2]|0;t=c[w+8>>2]|0;w=c[x>>2]|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];aa=V;ba=T;ca=Q;da=W;fa=O;ga=y;ha=o;ia=t;ja=w}else{aa=ea(3402823469999999843913219.0e14);ba=ea(0.0);ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=0;ha=1;ia=2;ja=I}if((n|0)==-1?(c[z+0>>2]=c[135320],c[z+4>>2]=c[135321],c[z+8>>2]=c[135322],c[A>>2]=3,sPa(B,q,r,s,z,A,u,v),O=ea(g[B>>2]),W=ea(g[B+4>>2]),Q=ea(g[B+8>>2]),T=ea(ea(ea(O*O)+ea(W*W))+ea(Q*Q)),aa>T):0){V=ea(g[B+12>>2]);B=c[z>>2]|0;n=c[z+4>>2]|0;I=c[z+8>>2]|0;z=c[A>>2]|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];ka=T;la=V;ma=Q;na=W;oa=O;pa=B;qa=n;ra=I;sa=z}else{ka=aa;la=ba;ma=ca;na=da;oa=fa;pa=ga;qa=ha;ra=ia;sa=ja}if((m|0)==-1?(c[C+0>>2]=c[135324],c[C+4>>2]=c[135325],c[C+8>>2]=c[135326],c[D>>2]=3,sPa(E,q,r,s,C,D,u,v),fa=ea(g[E>>2]),da=ea(g[E+4>>2]),ca=ea(g[E+8>>2]),ba=ea(ea(ea(fa*fa)+ea(da*da))+ea(ca*ca)),ka>ba):0){aa=ea(g[E+12>>2]);E=c[C>>2]|0;m=c[C+4>>2]|0;ja=c[C+8>>2]|0;C=c[D>>2]|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];ta=ba;ua=aa;va=ca;wa=da;xa=fa;ya=E;za=m;Aa=ja;Ba=C}else{ta=ka;ua=la;va=ma;wa=na;xa=oa;ya=pa;za=qa;Aa=ra;Ba=sa}if((c[l>>2]|0)==-1?(c[F+0>>2]=c[135328],c[F+4>>2]=c[135329],c[F+8>>2]=c[135330],c[G>>2]=3,sPa(H,q,r,s,F,G,u,v),oa=ea(g[H>>2]),na=ea(g[H+4>>2]),ma=ea(g[H+8>>2]),ta>ea(ea(ea(oa*oa)+ea(na*na))+ea(ma*ma))):0){ta=ea(g[H+12>>2]);H=c[F>>2]|0;l=c[F+4>>2]|0;sa=c[F+8>>2]|0;F=c[G>>2]|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];Ca=oa;Da=na;Ea=ma;Fa=ta;Ga=H;Ha=l;Ia=sa;Ja=F}else{Ca=xa;Da=wa;Ea=va;Fa=ua;Ga=ya;Ha=za;Ia=Aa;Ja=Ba}Ba=r+(Ga<<4)|0;c[d+0>>2]=c[Ba+0>>2];c[d+4>>2]=c[Ba+4>>2];c[d+8>>2]=c[Ba+8>>2];c[d+12>>2]=c[Ba+12>>2];Ba=r+(Ha<<4)|0;c[p+0>>2]=c[Ba+0>>2];c[p+4>>2]=c[Ba+4>>2];c[p+8>>2]=c[Ba+8>>2];c[p+12>>2]=c[Ba+12>>2];Ba=r+(Ia<<4)|0;c[Y+0>>2]=c[Ba+0>>2];c[Y+4>>2]=c[Ba+4>>2];c[Y+8>>2]=c[Ba+8>>2];c[Y+12>>2]=c[Ba+12>>2];Ba=s+(Ga<<4)|0;c[e+0>>2]=c[Ba+0>>2];c[e+4>>2]=c[Ba+4>>2];c[e+8>>2]=c[Ba+8>>2];c[e+12>>2]=c[Ba+12>>2];Ba=s+(Ha<<4)|0;c[L+0>>2]=c[Ba+0>>2];c[L+4>>2]=c[Ba+4>>2];c[L+8>>2]=c[Ba+8>>2];c[L+12>>2]=c[Ba+12>>2];Ba=s+(Ia<<4)|0;c[_+0>>2]=c[Ba+0>>2];c[_+4>>2]=c[Ba+4>>2];c[_+8>>2]=c[Ba+8>>2];c[_+12>>2]=c[Ba+12>>2];Ba=q+(Ga<<4)|0;c[b+0>>2]=c[Ba+0>>2];c[b+4>>2]=c[Ba+4>>2];c[b+8>>2]=c[Ba+8>>2];c[b+12>>2]=c[Ba+12>>2];Ba=q+(Ha<<4)|0;c[J+0>>2]=c[Ba+0>>2];c[J+4>>2]=c[Ba+4>>2];c[J+8>>2]=c[Ba+8>>2];c[J+12>>2]=c[Ba+12>>2];Ba=q+(Ia<<4)|0;c[K+0>>2]=c[Ba+0>>2];c[K+4>>2]=c[Ba+4>>2];c[K+8>>2]=c[Ba+8>>2];c[K+12>>2]=c[Ba+12>>2];c[f>>2]=Ja;g[a>>2]=Ca;g[a+4>>2]=Da;g[a+8>>2]=Ea;g[a+12>>2]=Fa;i=k;return}function uPa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=o7a(a,b,c,d,e,f,g)|0;i=h;return j|0}function vPa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=r7a(a,b,c,d,e,f,g)|0;i=h;return j|0}function wPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=s7a(a,b,c,d,e,f)|0;i=g;return h|0}function xPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=t7a(a,b,c,d,e,f)|0;i=g;return h|0}function yPa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=0;l=i;i=i+32|0;m=l+8|0;n=l;o=p7a(a,b,d,f,h,j,k)|0;if((o|0)==1){p=1;i=l;return p|0}q=ea(g[e>>2]);if(q>ea(g[k>>2])){p=1;i=l;return p|0}r=(o|0)==3;if(!r){p=r?3:0;i=l;return p|0}c[m>>2]=541592;c[m+4>>2]=a;c[m+8>>2]=d;c[n>>2]=541528;c[n+4>>2]=b;r=mPa(a,b,m,n,d+48|0,f,h,j,k)|0;if((r|0)!=3){p=r;i=l;return p|0}q=ea(g[e>>2]);p=q>ea(g[k>>2])&1;i=l;return p|0}function zPa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=0;l=i;i=i+32|0;m=l+8|0;n=l;o=q7a(a,b,d,f,h,j,k)|0;if((o|0)==1){p=1;i=l;return p|0}q=ea(g[e>>2]);if(q>ea(g[k>>2])){p=1;i=l;return p|0}r=(o|0)==3;if(!r){p=r?3:0;i=l;return p|0}c[m>>2]=541560;c[m+4>>2]=a;c[m+8>>2]=d;c[n>>2]=541528;c[n+4>>2]=b;r=mPa(a,b,m,n,d+48|0,f,h,j,k)|0;if((r|0)!=3){p=r;i=l;return p|0}q=ea(g[e>>2]);p=q>ea(g[k>>2])&1;i=l;return p|0}function APa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=ea(j);k=k|0;var l=0,m=0;l=i;m=u7a(a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function BPa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=ea(j);k=k|0;var l=0,m=0;l=i;m=v7a(a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function CPa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=ea(j);k=k|0;var l=0,m=0;l=i;m=w7a(a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function DPa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=ea(j);k=k|0;var l=0,m=0;l=i;m=x7a(a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function EPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=y7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function FPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=z7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function GPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=A7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function HPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=B7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function IPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=C7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function JPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=D7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function KPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=E7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function LPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=F7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function MPa(a,b,c,d,e,f,g,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0;m=i;n=G7a(a,b,c,d,e,f,g,h,j,k,l)|0;i=m;return n|0}function NPa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im;j=i;i=i+96|0;k=j+72|0;l=j+36|0;m=j;n=ea(g[e>>2]);o=ea(n-ea(g[b>>2]));n=ea(g[e+4>>2]);p=ea(n-ea(g[b+4>>2]));n=ea(g[e+8>>2]);q=ea(n-ea(g[b+8>>2]));n=ea(o*ea(g[c>>2]));r=ea(n+ea(p*ea(g[c+4>>2])));n=ea(r+ea(q*ea(g[c+8>>2])));r=ea(o*ea(g[c+12>>2]));s=ea(r+ea(p*ea(g[c+16>>2])));r=ea(s+ea(q*ea(g[c+20>>2])));s=ea(o*ea(g[c+24>>2]));o=ea(s+ea(p*ea(g[c+28>>2])));p=ea(o+ea(q*ea(g[c+32>>2])));g[k>>2]=n;g[k+4>>2]=r;g[k+8>>2]=p;q=ea(g[f>>2]);o=ea(g[f+4>>2]);s=ea(g[f+8>>2]);t=ea(g[f+12>>2]);u=ea(g[f+16>>2]);v=ea(g[f+20>>2]);w=ea(g[f+24>>2]);x=ea(g[f+28>>2]);y=ea(g[f+32>>2]);f=0;do{z=ea(g[c+(f*12|0)>>2]);A=ea(g[c+(f*12|0)+4>>2]);B=ea(g[c+(f*12|0)+8>>2]);C=ea(ea(ea(z*q)+ea(A*o))+ea(B*s));g[l+(f*12|0)>>2]=C;g[m+(f*12|0)>>2]=ea(ea(S(ea(C)))+ea(9.99999997e-07));C=ea(ea(ea(z*t)+ea(A*u))+ea(B*v));g[l+(f*12|0)+4>>2]=C;g[m+(f*12|0)+4>>2]=ea(ea(S(ea(C)))+ea(9.99999997e-07));C=ea(ea(ea(z*w)+ea(A*x))+ea(B*y));g[l+(f*12|0)+8>>2]=C;g[m+(f*12|0)+8>>2]=ea(ea(S(ea(C)))+ea(9.99999997e-07));f=f+1|0}while((f|0)!=3);y=ea(g[d>>2]);x=ea(g[d+4>>2]);w=ea(g[d+8>>2]);v=n;f=0;while(1){u=ea(g[a+(f<<2)>>2]);t=ea(y*ea(g[m+(f*12|0)>>2]));s=ea(t+ea(x*ea(g[m+(f*12|0)+4>>2])));c=f+1|0;if(ea(S(ea(v)))>ea(u+ea(s+ea(w*ea(g[m+(f*12|0)+8>>2]))))){D=0;E=22;break}if(c>>>0>=3)break;v=ea(g[k+(c<<2)>>2]);f=c}if((E|0)==22){i=j;return D|0}v=ea(g[a>>2]);s=ea(g[a+4>>2]);u=ea(g[a+8>>2]);t=y;a=0;while(1){o=ea(v*ea(g[m+(a<<2)>>2]));q=ea(o+ea(s*ea(g[m+(a<<2)+12>>2])));o=ea(q+ea(u*ea(g[m+(a<<2)+24>>2])));q=ea(n*ea(g[l+(a<<2)>>2]));C=ea(q+ea(r*ea(g[l+(a<<2)+12>>2])));f=a+1|0;if(ea(S(ea(C+ea(p*ea(g[l+(a<<2)+24>>2])))))>ea(t+o)){D=0;E=22;break}if(f>>>0>=3)break;t=ea(g[d+(f<<2)>>2]);a=f}if((E|0)==22){i=j;return D|0}if(h){t=ea(g[m+24>>2]);o=ea(s*t);C=ea(g[m+12>>2]);q=ea(o+ea(u*C));o=ea(g[m+8>>2]);B=ea(x*o);A=ea(g[m+4>>2]);z=ea(B+ea(w*A));B=ea(g[l+12>>2]);F=ea(p*B);G=ea(g[l+24>>2]);if(ea(S(ea(F-ea(r*G))))>ea(q+z)){D=0;i=j;return D|0}z=ea(g[m+28>>2]);q=ea(s*z);F=ea(g[m+16>>2]);H=ea(q+ea(u*F));q=ea(o*y);I=ea(g[m>>2]);J=ea(q+ea(w*I));q=ea(g[l+16>>2]);K=ea(p*q);L=ea(g[l+28>>2]);if(ea(S(ea(K-ea(r*L))))>ea(H+J)){D=0;i=j;return D|0}J=ea(g[m+32>>2]);H=ea(s*J);K=ea(g[m+20>>2]);M=ea(H+ea(u*K));H=ea(ea(A*y)+ea(x*I));N=ea(g[l+20>>2]);O=ea(p*N);P=ea(g[l+32>>2]);if(ea(S(ea(O-ea(r*P))))>ea(H+M)){D=0;i=j;return D|0}M=ea(ea(u*I)+ea(t*v));H=ea(ea(w*F)+ea(x*K));O=ea(G*n);G=ea(g[l>>2]);if(ea(S(ea(O-ea(p*G))))>ea(H+M)){D=0;i=j;return D|0}M=ea(ea(u*A)+ea(z*v));H=ea(ea(C*w)+ea(y*K));O=ea(L*n);L=ea(g[l+4>>2]);if(ea(S(ea(O-ea(p*L))))>ea(H+M)){D=0;i=j;return D|0}M=ea(ea(u*o)+ea(J*v));u=ea(ea(C*x)+ea(F*y));H=ea(P*n);P=ea(g[l+8>>2]);if(ea(S(ea(H-ea(p*P))))>ea(u+M)){D=0;i=j;return D|0}if(ea(S(ea(ea(r*G)-ea(B*n))))>ea(ea(ea(w*z)+ea(x*J))+ea(ea(s*I)+ea(C*v)))){D=0;i=j;return D|0}if(ea(S(ea(ea(r*L)-ea(q*n))))>ea(ea(ea(t*w)+ea(y*J))+ea(ea(s*A)+ea(F*v)))){D=0;i=j;return D|0}if(ea(S(ea(ea(r*P)-ea(N*n))))>ea(ea(ea(t*x)+ea(z*y))+ea(ea(s*o)+ea(K*v)))){D=0;i=j;return D|0}}D=1;i=j;return D|0}function OPa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=Im,n=Im,o=0,p=0,q=Im,r=Im,s=0,t=0,u=Im,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0;j=i;i=i+16|0;k=j;l=ea(g[b>>2]);m=ea(g[a>>2]);n=ea(l-m);o=b+4|0;l=ea(g[o>>2]);p=a+4|0;q=ea(g[p>>2]);r=ea(l-q);s=b+8|0;l=ea(g[s>>2]);t=a+8|0;u=ea(g[t>>2]);v=ea(l-u);g[k>>2]=n;g[k+4>>2]=r;g[k+8>>2]=v;w=c+8|0;l=ea(g[w>>2]);x=ea(r*l);y=c+4|0;z=ea(g[y>>2]);A=ea(x-ea(v*z));x=ea(g[c>>2]);B=ea(ea(v*x)-ea(l*n));l=ea(ea(z*n)-ea(r*x));x=ea(ea(ea(A*m)+ea(B*q))+ea(l*u));u=ea(g[d>>2]);q=ea(A*u);m=ea(g[d+4>>2]);r=ea(q+ea(B*m));q=ea(g[d+8>>2]);n=ea(ea(r+ea(l*q))-x);r=ea(g[e>>2]);z=ea(A*r);v=ea(g[e+4>>2]);C=ea(z+ea(B*v));z=ea(g[e+8>>2]);if(ea(n*ea(ea(C+ea(l*z))-x))>ea(0.0)){D=0;i=j;return D|0}x=ea(r-u);r=ea(v-m);v=ea(z-q);z=ea(ea(ea(A*x)+ea(B*r))+ea(l*v));if(z==ea(0.0)){D=0;i=j;return D|0}C=ea(n/z);z=ea(m-ea(r*C));r=ea(q-ea(v*C));g[h>>2]=ea(u-ea(x*C));e=h+4|0;g[e>>2]=z;d=h+8|0;g[d>>2]=r;r=ea(S(ea(A)));A=ea(S(ea(B)));B=ea(S(ea(l)));if(!(A>r&A>B))if(B>r){E=0;F=1}else{E=1;F=2}else{E=2;F=0}r=ea(g[k+(E<<2)>>2]);B=ea(g[h+(F<<2)>>2]);A=ea(r*ea(B-ea(g[a+(F<<2)>>2])));B=ea(g[k+(F<<2)>>2]);l=ea(g[h+(E<<2)>>2]);z=ea(A-ea(B*ea(l-ea(g[a+(E<<2)>>2]))));l=ea(r*ea(g[c+(F<<2)>>2]));r=ea(z/ea(l-ea(B*ea(g[c+(E<<2)>>2]))));g[f>>2]=r;if(r<ea(0.0)){D=0;i=j;return D|0}B=ea(g[c>>2]);l=ea(g[y>>2]);z=ea(r*B);B=ea(r*l);l=ea(r*ea(g[w>>2]));r=ea(ea(g[h>>2])-z);g[h>>2]=r;z=ea(ea(g[e>>2])-B);g[e>>2]=z;B=ea(ea(g[d>>2])-l);g[d>>2]=B;l=ea(ea(g[a>>2])-r);A=ea(l*ea(ea(g[b>>2])-r));r=ea(ea(g[p>>2])-z);l=ea(A+ea(r*ea(ea(g[o>>2])-z)));z=ea(ea(g[t>>2])-B);D=ea(l+ea(z*ea(ea(g[s>>2])-B)))<ea(0.0);i=j;return D|0}function PPa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,l=0,m=Im,n=Im,o=0,p=Im,q=0,r=Im,s=Im,t=0,u=0,v=Im,w=0,x=Im,y=Im,z=0,A=0,B=0;j=i;i=i+16|0;l=j;g[l>>2]=ea(-1.0);g[l+4>>2]=ea(-1.0);g[l+8>>2]=ea(-1.0);m=ea(g[d>>2]);n=ea(g[a>>2]);if(m<n){g[f>>2]=n;o=c[e>>2]|0;if(!o){p=ea(-1.0);q=0}else{n=(c[k>>2]=o,ea(g[k>>2]));r=ea(g[a>>2]);s=ea(ea(r-ea(g[d>>2]))/n);g[l>>2]=s;p=s;q=0}}else{s=ea(g[b>>2]);if(m>s){g[f>>2]=s;o=c[e>>2]|0;if(!o){p=ea(-1.0);q=0}else{s=(c[k>>2]=o,ea(g[k>>2]));m=ea(g[b>>2]);n=ea(ea(m-ea(g[d>>2]))/s);g[l>>2]=n;p=n;q=0}}else{p=ea(-1.0);q=1}}o=d+4|0;n=ea(g[o>>2]);t=a+4|0;s=ea(g[t>>2]);if(n<s){g[f+4>>2]=s;u=c[e+4>>2]|0;if(!u){v=ea(-1.0);w=0}else{s=(c[k>>2]=u,ea(g[k>>2]));m=ea(g[t>>2]);r=ea(ea(m-ea(g[o>>2]))/s);g[l+4>>2]=r;v=r;w=0}}else{t=b+4|0;r=ea(g[t>>2]);if(n>r){g[f+4>>2]=r;u=c[e+4>>2]|0;if(!u){v=ea(-1.0);w=0}else{r=(c[k>>2]=u,ea(g[k>>2]));n=ea(g[t>>2]);s=ea(ea(n-ea(g[o>>2]))/r);g[l+4>>2]=s;v=s;w=0}}else{v=ea(-1.0);w=q}}q=d+8|0;s=ea(g[q>>2]);o=a+8|0;r=ea(g[o>>2]);do if(s<r){g[f+8>>2]=r;t=c[e+8>>2]|0;if(!t)x=ea(-1.0);else{n=(c[k>>2]=t,ea(g[k>>2]));m=ea(g[o>>2]);y=ea(ea(m-ea(g[q>>2]))/n);g[l+8>>2]=y;x=y}}else{t=b+8|0;y=ea(g[t>>2]);if(s>y){g[f+8>>2]=y;u=c[e+8>>2]|0;if(!u){x=ea(-1.0);break}y=(c[k>>2]=u,ea(g[k>>2]));n=ea(g[t>>2]);m=ea(ea(n-ea(g[q>>2]))/y);g[l+8>>2]=m;x=m;break}if(!w)x=ea(-1.0);else{g[f>>2]=ea(g[d>>2]);g[f+4>>2]=ea(g[d+4>>2]);g[f+8>>2]=ea(g[d+8>>2]);g[h>>2]=ea(0.0);z=1;i=j;return z|0}}while(0);w=v>p&1;q=x>ea(g[l+(w<<2)>>2]);o=q?2:w;w=c[l+(o<<2)>>2]|0;x=(c[k>>2]=w,ea(g[k>>2]));if((w|0)<0){z=0;i=j;return z|0}else A=0;while(1){if((A|0)!=(o|0)){p=ea(g[d+(A<<2)>>2]);v=ea(p+ea(x*ea(g[e+(A<<2)>>2])));g[f+(A<<2)>>2]=v;if(v<ea(ea(g[a+(A<<2)>>2])+ea(-9.99999974e-06))){z=0;B=15;break}if(v>ea(ea(g[b+(A<<2)>>2])+ea(9.99999974e-06))){z=0;B=15;break}}A=A+1|0;if(A>>>0>=3){B=14;break}}if((B|0)==14){g[h>>2]=x;z=o+1|0;i=j;return z|0}else if((B|0)==15){i=j;return z|0}return 0}function QPa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=0,l=0,m=Im,n=Im,o=0,p=Im,q=0,r=Im,s=Im,t=0,u=Im,v=Im,w=0,x=Im,y=Im;h=i;g[e>>2]=ea(-3402823469999999843913219.0e14);g[f>>2]=ea(3402823469999999843913219.0e14);j=ea(3402823469999999843913219.0e14);k=0;l=-1;while(1){m=ea(g[d+(k<<2)>>2]);if(m>ea(-1.1920929e-07)&m<ea(1.1920929e-07)){n=ea(g[c+(k<<2)>>2]);if(n<ea(g[a+(k<<2)>>2])){o=12;break}if(n>ea(g[b+(k<<2)>>2])){o=12;break}else{p=j;q=l}}else{n=ea(ea(1.0)/m);m=ea(g[a+(k<<2)>>2]);r=ea(g[c+(k<<2)>>2]);s=ea(n*ea(m-r));m=ea(n*ea(ea(g[b+(k<<2)>>2])-r));t=s>m;r=t?m:s;n=t?s:m;m=ea(g[e>>2]);if(r>m){g[e>>2]=r;u=ea(g[f>>2]);v=r;w=t?k+3|0:k}else{u=j;v=m;w=l}if(n<u){g[f>>2]=n;x=ea(g[e>>2]);y=n}else{x=v;y=u}if(x>y|y<ea(1.1920929e-07)){o=12;break}else{p=y;q=w}}k=k+1|0;if((k|0)>=3){o=11;break}else{j=p;l=q}}if((o|0)==11){l=p<ea(1.1920929e-07)?1:ea(g[e>>2])>p;i=h;return (l?-1:q)|0}else if((o|0)==12){i=h;return -1}return 0}function RPa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;h=h|0;var i=Im,j=Im,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;i=ea(g[d>>2]);j=ea(S(ea(i)));k=j>ea(9.99999971e-10);l=k?j:ea(9.99999971e-10);k=i>=ea(0.0);i=ea(ea(1.0)/ea((k?ea(1.0):ea(-1.0))*l));l=ea(g[a>>2]);j=ea(g[c>>2]);m=ea(i*ea(l-j));l=ea(i*ea(ea(g[b>>2])-j));j=m<l?m:l;i=m>l?m:l;l=ea(g[d+4>>2]);m=ea(S(ea(l)));k=m>ea(9.99999971e-10);n=k?m:ea(9.99999971e-10);k=l>=ea(0.0);l=ea(ea(1.0)/ea((k?ea(1.0):ea(-1.0))*n));n=ea(g[a+4>>2]);m=ea(g[c+4>>2]);o=ea(l*ea(n-m));n=ea(l*ea(ea(g[b+4>>2])-m));m=o<n?o:n;l=o>n?o:n;n=ea(g[d+8>>2]);o=ea(S(ea(n)));d=o>ea(9.99999971e-10);p=d?o:ea(9.99999971e-10);d=n>=ea(0.0);n=ea(ea(1.0)/ea((d?ea(1.0):ea(-1.0))*p));p=ea(g[a+8>>2]);o=ea(g[c+8>>2]);q=ea(n*ea(p-o));p=ea(n*ea(ea(g[b+8>>2])-o));o=q<p?q:p;n=q>p?q:p;p=j>m?j:m;m=p>o?p:o;o=i<l?i:l;l=o<n?o:n;b=m>ea(0.0);g[f>>2]=b?m:ea(0.0);m=l<e?l:e;g[h>>2]=m;h=ea(g[f>>2])<m;return h|0}function SPa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;k=i;i=i+32|0;l=k+12|0;m=k;n=ea(g[e>>2]);o=ea(g[e+4>>2]);p=ea(g[e+8>>2]);q=ea(-n);r=ea(-o);s=ea(-p);t=n>q?n:q;q=o>r?o:r;r=p>s?p:s;e=t>ea(9.99999971e-10);s=e?t:ea(9.99999971e-10);e=q>ea(9.99999971e-10);t=e?q:ea(9.99999971e-10);e=r>ea(9.99999971e-10);q=e?r:ea(9.99999971e-10);e=n>=ea(0.0);n=e?ea(1.0):ea(-1.0);e=o>=ea(0.0);o=e?ea(1.0):ea(-1.0);e=p>=ea(0.0);p=ea(ea(1.0)/ea(n*s));s=ea(ea(1.0)/ea(o*t));t=ea(ea(1.0)/ea((e?ea(1.0):ea(-1.0))*q));q=ea(g[a>>2]);o=ea(g[a+4>>2]);n=ea(g[a+8>>2]);r=ea(g[d>>2]);u=ea(g[d+4>>2]);v=ea(g[d+8>>2]);w=ea(p*ea(q-r));q=ea(s*ea(o-u));o=ea(t*ea(n-v));n=ea(g[b>>2]);x=ea(g[b+4>>2]);y=ea(p*ea(n-r));r=ea(s*ea(x-u));u=ea(t*ea(ea(g[b+8>>2])-v));v=y<w?y:w;t=r<q?r:q;x=u<o?u:o;s=y>w?y:w;w=r>q?r:q;q=u>o?u:o;o=t>x?t:x;x=v>o?v:o;o=w>q?q:w;w=s>o?o:s;b=x>ea(0.0);g[h>>2]=b?x:ea(0.0);b=h+4|0;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];x=ea(g[f>>2]);s=w>x?x:w;g[j>>2]=s;f=j+4|0;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];m=s>ea(g[h>>2]);i=k;return m|0}function TPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;f=ea(g[c+12>>2]);h=ea(g[c>>2]);j=ea(f-h);k=ea(g[c+16>>2]);l=ea(g[c+4>>2]);m=ea(k-l);n=ea(g[c+20>>2]);o=ea(g[c+8>>2]);p=ea(n-o);q=ea(T(ea(ea(ea(j*j)+ea(m*m))+ea(p*p))));r=q>ea(0.0);if(r){s=ea(ea(1.0)/q);t=ea(j*s);u=ea(m*s);v=ea(p*s)}else{t=j;u=m;v=p}if(q<=ea(9.99999997e-07)){s=ea(g[a>>2]);w=ea(s-h);x=ea(g[a+4>>2]);y=ea(x-l);z=ea(g[a+8>>2]);A=ea(z-o);B=ea(ea(ea(w*w)+ea(y*y))+ea(A*A));A=ea(s-f);f=ea(x-k);k=ea(z-n);n=ea(ea(ea(A*A)+ea(f*f))+ea(k*k));k=ea(g[c+24>>2]);C=(UPa(a,b,ea(ea(k+(B>n?B:n))*ea(2.0)),c,k,d,0)|0)&1;i=e;return C|0}do if(r)if(!(ea(S(ea(t)))>=ea(S(ea(u))))){k=ea(ea(1.0)/ea(T(ea(ea(v*v)+ea(u*u)))));D=ea(-ea(u*k));E=ea(v*k);F=ea(0.0);break}else{k=ea(ea(1.0)/ea(T(ea(ea(v*v)+ea(t*t)))));D=ea(t*k);E=ea(0.0);F=ea(-ea(v*k));break}else{D=ea(0.0);E=ea(0.0);F=ea(0.0)}while(0);k=ea(ea(u*D)-ea(v*E));n=ea(ea(v*F)-ea(t*D));B=ea(ea(t*E)-ea(u*F));f=ea(T(ea(ea(B*B)+ea(ea(k*k)+ea(n*n)))));if(f>ea(0.0)){A=ea(ea(1.0)/f);G=ea(k*A);H=ea(n*A);I=ea(B*A)}else{G=k;H=n;I=B}B=ea(g[b>>2]);n=ea(F*B);k=ea(g[b+4>>2]);A=ea(n+ea(E*k));n=ea(g[b+8>>2]);f=ea(A+ea(D*n));A=ea(ea(ea(G*B)+ea(H*k))+ea(I*n));z=ea(ea(ea(t*B)+ea(u*k))+ea(v*n));x=ea(T(ea(ea(z*z)+ea(ea(f*f)+ea(A*A)))));s=ea(ea(1.0)/x);if(x>ea(0.0)){J=ea(z*s);K=ea(f*s);L=ea(A*s)}else{J=z;K=f;L=A}A=ea(ea(g[a>>2])-h);h=ea(ea(g[a+4>>2])-l);l=ea(ea(g[a+8>>2])-o);o=ea(ea(ea(F*A)+ea(E*h))+ea(D*l));D=ea(ea(ea(G*A)+ea(H*h))+ea(I*l));I=ea(ea(ea(t*A)+ea(u*h))+ea(v*l));l=ea(g[c+24>>2]);v=ea(l*l);if(ea(S(ea(J)))>=ea(.99999988)|x<ea(1.1920929e-07)){x=ea(ea(ea(j*B)+ea(m*k))+ea(p*n));n=ea(ea(v-ea(o*o))-ea(D*D));c=!(n>=ea(0.0));if(!(!(x<ea(0.0))|c)){p=ea(T(ea(n)));g[d>>2]=ea(s*ea(I+p));g[d+4>>2]=ea(-ea(s*ea(ea(q-I)+p)));C=2;i=e;return C|0}if(!(x>ea(0.0))|c){C=0;i=e;return C|0}x=ea(T(ea(n)));g[d>>2]=ea(-ea(s*ea(I+x)));g[d+4>>2]=ea(s*ea(ea(q-I)+x));C=2;i=e;return C|0}x=ea(ea(L*L)+ea(K*K));n=ea(ea(K*o)+ea(L*D));L=ea(ea(ea(o*o)+ea(D*D))-v);v=ea(ea(n*n)-ea(x*L));if(v<ea(0.0)){C=0;i=e;return C|0}if(v>ea(0.0)){D=ea(T(ea(v)));v=ea(ea(1.0)/x);o=ea(ea(ea(-n)-D)*v);K=ea(I+ea(J*o));if(!(K>=ea(0.0))|!(K<=q))M=0;else{g[d>>2]=ea(s*o);M=1}o=ea(ea(D-n)*v);v=ea(I+ea(J*o));if(!(!(v>=ea(0.0))|!(v<=q))){c=M+1|0;g[d+(M<<2)>>2]=ea(s*o);if((c|0)==2){C=2;i=e;return C|0}else N=c}else N=M}else{o=ea(ea(-n)/x);x=ea(I+ea(J*o));if(!(x>=ea(0.0))|!(x<=q))N=0;else{g[d>>2]=ea(s*o);C=1;i=e;return C|0}}o=ea(ea(J*I)+n);n=ea(ea(I*I)+L);L=ea(ea(o*o)-n);if(L>ea(0.0)){x=ea(T(ea(L)));v=ea(ea(-o)-x);if(ea(I+ea(J*v))<=ea(0.0)){M=N+1|0;g[d+(N<<2)>>2]=ea(s*v);if((M|0)==2){C=2;i=e;return C|0}else O=M}else O=N;v=ea(x-o);if(ea(I+ea(J*v))<=ea(0.0)){M=O+1|0;g[d+(O<<2)>>2]=ea(s*v);if((M|0)==2){C=2;i=e;return C|0}else P=M}else P=O}else if(L==ea(0.0)?(L=ea(-o),ea(I+ea(J*L))<=ea(0.0)):0){O=N+1|0;g[d+(N<<2)>>2]=ea(s*L);if((O|0)==2){C=2;i=e;return C|0}else P=O}else P=N;L=ea(o-ea(q*J));o=ea(ea(L*L)-ea(ea(q*ea(q-ea(I*ea(2.0))))+n));if(o>ea(0.0)){n=ea(T(ea(o)));v=ea(ea(-L)-n);if(ea(I+ea(J*v))>=q){N=P+1|0;g[d+(P<<2)>>2]=ea(s*v);if((N|0)==2){C=2;i=e;return C|0}else Q=N}else Q=P;v=ea(n-L);if(ea(I+ea(J*v))>=q){N=Q+1|0;g[d+(Q<<2)>>2]=ea(s*v);if((N|0)==2){C=2;i=e;return C|0}else R=N}else R=Q}else if(o==ea(0.0)?(o=ea(-L),ea(I+ea(J*o))>=q):0){Q=P+1|0;g[d+(P<<2)>>2]=ea(s*o);if((Q|0)==2){C=2;i=e;return C|0}else R=Q}else R=P;C=R;i=e;return C|0}function UPa(a,b,c,d,e,f,h){a=a|0;b=b|0;c=ea(c);d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im;j=i;k=ea(g[a>>2]);l=ea(g[d>>2]);m=ea(k-l);n=ea(g[a+4>>2]);o=ea(g[d+4>>2]);p=ea(n-o);q=ea(g[a+8>>2]);r=ea(g[d+8>>2]);s=ea(q-r);t=ea(ea(ea(T(ea(ea(ea(m*m)+ea(p*p))+ea(s*s))))-e)+ea(-10.0));d=t>ea(0.0);s=d?t:ea(0.0);t=ea(g[b>>2]);d=b+4|0;p=ea(g[d>>2]);a=b+8|0;m=ea(g[a>>2]);u=ea(k+ea(t*s));k=ea(n+ea(p*s));n=ea(q+ea(m*s));q=ea(c-s);c=ea(l-u);l=ea(o-k);o=ea(r-n);r=ea(ea(m*o)+ea(ea(t*c)+ea(p*l)));p=ea(ea(o*o)+ea(ea(c*c)+ea(l*l)));l=ea(e*e);if(!(p<=l)){if(r<=ea(0.0)|ea(r-q)>e){v=0;i=j;return v|0}e=ea(l-ea(p-ea(r*r)));if(e<ea(0.0)){v=0;i=j;return v|0}p=ea(r-ea(T(ea(e))));g[f>>2]=p;if(p>q){v=0;i=j;return v|0}if(!h)w=p;else{q=ea(p*ea(g[b>>2]));e=ea(p*ea(g[d>>2]));r=ea(k+e);e=ea(n+ea(p*ea(g[a>>2])));g[h>>2]=ea(u+q);g[h+4>>2]=r;g[h+8>>2]=e;w=ea(g[f>>2])}}else{if(h){g[h>>2]=u;g[h+4>>2]=k;g[h+8>>2]=n}g[f>>2]=ea(0.0);w=ea(0.0)}g[f>>2]=ea(s+w);v=1;i=j;return v|0}function VPa(a,b,c,d,e,f,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);var l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0;l=i;m=ea(g[d>>2]);n=ea(g[c>>2]);o=ea(m-n);m=ea(g[d+4>>2]);p=ea(g[c+4>>2]);q=ea(m-p);m=ea(g[d+8>>2]);r=ea(g[c+8>>2]);s=ea(m-r);m=ea(ea(g[e>>2])-n);t=ea(ea(g[e+4>>2])-p);u=ea(ea(g[e+8>>2])-r);e=b+4|0;v=ea(g[e>>2]);w=ea(v*u);c=b+8|0;x=ea(g[c>>2]);y=ea(w-ea(t*x));w=ea(m*x);x=ea(g[b>>2]);z=ea(w-ea(u*x));w=ea(ea(t*x)-ea(m*v));v=ea(ea(s*w)+ea(ea(o*y)+ea(q*z)));if(v<ea(9.99999997e-07)){A=0;i=l;return A|0}x=ea(ea(g[a>>2])-n);n=ea(ea(g[a+4>>2])-p);p=ea(ea(g[a+8>>2])-r);r=ea(ea(ea(y*x)+ea(z*n))+ea(w*p));g[h>>2]=r;w=ea(-k);if(r<w){A=0;i=l;return A|0}z=ea(v+k);if(r>z){A=0;i=l;return A|0}r=ea(ea(s*n)-ea(q*p));k=ea(ea(o*p)-ea(s*x));s=ea(ea(q*x)-ea(o*n));n=ea(r*ea(g[b>>2]));o=ea(n+ea(k*ea(g[e>>2])));n=ea(o+ea(s*ea(g[c>>2])));g[j>>2]=n;if(n<w){A=0;i=l;return A|0}if(ea(n+ea(g[h>>2]))>z){A=0;i=l;return A|0}z=ea(ea(1.0)/v);g[f>>2]=ea(ea(ea(u*s)+ea(ea(m*r)+ea(t*k)))*z);g[h>>2]=ea(z*ea(g[h>>2]));g[j>>2]=ea(z*ea(g[j>>2]));A=1;i=l;return A|0}function WPa(a,b,c,d,e,f,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);var l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0;l=i;m=ea(g[d>>2]);n=ea(g[c>>2]);o=ea(m-n);m=ea(g[d+4>>2]);p=ea(g[c+4>>2]);q=ea(m-p);m=ea(g[d+8>>2]);r=ea(g[c+8>>2]);s=ea(m-r);m=ea(ea(g[e>>2])-n);t=ea(ea(g[e+4>>2])-p);u=ea(ea(g[e+8>>2])-r);e=b+4|0;v=ea(g[e>>2]);w=ea(v*u);c=b+8|0;x=ea(g[c>>2]);y=ea(w-ea(t*x));w=ea(m*x);x=ea(g[b>>2]);z=ea(w-ea(u*x));w=ea(ea(t*x)-ea(m*v));v=ea(ea(s*w)+ea(ea(o*y)+ea(q*z)));if(v>ea(-9.99999997e-07)&v<ea(9.99999997e-07)){A=0;i=l;return A|0}x=ea(ea(1.0)/v);v=ea(ea(g[a>>2])-n);n=ea(ea(g[a+4>>2])-p);p=ea(ea(g[a+8>>2])-r);r=ea(x*ea(ea(ea(y*v)+ea(z*n))+ea(w*p)));g[h>>2]=r;w=ea(-k);if(r<w){A=0;i=l;return A|0}z=ea(k+ea(1.0));if(r>z){A=0;i=l;return A|0}r=ea(ea(s*n)-ea(q*p));k=ea(ea(o*p)-ea(s*v));s=ea(ea(q*v)-ea(o*n));n=ea(r*ea(g[b>>2]));o=ea(n+ea(k*ea(g[e>>2])));n=ea(x*ea(o+ea(s*ea(g[c>>2]))));g[j>>2]=n;if(n<w){A=0;i=l;return A|0}if(ea(n+ea(g[h>>2]))>z){A=0;i=l;return A|0}g[f>>2]=ea(x*ea(ea(u*s)+ea(ea(m*r)+ea(t*k))));A=1;i=l;return A|0}function XPa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0;f=i;h=ea(g[c>>2]);j=ea(g[a>>2]);k=ea(h-j);h=ea(g[c+4>>2]);l=ea(g[a+4>>2]);m=ea(h-l);h=ea(g[c+8>>2]);n=ea(g[a+8>>2]);o=ea(h-n);h=ea(ea(g[d>>2])-j);p=ea(ea(g[d+4>>2])-l);q=ea(ea(g[d+8>>2])-n);r=ea(ea(g[e>>2])-j);j=ea(ea(g[e+4>>2])-l);l=ea(ea(g[e+8>>2])-n);n=ea(h-k);s=ea(p-m);t=ea(q-o);u=ea(r-h);v=ea(j-p);w=ea(l-q);x=ea(k-r);y=ea(m-j);z=ea(o-l);A=ea(S(ea(n)));B=ea(S(ea(s)));C=ea(S(ea(t)));D=ea(ea(m*t)-ea(o*s));E=ea(ea(t*j)-ea(s*l));F=ea(g[b+4>>2]);G=ea(C*F);H=ea(g[b+8>>2]);I=ea(G+ea(B*H));if((D<E?D:E)>I?1:(D>E?D:E)<ea(-I)){J=0;i=f;return J|0}I=ea(-t);E=ea(ea(o*n)+ea(k*I));D=ea(ea(r*I)+ea(n*l));I=ea(g[b>>2]);G=ea(ea(A*H)+ea(C*I));if((E<D?E:D)>G?1:(E>D?E:D)<ea(-G)){J=0;i=f;return J|0}G=ea(ea(h*s)-ea(n*p));D=ea(ea(s*r)-ea(n*j));E=ea(ea(A*F)+ea(B*I));if((G<D?G:D)>E?1:(G>D?G:D)<ea(-E)){J=0;i=f;return J|0}E=ea(S(ea(u)));D=ea(S(ea(v)));G=ea(S(ea(w)));B=ea(ea(m*w)-ea(o*v));A=ea(ea(j*w)-ea(v*l));C=ea(ea(H*D)+ea(F*G));if((B<A?B:A)>C?1:(B>A?B:A)<ea(-C)){J=0;i=f;return J|0}C=ea(-w);A=ea(ea(o*u)+ea(k*C));B=ea(ea(u*l)+ea(r*C));C=ea(ea(H*E)+ea(I*G));if((A<B?A:B)>C?1:(A>B?A:B)<ea(-C)){J=0;i=f;return J|0}C=ea(ea(k*v)-ea(m*u));B=ea(ea(h*v)-ea(p*u));A=ea(ea(F*E)+ea(I*D));if((C<B?C:B)>A?1:(C>B?C:B)<ea(-A)){J=0;i=f;return J|0}A=ea(S(ea(x)));B=ea(S(ea(y)));C=ea(S(ea(z)));D=ea(ea(m*z)-ea(o*y));E=ea(ea(p*z)-ea(q*y));G=ea(ea(H*B)+ea(F*C));if((D<E?D:E)>G?1:(D>E?D:E)<ea(-G)){J=0;i=f;return J|0}G=ea(-z);z=ea(ea(o*x)+ea(k*G));E=ea(ea(q*x)+ea(h*G));G=ea(ea(H*A)+ea(I*C));if((z<E?z:E)>G?1:(z>E?z:E)<ea(-G)){J=0;i=f;return J|0}G=ea(ea(h*y)-ea(p*x));E=ea(ea(r*y)-ea(x*j));x=ea(ea(F*A)+ea(I*B));if((G<E?G:E)>x?1:(G>E?G:E)<ea(-x)){J=0;i=f;return J|0}x=k<h?k:h;E=k>h?k:h;h=ea(-I);if((x<r?x:r)>I?1:(E>r?E:r)<h){J=0;i=f;return J|0}r=m<p?m:p;E=m>p?m:p;p=ea(-F);if((r<j?r:j)>F?1:(E>j?E:j)<p){J=0;i=f;return J|0}j=o<q?o:q;E=o>q?o:q;q=ea(-H);if((j<l?j:l)>H?1:(E>l?E:l)<q){J=0;i=f;return J|0}l=ea(ea(s*w)-ea(t*v));E=ea(ea(t*u)-ea(n*w));w=ea(ea(n*v)-ea(s*u));u=ea(ea(o*w)+ea(ea(k*l)+ea(m*E)));b=l>ea(0.0);e=E>ea(0.0);d=w>ea(0.0);if(ea(ea(ea(w*(d?q:H))+ea(ea(E*(e?p:F))+ea(l*(b?h:I))))-u)>ea(0.0))K=1;else K=!(ea(ea(ea(w*(d?H:q))+ea(ea(E*(e?F:p))+ea(l*(b?I:h))))-u)>=ea(0.0));J=K&1^1;i=f;return J|0}function YPa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0;h=i;i=i+64|0;j=h+48|0;k=h+32|0;l=h+16|0;m=h;n=ea(g[b>>2]);o=b+4|0;p=ea(g[o>>2]);q=b+8|0;r=ea(g[q>>2]);s=ea(-n);t=ea(-p);u=ea(-r);v=ea(g[d>>2]);w=ea(g[d+4>>2]);x=ea(g[d+8>>2]);y=ea(g[a>>2]);z=ea(g[a+4>>2]);A=ea(g[a+8>>2]);B=ea(v-y);v=ea(w-z);w=ea(x-A);x=ea(g[e>>2]);C=ea(g[e+4>>2]);D=ea(x-y);x=ea(C-z);C=ea(ea(g[e+8>>2])-A);E=ea(g[f>>2]);F=ea(g[f+4>>2]);G=ea(E-y);y=ea(F-z);z=ea(ea(g[f+8>>2])-A);A=ea(D-B);F=ea(x-v);E=ea(C-w);H=ea(G-D);I=ea(y-x);J=ea(z-C);K=ea(B-G);L=ea(v-y);M=ea(w-z);N=ea(-E);O=ea(-J);P=ea(-M);Q=ea(-A);R=ea(-H);S=ea(-K);T=ea(-F);U=ea(-I);V=ea(-L);W=ea(B*ea(0.0));X=ea(ea(w*F)+ea(W+ea(v*N)));Y=ea(ea(ea(G*ea(0.0))+ea(y*N))+ea(F*z));Z=ea(n*ea(-0.0));n=ea(ea(Z+ea((E<N?N:E)*p))+ea((F>T?F:T)*r));_=ea(ea(w*I)+ea(W+ea(v*O)));$=ea(D*ea(0.0));aa=ea(ea(C*I)+ea($+ea(x*O)));ba=ea(ea(r*(I>U?I:U))+ea(Z+ea(p*(J<O?O:J))));ca=ea(ea(w*L)+ea(W+ea(v*P)));W=ea(ea(C*L)+ea($+ea(x*P)));$=ea(ea(r*(L>V?L:V))+ea(Z+ea(p*(M<P?P:M))));p=ea(-n);Z=ea(-ba);r=ea(-$);if(((_>aa?_:aa)<Z?1:(_<aa?_:aa)>ba)|((X>Y?X:Y)<p?1:(X<Y?X:Y)>n)|((ca>W?ca:W)<r?1:(ca<W?ca:W)>$)){da=0;i=h;return da|0}$=ea(v*ea(0.0));W=ea(ea(w*Q)+ea($+ea(B*E)));ca=ea(ea(ea(E*G)+ea(y*ea(0.0)))+ea(z*Q));r=ea(g[b>>2]);n=ea(g[o>>2]);Y=ea(g[q>>2]);X=ea(n*ea(-0.0));p=ea(ea(ea((E>N?E:N)*r)+X)+ea((A<Q?Q:A)*Y));N=ea(ea(w*R)+ea($+ea(B*J)));ba=ea(x*ea(0.0));aa=ea(ea(C*R)+ea(ba+ea(D*J)));_=ea(ea(ea((J>O?J:O)*r)+X)+ea((H<R?R:H)*Y));O=ea(ea(w*S)+ea($+ea(B*M)));$=ea(ea(C*S)+ea(ba+ea(D*M)));ba=ea(ea(ea((M>P?M:P)*r)+X)+ea((K<S?S:K)*Y));X=ea(-p);P=ea(-_);M=ea(-ba);if(((N>aa?N:aa)<P?1:(N<aa?N:aa)>_)|((W>ca?W:ca)<X?1:(W<ca?W:ca)>p)|((O>$?O:$)<M?1:(O<$?O:$)>ba)){da=0;i=h;return da|0}ba=ea(w*ea(0.0));$=ea(ba+ea(ea(v*A)+ea(B*T)));O=ea(ea(ea(G*T)+ea(A*y))+ea(z*ea(0.0)));M=ea(Y*ea(-0.0));p=ea(ea(ea((F<T?T:F)*r)+ea((A>Q?A:Q)*n))+M);Q=ea(ba+ea(ea(v*H)+ea(B*U)));T=ea(C*ea(0.0));ca=ea(T+ea(ea(x*H)+ea(D*U)));W=ea(ea(ea((I<U?U:I)*r)+ea((H>R?H:R)*n))+M);R=ea(ba+ea(ea(v*K)+ea(B*V)));ba=ea(T+ea(ea(x*K)+ea(D*V)));T=ea(ea(ea((L<V?V:L)*r)+ea((K>S?K:S)*n))+M);M=ea(-p);S=ea(-W);K=ea(-T);if(((Q>ca?Q:ca)<S?1:(Q<ca?Q:ca)>W)|(($>O?$:O)<M?1:($<O?$:O)>p)|((R>ba?R:ba)<K?1:(R<ba?R:ba)>T)){da=0;i=h;return da|0}T=D<G?D:G;ba=x<y?x:y;R=C<z?C:z;K=D>G?D:G;G=x>y?x:y;y=C>z?C:z;z=ea(ea(F*J)-ea(E*I));C=ea(ea(E*H)-ea(A*J));J=ea(ea(A*I)-ea(F*H));H=ea(ea(w*J)+ea(ea(B*z)+ea(v*C)));q=z>ea(0.0);o=C>ea(0.0);f=J>ea(0.0);c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];g[k>>2]=s;g[k+4>>2]=t;g[k+8>>2]=u;g[k+12>>2]=ea(0.0);F=ea(g[(q?k:j)>>2]);I=ea(g[(o?k:j)+4>>2]);A=ea(g[(f?k:j)+8>>2]);c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];g[l>>2]=s;g[l+4>>2]=t;g[l+8>>2]=u;g[l+12>>2]=ea(0.0);if(!(((v>G?v:G)<t?1:(v<ba?v:ba)>n)|((B>K?B:K)<s?1:(B<T?B:T)>r)|((w>y?w:y)<u?1:(w<R?w:R)>Y))?(Y=ea(g[(o?m:l)+4>>2]),R=ea(C*Y),Y=ea(z*ea(g[(q?m:l)>>2])),w=ea(C*I),I=ea(z*F),!(ea(ea(ea(ea(I+w)+ea(J*A))-H)*ea(ea(ea(R+Y)+ea(J*ea(g[(f?m:l)+8>>2])))-H))>ea(0.0))):0){da=1;i=h;return da|0}da=0;i=h;return da|0}function ZPa(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;g[a+96>>2]=ea(g[b+48>>2]);g[a+100>>2]=ea(g[b+52>>2]);g[a+104>>2]=ea(g[b+56>>2]);c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(g[b+12>>2]);h=ea(g[b+16>>2]);i=ea(g[b+20>>2]);j=ea(g[b+24>>2]);k=ea(g[b+28>>2]);l=ea(g[b+32>>2]);m=ea(g[b+36>>2]);n=ea(g[b+40>>2]);o=ea(g[b+44>>2]);p=ea(-m);q=ea(-n);r=ea(-o);s=ea(ea(ea(c*p)+ea(d*q))+ea(e*r));t=ea(ea(ea(f*p)+ea(h*q))+ea(i*r));u=ea(ea(ea(j*p)+ea(k*q))+ea(l*r));g[a>>2]=c;g[a+4>>2]=f;g[a+8>>2]=j;g[a+12>>2]=d;g[a+16>>2]=h;g[a+20>>2]=k;g[a+24>>2]=e;g[a+28>>2]=i;g[a+32>>2]=l;g[a+72>>2]=s;g[a+76>>2]=t;g[a+80>>2]=u;g[a+36>>2]=c;g[a+40>>2]=d;g[a+44>>2]=e;g[a+48>>2]=f;g[a+52>>2]=h;g[a+56>>2]=i;g[a+60>>2]=j;g[a+64>>2]=k;g[a+68>>2]=l;g[a+84>>2]=m;g[a+88>>2]=n;g[a+92>>2]=o;return}function _Pa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=0;e=i;f=ea(g[a>>2]);h=ea(g[a+4>>2]);j=ea(g[a+8>>2]);k=ea(g[a+12>>2]);l=ea(g[a+16>>2]);m=ea(g[a+20>>2]);n=ea(g[a+24>>2]);o=ea(g[a+28>>2]);p=ea(g[a+32>>2]);q=ea(g[a+72>>2]);r=ea(g[a+76>>2]);s=ea(g[a+80>>2]);t=ea(g[a+96>>2]);u=ea(g[a+100>>2]);v=ea(g[a+104>>2]);w=ea(g[b>>2]);x=ea(g[b+4>>2]);y=ea(g[b+8>>2]);z=ea(g[c>>2]);A=ea(g[c+4>>2]);B=ea(g[c+8>>2]);C=ea(g[d>>2]);D=ea(g[d+4>>2]);E=ea(g[d+8>>2]);F=ea(ea(ea(q+ea(f*w))+ea(k*x))+ea(n*y));G=ea(ea(ea(r+ea(h*w))+ea(l*x))+ea(o*y));H=ea(ea(ea(s+ea(j*w))+ea(m*x))+ea(p*y));y=ea(ea(ea(q+ea(f*z))+ea(k*A))+ea(n*B));x=ea(ea(ea(r+ea(h*z))+ea(l*A))+ea(o*B));w=ea(ea(ea(s+ea(j*z))+ea(m*A))+ea(p*B));B=ea(ea(ea(q+ea(f*C))+ea(k*D))+ea(n*E));n=ea(ea(ea(r+ea(h*C))+ea(l*D))+ea(o*E));o=ea(ea(ea(s+ea(j*C))+ea(m*D))+ea(p*E));E=ea(-t);p=ea(-u);D=ea(-v);m=y<B?y:B;C=x<n?x:n;j=w<o?w:o;s=y>B?y:B;l=x>n?x:n;h=w>o?w:o;if(((F>s?F:s)<E?1:(F<m?F:m)>t)|((G>l?G:l)<p?1:(G<C?G:C)>u)|((H>h?H:h)<D?1:(H<j?H:j)>v)){I=0;i=e;return I|0}j=ea(y-F);D=ea(x-G);h=ea(w-H);C=ea(F-B);p=ea(G-n);l=ea(H-o);m=ea(ea(h*p)-ea(D*l));E=ea(ea(j*l)-ea(h*C));s=ea(ea(D*C)-ea(j*p));r=ea(ea(H*s)+ea(ea(F*m)+ea(G*E)));k=ea(-m);f=ea(-E);q=ea(-s);A=ea(ea(v*(s>q?s:q))+ea(ea(t*(m>k?m:k))+ea(u*(E>f?E:f))));if(r>A|r<ea(-A)){I=0;i=e;return I|0}A=ea(t+t);t=ea(u+u);u=ea(v+v);v=ea(-j);r=ea(-D);f=ea(-h);E=ea(F*ea(0.0));k=ea(ea(H*D)+ea(E+ea(G*f)));m=ea(ea(D*o)+ea(ea(B*ea(0.0))+ea(n*f)));q=ea(A*ea(-0.0));s=ea(k+m);z=ea(ea(ea(u*(D>r?D:r))+ea(q+ea(t*(h<f?f:h))))+ea(S(ea(k-m))));if(s>z|s<ea(-z)){I=0;i=e;return I|0}z=ea(B-y);s=ea(n-x);m=ea(o-w);k=ea(-z);J=ea(-s);K=ea(-m);L=ea(ea(H*s)+ea(E+ea(G*K)));M=ea(y*ea(0.0));N=ea(ea(w*s)+ea(M+ea(x*K)));O=ea(L+N);P=ea(ea(ea(u*(s>J?s:J))+ea(q+ea(t*(m<K?K:m))))+ea(S(ea(L-N))));if(O>P|O<ea(-P)){I=0;i=e;return I|0}P=ea(-C);O=ea(-p);N=ea(-l);L=ea(ea(H*p)+ea(E+ea(G*N)));E=ea(ea(w*p)+ea(M+ea(x*N)));M=ea(L+E);Q=ea(ea(ea(u*(p>O?p:O))+ea(q+ea(t*(l<N?N:l))))+ea(S(ea(L-E))));if(M>Q|M<ea(-Q)){I=0;i=e;return I|0}Q=ea(G*ea(0.0));M=ea(ea(Q+ea(F*h))+ea(H*v));E=ea(ea(o*v)+ea(ea(h*B)+ea(n*ea(0.0))));L=ea(t*ea(-0.0));q=ea(M+E);R=ea(ea(ea(u*(j<v?v:j))+ea(L+ea(A*(h>f?h:f))))+ea(S(ea(M-E))));if(q>R|q<ea(-R)){I=0;i=e;return I|0}R=ea(ea(Q+ea(F*m))+ea(H*k));q=ea(x*ea(0.0));E=ea(ea(q+ea(y*m))+ea(w*k));M=ea(R+E);f=ea(ea(ea(u*(z<k?k:z))+ea(L+ea(A*(m>K?m:K))))+ea(S(ea(R-E))));if(M>f|M<ea(-f)){I=0;i=e;return I|0}f=ea(ea(Q+ea(F*l))+ea(H*P));Q=ea(ea(q+ea(y*l))+ea(w*P));q=ea(f+Q);M=ea(ea(ea(u*(C<P?P:C))+ea(L+ea(A*(l>N?l:N))))+ea(S(ea(f-Q))));if(q>M|q<ea(-M)){I=0;i=e;return I|0}M=ea(H*ea(0.0));H=ea(M+ea(ea(G*j)+ea(F*r)));q=ea(ea(o*ea(0.0))+ea(ea(B*r)+ea(j*n)));n=ea(u*ea(-0.0));u=ea(H+q);B=ea(ea(n+ea(ea(A*(D<r?r:D))+ea(t*(j>v?j:v))))+ea(S(ea(H-q))));if(u>B|u<ea(-B)){I=0;i=e;return I|0}B=ea(M+ea(ea(G*z)+ea(F*J)));u=ea(w*ea(0.0));w=ea(u+ea(ea(x*z)+ea(y*J)));q=ea(B+w);H=ea(ea(n+ea(ea(A*(s<J?J:s))+ea(t*(z>k?z:k))))+ea(S(ea(B-w))));if(q>H|q<ea(-H)){I=0;i=e;return I|0}H=ea(M+ea(ea(G*C)+ea(F*O)));F=ea(u+ea(ea(x*C)+ea(y*O)));y=ea(H+F);x=ea(ea(n+ea(ea(A*(p<O?O:p))+ea(t*(C>P?C:P))))+ea(S(ea(H-F))));if(y>x)T=0;else T=!(y<ea(-x));I=T&1;i=e;return I|0}function $Pa(a){a=a|0;var b=0;b=i;c[a>>2]=0;HQa(a+16|0);i=b;return}function aQa(a){a=a|0;var b=0;b=i;KQa(a+16|0);i=b;return}function bQa(a,b){a=a|0;b=b|0;var c=0;c=i;LQa(a+16|0,b);i=c;return}function cQa(b){b=b|0;var d=0,e=0;d=i;$Pa(b+16|0);e=b+160|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+176>>2]=ea(.00100000005);nQa(b+180|0);c[b+200>>2]=1;e=b+128|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;a[e+28>>0]=0;i=d;return}function dQa(a){a=a|0;var b=0;b=i;eQa(a);aQa(a+16|0);i=b;return}function eQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=a+152|0;if(!(c[a+200>>2]|0)){e=a+8|0;f=a+164|0;g=a+168|0;h=a+160|0;j=a+12|0;c[d>>2]=0;c[f>>2]=0;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;c[e>>2]=0;i=b;return}else{VJa(b+5|0,c[d>>2]|0);c[d>>2]=0;k=a+164|0;VJa(b+4|0,c[k>>2]|0);c[k>>2]=0;l=a+168|0;VJa(b+3|0,c[l>>2]|0);c[l>>2]=0;m=a+160|0;VJa(b+2|0,c[m>>2]|0);c[m>>2]=0;n=a+12|0;VJa(b+1|0,c[n>>2]|0);c[n>>2]=0;o=a+8|0;VJa(b,c[o>>2]|0);c[o>>2]=0;e=o;f=k;g=l;h=m;j=n;c[d>>2]=0;c[f>>2]=0;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;c[e>>2]=0;i=b;return}}function fQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;bQa(b+16|0,d);f=b+8|0;if(c[f>>2]|0){In[c[(c[d>>2]|0)+12>>2]&4095](d,16);co[c[(c[d>>2]|0)+8>>2]&2047](d,c[f>>2]|0,(c[b>>2]|0)*12|0)}f=b+12|0;if(c[f>>2]|0){g=(a[b+156>>0]&2)!=0;In[c[(c[d>>2]|0)+12>>2]&4095](d,16);h=da(g?6:12,c[b+4>>2]|0)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,c[f>>2]|0,h)}h=b+152|0;if(c[h>>2]|0){In[c[(c[d>>2]|0)+12>>2]&4095](d,16);co[c[(c[d>>2]|0)+8>>2]&2047](d,c[h>>2]|0,c[b+4>>2]|0)}h=b+160|0;if(c[h>>2]|0){In[c[(c[d>>2]|0)+12>>2]&4095](d,16);co[c[(c[d>>2]|0)+8>>2]&2047](d,c[h>>2]|0,c[b+4>>2]<<1)}h=b+164|0;if(c[h>>2]|0){In[c[(c[d>>2]|0)+12>>2]&4095](d,16);co[c[(c[d>>2]|0)+8>>2]&2047](d,c[h>>2]|0,c[b+4>>2]<<2)}h=b+168|0;if(!(c[h>>2]|0)){i=e;return}In[c[(c[d>>2]|0)+12>>2]&4095](d,16);co[c[(c[d>>2]|0)+8>>2]&2047](d,c[h>>2]|0,(c[b+4>>2]|0)*12|0);i=e;return}function gQa(b){b=b|0;var d=0,e=0;d=i;e=b+180|0;c[b+184>>2]=c[b>>2];c[e>>2]=c[b+4>>2];pQa(e,c[b+12>>2]|0,(a[b+156>>0]&2)!=0,c[b+8>>2]|0)|0;i=d;return}function hQa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;c[a>>2]=b;e=UJa(d,b*12|0,541616,181)|0;c[a+8>>2]=e;i=d;return e|0}function iQa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=c[b>>2]|0;if(!h){j=0;i=g;return j|0}c[b+4>>2]=e;if(h>>>0>65535|f){f=UJa(g,e*12|0,541616,202)|0;c[b+12>>2]=f;h=b+156|0;a[h>>0]=(d[h>>0]|0)&253;j=f;i=g;return j|0}else{f=UJa(g+1|0,e*6|0,541616,197)|0;c[b+12>>2]=f;e=b+156|0;a[e>>0]=d[e>>0]|0|2;j=f;i=g;return j|0}return 0}function jQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=c[a+4>>2]|0;if(!d){e=0;i=b;return e|0}f=d>>>0>2147483647?-1:d<<1;if(!f)g=0;else{d=mKa()|0;h=c[(c[d>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;g=Bn[h&255](d,f,k?541936:544544,541616,216)|0}c[a+160>>2]=g;e=g;i=b;return e|0}function kQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=c[a+4>>2]|0;if(!d){e=0;i=b;return e|0}f=d>>>0>1073741823?-1:d<<2;if(!f)g=0;else{d=mKa()|0;h=c[(c[d>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;g=Bn[h&255](d,f,k?541832:544544,541616,226)|0}c[a+164>>2]=g;e=g;i=b;return e|0}function lQa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+4|0;g=c[f>>2]|0;if(!g){h=0;i=e;return h|0}j=g*3|0;k=j>>>0>1073741823?-1:j<<2;if(!k){l=0;m=g}else{g=mKa()|0;j=c[(c[g>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[j&255](g,k,o?541832:544544,541616,236)|0;l=n;m=c[f>>2]|0}c[b+168>>2]=l;f=b+156|0;a[f>>0]=d[f>>0]|0|4;c[b+172>>2]=m*3;h=l;i=e;return h|0}function mQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=b+180|0;c[b+184>>2]=c[b>>2];c[h>>2]=c[b+4>>2];pQa(h,c[b+12>>2]|0,(a[b+156>>0]&2)!=0,c[b+8>>2]|0)|0;if(e>>>0<10){dKa(bKa()|0,32,541616,259,541712,g);j=0;i=f;return j|0}c[b+16>>2]=h;if(JQa(b+32|0,d,e)|0){j=1;i=f;return j|0}dKa(bKa()|0,32,541616,268,541800,g);j=0;i=f;return j|0}function nQa(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;return}function oQa(a){a=a|0;return}function pQa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;if((b|0)==0|(e|0)==0){dKa(bKa()|0,8,542040,86,542128,f);g=0;i=f;return g|0}else{c[a+8>>2]=b;c[a+12>>2]=e;c[a+16>>2]=d&1;g=1;i=f;return g|0}return 0}function qQa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+48|0;j=h;k=c[a+36>>2]|0;if((g|0)!=0?(c[k+184>>2]|0)==0:0)dKa(bKa()|0,8,542176,161,542264,j);i_a(j,b,a+4|0);v6a(k,e,d,j,f,g);i=h;return}function rQa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0;j=i;i=i+32|0;k=j;c[k+12>>2]=c[a+4>>2];c[k+16>>2]=a;g[k+4>>2]=ea(ea(1.0)/ea(g[a+8>>2]));g[k>>2]=ea(ea(1.0)/ea(g[a+12>>2]));g[k+8>>2]=ea(ea(1.0)/ea(g[a+16>>2]));LRa(k,b,e,f,h,d,1,1)|0;i=j;return}function sQa(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0;m=i;i=i+112|0;n=m+44|0;o=m+16|0;p=m;q=c[b>>2]|0;if((q|0)==3){g[n+36>>2]=ea(g[d+16>>2]);g[n+40>>2]=ea(g[d+20>>2]);g[n+44>>2]=ea(g[d+24>>2]);g[n+48>>2]=ea(g[b+4>>2]);g[n+52>>2]=ea(g[b+8>>2]);g[n+56>>2]=ea(g[b+12>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);t=ea(g[d+8>>2]);u=ea(g[d+12>>2]);v=ea(r+r);w=ea(s+s);x=ea(t+t);y=ea(s*w);z=ea(t*x);A=ea(v*s);s=ea(v*t);B=ea(v*u);C=ea(w*t);t=ea(w*u);w=ea(x*u);u=ea(A+w);x=ea(s-t);D=ea(A-w);w=ea(ea(1.0)-ea(r*v));v=ea(w-z);r=ea(C+B);A=ea(s+t);t=ea(C-B);B=ea(w-y);g[n>>2]=ea(ea(ea(1.0)-y)-z);g[n+4>>2]=u;g[n+8>>2]=x;g[n+12>>2]=D;g[n+16>>2]=v;g[n+20>>2]=r;g[n+24>>2]=A;g[n+28>>2]=t;g[n+32>>2]=B;E=BQa(n,(c[e+36>>2]|0)+32|0,f,e+4|0,h,j,k,l)|0;i=m;return E|0}else if((q|0)==2){B=ea(g[d>>2]);t=ea(B*ea(2.0));A=ea(g[d+12>>2]);r=ea(A*ea(2.0));v=ea(ea(B*t)+ea(ea(A*r)+ea(-1.0)));A=ea(g[d+8>>2]);B=ea(A*r);D=ea(g[d+4>>2]);x=ea(B+ea(t*D));B=ea(ea(t*A)-ea(r*D));D=ea(g[b+8>>2]);r=ea(D*v);v=ea(D*x);x=ea(D*B);B=ea(g[d+16>>2]);D=ea(B+r);A=ea(g[d+20>>2]);t=ea(A+v);u=ea(g[d+24>>2]);z=ea(x+u);g[o>>2]=D;g[o+4>>2]=t;g[o+8>>2]=z;z=ea(A-v);v=ea(u-x);g[o+12>>2]=ea(B-r);g[o+16>>2]=z;g[o+20>>2]=v;g[o+24>>2]=ea(g[b+4>>2]);E=AQa(o,(c[e+36>>2]|0)+32|0,f,e+4|0,h,j,k,l)|0;i=m;return E|0}else if(!q){q=c[e+36>>2]|0;v=ea(g[b+4>>2]);g[p>>2]=ea(g[d+16>>2]);g[p+4>>2]=ea(g[d+20>>2]);g[p+8>>2]=ea(g[d+24>>2]);g[p+12>>2]=v;E=zQa(p,q+32|0,f,e+4|0,h,j,k,l)|0;i=m;return E|0}else{a[l>>0]=0;E=0;i=m;return E|0}return 0}function tQa(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im;m=i;i=i+128|0;n=m+96|0;o=m+72|0;p=m;q=ea(-ea(g[f>>2]));r=ea(-ea(g[f+4>>2]));s=ea(-ea(g[f+8>>2]));t=ea(g[f+12>>2]);u=ea(g[d+16>>2]);v=ea(u-ea(g[f+16>>2]));u=ea(g[d+20>>2]);w=ea(u-ea(g[f+20>>2]));u=ea(g[d+24>>2]);x=ea(v*ea(2.0));v=ea(w*ea(2.0));w=ea(ea(u-ea(g[f+24>>2]))*ea(2.0));u=ea(ea(t*t)+ea(-.5));y=ea(ea(ea(x*q)+ea(v*r))+ea(w*s));z=ea(ea(y*q)+ea(ea(u*x)+ea(t*ea(ea(w*r)-ea(v*s)))));A=ea(ea(y*r)+ea(ea(u*v)+ea(t*ea(ea(x*s)-ea(w*q)))));B=ea(ea(ea(u*w)+ea(t*ea(ea(v*q)-ea(x*r))))+ea(y*s));y=ea(g[d>>2]);x=ea(t*y);v=ea(g[d+12>>2]);w=ea(x+ea(v*q));x=ea(g[d+8>>2]);u=ea(w+ea(x*r));w=ea(g[d+4>>2]);C=ea(u-ea(w*s));u=ea(ea(ea(y*s)+ea(ea(v*r)+ea(t*w)))-ea(x*q));D=ea(ea(ea(w*q)+ea(ea(v*s)+ea(t*x)))-ea(y*r));E=ea(ea(ea(ea(t*v)-ea(y*q))-ea(w*r))-ea(x*s));d=c[b>>2]|0;if((d|0)==2){s=ea(g[b+8>>2]);x=ea(g[b+4>>2]);F=ea(s+x);G=x;H=x}else if(!d){x=ea(g[b+4>>2]);F=x;G=x;H=x}else if((d|0)==3){x=ea(g[b+4>>2]);s=ea(g[b+8>>2]);F=x;G=s;H=ea(g[b+12>>2])}else{a[l>>0]=0;F=ea(0.0);G=ea(0.0);H=ea(0.0)}if(C==ea(0.0)&u==ea(0.0)&D==ea(0.0)){s=ea(A-G);x=ea(B-H);r=ea(z+F);w=ea(A+G);q=ea(B+H);g[n>>2]=ea(z-F);g[n+4>>2]=s;g[n+8>>2]=x;g[n+12>>2]=r;g[n+16>>2]=w;g[n+20>>2]=q;I=1}else{q=ea(C+C);w=ea(u+u);r=ea(D+D);x=ea(u*w);s=ea(D*r);y=ea(q*u);v=ea(q*D);t=ea(q*E);J=ea(D*w);K=ea(E*w);w=ea(E*r);r=ea(ea(1.0)-ea(C*q));q=ea(ea(ea(S(ea(ea(ea(ea(1.0)-x)-s)*F)))+ea(S(ea(ea(y-w)*G))))+ea(S(ea(ea(v+K)*H))));L=ea(ea(ea(S(ea(ea(y+w)*F)))+ea(S(ea(ea(r-s)*G))))+ea(S(ea(ea(J-t)*H))));s=ea(ea(ea(S(ea(ea(v-K)*F)))+ea(S(ea(ea(t+J)*G))))+ea(S(ea(ea(r-x)*H))));x=ea(A-L);r=ea(B-s);J=ea(z+q);t=ea(A+L);L=ea(B+s);g[n>>2]=ea(z-q);g[n+4>>2]=x;g[n+8>>2]=r;g[n+12>>2]=J;g[n+16>>2]=t;g[n+20>>2]=L;I=0}c[o+12>>2]=c[e+4>>2];c[o+16>>2]=e;g[o+4>>2]=ea(ea(1.0)/ea(g[e+8>>2]));g[o>>2]=ea(ea(1.0)/ea(g[e+12>>2]));g[o+8>>2]=ea(ea(1.0)/ea(g[e+16>>2]));c[p>>2]=542360;c[p+4>>2]=o;g[p+8>>2]=z;g[p+12>>2]=A;g[p+16>>2]=B;g[p+20>>2]=F;g[p+24>>2]=G;g[p+28>>2]=H;g[p+32>>2]=C;g[p+36>>2]=u;g[p+40>>2]=D;g[p+44>>2]=E;c[p+48>>2]=h;c[p+52>>2]=j;c[p+56>>2]=k;k=p+60|0;c[k>>2]=0;c[p+64>>2]=0;a[p+68>>0]=I;I=p+69|0;a[I>>0]=0;KRa(o,f,n,0,p)|0;a[l>>0]=a[I>>0]|0;i=m;return c[k>>2]|0}function uQa(a,d,e,f,h,j,k,l,m,n){a=a|0;d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im;o=i;i=i+32|0;p=o;q=o+18|0;r=o+16|0;s=o+14|0;t=o+12|0;u=c[e>>2]|0;if((u|0)==3){v=b[l>>1]|0;w=k+16|0;x=k+28|0;y=k+40|0;z=k+8|0;if(!(v&256)){b[t>>1]=v;A=LNa(h,j,e,f,a,d,w,x,y,z,m,n,t)|0;i=o;return A|0}else{b[s>>1]=v;A=_Ka(h,j,e,f,a,d,w,x,y,z,m,n,s)|0;i=o;return A|0}}else if(!u){B=ea(g[e+4>>2]);c[p>>2]=2;g[p+4>>2]=B;g[p+8>>2]=ea(0.0);b[q>>1]=b[l>>1]|0;A=BNa(h,j,p,f,a,d,m,k+16|0,k+28|0,k+40|0,k+8|0,n,q)|0;i=o;return A|0}else if((u|0)==2){b[r>>1]=b[l>>1]|0;A=BNa(h,j,e,f,a,d,m,k+16|0,k+28|0,k+40|0,k+8|0,n,r)|0;i=o;return A|0}else{A=0;i=o;return A|0}return 0}function vQa(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im;k=i;i=i+304|0;l=k+280|0;m=k;n=k+264|0;o=k+252|0;p=k+240|0;q=c[f>>2]|0;r=c[q+16>>2]|0;s=m+4|0;c[m>>2]=542528;c[s>>2]=542552;c[m+8>>2]=f;t=m+12|0;c[t>>2]=h;c[m+16>>2]=r;c[m+20>>2]=q+8;c[m+24>>2]=q+12;c[m+28>>2]=0;u=ea(g[f+8>>2]);q=m+32|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;a[m+56>>0]=e&1;g[m+60>>2]=u;e=m+64|0;g[e>>2]=ea(0.0);c[m+68>>2]=0;c[m+72>>2]=0;c[m+76>>2]=-1;b[m+80>>1]=0;q=m+84|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;g[m+108>>2]=ea(3402823469999999843913219.0e14);g[m+112>>2]=ea(0.0);g[m+116>>2]=ea(0.0);a[m+181>>0]=(c[h+4>>2]|0)==1&1;h=m+180|0;a[h>>0]=0;q=m+208|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;if(j?(UUa(n,d),ea(S(ea(g[n+12>>2])))>ea(.999899983)):0){u=ea(S(ea(g[d>>2])));v=ea(S(ea(g[d+4>>2])));w=ea(S(ea(g[d+8>>2])));n=d+12|0;x=ea(S(ea(g[n>>2])));y=ea(S(ea(g[n+4>>2])));z=ea(S(ea(g[n+8>>2])));n=d+24|0;A=ea(S(ea(g[n>>2])));B=ea(S(ea(g[n+4>>2])));C=ea(S(ea(g[n+8>>2])));D=ea(g[d+48>>2]);E=ea(g[d+52>>2]);F=ea(g[d+56>>2]);G=ea(ea(ea(u*D)+ea(x*E))+ea(A*F));A=ea(ea(ea(v*D)+ea(y*E))+ea(B*F));B=ea(ea(ea(w*D)+ea(z*E))+ea(C*F));n=c[f+4>>2]|0;F=ea(g[d+36>>2]);C=ea(F-G);E=ea(g[d+40>>2]);z=ea(E-A);D=ea(g[d+44>>2]);w=ea(D-B);g[o>>2]=C;g[o+4>>2]=z;g[o+8>>2]=w;w=ea(A+E);E=ea(B+D);g[p>>2]=ea(G+F);g[p+4>>2]=w;g[p+8>>2]=E;OQa(n,o,p,4,l,m+4|0)}else PQa(c[f+4>>2]|0,d,4,l,m+4|0);c[m>>2]=542528;c[s>>2]=542552;if(!(a[h>>0]|0)){i=k;return}h=c[t>>2]|0;gn[c[c[h>>2]>>2]&127](h,m+68|0,m+132|0,m+144|0,m+156|0,e,m+168|0)|0;i=k;return}function wQa(d,e,f,h,j,k,l){d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=0;m=i;i=i+528|0;n=m+504|0;o=m+240|0;p=m+492|0;q=m+480|0;r=m;s=c[j>>2]|0;t=s+16|0;u=s+8|0;v=s+12|0;if(f==ea(0.0)){s=c[t>>2]|0;w=o+4|0;c[o>>2]=542480;c[w>>2]=542504;c[o+8>>2]=j;x=o+12|0;c[x>>2]=k;c[o+16>>2]=s;c[o+20>>2]=u;c[o+24>>2]=v;c[o+28>>2]=l;y=ea(g[j+8>>2]);z=ea(g[d>>2]);g[o+32>>2]=z;A=ea(g[d+4>>2]);g[o+36>>2]=A;B=ea(g[d+8>>2]);g[o+40>>2]=B;C=ea(g[e>>2]);g[o+44>>2]=C;D=ea(g[e+4>>2]);g[o+48>>2]=D;E=ea(g[e+8>>2]);g[o+52>>2]=E;a[o+56>>0]=h&1;g[o+60>>2]=y;s=o+64|0;g[s>>2]=f;c[o+68>>2]=0;c[o+72>>2]=0;c[o+76>>2]=-1;b[o+80>>1]=0;F=o+84|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;c[F+16>>2]=0;c[F+20>>2]=0;g[o+108>>2]=ea(3402823469999999843913219.0e14);g[o+112>>2]=ea(0.0);g[o+116>>2]=ea(0.0);a[o+181>>0]=(c[k+4>>2]|0)==1&1;F=o+180|0;a[F>>0]=0;y=ea(g[l>>2]);G=ea(g[l+4>>2]);H=ea(g[l+8>>2]);g[o+192>>2]=y;g[o+196>>2]=G;g[o+200>>2]=H;g[o+204>>2]=ea(0.0);g[o+208>>2]=z;g[o+212>>2]=A;g[o+216>>2]=B;g[o+220>>2]=ea(0.0);g[o+224>>2]=C;g[o+228>>2]=D;g[o+232>>2]=E;g[o+236>>2]=ea(0.0);I=c[j+4>>2]|0;E=ea(A-G);D=ea(B-H);g[p>>2]=ea(z-y);g[p+4>>2]=E;g[p+8>>2]=D;D=ea(G+A);A=ea(H+B);g[q>>2]=ea(y+z);g[q+4>>2]=D;g[q+8>>2]=A;OQa(I,p,q,4,n,o+4|0);c[o>>2]=542480;c[w>>2]=542504;if(!(a[F>>0]|0)){i=m;return}F=c[x>>2]|0;gn[c[c[F>>2]>>2]&127](F,o+68|0,o+132|0,o+144|0,o+156|0,s,o+168|0)|0;i=m;return}else{o=c[t>>2]|0;t=r+4|0;c[r>>2]=542480;c[t>>2]=542504;c[r+8>>2]=j;s=r+12|0;c[s>>2]=k;c[r+16>>2]=o;c[r+20>>2]=u;c[r+24>>2]=v;c[r+28>>2]=l;A=ea(g[j+8>>2]);D=ea(g[d>>2]);g[r+32>>2]=D;z=ea(g[d+4>>2]);g[r+36>>2]=z;y=ea(g[d+8>>2]);g[r+40>>2]=y;B=ea(g[e>>2]);g[r+44>>2]=B;H=ea(g[e+4>>2]);g[r+48>>2]=H;G=ea(g[e+8>>2]);g[r+52>>2]=G;a[r+56>>0]=h&1;g[r+60>>2]=A;h=r+64|0;g[h>>2]=f;c[r+68>>2]=0;c[r+72>>2]=0;c[r+76>>2]=-1;b[r+80>>1]=0;v=r+84|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;g[r+108>>2]=ea(3402823469999999843913219.0e14);g[r+112>>2]=ea(0.0);g[r+116>>2]=ea(0.0);a[r+181>>0]=(c[k+4>>2]|0)==1&1;k=r+180|0;a[k>>0]=0;A=ea(g[l>>2]);E=ea(g[l+4>>2]);C=ea(g[l+8>>2]);g[r+192>>2]=A;g[r+196>>2]=E;g[r+200>>2]=C;g[r+204>>2]=ea(0.0);g[r+208>>2]=D;g[r+212>>2]=z;g[r+216>>2]=y;g[r+220>>2]=ea(0.0);g[r+224>>2]=B;g[r+228>>2]=H;g[r+232>>2]=G;g[r+236>>2]=ea(0.0);NQa(c[j+4>>2]|0,d,e,4,n,r,l,f);c[r>>2]=542480;c[t>>2]=542504;if(!(a[k>>0]|0)){i=m;return}k=c[s>>2]|0;gn[c[c[k>>2]>>2]&127](k,r+68|0,r+132|0,r+144|0,r+156|0,h,r+168|0)|0;i=m;return}}function xQa(d,e,f,h,j,k,l){d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0;m=i;i=i+528|0;n=m+504|0;o=m+240|0;p=m+492|0;q=m+480|0;r=m;s=c[j>>2]|0;t=s+16|0;u=s+8|0;v=s+12|0;if(f==ea(0.0)){s=c[t>>2]|0;w=o+4|0;c[o>>2]=542528;c[w>>2]=542552;c[o+8>>2]=j;x=o+12|0;c[x>>2]=k;c[o+16>>2]=s;c[o+20>>2]=u;c[o+24>>2]=v;c[o+28>>2]=l;y=ea(g[j+8>>2]);z=ea(g[d>>2]);g[o+32>>2]=z;A=ea(g[d+4>>2]);g[o+36>>2]=A;B=ea(g[d+8>>2]);g[o+40>>2]=B;C=ea(g[e>>2]);g[o+44>>2]=C;D=ea(g[e+4>>2]);g[o+48>>2]=D;E=ea(g[e+8>>2]);g[o+52>>2]=E;a[o+56>>0]=h&1;g[o+60>>2]=y;s=o+64|0;g[s>>2]=f;c[o+68>>2]=0;c[o+72>>2]=0;c[o+76>>2]=-1;b[o+80>>1]=0;F=o+84|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;c[F+16>>2]=0;c[F+20>>2]=0;g[o+108>>2]=ea(3402823469999999843913219.0e14);g[o+112>>2]=ea(0.0);g[o+116>>2]=ea(0.0);a[o+181>>0]=(c[k+4>>2]|0)==1&1;F=o+180|0;a[F>>0]=0;g[o+208>>2]=z;g[o+212>>2]=A;g[o+216>>2]=B;g[o+220>>2]=ea(0.0);g[o+224>>2]=C;g[o+228>>2]=D;g[o+232>>2]=E;g[o+236>>2]=ea(0.0);G=c[j+4>>2]|0;g[p>>2]=z;g[p+4>>2]=A;g[p+8>>2]=B;E=ea(A+ea(0.0));A=ea(B+ea(0.0));g[q>>2]=ea(z+ea(0.0));g[q+4>>2]=E;g[q+8>>2]=A;OQa(G,p,q,4,n,o+4|0);c[o>>2]=542528;c[w>>2]=542552;if(!(a[F>>0]|0)){i=m;return}F=c[x>>2]|0;gn[c[c[F>>2]>>2]&127](F,o+68|0,o+132|0,o+144|0,o+156|0,s,o+168|0)|0;i=m;return}else{o=c[t>>2]|0;t=r+4|0;c[r>>2]=542432;c[t>>2]=542456;c[r+8>>2]=j;s=r+12|0;c[s>>2]=k;c[r+16>>2]=o;c[r+20>>2]=u;c[r+24>>2]=v;c[r+28>>2]=l;A=ea(g[j+8>>2]);E=ea(g[d>>2]);g[r+32>>2]=E;z=ea(g[d+4>>2]);g[r+36>>2]=z;B=ea(g[d+8>>2]);g[r+40>>2]=B;D=ea(g[e>>2]);g[r+44>>2]=D;C=ea(g[e+4>>2]);g[r+48>>2]=C;y=ea(g[e+8>>2]);g[r+52>>2]=y;a[r+56>>0]=h&1;g[r+60>>2]=A;h=r+64|0;g[h>>2]=f;c[r+68>>2]=0;c[r+72>>2]=0;c[r+76>>2]=-1;b[r+80>>1]=0;v=r+84|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;g[r+108>>2]=ea(3402823469999999843913219.0e14);g[r+112>>2]=ea(0.0);g[r+116>>2]=ea(0.0);a[r+181>>0]=(c[k+4>>2]|0)==1&1;k=r+180|0;a[k>>0]=0;g[r+208>>2]=E;g[r+212>>2]=z;g[r+216>>2]=B;g[r+220>>2]=ea(0.0);g[r+224>>2]=D;g[r+228>>2]=C;g[r+232>>2]=y;g[r+236>>2]=ea(0.0);MQa(c[j+4>>2]|0,d,e,4,n,r,l,f);c[r>>2]=542432;c[t>>2]=542456;if(!(a[k>>0]|0)){i=m;return}k=c[s>>2]|0;gn[c[c[k>>2]>>2]&127](k,r+68|0,r+132|0,r+144|0,r+156|0,h,r+168|0)|0;i=m;return}}function yQa(d,e,f,h,j,k,l){d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=0;m=i;i=i+528|0;n=m+504|0;o=m+240|0;p=m+492|0;q=m+480|0;r=m;s=c[j>>2]|0;t=s+16|0;u=s+8|0;v=s+12|0;if(f==ea(0.0)){s=c[t>>2]|0;w=o+4|0;c[o>>2]=542480;c[w>>2]=542504;c[o+8>>2]=j;x=o+12|0;c[x>>2]=k;c[o+16>>2]=s;c[o+20>>2]=u;c[o+24>>2]=v;c[o+28>>2]=l;y=ea(g[j+8>>2]);z=ea(g[d>>2]);g[o+32>>2]=z;A=ea(g[d+4>>2]);g[o+36>>2]=A;B=ea(g[d+8>>2]);g[o+40>>2]=B;C=ea(g[e>>2]);g[o+44>>2]=C;D=ea(g[e+4>>2]);g[o+48>>2]=D;E=ea(g[e+8>>2]);g[o+52>>2]=E;a[o+56>>0]=h&1;g[o+60>>2]=y;s=o+64|0;g[s>>2]=f;c[o+68>>2]=0;c[o+72>>2]=0;c[o+76>>2]=-1;b[o+80>>1]=0;F=o+84|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;c[F+16>>2]=0;c[F+20>>2]=0;g[o+108>>2]=ea(3402823469999999843913219.0e14);g[o+112>>2]=ea(0.0);g[o+116>>2]=ea(0.0);a[o+181>>0]=(c[k+4>>2]|0)==1&1;F=o+180|0;a[F>>0]=0;y=ea(g[l>>2]);G=ea(g[l+4>>2]);H=ea(g[l+8>>2]);g[o+192>>2]=y;g[o+196>>2]=G;g[o+200>>2]=H;g[o+204>>2]=ea(0.0);g[o+208>>2]=z;g[o+212>>2]=A;g[o+216>>2]=B;g[o+220>>2]=ea(0.0);g[o+224>>2]=C;g[o+228>>2]=D;g[o+232>>2]=E;g[o+236>>2]=ea(0.0);I=c[j+4>>2]|0;E=ea(A-G);D=ea(B-H);g[p>>2]=ea(z-y);g[p+4>>2]=E;g[p+8>>2]=D;D=ea(G+A);A=ea(H+B);g[q>>2]=ea(y+z);g[q+4>>2]=D;g[q+8>>2]=A;OQa(I,p,q,4,n,o+4|0);c[o>>2]=542480;c[w>>2]=542504;if(!(a[F>>0]|0)){i=m;return}F=c[x>>2]|0;gn[c[c[F>>2]>>2]&127](F,o+68|0,o+132|0,o+144|0,o+156|0,s,o+168|0)|0;i=m;return}else{o=c[t>>2]|0;t=r+4|0;c[r>>2]=542384;c[t>>2]=542408;c[r+8>>2]=j;s=r+12|0;c[s>>2]=k;c[r+16>>2]=o;c[r+20>>2]=u;c[r+24>>2]=v;c[r+28>>2]=l;A=ea(g[j+8>>2]);D=ea(g[d>>2]);g[r+32>>2]=D;z=ea(g[d+4>>2]);g[r+36>>2]=z;y=ea(g[d+8>>2]);g[r+40>>2]=y;B=ea(g[e>>2]);g[r+44>>2]=B;H=ea(g[e+4>>2]);g[r+48>>2]=H;G=ea(g[e+8>>2]);g[r+52>>2]=G;a[r+56>>0]=h&1;g[r+60>>2]=A;h=r+64|0;g[h>>2]=f;c[r+68>>2]=0;c[r+72>>2]=0;c[r+76>>2]=-1;b[r+80>>1]=0;v=r+84|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;g[r+108>>2]=ea(3402823469999999843913219.0e14);g[r+112>>2]=ea(0.0);g[r+116>>2]=ea(0.0);a[r+181>>0]=(c[k+4>>2]|0)==1&1;k=r+180|0;a[k>>0]=0;A=ea(g[l>>2]);E=ea(g[l+4>>2]);C=ea(g[l+8>>2]);g[r+192>>2]=A;g[r+196>>2]=E;g[r+200>>2]=C;g[r+204>>2]=ea(0.0);g[r+208>>2]=D;g[r+212>>2]=z;g[r+216>>2]=y;g[r+220>>2]=ea(0.0);g[r+224>>2]=B;g[r+228>>2]=H;g[r+232>>2]=G;g[r+236>>2]=ea(0.0);NQa(c[j+4>>2]|0,d,e,4,n,r,l,f);c[r>>2]=542384;c[t>>2]=542408;if(!(a[k>>0]|0)){i=m;return}k=c[s>>2]|0;gn[c[c[k>>2]>>2]&127](k,r+68|0,r+132|0,r+144|0,r+156|0,h,r+168|0)|0;i=m;return}}function zQa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+32|0;m=l;c[m>>2]=g;c[m+8>>2]=h;c[m+12>>2]=j;j=m+4|0;c[j>>2]=0;c[m+16>>2]=0;h=m+20|0;a[h>>0]=0;H7a(b,d,e,f,m)|0;a[k>>0]=a[h>>0]|0;i=l;return c[j>>2]|0}function AQa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+32|0;m=l;c[m>>2]=g;c[m+8>>2]=h;c[m+12>>2]=j;j=m+4|0;c[j>>2]=0;c[m+16>>2]=0;h=m+20|0;a[h>>0]=0;I7a(b,d,e,f,m)|0;a[k>>0]=a[h>>0]|0;i=l;return c[j>>2]|0}function BQa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+32|0;m=l;c[m>>2]=g;c[m+8>>2]=h;c[m+12>>2]=j;j=m+4|0;c[j>>2]=0;c[m+16>>2]=0;h=m+20|0;a[h>>0]=0;J7a(b,d,e,f,m)|0;a[k>>0]=a[h>>0]|0;i=l;return c[j>>2]|0}function CQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=J7a(d,(c[a+36>>2]|0)+32|0,b,a+4|0,0)|0;i=e;return f|0}function DQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[a+4>>2]);g[h>>2]=ea(g[b+16>>2]);g[h+4>>2]=ea(g[b+20>>2]);g[h+8>>2]=ea(g[b+24>>2]);g[h+12>>2]=j;b=H7a(h,(c[d+36>>2]|0)+32|0,e,d+4|0,0)|0;i=f;return b|0}function EQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;f=i;i=i+32|0;h=f;j=c[d+36>>2]|0;k=ea(g[b>>2]);l=ea(k*ea(2.0));m=ea(g[b+12>>2]);n=ea(m*ea(2.0));o=ea(ea(k*l)+ea(ea(m*n)+ea(-1.0)));m=ea(g[b+8>>2]);k=ea(m*n);p=ea(g[b+4>>2]);q=ea(k+ea(l*p));k=ea(ea(l*m)-ea(n*p));p=ea(g[a+8>>2]);n=ea(p*o);o=ea(p*q);q=ea(p*k);k=ea(g[b+16>>2]);p=ea(k+n);m=ea(g[b+20>>2]);l=ea(m+o);r=ea(g[b+24>>2]);s=ea(q+r);g[h>>2]=p;g[h+4>>2]=l;g[h+8>>2]=s;s=ea(m-o);o=ea(r-q);g[h+12>>2]=ea(k-n);g[h+16>>2]=s;g[h+20>>2]=o;g[h+24>>2]=ea(g[a+4>>2]);a=I7a(h,j+32|0,e,d+4|0,0)|0;i=f;return a|0}function FQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;i=i+64|0;h=f;j=c[d+36>>2]|0;g[h+36>>2]=ea(g[b+16>>2]);g[h+40>>2]=ea(g[b+20>>2]);g[h+44>>2]=ea(g[b+24>>2]);g[h+48>>2]=ea(g[a+4>>2]);g[h+52>>2]=ea(g[a+8>>2]);g[h+56>>2]=ea(g[a+12>>2]);k=ea(g[b>>2]);l=ea(g[b+4>>2]);m=ea(g[b+8>>2]);n=ea(g[b+12>>2]);o=ea(k+k);p=ea(l+l);q=ea(m+m);r=ea(l*p);s=ea(m*q);t=ea(o*l);l=ea(o*m);u=ea(o*n);v=ea(p*m);m=ea(p*n);p=ea(q*n);n=ea(t+p);q=ea(l-m);w=ea(t-p);p=ea(ea(1.0)-ea(k*o));o=ea(p-s);k=ea(v+u);t=ea(l+m);m=ea(v-u);u=ea(p-r);g[h>>2]=ea(ea(ea(1.0)-r)-s);g[h+4>>2]=n;g[h+8>>2]=q;g[h+12>>2]=w;g[h+16>>2]=o;g[h+20>>2]=k;g[h+24>>2]=t;g[h+28>>2]=m;g[h+32>>2]=u;b=J7a(h,j+32|0,e,d+4|0,0)|0;i=f;return b|0}function GQa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im;h=i;i=i+800|0;j=h+696|0;k=h+512|0;l=h+648|0;m=h+600|0;n=h+768|0;o=h+448|0;p=h+584|0;q=h;r=c[b+32>>2]|0;s=c[e+36>>2]|0;t=b+4|0;if(ea(g[t>>2])==ea(1.0)?ea(g[b+8>>2])==ea(1.0):0)u=ea(g[b+12>>2])==ea(1.0);else u=0;v=e+4|0;if(ea(g[v>>2])==ea(1.0)?ea(g[e+8>>2])==ea(1.0):0)w=ea(g[e+12>>2])==ea(1.0);else w=0;g[j>>2]=ea(1.0);x=j+4|0;g[x>>2]=ea(0.0);y=j+8|0;g[y>>2]=ea(0.0);z=j+12|0;g[z>>2]=ea(0.0);A=j+16|0;g[A>>2]=ea(1.0);B=j+20|0;g[B>>2]=ea(0.0);C=j+24|0;g[C>>2]=ea(0.0);D=j+28|0;g[D>>2]=ea(0.0);E=j+32|0;g[E>>2]=ea(1.0);g[j+36>>2]=ea(1.0);g[j+40>>2]=ea(0.0);g[j+44>>2]=ea(0.0);g[j+48>>2]=ea(0.0);g[j+52>>2]=ea(1.0);g[j+56>>2]=ea(0.0);g[j+60>>2]=ea(0.0);g[j+64>>2]=ea(0.0);g[j+68>>2]=ea(1.0);if(!u)J0a(j,t,b+16|0);g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(1.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=ea(1.0);g[k+40>>2]=ea(0.0);g[k+44>>2]=ea(0.0);g[k+48>>2]=ea(0.0);g[k+52>>2]=ea(1.0);g[k+56>>2]=ea(0.0);g[k+60>>2]=ea(0.0);g[k+64>>2]=ea(0.0);g[k+68>>2]=ea(1.0);if(!w)J0a(k,v,e+16|0);F=ea(g[d>>2]);G=ea(F+F);H=ea(g[d+4>>2]);I=ea(H+H);J=ea(g[d+8>>2]);K=ea(J+J);L=ea(g[d+12>>2]);M=ea(G*L);N=ea(I*L);O=ea(L*K);L=ea(F*G);G=ea(F*I);P=ea(F*K);F=ea(H*I);I=ea(H*K);H=ea(J*K);g[l>>2]=ea(ea(ea(1.0)-F)-H);g[l+4>>2]=ea(G+O);g[l+8>>2]=ea(P-N);g[l+12>>2]=ea(G-O);O=ea(ea(1.0)-L);g[l+16>>2]=ea(O-H);g[l+20>>2]=ea(I+M);g[l+24>>2]=ea(P+N);g[l+28>>2]=ea(I-M);g[l+32>>2]=ea(O-F);g[l+36>>2]=ea(g[d+16>>2]);g[l+40>>2]=ea(g[d+20>>2]);g[l+44>>2]=ea(g[d+24>>2]);F=ea(g[f>>2]);O=ea(F+F);M=ea(g[f+4>>2]);I=ea(M+M);N=ea(g[f+8>>2]);P=ea(N+N);H=ea(g[f+12>>2]);L=ea(O*H);G=ea(I*H);K=ea(H*P);H=ea(F*O);O=ea(F*I);J=ea(F*P);F=ea(M*I);I=ea(M*P);M=ea(N*P);g[m>>2]=ea(ea(ea(1.0)-F)-M);g[m+4>>2]=ea(O+K);g[m+8>>2]=ea(J-G);g[m+12>>2]=ea(O-K);K=ea(ea(1.0)-H);g[m+16>>2]=ea(K-M);g[m+20>>2]=ea(I+L);g[m+24>>2]=ea(J+G);g[m+28>>2]=ea(I-L);g[m+32>>2]=ea(K-F);g[m+36>>2]=ea(g[f+16>>2]);g[m+40>>2]=ea(g[f+20>>2]);g[m+44>>2]=ea(g[f+24>>2]);F=ea(g[r+16>>2]);K=ea(g[r+28>>2]);L=ea(F+K);I=ea(g[r+20>>2]);G=ea(g[r+32>>2]);J=ea(I+G);M=ea(g[r+24>>2]);H=ea(g[r+36>>2]);O=ea(L*ea(.5));L=ea(J*ea(.5));J=ea(ea(M+H)*ea(.5));P=ea(g[j>>2]);N=ea(O*P);Q=ea(g[x>>2]);R=ea(O*Q);T=ea(g[y>>2]);U=ea(O*T);O=ea(g[z>>2]);V=ea(L*O);W=ea(g[A>>2]);X=ea(L*W);Y=ea(g[B>>2]);Z=ea(N+V);V=ea(R+X);X=ea(U+ea(L*Y));L=ea(g[C>>2]);U=ea(J*L);R=ea(g[D>>2]);N=ea(J*R);_=ea(g[E>>2]);$=ea(Z+U);U=ea(V+N);N=ea(X+ea(J*_));J=ea(ea(K-F)*ea(.5));F=ea(ea(G-I)*ea(.5));I=ea(ea(H-M)*ea(.5));M=ea(ea(ea(S(ea(J*P)))+ea(S(ea(F*O))))+ea(S(ea(I*L))));L=ea(ea(ea(S(ea(J*Q)))+ea(S(ea(F*W))))+ea(S(ea(I*R))));R=ea(ea(ea(S(ea(J*T)))+ea(S(ea(F*Y))))+ea(S(ea(I*_))));_=ea(U-L);I=ea(N-R);Y=ea($+M);F=ea(U+L);L=ea(N+R);g[n>>2]=ea($-M);g[n+4>>2]=_;g[n+8>>2]=I;g[n+12>>2]=Y;g[n+16>>2]=F;g[n+20>>2]=L;zOa(o,n,ea(0.0),d,l,m,k,w);c[p>>2]=c[s+32>>2];c[p+4>>2]=s+48;g[p+8>>2]=ea(g[s+36>>2]);K7a(q,r,t,k,d,f,w,o);vQa(o,1,p,q,0);i=h;return (a[q+432>>0]|0)!=0|0}function HQa(a){a=a|0;c[a+84>>2]=0;c[a+92>>2]=0;c[a+76>>2]=0;c[a+72>>2]=0;c[a+64>>2]=4;return}function IQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;PMa(82,84,82,69,b);VMa(1,1,b);ZMa(a,4,1,b);ZMa(a+16|0,4,1,b);ZMa(a+32|0,4,1,b);ZMa(a+48|0,4,1,b);VMa(c[a+64>>2]|0,1,b);VMa(c[a+68>>2]|0,1,b);VMa(c[a+72>>2]|0,1,b);VMa(c[a+76>>2]|0,1,b);e=a+80|0;VMa(c[e>>2]|0,1,b);VMa(c[a+88>>2]|0,1,b);if(!(c[e>>2]|0)){i=d;return 1}f=a+92|0;a=0;do{ZMa((c[f>>2]|0)+(a*112|0)|0,4,1,b);ZMa((c[f>>2]|0)+(a*112|0)+16|0,4,1,b);ZMa((c[f>>2]|0)+(a*112|0)+32|0,4,1,b);ZMa((c[f>>2]|0)+(a*112|0)+48|0,4,1,b);ZMa((c[f>>2]|0)+(a*112|0)+64|0,4,1,b);ZMa((c[f>>2]|0)+(a*112|0)+80|0,4,1,b);ZMa((c[f>>2]|0)+(a*112|0)+96|0,4,1,b);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=d;return 1}function JQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+5|0;g=e+4|0;h=e+3|0;j=e+2|0;k=e+1|0;l=e;if((c[b+84>>2]&1|0)==0?(m=b+92|0,n=c[m>>2]|0,(n|0)!=0):0){VJa(f,n+(0-(c[n+-4>>2]|0))|0);c[m>>2]=0}QMa(g,h,j,k,d);if(!((a[g>>0]|0)==82&(a[h>>0]|0)==84&(a[j>>0]|0)==82&(a[k>>0]|0)==69)){o=0;i=e;return o|0}if((SMa(1,d)|0)!=1){o=0;i=e;return o|0}XMa(b,4,1,d)|0;XMa(b+16|0,4,1,d)|0;XMa(b+32|0,4,1,d)|0;XMa(b+48|0,4,1,d)|0;c[b+64>>2]=SMa(1,d)|0;c[b+68>>2]=SMa(1,d)|0;c[b+72>>2]=SMa(1,d)|0;c[b+76>>2]=SMa(1,d)|0;k=b+80|0;c[k>>2]=SMa(1,d)|0;c[b+88>>2]=SMa(1,d)|0;j=UJa(l,((c[k>>2]|0)*112|0)+131|0,542736,137)|0;if(!j)p=0;else{l=j+131&-128;c[l+-4>>2]=l-j;p=l}l=b+92|0;c[l>>2]=p;if(!(c[k>>2]|0)){o=1;i=e;return o|0}else{q=p;r=0}while(1){XMa(q+(r*112|0)|0,4,1,d)|0;XMa((c[l>>2]|0)+(r*112|0)+16|0,4,1,d)|0;XMa((c[l>>2]|0)+(r*112|0)+32|0,4,1,d)|0;XMa((c[l>>2]|0)+(r*112|0)+48|0,4,1,d)|0;XMa((c[l>>2]|0)+(r*112|0)+64|0,4,1,d)|0;XMa((c[l>>2]|0)+(r*112|0)+80|0,4,1,d)|0;XMa((c[l>>2]|0)+(r*112|0)+96|0,4,1,d)|0;p=r+1|0;if(p>>>0>=(c[k>>2]|0)>>>0){o=1;break}q=c[l>>2]|0;r=p}i=e;return o|0}function KQa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;if(c[a+84>>2]&1){i=b;return}d=a+92|0;a=c[d>>2]|0;if(!a){i=b;return}VJa(b,a+(0-(c[a+-4>>2]|0))|0);c[d>>2]=0;i=b;return}function LQa(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[b>>2]|0)+12>>2]&4095](b,128);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+92>>2]|0,(c[a+80>>2]|0)*112|0);i=d;return}function MQa(a,b,d,e,f,h,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=ea(l);var m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im;j=i;i=i+528|0;f=j+8|0;e=j+4|0;m=j;n=(c[a+84>>2]&2|0)==0;if(n)o=c[a+92>>2]|0;else o=0;p=ea(g[b>>2]);q=ea(g[b+4>>2]);r=ea(g[b+8>>2]);s=ea(g[d>>2]);t=ea(g[d+4>>2]);u=ea(g[d+8>>2]);d=(g[k>>2]=s,c[k>>2]|0);b=(g[k>>2]=t,c[k>>2]|0);v=(g[k>>2]=u,c[k>>2]|0)&-2147483648;w=ea(-s);x=ea(-t);y=ea(-u);z=s>w?s:w;w=t>x?t:x;x=u>y?u:y;A=z>ea(9.99999971e-10);B=w>ea(9.99999971e-10);C=x>ea(9.99999971e-10);D=A?(g[k>>2]=z,c[k>>2]|0):814313567;A=B?(g[k>>2]=w,c[k>>2]|0):814313567;B=(C?(g[k>>2]=x,c[k>>2]|0):814313567)|v;x=(c[k>>2]=D|d&-2147483648,ea(g[k>>2]));w=(c[k>>2]=A|b&-2147483648,ea(g[k>>2]));z=(c[k>>2]=B,ea(g[k>>2]));y=ea(ea(1.0)/x);u=ea(ea(1.0)/w);t=ea(ea(1.0)/z);s=ea(y*ea(ea(2.0)-ea(y*x)));x=ea(u*ea(ea(2.0)-ea(u*w)));w=ea(t*ea(ea(2.0)-ea(t*z)));z=ea(ea(0.0)-ea(p*s));p=ea(ea(0.0)-ea(q*x));q=ea(ea(0.0)-ea(r*w));B=c[a+68>>2]|0;b=B+-1|0;if((b|0)<=-1){i=j;return}A=a+92|0;if(n){n=b;b=0;while(1){b=b+1|0;c[f+(b<<2)>>2]=n*112;if((b|0)==(B|0))break;else n=n+-1|0}}else{n=0;do{n=n+1|0;c[f+(n<<2)>>2]=c[A>>2]}while((n|0)!=(B|0))}if(!B){i=j;return}r=l;n=B;a:while(1){B=n;while(1){E=B+-1|0;A=f+(B<<2)|0;b=c[A>>2]|0;c[e>>2]=b;if(b&1){c[e>>2]=b+-1;g[m>>2]=r;if(!(kn[c[c[h>>2]>>2]&511](h,1,e,m)|0)){F=16;break a}G=ea(g[m>>2]);if(r!=G)break;else H=E}else{l=ea(g[o+b>>2]);t=ea(g[o+(b+4)>>2]);u=ea(g[o+(b+8)>>2]);y=ea(g[o+(b+12)>>2]);I=ea(g[o+(b+16)>>2]);J=ea(g[o+(b+20)>>2]);K=ea(g[o+(b+24)>>2]);L=ea(g[o+(b+28)>>2]);M=ea(g[o+(b+32)>>2]);N=ea(g[o+(b+36)>>2]);O=ea(g[o+(b+40)>>2]);P=ea(g[o+(b+44)>>2]);Q=ea(g[o+(b+48)>>2]);R=ea(g[o+(b+52)>>2]);S=ea(g[o+(b+56)>>2]);T=ea(g[o+(b+60)>>2]);U=ea(g[o+(b+64)>>2]);V=ea(g[o+(b+68)>>2]);W=ea(g[o+(b+72)>>2]);X=ea(g[o+(b+76)>>2]);Y=ea(g[o+(b+80)>>2]);Z=ea(g[o+(b+84)>>2]);_=ea(g[o+(b+88)>>2]);$=ea(z+ea(s*l));aa=ea(z+ea(s*t));ba=ea(z+ea(s*u));ca=ea(z+ea(s*y));da=ea(p+ea(x*I));I=ea(p+ea(x*J));J=ea(p+ea(x*K));K=ea(p+ea(x*L));L=ea(q+ea(w*M));M=ea(q+ea(w*N));N=ea(q+ea(w*O));O=ea(q+ea(w*P));P=ea(z+ea(s*Q));fa=ea(z+ea(s*R));ga=ea(z+ea(s*S));ha=ea(z+ea(s*T));ia=ea(p+ea(x*U));U=ea(p+ea(x*V));V=ea(p+ea(x*W));W=ea(p+ea(x*X));X=ea(q+ea(w*Y));Y=ea(q+ea(w*Z));Z=ea(q+ea(w*_));_=ea(q+ea(w*ea(g[o+(b+92)>>2])));ja=$<P?$:P;ka=aa<fa?aa:fa;la=ba<ga?ba:ga;ma=ca<ha?ca:ha;na=$>P?$:P;P=aa>fa?aa:fa;fa=ba>ga?ba:ga;ga=ca>ha?ca:ha;ha=da<ia?da:ia;ca=I<U?I:U;ba=J<V?J:V;aa=K<W?K:W;$=da>ia?da:ia;ia=I>U?I:U;U=J>V?J:V;V=K>W?K:W;W=L<X?L:X;K=M<Y?M:Y;J=N<Z?N:Z;I=O<_?O:_;da=L>X?L:X;X=M>Y?M:Y;Y=N>Z?N:Z;Z=O>_?O:_;_=ja>ha?ja:ha;ha=ka>ca?ka:ca;ca=la>ba?la:ba;ba=ma>aa?ma:aa;aa=_>W?_:W;W=ha>K?ha:K;K=ca>J?ca:J;J=ba>I?ba:I;I=na<$?na:$;$=P<ia?P:ia;ia=fa<U?fa:U;U=ga<V?ga:V;V=I<da?I:da;da=$<X?$:X;X=ia<Y?ia:Y;Y=U<Z?U:Z;a=(aa>r|(V<ea(9.99999971e-10)|l>Q)|aa>V)<<31>>31;d=(W>r|(da<ea(9.99999971e-10)|t>R)|W>da)<<31>>31;D=(K>r|(X<ea(9.99999971e-10)|u>S)|K>X)<<31>>31;v=(J>r|(Y<ea(9.99999971e-10)|y>T)|J>Y)<<31>>31;c[A>>2]=c[o+(b+96)>>2];A=a+B|0;c[f+(A+1<<2)>>2]=c[o+(b+100)>>2];a=d+1+A|0;c[f+(a+1<<2)>>2]=c[o+(b+104)>>2];A=D+1+a|0;c[f+(A+1<<2)>>2]=c[o+(b+108)>>2];H=v+1+A|0}if(!H){F=16;break a}else B=H}if(!E){F=16;break}else{r=G;n=E}}if((F|0)==16){i=j;return}}function NQa(a,b,d,e,f,h,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=ea(l);var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im;f=i;i=i+528|0;e=f+8|0;m=f+4|0;n=f;o=(c[a+84>>2]&2|0)==0;if(o)p=c[a+92>>2]|0;else p=0;q=ea(g[j>>2]);r=ea(g[j+4>>2]);s=ea(q+ea(1.00000001e-07));q=ea(r+ea(1.00000001e-07));r=ea(ea(g[j+8>>2])+ea(1.00000001e-07));t=ea(g[b>>2]);u=ea(g[b+4>>2]);v=ea(g[b+8>>2]);w=ea(g[d>>2]);x=ea(g[d+4>>2]);y=ea(g[d+8>>2]);d=(g[k>>2]=w,c[k>>2]|0);b=(g[k>>2]=x,c[k>>2]|0);j=(g[k>>2]=y,c[k>>2]|0)&-2147483648;z=ea(-w);A=ea(-x);B=ea(-y);C=w>z?w:z;z=x>A?x:A;A=y>B?y:B;D=C>ea(9.99999971e-10);E=z>ea(9.99999971e-10);F=A>ea(9.99999971e-10);G=D?(g[k>>2]=C,c[k>>2]|0):814313567;D=E?(g[k>>2]=z,c[k>>2]|0):814313567;E=(F?(g[k>>2]=A,c[k>>2]|0):814313567)|j;A=(c[k>>2]=G|d&-2147483648,ea(g[k>>2]));z=(c[k>>2]=D|b&-2147483648,ea(g[k>>2]));C=(c[k>>2]=E,ea(g[k>>2]));B=ea(ea(1.0)/A);y=ea(ea(1.0)/z);x=ea(ea(1.0)/C);w=ea(B*ea(ea(2.0)-ea(B*A)));A=ea(y*ea(ea(2.0)-ea(y*z)));z=ea(x*ea(ea(2.0)-ea(x*C)));C=ea(ea(0.0)-ea(t*w));t=ea(ea(0.0)-ea(u*A));u=ea(ea(0.0)-ea(v*z));E=c[a+68>>2]|0;b=E+-1|0;if((b|0)<=-1){i=f;return}D=a+92|0;if(o){o=b;b=0;while(1){b=b+1|0;c[e+(b<<2)>>2]=o*112;if((b|0)==(E|0))break;else o=o+-1|0}}else{o=0;do{o=o+1|0;c[e+(o<<2)>>2]=c[D>>2]}while((o|0)!=(E|0))}if(!E){i=f;return}v=l;o=E;a:while(1){E=o;while(1){H=E+-1|0;D=e+(E<<2)|0;b=c[D>>2]|0;c[m>>2]=b;if(b&1){c[m>>2]=b+-1;g[n>>2]=v;if(!(kn[c[c[h>>2]>>2]&511](h,1,m,n)|0)){I=16;break a}J=ea(g[n>>2]);if(v!=J)break;else K=H}else{l=ea(g[p+b>>2]);x=ea(g[p+(b+4)>>2]);y=ea(g[p+(b+8)>>2]);B=ea(g[p+(b+12)>>2]);L=ea(g[p+(b+16)>>2]);M=ea(g[p+(b+20)>>2]);N=ea(g[p+(b+24)>>2]);O=ea(g[p+(b+28)>>2]);P=ea(g[p+(b+32)>>2]);Q=ea(g[p+(b+36)>>2]);R=ea(g[p+(b+40)>>2]);S=ea(g[p+(b+44)>>2]);T=ea(g[p+(b+48)>>2]);U=ea(g[p+(b+52)>>2]);V=ea(g[p+(b+56)>>2]);W=ea(g[p+(b+60)>>2]);X=ea(g[p+(b+64)>>2]);Y=ea(g[p+(b+68)>>2]);Z=ea(g[p+(b+72)>>2]);_=ea(g[p+(b+76)>>2]);$=ea(g[p+(b+80)>>2]);aa=ea(g[p+(b+84)>>2]);ba=ea(g[p+(b+88)>>2]);ca=ea(C+ea(w*ea(l-s)));da=ea(C+ea(w*ea(x-s)));fa=ea(C+ea(w*ea(y-s)));ga=ea(C+ea(w*ea(B-s)));ha=ea(t+ea(A*ea(L-q)));L=ea(t+ea(A*ea(M-q)));M=ea(t+ea(A*ea(N-q)));N=ea(t+ea(A*ea(O-q)));O=ea(u+ea(z*ea(P-r)));P=ea(u+ea(z*ea(Q-r)));Q=ea(u+ea(z*ea(R-r)));R=ea(u+ea(z*ea(S-r)));S=ea(C+ea(w*ea(s+T)));ia=ea(C+ea(w*ea(s+U)));ja=ea(C+ea(w*ea(s+V)));ka=ea(C+ea(w*ea(s+W)));la=ea(t+ea(A*ea(q+X)));X=ea(t+ea(A*ea(q+Y)));Y=ea(t+ea(A*ea(q+Z)));Z=ea(t+ea(A*ea(q+_)));_=ea(u+ea(z*ea(r+$)));$=ea(u+ea(z*ea(r+aa)));aa=ea(u+ea(z*ea(r+ba)));ba=ea(u+ea(z*ea(r+ea(g[p+(b+92)>>2]))));ma=ca<S?ca:S;na=da<ia?da:ia;oa=fa<ja?fa:ja;pa=ga<ka?ga:ka;qa=ca>S?ca:S;S=da>ia?da:ia;ia=fa>ja?fa:ja;ja=ga>ka?ga:ka;ka=ha<la?ha:la;ga=L<X?L:X;fa=M<Y?M:Y;da=N<Z?N:Z;ca=ha>la?ha:la;la=L>X?L:X;X=M>Y?M:Y;Y=N>Z?N:Z;Z=O<_?O:_;N=P<$?P:$;M=Q<aa?Q:aa;L=R<ba?R:ba;ha=O>_?O:_;_=P>$?P:$;$=Q>aa?Q:aa;aa=R>ba?R:ba;ba=ma>ka?ma:ka;ka=na>ga?na:ga;ga=oa>fa?oa:fa;fa=pa>da?pa:da;da=ba>Z?ba:Z;Z=ka>N?ka:N;N=ga>M?ga:M;M=fa>L?fa:L;L=qa<ca?qa:ca;ca=S<la?S:la;la=ia<X?ia:X;X=ja<Y?ja:Y;Y=L<ha?L:ha;ha=ca<_?ca:_;_=la<$?la:$;$=X<aa?X:aa;a=(da>v|(Y<ea(9.99999971e-10)|l>T)|da>Y)<<31>>31;d=(Z>v|(ha<ea(9.99999971e-10)|x>U)|Z>ha)<<31>>31;G=(N>v|(_<ea(9.99999971e-10)|y>V)|N>_)<<31>>31;j=(M>v|($<ea(9.99999971e-10)|B>W)|M>$)<<31>>31;c[D>>2]=c[p+(b+96)>>2];D=a+E|0;c[e+(D+1<<2)>>2]=c[p+(b+100)>>2];a=d+1+D|0;c[e+(a+1<<2)>>2]=c[p+(b+104)>>2];D=G+1+a|0;c[e+(D+1<<2)>>2]=c[p+(b+108)>>2];K=j+1+D|0}if(!K){I=16;break a}else E=K}if(!H){I=16;break}else{v=J;o=H}}if((I|0)==16){i=f;return}}function OQa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0;f=i;i=i+544|0;e=f+24|0;j=f;k=f+16|0;l=e+4|0;m=ea(g[b>>2]);n=ea(g[b+4>>2]);o=ea(g[b+8>>2]);p=ea(g[d>>2]);q=ea(g[d+4>>2]);r=ea(g[d+8>>2]);d=a+84|0;b=(c[d>>2]&2|0)==0;if(b)s=c[a+92>>2]|0;else s=0;t=c[a+68>>2]|0;u=t+-1|0;if((u|0)>-1){v=a+92|0;w=t+1|0;t=b;x=u;u=l;while(1){if(t)y=x*112|0;else y=(c[v>>2]|0)+(x*112|0)|0;c[u>>2]=y;x=x+-1|0;t=(c[d>>2]&2|0)==0;if((x|0)<=-1)break;else u=u+4|0}u=e+(w<<2)|0;if(t){z=0;A=u}else{B=u;C=11}}else if(b){z=0;A=l}else{B=l;C=11}if((C|0)==11){z=c[a+92>>2]|0;A=B}B=j+4|0;a=j+8|0;b=j+12|0;u=z;z=1;t=A;a:while(1){A=t+-4|0;if(!z)D=c[A>>2]|0;else D=u;w=s+D|0;e=s+(D+96)|0;E=ea(g[w>>2]);F=ea(g[s+(D+4)>>2]);G=ea(g[s+(D+8)>>2]);H=ea(g[s+(D+12)>>2]);I=ea(g[s+(D+16)>>2]);J=ea(g[s+(D+20)>>2]);K=ea(g[s+(D+24)>>2]);L=ea(g[s+(D+28)>>2]);M=ea(g[s+(D+32)>>2]);N=ea(g[s+(D+36)>>2]);O=ea(g[s+(D+40)>>2]);P=ea(g[s+(D+44)>>2]);Q=ea(g[s+(D+48)>>2]);R=ea(g[s+(D+52)>>2]);S=ea(g[s+(D+56)>>2]);T=ea(g[s+(D+60)>>2]);U=ea(g[s+(D+64)>>2]);V=ea(g[s+(D+68)>>2]);W=ea(g[s+(D+72)>>2]);X=ea(g[s+(D+76)>>2]);Y=ea(g[s+(D+80)>>2]);Z=ea(g[s+(D+84)>>2]);_=ea(g[s+(D+88)>>2]);x=(M>r|I>q|(E>p|o>Y|(n>U|m>Q)))<<31>>31;d=(P>r|L>q|((H>p?1:o>ea(g[s+(D+92)>>2]))|(n>X|m>T)))<<31>>31;c[j>>2]=x;c[B>>2]=(N>r|J>q|(F>p|o>Z|(n>V|m>R)))<<31>>31;c[a>>2]=(O>r|K>q|(G>p|o>_|(n>W|m>S)))<<31>>31;c[b>>2]=d;d=x;x=u;y=0;v=0;$=A;while(1){A=c[e+(v<<2)>>2]&-2;c[k>>2]=A;do if(!d)if(c[w+(v<<2)+96>>2]&1)if(xo[c[c[h>>2]>>2]&2047](h,1,k)|0){aa=x;ba=y;ca=$;break}else{C=23;break a}else{c[$>>2]=A;aa=c[k>>2]|0;ba=1;ca=$+4|0;break}else{aa=x;ba=y;ca=$}while(0);A=v+1|0;if(A>>>0>=4)break;d=c[j+(A<<2)>>2]|0;x=aa;y=ba;v=A;$=ca}if(ca>>>0>l>>>0){u=aa;z=ba;t=ca}else{C=23;break}}if((C|0)==23){i=f;return}}function PQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;e=i;i=i+544|0;d=e+24|0;h=e;j=e+16|0;l=a+84|0;m=(c[l>>2]&2|0)==0;if(m)n=c[a+92>>2]|0;else n=0;o=b+36|0;p=ea(g[o>>2]);q=ea(g[o+4>>2]);r=ea(g[o+8>>2]);o=b+48|0;s=ea(g[o>>2]);t=ea(g[o+4>>2]);u=ea(g[o+8>>2]);v=ea(g[b>>2]);w=ea(g[b+4>>2]);x=ea(g[b+8>>2]);o=b+12|0;y=ea(g[o>>2]);z=ea(g[o+4>>2]);A=ea(g[o+8>>2]);o=b+24|0;B=ea(g[o>>2]);C=ea(g[o+4>>2]);D=ea(g[o+8>>2]);o=c[a+68>>2]|0;b=o+-1|0;if((b|0)>-1){E=a+92|0;F=m;G=b;b=d;while(1){if(F)H=G*112|0;else H=c[E>>2]|0;c[b>>2]=H;G=G+-1|0;F=(c[l>>2]&2|0)==0;if((G|0)<=-1)break;else b=b+4|0}b=d+(o<<2)|0;if(F){I=0;J=b}else{K=b;L=11}}else if(m){I=0;J=d}else{K=d;L=11}if((L|0)==11){I=c[a+92>>2]|0;J=K}M=ea(ea(0.0)-s);N=ea(ea(0.0)-t);O=ea(ea(0.0)-u);P=ea(ea(s*v)+ea(0.0));Q=ea(ea(s*w)+ea(0.0));R=ea(ea(s*x)+ea(0.0));S=ea(ea(t*y)+ea(0.0));T=ea(ea(t*z)+ea(0.0));U=ea(ea(t*A)+ea(0.0));V=ea(ea(u*B)+ea(0.0));W=ea(ea(u*C)+ea(0.0));X=ea(ea(u*D)+ea(0.0));K=h+4|0;a=h+8|0;m=h+12|0;b=I;I=1;F=J;a:while(1){J=F+-4|0;if(!I)Y=c[J>>2]|0;else Y=b;o=n+Y|0;G=n+(Y+96)|0;Z=ea(g[o>>2]);_=ea(g[n+(Y+4)>>2]);$=ea(g[n+(Y+8)>>2]);aa=ea(g[n+(Y+12)>>2]);ba=ea(g[n+(Y+16)>>2]);ca=ea(g[n+(Y+20)>>2]);da=ea(g[n+(Y+24)>>2]);fa=ea(g[n+(Y+28)>>2]);ga=ea(g[n+(Y+32)>>2]);ha=ea(g[n+(Y+36)>>2]);ia=ea(g[n+(Y+40)>>2]);ja=ea(g[n+(Y+44)>>2]);ka=ea(g[n+(Y+48)>>2]);la=ea(g[n+(Y+52)>>2]);ma=ea(g[n+(Y+56)>>2]);na=ea(g[n+(Y+60)>>2]);oa=ea(g[n+(Y+64)>>2]);pa=ea(g[n+(Y+68)>>2]);qa=ea(g[n+(Y+72)>>2]);ra=ea(g[n+(Y+76)>>2]);sa=ea(g[n+(Y+80)>>2]);ta=ea(g[n+(Y+84)>>2]);ua=ea(g[n+(Y+88)>>2]);va=ea(g[n+(Y+92)>>2]);wa=ka<p?ka:p;xa=la<p?la:p;ya=ma<p?ma:p;za=na<p?na:p;Aa=Z>wa?Z:wa;wa=_>xa?_:xa;xa=$>ya?$:ya;ya=aa>za?aa:za;za=oa<q?oa:q;Ba=pa<q?pa:q;Ca=qa<q?qa:q;Da=ra<q?ra:q;Ea=ba>za?ba:za;za=ca>Ba?ca:Ba;Ba=da>Ca?da:Ca;Ca=fa>Da?fa:Da;Da=sa<r?sa:r;Fa=ta<r?ta:r;Ga=ua<r?ua:r;Ha=va<r?va:r;Ia=ga>Da?ga:Da;Da=ha>Fa?ha:Fa;Fa=ia>Ga?ia:Ga;Ga=ja>Ha?ja:Ha;Ha=ea(Aa-p);Ja=ea(wa-p);Ka=ea(xa-p);La=ea(ya-p);Ma=ea(Ea-q);Na=ea(za-q);Oa=ea(Ba-q);Pa=ea(Ca-q);Qa=ea(Ia-r);Ra=ea(Da-r);Sa=ea(Fa-r);Ta=ea(Ga-r);Ua=ea(ea(v*Ha)+ea(ea(w*Ma)+ea(ea(x*Qa)+ea(0.0))));Va=ea(ea(v*Ja)+ea(ea(w*Na)+ea(ea(x*Ra)+ea(0.0))));Wa=ea(ea(v*Ka)+ea(ea(w*Oa)+ea(ea(x*Sa)+ea(0.0))));Xa=ea(ea(v*La)+ea(ea(w*Pa)+ea(ea(x*Ta)+ea(0.0))));Ya=ea(ea(y*Ha)+ea(ea(z*Ma)+ea(ea(A*Qa)+ea(0.0))));Za=ea(ea(y*Ja)+ea(ea(z*Na)+ea(ea(A*Ra)+ea(0.0))));_a=ea(ea(y*Ka)+ea(ea(z*Oa)+ea(ea(A*Sa)+ea(0.0))));$a=ea(ea(y*La)+ea(ea(z*Pa)+ea(ea(A*Ta)+ea(0.0))));ab=ea(ea(B*Ha)+ea(ea(C*Ma)+ea(ea(D*Qa)+ea(0.0))));Qa=ea(ea(B*Ja)+ea(ea(C*Na)+ea(ea(D*Ra)+ea(0.0))));Ra=ea(ea(B*Ka)+ea(ea(C*Oa)+ea(ea(D*Sa)+ea(0.0))));Sa=ea(ea(B*La)+ea(ea(C*Pa)+ea(ea(D*Ta)+ea(0.0))));Ta=Ua<s?Ua:s;Ua=Va<s?Va:s;Va=Wa<s?Wa:s;Wa=Xa<s?Xa:s;Xa=M>Ta?M:Ta;Ta=M>Ua?M:Ua;Ua=M>Va?M:Va;Va=M>Wa?M:Wa;Wa=Ya<t?Ya:t;Ya=Za<t?Za:t;Za=_a<t?_a:t;_a=$a<t?$a:t;$a=N>Wa?N:Wa;Wa=N>Ya?N:Ya;Ya=N>Za?N:Za;Za=N>_a?N:_a;_a=ab<u?ab:u;ab=Qa<u?Qa:u;Qa=Ra<u?Ra:u;Ra=Sa<u?Sa:u;Sa=O>_a?O:_a;_a=O>ab?O:ab;ab=O>Qa?O:Qa;Qa=O>Ra?O:Ra;Ra=ea(ea(v*Xa)+ea(ea(y*$a)+ea(p+ea(B*Sa))));Pa=ea(ea(v*Ta)+ea(ea(y*Wa)+ea(p+ea(B*_a))));La=ea(ea(v*Ua)+ea(ea(y*Ya)+ea(p+ea(B*ab))));Oa=ea(ea(v*Va)+ea(ea(y*Za)+ea(p+ea(B*Qa))));Ka=ea(ea(w*Xa)+ea(ea(z*$a)+ea(q+ea(C*Sa))));Na=ea(ea(w*Ta)+ea(ea(z*Wa)+ea(q+ea(C*_a))));Ja=ea(ea(w*Ua)+ea(ea(z*Ya)+ea(q+ea(C*ab))));Ma=ea(ea(w*Va)+ea(ea(z*Za)+ea(q+ea(C*Qa))));Ha=ea(ea(x*Xa)+ea(ea(A*$a)+ea(r+ea(D*Sa))));Sa=ea(ea(x*Ta)+ea(ea(A*Wa)+ea(r+ea(D*_a))));_a=ea(ea(x*Ua)+ea(ea(A*Ya)+ea(r+ea(D*ab))));ab=ea(ea(x*Va)+ea(ea(A*Za)+ea(r+ea(D*Qa))));Qa=ka<Ra?ka:Ra;Za=la<Pa?la:Pa;Va=ma<La?ma:La;Ya=na<Oa?na:Oa;Ua=oa<Ka?oa:Ka;Wa=pa<Na?pa:Na;Ta=qa<Ja?qa:Ja;$a=ra<Ma?ra:Ma;Xa=sa<Ha?sa:Ha;bb=ta<Sa?ta:Sa;cb=ua<_a?ua:_a;db=va<ab?va:ab;eb=ea(ea(ea(Z+ka)*ea(.5))+ea(0.0));fb=ea(ea(ea(_+la)*ea(.5))+ea(0.0));gb=ea(ea(ea($+ma)*ea(.5))+ea(0.0));hb=ea(ea(ea(aa+na)*ea(.5))+ea(0.0));ib=ea(ea(ea(ba+oa)*ea(.5))+ea(0.0));jb=ea(ea(ea(ca+pa)*ea(.5))+ea(0.0));kb=ea(ea(ea(da+qa)*ea(.5))+ea(0.0));lb=ea(ea(ea(fa+ra)*ea(.5))+ea(0.0));mb=ea(ea(ea(ga+sa)*ea(.5))+ea(0.0));nb=ea(ea(ea(ha+ta)*ea(.5))+ea(0.0));ob=ea(ea(ea(ia+ua)*ea(.5))+ea(0.0));pb=ea(ea(ea(ja+va)*ea(.5))+ea(0.0));qb=ea(ka-eb);rb=ea(la-fb);sb=ea(ma-gb);tb=ea(na-hb);ub=ea(oa-ib);oa=ea(pa-jb);pa=ea(qa-kb);qa=ea(ra-lb);ra=ea(sa-mb);sa=ea(ta-nb);ta=ea(ua-ob);ua=ea(va-pb);va=ea(Ra-Aa);Aa=ea(Pa-wa);wa=ea(La-xa);xa=ea(Oa-ya);ya=ea(Ka-Ea);Ea=ea(Na-za);za=ea(Ja-Ba);Ba=ea(Ma-Ca);Ca=ea(Ha-Ia);Ia=ea(Sa-Da);Da=ea(_a-Fa);Fa=ea(ab-Ga);Ga=ea(ea(qb*va)+ea(0.0));vb=ea(ea(rb*Aa)+ea(0.0));wb=ea(ea(sb*wa)+ea(0.0));xb=ea(ea(tb*xa)+ea(0.0));yb=ea(ea(ub*ya)+ea(0.0));zb=ea(ea(oa*Ea)+ea(0.0));Ab=ea(ea(pa*za)+ea(0.0));Bb=ea(ea(qa*Ba)+ea(0.0));Cb=ea(ea(ra*Ca)+ea(0.0));Db=ea(ea(sa*Ia)+ea(0.0));Eb=ea(ea(ta*Da)+ea(0.0));Fb=ea(ea(ua*Fa)+ea(0.0));Gb=ea(ea(P*va)+ea(ea(Q*ya)+ea(ea(R*Ca)+ea(0.0))));Hb=ea(ea(P*Aa)+ea(ea(Q*Ea)+ea(ea(R*Ia)+ea(0.0))));Ib=ea(ea(P*wa)+ea(ea(Q*za)+ea(ea(R*Da)+ea(0.0))));Jb=ea(ea(P*xa)+ea(ea(Q*Ba)+ea(ea(R*Fa)+ea(0.0))));Kb=ea(ea(S*va)+ea(ea(T*ya)+ea(ea(U*Ca)+ea(0.0))));Lb=ea(ea(S*Aa)+ea(ea(T*Ea)+ea(ea(U*Ia)+ea(0.0))));Mb=ea(ea(S*wa)+ea(ea(T*za)+ea(ea(U*Da)+ea(0.0))));Nb=ea(ea(S*xa)+ea(ea(T*Ba)+ea(ea(U*Fa)+ea(0.0))));Ob=ea(ea(V*va)+ea(ea(W*ya)+ea(ea(X*Ca)+ea(0.0))));Pb=ea(ea(V*Aa)+ea(ea(W*Ea)+ea(ea(X*Ia)+ea(0.0))));Qb=ea(ea(V*wa)+ea(ea(W*za)+ea(ea(X*Da)+ea(0.0))));Rb=ea(ea(V*xa)+ea(ea(W*Ba)+ea(ea(X*Fa)+ea(0.0))));Sb=ea(ea(ea(eb*va)+ea(ea(ib*ya)+ea(ea(mb*Ca)+ea(0.0))))-ea(ea(p*va)+ea(ea(q*ya)+ea(ea(r*Ca)+ea(0.0)))));Ca=ea(ea(ea(fb*Aa)+ea(ea(jb*Ea)+ea(ea(nb*Ia)+ea(0.0))))-ea(ea(p*Aa)+ea(ea(q*Ea)+ea(ea(r*Ia)+ea(0.0)))));Ia=ea(ea(ea(gb*wa)+ea(ea(kb*za)+ea(ea(ob*Da)+ea(0.0))))-ea(ea(p*wa)+ea(ea(q*za)+ea(ea(r*Da)+ea(0.0)))));Da=ea(ea(ea(hb*xa)+ea(ea(lb*Ba)+ea(ea(pb*Fa)+ea(0.0))))-ea(ea(p*xa)+ea(ea(q*Ba)+ea(ea(r*Fa)+ea(0.0)))));l=(g[k>>2]=Sb,c[k>>2]|0);H=(g[k>>2]=Ca,c[k>>2]|0);E=(g[k>>2]=Ia,c[k>>2]|0);Tb=(g[k>>2]=Da,c[k>>2]|0)&2147483647;Ub=(g[k>>2]=Ga,c[k>>2]|0);Vb=(g[k>>2]=vb,c[k>>2]|0);Wb=(g[k>>2]=wb,c[k>>2]|0);Xb=(g[k>>2]=xb,c[k>>2]|0)&2147483647;Yb=(g[k>>2]=yb,c[k>>2]|0);Zb=(g[k>>2]=zb,c[k>>2]|0);_b=(g[k>>2]=Ab,c[k>>2]|0);$b=(g[k>>2]=Bb,c[k>>2]|0)&2147483647;Bb=(c[k>>2]=Ub&2147483647,ea(g[k>>2]));Ab=ea(Bb+(c[k>>2]=Yb&2147483647,ea(g[k>>2])));Bb=(c[k>>2]=Vb&2147483647,ea(g[k>>2]));zb=ea(Bb+(c[k>>2]=Zb&2147483647,ea(g[k>>2])));Bb=(c[k>>2]=Wb&2147483647,ea(g[k>>2]));yb=ea(Bb+(c[k>>2]=_b&2147483647,ea(g[k>>2])));Bb=(c[k>>2]=Xb,ea(g[k>>2]));xb=ea(Bb+(c[k>>2]=$b,ea(g[k>>2])));$b=(g[k>>2]=Cb,c[k>>2]|0);Xb=(g[k>>2]=Db,c[k>>2]|0);_b=(g[k>>2]=Eb,c[k>>2]|0);Wb=(g[k>>2]=Fb,c[k>>2]|0)&2147483647;Fb=ea((c[k>>2]=$b&2147483647,ea(g[k>>2]))+Ab);Ab=ea((c[k>>2]=Xb&2147483647,ea(g[k>>2]))+zb);zb=ea((c[k>>2]=_b&2147483647,ea(g[k>>2]))+yb);yb=ea((c[k>>2]=Wb,ea(g[k>>2]))+xb);Wb=(g[k>>2]=Gb,c[k>>2]|0);_b=(g[k>>2]=Hb,c[k>>2]|0);Xb=(g[k>>2]=Ib,c[k>>2]|0);$b=(g[k>>2]=Jb,c[k>>2]|0)&2147483647;Zb=(g[k>>2]=Kb,c[k>>2]|0);Vb=(g[k>>2]=Lb,c[k>>2]|0);Yb=(g[k>>2]=Mb,c[k>>2]|0);Ub=(g[k>>2]=Nb,c[k>>2]|0)&2147483647;Nb=(c[k>>2]=Wb&2147483647,ea(g[k>>2]));Mb=ea(Nb+(c[k>>2]=Zb&2147483647,ea(g[k>>2])));Nb=(c[k>>2]=_b&2147483647,ea(g[k>>2]));Lb=ea(Nb+(c[k>>2]=Vb&2147483647,ea(g[k>>2])));Nb=(c[k>>2]=Xb&2147483647,ea(g[k>>2]));Kb=ea(Nb+(c[k>>2]=Yb&2147483647,ea(g[k>>2])));Nb=(c[k>>2]=$b,ea(g[k>>2]));Jb=ea(Nb+(c[k>>2]=Ub,ea(g[k>>2])));Ub=(g[k>>2]=Ob,c[k>>2]|0);$b=(g[k>>2]=Pb,c[k>>2]|0);Yb=(g[k>>2]=Qb,c[k>>2]|0);Xb=(g[k>>2]=Rb,c[k>>2]|0)&2147483647;Rb=ea((c[k>>2]=Ub&2147483647,ea(g[k>>2]))+Mb);Mb=ea((c[k>>2]=$b&2147483647,ea(g[k>>2]))+Lb);Lb=ea((c[k>>2]=Yb&2147483647,ea(g[k>>2]))+Kb);Kb=ea((c[k>>2]=Xb,ea(g[k>>2]))+Jb);Jb=(c[k>>2]=l&2147483647,ea(g[k>>2]));Qb=ea(Jb+ea(-9.99999997e-07));Pb=(c[k>>2]=H&2147483647,ea(g[k>>2]));Ob=ea(Pb+ea(-9.99999997e-07));Nb=(c[k>>2]=E&2147483647,ea(g[k>>2]));Ib=ea(Nb+ea(-9.99999997e-07));Hb=(c[k>>2]=Tb,ea(g[k>>2]));Tb=Qb>ea(Fb+Rb);E=Ob>ea(Ab+Mb);H=Ib>ea(zb+Lb);l=ea(Hb+ea(-9.99999997e-07))>ea(yb+Kb);Xb=Jb>ea(9.99999997e-07);Yb=Pb>ea(9.99999997e-07);$b=Nb>ea(9.99999997e-07);Ub=Hb>ea(9.99999997e-07);Hb=ea(Ra-(Z>Qa?Z:Qa));Qa=ea(Pa-(_>Za?_:Za));Za=ea(La-($>Va?$:Va));Va=ea(Oa-(aa>Ya?aa:Ya));Ya=ea(Ka-(ba>Ua?ba:Ua));Ua=ea(Na-(ca>Wa?ca:Wa));Wa=ea(Ja-(da>Ta?da:Ta));Ta=ea(Ma-(fa>$a?fa:$a));$a=ea(Ha-(ga>Xa?ga:Xa));Xa=ea(Sa-(ha>bb?ha:bb));bb=ea(_a-(ia>cb?ia:cb));cb=ea(ab-(ja>db?ja:db));db=ea(ea(qb*Hb)+ea(0.0));qb=ea(ea(rb*Qa)+ea(0.0));rb=ea(ea(sb*Za)+ea(0.0));sb=ea(ea(tb*Va)+ea(0.0));tb=ea(ea(ub*Ya)+ea(0.0));ub=ea(ea(oa*Ua)+ea(0.0));oa=ea(ea(pa*Wa)+ea(0.0));pa=ea(ea(qa*Ta)+ea(0.0));qa=ea(ea(ra*$a)+ea(0.0));ra=ea(ea(sa*Xa)+ea(0.0));sa=ea(ea(ta*bb)+ea(0.0));ta=ea(ea(ua*cb)+ea(0.0));ua=ea(ea(P*Hb)+ea(ea(Q*Ya)+ea(ea(R*$a)+ea(0.0))));ja=ea(ea(P*Qa)+ea(ea(Q*Ua)+ea(ea(R*Xa)+ea(0.0))));ab=ea(ea(P*Za)+ea(ea(Q*Wa)+ea(ea(R*bb)+ea(0.0))));ia=ea(ea(P*Va)+ea(ea(Q*Ta)+ea(ea(R*cb)+ea(0.0))));_a=ea(ea(S*Hb)+ea(ea(T*Ya)+ea(ea(U*$a)+ea(0.0))));ha=ea(ea(S*Qa)+ea(ea(T*Ua)+ea(ea(U*Xa)+ea(0.0))));Sa=ea(ea(S*Za)+ea(ea(T*Wa)+ea(ea(U*bb)+ea(0.0))));ga=ea(ea(S*Va)+ea(ea(T*Ta)+ea(ea(U*cb)+ea(0.0))));Ha=ea(ea(V*Hb)+ea(ea(W*Ya)+ea(ea(X*$a)+ea(0.0))));fa=ea(ea(V*Qa)+ea(ea(W*Ua)+ea(ea(X*Xa)+ea(0.0))));Ma=ea(ea(V*Za)+ea(ea(W*Wa)+ea(ea(X*bb)+ea(0.0))));da=ea(ea(V*Va)+ea(ea(W*Ta)+ea(ea(X*cb)+ea(0.0))));Ja=ea(ea(ea(eb*Hb)+ea(ea(ib*Ya)+ea(ea(mb*$a)+ea(0.0))))-ea(ea(p*Hb)+ea(ea(q*Ya)+ea(ea(r*$a)+ea(0.0)))));$a=ea(ea(ea(fb*Qa)+ea(ea(jb*Ua)+ea(ea(nb*Xa)+ea(0.0))))-ea(ea(p*Qa)+ea(ea(q*Ua)+ea(ea(r*Xa)+ea(0.0)))));Xa=ea(ea(ea(gb*Za)+ea(ea(kb*Wa)+ea(ea(ob*bb)+ea(0.0))))-ea(ea(p*Za)+ea(ea(q*Wa)+ea(ea(r*bb)+ea(0.0)))));bb=ea(ea(ea(hb*Va)+ea(ea(lb*Ta)+ea(ea(pb*cb)+ea(0.0))))-ea(ea(p*Va)+ea(ea(q*Ta)+ea(ea(r*cb)+ea(0.0)))));Vb=(g[k>>2]=Ja,c[k>>2]|0);_b=(g[k>>2]=$a,c[k>>2]|0);Zb=(g[k>>2]=Xa,c[k>>2]|0);Wb=(g[k>>2]=bb,c[k>>2]|0)&2147483647;ac=(g[k>>2]=db,c[k>>2]|0);bc=(g[k>>2]=qb,c[k>>2]|0);cc=(g[k>>2]=rb,c[k>>2]|0);dc=(g[k>>2]=sb,c[k>>2]|0)&2147483647;ec=(g[k>>2]=tb,c[k>>2]|0);fc=(g[k>>2]=ub,c[k>>2]|0);gc=(g[k>>2]=oa,c[k>>2]|0);hc=(g[k>>2]=pa,c[k>>2]|0)&2147483647;pa=(c[k>>2]=ac&2147483647,ea(g[k>>2]));oa=ea(pa+(c[k>>2]=ec&2147483647,ea(g[k>>2])));pa=(c[k>>2]=bc&2147483647,ea(g[k>>2]));ub=ea(pa+(c[k>>2]=fc&2147483647,ea(g[k>>2])));pa=(c[k>>2]=cc&2147483647,ea(g[k>>2]));tb=ea(pa+(c[k>>2]=gc&2147483647,ea(g[k>>2])));pa=(c[k>>2]=dc,ea(g[k>>2]));sb=ea(pa+(c[k>>2]=hc,ea(g[k>>2])));hc=(g[k>>2]=qa,c[k>>2]|0);dc=(g[k>>2]=ra,c[k>>2]|0);gc=(g[k>>2]=sa,c[k>>2]|0);cc=(g[k>>2]=ta,c[k>>2]|0)&2147483647;ta=ea((c[k>>2]=hc&2147483647,ea(g[k>>2]))+oa);oa=ea((c[k>>2]=dc&2147483647,ea(g[k>>2]))+ub);ub=ea((c[k>>2]=gc&2147483647,ea(g[k>>2]))+tb);tb=ea((c[k>>2]=cc,ea(g[k>>2]))+sb);cc=(g[k>>2]=ua,c[k>>2]|0);gc=(g[k>>2]=ja,c[k>>2]|0);dc=(g[k>>2]=ab,c[k>>2]|0);hc=(g[k>>2]=ia,c[k>>2]|0)&2147483647;fc=(g[k>>2]=_a,c[k>>2]|0);bc=(g[k>>2]=ha,c[k>>2]|0);ec=(g[k>>2]=Sa,c[k>>2]|0);ac=(g[k>>2]=ga,c[k>>2]|0)&2147483647;ga=(c[k>>2]=cc&2147483647,ea(g[k>>2]));Sa=ea(ga+(c[k>>2]=fc&2147483647,ea(g[k>>2])));ga=(c[k>>2]=gc&2147483647,ea(g[k>>2]));ha=ea(ga+(c[k>>2]=bc&2147483647,ea(g[k>>2])));ga=(c[k>>2]=dc&2147483647,ea(g[k>>2]));_a=ea(ga+(c[k>>2]=ec&2147483647,ea(g[k>>2])));ga=(c[k>>2]=hc,ea(g[k>>2]));ia=ea(ga+(c[k>>2]=ac,ea(g[k>>2])));ac=(g[k>>2]=Ha,c[k>>2]|0);hc=(g[k>>2]=fa,c[k>>2]|0);ec=(g[k>>2]=Ma,c[k>>2]|0);dc=(g[k>>2]=da,c[k>>2]|0)&2147483647;da=ea((c[k>>2]=ac&2147483647,ea(g[k>>2]))+Sa);Sa=ea((c[k>>2]=hc&2147483647,ea(g[k>>2]))+ha);ha=ea((c[k>>2]=ec&2147483647,ea(g[k>>2]))+_a);_a=ea((c[k>>2]=dc,ea(g[k>>2]))+ia);ia=(c[k>>2]=Vb&2147483647,ea(g[k>>2]));Ma=ea(ia+ea(-9.99999997e-07));fa=(c[k>>2]=_b&2147483647,ea(g[k>>2]));Ha=ea(fa+ea(-9.99999997e-07));ga=(c[k>>2]=Zb&2147483647,ea(g[k>>2]));ab=ea(ga+ea(-9.99999997e-07));ja=(c[k>>2]=Wb,ea(g[k>>2]));Wb=(Z>ka|(ia>ea(9.99999997e-07)&Ma>ea(ta+da)|Xb&Tb))&1^1;Tb=(_>la|(fa>ea(9.99999997e-07)&Ha>ea(oa+Sa)|Yb&E))&1^1;E=($>ma|(ga>ea(9.99999997e-07)&ab>ea(ub+ha)|$b&H))&1^1;H=(aa>na|((ja>ea(9.99999997e-07)?ea(ja+ea(-9.99999997e-07))>ea(tb+_a):0)|Ub&l))&1^1;c[h>>2]=Wb;c[K>>2]=Tb;c[a>>2]=E;c[m>>2]=H;H=Wb;Wb=b;E=0;Tb=0;l=J;while(1){J=c[G+(Tb<<2)>>2]&-2;c[j>>2]=J;do if(H)if(c[o+(Tb<<2)+96>>2]&1)if(xo[c[c[f>>2]>>2]&2047](f,1,j)|0){ic=Wb;jc=E;kc=l;break}else{L=23;break a}else{c[l>>2]=J;ic=c[j>>2]|0;jc=1;kc=l+4|0;break}else{ic=Wb;jc=E;kc=l}while(0);J=Tb+1|0;if(J>>>0>=4)break;H=c[h+(J<<2)>>2]|0;Wb=ic;E=jc;Tb=J;l=kc}if(kc>>>0>d>>>0){b=ic;I=jc;F=kc}else{L=23;break}}if((L|0)==23){i=e;return}}function QQa(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=0,M=Im,N=0,O=Im,P=Im,Q=Im,R=0,U=Im,V=Im,W=0,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im;n=i;i=i+320|0;o=n;p=n+120|0;q=n+248|0;r=n+12|0;s=n+260|0;t=n+272|0;u=n+72|0;v=n+176|0;w=n+148|0;x=n+24|0;y=c[d+36>>2]|0;z=a[d+32>>0]&2;A=b[l>>1]&128;B=z<<24>>24!=0|A<<16>>16!=0;c[o>>2]=c[y+32>>2];c[o+4>>2]=y+48;g[o+8>>2]=ea(g[y+36>>2]);C=ea(ea(g[f+24>>2])+m);m=ea(g[f>>2]);g[p>>2]=m;D=ea(g[f+4>>2]);g[p+4>>2]=D;E=ea(g[f+8>>2]);g[p+8>>2]=E;F=ea(g[f+12>>2]);g[p+12>>2]=F;G=ea(g[f+16>>2]);g[p+16>>2]=G;H=ea(g[f+20>>2]);g[p+20>>2]=H;f=p+24|0;g[f>>2]=C;y=e+16|0;C=ea(g[y>>2]);I=ea(m-C);J=e+20|0;m=ea(g[J>>2]);K=ea(D-m);L=e+24|0;D=ea(g[L>>2]);M=ea(I*ea(2.0));I=ea(K*ea(2.0));K=ea(ea(E-D)*ea(2.0));N=e+12|0;E=ea(g[N>>2]);O=ea(ea(E*E)+ea(-.5));P=ea(g[e>>2]);Q=ea(M*P);R=e+4|0;U=ea(g[R>>2]);V=ea(Q+ea(I*U));W=e+8|0;Q=ea(g[W>>2]);X=ea(V+ea(K*Q));V=ea(ea(P*X)+ea(ea(M*O)-ea(E*ea(ea(K*U)-ea(I*Q)))));Y=ea(ea(U*X)+ea(ea(I*O)-ea(E*ea(ea(M*Q)-ea(K*P)))));Z=ea(ea(ea(K*O)-ea(E*ea(ea(I*P)-ea(M*U))))+ea(Q*X));X=ea(ea(F-C)*ea(2.0));C=ea(ea(G-m)*ea(2.0));m=ea(ea(H-D)*ea(2.0));D=ea(ea(ea(P*X)+ea(U*C))+ea(Q*m));H=ea(ea(P*D)+ea(ea(O*X)-ea(E*ea(ea(U*m)-ea(Q*C)))));G=ea(ea(U*D)+ea(ea(O*C)-ea(E*ea(ea(Q*X)-ea(P*m)))));F=ea(ea(ea(O*m)-ea(E*ea(ea(P*C)-ea(U*X))))+ea(Q*D));D=ea(ea(Y+G)*ea(.5));X=ea(ea(Z+F)*ea(.5));g[q>>2]=ea(ea(V+H)*ea(.5));_=q+4|0;g[_>>2]=D;$=q+8|0;g[$>>2]=X;X=ea(ea(g[h>>2])*ea(2.0));D=ea(ea(g[h+4>>2])*ea(2.0));C=ea(ea(g[h+8>>2])*ea(2.0));m=ea(ea(ea(X*P)+ea(D*U))+ea(C*Q));M=ea(ea(U*m)+ea(ea(D*O)-ea(E*ea(ea(X*Q)-ea(C*P)))));I=ea(ea(ea(C*O)-ea(E*ea(ea(D*P)-ea(X*U))))+ea(Q*m));g[r>>2]=ea(ea(P*m)+ea(ea(X*O)-ea(E*ea(ea(C*U)-ea(D*Q)))));aa=r+4|0;g[aa>>2]=M;ba=r+8|0;g[ba>>2]=I;I=ea(g[f>>2]);M=ea(I+ea(ea(S(ea(Y-G)))*ea(.5)));G=ea(I+ea(ea(S(ea(Z-F)))*ea(.5)));g[s>>2]=ea(I+ea(ea(S(ea(V-H)))*ea(.5)));f=s+4|0;g[f>>2]=M;ca=s+8|0;g[ca>>2]=G;da=d+4|0;fa=d+8|0;if((ea(g[da>>2])==ea(1.0)?ea(g[fa>>2])==ea(1.0):0)?ea(g[d+12>>2])==ea(1.0):0){G=ea(g[e>>2]);M=ea(G+G);H=ea(g[R>>2]);V=ea(H+H);I=ea(g[W>>2]);F=ea(I+I);Z=ea(g[N>>2]);Y=ea(M*Z);Q=ea(V*Z);D=ea(Z*F);Z=ea(G*V);U=ea(G*F);C=ea(H*V);V=ea(H*F);H=ea(I*F);F=ea(ea(ea(1.0)-C)-H);I=ea(Z+D);E=ea(U-Q);O=ea(Z-D);D=ea(ea(1.0)-ea(G*M));M=ea(D-H);H=ea(V+Y);G=ea(U+Q);Q=ea(V-Y);Y=ea(D-C);C=ea(g[y>>2]);D=ea(g[J>>2]);V=ea(g[L>>2]);g[t>>2]=F;g[t+4>>2]=I;g[t+8>>2]=E;g[t+12>>2]=O;g[t+16>>2]=M;g[t+20>>2]=H;g[t+24>>2]=G;g[t+28>>2]=Q;g[t+32>>2]=Y;g[t+36>>2]=C;g[t+40>>2]=D;g[t+44>>2]=V;ga=j;ha=x+4|0;c[ha>>2]=2;c[x>>2]=542872;ia=x+8|0;c[ia>>2]=k;ja=x+12|0;c[ja>>2]=t;ka=x+16|0;g[ka>>2]=j;la=x+20|0;g[la>>2]=j;ma=x+24|0;na=(z&255)>>>1;oa=(A&65535)>>>7;pa=oa&255;qa=na|pa;a[ma>>0]=qa;ra=x+28|0;c[ra>>2]=p;sa=x+32|0;c[sa>>2]=h;ta=x+36|0;c[ta>>2]=l;ua=x+40|0;a[ua>>0]=0;va=x+41|0;a[va>>0]=0;wa=k+40|0;g[wa>>2]=ea(3402823469999999843913219.0e14);yQa(q,r,ga,1,o,x,s);xa=L7a(x,k,p,d,e,B,j)|0;i=n;return xa|0}i_a(u,e,da);g[t>>2]=ea(g[u>>2]);g[t+4>>2]=ea(g[u+4>>2]);g[t+8>>2]=ea(g[u+8>>2]);g[t+12>>2]=ea(g[u+12>>2]);g[t+16>>2]=ea(g[u+16>>2]);g[t+20>>2]=ea(g[u+20>>2]);g[t+24>>2]=ea(g[u+24>>2]);g[t+28>>2]=ea(g[u+28>>2]);g[t+32>>2]=ea(g[u+32>>2]);g[t+36>>2]=ea(g[u+36>>2]);g[t+40>>2]=ea(g[u+40>>2]);g[t+44>>2]=ea(g[u+44>>2]);V=ea(ea(1.0)/ea(g[da>>2]));D=ea(ea(1.0)/ea(g[fa>>2]));C=ea(ea(1.0)/ea(g[d+12>>2]));g[w>>2]=V;g[w+4>>2]=D;g[w+8>>2]=C;g[w+12>>2]=ea(g[d+16>>2]);g[w+16>>2]=ea(g[d+20>>2]);g[w+20>>2]=ea(g[d+24>>2]);g[w+24>>2]=ea(g[d+28>>2]);J0a(v,w,w+12|0);C=ea(g[q>>2]);D=ea(g[s>>2]);V=ea(C-D);Y=ea(g[_>>2]);Q=ea(g[f>>2]);G=ea(Y-Q);H=ea(g[$>>2]);M=ea(g[ca>>2]);O=ea(H-M);E=ea(C+D);I=ea(Y+Q);F=ea(H+M);U=ea(ea(V+E)*ea(.5));Z=ea(ea(G+I)*ea(.5));X=ea(ea(O+F)*ea(.5));m=ea(g[v>>2]);P=ea(U*m);K=ea(g[v+4>>2]);ya=ea(U*K);za=ea(g[v+8>>2]);Aa=ea(U*za);U=ea(g[v+12>>2]);Ba=ea(Z*U);Ca=ea(g[v+16>>2]);Da=ea(Z*Ca);Ea=ea(g[v+20>>2]);Fa=ea(P+Ba);Ba=ea(ya+Da);Da=ea(Aa+ea(Z*Ea));Z=ea(g[v+24>>2]);Aa=ea(X*Z);ya=ea(g[v+28>>2]);P=ea(X*ya);Ga=ea(g[v+32>>2]);Ha=ea(Fa+Aa);Aa=ea(Ba+P);P=ea(Da+ea(X*Ga));X=ea(ea(E-V)*ea(.5));V=ea(ea(I-G)*ea(.5));G=ea(ea(F-O)*ea(.5));O=ea(ea(ea(S(ea(X*m)))+ea(S(ea(V*U))))+ea(S(ea(G*Z))));F=ea(ea(ea(S(ea(X*K)))+ea(S(ea(V*Ca))))+ea(S(ea(G*ya))));I=ea(ea(ea(S(ea(X*za)))+ea(S(ea(V*Ea))))+ea(S(ea(G*Ga))));G=ea(Ha-O);V=ea(Aa-F);X=ea(P-I);E=ea(Ha+O);O=ea(Aa+F);F=ea(P+I);I=ea(ea(g[r>>2])*j);P=ea(ea(g[aa>>2])*j);Aa=ea(C+I);I=ea(Y+P);P=ea(H+ea(ea(g[ba>>2])*j));H=ea(Aa-D);Y=ea(I-Q);C=ea(P-M);Ha=ea(D+Aa);Aa=ea(Q+I);I=ea(M+P);P=ea(ea(H+Ha)*ea(.5));M=ea(ea(Y+Aa)*ea(.5));Q=ea(ea(C+I)*ea(.5));D=ea(ea(ea(m*P)+ea(U*M))+ea(Z*Q));Da=ea(ea(ea(K*P)+ea(Ca*M))+ea(ya*Q));Ba=ea(ea(ea(za*P)+ea(Ea*M))+ea(Ga*Q));Q=ea(ea(Ha-H)*ea(.5));H=ea(ea(Aa-Y)*ea(.5));Y=ea(ea(I-C)*ea(.5));C=ea(ea(ea(S(ea(m*Q)))+ea(S(ea(U*H))))+ea(S(ea(Z*Y))));Z=ea(ea(ea(S(ea(K*Q)))+ea(S(ea(Ca*H))))+ea(S(ea(ya*Y))));ya=ea(ea(ea(S(ea(za*Q)))+ea(S(ea(Ea*H))))+ea(S(ea(Ga*Y))));Y=ea(D-C);Ga=ea(Da-Z);H=ea(Ba-ya);Ea=ea(C+D);D=ea(Da+Z);Z=ea(Ba+ya);ya=ea(ea(G+E)*ea(.5));Ba=ea(ea(V+O)*ea(.5));Da=ea(ea(X+F)*ea(.5));g[q>>2]=ya;g[_>>2]=Ba;g[$>>2]=Da;C=ea(ea(O-V)*ea(.5));V=ea(ea(F-X)*ea(.5));g[s>>2]=ea(ea(E-G)*ea(.5));g[f>>2]=C;g[ca>>2]=V;V=ea(ea(ea(Y+Ea)*ea(.5))-ya);ya=ea(ea(ea(Ga+D)*ea(.5))-Ba);Ba=ea(ea(ea(H+Z)*ea(.5))-Da);g[r>>2]=V;g[aa>>2]=ya;g[ba>>2]=Ba;Da=ea(T(ea(ea(Ba*Ba)+ea(ea(V*V)+ea(ya*ya)))));if(Da<ea(9.99999968e-21)){ga=ea(0.0);ha=x+4|0;c[ha>>2]=2;c[x>>2]=542872;ia=x+8|0;c[ia>>2]=k;ja=x+12|0;c[ja>>2]=t;ka=x+16|0;g[ka>>2]=j;la=x+20|0;g[la>>2]=j;ma=x+24|0;na=(z&255)>>>1;oa=(A&65535)>>>7;pa=oa&255;qa=na|pa;a[ma>>0]=qa;ra=x+28|0;c[ra>>2]=p;sa=x+32|0;c[sa>>2]=h;ta=x+36|0;c[ta>>2]=l;ua=x+40|0;a[ua>>0]=0;va=x+41|0;a[va>>0]=0;wa=k+40|0;g[wa>>2]=ea(3402823469999999843913219.0e14);yQa(q,r,ga,1,o,x,s);xa=L7a(x,k,p,d,e,B,j)|0;i=n;return xa|0}Z=ea(ea(1.0)/Da);g[r>>2]=ea(V*Z);g[aa>>2]=ea(ya*Z);g[ba>>2]=ea(Ba*Z);ga=Da;ha=x+4|0;c[ha>>2]=2;c[x>>2]=542872;ia=x+8|0;c[ia>>2]=k;ja=x+12|0;c[ja>>2]=t;ka=x+16|0;g[ka>>2]=j;la=x+20|0;g[la>>2]=j;ma=x+24|0;na=(z&255)>>>1;oa=(A&65535)>>>7;pa=oa&255;qa=na|pa;a[ma>>0]=qa;ra=x+28|0;c[ra>>2]=p;sa=x+32|0;c[sa>>2]=h;ta=x+36|0;c[ta>>2]=l;ua=x+40|0;a[ua>>0]=0;va=x+41|0;a[va>>0]=0;wa=k+40|0;g[wa>>2]=ea(3402823469999999843913219.0e14);yQa(q,r,ga,1,o,x,s);xa=L7a(x,k,p,d,e,B,j)|0;i=n;return xa|0}function RQa(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=0,bb=0,cb=0,db=0,eb=Im,fb=Im,gb=Im,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im;n=i;i=i+544|0;o=n+464|0;p=n+316|0;q=n+328|0;r=n+208|0;s=n+256|0;t=n+404|0;u=n+524|0;v=n+352|0;w=n+380|0;x=n+392|0;y=n;z=n+340|0;A=n+304|0;B=d+4|0;C=d+8|0;if((ea(g[B>>2])==ea(1.0)?ea(g[C>>2])==ea(1.0):0)?ea(g[d+12>>2])==ea(1.0):0){D=ea(g[e>>2]);E=ea(D+D);F=ea(g[e+4>>2]);G=ea(F+F);H=ea(g[e+8>>2]);I=ea(H+H);J=ea(g[e+12>>2]);K=ea(E*J);L=ea(G*J);M=ea(J*I);N=ea(D*G);O=ea(D*I);P=ea(F*G);G=ea(F*I);Q=ea(H*I);I=ea(ea(ea(1.0)-P)-Q);R=ea(N+M);U=ea(O-L);V=ea(N-M);M=ea(ea(1.0)-ea(D*E));E=ea(M-Q);Q=ea(G+K);N=ea(O+L);L=ea(G-K);K=ea(M-P);P=ea(g[e+16>>2]);M=ea(g[e+20>>2]);G=ea(g[e+24>>2]);O=ea(-D);W=ea(-F);X=ea(-H);Y=ea(O-D);D=ea(W-F);F=ea(X-H);H=ea(D*W);Z=ea(F*X);_=ea(Y*W);W=ea(Y*X);$=ea(Y*J);aa=ea(D*X);X=ea(D*J);D=ea(J*F);F=ea(ea(ea(1.0)-H)-Z);J=ea(_+D);ba=ea(W-X);ca=ea(_-D);D=ea(ea(1.0)-ea(Y*O));O=ea(D-Z);Z=ea(aa+$);Y=ea(W+X);X=ea(aa-$);$=ea(D-H);da=f+36|0;H=ea(ea(g[da>>2])-P);fa=f+40|0;D=ea(ea(g[fa>>2])-M);ga=f+44|0;aa=ea(ea(g[ga>>2])-G);W=ea(ea(ea(H*J)+ea(O*D))+ea(X*aa));_=ea(ea(ea(ba*H)+ea(Z*D))+ea($*aa));g[q>>2]=ea(ea(ea(H*F)+ea(ca*D))+ea(Y*aa));g[q+4>>2]=W;g[q+8>>2]=_;_=ea(g[h>>2]);W=ea(F*_);aa=ea(J*_);D=ea(ba*_);_=ea(g[h+4>>2]);H=ea(W+ea(ca*_));W=ea(aa+ea(O*_));aa=ea(D+ea(Z*_));_=ea(g[h+8>>2]);D=ea(ea(H+ea(Y*_))*j);H=ea(ea(W+ea(X*_))*j);W=ea(ea(aa+ea($*_))*j);_=ea(g[f>>2]);aa=ea(F*_);ha=ea(J*_);ia=ea(ba*_);ja=ea(g[f+4>>2]);ka=ea(aa+ea(ca*ja));aa=ea(ha+ea(O*ja));ha=ea(ia+ea(Z*ja));ia=ea(g[f+8>>2]);la=ea(ka+ea(Y*ia));ka=ea(aa+ea(X*ia));aa=ea(ha+ea($*ia));ha=ea(g[f+12>>2]);ma=ea(F*ha);na=ea(J*ha);oa=ea(ba*ha);pa=ea(g[f+16>>2]);qa=ea(ma+ea(ca*pa));ma=ea(na+ea(O*pa));na=ea(oa+ea(Z*pa));oa=ea(g[f+20>>2]);ra=ea(qa+ea(Y*oa));qa=ea(ma+ea(X*oa));ma=ea(na+ea($*oa));na=ea(g[f+24>>2]);sa=ea(F*na);F=ea(J*na);J=ea(ba*na);ba=ea(g[f+28>>2]);ta=ea(sa+ea(ca*ba));ca=ea(F+ea(O*ba));O=ea(J+ea(Z*ba));Z=ea(g[f+32>>2]);J=ea(ta+ea(Y*Z));Y=ea(ca+ea(X*Z));X=ea(O+ea($*Z));$=ea(S(ea(la)));la=ea(S(ea(ka)));ka=ea(S(ea(aa)));aa=ea(g[f+48>>2]);O=ea($*aa);$=ea(la*aa);la=ea(ka*aa);aa=ea(S(ea(ra)));ra=ea(S(ea(qa)));qa=ea(S(ea(ma)));ma=ea(g[f+52>>2]);ka=ea(O+ea(aa*ma));aa=ea($+ea(ra*ma));ra=ea(la+ea(qa*ma));ma=ea(S(ea(J)));J=ea(S(ea(Y)));Y=ea(S(ea(X)));X=ea(g[f+56>>2]);qa=ea(ka+ea(ma*X));ma=ea(aa+ea(J*X));J=ea(ra+ea(Y*X));g[p>>2]=qa;g[p+4>>2]=ma;g[p+8>>2]=J;X=ea(g[da>>2]);Y=ea(g[fa>>2]);ua=qa;va=ma;wa=J;xa=D;ya=H;za=W;Aa=X;Ba=Y;Ca=ea(g[ga>>2]);Da=_;Ea=ja;Fa=ia;Ga=ha;Ha=pa;Ia=oa;Ja=na;Ka=ba;La=Z;Ma=I;Na=R;Oa=U;Pa=V;Qa=E;Ra=Q;Sa=N;Ta=L;Ua=K;Va=P;Wa=M;Xa=G}else{i_a(r,e,B);G=ea(g[r>>2]);M=ea(g[r+4>>2]);P=ea(g[r+8>>2]);K=ea(g[r+12>>2]);L=ea(g[r+16>>2]);N=ea(g[r+20>>2]);Q=ea(g[r+24>>2]);E=ea(g[r+28>>2]);V=ea(g[r+32>>2]);U=ea(g[r+36>>2]);R=ea(g[r+40>>2]);I=ea(g[r+44>>2]);Z=ea(g[e>>2]);ba=ea(g[e+4>>2]);na=ea(g[e+8>>2]);oa=ea(g[e+12>>2]);pa=ea(Z+Z);ha=ea(ba+ba);ia=ea(na+na);ja=ea(ba*ha);_=ea(na*ia);Y=ea(pa*ba);ba=ea(pa*na);X=ea(pa*oa);W=ea(ha*na);na=ea(ha*oa);ha=ea(ia*oa);oa=ea(ea(ea(1.0)-ja)-_);ia=ea(Y+ha);H=ea(ba-na);D=ea(Y-ha);ha=ea(ea(1.0)-ea(Z*pa));pa=ea(ha-_);_=ea(W+X);Z=ea(ba+na);na=ea(W-X);X=ea(ha-ja);ja=ea(g[d+16>>2]);ha=ea(g[d+20>>2]);W=ea(g[d+24>>2]);ba=ea(g[d+28>>2]);Y=ea(ja+ja);J=ea(ha+ha);ma=ea(W+W);qa=ea(ha*J);ra=ea(W*ma);aa=ea(Y*ha);ha=ea(Y*W);ka=ea(Y*ba);la=ea(J*W);W=ea(J*ba);J=ea(ma*ba);ba=ea(ea(ea(1.0)-qa)-ra);ma=ea(aa+J);$=ea(ha-W);O=ea(aa-J);J=ea(ea(1.0)-ea(ja*Y));Y=ea(J-ra);ra=ea(la+ka);ja=ea(ha+W);W=ea(la-ka);ka=ea(J-qa);qa=ea(g[B>>2]);J=ea(qa*ba);la=ea(qa*O);ha=ea(qa*ja);qa=ea(g[C>>2]);aa=ea(ma*qa);ca=ea(Y*qa);ta=ea(W*qa);qa=ea(g[d+12>>2]);F=ea($*qa);sa=ea(ra*qa);Ya=ea(ka*qa);qa=ea(ea(ea(ba*J)+ea(ma*aa))+ea($*F));Za=ea(ea(ea(ba*la)+ea(ma*ca))+ea($*sa));_a=ea(ea(ea(ba*ha)+ea(ma*ta))+ea($*Ya));$=ea(ea(ea(O*J)+ea(Y*aa))+ea(ra*F));ma=ea(ea(ea(O*la)+ea(Y*ca))+ea(ra*sa));ba=ea(ea(ea(O*ha)+ea(Y*ta))+ea(ra*Ya));ra=ea(ea(ea(ja*J)+ea(W*aa))+ea(ka*F));F=ea(ea(ea(ja*la)+ea(W*ca))+ea(ka*sa));sa=ea(ea(ea(ja*ha)+ea(W*ta))+ea(ka*Ya));Ya=ea(ea(na*_a)+ea(ea(ia*qa)+ea(pa*Za)));ka=ea(ea(X*_a)+ea(ea(H*qa)+ea(_*Za)));ta=ea(ea(Z*ba)+ea(ea(oa*$)+ea(D*ma)));W=ea(ea(na*ba)+ea(ea(ia*$)+ea(pa*ma)));ha=ea(ea(X*ba)+ea(ea(H*$)+ea(_*ma)));ma=ea(ea(Z*sa)+ea(ea(oa*ra)+ea(D*F)));$=ea(ea(na*sa)+ea(ea(ia*ra)+ea(pa*F)));pa=ea(ea(X*sa)+ea(ea(H*ra)+ea(_*F)));g[s>>2]=ea(ea(Z*_a)+ea(ea(oa*qa)+ea(D*Za)));g[s+4>>2]=Ya;g[s+8>>2]=ka;g[s+12>>2]=ta;g[s+16>>2]=W;g[s+20>>2]=ha;g[s+24>>2]=ma;g[s+28>>2]=$;g[s+32>>2]=pa;F0a(o,s);pa=ea(-ea(g[e+16>>2]));$=ea(-ea(g[e+20>>2]));ma=ea(-ea(g[e+24>>2]));ha=ea(g[o>>2]);W=ea(ha*pa);ta=ea(g[o+4>>2]);ka=ea(ta*pa);Ya=ea(g[o+8>>2]);Za=ea(Ya*pa);pa=ea(g[o+12>>2]);D=ea(pa*$);qa=ea(g[o+16>>2]);oa=ea(qa*$);_a=ea(g[o+20>>2]);Z=ea(W+D);D=ea(ka+oa);oa=ea(Za+ea(_a*$));$=ea(g[o+24>>2]);Za=ea($*ma);ka=ea(g[o+28>>2]);W=ea(ka*ma);F=ea(g[o+32>>2]);_=ea(Z+Za);Za=ea(D+W);W=ea(oa+ea(F*ma));g[o>>2]=ha;C=o+4|0;g[C>>2]=ta;B=o+8|0;g[B>>2]=Ya;r=o+12|0;g[r>>2]=pa;ga=o+16|0;g[ga>>2]=qa;fa=o+20|0;g[fa>>2]=_a;da=o+24|0;g[da>>2]=$;$a=o+28|0;g[$a>>2]=ka;ab=o+32|0;g[ab>>2]=F;bb=o+36|0;g[bb>>2]=_;cb=o+40|0;g[cb>>2]=Za;db=o+44|0;g[db>>2]=W;J6a(t,o,f);W=ea(g[t>>2]);Za=ea(g[t+4>>2]);_=ea(g[t+8>>2]);F=ea(g[t+12>>2]);ka=ea(g[t+16>>2]);$=ea(g[t+20>>2]);_a=ea(g[t+24>>2]);qa=ea(g[t+28>>2]);pa=ea(g[t+32>>2]);Ya=ea(g[t+48>>2]);ta=ea(g[t+52>>2]);ha=ea(g[t+56>>2]);ma=ea(ea(ea(Ya*ea(S(ea(W))))+ea(ta*ea(S(ea(F)))))+ea(ha*ea(S(ea(_a)))));_a=ea(ea(ea(Ya*ea(S(ea(Za))))+ea(ta*ea(S(ea(ka)))))+ea(ha*ea(S(ea(qa)))));qa=ea(ea(ea(Ya*ea(S(ea(_))))+ea(ta*ea(S(ea($)))))+ea(ha*ea(S(ea(pa)))));g[p>>2]=ma;g[p+4>>2]=_a;g[p+8>>2]=qa;pa=ea(g[f+36>>2]);ha=ea(g[o>>2]);$=ea(pa*ha);ta=ea(g[C>>2]);_=ea(pa*ta);Ya=ea(g[B>>2]);ka=ea(pa*Ya);Za=ea(g[f+40>>2]);F=ea(g[r>>2]);W=ea(Za*F);oa=ea(g[ga>>2]);D=ea(Za*oa);Z=ea(g[fa>>2]);ra=ea($+W);W=ea(_+D);D=ea(ka+ea(Za*Z));ka=ea(g[f+44>>2]);_=ea(g[da>>2]);$=ea(ka*_);H=ea(g[$a>>2]);sa=ea(ka*H);X=ea(g[ab>>2]);ia=ea(ra+$);$=ea(W+sa);sa=ea(D+ea(ka*X));D=ea(ia+ea(g[bb>>2]));ia=ea($+ea(g[cb>>2]));$=ea(sa+ea(g[db>>2]));g[q>>2]=D;g[q+4>>2]=ia;g[q+8>>2]=$;$=ea(ea(g[h>>2])*j);ia=ea(ea(g[h+4>>2])*j);D=ea(ea(g[h+8>>2])*j);sa=ea(ea(ea($*ha)+ea(ia*F))+ea(D*_));_=ea(ea(ea($*ta)+ea(ia*oa))+ea(D*H));H=ea(ea(ea($*Ya)+ea(ia*Z))+ea(D*X));X=ea(g[f>>2]);D=ea(g[f+4>>2]);Z=ea(g[f+8>>2]);ia=ea(g[f+12>>2]);Ya=ea(g[f+16>>2]);$=ea(g[f+20>>2]);oa=ea(g[f+24>>2]);ta=ea(g[f+28>>2]);ua=ma;va=_a;wa=qa;xa=sa;ya=_;za=H;Aa=pa;Ba=Za;Ca=ka;Da=X;Ea=D;Fa=Z;Ga=ia;Ha=Ya;Ia=$;Ja=oa;Ka=ta;La=ea(g[f+32>>2]);Ma=G;Na=M;Oa=P;Pa=K;Qa=L;Ra=N;Sa=Q;Ta=E;Ua=V;Va=U;Wa=R;Xa=I}I=ea(va+m);va=ea(wa+m);g[p>>2]=ea(ea(ua+m)*ea(1.00999999));g[p+4>>2]=ea(I*ea(1.00999999));g[p+8>>2]=ea(va*ea(1.00999999));db=c[d+36>>2]|0;c[u>>2]=c[db+32>>2];c[u+4>>2]=db+48;g[u+8>>2]=ea(g[db+36>>2]);va=ea(T(ea(ea(za*za)+ea(ea(ya*ya)+ea(xa*xa)))));db=va>ea(9.99999974e-06);I=db?va:ea(9.99999974e-06);va=ea(-Aa);Aa=ea(-Ba);Ba=ea(-Ca);Ca=ea(ea(ea(Da*va)+ea(Ea*Aa))+ea(Fa*Ba));ua=ea(ea(ea(Ga*va)+ea(Ha*Aa))+ea(Ia*Ba));wa=ea(ea(ea(Ja*va)+ea(Ka*Aa))+ea(La*Ba));db=a[d+32>>0]&2;cb=b[l>>1]&128;bb=db<<24>>24!=0|cb<<16>>16!=0;Ba=ea(ea(ea(Ma*Ga)+ea(Na*Ha))+ea(Oa*Ia));Aa=ea(ea(ea(Ma*Ja)+ea(Na*Ka))+ea(Oa*La));va=ea(ea(ea(Pa*Da)+ea(Qa*Ea))+ea(Ra*Fa));R=ea(ea(ea(Pa*Ga)+ea(Qa*Ha))+ea(Ra*Ia));U=ea(ea(ea(Pa*Ja)+ea(Qa*Ka))+ea(Ra*La));Ra=ea(ea(ea(Sa*Da)+ea(Ta*Ea))+ea(Ua*Fa));Qa=ea(ea(ea(Sa*Ga)+ea(Ta*Ha))+ea(Ua*Ia));Pa=ea(ea(ea(Sa*Ja)+ea(Ta*Ka))+ea(Ua*La));Ua=ea(ea(ea(ea(Va*Da)+ea(Wa*Ea))+ea(Xa*Fa))+Ca);Ca=ea(ea(ea(ea(Va*Ga)+ea(Wa*Ha))+ea(Xa*Ia))+ua);ua=ea(ea(ea(ea(Va*Ja)+ea(Wa*Ka))+ea(Xa*La))+wa);g[s>>2]=ea(ea(ea(Ma*Da)+ea(Na*Ea))+ea(Oa*Fa));g[s+4>>2]=Ba;g[s+8>>2]=Aa;g[s+12>>2]=va;g[s+16>>2]=R;g[s+20>>2]=U;g[s+24>>2]=Ra;g[s+28>>2]=Qa;g[s+32>>2]=Pa;g[s+36>>2]=Ua;g[s+40>>2]=Ca;g[s+44>>2]=ua;UUa(o,f);ua=ea(g[o>>2]);g[v>>2]=ua;Ca=ea(g[o+4>>2]);g[v+4>>2]=Ca;Ua=ea(g[o+8>>2]);g[v+8>>2]=Ua;Pa=ea(g[o+12>>2]);g[v+12>>2]=Pa;Qa=ea(g[f+36>>2]);g[v+16>>2]=Qa;Ra=ea(g[f+40>>2]);g[v+20>>2]=Ra;U=ea(g[f+44>>2]);g[v+24>>2]=U;R=ea(g[h>>2]);va=ea(Da*R);Da=ea(Ga*R);Ga=ea(Ja*R);ab=h+4|0;R=ea(g[ab>>2]);Ja=ea(va+ea(Ea*R));Ea=ea(Da+ea(Ha*R));Ha=ea(Ga+ea(Ka*R));$a=h+8|0;R=ea(g[$a>>2]);Ka=ea(Ja+ea(Fa*R));Fa=ea(Ea+ea(Ia*R));Ia=ea(Ha+ea(La*R));g[w>>2]=Ka;da=w+4|0;g[da>>2]=Fa;fa=w+8|0;g[fa>>2]=Ia;R=ea(Ka*j);La=ea(Fa*j);Ha=ea(Ia*j);g[x>>2]=R;g[x+4>>2]=La;g[x+8>>2]=Ha;c[y+4>>2]=2;c[y>>2]=542848;c[y+8>>2]=s;s=y+12|0;g[s>>2]=j;a[y+48>>0]=(db&255)>>>1|(cb&65535)>>>7&255;c[y+52>>2]=f;c[y+60>>2]=x;c[y+64>>2]=w;c[y+68>>2]=h;c[y+72>>2]=l;x=y+76|0;a[x>>0]=0;a[y+77>>0]=0;g[y+80>>2]=m;g[y+160>>2]=Ka;g[y+164>>2]=Fa;g[y+168>>2]=Ia;g[y+172>>2]=ea(0.0);g[y+176>>2]=R;g[y+180>>2]=La;g[y+184>>2]=Ha;g[y+188>>2]=ea(0.0);g[y+32>>2]=j;cb=y+36|0;c[cb+0>>2]=c[o+0>>2];c[cb+4>>2]=c[o+4>>2];c[cb+8>>2]=c[o+8>>2];g[y+16>>2]=j;if(Ka!=ea(0.0))eb=ea(ea(1.0)/Ka);else eb=ea(0.0);if(Fa!=ea(0.0))fb=ea(ea(1.0)/Fa);else fb=ea(0.0);if(Ia!=ea(0.0))gb=ea(ea(1.0)/Ia);else gb=ea(0.0);g[y+196>>2]=eb;g[y+200>>2]=fb;g[y+204>>2]=gb;gb=ea(ea(1.0)/I);fb=ea(ya*gb);ya=ea(za*gb);g[z>>2]=ea(xa*gb);g[z+4>>2]=fb;g[z+8>>2]=ya;yQa(q,z,I,bb,u,y,p);p=b[x>>1]|0;I=ea(g[y+128>>2]);ya=ea(g[y+132>>2]);fb=ea(g[y+136>>2]);gb=ea(g[y+144>>2]);xa=ea(g[y+148>>2]);za=ea(g[y+152>>2]);x=c[y+192>>2]|0;if(!((p&255)<<24>>24)){hb=0;i=n;return hb|0}if((p&65535)>=256){do if(b[l>>1]&512){p=lNa(d,e,f,v,m,j,bb,k)|0;u=k+12|0;b[u>>1]=6;if(p){b[u>>1]=7;break}else{g[k+40>>2]=ea(0.0);eb=ea(-ea(g[h>>2]));Ia=ea(-ea(g[ab>>2]));Fa=ea(-ea(g[$a>>2]));g[k+28>>2]=eb;g[k+32>>2]=Ia;g[k+36>>2]=Fa;break}}else{b[k+12>>1]=6;g[k+40>>2]=ea(0.0);Fa=ea(-ea(g[h>>2]));Ia=ea(-ea(g[ab>>2]));eb=ea(-ea(g[$a>>2]));g[k+28>>2]=Fa;g[k+32>>2]=Ia;g[k+36>>2]=eb}while(0);c[k+8>>2]=x;hb=1;i=n;return hb|0}$a=k+8|0;c[$a>>2]=x;j=ea(g[s>>2]);g[k+40>>2]=j;b[k+12>>1]=7;if(!(b[l>>1]&256)){m=ea(ea(Pa*Pa)+ea(-.5));eb=ea(ea(ea(ua*gb)+ea(Ca*xa))+ea(Ua*za));Ia=ea(-ea(ea(ea(Ca*eb)+ea(ea(m*xa)+ea(Pa*ea(ea(Ua*gb)-ea(ua*za)))))*ea(2.0)));Fa=ea(-ea(ea(ea(ea(m*za)+ea(Pa*ea(ea(ua*xa)-ea(Ca*gb))))+ea(Ua*eb))*ea(2.0)));Ka=ea(ea(ea(ua*I)+ea(Ca*ya))+ea(Ua*fb));Ha=ea(Qa+ea(ea(ea(ua*Ka)+ea(ea(m*I)+ea(Pa*ea(ea(Ca*fb)-ea(Ua*ya)))))*ea(2.0)));La=ea(Ra+ea(ea(ea(Ca*Ka)+ea(ea(m*ya)+ea(Pa*ea(ea(Ua*I)-ea(ua*fb)))))*ea(2.0)));R=ea(U+ea(ea(ea(ea(m*fb)+ea(Pa*ea(ea(ua*ya)-ea(Ca*I))))+ea(Ua*Ka))*ea(2.0)));g[k+28>>2]=ea(-ea(ea(ea(ua*eb)+ea(ea(m*gb)+ea(Pa*ea(ea(Ca*za)-ea(Ua*xa)))))*ea(2.0)));g[k+32>>2]=Ia;g[k+36>>2]=Fa;g[k+16>>2]=Ha;g[k+20>>2]=La;g[k+24>>2]=R;c[$a>>2]=x;hb=1;i=n;return hb|0}R=ea(g[w>>2]);if(R!=ea(0.0))ib=ea(ea(1.0)/R);else ib=ea(0.0);La=ea(g[da>>2]);if(La!=ea(0.0))jb=ea(ea(1.0)/La);else jb=ea(0.0);Ha=ea(g[fa>>2]);if(Ha!=ea(0.0))kb=ea(ea(1.0)/Ha);else kb=ea(0.0);g[A>>2]=ib;g[A+4>>2]=jb;g[A+8>>2]=kb;kb=ea(j+ea(-.00999999977));j=ea(R*kb);R=ea(kb*La);La=ea(kb*Ha);g[o>>2]=ea(1.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(0.0);g[o+16>>2]=ea(1.0);g[o+20>>2]=ea(0.0);g[o+24>>2]=ea(0.0);g[o+28>>2]=ea(0.0);g[o+32>>2]=ea(1.0);g[o+36>>2]=j;g[o+40>>2]=R;g[o+44>>2]=La;g[o+48>>2]=ea(g[f+48>>2]);g[o+52>>2]=ea(g[f+52>>2]);g[o+56>>2]=ea(g[f+56>>2]);bPa(k,o,w,w,A,y+84|0);y=k+28|0;La=ea(g[y>>2]);R=ea(La*La);A=k+32|0;j=ea(g[A>>2]);Ha=ea(R+ea(j*j));o=k+36|0;R=ea(g[o>>2]);kb=ea(T(ea(Ha+ea(R*R))));if(kb>ea(0.0)){Ha=ea(ea(1.0)/kb);kb=ea(La*Ha);g[y>>2]=kb;jb=ea(j*Ha);g[A>>2]=jb;ib=ea(R*Ha);g[o>>2]=ib;lb=kb;mb=jb;nb=ib}else{lb=La;mb=j;nb=R}R=ea(lb*ea(g[w>>2]));j=ea(R+ea(mb*ea(g[da>>2])));if(ea(j+ea(nb*ea(g[fa>>2])))>ea(0.0)){j=ea(-lb);R=ea(-mb);La=ea(-nb);g[y>>2]=j;g[A>>2]=R;g[o>>2]=La;ob=j;pb=R;qb=La}else{ob=lb;pb=mb;qb=nb}nb=ea(ea(Pa*Pa)+ea(-.5));mb=ea(ea(ea(ua*ob)+ea(Ca*pb))+ea(Ua*qb));lb=ea(ea(ea(Ca*mb)+ea(ea(nb*pb)+ea(Pa*ea(ea(Ua*ob)-ea(ua*qb)))))*ea(2.0));La=ea(ea(ea(ea(nb*qb)+ea(Pa*ea(ea(ua*pb)-ea(Ca*ob))))+ea(Ua*mb))*ea(2.0));g[y>>2]=ea(ea(ea(ua*mb)+ea(ea(nb*ob)+ea(Pa*ea(ea(Ca*qb)-ea(Ua*pb)))))*ea(2.0));g[A>>2]=lb;g[o>>2]=La;o=k+16|0;La=ea(g[o>>2]);A=k+20|0;lb=ea(g[A>>2]);y=k+24|0;pb=ea(g[y>>2]);qb=ea(ea(ea(ua*La)+ea(Ca*lb))+ea(Ua*pb));ob=ea(Ra+ea(ea(ea(Ca*qb)+ea(ea(nb*lb)+ea(Pa*ea(ea(Ua*La)-ea(ua*pb)))))*ea(2.0)));Ra=ea(U+ea(ea(ea(ea(nb*pb)+ea(Pa*ea(ea(ua*lb)-ea(Ca*La))))+ea(Ua*qb))*ea(2.0)));g[o>>2]=ea(Qa+ea(ea(ea(ua*qb)+ea(ea(nb*La)+ea(Pa*ea(ea(Ca*pb)-ea(Ua*lb)))))*ea(2.0)));g[A>>2]=ob;g[y>>2]=Ra;hb=1;i=n;return hb|0}function SQa(d,e,f,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=Im,oa=Im,pa=Im;o=i;i=i+896|0;p=o+488|0;q=o+648|0;r=o+560|0;s=o+584|0;t=o+736|0;u=o+784|0;v=o+832|0;w=o+720|0;x=o;y=o+476|0;z=o+892|0;A=o+464|0;B=c[f+32>>2]|0;C=c[d+36>>2]|0;D=f+4|0;if(ea(g[D>>2])==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0)E=ea(g[f+12>>2])==ea(1.0);else E=0;F=d+4|0;if(ea(g[F>>2])==ea(1.0)?ea(g[d+8>>2])==ea(1.0):0)G=ea(g[d+12>>2])==ea(1.0);else G=0;g[p>>2]=ea(1.0);H=p+4|0;g[H>>2]=ea(0.0);I=p+8|0;g[I>>2]=ea(0.0);J=p+12|0;g[J>>2]=ea(0.0);K=p+16|0;g[K>>2]=ea(1.0);L=p+20|0;g[L>>2]=ea(0.0);M=p+24|0;g[M>>2]=ea(0.0);N=p+28|0;g[N>>2]=ea(0.0);O=p+32|0;g[O>>2]=ea(1.0);g[p+36>>2]=ea(1.0);g[p+40>>2]=ea(0.0);g[p+44>>2]=ea(0.0);g[p+48>>2]=ea(0.0);g[p+52>>2]=ea(1.0);g[p+56>>2]=ea(0.0);g[p+60>>2]=ea(0.0);g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(1.0);if(!E)J0a(p,D,f+16|0);g[q>>2]=ea(1.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(0.0);g[q+16>>2]=ea(1.0);g[q+20>>2]=ea(0.0);g[q+24>>2]=ea(0.0);g[q+28>>2]=ea(0.0);g[q+32>>2]=ea(1.0);g[q+36>>2]=ea(1.0);g[q+40>>2]=ea(0.0);g[q+44>>2]=ea(0.0);g[q+48>>2]=ea(0.0);g[q+52>>2]=ea(1.0);g[q+56>>2]=ea(0.0);g[q+60>>2]=ea(0.0);g[q+64>>2]=ea(0.0);g[q+68>>2]=ea(1.0);if(!G)J0a(q,F,d+16|0);F=B+16|0;P=ea(g[F>>2]);Q=ea(g[B+28>>2]);R=ea(P+Q);U=ea(g[B+20>>2]);V=ea(g[B+32>>2]);W=ea(U+V);X=ea(g[B+24>>2]);Y=ea(g[B+36>>2]);Z=ea(R*ea(.5));R=ea(W*ea(.5));W=ea(ea(X+Y)*ea(.5));_=ea(g[p>>2]);$=ea(Z*_);aa=ea(g[H>>2]);ba=ea(Z*aa);ca=ea(g[I>>2]);da=ea(Z*ca);Z=ea(g[J>>2]);fa=ea(R*Z);ga=ea(g[K>>2]);ha=ea(R*ga);ia=ea(g[L>>2]);ja=ea($+fa);fa=ea(ba+ha);ha=ea(da+ea(R*ia));R=ea(g[M>>2]);da=ea(W*R);ba=ea(g[N>>2]);$=ea(W*ba);ka=ea(g[O>>2]);la=ea(ja+da);da=ea(fa+$);$=ea(ha+ea(W*ka));W=ea(ea(Q-P)*ea(.5));P=ea(ea(V-U)*ea(.5));U=ea(ea(Y-X)*ea(.5));X=ea(ea(ea(S(ea(W*_)))+ea(S(ea(P*Z))))+ea(S(ea(U*R))));R=ea(ea(ea(S(ea(W*aa)))+ea(S(ea(P*ga))))+ea(S(ea(U*ba))));ba=ea(ea(ea(S(ea(W*ca)))+ea(S(ea(P*ia))))+ea(S(ea(U*ka))));ka=ea(da-R);U=ea($-ba);ia=ea(la+X);P=ea(da+R);R=ea($+ba);g[r>>2]=ea(la-X);g[r+4>>2]=ka;g[r+8>>2]=U;g[r+12>>2]=ia;g[r+16>>2]=P;g[r+20>>2]=R;R=ea(g[h>>2]);P=ea(R+R);ia=ea(g[h+4>>2]);U=ea(ia+ia);ka=ea(g[h+8>>2]);X=ea(ka+ka);la=ea(g[h+12>>2]);ba=ea(P*la);$=ea(U*la);da=ea(la*X);la=ea(R*P);P=ea(R*U);ca=ea(R*X);R=ea(ia*U);U=ea(ia*X);ia=ea(ka*X);g[t>>2]=ea(ea(ea(1.0)-R)-ia);g[t+4>>2]=ea(P+da);g[t+8>>2]=ea(ca-$);g[t+12>>2]=ea(P-da);da=ea(ea(1.0)-la);g[t+16>>2]=ea(da-ia);g[t+20>>2]=ea(U+ba);g[t+24>>2]=ea(ca+$);g[t+28>>2]=ea(U-ba);g[t+32>>2]=ea(da-R);g[t+36>>2]=ea(g[h+16>>2]);g[t+40>>2]=ea(g[h+20>>2]);g[t+44>>2]=ea(g[h+24>>2]);R=ea(g[e>>2]);da=ea(R+R);O=e+4|0;ba=ea(g[O>>2]);U=ea(ba+ba);N=e+8|0;$=ea(g[N>>2]);ca=ea($+$);M=e+12|0;ia=ea(g[M>>2]);la=ea(da*ia);P=ea(U*ia);X=ea(ia*ca);ia=ea(R*da);da=ea(R*U);ka=ea(R*ca);R=ea(ba*U);U=ea(ba*ca);ba=ea($*ca);g[u>>2]=ea(ea(ea(1.0)-R)-ba);g[u+4>>2]=ea(da+X);g[u+8>>2]=ea(ka-P);g[u+12>>2]=ea(da-X);X=ea(ea(1.0)-ia);g[u+16>>2]=ea(X-ba);g[u+20>>2]=ea(U+la);g[u+24>>2]=ea(ka+P);g[u+28>>2]=ea(U-la);g[u+32>>2]=ea(X-R);g[u+36>>2]=ea(g[e+16>>2]);g[u+40>>2]=ea(g[e+20>>2]);g[u+44>>2]=ea(g[e+24>>2]);zOa(s,r,ea(0.0),h,t,u,q,G);G=s+48|0;g[G>>2]=ea(ea(g[G>>2])+n);u=s+52|0;g[u>>2]=ea(ea(g[u>>2])+n);u=s+56|0;g[u>>2]=ea(ea(g[u>>2])+n);R=ea(ea(g[j>>2])*ea(2.0));u=j+4|0;X=ea(ea(g[u>>2])*ea(2.0));t=j+8|0;la=ea(ea(g[t>>2])*ea(2.0));U=ea(g[M>>2]);P=ea(ea(U*U)+ea(-.5));ka=ea(g[e>>2]);ba=ea(R*ka);ia=ea(g[O>>2]);da=ea(ba+ea(X*ia));ba=ea(g[N>>2]);ca=ea(da+ea(la*ba));da=ea(ea(ia*ca)+ea(ea(X*P)-ea(U*ea(ea(R*ba)-ea(la*ka)))));$=ea(ea(ea(la*P)-ea(U*ea(ea(X*ka)-ea(R*ia))))+ea(ba*ca));g[w>>2]=ea(ea(ka*ca)+ea(ea(R*P)-ea(U*ea(ea(la*ia)-ea(X*ba)))));g[w+4>>2]=da;g[w+8>>2]=$;wLa(v,G,s+36|0,s,w,k);w=b[m>>1]|0;m=w&65535;s=(a[d+32>>0]&2)!=0|(m&128|0)!=0;G=(m&512|0)==0;$=ea(-ea(g[j>>2]));da=ea(-ea(g[u>>2]));ba=ea(-ea(g[t>>2]));g[y>>2]=$;g[y+4>>2]=da;g[y+8>>2]=ba;b[z>>1]=w;M7a(x,F,D,q,h,e,y,k,z,s,n,(w&64)!=0);c[A>>2]=c[C+32>>2];c[A+4>>2]=C+48;g[A+8>>2]=ea(g[C+36>>2]);vQa(v,1,A,x,1);if(!(a[x+449>>0]|0)){ma=0;i=o;return ma|0}if(a[x+448>>0]|0){do if(!G){A=nNa(d,e,f,h,n,k,s,l)|0;v=l+12|0;b[v>>1]=6;if(A){b[v>>1]=7;break}else{g[l+40>>2]=ea(0.0);ba=ea(-ea(g[j>>2]));da=ea(-ea(g[u>>2]));$=ea(-ea(g[t>>2]));g[l+28>>2]=ba;g[l+32>>2]=da;g[l+36>>2]=$;break}}else{b[l+12>>1]=6;g[l+40>>2]=ea(0.0);$=ea(-ea(g[j>>2]));da=ea(-ea(g[u>>2]));ba=ea(-ea(g[t>>2]));g[l+28>>2]=$;g[l+32>>2]=da;g[l+36>>2]=ba}while(0);c[l+8>>2]=c[x+332>>2];ma=1;i=o;return ma|0}h=x+324|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];b[l+12>>1]=b[x+336>>1]|0;g[l+16>>2]=ea(g[x+340>>2]);g[l+20>>2]=ea(g[x+344>>2]);g[l+24>>2]=ea(g[x+348>>2]);k=ea(g[x+352>>2]);h=l+28|0;n=ea(g[x+356>>2]);f=l+32|0;ba=ea(g[x+360>>2]);e=l+36|0;g[l+40>>2]=ea(g[x+364>>2]);c[l+44>>2]=c[x+368>>2];da=ea(-k);$=ea(-n);X=ea(-ba);g[h>>2]=da;g[f>>2]=$;g[e>>2]=X;ia=ea(T(ea(ea(ba*ba)+ea(ea(k*k)+ea(n*n)))));if(ia>ea(0.0)){n=ea(ea(1.0)/ia);ia=ea(n*da);g[h>>2]=ia;k=ea(n*$);g[f>>2]=k;ba=ea(n*X);g[e>>2]=ba;na=ia;oa=k;pa=ba}else{na=da;oa=$;pa=X}if(!s){ma=1;i=o;return ma|0}X=ea(na*ea(g[j>>2]));$=ea(X+ea(oa*ea(g[u>>2])));if(!(ea($+ea(pa*ea(g[t>>2])))>ea(0.0))){ma=1;i=o;return ma|0}$=ea(-oa);oa=ea(-pa);g[h>>2]=ea(-na);g[f>>2]=$;g[e>>2]=oa;ma=1;i=o;return ma|0}function TQa(a,b){a=a|0;b=b|0;var c=0;c=i;fQa(a+16|0,b);i=c;return}function UQa(a){a=a|0;var d=0,e=0;d=i;b[a+4>>1]=3;b[a+6>>1]=3;c[a>>2]=543408;e=a+8|0;c[e>>2]=434952;c[a+12>>2]=1;c[a>>2]=542896;c[e>>2]=542976;cQa(a+16|0);g[a+144>>2]=ea(8507058669999999534545717.0e13);g[a+148>>2]=ea(8507058669999999534545717.0e13);g[a+152>>2]=ea(8507058669999999534545717.0e13);g[a+156>>2]=ea(-8507058669999999534545717.0e13);g[a+160>>2]=ea(-8507058669999999534545717.0e13);g[a+164>>2]=ea(-8507058669999999534545717.0e13);i=d;return}function VQa(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;c[a>>2]=542896;c[a+8>>2]=542976;d=a+16|0;eQa(d);dQa(d);VJa(b,a);i=b;return}function WQa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a+-8|0;c[d>>2]=542896;c[a>>2]=542976;e=a+8|0;eQa(e);dQa(e);VJa(b,d);i=b;return}function XQa(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=542896;c[a+8>>2]=542976;d=a+16|0;eQa(d);dQa(d);i=b;return}function YQa(a){a=a|0;var b=0,d=0;b=i;c[a+-8>>2]=542896;c[a>>2]=542976;d=a+8|0;eQa(d);dQa(d);i=b;return}function ZQa(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a+224|0;if(!(_La(c[e>>2]|0,a)|0)){dKa(bKa()|0,8,542992,98,543080,d);i=d;return}f=c[e>>2]|0;e=c[a>>2]|0;if(!(b[a+6>>1]&1))ko[c[e+12>>2]&4095](a);else ko[c[e+16>>2]&4095](a);nMa(f,a,3,1);i=d;return}function _Qa(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=a+-8|0;f=a+216|0;if(!(_La(c[f>>2]|0,e)|0)){dKa(bKa()|0,8,542992,98,543080,d);i=d;return}g=c[f>>2]|0;f=c[e>>2]|0;if(!(b[a+-2>>1]&1))ko[c[f+12>>2]&4095](e);else ko[c[f+16>>2]&4095](e);nMa(g,e,3,1);i=d;return}function $Qa(f,h){f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+16|0;k=j+8|0;l=j+15|0;m=j+14|0;n=j+12|0;o=j+4|0;p=f+16|0;eQa(p);if(!(aNa(77,69,83,72,k,l,h)|0)){q=0;i=j;return q|0}if((c[k>>2]|0)>>>0<10){dKa(bKa()|0,32,542992,115,543136,j);q=0;i=j;return q|0}r=SMa((a[l>>0]|0)!=0,h)|0;g[f+192>>2]=ea(TMa((a[l>>0]|0)!=0,h));s=hQa(p,SMa((a[l>>0]|0)!=0,h)|0)|0;t=iQa(p,SMa((a[l>>0]|0)!=0,h)|0,0)|0;xo[c[c[h>>2]>>2]&2047](h,s,(c[p>>2]|0)*12|0)|0;if((a[l>>0]|0)!=0?(c[p>>2]|0)!=0:0){u=0;do{v=s+(u*12|0)|0;w=a[v>>0]|0;x=v+3|0;a[v>>0]=a[x>>0]|0;a[x>>0]=w;w=v+1|0;x=a[w>>0]|0;y=v+2|0;a[w>>0]=a[y>>0]|0;a[y>>0]=x;x=s+(u*12|0)+4|0;y=a[x>>0]|0;w=x+3|0;a[x>>0]=a[w>>0]|0;a[w>>0]=y;y=x+1|0;w=a[y>>0]|0;v=x+2|0;a[y>>0]=a[v>>0]|0;a[v>>0]=w;w=s+(u*12|0)+8|0;v=a[w>>0]|0;y=w+3|0;a[w>>0]=a[y>>0]|0;a[y>>0]=v;v=w+1|0;y=a[v>>0]|0;x=w+2|0;a[v>>0]=a[x>>0]|0;a[x>>0]=y;u=u+1|0}while(u>>>0<(c[p>>2]|0)>>>0)}u=f+20|0;s=c[u>>2]|0;y=s*3|0;a:do if(!(r&4)){x=(a[f+172>>0]&2)!=0;if(!(r&8)){if(!x){xo[c[c[h>>2]>>2]&2047](h,t,s*12|0)|0;if((a[l>>0]|0)==0|(y|0)==0)break;else z=0;while(1){v=t+(z<<2)|0;w=a[v>>0]|0;A=v+3|0;a[v>>0]=a[A>>0]|0;a[A>>0]=w;w=v+1|0;A=a[w>>0]|0;B=v+2|0;a[w>>0]=a[B>>0]|0;a[B>>0]=A;z=z+1|0;if((z|0)==(y|0))break a}}if(!y)break;A=o+3|0;B=o+1|0;w=o+2|0;v=0;C=t;while(1){xo[c[c[h>>2]>>2]&2047](h,o,4)|0;if(a[l>>0]|0){D=c[o>>2]|0;a[o>>0]=D>>>24;a[A>>0]=D;a[B>>0]=D>>>16;a[w>>0]=(D&65535)>>>8}b[C>>1]=c[o>>2];v=v+1|0;if((v|0)==(y|0))break;else C=C+2|0}}else{if(x){xo[c[c[h>>2]>>2]&2047](h,t,s*6|0)|0;if((a[l>>0]|0)==0|(y|0)==0)break;else E=0;while(1){C=t+(E<<1)|0;v=a[C>>0]|0;w=C+1|0;a[C>>0]=a[w>>0]|0;a[w>>0]=v;E=E+1|0;if((E|0)==(y|0))break a}}if(!y)break;x=n+1|0;v=0;w=t;while(1){xo[c[c[h>>2]>>2]&2047](h,n,2)|0;if(a[l>>0]|0){C=b[n>>1]|0;a[n>>0]=(C&65535)>>>8;a[x>>0]=C}c[w>>2]=e[n>>1];v=v+1|0;if((v|0)==(y|0))break;else w=w+4|0}}}else{w=(y|0)==0;if(!(a[f+172>>0]&2)){if(w)break;v=0;x=t;while(1){xo[c[c[h>>2]>>2]&2047](h,m,1)|0;c[x>>2]=d[m>>0];v=v+1|0;if((v|0)==(y|0))break;else x=x+4|0}}else{if(w)break;x=0;v=t;while(1){xo[c[c[h>>2]>>2]&2047](h,m,1)|0;b[v>>1]=d[m>>0]|0;x=x+1|0;if((x|0)==(y|0))break;else v=v+2|0}}}while(0);if(((r&1|0)!=0?(y=jQa(p)|0,xo[c[c[h>>2]>>2]&2047](h,y,c[u>>2]<<1)|0,(a[l>>0]|0)!=0):0)?(c[u>>2]|0)!=0:0){m=0;do{t=y+(m<<1)|0;n=a[t>>0]|0;E=t+1|0;a[t>>0]=a[E>>0]|0;a[E>>0]=n;m=m+1|0}while(m>>>0<(c[u>>2]|0)>>>0)}if(r&2){m=kQa(p)|0;y=SMa((a[l>>0]|0)!=0,h)|0;fNa(y,c[u>>2]|0,m,h,(a[l>>0]|0)!=0)}if(((r&16|0)!=0?(r=lQa(p)|0,xo[c[c[h>>2]>>2]&2047](h,r,(c[u>>2]|0)*12|0)|0,(a[l>>0]|0)!=0):0)?((c[u>>2]|0)*3|0)!=0:0){m=0;do{y=r+(m<<2)|0;n=a[y>>0]|0;E=y+3|0;a[y>>0]=a[E>>0]|0;a[E>>0]=n;n=y+1|0;E=a[n>>0]|0;t=y+2|0;a[n>>0]=a[t>>0]|0;a[t>>0]=E;m=m+1|0}while(m>>>0<((c[u>>2]|0)*3|0)>>>0)}if(!(mQa(p,h,c[k>>2]|0)|0)){q=0;i=j;return q|0}g[f+36>>2]=ea(TMa((a[l>>0]|0)!=0,h));g[f+144>>2]=ea(TMa((a[l>>0]|0)!=0,h));g[f+148>>2]=ea(TMa((a[l>>0]|0)!=0,h));g[f+152>>2]=ea(TMa((a[l>>0]|0)!=0,h));g[f+156>>2]=ea(TMa((a[l>>0]|0)!=0,h));g[f+160>>2]=ea(TMa((a[l>>0]|0)!=0,h));g[f+164>>2]=ea(TMa((a[l>>0]|0)!=0,h));k=SMa((a[l>>0]|0)!=0,h)|0;if(!k){q=1;i=j;return q|0}l=mKa()|0;p=c[(c[l>>2]|0)+8>>2]|0;u=pKa()|0;m=mo[c[(c[u>>2]|0)+24>>2]&4095](u)|0;u=Bn[p&255](l,k,m?543296:544544,542992,262)|0;c[f+168>>2]=u;xo[c[c[h>>2]>>2]&2047](h,u,k)|0;q=1;i=j;return q|0}function aRa(a){a=a|0;var b=0;b=i;gQa(a+16|0);c[a+32>>2]=a+196;i=b;return}function bRa(a){a=a|0;var d=0,e=0;d=i;nMa(c[a+224>>2]|0,a,3,0);e=a+6|0;b[e>>1]=b[e>>1]&-3;e=a+8|0;if(gTa(a+12|0)|0){i=d;return}ko[c[(c[e>>2]|0)+8>>2]&4095](e);i=d;return}function cRa(a){a=a|0;return c[a+12>>2]|0}function dRa(b,f,h,j,k,l,m,n,o){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im;o=i;i=i+464|0;m=o+24|0;p=o+152|0;q=o+445|0;r=o+88|0;s=o+116|0;t=o+288|0;u=o+332|0;v=o+380|0;w=o+420|0;x=o+248|0;y=o+260|0;z=o+432|0;A=o;B=o+12|0;C=o+446|0;D=o+304|0;E=o+447|0;F=o+448|0;G=o+408|0;H=o+368|0;I=o+224|0;J=o+272|0;K=o+236|0;L=o+212|0;g[m>>2]=ea(1.0);M=m+4|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;g[m+20>>2]=ea(1.0);M=m+24|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;g[m+40>>2]=ea(1.0);M=m+44|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;g[m+60>>2]=ea(1.0);M=c[b+20>>2]|0;N=c[b+16>>2]|0;O=c[b+24>>2]|0;P=c[b+28>>2]|0;Q=(a[b+172>>0]&2)!=0;if(!((l&1073741824|0)==0&0==0)){R=ea(g[k+12>>2]);S=ea(g[k>>2]);U=ea(R+S);V=ea(g[k+16>>2]);W=ea(g[k+4>>2]);X=ea(V+W);Y=ea(g[k+20>>2]);Z=ea(g[k+8>>2]);_=ea(U*ea(.5));U=ea(X*ea(.5));X=ea(ea(Y+Z)*ea(.5));$=ea(ea(R-S)*ea(.5));S=ea(ea(V-W)*ea(.5));W=ea(ea(Y-Z)*ea(.5));g[p>>2]=ea(1.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[p+12>>2]=ea(0.0);g[p+16>>2]=ea(1.0);g[p+20>>2]=ea(0.0);g[p+24>>2]=ea(0.0);g[p+28>>2]=ea(0.0);g[p+32>>2]=ea(1.0);g[p+36>>2]=_;g[p+40>>2]=U;g[p+44>>2]=X;g[p+48>>2]=$;g[p+52>>2]=S;g[p+56>>2]=W;k=UJa(o+444|0,M*12|0,542992,370)|0;a[q>>0]=0;g[s>>2]=ea(g[h>>2]);g[s+4>>2]=ea(g[h+4>>2]);g[s+8>>2]=ea(g[h+8>>2]);g[s+12>>2]=ea(g[h+12>>2]);g[s+16>>2]=ea(g[h+16>>2]);g[s+20>>2]=ea(g[h+20>>2]);g[s+24>>2]=ea(g[h+24>>2]);g[s+28>>2]=ea(g[h+28>>2]);g[s+32>>2]=ea(g[h+32>>2]);g[r+16>>2]=ea(g[h+36>>2]);g[r+20>>2]=ea(g[h+40>>2]);g[r+24>>2]=ea(g[h+44>>2]);UUa(t,s);g[r>>2]=ea(g[t>>2]);g[r+4>>2]=ea(g[t+4>>2]);g[r+8>>2]=ea(g[t+8>>2]);g[r+12>>2]=ea(g[t+12>>2]);t=BQa(p,b+32|0,r,j,k,M*3|0,0,q)|0;if(!(n==ea(0.0)|(t|0)==0)){q=u+12|0;j=u+4|0;r=u+16|0;s=u+8|0;aa=u+20|0;ba=u+24|0;ca=u+28|0;da=u+32|0;fa=v+4|0;ga=v+8|0;ha=v+12|0;ia=v+16|0;ja=v+20|0;ka=v+24|0;la=0;do{N7a(c[k+(la<<2)>>2]|0,u,O,P,h,Q);W=ea(g[u>>2]);S=ea(g[q>>2]);$=ea(W+S);X=ea(g[j>>2]);U=ea(g[r>>2]);_=ea(X+U);Z=ea(g[s>>2]);Y=ea(g[aa>>2]);V=ea(Z+Y);R=ea(g[ba>>2]);ma=ea($+R);$=ea(g[ca>>2]);na=ea(_+$);_=ea(g[da>>2]);oa=ea(ma*ea(.333333343));ma=ea(na*ea(.333333343));na=ea(ea(V+_)*ea(.333333343));V=ea(W-S);S=ea(X-U);U=ea(Z-Y);Y=ea(W-R);R=ea(X-$);$=ea(Z-_);_=ea(ea(S*$)-ea(U*R));Z=ea(ea(U*Y)-ea(V*$));$=ea(ea(V*R)-ea(S*Y));Y=ea(ea($*$)+ea(ea(_*_)+ea(Z*Z)));if(Y>ea(0.0)){S=ea(ea(1.0)/ea(T(ea(Y))));pa=ea(_*S);qa=ea(Z*S);ra=ea($*S)}else{pa=ea(0.0);qa=ea(0.0);ra=ea(0.0)}sa=DKa(EKa(f,m)|0,-2004353024)|0;S=ea(pa*n);$=ea(qa*n);Z=ea(ra*n);g[v>>2]=oa;g[fa>>2]=ma;g[ga>>2]=na;_=ea(ma+$);ma=ea(na+Z);g[ha>>2]=ea(oa+S);g[ia>>2]=_;g[ja>>2]=ma;g[ka>>2]=ea(ea(T(ea(ea(Z*Z)+ea(ea($*$)+ea(S*S)))))*ea(.150000006));IKa(sa,v)|0;la=la+1|0}while((la|0)!=(t|0))}if(!((l&8192|0)==0&0==0)?(DKa(EKa(f,m)|0,-65281)|0,la=f+100|0,v=c[la>>2]|0,ka=c[v+20>>2]|0,c6a(v+16|0,ka+(t*3|0)|0),(t|0)!=0):0){v=u+4|0;ja=u+8|0;ia=u+12|0;ha=u+16|0;ga=u+20|0;fa=u+24|0;da=u+28|0;ca=u+32|0;ba=0;aa=(c[(c[la>>2]|0)+16>>2]|0)+(ka<<5)|0;while(1){N7a(c[k+(ba<<2)>>2]|0,u,O,P,h,Q);ra=ea(g[u>>2]);qa=ea(g[v>>2]);pa=ea(g[ja>>2]);S=ea(g[ia>>2]);$=ea(g[ha>>2]);Z=ea(g[ga>>2]);g[aa>>2]=ra;g[aa+4>>2]=qa;g[aa+8>>2]=pa;c[aa+12>>2]=-65281;g[aa+16>>2]=S;g[aa+20>>2]=$;g[aa+24>>2]=Z;c[aa+28>>2]=-65281;Z=ea(g[ia>>2]);$=ea(g[ha>>2]);S=ea(g[ga>>2]);pa=ea(g[fa>>2]);qa=ea(g[da>>2]);ra=ea(g[ca>>2]);g[aa+32>>2]=Z;g[aa+36>>2]=$;g[aa+40>>2]=S;c[aa+44>>2]=-65281;g[aa+48>>2]=pa;g[aa+52>>2]=qa;g[aa+56>>2]=ra;c[aa+60>>2]=-65281;ra=ea(g[fa>>2]);qa=ea(g[da>>2]);pa=ea(g[ca>>2]);S=ea(g[u>>2]);$=ea(g[v>>2]);Z=ea(g[ja>>2]);g[aa+64>>2]=ra;g[aa+68>>2]=qa;g[aa+72>>2]=pa;c[aa+76>>2]=-65281;g[aa+80>>2]=S;g[aa+84>>2]=$;g[aa+88>>2]=Z;c[aa+92>>2]=-65281;ba=ba+1|0;if((ba|0)==(t|0))break;else aa=aa+96|0}}if(!((l&131072|0)==0&0==0)?(aa=b+168|0,!((c[aa>>2]|0)==0|(t|0)==0)):0){ba=A+4|0;ja=u+4|0;v=A+8|0;ca=u+8|0;da=u+24|0;fa=B+4|0;ga=u+28|0;ha=B+8|0;ia=u+32|0;ka=u+12|0;la=y+4|0;s=u+16|0;r=y+8|0;j=u+20|0;q=z+4|0;sa=z+8|0;ta=w+4|0;ua=w+8|0;va=x+4|0;wa=x+8|0;xa=0;do{ya=c[k+(xa<<2)>>2]|0;N7a(ya,u,O,P,h,Q);za=d[(c[aa>>2]|0)+ya>>0]|0;if(za&8){ya=CKa(DKa(EKa(f,m)|0,-256)|0,1)|0;g[w>>2]=ea(g[u>>2]);g[ta>>2]=ea(g[ja>>2]);g[ua>>2]=ea(g[ca>>2]);Aa=GKa(ya,w)|0;g[x>>2]=ea(g[ka>>2]);g[va>>2]=ea(g[s>>2]);g[wa>>2]=ea(g[j>>2]);GKa(Aa,x)|0}if(za&16){Aa=CKa(DKa(EKa(f,m)|0,-256)|0,1)|0;g[y>>2]=ea(g[ka>>2]);g[la>>2]=ea(g[s>>2]);g[r>>2]=ea(g[j>>2]);ya=GKa(Aa,y)|0;g[z>>2]=ea(g[da>>2]);g[q>>2]=ea(g[ga>>2]);g[sa>>2]=ea(g[ia>>2]);GKa(ya,z)|0}if(za&32){za=CKa(DKa(EKa(f,m)|0,-256)|0,1)|0;g[A>>2]=ea(g[u>>2]);g[ba>>2]=ea(g[ja>>2]);g[v>>2]=ea(g[ca>>2]);ya=GKa(za,A)|0;g[B>>2]=ea(g[da>>2]);g[fa>>2]=ea(g[ga>>2]);g[ha>>2]=ea(g[ia>>2]);GKa(ya,B)|0}xa=xa+1|0}while((xa|0)!=(t|0))}VJa(C,k);i=o;return}if(!(n==ea(0.0)|(M|0)==0)){k=p+12|0;C=p+4|0;t=p+16|0;xa=p+8|0;B=p+20|0;ia=p+24|0;ha=p+28|0;ga=p+32|0;fa=D+4|0;da=D+8|0;A=D+12|0;ca=D+16|0;v=D+20|0;ja=D+24|0;ba=0;do{N7a(ba,p,O,P,h,Q);Z=ea(g[p>>2]);$=ea(g[k>>2]);S=ea(Z+$);pa=ea(g[C>>2]);qa=ea(g[t>>2]);ra=ea(pa+qa);ma=ea(g[xa>>2]);_=ea(g[B>>2]);oa=ea(ma+_);na=ea(g[ia>>2]);Y=ea(S+na);S=ea(g[ha>>2]);R=ea(ra+S);ra=ea(g[ga>>2]);V=ea(Y*ea(.333333343));Y=ea(R*ea(.333333343));R=ea(ea(oa+ra)*ea(.333333343));oa=ea(Z-$);$=ea(pa-qa);qa=ea(ma-_);_=ea(Z-na);na=ea(pa-S);S=ea(ma-ra);ra=ea(ea($*S)-ea(qa*na));ma=ea(ea(qa*_)-ea(oa*S));S=ea(ea(oa*na)-ea($*_));_=ea(ea(S*S)+ea(ea(ra*ra)+ea(ma*ma)));if(_>ea(0.0)){$=ea(ea(1.0)/ea(T(ea(_))));Ba=ea(ra*$);Ca=ea(ma*$);Da=ea(S*$)}else{Ba=ea(0.0);Ca=ea(0.0);Da=ea(0.0)}u=DKa(EKa(f,m)|0,-2004353024)|0;$=ea(Ba*n);S=ea(Ca*n);ma=ea(Da*n);g[D>>2]=V;g[fa>>2]=Y;g[da>>2]=R;ra=ea(Y+S);Y=ea(R+ma);g[A>>2]=ea(V+$);g[ca>>2]=ra;g[v>>2]=Y;g[ja>>2]=ea(ea(T(ea(ea(ma*ma)+ea(ea(S*S)+ea($*$)))))*ea(.150000006));IKa(u,D)|0;ba=ba+1|0}while((ba|0)!=(M|0))}if(!((l&8192|0)==0&0==0)){DKa(EKa(f,m)|0,-65281)|0;ba=UJa(E,N*12|0,542992,475)|0;if(N){E=h+4|0;D=h+8|0;ja=h+12|0;v=h+16|0;ca=h+20|0;A=h+24|0;da=h+28|0;fa=h+32|0;ga=h+36|0;ha=h+40|0;ia=h+44|0;B=0;do{n=ea(g[O+(B*12|0)>>2]);Da=ea(n*ea(g[h>>2]));Ca=ea(n*ea(g[E>>2]));Ba=ea(n*ea(g[D>>2]));n=ea(g[O+(B*12|0)+4>>2]);$=ea(n*ea(g[ja>>2]));S=ea(n*ea(g[v>>2]));ma=ea(Da+$);$=ea(Ca+S);S=ea(Ba+ea(n*ea(g[ca>>2])));n=ea(g[O+(B*12|0)+8>>2]);Ba=ea(n*ea(g[A>>2]));Ca=ea(n*ea(g[da>>2]));Da=ea(ma+Ba);Ba=ea($+Ca);Ca=ea(S+ea(n*ea(g[fa>>2])));n=ea(Da+ea(g[ga>>2]));Da=ea(Ba+ea(g[ha>>2]));Ba=ea(Ca+ea(g[ia>>2]));g[ba+(B*12|0)>>2]=n;g[ba+(B*12|0)+4>>2]=Da;g[ba+(B*12|0)+8>>2]=Ba;B=B+1|0}while((B|0)!=(N|0))}N=f+100|0;B=c[N>>2]|0;ia=c[B+20>>2]|0;c6a(B+16|0,ia+(M*3|0)|0);B=(c[(c[N>>2]|0)+16>>2]|0)+(ia<<5)|0;if(M){ia=p+4|0;N=p+8|0;ha=p+12|0;ga=p+16|0;fa=p+20|0;da=p+24|0;A=p+28|0;ca=p+32|0;if(Q){v=0;ja=B;while(1){D=v*3|0;E=e[P+(D<<1)>>1]|0;xa=e[P+(D+1<<1)>>1]|0;t=e[P+(D+2<<1)>>1]|0;Ba=ea(g[ba+(E*12|0)>>2]);g[p>>2]=Ba;Da=ea(g[ba+(E*12|0)+4>>2]);g[ia>>2]=Da;n=ea(g[ba+(E*12|0)+8>>2]);g[N>>2]=n;Ca=ea(g[ba+(xa*12|0)>>2]);g[ha>>2]=Ca;S=ea(g[ba+(xa*12|0)+4>>2]);g[ga>>2]=S;$=ea(g[ba+(xa*12|0)+8>>2]);g[fa>>2]=$;g[da>>2]=ea(g[ba+(t*12|0)>>2]);g[A>>2]=ea(g[ba+(t*12|0)+4>>2]);g[ca>>2]=ea(g[ba+(t*12|0)+8>>2]);t=c[543248+(((((_n[c[(c[b>>2]|0)+48>>2]&4095](b,v)|0)&65535)%12|0)&65535)<<2)>>2]|0;g[ja>>2]=Ba;g[ja+4>>2]=Da;g[ja+8>>2]=n;c[ja+12>>2]=t;g[ja+16>>2]=Ca;g[ja+20>>2]=S;g[ja+24>>2]=$;c[ja+28>>2]=t;$=ea(g[ha>>2]);S=ea(g[ga>>2]);Ca=ea(g[fa>>2]);n=ea(g[da>>2]);Da=ea(g[A>>2]);Ba=ea(g[ca>>2]);g[ja+32>>2]=$;g[ja+36>>2]=S;g[ja+40>>2]=Ca;c[ja+44>>2]=t;g[ja+48>>2]=n;g[ja+52>>2]=Da;g[ja+56>>2]=Ba;c[ja+60>>2]=t;Ba=ea(g[da>>2]);Da=ea(g[A>>2]);n=ea(g[ca>>2]);Ca=ea(g[p>>2]);S=ea(g[ia>>2]);$=ea(g[N>>2]);g[ja+64>>2]=Ba;g[ja+68>>2]=Da;g[ja+72>>2]=n;c[ja+76>>2]=t;g[ja+80>>2]=Ca;g[ja+84>>2]=S;g[ja+88>>2]=$;c[ja+92>>2]=t;v=v+1|0;if((v|0)==(M|0))break;else ja=ja+96|0}}else{ja=0;v=B;while(1){B=ja*3|0;t=c[P+(B<<2)>>2]|0;xa=c[P+(B+1<<2)>>2]|0;E=c[P+(B+2<<2)>>2]|0;$=ea(g[ba+(t*12|0)>>2]);g[p>>2]=$;S=ea(g[ba+(t*12|0)+4>>2]);g[ia>>2]=S;Ca=ea(g[ba+(t*12|0)+8>>2]);g[N>>2]=Ca;n=ea(g[ba+(xa*12|0)>>2]);g[ha>>2]=n;Da=ea(g[ba+(xa*12|0)+4>>2]);g[ga>>2]=Da;Ba=ea(g[ba+(xa*12|0)+8>>2]);g[fa>>2]=Ba;g[da>>2]=ea(g[ba+(E*12|0)>>2]);g[A>>2]=ea(g[ba+(E*12|0)+4>>2]);g[ca>>2]=ea(g[ba+(E*12|0)+8>>2]);E=c[543248+(((((_n[c[(c[b>>2]|0)+48>>2]&4095](b,ja)|0)&65535)%12|0)&65535)<<2)>>2]|0;g[v>>2]=$;g[v+4>>2]=S;g[v+8>>2]=Ca;c[v+12>>2]=E;g[v+16>>2]=n;g[v+20>>2]=Da;g[v+24>>2]=Ba;c[v+28>>2]=E;Ba=ea(g[ha>>2]);Da=ea(g[ga>>2]);n=ea(g[fa>>2]);Ca=ea(g[da>>2]);S=ea(g[A>>2]);$=ea(g[ca>>2]);g[v+32>>2]=Ba;g[v+36>>2]=Da;g[v+40>>2]=n;c[v+44>>2]=E;g[v+48>>2]=Ca;g[v+52>>2]=S;g[v+56>>2]=$;c[v+60>>2]=E;$=ea(g[da>>2]);S=ea(g[A>>2]);Ca=ea(g[ca>>2]);n=ea(g[p>>2]);Da=ea(g[ia>>2]);Ba=ea(g[N>>2]);g[v+64>>2]=$;g[v+68>>2]=S;g[v+72>>2]=Ca;c[v+76>>2]=E;g[v+80>>2]=n;g[v+84>>2]=Da;g[v+88>>2]=Ba;c[v+92>>2]=E;ja=ja+1|0;if((ja|0)==(M|0))break;else v=v+96|0}}}VJa(F,ba)}if((l&131072|0)==0&0==0){i=o;return}l=b+168|0;if((c[l>>2]|0)==0|(M|0)==0){i=o;return}b=K+4|0;ba=p+4|0;F=K+8|0;v=p+8|0;ja=p+24|0;N=L+4|0;ia=p+28|0;ca=L+8|0;A=p+32|0;da=p+12|0;fa=I+4|0;ga=p+16|0;ha=I+8|0;E=p+20|0;xa=J+4|0;t=J+8|0;B=G+4|0;D=G+8|0;C=H+4|0;k=H+8|0;u=0;do{N7a(u,p,O,P,h,Q);z=d[(c[l>>2]|0)+u>>0]|0;if(z&8){sa=CKa(DKa(EKa(f,m)|0,-256)|0,1)|0;g[G>>2]=ea(g[p>>2]);g[B>>2]=ea(g[ba>>2]);g[D>>2]=ea(g[v>>2]);q=GKa(sa,G)|0;g[H>>2]=ea(g[da>>2]);g[C>>2]=ea(g[ga>>2]);g[k>>2]=ea(g[E>>2]);GKa(q,H)|0}if(z&16){q=CKa(DKa(EKa(f,m)|0,-256)|0,1)|0;g[I>>2]=ea(g[da>>2]);g[fa>>2]=ea(g[ga>>2]);g[ha>>2]=ea(g[E>>2]);sa=GKa(q,I)|0;g[J>>2]=ea(g[ja>>2]);g[xa>>2]=ea(g[ia>>2]);g[t>>2]=ea(g[A>>2]);GKa(sa,J)|0}if(z&32){z=CKa(DKa(EKa(f,m)|0,-256)|0,1)|0;g[K>>2]=ea(g[p>>2]);g[b>>2]=ea(g[ba>>2]);g[F>>2]=ea(g[v>>2]);sa=GKa(z,K)|0;g[L>>2]=ea(g[ja>>2]);g[N>>2]=ea(g[ia>>2]);g[ca>>2]=ea(g[A>>2]);GKa(sa,L)|0}u=u+1|0}while((u|0)!=(M|0));i=o;return}function eRa(a,d){a=a|0;d=d|0;var e=0;b[a+4>>1]=1;b[a+6>>1]=3;c[a>>2]=543888;e=a+8|0;c[e>>2]=434952;c[a+12>>2]=1;c[a>>2]=543480;c[e>>2]=543576;e=a+96|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[a+112>>2]=d;c[a+52>>2]=1;c[a+16>>2]=0;c[a+20>>2]=0;d=a+36|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b[d+12>>1]=0;return}function fRa(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[a>>2]=543480;c[a+8>>2]=543576;if(b[a+6>>1]&1){f=a+36|0;VJa(e,c[f>>2]|0);c[f>>2]=0}VJa(e,a);i=d;return}function gRa(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=a+-8|0;c[f>>2]=543480;c[f+8>>2]=543576;if(!(b[f+6>>1]&1)){VJa(e,f);i=d;return}a=f+36|0;VJa(e,c[a>>2]|0);c[a>>2]=0;VJa(e,f);i=d;return}function hRa(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;c[a>>2]=543480;c[a+8>>2]=543576;if(!(b[a+6>>1]&1)){i=d;return}e=a+36|0;VJa(d,c[e>>2]|0);c[e>>2]=0;i=d;return}function iRa(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=a+-8|0;c[e>>2]=543480;c[e+8>>2]=543576;if(!(b[e+6>>1]&1)){i=d;return}a=e+36|0;VJa(d,c[a>>2]|0);c[a>>2]=0;i=d;return}function jRa(a,d){a=a|0;d=d|0;var e=0;d=i;i=i+16|0;if(!(b[a+6>>1]&1)){i=d;return}e=a+36|0;VJa(d,c[e>>2]|0);c[e>>2]=0;i=d;return}function kRa(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a+112|0;if(!(jMa(c[e>>2]|0,a)|0)){dKa(bKa()|0,8,543592,96,543680,d);i=d;return}f=c[e>>2]|0;e=c[a>>2]|0;if(!(b[a+6>>1]&1))ko[c[e+12>>2]&4095](a);else ko[c[e+16>>2]&4095](a);nMa(f,a,1,1);i=d;return}function lRa(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a+-8|0;a=e+112|0;if(!(jMa(c[a>>2]|0,e)|0)){dKa(bKa()|0,8,543592,96,543680,d);i=d;return}f=c[a>>2]|0;a=c[e>>2]|0;if(!(b[e+6>>1]&1))ko[c[a+12>>2]&4095](e);else ko[c[a+16>>2]&4095](e);nMa(f,e,1,1);i=d;return}function mRa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=da(c[a+16>>2]<<2,c[a+20>>2]|0)|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,16);co[c[(c[b>>2]|0)+8>>2]&2047](b,c[a+36>>2]|0,e);i=d;return}function nRa(a){a=a|0;var d=0,e=0;d=i;nMa(c[a+112>>2]|0,a,1,0);e=a+6|0;b[e>>1]=b[e>>1]&-3;e=a+8|0;if(gTa(a+12|0)|0){i=d;return}ko[c[(c[e>>2]|0)+8>>2]&4095](e);i=d;return}function oRa(a){a=a|0;return c[a+12>>2]|0}function pRa(f,h,j,k,l){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=0,G=Im,H=Im,I=0,J=0,K=0,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=Im,S=Im,T=Im,U=0,V=0;m=i;n=mo[c[(c[f>>2]|0)+36>>2]&4095](f)|0;o=mo[c[(c[f>>2]|0)+32>>2]&4095](f)|0;p=f+104|0;q=ea(g[p>>2]);r=f+108|0;s=ea(g[r>>2]);t=(c[k>>2]|0)+j|0;u=(t|0)>0?t:0;t=k+4|0;v=(c[t>>2]|0)+h|0;w=(v|0)>0?v:0;v=(j|0)<0?0:j;a:do if(v>>>0<(u>>>0<o>>>0?u:o)>>>0){x=(h|0)<0?0:h;y=f+36|0;z=k+16|0;if(x>>>0>=(w>>>0<n>>>0?w:n)>>>0){A=~o;B=~u;C=~(A>>>0>B>>>0?A:B);B=v;while(1){B=B+1|0;if((B|0)==(C|0)){D=s;E=q;break a}}}C=~n;B=~w;A=~(C>>>0>B>>>0?C:B);B=~o;C=~u;F=~(B>>>0>C>>>0?B:C);G=s;H=q;C=v;while(1){B=da(C,n)|0;I=C-j|0;J=c[y>>2]|0;K=x;L=G;M=H;do{N=K+B|0;O=J+(N<<2)|0;P=K-h+(da(c[t>>2]|0,I)|0)|0;Q=(c[z>>2]|0)+(P<<2)|0;P=e[Q>>1]|e[Q+2>>1]<<16;b[O>>1]=P;b[O+2>>1]=P>>>16;P=qRa(f,N,C,K,127)|0;O=J+(N<<2)+3|0;Q=d[O>>0]|0;a[O>>0]=P?Q|128:Q&127;J=c[y>>2]|0;R=ea(b[J+(N<<2)>>1]|0);M=R<M?R:M;L=R>L?R:L;K=K+1|0}while((K|0)!=(A|0));C=C+1|0;if((C|0)==(F|0)){D=L;E=M;break}else{G=L;H=M}}}else{D=s;E=q}while(0);if(!l){S=D;T=E;g[p>>2]=T;g[r>>2]=S;U=f+60|0;g[U>>2]=T;V=f+72|0;g[V>>2]=S;i=m;return 1}l=da(o,n)|0;if(!l){S=ea(-3402823469999999843913219.0e14);T=ea(3402823469999999843913219.0e14);g[p>>2]=T;g[r>>2]=S;U=f+60|0;g[U>>2]=T;V=f+72|0;g[V>>2]=S;i=m;return 1}n=c[f+36>>2]|0;E=ea(-3402823469999999843913219.0e14);D=ea(3402823469999999843913219.0e14);o=0;while(1){q=ea(b[n+(o<<2)>>1]|0);s=q<D?q:D;H=q>E?q:E;o=o+1|0;if((o|0)==(l|0)){S=H;T=s;break}else{E=H;D=s}}g[p>>2]=T;g[r>>2]=S;U=f+60|0;g[U>>2]=T;V=f+72|0;g[V>>2]=S;i=m;return 1}function qRa(a,e,f,h,j){a=a|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im;k=i;i=i+224|0;l=k+96|0;m=k+64|0;n=k;if(b[a+48>>1]&1){if((f|0)==0|(h|0)==0){o=0;i=k;return o|0}if(((c[a+16>>2]|0)+-1|0)>>>0<=f>>>0){o=0;i=k;return o|0}if(((c[a+20>>2]|0)+-1|0)>>>0<=h>>>0){o=0;i=k;return o|0}}p=vRa(a,e,f,h,l)|0;q=(p|0)==0;if(q){o=0;i=k;return o|0}else{r=n;s=0}while(1){c[m+(s<<2)>>2]=wRa(a,l+(s<<4)|0,r)|0;s=s+1|0;if((s|0)==(p|0))break;else r=r+8|0}if(q){o=0;i=k;return o|0}q=c[a+36>>2]|0;r=n;n=0;s=0;a:while(1){l=c[r>>2]|0;t=l>>>1;if(!(l&1))u=q+(t<<2)+2|0;else u=q+(t<<2)+3|0;t=d[u>>0]&127;do if((c[m+(n<<2)>>2]|0)>>>0>1){l=c[r+4>>2]|0;v=l>>>1;if(!(l&1))w=q+(v<<2)+2|0;else w=q+(v<<2)+3|0;v=t<<16>>16==j<<16>>16;l=(d[w>>0]&127)<<16>>16==j<<16>>16;if(v)if(l|v^1){x=s|l^1;break}else{o=1;y=34;break a}else if(l){o=1;y=34;break a}else{x=1;break}}else if(t<<16>>16==j<<16>>16)x=s;else{o=1;y=34;break a}while(0);t=n+1|0;if(t>>>0>=p>>>0){y=22;break}r=r+8|0;n=t;s=x}if((y|0)==22){if(!x){o=0;i=k;return o|0}x=c[a+36>>2]|0;s=b[x+(e<<2)>>1]<<1;if((f|0)!=0?((c[a+16>>2]|0)+-1|0)>>>0>f>>>0:0){f=c[a+20>>2]|0;z=s-(b[x+(f+e<<2)>>1]|0)-(b[x+(e-f<<2)>>1]|0)|0;A=1}else{z=0;A=0}if((h|0)!=0?((c[a+20>>2]|0)+-1|0)>>>0>h>>>0:0)B=s-(b[x+(e+1<<2)>>1]|0)-(b[x+(e+-1<<2)>>1]|0)|0;else if(A)B=0;else{o=1;i=k;return o|0}if((B^z|0)>-1){o=0;i=k;return o|0}C=ea(B+z|0);z=!(ea(g[a+40>>2])<=ea(0.0));D=ea(g[a+44>>2]);if(z){o=C<ea(-D);i=k;return o|0}else{o=C>D;i=k;return o|0}}else if((y|0)==34){i=k;return o|0}return 0}function rRa(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;h=f;j=f+9|0;if(b[d+6>>1]&1){k=d+36|0;VJa(h,c[k>>2]|0);c[k>>2]=0}if(!(aNa(72,70,72,70,f+4|0,j,e)|0)){l=0;i=f;return l|0}k=d+16|0;c[k>>2]=SMa((a[j>>0]|0)!=0,e)|0;m=d+20|0;c[m>>2]=SMa((a[j>>0]|0)!=0,e)|0;g[d+24>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+28>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+32>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+40>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+44>>2]=ea(TMa((a[j>>0]|0)!=0,e));b[d+48>>1]=RMa((a[j>>0]|0)!=0,e)|0;c[d+52>>2]=SMa((a[j>>0]|0)!=0,e)|0;g[d+56>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+60>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+64>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+68>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+72>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+76>>2]=ea(TMa((a[j>>0]|0)!=0,e));c[d+80>>2]=SMa((a[j>>0]|0)!=0,e)|0;c[d+84>>2]=SMa((a[j>>0]|0)!=0,e)|0;c[d+88>>2]=SMa((a[j>>0]|0)!=0,e)|0;c[d+92>>2]=SMa((a[j>>0]|0)!=0,e)|0;c[d+96>>2]=SMa((a[j>>0]|0)!=0,e)|0;n=d+100|0;c[n>>2]=SMa((a[j>>0]|0)!=0,e)|0;g[d+104>>2]=ea(TMa((a[j>>0]|0)!=0,e));g[d+108>>2]=ea(TMa((a[j>>0]|0)!=0,e));o=d+36|0;c[o>>2]=0;d=da(c[m>>2]|0,c[k>>2]|0)|0;if(!d){l=1;i=f;return l|0}k=UJa(f+8|0,d<<2,543592,324)|0;c[o>>2]=k;if(!k){dKa(bKa()|0,16,543592,327,543744,h);l=0;i=f;return l|0}xo[c[c[e>>2]>>2]&2047](e,k,c[n>>2]<<2)|0;if(!(a[j>>0]|0)){l=1;i=f;return l|0}if(!(c[n>>2]|0)){l=1;i=f;return l|0}else p=0;do{j=(c[o>>2]|0)+(p<<2)|0;k=a[j>>0]|0;e=j+1|0;a[j>>0]=a[e>>0]|0;a[e>>0]=k;p=p+1|0}while(p>>>0<(c[n>>2]|0)>>>0);l=1;i=f;return l|0}function sRa(a,d,f){a=a|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im;f=i;i=i+16|0;h=f;j=a+36|0;if(b[a+6>>1]&1){VJa(h,c[j>>2]|0);c[j>>2]=0}c[a+52>>2]=c[d+8>>2];k=c[d>>2]|0;l=a+16|0;c[l>>2]=k;m=d+4|0;n=c[m>>2]|0;o=a+20|0;c[o>>2]=n;g[a+40>>2]=ea(g[d+20>>2]);g[a+44>>2]=ea(g[d+24>>2]);b[a+48>>1]=b[d+28>>1]|0;p=d+12|0;c[a+96>>2]=c[p>>2];g[a+24>>2]=ea((k+-2|0)>>>0);g[a+28>>2]=ea((n+-2|0)>>>0);n=c[m>>2]|0;g[a+32>>2]=ea(n>>>0);k=n+3|0;c[a+84>>2]=k&-4;n=(c[d>>2]|0)+3|0;c[a+80>>2]=n&-4;c[a+88>>2]=k>>>2;c[a+92>>2]=n>>>2;c[j>>2]=0;n=da(c[m>>2]|0,c[d>>2]|0)|0;m=a+104|0;g[m>>2]=ea(3402823469999999843913219.0e14);k=a+108|0;g[k>>2]=ea(-3402823469999999843913219.0e14);if(n){q=UJa(f+4|0,n<<2,543592,388)|0;c[j>>2]=q;if(!q){dKa(bKa()|0,16,543592,391,543744,h);r=0;i=f;return r|0}h=q;q=0;j=-32768;s=32767;t=c[d+16>>2]|0;while(1){d=e[t>>1]|e[t+2>>1]<<16;b[h>>1]=d;b[h+2>>1]=d>>>16;d=b[t>>1]|0;s=d<<16>>16<s<<16>>16?d:s;j=d<<16>>16>j<<16>>16?d:j;q=q+1|0;if((q|0)==(n|0))break;else{h=h+4|0;t=t+(c[p>>2]|0)|0}}u=ea(j<<16>>16);g[m>>2]=ea(s<<16>>16);g[k>>2]=u}tRa(a,127);s=c[l>>2]|0;l=c[o>>2]|0;c[a+100>>2]=da(l,s)|0;u=ea(g[m>>2]);v=ea(g[k>>2]);w=ea((s+-1|0)>>>0);x=ea((l+-1|0)>>>0);g[a+56>>2]=ea(0.0);g[a+60>>2]=u;g[a+64>>2]=ea(0.0);g[a+68>>2]=w;g[a+72>>2]=v;g[a+76>>2]=x;r=1;i=f;return r|0}function tRa(e,f){e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im;h=i;i=i+32|0;j=h;k=e+20|0;l=c[k>>2]|0;m=e+16|0;n=c[m>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;o=(l+32|0)>>>5;p=j+4|0;if(!o){q=0;r=0}else{c[p>>2]=o;s=UJa(j+8|0,o<<2,543784,362)|0;c[j>>2]=s;q=s;r=c[p>>2]<<2}PEi(q|0,0,r|0)|0;r=j+16|0;q=c[r>>2]|0;p=j+12|0;s=c[p>>2]|0;if(o>>>0>(q&2147483647)>>>0){t=j+20|0;if((s|0)!=0&(q|0)>-1)VJa(t,s);c[r>>2]=o;u=UJa(t,o<<2,543784,362)|0;c[p>>2]=u;v=c[r>>2]|0;w=u}else{v=q;w=s}PEi(w|0,0,v<<2|0)|0;v=(l|0)==0;if(!v){w=e+36|0;s=f&65535;q=0;while(1){u=c[w>>2]|0;if(!(((d[u+(q<<2)+3>>0]&127|0)==(s|0)?1:(d[u+(q<<2)+2>>0]&127|0)==(s|0))|0))x=q+1|0;else{u=c[j>>2]|0;r=u+(q>>>5<<2)|0;c[r>>2]=c[r>>2]|1<<(q&31);r=q+1|0;p=u+(r>>>5<<2)|0;c[p>>2]=c[p>>2]|1<<(r&31);x=r}r=qRa(e,q,0,q,f)|0;p=(c[w>>2]|0)+(q<<2)+3|0;u=d[p>>0]|0;a[p>>0]=r?u|128:u&127;if((x|0)==(l|0))break;else q=x}}if(n>>>0>1){x=e+36|0;q=f&65535;w=l+-1|0;s=n+-1|0;u=e+40|0;r=e+44|0;p=0;o=1;t=1;while(1){y=da(o,l)|0;if(v)z=j+(p*12|0)|0;else{A=(o|0)==(s|0);B=j+(p*12|0)|0;C=j+(t*12|0)|0;D=0;while(1){E=D+y|0;F=c[x>>2]|0;G=F+(E<<2)+3|0;if(((d[G>>0]&127|0)==(q|0)?1:(d[F+(E<<2)+2>>0]&127|0)==(q|0))|0){H=1<<(D&31);I=D>>>5;J=c[B>>2]|0;K=J+(I<<2)|0;c[K>>2]=c[K>>2]|H;K=D+1|0;L=1<<(K&31);M=K>>>5;K=J+(M<<2)|0;c[K>>2]=c[K>>2]|L;K=c[C>>2]|0;J=K+(I<<2)|0;c[J>>2]=c[J>>2]|H;H=K+(M<<2)|0;c[H>>2]=c[H>>2]|L}a:do if(!((D|0)==0|(D|0)==(w|0)|A)?(c[(c[B>>2]|0)+(D>>>5<<2)>>2]&1<<(D&31)|0)==0:0){L=b[F+(E<<2)>>1]<<1;if(((c[m>>2]|0)+-1|0)>>>0>o>>>0){H=c[k>>2]|0;N=L-(b[F+(H+E<<2)>>1]|0)-(b[F+(E-H<<2)>>1]|0)|0;O=1}else{N=0;O=0}if(((c[k>>2]|0)+-1|0)>>>0<=D>>>0){if(O){P=0;Q=31}}else{P=L-(b[F+(E+1<<2)>>1]|0)-(b[F+(E+-1<<2)>>1]|0)|0;Q=31}do if((Q|0)==31){Q=0;if((P^N|0)>-1)break a;R=ea(P+N|0);L=!(ea(g[u>>2])<=ea(0.0));S=ea(g[r>>2]);if(L)if(R<ea(-S))break;else break a;else if(R>S)break;else break a}while(0);a[G>>0]=d[G>>0]|128}else Q=23;while(0);do if((Q|0)==23){Q=0;G=qRa(e,E,o,D,f)|0;F=(c[x>>2]|0)+(E<<2)+3|0;L=d[F>>0]|0;if(G){a[F>>0]=L|128;break}else{a[F>>0]=L&127;break}}while(0);D=D+1|0;if((D|0)==(l|0)){z=B;break}}}PEi(c[z>>2]|0,0,c[j+(p*12|0)+4>>2]<<2|0)|0;o=o+1|0;if((o|0)==(n|0))break;else{p=p^1;t=t^1}}}t=c[j+12>>2]|0;if((t|0)!=0?(c[j+16>>2]|0)>-1:0)VJa(j+20|0,t);t=c[j>>2]|0;if(!t){i=h;return}if((c[j+4>>2]|0)<=-1){i=h;return}VJa(j+8|0,t);i=h;return}function uRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=da(c[a+20>>2]<<2,c[a+16>>2]|0)|0;g=f>>>0>d>>>0?d:f;YEi(b|0,c[a+36>>2]|0,g|0)|0;i=e;return g|0}function vRa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;j=c[b+20>>2]|0;k=c[b+16>>2]|0;l=(e|0)!=0;if(l){m=d-j|0;c[g>>2]=(m*3|0)+2;c[g+4>>2]=m;c[g+8>>2]=e+-1;c[g+12>>2]=f;n=1}else n=0;if((j+-1|0)>>>0>f>>>0){if(l?(m=d-j|0,(a[(c[b+36>>2]|0)+(m<<2)+2>>0]|0)>=0):0){c[g+(n<<4)>>2]=(m*3|0)+1;c[g+(n<<4)+4>>2]=m;c[g+(n<<4)+8>>2]=e+-1;c[g+(n<<4)+12>>2]=f;o=n+1|0}else o=n;m=d*3|0;c[g+(o<<4)>>2]=m;c[g+(o<<4)+4>>2]=d;c[g+(o<<4)+8>>2]=e;c[g+(o<<4)+12>>2]=f;p=o+1|0;q=k+-1|0;if(q>>>0>e>>>0?(a[(c[b+36>>2]|0)+(d<<2)+2>>0]|0)<0:0){c[g+(p<<4)>>2]=m+1;c[g+(p<<4)+4>>2]=d;c[g+(p<<4)+8>>2]=e;c[g+(p<<4)+12>>2]=f;r=q;s=o+2|0}else{r=q;s=p}}else{r=k+-1|0;s=n}n=r>>>0>e>>>0;if(n){c[g+(s<<4)>>2]=(d*3|0)+2;c[g+(s<<4)+4>>2]=d;c[g+(s<<4)+8>>2]=e;c[g+(s<<4)+12>>2]=f;t=s+1|0}else t=s;if(!f){u=t;i=h;return u|0}s=d+-1|0;if(n?(a[(c[b+36>>2]|0)+(s<<2)+2>>0]|0)>=0:0){c[g+(t<<4)>>2]=(s*3|0)+1;c[g+(t<<4)+4>>2]=s;c[g+(t<<4)+8>>2]=e;c[g+(t<<4)+12>>2]=f+-1;v=t+1|0}else v=t;c[g+(v<<4)>>2]=s*3;c[g+(v<<4)+4>>2]=s;c[g+(v<<4)+8>>2]=e;s=f+-1|0;c[g+(v<<4)+12>>2]=s;f=v+1|0;if(!l){u=f;i=h;return u|0}l=d-j+-1|0;if((a[(c[b+36>>2]|0)+(l<<2)+2>>0]|0)>=0){u=f;i=h;return u|0}c[g+(f<<4)>>2]=(l*3|0)+1;c[g+(f<<4)+4>>2]=l;c[g+(f<<4)+8>>2]=e+-1;c[g+(f<<4)+12>>2]=s;u=v+2|0;i=h;return u|0}function wRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[b+20>>2]|0;h=c[b+16>>2]|0;j=c[d+4>>2]|0;k=c[d+8>>2]|0;l=c[d+12>>2]|0;m=(da(j,-3)|0)+(c[d>>2]|0)|0;if((m|0)==1){if(!(k>>>0<(h+-1|0)>>>0&l>>>0<(g+-1|0)>>>0)){n=0;i=f;return n|0}d=j<<1;c[e>>2]=d;c[e+4>>2]=d|1;n=2;i=f;return n|0}else if(!m){if(l>>>0>=(g+-1|0)>>>0){n=0;i=f;return n|0}do if(k){d=j-g|0;o=d<<1;if((a[(c[b+36>>2]|0)+(d<<2)+2>>0]|0)<0){c[e>>2]=o;p=1;break}else{c[e>>2]=o|1;p=1;break}}else p=0;while(0);if(k>>>0>=(h+-1|0)>>>0){n=p;i=f;return n|0}o=j<<1;if((a[(c[b+36>>2]|0)+(j<<2)+2>>0]|0)<0){c[e+(p<<2)>>2]=o|1;n=p+1|0;i=f;return n|0}else{c[e+(p<<2)>>2]=o;n=p+1|0;i=f;return n|0}}else if((m|0)==2){if(k>>>0>=(h+-1|0)>>>0){n=0;i=f;return n|0}if(!l)q=0;else{c[e>>2]=(j<<1)+-1;q=1}if(l>>>0>=(g+-1|0)>>>0){n=q;i=f;return n|0}c[e+(q<<2)>>2]=j<<1;n=q+1|0;i=f;return n|0}else{n=0;i=f;return n|0}return 0}function xRa(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=d|0;e=e|0;var f=0,h=Im,i=Im,j=Im;f=b>ea(0.0);h=f?b:ea(0.0);f=c>ea(0.0);b=f?c:ea(0.0);c=ea(ea(1.0)-ea(ea(S(ea(h+ea(1.0))))*ea(9.99999997e-07)));i=ea(ea(1.0)-ea(ea(S(ea(b+ea(1.0))))*ea(9.99999997e-07)));j=ea(ea(g[a+24>>2])+c);c=h<j?h:j;j=ea(ea(g[a+28>>2])+i);i=b<j?b:j;j=ea(R(ea(c)));g[d>>2]=ea(c-j);c=ea(R(ea(i)));g[e>>2]=ea(i-c);e=~~ea(c+ea(j*ea(g[a+32>>2])))>>>0;return e|0}function yRa(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im;j=i;k=ea(g[a+40>>2])<=ea(0.0);l=k?-2147483648:2147483647;m=d>>>0>e>>>0;a:do if(k)if(m)n=l;else{o=a+20|0;p=a+36|0;if(f>>>0>h>>>0){q=d;while(1){q=q+1|0;if(q>>>0>e>>>0){n=l;break a}}}else{r=l;s=d}while(1){q=da(c[o>>2]|0,s)|0;t=c[p>>2]|0;u=f;v=r;do{w=b[t+(q+u<<2)>>1]|0;v=(v|0)<(w|0)?w:v;u=u+1|0}while(u>>>0<=h>>>0);s=s+1|0;if(s>>>0>e>>>0){n=v;break}else r=v}}else if(m)n=l;else{p=a+20|0;o=a+36|0;if(f>>>0>h>>>0){u=d;while(1){u=u+1|0;if(u>>>0>e>>>0){n=l;break a}}}else{x=l;y=d}while(1){u=da(c[p>>2]|0,y)|0;q=c[o>>2]|0;t=f;w=x;do{z=b[q+(u+t<<2)>>1]|0;w=(w|0)<(z|0)?w:z;t=t+1|0}while(t>>>0<=h>>>0);y=y+1|0;if(y>>>0>e>>>0){n=w;break}else x=w}}while(0);A=ea(n|0);i=j;return ea(A)}function zRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0;d=i;e=c[a+16>>2]|0;f=ea(g[e+12>>2]);h=ea(g[e+8>>2]);j=ea(g[e+16>>2]);k=ea(f*ea(0.0));l=ea(h*ea(0.0));m=ea(j*ea(0.0));n=ea(l*ea(0.0));o=ea(m*ea(0.0));p=ea(ea(f+n)+o);f=ea(ea(k+l)+o);q=ea(m+ea(k+n));r=ea(k*ea(0.0));k=ea(ea(h+r)+o);o=ea(ea(r+l)+m);m=ea(j+ea(r+n));e=c[a+12>>2]|0;n=ea(g[e+56>>2]);r=ea(n*p);j=ea(n*f);l=ea(n*q);n=ea(g[e+60>>2]);h=ea(r+ea(n*f));r=ea(j+ea(n*k));j=ea(l+ea(o*n));n=ea(g[e+64>>2]);l=ea(r+ea(o*n));r=ea(j+ea(m*n));g[b>>2]=ea(h+ea(q*n));a=b+4|0;g[a>>2]=l;g[b+8>>2]=r;r=ea(g[e+68>>2]);n=ea(p*r);p=ea(f*r);h=ea(q*r);r=ea(g[e+72>>2]);j=ea(n+ea(f*r));f=ea(p+ea(k*r));k=ea(h+ea(o*r));r=ea(g[e+76>>2]);h=ea(f+ea(o*r));o=ea(k+ea(m*r));g[b+12>>2]=ea(j+ea(q*r));s=b+16|0;g[s>>2]=h;g[b+20>>2]=o;o=ea(g[e+40>>2]);if(o<ea(0.0)){g[a>>2]=ea(o+l);i=d;return}else{g[s>>2]=ea(o+h);i=d;return}}function ARa(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;h=f+4|0;j=f;k=ea(ea(g[b>>2])*d);d=ea(ea(g[b+8>>2])*e);if(!(k>=ea(0.0))|!(d>=ea(0.0))){l=-1;i=f;return l|0}m=b+12|0;b=c[m>>2]|0;if(!(k<ea(ea(g[b+24>>2])+ea(1.0)))){l=-1;i=f;return l|0}if(!(d<ea(ea(g[b+28>>2])+ea(1.0)))){l=-1;i=f;return l|0}n=xRa(b,k,d,h,j)|0;d=ea(g[h>>2]);k=ea(g[j>>2]);if((a[(c[b+36>>2]|0)+(n<<2)+2>>0]|0)<0)o=k>d|n<<1;else o=ea(d+k)>ea(1.0)|n<<1;n=o>>>1;b=c[(c[m>>2]|0)+36>>2]|0;if(!(o&1))p=b+(n<<2)+2|0;else p=b+(n<<2)+3|0;l=(a[p>>0]&127)!=127?o:-1;i=f;return l|0}function BRa(b,d,e,f){b=b|0;d=d|0;e=ea(e);f=ea(f);var g=0,h=0,i=0;g=c[(c[b+12>>2]|0)+36>>2]|0;if((a[g+(d<<2)+2>>0]|0)<0)h=f>e|d<<1;else h=ea(e+f)>ea(1.0)|d<<1;d=h>>>1;if(!(h&1))i=g+(d<<2)+2|0;else i=g+(d<<2)+3|0;return ((a[i>>0]&127)!=127?h:-1)|0}function CRa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=Im;j=i;i=i+160|0;k=j+32|0;l=j+24|0;m=j+12|0;n=j;o=d+12|0;p=vRa(c[o>>2]|0,e,f,h,k)|0;if(!p){q=ea(0.0);r=ea(0.0);s=ea(0.0)}else{h=l+4|0;f=m+4|0;e=d+4|0;t=m+8|0;u=d+8|0;v=n+4|0;w=n+8|0;x=ea(0.0);y=ea(0.0);z=ea(0.0);A=0;while(1){B=wRa(c[o>>2]|0,k+(A<<4)|0,l)|0;if((B|0)==1){C=x;D=y;E=z;F=11}else if((B|0)==2){B=c[o>>2]|0;G=c[h>>2]|0;H=G>>>1;I=c[B+36>>2]|0;if(!(G&1))J=I+(H<<2)+2|0;else J=I+(H<<2)+3|0;if((a[J>>0]&127)==127){C=x;D=y;E=z;F=11}else{E1a(m,B,G);K=ea(g[m>>2]);L=ea(K*ea(g[d>>2]));K=ea(g[f>>2]);M=ea(K*ea(g[e>>2]));K=ea(g[t>>2]);N=ea(K*ea(g[u>>2]));K=ea(ea(ea(L*L)+ea(M*M))+ea(N*N));if(K>ea(0.0)){O=ea(ea(1.0)/ea(T(ea(K))));P=ea(L*O);Q=ea(M*O);R=ea(N*O)}else{P=ea(0.0);Q=ea(0.0);R=ea(0.0)}C=ea(x+P);D=ea(y+Q);E=ea(z+R);F=11}}else{S=z;U=y;V=x}if((F|0)==11){F=0;G=c[o>>2]|0;B=c[l>>2]|0;H=B>>>1;I=c[G+36>>2]|0;if(!(B&1))W=I+(H<<2)+2|0;else W=I+(H<<2)+3|0;if((a[W>>0]&127)==127){S=E;U=D;V=C}else{E1a(n,G,B);O=ea(g[n>>2]);N=ea(O*ea(g[d>>2]));O=ea(g[v>>2]);M=ea(O*ea(g[e>>2]));O=ea(g[w>>2]);L=ea(O*ea(g[u>>2]));O=ea(ea(ea(N*N)+ea(M*M))+ea(L*L));if(O>ea(0.0)){K=ea(ea(1.0)/ea(T(ea(O))));X=ea(N*K);Y=ea(M*K);Z=ea(L*K)}else{X=ea(0.0);Y=ea(0.0);Z=ea(0.0)}S=ea(E+Z);U=ea(D+Y);V=ea(C+X)}}A=A+1|0;if((A|0)==(p|0)){q=S;r=U;s=V;break}else{x=V;y=U;z=S}}}S=ea(ea(q*q)+ea(ea(r*r)+ea(s*s)));if(S>ea(0.0)){z=ea(ea(1.0)/ea(T(ea(S))));S=ea(r*z);r=ea(q*z);g[b>>2]=ea(s*z);g[b+4>>2]=S;g[b+8>>2]=r;i=j;return}else{g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);i=j;return}}function DRa(d,e,f,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=0;o=i;i=i+224|0;p=o+80|0;q=o+48|0;r=o+12|0;s=o+24|0;t=o+208|0;u=o;v=o+36|0;w=o+68|0;x=o+56|0;y=d+12|0;z=c[y>>2]|0;A=c[z+20>>2]|0;B=(da(A,e)|0)+f|0;C=B*3|0;D=((c[z+16>>2]|0)+-2|0)==(e|0);E=m&1;F=(A+-2|0)==(f|0)&m;G=D&m;H=D&F;D=B<<1;I=c[z+36>>2]|0;z=D|1;J=B&2147483647;K=a[I+(J<<2)+3>>0]|0;do if(l){if((a[I+(J<<2)+2>>0]&127)!=127?ERa(d,D,e,f,h,r)|0:0){g[j>>2]=ea(g[r>>2]);g[j+4>>2]=ea(g[r+4>>2]);g[j+8>>2]=ea(g[r+8>>2]);if(!k){L=1;M=0;N=0;O=0}else{c[k>>2]=D;L=1;M=0;N=0;O=0}}else{L=0;M=E;N=m;O=G}if((K&127)!=127?ERa(d,z,e,f,h,s)|0:0){g[j+(L*12|0)>>2]=ea(g[s>>2]);g[j+(L*12|0)+4>>2]=ea(g[s+4>>2]);g[j+(L*12|0)+8>>2]=ea(g[s+8>>2]);if(k)c[k+(L<<2)>>2]=z;P=L+1|0;Q=0;R=0;S=0}else{P=L;Q=M;R=F;S=H}if(!m){T=P;i=o;return T|0}if((P|0)==0|n^1){U=c[(c[y>>2]|0)+20>>2]|0;V=P;W=(Q&1)!=0;X=N;Y=R;Z=O;_=S;$=15;break}else{T=P;i=o;return T|0}}else if(m){U=A;V=0;W=1;X=1;Y=F;Z=G;_=H;$=15}else{aa=A;ba=0;ca=0;fa=0;ga=F;ha=G;ia=H;$=46}while(0);a:do if(($|0)==15){ja=ea(FRa(d,C,B,e,f,h,t));if(ja<=ea(0.0)){if(!X){aa=U;ba=V;ca=W;fa=0;ga=Y;ha=Z;ia=_;$=46;break}H=vRa(c[y>>2]|0,B,e,f,p)|0;if(!H){ka=U;la=V;ma=W;na=1;oa=Y;pa=0;qa=Z;ra=_;$=47;break}else sa=0;while(1){if((IRa(d,c[p+(sa<<4)>>2]|0,c[p+(sa<<4)+4>>2]|0,c[p+(sa<<4)+8>>2]|0,c[p+(sa<<4)+12>>2]|0)|0)!=-1)break;sa=sa+2|0;if(sa>>>0>=H>>>0){ka=U;la=V;ma=W;na=1;oa=Y;pa=0;qa=Z;ra=_;$=47;break a}}g[j+(V*12|0)>>2]=ea(g[t>>2]);g[j+(V*12|0)+4>>2]=ea(g[t+4>>2]);g[j+(V*12|0)+8>>2]=ea(g[t+8>>2]);if(k)c[k+(V<<2)>>2]=(da(U,e)|0)+f|-2147483648;ka=U;la=V+1|0;ma=W;na=1;oa=Y;pa=0;qa=Z;ra=_;$=47;break}if(!(ja<ea(1.0))){if(!Y){aa=U;ba=V;ca=W;fa=X;ga=0;ha=Z;ia=_;$=46;break}H=f+1|0;F=vRa(c[y>>2]|0,B+1|0,e,H,p)|0;if(!F){aa=U;ba=V;ca=W;fa=X;ga=1;ha=Z;ia=_;$=46;break}else ta=0;while(1){if((IRa(d,c[p+(ta<<4)>>2]|0,c[p+(ta<<4)+4>>2]|0,c[p+(ta<<4)+8>>2]|0,c[p+(ta<<4)+12>>2]|0)|0)!=-1)break;ta=ta+2|0;if(ta>>>0>=F>>>0){aa=U;ba=V;ca=W;fa=X;ga=1;ha=Z;ia=_;$=46;break a}}g[j+(V*12|0)>>2]=ea(g[t>>2]);g[j+(V*12|0)+4>>2]=ea(g[t+4>>2]);g[j+(V*12|0)+8>>2]=ea(g[t+8>>2]);if(k)c[k+(V<<2)>>2]=H+(da(U,e)|0)|-2147483648;aa=U;ba=V+1|0;ca=W;fa=X;ga=1;ha=Z;ia=_;$=46;break}if(m){F=(C1a(c[y>>2]|0,C,q)|0)>>>0>1;A=c[q>>2]|0;P=A>>>1;S=c[(c[y>>2]|0)+36>>2]|0;if(!(A&1))ua=S+(P<<2)+2|0;else ua=S+(P<<2)+3|0;P=(a[ua>>0]&127)!=127;if(F)if(P)va=A;else{F=c[q+4>>2]|0;O=F>>>1;if(!(F&1))wa=S+(O<<2)+2|0;else wa=S+(O<<2)+3|0;va=(a[wa>>0]&127)==127?-1:F}else va=P?A:-1;if((va|0)!=-1){g[j+(V*12|0)>>2]=ea(g[t>>2]);g[j+(V*12|0)+4>>2]=ea(g[t+4>>2]);g[j+(V*12|0)+8>>2]=ea(g[t+8>>2]);if(k)c[k+(V<<2)>>2]=C|1073741824;aa=U;ba=V+1|0;ca=W;fa=X;ga=Y;ha=Z;ia=_;$=46}else{aa=U;ba=V;ca=W;fa=X;ga=Y;ha=Z;ia=_;$=46}}else{aa=U;ba=V;ca=W;fa=X;ga=Y;ha=Z;ia=_;$=46}}while(0);if(($|0)==46)if(fa|ha){ka=aa;la=ba;ma=ca;na=fa;oa=ga;pa=fa;qa=ha;ra=ia;$=47}else{xa=aa;ya=ba;za=ca;Aa=ga;Ba=ia}b:do if(($|0)==47){ia=C+2|0;ja=ea(FRa(d,ia,B,e,f,h,u));if(ja<=ea(0.0)){if(!pa){xa=ka;ya=la;za=ma;Aa=oa;Ba=ra;break}ga=vRa(c[y>>2]|0,B,e,f,p)|0;if(!ga){xa=ka;ya=la;za=ma;Aa=oa;Ba=ra;break}else Ca=0;while(1){if((IRa(d,c[p+(Ca<<4)>>2]|0,c[p+(Ca<<4)+4>>2]|0,c[p+(Ca<<4)+8>>2]|0,c[p+(Ca<<4)+12>>2]|0)|0)!=-1)break;Ca=Ca+2|0;if(Ca>>>0>=ga>>>0){xa=ka;ya=la;za=ma;Aa=oa;Ba=ra;break b}}g[j+(la*12|0)>>2]=ea(g[u>>2]);g[j+(la*12|0)+4>>2]=ea(g[u+4>>2]);g[j+(la*12|0)+8>>2]=ea(g[u+8>>2]);if(k)c[k+(la<<2)>>2]=(da(ka,e)|0)+f|-2147483648;xa=ka;ya=la+1|0;za=ma;Aa=oa;Ba=ra;break}if(!(ja<ea(1.0))){if(!qa){xa=ka;ya=la;za=ma;Aa=oa;Ba=ra;break}ga=e+1|0;H=vRa(c[y>>2]|0,ka+B|0,ga,f,p)|0;if(!H){xa=ka;ya=la;za=ma;Aa=oa;Ba=ra;break}else Da=0;while(1){if((IRa(d,c[p+(Da<<4)>>2]|0,c[p+(Da<<4)+4>>2]|0,c[p+(Da<<4)+8>>2]|0,c[p+(Da<<4)+12>>2]|0)|0)!=-1)break;Da=Da+2|0;if(Da>>>0>=H>>>0){xa=ka;ya=la;za=ma;Aa=oa;Ba=ra;break b}}g[j+(la*12|0)>>2]=ea(g[u>>2]);g[j+(la*12|0)+4>>2]=ea(g[u+4>>2]);g[j+(la*12|0)+8>>2]=ea(g[u+8>>2]);if(k)c[k+(la<<2)>>2]=(da(ka,ga)|0)+f|-2147483648;xa=ka;ya=la+1|0;za=ma;Aa=oa;Ba=ra;break}if(na){H=(C1a(c[y>>2]|0,ia,q)|0)>>>0>1;ca=c[q>>2]|0;ba=ca>>>1;aa=c[(c[y>>2]|0)+36>>2]|0;if(!(ca&1))Ea=aa+(ba<<2)+2|0;else Ea=aa+(ba<<2)+3|0;ba=(a[Ea>>0]&127)!=127;if(H)if(ba)Fa=ca;else{H=c[q+4>>2]|0;ha=H>>>1;if(!(H&1))Ga=aa+(ha<<2)+2|0;else Ga=aa+(ha<<2)+3|0;Fa=(a[Ga>>0]&127)==127?-1:H}else Fa=ba?ca:-1;if((Fa|0)!=-1){g[j+(la*12|0)>>2]=ea(g[u>>2]);g[j+(la*12|0)+4>>2]=ea(g[u+4>>2]);g[j+(la*12|0)+8>>2]=ea(g[u+8>>2]);if(k)c[k+(la<<2)>>2]=ia|1073741824;xa=ka;ya=la+1|0;za=ma;Aa=oa;Ba=ra}else{xa=ka;ya=la;za=ma;Aa=oa;Ba=ra}}else{xa=ka;ya=la;za=ma;Aa=oa;Ba=ra}}while(0);if(G?(G=xa+B|0,ra=G*3|0,ja=ea(FRa(d,ra,G,e+1|0,f,h,v)),!(ja<=ea(0.0))&ja<ea(1.0)):0){G=(C1a(c[y>>2]|0,ra,q)|0)>>>0>1;oa=c[q>>2]|0;ma=oa>>>1;la=c[(c[y>>2]|0)+36>>2]|0;if(!(oa&1))Ha=la+(ma<<2)+2|0;else Ha=la+(ma<<2)+3|0;ma=(a[Ha>>0]&127)!=127;if(G)if(ma)Ia=oa;else{G=c[q+4>>2]|0;Ha=G>>>1;if(!(G&1))Ja=la+(Ha<<2)+2|0;else Ja=la+(Ha<<2)+3|0;Ia=(a[Ja>>0]&127)==127?-1:G}else Ia=ma?oa:-1;if((Ia|0)!=-1){g[j+(ya*12|0)>>2]=ea(g[v>>2]);g[j+(ya*12|0)+4>>2]=ea(g[v+4>>2]);g[j+(ya*12|0)+8>>2]=ea(g[v+8>>2]);if(k)c[k+(ya<<2)>>2]=ra|1073741824;Ka=ya+1|0}else Ka=ya}else Ka=ya;if(Aa?(Aa=C+5|0,ja=ea(FRa(d,Aa,B+1|0,e,f+1|0,h,w)),!(ja<=ea(0.0))&ja<ea(1.0)):0){ya=(C1a(c[y>>2]|0,Aa,q)|0)>>>0>1;ra=c[q>>2]|0;v=ra>>>1;Ia=c[(c[y>>2]|0)+36>>2]|0;if(!(ra&1))La=Ia+(v<<2)+2|0;else La=Ia+(v<<2)+3|0;v=(a[La>>0]&127)!=127;if(ya)if(v)Ma=ra;else{ya=c[q+4>>2]|0;La=ya>>>1;if(!(ya&1))Na=Ia+(La<<2)+2|0;else Na=Ia+(La<<2)+3|0;Ma=(a[Na>>0]&127)==127?-1:ya}else Ma=v?ra:-1;if((Ma|0)!=-1){g[j+(Ka*12|0)>>2]=ea(g[w>>2]);g[j+(Ka*12|0)+4>>2]=ea(g[w+4>>2]);g[j+(Ka*12|0)+8>>2]=ea(g[w+8>>2]);if(k)c[k+(Ka<<2)>>2]=Aa|1073741824;Oa=Ka+1|0}else Oa=Ka}else Oa=Ka;c:do if(Ba?(Ka=B+1|0,Aa=e+1|0,w=f+1|0,Ma=vRa(c[y>>2]|0,Ka+xa|0,Aa,w,p)|0,(Ma|0)!=0):0){ra=0;while(1){if((IRa(d,c[p+(ra<<4)>>2]|0,c[p+(ra<<4)+4>>2]|0,c[p+(ra<<4)+8>>2]|0,c[p+(ra<<4)+12>>2]|0)|0)!=-1)break;ra=ra+2|0;if(ra>>>0>=Ma>>>0){Pa=Oa;break c}}ja=ea(Aa>>>0);Ma=c[d+16>>2]|0;Qa=ea(ja*ea(g[Ma+12>>2]));ja=ea(g[Ma+8>>2]);ra=c[y>>2]|0;Ra=ea(ja*ea(b[(c[ra+36>>2]|0)+(Ka+(c[ra+20>>2]|0)<<2)>>1]|0));ja=ea(w>>>0);Sa=ea(ja*ea(g[Ma+16>>2]));g[j+(Oa*12|0)>>2]=Qa;g[j+(Oa*12|0)+4>>2]=Ra;g[j+(Oa*12|0)+8>>2]=Sa;if(k)c[k+(Oa<<2)>>2]=w+(da(xa,Aa)|0)|-2147483648;Pa=Oa+1|0}else Pa=Oa;while(0);if(!za){T=Pa;i=o;return T|0}za=C+1|0;C=(C1a(c[y>>2]|0,za,q)|0)>>>0>1;Oa=c[q>>2]|0;xa=Oa>>>1;p=c[(c[y>>2]|0)+36>>2]|0;if(!(Oa&1))Ta=p+(xa<<2)+2|0;else Ta=p+(xa<<2)+3|0;xa=(a[Ta>>0]&127)!=127;if(C)if(xa)Ua=Oa;else{C=c[q+4>>2]|0;q=C>>>1;if(!(C&1))Va=p+(q<<2)+2|0;else Va=p+(q<<2)+3|0;Ua=(a[Va>>0]&127)==127?-1:C}else Ua=xa?Oa:-1;if((Ua|0)==-1){T=Pa;i=o;return T|0}Sa=ea(FRa(d,za,B,e,f,h,x));if(!(!(Sa<=ea(0.0))&Sa<ea(1.0))){T=Pa;i=o;return T|0}g[j+(Pa*12|0)>>2]=ea(g[x>>2]);g[j+(Pa*12|0)+4>>2]=ea(g[x+4>>2]);g[j+(Pa*12|0)+8>>2]=ea(g[x+8>>2]);if(k)c[k+(Pa<<2)>>2]=za|1073741824;T=Pa+1|0;i=o;return T|0}function ERa(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=0,q=0,r=Im,s=Im,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0;l=i;m=e>>>1;n=c[d+16>>2]|0;o=ea(g[n+8>>2]);p=c[d+12>>2]|0;q=c[p+36>>2]|0;r=ea(o*ea(b[q+(m<<2)>>1]|0));s=ea(o*ea(b[q+(m+1<<2)>>1]|0));t=(c[p+20>>2]|0)+m|0;u=ea(o*ea(b[q+(t<<2)>>1]|0));v=ea(o*ea(b[q+(t+1<<2)>>1]|0));t=(e&1|0)==0;do if((a[q+(m<<2)+2>>0]|0)<0)if(t){o=ea((f+1|0)>>>0);w=ea(o*ea(g[n+12>>2]));o=ea(h>>>0);x=ea(o*ea(g[n+16>>2]));o=ea(g[d+8>>2]);y=w;z=x;A=u;B=v;C=r;D=o;E=ea(-ea(g[d>>2]));break}else{o=ea(f>>>0);x=ea(o*ea(g[n+12>>2]));o=ea((h+1|0)>>>0);w=ea(o*ea(g[n+16>>2]));o=ea(-ea(g[d+8>>2]));y=x;z=w;A=s;B=r;C=v;D=o;E=ea(g[d>>2]);break}else if(t){o=ea(f>>>0);w=ea(o*ea(g[n+12>>2]));o=ea(h>>>0);x=ea(o*ea(g[n+16>>2]));o=ea(g[d+8>>2]);y=w;z=x;A=r;B=s;C=u;D=o;E=ea(g[d>>2]);break}else{o=ea((f+1|0)>>>0);x=ea(o*ea(g[n+12>>2]));o=ea((h+1|0)>>>0);w=ea(o*ea(g[n+16>>2]));o=ea(-ea(g[d+8>>2]));y=x;z=w;A=v;B=u;C=s;D=o;E=ea(-ea(g[d>>2]));break}while(0);s=ea(ea(g[j>>2])-y);u=ea(ea(g[j+4>>2])-A);v=ea(ea(g[j+8>>2])-z);r=ea(D*ea(B-A));B=ea(-r);o=ea(E*ea(C-A));C=ea(-o);w=ea(ea(ea(1.0)/ea(ea(ea(r*r)+ea(o*o))+ea(1.0)))*ea(ea(u+ea(s*C))+ea(v*B)));o=ea(s-ea(w*C));C=ea(v-ea(w*B));B=ea(E*o);E=ea(D*C);if(!(B>ea(0.0)&E>ea(0.0)&ea(B+E)<ea(1.0))){F=0;i=l;return F|0}E=ea(A+ea(u-w));w=ea(z+C);g[k>>2]=ea(y+o);g[k+4>>2]=E;g[k+8>>2]=w;F=1;i=l;return F|0}function FRa(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;m=i;n=(da(f,-3)|0)+e|0;do if((n|0)==1){e=c[d+12>>2]|0;o=c[e+36>>2]|0;p=c[d+16>>2]|0;q=ea(g[p+8>>2]);if((a[o+(f<<2)+2>>0]|0)<0){r=ea(q*ea(b[o+(f<<2)>>1]|0));s=ea(q*ea(b[o+(f+1+(c[e+20>>2]|0)<<2)>>1]|0));t=ea(h>>>0);u=ea(g[p+12>>2]);v=ea(t*u);t=ea(j>>>0);w=ea(g[p+16>>2]);x=ea(s-r);y=v;z=r;A=ea(t*w);B=u;C=x;D=w;E=ea(ea(ea(u*u)+ea(w*w))+ea(x*x));break}else{x=ea(q*ea(b[o+(f+1<<2)>>1]|0));w=ea(q*ea(b[o+((c[e+20>>2]|0)+f<<2)>>1]|0));q=ea(h>>>0);u=ea(g[p+12>>2]);t=ea(q*u);q=ea((j+1|0)>>>0);r=ea(g[p+16>>2]);v=ea(w-x);y=t;z=x;A=ea(q*r);B=u;C=v;D=ea(-r);E=ea(ea(ea(u*u)+ea(r*r))+ea(v*v));break}}else if((n|0)==2){p=c[d+16>>2]|0;v=ea(g[p+8>>2]);e=c[d+12>>2]|0;o=c[e+36>>2]|0;r=ea(v*ea(b[o+(f<<2)>>1]|0));u=ea(v*ea(b[o+((c[e+20>>2]|0)+f<<2)>>1]|0));v=ea(h>>>0);q=ea(g[p+12>>2]);x=ea(v*q);v=ea(j>>>0);t=ea(u-r);y=x;z=r;A=ea(v*ea(g[p+16>>2]));B=q;C=t;D=ea(0.0);E=ea(ea(q*q)+ea(t*t))}else if(!n){p=c[d+16>>2]|0;t=ea(g[p+8>>2]);e=c[(c[d+12>>2]|0)+36>>2]|0;q=ea(t*ea(b[e+(f<<2)>>1]|0));v=ea(t*ea(b[e+(f+1<<2)>>1]|0));t=ea(h>>>0);r=ea(t*ea(g[p+12>>2]));t=ea(j>>>0);x=ea(g[p+16>>2]);u=ea(v-q);y=r;z=q;A=ea(t*x);B=ea(0.0);C=u;D=x;E=ea(ea(x*x)+ea(u*u))}else{y=ea(0.0);z=ea(0.0);A=ea(0.0);B=ea(0.0);C=ea(0.0);D=ea(0.0);E=ea(0.0)}while(0);u=ea(ea(g[k>>2])-y);x=ea(ea(g[k+4>>2])-z);t=ea(ea(ea(ea(B*u)+ea(C*x))+ea(D*ea(ea(g[k+8>>2])-A)))/E);if(t<ea(0.0)){g[l>>2]=y;g[l+4>>2]=z;g[l+8>>2]=A;i=m;return ea(t)}if(t>ea(1.0)){E=ea(z+C);x=ea(A+D);g[l>>2]=ea(y+B);g[l+4>>2]=E;g[l+8>>2]=x;i=m;return ea(t)}else{x=ea(z+ea(C*t));C=ea(A+ea(D*t));g[l>>2]=ea(y+ea(B*t));g[l+4>>2]=x;g[l+8>>2]=C;i=m;return ea(t)}return ea(0.0)}function GRa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+128|0;g=f;h=vRa(c[a+12>>2]|0,b,d,e,g)|0;if(!h){j=-1;i=f;return j|0}else k=0;while(1){e=IRa(a,c[g+(k<<4)>>2]|0,c[g+(k<<4)+4>>2]|0,c[g+(k<<4)+8>>2]|0,c[g+(k<<4)+12>>2]|0)|0;k=k+2|0;if((e|0)!=-1){j=e;l=4;break}if(k>>>0>=h>>>0){j=-1;l=4;break}}if((l|0)==4){i=f;return j|0}return 0}function HRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=b+12|0;b=(C1a(c[g>>2]|0,d,f)|0)>>>0>1;d=c[f>>2]|0;h=d>>>1;j=c[(c[g>>2]|0)+36>>2]|0;if(!(d&1))k=j+(h<<2)+2|0;else k=j+(h<<2)+3|0;h=(a[k>>0]&127)!=127;if(!b){l=h?d:-1;i=e;return l|0}if(h){l=d;i=e;return l|0}l=c[f+4>>2]|0;f=l>>>1;if(!(l&1)){m=j+(f<<2)+2|0;n=a[m>>0]|0;o=n&127;p=o<<24>>24==127;q=p?-1:l;i=e;return q|0}else{m=j+(f<<2)+3|0;n=a[m>>0]|0;o=n&127;p=o<<24>>24==127;q=p?-1:l;i=e;return q|0}return 0}function IRa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+16|0;k=j;l=c[b+12>>2]|0;b=(da(f,-3)|0)+e|0;if((b|0)==2)if(((c[l+16>>2]|0)+-1|0)>>>0>g>>>0){if(!h)m=0;else{c[k>>2]=(f<<1)+-1;m=1}if(((c[l+20>>2]|0)+-1|0)>>>0>h>>>0){c[k+(m<<2)>>2]=f<<1;n=m+1|0}else n=m}else n=0;else if((b|0)==1)if(((c[l+16>>2]|0)+-1|0)>>>0>g>>>0?((c[l+20>>2]|0)+-1|0)>>>0>h>>>0:0){m=f<<1;c[k>>2]=m;c[k+4>>2]=m|1;n=2}else n=0;else if((b|0)==0?(b=c[l+20>>2]|0,(b+-1|0)>>>0>h>>>0):0){if(!g)o=0;else{h=f-b|0;c[k>>2]=(d[(c[l+36>>2]|0)+(h<<2)+2>>0]|0)>>>7&255|h<<1;o=1}if(((c[l+16>>2]|0)+-1|0)>>>0>g>>>0){c[k+(o<<2)>>2]=(d[(c[l+36>>2]|0)+(f<<2)+2>>0]|0)>>>7&255|f<<1;n=o+1|0}else n=o}else n=0;o=c[k>>2]|0;f=o>>>1;g=c[l+36>>2]|0;if(!(o&1))p=g+(f<<2)+2|0;else p=g+(f<<2)+3|0;f=(a[p>>0]&127)!=127;if(n>>>0<=1){q=f?o:-1;i=j;return q|0}if(f){q=o;i=j;return q|0}q=c[k+4>>2]|0;k=q>>>1;if(!(q&1)){r=g+(k<<2)+2|0;s=a[r>>0]|0;t=s&127;u=t<<24>>24==127;v=u?-1:q;i=j;return v|0}else{r=g+(k<<2)+3|0;s=a[r>>0]|0;t=s&127;u=t<<24>>24==127;v=u?-1:q;i=j;return v|0}return 0}function JRa(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=0,v=Im,w=0,x=Im;m=i;n=(da(f,-3)|0)+e|0;if((n|0)==1){e=c[d+12>>2]|0;o=c[e+36>>2]|0;p=c[d+16>>2]|0;q=ea(g[p+8>>2]);if((a[o+(f<<2)+2>>0]|0)<0){r=ea(q*ea(b[o+(f<<2)>>1]|0));s=ea(q*ea(b[o+(f+1+(c[e+20>>2]|0)<<2)>>1]|0));t=ea(h>>>0);u=p+12|0;v=ea(t*ea(g[u>>2]));t=ea(j>>>0);w=p+16|0;x=ea(t*ea(g[w>>2]));g[k>>2]=v;g[k+4>>2]=r;g[k+8>>2]=x;x=ea(g[u>>2]);v=ea(s-r);r=ea(g[w>>2]);g[l>>2]=x;g[l+4>>2]=v;g[l+8>>2]=r;i=m;return}else{r=ea(q*ea(b[o+(f+1<<2)>>1]|0));v=ea(q*ea(b[o+((c[e+20>>2]|0)+f<<2)>>1]|0));q=ea(h>>>0);e=p+12|0;x=ea(q*ea(g[e>>2]));q=ea((j+1|0)>>>0);o=p+16|0;s=ea(q*ea(g[o>>2]));g[k>>2]=x;g[k+4>>2]=r;g[k+8>>2]=s;s=ea(g[e>>2]);x=ea(v-r);r=ea(-ea(g[o>>2]));g[l>>2]=s;g[l+4>>2]=x;g[l+8>>2]=r;i=m;return}}else if(!n){o=c[d+16>>2]|0;r=ea(g[o+8>>2]);e=c[(c[d+12>>2]|0)+36>>2]|0;x=ea(r*ea(b[e+(f<<2)>>1]|0));s=ea(r*ea(b[e+(f+1<<2)>>1]|0));r=ea(h>>>0);v=ea(r*ea(g[o+12>>2]));r=ea(j>>>0);e=o+16|0;q=ea(r*ea(g[e>>2]));g[k>>2]=v;g[k+4>>2]=x;g[k+8>>2]=q;q=ea(s-x);x=ea(g[e>>2]);g[l>>2]=ea(0.0);g[l+4>>2]=q;g[l+8>>2]=x;i=m;return}else if((n|0)==2){n=c[d+16>>2]|0;x=ea(g[n+8>>2]);e=c[d+12>>2]|0;d=c[e+36>>2]|0;q=ea(x*ea(b[d+(f<<2)>>1]|0));s=ea(x*ea(b[d+((c[e+20>>2]|0)+f<<2)>>1]|0));x=ea(h>>>0);h=n+12|0;v=ea(x*ea(g[h>>2]));x=ea(j>>>0);r=ea(x*ea(g[n+16>>2]));g[k>>2]=v;g[k+4>>2]=q;g[k+8>>2]=r;r=ea(s-q);g[l>>2]=ea(g[h>>2]);g[l+4>>2]=r;g[l+8>>2]=ea(0.0);i=m;return}else{i=m;return}}function KRa(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;k=i;i=i+336|0;l=k+312|0;m=k+288|0;n=k+256|0;o=k;p=ea(g[f>>2]);g[l>>2]=p;q=l+4|0;r=ea(g[f+4>>2]);g[q>>2]=r;s=l+8|0;t=ea(g[f+8>>2]);g[s>>2]=t;u=l+12|0;v=ea(g[f+12>>2]);g[u>>2]=v;w=l+16|0;x=ea(g[f+16>>2]);g[w>>2]=x;y=l+20|0;z=ea(g[f+20>>2]);g[y>>2]=z;if(!(h&1)){A=x;B=z;C=p;D=r;E=t;F=v}else{v=ea(g[e+16>>2]);t=ea(g[e+20>>2]);r=ea(v*ea(-2.0));v=ea(t*ea(-2.0));t=ea(ea(g[e+24>>2])*ea(-2.0));p=ea(g[e+12>>2]);z=ea(ea(p*p)+ea(-.5));x=ea(g[e>>2]);G=ea(r*x);H=ea(g[e+4>>2]);I=ea(G+ea(v*H));G=ea(g[e+8>>2]);J=ea(I+ea(t*G));I=ea(ea(x*J)+ea(ea(r*z)-ea(p*ea(ea(t*H)-ea(v*G)))));K=ea(ea(H*J)+ea(ea(v*z)-ea(p*ea(ea(r*G)-ea(t*x)))));L=ea(ea(ea(t*z)-ea(p*ea(ea(v*x)-ea(r*H))))+ea(G*J));J=ea(-H);H=ea(-G);g[n>>2]=ea(-x);g[n+4>>2]=J;g[n+8>>2]=H;g[n+12>>2]=p;g[n+16>>2]=I;g[n+20>>2]=K;g[n+24>>2]=L;e_a(m,n,l);L=ea(g[m>>2]);g[l>>2]=L;K=ea(g[m+4>>2]);g[q>>2]=K;I=ea(g[m+8>>2]);g[s>>2]=I;p=ea(g[m+12>>2]);g[u>>2]=p;H=ea(g[m+16>>2]);g[w>>2]=H;J=ea(g[m+20>>2]);g[y>>2]=J;A=H;B=J;C=L;D=K;E=I;F=p}p=ea(g[d>>2]);I=ea(p*C);g[l>>2]=I;C=ea(g[d+4>>2]);K=ea(C*D);g[q>>2]=K;D=ea(g[d+8>>2]);L=ea(D*E);g[s>>2]=L;E=ea(p*F);g[u>>2]=E;F=ea(C*A);g[w>>2]=F;A=ea(D*B);g[y>>2]=A;w=c[d+16>>2]|0;if(ea(g[w+12>>2])<ea(0.0)){g[l>>2]=E;g[u>>2]=I;M=E;N=I}else{M=I;N=E}if(ea(g[w+16>>2])<ea(0.0)){g[s>>2]=A;g[y>>2]=L;O=A;P=L}else{O=L;P=A}y=d+12|0;d=c[y>>2]|0;s=c[d+16>>2]|0;w=s+-1|0;if(M>ea(w>>>0)){Q=0;i=k;return Q|0}u=c[d+20>>2]|0;l=u+-1|0;if(O>ea(l>>>0)|N<ea(0.0)|P<ea(0.0)){Q=0;i=k;return Q|0}q=~~ea(R(ea(M)));m=s+-2|0;s=(q|0)>0?q:0;q=(s|0)>(m|0)?m:s;s=~~ea(ca(ea(N)));m=(s|0)>0?s:0;s=(m|0)>(w|0)?w:m;m=~~ea(R(ea(O)));w=u+-2|0;n=(m|0)>0?m:0;m=(n|0)>(w|0)?w:n;n=~~ea(ca(ea(P)));w=(n|0)>0?n:0;n=(w|0)>(l|0)?l:w;w=n-m|0;if(!(da(s-q<<1,w)|0)){Q=0;i=k;return Q|0}l=(h&2|0)==0;if(q>>>0<s>>>0){h=m>>>0<n>>>0;e=d;d=0;f=0;S=(da(u,q)|0)+m|0;u=q;a:while(1){b:do if(h){if(l){T=e;U=m;V=d;W=f;X=S}else{q=m;Y=S;while(1){Z=c[e+36>>2]|0;P=ea(b[Z+(Y<<2)>>1]|0);_=Y+1|0;O=ea(b[Z+(_<<2)>>1]|0);$=(c[e+20>>2]|0)+Y|0;N=ea(b[Z+($<<2)>>1]|0);M=ea(b[Z+($+1<<2)>>1]|0);if(!(F<P&F<O&F<N&F<M)?!(K>P&K>O&K>N&K>M):0){if((a[Z+(Y<<2)+2>>0]&127)!=127){aa=17;break a}if((a[Z+(Y<<2)+3>>0]&127)!=127){aa=21;break a}}q=q+1|0;if(q>>>0>=n>>>0){ba=e;fa=d;ga=f;ha=_;break b}else Y=_}}while(1){q=c[T+36>>2]|0;M=ea(b[q+(X<<2)>>1]|0);_=X+1|0;N=ea(b[q+(_<<2)>>1]|0);Z=(c[T+20>>2]|0)+X|0;O=ea(b[q+(Z<<2)>>1]|0);P=ea(b[q+(Z+1<<2)>>1]|0);if(!(F<M&F<N&F<O&F<P)?!(K>M&K>N&K>O&K>P):0){if((a[q+(X<<2)+2>>0]&127)==127){ia=q;ja=T;ka=V;la=W}else{if(V>>>0>63){xo[c[(c[j>>2]|0)+8>>2]&2047](j,V,o)|0;ma=0}else ma=V;c[o+(ma<<2)>>2]=X<<1;q=c[y>>2]|0;ia=c[q+36>>2]|0;ja=q;ka=ma+1|0;la=W+1|0}if((a[ia+(X<<2)+3>>0]&127)==127){na=ja;oa=ka;pa=la}else{if(ka>>>0>63){xo[c[(c[j>>2]|0)+8>>2]&2047](j,ka,o)|0;qa=0}else qa=ka;c[o+(qa<<2)>>2]=X<<1|1;na=c[y>>2]|0;oa=qa+1|0;pa=la+1|0}}else{na=T;oa=V;pa=W}U=U+1|0;if(U>>>0>=n>>>0){ba=na;fa=oa;ga=pa;ha=_;break}else{T=na;V=oa;W=pa;X=_}}}else{ba=e;fa=d;ga=f;ha=S}while(0);u=u+1|0;if(u>>>0>=s>>>0){ra=fa;sa=ga;break}else{e=ba;d=fa;f=ga;S=ha-w+(c[ba+20>>2]|0)|0}}if((aa|0)==17){if(d>>>0>63){xo[c[(c[j>>2]|0)+8>>2]&2047](j,d,o)|0;ta=0}else ta=d;c[o+(ta<<2)>>2]=Y<<1;ra=ta+1|0;sa=f+1|0}else if((aa|0)==21){if(d>>>0>63){xo[c[(c[j>>2]|0)+8>>2]&2047](j,d,o)|0;ua=0}else ua=d;c[o+(ua<<2)>>2]=Y<<1|1;ra=ua+1|0;sa=f+1|0}if(!ra)va=sa;else{xo[c[(c[j>>2]|0)+8>>2]&2047](j,ra,o)|0;va=sa}}else va=0;Q=(va|0)!=0;i=k;return Q|0}function LRa(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0;n=i;i=i+16|0;o=n;p=d+16|0;q=c[p>>2]|0;r=ea(g[q+16>>2])<ea(0.0);if(ea(g[q+12>>2])<ea(0.0))s=r^1;else s=r;r=d+12|0;d=c[r>>2]|0;if(ea(g[d+40>>2])>ea(0.0))if(s)t=13;else t=6;else if(s)t=6;else t=13;do if((t|0)==6){s=o+8|0;q=o+4|0;u=k>>>1;v=(k&1|0)==0;if((a[(c[d+36>>2]|0)+(u<<2)+2>>0]|0)<0)if(v){w=c[d+20>>2]|0;x=w+u|0;c[o>>2]=x;c[s>>2]=u;y=u+1+w|0;c[q>>2]=y;z=x;A=u;B=y;C=1;break}else{y=u+1|0;c[o>>2]=y;x=(c[d+20>>2]|0)+y|0;c[s>>2]=x;c[q>>2]=u;z=y;A=x;B=u;C=1;break}else if(v){c[o>>2]=u;v=u+1|0;c[s>>2]=v;x=(c[d+20>>2]|0)+u|0;c[q>>2]=x;z=u;A=v;B=x;C=1;break}else{x=c[d+20>>2]|0;v=u+1|0;y=x+v|0;c[o>>2]=y;w=x+u|0;c[s>>2]=w;c[q>>2]=v;z=y;A=w;B=v;C=1;break}}else if((t|0)==13){v=o+4|0;w=o+8|0;y=k>>>1;q=(k&1|0)==0;if((a[(c[d+36>>2]|0)+(y<<2)+2>>0]|0)<0)if(q){s=c[d+20>>2]|0;u=s+y|0;c[o>>2]=u;c[v>>2]=y;x=y+1+s|0;c[w>>2]=x;z=u;A=x;B=y;C=0;break}else{x=y+1|0;c[o>>2]=x;u=(c[d+20>>2]|0)+x|0;c[v>>2]=u;c[w>>2]=y;z=x;A=y;B=u;C=0;break}else if(q){c[o>>2]=y;q=y+1|0;c[v>>2]=q;u=(c[d+20>>2]|0)+y|0;c[w>>2]=u;z=y;A=u;B=q;C=0;break}else{q=c[d+20>>2]|0;u=y+1|0;x=q+u|0;c[o>>2]=x;s=q+y|0;c[v>>2]=s;c[w>>2]=u;z=x;A=u;B=s;C=0;break}}while(0);do if(j)if(C){O7a(d,k,z,A,B,j+8|0,j+4|0,j);break}else{O7a(d,k,z,B,A,j,j+4|0,j+8|0);break}while(0);if(h){c[h>>2]=z;c[h+4>>2]=B;c[h+8>>2]=A}h=c[r>>2]|0;r=c[h+20>>2]|0;j=c[h+36>>2]|0;h=c[p>>2]|0;p=h+12|0;d=h+8|0;C=h+16|0;a:do if(!m)if(l){h=e+16|0;t=e+20|0;s=e+24|0;D=ea(((z>>>0)/(r>>>0)|0)>>>0);E=ea(b[j+(z<<2)>>1]|0);F=ea(((z>>>0)%(r>>>0)|0)>>>0);G=ea(D*ea(g[p>>2]));D=ea(E*ea(g[d>>2]));E=ea(F*ea(g[C>>2]));F=ea(G+ea(g[h>>2]));G=ea(D+ea(g[t>>2]));D=ea(E+ea(g[s>>2]));g[f>>2]=F;g[f+4>>2]=G;g[f+8>>2]=D;D=ea(((B>>>0)/(r>>>0)|0)>>>0);G=ea(b[j+(B<<2)>>1]|0);F=ea(((B>>>0)%(r>>>0)|0)>>>0);E=ea(D*ea(g[p>>2]));D=ea(G*ea(g[d>>2]));G=ea(F*ea(g[C>>2]));F=ea(E+ea(g[h>>2]));E=ea(D+ea(g[t>>2]));D=ea(G+ea(g[s>>2]));g[f+12>>2]=F;g[f+16>>2]=E;g[f+20>>2]=D;D=ea(((A>>>0)/(r>>>0)|0)>>>0);E=ea(b[j+(A<<2)>>1]|0);F=ea(((A>>>0)%(r>>>0)|0)>>>0);G=ea(D*ea(g[p>>2]));D=ea(E*ea(g[d>>2]));E=ea(F*ea(g[C>>2]));F=ea(G+ea(g[h>>2]));G=ea(D+ea(g[t>>2]));D=ea(E+ea(g[s>>2]));g[f+24>>2]=F;g[f+28>>2]=G;g[f+32>>2]=D;break}else{D=ea(((z>>>0)/(r>>>0)|0)>>>0);G=ea(b[j+(z<<2)>>1]|0);F=ea(((z>>>0)%(r>>>0)|0)>>>0);E=ea(D*ea(g[p>>2]));D=ea(G*ea(g[d>>2]));G=ea(F*ea(g[C>>2]));g[f>>2]=E;g[f+4>>2]=D;g[f+8>>2]=G;G=ea(((B>>>0)/(r>>>0)|0)>>>0);D=ea(b[j+(B<<2)>>1]|0);E=ea(((B>>>0)%(r>>>0)|0)>>>0);F=ea(G*ea(g[p>>2]));G=ea(D*ea(g[d>>2]));D=ea(E*ea(g[C>>2]));g[f+12>>2]=F;g[f+16>>2]=G;g[f+20>>2]=D;D=ea(((A>>>0)/(r>>>0)|0)>>>0);G=ea(b[j+(A<<2)>>1]|0);F=ea(((A>>>0)%(r>>>0)|0)>>>0);E=ea(D*ea(g[p>>2]));D=ea(G*ea(g[d>>2]));G=ea(F*ea(g[C>>2]));g[f+24>>2]=E;g[f+28>>2]=D;g[f+32>>2]=G;break}else{s=e+12|0;t=e+4|0;h=e+8|0;if(!l){u=z;x=0;while(1){G=ea(((u>>>0)/(r>>>0)|0)>>>0);D=ea(b[j+(u<<2)>>1]|0);E=ea(((u>>>0)%(r>>>0)|0)>>>0);F=ea(G*ea(g[p>>2]));G=ea(D*ea(g[d>>2]));D=ea(F*ea(2.0));F=ea(G*ea(2.0));G=ea(ea(E*ea(g[C>>2]))*ea(2.0));E=ea(g[s>>2]);H=ea(ea(E*E)+ea(-.5));I=ea(g[e>>2]);J=ea(D*I);K=ea(g[t>>2]);L=ea(J+ea(F*K));J=ea(g[h>>2]);M=ea(L+ea(G*J));L=ea(ea(K*M)+ea(ea(F*H)+ea(E*ea(ea(D*J)-ea(G*I)))));N=ea(ea(ea(G*H)+ea(E*ea(ea(F*I)-ea(D*K))))+ea(J*M));g[f+(x*12|0)>>2]=ea(ea(I*M)+ea(ea(D*H)+ea(E*ea(ea(G*K)-ea(F*J)))));g[f+(x*12|0)+4>>2]=L;g[f+(x*12|0)+8>>2]=N;w=x+1|0;if((w|0)==3)break a;u=c[o+(w<<2)>>2]|0;x=w}}x=e+16|0;u=e+20|0;w=e+24|0;v=z;y=0;while(1){N=ea(((v>>>0)/(r>>>0)|0)>>>0);L=ea(b[j+(v<<2)>>1]|0);J=ea(((v>>>0)%(r>>>0)|0)>>>0);F=ea(N*ea(g[p>>2]));N=ea(L*ea(g[d>>2]));L=ea(F*ea(2.0));F=ea(N*ea(2.0));N=ea(ea(J*ea(g[C>>2]))*ea(2.0));J=ea(g[s>>2]);K=ea(ea(J*J)+ea(-.5));G=ea(g[e>>2]);E=ea(L*G);H=ea(g[t>>2]);D=ea(E+ea(F*H));E=ea(g[h>>2]);M=ea(D+ea(N*E));D=ea(ea(G*M)+ea(ea(L*K)+ea(J*ea(ea(N*H)-ea(F*E)))));I=ea(ea(H*M)+ea(ea(F*K)+ea(J*ea(ea(L*E)-ea(N*G)))));O=ea(ea(ea(N*K)+ea(J*ea(ea(F*G)-ea(L*H))))+ea(E*M));M=ea(ea(g[x>>2])+D);D=ea(ea(g[u>>2])+I);I=ea(ea(g[w>>2])+O);g[f+(y*12|0)>>2]=M;g[f+(y*12|0)+4>>2]=D;g[f+(y*12|0)+8>>2]=I;q=y+1|0;if((q|0)==3)break a;v=c[o+(q<<2)>>2]|0;y=q}}while(0);o=k>>>1;if(!(k&1)){P=j+(o<<2)+2|0;Q=a[P>>0]|0;R=Q&127;S=R<<24>>24!=127;T=S&1;i=n;return T|0}else{P=j+(o<<2)+3|0;Q=a[P>>0]|0;R=Q&127;S=R<<24>>24!=127;T=S&1;i=n;return T|0}return 0}function MRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+160|0;e=d+16|0;f=d+12|0;h=d;j=c[a+12>>2]|0;k=ea(g[b>>2]);l=b+8|0;m=ea(g[l>>2]);n=ea(g[a>>2]);o=ea(k*n);p=a+8|0;q=ea(g[p>>2]);r=ea(m*q);do if((!(!(o>=ea(0.0))|!(r>=ea(0.0)))?o<ea(ea(g[j+24>>2])+ea(1.0)):0)?r<ea(ea(g[j+28>>2])+ea(1.0)):0){s=ea(g[(c[a+16>>2]|0)+8>>2]);t=xRa(j,o,r,e,f)|0;u=ea(g[e>>2]);v=ea(s*ea(t1a(j,t,u,ea(g[f>>2]))));u=ea(ea(g[b+4>>2])-v);v=ea(g[j+40>>2]);if(!(v<=ea(0.0))|!(u<=ea(0.0))|!(v<=u)?!(v>ea(0.0)&u>ea(-0.0)&v>u):0){u=ea(g[b>>2]);v=ea(g[a>>2]);s=ea(g[l>>2]);w=u;x=v;y=s;z=ea(g[p>>2]);break}s=ea(g[b>>2]);A=(ARa(a,s,ea(g[l>>2]))|0)!=-1;i=d;return A|0}else{w=k;x=n;y=m;z=q}while(0);q=ea(g[b+12>>2]);m=ea(q*q);n=ea(w*x);p=b+4|0;w=ea(y*z);y=ea(q*ea(S(ea(x))));x=ea(q*ea(S(ea(z))));f=~~ea(R(ea(n-y)));t=c[j+16>>2]|0;B=t+-2|0;C=(f|0)>0?f:0;f=(C|0)>(B|0)?B:C;C=~~ea(ca(ea(n+y)));B=t+-1|0;t=(C|0)>0?C:0;C=(t|0)>(B|0)?B:t;t=~~ea(R(ea(w-x)));B=c[j+20>>2]|0;j=B+-2|0;D=(t|0)>0?t:0;t=(D|0)>(j|0)?j:D;D=~~ea(ca(ea(w+x)));j=B+-1|0;B=(D|0)>0?D:0;D=(B|0)>(j|0)?j:B;if(f>>>0>=C>>>0){A=0;i=d;return A|0}B=h+4|0;j=h+8|0;if(t>>>0<D>>>0)E=f;else{F=f;do F=F+1|0;while(F>>>0<C>>>0);A=0;i=d;return A|0}a:while(1){F=t;do{g[h>>2]=ea(g[b>>2]);g[B>>2]=ea(g[p>>2]);g[j>>2]=ea(g[l>>2]);f=DRa(a,E,F,h,e,0,1,1,1)|0;if(f){x=ea(g[b>>2]);w=ea(g[p>>2]);y=ea(g[l>>2]);G=0;do{n=ea(x-ea(g[e+(G*12|0)>>2]));z=ea(w-ea(g[e+(G*12|0)+4>>2]));q=ea(y-ea(g[e+(G*12|0)+8>>2]));G=G+1|0;if(!(ea(ea(ea(n*n)+ea(z*z))+ea(q*q))>m)){A=1;H=18;break a}}while(G>>>0<f>>>0)}F=F+1|0}while(F>>>0<D>>>0);E=E+1|0;if(E>>>0>=C>>>0){A=0;H=18;break}}if((H|0)==18){i=d;return A|0}return 0}function NRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=0,C=0,D=0,E=Im,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;d=i;i=i+256|0;e=d+100|0;f=d+56|0;h=d+16|0;j=d+40|0;k=d+232|0;l=d;m=d+52|0;n=d+96|0;o=d+72|0;p=a+12|0;q=c[p>>2]|0;r=ea(g[b+24>>2]);s=ea(g[a>>2]);t=ea(S(ea(s)));u=a+8|0;v=ea(g[u>>2]);w=ea(r*t);t=ea(r*ea(S(ea(v))));x=ea(g[b>>2]);g[h>>2]=x;y=b+4|0;g[h+4>>2]=ea(g[y>>2]);z=b+8|0;A=ea(g[z>>2]);g[h+8>>2]=A;B=b+12|0;g[h+12>>2]=ea(g[B>>2]);C=b+16|0;g[h+16>>2]=ea(g[C>>2]);D=b+20|0;g[h+20>>2]=ea(g[D>>2]);E=ea(r*r);F=q+16|0;G=q+20|0;H=a+16|0;I=q+40|0;q=j+4|0;J=j+8|0;r=x;x=s;s=A;A=v;K=0;L=0;M=-1;N=-1;O=0;a:while(1){v=ea(r*x);P=h+(O*12|0)+4|0;Q=ea(s*A);T=~~ea(R(ea(v-w)));U=c[F>>2]|0;V=U+-2|0;W=(T|0)>0?T:0;T=(W|0)>(V|0)?V:W;W=~~ea(ca(ea(w+v)));V=U+-1|0;U=(W|0)>0?W:0;W=(U|0)>(V|0)?V:U;U=~~ea(R(ea(Q-t)));V=c[G>>2]|0;X=V+-2|0;Y=(U|0)>0?U:0;U=(Y|0)>(X|0)?X:Y;Y=~~ea(ca(ea(t+Q)));X=V+-1|0;V=(Y|0)>0?Y:0;Y=(V|0)>(X|0)?X:V;Z=T>>>0<N>>>0?T:N;_=U>>>0<M>>>0?U:M;$=W>>>0>L>>>0?W:L;aa=Y>>>0>K>>>0?Y:K;do if((!(!(v>=ea(0.0))|!(Q>=ea(0.0)))?(V=c[p>>2]|0,v<ea(ea(g[V+24>>2])+ea(1.0))):0)?Q<ea(ea(g[V+28>>2])+ea(1.0)):0){ba=ea(g[(c[H>>2]|0)+8>>2]);X=xRa(V,v,Q,e,f)|0;fa=ea(g[e>>2]);ga=ea(ba*ea(t1a(V,X,fa,ea(g[f>>2]))));fa=ea(ea(g[P>>2])-ga);ga=ea(g[I>>2]);if(!(ga<=ea(0.0))|!(fa<=ea(0.0))|!(ga<=fa)?!(ga>ea(0.0)&fa>ea(-0.0)&ga>fa):0){ha=9;break}if((ARa(a,r,s)|0)!=-1){ia=1;ha=36;break a}}else ha=9;while(0);if((ha|0)==9?(ha=0,T>>>0<W>>>0):0){X=U>>>0<Y>>>0;V=T;do{if(X){Q=ea(g[P>>2]);ja=U;do{g[j>>2]=r;g[q>>2]=Q;g[J>>2]=s;ka=DRa(a,V,ja,j,e,0,1,1,1)|0;b:do if(ka){v=ea(g[I>>2]);la=v>ea(0.0);if(v<=ea(0.0)){ma=0;while(1){v=ea(r-ea(g[e+(ma*12|0)>>2]));fa=ea(Q-ea(g[e+(ma*12|0)+4>>2]));ga=ea(s-ea(g[e+(ma*12|0)+8>>2]));if(fa>ea(0.0)|la&fa<ea(0.0)?!(ea(ea(ea(v*v)+ea(fa*fa))+ea(ga*ga))>E):0){ia=1;ha=36;break a}ma=ma+1|0;if(ma>>>0>=ka>>>0)break b}}if(la)na=0;else{ma=0;while(1){ma=ma+1|0;if(ma>>>0>=ka>>>0)break b}}do{ga=ea(r-ea(g[e+(na*12|0)>>2]));fa=ea(Q-ea(g[e+(na*12|0)+4>>2]));v=ea(s-ea(g[e+(na*12|0)+8>>2]));if(fa<ea(0.0)?!(ea(ea(ea(ga*ga)+ea(fa*fa))+ea(v*v))>E):0){ia=1;ha=36;break a}na=na+1|0}while(na>>>0<ka>>>0)}while(0);ja=ja+1|0}while(ja>>>0<Y>>>0)}V=V+1|0}while(V>>>0<W>>>0)}W=O+1|0;if(W>>>0>=2){ha=2;break}Q=ea(g[h+(W*12|0)>>2]);v=ea(g[a>>2]);fa=ea(g[h+(W*12|0)+8>>2]);r=Q;x=v;s=fa;A=ea(g[u>>2]);K=aa;L=$;M=_;N=Z;O=W}if((ha|0)==2){if(Z>>>0>$>>>0){ia=0;i=d;return ia|0}O=_>>>0>aa>>>0;N=k+4|0;M=l+4|0;L=k+8|0;K=l+8|0;u=o+4|0;h=o+8|0;na=o+12|0;I=o+16|0;j=o+20|0;J=e+4|0;q=e+8|0;H=f+4|0;p=f+8|0;F=Z;c:while(1){if(!O){Z=(F|0)==($|0)?1:3;W=_;do{V=(da(c[G>>2]|0,F)|0)+W|0;Y=V*3|0;U=(W|0)==(aa|0)?2:0;if(U>>>0<Z>>>0){P=U;do{U=P+Y|0;if((IRa(a,U,V,F,W)|0)!=-1?(JRa(a,U,V,F,W,k,l),A=ea(g[k>>2]),s=ea(A+ea(g[l>>2])),x=ea(g[N>>2]),r=ea(x+ea(g[M>>2])),t=ea(g[L>>2]),w=ea(t+ea(g[K>>2])),g[o>>2]=A,g[u>>2]=x,g[h>>2]=t,g[na>>2]=s,g[I>>2]=r,g[j>>2]=w,fa=ea(g[B>>2]),v=ea(fa-ea(g[b>>2])),fa=ea(g[C>>2]),Q=ea(fa-ea(g[y>>2])),fa=ea(g[D>>2]),ga=ea(fa-ea(g[z>>2])),g[e>>2]=v,g[J>>2]=Q,g[q>>2]=ga,ga=ea(r-x),x=ea(w-t),g[f>>2]=ea(s-A),g[H>>2]=ga,g[p>>2]=x,ea(MOa(b,e,o,f,m,n))<E):0){ia=1;ha=36;break c}P=P+1|0}while(P>>>0<Z>>>0)}W=W+1|0}while(W>>>0<=aa>>>0)}F=F+1|0;if(F>>>0>$>>>0){ia=0;ha=36;break}}if((ha|0)==36){i=d;return ia|0}}else if((ha|0)==36){i=d;return ia|0}return 0}function ORa(e,f){e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=Im,I=0,J=Im,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=0,T=Im,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im;h=i;i=i+240|0;j=h+12|0;k=h+28|0;l=h+32|0;m=h+128|0;n=h;o=h+16|0;p=h+224|0;q=e+12|0;r=c[q>>2]|0;s=f+48|0;t=ea(g[s>>2]);u=f+52|0;v=ea(g[u>>2]);w=f+56|0;x=ea(g[w>>2]);y=0;do{z=y*3|0;A=ea(t*ea(g[543968+(z<<2)>>2]));B=ea(v*ea(g[543968+(z+1<<2)>>2]));C=ea(x*ea(g[543968+(z+2<<2)>>2]));g[l+(y*12|0)>>2]=A;g[l+(y*12|0)+4>>2]=B;g[l+(y*12|0)+8>>2]=C;y=y+1|0}while((y|0)!=8);x=ea(g[f>>2]);y=f+4|0;v=ea(g[y>>2]);z=f+8|0;t=ea(g[z>>2]);D=f+12|0;C=ea(g[D>>2]);E=f+16|0;B=ea(g[E>>2]);F=f+20|0;A=ea(g[F>>2]);G=f+24|0;H=ea(g[G>>2]);I=f+28|0;J=ea(g[I>>2]);K=f+32|0;L=ea(g[K>>2]);M=f+36|0;N=ea(g[M>>2]);O=f+40|0;P=ea(g[O>>2]);Q=f+44|0;T=ea(g[Q>>2]);U=0;do{V=ea(g[l+(U*12|0)>>2]);W=ea(V*x);X=ea(V*v);Y=ea(V*t);V=ea(g[l+(U*12|0)+4>>2]);Z=ea(W+ea(V*C));W=ea(X+ea(V*B));X=ea(Y+ea(V*A));V=ea(g[l+(U*12|0)+8>>2]);Y=ea(ea(W+ea(V*J))+P);W=ea(ea(X+ea(V*L))+T);g[m+(U*12|0)>>2]=ea(ea(Z+ea(V*H))+N);g[m+(U*12|0)+4>>2]=Y;g[m+(U*12|0)+8>>2]=W;U=U+1|0}while((U|0)!=8);U=e+8|0;l=e+16|0;_=r+40|0;$=0;a:do{aa=m+($*12|0)|0;N=ea(g[aa>>2]);ba=m+($*12|0)+8|0;H=ea(g[ba>>2]);T=ea(N*ea(g[e>>2]));N=ea(H*ea(g[U>>2]));do if((!(!(T>=ea(0.0))|!(N>=ea(0.0)))?(fa=c[q>>2]|0,T<ea(ea(g[fa+24>>2])+ea(1.0))):0)?N<ea(ea(g[fa+28>>2])+ea(1.0)):0){H=ea(g[(c[l>>2]|0)+8>>2]);ga=xRa(fa,T,N,j,k)|0;L=ea(g[j>>2]);P=ea(H*ea(t1a(fa,ga,L,ea(g[k>>2]))));L=ea(ea(g[m+($*12|0)+4>>2])-P);P=ea(g[_>>2]);if(!(P<=ea(0.0))|!(L<=ea(0.0))|!(P<=L)?!(P>ea(0.0)&L>ea(-0.0)&P>L):0)break;L=ea(g[aa>>2]);if((ARa(e,L,ea(g[ba>>2]))|0)!=-1){ha=1;ia=26;break a}}while(0);$=$+1|0}while($>>>0<8);if((ia|0)==26){i=h;return ha|0}$=n+4|0;_=n+8|0;k=o+4|0;j=o+8|0;ba=0;do{aa=ba<<1;ga=d[544064+aa>>0]|0;g[n>>2]=ea(g[m+(ga*12|0)>>2]);g[$>>2]=ea(g[m+(ga*12|0)+4>>2]);g[_>>2]=ea(g[m+(ga*12|0)+8>>2]);ga=d[544064+(aa|1)>>0]|0;g[o>>2]=ea(g[m+(ga*12|0)>>2]);g[k>>2]=ea(g[m+(ga*12|0)+4>>2]);g[j>>2]=ea(g[m+(ga*12|0)+8>>2]);a[p>>0]=0;P7a(e,n,o,p,0);ba=ba+1|0;if(a[p>>0]|0){ha=1;ia=26;break}}while(ba>>>0<12);if((ia|0)==26){i=h;return ha|0}N=ea(g[f>>2]);T=ea(g[y>>2]);L=ea(g[z>>2]);P=ea(g[D>>2]);H=ea(g[E>>2]);J=ea(g[F>>2]);A=ea(g[G>>2]);B=ea(g[I>>2]);C=ea(g[K>>2]);t=ea(g[M>>2]);v=ea(g[O>>2]);x=ea(-t);t=ea(-v);v=ea(-ea(g[Q>>2]));W=ea(T*t);Y=ea(L*v);V=ea(ea(ea(P*x)+ea(H*t))+ea(J*v));Z=ea(B*t);t=ea(C*v);v=ea(g[m>>2]);Q=v<ea(3402823469999999843913219.0e14);X=Q?v:ea(3402823469999999843913219.0e14);ja=ea(g[m+8>>2]);Q=ja<ea(3402823469999999843913219.0e14);ka=Q?ja:ea(3402823469999999843913219.0e14);Q=v>ea(-3402823469999999843913219.0e14);la=Q?v:ea(-3402823469999999843913219.0e14);Q=ja>ea(-3402823469999999843913219.0e14);v=Q?ja:ea(-3402823469999999843913219.0e14);ja=ea(g[m+12>>2]);ma=ja<X?ja:X;X=ea(g[m+20>>2]);na=X<ka?X:ka;ka=ja>la?ja:la;la=X>v?X:v;v=ea(g[m+24>>2]);X=v<ma?v:ma;ma=ea(g[m+32>>2]);ja=ma<na?ma:na;na=v>ka?v:ka;ka=ma>la?ma:la;la=ea(g[m+36>>2]);ma=la<X?la:X;X=ea(g[m+44>>2]);v=X<ja?X:ja;ja=la>na?la:na;na=X>ka?X:ka;ka=ea(g[m+48>>2]);X=ka<ma?ka:ma;ma=ea(g[m+56>>2]);la=ma<v?ma:v;v=ka>ja?ka:ja;ja=ma>na?ma:na;na=ea(g[m+60>>2]);ma=na<X?na:X;X=ea(g[m+68>>2]);ka=X<la?X:la;la=na>v?na:v;v=X>ja?X:ja;ja=ea(g[m+72>>2]);X=ja<ma?ja:ma;ma=ea(g[m+80>>2]);na=ma<ka?ma:ka;ka=ja>la?ja:la;la=ma>v?ma:v;v=ea(g[m+84>>2]);ma=ea(g[m+92>>2]);ja=ea(ea(ea(N*x)+W)+Y);Y=ea(ea(ea(A*x)+Z)+t);t=ea(g[e>>2]);Z=ea(g[U>>2]);U=~~ea(R(ea((v<X?v:X)*t)));e=c[r+16>>2]|0;m=e+-2|0;Q=(U|0)>0?U:0;U=(Q|0)>(m|0)?m:Q;Q=~~ea(ca(ea((v>ka?v:ka)*t)));m=e+-1|0;e=(Q|0)>0?Q:0;Q=(e|0)>(m|0)?m:e;e=~~ea(R(ea((ma<na?ma:na)*Z)));m=c[r+20>>2]|0;O=m+-2|0;M=(e|0)>0?e:0;e=(M|0)>(O|0)?O:M;M=~~ea(ca(ea((ma>la?ma:la)*Z)));O=m+-1|0;K=(M|0)>0?M:0;M=(K|0)>(O|0)?O:K;if(U>>>0>Q>>>0){ha=0;i=h;return ha|0}K=e>>>0>M>>>0;O=r+36|0;r=U;b:while(1){if(!K){U=da(m,r)|0;I=c[(c[q>>2]|0)+36>>2]|0;Z=ea(r>>>0);G=e;do{F=U+G|0;if((((a[I+(F<<2)+3>>0]|0)<0?(E=c[l>>2]|0,la=ea(Z*ea(g[E+12>>2])),ma=ea(g[E+8>>2]),na=ea(ma*ea(b[(c[O>>2]|0)+(F<<2)>>1]|0)),ma=ea(ea(G>>>0)*ea(g[E+16>>2])),t=ea(Y+ea(ea(C*ma)+ea(ea(A*la)+ea(B*na)))),ka=ea(S(ea(ja+ea(ea(L*ma)+ea(ea(N*la)+ea(T*na)))))),ea(ka-ea(g[s>>2]))<ea(0.0)):0)?(ka=ea(S(ea(V+ea(ea(J*ma)+ea(ea(P*la)+ea(H*na)))))),ea(ka-ea(g[u>>2]))<ea(0.0)):0)?(ka=ea(S(ea(t))),ea(ka-ea(g[w>>2]))<ea(0.0)):0){ha=1;ia=26;break b}G=G+1|0}while(G>>>0<=M>>>0)}r=r+1|0;if(r>>>0>Q>>>0){ha=0;ia=26;break}}if((ia|0)==26){i=h;return ha|0}return 0}function PRa(f,h,j,k,l){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=Im,Ka=Im,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;m=i;i=i+192|0;n=m+56|0;o=m+48|0;p=m+24|0;q=m+12|0;r=m;s=m+184|0;t=ea(g[h>>2]);u=ea(t+t);v=ea(g[h+4>>2]);w=ea(v+v);x=ea(g[h+8>>2]);y=ea(x+x);z=ea(g[h+12>>2]);A=ea(u*z);B=ea(w*z);C=ea(z*y);z=ea(t*w);D=ea(t*y);E=ea(v*w);w=ea(v*y);v=ea(x*y);y=ea(ea(ea(1.0)-E)-v);x=ea(z+C);F=ea(D-B);G=ea(z-C);C=ea(ea(1.0)-ea(t*u));u=ea(C-v);v=ea(w+A);t=ea(D+B);B=ea(w-A);A=ea(C-E);E=ea(g[h+16>>2]);C=ea(g[h+20>>2]);w=ea(g[h+24>>2]);D=ea(g[k>>2]);z=ea(D+D);H=ea(g[k+4>>2]);I=ea(H+H);J=ea(g[k+8>>2]);K=ea(J+J);L=ea(g[k+12>>2]);M=ea(z*L);N=ea(I*L);O=ea(L*K);L=ea(D*I);P=ea(D*K);Q=ea(H*I);I=ea(H*K);H=ea(J*K);K=ea(ea(ea(1.0)-Q)-H);J=ea(L+O);S=ea(P-N);T=ea(L-O);O=ea(ea(1.0)-ea(D*z));z=ea(O-H);H=ea(I+M);D=ea(P+N);N=ea(I-M);M=ea(O-Q);Q=ea(g[k+16>>2]);O=ea(g[k+20>>2]);I=ea(g[k+24>>2]);P=ea(g[l+12>>2]);L=ea(g[l+16>>2]);U=ea(g[l+20>>2]);V=ea(g[l+24>>2]);W=ea(P+P);X=ea(L+L);Y=ea(U+U);Z=ea(L*X);_=ea(U*Y);$=ea(W*L);L=ea(W*U);aa=ea(W*V);ba=ea(X*U);U=ea(X*V);X=ea(Y*V);V=ea(ea(ea(1.0)-Z)-_);Y=ea($+X);fa=ea(L-U);ga=ea($-X);X=ea(ea(1.0)-ea(P*W));W=ea(X-_);_=ea(ba+aa);P=ea(L+U);U=ea(ba-aa);aa=ea(X-Z);Z=ea(g[l>>2]);X=ea(Z*V);ba=ea(Z*ga);L=ea(Z*P);Z=ea(g[l+4>>2]);$=ea(Y*Z);ha=ea(W*Z);ia=ea(U*Z);Z=ea(g[l+8>>2]);ja=ea(fa*Z);ka=ea(_*Z);la=ea(aa*Z);Z=ea(ea(ea(V*X)+ea(Y*$))+ea(fa*ja));ma=ea(ea(ea(V*ba)+ea(Y*ha))+ea(fa*ka));na=ea(ea(ea(V*L)+ea(Y*ia))+ea(fa*la));fa=ea(ea(ea(ga*X)+ea(W*$))+ea(_*ja));Y=ea(ea(ea(ga*ba)+ea(W*ha))+ea(_*ka));V=ea(ea(ea(ga*L)+ea(W*ia))+ea(_*la));_=ea(ea(ea(P*X)+ea(U*$))+ea(aa*ja));ja=ea(ea(ea(P*ba)+ea(U*ha))+ea(aa*ka));ka=ea(ea(ea(P*L)+ea(U*ia))+ea(aa*la));la=ea(ea(D*na)+ea(ea(K*Z)+ea(T*ma)));aa=ea(ea(N*na)+ea(ea(J*Z)+ea(z*ma)));ia=ea(ea(M*na)+ea(ea(S*Z)+ea(H*ma)));U=ea(ea(D*V)+ea(ea(K*fa)+ea(T*Y)));L=ea(ea(N*V)+ea(ea(J*fa)+ea(z*Y)));P=ea(ea(M*V)+ea(ea(S*fa)+ea(H*Y)));ha=ea(ea(D*ka)+ea(ea(K*_)+ea(T*ja)));ba=ea(ea(N*ka)+ea(ea(J*_)+ea(z*ja)));$=ea(ea(M*ka)+ea(ea(S*_)+ea(H*ja)));X=ea(ea(Q+ea(ea(D*ea(0.0))+ea(ea(K*ea(0.0))+ea(T*ea(0.0)))))-E);W=ea(ea(O+ea(ea(N*ea(0.0))+ea(ea(J*ea(0.0))+ea(z*ea(0.0)))))-C);ga=ea(ea(I+ea(ea(M*ea(0.0))+ea(ea(S*ea(0.0))+ea(H*ea(0.0)))))-w);oa=ea(ea(F*ga)+ea(ea(y*X)+ea(x*W)));pa=ea(ea(v*ga)+ea(ea(G*X)+ea(u*W)));qa=ea(ea(A*ga)+ea(ea(t*X)+ea(B*W)));W=ea(ea(F*ia)+ea(ea(y*la)+ea(x*aa)));X=ea(ea(v*ia)+ea(ea(G*la)+ea(u*aa)));ga=ea(ea(A*ia)+ea(ea(t*la)+ea(B*aa)));aa=ea(ea(F*P)+ea(ea(y*U)+ea(x*L)));la=ea(ea(v*P)+ea(ea(G*U)+ea(u*L)));ia=ea(ea(A*P)+ea(ea(t*U)+ea(B*L)));L=ea(ea(F*$)+ea(ea(y*ha)+ea(x*ba)));U=ea(ea(v*$)+ea(ea(G*ha)+ea(u*ba)));P=ea(ea(A*$)+ea(ea(t*ha)+ea(B*ba)));l=j+54|0;k=a[l>>0]|0;h=k&255;ra=i;i=i+((1*(h*12|0)|0)+15&-16)|0;sa=j+56|0;ta=j+55|0;ua=(c[sa>>2]|0)+((d[ta>>0]|0)*20|0)|0;if(k<<24>>24){k=0;do{ba=ea(g[ua+(k*12|0)>>2]);ha=ea(W*ba);$=ea(X*ba);va=ea(ga*ba);ba=ea(g[ua+(k*12|0)+4>>2]);wa=ea(ha+ea(aa*ba));ha=ea($+ea(la*ba));$=ea(va+ea(ia*ba));ba=ea(g[ua+(k*12|0)+8>>2]);va=ea(pa+ea(ha+ea(U*ba)));ha=ea(qa+ea($+ea(P*ba)));g[ra+(k*12|0)>>2]=ea(oa+ea(wa+ea(L*ba)));g[ra+(k*12|0)+4>>2]=va;g[ra+(k*12|0)+8>>2]=ha;k=k+1|0}while(k>>>0<h>>>0)}vLa(p,h,ra);h=f+12|0;k=c[h>>2]|0;ua=k+40|0;L=ea(g[ua>>2]);xa=L<=ea(0.0);oa=xa?ea(-3402823469999999843913219.0e14):ea(3402823469999999843913219.0e14);P=ea(g[f>>2]);xa=f+8|0;qa=ea(g[xa>>2]);U=ea(ea(1.0)/P);pa=ea(ea(1.0)/qa);ia=ea(ea(1.0)/ea(g[f+4>>2]));if(P>ea(0.0)){ya=~~ea(R(ea(P*ea(g[p>>2]))));za=c[k+16>>2]|0;Aa=za+-2|0;Ba=(ya|0)>0?ya:0;ya=~~ea(ca(ea(P*ea(g[p+12>>2]))));Ca=za+-1|0;za=(ya|0)>0?ya:0;Da=(za|0)>(Ca|0)?Ca:za;Ea=(Ba|0)>(Aa|0)?Aa:Ba}else{Ba=~~ea(R(ea(P*ea(g[p+12>>2]))));Aa=c[k+16>>2]|0;za=Aa+-2|0;Ca=(Ba|0)>0?Ba:0;Ba=~~ea(ca(ea(P*ea(g[p>>2]))));ya=Aa+-1|0;Aa=(Ba|0)>0?Ba:0;Da=(Aa|0)>(ya|0)?ya:Aa;Ea=(Ca|0)>(za|0)?za:Ca}if(qa>ea(0.0)){Ca=~~ea(R(ea(qa*ea(g[p+8>>2]))));za=c[k+20>>2]|0;Aa=za+-2|0;ya=(Ca|0)>0?Ca:0;Ca=~~ea(ca(ea(qa*ea(g[p+20>>2]))));Ba=za+-1|0;Fa=(Ca|0)>0?Ca:0;Ga=za;Ha=(Fa|0)>(Ba|0)?Ba:Fa;Ia=(ya|0)>(Aa|0)?Aa:ya}else{ya=~~ea(R(ea(qa*ea(g[p+20>>2]))));Aa=c[k+20>>2]|0;Fa=Aa+-2|0;Ba=(ya|0)>0?ya:0;ya=~~ea(ca(ea(qa*ea(g[p+8>>2]))));za=Aa+-1|0;Ca=(ya|0)>0?ya:0;Ga=Aa;Ha=(Ca|0)>(za|0)?za:Ca;Ia=(Ba|0)>(Fa|0)?Fa:Ba}Ba=Ea>>>0>Da>>>0;if(Ba)Ja=oa;else{Fa=Ia>>>0>Ha>>>0;Ca=k+36|0;qa=oa;za=Ea;while(1){if(Fa)Ka=qa;else{Aa=da(Ga,za)|0;ya=c[Ca>>2]|0;La=!(L<=ea(0.0));Ma=Ia;oa=qa;while(1){P=ea(b[ya+(Aa+Ma<<2)>>1]|0);if(La)Na=oa<P;else Na=oa>P;la=Na?oa:P;Ma=Ma+1|0;if(Ma>>>0>Ha>>>0){Ka=la;break}else oa=la}}za=za+1|0;if(za>>>0>Da>>>0){Ja=Ka;break}else qa=Ka}}Ka=ea(ia*Ja);if(!(L<=ea(0.0))){if(ea(g[p+16>>2])<Ka){Oa=0;i=m;return Oa|0}}else if(ea(g[p+4>>2])>Ka){Oa=0;i=m;return Oa|0}a:do if(!(a[l>>0]|0))Pa=0;else{p=f+16|0;Ja=L;za=0;b:while(1){Na=!(Ja<=ea(0.0));Ca=ra+(za*12|0)+4|0;qa=ea(g[Ca>>2]);if(Na){if(qa>Ka)Qa=26}else if(qa<Ka)Qa=26;do if((((Qa|0)==26?(Qa=0,Na=ra+(za*12|0)|0,qa=ea(g[Na>>2]),Ga=ra+(za*12|0)+8|0,oa=ea(g[Ga>>2]),la=ea(qa*ea(g[f>>2])),qa=ea(oa*ea(g[xa>>2])),!(!(la>=ea(0.0))|!(qa>=ea(0.0)))):0)?(Fa=c[h>>2]|0,la<ea(ea(g[Fa+24>>2])+ea(1.0))):0)?qa<ea(ea(g[Fa+28>>2])+ea(1.0)):0){oa=ea(g[(c[p>>2]|0)+8>>2]);Ma=xRa(Fa,la,qa,n,o)|0;qa=ea(g[n>>2]);la=ea(oa*ea(t1a(Fa,Ma,qa,ea(g[o>>2]))));qa=ea(ea(g[Ca>>2])-la);la=ea(g[ua>>2]);if(!(la<=ea(0.0))|!(qa<=ea(0.0))|!(la<=qa)?!(la>ea(0.0)&qa>ea(-0.0)&la>qa):0)break;qa=ea(g[Na>>2]);if((ARa(f,qa,ea(g[Ga>>2]))|0)!=-1){Oa=1;break b}}while(0);Ca=za+1|0;Ga=a[l>>0]|0;if(Ca>>>0>=(Ga&255)>>>0){Pa=Ga;break a}Ja=ea(g[ua>>2]);za=Ca}i=m;return Oa|0}while(0);l=n+0|0;o=l+128|0;do{b[l>>1]=0;l=l+2|0}while((l|0)<(o|0));l=a[ta>>0]|0;o=l&255;xa=c[sa>>2]|0;za=xa+(o*20|0)|0;p=(e[j+52>>1]<<1)+((Pa&255)*15|0)|0;c:do if(l<<24>>24){Pa=q+4|0;j=q+8|0;Ca=r+4|0;Ga=r+8|0;Na=o;Ma=xa;d:while(1){Na=Na+-1|0;Fa=d[Ma+18>>0]|0;La=(e[Ma+16>>1]|0)+p|0;Ma=Ma+20|0;Aa=Fa+-1|0;ya=0;Ra=Fa;e:while(1){Fa=za+(La+Aa)|0;Sa=za+(La+ya)|0;Ta=Ra;do{Ua=Ta;Ta=Ta+-1|0;if(!Ua)break e;Ua=a[Fa>>0]|0;Va=a[Sa>>0]|0;Wa=(Va&255)<(Ua&255);Xa=(Wa?Va:Ua)&255;Ya=(Wa?Ua:Va)&255;Za=Xa<<8|Ya;Va=Za+~(Za<<15)|0;Ua=(Va>>>10^Va)*9|0;Va=Ua>>>6^Ua;Ua=Va+~(Va<<11)|0;_a=n+(((Ua>>>16^Ua)&63)<<1)|0}while((e[_a>>1]|0)==(Za|0));b[_a>>1]=Za;Sa=ya+1|0;Fa=!(ea(g[ua>>2])<=ea(0.0));L=ea(g[ra+(Xa*12|0)+4>>2]);if(Fa){if(L<Ka?ea(g[ra+(Ya*12|0)+4>>2])<Ka:0){$a=ya;ya=Sa;Ra=Ta;Aa=$a;continue}}else if(L>Ka?ea(g[ra+(Ya*12|0)+4>>2])>Ka:0){$a=ya;ya=Sa;Ra=Ta;Aa=$a;continue}g[q>>2]=ea(g[ra+(Xa*12|0)>>2]);g[Pa>>2]=L;g[j>>2]=ea(g[ra+(Xa*12|0)+8>>2]);g[r>>2]=ea(g[ra+(Ya*12|0)>>2]);g[Ca>>2]=ea(g[ra+(Ya*12|0)+4>>2]);g[Ga>>2]=ea(g[ra+(Ya*12|0)+8>>2]);a[s>>0]=0;P7a(f,q,r,s,0);if(!(a[s>>0]|0)){$a=ya;ya=Sa;Ra=Ta;Aa=$a}else{Oa=1;break d}}if(!Na)break c}i=m;return Oa|0}while(0);Ka=ea(E-Q);Q=ea(C-O);O=ea(w-I);I=ea(ea(ea(Ka*K)+ea(J*Q))+ea(S*O));w=ea(ea(ea(Ka*T)+ea(z*Q))+ea(H*O));C=ea(ea(ea(Ka*D)+ea(N*Q))+ea(M*O));O=ea(ea(F*S)+ea(ea(y*K)+ea(x*J)));Q=ea(ea(F*H)+ea(ea(y*T)+ea(x*z)));Ka=ea(ea(F*M)+ea(ea(y*D)+ea(x*N)));x=ea(ea(v*S)+ea(ea(G*K)+ea(u*J)));y=ea(ea(v*H)+ea(ea(G*T)+ea(u*z)));F=ea(ea(v*M)+ea(ea(G*D)+ea(u*N)));u=ea(ea(A*S)+ea(ea(t*K)+ea(B*J)));J=ea(ea(A*H)+ea(ea(t*T)+ea(B*z)));z=ea(ea(A*M)+ea(ea(t*D)+ea(B*N)));N=ea(ea(Ka*_)+ea(ea(O*Z)+ea(Q*fa)));B=ea(ea(Ka*ja)+ea(ea(O*ma)+ea(Q*Y)));D=ea(ea(Ka*ka)+ea(ea(O*na)+ea(Q*V)));Q=ea(ea(F*_)+ea(ea(x*Z)+ea(y*fa)));O=ea(ea(F*ja)+ea(ea(x*ma)+ea(y*Y)));Ka=ea(ea(F*ka)+ea(ea(x*na)+ea(y*V)));y=ea(ea(z*_)+ea(ea(u*Z)+ea(J*fa)));x=ea(ea(z*ja)+ea(ea(u*ma)+ea(J*Y)));F=ea(ea(z*ka)+ea(ea(u*na)+ea(J*V)));J=ea(ea(ea(C*_)+ea(ea(I*Z)+ea(w*fa)))+ea(0.0));fa=ea(ea(ea(C*ja)+ea(ea(I*ma)+ea(w*Y)))+ea(0.0));Y=ea(ea(ea(C*ka)+ea(ea(I*na)+ea(w*V)))+ea(0.0));if(Ba){Oa=0;i=m;return Oa|0}Ba=Ia>>>0>Ha>>>0;$a=k+20|0;s=k+36|0;k=Ea;f:while(1){if(!Ba){Ea=da(c[$a>>2]|0,k)|0;r=c[(c[h>>2]|0)+36>>2]|0;V=ea(U*ea(k>>>0));w=ea(N*V);na=ea(B*V);I=ea(D*V);q=Ia;do{f=Ea+q|0;g:do if((a[r+(f<<2)+3>>0]|0)<0){V=ea(ia*ea(b[(c[s>>2]|0)+(f<<2)>>1]|0));ka=ea(pa*ea(q>>>0));C=ea(J+ea(ea(y*ka)+ea(w+ea(Q*V))));ma=ea(fa+ea(ea(x*ka)+ea(na+ea(O*V))));ja=ea(Y+ea(ea(F*ka)+ea(I+ea(Ka*V))));Ya=a[ta>>0]|0;if(!(Ya<<24>>24)){Oa=1;Qa=58;break f}ra=c[sa>>2]|0;Xa=0;while(1){V=ea(C*ea(g[ra+(Xa*20|0)>>2]));ka=ea(V+ea(ma*ea(g[ra+(Xa*20|0)+4>>2])));V=ea(ka+ea(ja*ea(g[ra+(Xa*20|0)+8>>2])));if(ea(ea(g[ra+(Xa*20|0)+12>>2])+V)>=ea(0.0))break g;Xa=Xa+1|0;if(Xa>>>0>=(Ya&255)>>>0){Oa=1;Qa=58;break f}}}while(0);q=q+1|0}while(q>>>0<=Ha>>>0)}k=k+1|0;if(k>>>0>Da>>>0){Oa=0;Qa=58;break}}if((Qa|0)==58){i=m;return Oa|0}return 0}function QRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;e=i;i=i+80|0;f=e+20|0;h=e;j=ea(g[b+16>>2]);k=ea(g[b+20>>2]);l=ea(j*ea(-2.0));j=ea(k*ea(-2.0));k=ea(ea(g[b+24>>2])*ea(-2.0));m=ea(g[b+12>>2]);n=ea(ea(m*m)+ea(-.5));o=ea(g[b>>2]);p=ea(l*o);q=ea(g[b+4>>2]);r=ea(p+ea(j*q));p=ea(g[b+8>>2]);s=ea(r+ea(k*p));r=ea(ea(o*s)+ea(ea(l*n)-ea(m*ea(ea(k*q)-ea(j*p)))));t=ea(ea(q*s)+ea(ea(j*n)-ea(m*ea(ea(l*p)-ea(k*o)))));u=ea(ea(ea(k*n)-ea(m*ea(ea(j*o)-ea(l*q))))+ea(p*s));s=ea(-o);l=ea(-q);j=ea(-p);n=ea(s-o);o=ea(l-q);q=ea(j-p);p=ea(m*n);k=ea(m*o);v=ea(m*q);m=ea(o*s);w=ea(q*s);x=ea(o*l);o=ea(q*l);l=ea(q*j);j=ea(ea(ea(1.0)-x)-l);q=ea(m+v);y=ea(w-k);z=ea(m-v);v=ea(ea(1.0)-ea(n*s));s=ea(v-l);l=ea(p+o);n=ea(k+w);w=ea(o-p);p=ea(v-x);x=ea(g[d+36>>2]);v=ea(x*j);o=ea(x*q);k=ea(x*y);x=ea(g[d+40>>2]);m=ea(v+ea(x*z));v=ea(o+ea(x*s));o=ea(k+ea(x*l));x=ea(g[d+44>>2]);k=ea(r+ea(ea(x*n)+m));m=ea(t+ea(ea(x*w)+v));v=ea(u+ea(ea(p*x)+o));o=ea(g[d>>2]);x=ea(j*o);u=ea(q*o);t=ea(y*o);o=ea(g[d+4>>2]);r=ea(x+ea(z*o));x=ea(u+ea(s*o));u=ea(t+ea(l*o));o=ea(g[d+8>>2]);t=ea(r+ea(n*o));r=ea(x+ea(w*o));x=ea(u+ea(p*o));o=ea(g[d+12>>2]);u=ea(j*o);A=ea(q*o);B=ea(y*o);o=ea(g[d+16>>2]);C=ea(u+ea(z*o));u=ea(A+ea(s*o));A=ea(B+ea(l*o));o=ea(g[d+20>>2]);B=ea(C+ea(n*o));C=ea(u+ea(w*o));u=ea(A+ea(p*o));o=ea(g[d+24>>2]);A=ea(j*o);j=ea(q*o);q=ea(y*o);o=ea(g[d+28>>2]);y=ea(A+ea(z*o));z=ea(j+ea(s*o));s=ea(q+ea(l*o));o=ea(g[d+32>>2]);l=ea(y+ea(n*o));n=ea(z+ea(w*o));w=ea(s+ea(p*o));g[f>>2]=t;g[f+4>>2]=r;g[f+8>>2]=x;g[f+12>>2]=B;g[f+16>>2]=C;g[f+20>>2]=u;g[f+24>>2]=l;g[f+28>>2]=n;g[f+32>>2]=w;g[f+36>>2]=k;g[f+40>>2]=m;g[f+44>>2]=v;g[f+48>>2]=ea(g[d+48>>2]);g[f+52>>2]=ea(g[d+52>>2]);g[f+56>>2]=ea(g[d+56>>2]);c[h+12>>2]=c[a+4>>2];c[h+16>>2]=a;g[h+4>>2]=ea(ea(1.0)/ea(g[a+8>>2]));g[h>>2]=ea(ea(1.0)/ea(g[a+12>>2]));g[h+8>>2]=ea(ea(1.0)/ea(g[a+16>>2]));a=ORa(h,f)|0;i=e;return a|0}function RRa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;f=i;i=i+48|0;h=f+24|0;j=f;k=ea(g[b+16>>2]);l=ea(k-ea(g[e+16>>2]));k=ea(g[b+20>>2]);m=ea(k-ea(g[e+20>>2]));k=ea(g[b+24>>2]);n=ea(l*ea(2.0));l=ea(m*ea(2.0));m=ea(ea(k-ea(g[e+24>>2]))*ea(2.0));k=ea(g[e+12>>2]);o=ea(ea(k*k)+ea(-.5));p=ea(g[e>>2]);q=ea(n*p);r=ea(g[e+4>>2]);s=ea(q+ea(l*r));q=ea(g[e+8>>2]);t=ea(s+ea(m*q));s=ea(ea(p*t)+ea(ea(n*o)-ea(k*ea(ea(m*r)-ea(l*q)))));u=ea(ea(r*t)+ea(ea(l*o)-ea(k*ea(ea(n*q)-ea(m*p)))));v=ea(ea(ea(m*o)-ea(k*ea(ea(l*p)-ea(n*r))))+ea(q*t));t=ea(g[a+4>>2]);g[h>>2]=s;g[h+4>>2]=u;g[h+8>>2]=v;g[h+12>>2]=t;c[j+12>>2]=c[d+4>>2];c[j+16>>2]=d;g[j+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[j>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[j+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));d=MRa(j,h)|0;i=f;return d|0}function SRa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function TRa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;f=i;i=i+48|0;h=f+20|0;j=f;k=ea(-ea(g[e>>2]));l=ea(-ea(g[e+4>>2]));m=ea(-ea(g[e+8>>2]));n=ea(g[e+12>>2]);o=ea(g[b+16>>2]);p=ea(o-ea(g[e+16>>2]));o=ea(g[b+20>>2]);q=ea(o-ea(g[e+20>>2]));o=ea(g[b+24>>2]);r=ea(p*ea(2.0));p=ea(q*ea(2.0));q=ea(ea(o-ea(g[e+24>>2]))*ea(2.0));o=ea(ea(n*n)+ea(-.5));s=ea(ea(ea(r*k)+ea(p*l))+ea(q*m));t=ea(ea(s*k)+ea(ea(o*r)+ea(n*ea(ea(q*l)-ea(p*m)))));u=ea(ea(s*l)+ea(ea(o*p)+ea(n*ea(ea(r*m)-ea(q*k)))));v=ea(ea(ea(o*q)+ea(n*ea(ea(p*k)-ea(r*l))))+ea(s*m));s=ea(g[b>>2]);r=ea(n*s);p=ea(g[b+12>>2]);q=ea(r+ea(p*k));r=ea(g[b+8>>2]);o=ea(q+ea(r*l));q=ea(g[b+4>>2]);w=ea(o-ea(q*m));o=ea(ea(ea(s*m)+ea(ea(p*l)+ea(n*q)))-ea(r*k));x=ea(ea(ea(q*k)+ea(ea(p*m)+ea(n*r)))-ea(s*l));y=ea(ea(ea(ea(n*p)-ea(s*k))-ea(q*l))-ea(r*m));m=ea(w*ea(2.0));r=ea(y*ea(2.0));l=ea(ea(w*m)+ea(ea(y*r)+ea(-1.0)));y=ea(ea(x*r)+ea(m*o));w=ea(ea(m*x)-ea(r*o));o=ea(g[a+8>>2]);r=ea(o*l);l=ea(o*y);y=ea(o*w);w=ea(u+l);o=ea(v+y);g[h>>2]=ea(t+r);g[h+4>>2]=w;g[h+8>>2]=o;o=ea(u-l);l=ea(v-y);g[h+12>>2]=ea(t-r);g[h+16>>2]=o;g[h+20>>2]=l;g[h+24>>2]=ea(g[a+4>>2]);c[j+12>>2]=c[d+4>>2];c[j+16>>2]=d;g[j+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[j>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[j+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));d=NRa(j,h)|0;i=f;return d|0}function URa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;f=i;i=i+80|0;h=f+20|0;j=f;k=ea(-ea(g[e>>2]));l=ea(-ea(g[e+4>>2]));m=ea(-ea(g[e+8>>2]));n=ea(g[e+12>>2]);o=ea(g[b+16>>2]);p=ea(o-ea(g[e+16>>2]));o=ea(g[b+20>>2]);q=ea(o-ea(g[e+20>>2]));o=ea(g[b+24>>2]);r=ea(p*ea(2.0));p=ea(q*ea(2.0));q=ea(ea(o-ea(g[e+24>>2]))*ea(2.0));o=ea(ea(n*n)+ea(-.5));s=ea(ea(ea(r*k)+ea(p*l))+ea(q*m));t=ea(ea(s*k)+ea(ea(o*r)+ea(n*ea(ea(q*l)-ea(p*m)))));u=ea(ea(s*l)+ea(ea(o*p)+ea(n*ea(ea(r*m)-ea(q*k)))));v=ea(ea(ea(o*q)+ea(n*ea(ea(p*k)-ea(r*l))))+ea(s*m));s=ea(g[b>>2]);r=ea(n*s);p=ea(g[b+12>>2]);q=ea(r+ea(p*k));r=ea(g[b+8>>2]);o=ea(q+ea(r*l));q=ea(g[b+4>>2]);w=ea(o-ea(q*m));o=ea(ea(ea(s*m)+ea(ea(p*l)+ea(n*q)))-ea(r*k));x=ea(ea(ea(q*k)+ea(ea(p*m)+ea(n*r)))-ea(s*l));y=ea(ea(ea(ea(n*p)-ea(s*k))-ea(q*l))-ea(r*m));g[h+36>>2]=t;g[h+40>>2]=u;g[h+44>>2]=v;g[h+48>>2]=ea(g[a+4>>2]);g[h+52>>2]=ea(g[a+8>>2]);g[h+56>>2]=ea(g[a+12>>2]);v=ea(w+w);u=ea(o+o);t=ea(x+x);m=ea(o*u);r=ea(x*t);l=ea(v*o);o=ea(v*x);q=ea(v*y);k=ea(x*u);x=ea(y*u);u=ea(y*t);t=ea(l+u);y=ea(o-x);s=ea(l-u);u=ea(ea(1.0)-ea(w*v));v=ea(u-r);w=ea(q+k);l=ea(o+x);x=ea(k-q);q=ea(u-m);g[h>>2]=ea(ea(ea(1.0)-m)-r);g[h+4>>2]=t;g[h+8>>2]=y;g[h+12>>2]=s;g[h+16>>2]=v;g[h+20>>2]=w;g[h+24>>2]=l;g[h+28>>2]=x;g[h+32>>2]=q;c[j+12>>2]=c[d+4>>2];c[j+16>>2]=d;g[j+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[j>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[j+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));d=ORa(j,h)|0;i=f;return d|0}function VRa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0;f=i;i=i+32|0;h=f;j=c[a+32>>2]|0;c[h+12>>2]=c[d+4>>2];c[h+16>>2]=d;g[h+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[h>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[h+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));d=PRa(h,e,j,b,a+4|0)|0;i=f;return d|0}function WRa(d,f,h,j,k,l,m,n){d=d|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=0;o=i;i=i+384|0;p=o+160|0;q=o+144|0;r=o+228|0;s=o+256|0;t=o+176|0;u=o+352|0;v=o+216|0;w=o+316|0;x=o+328|0;y=o+340|0;z=o;A=h+24|0;B=ea(ea(g[A>>2])+n);g[r>>2]=ea(g[h>>2]);C=h+4|0;g[r+4>>2]=ea(g[C>>2]);D=h+8|0;g[r+8>>2]=ea(g[D>>2]);E=h+12|0;g[r+12>>2]=ea(g[E>>2]);F=h+16|0;g[r+16>>2]=ea(g[F>>2]);G=h+20|0;g[r+20>>2]=ea(g[G>>2]);H=r+24|0;g[H>>2]=B;$Ka(r,s);B=ea(S(ea(g[s>>2])));n=ea(S(ea(g[s+4>>2])));I=ea(S(ea(g[s+8>>2])));J=s+12|0;K=ea(S(ea(g[J>>2])));L=ea(S(ea(g[J+4>>2])));M=ea(S(ea(g[J+8>>2])));J=s+24|0;N=ea(S(ea(g[J>>2])));O=ea(S(ea(g[J+4>>2])));P=ea(S(ea(g[J+8>>2])));Q=ea(g[s+48>>2]);R=ea(g[s+52>>2]);T=ea(g[s+56>>2]);U=ea(ea(ea(B*Q)+ea(K*R))+ea(N*T));N=ea(ea(ea(n*Q)+ea(L*R))+ea(O*T));O=ea(ea(ea(I*Q)+ea(M*R))+ea(P*T));c[t>>2]=544144;J=t+24|0;a[J>>0]=0;a[t+25>>0]=0;c[u+12>>2]=c[d+4>>2];c[u+16>>2]=d;g[u+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[u>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[u+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));c[t+28>>2]=f;c[t+32>>2]=u;c[t+4>>2]=r;c[t+8>>2]=j;g[t+12>>2]=k;c[t+16>>2]=l;c[t+20>>2]=m;if(!(a[d+20>>0]&2))V=(e[m>>1]|0)>>>7&1;else V=1;r=t+36|0;a[r>>0]=V;V=l+40|0;g[V>>2]=ea(3402823469999999843913219.0e14);T=ea(g[f+16>>2]);P=ea(g[f+20>>2]);R=ea(T*ea(-2.0));T=ea(P*ea(-2.0));P=ea(ea(g[f+24>>2])*ea(-2.0));M=ea(g[f+12>>2]);Q=ea(ea(M*M)+ea(-.5));I=ea(g[f>>2]);L=ea(R*I);n=ea(g[f+4>>2]);K=ea(L+ea(T*n));L=ea(g[f+8>>2]);B=ea(K+ea(P*L));K=ea(ea(I*B)+ea(ea(R*Q)-ea(M*ea(ea(P*n)-ea(T*L)))));W=ea(ea(n*B)+ea(ea(T*Q)-ea(M*ea(ea(R*L)-ea(P*I)))));X=ea(ea(ea(P*Q)-ea(M*ea(ea(T*I)-ea(R*n))))+ea(L*B));B=ea(-I);R=ea(-n);T=ea(-L);P=ea(ea(g[s+36>>2])*ea(2.0));Y=ea(ea(g[s+40>>2])*ea(2.0));Z=ea(ea(g[s+44>>2])*ea(2.0));_=ea(ea(ea(P*B)+ea(Y*R))+ea(Z*T));$=ea(K+ea(ea(_*B)+ea(ea(Q*P)+ea(M*ea(ea(Z*R)-ea(Y*T))))));K=ea(W+ea(ea(_*R)+ea(ea(Q*Y)+ea(M*ea(ea(P*T)-ea(Z*B))))));W=ea(X+ea(ea(ea(Q*Z)+ea(M*ea(ea(Y*B)-ea(P*R))))+ea(_*T)));g[v>>2]=$;s=v+4|0;g[s>>2]=K;aa=v+8|0;g[aa>>2]=W;_=ea(ea(g[j>>2])*ea(2.0));ba=j+4|0;P=ea(ea(g[ba>>2])*ea(2.0));ca=j+8|0;Y=ea(ea(g[ca>>2])*ea(2.0));Z=ea(ea(ea(_*B)+ea(P*R))+ea(Y*T));X=ea(ea(Z*B)+ea(ea(Q*_)+ea(M*ea(ea(Y*R)-ea(P*T)))));da=ea(ea(Z*R)+ea(ea(Q*P)+ea(M*ea(ea(_*T)-ea(Y*B)))));fa=ea(ea(ea(Q*Y)+ea(M*ea(ea(P*B)-ea(_*R))))+ea(Z*T));Z=ea(B-I);I=ea(R-n);n=ea(T-L);L=ea(I*R);_=ea(n*T);P=ea(Z*R);R=ea(Z*T);Y=ea(M*Z);Q=ea(I*T);T=ea(M*I);I=ea(M*n);n=ea(ea(1.0)-ea(Z*B));B=ea(ea(ea(S(ea(U*ea(ea(ea(1.0)-L)-_))))+ea(S(ea(N*ea(P-I)))))+ea(S(ea(O*ea(R+T)))));Z=ea(ea(ea(S(ea(U*ea(P+I))))+ea(S(ea(N*ea(n-_)))))+ea(S(ea(O*ea(Q-Y)))));_=ea(ea(ea(S(ea(U*ea(R-T))))+ea(S(ea(N*ea(Y+Q)))))+ea(S(ea(O*ea(n-L)))));L=ea(ea(ea(Z+K)-ea(K-Z))*ea(.5));Z=ea(ea(ea(W+_)-ea(W-_))*ea(.5));g[w>>2]=ea(ea(ea(B+$)-ea($-B))*ea(.5));g[w+4>>2]=L;g[w+8>>2]=Z;Z=ea(X*k);X=ea(da*k);da=ea(fa*k);fa=ea(Z+ea(g[v>>2]));Z=ea(X+ea(g[s>>2]));X=ea(da+ea(g[aa>>2]));g[x>>2]=fa;g[x+4>>2]=Z;g[x+8>>2]=X;Q7a(u,v,x,t,w);w=b[J>>1]|0;if(!((w&255)<<24>>24)){ga=0;i=o;return ga|0}J=l+12|0;if((w&65535)<256){b[J>>1]=7;ga=1;i=o;return ga|0}b[J>>1]=6;if(!(b[m>>1]&512)){g[V>>2]=ea(0.0);X=ea(-ea(g[j>>2]));Z=ea(-ea(g[ba>>2]));fa=ea(-ea(g[ca>>2]));g[l+28>>2]=X;g[l+32>>2]=Z;g[l+36>>2]=fa;ga=1;i=o;return ga|0}fa=ea(g[h>>2]);Z=ea(g[C>>2]);X=ea(g[D>>2]);da=ea(g[E>>2]);L=ea(g[F>>2]);B=ea(g[G>>2]);$=ea(g[A>>2]);A=z+64|0;c[z+80>>2]=4;G=z+20|0;F=z+36|0;g[z+48>>2]=ea(0.0);E=z+52|0;c[E+0>>2]=c[p+0>>2];c[E+4>>2]=c[p+4>>2];c[E+8>>2]=c[p+8>>2];c[q+0>>2]=-1;c[q+4>>2]=-1;c[q+8>>2]=-1;c[q+12>>2]=-1;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];g[z+128>>2]=$;q=z+132|0;c[q+0>>2]=c[y+0>>2];c[q+4>>2]=c[y+4>>2];c[q+8>>2]=c[y+8>>2];g[z+96>>2]=fa;g[z+100>>2]=Z;g[z+104>>2]=X;g[z+108>>2]=ea(0.0);g[z+112>>2]=da;g[z+116>>2]=L;g[z+120>>2]=B;g[z+124>>2]=ea(0.0);g[z+16>>2]=$;c[G+0>>2]=c[y+0>>2];c[G+4>>2]=c[y+4>>2];c[G+8>>2]=c[y+8>>2];g[z+32>>2]=$;c[F+0>>2]=c[y+0>>2];c[F+4>>2]=c[y+4>>2];c[F+8>>2]=c[y+8>>2];$=ea(ea(Z+L)*ea(.5));L=ea(ea(X+B)*ea(.5));g[z>>2]=ea(ea(fa+da)*ea(.5));g[z+4>>2]=$;g[z+8>>2]=L;g[z+12>>2]=ea(0.0);L=ea(g[H>>2]);if(kNa(d,f,z,L,k,(a[r>>0]|0)!=0,1,l)|0){b[J>>1]=e[J>>1]|1;ga=1;i=o;return ga|0}else{g[V>>2]=ea(0.0);k=ea(-ea(g[j>>2]));L=ea(-ea(g[ba>>2]));$=ea(-ea(g[ca>>2]));g[l+28>>2]=k;g[l+32>>2]=L;g[l+36>>2]=$;ga=1;i=o;return ga|0}return 0}function XRa(d,e,f,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0;o=i;i=i+608|0;p=o+520|0;q=o+484|0;r=o;s=o+472|0;t=o+592|0;u=o+448|0;v=o+504|0;w=o+460|0;x=e+4|0;y=e+8|0;z=e+12|0;A=e+16|0;B=e+20|0;C=e+24|0;D=c[f+32>>2]|0;E=f+4|0;if(ea(g[E>>2])==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0)F=ea(g[f+12>>2])==ea(1.0);else F=0;g[p>>2]=ea(1.0);G=p+4|0;g[G>>2]=ea(0.0);H=p+8|0;g[H>>2]=ea(0.0);I=p+12|0;g[I>>2]=ea(0.0);J=p+16|0;g[J>>2]=ea(1.0);K=p+20|0;g[K>>2]=ea(0.0);L=p+24|0;g[L>>2]=ea(0.0);M=p+28|0;g[M>>2]=ea(0.0);N=p+32|0;g[N>>2]=ea(1.0);g[p+36>>2]=ea(1.0);g[p+40>>2]=ea(0.0);g[p+44>>2]=ea(0.0);g[p+48>>2]=ea(0.0);g[p+52>>2]=ea(1.0);g[p+56>>2]=ea(0.0);g[p+60>>2]=ea(0.0);g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(1.0);if(F){O=ea(1.0);P=ea(0.0);Q=ea(0.0);R=ea(0.0);U=ea(1.0);V=ea(0.0);W=ea(0.0);X=ea(0.0);Y=ea(1.0)}else{J0a(p,E,f+16|0);Z=ea(g[p>>2]);_=ea(g[G>>2]);$=ea(g[H>>2]);aa=ea(g[I>>2]);ba=ea(g[J>>2]);ca=ea(g[K>>2]);da=ea(g[L>>2]);fa=ea(g[M>>2]);O=Z;P=_;Q=$;R=aa;U=ba;V=ca;W=da;X=fa;Y=ea(g[N>>2])}N=D+16|0;fa=ea(g[N>>2]);da=ea(g[D+28>>2]);ca=ea(fa+da);ba=ea(g[D+20>>2]);aa=ea(g[D+32>>2]);$=ea(ba+aa);_=ea(g[D+24>>2]);Z=ea(g[D+36>>2]);ga=ea(ca*ea(.5));ca=ea($*ea(.5));$=ea(ea(_+Z)*ea(.5));ha=ea(ea(ea(ga*O)+ea(ca*R))+ea($*W));ia=ea(ea(ea(ga*P)+ea(ca*U))+ea($*X));ja=ea(ea(ea(ga*Q)+ea(ca*V))+ea($*Y));$=ea(ea(da-fa)*ea(.5));fa=ea(ea(aa-ba)*ea(.5));ba=ea(ea(Z-_)*ea(.5));_=ea(ea(ea(S(ea($*O)))+ea(S(ea(fa*R))))+ea(S(ea(ba*W))));W=ea(ea(ea(S(ea($*P)))+ea(S(ea(fa*U))))+ea(S(ea(ba*X))));X=ea(ea(ea(S(ea($*Q)))+ea(S(ea(fa*V))))+ea(S(ea(ba*Y))));Y=ea(ha-_);ba=ea(ia-W);V=ea(ja-X);fa=ea(ha+_);_=ea(ia+W);W=ea(ja+X);X=ea(ea(ea(fa-Y)*ea(.5))+n);ja=ea(ea(ea(_-ba)*ea(.5))+n);ia=ea(ea(ea(W-V)*ea(.5))+n);D=b[m>>1]|0;m=D&65535;M=(m&512|0)==0;L=(a[d+20>>0]&2)!=0|(m&128|0)!=0;c[q+12>>2]=c[d+4>>2];c[q+16>>2]=d;g[q+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[q>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[q+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));ha=ea(-ea(g[j>>2]));m=j+4|0;Q=ea(-ea(g[m>>2]));K=j+8|0;$=ea(-ea(g[K>>2]));g[s>>2]=ha;g[s+4>>2]=Q;g[s+8>>2]=$;b[t>>1]=D;R7a(r,q,N,E,h,e,s,k,t,n,(D&64)!=0,L);$=ea(g[A>>2]);Q=ea(g[B>>2]);ha=ea($*ea(-2.0));$=ea(Q*ea(-2.0));Q=ea(ea(g[C>>2])*ea(-2.0));U=ea(g[z>>2]);P=ea(ea(U*U)+ea(-.5));R=ea(g[e>>2]);O=ea(ha*R);Z=ea(g[x>>2]);aa=ea(O+ea($*Z));O=ea(g[y>>2]);da=ea(aa+ea(Q*O));aa=ea(-R);ca=ea(-Z);ga=ea(-O);ka=ea(ea(ea(Y+fa)*ea(.5))*ea(2.0));fa=ea(ea(ea(ba+_)*ea(.5))*ea(2.0));_=ea(ea(ea(V+W)*ea(.5))*ea(2.0));W=ea(ea(ea(ka*aa)+ea(fa*ca))+ea(_*ga));V=ea(ea(ea(R*da)+ea(ea(ha*P)-ea(U*ea(ea(Q*Z)-ea($*O)))))+ea(ea(W*aa)+ea(ea(ka*P)+ea(U*ea(ea(_*ca)-ea(fa*ga))))));ba=ea(ea(ea(Z*da)+ea(ea($*P)-ea(U*ea(ea(ha*O)-ea(Q*R)))))+ea(ea(W*ca)+ea(ea(fa*P)+ea(U*ea(ea(ka*ga)-ea(_*aa))))));Y=ea(ea(ea(ea(Q*P)-ea(U*ea(ea($*R)-ea(ha*Z))))+ea(O*da))+ea(ea(ea(_*P)+ea(U*ea(ea(fa*aa)-ea(ka*ca))))+ea(W*ga)));g[u>>2]=V;y=u+4|0;g[y>>2]=ba;x=u+8|0;g[x>>2]=Y;W=ea(ea(g[j>>2])*ea(2.0));ka=ea(ea(g[m>>2])*ea(2.0));fa=ea(ea(g[K>>2])*ea(2.0));_=ea(ea(ea(W*aa)+ea(ka*ca))+ea(fa*ga));da=ea(ea(_*aa)+ea(ea(P*W)+ea(U*ea(ea(fa*ca)-ea(ka*ga)))));ha=ea(ea(_*ca)+ea(ea(P*ka)+ea(U*ea(ea(W*ga)-ea(fa*aa)))));$=ea(ea(ea(P*fa)+ea(U*ea(ea(ka*aa)-ea(W*ca))))+ea(_*ga));_=ea(aa-R);R=ea(ca-Z);Z=ea(ga-O);O=ea(R*ca);W=ea(Z*ga);ka=ea(_*ca);ca=ea(_*ga);fa=ea(U*_);P=ea(R*ga);ga=ea(U*R);R=ea(U*Z);Z=ea(ea(1.0)-ea(_*aa));aa=ea(ea(ea(S(ea(X*ea(ea(ea(1.0)-O)-W))))+ea(S(ea(ja*ea(ka-R)))))+ea(S(ea(ia*ea(ca+ga)))));_=ea(ea(ea(S(ea(X*ea(ka+R))))+ea(S(ea(ja*ea(Z-W)))))+ea(S(ea(ia*ea(P-fa)))));W=ea(ea(ea(S(ea(X*ea(ca-ga))))+ea(S(ea(ja*ea(fa+P)))))+ea(S(ea(ia*ea(Z-O)))));O=ea(ea(ea(_+ba)-ea(ba-_))*ea(.5));_=ea(ea(ea(Y+W)-ea(Y-W))*ea(.5));g[v>>2]=ea(ea(ea(aa+V)-ea(V-aa))*ea(.5));g[v+4>>2]=O;g[v+8>>2]=_;_=ea(da*k);da=ea(ha*k);ha=ea($*k);$=ea(_+ea(g[u>>2]));_=ea(da+ea(g[y>>2]));da=ea(ha+ea(g[x>>2]));g[w>>2]=$;g[w+4>>2]=_;g[w+8>>2]=da;S7a(q,u,w,r,v);if(!(a[r+435>>0]|0)){la=0;i=o;return la|0}if(!(a[r+434>>0]|0)){v=r+320|0;c[l+0>>2]=c[v+0>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];b[l+12>>1]=b[r+332>>1]|0;g[l+16>>2]=ea(g[r+336>>2]);g[l+20>>2]=ea(g[r+340>>2]);g[l+24>>2]=ea(g[r+344>>2]);da=ea(g[r+348>>2]);v=l+28|0;_=ea(g[r+352>>2]);w=l+32|0;$=ea(g[r+356>>2]);u=l+36|0;g[l+40>>2]=ea(g[r+360>>2]);c[l+44>>2]=c[r+364>>2];ha=ea(-da);O=ea(-_);aa=ea(-$);g[v>>2]=ha;g[w>>2]=O;g[u>>2]=aa;V=ea(T(ea(ea($*$)+ea(ea(da*da)+ea(_*_)))));if(V>ea(0.0)){_=ea(ea(1.0)/V);g[v>>2]=ea(_*ha);g[w>>2]=ea(_*O);g[u>>2]=ea(_*aa)}c[l+8>>2]=c[r+328>>2];la=1;i=o;return la|0}if(M){b[l+12>>1]=6;g[l+40>>2]=ea(0.0);aa=ea(-ea(g[j>>2]));_=ea(-ea(g[m>>2]));O=ea(-ea(g[K>>2]));g[l+28>>2]=aa;g[l+32>>2]=_;g[l+36>>2]=O;c[l+8>>2]=c[r+328>>2];la=1;i=o;return la|0}r=oNa(d,e,f,h,n,k,L,1,l)|0;L=l+12|0;b[L>>1]=6;if(r){b[L>>1]=7;la=1;i=o;return la|0}else{g[l+40>>2]=ea(0.0);k=ea(-ea(g[j>>2]));n=ea(-ea(g[m>>2]));O=ea(-ea(g[K>>2]));g[l+28>>2]=k;g[l+32>>2]=n;g[l+36>>2]=O;la=1;i=o;return la|0}return 0}function YRa(d,f,h,j,k,l,m,n){d=d|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;m=m|0;n=ea(n);var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=0,N=Im,O=Im,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=0,ca=0,da=0,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0;o=i;i=i+384|0;p=o;q=o+356|0;r=o+328|0;s=o+240|0;t=o+80|0;u=o+308|0;v=o+296|0;w=o+284|0;x=o+272|0;y=o+368|0;z=ea(S(ea(g[h>>2])));A=ea(S(ea(g[h+4>>2])));B=ea(S(ea(g[h+8>>2])));C=h+12|0;D=ea(S(ea(g[C>>2])));E=ea(S(ea(g[C+4>>2])));F=ea(S(ea(g[C+8>>2])));C=h+24|0;G=ea(S(ea(g[C>>2])));H=ea(S(ea(g[C+4>>2])));I=ea(S(ea(g[C+8>>2])));C=h+48|0;J=ea(g[C>>2]);K=h+52|0;L=ea(g[K>>2]);M=h+56|0;N=ea(g[M>>2]);O=ea(ea(ea(ea(z*J)+ea(D*L))+ea(G*N))+n);G=ea(ea(ea(ea(A*J)+ea(E*L))+ea(H*N))+n);H=ea(ea(ea(ea(B*J)+ea(F*L))+ea(I*N))+n);P=d+20|0;Q=(a[P>>0]&2)!=0;UUa(p,h);N=ea(g[p>>2]);g[r>>2]=N;R=r+4|0;I=ea(g[p+4>>2]);g[R>>2]=I;T=r+8|0;L=ea(g[p+8>>2]);g[T>>2]=L;U=r+12|0;F=ea(g[p+12>>2]);g[U>>2]=F;V=r+16|0;W=h+36|0;J=ea(g[W>>2]);g[V>>2]=J;X=r+20|0;Y=h+40|0;B=ea(g[Y>>2]);g[X>>2]=B;Z=r+24|0;_=h+44|0;E=ea(g[_>>2]);g[Z>>2]=E;A=ea(J*ea(-2.0));J=ea(B*ea(-2.0));B=ea(E*ea(-2.0));E=ea(ea(F*F)+ea(-.5));D=ea(ea(ea(A*N)+ea(J*I))+ea(B*L));z=ea(ea(N*D)+ea(ea(A*E)-ea(F*ea(ea(B*I)-ea(J*L)))));$=ea(ea(I*D)+ea(ea(J*E)-ea(F*ea(ea(A*L)-ea(B*N)))));aa=ea(ea(ea(B*E)-ea(F*ea(ea(J*N)-ea(A*I))))+ea(L*D));D=ea(-N);N=ea(-I);I=ea(-L);g[s>>2]=D;g[s+4>>2]=N;g[s+8>>2]=I;g[s+12>>2]=F;g[s+16>>2]=z;g[s+20>>2]=$;g[s+24>>2]=aa;g[s+28>>2]=ea(0.0);aa=ea(ea(g[j>>2])*k);ba=j+4|0;$=ea(ea(g[ba>>2])*k);ca=j+8|0;z=ea(aa*ea(2.0));aa=ea($*ea(2.0));$=ea(ea(ea(g[ca>>2])*k)*ea(2.0));L=ea(ea(ea(z*D)+ea(aa*N))+ea($*I));A=ea(ea(L*D)+ea(ea(E*z)+ea(F*ea(ea($*N)-ea(aa*I)))));J=ea(ea(L*N)+ea(ea(E*aa)+ea(F*ea(ea(z*I)-ea($*D)))));B=ea(ea(ea(E*$)+ea(F*ea(ea(aa*D)-ea(z*N))))+ea(L*I));c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;I=ea(g[C>>2]);L=ea(g[K>>2]);N=ea(g[M>>2]);M=t+64|0;c[t+80>>2]=3;K=t+20|0;c[K+0>>2]=c[q+0>>2];c[K+4>>2]=c[q+4>>2];c[K+8>>2]=c[q+8>>2];C=t+36|0;g[t+48>>2]=ea(0.0);da=t+52|0;c[da+0>>2]=c[q+0>>2];c[da+4>>2]=c[q+4>>2];c[da+8>>2]=c[q+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[M+0>>2]=c[p+0>>2];c[M+4>>2]=c[p+4>>2];c[M+8>>2]=c[p+8>>2];c[M+12>>2]=c[p+12>>2];g[t+144>>2]=I;g[t+148>>2]=L;g[t+152>>2]=N;g[t+156>>2]=ea(0.0);z=!(I<=L)?L:I;D=!(z<=N)?N:z;z=!(I>=L)?L:I;I=ea(D*ea(.150000006));L=ea((!(z>=N)?N:z)*ea(.0299999993));z=I>L?I:L;g[t+16>>2]=D>z?z:D;c[K+0>>2]=c[q+0>>2];c[K+4>>2]=c[q+4>>2];c[K+8>>2]=c[q+8>>2];g[t+32>>2]=ea(D*ea(.0500000007));c[C+0>>2]=c[p+0>>2];c[C+4>>2]=c[p+4>>2];c[C+8>>2]=c[p+8>>2];C=l+40|0;g[C>>2]=ea(3402823469999999843913219.0e14);c[p>>2]=544096;c[u+12>>2]=c[d+4>>2];c[u+16>>2]=d;g[u+4>>2]=ea(ea(1.0)/ea(g[d+8>>2]));g[u>>2]=ea(ea(1.0)/ea(g[d+12>>2]));g[u+8>>2]=ea(ea(1.0)/ea(g[d+16>>2]));c[p+4>>2]=s;s=p+68|0;a[s>>0]=0;a[p+70>>0]=0;c[p+8>>2]=f;c[p+12>>2]=u;c[p+16>>2]=t;g[p+48>>2]=A;g[p+52>>2]=J;g[p+56>>2]=B;c[p+60>>2]=l;g[p+64>>2]=n;g[p+32>>2]=ea(3402823469999999843913219.0e14);t=p+36|0;c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];if(!(a[P>>0]&2))fa=(e[m>>1]|0)>>>7&1;else fa=1;a[p+69>>0]=fa;B=ea(g[f+16>>2]);J=ea(g[f+20>>2]);A=ea(B*ea(-2.0));B=ea(J*ea(-2.0));J=ea(ea(g[f+24>>2])*ea(-2.0));D=ea(g[f+12>>2]);z=ea(ea(D*D)+ea(-.5));L=ea(g[f>>2]);I=ea(A*L);N=ea(g[f+4>>2]);aa=ea(I+ea(B*N));I=ea(g[f+8>>2]);F=ea(aa+ea(J*I));aa=ea(ea(L*F)+ea(ea(A*z)-ea(D*ea(ea(J*N)-ea(B*I)))));$=ea(ea(N*F)+ea(ea(B*z)-ea(D*ea(ea(A*I)-ea(J*L)))));E=ea(ea(ea(J*z)-ea(D*ea(ea(B*L)-ea(A*N))))+ea(I*F));F=ea(-L);A=ea(-N);B=ea(-I);J=ea(ea(g[W>>2])*ea(2.0));ga=ea(ea(g[Y>>2])*ea(2.0));ha=ea(ea(g[_>>2])*ea(2.0));ia=ea(ea(ea(J*F)+ea(ga*A))+ea(ha*B));ja=ea(aa+ea(ea(ia*F)+ea(ea(z*J)+ea(D*ea(ea(ha*A)-ea(ga*B))))));aa=ea($+ea(ea(ia*A)+ea(ea(z*ga)+ea(D*ea(ea(J*B)-ea(ha*F))))));$=ea(E+ea(ea(ea(z*ha)+ea(D*ea(ea(ga*F)-ea(J*A))))+ea(ia*B)));g[w>>2]=ja;_=w+4|0;g[_>>2]=aa;Y=w+8|0;g[Y>>2]=$;ia=ea(ea(g[j>>2])*ea(2.0));J=ea(ea(g[ba>>2])*ea(2.0));ga=ea(ea(g[ca>>2])*ea(2.0));ha=ea(ea(ea(ia*F)+ea(J*A))+ea(ga*B));E=ea(ea(ha*F)+ea(ea(z*ia)+ea(D*ea(ea(ga*A)-ea(J*B)))));ka=ea(ea(ha*A)+ea(ea(z*J)+ea(D*ea(ea(ia*B)-ea(ga*F)))));la=ea(ea(ea(z*ga)+ea(D*ea(ea(J*F)-ea(ia*A))))+ea(ha*B));ha=ea(F-L);L=ea(A-N);N=ea(B-I);I=ea(L*A);ia=ea(N*B);J=ea(ha*A);A=ea(ha*B);ga=ea(D*ha);z=ea(L*B);B=ea(D*L);L=ea(D*N);N=ea(ea(1.0)-ea(ha*F));F=ea(ea(ea(S(ea(O*ea(ea(ea(1.0)-I)-ia))))+ea(S(ea(G*ea(J-L)))))+ea(S(ea(H*ea(A+B)))));ha=ea(ea(ea(S(ea(O*ea(J+L))))+ea(S(ea(G*ea(N-ia)))))+ea(S(ea(H*ea(z-ga)))));ia=ea(ea(ea(S(ea(O*ea(A-B))))+ea(S(ea(G*ea(ga+z)))))+ea(S(ea(H*ea(N-I)))));I=ea(ea(ea(ha+aa)-ea(aa-ha))*ea(.5));ha=ea(ea(ea($+ia)-ea($-ia))*ea(.5));g[x>>2]=ea(ea(ea(F+ja)-ea(ja-F))*ea(.5));g[x+4>>2]=I;g[x+8>>2]=ha;ha=ea(E*k);E=ea(ka*k);ka=ea(la*k);la=ea(ha+ea(g[w>>2]));ha=ea(E+ea(g[_>>2]));E=ea(ka+ea(g[Y>>2]));g[y>>2]=la;g[y+4>>2]=ha;g[y+8>>2]=E;T7a(u,w,y,p,x);x=c[s>>2]|0;if(!((x&255)<<24>>24)){ma=0;i=o;return ma|0}if(!(x&16711680)){g[C>>2]=ea(ea(g[C>>2])*k);x=l+28|0;E=ea(ea(g[x>>2])*ea(2.0));s=l+32|0;ha=ea(ea(g[s>>2])*ea(2.0));p=l+36|0;la=ea(ea(g[p>>2])*ea(2.0));ka=ea(g[U>>2]);I=ea(ea(ka*ka)+ea(-.5));F=ea(g[r>>2]);ja=ea(E*F);ia=ea(g[R>>2]);$=ea(ja+ea(ha*ia));ja=ea(g[T>>2]);aa=ea($+ea(la*ja));$=ea(ea(ia*aa)+ea(ea(ha*I)+ea(ka*ea(ea(E*ja)-ea(la*F)))));N=ea(ea(ea(la*I)+ea(ka*ea(ea(ha*F)-ea(E*ia))))+ea(ja*aa));g[x>>2]=ea(ea(F*aa)+ea(ea(E*I)+ea(ka*ea(ea(la*ia)-ea(ha*ja)))));g[s>>2]=$;g[p>>2]=N;p=l+16|0;N=ea(ea(g[p>>2])*ea(2.0));s=l+20|0;$=ea(ea(g[s>>2])*ea(2.0));x=l+24|0;ha=ea(ea(g[x>>2])*ea(2.0));la=ea(ea(ea(N*F)+ea($*ia))+ea(ha*ja));E=ea(ea(F*la)+ea(ea(N*I)+ea(ka*ea(ea(ha*ia)-ea($*ja)))));aa=ea(ea(ia*la)+ea(ea($*I)+ea(ka*ea(ea(N*ja)-ea(ha*F)))));H=ea(ea(ea(ha*I)+ea(ka*ea(ea($*F)-ea(N*ia))))+ea(ja*la));la=ea(ea(g[V>>2])+E);E=ea(ea(g[X>>2])+aa);aa=ea(ea(g[Z>>2])+H);g[p>>2]=la;g[s>>2]=E;g[x>>2]=aa;b[l+12>>1]=7;ma=1;i=o;return ma|0}x=l+12|0;b[x>>1]=6;if(!(b[m>>1]&512)){g[C>>2]=ea(0.0);aa=ea(-ea(g[j>>2]));E=ea(-ea(g[ba>>2]));la=ea(-ea(g[ca>>2]));g[l+28>>2]=aa;g[l+32>>2]=E;g[l+36>>2]=la;ma=1;i=o;return ma|0}if(mNa(d,f,h,r,n,k,Q,1,l)|0){b[x>>1]=e[x>>1]|0|1;ma=1;i=o;return ma|0}else{g[C>>2]=ea(0.0);k=ea(-ea(g[j>>2]));n=ea(-ea(g[ba>>2]));la=ea(-ea(g[ca>>2]));g[l+28>>2]=k;g[l+32>>2]=n;g[l+36>>2]=la;ma=1;i=o;return ma|0}return 0}function ZRa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=0,Jb=0,Kb=0,Lb=0,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=0,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=0,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=0,Jd=Im,Kd=Im,Ld=0,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=0;l=i;i=i+1104|0;m=l+384|0;n=l+320|0;o=l+16|0;p=l+640|0;q=l+880|0;r=l+352|0;s=l+80|0;t=l+96|0;u=l+160|0;v=l+224|0;w=l+240|0;x=l+256|0;y=l+272|0;z=l+288|0;A=l+800|0;B=l+832|0;C=l+864|0;D=l+1040|0;E=l+1056|0;F=l+1072|0;G=l+400|0;H=l+416|0;I=l+432|0;J=l+464|0;K=l+528|0;L=l+544|0;M=l+1088|0;N=l+48|0;O=l;P=l+32|0;Q=l+624|0;R=l+304|0;U=l+816|0;V=l+1092|0;W=l+848|0;X=l+64|0;Y=l+368|0;Z=l+336|0;_=l+608|0;$=c[j>>2]|0;g[F>>2]=ea(g[h>>2]);aa=ea(g[b+4>>2]);ba=ea(g[b+8>>2]);ca=ea(g[b+12>>2]);g[G>>2]=aa;b=G+4|0;g[b>>2]=ba;h=G+8|0;g[h>>2]=ca;g[G+12>>2]=ea(0.0);ca=ea(g[d+4>>2]);ba=ea(g[d+8>>2]);aa=ea(g[d+12>>2]);g[H>>2]=ca;d=H+4|0;g[d>>2]=ba;j=H+8|0;g[j>>2]=aa;g[H+12>>2]=ea(0.0);aa=ea(g[e>>2]);ba=ea(g[e+4>>2]);ca=ea(g[e+8>>2]);da=ea(g[e+12>>2]);fa=e+16|0;ga=ea(g[fa>>2]);ha=ea(g[fa+4>>2]);ia=ea(g[fa+8>>2]);ja=ea(g[f>>2]);ka=ea(g[f+4>>2]);la=ea(g[f+8>>2]);ma=ea(g[f+12>>2]);fa=f+16|0;na=ea(g[fa>>2]);oa=ea(g[fa+4>>2]);pa=ea(g[fa+8>>2]);g[I>>2]=ja;fa=I+4|0;g[fa>>2]=ka;f=I+8|0;g[f>>2]=la;e=I+12|0;g[e>>2]=ma;g[I+16>>2]=na;g[I+20>>2]=oa;g[I+24>>2]=pa;g[I+28>>2]=ea(0.0);qa=ea(-ja);ja=ea(-ka);ka=ea(-la);la=ea(ga-na);na=ea(ha-oa);oa=ea(ia-pa);pa=ea(ea(ma*ma)+ea(-.5));ra=ea(ea(ea(la*qa)+ea(na*ja))+ea(oa*ka));sa=ea(ea(ea(ra*qa)+ea(ea(pa*la)+ea(ma*ea(ea(oa*ja)-ea(na*ka)))))*ea(2.0));ta=ea(ea(ea(ra*ja)+ea(ea(pa*na)+ea(ma*ea(ea(la*ka)-ea(oa*qa)))))*ea(2.0));ua=ea(ea(ea(ea(pa*oa)+ea(ma*ea(ea(na*qa)-ea(la*ja))))+ea(ra*ka))*ea(2.0));ra=ea(ea(da*ma)-ea(ea(ea(aa*qa)+ea(ba*ja))+ea(ca*ka)));la=ea(ea(ea(ca*ja)-ea(ba*ka))+ea(ea(da*qa)+ea(aa*ma)));na=ea(ea(ea(aa*ka)-ea(ca*qa))+ea(ea(da*ja)+ea(ba*ma)));oa=ea(ea(ea(ba*qa)-ea(aa*ja))+ea(ea(ca*ma)+ea(da*ka)));va=J+48|0;g[va>>2]=sa;wa=J+52|0;g[wa>>2]=ta;xa=J+56|0;g[xa>>2]=ua;g[J+60>>2]=ea(0.0);ka=ea(la+la);ma=ea(na+na);ja=ea(oa+oa);qa=ea(na*ma);pa=ea(oa*ja);ya=ea(na*ka);za=ea(oa*ka);Aa=ea(ra*ka);Ba=ea(oa*ma);Ca=ea(ra*ma);ma=ea(ra*ja);ja=ea(ea(1.0)-ea(la*ka));ka=ea(ya+ma);Da=ea(za-Ca);Ea=ea(ya-ma);ma=ea(ja-pa);ya=ea(Ba+Aa);Fa=ea(za+Ca);Ca=ea(Ba-Aa);Aa=ea(ja-qa);g[J>>2]=ea(ea(ea(1.0)-qa)-pa);Ga=J+4|0;g[Ga>>2]=ka;Ha=J+8|0;g[Ha>>2]=Da;g[J+12>>2]=ea(0.0);Ia=J+16|0;g[Ia>>2]=Ea;Ja=J+20|0;g[Ja>>2]=ma;Ka=J+24|0;g[Ka>>2]=ya;g[J+28>>2]=ea(0.0);La=J+32|0;g[La>>2]=Fa;Ma=J+36|0;g[Ma>>2]=Ca;Na=J+40|0;g[Na>>2]=Aa;g[J+44>>2]=ea(0.0);Aa=ea(g[G>>2]);Ca=ea(g[b>>2]);Fa=ea(g[h>>2]);ya=!(Aa<=Ca)?Ca:Aa;Aa=ea((!(ya<=Fa)?Fa:ya)*ea(.150000006));ya=ea(g[H>>2]);Fa=ea(g[d>>2]);Ca=ea(g[j>>2]);ma=!(ya<=Fa)?Fa:ya;ya=ea((!(ma<=Ca)?Ca:ma)*ea(.150000006));ma=Aa>ya?ya:Aa;Oa=$+32|0;Pa=a[Oa>>0]|0;g[K>>2]=ea(ma*ea(.800000011));U7a($,J,K,0);if((a[Oa>>0]|0)==Pa<<24>>24){Oa=Pa&255;Aa=ea(ma*ea(g[544288+(Oa<<2)>>2]));K=$+16|0;ya=ea(g[K>>2]);Qa=$+20|0;Ca=ea(g[Qa>>2]);Ra=$+24|0;Fa=ea(sa-ya);ya=ea(ta-Ca);Ca=ea(ua-ea(g[Ra>>2]));Ea=ea(-Fa);Da=ea(-ya);ka=ea(-Ca);pa=Fa>Ea?Fa:Ea;Ea=ya>Da?ya:Da;Da=!(pa>=Ea)?Ea:pa;Sa=!((Ca>ka?Ca:ka)>=ea(0.0));ka=Sa?ea(0.0):pa;if(!((Da>=ka?Da:ka)>Aa)?(Aa=ea(g[$+4>>2]),ka=ea(na*Aa),Aa=ea(la*ea(g[$>>2])),Da=ea(oa*ea(g[$+8>>2])),pa=ea(ka+Aa),Aa=ea(ea(pa+Da)+ea(ra*ea(g[$+12>>2]))),!(ea(g[544328+(Oa<<2)>>2])>Aa)):0){if(!(Pa<<24>>24)){Ta=0;i=l;return Ta|0}X7a(_,$,I);OSa($,k,_,I);Ta=1;i=l;return Ta|0}else{Ua=K;Va=Qa;Wa=Ra}}else{Ua=$+16|0;Va=$+20|0;Wa=$+24|0}g[$>>2]=la;g[$+4>>2]=na;g[$+8>>2]=oa;g[$+12>>2]=ra;g[Ua>>2]=sa;g[Va>>2]=ta;g[Wa>>2]=ua;g[$+28>>2]=ea(0.0);ua=ea(aa+aa);ta=ea(ba+ba);sa=ea(ca+ca);ra=ea(ba*ta);oa=ea(ca*sa);na=ea(ua*ba);ba=ea(ua*ca);la=ea(ua*da);Aa=ea(ta*ca);ca=ea(ta*da);ta=ea(sa*da);da=ea(ea(1.0)-ea(aa*ua));ua=ea(ea(ea(1.0)-ra)-oa);aa=ea(na+ta);sa=ea(ba-ca);Da=ea(na-ta);ta=ea(da-oa);oa=ea(Aa+la);na=ea(ba+ca);ca=ea(Aa-la);la=ea(da-ra);Wa=L+48|0;Va=I+16|0;c[Wa+0>>2]=c[Va+0>>2];c[Wa+4>>2]=c[Va+4>>2];c[Wa+8>>2]=c[Va+8>>2];c[Wa+12>>2]=c[Va+12>>2];ra=ea(g[I>>2]);da=ea(g[fa>>2]);Aa=ea(g[f>>2]);ba=ea(g[e>>2]);pa=ea(ra+ra);ka=ea(da+da);Ca=ea(Aa+Aa);Ea=ea(da*ka);ya=ea(Aa*Ca);Fa=ea(pa*da);da=ea(pa*Aa);qa=ea(pa*ba);ja=ea(ka*Aa);Aa=ea(ka*ba);ka=ea(Ca*ba);ba=ea(ea(1.0)-ea(ra*pa));pa=ea(Fa+ka);ra=ea(da-Aa);Ca=ea(Fa-ka);ka=ea(ba-ya);Fa=ea(ja+qa);Ba=ea(da+Aa);Aa=ea(ja-qa);qa=ea(ba-Ea);g[L>>2]=ea(ea(ea(1.0)-Ea)-ya);Va=L+4|0;g[Va>>2]=pa;Wa=L+8|0;g[Wa>>2]=ra;g[L+12>>2]=ea(0.0);Ua=L+16|0;g[Ua>>2]=Ca;Ra=L+20|0;g[Ra>>2]=ka;Qa=L+24|0;g[Qa>>2]=Fa;g[L+28>>2]=ea(0.0);K=L+32|0;g[K>>2]=Ba;_=L+36|0;g[_>>2]=Aa;Pa=L+40|0;g[Pa>>2]=qa;g[L+44>>2]=ea(0.0);c[M>>2]=0;g[m>>2]=ea(g[G>>2]);g[n>>2]=ea(g[b>>2]);g[o>>2]=ea(g[h>>2]);g[p>>2]=ea(g[H>>2]);g[q>>2]=ea(g[d>>2]);qa=ea(g[j>>2]);g[r>>2]=qa;Oa=L+48|0;Aa=ea(g[Oa>>2]);Sa=L+52|0;Ba=ea(g[Sa>>2]);Xa=L+56|0;Fa=ea(Aa-ga);Aa=ea(Ba-ha);Ba=ea(ea(g[Xa>>2])-ia);ka=ea(ea(ea(ua*Fa)+ea(aa*Aa))+ea(sa*Ba));Ca=ea(ea(ea(Da*Fa)+ea(ta*Aa))+ea(oa*Ba));pa=ea(ea(ea(na*Fa)+ea(ca*Aa))+ea(la*Ba));Ba=ea(g[L>>2]);Aa=ea(g[Va>>2]);Fa=ea(ea(ea(ua*Ba)+ea(aa*Aa))+ea(sa*ra));ya=ea(ea(ea(Da*Ba)+ea(ta*Aa))+ea(oa*ra));Ea=ea(ea(ea(na*Ba)+ea(ca*Aa))+ea(la*ra));ba=ea(g[Ua>>2]);ja=ea(g[Ra>>2]);da=ea(g[Qa>>2]);za=ea(ea(ea(ua*ba)+ea(aa*ja))+ea(sa*da));Ya=ea(ea(ea(Da*ba)+ea(ta*ja))+ea(oa*da));Za=ea(ea(ea(na*ba)+ea(ca*ja))+ea(la*da));_a=ea(g[K>>2]);$a=ea(g[_>>2]);ab=ea(g[Pa>>2]);bb=ea(ea(ea(ua*_a)+ea(aa*$a))+ea(sa*ab));cb=ea(ea(ea(Da*_a)+ea(ta*$a))+ea(oa*ab));db=ea(ea(ea(na*_a)+ea(ca*$a))+ea(la*ab));eb=ea(-Fa);fb=ea(-ya);gb=ea(-Ea);hb=ea((ya>fb?ya:fb)+ea(9.99999997e-07));fb=ea(-za);ib=ea(-Ya);jb=ea(-Za);kb=ea((Ya>ib?Ya:ib)+ea(9.99999997e-07));ib=ea(-bb);lb=ea(-cb);mb=ea(-db);nb=ea((cb>lb?cb:lb)+ea(9.99999997e-07));lb=ea((za>fb?za:fb)+ea(9.99999997e-07));fb=ea((Za>jb?Za:jb)+ea(9.99999997e-07));jb=ea((Fa>eb?Fa:eb)+ea(9.99999997e-07));eb=ea((Ea>gb?Ea:gb)+ea(9.99999997e-07));gb=ea((bb>ib?bb:ib)+ea(9.99999997e-07));ib=ea((db>mb?db:mb)+ea(9.99999997e-07));mb=ea(g[H>>2]);ob=ea(g[d>>2]);pb=ea(g[j>>2]);qb=ea(ea(jb*mb)+ea(ea(ob*lb)+ea(pb*gb)));rb=ea(g[m>>2]);sb=ea(ea(rb+qb)-ea(S(ea(ka))));qb=ea(g[F>>2]);tb=ea(qb+sb);a:do if((((((((((((((!(tb<ea(0.0))?(sb=ea(ea(hb*mb)+ea(ea(ob*kb)+ea(pb*nb))),ub=ea(g[n>>2]),vb=ea(qb+ea(ea(sb+ub)-ea(S(ea(Ca))))),!(vb<ea(0.0))):0)?(sb=ea(ea(eb*mb)+ea(ea(ob*fb)+ea(pb*ib))),wb=ea(g[o>>2]),xb=ea(qb+ea(ea(sb+wb)-ea(S(ea(pa))))),!(xb<ea(0.0))):0)?(sb=ea(ea(pa*Ea)+ea(ea(ka*Fa)+ea(Ca*ya))),yb=ea(g[G>>2]),zb=ea(g[b>>2]),Ab=ea(g[h>>2]),Bb=ea(ea(jb*yb)+ea(ea(hb*zb)+ea(eb*Ab))),Cb=ea(g[p>>2]),Db=ea(qb+ea(ea(Cb+Bb)-ea(S(ea(sb))))),!(Db<ea(0.0))):0)?(Bb=ea(ea(pa*Za)+ea(ea(ka*za)+ea(Ca*Ya))),Eb=ea(ea(lb*yb)+ea(ea(kb*zb)+ea(fb*Ab))),Fb=ea(g[q>>2]),Gb=ea(qb+ea(ea(Eb+Fb)-ea(S(ea(Bb))))),!(Gb<ea(0.0))):0)?(Eb=ea(ea(pa*db)+ea(ea(ka*bb)+ea(Ca*cb))),Hb=ea(qb+ea(ea(qa+ea(ea(gb*yb)+ea(ea(nb*zb)+ea(ib*Ab))))-ea(S(ea(Eb))))),!(Hb<ea(0.0))):0)?!(ea(S(ea(ea(pa*ya)-ea(Ca*Ea))))>ea(qb+ea(ea(ea(eb*ub)+ea(hb*wb))+ea(ea(qa*lb)+ea(gb*Fb))))):0)?!(ea(S(ea(ea(pa*Ya)-ea(Ca*Za))))>ea(qb+ea(ea(ea(fb*ub)+ea(kb*wb))+ea(ea(qa*jb)+ea(gb*Cb))))):0)?!(ea(S(ea(ea(pa*cb)-ea(Ca*db))))>ea(qb+ea(ea(ea(ib*ub)+ea(nb*wb))+ea(ea(lb*Cb)+ea(jb*Fb))))):0)?!(ea(S(ea(ea(ka*Ea)-ea(pa*Fa))))>ea(qb+ea(ea(ea(eb*rb)+ea(jb*wb))+ea(ea(qa*kb)+ea(nb*Fb))))):0)?!(ea(S(ea(ea(ka*Za)-ea(pa*za))))>ea(qb+ea(ea(ea(fb*rb)+ea(lb*wb))+ea(ea(qa*hb)+ea(nb*Cb))))):0)?!(ea(S(ea(ea(ka*db)-ea(pa*bb))))>ea(qb+ea(ea(ea(rb*ib)+ea(gb*wb))+ea(ea(kb*Cb)+ea(hb*Fb))))):0)?!(ea(S(ea(ea(Ca*Fa)-ea(ka*ya))))>ea(qb+ea(ea(ea(hb*rb)+ea(jb*ub))+ea(ea(qa*fb)+ea(ib*Fb))))):0)?!(ea(S(ea(ea(Ca*za)-ea(ka*Ya))))>ea(qb+ea(ea(ea(kb*rb)+ea(lb*ub))+ea(ea(qa*eb)+ea(ib*Cb))))):0)?!(ea(S(ea(ea(Ca*bb)-ea(ka*cb))))>ea(qb+ea(ea(ea(rb*nb)+ea(gb*ub))+ea(ea(fb*Cb)+ea(eb*Fb))))):0){Ib=tb>vb;Ab=Ib?vb:tb;Jb=Ab>xb;vb=Jb?xb:Ab;Kb=vb>Db;Ab=Kb?Db:vb;Lb=Ab>Gb;switch(((Lb?Gb:Ab)>Hb?5:Lb?4:Kb?3:Jb?2:Ib&1)|0){case 0:{if(!(ka<=ea(0.0))){Mb=ea(ga+ea(ua*rb));Nb=ea(ha+ea(aa*rb));Ob=ea(ia+ea(sa*rb));Pb=na;Qb=ca;Rb=la;Sb=ea(-ua);Tb=ea(-aa);Ub=ea(-sa)}else{Mb=ea(ga-ea(ua*rb));Nb=ea(ha-ea(aa*rb));Ob=ea(ia-ea(sa*rb));Pb=ea(-na);Qb=ea(-ca);Rb=ea(-la);Sb=ua;Tb=aa;Ub=sa}Hb=ea(g[Oa>>2]);Ab=ea(Hb-Mb);Hb=ea(ea(g[Sa>>2])-Nb);Gb=ea(ea(g[Xa>>2])-Ob);vb=ea(ea(ea(Da*Ab)+ea(ta*Hb))+ea(oa*Gb));Db=ea(ea(ea(Sb*Ab)+ea(Tb*Hb))+ea(Ub*Gb));xb=ea(ea(ra*Rb)+ea(ea(Aa*Qb)+ea(Ba*Pb)));zb=ea(ea(ra*Ub)+ea(ea(Aa*Tb)+ea(Ba*Sb)));yb=ea(ea(da*Rb)+ea(ea(ja*Qb)+ea(ba*Pb)));Vb=ea(ea(da*Ub)+ea(ea(ja*Tb)+ea(ba*Sb)));Wb=ea(ea(ab*Rb)+ea(ea($a*Qb)+ea(_a*Pb)));Xb=ea(ea(ab*Ub)+ea(ea($a*Tb)+ea(_a*Sb)));g[u+48>>2]=ea(ea(ea(Pb*Ab)+ea(Qb*Hb))+ea(Rb*Gb));g[u+52>>2]=vb;g[u+56>>2]=Db;g[u+60>>2]=ea(0.0);g[u>>2]=xb;g[u+4>>2]=ya;g[u+8>>2]=zb;g[u+12>>2]=ea(0.0);g[u+16>>2]=yb;g[u+20>>2]=Ya;g[u+24>>2]=Vb;g[u+28>>2]=ea(0.0);g[u+32>>2]=Wb;g[u+36>>2]=cb;g[u+40>>2]=Xb;g[u+44>>2]=ea(0.0);Xb=ea(ea(Ub*Rb)+ea(ea(Tb*Qb)+ea(Sb*Pb)));Wb=ea(ea(oa*Ub)+ea(ea(ta*Tb)+ea(Da*Sb)));Vb=ea(ea(Ub*Ub)+ea(ea(Tb*Tb)+ea(Sb*Sb)));g[v>>2]=Xb;g[v+4>>2]=Wb;g[v+8>>2]=Vb;g[v+12>>2]=ea(0.0);yb=ea(-Wb);Wb=ea(-Vb);g[w>>2]=ea(-Xb);g[w+4>>2]=yb;g[w+8>>2]=Wb;g[w+12>>2]=ea(0.0);V7a(t,s,w,u,H);W7a(o,n,t,s,v,k,M,F);Yb=Mb;Zb=Nb;_b=Ob;$b=Pb;ac=Qb;bc=Rb;cc=Da;dc=ta;ec=oa;fc=Sb;gc=Tb;hc=Ub;break}case 3:{Wb=ea(-Ba);yb=ea(-Aa);Xb=ea(-ra);if(!(sb<=ea(0.0))){sb=ea(-_a);Vb=ea(-$a);zb=ea(-ab);xb=ea(g[Oa>>2]);Db=ea(g[Sa>>2]);ic=Ba;jc=Aa;kc=ra;lc=Wb;mc=yb;nc=Xb;oc=ea(xb-ea(Ba*Cb));pc=ea(Db-ea(Aa*Cb));qc=ea(ea(g[Xa>>2])-ea(ra*Cb));rc=sb;sc=Vb;tc=zb}else{zb=ea(g[Oa>>2]);Vb=ea(g[Sa>>2]);ic=Wb;jc=yb;kc=Xb;lc=Ba;mc=Aa;nc=ra;oc=ea(ea(Ba*Cb)+zb);pc=ea(ea(Aa*Cb)+Vb);qc=ea(ea(ra*Cb)+ea(g[Xa>>2]));rc=_a;sc=$a;tc=ab}Cb=ea(ga-oc);Vb=ea(ha-pc);zb=ea(ia-qc);Xb=ea(ea(da*zb)+ea(ea(ja*Vb)+ea(ba*Cb)));yb=ea(ea(zb*kc)+ea(ea(Vb*jc)+ea(Cb*ic)));Wb=ea(ea(sa*tc)+ea(ea(aa*sc)+ea(ua*rc)));sb=ea(ea(sa*kc)+ea(ea(aa*jc)+ea(ua*ic)));Db=ea(ea(oa*tc)+ea(ea(ta*sc)+ea(Da*rc)));xb=ea(ea(oa*kc)+ea(ea(ta*jc)+ea(Da*ic)));vb=ea(ea(la*tc)+ea(ea(ca*sc)+ea(na*rc)));Gb=ea(ea(la*kc)+ea(ea(ca*jc)+ea(na*ic)));g[u+48>>2]=ea(ea(zb*tc)+ea(ea(Vb*sc)+ea(Cb*rc)));g[u+52>>2]=Xb;g[u+56>>2]=yb;g[u+60>>2]=ea(0.0);g[u>>2]=Wb;g[u+4>>2]=za;g[u+8>>2]=sb;g[u+12>>2]=ea(0.0);g[u+16>>2]=Db;g[u+20>>2]=Ya;g[u+24>>2]=xb;g[u+28>>2]=ea(0.0);g[u+32>>2]=vb;g[u+36>>2]=Za;g[u+40>>2]=Gb;g[u+44>>2]=ea(0.0);Gb=ea(ea(da*nc)+ea(ea(ja*mc)+ea(ba*lc)));vb=ea(ea(nc*kc)+ea(ea(mc*jc)+ea(lc*ic)));g[B>>2]=ea(ea(nc*tc)+ea(ea(mc*sc)+ea(lc*rc)));g[B+4>>2]=Gb;g[B+8>>2]=vb;g[B+12>>2]=ea(0.0);V7a(t,s,B,u,G);W7a(r,q,t,s,B,k,M,F);uc=qc;vc=pc;wc=oc;xc=kc;yc=jc;zc=ic;Ac=da;Bc=ja;Cc=ba;Dc=tc;Ec=sc;Fc=rc;Gc=45;break}case 2:{if(!(pa<=ea(0.0))){Hc=ea(ga+ea(na*wb));Ic=ea(ha+ea(ca*wb));Jc=ea(ia+ea(la*wb));Kc=ea(-Da);Lc=ea(-ta);Mc=ea(-oa);Nc=ea(-na);Oc=ea(-ca);Pc=ea(-la)}else{Hc=ea(ga-ea(na*wb));Ic=ea(ha-ea(ca*wb));Jc=ea(ia-ea(la*wb));Kc=Da;Lc=ta;Mc=oa;Nc=na;Oc=ca;Pc=la}wb=ea(g[Oa>>2]);vb=ea(wb-Hc);wb=ea(ea(g[Sa>>2])-Ic);Gb=ea(ea(g[Xa>>2])-Jc);xb=ea(ea(ea(Kc*vb)+ea(Lc*wb))+ea(Mc*Gb));Db=ea(ea(ea(Nc*vb)+ea(Oc*wb))+ea(Pc*Gb));sb=ea(ea(ra*Mc)+ea(ea(Aa*Lc)+ea(Ba*Kc)));Wb=ea(ea(ra*Pc)+ea(ea(Aa*Oc)+ea(Ba*Nc)));yb=ea(ea(da*Mc)+ea(ea(ja*Lc)+ea(ba*Kc)));Xb=ea(ea(da*Pc)+ea(ea(ja*Oc)+ea(ba*Nc)));Cb=ea(ea(ab*Mc)+ea(ea($a*Lc)+ea(_a*Kc)));Vb=ea(ea(ab*Pc)+ea(ea($a*Oc)+ea(_a*Nc)));g[u+48>>2]=ea(ea(ea(ua*vb)+ea(aa*wb))+ea(sa*Gb));g[u+52>>2]=xb;g[u+56>>2]=Db;g[u+60>>2]=ea(0.0);g[u>>2]=Fa;g[u+4>>2]=sb;g[u+8>>2]=Wb;g[u+12>>2]=ea(0.0);g[u+16>>2]=za;g[u+20>>2]=yb;g[u+24>>2]=Xb;g[u+28>>2]=ea(0.0);g[u+32>>2]=bb;g[u+36>>2]=Cb;g[u+40>>2]=Vb;g[u+44>>2]=ea(0.0);Vb=ea(ea(sa*Pc)+ea(ea(aa*Oc)+ea(ua*Nc)));Cb=ea(ea(Pc*Mc)+ea(ea(Oc*Lc)+ea(Nc*Kc)));Xb=ea(ea(Pc*Pc)+ea(ea(Oc*Oc)+ea(Nc*Nc)));g[z>>2]=Vb;g[z+4>>2]=Cb;g[z+8>>2]=Xb;g[z+12>>2]=ea(0.0);yb=ea(-Cb);Cb=ea(-Xb);g[A>>2]=ea(-Vb);g[A+4>>2]=yb;g[A+8>>2]=Cb;g[A+12>>2]=ea(0.0);V7a(t,s,A,u,H);W7a(m,n,t,s,z,k,M,F);Yb=Hc;Zb=Ic;_b=Jc;$b=ua;ac=aa;bc=sa;cc=Kc;dc=Lc;ec=Mc;fc=Nc;gc=Oc;hc=Pc;break}case 4:{Cb=ea(-ba);yb=ea(-ja);Vb=ea(-da);if(!(Bb<=ea(0.0))){Bb=ea(-_a);Xb=ea(-$a);Wb=ea(-ab);sb=ea(g[Oa>>2]);Db=ea(g[Sa>>2]);Qc=ea(sb-ea(ba*Fb));Rc=ea(Db-ea(ja*Fb));Sc=ea(ea(g[Xa>>2])-ea(da*Fb));Tc=Bb;Uc=Xb;Vc=Wb;Wc=ba;Xc=ja;Yc=da;Zc=Cb;_c=yb;$c=Vb}else{Wb=ea(g[Oa>>2]);Xb=ea(g[Sa>>2]);Qc=ea(ea(ba*Fb)+Wb);Rc=ea(ea(ja*Fb)+Xb);Sc=ea(ea(da*Fb)+ea(g[Xa>>2]));Tc=_a;Uc=$a;Vc=ab;Wc=Cb;Xc=yb;Yc=Vb;Zc=ba;_c=ja;$c=da}Vb=ea(ga-Qc);yb=ea(ha-Rc);Cb=ea(ia-Sc);Fb=ea(ea(Cb*Vc)+ea(ea(yb*Uc)+ea(Vb*Tc)));Xb=ea(ea(Cb*Yc)+ea(ea(yb*Xc)+ea(Vb*Wc)));Wb=ea(ea(sa*Vc)+ea(ea(aa*Uc)+ea(ua*Tc)));Bb=ea(ea(sa*Yc)+ea(ea(aa*Xc)+ea(ua*Wc)));Db=ea(ea(oa*Vc)+ea(ea(ta*Uc)+ea(Da*Tc)));sb=ea(ea(oa*Yc)+ea(ea(ta*Xc)+ea(Da*Wc)));xb=ea(ea(la*Vc)+ea(ea(ca*Uc)+ea(na*Tc)));Gb=ea(ea(la*Yc)+ea(ea(ca*Xc)+ea(na*Wc)));g[u+48>>2]=ea(ea(ra*Cb)+ea(ea(Aa*yb)+ea(Ba*Vb)));g[u+52>>2]=Fb;g[u+56>>2]=Xb;g[u+60>>2]=ea(0.0);g[u>>2]=Fa;g[u+4>>2]=Wb;g[u+8>>2]=Bb;g[u+12>>2]=ea(0.0);g[u+16>>2]=ya;g[u+20>>2]=Db;g[u+24>>2]=sb;g[u+28>>2]=ea(0.0);g[u+32>>2]=Ea;g[u+36>>2]=xb;g[u+40>>2]=Gb;g[u+44>>2]=ea(0.0);Gb=ea(ea($c*Vc)+ea(ea(_c*Uc)+ea(Zc*Tc)));xb=ea(ea($c*Yc)+ea(ea(_c*Xc)+ea(Zc*Wc)));g[C>>2]=ea(ea(ra*$c)+ea(ea(Aa*_c)+ea(Ba*Zc)));g[C+4>>2]=Gb;g[C+8>>2]=xb;g[C+12>>2]=ea(0.0);V7a(t,s,C,u,G);W7a(p,r,t,s,C,k,M,F);uc=Sc;vc=Rc;wc=Qc;xc=Yc;yc=Xc;zc=Wc;Ac=Vc;Bc=Uc;Cc=Tc;Dc=ra;Ec=Aa;Fc=Ba;Gc=45;break}case 5:{if(!(Eb<=ea(0.0))){Eb=ea(-_a);xb=ea(-$a);Gb=ea(-ab);sb=ea(g[Oa>>2]);Db=ea(g[Sa>>2]);ad=ea(sb-ea(qa*_a));bd=ea(Db-ea(qa*$a));cd=ea(ea(g[Xa>>2])-ea(qa*ab));dd=ba;ed=ja;fd=da;gd=_a;hd=$a;id=ab;jd=Eb;kd=xb;ld=Gb}else{Gb=ea(-ba);xb=ea(-ja);Eb=ea(-da);Db=ea(-_a);sb=ea(-$a);Bb=ea(-ab);Wb=ea(g[Oa>>2]);Xb=ea(g[Sa>>2]);ad=ea(ea(qa*_a)+Wb);bd=ea(ea(qa*$a)+Xb);cd=ea(ea(qa*ab)+ea(g[Xa>>2]));dd=Gb;ed=xb;fd=Eb;gd=Db;hd=sb;id=Bb;jd=_a;kd=$a;ld=ab}Bb=ea(ga-ad);sb=ea(ha-bd);Db=ea(ia-cd);Eb=ea(ea(Db*fd)+ea(ea(sb*ed)+ea(Bb*dd)));xb=ea(ea(Db*id)+ea(ea(sb*hd)+ea(Bb*gd)));Gb=ea(ea(sa*fd)+ea(ea(aa*ed)+ea(ua*dd)));Xb=ea(ea(sa*id)+ea(ea(aa*hd)+ea(ua*gd)));Wb=ea(ea(oa*fd)+ea(ea(ta*ed)+ea(Da*dd)));Fb=ea(ea(oa*id)+ea(ea(ta*hd)+ea(Da*gd)));Vb=ea(ea(la*fd)+ea(ea(ca*ed)+ea(na*dd)));yb=ea(ea(la*id)+ea(ea(ca*hd)+ea(na*gd)));g[u+48>>2]=ea(ea(ra*Db)+ea(ea(Aa*sb)+ea(Ba*Bb)));g[u+52>>2]=Eb;g[u+56>>2]=xb;g[u+60>>2]=ea(0.0);g[u>>2]=Fa;g[u+4>>2]=Gb;g[u+8>>2]=Xb;g[u+12>>2]=ea(0.0);g[u+16>>2]=ya;g[u+20>>2]=Wb;g[u+24>>2]=Fb;g[u+28>>2]=ea(0.0);g[u+32>>2]=Ea;g[u+36>>2]=Vb;g[u+40>>2]=yb;g[u+44>>2]=ea(0.0);yb=ea(ea(ld*fd)+ea(ea(kd*ed)+ea(jd*dd)));Vb=ea(ea(ld*id)+ea(ea(kd*hd)+ea(jd*gd)));g[D>>2]=ea(ea(ra*ld)+ea(ea(Aa*kd)+ea(Ba*jd)));g[D+4>>2]=yb;g[D+8>>2]=Vb;g[D+12>>2]=ea(0.0);V7a(t,s,D,u,G);W7a(p,q,t,s,D,k,M,F);uc=cd;vc=bd;wc=ad;xc=id;yc=hd;zc=gd;Ac=fd;Bc=ed;Cc=dd;Dc=ra;Ec=Aa;Fc=Ba;Gc=45;break}case 1:{if(!(Ca<=ea(0.0))){md=ea(ga+ea(Da*ub));nd=ea(ha+ea(ta*ub));od=ea(ia+ea(oa*ub));pd=na;qd=ca;rd=la;sd=ea(-Da);td=ea(-ta);ud=ea(-oa)}else{md=ea(ga-ea(Da*ub));nd=ea(ha-ea(ta*ub));od=ea(ia-ea(oa*ub));pd=ea(-na);qd=ea(-ca);rd=ea(-la);sd=Da;td=ta;ud=oa}ub=ea(g[Oa>>2]);Vb=ea(ub-md);ub=ea(ea(g[Sa>>2])-nd);yb=ea(ea(g[Xa>>2])-od);Fb=ea(ea(ea(pd*Vb)+ea(qd*ub))+ea(rd*yb));Wb=ea(ea(ea(sd*Vb)+ea(td*ub))+ea(ud*yb));Xb=ea(ea(ra*rd)+ea(ea(Aa*qd)+ea(Ba*pd)));Gb=ea(ea(ra*ud)+ea(ea(Aa*td)+ea(Ba*sd)));xb=ea(ea(da*rd)+ea(ea(ja*qd)+ea(ba*pd)));Eb=ea(ea(da*ud)+ea(ea(ja*td)+ea(ba*sd)));Bb=ea(ea(ab*rd)+ea(ea($a*qd)+ea(_a*pd)));sb=ea(ea(ab*ud)+ea(ea($a*td)+ea(_a*sd)));g[u+48>>2]=ea(ea(ea(ua*Vb)+ea(aa*ub))+ea(sa*yb));g[u+52>>2]=Fb;g[u+56>>2]=Wb;g[u+60>>2]=ea(0.0);g[u>>2]=Fa;g[u+4>>2]=Xb;g[u+8>>2]=Gb;g[u+12>>2]=ea(0.0);g[u+16>>2]=za;g[u+20>>2]=xb;g[u+24>>2]=Eb;g[u+28>>2]=ea(0.0);g[u+32>>2]=bb;g[u+36>>2]=Bb;g[u+40>>2]=sb;g[u+44>>2]=ea(0.0);sb=ea(ea(sa*ud)+ea(ea(aa*td)+ea(ua*sd)));Bb=ea(ea(ud*rd)+ea(ea(td*qd)+ea(sd*pd)));Eb=ea(ea(ud*ud)+ea(ea(td*td)+ea(sd*sd)));g[x>>2]=sb;g[x+4>>2]=Bb;g[x+8>>2]=Eb;g[x+12>>2]=ea(0.0);xb=ea(-Bb);Bb=ea(-Eb);g[y>>2]=ea(-sb);g[y+4>>2]=xb;g[y+8>>2]=Bb;g[y+12>>2]=ea(0.0);V7a(t,s,y,u,H);W7a(m,o,t,s,x,k,M,F);Yb=md;Zb=nd;_b=od;$b=ua;ac=aa;bc=sa;cc=pd;dc=qd;ec=rd;fc=sd;gc=td;hc=ud;break}default:{vd=1;break a}}if((Gc|0)==45){Ib=c[M>>2]|0;if(!Ib){Yb=wc;Zb=vc;_b=uc;$b=Fc;ac=Ec;bc=Dc;cc=Cc;dc=Bc;ec=Ac;fc=zc;gc=yc;hc=xc}else{Jb=0;do{Kb=k+(Jb*48|0)+16|0;c[E+0>>2]=c[Kb+0>>2];c[E+4>>2]=c[Kb+4>>2];c[E+8>>2]=c[Kb+8>>2];c[E+12>>2]=c[Kb+12>>2];Lb=k+(Jb*48|0)|0;c[Kb+0>>2]=c[Lb+0>>2];c[Kb+4>>2]=c[Lb+4>>2];c[Kb+8>>2]=c[Lb+8>>2];c[Kb+12>>2]=c[Lb+12>>2];c[Lb+0>>2]=c[E+0>>2];c[Lb+4>>2]=c[E+4>>2];c[Lb+8>>2]=c[E+8>>2];c[Lb+12>>2]=c[E+12>>2];Jb=Jb+1|0}while(Jb>>>0<Ib>>>0);Yb=wc;Zb=vc;_b=uc;$b=Fc;ac=Ec;bc=Dc;cc=Cc;dc=Bc;ec=Ac;fc=zc;gc=yc;hc=xc}}Bb=ea(g[Oa>>2]);xb=ea(g[Sa>>2]);sb=ea(Yb-Bb);Bb=ea(Zb-xb);xb=ea(_b-ea(g[Xa>>2]));Eb=ea(g[L>>2]);Gb=ea(sb*Eb);Xb=ea(g[Va>>2]);Wb=ea(Gb+ea(Bb*Xb));Gb=ea(g[Wa>>2]);Fb=ea(Wb+ea(xb*Gb));Wb=ea(g[Ua>>2]);yb=ea(sb*Wb);ub=ea(g[Ra>>2]);Vb=ea(yb+ea(Bb*ub));yb=ea(g[Qa>>2]);Db=ea(Vb+ea(xb*yb));Vb=ea(g[K>>2]);Cb=ea(sb*Vb);sb=ea(g[_>>2]);wb=ea(Cb+ea(Bb*sb));Bb=ea(g[Pa>>2]);Cb=ea(wb+ea(xb*Bb));xb=ea(ea(ea($b*Eb)+ea(ac*Xb))+ea(bc*Gb));wb=ea(ea(ea($b*Wb)+ea(ac*ub))+ea(bc*yb));vb=ea(ea(ea($b*Vb)+ea(ac*sb))+ea(bc*Bb));zb=ea(ea(ea(cc*Eb)+ea(dc*Xb))+ea(ec*Gb));Hb=ea(ea(ea(cc*Wb)+ea(dc*ub))+ea(ec*yb));Ab=ea(ea(ea(cc*Vb)+ea(dc*sb))+ea(ec*Bb));wd=ea(ea(ea(fc*Eb)+ea(gc*Xb))+ea(hc*Gb));Gb=ea(ea(ea(fc*Wb)+ea(gc*ub))+ea(hc*yb));yb=ea(ea(ea(fc*Vb)+ea(gc*sb))+ea(hc*Bb));Bb=ea(Yb-ga);sb=ea(Zb-ha);Vb=ea(_b-ia);ub=ea(ea(sa*Vb)+ea(ea(aa*sb)+ea(ua*Bb)));Wb=ea(ea(oa*Vb)+ea(ea(ta*sb)+ea(Da*Bb)));Xb=ea(ea(la*Vb)+ea(ea(ca*sb)+ea(na*Bb)));Bb=ea(ea(sa*bc)+ea(ea(aa*ac)+ea(ua*$b)));sb=ea(ea(oa*bc)+ea(ea(ta*ac)+ea(Da*$b)));Vb=ea(ea(la*bc)+ea(ea(ca*ac)+ea(na*$b)));Eb=ea(ea(sa*ec)+ea(ea(aa*dc)+ea(ua*cc)));xd=ea(ea(oa*ec)+ea(ea(ta*dc)+ea(Da*cc)));yd=ea(ea(la*ec)+ea(ea(ca*dc)+ea(na*cc)));zd=ea(ea(sa*hc)+ea(ea(aa*gc)+ea(ua*fc)));Ad=ea(ea(oa*hc)+ea(ea(ta*gc)+ea(Da*fc)));Bd=ea(ea(la*hc)+ea(ea(ca*gc)+ea(na*fc)));Cd=ea(g[k+32>>2]);Dd=ea(g[k+36>>2]);Ed=ea(g[k+40>>2]);Fd=ea(ea(ea(xb*Cd)+ea(zb*Dd))+ea(wd*Ed));Gd=ea(ea(ea(wb*Cd)+ea(Hb*Dd))+ea(Gb*Ed));Hd=ea(ea(ea(Cd*vb)+ea(Ab*Dd))+ea(yb*Ed));Ib=c[M>>2]|0;if(!Ib)vd=0;else{Jb=0;do{Lb=k+(Jb*48|0)|0;Ed=ea(g[Lb>>2]);Kb=k+(Jb*48|0)+4|0;Dd=ea(g[Kb>>2]);Id=k+(Jb*48|0)+8|0;Cd=ea(g[Id>>2]);Jd=ea(Wb+ea(ea(ea(sb*Ed)+ea(xd*Dd))+ea(Ad*Cd)));Kd=ea(Xb+ea(ea(ea(Vb*Ed)+ea(yd*Dd))+ea(Bd*Cd)));g[Lb>>2]=ea(ub+ea(ea(ea(Bb*Ed)+ea(Eb*Dd))+ea(zd*Cd)));g[Kb>>2]=Jd;g[Id>>2]=Kd;g[k+(Jb*48|0)+12>>2]=ea(0.0);Id=k+(Jb*48|0)+16|0;Kd=ea(g[Id>>2]);Kb=k+(Jb*48|0)+20|0;Jd=ea(g[Kb>>2]);Lb=k+(Jb*48|0)+24|0;Cd=ea(g[Lb>>2]);Dd=ea(Db+ea(ea(ea(wb*Kd)+ea(Hb*Jd))+ea(Gb*Cd)));Ed=ea(Cb+ea(ea(ea(vb*Kd)+ea(Ab*Jd))+ea(yb*Cd)));g[Id>>2]=ea(Fb+ea(ea(ea(xb*Kd)+ea(zb*Jd))+ea(wd*Cd)));g[Kb>>2]=Dd;g[Lb>>2]=Ed;g[k+(Jb*48|0)+28>>2]=ea(0.0);g[k+(Jb*48|0)+32>>2]=Fd;g[k+(Jb*48|0)+36>>2]=Gd;g[k+(Jb*48|0)+40>>2]=Hd;Jb=Jb+1|0}while(Jb>>>0<Ib>>>0);vd=0}}else vd=1;while(0);if(vd){Ta=0;i=l;return Ta|0}vd=c[M>>2]|0;if(vd){RSa($,k,vd);vd=c[$+44>>2]|0;fc=ea(g[vd+32>>2]);na=ea(g[vd+36>>2]);gc=ea(g[vd+40>>2]);ca=ea(fc*ea(g[L>>2]));hc=ea(ca+ea(na*ea(g[Ua>>2])));ca=ea(hc+ea(gc*ea(g[K>>2])));hc=ea(fc*ea(g[Va>>2]));la=ea(hc+ea(na*ea(g[Ra>>2])));hc=ea(la+ea(gc*ea(g[_>>2])));la=ea(fc*ea(g[Wa>>2]));fc=ea(la+ea(na*ea(g[Qa>>2])));na=ea(fc+ea(gc*ea(g[Pa>>2])));g[N>>2]=ca;g[N+4>>2]=hc;g[N+8>>2]=na;g[N+12>>2]=ea(0.0);PSa($,k,N,L);Ta=1;i=l;return Ta|0};c[O+0>>2]=0;c[O+4>>2]=0;c[O+8>>2]=0;c[O+12>>2]=0;L=p+64|0;c[p+0>>2]=c[O+0>>2];c[p+4>>2]=c[O+4>>2];c[p+8>>2]=c[O+8>>2];c[p+12>>2]=c[O+12>>2];c[p+80>>2]=3;N=p+20|0;c[N+0>>2]=c[n+0>>2];c[N+4>>2]=c[n+4>>2];c[N+8>>2]=c[n+8>>2];Pa=p+36|0;Qa=p+52|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[L+0>>2]=c[m+0>>2];c[L+4>>2]=c[m+4>>2];c[L+8>>2]=c[m+8>>2];c[L+12>>2]=c[m+12>>2];L=p+144|0;c[L+0>>2]=c[G+0>>2];c[L+4>>2]=c[G+4>>2];c[L+8>>2]=c[G+8>>2];c[L+12>>2]=c[G+12>>2];na=ea(g[G>>2]);hc=ea(g[b>>2]);ca=ea(g[h>>2]);gc=!(na<=hc)?hc:na;fc=!(gc<=ca)?ca:gc;gc=!(na>=hc)?hc:na;na=ea(fc*ea(.150000006));hc=ea((!(gc>=ca)?ca:gc)*ea(.0299999993));gc=na>hc?na:hc;hc=fc>gc?gc:fc;g[p+16>>2]=hc;c[N+0>>2]=c[n+0>>2];c[N+4>>2]=c[n+4>>2];c[N+8>>2]=c[n+8>>2];g[p+32>>2]=ea(fc*ea(.0500000007));c[Pa+0>>2]=c[m+0>>2];c[Pa+4>>2]=c[m+4>>2];c[Pa+8>>2]=c[m+8>>2];fc=ea(hc*hc);g[p+48>>2]=ea(ea(T(ea(fc+ea(fc+fc))))-hc);c[Qa+0>>2]=c[o+0>>2];c[Qa+4>>2]=c[o+4>>2];c[Qa+8>>2]=c[o+8>>2];Qa=q+64|0;c[q+0>>2]=c[O+0>>2];c[q+4>>2]=c[O+4>>2];c[q+8>>2]=c[O+8>>2];c[q+12>>2]=c[O+12>>2];c[q+80>>2]=3;Pa=q+20|0;c[Pa+0>>2]=c[n+0>>2];c[Pa+4>>2]=c[n+4>>2];c[Pa+8>>2]=c[n+8>>2];N=q+36|0;h=q+52|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[Qa+0>>2]=c[m+0>>2];c[Qa+4>>2]=c[m+4>>2];c[Qa+8>>2]=c[m+8>>2];c[Qa+12>>2]=c[m+12>>2];Qa=q+144|0;c[Qa+0>>2]=c[H+0>>2];c[Qa+4>>2]=c[H+4>>2];c[Qa+8>>2]=c[H+8>>2];c[Qa+12>>2]=c[H+12>>2];hc=ea(g[H>>2]);fc=ea(g[d>>2]);gc=ea(g[j>>2]);na=!(hc<=fc)?fc:hc;ca=!(na<=gc)?gc:na;na=!(hc>=fc)?fc:hc;hc=ea(ca*ea(.150000006));fc=ea((!(na>=gc)?gc:na)*ea(.0299999993));na=hc>fc?hc:fc;fc=ca>na?na:ca;g[q+16>>2]=fc;c[Pa+0>>2]=c[n+0>>2];c[Pa+4>>2]=c[n+4>>2];c[Pa+8>>2]=c[n+8>>2];g[q+32>>2]=ea(ca*ea(.0500000007));c[N+0>>2]=c[m+0>>2];c[N+4>>2]=c[m+4>>2];c[N+8>>2]=c[m+8>>2];ca=ea(fc*fc);g[q+48>>2]=ea(ea(T(ea(ca+ea(ca+ca))))-fc);c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[P+0>>2]=c[O+0>>2];c[P+4>>2]=c[O+4>>2];c[P+8>>2]=c[O+8>>2];c[P+12>>2]=c[O+12>>2];c[Q+0>>2]=c[O+0>>2];c[Q+4>>2]=c[O+4>>2];c[Q+8>>2]=c[O+8>>2];c[Q+12>>2]=c[O+12>>2];c[R+0>>2]=c[O+0>>2];c[R+4>>2]=c[O+4>>2];c[R+8>>2]=c[O+8>>2];c[R+12>>2]=c[O+12>>2];g[U>>2]=ea(0.0);O=$+33|0;a[O>>0]=0;o=$+34|0;h=$+38|0;m=oPa(p,q,J,F,P,Q,R,U,o,h,O)|0;if((m|0)==6){F=lPa(p,q,J,P,Q,R,U,o,h,O,0)|0;if((F|0)==6){fc=ea(g[Q>>2]);ca=ea(g[Q+4>>2]);na=ea(g[Q+8>>2]);hc=ea(g[P>>2]);gc=ea(g[P+4>>2]);la=ea(g[P+8>>2]);Da=ea(fc-hc);fc=ea(ca-gc);ca=ea(na-la);na=ea(T(ea(ea(ea(Da*Da)+ea(fc*fc))+ea(ca*ca))));ta=ea(ea(1.0)/na);oa=ea(Da*ta);Da=ea(fc*ta);fc=ea(ca*ta);g[R>>2]=oa;g[R+4>>2]=Da;g[R+8>>2]=fc;O=R+12|0;g[O>>2]=ea(0.0);ta=ea(-na);g[U>>2]=ta;h=U+4|0;c[h+0>>2]=c[V+0>>2];c[h+4>>2]=c[V+4>>2];c[h+8>>2]=c[V+8>>2];Ld=O;Md=hc;Nd=gc;Od=la;Pd=oa;Qd=Da;Rd=fc;Sd=ta}else{Td=F;Gc=55}}else{Td=m;Gc=55}do if((Gc|0)==55)if((Td|0)==1){ta=ea(g[P>>2]);fc=ea(g[P+4>>2]);Da=ea(g[P+8>>2]);oa=ea(g[R>>2]);la=ea(g[R+4>>2]);gc=ea(g[R+8>>2]);Ld=R+12|0;Md=ta;Nd=fc;Od=Da;Pd=oa;Qd=la;Rd=gc;Sd=ea(g[U>>2]);break}else{Ta=0;i=l;return Ta|0}while(0);g[W>>2]=ea(ma*ea(.0500000007));ma=ea(g[va>>2]);gc=ea(g[wa>>2]);la=ea(Md-ma);ma=ea(Nd-gc);gc=ea(Od-ea(g[xa>>2]));Od=ea(la*ea(g[J>>2]));Nd=ea(Od+ea(ma*ea(g[Ga>>2])));Od=ea(Nd+ea(gc*ea(g[Ha>>2])));Nd=ea(la*ea(g[Ia>>2]));Md=ea(Nd+ea(ma*ea(g[Ja>>2])));Nd=ea(Md+ea(gc*ea(g[Ka>>2])));Md=ea(la*ea(g[La>>2]));la=ea(Md+ea(ma*ea(g[Ma>>2])));ma=ea(la+ea(gc*ea(g[Na>>2])));g[X>>2]=Od;g[X+4>>2]=Nd;g[X+8>>2]=ma;g[X+12>>2]=ea(0.0);c[Y+0>>2]=c[Q+0>>2];c[Y+4>>2]=c[Q+4>>2];c[Y+8>>2]=c[Q+8>>2];c[Y+12>>2]=c[Q+12>>2];Q=R+4|0;Na=R+8|0;g[Z>>2]=Pd;g[Z+4>>2]=Qd;g[Z+8>>2]=Rd;g[Z+12>>2]=Sd;Ma=WSa($,X,Y,Z,W)|0;c[M>>2]=(c[M>>2]|0)+Ma;Sd=ea(g[I>>2]);Rd=ea(g[fa>>2]);Qd=ea(g[f>>2]);Pd=ea(g[e>>2]);ma=ea(g[R>>2]);Nd=ea(g[Q>>2]);Od=ea(g[Na>>2]);gc=ea(ea(Pd*Pd)+ea(-.5));la=ea(ea(ea(Sd*ma)+ea(Rd*Nd))+ea(Qd*Od));Md=ea(ea(ea(Rd*la)+ea(ea(gc*Nd)+ea(Pd*ea(ea(Qd*ma)-ea(Sd*Od)))))*ea(2.0));oa=ea(ea(ea(ea(gc*Od)+ea(Pd*ea(ea(Sd*Nd)-ea(Rd*ma))))+ea(Qd*la))*ea(2.0));g[R>>2]=ea(ea(ea(Sd*la)+ea(ea(ma*gc)+ea(Pd*ea(ea(Rd*Od)-ea(Qd*Nd)))))*ea(2.0));g[Q>>2]=Md;g[Na>>2]=oa;g[Ld>>2]=ea(0.0);OSa($,k,R,I);Ta=1;i=l;return Ta|0}function _Ra(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=Im,X=0,Y=0,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=Im,qa=Im,ra=Im,sa=Im,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;m=i;i=i+848|0;n=m+544|0;o=m+768|0;p=m+800|0;q=m+496|0;r=m+688|0;s=m+64|0;t=m+80|0;u=m+576|0;v=m+624|0;w=m+704|0;x=m+736|0;y=m+512|0;z=m+528|0;A=m+752|0;B=m+32|0;C=m;D=m+112|0;E=m+320|0;F=m+812|0;G=m+48|0;H=m+480|0;I=m+816|0;J=m+720|0;K=m+608|0;L=m+560|0;M=m+780|0;N=m+16|0;O=c[k>>2]|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;g[r>>2]=ea(g[j>>2]);j=b+4|0;P=ea(g[j>>2]);Q=ea(g[b+8>>2]);R=ea(g[b+12>>2]);b=e+4|0;S=ea(g[b>>2]);k=e+8|0;U=ea(g[k>>2]);V=e+12|0;W=ea(g[V>>2]);g[s>>2]=S;X=s+4|0;g[X>>2]=U;Y=s+8|0;g[Y>>2]=W;g[s+12>>2]=ea(0.0);W=ea(g[f>>2]);U=ea(g[f+4>>2]);S=ea(g[f+8>>2]);Z=ea(g[f+12>>2]);_=f+16|0;$=ea(g[_>>2]);aa=ea(g[_+4>>2]);ba=ea(g[_+8>>2]);g[t>>2]=W;g[t+4>>2]=U;g[t+8>>2]=S;g[t+12>>2]=Z;g[t+16>>2]=$;g[t+20>>2]=aa;g[t+24>>2]=ba;g[t+28>>2]=ea(0.0);ca=ea(g[h>>2]);da=ea(g[h+4>>2]);fa=ea(g[h+8>>2]);ga=ea(g[h+12>>2]);_=h+16|0;ha=ea(g[_>>2]);ia=ea(g[_+4>>2]);ja=ea(g[_+8>>2]);g[u>>2]=ca;_=u+4|0;g[_>>2]=da;h=u+8|0;g[h>>2]=fa;f=u+12|0;g[f>>2]=ga;g[u+16>>2]=ha;g[u+20>>2]=ia;g[u+24>>2]=ja;g[u+28>>2]=ea(0.0);ka=ea(-ca);ca=ea(-da);da=ea(-fa);fa=ea($-ha);ha=ea(aa-ia);ia=ea(ba-ja);ja=ea(ea(ga*ga)+ea(-.5));ba=ea(ea(ea(fa*ka)+ea(ha*ca))+ea(ia*da));aa=ea(ea(ea(ba*ka)+ea(ea(ja*fa)+ea(ga*ea(ea(ia*ca)-ea(ha*da)))))*ea(2.0));$=ea(ea(ea(ba*ca)+ea(ea(ja*ha)+ea(ga*ea(ea(fa*da)-ea(ia*ka)))))*ea(2.0));la=ea(ea(ea(ea(ja*ia)+ea(ga*ea(ea(ha*ka)-ea(fa*ca))))+ea(ba*da))*ea(2.0));ba=ea(ea(ga*Z)-ea(ea(ea(W*ka)+ea(U*ca))+ea(S*da)));fa=ea(ea(ea(S*ca)-ea(U*da))+ea(ea(ga*W)+ea(Z*ka)));ha=ea(ea(ea(W*da)-ea(S*ka))+ea(ea(ga*U)+ea(Z*ca)));ia=ea(ea(ea(U*ka)-ea(W*ca))+ea(ea(ga*S)+ea(Z*da)));ma=v+48|0;g[ma>>2]=aa;na=v+52|0;g[na>>2]=$;oa=v+56|0;g[oa>>2]=la;g[v+60>>2]=ea(0.0);da=ea(fa+fa);Z=ea(ha+ha);S=ea(ia+ia);ga=ea(ha*Z);ca=ea(ia*S);W=ea(ha*da);ka=ea(ia*da);U=ea(ba*da);ja=ea(ia*Z);pa=ea(ba*Z);Z=ea(ba*S);S=ea(ea(1.0)-ea(fa*da));da=ea(W+Z);qa=ea(ka-pa);ra=ea(W-Z);Z=ea(S-ca);W=ea(ja+U);sa=ea(ka+pa);pa=ea(ja-U);U=ea(S-ga);g[v>>2]=ea(ea(ea(1.0)-ga)-ca);ta=v+4|0;g[ta>>2]=da;ua=v+8|0;g[ua>>2]=qa;g[v+12>>2]=ea(0.0);va=v+16|0;g[va>>2]=ra;wa=v+20|0;g[wa>>2]=Z;xa=v+24|0;g[xa>>2]=W;g[v+28>>2]=ea(0.0);ya=v+32|0;g[ya>>2]=sa;za=v+36|0;g[za>>2]=pa;Aa=v+40|0;g[Aa>>2]=U;g[v+44>>2]=ea(0.0);Ba=c[e+36>>2]|0;U=ea(g[Ba+52>>2]);pa=ea(g[Ba+56>>2]);sa=ea(g[Ba+60>>2]);W=ea(g[s>>2]);Z=ea(g[X>>2]);ra=ea(U*W);W=ea(pa*Z);Z=ea(sa*ea(g[Y>>2]));sa=!(ra<=W)?W:ra;ra=ea((!(sa<=Z)?Z:sa)*ea(.25));sa=!(P<=Q)?Q:P;Z=!(sa<=R)?R:sa;sa=ea(Z*ea(.150000006));W=ra>sa?sa:ra;g[w>>2]=ea(W*ea(.800000011));Y=O+32|0;X=a[Y>>0]|0;U7a(O,v,w,0);if(((a[Y>>0]|0)==X<<24>>24?(w=X&255,ra=ea(W*ea(g[544288+(w<<2)>>2])),pa=ea(g[O+16>>2]),U=ea(g[O+20>>2]),qa=ea(aa-pa),pa=ea($-U),U=ea(la-ea(g[O+24>>2])),da=ea(-qa),ca=ea(-pa),ga=ea(-U),S=qa>da?qa:da,da=pa>ca?pa:ca,ca=!(S>=da)?da:S,Ca=!((U>ga?U:ga)>=ea(0.0)),ga=Ca?ea(0.0):S,!((ca>=ga?ca:ga)>ra)):0)?(ra=ea(g[O+4>>2]),ga=ea(ha*ra),ra=ea(fa*ea(g[O>>2])),ca=ea(ia*ea(g[O+8>>2])),S=ea(ga+ra),ra=ea(ea(S+ca)+ea(ba*ea(g[O+12>>2]))),!(ea(g[544328+(w<<2)>>2])>ra)):0){if(!(X<<24>>24)){Da=0;i=m;return Da|0}X7a(N,O,u);OSa(O,l,N,u);Da=1;i=m;return Da|0}g[x>>2]=ea(W*ea(.0500000007));c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];g[B>>2]=ea(0.0);W=ea(g[e+16>>2]);ra=ea(g[e+20>>2]);ca=ea(g[e+24>>2]);S=ea(g[e+28>>2]);g[C>>2]=W;g[C+4>>2]=ra;g[C+8>>2]=ca;g[C+12>>2]=S;z1a(D,Ba,q,s,C);C=E+64|0;c[E+0>>2]=c[q+0>>2];c[E+4>>2]=c[q+4>>2];c[E+8>>2]=c[q+8>>2];c[E+12>>2]=c[q+12>>2];c[E+80>>2]=3;q=E+20|0;c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];s=E+36|0;Ba=E+52|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[C+0>>2]=c[n+0>>2];c[C+4>>2]=c[n+4>>2];c[C+8>>2]=c[n+8>>2];c[C+12>>2]=c[n+12>>2];g[E+144>>2]=P;g[E+148>>2]=Q;g[E+152>>2]=R;g[E+156>>2]=ea(0.0);S=!(P>=Q)?Q:P;P=ea((!(S>=R)?R:S)*ea(.0299999993));S=sa>P?sa:P;P=Z>S?S:Z;g[E+16>>2]=P;c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];g[E+32>>2]=ea(Z*ea(.0500000007));c[s+0>>2]=c[n+0>>2];c[s+4>>2]=c[n+4>>2];c[s+8>>2]=c[n+8>>2];Z=ea(P*P);g[E+48>>2]=ea(ea(T(ea(Z+ea(Z+Z))))-P);c[Ba+0>>2]=c[p+0>>2];c[Ba+4>>2]=c[p+4>>2];c[Ba+8>>2]=c[p+8>>2];if((ea(g[b>>2])==ea(1.0)?ea(g[k>>2])==ea(1.0):0)?ea(g[V>>2])==ea(1.0):0){Ea=1;Fa=f7a(E,D,v,r,y,z,A,B,O+34|0,O+38|0,O+33|0)|0}else{Ea=0;Fa=e7a(E,D,v,r,y,z,A,B,O+34|0,O+38|0,O+33|0)|0}g[O>>2]=fa;g[O+4>>2]=ha;g[O+8>>2]=ia;g[O+12>>2]=ba;g[O+16>>2]=aa;g[O+20>>2]=$;g[O+24>>2]=la;g[O+28>>2]=ea(0.0);c[F>>2]=0;if((Fa|0)==3){Da=Y7a(j,E,D,t,u,l,F,l,O,A,r,Ea,0)|0;i=m;return Da|0}else if(!Fa){Da=0;i=m;return Da|0}else{V=(Fa|0)==1;if(!(a[Y>>0]|0)){do if(!V)if((Fa|0)==6){a[M+4>>0]=0;c[M>>2]=541080;c[M+8>>2]=E;c[M+12>>2]=D;c[M+16>>2]=v;k=cPa(E,D,M,O+34|0,O+38|0,a[O+33>>0]|0,y,z,A,B,0)|0;if((k|0)==6){la=ea(g[y>>2]);$=ea(g[y+4>>2]);aa=ea(g[y+8>>2]);ba=ea(g[ma>>2]);ia=ea(g[na>>2]);ha=ea(la-ba);ba=ea($-ia);ia=ea(aa-ea(g[oa>>2]));aa=ea(ha*ea(g[v>>2]));$=ea(aa+ea(ba*ea(g[ta>>2])));aa=ea($+ea(ia*ea(g[ua>>2])));$=ea(ha*ea(g[va>>2]));la=ea($+ea(ba*ea(g[wa>>2])));$=ea(la+ea(ia*ea(g[xa>>2])));la=ea(ha*ea(g[ya>>2]));ha=ea(la+ea(ba*ea(g[za>>2])));ba=ea(ha+ea(ia*ea(g[Aa>>2])));ia=ea(g[A>>2]);ha=ea(g[A+4>>2]);la=ea(g[A+8>>2]);fa=ea(g[B>>2]);b=c[F>>2]|0;g[l+(b*48|0)>>2]=aa;g[l+(b*48|0)+4>>2]=$;g[l+(b*48|0)+8>>2]=ba;g[l+(b*48|0)+12>>2]=ea(0.0);p=l+(b*48|0)+16|0;c[p+0>>2]=c[z+0>>2];c[p+4>>2]=c[z+4>>2];c[p+8>>2]=c[z+8>>2];c[p+12>>2]=c[z+12>>2];c[F>>2]=b+1;g[l+(b*48|0)+32>>2]=ia;g[l+(b*48|0)+36>>2]=ha;g[l+(b*48|0)+40>>2]=la;g[l+(b*48|0)+44>>2]=fa;Ga=0;break}else if((k|0)==4){Ga=1;break}else{Ga=0;break}}else Ga=0;else{fa=ea(g[y>>2]);la=ea(g[y+4>>2]);ha=ea(g[y+8>>2]);ia=ea(g[ma>>2]);ba=ea(g[na>>2]);$=ea(fa-ia);ia=ea(la-ba);ba=ea(ha-ea(g[oa>>2]));ha=ea($*ea(g[v>>2]));la=ea(ha+ea(ia*ea(g[ta>>2])));ha=ea(la+ea(ba*ea(g[ua>>2])));la=ea($*ea(g[va>>2]));fa=ea(la+ea(ia*ea(g[wa>>2])));la=ea(fa+ea(ba*ea(g[xa>>2])));fa=ea($*ea(g[ya>>2]));$=ea(fa+ea(ia*ea(g[za>>2])));ia=ea($+ea(ba*ea(g[Aa>>2])));ba=ea(g[A>>2]);$=ea(g[A+4>>2]);fa=ea(g[A+8>>2]);aa=ea(g[B>>2]);g[l>>2]=ha;g[l+4>>2]=la;g[l+8>>2]=ia;g[l+12>>2]=ea(0.0);k=l+16|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[k+12>>2]=c[z+12>>2];c[F>>2]=1;g[l+32>>2]=ba;g[l+36>>2]=$;g[l+40>>2]=fa;g[l+44>>2]=aa;Ga=0}while(0);Da=Y7a(j,E,D,t,u,l,F,l,O,A,r,Ea,Ga)|0;i=m;return Da|0}do if(V){aa=ea(g[y>>2]);fa=ea(g[y+4>>2]);$=ea(g[y+8>>2]);ba=ea(g[ma>>2]);ia=ea(g[na>>2]);la=ea(aa-ba);ba=ea(fa-ia);ia=ea($-ea(g[oa>>2]));$=ea(la*ea(g[v>>2]));fa=ea($+ea(ba*ea(g[ta>>2])));$=ea(fa+ea(ia*ea(g[ua>>2])));fa=ea(la*ea(g[va>>2]));aa=ea(fa+ea(ba*ea(g[wa>>2])));fa=ea(aa+ea(ia*ea(g[xa>>2])));aa=ea(la*ea(g[ya>>2]));la=ea(aa+ea(ba*ea(g[za>>2])));ba=ea(la+ea(ia*ea(g[Aa>>2])));ia=ea(g[A>>2]);la=ea(g[A+4>>2]);aa=ea(g[A+8>>2]);ha=ea(g[B>>2]);g[G>>2]=ia;g[G+4>>2]=la;g[G+8>>2]=aa;g[G+12>>2]=ha;g[l>>2]=$;g[l+4>>2]=fa;g[l+8>>2]=ba;g[l+12>>2]=ea(0.0);Ga=l+16|0;c[Ga+0>>2]=c[z+0>>2];c[Ga+4>>2]=c[z+4>>2];c[Ga+8>>2]=c[z+8>>2];c[Ga+12>>2]=c[z+12>>2];c[F>>2]=1;Ga=l+32|0;c[Ga+0>>2]=c[G+0>>2];c[Ga+4>>2]=c[G+4>>2];c[Ga+8>>2]=c[G+8>>2];c[Ga+12>>2]=c[G+12>>2];g[H>>2]=$;g[H+4>>2]=fa;g[H+8>>2]=ba;g[H+12>>2]=ea(0.0);WSa(O,H,z,G,x)|0;Ha=16}else{a[I+4>>0]=0;c[I>>2]=541080;c[I+8>>2]=E;c[I+12>>2]=D;c[I+16>>2]=v;Ga=cPa(E,D,I,O+34|0,O+38|0,a[O+33>>0]|0,y,z,A,B,0)|0;if((Ga|0)==4){Ia=E;Ja=1;break}else if((Ga|0)!=6){Ha=16;break}ba=ea(g[y>>2]);fa=ea(g[y+4>>2]);$=ea(g[y+8>>2]);ha=ea(g[ma>>2]);aa=ea(g[na>>2]);la=ea(ba-ha);ha=ea(fa-aa);aa=ea($-ea(g[oa>>2]));$=ea(la*ea(g[v>>2]));fa=ea($+ea(ha*ea(g[ta>>2])));$=ea(fa+ea(aa*ea(g[ua>>2])));fa=ea(la*ea(g[va>>2]));ba=ea(fa+ea(ha*ea(g[wa>>2])));fa=ea(ba+ea(aa*ea(g[xa>>2])));ba=ea(la*ea(g[ya>>2]));la=ea(ba+ea(ha*ea(g[za>>2])));ha=ea(la+ea(aa*ea(g[Aa>>2])));g[J>>2]=$;g[J+4>>2]=fa;g[J+8>>2]=ha;g[J+12>>2]=ea(0.0);ha=ea(g[A>>2]);fa=ea(g[A+4>>2]);$=ea(g[A+8>>2]);aa=ea(g[B>>2]);g[K>>2]=ha;g[K+4>>2]=fa;g[K+8>>2]=$;g[K+12>>2]=aa;Ga=c[F>>2]|0;M=l+(Ga*48|0)|0;c[M+0>>2]=c[J+0>>2];c[M+4>>2]=c[J+4>>2];c[M+8>>2]=c[J+8>>2];c[M+12>>2]=c[J+12>>2];M=l+(Ga*48|0)+16|0;c[M+0>>2]=c[z+0>>2];c[M+4>>2]=c[z+4>>2];c[M+8>>2]=c[z+8>>2];c[M+12>>2]=c[z+12>>2];c[F>>2]=Ga+1;M=l+(Ga*48|0)+32|0;c[M+0>>2]=c[K+0>>2];c[M+4>>2]=c[K+4>>2];c[M+8>>2]=c[K+8>>2];c[M+12>>2]=c[K+12>>2];WSa(O,J,z,K,x)|0;Ha=16}while(0);do if((Ha|0)==16){if((d[Y>>0]|0)<(X&255)){Ia=E;Ja=0;break}aa=ea(g[u>>2]);$=ea(g[_>>2]);fa=ea(g[h>>2]);ha=ea(g[f>>2]);la=ea(g[A>>2]);ba=ea(g[A+4>>2]);ia=ea(g[A+8>>2]);P=ea(ea(ha*ha)+ea(-.5));Z=ea(ea(ea(aa*la)+ea($*ba))+ea(fa*ia));S=ea(ea(ea($*Z)+ea(ea(P*ba)+ea(ha*ea(ea(fa*la)-ea(aa*ia)))))*ea(2.0));sa=ea(ea(ea(ea(P*ia)+ea(ha*ea(ea(aa*ba)-ea($*la))))+ea(fa*Z))*ea(2.0));g[L>>2]=ea(ea(ea(aa*Z)+ea(ea(la*P)+ea(ha*ea(ea($*ia)-ea(fa*ba)))))*ea(2.0));g[L+4>>2]=S;g[L+8>>2]=sa;g[L+12>>2]=ea(0.0);OSa(O,l,L,u);Da=1;i=m;return Da|0}while(0);Da=Y7a(j,Ia,D,t,u,l,F,l,O,A,r,Ea,Ja)|0;i=m;return Da|0}return 0}function $Ra(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;l=i;i=i+768|0;m=l+704|0;n=l+160|0;o=l+176|0;p=l+208|0;q=l+96|0;r=l+128|0;s=l+416|0;t=l+624|0;u=l+656|0;v=l+688|0;w=l+224|0;x=l+240|0;y=l+720|0;z=l;A=l+16|0;B=l+256|0;C=l+480|0;D=l+732|0;E=l+736|0;F=l+748|0;G=l+672|0;H=l+640|0;I=l+192|0;J=l+80|0;K=c[j>>2]|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;j=d+4|0;L=ea(g[j>>2]);M=d+8|0;N=ea(g[M>>2]);O=d+12|0;P=ea(g[O>>2]);g[p>>2]=ea(g[h>>2]);Q=ea(g[e>>2]);R=ea(g[e+4>>2]);S=ea(g[e+8>>2]);T=ea(g[e+12>>2]);h=e+16|0;U=ea(g[h>>2]);V=ea(g[h+4>>2]);W=ea(g[h+8>>2]);g[q>>2]=Q;g[q+4>>2]=R;g[q+8>>2]=S;g[q+12>>2]=T;g[q+16>>2]=U;g[q+20>>2]=V;g[q+24>>2]=W;g[q+28>>2]=ea(0.0);X=ea(g[f>>2]);Y=ea(g[f+4>>2]);Z=ea(g[f+8>>2]);_=ea(g[f+12>>2]);h=f+16|0;$=ea(g[h>>2]);aa=ea(g[h+4>>2]);ba=ea(g[h+8>>2]);g[r>>2]=X;h=r+4|0;g[h>>2]=Y;f=r+8|0;g[f>>2]=Z;e=r+12|0;g[e>>2]=_;g[r+16>>2]=$;g[r+20>>2]=aa;g[r+24>>2]=ba;g[r+28>>2]=ea(0.0);ca=ea(-X);X=ea(-Y);Y=ea(-Z);Z=ea(U-$);$=ea(V-aa);aa=ea(W-ba);ba=ea(ea(_*_)+ea(-.5));W=ea(ea(ea(Z*ca)+ea($*X))+ea(aa*Y));V=ea(ea(ea(W*ca)+ea(ea(ba*Z)+ea(_*ea(ea(aa*X)-ea($*Y)))))*ea(2.0));U=ea(ea(ea(W*X)+ea(ea(ba*$)+ea(_*ea(ea(Z*Y)-ea(aa*ca)))))*ea(2.0));da=ea(ea(ea(ea(ba*aa)+ea(_*ea(ea($*ca)-ea(Z*X))))+ea(W*Y))*ea(2.0));W=ea(ea(_*T)-ea(ea(ea(Q*ca)+ea(R*X))+ea(S*Y)));Z=ea(ea(ea(S*X)-ea(R*Y))+ea(ea(_*Q)+ea(T*ca)));$=ea(ea(ea(Q*Y)-ea(S*ca))+ea(ea(_*R)+ea(T*X)));aa=ea(ea(ea(R*ca)-ea(Q*X))+ea(ea(_*S)+ea(T*Y)));g[s+48>>2]=V;g[s+52>>2]=U;g[s+56>>2]=da;g[s+60>>2]=ea(0.0);Y=ea(Z+Z);T=ea($+$);S=ea(aa+aa);_=ea($*T);X=ea(aa*S);Q=ea($*Y);ca=ea(aa*Y);R=ea(W*Y);ba=ea(aa*T);fa=ea(W*T);T=ea(W*S);S=ea(ea(1.0)-ea(Z*Y));Y=ea(ea(ea(1.0)-_)-X);ga=ea(Q+T);ha=ea(ca-fa);ia=ea(Q-T);T=ea(S-X);X=ea(ba+R);Q=ea(ca+fa);fa=ea(ba-R);R=ea(S-_);g[s>>2]=Y;g[s+4>>2]=ga;g[s+8>>2]=ha;g[s+12>>2]=ea(0.0);g[s+16>>2]=ia;g[s+20>>2]=T;g[s+24>>2]=X;g[s+28>>2]=ea(0.0);g[s+32>>2]=Q;g[s+36>>2]=fa;g[s+40>>2]=R;g[s+44>>2]=ea(0.0);_=ea(g[b+4>>2]);g[t>>2]=_;S=ea(g[b+8>>2]);b=K+32|0;d=a[b>>0]|0;ba=!(L<=N)?N:L;ca=!(ba<=P)?P:ba;ba=ea(ca*ea(.150000006));ja=ba>_?_:ba;g[u>>2]=ea(ja*ea(.800000011));U7a(K,s,u,0);u=(a[b>>0]|0)!=d<<24>>24;if(!u){b=d&255;ba=ea(ja*ea(g[544312+(b<<2)>>2]));s=K+16|0;_=ea(g[s>>2]);ka=K+20|0;la=ea(g[ka>>2]);ma=K+24|0;na=ea(V-_);_=ea(U-la);la=ea(da-ea(g[ma>>2]));oa=ea(-na);pa=ea(-_);qa=ea(-la);ra=na>oa?na:oa;oa=_>pa?_:pa;pa=!(ra>=oa)?oa:ra;sa=!((la>qa?la:qa)>=ea(0.0));qa=sa?ea(0.0):ra;if(!((pa>=qa?pa:qa)>ba)?(ba=ea(g[K+4>>2]),qa=ea($*ba),ba=ea(Z*ea(g[K>>2])),pa=ea(aa*ea(g[K+8>>2])),ra=ea(qa+ba),ba=ea(ea(ra+pa)+ea(W*ea(g[K+12>>2]))),!(ea(g[544352+(b<<2)>>2])>ba)):0){if(!(d<<24>>24)){ta=0;i=l;return ta|0}X7a(J,K,r);QSa(K,k,J,q,t);ta=1;i=l;return ta|0}else{ua=ka;va=ma;wa=s}}else{ua=K+20|0;va=K+24|0;wa=K+16|0};c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[x+0>>2]=c[o+0>>2];c[x+4>>2]=c[o+4>>2];c[x+8>>2]=c[o+8>>2];c[x+12>>2]=c[o+12>>2];g[z>>2]=ea(0.0);o=z+4|0;c[o+0>>2]=c[y+0>>2];c[o+4>>2]=c[y+4>>2];c[o+8>>2]=c[y+8>>2];g[K>>2]=Z;g[K+4>>2]=$;g[K+8>>2]=aa;g[K+12>>2]=W;g[wa>>2]=V;g[ua>>2]=U;g[va>>2]=da;g[K+28>>2]=ea(0.0);va=A+48|0;g[va>>2]=V;ua=A+52|0;g[ua>>2]=U;wa=A+56|0;g[wa>>2]=da;g[A+60>>2]=ea(0.0);g[A>>2]=Y;o=A+4|0;g[o>>2]=ga;s=A+8|0;g[s>>2]=ha;g[A+12>>2]=ea(0.0);ma=A+16|0;g[ma>>2]=ia;ka=A+20|0;g[ka>>2]=T;J=A+24|0;g[J>>2]=X;g[A+28>>2]=ea(0.0);b=A+32|0;g[b>>2]=Q;sa=A+36|0;g[sa>>2]=fa;xa=A+40|0;g[xa>>2]=R;g[A+44>>2]=ea(0.0);ya=r+16|0;za=B+64|0;c[B+0>>2]=c[ya+0>>2];c[B+4>>2]=c[ya+4>>2];c[B+8>>2]=c[ya+8>>2];c[B+12>>2]=c[ya+12>>2];c[B+80>>2]=3;ya=B+20|0;Aa=B+36|0;g[B+48>>2]=ea(0.0);Ba=B+52|0;c[Ba+0>>2]=c[m+0>>2];c[Ba+4>>2]=c[m+4>>2];c[Ba+8>>2]=c[m+8>>2];c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[za+0>>2]=c[n+0>>2];c[za+4>>2]=c[n+4>>2];c[za+8>>2]=c[n+8>>2];c[za+12>>2]=c[n+12>>2];g[B+144>>2]=L;g[B+148>>2]=N;g[B+152>>2]=P;g[B+156>>2]=ea(0.0);g[B+32>>2]=ea(ca*ea(.0500000007));c[Aa+0>>2]=c[n+0>>2];c[Aa+4>>2]=c[n+4>>2];c[Aa+8>>2]=c[n+8>>2];g[B+16>>2]=ea(0.0);c[ya+0>>2]=c[y+0>>2];c[ya+4>>2]=c[y+4>>2];c[ya+8>>2]=c[y+8>>2];y=A+48|0;ca=ea(S*ea(0.0));P=ea(ea(ea(S*Y)+ea(ca*ia))+ea(ca*Q));Q=ea(ea(ea(S*ga)+ea(ca*T))+ea(ca*fa));fa=ea(ea(ea(S*ha)+ea(ca*X))+ea(ca*R));ya=C+64|0;c[C+0>>2]=c[y+0>>2];c[C+4>>2]=c[y+4>>2];c[C+8>>2]=c[y+8>>2];c[C+12>>2]=c[y+12>>2];c[C+80>>2]=4;g[C+48>>2]=ea(0.0);Aa=C+52|0;c[Aa+0>>2]=c[n+0>>2];c[Aa+4>>2]=c[n+4>>2];c[Aa+8>>2]=c[n+8>>2];n=C+128|0;c[n+0>>2]=c[t+0>>2];c[n+4>>2]=c[t+4>>2];c[n+8>>2]=c[t+8>>2];c[n+12>>2]=c[t+12>>2];R=ea(g[y>>2]);ca=ea(g[ua>>2]);X=ea(g[wa>>2]);ha=ea(Q+ca);S=ea(fa+X);g[C+96>>2]=ea(P+R);g[C+100>>2]=ha;g[C+104>>2]=S;g[C+108>>2]=ea(0.0);S=ea(ca-Q);Q=ea(X-fa);g[C+112>>2]=ea(R-P);g[C+116>>2]=S;g[C+120>>2]=Q;g[C+124>>2]=ea(0.0);y=C+16|0;c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];y=C+32|0;c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[m+0>>2]=-1;c[m+4>>2]=-1;c[m+8>>2]=-1;c[m+12>>2]=-1;c[ya+0>>2]=c[m+0>>2];c[ya+4>>2]=c[m+4>>2];c[ya+8>>2]=c[m+8>>2];c[ya+12>>2]=c[m+12>>2];m=K+34|0;ya=K+38|0;y=K+33|0;n=nPa(C,B,p,v,w,x,z,m,ya,y,1)|0;c[D>>2]=0;do if((n|0)==1){Q=ea(g[v>>2]);S=ea(g[v+4>>2]);P=ea(Q-R);Q=ea(S-ca);S=ea(ea(g[v+8>>2])-X);fa=ea(P*ea(g[A>>2]));ha=ea(fa+ea(Q*ea(g[o>>2])));fa=ea(ha+ea(S*ea(g[s>>2])));ha=ea(P*ea(g[ma>>2]));T=ea(ha+ea(Q*ea(g[ka>>2])));ha=ea(T+ea(S*ea(g[J>>2])));T=ea(P*ea(g[b>>2]));P=ea(T+ea(Q*ea(g[sa>>2])));Q=ea(P+ea(S*ea(g[xa>>2])));S=ea(g[x>>2]);P=ea(g[x+4>>2]);T=ea(g[x+8>>2]);ga=ea(g[z>>2]);g[k>>2]=fa;g[k+4>>2]=ha;g[k+8>>2]=Q;g[k+12>>2]=ea(0.0);Aa=k+16|0;c[Aa+0>>2]=c[w+0>>2];c[Aa+4>>2]=c[w+4>>2];c[Aa+8>>2]=c[w+8>>2];c[Aa+12>>2]=c[w+12>>2];c[D>>2]=1;g[k+32>>2]=S;g[k+36>>2]=P;g[k+40>>2]=T;g[k+44>>2]=ga;Ca=10}else if((n|0)==3){g[E>>2]=ea(g[j>>2]);g[E+4>>2]=ea(g[M>>2]);g[E+8>>2]=ea(g[O>>2]);ta=Z7a(C,B,E,A,q,r,k,D,k,K,x,p,0)|0;i=l;return ta|0}else if(!n){ta=0;i=l;return ta|0}else{Aa=kPa(C,B,v,w,x,z,m,ya,y,1)|0;if((Aa|0)==4){Da=1;break}else if((Aa|0)!=6){Ca=10;break}ga=ea(g[v>>2]);T=ea(g[v+4>>2]);P=ea(g[v+8>>2]);S=ea(g[va>>2]);Q=ea(g[ua>>2]);ha=ea(ga-S);S=ea(T-Q);Q=ea(P-ea(g[wa>>2]));P=ea(ha*ea(g[A>>2]));T=ea(P+ea(S*ea(g[o>>2])));P=ea(T+ea(Q*ea(g[s>>2])));T=ea(ha*ea(g[ma>>2]));ga=ea(T+ea(S*ea(g[ka>>2])));T=ea(ga+ea(Q*ea(g[J>>2])));ga=ea(ha*ea(g[b>>2]));ha=ea(ga+ea(S*ea(g[sa>>2])));S=ea(ha+ea(Q*ea(g[xa>>2])));Q=ea(g[x>>2]);ha=ea(g[x+4>>2]);ga=ea(g[x+8>>2]);fa=ea(g[z>>2]);Aa=c[D>>2]|0;g[k+(Aa*48|0)>>2]=P;g[k+(Aa*48|0)+4>>2]=T;g[k+(Aa*48|0)+8>>2]=S;g[k+(Aa*48|0)+12>>2]=ea(0.0);za=k+(Aa*48|0)+16|0;c[za+0>>2]=c[w+0>>2];c[za+4>>2]=c[w+4>>2];c[za+8>>2]=c[w+8>>2];c[za+12>>2]=c[w+12>>2];c[D>>2]=Aa+1;g[k+(Aa*48|0)+32>>2]=Q;g[k+(Aa*48|0)+36>>2]=ha;g[k+(Aa*48|0)+40>>2]=ga;g[k+(Aa*48|0)+44>>2]=fa;Ca=10}while(0);if((Ca|0)==10)if(d<<24>>24==0|u)Da=0;else{g[G>>2]=ea(ja*ea(.100000001));ja=ea(g[x>>2]);u=x+4|0;X=ea(g[u>>2]);d=x+8|0;ca=ea(g[d>>2]);R=ea(g[z>>2]);g[H>>2]=ja;g[H+4>>2]=X;g[H+8>>2]=ca;g[H+12>>2]=R;R=ea(g[v>>2]);ca=ea(g[v+4>>2]);X=ea(R-V);V=ea(ca-U);U=ea(ea(g[v+8>>2])-da);da=ea(ea(W*W)+ea(-.5));ca=ea(ea(ea(Z*X)+ea($*V))+ea(aa*U));R=ea(ea(ea($*ca)+ea(ea(da*V)-ea(W*ea(ea(aa*X)-ea(Z*U)))))*ea(2.0));ja=ea(ea(ea(ea(da*U)-ea(W*ea(ea(Z*V)-ea($*X))))+ea(aa*ca))*ea(2.0));g[I>>2]=ea(ea(ea(Z*ca)+ea(ea(da*X)-ea(W*ea(ea($*U)-ea(aa*V)))))*ea(2.0));g[I+4>>2]=R;g[I+8>>2]=ja;g[I+12>>2]=ea(0.0);XSa(K,I,w,H,G)|0;ja=ea(g[r>>2]);R=ea(g[h>>2]);V=ea(g[f>>2]);aa=ea(g[e>>2]);U=ea(g[x>>2]);$=ea(g[u>>2]);W=ea(g[d>>2]);X=ea(ea(aa*aa)+ea(-.5));da=ea(ea(ea(ja*U)+ea(R*$))+ea(V*W));ca=ea(ea(ea(R*da)+ea(ea(X*$)+ea(aa*ea(ea(V*U)-ea(ja*W)))))*ea(2.0));Z=ea(ea(ea(ea(X*W)+ea(aa*ea(ea(ja*$)-ea(R*U))))+ea(V*da))*ea(2.0));g[x>>2]=ea(ea(ea(ja*da)+ea(ea(U*X)+ea(aa*ea(ea(R*W)-ea(V*$)))))*ea(2.0));g[u>>2]=ca;g[d>>2]=Z;g[x+12>>2]=ea(0.0);QSa(K,k,x,q,t);ta=1;i=l;return ta|0}g[F>>2]=ea(g[j>>2]);g[F+4>>2]=ea(g[M>>2]);g[F+8>>2]=ea(g[O>>2]);ta=Z7a(C,B,F,A,q,r,k,D,k,K,x,p,Da)|0;i=l;return ta|0}function aSa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=0,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;l=i;i=i+768|0;m=l+720|0;n=l+80|0;o=l+96|0;p=l+256|0;q=l+48|0;r=l+64|0;s=l+320|0;t=l+560|0;u=l+608|0;v=l+688|0;w=l+272|0;x=l+288|0;y=l+704|0;z=l+732|0;A=l+16|0;B=l+304|0;C=l+352|0;D=l+112|0;E=l+744|0;F=l+752|0;G=l+672|0;H=l+592|0;I=l;J=l+32|0;K=c[j>>2]|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;j=d+4|0;L=ea(g[j>>2]);M=d+8|0;N=ea(g[M>>2]);O=d+12|0;P=ea(g[O>>2]);g[p>>2]=L;Q=p+4|0;g[Q>>2]=N;R=p+8|0;g[R>>2]=P;g[p+12>>2]=ea(0.0);g[q>>2]=ea(g[h>>2]);P=ea(g[b+8>>2]);g[r>>2]=ea(g[b+4>>2]);b=c[d+36>>2]|0;N=ea(g[e>>2]);L=ea(g[e+4>>2]);S=ea(g[e+8>>2]);T=ea(g[e+12>>2]);h=e+16|0;U=ea(g[h>>2]);V=ea(g[h+4>>2]);W=ea(g[h+8>>2]);g[s>>2]=N;g[s+4>>2]=L;g[s+8>>2]=S;g[s+12>>2]=T;g[s+16>>2]=U;g[s+20>>2]=V;g[s+24>>2]=W;g[s+28>>2]=ea(0.0);X=ea(g[f>>2]);Y=ea(g[f+4>>2]);Z=ea(g[f+8>>2]);_=ea(g[f+12>>2]);h=f+16|0;$=ea(g[h>>2]);aa=ea(g[h+4>>2]);ba=ea(g[h+8>>2]);g[t>>2]=X;h=t+4|0;g[h>>2]=Y;f=t+8|0;g[f>>2]=Z;e=t+12|0;g[e>>2]=_;g[t+16>>2]=$;g[t+20>>2]=aa;g[t+24>>2]=ba;g[t+28>>2]=ea(0.0);ca=ea(-X);X=ea(-Y);Y=ea(-Z);Z=ea(U-$);$=ea(V-aa);aa=ea(W-ba);ba=ea(ea(_*_)+ea(-.5));W=ea(ea(ea(Z*ca)+ea($*X))+ea(aa*Y));V=ea(ea(ea(W*ca)+ea(ea(ba*Z)+ea(_*ea(ea(aa*X)-ea($*Y)))))*ea(2.0));U=ea(ea(ea(W*X)+ea(ea(ba*$)+ea(_*ea(ea(Z*Y)-ea(aa*ca)))))*ea(2.0));da=ea(ea(ea(ea(ba*aa)+ea(_*ea(ea($*ca)-ea(Z*X))))+ea(W*Y))*ea(2.0));W=ea(ea(_*T)-ea(ea(ea(N*ca)+ea(L*X))+ea(S*Y)));Z=ea(ea(ea(S*X)-ea(L*Y))+ea(ea(_*N)+ea(T*ca)));$=ea(ea(ea(N*Y)-ea(S*ca))+ea(ea(_*L)+ea(T*X)));aa=ea(ea(ea(L*ca)-ea(N*X))+ea(ea(_*S)+ea(T*Y)));fa=u+48|0;g[fa>>2]=V;ga=u+52|0;g[ga>>2]=U;ha=u+56|0;g[ha>>2]=da;g[u+60>>2]=ea(0.0);Y=ea(Z+Z);T=ea($+$);S=ea(aa+aa);_=ea($*T);X=ea(aa*S);N=ea($*Y);ca=ea(aa*Y);L=ea(W*Y);ba=ea(aa*T);ia=ea(W*T);T=ea(W*S);S=ea(ea(1.0)-ea(Z*Y));Y=ea(N+T);ja=ea(ca-ia);ka=ea(N-T);T=ea(S-X);N=ea(ba+L);la=ea(ca+ia);ia=ea(ba-L);L=ea(S-_);g[u>>2]=ea(ea(ea(1.0)-_)-X);ma=u+4|0;g[ma>>2]=Y;na=u+8|0;g[na>>2]=ja;g[u+12>>2]=ea(0.0);oa=u+16|0;g[oa>>2]=ka;pa=u+20|0;g[pa>>2]=T;qa=u+24|0;g[qa>>2]=N;g[u+28>>2]=ea(0.0);ra=u+32|0;g[ra>>2]=la;sa=u+36|0;g[sa>>2]=ia;ta=u+40|0;g[ta>>2]=L;g[u+44>>2]=ea(0.0);L=ea(g[b+52>>2]);ia=ea(g[b+56>>2]);la=ea(g[b+60>>2]);N=ea(g[p>>2]);T=ea(g[Q>>2]);ka=ea(L*N);N=ea(ia*T);T=ea(la*ea(g[R>>2]));la=!(ka<=N)?N:ka;ka=ea((!(la<=T)?T:la)*ea(.25));la=ea(ea(g[r>>2])*ea(.0500000007));T=ka>la?la:ka;R=K+32|0;Q=a[R>>0]|0;g[v>>2]=ea(T*ea(1.25));U7a(K,u,v,0);v=(a[R>>0]|0)!=Q<<24>>24;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[x+0>>2]=c[o+0>>2];c[x+4>>2]=c[o+4>>2];c[x+8>>2]=c[o+8>>2];c[x+12>>2]=c[o+12>>2];c[y+0>>2]=c[o+0>>2];c[y+4>>2]=c[o+4>>2];c[y+8>>2]=c[o+8>>2];c[y+12>>2]=c[o+12>>2];g[A>>2]=ea(0.0);ua=A+4|0;c[ua+0>>2]=c[z+0>>2];c[ua+4>>2]=c[z+4>>2];c[ua+8>>2]=c[z+8>>2];if(!v){ua=a[R>>0]|0;R=ua&255;ka=ea(T*ea(g[544312+(R<<2)>>2]));va=K+16|0;la=ea(g[va>>2]);wa=K+20|0;N=ea(g[wa>>2]);xa=K+24|0;ia=ea(V-la);la=ea(U-N);N=ea(da-ea(g[xa>>2]));L=ea(-ia);ja=ea(-la);Y=ea(-N);X=ia>L?ia:L;L=la>ja?la:ja;ja=!(X>=L)?L:X;ya=!((N>Y?N:Y)>=ea(0.0));Y=ya?ea(0.0):X;if(!((ja>=Y?ja:Y)>ka)?(ka=ea(g[K+4>>2]),Y=ea($*ka),ka=ea(Z*ea(g[K>>2])),ja=ea(aa*ea(g[K+8>>2])),X=ea(Y+ka),ka=ea(ea(X+ja)+ea(W*ea(g[K+12>>2]))),!(ea(g[544352+(R<<2)>>2])>ka)):0){if(!(ua<<24>>24)){za=0;i=l;return za|0}X7a(J,K,t);c[y+0>>2]=c[J+0>>2];c[y+4>>2]=c[J+4>>2];c[y+8>>2]=c[J+8>>2];c[y+12>>2]=c[J+12>>2];QSa(K,k,y,s,r);za=1;i=l;return za|0}else{Aa=wa;Ba=xa;Ca=va}}else{Aa=K+20|0;Ba=K+24|0;Ca=K+16|0}g[K>>2]=Z;g[K+4>>2]=$;g[K+8>>2]=aa;g[K+12>>2]=W;g[Ca>>2]=V;g[Aa>>2]=U;g[Ba>>2]=da;g[K+28>>2]=ea(0.0);da=ea(g[d+16>>2]);U=ea(g[d+20>>2]);V=ea(g[d+24>>2]);W=ea(g[d+28>>2]);g[B>>2]=da;g[B+4>>2]=U;g[B+8>>2]=V;g[B+12>>2]=W;z1a(C,b,o,p,B);g[C+16>>2]=ea(0.0);B=C+20|0;c[B+0>>2]=c[z+0>>2];c[B+4>>2]=c[z+4>>2];c[B+8>>2]=c[z+8>>2];z=u+48|0;W=ea(P*ea(0.0));V=ea(P*ea(g[u>>2]));U=ea(V+ea(W*ea(g[oa>>2])));V=ea(U+ea(W*ea(g[ra>>2])));U=ea(P*ea(g[ma>>2]));da=ea(U+ea(W*ea(g[pa>>2])));U=ea(da+ea(W*ea(g[sa>>2])));da=ea(P*ea(g[na>>2]));P=ea(da+ea(W*ea(g[qa>>2])));da=ea(P+ea(W*ea(g[ta>>2])));B=D+64|0;c[D+0>>2]=c[z+0>>2];c[D+4>>2]=c[z+4>>2];c[D+8>>2]=c[z+8>>2];c[D+12>>2]=c[z+12>>2];c[D+80>>2]=4;g[D+48>>2]=ea(0.0);p=D+52|0;c[p+0>>2]=c[m+0>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2];m=D+128|0;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];W=ea(g[z>>2]);P=ea(g[ga>>2]);aa=ea(g[ha>>2]);$=ea(U+P);Z=ea(da+aa);g[D+96>>2]=ea(V+W);g[D+100>>2]=$;g[D+104>>2]=Z;g[D+108>>2]=ea(0.0);Z=ea(P-U);U=ea(aa-da);g[D+112>>2]=ea(W-V);g[D+116>>2]=Z;g[D+120>>2]=U;g[D+124>>2]=ea(0.0);z=D+16|0;c[z+0>>2]=c[r+0>>2];c[z+4>>2]=c[r+4>>2];c[z+8>>2]=c[r+8>>2];c[z+12>>2]=c[r+12>>2];z=D+32|0;c[z+0>>2]=c[r+0>>2];c[z+4>>2]=c[r+4>>2];c[z+8>>2]=c[r+8>>2];c[z+12>>2]=c[r+12>>2];c[n+0>>2]=-1;c[n+4>>2]=-1;c[n+8>>2]=-1;c[n+12>>2]=-1;c[B+0>>2]=c[n+0>>2];c[B+4>>2]=c[n+4>>2];c[B+8>>2]=c[n+8>>2];c[B+12>>2]=c[n+12>>2];if((ea(g[j>>2])==ea(1.0)?ea(g[M>>2])==ea(1.0):0)?ea(g[O>>2])==ea(1.0):0){Da=1;Ea=c7a(D,C,q,w,x,y,A,K+34|0,K+38|0,K+33|0,1)|0}else{Da=0;Ea=a7a(D,C,q,w,x,y,A,K+34|0,K+38|0,K+33|0,1)|0}c[E>>2]=0;do if((Ea|0)==3){za=_7a(D,C,u,s,t,k,E,k,Da,K,y,q,0)|0;i=l;return za|0}else if((Ea|0)==1){U=ea(g[w>>2]);Z=ea(g[w+4>>2]);V=ea(g[w+8>>2]);W=ea(g[fa>>2]);da=ea(g[ga>>2]);aa=ea(U-W);W=ea(Z-da);da=ea(V-ea(g[ha>>2]));V=ea(aa*ea(g[u>>2]));Z=ea(V+ea(W*ea(g[ma>>2])));V=ea(Z+ea(da*ea(g[na>>2])));Z=ea(aa*ea(g[oa>>2]));U=ea(Z+ea(W*ea(g[pa>>2])));Z=ea(U+ea(da*ea(g[qa>>2])));U=ea(aa*ea(g[ra>>2]));aa=ea(U+ea(W*ea(g[sa>>2])));W=ea(aa+ea(da*ea(g[ta>>2])));da=ea(g[y>>2]);aa=ea(g[y+4>>2]);U=ea(g[y+8>>2]);P=ea(g[A>>2]);g[k>>2]=V;g[k+4>>2]=Z;g[k+8>>2]=W;g[k+12>>2]=ea(0.0);O=k+16|0;c[O+0>>2]=c[x+0>>2];c[O+4>>2]=c[x+4>>2];c[O+8>>2]=c[x+8>>2];c[O+12>>2]=c[x+12>>2];c[E>>2]=1;g[k+32>>2]=da;g[k+36>>2]=aa;g[k+40>>2]=U;g[k+44>>2]=P;Fa=15}else if(!Ea){za=0;i=l;return za|0}else{a[F+4>>0]=0;c[F>>2]=541208;c[F+8>>2]=D;c[F+12>>2]=C;O=cPa(D,C,F,K+34|0,K+38|0,a[K+33>>0]|0,w,x,y,A,1)|0;if((O|0)==4){Ga=1;break}else if((O|0)!=6){Fa=15;break}P=ea(g[w>>2]);U=ea(g[w+4>>2]);aa=ea(g[w+8>>2]);da=ea(g[fa>>2]);W=ea(g[ga>>2]);Z=ea(P-da);da=ea(U-W);W=ea(aa-ea(g[ha>>2]));aa=ea(Z*ea(g[u>>2]));U=ea(aa+ea(da*ea(g[ma>>2])));aa=ea(U+ea(W*ea(g[na>>2])));U=ea(Z*ea(g[oa>>2]));P=ea(U+ea(da*ea(g[pa>>2])));U=ea(P+ea(W*ea(g[qa>>2])));P=ea(Z*ea(g[ra>>2]));Z=ea(P+ea(da*ea(g[sa>>2])));da=ea(Z+ea(W*ea(g[ta>>2])));W=ea(g[y>>2]);Z=ea(g[y+4>>2]);P=ea(g[y+8>>2]);V=ea(g[A>>2]);O=c[E>>2]|0;g[k+(O*48|0)>>2]=aa;g[k+(O*48|0)+4>>2]=U;g[k+(O*48|0)+8>>2]=da;g[k+(O*48|0)+12>>2]=ea(0.0);M=k+(O*48|0)+16|0;c[M+0>>2]=c[x+0>>2];c[M+4>>2]=c[x+4>>2];c[M+8>>2]=c[x+8>>2];c[M+12>>2]=c[x+12>>2];c[E>>2]=O+1;g[k+(O*48|0)+32>>2]=W;g[k+(O*48|0)+36>>2]=Z;g[k+(O*48|0)+40>>2]=P;g[k+(O*48|0)+44>>2]=V;Fa=15}while(0);if((Fa|0)==15)if(Q<<24>>24==0|v)Ga=0;else{g[G>>2]=ea(T*ea(.0500000007));T=ea(g[y>>2]);v=y+4|0;V=ea(g[v>>2]);Q=y+8|0;P=ea(g[Q>>2]);Z=ea(g[A>>2]);g[H>>2]=T;g[H+4>>2]=V;g[H+8>>2]=P;g[H+12>>2]=Z;Z=ea(g[w>>2]);P=ea(g[w+4>>2]);V=ea(g[w+8>>2]);T=ea(g[fa>>2]);W=ea(g[ga>>2]);da=ea(Z-T);T=ea(P-W);W=ea(V-ea(g[ha>>2]));V=ea(da*ea(g[u>>2]));P=ea(V+ea(T*ea(g[ma>>2])));V=ea(P+ea(W*ea(g[na>>2])));P=ea(da*ea(g[oa>>2]));Z=ea(P+ea(T*ea(g[pa>>2])));P=ea(Z+ea(W*ea(g[qa>>2])));Z=ea(da*ea(g[ra>>2]));da=ea(Z+ea(T*ea(g[sa>>2])));T=ea(da+ea(W*ea(g[ta>>2])));g[I>>2]=V;g[I+4>>2]=P;g[I+8>>2]=T;g[I+12>>2]=ea(0.0);XSa(K,I,x,H,G)|0;T=ea(g[t>>2]);P=ea(g[h>>2]);V=ea(g[f>>2]);W=ea(g[e>>2]);da=ea(g[y>>2]);Z=ea(g[v>>2]);U=ea(g[Q>>2]);aa=ea(ea(W*W)+ea(-.5));$=ea(ea(ea(T*da)+ea(P*Z))+ea(V*U));ka=ea(ea(ea(P*$)+ea(ea(aa*Z)+ea(W*ea(ea(V*da)-ea(T*U)))))*ea(2.0));ja=ea(ea(ea(ea(aa*U)+ea(W*ea(ea(T*Z)-ea(P*da))))+ea(V*$))*ea(2.0));g[y>>2]=ea(ea(ea(T*$)+ea(ea(da*aa)+ea(W*ea(ea(P*U)-ea(V*Z)))))*ea(2.0));g[v>>2]=ka;g[Q>>2]=ja;g[y+12>>2]=ea(0.0);QSa(K,k,y,s,r);za=1;i=l;return za|0}za=_7a(D,C,u,s,t,k,E,k,Da,K,y,q,Ga)|0;i=l;return za|0}function bSa(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im;m=i;i=i+3808|0;n=m+3616|0;o=m+3688|0;p=m+3536|0;q=m+144|0;r=m+3552|0;s=m+3584|0;t=m+176|0;u=m+3520|0;v=m+3504|0;w=m+160|0;x=m+3728|0;y=m;z=m+3700|0;A=m+240|0;B=m+3676|0;C=c[k>>2]&-16;k=b+4|0;g[p>>2]=ea(g[k>>2]);g[q>>2]=ea(g[j>>2]);D=ea(g[f>>2]);E=ea(g[f+4>>2]);F=ea(g[f+8>>2]);G=ea(g[f+12>>2]);H=f+16|0;I=ea(g[H>>2]);J=ea(g[H+4>>2]);K=ea(g[H+8>>2]);g[r>>2]=D;g[r+4>>2]=E;g[r+8>>2]=F;g[r+12>>2]=G;g[r+16>>2]=I;g[r+20>>2]=J;g[r+24>>2]=K;g[r+28>>2]=ea(0.0);L=ea(g[h>>2]);M=ea(g[h+4>>2]);N=ea(g[h+8>>2]);O=ea(g[h+12>>2]);P=h+16|0;Q=ea(g[P>>2]);R=ea(g[P+4>>2]);S=ea(g[P+8>>2]);g[s>>2]=L;g[s+4>>2]=M;g[s+8>>2]=N;g[s+12>>2]=O;g[s+16>>2]=Q;g[s+20>>2]=R;g[s+24>>2]=S;g[s+28>>2]=ea(0.0);T=ea(-L);L=ea(-M);M=ea(-N);N=ea(I-Q);Q=ea(J-R);R=ea(K-S);S=ea(ea(O*O)+ea(-.5));K=ea(ea(ea(N*T)+ea(Q*L))+ea(R*M));J=ea(ea(ea(K*T)+ea(ea(S*N)+ea(O*ea(ea(R*L)-ea(Q*M)))))*ea(2.0));I=ea(ea(ea(K*L)+ea(ea(S*Q)+ea(O*ea(ea(N*M)-ea(R*T)))))*ea(2.0));U=ea(ea(ea(ea(S*R)+ea(O*ea(ea(Q*T)-ea(N*L))))+ea(K*M))*ea(2.0));K=ea(ea(O*G)-ea(ea(ea(D*T)+ea(E*L))+ea(F*M)));N=ea(ea(ea(F*L)-ea(E*M))+ea(ea(O*D)+ea(G*T)));Q=ea(ea(ea(D*M)-ea(F*T))+ea(ea(O*E)+ea(G*L)));R=ea(ea(ea(E*T)-ea(D*L))+ea(ea(O*F)+ea(G*M)));g[t+48>>2]=J;g[t+52>>2]=I;g[t+56>>2]=U;g[t+60>>2]=ea(0.0);M=ea(N+N);G=ea(Q+Q);F=ea(R+R);O=ea(Q*G);L=ea(R*F);D=ea(Q*M);T=ea(R*M);E=ea(K*M);S=ea(R*G);V=ea(K*G);G=ea(K*F);F=ea(ea(1.0)-ea(N*M));M=ea(D+G);W=ea(T-V);X=ea(D-G);G=ea(F-L);D=ea(S+E);Y=ea(T+V);V=ea(S-E);E=ea(F-O);g[t>>2]=ea(ea(ea(1.0)-O)-L);g[t+4>>2]=M;g[t+8>>2]=W;g[t+12>>2]=ea(0.0);g[t+16>>2]=X;g[t+20>>2]=G;g[t+24>>2]=D;g[t+28>>2]=ea(0.0);g[t+32>>2]=Y;g[t+36>>2]=V;g[t+40>>2]=E;g[t+44>>2]=ea(0.0);E=ea(g[p>>2]);g[u>>2]=ea(E*ea(.00100000005));g[v>>2]=ea(E*ea(.0500000007));Z=C+53|0;_=a[Z>>0]|0;g[w>>2]=ea(E+ea(g[q>>2]));$=C+52|0;aa=a[$>>0]|0;if(aa<<24>>24){ba=aa&255;aa=0;while(1){ca=C+aa+48|0;da=a[ca>>0]|0;fa=da&255;aTa(n,C+(fa*400|0)+64|0,t,v,w);if(!(c[C+(fa*400|0)+448>>2]|0)){ga=(a[$>>0]|0)+-1<<24>>24;a[$>>0]=ga;ha=C+(ga&255)+48|0;ga=a[ha>>0]|0;a[ha>>0]=da;a[ca>>0]=ga;ia=aa+-1|0}else{g[C+(fa<<2)+32>>2]=ea(g[n>>2]);ia=aa}fa=ia+1|0;ga=d[$>>0]|0;if(fa>>>0<ga>>>0){ba=ga;aa=fa}else break}}if(((a[Z>>0]|0)==_<<24>>24?(E=ea(ea(g[p>>2])*ea(.0199999996)),V=ea(g[C+16>>2]),Y=ea(g[C+20>>2]),D=ea(J-V),V=ea(I-Y),Y=ea(U-ea(g[C+24>>2])),G=ea(-D),X=ea(-V),W=ea(-Y),M=D>G?D:G,G=V>X?V:X,X=!(M>=G)?G:M,_=!((Y>W?Y:W)>=ea(0.0)),W=_?ea(0.0):M,!((X>=W?X:W)>E)):0)?(E=ea(g[C+4>>2]),W=ea(Q*E),E=ea(N*ea(g[C>>2])),X=ea(R*ea(g[C+8>>2])),M=ea(W+E),!(ea(ea(M+X)+ea(K*ea(g[C+12>>2])))<ea(.999800026))):0){ja=dTa(C,l,r,s,p)|0;i=m;return ja|0}g[x>>2]=ea(1.0);g[x+4>>2]=ea(0.0);g[x+8>>2]=ea(0.0);g[x+12>>2]=ea(0.0);g[x+16>>2]=ea(1.0);g[x+20>>2]=ea(0.0);g[x+24>>2]=ea(0.0);g[x+28>>2]=ea(0.0);g[x+32>>2]=ea(1.0);g[x+36>>2]=ea(1.0);g[x+40>>2]=ea(0.0);g[x+44>>2]=ea(0.0);g[x+48>>2]=ea(0.0);g[x+52>>2]=ea(1.0);g[x+56>>2]=ea(0.0);g[x+60>>2]=ea(0.0);g[x+64>>2]=ea(0.0);g[x+68>>2]=ea(1.0);_=e+4|0;if((ea(g[_>>2])==ea(1.0)?ea(g[e+8>>2])==ea(1.0):0)?ea(g[e+12>>2])==ea(1.0):0)ka=1;else{J0a(x,_,e+16|0);ka=0}X=ea(g[f>>2]);M=ea(X*ea(2.0));E=ea(g[f+12>>2]);W=ea(E*ea(2.0));Y=ea(ea(X*M)+ea(ea(E*W)+ea(-1.0)));E=ea(g[f+8>>2]);X=ea(E*W);G=ea(g[f+4>>2]);V=ea(X+ea(M*G));X=ea(ea(M*E)-ea(W*G));G=ea(g[b+8>>2]);W=ea(G*Y);Y=ea(G*V);V=ea(G*X);X=ea(g[H>>2]);G=ea(X+W);E=ea(g[f+20>>2]);M=ea(E+Y);D=ea(g[f+24>>2]);L=ea(V+D);O=ea(X-W);F=ea(E-Y);S=ea(D-V);T=ea(g[P>>2]);la=ea(G-T);G=ea(g[h+20>>2]);ma=ea(M-G);M=ea(g[h+24>>2]);na=ea(la*ea(2.0));la=ea(ma*ea(2.0));ma=ea(ea(L-M)*ea(2.0));L=ea(g[h+12>>2]);oa=ea(ea(L*L)+ea(-.5));pa=ea(g[h>>2]);qa=ea(na*pa);ra=ea(g[h+4>>2]);sa=ea(qa+ea(la*ra));qa=ea(g[h+8>>2]);ta=ea(sa+ea(ma*qa));sa=ea(ea(pa*ta)+ea(ea(na*oa)-ea(L*ea(ea(ma*ra)-ea(la*qa)))));ua=ea(ea(ra*ta)+ea(ea(la*oa)-ea(L*ea(ea(na*qa)-ea(ma*pa)))));va=ea(ea(ea(ma*oa)-ea(L*ea(ea(la*pa)-ea(na*ra))))+ea(qa*ta));ta=ea(ea(O-T)*ea(2.0));O=ea(ea(F-G)*ea(2.0));F=ea(ea(S-M)*ea(2.0));S=ea(ea(ea(ta*pa)+ea(O*ra))+ea(F*qa));na=ea(ea(pa*S)+ea(ea(ta*oa)-ea(L*ea(ea(F*ra)-ea(O*qa)))));la=ea(ea(ra*S)+ea(ea(O*oa)-ea(L*ea(ea(ta*qa)-ea(F*pa)))));ma=ea(ea(ea(F*oa)-ea(L*ea(ea(O*pa)-ea(ta*ra))))+ea(qa*S));S=ea(g[k>>2]);ta=ea(S+ea(g[j>>2]));S=ea(ea(X-T)*ea(2.0));T=ea(ea(E-G)*ea(2.0));G=ea(ea(D-M)*ea(2.0));M=ea(ea(ea(S*pa)+ea(T*ra))+ea(G*qa));D=ea(ea(pa*M)+ea(ea(S*oa)-ea(L*ea(ea(G*ra)-ea(T*qa)))));E=ea(ea(ra*M)+ea(ea(T*oa)-ea(L*ea(ea(S*qa)-ea(G*pa)))));X=ea(ea(ea(G*oa)-ea(L*ea(ea(T*pa)-ea(S*ra))))+ea(qa*M));M=ea(W*ea(2.0));W=ea(Y*ea(2.0));Y=ea(V*ea(2.0));V=ea(ea(ea(M*pa)+ea(W*ra))+ea(Y*qa));S=ea(ea(pa*V)+ea(ea(M*oa)-ea(L*ea(ea(Y*ra)-ea(W*qa)))));T=ea(ea(ra*V)+ea(ea(W*oa)-ea(L*ea(ea(M*qa)-ea(Y*pa)))));G=ea(ea(ea(Y*oa)-ea(L*ea(ea(W*pa)-ea(M*ra))))+ea(qa*V));j=y+64|0;g[y>>2]=D;g[y+4>>2]=E;g[y+8>>2]=X;g[y+12>>2]=ea(0.0);c[y+80>>2]=4;g[y+48>>2]=ea(0.0);k=y+52|0;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];k=y+128|0;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];V=ea(E+T);qa=ea(X+G);g[y+96>>2]=ea(D+S);g[y+100>>2]=V;g[y+104>>2]=qa;g[y+108>>2]=ea(0.0);qa=ea(E-T);T=ea(X-G);g[y+112>>2]=ea(D-S);g[y+116>>2]=qa;g[y+120>>2]=T;g[y+124>>2]=ea(0.0);k=y+16|0;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];k=y+32|0;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[n+0>>2]=-1;c[n+4>>2]=-1;c[n+8>>2]=-1;c[n+12>>2]=-1;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];g[z>>2]=sa;g[z+4>>2]=ua;g[z+8>>2]=va;g[z+12>>2]=na;g[z+16>>2]=la;g[z+20>>2]=ma;g[z+24>>2]=ta;j=c[e+40>>2]|0;a[$>>0]=0;g[C>>2]=N;g[C+4>>2]=Q;g[C+8>>2]=R;g[C+12>>2]=K;g[C+16>>2]=J;g[C+20>>2]=I;g[C+24>>2]=U;g[C+28>>2]=ea(0.0);$=c[j+152>>2]|0;c[A+4>>2]=2;c[A+8>>2]=x;c[A+12>>2]=$;a[A+16>>0]=ka&1;$=A+868|0;c[$>>2]=0;c[A>>2]=544168;e=A+880|0;$7a(e,q,u,r,s,C,l);c[A+3248>>2]=y;U=ea(g[y+128>>2]);I=ea(U+ea(g[q>>2]));g[A+3216>>2]=I;q=A+3220|0;c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];g[A+3232>>2]=ea(I*I);o=A+3236|0;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];RKa(n,z);if(!ka)x6a(x,n+36|0,n+48|0,n);c[B>>2]=c[j+16>>2];c[B+4>>2]=j+32;g[B+8>>2]=ea(g[j+20>>2]);vQa(n,1,B,A,1);B=c[$>>2]|0;if(B){n=A+880|0;j=B;B=A+852|0;x=A+788|0;ka=A+596|0;z=A+20|0;while(1){j=j+-1|0;lSa(n,z,c[x>>2]|0,a[B>>0]|0,ka)|0;if(!j)break;else{B=B+1|0;x=x+4|0;ka=ka+12|0;z=z+36|0}}c[$>>2]=0}a8a(e,3,0);ja=dTa(C,l,r,s,p)|0;i=m;return ja|0}function cSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0;f=i;i=i+48|0;h=f+16|0;j=f;k=f+32|0;l=ea(g[b>>2]);m=ea(g[b+4>>2]);n=ea(g[b+8>>2]);b=a+2256|0;o=ea(l*ea(g[b>>2]));p=a+2260|0;q=ea(o+ea(m*ea(g[p>>2])));r=a+2264|0;o=ea(q+ea(n*ea(g[r>>2])));s=a+2272|0;q=ea(l*ea(g[s>>2]));t=a+2276|0;u=ea(q+ea(m*ea(g[t>>2])));v=a+2280|0;q=ea(u+ea(n*ea(g[v>>2])));w=a+2288|0;u=ea(l*ea(g[w>>2]));x=a+2292|0;l=ea(u+ea(m*ea(g[x>>2])));y=a+2296|0;m=ea(l+ea(n*ea(g[y>>2])));g[h>>2]=o;g[h+4>>2]=q;g[h+8>>2]=m;g[h+12>>2]=ea(0.0);if(e>>>0>4){z=($Sa((c[a+2320>>2]|0)+(d<<6)|0,e)|0)+d|0;c[a+2324>>2]=z;A=z}else A=c[a+2324>>2]|0;g[j>>2]=ea(3402823469999999843913219.0e14);z=a+2324|0;if(A>>>0>d>>>0){e=a+2320|0;B=a+2304|0;C=a+2308|0;D=a+2312|0;E=j+4|0;n=ea(3402823469999999843913219.0e14);F=d;do{G=c[e>>2]|0;l=ea(g[G+(F<<6)+44>>2]);g[G+(F<<6)+32>>2]=o;g[G+(F<<6)+36>>2]=q;g[G+(F<<6)+40>>2]=m;G=c[e>>2]|0;H=G+(F<<6)+16|0;u=ea(g[H>>2]);I=G+(F<<6)+20|0;J=ea(g[I>>2]);K=G+(F<<6)+24|0;L=ea(g[K>>2]);M=ea(g[B>>2]);N=ea(g[C>>2]);O=ea(u-M);M=ea(J-N);N=ea(L-ea(g[D>>2]));L=ea(O*ea(g[b>>2]));J=ea(L+ea(M*ea(g[p>>2])));L=ea(J+ea(N*ea(g[r>>2])));J=ea(O*ea(g[s>>2]));u=ea(J+ea(M*ea(g[t>>2])));J=ea(u+ea(N*ea(g[v>>2])));u=ea(O*ea(g[w>>2]));O=ea(u+ea(M*ea(g[x>>2])));M=ea(O+ea(N*ea(g[y>>2])));g[H>>2]=L;g[I>>2]=J;g[K>>2]=M;g[G+(F<<6)+28>>2]=ea(0.0);n=n>l?l:n;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];F=F+1|0;P=c[z>>2]|0}while(F>>>0<P>>>0);g[j>>2]=n;Q=P}else Q=A;if(Q>>>0>d>>>0){A=a+2320|0;P=a+2240|0;F=Q;Q=d;while(1){k=Q;Q=Q+1|0;if(Q>>>0<F>>>0){E=F;y=Q;while(1){x=c[A>>2]|0;n=ea(g[x+(y<<6)+16>>2]);m=ea(g[x+(y<<6)+20>>2]);q=ea(g[x+(y<<6)+24>>2]);o=ea(g[x+(k<<6)+16>>2]);l=ea(g[x+(k<<6)+20>>2]);M=ea(n-o);o=ea(m-l);l=ea(q-ea(g[x+(k<<6)+24>>2]));q=ea(ea(ea(M*M)+ea(o*o))+ea(l*l));if(ea(g[P>>2])>q){w=x+(y<<6)+0|0;v=x+(E+-1<<6)+0|0;x=w+52|0;do{c[w>>2]=c[v>>2];w=w+4|0;v=v+4|0}while((w|0)<(x|0));v=(c[z>>2]|0)+-1|0;c[z>>2]=v;R=v;S=y+-1|0}else{R=E;S=y}y=S+1|0;if(y>>>0>=R>>>0){T=R;break}else E=R}}else T=F;if(Q>>>0>=T>>>0)break;else F=T}}b8a(a,h,j,d);if((c[z>>2]|0)>>>0<=15){i=f;return}a8a(a,6,1);i=f;return}function dSa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im;d=i;i=i+224|0;e=d+200|0;f=d+160|0;h=d+188|0;j=d+176|0;k=d+16|0;l=d;m=c[b+3648>>2]|0;n=c[m+4>>2]|0;if(!n){i=d;return}o=(n>>>0)/15|0;p=c[m+8>>2]|0;if(n>>>0<=14){i=d;return}n=k+64|0;m=k+80|0;q=k+16|0;r=k+20|0;s=k+32|0;t=k+36|0;u=k+48|0;v=k+52|0;w=k+4|0;x=k+8|0;y=k+12|0;z=k+96|0;A=k+100|0;B=k+104|0;C=k+108|0;D=k+112|0;E=k+116|0;F=k+120|0;G=k+124|0;H=k+128|0;I=k+132|0;J=k+136|0;K=k+140|0;L=b+2324|0;M=b+2320|0;N=b+2176|0;O=0;do{P=c[p+(O*60|0)+36>>2]|0;Q=c[p+(O*60|0)+40>>2]|0;R=c[p+(O*60|0)+44>>2]|0;S=a[p+(O*60|0)+56>>0]|0;T=S&255;a:do if((T&8|0)==0?(U=P>>>0<Q>>>0,V=U?P:Q,W=U?Q:P,U=V<<16|W,X=U+~(U<<15)|0,U=(X>>>10^X)*9|0,X=U>>>6^U,U=X+~(X<<11)|0,X=a[b+((U>>>16^U)&127)+3488>>0]|0,X<<24>>24!=-1):0){U=X&255;while(1){if((c[b+(U<<3)+2336>>2]|0)==(V|0)?(c[b+(U<<3)+2340>>2]|0)==(W|0):0)break a;X=a[b+U+3360>>0]|0;if(X<<24>>24==-1){Y=10;break}else U=X&255}}else Y=10;while(0);b:do if((Y|0)==10){Y=0;if((T&16|0)==0?(U=Q>>>0<R>>>0,W=U?Q:R,V=U?R:Q,U=W<<16|V,X=U+~(U<<15)|0,U=(X>>>10^X)*9|0,X=U>>>6^U,U=X+~(X<<11)|0,X=a[b+((U>>>16^U)&127)+3488>>0]|0,X<<24>>24!=-1):0){U=X&255;while(1){if((c[b+(U<<3)+2336>>2]|0)==(W|0)?(c[b+(U<<3)+2340>>2]|0)==(V|0):0)break b;X=a[b+U+3360>>0]|0;if(X<<24>>24==-1)break;else U=X&255}}if((T&32|0)==0?(U=R>>>0<P>>>0,V=U?R:P,W=U?P:R,U=V<<16|W,X=U+~(U<<15)|0,U=(X>>>10^X)*9|0,X=U>>>6^U,U=X+~(X<<11)|0,X=a[b+((U>>>16^U)&127)+3488>>0]|0,X<<24>>24!=-1):0){U=X&255;while(1){if((c[b+(U<<3)+2336>>2]|0)==(V|0)?(c[b+(U<<3)+2340>>2]|0)==(W|0):0)break b;X=a[b+U+3360>>0]|0;if(X<<24>>24==-1)break;else U=X&255}}c[m>>2]=7;g[q>>2]=ea(0.0);c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];g[s>>2]=ea(0.0);c[t+0>>2]=c[e+0>>2];c[t+4>>2]=c[e+4>>2];c[t+8>>2]=c[e+8>>2];g[u>>2]=ea(0.0);c[v+0>>2]=c[e+0>>2];c[v+4>>2]=c[e+4>>2];c[v+8>>2]=c[e+8>>2];c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];Z=ea(g[p+(O*60|0)>>2]);_=ea(g[p+(O*60|0)+4>>2]);$=ea(g[p+(O*60|0)+8>>2]);aa=ea(g[p+(O*60|0)+12>>2]);ba=ea(g[p+(O*60|0)+16>>2]);ca=ea(g[p+(O*60|0)+20>>2]);da=ea(g[p+(O*60|0)+24>>2]);fa=ea(g[p+(O*60|0)+28>>2]);ga=ea(g[p+(O*60|0)+32>>2]);ha=ea(ea(ea(_+ba)+fa)*ea(.333332986));ia=ea(ea(ea($+ca)+ga)*ea(.333332986));g[k>>2]=ea(ea(ea(Z+aa)+da)*ea(.333332986));g[w>>2]=ha;g[x>>2]=ia;g[y>>2]=ea(0.0);g[z>>2]=Z;g[A>>2]=_;g[B>>2]=$;g[C>>2]=ea(0.0);g[D>>2]=aa;g[E>>2]=ba;g[F>>2]=ca;g[G>>2]=ea(0.0);g[H>>2]=da;g[I>>2]=fa;g[J>>2]=ga;g[K>>2]=ea(0.0);g[q>>2]=ea(0.0);c[r+0>>2]=c[h+0>>2];c[r+4>>2]=c[h+4>>2];c[r+8>>2]=c[h+8>>2];g[s>>2]=ea(3402823469999999843913219.0e14);c[t+0>>2]=c[j+0>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];U=c[L>>2]|0;LSa(b,k,c[p+(O*60|0)+52>>2]|0,c[p+(O*60|0)+48>>2]|0,S,c[M>>2]|0,L,N,l)|0;W=c[L>>2]|0;if((W|0)!=(U|0))cSa(b,l,U,W-U|0)}while(0);O=O+1|0}while(O>>>0<o>>>0);i=d;return}function eSa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=0;j=i;i=i+336|0;k=j+224|0;l=j+160|0;m=j+312|0;n=j+324|0;o=j+176|0;p=j;q=j+144|0;r=j+304|0;s=j+296|0;t=j+288|0;g[o>>2]=ea(1.0);u=o+4|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;g[o+20>>2]=ea(1.0);u=o+24|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;g[o+40>>2]=ea(1.0);g[o+44>>2]=ea(0.0);v=ea(g[d>>2]);w=ea(g[d+4>>2]);x=ea(g[d+8>>2]);y=ea(g[d+12>>2]);z=ea(g[d+16>>2]);A=ea(g[d+20>>2]);B=ea(g[d+24>>2]);C=ea(g[d+28>>2]);D=ea(g[d+32>>2]);E=ea(y-v);F=ea(z-w);G=ea(A-x);H=ea(B-v);I=ea(C-w);J=ea(D-x);K=ea(ea(F*J)-ea(G*I));L=ea(ea(G*H)-ea(E*J));J=ea(ea(E*I)-ea(F*H));H=ea(ea(1.0)/ea(T(ea(ea(J*J)+ea(ea(K*K)+ea(L*L))))));F=ea(H*K);K=ea(H*L);L=ea(J*H);H=ea(ea(x*L)+ea(ea(v*F)+ea(w*K)));J=ea(g[b+3632>>2]);I=ea(g[b+3636>>2]);if(ea(ea(ea(ea(J*F)+ea(I*K))+ea(L*ea(g[b+3640>>2])))-H)<ea(0.0)){M=0;i=j;return M|0}H=ea(g[b+2304>>2]);L=ea(g[b+2308>>2]);K=ea(g[b+2312>>2]);I=ea(g[b+2256>>2]);F=ea(v*I);J=ea(g[b+2272>>2]);E=ea(F+ea(w*J));F=ea(g[b+2288>>2]);G=ea(E+ea(x*F));E=ea(g[b+2260>>2]);N=ea(v*E);O=ea(g[b+2276>>2]);P=ea(N+ea(w*O));N=ea(g[b+2292>>2]);Q=ea(P+ea(x*N));P=ea(g[b+2264>>2]);R=ea(v*P);v=ea(g[b+2280>>2]);S=ea(R+ea(w*v));w=ea(g[b+2296>>2]);R=ea(H+G);G=ea(L+Q);Q=ea(K+ea(S+ea(x*w)));x=ea(H+ea(ea(ea(y*I)+ea(z*J))+ea(A*F)));S=ea(L+ea(ea(ea(y*E)+ea(z*O))+ea(A*N)));U=ea(K+ea(ea(ea(y*P)+ea(z*v))+ea(A*w)));A=ea(H+ea(ea(ea(B*I)+ea(C*J))+ea(D*F)));F=ea(L+ea(ea(ea(B*E)+ea(C*O))+ea(D*N)));N=ea(K+ea(ea(ea(B*P)+ea(C*v))+ea(D*w)));d=p+64|0;c[p+80>>2]=7;u=p+20|0;V=p+36|0;g[p+48>>2]=ea(0.0);W=p+52|0;c[W+0>>2]=c[k+0>>2];c[W+4>>2]=c[k+4>>2];c[W+8>>2]=c[k+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];w=ea(ea(F+ea(G+S))*ea(.333332986));D=ea(ea(N+ea(Q+U))*ea(.333332986));g[p>>2]=ea(ea(A+ea(R+x))*ea(.333332986));g[p+4>>2]=w;g[p+8>>2]=D;g[p+12>>2]=ea(0.0);g[p+96>>2]=R;g[p+100>>2]=G;g[p+104>>2]=Q;g[p+108>>2]=ea(0.0);g[p+112>>2]=x;g[p+116>>2]=S;g[p+120>>2]=U;g[p+124>>2]=ea(0.0);g[p+128>>2]=A;g[p+132>>2]=F;g[p+136>>2]=N;g[p+140>>2]=ea(0.0);g[p+16>>2]=ea(0.0);c[u+0>>2]=c[m+0>>2];c[u+4>>2]=c[m+4>>2];c[u+8>>2]=c[m+8>>2];g[p+32>>2]=ea(3402823469999999843913219.0e14);c[V+0>>2]=c[n+0>>2];c[V+4>>2]=c[n+4>>2];c[V+8>>2]=c[n+8>>2];c[k+32>>2]=c[b+2208>>2];c[k+36>>2]=o;c[k+40>>2]=o;a[k+44>>0]=1;c[k>>2]=544192;c[k+48>>2]=p;o=b+2324|0;n=c[o>>2]|0;JSa(b,p,e,h,f,c[b+3652>>2]|0,k,c[b+3656>>2]|0,c[b+2320>>2]|0,o,b+2176|0,q)|0;k=c[o>>2]|0;if((k|0)==(n|0)){M=1;i=j;return M|0}o=f&255;if(!(o&8)){f=c[h>>2]|0;e=c[h+4>>2]|0;p=f>>>0<e>>>0;c[r>>2]=p?f:e;c[r+4>>2]=p?e:f;A6a(b+2336|0,r)|0}if(!(o&16)){r=c[h+4>>2]|0;f=c[h+8>>2]|0;e=r>>>0<f>>>0;c[s>>2]=e?r:f;c[s+4>>2]=e?f:r;A6a(b+2336|0,s)|0}if(!(o&32)){o=c[h+8>>2]|0;s=c[h>>2]|0;h=o>>>0<s>>>0;c[t>>2]=h?o:s;c[t+4>>2]=h?s:o;A6a(b+2336|0,t)|0}cSa(b,q,n,k-n|0);M=1;i=j;return M|0}function fSa(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=0;p=i;i=i+320|0;q=p+208|0;r=p+272|0;s=p+288|0;t=p+300|0;u=p+144|0;v=p;w=p+192|0;g[u>>2]=ea(1.0);x=u+4|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[u+20>>2]=ea(1.0);x=u+24|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;g[u+40>>2]=ea(1.0);g[u+44>>2]=ea(0.0);y=ea(g[e>>2]);z=ea(g[e+4>>2]);A=ea(g[e+8>>2]);B=ea(g[e+12>>2]);C=ea(g[e+16>>2]);D=ea(g[e+20>>2]);E=ea(g[e+24>>2]);F=ea(g[e+28>>2]);G=ea(g[e+32>>2]);H=ea(g[m+48>>2]);I=ea(g[m+52>>2]);J=ea(g[m+56>>2]);K=ea(g[m>>2]);L=ea(y*K);M=ea(g[m+16>>2]);N=ea(L+ea(z*M));L=ea(g[m+32>>2]);O=ea(N+ea(A*L));N=ea(g[m+4>>2]);P=ea(y*N);Q=ea(g[m+20>>2]);R=ea(P+ea(z*Q));P=ea(g[m+36>>2]);S=ea(R+ea(A*P));R=ea(g[m+8>>2]);U=ea(y*R);y=ea(g[m+24>>2]);V=ea(U+ea(z*y));z=ea(g[m+40>>2]);U=ea(H+O);O=ea(I+S);S=ea(J+ea(V+ea(A*z)));A=ea(H+ea(ea(ea(B*K)+ea(C*M))+ea(D*L)));V=ea(I+ea(ea(ea(B*N)+ea(C*Q))+ea(D*P)));W=ea(J+ea(ea(ea(B*R)+ea(C*y))+ea(D*z)));D=ea(H+ea(ea(ea(E*K)+ea(F*M))+ea(G*L)));L=ea(I+ea(ea(ea(E*N)+ea(F*Q))+ea(G*P)));P=ea(J+ea(ea(ea(E*R)+ea(F*y))+ea(G*z)));z=ea(A-U);G=ea(V-O);y=ea(W-S);F=ea(D-U);R=ea(L-O);E=ea(P-S);J=ea(ea(G*E)-ea(R*y));Q=ea(ea(F*y)-ea(z*E));E=ea(ea(z*R)-ea(F*G));G=ea(ea(1.0)/ea(T(ea(ea(E*E)+ea(ea(J*J)+ea(Q*Q))))));F=ea(G*J);J=ea(G*Q);Q=ea(G*E);if(!k?(E=ea(g[d+20>>2]),G=ea(J*E),E=ea(F*ea(g[d+16>>2])),ea(ea(ea(G+E)+ea(Q*ea(g[d+24>>2])))-ea(ea(S*Q)+ea(ea(U*F)+ea(O*J))))<ea(0.0)):0){X=0;i=p;return X|0}k=v+64|0;c[v+80>>2]=7;m=v+20|0;e=v+36|0;g[v+48>>2]=ea(0.0);x=v+52|0;c[x+0>>2]=c[q+0>>2];c[x+4>>2]=c[q+4>>2];c[x+8>>2]=c[q+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];J=ea(ea(L+ea(O+V))*ea(.333332986));F=ea(ea(P+ea(S+W))*ea(.333332986));g[v>>2]=ea(ea(D+ea(U+A))*ea(.333332986));g[v+4>>2]=J;g[v+8>>2]=F;g[v+12>>2]=ea(0.0);g[v+96>>2]=U;g[v+100>>2]=O;g[v+104>>2]=S;g[v+108>>2]=ea(0.0);g[v+112>>2]=A;g[v+116>>2]=V;g[v+120>>2]=W;g[v+124>>2]=ea(0.0);g[v+128>>2]=D;g[v+132>>2]=L;g[v+136>>2]=P;g[v+140>>2]=ea(0.0);g[v+16>>2]=ea(0.0);c[m+0>>2]=c[s+0>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];g[v+32>>2]=ea(3402823469999999843913219.0e14);c[e+0>>2]=c[t+0>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[q+32>>2]=l;c[q+36>>2]=u;c[q+40>>2]=u;a[q+44>>0]=1;c[q>>2]=544192;c[q+48>>2]=v;KSa(v,f,h,b,q,d,n,o,j,w)|0;X=1;i=p;return X|0}function gSa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0;f=i;i=i+32|0;h=f;j=f+16|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;k=ea(g[b>>2]);l=ea(g[b+4>>2]);m=ea(g[b+8>>2]);n=ea(g[b+12>>2]);o=ea(g[b+16>>2]);p=ea(g[b+20>>2]);q=ea(g[b+24>>2]);r=ea(g[b+28>>2]);s=ea(g[b+32>>2]);t=ea(n-k);u=ea(o-l);v=ea(p-m);w=ea(q-k);x=ea(r-l);y=ea(s-m);z=ea(ea(u*y)-ea(v*x));A=ea(ea(v*w)-ea(t*y));B=ea(ea(t*x)-ea(u*w));C=ea(ea(1.0)/ea(T(ea(ea(B*B)+ea(ea(z*z)+ea(A*A))))));D=ea(C*z);z=ea(C*A);A=ea(B*C);C=ea(ea(m*A)+ea(ea(k*D)+ea(l*z)));B=ea(g[a+2336>>2]);E=ea(g[a+2340>>2]);F=ea(g[a+2344>>2]);if(ea(ea(ea(ea(B*D)+ea(E*z))+ea(A*F))-C)<ea(0.0)){G=0;i=f;return G|0}C=ea(q-n);H=ea(r-o);I=ea(s-p);J=ea(B-k);K=ea(E-l);L=ea(F-m);M=ea(B-n);N=ea(E-o);O=ea(F-p);P=ea(B-q);Q=ea(E-r);R=ea(F-s);S=ea(ea(ea(t*J)+ea(u*K))+ea(v*L));U=ea(ea(ea(w*J)+ea(x*K))+ea(y*L));V=ea(ea(ea(t*M)+ea(u*N))+ea(v*O));W=ea(ea(ea(w*M)+ea(x*N))+ea(y*O));X=ea(ea(ea(t*P)+ea(u*Q))+ea(v*R));Y=ea(ea(ea(w*P)+ea(x*Q))+ea(y*R));Z=ea(W-V);_=ea(X-Y);do if(S<ea(0.0)&U<ea(0.0)){b=e&255;if(!(b&8))$=b>>>5&1;else $=1;aa=k;ba=l;ca=m;da=ea(ea(ea(J*J)+ea(K*K))+ea(L*L));fa=$}else{if(!(!(V>=ea(0.0))|!(V>=W))){b=e&255;if(!(b&8))ga=b>>>4&1;else ga=1;aa=n;ba=o;ca=p;da=ea(ea(ea(M*M)+ea(N*N))+ea(O*O));fa=ga;break}if(!(!(Y>=ea(0.0))|!(Y>=X))){b=e&255;if(!(b&16))ha=b>>>5&1;else ha=1;aa=q;ba=r;ca=s;da=ea(ea(ea(P*P)+ea(Q*Q))+ea(R*R));fa=ha;break}ia=ea(ea(S*W)-ea(V*U));if(S>=ea(0.0)?!(!(ia<ea(0.0))|!(V<ea(0.0))):0){ja=ea(S/ea(S-V));ka=ea(k+ea(t*ja));la=ea(l+ea(u*ja));ma=ea(m+ea(v*ja));ja=ea(B-ka);na=ea(E-la);oa=ea(F-ma);aa=ka;ba=la;ca=ma;da=ea(ea(ea(ja*ja)+ea(na*na))+ea(oa*oa));fa=(e&255)>>>3&1;break}oa=ea(ea(V*Y)-ea(X*W));if(W>=V?!(!(oa<ea(0.0))|!(X>=Y)):0){na=ea(Z/ea(Z+_));ja=ea(n+ea(C*na));ma=ea(o+ea(H*na));la=ea(p+ea(I*na));na=ea(B-ja);ka=ea(E-ma);pa=ea(F-la);aa=ja;ba=ma;ca=la;da=ea(ea(ea(na*na)+ea(ka*ka))+ea(pa*pa));fa=(e&255)>>>4&1;break}pa=ea(ea(X*U)-ea(S*Y));if(U>=ea(0.0)?!(!(pa<ea(0.0))|!(Y<ea(0.0))):0){ka=ea(U/ea(U-Y));na=ea(k+ea(w*ka));la=ea(l+ea(x*ka));ma=ea(m+ea(y*ka));ka=ea(B-na);ja=ea(E-la);qa=ea(F-ma);aa=na;ba=la;ca=ma;da=ea(ea(ea(ka*ka)+ea(ja*ja))+ea(qa*qa));fa=(e&255)>>>5&1;break}qa=ea(ea(1.0)/ea(oa+ea(pa+ia)));oa=ea(pa*qa);pa=ea(ia*qa);qa=ea(k+ea(ea(t*oa)+ea(w*pa)));ia=ea(l+ea(ea(u*oa)+ea(x*pa)));ja=ea(m+ea(ea(v*oa)+ea(y*pa)));pa=ea(B-qa);oa=ea(E-ia);ka=ea(F-ja);aa=qa;ba=ia;ca=ja;da=ea(ea(ka*ka)+ea(ea(pa*pa)+ea(oa*oa)));fa=1}while(0);y=ea(B-aa);B=ea(E-ba);E=ea(F-ca);F=ea(ea(1.0)/ea(T(ea(ea(ea(y*y)+ea(B*B))+ea(E*E)))));v=ea(y*F);y=ea(B*F);B=ea(E*F);if(!(ea(g[a+2368>>2])>da)){G=1;i=f;return G|0}if(!(fa<<24>>24!=0?1:ea(ea(A*B)+ea(ea(D*v)+ea(z*y)))>ea(.995999991))){G=1;i=f;return G|0}z=ea(T(ea(da)));fa=a+2328|0;e=c[fa>>2]|0;if((e|0)!=0?(ha=e+-1|0,da=ea(g[a+(ha<<6)>>2]),D=ea(g[a+(ha<<6)+4>>2]),A=ea(ea(ea(v*da)+ea(y*D))+ea(B*ea(g[a+(ha<<6)+8>>2]))),A>ea(g[a+2224>>2])):0){e=a+(ha<<6)+32|0;if(ea(g[e>>2])>z){ga=a+(ha<<6)+36|0;$=a+(ha<<6)+48|0;ha=a+2320|0;b=(c[ha>>2]|0)+(c[$>>2]<<6)|0;c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];b=c[$>>2]|0;ra=c[ha>>2]|0;g[ra+(b<<6)+16>>2]=aa;g[ra+(b<<6)+20>>2]=ba;g[ra+(b<<6)+24>>2]=ca;g[ra+(b<<6)+28>>2]=ea(0.0);b=c[$>>2]|0;ra=c[ha>>2]|0;g[ra+(b<<6)+32>>2]=v;g[ra+(b<<6)+36>>2]=y;g[ra+(b<<6)+40>>2]=B;g[ra+(b<<6)+44>>2]=z;c[(c[ha>>2]|0)+(c[$>>2]<<6)+48>>2]=d;g[e>>2]=z;c[ga+0>>2]=c[j+0>>2];c[ga+4>>2]=c[j+4>>2];c[ga+8>>2]=c[j+8>>2]}}else{ga=a+2324|0;e=a+2320|0;$=(c[e>>2]|0)+(c[ga>>2]<<6)|0;c[$+0>>2]=c[h+0>>2];c[$+4>>2]=c[h+4>>2];c[$+8>>2]=c[h+8>>2];c[$+12>>2]=c[h+12>>2];h=c[ga>>2]|0;$=c[e>>2]|0;g[$+(h<<6)+16>>2]=aa;g[$+(h<<6)+20>>2]=ba;g[$+(h<<6)+24>>2]=ca;g[$+(h<<6)+28>>2]=ea(0.0);h=c[ga>>2]|0;$=c[e>>2]|0;g[$+(h<<6)+32>>2]=v;g[$+(h<<6)+36>>2]=y;g[$+(h<<6)+40>>2]=B;g[$+(h<<6)+44>>2]=z;h=c[ga>>2]|0;c[ga>>2]=h+1;c[(c[e>>2]|0)+(h<<6)+48>>2]=d;d=c[ga>>2]|0;ga=c[fa>>2]|0;c[a+(ga<<6)+48>>2]=d+-1;c[a+(ga<<6)+52>>2]=d;g[a+(ga<<6)+32>>2]=z;d=a+(ga<<6)+36|0;c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[fa>>2]=ga+1;g[a+(ga<<6)>>2]=v;g[a+(ga<<6)+4>>2]=y;g[a+(ga<<6)+8>>2]=B;g[a+(ga<<6)+12>>2]=ea(0.0)}if((c[a+2324>>2]|0)>>>0<=15){G=1;i=f;return G|0}a8a(a,1,1);G=1;i=f;return G|0}function hSa(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;a=i;n=ea(g[k>>2]);o=ea(g[k+4>>2]);p=ea(g[k+8>>2]);q=ea(g[j>>2]);r=ea(g[j+4>>2]);s=ea(g[j+8>>2]);t=ea(n-q);n=ea(o-r);o=ea(p-s);p=ea(g[f>>2]);j=f+4|0;u=ea(g[j>>2]);k=f+8|0;v=ea(g[k>>2]);w=ea(ea(n*v)-ea(o*u));x=ea(ea(o*p)-ea(t*v));y=ea(ea(t*u)-ea(n*p));z=ea(ea(s*y)+ea(ea(q*w)+ea(r*x)));A=ea(g[b>>2]);B=ea(g[b+4>>2]);C=ea(g[b+8>>2]);D=ea(ea(ea(A*w)+ea(x*B))+ea(y*C));E=ea(g[d>>2]);F=ea(g[d+4>>2]);G=ea(g[d+8>>2]);if(ea(ea(D-z)*ea(ea(ea(ea(w*E)+ea(x*F))+ea(y*G))-z))>ea(0.0)){i=a;return}H=ea(E-A);E=ea(F-B);F=ea(G-C);G=ea(ea(ea(w*H)+ea(x*E))+ea(y*F));if(G==ea(0.0)){i=a;return}y=ea(ea(z-D)/G);G=ea(ea(H*y)+A);A=ea(ea(E*y)+B);B=ea(ea(F*y)+C);C=ea(ea(F*u)-ea(E*v));y=ea(ea(H*v)-ea(F*p));F=ea(ea(E*p)-ea(H*u));H=ea(G-q);q=ea(A-r);r=ea(B-s);s=ea(ea(ea(ea(C*H)+ea(y*q))+ea(F*r))/ea(ea(o*F)+ea(ea(t*C)+ea(n*y))));if(!(s<=ea(1.0))|!(s>=ea(0.0))){i=a;return}y=ea(H-ea(t*s));t=ea(q-ea(n*s));n=ea(r-ea(o*s));s=ea(ea(n*n)+ea(ea(y*y)+ea(t*t)));if(!(ea(g[e>>2])>s)){i=a;return}s=ea(G-y);o=ea(A-t);r=ea(B-n);q=ea(ea(ea(y*p)+ea(t*u))+ea(n*v));e=c[m>>2]|0;g[l+(e<<6)>>2]=G;g[l+(e<<6)+4>>2]=A;g[l+(e<<6)+8>>2]=B;g[l+(e<<6)+12>>2]=ea(0.0);e=c[m>>2]|0;g[l+(e<<6)+16>>2]=s;g[l+(e<<6)+20>>2]=o;g[l+(e<<6)+24>>2]=r;g[l+(e<<6)+28>>2]=ea(0.0);e=c[m>>2]|0;r=ea(g[f>>2]);o=ea(g[j>>2]);s=ea(g[k>>2]);g[l+(e<<6)+32>>2]=r;g[l+(e<<6)+36>>2]=o;g[l+(e<<6)+40>>2]=s;g[l+(e<<6)+44>>2]=q;e=c[m>>2]|0;c[m>>2]=e+1;c[l+(e<<6)+48>>2]=h;i=a;return}function iSa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;m=i;n=ea(g[j>>2]);o=ea(g[j+4>>2]);p=ea(g[j+8>>2]);q=ea(g[h>>2]);r=ea(g[h+4>>2]);s=ea(g[h+8>>2]);t=ea(n-q);n=ea(o-r);o=ea(p-s);p=ea(g[e>>2]);h=e+4|0;u=ea(g[h>>2]);j=e+8|0;v=ea(g[j>>2]);w=ea(ea(n*v)-ea(o*u));x=ea(ea(o*p)-ea(t*v));y=ea(ea(t*u)-ea(n*p));z=ea(ea(s*y)+ea(ea(q*w)+ea(r*x)));A=ea(g[a>>2]);B=ea(g[a+4>>2]);C=ea(g[a+8>>2]);D=ea(ea(ea(A*w)+ea(x*B))+ea(y*C));E=ea(g[b>>2]);F=ea(g[b+4>>2]);G=ea(g[b+8>>2]);if(ea(ea(D-z)*ea(ea(ea(ea(w*E)+ea(x*F))+ea(y*G))-z))>ea(0.0)){i=m;return}H=ea(E-A);E=ea(F-B);F=ea(G-C);G=ea(ea(ea(w*H)+ea(x*E))+ea(y*F));if(G==ea(0.0)){i=m;return}y=ea(ea(z-D)/G);G=ea(ea(H*y)+A);A=ea(ea(E*y)+B);B=ea(ea(F*y)+C);C=ea(ea(F*u)-ea(E*v));y=ea(ea(H*v)-ea(F*p));F=ea(ea(E*p)-ea(H*u));H=ea(G-q);q=ea(A-r);r=ea(B-s);s=ea(ea(ea(ea(C*H)+ea(y*q))+ea(F*r))/ea(ea(o*F)+ea(ea(t*C)+ea(n*y))));b=s>ea(1.0);y=b?ea(1.0):s;b=y>ea(0.0);s=b?y:ea(0.0);y=ea(H-ea(t*s));t=ea(q-ea(n*s));n=ea(r-ea(o*s));s=ea(ea(v*n)+ea(ea(p*y)+ea(u*t)));if(!(ea(g[d>>2])>s)){i=m;return}u=ea(G-y);y=ea(A-t);t=ea(B-n);d=c[l>>2]|0;g[k+(d<<6)>>2]=G;g[k+(d<<6)+4>>2]=A;g[k+(d<<6)+8>>2]=B;g[k+(d<<6)+12>>2]=ea(0.0);d=c[l>>2]|0;g[k+(d<<6)+16>>2]=u;g[k+(d<<6)+20>>2]=y;g[k+(d<<6)+24>>2]=t;g[k+(d<<6)+28>>2]=ea(0.0);d=c[l>>2]|0;t=ea(g[e>>2]);y=ea(g[h>>2]);u=ea(g[j>>2]);g[k+(d<<6)+32>>2]=t;g[k+(d<<6)+36>>2]=y;g[k+(d<<6)+40>>2]=u;g[k+(d<<6)+44>>2]=s;d=c[l>>2]|0;c[l>>2]=d+1;c[k+(d<<6)+48>>2]=f;i=m;return}function jSa(a,b,d,e,f,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=Im,V=0,W=Im,X=Im,Y=Im,Z=0,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im;o=i;i=i+32|0;p=o+16|0;q=o;r=ea(g[b>>2]);s=ea(g[b+4>>2]);t=ea(g[b+8>>2]);u=ea(g[a>>2]);b=a+4|0;v=ea(g[b>>2]);w=a+8|0;x=ea(g[w>>2]);y=ea(r-u);r=ea(s-v);s=ea(t-x);t=ea(g[d>>2]);z=ea(g[d+4>>2]);A=ea(t-u);t=ea(z-v);z=ea(ea(g[d+8>>2])-x);B=ea(g[j>>2]);C=ea(g[j+4>>2]);D=ea(g[j+8>>2]);E=ea(B-u);F=ea(C-v);G=ea(D-x);H=ea(g[k>>2]);d=k+4|0;I=ea(g[d>>2]);J=k+8|0;K=ea(g[J>>2]);L=ea(H-u);M=ea(I-v);N=ea(K-x);O=ea(ea(ea(y*y)+ea(r*r))+ea(s*s));P=ea(ea(ea(y*A)+ea(r*t))+ea(s*z));Q=ea(ea(ea(A*A)+ea(t*t))+ea(z*z));R=ea(ea(1.0)/ea(ea(O*Q)-ea(P*P)));S=ea(g[e>>2]);T=e+4|0;U=ea(g[T>>2]);V=e+8|0;W=ea(g[V>>2]);X=ea(E*S);E=ea(F*U);F=ea(G*W);G=ea(ea(ea(-E)-X)-F);Y=ea(g[f>>2]);Z=f+4|0;_=ea(g[Z>>2]);$=f+8|0;aa=ea(g[$>>2]);ba=ea(ea(ea(S*Y)+ea(U*_))+ea(W*aa));ca=ea(G/ba);G=ea(ea(ca*Y)+B);B=ea(ea(ca*_)+C);C=ea(ea(ca*aa)+D);c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];D=ea(G-u);u=ea(B-v);v=ea(C-x);x=ea(ea(ea(y*D)+ea(r*u))+ea(s*v));da=ea(ea(ea(A*D)+ea(t*u))+ea(z*v));v=ea(R*ea(ea(Q*x)-ea(P*da)));u=ea(R*ea(ea(O*da)-ea(P*x)));if(ea(v+u)<ea(1.0)&(u<=ea(1.0)&u>=ea(0.0))&(v<=ea(1.0)&v>=ea(0.0))?(v=ea(X+E),ea(g[l>>2])>ea(v+F)):0){j=m+(c[n>>2]<<6)|0;c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];p=c[n>>2]|0;g[m+(p<<6)+16>>2]=G;g[m+(p<<6)+20>>2]=B;g[m+(p<<6)+24>>2]=C;g[m+(p<<6)+28>>2]=ea(0.0);p=c[n>>2]|0;C=ea(g[f>>2]);B=ea(g[Z>>2]);G=ea(g[$>>2]);F=ea(-ca);g[m+(p<<6)+32>>2]=C;g[m+(p<<6)+36>>2]=B;g[m+(p<<6)+40>>2]=G;g[m+(p<<6)+44>>2]=F;p=c[n>>2]|0;c[n>>2]=p+1;c[m+(p<<6)+48>>2]=h;F=ea(g[e>>2]);G=ea(g[T>>2]);B=ea(g[V>>2]);C=ea(g[f>>2]);ca=ea(g[Z>>2]);v=ea(g[$>>2]);E=ea(g[k>>2]);X=ea(g[d>>2]);fa=F;ga=G;ha=B;ia=C;ja=ca;ka=v;la=E;ma=X;na=ea(g[J>>2])}else{fa=S;ga=U;ha=W;ia=Y;ja=_;ka=aa;la=H;ma=I;na=K}K=ea(L*fa);fa=ea(M*ga);ga=ea(N*ha);ha=ea(ea(ea(ea(-fa)-K)-ga)/ba);ba=ea(ea(ha*ia)+la);la=ea(ea(ha*ja)+ma);ma=ea(ea(ha*ka)+na);c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];na=ea(g[a>>2]);ka=ea(g[b>>2]);ja=ea(ba-na);na=ea(la-ka);ka=ea(ma-ea(g[w>>2]));ia=ea(ea(ea(y*ja)+ea(r*na))+ea(s*ka));s=ea(ea(ea(A*ja)+ea(t*na))+ea(z*ka));ka=ea(R*ea(ea(Q*ia)-ea(P*s)));Q=ea(R*ea(ea(O*s)-ea(P*ia)));if(!(ea(ka+Q)<ea(1.0)&(Q<=ea(1.0)&Q>=ea(0.0))&(ka<=ea(1.0)&ka>=ea(0.0)))){i=o;return 0}ka=ea(K+fa);if(!(ea(g[l>>2])>ea(ka+ga))){i=o;return 0}l=m+(c[n>>2]<<6)|0;c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];q=c[n>>2]|0;g[m+(q<<6)+16>>2]=ba;g[m+(q<<6)+20>>2]=la;g[m+(q<<6)+24>>2]=ma;g[m+(q<<6)+28>>2]=ea(0.0);q=c[n>>2]|0;ma=ea(g[f>>2]);la=ea(g[Z>>2]);ba=ea(g[$>>2]);ga=ea(-ha);g[m+(q<<6)+32>>2]=ma;g[m+(q<<6)+36>>2]=la;g[m+(q<<6)+40>>2]=ba;g[m+(q<<6)+44>>2]=ga;q=c[n>>2]|0;c[n>>2]=q+1;c[m+(q<<6)+48>>2]=h;i=o;return 0}function kSa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=Im,R=0,S=Im,U=0,V=Im,W=Im,X=Im,Y=0,Z=0,_=Im,$=Im,aa=0,ba=Im,ca=0,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im;m=i;i=i+320|0;n=m+256|0;o=m+32|0;p=m+64|0;q=m+96|0;r=m+48|0;s=m+232|0;t=m+148|0;u=m+196|0;v=m+184|0;w=m+244|0;x=m+268|0;y=m+80|0;z=m;A=m+16|0;B=m+280|0;C=m+292|0;D=m+208|0;E=m+136|0;F=m+124|0;G=m+112|0;H=m+220|0;I=m+160|0;J=m+172|0;K=m+304|0;L=ea(g[d>>2]);M=d+4|0;N=ea(g[M>>2]);O=d+8|0;P=ea(g[O>>2]);Q=ea(g[b>>2]);R=b+4|0;S=ea(g[R>>2]);U=b+8|0;V=ea(g[U>>2]);W=ea(N-S);X=ea(P-V);g[o>>2]=ea(L-Q);Y=o+4|0;g[Y>>2]=W;Z=o+8|0;g[Z>>2]=X;g[o+12>>2]=ea(0.0);X=ea(g[f>>2]);W=ea(g[f+4>>2]);_=ea(g[f+8>>2]);$=ea(g[e>>2]);aa=e+4|0;ba=ea(g[aa>>2]);ca=e+8|0;da=ea(g[ca>>2]);fa=ea(X-$);ga=ea(W-ba);ha=ea(_-da);g[p>>2]=fa;g[p+4>>2]=ga;g[p+8>>2]=ha;g[p+12>>2]=ea(0.0);ia=ea(g[h>>2]);ja=ea(g[h+4>>2]);ka=ea(g[h+8>>2]);la=ea(ia-$);ma=ea(ja-ba);na=ea(ka-da);g[q>>2]=la;g[q+4>>2]=ma;g[q+8>>2]=na;g[q+12>>2]=ea(0.0);oa=ea(ja-W);W=ea(ka-_);g[r>>2]=ea(ia-X);g[r+4>>2]=oa;g[r+8>>2]=W;g[r+12>>2]=ea(0.0);W=ea(ea(ga*na)-ea(ha*ma));oa=ea(ea(ha*la)-ea(fa*na));X=ea(ea(fa*ma)-ea(ga*la));ia=ea(ea(1.0)/ea(T(ea(ea(X*X)+ea(ea(W*W)+ea(oa*oa))))));_=ea(W*ia);W=ea(oa*ia);oa=ea(X*ia);ia=ea(ea(ea(fa*fa)+ea(ga*ga))+ea(ha*ha));X=ea(ea(ea(fa*la)+ea(ga*ma))+ea(ha*na));ka=ea(ea(ea(la*la)+ea(ma*ma))+ea(na*na));ja=ea(ea(ea(V-da)*oa)+ea(ea(ea(Q-$)*_)+ea(ea(S-ba)*W)));S=ea(ea(1.0)/ea(ea(ia*ka)-ea(X*X)));Q=ea(ja*ja);V=ea(ea(ea(P-da)*oa)+ea(ea(ea(L-$)*_)+ea(ea(N-ba)*W)));ba=ea(V*V);if(ea(ja*V)<ea(0.0)){N=ea(g[o>>2]);$=ea(g[Y>>2]);L=ea(g[Z>>2]);da=ea(-ea(ja*ea(ea(1.0)/ea(ea(ea(_*N)+ea(W*$))+ea(oa*L)))));P=ea(g[b>>2]);pa=ea(g[R>>2]);qa=ea(g[U>>2]);ra=ea(ea(N*da)+P);N=ea(ea($*da)+pa);$=ea(ea(L*da)+qa);L=ea(g[e>>2]);sa=ea(g[aa>>2]);ta=ea(g[ca>>2]);ua=ea(ra-L);ra=ea(N-sa);N=ea($-ta);$=ea(ea(ea(ua*fa)+ea(ra*ga))+ea(N*ha));va=ea(ea(ea(ua*la)+ea(ra*ma))+ea(N*na));N=ea(S*ea(ea(ka*$)-ea(X*va)));ra=ea(S*ea(ea(ia*va)-ea(X*$)));if(ea(N+ra)<ea(1.0)&(ra<=ea(1.0)&ra>=ea(0.0))&(N<=ea(1.0)&N>=ea(0.0))){g[j>>2]=da;Z=j+4|0;c[Z+0>>2]=c[s+0>>2];c[Z+4>>2]=c[s+4>>2];c[Z+8>>2]=c[s+8>>2];g[k>>2]=N;s=k+4|0;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];g[l>>2]=ra;t=l+4|0;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g[a>>2]=ea(0.0);u=a+4|0;c[u+0>>2]=c[n+0>>2];c[u+4>>2]=c[n+4>>2];c[u+8>>2]=c[n+8>>2];i=m;return}else{wa=P;xa=pa;ya=qa;za=L;Aa=sa;Ba=ta}}else{ta=ea(g[b>>2]);sa=ea(g[R>>2]);L=ea(g[U>>2]);qa=ea(g[e>>2]);pa=ea(g[aa>>2]);wa=ta;xa=sa;ya=L;za=qa;Aa=pa;Ba=ea(g[ca>>2])}pa=ea(wa-ea(_*ja));wa=ea(xa-ea(W*ja));xa=ea(ya-ea(oa*ja));ja=ea(g[d>>2]);ya=ea(g[M>>2]);qa=ea(pa-za);pa=ea(wa-Aa);wa=ea(xa-Ba);xa=ea(ea(ja-ea(_*V))-za);za=ea(ea(ya-ea(W*V))-Aa);Aa=ea(ea(ea(g[O>>2])-ea(oa*V))-Ba);Ba=ea(ea(ea(qa*fa)+ea(pa*ga))+ea(wa*ha));V=ea(ea(ea(qa*la)+ea(pa*ma))+ea(wa*na));wa=ea(ea(ea(xa*fa)+ea(za*ga))+ea(Aa*ha));ha=ea(ea(ea(xa*la)+ea(za*ma))+ea(Aa*na));na=ea(S*ea(ea(ka*Ba)-ea(X*V)));Aa=ea(S*ea(ea(ia*V)-ea(X*Ba)));Ba=ea(S*ea(ea(ka*wa)-ea(X*ha)));ka=ea(S*ea(ea(ia*ha)-ea(X*wa)));O=ea(na+Aa)<ea(1.0)&(Aa<=ea(1.0)&Aa>=ea(0.0))&(na<=ea(1.0)&na>=ea(0.0));M=ea(Ba+ka)<ea(1.0)&(ka<=ea(1.0)&ka>=ea(0.0))&(Ba<=ea(1.0)&Ba>=ea(0.0));if(O&M){d=!(ba>Q);g[j>>2]=d?ea(1.0):ea(0.0);ca=j+4|0;c[ca+0>>2]=c[v+0>>2];c[ca+4>>2]=c[v+4>>2];c[ca+8>>2]=c[v+8>>2];g[k>>2]=d?Ba:na;v=k+4|0;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g[l>>2]=d?ka:Aa;w=l+4|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];g[a>>2]=d?ba:Q;i=m;return}c8a(A,b,o,e,p,f,r,e,q,e,p,y,z);wa=ea(g[y>>2]);X=ea(g[y+4>>2]);ha=ea(g[y+8>>2]);ia=ea(g[z>>2]);S=ea(g[z+4>>2]);V=ea(g[z+8>>2]);ma=ea(ea(1.0)-S);za=ea(g[A>>2]);la=ea(g[A+4>>2]);xa=ea(g[A+8>>2]);A=!(xa>la);z=xa>za&la>za;ga=z?za:A?xa:la;la=A?ea(0.0):ma;ma=z?ia:la;la=z?ea(0.0):A?V:S;S=z?wa:A?ha:X;if(O){O=!(ga>Q);g[j>>2]=O?S:ea(0.0);A=j+4|0;c[A+0>>2]=c[F+0>>2];c[A+4>>2]=c[F+4>>2];c[A+8>>2]=c[F+8>>2];g[k>>2]=O?ma:na;F=k+4|0;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g[l>>2]=O?la:Aa;G=l+4|0;c[G+0>>2]=c[H+0>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];g[a>>2]=O?ga:Q;i=m;return}if(M){M=!(ga>ba);g[j>>2]=M?S:ea(1.0);O=j+4|0;c[O+0>>2]=c[I+0>>2];c[O+4>>2]=c[I+4>>2];c[O+8>>2]=c[I+8>>2];g[k>>2]=M?ma:Ba;I=k+4|0;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];g[l>>2]=M?la:ka;J=l+4|0;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];g[a>>2]=M?ga:ba;i=m;return}else{g[j>>2]=S;M=j+4|0;c[M+0>>2]=c[E+0>>2];c[M+4>>2]=c[E+4>>2];c[M+8>>2]=c[E+8>>2];g[k>>2]=ma;E=k+4|0;c[E+0>>2]=c[C+0>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];g[l>>2]=la;C=l+4|0;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];g[a>>2]=ga;D=a+4|0;c[D+0>>2]=c[B+0>>2];c[D+4>>2]=c[B+4>>2];c[D+8>>2]=c[B+8>>2];i=m;return}}function lSa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+176|0;h=f+144|0;j=f+64|0;k=f+112|0;l=f+16|0;m=f+128|0;n=f;o=f+48|0;p=f+96|0;q=f+80|0;r=f+32|0;s=f+160|0;t=ea(g[b>>2]);u=ea(g[b+4>>2]);v=ea(g[b+8>>2]);g[h>>2]=t;w=h+4|0;g[w>>2]=u;x=h+8|0;g[x>>2]=v;g[h+12>>2]=ea(0.0);y=ea(g[b+12>>2]);z=ea(g[b+16>>2]);A=ea(g[b+20>>2]);g[j>>2]=y;B=j+4|0;g[B>>2]=z;C=j+8|0;g[C>>2]=A;g[j+12>>2]=ea(0.0);D=ea(g[b+24>>2]);E=ea(g[b+28>>2]);F=ea(g[b+32>>2]);g[k>>2]=D;b=k+4|0;g[b>>2]=E;G=k+8|0;g[G>>2]=F;g[k+12>>2]=ea(0.0);H=ea(y-t);y=ea(z-u);z=ea(A-v);A=ea(D-t);D=ea(E-u);E=ea(F-v);F=ea(ea(y*E)-ea(z*D));I=ea(ea(z*A)-ea(H*E));E=ea(ea(H*D)-ea(y*A));A=ea(ea(1.0)/ea(T(ea(ea(E*E)+ea(ea(F*F)+ea(I*I))))));y=ea(A*F);F=ea(A*I);I=ea(E*A);g[l>>2]=y;g[l+4>>2]=F;g[l+8>>2]=I;g[l+12>>2]=ea(0.0);A=ea(ea(ea(t*y)+ea(u*F))+ea(v*I));J=a+2368|0;K=c[J>>2]|0;v=ea(g[K>>2]);u=ea(g[K+4>>2]);if(ea(ea(ea(ea(y*v)+ea(F*u))+ea(I*ea(g[K+8>>2])))-A)<ea(0.0)){L=0;i=f;return L|0}kSa(p,K+96|0,K+112|0,h,j,k,m,n,o);K=a+2352|0;A=ea(g[a+2352>>2]);I=ea(g[p>>2]);if(!(A>I)){L=1;i=f;return L|0}A=ea(g[n>>2]);do if(A==ea(0.0)){u=ea(g[o>>2]);if(u==ea(0.0))if(!(e&40)){M=14;break}else{N=u;M=15;break}n=e&255;if(u==ea(1.0))if(!(n&48)){M=14;break}else{N=u;M=15;break}else if(!(n&32)){M=14;break}else{N=u;M=15;break}}else{n=A==ea(1.0);u=ea(g[o>>2]);p=u==ea(0.0);if(n)if(p&(e&24)==0){M=14;break}else{N=u;M=15;break}if(p)if(!(e&8)){M=14;break}else{N=u;M=15;break}else if(!(ea(A+u)>=ea(.999899983))|(e&16)==0){M=14;break}else{N=u;M=15;break}}while(0);do if((M|0)==14){c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];c[q+12>>2]=c[l+12>>2]}else if((M|0)==15)if(I==ea(0.0)){c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];c[q+12>>2]=c[l+12>>2];break}else{e=c[J>>2]|0;u=ea(g[e+112>>2]);F=ea(g[e+116>>2]);v=ea(g[e+120>>2]);y=ea(g[e+96>>2]);t=ea(g[e+100>>2]);E=ea(g[e+104>>2]);D=ea(u-y);u=ea(F-t);F=ea(v-E);v=ea(g[m>>2]);H=ea(ea(D*v)+y);y=ea(ea(u*v)+t);t=ea(ea(F*v)+E);E=ea(ea(1.0)-ea(A+N));v=ea(g[h>>2]);F=ea(g[w>>2]);u=ea(g[x>>2]);D=ea(g[j>>2]);z=ea(g[B>>2]);O=ea(g[C>>2]);P=ea(g[k>>2]);Q=ea(g[b>>2]);R=ea(H-ea(ea(v*E)+ea(ea(D*A)+ea(P*N))));P=ea(y-ea(ea(F*E)+ea(ea(z*A)+ea(Q*N))));Q=ea(t-ea(ea(E*u)+ea(ea(O*A)+ea(ea(g[G>>2])*N))));O=ea(ea(1.0)/ea(T(ea(ea(Q*Q)+ea(ea(R*R)+ea(P*P))))));u=ea(O*P);P=ea(O*Q);g[q>>2]=ea(O*R);g[q+4>>2]=u;g[q+8>>2]=P;g[q+12>>2]=ea(0.0);break}while(0);G=a+2324|0;b=c[G>>2]|0;C=c[J>>2]|0;B=a+2320|0;jSa(h,j,k,l,q,d,C+96|0,C+112|0,a+2336|0,c[B>>2]|0,G)|0;C=c[J>>2]|0;J=C+96|0;l=C+112|0;C=c[B>>2]|0;hSa(0,J,l,K,q,d,h,j,C,G);hSa(0,J,l,K,q,d,j,k,C,G);hSa(0,J,l,K,q,d,h,k,C,G);C=c[G>>2]|0;if((C|0)==(b|0)){L=1;i=f;return L|0}g[r>>2]=ea(3402823469999999843913219.0e14);if(b>>>0<C>>>0){k=a+2304|0;h=a+2308|0;d=a+2312|0;K=a+2256|0;l=a+2272|0;J=a+2288|0;j=a+2260|0;x=a+2276|0;w=a+2292|0;m=a+2264|0;M=a+2280|0;e=a+2296|0;o=r+4|0;N=ea(3402823469999999843913219.0e14);p=b;do{n=c[B>>2]|0;A=ea(g[n+(p<<6)+44>>2]);I=ea(g[k>>2]);P=ea(g[h>>2]);u=ea(g[d>>2]);S=n+(p<<6)|0;R=ea(g[S>>2]);U=n+(p<<6)+4|0;O=ea(g[U>>2]);V=n+(p<<6)+8|0;Q=ea(g[V>>2]);E=ea(R*ea(g[K>>2]));t=ea(E+ea(O*ea(g[l>>2])));E=ea(t+ea(Q*ea(g[J>>2])));t=ea(R*ea(g[j>>2]));z=ea(t+ea(O*ea(g[x>>2])));t=ea(z+ea(Q*ea(g[w>>2])));z=ea(R*ea(g[m>>2]));R=ea(z+ea(O*ea(g[M>>2])));O=ea(P+t);t=ea(u+ea(R+ea(Q*ea(g[e>>2]))));g[S>>2]=ea(I+E);g[U>>2]=O;g[V>>2]=t;g[n+(p<<6)+12>>2]=ea(0.0);N=N>A?A:N;c[o+0>>2]=c[s+0>>2];c[o+4>>2]=c[s+4>>2];c[o+8>>2]=c[s+8>>2];p=p+1|0;W=c[G>>2]|0}while(p>>>0<W>>>0);g[r>>2]=N;X=W}else X=C;if(b>>>0<X>>>0){C=a+2240|0;W=X;X=b;while(1){p=c[B>>2]|0;N=ea(g[p+(X<<6)+16>>2]);A=ea(g[p+(X<<6)+20>>2]);t=ea(g[p+(X<<6)+24>>2]);X=X+1|0;a:do if(X>>>0<W>>>0){s=p;o=W;e=X;while(1){O=ea(g[s+(e<<6)+16>>2]);E=ea(g[s+(e<<6)+20>>2]);I=ea(O-N);O=ea(E-A);E=ea(ea(g[s+(e<<6)+24>>2])-t);Q=ea(ea(ea(I*I)+ea(O*O))+ea(E*E));if(ea(g[C>>2])>Q){M=s+(e<<6)+0|0;m=s+(o+-1<<6)+0|0;w=M+52|0;do{c[M>>2]=c[m>>2];M=M+4|0;m=m+4|0}while((M|0)<(w|0));m=(c[G>>2]|0)+-1|0;c[G>>2]=m;Y=m;Z=e+-1|0}else{Y=o;Z=e}m=Z+1|0;if(m>>>0>=Y>>>0){_=Y;break a}s=c[B>>2]|0;o=Y;e=m}}else _=W;while(0);if(X>>>0>=_>>>0)break;else W=_}}b8a(a,q,r,b);if((c[G>>2]|0)>>>0<=15){L=1;i=f;return L|0}a8a(a,3,1);L=1;i=f;return L|0}function mSa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im;k=i;i=i+144|0;l=k+112|0;m=k+64|0;n=k+16|0;o=k+32|0;p=k+128|0;q=k;r=k+48|0;s=k+96|0;t=k+80|0;u=a+96|0;c[l+0>>2]=c[u+0>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[l+12>>2]=c[u+12>>2];u=a+112|0;c[m+0>>2]=c[u+0>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];u=a+128|0;c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];c[n+12>>2]=c[u+12>>2];v=ea(g[a+112>>2]);w=ea(g[a+116>>2]);x=ea(g[a+120>>2]);y=ea(g[a+96>>2]);z=ea(g[a+100>>2]);A=ea(g[a+104>>2]);B=ea(v-y);v=ea(w-z);w=ea(x-A);x=ea(g[a+128>>2]);C=ea(g[a+132>>2]);D=ea(x-y);y=ea(C-z);z=ea(ea(g[a+136>>2])-A);A=ea(ea(v*z)-ea(w*y));C=ea(ea(w*D)-ea(B*z));z=ea(ea(B*y)-ea(v*D));D=ea(ea(1.0)/ea(T(ea(ea(z*z)+ea(ea(A*A)+ea(C*C))))));v=ea(D*C);C=ea(z*D);g[o>>2]=ea(D*A);g[o+4>>2]=v;g[o+8>>2]=C;g[o+12>>2]=ea(0.0);C=ea(g[e>>2]);v=ea(C*C);a=d+96|0;u=d+112|0;kSa(s,a,u,l,m,n,p,q,r);C=ea(g[s>>2]);if(!(v>C)){i=k;return 1}v=ea(g[q>>2]);do if(v==ea(0.0)){A=ea(g[r>>2]);if(A==ea(0.0))if(!(f&40)){E=13;break}else{F=A;E=14;break}q=f&255;if(A==ea(1.0))if(!(q&48)){E=13;break}else{F=A;E=14;break}else if(!(q&32)){E=13;break}else{F=A;E=14;break}}else{q=v==ea(1.0);A=ea(g[r>>2]);s=A==ea(0.0);if(q)if(s&(f&24)==0){E=13;break}else{F=A;E=14;break}if(s)if(!(f&8)){E=13;break}else{F=A;E=14;break}else if(!(ea(v+A)>=ea(.999899983))|(f&16)==0){E=13;break}else{F=A;E=14;break}}while(0);do if((E|0)==13){c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2]}else if((E|0)==14)if(C==ea(0.0)){c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];break}else{A=ea(g[d+112>>2]);D=ea(g[d+116>>2]);z=ea(g[d+120>>2]);y=ea(g[d+96>>2]);B=ea(g[d+100>>2]);w=ea(g[d+104>>2]);x=ea(A-y);A=ea(D-B);D=ea(z-w);z=ea(g[p>>2]);G=ea(ea(x*z)+y);y=ea(ea(A*z)+B);B=ea(ea(D*z)+w);w=ea(ea(1.0)-ea(v+F));z=ea(g[l>>2]);D=ea(g[l+4>>2]);A=ea(g[l+8>>2]);x=ea(g[m>>2]);H=ea(g[m+4>>2]);I=ea(g[m+8>>2]);J=ea(g[n>>2]);K=ea(g[n+4>>2]);L=ea(G-ea(ea(z*w)+ea(ea(x*v)+ea(J*F))));J=ea(y-ea(ea(D*w)+ea(ea(H*v)+ea(K*F))));K=ea(B-ea(ea(w*A)+ea(ea(I*v)+ea(ea(g[n+8>>2])*F))));I=ea(ea(1.0)/ea(T(ea(ea(K*K)+ea(ea(L*L)+ea(J*J))))));A=ea(I*J);J=ea(I*K);g[t>>2]=ea(I*L);g[t+4>>2]=A;g[t+8>>2]=J;g[t+12>>2]=ea(0.0);break}while(0);jSa(l,m,n,o,t,b,a,u,e,h,j)|0;iSa(a,u,e,t,b,l,m,h,j);iSa(a,u,e,t,b,m,n,h,j);iSa(a,u,e,t,b,l,n,h,j);i=k;return 1}function nSa(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=0,R=Im,S=0,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;m=i;i=i+896|0;n=m+832|0;o=m+16|0;p=m;q=m+576|0;r=m+224|0;s=m+64|0;t=m+96|0;u=m+128|0;v=m+528|0;w=m+560|0;x=m+592|0;y=m+608|0;z=m+256|0;A=m+624|0;B=m+480|0;C=m+32|0;D=m+496|0;E=m+192|0;F=m+864|0;G=m+48|0;H=m+208|0;I=m+868|0;J=m+240|0;K=m+544|0;L=m+512|0;M=m+844|0;N=m+464|0;O=c[k>>2]|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;k=b+4|0;P=ea(g[k>>2]);Q=b+8|0;R=ea(g[Q>>2]);S=b+12|0;T=ea(g[S>>2]);g[p>>2]=P;U=p+4|0;g[U>>2]=R;V=p+8|0;g[V>>2]=T;g[p+12>>2]=ea(0.0);W=e+4|0;T=ea(g[W>>2]);X=e+8|0;R=ea(g[X>>2]);Y=e+12|0;P=ea(g[Y>>2]);g[q>>2]=T;Z=q+4|0;g[Z>>2]=R;_=q+8|0;g[_>>2]=P;g[q+12>>2]=ea(0.0);g[r>>2]=ea(g[j>>2]);P=ea(g[f>>2]);R=ea(g[f+4>>2]);T=ea(g[f+8>>2]);$=ea(g[f+12>>2]);j=f+16|0;aa=ea(g[j>>2]);ba=ea(g[j+4>>2]);ca=ea(g[j+8>>2]);g[s>>2]=P;g[s+4>>2]=R;g[s+8>>2]=T;g[s+12>>2]=$;g[s+16>>2]=aa;g[s+20>>2]=ba;g[s+24>>2]=ca;g[s+28>>2]=ea(0.0);da=ea(g[h>>2]);fa=ea(g[h+4>>2]);ga=ea(g[h+8>>2]);ha=ea(g[h+12>>2]);j=h+16|0;ia=ea(g[j>>2]);ja=ea(g[j+4>>2]);ka=ea(g[j+8>>2]);g[t>>2]=da;g[t+4>>2]=fa;g[t+8>>2]=ga;g[t+12>>2]=ha;g[t+16>>2]=ia;g[t+20>>2]=ja;g[t+24>>2]=ka;g[t+28>>2]=ea(0.0);la=ea(-da);da=ea(-fa);fa=ea(-ga);ga=ea(aa-ia);ia=ea(ba-ja);ja=ea(ca-ka);ka=ea(ea(ha*ha)+ea(-.5));ca=ea(ea(ea(ga*la)+ea(ia*da))+ea(ja*fa));ba=ea(ea(ea(ca*la)+ea(ea(ka*ga)+ea(ha*ea(ea(ja*da)-ea(ia*fa)))))*ea(2.0));aa=ea(ea(ea(ca*da)+ea(ea(ka*ia)+ea(ha*ea(ea(ga*fa)-ea(ja*la)))))*ea(2.0));ma=ea(ea(ea(ea(ka*ja)+ea(ha*ea(ea(ia*la)-ea(ga*da))))+ea(ca*fa))*ea(2.0));ca=ea(ea(ha*$)-ea(ea(ea(P*la)+ea(R*da))+ea(T*fa)));ga=ea(ea(ea(T*da)-ea(R*fa))+ea(ea(ha*P)+ea($*la)));ia=ea(ea(ea(P*fa)-ea(T*la))+ea(ea(ha*R)+ea($*da)));ja=ea(ea(ea(R*la)-ea(P*da))+ea(ea(ha*T)+ea($*fa)));j=u+48|0;g[j>>2]=ba;h=u+52|0;g[h>>2]=aa;f=u+56|0;g[f>>2]=ma;g[u+60>>2]=ea(0.0);fa=ea(ga+ga);$=ea(ia+ia);T=ea(ja+ja);ha=ea(ia*$);da=ea(ja*T);P=ea(ia*fa);la=ea(ja*fa);R=ea(ca*fa);ka=ea(ja*$);na=ea(ca*$);$=ea(ca*T);T=ea(ea(1.0)-ea(ga*fa));fa=ea(P+$);oa=ea(la-na);pa=ea(P-$);$=ea(T-da);P=ea(ka+R);qa=ea(la+na);na=ea(ka-R);R=ea(T-ha);g[u>>2]=ea(ea(ea(1.0)-ha)-da);ra=u+4|0;g[ra>>2]=fa;sa=u+8|0;g[sa>>2]=oa;g[u+12>>2]=ea(0.0);ta=u+16|0;g[ta>>2]=pa;ua=u+20|0;g[ua>>2]=$;va=u+24|0;g[va>>2]=P;g[u+28>>2]=ea(0.0);wa=u+32|0;g[wa>>2]=qa;xa=u+36|0;g[xa>>2]=na;ya=u+40|0;g[ya>>2]=R;g[u+44>>2]=ea(0.0);za=c[b+36>>2]|0;Aa=c[e+36>>2]|0;R=ea(g[za+52>>2]);na=ea(g[za+56>>2]);qa=ea(g[za+60>>2]);P=ea(g[p>>2]);$=ea(g[U>>2]);pa=ea(R*P);P=ea(na*$);$=ea(qa*ea(g[V>>2]));qa=!(pa<=P)?P:pa;pa=ea((!(qa<=$)?$:qa)*ea(.25));qa=ea(g[Aa+52>>2]);$=ea(g[Aa+56>>2]);P=ea(g[Aa+60>>2]);na=ea(g[q>>2]);R=ea(g[Z>>2]);oa=ea(qa*na);na=ea($*R);R=ea(P*ea(g[_>>2]));P=!(oa<=na)?na:oa;oa=ea((!(P<=R)?R:P)*ea(.25));_=O+32|0;Z=a[_>>0]|0;P=pa>oa?oa:pa;g[v>>2]=ea(P*ea(.800000011));U7a(O,u,v,0);if(((a[_>>0]|0)==Z<<24>>24?(v=Z&255,pa=ea(P*ea(g[544288+(v<<2)>>2])),oa=ea(g[O+16>>2]),R=ea(g[O+20>>2]),na=ea(ba-oa),oa=ea(aa-R),R=ea(ma-ea(g[O+24>>2])),$=ea(-na),qa=ea(-oa),fa=ea(-R),da=na>$?na:$,$=oa>qa?oa:qa,qa=!(da>=$)?$:da,V=!((R>fa?R:fa)>=ea(0.0)),fa=V?ea(0.0):da,!((qa>=fa?qa:fa)>pa)):0)?(pa=ea(g[O+4>>2]),fa=ea(ia*pa),pa=ea(ga*ea(g[O>>2])),qa=ea(ja*ea(g[O+8>>2])),da=ea(fa+pa),pa=ea(ea(da+qa)+ea(ca*ea(g[O+12>>2]))),!(ea(g[544328+(v<<2)>>2])>pa)):0){if(!(Z<<24>>24)){Ba=0;i=m;return Ba|0}X7a(N,O,t);OSa(O,l,N,t);Ba=1;i=m;return Ba|0}g[w>>2]=ea(P*ea(.0500000007));if(ea(g[k>>2])==ea(1.0)?ea(g[Q>>2])==ea(1.0):0)Ca=ea(g[S>>2])==ea(1.0);else Ca=0;if(ea(g[W>>2])==ea(1.0)?ea(g[X>>2])==ea(1.0):0)Da=ea(g[Y>>2])==ea(1.0);else Da=0;P=ea(g[b+16>>2]);pa=ea(g[b+20>>2]);qa=ea(g[b+24>>2]);da=ea(g[b+28>>2]);g[x>>2]=P;g[x+4>>2]=pa;g[x+8>>2]=qa;g[x+12>>2]=da;da=ea(g[e+16>>2]);qa=ea(g[e+20>>2]);pa=ea(g[e+24>>2]);P=ea(g[e+28>>2]);g[y>>2]=da;g[y+4>>2]=qa;g[y+8>>2]=pa;g[y+12>>2]=P;z1a(z,za,o,p,x);z1a(A,Aa,o,q,y);c[B+0>>2]=c[o+0>>2];c[B+4>>2]=c[o+4>>2];c[B+8>>2]=c[o+8>>2];c[B+12>>2]=c[o+12>>2];c[C+0>>2]=c[o+0>>2];c[C+4>>2]=c[o+4>>2];c[C+8>>2]=c[o+8>>2];c[C+12>>2]=c[o+12>>2];c[D+0>>2]=c[o+0>>2];c[D+4>>2]=c[o+4>>2];c[D+8>>2]=c[o+8>>2];c[D+12>>2]=c[o+12>>2];g[E>>2]=ea(0.0);o=E+4|0;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];do if(Ca)if(Da){Ea=j7a(z,A,u,r,B,C,D,E,O+34|0,O+38|0,O+33|0)|0;break}else{Ea=i7a(z,A,u,r,B,C,D,E,O+34|0,O+38|0,O+33|0)|0;break}else if(Da){Ea=h7a(z,A,u,r,C,C,D,E,O+34|0,O+38|0,O+33|0)|0;break}else{Ea=g7a(z,A,u,r,C,C,D,E,O+34|0,O+38|0,O+33|0)|0;break}while(0);g[O>>2]=ga;g[O+4>>2]=ia;g[O+8>>2]=ja;g[O+12>>2]=ca;g[O+16>>2]=ba;g[O+20>>2]=aa;g[O+24>>2]=ma;g[O+28>>2]=ea(0.0);c[F>>2]=0;if((Ea|0)==3){Ba=d8a(z,A,s,t,Ca,Da,l,F,l,O,D,r,0)|0;i=m;return Ba|0}else if(!Ea){Ba=0;i=m;return Ba|0}else{n=(Ea|0)==1;if(!(a[_>>0]|0)){do if(!n){a[M+4>>0]=0;c[M>>2]=541048;c[M+8>>2]=z;c[M+12>>2]=A;c[M+16>>2]=u;Ea=cPa(z,A,M,O+34|0,O+38|0,a[O+33>>0]|0,B,C,D,E,0)|0;if((Ea|0)==6){ma=ea(g[B>>2]);aa=ea(g[B+4>>2]);ba=ea(g[B+8>>2]);ca=ea(g[j>>2]);ja=ea(g[h>>2]);ia=ea(ma-ca);ca=ea(aa-ja);ja=ea(ba-ea(g[f>>2]));ba=ea(ia*ea(g[u>>2]));aa=ea(ba+ea(ca*ea(g[ra>>2])));ba=ea(aa+ea(ja*ea(g[sa>>2])));aa=ea(ia*ea(g[ta>>2]));ma=ea(aa+ea(ca*ea(g[ua>>2])));aa=ea(ma+ea(ja*ea(g[va>>2])));ma=ea(ia*ea(g[wa>>2]));ia=ea(ma+ea(ca*ea(g[xa>>2])));ca=ea(ia+ea(ja*ea(g[ya>>2])));ja=ea(g[D>>2]);ia=ea(g[D+4>>2]);ma=ea(g[D+8>>2]);ga=ea(g[E>>2]);o=c[F>>2]|0;g[l+(o*48|0)>>2]=ba;g[l+(o*48|0)+4>>2]=aa;g[l+(o*48|0)+8>>2]=ca;g[l+(o*48|0)+12>>2]=ea(0.0);y=l+(o*48|0)+16|0;c[y+0>>2]=c[C+0>>2];c[y+4>>2]=c[C+4>>2];c[y+8>>2]=c[C+8>>2];c[y+12>>2]=c[C+12>>2];c[F>>2]=o+1;g[l+(o*48|0)+32>>2]=ja;g[l+(o*48|0)+36>>2]=ia;g[l+(o*48|0)+40>>2]=ma;g[l+(o*48|0)+44>>2]=ga;Fa=0;break}else if((Ea|0)==4){Fa=1;break}else{Fa=0;break}}else{ga=ea(g[B>>2]);ma=ea(g[B+4>>2]);ia=ea(g[B+8>>2]);ja=ea(g[j>>2]);ca=ea(g[h>>2]);aa=ea(ga-ja);ja=ea(ma-ca);ca=ea(ia-ea(g[f>>2]));ia=ea(aa*ea(g[u>>2]));ma=ea(ia+ea(ja*ea(g[ra>>2])));ia=ea(ma+ea(ca*ea(g[sa>>2])));ma=ea(aa*ea(g[ta>>2]));ga=ea(ma+ea(ja*ea(g[ua>>2])));ma=ea(ga+ea(ca*ea(g[va>>2])));ga=ea(aa*ea(g[wa>>2]));aa=ea(ga+ea(ja*ea(g[xa>>2])));ja=ea(aa+ea(ca*ea(g[ya>>2])));ca=ea(g[D>>2]);aa=ea(g[D+4>>2]);ga=ea(g[D+8>>2]);ba=ea(g[E>>2]);g[l>>2]=ia;g[l+4>>2]=ma;g[l+8>>2]=ja;g[l+12>>2]=ea(0.0);Ea=l+16|0;c[Ea+0>>2]=c[C+0>>2];c[Ea+4>>2]=c[C+4>>2];c[Ea+8>>2]=c[C+8>>2];c[Ea+12>>2]=c[C+12>>2];c[F>>2]=1;g[l+32>>2]=ca;g[l+36>>2]=aa;g[l+40>>2]=ga;g[l+44>>2]=ba;Fa=0}while(0);Ba=d8a(z,A,s,t,Ca,Da,l,F,l,O,D,r,Fa)|0;i=m;return Ba|0}do if(n){ba=ea(g[B>>2]);ga=ea(g[B+4>>2]);aa=ea(g[B+8>>2]);ca=ea(g[j>>2]);ja=ea(g[h>>2]);ma=ea(ba-ca);ca=ea(ga-ja);ja=ea(aa-ea(g[f>>2]));aa=ea(ma*ea(g[u>>2]));ga=ea(aa+ea(ca*ea(g[ra>>2])));aa=ea(ga+ea(ja*ea(g[sa>>2])));ga=ea(ma*ea(g[ta>>2]));ba=ea(ga+ea(ca*ea(g[ua>>2])));ga=ea(ba+ea(ja*ea(g[va>>2])));ba=ea(ma*ea(g[wa>>2]));ma=ea(ba+ea(ca*ea(g[xa>>2])));ca=ea(ma+ea(ja*ea(g[ya>>2])));g[G>>2]=aa;g[G+4>>2]=ga;g[G+8>>2]=ca;g[G+12>>2]=ea(0.0);ca=ea(g[D>>2]);ga=ea(g[D+4>>2]);aa=ea(g[D+8>>2]);ja=ea(g[E>>2]);g[H>>2]=ca;g[H+4>>2]=ga;g[H+8>>2]=aa;g[H+12>>2]=ja;c[l+0>>2]=c[G+0>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];c[l+12>>2]=c[G+12>>2];Fa=l+16|0;c[Fa+0>>2]=c[C+0>>2];c[Fa+4>>2]=c[C+4>>2];c[Fa+8>>2]=c[C+8>>2];c[Fa+12>>2]=c[C+12>>2];c[F>>2]=1;Fa=l+32|0;c[Fa+0>>2]=c[H+0>>2];c[Fa+4>>2]=c[H+4>>2];c[Fa+8>>2]=c[H+8>>2];c[Fa+12>>2]=c[H+12>>2];WSa(O,G,C,H,w)|0;Ga=24}else{a[I+4>>0]=0;c[I>>2]=541048;c[I+8>>2]=z;c[I+12>>2]=A;c[I+16>>2]=u;Fa=cPa(z,A,I,O+34|0,O+38|0,a[O+33>>0]|0,B,C,D,E,0)|0;if((Fa|0)==4){Ha=1;break}else if((Fa|0)!=6){Ga=24;break}ja=ea(g[B>>2]);aa=ea(g[B+4>>2]);ga=ea(g[B+8>>2]);ca=ea(g[j>>2]);ma=ea(g[h>>2]);ba=ea(ja-ca);ca=ea(aa-ma);ma=ea(ga-ea(g[f>>2]));ga=ea(ba*ea(g[u>>2]));aa=ea(ga+ea(ca*ea(g[ra>>2])));ga=ea(aa+ea(ma*ea(g[sa>>2])));aa=ea(ba*ea(g[ta>>2]));ja=ea(aa+ea(ca*ea(g[ua>>2])));aa=ea(ja+ea(ma*ea(g[va>>2])));ja=ea(ba*ea(g[wa>>2]));ba=ea(ja+ea(ca*ea(g[xa>>2])));ca=ea(ba+ea(ma*ea(g[ya>>2])));g[J>>2]=ga;g[J+4>>2]=aa;g[J+8>>2]=ca;g[J+12>>2]=ea(0.0);ca=ea(g[D>>2]);aa=ea(g[D+4>>2]);ga=ea(g[D+8>>2]);ma=ea(g[E>>2]);g[K>>2]=ca;g[K+4>>2]=aa;g[K+8>>2]=ga;g[K+12>>2]=ma;Fa=c[F>>2]|0;M=l+(Fa*48|0)|0;c[M+0>>2]=c[J+0>>2];c[M+4>>2]=c[J+4>>2];c[M+8>>2]=c[J+8>>2];c[M+12>>2]=c[J+12>>2];M=l+(Fa*48|0)+16|0;c[M+0>>2]=c[C+0>>2];c[M+4>>2]=c[C+4>>2];c[M+8>>2]=c[C+8>>2];c[M+12>>2]=c[C+12>>2];c[F>>2]=Fa+1;M=l+(Fa*48|0)+32|0;c[M+0>>2]=c[K+0>>2];c[M+4>>2]=c[K+4>>2];c[M+8>>2]=c[K+8>>2];c[M+12>>2]=c[K+12>>2];WSa(O,J,C,K,w)|0;Ga=24}while(0);if((Ga|0)==24)if((d[_>>0]|0)<(Z&255))Ha=0;else{X7a(L,O,t);OSa(O,l,L,t);Ba=1;i=m;return Ba|0}Ba=d8a(z,A,s,t,Ca,Da,l,F,l,O,D,r,Ha)|0;i=m;return Ba|0}return 0}function oSa(b,e,f,h,j,k,l,m,n,o,p,q,r,s){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;t=i;i=i+5040|0;u=t+4752|0;v=t+4800|0;w=t+4816|0;x=t+4848|0;y=t+16|0;z=t;A=t+4880|0;B=t+4896|0;C=t+4972|0;D=t+4960|0;E=t+4944|0;F=t+80|0;G=ea(g[k>>2]);H=ea(g[k+4>>2]);I=ea(g[k+8>>2]);J=ea(g[k+12>>2]);K=k+16|0;L=ea(g[K>>2]);M=ea(g[K+4>>2]);N=ea(g[K+8>>2]);O=ea(g[l>>2]);P=ea(g[l+4>>2]);Q=ea(g[l+8>>2]);R=ea(g[l+12>>2]);S=l+16|0;T=ea(g[S>>2]);U=ea(g[S+4>>2]);V=ea(g[S+8>>2]);g[v>>2]=m;g[w>>2]=G;g[w+4>>2]=H;g[w+8>>2]=I;g[w+12>>2]=J;g[w+16>>2]=L;g[w+20>>2]=M;g[w+24>>2]=N;g[w+28>>2]=ea(0.0);g[x>>2]=O;g[x+4>>2]=P;g[x+8>>2]=Q;g[x+12>>2]=R;g[x+16>>2]=T;g[x+20>>2]=U;g[x+24>>2]=V;g[x+28>>2]=ea(0.0);W=ea(-O);O=ea(-P);P=ea(-Q);Q=ea(L-T);T=ea(M-U);U=ea(N-V);V=ea(ea(R*R)+ea(-.5));N=ea(ea(ea(Q*W)+ea(T*O))+ea(U*P));M=ea(ea(ea(N*W)+ea(ea(V*Q)+ea(R*ea(ea(U*O)-ea(T*P)))))*ea(2.0));L=ea(ea(ea(N*O)+ea(ea(V*T)+ea(R*ea(ea(Q*P)-ea(U*W)))))*ea(2.0));X=ea(ea(ea(ea(V*U)+ea(R*ea(ea(T*W)-ea(Q*O))))+ea(N*P))*ea(2.0));N=ea(ea(R*J)-ea(ea(ea(G*W)+ea(H*O))+ea(I*P)));Q=ea(ea(ea(I*O)-ea(H*P))+ea(ea(R*G)+ea(J*W)));T=ea(ea(ea(G*P)-ea(I*W))+ea(ea(R*H)+ea(J*O)));U=ea(ea(ea(H*W)-ea(G*O))+ea(ea(R*I)+ea(J*P)));g[y+48>>2]=M;g[y+52>>2]=L;g[y+56>>2]=X;g[y+60>>2]=ea(0.0);P=ea(Q+Q);J=ea(T+T);I=ea(U+U);R=ea(T*J);O=ea(U*I);G=ea(T*P);W=ea(U*P);H=ea(N*P);V=ea(U*J);Y=ea(N*J);J=ea(N*I);I=ea(ea(1.0)-ea(Q*P));P=ea(G+J);Z=ea(W-Y);_=ea(G-J);J=ea(I-O);G=ea(V+H);$=ea(W+Y);Y=ea(V-H);H=ea(I-R);g[y>>2]=ea(ea(ea(1.0)-R)-O);g[y+4>>2]=P;g[y+8>>2]=Z;g[y+12>>2]=ea(0.0);g[y+16>>2]=_;g[y+20>>2]=J;g[y+24>>2]=G;g[y+28>>2]=ea(0.0);g[y+32>>2]=$;g[y+36>>2]=Y;g[y+40>>2]=H;g[y+44>>2]=ea(0.0);H=ea(g[f>>2]);g[z>>2]=ea(H*ea(.0500000007));f=s+53|0;aa=a[f>>0]|0;Y=ea(H*ea(.200000003));ba=s+16|0;$=ea(g[ba>>2]);ca=s+20|0;G=ea(g[ca>>2]);da=s+24|0;J=ea(M-$);$=ea(L-G);G=ea(X-ea(g[da>>2]));_=ea(-J);Z=ea(-$);P=ea(-G);O=J>_?J:_;_=$>Z?$:Z;Z=!(O>=_)?_:O;fa=!((G>P?G:P)>=ea(0.0));P=fa?ea(0.0):O;if(!((Z>=P?Z:P)>Y)){fa=s+4|0;ga=s+8|0;Y=ea(g[fa>>2]);P=ea(T*Y);Y=ea(Q*ea(g[s>>2]));ha=s+12|0;Z=ea(U*ea(g[ga>>2]));O=ea(P+Y);if(!(ea(ea(O+Z)+ea(N*ea(g[ha>>2])))<ea(.999800026))){g[A>>2]=ea(H*ea(.800000011));ia=s+52|0;ja=a[ia>>0]|0;if(!(ja<<24>>24)){ka=cTa(s,n,x)|0;i=t;return ka|0}la=ja&255;ja=0;while(1){ma=s+ja+48|0;na=a[ma>>0]|0;oa=na&255;aTa(u,s+(oa*400|0)+64|0,y,A,v);if(!(c[s+(oa*400|0)+448>>2]|0)){pa=(a[ia>>0]|0)+-1<<24>>24;a[ia>>0]=pa;qa=s+(pa&255)+48|0;pa=a[qa>>0]|0;a[qa>>0]=na;a[ma>>0]=pa;ra=ja+-1|0}else{g[s+(oa<<2)+32>>2]=ea(g[u>>2]);ra=ja}oa=ra+1|0;pa=d[ia>>0]|0;if(oa>>>0<pa>>>0){la=pa;ja=oa}else break}if((a[f>>0]|0)==aa<<24>>24){ka=cTa(s,n,x)|0;i=t;return ka|0}else{sa=fa;ta=ga;ua=ha;va=s}}else{sa=fa;ta=ga;ua=ha;va=s}}else{sa=s+4|0;ta=s+8|0;ua=s+12|0;va=s}a[s+52>>0]=0;g[va>>2]=Q;g[sa>>2]=T;g[ta>>2]=U;g[ua>>2]=N;g[ba>>2]=M;g[ca>>2]=L;g[da>>2]=X;g[s+28>>2]=ea(0.0);da=c[j+40>>2]|0;X=ea(g[k>>2]);L=ea(X+X);M=ea(g[k+4>>2]);N=ea(M+M);U=ea(g[k+8>>2]);T=ea(U+U);Q=ea(g[k+12>>2]);H=ea(L*Q);Z=ea(N*Q);O=ea(Q*T);Q=ea(X*L);L=ea(X*N);Y=ea(X*T);X=ea(M*N);N=ea(M*T);M=ea(U*T);g[u>>2]=ea(ea(ea(1.0)-X)-M);g[u+4>>2]=ea(L+O);g[u+8>>2]=ea(Y-Z);g[u+12>>2]=ea(L-O);O=ea(ea(1.0)-Q);g[u+16>>2]=ea(O-M);g[u+20>>2]=ea(N+H);g[u+24>>2]=ea(Y+Z);g[u+28>>2]=ea(N-H);g[u+32>>2]=ea(O-X);g[u+36>>2]=ea(g[K>>2]);g[u+40>>2]=ea(g[k+20>>2]);g[u+44>>2]=ea(g[k+24>>2]);X=ea(g[l>>2]);O=ea(X+X);H=ea(g[l+4>>2]);N=ea(H+H);Z=ea(g[l+8>>2]);Y=ea(Z+Z);M=ea(g[l+12>>2]);Q=ea(O*M);L=ea(N*M);T=ea(M*Y);M=ea(X*O);O=ea(X*N);U=ea(X*Y);X=ea(H*N);N=ea(H*Y);H=ea(Z*Y);g[B>>2]=ea(ea(ea(1.0)-X)-H);g[B+4>>2]=ea(O+T);g[B+8>>2]=ea(U-L);g[B+12>>2]=ea(O-T);T=ea(ea(1.0)-M);g[B+16>>2]=ea(T-H);g[B+20>>2]=ea(N+Q);g[B+24>>2]=ea(U+L);g[B+28>>2]=ea(N-Q);g[B+32>>2]=ea(T-X);g[B+36>>2]=ea(g[S>>2]);g[B+40>>2]=ea(g[l+20>>2]);g[B+44>>2]=ea(g[l+24>>2]);zOa(C,h,m,k,u,B,p,r);c[D>>2]=c[da+16>>2];c[D+4>>2]=da+32;g[D+8>>2]=ea(g[da+20>>2]);aLa(E);B=i;i=i+4352|0;fLa(E,1088,B,1);B=c[da+152>>2]|0;c[F+4>>2]=2;c[F+8>>2]=p;c[F+12>>2]=B;a[F+16>>0]=r&1;r=F+868|0;c[r>>2]=0;c[F>>2]=544224;$7a(F+880|0,v,z,w,x,s,n);c[F+4496>>2]=0;w=F+4368|0;z=w+128|0;do{c[w>>2]=-1;w=w+4|0}while((w|0)<(z|0));c[F+4528>>2]=E;c[F+4532>>2]=b;c[F+4536>>2]=e;c[F+4540>>2]=o;a[F+4544>>0]=q&1;m=ea(g[b>>2]);X=ea(g[b+4>>2]);T=ea(g[b+8>>2]);Q=ea(g[F+3184>>2]);N=ea(g[F+3188>>2]);L=ea(m-Q);Q=ea(X-N);N=ea(T-ea(g[F+3192>>2]));T=ea(L*ea(g[F+3136>>2]));X=ea(T+ea(Q*ea(g[F+3140>>2])));T=ea(X+ea(N*ea(g[F+3144>>2])));X=ea(L*ea(g[F+3152>>2]));m=ea(X+ea(Q*ea(g[F+3156>>2])));X=ea(m+ea(N*ea(g[F+3160>>2])));m=ea(L*ea(g[F+3168>>2]));L=ea(m+ea(Q*ea(g[F+3172>>2])));Q=ea(L+ea(N*ea(g[F+3176>>2])));g[F+4512>>2]=T;g[F+4516>>2]=X;g[F+4520>>2]=Q;g[F+4524>>2]=ea(0.0);ZPa(F+4560|0,C);vQa(C,1,D,F,1);D=c[r>>2]|0;if(D){C=F+880|0;b=D;D=F+852|0;q=F+788|0;o=F+596|0;e=F+20|0;while(1){b=b+-1|0;eSa(C,e,c[q>>2]|0,a[D>>0]|0,o)|0;if(!b)break;else{D=D+1|0;q=q+4|0;o=o+12|0;e=e+36|0}}c[r>>2]=0}r=F+880|0;dSa(r);a8a(r,6,0);dLa(E);ka=cTa(s,n,x)|0;i=t;return ka|0}function pSa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0;l=i;i=i+608|0;m=l;n=l+368|0;o=l+440|0;p=l+512|0;q=l+536|0;r=l+352|0;s=l+336|0;t=l+32|0;u=l+48|0;v=l+256|0;w=l+272|0;x=c[b+36>>2]|0;y=c[j>>2]&-16;z=ea(g[e>>2]);A=ea(g[e+4>>2]);B=ea(g[e+8>>2]);C=ea(g[e+12>>2]);j=e+16|0;D=ea(g[j>>2]);E=ea(g[j+4>>2]);F=ea(g[j+8>>2]);g[m>>2]=z;g[m+4>>2]=A;g[m+8>>2]=B;g[m+12>>2]=C;g[m+16>>2]=D;g[m+20>>2]=E;g[m+24>>2]=F;g[m+28>>2]=ea(0.0);j=d+4|0;if(ea(g[j>>2])==ea(1.0)?ea(g[d+8>>2])==ea(1.0):0)G=ea(g[d+12>>2])==ea(1.0);else G=0;g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);g[n+16>>2]=ea(1.0);g[n+20>>2]=ea(0.0);g[n+24>>2]=ea(0.0);g[n+28>>2]=ea(0.0);g[n+32>>2]=ea(1.0);g[n+36>>2]=ea(1.0);g[n+40>>2]=ea(0.0);g[n+44>>2]=ea(0.0);g[n+48>>2]=ea(0.0);g[n+52>>2]=ea(1.0);g[n+56>>2]=ea(0.0);g[n+60>>2]=ea(0.0);g[n+64>>2]=ea(0.0);g[n+68>>2]=ea(1.0);if(!G)J0a(n,j,d+16|0);g[o>>2]=ea(1.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);g[o+12>>2]=ea(0.0);g[o+16>>2]=ea(1.0);g[o+20>>2]=ea(0.0);g[o+24>>2]=ea(0.0);g[o+28>>2]=ea(0.0);g[o+32>>2]=ea(1.0);g[o+36>>2]=ea(1.0);g[o+40>>2]=ea(0.0);g[o+44>>2]=ea(0.0);g[o+48>>2]=ea(0.0);g[o+52>>2]=ea(1.0);g[o+56>>2]=ea(0.0);g[o+60>>2]=ea(0.0);g[o+64>>2]=ea(0.0);g[o+68>>2]=ea(1.0);j=ISa(b,o,p,q)|0;F=ea(g[b+4>>2]);E=ea(g[b+8>>2]);D=ea(g[b+12>>2]);g[r>>2]=F;g[r+4>>2]=E;g[r+8>>2]=D;g[r+12>>2]=ea(0.0);C=ea(g[x+52>>2]);B=ea(g[x+56>>2]);A=ea(C*F);F=ea(B*E);E=ea(ea(g[x+60>>2])*D);D=!(A<=F)?F:A;g[s>>2]=ea((!(D<=E)?E:D)*ea(.25));D=ea(g[b+16>>2]);E=ea(g[b+20>>2]);A=ea(g[b+24>>2]);F=ea(g[b+28>>2]);g[t>>2]=D;g[t+4>>2]=E;g[t+8>>2]=A;g[t+12>>2]=F;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;z1a(u,x,v,r,t);if(j){c[w+32>>2]=m;c[w+36>>2]=u+96;c[w+40>>2]=u+144;a[w+44>>0]=1;c[w>>2]=537488;c[w+48>>2]=u;H=oSa(q,w,s,p,d,e,f,ea(g[h>>2]),k,o,n,1,G,y)|0;i=l;return H|0}else{c[w+32>>2]=m;c[w+36>>2]=u+96;c[w+40>>2]=u+144;a[w+44>>0]=0;c[w>>2]=537456;c[w+48>>2]=u;H=oSa(q,w,s,p,d,e,f,ea(g[h>>2]),k,o,n,0,G,y)|0;i=l;return H|0}return 0}function qSa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=0,A=Im,B=Im,C=0,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=0;l=i;i=i+800|0;m=l+304|0;n=l+400|0;o=l+624|0;p=l+648|0;q=l+720|0;r=l+384|0;s=l;t=l+160|0;u=l+192|0;v=l+240|0;w=c[j>>2]&-16;j=b+4|0;x=ea(g[j>>2]);y=ea(-x);z=b+8|0;A=ea(g[z>>2]);B=ea(-A);C=b+12|0;D=ea(g[C>>2]);E=ea(-D);g[o>>2]=y;g[o+4>>2]=B;g[o+8>>2]=E;g[o+12>>2]=x;g[o+16>>2]=A;g[o+20>>2]=D;b=d+4|0;if(ea(g[b>>2])==ea(1.0)?ea(g[d+8>>2])==ea(1.0):0)F=ea(g[d+12>>2])==ea(1.0);else F=0;g[p>>2]=ea(1.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=ea(0.0);g[p+12>>2]=ea(0.0);g[p+16>>2]=ea(1.0);g[p+20>>2]=ea(0.0);g[p+24>>2]=ea(0.0);g[p+28>>2]=ea(0.0);g[p+32>>2]=ea(1.0);g[p+36>>2]=ea(1.0);g[p+40>>2]=ea(0.0);g[p+44>>2]=ea(0.0);g[p+48>>2]=ea(0.0);g[p+52>>2]=ea(1.0);g[p+56>>2]=ea(0.0);g[p+60>>2]=ea(0.0);g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(1.0);if(F){G=x;H=A;I=D}else{J0a(p,b,d+16|0);D=ea(g[j>>2]);A=ea(g[z>>2]);G=D;H=A;I=ea(g[C>>2])}g[q>>2]=ea(1.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(0.0);g[q+16>>2]=ea(1.0);g[q+20>>2]=ea(0.0);g[q+24>>2]=ea(0.0);g[q+28>>2]=ea(0.0);g[q+32>>2]=ea(1.0);g[q+36>>2]=ea(1.0);g[q+40>>2]=ea(0.0);g[q+44>>2]=ea(0.0);g[q+48>>2]=ea(0.0);g[q+52>>2]=ea(1.0);g[q+56>>2]=ea(0.0);g[q+60>>2]=ea(0.0);g[q+64>>2]=ea(0.0);g[q+68>>2]=ea(1.0);A=!(G<=H)?H:G;D=!(A<=I)?I:A;A=ea(D*ea(.150000006));g[r>>2]=A;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;C=s+64|0;c[s+80>>2]=3;z=s+20|0;c[z+0>>2]=c[n+0>>2];c[z+4>>2]=c[n+4>>2];c[z+8>>2]=c[n+8>>2];b=s+36|0;g[s+48>>2]=ea(0.0);J=s+52|0;c[J+0>>2]=c[n+0>>2];c[J+4>>2]=c[n+4>>2];c[J+8>>2]=c[n+8>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[C+0>>2]=c[m+0>>2];c[C+4>>2]=c[m+4>>2];c[C+8>>2]=c[m+8>>2];c[C+12>>2]=c[m+12>>2];g[s+144>>2]=G;g[s+148>>2]=H;g[s+152>>2]=I;g[s+156>>2]=ea(0.0);x=!(G>=H)?H:G;G=ea((!(x>=I)?I:x)*ea(.0299999993));x=A>G?A:G;g[s+16>>2]=D>x?x:D;c[z+0>>2]=c[n+0>>2];c[z+4>>2]=c[n+4>>2];c[z+8>>2]=c[n+8>>2];g[s+32>>2]=ea(D*ea(.0500000007));c[b+0>>2]=c[m+0>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];D=ea(g[e>>2]);x=ea(g[e+4>>2]);G=ea(g[e+8>>2]);A=ea(g[e+12>>2]);b=e+16|0;I=ea(g[b>>2]);H=ea(g[b+4>>2]);E=ea(g[b+8>>2]);g[t>>2]=D;g[t+4>>2]=x;g[t+8>>2]=G;g[t+12>>2]=A;g[t+16>>2]=I;g[t+20>>2]=H;g[t+24>>2]=E;g[t+28>>2]=ea(0.0);FSa(n,j);GSa(n,m);g[u>>2]=ea(1.0);n=u+4|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[u+20>>2]=ea(1.0);n=u+24|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;g[u+40>>2]=ea(1.0);g[u+44>>2]=ea(0.0);c[v+32>>2]=t;c[v+36>>2]=u;c[v+40>>2]=u;a[v+44>>0]=1;c[v>>2]=537520;c[v+48>>2]=s;s=oSa(m,v,r,o,d,e,f,ea(g[h>>2]),k,q,p,1,F,w)|0;i=l;return s|0}function rSa(b,f,h,j,k){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im;l=i;i=i+16|0;m=l;n=ea(g[k>>2]);o=ea(g[k+4>>2]);p=ea(g[k+8>>2]);q=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(o*o))+ea(p*p)))));r=ea(n*q);n=ea(o*q);o=ea(p*q);k=b+16|0;s=c[k>>2]|0;if(!s){i=l;return}t=b+24|0;u=b+32|0;v=f+36|0;f=b+28|0;b=j+4|0;w=j+8|0;x=m+4|0;y=m+8|0;z=s;s=0;while(1){A=c[t>>2]|0;B=c[u>>2]|0;C=e[A+(s*20|0)+16>>1]|0;D=c[v>>2]|0;E=d[B+C>>0]|0;F=c[f>>2]|0;q=ea(g[F+(E*12|0)>>2]);p=ea(g[F+(E*12|0)+4>>2]);G=ea(g[F+(E*12|0)+8>>2]);H=ea(g[D>>2]);I=ea(q*H);J=ea(g[D+16>>2]);K=ea(I+ea(p*J));I=ea(g[D+32>>2]);L=ea(K+ea(G*I));K=ea(g[D+4>>2]);M=ea(q*K);N=ea(g[D+20>>2]);O=ea(M+ea(p*N));M=ea(g[D+36>>2]);P=ea(O+ea(G*M));O=ea(g[D+8>>2]);Q=ea(q*O);q=ea(g[D+24>>2]);R=ea(Q+ea(p*q));p=ea(g[D+40>>2]);Q=ea(R+ea(G*p));D=A+(s*20|0)+18|0;A=a[D>>0]|0;if(!(A<<24>>24))S=z;else{G=ea(g[b>>2]);R=ea(g[j>>2]);U=ea(P-G);V=ea(L-R);W=ea(g[w>>2]);X=H;H=J;J=I;I=K;K=N;N=M;M=O;O=q;q=p;p=R;R=G;G=W;Y=ea(ea(ea(r*V)+ea(n*U))+ea(o*ea(Q-W)));W=L;L=P;P=Q;E=A;Z=F;F=(A&255)+-1|0;A=0;while(1){_=d[B+(F+C)>>0]|0;Q=ea(g[Z+(_*12|0)>>2]);U=ea(g[Z+(_*12|0)+4>>2]);V=ea(g[Z+(_*12|0)+8>>2]);$=ea(ea(ea(Q*X)+ea(U*H))+ea(V*J));aa=ea(ea(ea(Q*I)+ea(U*K))+ea(V*N));ba=ea(ea(ea(Q*M)+ea(U*O))+ea(V*q));V=ea(ea(ea(r*ea($-p))+ea(n*ea(aa-R)))+ea(o*ea(ba-G)));if(Y>ea(0.0)|V>ea(0.0)){U=ea(W-$);Q=ea(L-aa);ca=ea(P-ba);da=ea(ea(ea(U*U)+ea(Q*Q))+ea(ca*ca));if(da>ea(0.0)){fa=ea(ea(1.0)/ea(T(ea(da))));ga=ea(ca*fa);ha=ea(Q*fa);ia=ea(U*fa)}else{ga=ea(0.0);ha=ea(0.0);ia=ea(0.0)}g[m>>2]=ia;g[x>>2]=ha;g[y>>2]=ga;bOa(h,m)|0;ja=a[D>>0]|0}else ja=E;_=A+1|0;if(_>>>0>=(ja&255)>>>0)break;ka=c[v>>2]|0;fa=ea(g[ka>>2]);U=ea(g[ka+16>>2]);Q=ea(g[ka+32>>2]);ca=ea(g[ka+4>>2]);da=ea(g[ka+20>>2]);la=ea(g[ka+36>>2]);ma=ea(g[ka+8>>2]);na=ea(g[ka+24>>2]);oa=ea(g[ka+40>>2]);pa=ea(g[j>>2]);qa=ea(g[b>>2]);ka=A;X=fa;H=U;J=Q;I=ca;K=da;N=la;M=ma;O=na;q=oa;p=pa;R=qa;G=ea(g[w>>2]);Y=V;W=$;L=aa;P=ba;E=ja;Z=c[f>>2]|0;A=_;F=ka}S=c[k>>2]|0}s=s+1|0;if(s>>>0>=S>>>0)break;else z=S}i=l;return}function sSa(b,f,h,j,k,l,m,n,o,p){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=Im,Ia=Im,Ja=Im,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=0;q=i;i=i+80|0;r=q+48|0;s=q;t=q+64|0;u=(c[b+32>>2]|0)+(e[h+16>>1]|0)|0;v=c[k+40>>2]|0;w=ea(g[h>>2]);x=ea(g[h+4>>2]);y=ea(g[h+8>>2]);z=ea(w*ea(g[v>>2]));A=ea(z+ea(x*ea(g[v+4>>2])));z=ea(A+ea(y*ea(g[v+8>>2])));A=ea(w*ea(g[v+16>>2]));B=ea(A+ea(x*ea(g[v+20>>2])));A=ea(B+ea(y*ea(g[v+24>>2])));B=ea(w*ea(g[v+32>>2]));w=ea(B+ea(x*ea(g[v+36>>2])));x=ea(w+ea(y*ea(g[v+40>>2])));y=ea(ea(1.0)/ea(T(ea(ea(ea(z*z)+ea(A*A))+ea(x*x)))));w=ea(A*y);A=ea(x*y);g[r>>2]=ea(z*y);v=r+4|0;g[v>>2]=w;C=r+8|0;g[C>>2]=A;g[r+12>>2]=ea(0.0);MSa(s,r);D=(c[f+32>>2]|0)+(e[j+16>>1]|0)|0;E=h+18|0;h=d[E>>0]|0;F=i;i=i+((1*((h<<4)+16|0)|0)+15&-16)|0;G=F+15&-16;F=G;H=j+18|0;I=d[H>>0]|0;J=(I<<4)+16|0;K=i;i=i+((1*J|0)+15&-16)|0;L=K+15&-16;K=L;M=i;i=i+((1*I|0)+15&-16)|0;I=i;i=i+((1*J|0)+15&-16)|0;J=I+15&-16;En[c[(c[k>>2]|0)+16>>2]&127](k,u,h,c[b+28>>2]|0,F);En[c[(c[l>>2]|0)+16>>2]&127](l,D,d[H>>0]|0,c[f+28>>2]|0,K);f=L;A=ea(g[L>>2]);w=ea(g[f+4>>2]);y=ea(g[f+8>>2]);if(!(a[E>>0]|0)){N=ea(-3402823469999999843913219.0e14);O=ea(3402823469999999843913219.0e14);P=ea(3402823469999999843913219.0e14);Q=ea(-3402823469999999843913219.0e14)}else{f=s+16|0;L=s+32|0;D=s+4|0;b=s+20|0;h=s+36|0;u=s+8|0;k=s+24|0;I=s+40|0;z=ea(-3402823469999999843913219.0e14);x=ea(3402823469999999843913219.0e14);B=ea(3402823469999999843913219.0e14);R=ea(-3402823469999999843913219.0e14);S=0;do{U=F+(S<<4)|0;V=ea(g[U>>2]);W=F+(S<<4)+4|0;X=ea(g[W>>2]);Y=F+(S<<4)+8|0;Z=ea(g[Y>>2]);_=ea(V*ea(g[s>>2]));$=ea(_+ea(X*ea(g[f>>2])));_=ea($+ea(Z*ea(g[L>>2])));$=ea(V*ea(g[D>>2]));aa=ea($+ea(X*ea(g[b>>2])));$=ea(aa+ea(Z*ea(g[h>>2])));aa=ea(V*ea(g[u>>2]));V=ea(aa+ea(X*ea(g[k>>2])));X=ea(V+ea(Z*ea(g[I>>2])));g[U>>2]=_;g[W>>2]=$;g[Y>>2]=X;g[F+(S<<4)+12>>2]=ea(0.0);x=x<_?x:_;B=B<$?B:$;z=z>_?z:_;R=R>$?R:$;S=S+1|0}while(S>>>0<(d[E>>0]|0)>>>0);N=ea(z+ea(1.1920929e-07));O=ea(x+ea(-1.1920929e-07));P=ea(B+ea(-1.1920929e-07));Q=ea(R+ea(1.1920929e-07))}R=ea(g[G+8>>2]);B=ea(R+ea(g[p>>2]));G=a[H>>0]|0;if(!(G<<24>>24)){ba=ea(-3402823469999999843913219.0e14);ca=ea(3402823469999999843913219.0e14);da=ea(3402823469999999843913219.0e14);fa=ea(-3402823469999999843913219.0e14);ga=G&255;ha=0;ia=0}else{G=m+48|0;S=m+52|0;I=m+56|0;k=m+4|0;u=m+8|0;h=m+16|0;b=m+20|0;D=m+24|0;L=m+32|0;f=m+36|0;Y=m+40|0;W=s+16|0;U=s+32|0;ja=s+4|0;ka=s+20|0;la=s+36|0;ma=s+8|0;na=s+24|0;oa=s+40|0;x=ea(-3402823469999999843913219.0e14);z=ea(3402823469999999843913219.0e14);$=ea(3402823469999999843913219.0e14);_=ea(-3402823469999999843913219.0e14);pa=0;qa=0;while(1){ra=K+(pa<<4)|0;X=ea(g[ra>>2]);sa=K+(pa<<4)+4|0;Z=ea(g[sa>>2]);ta=K+(pa<<4)+8|0;V=ea(g[ta>>2]);ua=K+(pa<<4)+12|0;aa=ea(g[ua>>2]);va=ea(g[G>>2]);wa=ea(g[S>>2]);xa=ea(X-va);va=ea(Z-wa);wa=ea(V-ea(g[I>>2]));ya=ea(xa*ea(g[m>>2]));za=ea(ya+ea(va*ea(g[k>>2])));ya=ea(za+ea(wa*ea(g[u>>2])));za=ea(xa*ea(g[h>>2]));Aa=ea(za+ea(va*ea(g[b>>2])));za=ea(Aa+ea(wa*ea(g[D>>2])));Aa=ea(xa*ea(g[L>>2]));xa=ea(Aa+ea(va*ea(g[f>>2])));va=ea(xa+ea(wa*ea(g[Y>>2])));wa=ea(ya*ea(g[s>>2]));xa=ea(wa+ea(za*ea(g[W>>2])));wa=ea(xa+ea(va*ea(g[U>>2])));xa=ea(ya*ea(g[ja>>2]));Aa=ea(xa+ea(za*ea(g[ka>>2])));xa=ea(Aa+ea(va*ea(g[la>>2])));Aa=ea(ya*ea(g[ma>>2]));ya=ea(Aa+ea(za*ea(g[na>>2])));za=ea(ya+ea(va*ea(g[oa>>2])));g[ra>>2]=wa;g[sa>>2]=xa;g[ta>>2]=za;g[ua>>2]=ea(0.0);Ba=J+(pa<<4)|0;g[Ba>>2]=ea(za-R);Ca=J+(pa<<4)+4|0;c[Ca+0>>2]=c[t+0>>2];c[Ca+4>>2]=c[t+4>>2];c[Ca+8>>2]=c[t+8>>2];xa=ea(g[ra>>2]);wa=ea(g[sa>>2]);g[ta>>2]=R;g[ua>>2]=ea(0.0);z=z<xa?z:xa;$=$<wa?$:wa;x=x>xa?x:xa;_=_>wa?_:wa;ua=M+pa|0;a:do if(B>za){a[ua>>0]=1;Ca=a[E>>0]|0;Da=Ca&255;wa=ea(g[ra>>2]);xa=ea(g[sa>>2]);if(!(wa>N|O>wa)?!(xa>Q|P>xa|Ca<<24>>24==0):0){Ca=Da+-1|0;va=ea(g[F+(Ca<<4)+4>>2]);Ea=0;Fa=0;Ga=Ca;while(1){ya=va;va=ea(g[F+(Ea<<4)+4>>2]);if(ya>xa^va>xa?(Aa=ea(g[F+(Ga<<4)>>2]),Ha=ea(va-ya),Ia=ea(wa*Ha),Ja=ea(ea(Ha*Aa)+ea(ea(xa-ya)*ea(ea(g[F+(Ea<<4)>>2])-Aa))),Ca=!(Ha>ea(0.0)),(Ca?Ia:Ja)>=(Ca?Ja:Ia)):0){if((Fa|0)==1){Ka=qa;break a}La=Fa+1|0}else La=Fa;Ca=Ea+1|0;if(Ca>>>0>=Da>>>0)break;else{Ma=Ea;Ea=Ca;Fa=La;Ga=Ma}}if(La){xa=ea(g[r>>2]);wa=ea(g[v>>2]);va=ea(g[C>>2]);Ia=ea(g[Ba>>2]);Ga=c[o>>2]|0;g[n+(Ga*48|0)>>2]=X;g[n+(Ga*48|0)+4>>2]=Z;g[n+(Ga*48|0)+8>>2]=V;g[n+(Ga*48|0)+12>>2]=aa;Ga=c[o>>2]|0;Ja=ea(g[ra>>2]);Ha=ea(g[sa>>2]);Aa=ea(g[ta>>2]);ya=ea(Ja*ea(g[s>>2]));Na=ea(ya+ea(Ha*ea(g[ja>>2])));ya=ea(Na+ea(Aa*ea(g[ma>>2])));Na=ea(Ja*ea(g[W>>2]));Oa=ea(Na+ea(Ha*ea(g[ka>>2])));Na=ea(Oa+ea(Aa*ea(g[na>>2])));Oa=ea(Ja*ea(g[U>>2]));Ja=ea(Oa+ea(Ha*ea(g[la>>2])));Ha=ea(Ja+ea(Aa*ea(g[oa>>2])));g[n+(Ga*48|0)+16>>2]=ya;g[n+(Ga*48|0)+20>>2]=Na;g[n+(Ga*48|0)+24>>2]=Ha;g[n+(Ga*48|0)+28>>2]=ea(0.0);Ga=c[o>>2]|0;c[o>>2]=Ga+1;g[n+(Ga*48|0)+32>>2]=xa;g[n+(Ga*48|0)+36>>2]=wa;g[n+(Ga*48|0)+40>>2]=va;g[n+(Ga*48|0)+44>>2]=Ia;Ka=qa+1|0}else Ka=qa}else Ka=qa}else{a[ua>>0]=0;Ka=qa}while(0);pa=pa+1|0;Pa=a[H>>0]|0;Qa=Pa&255;if(pa>>>0>=Qa>>>0)break;else qa=Ka}ba=ea(x+ea(1.1920929e-07));ca=ea(z+ea(-1.1920929e-07));da=ea($+ea(-1.1920929e-07));fa=ea(_+ea(1.1920929e-07));ga=Qa;ha=Pa;ia=Ka}if((ia|0)==(ga|0)){i=q;return}ga=c[l+40>>2]|0;_=ea(g[j>>2]);$=ea(g[j+4>>2]);z=ea(g[j+8>>2]);x=ea(_*ea(g[ga>>2]));P=ea(x+ea($*ea(g[ga+4>>2])));x=ea(P+ea(z*ea(g[ga+8>>2])));P=ea(_*ea(g[ga+16>>2]));Q=ea(P+ea($*ea(g[ga+20>>2])));P=ea(Q+ea(z*ea(g[ga+24>>2])));Q=ea(_*ea(g[ga+32>>2]));_=ea(Q+ea($*ea(g[ga+36>>2])));$=ea(_+ea(z*ea(g[ga+40>>2])));z=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(P*P))+ea($*$)))));_=ea(x*z);x=ea(P*z);P=ea($*z);z=ea(g[r>>2]);$=ea(g[v>>2]);Q=ea(g[C>>2]);O=ea(z*ea(g[m>>2]));C=m+16|0;N=ea(O+ea($*ea(g[C>>2])));v=m+32|0;O=ea(N+ea(Q*ea(g[v>>2])));r=m+4|0;N=ea(z*ea(g[r>>2]));ga=m+20|0;B=ea(N+ea($*ea(g[ga>>2])));j=m+36|0;N=ea(B+ea(Q*ea(g[j>>2])));l=m+8|0;B=ea(z*ea(g[l>>2]));ia=m+24|0;aa=ea(B+ea($*ea(g[ia>>2])));Ka=m+40|0;B=ea(aa+ea(Q*ea(g[Ka>>2])));Pa=a[E>>0]|0;if(!(Pa<<24>>24)){i=q;return}Qa=s+4|0;qa=s+8|0;pa=s+16|0;oa=s+20|0;la=s+24|0;U=s+32|0;na=s+36|0;ka=s+40|0;W=m+48|0;ma=m+52|0;ja=m+56|0;aa=ea(ea(ea(_*O)+ea(x*N))+ea(P*B));La=ha;ha=Pa;Pa=0;while(1){t=La&255;V=ea(g[F+(Pa<<4)>>2]);Z=ea(g[F+(Pa<<4)+4>>2]);b:do if(!(V>ba|ca>V)?!(Z>fa|da>Z|La<<24>>24==0):0){Y=t+-1|0;X=ea(g[K+(Y<<4)+4>>2]);f=0;L=0;D=Y;while(1){za=X;X=ea(g[K+(f<<4)+4>>2]);if(za>Z^X>Z?(Ia=ea(g[K+(D<<4)>>2]),va=ea(X-za),wa=ea(V*va),xa=ea(ea(va*Ia)+ea(ea(Z-za)*ea(ea(g[K+(f<<4)>>2])-Ia))),Y=!(va>ea(0.0)),(Y?wa:xa)>=(Y?xa:wa)):0){if((L|0)==1){Ra=ha;break b}Sa=L+1|0}else Sa=L;Y=f+1|0;if(Y>>>0>=t>>>0)break;else{b=f;f=Y;L=Sa;D=b}}if((Sa|0)!=0?(X=ea(g[F+(Pa<<4)+8>>2]),wa=ea(V*ea(g[s>>2])),xa=ea(wa+ea(Z*ea(g[Qa>>2]))),wa=ea(xa+ea(X*ea(g[qa>>2]))),xa=ea(V*ea(g[pa>>2])),va=ea(xa+ea(Z*ea(g[oa>>2]))),xa=ea(va+ea(X*ea(g[la>>2]))),va=ea(V*ea(g[U>>2])),Ia=ea(va+ea(Z*ea(g[na>>2]))),va=ea(Ia+ea(X*ea(g[ka>>2]))),X=ea(g[W>>2]),Ia=ea(g[ma>>2]),za=ea(g[ja>>2]),Ha=ea(wa*ea(g[m>>2])),Na=ea(Ha+ea(xa*ea(g[C>>2]))),Ha=ea(Na+ea(va*ea(g[v>>2]))),Na=ea(wa*ea(g[r>>2])),ya=ea(Na+ea(xa*ea(g[ga>>2]))),Na=ea(ya+ea(va*ea(g[j>>2]))),ya=ea(wa*ea(g[l>>2])),Aa=ea(ya+ea(xa*ea(g[ia>>2]))),ya=ea(X+Ha),Ha=ea(Ia+Na),Na=ea(za+ea(Aa+ea(va*ea(g[Ka>>2])))),Aa=ea(ea(ea(ea(_*ea(A-ya))+ea(x*ea(w-Ha)))+ea(P*ea(y-Na)))/aa),!(Aa>ea(g[p>>2]))):0){za=ea(ya+ea(O*Aa));ya=ea(Ha+ea(N*Aa));Ha=ea(ea(B*Aa)+Na);D=c[o>>2]|0;g[n+(D*48|0)>>2]=za;g[n+(D*48|0)+4>>2]=ya;g[n+(D*48|0)+8>>2]=Ha;g[n+(D*48|0)+12>>2]=ea(0.0);D=c[o>>2]|0;g[n+(D*48|0)+16>>2]=wa;g[n+(D*48|0)+20>>2]=xa;g[n+(D*48|0)+24>>2]=va;g[n+(D*48|0)+28>>2]=ea(0.0);D=c[o>>2]|0;c[o>>2]=D+1;g[n+(D*48|0)+32>>2]=z;g[n+(D*48|0)+36>>2]=$;g[n+(D*48|0)+40>>2]=Q;g[n+(D*48|0)+44>>2]=Aa;Ra=a[E>>0]|0}else Ra=ha}else Ra=ha;while(0);t=Pa+1|0;if(t>>>0>=(Ra&255)>>>0)break;La=a[H>>0]|0;ha=Ra;Pa=t}if(!(Ra<<24>>24)){i=q;return}Pa=a[H>>0]|0;if(!(Pa<<24>>24)){i=q;return}ha=s+4|0;La=s+8|0;ja=s+16|0;ma=s+20|0;W=s+24|0;ka=s+32|0;na=s+36|0;U=s+40|0;la=m+56|0;oa=m+52|0;pa=m+48|0;qa=Ra;Qa=Pa;Sa=Ra;Ra=(Pa&255)+-1|0;Pa=0;while(1){if((a[M+Pa>>0]|0)==0?(a[M+Ra>>0]|0)==0:0){Ta=Qa;Ua=Sa;Va=qa}else{B=ea(g[K+(Pa<<4)>>2]);N=ea(g[K+(Pa<<4)+4>>2]);O=ea(g[K+(Ra<<4)>>2]);aa=ea(g[K+(Ra<<4)+4>>2]);y=ea(R+ea(g[J+(Pa<<4)>>2]));P=B<O?B:O;w=N<aa?N:aa;x=B>O?B:O;A=N>aa?N:aa;if(!(qa<<24>>24)){Ta=Qa;Ua=Sa;Va=0}else{_=ea(O-B);da=ea(aa-N);fa=ea(ea(R+ea(g[J+(Ra<<4)>>2]))-y);t=Sa;D=(qa&255)+-1|0;L=0;while(1){ca=ea(g[F+(L<<4)>>2]);ba=ea(g[F+(L<<4)+4>>2]);Z=ea(g[F+(D<<4)>>2]);V=ea(g[F+(D<<4)+4>>2]);if((((!((ca<Z?ca:Z)>x?1:P>(ca>Z?ca:Z))?!((ba<V?ba:V)>A?1:w>(ba>V?ba:V)):0)?(Aa=ea(ea(ea(ca-B)*ea(V-N))-ea(ea(ba-N)*ea(Z-B))),va=ea(ea(ea(ca-O)*ea(V-aa))-ea(ea(ba-aa)*ea(Z-O))),ea(Aa*va)<ea(0.0)):0)?ea(ea(ea(ea(B-ca)*ea(aa-ba))-ea(ea(O-ca)*ea(N-ba)))*ea(ea(ea(B-Z)*ea(aa-V))-ea(ea(O-Z)*ea(N-V))))<ea(0.0):0)?(V=ea(Aa/ea(va-Aa)),Aa=ea(B-ea(_*V)),va=ea(N-ea(da*V)),Z=ea(y-ea(fa*V)),V=ea(ea(g[s>>2])*Aa),ba=ea(V+ea(ea(g[ha>>2])*va)),V=ea(g[La>>2]),ca=ea(Aa*ea(g[ja>>2])),xa=ea(ca+ea(va*ea(g[ma>>2]))),ca=ea(g[W>>2]),wa=ea(Aa*ea(g[ka>>2])),Aa=ea(wa+ea(va*ea(g[na>>2]))),va=ea(g[U>>2]),wa=ea(ba+ea(Z*V)),Ha=ea(xa+ea(Z*ca)),ya=ea(Aa+ea(Z*va)),za=ea(Z-R),!(za>ea(g[p>>2]))):0){Z=ea(g[ia>>2]);Na=ea(g[l>>2]);Ia=ea(g[ga>>2]);X=ea(g[r>>2]);Ja=ea(g[C>>2]);Oa=ea(g[m>>2]);Wa=ea(g[Ka>>2]);Xa=ea(Ha*Z);Z=ea(wa*Na);Na=ea(g[j>>2]);Ya=ea(Ha*Ia);Ia=ea(wa*X);X=ea(ea(Xa+Z)+ea(ya*Wa));Wa=ea(ea(Ya+Ia)+ea(ya*Na));Na=ea(ea(ea(Ha*Ja)+ea(wa*Oa))+ea(ya*ea(g[v>>2])));ya=ea(g[la>>2]);Oa=ea(g[oa>>2]);wa=ea(X+ya);ya=ea(Wa+Oa);Oa=ea(Na+ea(g[pa>>2]));Na=ea(Aa+ea(R*va));va=ea(xa+ea(R*ca));ca=ea(ba+ea(R*V));f=c[o>>2]|0;g[n+(f*48|0)>>2]=Oa;g[n+(f*48|0)+4>>2]=ya;g[n+(f*48|0)+8>>2]=wa;g[n+(f*48|0)+12>>2]=ea(0.0);f=c[o>>2]|0;g[n+(f*48|0)+16>>2]=ca;g[n+(f*48|0)+20>>2]=va;g[n+(f*48|0)+24>>2]=Na;g[n+(f*48|0)+28>>2]=ea(0.0);f=c[o>>2]|0;c[o>>2]=f+1;g[n+(f*48|0)+32>>2]=z;g[n+(f*48|0)+36>>2]=$;g[n+(f*48|0)+40>>2]=Q;g[n+(f*48|0)+44>>2]=za;Za=a[E>>0]|0}else Za=t;f=L+1|0;if(f>>>0<(Za&255)>>>0){b=L;t=Za;L=f;D=b}else break}Ta=a[H>>0]|0;Ua=Za;Va=Za}}D=Pa+1|0;if(D>>>0<(Ta&255)>>>0){L=Pa;qa=Va;Qa=Ta;Sa=Ua;Pa=D;Ra=L}else break}i=q;return}function tSa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;m=i;i=i+288|0;n=m+144|0;o=m+64|0;p=m+272|0;q=m+16|0;r=m+224|0;s=m+276|0;t=m+280|0;u=m+256|0;v=m+128|0;w=m+32|0;x=m;y=m+48|0;z=m+240|0;A=m+208|0;B=d+32|0;C=c[B>>2]|0;D=e+32|0;E=c[D>>2]|0;F=ea(g[C>>2]);G=ea(g[C+4>>2]);H=ea(g[C+8>>2]);I=ea(g[C+12>>2]);J=ea(-F);F=ea(-G);G=ea(-H);H=ea(g[E+16>>2]);K=ea(g[E+20>>2]);L=ea(g[E+24>>2]);M=ea(g[C+16>>2]);N=ea(g[C+20>>2]);O=ea(H-M);M=ea(K-N);N=ea(L-ea(g[C+24>>2]));L=ea(ea(I*I)+ea(-.5));K=ea(ea(ea(O*J)+ea(M*F))+ea(N*G));H=ea(ea(ea(K*J)+ea(ea(L*O)+ea(I*ea(ea(N*F)-ea(M*G)))))*ea(2.0));P=ea(ea(ea(K*F)+ea(ea(L*M)+ea(I*ea(ea(O*G)-ea(N*J)))))*ea(2.0));Q=ea(ea(ea(ea(L*N)+ea(I*ea(ea(M*J)-ea(O*F))))+ea(K*G))*ea(2.0));K=ea(g[E>>2]);O=ea(g[E+4>>2]);M=ea(g[E+8>>2]);N=ea(g[E+12>>2]);L=ea(ea(I*N)-ea(ea(ea(K*J)+ea(O*F))+ea(M*G)));R=ea(ea(ea(M*F)-ea(O*G))+ea(ea(I*K)+ea(N*J)));S=ea(ea(ea(K*G)-ea(M*J))+ea(ea(I*O)+ea(N*F)));T=ea(ea(ea(O*J)-ea(K*F))+ea(ea(I*M)+ea(N*G)));g[n+48>>2]=H;g[n+52>>2]=P;g[n+56>>2]=Q;g[n+60>>2]=ea(0.0);Q=ea(R+R);P=ea(S+S);H=ea(T+T);G=ea(S*P);N=ea(T*H);M=ea(S*Q);S=ea(T*Q);I=ea(L*Q);F=ea(T*P);T=ea(L*P);P=ea(L*H);H=ea(ea(1.0)-ea(R*Q));Q=ea(M+P);R=ea(S-T);L=ea(M-P);P=ea(H-N);M=ea(F+I);K=ea(S+T);T=ea(F-I);I=ea(H-G);g[n>>2]=ea(ea(ea(1.0)-G)-N);E=n+4|0;g[E>>2]=Q;C=n+8|0;g[C>>2]=R;g[n+12>>2]=ea(0.0);U=n+16|0;g[U>>2]=L;V=n+20|0;g[V>>2]=P;W=n+24|0;g[W>>2]=M;g[n+28>>2]=ea(0.0);X=n+32|0;g[X>>2]=K;Y=n+36|0;g[Y>>2]=T;Z=n+40|0;g[Z>>2]=I;g[n+44>>2]=ea(0.0);_=c[D>>2]|0;D=c[B>>2]|0;I=ea(g[_>>2]);T=ea(g[_+4>>2]);K=ea(g[_+8>>2]);M=ea(g[_+12>>2]);P=ea(-I);I=ea(-T);T=ea(-K);K=ea(g[D+16>>2]);L=ea(g[D+20>>2]);R=ea(g[D+24>>2]);Q=ea(g[_+16>>2]);N=ea(g[_+20>>2]);G=ea(K-Q);Q=ea(L-N);N=ea(R-ea(g[_+24>>2]));R=ea(ea(M*M)+ea(-.5));L=ea(ea(ea(G*P)+ea(Q*I))+ea(N*T));K=ea(ea(ea(L*P)+ea(ea(R*G)+ea(M*ea(ea(N*I)-ea(Q*T)))))*ea(2.0));H=ea(ea(ea(L*I)+ea(ea(R*Q)+ea(M*ea(ea(G*T)-ea(N*P)))))*ea(2.0));F=ea(ea(ea(ea(R*N)+ea(M*ea(ea(Q*P)-ea(G*I))))+ea(L*T))*ea(2.0));L=ea(g[D>>2]);G=ea(g[D+4>>2]);Q=ea(g[D+8>>2]);N=ea(g[D+12>>2]);R=ea(ea(M*N)-ea(ea(ea(L*P)+ea(G*I))+ea(Q*T)));S=ea(ea(ea(Q*I)-ea(G*T))+ea(ea(M*L)+ea(N*P)));J=ea(ea(ea(L*T)-ea(Q*P))+ea(ea(M*G)+ea(N*I)));O=ea(ea(ea(G*P)-ea(L*I))+ea(ea(M*Q)+ea(N*T)));g[o+48>>2]=K;g[o+52>>2]=H;g[o+56>>2]=F;g[o+60>>2]=ea(0.0);F=ea(S+S);H=ea(J+J);K=ea(O+O);T=ea(J*H);N=ea(O*K);Q=ea(J*F);J=ea(O*F);M=ea(R*F);I=ea(O*H);O=ea(R*H);H=ea(R*K);K=ea(ea(1.0)-ea(S*F));F=ea(Q+H);S=ea(J-O);R=ea(Q-H);H=ea(K-N);Q=ea(I+M);L=ea(J+O);O=ea(I-M);M=ea(K-T);g[o>>2]=ea(ea(ea(1.0)-T)-N);D=o+4|0;g[D>>2]=F;_=o+8|0;g[_>>2]=S;g[o+12>>2]=ea(0.0);B=o+16|0;g[B>>2]=R;$=o+20|0;g[$>>2]=H;aa=o+24|0;g[aa>>2]=Q;g[o+28>>2]=ea(0.0);ba=o+32|0;g[ba>>2]=L;ca=o+36|0;g[ca>>2]=O;da=o+40|0;g[da>>2]=M;g[o+44>>2]=ea(0.0);fa=c[h>>2]|0;if(!l){M=ea(g[k>>2]);l=k+4|0;O=ea(g[l>>2]);ga=k+8|0;L=ea(-O);O=ea(-ea(g[ga>>2]));g[z>>2]=ea(-M);g[z+4>>2]=L;g[z+8>>2]=O;g[z+12>>2]=ea(0.0);ha=g8a(b,e,z)|0;O=ea(g[k>>2]);L=ea(g[l>>2]);M=ea(g[ga>>2]);Q=ea(O*ea(g[o>>2]));H=ea(Q+ea(L*ea(g[D>>2])));Q=ea(H+ea(M*ea(g[_>>2])));H=ea(O*ea(g[B>>2]));R=ea(H+ea(L*ea(g[$>>2])));H=ea(R+ea(M*ea(g[aa>>2])));R=ea(O*ea(g[ba>>2]));O=ea(R+ea(L*ea(g[ca>>2])));L=ea(O+ea(M*ea(g[da>>2])));g[A>>2]=Q;g[A+4>>2]=H;g[A+8>>2]=L;g[A+12>>2]=ea(0.0);ga=g8a(a,d,A)|0;sSa(b,a,(c[b+24>>2]|0)+(ha*20|0)|0,(c[a+24>>2]|0)+(ga*20|0)|0,e,d,n,f,h,j);ia=1;i=m;return ia|0}c[p>>2]=0;g[q>>2]=ea(3402823469999999843913219.0e14);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;if(!(e8a(a,b,d,e,o,n,j,q,s,r,0,p)|0)){ia=0;i=m;return ia|0}if(!(e8a(b,a,e,d,n,o,j,q,t,r,1,p)|0)){ia=0;i=m;return ia|0}ga=r+4|0;ha=r+8|0;A=x+4|0;l=x+8|0;k=x+12|0;z=a+24|0;ja=y+4|0;ka=y+8|0;la=y+12|0;ma=b+24|0;na=c[s>>2]|0;s=u+4|0;oa=u+8|0;pa=u+12|0;qa=c[t>>2]|0;t=w+4|0;ra=w+8|0;sa=w+12|0;ta=0;a:while(1){do if(ta){if(!(f8a(a,b,d,e,o,n,j,q,r,p)|0)){ia=0;ua=16;break a}if((c[p>>2]|0)==2)ua=13;else{ia=1;ua=16;break a}}else{va=c[p>>2]|0;if((va|0)==1){wa=(c[ma>>2]|0)+(qa*20|0)|0;L=ea(g[r>>2]);H=ea(g[ga>>2]);Q=ea(g[ha>>2]);M=ea(L*ea(g[n>>2]));O=ea(M+ea(H*ea(g[U>>2])));M=ea(O+ea(Q*ea(g[X>>2])));O=ea(L*ea(g[E>>2]));R=ea(O+ea(H*ea(g[V>>2])));O=ea(R+ea(Q*ea(g[Y>>2])));R=ea(L*ea(g[C>>2]));L=ea(R+ea(H*ea(g[W>>2])));H=ea(L+ea(Q*ea(g[Z>>2])));g[w>>2]=M;g[t>>2]=O;g[ra>>2]=H;g[sa>>2]=ea(0.0);xa=g8a(a,d,w)|0;sSa(b,a,wa,(c[z>>2]|0)+(xa*20|0)|0,e,d,n,f,h,j);break}else if(va){ua=13;break}va=(c[z>>2]|0)+(na*20|0)|0;H=ea(g[r>>2]);O=ea(g[ga>>2]);M=ea(g[ha>>2]);Q=ea(H*ea(g[o>>2]));L=ea(Q+ea(O*ea(g[B>>2])));Q=ea(L+ea(M*ea(g[ba>>2])));L=ea(H*ea(g[D>>2]));R=ea(L+ea(O*ea(g[$>>2])));L=ea(R+ea(M*ea(g[ca>>2])));R=ea(H*ea(g[_>>2]));H=ea(R+ea(O*ea(g[aa>>2])));O=ea(H+ea(M*ea(g[da>>2])));g[u>>2]=Q;g[s>>2]=L;g[oa>>2]=O;g[pa>>2]=ea(0.0);xa=g8a(b,e,u)|0;sSa(a,b,va,(c[ma>>2]|0)+(xa*20|0)|0,d,e,o,f,h,j);xa=c[h>>2]|0;if((xa|0)!=(fa|0)?(O=ea(g[u>>2]),L=ea(g[s>>2]),Q=ea(-O),O=ea(-L),L=ea(-ea(g[oa>>2])),fa>>>0<xa>>>0):0){xa=fa;do{va=f+(xa*48|0)|0;wa=f+(xa*48|0)+16|0;c[v+0>>2]=c[wa+0>>2];c[v+4>>2]=c[wa+4>>2];c[v+8>>2]=c[wa+8>>2];c[v+12>>2]=c[wa+12>>2];c[wa+0>>2]=c[va+0>>2];c[wa+4>>2]=c[va+4>>2];c[wa+8>>2]=c[va+8>>2];c[wa+12>>2]=c[va+12>>2];c[va+0>>2]=c[v+0>>2];c[va+4>>2]=c[v+4>>2];c[va+8>>2]=c[v+8>>2];c[va+12>>2]=c[v+12>>2];g[f+(xa*48|0)+32>>2]=Q;g[f+(xa*48|0)+36>>2]=O;g[f+(xa*48|0)+40>>2]=L;xa=xa+1|0}while(xa>>>0<(c[h>>2]|0)>>>0)}}while(0);if((ua|0)==13){ua=0;L=ea(g[r>>2]);O=ea(g[ga>>2]);Q=ea(g[ha>>2]);M=ea(-O);H=ea(-Q);g[x>>2]=ea(-L);g[A>>2]=M;g[l>>2]=H;g[k>>2]=ea(0.0);xa=g8a(a,d,x)|0;va=(c[z>>2]|0)+(xa*20|0)|0;H=ea(L*ea(g[o>>2]));M=ea(H+ea(O*ea(g[B>>2])));H=ea(M+ea(Q*ea(g[ba>>2])));M=ea(L*ea(g[D>>2]));R=ea(M+ea(O*ea(g[$>>2])));M=ea(R+ea(Q*ea(g[ca>>2])));R=ea(L*ea(g[_>>2]));L=ea(R+ea(O*ea(g[aa>>2])));O=ea(L+ea(Q*ea(g[da>>2])));g[y>>2]=H;g[ja>>2]=M;g[ka>>2]=O;g[la>>2]=ea(0.0);xa=g8a(b,e,y)|0;sSa(b,a,(c[ma>>2]|0)+(xa*20|0)|0,va,e,d,n,f,h,j)}if((c[h>>2]|0)!=(fa|0)|ta){ia=1;ua=16;break}else ta=1}if((ua|0)==16){i=m;return ia|0}return 0}function uSa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0;j=i;i=i+192|0;k=j+112|0;l=j+32|0;m=j+184|0;n=j;o=j+96|0;p=j+16|0;q=d+32|0;r=c[q>>2]|0;s=e+32|0;t=c[s>>2]|0;u=ea(g[r>>2]);v=ea(g[r+4>>2]);w=ea(g[r+8>>2]);x=ea(g[r+12>>2]);y=ea(-u);u=ea(-v);v=ea(-w);w=ea(g[t+16>>2]);z=ea(g[t+20>>2]);A=ea(g[t+24>>2]);B=ea(g[r+16>>2]);C=ea(g[r+20>>2]);D=ea(w-B);B=ea(z-C);C=ea(A-ea(g[r+24>>2]));A=ea(ea(x*x)+ea(-.5));z=ea(ea(ea(D*y)+ea(B*u))+ea(C*v));w=ea(ea(ea(z*y)+ea(ea(A*D)+ea(x*ea(ea(C*u)-ea(B*v)))))*ea(2.0));E=ea(ea(ea(z*u)+ea(ea(A*B)+ea(x*ea(ea(D*v)-ea(C*y)))))*ea(2.0));F=ea(ea(ea(ea(A*C)+ea(x*ea(ea(B*y)-ea(D*u))))+ea(z*v))*ea(2.0));z=ea(g[t>>2]);D=ea(g[t+4>>2]);B=ea(g[t+8>>2]);C=ea(g[t+12>>2]);A=ea(ea(x*C)-ea(ea(ea(z*y)+ea(D*u))+ea(B*v)));G=ea(ea(ea(B*u)-ea(D*v))+ea(ea(x*z)+ea(C*y)));H=ea(ea(ea(z*v)-ea(B*y))+ea(ea(x*D)+ea(C*u)));I=ea(ea(ea(D*y)-ea(z*u))+ea(ea(x*B)+ea(C*v)));g[k+48>>2]=w;g[k+52>>2]=E;g[k+56>>2]=F;g[k+60>>2]=ea(0.0);F=ea(G+G);E=ea(H+H);w=ea(I+I);v=ea(H*E);C=ea(I*w);B=ea(H*F);H=ea(I*F);x=ea(A*F);u=ea(I*E);I=ea(A*E);E=ea(A*w);w=ea(ea(1.0)-ea(G*F));F=ea(B+E);G=ea(H-I);A=ea(B-E);E=ea(w-C);B=ea(u+x);z=ea(H+I);I=ea(u-x);x=ea(w-v);g[k>>2]=ea(ea(ea(1.0)-v)-C);g[k+4>>2]=F;g[k+8>>2]=G;g[k+12>>2]=ea(0.0);g[k+16>>2]=A;g[k+20>>2]=E;g[k+24>>2]=B;g[k+28>>2]=ea(0.0);g[k+32>>2]=z;g[k+36>>2]=I;g[k+40>>2]=x;g[k+44>>2]=ea(0.0);t=c[s>>2]|0;r=c[q>>2]|0;x=ea(g[t>>2]);I=ea(g[t+4>>2]);z=ea(g[t+8>>2]);B=ea(g[t+12>>2]);E=ea(-x);x=ea(-I);I=ea(-z);z=ea(g[r+16>>2]);A=ea(g[r+20>>2]);G=ea(g[r+24>>2]);F=ea(g[t+16>>2]);C=ea(g[t+20>>2]);v=ea(z-F);F=ea(A-C);C=ea(G-ea(g[t+24>>2]));G=ea(ea(B*B)+ea(-.5));A=ea(ea(ea(v*E)+ea(F*x))+ea(C*I));z=ea(ea(ea(A*E)+ea(ea(G*v)+ea(B*ea(ea(C*x)-ea(F*I)))))*ea(2.0));w=ea(ea(ea(A*x)+ea(ea(G*F)+ea(B*ea(ea(v*I)-ea(C*E)))))*ea(2.0));u=ea(ea(ea(ea(G*C)+ea(B*ea(ea(F*E)-ea(v*x))))+ea(A*I))*ea(2.0));A=ea(g[r>>2]);v=ea(g[r+4>>2]);F=ea(g[r+8>>2]);C=ea(g[r+12>>2]);G=ea(ea(B*C)-ea(ea(ea(A*E)+ea(v*x))+ea(F*I)));H=ea(ea(ea(F*x)-ea(v*I))+ea(ea(B*A)+ea(C*E)));y=ea(ea(ea(A*I)-ea(F*E))+ea(ea(B*v)+ea(C*x)));D=ea(ea(ea(v*E)-ea(A*x))+ea(ea(B*F)+ea(C*I)));g[l+48>>2]=z;g[l+52>>2]=w;g[l+56>>2]=u;g[l+60>>2]=ea(0.0);u=ea(H+H);w=ea(y+y);z=ea(D+D);I=ea(y*w);C=ea(D*z);F=ea(y*u);y=ea(D*u);B=ea(G*u);x=ea(D*w);D=ea(G*w);w=ea(G*z);z=ea(ea(1.0)-ea(H*u));u=ea(F+w);H=ea(y-D);G=ea(F-w);w=ea(z-C);F=ea(x+B);A=ea(y+D);D=ea(x-B);B=ea(z-I);g[l>>2]=ea(ea(ea(1.0)-I)-C);g[l+4>>2]=u;g[l+8>>2]=H;g[l+12>>2]=ea(0.0);g[l+16>>2]=G;g[l+20>>2]=w;g[l+24>>2]=F;g[l+28>>2]=ea(0.0);g[l+32>>2]=A;g[l+36>>2]=D;g[l+40>>2]=B;g[l+44>>2]=ea(0.0);c[m>>2]=0;g[n>>2]=ea(3402823469999999843913219.0e14);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[p>>2]=ea(0.0);if(!(e8a(a,b,d,e,l,k,p,n,j+180|0,o,0,m)|0)){J=0;i=j;return J|0}if(!(e8a(b,a,e,d,k,l,p,n,j+176|0,o,1,m)|0)){J=0;i=j;return J|0}if(!(f8a(a,b,d,e,l,k,p,n,o,m)|0)){J=0;i=j;return J|0};c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];if((c[m>>2]|0)==1){m=c[s>>2]|0;B=ea(g[m>>2]);D=ea(g[m+4>>2]);A=ea(g[m+8>>2]);F=ea(g[m+12>>2]);w=ea(g[o>>2]);G=ea(g[o+4>>2]);H=ea(g[o+8>>2]);u=ea(ea(F*F)+ea(-.5));C=ea(ea(ea(B*w)+ea(D*G))+ea(A*H));I=ea(ea(ea(D*C)+ea(ea(u*G)+ea(F*ea(ea(A*w)-ea(B*H)))))*ea(2.0));z=ea(ea(ea(ea(u*H)+ea(F*ea(ea(B*G)-ea(D*w))))+ea(A*C))*ea(2.0));g[h>>2]=ea(ea(ea(B*C)+ea(ea(w*u)+ea(F*ea(ea(D*H)-ea(A*G)))))*ea(2.0));g[h+4>>2]=I;g[h+8>>2]=z;g[h+12>>2]=ea(0.0);J=1;i=j;return J|0}else{m=c[q>>2]|0;z=ea(g[m>>2]);I=ea(g[m+4>>2]);G=ea(g[m+8>>2]);A=ea(g[m+12>>2]);H=ea(g[o>>2]);D=ea(g[o+4>>2]);F=ea(g[o+8>>2]);u=ea(ea(A*A)+ea(-.5));w=ea(ea(ea(z*H)+ea(I*D))+ea(G*F));C=ea(-ea(ea(ea(I*w)+ea(ea(u*D)+ea(A*ea(ea(G*H)-ea(z*F)))))*ea(2.0)));B=ea(-ea(ea(ea(ea(u*F)+ea(A*ea(ea(z*D)-ea(I*H))))+ea(G*w))*ea(2.0)));g[h>>2]=ea(-ea(ea(ea(z*w)+ea(ea(H*u)+ea(A*ea(ea(I*F)-ea(G*D)))))*ea(2.0)));g[h+4>>2]=C;g[h+8>>2]=B;g[h+12>>2]=ea(0.0);J=1;i=j;return J|0}return 0}function vSa(b,f,h,j,k,l,m,n,o){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=Im,ha=0,ia=0;p=i;i=i+64|0;q=p+48|0;r=p;s=ea(g[b+128>>2]);t=ea(s+ea(g[n>>2]));n=c[j+40>>2]|0;s=ea(g[h>>2]);u=ea(g[h+4>>2]);v=ea(g[h+8>>2]);w=ea(s*ea(g[n>>2]));x=ea(w+ea(u*ea(g[n+4>>2])));w=ea(x+ea(v*ea(g[n+8>>2])));x=ea(s*ea(g[n+16>>2]));y=ea(x+ea(u*ea(g[n+20>>2])));x=ea(y+ea(v*ea(g[n+24>>2])));y=ea(s*ea(g[n+32>>2]));s=ea(y+ea(u*ea(g[n+36>>2])));u=ea(s+ea(v*ea(g[n+40>>2])));v=ea(ea(1.0)/ea(T(ea(ea(ea(w*w)+ea(x*x))+ea(u*u)))));s=ea(w*v);w=ea(x*v);x=ea(u*v);g[q>>2]=s;g[q+4>>2]=w;g[q+8>>2]=x;g[q+12>>2]=ea(0.0);n=(c[f+32>>2]|0)+(e[h+16>>1]|0)|0;z=c[j+36>>2]|0;A=d[n>>0]|0;B=f+28|0;f=c[B>>2]|0;v=ea(g[f+(A*12|0)>>2]);u=ea(g[f+(A*12|0)+4>>2]);y=ea(g[f+(A*12|0)+8>>2]);C=ea(v*ea(g[z>>2]));D=ea(C+ea(u*ea(g[z+16>>2])));C=ea(D+ea(y*ea(g[z+32>>2])));D=ea(v*ea(g[z+4>>2]));E=ea(D+ea(u*ea(g[z+20>>2])));D=ea(E+ea(y*ea(g[z+36>>2])));E=ea(v*ea(g[z+8>>2]));v=ea(E+ea(u*ea(g[z+24>>2])));u=ea(v+ea(y*ea(g[z+40>>2])));z=b+96|0;y=ea(g[z>>2]);A=b+100|0;v=ea(g[A>>2]);f=b+104|0;E=ea(ea(ea(s*ea(y-C))+ea(w*ea(v-D)))+ea(x*ea(ea(g[f>>2])-u)));F=b+112|0;v=ea(g[F>>2]);G=b+116|0;y=ea(g[G>>2]);H=b+120|0;I=ea(ea(ea(s*ea(v-C))+ea(w*ea(y-D)))+ea(x*ea(ea(g[H>>2])-u)));u=ea(g[o>>2]);b=o+4|0;D=ea(g[b>>2]);J=o+8|0;y=ea(ea(1.0)/ea(ea(ea(s*u)+ea(w*D))+ea(x*ea(g[J>>2]))));x=ea(E*y);E=ea(I*y);K=t>=x;L=t>=E;if(!(K|L)){i=p;return}MSa(r,q);q=h+18|0;h=d[q>>0]|0;M=i;i=i+((1*((h<<4)+16|0)|0)+15&-16)|0;N=M+15&-16;En[c[(c[j>>2]|0)+16>>2]&127](j,n,h,c[B>>2]|0,N);if(!(a[q>>0]|0)){O=ea(-3402823469999999843913219.0e14);P=ea(3402823469999999843913219.0e14);Q=ea(3402823469999999843913219.0e14);R=ea(-3402823469999999843913219.0e14);S=0}else{B=r+16|0;h=r+32|0;n=r+4|0;j=r+20|0;M=r+36|0;U=r+8|0;V=r+24|0;W=r+40|0;t=ea(-3402823469999999843913219.0e14);y=ea(3402823469999999843913219.0e14);I=ea(3402823469999999843913219.0e14);D=ea(-3402823469999999843913219.0e14);X=0;while(1){Y=N+(X<<4)|0;w=ea(g[Y>>2]);Z=N+(X<<4)+4|0;u=ea(g[Z>>2]);_=N+(X<<4)+8|0;s=ea(g[_>>2]);C=ea(w*ea(g[r>>2]));v=ea(C+ea(u*ea(g[B>>2])));C=ea(v+ea(s*ea(g[h>>2])));v=ea(w*ea(g[n>>2]));$=ea(v+ea(u*ea(g[j>>2])));v=ea($+ea(s*ea(g[M>>2])));$=ea(w*ea(g[U>>2]));w=ea($+ea(u*ea(g[V>>2])));u=ea(w+ea(s*ea(g[W>>2])));g[Y>>2]=C;g[Z>>2]=v;g[_>>2]=u;g[N+(X<<4)+12>>2]=ea(0.0);u=y<C?y:C;s=I<v?I:v;w=t>C?t:C;C=D>v?D:v;X=X+1|0;_=a[q>>0]|0;if(X>>>0>=(_&255)>>>0){O=w;P=u;Q=s;R=C;S=_;break}else{t=w;y=u;I=s;D=C}}}a:do if((K?(D=ea(g[o>>2]),I=ea(g[b>>2]),y=ea(g[J>>2]),t=ea(g[z>>2]),C=ea(g[A>>2]),s=ea(g[f>>2]),u=ea(t-ea(x*D)),D=ea(C-ea(x*I)),I=ea(s-ea(x*y)),y=ea(u*ea(g[r>>2])),w=ea(y+ea(D*ea(g[r+16>>2]))),y=ea(w+ea(I*ea(g[r+32>>2]))),w=ea(u*ea(g[r+4>>2])),v=ea(w+ea(D*ea(g[r+20>>2]))),w=ea(v+ea(I*ea(g[r+36>>2]))),X=S&255,!(y>O|P>y)):0)?!(w>R|Q>w|S<<24>>24==0):0){W=X+-1|0;v=ea(g[N+(W<<4)+4>>2]);V=0;U=0;M=W;while(1){$=v;v=ea(g[N+(V<<4)+4>>2]);if($>w^v>w?(aa=ea(g[N+(M<<4)>>2]),ba=ea(v-$),ca=ea(y*ba),da=ea(ea(ba*aa)+ea(ea(w-$)*ea(ea(g[N+(V<<4)>>2])-aa))),W=!(ba>ea(0.0)),(W?ca:da)>=(W?da:ca)):0){if((U|0)==1)break a;fa=U+1|0}else fa=U;W=V+1|0;if(W>>>0>=X>>>0)break;else{j=V;V=W;U=fa;M=j}}if(fa){M=c[m>>2]|0;w=ea(g[k+48>>2]);y=ea(g[k+52>>2]);v=ea(t-w);w=ea(C-y);y=ea(s-ea(g[k+56>>2]));ca=ea(v*ea(g[k>>2]));da=ea(ca+ea(w*ea(g[k+4>>2])));ca=ea(da+ea(y*ea(g[k+8>>2])));da=ea(v*ea(g[k+16>>2]));ba=ea(da+ea(w*ea(g[k+20>>2])));da=ea(ba+ea(y*ea(g[k+24>>2])));ba=ea(v*ea(g[k+32>>2]));v=ea(ba+ea(w*ea(g[k+36>>2])));w=ea(v+ea(y*ea(g[k+40>>2])));g[l+(M*48|0)>>2]=ca;g[l+(M*48|0)+4>>2]=da;g[l+(M*48|0)+8>>2]=w;g[l+(M*48|0)+12>>2]=ea(0.0);M=c[m>>2]|0;g[l+(M*48|0)+16>>2]=u;g[l+(M*48|0)+20>>2]=D;g[l+(M*48|0)+24>>2]=I;g[l+(M*48|0)+28>>2]=ea(0.0);M=c[m>>2]|0;c[m>>2]=M+1;w=ea(g[o>>2]);da=ea(g[b>>2]);ca=ea(g[J>>2]);g[l+(M*48|0)+32>>2]=w;g[l+(M*48|0)+36>>2]=da;g[l+(M*48|0)+40>>2]=ca;g[l+(M*48|0)+44>>2]=x}}while(0);if(!L){i=p;return}x=ea(g[o>>2]);ca=ea(g[b>>2]);da=ea(g[J>>2]);w=ea(g[F>>2]);y=ea(g[G>>2]);v=ea(g[H>>2]);ba=ea(w-ea(E*x));x=ea(y-ea(E*ca));ca=ea(v-ea(E*da));da=ea(ba*ea(g[r>>2]));aa=ea(da+ea(x*ea(g[r+16>>2])));da=ea(aa+ea(ca*ea(g[r+32>>2])));aa=ea(ba*ea(g[r+4>>2]));$=ea(aa+ea(x*ea(g[r+20>>2])));aa=ea($+ea(ca*ea(g[r+36>>2])));r=a[q>>0]|0;q=r&255;if(da>O|P>da){i=p;return}if(aa>R|Q>aa|r<<24>>24==0){i=p;return}r=q+-1|0;Q=ea(g[N+(r<<4)+4>>2]);H=0;G=0;F=r;while(1){R=Q;Q=ea(g[N+(H<<4)+4>>2]);if(R>aa^Q>aa?(P=ea(g[N+(F<<4)>>2]),O=ea(Q-R),$=ea(da*O),ga=ea(ea(O*P)+ea(ea(aa-R)*ea(ea(g[N+(H<<4)>>2])-P))),r=!(O>ea(0.0)),(r?$:ga)>=(r?ga:$)):0){if((G|0)==1){ha=27;break}ia=G+1|0}else ia=G;r=H+1|0;if(r>>>0>=q>>>0)break;else{L=H;H=r;G=ia;F=L}}if((ha|0)==27){i=p;return}if(!ia){i=p;return}ia=c[m>>2]|0;aa=ea(g[k+48>>2]);da=ea(g[k+52>>2]);Q=ea(w-aa);aa=ea(y-da);da=ea(v-ea(g[k+56>>2]));v=ea(Q*ea(g[k>>2]));y=ea(v+ea(aa*ea(g[k+4>>2])));v=ea(y+ea(da*ea(g[k+8>>2])));y=ea(Q*ea(g[k+16>>2]));w=ea(y+ea(aa*ea(g[k+20>>2])));y=ea(w+ea(da*ea(g[k+24>>2])));w=ea(Q*ea(g[k+32>>2]));Q=ea(w+ea(aa*ea(g[k+36>>2])));aa=ea(Q+ea(da*ea(g[k+40>>2])));g[l+(ia*48|0)>>2]=v;g[l+(ia*48|0)+4>>2]=y;g[l+(ia*48|0)+8>>2]=aa;g[l+(ia*48|0)+12>>2]=ea(0.0);ia=c[m>>2]|0;g[l+(ia*48|0)+16>>2]=ba;g[l+(ia*48|0)+20>>2]=x;g[l+(ia*48|0)+24>>2]=ca;g[l+(ia*48|0)+28>>2]=ea(0.0);ia=c[m>>2]|0;c[m>>2]=ia+1;ca=ea(g[o>>2]);x=ea(g[b>>2]);ba=ea(g[J>>2]);g[l+(ia*48|0)+32>>2]=ca;g[l+(ia*48|0)+36>>2]=x;g[l+(ia*48|0)+40>>2]=ba;g[l+(ia*48|0)+44>>2]=E;i=p;return}function wSa(b,f,h,j,k,l,m,n,o){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0;p=i;q=h+18|0;r=d[q>>0]|0;s=i;i=i+((1*((r<<4)+16|0)|0)+15&-16)|0;t=s+15&-16;En[c[(c[j>>2]|0)+16>>2]&127](j,(c[f+32>>2]|0)+(e[h+16>>1]|0)|0,r,c[f+28>>2]|0,t);u=ea(g[b+128>>2]);v=ea(u+ea(g[n>>2]));n=a[q>>0]|0;if(!(n<<24>>24)){i=p;return}f=o+4|0;r=o+8|0;h=b+96|0;j=b+100|0;s=b+104|0;w=b+112|0;x=b+116|0;y=b+120|0;b=k+48|0;z=k+52|0;A=k+56|0;B=k+4|0;C=k+8|0;D=k+16|0;E=k+20|0;F=k+24|0;G=k+32|0;H=k+36|0;I=k+40|0;J=n;K=(n&255)+-1|0;n=0;while(1){u=ea(g[t+(K<<4)>>2]);L=ea(g[t+(K<<4)+4>>2]);M=ea(g[t+(K<<4)+8>>2]);N=ea(g[t+(n<<4)>>2]);O=ea(g[t+(n<<4)+4>>2]);P=ea(g[t+(n<<4)+8>>2]);Q=ea(u-N);u=ea(L-O);L=ea(M-P);M=ea(g[o>>2]);R=ea(g[f>>2]);S=ea(g[r>>2]);T=ea(ea(u*S)-ea(L*R));U=ea(ea(L*M)-ea(Q*S));V=ea(ea(Q*R)-ea(u*M));W=ea(ea(P*V)+ea(ea(N*T)+ea(O*U)));X=ea(g[h>>2]);Y=ea(g[j>>2]);Z=ea(g[s>>2]);_=ea(ea(ea(X*T)+ea(U*Y))+ea(V*Z));$=ea(g[w>>2]);aa=ea(g[x>>2]);ba=ea(g[y>>2]);if(((!(ea(ea(_-W)*ea(ea(ea(ea(T*$)+ea(U*aa))+ea(V*ba))-W))>ea(0.0))?(ca=ea($-X),$=ea(aa-Y),aa=ea(ba-Z),ba=ea(ea(ea(T*ca)+ea(U*$))+ea(V*aa)),!(ba==ea(0.0))):0)?(V=ea(ea(W-_)/ba),ba=ea(X+ea(ca*V)),X=ea(Y+ea($*V)),Y=ea(Z+ea(aa*V)),V=ea(ea(R*aa)-ea(S*$)),Z=ea(ea(S*ca)-ea(M*aa)),aa=ea(ea(M*$)-ea(R*ca)),ca=ea(ba-N),N=ea(X-O),O=ea(Y-P),P=ea(ea(ea(aa*O)+ea(ea(V*ca)+ea(Z*N)))/ea(ea(L*aa)+ea(ea(Q*V)+ea(u*Z)))),!(P>ea(1.005)|P<ea(-.00499999989))):0)?(Z=ea(ca-ea(Q*P)),Q=ea(N-ea(u*P)),u=ea(O-ea(L*P)),P=ea(ea(S*u)+ea(ea(M*Z)+ea(R*Q))),v>=P):0){R=ea(ba-Z);Z=ea(X-Q);Q=ea(Y-u);da=c[m>>2]|0;u=ea(g[b>>2]);M=ea(g[z>>2]);S=ea(ba-u);u=ea(X-M);M=ea(Y-ea(g[A>>2]));Y=ea(S*ea(g[k>>2]));X=ea(Y+ea(u*ea(g[B>>2])));Y=ea(X+ea(M*ea(g[C>>2])));X=ea(S*ea(g[D>>2]));ba=ea(X+ea(u*ea(g[E>>2])));X=ea(ba+ea(M*ea(g[F>>2])));ba=ea(S*ea(g[G>>2]));S=ea(ba+ea(u*ea(g[H>>2])));u=ea(S+ea(M*ea(g[I>>2])));g[l+(da*48|0)>>2]=Y;g[l+(da*48|0)+4>>2]=X;g[l+(da*48|0)+8>>2]=u;g[l+(da*48|0)+12>>2]=ea(0.0);da=c[m>>2]|0;g[l+(da*48|0)+16>>2]=R;g[l+(da*48|0)+20>>2]=Z;g[l+(da*48|0)+24>>2]=Q;g[l+(da*48|0)+28>>2]=ea(0.0);da=c[m>>2]|0;c[m>>2]=da+1;Q=ea(g[o>>2]);Z=ea(g[f>>2]);R=ea(g[r>>2]);g[l+(da*48|0)+32>>2]=Q;g[l+(da*48|0)+36>>2]=Z;g[l+(da*48|0)+40>>2]=R;g[l+(da*48|0)+44>>2]=P;fa=a[q>>0]|0}else fa=J;da=n+1|0;if(da>>>0<(fa&255)>>>0){ga=n;J=fa;n=da;K=ga}else break}i=p;return}function xSa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im;m=i;i=i+32|0;n=m;o=c[h>>2]|0;if(l?!(h8a(a,b,d,j,m+16|0,k)|0):0){p=0;i=m;return p|0}q=ea(g[k>>2]);r=ea(g[k+4>>2]);s=ea(-r);r=ea(-ea(g[k+8>>2]));g[n>>2]=ea(-q);g[n+4>>2]=s;g[n+8>>2]=r;g[n+12>>2]=ea(0.0);l=g8a(b,d,n)|0;n=(c[b+24>>2]|0)+(l*20|0)|0;vSa(a,b,n,d,e,f,h,j,k);if(((c[h>>2]|0)-o|0)>>>0>=2){p=1;i=m;return p|0}wSa(a,b,n,d,e,f,h,j,k);p=1;i=m;return p|0}function ySa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=0,u=Im,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=0,N=Im,O=Im,P=Im,Q=Im,R=0,T=0,U=Im,V=0,W=0,X=Im,Y=Im,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im;m=i;i=i+32|0;n=m;o=c[h>>2]|0;if(l?!(h8a(a,b,d,j,m+16|0,k)|0):0){p=0;i=m;return p|0}q=ea(g[a+128>>2]);r=ea(q+ea(g[j>>2]));q=ea(g[k>>2]);l=k+4|0;s=ea(g[l>>2]);t=k+8|0;u=ea(-q);q=ea(-s);s=ea(-ea(g[t>>2]));v=d+40|0;w=c[v>>2]|0;x=ea(g[w>>2]);y=ea(x*u);z=ea(g[w+16>>2]);A=ea(y+ea(z*q));y=ea(g[w+32>>2]);B=ea(A+ea(y*s));A=ea(g[w+4>>2]);C=ea(A*u);D=ea(g[w+20>>2]);E=ea(C+ea(D*q));C=ea(g[w+36>>2]);F=ea(E+ea(C*s));E=ea(g[w+8>>2]);G=ea(E*u);H=ea(g[w+24>>2]);I=ea(G+ea(H*q));G=ea(g[w+40>>2]);J=ea(I+ea(G*s));w=a+96|0;I=ea(g[w>>2]);K=a+100|0;L=ea(g[K>>2]);M=a+104|0;N=ea(g[M>>2]);O=ea(ea(ea(x*I)+ea(z*L))+ea(y*N));P=ea(ea(ea(A*I)+ea(D*L))+ea(C*N));Q=ea(ea(ea(E*I)+ea(H*L))+ea(G*N));R=b+16|0;T=c[R>>2]|0;a:do if(!T){U=ea(0.0);V=10}else{W=c[b+24>>2]|0;X=ea(0.0);Y=ea(1.0);Z=0;while(1){_=ea(g[W+(Z*20|0)>>2]);$=ea(g[W+(Z*20|0)+4>>2]);aa=ea(g[W+(Z*20|0)+8>>2]);ba=ea(ea(ea(B*_)+ea(F*$))+ea(J*aa));ca=ea(ea(g[W+(Z*20|0)+12>>2])+ea(ea(ea(O*_)+ea(P*$))+ea(Q*aa)));if(ea(S(ea(ba)))<ea(1.00000001e-07))if(ca>ea(0.0)){da=x;fa=z;ga=y;ha=A;ia=D;ja=C;ka=E;la=H;ma=G;na=T;break a}else{oa=X;pa=Y}else{aa=ea(-ea(ca/ba));qa=ba<ea(0.0);oa=X<aa&qa?aa:X;pa=qa|!(Y>aa)?Y:aa}Z=Z+1|0;if(oa>pa){da=x;fa=z;ga=y;ha=A;ia=D;ja=C;ka=E;la=H;ma=G;na=T;break a}if(Z>>>0>=T>>>0){U=oa;V=10;break}else{X=oa;Y=pa}}}while(0);if((V|0)==10)if(!(r>=U)){da=x;fa=z;ga=y;ha=A;ia=D;ja=C;ka=E;la=H;ma=G;na=T}else{T=c[h>>2]|0;G=ea(g[e+48>>2]);H=ea(g[e+52>>2]);E=ea(I-G);G=ea(L-H);H=ea(N-ea(g[e+56>>2]));N=ea(E*ea(g[e>>2]));L=ea(N+ea(G*ea(g[e+4>>2])));N=ea(L+ea(H*ea(g[e+8>>2])));L=ea(E*ea(g[e+16>>2]));I=ea(L+ea(G*ea(g[e+20>>2])));L=ea(I+ea(H*ea(g[e+24>>2])));I=ea(E*ea(g[e+32>>2]));E=ea(I+ea(G*ea(g[e+36>>2])));G=ea(E+ea(H*ea(g[e+40>>2])));g[f+(T*48|0)>>2]=N;g[f+(T*48|0)+4>>2]=L;g[f+(T*48|0)+8>>2]=G;g[f+(T*48|0)+12>>2]=ea(0.0);T=c[h>>2]|0;G=ea(g[w>>2]);L=ea(g[K>>2]);N=ea(ea(U*q)+L);L=ea(ea(U*s)+ea(g[M>>2]));g[f+(T*48|0)+16>>2]=ea(ea(U*u)+G);g[f+(T*48|0)+20>>2]=N;g[f+(T*48|0)+24>>2]=L;g[f+(T*48|0)+28>>2]=ea(0.0);T=c[h>>2]|0;c[h>>2]=T+1;L=ea(g[k>>2]);N=ea(g[l>>2]);G=ea(g[t>>2]);g[f+(T*48|0)+32>>2]=L;g[f+(T*48|0)+36>>2]=N;g[f+(T*48|0)+40>>2]=G;g[f+(T*48|0)+44>>2]=U;T=c[v>>2]|0;U=ea(g[T>>2]);G=ea(g[T+16>>2]);N=ea(g[T+32>>2]);L=ea(g[T+4>>2]);H=ea(g[T+20>>2]);E=ea(g[T+36>>2]);I=ea(g[T+8>>2]);C=ea(g[T+24>>2]);D=ea(g[T+40>>2]);da=U;fa=G;ga=N;ha=L;ia=H;ja=E;ka=I;la=C;ma=D;na=c[R>>2]|0}R=a+112|0;D=ea(g[R>>2]);T=a+116|0;C=ea(g[T>>2]);v=a+120|0;I=ea(g[v>>2]);E=ea(ea(ea(da*D)+ea(fa*C))+ea(ga*I));ga=ea(ea(ea(ha*D)+ea(ia*C))+ea(ja*I));ja=ea(ea(ea(ka*D)+ea(la*C))+ea(ma*I));b:do if(!na){ra=ea(0.0);V=19}else{M=c[b+24>>2]|0;ma=ea(0.0);la=ea(1.0);K=0;while(1){ka=ea(g[M+(K*20|0)>>2]);ia=ea(g[M+(K*20|0)+4>>2]);ha=ea(g[M+(K*20|0)+8>>2]);fa=ea(ea(ea(B*ka)+ea(F*ia))+ea(J*ha));da=ea(ea(g[M+(K*20|0)+12>>2])+ea(ea(ea(E*ka)+ea(ga*ia))+ea(ja*ha)));if(ea(S(ea(fa)))<ea(1.00000001e-07))if(da>ea(0.0))break b;else{sa=ma;ta=la}else{ha=ea(-ea(da/fa));w=fa<ea(0.0);sa=ma<ha&w?ha:ma;ta=w|!(la>ha)?la:ha}K=K+1|0;if(sa>ta)break b;if(K>>>0>=na>>>0){ra=sa;V=19;break}else{ma=sa;la=ta}}}while(0);if((V|0)==19?r>=ra:0){V=c[h>>2]|0;r=ea(g[e+48>>2]);ta=ea(g[e+52>>2]);sa=ea(D-r);r=ea(C-ta);ta=ea(I-ea(g[e+56>>2]));I=ea(sa*ea(g[e>>2]));C=ea(I+ea(r*ea(g[e+4>>2])));I=ea(C+ea(ta*ea(g[e+8>>2])));C=ea(sa*ea(g[e+16>>2]));D=ea(C+ea(r*ea(g[e+20>>2])));C=ea(D+ea(ta*ea(g[e+24>>2])));D=ea(sa*ea(g[e+32>>2]));sa=ea(D+ea(r*ea(g[e+36>>2])));r=ea(sa+ea(ta*ea(g[e+40>>2])));g[f+(V*48|0)>>2]=I;g[f+(V*48|0)+4>>2]=C;g[f+(V*48|0)+8>>2]=r;g[f+(V*48|0)+12>>2]=ea(0.0);V=c[h>>2]|0;r=ea(g[R>>2]);C=ea(g[T>>2]);I=ea(ea(ra*q)+C);C=ea(ea(ra*s)+ea(g[v>>2]));g[f+(V*48|0)+16>>2]=ea(ea(ra*u)+r);g[f+(V*48|0)+20>>2]=I;g[f+(V*48|0)+24>>2]=C;g[f+(V*48|0)+28>>2]=ea(0.0);V=c[h>>2]|0;c[h>>2]=V+1;C=ea(g[k>>2]);I=ea(g[l>>2]);r=ea(g[t>>2]);g[f+(V*48|0)+32>>2]=C;g[f+(V*48|0)+36>>2]=I;g[f+(V*48|0)+40>>2]=r;g[f+(V*48|0)+44>>2]=ra}if(((c[h>>2]|0)-o|0)>>>0>=2){p=1;i=m;return p|0}ra=ea(g[k>>2]);r=ea(g[l>>2]);I=ea(-r);r=ea(-ea(g[t>>2]));g[n>>2]=ea(-ra);g[n+4>>2]=I;g[n+8>>2]=r;g[n+12>>2]=ea(0.0);t=g8a(b,d,n)|0;wSa(a,b,(c[b+24>>2]|0)+(t*20|0)|0,d,e,f,h,j,k);p=1;i=m;return p|0}function zSa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;g[j>>2]=ea(0.0);if(!(h8a(a,b,d,j,l,k)|0)){m=0;i=h;return m|0}j=c[d+32>>2]|0;n=ea(g[j>>2]);o=ea(g[j+4>>2]);p=ea(g[j+8>>2]);q=ea(g[j+12>>2]);r=ea(g[k>>2]);s=ea(g[k+4>>2]);t=ea(g[k+8>>2]);u=ea(ea(q*q)+ea(-.5));v=ea(ea(ea(n*r)+ea(o*s))+ea(p*t));w=ea(ea(ea(o*v)+ea(ea(u*s)+ea(q*ea(ea(p*r)-ea(n*t)))))*ea(2.0));x=ea(ea(ea(ea(u*t)+ea(q*ea(ea(n*s)-ea(o*r))))+ea(p*v))*ea(2.0));g[f>>2]=ea(ea(ea(n*v)+ea(ea(r*u)+ea(q*ea(ea(o*t)-ea(p*s)))))*ea(2.0));g[f+4>>2]=w;g[f+8>>2]=x;g[f+12>>2]=ea(0.0);c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];m=1;i=h;return m|0}function ASa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;b=i;i=i+128|0;l=b+96|0;m=b+80|0;n=b+64|0;o=b;p=c[j>>2]|0;q=ea(g[f>>2]);r=ea(g[f+4>>2]);s=ea(g[f+8>>2]);t=ea(g[f+12>>2]);j=f+16|0;u=ea(g[j>>2]);v=ea(g[j+4>>2]);w=ea(g[j+8>>2]);x=ea(g[e>>2]);y=ea(g[e+4>>2]);z=ea(g[e+8>>2]);A=ea(g[e+12>>2]);j=e+16|0;B=ea(g[j>>2]);C=ea(g[j+4>>2]);D=ea(g[j+8>>2]);g[l>>2]=x;g[l+4>>2]=y;g[l+8>>2]=z;g[l+12>>2]=A;g[l+16>>2]=B;g[l+20>>2]=C;g[l+24>>2]=D;g[l+28>>2]=ea(0.0);E=ea(-x);F=ea(-y);G=ea(-z);H=ea(u-B);B=ea(v-C);C=ea(w-D);D=ea(ea(A*A)+ea(-.5));w=ea(ea(ea(H*E)+ea(B*F))+ea(C*G));v=ea(ea(ea(w*E)+ea(ea(D*H)+ea(A*ea(ea(C*F)-ea(B*G)))))*ea(2.0));u=ea(ea(ea(w*F)+ea(ea(D*B)+ea(A*ea(ea(H*G)-ea(C*E)))))*ea(2.0));I=ea(ea(ea(ea(D*C)+ea(A*ea(ea(B*E)-ea(H*F))))+ea(w*G))*ea(2.0));w=ea(ea(t*A)-ea(ea(ea(q*E)+ea(r*F))+ea(s*G)));H=ea(ea(ea(s*F)-ea(r*G))+ea(ea(t*E)+ea(q*A)));B=ea(ea(ea(q*G)-ea(s*E))+ea(ea(t*F)+ea(r*A)));C=ea(ea(ea(r*E)-ea(q*F))+ea(ea(s*A)+ea(t*G)));G=ea(x*ea(2.0));t=ea(A*ea(2.0));s=ea(ea(G*y)+ea(z*t));F=ea(ea(G*z)-ea(y*t));y=ea(ea(ea(x*G)+ea(A*t))+ea(-1.0));t=ea(ea(1.0)/ea(T(ea(ea(F*F)+ea(ea(s*s)+ea(y*y))))));A=ea(-ea(s*t));s=ea(-ea(F*t));g[m>>2]=ea(-ea(y*t));g[m+4>>2]=A;g[m+8>>2]=s;g[m+12>>2]=ea(0.0);s=ea(g[h>>2]);A=ea(g[d+4>>2]);t=ea(g[d+8>>2]);y=ea(g[d+12>>2]);F=!(A<=t)?t:A;G=ea((!(F<=y)?y:F)*ea(.150000006));g[n>>2]=ea(G*ea(.200000003));d=p+32|0;h=a[d>>0]|0;g[o+48>>2]=v;g[o+52>>2]=u;g[o+56>>2]=I;g[o+60>>2]=ea(0.0);F=ea(H+H);x=ea(B+B);z=ea(C+C);q=ea(B*x);E=ea(C*z);r=ea(B*F);D=ea(C*F);J=ea(w*F);K=ea(C*x);L=ea(w*x);x=ea(w*z);z=ea(ea(1.0)-ea(H*F));F=ea(ea(ea(1.0)-q)-E);M=ea(r+x);N=ea(D-L);O=ea(r-x);x=ea(z-E);E=ea(K+J);r=ea(D+L);L=ea(K-J);J=ea(z-q);g[o>>2]=F;g[o+4>>2]=M;g[o+8>>2]=N;g[o+12>>2]=ea(0.0);g[o+16>>2]=O;g[o+20>>2]=x;g[o+24>>2]=E;g[o+28>>2]=ea(0.0);g[o+32>>2]=r;g[o+36>>2]=L;g[o+40>>2]=J;g[o+44>>2]=ea(0.0);U7a(p,o,n,0);if((a[d>>0]|0)==h<<24>>24){n=h&255;q=ea(G*ea(g[544288+(n<<2)>>2]));h=p+16|0;G=ea(g[h>>2]);o=p+20|0;z=ea(g[o>>2]);j=p+24|0;K=ea(v-G);G=ea(u-z);z=ea(I-ea(g[j>>2]));D=ea(-K);P=ea(-G);Q=ea(-z);R=K>D?K:D;D=G>P?G:P;P=!(R>=D)?D:R;e=!((z>Q?z:Q)>=ea(0.0));Q=e?ea(0.0):R;if(!((P>=Q?P:Q)>q)?(q=ea(g[p+4>>2]),Q=ea(B*q),q=ea(H*ea(g[p>>2])),P=ea(C*ea(g[p+8>>2])),R=ea(Q+q),q=ea(ea(R+P)+ea(w*ea(g[p+12>>2]))),!(ea(g[544328+(n<<2)>>2])>q)):0){OSa(p,k,m,l);S=a[d>>0]|0;U=S<<24>>24!=0;i=b;return U|0}else{V=o;W=j;X=h}}else{V=p+20|0;W=p+24|0;X=p+16|0}a[d>>0]=0;g[p>>2]=H;g[p+4>>2]=B;g[p+8>>2]=C;g[p+12>>2]=w;g[X>>2]=v;g[V>>2]=u;g[W>>2]=I;g[p+28>>2]=ea(0.0);w=ea(-A);C=ea(-t);B=ea(-y);H=ea(F*A);q=ea(M*A);P=ea(N*A);R=ea(O*t);Q=ea(x*t);z=ea(E*t);D=ea(r*y);G=ea(L*y);K=ea(J*y);Y=ea(-D);Z=ea(H+R);_=ea(q+Q);$=ea(P+z);aa=ea(H-R);ba=ea(D+Z);ca=ea(Z-D);da=ea(D+aa);fa=ea(aa-D);ga=ea(D-aa);ha=ea(Y-aa);aa=ea(D-Z);ia=ea(Y-Z);Y=ea(s-v);if(Y>ba){s=ea(v+ba);g[k>>2]=A;g[k+4>>2]=t;g[k+8>>2]=y;g[k+12>>2]=ea(0.0);ba=ea(s*ea(0.0));ja=ea(ea(u+ea(_+G))-ba);ka=ea(ea(I+ea($+K))-ba);g[k+16>>2]=ea(s-s);g[k+20>>2]=ja;g[k+24>>2]=ka;g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=ea(0.0);g[k+40>>2]=ea(0.0);g[k+44>>2]=s;la=1}else la=0;if(Y>ca){s=ea(v+ca);g[k+(la*48|0)>>2]=A;g[k+(la*48|0)+4>>2]=t;g[k+(la*48|0)+8>>2]=B;g[k+(la*48|0)+12>>2]=ea(0.0);ca=ea(s*ea(0.0));ka=ea(ea(u+ea(_+ea(L*B)))-ca);_=ea(ea(I+ea($+ea(J*B)))-ca);g[k+(la*48|0)+16>>2]=ea(ea(v+ea(Z+ea(r*B)))-s);g[k+(la*48|0)+20>>2]=ka;g[k+(la*48|0)+24>>2]=_;g[k+(la*48|0)+28>>2]=ea(0.0);g[k+(la*48|0)+32>>2]=ea(1.0);g[k+(la*48|0)+36>>2]=ea(0.0);g[k+(la*48|0)+40>>2]=ea(0.0);g[k+(la*48|0)+44>>2]=s;ma=la+1|0}else ma=la;if(Y>da){s=ea(v+da);g[k+(ma*48|0)>>2]=A;g[k+(ma*48|0)+4>>2]=C;g[k+(ma*48|0)+8>>2]=y;g[k+(ma*48|0)+12>>2]=ea(0.0);da=ea(s*ea(0.0));_=ea(ea(u+ea(G+ea(q+ea(x*C))))-da);ka=ea(ea(I+ea(K+ea(P+ea(E*C))))-da);g[k+(ma*48|0)+16>>2]=ea(ea(v+ea(D+ea(H+ea(O*C))))-s);g[k+(ma*48|0)+20>>2]=_;g[k+(ma*48|0)+24>>2]=ka;g[k+(ma*48|0)+28>>2]=ea(0.0);g[k+(ma*48|0)+32>>2]=ea(1.0);g[k+(ma*48|0)+36>>2]=ea(0.0);g[k+(ma*48|0)+40>>2]=ea(0.0);g[k+(ma*48|0)+44>>2]=s;na=ma+1|0}else na=ma;if(Y>fa){s=ea(v+fa);g[k+(na*48|0)>>2]=A;g[k+(na*48|0)+4>>2]=C;g[k+(na*48|0)+8>>2]=B;g[k+(na*48|0)+12>>2]=ea(0.0);A=ea(s*ea(0.0));fa=ea(ea(u+ea(ea(q+ea(x*C))+ea(L*B)))-A);q=ea(ea(I+ea(ea(P+ea(E*C))+ea(J*B)))-A);g[k+(na*48|0)+16>>2]=ea(ea(v+ea(ea(H+ea(O*C))+ea(r*B)))-s);g[k+(na*48|0)+20>>2]=fa;g[k+(na*48|0)+24>>2]=q;g[k+(na*48|0)+28>>2]=ea(0.0);g[k+(na*48|0)+32>>2]=ea(1.0);g[k+(na*48|0)+36>>2]=ea(0.0);g[k+(na*48|0)+40>>2]=ea(0.0);g[k+(na*48|0)+44>>2]=s;oa=na+1|0}else oa=na;if(Y>ga){s=ea(v+ga);g[k+(oa*48|0)>>2]=w;g[k+(oa*48|0)+4>>2]=t;g[k+(oa*48|0)+8>>2]=y;g[k+(oa*48|0)+12>>2]=ea(0.0);ga=ea(s*ea(0.0));q=ea(ea(u+ea(ea(ea(M*w)+Q)+G))-ga);fa=ea(ea(I+ea(ea(ea(N*w)+z)+K))-ga);g[k+(oa*48|0)+16>>2]=ea(ea(v+ea(ea(ea(F*w)+R)+D))-s);g[k+(oa*48|0)+20>>2]=q;g[k+(oa*48|0)+24>>2]=fa;g[k+(oa*48|0)+28>>2]=ea(0.0);g[k+(oa*48|0)+32>>2]=ea(1.0);g[k+(oa*48|0)+36>>2]=ea(0.0);g[k+(oa*48|0)+40>>2]=ea(0.0);g[k+(oa*48|0)+44>>2]=s;pa=oa+1|0}else pa=oa;if(Y>ha){s=ea(v+ha);g[k+(pa*48|0)>>2]=w;g[k+(pa*48|0)+4>>2]=t;g[k+(pa*48|0)+8>>2]=B;g[k+(pa*48|0)+12>>2]=ea(0.0);t=ea(s*ea(0.0));ha=ea(ea(u+ea(ea(ea(M*w)+Q)+ea(L*B)))-t);Q=ea(ea(I+ea(ea(ea(N*w)+z)+ea(J*B)))-t);g[k+(pa*48|0)+16>>2]=ea(ea(v+ea(ea(ea(F*w)+R)+ea(r*B)))-s);g[k+(pa*48|0)+20>>2]=ha;g[k+(pa*48|0)+24>>2]=Q;g[k+(pa*48|0)+28>>2]=ea(0.0);g[k+(pa*48|0)+32>>2]=ea(1.0);g[k+(pa*48|0)+36>>2]=ea(0.0);g[k+(pa*48|0)+40>>2]=ea(0.0);g[k+(pa*48|0)+44>>2]=s;qa=pa+1|0}else qa=pa;if(Y>aa){s=ea(v+aa);g[k+(qa*48|0)>>2]=w;g[k+(qa*48|0)+4>>2]=C;g[k+(qa*48|0)+8>>2]=y;g[k+(qa*48|0)+12>>2]=ea(0.0);y=ea(s*ea(0.0));aa=ea(ea(u+ea(G+ea(ea(M*w)+ea(x*C))))-y);G=ea(ea(I+ea(K+ea(ea(N*w)+ea(E*C))))-y);g[k+(qa*48|0)+16>>2]=ea(ea(v+ea(D+ea(ea(F*w)+ea(O*C))))-s);g[k+(qa*48|0)+20>>2]=aa;g[k+(qa*48|0)+24>>2]=G;g[k+(qa*48|0)+28>>2]=ea(0.0);g[k+(qa*48|0)+32>>2]=ea(1.0);g[k+(qa*48|0)+36>>2]=ea(0.0);g[k+(qa*48|0)+40>>2]=ea(0.0);g[k+(qa*48|0)+44>>2]=s;ra=qa+1|0}else ra=qa;if(Y>ia){Y=ea(v+ia);g[k+(ra*48|0)>>2]=w;g[k+(ra*48|0)+4>>2]=C;g[k+(ra*48|0)+8>>2]=B;g[k+(ra*48|0)+12>>2]=ea(0.0);ia=ea(Y*ea(0.0));s=ea(ea(u+ea(ea(ea(M*w)+ea(x*C))+ea(L*B)))-ia);L=ea(ea(I+ea(ea(ea(N*w)+ea(E*C))+ea(J*B)))-ia);g[k+(ra*48|0)+16>>2]=ea(ea(v+ea(ea(ea(F*w)+ea(O*C))+ea(r*B)))-Y);g[k+(ra*48|0)+20>>2]=s;g[k+(ra*48|0)+24>>2]=L;g[k+(ra*48|0)+28>>2]=ea(0.0);g[k+(ra*48|0)+32>>2]=ea(1.0);g[k+(ra*48|0)+36>>2]=ea(0.0);g[k+(ra*48|0)+40>>2]=ea(0.0);g[k+(ra*48|0)+44>>2]=Y;sa=ra+1|0}else sa=ra;TSa(p,k,sa);OSa(p,k,m,l);S=a[d>>0]|0;U=S<<24>>24!=0;i=b;return U|0}function BSa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0;b=i;i=i+256|0;l=b+16|0;m=b+80|0;n=b+160|0;o=b;p=b+144|0;q=b+176|0;r=b+240|0;s=b+112|0;t=b+96|0;u=b+48|0;v=b+64|0;w=b+128|0;x=c[j>>2]|0;y=ea(g[f>>2]);z=ea(g[f+4>>2]);A=ea(g[f+8>>2]);B=ea(g[f+12>>2]);j=f+16|0;C=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);g[l>>2]=y;g[l+4>>2]=z;g[l+8>>2]=A;g[l+12>>2]=B;g[l+16>>2]=C;g[l+20>>2]=D;g[l+24>>2]=E;g[l+28>>2]=ea(0.0);F=ea(g[e>>2]);G=ea(g[e+4>>2]);H=ea(g[e+8>>2]);I=ea(g[e+12>>2]);j=e+16|0;J=ea(g[j>>2]);K=ea(g[j+4>>2]);L=ea(-F);M=ea(-G);N=ea(-H);O=ea(C-J);J=ea(D-K);K=ea(E-ea(g[j+8>>2]));E=ea(ea(I*I)+ea(-.5));D=ea(ea(ea(O*L)+ea(J*M))+ea(K*N));C=ea(ea(ea(D*L)+ea(ea(E*O)+ea(I*ea(ea(K*M)-ea(J*N)))))*ea(2.0));P=ea(ea(ea(D*M)+ea(ea(E*J)+ea(I*ea(ea(O*N)-ea(K*L)))))*ea(2.0));Q=ea(ea(ea(ea(E*K)+ea(I*ea(ea(J*L)-ea(O*M))))+ea(D*N))*ea(2.0));D=ea(ea(I*B)-ea(ea(ea(y*L)+ea(z*M))+ea(A*N)));O=ea(ea(ea(A*M)-ea(z*N))+ea(ea(I*y)+ea(B*L)));J=ea(ea(ea(y*N)-ea(A*L))+ea(ea(I*z)+ea(B*M)));K=ea(ea(ea(z*L)-ea(y*M))+ea(ea(I*A)+ea(B*N)));N=ea(F*ea(2.0));B=ea(I*ea(2.0));A=ea(ea(N*G)+ea(H*B));M=ea(ea(N*H)-ea(G*B));G=ea(ea(ea(F*N)+ea(I*B))+ea(-1.0));B=ea(ea(1.0)/ea(T(ea(ea(M*M)+ea(ea(A*A)+ea(G*G))))));I=ea(-ea(A*B));A=ea(-ea(M*B));g[m>>2]=ea(-ea(G*B));g[m+4>>2]=I;g[m+8>>2]=A;g[m+12>>2]=ea(0.0);A=ea(g[h>>2]);I=ea(g[d+4>>2]);g[n>>2]=I;B=ea(g[d+8>>2]);G=ea(O*ea(2.0));M=ea(D*ea(2.0));N=ea(B*ea(ea(ea(D*M)+ea(O*G))+ea(-1.0)));F=ea(B*ea(ea(M*K)+ea(J*G)));H=ea(B*ea(ea(K*G)-ea(M*J)));M=ea(C+N);G=ea(P+F);B=ea(Q+H);y=ea(C-N);N=ea(P-F);F=ea(Q-H);H=ea(A+I);g[o>>2]=ea(I*ea(.00100000005));g[p>>2]=ea(I*ea(.0500000007));d=x+32|0;h=a[d>>0]|0;g[q+48>>2]=C;g[q+52>>2]=P;g[q+56>>2]=Q;g[q+60>>2]=ea(0.0);I=ea(O+O);A=ea(J+J);L=ea(K+K);z=ea(J*A);E=ea(K*L);R=ea(J*I);S=ea(K*I);U=ea(D*I);V=ea(K*A);W=ea(D*A);A=ea(D*L);L=ea(ea(1.0)-ea(O*I));I=ea(R+A);X=ea(S-W);Y=ea(R-A);A=ea(L-E);R=ea(V+U);Z=ea(S+W);W=ea(V-U);U=ea(L-z);g[q>>2]=ea(ea(ea(1.0)-z)-E);g[q+4>>2]=I;g[q+8>>2]=X;g[q+12>>2]=ea(0.0);g[q+16>>2]=Y;g[q+20>>2]=A;g[q+24>>2]=R;g[q+28>>2]=ea(0.0);g[q+32>>2]=Z;g[q+36>>2]=W;g[q+40>>2]=U;g[q+44>>2]=ea(0.0);U7a(x,q,p,0);if((a[d>>0]|0)==h<<24>>24){U=ea(ea(g[n>>2])*ea(.0199999996));h=x+16|0;W=ea(g[h>>2]);p=x+20|0;Z=ea(g[p>>2]);q=x+24|0;R=ea(C-W);W=ea(P-Z);Z=ea(Q-ea(g[q>>2]));A=ea(-R);Y=ea(-W);X=ea(-Z);I=R>A?R:A;A=W>Y?W:Y;Y=!(I>=A)?A:I;j=!((Z>X?Z:X)>=ea(0.0));X=j?ea(0.0):I;if(!((Y>=X?Y:X)>U)?(U=ea(g[x+4>>2]),X=ea(J*U),U=ea(O*ea(g[x>>2])),Y=ea(K*ea(g[x+8>>2])),I=ea(X+U),!(ea(ea(I+Y)+ea(D*ea(g[x+12>>2])))<ea(.999800026))):0){QSa(x,k,m,l,n);_=a[d>>0]|0;$=_<<24>>24!=0;i=b;return $|0}else{aa=p;ba=q;ca=h}}else{aa=x+20|0;ba=x+24|0;ca=x+16|0}a[d>>0]=0;g[x>>2]=O;g[x+4>>2]=J;g[x+8>>2]=K;g[x+12>>2]=D;g[ca>>2]=C;g[aa>>2]=P;g[ba>>2]=Q;g[x+28>>2]=ea(0.0);if(H>M){Y=ea(M-C);I=ea(G-P);U=ea(B-Q);X=ea(ea(D*D)+ea(-.5));Z=ea(ea(K*U)+ea(ea(J*I)+ea(O*Y)));A=ea(ea(ea(J*Z)+ea(ea(X*I)-ea(D*ea(ea(K*Y)-ea(O*U)))))*ea(2.0));W=ea(ea(ea(ea(X*U)-ea(D*ea(ea(O*I)-ea(J*Y))))+ea(K*Z))*ea(2.0));g[r>>2]=ea(ea(ea(ea(X*Y)-ea(D*ea(ea(J*U)-ea(K*I))))+ea(O*Z))*ea(2.0));g[r+4>>2]=A;g[r+8>>2]=W;g[r+12>>2]=ea(0.0);W=ea(M*ea(0.0));A=ea(G-W);G=ea(B-W);g[s>>2]=ea(M-M);g[s+4>>2]=A;g[s+8>>2]=G;g[s+12>>2]=ea(0.0);g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=M;XSa(x,r,s,t,o)|0}if(H>y){H=ea(y-C);C=ea(N-P);P=ea(F-Q);Q=ea(ea(D*D)+ea(-.5));M=ea(ea(K*P)+ea(ea(J*C)+ea(O*H)));G=ea(ea(ea(J*M)+ea(ea(Q*C)-ea(D*ea(ea(K*H)-ea(O*P)))))*ea(2.0));A=ea(ea(ea(ea(Q*P)-ea(D*ea(ea(O*C)-ea(J*H))))+ea(K*M))*ea(2.0));g[u>>2]=ea(ea(ea(ea(Q*H)-ea(D*ea(ea(J*P)-ea(K*C))))+ea(O*M))*ea(2.0));g[u+4>>2]=G;g[u+8>>2]=A;g[u+12>>2]=ea(0.0);A=ea(y*ea(0.0));G=ea(N-A);N=ea(F-A);g[v>>2]=ea(y-y);g[v+4>>2]=G;g[v+8>>2]=N;g[v+12>>2]=ea(0.0);g[w>>2]=ea(1.0);g[w+4>>2]=ea(0.0);g[w+8>>2]=ea(0.0);g[w+12>>2]=y;XSa(x,u,v,w,o)|0}QSa(x,k,m,l,n);_=a[d>>0]|0;$=_<<24>>24!=0;i=b;return $|0}function CSa(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0;b=i;i=i+128|0;m=b+96|0;n=b+80|0;o=b+64|0;p=b;q=c[k>>2]|0;r=ea(g[h>>2]);s=ea(g[h+4>>2]);t=ea(g[h+8>>2]);u=ea(g[h+12>>2]);k=h+16|0;v=ea(g[k>>2]);w=ea(g[k+4>>2]);x=ea(g[k+8>>2]);y=ea(g[f>>2]);z=ea(g[f+4>>2]);A=ea(g[f+8>>2]);B=ea(g[f+12>>2]);k=f+16|0;C=ea(g[k>>2]);D=ea(g[k+4>>2]);E=ea(g[k+8>>2]);g[m>>2]=y;g[m+4>>2]=z;g[m+8>>2]=A;g[m+12>>2]=B;g[m+16>>2]=C;g[m+20>>2]=D;g[m+24>>2]=E;g[m+28>>2]=ea(0.0);F=ea(-y);G=ea(-z);H=ea(-A);I=ea(v-C);C=ea(w-D);D=ea(x-E);E=ea(ea(B*B)+ea(-.5));x=ea(ea(ea(I*F)+ea(C*G))+ea(D*H));w=ea(ea(ea(x*F)+ea(ea(E*I)+ea(B*ea(ea(D*G)-ea(C*H)))))*ea(2.0));v=ea(ea(ea(x*G)+ea(ea(E*C)+ea(B*ea(ea(I*H)-ea(D*F)))))*ea(2.0));J=ea(ea(ea(ea(E*D)+ea(B*ea(ea(C*F)-ea(I*G))))+ea(x*H))*ea(2.0));x=ea(ea(u*B)-ea(ea(ea(r*F)+ea(s*G))+ea(t*H)));I=ea(ea(ea(t*G)-ea(s*H))+ea(ea(u*F)+ea(r*B)));C=ea(ea(ea(r*H)-ea(t*F))+ea(ea(u*G)+ea(s*B)));D=ea(ea(ea(s*F)-ea(r*G))+ea(ea(t*B)+ea(u*H)));H=ea(g[e+4>>2]);u=ea(g[e+8>>2]);t=ea(g[e+12>>2]);k=c[e+36>>2]|0;G=ea(g[k+52>>2]);r=ea(g[k+56>>2]);F=ea(H*G);G=ea(u*r);r=ea(t*ea(g[k+60>>2]));s=!(F<=G)?G:F;F=ea((!(s<=r)?r:s)*ea(.25));s=ea(y*ea(2.0));r=ea(B*ea(2.0));G=ea(ea(s*z)+ea(A*r));E=ea(ea(s*A)-ea(z*r));z=ea(ea(ea(y*s)+ea(B*r))+ea(-1.0));r=ea(ea(1.0)/ea(T(ea(ea(E*E)+ea(ea(G*G)+ea(z*z))))));B=ea(-ea(G*r));G=ea(-ea(E*r));g[n>>2]=ea(-ea(z*r));g[n+4>>2]=B;g[n+8>>2]=G;g[n+12>>2]=ea(0.0);G=ea(g[j>>2]);g[o>>2]=ea(F*ea(.200000003));j=q+32|0;f=a[j>>0]|0;g[p+48>>2]=w;g[p+52>>2]=v;g[p+56>>2]=J;g[p+60>>2]=ea(0.0);B=ea(I+I);r=ea(C+C);z=ea(D+D);E=ea(C*r);s=ea(D*z);y=ea(C*B);A=ea(D*B);K=ea(x*B);L=ea(D*r);M=ea(x*r);r=ea(x*z);z=ea(ea(1.0)-ea(I*B));B=ea(ea(ea(1.0)-E)-s);N=ea(y+r);O=ea(A-M);P=ea(y-r);r=ea(z-s);s=ea(L+K);y=ea(A+M);M=ea(L-K);K=ea(z-E);g[p>>2]=B;g[p+4>>2]=N;g[p+8>>2]=O;g[p+12>>2]=ea(0.0);g[p+16>>2]=P;g[p+20>>2]=r;g[p+24>>2]=s;g[p+28>>2]=ea(0.0);g[p+32>>2]=y;g[p+36>>2]=M;g[p+40>>2]=K;g[p+44>>2]=ea(0.0);U7a(q,p,o,0);if((a[j>>0]|0)==f<<24>>24){o=f&255;E=ea(F*ea(g[544288+(o<<2)>>2]));f=q+16|0;F=ea(g[f>>2]);p=q+20|0;z=ea(g[p>>2]);h=q+24|0;L=ea(w-F);F=ea(v-z);z=ea(J-ea(g[h>>2]));A=ea(-L);Q=ea(-F);R=ea(-z);S=L>A?L:A;A=F>Q?F:Q;Q=!(S>=A)?A:S;U=!((z>R?z:R)>=ea(0.0));R=U?ea(0.0):S;if(!((Q>=R?Q:R)>E)?(E=ea(g[q+4>>2]),R=ea(C*E),E=ea(I*ea(g[q>>2])),Q=ea(D*ea(g[q+8>>2])),S=ea(R+E),E=ea(ea(S+Q)+ea(x*ea(g[q+12>>2]))),!(ea(g[544328+(o<<2)>>2])>E)):0){OSa(q,l,n,m);V=a[j>>0]|0;W=V<<24>>24!=0;i=b;return W|0}else{X=p;Y=h;Z=f}}else{X=q+20|0;Y=q+24|0;Z=q+16|0}E=ea(g[e+16>>2]);Q=ea(g[e+20>>2]);S=ea(g[e+24>>2]);R=ea(g[e+28>>2]);z=ea(E+E);A=ea(Q+Q);F=ea(S+S);L=ea(Q*A);_=ea(S*F);$=ea(z*Q);Q=ea(z*S);aa=ea(z*R);ba=ea(A*S);S=ea(A*R);A=ea(F*R);R=ea(ea(1.0)-ea(E*z));z=ea(ea(ea(1.0)-L)-_);E=ea($+A);F=ea(Q-S);ca=ea($-A);A=ea(R-_);_=ea(ba+aa);$=ea(Q+S);S=ea(ba-aa);aa=ea(R-L);L=ea(H*z);R=ea(H*ca);ba=ea(H*$);H=ea(u*E);Q=ea(u*A);da=ea(u*S);u=ea(t*F);fa=ea(t*_);ga=ea(t*aa);t=ea(ea(F*u)+ea(ea(z*L)+ea(E*H)));ha=ea(ea(F*fa)+ea(ea(z*R)+ea(E*Q)));ia=ea(ea(F*ga)+ea(ea(z*ba)+ea(E*da)));E=ea(ea(_*u)+ea(ea(ca*L)+ea(A*H)));z=ea(ea(_*fa)+ea(ea(ca*R)+ea(A*Q)));F=ea(ea(_*ga)+ea(ea(ca*ba)+ea(A*da)));A=ea(ea(aa*u)+ea(ea($*L)+ea(S*H)));H=ea(ea(aa*fa)+ea(ea($*R)+ea(S*Q)));Q=ea(ea(aa*ga)+ea(ea($*ba)+ea(S*da)));a[j>>0]=0;g[q>>2]=I;g[q+4>>2]=C;g[q+8>>2]=D;g[q+12>>2]=x;g[Z>>2]=w;g[X>>2]=v;g[Y>>2]=J;g[q+28>>2]=ea(0.0);Y=(c[k+40>>2]|0)+((d[k+39>>0]|0)*20|0)|0;X=a[k+38>>0]|0;x=ea(ea(y*ia)+ea(ea(B*t)+ea(P*ha)));D=ea(ea(M*ia)+ea(ea(N*t)+ea(r*ha)));C=ea(ea(K*ia)+ea(ea(O*t)+ea(s*ha)));I=ea(ea(y*F)+ea(ea(B*E)+ea(P*z)));da=ea(ea(M*F)+ea(ea(N*E)+ea(r*z)));S=ea(ea(K*F)+ea(ea(O*E)+ea(s*z)));ba=ea(ea(y*Q)+ea(ea(B*A)+ea(P*H)));P=ea(ea(M*Q)+ea(ea(N*A)+ea(r*H)));r=ea(ea(K*Q)+ea(ea(O*A)+ea(s*H)));if(!(X<<24>>24))ja=0;else{k=0;Z=0;while(1){s=ea(g[Y+(k*12|0)>>2]);O=ea(g[Y+(k*12|0)+4>>2]);K=ea(g[Y+(k*12|0)+8>>2]);N=ea(w+ea(ea(ea(x*s)+ea(I*O))+ea(ba*K)));if(G>N){M=ea(J+ea(ea(ea(C*s)+ea(S*O))+ea(r*K)));B=ea(v+ea(ea(ea(D*s)+ea(da*O))+ea(P*K)));y=ea(ea(ea(ha*s)+ea(z*O))+ea(H*K));$=ea(ea(ea(ia*s)+ea(F*O))+ea(Q*K));g[l+(Z*48|0)>>2]=ea(ea(ea(t*s)+ea(E*O))+ea(A*K));g[l+(Z*48|0)+4>>2]=y;g[l+(Z*48|0)+8>>2]=$;g[l+(Z*48|0)+12>>2]=ea(0.0);$=ea(N*ea(0.0));y=ea(B-$);B=ea(M-$);g[l+(Z*48|0)+16>>2]=ea(N-N);g[l+(Z*48|0)+20>>2]=y;g[l+(Z*48|0)+24>>2]=B;g[l+(Z*48|0)+28>>2]=ea(0.0);g[l+(Z*48|0)+32>>2]=ea(1.0);g[l+(Z*48|0)+36>>2]=ea(0.0);g[l+(Z*48|0)+40>>2]=ea(0.0);g[l+(Z*48|0)+44>>2]=N;ka=Z+1|0}else ka=Z;k=k+1|0;if((k&255)<<24>>24==X<<24>>24){ja=ka;break}else Z=ka}}RSa(q,l,ja);OSa(q,l,n,m);V=a[j>>0]|0;W=V<<24>>24!=0;i=b;return W|0}function DSa(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=0,J=Im,K=0,L=Im,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;m=i;i=i+656|0;n=m+608|0;o=m+464|0;p=m+192|0;q=m+560|0;r=m+620|0;s=m+480|0;t=m+496|0;u=m+224|0;v=m+208|0;w=m+160|0;x=m+176|0;y=m+632|0;z=m+144|0;A=m+240|0;B=m+256|0;C=m;D=m+592|0;E=m+576|0;F=m+644|0;G=c[k>>2]|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;k=e+4|0;H=ea(g[k>>2]);I=e+8|0;J=ea(g[I>>2]);K=e+12|0;L=ea(g[K>>2]);g[q>>2]=H;M=q+4|0;g[M>>2]=J;N=q+8|0;g[N>>2]=L;g[q+12>>2]=ea(0.0);L=ea(g[b+4>>2]);g[s>>2]=ea(g[j>>2]);j=c[e+36>>2]|0;J=ea(g[f>>2]);H=ea(g[f+4>>2]);O=ea(g[f+8>>2]);P=ea(g[f+12>>2]);b=f+16|0;Q=ea(g[b>>2]);R=ea(g[b+4>>2]);S=ea(g[b+8>>2]);T=ea(g[h>>2]);U=ea(g[h+4>>2]);V=ea(g[h+8>>2]);W=ea(g[h+12>>2]);b=h+16|0;X=ea(g[b>>2]);Y=ea(g[b+4>>2]);Z=ea(-T);_=ea(-U);$=ea(-V);aa=ea(Q-X);X=ea(R-Y);Y=ea(S-ea(g[b+8>>2]));ba=ea(ea(W*W)+ea(-.5));ca=ea(ea(ea(aa*Z)+ea(X*_))+ea(Y*$));da=ea(ea(ea(ca*Z)+ea(ea(ba*aa)+ea(W*ea(ea(Y*_)-ea(X*$)))))*ea(2.0));fa=ea(ea(ea(ca*_)+ea(ea(ba*X)+ea(W*ea(ea(aa*$)-ea(Y*Z)))))*ea(2.0));ga=ea(ea(ea(ea(ba*Y)+ea(W*ea(ea(X*Z)-ea(aa*_))))+ea(ca*$))*ea(2.0));ca=ea(ea(P*W)-ea(ea(ea(J*Z)+ea(H*_))+ea(O*$)));aa=ea(ea(ea(O*_)-ea(H*$))+ea(ea(P*Z)+ea(J*W)));X=ea(ea(ea(J*$)-ea(O*Z))+ea(ea(P*_)+ea(H*W)));Y=ea(ea(ea(H*Z)-ea(J*_))+ea(ea(O*W)+ea(P*$)));b=t+48|0;g[b>>2]=da;h=t+52|0;g[h>>2]=fa;f=t+56|0;g[f>>2]=ga;g[t+60>>2]=ea(0.0);$=ea(aa+aa);P=ea(X+X);O=ea(Y+Y);_=ea(X*P);J=ea(Y*O);Z=ea(X*$);H=ea(Y*$);ha=ea(ca*$);ia=ea(Y*P);ja=ea(ca*P);P=ea(ca*O);O=ea(ea(1.0)-ea(aa*$));$=ea(Z+P);ka=ea(H-ja);la=ea(Z-P);P=ea(O-J);Z=ea(ia+ha);ma=ea(H+ja);ja=ea(ia-ha);ha=ea(O-_);g[t>>2]=ea(ea(ea(1.0)-_)-J);g[t+4>>2]=$;g[t+8>>2]=ka;g[t+12>>2]=ea(0.0);g[t+16>>2]=la;g[t+20>>2]=P;g[t+24>>2]=Z;g[t+28>>2]=ea(0.0);g[t+32>>2]=ma;g[t+36>>2]=ja;g[t+40>>2]=ha;g[t+44>>2]=ea(0.0);ha=ea(g[j+52>>2]);ja=ea(g[j+56>>2]);ma=ea(g[j+60>>2]);Z=ea(g[q>>2]);P=ea(g[M>>2]);la=ea(ha*Z);Z=ea(ja*P);P=ea(ma*ea(g[N>>2]));ma=!(la<=Z)?Z:la;la=ea((!(ma<=P)?P:ma)*ea(.25));N=G+32|0;M=a[N>>0]|0;ma=la>L?L:la;g[u>>2]=ea(ma*ea(.0500000007));U7a(G,t,u,0);u=(a[N>>0]|0)==M<<24>>24;c[v+0>>2]=c[p+0>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];c[v+12>>2]=c[p+12>>2];c[w+0>>2]=c[p+0>>2];c[w+4>>2]=c[p+4>>2];c[w+8>>2]=c[p+8>>2];c[w+12>>2]=c[p+12>>2];c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];g[z>>2]=ea(0.0);na=z+4|0;c[na+0>>2]=c[y+0>>2];c[na+4>>2]=c[y+4>>2];c[na+8>>2]=c[y+8>>2];if(u){u=d[N>>0]|0;la=ea(ma*ea(g[544312+(u<<2)>>2]));oa=G+16|0;ma=ea(g[oa>>2]);pa=G+20|0;P=ea(g[pa>>2]);qa=G+24|0;Z=ea(da-ma);ma=ea(fa-P);P=ea(ga-ea(g[qa>>2]));ja=ea(-Z);ha=ea(-ma);ka=ea(-P);$=Z>ja?Z:ja;ja=ma>ha?ma:ha;ha=!($>=ja)?ja:$;ra=!((P>ka?P:ka)>=ea(0.0));ka=ra?ea(0.0):$;if(!((ha>=ka?ha:ka)>la)?(la=ea(g[G+4>>2]),ka=ea(X*la),la=ea(aa*ea(g[G>>2])),ha=ea(Y*ea(g[G+8>>2])),$=ea(ka+la),la=ea(ea($+ha)+ea(ca*ea(g[G+12>>2]))),!(ea(g[544352+(u<<2)>>2])>la)):0){sa=M<<24>>24!=0?2:0;ta=15}else{ua=pa;va=qa;wa=oa;ta=5}}else{ua=G+20|0;va=G+24|0;wa=G+16|0;ta=5}do if((ta|0)==5){g[G>>2]=aa;g[G+4>>2]=X;g[G+8>>2]=Y;g[G+12>>2]=ca;g[wa>>2]=da;g[ua>>2]=fa;g[va>>2]=ga;g[G+28>>2]=ea(0.0);la=ea(g[e+16>>2]);ha=ea(g[e+20>>2]);$=ea(g[e+24>>2]);ka=ea(g[e+28>>2]);g[A>>2]=la;g[A+4>>2]=ha;g[A+8>>2]=$;g[A+12>>2]=ka;z1a(B,j,p,q,A);g[B+16>>2]=ea(0.0);oa=B+20|0;c[oa+0>>2]=c[y+0>>2];c[oa+4>>2]=c[y+4>>2];c[oa+8>>2]=c[y+8>>2];oa=t+48|0;qa=C+64|0;c[C+80>>2]=4;pa=C+20|0;M=C+36|0;g[C+48>>2]=ea(0.0);u=C+52|0;c[u+0>>2]=c[n+0>>2];c[u+4>>2]=c[n+4>>2];c[u+8>>2]=c[n+8>>2];u=C+96|0;ra=C+112|0;c[C+0>>2]=c[oa+0>>2];c[C+4>>2]=c[oa+4>>2];c[C+8>>2]=c[oa+8>>2];c[C+12>>2]=c[oa+12>>2];g[C+128>>2]=L;xa=C+132|0;c[xa+0>>2]=c[r+0>>2];c[xa+4>>2]=c[r+4>>2];c[xa+8>>2]=c[r+8>>2];c[u+0>>2]=c[oa+0>>2];c[u+4>>2]=c[oa+4>>2];c[u+8>>2]=c[oa+8>>2];c[u+12>>2]=c[oa+12>>2];c[ra+0>>2]=c[oa+0>>2];c[ra+4>>2]=c[oa+4>>2];c[ra+8>>2]=c[oa+8>>2];c[ra+12>>2]=c[oa+12>>2];g[C+16>>2]=L;c[pa+0>>2]=c[r+0>>2];c[pa+4>>2]=c[r+4>>2];c[pa+8>>2]=c[r+8>>2];g[C+32>>2]=L;c[M+0>>2]=c[r+0>>2];c[M+4>>2]=c[r+4>>2];c[M+8>>2]=c[r+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[qa+0>>2]=c[o+0>>2];c[qa+4>>2]=c[o+4>>2];c[qa+8>>2]=c[o+8>>2];c[qa+12>>2]=c[o+12>>2];if((ea(g[k>>2])==ea(1.0)?ea(g[I>>2])==ea(1.0):0)?ea(g[K>>2])==ea(1.0):0)ya=c7a(C,B,s,v,w,x,z,G+34|0,G+38|0,G+33|0,1)|0;else ya=a7a(C,B,s,v,w,x,z,G+34|0,G+38|0,G+33|0,1)|0;if((ya|0)==6){a[D+4>>0]=0;c[D>>2]=541208;c[D+8>>2]=C;c[D+12>>2]=B;qa=cPa(C,B,D,G+34|0,G+38|0,a[G+33>>0]|0,v,w,x,z,1)|0;sa=(qa+-5|0)>>>0<2?1:qa;ta=15;break}else if((ya|0)!=1){sa=ya;ta=15;break}qa=c[B+192>>2]|0;ka=ea(g[qa+24>>2]);$=ea(g[qa+28>>2]);ha=ea(g[qa+32>>2]);la=ea(ka*ea(g[B+96>>2]));P=ea(la+ea($*ea(g[B+112>>2])));la=ea(P+ea(ha*ea(g[B+128>>2])));P=ea(ka*ea(g[B+100>>2]));ja=ea(P+ea($*ea(g[B+116>>2])));P=ea(ja+ea(ha*ea(g[B+132>>2])));ja=ea(ka*ea(g[B+104>>2]));ka=ea(ja+ea($*ea(g[B+120>>2])));$=ea(ka+ea(ha*ea(g[B+136>>2])));ha=ea(g[b>>2]);ka=ea(g[h>>2]);ja=ea(ha-la);la=ea(ka-P);P=ea(ea(g[f>>2])-$);$=ea(g[x>>2]);qa=x+4|0;ka=ea(g[qa>>2]);M=x+8|0;ha=ea(g[M>>2]);if(ea(ea(ea(ja*$)+ea(la*ka))+ea(P*ha))<ea(0.0)){P=ea(-ka);ka=ea(-ha);g[x>>2]=ea(-$);g[qa>>2]=P;g[M>>2]=ka;g[x+12>>2]=ea(0.0)}za=c[G+44>>2]|0}while(0);if((ta|0)==15){if(!sa){Aa=0;i=m;return Aa|0}ta=c[G+44>>2]|0;if((sa|0)==1)za=ta;else{if(!(a[N>>0]|0)){Aa=1;i=m;return Aa|0}ga=ea(g[ta+32>>2]);fa=ea(g[ta+36>>2]);da=ea(g[ta+40>>2]);ca=ea(ea(ea(T*ga)+ea(U*fa))+ea(V*da));Y=ea(ea(ea(T*ca)+ea(ea(ba*ga)+ea(W*ea(ea(U*da)-ea(V*fa)))))*ea(2.0));X=ea(ea(ea(U*ca)+ea(ea(ba*fa)+ea(W*ea(ea(V*ga)-ea(T*da)))))*ea(2.0));aa=ea(ea(ea(ea(ba*da)+ea(W*ea(ea(T*fa)-ea(U*ga))))+ea(V*ca))*ea(2.0));g[x>>2]=Y;g[x+4>>2]=X;g[x+8>>2]=aa;g[x+12>>2]=ea(0.0);ca=ea(Q-ea(L*Y));ga=ea(R-ea(L*X));fa=ea(S-ea(L*aa));da=ea(ea(g[ta+44>>2])-L);g[z>>2]=da;c[na+0>>2]=c[F+0>>2];c[na+4>>2]=c[F+4>>2];c[na+8>>2]=c[F+8>>2];F=l+4096|0;ta=c[F>>2]|0;c[F>>2]=ta+1;F=l+(ta<<6)|0;g[F>>2]=Y;g[F+4>>2]=X;g[F+8>>2]=aa;g[F+12>>2]=ea(0.0);F=l+(ta<<6)+16|0;g[F>>2]=ca;g[F+4>>2]=ga;g[F+8>>2]=fa;g[F+12>>2]=ea(0.0);g[l+(ta<<6)+12>>2]=da;c[l+(ta<<6)+48>>2]=-1;c[l+(ta<<6)+52>>2]=-1;Aa=1;i=m;return Aa|0}};c[za+0>>2]=c[p+0>>2];c[za+4>>2]=c[p+4>>2];c[za+8>>2]=c[p+8>>2];c[za+12>>2]=c[p+12>>2];p=za+16|0;c[p+0>>2]=c[w+0>>2];c[p+4>>2]=c[w+4>>2];c[p+8>>2]=c[w+8>>2];c[p+12>>2]=c[w+12>>2];da=ea(g[x>>2]);w=x+4|0;fa=ea(g[w>>2]);p=x+8|0;ga=ea(g[p>>2]);ca=ea(g[z>>2]);g[za+32>>2]=da;g[za+36>>2]=fa;g[za+40>>2]=ga;g[za+44>>2]=ca;a[N>>0]=1;N=l+4096|0;za=c[N>>2]|0;c[N>>2]=za+1;ca=ea(g[x>>2]);ga=ea(g[w>>2]);fa=ea(g[p>>2]);da=ea(ea(ea(T*ca)+ea(U*ga))+ea(V*fa));aa=ea(ea(ea(T*da)+ea(ea(ba*ca)+ea(W*ea(ea(U*fa)-ea(V*ga)))))*ea(2.0));X=ea(ea(ea(U*da)+ea(ea(ba*ga)+ea(W*ea(ea(V*ca)-ea(T*fa)))))*ea(2.0));Y=ea(ea(ea(ea(ba*fa)+ea(W*ea(ea(T*ga)-ea(U*ca))))+ea(V*da))*ea(2.0));g[x>>2]=aa;g[w>>2]=X;g[p>>2]=Y;g[x+12>>2]=ea(0.0);da=ea(Q-ea(L*aa));Q=ea(R-ea(L*X));R=ea(S-ea(L*Y));S=ea(ea(g[z>>2])-L);g[z>>2]=S;c[na+0>>2]=c[E+0>>2];c[na+4>>2]=c[E+4>>2];c[na+8>>2]=c[E+8>>2];E=l+(za<<6)|0;g[E>>2]=aa;g[E+4>>2]=X;g[E+8>>2]=Y;g[E+12>>2]=ea(0.0);E=l+(za<<6)+16|0;g[E>>2]=da;g[E+4>>2]=Q;g[E+8>>2]=R;g[E+12>>2]=ea(0.0);g[l+(za<<6)+12>>2]=S;c[l+(za<<6)+48>>2]=-1;c[l+(za<<6)+52>>2]=-1;Aa=1;i=m;return Aa|0}function ESa(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=Im,Q=Im,R=Im,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im;m=i;i=i+3680|0;n=m+3472|0;o=m+128|0;p=m+64|0;q=m+80|0;r=m+3440|0;s=m;t=m+112|0;u=m+160|0;v=m+144|0;w=m+3608|0;x=m+176|0;y=m+3592|0;z=m+3580|0;A=m+3568|0;B=m+3508|0;C=c[k>>2]&-16;D=ea(g[f>>2]);E=ea(g[f+4>>2]);F=ea(g[f+8>>2]);G=ea(g[f+12>>2]);k=f+16|0;H=ea(g[k>>2]);I=ea(g[k+4>>2]);J=ea(g[k+8>>2]);K=ea(g[h>>2]);L=ea(g[h+4>>2]);M=ea(g[h+8>>2]);N=ea(g[h+12>>2]);O=h+16|0;P=ea(g[O>>2]);Q=ea(g[O+4>>2]);R=ea(g[O+8>>2]);S=b+4|0;g[o>>2]=ea(g[S>>2]);g[p>>2]=ea(g[j>>2]);g[q>>2]=D;g[q+4>>2]=E;g[q+8>>2]=F;g[q+12>>2]=G;g[q+16>>2]=H;g[q+20>>2]=I;g[q+24>>2]=J;g[q+28>>2]=ea(0.0);g[r>>2]=K;g[r+4>>2]=L;g[r+8>>2]=M;g[r+12>>2]=N;g[r+16>>2]=P;g[r+20>>2]=Q;g[r+24>>2]=R;g[r+28>>2]=ea(0.0);T=ea(-K);K=ea(-L);L=ea(-M);M=ea(H-P);P=ea(I-Q);Q=ea(J-R);R=ea(ea(N*N)+ea(-.5));J=ea(ea(ea(M*T)+ea(P*K))+ea(Q*L));I=ea(ea(ea(J*T)+ea(ea(R*M)+ea(N*ea(ea(Q*K)-ea(P*L)))))*ea(2.0));H=ea(ea(ea(J*K)+ea(ea(R*P)+ea(N*ea(ea(M*L)-ea(Q*T)))))*ea(2.0));U=ea(ea(ea(ea(R*Q)+ea(N*ea(ea(P*T)-ea(M*K))))+ea(J*L))*ea(2.0));J=ea(ea(N*G)-ea(ea(ea(D*T)+ea(E*K))+ea(F*L)));M=ea(ea(ea(F*K)-ea(E*L))+ea(ea(N*D)+ea(G*T)));P=ea(ea(ea(D*L)-ea(F*T))+ea(ea(N*E)+ea(G*K)));Q=ea(ea(ea(E*T)-ea(D*K))+ea(ea(N*F)+ea(G*L)));g[s+48>>2]=I;g[s+52>>2]=H;g[s+56>>2]=U;g[s+60>>2]=ea(0.0);L=ea(M+M);G=ea(P+P);F=ea(Q+Q);N=ea(P*G);K=ea(Q*F);D=ea(P*L);T=ea(Q*L);E=ea(J*L);R=ea(Q*G);V=ea(J*G);G=ea(J*F);F=ea(ea(1.0)-ea(M*L));L=ea(D+G);W=ea(T-V);X=ea(D-G);G=ea(F-K);D=ea(R+E);Y=ea(T+V);V=ea(R-E);E=ea(F-N);g[s>>2]=ea(ea(ea(1.0)-N)-K);g[s+4>>2]=L;g[s+8>>2]=W;g[s+12>>2]=ea(0.0);g[s+16>>2]=X;g[s+20>>2]=G;g[s+24>>2]=D;g[s+28>>2]=ea(0.0);g[s+32>>2]=Y;g[s+36>>2]=V;g[s+40>>2]=E;g[s+44>>2]=ea(0.0);E=ea(g[o>>2]);g[t>>2]=ea(E*ea(.00100000005));g[u>>2]=ea(E*ea(.0500000007));b=C+53|0;Z=a[b>>0]|0;g[v>>2]=ea(E+ea(g[p>>2]));_=C+52|0;$=a[_>>0]|0;if($<<24>>24){aa=$&255;$=0;while(1){ba=C+$+48|0;ca=a[ba>>0]|0;da=ca&255;aTa(n,C+(da*400|0)+64|0,s,u,v);if(!(c[C+(da*400|0)+448>>2]|0)){fa=(a[_>>0]|0)+-1<<24>>24;a[_>>0]=fa;ga=C+(fa&255)+48|0;fa=a[ga>>0]|0;a[ga>>0]=ca;a[ba>>0]=fa;ha=$+-1|0}else{g[C+(da<<2)+32>>2]=ea(g[n>>2]);ha=$}da=ha+1|0;fa=d[_>>0]|0;if(da>>>0<fa>>>0){aa=fa;$=da}else break}}if(((a[b>>0]|0)==Z<<24>>24?(E=ea(ea(g[o>>2])*ea(.0199999996)),V=ea(g[C+16>>2]),Y=ea(g[C+20>>2]),D=ea(I-V),V=ea(H-Y),Y=ea(U-ea(g[C+24>>2])),G=ea(-D),X=ea(-V),W=ea(-Y),L=D>G?D:G,G=V>X?V:X,X=!(L>=G)?G:L,Z=!((Y>W?Y:W)>=ea(0.0)),W=Z?ea(0.0):L,!((X>=W?X:W)>E)):0)?(E=ea(g[C+4>>2]),W=ea(P*E),E=ea(M*ea(g[C>>2])),X=ea(Q*ea(g[C+8>>2])),L=ea(W+E),!(ea(ea(L+X)+ea(J*ea(g[C+12>>2])))<ea(.999800026))):0){ia=dTa(C,l,q,r,o)|0;i=m;return ia|0}X=ea(g[k>>2]);L=ea(X-ea(g[O>>2]));X=ea(g[f+20>>2]);E=ea(X-ea(g[h+20>>2]));X=ea(g[f+24>>2]);W=ea(L*ea(2.0));L=ea(E*ea(2.0));E=ea(ea(X-ea(g[h+24>>2]))*ea(2.0));X=ea(g[h+12>>2]);Y=ea(ea(X*X)+ea(-.5));G=ea(g[h>>2]);V=ea(W*G);D=ea(g[h+4>>2]);K=ea(V+ea(L*D));V=ea(g[h+8>>2]);N=ea(K+ea(E*V));K=ea(ea(G*N)+ea(ea(W*Y)-ea(X*ea(ea(E*D)-ea(L*V)))));F=ea(ea(D*N)+ea(ea(L*Y)-ea(X*ea(ea(W*V)-ea(E*G)))));R=ea(ea(ea(E*Y)-ea(X*ea(ea(L*G)-ea(W*D))))+ea(V*N));N=ea(g[S>>2]);V=ea(N+ea(g[j>>2]));g[w>>2]=ea(1.0);g[w+4>>2]=ea(0.0);g[w+8>>2]=ea(0.0);g[w+12>>2]=ea(0.0);g[w+16>>2]=ea(1.0);g[w+20>>2]=ea(0.0);g[w+24>>2]=ea(0.0);g[w+28>>2]=ea(0.0);g[w+32>>2]=ea(1.0);g[w+36>>2]=ea(1.0);g[w+40>>2]=ea(0.0);g[w+44>>2]=ea(0.0);g[w+48>>2]=ea(0.0);g[w+52>>2]=ea(1.0);g[w+56>>2]=ea(0.0);g[w+60>>2]=ea(0.0);g[w+64>>2]=ea(0.0);g[w+68>>2]=ea(1.0);j=e+4|0;if((ea(g[j>>2])==ea(1.0)?ea(g[e+8>>2])==ea(1.0):0)?ea(g[e+12>>2])==ea(1.0):0)ja=1;else{J0a(w,j,e+16|0);ja=0}j=c[e+40>>2]|0;a[_>>0]=0;g[C>>2]=M;g[C+4>>2]=P;g[C+8>>2]=Q;g[C+12>>2]=J;g[C+16>>2]=I;g[C+20>>2]=H;g[C+24>>2]=U;g[C+28>>2]=ea(0.0);_=c[j+152>>2]|0;c[x+4>>2]=2;c[x+8>>2]=w;c[x+12>>2]=_;a[x+16>>0]=ja&1;_=x+868|0;c[_>>2]=0;c[x>>2]=544248;e=x+880|0;$7a(e,p,t,q,r,C,l);g[x+3216>>2]=K;g[x+3220>>2]=F;g[x+3224>>2]=R;g[x+3228>>2]=ea(0.0);t=x+3232|0;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];U=ea(g[o>>2]);H=ea(U+ea(g[p>>2]));g[x+3248>>2]=ea(H*H);p=x+3252|0;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[y>>2]=c[j+16>>2];c[y+4>>2]=j+32;g[y+8>>2]=ea(g[j+20>>2]);g[z>>2]=K;j=z+4|0;g[j>>2]=F;p=z+8|0;g[p>>2]=R;g[A>>2]=V;t=A+4|0;g[t>>2]=V;S=A+8|0;g[S>>2]=V;g[n>>2]=ea(1.0);h=n+4|0;g[h>>2]=ea(0.0);f=n+8|0;g[f>>2]=ea(0.0);O=n+12|0;g[O>>2]=ea(0.0);k=n+16|0;g[k>>2]=ea(1.0);Z=n+20|0;g[Z>>2]=ea(0.0);b=n+24|0;g[b>>2]=ea(0.0);$=n+28|0;g[$>>2]=ea(0.0);aa=n+32|0;g[aa>>2]=ea(1.0);if(ja){ka=ea(1.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(1.0);pa=ea(0.0);qa=ea(0.0);ra=ea(0.0);sa=ea(1.0);ta=K;ua=F;va=R;wa=V;xa=V;ya=V}else{x6a(w,z,A,n);V=ea(g[n>>2]);R=ea(g[h>>2]);F=ea(g[f>>2]);K=ea(g[O>>2]);H=ea(g[k>>2]);U=ea(g[Z>>2]);I=ea(g[b>>2]);J=ea(g[$>>2]);Q=ea(g[aa>>2]);P=ea(g[z>>2]);M=ea(g[j>>2]);N=ea(g[p>>2]);D=ea(g[A>>2]);W=ea(g[t>>2]);ka=V;la=R;ma=F;na=K;oa=H;pa=U;qa=I;ra=J;sa=Q;ta=P;ua=M;va=N;wa=D;xa=W;ya=ea(g[S>>2])}g[B>>2]=ka;g[B+4>>2]=la;g[B+8>>2]=ma;g[B+12>>2]=na;g[B+16>>2]=oa;g[B+20>>2]=pa;g[B+24>>2]=qa;g[B+28>>2]=ra;g[B+32>>2]=sa;g[B+36>>2]=ta;g[B+40>>2]=ua;g[B+44>>2]=va;g[B+48>>2]=wa;g[B+52>>2]=xa;g[B+56>>2]=ya;vQa(B,1,y,x,1);y=c[_>>2]|0;if(y){B=x+880|0;S=y;y=x+852|0;t=x+788|0;A=x+596|0;p=x+20|0;while(1){S=S+-1|0;gSa(B,p,c[t>>2]|0,a[y>>0]|0,A)|0;if(!S)break;else{y=y+1|0;t=t+4|0;A=A+12|0;p=p+36|0}}c[_>>2]=0}a8a(e,1,0);ia=dTa(C,l,q,r,o)|0;i=m;return ia|0}function FSa(d,e){d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=0;c[d>>2]=e;f=ea(g[e>>2]);h=ea(-f);i=ea(g[e+4>>2]);j=ea(-i);k=ea(g[e+8>>2]);l=ea(-k);g[d+4>>2]=h;g[d+8>>2]=j;g[d+12>>2]=l;g[d+16>>2]=f;g[d+20>>2]=j;g[d+24>>2]=l;g[d+28>>2]=f;g[d+32>>2]=i;g[d+36>>2]=l;g[d+40>>2]=h;g[d+44>>2]=i;g[d+48>>2]=l;g[d+52>>2]=h;g[d+56>>2]=j;g[d+60>>2]=k;g[d+64>>2]=f;g[d+68>>2]=j;g[d+72>>2]=k;g[d+76>>2]=f;g[d+80>>2]=i;g[d+84>>2]=k;g[d+88>>2]=h;g[d+92>>2]=i;g[d+96>>2]=k;a[d+118>>0]=4;b[d+116>>1]=0;a[d+138>>0]=4;b[d+136>>1]=4;a[d+158>>0]=4;b[d+156>>1]=8;a[d+178>>0]=4;b[d+176>>1]=12;a[d+198>>0]=4;b[d+196>>1]=16;a[d+218>>0]=4;b[d+216>>1]=20;g[d+120>>2]=ea(1.0);g[d+124>>2]=ea(0.0);g[d+128>>2]=ea(0.0);g[d+132>>2]=ea(-ea(g[e>>2]));g[d+160>>2]=ea(-1.0);g[d+164>>2]=ea(0.0);g[d+168>>2]=ea(0.0);e=c[d>>2]|0;g[d+172>>2]=ea(-ea(g[e>>2]));a[d+139>>0]=0;a[d+179>>0]=1;g[d+180>>2]=ea(0.0);g[d+184>>2]=ea(1.0);g[d+188>>2]=ea(0.0);m=e+4|0;g[d+192>>2]=ea(-ea(g[m>>2]));g[d+200>>2]=ea(0.0);g[d+204>>2]=ea(-1.0);g[d+208>>2]=ea(0.0);g[d+212>>2]=ea(-ea(g[m>>2]));a[d+199>>0]=0;a[d+219>>0]=2;g[d+140>>2]=ea(0.0);g[d+144>>2]=ea(0.0);g[d+148>>2]=ea(1.0);m=e+8|0;g[d+152>>2]=ea(-ea(g[m>>2]));g[d+100>>2]=ea(0.0);g[d+104>>2]=ea(0.0);g[d+108>>2]=ea(-1.0);g[d+112>>2]=ea(-ea(g[m>>2]));a[d+159>>0]=0;a[d+119>>0]=4;return}function GSa(a,b){a=a|0;b=b|0;g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);c[b+12>>2]=8;c[b+16>>2]=6;c[b+24>>2]=a+100;c[b+20>>2]=0;c[b+28>>2]=a+4;c[b+32>>2]=544264;a=b+36|0;c[b+60>>2]=0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;return}function HSa(a,b,f){a=a|0;b=b|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=0;h=i;j=c[a+192>>2]|0;k=ea(g[j+24>>2]);l=ea(g[j+28>>2]);m=ea(g[j+32>>2]);n=ea(k*ea(g[a+96>>2]));o=ea(n+ea(l*ea(g[a+112>>2])));n=ea(o+ea(m*ea(g[a+128>>2])));o=ea(k*ea(g[a+100>>2]));p=ea(o+ea(l*ea(g[a+116>>2])));o=ea(p+ea(m*ea(g[a+132>>2])));p=ea(k*ea(g[a+104>>2]));k=ea(p+ea(l*ea(g[a+120>>2])));l=ea(k+ea(m*ea(g[a+136>>2])));g[f>>2]=n;g[f+4>>2]=o;g[f+8>>2]=l;a=j+38|0;c[f+12>>2]=d[a>>0];q=j+39|0;c[f+16>>2]=d[q>>0];r=e[j+36>>1]|0;c[f+20>>2]=r;s=j+40|0;c[f+24>>2]=c[s>>2];c[f+28>>2]=(c[s>>2]|0)+((d[q>>0]|0)*20|0);c[f+32>>2]=(c[s>>2]|0)+((d[q>>0]|0)*20|0)+(((d[a>>0]|0)*15|0)+(r<<1));c[f+36>>2]=(c[s>>2]|0)+((d[q>>0]|0)*20|0)+((d[a>>0]|0)*12|0);c[f+56>>2]=c[j+44>>2];a=f+40|0;q=j+48|0;c[a+0>>2]=c[q+0>>2];c[a+4>>2]=c[q+4>>2];c[a+8>>2]=c[q+8>>2];c[a+12>>2]=c[q+12>>2];c[f+60>>2]=2657;if(b){i=h;return};c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=h;return}function ISa(a,b,f,h){a=a|0;b=b|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=Im,C=0,D=Im,E=0,F=Im,G=Im,H=0,I=Im,J=Im,K=0,L=0,M=0,N=Im,O=Im;j=i;k=a+4|0;if((ea(g[k>>2])==ea(1.0)?ea(g[a+8>>2])==ea(1.0):0)?ea(g[a+12>>2])==ea(1.0):0)l=1;else{J0a(b,k,a+16|0);l=0}k=a+36|0;a=c[k>>2]|0;m=ea(g[a>>2]);n=ea(g[a+12>>2]);o=ea(m+n);p=ea(g[a+4>>2]);q=ea(g[a+16>>2]);r=ea(p+q);s=ea(g[a+8>>2]);t=ea(g[a+20>>2]);u=ea(o*ea(.5));o=ea(r*ea(.5));r=ea(ea(s+t)*ea(.5));v=ea(g[b>>2]);w=ea(u*v);a=b+4|0;x=ea(g[a>>2]);y=ea(u*x);z=b+8|0;A=ea(g[z>>2]);B=ea(u*A);C=b+12|0;u=ea(g[C>>2]);D=ea(o*u);E=b+16|0;F=ea(g[E>>2]);G=ea(o*F);H=b+20|0;I=ea(g[H>>2]);J=ea(w+D);D=ea(y+G);G=ea(B+ea(o*I));K=b+24|0;o=ea(g[K>>2]);B=ea(r*o);L=b+28|0;y=ea(g[L>>2]);w=ea(r*y);M=b+32|0;N=ea(g[M>>2]);O=ea(J+B);B=ea(D+w);w=ea(G+ea(r*N));r=ea(ea(n-m)*ea(.5));m=ea(ea(q-p)*ea(.5));p=ea(ea(t-s)*ea(.5));s=ea(ea(ea(S(ea(r*v)))+ea(S(ea(m*u))))+ea(S(ea(p*o))));o=ea(ea(ea(S(ea(r*x)))+ea(S(ea(m*F))))+ea(S(ea(p*y))));y=ea(ea(ea(S(ea(r*A)))+ea(S(ea(m*I))))+ea(S(ea(p*N))));N=ea(B-o);p=ea(w-y);I=ea(O+s);m=ea(B+o);o=ea(w+y);g[f>>2]=ea(O-s);g[f+4>>2]=N;g[f+8>>2]=p;g[f+12>>2]=I;g[f+16>>2]=m;g[f+20>>2]=o;f=c[k>>2]|0;o=ea(g[f+24>>2]);m=ea(o*ea(g[b>>2]));I=ea(o*ea(g[a>>2]));p=ea(o*ea(g[z>>2]));o=ea(g[f+28>>2]);N=ea(o*ea(g[C>>2]));s=ea(o*ea(g[E>>2]));O=ea(m+N);N=ea(I+s);s=ea(p+ea(o*ea(g[H>>2])));o=ea(g[f+32>>2]);p=ea(o*ea(g[K>>2]));I=ea(o*ea(g[L>>2]));m=ea(N+I);I=ea(s+ea(o*ea(g[M>>2])));g[h>>2]=ea(O+p);g[h+4>>2]=m;g[h+8>>2]=I;M=f+38|0;c[h+12>>2]=d[M>>0];L=f+39|0;c[h+16>>2]=d[L>>0];K=e[f+36>>1]|0;c[h+20>>2]=K;H=f+40|0;c[h+24>>2]=c[H>>2];c[h+28>>2]=(c[H>>2]|0)+((d[L>>0]|0)*20|0);c[h+32>>2]=(c[H>>2]|0)+((d[L>>0]|0)*20|0)+(((d[M>>0]|0)*15|0)+(K<<1));c[h+36>>2]=(c[H>>2]|0)+((d[L>>0]|0)*20|0)+((d[M>>0]|0)*12|0);c[h+56>>2]=c[f+44>>2];M=h+40|0;L=f+48|0;c[M+0>>2]=c[L+0>>2];c[M+4>>2]=c[L+4>>2];c[M+8>>2]=c[L+8>>2];c[M+12>>2]=c[L+12>>2];c[h+60>>2]=2657;i=j;return l|0}function JSa(b,d,e,f,h,j,k,l,m,n,o,p){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=0,K=Im,L=Im,M=0,N=0,O=Im,P=0,Q=Im,R=0,S=0,U=0;q=i;i=i+112|0;r=q+96|0;s=q+48|0;t=q+80|0;u=q+104|0;v=q+64|0;w=q;x=q+16|0;y=q+32|0;c[r>>2]=0;g[s>>2]=ea(3402823469999999843913219.0e14);c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;if(!(j8a(d,l,o,s,q+100|0,t,r)|0)){z=0;i=q;return z|0}if(!(k8a(j,k,l,o,s,u,t,r)|0)){z=0;i=q;return z|0}A=j+24|0;if(!(l8a(d,h,j,k,l,o,s,t,r)|0)){z=0;i=q;return z|0}s=d+112|0;B=ea(g[s>>2]);k=d+116|0;C=ea(g[k>>2]);D=d+120|0;E=ea(g[D>>2]);F=d+96|0;G=ea(g[F>>2]);H=d+100|0;I=ea(g[H>>2]);J=d+104|0;K=ea(g[J>>2]);L=ea(B-G);B=ea(C-I);C=ea(E-K);M=d+128|0;E=ea(g[M>>2]);N=d+132|0;O=ea(g[N>>2]);P=d+136|0;Q=ea(E-G);G=ea(O-I);I=ea(ea(g[P>>2])-K);K=ea(ea(B*I)-ea(C*G));O=ea(ea(C*Q)-ea(L*I));I=ea(ea(L*G)-ea(B*Q));Q=ea(ea(1.0)/ea(T(ea(ea(I*I)+ea(ea(K*K)+ea(O*O))))));B=ea(Q*K);K=ea(Q*O);O=ea(I*Q);g[v>>2]=B;g[v+4>>2]=K;g[v+8>>2]=O;g[v+12>>2]=ea(0.0);R=c[r>>2]|0;if(!R){r=c[l+36>>2]|0;Q=ea(g[t>>2]);I=ea(g[t+4>>2]);G=ea(g[t+8>>2]);L=ea(Q*ea(g[r>>2]));C=ea(L+ea(I*ea(g[r+4>>2])));L=ea(C+ea(G*ea(g[r+8>>2])));C=ea(Q*ea(g[r+16>>2]));E=ea(C+ea(I*ea(g[r+20>>2])));C=ea(E+ea(G*ea(g[r+24>>2])));E=ea(Q*ea(g[r+32>>2]));Q=ea(E+ea(I*ea(g[r+36>>2])));I=ea(Q+ea(G*ea(g[r+40>>2])));g[w>>2]=L;g[w+4>>2]=C;g[w+8>>2]=I;g[w+12>>2]=ea(0.0);r=g8a(j,l,w)|0;w=(c[A>>2]|0)+(r*20|0)|0;c[p+0>>2]=c[v+0>>2];c[p+4>>2]=c[v+4>>2];c[p+8>>2]=c[v+8>>2];c[p+12>>2]=c[v+12>>2];m8a(d,e,h,j,w,l,m,n,o,v);z=1;i=q;return z|0}else if((R|0)==1){R=c[u>>2]|0;w=c[A>>2]|0;r=w+(R*20|0)|0;S=c[l+40>>2]|0;I=ea(g[r>>2]);C=ea(g[w+(R*20|0)+4>>2]);L=ea(g[w+(R*20|0)+8>>2]);G=ea(I*ea(g[S>>2]));Q=ea(G+ea(C*ea(g[S+4>>2])));G=ea(Q+ea(L*ea(g[S+8>>2])));Q=ea(I*ea(g[S+16>>2]));E=ea(Q+ea(C*ea(g[S+20>>2])));Q=ea(E+ea(L*ea(g[S+24>>2])));E=ea(I*ea(g[S+32>>2]));I=ea(E+ea(C*ea(g[S+36>>2])));C=ea(I+ea(L*ea(g[S+40>>2])));L=ea(ea(1.0)/ea(T(ea(ea(ea(G*G)+ea(Q*Q))+ea(C*C)))));if(ea(ea(ea(-ea(ea(Q*L)*K))-ea(ea(G*L)*B))-ea(ea(C*L)*O))>ea(.707099974)){c[p+0>>2]=c[v+0>>2];c[p+4>>2]=c[v+4>>2];c[p+8>>2]=c[v+8>>2];c[p+12>>2]=c[v+12>>2];m8a(d,e,h,j,r,l,m,n,o,v);z=1;i=q;return z|0}v=c[b+3648>>2]|0;b=v+4|0;r=c[b>>2]|0;if((r+15|0)>>>0>(c[v>>2]|0)>>>0){gLa(v,15)|0;U=c[b>>2]|0}else U=r;r=c[v+8>>2]|0;c[b>>2]=U+15;c[r+(U+12<<2)>>2]=e;c[r+(U+13<<2)>>2]=R;a[r+(U+14<<2)>>0]=h;c[r+(U+9<<2)>>2]=c[f>>2];c[r+(U+10<<2)>>2]=c[f+4>>2];c[r+(U+11<<2)>>2]=c[f+8>>2];O=ea(g[F>>2]);L=ea(g[H>>2]);C=ea(g[J>>2]);g[r+(U<<2)>>2]=O;g[r+(U+1<<2)>>2]=L;g[r+(U+2<<2)>>2]=C;C=ea(g[s>>2]);L=ea(g[k>>2]);O=ea(g[D>>2]);g[r+(U+3<<2)>>2]=C;g[r+(U+4<<2)>>2]=L;g[r+(U+5<<2)>>2]=O;O=ea(g[M>>2]);L=ea(g[N>>2]);C=ea(g[P>>2]);g[r+(U+6<<2)>>2]=O;g[r+(U+7<<2)>>2]=L;g[r+(U+8<<2)>>2]=C;z=1;i=q;return z|0}else{U=c[l+36>>2]|0;C=ea(g[t>>2]);L=ea(g[t+4>>2]);O=ea(g[t+8>>2]);B=ea(C*ea(g[U>>2]));G=ea(B+ea(L*ea(g[U+4>>2])));B=ea(G+ea(O*ea(g[U+8>>2])));G=ea(C*ea(g[U+16>>2]));K=ea(G+ea(L*ea(g[U+20>>2])));G=ea(K+ea(O*ea(g[U+24>>2])));K=ea(C*ea(g[U+32>>2]));C=ea(K+ea(L*ea(g[U+36>>2])));L=ea(C+ea(O*ea(g[U+40>>2])));g[x>>2]=B;g[x+4>>2]=G;g[x+8>>2]=L;g[x+12>>2]=ea(0.0);U=g8a(j,l,x)|0;c[u>>2]=U;u=c[A>>2]|0;A=u+(U*20|0)|0;x=c[l+40>>2]|0;L=ea(g[A>>2]);G=ea(g[u+(U*20|0)+4>>2]);B=ea(g[u+(U*20|0)+8>>2]);O=ea(L*ea(g[x>>2]));C=ea(O+ea(G*ea(g[x+4>>2])));O=ea(C+ea(B*ea(g[x+8>>2])));C=ea(L*ea(g[x+16>>2]));K=ea(C+ea(G*ea(g[x+20>>2])));C=ea(K+ea(B*ea(g[x+24>>2])));K=ea(L*ea(g[x+32>>2]));L=ea(K+ea(G*ea(g[x+36>>2])));G=ea(L+ea(B*ea(g[x+40>>2])));B=ea(ea(1.0)/ea(T(ea(ea(ea(O*O)+ea(C*C))+ea(G*G)))));L=ea(O*B);O=ea(C*B);C=ea(G*B);g[y>>2]=L;g[y+4>>2]=O;g[y+8>>2]=C;g[y+12>>2]=ea(0.0);B=ea(-O);O=ea(-C);g[p>>2]=ea(-L);g[p+4>>2]=B;g[p+8>>2]=O;g[p+12>>2]=ea(0.0);n8a(j,A,d,e,h,l,m,n,o,y);z=1;i=q;return z|0}return 0}function KSa(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;n=i;i=i+80|0;o=n+68|0;p=n+32|0;q=n+48|0;r=n;s=n+16|0;c[o>>2]=0;g[p>>2]=ea(3402823469999999843913219.0e14);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;if(!(j8a(a,h,l,p,n+72|0,q,o)|0)){t=0;i=n;return t|0}if(!(k8a(e,f,h,l,p,n+64|0,q,o)|0)){t=0;i=n;return t|0}if(!(l8a(a,d,e,f,h,l,p,q,o)|0)){t=0;i=n;return t|0}u=ea(g[a+112>>2]);v=ea(g[a+116>>2]);w=ea(g[a+120>>2]);x=ea(g[a+96>>2]);y=ea(g[a+100>>2]);z=ea(g[a+104>>2]);A=ea(u-x);u=ea(v-y);v=ea(w-z);w=ea(g[a+128>>2]);B=ea(g[a+132>>2]);C=ea(w-x);x=ea(B-y);y=ea(ea(g[a+136>>2])-z);z=ea(ea(u*y)-ea(v*x));B=ea(ea(v*C)-ea(A*y));y=ea(ea(A*x)-ea(u*C));C=ea(ea(1.0)/ea(T(ea(ea(y*y)+ea(ea(z*z)+ea(B*B))))));u=ea(C*z);z=ea(C*B);B=ea(y*C);g[r>>2]=u;g[r+4>>2]=z;g[r+8>>2]=B;g[r+12>>2]=ea(0.0);c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];m=c[h+36>>2]|0;C=ea(u*ea(g[m>>2]));y=ea(C+ea(z*ea(g[m+4>>2])));C=ea(y+ea(B*ea(g[m+8>>2])));y=ea(u*ea(g[m+16>>2]));x=ea(y+ea(z*ea(g[m+20>>2])));y=ea(x+ea(B*ea(g[m+24>>2])));x=ea(u*ea(g[m+32>>2]));u=ea(x+ea(z*ea(g[m+36>>2])));z=ea(u+ea(B*ea(g[m+40>>2])));g[s>>2]=C;g[s+4>>2]=y;g[s+8>>2]=z;g[s+12>>2]=ea(0.0);m=g8a(e,h,s)|0;m8a(a,b,d,e,(c[e+24>>2]|0)+(m*20|0)|0,h,j,k,l,r);t=1;i=n;return t|0}function LSa(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;m=i;i=i+16|0;n=m;o=a+3652|0;p=c[(c[o>>2]|0)+24>>2]|0;q=p+(d*20|0)|0;r=a+3656|0;a=c[(c[r>>2]|0)+40>>2]|0;s=ea(g[q>>2]);t=ea(g[p+(d*20|0)+4>>2]);u=ea(g[p+(d*20|0)+8>>2]);v=ea(s*ea(g[a>>2]));w=ea(v+ea(t*ea(g[a+4>>2])));v=ea(w+ea(u*ea(g[a+8>>2])));w=ea(s*ea(g[a+16>>2]));x=ea(w+ea(t*ea(g[a+20>>2])));w=ea(x+ea(u*ea(g[a+24>>2])));x=ea(s*ea(g[a+32>>2]));s=ea(x+ea(t*ea(g[a+36>>2])));t=ea(s+ea(u*ea(g[a+40>>2])));u=ea(ea(1.0)/ea(T(ea(ea(ea(v*v)+ea(w*w))+ea(t*t)))));s=ea(v*u);v=ea(w*u);w=ea(t*u);g[n>>2]=s;g[n+4>>2]=v;g[n+8>>2]=w;g[n+12>>2]=ea(0.0);u=ea(-v);v=ea(-w);g[l>>2]=ea(-s);g[l+4>>2]=u;g[l+8>>2]=v;g[l+12>>2]=ea(0.0);n8a(c[o>>2]|0,q,b,e,f,c[r>>2]|0,h,j,k,n);i=m;return 1}function MSa(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;c=i;d=ea(g[b+8>>2]);if(ea(S(ea(d)))<ea(.999899983)){e=ea(g[b+4>>2]);f=ea(-e);h=ea(g[b>>2]);j=ea(ea(1.0)/ea(d+ea(1.0)));k=ea(j*f);l=ea(h*k);m=ea(d+ea(j*ea(h*h)));j=ea(-h);g[a>>2]=ea(d+ea(k*f));g[a+4>>2]=l;g[a+8>>2]=h;g[a+12>>2]=ea(0.0);g[a+16>>2]=l;g[a+20>>2]=m;g[a+24>>2]=e;g[a+28>>2]=ea(0.0);g[a+32>>2]=j;g[a+36>>2]=f;g[a+40>>2]=d;g[a+44>>2]=ea(0.0);i=c;return}else{f=ea(g[b>>2]);j=ea(ea(0.0)-f);f=ea(ea(1.0)-ea(g[b+4>>2]));e=ea(ea(0.0)-d);d=ea(-ea(ea(2.0)/ea(ea(ea(j*j)+ea(f*f))+ea(e*e))));m=ea(ea(ea(ea(ea(j*ea(0.0))+f)+ea(e*ea(-1.0)))*d)*ea(-1.0));l=ea(j*d);h=ea(f*d);k=ea(e*d);d=ea(j*m);n=ea(f*m);o=ea(e*m);m=ea(ea(f*l)+d);p=ea(ea(ea(e*l)+ea(d*ea(-1.0)))+ea(0.0));q=ea(ea(j*h)+ea(n*ea(0.0)));r=ea(ea(ea(e*h)+ea(n*ea(-1.0)))+ea(1.0));s=ea(ea(ea(ea(f*h)+n)+ea(-1.0))+ea(1.0));n=ea(ea(ea(j*k)+ea(o*ea(0.0)))+ea(0.0));h=ea(ea(ea(f*k)+o)+ea(1.0));f=ea(ea(ea(ea(e*k)+ea(o*ea(-1.0)))+ea(-1.0))+ea(1.0));g[a>>2]=ea(ea(ea(j*l)+ea(d*ea(0.0)))+ea(1.0));g[a+4>>2]=m;g[a+8>>2]=p;g[a+12>>2]=ea(0.0);g[a+16>>2]=q;g[a+20>>2]=s;g[a+24>>2]=r;g[a+28>>2]=ea(0.0);g[a+32>>2]=n;g[a+36>>2]=h;g[a+40>>2]=f;g[a+44>>2]=ea(0.0);i=c;return}}function NSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=0,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=0;h=i;i=i+256|0;j=h+240|0;k=h;a[j+0>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=0;a[j+4>>0]=0;l=b+44|0;m=c[l>>2]|0;n=k+0|0;o=m+0|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));n=k+48|0;o=m+48|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));n=k+96|0;o=m+96|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));n=k+144|0;o=m+144|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));q=k+192|0;c[q+0>>2]=c[d+0>>2];c[q+4>>2]=c[d+4>>2];c[q+8>>2]=c[d+8>>2];c[q+12>>2]=c[d+12>>2];d=k+208|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];e=k+224|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];r=ea(g[f+12>>2]);s=ea(g[k+44>>2]);f=r>s;t=f?s:r;r=ea(g[k+92>>2]);e=t>r;s=e?r:t;t=ea(g[k+140>>2]);d=s>t;q=(d?t:s)>ea(g[k+188>>2]);u=q?3:d?2:e?1:f?0:4;a[j+u>>0]=1;n=m+0|0;o=k+(u*48|0)+0|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));s=ea(g[k+16>>2]);t=ea(g[k+20>>2]);r=ea(g[k+24>>2]);u=c[l>>2]|0;v=ea(g[u+16>>2]);w=ea(g[u+20>>2]);x=ea(g[u+24>>2]);y=ea(s-v);s=ea(t-w);t=ea(r-x);r=ea(ea(ea(y*y)+ea(s*s))+ea(t*t));if((a[j+1>>0]|0)==0?(t=ea(g[k+64>>2]),s=ea(g[k+68>>2]),y=ea(t-v),t=ea(s-w),s=ea(ea(g[k+72>>2])-x),z=ea(ea(ea(y*y)+ea(t*t))+ea(s*s)),z>r):0){A=z;B=1}else{A=r;B=0}if((a[j+2>>0]|0)==0?(r=ea(g[k+112>>2]),z=ea(g[k+116>>2]),s=ea(r-v),r=ea(z-w),z=ea(ea(g[k+120>>2])-x),t=ea(ea(ea(s*s)+ea(r*r))+ea(z*z)),t>A):0){C=t;D=2}else{C=A;D=B}if((a[j+3>>0]|0)==0?(A=ea(g[k+160>>2]),t=ea(g[k+164>>2]),z=ea(A-v),A=ea(t-w),t=ea(ea(g[k+168>>2])-x),r=ea(ea(ea(z*z)+ea(A*A))+ea(t*t)),r>C):0){E=r;F=3}else{E=C;F=D}if((a[j+4>>0]|0)==0?(C=ea(g[k+208>>2]),r=ea(g[k+212>>2]),t=ea(C-v),v=ea(r-w),w=ea(ea(g[k+216>>2])-x),ea(ea(ea(t*t)+ea(v*v))+ea(w*w))>E):0)G=4;else G=F;a[j+G>>0]=1;n=u+48|0;o=k+(G*48|0)+0|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));E=ea(0.0);u=0;F=G;while(1){if((a[j+u>>0]|0)==0?(G=c[l>>2]|0,w=ea(g[k+(u*48|0)+16>>2]),v=ea(g[k+(u*48|0)+20>>2]),t=ea(g[k+(u*48|0)+24>>2]),x=ea(g[G+16>>2]),r=ea(g[G+20>>2]),C=ea(g[G+24>>2]),A=ea(w-x),w=ea(v-r),v=ea(t-C),t=ea(g[G+64>>2]),z=ea(g[G+68>>2]),s=ea(t-x),x=ea(z-r),r=ea(ea(g[G+72>>2])-C),C=ea(ea(ea(s*s)+ea(x*x))+ea(r*r)),z=ea(ea(ea(ea(A*s)+ea(w*x))+ea(v*r))/C),G=z>ea(1.0),t=G?ea(1.0):z,G=t>ea(0.0),z=G?t:ea(0.0),G=C!=ea(0.0),C=G?z:ea(0.0),z=ea(A-ea(s*C)),s=ea(w-ea(x*C)),x=ea(v-ea(r*C)),C=ea(ea(x*x)+ea(ea(z*z)+ea(s*s))),C>E):0){H=C;I=u}else{H=E;I=F}u=u+1|0;if((u|0)==5)break;else{E=H;F=I}}a[j+I>>0]=1;n=(c[l>>2]|0)+96|0;o=k+(I*48|0)+0|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));H=ea(0.0);F=0;u=I;while(1){if(!(a[j+F>>0]|0)){I=c[l>>2]|0;E=ea(g[I+64>>2]);C=ea(g[I+68>>2]);s=ea(g[I+72>>2]);z=ea(g[I+16>>2]);x=ea(g[I+20>>2]);r=ea(g[I+24>>2]);v=ea(E-z);w=ea(C-x);A=ea(s-r);t=ea(g[I+112>>2]);y=ea(g[I+116>>2]);J=ea(g[I+120>>2]);K=ea(t-z);L=ea(y-x);M=ea(J-r);N=ea(t-E);O=ea(y-C);P=ea(J-s);Q=ea(g[k+(F*48|0)+16>>2]);R=ea(g[k+(F*48|0)+20>>2]);S=ea(g[k+(F*48|0)+24>>2]);T=ea(Q-z);U=ea(R-x);V=ea(S-r);W=ea(Q-E);X=ea(R-C);Y=ea(S-s);Z=ea(Q-t);t=ea(R-y);y=ea(S-J);J=ea(ea(ea(v*T)+ea(w*U))+ea(A*V));_=ea(ea(ea(K*T)+ea(L*U))+ea(M*V));$=ea(ea(ea(v*W)+ea(w*X))+ea(A*Y));aa=ea(ea(ea(K*W)+ea(L*X))+ea(M*Y));ba=ea(ea(ea(v*Z)+ea(w*t))+ea(A*y));ca=ea(ea(ea(K*Z)+ea(L*t))+ea(M*y));da=ea(aa-$);fa=ea(ba-ca);do if(J<ea(0.0)&_<ea(0.0))ga=ea(ea(ea(T*T)+ea(U*U))+ea(V*V));else{if(!(!($>=ea(0.0))|!($>=aa))){ga=ea(ea(ea(W*W)+ea(X*X))+ea(Y*Y));break}if(!(!(ca>=ea(0.0))|!(ca>=ba))){ga=ea(ea(ea(Z*Z)+ea(t*t))+ea(y*y));break}ha=ea(ea(J*aa)-ea($*_));if(J>=ea(0.0)?!(!(ha<ea(0.0))|!($<ea(0.0))):0){ia=ea(J/ea(J-$));ja=ea(Q-ea(z+ea(v*ia)));ka=ea(R-ea(x+ea(w*ia)));la=ea(S-ea(r+ea(A*ia)));ga=ea(ea(la*la)+ea(ea(ja*ja)+ea(ka*ka)));break}ka=ea(ea($*ca)-ea(ba*aa));if(aa>=$?!(!(ka<ea(0.0))|!(ba>=ca)):0){ja=ea(da/ea(da+fa));la=ea(Q-ea(E+ea(N*ja)));ia=ea(R-ea(C+ea(O*ja)));ma=ea(S-ea(s+ea(P*ja)));ga=ea(ea(ma*ma)+ea(ea(la*la)+ea(ia*ia)));break}ia=ea(ea(ba*_)-ea(J*ca));if(_>=ea(0.0)?!(!(ia<ea(0.0))|!(ca<ea(0.0))):0){la=ea(_/ea(_-ca));ma=ea(Q-ea(z+ea(K*la)));ja=ea(R-ea(x+ea(L*la)));na=ea(S-ea(r+ea(M*la)));ga=ea(ea(na*na)+ea(ea(ma*ma)+ea(ja*ja)));break}ja=ea(ea(1.0)/ea(ka+ea(ia+ha)));ka=ea(ia*ja);ia=ea(ha*ja);ja=ea(Q-ea(z+ea(ea(v*ka)+ea(K*ia))));ha=ea(R-ea(x+ea(ea(w*ka)+ea(L*ia))));ma=ea(S-ea(r+ea(ea(A*ka)+ea(M*ia))));ga=ea(ea(ma*ma)+ea(ea(ja*ja)+ea(ha*ha)))}while(0);if(ga>H){oa=ga;pa=F}else{oa=H;pa=u}}else{oa=H;pa=u}F=F+1|0;if((F|0)==5)break;else{H=oa;u=pa}}u=j+pa|0;if(a[u>>0]|0){a[b+32>>0]=3;i=h;return 0}a[u>>0]=1;n=(c[l>>2]|0)+144|0;o=k+(pa*48|0)+0|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));pa=0;while(1){if(!(a[j+pa>>0]|0)){qa=pa;break}pa=pa+1|0;if(pa>>>0>=5){qa=0;break}}pa=c[l>>2]|0;oa=ea(g[k+(qa*48|0)>>2]);H=ea(g[k+(qa*48|0)+4>>2]);ga=ea(g[k+(qa*48|0)+8>>2]);M=ea(g[pa>>2]);A=ea(g[pa+4>>2]);r=ea(M-oa);M=ea(A-H);A=ea(ea(g[pa+8>>2])-ga);S=ea(ea(ea(r*r)+ea(M*M))+ea(A*A));l=S<ea(3402823469999999843913219.0e14);A=l?S:ea(3402823469999999843913219.0e14);S=ea(g[pa+48>>2]);M=ea(g[pa+52>>2]);r=ea(S-oa);S=ea(M-H);M=ea(ea(g[pa+56>>2])-ga);L=ea(ea(ea(r*r)+ea(S*S))+ea(M*M));l=A>L;M=l?L:A;A=ea(g[pa+96>>2]);L=ea(g[pa+100>>2]);S=ea(A-oa);A=ea(L-H);L=ea(ea(g[pa+104>>2])-ga);r=ea(ea(ea(S*S)+ea(A*A))+ea(L*L));j=M>r;L=ea(g[pa+144>>2]);A=ea(g[pa+148>>2]);S=ea(L-oa);oa=ea(A-H);H=ea(ea(g[pa+152>>2])-ga);u=(j?r:M)>ea(ea(ea(S*S)+ea(oa*oa))+ea(H*H));b=u?3:j?2:l&1;H=ea(g[pa+(b*48|0)+44>>2]);if(!(H>ea(g[k+(qa*48|0)+44>>2]))){i=h;return 0}n=pa+(b*48|0)+0|0;o=k+(qa*48|0)+0|0;p=n+48|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));i=h;return 0}function OSa(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0;j=i;k=b+32|0;if(!(a[k>>0]|0)){l=0;m=e+4096|0;c[m>>2]=l;i=j;return}n=b+44|0;b=h+4|0;o=h+8|0;p=h+12|0;q=h+16|0;r=h+20|0;s=h+24|0;t=f+4|0;u=f+8|0;v=0;while(1){w=c[n>>2]|0;x=ea(g[h>>2]);y=ea(g[b>>2]);z=ea(g[o>>2]);A=ea(g[p>>2]);B=ea(g[q>>2]);C=ea(g[r>>2]);D=ea(g[s>>2]);E=ea(g[w+(v*48|0)+16>>2]);F=ea(g[w+(v*48|0)+20>>2]);G=ea(g[w+(v*48|0)+24>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(x*E)+ea(y*F))+ea(z*G));J=ea(B+ea(ea(ea(x*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0)));B=ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(x*G)))))*ea(2.0)));C=ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(x*F)-ea(y*E))))+ea(z*I))*ea(2.0)));I=ea(g[w+(v*48|0)+44>>2]);w=v+1|0;z=ea(g[f>>2]);E=ea(g[t>>2]);y=ea(g[u>>2]);K=e+(v<<6)|0;g[K>>2]=z;g[K+4>>2]=E;g[K+8>>2]=y;g[K+12>>2]=ea(0.0);K=e+(v<<6)+16|0;g[K>>2]=J;g[K+4>>2]=B;g[K+8>>2]=C;g[K+12>>2]=ea(0.0);g[e+(v<<6)+12>>2]=I;c[e+(v<<6)+48>>2]=-1;c[e+(v<<6)+52>>2]=-1;if(w>>>0<(d[k>>0]|0)>>>0&w>>>0<64)v=w;else{l=w;break}}m=e+4096|0;c[m>>2]=l;i=j;return}function PSa(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0;j=i;k=b+32|0;if(!(a[k>>0]|0)){l=0;m=e+4096|0;c[m>>2]=l;i=j;return}n=b+44|0;b=h+48|0;o=h+52|0;p=h+56|0;q=h+16|0;r=h+32|0;s=h+4|0;t=h+20|0;u=h+36|0;v=h+8|0;w=h+24|0;x=h+40|0;y=f+4|0;z=f+8|0;A=0;while(1){B=c[n>>2]|0;C=ea(g[b>>2]);D=ea(g[o>>2]);E=ea(g[p>>2]);F=ea(g[B+(A*48|0)+16>>2]);G=ea(g[B+(A*48|0)+20>>2]);H=ea(g[B+(A*48|0)+24>>2]);I=ea(F*ea(g[h>>2]));J=ea(I+ea(G*ea(g[q>>2])));I=ea(J+ea(H*ea(g[r>>2])));J=ea(F*ea(g[s>>2]));K=ea(J+ea(G*ea(g[t>>2])));J=ea(K+ea(H*ea(g[u>>2])));K=ea(F*ea(g[v>>2]));F=ea(K+ea(G*ea(g[w>>2])));G=ea(C+I);I=ea(D+J);J=ea(E+ea(F+ea(H*ea(g[x>>2]))));H=ea(g[B+(A*48|0)+44>>2]);B=A+1|0;F=ea(g[f>>2]);E=ea(g[y>>2]);D=ea(g[z>>2]);L=e+(A<<6)|0;g[L>>2]=F;g[L+4>>2]=E;g[L+8>>2]=D;g[L+12>>2]=ea(0.0);L=e+(A<<6)+16|0;g[L>>2]=G;g[L+4>>2]=I;g[L+8>>2]=J;g[L+12>>2]=ea(0.0);g[e+(A<<6)+12>>2]=H;c[e+(A<<6)+48>>2]=-1;c[e+(A<<6)+52>>2]=-1;if(B>>>0<(d[k>>0]|0)>>>0&B>>>0<64)A=B;else{l=B;break}}m=e+4096|0;c[m>>2]=l;i=j;return}function QSa(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0;k=i;l=b+32|0;if(!(a[l>>0]|0)){m=0;n=e+4096|0;c[n>>2]=m;i=k;return}o=b+44|0;b=f+4|0;p=f+8|0;q=h+4|0;r=h+8|0;s=h+12|0;t=h+16|0;u=h+20|0;v=h+24|0;w=0;while(1){x=c[o>>2]|0;y=ea(g[f>>2]);z=ea(g[b>>2]);A=ea(g[p>>2]);B=ea(g[j>>2]);C=ea(g[h>>2]);D=ea(g[q>>2]);E=ea(g[r>>2]);F=ea(g[s>>2]);G=ea(g[t>>2]);H=ea(g[u>>2]);I=ea(g[v>>2]);J=ea(g[x+(w*48|0)>>2]);K=ea(g[x+(w*48|0)+4>>2]);L=ea(g[x+(w*48|0)+8>>2]);M=ea(ea(F*F)+ea(-.5));N=ea(ea(ea(C*J)+ea(D*K))+ea(E*L));O=ea(ea(G+ea(ea(ea(C*N)+ea(ea(M*J)+ea(F*ea(ea(D*L)-ea(E*K)))))*ea(2.0)))-ea(y*B));G=ea(ea(H+ea(ea(ea(D*N)+ea(ea(M*K)+ea(F*ea(ea(E*J)-ea(C*L)))))*ea(2.0)))-ea(z*B));H=ea(ea(I+ea(ea(ea(ea(M*L)+ea(F*ea(ea(C*K)-ea(D*J))))+ea(E*N))*ea(2.0)))-ea(A*B));N=ea(ea(g[x+(w*48|0)+44>>2])-B);x=w+1|0;P=e+(w<<6)|0;g[P>>2]=y;g[P+4>>2]=z;g[P+8>>2]=A;g[P+12>>2]=ea(0.0);P=e+(w<<6)+16|0;g[P>>2]=O;g[P+4>>2]=G;g[P+8>>2]=H;g[P+12>>2]=ea(0.0);g[e+(w<<6)+12>>2]=N;c[e+(w<<6)+48>>2]=-1;c[e+(w<<6)+52>>2]=-1;if(x>>>0<(d[l>>0]|0)>>>0&x>>>0<64)w=x;else{m=x;break}}n=e+4096|0;c[n>>2]=m;i=k;return}function RSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(e>>>0>=5){SSa(b,d,e);a[b+32>>0]=4;i=f;return}if(e){g=b+44|0;h=0;do{j=(c[g>>2]|0)+(h*48|0)|0;k=d+(h*48|0)|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];k=(c[g>>2]|0)+(h*48|0)+16|0;j=d+(h*48|0)+16|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];j=(c[g>>2]|0)+(h*48|0)+32|0;k=d+(h*48|0)+32|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];h=h+1|0}while((h|0)!=(e|0))}a[b+32>>0]=e;i=f;return}function SSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=0,m=0,n=Im,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=0,U=Im,V=0;f=i;i=i+64|0;h=f;PEi(h|0,0,e|0)|0;j=e>>>0>1;if(j){k=ea(g[d+44>>2]);l=1;m=0;while(1){n=ea(g[d+(l*48|0)+44>>2]);o=k>n;p=o?l:m;l=l+1|0;if((l|0)==(e|0)){q=p;break}else{k=o?n:k;m=p}}}else q=0;m=b+44|0;b=(c[m>>2]|0)+0|0;l=d+(q*48|0)+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));a[h+q>>0]=1;k=ea(g[d+16>>2]);n=ea(g[d+20>>2]);r=ea(g[d+24>>2]);q=c[m>>2]|0;s=ea(g[q+16>>2]);t=ea(g[q+20>>2]);u=ea(g[q+24>>2]);v=ea(k-s);k=ea(n-t);n=ea(r-u);if(j){r=ea(ea(ea(v*v)+ea(k*k))+ea(n*n));j=1;o=0;while(1){n=ea(g[d+(j*48|0)+16>>2]);k=ea(g[d+(j*48|0)+20>>2]);v=ea(n-s);n=ea(k-t);k=ea(ea(g[d+(j*48|0)+24>>2])-u);w=ea(ea(ea(v*v)+ea(n*n))+ea(k*k));x=w>r;y=x?j:o;j=j+1|0;if((j|0)==(e|0)){z=y;break}else{r=x?w:r;o=y}}}else z=0;b=q+48|0;l=d+(z*48|0)+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));a[h+z>>0]=1;z=c[m>>2]|0;r=ea(g[z+64>>2]);u=ea(g[z+68>>2]);t=ea(g[z+72>>2]);s=ea(g[z+16>>2]);w=ea(g[z+20>>2]);k=ea(g[z+24>>2]);n=ea(r-s);r=ea(u-w);u=ea(t-k);t=ea(g[z+32>>2]);v=ea(g[z+36>>2]);A=ea(g[z+40>>2]);B=ea(ea(r*A)-ea(u*v));C=ea(ea(u*t)-ea(n*A));A=ea(ea(n*v)-ea(r*t));t=ea(ea(1.0)/ea(T(ea(ea(A*A)+ea(ea(B*B)+ea(C*C))))));r=ea(B*t);B=ea(C*t);C=ea(A*t);q=(e|0)==0;if(q){D=ea(-3402823469999999843913219.0e14);E=ea(3402823469999999843913219.0e14);F=-1;G=-1}else{t=ea(-3402823469999999843913219.0e14);A=ea(3402823469999999843913219.0e14);o=0;j=-1;y=-1;while(1){if(!(a[h+o>>0]|0)){v=ea(g[d+(o*48|0)+16>>2]);n=ea(g[d+(o*48|0)+20>>2]);u=ea(ea(ea(r*ea(v-s))+ea(B*ea(n-w)))+ea(C*ea(ea(g[d+(o*48|0)+24>>2])-k)));x=u>t;n=x?u:t;H=x?o:j;if(A>u){I=n;J=u;K=H;L=o}else{I=n;J=A;K=H;L=y}}else{I=t;J=A;K=j;L=y}o=o+1|0;if((o|0)==(e|0)){D=I;E=J;F=K;G=L;break}else{t=I;A=J;j=K;y=L}}}b=z+96|0;l=d+(F*48|0)+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));a[h+F>>0]=1;if(!(ea(D*E)>ea(0.0))|q){M=G;N=c[m>>2]|0;O=N+144|0;P=d+(M*48|0)|0;b=O+0|0;l=P+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));i=f;return}else{Q=ea(-3402823469999999843913219.0e14);R=0;S=G}while(1){if((a[h+R>>0]|0)==0?(E=ea(g[d+(R*48|0)+16>>2]),D=ea(g[d+(R*48|0)+20>>2]),J=ea(g[d+(R*48|0)+24>>2]),G=c[m>>2]|0,A=ea(g[G+16>>2]),I=ea(g[G+20>>2]),t=ea(ea(ea(r*ea(E-A))+ea(B*ea(D-I)))+ea(C*ea(J-ea(g[G+24>>2])))),t>Q):0){U=t;V=R}else{U=Q;V=S}R=R+1|0;if((R|0)==(e|0)){M=V;break}else{Q=U;S=V}}N=c[m>>2]|0;O=N+144|0;P=d+(M*48|0)|0;b=O+0|0;l=P+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));i=f;return}function TSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(e>>>0>=5){USa(b,d,e);a[b+32>>0]=4;i=f;return}if(e){g=b+44|0;h=0;do{j=(c[g>>2]|0)+(h*48|0)|0;k=d+(h*48|0)|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];k=(c[g>>2]|0)+(h*48|0)+16|0;j=d+(h*48|0)+16|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];j=(c[g>>2]|0)+(h*48|0)+32|0;k=d+(h*48|0)+32|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];h=h+1|0}while((h|0)!=(e|0))}a[b+32>>0]=e;i=f;return}function USa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=Im,w=Im,x=0,y=0,z=Im,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=Im,N=Im,O=0,P=0,Q=0,R=Im,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0;f=i;i=i+80|0;h=f+16|0;j=f;PEi(h|0,0,e|0)|0;k=(e|0)==0;if(k)l=0;else{m=ea(-3402823469999999843913219.0e14);n=0;o=0;while(1){p=ea(g[d+(n*48|0)+16>>2]);q=ea(g[d+(n*48|0)+20>>2]);r=ea(g[d+(n*48|0)+24>>2]);s=ea(ea(ea(p*p)+ea(q*q))+ea(r*r));t=s>m;u=t?n:o;n=n+1|0;if((n|0)==(e|0)){l=u;break}else{m=t?s:m;o=u}}}o=b+44|0;b=(c[o>>2]|0)+0|0;n=d+(l*48|0)+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));a[h+l>>0]=1;c[j>>2]=l;m=ea(g[d+16>>2]);s=ea(g[d+20>>2]);r=ea(g[d+24>>2]);t=c[o>>2]|0;q=ea(g[t+16>>2]);p=ea(g[t+20>>2]);v=ea(g[t+24>>2]);w=ea(m-q);m=ea(s-p);s=ea(r-v);if(e>>>0>1){r=ea(ea(ea(w*w)+ea(m*m))+ea(s*s));x=1;y=0;while(1){s=ea(g[d+(x*48|0)+16>>2]);m=ea(g[d+(x*48|0)+20>>2]);w=ea(s-q);s=ea(m-p);m=ea(ea(g[d+(x*48|0)+24>>2])-v);z=ea(ea(ea(w*w)+ea(s*s))+ea(m*m));A=z>r;B=A?x:y;x=x+1|0;if((x|0)==(e|0)){C=B;break}else{r=A?z:r;y=B}}}else C=0;b=t+48|0;n=d+(C*48|0)+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));a[h+C>>0]=1;t=j+4|0;c[t>>2]=C;y=c[o>>2]|0;r=ea(g[y+64>>2]);v=ea(g[y+68>>2]);p=ea(g[y+72>>2]);q=ea(g[y+16>>2]);z=ea(g[y+20>>2]);m=ea(g[y+24>>2]);s=ea(r-q);r=ea(v-z);v=ea(p-m);p=ea(g[y+32>>2]);w=ea(g[y+36>>2]);D=ea(g[y+40>>2]);E=ea(ea(r*D)-ea(v*w));F=ea(ea(v*p)-ea(s*D));D=ea(ea(s*w)-ea(r*p));p=ea(ea(1.0)/ea(T(ea(ea(D*D)+ea(ea(E*E)+ea(F*F))))));r=ea(E*p);E=ea(F*p);F=ea(D*p);if(k){G=ea(-3402823469999999843913219.0e14);H=ea(3402823469999999843913219.0e14);I=-1;J=-1}else{p=ea(-3402823469999999843913219.0e14);D=ea(3402823469999999843913219.0e14);x=0;B=-1;A=-1;while(1){if(!(a[h+x>>0]|0)){w=ea(g[d+(x*48|0)+16>>2]);s=ea(g[d+(x*48|0)+20>>2]);v=ea(ea(ea(r*ea(w-q))+ea(E*ea(s-z)))+ea(F*ea(ea(g[d+(x*48|0)+24>>2])-m)));K=v>p;s=K?v:p;L=K?x:B;if(D>v){M=s;N=v;O=L;P=x}else{M=s;N=D;O=L;P=A}}else{M=p;N=D;O=B;P=A}x=x+1|0;if((x|0)==(e|0)){G=M;H=N;I=O;J=P;break}else{p=M;D=N;B=O;A=P}}}b=y+96|0;n=d+(I*48|0)+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));a[h+I>>0]=1;y=j+8|0;c[y>>2]=I;if(!(ea(G*H)>ea(0.0))|k)Q=J;else{H=ea(-3402823469999999843913219.0e14);P=0;A=J;while(1){if((a[h+P>>0]|0)==0?(G=ea(g[d+(P*48|0)+16>>2]),N=ea(g[d+(P*48|0)+20>>2]),D=ea(g[d+(P*48|0)+24>>2]),J=c[o>>2]|0,M=ea(g[J+16>>2]),p=ea(g[J+20>>2]),m=ea(ea(ea(r*ea(G-M))+ea(E*ea(N-p)))+ea(F*ea(D-ea(g[J+24>>2])))),m>H):0){R=m;S=P}else{R=H;S=A}P=P+1|0;if((P|0)==(e|0)){Q=S;break}else{H=R;A=S}}}b=(c[o>>2]|0)+144|0;n=d+(Q*48|0)+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));a[h+Q>>0]=1;S=j+12|0;c[S>>2]=Q;if(k){U=l;V=C;W=I;X=Q;Y=c[o>>2]|0;Z=d+(U*48|0)|0;b=Y+0|0;n=Z+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));_=c[o>>2]|0;$=_+48|0;aa=d+(V*48|0)|0;b=$+0|0;n=aa+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));ba=c[o>>2]|0;ca=ba+96|0;da=d+(W*48|0)|0;b=ca+0|0;n=da+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));fa=c[o>>2]|0;ga=fa+144|0;ha=d+(X*48|0)|0;b=ga+0|0;n=ha+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));i=f;return}else ia=0;do{if((a[h+ia>>0]|0)==0?(R=ea(g[d+(ia*48|0)+44>>2]),H=ea(g[d+(ia*48|0)+16>>2]),F=ea(g[d+(ia*48|0)+20>>2]),E=ea(g[d+(ia*48|0)+24>>2]),Q=c[o>>2]|0,r=ea(g[Q+16>>2]),m=ea(g[Q+20>>2]),D=ea(H-r),r=ea(F-m),m=ea(E-ea(g[Q+24>>2])),p=ea(ea(ea(D*D)+ea(r*r))+ea(m*m)),I=p<ea(3402823469999999843913219.0e14),m=I?p:ea(3402823469999999843913219.0e14),p=ea(g[Q+64>>2]),r=ea(g[Q+68>>2]),D=ea(H-p),p=ea(F-r),r=ea(E-ea(g[Q+72>>2])),N=ea(ea(ea(D*D)+ea(p*p))+ea(r*r)),I=m>N,r=I?N:m,m=ea(g[Q+112>>2]),N=ea(g[Q+116>>2]),p=ea(H-m),m=ea(F-N),N=ea(E-ea(g[Q+120>>2])),D=ea(ea(ea(p*p)+ea(m*m))+ea(N*N)),C=r>D,N=ea(g[Q+160>>2]),m=ea(g[Q+164>>2]),p=ea(H-N),N=ea(F-m),m=ea(E-ea(g[Q+168>>2])),Q=(C?D:r)>ea(ea(ea(p*p)+ea(N*N))+ea(m*m)),l=j+((Q?3:C?2:I&1)<<2)|0,ea(g[d+((c[l>>2]|0)*48|0)+44>>2])>R):0)c[l>>2]=ia;ia=ia+1|0}while((ia|0)!=(e|0));U=c[j>>2]|0;V=c[t>>2]|0;W=c[y>>2]|0;X=c[S>>2]|0;Y=c[o>>2]|0;Z=d+(U*48|0)|0;b=Y+0|0;n=Z+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));_=c[o>>2]|0;$=_+48|0;aa=d+(V*48|0)|0;b=$+0|0;n=aa+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));ba=c[o>>2]|0;ca=ba+96|0;da=d+(W*48|0)|0;b=ca+0|0;n=da+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));fa=c[o>>2]|0;ga=fa+144|0;ha=d+(X*48|0)|0;b=ga+0|0;n=ha+0|0;u=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(u|0));i=f;return}function VSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=0,m=0,n=Im,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=0;f=i;i=i+64|0;h=f;PEi(h|0,0,e|0)|0;j=e>>>0>1;if(j){k=ea(g[d+44>>2]);l=1;m=0;while(1){n=ea(g[d+(l*48|0)+44>>2]);o=k>n;p=o?l:m;l=l+1|0;if((l|0)==(e|0)){q=p;break}else{k=o?n:k;m=p}}}else q=0;m=b+44|0;b=(c[m>>2]|0)+0|0;l=d+(q*48|0)+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));a[h+q>>0]=1;k=ea(g[d+16>>2]);n=ea(g[d+20>>2]);r=ea(g[d+24>>2]);q=c[m>>2]|0;s=ea(g[q+16>>2]);t=ea(g[q+20>>2]);u=ea(g[q+24>>2]);v=ea(k-s);k=ea(n-t);n=ea(r-u);if(j){r=ea(ea(ea(v*v)+ea(k*k))+ea(n*n));j=1;o=0;while(1){n=ea(g[d+(j*48|0)+16>>2]);k=ea(g[d+(j*48|0)+20>>2]);v=ea(n-s);n=ea(k-t);k=ea(ea(g[d+(j*48|0)+24>>2])-u);w=ea(ea(ea(v*v)+ea(n*n))+ea(k*k));x=w>r;y=x?j:o;j=j+1|0;if((j|0)==(e|0)){z=y;break}else{r=x?w:r;o=y}}}else z=0;b=q+48|0;l=d+(z*48|0)+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));a[h+z>>0]=1;r=ea(g[d+(z*48|0)+44>>2]);if(!e){i=f;return}else{A=0;B=z}while(1){if((a[h+A>>0]|0)==0?(q=c[m>>2]|0,u=ea(g[q+16>>2]),t=ea(g[q+20>>2]),s=ea(g[q+24>>2]),w=ea(g[d+(A*48|0)+16>>2]),k=ea(g[d+(A*48|0)+20>>2]),n=ea(g[d+(A*48|0)+24>>2]),v=ea(u-w),u=ea(t-k),t=ea(s-n),s=ea(g[q+64>>2]),C=ea(g[q+68>>2]),D=ea(s-w),w=ea(C-k),k=ea(ea(g[q+72>>2])-n),ea(ea(ea(v*v)+ea(u*u))+ea(t*t))>ea(ea(ea(D*D)+ea(w*w))+ea(k*k))):0){q=r>ea(g[d+(A*48|0)+44>>2]);E=q?A:B}else E=B;A=A+1|0;if((A|0)==(e|0))break;else B=E}if((E|0)==(z|0)){i=f;return}b=(c[m>>2]|0)+48|0;l=d+(E*48|0)+0|0;p=b+48|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(p|0));i=f;return}function WSa(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=Im,m=Im,n=0,o=0,p=0,q=Im,r=Im,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0;k=i;l=ea(g[j>>2]);m=ea(l*l);j=b+32|0;n=a[j>>0]|0;o=b+44|0;p=c[o>>2]|0;if(n<<24>>24){l=ea(g[f>>2]);q=ea(g[f+4>>2]);r=ea(g[f+8>>2]);s=n&255;t=0;while(1){u=ea(g[p+(t*48|0)+16>>2]);v=ea(g[p+(t*48|0)+20>>2]);w=ea(u-l);u=ea(v-q);v=ea(ea(g[p+(t*48|0)+24>>2])-r);x=t+1|0;if(m>ea(ea(ea(w*w)+ea(u*u))+ea(v*v))){y=5;break}if(x>>>0<s>>>0)t=x;else break}if((y|0)==5){y=p+(t*48|0)|0;c[y+0>>2]=c[e+0>>2];c[y+4>>2]=c[e+4>>2];c[y+8>>2]=c[e+8>>2];c[y+12>>2]=c[e+12>>2];y=(c[o>>2]|0)+(t*48|0)+16|0;c[y+0>>2]=c[f+0>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];c[y+12>>2]=c[f+12>>2];y=(c[o>>2]|0)+(t*48|0)+32|0;c[y+0>>2]=c[h+0>>2];c[y+4>>2]=c[h+4>>2];c[y+8>>2]=c[h+8>>2];c[y+12>>2]=c[h+12>>2];z=0;i=k;return z|0}if((n&255)<4)A=n;else{NSa(b,e,f,h)|0;z=0;i=k;return z|0}}else A=0;n=b+44|0;b=p+((A&255)*48|0)|0;c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];e=(c[n>>2]|0)+((d[j>>0]|0)*48|0)+16|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=a[j>>0]|0;a[j>>0]=f+1<<24>>24;j=(c[n>>2]|0)+((f&255)*48|0)+32|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];z=1;i=k;return z|0}function XSa(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=Im,m=Im,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=Im;k=i;l=ea(g[j>>2]);m=ea(l*l);j=b+32|0;n=a[j>>0]|0;a:do if(!(n<<24>>24))o=n&255;else{p=b+44|0;q=c[p>>2]|0;l=ea(g[f>>2]);r=ea(g[f+4>>2]);s=ea(g[f+8>>2]);t=n&255;u=0;while(1){v=ea(g[q+(u*48|0)+16>>2]);w=ea(g[q+(u*48|0)+20>>2]);x=ea(v-l);v=ea(w-r);w=ea(ea(g[q+(u*48|0)+24>>2])-s);y=u+1|0;if(m>ea(ea(ea(x*x)+ea(v*v))+ea(w*w)))break;if(y>>>0<t>>>0)u=y;else{o=t;break a}}t=q+(u*48|0)|0;c[t+0>>2]=c[e+0>>2];c[t+4>>2]=c[e+4>>2];c[t+8>>2]=c[e+8>>2];c[t+12>>2]=c[e+12>>2];t=(c[p>>2]|0)+(u*48|0)+16|0;c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];t=(c[p>>2]|0)+(u*48|0)+32|0;c[t+0>>2]=c[h+0>>2];c[t+4>>2]=c[h+4>>2];c[t+8>>2]=c[h+8>>2];c[t+12>>2]=c[h+12>>2];z=0;i=k;return z|0}while(0);if((o|0)==1|(o|0)==0){n=b+44|0;t=(c[n>>2]|0)+(o*48|0)|0;c[t+0>>2]=c[e+0>>2];c[t+4>>2]=c[e+4>>2];c[t+8>>2]=c[e+8>>2];c[t+12>>2]=c[e+12>>2];t=(c[n>>2]|0)+((d[j>>0]|0)*48|0)+16|0;c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];t=a[j>>0]|0;a[j>>0]=t+1<<24>>24;j=(c[n>>2]|0)+((t&255)*48|0)+32|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];z=1;i=k;return z|0}else if((o|0)==2){m=ea(g[f>>2]);s=ea(g[f+4>>2]);r=ea(g[f+8>>2]);o=b+44|0;b=c[o>>2]|0;l=ea(g[b+16>>2]);w=ea(g[b+20>>2]);v=ea(g[b+24>>2]);x=ea(g[b+64>>2]);A=ea(g[b+68>>2]);B=ea(l-m);l=ea(w-s);w=ea(v-r);v=ea(x-m);m=ea(A-s);s=ea(ea(g[b+72>>2])-r);if(ea(ea(ea(B*B)+ea(l*l))+ea(w*w))>ea(ea(ea(v*v)+ea(m*m))+ea(s*s))){j=b+48|0;c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];j=(c[o>>2]|0)+64|0;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];j=(c[o>>2]|0)+80|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];z=0;i=k;return z|0}else{c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];e=(c[o>>2]|0)+16|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=(c[o>>2]|0)+32|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];z=0;i=k;return z|0}}else{z=0;i=k;return z|0}return 0}function YSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(e>>>0>=3){VSa(b,d,e);a[b+32>>0]=2;i=f;return}if(e){g=b+44|0;h=0;do{j=(c[g>>2]|0)+(h*48|0)|0;k=d+(h*48|0)|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];k=(c[g>>2]|0)+(h*48|0)+16|0;j=d+(h*48|0)+16|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];j=(c[g>>2]|0)+(h*48|0)+32|0;k=d+(h*48|0)+32|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];h=h+1|0}while((h|0)!=(e|0))}a[b+32>>0]=e;i=f;return}function ZSa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=0,A=Im,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=Im,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=0,S=Im,U=Im,V=Im,W=0,X=0,Y=Im,Z=Im,_=0,$=Im,aa=Im,ba=0,ca=0,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=Im,ka=0,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=Im,ua=0,va=0,wa=Im,xa=0,ya=Im,za=0,Aa=Im,Ba=0,Ca=Im,Da=0;j=i;i=i+224|0;k=j;l=j+140|0;m=j+176|0;n=j+164|0;o=j+188|0;p=j+128|0;q=j+152|0;r=j+200|0;s=i;i=i+((1*f|0)+15&-16)|0;PEi(s|0,0,f|0)|0;t=(h|0)==0;if(t)u=-1;else{v=ea(-3402823469999999843913219.0e14);w=h;x=-1;while(1){y=c[w+48>>2]|0;z=c[w+52>>2]|0;if(y>>>0<z>>>0){A=v;B=y;y=x;while(1){C=ea(g[e+(B<<6)+16>>2]);D=ea(g[e+(B<<6)+20>>2]);E=ea(g[e+(B<<6)+24>>2]);F=ea(ea(ea(C*C)+ea(D*D))+ea(E*E));G=F>A;E=G?F:A;H=G?B:y;B=B+1|0;if(B>>>0>=z>>>0){I=E;J=H;break}else{A=E;y=H}}}else{I=v;J=x}w=c[w+16>>2]|0;if(!w){u=J;break}else{v=I;x=J}}}a[s+u>>0]=1;c[k>>2]=u;c[k+4>>2]=u;g[k+16>>2]=ea(g[e+(u<<6)+44>>2]);J=k+20|0;c[J+0>>2]=c[l+0>>2];c[J+4>>2]=c[l+4>>2];c[J+8>>2]=c[l+8>>2];l=c[h+48>>2]|0;I=ea(g[e+(l<<6)+16>>2]);v=ea(g[e+(l<<6)+20>>2]);A=ea(g[e+(l<<6)+24>>2]);E=ea(g[e+(u<<6)+16>>2]);F=ea(g[e+(u<<6)+20>>2]);D=ea(g[e+(u<<6)+24>>2]);C=ea(I-E);K=ea(v-F);L=ea(A-D);if(t){M=I;N=v;O=A;P=l}else{A=ea(ea(ea(C*C)+ea(K*K))+ea(L*L));J=l;x=h;w=l;while(1){y=c[x+52>>2]|0;if(J>>>0<y>>>0){L=A;z=J;B=w;while(1){K=ea(g[e+(z<<6)+16>>2]);C=ea(g[e+(z<<6)+20>>2]);v=ea(K-E);K=ea(C-F);C=ea(ea(g[e+(z<<6)+24>>2])-D);I=ea(ea(ea(v*v)+ea(K*K))+ea(C*C));H=I>L;C=H?I:L;G=H?z:B;z=z+1|0;if(z>>>0>=y>>>0){Q=C;R=G;break}else{L=C;B=G}}}else{Q=A;R=w}B=c[x+16>>2]|0;if(!B)break;A=Q;J=c[B+48>>2]|0;x=B;w=R}Q=ea(g[e+(R<<6)+16>>2]);A=ea(g[e+(R<<6)+20>>2]);M=Q;N=A;O=ea(g[e+(R<<6)+24>>2]);P=R}a[s+P>>0]=1;R=k+32|0;c[R>>2]=P;c[k+36>>2]=P;g[k+48>>2]=ea(g[e+(P<<6)+44>>2]);w=k+52|0;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];A=ea(M-E);Q=ea(N-F);L=ea(O-D);C=ea(g[e+(u<<6)+32>>2]);I=ea(g[e+(u<<6)+36>>2]);K=ea(g[e+(u<<6)+40>>2]);v=ea(ea(Q*K)-ea(L*I));S=ea(ea(L*C)-ea(A*K));K=ea(ea(A*I)-ea(Q*C));C=ea(ea(1.0)/ea(T(ea(ea(K*K)+ea(ea(v*v)+ea(S*S))))));Q=ea(v*C);v=ea(S*C);S=ea(K*C);a:do if(t){U=ea(-3402823469999999843913219.0e14);V=ea(3402823469999999843913219.0e14);W=-1;X=-1}else{m=l;C=ea(3402823469999999843913219.0e14);K=ea(-3402823469999999843913219.0e14);w=h;x=-1;J=-1;while(1){B=c[w+52>>2]|0;if(m>>>0<B>>>0){I=K;A=C;y=m;z=x;G=J;while(1){if(!(a[s+y>>0]|0)){L=ea(g[e+(y<<6)+16>>2]);Y=ea(g[e+(y<<6)+20>>2]);Z=ea(ea(ea(Q*ea(L-E))+ea(v*ea(Y-F)))+ea(S*ea(ea(g[e+(y<<6)+24>>2])-D)));H=Z>I;Y=H?Z:I;_=H?y:z;if(A>Z){$=Y;aa=Z;ba=_;ca=y}else{$=Y;aa=A;ba=_;ca=G}}else{$=I;aa=A;ba=z;ca=G}y=y+1|0;if(y>>>0>=B>>>0){da=$;fa=aa;ga=ba;ha=ca;break}else{I=$;A=aa;z=ba;G=ca}}}else{da=K;fa=C;ga=x;ha=J}G=c[w+16>>2]|0;if(!G){U=da;V=fa;W=ga;X=ha;break a}m=c[G+48>>2]|0;C=fa;K=da;w=G;x=ga;J=ha}}while(0);ha=s+W|0;a[ha>>0]=1;ga=k+64|0;c[ga>>2]=W;c[k+68>>2]=W;g[k+80>>2]=ea(g[e+(W<<6)+44>>2]);ca=k+84|0;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];b:do if(!(ea(U*V)>ea(0.0))|t)ia=X;else{n=l;da=ea(-3402823469999999843913219.0e14);ca=h;ba=X;while(1){J=c[ca+52>>2]|0;if(n>>>0<J>>>0){fa=da;x=n;w=ba;while(1){if((a[s+x>>0]|0)==0?(aa=ea(g[e+(x<<6)+16>>2]),$=ea(g[e+(x<<6)+20>>2]),K=ea(ea(ea(Q*ea(aa-E))+ea(v*ea($-F)))+ea(S*ea(ea(g[e+(x<<6)+24>>2])-D))),K>fa):0){ja=K;ka=x}else{ja=fa;ka=w}x=x+1|0;if(x>>>0>=J>>>0){la=ja;ma=ka;break}else{fa=ja;w=ka}}}else{la=da;ma=ba}w=c[ca+16>>2]|0;if(!w){ia=ma;break b}n=c[w+48>>2]|0;da=la;ca=w;ba=ma}}while(0);a[s+ia>>0]=1;ma=k+96|0;c[ma>>2]=ia;c[k+100>>2]=ia;g[k+112>>2]=ea(g[e+(ia<<6)+44>>2]);ka=k+116|0;c[ka+0>>2]=c[o+0>>2];c[ka+4>>2]=c[o+4>>2];c[ka+8>>2]=c[o+8>>2];if(t){na=u;oa=P;pa=W;qa=ia}else{P=l;l=h;while(1){u=l+52|0;o=c[u>>2]|0;if(P>>>0<o>>>0){la=ea(g[e+(W<<6)+16>>2]);ja=ea(g[e+(W<<6)+20>>2]);S=ea(g[e+(W<<6)+24>>2]);v=ea(g[e+(ia<<6)+16>>2]);Q=ea(g[e+(ia<<6)+20>>2]);V=ea(g[e+(ia<<6)+24>>2]);ka=o;o=P;while(1){U=ea(g[e+(o<<6)+16>>2]);da=ea(g[e+(o<<6)+20>>2]);fa=ea(g[e+(o<<6)+24>>2]);K=ea(E-U);$=ea(F-da);aa=ea(D-fa);C=ea(ea(ea(K*K)+ea($*$))+ea(aa*aa));X=C<ea(3402823469999999843913219.0e14);aa=X?C:ea(3402823469999999843913219.0e14);C=ea(M-U);$=ea(N-da);K=ea(O-fa);A=ea(ea(ea(C*C)+ea($*$))+ea(K*K));X=aa>A;K=X?A:aa;aa=ea(la-U);A=ea(ja-da);$=ea(S-fa);C=ea(ea(ea(aa*aa)+ea(A*A))+ea($*$));ba=K>C;$=ea(v-U);U=ea(Q-da);da=ea(V-fa);ca=(ba?C:K)>ea(ea(ea($*$)+ea(U*U))+ea(da*da));n=ca?3:ba?2:X&1;X=k+(n<<5)+16|0;da=ea(g[X>>2]);U=ea(g[e+(o<<6)+44>>2]);if(da>U){ba=k+(n<<5)+20|0;g[X>>2]=U;c[ba+0>>2]=c[p+0>>2];c[ba+4>>2]=c[p+4>>2];c[ba+8>>2]=c[p+8>>2];c[k+(n<<5)>>2]=o;ra=c[u>>2]|0}else ra=ka;o=o+1|0;if(o>>>0>=ra>>>0)break;else ka=ra}}ka=c[l+16>>2]|0;if(!ka)break;P=c[ka+48>>2]|0;l=ka}na=c[k>>2]|0;oa=c[R>>2]|0;pa=c[ga>>2]|0;qa=c[ma>>2]|0}ma=b+4|0;PEi(s|0,0,f|0)|0;a[s+na>>0]=1;f=d+0|0;ga=e+(na<<6)+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));O=ea(g[e+(na<<6)+44>>2]);na=O<ea(3402823469999999843913219.0e14);N=na?O:ea(3402823469999999843913219.0e14);a[s+oa>>0]=1;f=d+64|0;ga=e+(oa<<6)+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));O=ea(g[e+(oa<<6)+44>>2]);M=N>O?O:N;a[s+pa>>0]=1;f=d+128|0;ga=e+(pa<<6)+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));N=ea(g[e+(pa<<6)+44>>2]);O=M>N?N:M;a[s+qa>>0]=1;f=d+192|0;ga=e+(qa<<6)+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));M=ea(g[e+(qa<<6)+44>>2]);N=O>M?M:O;c[ma+0>>2]=c[q+0>>2];c[ma+4>>2]=c[q+4>>2];c[ma+8>>2]=c[q+8>>2];g[b>>2]=N;if(t){t=e+(W<<6)|0;f=d+256|0;ga=t+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));q=N>ea(3402823469999999843913219.0e14);O=q?ea(3402823469999999843913219.0e14):N;f=d+320|0;ga=t+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));c[ma+0>>2]=c[r+0>>2];c[ma+4>>2]=c[r+4>>2];c[ma+8>>2]=c[r+8>>2];a[ha>>0]=1;sa=O;g[b>>2]=sa;i=j;return}else{ta=ea(3402823469999999843913219.0e14);ua=h;va=W}while(1){W=c[ua+48>>2]|0;ha=c[ua+52>>2]|0;if(W>>>0<ha>>>0){O=ta;t=W;W=va;while(1){if((a[s+t>>0]|0)==0?(M=ea(g[e+(t<<6)+44>>2]),O>M):0){wa=M;xa=t}else{wa=O;xa=W}t=t+1|0;if(t>>>0>=ha>>>0){ya=wa;za=xa;break}else{O=wa;W=xa}}}else{ya=ta;za=va}ua=c[ua+16>>2]|0;if(!ua)break;else{ta=ya;va=za}}f=d+256|0;ga=e+(za<<6)+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));ta=N>ya?ya:N;c[ma+0>>2]=c[r+0>>2];c[ma+4>>2]=c[r+4>>2];c[ma+8>>2]=c[r+8>>2];a[s+za>>0]=1;N=ea(3402823469999999843913219.0e14);va=h;h=za;while(1){za=c[va+48>>2]|0;ua=c[va+52>>2]|0;if(za>>>0<ua>>>0){ya=N;xa=za;za=h;while(1){if((a[s+xa>>0]|0)==0?(wa=ea(g[e+(xa<<6)+44>>2]),ya>wa):0){Aa=wa;Ba=xa}else{Aa=ya;Ba=za}xa=xa+1|0;if(xa>>>0>=ua>>>0){Ca=Aa;Da=Ba;break}else{ya=Aa;za=Ba}}}else{Ca=N;Da=h}va=c[va+16>>2]|0;if(!va)break;else{N=Ca;h=Da}}f=d+320|0;ga=e+(Da<<6)+0|0;R=f+52|0;do{c[f>>2]=c[ga>>2];f=f+4|0;ga=ga+4|0}while((f|0)<(R|0));c[ma+0>>2]=c[r+0>>2];c[ma+4>>2]=c[r+4>>2];c[ma+8>>2]=c[r+8>>2];a[s+Da>>0]=1;sa=ta>Ca?Ca:ta;g[b>>2]=sa;i=j;return}function _Sa(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=Im,P=0,Q=0,R=0,S=0,T=0,U=Im,V=0,W=Im,X=Im,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0;j=i;i=i+48|0;k=j+36|0;l=j+24|0;m=j+12|0;n=j;o=i;i=i+((1*f|0)+15&-16)|0;PEi(o|0,0,f|0)|0;g[b>>2]=ea(3402823469999999843913219.0e14);f=b+4|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];k=(h|0)==0;if(k)p=-1;else{q=ea(3402823469999999843913219.0e14);r=h;s=-1;while(1){t=c[r+48>>2]|0;u=c[r+52>>2]|0;if(t>>>0<u>>>0){v=q;w=t;t=s;while(1){x=ea(g[e+(w<<6)+44>>2]);y=v>x;z=y?x:v;A=y?w:t;w=w+1|0;if(w>>>0>=u>>>0){B=z;C=A;break}else{v=z;t=A}}}else{B=q;C=s}r=c[r+16>>2]|0;if(!r){p=C;break}else{q=B;s=C}}}a[o+p>>0]=1;C=d+0|0;s=e+(p<<6)+0|0;r=C+52|0;do{c[C>>2]=c[s>>2];C=C+4|0;s=s+4|0}while((C|0)<(r|0));B=ea(g[e+(p<<6)+44>>2]);p=B<ea(3402823469999999843913219.0e14);q=p?B:ea(3402823469999999843913219.0e14);g[b>>2]=q;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=c[h+48>>2]|0;B=ea(g[e+(l<<6)+16>>2]);v=ea(g[e+(l<<6)+20>>2]);z=ea(g[e+(l<<6)+24>>2]);x=ea(g[d+16>>2]);D=ea(g[d+20>>2]);E=ea(g[d+24>>2]);F=ea(B-x);B=ea(v-D);v=ea(z-E);a:do if(k)G=l;else{z=ea(ea(ea(F*F)+ea(B*B))+ea(v*v));p=l;t=h;u=l;while(1){w=c[t+52>>2]|0;if(p>>>0<w>>>0){H=z;A=p;y=u;while(1){I=ea(g[e+(A<<6)+16>>2]);J=ea(g[e+(A<<6)+20>>2]);K=ea(I-x);I=ea(J-D);J=ea(ea(g[e+(A<<6)+24>>2])-E);L=ea(ea(ea(K*K)+ea(I*I))+ea(J*J));M=L>H;J=M?L:H;N=M?A:y;A=A+1|0;if(A>>>0>=w>>>0){O=J;P=N;break}else{H=J;y=N}}}else{O=z;P=u}y=c[t+16>>2]|0;if(!y){G=P;break a}z=O;p=c[y+48>>2]|0;t=y;u=P}}while(0);a[o+G>>0]=1;C=d+64|0;s=e+(G<<6)+0|0;r=C+52|0;do{c[C>>2]=c[s>>2];C=C+4|0;s=s+4|0}while((C|0)<(r|0));O=ea(g[e+(G<<6)+44>>2]);E=q>O?O:q;g[b>>2]=E;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];if(k){Q=G;R=d+128|0;S=e+(Q<<6)|0;C=R+0|0;s=S+0|0;r=C+52|0;do{c[C>>2]=c[s>>2];C=C+4|0;s=s+4|0}while((C|0)<(r|0));T=e+(Q<<6)+44|0;U=ea(g[T>>2]);V=E>U;W=V?U:E;g[b>>2]=W;c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];i=j;return}else{X=ea(3402823469999999843913219.0e14);Y=h;Z=G}while(1){G=c[Y+48>>2]|0;h=c[Y+52>>2]|0;if(G>>>0<h>>>0){q=X;k=G;G=Z;while(1){if((a[o+k>>0]|0)==0?(O=ea(g[e+(k<<6)+44>>2]),q>O):0){_=O;$=k}else{_=q;$=G}k=k+1|0;if(k>>>0>=h>>>0){aa=_;ba=$;break}else{q=_;G=$}}}else{aa=X;ba=Z}Y=c[Y+16>>2]|0;if(!Y){Q=ba;break}else{X=aa;Z=ba}}R=d+128|0;S=e+(Q<<6)|0;C=R+0|0;s=S+0|0;r=C+52|0;do{c[C>>2]=c[s>>2];C=C+4|0;s=s+4|0}while((C|0)<(r|0));T=e+(Q<<6)+44|0;U=ea(g[T>>2]);V=E>U;W=V?U:E;g[b>>2]=W;c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];i=j;return}function $Sa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=0,n=0,o=Im,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=0,V=0,W=Im,X=0;e=i;i=i+256|0;f=e;h=i;i=i+((1*d|0)+15&-16)|0;PEi(h|0,0,d|0)|0;j=(d|0)==0;if(j)k=-1;else{l=ea(3402823469999999843913219.0e14);m=0;n=-1;while(1){o=ea(g[b+(m<<6)+44>>2]);p=l>o;q=p?m:n;m=m+1|0;if((m|0)==(d|0)){k=q;break}else{l=p?o:l;n=q}}}n=f+0|0;m=b+(k<<6)+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));a[h+k>>0]=1;l=ea(g[b+16>>2]);o=ea(g[b+20>>2]);r=ea(g[b+24>>2]);s=ea(g[f+16>>2]);t=ea(g[f+20>>2]);u=ea(g[f+24>>2]);v=ea(l-s);l=ea(o-t);o=ea(r-u);if(d>>>0>1){r=ea(ea(ea(v*v)+ea(l*l))+ea(o*o));k=1;p=0;while(1){o=ea(g[b+(k<<6)+16>>2]);l=ea(g[b+(k<<6)+20>>2]);v=ea(o-s);o=ea(l-t);l=ea(ea(g[b+(k<<6)+24>>2])-u);w=ea(ea(ea(v*v)+ea(o*o))+ea(l*l));x=w>r;y=x?k:p;k=k+1|0;if((k|0)==(d|0)){z=y;break}else{r=x?w:r;p=y}}}else z=0;p=f+64|0;n=p+0|0;m=b+(z<<6)+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));a[h+z>>0]=1;r=ea(g[f+80>>2]);w=ea(g[f+84>>2]);l=ea(r-s);r=ea(w-t);w=ea(ea(g[f+88>>2])-u);o=ea(g[f+32>>2]);v=ea(g[f+36>>2]);A=ea(g[f+40>>2]);B=ea(ea(r*A)-ea(w*v));C=ea(ea(w*o)-ea(l*A));A=ea(ea(l*v)-ea(r*o));o=ea(ea(1.0)/ea(T(ea(ea(A*A)+ea(ea(B*B)+ea(C*C))))));r=ea(B*o);B=ea(C*o);C=ea(A*o);if(j){D=ea(-3402823469999999843913219.0e14);E=ea(3402823469999999843913219.0e14);F=-1;G=-1}else{o=ea(-3402823469999999843913219.0e14);A=ea(3402823469999999843913219.0e14);z=0;k=-1;y=-1;while(1){if(!(a[h+z>>0]|0)){v=ea(g[b+(z<<6)+16>>2]);l=ea(g[b+(z<<6)+20>>2]);w=ea(ea(ea(r*ea(v-s))+ea(B*ea(l-t)))+ea(C*ea(ea(g[b+(z<<6)+24>>2])-u)));x=w>o;l=x?w:o;H=x?z:k;if(A>w){I=l;J=w;K=H;L=z}else{I=l;J=A;K=H;L=y}}else{I=o;J=A;K=k;L=y}z=z+1|0;if((z|0)==(d|0)){D=I;E=J;F=K;G=L;break}else{o=I;A=J;k=K;y=L}}}a[h+F>>0]=1;L=f+128|0;n=L+0|0;m=b+(F<<6)+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));if(!(ea(D*E)>ea(0.0))|j){M=G;N=f+192|0;O=b+(M<<6)|0;n=N+0|0;m=O+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));n=b+0|0;m=f+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));P=b+64|0;n=P+0|0;m=p+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));Q=b+128|0;n=Q+0|0;m=L+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));R=b+192|0;n=R+0|0;m=N+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));i=e;return 4}else{S=ea(-3402823469999999843913219.0e14);U=0;V=G}while(1){if((a[h+U>>0]|0)==0?(E=ea(g[b+(U<<6)+16>>2]),D=ea(g[b+(U<<6)+20>>2]),J=ea(ea(ea(r*ea(E-s))+ea(B*ea(D-t)))+ea(C*ea(ea(g[b+(U<<6)+24>>2])-u))),J>S):0){W=J;X=U}else{W=S;X=V}U=U+1|0;if((U|0)==(d|0)){M=X;break}else{S=W;V=X}}N=f+192|0;O=b+(M<<6)|0;n=N+0|0;m=O+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));n=b+0|0;m=f+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));P=b+64|0;n=P+0|0;m=p+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));Q=b+128|0;n=Q+0|0;m=L+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));R=b+192|0;n=R+0|0;m=N+0|0;q=n+52|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(q|0));i=e;return 4}function aTa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=0,M=Im,N=Im,O=0,P=0,Q=0,R=Im;f=i;i=i+16|0;h=f;j=ea(g[e>>2]);k=ea(j*j);g[a>>2]=ea(0.0);e=b+384|0;l=c[e>>2]|0;if(!l){i=f;return}m=d+48|0;n=d+52|0;o=d+56|0;p=d+16|0;q=d+32|0;r=d+4|0;s=d+20|0;t=d+36|0;u=d+8|0;v=d+24|0;w=d+40|0;x=a+4|0;j=ea(0.0);y=l;while(1){y=y+-1|0;z=ea(g[m>>2]);A=ea(g[n>>2]);B=ea(g[o>>2]);C=ea(g[b+(y<<6)>>2]);D=ea(g[b+(y<<6)+4>>2]);E=ea(g[b+(y<<6)+8>>2]);F=ea(C*ea(g[d>>2]));G=ea(F+ea(D*ea(g[p>>2])));F=ea(G+ea(E*ea(g[q>>2])));G=ea(C*ea(g[r>>2]));H=ea(G+ea(D*ea(g[s>>2])));G=ea(H+ea(E*ea(g[t>>2])));H=ea(C*ea(g[u>>2]));C=ea(H+ea(D*ea(g[v>>2])));D=ea(z+F);F=ea(A+G);G=ea(B+ea(C+ea(E*ea(g[w>>2]))));E=ea(g[b+(y<<6)+16>>2]);C=ea(g[b+(y<<6)+20>>2]);B=ea(g[b+(y<<6)+24>>2]);A=ea(D-E);z=ea(F-C);H=ea(G-B);l=b+(y<<6)+32|0;I=ea(g[l>>2]);J=b+(y<<6)+36|0;K=ea(g[J>>2]);L=b+(y<<6)+40|0;M=ea(g[L>>2]);N=ea(ea(ea(A*I)+ea(z*K))+ea(H*M));H=ea(E-ea(D-ea(I*N)));D=ea(C-ea(F-ea(K*N)));F=ea(B-ea(G-ea(M*N)));if(ea(ea(F*F)+ea(ea(H*H)+ea(D*D)))>k){O=(c[e>>2]|0)+-1|0;c[e>>2]=O;P=b+(y<<6)+0|0;Q=b+(O<<6)+0|0;O=P+52|0;do{c[P>>2]=c[Q>>2];P=P+4|0;Q=Q+4|0}while((P|0)<(O|0));R=j}else{g[l>>2]=I;g[J>>2]=K;g[L>>2]=M;g[b+(y<<6)+44>>2]=N;D=j>N?N:j;g[a>>2]=D;c[x+0>>2]=c[h+0>>2];c[x+4>>2]=c[h+4>>2];c[x+8>>2]=c[h+8>>2];R=D}if(!y)break;else j=R}i=f;return}function bTa(b,e,f,h,j,k,l,m){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=0,H=0,I=0,J=0,K=Im,L=0,M=Im,N=Im,O=0,P=Im,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=Im,ha=Im,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=0,Da=Im,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=Im,Na=0,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=Im,Ya=0,Za=Im,_a=0,$a=0,ab=0,bb=0;k=i;i=i+176|0;n=k+128|0;o=k+140|0;p=k+16|0;q=k+48|0;r=k+152|0;s=k;t=k+32|0;u=k+112|0;v=b+52|0;if(!(a[v>>0]|0)){if(!j){i=k;return}w=m&255;x=p+4|0;y=0;z=0;while(1){A=c[h+(z<<2)>>2]|0;if((c[A+24>>2]|0)==(A|0)){if((y&255)>=4){B=107;break}C=d[b+(y&255)+48>>0]|0;D=b+(C*400|0)+64|0;do if((w|0)==1){g[p>>2]=ea(3402823469999999843913219.0e14);c[x+0>>2]=c[n+0>>2];c[x+4>>2]=c[n+4>>2];c[x+8>>2]=c[n+8>>2];if(!A)E=-1;else{F=ea(3402823469999999843913219.0e14);G=A;H=-1;while(1){I=c[G+48>>2]|0;J=c[G+52>>2]|0;if(I>>>0<J>>>0){K=F;L=I;I=H;while(1){M=ea(g[e+(L<<6)+44>>2]);if(K>M){g[p>>2]=M;c[x+0>>2]=c[o+0>>2];c[x+4>>2]=c[o+4>>2];c[x+8>>2]=c[o+8>>2];N=M;O=L}else{N=K;O=I}L=L+1|0;if((L|0)==(J|0)){P=N;Q=O;break}else{K=N;I=O}}}else{P=F;Q=H}G=c[G+16>>2]|0;if(!G){E=Q;break}else{F=P;H=Q}}}R=D+0|0;S=e+(E<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));c[b+(C*400|0)+448>>2]=1}else if((w|0)==3){if((c[A+56>>2]|0)>>>0<4){V=A;W=0}else{_Sa(p,D,e,f,A);c[b+(C*400|0)+448>>2]=3;break}while(1){H=c[V+48>>2]|0;G=V+52|0;if(H>>>0<(c[G>>2]|0)>>>0){I=H;H=W;while(1){J=H+1|0;R=b+(C*400|0)+(H<<6)+64|0;S=e+(I<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));I=I+1|0;if(I>>>0>=(c[G>>2]|0)>>>0){X=J;break}else H=J}}else X=W;V=c[V+16>>2]|0;if(!V)break;else W=X}c[b+(C*400|0)+448>>2]=X;H=A+32|0;c[p+0>>2]=c[H+0>>2];c[p+4>>2]=c[H+4>>2];c[p+8>>2]=c[H+8>>2];c[p+12>>2]=c[H+12>>2]}else{if((c[A+56>>2]|0)>>>0<7){Y=A;Z=0}else{ZSa(p,D,e,f,A);c[b+(C*400|0)+448>>2]=6;break}while(1){H=c[Y+48>>2]|0;G=Y+52|0;if(H>>>0<(c[G>>2]|0)>>>0){I=H;H=Z;while(1){L=H+1|0;R=b+(C*400|0)+(H<<6)+64|0;S=e+(I<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));I=I+1|0;if(I>>>0>=(c[G>>2]|0)>>>0){_=L;break}else H=L}}else _=Z;Y=c[Y+16>>2]|0;if(!Y)break;else Z=_}c[b+(C*400|0)+448>>2]=_;H=A+32|0;c[p+0>>2]=c[H+0>>2];c[p+4>>2]=c[H+4>>2];c[p+8>>2]=c[H+8>>2];c[p+12>>2]=c[H+12>>2]}while(0);F=ea(g[p>>2]);g[b+(d[b+(d[v>>0]|0)+48>>0]<<2)+32>>2]=F;A=(a[v>>0]|0)+1<<24>>24;a[v>>0]=A;$=A}else $=y;z=z+1|0;if(z>>>0>=j>>>0){B=107;break}else y=$}if((B|0)==107){i=k;return}}$=q+16|0;c[$>>2]=0;c[q+20>>2]=0;y=q+24|0;c[y>>2]=q;g[q+32>>2]=ea(3402823469999999843913219.0e14);z=q+36|0;c[z+0>>2]=c[n+0>>2];c[z+4>>2]=c[n+4>>2];c[z+8>>2]=c[n+8>>2];if(!j){i=k;return}z=m&255;m=t+4|0;p=q+48|0;_=q+52|0;Z=q+4|0;Y=q+8|0;X=q+12|0;W=s+4|0;V=0;a:while(1){aa=c[h+(V<<2)>>2]|0;b:do if((c[aa+24>>2]|0)==(aa|0)){ba=a[v>>0]|0;w=ba&255;do if(ba<<24>>24){P=ea(g[aa>>2]);N=ea(g[aa+4>>2]);F=ea(g[aa+8>>2]);K=ea(g[l>>2]);E=0;while(1){ca=b+E+48|0;da=d[ca>>0]|0;fa=b+(da*400|0)+64|0;M=ea(g[b+(da*400|0)+96>>2]);ga=ea(g[b+(da*400|0)+100>>2]);ha=ea(g[b+(da*400|0)+104>>2]);ia=b+(da*400|0)+448|0;ja=c[ia>>2]|0;if(ja>>>0>1){ka=M;la=ga;ma=ha;Q=1;while(1){na=ea(g[b+(da*400|0)+(Q<<6)+96>>2]);oa=ea(g[b+(da*400|0)+(Q<<6)+100>>2]);pa=ea(ka+na);na=ea(la+oa);oa=ea(ma+ea(g[b+(da*400|0)+(Q<<6)+104>>2]));Q=Q+1|0;if((Q|0)==(ja|0)){qa=oa;ra=na;sa=pa;break}else{ka=pa;la=na;ma=oa}}}else{qa=ha;ra=ga;sa=M}ma=ea(ea(1.0)/ea(T(ea(ea(qa*qa)+ea(ea(sa*sa)+ea(ra*ra))))));ta=ea(sa*ma);ua=ea(ra*ma);va=ea(qa*ma);E=E+1|0;if(ea(ea(ea(P*ta)+ea(ua*N))+ea(va*F))>=K)break;if(E>>>0>=w>>>0){B=60;break}}if((B|0)==60){B=0;if((ba&255)<4)break;else break a}if(!ja)wa=0;else{E=0;do{R=e+(E+f<<6)+0|0;S=b+(da*400|0)+(E<<6)+64|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));E=E+1|0;Q=c[ia>>2]|0}while(E>>>0<Q>>>0);wa=Q}c[p>>2]=f;c[_>>2]=wa+f;g[q>>2]=ta;g[Z>>2]=ua;g[Y>>2]=va;g[X>>2]=ea(0.0);c[y>>2]=aa;c[$>>2]=0;c[(c[aa+20>>2]|0)+16>>2]=q;E=aa+56|0;Q=(c[E>>2]|0)+wa|0;c[E>>2]=Q;E=aa+32|0;M=ea(g[E>>2]);L=aa+36|0;ga=ea(g[b+(d[ca>>0]<<2)+32>>2]);g[E>>2]=M>ga?ga:M;c[L+0>>2]=c[r+0>>2];c[L+4>>2]=c[r+4>>2];c[L+8>>2]=c[r+8>>2];L=(c[ia>>2]|0)+f|0;do if((z|0)==3){if(Q>>>0<4){xa=aa;ya=0}else{_Sa(s,fa,e,L,aa);c[ia>>2]=3;break}while(1){E=c[xa+48>>2]|0;O=xa+52|0;if(E>>>0<(c[O>>2]|0)>>>0){x=E;E=ya;while(1){A=E+1|0;R=b+(da*400|0)+(E<<6)+64|0;S=e+(x<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));x=x+1|0;if(x>>>0>=(c[O>>2]|0)>>>0){za=A;break}else E=A}}else za=ya;xa=c[xa+16>>2]|0;if(!xa)break;else ya=za}c[ia>>2]=za;E=aa+32|0;c[s+0>>2]=c[E+0>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];c[s+12>>2]=c[E+12>>2]}else if((z|0)==1){g[s>>2]=ea(3402823469999999843913219.0e14);c[W+0>>2]=c[n+0>>2];c[W+4>>2]=c[n+4>>2];c[W+8>>2]=c[n+8>>2];if(!aa)Aa=-1;else{M=ea(3402823469999999843913219.0e14);E=aa;O=-1;while(1){x=c[E+48>>2]|0;C=c[E+52>>2]|0;if(x>>>0<C>>>0){ga=M;D=x;x=O;while(1){ha=ea(g[e+(D<<6)+44>>2]);if(ga>ha){g[s>>2]=ha;c[W+0>>2]=c[o+0>>2];c[W+4>>2]=c[o+4>>2];c[W+8>>2]=c[o+8>>2];Ba=ha;Ca=D}else{Ba=ga;Ca=x}D=D+1|0;if((D|0)==(C|0)){Da=Ba;Ea=Ca;break}else{ga=Ba;x=Ca}}}else{Da=M;Ea=O}E=c[E+16>>2]|0;if(!E){Aa=Ea;break}else{M=Da;O=Ea}}}R=fa+0|0;S=e+(Aa<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));c[ia>>2]=1}else{if(Q>>>0<7){Fa=aa;Ga=0}else{ZSa(s,fa,e,L,aa);c[ia>>2]=6;break}while(1){O=c[Fa+48>>2]|0;E=Fa+52|0;if(O>>>0<(c[E>>2]|0)>>>0){x=O;O=Ga;while(1){C=O+1|0;R=b+(da*400|0)+(O<<6)+64|0;S=e+(x<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));x=x+1|0;if(x>>>0>=(c[E>>2]|0)>>>0){Ha=C;break}else O=C}}else Ha=Ga;Fa=c[Fa+16>>2]|0;if(!Fa)break;else Ga=Ha}c[ia>>2]=Ha;O=aa+32|0;c[s+0>>2]=c[O+0>>2];c[s+4>>2]=c[O+4>>2];c[s+8>>2]=c[O+8>>2];c[s+12>>2]=c[O+12>>2]}while(0);M=ea(g[s>>2]);g[b+(d[ca>>0]<<2)+32>>2]=M;break b}while(0);L=d[b+w+48>>0]|0;Q=b+(L*400|0)+64|0;do if((z|0)==3){if((c[aa+56>>2]|0)>>>0<4){Ia=aa;Ja=0}else{_Sa(t,Q,e,f,aa);c[b+(L*400|0)+448>>2]=3;break}while(1){O=c[Ia+48>>2]|0;E=Ia+52|0;if(O>>>0<(c[E>>2]|0)>>>0){x=O;O=Ja;while(1){A=O+1|0;R=b+(L*400|0)+(O<<6)+64|0;S=e+(x<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));x=x+1|0;if(x>>>0>=(c[E>>2]|0)>>>0){Ka=A;break}else O=A}}else Ka=Ja;Ia=c[Ia+16>>2]|0;if(!Ia)break;else Ja=Ka}c[b+(L*400|0)+448>>2]=Ka;O=aa+32|0;c[t+0>>2]=c[O+0>>2];c[t+4>>2]=c[O+4>>2];c[t+8>>2]=c[O+8>>2];c[t+12>>2]=c[O+12>>2]}else if((z|0)==1){g[t>>2]=ea(3402823469999999843913219.0e14);c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];if(!aa)La=-1;else{M=ea(3402823469999999843913219.0e14);O=aa;E=-1;while(1){x=c[O+48>>2]|0;D=c[O+52>>2]|0;if(x>>>0<D>>>0){ga=M;H=x;x=E;while(1){ha=ea(g[e+(H<<6)+44>>2]);if(ga>ha){g[t>>2]=ha;c[m+0>>2]=c[o+0>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];Ma=ha;Na=H}else{Ma=ga;Na=x}H=H+1|0;if((H|0)==(D|0)){Oa=Ma;Pa=Na;break}else{ga=Ma;x=Na}}}else{Oa=M;Pa=E}O=c[O+16>>2]|0;if(!O){La=Pa;break}else{M=Oa;E=Pa}}}R=Q+0|0;S=e+(La<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));c[b+(L*400|0)+448>>2]=1}else{if((c[aa+56>>2]|0)>>>0<7){Qa=aa;Ra=0}else{ZSa(t,Q,e,f,aa);c[b+(L*400|0)+448>>2]=6;break}while(1){E=c[Qa+48>>2]|0;O=Qa+52|0;if(E>>>0<(c[O>>2]|0)>>>0){x=E;E=Ra;while(1){D=E+1|0;R=b+(L*400|0)+(E<<6)+64|0;S=e+(x<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));x=x+1|0;if(x>>>0>=(c[O>>2]|0)>>>0){Sa=D;break}else E=D}}else Sa=Ra;Qa=c[Qa+16>>2]|0;if(!Qa)break;else Ra=Sa}c[b+(L*400|0)+448>>2]=Sa;E=aa+32|0;c[t+0>>2]=c[E+0>>2];c[t+4>>2]=c[E+4>>2];c[t+8>>2]=c[E+8>>2];c[t+12>>2]=c[E+12>>2]}while(0);M=ea(g[t>>2]);g[b+(d[b+(d[v>>0]|0)+48>>0]<<2)+32>>2]=M;a[v>>0]=(a[v>>0]|0)+1<<24>>24}while(0);V=V+1|0;if(V>>>0>=j>>>0){B=107;break}}if((B|0)==107){i=k;return}B=ba&255;ba=0;j=1;do{Oa=ea(g[b+(d[b+j+48>>0]<<2)+32>>2]);V=Oa>ea(g[b+(d[b+ba+48>>0]<<2)+32>>2]);ba=V?j:ba;j=j+1|0}while(j>>>0<B>>>0);B=b+ba+48|0;ba=d[B>>0]|0;Oa=ea(g[b+(ba<<2)+32>>2]);if(!(Oa>ea(g[aa+32>>2]))){i=k;return}j=b+(ba*400|0)+64|0;V=b+(ba*400|0)+448|0;c[V>>2]=0;do if((z|0)==3){if((c[aa+56>>2]|0)>>>0<4){Ta=aa;Ua=0}else{_Sa(u,j,e,f,aa);c[V>>2]=3;break}while(1){v=c[Ta+48>>2]|0;t=Ta+52|0;if(v>>>0<(c[t>>2]|0)>>>0){Sa=v;v=Ua;while(1){Ra=v+1|0;R=b+(ba*400|0)+(v<<6)+64|0;S=e+(Sa<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));Sa=Sa+1|0;if(Sa>>>0>=(c[t>>2]|0)>>>0){Va=Ra;break}else v=Ra}}else Va=Ua;Ta=c[Ta+16>>2]|0;if(!Ta)break;else Ua=Va}c[V>>2]=Va;v=aa+32|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2]}else if((z|0)==1){g[u>>2]=ea(3402823469999999843913219.0e14);v=u+4|0;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];if(!aa)Wa=-1;else{Oa=ea(3402823469999999843913219.0e14);t=aa;Sa=-1;while(1){Qa=c[t+48>>2]|0;La=c[t+52>>2]|0;if(Qa>>>0<La>>>0){Ma=Oa;Pa=Qa;Qa=Sa;while(1){Da=ea(g[e+(Pa<<6)+44>>2]);if(Ma>Da){g[u>>2]=Da;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];Xa=Da;Ya=Pa}else{Xa=Ma;Ya=Qa}Pa=Pa+1|0;if((Pa|0)==(La|0)){Za=Xa;_a=Ya;break}else{Ma=Xa;Qa=Ya}}}else{Za=Oa;_a=Sa}t=c[t+16>>2]|0;if(!t){Wa=_a;break}else{Oa=Za;Sa=_a}}}R=j+0|0;S=e+(Wa<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));c[V>>2]=1}else{if((c[aa+56>>2]|0)>>>0<7){$a=aa;ab=0}else{ZSa(u,j,e,f,aa);c[V>>2]=6;break}while(1){Sa=c[$a+48>>2]|0;t=$a+52|0;if(Sa>>>0<(c[t>>2]|0)>>>0){v=Sa;Sa=ab;while(1){Qa=Sa+1|0;R=b+(ba*400|0)+(Sa<<6)+64|0;S=e+(v<<6)+0|0;U=R+52|0;do{c[R>>2]=c[S>>2];R=R+4|0;S=S+4|0}while((R|0)<(U|0));v=v+1|0;if(v>>>0>=(c[t>>2]|0)>>>0){bb=Qa;break}else Sa=Qa}}else bb=ab;$a=c[$a+16>>2]|0;if(!$a)break;else ab=bb}c[V>>2]=bb;Sa=aa+32|0;c[u+0>>2]=c[Sa+0>>2];c[u+4>>2]=c[Sa+4>>2];c[u+8>>2]=c[Sa+8>>2];c[u+12>>2]=c[Sa+12>>2]}while(0);Za=ea(g[u>>2]);g[b+(d[B>>0]<<2)+32>>2]=Za;i=k;return}function cTa(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0;h=i;i=i+16|0;j=h;k=b+53|0;a[k>>0]=0;l=b+52|0;if(!(a[l>>0]|0)){m=0;n=e+4096|0;c[n>>2]=m;o=(m|0)!=0;i=h;return o|0}p=f+4|0;q=f+8|0;r=f+12|0;s=f+16|0;t=f+20|0;u=f+24|0;v=j+4|0;w=j+8|0;x=0;y=0;z=0;while(1){A=d[b+z+48>>0]|0;B=c[b+(A*400|0)+448>>2]|0;a[k>>0]=(x&255)+B;o8a(j,b+(A*400|0)+64|0,f);if((B|0)!=0&y>>>0<64){C=ea(g[j>>2]);D=ea(g[v>>2]);E=ea(g[w>>2]);F=0-B|0;B=y+-64|0;G=B>>>0<F>>>0?F:B;B=0-G|0;F=y;H=0;while(1){I=ea(g[f>>2]);J=ea(g[p>>2]);K=ea(g[q>>2]);L=ea(g[r>>2]);M=ea(g[s>>2]);N=ea(g[t>>2]);O=ea(g[u>>2]);P=ea(g[b+(A*400|0)+(H<<6)+80>>2]);Q=ea(g[b+(A*400|0)+(H<<6)+84>>2]);R=ea(g[b+(A*400|0)+(H<<6)+88>>2]);S=ea(ea(L*L)+ea(-.5));T=ea(ea(ea(I*P)+ea(J*Q))+ea(K*R));U=ea(M+ea(ea(ea(I*T)+ea(ea(S*P)+ea(L*ea(ea(J*R)-ea(K*Q)))))*ea(2.0)));M=ea(N+ea(ea(ea(J*T)+ea(ea(S*Q)+ea(L*ea(ea(K*P)-ea(I*R)))))*ea(2.0)));N=ea(O+ea(ea(ea(ea(S*R)+ea(L*ea(ea(I*Q)-ea(J*P))))+ea(K*T))*ea(2.0)));T=ea(g[b+(A*400|0)+(H<<6)+108>>2]);V=e+(F<<6)|0;g[V>>2]=C;g[V+4>>2]=D;g[V+8>>2]=E;g[V+12>>2]=ea(0.0);V=e+(F<<6)+16|0;g[V>>2]=U;g[V+4>>2]=M;g[V+8>>2]=N;g[V+12>>2]=ea(0.0);g[e+(F<<6)+12>>2]=T;c[e+(F<<6)+48>>2]=-1;c[e+(F<<6)+52>>2]=c[b+(A*400|0)+(H<<6)+112>>2];H=H+1|0;if((H|0)==(B|0))break;else F=F+1|0}W=y-G|0}else W=y;F=z+1|0;if(F>>>0>=(d[l>>0]|0)>>>0){m=W;break}x=a[k>>0]|0;y=W;z=F}n=e+4096|0;c[n>>2]=m;o=(m|0)!=0;i=h;return o|0}function dTa(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0;k=i;i=i+16|0;l=k;m=b+53|0;a[m>>0]=0;n=b+52|0;if(!(a[n>>0]|0)){o=0;p=e+4096|0;c[p>>2]=o;q=(o|0)!=0;i=k;return q|0}r=l+4|0;s=l+8|0;t=f+4|0;u=f+8|0;v=f+12|0;w=f+16|0;x=f+20|0;y=f+24|0;z=0;A=0;B=0;while(1){C=d[b+B+48>>0]|0;D=c[b+(C*400|0)+448>>2]|0;a[m>>0]=(z&255)+D;o8a(l,b+(C*400|0)+64|0,h);if((D|0)!=0&A>>>0<64){E=ea(g[l>>2]);F=ea(g[r>>2]);G=ea(g[s>>2]);H=0-D|0;D=A+-64|0;I=D>>>0<H>>>0?H:D;D=0-I|0;H=A;J=0;while(1){K=ea(g[j>>2]);L=ea(g[f>>2]);M=ea(g[t>>2]);N=ea(g[u>>2]);O=ea(g[v>>2]);P=ea(g[w>>2]);Q=ea(g[x>>2]);R=ea(g[y>>2]);S=ea(g[b+(C*400|0)+(J<<6)+64>>2]);T=ea(g[b+(C*400|0)+(J<<6)+68>>2]);U=ea(g[b+(C*400|0)+(J<<6)+72>>2]);V=ea(ea(O*O)+ea(-.5));W=ea(ea(ea(L*S)+ea(M*T))+ea(N*U));X=ea(ea(P+ea(ea(ea(L*W)+ea(ea(V*S)+ea(O*ea(ea(M*U)-ea(N*T)))))*ea(2.0)))-ea(E*K));P=ea(ea(Q+ea(ea(ea(M*W)+ea(ea(V*T)+ea(O*ea(ea(N*S)-ea(L*U)))))*ea(2.0)))-ea(F*K));Q=ea(ea(R+ea(ea(ea(ea(V*U)+ea(O*ea(ea(L*T)-ea(M*S))))+ea(N*W))*ea(2.0)))-ea(G*K));W=ea(ea(g[b+(C*400|0)+(J<<6)+108>>2])-K);Y=e+(H<<6)|0;g[Y>>2]=E;g[Y+4>>2]=F;g[Y+8>>2]=G;g[Y+12>>2]=ea(0.0);Y=e+(H<<6)+16|0;g[Y>>2]=X;g[Y+4>>2]=P;g[Y+8>>2]=Q;g[Y+12>>2]=ea(0.0);g[e+(H<<6)+12>>2]=W;c[e+(H<<6)+48>>2]=-1;c[e+(H<<6)+52>>2]=c[b+(C*400|0)+(J<<6)+112>>2];J=J+1|0;if((J|0)==(D|0))break;else H=H+1|0}Z=A-I|0}else Z=A;H=B+1|0;if(H>>>0>=(d[n>>0]|0)>>>0){o=Z;break}z=a[m>>0]|0;A=Z;B=H}p=e+4096|0;c[p>>2]=o;q=(o|0)!=0;i=k;return q|0}function eTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[a>>2]|0;if((e|0)==(d|0))c[a>>2]=b;return e|0}function fTa(a){a=a|0;var b=0;b=c[a>>2]|0;c[a>>2]=b+1;return b+1|0}function gTa(a){a=a|0;var b=0;b=c[a>>2]|0;c[a>>2]=b-1;return b+-1|0}function hTa(a,b){a=a|0;b=b|0;var d=0;d=c[a>>2]|0;c[a>>2]=d+b;return d+b|0}function iTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{e=c[a>>2]|0;f=c[a>>2]|0;if((f|0)==(e|0))c[a>>2]=(e|0)<(b|0)?b:e}while((f|0)!=(e|0));i=d;return c[a>>2]|0}function jTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{e=c[a>>2]|0;f=c[a>>2]|0;if((f|0)==(e|0))c[a>>2]=b}while((f|0)!=(e|0));i=d;return e|0}function kTa(a){a=a|0;return}function lTa(a){a=a|0;return}function mTa(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;Am(c|0)|0;_h(c|0,1)|0;Be(a|0,c|0)|0;Aj(c|0)|0;i=b;return}function nTa(a){a=a|0;var b=0;b=i;Jl(a|0)|0;i=b;return}function oTa(a){a=a|0;var b=0;b=i;pd(a|0)|0;i=b;return}function pTa(a){a=a|0;var b=0;b=i;ih(a|0)|0;i=b;return}function qTa(){return 544368}function rTa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=UJa(b,8,544376,124)|0;c[a>>2]=d;if(!d){e=d;f=e+4|0;c[f>>2]=0;i=b;return}p8a(d,b+1|0);e=c[a>>2]|0;f=e+4|0;c[f>>2]=0;i=b;return}function sTa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=c[a>>2]|0;Jl(c[d>>2]|0)|0;e=c[d>>2]|0;if(e){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}VJa(b,c[a>>2]|0);i=b;return}function tTa(a){a=a|0;var b=0;b=i;pd(c[c[a>>2]>>2]|0)|0;fTa((c[a>>2]|0)+4|0)|0;ih(c[c[a>>2]>>2]|0)|0;i=b;return}function uTa(a){a=a|0;var b=0,d=0;b=i;pd(c[c[a>>2]>>2]|0)|0;d=(c[a>>2]|0)+4|0;do{}while((c[d>>2]|0)!=0);i=b;return}function vTa(a){a=a|0;var b=0;b=i;gTa((c[a>>2]|0)+4|0)|0;i=b;return}function wTa(a){a=a|0;var b=0;b=i;ih(c[c[a>>2]>>2]|0)|0;i=b;return}function xTa(a){a=a|0;return}function yTa(a){a=a|0;return}function zTa(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;return}function ATa(a){a=a|0;return}function BTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+4|0;f=c[e>>2]|0;c[e>>2]=1;if(f)while(1){if(c[e>>2]|0)continue;f=c[e>>2]|0;c[e>>2]=1;if(!f)break}c[b>>2]=c[a>>2];c[a>>2]=b;c[e>>2]=0;i=d;return}function CTa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=1;if(e)while(1){if(c[d>>2]|0)continue;e=c[d>>2]|0;c[d>>2]=1;if(!e)break}e=c[a>>2]|0;if(!e){c[d>>2]=0;i=b;return e|0}c[a>>2]=c[e>>2];c[d>>2]=0;i=b;return e|0}function DTa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=1;if(e)while(1){if(c[d>>2]|0)continue;e=c[d>>2]|0;c[d>>2]=1;if(!e)break}e=c[a>>2]|0;c[a>>2]=0;c[d>>2]=0;i=b;return e|0}function ETa(){return 544704}function FTa(){return 544712}function GTa(b){b=b|0;var d=0;d=i;Be(b|0,0)|0;ui(b+24|0,0)|0;a[b+76>>0]=0;c[b+72>>2]=0;i=d;return}function HTa(a){a=a|0;var b=0;b=i;nf(a+24|0)|0;Jl(a|0)|0;i=b;return}function ITa(b){b=b|0;var c=0;c=i;pd(b|0)|0;a[b+76>>0]=0;ih(b|0)|0;i=c;return}function JTa(b){b=b|0;var d=0,e=0;d=i;pd(b|0)|0;e=b+76|0;if(a[e>>0]|0){ih(b|0)|0;i=d;return}a[e>>0]=1;e=b+72|0;c[e>>2]=(c[e>>2]|0)+1;Pl(b+24|0)|0;ih(b|0)|0;i=d;return}function KTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+8|0;g=e;pd(b|0)|0;h=b+72|0;j=c[h>>2]|0;k=b+76|0;a:do if(!(a[k>>0]|0))if((d|0)==-1){l=b+24|0;do{if(a[k>>0]|0)break a;if((j|0)!=(c[h>>2]|0))break a}while((td(l|0,b|0)|0)==0)}else{Mi(g|0,0)|0;l=(d>>>0)/1e3|0;m=((da(l,-1e3)|0)+d|0)*1e3|0;n=m+(c[g+4>>2]|0)|0;m=(n>>>0)/1e6|0;o=n+(da(m,-1e6)|0)|0;c[f>>2]=m+l+(c[g>>2]|0);c[f+4>>2]=o*1e3;o=b+24|0;do{if(a[k>>0]|0)break a;if((j|0)!=(c[h>>2]|0))break a}while((Rc(o|0,b|0,f|0)|0)==0)}while(0);if(a[k>>0]|0){p=1;ih(b|0)|0;i=e;return p|0}p=(j|0)!=(c[h>>2]|0);ih(b|0)|0;i=e;return p|0}function LTa(){var a=0,b=0;a=i;b=pe()|0;i=a;return b|0}function MTa(){var a=0,b=0;a=i;i=i+16|0;b=a;Cg(b|0,0)|0;i=a;return c[b>>2]|0}function NTa(a){a=a|0;var b=0;b=i;vc(a|0)|0;i=b;return}function OTa(a){a=a|0;var b=0,c=0;b=i;c=Fd(a|0)|0;i=b;return c|0}function PTa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Tj(a|0,b|0)|0)==0&1;i=c;return d|0}function QTa(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;Oh(0,b|0)|0;d=c[b>>2]|0;e=gFi(d|0,((d|0)<0)<<31>>31|0,1e9,0)|0;d=c[b+4>>2]|0;b=_Ei(e|0,H|0,d|0,((d|0)<0)<<31>>31|0)|0;i=a;return b|0}function RTa(){var a=0;a=i;PEi(424576,1,1024)|0;c[106400]=0;c[106401]=0;c[106402]=0;c[106403]=0;i=a;return}function STa(){var b=0,d=0;b=i;g[119914]=ea(1.1920929e-07);g[119915]=ea(1.1920929e-07);g[119916]=ea(1.1920929e-07);g[119917]=ea(1.1920929e-07);g[119918]=ea(3402823469999999843913219.0e14);g[119919]=ea(3402823469999999843913219.0e14);g[119920]=ea(3402823469999999843913219.0e14);g[119921]=ea(3402823469999999843913219.0e14);c[119922]=-1;c[119923]=0;c[119924]=0;c[119925]=0;c[119926]=0;c[119927]=0;c[119928]=-1;c[119929]=0;c[119930]=0;c[119931]=0;c[119932]=0;c[119933]=-1;c[119934]=0;c[119935]=0;c[119936]=0;c[119937]=0;g[119938]=ea(1.0);g[119939]=ea(1.0);g[119940]=ea(1.0);g[119941]=ea(1.0);g[119942]=ea(-1.0);g[119943]=ea(-1.0);g[119944]=ea(-1.0);g[119945]=ea(-1.0);g[119946]=ea(.5);g[119947]=ea(.5);g[119948]=ea(.5);g[119949]=ea(.5);g[119950]=ea(1.0);g[119951]=ea(1.0);g[119952]=ea(1.0);g[119953]=ea(0.0);g[119954]=ea(7.99900007);g[119955]=ea(7.99900007);g[119956]=ea(7.99900007);g[119957]=ea(7.99900007);g[119958]=ea(.0000999999974);g[119959]=ea(.0000999999974);g[119960]=ea(.0000999999974);g[119961]=ea(.0000999999974);g[119962]=ea(-3402823469999999843913219.0e14);g[119963]=ea(-3402823469999999843913219.0e14);g[119964]=ea(-3402823469999999843913219.0e14);g[119965]=ea(0.0);if(a[479880]|0){i=b;return}g[119966]=ea(.949999988);g[119967]=ea(.949999988);g[119968]=ea(.949999988);g[119969]=ea(.949999988);d=479880;c[d>>2]=1;c[d+4>>2]=0;i=b;return}function TTa(){c[120264]=-1;c[120265]=-1;c[120266]=-1;c[120267]=0;c[120268]=0;c[120269]=0;c[120270]=0;c[120271]=-1;g[120272]=ea(1.1920929e-07);g[120273]=ea(1.1920929e-07);g[120274]=ea(1.1920929e-07);g[120275]=ea(1.1920929e-07);g[120276]=ea(-3402823469999999843913219.0e14);g[120277]=ea(-3402823469999999843913219.0e14);g[120278]=ea(-3402823469999999843913219.0e14);g[120279]=ea(0.0);return}function UTa(){c[120280]=-1;c[120281]=-1;c[120282]=-1;c[120283]=0;g[120284]=ea(1.1920929e-07);g[120285]=ea(1.1920929e-07);g[120286]=ea(1.1920929e-07);g[120287]=ea(1.1920929e-07);return}function VTa(){c[120496]=0;c[120497]=0;c[120498]=0;c[120499]=-1;c[120500]=-1;c[120501]=-1;c[120502]=0;c[120503]=0;c[120504]=-1;c[120505]=-1;c[120506]=-1;c[120507]=0;c[120508]=0;c[120509]=-1;c[120510]=-1;c[120511]=-1;g[120512]=ea(1.1920929e-07);g[120513]=ea(1.1920929e-07);g[120514]=ea(1.1920929e-07);g[120515]=ea(1.1920929e-07);g[120516]=ea(-1.0);g[120517]=ea(-1.0);g[120518]=ea(-1.0);g[120519]=ea(1.0);g[120520]=ea(0.0);g[120521]=ea(0.0);g[120522]=ea(0.0);g[120523]=ea(3402823469999999843913219.0e14);g[120524]=ea(-3402823469999999843913219.0e14);g[120525]=ea(-3402823469999999843913219.0e14);g[120526]=ea(-3402823469999999843913219.0e14);g[120527]=ea(0.0);return}function WTa(){var a=0,b=0;a=i;b=0;do{c[494600+(b<<2)>>2]=b;b=b+1|0}while((b|0)!=512);i=a;return}function XTa(){c[132282]=530720;c[132283]=65536;c[132284]=530744;c[132285]=65537;c[132286]=530776;c[132287]=65538;c[132288]=530808;c[132289]=65539;c[132290]=530832;c[132291]=65540;c[132292]=530856;c[132293]=65541;c[132294]=530888;c[132295]=65542;c[132296]=530920;c[132297]=65543;c[132298]=530960;c[132299]=65544;c[132300]=530992;c[132301]=65545;c[132302]=531024;c[132303]=65546;c[132304]=531048;c[132305]=65547;c[132306]=531072;c[132307]=65548;c[132308]=531096;c[132309]=65549;c[132310]=531120;c[132311]=65550;c[132312]=531152;c[132313]=65551;c[132314]=531176;c[132315]=65552;c[132316]=531200;c[132317]=65553;c[132318]=531224;c[132319]=65554;c[132320]=531256;c[132321]=65555;c[132322]=531280;c[132323]=65556;c[132324]=531312;c[132325]=65557;c[132326]=531344;c[132327]=65558;c[132328]=531376;c[132329]=65559;c[132330]=531408;c[132331]=65560;c[132332]=531440;c[132333]=65561;c[132334]=531472;c[132335]=65562;c[132336]=531504;c[132337]=65563;c[132338]=531544;c[132339]=65564;c[132340]=531576;c[132341]=65565;c[132342]=531616;c[132343]=65566;c[132344]=531656;c[132345]=65567;c[132346]=531680;c[132347]=65568;c[132348]=531712;c[132349]=65569;c[132350]=531744;c[132351]=65570;c[132352]=531776;c[132353]=65571;c[132354]=531808;c[132355]=65572;c[132356]=531848;c[132357]=65573;c[132358]=531896;c[132359]=65574;c[132360]=531928;c[132361]=65575;c[132362]=531976;c[132363]=65576;c[132364]=532024;c[132365]=65577;c[132366]=532080;c[132367]=65578;c[132368]=532136;c[132369]=65579;c[132370]=532184;c[132371]=65580;c[132372]=532208;c[132373]=65581;c[132374]=532224;c[132375]=65582;c[132376]=532248;c[132377]=65583;c[132378]=532272;c[132379]=65584;c[132380]=532288;c[132381]=65585;c[132382]=532312;c[132383]=65586;c[132384]=532336;c[132385]=65587;c[132386]=532360;c[132387]=65588;c[132388]=532384;c[132389]=53;c[132390]=532408;c[132391]=54;c[132392]=532440;c[132393]=55;c[132394]=532464;c[132395]=56;c[132396]=532496;c[132397]=57;c[132398]=532520;c[132399]=58;c[132400]=532552;c[132401]=59;c[132402]=532584;c[132403]=60;c[132404]=532616;c[132405]=65597;c[132406]=532640;c[132407]=65598;c[132408]=532664;c[132409]=65599;c[132410]=532688;c[132411]=65600;c[132412]=532712;c[132413]=65601;c[132414]=532728;c[132415]=65602;c[132416]=532744;c[132417]=65603;c[132418]=532768;c[132419]=65604;c[132420]=532792;c[132421]=65605;c[132422]=532816;c[132423]=65606;c[132424]=532840;c[132425]=65607;c[132426]=532864;c[132427]=65608;c[132428]=532880;c[132429]=65609;c[132430]=532904;c[132431]=65610;c[132432]=532936;c[132433]=65611;c[132434]=532960;c[132435]=65612;c[132436]=532984;c[132437]=65613;c[132438]=533016;c[132439]=65614;c[132440]=533048;c[132441]=65615;c[132442]=533080;c[132443]=65616;c[132444]=533104;c[132445]=65617;c[132446]=533128;c[132447]=65618;c[132448]=533152;c[132449]=65619;c[132450]=533168;c[132451]=65620;c[132452]=533184;c[132453]=65621;c[132454]=533200;c[132455]=65622;c[132456]=533224;c[132457]=65623;c[132458]=533248;c[132459]=65624;c[132460]=533272;c[132461]=65625;c[132462]=533304;c[132463]=65626;c[132464]=533328;c[132465]=65627;c[132466]=533344;c[132467]=65628;c[132468]=533368;c[132469]=65629;c[132470]=533392;c[132471]=65630;c[132472]=533416;c[132473]=65631;c[132474]=533448;c[132475]=65632;c[132476]=533472;c[132477]=65633;c[132478]=533496;c[132479]=65634;c[132480]=533520;c[132481]=65635;c[132482]=533536;c[132483]=65636;c[132484]=533560;c[132485]=65637;c[132486]=533576;c[132487]=65638;c[132488]=533592;c[132489]=65639;c[132490]=533616;c[132491]=65640;c[132492]=533648;c[132493]=65641;c[132494]=533680;c[132495]=65642;c[132496]=533704;c[132497]=65643;c[132498]=533736;c[132499]=65644;c[132500]=533760;c[132501]=65645;c[132502]=533800;c[132503]=65646;c[132504]=533832;c[132505]=65647;c[132506]=533856;c[132507]=65648;c[132508]=533888;c[132509]=65649;c[132510]=533904;c[132511]=65650;c[132512]=533936;c[132513]=65651;c[132514]=533960;c[132515]=65652;c[132516]=533992;c[132517]=65653;c[132518]=534024;c[132519]=65654;c[132520]=534072;c[132521]=65655;c[132522]=534112;c[132523]=65656;c[132524]=534128;c[132525]=65657;c[132526]=534152;c[132527]=65658;c[132528]=534176;c[132529]=65659;c[132530]=534200;c[132531]=65660;c[132532]=534216;c[132533]=65661;c[132534]=534240;c[132535]=65662;c[132536]=534272;c[132537]=65663;c[132538]=534304;c[132539]=65664;c[132540]=534336;c[132541]=65665;c[132542]=534360;c[132543]=65666;c[132544]=534384;c[132545]=65667;c[132546]=534408;c[132547]=65668;c[132548]=534440;c[132549]=65669;c[132550]=534472;c[132551]=65670;c[132552]=534504;c[132553]=65671;c[132554]=534528;c[132555]=65672;c[132556]=534560;c[132557]=65673;c[132558]=534592;c[132559]=65674;c[132560]=534624;c[132561]=65675;c[132562]=534664;c[132563]=65676;c[132564]=534704;c[132565]=65677;c[132566]=534736;c[132567]=65678;c[132568]=534768;c[132569]=65679;c[132570]=534800;c[132571]=65680;c[132572]=534832;c[132573]=65681;c[132574]=534864;c[132575]=65682;c[132576]=534896;c[132577]=65683;c[132578]=534928;c[132579]=65684;c[132580]=534968;c[132581]=65685;c[132582]=535008;c[132583]=65686;c[132584]=535040;c[132585]=65687;c[132586]=535080;c[132587]=65688;c[132588]=535112;c[132589]=65689;c[132590]=535136;c[132591]=65690;c[132592]=535176;c[132593]=65691;c[132594]=535216;c[132595]=65692;c[132596]=535248;c[132597]=65693;c[132598]=535280;c[132599]=65694;c[132600]=535312;c[132601]=65695;c[132602]=535336;c[132603]=65696;c[132604]=535368;c[132605]=65697;c[132606]=535392;c[132607]=65698;c[132608]=535424;c[132609]=65699;c[132610]=535448;c[132611]=65700;c[132612]=535480;c[132613]=65701;c[132614]=535504;c[132615]=65702;c[132616]=535536;c[132617]=65703;c[132618]=535568;c[132619]=65704;c[132620]=535608;c[132621]=65705;c[132622]=535648;c[132623]=65706;c[132624]=535672;c[132625]=65707;c[132626]=535696;c[132627]=65708;c[132628]=535720;c[132629]=65709;c[132630]=535760;c[132631]=65710;c[132632]=535792;c[132633]=65711;c[132634]=535832;c[132635]=65712;c[132636]=535872;c[132637]=65713;c[132638]=535904;c[132639]=65714;c[132640]=535928;c[132641]=65715;c[132642]=535952;c[132643]=65716;c[132644]=535976;c[132645]=65717;c[132646]=536e3;c[132647]=65718;c[132648]=536024;c[132649]=65719;c[132650]=536056;c[132651]=65720;c[132652]=536072;c[132653]=65721;c[132654]=536096;c[132655]=65722;c[132656]=536128;c[132657]=65723;c[132658]=536160;c[132659]=65724;c[132660]=536184;c[132661]=65725;c[132662]=536208;c[132663]=65726;c[132664]=536240;c[132665]=65727;c[132666]=536280;c[132667]=65728;c[132668]=536312;c[132669]=65729;c[132670]=536360;c[132671]=65730;c[132672]=536408;c[132673]=65731;c[132674]=536448;c[132675]=65732;c[132676]=536480;c[132677]=65733;c[132678]=536520;c[132679]=65734;c[134140]=199;c[134141]=529128;c[134142]=65550;c[134144]=65559;c[134146]=65560;c[134148]=65561;c[134150]=65569;c[134152]=65570;c[134154]=65581;c[134156]=65607;c[134158]=65608;c[134160]=65609;c[134162]=65610;c[134164]=65637;c[134166]=65654;c[134168]=65656;c[134170]=65657;c[134172]=65658;c[134174]=65659;c[134176]=65679;c[134178]=65680;c[134180]=65681;c[134182]=65682;c[134184]=65683;c[134186]=65684;c[134188]=65685;c[134190]=65686;c[134192]=65687;c[134194]=65688;c[134196]=65689;c[134198]=65706;c[134200]=65707;c[134202]=65708;c[134204]=65709;c[134206]=65710;c[134208]=65711;c[134210]=65713;return}function YTa(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)yUa(a,b);c[a+4>>2]=b;i=d;return}function ZTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*56|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?421168:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*56|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];g[k+24>>2]=ea(g[l+24>>2]);g[k+28>>2]=ea(g[l+28>>2]);g[k+32>>2]=ea(g[l+32>>2]);c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];g[k+36>>2]=ea(g[l+36>>2]);g[k+40>>2]=ea(g[l+40>>2]);g[k+44>>2]=ea(g[l+44>>2]);g[k+48>>2]=ea(g[l+48>>2]);c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2]}k=k+56|0;if(k>>>0>=j>>>0)break;else l=l+56|0}o=c[m>>2]|0}else o=f;f=n+(o*56|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];g[n+(o*56|0)+24>>2]=ea(g[b+24>>2]);g[n+(o*56|0)+28>>2]=ea(g[b+28>>2]);g[n+(o*56|0)+32>>2]=ea(g[b+32>>2]);c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];g[n+(o*56|0)+36>>2]=ea(g[b+36>>2]);g[n+(o*56|0)+40>>2]=ea(g[b+40>>2]);g[n+(o*56|0)+44>>2]=ea(g[b+44>>2]);g[n+(o*56|0)+48>>2]=ea(g[b+48>>2]);c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*56|0)|0;i=d;return r|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*56|0)|0;i=d;return r|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*56|0)|0;i=d;return r|0}function _Ta(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?421288:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function $Ta(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*56|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?421040:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*56|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=j+0|0;o=k+0|0;p=n+56|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0))}j=j+56|0;if(j>>>0>=h>>>0)break;else k=k+56|0}q=c[l>>2]|0}else q=f;f=m+(q*56|0)|0;if(f){n=f+0|0;o=b+0|0;p=n+56|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0))}if((c[e>>2]|0)>-1?(o=c[a>>2]|0,(o|0)!=0):0){n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,o)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g*56|0)|0}function aUa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0;h=i;i=i+80|0;j=h+60|0;k=h+48|0;l=h+36|0;m=h;n=a+44|0;b[n>>1]=(b[n>>1]|0)+1<<16>>16;if(!(XPa(a+16|0,a+28|0,d,e,f)|0)){i=h;return}o=ea(g[d>>2]);p=ea(g[e>>2]);q=ea(o-p);r=ea(g[d+4>>2]);s=ea(g[e+4>>2]);t=ea(r-s);u=ea(g[d+8>>2]);v=ea(g[e+8>>2]);w=ea(u-v);x=ea(g[f>>2]);y=ea(p-x);z=ea(g[f+4>>2]);A=ea(s-z);B=ea(g[f+8>>2]);C=ea(v-B);D=ea(x-o);E=ea(z-r);F=ea(B-u);G=ea(g[a+40>>2]);n=(ea(ea(ea(y*y)+ea(A*A))+ea(C*C))>G&1)<<1|ea(ea(ea(q*q)+ea(t*t))+ea(w*w))>G|(ea(ea(ea(D*D)+ea(E*E))+ea(F*F))>G&1)<<2;G=ea(ea(r+s)*ea(.5));F=ea(ea(u+v)*ea(.5));g[j>>2]=ea(ea(o+p)*ea(.5));g[j+4>>2]=G;g[j+8>>2]=F;F=ea(ea(s+z)*ea(.5));G=ea(ea(v+B)*ea(.5));g[k>>2]=ea(ea(p+x)*ea(.5));g[k+4>>2]=F;g[k+8>>2]=G;G=ea(ea(z+r)*ea(.5));F=ea(ea(B+u)*ea(.5));g[l>>2]=ea(ea(x+o)*ea(.5));g[l+4>>2]=G;g[l+8>>2]=F;switch(n|0){case 0:{n=c[a+8>>2]|0;g[m>>2]=o;g[m+4>>2]=r;g[m+8>>2]=u;g[m+12>>2]=p;g[m+16>>2]=s;g[m+20>>2]=v;g[m+24>>2]=x;g[m+28>>2]=z;g[m+32>>2]=B;H=n+4|0;I=c[H>>2]|0;if((c[n+8>>2]&2147483647)>>>0>I>>>0){J=c[n>>2]|0;K=J+(I*36|0)|0;if(K){g[K>>2]=o;g[J+(I*36|0)+4>>2]=r;g[J+(I*36|0)+8>>2]=u;g[J+(I*36|0)+12>>2]=p;g[J+(I*36|0)+16>>2]=s;g[J+(I*36|0)+20>>2]=v;g[J+(I*36|0)+24>>2]=x;g[J+(I*36|0)+28>>2]=z;g[J+(I*36|0)+32>>2]=B}c[H>>2]=I+1}else eUa(n,m)|0;m=c[a+12>>2]|0;n=a+4|0;I=m+4|0;H=c[I>>2]|0;if((c[m+8>>2]&2147483647)>>>0>H>>>0){J=(c[m>>2]|0)+(H<<2)|0;if(!J)L=H;else{c[J>>2]=c[n>>2];L=c[I>>2]|0}c[I>>2]=L+1}else cUa(m,n)|0;c[a>>2]=(c[a>>2]|0)+1;i=h;return}case 4:{aUa(a,d,e,l);aUa(a,e,f,l);i=h;return}case 5:{aUa(a,d,j,l);aUa(a,j,e,l);aUa(a,l,e,f);i=h;return}case 3:{aUa(a,d,j,k);aUa(a,d,k,f);aUa(a,j,e,k);i=h;return}case 1:{aUa(a,d,j,f);aUa(a,j,e,f);i=h;return}case 2:{aUa(a,d,e,k);aUa(a,d,k,f);i=h;return}case 6:{aUa(a,d,e,k);aUa(a,d,k,l);aUa(a,l,k,f);i=h;return}case 7:{aUa(a,d,j,l);aUa(a,j,e,k);aUa(a,l,k,f);aUa(a,j,k,l);i=h;return}default:{i=h;return}}}function bUa(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)JAb(a,b);c[a+4>>2]=b;i=d;return}function cUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?541832:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}n=c[l>>2]|0}else n=f;f=m+(n<<2)|0;if(f)c[f>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<2)|0}function dUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=Im,t=0,u=Im,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=0,C=Im,D=Im,E=0,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;f=i;i=i+80|0;h=f+40|0;j=f+4|0;k=f;l=ea(g[a+44>>2]);if(l==ea(0.0)){m=0;i=f;return m|0}n=b+12|0;o=ea(g[n>>2]);p=ea(g[b>>2]);q=ea(o-p);r=b+16|0;s=ea(g[r>>2]);t=b+4|0;u=ea(g[t>>2]);v=ea(s-u);w=b+20|0;x=ea(g[w>>2]);y=b+8|0;z=ea(g[y>>2]);A=ea(x-z);B=b+24|0;C=ea(g[B>>2]);D=ea(C-p);E=b+28|0;F=ea(g[E>>2]);G=ea(F-u);H=b+32|0;I=ea(g[H>>2]);J=ea(I-z);K=ea(ea(v*J)-ea(A*G));L=ea(ea(A*D)-ea(q*J));J=ea(ea(q*G)-ea(v*D));D=ea(T(ea(ea(J*J)+ea(ea(K*K)+ea(L*L)))));if(D>ea(0.0)){v=ea(ea(1.0)/D);M=ea(K*v);N=ea(L*v);O=ea(J*v)}else{M=K;N=L;O=J}J=ea(g[a+32>>2]);L=ea(g[a+20>>2]);K=ea(M*L);M=ea(g[a+24>>2]);v=ea(K+ea(N*M));N=ea(g[a+28>>2]);K=ea(v+ea(O*N));if(!(K>=ea(0.0)&K<J)){m=0;i=f;return m|0}J=ea(l*L);L=ea(l*M);M=ea(l*N);N=ea(J+p);l=ea(L+u);K=ea(M+z);O=ea(J+o);v=ea(L+s);D=ea(M+x);G=ea(J+C);C=ea(L+F);F=ea(M+I);g[h>>2]=p;g[h+4>>2]=u;g[h+8>>2]=z;g[h+12>>2]=o;g[h+16>>2]=s;g[h+20>>2]=x;g[h+24>>2]=N;g[h+28>>2]=l;g[h+32>>2]=K;a=d+8|0;P=c[a>>2]|0;Q=d+4|0;R=c[Q>>2]|0;if((P&2147483647)>>>0>R>>>0){S=c[d>>2]|0;U=S+(R*36|0)|0;if(U){g[U>>2]=p;g[S+(R*36|0)+4>>2]=u;g[S+(R*36|0)+8>>2]=z;g[S+(R*36|0)+12>>2]=o;g[S+(R*36|0)+16>>2]=s;g[S+(R*36|0)+20>>2]=x;g[S+(R*36|0)+24>>2]=N;g[S+(R*36|0)+28>>2]=l;g[S+(R*36|0)+32>>2]=K}S=R+1|0;c[Q>>2]=S;V=P;W=S}else{eUa(d,h)|0;V=c[a>>2]|0;W=c[Q>>2]|0}g[j>>2]=N;g[j+4>>2]=l;g[j+8>>2]=K;x=ea(g[n>>2]);g[j+12>>2]=x;s=ea(g[r>>2]);g[j+16>>2]=s;o=ea(g[w>>2]);g[j+20>>2]=o;g[j+24>>2]=O;g[j+28>>2]=v;g[j+32>>2]=D;if((V&2147483647)>>>0>W>>>0){S=c[d>>2]|0;P=S+(W*36|0)|0;if(P){g[P>>2]=N;g[S+(W*36|0)+4>>2]=l;g[S+(W*36|0)+8>>2]=K;g[S+(W*36|0)+12>>2]=x;g[S+(W*36|0)+16>>2]=s;g[S+(W*36|0)+20>>2]=o;g[S+(W*36|0)+24>>2]=O;g[S+(W*36|0)+28>>2]=v;g[S+(W*36|0)+32>>2]=D}S=W+1|0;c[Q>>2]=S;X=V;Y=S}else{eUa(d,j)|0;X=c[a>>2]|0;Y=c[Q>>2]|0}g[h>>2]=O;g[h+4>>2]=v;g[h+8>>2]=D;o=ea(g[n>>2]);g[h+12>>2]=o;s=ea(g[r>>2]);g[h+16>>2]=s;x=ea(g[w>>2]);g[h+20>>2]=x;g[h+24>>2]=G;g[h+28>>2]=C;g[h+32>>2]=F;if((X&2147483647)>>>0>Y>>>0){S=c[d>>2]|0;V=S+(Y*36|0)|0;if(V){g[V>>2]=O;g[S+(Y*36|0)+4>>2]=v;g[S+(Y*36|0)+8>>2]=D;g[S+(Y*36|0)+12>>2]=o;g[S+(Y*36|0)+16>>2]=s;g[S+(Y*36|0)+20>>2]=x;g[S+(Y*36|0)+24>>2]=G;g[S+(Y*36|0)+28>>2]=C;g[S+(Y*36|0)+32>>2]=F}S=Y+1|0;c[Q>>2]=S;Z=X;_=S}else{eUa(d,h)|0;Z=c[a>>2]|0;_=c[Q>>2]|0}g[j>>2]=G;g[j+4>>2]=C;g[j+8>>2]=F;x=ea(g[n>>2]);g[j+12>>2]=x;s=ea(g[r>>2]);g[j+16>>2]=s;o=ea(g[w>>2]);g[j+20>>2]=o;D=ea(g[B>>2]);g[j+24>>2]=D;v=ea(g[E>>2]);g[j+28>>2]=v;O=ea(g[H>>2]);g[j+32>>2]=O;if((Z&2147483647)>>>0>_>>>0){w=c[d>>2]|0;r=w+(_*36|0)|0;if(r){g[r>>2]=G;g[w+(_*36|0)+4>>2]=C;g[w+(_*36|0)+8>>2]=F;g[w+(_*36|0)+12>>2]=x;g[w+(_*36|0)+16>>2]=s;g[w+(_*36|0)+20>>2]=o;g[w+(_*36|0)+24>>2]=D;g[w+(_*36|0)+28>>2]=v;g[w+(_*36|0)+32>>2]=O}w=_+1|0;c[Q>>2]=w;$=Z;aa=w}else{eUa(d,j)|0;$=c[a>>2]|0;aa=c[Q>>2]|0}g[h>>2]=N;g[h+4>>2]=l;g[h+8>>2]=K;O=ea(g[B>>2]);g[h+12>>2]=O;v=ea(g[E>>2]);g[h+16>>2]=v;D=ea(g[H>>2]);g[h+20>>2]=D;o=ea(g[b>>2]);g[h+24>>2]=o;s=ea(g[t>>2]);g[h+28>>2]=s;x=ea(g[y>>2]);g[h+32>>2]=x;if(($&2147483647)>>>0>aa>>>0){y=c[d>>2]|0;t=y+(aa*36|0)|0;if(t){g[t>>2]=N;g[y+(aa*36|0)+4>>2]=l;g[y+(aa*36|0)+8>>2]=K;g[y+(aa*36|0)+12>>2]=O;g[y+(aa*36|0)+16>>2]=v;g[y+(aa*36|0)+20>>2]=D;g[y+(aa*36|0)+24>>2]=o;g[y+(aa*36|0)+28>>2]=s;g[y+(aa*36|0)+32>>2]=x}y=aa+1|0;c[Q>>2]=y;ba=$;ca=y}else{eUa(d,h)|0;ba=c[a>>2]|0;ca=c[Q>>2]|0}g[j>>2]=N;g[j+4>>2]=l;g[j+8>>2]=K;g[j+12>>2]=G;g[j+16>>2]=C;g[j+20>>2]=F;x=ea(g[B>>2]);g[j+24>>2]=x;s=ea(g[E>>2]);g[j+28>>2]=s;o=ea(g[H>>2]);g[j+32>>2]=o;if((ba&2147483647)>>>0>ca>>>0){ba=c[d>>2]|0;H=ba+(ca*36|0)|0;if(H){g[H>>2]=N;g[ba+(ca*36|0)+4>>2]=l;g[ba+(ca*36|0)+8>>2]=K;g[ba+(ca*36|0)+12>>2]=G;g[ba+(ca*36|0)+16>>2]=C;g[ba+(ca*36|0)+20>>2]=F;g[ba+(ca*36|0)+24>>2]=x;g[ba+(ca*36|0)+28>>2]=s;g[ba+(ca*36|0)+32>>2]=o}c[Q>>2]=ca+1}else eUa(d,j)|0;c[k>>2]=-1;j=e+8|0;d=e+4|0;ca=c[d>>2]|0;if((c[j>>2]&2147483647)>>>0>ca>>>0){Q=(c[e>>2]|0)+(ca<<2)|0;if(!Q)da=ca;else{c[Q>>2]=-1;da=c[d>>2]|0}Q=da+1|0;c[d>>2]=Q;fa=Q}else{cUa(e,k)|0;fa=c[d>>2]|0}if((c[j>>2]&2147483647)>>>0>fa>>>0){Q=(c[e>>2]|0)+(fa<<2)|0;if(!Q)ga=fa;else{c[Q>>2]=c[k>>2];ga=c[d>>2]|0}Q=ga+1|0;c[d>>2]=Q;ha=Q}else{cUa(e,k)|0;ha=c[d>>2]|0}if((c[j>>2]&2147483647)>>>0>ha>>>0){Q=(c[e>>2]|0)+(ha<<2)|0;if(!Q)ia=ha;else{c[Q>>2]=c[k>>2];ia=c[d>>2]|0}Q=ia+1|0;c[d>>2]=Q;ja=Q}else{cUa(e,k)|0;ja=c[d>>2]|0}if((c[j>>2]&2147483647)>>>0>ja>>>0){Q=(c[e>>2]|0)+(ja<<2)|0;if(!Q)ka=ja;else{c[Q>>2]=c[k>>2];ka=c[d>>2]|0}Q=ka+1|0;c[d>>2]=Q;la=Q}else{cUa(e,k)|0;la=c[d>>2]|0}if((c[j>>2]&2147483647)>>>0>la>>>0){Q=(c[e>>2]|0)+(la<<2)|0;if(!Q)ma=la;else{c[Q>>2]=c[k>>2];ma=c[d>>2]|0}Q=ma+1|0;c[d>>2]=Q;na=Q}else{cUa(e,k)|0;na=c[d>>2]|0}if((c[j>>2]&2147483647)>>>0<=na>>>0){cUa(e,k)|0;m=6;i=f;return m|0}j=(c[e>>2]|0)+(na<<2)|0;if(!j)oa=na;else{c[j>>2]=c[k>>2];oa=c[d>>2]|0}c[d>>2]=oa+1;m=6;i=f;return m|0}function eUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*36|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?420304:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*36|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);g[k+12>>2]=ea(g[l+12>>2]);g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);g[k+24>>2]=ea(g[l+24>>2]);g[k+28>>2]=ea(g[l+28>>2]);g[k+32>>2]=ea(g[l+32>>2])}k=k+36|0;if(k>>>0>=j>>>0)break;else l=l+36|0}}if(j){g[j>>2]=ea(g[b>>2]);g[n+(f*36|0)+4>>2]=ea(g[b+4>>2]);g[n+(f*36|0)+8>>2]=ea(g[b+8>>2]);g[n+(f*36|0)+12>>2]=ea(g[b+12>>2]);g[n+(f*36|0)+16>>2]=ea(g[b+16>>2]);g[n+(f*36|0)+20>>2]=ea(g[b+20>>2]);g[n+(f*36|0)+24>>2]=ea(g[b+24>>2]);g[n+(f*36|0)+28>>2]=ea(g[b+28>>2]);g[n+(f*36|0)+32>>2]=ea(g[b+32>>2])}if((c[e>>2]|0)<=-1){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*36|0)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*36|0)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);o=c[m>>2]|0;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*36|0)|0;i=d;return q|0}function fUa(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=ea(j);k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;l=i;i=i+176|0;m=l+24|0;n=l+140|0;o=l+152|0;p=l+164|0;q=l+12|0;r=l;s=l+128|0;if(!e){i=l;return}t=ea(ea(g[k>>2])*ea(.00999999977));u=ea(ea(g[k+4>>2])*ea(.00999999977));v=ea(t-f);f=ea(u-h);h=ea(ea(ea(g[k+8>>2])*ea(.00999999977))-j);if(!a){i=l;return}k=m+36|0;w=m+40|0;x=m+56|0;y=m+60|0;z=m+76|0;A=m+80|0;B=m+96|0;C=m+100|0;D=n+4|0;E=n+8|0;F=o+4|0;G=o+8|0;H=p+4|0;I=p+8|0;J=q+4|0;K=q+8|0;L=r+4|0;M=r+8|0;N=s+4|0;O=s+8|0;P=0;do{Q=P+b|0;R=m+0|0;S=R+36|0;do{c[R>>2]=0;R=R+4|0}while((R|0)<(S|0));g[k>>2]=ea(1.0);c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;g[x>>2]=ea(1.0);c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[z>>2]=ea(1.0);c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;g[B>>2]=ea(1.0);c[C>>2]=e;R=CKa(DKa(m,-16711936)|0,1)|0;S=d+(Q*36|0)|0;j=ea(v+ea(g[S>>2]));T=d+(Q*36|0)+4|0;u=ea(f+ea(g[T>>2]));U=d+(Q*36|0)+8|0;t=ea(h+ea(g[U>>2]));g[n>>2]=j;g[D>>2]=u;g[E>>2]=t;V=GKa(R,n)|0;R=d+(Q*36|0)+12|0;t=ea(v+ea(g[R>>2]));W=d+(Q*36|0)+16|0;u=ea(f+ea(g[W>>2]));X=d+(Q*36|0)+20|0;j=ea(h+ea(g[X>>2]));g[o>>2]=t;g[F>>2]=u;g[G>>2]=j;Y=GKa(V,o)|0;j=ea(v+ea(g[R>>2]));u=ea(f+ea(g[W>>2]));t=ea(h+ea(g[X>>2]));g[p>>2]=j;g[H>>2]=u;g[I>>2]=t;X=GKa(Y,p)|0;Y=d+(Q*36|0)+24|0;t=ea(v+ea(g[Y>>2]));W=d+(Q*36|0)+28|0;u=ea(f+ea(g[W>>2]));R=d+(Q*36|0)+32|0;j=ea(h+ea(g[R>>2]));g[q>>2]=t;g[J>>2]=u;g[K>>2]=j;V=GKa(X,q)|0;j=ea(v+ea(g[Y>>2]));u=ea(f+ea(g[W>>2]));t=ea(h+ea(g[R>>2]));g[r>>2]=j;g[L>>2]=u;g[M>>2]=t;R=GKa(V,r)|0;t=ea(v+ea(g[S>>2]));u=ea(f+ea(g[T>>2]));j=ea(h+ea(g[U>>2]));g[s>>2]=t;g[N>>2]=u;g[O>>2]=j;GKa(R,s)|0;P=P+1|0}while((P|0)!=(a|0));i=l;return}function gUa(f,j,k,l,m,n,o,p,q,r,s){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0.0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;t=i;i=i+176|0;u=t+64|0;v=t+24|0;w=t+148|0;x=t;y=t+112|0;z=t+20|0;c[v>>2]=4;A=v+4|0;g[A>>2]=ea(1.0);g[v+8>>2]=ea(1.0);g[v+12>>2]=ea(1.0);B=v+16|0;g[B>>2]=ea(0.0);C=v+20|0;g[C>>2]=ea(0.0);D=v+24|0;g[D>>2]=ea(0.0);E=v+28|0;g[E>>2]=ea(1.0);F=v+32|0;c[F>>2]=0;_n[c[(c[f>>2]|0)+52>>2]&4095](f,v)|0;v=c[F>>2]|0;F=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;G=mo[c[(c[v>>2]|0)+32>>2]&4095](v)|0;H=(F|0)==0;if(!H){I=w+16|0;J=0;K=0;do{xo[c[(c[v>>2]|0)+40>>2]&2047](v,K,w)|0;J=J+-2+(e[I>>1]|0)|0;K=K+1|0}while((K|0)!=(F|0));K=i;i=i+((1*(J*12|0)|0)+15&-16)|0;if(H){L=K;M=J}else{H=x+16|0;I=0;w=G;G=K;while(1){xo[c[(c[v>>2]|0)+40>>2]&2047](v,I,x)|0;N=e[H>>1]|0;O=N+-2|0;if(!O)P=G;else{Q=d[w>>0]|0;R=N*3|0;S=0;T=G;while(1){U=S;S=S+1|0;V=d[w+((S>>>0)%(N>>>0)|0)>>0]|0;W=d[w+(((U+2|0)>>>0)%(N>>>0)|0)>>0]|0;c[T>>2]=Q;c[T+4>>2]=V;c[T+8>>2]=W;if((S|0)==(O|0))break;else T=T+12|0}P=G+(R+-6<<2)|0}I=I+1|0;if((I|0)==(F|0)){L=K;M=J;break}else{w=w+N|0;G=P}}}}else{L=t+168|0;M=0}X=ea(g[k>>2]);Y=ea(g[k+4>>2]);Z=ea(g[k+8>>2]);_=ea(g[k+12>>2]);$=ea(X+X);aa=ea(Y+Y);ba=ea(Z+Z);ca=ea(Y*aa);da=ea(Z*ba);fa=ea($*Y);Y=ea($*Z);ga=ea($*_);ha=ea(aa*Z);Z=ea(aa*_);aa=ea(ba*_);_=ea(ea(ea(1.0)-ca)-da);ba=ea(fa+aa);ia=ea(Y-Z);ja=ea(fa-aa);aa=ea(ea(1.0)-ea(X*$));$=ea(aa-da);da=ea(ha+ga);X=ea(Y+Z);Z=ea(ha-ga);ga=ea(aa-ca);ca=ea(g[B>>2]);aa=ea(g[C>>2]);ha=ea(g[D>>2]);Y=ea(g[E>>2]);fa=ea(ca+ca);ka=ea(aa+aa);la=ea(ha+ha);ma=ea(aa*ka);na=ea(ha*la);oa=ea(fa*aa);aa=ea(fa*ha);pa=ea(fa*Y);qa=ea(ka*ha);ha=ea(ka*Y);ka=ea(la*Y);Y=ea(ea(ea(1.0)-ma)-na);la=ea(oa+ka);ra=ea(aa-ha);sa=ea(oa-ka);ka=ea(ea(1.0)-ea(ca*fa));fa=ea(ka-na);na=ea(qa+pa);ca=ea(aa+ha);ha=ea(qa-pa);pa=ea(ka-ma);ma=ea(g[A>>2]);ka=ea(ma*Y);qa=ea(ma*sa);aa=ea(ma*ca);ma=ea(g[A+4>>2]);oa=ea(la*ma);ta=ea(fa*ma);ua=ea(ha*ma);ma=ea(g[A+8>>2]);va=ea(ra*ma);wa=ea(na*ma);xa=ea(pa*ma);ma=ea(ea(ea(Y*ka)+ea(la*oa))+ea(ra*va));ya=ea(ea(ea(Y*qa)+ea(la*ta))+ea(ra*wa));za=ea(ea(ea(Y*aa)+ea(la*ua))+ea(ra*xa));ra=ea(ea(ea(sa*ka)+ea(fa*oa))+ea(na*va));la=ea(ea(ea(sa*qa)+ea(fa*ta))+ea(na*wa));Y=ea(ea(ea(sa*aa)+ea(fa*ua))+ea(na*xa));na=ea(ea(ea(ca*ka)+ea(ha*oa))+ea(pa*va));va=ea(ea(ea(ca*qa)+ea(ha*ta))+ea(pa*wa));wa=ea(ea(ea(ca*aa)+ea(ha*ua))+ea(pa*xa));xa=ea(ea(X*za)+ea(ea(_*ma)+ea(ja*ya)));pa=ea(ea(Z*za)+ea(ea(ba*ma)+ea($*ya)));ua=ea(ea(ga*za)+ea(ea(ia*ma)+ea(da*ya)));ya=ea(ea(X*Y)+ea(ea(_*ra)+ea(ja*la)));ma=ea(ea(Z*Y)+ea(ea(ba*ra)+ea($*la)));za=ea(ea(ga*Y)+ea(ea(ia*ra)+ea(da*la)));la=ea(ea(X*wa)+ea(ea(_*na)+ea(ja*va)));ja=ea(ea(Z*wa)+ea(ea(ba*na)+ea($*va)));$=ea(ea(ga*wa)+ea(ea(ia*na)+ea(da*va)));va=ea(g[k+16>>2]);da=ea(g[k+20>>2]);na=ea(g[k+24>>2]);Aa=+h[o>>3];ia=ea(+va-Aa);Ba=+h[o+8>>3];va=ea(+da-Ba);Ca=+h[o+16>>3];da=ea(+na-Ca);na=ea(Aa);wa=ea(-na);ga=ea(Ba);ba=ea(-ga);Z=ea(Ca);_=ea(-Z);k=c[l+4>>2]|0;YTa(l,k+12|0);A=c[l>>2]|0;c[A+(k<<2)>>2]=2;c[A+(k+1<<2)>>2]=f;c[A+(k+2<<2)>>2]=j;j=A+(k+4<<2)|0;c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[j+16>>2]=c[o+16>>2];c[j+20>>2]=c[o+20>>2];o=m+4|0;j=A+(k+11<<2)|0;c[j>>2]=c[o>>2];f=mo[c[(c[v>>2]|0)+28>>2]&4095](v)|0;if(a[q+56>>0]|0){X=ea(g[p+12>>2]);ra=ea(g[p>>2]);Y=ea(X-ra);ha=ea(g[p+16>>2]);aa=ea(g[p+4>>2]);ca=ea(ha-aa);ta=ea(g[p+20>>2]);qa=ea(g[p+8>>2]);oa=ea(Y*ea(.5));Y=ea(ca*ea(.5));ca=ea(ea(ta-qa)*ea(.5));ka=ea(ea(ea(X+ra)*ea(.5))-na);na=ea(ea(ea(ha+aa)*ea(.5))-ga);ga=ea(ea(ea(ta+qa)*ea(.5))-Z);Z=ea(ka-oa);qa=ea(na-Y);ta=ea(ga-ca);aa=ea(oa+ka);ka=ea(Y+na);na=ea(ca+ga);if(!M)Da=0;else{p=y+4|0;v=y+8|0;l=y+12|0;E=y+16|0;D=y+20|0;C=y+24|0;B=y+28|0;P=y+32|0;G=q+52|0;w=u+4|0;J=u+8|0;K=u+12|0;ga=ea(ea(Z+aa)*ea(.5));ca=ea(ea(qa+ka)*ea(.5));Y=ea(ea(ta+na)*ea(.5));F=u+16|0;I=u+20|0;H=u+24|0;oa=ea(ea(aa-Z)*ea(.5));Z=ea(ea(ka-qa)*ea(.5));qa=ea(ea(na-ta)*ea(.5));x=u+28|0;T=u+32|0;O=u+36|0;S=u+40|0;Q=u+44|0;W=M;V=L;U=0;while(1){W=W+-1|0;Ea=c[V>>2]|0;Fa=c[V+4>>2]|0;Ga=c[V+8>>2]|0;ta=ea(g[f+(Ea*12|0)>>2]);na=ea(g[f+(Ea*12|0)+4>>2]);ka=ea(g[f+(Ea*12|0)+8>>2]);aa=ea(va+ea(ea(ea(pa*ta)+ea(ma*na))+ea(ja*ka)));ha=ea(da+ea(ea(ea(ua*ta)+ea(za*na))+ea($*ka)));g[y>>2]=ea(ia+ea(ea(ea(xa*ta)+ea(ya*na))+ea(la*ka)));g[p>>2]=aa;g[v>>2]=ha;ha=ea(g[f+(Fa*12|0)>>2]);aa=ea(g[f+(Fa*12|0)+4>>2]);ka=ea(g[f+(Fa*12|0)+8>>2]);na=ea(va+ea(ea(ea(pa*ha)+ea(ma*aa))+ea(ja*ka)));ta=ea(da+ea(ea(ea(ua*ha)+ea(za*aa))+ea($*ka)));g[l>>2]=ea(ia+ea(ea(ea(xa*ha)+ea(ya*aa))+ea(la*ka)));g[E>>2]=na;g[D>>2]=ta;ta=ea(g[f+(Ga*12|0)>>2]);na=ea(g[f+(Ga*12|0)+4>>2]);ka=ea(g[f+(Ga*12|0)+8>>2]);aa=ea(va+ea(ea(ea(pa*ta)+ea(ma*na))+ea(ja*ka)));ha=ea(da+ea(ea(ea(ua*ta)+ea(za*na))+ea($*ka)));g[C>>2]=ea(ia+ea(ea(ea(xa*ta)+ea(ya*na))+ea(la*ka)));g[B>>2]=aa;g[P>>2]=ha;ha=ea(g[G>>2]);c[u>>2]=0;c[w>>2]=-1;c[J>>2]=m;c[K>>2]=n;g[F>>2]=ga;g[I>>2]=ca;g[H>>2]=Y;g[x>>2]=oa;g[T>>2]=Z;g[O>>2]=qa;g[S>>2]=ha;b[Q>>1]=0;aUa(u,y,l,C);Ga=c[u>>2]|0;b[s>>1]=(e[s>>1]|0)+(e[Q>>1]|0);Fa=Ga+U|0;if(!W){Da=Fa;break}else{V=V+12|0;U=Fa}}}c[A+(k+10<<2)>>2]=Da;Ha=m;Ia=k+10|0;Ja=A+(Ia<<2)|0;Ka=c[Ja>>2]|0;La=c[j>>2]|0;Ma=c[Ha>>2]|0;Na=q+20|0;fUa(Ka,La,Ma,r,wa,ba,_,Na);i=t;return}Da=c[o>>2]|0;bUa(m,Da+M|0);o=c[m>>2]|0;c[A+(k+10<<2)>>2]=M;if(!M){Ha=m;Ia=k+10|0;Ja=A+(Ia<<2)|0;Ka=c[Ja>>2]|0;La=c[j>>2]|0;Ma=c[Ha>>2]|0;Na=q+20|0;fUa(Ka,La,Ma,r,wa,ba,_,Na);i=t;return}U=n+8|0;V=n+4|0;W=M;M=L;L=o+(Da*36|0)|0;do{W=W+-1|0;Da=L;L=L+36|0;o=c[M>>2]|0;Q=c[M+4>>2]|0;s=c[M+8>>2]|0;M=M+12|0;qa=ea(g[f+(o*12|0)>>2]);Z=ea(g[f+(o*12|0)+4>>2]);oa=ea(g[f+(o*12|0)+8>>2]);Y=ea(va+ea(ea(ea(pa*qa)+ea(ma*Z))+ea(ja*oa)));ca=ea(da+ea(ea(ea(ua*qa)+ea(za*Z))+ea($*oa)));g[Da>>2]=ea(ia+ea(ea(ea(xa*qa)+ea(ya*Z))+ea(la*oa)));g[Da+4>>2]=Y;g[Da+8>>2]=ca;ca=ea(g[f+(Q*12|0)>>2]);Y=ea(g[f+(Q*12|0)+4>>2]);oa=ea(g[f+(Q*12|0)+8>>2]);Z=ea(va+ea(ea(ea(pa*ca)+ea(ma*Y))+ea(ja*oa)));qa=ea(da+ea(ea(ea(ua*ca)+ea(za*Y))+ea($*oa)));g[Da+12>>2]=ea(ia+ea(ea(ea(xa*ca)+ea(ya*Y))+ea(la*oa)));g[Da+16>>2]=Z;g[Da+20>>2]=qa;qa=ea(g[f+(s*12|0)>>2]);Z=ea(g[f+(s*12|0)+4>>2]);oa=ea(g[f+(s*12|0)+8>>2]);Y=ea(va+ea(ea(ea(pa*qa)+ea(ma*Z))+ea(ja*oa)));ca=ea(da+ea(ea(ea(ua*qa)+ea(za*Z))+ea($*oa)));g[Da+24>>2]=ea(ia+ea(ea(ea(xa*qa)+ea(ya*Z))+ea(la*oa)));g[Da+28>>2]=Y;g[Da+32>>2]=ca;c[z>>2]=-1;Da=c[V>>2]|0;if((c[U>>2]&2147483647)>>>0>Da>>>0){s=(c[n>>2]|0)+(Da<<2)|0;if(!s)Oa=Da;else{c[s>>2]=-1;Oa=c[V>>2]|0}c[V>>2]=Oa+1}else cUa(n,z)|0}while((W|0)!=0);Ha=m;Ia=k+10|0;Ja=A+(Ia<<2)|0;Ka=c[Ja>>2]|0;La=c[j>>2]|0;Ma=c[Ha>>2]|0;Na=q+20|0;fUa(Ka,La,Ma,r,wa,ba,_,Na);i=t;return}function hUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function iUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?421656:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function jUa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){hUa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function kUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?421392:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function lUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)mUa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function mUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?421288:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}
function nUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)oUa(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b*56|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+24|0;l=d+28|0;m=d+32|0;n=d+36|0;o=d+40|0;p=d+44|0;q=d+48|0;r=f+(a*56|0)|0;do{if(r){c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];c[r+16>>2]=c[d+16>>2];c[r+20>>2]=c[d+20>>2];g[r+24>>2]=ea(g[k>>2]);g[r+28>>2]=ea(g[l>>2]);g[r+32>>2]=ea(g[m>>2]);c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];c[r+16>>2]=c[d+16>>2];c[r+20>>2]=c[d+20>>2];g[r+36>>2]=ea(g[n>>2]);g[r+40>>2]=ea(g[o>>2]);g[r+44>>2]=ea(g[p>>2]);g[r+48>>2]=ea(g[q>>2]);c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];c[r+16>>2]=c[d+16>>2];c[r+20>>2]=c[d+20>>2]}r=r+56|0}while(r>>>0<j>>>0);c[h>>2]=b;i=e;return}function oUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*56|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?421168:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*56|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[k+16>>2]=c[f+16>>2];c[k+20>>2]=c[f+20>>2];g[k+24>>2]=ea(g[f+24>>2]);g[k+28>>2]=ea(g[f+28>>2]);g[k+32>>2]=ea(g[f+32>>2]);c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[k+16>>2]=c[f+16>>2];c[k+20>>2]=c[f+20>>2];g[k+36>>2]=ea(g[f+36>>2]);g[k+40>>2]=ea(g[f+40>>2]);g[k+44>>2]=ea(g[f+44>>2]);g[k+48>>2]=ea(g[f+48>>2]);c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[k+16>>2]=c[f+16>>2];c[k+20>>2]=c[f+20>>2]}k=k+56|0;if(k>>>0>=e>>>0)break;else f=f+56|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function pUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)qUa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b*56|0)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a*56|0)|0;do{if(j){a=j+0|0;f=d+0|0;k=a+56|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(k|0))}j=j+56|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function qUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*56|0,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?421040:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j*56|0)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=j+0|0;h=f+0|0;l=g+56|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(l|0))}j=j+56|0;if(j>>>0>=e>>>0)break;else f=f+56|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function rUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=0;d=i;e=c[a+8>>2]|0;if(e){f=c[a+4>>2]|0;h=b+4|0;j=b+8|0;k=0;do{l=ea(g[b>>2]);m=f+(k<<4)|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[h>>2]);m=f+(k<<4)+4|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[j>>2]);m=f+(k<<4)+8|0;g[m>>2]=ea(l+ea(g[m>>2]));k=k+1|0}while(k>>>0<e>>>0)}e=c[a+20>>2]|0;if(e){k=c[a+16>>2]|0;f=b+4|0;j=b+8|0;h=0;do{l=ea(g[b>>2]);m=k+(h<<5)|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[f>>2]);m=k+(h<<5)+4|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[j>>2]);m=k+(h<<5)+8|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[b>>2]);m=k+(h<<5)+16|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[f>>2]);m=k+(h<<5)+20|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[j>>2]);m=k+(h<<5)+24|0;g[m>>2]=ea(l+ea(g[m>>2]));h=h+1|0}while(h>>>0<e>>>0)}e=c[a+32>>2]|0;if(e){h=c[a+28>>2]|0;k=b+4|0;j=b+8|0;f=0;do{l=ea(g[b>>2]);m=h+(f*48|0)|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[k>>2]);m=h+(f*48|0)+4|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[j>>2]);m=h+(f*48|0)+8|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[b>>2]);m=h+(f*48|0)+16|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[k>>2]);m=h+(f*48|0)+20|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[j>>2]);m=h+(f*48|0)+24|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[b>>2]);m=h+(f*48|0)+32|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[k>>2]);m=h+(f*48|0)+36|0;g[m>>2]=ea(l+ea(g[m>>2]));l=ea(g[j>>2]);m=h+(f*48|0)+40|0;g[m>>2]=ea(l+ea(g[m>>2]));f=f+1|0}while(f>>>0<e>>>0)}e=c[a+44>>2]|0;if(!e){i=d;return}f=c[a+40>>2]|0;a=b+4|0;h=b+8|0;j=0;do{l=ea(g[b>>2]);k=f+(j*24|0)|0;g[k>>2]=ea(l+ea(g[k>>2]));l=ea(g[a>>2]);k=f+(j*24|0)+4|0;g[k>>2]=ea(l+ea(g[k>>2]));l=ea(g[h>>2]);k=f+(j*24|0)+8|0;g[k>>2]=ea(l+ea(g[k>>2]));j=j+1|0}while(j>>>0<e>>>0);i=d;return}function sUa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;d=i;e=ea(g[b+4>>2]);f=ea(g[c+8>>2]);h=ea(g[b+8>>2]);j=ea(g[c+4>>2]);k=ea(g[c>>2]);l=ea(g[b>>2]);m=ea(ea(f*h)+ea(ea(e*j)+ea(k*l)));if(!(m<=ea(-.999989986))){n=ea(T(ea(ea(m+ea(1.0))*ea(2.0))));m=ea(ea(1.0)/n);o=ea(ea(ea(e*f)-ea(h*j))*m);p=ea(ea(ea(h*k)-ea(f*l))*m);f=ea(ea(ea(j*l)-ea(e*k))*m);m=ea(n*ea(.5));n=ea(ea(1.0)/ea(T(ea(ea(m*m)+ea(ea(f*f)+ea(ea(o*o)+ea(p*p)))))));k=ea(p*n);p=ea(f*n);f=ea(m*n);g[a>>2]=ea(o*n);g[a+4>>2]=k;g[a+8>>2]=p;g[a+12>>2]=f;i=d;return}if(ea(S(ea(l)))<ea(.100000001)){q=ea(0.0);r=h;s=ea(-e)}else{q=e;r=ea(-l);s=ea(0.0)}l=ea(ea(1.0)/ea(T(ea(ea(ea(s*s)+ea(ea(r*r)+ea(q*q)))+ea(0.0)))));e=ea(r*l);r=ea(s*l);s=ea(l*ea(0.0));g[a>>2]=ea(q*l);g[a+4>>2]=e;g[a+8>>2]=r;g[a+12>>2]=s;i=d;return}function tUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*72|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?423240:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*72|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){c[k>>2]=c[l>>2];o=k+8|0;p=l+8|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[o+16>>2]=c[p+16>>2];c[o+20>>2]=c[p+20>>2];c[o+24>>2]=c[p+24>>2];c[o+28>>2]=c[p+28>>2];g[k+40>>2]=ea(g[l+40>>2]);g[k+44>>2]=ea(g[l+44>>2]);g[k+48>>2]=ea(g[l+48>>2]);g[k+52>>2]=ea(g[l+52>>2]);g[k+56>>2]=ea(g[l+56>>2]);g[k+60>>2]=ea(g[l+60>>2]);g[k+64>>2]=ea(g[l+64>>2]);c[k>>2]=c[l>>2]}k=k+72|0;if(k>>>0>=j>>>0)break;else l=l+72|0}q=c[m>>2]|0}else q=f;f=n+(q*72|0)|0;if(f){c[f>>2]=c[b>>2];l=n+(q*72|0)+8|0;j=b+8|0;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];g[n+(q*72|0)+40>>2]=ea(g[b+40>>2]);g[n+(q*72|0)+44>>2]=ea(g[b+44>>2]);g[n+(q*72|0)+48>>2]=ea(g[b+48>>2]);g[n+(q*72|0)+52>>2]=ea(g[b+52>>2]);g[n+(q*72|0)+56>>2]=ea(g[b+56>>2]);g[n+(q*72|0)+60>>2]=ea(g[b+60>>2]);g[n+(q*72|0)+64>>2]=ea(g[b+64>>2]);c[f>>2]=c[b>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;r=c[m>>2]|0;s=r+1|0;c[m>>2]=s;t=n+(r*72|0)|0;i=d;return t|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;r=c[m>>2]|0;s=r+1|0;c[m>>2]=s;t=n+(r*72|0)|0;i=d;return t|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);c[a>>2]=n;c[e>>2]=h;r=c[m>>2]|0;s=r+1|0;c[m>>2]=s;t=n+(r*72|0)|0;i=d;return t|0}function uUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<6,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?423056:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<6)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){c[k>>2]=c[l>>2];o=k+8|0;p=l+8|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[o+16>>2]=c[p+16>>2];c[o+20>>2]=c[p+20>>2];c[o+24>>2]=c[p+24>>2];c[o+28>>2]=c[p+28>>2];g[k+40>>2]=ea(g[l+40>>2]);g[k+44>>2]=ea(g[l+44>>2]);g[k+48>>2]=ea(g[l+48>>2]);g[k+52>>2]=ea(g[l+52>>2]);p=l+56|0;o=c[p+4>>2]|0;q=k+56|0;c[q>>2]=c[p>>2];c[q+4>>2]=o;c[k>>2]=c[l>>2]}k=k+64|0;if(k>>>0>=j>>>0)break;else l=l+64|0}r=c[m>>2]|0}else r=f;f=n+(r<<6)|0;if(f){c[f>>2]=c[b>>2];l=n+(r<<6)+8|0;j=b+8|0;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];g[n+(r<<6)+40>>2]=ea(g[b+40>>2]);g[n+(r<<6)+44>>2]=ea(g[b+44>>2]);g[n+(r<<6)+48>>2]=ea(g[b+48>>2]);g[n+(r<<6)+52>>2]=ea(g[b+52>>2]);j=b+56|0;l=c[j+4>>2]|0;k=n+(r<<6)+56|0;c[k>>2]=c[j>>2];c[k+4>>2]=l;c[f>>2]=c[b>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s<<6)|0;i=d;return u|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s<<6)|0;i=d;return u|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s<<6)|0;i=d;return u|0}function vUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?424080:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function wUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<4,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?424080:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<4)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);g[k+12>>2]=ea(g[l+12>>2])}k=k+16|0;if(k>>>0>=j>>>0)break;else l=l+16|0}}if(j){g[j>>2]=ea(g[b>>2]);g[n+(f<<4)+4>>2]=ea(g[b+4>>2]);g[n+(f<<4)+8>>2]=ea(g[b+8>>2]);g[n+(f<<4)+12>>2]=ea(g[b+12>>2])}if((c[e>>2]|0)<=-1){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o<<4)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o<<4)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);o=c[m>>2]|0;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o<<4)|0;i=d;return q|0}function xUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)yUa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function yUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?541832:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function zUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+16|0;f=c[b>>2]|0;h=ea(e>>>0);j=~~ea(h*ea(g[a+24>>2]))>>>0;k=e<<2;l=(j<<2)+k|0;m=(0-l&12)+l|0;l=UJa(a,m+(j*20|0)|0,529024,354)|0;n=l+k|0;o=l+m|0;PEi(l|0,-1,k|0)|0;k=a+36|0;m=a+4|0;if(c[k>>2]|0){p=e+-1|0;q=0;do{r=c[m>>2]|0;s=r+(q*20|0)|0;t=c[s>>2]|0;u=r+(q*20|0)+4|0;v=c[u>>2]|0;w=v+~(v<<15)|0;v=(w>>>10^w)*9|0;w=v>>>6^v;v=w+~(w<<11)|0;w=t+~(t<<15)|0;t=(w>>>10^w)*9|0;w=t>>>6^t;t=w+~(w<<11)|0;w=l+(((v>>>16^v^(t^-57320555^t>>>16)*1000007)&p)<<2)|0;c[n+(q<<2)>>2]=c[w>>2];c[w>>2]=q;w=o+(q*20|0)|0;if(w){c[w>>2]=c[s>>2];c[o+(q*20|0)+4>>2]=c[u>>2];u=o+(q*20|0)+8|0;s=r+(q*20|0)+8|0;c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2]}q=q+1|0}while(q>>>0<(c[k>>2]|0)>>>0)}VJa(a,c[a>>2]|0);c[a>>2]=l;c[a+12>>2]=l;c[a+20>>2]=e;c[a+8>>2]=n;c[m>>2]=o;c[b>>2]=j;j=a+28|0;if((c[j>>2]|0)!=-1){i=d;return}c[j>>2]=f;i=d;return}function AUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+20|0;f=c[e>>2]|0;a:do if(f){h=c[b>>2]|0;j=c[b+4>>2]|0;k=j+~(j<<15)|0;l=(k>>>10^k)*9|0;k=l>>>6^l;l=k+~(k<<11)|0;k=h+~(h<<15)|0;m=(k>>>10^k)*9|0;k=m>>>6^m;m=k+~(k<<11)|0;k=(l>>>16^l^(m^-57320555^m>>>16)*1000007)&f+-1;m=c[(c[a+12>>2]|0)+(k<<2)>>2]|0;if((m|0)==-1){n=f;o=k}else{l=c[a+4>>2]|0;p=a+8|0;q=m;while(1){if((c[l+(q*20|0)>>2]|0)==(h|0)?(c[l+(q*20|0)+4>>2]|0)==(j|0):0)break;m=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((m|0)==-1){n=f;o=k;break a}else q=m}r=l+(q*20|0)|0;s=r+8|0;i=d;return s|0}}else{n=0;o=0}while(0);f=a+36|0;if((c[f>>2]|0)==(c[a+16>>2]|0)){k=(n|0)==0?16:n<<1;if(n>>>0<k>>>0){zUa(a,k);t=c[e>>2]|0}else t=n;n=c[b>>2]|0;e=c[b+4>>2]|0;k=e+~(e<<15)|0;e=(k>>>10^k)*9|0;k=e>>>6^e;e=k+~(k<<11)|0;k=n+~(n<<15)|0;n=(k>>>10^k)*9|0;k=n>>>6^n;n=k+~(k<<11)|0;u=(e>>>16^e^(n^-57320555^n>>>16)*1000007)&t+-1}else u=o;o=a+28|0;t=c[o>>2]|0;c[o>>2]=t+1;o=(c[a+12>>2]|0)+(u<<2)|0;c[(c[a+8>>2]|0)+(t<<2)>>2]=c[o>>2];c[o>>2]=t;c[f>>2]=(c[f>>2]|0)+1;f=a+32|0;c[f>>2]=(c[f>>2]|0)+1;f=c[a+4>>2]|0;a=f+(t*20|0)|0;if(!a){r=0;s=r+8|0;i=d;return s|0}c[a>>2]=c[b>>2];c[f+(t*20|0)+4>>2]=c[b+4>>2];g[f+(t*20|0)+8>>2]=ea(0.0);g[f+(t*20|0)+12>>2]=ea(0.0);g[f+(t*20|0)+16>>2]=ea(0.0);r=a;s=r+8|0;i=d;return s|0}function BUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b*12|0,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?423792:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j*12|0)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j>>2]=c[f>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2]}j=j+12|0;if(j>>>0>=e>>>0)break;else f=f+12|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function CUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*12|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?423792:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*12|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}j=j+12|0;if(j>>>0>=h>>>0)break;else k=k+12|0}n=c[l>>2]|0}else n=f;f=m+(n*12|0)|0;if(f){c[f>>2]=c[b>>2];c[m+(n*12|0)+4>>2]=c[b+4>>2];c[m+(n*12|0)+8>>2]=c[b+8>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o*12|0)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o*12|0)|0;i=d;return q|0}n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,b);c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o*12|0)|0;i=d;return q|0}function DUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?423640:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function EUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?423640:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function FUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?453600:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function GUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)HUa(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<2)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=f+(a<<2)|0;do{if(k)g[k>>2]=ea(g[d>>2]);k=k+4|0}while(k>>>0<j>>>0);c[h>>2]=b;i=e;return}function HUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?526520:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<2)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k)g[k>>2]=ea(g[f>>2]);k=k+4|0;if(k>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function IUa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+72>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+64>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+60>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+52>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+48>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+40>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+36>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+28>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+24>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+16>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+12>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+4>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function JUa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+104>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+96>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+92>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+84>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+76>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+68>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+64>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+56>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+52>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+44>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+32>>2]|0;e=c[a+40>>2]|0;if(!((e|0)<0|(e&2147483647|0)==0|(d|0)==0)){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+28>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+20>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+16>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+8>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function KUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)k_a(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b*12|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=f+(a*12|0)|0;do{if(m){g[m>>2]=ea(g[d>>2]);g[m+4>>2]=ea(g[k>>2]);g[m+8>>2]=ea(g[l>>2])}m=m+12|0}while(m>>>0<j>>>0);c[h>>2]=b;i=e;return}function LUa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((c[b+8>>2]&2147483647)>>>0<d>>>0)KAb(b,d);g=c[b>>2]|0;h=b+4|0;b=c[h>>2]|0;j=g+d|0;if((b|0)>=(d|0)){c[h>>2]=d;i=f;return}k=g+b|0;do{if(k)a[k>>0]=a[e>>0]|0;k=k+1|0}while((k|0)!=(j|0));c[h>>2]=d;i=f;return}function MUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*12|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?424432:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*12|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}j=j+12|0;if(j>>>0>=h>>>0)break;else k=k+12|0}n=c[l>>2]|0}else n=f;f=m+(n*12|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g*12|0)|0}function NUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?424184:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function OUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?424184:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function PUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*12|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?424312:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*12|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}j=j+12|0;if(j>>>0>=h>>>0)break;else k=k+12|0}n=c[l>>2]|0}else n=f;f=m+(n*12|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g*12|0)|0}function QUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im;f=i;if((d|0)==(b|0)){c[e>>2]=1;c[e+4>>2]=d;g[e+8>>2]=ea(0.0);g[e+12>>2]=ea(0.0);h=0;i=f;return h|0}j=c[a+8>>2]|0;k=ea(g[j+(b*12|0)>>2]);l=ea(g[j+(d*12|0)>>2]);m=ea(k-l);k=ea(g[j+(b*12|0)+4>>2]);n=ea(g[j+(d*12|0)+4>>2]);o=ea(k-n);k=ea(g[j+(b*12|0)+8>>2]);p=ea(g[j+(d*12|0)+8>>2]);q=ea(k-p);k=ea(ea(ea(m*m)+ea(o*o))+ea(q*q));if(k>ea(0.0)){r=ea(ea(1.0)/ea(T(ea(k))));s=ea(m*r);t=ea(o*r);u=ea(q*r)}else{s=ea(0.0);t=ea(0.0);u=ea(0.0)}v=c[a+44>>2]|0;w=c[v+(d<<2)>>2]|0;if(((c[a+4>>2]|0)+-1|0)>>>0>d>>>0)x=v+(d+1<<2)|0;else x=a+60|0;v=c[x>>2]|0;if(w>>>0>=v>>>0){h=-1;i=f;return h|0}x=c[a+56>>2]|0;y=c[a+20>>2]|0;a=w;w=-1;r=ea(-1.0);while(1){z=(c[x+(a<<2)>>2]|0)*3|0;A=c[y+(z+2<<2)>>2]|0;if((c[y+(z<<2)>>2]|0)!=(d|0))if((c[y+(z+1<<2)>>2]|0)!=(d|0))if((A|0)==(d|0)){B=0;C=13}else{D=w;E=r}else{B=2;C=13}else{B=1;C=13}if((C|0)==13){C=0;F=B+z|0;G=c[y+(F<<2)>>2]|0;H=c[y+((((B+1|0)>>>0)%3|0)+z<<2)>>2]|0;I=ea(g[j+(G*12|0)>>2]);J=ea(g[j+(G*12|0)+4>>2]);K=ea(g[j+(G*12|0)+8>>2]);L=ea(g[j+(H*12|0)>>2]);M=ea(g[j+(H*12|0)+4>>2]);N=ea(g[j+(H*12|0)+8>>2]);if((G|0)==(b|0)){C=14;break}if((H|0)==(b|0)){C=16;break}q=ea(I-l);o=ea(J-n);m=ea(K-p);k=ea(L-l);O=ea(M-n);P=ea(N-p);Q=ea(ea(o*P)-ea(O*m));R=ea(ea(k*m)-ea(q*P));U=ea(ea(q*O)-ea(k*o));V=ea(ea(U*U)+ea(ea(Q*Q)+ea(R*R)));if(V>ea(0.0)){W=ea(ea(1.0)/ea(T(ea(V))));X=ea(Q*W);Y=ea(R*W);Z=ea(U*W)}else{X=ea(0.0);Y=ea(0.0);Z=ea(0.0)}W=ea(ea(u*Z)+ea(ea(t*Y)+ea(s*X)));U=ea(s-ea(X*W));R=ea(t-ea(Y*W));Q=ea(u-ea(Z*W));W=ea(ea(Q*Q)+ea(ea(U*U)+ea(R*R)));if(W>ea(0.0)){V=ea(ea(1.0)/ea(T(ea(W))));_=ea(U*V);$=ea(R*V);aa=ea(Q*V)}else{_=ea(0.0);$=ea(0.0);aa=ea(0.0)}V=ea(l-I);Q=ea(n-J);R=ea(p-K);ba=ea(L-I);ca=ea(M-J);da=ea(N-K);U=ea(ea(ea(ba*ba)+ea(ca*ca))+ea(da*da));W=ea(ea(da*aa)+ea(ea(ca*$)+ea(ba*_)));fa=ea(ea(aa*aa)+ea(ea($*$)+ea(_*_)));ga=ea(ea(ea(ba*V)+ea(ca*Q))+ea(da*R));ha=ea(-ea(ea(R*aa)+ea(ea(Q*$)+ea(V*_))));V=ea(ea(U*fa)-ea(W*W));if(!(ea(S(ea(V)))<ea(.0000999999974))){Q=ea(ea(1.0)/V);V=ea(W*Q);ia=ea(ea(ga*ea(fa*Q))+ea(V*ha));if(ea(ea(ga*V)+ea(ea(U*Q)*ha))>ea(-9.99999974e-06)?ia>ea(-9.99999974e-06)&ia<ea(1.00001001):0){C=24;break}ha=ea(ea(ea(q*q)+ea(o*o))+ea(m*m));if(ha>ea(0.0)){Q=ea(ea(1.0)/ea(T(ea(ha))));ja=ea(q*Q);ka=ea(o*Q);la=ea(m*Q)}else{ja=ea(0.0);ka=ea(0.0);la=ea(0.0)}Q=ea(ea(ea(k*k)+ea(O*O))+ea(P*P));if(Q>ea(0.0)){m=ea(ea(1.0)/ea(T(ea(Q))));ma=ea(k*m);na=ea(O*m);oa=ea(P*m)}else{ma=ea(0.0);na=ea(0.0);oa=ea(0.0)}m=ea(ea(aa*la)+ea(ea($*ka)+ea(_*ja)));P=ea(ea(aa*oa)+ea(ea($*na)+ea(_*ma)));z=m>r;O=z?m:r;if(P>O){D=H;E=P}else{D=z?G:w;E=O}}else{D=w;E=r}}a=a+1|0;if(a>>>0>=v>>>0){C=34;break}else{w=D;r=E}}if((C|0)==14){E=ea(I-l);r=ea(J-n);ma=ea(K-p);_=ea(T(ea(ea(ea(E*E)+ea(r*r))+ea(ma*ma))));c[e>>2]=1;c[e+4>>2]=b;g[e+8>>2]=ea(0.0);g[e+12>>2]=_;h=1;i=f;return h|0}else if((C|0)==16){_=ea(L-l);L=ea(M-n);M=ea(N-p);N=ea(T(ea(ea(ea(_*_)+ea(L*L))+ea(M*M))));c[e>>2]=1;c[e+4>>2]=b;g[e+8>>2]=ea(0.0);g[e+12>>2]=N;h=1;i=f;return h|0}else if((C|0)==24){b=ia<ea(9.99999974e-06);if(b|ia>ea(.999989986)){c[e>>2]=1;w=b?G:H;c[e+4>>2]=w;N=ea(l-ea(g[j+(w*12|0)>>2]));M=ea(n-ea(g[j+(w*12|0)+4>>2]));L=ea(p-ea(g[j+(w*12|0)+8>>2]));g[e+12>>2]=ea(T(ea(ea(ea(N*N)+ea(M*M))+ea(L*L))));h=1;i=f;return h|0}else{L=ea(l-ea(I+ea(ba*ia)));ba=ea(n-ea(J+ea(ca*ia)));ca=ea(p-ea(K+ea(da*ia)));da=ea(T(ea(ea(ca*ca)+ea(ea(L*L)+ea(ba*ba)))));c[e>>2]=0;c[e+4>>2]=F;g[e+8>>2]=ia;g[e+12>>2]=da;h=1;i=f;return h|0}}else if((C|0)==34){if((D|0)<=0){h=-1;i=f;return h|0}da=ea(l-ea(g[j+(D*12|0)>>2]));l=ea(n-ea(g[j+(D*12|0)+4>>2]));n=ea(p-ea(g[j+(D*12|0)+8>>2]));p=ea(T(ea(ea(ea(da*da)+ea(l*l))+ea(n*n))));c[e>>2]=1;c[e+4>>2]=D;g[e+8>>2]=ea(0.0);g[e+12>>2]=p;h=1;i=f;return h|0}return 0}function RUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<2,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?526520:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<2)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k)g[k>>2]=ea(g[l>>2]);k=k+4|0;if(k>>>0>=j>>>0)break;else l=l+4|0}}if(j)g[j>>2]=ea(g[b>>2]);if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,b);o=c[m>>2]|0}else o=f;c[a>>2]=n;c[e>>2]=h;c[m>>2]=o+1;i=d;return n+(o<<2)|0}function SUa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;e=i;i=i+48|0;f=e+24|0;h=e+12|0;j=e;k=ea(g[b>>2]);l=ea(k*ea(2.0));m=ea(g[b+12>>2]);n=ea(m*ea(2.0));o=ea(g[b+8>>2]);p=ea(g[b+4>>2]);q=ea(m+ea(1.0));r=ea(o/q);s=ea(-ea(p/q));g[h>>2]=ea(0.0);g[h+4>>2]=r;g[h+8>>2]=s;q=ea(S(ea(r)));r=ea(g[a+8>>2]);t=ea(ea(q+r)/ea(ea(1.0)-ea(q*r)));q=ea(S(ea(s)));s=ea(ea(r+q)/ea(ea(1.0)-ea(r*q)));q=ea(g[a>>2]);r=ea(t/q);t=ea(r*r);b=a+4|0;r=ea(g[b>>2]);u=ea(s/r);if(ea(t+ea(u*u))<=ea(1.0)){v=0;i=e;return v|0}u=ea(ea(l*o)-ea(n*p));t=ea(ea(o*n)+ea(l*p));p=ea(ea(k*l)+ea(ea(m*n)+ea(-1.0)));g[f>>2]=ea(0.0);g[f+4>>2]=q;g[f+8>>2]=r;LAb(j,h,f);r=ea(g[j+4>>2]);q=ea(g[a>>2]);n=ea(r/ea(q*q));q=ea(g[j+8>>2]);m=ea(g[b>>2]);l=ea(q/ea(m*m));m=ea(ea(ea(q*q)+ea(0.0))+ea(r*r));k=ea(ea(1.0)-m);o=ea(ea(1.0)/ea(m+ea(1.0)));s=ea(o*o);w=ea(s*ea(k*ea(2.0)));x=ea(r*ea(2.0));y=ea(q*ea(2.0));z=ea(x*w);A=ea(y*w);B=ea(ea(k*w)+ea(-1.0));C=ea(ea(ea(l*q)+ea(0.0))+ea(n*r));r=ea(o*ea(s*ea(ea(C*ea(-4.0))*ea(ea(3.0)-m))));m=ea(ea(ea(C*ea(-2.0))*w)+ea(k*r));k=ea(ea(ea(n*ea(2.0))*w)+ea(x*r));x=ea(ea(ea(l*ea(2.0))*w)+ea(y*r));r=ea(ea(1.0)/ea(T(ea(ea(x*x)+ea(ea(m*m)+ea(k*k))))));y=ea(r*ea(ea(z*x)-ea(A*k)));w=ea(r*ea(ea(A*m)-ea(B*x)));x=ea(r*ea(ea(B*k)-ea(z*m)));g[c>>2]=y;g[c+4>>2]=w;g[c+8>>2]=x;g[d>>2]=ea(ea(u*ea(ea(w*B)-ea(y*z)))+ea(ea(p*ea(ea(z*x)-ea(w*A)))+ea(t*ea(ea(y*A)-ea(B*x)))));v=1;i=e;return v|0}function TUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+16|0;f=b;if((a|0)==0|(d|0)==0){g=-1;i=b;return g|0}c[f>>2]=e;g=vEi(a,d,f)|0;i=b;return g|0}function UUa(a,b){a=a|0;b=b|0;var d=0,e=Im,f=0,h=Im,j=Im,k=0,l=Im,m=Im,n=Im,o=0,p=0,q=0;d=i;e=ea(g[b>>2]);f=b+12|0;h=ea(g[f+4>>2]);j=ea(e+h);k=b+24|0;l=ea(g[k+8>>2]);m=ea(j+l);if(m>=ea(0.0)){n=ea(T(ea(m+ea(1.0))));g[a+12>>2]=ea(n*ea(.5));m=ea(ea(.5)/n);n=ea(g[f+8>>2]);g[a>>2]=ea(m*ea(n-ea(g[k+4>>2])));n=ea(g[k>>2]);g[a+4>>2]=ea(m*ea(n-ea(g[b+8>>2])));n=ea(g[b+4>>2]);g[a+8>>2]=ea(m*ea(n-ea(g[f>>2])));i=d;return}o=h>e&1;p=l>ea(g[b+(o*12|0)+(o<<2)>>2]);q=p?2:o;if(!q){n=ea(T(ea(ea(e-ea(h+l))+ea(1.0))));g[a>>2]=ea(n*ea(.5));m=ea(ea(.5)/n);n=ea(g[f>>2]);g[a+4>>2]=ea(m*ea(n+ea(g[b+4>>2])));n=ea(g[b+8>>2]);g[a+8>>2]=ea(m*ea(n+ea(g[k>>2])));n=ea(g[f+8>>2]);g[a+12>>2]=ea(m*ea(n-ea(g[k+4>>2])));i=d;return}else if((q|0)==2){n=ea(T(ea(ea(l-j)+ea(1.0))));g[a+8>>2]=ea(n*ea(.5));j=ea(ea(.5)/n);n=ea(g[b+8>>2]);g[a>>2]=ea(j*ea(n+ea(g[k>>2])));n=ea(g[k+4>>2]);g[a+4>>2]=ea(j*ea(n+ea(g[f+8>>2])));n=ea(g[b+4>>2]);g[a+12>>2]=ea(j*ea(n-ea(g[f>>2])));i=d;return}else if((q|0)==1){n=ea(T(ea(ea(h-ea(e+l))+ea(1.0))));g[a+4>>2]=ea(n*ea(.5));l=ea(ea(.5)/n);n=ea(g[k+4>>2]);g[a+8>>2]=ea(l*ea(n+ea(g[f+8>>2])));n=ea(g[f>>2]);g[a>>2]=ea(l*ea(n+ea(g[b+4>>2])));n=ea(g[k>>2]);g[a+12>>2]=ea(l*ea(n-ea(g[b+8>>2])));i=d;return}else{c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}}function VUa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;if((d|0)!=0?(d+-1&d|0)==0:0)f=d;else{h=d>>>1|d;d=h>>>2|h;h=d>>>4|d;d=h>>>8|h;f=(d>>>16|d)+1|0}d=b+20|0;h=c[d>>2]|0;j=ea(f>>>0);k=~~ea(j*ea(g[b+28>>2]))>>>0;l=f<<2;m=(k<<2)+l|0;n=(0-m&12)+m|0;m=c[c[b>>2]>>2]|0;o=Bn[c[(c[m>>2]|0)+8>>2]&255](m,n+(k<<3)|0,527016,529024,354)|0;m=o+l|0;p=o+n|0;PEi(o|0,-1,l|0)|0;l=b+40|0;if(c[l>>2]|0){n=b+8|0;q=f+-1|0;r=0;do{s=c[n>>2]|0;t=c[s+(r<<3)>>2]|0;u=a[t>>0]|0;if(!(u<<24>>24))v=5381;else{w=u;u=5381;x=t;while(1){y=u*33^w<<24>>24;x=x+1|0;w=a[x>>0]|0;if(!(w<<24>>24)){v=y;break}else u=y}}u=o+((v&q)<<2)|0;c[m+(r<<2)>>2]=c[u>>2];c[u>>2]=r;u=p+(r<<3)|0;if(u){c[u>>2]=t;c[p+(r<<3)+4>>2]=c[s+(r<<3)+4>>2]}r=r+1|0}while(r>>>0<(c[l>>2]|0)>>>0)}l=b+4|0;r=c[l>>2]|0;if(r){q=c[c[b>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,r)}c[l>>2]=o;c[b+16>>2]=o;c[b+24>>2]=f;c[b+12>>2]=m;c[b+8>>2]=p;c[d>>2]=k;k=b+32|0;if((c[k>>2]|0)!=-1){i=e;return}c[k>>2]=h;i=e;return}function WUa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=Im,D=Im,E=Im,F=Im,G=0;j=i;i=i+128|0;k=j;l=j+96|0;m=j+100|0;n=j+112|0;o=j+56|0;p=j+4|0;q=j+68|0;g[l>>2]=ea(1.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(1.0);g[m+8>>2]=ea(1.0);g[n>>2]=ea(0.0);r=n+4|0;g[r>>2]=ea(0.0);s=n+8|0;g[s>>2]=ea(0.0);t=n+12|0;g[t>>2]=ea(1.0);u=(f|0)!=0;if(u){v=ea(g[f>>2]);g[o>>2]=v;w=ea(g[f+4>>2]);g[o+4>>2]=w;x=ea(g[f+8>>2]);g[o+8>>2]=x;y=x;z=w;A=v}else{g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);y=ea(0.0);z=ea(0.0);A=ea(0.0)}do if(!((d|0)==0|(e|0)==0)){f=p+0|0;B=f+52|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(B|0));if(!(MAb(a,b,d,0,e,h,p)|0)){f=bKa()|0;c[k>>2]=426656;dKa(f,4,425800,283,426016,k);C=ea(1.0);D=A;E=z;F=y;G=0;break}if(ea(g[p+48>>2])!=ea(0.0)){NAb(p,m,n,l,o,u,b,426656);v=ea(g[l>>2]);w=ea(g[o>>2]);x=ea(g[o+4>>2]);C=v;D=w;E=x;F=ea(g[o+8>>2]);G=1}else{C=ea(1.0);D=A;E=z;F=y;G=0}}else{f=bKa()|0;c[k>>2]=426656;dKa(f,4,425800,291,426696,k);C=ea(1.0);D=A;E=z;F=y;G=0}while(0);Fn[c[(c[b>>2]|0)+128>>2]&255](b,C);In[c[(c[b>>2]|0)+140>>2]&4095](b,m);m=c[(c[b>>2]|0)+120>>2]|0;g[q>>2]=ea(g[n>>2]);g[q+4>>2]=ea(g[r>>2]);g[q+8>>2]=ea(g[s>>2]);g[q+12>>2]=ea(g[t>>2]);g[q+16>>2]=D;g[q+20>>2]=E;g[q+24>>2]=F;In[m&4095](b,q);i=j;return G|0}function XUa(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=Im;j=i;i=i+128|0;k=j;l=j+96|0;m=j+100|0;n=j+112|0;o=j+56|0;p=j+4|0;q=j+68|0;g[l>>2]=ea(1.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(1.0);g[m+8>>2]=ea(1.0);g[n>>2]=ea(0.0);r=n+4|0;g[r>>2]=ea(0.0);s=n+8|0;g[s>>2]=ea(0.0);t=n+12|0;g[t>>2]=ea(1.0);u=(f|0)!=0;if(u){g[o>>2]=ea(g[f>>2]);g[o+4>>2]=ea(g[f+4>>2]);g[o+8>>2]=ea(g[f+8>>2])}else{g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0)}do if(!((d|0)==0|(e|0)==0)){f=p+0|0;v=f+52|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(v|0));if(!(MAb(a,b,0,d,e,h,p)|0)){f=bKa()|0;c[k>>2]=425976;dKa(f,4,425800,345,426016,k);w=ea(1.0);x=0;break}if(ea(g[p+48>>2])!=ea(0.0))NAb(p,m,n,l,o,u,b,425976);if((e|0)==1){y=ea(g[d>>2]);g[l>>2]=y;w=y;x=1;break}else{w=ea(g[l>>2]);x=1;break}}else{f=bKa()|0;c[k>>2]=425976;dKa(f,4,425800,353,426104,k);w=ea(1.0);x=0}while(0);Fn[c[(c[b>>2]|0)+128>>2]&255](b,w);In[c[(c[b>>2]|0)+140>>2]&4095](b,m);m=c[(c[b>>2]|0)+120>>2]|0;g[q>>2]=ea(g[n>>2]);g[q+4>>2]=ea(g[r>>2]);g[q+8>>2]=ea(g[s>>2]);g[q+12>>2]=ea(g[t>>2]);g[q+16>>2]=ea(g[o>>2]);g[q+20>>2]=ea(g[o+4>>2]);g[q+24>>2]=ea(g[o+8>>2]);In[m&4095](b,q);i=j;return x|0}function YUa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;h=i;i=i+80|0;j=h+44|0;k=h+16|0;l=h+4|0;if((e&-2|0)==2){dKa(bKa()|0,4,425800,382,425888,h);i=h;return}else{In[c[(c[a>>2]|0)+84>>2]&4095](j,a);In[c[(c[a>>2]|0)+124>>2]&4095](k,a);m=ea(ea(g[k+16>>2])*ea(2.0));n=ea(ea(g[k+20>>2])*ea(2.0));o=ea(ea(g[k+24>>2])*ea(2.0));p=ea(g[j+12>>2]);q=ea(ea(p*p)+ea(-.5));r=ea(g[j>>2]);s=ea(m*r);t=ea(g[j+4>>2]);u=ea(s+ea(n*t));s=ea(g[j+8>>2]);v=ea(u+ea(o*s));u=ea(ea(r*v)+ea(ea(m*q)+ea(p*ea(ea(o*t)-ea(n*s)))));w=ea(ea(t*v)+ea(ea(n*q)+ea(p*ea(ea(m*s)-ea(o*r)))));x=ea(ea(ea(o*q)+ea(p*ea(ea(n*r)-ea(m*t))))+ea(s*v));v=ea(ea(g[j+16>>2])+u);u=ea(ea(g[j+20>>2])+w);w=ea(ea(g[j+24>>2])+x);x=ea(ea(g[d>>2])-v);v=ea(ea(g[d+4>>2])-u);u=ea(ea(g[d+8>>2])-w);w=ea(g[b+8>>2]);s=ea(v*w);t=ea(g[b+4>>2]);m=ea(s-ea(u*t));s=ea(g[b>>2]);r=ea(ea(u*s)-ea(w*x));w=ea(ea(x*t)-ea(v*s));g[l>>2]=m;g[l+4>>2]=r;g[l+8>>2]=w;Dn[c[(c[a>>2]|0)+168>>2]&511](a,b,e,f);Dn[c[(c[a>>2]|0)+172>>2]&511](a,l,e,f);i=h;return}}function ZUa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,l=0.0,m=0,n=0,o=0,p=0;e=i;i=i+144|0;f=e;j=e+8|0;l=+ea(g[d>>2]);m=j+0|0;n=m+128|0;do{a[m>>0]=0;m=m+1|0}while((m|0)<(n|0));h[k>>3]=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(j,0,515880,f)|0;if(a[j>>0]|0){o=c[c[b>>2]>>2]|0;p=SEi(j|0)|0;xo[o&2047](b,j,p)|0}xo[c[c[b>>2]>>2]&2047](b,1076904,1)|0;l=+ea(g[d+4>>2]);m=j+0|0;n=m+128|0;do{a[m>>0]=0;m=m+1|0}while((m|0)<(n|0));h[k>>3]=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(j,0,515880,f)|0;if(a[j>>0]|0){p=c[c[b>>2]>>2]|0;o=SEi(j|0)|0;xo[p&2047](b,j,o)|0}xo[c[c[b>>2]>>2]&2047](b,1076904,1)|0;l=+ea(g[d+8>>2]);m=j+0|0;n=m+128|0;do{a[m>>0]=0;m=m+1|0}while((m|0)<(n|0));h[k>>3]=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(j,0,515880,f)|0;if(!(a[j>>0]|0)){i=e;return b|0}f=c[c[b>>2]>>2]|0;m=SEi(j|0)|0;xo[f&2047](b,j,m)|0;i=e;return b|0}function _Ua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*12|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?516096:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*12|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2])}k=k+12|0;if(k>>>0>=j>>>0)break;else l=l+12|0}}if(j){g[j>>2]=ea(g[b>>2]);g[n+(f*12|0)+4>>2]=ea(g[b+4>>2]);g[n+(f*12|0)+8>>2]=ea(g[b+8>>2])}if((c[e>>2]|0)<=-1){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*12|0)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*12|0)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);o=c[m>>2]|0;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*12|0)|0;i=d;return q|0}function $Ua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<3;h=b+32|0;if(!((a[h>>0]|0)==0&g>>>0<33))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?427112:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+40>>2]|0;h=f+(j<<3)|0;n=b+36|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j){a[j>>0]=a[g>>0]|0;c[j+4>>2]=c[g+4>>2]}j=j+8|0;if(j>>>0>=h>>>0)break;else g=g+8|0}}g=b+44|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+32>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function aVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+44|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<3;k=b+32|0;if(!((a[k>>0]|0)==0&g>>>0<33))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?427112:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+40|0;k=c[l>>2]|0;p=j+(k<<3)|0;g=b+36|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m){a[m>>0]=a[n>>0]|0;c[m+4>>2]=c[n+4>>2]}m=m+8|0;if(m>>>0>=p>>>0)break;else n=n+8|0}q=c[l>>2]|0}else q=k;k=j+(q<<3)|0;if(k){a[k>>0]=a[d>>0]|0;c[k+4>>2]=c[d+4>>2]}do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+32>>0]=0;break}if(d){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,d)}}while(0);c[g>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h<<3)|0}function bVa(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+44>>2]&2147483647)>>>0<b>>>0)$Ua(a,b);c[a+40>>2]=b;i=d;return}function cVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?427224:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function dVa(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;f=b+228|0;g[f>>2]=d;h=(c[b+4>>2]|0)>>>30;if((h|0)==2){j=c[b>>2]|0;if(!(a[j+2416>>0]|0)){k=j;l=4}}else if((h|0)!=3){k=c[b>>2]|0;l=4}if((l|0)==4){if((k|0)!=0&d>ea(0.0))c[b+232>>2]=0;e9(b+16|0,d,0);i=e;return}if(!(d>ea(0.0))){r4(c[b>>2]|0,b);k=b+236|0;c[k>>2]=c[k>>2]|1048576;i=e;return}if((h|0)==2){k=c[b>>2]|0;if(!(a[k+2416>>0]|0))l=11;else{m=k;l=12}}else if((h|0)==3){m=c[b>>2]|0;l=12}else l=11;if((l|0)==11){c[b+232>>2]=0;g[f>>2]=d;e9(b+16|0,d,1);i=e;return}else if((l|0)==12){c[b+232>>2]=0;g[f>>2]=d;r4(m,b);m=b+236|0;c[m>>2]=c[m>>2]&-7340033|5242880;i=e;return}}function eVa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=b+4|0;f=c[e>>2]|0;h=f>>>30;if((h|0)==2){if(!(a[(c[b>>2]|0)+2416>>0]|0))j=3}else if((h|0)!=3)j=3;if((j|0)==3){c[b+232>>2]=1;k=b+204|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;b9(b+16|0);i=d;return}c[b+232>>2]=1;g[b+228>>2]=ea(0.0);g[b+204>>2]=ea(0.0);g[b+208>>2]=ea(0.0);g[b+212>>2]=ea(0.0);if((h|0)==3){l=c[b>>2]|0;j=8}else if((h|0)==2?(h=c[b>>2]|0,(a[h+2416>>0]|0)!=0):0){l=h;j=8}else j=7;if((j|0)==7){g[b+96>>2]=ea(0.0);g[b+100>>2]=ea(0.0);g[b+104>>2]=ea(0.0);m=f}else if((j|0)==8){r4(l,b);l=b+236|0;c[l>>2]=c[l>>2]|262144;m=c[e>>2]|0}g[b+216>>2]=ea(0.0);g[b+220>>2]=ea(0.0);g[b+224>>2]=ea(0.0);e=m>>>30;if((e|0)==2){m=c[b>>2]|0;if(!(a[m+2416>>0]|0))j=12;else{n=m;j=13}}else if((e|0)==3){n=c[b>>2]|0;j=13}else j=12;if((j|0)==12){g[b+112>>2]=ea(0.0);g[b+116>>2]=ea(0.0);g[b+120>>2]=ea(0.0);o=c[b+236>>2]|0}else if((j|0)==13){r4(n,b);n=b+236|0;j=c[n>>2]|524288;c[n>>2]=j;o=j}j=b+236|0;c[j>>2]=o&-57345;r4(c[b>>2]|0,b);c[j>>2]=c[j>>2]&-7340033|3145728;i=d;return}function fVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+28|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+16|0;if(!((a[k>>0]|0)==0&g>>>0<17))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?430528:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+24|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+20|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+16>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function gVa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+64|0;f=e+28|0;h=e;In[c[(c[b>>2]|0)+84>>2]&4095](h,b);j=d+16|0;k=ea(ea(g[j>>2])*ea(2.0));l=d+20|0;m=ea(ea(g[l>>2])*ea(2.0));n=d+24|0;o=ea(ea(g[n>>2])*ea(2.0));p=ea(g[h+12>>2]);q=ea(ea(p*p)+ea(-.5));r=ea(g[h>>2]);s=ea(k*r);t=ea(g[h+4>>2]);u=ea(s+ea(m*t));s=ea(g[h+8>>2]);v=ea(u+ea(o*s));u=ea(ea(r*v)+ea(ea(k*q)+ea(p*ea(ea(o*t)-ea(m*s)))));w=ea(ea(t*v)+ea(ea(m*q)+ea(p*ea(ea(k*s)-ea(o*r)))));x=ea(ea(ea(o*q)+ea(p*ea(ea(m*r)-ea(k*t))))+ea(s*v));v=ea(ea(g[h+16>>2])+u);u=ea(ea(g[h+20>>2])+w);w=ea(ea(g[h+24>>2])+x);x=ea(g[d>>2]);k=ea(p*x);h=d+12|0;m=ea(g[h>>2]);q=ea(k+ea(r*m));y=d+8|0;k=ea(g[y>>2]);o=ea(q+ea(t*k));z=d+4|0;q=ea(g[z>>2]);A=ea(o-ea(s*q));o=ea(ea(ea(s*x)+ea(ea(t*m)+ea(p*q)))-ea(r*k));B=ea(ea(ea(r*q)+ea(ea(s*m)+ea(p*k)))-ea(t*x));C=ea(ea(ea(ea(p*m)-ea(r*x))-ea(t*q))-ea(s*k));g[f>>2]=A;g[f+4>>2]=o;g[f+8>>2]=B;g[f+12>>2]=C;g[f+16>>2]=v;g[f+20>>2]=u;g[f+24>>2]=w;D=b+48|0;g[b+224>>2]=A;g[b+228>>2]=o;g[b+232>>2]=B;g[b+236>>2]=C;g[b+240>>2]=v;g[b+244>>2]=u;g[b+248>>2]=w;E=b+52|0;F=(c[E>>2]|0)>>>30;if((F|0)==3)G=4;else if((F|0)==2?(a[(c[D>>2]|0)+2417>>0]|0)!=0:0)G=4;else G=3;if((G|0)==3)M8(b+64|0,f);else if((G|0)==4){f=b+284|0;F=c[f>>2]|0;if(!(F&65536))c[f>>2]=F|131072;r4(c[D>>2]|0,D);c[f>>2]=c[f>>2]|65536}f=c[E>>2]|0;E=f>>>30;if((E|0)==2)if(!(a[(c[D>>2]|0)+2417>>0]|0))G=10;else{H=D;G=11}else if((E|0)==3){H=D;G=11}else G=10;if((G|0)==10){g[b+112>>2]=ea(g[d>>2]);g[b+116>>2]=ea(g[z>>2]);g[b+120>>2]=ea(g[y>>2]);g[b+124>>2]=ea(g[h>>2]);g[b+128>>2]=ea(g[j>>2]);g[b+132>>2]=ea(g[l>>2]);g[b+136>>2]=ea(g[n>>2])}else if((G|0)==11){E=b+56|0;F=c[E>>2]|0;if(!F){I=s4(c[H>>2]|0,f>>>24&15)|0;c[E>>2]=I;J=I}else J=F;g[J+144>>2]=ea(g[d>>2]);g[J+148>>2]=ea(g[z>>2]);g[J+152>>2]=ea(g[y>>2]);g[J+156>>2]=ea(g[h>>2]);g[J+160>>2]=ea(g[j>>2]);g[J+164>>2]=ea(g[l>>2]);g[J+168>>2]=ea(g[n>>2]);r4(c[H>>2]|0,D);D=b+284|0;c[D>>2]=c[D>>2]|512}D=c[b+16>>2]|0;if(!D){i=e;return}H=c[D+36>>2]|0;n=c[D+40>>2]|0;if(!n){i=e;return}D=0;while(1){if(!(a[H+(D<<3)>>0]|0)){J=c[H+(D<<3)+4>>2]|0;if(!J){G=21;break}MX(J,b)}D=D+1|0;if(D>>>0>=n>>>0){G=21;break}}if((G|0)==21){i=e;return}}function hVa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=0,C=Im,D=0,E=0;f=i;i=i+128|0;h=f+108|0;j=f+96|0;k=f+60|0;l=f+48|0;m=f+36|0;n=f;if((e|0)==3){TAb(a+48|0,b,d);i=f;return}else if((e|0)==1){if(!b)o=0;else{if(!(c[a+284>>2]&1))p=ea(S8(a+64|0));else{q=a+56|0;r=c[q>>2]|0;if(!r){s=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[q>>2]=s;t=s}else t=r;p=ea(g[t+92>>2])}u=ea(p*ea(g[b>>2]));v=ea(p*ea(g[b+4>>2]));w=ea(p*ea(g[b+8>>2]));g[l>>2]=u;g[l+4>>2]=v;g[l+8>>2]=w;o=l}l=a+48|0;if(!d)x=0;else{SAb(n,l);w=ea(g[d>>2]);v=ea(w*ea(g[n>>2]));u=ea(w*ea(g[n+4>>2]));p=ea(w*ea(g[n+8>>2]));w=ea(g[d+4>>2]);y=ea(w*ea(g[n+12>>2]));z=ea(w*ea(g[n+16>>2]));A=ea(v+y);y=ea(u+z);z=ea(p+ea(w*ea(g[n+20>>2])));w=ea(g[d+8>>2]);p=ea(w*ea(g[n+24>>2]));u=ea(w*ea(g[n+28>>2]));v=ea(y+u);u=ea(z+ea(w*ea(g[n+32>>2])));g[m>>2]=ea(A+p);g[m+4>>2]=v;g[m+8>>2]=u;x=m}UAb(l,o,x);i=f;return}else if(!e){if(!b)B=0;else{if(!(c[a+284>>2]&1))C=ea(S8(a+64|0));else{x=a+56|0;o=c[x>>2]|0;if(!o){l=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[x>>2]=l;D=l}else D=o;C=ea(g[D+92>>2])}u=ea(C*ea(g[b>>2]));v=ea(C*ea(g[b+4>>2]));p=ea(C*ea(g[b+8>>2]));g[h>>2]=u;g[h+4>>2]=v;g[h+8>>2]=p;B=h}h=a+48|0;if(!d)E=0;else{SAb(k,h);p=ea(g[d>>2]);v=ea(p*ea(g[k>>2]));u=ea(p*ea(g[k+4>>2]));C=ea(p*ea(g[k+8>>2]));p=ea(g[d+4>>2]);A=ea(p*ea(g[k+12>>2]));w=ea(p*ea(g[k+16>>2]));z=ea(v+A);A=ea(u+w);w=ea(C+ea(p*ea(g[k+20>>2])));p=ea(g[d+8>>2]);C=ea(p*ea(g[k+24>>2]));u=ea(p*ea(g[k+28>>2]));v=ea(A+u);u=ea(w+ea(p*ea(g[k+32>>2])));g[j>>2]=ea(z+C);g[j+4>>2]=v;g[j+8>>2]=u;E=j}TAb(h,B,E);i=f;return}else if((e|0)==2){UAb(a+48|0,b,d);i=f;return}else{i=f;return}}function iVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;if((d|0)==3){f=b+48|0;g=c[b+52>>2]|0;h=g>>>30;if((h|0)==2){if(!(a[(c[f>>2]|0)+2416>>0]|0))j=10}else if((h|0)!=3)j=10;if((j|0)==10){P8(b+64|0);i=e;return}h=b+56|0;k=c[h>>2]|0;if(!k){l=s4(c[f>>2]|0,g>>>24&15)|0;c[h>>2]=l;m=l}else m=k;k=m+220|0;m=b+284|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[m>>2]=c[m>>2]&-16385;i=e;return}else if(!d){m=b+48|0;k=c[b+52>>2]|0;l=k>>>30;if((l|0)==2){if(!(a[(c[m>>2]|0)+2416>>0]|0))j=4}else if((l|0)!=3)j=4;if((j|0)==4){P8(b+64|0);i=e;return}l=b+56|0;h=c[l>>2]|0;if(!h){g=s4(c[m>>2]|0,k>>>24&15)|0;c[l>>2]=g;n=g}else n=h;h=n+220|0;n=b+284|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[n>>2]=c[n>>2]&-16385;i=e;return}else if((d|0)==2){n=b+48|0;h=c[b+52>>2]|0;g=h>>>30;if((g|0)==2){if(!(a[(c[n>>2]|0)+2416>>0]|0))j=22}else if((g|0)!=3)j=22;if((j|0)==22){R8(b+64|0);i=e;return}g=b+56|0;l=c[g>>2]|0;if(!l){k=s4(c[n>>2]|0,h>>>24&15)|0;c[g>>2]=k;o=k}else o=l;l=o+244|0;o=b+284|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[o>>2]=c[o>>2]&-32769;i=e;return}else if((d|0)==1){d=b+48|0;o=c[b+52>>2]|0;l=o>>>30;if((l|0)==2){if(!(a[(c[d>>2]|0)+2416>>0]|0))j=16}else if((l|0)!=3)j=16;if((j|0)==16){R8(b+64|0);i=e;return}j=b+56|0;l=c[j>>2]|0;if(!l){k=s4(c[d>>2]|0,o>>>24&15)|0;c[j>>2]=k;p=k}else p=l;l=p+244|0;p=b+284|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[p>>2]=c[p>>2]&-32769;i=e;return}else{i=e;return}}function jVa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;h=i;i=i+400|0;j=h+304|0;k=h+180|0;l=h+64|0;m=h+88|0;n=h+368|0;o=h;p=h+152|0;q=h+240|0;r=h+208|0;I2(d+20|0,e,f,d);s=d+48|0;t=c[d+52>>2]|0;if(!(t&1))u=(c[450992+((t>>>24&15)<<2)>>2]|0)+s+8|0;else{v=d+56|0;w=c[v>>2]|0;if(!w){x=s4(c[s>>2]|0,t>>>24&15)|0;c[v>>2]=x;y=x}else y=w;u=y}if(!(b[u>>1]&1)){i=h;return}u=f+3372|0;y=c[u>>2]|0;if((y&64|0)!=0?(a[f+3012>>0]|0)!=0:0){z=ea(g[f+2864>>2]);A=y}else{B=ea(Cda(f+32|0,0));z=B;A=c[u>>2]|0}if((A&64|0)!=0?(a[f+3023>>0]|0)!=0:0)C=ea(g[f+2908>>2]);else C=ea(Cda(f+32|0,11));B=ea(z*C);if(B!=ea(0.0)){In[c[(c[d>>2]|0)+84>>2]&4095](k,d);kLa(j,k);k=EKa(e,j)|0;g[l>>2]=B;g[l+4>>2]=B;g[l+8>>2]=B;c[l+12>>2]=-65536;c[l+16>>2]=-16711936;c[l+20>>2]=-16776961;JKa(k,l)|0}if((c[u>>2]&64|0)!=0?(a[f+3014>>0]|0)!=0:0)D=ea(g[f+2872>>2]);else D=ea(Cda(f+32|0,2));B=ea(z*D);if(B!=ea(0.0)){kLa(m,d+224|0);l=EKa(e,m)|0;g[n>>2]=B;g[n+4>>2]=B;g[n+8>>2]=B;c[n+12>>2]=-65536;c[n+16>>2]=-16711936;c[n+20>>2]=-16776961;JKa(l,n)|0}if((c[u>>2]&64|0)!=0?(a[f+3016>>0]|0)!=0:0)E=ea(g[f+2880>>2]);else E=ea(Cda(f+32|0,4));B=ea(z*E);if(B!=ea(0.0)){n=DKa(e,16777215)|0;g[o>>2]=ea(1.0);l=o+4|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[o+20>>2]=ea(1.0);l=o+24|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[o+40>>2]=ea(1.0);l=o+44|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[o+60>>2]=ea(1.0);l=EKa(n,o)|0;E=ea(B*ea(g[d+252>>2]));D=ea(B*ea(g[d+256>>2]));C=ea(B*ea(g[d+260>>2]));F=ea(B*ea(.200000003));B=ea(g[d+240>>2]);g[p>>2]=B;G=ea(g[d+244>>2]);g[p+4>>2]=G;H=ea(g[d+248>>2]);g[p+8>>2]=H;I=ea(D+G);G=ea(C+H);g[p+12>>2]=ea(E+B);g[p+16>>2]=I;g[p+20>>2]=G;g[p+24>>2]=F;IKa(l,p)|0}if((c[u>>2]&64|0)!=0?(a[f+3017>>0]|0)!=0:0)J=ea(g[f+2884>>2]);else J=ea(Cda(f+32|0,5));F=ea(z*J);if(!(F!=ea(0.0))){i=h;return}f=DKa(e,0)|0;g[q>>2]=ea(1.0);e=q+4|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[q+20>>2]=ea(1.0);e=q+24|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[q+40>>2]=ea(1.0);e=q+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[q+60>>2]=ea(1.0);e=EKa(f,q)|0;J=ea(F*ea(g[d+264>>2]));z=ea(F*ea(g[d+268>>2]));G=ea(F*ea(g[d+272>>2]));I=ea(F*ea(.200000003));F=ea(g[d+240>>2]);g[r>>2]=F;B=ea(g[d+244>>2]);g[r+4>>2]=B;E=ea(g[d+248>>2]);g[r+8>>2]=E;H=ea(z+B);B=ea(G+E);g[r+12>>2]=ea(J+F);g[r+16>>2]=H;g[r+20>>2]=B;g[r+24>>2]=I;IKa(e,r)|0;i=h;return}function kVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!d)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,d,k?528936:544544,537640,558)|0}k=c[b+4>>2]|0;g=f+k|0;h=c[b>>2]|0;if((k|0)>0){k=f;j=h;while(1){if(k)a[k>>0]=a[j>>0]|0;k=k+1|0;if((k|0)==(g|0))break;else j=j+1|0}l=c[b>>2]|0}else l=h;h=b+8|0;if((c[h>>2]|0)<0|(l|0)==0){c[b>>2]=f;c[h>>2]=d;i=e;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,l);c[b>>2]=f;c[h>>2]=d;i=e;return}function lVa(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)kVa(a,b);c[a+4>>2]=b;i=d;return}function mVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+12|0;f=c[e>>2]|0;h=f+24|0;j=a+8|0;k=c[j>>2]&2147483647;if(h>>>0>k>>>0?(l=(h*3|0)+256|0,k>>>0<l>>>0):0)kVa(a,l);lVa(a,h);l=(c[a>>2]|0)+(c[e>>2]|0)|0;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];c[l+16>>2]=c[b+16>>2];c[l+20>>2]=c[b+20>>2];c[e>>2]=h;l=c[b>>2]|0;if(!l)m=h;else{h=f+36|0;f=c[j>>2]&2147483647;if(h>>>0>f>>>0?(k=(h*3|0)+256|0,f>>>0<k>>>0):0)kVa(a,k);lVa(a,h);k=c[e>>2]|0;f=c[a>>2]|0;g[f+k>>2]=ea(g[l>>2]);g[f+(k+4)>>2]=ea(g[l+4>>2]);g[f+(k+8)>>2]=ea(g[l+8>>2]);c[e>>2]=h;m=h}h=c[b+4>>2]|0;if(!h)n=m;else{l=m+12|0;m=c[j>>2]&2147483647;if(l>>>0>m>>>0?(k=(l*3|0)+256|0,m>>>0<k>>>0):0)kVa(a,k);lVa(a,l);k=c[e>>2]|0;m=c[a>>2]|0;g[m+k>>2]=ea(g[h>>2]);g[m+(k+4)>>2]=ea(g[h+4>>2]);g[m+(k+8)>>2]=ea(g[h+8>>2]);c[e>>2]=l;n=l}l=c[b+16>>2]|0;if(!l)o=n;else{h=n+28|0;n=c[j>>2]&2147483647;if(h>>>0>n>>>0?(k=(h*3|0)+256|0,n>>>0<k>>>0):0)kVa(a,k);lVa(a,h);k=c[e>>2]|0;n=c[a>>2]|0;g[n+k>>2]=ea(g[l>>2]);g[n+(k+4)>>2]=ea(g[l+4>>2]);g[n+(k+8)>>2]=ea(g[l+8>>2]);g[n+(k+12)>>2]=ea(g[l+12>>2]);g[n+(k+16)>>2]=ea(g[l+16>>2]);g[n+(k+20)>>2]=ea(g[l+20>>2]);g[n+(k+24)>>2]=ea(g[l+24>>2]);c[e>>2]=h;o=h}h=c[b+12>>2]|0;if(!h){i=d;return}b=c[h>>2]|0;l=o+4|0;k=c[j>>2]&2147483647;if(l>>>0>k>>>0?(n=(l*3|0)+256|0,k>>>0<n>>>0):0)kVa(a,n);lVa(a,l);c[(c[a>>2]|0)+(c[e>>2]|0)>>2]=b;c[e>>2]=l;if((b|0)==3){l=o+20|0;n=c[j>>2]&2147483647;if(l>>>0>n>>>0?(k=(l*3|0)+256|0,n>>>0<k>>>0):0)kVa(a,k);lVa(a,l);k=c[e>>2]|0;n=c[a>>2]|0;c[n+k>>2]=c[h>>2];g[n+(k+4)>>2]=ea(g[h+4>>2]);g[n+(k+8)>>2]=ea(g[h+8>>2]);g[n+(k+12)>>2]=ea(g[h+12>>2]);c[e>>2]=l;i=d;return}else if((b|0)==2){l=o+16|0;k=c[j>>2]&2147483647;if(l>>>0>k>>>0?(n=(l*3|0)+256|0,k>>>0<n>>>0):0)kVa(a,n);lVa(a,l);n=(c[a>>2]|0)+(c[e>>2]|0)|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[e>>2]=l;i=d;return}else if((b|0)==4){l=o+40|0;n=c[j>>2]&2147483647;if(l>>>0>n>>>0?(k=(l*3|0)+256|0,n>>>0<k>>>0):0)kVa(a,k);lVa(a,l);k=c[e>>2]|0;n=c[a>>2]|0;c[n+k>>2]=c[h>>2];g[n+(k+4)>>2]=ea(g[h+4>>2]);g[n+(k+8)>>2]=ea(g[h+8>>2]);g[n+(k+12)>>2]=ea(g[h+12>>2]);g[n+(k+16)>>2]=ea(g[h+16>>2]);g[n+(k+20)>>2]=ea(g[h+20>>2]);g[n+(k+24)>>2]=ea(g[h+24>>2]);g[n+(k+28)>>2]=ea(g[h+28>>2]);c[n+(k+32)>>2]=c[h+32>>2];c[e>>2]=l;i=d;return}else if(!b){b=o+12|0;o=c[j>>2]&2147483647;if(b>>>0>o>>>0?(j=(b*3|0)+256|0,o>>>0<j>>>0):0)kVa(a,j);lVa(a,b);j=h;h=c[j+4>>2]|0;o=(c[a>>2]|0)+(c[e>>2]|0)|0;c[o>>2]=c[j>>2];c[o+4>>2]=h;c[e>>2]=b;i=d;return}else{i=d;return}}function nVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function oVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function pVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function qVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function rVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function sVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+16|0;f=c[b>>2]|0;h=ea(e>>>0);j=~~ea(h*ea(g[a+24>>2]))>>>0;k=e<<2;l=j<<2;m=l+k|0;n=(0-m&12)+m|0;m=UJa(a,n+l|0,529024,354)|0;l=m+k|0;o=m+n|0;PEi(m|0,-1,k|0)|0;k=a+36|0;n=a+4|0;if(c[k>>2]|0){p=e+-1|0;q=0;do{r=c[(c[n>>2]|0)+(q<<2)>>2]|0;s=r;t=s+~(s<<15)|0;s=(t>>>10^t)*9|0;t=s>>>6^s;s=t+~(t<<11)|0;t=m+(((s>>>16^s)&p)<<2)|0;c[l+(q<<2)>>2]=c[t>>2];c[t>>2]=q;t=o+(q<<2)|0;if(t)c[t>>2]=r;q=q+1|0}while(q>>>0<(c[k>>2]|0)>>>0)}VJa(a,c[a>>2]|0);c[a>>2]=m;c[a+12>>2]=m;c[a+20>>2]=e;c[a+8>>2]=l;c[n>>2]=o;c[b>>2]=j;j=a+28|0;if((c[j>>2]|0)!=-1){i=d;return}c[j>>2]=f;i=d;return}function tVa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)VAb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function uVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?433504:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function vVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?433504:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function wVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?427224:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function xVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?433384:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function yVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?433384:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function zVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?433272:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function AVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?433272:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function BVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){qVa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function CVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+36|0;if((c[e>>2]|0)==(c[b+16>>2]|0)){r=j?16:h<<1;if(h>>>0<r>>>0){sVa(b,r);t=c[g>>2]|0}else t=h;h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;u=(h>>>16^h)&t+-1}else u=n;n=b+28|0;t=c[n>>2]|0;c[n>>2]=t+1;n=(c[b+12>>2]|0)+(u<<2)|0;c[(c[b+8>>2]|0)+(t<<2)>>2]=c[n>>2];c[n>>2]=t;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(t<<2)|0;i=f;return s|0}function DVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,200,h?434544:544544,431648,205)|0;o3(g,a,b);i=d;return g|0}function EVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,200,h?434424:544544,431648,210)|0;a3(g,a,b);i=d;return g|0}function FVa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,152,m?434320:544544,431648,285)|0;b[h>>1]=b[f>>1]|0;B4(l,a,d,e,h);i=g;return l|0}function GVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=mKa()|0;e=c[(c[d>>2]|0)+8>>2]|0;f=pKa()|0;g=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=Bn[e&255](d,36,g?434200:544544,431648,290)|0;E6(f);if(!f){h=0;i=b;return h|0}if(N6(f,a)|0){h=f;i=b;return h|0}a=f+8|0;if(gTa(f+12|0)|0){h=0;i=b;return h|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);h=0;i=b;return h|0}function HVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=mKa()|0;e=c[(c[d>>2]|0)+8>>2]|0;f=pKa()|0;g=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=Bn[e&255](d,36,g?434200:544544,431648,301)|0;E6(f);if(!f){h=0;i=b;return h|0}if(O6(f,a)|0){h=f;i=b;return h|0}a=f+8|0;if(gTa(f+12|0)|0){h=0;i=b;return h|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);h=0;i=b;return h|0}function IVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?433040:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function JVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?433040:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function KVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+20|0;f=c[e>>2]|0;if(!f){g=0;i=d;return g|0}h=c[b>>2]|0;b=h;j=b+~(b<<15)|0;b=(j>>>10^j)*9|0;j=b>>>6^b;b=j+~(j<<11)|0;j=a+12|0;k=c[j>>2]|0;l=k+(((b>>>16^b)&f+-1)<<2)|0;f=c[l>>2]|0;if((f|0)==-1){g=0;i=d;return g|0}b=a+4|0;m=c[b>>2]|0;n=a+8|0;o=f;f=l;while(1){p=m+(o<<2)|0;if((c[p>>2]|0)==(h|0))break;l=(c[n>>2]|0)+(o<<2)|0;q=c[l>>2]|0;if((q|0)==-1){g=0;r=14;break}else{o=q;f=l}}if((r|0)==14){i=d;return g|0}if((o|0)==-1){g=0;i=d;return g|0}r=c[n>>2]|0;c[f>>2]=c[r+(o<<2)>>2];f=a+36|0;l=(c[f>>2]|0)+-1|0;c[f>>2]=l;q=a+32|0;c[q>>2]=(c[q>>2]|0)+1;if((o|0)!=(l|0)){if(!p){s=r;t=h;u=k}else{c[p>>2]=c[m+(l<<2)>>2];s=c[n>>2]|0;t=c[(c[b>>2]|0)+(o<<2)>>2]|0;u=c[j>>2]|0}c[s+(o<<2)>>2]=c[s+(l<<2)>>2];l=t;t=l+~(l<<15)|0;l=(t>>>10^t)*9|0;t=l>>>6^l;l=t+~(t<<11)|0;t=u+(((l>>>16^l)&(c[e>>2]|0)+-1)<<2)|0;e=c[t>>2]|0;l=c[f>>2]|0;if((e|0)==(l|0))v=t;else{t=e;do{e=s+(t<<2)|0;t=c[e>>2]|0}while((t|0)!=(l|0));v=e}c[v>>2]=o}o=a+28|0;c[o>>2]=(c[o>>2]|0)+-1;g=1;i=d;return g|0}function LVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){oVa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function MVa(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=mKa()|0;d=c[(c[b>>2]|0)+8>>2]|0;e=pKa()|0;f=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;e=Bn[d&255](b,108,f?434080:544544,431648,475)|0;fV(e);if(e){i=a;return e|0}dKa(bKa()|0,32,431648,477,434024,a);i=a;return e|0}function NVa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;e=i;i=i+96|0;f=e;h=e+60|0;j=e+32|0;k=e+4|0;l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,336,o?433896:544544,431648,487)|0;FW(n,d,a,b);if(!n){dKa(bKa()|0,32,431648,490,433624,f);p=0;i=e;return p|0}if(!b){p=n;i=e;return p|0}In[c[(c[b>>2]|0)+124>>2]&4095](j,b);q=ea(-ea(g[j>>2]));r=ea(-ea(g[j+4>>2]));s=ea(-ea(g[j+8>>2]));t=ea(g[j+12>>2]);u=ea(g[d+16>>2]);v=ea(u-ea(g[j+16>>2]));u=ea(g[d+20>>2]);w=ea(u-ea(g[j+20>>2]));u=ea(g[d+24>>2]);x=ea(v*ea(2.0));v=ea(w*ea(2.0));w=ea(ea(u-ea(g[j+24>>2]))*ea(2.0));u=ea(ea(t*t)+ea(-.5));y=ea(ea(ea(x*q)+ea(v*r))+ea(w*s));z=ea(ea(y*q)+ea(ea(u*x)+ea(t*ea(ea(w*r)-ea(v*s)))));A=ea(ea(y*r)+ea(ea(u*v)+ea(t*ea(ea(x*s)-ea(w*q)))));B=ea(ea(ea(u*w)+ea(t*ea(ea(v*q)-ea(x*r))))+ea(y*s));y=ea(g[d>>2]);x=ea(t*y);v=ea(g[d+12>>2]);w=ea(x+ea(v*q));x=ea(g[d+8>>2]);u=ea(w+ea(x*r));w=ea(g[d+4>>2]);C=ea(ea(ea(y*s)+ea(ea(v*r)+ea(t*w)))-ea(x*q));D=ea(ea(ea(w*q)+ea(ea(v*s)+ea(t*x)))-ea(y*r));E=ea(ea(ea(ea(t*v)-ea(y*q))-ea(w*r))-ea(x*s));g[h>>2]=ea(u-ea(w*s));g[h+4>>2]=C;g[h+8>>2]=D;g[h+12>>2]=E;g[h+16>>2]=z;g[h+20>>2]=A;g[h+24>>2]=B;g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(1.0);g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);d=mKa()|0;j=c[(c[d>>2]|0)+8>>2]|0;a=pKa()|0;o=mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0;a=Bn[j&255](d,204,o?433768:544544,431648,500)|0;TV(a,b,h,n,k);if(!a){ko[c[(c[n>>2]|0)+16>>2]&4095](n);dKa(bKa()|0,32,431648,505,433680,f);p=0;i=e;return p|0}else{c[n+292>>2]=a;p=n;i=e;return p|0}return 0}function OVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){pVa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function PVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){nVa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function QVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?432584:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else WAb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*48|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-48|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function RVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;XAb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else YAb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(ZAb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,ZAb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+48|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){WAb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function SVa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((c[a+20>>2]&2147483647)>>>0<d>>>0)_Ab(a,d);g=c[a+12>>2]|0;h=a+16|0;a=c[h>>2]|0;j=g+(d<<1)|0;if((a|0)>=(d|0)){c[h>>2]=d;i=f;return}k=g+(a<<1)|0;do{if(k)b[k>>1]=b[e>>1]|0;k=k+2|0}while(k>>>0<j>>>0);c[h>>2]=d;i=f;return}function TVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;e=b+4|0;f=a+20|0;g=c[f>>2]|0;h=a+16|0;j=c[h>>2]|0;if(!g){k=j;VJa(e,k);i=b;return}l=a+4|0;m=a+12|0;n=a+8|0;o=j;j=g;g=0;while(1){p=c[o+(g<<2)>>2]|0;if(!p){q=j;r=o}else{s=c[p+52>>2]|0;c[d>>2]=s;do if(((c[a>>2]|0)+-1|0)==(s|0)){c[a>>2]=s;t=o}else{p=c[n>>2]|0;if((c[m>>2]&2147483647)>>>0<=p>>>0){cUa(l,d)|0;t=c[h>>2]|0;break}u=(c[l>>2]|0)+(p<<2)|0;if(!u)v=p;else{c[u>>2]=s;v=c[n>>2]|0}c[n>>2]=v+1;t=o}while(0);s=c[t+(g<<2)>>2]|0;ko[c[c[s>>2]>>2]&4095](s);c[(c[h>>2]|0)+(g<<2)>>2]=0;q=c[f>>2]|0;r=c[h>>2]|0}g=g+1|0;if(g>>>0>=q>>>0){k=r;break}else{o=r;j=q}}VJa(e,k);i=b;return}function UVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?435824:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function VVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function WVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?435520:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function XVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){VVa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function YVa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0;e=i;i=i+32|0;f=e;h=b+48|0;j=b+284|0;if(!(c[j>>2]&512))k=b+112|0;else{l=b+56|0;m=c[l>>2]|0;if(!m){n=s4(c[h>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[l>>2]=n;o=n}else o=m;k=o+144|0}p=ea(ea(g[k+16>>2])*ea(2.0));q=ea(ea(g[k+20>>2])*ea(2.0));r=ea(ea(g[k+24>>2])*ea(2.0));s=ea(g[d+12>>2]);t=ea(ea(s*s)+ea(-.5));u=ea(g[d>>2]);v=ea(p*u);w=ea(g[d+4>>2]);x=ea(v+ea(q*w));v=ea(g[d+8>>2]);y=ea(x+ea(r*v));x=ea(ea(u*y)+ea(ea(p*t)+ea(s*ea(ea(r*w)-ea(q*v)))));z=ea(ea(w*y)+ea(ea(q*t)+ea(s*ea(ea(p*v)-ea(r*u)))));A=ea(ea(ea(r*t)+ea(s*ea(ea(q*u)-ea(p*w))))+ea(v*y));y=ea(ea(g[d+16>>2])+x);x=ea(ea(g[d+20>>2])+z);z=ea(ea(g[d+24>>2])+A);A=ea(g[k>>2]);p=ea(s*A);q=ea(g[k+12>>2]);t=ea(p+ea(u*q));p=ea(g[k+8>>2]);r=ea(t+ea(w*p));t=ea(g[k+4>>2]);B=ea(ea(ea(v*A)+ea(ea(w*q)+ea(s*t)))-ea(u*p));C=ea(ea(ea(u*t)+ea(ea(v*q)+ea(s*p)))-ea(w*A));D=ea(ea(ea(ea(s*q)-ea(u*A))-ea(w*t))-ea(v*p));g[f>>2]=ea(r-ea(v*t));g[f+4>>2]=B;g[f+8>>2]=C;g[f+12>>2]=D;g[f+16>>2]=y;g[f+20>>2]=x;g[f+24>>2]=z;$Ab(h,f);f=LU(b)|0;if(!(c[j>>2]&4096))E=b+108|0;else{j=b+56|0;k=c[j>>2]|0;if(!k){d=s4(c[h>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[j>>2]=d;F=d}else F=k;E=F+268|0}if((a[E>>0]&2)==0|(f|0)==0){i=e;return}G2(b+20|0,f+3376|0);b=f+3400|0;c[b>>2]=(c[b>>2]|0)+1;i=e;return}function ZVa(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+64|0;f=e+28|0;h=e;In[c[(c[b>>2]|0)+84>>2]&4095](h,b);j=d+16|0;k=ea(ea(g[j>>2])*ea(2.0));l=d+20|0;m=ea(ea(g[l>>2])*ea(2.0));n=d+24|0;o=ea(ea(g[n>>2])*ea(2.0));p=ea(g[h+12>>2]);q=ea(ea(p*p)+ea(-.5));r=ea(g[h>>2]);s=ea(k*r);t=ea(g[h+4>>2]);u=ea(s+ea(m*t));s=ea(g[h+8>>2]);v=ea(u+ea(o*s));u=ea(ea(r*v)+ea(ea(k*q)+ea(p*ea(ea(o*t)-ea(m*s)))));w=ea(ea(t*v)+ea(ea(m*q)+ea(p*ea(ea(k*s)-ea(o*r)))));x=ea(ea(ea(o*q)+ea(p*ea(ea(m*r)-ea(k*t))))+ea(s*v));v=ea(ea(g[h+16>>2])+u);u=ea(ea(g[h+20>>2])+w);w=ea(ea(g[h+24>>2])+x);x=ea(g[d>>2]);k=ea(p*x);h=d+12|0;m=ea(g[h>>2]);q=ea(k+ea(r*m));y=d+8|0;k=ea(g[y>>2]);o=ea(q+ea(t*k));z=d+4|0;q=ea(g[z>>2]);A=ea(o-ea(s*q));o=ea(ea(ea(s*x)+ea(ea(t*m)+ea(p*q)))-ea(r*k));B=ea(ea(ea(r*q)+ea(ea(s*m)+ea(p*k)))-ea(t*x));C=ea(ea(ea(ea(p*m)-ea(r*x))-ea(t*q))-ea(s*k));g[f>>2]=A;g[f+4>>2]=o;g[f+8>>2]=B;g[f+12>>2]=C;g[f+16>>2]=v;g[f+20>>2]=u;g[f+24>>2]=w;D=b+48|0;g[b+224>>2]=A;g[b+228>>2]=o;g[b+232>>2]=B;g[b+236>>2]=C;g[b+240>>2]=v;g[b+244>>2]=u;g[b+248>>2]=w;E=b+52|0;F=(c[E>>2]|0)>>>30;if((F|0)==2)if(!(a[(c[D>>2]|0)+2417>>0]|0))G=3;else G=4;else if((F|0)==3)G=4;else G=3;if((G|0)==3)M8(b+64|0,f);else if((G|0)==4){f=b+284|0;F=c[f>>2]|0;if(!(F&65536))c[f>>2]=F|131072;r4(c[D>>2]|0,D);c[f>>2]=c[f>>2]|65536}f=c[E>>2]|0;E=f>>>30;if((E|0)==3){H=D;G=11}else if((E|0)==2?(a[(c[D>>2]|0)+2417>>0]|0)!=0:0){H=D;G=11}else G=10;if((G|0)==10){g[b+112>>2]=ea(g[d>>2]);g[b+116>>2]=ea(g[z>>2]);g[b+120>>2]=ea(g[y>>2]);g[b+124>>2]=ea(g[h>>2]);g[b+128>>2]=ea(g[j>>2]);g[b+132>>2]=ea(g[l>>2]);g[b+136>>2]=ea(g[n>>2])}else if((G|0)==11){E=b+56|0;F=c[E>>2]|0;if(!F){I=s4(c[H>>2]|0,f>>>24&15)|0;c[E>>2]=I;J=I}else J=F;g[J+144>>2]=ea(g[d>>2]);g[J+148>>2]=ea(g[z>>2]);g[J+152>>2]=ea(g[y>>2]);g[J+156>>2]=ea(g[h>>2]);g[J+160>>2]=ea(g[j>>2]);g[J+164>>2]=ea(g[l>>2]);g[J+168>>2]=ea(g[n>>2]);r4(c[H>>2]|0,D);D=b+284|0;c[D>>2]=c[D>>2]|512}D=c[b+16>>2]|0;if(!D){i=e;return}H=c[D+36>>2]|0;n=c[D+40>>2]|0;if(!n){i=e;return}D=0;while(1){if(!(a[H+(D<<3)>>0]|0)){J=c[H+(D<<3)+4>>2]|0;if(!J){G=21;break}MX(J,b)}D=D+1|0;if(D>>>0>=n>>>0){G=21;break}}if((G|0)==21){i=e;return}}function _Va(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=0,C=Im,D=0,E=0;f=i;i=i+128|0;h=f+108|0;j=f+96|0;k=f+60|0;l=f+48|0;m=f+36|0;n=f;if((e|0)==3){TAb(a+48|0,b,d);i=f;return}else if((e|0)==1){if(!b)o=0;else{if(!(c[a+284>>2]&1))p=ea(S8(a+64|0));else{q=a+56|0;r=c[q>>2]|0;if(!r){s=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[q>>2]=s;t=s}else t=r;p=ea(g[t+92>>2])}u=ea(p*ea(g[b>>2]));v=ea(p*ea(g[b+4>>2]));w=ea(p*ea(g[b+8>>2]));g[l>>2]=u;g[l+4>>2]=v;g[l+8>>2]=w;o=l}l=a+48|0;if(!d)x=0;else{SAb(n,l);w=ea(g[d>>2]);v=ea(w*ea(g[n>>2]));u=ea(w*ea(g[n+4>>2]));p=ea(w*ea(g[n+8>>2]));w=ea(g[d+4>>2]);y=ea(w*ea(g[n+12>>2]));z=ea(w*ea(g[n+16>>2]));A=ea(v+y);y=ea(u+z);z=ea(p+ea(w*ea(g[n+20>>2])));w=ea(g[d+8>>2]);p=ea(w*ea(g[n+24>>2]));u=ea(w*ea(g[n+28>>2]));v=ea(y+u);u=ea(z+ea(w*ea(g[n+32>>2])));g[m>>2]=ea(A+p);g[m+4>>2]=v;g[m+8>>2]=u;x=m}UAb(l,o,x);i=f;return}else if(!e){if(!b)B=0;else{if(!(c[a+284>>2]&1))C=ea(S8(a+64|0));else{x=a+56|0;o=c[x>>2]|0;if(!o){l=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[x>>2]=l;D=l}else D=o;C=ea(g[D+92>>2])}u=ea(C*ea(g[b>>2]));v=ea(C*ea(g[b+4>>2]));p=ea(C*ea(g[b+8>>2]));g[h>>2]=u;g[h+4>>2]=v;g[h+8>>2]=p;B=h}h=a+48|0;if(!d)E=0;else{SAb(k,h);p=ea(g[d>>2]);v=ea(p*ea(g[k>>2]));u=ea(p*ea(g[k+4>>2]));C=ea(p*ea(g[k+8>>2]));p=ea(g[d+4>>2]);A=ea(p*ea(g[k+12>>2]));w=ea(p*ea(g[k+16>>2]));z=ea(v+A);A=ea(u+w);w=ea(C+ea(p*ea(g[k+20>>2])));p=ea(g[d+8>>2]);C=ea(p*ea(g[k+24>>2]));u=ea(p*ea(g[k+28>>2]));v=ea(A+u);u=ea(w+ea(p*ea(g[k+32>>2])));g[j>>2]=ea(z+C);g[j+4>>2]=v;g[j+8>>2]=u;E=j}TAb(h,B,E);i=f;return}else if((e|0)==2){UAb(a+48|0,b,d);i=f;return}else{i=f;return}}function $Va(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;if(!d){f=b+48|0;g=c[b+52>>2]|0;h=g>>>30;if((h|0)==2){if(!(a[(c[f>>2]|0)+2416>>0]|0))j=4}else if((h|0)!=3)j=4;if((j|0)==4){P8(b+64|0);i=e;return}h=b+56|0;k=c[h>>2]|0;if(!k){l=s4(c[f>>2]|0,g>>>24&15)|0;c[h>>2]=l;m=l}else m=k;k=m+220|0;m=b+284|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[m>>2]=c[m>>2]&-16385;i=e;return}else if((d|0)==2){m=b+48|0;k=c[b+52>>2]|0;l=k>>>30;if((l|0)==2){if(!(a[(c[m>>2]|0)+2416>>0]|0))j=22}else if((l|0)!=3)j=22;if((j|0)==22){R8(b+64|0);i=e;return}l=b+56|0;h=c[l>>2]|0;if(!h){g=s4(c[m>>2]|0,k>>>24&15)|0;c[l>>2]=g;n=g}else n=h;h=n+244|0;n=b+284|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[n>>2]=c[n>>2]&-32769;i=e;return}else if((d|0)==3){n=b+48|0;h=c[b+52>>2]|0;g=h>>>30;if((g|0)==2){if(!(a[(c[n>>2]|0)+2416>>0]|0))j=10}else if((g|0)!=3)j=10;if((j|0)==10){P8(b+64|0);i=e;return}g=b+56|0;l=c[g>>2]|0;if(!l){k=s4(c[n>>2]|0,h>>>24&15)|0;c[g>>2]=k;o=k}else o=l;l=o+220|0;o=b+284|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[o>>2]=c[o>>2]&-16385;i=e;return}else if((d|0)==1){d=b+48|0;o=c[b+52>>2]|0;l=o>>>30;if((l|0)==2){if(!(a[(c[d>>2]|0)+2416>>0]|0))j=16}else if((l|0)!=3)j=16;if((j|0)==16){R8(b+64|0);i=e;return}j=b+56|0;l=c[j>>2]|0;if(!l){k=s4(c[d>>2]|0,o>>>24&15)|0;c[j>>2]=k;p=k}else p=l;l=p+244|0;p=b+284|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[p>>2]=c[p>>2]&-32769;i=e;return}else{i=e;return}}function aWa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b>>2]|0;if(!e){c[b+232>>2]=1;f=b+204|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;b9(b+16|0);i=d;return}if(!(a[e+2417>>0]|0))Q3(e,b,1);if(!(a[(c[b>>2]|0)+2417>>0]|0)){c[b+232>>2]=1;e=b+204|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;b9(b+16|0)}else eVa(b);e=b+16|0;if((c[b+4>>2]&-1073741824|0)!=1073741824){i=d;return}f=b+172|0;if(!(c[f>>2]|0)){i=d;return}g=h9(e,1)|0;h=(c[f>>2]|0)==0;if(g){if(h){i=d;return}c9(e,c[(c[b>>2]|0)+1256>>2]|0,1);i=d;return}if(h){i=d;return}if(!(h9(e,0)|0)){i=d;return}if(!(c[f>>2]|0)){i=d;return}c9(e,c[(c[b>>2]|0)+1256>>2]|0,0);i=d;return}function bWa(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;h=i;i=i+400|0;j=h+304|0;k=h+180|0;l=h+64|0;m=h+88|0;n=h+368|0;o=h;p=h+152|0;q=h+240|0;r=h+208|0;I2(d+20|0,e,f,d);s=d+48|0;t=c[d+52>>2]|0;if(!(t&1))u=(c[450992+((t>>>24&15)<<2)>>2]|0)+s+8|0;else{v=d+56|0;w=c[v>>2]|0;if(!w){x=s4(c[s>>2]|0,t>>>24&15)|0;c[v>>2]=x;y=x}else y=w;u=y}if(!(b[u>>1]&1)){i=h;return}u=f+3372|0;y=c[u>>2]|0;if((y&64|0)!=0?(a[f+3012>>0]|0)!=0:0){z=ea(g[f+2864>>2]);A=y}else{B=ea(Cda(f+32|0,0));z=B;A=c[u>>2]|0}if((A&64|0)!=0?(a[f+3023>>0]|0)!=0:0)C=ea(g[f+2908>>2]);else C=ea(Cda(f+32|0,11));B=ea(z*C);if(B!=ea(0.0)){In[c[(c[d>>2]|0)+84>>2]&4095](k,d);kLa(j,k);k=EKa(e,j)|0;g[l>>2]=B;g[l+4>>2]=B;g[l+8>>2]=B;c[l+12>>2]=-65536;c[l+16>>2]=-16711936;c[l+20>>2]=-16776961;JKa(k,l)|0}if((c[u>>2]&64|0)!=0?(a[f+3014>>0]|0)!=0:0)D=ea(g[f+2872>>2]);else D=ea(Cda(f+32|0,2));B=ea(z*D);if(B!=ea(0.0)){kLa(m,d+224|0);l=EKa(e,m)|0;g[n>>2]=B;g[n+4>>2]=B;g[n+8>>2]=B;c[n+12>>2]=-65536;c[n+16>>2]=-16711936;c[n+20>>2]=-16776961;JKa(l,n)|0}if((c[u>>2]&64|0)!=0?(a[f+3016>>0]|0)!=0:0)E=ea(g[f+2880>>2]);else E=ea(Cda(f+32|0,4));B=ea(z*E);if(B!=ea(0.0)){n=DKa(e,16777215)|0;g[o>>2]=ea(1.0);l=o+4|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[o+20>>2]=ea(1.0);l=o+24|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[o+40>>2]=ea(1.0);l=o+44|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[o+60>>2]=ea(1.0);l=EKa(n,o)|0;E=ea(B*ea(g[d+252>>2]));D=ea(B*ea(g[d+256>>2]));C=ea(B*ea(g[d+260>>2]));F=ea(B*ea(.200000003));B=ea(g[d+240>>2]);g[p>>2]=B;G=ea(g[d+244>>2]);g[p+4>>2]=G;H=ea(g[d+248>>2]);g[p+8>>2]=H;I=ea(D+G);G=ea(C+H);g[p+12>>2]=ea(E+B);g[p+16>>2]=I;g[p+20>>2]=G;g[p+24>>2]=F;IKa(l,p)|0}if((c[u>>2]&64|0)!=0?(a[f+3017>>0]|0)!=0:0)J=ea(g[f+2884>>2]);else J=ea(Cda(f+32|0,5));F=ea(z*J);if(!(F!=ea(0.0))){i=h;return}f=DKa(e,0)|0;g[q>>2]=ea(1.0);e=q+4|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[q+20>>2]=ea(1.0);e=q+24|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[q+40>>2]=ea(1.0);e=q+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[q+60>>2]=ea(1.0);e=EKa(f,q)|0;J=ea(F*ea(g[d+264>>2]));z=ea(F*ea(g[d+268>>2]));G=ea(F*ea(g[d+272>>2]));I=ea(F*ea(.200000003));F=ea(g[d+240>>2]);g[r>>2]=F;B=ea(g[d+244>>2]);g[r+4>>2]=B;E=ea(g[d+248>>2]);g[r+8>>2]=E;H=ea(z+B);B=ea(G+E);g[r+12>>2]=ea(J+F);g[r+16>>2]=H;g[r+20>>2]=B;g[r+24>>2]=I;IKa(e,r)|0;i=h;return}function cWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+12|0;u=a+4|0;v=e+-1|0;w=p;p=0;while(1){x=c[(c[t>>2]|0)+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=x;do{x=c[(c[u>>2]|0)+(z<<2)>>2]|0;A=x;B=A+~(A<<15)|0;A=(B>>>10^B)*9|0;B=A>>>6^A;A=B+~(B<<11)|0;B=o+(((A>>>16^A)&v)<<2)|0;c[n+(z<<2)>>2]=c[B>>2];c[B>>2]=z;B=q+(z<<2)|0;if(B)c[B>>2]=x;z=c[(c[f>>2]|0)+(z<<2)>>2]|0}while((z|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=a+4|0;m=e+-1|0;f=0;do{p=c[(c[w>>2]|0)+(f<<2)>>2]|0;v=p;u=v+~(v<<15)|0;v=(u>>>10^u)*9|0;u=v>>>6^v;v=u+~(u<<11)|0;u=o+(((v>>>16^v)&m)<<2)|0;c[n+(f<<2)>>2]=c[u>>2];c[u>>2]=f;u=q+(f<<2)|0;if(u)c[u>>2]=p;f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)C=j;else{D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}do{l=C;C=C+1|0;c[n+(l<<2)>>2]=C}while((C|0)!=(h|0));D=c[b>>2]|0;E=n+(h<<2)|0;c[E>>2]=D;c[b>>2]=j;i=d;return}function dWa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+3352>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+3344>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+2804|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+2764|0;d=c[e>>2]|0;if(d)VJa(e,d);d=a+2724|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+2684|0;d=c[e>>2]|0;if(d)VJa(e,d);d=a+2644|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+2604|0;d=c[e>>2]|0;if(d)VJa(e,d);d=a+2564|0;e=c[d>>2]|0;if(e)VJa(d,e);e=a+2524|0;d=c[e>>2]|0;if(d)VJa(e,d);d=c[a+2520>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+2512>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+2508>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+2500>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+2496>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+2488>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=a+2448|0;e=c[d>>2]|0;if(e)VJa(d,e);aBb(a+2420|0);e=a+2412|0;nTa(c[e>>2]|0);d=c[e>>2]|0;if(d){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+2408>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){f=a+16|0;bBb(f);i=b;return}d=c[a+2400>>2]|0;if(!d){f=a+16|0;bBb(f);i=b;return}e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d);f=a+16|0;bBb(f);i=b;return}function eWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?443592:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function fWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?443592:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function gWa(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=422368;d=c[a+52>>2]|0;e=c[a+60>>2]|0;if(!((e|0)<0|(e&2147483647|0)==0|(d|0)==0)){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+48>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+40>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+36>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+28>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+24>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+16>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+12>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+4>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function hWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?443360:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function iWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?443160:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function jWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?443048:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function kWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?443360:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function lWa(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+204>>2]&2147483647)>>>0<b>>>0)cBb(a,b);c[a+200>>2]=b;i=d;return}function mWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+8|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=mKa()|0;k=c[(c[g>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;j=Bn[k&255](g,h,m?445024:544544,537640,558)|0}m=b+4|0;g=c[m>>2]|0;k=j+g|0;if((g|0)>0){l=j;n=c[b>>2]|0;while(1){if(l)a[l>>0]=a[n>>0]|0;l=l+1|0;if((l|0)==(k|0))break;else n=n+1|0}o=c[m>>2]|0}else o=g;g=j+o|0;if(g)a[g>>0]=a[d>>0]|0;if((c[f>>2]|0)>-1?(d=c[b>>2]|0,(d|0)!=0):0){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,d)}c[b>>2]=j;c[f>>2]=h;h=c[m>>2]|0;c[m>>2]=h+1;i=e;return j+h|0}function nWa(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+16|0;k=j;l=(g|0)!=0;if(l)m=h;else m=e[d+24>>1]|0;h=k;c[h>>2]=0;c[h+4>>2]=0;h=m<<2;n=h>>>0>1024;o=k+4|0;a[o>>0]=n&1;if(n){n=sKa(j+8|0,h,443280,393)|0;c[k>>2]=n;if(!n)p=k;else{q=k;r=6}}else{n=i;i=i+((1*h|0)+15&-16)|0;c[k>>2]=n;q=k;r=6}do if((r|0)==6){if(l){if(!m){p=q;break}else{s=0;t=0}while(1){n=(c[g+(s<<2)>>2]|0)+32|0;if((c[n+4>>2]&-1073741824|0)==1073741824)u=t;else{c[(c[q>>2]|0)+(s<<2)>>2]=n;u=t+1|0}s=s+1|0;if((s|0)==(m|0)){v=u;break}else t=u}}else{n=d+20|0;if((b[d+24>>1]|0)==1)w=n;else w=c[n>>2]|0;if(!m){p=q;break}else{x=0;y=0}while(1){n=c[w+(x<<2)>>2]|0;h=n+32|0;z=c[n+36>>2]|0;if((z&-1073741824|0)!=1073741824){if(!(z&64))A=n+112|0;else{B=n+40|0;n=c[B>>2]|0;if(!n){C=s4(c[h>>2]|0,z>>>24&15)|0;c[B>>2]=C;D=C}else D=n;A=D+116|0}if(a[A>>0]&5){c[(c[q>>2]|0)+(y<<2)>>2]=h;E=y+1|0}else E=y}else E=y;x=x+1|0;if((x|0)==(m|0)){v=E;break}else y=E}}if(!v)p=q;else{dBb(f,c[q>>2]|0,v);p=q}}while(0);if(!(a[o>>0]|0)){i=j;return 1}tKa(k,c[p>>2]|0);i=j;return 1}function oWa(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+16|0;k=j;l=(g|0)!=0;if(l)m=h;else m=e[d+24>>1]|0;h=k;c[h>>2]=0;c[h+4>>2]=0;h=m<<2;n=h>>>0>1024;o=k+4|0;a[o>>0]=n&1;if(n){n=sKa(j+8|0,h,443280,393)|0;c[k>>2]=n;if(!n)p=k;else{q=k;r=6}}else{n=i;i=i+((1*h|0)+15&-16)|0;c[k>>2]=n;q=k;r=6}do if((r|0)==6){if(l){if(!m){p=q;break}else{s=0;t=0}while(1){n=(c[g+(s<<2)>>2]|0)+32|0;if((c[n+4>>2]&-1073741824|0)==1073741824)u=t;else{c[(c[q>>2]|0)+(s<<2)>>2]=n;u=t+1|0}s=s+1|0;if((s|0)==(m|0)){v=u;break}else t=u}}else{n=d+20|0;if((b[d+24>>1]|0)==1)w=n;else w=c[n>>2]|0;if(!m){p=q;break}else{x=0;y=0}while(1){n=c[w+(x<<2)>>2]|0;h=n+32|0;z=c[n+36>>2]|0;if((z&-1073741824|0)!=1073741824){if(!(z&64))A=n+112|0;else{B=n+40|0;n=c[B>>2]|0;if(!n){C=s4(c[h>>2]|0,z>>>24&15)|0;c[B>>2]=C;D=C}else D=n;A=D+116|0}if(a[A>>0]&5){c[(c[q>>2]|0)+(y<<2)>>2]=h;E=y+1|0}else E=y}else E=y;x=x+1|0;if((x|0)==(m|0)){v=E;break}else y=E}}if(!v)p=q;else{dBb(f,c[q>>2]|0,v);p=q}}while(0);if(!(a[o>>0]|0)){i=j;return 1}tKa(k,c[p>>2]|0);i=j;return 1}function pWa(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+16|0;k=j;l=(g|0)!=0;if(l)m=h;else m=e[d+24>>1]|0;h=k;c[h>>2]=0;c[h+4>>2]=0;h=m<<2;n=h>>>0>1024;o=k+4|0;a[o>>0]=n&1;if(n){n=sKa(j+8|0,h,443280,393)|0;c[k>>2]=n;if(!n)p=k;else{q=k;r=6}}else{n=i;i=i+((1*h|0)+15&-16)|0;c[k>>2]=n;q=k;r=6}do if((r|0)==6){if(l){if(!m){p=q;break}else{s=0;t=0}while(1){n=(c[g+(s<<2)>>2]|0)+32|0;if((c[n+4>>2]&-1073741824|0)==1073741824)u=t;else{c[(c[q>>2]|0)+(s<<2)>>2]=n;u=t+1|0}s=s+1|0;if((s|0)==(m|0)){v=u;break}else t=u}}else{n=d+20|0;if((b[d+24>>1]|0)==1)w=n;else w=c[n>>2]|0;if(!m){p=q;break}else{x=0;y=0}while(1){n=c[w+(x<<2)>>2]|0;h=n+32|0;z=c[n+36>>2]|0;if((z&-1073741824|0)!=1073741824){if(!(z&64))A=n+112|0;else{B=n+40|0;n=c[B>>2]|0;if(!n){C=s4(c[h>>2]|0,z>>>24&15)|0;c[B>>2]=C;D=C}else D=n;A=D+116|0}if(a[A>>0]&5){c[(c[q>>2]|0)+(y<<2)>>2]=h;E=y+1|0}else E=y}else E=y;x=x+1|0;if((x|0)==(m|0)){v=E;break}else y=E}}if(!v)p=q;else{dBb(f,c[q>>2]|0,v);p=q}}while(0);if(!(a[o>>0]|0)){i=j;return 1}tKa(k,c[p>>2]|0);i=j;return 1}function qWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)rWa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function rWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?482704:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function sWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+4|0;f=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;h=mo[c[(c[b>>2]|0)+8>>2]&4095](b)|0;j=a+8|0;k=(c[j>>2]|0)+h|0;l=a+12|0;if((c[l>>2]&2147483647)>>>0<k>>>0)eBb(e,k);k=f+(h<<4)|0;if((h|0)>0){h=f;do{f=c[j>>2]|0;if((c[l>>2]&2147483647)>>>0>f>>>0){m=c[e>>2]|0;n=m+(f<<4)|0;if(!n)o=f;else{g[n>>2]=ea(g[h>>2]);g[m+(f<<4)+4>>2]=ea(g[h+4>>2]);g[m+(f<<4)+8>>2]=ea(g[h+8>>2]);c[m+(f<<4)+12>>2]=c[h+12>>2];o=c[j>>2]|0}c[j>>2]=o+1}else Y5a(e,h)|0;h=h+16|0}while(h>>>0<k>>>0)}k=a+16|0;h=mo[c[(c[b>>2]|0)+20>>2]&4095](b)|0;e=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;o=a+20|0;j=(c[o>>2]|0)+e|0;l=a+24|0;if((c[l>>2]&2147483647)>>>0<j>>>0)fBb(k,j);j=h+(e<<5)|0;if((e|0)>0){e=h;do{h=c[o>>2]|0;if((c[l>>2]&2147483647)>>>0>h>>>0){f=c[k>>2]|0;m=f+(h<<5)|0;if(!m)p=h;else{g[m>>2]=ea(g[e>>2]);g[f+(h<<5)+4>>2]=ea(g[e+4>>2]);g[f+(h<<5)+8>>2]=ea(g[e+8>>2]);c[f+(h<<5)+12>>2]=c[e+12>>2];g[f+(h<<5)+16>>2]=ea(g[e+16>>2]);g[f+(h<<5)+20>>2]=ea(g[e+20>>2]);g[f+(h<<5)+24>>2]=ea(g[e+24>>2]);c[f+(h<<5)+28>>2]=c[e+28>>2];p=c[o>>2]|0}c[o>>2]=p+1}else Z5a(k,e)|0;e=e+32|0}while(e>>>0<j>>>0)}j=a+28|0;e=mo[c[(c[b>>2]|0)+28>>2]&4095](b)|0;k=mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0;p=a+32|0;o=(c[p>>2]|0)+k|0;l=a+36|0;if((c[l>>2]&2147483647)>>>0<o>>>0)gBb(j,o);o=e+(k*48|0)|0;if((k|0)>0){k=e;do{e=c[p>>2]|0;if((c[l>>2]&2147483647)>>>0>e>>>0){h=c[j>>2]|0;f=h+(e*48|0)|0;if(!f)q=e;else{g[f>>2]=ea(g[k>>2]);g[h+(e*48|0)+4>>2]=ea(g[k+4>>2]);g[h+(e*48|0)+8>>2]=ea(g[k+8>>2]);c[h+(e*48|0)+12>>2]=c[k+12>>2];g[h+(e*48|0)+16>>2]=ea(g[k+16>>2]);g[h+(e*48|0)+20>>2]=ea(g[k+20>>2]);g[h+(e*48|0)+24>>2]=ea(g[k+24>>2]);c[h+(e*48|0)+28>>2]=c[k+28>>2];g[h+(e*48|0)+32>>2]=ea(g[k+32>>2]);g[h+(e*48|0)+36>>2]=ea(g[k+36>>2]);g[h+(e*48|0)+40>>2]=ea(g[k+40>>2]);c[h+(e*48|0)+44>>2]=c[k+44>>2];q=c[p>>2]|0}c[p>>2]=q+1}else _5a(j,k)|0;k=k+48|0}while(k>>>0<o>>>0)}o=a+40|0;k=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;j=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;b=a+44|0;q=(c[b>>2]|0)+j|0;p=a+48|0;if((c[p>>2]&2147483647)>>>0<q>>>0)hBb(o,q);q=k+(j*24|0)|0;if((j|0)<=0){i=d;return}j=k;do{k=c[b>>2]|0;if((c[p>>2]&2147483647)>>>0>k>>>0){a=c[o>>2]|0;l=a+(k*24|0)|0;if(!l)r=k;else{g[l>>2]=ea(g[j>>2]);g[a+(k*24|0)+4>>2]=ea(g[j+4>>2]);g[a+(k*24|0)+8>>2]=ea(g[j+8>>2]);l=a+(k*24|0)+12|0;k=j+12|0;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];r=c[b>>2]|0}c[b>>2]=r+1}else $5a(o,j)|0;j=j+24|0}while(j>>>0<q>>>0);i=d;return}function tWa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((c[a+8>>2]&2147483647)>>>0<d>>>0)uWa(a,d);g=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=g+(d<<1)|0;if((a|0)>=(d|0)){c[h>>2]=d;i=f;return}k=g+(a<<1)|0;do{if(k)b[k>>1]=b[e>>1]|0;k=k+2|0}while(k>>>0<j>>>0);c[h>>2]=d;i=f;return}function uWa(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=0?(f=d<<1,(f|0)!=0):0){g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](g,f,k?541936:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;f=l+(k<<1)|0;if((k|0)>0){k=l;g=c[a>>2]|0;while(1){if(k)b[k>>1]=b[g>>1]|0;k=k+2|0;if(k>>>0>=f>>>0)break;else g=g+2|0}}g=a+8|0;if((c[g>>2]|0)<=-1){c[a>>2]=l;c[g>>2]=d;i=e;return}f=c[a>>2]|0;if(!f){c[a>>2]=l;c[g>>2]=d;i=e;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,f);c[a>>2]=l;c[g>>2]=d;i=e;return}function vWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)wWa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function wWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?452136:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function xWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)yWa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function yWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?444096:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function zWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){m=j?16:h<<1;if(h>>>0<m>>>0){cWa(b,m);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function AWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?442696:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function BWa(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=Im,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=0,Sa=0;j=i;i=i+272|0;k=j+128|0;l=j+80|0;m=j;n=j+112|0;o=j+264|0;p=j+260|0;q=j+266|0;r=j+212|0;s=j+64|0;t=j+96|0;u=j+240|0;v=j+268|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=-1;b[m+12>>1]=0;w=m+16|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;g[m+40>>2]=ea(3402823469999999843913219.0e14);g[m+44>>2]=ea(0.0);g[m+48>>2]=ea(0.0);if(!h){x=1;i=j;return x|0}w=n+4|0;y=d+20|0;z=d+12|0;A=d+41|0;B=d+16|0;C=d+24|0;D=d+4|0;E=d+32|0;F=n+8|0;G=n+12|0;H=d+8|0;I=d+39|0;J=d+28|0;K=d+40|0;L=d+38|0;M=d+36|0;N=u+16|0;O=u+18|0;P=k+4|0;Q=k+8|0;R=k+12|0;S=k+16|0;T=k+20|0;U=k+44|0;V=k+48|0;W=k+52|0;X=k+68|0;Y=k+72|0;Z=k+76|0;_=k+80|0;$=d+37|0;d=k+4|0;aa=k+24|0;ba=k+28|0;ca=k+32|0;da=k+36|0;fa=k+40|0;ga=d+40|0;ha=0;a:while(1){c[n>>2]=0;c[w>>2]=0;DCa(f+(ha<<3)|0,n);ia=c[y>>2]|0;ja=b[ia+16>>1]|0;b[o>>1]=ja;ka=a[A>>0]|0;if(ja<<16>>16<0?1:(c[(c[z>>2]|0)+76>>2]|0)!=0)la=ka<<24>>24!=0?2:1;else la=2;c[p>>2]=la;b[q>>1]=b[B>>1]|0;if(!(ka<<24>>24)){ka=(iBb(n,p,o,ia,c[C>>2]|0,c[D>>2]|0,c[E>>2]|0,q)|0)^1;ia=c[p>>2]|0;if(!((ia|0)==0|ka)){ma=ia;na=7}}else{ma=la;na=7}if((na|0)==7){na=0;ia=c[F>>2]|0;ACa(r,ia,c[G>>2]|0);ka=c[ia+4>>2]|0;if(!(ka&1))oa=ia+84|0;else{ja=ia+8|0;pa=c[ja>>2]|0;if(!pa){qa=s4(c[ia>>2]|0,ka>>>24&15)|0;c[ja>>2]=qa;ra=qa}else ra=pa;oa=ra}pa=c[z>>2]|0;qa=c[pa+76>>2]|0;ja=c[pa+80>>2]|0;ka=ja>>>0<qa>>>0;ia=ka?qa-ja|0:1;sa=ka?(c[pa+72>>2]|0)+(ja<<6)|0:m;ja=c[oa>>2]|0;pa=b[q>>1]|0;if((ja|0)==5)ta=(pa&32)!=0?ia:1;else ta=ia;ia=c[H>>2]|0;ua=ea(g[J>>2]);ka=(a[K>>0]|0)!=0;qa=c[(c[(c[D>>2]|0)+3376>>2]|0)+(ja<<2)>>2]|0;ja=c[ia>>2]|0;va=c[ia+4>>2]|0;b[k>>1]=((a[I>>0]|0)==0?4:64)|pa;pa=po[qa&7](oa,r,ja,va,ua,k,ta,sa,ka,0,0)|0;if(pa){ka=(b[o>>1]&8)==0;wa=0;while(1){xa=sa+(wa<<6)|0;c[xa>>2]=c[n>>2];c[sa+(wa<<6)+4>>2]=c[w>>2];do if(!(a[A>>0]|0)){va=c[C>>2]|0;ja=(va|0)==0;if(ja){if((c[E>>2]|0)==0|ka){ya=ma;break}}else if(ka){ya=ma;break}if(!ja){ya=xo[c[(c[va>>2]|0)+4>>2]&2047](va,c[y>>2]|0,xa)|0;break}va=c[E>>2]|0;ja=c[va+12>>2]|0;if(ja){qa=c[y>>2]|0;c[s+0>>2]=c[qa+0>>2];c[s+4>>2]=c[qa+4>>2];c[s+8>>2]=c[qa+8>>2];c[s+12>>2]=c[qa+12>>2];qa=(c[F>>2]|0)+16|0;c[t+0>>2]=c[qa+0>>2];c[t+4>>2]=c[qa+4>>2];c[t+8>>2]=c[qa+8>>2];c[t+12>>2]=c[qa+12>>2];qa=c[va>>2]|0;ia=c[va+4>>2]|0;c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];c[l+12>>2]=c[s+12>>2];c[k+0>>2]=c[t+0>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[k+12>>2]=c[t+12>>2];ya=Bn[ja&255](l,k,qa,ia,xa)|0}else ya=ma}else ya=ma;while(0);if(!((a[I>>0]|0)==0|(ya|0)==0)){na=25;break a}ia=(a[L>>0]|0)==0?ya:1;if((ia|0)==1){qa=c[z>>2]|0;ja=qa+76|0;va=c[ja>>2]|0;if(((va|0)!=0?(a[M>>0]|0)!=0:0)?(ua=ea(g[xa+40>>2]),ua<=ea(g[J>>2])):0){za=c[qa+80>>2]|0;if((za|0)==(va|0)){va=c[y>>2]|0;c[u+0>>2]=c[va+0>>2];c[u+4>>2]=c[va+4>>2];c[u+8>>2]=c[va+8>>2];c[u+12>>2]=c[va+12>>2];Aa=b[va+16>>1]|0;b[N>>1]=Aa;a[O>>0]=a[va+18>>0]|0;b[N>>1]=Aa&65535|32768;c[P>>2]=0;c[Q>>2]=0;c[R>>2]=-1;b[S>>1]=0;c[T+0>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;c[T+12>>2]=0;c[T+16>>2]=0;c[T+20>>2]=0;g[U>>2]=ea(3402823469999999843913219.0e14);g[V>>2]=ea(0.0);g[W>>2]=ea(0.0);a[X>>0]=0;c[Y>>2]=0;c[Z>>2]=0;c[_>>2]=0;c[k>>2]=420192;do if((a[$>>0]|0)==0?(c[ja>>2]|0)!=0:0){Aa=c[D>>2]|0;va=c[H>>2]|0;b[v>>1]=b[B>>1]|0;if(!(r1(Aa,va,k,v,0,u,c[C>>2]|0,c[E>>2]|0)|0))break;va=c[z>>2]|0;Aa=va+4|0;c[Aa+0>>2]=c[d+0>>2];c[Aa+4>>2]=c[d+4>>2];c[Aa+8>>2]=c[d+8>>2];b[va+16>>1]=b[S>>1]|0;g[va+20>>2]=ea(g[T>>2]);g[va+24>>2]=ea(g[aa>>2]);g[va+28>>2]=ea(g[ba>>2]);g[va+32>>2]=ea(g[ca>>2]);g[va+36>>2]=ea(g[da>>2]);g[va+40>>2]=ea(g[fa>>2]);g[va+44>>2]=ea(g[U>>2]);Aa=va+48|0;c[Aa+0>>2]=c[V+0>>2];c[Aa+4>>2]=c[V+4>>2];c[Aa+8>>2]=c[V+8>>2];c[Aa+12>>2]=c[V+12>>2];c[Aa+16>>2]=c[V+16>>2];a[(c[z>>2]|0)+68>>0]=1;Aa=c[z>>2]|0;va=c[Aa+72>>2]|0;Ba=c[Aa+80>>2]|0;ua=ea(g[ga>>2]);if(!Ba){Ca=Aa;Da=ua;Ea=0}else{Aa=0;Fa=Ba;while(1){Ga=va+(Aa<<6)+40|0;if(ea(g[Ga>>2])>ua){Ha=Fa+-1|0;Ia=b[va+(Ha<<6)+12>>1]|0;Ja=ea(g[va+(Ha<<6)+16>>2]);Ka=ea(g[va+(Ha<<6)+20>>2]);La=ea(g[va+(Ha<<6)+24>>2]);Ma=ea(g[va+(Ha<<6)+28>>2]);Na=ea(g[va+(Ha<<6)+32>>2]);Oa=ea(g[va+(Ha<<6)+36>>2]);Pa=ea(g[va+(Ha<<6)+40>>2]);aFi(va+(Aa<<6)|0,va+(Ha<<6)|0,12)|0;b[va+(Aa<<6)+12>>1]=Ia;g[va+(Aa<<6)+16>>2]=Ja;g[va+(Aa<<6)+20>>2]=Ka;g[va+(Aa<<6)+24>>2]=La;g[va+(Aa<<6)+28>>2]=Ma;g[va+(Aa<<6)+32>>2]=Na;g[va+(Aa<<6)+36>>2]=Oa;g[Ga>>2]=Pa;aFi(va+(Aa<<6)+44|0,va+(Ha<<6)+44|0,20)|0;Qa=Ha}else Qa=Fa;Aa=Aa+1|0;if((Aa|0)==(Ba|0))break;else Fa=Qa}Ca=c[z>>2]|0;Da=ea(g[ga>>2]);Ea=Qa}c[Ca+80>>2]=Ea;g[J>>2]=Da;g[e>>2]=Da}while(0);a[$>>0]=1;ja=c[z>>2]|0;Fa=c[ja+80>>2]|0;if((Fa|0)==(c[ja+76>>2]|0)){Ba=xo[c[c[ja>>2]>>2]&2047](ja,c[ja+72>>2]|0,Fa)|0;a[M>>0]=Ba&1;if(!Ba){x=0;na=48;break a}c[(c[z>>2]|0)+80>>2]=0;Ba=c[z>>2]|0;Ra=Ba;Sa=c[Ba+80>>2]|0}else{Ra=ja;Sa=Fa}}else{Ra=qa;Sa=za}Fa=c[Ra+72>>2]|0;c[Ra+80>>2]=Sa+1;ja=Fa+(Sa<<6)|0;c[ja+0>>2]=c[xa+0>>2];c[ja+4>>2]=c[xa+4>>2];c[ja+8>>2]=c[xa+8>>2];b[Fa+(Sa<<6)+12>>1]=b[sa+(wa<<6)+12>>1]|0;g[Fa+(Sa<<6)+16>>2]=ea(g[sa+(wa<<6)+16>>2]);g[Fa+(Sa<<6)+20>>2]=ea(g[sa+(wa<<6)+20>>2]);g[Fa+(Sa<<6)+24>>2]=ea(g[sa+(wa<<6)+24>>2]);g[Fa+(Sa<<6)+28>>2]=ea(g[sa+(wa<<6)+28>>2]);g[Fa+(Sa<<6)+32>>2]=ea(g[sa+(wa<<6)+32>>2]);g[Fa+(Sa<<6)+36>>2]=ea(g[sa+(wa<<6)+36>>2]);g[Fa+(Sa<<6)+40>>2]=ea(g[sa+(wa<<6)+40>>2]);ja=Fa+(Sa<<6)+44|0;Fa=sa+(wa<<6)+44|0;c[ja+0>>2]=c[Fa+0>>2];c[ja+4>>2]=c[Fa+4>>2];c[ja+8>>2]=c[Fa+8>>2];c[ja+12>>2]=c[Fa+12>>2];c[ja+16>>2]=c[Fa+16>>2]}}else if((ia|0)==2?(ua=ea(g[xa+40>>2]),ua<=ea(g[J>>2])):0){g[J>>2]=ua;g[e>>2]=ua;Fa=c[z>>2]|0;ja=Fa+4|0;c[ja+0>>2]=c[xa+0>>2];c[ja+4>>2]=c[xa+4>>2];c[ja+8>>2]=c[xa+8>>2];b[Fa+16>>1]=b[sa+(wa<<6)+12>>1]|0;g[Fa+20>>2]=ea(g[sa+(wa<<6)+16>>2]);g[Fa+24>>2]=ea(g[sa+(wa<<6)+20>>2]);g[Fa+28>>2]=ea(g[sa+(wa<<6)+24>>2]);g[Fa+32>>2]=ea(g[sa+(wa<<6)+28>>2]);g[Fa+36>>2]=ea(g[sa+(wa<<6)+32>>2]);g[Fa+40>>2]=ea(g[sa+(wa<<6)+36>>2]);g[Fa+44>>2]=ea(g[sa+(wa<<6)+40>>2]);ja=Fa+48|0;Fa=sa+(wa<<6)+44|0;c[ja+0>>2]=c[Fa+0>>2];c[ja+4>>2]=c[Fa+4>>2];c[ja+8>>2]=c[Fa+8>>2];c[ja+12>>2]=c[Fa+12>>2];c[ja+16>>2]=c[Fa+16>>2];a[(c[z>>2]|0)+68>>0]=1}Fa=wa+1|0;if(Fa>>>0<pa>>>0)wa=Fa;else break}}}ha=ha+1|0;if(ha>>>0>=h>>>0){x=1;na=48;break}}if((na|0)==25){h=c[z>>2]|0;ha=h+4|0;c[ha+0>>2]=c[xa+0>>2];c[ha+4>>2]=c[xa+4>>2];c[ha+8>>2]=c[xa+8>>2];b[h+16>>1]=b[sa+(wa<<6)+12>>1]|0;g[h+20>>2]=ea(g[sa+(wa<<6)+16>>2]);g[h+24>>2]=ea(g[sa+(wa<<6)+20>>2]);g[h+28>>2]=ea(g[sa+(wa<<6)+24>>2]);g[h+32>>2]=ea(g[sa+(wa<<6)+28>>2]);g[h+36>>2]=ea(g[sa+(wa<<6)+32>>2]);g[h+40>>2]=ea(g[sa+(wa<<6)+36>>2]);g[h+44>>2]=ea(g[sa+(wa<<6)+40>>2]);xa=h+48|0;h=sa+(wa<<6)+44|0;c[xa+0>>2]=c[h+0>>2];c[xa+4>>2]=c[h+4>>2];c[xa+8>>2]=c[h+8>>2];c[xa+12>>2]=c[h+12>>2];c[xa+16>>2]=c[h+16>>2];a[(c[z>>2]|0)+68>>0]=1;x=0;i=j;return x|0}else if((na|0)==48){i=j;return x|0}return 0}function CWa(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+144|0;j=e;k=e+80|0;l=e+96|0;m=e+112|0;n=e+132|0;o=e+128|0;p=e+134|0;q=e+32|0;r=e+64|0;s=e+16|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=-1;if(!h){t=1;i=e;return t|0}u=m+4|0;v=d+20|0;w=d+12|0;x=d+41|0;y=d+16|0;z=d+24|0;A=d+4|0;B=d+32|0;C=m+8|0;D=m+12|0;E=d+8|0;F=d+39|0;G=d+28|0;H=d+38|0;I=d+36|0;d=0;a:while(1){c[m>>2]=0;c[u>>2]=0;DCa(f+(d<<3)|0,m);J=c[v>>2]|0;K=b[J+16>>1]|0;b[n>>1]=K;L=a[x>>0]|0;if(K<<16>>16<0?1:(c[(c[w>>2]|0)+28>>2]|0)!=0)M=L<<24>>24!=0?2:1;else M=2;c[o>>2]=M;b[p>>1]=b[y>>1]|0;if(!(L<<24>>24)){L=(iBb(m,o,n,J,c[z>>2]|0,c[A>>2]|0,c[B>>2]|0,p)|0)^1;J=c[o>>2]|0;if(!((J|0)==0|L)){N=J;O=7}}else{N=M;O=7}do if((O|0)==7){O=0;J=c[C>>2]|0;ACa(q,J,c[D>>2]|0);L=c[J+4>>2]|0;if(!(L&1))P=J+84|0;else{K=J+8|0;Q=c[K>>2]|0;if(!Q){R=s4(c[J>>2]|0,L>>>24&15)|0;c[K>>2]=R;S=R}else S=Q;P=S}Q=c[w>>2]|0;R=c[Q+32>>2]|0;T=R>>>0<(c[Q+28>>2]|0)>>>0?(c[Q+24>>2]|0)+(R<<4)|0:l;R=c[E>>2]|0;Q=c[R+12>>2]|0;K=c[R+16>>2]|0;R=c[(c[A>>2]|0)+3384>>2]|0;L=c[Q>>2]|0;J=c[P>>2]|0;if((L|0)>(J|0)){if(!(Bn[c[R+(J*28|0)+(L<<2)>>2]&255](P,q,Q,K,0)|0))break}else if(!(Bn[c[R+(L*28|0)+(J<<2)>>2]&255](Q,K,P,q,0)|0))break;K=(b[n>>1]&8)==0;c[T>>2]=c[m>>2];c[T+4>>2]=c[u>>2];if(K){if(!((a[F>>0]|0)==0|(N|0)==0)){O=34;break a}K=(a[H>>0]|0)==0?N:1;if((K|0)==2){if(!(ea(g[G>>2])>=ea(-1.0)))break;Q=(c[w>>2]|0)+4|0;c[Q+0>>2]=c[T+0>>2];c[Q+4>>2]=c[T+4>>2];c[Q+8>>2]=c[T+8>>2];c[Q+12>>2]=c[T+12>>2];a[(c[w>>2]|0)+20>>0]=1;break}else if((K|0)!=1)break;K=c[w>>2]|0;Q=c[K+28>>2]|0;if(!Q)break;if(!(a[I>>0]|0))break;if(!(ea(g[G>>2])>=ea(-1.0)))break;J=c[K+32>>2]|0;if((J|0)==(Q|0)){L=xo[c[c[K>>2]>>2]&2047](K,c[K+24>>2]|0,Q)|0;a[I>>0]=L&1;if(!L){t=0;O=46;break a}c[(c[w>>2]|0)+32>>2]=0;L=c[w>>2]|0;U=L;V=c[L+32>>2]|0}else{U=K;V=J}J=c[U+24>>2]|0;c[U+32>>2]=V+1;K=J+(V<<4)|0;c[K+0>>2]=c[T+0>>2];c[K+4>>2]=c[T+4>>2];c[K+8>>2]=c[T+8>>2];c[K+12>>2]=c[T+12>>2];break}do if(!(a[x>>0]|0)){K=c[z>>2]|0;if(K){W=xo[c[(c[K>>2]|0)+4>>2]&2047](K,c[v>>2]|0,T)|0;break}if((c[B>>2]|0)!=0?(K=c[B>>2]|0,J=c[K+12>>2]|0,(J|0)!=0):0){L=c[v>>2]|0;c[r+0>>2]=c[L+0>>2];c[r+4>>2]=c[L+4>>2];c[r+8>>2]=c[L+8>>2];c[r+12>>2]=c[L+12>>2];L=(c[C>>2]|0)+16|0;c[s+0>>2]=c[L+0>>2];c[s+4>>2]=c[L+4>>2];c[s+8>>2]=c[L+8>>2];c[s+12>>2]=c[L+12>>2];L=c[K>>2]|0;Q=c[K+4>>2]|0;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];W=Bn[J&255](k,j,L,Q,T)|0}else W=N}else W=N;while(0);if(!((a[F>>0]|0)==0|(W|0)==0)){O=34;break a}Q=(a[H>>0]|0)==0?W:1;if((Q|0)==2){if(!(ea(g[G>>2])>=ea(-1.0)))break;L=(c[w>>2]|0)+4|0;c[L+0>>2]=c[T+0>>2];c[L+4>>2]=c[T+4>>2];c[L+8>>2]=c[T+8>>2];c[L+12>>2]=c[T+12>>2];a[(c[w>>2]|0)+20>>0]=1;break}else if((Q|0)!=1)break;Q=c[w>>2]|0;L=c[Q+28>>2]|0;if(((L|0)!=0?(a[I>>0]|0)!=0:0)?ea(g[G>>2])>=ea(-1.0):0){J=c[Q+32>>2]|0;if((J|0)==(L|0)){K=xo[c[c[Q>>2]>>2]&2047](Q,c[Q+24>>2]|0,L)|0;a[I>>0]=K&1;if(!K){t=0;O=46;break a}c[(c[w>>2]|0)+32>>2]=0;K=c[w>>2]|0;X=K;Y=c[K+32>>2]|0}else{X=Q;Y=J}J=c[X+24>>2]|0;c[X+32>>2]=Y+1;Q=J+(Y<<4)|0;c[Q+0>>2]=c[T+0>>2];c[Q+4>>2]=c[T+4>>2];c[Q+8>>2]=c[T+8>>2];c[Q+12>>2]=c[T+12>>2]}}while(0);d=d+1|0;if(d>>>0>=h>>>0){t=1;O=46;break}}if((O|0)==34){h=(c[w>>2]|0)+4|0;c[h+0>>2]=c[T+0>>2];c[h+4>>2]=c[T+4>>2];c[h+8>>2]=c[T+8>>2];c[h+12>>2]=c[T+12>>2];a[(c[w>>2]|0)+20>>0]=1;t=0;i=e;return t|0}else if((O|0)==46){i=e;return t|0}return 0}function DWa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im;f=i;i=i+144|0;h=f+120|0;j=f+96|0;k=f+80|0;l=f+16|0;m=f;c[a>>2]=-1;n=a+56|0;g[n>>2]=ea(g[d>>2]);o=a+60|0;g[o>>2]=ea(g[d+4>>2]);p=a+64|0;g[p>>2]=ea(g[d+8>>2]);q=a+68|0;g[q>>2]=ea(g[d+12>>2]);r=a+72|0;g[r>>2]=ea(g[d+16>>2]);s=a+76|0;g[s>>2]=ea(g[d+20>>2]);t=a+80|0;g[t>>2]=ea(g[d+24>>2]);c[a+144>>2]=b;CLa(a,b);oMa(a,j,n,e,0);e=ea(g[n>>2]);u=ea(g[o>>2]);v=ea(g[p>>2]);w=ea(g[q>>2]);x=ea(e+e);y=ea(u+u);z=ea(v+v);A=ea(u*y);B=ea(v*z);C=ea(x*u);D=ea(x*v);E=ea(x*w);F=ea(y*v);G=ea(y*w);y=ea(z*w);z=ea(ea(ea(1.0)-A)-B);H=ea(C+y);I=ea(D-G);J=ea(C-y);y=ea(ea(1.0)-ea(e*x));x=ea(y-B);B=ea(F+E);C=ea(D+G);G=ea(F-E);E=ea(y-A);d=a+84|0;g[d>>2]=z;K=a+88|0;g[K>>2]=H;L=a+92|0;g[L>>2]=I;M=a+96|0;g[M>>2]=J;N=a+100|0;g[N>>2]=x;O=a+104|0;g[O>>2]=B;P=a+108|0;g[P>>2]=C;Q=a+112|0;g[Q>>2]=G;R=a+116|0;g[R>>2]=E;A=ea(g[j>>2]);y=ea(g[j+12>>2]);F=ea(A+y);D=ea(g[j+4>>2]);S=ea(g[j+16>>2]);T=ea(D+S);U=ea(g[j+8>>2]);V=ea(g[j+20>>2]);W=ea(F*ea(.5));F=ea(T*ea(.5));T=ea(ea(U+V)*ea(.5));X=ea(ea(ea(y-A)*ea(.5))*ea(1.00999999));A=ea(ea(ea(S-D)*ea(.5))*ea(1.00999999));D=ea(ea(ea(V-U)*ea(.5))*ea(1.00999999));U=ea(F-A);V=ea(T-D);S=ea(W+X);y=ea(F+A);A=ea(T+D);g[a+120>>2]=ea(W-X);g[a+124>>2]=U;g[a+128>>2]=V;g[a+132>>2]=S;g[a+136>>2]=y;g[a+140>>2]=A;j=c[b>>2]|0;if((j|0)==3){g[a+184>>2]=ea(g[r>>2]);g[a+188>>2]=ea(g[s>>2]);g[a+192>>2]=ea(g[t>>2]);g[a+196>>2]=ea(g[a+4>>2]);g[a+200>>2]=ea(g[a+8>>2]);g[a+204>>2]=ea(g[a+12>>2]);g[a+148>>2]=z;g[a+152>>2]=H;g[a+156>>2]=I;g[a+160>>2]=J;g[a+164>>2]=x;g[a+168>>2]=B;g[a+172>>2]=C;g[a+176>>2]=G;g[a+180>>2]=E;i=f;return}else if((j|0)==2){E=ea(e*ea(2.0));G=ea(w*ea(2.0));C=ea(ea(e*E)+ea(ea(w*G)+ea(-1.0)));w=ea(ea(v*G)+ea(E*u));e=ea(ea(E*v)-ea(G*u));u=ea(g[a+8>>2]);G=ea(u*C);C=ea(u*w);w=ea(u*e);e=ea(g[r>>2]);u=ea(e+G);v=ea(g[s>>2]);E=ea(v+C);B=ea(g[t>>2]);x=ea(w+B);g[a+148>>2]=u;g[a+152>>2]=E;g[a+156>>2]=x;x=ea(v-C);C=ea(B-w);g[a+160>>2]=ea(e-G);g[a+164>>2]=x;g[a+168>>2]=C;g[a+172>>2]=ea(g[a+4>>2]);c[k>>2]=3;C=ea(g[b+4>>2]);g[k+4>>2]=ea(C+ea(g[b+8>>2]));g[k+8>>2]=C;g[k+12>>2]=C;CLa(a,k);i=f;return}else if((j|0)==4){BOa(l,a,c[a+32>>2]|0,n);g[d>>2]=ea(g[l>>2]);g[K>>2]=ea(g[l+4>>2]);g[L>>2]=ea(g[l+8>>2]);g[M>>2]=ea(g[l+12>>2]);g[N>>2]=ea(g[l+16>>2]);g[O>>2]=ea(g[l+20>>2]);g[P>>2]=ea(g[l+24>>2]);g[Q>>2]=ea(g[l+28>>2]);g[R>>2]=ea(g[l+32>>2]);C=ea(g[l+48>>2]);x=ea(g[l+52>>2]);G=ea(g[l+56>>2]);c[m>>2]=3;g[m+4>>2]=C;g[m+8>>2]=x;g[m+12>>2]=G;CLa(a,m);UUa(h,l);G=ea(g[h>>2]);x=ea(g[h+4>>2]);C=ea(g[h+8>>2]);e=ea(g[h+12>>2]);w=ea(g[l+36>>2]);B=ea(g[l+40>>2]);v=ea(g[l+44>>2]);g[n>>2]=G;g[o>>2]=x;g[p>>2]=C;g[q>>2]=e;g[r>>2]=w;g[s>>2]=B;g[t>>2]=v;i=f;return}else if(!j){v=ea(g[a+4>>2]);B=ea(g[r>>2]);w=ea(g[s>>2]);e=ea(g[t>>2]);g[a+148>>2]=B;g[a+152>>2]=w;g[a+156>>2]=e;g[a+160>>2]=v;i=f;return}else{i=f;return}}function EWa(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=0,xa=0,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=0,Ta=0,Ua=0;j=i;i=i+256|0;k=j+72|0;l=j+24|0;m=j+192|0;n=j+56|0;o=j+240|0;p=j;q=j+242|0;r=j+140|0;s=j+244|0;t=j+8|0;u=j+40|0;v=j+168|0;w=j+246|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=-1;b[m+12>>1]=0;x=m+16|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[x+16>>2]=0;c[x+20>>2]=0;g[m+40>>2]=ea(3402823469999999843913219.0e14);if(!h){y=1;i=j;return y|0}x=n+4|0;z=d+20|0;A=d+12|0;B=d+41|0;C=d+16|0;D=d+24|0;E=d+4|0;F=d+32|0;G=n+8|0;H=n+12|0;I=d+8|0;J=d+72|0;K=d+39|0;L=d+28|0;M=d+68|0;N=d+44|0;O=d+38|0;P=d+36|0;Q=v+16|0;R=v+18|0;S=k+4|0;T=k+8|0;U=k+12|0;V=k+16|0;W=k+20|0;X=k+44|0;Y=k+52|0;Z=k+56|0;_=k+60|0;$=k+64|0;aa=d+37|0;d=k+4|0;ba=k+24|0;ca=k+28|0;da=k+32|0;fa=k+36|0;ga=k+40|0;ha=k+48|0;ia=d+40|0;ja=0;a:while(1){c[n>>2]=0;c[x>>2]=0;DCa(f+(ja<<3)|0,n);ka=c[z>>2]|0;la=b[ka+16>>1]|0;b[o>>1]=la;ma=a[B>>0]|0;if(la<<16>>16<0?1:(c[(c[A>>2]|0)+60>>2]|0)!=0)na=ma<<24>>24!=0?2:1;else na=2;c[p>>2]=na;b[q>>1]=b[C>>1]|0;if(!(ma<<24>>24)){ma=(iBb(n,p,o,ka,c[D>>2]|0,c[E>>2]|0,c[F>>2]|0,q)|0)^1;ka=c[p>>2]|0;if(!((ka|0)==0|ma)){oa=ka;pa=7}}else{oa=na;pa=7}if((pa|0)==7){pa=0;ka=c[G>>2]|0;ACa(r,ka,c[H>>2]|0);ma=c[ka+4>>2]|0;if(!(ma&1))qa=ka+84|0;else{la=ka+8|0;ra=c[la>>2]|0;if(!ra){sa=s4(c[ka>>2]|0,ma>>>24&15)|0;c[la>>2]=sa;ta=sa}else ta=ra;qa=ta}ra=c[A>>2]|0;sa=c[ra+64>>2]|0;ua=sa>>>0<(c[ra+60>>2]|0)>>>0?(c[ra+56>>2]|0)+(sa*48|0)|0:m;sa=(c[E>>2]|0)+3376|0;ra=c[I>>2]|0;la=c[J>>2]|0;b[s>>1]=((a[K>>0]|0)==0?4:64)|b[q>>1];va=ea(g[L>>2]);ma=jBb(sa,ra,la,qa,r,s,0,ua,va,0,(a[M>>0]|0)!=0?N:0)|0;if(ma){la=(b[o>>1]&8)==0;wa=0;while(1){xa=ua+(wa*48|0)|0;c[xa>>2]=c[n>>2];c[ua+(wa*48|0)+4>>2]=c[x>>2];ra=xa+40|0;if(ea(g[ra>>2])==ea(0.0)){sa=c[(c[I>>2]|0)+4>>2]|0;va=ea(-ea(g[sa>>2]));ya=ea(-ea(g[sa+4>>2]));za=ea(-ea(g[sa+8>>2]));g[ua+(wa*48|0)+28>>2]=va;g[ua+(wa*48|0)+32>>2]=ya;g[ua+(wa*48|0)+36>>2]=za}do if(!(a[B>>0]|0)){sa=c[D>>2]|0;ka=(sa|0)==0;if(ka){if((c[F>>2]|0)==0|la){Aa=oa;break}}else if(la){Aa=oa;break}if(!ka){Aa=xo[c[(c[sa>>2]|0)+4>>2]&2047](sa,c[z>>2]|0,xa)|0;break}sa=c[F>>2]|0;ka=c[sa+12>>2]|0;if(ka){Ba=c[z>>2]|0;c[t+0>>2]=c[Ba+0>>2];c[t+4>>2]=c[Ba+4>>2];c[t+8>>2]=c[Ba+8>>2];c[t+12>>2]=c[Ba+12>>2];Ba=(c[G>>2]|0)+16|0;c[u+0>>2]=c[Ba+0>>2];c[u+4>>2]=c[Ba+4>>2];c[u+8>>2]=c[Ba+8>>2];c[u+12>>2]=c[Ba+12>>2];Ba=c[sa>>2]|0;Ca=c[sa+4>>2]|0;c[l+0>>2]=c[t+0>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[l+12>>2]=c[t+12>>2];c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[k+12>>2]=c[u+12>>2];Aa=Bn[ka&255](l,k,Ba,Ca,xa)|0}else Aa=oa}else Aa=oa;while(0);if(!((a[K>>0]|0)==0|(Aa|0)==0)){pa=25;break a}Ca=(a[O>>0]|0)==0?Aa:1;if((Ca|0)==2){za=ea(g[ra>>2]);if(za<=ea(g[L>>2])){g[L>>2]=za;g[e>>2]=za;Ba=c[A>>2]|0;ka=Ba+4|0;c[ka+0>>2]=c[xa+0>>2];c[ka+4>>2]=c[xa+4>>2];c[ka+8>>2]=c[xa+8>>2];b[Ba+16>>1]=b[ua+(wa*48|0)+12>>1]|0;g[Ba+20>>2]=ea(g[ua+(wa*48|0)+16>>2]);g[Ba+24>>2]=ea(g[ua+(wa*48|0)+20>>2]);g[Ba+28>>2]=ea(g[ua+(wa*48|0)+24>>2]);g[Ba+32>>2]=ea(g[ua+(wa*48|0)+28>>2]);g[Ba+36>>2]=ea(g[ua+(wa*48|0)+32>>2]);g[Ba+40>>2]=ea(g[ua+(wa*48|0)+36>>2]);g[Ba+44>>2]=ea(g[ua+(wa*48|0)+40>>2]);c[Ba+48>>2]=c[ua+(wa*48|0)+44>>2];a[(c[A>>2]|0)+52>>0]=1}}else if((((Ca|0)==1?(Ca=c[A>>2]|0,Ba=Ca+60|0,ka=c[Ba>>2]|0,(ka|0)!=0):0)?(a[P>>0]|0)!=0:0)?(za=ea(g[ra>>2]),za<=ea(g[L>>2])):0){sa=c[Ca+64>>2]|0;if((sa|0)==(ka|0)){ka=c[z>>2]|0;c[v+0>>2]=c[ka+0>>2];c[v+4>>2]=c[ka+4>>2];c[v+8>>2]=c[ka+8>>2];c[v+12>>2]=c[ka+12>>2];Da=b[ka+16>>1]|0;b[Q>>1]=Da;a[R>>0]=a[ka+18>>0]|0;b[Q>>1]=Da&65535|32768;c[S>>2]=0;c[T>>2]=0;c[U>>2]=-1;b[V>>1]=0;c[W+0>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;c[W+12>>2]=0;c[W+16>>2]=0;c[W+20>>2]=0;g[X>>2]=ea(3402823469999999843913219.0e14);a[Y>>0]=0;c[Z>>2]=0;c[_>>2]=0;c[$>>2]=0;c[k>>2]=425784;do if((a[aa>>0]|0)==0?(c[Ba>>2]|0)!=0:0){Da=c[E>>2]|0;ka=c[I>>2]|0;b[w>>1]=b[C>>1]|0;if(!(v1(Da,ka,k,w,0,v,c[D>>2]|0,c[F>>2]|0)|0))break;ka=c[A>>2]|0;Da=ka+4|0;c[Da+0>>2]=c[d+0>>2];c[Da+4>>2]=c[d+4>>2];c[Da+8>>2]=c[d+8>>2];b[ka+16>>1]=b[V>>1]|0;g[ka+20>>2]=ea(g[W>>2]);g[ka+24>>2]=ea(g[ba>>2]);g[ka+28>>2]=ea(g[ca>>2]);g[ka+32>>2]=ea(g[da>>2]);g[ka+36>>2]=ea(g[fa>>2]);g[ka+40>>2]=ea(g[ga>>2]);g[ka+44>>2]=ea(g[X>>2]);c[ka+48>>2]=c[ha>>2];a[(c[A>>2]|0)+52>>0]=1;ka=c[A>>2]|0;Da=c[ka+56>>2]|0;Ea=c[ka+64>>2]|0;za=ea(g[ia>>2]);if(!Ea){Fa=ka;Ga=za;Ha=0}else{ka=0;Ia=Ea;while(1){Ja=Da+(ka*48|0)+40|0;if(ea(g[Ja>>2])>za){Ka=Ia+-1|0;La=b[Da+(Ka*48|0)+12>>1]|0;ya=ea(g[Da+(Ka*48|0)+16>>2]);va=ea(g[Da+(Ka*48|0)+20>>2]);Ma=ea(g[Da+(Ka*48|0)+24>>2]);Na=ea(g[Da+(Ka*48|0)+28>>2]);Oa=ea(g[Da+(Ka*48|0)+32>>2]);Pa=ea(g[Da+(Ka*48|0)+36>>2]);Qa=ea(g[Da+(Ka*48|0)+40>>2]);Ra=c[Da+(Ka*48|0)+44>>2]|0;aFi(Da+(ka*48|0)|0,Da+(Ka*48|0)|0,12)|0;b[Da+(ka*48|0)+12>>1]=La;g[Da+(ka*48|0)+16>>2]=ya;g[Da+(ka*48|0)+20>>2]=va;g[Da+(ka*48|0)+24>>2]=Ma;g[Da+(ka*48|0)+28>>2]=Na;g[Da+(ka*48|0)+32>>2]=Oa;g[Da+(ka*48|0)+36>>2]=Pa;g[Ja>>2]=Qa;c[Da+(ka*48|0)+44>>2]=Ra;Sa=Ka}else Sa=Ia;ka=ka+1|0;if((ka|0)==(Ea|0))break;else Ia=Sa}Fa=c[A>>2]|0;Ga=ea(g[ia>>2]);Ha=Sa}c[Fa+64>>2]=Ha;g[L>>2]=Ga;g[e>>2]=Ga}while(0);a[aa>>0]=1;Ba=c[A>>2]|0;ra=c[Ba+64>>2]|0;if((ra|0)==(c[Ba+60>>2]|0)){Ia=xo[c[c[Ba>>2]>>2]&2047](Ba,c[Ba+56>>2]|0,ra)|0;a[P>>0]=Ia&1;if(!Ia){y=0;pa=48;break a}c[(c[A>>2]|0)+64>>2]=0;Ia=c[A>>2]|0;Ta=Ia;Ua=c[Ia+64>>2]|0}else{Ta=Ba;Ua=ra}}else{Ta=Ca;Ua=sa}ra=c[Ta+56>>2]|0;c[Ta+64>>2]=Ua+1;Ba=ra+(Ua*48|0)|0;c[Ba+0>>2]=c[xa+0>>2];c[Ba+4>>2]=c[xa+4>>2];c[Ba+8>>2]=c[xa+8>>2];b[ra+(Ua*48|0)+12>>1]=b[ua+(wa*48|0)+12>>1]|0;g[ra+(Ua*48|0)+16>>2]=ea(g[ua+(wa*48|0)+16>>2]);g[ra+(Ua*48|0)+20>>2]=ea(g[ua+(wa*48|0)+20>>2]);g[ra+(Ua*48|0)+24>>2]=ea(g[ua+(wa*48|0)+24>>2]);g[ra+(Ua*48|0)+28>>2]=ea(g[ua+(wa*48|0)+28>>2]);g[ra+(Ua*48|0)+32>>2]=ea(g[ua+(wa*48|0)+32>>2]);g[ra+(Ua*48|0)+36>>2]=ea(g[ua+(wa*48|0)+36>>2]);g[ra+(Ua*48|0)+40>>2]=ea(g[ua+(wa*48|0)+40>>2]);c[ra+(Ua*48|0)+44>>2]=c[ua+(wa*48|0)+44>>2]}ra=wa+1|0;if(ra>>>0<ma>>>0)wa=ra;else break}}}ja=ja+1|0;if(ja>>>0>=h>>>0){y=1;pa=48;break}}if((pa|0)==25){h=c[A>>2]|0;ja=h+4|0;c[ja+0>>2]=c[xa+0>>2];c[ja+4>>2]=c[xa+4>>2];c[ja+8>>2]=c[xa+8>>2];b[h+16>>1]=b[ua+(wa*48|0)+12>>1]|0;g[h+20>>2]=ea(g[ua+(wa*48|0)+16>>2]);g[h+24>>2]=ea(g[ua+(wa*48|0)+20>>2]);g[h+28>>2]=ea(g[ua+(wa*48|0)+24>>2]);g[h+32>>2]=ea(g[ua+(wa*48|0)+28>>2]);g[h+36>>2]=ea(g[ua+(wa*48|0)+32>>2]);g[h+40>>2]=ea(g[ua+(wa*48|0)+36>>2]);g[h+44>>2]=ea(g[ua+(wa*48|0)+40>>2]);c[h+48>>2]=c[ua+(wa*48|0)+44>>2];a[(c[A>>2]|0)+52>>0]=1;y=0;i=j;return y|0}else if((pa|0)==48){i=j;return y|0}return 0}function FWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=e+4|0;h=b+4|0;j=(c[h>>2]|0)>>>30;if((j|0)==3){k=c[b>>2]|0;l=6}else if((j|0)==2?(j=c[b>>2]|0,(a[j+2417>>0]|0)!=0):0){k=j;l=6}else l=4;if((l|0)==4){j=b+16|0;bfa(j,d);m=c[b+-12>>2]|0;if(!m){n=0;i=e;return n|0}c[f>>2]=1;a[g>>0]=0;Yba(m+64|0,j,f,g);n=0;i=e;return n|0}else if((l|0)==6){r4(k,b);k=c[h>>2]|0;c[h>>2]=k|1;h=b+8|0;l=c[h>>2]|0;if(!l){g=s4(c[b>>2]|0,k>>>24&15)|0;c[h>>2]=g;o=g}else o=l;CLa(o,d);n=o;i=e;return n|0}return 0}function GWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;h=f;j=f+4|0;k=b+4|0;l=c[k>>2]|0;m=l>>>30;if((m|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)n=6}else if((m|0)==3)n=6;if((n|0)==6){n=b+8|0;m=c[n>>2]|0;if(!m){o=s4(c[b>>2]|0,l>>>24&15)|0;c[n>>2]=o;p=o}else p=m;g[p+64>>2]=ea(g[e>>2]);g[p+68>>2]=ea(g[e+4>>2]);g[p+72>>2]=ea(g[e+8>>2]);g[p+76>>2]=ea(g[e+12>>2]);g[p+80>>2]=ea(g[e+16>>2]);g[p+84>>2]=ea(g[e+20>>2]);g[p+88>>2]=ea(g[e+24>>2]);r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|4;i=f;return}p=a[d+64>>0]|0;Yea(d,e);e=c[b+-12>>2]|0;if(!e){i=f;return}if((c[k>>2]&-1073741824|0)==1073741824){i=f;return}c[h>>2]=4;a[j>>0]=p;Yba(e+64|0,d,h,j);i=f;return}function HWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+4|0;j=b+4|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)m=6}else if((l|0)==3)m=6;if((m|0)==6){m=b+8|0;l=c[m>>2]|0;if(!l){n=s4(c[b>>2]|0,k>>>24&15)|0;c[m>>2]=n;o=n}else o=l;l=o+92|0;c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];r4(c[b>>2]|0,b);c[j>>2]=c[j>>2]|8;i=f;return}l=a[d+64>>0]|0;Zea(d,e);e=c[b+-12>>2]|0;if(!e){i=f;return}if((c[j>>2]&-1073741824|0)==1073741824){i=f;return}c[g>>2]=8;a[h>>0]=l;Yba(e+64|0,d,g,h);i=f;return}function IWa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;h=g;j=d+4|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2){if(!(a[(c[d>>2]|0)+2417>>0]|0))m=3}else if((l|0)!=3)m=3;if((m|0)==3){n=z4(d,e,f)|0;i=g;return n|0}l=d+8|0;o=c[l>>2]|0;if(!o){p=s4(c[d>>2]|0,k>>>24&15)|0;c[l>>2]=p;q=p}else q=o;o=f&65535;if(f<<16>>16!=1){p=c[d>>2]|0;l=p+2488|0;k=c[p+2492>>2]|0;b[h>>1]=0;tWa(l,k+o|0,h);h=(c[l>>2]|0)+(k<<1)|0;c[q+56>>2]=k;b[q+60>>1]=f;if(f<<16>>16){r=h;m=9}}else{b[q+60>>1]=f;r=q+56|0;m=9}if((m|0)==9){m=0;do{b[r+(m<<1)>>1]=c[(c[e+(m<<2)>>2]|0)+52>>2];m=m+1|0}while((m|0)!=(o|0))}r4(c[d>>2]|0,d);c[j>>2]=c[j>>2]|2;n=1;i=g;return n|0}function JWa(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;h=f;j=f+4|0;k=b+4|0;l=c[k>>2]|0;m=l>>>30;if((m|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)n=6}else if((m|0)==3)n=6;if((n|0)==6){n=b+8|0;m=c[n>>2]|0;if(!m){o=s4(c[b>>2]|0,l>>>24&15)|0;c[n>>2]=o;p=o}else p=m;g[p+112>>2]=e;r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|32;i=f;return}p=a[d+64>>0]|0;afa(d,e);m=c[b+-12>>2]|0;if(!m){i=f;return}if((c[k>>2]&-1073741824|0)==1073741824){i=f;return}c[h>>2]=32;a[j>>0]=p;Yba(m+64|0,d,h,j);i=f;return}function KWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+5|0;h=f;j=f+4|0;k=b+4|0;l=c[k>>2]|0;m=l>>>30;if((m|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)n=6}else if((m|0)==3)n=6;if((n|0)==6){n=b+8|0;m=c[n>>2]|0;if(!m){o=s4(c[b>>2]|0,l>>>24&15)|0;c[n>>2]=o;p=o}else p=m;a[p+116>>0]=a[e>>0]|0;r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|64;i=f;return}p=a[d+64>>0]|0;a[g>>0]=a[e>>0]|0;cfa(d,g);g=c[b+-12>>2]|0;if(!g){i=f;return}if((c[k>>2]&-1073741824|0)==1073741824){i=f;return}c[h>>2]=64;a[j>>0]=p;Yba(g+64|0,d,h,j);i=f;return}function LWa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;k=j>>>30;if(!k){i=f;return}l=c[d>>2]|0;if(!(a[l+2417>>0]|0)){if(!(j&1))m=(c[450992+((j>>>24&15)<<2)>>2]|0)+d+8|0;else{n=d+8|0;o=c[n>>2]|0;if(!o){p=s4(l,j>>>24&15)|0;c[n>>2]=p;q=p}else q=o;m=q}if(!(b[m>>1]&8)){q2(e);m=d;Vba((c[450992+(((c[h>>2]|0)>>>24&15)<<2)>>2]|0)+m|0,e+16|0);r=m}else r=d;Zba((c[450992+(((c[h>>2]|0)>>>24&15)<<2)>>2]|0)+r|0)|0;r=e+4|0;m=c[r>>2]|0;if((m&251658240|0)!=16777216){i=f;return}c[r>>2]=m&1073741823|-2147483648;c[e>>2]=l;i=f;return}if((k|0)==1){k=e+4|0;m=c[k>>2]|0;if((m&251658240|0)!=16777216){i=f;return}c[k>>2]=m&1073741823|1073741824;c[e>>2]=l;i=f;return}m=d+8|0;k=c[m>>2]|0;if(!k){r=s4(l,j>>>24&15)|0;c[m>>2]=r;s=r}else s=k;k=s+76|0;r=c[k>>2]|0;if(r){m=c[s+72>>2]|0;j=0;while(1){q=j+1|0;if((c[m+(j<<3)>>2]|0)==(e|0)){t=j;break}if(q>>>0<r>>>0)j=q;else{t=q;break}}if((t|0)!=(r|0)){j=m+(t<<3)|0;t=r+-1|0;c[k>>2]=t;k=m+(t<<3)|0;c[j+0>>2]=c[k+0>>2];a[j+4>>0]=a[k+4>>0]|0}else u=24}else u=24;do if((u|0)==24){c[g>>2]=e;k=s+28|0;j=c[k>>2]|0;if((c[s+32>>2]&2147483647)>>>0<=j>>>0){kBb(s+4|0,g)|0;break}t=(c[s+24>>2]|0)+(j<<2)|0;if(t)c[t>>2]=e;c[k>>2]=j+1}while(0);r4(c[d>>2]|0,d);c[h>>2]=c[h>>2]|8;h=e+4|0;d=c[h>>2]|0;if((d&251658240|0)!=16777216){i=f;return}c[h>>2]=d&1073741823|1073741824;c[e>>2]=l;i=f;return}function MWa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;h=i;i=i+16|0;j=h+8|0;k=h;l=d+4|0;m=c[l>>2]|0;n=m>>>30;if(!n){i=h;return}o=c[d>>2]|0;if(!(a[o+2417>>0]|0)){p=d;Zba((c[450992+((m>>>24&15)<<2)>>2]|0)+p|0)|0;q=c[l>>2]|0;if(!(q&1))r=(c[450992+((q>>>24&15)<<2)>>2]|0)+p+8|0;else{s=d+8|0;t=c[s>>2]|0;if(!t){u=s4(c[d>>2]|0,q>>>24&15)|0;c[s>>2]=u;v=u}else v=t;r=v}if(!(b[r>>1]&8)){Xba((c[450992+(((c[l>>2]|0)>>>24&15)<<2)>>2]|0)+p|0,e+16|0,f);r2(e)}p=e+4|0;r=c[p>>2]|0;if((r&251658240|0)!=16777216){i=h;return}c[p>>2]=r&1073741823;c[e>>2]=0;i=h;return}if((n|0)==1){n=e+4|0;r=c[n>>2]|0;if((r&251658240|0)!=16777216){i=h;return}c[n>>2]=r&1073741823;c[e>>2]=0;i=h;return}r=d+8|0;n=c[r>>2]|0;if(!n){p=s4(o,m>>>24&15)|0;c[r>>2]=p;w=c[l>>2]|0;x=p}else{w=m;x=n}a:do if(w&32){n=x+88|0;m=c[n>>2]|0;p=x+84|0;if((m|0)==1){if((c[p>>2]|0)!=(e|0))break;c[n>>2]=0;c[p>>2]=0;c[l>>2]=c[l>>2]&-33;break}r=c[p>>2]|0;v=c[o+2500>>2]|0;t=v+(r<<2)|0;do if(!m)c[n>>2]=0;else{u=0;s=0;q=m;while(1){y=v+(u+r<<2)|0;if((c[y>>2]|0)==(e|0)){z=q+-1|0;c[y>>2]=c[v+(z+r<<2)>>2];A=u;B=z}else{A=u+1|0;B=q}s=s+1|0;if(s>>>0>=m>>>0)break;else{u=A;q=B}}c[n>>2]=A;if(!A)break;else if((A|0)!=1)break a;c[p>>2]=c[t>>2];break a}while(0);c[p>>2]=0;c[l>>2]=c[l>>2]&-33}while(0);A=x+28|0;B=c[A>>2]|0;if(B){w=c[x+24>>2]|0;t=0;while(1){n=t+1|0;if((c[w+(t<<2)>>2]|0)==(e|0)){C=t;break}if(n>>>0<B>>>0)t=n;else{C=n;break}}if((C|0)!=(B|0)){t=B+-1|0;c[A>>2]=t;c[w+(C<<2)>>2]=c[w+(t<<2)>>2];t=e+4|0;w=c[t>>2]|0;if((w&251658240|0)==16777216){c[t>>2]=w&1073741823|-2147483648;c[e>>2]=o}}else D=37}else D=37;if((D|0)==37){D=d;w=c[l>>2]|0;do if(!(b[(c[450992+((w>>>24&15)<<2)>>2]|0)+D+8>>1]&8)){c[j>>2]=e;a[j+4>>0]=f&1;t=x+76|0;C=c[t>>2]|0;if((c[x+80>>2]&2147483647)>>>0<=C>>>0){lBb(x+36|0,j)|0;break}A=(c[x+72>>2]|0)+(C<<3)|0;if(!A)E=C;else{C=j;B=c[C+4>>2]|0;n=A;c[n>>2]=c[C>>2];c[n+4>>2]=B;E=c[t>>2]|0}c[t>>2]=E+1}else{if(g){if(!(c[e+4>>2]&268435456))F=w;else{L3(o+2448|0,e);F=c[l>>2]|0}Zba((c[450992+((F>>>24&15)<<2)>>2]|0)+D|0)|0;break}c[k>>2]=e;a[k+4>>0]=0;t=x+76|0;B=c[t>>2]|0;if((c[x+80>>2]&2147483647)>>>0<=B>>>0){lBb(x+36|0,k)|0;break}n=(c[x+72>>2]|0)+(B<<3)|0;if(!n)G=B;else{B=k;C=c[B+4>>2]|0;A=n;c[A>>2]=c[B>>2];c[A+4>>2]=C;G=c[t>>2]|0}c[t>>2]=G+1}while(0);G=e+4|0;k=c[G>>2]|0;if((k&251658240|0)==16777216){c[G>>2]=k|-1073741824;c[e>>2]=o}}r4(c[d>>2]|0,d);c[l>>2]=c[l>>2]|8;i=h;return}function NWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?447768:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function OWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)NWa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function PWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?447768:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function QWa(d,f,h,j,k,l,m){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=Im,Ma=Im,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=0,bb=0,cb=Im,db=0,eb=0,fb=0;n=i;i=i+144|0;o=n;p=n+136|0;q=n+132|0;r=n+96|0;s=n+137|0;t=n+4|0;u=n+104|0;v=n+8|0;w=n+134|0;x=h+68|0;a[x>>0]=0;y=h+80|0;c[y>>2]=0;z=k+16|0;A=b[z>>1]|0;b[q>>1]=A;B=d+80|0;C=d+108|0;D=d+112|0;E=A&65535;A=d+4|0;F=0;a:while(1){do if(!(a[d+F+116>>0]|0)){G=c[B>>2]|0;if(F)if((c[G+24>>2]|0)==(c[D>>2]|0))break;else{H=7;break}if((c[G+20>>2]|0)==(c[C>>2]|0)){F=F+1|0;continue a}else H=7}else H=7;while(0);if((H|0)==7?(H=0,(E&F+1|0)!=0):0){G=(R2(d,F,0,0)|0)==1;I=(c[A>>2]|0)==-1;if(G){H=10;break}if(I){H=11;break}}F=F+1|0;if(F>>>0>=2){H=15;break}}if((H|0)==10){if(I)H=11}else if((H|0)==15){I=c[d+88>>2]|0;c[r>>2]=I;F=c[d+100>>2]|0;c[r+4>>2]=F;if(!(I|F)){J=0;i=n;return J|0}K=ea(g[f+8>>2]);F=xCa(c[B>>2]|0)|0;A=c[d+72>>2]|0;E=c[d+76>>2]|0;C=A>>>0<E>>>0?E:A;A=C<<6;if(C>>>0<128){E=i;i=i+((1*A|0)+15&-16)|0;L=0;M=E}else{E=sKa(s,A,447432,632)|0;L=E;M=E}E=(b[z>>1]&32)!=0;A=h+76|0;s=f+4|0;D=(l|0)==0;G=v+4|0;N=v+8|0;O=v+12|0;P=v+16|0;Q=v+20|0;R=v+44|0;S=v+48|0;T=v+52|0;U=v+68|0;V=v+72|0;W=v+76|0;X=v+80|0;Y=h+4|0;Z=v+4|0;_=h+16|0;$=h+20|0;aa=v+24|0;ba=h+24|0;ca=v+28|0;da=h+28|0;fa=v+32|0;ga=h+32|0;ha=v+36|0;ia=h+36|0;ja=v+40|0;ka=h+40|0;la=h+44|0;ma=h+48|0;na=h+72|0;oa=I;pa=K;I=0;b:while(1){if(!oa)qa=pa;else{ra=d+(I*12|0)+84|0;K=pa;sa=0;while(1){ta=(c[ra>>2]|0)+(sa<<3)|0;ua=c[ta>>2]|0;if((b[ua+4>>1]|0)==5)va=(ua|0)!=0?2:1;else va=1;if((e[q>>1]&va|0)!=0?(c[t>>2]=(c[A>>2]|0)!=0?1:2,ua=b[j>>1]|0,wa=mBb(ta,t,q,k,l,F,j)|0,ta=c[t>>2]|0,!((wa|0)==0|(ta|0)==0)):0){xa=wa+4|0;ya=c[xa>>2]|0;zCa(u,ya,c[wa>>2]|0);za=c[ya+36>>2]|0;if(!(za&1))Aa=ya+116|0;else{Ba=ya+40|0;Ca=c[Ba>>2]|0;if(!Ca){Da=s4(c[ya+32>>2]|0,za>>>24&15)|0;c[Ba>>2]=Da;Ea=Da}else Ea=Ca;Aa=Ea}if((c[Aa>>2]|0)==5?(b[j>>1]&32)==0:0)Fa=1;else Fa=C;Ca=c[f>>2]|0;Da=c[s>>2]|0;b[o>>1]=ua;ua=zLa(Ca,Da,Aa,u,K,o,Fa,M,0)|0;if(ua){Da=(b[q>>1]&8)==0;Ga=K;Ha=0;while(1){Ia=M+(Ha<<6)|0;c[Ia>>2]=c[wa>>2];c[M+(Ha<<6)+4>>2]=c[xa>>2];Ja=M+(Ha<<6)+12|0;Ca=b[Ja>>1]|0;if(!(Ca&4))g[M+(Ha<<6)+40>>2]=ea(0.0);if(!(Ca&1)){g[M+(Ha<<6)+16>>2]=ea(0.0);g[M+(Ha<<6)+20>>2]=ea(0.0);g[M+(Ha<<6)+24>>2]=ea(0.0)}if(!(Ca&2)){g[M+(Ha<<6)+28>>2]=ea(0.0);g[M+(Ha<<6)+32>>2]=ea(0.0);g[M+(Ha<<6)+36>>2]=ea(0.0)}if(!(Ca&8)){g[M+(Ha<<6)+44>>2]=ea(0.0);g[M+(Ha<<6)+48>>2]=ea(0.0)}if(D|Da)Ka=ta;else Ka=xo[c[(c[l>>2]|0)+4>>2]&2047](l,k,Ia)|0;if(!((b[z>>1]&16)==0|(Ka|0)==0)){H=47;break b}Ca=E?1:Ka;do if((Ca|0)==2){La=ea(g[Ia+40>>2]);if(!(La<=Ga)){Ma=Ga;break};c[Y+0>>2]=c[Ia+0>>2];c[Y+4>>2]=c[Ia+4>>2];c[Y+8>>2]=c[Ia+8>>2];b[_>>1]=b[Ja>>1]|0;g[$>>2]=ea(g[M+(Ha<<6)+16>>2]);g[ba>>2]=ea(g[M+(Ha<<6)+20>>2]);g[da>>2]=ea(g[M+(Ha<<6)+24>>2]);g[ga>>2]=ea(g[M+(Ha<<6)+28>>2]);g[ia>>2]=ea(g[M+(Ha<<6)+32>>2]);g[ka>>2]=ea(g[M+(Ha<<6)+36>>2]);g[la>>2]=ea(g[M+(Ha<<6)+40>>2]);Ba=M+(Ha<<6)+44|0;c[ma+0>>2]=c[Ba+0>>2];c[ma+4>>2]=c[Ba+4>>2];c[ma+8>>2]=c[Ba+8>>2];c[ma+12>>2]=c[Ba+12>>2];c[ma+16>>2]=c[Ba+16>>2];a[x>>0]=1;Ma=La}else if((Ca|0)==1){Ba=c[A>>2]|0;if(!Ba){Ma=Ga;break}if(!(ea(g[Ia+40>>2])<=Ga)){Ma=Ga;break}za=c[y>>2]|0;do if((za|0)==(Ba|0)){c[G>>2]=0;c[N>>2]=0;c[O>>2]=-1;b[P>>1]=0;c[Q+0>>2]=0;c[Q+4>>2]=0;c[Q+8>>2]=0;c[Q+12>>2]=0;c[Q+16>>2]=0;c[Q+20>>2]=0;g[R>>2]=ea(3402823469999999843913219.0e14);g[S>>2]=ea(0.0);g[T>>2]=ea(0.0);a[U>>0]=0;c[V>>2]=0;c[W>>2]=0;c[X>>2]=0;c[v>>2]=420192;b[w>>1]=b[j>>1]|0;if(QWa(d,f,v,w,k,l,m)|0){c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];b[_>>1]=b[P>>1]|0;g[$>>2]=ea(g[Q>>2]);g[ba>>2]=ea(g[aa>>2]);g[da>>2]=ea(g[ca>>2]);g[ga>>2]=ea(g[fa>>2]);g[ia>>2]=ea(g[ha>>2]);g[ka>>2]=ea(g[ja>>2]);La=ea(g[R>>2]);g[la>>2]=La;c[ma+0>>2]=c[S+0>>2];c[ma+4>>2]=c[S+4>>2];c[ma+8>>2]=c[S+8>>2];c[ma+12>>2]=c[S+12>>2];c[ma+16>>2]=c[S+16>>2];a[x>>0]=1;ya=c[na>>2]|0;Na=c[y>>2]|0;if(!Na)Oa=0;else{Pa=0;Qa=Na;while(1){Ra=ya+(Pa<<6)+40|0;if(ea(g[Ra>>2])>La){Sa=Qa+-1|0;Ta=b[ya+(Sa<<6)+12>>1]|0;Ua=ea(g[ya+(Sa<<6)+16>>2]);Va=ea(g[ya+(Sa<<6)+20>>2]);Wa=ea(g[ya+(Sa<<6)+24>>2]);Xa=ea(g[ya+(Sa<<6)+28>>2]);Ya=ea(g[ya+(Sa<<6)+32>>2]);Za=ea(g[ya+(Sa<<6)+36>>2]);_a=ea(g[ya+(Sa<<6)+40>>2]);aFi(ya+(Pa<<6)|0,ya+(Sa<<6)|0,12)|0;b[ya+(Pa<<6)+12>>1]=Ta;g[ya+(Pa<<6)+16>>2]=Ua;g[ya+(Pa<<6)+20>>2]=Va;g[ya+(Pa<<6)+24>>2]=Wa;g[ya+(Pa<<6)+28>>2]=Xa;g[ya+(Pa<<6)+32>>2]=Ya;g[ya+(Pa<<6)+36>>2]=Za;g[Ra>>2]=_a;aFi(ya+(Pa<<6)+44|0,ya+(Sa<<6)+44|0,20)|0;$a=Sa}else $a=Qa;Pa=Pa+1|0;if((Pa|0)==(Na|0)){Oa=$a;break}else Qa=$a}}c[y>>2]=Oa;ab=Oa}else ab=c[y>>2]|0;if((ab|0)!=(c[A>>2]|0)){bb=ab;break}if(!(xo[c[c[h>>2]>>2]&2047](h,c[na>>2]|0,ab)|0)){H=62;break b}c[y>>2]=0;bb=0}else bb=za;while(0);c[y>>2]=bb+1;za=c[na>>2]|0;Ba=za+(bb<<6)|0;c[Ba+0>>2]=c[Ia+0>>2];c[Ba+4>>2]=c[Ia+4>>2];c[Ba+8>>2]=c[Ia+8>>2];b[za+(bb<<6)+12>>1]=b[Ja>>1]|0;g[za+(bb<<6)+16>>2]=ea(g[M+(Ha<<6)+16>>2]);g[za+(bb<<6)+20>>2]=ea(g[M+(Ha<<6)+20>>2]);g[za+(bb<<6)+24>>2]=ea(g[M+(Ha<<6)+24>>2]);g[za+(bb<<6)+28>>2]=ea(g[M+(Ha<<6)+28>>2]);g[za+(bb<<6)+32>>2]=ea(g[M+(Ha<<6)+32>>2]);g[za+(bb<<6)+36>>2]=ea(g[M+(Ha<<6)+36>>2]);g[za+(bb<<6)+40>>2]=ea(g[M+(Ha<<6)+40>>2]);Ba=za+(bb<<6)+44|0;za=M+(Ha<<6)+44|0;c[Ba+0>>2]=c[za+0>>2];c[Ba+4>>2]=c[za+4>>2];c[Ba+8>>2]=c[za+8>>2];c[Ba+12>>2]=c[za+12>>2];c[Ba+16>>2]=c[za+16>>2];Ma=Ga}else Ma=Ga;while(0);Ca=Ha+1|0;if(Ca>>>0<ua>>>0){Ga=Ma;Ha=Ca}else{cb=Ma;break}}}else cb=K}else cb=K;sa=sa+1|0;if(sa>>>0>=oa>>>0){qa=cb;break}else K=cb}}sa=I+1|0;if(sa>>>0>=2){H=70;break}oa=c[r+(sa<<2)>>2]|0;pa=qa;I=sa}if((H|0)==47){c[Y+0>>2]=c[Ia+0>>2];c[Y+4>>2]=c[Ia+4>>2];c[Y+8>>2]=c[Ia+8>>2];b[_>>1]=b[Ja>>1]|0;g[$>>2]=ea(g[M+(Ha<<6)+16>>2]);g[ba>>2]=ea(g[M+(Ha<<6)+20>>2]);g[da>>2]=ea(g[M+(Ha<<6)+24>>2]);g[ga>>2]=ea(g[M+(Ha<<6)+28>>2]);g[ia>>2]=ea(g[M+(Ha<<6)+32>>2]);g[ka>>2]=ea(g[M+(Ha<<6)+36>>2]);g[la>>2]=ea(g[M+(Ha<<6)+40>>2]);la=M+(Ha<<6)+44|0;c[ma+0>>2]=c[la+0>>2];c[ma+4>>2]=c[la+4>>2];c[ma+8>>2]=c[la+8>>2];c[ma+12>>2]=c[la+12>>2];c[ma+16>>2]=c[la+16>>2];ko[c[(c[h>>2]|0)+4>>2]&4095](h);a[x>>0]=1;db=1}else if((H|0)==62){ko[c[(c[h>>2]|0)+4>>2]&4095](h);db=(a[x>>0]|0)!=0}else if((H|0)==70){la=c[y>>2]|0;if(a[x>>0]|0){if(la){ma=c[na>>2]|0;qa=ea(g[h+44>>2]);Ha=0;M=la;while(1){ka=ma+(Ha<<6)+40|0;if(ea(g[ka>>2])>qa){ia=M+-1|0;ga=b[ma+(ia<<6)+12>>1]|0;pa=ea(g[ma+(ia<<6)+16>>2]);cb=ea(g[ma+(ia<<6)+20>>2]);Ma=ea(g[ma+(ia<<6)+24>>2]);m=ea(g[ma+(ia<<6)+28>>2]);K=ea(g[ma+(ia<<6)+32>>2]);Ga=ea(g[ma+(ia<<6)+36>>2]);La=ea(g[ma+(ia<<6)+40>>2]);aFi(ma+(Ha<<6)|0,ma+(ia<<6)|0,12)|0;b[ma+(Ha<<6)+12>>1]=ga;g[ma+(Ha<<6)+16>>2]=pa;g[ma+(Ha<<6)+20>>2]=cb;g[ma+(Ha<<6)+24>>2]=Ma;g[ma+(Ha<<6)+28>>2]=m;g[ma+(Ha<<6)+32>>2]=K;g[ma+(Ha<<6)+36>>2]=Ga;g[ka>>2]=La;aFi(ma+(Ha<<6)+44|0,ma+(ia<<6)+44|0,20)|0;eb=ia}else eb=M;Ha=Ha+1|0;if((Ha|0)==(la|0))break;else M=eb}c[y>>2]=eb;fb=eb;H=77}}else{fb=la;H=77}if(((H|0)==77?(fb|0)!=0:0)?xo[c[c[h>>2]>>2]&2047](h,c[na>>2]|0,fb)|0:0)c[y>>2]=0;ko[c[(c[h>>2]|0)+4>>2]&4095](h);db=(a[x>>0]|0)!=0}if(!L){J=db;i=n;return J|0}tKa(p,L);J=db;i=n;return J|0}if((H|0)==11)dKa(bKa()|0,128,447432,599,447688,o);H=xCa(c[B>>2]|0)|0;B=c[(c[H>>2]|0)+348>>2]|0;db=c[f>>2]|0;L=c[f+4>>2]|0;qa=ea(g[f+8>>2]);b[o>>1]=b[j>>1]|0;Fo[B&1](H,db,L,qa,h,o,k,l,0)|0;if(a[x>>0]|0){J=1;i=n;return J|0}J=(c[y>>2]|0)!=0;i=n;return J|0}function RWa(d,f,h,j,k,l,m){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=Im,Ia=0,Ja=Im,Ka=Im,La=0,Ma=Im,Na=0,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;n=i;i=i+128|0;o=n;p=n+120|0;q=n+116|0;r=n+80|0;s=n+121|0;t=n+4|0;u=n+88|0;v=n+8|0;w=n+118|0;x=h+52|0;a[x>>0]=0;y=h+64|0;c[y>>2]=0;z=k+16|0;A=b[z>>1]|0;b[q>>1]=A;B=d+80|0;C=d+108|0;D=d+112|0;E=A&65535;A=d+4|0;F=0;a:while(1){do if(!(a[d+F+116>>0]|0)){G=c[B>>2]|0;if(F)if((c[G+24>>2]|0)==(c[D>>2]|0))break;else{H=7;break}if((c[G+20>>2]|0)==(c[C>>2]|0)){F=F+1|0;continue a}else H=7}else H=7;while(0);if((H|0)==7?(H=0,(E&F+1|0)!=0):0){G=(R2(d,F,0,0)|0)==1;I=(c[A>>2]|0)==-1;if(G){H=10;break}if(I){H=11;break}}F=F+1|0;if(F>>>0>=2){H=15;break}}if((H|0)==10){if(I)H=11}else if((H|0)==15){I=c[d+88>>2]|0;c[r>>2]=I;F=c[d+100>>2]|0;c[r+4>>2]=F;if(!(I|F)){J=0;i=n;return J|0}F=f+8|0;K=ea(g[F>>2]);A=xCa(c[B>>2]|0)|0;E=c[d+72>>2]|0;C=c[d+76>>2]|0;D=E>>>0<C>>>0?C:E;E=D*48|0;if(D>>>0<128){D=i;i=i+((1*E|0)+15&-16)|0;L=0;M=D}else{D=sKa(s,E,447432,632)|0;L=D;M=D}D=(b[z>>1]&32)!=0;E=h+60|0;s=f+4|0;C=f+12|0;G=f+16|0;N=(l|0)==0;O=v+4|0;P=v+8|0;Q=v+12|0;R=v+16|0;S=v+20|0;T=v+44|0;U=v+52|0;V=v+56|0;W=v+60|0;X=v+64|0;Y=h+4|0;Z=v+4|0;_=h+16|0;$=h+20|0;aa=v+24|0;ba=h+24|0;ca=v+28|0;da=h+28|0;fa=v+32|0;ga=h+32|0;ha=v+36|0;ia=h+36|0;ja=v+40|0;ka=h+40|0;la=h+44|0;ma=v+48|0;na=h+48|0;oa=h+56|0;pa=I;qa=K;I=0;b:while(1){if(!pa)ra=qa;else{sa=d+(I*12|0)+84|0;K=qa;ta=0;while(1){ua=(c[sa>>2]|0)+(ta<<3)|0;va=c[ua>>2]|0;if((b[va+4>>1]|0)==5)wa=(va|0)!=0?2:1;else wa=1;do if((e[q>>1]&wa|0)!=0?(c[t>>2]=(c[E>>2]|0)!=0?1:2,va=b[j>>1]|0,xa=mBb(ua,t,q,k,l,A,j)|0,ya=c[t>>2]|0,!((xa|0)==0|(ya|0)==0)):0){za=xa+4|0;Aa=c[za>>2]|0;zCa(u,Aa,c[xa>>2]|0);Ba=c[Aa+36>>2]|0;if(!(Ba&1))Ca=Aa+116|0;else{Da=Aa+40|0;Ea=c[Da>>2]|0;if(!Ea){Fa=s4(c[Aa+32>>2]|0,Ba>>>24&15)|0;c[Da>>2]=Fa;Ga=Fa}else Ga=Ea;Ca=Ga}Ea=c[s>>2]|0;Ha=ea(g[F>>2]);Fa=c[C>>2]|0;Da=c[G>>2]|0;b[o>>1]=va;if(xLa(Ea,Ha,Fa,Da,Ca,u,M,o,ea(0.0))|0){Da=(b[q>>1]&8)==0;c[M>>2]=c[xa>>2];c[M+4>>2]=c[za>>2];Ia=M+12|0;za=b[Ia>>1]|0;if(!(za&4))g[M+40>>2]=ea(0.0);if(!(za&1)){g[M+16>>2]=ea(0.0);g[M+20>>2]=ea(0.0);g[M+24>>2]=ea(0.0)}if(!(za&2)){g[M+28>>2]=ea(0.0);g[M+32>>2]=ea(0.0);g[M+36>>2]=ea(0.0)}za=M+40|0;if(ea(g[za>>2])==ea(0.0)){xa=c[s>>2]|0;Ha=ea(-ea(g[xa>>2]));Ja=ea(-ea(g[xa+4>>2]));Ka=ea(-ea(g[xa+8>>2]));g[M+28>>2]=Ha;g[M+32>>2]=Ja;g[M+36>>2]=Ka}if(N|Da)La=ya;else La=xo[c[(c[l>>2]|0)+4>>2]&2047](l,k,M)|0;if(!((b[z>>1]&16)==0|(La|0)==0)){H=43;break b}ya=D?1:La;if((ya|0)==2){Ka=ea(g[za>>2]);if(!(Ka<=K)){Ma=K;break};c[Y+0>>2]=c[M+0>>2];c[Y+4>>2]=c[M+4>>2];c[Y+8>>2]=c[M+8>>2];b[_>>1]=b[Ia>>1]|0;g[$>>2]=ea(g[M+16>>2]);g[ba>>2]=ea(g[M+20>>2]);g[da>>2]=ea(g[M+24>>2]);g[ga>>2]=ea(g[M+28>>2]);g[ia>>2]=ea(g[M+32>>2]);g[ka>>2]=ea(g[M+36>>2]);g[la>>2]=ea(g[M+40>>2]);c[na>>2]=c[M+44>>2];a[x>>0]=1;Ma=Ka;break}else if((ya|0)!=1){Ma=K;break}ya=c[E>>2]|0;if(ya){if(!(ea(g[za>>2])<=K)){Ma=K;break}za=c[y>>2]|0;do if((za|0)==(ya|0)){c[O>>2]=0;c[P>>2]=0;c[Q>>2]=-1;b[R>>1]=0;c[S+0>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;c[S+12>>2]=0;c[S+16>>2]=0;c[S+20>>2]=0;g[T>>2]=ea(3402823469999999843913219.0e14);a[U>>0]=0;c[V>>2]=0;c[W>>2]=0;c[X>>2]=0;c[v>>2]=425784;b[w>>1]=b[j>>1]|0;if(RWa(d,f,v,w,k,l,m)|0){c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];b[_>>1]=b[R>>1]|0;g[$>>2]=ea(g[S>>2]);g[ba>>2]=ea(g[aa>>2]);g[da>>2]=ea(g[ca>>2]);g[ga>>2]=ea(g[fa>>2]);g[ia>>2]=ea(g[ha>>2]);g[ka>>2]=ea(g[ja>>2]);Ka=ea(g[T>>2]);g[la>>2]=Ka;c[na>>2]=c[ma>>2];a[x>>0]=1;Da=c[oa>>2]|0;xa=c[y>>2]|0;if(!xa)Na=0;else{Fa=0;Ea=xa;while(1){va=Da+(Fa*48|0)+40|0;if(ea(g[va>>2])>Ka){Ba=Ea+-1|0;Aa=b[Da+(Ba*48|0)+12>>1]|0;Ja=ea(g[Da+(Ba*48|0)+16>>2]);Ha=ea(g[Da+(Ba*48|0)+20>>2]);Oa=ea(g[Da+(Ba*48|0)+24>>2]);Pa=ea(g[Da+(Ba*48|0)+28>>2]);Qa=ea(g[Da+(Ba*48|0)+32>>2]);Ra=ea(g[Da+(Ba*48|0)+36>>2]);Sa=ea(g[Da+(Ba*48|0)+40>>2]);Ta=c[Da+(Ba*48|0)+44>>2]|0;aFi(Da+(Fa*48|0)|0,Da+(Ba*48|0)|0,12)|0;b[Da+(Fa*48|0)+12>>1]=Aa;g[Da+(Fa*48|0)+16>>2]=Ja;g[Da+(Fa*48|0)+20>>2]=Ha;g[Da+(Fa*48|0)+24>>2]=Oa;g[Da+(Fa*48|0)+28>>2]=Pa;g[Da+(Fa*48|0)+32>>2]=Qa;g[Da+(Fa*48|0)+36>>2]=Ra;g[va>>2]=Sa;c[Da+(Fa*48|0)+44>>2]=Ta;Ua=Ba}else Ua=Ea;Fa=Fa+1|0;if((Fa|0)==(xa|0)){Na=Ua;break}else Ea=Ua}}c[y>>2]=Na;Va=Na}else Va=c[y>>2]|0;if((Va|0)!=(c[E>>2]|0)){Wa=Va;break}if(!(xo[c[c[h>>2]>>2]&2047](h,c[oa>>2]|0,Va)|0)){H=58;break b}c[y>>2]=0;Wa=0}else Wa=za;while(0);c[y>>2]=Wa+1;za=c[oa>>2]|0;ya=za+(Wa*48|0)|0;c[ya+0>>2]=c[M+0>>2];c[ya+4>>2]=c[M+4>>2];c[ya+8>>2]=c[M+8>>2];b[za+(Wa*48|0)+12>>1]=b[Ia>>1]|0;g[za+(Wa*48|0)+16>>2]=ea(g[M+16>>2]);g[za+(Wa*48|0)+20>>2]=ea(g[M+20>>2]);g[za+(Wa*48|0)+24>>2]=ea(g[M+24>>2]);g[za+(Wa*48|0)+28>>2]=ea(g[M+28>>2]);g[za+(Wa*48|0)+32>>2]=ea(g[M+32>>2]);g[za+(Wa*48|0)+36>>2]=ea(g[M+36>>2]);g[za+(Wa*48|0)+40>>2]=ea(g[M+40>>2]);c[za+(Wa*48|0)+44>>2]=c[M+44>>2];Ma=K}else Ma=K}else Ma=K}else Ma=K;while(0);ta=ta+1|0;if(ta>>>0>=pa>>>0){ra=Ma;break}else K=Ma}}ta=I+1|0;if(ta>>>0>=2){H=65;break}pa=c[r+(ta<<2)>>2]|0;qa=ra;I=ta}if((H|0)==43){c[Y+0>>2]=c[M+0>>2];c[Y+4>>2]=c[M+4>>2];c[Y+8>>2]=c[M+8>>2];b[_>>1]=b[Ia>>1]|0;g[$>>2]=ea(g[M+16>>2]);g[ba>>2]=ea(g[M+20>>2]);g[da>>2]=ea(g[M+24>>2]);g[ga>>2]=ea(g[M+28>>2]);g[ia>>2]=ea(g[M+32>>2]);g[ka>>2]=ea(g[M+36>>2]);g[la>>2]=ea(g[M+40>>2]);c[na>>2]=c[M+44>>2];ko[c[(c[h>>2]|0)+4>>2]&4095](h);a[x>>0]=1;Xa=1}else if((H|0)==58){ko[c[(c[h>>2]|0)+4>>2]&4095](h);Xa=(a[x>>0]|0)!=0}else if((H|0)==65){M=c[y>>2]|0;if(a[x>>0]|0){if(M){na=c[oa>>2]|0;ra=ea(g[h+44>>2]);la=0;ka=M;while(1){ia=na+(la*48|0)+40|0;if(ea(g[ia>>2])>ra){ga=ka+-1|0;da=b[na+(ga*48|0)+12>>1]|0;qa=ea(g[na+(ga*48|0)+16>>2]);Ma=ea(g[na+(ga*48|0)+20>>2]);m=ea(g[na+(ga*48|0)+24>>2]);K=ea(g[na+(ga*48|0)+28>>2]);Ka=ea(g[na+(ga*48|0)+32>>2]);Sa=ea(g[na+(ga*48|0)+36>>2]);Ra=ea(g[na+(ga*48|0)+40>>2]);ba=c[na+(ga*48|0)+44>>2]|0;aFi(na+(la*48|0)|0,na+(ga*48|0)|0,12)|0;b[na+(la*48|0)+12>>1]=da;g[na+(la*48|0)+16>>2]=qa;g[na+(la*48|0)+20>>2]=Ma;g[na+(la*48|0)+24>>2]=m;g[na+(la*48|0)+28>>2]=K;g[na+(la*48|0)+32>>2]=Ka;g[na+(la*48|0)+36>>2]=Sa;g[ia>>2]=Ra;c[na+(la*48|0)+44>>2]=ba;Ya=ga}else Ya=ka;la=la+1|0;if((la|0)==(M|0))break;else ka=Ya}c[y>>2]=Ya;Za=Ya;H=72}}else{Za=M;H=72}if(((H|0)==72?(Za|0)!=0:0)?xo[c[c[h>>2]>>2]&2047](h,c[oa>>2]|0,Za)|0:0)c[y>>2]=0;ko[c[(c[h>>2]|0)+4>>2]&4095](h);Xa=(a[x>>0]|0)!=0}if(!L){J=Xa;i=n;return J|0}tKa(p,L);J=Xa;i=n;return J|0}if((H|0)==11)dKa(bKa()|0,128,447432,599,447688,o);H=xCa(c[B>>2]|0)|0;B=c[(c[H>>2]|0)+352>>2]|0;Xa=c[f+12>>2]|0;L=c[f+16>>2]|0;p=c[f+4>>2]|0;ra=ea(g[f+8>>2]);b[o>>1]=b[j>>1]|0;qo[B&1](H,Xa,L,p,ra,h,o,k,l,0,ea(0.0))|0;if(a[x>>0]|0){J=1;i=n;return J|0}J=(c[y>>2]|0)!=0;i=n;return J|0}function SWa(d,f,g,h,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=0,ma=0,na=0,oa=0;m=i;i=i+96|0;n=m;o=m+82|0;p=m+32|0;q=m+84|0;r=m+76|0;s=m+4|0;t=m+40|0;u=m+80|0;v=g+20|0;a[v>>0]=0;w=g+32|0;c[w>>2]=0;x=j+16|0;y=b[x>>1]|0;b[o>>1]=y;z=d+80|0;A=d+108|0;B=d+112|0;C=y&65535;y=d+4|0;D=0;a:while(1){do if(!(a[d+D+116>>0]|0)){E=c[z>>2]|0;if(D)if((c[E+24>>2]|0)==(c[B>>2]|0))break;else{F=7;break}if((c[E+20>>2]|0)==(c[A>>2]|0)){D=D+1|0;continue a}else F=7}else F=7;while(0);if((F|0)==7?(F=0,(C&D+1|0)!=0):0){E=(R2(d,D,0,0)|0)==1;G=(c[y>>2]|0)==-1;if(E){F=10;break}if(G){F=11;break}}D=D+1|0;if(D>>>0>=2){F=15;break}}if((F|0)==10){if(G)F=11}else if((F|0)==15){G=c[d+88>>2]|0;c[p>>2]=G;D=c[d+100>>2]|0;c[p+4>>2]=D;if(!(G|D)){H=0;i=m;return H|0}D=xCa(c[z>>2]|0)|0;y=c[d+72>>2]|0;C=c[d+76>>2]|0;A=y>>>0<C>>>0?C:y;y=A<<4;if(A>>>0<128){A=i;i=i+((1*y|0)+15&-16)|0;I=0;J=A}else{A=sKa(q,y,447432,632)|0;I=A;J=A}A=(b[x>>1]&32)!=0;y=g+28|0;q=f+12|0;C=f+16|0;B=(k|0)==0;E=t+4|0;K=t+8|0;L=t+12|0;M=t+20|0;N=t+24|0;O=t+28|0;P=t+32|0;Q=g+4|0;R=t+4|0;S=g+24|0;T=ea(3402823469999999843913219.0e14);U=G;G=0;b:while(1){if(!U)V=T;else{W=d+(G*12|0)+84|0;X=T;Y=0;while(1){Z=(c[W>>2]|0)+(Y<<3)|0;_=c[Z>>2]|0;if((b[_+4>>1]|0)==5)$=(_|0)!=0?2:1;else $=1;do if((e[o>>1]&$|0)!=0?(c[r>>2]=(c[y>>2]|0)!=0?1:2,_=mBb(Z,r,o,j,k,D,h)|0,aa=c[r>>2]|0,!((_|0)==0|(aa|0)==0)):0){ba=_+4|0;ca=c[ba>>2]|0;zCa(s,ca,c[_>>2]|0);da=c[ca+36>>2]|0;if(!(da&1))fa=ca+116|0;else{ga=ca+40|0;ha=c[ga>>2]|0;if(!ha){ia=s4(c[ca+32>>2]|0,da>>>24&15)|0;c[ga>>2]=ia;ja=ia}else ja=ha;fa=ja}if(yLa(c[q>>2]|0,c[C>>2]|0,fa,s)|0){ha=b[o>>1]|0;c[J>>2]=c[_>>2];c[J+4>>2]=c[ba>>2];if(B){if(b[x>>1]&16){F=48;break b}ba=A?1:aa;if((ba|0)==2){if(!(X>=ea(-1.0))){ka=X;break};c[Q+0>>2]=c[J+0>>2];c[Q+4>>2]=c[J+4>>2];c[Q+8>>2]=c[J+8>>2];c[Q+12>>2]=c[J+12>>2];a[v>>0]=1;ka=ea(-1.0);break}else if((ba|0)!=1){ka=X;break}ba=c[y>>2]|0;if((ba|0)==0|!(X>=ea(-1.0))){ka=X;break}_=c[w>>2]|0;do if((_|0)==(ba|0)){c[E>>2]=0;c[K>>2]=0;c[L>>2]=-1;a[M>>0]=0;c[N>>2]=0;c[O>>2]=0;c[P>>2]=0;c[t>>2]=420288;b[u>>1]=b[h>>1]|0;if(SWa(d,f,t,u,j,0,l)|0){c[Q+0>>2]=c[R+0>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];c[Q+12>>2]=c[R+12>>2];a[v>>0]=1}ia=c[w>>2]|0;if((ia|0)!=(c[y>>2]|0)){la=ia;break}if(!(xo[c[c[g>>2]>>2]&2047](g,c[S>>2]|0,ia)|0)){F=57;break b}c[w>>2]=0;la=0}else la=_;while(0);c[w>>2]=la+1;_=(c[S>>2]|0)+(la<<4)|0;c[_+0>>2]=c[J+0>>2];c[_+4>>2]=c[J+4>>2];c[_+8>>2]=c[J+8>>2];c[_+12>>2]=c[J+12>>2];ka=X;break}if(!(ha&8))ma=aa;else ma=xo[c[(c[k>>2]|0)+4>>2]&2047](k,j,J)|0;if(!((b[x>>1]&16)==0|(ma|0)==0)){F=48;break b}_=A?1:ma;if((_|0)==2){if(!(X>=ea(-1.0))){ka=X;break};c[Q+0>>2]=c[J+0>>2];c[Q+4>>2]=c[J+4>>2];c[Q+8>>2]=c[J+8>>2];c[Q+12>>2]=c[J+12>>2];a[v>>0]=1;ka=ea(-1.0);break}else if((_|0)!=1){ka=X;break}_=c[y>>2]|0;if(!((_|0)==0|!(X>=ea(-1.0)))){ba=c[w>>2]|0;do if((ba|0)==(_|0)){c[E>>2]=0;c[K>>2]=0;c[L>>2]=-1;a[M>>0]=0;c[N>>2]=0;c[O>>2]=0;c[P>>2]=0;c[t>>2]=420288;b[u>>1]=b[h>>1]|0;if(SWa(d,f,t,u,j,k,l)|0){c[Q+0>>2]=c[R+0>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];c[Q+12>>2]=c[R+12>>2];a[v>>0]=1}ia=c[w>>2]|0;if((ia|0)!=(c[y>>2]|0)){na=ia;break}if(!(xo[c[c[g>>2]>>2]&2047](g,c[S>>2]|0,ia)|0)){F=57;break b}c[w>>2]=0;na=0}else na=ba;while(0);c[w>>2]=na+1;ba=(c[S>>2]|0)+(na<<4)|0;c[ba+0>>2]=c[J+0>>2];c[ba+4>>2]=c[J+4>>2];c[ba+8>>2]=c[J+8>>2];c[ba+12>>2]=c[J+12>>2];ka=X}else ka=X}else ka=X}else ka=X;while(0);Y=Y+1|0;if(Y>>>0>=U>>>0){V=ka;break}else X=ka}}Y=G+1|0;if(Y>>>0>=2){F=64;break}T=V;U=c[p+(Y<<2)>>2]|0;G=Y}if((F|0)==48){c[Q+0>>2]=c[J+0>>2];c[Q+4>>2]=c[J+4>>2];c[Q+8>>2]=c[J+8>>2];c[Q+12>>2]=c[J+12>>2];ko[c[(c[g>>2]|0)+4>>2]&4095](g);a[v>>0]=1;oa=1}else if((F|0)==57){ko[c[(c[g>>2]|0)+4>>2]&4095](g);oa=(a[v>>0]|0)!=0}else if((F|0)==64){J=c[w>>2]|0;Q=(J|0)==0;if(!(a[v>>0]|0)){if(!Q)F=68}else if(!Q){c[w>>2]=J;F=68}if((F|0)==68?xo[c[c[g>>2]>>2]&2047](g,c[S>>2]|0,J)|0:0)c[w>>2]=0;ko[c[(c[g>>2]|0)+4>>2]&4095](g);oa=(a[v>>0]|0)!=0}if(!I){H=oa;i=m;return H|0}tKa(n,I);H=oa;i=m;return H|0}if((F|0)==11)dKa(bKa()|0,128,447432,599,447688,n);n=xCa(c[z>>2]|0)|0;Km[c[(c[n>>2]|0)+356>>2]&127](n,c[f+12>>2]|0,c[f+16>>2]|0,g,j,k)|0;if(a[v>>0]|0){H=1;i=m;return H|0}H=(c[w>>2]|0)!=0;i=m;return H|0}function TWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+20|0;f=c[e>>2]|0;if(!f){g=0;i=d;return g|0}h=c[b>>2]|0;b=h;j=b+~(b<<15)|0;b=(j>>>10^j)*9|0;j=b>>>6^b;b=j+~(j<<11)|0;j=a+12|0;k=c[j>>2]|0;l=k+(((b>>>16^b)&f+-1)<<2)|0;f=c[l>>2]|0;if((f|0)==-1){g=0;i=d;return g|0}b=a+4|0;m=c[b>>2]|0;n=a+8|0;o=f;f=l;while(1){p=m+(o<<2)|0;if((c[p>>2]|0)==(h|0))break;l=(c[n>>2]|0)+(o<<2)|0;q=c[l>>2]|0;if((q|0)==-1){g=0;r=14;break}else{o=q;f=l}}if((r|0)==14){i=d;return g|0}if((o|0)==-1){g=0;i=d;return g|0}r=c[n>>2]|0;c[f>>2]=c[r+(o<<2)>>2];f=a+36|0;l=(c[f>>2]|0)+-1|0;c[f>>2]=l;q=a+32|0;c[q>>2]=(c[q>>2]|0)+1;if((o|0)!=(l|0)){if(!p){s=r;t=h;u=k}else{c[p>>2]=c[m+(l<<2)>>2];s=c[n>>2]|0;t=c[(c[b>>2]|0)+(o<<2)>>2]|0;u=c[j>>2]|0}c[s+(o<<2)>>2]=c[s+(l<<2)>>2];l=t;t=l+~(l<<15)|0;l=(t>>>10^t)*9|0;t=l>>>6^l;l=t+~(t<<11)|0;t=u+(((l>>>16^l)&(c[e>>2]|0)+-1)<<2)|0;e=c[t>>2]|0;l=c[f>>2]|0;if((e|0)==(l|0))v=t;else{t=e;do{e=s+(t<<2)|0;t=c[e>>2]|0}while((t|0)!=(l|0));v=e}c[v>>2]=o}o=a+28|0;c[o>>2]=(c[o>>2]|0)+-1;g=1;i=d;return g|0}function UWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=(l>>>16^l)&h+-1;l=c[(c[b+12>>2]|0)+(m<<2)>>2]|0;if((l|0)==-1)n=m;else{o=c[b+4>>2]|0;p=b+8|0;q=l;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=m;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+36|0;if((c[e>>2]|0)==(c[b+16>>2]|0)){r=j?16:h<<1;if(h>>>0<r>>>0){WWa(b,r);t=c[g>>2]|0}else t=h;h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;u=(h>>>16^h)&t+-1}else u=n;n=b+28|0;t=c[n>>2]|0;c[n>>2]=t+1;n=(c[b+12>>2]|0)+(u<<2)|0;c[(c[b+8>>2]|0)+(t<<2)>>2]=c[n>>2];c[n>>2]=t;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(t<<2)|0;i=f;return s|0}function VWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[(qTa()|0)>>2]|0;if(g){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;k=Bn[j&255](h,g,l?544576:544544,544464,111)|0;c[a>>2]=k;if(k)mTa(k)}else c[a>>2]=0;k=a+4|0;l=a+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[a+24>>2]=b;g=UJa(e,b,452376,56)|0;c[f>>2]=g;b=c[l>>2]|0;if((c[a+12>>2]&2147483647)>>>0<=b>>>0){m0a(k,f)|0;i=d;return}f=(c[k>>2]|0)+(b<<2)|0;if(f)c[f>>2]=g;c[l>>2]=b+1;i=d;return}function WWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+16|0;f=c[b>>2]|0;h=ea(e>>>0);j=~~ea(h*ea(g[a+24>>2]))>>>0;k=e<<2;l=j<<2;m=l+k|0;n=(0-m&12)+m|0;m=UJa(a,n+l|0,529024,354)|0;l=m+k|0;o=m+n|0;PEi(m|0,-1,k|0)|0;k=a+36|0;n=a+4|0;if(c[k>>2]|0){p=e+-1|0;q=0;do{r=c[(c[n>>2]|0)+(q<<2)>>2]|0;s=r;t=s+~(s<<15)|0;s=(t>>>10^t)*9|0;t=s>>>6^s;s=t+~(t<<11)|0;t=m+(((s>>>16^s)&p)<<2)|0;c[l+(q<<2)>>2]=c[t>>2];c[t>>2]=q;t=o+(q<<2)|0;if(t)c[t>>2]=r;q=q+1|0}while(q>>>0<(c[k>>2]|0)>>>0)}VJa(a,c[a>>2]|0);c[a>>2]=m;c[a+12>>2]=m;c[a+20>>2]=e;c[a+8>>2]=l;c[n>>2]=o;c[b>>2]=j;j=a+28|0;if((c[j>>2]|0)!=-1){i=d;return}c[j>>2]=f;i=d;return}function XWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=b;j=d+4|0;k=c[j>>2]|0;if(!(a[b+2417>>0]|0)){c[j>>2]=k&268435455|-2147483648;nXa(b+16|0,d);i=f;return}b=k&1073741823;if((k&-1073741824|0)==-1073741824){c[j>>2]=b|-2147483648;if(k&268435456){i=f;return}c[g>>2]=d;TWa(e,g)|0;i=f;return}else{c[j>>2]=b|1073741824;c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}}function YWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[d+264>>2]|0;if(!f){c[b+260>>2]=0;c[b+264>>2]=0;c[b+268>>2]=0;i=e;return}c[b+268>>2]=f;g=b+264|0;c[g>>2]=f;h=f<<2;j=b+256|0;if(!((a[j>>0]|0)==0&h>>>0<257))if(!h){k=0;l=f}else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;o=Bn[n&255](m,h,p?468728:544544,537640,558)|0;k=o;l=c[g>>2]|0}else{a[j>>0]=1;k=b;l=f}c[b+260>>2]=k;b=k+(l<<2)|0;if(k>>>0>=b>>>0){i=e;return}l=k;k=c[d+260>>2]|0;while(1){if(l)c[l>>2]=c[k>>2];l=l+4|0;if(l>>>0>=b>>>0)break;else k=k+4|0}i=e;return}function ZWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+824|0;h=f+820|0;j=f+816|0;k=f+544|0;l=f+272|0;m=f;c[d>>2]=b;n=d+4|0;o=c[n>>2]|0;if(!(a[b+2417>>0]|0)){c[n>>2]=o&268435455|-2147483648;nBb(c[b+1260>>2]|0,d);i=f;return}p=o&1073741823;if((o&-1073741824|0)==-1073741824){c[n>>2]=p|-2147483648;if(!(o&268435456)){c[g>>2]=d;TWa(e,g)|0}}else{c[n>>2]=p|1073741824;c[h>>2]=d;p=UWa(e,h,g)|0;if(!((a[g>>0]|0)!=0|(p|0)==0))c[p>>2]=c[h>>2]}h=c[b+1260>>2]|0;if(h){b=k+256|0;a[b>>0]=0;YWa(k,h+272|0);h=o2()|0;p=h+-16|0;g=R_(d,j)|0;e=c[d>>2]|0;o=c[n>>2]&-1073741824;if(g){q=h+-12|0;h=0;do{r=c[(c[j>>2]|0)+(h<<2)>>2]|0;s=r+q|0;t=c[s>>2]|0;if((t&251658240|0)==16777216){c[s>>2]=t&1073741823|o;c[r+p>>2]=e}h=h+1|0}while((h|0)!=(g|0))}g=c[k+268>>2]|0;if(!((g&2147483647|0)!=0&(g|0)>-1)){i=f;return}g=c[k+260>>2]|0;if((k|0)==(g|0)){a[b>>0]=0;i=f;return}if(!g){i=f;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,g);i=f;return}g=l+256|0;b=l+260|0;c[l+264>>2]=0;k=l+268|0;a[g>>0]=1;c[b>>2]=l;c[k>>2]=64;h=m+256|0;a[h>>0]=0;YWa(m,l);e=o2()|0;p=e+-16|0;o=R_(d,j)|0;q=c[d>>2]|0;d=c[n>>2]&-1073741824;if(o){n=e+-12|0;e=0;do{r=c[(c[j>>2]|0)+(e<<2)>>2]|0;t=r+n|0;s=c[t>>2]|0;if((s&251658240|0)==16777216){c[t>>2]=s&1073741823|d;c[r+p>>2]=q}e=e+1|0}while((e|0)!=(o|0))}o=c[m+268>>2]|0;do if((o&2147483647|0)!=0&(o|0)>-1){e=c[m+260>>2]|0;if((m|0)==(e|0)){a[h>>0]=0;break}if(e){q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e)}}while(0);h=c[k>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=f;return}h=c[b>>2]|0;if((l|0)==(h|0)){a[g>>0]=0;i=f;return}if(!h){i=f;return}g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,h);i=f;return}function _Wa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+816|0;h=g+544|0;j=g+272|0;k=g;if(b[(c[450992+(((c[e+4>>2]|0)>>>24&15)<<2)>>2]|0)+e+8>>1]&8){pBb(c[d+1244>>2]|0,e);i=g;return}l=c[d+1244>>2]|0;if(l){m=h+256|0;a[m>>0]=0;YWa(h,l+272|0);oBb(d,e,h,f);l=c[h+268>>2]|0;if(!((l&2147483647|0)!=0&(l|0)>-1)){i=g;return}l=c[h+260>>2]|0;if((h|0)==(l|0)){a[m>>0]=0;i=g;return}if(!l){i=g;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,l);i=g;return}l=j+256|0;m=j+260|0;c[j+264>>2]=0;h=j+268|0;a[l>>0]=1;c[m>>2]=j;c[h>>2]=64;n=k+256|0;a[n>>0]=0;YWa(k,j);oBb(d,e,k,f);f=c[k+268>>2]|0;do if((f&2147483647|0)!=0&(f|0)>-1){e=c[k+260>>2]|0;if((k|0)==(e|0)){a[n>>0]=0;break}if(e){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}}while(0);n=c[h>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=g;return}n=c[m>>2]|0;if((j|0)==(n|0)){a[l>>0]=0;i=g;return}if(!n){i=g;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,n);i=g;return}function $Wa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+824|0;h=f+820|0;j=f+816|0;k=f+544|0;l=f+272|0;m=f;if(!(a[b+2417>>0]|0)){pBb(c[b+1260>>2]|0,d);n=d+4|0;c[n>>2]=c[n>>2]&268435455;c[d>>2]=0;i=f;return}n=d+4|0;o=c[n>>2]|0;p=o>>>30;if((p|0)==2){c[n>>2]=o|-1073741824;if((o&268435456|0)==0?(c[h>>2]=d,q=UWa(e,h,g)|0,!((a[g>>0]|0)!=0|(q|0)==0)):0)c[q>>2]=c[h>>2]}else if((p|0)==1){c[n>>2]=o&1073741823;c[g>>2]=d;TWa(e,g)|0}g=c[b+1260>>2]|0;if(g){b=k+256|0;a[b>>0]=0;YWa(k,g+272|0);g=o2()|0;e=g+-16|0;o=R_(d,j)|0;p=c[d>>2]|0;h=c[n>>2]&-1073741824;if(o){q=g+-12|0;g=0;do{r=c[(c[j>>2]|0)+(g<<2)>>2]|0;s=r+q|0;t=c[s>>2]|0;if((t&251658240|0)==16777216){c[s>>2]=t&1073741823|h;c[r+e>>2]=p}g=g+1|0}while((g|0)!=(o|0))}o=c[k+268>>2]|0;if(!((o&2147483647|0)!=0&(o|0)>-1)){i=f;return}o=c[k+260>>2]|0;if((k|0)==(o|0)){a[b>>0]=0;i=f;return}if(!o){i=f;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,o);i=f;return}o=l+256|0;b=l+260|0;c[l+264>>2]=0;k=l+268|0;a[o>>0]=1;c[b>>2]=l;c[k>>2]=64;g=m+256|0;a[g>>0]=0;YWa(m,l);p=o2()|0;e=p+-16|0;h=R_(d,j)|0;q=c[d>>2]|0;d=c[n>>2]&-1073741824;if(h){n=p+-12|0;p=0;do{r=c[(c[j>>2]|0)+(p<<2)>>2]|0;t=r+n|0;s=c[t>>2]|0;if((s&251658240|0)==16777216){c[t>>2]=s&1073741823|d;c[r+e>>2]=q}p=p+1|0}while((p|0)!=(h|0))}h=c[m+268>>2]|0;do if((h&2147483647|0)!=0&(h|0)>-1){p=c[m+260>>2]|0;if((m|0)==(p|0)){a[g>>0]=0;break}if(p){q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,p)}}while(0);g=c[k>>2]|0;if(!((g&2147483647|0)!=0&(g|0)>-1)){i=f;return}g=c[b>>2]|0;if((l|0)==(g|0)){a[o>>0]=0;i=f;return}if(!g){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,g);i=f;return}function aXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=b;j=d+4|0;k=c[j>>2]|0;if(!(a[b+2417>>0]|0)){c[j>>2]=k&268435455|-2147483648;qXa(b+16|0,d);i=f;return}b=k&1073741823;if((k&-1073741824|0)==-1073741824){c[j>>2]=b|-2147483648;if(k&268435456){i=f;return}c[g>>2]=d;TWa(e,g)|0;i=f;return}else{c[j>>2]=b|1073741824;c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}}function bXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+824|0;h=f+820|0;j=f+816|0;k=f+544|0;l=f+272|0;m=f;c[d>>2]=b;n=d+4|0;o=c[n>>2]|0;if(!(a[b+2417>>0]|0)){c[n>>2]=o&268435455|-2147483648;qBb(c[b+1260>>2]|0,d);i=f;return}p=o&1073741823;if((o&-1073741824|0)==-1073741824){c[n>>2]=p|-2147483648;if(!(o&268435456)){c[g>>2]=d;TWa(e,g)|0}}else{c[n>>2]=p|1073741824;c[h>>2]=d;p=UWa(e,h,g)|0;if(!((a[g>>0]|0)!=0|(p|0)==0))c[p>>2]=c[h>>2]}h=c[b+1260>>2]|0;if(h){b=k+256|0;a[b>>0]=0;YWa(k,h+272|0);h=o2()|0;p=h+-16|0;g=E_(d,j)|0;e=c[d>>2]|0;o=c[n>>2]&-1073741824;if(g){q=h+-12|0;h=0;do{r=c[(c[j>>2]|0)+(h<<2)>>2]|0;s=r+q|0;t=c[s>>2]|0;if((t&251658240|0)==16777216){c[s>>2]=t&1073741823|o;c[r+p>>2]=e}h=h+1|0}while((h|0)!=(g|0))}g=c[k+268>>2]|0;if(!((g&2147483647|0)!=0&(g|0)>-1)){i=f;return}g=c[k+260>>2]|0;if((k|0)==(g|0)){a[b>>0]=0;i=f;return}if(!g){i=f;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,g);i=f;return}g=l+256|0;b=l+260|0;c[l+264>>2]=0;k=l+268|0;a[g>>0]=1;c[b>>2]=l;c[k>>2]=64;h=m+256|0;a[h>>0]=0;YWa(m,l);e=o2()|0;p=e+-16|0;o=E_(d,j)|0;q=c[d>>2]|0;d=c[n>>2]&-1073741824;if(o){n=e+-12|0;e=0;do{r=c[(c[j>>2]|0)+(e<<2)>>2]|0;t=r+n|0;s=c[t>>2]|0;if((s&251658240|0)==16777216){c[t>>2]=s&1073741823|d;c[r+p>>2]=q}e=e+1|0}while((e|0)!=(o|0))}o=c[m+268>>2]|0;do if((o&2147483647|0)!=0&(o|0)>-1){e=c[m+260>>2]|0;if((m|0)==(e|0)){a[h>>0]=0;break}if(e){q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e)}}while(0);h=c[k>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=f;return}h=c[b>>2]|0;if((l|0)==(h|0)){a[g>>0]=0;i=f;return}if(!h){i=f;return}g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,h);i=f;return}function cXa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+816|0;h=g+544|0;j=g+272|0;k=g;l=e+236|0;c[l>>2]=c[l>>2]&-6291457;if(b[(c[450992+(((c[e+4>>2]|0)>>>24&15)<<2)>>2]|0)+e+8>>1]&8){sBb(c[d+1244>>2]|0,e);i=g;return}l=c[d+1244>>2]|0;if(l){m=h+256|0;a[m>>0]=0;YWa(h,l+272|0);rBb(d,e,h,f);l=c[h+268>>2]|0;if(!((l&2147483647|0)!=0&(l|0)>-1)){i=g;return}l=c[h+260>>2]|0;if((h|0)==(l|0)){a[m>>0]=0;i=g;return}if(!l){i=g;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,l);i=g;return}l=j+256|0;m=j+260|0;c[j+264>>2]=0;h=j+268|0;a[l>>0]=1;c[m>>2]=j;c[h>>2]=64;n=k+256|0;a[n>>0]=0;YWa(k,j);rBb(d,e,k,f);f=c[k+268>>2]|0;do if((f&2147483647|0)!=0&(f|0)>-1){e=c[k+260>>2]|0;if((k|0)==(e|0)){a[n>>0]=0;break}if(e){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}}while(0);n=c[h>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=g;return}n=c[m>>2]|0;if((j|0)==(n|0)){a[l>>0]=0;i=g;return}if(!n){i=g;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,n);i=g;return}function dXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+824|0;h=f+820|0;j=f+816|0;k=f+544|0;l=f+272|0;m=f;if(!(a[b+2417>>0]|0)){sBb(c[b+1260>>2]|0,d);n=d+4|0;c[n>>2]=c[n>>2]&268435455;c[d>>2]=0;i=f;return}n=d+4|0;o=c[n>>2]|0;p=o>>>30;if((p|0)==2){c[n>>2]=o|-1073741824;if((o&268435456|0)==0?(c[h>>2]=d,q=UWa(e,h,g)|0,!((a[g>>0]|0)!=0|(q|0)==0)):0)c[q>>2]=c[h>>2]}else if((p|0)==1){c[n>>2]=o&1073741823;c[g>>2]=d;TWa(e,g)|0}g=c[b+1260>>2]|0;if(g){b=k+256|0;a[b>>0]=0;YWa(k,g+272|0);g=o2()|0;e=g+-16|0;o=E_(d,j)|0;p=c[d>>2]|0;h=c[n>>2]&-1073741824;if(o){q=g+-12|0;g=0;do{r=c[(c[j>>2]|0)+(g<<2)>>2]|0;s=r+q|0;t=c[s>>2]|0;if((t&251658240|0)==16777216){c[s>>2]=t&1073741823|h;c[r+e>>2]=p}g=g+1|0}while((g|0)!=(o|0))}o=c[k+268>>2]|0;if(!((o&2147483647|0)!=0&(o|0)>-1)){i=f;return}o=c[k+260>>2]|0;if((k|0)==(o|0)){a[b>>0]=0;i=f;return}if(!o){i=f;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,o);i=f;return}o=l+256|0;b=l+260|0;c[l+264>>2]=0;k=l+268|0;a[o>>0]=1;c[b>>2]=l;c[k>>2]=64;g=m+256|0;a[g>>0]=0;YWa(m,l);p=o2()|0;e=p+-16|0;h=E_(d,j)|0;q=c[d>>2]|0;d=c[n>>2]&-1073741824;if(h){n=p+-12|0;p=0;do{r=c[(c[j>>2]|0)+(p<<2)>>2]|0;t=r+n|0;s=c[t>>2]|0;if((s&251658240|0)==16777216){c[t>>2]=s&1073741823|d;c[r+e>>2]=q}p=p+1|0}while((p|0)!=(h|0))}h=c[m+268>>2]|0;do if((h&2147483647|0)!=0&(h|0)>-1){p=c[m+260>>2]|0;if((m|0)==(p|0)){a[g>>0]=0;break}if(p){q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,p)}}while(0);g=c[k>>2]|0;if(!((g&2147483647|0)!=0&(g|0)>-1)){i=f;return}g=c[b>>2]|0;if((l|0)==(g|0)){a[o>>0]=0;i=f;return}if(!g){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,g);i=f;return}function eXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=b;j=d+4|0;k=c[j>>2]|0;if(!(a[b+2417>>0]|0)){c[j>>2]=k&268435455|-2147483648;OX(d,g,h);l=c[g>>2]|0;if(!l)m=0;else m=(c[450992+(((c[l+4>>2]|0)>>>24&15)<<2)>>2]|0)+l|0;l=c[h>>2]|0;if(!l)n=0;else n=(c[450992+(((c[l+4>>2]|0)>>>24&15)<<2)>>2]|0)+l|0;Wca(b+16|0,d+12|0,m,n);i=f;return}n=k&1073741823;if((k&-1073741824|0)==-1073741824){c[j>>2]=n|-2147483648;if(k&268435456){i=f;return}c[g>>2]=d;TWa(e,g)|0;i=f;return}else{c[j>>2]=n|1073741824;c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}}function fXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=b;j=d+4|0;k=c[j>>2]|0;if(!(a[b+2417>>0]|0)){c[j>>2]=k&268435455|-2147483648;Yca(b+16|0,d+12|0,(RV(d)|0)+16|0);i=f;return}b=k&1073741823;if((k&-1073741824|0)==-1073741824){c[j>>2]=b|-2147483648;if(k&268435456){i=f;return}c[g>>2]=d;TWa(e,g)|0;i=f;return}else{c[j>>2]=b|1073741824;c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}}function gXa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;if(!(a[b+2417>>0]|0)){j=d+4|0;c[j>>2]=c[j>>2]&-769;Zca(b+16|0,d+12|0);c[j>>2]=c[j>>2]&268435455;c[d>>2]=0;i=f;return}j=d+4|0;b=c[j>>2]|0;k=b>>>30;if((k|0)==1){c[j>>2]=b&1073741823;c[g>>2]=d;TWa(e,g)|0;i=f;return}else if((k|0)==2){c[j>>2]=b|-1073741824;if(b&268435456){i=f;return}c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}else{i=f;return}}function hXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=b;j=d+4|0;k=c[j>>2]|0;if(!(a[b+2417>>0]|0)){c[j>>2]=k&268435455|-2147483648;BW(d,g,h);_ca(b+16|0,d+12|0,(c[g>>2]|0)+16|0,(c[h>>2]|0)+16|0);i=f;return}b=k&1073741823;if((k&-1073741824|0)==-1073741824){c[j>>2]=b|-2147483648;if(k&268435456){i=f;return}c[g>>2]=d;TWa(e,g)|0;i=f;return}else{c[j>>2]=b|1073741824;c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}}function iXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?452248:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function jXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=b;j=d+4|0;k=c[j>>2]|0;if(!(a[b+2417>>0]|0)){c[j>>2]=k&268435455|-2147483648;Bea(b+16|0,d+12|0);i=f;return}b=k&1073741823;if((k&-1073741824|0)==-1073741824){c[j>>2]=b|-2147483648;if(k&268435456){i=f;return}c[g>>2]=d;TWa(e,g)|0;i=f;return}else{c[j>>2]=b|1073741824;c[h>>2]=d;d=UWa(e,h,g)|0;if((a[g>>0]|0)!=0|(d|0)==0){i=f;return}c[d>>2]=c[h>>2];i=f;return}}function kXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;if(g>>>0>=b>>>0){i=d;return}h=b+31&-32;c[f>>2]=h;b=UJa(d+1|0,h<<5|19,474640,115)|0;if(!b)j=0;else{h=b+19&-16;c[h+-4>>2]=h-b;j=h}if(g){h=0;do{b=j+(h<<5)|0;k=(c[a>>2]|0)+(h<<5)|0;c[b+0>>2]=c[k+0>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];c[b+16>>2]=c[k+16>>2];c[b+20>>2]=c[k+20>>2];h=h+1|0}while((h|0)!=(g|0))}if(g>>>0<(c[f>>2]|0)>>>0){h=g;do{c[j+(h<<5)+20>>2]=-1;h=h+1|0}while(h>>>0<(c[f>>2]|0)>>>0)}f=c[a>>2]|0;if(f)VJa(e,f+(0-(c[f+-4>>2]|0))|0);c[a>>2]=j;i=d;return}function lXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)tBb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function mXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+4|0;f=c[e>>2]|0;g=a+8|0;if(!(f&16777215)){c[g>>2]=0;h=c[e>>2]|0;j=h&-16777216;c[e>>2]=j;i=d;return}k=c[g>>2]|0;if(!k){l=s4(c[a>>2]|0,f>>>24&15)|0;c[g>>2]=l;m=l}else m=k;if((f&1|0)!=0?(k=c[m>>2]|0,l=c[b+2512>>2]|0,n=m+4|0,(c[n>>2]|0)!=0):0){o=a+16|0;a=0;do{p=c[l+(a+k<<2)>>2]|0;c[(c[450992+(((c[p+4>>2]|0)>>>24&15)<<2)>>2]|0)+p>>2]=c[o>>2];a=a+1|0}while(a>>>0<(c[n>>2]|0)>>>0)}if(!(f&2)){c[g>>2]=0;h=c[e>>2]|0;j=h&-16777216;c[e>>2]=j;i=d;return}f=c[m+8>>2]|0;n=c[b+2512>>2]|0;b=m+12|0;if(!(c[b>>2]|0)){c[g>>2]=0;h=c[e>>2]|0;j=h&-16777216;c[e>>2]=j;i=d;return}else q=0;do{m=c[n+(q+f<<2)>>2]|0;a=c[m+4>>2]|0;o=(c[450992+((a>>>24&15)<<2)>>2]|0)+m|0;c[o>>2]=-1;if(((a>>>30)+-1|0)>>>0<2)h7(o);q=q+1|0}while(q>>>0<(c[b>>2]|0)>>>0);c[g>>2]=0;h=c[e>>2]|0;j=h&-16777216;c[e>>2]=j;i=d;return}function nXa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+816|0;h=f+544|0;j=f+272|0;k=f;l=c[e+4>>2]|0;if(!(l&1))m=(c[450992+((l>>>24&15)<<2)>>2]|0)+e+8|0;else{n=e+8|0;o=c[n>>2]|0;if(!o){p=s4(c[e>>2]|0,l>>>24&15)|0;c[n>>2]=p;q=p}else q=o;m=q}if(b[m>>1]&8){nBb(c[d+1244>>2]|0,e);i=f;return}m=c[d+1244>>2]|0;if(m){q=h+256|0;a[q>>0]=0;YWa(h,m+272|0);m=o2()|0;o=e+16|0;Zba(o)|0;p=m+-16|0;n=R_(e,g)|0;Tda(d,o,c[g>>2]|0,n,m);o=c[e>>2]|0;if(n){l=m+-12|0;m=0;do{r=c[(c[g>>2]|0)+(m<<2)>>2]|0;s=r+p|0;t=r+l|0;r=c[t>>2]|0;if((r&251658240|0)==16777216){c[t>>2]=r&1073741823|-2147483648;c[s>>2]=o}q2(s);m=m+1|0}while((m|0)!=(n|0))}n=c[h+268>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=f;return}n=c[h+260>>2]|0;if((h|0)==(n|0)){a[q>>0]=0;i=f;return}if(!n){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,n);i=f;return}n=j+256|0;q=j+260|0;c[j+264>>2]=0;h=j+268|0;a[n>>0]=1;c[q>>2]=j;c[h>>2]=64;m=k+256|0;a[m>>0]=0;YWa(k,j);o=o2()|0;l=e+16|0;Zba(l)|0;p=o+-16|0;s=R_(e,g)|0;Tda(d,l,c[g>>2]|0,s,o);l=c[e>>2]|0;if(s){e=o+-12|0;o=0;do{d=c[(c[g>>2]|0)+(o<<2)>>2]|0;r=d+p|0;t=d+e|0;d=c[t>>2]|0;if((d&251658240|0)==16777216){c[t>>2]=d&1073741823|-2147483648;c[r>>2]=l}q2(r);o=o+1|0}while((o|0)!=(s|0))}s=c[k+268>>2]|0;do if((s&2147483647|0)!=0&(s|0)>-1){o=c[k+260>>2]|0;if((k|0)==(o|0)){a[m>>0]=0;break}if(o){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,o)}}while(0);m=c[h>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=f;return}m=c[q>>2]|0;if((j|0)==(m|0)){a[n>>0]=0;i=f;return}if(!m){i=f;return}n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,m);i=f;return}function oXa(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g&1){h=a+8|0;j=c[h>>2]|0;if(!j){k=s4(c[a>>2]|0,g>>>24&15)|0;c[h>>2]=k;l=k}else l=j;j=(b[a+24>>1]&8)!=0;k=(b[l>>1]&8)!=0;if(k|j^1){if(j|k^1)break;Q3(c[a>>2]|0,a,0);break}k=c[a>>2]|0;if((c[f>>2]&-1073741824|0)==-2147483648?(j=o2()|0,h=j+-16|0,m=R_(a,e)|0,Tda(k+16|0,(c[450992+(((c[f>>2]|0)>>>24&15)<<2)>>2]|0)+a|0,c[e>>2]|0,m,j),(m|0)!=0):0){j=0;do{q2((c[(c[e>>2]|0)+(j<<2)>>2]|0)+h|0);j=j+1|0}while((j|0)!=(m|0))}}while(0);uBb(a);e=a+8|0;if(!(g&64)){c[e>>2]=0;n=c[f>>2]|0;o=n&-16777216;c[f>>2]=o;i=d;return}g=c[e>>2]|0;if(!g){l=s4(c[a>>2]|0,(c[f>>2]|0)>>>24&15)|0;c[e>>2]=l;p=l}else p=g;if(!(c[f>>2]&64)){c[e>>2]=0;n=c[f>>2]|0;o=n&-16777216;c[f>>2]=o;i=d;return}cga(a+16|0,p+96|0);c[e>>2]=0;n=c[f>>2]|0;o=n&-16777216;c[f>>2]=o;i=d;return}function pXa(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+48|0;f=e+28|0;h=e;j=e+32|0;k=d+236|0;l=c[k>>2]|0;m=d+4|0;n=c[m>>2]|0;do if(!(l&65536)){g[d+176>>2]=ea(g[d+32>>2]);g[d+180>>2]=ea(g[d+36>>2]);g[d+184>>2]=ea(g[d+40>>2]);g[d+188>>2]=ea(g[d+44>>2]);g[d+192>>2]=ea(g[d+48>>2]);g[d+196>>2]=ea(g[d+52>>2]);g[d+200>>2]=ea(g[d+56>>2])}else{if(!(l&131072)){M8(d+16|0,d+176|0);break}o=d+8|0;p=c[o>>2]|0;if(!p){q=s4(c[d>>2]|0,n>>>24&15)|0;c[o>>2]=q;r=q}else r=p;s=ea(-ea(g[d+64>>2]));t=ea(-ea(g[d+68>>2]));u=ea(-ea(g[d+72>>2]));v=ea(g[d+76>>2]);w=ea(g[r+160>>2]);x=ea(w-ea(g[d+80>>2]));w=ea(g[r+164>>2]);y=ea(w-ea(g[d+84>>2]));w=ea(g[r+168>>2]);z=ea(x*ea(2.0));x=ea(y*ea(2.0));y=ea(ea(w-ea(g[d+88>>2]))*ea(2.0));w=ea(ea(v*v)+ea(-.5));A=ea(ea(ea(z*s)+ea(x*t))+ea(y*u));B=ea(ea(A*s)+ea(ea(w*z)+ea(v*ea(ea(y*t)-ea(x*u)))));C=ea(ea(A*t)+ea(ea(w*x)+ea(v*ea(ea(z*u)-ea(y*s)))));D=ea(ea(ea(w*y)+ea(v*ea(ea(x*s)-ea(z*t))))+ea(A*u));A=ea(g[r+144>>2]);z=ea(v*A);x=ea(g[r+156>>2]);y=ea(z+ea(x*s));z=ea(g[r+152>>2]);w=ea(y+ea(z*t));y=ea(g[r+148>>2]);E=ea(w-ea(y*u));w=ea(ea(ea(A*u)+ea(ea(x*t)+ea(v*y)))-ea(z*s));F=ea(ea(ea(y*s)+ea(ea(x*u)+ea(v*z)))-ea(A*t));G=ea(ea(ea(ea(v*x)-ea(A*s))-ea(y*t))-ea(z*u));u=ea(g[d+32>>2]);z=ea(g[d+36>>2]);t=ea(g[d+40>>2]);y=ea(g[d+44>>2]);s=ea(g[d+48>>2]);A=ea(g[d+52>>2]);x=ea(B*ea(2.0));B=ea(C*ea(2.0));C=ea(D*ea(2.0));D=ea(ea(y*y)+ea(-.5));v=ea(ea(ea(x*u)+ea(B*z))+ea(C*t));H=ea(s+ea(ea(u*v)+ea(ea(x*D)+ea(y*ea(ea(C*z)-ea(B*t))))));s=ea(A+ea(ea(z*v)+ea(ea(B*D)+ea(y*ea(ea(x*t)-ea(C*u))))));A=ea(ea(g[d+56>>2])+ea(ea(ea(C*D)+ea(y*ea(ea(B*u)-ea(x*z))))+ea(t*v)));v=ea(ea(ea(ea(E*y)+ea(G*u))+ea(F*z))-ea(w*t));x=ea(ea(ea(E*t)+ea(ea(w*y)+ea(G*z)))-ea(F*u));B=ea(ea(ea(w*u)+ea(ea(F*y)+ea(G*t)))-ea(E*z));D=ea(ea(ea(ea(G*y)-ea(E*u))-ea(w*z))-ea(F*t));g[h>>2]=v;g[h+4>>2]=x;g[h+8>>2]=B;g[h+12>>2]=D;g[h+16>>2]=H;g[h+20>>2]=s;g[h+24>>2]=A;g[d+176>>2]=v;g[d+180>>2]=x;g[d+184>>2]=B;g[d+188>>2]=D;g[d+192>>2]=H;g[d+196>>2]=s;g[d+200>>2]=A;M8(d+16|0,h)}while(0);if(!(l&262144)){g[d+204>>2]=ea(g[d+96>>2]);g[d+208>>2]=ea(g[d+100>>2]);g[d+212>>2]=ea(g[d+104>>2])}else{g[d+96>>2]=ea(g[d+204>>2]);g[d+100>>2]=ea(g[d+208>>2]);g[d+104>>2]=ea(g[d+212>>2])}if(!(l&524288)){g[d+216>>2]=ea(g[d+112>>2]);g[d+220>>2]=ea(g[d+116>>2]);g[d+224>>2]=ea(g[d+120>>2])}else{g[d+112>>2]=ea(g[d+216>>2]);g[d+116>>2]=ea(g[d+220>>2]);g[d+120>>2]=ea(g[d+224>>2])}do if(n&1){h=d+8|0;r=c[h>>2]|0;if(!r){p=s4(c[d>>2]|0,(c[m>>2]|0)>>>24&15)|0;c[h>>2]=p;I=p}else I=r;r=(b[d+24>>1]&8)!=0;p=(b[I>>1]&8)!=0;if(p|r^1){if(r|p^1)break;Q3(c[d>>2]|0,d,1);break}p=c[d>>2]|0;if((c[m>>2]&-1073741824|0)==-2147483648?(r=o2()|0,h=r+-16|0,q=E_(d,f)|0,Xda(p+16|0,(c[450992+(((c[m>>2]|0)>>>24&15)<<2)>>2]|0)+d|0,c[f>>2]|0,q,r),(q|0)!=0):0){r=0;do{q2((c[(c[f>>2]|0)+(r<<2)>>2]|0)+h|0);r=r+1|0}while((r|0)!=(q|0))}}while(0);do if(l&-8192002){f=d+8|0;I=c[f>>2]|0;if(!I){n=s4(c[d>>2]|0,(c[m>>2]|0)>>>24&15)|0;c[f>>2]=n;J=n}else J=I;I=c[k>>2]|0;if(!(I&1))K=I;else{T8(d+16|0,ea(g[J+92>>2]));K=c[k>>2]|0}if(!(K&2))L=K;else{V8(d+16|0,J+96|0);L=c[k>>2]|0}if(!(L&4))M=L;else{X8(d+16|0,ea(g[J+108>>2]));M=c[k>>2]|0}if(!(M&8))N=M;else{Z8(d+16|0,ea(g[J+112>>2]));N=c[k>>2]|0}if(!(N&16))O=N;else{$8(d+16|0,ea(g[J+116>>2]));O=c[k>>2]|0}if(O&32)g[d+160>>2]=ea(g[J+120>>2]);if(O&256)b[d+62>>1]=b[J+132>>1]|0;if(O&128)g[d+124>>2]=ea(g[J+128>>2]);if(O&512){g[d+64>>2]=ea(g[J+144>>2]);g[d+68>>2]=ea(g[J+148>>2]);g[d+72>>2]=ea(g[J+152>>2]);g[d+76>>2]=ea(g[J+156>>2]);g[d+80>>2]=ea(g[J+160>>2]);g[d+84>>2]=ea(g[J+164>>2]);g[d+88>>2]=ea(g[J+168>>2])}if(O&2048)g[d+164>>2]=ea(g[J+176>>2]);if(O&1024)g[d+108>>2]=ea(g[J+172>>2]);if(l&4096){I=c[(c[d>>2]|0)+1256>>2]|0;a[j>>0]=a[J+268>>0]|0;a9(d+16|0,I,j)}if(l&8192)g9(d+16|0,c[(c[d>>2]|0)+1256>>2]|0,J+192|0,ea(g[d+228>>2]));if(l&16384)N8(d+16|0,c[(c[d>>2]|0)+1256>>2]|0,J+220|0,J+232|0);if(!(l&32768))break;Q8(d+16|0,c[(c[d>>2]|0)+1256>>2]|0,J+244|0,J+256|0)}while(0);if(l&1048576){J=l&6291456;j=d+16|0;if(!J){e9(j,ea(g[d+228>>2]),0);P=f9(j)|0}else{Q=j;R=J;S=60}}else{J=d+16|0;g[d+228>>2]=ea(d9(J));Q=J;R=l&6291456;S=60}if((S|0)==60){S=f9(Q)|0;if(R)if(!(l&2097152)){e9(Q,ea(g[d+228>>2]),1);uBb(d);T=d+8|0;c[T>>2]=0;U=c[m>>2]|0;V=U&-16777216;c[m>>2]=V;c[k>>2]=0;i=e;return}else{b9(Q);uBb(d);T=d+8|0;c[T>>2]=0;U=c[m>>2]|0;V=U&-16777216;c[m>>2]=V;c[k>>2]=0;i=e;return}else P=S}if((c[m>>2]&-1073741824|0)==-1073741824){uBb(d);T=d+8|0;c[T>>2]=0;U=c[m>>2]|0;V=U&-16777216;c[m>>2]=V;c[k>>2]=0;i=e;return}c[d+232>>2]=P&1;uBb(d);T=d+8|0;c[T>>2]=0;U=c[m>>2]|0;V=U&-16777216;c[m>>2]=V;c[k>>2]=0;i=e;return}function qXa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+832|0;g=f+816|0;h=f+544|0;j=f+272|0;k=f;l=c[e+4>>2]|0;if(!(l&1))m=(c[450992+((l>>>24&15)<<2)>>2]|0)+e+8|0;else{n=e+8|0;o=c[n>>2]|0;if(!o){p=s4(c[e>>2]|0,l>>>24&15)|0;c[n>>2]=p;q=p}else q=o;m=q}if(b[m>>1]&8){qBb(c[d+1244>>2]|0,e);i=f;return}m=c[d+1244>>2]|0;if(m){q=h+256|0;a[q>>0]=0;YWa(h,m+272|0);m=o2()|0;o=e+16|0;Zba(o)|0;p=m+-16|0;n=E_(e,g)|0;Xda(d,o,c[g>>2]|0,n,m);o=c[e>>2]|0;if(n){l=m+-12|0;m=0;do{r=c[(c[g>>2]|0)+(m<<2)>>2]|0;s=r+p|0;t=r+l|0;r=c[t>>2]|0;if((r&251658240|0)==16777216){c[t>>2]=r&1073741823|-2147483648;c[s>>2]=o}q2(s);m=m+1|0}while((m|0)!=(n|0))}n=c[h+268>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=f;return}n=c[h+260>>2]|0;if((h|0)==(n|0)){a[q>>0]=0;i=f;return}if(!n){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,n);i=f;return}n=j+256|0;q=j+260|0;c[j+264>>2]=0;h=j+268|0;a[n>>0]=1;c[q>>2]=j;c[h>>2]=64;m=k+256|0;a[m>>0]=0;YWa(k,j);o=o2()|0;l=e+16|0;Zba(l)|0;p=o+-16|0;s=E_(e,g)|0;Xda(d,l,c[g>>2]|0,s,o);l=c[e>>2]|0;if(s){e=o+-12|0;o=0;do{d=c[(c[g>>2]|0)+(o<<2)>>2]|0;r=d+p|0;t=d+e|0;d=c[t>>2]|0;if((d&251658240|0)==16777216){c[t>>2]=d&1073741823|-2147483648;c[r>>2]=l}q2(r);o=o+1|0}while((o|0)!=(s|0))}s=c[k+268>>2]|0;do if((s&2147483647|0)!=0&(s|0)>-1){o=c[k+260>>2]|0;if((k|0)==(o|0)){a[m>>0]=0;break}if(o){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,o)}}while(0);m=c[h>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=f;return}m=c[q>>2]|0;if((j|0)==(m|0)){a[n>>0]=0;i=f;return}if(!m){i=f;return}n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,m);i=f;return}function rXa(a){a=a|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im;d=i;i=i+16|0;f=d;h=a+12|0;U9(h,a+84|0,a+96|0);j=a+108|0;b[j>>1]=(e[h>>1]|0)&1;k=a+4|0;l=c[k>>2]|0;m=a+8|0;if(!(l&16777215)){c[m>>2]=0;n=c[k>>2]|0;o=n&-16777216;c[k>>2]=o;i=d;return}p=c[m>>2]|0;if(!p){q=s4(c[a>>2]|0,l>>>24&15)|0;c[m>>2]=q;r=q}else r=p;if(l&1)V9(h,c[r>>2]|0,c[r+4>>2]|0);if(l&2){s=ea(g[r+8>>2]);X9(h,s,ea(g[r+12>>2]))}if(l&8)Z9(h,ea(g[r+20>>2]));if(!(l&4)){c[m>>2]=0;n=c[k>>2]|0;o=n&-16777216;c[k>>2]=o;i=d;return}b[f>>1]=b[j>>1]|b[r+16>>1];T9(h,f);c[m>>2]=0;n=c[k>>2]|0;o=n&-16777216;c[k>>2]=o;i=d;return}function sXa(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=d+4|0;h=c[f>>2]|0;if(h&128){j=h&768;k=d+12|0;if(!j){F7(k,ea(g[d+48>>2]));l=k;m=G7(k)|0;n=6}else{o=k;p=j;n=5}}else{j=d+12|0;g[d+48>>2]=ea(D7(j));o=j;p=h&768;n=5}do if((n|0)==5){j=G7(o)|0;if(p)if(!(h&256)){H7(o,ea(g[d+48>>2]));q=o;break}else{I7(o);q=o;break}else{l=o;m=j;n=6}}while(0);if((n|0)==6)if((c[f>>2]&-1073741824|0)==-1073741824)q=l;else{a[d+52>>0]=m&1;q=l}l=d+8|0;if(!(h&16776319)){c[l>>2]=0;r=c[f>>2]|0;s=r&-16777216;c[f>>2]=s;i=e;return}h=c[l>>2]|0;if(!h){m=s4(c[d>>2]|0,(c[f>>2]|0)>>>24&15)|0;c[l>>2]=m;t=m}else t=h;h=c[f>>2]|0;if(!(h&2))u=h;else{y7(q,c[t+4>>2]|0);u=c[f>>2]|0}if(!(u&1))v=u;else{w7(q,c[t>>2]|0);v=c[f>>2]|0}if(!(v&4))w=v;else{A7(q,c[t+8>>2]|0);w=c[f>>2]|0}if(!(w&8))x=w;else{C7(q,ea(g[t+12>>2]));x=c[f>>2]|0}if(!(x&16))y=x;else{K7(q,ea(g[t+16>>2]));y=c[f>>2]|0}if(!(y&32))z=y;else{N7(q,b[t+20>>1]|0);z=c[f>>2]|0}if(!(z&64)){c[l>>2]=0;r=c[f>>2]|0;s=r&-16777216;c[f>>2]=s;i=e;return}L7(q,ea(g[t+24>>2]));c[l>>2]=0;r=c[f>>2]|0;s=r&-16777216;c[f>>2]=s;i=e;return}function tXa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im;d=i;e=b+4|0;f=c[e>>2]|0;h=b+8|0;if(!(f&16777215)){j=f;c[h>>2]=0;k=j&-16777216;c[e>>2]=k;i=d;return}l=c[h>>2]|0;if(!l){m=s4(c[b>>2]|0,f>>>24&15)|0;c[h>>2]=m;n=c[e>>2]|0;o=m}else{n=f;o=l}if(!(n&1))p=n;else{V7(b+12|0,o);p=c[e>>2]|0}if(!(p&2))q=p;else{W7(b+12|0,o+28|0);q=c[e>>2]|0}if(!(q&4))r=q;else{X7(b+12|0,o+56|0);r=c[e>>2]|0}if(!(r&8))s=r;else{Y7(b+12|0,o+72|0);s=c[e>>2]|0}if(!(s&16))t=s;else{Z7(b+12|0,ea(g[o+84>>2]));t=c[e>>2]|0}if(!(t&32))u=t;else{_7(b+12|0,ea(g[o+88>>2]));u=c[e>>2]|0}if(!(u&64))v=u;else{$7(b+12|0,ea(g[o+92>>2]));v=c[e>>2]|0}if(!(v&128))w=v;else{a8(b+12|0,ea(g[o+96>>2]));w=c[e>>2]|0}if(!(w&256))x=w;else{f8(b+12|0,ea(g[o+100>>2]));x=c[e>>2]|0}if(!(x&512))y=x;else{e8(b+12|0,(a[o+104>>0]|0)!=0);y=c[e>>2]|0}if(!(y&4096))z=y;else{i8(b+12|0,ea(g[o+116>>2]));z=c[e>>2]|0}if(!(z&8192))A=z;else{h8(b+12|0,(a[o+120>>0]|0)!=0);A=c[e>>2]|0}if(!(A&1024))B=A;else{c8(b+12|0,ea(g[o+108>>2]));B=c[e>>2]|0}if(!(B&2048))C=B;else{d8(b+12|0,ea(g[o+112>>2]));C=c[e>>2]|0}if(!(C&16384))D=C;else{E=ea(g[o+124>>2]);b8(b+12|0,E,ea(g[o+128>>2]));D=c[e>>2]|0}if(!(D&32768)){j=D;c[h>>2]=0;k=j&-16777216;c[e>>2]=k;i=d;return}E=ea(g[o+132>>2]);g8(b+12|0,E,ea(g[o+136>>2]));j=c[e>>2]|0;c[h>>2]=0;k=j&-16777216;c[e>>2]=k;i=d;return}function uXa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=d+4|0;h=c[g>>2]|0;if(!(h&8)){i=e;return}j=d+8|0;k=c[j>>2]|0;if(!k){l=s4(c[d>>2]|0,h>>>24&15)|0;c[j>>2]=l;m=c[g>>2]|0;n=l}else{m=h;n=k}k=d;Zba((c[450992+((m>>>24&15)<<2)>>2]|0)+k|0)|0;m=n+36|0;h=n+76|0;if(c[h>>2]|0){l=n+72|0;n=0;do{j=c[l>>2]|0;o=c[j+(n<<3)>>2]|0;p=o+4|0;q=c[p>>2]|0;if((q&251658240|0)==16777216){c[p>>2]=q&1073741823;c[o>>2]=0}q=(c[450992+(((c[g>>2]|0)>>>24&15)<<2)>>2]|0)+k|0;r=c[d>>2]|0;if(!(b[q+8>>1]&8)){Xba(q,o+16|0,(a[j+(n<<3)+4>>0]|0)!=0);if(c[p>>2]&268435456){A4(o);c[f>>2]=o;TWa(r+2448|0,f)|0}r2(o)}n=n+1|0}while(n>>>0<(c[h>>2]|0)>>>0)}c[f>>2]=0;a[f+4>>0]=0;vBb(m,0,f);wBb(m,c[h>>2]|0);i=e;return}function vXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e;g=a+4|0;h=a+16|0;j=c[h>>2]|0;k=c[(c[g>>2]|0)+(j<<2)>>2]|0;l=a+20|0;m=c[l>>2]|0;n=k+m|0;o=d+-1|0;p=0-d|0;d=(o+n&p)-n|0;n=c[a+24>>2]|0;if((m+b+d|0)>>>0<=n>>>0){q=m;r=k;s=d;t=q+s|0;u=r+t|0;v=s+b|0;w=v+q|0;c[l>>2]=w;i=e;return u|0}d=j+1|0;c[h>>2]=d;c[l>>2]=0;j=a+8|0;do if(d>>>0>=(c[j>>2]|0)>>>0){k=UJa(e+4|0,n,452376,87)|0;c[f>>2]=k;m=c[j>>2]|0;if((c[a+12>>2]&2147483647)>>>0<=m>>>0){m0a(g,f)|0;break}x=(c[g>>2]|0)+(m<<2)|0;if(x)c[x>>2]=k;c[j>>2]=m+1}while(0);j=c[(c[g>>2]|0)+(c[h>>2]<<2)>>2]|0;h=j;q=c[l>>2]|0;r=j;s=(o+h&p)-h|0;t=q+s|0;u=r+t|0;v=s+b|0;w=v+q|0;c[l>>2]=w;i=e;return u|0}function wXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)xBb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function xXa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+64|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;d=0;do{c[a+(d*28|0)+88>>2]=0;c[a+(d*28|0)+480>>2]=0;c[a+(d*28|0)+284>>2]=0;c[a+(d*28|0)+676>>2]=0;c[a+(d*28|0)+92>>2]=0;c[a+(d*28|0)+484>>2]=0;c[a+(d*28|0)+288>>2]=0;c[a+(d*28|0)+680>>2]=0;c[a+(d*28|0)+96>>2]=0;c[a+(d*28|0)+488>>2]=0;c[a+(d*28|0)+292>>2]=0;c[a+(d*28|0)+684>>2]=0;c[a+(d*28|0)+100>>2]=0;c[a+(d*28|0)+492>>2]=0;c[a+(d*28|0)+296>>2]=0;c[a+(d*28|0)+688>>2]=0;c[a+(d*28|0)+104>>2]=0;c[a+(d*28|0)+496>>2]=0;c[a+(d*28|0)+300>>2]=0;c[a+(d*28|0)+692>>2]=0;c[a+(d*28|0)+108>>2]=0;c[a+(d*28|0)+500>>2]=0;c[a+(d*28|0)+304>>2]=0;c[a+(d*28|0)+696>>2]=0;c[a+(d*28|0)+112>>2]=0;c[a+(d*28|0)+504>>2]=0;c[a+(d*28|0)+308>>2]=0;c[a+(d*28|0)+700>>2]=0;d=d+1|0}while((d|0)!=7);d=a+872|0;e=a+0|0;a=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}function yXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?463264:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<5)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2];c[j+28>>2]=c[f+28>>2]}j=j+32|0;if(j>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function zXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?463392:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function AXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?463536:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function BXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?463536:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function CXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?463392:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function DXa(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+52>>2]|0;f=e+156|0;if((c[f>>2]|0)!=0?h9(e,0)|0:0){h=c[f>>2]|0;j=(h|0)==0?0:h}else j=0;if((((ea(g[e+80>>2])==ea(0.0)?ea(g[e+84>>2])==ea(0.0):0)?ea(g[e+88>>2])==ea(0.0):0)?ea(g[e+96>>2])==ea(0.0):0)?ea(g[e+100>>2])==ea(0.0):0)k=ea(g[e+104>>2])==ea(0.0);else k=0;e=a[b+146>>0]|0;b=(e&2)==0;if(!(b|k^1))if(j)if((((ea(g[j>>2])==ea(0.0)?ea(g[j+4>>2])==ea(0.0):0)?ea(g[j+8>>2])==ea(0.0):0)?ea(g[j+16>>2])==ea(0.0):0)?ea(g[j+20>>2])==ea(0.0):0){l=ea(g[j+24>>2])==ea(0.0);m=18}else n=0;else{l=1;m=18}else{l=b&k;m=18}if((m|0)==18){m=(e&4)==0;if(!(m|l^1))if(j)if((((ea(g[j+32>>2])==ea(0.0)?ea(g[j+36>>2])==ea(0.0):0)?ea(g[j+40>>2])==ea(0.0):0)?ea(g[j+48>>2])==ea(0.0):0)?ea(g[j+52>>2])==ea(0.0):0)n=ea(g[j+56>>2])==ea(0.0);else n=0;else n=1;else n=m&l}i=d;return n|0}function EXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)yBb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<5)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=d+16|0;k=f+(a<<5)|0;do{if(k){c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];a=k+16|0;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2]}k=k+32|0}while(k>>>0<h>>>0);c[g>>2]=b;i=e;return}function FXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)CZa(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b*28|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=d+16|0;o=d+20|0;p=d+24|0;q=f+(a*28|0)|0;do{if(q){g[q>>2]=ea(g[d>>2]);g[q+4>>2]=ea(g[k>>2]);g[q+8>>2]=ea(g[l>>2]);g[q+12>>2]=ea(g[m>>2]);g[q+16>>2]=ea(g[n>>2]);g[q+20>>2]=ea(g[o>>2]);g[q+24>>2]=ea(g[p>>2])}q=q+28|0}while(q>>>0<j>>>0);c[h>>2]=b;i=e;return}function GXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)zBb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b*48|0)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a*48|0)|0;do{if(j){a=j+0|0;f=d+0|0;k=a+48|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(k|0))}j=j+48|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function HXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((c[b+8>>2]&2147483647)>>>0<d>>>0)kVa(b,d);g=c[b>>2]|0;h=b+4|0;b=c[h>>2]|0;j=g+d|0;if((b|0)>=(d|0)){c[h>>2]=d;i=f;return}k=g+b|0;do{if(k)a[k>>0]=a[e>>0]|0;k=k+1|0}while((k|0)!=(j|0));c[h>>2]=d;i=f;return}function IXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?463656:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else ABb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<6)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-64|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function JXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;BBb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else CBb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(DBb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,DBb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+64|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){ABb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function KXa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+16|0;h=g+1|0;j=g;k=b+12|0;l=b+28|0;m=c[l>>2]|0;do if((m|0)==-1){n=c[b+24>>2]|0;if(!n){o=-1;p=b+16|0;break}else{In[c[(c[k>>2]|0)+8>>2]&4095](k,n<<1);q=c[l>>2]|0;r=5;break}}else{q=m;r=5}while(0);if((r|0)==5){r=(c[b+20>>2]|0)+(q<<2)|0;c[l>>2]=c[r>>2];c[r>>2]=-1;r=b+16|0;l=c[r>>2]|0;c[l+(q*12|0)>>2]=0;c[l+(q*12|0)+4>>2]=-1;a[l+(q*12|0)+8>>0]=0;o=q;p=r}c[e>>2]=o;e=c[p>>2]|0;c[e+(o*12|0)+4>>2]=-1;c[e+(o*12|0)>>2]=d;a[e+(o*12|0)+8>>0]=f&1|64;e=b+120|0;d=b+124|0;p=c[d>>2]|0;r=b+136|0;if((p|0)==(c[r>>2]|0)){q=p<<1;l=UJa(h,p<<4,497248,1373)|0;h=l+(q<<2)|0;YEi(l|0,c[e>>2]|0,c[d>>2]<<2|0)|0;m=b+128|0;YEi(h|0,c[m>>2]|0,c[b+132>>2]<<2|0)|0;VJa(j,c[e>>2]|0);c[e>>2]=l;c[m>>2]=h;c[r>>2]=q;s=l;t=c[d>>2]|0}else{s=c[e>>2]|0;t=p}c[s+(t<<2)>>2]=o;c[d>>2]=(c[d>>2]|0)+1;d=f&1;t=b+244|0;c[t>>2]=(c[t>>2]|0)+(d^1);t=b+252|0;c[t>>2]=(c[t>>2]|0)+d;if(!f){u=b+273|0;a[u>>0]=1;i=g;return}f=(c[c[b+92>>2]>>2]|0)+(o>>>5<<2)|0;c[f>>2]=c[f>>2]|1<<(o&31);u=b+273|0;a[u>>0]=1;i=g;return}function LXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?464008:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function MXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?463872:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else EBb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*48|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-48|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function NXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;FBb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else GBb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(HBb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,HBb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+48|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){EBb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function OXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+780|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h*12|0;k=b+768|0;if(!((a[k>>0]|0)==0&g>>>0<769))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?464288:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+776|0;k=c[l>>2]|0;p=j+(k*12|0)|0;g=b+772|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m){c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2]}m=m+12|0;if(m>>>0>=p>>>0)break;else n=n+12|0}q=c[l>>2]|0}else q=k;k=j+(q*12|0)|0;if(k){c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2]}do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+768>>0]=0;break}if(d){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,d)}}while(0);c[g>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h*12|0)|0}function PXa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+160|0;g=f+136|0;h=f;j=h;c[j>>2]=0;c[j+4>>2]=0;j=h+4|0;a[j>>0]=0;k=f+8|0;c[h>>2]=k;l=d+-1|0;if((l|0)>0){d=0;m=0;n=0;o=l;l=k;k=32;a:while(1){p=n;q=m;r=o;while(1){if((r|0)>(p|0)){if((r-p|0)>>>0<5)s=p;else break;do{t=s;s=s+1|0;u=s;v=t;while(1){v=(c[b+(u*12|0)+8>>2]|0)>>>0>(c[b+(v*12|0)+8>>2]|0)>>>0?u:v;if((u|0)>=(r|0))break;else u=u+1|0}u=b+(v*12|0)|0;w=b+(t*12|0)|0;c[g+0>>2]=c[u+0>>2];c[g+4>>2]=c[u+4>>2];c[g+8>>2]=c[u+8>>2];c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2]}while((s|0)!=(r|0))}if(!q)break a;w=c[l+(q+-1<<2)>>2]|0;u=q+-2|0;p=c[l+(u<<2)>>2]|0;q=u;r=w}w=IBb(b,p,r,e)|0;if((w-p|0)<(r-w|0)){u=w+-1|0;if(q>>>0>=(k+-1|0)>>>0){x=k<<1;y=k<<3;if(!y)z=0;else{A=mKa()|0;B=c[(c[A>>2]|0)+8>>2]|0;C=pKa()|0;D=mo[c[(c[C>>2]|0)+24>>2]&4095](C)|0;z=Bn[B&255](A,y,D?464288:544544,523928,148)|0}YEi(z|0,l|0,q<<2|0)|0;if(d<<24>>24==0|(l|0)==0){E=1;F=x;G=z}else{D=mKa()|0;In[c[(c[D>>2]|0)+12>>2]&4095](D,l);E=1;F=x;G=z}}else{E=d;F=k;G=l}c[G+(q<<2)>>2]=p;c[G+(q+1<<2)>>2]=u;H=E;I=w+1|0;J=r;K=G;L=F}else{u=w+1|0;if(q>>>0>=(k+-1|0)>>>0){x=k<<1;D=k<<3;if(!D)M=0;else{y=mKa()|0;A=c[(c[y>>2]|0)+8>>2]|0;B=pKa()|0;C=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;M=Bn[A&255](y,D,C?464288:544544,523928,148)|0}YEi(M|0,l|0,q<<2|0)|0;if(d<<24>>24==0|(l|0)==0){N=1;O=x;P=M}else{C=mKa()|0;In[c[(c[C>>2]|0)+12>>2]&4095](C,l);N=1;O=x;P=M}}else{N=d;O=k;P=l}c[P+(q<<2)>>2]=u;c[P+(q+1<<2)>>2]=r;H=N;I=p;J=w+-1|0;K=P;L=O}d=H;m=q+2|0;n=I;o=J;l=K;k=L}if(!(d<<24>>24==0|(l|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,l)}}if(!(a[j>>0]|0)){i=f;return}tKa(h,c[h>>2]|0);i=f;return}function QXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?464552:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else JBb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*40|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-40|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function RXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;KBb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else LBb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(MBb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,MBb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+40|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){JBb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function SXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)NBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function TXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)OBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function UXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)PBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function VXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)QBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function WXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)RBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function XXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)SBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function YXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)TBb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function ZXa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=a+4|0;if(c[e>>2]|0){f=0;do{VJa(d,c[(c[a>>2]|0)+(f<<2)>>2]|0);c[(c[a>>2]|0)+(f<<2)>>2]=0;f=f+1|0}while(f>>>0<(c[e>>2]|0)>>>0)}e=c[a+24>>2]|0;if((e|0)!=0?(c[a+28>>2]|0)>-1:0)VJa(a+32|0,e);e=c[a+20>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+12>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+8>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=b;return}e=c[a>>2]|0;if(!e){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,e);i=b;return}function _Xa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;UBb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else VBb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(WBb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,WBb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+24|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){XBb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function $Xa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)aYa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function aYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?474896:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function bYa(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;i=i+128|0;j=h;k=h+56|0;l=h+114|0;m=h+80|0;n=h+16|0;o=h+96|0;p=h+40|0;q=h+32|0;r=h+72|0;s=h+112|0;t=a;c[t>>2]=0;c[t+4>>2]=0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;co[c[(c[e>>2]|0)+8>>2]&2047](e,q,o);co[c[(c[f>>2]|0)+8>>2]&2047](f,r,p);t=c[d>>2]|0;u=c[t+1100>>2]|0;v=c[q>>2]|0;c[m+0>>2]=c[o+0>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[m+12>>2]=c[o+12>>2];w=c[r>>2]|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];x=a+2|0;y=c[t+1092>>2]|0;z=c[t+1096>>2]|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];Nn[u&31](l,v,k,w,j,x,y,z);z=b[l>>1]|0;b[a>>1]=z;l=z&65535;do if(!(l&4)){A=g;B=z}else{if(!(c[(c[d>>2]|0)+1104>>2]|0)){b[a>>1]=l&65523;dKa(bKa()|0,2,464776,1237,466536,j);A=g;B=b[a>>1]|0;break}if(!g)C=sba(d)|0;else C=g;y=e+12|0;w=VEi(c[y>>2]|0,c[y+4>>2]|0,30)|0;y=w&3;if(!y){w=dca(Vfa(e)|0)|0;D=w;E=dfa(c[e+28>>2]|0)|0}else if((y|0)==1){D=Vga(Pha(Iga(e)|0)|0)|0;E=0}else{D=0;E=0}y=f+12|0;w=VEi(c[y>>2]|0,c[y+4>>2]|0,30)|0;y=w&3;if((y|0)==1){F=Vga(Pha(Iga(f)|0)|0)|0;G=0}else if(!y){y=dca(Vfa(f)|0)|0;F=y;G=dfa(c[f+28>>2]|0)|0}else{F=0;G=0}y=c[(c[d>>2]|0)+1104>>2]|0;w=c[c[y>>2]>>2]|0;v=c[C>>2]|0;u=c[q>>2]|0;n=c[r>>2]|0;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];An[w&3](s,y,v,u,k,D,E,n,j,F,G,x);n=b[s>>1]|0;b[a>>1]=n;c[a+4>>2]=C;A=C;B=n}while(0);if((B&3)==3){dKa(bKa()|0,2,464776,882,466448,j);H=B&65534}else H=B;b[a>>1]=H;if(!A){i=h;return}B=H&13;if(B<<16>>16==12){i=h;return}else if(B<<16>>16==13){B=c[(c[d>>2]|0)+1104>>2]|0;C=c[(c[B>>2]|0)+4>>2]|0;s=c[A>>2]|0;x=c[q>>2]|0;q=c[r>>2]|0;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];Wn[C&127](B,s,x,k,q,j,0);I=b[a>>1]|0}else I=H;H=I&65535;if((H&12|0)!=12)b[a>>1]=H&65523;tba(d,A);c[a+4>>2]=0;i=h;return}function cYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?465128:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else YBb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*24|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-24|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function dYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?464960:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else ZBb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*48|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-48|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function eYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?465808:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else _Bb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*40|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-40|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function fYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;$Bb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else aCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(bCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,bCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+60|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){cCb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function gYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;dCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else eCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(fCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,fCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+40|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){_Bb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function hYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?465672:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else gCb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*68|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-68|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function iYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?465952:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else cCb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*60|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-60|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function jYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?465552:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else XBb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*24|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-24|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function kYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+4|0;e=b;f=UJa(b+8|0,384,466344,186)|0;c[d>>2]=f;if(!f){g=0;i=b;return g|0}h=a+12|0;j=a+20|0;if((c[j>>2]&2147483616)>>>0<32)hCb(h,32);k=a+16|0;l=a+4|0;m=31;while(1){n=f+(m*12|0)|0;if(n)c[n>>2]=(c[l>>2]<<5)+m;n=f+(m*12|0)|0;c[e>>2]=n;o=c[k>>2]|0;if((c[j>>2]&2147483647)>>>0>o>>>0){p=(c[h>>2]|0)+(o<<2)|0;if(p)c[p>>2]=n;c[k>>2]=o+1}else lYa(h,e)|0;if((m|0)>0)m=m+-1|0;else break}m=c[l>>2]|0;if((c[a+8>>2]&2147483647)>>>0>m>>>0){e=(c[a>>2]|0)+(m<<2)|0;if(e)c[e>>2]=f;f=m+1|0;c[l>>2]=f;q=f}else{lYa(a,d)|0;q=c[l>>2]|0}l=a+24|0;d=(q<<5)+-1|0;f=q&134217727;q=a+28|0;if(f>>>0>(c[q>>2]&2147483647)>>>0){m=a+32|0;a=UJa(m,f<<2,543784,339)|0;e=c[l>>2]|0;if((e|0)!=0?(YEi(a|0,e|0,c[q>>2]<<2|0)|0,(c[q>>2]|0)>-1):0)VJa(m,c[l>>2]|0);m=c[q>>2]|0;PEi(a+((m&2147483647)<<2)|0,0,f-m<<2|0)|0;c[l>>2]=a;c[q>>2]=f;r=a}else r=c[l>>2]|0;l=r+(d>>>5<<2)|0;c[l>>2]=c[l>>2]&2147483647;g=1;i=b;return g|0}function lYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?466224:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function mYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;iCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else jCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(kCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,kCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+24|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){YBb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function nYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;lCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else mCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(nCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,nCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+48|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){ZBb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function oYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=b+8|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if((h|0)!=0?(g=h*24|0,(g|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,g,m?471120:544544,537640,558)|0}else n=0;m=b+4|0;g=c[m>>2]|0;j=n+(g*24|0)|0;if((g|0)>0){k=n;l=c[b>>2]|0;while(1){if(k){c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];a[k+20>>0]=a[l+20>>0]|0}k=k+24|0;if(k>>>0>=j>>>0)break;else l=l+24|0}o=c[m>>2]|0}else o=g;g=n+(o*24|0)|0;if(g){c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];a[n+(o*24|0)+20>>0]=a[d+20>>0]|0}if((c[f>>2]|0)<=-1){c[b>>2]=n;c[f>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*24|0)|0;i=e;return r|0}d=c[b>>2]|0;if(!d){c[b>>2]=n;c[f>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*24|0)|0;i=e;return r|0}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,d);c[b>>2]=n;c[f>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*24|0)|0;i=e;return r|0}function pYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*12|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?470984:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*12|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}j=j+12|0;if(j>>>0>=h>>>0)break;else k=k+12|0}n=c[l>>2]|0}else n=f;f=m+(n*12|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g*12|0)|0}function qYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?466088:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function rYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;oCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else pCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(qCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,qCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+68|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){gCb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function sYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465408:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function tYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?465256:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else rCb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*36|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-36|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function uYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;sCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else tCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(uCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,uCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+36|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){rCb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function vYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=a+16|0;g=(b+32|0)>>>5;h=a+20|0;if(g>>>0>(c[h>>2]&2147483647)>>>0){j=a+24|0;k=UJa(j,g<<2,543784,339)|0;l=c[f>>2]|0;if((l|0)!=0?(YEi(k|0,l|0,c[h>>2]<<2|0)|0,(c[h>>2]|0)>-1):0)VJa(j,c[f>>2]|0);j=c[h>>2]|0;PEi(k+((j&2147483647)<<2)|0,0,g-j<<2|0)|0;c[f>>2]=k;c[h>>2]=g;m=k}else m=c[f>>2]|0;f=m+(b>>>5<<2)|0;c[f>>2]=c[f>>2]|1<<(b&31);f=a+28|0;m=a+32|0;k=c[m>>2]|0;if((c[a+36>>2]&2147483647)>>>0<=k>>>0){cUa(f,e)|0;i=d;return}e=(c[f>>2]|0)+(k<<2)|0;if(!e)n=k;else{c[e>>2]=b;n=c[m>>2]|0}c[m>>2]=n+1;i=d;return}function wYa(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=d;c[g>>2]=0;c[g+4>>2]=0;b[d+4>>1]=-1;b[d+6>>1]=0;c[d+8>>2]=0;c[d>>2]=445416;c[d+12>>2]=0;c[d+16>>2]=e;c[d+44>>2]=0;a[d+36>>0]=1;c[d+40>>2]=d+20;c[d+48>>2]=4;c[d+76>>2]=0;a[d+68>>0]=1;c[d+72>>2]=d+52;c[d+80>>2]=4;a[d+84>>0]=0;e=d+88|0;d=c[(qTa()|0)>>2]|0;if(!d){c[e>>2]=0;i=f;return}g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](g,d,k?544576:544544,544464,111)|0;c[e>>2]=j;if(!j){i=f;return}mTa(j);i=f;return}function xYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*12|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?468392:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*12|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}j=j+12|0;if(j>>>0>=h>>>0)break;else k=k+12|0}n=c[l>>2]|0}else n=f;f=m+(n*12|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g*12|0)|0}function yYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?470872:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function zYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+12|0;f=d;g=b+12|0;h=b+16|0;j=c[h>>2]|0;k=b+8|0;l=c[k>>2]|0;m=c[b>>2]|0;n=c[b+4>>2]|0;a:do if(j){o=0;while(1){if((o|0)!=(l|0)){p=c[g>>2]|0;q=p+(o*12|0)+4|0;r=c[q>>2]|0;if(r){s=5;break}t=p+(o*12|0)+8|0;u=c[t>>2]|0;if((u|0)!=(m|0)?(c[t>>2]=u+1,t=(c[p+(o*12|0)>>2]|0)+(da(u,n)|0)|0,(t|0)!=0):0){v=t;break}}t=o+1|0;if(t>>>0<j>>>0)o=t;else break a}if((s|0)==5){c[q>>2]=c[r>>2];v=r}c[k>>2]=o;w=v;i=d;return w|0}while(0);c[k>>2]=j;a[b+24>>0]=1;c[f+4>>2]=0;c[f+8>>2]=0;c[f>>2]=UJa(e,da(n,m)|0,468528,60)|0;e=c[h>>2]|0;if((c[b+20>>2]&2147483647)>>>0>e>>>0){b=c[g>>2]|0;j=b+(e*12|0)|0;if(!j){x=e;y=b}else{c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];x=c[h>>2]|0;y=c[g>>2]|0}c[h>>2]=x+1;z=y+(x*12|0)|0}else z=xYa(g,f)|0;f=z+4|0;g=c[f>>2]|0;if(g){c[f>>2]=c[g>>2];w=g;i=d;return w|0}g=z+8|0;f=c[g>>2]|0;if((f|0)==(m|0)){w=0;i=d;return w|0}c[g>>2]=f+1;w=(c[z>>2]|0)+(da(f,n)|0)|0;i=d;return w|0}function AYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;if(!d){i=e;return}f=b+24|0;if(!(a[f>>0]|0))g=b+16|0;else{h=b+16|0;vCb(c[b+12>>2]|0,c[h>>2]|0,e+1|0,e);g=h}h=da(c[b+4>>2]|0,c[b>>2]|0)|0;j=(c[g>>2]|0)+-1|0;if((j|0)<0){i=e;return}g=c[b+12>>2]|0;k=0;l=j;a:while(1){j=k;while(1){m=j+l>>1;n=c[g+(m*12|0)>>2]|0;if(n>>>0<=d>>>0&(n+h|0)>>>0>d>>>0){o=10;break a}if(n>>>0>=d>>>0)break;if((m|0)<(l|0))j=m+1|0;else{o=15;break a}}l=m+-1|0;if((j|0)>(l|0)){o=15;break}else k=j}if((o|0)==10){k=g+(m*12|0)+4|0;c[d>>2]=c[k>>2];c[k>>2]=d;if(a[f>>0]|0)c[b+8>>2]=m;a[f>>0]=0;i=e;return}else if((o|0)==15){i=e;return}}function BYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)wCb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function CYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)xCb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function DYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)yCb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function EYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)zCb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function FYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?470736:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function GYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?470736:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function HYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?470480:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function IYa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((c[b+8>>2]&2147483647)>>>0<d>>>0)JYa(b,d);g=c[b>>2]|0;h=b+4|0;b=c[h>>2]|0;j=g+(d*24|0)|0;if((b|0)>=(d|0)){c[h>>2]=d;i=f;return}k=e+20|0;l=g+(b*24|0)|0;do{if(l){c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[l+16>>2]=c[e+16>>2];a[l+20>>0]=a[k>>0]|0}l=l+24|0}while(l>>>0<j>>>0);c[h>>2]=d;i=f;return}function JYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=0?(f=d*24|0,(f|0)!=0):0){g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](g,f,k?471120:544544,537640,558)|0}else l=0;k=c[b+4>>2]|0;f=l+(k*24|0)|0;if((k|0)>0){k=l;g=c[b>>2]|0;while(1){if(k){c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];a[k+20>>0]=a[g+20>>0]|0}k=k+24|0;if(k>>>0>=f>>>0)break;else g=g+24|0}}g=b+8|0;if((c[g>>2]|0)<=-1){c[b>>2]=l;c[g>>2]=d;i=e;return}f=c[b>>2]|0;if(!f){c[b>>2]=l;c[g>>2]=d;i=e;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,f);c[b>>2]=l;c[g>>2]=d;i=e;return}function KYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)LYa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b*12|0)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a*12|0)|0;do{if(j){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2]}j=j+12|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function LYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b*12|0,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?470984:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j*12|0)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2]}j=j+12|0;if(j>>>0>=e>>>0)break;else f=f+12|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function MYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)HYa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function NYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)OYa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function OYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?468272:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function PYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?470872:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function QYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)RYa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<4)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<4)|0;do{if(j){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2]}j=j+16|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function RYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?468128:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<4)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}j=j+16|0;if(j>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function SYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?467856:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function TYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)FYa(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function UYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!d)f=0;else{g=d*24|0;h=b+768|0;if((a[h>>0]|0)==0&g>>>0<769){a[h>>0]=1;j=b}else j=sKa(b,g,537640,558)|0;f=j}j=c[b+776>>2]|0;g=f+(j*24|0)|0;h=b+772|0;if((j|0)>0){j=f;k=c[h>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];a[j+20>>0]=a[k+20>>0]|0}j=j+24|0;if(j>>>0>=g>>>0)break;else k=k+24|0}}k=b+780|0;if((c[k>>2]|0)<=-1){c[h>>2]=f;c[k>>2]=d;i=e;return}g=c[h>>2]|0;if((b|0)==(g|0)){a[b+768>>0]=0;c[h>>2]=f;c[k>>2]=d;i=e;return}else{tKa(b,g);c[h>>2]=f;c[k>>2]=d;i=e;return}}function VYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+780|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h*24|0;k=b+768|0;if((a[k>>0]|0)==0&g>>>0<769){a[k>>0]=1;l=b}else l=sKa(b,g,537640,558)|0;j=l}l=b+776|0;g=c[l>>2]|0;k=j+(g*24|0)|0;m=b+772|0;if((g|0)>0){n=j;o=c[m>>2]|0;while(1){if(n){c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];a[n+20>>0]=a[o+20>>0]|0}n=n+24|0;if(n>>>0>=k>>>0)break;else o=o+24|0}p=c[l>>2]|0}else p=g;g=j+(p*24|0)|0;if(g){c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];a[j+(p*24|0)+20>>0]=a[d+20>>0]|0}do if((c[f>>2]|0)>-1){d=c[m>>2]|0;if((b|0)==(d|0)){a[b+768>>0]=0;break}else{tKa(b,d);break}}while(0);c[m>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h*24|0)|0}function WYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?470608:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else ACb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<7)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-128|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function XYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?470480:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function YYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;BCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else CCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(DCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,DCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+128|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){ACb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function ZYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?470216:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function _Ya(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?469928:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else ECb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<7)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-128|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function $Ya(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?469776:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else FCb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<8)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-256|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function aZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?469624:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else GCb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*384|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-384|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function bZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;HCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else ICb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(JCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,JCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+128|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){ECb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function cZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;KCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else LCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(MCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,MCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+256|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){FCb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function dZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;NCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else OCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(PCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,PCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+384|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){GCb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function eZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+28|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+16|0;if(!((a[k>>0]|0)==0&g>>>0<17))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?445456:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+24|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+20|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+16>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function fZa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=b+88|0;oTa(c[e>>2]|0);f=b+12|0;if(gTa(f)|0){g=c[e>>2]|0;pTa(g);i=d;return}fTa(f)|0;a[b+84>>0]=0;f=b+44|0;h=c[f>>2]|0;if(h){j=b+40|0;k=b+80|0;l=b+76|0;m=b+72|0;n=b+52|0;o=h;h=0;while(1){p=(c[j>>2]|0)+(h<<2)|0;q=c[l>>2]|0;if((c[k>>2]&2147483647)>>>0>q>>>0){r=(c[m>>2]|0)+(q<<2)|0;if(r)c[r>>2]=c[p>>2];c[l>>2]=q+1;s=o}else{eZa(n,p)|0;s=c[f>>2]|0}h=h+1|0;if(h>>>0>=s>>>0)break;else o=s}}c[f>>2]=0;f=c[b+8>>2]|0;s=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;In[c[c[s>>2]>>2]&4095](s,b);g=c[e>>2]|0;pTa(g);i=d;return}function gZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<4,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?468128:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<4)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2]}j=j+16|0;if(j>>>0>=h>>>0)break;else k=k+16|0}n=c[l>>2]|0}else n=f;f=m+(n<<4)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<4)|0}function hZa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if((d|0)!=0?(g=d*28|0,(g|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,g,l?469440:544544,537640,558)|0}else m=0;l=a+4|0;g=c[l>>2]|0;h=m+(g*28|0)|0;if((g|0)>0){g=m;j=c[a>>2]|0;while(1){if(g){c[g>>2]=468920;k=j+4|0;n=k;o=e[n>>1]|e[n+2>>1]<<16;n=k+4|0;k=e[n>>1]|e[n+2>>1]<<16;n=g+4|0;p=n;b[p>>1]=o;b[p+2>>1]=o>>>16;o=n+4|0;b[o>>1]=k;b[o+2>>1]=k>>>16;c[g>>2]=443968;k=g+12|0;o=j+12|0;c[k>>2]=c[o>>2];c[g+16>>2]=c[j+16>>2];c[k>>2]=c[o>>2];c[g>>2]=469400;o=j+20|0;k=c[o+4>>2]|0;n=g+20|0;c[n>>2]=c[o>>2];c[n+4>>2]=k}g=g+28|0;if(g>>>0>=h>>>0)break;else j=j+28|0}j=c[l>>2]|0;l=c[a>>2]|0;h=l+(j*28|0)|0;if((j|0)>0){j=l;do{ko[c[c[j>>2]>>2]&4095](j);j=j+28|0}while(j>>>0<h>>>0)}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=m;c[h>>2]=d;i=f;return}j=c[a>>2]|0;if(!j){c[a>>2]=m;c[h>>2]=d;i=f;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,j);c[a>>2]=m;c[h>>2]=d;i=f;return}function iZa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if((d|0)!=0?(g=d*28|0,(g|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,g,l?469192:544544,537640,558)|0}else m=0;l=a+4|0;g=c[l>>2]|0;h=m+(g*28|0)|0;if((g|0)>0){g=m;j=c[a>>2]|0;while(1){if(g){c[g>>2]=468920;k=j+4|0;n=k;o=e[n>>1]|e[n+2>>1]<<16;n=k+4|0;k=e[n>>1]|e[n+2>>1]<<16;n=g+4|0;p=n;b[p>>1]=o;b[p+2>>1]=o>>>16;o=n+4|0;b[o>>1]=k;b[o+2>>1]=k>>>16;c[g>>2]=443968;k=g+12|0;o=j+12|0;c[k>>2]=c[o>>2];c[g+16>>2]=c[j+16>>2];c[k>>2]=c[o>>2];c[g>>2]=469152;o=j+20|0;k=c[o+4>>2]|0;n=g+20|0;c[n>>2]=c[o>>2];c[n+4>>2]=k}g=g+28|0;if(g>>>0>=h>>>0)break;else j=j+28|0}j=c[l>>2]|0;l=c[a>>2]|0;h=l+(j*28|0)|0;if((j|0)>0){j=l;do{ko[c[c[j>>2]>>2]&4095](j);j=j+28|0}while(j>>>0<h>>>0)}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=m;c[h>>2]=d;i=f;return}j=c[a>>2]|0;if(!j){c[a>>2]=m;c[h>>2]=d;i=f;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,j);c[a>>2]=m;c[h>>2]=d;i=f;return}function jZa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if((d|0)!=0?(g=d*28|0,(g|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,g,l?468952:544544,537640,558)|0}else m=0;l=a+4|0;g=c[l>>2]|0;h=m+(g*28|0)|0;if((g|0)>0){g=m;j=c[a>>2]|0;while(1){if(g){c[g>>2]=468920;k=j+4|0;n=k;o=e[n>>1]|e[n+2>>1]<<16;n=k+4|0;k=e[n>>1]|e[n+2>>1]<<16;n=g+4|0;p=n;b[p>>1]=o;b[p+2>>1]=o>>>16;o=n+4|0;b[o>>1]=k;b[o+2>>1]=k>>>16;c[g>>2]=443968;k=g+12|0;o=j+12|0;c[k>>2]=c[o>>2];c[g+16>>2]=c[j+16>>2];c[k>>2]=c[o>>2];c[g>>2]=468872;o=j+20|0;k=c[o+4>>2]|0;n=g+20|0;c[n>>2]=c[o>>2];c[n+4>>2]=k}g=g+28|0;if(g>>>0>=h>>>0)break;else j=j+28|0}j=c[l>>2]|0;l=c[a>>2]|0;h=l+(j*28|0)|0;if((j|0)>0){j=l;do{ko[c[c[j>>2]>>2]&4095](j);j=j+28|0}while(j>>>0<h>>>0)}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=m;c[h>>2]=d;i=f;return}j=c[a>>2]|0;if(!j){c[a>>2]=m;c[h>>2]=d;i=f;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,j);c[a>>2]=m;c[h>>2]=d;i=f;return}function kZa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=a+8|0;h=c[g>>2]|0;j=(h&2147483647|0)==0?1:h<<1;if((j|0)!=0?(h=j*28|0,(h|0)!=0):0){k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;o=Bn[l&255](k,h,n?469440:544544,537640,558)|0}else o=0;n=a+4|0;h=c[n>>2]|0;k=o+(h*28|0)|0;if((h|0)>0){l=o;m=c[a>>2]|0;while(1){if(l){c[l>>2]=468920;p=m+4|0;q=p;r=e[q>>1]|e[q+2>>1]<<16;q=p+4|0;p=e[q>>1]|e[q+2>>1]<<16;q=l+4|0;s=q;b[s>>1]=r;b[s+2>>1]=r>>>16;r=q+4|0;b[r>>1]=p;b[r+2>>1]=p>>>16;c[l>>2]=443968;p=l+12|0;r=m+12|0;c[p>>2]=c[r>>2];c[l+16>>2]=c[m+16>>2];c[p>>2]=c[r>>2];c[l>>2]=469400;r=m+20|0;p=c[r+4>>2]|0;q=l+20|0;c[q>>2]=c[r>>2];c[q+4>>2]=p}l=l+28|0;if(l>>>0>=k>>>0)break;else m=m+28|0}t=c[n>>2]|0}else t=h;h=o+(t*28|0)|0;c[h>>2]=468920;m=d+4|0;k=m;l=e[k>>1]|e[k+2>>1]<<16;k=m+4|0;m=e[k>>1]|e[k+2>>1]<<16;k=o+(t*28|0)+4|0;p=k;b[p>>1]=l;b[p+2>>1]=l>>>16;l=k+4|0;b[l>>1]=m;b[l+2>>1]=m>>>16;c[h>>2]=443968;m=o+(t*28|0)+12|0;l=d+12|0;c[m>>2]=c[l>>2];c[o+(t*28|0)+16>>2]=c[d+16>>2];c[m>>2]=c[l>>2];c[h>>2]=469400;h=d+20|0;d=c[h+4>>2]|0;l=o+(t*28|0)+20|0;c[l>>2]=c[h>>2];c[l+4>>2]=d;d=c[a>>2]|0;l=c[n>>2]|0;h=d+(l*28|0)|0;if((l|0)>0){l=d;do{ko[c[c[l>>2]>>2]&4095](l);l=l+28|0}while(l>>>0<h>>>0)}if((c[g>>2]|0)<=-1){c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}h=c[a>>2]|0;if(!h){c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,h);c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}function lZa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=a+8|0;h=c[g>>2]|0;j=(h&2147483647|0)==0?1:h<<1;if((j|0)!=0?(h=j*28|0,(h|0)!=0):0){k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;o=Bn[l&255](k,h,n?469192:544544,537640,558)|0}else o=0;n=a+4|0;h=c[n>>2]|0;k=o+(h*28|0)|0;if((h|0)>0){l=o;m=c[a>>2]|0;while(1){if(l){c[l>>2]=468920;p=m+4|0;q=p;r=e[q>>1]|e[q+2>>1]<<16;q=p+4|0;p=e[q>>1]|e[q+2>>1]<<16;q=l+4|0;s=q;b[s>>1]=r;b[s+2>>1]=r>>>16;r=q+4|0;b[r>>1]=p;b[r+2>>1]=p>>>16;c[l>>2]=443968;p=l+12|0;r=m+12|0;c[p>>2]=c[r>>2];c[l+16>>2]=c[m+16>>2];c[p>>2]=c[r>>2];c[l>>2]=469152;r=m+20|0;p=c[r+4>>2]|0;q=l+20|0;c[q>>2]=c[r>>2];c[q+4>>2]=p}l=l+28|0;if(l>>>0>=k>>>0)break;else m=m+28|0}t=c[n>>2]|0}else t=h;h=o+(t*28|0)|0;c[h>>2]=468920;m=d+4|0;k=m;l=e[k>>1]|e[k+2>>1]<<16;k=m+4|0;m=e[k>>1]|e[k+2>>1]<<16;k=o+(t*28|0)+4|0;p=k;b[p>>1]=l;b[p+2>>1]=l>>>16;l=k+4|0;b[l>>1]=m;b[l+2>>1]=m>>>16;c[h>>2]=443968;m=o+(t*28|0)+12|0;l=d+12|0;c[m>>2]=c[l>>2];c[o+(t*28|0)+16>>2]=c[d+16>>2];c[m>>2]=c[l>>2];c[h>>2]=469152;h=d+20|0;d=c[h+4>>2]|0;l=o+(t*28|0)+20|0;c[l>>2]=c[h>>2];c[l+4>>2]=d;d=c[a>>2]|0;l=c[n>>2]|0;h=d+(l*28|0)|0;if((l|0)>0){l=d;do{ko[c[c[l>>2]>>2]&4095](l);l=l+28|0}while(l>>>0<h>>>0)}if((c[g>>2]|0)<=-1){c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}h=c[a>>2]|0;if(!h){c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,h);c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}function mZa(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=a+8|0;h=c[g>>2]|0;j=(h&2147483647|0)==0?1:h<<1;if((j|0)!=0?(h=j*28|0,(h|0)!=0):0){k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;o=Bn[l&255](k,h,n?468952:544544,537640,558)|0}else o=0;n=a+4|0;h=c[n>>2]|0;k=o+(h*28|0)|0;if((h|0)>0){l=o;m=c[a>>2]|0;while(1){if(l){c[l>>2]=468920;p=m+4|0;q=p;r=e[q>>1]|e[q+2>>1]<<16;q=p+4|0;p=e[q>>1]|e[q+2>>1]<<16;q=l+4|0;s=q;b[s>>1]=r;b[s+2>>1]=r>>>16;r=q+4|0;b[r>>1]=p;b[r+2>>1]=p>>>16;c[l>>2]=443968;p=l+12|0;r=m+12|0;c[p>>2]=c[r>>2];c[l+16>>2]=c[m+16>>2];c[p>>2]=c[r>>2];c[l>>2]=468872;r=m+20|0;p=c[r+4>>2]|0;q=l+20|0;c[q>>2]=c[r>>2];c[q+4>>2]=p}l=l+28|0;if(l>>>0>=k>>>0)break;else m=m+28|0}t=c[n>>2]|0}else t=h;h=o+(t*28|0)|0;c[h>>2]=468920;m=d+4|0;k=m;l=e[k>>1]|e[k+2>>1]<<16;k=m+4|0;m=e[k>>1]|e[k+2>>1]<<16;k=o+(t*28|0)+4|0;p=k;b[p>>1]=l;b[p+2>>1]=l>>>16;l=k+4|0;b[l>>1]=m;b[l+2>>1]=m>>>16;c[h>>2]=443968;m=o+(t*28|0)+12|0;l=d+12|0;c[m>>2]=c[l>>2];c[o+(t*28|0)+16>>2]=c[d+16>>2];c[m>>2]=c[l>>2];c[h>>2]=468872;h=d+20|0;d=c[h+4>>2]|0;l=o+(t*28|0)+20|0;c[l>>2]=c[h>>2];c[l+4>>2]=d;d=c[a>>2]|0;l=c[n>>2]|0;h=d+(l*28|0)|0;if((l|0)>0){l=d;do{ko[c[c[l>>2]>>2]&4095](l);l=l+28|0}while(l>>>0<h>>>0)}if((c[g>>2]|0)<=-1){c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}h=c[a>>2]|0;if(!h){c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,h);c[a>>2]=o;c[g>>2]=j;u=c[n>>2]|0;v=u+1|0;c[n>>2]=v;w=o+(u*28|0)|0;i=f;return w|0}function nZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d+2|0;f=d+1|0;h=d;j=c[b+4>>2]|0;if(!j){c[a+24>>2]=0;c[a+28>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;k=c[a>>2]|0;if(k)VJa(e,k);c[a>>2]=0;i=d;return}k=j<<1|1;e=a+28|0;l=c[e>>2]|0;if(j>>>0>l>>>0|j>>>0<l>>>2>>>0){l=c[a>>2]|0;if(l)VJa(f,l);l=j<<3;f=k<<2;m=l+(j<<2)|0;n=UJa(h,f+m|0,474448,101)|0;c[a>>2]=n;h=a+16|0;c[h>>2]=n;o=a+20|0;c[o>>2]=n+l;l=n+m|0;c[a+4>>2]=l;c[e>>2]=j;c[a+12>>2]=k;p=o;q=h;r=f;s=l}else{p=a+20|0;q=a+16|0;r=k<<2;s=c[a+4>>2]|0}PEi(s|0,-1,r|0)|0;r=a+24|0;c[r>>2]=0;c[a+8>>2]=k;s=c[a+4>>2]|0;a=c[p>>2]|0;p=c[q>>2]|0;q=c[b>>2]|0;b=0;l=0;while(1){f=c[q+(b<<4)>>2]|0;h=c[q+(b<<4)+4>>2]|0;t=ea(g[q+(b<<4)+8>>2]);o=h;e=_Ei(o|0,f|0,-1,~o|0)|0;o=H;m=VEi(e|0,o|0,22)|0;n=m^e;e=H^o;o=cFi(n|0,e|0,13)|0;m=_Ei(n|0,e|0,~o|0,~H|0)|0;o=H;e=VEi(m|0,o|0,8)|0;n=gFi(e^m|0,H^o|0,9,0)|0;o=H;m=VEi(n|0,o|0,15)|0;e=m^n;n=H^o;o=cFi(e|0,n|0,27)|0;m=_Ei(e|0,n|0,~o|0,~H|0)|0;o=H;n=VEi(m|0,o|0,31)|0;o=((n^m)>>>0)%(k>>>0)|0;m=s+(o<<2)|0;n=c[m>>2]|0;a:do if((n|0)==-1){u=o;v=16}else{e=n;while(1){w=c[p+(e<<3)>>2]|0;if((f|0)==(c[q+(w<<4)>>2]|0)?(h|0)==(c[q+(w<<4)+4>>2]|0):0)break;w=c[a+(e<<2)>>2]|0;if((w|0)==-1){u=e;v=16;break a}else e=w}w=p+(e<<3)+4|0;g[w>>2]=ea(t+ea(g[w>>2]));x=l}while(0);if((v|0)==16){v=0;if((u|0)==-1)x=l;else{c[m>>2]=l;c[a+(l<<2)>>2]=-1;c[p+(l<<3)>>2]=b;g[p+(l<<3)+4>>2]=t;x=l+1|0}}b=b+1|0;if((b|0)==(j|0))break;else l=x}c[r>>2]=x;i=d;return}function oZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!d)f=0;else{g=d<<4;h=b+512|0;if((a[h>>0]|0)==0&g>>>0<513){a[h>>0]=1;j=b}else j=sKa(b,g,537640,558)|0;f=j}j=c[b+520>>2]|0;g=f+(j<<4)|0;h=b+516|0;if((j|0)>0){j=f;k=c[h>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2]}j=j+16|0;if(j>>>0>=g>>>0)break;else k=k+16|0}}k=b+524|0;if((c[k>>2]|0)<=-1){c[h>>2]=f;c[k>>2]=d;i=e;return}g=c[h>>2]|0;if((b|0)==(g|0)){a[b+512>>0]=0;c[h>>2]=f;c[k>>2]=d;i=e;return}else{tKa(b,g);c[h>>2]=f;c[k>>2]=d;i=e;return}}function pZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+524|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<4;k=b+512|0;if((a[k>>0]|0)==0&g>>>0<513){a[k>>0]=1;l=b}else l=sKa(b,g,537640,558)|0;j=l}l=b+520|0;g=c[l>>2]|0;k=j+(g<<4)|0;m=b+516|0;if((g|0)>0){n=j;o=c[m>>2]|0;while(1){if(n){c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2]}n=n+16|0;if(n>>>0>=k>>>0)break;else o=o+16|0}p=c[l>>2]|0}else p=g;g=j+(p<<4)|0;if(g){c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2]}do if((c[f>>2]|0)>-1){d=c[m>>2]|0;if((b|0)==(d|0)){a[b+512>>0]=0;break}else{tKa(b,d);break}}while(0);c[m>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h<<4)|0}function qZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!d)f=0;else{g=d*12|0;h=b+384|0;if((a[h>>0]|0)==0&g>>>0<385){a[h>>0]=1;j=b}else j=sKa(b,g,537640,558)|0;f=j}j=c[b+392>>2]|0;g=f+(j*12|0)|0;h=b+388|0;if((j|0)>0){j=f;k=c[h>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}j=j+12|0;if(j>>>0>=g>>>0)break;else k=k+12|0}}k=b+396|0;if((c[k>>2]|0)<=-1){c[h>>2]=f;c[k>>2]=d;i=e;return}g=c[h>>2]|0;if((b|0)==(g|0)){a[b+384>>0]=0;c[h>>2]=f;c[k>>2]=d;i=e;return}else{tKa(b,g);c[h>>2]=f;c[k>>2]=d;i=e;return}}function rZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+396|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h*12|0;k=b+384|0;if((a[k>>0]|0)==0&g>>>0<385){a[k>>0]=1;l=b}else l=sKa(b,g,537640,558)|0;j=l}l=b+392|0;g=c[l>>2]|0;k=j+(g*12|0)|0;m=b+388|0;if((g|0)>0){n=j;o=c[m>>2]|0;while(1){if(n){c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2]}n=n+12|0;if(n>>>0>=k>>>0)break;else o=o+12|0}p=c[l>>2]|0}else p=g;g=j+(p*12|0)|0;if(g){c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2]}do if((c[f>>2]|0)>-1){d=c[m>>2]|0;if((b|0)==(d|0)){a[b+384>>0]=0;break}else{tKa(b,d);break}}while(0);c[m>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h*12|0)|0}function sZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?468608:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function tZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?468728:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function uZa(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e;h=e+36|0;j=dca(a)|0;c[f>>2]=j;c[f+4>>2]=c[j+8>>2];In[c[(c[j>>2]|0)+84>>2]&4095](h,j);k=ea(g[h>>2]);g[f+8>>2]=k;l=ea(g[h+4>>2]);g[f+12>>2]=l;m=ea(g[h+8>>2]);g[f+16>>2]=m;n=ea(g[h+12>>2]);g[f+20>>2]=n;o=ea(g[h+16>>2]);g[f+24>>2]=o;p=ea(g[h+20>>2]);g[f+28>>2]=p;q=ea(g[h+24>>2]);g[f+32>>2]=q;h=b+((d[(c[a+52>>2]|0)+13>>0]|0)<<2)|0;a=c[h>>2]|0;b=a+4|0;j=c[b>>2]|0;if((c[a+8>>2]&2147483647)>>>0<=j>>>0){QCb(a,f)|0;r=c[h>>2]|0;s=c[r>>2]|0;t=j+1|0;u=s+(t*36|0)|0;v=u;w=v+128|0;x=w&-128;y=x;i=e;return}z=c[a>>2]|0;a=z+(j*36|0)|0;if(!a)A=j;else{B=f;f=c[B+4>>2]|0;C=a;c[C>>2]=c[B>>2];c[C+4>>2]=f;g[z+(j*36|0)+8>>2]=k;g[z+(j*36|0)+12>>2]=l;g[z+(j*36|0)+16>>2]=m;g[z+(j*36|0)+20>>2]=n;g[z+(j*36|0)+24>>2]=o;g[z+(j*36|0)+28>>2]=p;g[z+(j*36|0)+32>>2]=q;A=c[b>>2]|0}c[b>>2]=A+1;r=c[h>>2]|0;s=c[r>>2]|0;t=j+1|0;u=s+(t*36|0)|0;v=u;w=v+128|0;x=w&-128;y=x;i=e;return}function vZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?468272:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function wZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?467856:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function xZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?467736:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function yZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?474896:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function zZa(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=i;b[e>>1]=k;o=e+m|0;p=(k|0)!=0;a[o>>0]=3;b[e+(m+2)>>1]=l;l=e+(m+4)|0;do if(f&8192){a[l>>0]=1;k=e+(m+56)|0;if(!p){q=d+10|0;b[q>>1]=b[q>>1]|8;r=k;break}if(!(a[h+50>>0]|0)){g[e+(m+8)>>2]=ea(0.0);g[e+(m+12)>>2]=ea(0.0);g[e+(m+16)>>2]=ea(0.0);g[e+(m+32)>>2]=ea(0.0);g[e+(m+36)>>2]=ea(0.0);g[e+(m+40)>>2]=ea(0.0)}else{q=c[h+52>>2]|0;g[e+(m+8)>>2]=ea(g[q+80>>2]);g[e+(m+12)>>2]=ea(g[q+84>>2]);g[e+(m+16)>>2]=ea(g[q+88>>2]);g[e+(m+32)>>2]=ea(g[q+96>>2]);g[e+(m+36)>>2]=ea(g[q+100>>2]);g[e+(m+40)>>2]=ea(g[q+104>>2])}if(!(a[j+50>>0]|0)){g[e+(m+20)>>2]=ea(0.0);g[e+(m+24)>>2]=ea(0.0);g[e+(m+28)>>2]=ea(0.0);g[e+(m+44)>>2]=ea(0.0);g[e+(m+48)>>2]=ea(0.0);g[e+(m+52)>>2]=ea(0.0);r=k;break}else{q=c[j+52>>2]|0;g[e+(m+20)>>2]=ea(g[q+80>>2]);g[e+(m+24)>>2]=ea(g[q+84>>2]);g[e+(m+28)>>2]=ea(g[q+88>>2]);g[e+(m+44)>>2]=ea(g[q+96>>2]);g[e+(m+48)>>2]=ea(g[q+100>>2]);g[e+(m+52)>>2]=ea(g[q+104>>2]);r=k;break}}else r=l;while(0);if(!(f&4096))s=r;else{a[r>>0]=0;do if(a[h+50>>0]|0)if(p){l=h+64|0;g[r+4>>2]=ea(g[l>>2]);g[r+8>>2]=ea(g[h+68>>2]);g[r+12>>2]=ea(g[h+72>>2]);g[r+28>>2]=ea(g[l+16>>2]);g[r+32>>2]=ea(g[l+20>>2]);g[r+36>>2]=ea(g[l+24>>2]);break}else{l=c[h+52>>2]|0;g[r+4>>2]=ea(g[l+80>>2]);g[r+8>>2]=ea(g[l+84>>2]);g[r+12>>2]=ea(g[l+88>>2]);g[r+28>>2]=ea(g[l+96>>2]);g[r+32>>2]=ea(g[l+100>>2]);g[r+36>>2]=ea(g[l+104>>2]);break}else{g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);g[r+28>>2]=ea(0.0);g[r+32>>2]=ea(0.0);g[r+36>>2]=ea(0.0)}while(0);do if(a[j+50>>0]|0)if(p){l=j+64|0;g[r+16>>2]=ea(g[l>>2]);g[r+20>>2]=ea(g[j+68>>2]);g[r+24>>2]=ea(g[j+72>>2]);g[r+40>>2]=ea(g[l+16>>2]);g[r+44>>2]=ea(g[l+20>>2]);g[r+48>>2]=ea(g[l+24>>2]);break}else{l=c[j+52>>2]|0;g[r+16>>2]=ea(g[l+80>>2]);g[r+20>>2]=ea(g[l+84>>2]);g[r+24>>2]=ea(g[l+88>>2]);g[r+40>>2]=ea(g[l+96>>2]);g[r+44>>2]=ea(g[l+100>>2]);g[r+48>>2]=ea(g[l+104>>2]);break}else{g[r+16>>2]=ea(0.0);g[r+20>>2]=ea(0.0);g[r+24>>2]=ea(0.0);g[r+40>>2]=ea(0.0);g[r+44>>2]=ea(0.0);g[r+48>>2]=ea(0.0)}while(0);s=r+52|0}if(!(f&16384)){t=s;u=t;v=o;w=m-v|0;x=w+u|0;y=x&65535;z=d+8|0;b[z>>1]=y;i=n;return}a[s>>0]=2;RCb(s,0,h,p);RCb(s,1,j,p);t=s+60|0;u=t;v=o;w=m-v|0;x=w+u|0;y=x&65535;z=d+8|0;b[z>>1]=y;i=n;return}function AZa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+56|0;if(!(c[d>>2]|0)){i=b;return}e=a+32|0;f=c[(Dfa(c[e>>2]|0)|0)+1212>>2]|0;Hua(Via(f)|0,a+60|0);Qsa(c[f+1e3>>2]|0,c[d>>2]|0);c[d>>2]=0;d=(c[(c[(Dfa(c[e>>2]|0)|0)+1212>>2]|0)+1e3>>2]|0)+7384|0;Jfa(c[e>>2]|0,d);Jfa(c[a+36>>2]|0,d);i=b;return}function BZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;e=ea(g[b+16>>2]);f=ea(g[b+20>>2]);h=ea(g[b+24>>2]);i=ea(g[b>>2]);j=ea(g[b+4>>2]);k=ea(g[b+8>>2]);l=ea(g[b+12>>2]);m=ea(g[c+16>>2]);n=ea(g[c+20>>2]);o=ea(g[c+24>>2]);p=ea(g[c>>2]);q=ea(g[c+4>>2]);r=ea(g[c+8>>2]);s=ea(g[c+12>>2]);t=ea(g[a+16>>2]);u=ea(g[a+20>>2]);v=ea(g[a+24>>2]);w=ea(g[a>>2]);x=ea(g[a+4>>2]);y=ea(g[a+8>>2]);z=ea(g[a+12>>2]);A=ea(ea(l*s)+ea(ea(ea(i*p)+ea(j*q))+ea(k*r)));B=ea(ea(ea(i*s)+ea(ea(j*r)-ea(k*q)))-ea(l*p));C=ea(ea(ea(j*s)+ea(ea(k*p)-ea(i*r)))-ea(l*q));D=ea(ea(ea(ea(i*q)-ea(j*p))+ea(k*s))-ea(l*r));l=ea(e-m);m=ea(f-n);n=ea(h-o);o=ea(ea(s*s)+ea(-.5));h=ea(ea(ea(l*p)+ea(m*q))+ea(n*r));f=ea(ea(p*h)+ea(ea(s*ea(ea(m*r)-ea(n*q)))+ea(l*o)));e=ea(ea(q*h)+ea(ea(s*ea(ea(n*p)-ea(l*r)))+ea(m*o)));k=ea(ea(r*h)+ea(ea(ea(ea(l*q)-ea(m*p))*s)+ea(n*o)));o=ea(f+f);f=ea(e+e);e=ea(k+k);k=ea(ea(A*z)-ea(ea(ea(B*w)+ea(C*x))+ea(D*y)));n=ea(ea(A*w)+ea(ea(B*z)+ea(ea(D*x)-ea(C*y))));s=ea(ea(A*x)+ea(ea(C*z)+ea(ea(B*y)-ea(D*w))));p=ea(ea(A*y)+ea(ea(ea(C*w)-ea(B*x))+ea(D*z)));D=ea(ea(z*z)+ea(-.5));B=ea(ea(y*e)+ea(ea(w*o)+ea(x*f)));C=ea(u+ea(ea(ea(x*B)+ea(ea(z*ea(ea(y*o)-ea(w*e)))+ea(f*D)))*ea(2.0)));u=ea(v+ea(ea(ea(y*B)+ea(ea(z*ea(ea(w*f)-ea(x*o)))+ea(e*D)))*ea(2.0)));g[d+16>>2]=ea(t+ea(ea(ea(w*B)+ea(ea(z*ea(ea(x*e)-ea(y*f)))+ea(o*D)))*ea(2.0)));g[d+20>>2]=C;g[d+24>>2]=u;g[d>>2]=n;g[d+4>>2]=s;g[d+8>>2]=p;g[d+12>>2]=k;return}function CZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*28|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?463032:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*28|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2]);g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2])}k=k+28|0;if(k>>>0>=e>>>0)break;else f=f+28|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function DZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;SCb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else TCb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(UCb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,UCb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+52|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){VCb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function EZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;d=ea(g[c>>2]);e=ea(d-ea(g[a+16>>2]));d=ea(g[c+4>>2]);f=ea(d-ea(g[a+20>>2]));d=ea(g[c+8>>2]);h=ea(d-ea(g[a+24>>2]));d=ea(g[b+8>>2]);i=ea(f*d);j=ea(g[b+4>>2]);k=ea(i-ea(h*j));i=ea(g[b>>2]);l=ea(ea(h*i)-ea(e*d));h=ea(ea(e*j)-ea(f*i));f=ea(g[a+124>>2]);e=ea(i*f);i=ea(j*f);j=ea(d*f);b=a+64|0;g[b>>2]=ea(e+ea(g[b>>2]));b=a+68|0;g[b>>2]=ea(i+ea(g[b>>2]));b=a+72|0;g[b>>2]=ea(j+ea(g[b>>2]));j=ea(k*ea(2.0));k=ea(l*ea(2.0));l=ea(h*ea(2.0));h=ea(g[a+12>>2]);i=ea(ea(h*h)+ea(-.5));e=ea(g[a>>2]);f=ea(j*e);d=ea(g[a+4>>2]);m=ea(f+ea(k*d));f=ea(g[a+8>>2]);n=ea(m+ea(l*f));m=ea(ea(e*n)+ea(ea(j*i)-ea(h*ea(ea(l*d)-ea(k*f)))));o=ea(ea(d*n)+ea(ea(k*i)-ea(h*ea(ea(j*f)-ea(l*e)))));p=ea(ea(ea(l*i)-ea(h*ea(ea(k*e)-ea(j*d))))+ea(f*n));n=ea(ea(g[a+112>>2])*m);m=ea(ea(g[a+116>>2])*o);o=ea(n*ea(2.0));n=ea(m*ea(2.0));m=ea(ea(ea(g[a+120>>2])*p)*ea(2.0));p=ea(ea(f*m)+ea(ea(e*o)+ea(d*n)));j=ea(ea(e*p)+ea(ea(i*o)+ea(h*ea(ea(d*m)-ea(f*n)))));k=ea(ea(d*p)+ea(ea(i*n)+ea(h*ea(ea(f*o)-ea(e*m)))));l=ea(ea(ea(i*m)+ea(h*ea(ea(e*n)-ea(d*o))))+ea(f*p));b=a+80|0;g[b>>2]=ea(ea(g[b>>2])+j);b=a+84|0;g[b>>2]=ea(ea(g[b>>2])+k);b=a+88|0;g[b>>2]=ea(ea(g[b>>2])+l);return}function FZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?475528:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else VCb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*52|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-52|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function GZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?475712:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function HZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)WCb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function IZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)XCb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function JZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)YCb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function KZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;if((g|0)!=(c[h>>2]|0)){j=g;k=c[a>>2]|0;l=c[b>>2]|0;m=j+1|0;c[f>>2]=m;n=k+(j<<2)|0;c[n>>2]=l;i=e;return}o=g+1&65535;do if(o)if(o>>>0<5){p=4;q=d+4|0;break}else{r=o+-1|0;s=r>>>1|r;r=s>>>2|s;s=r>>>4|r;r=s>>>8|s;s=(r>>>16|r)+1|0;p=s;q=Wia(c[d+36>>2]|0,s)|0;break}else{p=0;q=0}while(0);o=c[a>>2]|0;if((o|0)!=0?(YEi(q|0,o|0,g<<2|0)|0,g=c[a>>2]|0,(g|0)!=(d+4|0)):0)Xia(c[d+36>>2]|0,g,c[h>>2]|0);c[h>>2]=p;c[a>>2]=q;j=c[f>>2]|0;k=q;l=c[b>>2]|0;m=j+1|0;c[f>>2]=m;n=k+(j<<2)|0;c[n>>2]=l;i=e;return}function LZa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)ZCb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function MZa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)_Cb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function NZa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)$Cb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function OZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?476816:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function PZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?476688:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function QZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?476688:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function RZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?476816:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function SZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?476552:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else aDb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<5)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-32|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function TZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?476416:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else bDb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<6)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-64|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function UZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?476280:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else cDb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<7)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-128|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function VZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;dDb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else eDb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(fDb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,fDb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+32|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){aDb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function WZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;gDb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else hDb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(iDb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,iDb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+64|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){bDb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function XZa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;jDb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else kDb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(lDb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,lDb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+128|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){cDb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function YZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)mDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function ZZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)nDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function _Za(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)oDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function $Za(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)pDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b*36|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=d+16|0;o=d+20|0;p=d+24|0;q=d+28|0;r=d+32|0;s=f+(a*36|0)|0;do{if(s){g[s>>2]=ea(g[d>>2]);g[s+4>>2]=ea(g[k>>2]);g[s+8>>2]=ea(g[l>>2]);g[s+12>>2]=ea(g[m>>2]);g[s+16>>2]=ea(g[n>>2]);g[s+20>>2]=ea(g[o>>2]);g[s+24>>2]=ea(g[p>>2]);g[s+28>>2]=ea(g[q>>2]);g[s+32>>2]=ea(g[r>>2])}s=s+36|0}while(s>>>0<j>>>0);c[h>>2]=b;i=e;return}function a_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)qDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function b_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)rDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function c_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)vUa(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function d_a(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+152>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+144>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+140>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+132>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+128>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+120>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+116>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+108>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+104>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+96>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+92>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+84>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+80>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+72>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+68>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+60>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+56>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+48>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+44>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+36>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+32>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+24>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+20>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+12>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+8>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function e_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;d=ea(g[c>>2]);e=ea(g[c+12>>2]);f=ea(d+e);h=ea(g[c+4>>2]);i=ea(g[c+16>>2]);j=ea(h+i);k=ea(g[c+8>>2]);l=ea(g[c+20>>2]);m=ea(ea(f*ea(.5))*ea(2.0));f=ea(ea(j*ea(.5))*ea(2.0));j=ea(ea(ea(k+l)*ea(.5))*ea(2.0));n=ea(g[b+12>>2]);o=ea(ea(n*n)+ea(-.5));p=ea(g[b>>2]);q=ea(m*p);r=ea(g[b+4>>2]);s=ea(q+ea(f*r));q=ea(g[b+8>>2]);t=ea(s+ea(j*q));s=ea(ea(p*t)+ea(ea(m*o)+ea(n*ea(ea(j*r)-ea(f*q)))));u=ea(ea(r*t)+ea(ea(f*o)+ea(n*ea(ea(m*q)-ea(p*j)))));v=ea(ea(ea(j*o)+ea(n*ea(ea(f*p)-ea(m*r))))+ea(q*t));t=ea(ea(g[b+16>>2])+s);s=ea(ea(g[b+20>>2])+u);u=ea(ea(g[b+24>>2])+v);v=ea(p+p);m=ea(r+r);f=ea(q+q);o=ea(r*m);j=ea(q*f);w=ea(v*r);r=ea(v*q);x=ea(v*n);y=ea(m*q);q=ea(m*n);m=ea(f*n);n=ea(ea(1.0)-ea(p*v));v=ea(ea(e-d)*ea(.5));d=ea(ea(i-h)*ea(.5));h=ea(ea(l-k)*ea(.5));k=ea(ea(ea(S(ea(v*ea(ea(ea(1.0)-o)-j))))+ea(S(ea(d*ea(w-m)))))+ea(S(ea(h*ea(r+q)))));l=ea(ea(ea(S(ea(v*ea(w+m))))+ea(S(ea(d*ea(n-j)))))+ea(S(ea(h*ea(y-x)))));j=ea(ea(ea(S(ea(v*ea(r-q))))+ea(S(ea(d*ea(y+x)))))+ea(S(ea(h*ea(n-o)))));o=ea(s-l);n=ea(u-j);h=ea(t+k);x=ea(s+l);l=ea(u+j);g[a>>2]=ea(t-k);g[a+4>>2]=o;g[a+8>>2]=n;g[a+12>>2]=h;g[a+16>>2]=x;g[a+20>>2]=l;return}function f_a(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+72>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+64>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+60>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+52>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+48>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+40>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+36>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+28>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+24>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+16>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+12>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){i=b;return}d=c[a+4>>2]|0;if(!d){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,d);i=b;return}function g_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)sDb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function h_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<4,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?479464:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<4)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);g[k+12>>2]=ea(g[l+12>>2])}k=k+16|0;if(k>>>0>=j>>>0)break;else l=l+16|0}}if(j){g[j>>2]=ea(g[b>>2]);g[n+(f<<4)+4>>2]=ea(g[b+4>>2]);g[n+(f<<4)+8>>2]=ea(g[b+8>>2]);g[n+(f<<4)+12>>2]=ea(g[b+12>>2])}if((c[e>>2]|0)<=-1){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o<<4)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o<<4)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);o=c[m>>2]|0;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o<<4)|0;i=d;return q|0}function i_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[b+12>>2]);i=ea(d+d);j=ea(e+e);k=ea(f+f);l=ea(e*j);m=ea(f*k);n=ea(i*e);e=ea(i*f);o=ea(i*h);p=ea(j*f);f=ea(j*h);j=ea(k*h);h=ea(ea(ea(1.0)-l)-m);k=ea(n+j);q=ea(e-f);r=ea(n-j);j=ea(ea(1.0)-ea(d*i));i=ea(j-m);m=ea(p+o);d=ea(e+f);f=ea(p-o);o=ea(j-l);l=ea(g[c+12>>2]);j=ea(g[c+16>>2]);p=ea(g[c+20>>2]);e=ea(g[c+24>>2]);n=ea(l+l);s=ea(j+j);t=ea(p+p);u=ea(j*s);v=ea(p*t);w=ea(n*j);j=ea(n*p);x=ea(n*e);y=ea(s*p);p=ea(s*e);s=ea(t*e);e=ea(ea(ea(1.0)-u)-v);t=ea(w+s);z=ea(j-p);A=ea(w-s);s=ea(ea(1.0)-ea(l*n));n=ea(s-v);v=ea(y+x);l=ea(j+p);p=ea(y-x);x=ea(s-u);u=ea(g[c>>2]);s=ea(u*e);y=ea(u*A);j=ea(u*l);u=ea(g[c+4>>2]);w=ea(t*u);B=ea(n*u);C=ea(p*u);u=ea(g[c+8>>2]);D=ea(z*u);E=ea(v*u);F=ea(x*u);u=ea(ea(ea(e*s)+ea(t*w))+ea(z*D));G=ea(ea(ea(e*y)+ea(t*B))+ea(z*E));H=ea(ea(ea(e*j)+ea(t*C))+ea(z*F));z=ea(ea(ea(A*s)+ea(n*w))+ea(v*D));t=ea(ea(ea(A*y)+ea(n*B))+ea(v*E));e=ea(ea(ea(A*j)+ea(n*C))+ea(v*F));v=ea(ea(ea(l*s)+ea(p*w))+ea(x*D));D=ea(ea(ea(l*y)+ea(p*B))+ea(x*E));E=ea(ea(ea(l*j)+ea(p*C))+ea(x*F));F=ea(ea(f*H)+ea(ea(k*u)+ea(i*G)));x=ea(ea(o*H)+ea(ea(q*u)+ea(m*G)));C=ea(ea(d*e)+ea(ea(h*z)+ea(r*t)));p=ea(ea(f*e)+ea(ea(k*z)+ea(i*t)));j=ea(ea(o*e)+ea(ea(q*z)+ea(m*t)));t=ea(ea(d*E)+ea(ea(h*v)+ea(r*D)));z=ea(ea(f*E)+ea(ea(k*v)+ea(i*D)));i=ea(ea(o*E)+ea(ea(q*v)+ea(m*D)));g[a>>2]=ea(ea(d*H)+ea(ea(h*u)+ea(r*G)));g[a+4>>2]=F;g[a+8>>2]=x;g[a+12>>2]=C;g[a+16>>2]=p;g[a+20>>2]=j;g[a+24>>2]=t;g[a+28>>2]=z;g[a+32>>2]=i;g[a+36>>2]=ea(g[b+16>>2]);g[a+40>>2]=ea(g[b+20>>2]);g[a+44>>2]=ea(g[b+24>>2]);return}function j_a(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((c[a+8>>2]&2147483647)>>>0<d>>>0)tDb(a,d);h=c[a>>2]|0;j=a+4|0;a=c[j>>2]|0;k=h+(d<<2)|0;if((a|0)>=(d|0)){c[j>>2]=d;i=g;return}l=h+(a<<2)|0;do{if(l){a=e[f>>1]|e[f+2>>1]<<16;b[l>>1]=a;b[l+2>>1]=a>>>16}l=l+4|0}while(l>>>0<k>>>0);c[j>>2]=d;i=g;return}function k_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*12|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?516096:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*12|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2])}k=k+12|0;if(k>>>0>=e>>>0)break;else f=f+12|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function l_a(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=Im,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;d=i;if(a>>>0<b>>>0)e=a;else{i=d;return}do{f=ea(g[e>>2]);a=e+4|0;h=ea(g[a>>2]);j=e+8|0;k=ea(g[j>>2]);l=e+12|0;m=ea(g[l>>2]);n=e+16|0;o=ea(g[n>>2]);p=e+20|0;q=ea(g[p>>2]);r=e+24|0;s=ea(g[r>>2]);t=e+28|0;u=ea(g[t>>2]);v=e+32|0;w=ea(g[v>>2]);x=ea(m-f);y=ea(o-h);z=ea(q-k);A=ea(s-f);B=ea(u-h);C=ea(w-k);D=ea(ea(y*C)-ea(z*B));E=ea(ea(z*A)-ea(x*C));C=ea(ea(x*B)-ea(y*A));A=ea(ea(C*C)+ea(ea(D*D)+ea(E*E)));if(A>ea(0.0)){y=ea(ea(1.0)/ea(T(ea(A))));F=ea(D*y);G=ea(E*y);H=ea(C*y)}else{F=ea(0.0);G=ea(0.0);H=ea(0.0)}y=ea(F*c);C=ea(G*c);E=ea(H*c);D=ea(h+C);h=ea(k+E);g[e>>2]=ea(f+y);g[a>>2]=D;g[j>>2]=h;h=ea(o+C);o=ea(q+E);g[l>>2]=ea(m+y);g[n>>2]=h;g[p>>2]=o;o=ea(u+C);C=ea(w+E);g[r>>2]=ea(s+y);g[t>>2]=o;g[v>>2]=C;e=e+36|0}while(e>>>0<b>>>0);i=d;return}function m_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?479096:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function n_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?479464:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function o_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*48|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?479352:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*48|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);g[k+12>>2]=ea(g[l+12>>2]);g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);g[k+24>>2]=ea(g[l+24>>2]);g[k+28>>2]=ea(g[l+28>>2]);g[k+32>>2]=ea(g[l+32>>2]);g[k+36>>2]=ea(g[l+36>>2]);g[k+40>>2]=ea(g[l+40>>2]);g[k+44>>2]=ea(g[l+44>>2])}k=k+48|0;if(k>>>0>=j>>>0)break;else l=l+48|0}}if(j){g[j>>2]=ea(g[b>>2]);g[n+(f*48|0)+4>>2]=ea(g[b+4>>2]);g[n+(f*48|0)+8>>2]=ea(g[b+8>>2]);g[n+(f*48|0)+12>>2]=ea(g[b+12>>2]);g[n+(f*48|0)+16>>2]=ea(g[b+16>>2]);g[n+(f*48|0)+20>>2]=ea(g[b+20>>2]);g[n+(f*48|0)+24>>2]=ea(g[b+24>>2]);g[n+(f*48|0)+28>>2]=ea(g[b+28>>2]);g[n+(f*48|0)+32>>2]=ea(g[b+32>>2]);g[n+(f*48|0)+36>>2]=ea(g[b+36>>2]);g[n+(f*48|0)+40>>2]=ea(g[b+40>>2]);g[n+(f*48|0)+44>>2]=ea(g[b+44>>2])}if((c[e>>2]|0)<=-1){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*48|0)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){o=f;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*48|0)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);o=c[m>>2]|0;c[a>>2]=n;c[e>>2]=h;p=o+1|0;c[m>>2]=p;q=n+(o*48|0)|0;i=d;return q|0}function p_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)uDb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function q_a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0;f=i;i=i+32|0;h=f;if((d|0)==(e|0)){j=ea(3402823469999999843913219.0e14);k=ea(3402823469999999843913219.0e14);l=ea(3402823469999999843913219.0e14);m=ea(-3402823469999999843913219.0e14);n=ea(-3402823469999999843913219.0e14);o=ea(-3402823469999999843913219.0e14)}else{p=d;q=ea(3402823469999999843913219.0e14);r=ea(-3402823469999999843913219.0e14);s=ea(-3402823469999999843913219.0e14);t=ea(-3402823469999999843913219.0e14);u=ea(3402823469999999843913219.0e14);v=ea(3402823469999999843913219.0e14);while(1){w=ea(g[p>>2]);x=u<w?u:w;y=ea(g[p+4>>2]);z=v<y?v:y;A=ea(g[p+8>>2]);B=q<A?q:A;C=r>w?r:w;w=s>y?s:y;y=t>A?t:A;p=p+16|0;if((p|0)==(e|0)){j=B;k=z;l=x;m=y;n=w;o=C;break}else{q=B;r=C;s=w;t=y;u=x;v=z}}}v=ea(ea(k+n)*ea(.5));u=ea(ea(j+m)*ea(.5));t=ea(ea(o-l)*ea(.5));s=ea(ea(n-k)*ea(.5));k=ea(ea(m-j)*ea(.5));g[b+32>>2]=ea(ea(l+o)*ea(.5));g[b+36>>2]=v;g[b+40>>2]=u;g[b+44>>2]=t;g[b+48>>2]=s;g[b+52>>2]=k;e=b+104|0;p=b+56|0;d=p+48|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(d|0));g[e>>2]=ea(1.0);g[b+108>>2]=ea(1.0);g[b+112>>2]=ea(1.0);g[b+116>>2]=ea(1.0);g[b+120>>2]=ea(1.0);g[b+124>>2]=ea(1.0);g[b+128>>2]=ea(1.0);g[b+132>>2]=ea(1.0);g[b+136>>2]=ea(1.0);g[b+140>>2]=ea(60.0);g[b+144>>2]=ea(10.0);g[b+148>>2]=ea(0.0);g[b+152>>2]=ea(0.0);g[b+156>>2]=ea(0.0);g[b+160>>2]=ea(1.0);e=b+164|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+188>>2]=ea(1.0);e=b+232|0;D=h+16|0;p=b+192|0;d=p+40|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(d|0));c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[D>>2]=30;if((h|0)==(e|0))E=0;else{c[b+236>>2]=0;E=c[h+8>>2]|0}e=h+12|0;D=c[e+4>>2]|0;p=b+244|0;c[p>>2]=c[e>>2];c[p+4>>2]=D;if((E&2147483647|0)!=0&(E|0)>-1)VJa(h,c[h>>2]|0);g[b+264>>2]=ea(-128.0);g[b+268>>2]=ea(1.0);g[b+296>>2]=ea(1.0);g[b+300>>2]=ea(0.0);g[b+304>>2]=ea(-128.0);a[b+440>>0]=0;g[b+444>>2]=ea(0.0);g[b+448>>2]=ea(0.0);g[b+480>>2]=ea(0.0);g[b+484>>2]=ea(-128.0);c[b+512>>2]=-1;c[b+516>>2]=-1;g[b+520>>2]=ea(0.0);c[b+524>>2]=0;c[b+528>>2]=0;i=f;return}function r_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;if((b|0)!=0?(e=UJa(a,(b<<4)+19|0,537640,558)|0,(e|0)!=0):0){f=e+19&-16;c[f+-4>>2]=f-e;h=f}else h=0;f=c[a+4>>2]|0;e=h+(f<<4)|0;if((f|0)>0){f=h;j=c[a>>2]|0;while(1){if(f){g[f>>2]=ea(g[j>>2]);g[f+4>>2]=ea(g[j+4>>2]);g[f+8>>2]=ea(g[j+8>>2]);g[f+12>>2]=ea(g[j+12>>2])}f=f+16|0;if(f>>>0>=e>>>0)break;else j=j+16|0}}j=a+8|0;if((c[j>>2]|0)<=-1){c[a>>2]=h;c[j>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=h;c[j>>2]=b;i=d;return}VJa(a,e+(0-(c[e+-4>>2]|0))|0);c[a>>2]=h;c[j>>2]=b;i=d;return}function s_a(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)r_a(a,b);c[a+4>>2]=b;i=d;return}function t_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)r_a(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<4)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=f+(a<<4)|0;do{if(n){g[n>>2]=ea(g[d>>2]);g[n+4>>2]=ea(g[k>>2]);g[n+8>>2]=ea(g[l>>2]);g[n+12>>2]=ea(g[m>>2])}n=n+16|0}while(n>>>0<j>>>0);c[h>>2]=b;i=e;return}function u_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+4>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=UJa(a,e*20|0,537640,558)|0;c[a>>2]=g;a=g+((c[f>>2]|0)*20|0)|0;if(g>>>0>=a>>>0){i=d;return}f=g;g=c[b>>2]|0;while(1){if(f){c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2]}f=f+20|0;if(f>>>0>=a>>>0)break;else g=g+20|0}i=d;return}function v_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b+4>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=UJa(a,e<<3,537640,558)|0;c[a>>2]=g;a=g+(c[f>>2]<<3)|0;if(g>>>0>=a>>>0){i=d;return}f=g;g=c[b>>2]|0;while(1){if(f){b=g;e=c[b+4>>2]|0;h=f;c[h>>2]=c[b>>2];c[h+4>>2]=e}f=f+8|0;if(f>>>0>=a>>>0)break;else g=g+8|0}i=d;return}function w_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;e=c[b+4>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;h=UJa(a,(e<<4)+19|0,537640,558)|0;if(!h)j=0;else{e=h+19&-16;c[e+-4>>2]=e-h;j=e}c[a>>2]=j;a=c[f>>2]|0;f=j+(a<<4)|0;if((a|0)<=0){i=d;return}a=j;j=c[b>>2]|0;while(1){if(a){g[a>>2]=ea(g[j>>2]);g[a+4>>2]=ea(g[j+4>>2]);g[a+8>>2]=ea(g[j+8>>2]);g[a+12>>2]=ea(g[j+12>>2])}a=a+16|0;if(a>>>0>=f>>>0)break;else j=j+16|0}i=d;return}function x_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0;d=i;e=c[b+4>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;h=UJa(a,e*12|0,537640,558)|0;c[a>>2]=h;a=h+((c[f>>2]|0)*12|0)|0;if(h>>>0>=a>>>0){i=d;return}f=h;h=c[b>>2]|0;while(1){if(f){g[f>>2]=ea(g[h>>2]);g[f+4>>2]=ea(g[h+4>>2]);g[f+8>>2]=ea(g[h+8>>2])}f=f+12|0;if(f>>>0>=a>>>0)break;else h=h+12|0}i=d;return}function y_a(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[d+4>>2]|0;if(!g){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=f;return}c[a+8>>2]=g;h=a+4|0;c[h>>2]=g;j=UJa(a,g<<3,537640,558)|0;c[a>>2]=j;a=j+(c[h>>2]<<3)|0;if(j>>>0>=a>>>0){i=f;return}h=j;j=c[d>>2]|0;while(1){if(h){d=j;g=d;k=e[g>>1]|e[g+2>>1]<<16;g=d+4|0;d=e[g>>1]|e[g+2>>1]<<16;g=h;l=g;b[l>>1]=k;b[l+2>>1]=k>>>16;k=g+4|0;b[k>>1]=d;b[k+2>>1]=d>>>16}h=h+8|0;if(h>>>0>=a>>>0)break;else j=j+8|0}i=f;return}function z_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+4>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=UJa(a,e<<2,537640,558)|0;c[a>>2]=g;a=g+(c[f>>2]<<2)|0;if(g>>>0>=a>>>0){i=d;return}f=g;g=c[b>>2]|0;while(1){if(f)c[f>>2]=c[g>>2];f=f+4|0;if(f>>>0>=a>>>0)break;else g=g+4|0}i=d;return}function A_a(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;g[b+32>>2]=ea(g[d+32>>2]);g[b+36>>2]=ea(g[d+36>>2]);g[b+40>>2]=ea(g[d+40>>2]);g[b+44>>2]=ea(g[d+44>>2]);g[b+48>>2]=ea(g[d+48>>2]);g[b+52>>2]=ea(g[d+52>>2]);g[b+56>>2]=ea(g[d+56>>2]);g[b+60>>2]=ea(g[d+60>>2]);g[b+64>>2]=ea(g[d+64>>2]);g[b+68>>2]=ea(g[d+68>>2]);g[b+72>>2]=ea(g[d+72>>2]);g[b+76>>2]=ea(g[d+76>>2]);g[b+80>>2]=ea(g[d+80>>2]);g[b+84>>2]=ea(g[d+84>>2]);g[b+88>>2]=ea(g[d+88>>2]);g[b+92>>2]=ea(g[d+92>>2]);g[b+96>>2]=ea(g[d+96>>2]);g[b+100>>2]=ea(g[d+100>>2]);g[b+104>>2]=ea(g[d+104>>2]);g[b+108>>2]=ea(g[d+108>>2]);g[b+112>>2]=ea(g[d+112>>2]);g[b+116>>2]=ea(g[d+116>>2]);g[b+120>>2]=ea(g[d+120>>2]);g[b+124>>2]=ea(g[d+124>>2]);g[b+128>>2]=ea(g[d+128>>2]);g[b+132>>2]=ea(g[d+132>>2]);g[b+136>>2]=ea(g[d+136>>2]);g[b+140>>2]=ea(g[d+140>>2]);g[b+144>>2]=ea(g[d+144>>2]);g[b+148>>2]=ea(g[d+148>>2]);g[b+152>>2]=ea(g[d+152>>2]);g[b+156>>2]=ea(g[d+156>>2]);g[b+160>>2]=ea(g[d+160>>2]);g[b+164>>2]=ea(g[d+164>>2]);g[b+168>>2]=ea(g[d+168>>2]);g[b+172>>2]=ea(g[d+172>>2]);g[b+176>>2]=ea(g[d+176>>2]);g[b+180>>2]=ea(g[d+180>>2]);g[b+184>>2]=ea(g[d+184>>2]);g[b+188>>2]=ea(g[d+188>>2]);g[b+192>>2]=ea(g[d+192>>2]);g[b+196>>2]=ea(g[d+196>>2]);g[b+200>>2]=ea(g[d+200>>2]);g[b+204>>2]=ea(g[d+204>>2]);g[b+208>>2]=ea(g[d+208>>2]);g[b+212>>2]=ea(g[d+212>>2]);g[b+216>>2]=ea(g[d+216>>2]);g[b+220>>2]=ea(g[d+220>>2]);g[b+224>>2]=ea(g[d+224>>2]);g[b+228>>2]=ea(g[d+228>>2]);f=b+232|0;if((d|0)!=(b|0)){h=b+236|0;c[h>>2]=0;j=d+236|0;k=c[j>>2]|0;if((c[b+240>>2]&2147483647)>>>0<k>>>0){vDb(f,k);l=c[j>>2]|0}else l=k;k=c[f>>2]|0;f=k+(l<<3)|0;if((l|0)>0){m=k;k=c[d+232>>2]|0;while(1){if(m){n=k;o=c[n+4>>2]|0;p=m;c[p>>2]=c[n>>2];c[p+4>>2]=o}m=m+8|0;if(m>>>0>=f>>>0)break;else k=k+8|0}q=c[j>>2]|0}else q=l;c[h>>2]=q}q=d+244|0;h=c[q+4>>2]|0;l=b+244|0;c[l>>2]=c[q>>2];c[l+4>>2]=h;g[b+264>>2]=ea(g[d+264>>2]);g[b+268>>2]=ea(g[d+268>>2]);g[b+296>>2]=ea(g[d+296>>2]);g[b+300>>2]=ea(g[d+300>>2]);g[b+304>>2]=ea(g[d+304>>2]);a[b+440>>0]=a[d+440>>0]|0;g[b+444>>2]=ea(g[d+444>>2]);g[b+448>>2]=ea(g[d+448>>2]);g[b+480>>2]=ea(g[d+480>>2]);g[b+484>>2]=ea(g[d+484>>2]);c[b+512>>2]=c[d+512>>2];c[b+516>>2]=c[d+516>>2];g[b+520>>2]=ea(g[d+520>>2]);c[b+524>>2]=c[d+524>>2];c[b+528>>2]=c[d+528>>2];c[b+532>>2]=c[d+532>>2];i=e;return}function B_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;h=b+8|0;j=c[h>>2]&2147483647;if((c[a+8>>2]&2147483647)>>>0<j>>>0)r_a(a,j);j=c[b>>2]|0;k=b+4|0;s_a(a,c[k>>2]<<4>>4);b=c[a>>2]|0;l=c[a+4>>2]|0;m=b+(l<<4)|0;if((l|0)>0){l=b;b=j;while(1){if(l){g[l>>2]=ea(g[b>>2]);g[l+4>>2]=ea(g[b+4>>2]);g[l+8>>2]=ea(g[b+8>>2]);g[l+12>>2]=ea(g[b+12>>2])}l=l+16|0;if(l>>>0>=m>>>0)break;else b=b+16|0}}b=c[h>>2]&2147483647;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;t_a(a,b,e);t_a(a,c[k>>2]|0,f);i=d;return}function C_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)wDb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b*20|0)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a*20|0)|0;do{if(j){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2]}j=j+20|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function D_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else h=UJa(a,g*20|0,537640,558)|0;f=a+4|0;j=c[f>>2]|0;k=h+(j*20|0)|0;if((j|0)>0){l=h;m=c[a>>2]|0;while(1){if(l){c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2]}l=l+20|0;if(l>>>0>=k>>>0)break;else m=m+20|0}n=c[f>>2]|0}else n=j;j=h+(n*20|0)|0;if(j){c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=h;c[e>>2]=g;o=c[f>>2]|0;p=o+1|0;c[f>>2]=p;q=h+(o*20|0)|0;i=d;return q|0}VJa(a,c[a>>2]|0);c[a>>2]=h;c[e>>2]=g;o=c[f>>2]|0;p=o+1|0;c[f>>2]=p;q=h+(o*20|0)|0;i=d;return q|0}function E_a(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)L_a(a,b);c[a+4>>2]=b;i=d;return}function F_a(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;if((c[a+8>>2]&2147483647)>>>0<d>>>0)G_a(a,d);h=c[a>>2]|0;j=a+4|0;a=c[j>>2]|0;k=h+(d<<3)|0;if((a|0)>=(d|0)){c[j>>2]=d;i=g;return}l=h+(a<<3)|0;do{if(l){a=f;h=a;m=e[h>>1]|e[h+2>>1]<<16;h=a+4|0;a=e[h>>1]|e[h+2>>1]<<16;h=l;n=h;b[n>>1]=m;b[n+2>>1]=m>>>16;m=h+4|0;b[m>>1]=a;b[m+2>>1]=a>>>16}l=l+8|0}while(l>>>0<k>>>0);c[j>>2]=d;i=g;return}function G_a(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if(!d)g=0;else g=UJa(a,d<<3,537640,558)|0;h=c[a+4>>2]|0;j=g+(h<<3)|0;if((h|0)>0){h=g;k=c[a>>2]|0;while(1){if(h){l=k;m=l;n=e[m>>1]|e[m+2>>1]<<16;m=l+4|0;l=e[m>>1]|e[m+2>>1]<<16;m=h;o=m;b[o>>1]=n;b[o+2>>1]=n>>>16;n=m+4|0;b[n>>1]=l;b[n+2>>1]=l>>>16}h=h+8|0;if(h>>>0>=j>>>0)break;else k=k+8|0}}k=a+8|0;if((c[k>>2]|0)<=-1){c[a>>2]=g;c[k>>2]=d;i=f;return}VJa(a,c[a>>2]|0);c[a>>2]=g;c[k>>2]=d;i=f;return}function H_a(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=a+8|0;h=c[g>>2]|0;j=(h&2147483647|0)==0?1:h<<1;if(!j)k=0;else k=UJa(a,j<<3,537640,558)|0;h=a+4|0;l=c[h>>2]|0;m=k+(l<<3)|0;if((l|0)>0){n=k;o=c[a>>2]|0;while(1){if(n){p=o;q=p;r=e[q>>1]|e[q+2>>1]<<16;q=p+4|0;p=e[q>>1]|e[q+2>>1]<<16;q=n;s=q;b[s>>1]=r;b[s+2>>1]=r>>>16;r=q+4|0;b[r>>1]=p;b[r+2>>1]=p>>>16}n=n+8|0;if(n>>>0>=m>>>0)break;else o=o+8|0}t=c[h>>2]|0}else t=l;l=k+(t<<3)|0;if(l){t=d;d=t;o=e[d>>1]|e[d+2>>1]<<16;d=t+4|0;t=e[d>>1]|e[d+2>>1]<<16;d=l;l=d;b[l>>1]=o;b[l+2>>1]=o>>>16;o=d+4|0;b[o>>1]=t;b[o+2>>1]=t>>>16}if((c[g>>2]|0)<=-1){c[a>>2]=k;c[g>>2]=j;u=c[h>>2]|0;v=u+1|0;c[h>>2]=v;w=k+(u<<3)|0;i=f;return w|0}VJa(a,c[a>>2]|0);c[a>>2]=k;c[g>>2]=j;u=c[h>>2]|0;v=u+1|0;c[h>>2]=v;w=k+(u<<3)|0;i=f;return w|0}function I_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=UJa(a,(h<<4)+19|0,537640,558)|0,(f|0)!=0):0){j=f+19&-16;c[j+-4>>2]=j-f;k=j}else k=0;j=a+4|0;f=c[j>>2]|0;l=k+(f<<4)|0;if((f|0)>0){m=k;n=c[a>>2]|0;while(1){if(m){g[m>>2]=ea(g[n>>2]);g[m+4>>2]=ea(g[n+4>>2]);g[m+8>>2]=ea(g[n+8>>2]);g[m+12>>2]=ea(g[n+12>>2])}m=m+16|0;if(m>>>0>=l>>>0)break;else n=n+16|0}}if(l){g[l>>2]=ea(g[b>>2]);g[k+(f<<4)+4>>2]=ea(g[b+4>>2]);g[k+(f<<4)+8>>2]=ea(g[b+8>>2]);g[k+(f<<4)+12>>2]=ea(g[b+12>>2])}if((c[e>>2]|0)<=-1){o=f;c[a>>2]=k;c[e>>2]=h;p=o+1|0;c[j>>2]=p;q=k+(o<<4)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){o=f;c[a>>2]=k;c[e>>2]=h;p=o+1|0;c[j>>2]=p;q=k+(o<<4)|0;i=d;return q|0}VJa(a,b+(0-(c[b+-4>>2]|0))|0);o=c[j>>2]|0;c[a>>2]=k;c[e>>2]=h;p=o+1|0;c[j>>2]=p;q=k+(o<<4)|0;i=d;return q|0}function J_a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;h=d+(e<<3)|0;if(!e){i=f;return}else{j=a;k=d}while(1){d=c[k>>2]|0;l=ea(g[b+(d<<4)>>2]);m=ea(g[b+(d<<4)+4>>2]);n=ea(g[b+(d<<4)+8>>2]);o=ea(g[b+(d<<4)+12>>2]);a=k+4|0;e=c[a>>2]|0;p=ea(g[b+(e<<4)>>2]);q=ea(g[b+(e<<4)+4>>2]);r=ea(g[b+(e<<4)+8>>2]);s=ea(ea(l+p)*ea(.5));t=ea(ea(m+q)*ea(.5));u=ea(ea(n+r)*ea(.5));v=ea(ea(p-l)*ea(.5));l=ea(ea(q-m)*ea(.5));m=ea(ea(r-n)*ea(.5));n=ea(ea(ea(g[b+(e<<4)+12>>2])-o)*ea(.5));r=ea(ea(ea(v*v)+ea(l*l))+ea(m*m));q=ea(r-ea(n*n));p=ea(ea(1.0)/ea(T(ea(r))));w=ea(ea(1.0)/ea(T(ea(q))));e=!(q<=ea(0.0));q=e?w:ea(0.0);w=e?p:ea(0.0);p=ea(r*w);r=ea(n*q);g[j>>2]=s;g[j+4>>2]=t;g[j+8>>2]=u;g[j+12>>2]=ea(ea(ea(o+n)*q)*p);q=ea(l*w);l=ea(m*w);g[j+16>>2]=ea(v*w);g[j+20>>2]=q;g[j+24>>2]=l;g[j+28>>2]=r;r=ea(n*w);g[j+32>>2]=ea(ea(1.0)-ea(r*r));g[j+36>>2]=p;e=1<<d;c[j+40>>2]=e;c[j+44>>2]=1<<c[a>>2]|e;k=k+8|0;if((k|0)==(h|0))break;else j=j+48|0}i=f;return}function K_a(a,b,d,e,f,h,j,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im;q=i;r=ea(g[a>>2]);s=ea(r*r);t=ea(g[a+4>>2]);u=ea(t*t);v=ea(g[a+8>>2]);w=ea(v*v);x=ea(g[a+12>>2]);y=ea(x*x);z=ea(g[b>>2]);A=ea(z*z);B=ea(g[b+4>>2]);C=ea(B*B);D=ea(g[b+8>>2]);E=ea(D*D);F=ea(g[b+12>>2]);G=ea(s+A);A=ea(u+C);C=ea(w+E);E=ea(y+ea(F*F));y=ea(g[d>>2]);w=ea(y*y);u=ea(g[d+4>>2]);s=ea(u*u);H=ea(g[d+8>>2]);I=ea(H*H);J=ea(g[d+12>>2]);K=ea(G+w);w=ea(A+s);s=ea(C+I);I=ea(E+ea(J*J));E=ea(g[119914]);C=ea(K+E);A=ea(g[119915]);G=ea(w+A);L=ea(g[119916]);M=ea(s+L);N=ea(g[119917]);O=ea(ea(1.0)/ea(T(ea(C))));C=ea(ea(1.0)/ea(T(ea(G))));G=ea(ea(1.0)/ea(T(ea(M))));M=ea(ea(1.0)/ea(T(ea(I+N))));P=ea(r*O);r=ea(t*C);t=ea(v*G);v=ea(x*M);x=ea(z*O);z=ea(B*C);B=ea(D*G);D=ea(F*M);F=ea(y*O);y=ea(u*C);u=ea(H*G);H=ea(J*M);J=ea(g[j>>2]);Q=ea(J-ea(g[l>>2]));J=ea(g[j+4>>2]);R=ea(J-ea(g[l+4>>2]));J=ea(g[j+8>>2]);S=ea(J-ea(g[l+8>>2]));J=ea(g[j+12>>2]);U=ea(J-ea(g[l+12>>2]));J=ea(g[e>>2]);V=ea(g[m>>2]);W=ea(J*V);J=ea(g[e+4>>2]);X=ea(g[m+4>>2]);Y=ea(J*X);J=ea(g[e+8>>2]);Z=ea(g[m+8>>2]);_=ea(J*Z);J=ea(g[e+12>>2]);$=ea(g[m+12>>2]);aa=ea(Q-W);W=ea(R-Y);Y=ea(S-_);_=ea(U-ea(J*$));J=ea(g[j+16>>2]);U=ea(J-ea(g[l+16>>2]));J=ea(g[j+20>>2]);S=ea(J-ea(g[l+20>>2]));J=ea(g[j+24>>2]);R=ea(J-ea(g[l+24>>2]));J=ea(g[j+28>>2]);Q=ea(J-ea(g[l+28>>2]));J=ea(V*ea(g[f>>2]));ba=ea(X*ea(g[f+4>>2]));ca=ea(Z*ea(g[f+8>>2]));da=ea(U-J);J=ea(S-ba);ba=ea(R-ca);ca=ea(Q-ea($*ea(g[f+12>>2])));Q=ea(g[j+32>>2]);R=ea(Q-ea(g[l+32>>2]));Q=ea(g[j+36>>2]);S=ea(Q-ea(g[l+36>>2]));Q=ea(g[j+40>>2]);U=ea(Q-ea(g[l+40>>2]));Q=ea(g[j+44>>2]);fa=ea(Q-ea(g[l+44>>2]));Q=ea(V*ea(g[h>>2]));V=ea(X*ea(g[h+4>>2]));X=ea(Z*ea(g[h+8>>2]));Z=ea(R-Q);Q=ea(S-V);V=ea(U-X);X=ea(fa-ea($*ea(g[h+12>>2])));$=ea(ea(ea(P*aa)+ea(x*da))+ea(F*Z));fa=ea(ea(ea(r*W)+ea(z*J))+ea(y*Q));U=ea(ea(ea(t*Y)+ea(B*ba))+ea(u*V));S=ea(ea(ea(v*_)+ea(D*ca))+ea(H*X));R=ea(aa-ea(P*$));P=ea(W-ea(r*fa));r=ea(Y-ea(t*U));t=ea(_-ea(v*S));v=ea(da-ea(x*$));x=ea(J-ea(z*fa));z=ea(ba-ea(B*U));B=ea(ca-ea(D*S));D=ea(Z-ea(F*$));$=ea(Q-ea(y*fa));fa=ea(V-ea(u*U));U=ea(X-ea(H*S));S=ea(ea(1.0)/ea(T(ea(E+ea(ea(D*D)+ea(ea(R*R)+ea(v*v)))))));E=ea(ea(1.0)/ea(T(ea(A+ea(ea($*$)+ea(ea(P*P)+ea(x*x)))))));A=ea(ea(1.0)/ea(T(ea(L+ea(ea(fa*fa)+ea(ea(r*r)+ea(z*z)))))));L=ea(ea(1.0)/ea(T(ea(N+ea(ea(U*U)+ea(ea(t*t)+ea(B*B)))))));N=ea(g[n>>2]);H=ea(g[n+4>>2]);X=ea(g[n+8>>2]);u=ea(-ea(S*ea(O*ea(K*N))));N=ea(-ea(E*ea(C*ea(w*H))));H=ea(-ea(A*ea(G*ea(s*X))));X=ea(-ea(L*ea(M*ea(I*ea(g[n+12>>2])))));I=ea(g[119942]);M=ea(g[119943]);L=ea(g[119944]);s=ea(g[119945]);n=(g[k>>2]=I>u?I:u,c[k>>2]|0);h=(g[k>>2]=M>N?M:N,c[k>>2]|0);l=(g[k>>2]=L>H?L:H,c[k>>2]|0);j=c[o+12>>2]&(g[k>>2]=s>X?s:X,c[k>>2]|0);X=(c[k>>2]=c[o>>2]&n,ea(g[k>>2]));s=ea(R*X);R=(c[k>>2]=c[o+4>>2]&h,ea(g[k>>2]));H=ea(P*R);P=(c[k>>2]=c[o+8>>2]&l,ea(g[k>>2]));L=ea(r*P);r=(c[k>>2]=j,ea(g[k>>2]));N=ea(t*r);t=ea(s);s=ea(H);H=ea(L);L=ea(N);g[p>>2]=t;g[p+4>>2]=s;g[p+8>>2]=H;g[p+12>>2]=L;L=ea(v*X);v=ea(x*R);x=ea(z*P);z=ea(B*r);B=ea(L);L=ea(v);v=ea(x);x=ea(z);g[p+16>>2]=B;g[p+20>>2]=L;g[p+24>>2]=v;g[p+28>>2]=x;x=ea(D*X);X=ea($*R);R=ea(fa*P);P=ea(U*r);r=ea(x);x=ea(X);X=ea(R);R=ea(P);g[p+32>>2]=r;g[p+36>>2]=x;g[p+40>>2]=X;g[p+44>>2]=R;i=q;return}function L_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b)e=0;else e=UJa(a,b<<2,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<2)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f)c[f>>2]=c[h>>2];f=f+4|0;if(f>>>0>=g>>>0)break;else h=h+4|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function M_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else h=UJa(a,g<<2,537640,558)|0;f=a+4|0;j=c[f>>2]|0;k=h+(j<<2)|0;if((j|0)>0){l=h;m=c[a>>2]|0;while(1){if(l)c[l>>2]=c[m>>2];l=l+4|0;if(l>>>0>=k>>>0)break;else m=m+4|0}n=c[f>>2]|0}else n=j;j=h+(n<<2)|0;if(j)c[j>>2]=c[b>>2];if((c[e>>2]|0)<=-1){c[a>>2]=h;c[e>>2]=g;o=c[f>>2]|0;p=o+1|0;c[f>>2]=p;q=h+(o<<2)|0;i=d;return q|0}VJa(a,c[a>>2]|0);c[a>>2]=h;c[e>>2]=g;o=c[f>>2]|0;p=o+1|0;c[f>>2]=p;q=h+(o<<2)|0;i=d;return q|0}function N_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=UJa(a,(h<<2)+19|0,537640,558)|0,(f|0)!=0):0){j=f+19&-16;c[j+-4>>2]=j-f;k=j}else k=0;j=a+4|0;f=c[j>>2]|0;l=k+(f<<2)|0;if((f|0)>0){m=k;n=c[a>>2]|0;while(1){if(m)g[m>>2]=ea(g[n>>2]);m=m+4|0;if(m>>>0>=l>>>0)break;else n=n+4|0}}if(l)g[l>>2]=ea(g[b>>2]);if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){VJa(a,b+(0-(c[b+-4>>2]|0))|0);o=c[j>>2]|0}else o=f;c[a>>2]=k;c[e>>2]=h;c[j>>2]=o+1;i=d;return k+(o<<2)|0}function O_a(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=a+8|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else j=UJa(a,h<<1,537640,558)|0;g=a+4|0;k=c[g>>2]|0;l=j+(k<<1)|0;if((k|0)>0){m=j;n=c[a>>2]|0;while(1){if(m)b[m>>1]=b[n>>1]|0;m=m+2|0;if(m>>>0>=l>>>0)break;else n=n+2|0}}if(l)b[l>>1]=b[d>>1]|0;if((c[f>>2]|0)<=-1){o=k;c[a>>2]=j;c[f>>2]=h;p=o+1|0;c[g>>2]=p;q=j+(o<<1)|0;i=e;return q|0}VJa(a,c[a>>2]|0);o=c[g>>2]|0;c[a>>2]=j;c[f>>2]=h;p=o+1|0;c[g>>2]=p;q=j+(o<<1)|0;i=e;return q|0}function P_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(!b)e=0;else e=UJa(a,b<<3,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<3)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f){j=h;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k}f=f+8|0;if(f>>>0>=g>>>0)break;else h=h+8|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function Q_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else h=UJa(a,g<<3,537640,558)|0;f=a+4|0;j=c[f>>2]|0;k=h+(j<<3)|0;if((j|0)>0){l=h;m=c[a>>2]|0;while(1){if(l){n=m;o=c[n+4>>2]|0;p=l;c[p>>2]=c[n>>2];c[p+4>>2]=o}l=l+8|0;if(l>>>0>=k>>>0)break;else m=m+8|0}q=c[f>>2]|0}else q=j;j=h+(q<<3)|0;if(j){q=b;b=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=b}if((c[e>>2]|0)<=-1){c[a>>2]=h;c[e>>2]=g;r=c[f>>2]|0;s=r+1|0;c[f>>2]=s;t=h+(r<<3)|0;i=d;return t|0}VJa(a,c[a>>2]|0);c[a>>2]=h;c[e>>2]=g;r=c[f>>2]|0;s=r+1|0;c[f>>2]=s;t=h+(r<<3)|0;i=d;return t|0}function R_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else h=UJa(a,g<<2,537640,558)|0;f=a+4|0;j=c[f>>2]|0;k=h+(j<<2)|0;if((j|0)>0){l=h;m=c[a>>2]|0;while(1){if(l)c[l>>2]=c[m>>2];l=l+4|0;if(l>>>0>=k>>>0)break;else m=m+4|0}}if(k)c[k>>2]=c[b>>2];if((c[e>>2]|0)<=-1){n=j;c[a>>2]=h;c[e>>2]=g;o=n+1|0;c[f>>2]=o;p=h+(n<<2)|0;i=d;return p|0}VJa(a,c[a>>2]|0);n=c[f>>2]|0;c[a>>2]=h;c[e>>2]=g;o=n+1|0;c[f>>2]=o;p=h+(n<<2)|0;i=d;return p|0}function S_a(a,b,d,f,g){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=i;i=i+80|0;j=h+52|0;k=h+32|0;l=h+16|0;m=h;n=c[a+48>>2]|0;o=c[n+4>>2]|0;p=c[n+240>>2]|0;q=c[b>>2]|0;r=q&65535;s=r>>>0>g>>>0?g:r;r=q+g|0;t=q|65535;u=r>>>0<t>>>0?r:t;c[j>>2]=b;t=q;r=b;while(1){v=r+4|0;if(t>>>0>=u>>>0)break;t=c[v>>2]|0;r=v}v=q-s|0;c[k>>2]=r;s=v+65536|0;w=t;x=r;while(1){y=x+4|0;if(w>>>0>=s>>>0)break;w=c[y>>2]|0;x=y}c[j+4>>2]=x;s=u+65536|0;y=w;w=x;while(1){x=w+4|0;if(y>>>0>=s>>>0)break;y=c[x>>2]|0;w=x}c[k+4>>2]=w;w=v+16711680|0;y=b+((d&65535)<<2)|0;while(1){z=c[y>>2]|0;if(z>>>0<w>>>0)y=y+4|0;else break}c[j+8>>2]=y;w=u+16711680|0;d=z;z=y;while(1){y=z+4|0;if(d>>>0>=w>>>0)break;d=c[y>>2]|0;z=y}c[k+8>>2]=z;z=v+16777216|0;d=q;w=b;while(1){y=w+4|0;if(d>>>0>=z>>>0)break;d=c[y>>2]|0;w=y}c[j+12>>2]=w;z=u+16777216|0;y=d;d=w;while(1){w=d+4|0;if(y>>>0>=z>>>0)break;y=c[w>>2]|0;d=w}c[k+12>>2]=d;d=v+16842752|0;v=q;y=b;while(1){z=y+4|0;if(v>>>0>=d>>>0)break;v=c[z>>2]|0;y=z}c[j+16>>2]=y;d=u+16842752|0;u=v;v=y;while(1){y=v+4|0;if(u>>>0>=d>>>0)break;u=c[y>>2]|0;v=y}c[k+16>>2]=v;v=c[n+232>>2]|0;n=f+(v<<1)|0;if(!v){i=h;return}v=l+4|0;u=l+8|0;d=l+12|0;y=m+4|0;z=m+8|0;w=m+12|0;s=b;b=r;r=q;q=t;t=f;while(1){x=e[t>>1]|0;c[l>>2]=c[o+(x<<4)>>2];c[v>>2]=c[o+(x<<4)+4>>2];c[u>>2]=c[o+(x<<4)+8>>2];c[d>>2]=c[o+(x<<4)+12>>2];c[m>>2]=c[p+(x<<4)>>2];c[y>>2]=c[p+(x<<4)+4>>2];c[z>>2]=c[p+(x<<4)+8>>2];c[w>>2]=c[p+(x<<4)+12>>2];x=r&65535;A=r-(x>>>0>g>>>0?g:x)|0;x=r+g|0;B=r|65535;C=x>>>0<B>>>0?x:B;if(q>>>0<C>>>0){B=b;do B=B+4|0;while((c[B>>2]|0)>>>0<C>>>0);c[k>>2]=B;D=B}else D=b;x=f+(D-s>>2<<1)|0;E=t+2|0;if((E|0)==(x|0))F=1;else{G=E;do{H=e[G>>1]|0;xDb(a,l,o+(H<<4)|0,m,p+(H<<4)|0);G=G+2|0}while((G|0)!=(x|0));F=1}do{x=c[481152+(F<<2)>>2]|0;G=A+x|0;B=j+(F<<2)|0;H=c[B>>2]|0;if((c[H>>2]|0)>>>0<G>>>0){I=H;do I=I+4|0;while((c[I>>2]|0)>>>0<G>>>0);c[B>>2]=I;J=I}else J=H;G=x+C|0;K=k+(F<<2)|0;L=c[K>>2]|0;if((c[L>>2]|0)>>>0<G>>>0){M=L;do M=M+4|0;while((c[M>>2]|0)>>>0<G>>>0);c[K>>2]=M;N=M}else N=L;G=N-s>>2;x=f+(G<<1)|0;H=J-s>>2;if((H|0)!=(G|0)){G=f+(H<<1)|0;do{H=e[G>>1]|0;xDb(a,l,o+(H<<4)|0,m,p+(H<<4)|0);G=G+2|0}while((G|0)!=(x|0))}F=F+1|0}while((F|0)!=5);C=e[t>>1]|0;c[o+(C<<4)>>2]=c[l>>2];c[o+(C<<4)+4>>2]=c[v>>2];c[o+(C<<4)+8>>2]=c[u>>2];c[o+(C<<4)+12>>2]=c[d>>2];C=(c[j>>2]|0)+4|0;c[j>>2]=C;if((E|0)==(n|0))break;A=c[k>>2]|0;b=A;r=c[C>>2]|0;q=c[A>>2]|0;t=E}i=h;return}function T_a(a,b,d,f,g){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;i=i+64|0;j=h+36|0;k=h+16|0;l=h;m=c[a+48>>2]|0;n=c[m+4>>2]|0;o=c[b>>2]|0;p=o&65535;q=p>>>0>g>>>0?g:p;p=o+g|0;r=o|65535;s=p>>>0<r>>>0?p:r;c[j>>2]=b;r=o;p=b;while(1){t=p+4|0;if(r>>>0>=s>>>0)break;r=c[t>>2]|0;p=t}t=o-q|0;c[k>>2]=p;q=t+65536|0;u=r;v=p;while(1){w=v+4|0;if(u>>>0>=q>>>0)break;u=c[w>>2]|0;v=w}c[j+4>>2]=v;q=s+65536|0;w=u;u=v;while(1){v=u+4|0;if(w>>>0>=q>>>0)break;w=c[v>>2]|0;u=v}c[k+4>>2]=u;u=t+16711680|0;w=b+((d&65535)<<2)|0;while(1){x=c[w>>2]|0;if(x>>>0<u>>>0)w=w+4|0;else break}c[j+8>>2]=w;u=s+16711680|0;d=x;x=w;while(1){w=x+4|0;if(d>>>0>=u>>>0)break;d=c[w>>2]|0;x=w}c[k+8>>2]=x;x=t+16777216|0;d=o;u=b;while(1){w=u+4|0;if(d>>>0>=x>>>0)break;d=c[w>>2]|0;u=w}c[j+12>>2]=u;x=s+16777216|0;w=d;d=u;while(1){u=d+4|0;if(w>>>0>=x>>>0)break;w=c[u>>2]|0;d=u}c[k+12>>2]=d;d=t+16842752|0;t=o;w=b;while(1){x=w+4|0;if(t>>>0>=d>>>0)break;t=c[x>>2]|0;w=x}c[j+16>>2]=w;d=s+16842752|0;s=t;t=w;while(1){w=t+4|0;if(s>>>0>=d>>>0)break;s=c[w>>2]|0;t=w}c[k+16>>2]=t;t=c[m+232>>2]|0;m=f+(t<<1)|0;if(!t){i=h;return}t=l+4|0;s=l+8|0;d=l+12|0;w=b;b=p;p=o;o=r;r=f;while(1){x=e[r>>1]|0;c[l>>2]=c[n+(x<<4)>>2];c[t>>2]=c[n+(x<<4)+4>>2];c[s>>2]=c[n+(x<<4)+8>>2];c[d>>2]=c[n+(x<<4)+12>>2];x=p&65535;u=p-(x>>>0>g>>>0?g:x)|0;x=p+g|0;q=p|65535;v=x>>>0<q>>>0?x:q;if(o>>>0<v>>>0){q=b;do q=q+4|0;while((c[q>>2]|0)>>>0<v>>>0);c[k>>2]=q;y=q}else y=b;x=f+(y-w>>2<<1)|0;z=r+2|0;if((z|0)==(x|0))A=1;else{B=z;do{yDb(a,l,n+((e[B>>1]|0)<<4)|0,0,0);B=B+2|0}while((B|0)!=(x|0));A=1}do{x=c[481152+(A<<2)>>2]|0;B=u+x|0;q=j+(A<<2)|0;C=c[q>>2]|0;if((c[C>>2]|0)>>>0<B>>>0){D=C;do D=D+4|0;while((c[D>>2]|0)>>>0<B>>>0);c[q>>2]=D;E=D}else E=C;B=x+v|0;F=k+(A<<2)|0;G=c[F>>2]|0;if((c[G>>2]|0)>>>0<B>>>0){H=G;do H=H+4|0;while((c[H>>2]|0)>>>0<B>>>0);c[F>>2]=H;I=H}else I=G;B=I-w>>2;x=f+(B<<1)|0;C=E-w>>2;if((C|0)!=(B|0)){B=f+(C<<1)|0;do{yDb(a,l,n+((e[B>>1]|0)<<4)|0,0,0);B=B+2|0}while((B|0)!=(x|0))}A=A+1|0}while((A|0)!=5);v=e[r>>1]|0;c[n+(v<<4)>>2]=c[l>>2];c[n+(v<<4)+4>>2]=c[t>>2];c[n+(v<<4)+8>>2]=c[s>>2];c[n+(v<<4)+12>>2]=c[d>>2];v=(c[j>>2]|0)+4|0;c[j>>2]=v;if((z|0)==(m|0))break;u=c[k>>2]|0;b=u;p=c[v>>2]|0;o=c[u>>2]|0;r=z}i=h;return}function U_a(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=a+8|0;h=c[g>>2]|0;j=(h&2147483647|0)==0?1:h<<1;if(!j)k=0;else k=UJa(a,j*40|0,537640,558)|0;h=a+4|0;l=c[h>>2]|0;m=k+(l*40|0)|0;if((l|0)>0){n=k;o=c[a>>2]|0;while(1){if(n){c[n>>2]=468920;p=o+4|0;q=p;r=e[q>>1]|e[q+2>>1]<<16;q=p+4|0;p=e[q>>1]|e[q+2>>1]<<16;q=n+4|0;s=q;b[s>>1]=r;b[s+2>>1]=r>>>16;r=q+4|0;b[r>>1]=p;b[r+2>>1]=p>>>16;c[n>>2]=443968;p=n+12|0;r=o+12|0;c[p>>2]=c[r>>2];c[n+16>>2]=c[o+16>>2];c[p>>2]=c[r>>2];c[n>>2]=481496;r=n+20|0;p=o+20|0;c[r+0>>2]=c[p+0>>2];c[r+4>>2]=c[p+4>>2];c[r+8>>2]=c[p+8>>2];c[r+12>>2]=c[p+12>>2];c[r+16>>2]=c[p+16>>2]}n=n+40|0;if(n>>>0>=m>>>0)break;else o=o+40|0}t=c[h>>2]|0}else t=l;l=k+(t*40|0)|0;if(!l)u=t;else{c[l>>2]=468920;o=d+4|0;m=o;n=e[m>>1]|e[m+2>>1]<<16;m=o+4|0;o=e[m>>1]|e[m+2>>1]<<16;m=k+(t*40|0)+4|0;p=m;b[p>>1]=n;b[p+2>>1]=n>>>16;n=m+4|0;b[n>>1]=o;b[n+2>>1]=o>>>16;c[l>>2]=443968;o=k+(t*40|0)+12|0;n=d+12|0;c[o>>2]=c[n>>2];c[k+(t*40|0)+16>>2]=c[d+16>>2];c[o>>2]=c[n>>2];c[l>>2]=481496;l=k+(t*40|0)+20|0;t=d+20|0;c[l+0>>2]=c[t+0>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[l+12>>2]=c[t+12>>2];c[l+16>>2]=c[t+16>>2];u=c[h>>2]|0}t=c[a>>2]|0;l=t+(u*40|0)|0;if((u|0)>0){u=t;do{ko[c[c[u>>2]>>2]&4095](u);u=u+40|0}while(u>>>0<l>>>0)}if((c[g>>2]|0)<=-1){c[a>>2]=k;c[g>>2]=j;v=c[h>>2]|0;w=v+1|0;c[h>>2]=w;x=k+(v*40|0)|0;i=f;return x|0}VJa(a,c[a>>2]|0);c[a>>2]=k;c[g>>2]=j;v=c[h>>2]|0;w=v+1|0;c[h>>2]=w;x=k+(v*40|0)|0;i=f;return x|0}function V_a(a,b){a=a|0;b=b|0;return (c[(c[a+20>>2]|0)+12>>2]|0)>>>0>(c[(c[b+20>>2]|0)+12>>2]|0)>>>0|0}function W_a(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=i;i=i+176|0;j=h+160|0;k=h+8|0;l=h;m=l;c[m>>2]=0;c[m+4>>2]=0;m=l+4|0;a[m>>0]=0;n=h+32|0;c[l>>2]=n;o=f+-1|0;if((o|0)>0){f=0;p=0;q=0;r=o;o=n;n=32;a:while(1){s=q;t=p;u=r;while(1){if((u|0)>(s|0)){if((u-s|0)>>>0<5)v=s;else break;do{w=v;v=v+1|0;x=v;y=w;while(1){z=_n[c[g>>2]&4095](d+(x*40|0)|0,d+(y*40|0)|0)|0;y=z?x:y;if((x|0)>=(u|0))break;else x=x+1|0}x=d+(y*40|0)+4|0;z=x;A=z;B=e[A>>1]|e[A+2>>1]<<16;A=z+4|0;z=e[A>>1]|e[A+2>>1]<<16;A=d+(y*40|0)+12|0;C=d+(y*40|0)+16|0;c[j>>2]=c[C>>2];D=c[A>>2]|0;E=d+(y*40|0)+20|0;c[k+0>>2]=c[E+0>>2];c[k+4>>2]=c[E+4>>2];c[k+8>>2]=c[E+8>>2];c[k+12>>2]=c[E+12>>2];c[k+16>>2]=c[E+16>>2];F=d+(w*40|0)+4|0;G=F;H=G;I=e[H>>1]|e[H+2>>1]<<16;H=G+4|0;G=e[H>>1]|e[H+2>>1]<<16;H=x;x=H;b[x>>1]=I;b[x+2>>1]=I>>>16;I=H+4|0;b[I>>1]=G;b[I+2>>1]=G>>>16;G=d+(w*40|0)+12|0;c[A>>2]=c[G>>2];A=d+(w*40|0)+16|0;c[C>>2]=c[A>>2];C=d+(w*40|0)+20|0;c[E+0>>2]=c[C+0>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];c[E+12>>2]=c[C+12>>2];c[E+16>>2]=c[C+16>>2];E=F;F=E;b[F>>1]=B;b[F+2>>1]=B>>>16;B=E+4|0;b[B>>1]=z;b[B+2>>1]=z>>>16;c[G>>2]=D;c[A>>2]=c[j>>2];c[C+0>>2]=c[k+0>>2];c[C+4>>2]=c[k+4>>2];c[C+8>>2]=c[k+8>>2];c[C+12>>2]=c[k+12>>2];c[C+16>>2]=c[k+16>>2]}while((v|0)!=(u|0))}if(!t)break a;C=c[o+(t+-1<<2)>>2]|0;A=t+-2|0;s=c[o+(A<<2)>>2]|0;t=A;u=C}C=zDb(d,s,u,g)|0;if((C-s|0)<(u-C|0)){A=C+-1|0;if(t>>>0>=(n+-1|0)>>>0){D=n<<1;G=n<<3;if(!G)J=0;else{z=mKa()|0;B=c[(c[z>>2]|0)+8>>2]|0;E=pKa()|0;F=mo[c[(c[E>>2]|0)+24>>2]&4095](E)|0;J=Bn[B&255](z,G,F?481816:544544,523928,148)|0}YEi(J|0,o|0,t<<2|0)|0;if(f<<24>>24==0|(o|0)==0){K=1;L=D;M=J}else{F=mKa()|0;In[c[(c[F>>2]|0)+12>>2]&4095](F,o);K=1;L=D;M=J}}else{K=f;L=n;M=o}c[M+(t<<2)>>2]=s;c[M+(t+1<<2)>>2]=A;N=K;O=C+1|0;P=u;Q=M;R=L}else{A=C+1|0;if(t>>>0>=(n+-1|0)>>>0){D=n<<1;F=n<<3;if(!F)S=0;else{G=mKa()|0;z=c[(c[G>>2]|0)+8>>2]|0;B=pKa()|0;E=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;S=Bn[z&255](G,F,E?481816:544544,523928,148)|0}YEi(S|0,o|0,t<<2|0)|0;if(f<<24>>24==0|(o|0)==0){T=S;U=1;V=D}else{E=mKa()|0;In[c[(c[E>>2]|0)+12>>2]&4095](E,o);T=S;U=1;V=D}}else{T=o;U=f;V=n}c[T+(t<<2)>>2]=A;c[T+(t+1<<2)>>2]=u;N=U;O=s;P=C+-1|0;Q=T;R=V}f=N;p=t+2|0;q=O;r=P;o=Q;n=R}if(!(f<<24>>24==0|(o|0)==0)){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,o)}}if(!(a[m>>0]|0)){i=h;return}tKa(l,c[l>>2]|0);i=h;return}function X_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)ADb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b*76|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+16|0;l=d+20|0;m=d+24|0;n=d+28|0;o=d+32|0;p=d+36|0;q=d+40|0;r=d+44|0;s=d+48|0;t=d+52|0;u=d+56|0;v=d+60|0;w=d+64|0;x=d+68|0;y=f+(a*76|0)|0;do{if(y){c[y+0>>2]=c[d+0>>2];c[y+4>>2]=c[d+4>>2];c[y+8>>2]=c[d+8>>2];c[y+12>>2]=c[d+12>>2];g[y+16>>2]=ea(g[k>>2]);g[y+20>>2]=ea(g[l>>2]);g[y+24>>2]=ea(g[m>>2]);g[y+28>>2]=ea(g[n>>2]);g[y+32>>2]=ea(g[o>>2]);g[y+36>>2]=ea(g[p>>2]);g[y+40>>2]=ea(g[q>>2]);g[y+44>>2]=ea(g[r>>2]);g[y+48>>2]=ea(g[s>>2]);g[y+52>>2]=ea(g[t>>2]);g[y+56>>2]=ea(g[u>>2]);g[y+60>>2]=ea(g[v>>2]);g[y+64>>2]=ea(g[w>>2]);a=x;f=c[a+4>>2]|0;z=y+68|0;c[z>>2]=c[a>>2];c[z+4>>2]=f}y=y+76|0}while(y>>>0<j>>>0);c[h>>2]=b;i=e;return}function Y_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+4|0;f=c[e>>2]|0;if((c[a+8>>2]&2147483647)>>>0<=f>>>0){h=BDb(a,b)|0;i=d;return h|0}j=c[a>>2]|0;k=j+(f*76|0)|0;if(!k){l=f;m=j}else{c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];g[j+(f*76|0)+16>>2]=ea(g[b+16>>2]);g[j+(f*76|0)+20>>2]=ea(g[b+20>>2]);g[j+(f*76|0)+24>>2]=ea(g[b+24>>2]);g[j+(f*76|0)+28>>2]=ea(g[b+28>>2]);g[j+(f*76|0)+32>>2]=ea(g[b+32>>2]);g[j+(f*76|0)+36>>2]=ea(g[b+36>>2]);g[j+(f*76|0)+40>>2]=ea(g[b+40>>2]);g[j+(f*76|0)+44>>2]=ea(g[b+44>>2]);g[j+(f*76|0)+48>>2]=ea(g[b+48>>2]);g[j+(f*76|0)+52>>2]=ea(g[b+52>>2]);g[j+(f*76|0)+56>>2]=ea(g[b+56>>2]);g[j+(f*76|0)+60>>2]=ea(g[b+60>>2]);g[j+(f*76|0)+64>>2]=ea(g[b+64>>2]);k=b+68|0;b=c[k+4>>2]|0;n=j+(f*76|0)+68|0;c[n>>2]=c[k>>2];c[n+4>>2]=b;l=c[e>>2]|0;m=c[a>>2]|0}c[e>>2]=l+1;h=m+(l*76|0)|0;i=d;return h|0}function Z_a(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im;e=i;f=~~ea(ea(ea(g[b+140>>2])*d)+ea(.5));h=(f|0)>1?f:1;c[a>>2]=h;j=ea(ea(1.0)/ea(h|0));g[a+4>>2]=j;k=ea(j*d);h=a+8|0;g[h>>2]=k;f=b+228|0;j=ea(g[f>>2]);if(j!=ea(0.0))l=ea(k/j);else l=ea(1.0);g[a+12>>2]=l;m=b+232|0;n=c[b+236>>2]|0;if(!n)o=k;else{p=c[m>>2]|0;q=p+(n<<3)|0;r=p;k=ea(0.0);do{l=ea((c[r>>2]|0)>>>0);k=ea(k+ea(l*ea(g[r+4>>2])));r=r+8|0}while((r|0)!=(q|0));q=c[b+244>>2]|0;r=q>>>3;s=p+(n+-1<<3)|0;if(!r)t=ea(0.0);else{n=c[s>>2]|0;u=c[p>>2]|0;v=s;s=0;w=p;l=ea(0.0);j=ea(0.0);while(1){if((s|0)==(u|0)){p=w+8|0;x=(c[p>>2]|0)+s|0;y=p}else{x=u;y=w}if((s|0)==(n|0)){p=v+-8|0;z=(c[p>>2]|0)+s|0;A=p}else{z=n;A=v}B=ea(g[y+4>>2]);j=ea(j+ea(B+ea(g[A+4>>2])));B=ea(l+j);s=s+1|0;if(s>>>0>=r>>>0){t=B;break}else{n=z;u=x;v=A;w=y;l=B}}}y=r+1|0;o=ea(ea(ea(k*ea(y>>>0))-t)/ea((da(q-r|0,y)|0)>>>0))}g[a+16>>2]=o;y=b+176|0;g[a+20>>2]=ea(g[y>>2]);r=b+180|0;g[a+24>>2]=ea(g[r>>2]);q=b+184|0;g[a+28>>2]=ea(g[q>>2]);w=b+188|0;g[a+32>>2]=ea(g[w>>2]);A=b+204|0;g[a+36>>2]=ea(g[A>>2]);v=b+208|0;g[a+40>>2]=ea(g[v>>2]);x=b+212|0;g[a+44>>2]=ea(g[x>>2]);u=b+216|0;g[a+48>>2]=ea(g[u>>2]);z=b+220|0;g[a+52>>2]=ea(g[z>>2]);n=b+224|0;g[a+56>>2]=ea(g[n>>2]);o=ea(ea(1.0)/d);s=b+164|0;d=ea(g[s>>2]);p=b+192|0;t=ea(d-ea(g[p>>2]));C=b+168|0;d=ea(g[C>>2]);D=b+196|0;k=ea(d-ea(g[D>>2]));E=b+172|0;d=ea(g[E>>2]);F=b+200|0;l=ea(o*k);k=ea(o*ea(d-ea(g[F>>2])));g[A>>2]=ea(o*t);g[v>>2]=l;g[x>>2]=k;k=ea(-ea(g[y>>2]));l=ea(-ea(g[r>>2]));t=ea(-ea(g[q>>2]));d=ea(g[w>>2]);x=b+160|0;j=ea(g[x>>2]);B=ea(j*k);v=b+148|0;G=ea(g[v>>2]);H=ea(B+ea(d*G));A=b+152|0;B=ea(g[A>>2]);I=ea(H+ea(B*t));J=b+156|0;H=ea(g[J>>2]);K=ea(I-ea(H*l));I=ea(ea(ea(ea(j*l)+ea(d*B))+ea(H*k))-ea(G*t));L=ea(ea(ea(G*l)+ea(ea(j*t)+ea(d*H)))-ea(B*k));M=ea(ea(ea(ea(d*j)-ea(G*k))-ea(B*l))-ea(H*t));t=ea(T(ea(ea(ea(K*K)+ea(I*I))+ea(L*L))));if(!(t>ea(1.1920929e-07))){N=ea(1.0);O=ea(-N);P=M>=ea(0.0);Q=P?N:O;R=ea(K*Q);S=ea(I*Q);U=ea(L*Q);V=ea(o*R);W=ea(o*S);X=ea(o*U);g[u>>2]=V;g[z>>2]=W;g[n>>2]=X;Y=ea(g[h>>2]);g[f>>2]=Y;_=c[a>>2]|0;$=ea(g[h>>2]);CDb(m,_,$);aa=ea(g[v>>2]);g[y>>2]=aa;ba=ea(g[A>>2]);g[r>>2]=ba;ca=ea(g[J>>2]);g[q>>2]=ca;fa=ea(g[x>>2]);g[w>>2]=fa;ga=ea(g[s>>2]);g[p>>2]=ga;ha=ea(g[C>>2]);g[D>>2]=ha;ia=ea(g[E>>2]);g[F>>2]=ia;i=e;return}b=t<ea(-1.0);H=b?ea(-1.0):t;b=H>ea(1.0);N=ea(ea(+Z(+(b?1.0:+H)))/t);O=ea(-N);P=M>=ea(0.0);Q=P?N:O;R=ea(K*Q);S=ea(I*Q);U=ea(L*Q);V=ea(o*R);W=ea(o*S);X=ea(o*U);g[u>>2]=V;g[z>>2]=W;g[n>>2]=X;Y=ea(g[h>>2]);g[f>>2]=Y;_=c[a>>2]|0;$=ea(g[h>>2]);CDb(m,_,$);aa=ea(g[v>>2]);g[y>>2]=aa;ba=ea(g[A>>2]);g[r>>2]=ba;ca=ea(g[J>>2]);g[q>>2]=ca;fa=ea(g[x>>2]);g[w>>2]=fa;ga=ea(g[s>>2]);g[p>>2]=ga;ha=ea(g[C>>2]);g[D>>2]=ha;ia=ea(g[E>>2]);g[F>>2]=ia;i=e;return}function __a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)DDb(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b*12|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=f+(a*12|0)|0;do{if(m){g[m>>2]=ea(g[d>>2]);g[m+4>>2]=ea(g[k>>2]);g[m+8>>2]=ea(g[l>>2])}m=m+12|0}while(m>>>0<j>>>0);c[h>>2]=b;i=e;return}function $_a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,X=Im,Y=Im,Z=Im,_=0,$=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im;f=i;i=i+208|0;h=f+184|0;j=f+120|0;l=f+56|0;m=f+40|0;n=f;c[b>>2]=c[d>>2];o=d+4|0;g[b+4>>2]=ea(g[o>>2]);p=d+8|0;g[b+8>>2]=ea(g[p>>2]);q=e+204|0;r=ea(g[q>>2]);s=ea(g[q+4>>2]);t=ea(g[q+8>>2]);q=d+36|0;u=ea(g[q>>2]);v=ea(g[q+4>>2]);w=ea(g[q+8>>2]);x=ea(g[p>>2]);y=ea(x*ea(g[e+144>>2]));p=e+56|0;z=ea(g[p>>2]);A=ea(g[p+4>>2]);B=ea(g[p+8>>2]);C=ea(g[d+16>>2]);D=ea(C*C);C=ea(z*D);z=ea(A*D);A=ea(B*D);p=e+68|0;D=ea(g[p>>2]);B=ea(g[p+4>>2]);E=ea(g[p+8>>2]);F=ea(+aa(+ea(ea(y*D)*ea(.693147182))));D=ea(+aa(+ea(ea(y*B)*ea(.693147182))));B=ea(+aa(+ea(ea(y*E)*ea(.693147182))));E=ea(+aa(+ea(ea(y*ea(g[p+12>>2]))*ea(.693147182))));G=ea(g[d+12>>2]);H=ea(D*G);I=ea(B*G);J=ea(E*G);g[h>>2]=ea(F*G);p=h+4|0;g[p>>2]=H;q=h+8|0;g[q>>2]=I;g[h+12>>2]=J;K=e+80|0;J=ea(g[K+4>>2]);I=ea(r*ea(x*ea(ea(1.0)-E)));E=ea(s*ea(x*ea(ea(1.0)-ea(+aa(+ea(ea(y*J)*ea(.693147182)))))));J=ea(t*ea(x*ea(ea(1.0)-ea(+aa(+ea(ea(y*ea(g[K+8>>2]))*ea(.693147182)))))));K=e+104|0;H=ea(g[K>>2]);G=ea(g[K+4>>2]);L=ea(ea(u-r)*ea(x*H));H=ea(ea(v-s)*ea(x*G));G=ea(ea(w-t)*ea(x*ea(g[K+8>>2])));t=ea(ea((c[d>>2]|0)+1|0)*ea(.5));w=ea(ea(g[o>>2])*t);t=ea(L*w);s=ea(H*w);v=ea(G*w);w=ea(g[d+20>>2]);r=ea(-w);u=ea(g[d+24>>2]);M=ea(-u);N=ea(g[d+28>>2]);O=ea(-N);P=ea(g[d+32>>2]);Q=ea(r-w);w=ea(M-u);u=ea(O-N);N=ea(w*M);R=ea(u*O);S=ea(Q*M);M=ea(Q*O);U=ea(Q*P);X=ea(w*O);O=ea(w*P);w=ea(P*u);u=ea(ea(ea(1.0)-N)-R);P=ea(S+w);Y=ea(M-O);Z=ea(S-w);w=ea(ea(1.0)-ea(Q*r));r=ea(w-R);R=ea(X+U);Q=ea(M+O);O=ea(X-U);U=ea(w-N);K=b+16|0;N=ea(u);w=ea(P);X=ea(Y);g[K>>2]=N;_=b+20|0;g[_>>2]=w;$=b+24|0;g[$>>2]=X;ba=b+28|0;c[ba>>2]=0;ca=b+32|0;X=ea(Z);w=ea(r);N=ea(R);g[ca>>2]=X;da=b+36|0;g[da>>2]=w;fa=b+40|0;g[fa>>2]=N;ga=b+44|0;c[ga>>2]=0;ha=b+48|0;N=ea(Q);w=ea(O);X=ea(U);g[ha>>2]=N;ia=b+52|0;g[ia>>2]=w;ja=b+56|0;g[ja>>2]=X;ka=b+60|0;c[ka>>2]=0;X=ea(ea(C-I)+t);I=ea(ea(z-E)+s);E=ea(ea(A-J)+v);J=ea(ea(ea(X*u)+ea(I*Z))+ea(E*Q));A=ea(ea(ea(X*P)+ea(I*r))+ea(E*O));z=ea(ea(ea(X*Y)+ea(I*R))+ea(E*U));E=ea(J);J=ea(A);A=ea(z);g[b+64>>2]=E;g[b+68>>2]=J;g[b+72>>2]=A;c[b+76>>2]=0;A=ea(L-t);t=ea(H-s);s=ea(G-v);v=ea(ea(ea(A*u)+ea(t*Z))+ea(s*Q));G=ea(ea(ea(A*P)+ea(t*r))+ea(s*O));H=ea(ea(ea(A*Y)+ea(t*R))+ea(s*U));s=ea(v);v=ea(G);G=ea(H);g[b+80>>2]=s;g[b+84>>2]=v;g[b+88>>2]=G;c[b+92>>2]=0;G=ea(g[d+48>>2]);v=ea(G*G);s=ea(g[d+52>>2]);H=ea(v+ea(s*s));v=ea(g[d+56>>2]);t=ea(H+ea(v*v));H=ea(g[e+216>>2]);A=ea(H*H);L=ea(g[e+220>>2]);J=ea(A+ea(L*L));A=ea(g[e+224>>2]);la=ea(t+ea(J+ea(A*A)))>ea(0.0);a[b+12>>0]=la&1;if(!la){c[K>>2]=-1082130432;c[_>>2]=-1082130432;c[$>>2]=-1082130432;c[ba>>2]=-1082130432;la=c[h>>2]|0;ma=c[p>>2]|0;na=c[q>>2]|0;c[b+96>>2]=la;c[b+100>>2]=ma;c[b+104>>2]=na;c[b+108>>2]=-1082130432;J=(c[k>>2]=la,ea(g[k>>2]));t=(c[k>>2]=ma,ea(g[k>>2]));oa=J;pa=t;qa=(c[k>>2]=na,ea(g[k>>2]));ra=b+192|0;sa=ea(F-oa);ta=ea(D-pa);ua=ea(B-qa);va=ea(sa);wa=ea(ta);xa=ea(ua);g[ra>>2]=va;ya=b+196|0;g[ya>>2]=wa;za=b+200|0;g[za>>2]=xa;Aa=b+204|0;c[Aa>>2]=0;i=f;return}t=ea(ea(ea(u*H)+ea(Z*L))+ea(Q*A));J=ea(ea(ea(P*H)+ea(r*L))+ea(O*A));E=ea(ea(ea(Y*H)+ea(R*L))+ea(U*A));A=ea(ea(ea(u*G)+ea(Z*s))+ea(Q*v));Q=ea(ea(ea(P*G)+ea(r*s))+ea(O*v));O=ea(ea(ea(Y*G)+ea(R*s))+ea(U*v));v=ea(-x);x=ea(t*v);U=ea(J*v);s=ea(E*v);R=ea(v*ea(0.0));G=ea(A*v);Y=ea(Q*v);r=ea(O*v);v=ea(T(ea(ea(s*s)+ea(ea(x*x)+ea(U*U)))));if(v>ea(1.1920929e-07))Ba=ea(ea(+W(+v))/v);else Ba=ea(1.0);P=ea(x*Ba);Z=ea(U*Ba);u=ea(s*Ba);Ba=ea(+V(+(+v)));v=ea(T(ea(ea(r*r)+ea(ea(G*G)+ea(Y*Y)))));if(v>ea(1.1920929e-07))Ca=ea(ea(+W(+v))/v);else Ca=ea(1.0);L=ea(G*Ca);H=ea(Y*Ca);z=ea(r*Ca);Ca=ea(+V(+(+v)));v=ea(P+P);I=ea(Z+Z);X=ea(u+u);C=ea(P*v);w=ea(Z*I);N=ea(u*X);M=ea(Z*v);S=ea(u*v);Da=ea(v*Ba);v=ea(u*I);Ea=ea(I*Ba);I=ea(X*Ba);X=ea(M+I);Fa=ea(S-Ea);g[j>>2]=ea(ea(ea(1.0)-w)-N);g[j+4>>2]=X;g[j+8>>2]=Fa;g[j+12>>2]=ea(0.0);Fa=ea(ea(1.0)-C);C=ea(Fa-N);N=ea(v+Da);g[j+16>>2]=ea(M-I);g[j+20>>2]=C;g[j+24>>2]=N;g[j+28>>2]=ea(0.0);N=ea(v-Da);Da=ea(Fa-w);g[j+32>>2]=ea(S+Ea);g[j+36>>2]=N;g[j+40>>2]=Da;na=j+44|0;c[na+0>>2]=0;c[na+4>>2]=0;c[na+8>>2]=0;c[na+12>>2]=0;g[j+60>>2]=ea(1.0);Da=ea(ea(ea(u*H)+ea(ea(Ba*L)+ea(P*Ca)))-ea(Z*z));N=ea(ea(ea(P*z)+ea(ea(Ba*H)+ea(Z*Ca)))-ea(u*L));Ea=ea(ea(ea(Z*L)+ea(ea(Ba*z)+ea(u*Ca)))-ea(P*H));S=ea(ea(ea(ea(Ba*Ca)-ea(P*L))-ea(Z*H))-ea(u*z));z=ea(Da+Da);u=ea(N+N);H=ea(Ea+Ea);Z=ea(Da*z);Da=ea(N*u);L=ea(Ea*H);P=ea(N*z);N=ea(Ea*z);Ca=ea(S*z);z=ea(Ea*u);Ea=ea(S*u);u=ea(S*H);H=ea(P+u);S=ea(N-Ea);g[l>>2]=ea(ea(ea(1.0)-Da)-L);g[l+4>>2]=H;g[l+8>>2]=S;g[l+12>>2]=ea(0.0);S=ea(ea(1.0)-Z);Z=ea(S-L);L=ea(z+Ca);g[l+16>>2]=ea(P-u);g[l+20>>2]=Z;g[l+24>>2]=L;g[l+28>>2]=ea(0.0);L=ea(z-Ca);Ca=ea(S-Da);g[l+32>>2]=ea(N+Ea);g[l+36>>2]=L;g[l+40>>2]=Ca;na=l+44|0;c[na+0>>2]=0;c[na+4>>2]=0;c[na+8>>2]=0;c[na+12>>2]=0;g[l+60>>2]=ea(1.0);Ca=ea(g[j>>2]);na=j+4|0;L=ea(g[na>>2]);ma=j+8|0;Ea=ea(g[ma>>2]);la=j+12|0;N=ea(g[la>>2]);Da=ea(Ca);Ca=ea(L);L=ea(Ea);Ea=ea(N);g[K>>2]=Da;g[_>>2]=Ca;g[$>>2]=L;g[ba>>2]=Ea;ba=j+16|0;Ea=ea(g[ba>>2]);$=ba+4|0;L=ea(g[$>>2]);_=ba+8|0;Ca=ea(g[_>>2]);K=ba+12|0;Da=ea(g[K>>2]);N=ea(Ea);Ea=ea(L);L=ea(Ca);Ca=ea(Da);g[ca>>2]=N;g[da>>2]=Ea;g[fa>>2]=L;g[ga>>2]=Ca;ga=j+32|0;Ca=ea(g[ga>>2]);fa=ga+4|0;L=ea(g[fa>>2]);da=ga+8|0;Ea=ea(g[da>>2]);ca=ga+12|0;N=ea(g[ca>>2]);Da=ea(Ca);Ca=ea(L);L=ea(Ea);Ea=ea(N);g[ha>>2]=Da;g[ia>>2]=Ca;g[ja>>2]=L;g[ka>>2]=Ea;ka=e+92|0;Ea=ea(g[ka>>2]);L=ea(g[ka+4>>2]);Ca=ea(ea(1.0)-ea(+aa(+ea(ea(y*Ea)*ea(.693147182)))));Ea=ea(ea(1.0)-ea(+aa(+ea(ea(y*L)*ea(.693147182)))));L=ea(ea(1.0)-ea(+aa(+ea(ea(y*ea(g[ka+8>>2]))*ea(.693147182)))));ka=e+128|0;y=ea(g[ka>>2]);Da=ea(g[ka+4>>2]);N=ea(g[ka+8>>2]);ka=e+116|0;S=ea(g[ka>>2]);z=ea(g[ka+4>>2]);Z=ea(t-A);A=ea(J-Q);Q=ea(E-O);O=ea(ea(ea(E*E)+ea(ea(t*t)+ea(J*J)))+ea(1.08420217e-19));u=ea(t*Ca);Ca=ea(J*Ea);Ea=ea(E*L);L=ea(ea(ea(ea(u*u)+ea(Ca*Ca))+ea(Ea*Ea))+ea(1.08420217e-19));Ea=ea(t*y);y=ea(J*Da);Da=ea(E*N);N=ea(ea(ea(ea(Ea*Ea)+ea(y*y))+ea(Da*Da))+ea(1.08420217e-19));Da=ea(ea(ea(Q*Q)+ea(ea(Z*Z)+ea(A*A)))+ea(1.08420217e-19));y=ea(Z*S);S=ea(A*z);z=ea(Q*ea(g[ka+8>>2]));Q=ea(ea(ea(ea(y*y)+ea(S*S))+ea(z*z))+ea(1.08420217e-19));z=ea(L*ea(ea(1.0)/ea(T(ea(O*L)))));L=ea(g[o>>2]);S=ea(L*ea(Q*ea(ea(1.0)/ea(T(ea(Da*Q))))));Q=ea(ea(ea(N*ea(ea(1.0)/ea(T(ea(O*N)))))*ea(L*ea((c[d>>2]<<1)+-1|0)))-S);L=ea(ea(x+G)*ea(.5));G=ea(ea(U+Y)*ea(.5));Y=ea(ea(s+r)*ea(.5));r=ea(ea(R+R)*ea(.5));g[m>>2]=L;g[m+4>>2]=G;g[m+8>>2]=Y;g[m+12>>2]=r;r=ea(Q*ea(ea(ea(L*L)+ea(G*G))+ea(Y*Y)));R=ea(L*Q);s=ea(G*Q);U=ea(Y*Q);x=ea(-s);N=ea(-U);O=ea(-R);g[n>>2]=ea(0.0);g[n+4>>2]=U;g[n+8>>2]=x;g[n+12>>2]=N;g[n+16>>2]=ea(0.0);g[n+20>>2]=R;g[n+24>>2]=s;g[n+28>>2]=O;g[n+32>>2]=ea(0.0);O=ea(ea(r-S)-z);s=L;d=0;while(1){R=ea(Q*s);N=ea(g[h+(d<<2)>>2]);o=n+(d*12|0)|0;ka=j+(d<<4)|0;x=ea(S-N);e=l+(d<<4)|0;U=ea(z+ea(S+N));N=ea(g[o>>2]);Da=ea(R*L);y=ea(ea(-Da)-N);A=ea(g[ka>>2]);Z=ea(ea(x*A)+y);g[e>>2]=ea(Z-ea(S*ea(g[e>>2])));g[ka>>2]=ea(ea(N-Da)+ea(U*A));A=ea(g[o+4>>2]);Da=ea(R*G);N=ea(ea(-Da)-A);ja=ka+4|0;Z=ea(g[ja>>2]);y=ea(ea(x*Z)+N);ia=e+4|0;g[ia>>2]=ea(y-ea(S*ea(g[ia>>2])));g[ja>>2]=ea(ea(A-Da)+ea(U*Z));Z=ea(g[o+8>>2]);Da=ea(R*Y);R=ea(ea(-Da)-Z);o=ka+8|0;A=ea(g[o>>2]);y=ea(ea(x*A)+R);ja=e+8|0;g[ja>>2]=ea(y-ea(S*ea(g[ja>>2])));g[o>>2]=ea(ea(Z-Da)+ea(U*A));o=ka+(d<<2)|0;g[o>>2]=ea(O+ea(g[o>>2]));o=e+(d<<2)|0;g[o>>2]=ea(r+ea(g[o>>2]));o=d+1|0;if((o|0)==3)break;s=ea(g[m+(o<<2)>>2]);d=o}s=ea(g[l>>2]);r=ea(g[l+4>>2]);O=ea(g[l+8>>2]);S=ea(g[l+12>>2]);Y=ea(s);s=ea(r);r=ea(O);O=ea(S);g[b+96>>2]=Y;g[b+100>>2]=s;g[b+104>>2]=r;g[b+108>>2]=O;d=l+16|0;O=ea(g[d>>2]);r=ea(g[d+4>>2]);s=ea(g[d+8>>2]);Y=ea(g[d+12>>2]);S=ea(O);O=ea(r);r=ea(s);s=ea(Y);g[b+112>>2]=S;g[b+116>>2]=O;g[b+120>>2]=r;g[b+124>>2]=s;d=l+32|0;s=ea(g[d>>2]);r=ea(g[d+4>>2]);O=ea(g[d+8>>2]);S=ea(g[d+12>>2]);Y=ea(s);s=ea(r);r=ea(O);O=ea(S);g[b+128>>2]=Y;g[b+132>>2]=s;g[b+136>>2]=r;g[b+140>>2]=O;O=ea(g[j>>2]);r=ea(g[na>>2]);s=ea(g[ma>>2]);Y=ea(g[la>>2]);S=ea(O);O=ea(r);r=ea(s);s=ea(Y);g[b+144>>2]=S;g[b+148>>2]=O;g[b+152>>2]=r;g[b+156>>2]=s;s=ea(g[ba>>2]);r=ea(g[$>>2]);O=ea(g[_>>2]);S=ea(g[K>>2]);Y=ea(s);s=ea(r);r=ea(O);O=ea(S);g[b+160>>2]=Y;g[b+164>>2]=s;g[b+168>>2]=r;g[b+172>>2]=O;O=ea(g[ga>>2]);r=ea(g[fa>>2]);s=ea(g[da>>2]);Y=ea(g[ca>>2]);S=ea(O);O=ea(r);r=ea(s);s=ea(Y);g[b+176>>2]=S;g[b+180>>2]=O;g[b+184>>2]=r;g[b+188>>2]=s;s=ea(g[h>>2]);r=ea(g[p>>2]);oa=s;pa=r;qa=ea(g[q>>2]);ra=b+192|0;sa=ea(F-oa);ta=ea(D-pa);ua=ea(B-qa);va=ea(sa);wa=ea(ta);xa=ea(ua);g[ra>>2]=va;ya=b+196|0;g[ya>>2]=wa;za=b+200|0;g[za>>2]=xa;Aa=b+204|0;c[Aa>>2]=0;i=f;return}function a$a(b){b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0;d=i;if(a[b+12>>0]|0){e=b+64|0;f=ea(g[e>>2]);h=ea(g[b+16>>2]);j=ea(f*h);k=ea(g[b+20>>2]);l=ea(f*k);m=ea(g[b+24>>2]);n=ea(f*m);o=ea(g[b+28>>2]);p=ea(f*o);q=b+68|0;f=ea(g[q>>2]);r=ea(g[b+32>>2]);s=ea(f*r);t=ea(g[b+36>>2]);u=ea(f*t);v=ea(g[b+40>>2]);w=ea(f*v);x=ea(g[b+44>>2]);y=ea(j+s);s=ea(l+u);u=ea(n+w);w=ea(p+ea(f*x));z=b+72|0;f=ea(g[z>>2]);p=ea(g[b+48>>2]);n=ea(f*p);l=ea(g[b+52>>2]);j=ea(f*l);A=ea(g[b+56>>2]);B=ea(f*A);C=ea(g[b+60>>2]);D=ea(y+n);n=ea(s+j);j=ea(u+B);B=ea(w+ea(f*C));f=ea(D);D=ea(n);n=ea(j);j=ea(B);g[e>>2]=f;g[q>>2]=D;g[z>>2]=n;g[b+76>>2]=j;z=b+80|0;j=ea(g[z>>2]);n=ea(j*h);h=ea(j*k);k=ea(j*m);m=ea(j*o);q=b+84|0;o=ea(g[q>>2]);j=ea(n+ea(o*r));r=ea(h+ea(o*t));t=ea(k+ea(o*v));v=ea(m+ea(o*x));e=b+88|0;x=ea(g[e>>2]);o=ea(j+ea(x*p));p=ea(r+ea(x*l));l=ea(t+ea(x*A));A=ea(v+ea(x*C));C=ea(o);o=ea(p);p=ea(l);l=ea(A);g[z>>2]=C;g[q>>2]=o;g[e>>2]=p;g[b+92>>2]=l}e=b+192|0;q=b+196|0;z=b+200|0;E=b+204|0;F=0;do{G=b+(F<<4)+96|0;l=ea(g[b+(F<<4)+16>>2]);p=ea(l*ea(g[e>>2]));o=ea(g[b+(F<<4)+20>>2]);C=ea(o*ea(g[q>>2]));A=ea(g[b+(F<<4)+24>>2]);x=ea(A*ea(g[z>>2]));v=ea(g[b+(F<<4)+28>>2]);t=ea(v*ea(g[E>>2]));r=ea(ea(g[G>>2])-p);H=b+(F<<4)+100|0;p=ea(ea(g[H>>2])-C);I=b+(F<<4)+104|0;C=ea(ea(g[I>>2])-x);J=b+(F<<4)+108|0;x=ea(ea(g[J>>2])-t);t=ea(r);r=ea(p);p=ea(C);C=ea(x);g[G>>2]=t;g[H>>2]=r;g[I>>2]=p;g[J>>2]=C;J=b+(F<<4)+144|0;C=ea(l*ea(g[e>>2]));l=ea(o*ea(g[q>>2]));o=ea(A*ea(g[z>>2]));A=ea(v*ea(g[E>>2]));v=ea(C+ea(g[J>>2]));I=b+(F<<4)+148|0;C=ea(l+ea(g[I>>2]));H=b+(F<<4)+152|0;l=ea(o+ea(g[H>>2]));G=b+(F<<4)+156|0;o=ea(A+ea(g[G>>2]));A=ea(v);v=ea(C);C=ea(l);l=ea(o);g[J>>2]=A;g[I>>2]=v;g[H>>2]=C;g[G>>2]=l;F=F+1|0}while((F|0)!=3);F=b+192|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;c[b>>2]=(c[b>>2]|0)+-1;i=d;return}function b$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im;f=i;h=c[b+4>>2]|0;j=c[h+4>>2]|0;l=j+(c[h>>2]<<4)|0;m=c[h+8>>2]|0;h=b+620|0;n=(j|0)==(l|0);if(!(a[b+536>>0]|0)){if(n){i=f;return}o=ea(g[h>>2]);p=ea(g[b+624>>2]);q=ea(g[b+628>>2]);r=ea(g[b+632>>2]);s=ea(g[d>>2]);t=ea(g[d+4>>2]);u=ea(g[d+8>>2]);v=ea(g[d+12>>2]);w=e+4|0;x=e+8|0;y=e+12|0;z=m;A=j;while(1){B=c[A>>2]|0;C=A+4|0;D=c[C>>2]|0;E=A+8|0;F=c[E>>2]|0;G=A+12|0;H=c[G>>2]|0;I=c[z>>2]|0;J=z+4|0;K=c[J>>2]|0;L=z+8|0;M=c[L>>2]|0;N=z+12|0;O=c[N>>2]|0;P=(c[k>>2]=B,ea(g[k>>2]));Q=ea(g[120524]);R=(c[k>>2]=D,ea(g[k>>2]));S=ea(g[120525]);T=(c[k>>2]=F,ea(g[k>>2]));U=ea(g[120526]);V=(c[k>>2]=H,ea(g[k>>2]));W=V>ea(g[120527]);X=P>Q?I^B:0;B=R>S?K^D:0;D=T>U?M^F:0;F=W?O^H:0;H=X^I;W=B^K;Y=D^M;Z=F^O;U=(c[k>>2]=O,ea(g[k>>2]));T=ea(g[120520]);S=ea(g[120521]);R=ea(g[120522]);O=U>T;_=U>S;$=U>R;aa=U>ea(g[120523]);R=(c[k>>2]=H,ea(g[k>>2]));S=ea(R-(c[k>>2]=I,ea(g[k>>2])));T=(c[k>>2]=W,ea(g[k>>2]));Q=ea(T-(c[k>>2]=K,ea(g[k>>2])));P=(c[k>>2]=Y,ea(g[k>>2]));V=ea(P-(c[k>>2]=M,ea(g[k>>2])));ba=(c[k>>2]=Z,ea(g[k>>2]));ca=ea(s+ea(o*S));S=ea(t+ea(p*Q));Q=ea(u+ea(q*V));V=ea(v+ea(r*ea(ba-U)));U=ea(R+(O?ca:ea(0.0)));ca=ea(T+(_?S:ea(0.0)));S=ea(P+($?Q:ea(0.0)));Q=ea(ba+(aa?V:ea(0.0)));V=ea(U);U=ea(ca);ca=ea(S);S=ea(Q);g[A>>2]=V;g[C>>2]=U;g[E>>2]=ca;g[G>>2]=S;S=(c[k>>2]=c[120496]&X^H,ea(g[k>>2]));ca=ea(g[e>>2]);U=ea(S+(O?ca:ea(0.0)));ca=(c[k>>2]=c[120497]&B^W,ea(g[k>>2]));S=ea(g[w>>2]);V=ea(ca+(_?S:ea(0.0)));S=(c[k>>2]=c[120498]&D^Y,ea(g[k>>2]));ca=ea(g[x>>2]);Q=ea(S+($?ca:ea(0.0)));ca=(c[k>>2]=c[120499]&F^Z,ea(g[k>>2]));S=ea(g[y>>2]);ba=ea(ca+(aa?S:ea(0.0)));S=ea(U);U=ea(V);V=ea(Q);Q=ea(ba);g[z>>2]=S;g[J>>2]=U;g[L>>2]=V;g[N>>2]=Q;A=A+16|0;if((A|0)==(l|0))break;else z=z+16|0}i=f;return}else{if(n){i=f;return}r=ea(g[h>>2]);v=ea(g[b+624>>2]);q=ea(g[b+628>>2]);u=ea(g[b+632>>2]);p=ea(g[d>>2]);t=ea(g[d+4>>2]);o=ea(g[d+8>>2]);s=ea(g[d+12>>2]);Q=ea(g[b+636>>2]);V=ea(g[b+640>>2]);U=ea(g[b+644>>2]);S=ea(g[b+648>>2]);ba=ea(g[b+652>>2]);ca=ea(g[b+656>>2]);P=ea(g[b+660>>2]);T=ea(g[b+664>>2]);R=ea(g[b+668>>2]);da=ea(g[b+672>>2]);fa=ea(g[b+676>>2]);ga=ea(g[b+680>>2]);ha=ea(g[b+684>>2]);ia=ea(g[b+688>>2]);ja=ea(g[b+692>>2]);ka=ea(g[b+696>>2]);la=ea(g[b+700>>2]);ma=ea(g[b+704>>2]);na=ea(g[b+708>>2]);oa=ea(g[b+712>>2]);b=e+4|0;d=e+8|0;h=e+12|0;n=m;m=j;while(1){j=c[m>>2]|0;z=m+4|0;A=c[z>>2]|0;y=m+8|0;x=c[y>>2]|0;w=m+12|0;N=c[w>>2]|0;L=c[n>>2]|0;J=n+4|0;aa=c[J>>2]|0;Z=n+8|0;F=c[Z>>2]|0;$=n+12|0;Y=c[$>>2]|0;pa=(c[k>>2]=j,ea(g[k>>2]));qa=ea(g[120524]);ra=(c[k>>2]=A,ea(g[k>>2]));sa=ea(g[120525]);ta=(c[k>>2]=x,ea(g[k>>2]));ua=ea(g[120526]);va=(c[k>>2]=N,ea(g[k>>2]));D=va>ea(g[120527]);_=pa>qa?L^j:0;j=ra>sa?aa^A:0;A=ta>ua?F^x:0;x=D?Y^N:0;N=_^L;D=j^aa;W=A^F;B=x^Y;ua=(c[k>>2]=Y,ea(g[k>>2]));ta=ea(g[120520]);sa=ea(g[120521]);ra=ea(g[120522]);Y=ua>ta;O=ua>sa;H=ua>ra;X=ua>ea(g[120523]);ua=(c[k>>2]=L,ea(g[k>>2]));ra=ea(p+ea(r*ua));sa=ea(t+ea(v*ua));ta=ea(o+ea(q*ua));qa=ea(s+ea(u*ua));ua=(c[k>>2]=aa,ea(g[k>>2]));pa=ea(ra+ea(Q*ua));ra=ea(sa+ea(V*ua));sa=ea(ta+ea(U*ua));ta=ea(qa+ea(S*ua));ua=(c[k>>2]=F,ea(g[k>>2]));qa=ea(pa+ea(ba*ua));pa=ea(ra+ea(ca*ua));ra=ea(sa+ea(P*ua));sa=ea(ta+ea(T*ua));ua=(c[k>>2]=N,ea(g[k>>2]));ta=ea(qa+ea(R*ua));qa=ea(pa+ea(da*ua));pa=ea(ra+ea(fa*ua));ra=ea(sa+ea(ga*ua));sa=(c[k>>2]=D,ea(g[k>>2]));va=ea(ta+ea(ha*sa));ta=ea(qa+ea(ia*sa));qa=ea(pa+ea(ja*sa));pa=ea(ra+ea(ka*sa));ra=(c[k>>2]=W,ea(g[k>>2]));wa=ea(va+ea(la*ra));va=ea(ta+ea(ma*ra));ta=ea(qa+ea(na*ra));qa=ea(pa+ea(oa*ra));pa=ea(ua+(Y?wa:ea(0.0)));wa=ea(sa+(O?va:ea(0.0)));va=ea(ra+(H?ta:ea(0.0)));ta=(c[k>>2]=B,ea(g[k>>2]));ra=ea(ta+(X?qa:ea(0.0)));qa=ea(pa);pa=ea(wa);wa=ea(va);va=ea(ra);g[m>>2]=qa;g[z>>2]=pa;g[y>>2]=wa;g[w>>2]=va;va=(c[k>>2]=c[120496]&_^N,ea(g[k>>2]));wa=ea(g[e>>2]);pa=ea(va+(Y?wa:ea(0.0)));wa=(c[k>>2]=c[120497]&j^D,ea(g[k>>2]));va=ea(g[b>>2]);qa=ea(wa+(O?va:ea(0.0)));va=(c[k>>2]=c[120498]&A^W,ea(g[k>>2]));wa=ea(g[d>>2]);ra=ea(va+(H?wa:ea(0.0)));wa=(c[k>>2]=c[120499]&x^B,ea(g[k>>2]));va=ea(g[h>>2]);ta=ea(wa+(X?va:ea(0.0)));va=ea(pa);pa=ea(qa);qa=ea(ra);ra=ea(ta);g[n>>2]=va;g[J>>2]=pa;g[Z>>2]=qa;g[$>>2]=ra;m=m+16|0;if((m|0)==(l|0))break;else n=n+16|0}i=f;return}}function c$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im;f=i;h=c[b+4>>2]|0;j=c[h+4>>2]|0;l=j+(c[h>>2]<<4)|0;m=c[h+8>>2]|0;h=b+620|0;n=(j|0)==(l|0);if(!(a[b+536>>0]|0)){if(n){i=f;return}o=ea(g[h>>2]);p=ea(g[b+624>>2]);q=ea(g[b+628>>2]);r=ea(g[b+632>>2]);s=ea(g[d+4>>2]);t=ea(g[d+8>>2]);u=ea(g[d+12>>2]);v=ea(g[d+16>>2]);w=ea(g[d+20>>2]);x=ea(g[d+24>>2]);y=ea(g[d+28>>2]);z=ea(g[d+32>>2]);A=e+4|0;B=e+8|0;C=e+12|0;D=m;E=j;F=c[d>>2]|0;while(1){G=c[E>>2]|0;H=E+4|0;I=c[H>>2]|0;J=E+8|0;K=c[J>>2]|0;L=E+12|0;M=c[L>>2]|0;N=c[D>>2]|0;O=D+4|0;P=c[O>>2]|0;Q=D+8|0;R=c[Q>>2]|0;S=D+12|0;T=c[S>>2]|0;U=(c[k>>2]=G,ea(g[k>>2]));V=ea(g[120524]);W=(c[k>>2]=I,ea(g[k>>2]));X=ea(g[120525]);Y=(c[k>>2]=K,ea(g[k>>2]));Z=ea(g[120526]);_=(c[k>>2]=M,ea(g[k>>2]));$=_>ea(g[120527]);aa=U>V?N^G:0;G=W>X?P^I:0;I=Y>Z?R^K:0;K=$?T^M:0;M=aa^N;$=G^P;ba=I^R;ca=K^T;Z=(c[k>>2]=T,ea(g[k>>2]));Y=ea(g[120520]);X=ea(g[120521]);W=ea(g[120522]);T=Z>Y;da=Z>X;fa=Z>W;ga=Z>ea(g[120523]);W=(c[k>>2]=M,ea(g[k>>2]));X=ea(W-(c[k>>2]=N,ea(g[k>>2])));Y=(c[k>>2]=$,ea(g[k>>2]));V=ea(Y-(c[k>>2]=P,ea(g[k>>2])));U=(c[k>>2]=ba,ea(g[k>>2]));_=ea(U-(c[k>>2]=R,ea(g[k>>2])));ha=(c[k>>2]=ca,ea(g[k>>2]));ia=ea(o*X);X=ea(p*V);V=ea(q*_);_=ea(r*ea(ha-Z));Z=ea(s*ea(g[F>>2]));ja=ea(t*ea(g[F+4>>2]));ka=ea(u*ea(g[F+8>>2]));la=ea(ia+ea(w+Z));Z=ea(X+ea(x+ja));ja=ea(V+ea(y+ka));ka=ea(_+ea(z+ea(v*ea(g[F+12>>2]))));_=ea(W+(T?la:ea(0.0)));la=ea(Y+(da?Z:ea(0.0)));Z=ea(U+(fa?ja:ea(0.0)));ja=ea(ha+(ga?ka:ea(0.0)));ka=ea(_);_=ea(la);la=ea(Z);Z=ea(ja);g[E>>2]=ka;g[H>>2]=_;g[J>>2]=la;g[L>>2]=Z;Z=(c[k>>2]=c[120496]&aa^M,ea(g[k>>2]));la=ea(g[e>>2]);_=ea(Z+(T?la:ea(0.0)));la=(c[k>>2]=c[120497]&G^$,ea(g[k>>2]));Z=ea(g[A>>2]);ka=ea(la+(da?Z:ea(0.0)));Z=(c[k>>2]=c[120498]&I^ba,ea(g[k>>2]));la=ea(g[B>>2]);ja=ea(Z+(fa?la:ea(0.0)));la=(c[k>>2]=c[120499]&K^ca,ea(g[k>>2]));Z=ea(g[C>>2]);ha=ea(la+(ga?Z:ea(0.0)));Z=ea(_);_=ea(ka);ka=ea(ja);ja=ea(ha);g[D>>2]=Z;g[O>>2]=_;g[Q>>2]=ka;g[S>>2]=ja;E=E+16|0;if((E|0)==(l|0))break;else{D=D+16|0;F=F+16|0}}i=f;return}else{if(n){i=f;return}v=ea(g[d+4>>2]);z=ea(g[d+8>>2]);y=ea(g[d+12>>2]);x=ea(g[d+16>>2]);w=ea(g[d+20>>2]);u=ea(g[d+24>>2]);t=ea(g[d+28>>2]);s=ea(g[d+32>>2]);r=ea(g[h>>2]);q=ea(g[b+624>>2]);p=ea(g[b+628>>2]);o=ea(g[b+632>>2]);ja=ea(g[b+636>>2]);ka=ea(g[b+640>>2]);_=ea(g[b+644>>2]);Z=ea(g[b+648>>2]);ha=ea(g[b+652>>2]);la=ea(g[b+656>>2]);U=ea(g[b+660>>2]);Y=ea(g[b+664>>2]);W=ea(g[b+668>>2]);V=ea(g[b+672>>2]);X=ea(g[b+676>>2]);ia=ea(g[b+680>>2]);ma=ea(g[b+684>>2]);na=ea(g[b+688>>2]);oa=ea(g[b+692>>2]);pa=ea(g[b+696>>2]);qa=ea(g[b+700>>2]);ra=ea(g[b+704>>2]);sa=ea(g[b+708>>2]);ta=ea(g[b+712>>2]);b=e+4|0;h=e+8|0;n=e+12|0;F=m;m=j;j=c[d>>2]|0;while(1){d=c[m>>2]|0;D=m+4|0;E=c[D>>2]|0;C=m+8|0;B=c[C>>2]|0;A=m+12|0;S=c[A>>2]|0;Q=c[F>>2]|0;O=F+4|0;ga=c[O>>2]|0;ca=F+8|0;K=c[ca>>2]|0;fa=F+12|0;ba=c[fa>>2]|0;ua=(c[k>>2]=d,ea(g[k>>2]));va=ea(g[120524]);wa=(c[k>>2]=E,ea(g[k>>2]));xa=ea(g[120525]);ya=(c[k>>2]=B,ea(g[k>>2]));za=ea(g[120526]);Aa=(c[k>>2]=S,ea(g[k>>2]));I=Aa>ea(g[120527]);da=ua>va?Q^d:0;d=wa>xa?ga^E:0;E=ya>za?K^B:0;B=I?ba^S:0;S=da^Q;I=d^ga;$=E^K;G=B^ba;za=(c[k>>2]=ba,ea(g[k>>2]));ya=ea(g[120520]);xa=ea(g[120521]);wa=ea(g[120522]);ba=za>ya;T=za>xa;M=za>wa;aa=za>ea(g[120523]);za=ea(v*ea(g[j>>2]));wa=ea(z*ea(g[j+4>>2]));xa=ea(y*ea(g[j+8>>2]));ya=ea(w+za);za=ea(u+wa);wa=ea(t+xa);xa=ea(s+ea(x*ea(g[j+12>>2])));va=(c[k>>2]=Q,ea(g[k>>2]));ua=ea(ea(r*va)+ya);ya=ea(ea(q*va)+za);za=ea(ea(p*va)+wa);wa=ea(ea(o*va)+xa);xa=(c[k>>2]=ga,ea(g[k>>2]));va=ea(ea(ja*xa)+ua);ua=ea(ea(ka*xa)+ya);ya=ea(ea(_*xa)+za);za=ea(ea(Z*xa)+wa);wa=(c[k>>2]=K,ea(g[k>>2]));xa=ea(ea(ha*wa)+va);va=ea(ea(la*wa)+ua);ua=ea(ea(U*wa)+ya);ya=ea(ea(Y*wa)+za);za=(c[k>>2]=S,ea(g[k>>2]));wa=ea(ea(W*za)+xa);xa=ea(ea(V*za)+va);va=ea(ea(X*za)+ua);ua=ea(ea(ia*za)+ya);ya=(c[k>>2]=I,ea(g[k>>2]));Aa=ea(ea(ma*ya)+wa);wa=ea(ea(na*ya)+xa);xa=ea(ea(oa*ya)+va);va=ea(ea(pa*ya)+ua);ua=(c[k>>2]=$,ea(g[k>>2]));Ba=ea(ea(qa*ua)+Aa);Aa=ea(ea(ra*ua)+wa);wa=ea(ea(sa*ua)+xa);xa=ea(ea(ta*ua)+va);va=ea(za+(ba?Ba:ea(0.0)));Ba=ea(ya+(T?Aa:ea(0.0)));Aa=ea(ua+(M?wa:ea(0.0)));wa=(c[k>>2]=G,ea(g[k>>2]));ua=ea(wa+(aa?xa:ea(0.0)));xa=ea(va);va=ea(Ba);Ba=ea(Aa);Aa=ea(ua);g[m>>2]=xa;g[D>>2]=va;g[C>>2]=Ba;g[A>>2]=Aa;Aa=(c[k>>2]=c[120496]&da^S,ea(g[k>>2]));Ba=ea(g[e>>2]);va=ea(Aa+(ba?Ba:ea(0.0)));Ba=(c[k>>2]=c[120497]&d^I,ea(g[k>>2]));Aa=ea(g[b>>2]);xa=ea(Ba+(T?Aa:ea(0.0)));Aa=(c[k>>2]=c[120498]&E^$,ea(g[k>>2]));Ba=ea(g[h>>2]);ua=ea(Aa+(M?Ba:ea(0.0)));Ba=(c[k>>2]=c[120499]&B^G,ea(g[k>>2]));Aa=ea(g[n>>2]);wa=ea(Ba+(aa?Aa:ea(0.0)));Aa=ea(va);va=ea(xa);xa=ea(ua);ua=ea(wa);g[F>>2]=Aa;g[O>>2]=va;g[ca>>2]=xa;g[fa>>2]=ua;m=m+16|0;if((m|0)==(l|0))break;else{F=F+16|0;j=j+16|0}}i=f;return}}function d$a(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);h=ea(h);var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;j=i;if(a>>>0<b>>>0){l=a;m=d}else{i=j;return}while(1){d=c[l>>2]|0;a=l+4|0;n=c[a>>2]|0;o=l+8|0;p=c[o>>2]|0;q=l+12|0;r=c[q>>2]|0;s=l+16|0;t=c[s>>2]|0;u=l+20|0;v=c[u>>2]|0;w=l+24|0;x=c[w>>2]|0;y=l+28|0;z=c[y>>2]|0;A=l+32|0;B=c[A>>2]|0;C=l+36|0;D=c[C>>2]|0;E=l+40|0;F=c[E>>2]|0;G=l+44|0;H=c[G>>2]|0;I=l+48|0;J=c[I>>2]|0;K=l+52|0;L=c[K>>2]|0;M=l+56|0;N=c[M>>2]|0;O=l+60|0;P=c[O>>2]|0;Q=c[120504]|0;R=c[120505]|0;S=c[120506]|0;U=c[120507]|0;V=ea(g[m>>2]);W=ea(V-(c[k>>2]=Q&d,ea(g[k>>2])));V=ea(g[m+4>>2]);X=ea(V-(c[k>>2]=R&n,ea(g[k>>2])));V=ea(g[m+8>>2]);Y=ea(V-(c[k>>2]=S&p,ea(g[k>>2])));V=ea(g[m+12>>2]);Z=ea(V-(c[k>>2]=U&r,ea(g[k>>2])));V=ea(g[m+16>>2]);_=ea(V-(c[k>>2]=Q&t,ea(g[k>>2])));V=ea(g[m+20>>2]);$=ea(V-(c[k>>2]=R&v,ea(g[k>>2])));V=ea(g[m+24>>2]);aa=ea(V-(c[k>>2]=S&x,ea(g[k>>2])));V=ea(g[m+28>>2]);ba=ea(V-(c[k>>2]=U&z,ea(g[k>>2])));V=ea(g[m+32>>2]);ca=ea(V-(c[k>>2]=Q&B,ea(g[k>>2])));V=ea(g[m+36>>2]);da=ea(V-(c[k>>2]=R&D,ea(g[k>>2])));V=ea(g[m+40>>2]);fa=ea(V-(c[k>>2]=S&F,ea(g[k>>2])));V=ea(g[m+44>>2]);ga=ea(V-(c[k>>2]=U&H,ea(g[k>>2])));V=ea(g[m+48>>2]);ha=ea(V-(c[k>>2]=Q&J,ea(g[k>>2])));V=ea(g[m+52>>2]);ia=ea(V-(c[k>>2]=R&L,ea(g[k>>2])));V=ea(g[m+56>>2]);ja=ea(V-(c[k>>2]=S&N,ea(g[k>>2])));V=ea(g[m+60>>2]);ka=ea(V-(c[k>>2]=U&P,ea(g[k>>2])));V=ea(W*W);la=ea(_*_);ma=ea(ca*ca);na=ea(ha*ha);oa=ea(V+ea(g[120512]));V=ea(la+ea(g[120513]));la=ea(ma+ea(g[120514]));ma=ea(ea(Y*Y)+ea(ea(X*X)+oa));oa=ea(ea(aa*aa)+ea(ea($*$)+V));V=ea(ea(fa*fa)+ea(ea(da*da)+la));la=ea(ea(ja*ja)+ea(ea(ia*ia)+ea(na+ea(g[120515]))));na=ea(ea(Z*e)+f);pa=ea(ea(ba*e)+f);qa=ea(ea(ga*e)+f);ra=ea(ea(ka*e)+f);sa=na>ea(0.0);ta=sa?na:ea(0.0);sa=pa>ea(0.0);na=sa?pa:ea(0.0);sa=qa>ea(0.0);pa=sa?qa:ea(0.0);sa=ra>ea(0.0);qa=sa?ra:ea(0.0);ra=ea(ea(1.0)-ea(ta*ea(ea(1.0)/ea(T(ea(ma))))));ma=ea(ea(1.0)-ea(na*ea(ea(1.0)/ea(T(ea(oa))))));oa=ea(ea(1.0)-ea(pa*ea(ea(1.0)/ea(T(ea(V))))));V=ea(ea(1.0)-ea(qa*ea(ea(1.0)/ea(T(ea(la))))));sa=ra>ea(0.0);ua=ma>ea(0.0);va=oa>ea(0.0);wa=V>ea(0.0);if(sa|ua|va|wa){xa=(g[k>>2]=ka,c[k>>2]|0);ya=(g[k>>2]=fa,c[k>>2]|0);za=(g[k>>2]=$,c[k>>2]|0);Aa=(g[k>>2]=W,c[k>>2]|0);Ba=(g[k>>2]=ja,c[k>>2]|0);Ca=(g[k>>2]=ia,c[k>>2]|0);Da=(g[k>>2]=da,c[k>>2]|0);Ea=(g[k>>2]=ha,c[k>>2]|0);Fa=(g[k>>2]=ca,c[k>>2]|0);Ga=(g[k>>2]=_,c[k>>2]|0);Ha=(g[k>>2]=ga,c[k>>2]|0);Ia=(g[k>>2]=ba,c[k>>2]|0);Ja=(g[k>>2]=aa,c[k>>2]|0);Ka=(g[k>>2]=Z,c[k>>2]|0);La=(g[k>>2]=Y,c[k>>2]|0);Ma=(g[k>>2]=X,c[k>>2]|0);X=ea(g[120524]);Y=ea(g[120525]);Z=ea(g[120526]);aa=ea(g[120527]);Na=ta>X;Oa=na>Y;Pa=pa>Z;ba=ea(ra*h);ra=ea(ma*h);ma=ea(oa*h);oa=ea(V*h);V=sa?ba:ea(0.0);ba=ea((c[k>>2]=Aa&Q,ea(g[k>>2]))*V);ga=ea((c[k>>2]=Ma&R,ea(g[k>>2]))*V);_=ea((c[k>>2]=La&S,ea(g[k>>2]))*V);ca=ea((c[k>>2]=Ka&U,ea(g[k>>2]))*V);V=(c[k>>2]=d,ea(g[k>>2]));ha=ea(ba+(Na?V:ea(0.0)));V=(c[k>>2]=n,ea(g[k>>2]));ba=ea(ga+(ta>Y?V:ea(0.0)));V=(c[k>>2]=p,ea(g[k>>2]));ga=ea(_+(ta>Z?V:ea(0.0)));V=(c[k>>2]=r,ea(g[k>>2]));_=ea(ca+(ta>aa?V:ea(0.0)));V=ea(ha);ha=ea(ba);ba=ea(ga);ga=ea(_);g[l>>2]=V;g[a>>2]=ha;g[o>>2]=ba;g[q>>2]=ga;ga=ua?ra:ea(0.0);ra=ea(ga*(c[k>>2]=c[120504]&Ga,ea(g[k>>2])));ba=ea(ga*(c[k>>2]=c[120505]&za,ea(g[k>>2])));ha=ea(ga*(c[k>>2]=c[120506]&Ja,ea(g[k>>2])));V=ea(ga*(c[k>>2]=c[120507]&Ia,ea(g[k>>2])));ga=(c[k>>2]=t,ea(g[k>>2]));_=ea((na>X?ga:ea(0.0))+ra);ra=(c[k>>2]=v,ea(g[k>>2]));ga=ea((Oa?ra:ea(0.0))+ba);ba=(c[k>>2]=x,ea(g[k>>2]));ra=ea((na>Z?ba:ea(0.0))+ha);ha=(c[k>>2]=z,ea(g[k>>2]));ba=ea((na>aa?ha:ea(0.0))+V);V=ea(_);_=ea(ga);ga=ea(ra);ra=ea(ba);g[s>>2]=V;g[u>>2]=_;g[w>>2]=ga;g[y>>2]=ra;ra=va?ma:ea(0.0);ma=ea(ra*(c[k>>2]=c[120504]&Fa,ea(g[k>>2])));ga=ea(ra*(c[k>>2]=c[120505]&Da,ea(g[k>>2])));_=ea(ra*(c[k>>2]=c[120506]&ya,ea(g[k>>2])));V=ea(ra*(c[k>>2]=c[120507]&Ha,ea(g[k>>2])));ra=(c[k>>2]=B,ea(g[k>>2]));ba=ea((pa>X?ra:ea(0.0))+ma);ma=(c[k>>2]=D,ea(g[k>>2]));ra=ea((pa>Y?ma:ea(0.0))+ga);ga=(c[k>>2]=F,ea(g[k>>2]));ma=ea((Pa?ga:ea(0.0))+_);_=(c[k>>2]=H,ea(g[k>>2]));ga=ea((pa>aa?_:ea(0.0))+V);V=ea(ba);ba=ea(ra);ra=ea(ma);ma=ea(ga);g[A>>2]=V;g[C>>2]=ba;g[E>>2]=ra;g[G>>2]=ma;ma=wa?oa:ea(0.0);oa=ea(ma*(c[k>>2]=c[120504]&Ea,ea(g[k>>2])));ra=ea(ma*(c[k>>2]=c[120505]&Ca,ea(g[k>>2])));ba=ea(ma*(c[k>>2]=c[120506]&Ba,ea(g[k>>2])));V=ea(ma*(c[k>>2]=c[120507]&xa,ea(g[k>>2])));ma=(c[k>>2]=J,ea(g[k>>2]));ga=ea((Na?ma:ea(0.0))+oa);oa=(c[k>>2]=L,ea(g[k>>2]));ma=ea((Oa?oa:ea(0.0))+ra);ra=(c[k>>2]=N,ea(g[k>>2]));oa=ea((Pa?ra:ea(0.0))+ba);ba=(c[k>>2]=P,ea(g[k>>2]));ra=ea((qa>aa?ba:ea(0.0))+V);V=ea(ga);ga=ea(ma);ma=ea(oa);oa=ea(ra);g[I>>2]=V;g[K>>2]=ga;g[M>>2]=ma;g[O>>2]=oa}l=l+64|0;if(l>>>0>=b>>>0)break;else m=m+64|0}i=j;return}function e$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0;e=i;if(a>>>0<b>>>0){f=a;h=d}else{i=e;return}while(1){d=c[f>>2]|0;a=f+4|0;j=c[a>>2]|0;l=f+8|0;m=c[l>>2]|0;n=f+12|0;o=c[n>>2]|0;p=f+16|0;q=c[p>>2]|0;r=f+20|0;s=c[r>>2]|0;t=f+24|0;u=c[t>>2]|0;v=f+28|0;w=c[v>>2]|0;x=f+32|0;y=c[x>>2]|0;z=f+36|0;A=c[z>>2]|0;B=f+40|0;C=c[B>>2]|0;D=f+44|0;E=c[D>>2]|0;F=f+48|0;G=c[F>>2]|0;H=f+52|0;I=c[H>>2]|0;J=f+56|0;K=c[J>>2]|0;L=f+60|0;M=c[L>>2]|0;N=c[120504]|0;O=c[120505]|0;P=c[120506]|0;Q=c[120507]|0;R=ea(g[h>>2]);S=ea(R-(c[k>>2]=N&d,ea(g[k>>2])));R=ea(g[h+4>>2]);U=ea(R-(c[k>>2]=O&j,ea(g[k>>2])));R=ea(g[h+8>>2]);V=ea(R-(c[k>>2]=P&m,ea(g[k>>2])));R=ea(g[h+12>>2]);W=ea(R-(c[k>>2]=Q&o,ea(g[k>>2])));R=ea(g[h+16>>2]);X=ea(R-(c[k>>2]=N&q,ea(g[k>>2])));R=ea(g[h+20>>2]);Y=ea(R-(c[k>>2]=O&s,ea(g[k>>2])));R=ea(g[h+24>>2]);Z=ea(R-(c[k>>2]=P&u,ea(g[k>>2])));R=ea(g[h+28>>2]);_=ea(R-(c[k>>2]=Q&w,ea(g[k>>2])));R=ea(g[h+32>>2]);$=ea(R-(c[k>>2]=N&y,ea(g[k>>2])));R=ea(g[h+36>>2]);aa=ea(R-(c[k>>2]=O&A,ea(g[k>>2])));R=ea(g[h+40>>2]);ba=ea(R-(c[k>>2]=P&C,ea(g[k>>2])));R=ea(g[h+44>>2]);ca=ea(R-(c[k>>2]=Q&E,ea(g[k>>2])));R=ea(g[h+48>>2]);da=ea(R-(c[k>>2]=N&G,ea(g[k>>2])));R=ea(g[h+52>>2]);fa=ea(R-(c[k>>2]=O&I,ea(g[k>>2])));R=ea(g[h+56>>2]);ga=ea(R-(c[k>>2]=P&K,ea(g[k>>2])));R=ea(g[h+60>>2]);ha=ea(R-(c[k>>2]=Q&M,ea(g[k>>2])));R=ea(S*S);ia=ea(X*X);ja=ea($*$);ka=ea(da*da);la=ea(R+ea(g[120512]));R=ea(ia+ea(g[120513]));ia=ea(ja+ea(g[120514]));ja=ea(ea(1.0)-ea(W*ea(ea(1.0)/ea(T(ea(ea(V*V)+ea(ea(U*U)+la)))))));la=ea(ea(1.0)-ea(_*ea(ea(1.0)/ea(T(ea(ea(Z*Z)+ea(ea(Y*Y)+R)))))));R=ea(ea(1.0)-ea(ca*ea(ea(1.0)/ea(T(ea(ea(ba*ba)+ea(ea(aa*aa)+ia)))))));ia=ea(ea(1.0)-ea(ha*ea(ea(1.0)/ea(T(ea(ea(ga*ga)+ea(ea(fa*fa)+ea(ka+ea(g[120515])))))))));ma=ja<ea(0.0);na=la<ea(0.0);oa=R<ea(0.0);pa=ia<ea(0.0);if(ma|na|oa|pa){qa=(g[k>>2]=ha,c[k>>2]|0);ra=(g[k>>2]=ba,c[k>>2]|0);sa=(g[k>>2]=Y,c[k>>2]|0);ta=(g[k>>2]=S,c[k>>2]|0);ua=(g[k>>2]=ga,c[k>>2]|0);va=(g[k>>2]=fa,c[k>>2]|0);wa=(g[k>>2]=aa,c[k>>2]|0);xa=(g[k>>2]=da,c[k>>2]|0);ya=(g[k>>2]=$,c[k>>2]|0);za=(g[k>>2]=X,c[k>>2]|0);Aa=(g[k>>2]=ca,c[k>>2]|0);Ba=(g[k>>2]=_,c[k>>2]|0);Ca=(g[k>>2]=Z,c[k>>2]|0);Da=(g[k>>2]=W,c[k>>2]|0);Ea=(g[k>>2]=V,c[k>>2]|0);Fa=(g[k>>2]=U,c[k>>2]|0)&O;U=ma?ja:ea(0.0);ja=ea((c[k>>2]=ta&N,ea(g[k>>2]))*U);V=ea((c[k>>2]=Fa,ea(g[k>>2]))*U);W=ea((c[k>>2]=Ea&P,ea(g[k>>2]))*U);Z=ea((c[k>>2]=Da&Q,ea(g[k>>2]))*U);U=ea((c[k>>2]=d,ea(g[k>>2]))+ja);ja=ea((c[k>>2]=j,ea(g[k>>2]))+V);V=ea((c[k>>2]=m,ea(g[k>>2]))+W);W=ea((c[k>>2]=o,ea(g[k>>2]))+Z);Z=ea(U);U=ea(ja);ja=ea(V);V=ea(W);g[f>>2]=Z;g[a>>2]=U;g[l>>2]=ja;g[n>>2]=V;V=na?la:ea(0.0);la=ea(V*(c[k>>2]=c[120504]&za,ea(g[k>>2])));ja=ea(V*(c[k>>2]=c[120505]&sa,ea(g[k>>2])));U=ea(V*(c[k>>2]=c[120506]&Ca,ea(g[k>>2])));Z=ea(V*(c[k>>2]=c[120507]&Ba,ea(g[k>>2])));V=ea((c[k>>2]=q,ea(g[k>>2]))+la);la=ea((c[k>>2]=s,ea(g[k>>2]))+ja);ja=ea((c[k>>2]=u,ea(g[k>>2]))+U);U=ea((c[k>>2]=w,ea(g[k>>2]))+Z);Z=ea(V);V=ea(la);la=ea(ja);ja=ea(U);g[p>>2]=Z;g[r>>2]=V;g[t>>2]=la;g[v>>2]=ja;ja=oa?R:ea(0.0);R=ea(ja*(c[k>>2]=c[120504]&ya,ea(g[k>>2])));la=ea(ja*(c[k>>2]=c[120505]&wa,ea(g[k>>2])));V=ea(ja*(c[k>>2]=c[120506]&ra,ea(g[k>>2])));Z=ea(ja*(c[k>>2]=c[120507]&Aa,ea(g[k>>2])));ja=ea((c[k>>2]=y,ea(g[k>>2]))+R);R=ea((c[k>>2]=A,ea(g[k>>2]))+la);la=ea((c[k>>2]=C,ea(g[k>>2]))+V);V=ea((c[k>>2]=E,ea(g[k>>2]))+Z);Z=ea(ja);ja=ea(R);R=ea(la);la=ea(V);g[x>>2]=Z;g[z>>2]=ja;g[B>>2]=R;g[D>>2]=la;la=pa?ia:ea(0.0);ia=ea(la*(c[k>>2]=c[120504]&xa,ea(g[k>>2])));R=ea(la*(c[k>>2]=c[120505]&va,ea(g[k>>2])));ja=ea(la*(c[k>>2]=c[120506]&ua,ea(g[k>>2])));Z=ea(la*(c[k>>2]=c[120507]&qa,ea(g[k>>2])));la=ea((c[k>>2]=G,ea(g[k>>2]))+ia);ia=ea((c[k>>2]=I,ea(g[k>>2]))+R);R=ea((c[k>>2]=K,ea(g[k>>2]))+ja);ja=ea((c[k>>2]=M,ea(g[k>>2]))+Z);Z=ea(la);la=ea(ia);ia=ea(R);R=ea(ja);g[F>>2]=Z;g[H>>2]=la;g[J>>2]=ia;g[L>>2]=R}f=f+64|0;if(f>>>0>=b>>>0)break;else h=h+64|0}i=e;return}function f$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)L_a(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function g$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;f=(b*24|0)+15&-16;g=(b<<2)+15&-16;h=UJa(d+1|0,(g*5|0)+f|0,483416,1594)|0;j=a+28|0;k=c[j>>2]|0;l=a+4|0;m=c[l>>2]|0;if(m)YEi(h|0,m|0,k*24|0)|0;PEi(h+(k*24|0)|0,0,(b-k|0)*24|0)|0;k=h+f|0;c[l>>2]=h;m=c[j>>2]|0;n=a+8|0;o=c[n>>2]|0;if(o)YEi(k|0,o|0,m<<2|0)|0;PEi(k+(m<<2)|0,0,b-m<<2|0)|0;m=f+g|0;f=h+m|0;c[n>>2]=k;k=c[j>>2]|0;n=a+12|0;o=c[n>>2]|0;if(o)YEi(f|0,o|0,k<<2|0)|0;PEi(f+(k<<2)|0,0,b-k<<2|0)|0;k=m+g|0;m=h+k|0;c[n>>2]=f;f=c[j>>2]|0;o=a+16|0;p=c[o>>2]|0;if(p)YEi(m|0,p|0,f<<2|0)|0;PEi(m+(f<<2)|0,0,b-f<<2|0)|0;f=k+g|0;k=h+f|0;c[o>>2]=m;m=c[j>>2]|0;o=a+24|0;p=c[o>>2]|0;if(p)YEi(k|0,p|0,m<<2|0)|0;PEi(k+(m<<2)|0,0,b-m<<2|0)|0;m=h+(f+g)|0;c[o>>2]=k;k=c[j>>2]|0;o=a+20|0;g=c[o>>2]|0;if(g)YEi(m|0,g|0,k<<2|0)|0;PEi(m+(k<<2)|0,0,b-k<<2|0)|0;c[o>>2]=m;m=a+32|0;o=b+-1|0;k=c[n>>2]|0;c[k+(o<<2)>>2]=c[m>>2];n=c[j>>2]|0;if(n>>>0<o>>>0)q=n;else{r=n;c[m>>2]=r;s=c[a>>2]|0;VJa(e,s);t=c[l>>2]|0;c[a>>2]=t;c[j>>2]=b;i=d;return}do{n=q;q=q+1|0;c[k+(n<<2)>>2]=q}while((q|0)!=(o|0));r=c[j>>2]|0;c[m>>2]=r;s=c[a>>2]|0;VJa(e,s);t=c[l>>2]|0;c[a>>2]=t;c[j>>2]=b;i=d;return}function h$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=a+12|0;g=c[f>>2]|0;h=UJa(d+1|0,(b<<3)+30&-32,483416,1105)|0;j=a+4|0;k=c[j>>2]|0;if(k)YEi(h|0,k|0,g<<2|0)|0;k=b-g<<2;PEi(h+(g<<2)|0,0,k|0)|0;l=h+((b<<2)+15&-16)|0;c[j>>2]=h;if(g>>>0<b>>>0){m=g;do{c[h+(m<<2)>>2]=1073741823;m=m+1|0}while((m|0)!=(b|0))}m=a+16|0;h=c[m>>2]|0;if(h)YEi(l|0,h|0,g<<2|0)|0;PEi(l+(g<<2)|0,0,k|0)|0;c[m>>2]=l;c[f>>2]=b;VJa(e,c[a>>2]|0);c[a>>2]=c[j>>2];i=d;return}function i$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e;g=b+20|0;h=c[g>>2]|0;j=(d+31|0)>>>5;k=(d*1048|0)+15&-16;l=(d<<2)+15&-16;m=d<<4;n=UJa(e+1|0,((j<<3)+30&2147483616)+k+(l<<1)+(d<<5)|0,483416,474)|0;o=b+4|0;p=c[o>>2]|0;if(p)YEi(n|0,p|0,h*1048|0)|0;p=d-h|0;PEi(n+(h*1048|0)|0,0,p*1048|0)|0;q=n+k|0;c[o>>2]=n;a:do if(h>>>0<d>>>0){r=n;s=h;while(1){PEi(r+(s*1048|0)|0,0,1024)|0;a[r+(s*1048|0)+1024>>0]=1;a[r+(s*1048|0)+1025>>0]=0;a[r+(s*1048|0)+1026>>0]=0;c[r+(s*1048|0)+1028>>2]=1073741823;c[r+(s*1048|0)+1032>>2]=1073741823;c[r+(s*1048|0)+1036>>2]=1073741823;c[r+(s*1048|0)+1040>>2]=1073741823;c[r+(s*1048|0)+1044>>2]=0;t=s+1|0;if((t|0)==(d|0))break a;r=c[o>>2]|0;s=t}}while(0);s=b+24|0;r=c[s>>2]|0;if(r)YEi(q|0,r|0,h<<2|0)|0;r=p<<2;PEi(q+(h<<2)|0,0,r|0)|0;t=k+l|0;k=n+t|0;c[s>>2]=q;q=b+36|0;s=c[q>>2]|0;if(s)YEi(k|0,s|0,h<<2|0)|0;PEi(k+(h<<2)|0,0,r|0)|0;r=t+l|0;l=n+r|0;c[q>>2]=k;k=b+8|0;q=c[k>>2]|0;if(q)YEi(l|0,q|0,h<<4|0)|0;q=p<<4;PEi(l+(h<<4)|0,0,q|0)|0;p=r+m|0;r=n+p|0;c[k>>2]=l;l=b+12|0;k=c[l>>2]|0;if(k)YEi(r|0,k|0,h<<4|0)|0;PEi(r+(h<<4)|0,0,q|0)|0;q=p+m|0;m=n+q|0;c[l>>2]=r;r=b+48|0;l=c[r>>2]|0;p=b+44|0;h=c[p>>2]|0;if(h)YEi(m|0,h|0,l<<2|0)|0;PEi(m+((l&2147483647)<<2)|0,0,j-l<<2|0)|0;l=n+(q+((j<<2)+15&1073741808))|0;c[p>>2]=m;m=j|-2147483648;c[r>>2]=m;r=b+60|0;p=c[r>>2]|0;q=p&2147483647;n=b+56|0;h=c[n>>2]|0;if(!h){u=l+(q<<2)|0;v=j-p|0;w=v<<2;PEi(u|0,0,w|0)|0;c[n>>2]=l;c[r>>2]=m;c[g>>2]=d;x=c[b>>2]|0;VJa(f,x);y=c[o>>2]|0;c[b>>2]=y;i=e;return}YEi(l|0,h|0,p<<2|0)|0;u=l+(q<<2)|0;v=j-p|0;w=v<<2;PEi(u|0,0,w|0)|0;c[n>>2]=l;c[r>>2]=m;c[g>>2]=d;x=c[b>>2]|0;VJa(f,x);y=c[o>>2]|0;c[b>>2]=y;i=e;return}function j$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+16388|0;g=c[f>>2]|0;do if(!((g|0)==0|(g|0)==(a|0))){h=c[a+16384>>2]|0;if(!h){VJa(e,g);break}j=c[h+16>>2]|0;if(j>>>0<=g>>>0?(j+(c[h+20>>2]|0)|0)>>>0>g>>>0:0){oTa(c[h>>2]|0);j=h+8|0;k=c[j>>2]|0;l=h+4|0;m=c[l>>2]|0;n=k;while(1){o=n+-1|0;p=m+(o<<2)|0;if((c[p>>2]|0)>>>0<g>>>0)n=o;else break}if(n>>>0<k>>>0){m=n;o=p;while(1){if(o)c[o>>2]=c[(c[l>>2]|0)+(m<<2)>>2];m=m+1|0;if((m|0)==(k|0))break;else o=o+4|0}}c[j>>2]=k+-1;pTa(c[h>>2]|0);break}VJa(d,g)}while(0);c[f>>2]=0;c[a+16392>>2]=0;i=b;return}function k$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+4100|0;g=c[f>>2]|0;do if(!((g|0)==0|(g|0)==(a|0))){h=c[a+4096>>2]|0;if(!h){VJa(e,g);break}j=c[h+16>>2]|0;if(j>>>0<=g>>>0?(j+(c[h+20>>2]|0)|0)>>>0>g>>>0:0){oTa(c[h>>2]|0);j=h+8|0;k=c[j>>2]|0;l=h+4|0;m=c[l>>2]|0;n=k;while(1){o=n+-1|0;p=m+(o<<2)|0;if((c[p>>2]|0)>>>0<g>>>0)n=o;else break}if(n>>>0<k>>>0){m=n;o=p;while(1){if(o)c[o>>2]=c[(c[l>>2]|0)+(m<<2)>>2];m=m+1|0;if((m|0)==(k|0))break;else o=o+4|0}}c[j>>2]=k+-1;pTa(c[h>>2]|0);break}VJa(d,g)}while(0);c[f>>2]=0;c[a+4104>>2]=0;i=b;return}function l$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=b+28|0;h=c[g>>2]|0;do if(!h){j=b+16|0;k=c[j>>2]|0;if(k>>>0<(c[b+20>>2]|0)>>>0){l=(c[b+4>>2]|0)+(k*1048|0)|0;c[j>>2]=k+1;m=l;n=k;break}else{i$a(b,k+32|0);k=c[j>>2]|0;l=(c[b+4>>2]|0)+(k*1048|0)|0;c[j>>2]=k+1;m=l;n=k;break}}else{k=h+-1|0;l=c[(c[b+24>>2]|0)+(k<<2)>>2]|0;c[g>>2]=k;m=(c[b+4>>2]|0)+(l*1048|0)|0;n=l}while(0);a[m+1024>>0]=e&1;c[m+1044>>2]=d;d=(c[b+44>>2]|0)+(n>>>5<<2)|0;c[d>>2]=c[d>>2]&~(1<<(n&31));d=b+40|0;e=c[d>>2]|0;if(!e){g=b+32|0;h=c[g>>2]|0;c[g>>2]=h+-1;o=h;p=m+1036|0;c[p>>2]=o;i=f;return n|0}else{h=e+-1|0;e=c[(c[b+36>>2]|0)+(h<<2)>>2]|0;c[d>>2]=h;o=e;p=m+1036|0;c[p>>2]=o;i=f;return n|0}return 0}function m$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=a+20|0;f=c[e>>2]|0;g=(b+31|0)>>>5;h=(b*24|0)+15&-16;j=(b<<2)+15&-16;k=h+(b+15&-16)|0;l=UJa(d+1|0,k+((g<<3)+30&2147483616)+(j<<1)|0,483416,990)|0;m=a+4|0;n=c[m>>2]|0;if(n)YEi(l|0,n|0,f*24|0)|0;n=b-f|0;PEi(l+(f*24|0)|0,0,n*24|0)|0;o=l+h|0;c[m>>2]=l;p=a+8|0;q=c[p>>2]|0;if(q)YEi(o|0,q|0,f|0)|0;PEi(l+(f+h)|0,0,n|0)|0;h=l+k|0;c[p>>2]=o;o=a+12|0;p=c[o>>2]|0;if(p)YEi(h|0,p|0,f<<2|0)|0;p=n<<2;PEi(h+(f<<2)|0,0,p|0)|0;n=k+j|0;k=l+n|0;c[o>>2]=h;h=a+16|0;o=c[h>>2]|0;if(o)YEi(k|0,o|0,f<<2|0)|0;PEi(k+(f<<2)|0,0,p|0)|0;p=n+j|0;j=l+p|0;c[h>>2]=k;k=a+28|0;h=c[k>>2]|0;n=a+24|0;o=c[n>>2]|0;if(o)YEi(j|0,o|0,h<<2|0)|0;PEi(j+((h&2147483647)<<2)|0,0,g-h<<2|0)|0;h=l+(p+((g<<2)+15&1073741808))|0;c[n>>2]=j;j=g|-2147483648;c[k>>2]=j;k=a+40|0;n=c[k>>2]|0;p=a+36|0;l=c[p>>2]|0;if(l)YEi(h|0,l|0,n<<2|0)|0;PEi(h+((n&2147483647)<<2)|0,0,g-n<<2|0)|0;c[p>>2]=h;c[k>>2]=j;j=c[a>>2]|0;if(j)VJa(d,j);j=c[m>>2]|0;c[a>>2]=j;c[e>>2]=b;e=a+48|0;a=b+-1|0;c[j+(a*24|0)>>2]=c[e>>2];if(f>>>0<a>>>0)r=f;else{c[e>>2]=f;i=d;return}do{b=r;r=r+1|0;c[j+(b*24|0)>>2]=r}while((r|0)!=(a|0));c[e>>2]=f;i=d;return}function n$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=a+36|0;h=a+44|0;j=c[h>>2]|0;if((j|0)==1073741823){k=a+40|0;l=c[k>>2]|0;m=l<<1;n=m>>>0<64?64:m;m=UJa(e+1|0,n<<3,483416,1503)|0;o=c[g>>2]|0;if(o){YEi(m|0,o|0,l<<3|0)|0;PEi(m+(l<<3)|0,0,n-l<<3|0)|0}o=n+-1|0;c[m+(o<<3)>>2]=c[h>>2];if(l>>>0<o>>>0){p=l;do{l=p;p=p+1|0;c[m+(l<<3)>>2]=p}while((p|0)!=(o|0))}c[h>>2]=c[k>>2];VJa(f,c[g>>2]|0);c[g>>2]=m;c[k>>2]=n;q=m;r=c[h>>2]|0}else{q=c[g>>2]|0;r=j}c[h>>2]=c[q+(r<<3)>>2];c[q+(r<<3)>>2]=0;c[q+(r<<3)+4>>2]=0;q=d;d=c[q+4>>2]|0;h=(c[g>>2]|0)+(r<<3)|0;c[h>>2]=c[q>>2];c[h+4>>2]=d;c[(c[a+24>>2]|0)+(b<<2)>>2]=r;i=e;return}function o$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=a+48|0;h=a+56|0;j=c[h>>2]|0;if((j|0)==1073741823){k=a+52|0;l=c[k>>2]|0;m=l<<1;n=m>>>0<64?64:m;m=UJa(e+1|0,n<<4,483416,1503)|0;o=c[g>>2]|0;if(o){YEi(m|0,o|0,l<<4|0)|0;PEi(m+(l<<4)|0,0,n-l<<4|0)|0}o=n+-1|0;c[m+(o<<4)>>2]=c[h>>2];if(l>>>0<o>>>0){p=l;do{l=p;p=p+1|0;c[m+(l<<4)>>2]=p}while((p|0)!=(o|0))}c[h>>2]=c[k>>2];VJa(f,c[g>>2]|0);c[g>>2]=m;c[k>>2]=n;q=m;r=c[h>>2]|0}else{q=c[g>>2]|0;r=j}j=q+(r<<4)|0;c[h>>2]=c[j>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;j=(c[g>>2]|0)+(r<<4)|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[(c[a+24>>2]|0)+(b<<2)>>2]=r;i=e;return}function p$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;g=e+4|0;h=b+15&-16;oTa(c[a>>2]|0);b=a+4|0;j=a+8|0;k=c[j>>2]|0;l=c[b>>2]|0;m=c[l+(k+-1<<2)>>2]|0;do if((m-(c[a+16>>2]|0)|0)<(h|0))if(d)n=UJa(g,h,482328,99)|0;else n=0;else{o=m+(0-h)|0;c[f>>2]=o;if((c[a+12>>2]&2147483647)>>>0<=k>>>0){m0a(b,f)|0;n=c[f>>2]|0;break}p=l+(k<<2)|0;if(p)c[p>>2]=o;c[j>>2]=k+1;n=o}while(0);pTa(c[a>>2]|0);i=e;return n|0}function q$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+16|0;d=b+1|0;e=b;f=c[a>>2]|0;if(!f){i=b;return}g=a+4|0;h=c[g>>2]|0;j=h&2147483647;if(j){k=0;l=0;do{m=c[f+(l<<2)>>2]|0;n=m-(m>>>1&1431655765)|0;m=(n>>>2&858993459)+(n&858993459)|0;k=((da((m>>>4)+m&252645135,16843009)|0)>>>24)+k|0;l=l+1|0}while((l|0)!=(j|0));j=a+20|0;l=c[j>>2]|0;if(k>>>0>l>>>0){f=k+31&-32;k=a+12|0;m=c[k>>2]|0;n=UJa(d,f<<2,483416,76)|0;if(m)YEi(n|0,m|0,l<<2|0)|0;PEi(n+(l<<2)|0,0,f-l<<2|0)|0;VJa(e,m);c[k>>2]=n;c[j>>2]=f;o=c[g>>2]|0}else o=h}else o=h;h=o&2147483647;a:do if(h){o=c[a>>2]|0;f=0;while(1){p=c[o+(f<<2)>>2]|0;if(p)break;j=f+1|0;if(j>>>0<h>>>0)f=j;else{q=0;break a}}j=c[425648+((da(p&0-p,125613361)|0)>>>27<<2)>>2]|f<<5;n=p+-1&p;b:do if(!n){k=f;while(1){m=k+1|0;if(m>>>0>=h>>>0){r=m;s=0;break b}e=c[o+(m<<2)>>2]|0;if(!e)k=m;else{r=m;s=e;break}}}else{r=f;s=n}while(0);if((j|0)!=-1){n=c[a+12>>2]|0;f=s;o=r;k=j;e=0;while(1){m=o<<5;l=f;d=k;t=e;while(1){c[n+(t<<2)>>2]=d;u=t+1|0;if(!l){q=u;break a}d=c[425648+((da(l&0-l,125613361)|0)>>>27<<2)>>2]|m;l=l+-1&l;v=c[g>>2]&2147483647;if(!l){w=o;break}if((d|0)==-1){q=u;break a}else t=u}while(1){w=w+1|0;if(w>>>0>=v>>>0){x=0;break}t=c[(c[a>>2]|0)+(w<<2)>>2]|0;if(t){x=t;break}}if((d|0)==-1){q=u;break}else{f=x;o=w;k=d;e=u}}}else q=0}else q=0;while(0);c[a+16>>2]=q;i=b;return}function r$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+1|0;e=b;f=a+516|0;g=c[f>>2]|0;do if(!((g|0)==0|(g|0)==(a|0))){h=c[a+512>>2]|0;if(!h){VJa(e,g);break}j=c[h+16>>2]|0;if(j>>>0<=g>>>0?(j+(c[h+20>>2]|0)|0)>>>0>g>>>0:0){oTa(c[h>>2]|0);j=h+8|0;k=c[j>>2]|0;l=h+4|0;m=c[l>>2]|0;n=k;while(1){o=n+-1|0;p=m+(o<<2)|0;if((c[p>>2]|0)>>>0<g>>>0)n=o;else break}if(n>>>0<k>>>0){m=n;o=p;while(1){if(o)c[o>>2]=c[(c[l>>2]|0)+(m<<2)>>2];m=m+1|0;if((m|0)==(k|0))break;else o=o+4|0}}c[j>>2]=k+-1;pTa(c[h>>2]|0);break}VJa(d,g)}while(0);c[f>>2]=0;c[a+520>>2]=-2147483648;i=b;return}function s$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?482704:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function t$a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<3)>>2]|0)>>>0<(c[b+(t<<3)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<3)|0;u=b+(r<<3)|0;v=s;w=c[v>>2]|0;x=c[v+4>>2]|0;v=u;y=c[v+4>>2]|0;z=s;c[z>>2]=c[v>>2];c[z+4>>2]=y;y=u;c[y>>2]=w;c[y+4>>2]=x}while((q|0)!=(p|0))}if(!o)break a;x=c[k+(o+-1<<2)>>2]|0;y=o+-2|0;j=c[k+(y<<2)>>2]|0;o=y;p=x}x=b+(((p+j|0)/2|0)<<3)|0;y=b+(j<<3)|0;w=c[x>>2]|0;u=c[y>>2]|0;if(w>>>0<u>>>0){z=y;v=c[z>>2]|0;s=c[z+4>>2]|0;z=x;A=c[z+4>>2]|0;B=y;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=x;c[A>>2]=v;c[A+4>>2]=s;C=v;D=c[y>>2]|0}else{C=w;D=u}u=b+(p<<3)|0;w=c[u>>2]|0;if(w>>>0<D>>>0){v=y;s=c[v>>2]|0;A=c[v+4>>2]|0;v=u;B=c[v+4>>2]|0;z=y;c[z>>2]=c[v>>2];c[z+4>>2]=B;B=u;c[B>>2]=s;c[B+4>>2]=A;E=s;F=c[x>>2]|0}else{E=w;F=C}if(E>>>0<F>>>0){w=x;s=c[w>>2]|0;A=c[w+4>>2]|0;w=u;B=c[w+4>>2]|0;z=x;c[z>>2]=c[w>>2];c[z+4>>2]=B;B=u;c[B>>2]=s;c[B+4>>2]=A}A=p+-1|0;B=b+(A<<3)|0;s=x;u=c[s>>2]|0;z=c[s+4>>2]|0;s=B;w=c[s+4>>2]|0;v=x;c[v>>2]=c[s>>2];c[v+4>>2]=w;w=B;c[w>>2]=u;c[w+4>>2]=z;z=u;u=j;w=A;while(1){G=u;while(1){H=G+1|0;I=b+(H<<3)|0;if((c[I>>2]|0)>>>0<z>>>0)G=H;else{J=w;break}}do{J=J+-1|0;K=b+(J<<3)|0}while(z>>>0<(c[K>>2]|0)>>>0);A=I;L=c[A>>2]|0;M=c[A+4>>2]|0;if((H|0)>=(J|0))break;A=K;v=c[A+4>>2]|0;s=I;c[s>>2]=c[A>>2];c[s+4>>2]=v;v=K;c[v>>2]=L;c[v+4>>2]=M;z=c[B>>2]|0;u=H;w=J}w=B;u=c[w+4>>2]|0;z=I;c[z>>2]=c[w>>2];c[z+4>>2]=u;u=B;c[u>>2]=L;c[u+4>>2]=M;if((H-j|0)<(p-H|0)){if(o>>>0>=(h+-1|0)>>>0){u=h<<1;z=h<<3;if(!z)N=0;else{w=mKa()|0;v=c[(c[w>>2]|0)+8>>2]|0;s=pKa()|0;A=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;N=Bn[v&255](w,z,A?482608:544544,523928,148)|0}YEi(N|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=N;P=1;Q=u}else{A=mKa()|0;In[c[(c[A>>2]|0)+12>>2]&4095](A,k);O=N;P=1;Q=u}}else{O=k;P=d;Q=h}c[O+(o<<2)>>2]=j;c[O+(o+1<<2)>>2]=G;R=P;S=O;T=Q;U=G+2|0;V=p}else{u=G+2|0;if(o>>>0>=(h+-1|0)>>>0){A=h<<1;z=h<<3;if(!z)W=0;else{w=mKa()|0;v=c[(c[w>>2]|0)+8>>2]|0;s=pKa()|0;x=mo[c[(c[s>>2]|0)+24>>2]&4095](s)|0;W=Bn[v&255](w,z,x?482608:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){X=W;Y=1;Z=A}else{x=mKa()|0;In[c[(c[x>>2]|0)+12>>2]&4095](x,k);X=W;Y=1;Z=A}}else{X=k;Y=d;Z=h}c[X+(o<<2)>>2]=u;c[X+(o+1<<2)>>2]=p;R=Y;S=X;T=Z;U=j;V=G}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function u$a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=(a+255|0)>>>8;h=(g>>>0)/(b>>>0)|0;j=da(h,b)|0;k=h<<8;l=j-g+b|0;if(!l){m=0;n=0}else{o=da(h+1|0,b)|0;p=(o<<8)-(g<<8)|0;q=da(h,o+-1-g|0)|0;r=o-g|0;o=0;s=0;while(1){c[d+(s<<2)>>2]=o;c[e+(s<<2)>>2]=k;s=s+1|0;if((s|0)==(r|0))break;else o=o+k|0}m=da(h,p)|0;n=q<<8}q=k+256|0;if(l>>>0<b>>>0){k=da(g+-1-j|0,(h<<8)+256|0)|0;h=m;j=l;while(1){c[d+(j<<2)>>2]=h;c[e+(j<<2)>>2]=q;j=j+1|0;if(j>>>0>=b>>>0)break;else h=h+q|0}t=m+k|0}else t=n;c[e+(b+-1<<2)>>2]=a-t;if(b>>>0<6)u=b;else{i=f;return}do{c[d+(u<<2)>>2]=0;c[e+(u<<2)>>2]=0;u=u+1|0}while((u|0)!=6);i=f;return}function v$a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=(a+31|0)>>>5;h=(g>>>0)/(b>>>0)|0;j=da(h,b)|0;k=h<<5;l=j-g+b|0;if(!l){m=0;n=0}else{o=da(h+1|0,b)|0;p=(o<<5)-(g<<5)|0;q=da(h,o+-1-g|0)|0;r=o-g|0;o=0;s=0;while(1){c[d+(s<<2)>>2]=o;c[e+(s<<2)>>2]=k;s=s+1|0;if((s|0)==(r|0))break;else o=o+k|0}m=da(h,p)|0;n=q<<5}q=k+32|0;if(l>>>0<b>>>0){k=da(g+-1-j|0,(h<<5)+32|0)|0;h=m;j=l;while(1){c[d+(j<<2)>>2]=h;c[e+(j<<2)>>2]=q;j=j+1|0;if(j>>>0>=b>>>0)break;else h=h+q|0}t=m+k|0}else t=n;c[e+(b+-1<<2)>>2]=a-t;if(b>>>0<6)u=b;else{i=f;return}do{c[d+(u<<2)>>2]=0;c[e+(u<<2)>>2]=0;u=u+1|0}while((u|0)!=6);i=f;return}function w$a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)EDb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function x$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?483640:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else FDb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*40|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-40|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function y$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;GDb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else HDb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(IDb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,IDb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+40|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){FDb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function z$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=(a|0)==0;if(e){i=d;return}else f=0;do{c[b+(f*40|0)+32>>2]=0;f=f+1|0}while((f|0)!=(a|0));if(e){i=d;return}else g=0;do{e=g;g=g+1|0;if(g>>>0<a>>>0?(c[b+(e*40|0)+28>>2]|0)!=0:0){f=b+(e*40|0)+16|0;h=b+(e*40|0)+4|0;j=b+(e*40|0)+20|0;k=b+(e*40|0)+8|0;l=b+(e*40|0)+24|0;m=b+(e*40|0)+12|0;n=b+(e*40|0)+32|0;e=g;do{if(((((((c[b+(e*40|0)+28>>2]|0)!=0?(c[f>>2]|0)>>>0>(c[b+(e*40|0)+4>>2]|0)>>>0:0)?(c[b+(e*40|0)+16>>2]|0)>>>0>(c[h>>2]|0)>>>0:0)?(c[j>>2]|0)>>>0>(c[b+(e*40|0)+8>>2]|0)>>>0:0)?(c[b+(e*40|0)+20>>2]|0)>>>0>(c[k>>2]|0)>>>0:0)?(c[l>>2]|0)>>>0>(c[b+(e*40|0)+12>>2]|0)>>>0:0)?(c[b+(e*40|0)+24>>2]|0)>>>0>(c[m>>2]|0)>>>0:0){c[n>>2]=1;c[b+(e*40|0)+32>>2]=1}e=e+1|0}while((e|0)!=(a|0))}}while((g|0)!=(a|0));i=d;return}function A$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?484088:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function B$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?484088:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function C$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)B$a(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function D$a(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+16|0;l=k+1|0;m=k;n=Ora(f,b,e,8)|0;if(!n){o=0;i=k;return o|0}e=f+20|0;b=c[e>>2]|0;p=n;n=f+24|0;f=c[n>>2]|0;q=f+(p-b>>3)|0;if(!(a[q>>0]&8)){r=b;s=f}else{a[q>>0]=0;q=(c[n>>2]|0)+(p-(c[e>>2]|0)>>3)|0;a[q>>0]=d[q>>0]|0|1;q=c[e>>2]|0;f=c[h>>2]|0;if((f|0)==(c[j>>2]|0)){b=(f|0)==0?64:f<<1;t=UJa(l,b<<2,484896,217)|0;YEi(t|0,c[g>>2]|0,c[j>>2]<<2|0)|0;VJa(m,c[g>>2]|0);c[g>>2]=t;c[j>>2]=b;u=t;v=c[h>>2]|0;w=c[e>>2]|0}else{u=c[g>>2]|0;v=f;w=q}c[u+(v<<2)>>2]=(p-q|0)>>>3;c[h>>2]=(c[h>>2]|0)+1;h=(c[n>>2]|0)+(p-w>>3)|0;a[h>>0]=d[h>>0]|0|4;r=c[e>>2]|0;s=c[n>>2]|0}n=s+(p-r>>3)|0;a[n>>0]=(d[n>>0]|0)&253;o=1;i=k;return o|0}function E$a(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+16|0;l=k+1|0;m=k;n=Nra(f,b,e)|0;if(!n){i=k;return}e=f+20|0;b=c[e>>2]|0;o=n;n=f+24|0;f=c[n>>2]|0;p=f+(o-b>>3)|0;q=a[p>>0]|0;if(!(q&1)){a[p>>0]=q&255|1;q=c[e>>2]|0;p=c[h>>2]|0;if((p|0)==(c[j>>2]|0)){r=(p|0)==0?64:p<<1;s=UJa(l,r<<2,484896,217)|0;YEi(s|0,c[g>>2]|0,c[j>>2]<<2|0)|0;VJa(m,c[g>>2]|0);c[g>>2]=s;c[j>>2]=r;t=c[e>>2]|0;u=s;v=c[h>>2]|0}else{t=q;u=c[g>>2]|0;v=p}c[u+(v<<2)>>2]=(o-q|0)>>>3;c[h>>2]=(c[h>>2]|0)+1;w=t;x=c[n>>2]|0}else{w=b;x=f}f=x+(o-w>>3)|0;a[f>>0]=d[f>>0]|0|2;i=k;return}function F$a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?541832:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?541832:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function G$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?486856:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function H$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?486472:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function I$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?487232:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function J$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+16|0;f=c[b>>2]|0;h=ea(e>>>0);j=~~ea(h*ea(g[a+24>>2]))>>>0;k=e<<2;l=(j<<2)+k|0;m=(0-l&12)+l|0;l=UJa(a,m+(j*12|0)|0,529024,354)|0;n=l+k|0;o=l+m|0;PEi(l|0,-1,k|0)|0;k=a+36|0;m=a+4|0;if(c[k>>2]|0){p=e+-1|0;q=0;do{r=c[m>>2]|0;s=r+(q*12|0)+4|0;t=c[s>>2]|0;u=t+~(t<<15)|0;t=(u>>>10^u)*9|0;u=t>>>6^t;t=u+~(u<<11)|0;u=c[r+(q*12|0)>>2]|0;v=u;w=v+~(v<<15)|0;v=(w>>>10^w)*9|0;w=v>>>6^v;v=w+~(w<<11)|0;w=l+(((t>>>16^t^(v^-57320555^v>>>16)*1000007)&p)<<2)|0;c[n+(q<<2)>>2]=c[w>>2];c[w>>2]=q;w=o+(q*12|0)|0;if(w){c[w>>2]=u;c[o+(q*12|0)+4>>2]=c[s>>2];c[o+(q*12|0)+8>>2]=c[r+(q*12|0)+8>>2]}q=q+1|0}while(q>>>0<(c[k>>2]|0)>>>0)}VJa(a,c[a>>2]|0);c[a>>2]=l;c[a+12>>2]=l;c[a+20>>2]=e;c[a+8>>2]=n;c[m>>2]=o;c[b>>2]=j;j=a+28|0;if((c[j>>2]|0)!=-1){i=d;return}c[j>>2]=f;i=d;return}function K$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?486088:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function L$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;e=a+4|0;f=a+12|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[h+(g<<3)+4>>2]|0;if((j|0)!=128){k=h;l=g;m=j;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m*96|0)|0;i=b;return s|0}do if((g+1|0)==(c[e>>2]|0)){j=mKa()|0;h=c[(c[j>>2]|0)+8>>2]|0;t=pKa()|0;u=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;c[d>>2]=Bn[h&255](j,12288,u?487048:544544,485816,253)|0;c[d+4>>2]=0;u=c[e>>2]|0;if((c[a+8>>2]&2147483647)>>>0<=u>>>0){I$a(a,d)|0;break}j=(c[a>>2]|0)+(u<<3)|0;if(!j)v=u;else{u=d;h=c[u+4>>2]|0;t=j;c[t>>2]=c[u>>2];c[t+4>>2]=h;v=c[e>>2]|0}c[e>>2]=v+1}while(0);v=(c[f>>2]|0)+1|0;c[f>>2]=v;e=c[a>>2]|0;c[e+(v<<3)+4>>2]=0;v=c[f>>2]|0;k=e;l=v;m=c[e+(v<<3)+4>>2]|0;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m*96|0)|0;i=b;return s|0}function M$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d+4>>2]|0;l=k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=c[d>>2]|0;n=m;o=n+~(n<<15)|0;n=(o>>>10^o)*9|0;o=n>>>6^n;n=o+~(o<<11)|0;o=(l>>>16^l^(n^-57320555^n>>>16)*1000007)&h+-1;n=c[(c[b+12>>2]|0)+(o<<2)>>2]|0;if((n|0)==-1)p=o;else{l=c[b+4>>2]|0;q=b+8|0;r=n;while(1){if((c[l+(r*12|0)>>2]|0)==(m|0)?(c[l+(r*12|0)+4>>2]|0)==(k|0):0)break;n=c[(c[q>>2]|0)+(r<<2)>>2]|0;if((n|0)==-1){p=o;break a}else r=n}a[e>>0]=1;s=l+(r*12|0)|0;i=f;return s|0}}else p=0;while(0);a[e>>0]=0;e=b+36|0;if((c[e>>2]|0)==(c[b+16>>2]|0)){o=j?16:h<<1;if(h>>>0<o>>>0){J$a(b,o);t=c[g>>2]|0}else t=h;h=c[d+4>>2]|0;g=h+~(h<<15)|0;h=(g>>>10^g)*9|0;g=h>>>6^h;h=g+~(g<<11)|0;g=c[d>>2]|0;d=g+~(g<<15)|0;g=(d>>>10^d)*9|0;d=g>>>6^g;g=d+~(d<<11)|0;u=(h>>>16^h^(g^-57320555^g>>>16)*1000007)&t+-1}else u=p;p=b+28|0;t=c[p>>2]|0;c[p>>2]=t+1;p=(c[b+12>>2]|0)+(u<<2)|0;c[(c[b+8>>2]|0)+(t<<2)>>2]=c[p>>2];c[p>>2]=t;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(t*12|0)|0;i=f;return s|0}function N$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;e=a+4|0;f=a+12|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[h+(g<<3)+4>>2]|0;if((j|0)!=128){k=h;l=g;m=j;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m*20|0)|0;i=b;return s|0}do if((g+1|0)==(c[e>>2]|0)){j=mKa()|0;h=c[(c[j>>2]|0)+8>>2]|0;t=pKa()|0;u=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;c[d>>2]=Bn[h&255](j,2560,u?486672:544544,485816,253)|0;c[d+4>>2]=0;u=c[e>>2]|0;if((c[a+8>>2]&2147483647)>>>0<=u>>>0){G$a(a,d)|0;break}j=(c[a>>2]|0)+(u<<3)|0;if(!j)v=u;else{u=d;h=c[u+4>>2]|0;t=j;c[t>>2]=c[u>>2];c[t+4>>2]=h;v=c[e>>2]|0}c[e>>2]=v+1}while(0);v=(c[f>>2]|0)+1|0;c[f>>2]=v;e=c[a>>2]|0;c[e+(v<<3)+4>>2]=0;v=c[f>>2]|0;k=e;l=v;m=c[e+(v<<3)+4>>2]|0;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m*20|0)|0;i=b;return s|0}function O$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;e=a+4|0;f=a+12|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[h+(g<<3)+4>>2]|0;if((j|0)!=128){k=h;l=g;m=j;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m<<3)|0;i=b;return s|0}do if((g+1|0)==(c[e>>2]|0)){j=mKa()|0;h=c[(c[j>>2]|0)+8>>2]|0;t=pKa()|0;u=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;c[d>>2]=Bn[h&255](j,1024,u?486280:544544,485816,253)|0;c[d+4>>2]=0;u=c[e>>2]|0;if((c[a+8>>2]&2147483647)>>>0<=u>>>0){H$a(a,d)|0;break}j=(c[a>>2]|0)+(u<<3)|0;if(!j)v=u;else{u=d;h=c[u+4>>2]|0;t=j;c[t>>2]=c[u>>2];c[t+4>>2]=h;v=c[e>>2]|0}c[e>>2]=v+1}while(0);v=(c[f>>2]|0)+1|0;c[f>>2]=v;e=c[a>>2]|0;c[e+(v<<3)+4>>2]=0;v=c[f>>2]|0;k=e;l=v;m=c[e+(v<<3)+4>>2]|0;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m<<3)|0;i=b;return s|0}function P$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;e=a+4|0;f=a+12|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[h+(g<<3)+4>>2]|0;if((j|0)!=128){k=h;l=g;m=j;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m*108|0)|0;i=b;return s|0}do if((g+1|0)==(c[e>>2]|0)){j=mKa()|0;h=c[(c[j>>2]|0)+8>>2]|0;t=pKa()|0;u=mo[c[(c[t>>2]|0)+24>>2]&4095](t)|0;c[d>>2]=Bn[h&255](j,13824,u?485904:544544,485816,253)|0;c[d+4>>2]=0;u=c[e>>2]|0;if((c[a+8>>2]&2147483647)>>>0<=u>>>0){K$a(a,d)|0;break}j=(c[a>>2]|0)+(u<<3)|0;if(!j)v=u;else{u=d;h=c[u+4>>2]|0;t=j;c[t>>2]=c[u>>2];c[t+4>>2]=h;v=c[e>>2]|0}c[e>>2]=v+1}while(0);v=(c[f>>2]|0)+1|0;c[f>>2]=v;e=c[a>>2]|0;c[e+(v<<3)+4>>2]=0;v=c[f>>2]|0;k=e;l=v;m=c[e+(v<<3)+4>>2]|0;n=k+(l<<3)+4|0;o=m+1|0;c[n>>2]=o;p=c[f>>2]|0;q=k+(p<<3)|0;r=c[q>>2]|0;s=r+(m*108|0)|0;i=b;return s|0}function Q$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?485464:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function R$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?485464:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function S$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?485320:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<4)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}j=j+16|0;if(j>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function T$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?485688:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function U$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?485576:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function V$a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[(c[b+(s<<2)>>2]|0)+56>>2]|0)>>>0<(c[(c[b+(t<<2)>>2]|0)+56>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;x=c[w+56>>2]|0;if((c[s+56>>2]|0)>>>0<x>>>0){c[u>>2]=s;c[v>>2]=w;y=c[u>>2]|0;z=c[y+56>>2]|0;A=w;B=y}else{z=x;A=s;B=w}w=b+(p<<2)|0;s=c[w>>2]|0;x=c[s+56>>2]|0;if(x>>>0<z>>>0){c[u>>2]=s;c[w>>2]=B;C=c[v>>2]|0;D=z;E=B}else{C=A;D=x;E=s}if(D>>>0<(c[C+56>>2]|0)>>>0){c[v>>2]=E;c[w>>2]=C;F=c[v>>2]|0}else F=C;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=F;v=F;x=j;u=w;while(1){w=c[v+56>>2]|0;G=x;while(1){H=G+1|0;I=b+(H<<2)|0;J=c[I>>2]|0;if((c[J+56>>2]|0)>>>0<w>>>0)G=H;else{K=u;break}}do{K=K+-1|0;L=b+(K<<2)|0;M=c[L>>2]|0}while(w>>>0<(c[M+56>>2]|0)>>>0);if((H|0)>=(K|0))break;c[I>>2]=M;c[L>>2]=J;v=c[s>>2]|0;x=H;u=K}c[I>>2]=v;c[s>>2]=J;if((H-j|0)<(p-H|0)){if(o>>>0>=(h+-1|0)>>>0){u=h<<1;x=h<<3;if(!x)N=0;else{w=mKa()|0;y=c[(c[w>>2]|0)+8>>2]|0;O=pKa()|0;P=mo[c[(c[O>>2]|0)+24>>2]&4095](O)|0;N=Bn[y&255](w,x,P?485464:544544,523928,148)|0}YEi(N|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Q=N;R=1;S=u}else{P=mKa()|0;In[c[(c[P>>2]|0)+12>>2]&4095](P,k);Q=N;R=1;S=u}}else{Q=k;R=d;S=h}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=G;T=R;U=Q;V=S;W=G+2|0;X=p}else{u=G+2|0;if(o>>>0>=(h+-1|0)>>>0){P=h<<1;x=h<<3;if(!x)Y=0;else{w=mKa()|0;y=c[(c[w>>2]|0)+8>>2]|0;O=pKa()|0;Z=mo[c[(c[O>>2]|0)+24>>2]&4095](O)|0;Y=Bn[y&255](w,x,Z?485464:544544,523928,148)|0}YEi(Y|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){_=Y;$=1;aa=P}else{Z=mKa()|0;In[c[(c[Z>>2]|0)+12>>2]&4095](Z,k);_=Y;$=1;aa=P}}else{_=k;$=d;aa=h}c[_+(o<<2)>>2]=u;c[_+(o+1<<2)>>2]=p;T=$;U=_;V=aa;W=j;X=G}d=T;k=U;h=V;l=o+2|0;m=W;n=X}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function W$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<4,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?485320:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<4)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2]}j=j+16|0;if(j>>>0>=h>>>0)break;else k=k+16|0}n=c[l>>2]|0}else n=f;f=m+(n<<4)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<4)|0}function X$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?487800:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function Y$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im;d=i;i=i+80|0;e=d+32|0;f=d+16|0;h=d;j=c[a>>2]|0;k=ea(JDb(j,j,b));j=a+4|0;l=ea(JDb(c[a>>2]|0,c[j>>2]|0,b));m=a+8|0;n=ea(JDb(c[a>>2]|0,c[m>>2]|0,b));o=c[j>>2]|0;p=ea(JDb(o,o,b));q=ea(JDb(c[j>>2]|0,c[m>>2]|0,b));o=c[m>>2]|0;r=ea(JDb(o,o,b));b=e+4|0;o=e+8|0;s=e+12|0;t=e+16|0;u=e+20|0;v=e+24|0;w=e+28|0;x=e+32|0;y=f+4|0;z=f+8|0;A=f+12|0;B=h+4|0;C=h+8|0;D=h+12|0;E=ea(0.0);F=ea(0.0);G=ea(0.0);H=ea(1.0);I=0;while(1){J=ea(E+E);K=ea(F+F);L=ea(G+G);M=ea(F*K);N=ea(G*L);O=ea(F*J);P=ea(G*J);Q=ea(H*J);R=ea(G*K);U=ea(H*K);K=ea(H*L);L=ea(ea(ea(1.0)-M)-N);V=ea(K+O);W=ea(P-U);X=ea(O-K);K=ea(ea(1.0)-ea(E*J));J=ea(K-N);N=ea(R+Q);O=ea(U+P);P=ea(R-Q);Q=ea(K-M);M=ea(ea(n*W)+ea(ea(k*L)+ea(l*V)));K=ea(ea(n*N)+ea(ea(k*X)+ea(l*J)));R=ea(ea(ea(k*O)+ea(l*P))+ea(n*Q));U=ea(ea(q*W)+ea(ea(l*L)+ea(p*V)));Y=ea(ea(q*N)+ea(ea(l*X)+ea(p*J)));Z=ea(ea(ea(l*O)+ea(p*P))+ea(q*Q));_=ea(ea(r*W)+ea(ea(n*L)+ea(q*V)));$=ea(ea(r*N)+ea(ea(n*X)+ea(q*J)));aa=ea(ea(ea(n*O)+ea(q*P))+ea(r*Q));ba=ea(ea(W*$)+ea(ea(L*K)+ea(V*Y)));ca=ea(ea(W*aa)+ea(ea(L*R)+ea(V*Z)));da=ea(ea(N*_)+ea(ea(X*M)+ea(J*U)));fa=ea(ea(N*$)+ea(ea(X*K)+ea(J*Y)));ga=ea(ea(N*aa)+ea(ea(X*R)+ea(J*Z)));J=ea(ea(Q*_)+ea(ea(O*M)+ea(P*U)));X=ea(ea(Q*$)+ea(ea(O*K)+ea(P*Y)));Y=ea(ea(Q*aa)+ea(ea(O*R)+ea(P*Z)));g[e>>2]=ea(ea(W*_)+ea(ea(L*M)+ea(V*U)));g[b>>2]=ba;g[o>>2]=ca;g[s>>2]=da;g[t>>2]=fa;g[u>>2]=ga;g[v>>2]=J;g[w>>2]=X;g[x>>2]=Y;Y=ea(S(ea(ga)));ga=ea(S(ea(ca)));ca=ea(S(ea(ba)));if(Y>ga&Y>ca)ha=0;else ha=ga>ca?1:2;ia=ha+1+(ha>>>1)|0;ja=ia&3;ka=ia+1+(ja>>>1)&3;ia=e+(ja*12|0)|0;ca=ea(g[ia+(ka<<2)>>2]);if(ca==ea(0.0)){la=E;ma=F;na=G;oa=H;break}ga=ea(g[ia+(ja<<2)>>2]);Y=ea(ga-ea(g[e+(ka*12|0)+(ka<<2)>>2]));ga=ea(ca*ea(2.0));if(+ea(S(ea(Y)))>+ea(S(ea(ga)))*2.0e6){la=E;ma=F;na=G;oa=H;break}ca=ea(Y/ga);ga=ea(S(ea(ca)));if(ga>ea(1.0e3)){Y=ea(ea(1.0)/ea(ca*ea(4.0)));g[f>>2]=ea(0.0);g[y>>2]=ea(0.0);g[z>>2]=ea(0.0);g[A>>2]=ea(1.0);g[f+(ha<<2)>>2]=Y;Y=ea(g[f>>2]);ba=ea(g[y>>2]);X=ea(g[z>>2]);pa=Y;qa=ea(g[A>>2]);ra=X;sa=ba}else{ba=ea(ea(1.0)/ea(ga+ea(T(ea(ea(ca*ca)+ea(1.0))))));ga=ea(ea(1.0)/ea(T(ea(ea(ba*ba)+ea(1.0)))));ba=ea(T(ea(ea(ea(1.0)-ga)*ea(.5))));ka=ca>=ea(0.0);ca=ea((ka?ea(1.0):ea(-1.0))*ba);ba=ea(T(ea(ea(ga+ea(1.0))*ea(.5))));g[h>>2]=ea(0.0);g[B>>2]=ea(0.0);g[C>>2]=ea(0.0);g[D>>2]=ba;g[h+(ha<<2)>>2]=ca;ca=ea(g[h>>2]);ba=ea(g[B>>2]);ga=ea(g[C>>2]);pa=ca;qa=ea(g[D>>2]);ra=ga;sa=ba}ba=ea(ea(ea(F*ra)+ea(ea(E*qa)+ea(H*pa)))-ea(G*sa));ga=ea(ea(ea(ea(F*qa)+ea(H*sa))+ea(G*pa))-ea(E*ra));ca=ea(ea(ea(E*sa)+ea(ea(G*qa)+ea(H*ra)))-ea(F*pa));X=ea(ea(ea(ea(H*qa)-ea(E*pa))-ea(F*sa))-ea(G*ra));Y=ea(ea(1.0)/ea(T(ea(ea(X*X)+ea(ea(ca*ca)+ea(ea(ga*ga)+ea(ba*ba)))))));J=ea(Y*ba);ba=ea(Y*ga);ga=ea(Y*ca);ca=ea(Y*X);I=I+1|0;if(I>>>0>=5){la=J;ma=ba;na=ga;oa=ca;break}else{E=J;F=ba;G=ga;H=ca}}H=ea(-la);G=ea(-ma);F=ea(-na);E=ea(-oa);oa=ea(H-la);la=ea(G-ma);ma=ea(F-na);na=ea(la*G);ra=ea(ma*F);sa=ea(oa*G);G=ea(oa*F);pa=ea(oa*E);qa=ea(la*F);F=ea(la*E);la=ea(ma*E);E=ea(ea(ea(1.0)-na)-ra);ma=ea(la+sa);r=ea(G-F);q=ea(sa-la);la=ea(ea(1.0)-ea(oa*H));H=ea(la-ra);ra=ea(qa+pa);oa=ea(F+G);G=ea(qa-pa);pa=ea(la-na);I=c[a>>2]|0;D=c[j>>2]|0;C=c[m>>2]|0;na=ea(g[I>>2]);la=ea(E*na);B=I+4|0;qa=ea(g[B>>2]);F=ea(E*qa);h=I+8|0;sa=ea(g[h>>2]);n=ea(E*sa);p=ea(g[D>>2]);l=ea(ma*p);ha=D+4|0;k=ea(g[ha>>2]);ca=ea(ma*k);A=D+8|0;ga=ea(g[A>>2]);ba=ea(la+l);l=ea(F+ca);ca=ea(n+ea(ma*ga));n=ea(g[C>>2]);F=ea(r*n);z=C+4|0;la=ea(g[z>>2]);J=ea(r*la);y=C+8|0;X=ea(g[y>>2]);Y=ea(l+J);J=ea(ca+ea(r*X));ca=ea(ea(ea(q*na)+ea(H*p))+ea(ra*n));l=ea(ea(ea(q*qa)+ea(H*k))+ea(ra*la));fa=ea(ea(ea(q*sa)+ea(H*ga))+ea(ra*X));da=ea(ea(ea(oa*na)+ea(G*p))+ea(pa*n));n=ea(ea(ea(oa*qa)+ea(G*k))+ea(pa*la));la=ea(ea(ea(oa*sa)+ea(G*ga))+ea(pa*X));g[I>>2]=ea(ba+F);g[B>>2]=Y;g[h>>2]=J;g[D>>2]=ca;g[ha>>2]=l;g[A>>2]=fa;g[C>>2]=da;g[z>>2]=n;g[y>>2]=la;y=I+32|0;la=ea(g[y>>2]);n=ea(E*la);z=I+36|0;da=ea(g[z>>2]);fa=ea(E*da);A=I+40|0;l=ea(g[A>>2]);ca=ea(E*l);I=D+32|0;J=ea(g[I>>2]);Y=ea(ma*J);ha=D+36|0;F=ea(g[ha>>2]);ba=ea(ma*F);h=D+40|0;X=ea(g[h>>2]);ga=ea(n+Y);Y=ea(fa+ba);ba=ea(ca+ea(ma*X));D=C+32|0;ca=ea(g[D>>2]);fa=ea(r*ca);B=C+36|0;n=ea(g[B>>2]);sa=ea(r*n);f=C+40|0;k=ea(g[f>>2]);qa=ea(Y+sa);sa=ea(ba+ea(r*k));ba=ea(ea(ea(q*la)+ea(H*J))+ea(ra*ca));Y=ea(ea(ea(q*da)+ea(H*F))+ea(ra*n));p=ea(ea(ea(q*l)+ea(H*X))+ea(ra*k));na=ea(ea(ea(oa*la)+ea(G*J))+ea(pa*ca));ca=ea(ea(ea(oa*da)+ea(G*F))+ea(pa*n));n=ea(ea(ea(oa*l)+ea(G*X))+ea(pa*k));g[y>>2]=ea(ga+fa);g[z>>2]=qa;g[A>>2]=sa;g[I>>2]=ba;g[ha>>2]=Y;g[h>>2]=p;g[D>>2]=na;g[B>>2]=ca;g[f>>2]=n;f=c[a>>2]|0;B=c[j>>2]|0;D=c[m>>2]|0;h=f+16|0;n=ea(g[h>>2]);ca=ea(E*n);ha=f+20|0;na=ea(g[ha>>2]);p=ea(E*na);I=f+24|0;Y=ea(g[I>>2]);ba=ea(E*Y);A=B+16|0;sa=ea(g[A>>2]);qa=ea(ma*sa);z=B+20|0;fa=ea(g[z>>2]);ga=ea(ma*fa);y=B+24|0;k=ea(g[y>>2]);X=ea(ca+qa);qa=ea(p+ga);ga=ea(ba+ea(ma*k));C=D+16|0;ba=ea(g[C>>2]);p=ea(r*ba);e=D+20|0;ca=ea(g[e>>2]);l=ea(r*ca);x=D+24|0;F=ea(g[x>>2]);da=ea(qa+l);l=ea(ga+ea(r*F));ga=ea(ea(ea(q*n)+ea(H*sa))+ea(ra*ba));qa=ea(ea(ea(q*na)+ea(H*fa))+ea(ra*ca));J=ea(ea(ea(q*Y)+ea(H*k))+ea(ra*F));la=ea(ea(ea(oa*n)+ea(G*sa))+ea(pa*ba));ba=ea(ea(ea(oa*na)+ea(G*fa))+ea(pa*ca));ca=ea(ea(ea(oa*Y)+ea(G*k))+ea(pa*F));g[h>>2]=ea(X+p);g[ha>>2]=da;g[I>>2]=l;g[A>>2]=ga;g[z>>2]=qa;g[y>>2]=J;g[C>>2]=la;g[e>>2]=ba;g[x>>2]=ca;x=f+48|0;ca=ea(g[x>>2]);ba=ea(E*ca);e=f+52|0;la=ea(g[e>>2]);J=ea(E*la);C=f+56|0;qa=ea(g[C>>2]);ga=ea(E*qa);f=B+48|0;l=ea(g[f>>2]);da=ea(ma*l);y=B+52|0;p=ea(g[y>>2]);X=ea(ma*p);z=B+56|0;F=ea(g[z>>2]);k=ea(ba+da);da=ea(J+X);X=ea(ga+ea(ma*F));B=D+48|0;ga=ea(g[B>>2]);J=ea(r*ga);A=D+52|0;ba=ea(g[A>>2]);Y=ea(r*ba);I=D+56|0;fa=ea(g[I>>2]);na=ea(da+Y);Y=ea(X+ea(r*fa));X=ea(ea(ea(q*ca)+ea(H*l))+ea(ra*ga));da=ea(ea(ea(q*la)+ea(H*p))+ea(ra*ba));sa=ea(ea(ea(q*qa)+ea(H*F))+ea(ra*fa));n=ea(ea(ea(oa*ca)+ea(G*l))+ea(pa*ga));ga=ea(ea(ea(oa*la)+ea(G*p))+ea(pa*ba));ba=ea(ea(ea(oa*qa)+ea(G*F))+ea(pa*fa));g[x>>2]=ea(k+J);g[e>>2]=na;g[C>>2]=Y;g[f>>2]=X;g[y>>2]=da;g[z>>2]=sa;g[B>>2]=n;g[A>>2]=ga;g[I>>2]=ba;I=c[a>>2]|0;a=I+28|0;A=c[j>>2]|0;j=A+28|0;B=c[m>>2]|0;m=B+28|0;ba=ea(g[a>>2]);ga=ea(E*ba);n=ea(g[j>>2]);sa=ea(ga+ea(ma*n));ga=ea(g[m>>2]);da=ea(ea(ea(q*ba)+ea(H*n))+ea(ra*ga));X=ea(ea(ea(oa*ba)+ea(G*n))+ea(pa*ga));g[a>>2]=ea(sa+ea(r*ga));g[j>>2]=da;g[m>>2]=X;m=I+12|0;I=A+12|0;A=B+12|0;X=ea(g[m>>2]);da=ea(E*X);E=ea(g[I>>2]);ga=ea(da+ea(ma*E));ma=ea(g[A>>2]);da=ea(ea(ea(q*X)+ea(H*E))+ea(ra*ma));ra=ea(ea(ea(oa*X)+ea(G*E))+ea(pa*ma));g[m>>2]=ea(ga+ea(r*ma));g[I>>2]=da;g[A>>2]=ra;i=d;return}function Z$a(a,c,d,e,f,h,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=ea(k);l=ea(l);m=ea(m);n=ea(n);var o=0,p=Im,q=0,r=0,s=0,t=Im,u=Im,v=Im;o=i;if(!(j<=k))p=ea(ea(1.0)/j);else p=ea(0.0);q=f+12|0;r=b[f+76>>1]|0;s=r&65535;if(s&1){k=ea(ea(g[q>>2])*l);l=ea(m*m);t=ea(g[f+64>>2]);u=ea(l*t);l=ea(g[f+68>>2]);v=ea(u+ea(l*m));u=ea(ea(ea(l*ea(g[f+28>>2]))-ea(t*k))*m);if(!(s&2)){m=ea(ea(1.0)/ea(ea(v*j)+ea(1.0)));j=ea(u*m);g[c>>2]=j;g[a>>2]=j;g[d>>2]=ea(-ea(v*m));g[e>>2]=ea(ea(1.0)-m);i=o;return}else{m=ea(ea(1.0)/ea(v+ea(1.0)));j=ea(p*m);k=ea(u*j);g[c>>2]=k;g[a>>2]=k;g[d>>2]=ea(-ea(v*j));g[e>>2]=ea(ea(1.0)-m);i=o;return}}g[d>>2]=ea(-p);g[e>>2]=ea(1.0);if((r&4)!=0?(m=ea(-h),ea(g[f+68>>2])<m):0){h=ea(ea(p*ea(g[f+64>>2]))*m);g[a>>2]=h;g[c>>2]=h;i=o;return}r=f+28|0;h=ea(g[r>>2]);g[a>>2]=ea(p*ea(h-ea(ea(g[q>>2])*n)));h=ea(g[r>>2]);g[c>>2]=ea(p*ea(h-ea(ea(g[f+72>>2])*n)));i=o;return}function _$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;e=c[(qTa()|0)>>2]|0;if(e){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,e,j?544576:544544,544464,111)|0;c[a>>2]=h;if(h)mTa(h)}else c[a>>2]=0;h=a+4|0;j=a+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c2a(h,64);e=c[j>>2]|0;f=c[a+12>>2]&2147483647;c[d>>2]=0;if(f>>>0<=e>>>0){m0a(h,d)|0;i=b;return}d=(c[h>>2]|0)+(e<<2)|0;if(d)c[d>>2]=0;c[j>>2]=e+1;i=b;return}function $$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+2|0;e=b+1|0;f=b;g=a+8|0;h=c[g>>2]|0;if(h){j=c[a>>2]|0;k=h;h=0;while(1){if(!j){l=0;m=k}else{n=0;do{n=n+1|0;o=c[a>>2]|0}while(n>>>0<o>>>0);l=o;m=c[g>>2]|0}h=h+1|0;if(h>>>0>=m>>>0)break;else{j=l;k=m}}if(m){m=a+24|0;k=0;do{VJa(d,c[(c[m>>2]|0)+(k<<2)>>2]|0);c[(c[m>>2]|0)+(k<<2)>>2]=0;k=k+1|0}while(k>>>0<(c[g>>2]|0)>>>0)}}c[g>>2]=0;g=a+16|0;k=c[g>>2]|0;if(k)VJa(e,k);c[g>>2]=0;g=a+24|0;a=c[g>>2]|0;if(!a){i=b;return}VJa(f,a);c[g>>2]=0;i=b;return}function a0a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)KDb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function b0a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)LDb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function c0a(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;c[b>>2]=445416;e=b+88|0;nTa(c[e>>2]|0);f=c[e>>2]|0;if(f){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,f)}f=c[b+80>>2]|0;do if((f&2147483647|0)!=0&(f|0)>-1){e=c[b+72>>2]|0;if((b+52|0)==(e|0)){a[b+68>>0]=0;break}if(e){g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,e)}}while(0);f=c[b+48>>2]|0;if(!((f&2147483647|0)!=0&(f|0)>-1)){i=d;return}f=c[b+40>>2]|0;if((b+20|0)==(f|0)){a[b+36>>0]=0;i=d;return}if(!f){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,f);i=d;return}function d0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+2|0;e=b+1|0;f=b;g=a+8|0;h=c[g>>2]|0;if(h){j=a+24|0;k=c[a>>2]|0;l=h;h=0;while(1){m=c[(c[j>>2]|0)+(h<<2)>>2]|0;if(!k){n=0;o=l}else{p=0;do{q=m+(p*52|0)|0;ko[c[c[q>>2]>>2]&4095](q);p=p+1|0;r=c[a>>2]|0}while(p>>>0<r>>>0);n=r;o=c[g>>2]|0}h=h+1|0;if(h>>>0>=o>>>0)break;else{k=n;l=o}}if(o){o=a+24|0;l=0;do{VJa(d,c[(c[o>>2]|0)+(l<<2)>>2]|0);c[(c[o>>2]|0)+(l<<2)>>2]=0;l=l+1|0}while(l>>>0<(c[g>>2]|0)>>>0)}}c[g>>2]=0;g=a+16|0;l=c[g>>2]|0;if(l)VJa(e,l);c[g>>2]=0;g=a+24|0;a=c[g>>2]|0;if(!a){i=b;return}VJa(f,a);c[g>>2]=0;i=b;return}function e0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+2|0;e=b+1|0;f=b;g=a+8|0;h=c[g>>2]|0;if(h){j=a+24|0;k=c[a>>2]|0;l=h;h=0;while(1){m=c[(c[j>>2]|0)+(h<<2)>>2]|0;if(!k){n=0;o=l}else{p=0;do{q=m+(p*1328|0)|0;ko[c[(c[q>>2]|0)+56>>2]&4095](q);p=p+1|0;r=c[a>>2]|0}while(p>>>0<r>>>0);n=r;o=c[g>>2]|0}h=h+1|0;if(h>>>0>=o>>>0)break;else{k=n;l=o}}if(o){o=a+24|0;l=0;do{VJa(d,c[(c[o>>2]|0)+(l<<2)>>2]|0);c[(c[o>>2]|0)+(l<<2)>>2]=0;l=l+1|0}while(l>>>0<(c[g>>2]|0)>>>0)}}c[g>>2]=0;g=a+16|0;l=c[g>>2]|0;if(l)VJa(e,l);c[g>>2]=0;g=a+24|0;a=c[g>>2]|0;if(!a){i=b;return}VJa(f,a);c[g>>2]=0;i=b;return}function f0a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=CTa(c[a>>2]|0)|0;if(d){e=d;do{MDb(e);d=e+(0-(c[e+-4>>2]|0))|0;if(d){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}e=CTa(c[a>>2]|0)|0}while((e|0)!=0)}e=c[a>>2]|0;if(!e){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,e);i=b;return}function g0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=a+8|0;if((c[d>>2]|0)==(c[a+4>>2]|0)){e=0;i=b;return e|0}f=(c[a>>2]|0)*1328|0;if(!f){e=0;i=b;return e|0}g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](g,f,k?489056:544544,488400,157)|0;if(!j){e=0;i=b;return e|0}k=c[d>>2]|0;f=k+1|0;c[d>>2]=f;c[(c[a+24>>2]|0)+(k<<2)>>2]=j;k=a+16|0;g=c[k>>2]|0;if(!g)l=f;else{VJa(b,g);l=c[d>>2]|0}g=c[a>>2]|0;f=da(l<<2,g)|0;if(!f){m=0;n=g;o=l}else{l=mKa()|0;g=c[(c[l>>2]|0)+8>>2]|0;h=pKa()|0;p=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](l,f,p?489056:544544,488400,164)|0;m=h;n=c[a>>2]|0;o=c[d>>2]|0}c[k>>2]=m;m=((da(n,o)|0)+31|0)>>>5;o=a+36|0;if(m>>>0>(c[o>>2]&2147483647)>>>0){h=a+40|0;p=UJa(h,m<<2,543784,339)|0;f=a+32|0;l=c[f>>2]|0;if((l|0)!=0?(YEi(p|0,l|0,c[o>>2]<<2|0)|0,(c[o>>2]|0)>-1):0)VJa(h,c[f>>2]|0);h=c[o>>2]|0;PEi(p+((h&2147483647)<<2)|0,0,m-h<<2|0)|0;c[f>>2]=p;c[o>>2]=m;q=c[a>>2]|0}else q=n;n=q+-1|0;if((n|0)<=-1){e=1;i=b;return e|0}q=a+20|0;m=a+28|0;o=n;do{n=j+(o*1328|0)|0;if(!n)r=0;else{dwa(n,c[m>>2]|0,(da((c[d>>2]|0)+-1|0,c[a>>2]|0)|0)+o|0);r=n}n=c[q>>2]|0;c[q>>2]=n+1;c[(c[k>>2]|0)+(n<<2)>>2]=r;o=o+-1|0}while((o|0)>-1);e=1;i=b;return e|0}function h0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=a+8|0;if((c[d>>2]|0)==(c[a+4>>2]|0)){e=0;i=b;return e|0}f=c[a>>2]<<7;if(!f){e=0;i=b;return e|0}g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](g,f,k?488928:544544,488400,157)|0;if(!j){e=0;i=b;return e|0}k=c[d>>2]|0;f=k+1|0;c[d>>2]=f;c[(c[a+24>>2]|0)+(k<<2)>>2]=j;k=a+16|0;g=c[k>>2]|0;if(!g)l=f;else{VJa(b,g);l=c[d>>2]|0}g=c[a>>2]|0;f=da(l<<2,g)|0;if(!f){m=0;n=g;o=l}else{l=mKa()|0;g=c[(c[l>>2]|0)+8>>2]|0;h=pKa()|0;p=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](l,f,p?488928:544544,488400,164)|0;m=h;n=c[a>>2]|0;o=c[d>>2]|0}c[k>>2]=m;m=((da(n,o)|0)+31|0)>>>5;o=a+36|0;if(m>>>0>(c[o>>2]&2147483647)>>>0){h=a+40|0;p=UJa(h,m<<2,543784,339)|0;f=a+32|0;l=c[f>>2]|0;if((l|0)!=0?(YEi(p|0,l|0,c[o>>2]<<2|0)|0,(c[o>>2]|0)>-1):0)VJa(h,c[f>>2]|0);h=c[o>>2]|0;PEi(p+((h&2147483647)<<2)|0,0,m-h<<2|0)|0;c[f>>2]=p;c[o>>2]=m;q=c[a>>2]|0}else q=n;n=q+-1|0;if((n|0)<=-1){e=1;i=b;return e|0}q=a+20|0;m=a+28|0;o=n;do{n=j+(o<<7)|0;if(!n)r=0;else{ysa(n,c[m>>2]|0,(da((c[d>>2]|0)+-1|0,c[a>>2]|0)|0)+o|0);r=n}n=c[q>>2]|0;c[q>>2]=n+1;c[(c[k>>2]|0)+(n<<2)>>2]=r;o=o+-1|0}while((o|0)>-1);e=1;i=b;return e|0}function i0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?488768:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else NDb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*96|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-96|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function j0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=c[a+288>>2]|0;if(!e)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,e,k?488608:544544,498984,191)|0}c[d>>2]=f;k=a+268|0;e=c[k>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){g=(c[a+264>>2]|0)+(e<<2)|0;if(g)c[g>>2]=f;c[k>>2]=e+1}else ODb(a+4|0,d)|0;d=f+(((c[a+276>>2]|0)+-1|0)*240|0)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;k=a+284|0;a=c[e>>2]|0;g=d;d=c[k>>2]|0;while(1){c[g>>2]=a;c[e>>2]=g;d=d+1|0;h=g+-240|0;if(h>>>0<f>>>0)break;else{j=g;g=h;a=j}}c[k>>2]=d;i=b;return}function k0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;PDb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else QDb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(RDb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,RDb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+96|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){NDb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function l0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;SDb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=0;p=0;q=n;while(1){c[f>>2]=q;if(o>>>0>p>>>0){n=(c[d>>2]|0)+(p<<2)|0;if(n)c[n>>2]=q;c[j>>2]=p+1}else TDb(d,f)|0;n=c[c[m>>2]>>2]|0;c[m>>2]=n;if(!n)break;o=c[k>>2]&2147483647;p=c[j>>2]|0;q=n}q=c[d>>2]|0;p=c[j>>2]|0;j=q+(p<<2)|0;o=a+276|0;f=c[o>>2]|0;n=q+(p-f<<2)|0;if(p>>>0>f>>>0?(UDb(q,p,g,a),g=c[e>>2]|0,f=c[e+4>>2]|0,UDb(g,f,h,a),h=a+268|0,c[h>>2]=0,r=g+(f<<2)|0,(f|0)!=0):0){f=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=q;w=g;while(1){g=c[w>>2]|0;a:do if(v>>>0<n>>>0){x=g;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<n>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=g;B=v}while(0);if((A|0)==(c[B>>2]|0)?(g=c[o>>2]|0,((c[B+(g+-1<<2)>>2]|0)+240|0)==((c[f>>2]|0)+A|0)):0){if(!A)D=g;else{g=mKa()|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,A);D=c[o>>2]|0}E=B+(D<<2)|0}else F=22;do if((F|0)==22){F=0;g=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=g>>>0){ODb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(g<<2)|0;if(y)c[y>>2]=A;c[h>>2]=g+1;E=B}while(0);w=w+4|0;if((w|0)==(r|0)){G=E;break}else v=E}}else G=q;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((q+(p+-1<<2)+(0-G)|0)>>>2)|0;p=c[m>>2]|0;q=G;do{G=p;p=c[q>>2]|0;c[p>>2]=G;c[m>>2]=p;q=q+4|0}while((q|0)!=(j|0));c[E>>2]=a+1}}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,a)}a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function m0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?489680:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function n0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=a+8|0;if((c[d>>2]|0)==(c[a+4>>2]|0)){e=0;i=b;return e|0}f=(c[a>>2]|0)*52|0;if(!f){e=0;i=b;return e|0}g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;j=Bn[h&255](g,f,k?488488:544544,488400,157)|0;if(!j){e=0;i=b;return e|0}k=c[d>>2]|0;f=k+1|0;c[d>>2]=f;c[(c[a+24>>2]|0)+(k<<2)>>2]=j;k=a+16|0;g=c[k>>2]|0;if(!g)l=f;else{VJa(b,g);l=c[d>>2]|0}g=c[a>>2]|0;f=da(l<<2,g)|0;if(!f){m=0;n=g;o=l}else{l=mKa()|0;g=c[(c[l>>2]|0)+8>>2]|0;h=pKa()|0;p=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](l,f,p?488488:544544,488400,164)|0;m=h;n=c[a>>2]|0;o=c[d>>2]|0}c[k>>2]=m;m=((da(n,o)|0)+31|0)>>>5;o=a+36|0;if(m>>>0>(c[o>>2]&2147483647)>>>0){h=a+40|0;p=UJa(h,m<<2,543784,339)|0;f=a+32|0;l=c[f>>2]|0;if((l|0)!=0?(YEi(p|0,l|0,c[o>>2]<<2|0)|0,(c[o>>2]|0)>-1):0)VJa(h,c[f>>2]|0);h=c[o>>2]|0;PEi(p+((h&2147483647)<<2)|0,0,m-h<<2|0)|0;c[f>>2]=p;c[o>>2]=m;q=c[a>>2]|0}else q=n;n=q+-1|0;if((n|0)<=-1){e=1;i=b;return e|0}q=a+20|0;m=a+28|0;o=n;do{n=j+(o*52|0)|0;if(!n)r=0;else{Eva(n,c[m>>2]|0,(da((c[d>>2]|0)+-1|0,c[a>>2]|0)|0)+o|0);r=n}n=c[q>>2]|0;c[q>>2]=n+1;c[(c[k>>2]|0)+(n<<2)>>2]=r;o=o+-1|0}while((o|0)>-1);e=1;i=b;return e|0}function o0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;if((b|0)!=0?(e=b*80|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?488272:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*80|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);g[k+28>>2]=ea(g[f+28>>2]);g[k+32>>2]=ea(g[f+32>>2]);g[k+36>>2]=ea(g[f+36>>2]);g[k+40>>2]=ea(g[f+40>>2]);g[k+44>>2]=ea(g[f+44>>2]);g[k+48>>2]=ea(g[f+48>>2]);g[k+52>>2]=ea(g[f+52>>2]);g[k+56>>2]=ea(g[f+56>>2]);g[k+60>>2]=ea(g[f+60>>2]);g[k+64>>2]=ea(g[f+64>>2]);g[k+68>>2]=ea(g[f+68>>2]);h=f+72|0;j=c[h+4>>2]|0;m=k+72|0;c[m>>2]=c[h>>2];c[m+4>>2]=j}k=k+80|0;if(k>>>0>=e>>>0)break;else f=f+80|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function p0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=d&134217727;g=a+4|0;h=c[g>>2]|0;if(f>>>0>(h&2147483647)>>>0){j=a+8|0;k=UJa(j,f<<2,543784,339)|0;l=c[a>>2]|0;if((l|0)!=0?(YEi(k|0,l|0,c[g>>2]<<2|0)|0,(c[g>>2]|0)>-1):0)VJa(j,c[a>>2]|0);j=c[g>>2]|0;PEi(k+((j&2147483647)<<2)|0,0,f-j<<2|0)|0;c[a>>2]=k;c[g>>2]=f;m=f}else m=h;h=m&2147483647;if(!((h>>>0<d>>>0?h:d)|0)){i=e;return}h=c[a>>2]|0;a=~d;d=(m|-2147483648)^2147483647;m=~(d>>>0<a>>>0?a:d);d=0;do{a=h+(d<<2)|0;c[a>>2]=c[b+(d<<2)>>2]|c[a>>2];d=d+1|0}while((d|0)!=(m|0));i=e;return}function q0a(a,d){a=a|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if((d|0)!=0?(h=mKa()|0,j=c[(c[h>>2]|0)+8>>2]|0,k=pKa()|0,l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0,k=Bn[j&255](h,(d<<5)+131|0,l?490512:544544,537640,558)|0,(k|0)!=0):0){l=k+131&-128;c[l+-4>>2]=l-k;m=l}else m=0;l=c[a+4>>2]|0;k=m+(l<<5)|0;if((l|0)>0){l=m;h=c[a>>2]|0;while(1){if(l){g[l>>2]=ea(g[h>>2]);g[l+4>>2]=ea(g[h+4>>2]);g[l+8>>2]=ea(g[h+8>>2]);j=l+12|0;n=h+12|0;o=e[n>>1]|e[n+2>>1]<<16;b[j>>1]=o;b[j+2>>1]=o>>>16;g[l+16>>2]=ea(g[h+16>>2]);g[l+20>>2]=ea(g[h+20>>2]);g[l+24>>2]=ea(g[h+24>>2]);c[l+28>>2]=c[h+28>>2]}l=l+32|0;if(l>>>0>=k>>>0)break;else h=h+32|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=m;c[h>>2]=d;i=f;return}k=c[a>>2]|0;if(!k){c[a>>2]=m;c[h>>2]=d;i=f;return}l=k+(0-(c[k+-4>>2]|0))|0;if(!l){c[a>>2]=m;c[h>>2]=d;i=f;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,l);c[a>>2]=m;c[h>>2]=d;i=f;return}function r0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=mKa()|0,f=c[(c[e>>2]|0)+8>>2]|0,h=pKa()|0,j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0,h=Bn[f&255](e,(b<<6)+131|0,j?490384:544544,537640,558)|0,(h|0)!=0):0){j=h+131&-128;c[j+-4>>2]=j-h;k=j}else k=0;j=c[a+4>>2]|0;h=k+(j<<6)|0;if((j|0)>0){j=k;e=c[a>>2]|0;while(1){if(j){g[j>>2]=ea(g[e>>2]);g[j+4>>2]=ea(g[e+4>>2]);g[j+8>>2]=ea(g[e+8>>2]);g[j+12>>2]=ea(g[e+12>>2]);g[j+16>>2]=ea(g[e+16>>2]);g[j+20>>2]=ea(g[e+20>>2]);g[j+24>>2]=ea(g[e+24>>2]);g[j+28>>2]=ea(g[e+28>>2]);g[j+32>>2]=ea(g[e+32>>2]);f=j+36|0;l=e+36|0;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[f+16>>2]=c[l+16>>2];c[f+20>>2]=c[l+20>>2];c[f+24>>2]=c[l+24>>2]}j=j+64|0;if(j>>>0>=h>>>0)break;else e=e+64|0}}e=a+8|0;if((c[e>>2]|0)<=-1){c[a>>2]=k;c[e>>2]=b;i=d;return}h=c[a>>2]|0;if(!h){c[a>>2]=k;c[e>>2]=b;i=d;return}j=h+(0-(c[h+-4>>2]|0))|0;if(!j){c[a>>2]=k;c[e>>2]=b;i=d;return}h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,j);c[a>>2]=k;c[e>>2]=b;i=d;return}function s0a(a,d,f){a=a|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;if((c[a+8>>2]&2147483647)>>>0<d>>>0)q0a(a,d);j=c[a>>2]|0;k=a+4|0;a=c[k>>2]|0;l=j+(d<<5)|0;if((a|0)>=(d|0)){c[k>>2]=d;i=h;return}m=f+4|0;n=f+8|0;o=f+12|0;p=f+16|0;q=f+20|0;r=f+24|0;s=f+28|0;t=j+(a<<5)|0;do{if(t){g[t>>2]=ea(g[f>>2]);g[t+4>>2]=ea(g[m>>2]);g[t+8>>2]=ea(g[n>>2]);a=t+12|0;j=e[o>>1]|e[o+2>>1]<<16;b[a>>1]=j;b[a+2>>1]=j>>>16;g[t+16>>2]=ea(g[p>>2]);g[t+20>>2]=ea(g[q>>2]);g[t+24>>2]=ea(g[r>>2]);c[t+28>>2]=c[s>>2]}t=t+32|0}while(t>>>0<l>>>0);c[k>>2]=d;i=h;return}function t0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)r0a(a,b);f=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;j=f+(b<<6)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=d+12|0;n=d+16|0;o=d+20|0;p=d+24|0;q=d+28|0;r=d+32|0;s=d+36|0;t=f+(a<<6)|0;do{if(t){g[t>>2]=ea(g[d>>2]);g[t+4>>2]=ea(g[k>>2]);g[t+8>>2]=ea(g[l>>2]);g[t+12>>2]=ea(g[m>>2]);g[t+16>>2]=ea(g[n>>2]);g[t+20>>2]=ea(g[o>>2]);g[t+24>>2]=ea(g[p>>2]);g[t+28>>2]=ea(g[q>>2]);g[t+32>>2]=ea(g[r>>2]);a=t+36|0;c[a+0>>2]=c[s+0>>2];c[a+4>>2]=c[s+4>>2];c[a+8>>2]=c[s+8>>2];c[a+12>>2]=c[s+12>>2];c[a+16>>2]=c[s+16>>2];c[a+20>>2]=c[s+20>>2];c[a+24>>2]=c[s+24>>2]}t=t+64|0}while(t>>>0<j>>>0);c[h>>2]=b;i=e;return}function u0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)S$a(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<4)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<4)|0;do{if(j){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2]}j=j+16|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function v0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;e=i;f=a+64|0;h=ea(g[f>>2]);j=a+68|0;k=ea(g[j>>2]);l=a+72|0;m=ea(g[l>>2]);n=a+80|0;o=ea(g[n>>2]);p=a+84|0;q=ea(g[p>>2]);r=a+88|0;s=ea(g[r>>2]);t=ea(g[a+104>>2]);u=ea(g[a+108>>2]);v=ea(g[a+100>>2]);w=ea(g[a+96>>2]);x=ea(ea(g[b>>2])*d);y=ea(ea(g[b+4>>2])*d);z=ea(ea(g[b+8>>2])*d);A=ea(ea(g[c>>2])*d);B=ea(ea(g[c+4>>2])*d);C=ea(ea(1.0)-ea(t*d));t=ea(ea(1.0)-ea(u*d));u=ea(h+x);x=ea(k+y);y=ea(m+z);z=ea(o+A);A=ea(q+B);B=ea(s+ea(ea(g[c+8>>2])*d));c=C>=ea(0.0);d=c?C:ea(0.0);c=t>=ea(0.0);C=c?t:ea(0.0);t=ea(d*u);u=ea(d*x);x=ea(d*y);y=ea(C*z);z=ea(C*A);A=ea(C*B);B=ea(ea(ea(t*t)+ea(u*u))+ea(x*x));if(B>v){C=ea(T(ea(v/B)));D=ea(t*C);E=ea(u*C);F=ea(x*C)}else{D=t;E=u;F=x}x=ea(ea(ea(y*y)+ea(z*z))+ea(A*A));if(!(x>w)){G=y;H=z;I=A;g[f>>2]=D;g[j>>2]=E;g[l>>2]=F;g[n>>2]=G;g[p>>2]=H;g[r>>2]=I;i=e;return}u=ea(T(ea(w/x)));G=ea(y*u);H=ea(z*u);I=ea(A*u);g[f>>2]=D;g[j>>2]=E;g[l>>2]=F;g[n>>2]=G;g[p>>2]=H;g[r>>2]=I;i=e;return}function w0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0,f=Im,h=0,j=Im,k=0,l=Im,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;e=i;f=ea(ea(g[c>>2])*d);h=c+4|0;j=ea(ea(g[h>>2])*d);k=c+8|0;l=ea(ea(g[k>>2])*d);m=c+16|0;n=ea(g[m>>2]);o=ea(n*n);p=c+20|0;n=ea(g[p>>2]);q=ea(o+ea(n*n));r=c+24|0;n=ea(g[r>>2]);o=ea(q+ea(n*n));s=a+16|0;g[s>>2]=ea(f+ea(g[s>>2]));s=a+20|0;g[s>>2]=ea(j+ea(g[s>>2]));s=a+24|0;g[s>>2]=ea(l+ea(g[s>>2]));g[b>>2]=ea(g[c>>2]);g[b+4>>2]=ea(g[h>>2]);g[b+8>>2]=ea(g[k>>2]);g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(g[m>>2]);g[b+20>>2]=ea(g[p>>2]);g[b+24>>2]=ea(g[r>>2]);g[b+28>>2]=ea(0.0);l=ea(T(ea(o)));do if(!(l>ea(1.0e7)))if(l!=ea(0.0)){o=ea(g[m>>2]);j=ea(g[p>>2]);t=o;u=j;v=ea(g[r>>2]);w=l;break}else{i=e;return}else{j=ea(g[m>>2]);o=ea(j*j);f=ea(g[p>>2]);n=ea(o+ea(f*f));o=ea(g[r>>2]);q=ea(n+ea(o*o));if(q>ea(0.0)){n=ea(ea(1.0)/ea(T(ea(q))));x=ea(ea(j*n)*ea(1.0e7));y=ea(ea(f*n)*ea(1.0e7));z=ea(ea(o*n)*ea(1.0e7))}else{x=ea(0.0);y=ea(0.0);z=ea(0.0)}g[m>>2]=x;g[p>>2]=y;g[r>>2]=z;t=x;u=y;v=z;w=ea(1.0e7)}while(0);z=ea(ea(w*d)*ea(.5));d=ea(+V(+z));y=ea(ea(+W(+z))/w);w=ea(y*t);t=ea(y*u);u=ea(y*v);v=ea(g[a>>2]);y=ea(v*ea(0.0));r=a+12|0;z=ea(g[r>>2]);x=ea(y+ea(w*z));p=a+8|0;y=ea(g[p>>2]);l=ea(x+ea(t*y));m=a+4|0;x=ea(g[m>>2]);n=ea(ea(d*v)+ea(l-ea(u*x)));l=ea(ea(d*x)+ea(ea(ea(v*u)+ea(ea(t*z)+ea(x*ea(0.0))))-ea(w*y)));o=ea(ea(d*y)+ea(ea(ea(w*x)+ea(ea(u*z)+ea(y*ea(0.0))))-ea(t*v)));f=ea(ea(d*z)+ea(ea(ea(ea(z*ea(0.0))-ea(w*v))-ea(t*x))-ea(u*y)));y=ea(ea(1.0)/ea(T(ea(ea(f*f)+ea(ea(o*o)+ea(ea(n*n)+ea(l*l)))))));u=ea(y*l);l=ea(y*o);o=ea(y*f);g[a>>2]=ea(y*n);g[m>>2]=u;g[p>>2]=l;g[r>>2]=o;i=e;return}function x0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?490104:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<5)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2];c[j+28>>2]=c[f+28>>2]}j=j+32|0;if(j>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function y0a(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=Im,k=Im,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;f=i;j=ea(g[b>>2]);k=ea(g[e>>2]);l=ea(j-k);m=b+4|0;n=ea(g[m>>2]);o=e+4|0;p=ea(g[o>>2]);q=ea(n-p);r=b+8|0;n=ea(g[r>>2]);b=e+8|0;s=ea(g[b>>2]);t=ea(n-s);n=ea(g[d>>2]);u=ea(l*n);v=ea(g[d+4>>2]);w=ea(u+ea(q*v));u=ea(g[d+8>>2]);x=ea(w+ea(t*u));if(x<ea(0.0)){w=ea(g[h+20>>2]);y=ea(g[h+24>>2]);z=ea(g[h+16>>2]);A=ea(n*x);B=ea(v*x);C=ea(u*x);x=ea(l-A);l=ea(q-B);q=ea(t-C);t=ea(ea(g[c>>2])-k);k=ea(ea(g[c+4>>2])-p);p=ea(ea(ea(n*t)+ea(v*k))+ea(u*ea(ea(g[c+8>>2])-s)));s=ea(n*p);n=ea(v*p);v=ea(u*p);u=ea(A-s);A=ea(B-n);B=ea(C-v);c=ea(ea(ea(q*q)+ea(ea(x*x)+ea(l*l)))-ea(y*ea(ea(B*B)+ea(ea(u*u)+ea(A*A)))))>=ea(0.0);A=c?x:ea(0.0);x=c?l:ea(0.0);l=ea(ea(1.0)-w);w=ea(l*A);A=ea(l*x);x=ea(l*(c?q:ea(0.0)));c=a+4|0;h=a+8|0;q=ea(w-ea(z*s));s=ea(A-ea(z*n));n=ea(x-ea(z*v));d=p>=ea(0.0);p=d?w:q;g[a>>2]=p;q=d?A:s;g[c>>2]=q;s=d?x:n;g[h>>2]=s;g[a>>2]=ea(ea(g[e>>2])+p);g[c>>2]=ea(ea(g[o>>2])+q);g[h>>2]=ea(ea(g[b>>2])+s);i=f;return}else{g[a>>2]=j;g[a+4>>2]=ea(g[m>>2]);g[a+8>>2]=ea(g[r>>2]);i=f;return}}function z0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0;b=i;f=c[d+8>>2]|0;h=f&2147483647;j=d+4|0;k=c[j>>2]|0;if(h>>>0>k>>>0)l=k;else{VDb(d,(h|0)==0?1:f<<1);l=c[j>>2]|0}f=c[d>>2]|0;c[j>>2]=l+1;j=f+(l*56|0)|0;if(!(a[e+13>>0]|0)){d=c[e+4>>2]|0;m=ea(g[d+16>>2]);n=ea(g[d+20>>2]);o=ea(m*ea(-2.0));m=ea(n*ea(-2.0));n=ea(ea(g[d+24>>2])*ea(-2.0));p=ea(g[d+12>>2]);q=ea(ea(p*p)+ea(-.5));r=ea(g[d>>2]);s=ea(o*r);t=ea(g[d+4>>2]);u=ea(s+ea(m*t));s=ea(g[d+8>>2]);v=ea(u+ea(n*s));u=ea(ea(r*v)+ea(ea(o*q)-ea(p*ea(ea(n*t)-ea(m*s)))));w=ea(ea(t*v)+ea(ea(m*q)-ea(p*ea(ea(o*s)-ea(n*r)))));x=ea(ea(ea(n*q)-ea(p*ea(ea(m*r)-ea(o*t))))+ea(s*v));v=ea(-r);o=ea(-t);m=ea(-s);d=c[e>>2]|0;n=ea(g[d+16>>2]);y=ea(g[d+20>>2]);z=ea(n*ea(-2.0));n=ea(y*ea(-2.0));y=ea(ea(g[d+24>>2])*ea(-2.0));A=ea(g[d+12>>2]);B=ea(ea(A*A)+ea(-.5));C=ea(g[d>>2]);D=ea(z*C);E=ea(g[d+4>>2]);F=ea(D+ea(n*E));D=ea(g[d+8>>2]);G=ea(F+ea(y*D));F=ea(ea(ea(C*G)+ea(ea(z*B)-ea(A*ea(ea(y*E)-ea(n*D)))))*ea(2.0));H=ea(ea(ea(E*G)+ea(ea(n*B)-ea(A*ea(ea(z*D)-ea(y*C)))))*ea(2.0));I=ea(ea(ea(ea(y*B)-ea(A*ea(ea(n*C)-ea(z*E))))+ea(D*G))*ea(2.0));G=ea(ea(I*m)+ea(ea(F*v)+ea(H*o)));z=ea(u+ea(ea(G*v)+ea(ea(q*F)+ea(p*ea(ea(I*o)-ea(H*m))))));u=ea(w+ea(ea(G*o)+ea(ea(q*H)+ea(p*ea(ea(F*m)-ea(I*v))))));w=ea(x+ea(ea(ea(q*I)+ea(p*ea(ea(H*v)-ea(F*o))))+ea(G*m)));G=ea(ea(ea(ea(A*v)-ea(p*C))+ea(t*D))-ea(s*E));v=ea(ea(ea(s*C)+ea(ea(A*o)-ea(p*E)))-ea(r*D));o=ea(ea(ea(r*E)+ea(ea(A*m)-ea(p*D)))-ea(t*C));m=ea(ea(ea(ea(p*A)-ea(r*C))-ea(t*E))-ea(s*D));g[j>>2]=G;g[f+(l*56|0)+4>>2]=v;g[f+(l*56|0)+8>>2]=o;g[f+(l*56|0)+12>>2]=m;g[f+(l*56|0)+16>>2]=z;g[f+(l*56|0)+20>>2]=u;g[f+(l*56|0)+24>>2]=w;g[f+(l*56|0)+28>>2]=G;g[f+(l*56|0)+32>>2]=v;g[f+(l*56|0)+36>>2]=o;g[f+(l*56|0)+40>>2]=m;g[f+(l*56|0)+44>>2]=z;g[f+(l*56|0)+48>>2]=u;g[f+(l*56|0)+52>>2]=w;i=b;return}else{d=c[e>>2]|0;h=e+4|0;k=c[h>>2]|0;w=ea(-ea(g[k>>2]));u=ea(-ea(g[k+4>>2]));z=ea(-ea(g[k+8>>2]));m=ea(g[k+12>>2]);J=d+48|0;o=ea(g[J>>2]);v=ea(o-ea(g[k+16>>2]));K=d+52|0;o=ea(g[K>>2]);G=ea(o-ea(g[k+20>>2]));L=d+56|0;o=ea(g[L>>2]);D=ea(v*ea(2.0));v=ea(G*ea(2.0));G=ea(ea(o-ea(g[k+24>>2]))*ea(2.0));o=ea(ea(m*m)+ea(-.5));s=ea(ea(ea(D*w)+ea(v*u))+ea(G*z));E=ea(ea(s*w)+ea(ea(o*D)+ea(m*ea(ea(G*u)-ea(v*z)))));t=ea(ea(s*u)+ea(ea(o*v)+ea(m*ea(ea(D*z)-ea(G*w)))));C=ea(ea(ea(o*G)+ea(m*ea(ea(v*w)-ea(D*u))))+ea(s*z));k=d+32|0;s=ea(g[k>>2]);D=ea(m*s);M=d+44|0;v=ea(g[M>>2]);G=ea(D+ea(v*w));N=d+40|0;D=ea(g[N>>2]);o=ea(G+ea(D*u));O=d+36|0;G=ea(g[O>>2]);r=ea(o-ea(G*z));o=ea(ea(ea(s*z)+ea(ea(v*u)+ea(m*G)))-ea(D*w));A=ea(ea(ea(G*w)+ea(ea(v*z)+ea(m*D)))-ea(s*u));p=ea(ea(ea(ea(m*v)-ea(s*w))-ea(G*u))-ea(D*z));P=c[e+8>>2]|0;z=ea(g[P+16>>2]);D=ea(g[P+20>>2]);u=ea(z*ea(-2.0));z=ea(D*ea(-2.0));D=ea(ea(g[P+24>>2])*ea(-2.0));G=ea(g[P+12>>2]);w=ea(ea(G*G)+ea(-.5));s=ea(g[P>>2]);v=ea(u*s);m=ea(g[P+4>>2]);F=ea(v+ea(z*m));v=ea(g[P+8>>2]);H=ea(F+ea(D*v));F=ea(-s);I=ea(-m);q=ea(-v);x=ea(ea(ea(s*H)+ea(ea(u*w)-ea(G*ea(ea(D*m)-ea(z*v)))))*ea(2.0));n=ea(ea(ea(m*H)+ea(ea(z*w)-ea(G*ea(ea(u*v)-ea(D*s)))))*ea(2.0));B=ea(ea(ea(ea(D*w)-ea(G*ea(ea(z*s)-ea(u*m))))+ea(v*H))*ea(2.0));H=ea(ea(p*p)+ea(-.5));v=ea(ea(A*B)+ea(ea(r*x)+ea(o*n)));m=ea(E+ea(ea(r*v)+ea(ea(H*x)+ea(p*ea(ea(o*B)-ea(A*n))))));E=ea(t+ea(ea(o*v)+ea(ea(H*n)+ea(p*ea(ea(A*x)-ea(r*B))))));t=ea(C+ea(ea(ea(H*B)+ea(p*ea(ea(r*n)-ea(o*x))))+ea(A*v)));v=ea(ea(ea(A*F)+ea(ea(o*G)+ea(p*I)))-ea(r*q));x=ea(ea(ea(r*I)+ea(ea(A*G)+ea(p*q)))-ea(o*F));n=ea(ea(ea(ea(p*G)-ea(r*F))-ea(o*I))-ea(A*q));g[j>>2]=ea(ea(ea(ea(r*G)+ea(p*F))+ea(o*q))-ea(A*I));g[f+(l*56|0)+4>>2]=v;g[f+(l*56|0)+8>>2]=x;g[f+(l*56|0)+12>>2]=n;g[f+(l*56|0)+16>>2]=m;g[f+(l*56|0)+20>>2]=E;g[f+(l*56|0)+24>>2]=t;j=c[h>>2]|0;t=ea(-ea(g[j>>2]));E=ea(-ea(g[j+4>>2]));m=ea(-ea(g[j+8>>2]));n=ea(g[j+12>>2]);x=ea(g[J>>2]);v=ea(x-ea(g[j+16>>2]));x=ea(g[K>>2]);I=ea(x-ea(g[j+20>>2]));x=ea(g[L>>2]);A=ea(v*ea(2.0));v=ea(I*ea(2.0));I=ea(ea(x-ea(g[j+24>>2]))*ea(2.0));x=ea(ea(n*n)+ea(-.5));q=ea(ea(ea(A*t)+ea(v*E))+ea(I*m));o=ea(ea(q*t)+ea(ea(x*A)+ea(n*ea(ea(I*E)-ea(v*m)))));F=ea(ea(q*E)+ea(ea(x*v)+ea(n*ea(ea(A*m)-ea(I*t)))));p=ea(ea(ea(x*I)+ea(n*ea(ea(v*t)-ea(A*E))))+ea(q*m));q=ea(g[k>>2]);A=ea(n*q);v=ea(g[M>>2]);I=ea(A+ea(v*t));A=ea(g[N>>2]);x=ea(I+ea(A*E));I=ea(g[O>>2]);G=ea(x-ea(I*m));x=ea(ea(ea(q*m)+ea(ea(v*E)+ea(n*I)))-ea(A*t));r=ea(ea(ea(I*t)+ea(ea(v*m)+ea(n*A)))-ea(q*E));B=ea(ea(ea(ea(n*v)-ea(q*t))-ea(I*E))-ea(A*m));m=ea(g[d+16>>2]);A=ea(g[d+20>>2]);E=ea(m*ea(-2.0));m=ea(A*ea(-2.0));A=ea(ea(g[d+24>>2])*ea(-2.0));I=ea(g[d+12>>2]);t=ea(ea(I*I)+ea(-.5));q=ea(g[d>>2]);v=ea(E*q);n=ea(g[d+4>>2]);H=ea(v+ea(m*n));v=ea(g[d+8>>2]);C=ea(H+ea(A*v));H=ea(-q);u=ea(-n);s=ea(-v);z=ea(ea(ea(q*C)+ea(ea(E*t)-ea(I*ea(ea(A*n)-ea(m*v)))))*ea(2.0));w=ea(ea(ea(n*C)+ea(ea(m*t)-ea(I*ea(ea(E*v)-ea(A*q)))))*ea(2.0));D=ea(ea(ea(ea(A*t)-ea(I*ea(ea(m*q)-ea(E*n))))+ea(v*C))*ea(2.0));C=ea(ea(B*B)+ea(-.5));v=ea(ea(r*D)+ea(ea(G*z)+ea(x*w)));n=ea(o+ea(ea(G*v)+ea(ea(C*z)+ea(B*ea(ea(x*D)-ea(r*w))))));o=ea(F+ea(ea(x*v)+ea(ea(C*w)+ea(B*ea(ea(r*z)-ea(G*D))))));F=ea(p+ea(ea(ea(C*D)+ea(B*ea(ea(G*w)-ea(x*z))))+ea(r*v)));v=ea(ea(ea(r*H)+ea(ea(x*I)+ea(B*u)))-ea(G*s));z=ea(ea(ea(G*u)+ea(ea(r*I)+ea(B*s)))-ea(x*H));w=ea(ea(ea(ea(B*I)-ea(G*H))-ea(x*u))-ea(r*s));g[f+(l*56|0)+28>>2]=ea(ea(ea(ea(G*I)+ea(B*H))+ea(x*s))-ea(r*u));g[f+(l*56|0)+32>>2]=v;g[f+(l*56|0)+36>>2]=z;g[f+(l*56|0)+40>>2]=w;g[f+(l*56|0)+44>>2]=n;g[f+(l*56|0)+48>>2]=o;g[f+(l*56|0)+52>>2]=F;i=b;return}}function A0a(d,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;x=i;i=i+48|0;y=x+24|0;z=x+12|0;A=x;B=x+36|0;C=UJa(x+37|0,s*176|0,491904,374)|0;D=(s|0)==0;if(!D){E=l+4|0;F=y+4|0;G=y+8|0;H=d+4|0;I=d+8|0;J=d+88|0;K=d+56|0;L=d+12|0;M=d+64|0;N=z+4|0;O=z+8|0;P=A+4|0;Q=A+8|0;R=l+12|0;S=(h|0)==0;U=l+8|0;V=0;do{W=c[r+(V<<2)>>2]|0;X=f+(V<<5)|0;Y=C+(V*176|0)|0;c[C+(V*176|0)+140>>2]=(c[l>>2]|0)+(W<<4);c[C+(V*176|0)+156>>2]=(c[E>>2]|0)+(W<<4);Z=f+(V<<5)+16|0;_=ea(g[Z>>2]);g[y>>2]=_;$=f+(V<<5)+20|0;aa=ea(g[$>>2]);g[F>>2]=aa;ba=f+(V<<5)+24|0;ca=ea(g[ba>>2]);g[G>>2]=ca;da=ea(g[d>>2]);fa=ea(g[H>>2]);ga=ea(g[I>>2]);if(!(c[J>>2]&65536)){ha=da;ia=fa;ja=ga}else{ka=ea(da+ea(g[j+(W*12|0)>>2]));da=ea(fa+ea(g[j+(W*12|0)+4>>2]));ha=ka;ia=da;ja=ea(ga+ea(g[j+(W*12|0)+8>>2]))}ga=ea(g[K>>2]);da=ea(g[L>>2]);ka=ea(g[M>>2]);fa=ea(ea(ia*ka)+aa);aa=ea(ea(ja*ka)+ca);ca=ea(da*ea(ea(ha*ka)+_));g[Z>>2]=ca;_=ea(da*fa);g[$>>2]=_;fa=ea(da*aa);g[ba>>2]=fa;aa=ea(ka*ea(T(ea(ea(fa*fa)+ea(ea(ca*ca)+ea(_*_))))));if(aa>ga){ka=ea(ga/aa);g[Z>>2]=ea(ca*ka);g[$>>2]=ea(_*ka);g[ba>>2]=ea(fa*ka)}g[z>>2]=ea(0.0);g[N>>2]=ea(0.0);g[O>>2]=ea(0.0);g[A>>2]=ea(0.0);g[P>>2]=ea(0.0);g[Q>>2]=ea(0.0);ba=b[f+(V<<5)+30>>1]|0;if((ba&4)!=0?($=c[U>>2]|0,g[z>>2]=ea(g[$+(W<<4)>>2]),g[N>>2]=ea(g[$+(W<<4)+4>>2]),g[O>>2]=ea(g[$+(W<<4)+8>>2]),!S):0)la=c[$+(W<<4)+12>>2]|0;else la=0;if((ba&8)!=0?(ba=c[R>>2]|0,g[A>>2]=ea(g[ba+(W<<4)>>2]),g[P>>2]=ea(g[ba+(W<<4)+4>>2]),g[Q>>2]=ea(g[ba+(W<<4)+8>>2]),!S):0)ma=c[ba+(W<<4)+12>>2]|0;else ma=0;WDb(Y,X,y,ea(g[w+(V<<2)>>2]),z,A,la,ma,W,d);W=C+(V*176|0)+62|0;b[W>>1]=e[W>>1]&65520;V=V+1|0}while((V|0)!=(s|0))}V=(v|0)==0;a:do if(!V){ma=0;la=0;while(1){if(!(a[t+(ma<<4)+13>>0]|0))na=la;else{Rta(d,f,s,C,l,m,o,q,t+(ma<<4)|0,u+(ma*56|0)|0);na=la+1|0}ma=ma+1|0;if((ma|0)==(v|0))break;else la=na}la=d+56|0;ha=ea(g[la>>2]);ja=ea(ha*ha);if((na|0)!=0?(ma=(c[d+88>>2]&1|0)!=0,!D):0){A=0;do{Lta(C+(A*176|0)|0,ma,0,d);ha=ea(g[la>>2]);z=C+(A*176|0)+64|0;ia=ea(g[z>>2]);ka=ea(g[C+(A*176|0)+48>>2]);fa=ea(ia-ka);w=C+(A*176|0)+68|0;ia=ea(g[w>>2]);_=ea(g[C+(A*176|0)+52>>2]);ca=ea(ia-_);y=C+(A*176|0)+72|0;ia=ea(g[y>>2]);aa=ea(g[C+(A*176|0)+56>>2]);ga=ea(ia-aa);ia=ea(ea(ea(fa*fa)+ea(ca*ca))+ea(ga*ga));if(ia>ja){da=ea(ea(1.0)/ea(T(ea(ia))));ia=ea(_+ea(ea(ha*ca)*da));ca=ea(aa+ea(ea(ha*ga)*da));g[z>>2]=ea(ka+ea(ea(ha*fa)*da));g[w>>2]=ia;g[y>>2]=ca}y=C+(A*176|0)+12|0;c[y>>2]=c[y>>2]&-8|4;g[C+(A*176|0)+16>>2]=ea(0.0);g[C+(A*176|0)+20>>2]=ea(0.0);g[C+(A*176|0)+24>>2]=ea(0.0);g[C+(A*176|0)+44>>2]=ea(1.0);A=A+1|0}while((A|0)!=(s|0))}if(!V){if(!m){A=0;while(1){if(!(a[t+(A<<4)+13>>0]|0))Rta(d,f,s,C,l,0,o,q,t+(A<<4)|0,u+(A*56|0)|0);A=A+1|0;if((A|0)==(v|0)){oa=d;pa=la;qa=ja;ra=43;break a}}}if(!s){A=0;ma=0;while(1){y=t+(A<<4)|0;if(!(a[t+(A<<4)+13>>0]|0)){if(ma)sa=1;else sa=(c[(c[t+(A<<4)+4>>2]|0)+36>>2]|0)==5;Rta(d,f,0,C,l,m,o,q,y,u+(A*56|0)|0);ta=sa}else ta=ma;A=A+1|0;if((A|0)==(v|0)){ua=ta;break}else ma=ta}}else{ma=0;A=0;while(1){y=t+(ma<<4)|0;if(!(a[t+(ma<<4)+13>>0]|0)){if(!A)if((c[(c[t+(ma<<4)+4>>2]|0)+36>>2]|0)==5){w=0;do{z=c[r+(w<<2)>>2]|0;c[m+(w<<5)>>2]=c[n+(z<<5)>>2];c[m+(w<<5)+4>>2]=c[n+(z<<5)+4>>2];c[m+(w<<5)+8>>2]=c[n+(z<<5)+8>>2];c[m+(w<<5)+12>>2]=c[n+(z<<5)+12>>2];c[m+(w<<5)+16>>2]=c[n+(z<<5)+16>>2];c[m+(w<<5)+20>>2]=c[n+(z<<5)+20>>2];c[m+(w<<5)+24>>2]=c[n+(z<<5)+24>>2];c[m+(w<<5)+28>>2]=c[n+(z<<5)+28>>2];w=w+1|0}while((w|0)!=(s|0));va=1}else va=0;else va=1;Rta(d,f,s,C,l,m,o,q,y,u+(ma*56|0)|0);wa=va}else wa=A;ma=ma+1|0;if((ma|0)==(v|0)){ua=wa;break}else A=wa}}if(ua){if(!D){A=0;do{ma=c[r+(A<<2)>>2]|0;c[n+(ma<<5)>>2]=c[m+(A<<5)>>2];c[n+(ma<<5)+4>>2]=c[m+(A<<5)+4>>2];c[n+(ma<<5)+8>>2]=c[m+(A<<5)+8>>2];c[n+(ma<<5)+12>>2]=c[m+(A<<5)+12>>2];c[n+(ma<<5)+16>>2]=c[m+(A<<5)+16>>2];c[n+(ma<<5)+20>>2]=c[m+(A<<5)+20>>2];c[n+(ma<<5)+24>>2]=c[m+(A<<5)+24>>2];c[n+(ma<<5)+28>>2]=c[m+(A<<5)+28>>2];A=A+1|0}while((A|0)!=(s|0));oa=d;pa=la;qa=ja;ra=43}}else{oa=d;pa=la;qa=ja;ra=43}}else{oa=d;pa=la;qa=ja;ra=43}}else{A=d+56|0;ca=ea(g[A>>2]);oa=d;pa=A;qa=ea(ca*ca);ra=43}while(0);if((ra|0)==43?!D:0){ra=d+88|0;m=d+72|0;d=0;do{n=C+(d*176|0)|0;Lta(n,0,1,oa);ca=ea(g[pa>>2]);r=C+(d*176|0)+64|0;ia=ea(g[r>>2]);da=ea(g[C+(d*176|0)+48>>2]);fa=ea(ia-da);ua=C+(d*176|0)+68|0;ia=ea(g[ua>>2]);ha=ea(g[C+(d*176|0)+52>>2]);ka=ea(ia-ha);wa=C+(d*176|0)+72|0;ia=ea(g[wa>>2]);ga=ea(g[C+(d*176|0)+56>>2]);aa=ea(ia-ga);ia=ea(ea(ea(fa*fa)+ea(ka*ka))+ea(aa*aa));if(ia>qa){_=ea(ea(1.0)/ea(T(ea(ia))));ia=ea(ha+ea(ea(ca*ka)*_));ka=ea(ga+ea(ea(ca*aa)*_));g[r>>2]=ea(da+ea(ea(ca*fa)*_));g[ua>>2]=ia;g[wa>>2]=ka}XDb(f+(d<<5)|0,n,(c[ra>>2]&8|0)!=0,m,p);d=d+1|0}while((d|0)!=(s|0))}if(!((j|0)==0|D)){d=0;do{p=c[C+(d*176|0)+76>>2]|0;g[j+(p*12|0)>>2]=ea(g[C+(d*176|0)>>2]);g[j+(p*12|0)+4>>2]=ea(g[C+(d*176|0)+4>>2]);g[j+(p*12|0)+8>>2]=ea(g[C+(d*176|0)+8>>2]);d=d+1|0}while((d|0)!=(s|0))}if(!((k|0)==0|D)){d=0;do{qa=ea(g[f+(d<<5)+16>>2]);ka=ea(qa-ea(g[C+(d*176|0)+32>>2]));qa=ea(g[f+(d<<5)+20>>2]);ia=ea(qa-ea(g[C+(d*176|0)+36>>2]));qa=ea(g[f+(d<<5)+24>>2]);_=ea(qa-ea(g[C+(d*176|0)+40>>2]));j=c[C+(d*176|0)+76>>2]|0;g[k+(j*12|0)>>2]=ka;g[k+(j*12|0)+4>>2]=ia;g[k+(j*12|0)+8>>2]=_;d=d+1|0}while((d|0)!=(s|0))}if((h|0)==0|D){VJa(B,C);i=x;return}else xa=0;do{D=c[C+(xa*176|0)+76>>2]|0;c[h+(D<<4)+12>>2]=c[C+(xa*176|0)+108>>2];g[h+(D<<4)>>2]=ea(g[C+(xa*176|0)+96>>2]);g[h+(D<<4)+4>>2]=ea(g[C+(xa*176|0)+100>>2]);g[h+(D<<4)+8>>2]=ea(g[C+(xa*176|0)+104>>2]);xa=xa+1|0}while((xa|0)!=(s|0));VJa(B,C);i=x;return}function B0a(a,d,f){a=a|0;d=d|0;f=ea(f);var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=0;h=i;j=c[a+124>>2]|0;if(!(j&56)){i=h;return}if(j&8){f=ea(ea(g[a+144>>2])*ea(2.0));k=ea(ea(g[a+148>>2])*ea(2.0));l=ea(ea(g[a+152>>2])*ea(2.0));m=ea(g[d+12>>2]);n=ea(ea(m*m)+ea(-.5));o=ea(g[d>>2]);p=ea(f*o);q=ea(g[d+4>>2]);r=ea(p+ea(k*q));p=ea(g[d+8>>2]);s=ea(r+ea(l*p));r=ea(ea(o*s)+ea(ea(f*n)+ea(m*ea(ea(l*q)-ea(k*p)))));t=ea(ea(q*s)+ea(ea(k*n)+ea(m*ea(ea(f*p)-ea(l*o)))));u=ea(ea(ea(l*n)+ea(m*ea(ea(k*o)-ea(f*q))))+ea(p*s));v=a+12|0;c[v>>2]=c[v>>2]&-4|2;g[a>>2]=r;g[a+4>>2]=t;g[a+8>>2]=u;g[a+16>>2]=ea(g[a+48>>2]);g[a+20>>2]=ea(g[a+52>>2]);g[a+24>>2]=ea(g[a+56>>2]);v=a+60|0;b[v>>1]=e[v>>1]|0|2}if(!(j&16)){i=h;return}j=a+172|0;u=ea(g[j>>2]);if(u<ea(3.0)){v=ea(u+ea(-1.5))>=ea(0.0);w=v?ea(.5):ea(1.0)}else w=ea(ea(1.0)/u);t=ea(w*ea(g[a+144>>2]));r=ea(w*ea(g[a+148>>2]));s=ea(w*ea(g[a+152>>2]));p=ea(w*ea(g[a+160>>2]));q=ea(w*ea(g[a+164>>2]));f=ea(w*ea(g[a+168>>2]));w=ea(t*ea(2.0));t=ea(r*ea(2.0));r=ea(s*ea(2.0));s=ea(g[d+12>>2]);o=ea(ea(s*s)+ea(-.5));k=ea(g[d>>2]);m=ea(w*k);n=ea(g[d+4>>2]);l=ea(m+ea(t*n));m=ea(g[d+8>>2]);x=ea(l+ea(r*m));l=ea(u*ea(ea(k*x)+ea(ea(w*o)+ea(s*ea(ea(r*n)-ea(t*m))))));y=ea(u*ea(ea(n*x)+ea(ea(t*o)+ea(s*ea(ea(w*m)-ea(r*k))))));z=ea(u*ea(ea(ea(r*o)+ea(s*ea(ea(t*k)-ea(w*n))))+ea(m*x)));x=ea(p*ea(2.0));p=ea(q*ea(2.0));q=ea(f*ea(2.0));f=ea(ea(ea(x*k)+ea(p*n))+ea(q*m));w=ea(ea(k*f)+ea(ea(x*o)+ea(s*ea(ea(q*n)-ea(p*m)))));t=ea(ea(n*f)+ea(ea(p*o)+ea(s*ea(ea(x*m)-ea(q*k)))));r=ea(ea(ea(q*o)+ea(s*ea(ea(p*k)-ea(x*n))))+ea(m*f));f=ea(ea(g[d+16>>2])+w);w=ea(ea(g[d+20>>2])+t);t=ea(u*f);f=ea(u*w);w=ea(u*ea(ea(g[d+24>>2])+r));d=a+12|0;v=c[d>>2]|0;A=v|1;c[d>>2]=A;if(!(v&4)){g[a>>2]=ea(l+ea(g[a>>2]));v=a+4|0;g[v>>2]=ea(y+ea(g[v>>2]));v=a+8|0;g[v>>2]=ea(z+ea(g[v>>2]))}else{g[a>>2]=l;g[a+4>>2]=y;g[a+8>>2]=z;c[d>>2]=A&-5}A=a+16|0;g[A>>2]=ea(t+ea(g[A>>2]));A=a+20|0;g[A>>2]=ea(f+ea(g[A>>2]));A=a+24|0;g[A>>2]=ea(w+ea(g[A>>2]));w=ea(g[j>>2]);j=a+28|0;g[j>>2]=ea(w+ea(g[j>>2]));j=a+60|0;b[j>>1]=e[j>>1]|0|2;i=h;return}function C0a(a,d,f,h,j,k,l,m,n){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im;o=i;i=i+48|0;p=o+24|0;q=o+12|0;r=o;s=a+124|0;if(!(c[s>>2]&56)){i=o;return}t=ea(ea(g[a+144>>2])*ea(2.0));u=ea(ea(g[a+148>>2])*ea(2.0));v=ea(ea(g[a+152>>2])*ea(2.0));w=ea(g[k+12>>2]);x=ea(ea(w*w)+ea(-.5));y=ea(g[k>>2]);z=ea(t*y);A=ea(g[k+4>>2]);B=ea(z+ea(u*A));z=ea(g[k+8>>2]);C=ea(B+ea(v*z));B=ea(ea(A*C)+ea(ea(u*x)+ea(w*ea(ea(t*z)-ea(v*y)))));D=ea(ea(ea(v*x)+ea(w*ea(ea(u*y)-ea(t*A))))+ea(z*C));g[p>>2]=ea(ea(y*C)+ea(ea(t*x)+ea(w*ea(ea(v*A)-ea(u*z)))));E=p+4|0;g[E>>2]=B;F=p+8|0;g[F>>2]=D;u=ea(ea(g[a+160>>2])*ea(2.0));v=ea(ea(g[a+164>>2])*ea(2.0));t=ea(ea(g[a+168>>2])*ea(2.0));C=ea(ea(ea(u*y)+ea(v*A))+ea(t*z));G=ea(ea(y*C)+ea(ea(u*x)+ea(w*ea(ea(t*A)-ea(v*z)))));H=ea(ea(A*C)+ea(ea(v*x)+ea(w*ea(ea(u*z)-ea(t*y)))));I=ea(ea(ea(t*x)+ea(w*ea(ea(v*y)-ea(u*A))))+ea(z*C));C=ea(ea(g[k+16>>2])+G);G=ea(ea(g[k+20>>2])+H);H=ea(ea(g[k+24>>2])+I);g[q>>2]=C;k=q+4|0;g[k>>2]=G;J=q+8|0;g[J>>2]=H;K=d+16|0;I=ea(C-ea(g[K>>2]));L=d+20|0;z=ea(G-ea(g[L>>2]));M=d+24|0;A=ea(H-ea(g[M>>2]));d=h+4|0;u=ea(g[d>>2]);y=ea(u*A);N=h+8|0;v=ea(g[N>>2]);w=ea(y-ea(z*v));y=ea(I*v);v=ea(g[h>>2]);x=ea(y-ea(A*v));y=ea(ea(z*v)-ea(I*u));u=ea(w+ea(g[f>>2]));O=f+4|0;v=ea(x+ea(g[O>>2]));P=f+8|0;t=ea(y+ea(g[P>>2]));g[r>>2]=u;g[r+4>>2]=v;g[r+8>>2]=t;Q=c[s>>2]|0;if(Q&8){s=a+12|0;c[s>>2]=c[s>>2]&-4|2;g[a>>2]=ea(g[p>>2]);g[a+4>>2]=B;g[a+8>>2]=D;g[a+16>>2]=C;g[a+20>>2]=G;g[a+24>>2]=H;g[a+32>>2]=u;g[a+36>>2]=v;g[a+40>>2]=t;c[a+108>>2]=j;s=a+60|0;b[s>>1]=e[s>>1]|0|4}if(Q&16){s=a+12|0;R=c[s>>2]|0;S=R|1;c[s>>2]=S;U=ea(g[p>>2]);if(!(R&4)){g[a>>2]=ea(U+ea(g[a>>2]));R=a+4|0;g[R>>2]=ea(B+ea(g[R>>2]));R=a+8|0;g[R>>2]=ea(D+ea(g[R>>2]));R=a+32|0;g[R>>2]=ea(u+ea(g[R>>2]));R=a+36|0;g[R>>2]=ea(v+ea(g[R>>2]));R=a+40|0;g[R>>2]=ea(t+ea(g[R>>2]))}else{g[a>>2]=U;g[a+4>>2]=B;g[a+8>>2]=D;g[a+32>>2]=u;g[a+36>>2]=v;g[a+40>>2]=t;c[s>>2]=S&-5}S=a+16|0;g[S>>2]=ea(C+ea(g[S>>2]));S=a+20|0;g[S>>2]=ea(G+ea(g[S>>2]));S=a+24|0;g[S>>2]=ea(H+ea(g[S>>2]));S=a+28|0;g[S>>2]=ea(ea(g[S>>2])+ea(1.0));c[a+108>>2]=j;S=a+60|0;b[S>>1]=e[S>>1]|0|4}if(!(Q&40)){i=o;return}H=ea(T(ea(ea(ea(I*I)+ea(z*z))+ea(A*A))));G=ea(I+ea(w*l));w=ea(z+ea(x*l));x=ea(A+ea(y*l));g[q>>2]=G;g[k>>2]=w;g[J>>2]=x;y=ea(ea(x*x)+ea(ea(G*G)+ea(w*w)));if(y>ea(0.0)){A=ea(ea(1.0)/ea(T(ea(y))));V=ea(G*A);W=ea(w*A);X=ea(x*A)}else{V=ea(0.0);W=ea(0.0);X=ea(0.0)}A=ea(H*V);V=ea(H*W);W=ea(H*X);X=ea(ea(g[f>>2])*l);H=ea(ea(g[O>>2])*l);x=ea(ea(g[P>>2])*l);w=ea(X+ea(g[K>>2]));X=ea(H+ea(g[L>>2]));H=ea(x+ea(g[M>>2]));g[q>>2]=ea(w+A);g[k>>2]=ea(X+V);g[J>>2]=ea(H+W);W=ea(g[d>>2]);H=ea(W*D);V=ea(g[N>>2]);X=ea(H-ea(V*B));H=ea(g[p>>2]);A=ea(V*H);V=ea(g[h>>2]);w=ea(ea(A-ea(D*V))*l);A=ea(ea(ea(B*V)-ea(W*H))*l);W=ea(H+ea(X*l));g[p>>2]=W;l=ea(B+w);g[E>>2]=l;w=ea(D+A);g[F>>2]=w;A=ea(ea(w*w)+ea(ea(W*W)+ea(l*l)));if(A>ea(0.0)){D=ea(ea(1.0)/ea(T(ea(A))));Y=ea(W*D);Z=ea(l*D);_=ea(w*D)}else{Y=ea(0.0);Z=ea(0.0);_=ea(0.0)}g[p>>2]=Y;g[E>>2]=Z;g[F>>2]=_;YDb(a,p,q,r,j,m,n);i=o;return}function D0a(a,d,f){a=a|0;d=d|0;f=ea(f);var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0;h=i;i=i+32|0;j=h+12|0;k=h;l=a+124|0;if(!(c[l>>2]&56)){i=h;return}f=ea(ea(g[a+144>>2])*ea(2.0));m=ea(ea(g[a+148>>2])*ea(2.0));n=ea(ea(g[a+152>>2])*ea(2.0));o=ea(g[d+12>>2]);p=ea(ea(o*o)+ea(-.5));q=ea(g[d>>2]);r=ea(f*q);s=ea(g[d+4>>2]);t=ea(r+ea(m*s));r=ea(g[d+8>>2]);u=ea(t+ea(n*r));t=ea(ea(q*u)+ea(ea(f*p)+ea(o*ea(ea(n*s)-ea(m*r)))));v=ea(ea(s*u)+ea(ea(m*p)+ea(o*ea(ea(f*r)-ea(n*q)))));w=ea(ea(ea(n*p)+ea(o*ea(ea(m*q)-ea(f*s))))+ea(r*u));g[j>>2]=t;g[j+4>>2]=v;g[j+8>>2]=w;u=ea(ea(g[a+160>>2])*ea(2.0));f=ea(ea(g[a+164>>2])*ea(2.0));m=ea(ea(g[a+168>>2])*ea(2.0));n=ea(ea(ea(u*q)+ea(f*s))+ea(m*r));x=ea(ea(q*n)+ea(ea(u*p)+ea(o*ea(ea(m*s)-ea(f*r)))));y=ea(ea(s*n)+ea(ea(f*p)+ea(o*ea(ea(u*r)-ea(m*q)))));z=ea(ea(ea(m*p)+ea(o*ea(ea(f*q)-ea(u*s))))+ea(r*n));n=ea(ea(g[d+16>>2])+x);x=ea(ea(g[d+20>>2])+y);y=ea(ea(g[d+24>>2])+z);g[k>>2]=n;g[k+4>>2]=x;g[k+8>>2]=y;d=c[l>>2]|0;if(d&8){l=a+12|0;c[l>>2]=c[l>>2]&-4|2;g[a>>2]=t;g[a+4>>2]=v;g[a+8>>2]=w;g[a+16>>2]=n;g[a+20>>2]=x;g[a+24>>2]=y;l=a+60|0;b[l>>1]=e[l>>1]|0|2}if(d&16){l=a+12|0;A=c[l>>2]|0;B=A|1;c[l>>2]=B;if(!(A&4)){g[a>>2]=ea(t+ea(g[a>>2]));A=a+4|0;g[A>>2]=ea(v+ea(g[A>>2]));A=a+8|0;g[A>>2]=ea(w+ea(g[A>>2]))}else{g[a>>2]=t;g[a+4>>2]=v;g[a+8>>2]=w;c[l>>2]=B&-5}B=a+16|0;g[B>>2]=ea(n+ea(g[B>>2]));B=a+20|0;g[B>>2]=ea(x+ea(g[B>>2]));B=a+24|0;g[B>>2]=ea(y+ea(g[B>>2]));B=a+28|0;g[B>>2]=ea(ea(g[B>>2])+ea(1.0));B=a+60|0;b[B>>1]=e[B>>1]|0|2}if(!(d&40)){i=h;return}ZDb(a,j,k);i=h;return}function E0a(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=0,S=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im;e=i;i=i+80|0;f=e+52|0;h=e+40|0;j=e+12|0;k=e+16|0;l=e+56|0;m=e;n=e+28|0;o=e+48|0;p=e+44|0;g[f>>2]=d;q=a+112|0;r=a+128|0;s=ea(g[b+4>>2]);g[h>>2]=s;t=ea(g[b+8>>2]);g[j>>2]=t;u=ea(g[a+116>>2]);v=ea(u*u);w=ea(g[a+120>>2]);x=ea(w*w);y=ea(ea(v+x)-ea(s*s));z=ea(g[q>>2]);A=ea(ea(t*t)+ea(y+ea(z*z)));B=ea(ea(t*ea(2.0))*z);C=ea(A-B);D=ea(B+A);b=y<ea(0.0);E=C<ea(0.0);F=D<ea(0.0);A=ea(-t);if(z>t|z<A){if(E|F)G=4}else if(b|E|F)G=4;if((G|0)==4){B=z>A?z:A;H=B<t?B:t;B=ea(z-H);if(!(B==ea(0.0)&u==ea(0.0)&w==ea(0.0))){I=ea(x+ea(v+ea(B*B)));if(I>ea(0.0)){v=ea(ea(1.0)/ea(T(ea(I))));J=ea(B*v);K=ea(u*v);L=ea(w*v)}else{J=ea(0.0);K=ea(0.0);L=ea(0.0)}}else{J=ea(0.0);K=ea(1.0);L=ea(0.0)}g[a+144>>2]=J;g[a+148>>2]=K;g[a+152>>2]=L;v=ea(s+ea(g[a+92>>2]));B=ea(ea(v*K)+ea(0.0));K=ea(ea(L*v)+ea(0.0));g[a+160>>2]=ea(H+ea(J*v));g[a+164>>2]=B;g[a+168>>2]=K;g[a+44>>2]=ea(0.0);G=a+124|0;c[G>>2]=c[G>>2]|8;i=e;return}K=ea(g[r>>2]);B=ea(K-z);v=ea(g[a+132>>2]);J=ea(v-u);H=ea(g[a+136>>2]);L=ea(H-w);g[m>>2]=B;g[m+4>>2]=J;g[m+8>>2]=L;I=ea(ea(J*u)+ea(L*w));g[l+4>>2]=I;x=ea(I+ea(B*z));M=ea(B*t);N=ea(x-M);g[l>>2]=N;O=ea(x+M);G=l+8|0;g[G>>2]=O;M=ea(ea(J*J)+ea(L*L));g[k+4>>2]=M;x=ea(M+ea(B*B));g[k>>2]=x;F=k+8|0;g[F>>2]=x;P=ea(ea(I*I)-ea(y*M));y=ea(ea(O*O)-ea(D*x));g[n>>2]=ea(ea(N*N)-ea(C*x));g[n+4>>2]=P;E=n+8|0;g[E>>2]=y;if(!(P>=ea(0.0))){Q=a+124|0;R=c[Q>>2]|0;if(R&2){i=e;return}y=K>A?K:A;x=y<t?y:t;y=ea(K-x);S=a+144|0;g[S>>2]=y;U=a+148|0;g[U>>2]=v;V=a+152|0;g[V>>2]=H;C=ea(T(ea(ea(H*H)+ea(ea(v*v)+ea(y*y)))));if(!(C<ea(s+d))){i=e;return}if(C!=ea(0.0)){N=ea(ea(1.0)/C);D=ea(y*N);g[S>>2]=D;y=ea(v*N);g[U>>2]=y;W=D;X=y;Y=ea(H*N)}else{g[S>>2]=ea(0.0);g[U>>2]=ea(0.0);W=ea(0.0);X=ea(0.0);Y=ea(0.0)}g[V>>2]=Y;N=ea(s+ea(g[a+92>>2]));y=ea(ea(X*N)+ea(0.0));X=ea(ea(Y*N)+ea(0.0));g[a+160>>2]=ea(x+ea(W*N));g[a+164>>2]=y;g[a+168>>2]=X;c[Q>>2]=R|32;if(!(C<N)){i=e;return}c[Q>>2]=R|48;i=e;return}if(b)if(z>ea(0.0)){Uta(a,q,r,m,j,h,j,n,k,l,f);i=e;return}else{g[o>>2]=A;Uta(a,q,r,m,j,h,o,E,F,G,f);i=e;return}if(P<=ea(0.0)|M==ea(0.0)){o=a+124|0;b=c[o>>2]|0;if(b&2){i=e;return}N=K>A?K:A;C=N<t?N:t;N=ea(K-C);R=a+144|0;g[R>>2]=N;Q=a+148|0;g[Q>>2]=v;V=a+152|0;g[V>>2]=H;X=ea(T(ea(ea(H*H)+ea(ea(v*v)+ea(N*N)))));if(!(X<ea(s+d))){i=e;return}if(X!=ea(0.0)){y=ea(ea(1.0)/X);W=ea(N*y);g[R>>2]=W;N=ea(v*y);g[Q>>2]=N;Z=W;_=N;$=ea(H*y)}else{g[R>>2]=ea(0.0);g[Q>>2]=ea(0.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0)}g[V>>2]=$;y=ea(s+ea(g[a+92>>2]));N=ea(ea(_*y)+ea(0.0));_=ea(ea($*y)+ea(0.0));g[a+160>>2]=ea(C+ea(Z*y));g[a+164>>2]=N;g[a+168>>2]=_;c[o>>2]=b|32;if(!(X<y)){i=e;return}c[o>>2]=b|48;i=e;return}y=ea(ea(-ea(I+ea(T(ea(P)))))/M);if(!(y<ea(0.0)|y>ea(1.0))){M=ea(ea(y*B)+z);B=ea(ea(y*J)+u);J=ea(ea(y*L)+w);if(M>t){Uta(a,q,r,m,j,h,j,n,k,l,f);i=e;return}if(M<A){g[p>>2]=A;Uta(a,q,r,m,j,h,p,E,F,G,f);i=e;return}f=a+44|0;if(!(y<ea(g[f>>2]))){i=e;return}M=ea(ea(1.0)/s);L=ea(J*M);g[a+148>>2]=ea(B*M);g[a+152>>2]=L;g[a+144>>2]=ea(0.0);g[a+160>>2]=z;g[a+164>>2]=u;g[a+168>>2]=w;g[f>>2]=y;f=a+124|0;c[f>>2]=c[f>>2]|8;i=e;return}f=a+124|0;G=c[f>>2]|0;if(G&2){i=e;return}y=K>A?K:A;A=y<t?y:t;t=ea(K-A);F=a+144|0;g[F>>2]=t;E=a+148|0;g[E>>2]=v;p=a+152|0;g[p>>2]=H;K=ea(T(ea(ea(H*H)+ea(ea(v*v)+ea(t*t)))));if(!(K<ea(s+d))){i=e;return}if(K!=ea(0.0)){d=ea(ea(1.0)/K);y=ea(t*d);g[F>>2]=y;t=ea(v*d);g[E>>2]=t;aa=y;ba=t;ca=ea(H*d)}else{g[F>>2]=ea(0.0);g[E>>2]=ea(0.0);aa=ea(0.0);ba=ea(0.0);ca=ea(0.0)}g[p>>2]=ca;d=ea(s+ea(g[a+92>>2]));s=ea(ea(ba*d)+ea(0.0));ba=ea(ea(ca*d)+ea(0.0));g[a+160>>2]=ea(A+ea(aa*d));g[a+164>>2]=s;g[a+168>>2]=ba;c[f>>2]=G|32;if(!(K<d)){i=e;return}c[f>>2]=G|48;i=e;return}function F0a(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;c=i;d=ea(g[b+16>>2]);e=ea(g[b+32>>2]);f=ea(d*e);h=ea(g[b+20>>2]);j=ea(g[b+28>>2]);k=ea(f-ea(h*j));f=ea(g[b+24>>2]);l=ea(h*f);m=ea(g[b+12>>2]);n=ea(e*m);o=ea(l-n);p=ea(ea(j*m)-ea(d*f));q=ea(g[b>>2]);r=ea(k*q);s=ea(g[b+4>>2]);t=ea(r+ea(s*o));o=ea(g[b+8>>2]);r=ea(t+ea(p*o));if(r!=ea(0.0)){t=ea(ea(1.0)/r);r=ea(-ea(t*ea(ea(e*s)-ea(j*o))));u=ea(t*ea(ea(h*s)-ea(d*o)));v=ea(-ea(t*ea(n-l)));l=ea(t*ea(ea(e*q)-ea(o*f)));e=ea(-ea(t*ea(ea(h*q)-ea(o*m))));o=ea(t*p);p=ea(-ea(t*ea(ea(j*q)-ea(s*f))));f=ea(t*ea(ea(d*q)-ea(s*m)));g[a>>2]=ea(t*k);g[a+4>>2]=r;g[a+8>>2]=u;g[a+12>>2]=v;g[a+16>>2]=l;g[a+20>>2]=e;g[a+24>>2]=o;g[a+28>>2]=p;g[a+32>>2]=f;i=c;return}else{g[a>>2]=ea(1.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+16>>2]=ea(1.0);g[a+20>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+32>>2]=ea(1.0);i=c;return}}function G0a(a,b,c,d,e,f,h,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=0,N=Im,O=Im,P=0,Q=Im,R=Im,S=0,U=Im,V=Im,W=Im,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=0;q=i;r=ea(g[o>>2]);s=ea(r*r);r=ea(g[p>>2]);t=ea(r*r);r=ea(g[j>>2]);u=ea(r-ea(g[h>>2]));v=ea(g[j+4>>2]);p=h+4|0;w=ea(v-ea(g[p>>2]));x=ea(g[j+8>>2]);j=h+8|0;y=ea(x-ea(g[j>>2]));z=ea(g[k>>2]);A=ea(z-r);B=k+4|0;C=ea(g[B>>2]);D=ea(C-v);E=k+8|0;F=ea(g[E>>2]);G=ea(F-x);H=ea(g[l>>2]);I=ea(H*H);J=l+4|0;K=ea(g[J>>2]);L=ea(I+ea(K*K));M=l+8|0;I=ea(g[M>>2]);N=ea(L+ea(I*I));L=ea(g[m>>2]);O=ea(H*L);P=m+4|0;Q=ea(g[P>>2]);R=ea(O+ea(K*Q));S=m+8|0;O=ea(g[S>>2]);U=ea(R+ea(I*O));R=ea(ea(ea(L*L)+ea(Q*Q))+ea(O*O));V=ea(ea(ea(A*H)+ea(D*K))+ea(G*I));W=ea(ea(ea(A*L)+ea(D*Q))+ea(G*O));G=ea(ea(U*W)-ea(V*R));D=ea(ea(V*U)-ea(N*W));A=ea(ea(N*R)-ea(U*U));do if(!(G<=ea(0.0))){if(D<=ea(0.0)){X=N>ea(1.17549435e-38);Y=X?N:ea(1.17549435e-38);Z=ea(0.0);_=ea(ea(-V)/Y);$=Y;aa=R;ba=0;break}if(ea(G+D)>A){Y=ea(ea(ea(N+R)-U)-U);ca=ea(ea(ea(R+W)-U)-V);X=Y>ea(1.17549435e-38);da=ea(ca/(X?Y:ea(1.17549435e-38)));Z=ea(ea(1.0)-da);_=da;$=N;aa=R;ba=0;break}else{X=A>ea(1.17549435e-38);da=ea(ea(1.0)/(X?A:ea(1.17549435e-38)));Z=ea(D*da);_=ea(G*da);$=N;aa=R;ba=1;break}}else{X=R>ea(1.17549435e-38);da=X?R:ea(1.17549435e-38);Z=ea(ea(-W)/da);_=ea(0.0);$=N;aa=da;ba=0}while(0);X=_>ea(0.0);N=X?_:ea(0.0);X=Z>ea(0.0);_=X?Z:ea(0.0);X=N<ea(1.0);Z=X?N:ea(1.0);X=_<ea(1.0);N=X?_:ea(1.0);_=ea(ea(ea(H*Z)+z)+ea(N*L));z=ea(ea(ea(Z*K)+C)+ea(N*Q));C=ea(ea(ea(Z*I)+F)+ea(N*O));N=ea(r-_);r=ea(v-z);v=ea(x-C);x=ea(ea(ea(N*N)+ea(r*r))+ea(v*v));F=ea(ea(K*O)-ea(I*Q));Z=ea(ea(I*L)-ea(H*O));O=ea(ea(H*Q)-ea(K*L));L=ea(T(ea(ea(O*O)+ea(ea(F*F)+ea(Z*Z)))));X=ea(ea(ea(N*F)+ea(Z*r))+ea(O*v))>ea(0.0);fa=ba&x<t&X;ba=x<s&X;if(!n){if(ba){if(x>ea(9.99999974e-06)){s=ea(ea(1.0)/ea(T(ea(x))));x=ea(N*s);N=ea(r*s);r=ea(v*s);g[a>>2]=x;g[a+4>>2]=N;g[a+8>>2]=r;ga=x;ha=N;ia=r}else{r=ea(ea(1.0)/L);N=ea(F*r);x=ea(Z*r);s=ea(O*r);g[a>>2]=N;g[a+4>>2]=x;g[a+8>>2]=s;ga=N;ha=x;ia=s}s=ea(g[o>>2]);x=ea(z+ea(s*ha));ha=ea(C+ea(s*ia));g[b>>2]=ea(_+ea(s*ga));g[b+4>>2]=x;g[b+8>>2]=ha;ja=16}else ja=0;if(fa){ha=ea(ea(1.0)/L);x=ea(F*ha);ga=ea(Z*ha);s=ea(O*ha);g[c>>2]=x;n=c+4|0;g[n>>2]=ga;X=c+8|0;g[X>>2]=s;ha=ea(g[o>>2]);ia=ea(z+ea(ha*ga));ga=ea(C+ea(s*ha));g[d>>2]=ea(_+ea(ha*x));g[d+4>>2]=ia;g[d+8>>2]=ga;ga=ea(g[h>>2]);ia=ea(ga-ea(g[k>>2]));ga=ea(g[p>>2]);x=ea(ga-ea(g[B>>2]));ga=ea(g[j>>2]);ha=ea(ga-ea(g[E>>2]));ga=ea(ia*ea(g[c>>2]));ia=ea(ga+ea(x*ea(g[n>>2])));g[f>>2]=ea(ia+ea(ha*ea(g[X>>2])));ka=ja|32;i=q;return ka|0}else la=ja}else la=0;if(ba|fa){ka=la;i=q;return ka|0}ha=ea(g[k>>2]);ia=ea(g[h>>2]);x=ea(ha-ia);ga=ea(g[B>>2]);_=ea(g[p>>2]);s=ea(ga-_);C=ea(g[E>>2]);z=ea(g[j>>2]);N=ea(ea(ea(F*x)+ea(Z*s))+ea(O*ea(C-z)));s=ea(ea(y*O)+ea(ea(u*F)+ea(w*Z)));if(!(!(N>ea(0.0))&!(s>=N))){ka=la;i=q;return ka|0}x=ea(N/s);s=ea(ha-ea(ia+ea(u*x)));u=ea(ga-ea(_+ea(w*x)));w=ea(C-ea(z+ea(y*x)));y=ea(ea(g[l>>2])*s);z=ea(y+ea(ea(g[J>>2])*u));y=ea(ea(ea(g[M>>2])*w)+z);z=ea(s*ea(g[m>>2]));s=ea(z+ea(u*ea(g[P>>2])));u=ea(s+ea(w*ea(g[S>>2])));w=ea(ea(U*u)-ea(aa*y));aa=ea(ea(U*y)-ea($*u));u=ea(A*ea(.0000999999974));$=ea(-u);if(!(w>=$)|!(aa>=$)){ka=la;i=q;return ka|0}if(!(ea(w+aa)<=ea(A+u))){ka=la;i=q;return ka|0}u=ea(ea(1.0)/L);g[f>>2]=ea(-ea(N*u));N=ea(Z*u);Z=ea(O*u);g[a>>2]=ea(F*u);g[a+4>>2]=N;g[a+8>>2]=Z;g[b>>2]=ea(g[h>>2]);g[b+4>>2]=ea(g[p>>2]);g[b+8>>2]=ea(g[j>>2]);g[e>>2]=x;ka=la|8;i=q;return ka|0}function H0a(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;o=i;i=i+16|0;p=o;g[p>>2]=h;if(e&8){q=b+44|0;if(ea(g[q>>2])>f){g[b+144>>2]=ea(g[j>>2]);g[b+148>>2]=ea(g[j+4>>2]);g[b+152>>2]=ea(g[j+8>>2]);g[b+160>>2]=ea(g[k>>2]);g[b+164>>2]=ea(g[k+4>>2]);g[b+168>>2]=ea(g[k+8>>2]);g[q>>2]=f;c[b+124>>2]=8}_Db(b,p,j,k,n);a[d>>0]=1;i=o;return}if(a[d>>0]|0){i=o;return}if(e&32){_Db(b,p,l,m,n);n=b+124|0;c[n>>2]=c[n>>2]|32}if(!(e&16)){i=o;return}f=ea(g[j>>2]);e=b+144|0;g[e>>2]=ea(f+ea(g[e>>2]));f=ea(g[j+4>>2]);e=b+148|0;g[e>>2]=ea(f+ea(g[e>>2]));f=ea(g[j+8>>2]);j=b+152|0;g[j>>2]=ea(f+ea(g[j>>2]));f=ea(g[k>>2]);j=b+160|0;g[j>>2]=ea(f+ea(g[j>>2]));f=ea(g[k+4>>2]);j=b+164|0;g[j>>2]=ea(f+ea(g[j>>2]));f=ea(g[k+8>>2]);k=b+168|0;g[k>>2]=ea(f+ea(g[k>>2]));k=b+172|0;g[k>>2]=ea(ea(g[k>>2])+ea(1.0));k=b+124|0;c[k>>2]=c[k>>2]|16;i=o;return}function I0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=i;e=ea(g[c>>2]);f=ea(g[c+12>>2]);if(e>f){g[a>>2]=e;g[a+4>>2]=ea(g[c+4>>2]);g[a+8>>2]=ea(g[c+8>>2]);g[a+12>>2]=f;g[a+16>>2]=ea(g[c+16>>2]);g[a+20>>2]=ea(g[c+20>>2]);i=d;return}else{h=ea(g[b>>2]);j=ea(g[b+4>>2]);k=ea(g[b+8>>2]);l=ea(g[b+12>>2]);m=ea(g[b+16>>2]);n=ea(g[b+20>>2]);o=ea(g[b+24>>2]);p=ea(g[b+28>>2]);q=ea(g[b+32>>2]);r=ea(e+f);s=ea(g[c+4>>2]);t=ea(g[c+16>>2]);u=ea(s+t);v=ea(g[c+8>>2]);w=ea(g[c+20>>2]);x=ea(r*ea(.5));r=ea(u*ea(.5));u=ea(ea(v+w)*ea(.5));y=ea(ea(ea(x*h)+ea(r*l))+ea(u*o));z=ea(ea(ea(x*j)+ea(r*m))+ea(u*p));A=ea(ea(ea(x*k)+ea(r*n))+ea(u*q));u=ea(y+ea(g[b+36>>2]));y=ea(z+ea(g[b+40>>2]));z=ea(A+ea(g[b+44>>2]));A=ea(ea(f-e)*ea(.5));e=ea(ea(t-s)*ea(.5));s=ea(ea(w-v)*ea(.5));v=ea(ea(ea(S(ea(A*h)))+ea(S(ea(l*e))))+ea(S(ea(o*s))));o=ea(ea(ea(S(ea(A*j)))+ea(S(ea(m*e))))+ea(S(ea(p*s))));p=ea(ea(ea(S(ea(A*k)))+ea(S(ea(n*e))))+ea(S(ea(q*s))));s=ea(y-o);q=ea(z-p);e=ea(u+v);n=ea(y+o);o=ea(z+p);g[a>>2]=ea(u-v);g[a+4>>2]=s;g[a+8>>2]=q;g[a+12>>2]=e;g[a+16>>2]=n;g[a+20>>2]=o;i=d;return}}function J0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im;d=i;i=i+48|0;e=d;f=ea(g[c>>2]);h=ea(g[c+4>>2]);j=ea(g[c+8>>2]);k=ea(g[c+12>>2]);l=ea(f+f);m=ea(h+h);n=ea(j+j);o=ea(h*m);p=ea(j*n);q=ea(l*h);h=ea(l*j);r=ea(l*k);s=ea(m*j);j=ea(m*k);m=ea(n*k);k=ea(ea(ea(1.0)-o)-p);n=ea(q+m);t=ea(h-j);u=ea(q-m);m=ea(ea(1.0)-ea(f*l));l=ea(m-p);p=ea(s+r);f=ea(h+j);j=ea(s-r);r=ea(m-o);g[a>>2]=k;c=a+4|0;g[c>>2]=u;v=a+8|0;g[v>>2]=f;w=a+12|0;g[w>>2]=n;x=a+16|0;g[x>>2]=l;y=a+20|0;g[y>>2]=j;z=a+24|0;g[z>>2]=t;A=a+28|0;g[A>>2]=p;B=a+32|0;g[B>>2]=r;o=ea(g[b>>2]);m=ea(g[b+4>>2]);s=ea(g[b+8>>2]);h=ea(n*ea(0.0));q=ea(l*ea(0.0));C=ea(j*ea(0.0));D=ea(t*ea(0.0));E=ea(p*ea(0.0));F=ea(r*ea(0.0));G=ea(ea(ea(o*k)+h)+D);H=ea(ea(ea(o*u)+q)+E);I=ea(F+ea(ea(o*f)+C));o=ea(k*ea(0.0));J=ea(u*ea(0.0));K=ea(f*ea(0.0));L=ea(ea(o+ea(m*n))+D);D=ea(ea(J+ea(m*l))+E);E=ea(F+ea(K+ea(m*j)));m=ea(ea(o+h)+ea(s*t));h=ea(ea(J+q)+ea(s*p));q=ea(ea(r*s)+ea(K+C));C=ea(ea(ea(k*H)+ea(n*D))+ea(t*h));K=ea(ea(t*q)+ea(ea(k*I)+ea(n*E)));s=ea(ea(ea(u*G)+ea(l*L))+ea(p*m));J=ea(ea(ea(u*H)+ea(l*D))+ea(p*h));o=ea(ea(p*q)+ea(ea(u*I)+ea(l*E)));l=ea(ea(ea(f*G)+ea(j*L))+ea(r*m));u=ea(ea(ea(f*H)+ea(j*D))+ea(r*h));h=ea(ea(r*q)+ea(ea(f*I)+ea(j*E)));g[a>>2]=ea(ea(ea(k*G)+ea(n*L))+ea(t*m));g[c>>2]=C;g[v>>2]=K;g[w>>2]=s;g[x>>2]=J;g[y>>2]=o;g[z>>2]=l;g[A>>2]=u;g[B>>2]=h;F0a(e,a);g[a+36>>2]=ea(g[e>>2]);g[a+40>>2]=ea(g[e+4>>2]);g[a+44>>2]=ea(g[e+8>>2]);g[a+48>>2]=ea(g[e+12>>2]);g[a+52>>2]=ea(g[e+16>>2]);g[a+56>>2]=ea(g[e+20>>2]);g[a+60>>2]=ea(g[e+24>>2]);g[a+64>>2]=ea(g[e+28>>2]);g[a+68>>2]=ea(g[e+32>>2]);i=d;return}function K0a(f,h,j,k,l,m,n,o){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0;p=i;q=b[h>>1]|0;do if((q&16)!=0?(c[f+28>>2]|0)==(n|0):0){r=a[f>>0]|0;s=r&255;c[j>>2]=s;if((r&255)<2&o){c[k>>2]=e[f+2>>1];t=ea(g[l>>2]);u=ea(t-ea(g[f+4>>2]));t=ea(g[l+4>>2]);v=ea(t-ea(g[f+8>>2]));t=ea(g[l+8>>2]);w=ea(t-ea(g[f+12>>2]));x=u<ea(0.0);t=x?u:ea(0.0);x=v<ea(0.0);u=x?v:ea(0.0);x=w<ea(0.0);v=x?w:ea(0.0);w=ea(g[f+16>>2]);y=ea(w-ea(g[l+12>>2]));w=ea(g[f+20>>2]);z=ea(w-ea(g[l+16>>2]));w=ea(g[f+24>>2]);A=ea(w-ea(g[l+20>>2]));x=y<ea(0.0);w=x?y:ea(0.0);x=z<ea(0.0);y=x?z:ea(0.0);x=A<ea(0.0);if(!(ea(ea(ea(ea(ea(t+u)+v)+w)+y)+(x?A:ea(0.0)))==ea(0.0)))break;b[h>>1]=q&65535|48;B=1;i=p;return B|0}x=f+16|0;A=ea(g[l>>2]);y=ea(g[f+4>>2]);w=ea(A-y);A=ea(g[l+4>>2]);v=ea(g[f+8>>2]);u=ea(A-v);A=ea(g[l+8>>2]);t=ea(g[f+12>>2]);z=ea(A-t);A=ea(ea(g[l+12>>2])-y);y=ea(ea(g[l+16>>2])-v);v=ea(ea(g[l+20>>2])-t);t=ea(S(ea(w)));w=ea(S(ea(A)));A=ea(S(ea(u)));u=ea(S(ea(y)));y=ea(S(ea(z)));z=ea(S(ea(v)));v=ea(g[m+4>>2]);if((~~ea((t>w?t:w)*v)&255)<(d[f+1>>0]|0)?(C=~~ea(v*(y>z?y:z))&255,(C&255)<(d[f+3>>0]|0)?(~~ea((A>u?A:u)*v)&255)<(d[f+2>>0]|0):0):0){if(!o){if((r&255)>=4)break;C=x+(s<<2)|0;if((x|0)!=(C|0)){D=0;E=x;while(1){c[k+(D<<2)>>2]=c[E>>2];E=E+4|0;if((E|0)==(C|0))break;else D=D+1|0}}b[h>>1]=q&65535|48;B=1;i=p;return B|0}if((r&255)>=7){if((r&255)>=10)break;D=e[x>>1]|0;c[k>>2]=D;C=e[f+18>>1]|0;c[k+4>>2]=(C>>>6)+D;E=e[f+20>>1]|0;c[k+8>>2]=(C<<4&1008|E>>>12)+D;c[k+12>>2]=(E>>>2&1023)+D;C=e[f+22>>1]|0;c[k+16>>2]=(E<<8&768|C>>>8)+D;E=e[f+24>>1]|0;c[k+20>>2]=(C<<2&1020|E>>>14)+D;c[k+24>>2]=(E>>>4&1023)+D;C=e[f+26>>1]|0;c[k+28>>2]=(E<<6&960|C>>>10)+D;c[k+32>>2]=(C&1023)+D;b[h>>1]=q&65535|48;B=1;i=p;return B|0}D=x+(s<<1)|0;if((x|0)!=(D|0)){C=0;E=x;while(1){c[k+(C<<2)>>2]=e[E>>1];E=E+2|0;if((E|0)==(D|0))break;else C=C+1|0}}b[h>>1]=q&65535|48;B=1;i=p;return B|0}}while(0);c[j>>2]=0;B=0;i=p;return B|0}function L0a(d,f,h,j,k,l){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=0,x=0,y=Im,z=0,A=0,B=Im,C=0;m=i;n=d+28|0;o=c[n>>2]|0;if(l?(p=a[d>>0]|0,(p&255)<2):0){if(!(p<<24>>24))q=0;else q=c[o>>2]&65535;b[d+2>>1]=q;g[d+4>>2]=ea(g[h>>2]);g[d+8>>2]=ea(g[h+4>>2]);g[d+12>>2]=ea(g[h+8>>2]);g[d+16>>2]=ea(g[h+12>>2]);g[d+20>>2]=ea(g[h+16>>2]);g[d+24>>2]=ea(g[h+20>>2])}else r=6;a:do if((r|0)==6){q=d+1|0;p=d+2|0;s=d+16|0;t=ea(g[h>>2]);u=h+12|0;v=ea(t+ea(g[u>>2]));w=h+4|0;t=ea(g[w>>2]);x=h+16|0;y=ea(t+ea(g[x>>2]));z=h+8|0;t=ea(g[z>>2]);A=h+20|0;B=ea(y*ea(.5));y=ea(ea(t+ea(g[A>>2]))*ea(.5));g[d+4>>2]=ea(v*ea(.5));g[d+8>>2]=B;g[d+12>>2]=y;y=ea(g[h>>2]);B=ea(g[u>>2]);if(y>B){a[q>>0]=0;a[p>>0]=0;C=0}else{v=ea(B-y);y=ea(g[x>>2]);B=ea(y-ea(g[w>>2]));y=ea(g[A>>2]);t=ea(v*ea(.5));v=ea(B*ea(.5));B=ea(ea(y-ea(g[z>>2]))*ea(.5));z=j+4|0;a[q>>0]=~~ea(ea(t*ea(g[z>>2]))+ea(1.0));a[p>>0]=~~ea(ea(v*ea(g[z>>2]))+ea(1.0));C=~~ea(ea(B*ea(g[z>>2]))+ea(1.0))&255}a[d+3>>0]=C;z=a[d>>0]|0;if(l){if((z&255)<7){p=z&255;if(!(z<<24>>24))break;q=s;A=0;while(1){b[q>>1]=c[o+(A<<2)>>2];A=A+1|0;if((A|0)==(p|0))break a;else q=q+2|0}}if((z&255)<10){if($Db(s,o,z&255)|0)break;b[f>>1]=(e[f>>1]|0)&65487;i=m;return}}else if((z&255)<4){q=z&255;if(!(z<<24>>24))break;p=s;A=0;while(1){c[p>>2]=c[o+(A<<2)>>2];A=A+1|0;if((A|0)==(q|0))break a;else p=p+4|0}}b[f>>1]=(e[f>>1]|0)&65487;i=m;return}while(0);b[f>>1]=e[f>>1]|0|48;c[n>>2]=k;i=m;return}function M0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0;f=i;c[b>>2]=e;h=b+4|0;a[h>>0]=0;j=c[e+16>>2]|0;l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(g[d+12>>2]);p=ea(g[d+16>>2]);q=ea(g[d+20>>2]);r=ea(g[e>>2]);s=ea(l*r);l=ea(g[e+4>>2]);t=ea(m*l);m=ea(g[e+8>>2]);u=ea(n*m);n=ea(o*r);r=ea(p*l);l=ea(q*m);d=j+12|0;v=ea(g[d>>2])<ea(0.0);m=v?n:s;q=v?s:n;v=j+16|0;j=ea(g[v>>2])<ea(0.0);n=j?l:u;s=j?u:l;j=c[e+12>>2]|0;e=j+16|0;w=c[e>>2]|0;if(!(m>ea((w+-1|0)>>>0))?(x=j+20|0,!((q<ea(0.0)?1:n>ea(((c[x>>2]|0)+-1|0)>>>0))|s<ea(0.0))):0){y=~~ea(R(ea(m)));z=w+-2|0;w=(y|0)>0?y:0;y=(w|0)>(z|0)?z:w;c[b+8>>2]=y;w=~~ea(ca(ea(q)));z=(c[e>>2]|0)+-1|0;e=(w|0)>0?w:0;w=(e|0)>(z|0)?z:e;c[b+12>>2]=w;e=~~ea(R(ea(n)));z=(c[x>>2]|0)+-2|0;A=(e|0)>0?e:0;e=(A|0)>(z|0)?z:A;c[b+16>>2]=e;A=~~ea(ca(ea(s)));z=(c[x>>2]|0)+-1|0;x=(A|0)>0?A:0;A=(x|0)>(z|0)?z:x;c[b+20>>2]=A;if((y|0)==(w|0)|(e|0)==(A|0)){a[h>>0]=1;i=f;return}else{g[b+24>>2]=t;g[b+28>>2]=r;A=ea(g[j+40>>2])>ea(0.0)&1;r=ea(g[d>>2]);t=ea(g[v>>2]);v=(g[k>>2]=r,c[k>>2]|0);a[b+32>>0]=(A|0)!=(((g[k>>2]=t,c[k>>2]|0)^v)&-2147483648|0)&1;i=f;return}}a[h>>0]=1;i=f;return}function N0a(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im;f=i;i=i+32|0;h=f;if(a[e+4>>0]|0){c[d>>2]=0;c[d+4>>2]=0;c[d+16>>2]=e;c[d+8>>2]=0;c[d+12>>2]=0;i=f;return}j=c[e+8>>2]|0;k=c[e+16>>2]|0;c[h>>2]=j;c[h+4>>2]=k;c[h+16>>2]=e;c[h+8>>2]=0;l=c[(c[e>>2]|0)+12>>2]|0;m=l+20|0;n=(da(c[m>>2]|0,j)|0)+k|0;c[h+12>>2]=n;do if(((da(c[m>>2]|0,c[e+12>>2]|0)|0)+(c[e+20>>2]|0)|0)!=(n|0)){k=c[l+36>>2]|0;if(((a[k+((n&2147483647)<<2)+2>>0]&127)!=127?(o=ea(b[k+(n<<2)>>1]|0),p=ea(b[k+(n+1<<2)>>1]|0),j=(c[m>>2]|0)+n|0,q=ea(b[k+(j<<2)>>1]|0),r=ea(b[k+(j+1<<2)>>1]|0),s=ea(g[e+28>>2]),!(s<o&s<p&s<q&s<r)):0)?(s=ea(g[e+24>>2]),!(s>r)|s>o&s>p&s>q^1):0)break;P0a(h)|0}while(0);c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];i=f;return}function O0a(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im;m=i;n=e>>>1;o=c[d+36>>2]|0;p=ea(b[o+(n<<2)>>1]|0);q=ea(b[o+(n+1<<2)>>1]|0);r=(c[d+20>>2]|0)+n|0;s=ea(b[o+(r<<2)>>1]|0);t=ea(b[o+(r+1<<2)>>1]|0);r=(a[o+(n<<2)+2>>0]|0)<0;if(!(e&1))if(r){u=ea((f+1|0)>>>0);v=ea(h>>>0);g[j>>2]=u;g[j+4>>2]=s;g[j+8>>2]=v;g[k>>2]=ea(f>>>0);g[k+4>>2]=p;g[k+8>>2]=v;v=ea((h+1|0)>>>0);g[l>>2]=u;g[l+4>>2]=t;g[l+8>>2]=v;i=m;return}else{v=ea(f>>>0);u=ea(h>>>0);g[j>>2]=v;g[j+4>>2]=p;g[j+8>>2]=u;w=ea((h+1|0)>>>0);g[k>>2]=v;g[k+4>>2]=q;g[k+8>>2]=w;g[l>>2]=ea((f+1|0)>>>0);g[l+4>>2]=s;g[l+8>>2]=u;i=m;return}else if(r){u=ea(f>>>0);w=ea((h+1|0)>>>0);g[j>>2]=u;g[j+4>>2]=q;g[j+8>>2]=w;g[k>>2]=ea((f+1|0)>>>0);g[k+4>>2]=t;g[k+8>>2]=w;w=ea(h>>>0);g[l>>2]=u;g[l+4>>2]=p;g[l+8>>2]=w;i=m;return}else{w=ea((f+1|0)>>>0);p=ea((h+1|0)>>>0);g[j>>2]=w;g[j+4>>2]=t;g[j+8>>2]=p;t=ea(h>>>0);g[k>>2]=w;g[k+4>>2]=s;g[k+8>>2]=t;g[l>>2]=ea(f>>>0);g[l+4>>2]=q;g[l+8>>2]=p;i=m;return}}function P0a(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;f=d+8|0;h=c[f>>2]|0;j=c[d+16>>2]|0;if((h|0)!=1){k=c[d+12>>2]|0;l=c[(c[j>>2]|0)+12>>2]|0;m=c[l+36>>2]|0;n=ea(b[m+(k<<2)>>1]|0);o=ea(b[m+(k+1<<2)>>1]|0);p=c[l+20>>2]|0;l=p+k|0;q=ea(b[m+(l<<2)>>1]|0);r=ea(b[m+(l+1<<2)>>1]|0);s=ea(g[j+28>>2]);if(!(s<n&s<o&s<q&s<r)){s=ea(g[j+24>>2]);if(s>n&s>o&s>q){t=!(s>r);u=p;v=k}else{t=1;u=p;v=k}}else{t=0;u=p;v=k}}else{t=1;u=c[(c[(c[j>>2]|0)+12>>2]|0)+20>>2]|0;v=c[d+12>>2]|0}k=j+12|0;p=da(u,c[k>>2]|0)|0;u=j+20|0;l=p+(c[u>>2]|0)|0;p=d+12|0;if(v>>>0>=l>>>0){i=e;return d|0}m=d+4|0;w=h;h=v;v=t;a:while(1){b:do if(v){t=w;x=h;while(1){if(!t){c[f>>2]=1;if((a[(c[(c[(c[j>>2]|0)+12>>2]|0)+36>>2]|0)+((x&2147483647)<<2)+3>>0]&127)==127){y=x;z=1}else{A=23;break a}}else{c[f>>2]=0;B=(c[m>>2]|0)+1|0;c[m>>2]=B;C=x+1|0;c[p>>2]=C;if((B|0)!=(c[u>>2]|0)){D=C;break b}B=(c[d>>2]|0)+1|0;c[d>>2]=B;E=j+16|0;F=(c[(c[(c[j>>2]|0)+12>>2]|0)+20>>2]|0)-(c[u>>2]|0)+(c[E>>2]|0)+C|0;c[p>>2]=F;if((B|0)!=(c[k>>2]|0)){G=F;A=18;break b}B=(c[u>>2]|0)+F-(c[E>>2]|0)|0;c[p>>2]=B;y=B;z=0}if(y>>>0<l>>>0){t=z;x=y}else{A=23;break a}}}else{x=h;while(1){c[f>>2]=0;t=(c[m>>2]|0)+1|0;c[m>>2]=t;B=x+1|0;c[p>>2]=B;if((t|0)!=(c[u>>2]|0)){D=B;break b}t=(c[d>>2]|0)+1|0;c[d>>2]=t;E=j+16|0;F=(c[(c[(c[j>>2]|0)+12>>2]|0)+20>>2]|0)-(c[u>>2]|0)+(c[E>>2]|0)+B|0;c[p>>2]=F;if((t|0)!=(c[k>>2]|0)){G=F;A=18;break b}x=(c[u>>2]|0)+F-(c[E>>2]|0)|0;c[p>>2]=x;if(x>>>0>=l>>>0){A=23;break a}}}while(0);if((A|0)==18){A=0;c[m>>2]=c[j+16>>2];D=G}x=c[(c[j>>2]|0)+12>>2]|0;E=c[x+36>>2]|0;r=ea(b[E+(D<<2)>>1]|0);s=ea(b[E+(D+1<<2)>>1]|0);F=(c[x+20>>2]|0)+D|0;q=ea(b[E+(F<<2)>>1]|0);o=ea(b[E+(F+1<<2)>>1]|0);n=ea(g[j+28>>2]);if(!(n<r&n<s&n<q&n<o)?(n=ea(g[j+24>>2]),!(n>o)|n>r&n>s&n>q^1):0)if((a[E+((D&2147483647)<<2)+2>>0]&127)==127)H=1;else{A=23;break}else H=0;if(D>>>0<l>>>0){w=0;h=D;v=H}else{A=23;break}}if((A|0)==23){i=e;return d|0}return 0}function Q0a(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0;d=i;e=ea(g[a+128>>2]);f=ea(g[a+112>>2]);h=f<=ea(0.0);if(e<=b){j=e>ea(0.0);if(!(e<=ea(g[a+92>>2]))){k=j;l=3}else{m=1;n=j}}else{k=0;l=3}if((l|0)==3)if(k|h){m=0;n=k}else{i=d;return}b=ea(e-f);k=a+132|0;l=a+116|0;j=a+136|0;o=a+120|0;if(b==ea(0.0))if(e>ea(0.0)){p=ea(-3402823469999999843913219.0e14);q=1}else{p=ea(-3402823469999999843913219.0e14);q=0}else if(b<ea(0.0)){p=ea(ea(-f)/b);q=0}else{p=ea(-3402823469999999843913219.0e14);q=0}if(h){h=a+124|0;c[h>>2]=c[h>>2]|8;g[a+44>>2]=ea(0.0);g[a+144>>2]=ea(1.0);g[a+148>>2]=ea(0.0);g[a+152>>2]=ea(0.0);g[a+164>>2]=ea(g[l>>2]);g[a+168>>2]=ea(g[o>>2]);g[a+160>>2]=ea(f+ea(ea(g[a+92>>2])-f));i=d;return}if(p>=ea(0.0)?(h=a+44|0,!(!(p<ea(g[h>>2]))|q)):0){g[a+144>>2]=ea(1.0);g[a+148>>2]=ea(0.0);g[a+152>>2]=ea(0.0);g[a+160>>2]=f;g[a+164>>2]=ea(g[l>>2]);g[a+168>>2]=ea(g[o>>2]);g[h>>2]=p;h=a+124|0;c[h>>2]=c[h>>2]|8;i=d;return}h=a+124|0;o=c[h>>2]|0;if(o&2){i=d;return}if(n){n=o|32;c[h>>2]=n;r=n}else r=o;if(m)c[h>>2]=r|16;g[a+144>>2]=ea(1.0);g[a+148>>2]=ea(0.0);g[a+152>>2]=ea(0.0);g[a+164>>2]=ea(g[k>>2]);g[a+168>>2]=ea(g[j>>2]);g[a+160>>2]=ea(e+ea(ea(g[a+92>>2])-e));i=d;return}function R0a(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;e=i;f=ea(g[b+4>>2]);h=ea(g[a+112>>2]);j=ea(h*h);k=ea(g[a+116>>2]);l=ea(j+ea(k*k));j=ea(g[a+120>>2]);m=ea(l+ea(j*j));l=ea(f*f);if(m<l){b=a+144|0;g[b>>2]=h;n=a+148|0;g[n>>2]=k;o=a+152|0;g[o>>2]=j;if(m>ea(0.0)){p=ea(ea(1.0)/ea(T(ea(m))));q=ea(p*h);g[b>>2]=q;r=ea(p*k);g[n>>2]=r;s=q;t=r;u=ea(p*j)}else{g[b>>2]=ea(0.0);g[n>>2]=ea(1.0);s=ea(0.0);t=ea(1.0);u=ea(0.0)}g[o>>2]=u;p=ea(f+ea(g[a+92>>2]));r=ea(p*t);t=ea(p*u);g[a+160>>2]=ea(s*p);g[a+164>>2]=r;g[a+168>>2]=t;g[a+44>>2]=ea(0.0);o=a+124|0;c[o>>2]=c[o>>2]|8;i=e;return}t=ea(g[a+128>>2]);r=ea(t-h);p=ea(g[a+132>>2]);s=ea(p-k);u=ea(g[a+136>>2]);q=ea(u-j);v=ea(ea(ea(ea(h*r)+ea(k*s))+ea(j*q))*ea(2.0));w=ea(ea(ea(ea(r*r)+ea(s*s))+ea(q*q))*ea(2.0));x=ea(ea(v*v)-ea(ea(m-l)*ea(w*ea(2.0))));if(!(x>ea(0.0))|w==ea(0.0)){o=a+124|0;n=c[o>>2]|0;if(n&2){i=e;return}l=ea(T(ea(ea(ea(t*t)+ea(p*p))+ea(u*u))));b=a+144|0;g[b>>2]=t;y=a+148|0;g[y>>2]=p;z=a+152|0;g[z>>2]=u;if(!(l<ea(f+d))){i=e;return}if(l!=ea(0.0)){m=ea(ea(1.0)/l);A=ea(t*m);g[b>>2]=A;B=ea(p*m);g[y>>2]=B;C=A;D=B;E=ea(u*m)}else{g[b>>2]=ea(0.0);g[y>>2]=ea(0.0);C=ea(0.0);D=ea(0.0);E=ea(0.0)}g[z>>2]=E;m=ea(f+ea(g[a+92>>2]));B=ea(D*m);D=ea(E*m);g[a+160>>2]=ea(C*m);g[a+164>>2]=B;g[a+168>>2]=D;c[o>>2]=n|32;if(!(l<m)){i=e;return}c[o>>2]=n|48;i=e;return}m=ea(ea(-ea(v+ea(T(ea(x)))))/w);if(!(m<ea(0.0)|m>ea(1.0))){n=a+44|0;if(!(m<ea(g[n>>2]))){i=e;return}w=ea(k+ea(s*m));s=ea(j+ea(q*m));q=ea(ea(1.0)/f);g[a+144>>2]=ea(q*ea(h+ea(r*m)));g[a+148>>2]=ea(q*w);g[a+152>>2]=ea(q*s);g[a+160>>2]=h;g[a+164>>2]=k;g[a+168>>2]=j;g[n>>2]=m;n=a+124|0;c[n>>2]=c[n>>2]|8;i=e;return}n=a+124|0;o=c[n>>2]|0;if(o&2){i=e;return}m=ea(T(ea(ea(ea(t*t)+ea(p*p))+ea(u*u))));z=a+144|0;g[z>>2]=t;y=a+148|0;g[y>>2]=p;b=a+152|0;g[b>>2]=u;if(!(m<ea(f+d))){i=e;return}if(m!=ea(0.0)){d=ea(ea(1.0)/m);j=ea(t*d);g[z>>2]=j;t=ea(p*d);g[y>>2]=t;F=j;G=t;H=ea(u*d)}else{g[z>>2]=ea(0.0);g[y>>2]=ea(0.0);F=ea(0.0);G=ea(0.0);H=ea(0.0)}g[b>>2]=H;d=ea(f+ea(g[a+92>>2]));f=ea(G*d);G=ea(H*d);g[a+160>>2]=ea(F*d);g[a+164>>2]=f;g[a+168>>2]=G;c[n>>2]=o|32;if(!(m<d)){i=e;return}c[n>>2]=o|48;i=e;return}function S0a(a,b,d,e,f,h,j,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=0;r=i;i=i+272|0;s=r+176|0;t=r+224|0;u=r+240|0;v=r+256|0;w=r+144|0;x=r;y=r+192|0;if(l>>>0>=8){z=l+7&-4;g[w>>2]=ea(3402823469999999843913219.0e14);g[w+4>>2]=ea(3402823469999999843913219.0e14);g[w+8>>2]=ea(3402823469999999843913219.0e14);g[w+12>>2]=ea(3402823469999999843913219.0e14);A=j+(l<<2)|0;if(z){B=j;C=0;D=0;while(1){if(C>>>0<l>>>0)E=e+(c[B>>2]<<5)|0;else E=w;if((C|1)>>>0<l>>>0)F=e+(c[B+4>>2]<<5)|0;else F=w;if((C|2)>>>0<l>>>0)G=e+(c[B+8>>2]<<5)|0;else G=w;if((C|3)>>>0<l>>>0)H=e+(c[B+12>>2]<<5)|0;else H=w;I=ea(g[E>>2]);J=ea(g[E+4>>2]);K=ea(g[E+8>>2]);L=ea(g[F>>2]);M=ea(g[F+4>>2]);N=ea(g[F+8>>2]);O=ea(g[G>>2]);P=ea(g[G+4>>2]);Q=ea(g[G+8>>2]);R=ea(g[H>>2]);S=ea(g[H+4>>2]);U=ea(g[H+8>>2]);g[p+(D<<4)>>2]=I;g[p+(D<<4)+4>>2]=L;g[p+(D<<4)+8>>2]=O;g[p+(D<<4)+12>>2]=R;V=D+1|0;g[p+(V<<4)>>2]=J;g[p+(V<<4)+4>>2]=M;g[p+(V<<4)+8>>2]=P;g[p+(V<<4)+12>>2]=S;V=D+2|0;g[p+(V<<4)>>2]=K;g[p+(V<<4)+4>>2]=N;g[p+(V<<4)+8>>2]=Q;g[p+(V<<4)+12>>2]=U;C=C+4|0;if(C>>>0>=z>>>0)break;else{B=B+16|0;D=D+3|0}}}U=ea(g[o+48>>2]);g[x>>2]=U;g[x+4>>2]=U;g[x+8>>2]=U;g[x+12>>2]=U;D=o+52|0;U=ea(g[D>>2]);g[x+16>>2]=U;g[x+20>>2]=U;g[x+24>>2]=U;g[x+28>>2]=U;U=ea(g[o+24>>2]);g[x+32>>2]=U;g[x+36>>2]=U;g[x+40>>2]=U;g[x+44>>2]=U;B=o+28|0;U=ea(g[B>>2]);g[x+48>>2]=U;g[x+52>>2]=U;g[x+56>>2]=U;g[x+60>>2]=U;z=o+32|0;U=ea(g[z>>2]);g[x+64>>2]=U;g[x+68>>2]=U;g[x+72>>2]=U;g[x+76>>2]=U;U=ea(g[o+36>>2]);g[x+80>>2]=U;g[x+84>>2]=U;g[x+88>>2]=U;g[x+92>>2]=U;U=ea(g[o+40>>2]);g[x+96>>2]=U;g[x+100>>2]=U;g[x+104>>2]=U;g[x+108>>2]=U;U=ea(g[o+44>>2]);g[x+112>>2]=U;g[x+116>>2]=U;g[x+120>>2]=U;g[x+124>>2]=U;U=ea(g[o+16>>2]);if(!h){i=r;return}C=p+4|0;H=p+8|0;G=p+12|0;F=p+16|0;E=p+20|0;w=p+24|0;V=p+28|0;W=p+32|0;X=p+36|0;Y=p+40|0;Z=p+44|0;_=t+4|0;$=t+8|0;aa=t+12|0;ba=y+4|0;ca=y+8|0;da=y+12|0;fa=(l|0)==0;ga=v+4|0;ha=v+8|0;ia=v+12|0;ja=q+4|0;ka=f;la=0;ma=0;while(1){na=c[ka>>2]|0;c[q+(la<<2)>>2]=na;oa=la+2|0;pa=q+(la+1<<2)|0;qa=d+(na<<5)|0;Q=ea(g[qa>>2]);N=ea(g[qa+4>>2]);K=ea(g[qa+8>>2]);S=ea(g[p>>2]);P=ea(g[C>>2]);M=ea(g[H>>2]);J=ea(g[G>>2]);R=ea(g[F>>2]);O=ea(g[E>>2]);L=ea(g[w>>2]);I=ea(g[V>>2]);ra=ea(g[W>>2]);sa=ea(g[X>>2]);ta=ea(g[Y>>2]);ua=ea(Q-S);S=ea(Q-P);P=ea(Q-M);M=ea(Q-J);J=ea(N-R);R=ea(N-O);O=ea(N-L);L=ea(N-I);I=ea(K-ra);ra=ea(K-sa);sa=ea(K-ta);ta=ea(K-ea(g[Z>>2]));va=ea(ea(ea(ua*ua)+ea(J*J))+ea(I*I));I=ea(ea(ea(S*S)+ea(R*R))+ea(ra*ra));ra=ea(ea(ea(P*P)+ea(O*O))+ea(sa*sa));sa=ea(ea(ea(M*M)+ea(L*L))+ea(ta*ta));qa=va>ea(0.0);na=I>ea(0.0);wa=ra>ea(0.0);xa=sa>ea(0.0);c[t>>2]=1;c[_>>2]=1;c[$>>2]=1;c[aa>>2]=1;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;ya=c[(na&U>I?t:s)+4>>2]|0;na=c[(wa&U>ra?t:s)+8>>2]|0;wa=c[(xa&U>sa?t:s)+12>>2]|0;c[y>>2]=c[(qa&U>va?t:s)>>2];c[ba>>2]=ya;c[ca>>2]=na;c[da>>2]=wa;if(fa){za=oa;Aa=oa;Ba=pa}else{wa=j;na=oa;ya=oa;oa=pa;pa=0;qa=p;while(1){va=ea(g[qa+48>>2]);sa=ea(g[qa+52>>2]);ra=ea(g[qa+56>>2]);I=ea(g[qa+60>>2]);ta=ea(g[qa+64>>2]);L=ea(g[qa+68>>2]);M=ea(g[qa+72>>2]);O=ea(g[qa+76>>2]);P=ea(g[qa+80>>2]);R=ea(g[qa+84>>2]);S=ea(g[qa+88>>2]);J=ea(Q-va);va=ea(Q-sa);sa=ea(Q-ra);ra=ea(Q-I);I=ea(N-ta);ta=ea(N-L);L=ea(N-M);M=ea(N-O);O=ea(K-P);P=ea(K-R);R=ea(K-S);S=ea(K-ea(g[qa+92>>2]));qa=qa+48|0;ua=ea(ea(ea(J*J)+ea(I*I))+ea(O*O));O=ea(ea(ea(va*va)+ea(ta*ta))+ea(P*P));P=ea(ea(ea(sa*sa)+ea(L*L))+ea(R*R));R=ea(ea(ea(ra*ra)+ea(M*M))+ea(S*S));xa=ua>ea(0.0);Ca=O>ea(0.0);Da=P>ea(0.0);Ea=R>ea(0.0);c[v>>2]=1;c[ga>>2]=1;c[ha>>2]=1;c[ia>>2]=1;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;Fa=c[(Ca&U>O?v:u)+4>>2]|0;Ca=c[(Da&U>P?v:u)+8>>2]|0;Da=c[(Ea&U>R?v:u)+12>>2]|0;Ea=pa;pa=pa+4|0;Ga=pa&4;c[y+(Ga<<2)>>2]=c[(xa&U>ua?v:u)>>2];c[y+((Ga|1)<<2)>>2]=Fa;c[y+((Ga|2)<<2)>>2]=Ca;c[y+((Ga|3)<<2)>>2]=Da;Da=Ea&4;Ea=c[y+(Da<<2)>>2]|0;Ga=c[y+((Da|1)<<2)>>2]|0;Ca=c[y+((Da|2)<<2)>>2]|0;Fa=c[y+((Da|3)<<2)>>2]|0;c[q+(na<<2)>>2]=c[wa>>2];Da=Ea+na|0;Ea=wa+4|0;if(Ea>>>0<A>>>0)Ha=c[Ea>>2]|0;else Ha=0;c[q+(Da<<2)>>2]=Ha;Ea=Da+Ga|0;Ga=wa+8|0;if(Ga>>>0<A>>>0)Ia=c[Ga>>2]|0;else Ia=0;c[q+(Ea<<2)>>2]=Ia;Ga=Ea+Ca|0;Ca=wa+12|0;if(Ca>>>0<A>>>0)Ja=c[Ca>>2]|0;else Ja=0;c[q+(Ga<<2)>>2]=Ja;Ca=Ga+Fa|0;if((128-Ca|0)>>>0>5){Ka=Ca;La=ya;Ma=oa}else{c[oa>>2]=Ca-ya;do if(n){Fa=(Ca|0)==0;if(m){if(Fa)break;else Na=0;while(1){Ga=c[q+(Na<<2)>>2]|0;Ea=Na+2|0;Da=c[q+(Na+1<<2)>>2]|0;if(!Da)Oa=Ea;else{ua=ea(g[d+(Ga<<5)>>2]);R=ea(g[d+(Ga<<5)+4>>2]);P=ea(g[d+(Ga<<5)+8>>2]);O=ea(g[D>>2]);S=ea(g[B>>2]);M=ea(g[z>>2]);xa=d+(Ga<<5)+12|0;ra=ea(g[xa>>2]);Ga=0;Pa=Ea;while(1){Qa=c[q+(Pa<<2)>>2]|0;L=ea(ua-ea(g[e+(Qa<<5)>>2]));sa=ea(R-ea(g[e+(Qa<<5)+4>>2]));ta=ea(P-ea(g[e+(Qa<<5)+8>>2]));va=ea(S-ea(O*ea(ea(ea(L*L)+ea(sa*sa))+ea(ta*ta))));ta=ea(va*ea(va*ea(M*va)));ra=ea(ra+ta);Ra=e+(Qa<<5)+12|0;g[Ra>>2]=ea(ea(g[Ra>>2])+ta);Ga=Ga+1|0;if((Ga|0)==(Da|0))break;else Pa=Pa+1|0}g[xa>>2]=ra;Oa=Da+Ea|0}if(Oa>>>0<Ca>>>0)Na=Oa;else break}}else{if(Fa)break;else Sa=0;while(1){Pa=c[q+(Sa<<2)>>2]|0;Ga=Sa+2|0;Ra=c[q+(Sa+1<<2)>>2]|0;if(!Ra)Ta=Ga;else{M=ea(g[d+(Pa<<5)>>2]);O=ea(g[d+(Pa<<5)+4>>2]);S=ea(g[d+(Pa<<5)+8>>2]);P=ea(g[D>>2]);R=ea(g[B>>2]);ua=ea(g[z>>2]);Qa=d+(Pa<<5)+12|0;ta=ea(g[Qa>>2]);Pa=0;Ua=Ga;while(1){Va=c[q+(Ua<<2)>>2]|0;va=ea(M-ea(g[e+(Va<<5)>>2]));sa=ea(O-ea(g[e+(Va<<5)+4>>2]));L=ea(S-ea(g[e+(Va<<5)+8>>2]));I=ea(R-ea(P*ea(ea(ea(va*va)+ea(sa*sa))+ea(L*L))));ta=ea(ta+ea(I*ea(I*ea(ua*I))));Pa=Pa+1|0;if((Pa|0)==(Ra|0))break;else Ua=Ua+1|0}g[Qa>>2]=ta;Ta=Ra+Ga|0}if(Ta>>>0<Ca>>>0)Sa=Ta;else break}}}else if(m){aEb(a,b,d,e,q,Ca,o,x);break}else{bEb(a,d,e,q,Ca,o,x);break}while(0);c[q>>2]=c[ka>>2];Ka=2;La=2;Ma=ja}if(pa>>>0>=l>>>0){za=Ka;Aa=La;Ba=Ma;break}else{wa=wa+16|0;na=Ka;ya=La;oa=Ma}}}c[Ba>>2]=za-Aa;ma=ma+1|0;if((ma|0)==(h|0))break;else{ka=ka+4|0;la=za}}if(!za){i=r;return}if(!n)if(m){aEb(a,b,d,e,q,za,o,x);i=r;return}else{bEb(a,d,e,q,za,o,x);i=r;return}if(m){x=0;while(1){la=c[q+(x<<2)>>2]|0;ka=x+2|0;ma=c[q+(x+1<<2)>>2]|0;if(!ma)Wa=ka;else{U=ea(g[d+(la<<5)>>2]);K=ea(g[d+(la<<5)+4>>2]);N=ea(g[d+(la<<5)+8>>2]);Q=ea(g[D>>2]);ua=ea(g[B>>2]);P=ea(g[z>>2]);Aa=d+(la<<5)+12|0;R=ea(g[Aa>>2]);la=0;Ba=ka;while(1){Ma=c[q+(Ba<<2)>>2]|0;S=ea(U-ea(g[e+(Ma<<5)>>2]));O=ea(K-ea(g[e+(Ma<<5)+4>>2]));M=ea(N-ea(g[e+(Ma<<5)+8>>2]));ra=ea(ua-ea(Q*ea(ea(ea(S*S)+ea(O*O))+ea(M*M))));M=ea(ra*ea(ra*ea(P*ra)));R=ea(R+M);La=e+(Ma<<5)+12|0;g[La>>2]=ea(ea(g[La>>2])+M);la=la+1|0;if((la|0)==(ma|0))break;else Ba=Ba+1|0}g[Aa>>2]=R;Wa=ma+ka|0}if(Wa>>>0<za>>>0)x=Wa;else break}i=r;return}else{Wa=0;while(1){x=c[q+(Wa<<2)>>2]|0;Ba=Wa+2|0;la=c[q+(Wa+1<<2)>>2]|0;if(!la)Xa=Ba;else{P=ea(g[d+(x<<5)>>2]);Q=ea(g[d+(x<<5)+4>>2]);ua=ea(g[d+(x<<5)+8>>2]);N=ea(g[D>>2]);K=ea(g[B>>2]);U=ea(g[z>>2]);La=d+(x<<5)+12|0;M=ea(g[La>>2]);x=0;Ma=Ba;while(1){Ka=c[q+(Ma<<2)>>2]|0;ra=ea(P-ea(g[e+(Ka<<5)>>2]));O=ea(Q-ea(g[e+(Ka<<5)+4>>2]));S=ea(ua-ea(g[e+(Ka<<5)+8>>2]));I=ea(K-ea(N*ea(ea(ea(ra*ra)+ea(O*O))+ea(S*S))));M=ea(M+ea(I*ea(I*ea(U*I))));x=x+1|0;if((x|0)==(la|0))break;else Ma=Ma+1|0}g[La>>2]=M;Xa=la+Ba|0}if(Xa>>>0<za>>>0)Wa=Xa;else break}i=r;return}}Xa=l&-4;Wa=o+16|0;U=ea(g[Wa>>2]);za=(g[k>>2]=U,c[k>>2]|0);q=(h|0)==0;if(!n)if(m){if(q){i=r;return}n=(Xa|0)==0;z=Xa>>>0<l>>>0;B=o+52|0;D=o+24|0;Ma=o+44|0;x=o+28|0;ka=o+36|0;ma=o+48|0;Aa=o+40|0;Ka=0;do{ja=c[f+(Ka<<2)>>2]|0;Ta=d+(ja<<5)|0;Sa=a+(ja*12|0)|0;if(!n){N=ea(g[Ta>>2]);K=ea(g[d+(ja<<5)+4>>2]);ua=ea(g[d+(ja<<5)+8>>2]);Oa=d+(ja<<5)+12|0;Na=d+(ja<<5)+16|0;Ja=d+(ja<<5)+20|0;A=d+(ja<<5)+24|0;Ia=a+(ja*12|0)+4|0;Ha=a+(ja*12|0)+8|0;y=0;do{u=c[j+(y<<2)>>2]|0;v=c[j+((y|1)<<2)>>2]|0;ia=c[j+((y|2)<<2)>>2]|0;ha=c[j+((y|3)<<2)>>2]|0;Q=ea(N-ea(g[e+(u<<5)>>2]));P=ea(K-ea(g[e+(u<<5)+4>>2]));R=ea(ua-ea(g[e+(u<<5)+8>>2]));I=ea(N-ea(g[e+(v<<5)>>2]));S=ea(K-ea(g[e+(v<<5)+4>>2]));O=ea(ua-ea(g[e+(v<<5)+8>>2]));ra=ea(N-ea(g[e+(ia<<5)>>2]));L=ea(K-ea(g[e+(ia<<5)+4>>2]));sa=ea(ua-ea(g[e+(ia<<5)+8>>2]));va=ea(N-ea(g[e+(ha<<5)>>2]));J=ea(K-ea(g[e+(ha<<5)+4>>2]));Ya=ea(ua-ea(g[e+(ha<<5)+8>>2]));Za=ea(ea(ea(Q*Q)+ea(P*P))+ea(R*R));_a=ea(ea(ea(I*I)+ea(S*S))+ea(O*O));$a=ea(ea(ea(ra*ra)+ea(L*L))+ea(sa*sa));ab=ea(ea(ea(va*va)+ea(J*J))+ea(Ya*Ya));if(!(!(ea(U-_a)>=ea(0.0))&!(ea(U-Za)>=ea(0.0))&!(ea(U-$a)>=ea(0.0))&!(ea(U-ab)>=ea(0.0)))){ga=(g[k>>2]=Za,c[k>>2]|0);p=(g[k>>2]=_a,c[k>>2]|0);fa=(g[k>>2]=$a,c[k>>2]|0);da=(g[k>>2]=ab,c[k>>2]|0);if(ga>>>0<za>>>0&(ga|0)!=0){bb=ea(Za*ea(g[B>>2]));Za=ea(ea(1.0)/ea(T(ea(bb))));cb=ea(bb*Za);bb=ea(g[D>>2]);db=ea(bb-cb);eb=ea(g[Oa>>2]);fb=ea(g[Ma>>2]);gb=ea(eb-fb);ga=gb>ea(0.0);hb=ga?gb:ea(0.0);gb=ea(g[e+(u<<5)+12>>2]);ib=ea(gb-fb);ga=ib>ea(0.0);fb=ea(hb+(ga?ib:ea(0.0)));ib=ea(cb+ea(ea(Za*ea(g[x>>2]))-ea(bb*ea(2.0))));bb=ea(fb*ea(ea(g[ka>>2])*ib));ib=ea(Q*bb);Q=ea(P*bb);P=ea(R*bb);bb=ea(g[ma>>2]);R=ea(bb*ib);ib=ea(bb*Q);Q=ea(bb*P);P=ea(db*ea(g[Aa>>2]));db=ea(g[e+(u<<5)+16>>2]);fb=ea(db-ea(g[Na>>2]));db=ea(g[e+(u<<5)+20>>2]);Za=ea(db-ea(g[Ja>>2]));db=ea(g[e+(u<<5)+24>>2]);cb=ea(R+ea(P*ea(bb*fb)));fb=ea(ib+ea(P*ea(bb*Za)));Za=ea(Q+ea(P*ea(bb*ea(db-ea(g[A>>2])))));db=ea(ea(1.0)/gb);gb=ea(cb*db);bb=ea(db*fb);P=ea(db*Za);g[Sa>>2]=ea(gb+ea(g[Sa>>2]));g[Ia>>2]=ea(bb+ea(g[Ia>>2]));g[Ha>>2]=ea(ea(g[Ha>>2])+P);P=ea(ea(1.0)/eb);eb=ea(cb*P);cb=ea(fb*P);fb=ea(Za*P);ga=b+(u*12|0)|0;g[ga>>2]=ea(ea(g[ga>>2])-eb);ga=b+(u*12|0)+4|0;g[ga>>2]=ea(ea(g[ga>>2])-cb);ga=b+(u*12|0)+8|0;g[ga>>2]=ea(ea(g[ga>>2])-fb)}if(p>>>0<za>>>0&(p|0)!=0){fb=ea(_a*ea(g[B>>2]));_a=ea(ea(1.0)/ea(T(ea(fb))));cb=ea(fb*_a);fb=ea(g[D>>2]);eb=ea(fb-cb);P=ea(g[Oa>>2]);Za=ea(g[Ma>>2]);bb=ea(P-Za);p=bb>ea(0.0);gb=p?bb:ea(0.0);bb=ea(g[e+(v<<5)+12>>2]);db=ea(bb-Za);p=db>ea(0.0);Za=ea(gb+(p?db:ea(0.0)));db=ea(cb+ea(ea(_a*ea(g[x>>2]))-ea(fb*ea(2.0))));fb=ea(Za*ea(ea(g[ka>>2])*db));db=ea(I*fb);I=ea(S*fb);S=ea(O*fb);fb=ea(g[ma>>2]);O=ea(fb*db);db=ea(fb*I);I=ea(fb*S);S=ea(eb*ea(g[Aa>>2]));eb=ea(g[e+(v<<5)+16>>2]);Za=ea(eb-ea(g[Na>>2]));eb=ea(g[e+(v<<5)+20>>2]);_a=ea(eb-ea(g[Ja>>2]));eb=ea(g[e+(v<<5)+24>>2]);cb=ea(O+ea(S*ea(fb*Za)));Za=ea(db+ea(S*ea(fb*_a)));_a=ea(I+ea(S*ea(fb*ea(eb-ea(g[A>>2])))));eb=ea(ea(1.0)/bb);bb=ea(cb*eb);fb=ea(eb*Za);S=ea(eb*_a);g[Sa>>2]=ea(bb+ea(g[Sa>>2]));g[Ia>>2]=ea(fb+ea(g[Ia>>2]));g[Ha>>2]=ea(ea(g[Ha>>2])+S);S=ea(ea(1.0)/P);P=ea(cb*S);cb=ea(Za*S);Za=ea(_a*S);p=b+(v*12|0)|0;g[p>>2]=ea(ea(g[p>>2])-P);p=b+(v*12|0)+4|0;g[p>>2]=ea(ea(g[p>>2])-cb);p=b+(v*12|0)+8|0;g[p>>2]=ea(ea(g[p>>2])-Za)}if(fa>>>0<za>>>0&(fa|0)!=0){Za=ea($a*ea(g[B>>2]));$a=ea(ea(1.0)/ea(T(ea(Za))));cb=ea(Za*$a);Za=ea(g[D>>2]);P=ea(Za-cb);S=ea(g[Oa>>2]);_a=ea(g[Ma>>2]);fb=ea(S-_a);fa=fb>ea(0.0);bb=fa?fb:ea(0.0);fb=ea(g[e+(ia<<5)+12>>2]);eb=ea(fb-_a);fa=eb>ea(0.0);_a=ea(bb+(fa?eb:ea(0.0)));eb=ea(cb+ea(ea($a*ea(g[x>>2]))-ea(Za*ea(2.0))));Za=ea(_a*ea(ea(g[ka>>2])*eb));eb=ea(ra*Za);ra=ea(L*Za);L=ea(sa*Za);Za=ea(g[ma>>2]);sa=ea(Za*eb);eb=ea(Za*ra);ra=ea(Za*L);L=ea(P*ea(g[Aa>>2]));P=ea(g[e+(ia<<5)+16>>2]);_a=ea(P-ea(g[Na>>2]));P=ea(g[e+(ia<<5)+20>>2]);$a=ea(P-ea(g[Ja>>2]));P=ea(g[e+(ia<<5)+24>>2]);cb=ea(sa+ea(L*ea(Za*_a)));_a=ea(eb+ea(L*ea(Za*$a)));$a=ea(ra+ea(L*ea(Za*ea(P-ea(g[A>>2])))));P=ea(ea(1.0)/fb);fb=ea(cb*P);Za=ea(P*_a);L=ea(P*$a);g[Sa>>2]=ea(fb+ea(g[Sa>>2]));g[Ia>>2]=ea(Za+ea(g[Ia>>2]));g[Ha>>2]=ea(ea(g[Ha>>2])+L);L=ea(ea(1.0)/S);S=ea(cb*L);cb=ea(_a*L);_a=ea($a*L);fa=b+(ia*12|0)|0;g[fa>>2]=ea(ea(g[fa>>2])-S);fa=b+(ia*12|0)+4|0;g[fa>>2]=ea(ea(g[fa>>2])-cb);fa=b+(ia*12|0)+8|0;g[fa>>2]=ea(ea(g[fa>>2])-_a)}if(da>>>0<za>>>0&(da|0)!=0){_a=ea(ab*ea(g[B>>2]));ab=ea(ea(1.0)/ea(T(ea(_a))));cb=ea(_a*ab);_a=ea(g[D>>2]);S=ea(_a-cb);L=ea(g[Oa>>2]);$a=ea(g[Ma>>2]);Za=ea(L-$a);da=Za>ea(0.0);fb=da?Za:ea(0.0);Za=ea(g[e+(ha<<5)+12>>2]);P=ea(Za-$a);da=P>ea(0.0);$a=ea(fb+(da?P:ea(0.0)));P=ea(cb+ea(ea(ab*ea(g[x>>2]))-ea(_a*ea(2.0))));_a=ea($a*ea(ea(g[ka>>2])*P));P=ea(va*_a);va=ea(J*_a);J=ea(Ya*_a);_a=ea(g[ma>>2]);Ya=ea(_a*P);P=ea(_a*va);va=ea(_a*J);J=ea(S*ea(g[Aa>>2]));S=ea(g[e+(ha<<5)+16>>2]);$a=ea(S-ea(g[Na>>2]));S=ea(g[e+(ha<<5)+20>>2]);ab=ea(S-ea(g[Ja>>2]));S=ea(g[e+(ha<<5)+24>>2]);cb=ea(Ya+ea(J*ea(_a*$a)));$a=ea(P+ea(J*ea(_a*ab)));ab=ea(va+ea(J*ea(_a*ea(S-ea(g[A>>2])))));S=ea(ea(1.0)/Za);Za=ea(cb*S);_a=ea(S*$a);J=ea(S*ab);g[Sa>>2]=ea(Za+ea(g[Sa>>2]));g[Ia>>2]=ea(_a+ea(g[Ia>>2]));g[Ha>>2]=ea(ea(g[Ha>>2])+J);J=ea(ea(1.0)/L);L=ea(cb*J);cb=ea($a*J);$a=ea(ab*J);da=b+(ha*12|0)|0;g[da>>2]=ea(ea(g[da>>2])-L);da=b+(ha*12|0)+4|0;g[da>>2]=ea(ea(g[da>>2])-cb);da=b+(ha*12|0)+8|0;g[da>>2]=ea(ea(g[da>>2])-$a)}}y=y+4|0}while(y>>>0<Xa>>>0)}if(z){ua=ea(g[Ta>>2]);K=ea(g[d+(ja<<5)+4>>2]);N=ea(g[d+(ja<<5)+8>>2]);y=d+(ja<<5)+12|0;Ha=d+(ja<<5)+16|0;Ia=d+(ja<<5)+20|0;A=d+(ja<<5)+24|0;Ja=a+(ja*12|0)+4|0;Na=a+(ja*12|0)+8|0;Oa=Xa;do{Ba=c[j+(Oa<<2)>>2]|0;M=ea(ua-ea(g[e+(Ba<<5)>>2]));$a=ea(K-ea(g[e+(Ba<<5)+4>>2]));cb=ea(N-ea(g[e+(Ba<<5)+8>>2]));L=ea(ea(ea(M*M)+ea($a*$a))+ea(cb*cb));la=(g[k>>2]=L,c[k>>2]|0);if(la>>>0<za>>>0&(la|0)!=0){J=ea(L*ea(g[B>>2]));L=ea(ea(1.0)/ea(T(ea(J))));ab=ea(J*L);J=ea(g[D>>2]);_a=ea(J-ab);Za=ea(g[y>>2]);S=ea(g[Ma>>2]);va=ea(Za-S);la=va>ea(0.0);P=la?va:ea(0.0);va=ea(g[e+(Ba<<5)+12>>2]);Ya=ea(va-S);la=Ya>ea(0.0);S=ea(P+(la?Ya:ea(0.0)));Ya=ea(ab+ea(ea(L*ea(g[x>>2]))-ea(J*ea(2.0))));J=ea(S*ea(ea(g[ka>>2])*Ya));Ya=ea(M*J);M=ea($a*J);$a=ea(cb*J);J=ea(g[ma>>2]);cb=ea(J*Ya);Ya=ea(J*M);M=ea(J*$a);$a=ea(_a*ea(g[Aa>>2]));_a=ea(g[e+(Ba<<5)+16>>2]);S=ea(_a-ea(g[Ha>>2]));_a=ea(g[e+(Ba<<5)+20>>2]);L=ea(_a-ea(g[Ia>>2]));_a=ea(g[e+(Ba<<5)+24>>2]);ab=ea(cb+ea($a*ea(J*S)));S=ea(Ya+ea($a*ea(J*L)));L=ea(M+ea($a*ea(J*ea(_a-ea(g[A>>2])))));_a=ea(ea(1.0)/va);va=ea(ab*_a);J=ea(_a*S);$a=ea(_a*L);g[Sa>>2]=ea(va+ea(g[Sa>>2]));g[Ja>>2]=ea(J+ea(g[Ja>>2]));g[Na>>2]=ea(ea(g[Na>>2])+$a);$a=ea(ea(1.0)/Za);Za=ea(ab*$a);ab=ea(S*$a);S=ea(L*$a);la=b+(Ba*12|0)|0;g[la>>2]=ea(ea(g[la>>2])-Za);la=b+(Ba*12|0)+4|0;g[la>>2]=ea(ea(g[la>>2])-ab);la=b+(Ba*12|0)+8|0;g[la>>2]=ea(ea(g[la>>2])-S)}Oa=Oa+1|0}while((Oa|0)!=(l|0))}Ka=Ka+1|0}while((Ka|0)!=(h|0));i=r;return}else{if(q){i=r;return}Ka=(Xa|0)==0;b=Xa>>>0<l>>>0;Aa=o+52|0;ma=o+24|0;ka=o+44|0;x=o+28|0;Ma=o+36|0;D=o+48|0;B=o+40|0;z=0;do{n=c[f+(z<<2)>>2]|0;Oa=d+(n<<5)|0;Na=a+(n*12|0)|0;if(!Ka){N=ea(g[Oa>>2]);K=ea(g[d+(n<<5)+4>>2]);ua=ea(g[d+(n<<5)+8>>2]);Ja=d+(n<<5)+12|0;Sa=d+(n<<5)+16|0;A=d+(n<<5)+20|0;Ia=d+(n<<5)+24|0;Ha=a+(n*12|0)+4|0;y=a+(n*12|0)+8|0;ja=0;do{Ta=c[j+(ja<<2)>>2]|0;la=c[j+((ja|1)<<2)>>2]|0;Ba=c[j+((ja|2)<<2)>>2]|0;La=c[j+((ja|3)<<2)>>2]|0;S=ea(N-ea(g[e+(Ta<<5)>>2]));ab=ea(K-ea(g[e+(Ta<<5)+4>>2]));Za=ea(ua-ea(g[e+(Ta<<5)+8>>2]));$a=ea(N-ea(g[e+(la<<5)>>2]));L=ea(K-ea(g[e+(la<<5)+4>>2]));J=ea(ua-ea(g[e+(la<<5)+8>>2]));va=ea(N-ea(g[e+(Ba<<5)>>2]));_a=ea(K-ea(g[e+(Ba<<5)+4>>2]));M=ea(ua-ea(g[e+(Ba<<5)+8>>2]));Ya=ea(N-ea(g[e+(La<<5)>>2]));cb=ea(K-ea(g[e+(La<<5)+4>>2]));P=ea(ua-ea(g[e+(La<<5)+8>>2]));fb=ea(ea(ea(S*S)+ea(ab*ab))+ea(Za*Za));ra=ea(ea(ea($a*$a)+ea(L*L))+ea(J*J));eb=ea(ea(ea(va*va)+ea(_a*_a))+ea(M*M));sa=ea(ea(ea(Ya*Ya)+ea(cb*cb))+ea(P*P));if(!(!(ea(U-ra)>=ea(0.0))&!(ea(U-fb)>=ea(0.0))&!(ea(U-eb)>=ea(0.0))&!(ea(U-sa)>=ea(0.0)))){da=(g[k>>2]=fb,c[k>>2]|0);ha=(g[k>>2]=ra,c[k>>2]|0);fa=(g[k>>2]=eb,c[k>>2]|0);ia=(g[k>>2]=sa,c[k>>2]|0);if(da>>>0<za>>>0&(da|0)!=0){bb=ea(fb*ea(g[Aa>>2]));fb=ea(ea(1.0)/ea(T(ea(bb))));I=ea(bb*fb);bb=ea(g[ma>>2]);db=ea(bb-I);O=ea(g[Ja>>2]);gb=ea(g[ka>>2]);Q=ea(O-gb);da=Q>ea(0.0);O=da?Q:ea(0.0);Q=ea(g[e+(Ta<<5)+12>>2]);ib=ea(Q-gb);da=ib>ea(0.0);gb=ea(O+(da?ib:ea(0.0)));ib=ea(I+ea(ea(fb*ea(g[x>>2]))-ea(bb*ea(2.0))));bb=ea(gb*ea(ea(g[Ma>>2])*ib));ib=ea(S*bb);S=ea(ab*bb);ab=ea(Za*bb);bb=ea(g[D>>2]);Za=ea(bb*ib);ib=ea(bb*S);S=ea(bb*ab);ab=ea(db*ea(g[B>>2]));db=ea(g[e+(Ta<<5)+16>>2]);gb=ea(db-ea(g[Sa>>2]));db=ea(g[e+(Ta<<5)+20>>2]);fb=ea(db-ea(g[A>>2]));db=ea(g[e+(Ta<<5)+24>>2]);I=ea(ea(1.0)/Q);Q=ea(ea(Za+ea(ab*ea(bb*gb)))*I);gb=ea(I*ea(ib+ea(ab*ea(bb*fb))));fb=ea(I*ea(S+ea(ab*ea(bb*ea(db-ea(g[Ia>>2]))))));g[Na>>2]=ea(Q+ea(g[Na>>2]));g[Ha>>2]=ea(gb+ea(g[Ha>>2]));g[y>>2]=ea(ea(g[y>>2])+fb)}if(ha>>>0<za>>>0&(ha|0)!=0){fb=ea(ra*ea(g[Aa>>2]));ra=ea(ea(1.0)/ea(T(ea(fb))));gb=ea(fb*ra);fb=ea(g[ma>>2]);Q=ea(fb-gb);db=ea(g[Ja>>2]);bb=ea(g[ka>>2]);ab=ea(db-bb);ha=ab>ea(0.0);db=ha?ab:ea(0.0);ab=ea(g[e+(la<<5)+12>>2]);S=ea(ab-bb);ha=S>ea(0.0);bb=ea(db+(ha?S:ea(0.0)));S=ea(gb+ea(ea(ra*ea(g[x>>2]))-ea(fb*ea(2.0))));fb=ea(bb*ea(ea(g[Ma>>2])*S));S=ea($a*fb);$a=ea(L*fb);L=ea(J*fb);fb=ea(g[D>>2]);J=ea(fb*S);S=ea(fb*$a);$a=ea(fb*L);L=ea(Q*ea(g[B>>2]));Q=ea(g[e+(la<<5)+16>>2]);bb=ea(Q-ea(g[Sa>>2]));Q=ea(g[e+(la<<5)+20>>2]);ra=ea(Q-ea(g[A>>2]));Q=ea(g[e+(la<<5)+24>>2]);gb=ea(ea(1.0)/ab);ab=ea(ea(J+ea(L*ea(fb*bb)))*gb);bb=ea(gb*ea(S+ea(L*ea(fb*ra))));ra=ea(gb*ea($a+ea(L*ea(fb*ea(Q-ea(g[Ia>>2]))))));g[Na>>2]=ea(ab+ea(g[Na>>2]));g[Ha>>2]=ea(bb+ea(g[Ha>>2]));g[y>>2]=ea(ea(g[y>>2])+ra)}if(fa>>>0<za>>>0&(fa|0)!=0){ra=ea(eb*ea(g[Aa>>2]));eb=ea(ea(1.0)/ea(T(ea(ra))));bb=ea(ra*eb);ra=ea(g[ma>>2]);ab=ea(ra-bb);Q=ea(g[Ja>>2]);fb=ea(g[ka>>2]);L=ea(Q-fb);fa=L>ea(0.0);Q=fa?L:ea(0.0);L=ea(g[e+(Ba<<5)+12>>2]);$a=ea(L-fb);fa=$a>ea(0.0);fb=ea(Q+(fa?$a:ea(0.0)));$a=ea(bb+ea(ea(eb*ea(g[x>>2]))-ea(ra*ea(2.0))));ra=ea(fb*ea(ea(g[Ma>>2])*$a));$a=ea(va*ra);va=ea(_a*ra);_a=ea(M*ra);ra=ea(g[D>>2]);M=ea(ra*$a);$a=ea(ra*va);va=ea(ra*_a);_a=ea(ab*ea(g[B>>2]));ab=ea(g[e+(Ba<<5)+16>>2]);fb=ea(ab-ea(g[Sa>>2]));ab=ea(g[e+(Ba<<5)+20>>2]);eb=ea(ab-ea(g[A>>2]));ab=ea(g[e+(Ba<<5)+24>>2]);bb=ea(ea(1.0)/L);L=ea(ea(M+ea(_a*ea(ra*fb)))*bb);fb=ea(bb*ea($a+ea(_a*ea(ra*eb))));eb=ea(bb*ea(va+ea(_a*ea(ra*ea(ab-ea(g[Ia>>2]))))));g[Na>>2]=ea(L+ea(g[Na>>2]));g[Ha>>2]=ea(fb+ea(g[Ha>>2]));g[y>>2]=ea(ea(g[y>>2])+eb)}if(ia>>>0<za>>>0&(ia|0)!=0){eb=ea(sa*ea(g[Aa>>2]));sa=ea(ea(1.0)/ea(T(ea(eb))));fb=ea(eb*sa);eb=ea(g[ma>>2]);L=ea(eb-fb);ab=ea(g[Ja>>2]);ra=ea(g[ka>>2]);_a=ea(ab-ra);ia=_a>ea(0.0);ab=ia?_a:ea(0.0);_a=ea(g[e+(La<<5)+12>>2]);va=ea(_a-ra);ia=va>ea(0.0);ra=ea(ab+(ia?va:ea(0.0)));va=ea(fb+ea(ea(sa*ea(g[x>>2]))-ea(eb*ea(2.0))));eb=ea(ra*ea(ea(g[Ma>>2])*va));va=ea(Ya*eb);Ya=ea(cb*eb);cb=ea(P*eb);eb=ea(g[D>>2]);P=ea(eb*va);va=ea(eb*Ya);Ya=ea(eb*cb);cb=ea(L*ea(g[B>>2]));L=ea(g[e+(La<<5)+16>>2]);ra=ea(L-ea(g[Sa>>2]));L=ea(g[e+(La<<5)+20>>2]);sa=ea(L-ea(g[A>>2]));L=ea(g[e+(La<<5)+24>>2]);fb=ea(ea(1.0)/_a);_a=ea(ea(P+ea(cb*ea(eb*ra)))*fb);ra=ea(fb*ea(va+ea(cb*ea(eb*sa))));sa=ea(fb*ea(Ya+ea(cb*ea(eb*ea(L-ea(g[Ia>>2]))))));g[Na>>2]=ea(_a+ea(g[Na>>2]));g[Ha>>2]=ea(ra+ea(g[Ha>>2]));g[y>>2]=ea(ea(g[y>>2])+sa)}}ja=ja+4|0}while(ja>>>0<Xa>>>0)}if(b){ua=ea(g[Oa>>2]);K=ea(g[d+(n<<5)+4>>2]);N=ea(g[d+(n<<5)+8>>2]);ja=d+(n<<5)+12|0;y=d+(n<<5)+16|0;Ha=d+(n<<5)+20|0;Ia=d+(n<<5)+24|0;A=a+(n*12|0)+4|0;Sa=a+(n*12|0)+8|0;Ja=Xa;do{La=c[j+(Ja<<2)>>2]|0;sa=ea(ua-ea(g[e+(La<<5)>>2]));ra=ea(K-ea(g[e+(La<<5)+4>>2]));_a=ea(N-ea(g[e+(La<<5)+8>>2]));L=ea(ea(ea(sa*sa)+ea(ra*ra))+ea(_a*_a));ia=(g[k>>2]=L,c[k>>2]|0);if(ia>>>0<za>>>0&(ia|0)!=0){eb=ea(L*ea(g[Aa>>2]));L=ea(ea(1.0)/ea(T(ea(eb))));cb=ea(eb*L);eb=ea(g[ma>>2]);Ya=ea(eb-cb);fb=ea(g[ja>>2]);va=ea(g[ka>>2]);P=ea(fb-va);ia=P>ea(0.0);fb=ia?P:ea(0.0);P=ea(g[e+(La<<5)+12>>2]);ab=ea(P-va);ia=ab>ea(0.0);va=ea(fb+(ia?ab:ea(0.0)));ab=ea(cb+ea(ea(L*ea(g[x>>2]))-ea(eb*ea(2.0))));eb=ea(va*ea(ea(g[Ma>>2])*ab));ab=ea(sa*eb);sa=ea(ra*eb);ra=ea(_a*eb);eb=ea(g[D>>2]);_a=ea(eb*ab);ab=ea(eb*sa);sa=ea(eb*ra);ra=ea(Ya*ea(g[B>>2]));Ya=ea(g[e+(La<<5)+16>>2]);va=ea(Ya-ea(g[y>>2]));Ya=ea(g[e+(La<<5)+20>>2]);L=ea(Ya-ea(g[Ha>>2]));Ya=ea(g[e+(La<<5)+24>>2]);cb=ea(ea(1.0)/P);P=ea(ea(_a+ea(ra*ea(eb*va)))*cb);va=ea(cb*ea(ab+ea(ra*ea(eb*L))));L=ea(cb*ea(sa+ea(ra*ea(eb*ea(Ya-ea(g[Ia>>2]))))));g[Na>>2]=ea(P+ea(g[Na>>2]));g[A>>2]=ea(va+ea(g[A>>2]));g[Sa>>2]=ea(ea(g[Sa>>2])+L)}Ja=Ja+1|0}while((Ja|0)!=(l|0))}z=z+1|0}while((z|0)!=(h|0));i=r;return}if(!m){if(q){i=r;return}m=(Xa|0)==0;z=Xa>>>0<l>>>0;B=o+28|0;D=o+32|0;Ma=o+52|0;x=0;do{ka=c[f+(x<<2)>>2]|0;ma=d+(ka<<5)|0;if(!m){N=ea(g[ma>>2]);K=ea(g[d+(ka<<5)+4>>2]);ua=ea(g[d+(ka<<5)+8>>2]);Aa=d+(ka<<5)+12|0;a=0;do{b=c[j+(a<<2)>>2]|0;Ka=c[j+((a|1)<<2)>>2]|0;Ja=c[j+((a|2)<<2)>>2]|0;Sa=c[j+((a|3)<<2)>>2]|0;L=ea(N-ea(g[e+(b<<5)>>2]));va=ea(K-ea(g[e+(b<<5)+4>>2]));P=ea(ua-ea(g[e+(b<<5)+8>>2]));Ya=ea(N-ea(g[e+(Ka<<5)>>2]));eb=ea(K-ea(g[e+(Ka<<5)+4>>2]));ra=ea(ua-ea(g[e+(Ka<<5)+8>>2]));sa=ea(N-ea(g[e+(Ja<<5)>>2]));cb=ea(K-ea(g[e+(Ja<<5)+4>>2]));ab=ea(ua-ea(g[e+(Ja<<5)+8>>2]));_a=ea(N-ea(g[e+(Sa<<5)>>2]));fb=ea(K-ea(g[e+(Sa<<5)+4>>2]));bb=ea(ua-ea(g[e+(Sa<<5)+8>>2]));$a=ea(ea(ea(L*L)+ea(va*va))+ea(P*P));P=ea(ea(ea(Ya*Ya)+ea(eb*eb))+ea(ra*ra));ra=ea(ea(ea(sa*sa)+ea(cb*cb))+ea(ab*ab));ab=ea(ea(ea(_a*_a)+ea(fb*fb))+ea(bb*bb));if(!(!(ea(U-P)>=ea(0.0))&!(ea(U-$a)>=ea(0.0))&!(ea(U-ra)>=ea(0.0))&!(ea(U-ab)>=ea(0.0)))){Sa=(g[k>>2]=$a,c[k>>2]|0);Ja=(g[k>>2]=P,c[k>>2]|0);Ka=(g[k>>2]=ra,c[k>>2]|0);b=(g[k>>2]=ab,c[k>>2]|0);if(Sa>>>0<za>>>0&(Sa|0)!=0){bb=ea(g[B>>2]);fb=ea(g[D>>2]);_a=ea(bb-ea($a*ea(g[Ma>>2])));$a=ea(_a*ea(_a*ea(fb*_a)));g[Aa>>2]=ea(ea(g[Aa>>2])+$a)}if(Ja>>>0<za>>>0&(Ja|0)!=0){$a=ea(g[B>>2]);_a=ea(g[D>>2]);fb=ea($a-ea(P*ea(g[Ma>>2])));P=ea(fb*ea(fb*ea(_a*fb)));g[Aa>>2]=ea(ea(g[Aa>>2])+P)}if(Ka>>>0<za>>>0&(Ka|0)!=0){P=ea(g[B>>2]);fb=ea(g[D>>2]);_a=ea(P-ea(ra*ea(g[Ma>>2])));ra=ea(_a*ea(_a*ea(fb*_a)));g[Aa>>2]=ea(ea(g[Aa>>2])+ra)}if(b>>>0<za>>>0&(b|0)!=0){ra=ea(g[B>>2]);_a=ea(g[D>>2]);fb=ea(ra-ea(ab*ea(g[Ma>>2])));ab=ea(fb*ea(fb*ea(_a*fb)));g[Aa>>2]=ea(ea(g[Aa>>2])+ab)}}a=a+4|0}while(a>>>0<Xa>>>0)}if(z){ua=ea(g[ma>>2]);K=ea(g[d+(ka<<5)+4>>2]);N=ea(g[d+(ka<<5)+8>>2]);a=d+(ka<<5)+12|0;Aa=Xa;do{b=c[j+(Aa<<2)>>2]|0;ab=ea(ua-ea(g[e+(b<<5)>>2]));fb=ea(K-ea(g[e+(b<<5)+4>>2]));_a=ea(N-ea(g[e+(b<<5)+8>>2]));ra=ea(ea(ea(ab*ab)+ea(fb*fb))+ea(_a*_a));b=(g[k>>2]=ra,c[k>>2]|0);if(b>>>0<za>>>0&(b|0)!=0){_a=ea(g[B>>2]);fb=ea(g[D>>2]);ab=ea(_a-ea(ra*ea(g[Ma>>2])));ra=ea(ab*ea(ab*ea(fb*ab)));g[a>>2]=ea(ea(g[a>>2])+ra)}Aa=Aa+1|0}while((Aa|0)!=(l|0))}x=x+1|0}while((x|0)!=(h|0));i=r;return}if(q){i=r;return}q=Xa>>>0<l>>>0;x=o+28|0;Ma=o+32|0;D=o+52|0;if(!Xa){o=0;do{B=c[f+(o<<2)>>2]|0;if(q){N=ea(g[d+(B<<5)>>2]);K=ea(g[d+(B<<5)+4>>2]);ua=ea(g[d+(B<<5)+8>>2]);z=d+(B<<5)+12|0;B=0;do{m=c[j+(B<<2)>>2]|0;ra=ea(N-ea(g[e+(m<<5)>>2]));ab=ea(K-ea(g[e+(m<<5)+4>>2]));fb=ea(ua-ea(g[e+(m<<5)+8>>2]));_a=ea(ea(ea(ra*ra)+ea(ab*ab))+ea(fb*fb));Aa=(g[k>>2]=_a,c[k>>2]|0);if(Aa>>>0<za>>>0&(Aa|0)!=0){fb=ea(g[x>>2]);ab=ea(g[Ma>>2]);ra=ea(fb-ea(_a*ea(g[D>>2])));_a=ea(ra*ea(ra*ea(ab*ra)));g[z>>2]=ea(ea(g[z>>2])+_a);Aa=e+(m<<5)+12|0;g[Aa>>2]=ea(ea(g[Aa>>2])+_a)}B=B+1|0}while((B|0)!=(l|0))}o=o+1|0}while((o|0)!=(h|0));i=r;return}else{jb=U;kb=0}while(1){o=c[f+(kb<<2)>>2]|0;U=ea(g[d+(o<<5)>>2]);ua=ea(g[d+(o<<5)+4>>2]);K=ea(g[d+(o<<5)+8>>2]);B=d+(o<<5)+12|0;o=0;do{z=c[j+(o<<2)>>2]|0;Aa=c[j+((o|1)<<2)>>2]|0;m=c[j+((o|2)<<2)>>2]|0;a=c[j+((o|3)<<2)>>2]|0;N=ea(U-ea(g[e+(z<<5)>>2]));_a=ea(ua-ea(g[e+(z<<5)+4>>2]));ra=ea(K-ea(g[e+(z<<5)+8>>2]));ab=ea(U-ea(g[e+(Aa<<5)>>2]));fb=ea(ua-ea(g[e+(Aa<<5)+4>>2]));P=ea(K-ea(g[e+(Aa<<5)+8>>2]));$a=ea(U-ea(g[e+(m<<5)>>2]));bb=ea(ua-ea(g[e+(m<<5)+4>>2]));cb=ea(K-ea(g[e+(m<<5)+8>>2]));sa=ea(U-ea(g[e+(a<<5)>>2]));eb=ea(ua-ea(g[e+(a<<5)+4>>2]));Ya=ea(K-ea(g[e+(a<<5)+8>>2]));va=ea(ea(ea(N*N)+ea(_a*_a))+ea(ra*ra));ra=ea(ea(ea(ab*ab)+ea(fb*fb))+ea(P*P));P=ea(ea(ea($a*$a)+ea(bb*bb))+ea(cb*cb));cb=ea(ea(ea(sa*sa)+ea(eb*eb))+ea(Ya*Ya));if(!(!(ea(jb-ra)>=ea(0.0))&!(ea(jb-va)>=ea(0.0))&!(ea(jb-P)>=ea(0.0))&!(ea(jb-cb)>=ea(0.0)))){ka=(g[k>>2]=va,c[k>>2]|0);ma=(g[k>>2]=ra,c[k>>2]|0);b=(g[k>>2]=P,c[k>>2]|0);Ka=(g[k>>2]=cb,c[k>>2]|0);if(ka>>>0<za>>>0&(ka|0)!=0){Ya=ea(g[x>>2]);eb=ea(g[Ma>>2]);sa=ea(Ya-ea(va*ea(g[D>>2])));va=ea(sa*ea(sa*ea(eb*sa)));g[B>>2]=ea(ea(g[B>>2])+va);ka=e+(z<<5)+12|0;g[ka>>2]=ea(ea(g[ka>>2])+va)}if(ma>>>0<za>>>0&(ma|0)!=0){va=ea(g[x>>2]);sa=ea(g[Ma>>2]);eb=ea(va-ea(ra*ea(g[D>>2])));ra=ea(eb*ea(eb*ea(sa*eb)));g[B>>2]=ea(ea(g[B>>2])+ra);ma=e+(Aa<<5)+12|0;g[ma>>2]=ea(ea(g[ma>>2])+ra)}if(b>>>0<za>>>0&(b|0)!=0){ra=ea(g[x>>2]);eb=ea(g[Ma>>2]);sa=ea(ra-ea(P*ea(g[D>>2])));P=ea(sa*ea(sa*ea(eb*sa)));g[B>>2]=ea(ea(g[B>>2])+P);b=e+(m<<5)+12|0;g[b>>2]=ea(ea(g[b>>2])+P)}if(Ka>>>0<za>>>0&(Ka|0)!=0){P=ea(g[x>>2]);sa=ea(g[Ma>>2]);eb=ea(P-ea(cb*ea(g[D>>2])));cb=ea(eb*ea(eb*ea(sa*eb)));g[B>>2]=ea(ea(g[B>>2])+cb);Ka=e+(a<<5)+12|0;g[Ka>>2]=ea(ea(g[Ka>>2])+cb)}}o=o+4|0}while(o>>>0<Xa>>>0);if(q){o=Xa;do{Ka=c[j+(o<<2)>>2]|0;cb=ea(U-ea(g[e+(Ka<<5)>>2]));eb=ea(ua-ea(g[e+(Ka<<5)+4>>2]));sa=ea(K-ea(g[e+(Ka<<5)+8>>2]));P=ea(ea(ea(cb*cb)+ea(eb*eb))+ea(sa*sa));a=(g[k>>2]=P,c[k>>2]|0);if(a>>>0<za>>>0&(a|0)!=0){sa=ea(g[x>>2]);eb=ea(g[Ma>>2]);cb=ea(sa-ea(P*ea(g[D>>2])));P=ea(cb*ea(cb*ea(eb*cb)));g[B>>2]=ea(ea(g[B>>2])+P);a=e+(Ka<<5)+12|0;g[a>>2]=ea(ea(g[a>>2])+P)}o=o+1|0}while((o|0)!=(l|0))}o=kb+1|0;if((o|0)==(h|0))break;jb=ea(g[Wa>>2]);kb=o}i=r;return}function T0a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;k=h+36|0;l=h+8|0;m=(b|0)==0;b=a+16|0;a=h+28|0;n=h+32|0;h=0;do{o=f+(h<<2)|0;if((c[o>>2]|0)!=0?(p=c[f+(h<<2)+108>>2]|0,q=e+(p<<5)|0,r=d+(p*12|0)|0,p=c[492520+(h*80|0)>>2]|0,(p|0)!=0):0){s=0;t=0;while(1){u=c[492520+(h*80|0)+(s<<2)+4>>2]|0;v=g+(u<<2)|0;w=c[v>>2]|0;if(w){if((w+t|0)>>>0>512){S0a(r,d,q,e,c[k>>2]|0,c[o>>2]|0,c[l>>2]|0,t,0,m,b,c[a>>2]|0,c[n>>2]|0);x=c[v>>2]|0;y=0}else{x=w;y=t}if(!x)z=y;else{w=c[l>>2]|0;A=c[g+(u<<2)+392>>2]|0;u=0;B=y;while(1){C=B+1|0;c[w+(B<<2)>>2]=A;u=u+1|0;if(u>>>0>=(c[v>>2]|0)>>>0){z=C;break}else{A=A+1|0;B=C}}}}else z=t;s=s+1|0;if((s|0)==(p|0))break;else t=z}if(z)S0a(r,d,q,e,c[k>>2]|0,c[o>>2]|0,c[l>>2]|0,z,0,m,b,c[a>>2]|0,c[n>>2]|0)}h=h+1|0}while((h|0)!=26);i=j;return}function U0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+1|0;f=a+20|0;if(!(c[f>>2]|0)){c[f>>2]=b;g=UJa(e,b<<3,497248,1307)|0;c[a>>2]=g;h=c[f>>2]|0;c[a+8>>2]=g+(h<<2);c[a+16>>2]=h;i=d;return}h=a+16|0;if((c[h>>2]|0)>>>0>=b>>>0){i=d;return}g=UJa(e,b<<3,497248,1373)|0;e=g+(b<<2)|0;YEi(g|0,c[a>>2]|0,c[a+4>>2]<<2|0)|0;j=a+8|0;YEi(e|0,c[j>>2]|0,c[a+12>>2]<<2|0)|0;VJa(d,c[a>>2]|0);c[a>>2]=g;c[j>>2]=e;c[h>>2]=b;c[f>>2]=b;i=d;return}function V0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+1|0;f=a+36|0;if(!(c[f>>2]|0)){c[f>>2]=b;g=UJa(e,b<<4,497248,1437)|0;c[a>>2]=g;h=c[f>>2]|0;c[a+8>>2]=g+(h<<2);c[a+24>>2]=g+(h*3<<2);c[a+16>>2]=g+(h<<1<<2);c[a+32>>2]=h;i=d;return}h=a+32|0;if((c[h>>2]|0)>>>0>=b>>>0){i=d;return}g=UJa(e,b<<4,497248,1550)|0;e=g+(b<<2)|0;j=g+(b<<1<<2)|0;k=g+(b*3<<2)|0;YEi(g|0,c[a>>2]|0,c[a+4>>2]<<2|0)|0;l=a+8|0;YEi(e|0,c[l>>2]|0,c[a+12>>2]<<2|0)|0;m=a+24|0;YEi(j|0,c[m>>2]|0,c[a+28>>2]<<2|0)|0;n=a+16|0;YEi(k|0,c[n>>2]|0,c[a+20>>2]<<2|0)|0;VJa(d,c[a>>2]|0);c[a>>2]=g;c[l>>2]=e;c[m>>2]=j;c[n>>2]=k;c[h>>2]=b;c[f>>2]=b;i=d;return}function W0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=(b*12|0)+15&-16;f=(b<<2)+15&-16;g=(b+31|0)>>>5;h=(g<<2)+15&1073741808;j=e+f|0;k=j+f|0;f=UJa(d+1|0,k+h|0,497248,882)|0;l=f+e|0;e=f+j|0;j=f+k|0;PEi(j|0,0,h|0)|0;h=a+4|0;k=c[h>>2]|0;if(!k){m=a+12|0;n=a+8|0}else{o=a+12|0;YEi(f|0,k|0,(c[o>>2]|0)*12|0)|0;k=a+8|0;YEi(l|0,c[k>>2]|0,c[o>>2]<<2|0)|0;YEi(e|0,c[a+20>>2]|0,c[o>>2]<<2|0)|0;YEi(j|0,c[a+24>>2]|0,c[a+28>>2]<<2|0)|0;VJa(d,c[h>>2]|0);m=o;n=k}c[h>>2]=f;c[n>>2]=l;n=c[m>>2]|0;f=a+16|0;h=b+-1|0;c[l+(h<<2)>>2]=c[f>>2];if(h>>>0>n>>>0){k=n;do{o=k;k=k+1|0;c[l+(o<<2)>>2]=k}while((k|0)!=(h|0))}c[f>>2]=n;n=c[m>>2]|0;PEi(e+(n<<2)|0,-1,b-n<<2|0)|0;c[a+20>>2]=e;e=a+28|0;n=c[e>>2]|0;PEi(j+(n<<2)|0,0,g-n<<2|0)|0;c[a+24>>2]=j;c[e>>2]=g;e=c[a+80>>2]|0;c[e>>2]=j;c[e+4>>2]=g|-2147483648;c[m>>2]=b;i=d;return}function X0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=b>>>5;f=b<<4;g=((b<<2)+15&-16)+f|0;h=UJa(d+1|0,g+((e<<2)+15&1073741808)|0,497248,1044)|0;j=h+f|0;f=h+g|0;g=a+4|0;k=c[g>>2]|0;if(!k){l=a+12|0;m=a+8|0}else{n=a+12|0;YEi(h|0,k|0,c[n>>2]<<4|0)|0;k=a+8|0;YEi(j|0,c[k>>2]|0,c[n>>2]<<2|0)|0;YEi(f|0,c[a+32>>2]|0,c[a+36>>2]<<2|0)|0;VJa(d,c[g>>2]|0);l=n;m=k}c[g>>2]=h;c[m>>2]=j;m=c[l>>2]|0;h=a+16|0;g=b+-1|0;c[j+(g<<2)>>2]=c[h>>2];if(g>>>0>m>>>0){k=m;do{n=k;k=k+1|0;c[j+(n<<2)>>2]=k}while((k|0)!=(g|0))}c[h>>2]=m;m=a+36|0;h=c[m>>2]|0;PEi(f+(h<<2)|0,0,e-h<<2|0)|0;c[a+20>>2]=f;c[a+24>>2]=e|-2147483648;c[a+32>>2]=f;c[m>>2]=e;c[l>>2]=b;i=d;return}function Y0a(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+4096|0;n=m;o=c[h+4>>2]|0;h=j+4|0;p=c[h>>2]|0;a:do if(d){if(!g){q=0;while(1){r=c[b+(q<<2)>>2]|0;s=c[p+(r*12|0)>>2]|0;t=c[p+(r*12|0)+4>>2]|0;if((s|0)!=-1?(r=c[o+(s*12|0)+4>>2]|0,(r|0)!=-1):0){s=(c[l>>2]|0)+(r>>>5<<2)|0;c[s>>2]=c[s>>2]|1<<(r&31)}if((t|0)!=-1?(r=c[o+(t*12|0)+4>>2]|0,(r|0)!=-1):0){t=(c[l>>2]|0)+(r>>>5<<2)|0;c[t>>2]=c[t>>2]|1<<(r&31)}q=q+1|0;if((q|0)==(d|0))break a}}else u=0;do{q=c[b+(u<<2)>>2]|0;r=p+(q*12|0)|0;t=c[r>>2]|0;s=p+(q*12|0)+4|0;q=c[s>>2]|0;if((t|0)!=-1){v=c[o+(t*12|0)+4>>2]|0;if((v|0)!=-1){w=(c[l>>2]|0)+(v>>>5<<2)|0;c[w>>2]=c[w>>2]|1<<(v&31)}if(a[o+(t*12|0)+8>>0]&1)c[r>>2]=c[g+(t<<2)>>2]}if((q|0)!=-1){t=c[o+(q*12|0)+4>>2]|0;if((t|0)!=-1){r=(c[l>>2]|0)+(t>>>5<<2)|0;c[r>>2]=c[r>>2]|1<<(t&31)}if(a[o+(q*12|0)+8>>0]&1)c[s>>2]=c[g+(q<<2)>>2]}u=u+1|0}while((u|0)!=(d|0))}while(0);if(f){d=0;do{u=c[e+(d<<2)>>2]|0;g=p+(u*12|0)+8|0;b=c[g>>2]|0;if(b&4){c[g>>2]=b&-5;b=c[p+(u*12|0)>>2]|0;g=c[p+(u*12|0)+4>>2]|0;if((b|0)!=-1?(u=c[o+(b*12|0)+4>>2]|0,(u|0)!=-1):0){b=(c[l>>2]|0)+(u>>>5<<2)|0;c[b>>2]=c[b>>2]|1<<(u&31)}if((g|0)!=-1?(u=c[o+(g*12|0)+4>>2]|0,(u|0)!=-1):0){g=(c[l>>2]|0)+(u>>>5<<2)|0;c[g>>2]=c[g>>2]|1<<(u&31)}}d=d+1|0}while((d|0)!=(f|0))}f=c[l+4>>2]&2147483647;while(1){d=f;f=f+-1|0;x=c[l>>2]|0;if(!d){y=1;break}z=c[x+(f<<2)>>2]|0;if(z){A=33;break}}if((A|0)==33){l=z>>>1|z;z=l>>>2|l;l=z>>>4|z;z=l>>>8|l;y=(((c[482792+((da(z>>>16|z,130329821)|0)>>>27<<2)>>2]|0)+(f<<5)|0)>>>5)+1|0}f=j+20|0;j=k+4|0;k=0;z=0;while(1){l=c[x+(z<<2)>>2]|0;if(!l)B=k;else{d=z<<5;o=l;l=k;while(1){p=c[425648+((da(o&0-o,125613361)|0)>>>27<<2)>>2]|d;if(l>>>0<1024){c[n+(l<<2)>>2]=p;C=l+1|0}else{e=c[h>>2]|0;u=c[f>>2]|0;g=c[j>>2]|0;b=0;do{q=c[n+(b<<2)>>2]|0;s=g+(q<<4)+4|0;t=c[s>>2]|0;b:do if((t|0)!=-1){r=t;while(1){if(c[e+(r*12|0)+8>>2]&4)break;v=u+(r<<2)|0;w=c[v>>2]|0;c[v>>2]=-1;if((w|0)==-1){A=43;break b}else r=w}c[s>>2]=r;if((r|0)==-1)D=-1;else{w=r;c:while(1){E=u+(w<<2)|0;v=c[E>>2]|0;if((v|0)==-1)break;else F=v;while(1){if(c[e+(F*12|0)+8>>2]&4)break;v=u+(F<<2)|0;G=c[v>>2]|0;c[v>>2]=-1;if((G|0)==-1)break c;else F=G}c[E>>2]=F;if((F|0)==-1){D=w;break b}else w=F}c[E>>2]=-1;D=w}}else A=43;while(0);if((A|0)==43){A=0;c[s>>2]=-1;D=-1}c[g+(q<<4)+12>>2]=D;b=b+1|0}while((b|0)!=(l|0));c[n>>2]=p;C=1}o=o+-1&o;if(!o){B=C;break}else l=C}}z=z+1|0;if((z|0)==(y|0))break;else k=B}k=c[h>>2]|0;h=c[f>>2]|0;if(!B){i=m;return}f=c[j>>2]|0;j=0;do{y=c[n+(j<<2)>>2]|0;z=f+(y<<4)+4|0;C=c[z>>2]|0;d:do if((C|0)!=-1){D=C;while(1){if(c[k+(D*12|0)+8>>2]&4)break;E=h+(D<<2)|0;F=c[E>>2]|0;c[E>>2]=-1;if((F|0)==-1){A=59;break d}else D=F}c[z>>2]=D;if((D|0)==-1)H=-1;else{p=D;e:while(1){I=h+(p<<2)|0;F=c[I>>2]|0;if((F|0)==-1)break;else J=F;while(1){if(c[k+(J*12|0)+8>>2]&4)break;F=h+(J<<2)|0;E=c[F>>2]|0;c[F>>2]=-1;if((E|0)==-1)break e;else J=E}c[I>>2]=J;if((J|0)==-1){H=p;break d}else p=J}c[I>>2]=-1;H=p}}else A=59;while(0);if((A|0)==59){A=0;c[z>>2]=-1;H=-1}c[f+(y<<4)+12>>2]=H;j=j+1|0}while((j|0)!=(B|0));i=m;return}function Z0a(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;l=i;m=e+4|0;n=c[m>>2]|0;o=e+20|0;p=c[o>>2]|0;q=c[f+4>>2]|0;r=c[f+20>>2]|0;f=c[e+12>>2]<<2;PEi(h|0,-1,f|0)|0;PEi(j|0,-1,f|0)|0;f=c[b>>2]|0;s=b+4|0;t=c[s>>2]&2147483647;while(1){u=t;t=t+-1|0;if(!u){v=1;break}w=c[f+(t<<2)>>2]|0;if(w){x=4;break}}if((x|0)==4){u=w>>>1|w;w=u>>>2|u;u=w>>>4|w;w=u>>>8|u;v=(((c[482792+((da(w>>>16|w,130329821)|0)>>>27<<2)>>2]|0)+(t<<5)|0)>>>5)+1|0}t=0;do{w=c[f+(t<<2)>>2]|0;if(w){u=t<<5;y=w;do{w=c[425648+((da(y&0-y,125613361)|0)>>>27<<2)>>2]|u;z=c[n+(w*12|0)+4>>2]|0;A=(c[k>>2]|0)+(z>>>5<<2)|0;c[A>>2]=c[A>>2]|1<<(z&31);z=n+(w*12|0)+8|0;a[z>>0]=d[z>>0]|0|32;y=y+-1&y}while((y|0)!=0)}t=t+1|0}while((t|0)!=(v|0));v=c[k+4>>2]&2147483647;while(1){t=v;v=v+-1|0;if(!t){B=1;break}C=c[(c[k>>2]|0)+(v<<2)>>2]|0;if(C){x=13;break}}if((x|0)==13){t=C>>>1|C;C=t>>>2|t;t=C>>>4|C;C=t>>>8|t;B=(((c[482792+((da(C>>>16|C,130329821)|0)>>>27<<2)>>2]|0)+(v<<5)|0)>>>5)+1|0}v=g+4|0;g=e+16|0;C=e+8|0;e=0;do{t=c[(c[k>>2]|0)+(e<<2)>>2]|0;if(t){f=e<<5;y=c[v>>2]|0;u=t;while(1){t=c[425648+((da(u&0-u,125613361)|0)>>>27<<2)>>2]|f;z=c[m>>2]|0;w=c[o>>2]|0;A=y+(t<<4)|0;D=c[A>>2]|0;a:do if((D|0)==-1)x=20;else{E=D;while(1){if(!(a[z+(E*12|0)+8>>0]&32))break;F=w+(E<<2)|0;G=c[F>>2]|0;c[F>>2]=-1;if((G|0)==-1){x=20;break a}else E=G}c[A>>2]=E;G=E;b:while(1){H=w+(G<<2)|0;F=c[H>>2]|0;if((F|0)==-1)break;else I=F;while(1){if(!(a[z+(I*12|0)+8>>0]&32))break;F=w+(I<<2)|0;J=c[F>>2]|0;c[F>>2]=-1;if((J|0)==-1)break b;else I=J}c[H>>2]=I;if((I|0)==-1){K=G;break a}else G=I}c[H>>2]=-1;K=G}while(0);if((x|0)==20){x=0;c[A>>2]=-1;K=-1}c[y+(t<<4)+8>>2]=K;w=c[y+(t<<4)+4>>2]|0;if((w|0)==-1)L=y;else{z=y;D=w;while(1){w=q+(D*12|0)|0;E=c[w>>2]|0;if((E|0)!=-1?(J=n+(E*12|0)+8|0,(a[J>>0]&1)!=0):0){F=c[g>>2]|0;M=(c[C>>2]|0)+(F<<2)|0;c[g>>2]=c[M>>2];c[M>>2]=-1;M=c[m>>2]|0;c[M+(F*12|0)>>2]=0;c[M+(F*12|0)+4>>2]=-1;a[M+(F*12|0)+8>>0]=0;c[h+(F<<2)>>2]=E;M=E;do{N=j+(M<<2)|0;M=c[N>>2]|0}while((M|0)!=-1);c[N>>2]=F;c[j+(F<<2)>>2]=-1;c[n+(F*12|0)>>2]=c[n+(E*12|0)>>2];a[n+(F*12|0)+8>>0]=(d[J>>0]|0)&223;M=c[v>>2]|0;c[n+(F*12|0)+4>>2]=t;G=M+(t<<4)|0;c[p+(F<<2)>>2]=c[G>>2];c[G>>2]=F;G=M+(t<<4)+8|0;O=c[G>>2]|0;c[G>>2]=(O|0)==-1?F:O;c[w>>2]=F;P=M}else P=z;M=q+(D*12|0)+4|0;O=c[M>>2]|0;if((O|0)!=-1?(G=n+(O*12|0)+8|0,(a[G>>0]&1)!=0):0){Q=c[g>>2]|0;R=(c[C>>2]|0)+(Q<<2)|0;c[g>>2]=c[R>>2];c[R>>2]=-1;R=c[m>>2]|0;c[R+(Q*12|0)>>2]=0;c[R+(Q*12|0)+4>>2]=-1;a[R+(Q*12|0)+8>>0]=0;c[h+(Q<<2)>>2]=O;R=O;do{S=j+(R<<2)|0;R=c[S>>2]|0}while((R|0)!=-1);c[S>>2]=Q;c[j+(Q<<2)>>2]=-1;c[n+(Q*12|0)>>2]=c[n+(O*12|0)>>2];a[n+(Q*12|0)+8>>0]=(d[G>>0]|0)&223;R=c[v>>2]|0;c[n+(Q*12|0)+4>>2]=t;F=R+(t<<4)|0;c[p+(Q<<2)>>2]=c[F>>2];c[F>>2]=Q;F=R+(t<<4)+8|0;w=c[F>>2]|0;c[F>>2]=(w|0)==-1?Q:w;c[M>>2]=Q;T=R}else T=P;D=c[r+(D<<2)>>2]|0;if((D|0)==-1){L=T;break}else z=T}}u=u+-1&u;if(!u)break;else y=L}}e=e+1|0}while((e|0)!=(B|0));B=c[b>>2]|0;b=c[s>>2]&2147483647;while(1){s=b;b=b+-1|0;if(!s){U=1;break}V=c[B+(b<<2)>>2]|0;if(V){x=44;break}}if((x|0)==44){x=V>>>1|V;V=x>>>2|x;x=V>>>4|V;V=x>>>8|x;U=(((c[482792+((da(V>>>16|V,130329821)|0)>>>27<<2)>>2]|0)+(b<<5)|0)>>>5)+1|0}b=0;do{V=c[B+(b<<2)>>2]|0;if(V){x=b<<5;s=V;do{V=c[425648+((da(s&0-s,125613361)|0)>>>27<<2)>>2]|x;e=n+(V*12|0)+8|0;a[e>>0]=(d[e>>0]|0)&223;e=n+(V*12|0)+4|0;if((c[j+(V<<2)>>2]|0)==-1){L=c[e>>2]|0;T=c[v>>2]|0;r=T+(L<<4)|0;c[p+(V<<2)>>2]=c[r>>2];c[r>>2]=V;r=T+(L<<4)+8|0;L=c[r>>2]|0;c[r>>2]=(L|0)==-1?V:L}else c[e>>2]=-1;s=s+-1&s}while((s|0)!=0)}b=b+1|0}while((b|0)!=(U|0));i=l;return}function _0a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+4096|0;l=k;m=c[a+4>>2]&2147483647;while(1){n=m;m=m+-1|0;if(!n){o=1;break}p=c[(c[a>>2]|0)+(m<<2)>>2]|0;if(p){q=4;break}}if((q|0)==4){q=p>>>1|p;p=q>>>2|q;q=p>>>4|p;p=q>>>8|q;o=(((c[482792+((da(p>>>16|p,130329821)|0)>>>27<<2)>>2]|0)+(m<<5)|0)>>>5)+1|0}m=e+20|0;p=0;q=0;while(1){n=c[(c[a>>2]|0)+(q<<2)>>2]|0;if(!n)r=p;else{s=q<<5;t=n;n=p;while(1){u=c[425648+((da(t&0-t,125613361)|0)>>>27<<2)>>2]|0;v=u|s;do if(c[(c[m>>2]|0)+(v>>>5<<2)>>2]&1<<(u&31))if(n>>>0<1024){c[l+(n<<2)>>2]=v;w=n+1|0;break}else{cEb(l,n,b,d,e,f,g,h,j);c[l>>2]=v;w=1;break}else w=n;while(0);t=t+-1&t;if(!t){r=w;break}else n=w}}q=q+1|0;if((q|0)==(o|0))break;else p=r}cEb(l,r,b,d,e,f,g,h,j);i=k;return}function $0a(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0;l=i;m=k+12|0;c[m>>2]=0;n=k+16|0;c[n>>2]=0;o=k+28|0;c[o>>2]=0;p=k+48|0;c[p>>2]=0;q=k+60|0;c[q>>2]=0;r=k+76|0;c[r>>2]=0;s=k+88|0;c[s>>2]=0;t=k+100|0;c[t>>2]=0;u=k+112|0;c[u>>2]=0;v=k+120|0;c[v>>2]=0;w=c[f+4>>2]|0;x=c[f+20>>2]|0;f=c[g+4>>2]|0;y=c[g+20>>2]|0;g=c[j+4>>2]|0;j=c[h+4>>2]|0;h=c[k+36>>2]|0;z=c[k+8>>2]|0;A=c[k+20>>2]|0;B=c[k+24>>2]|0;C=c[k+44>>2]|0;D=c[k+56>>2]|0;E=c[k+68>>2]|0;F=c[k+72>>2]|0;G=c[k+84>>2]|0;H=c[k+96>>2]|0;I=k+108|0;J=c[I>>2]|0;K=c[k+116>>2]|0;k=c[b>>2]|0;L=c[b+4>>2]&2147483647;while(1){b=L;L=L+-1|0;if(!b){M=1;break}N=c[k+(L<<2)>>2]|0;if(N){O=4;break}}if((O|0)==4){b=N>>>1|N;N=b>>>2|b;b=N>>>4|N;N=b>>>8|b;M=(((c[482792+((da(N>>>16|N,130329821)|0)>>>27<<2)>>2]|0)+(L<<5)|0)>>>5)+1|0}L=A+-1|0;A=0;N=0;b=0;P=0;Q=0;R=0;S=0;T=0;U=0;V=0;W=0;while(1){X=c[k+(W<<2)>>2]|0;if(!X){Y=A;Z=N;_=b;$=P;aa=Q;ba=R;ca=S;ea=T;fa=U;ga=V}else{ha=W<<5;ia=X;X=A;ja=N;ka=b;la=P;ma=Q;na=R;oa=S;pa=T;qa=U;ra=V;while(1){sa=c[425648+((da(ia&0-ia,125613361)|0)>>>27<<2)>>2]|ha;ta=j+(sa<<4)|0;ua=c[ta>>2]|0;va=(ua|0)==-1;a:do if(!va){wa=0;xa=ua;do{wa=d[w+(xa*12|0)+8>>0]|0|wa;xa=c[x+(xa<<2)>>2]|0}while((xa|0)!=-1);if(!(wa&8)){if(va){ya=X;za=ja;Aa=ka;Ba=la;Ca=ma;Da=na;Ea=oa;Fa=pa;Ga=qa;Ha=ra;break}else{Ia=X;Ja=ua}while(1){xa=Ja;b:while(1){Ka=w+(xa*12|0)|0;La=x+(xa<<2)|0;Ma=w+(xa*12|0)+8|0;Na=a[Ma>>0]|0;do if(!(Na&16))if(!(Na&2))if(!(Na&1)){O=17;break b}else break;else if(!(Na&4))break;else{O=20;break b}while(0);xa=c[La>>2]|0;if((xa|0)==-1){ya=Ia;za=ja;Aa=ka;Ba=la;Ca=ma;Da=na;Ea=oa;Fa=pa;Ga=qa;Ha=ra;break a}}if((O|0)==17){O=0;a[Ma>>0]=Na&255|16;c[z+(L-Ia<<2)>>2]=c[Ka>>2]}else if((O|0)==20){O=0;a[Ma>>0]=Na&255|16;c[z+(L-Ia<<2)>>2]=c[g+(c[Ka>>2]<<3)+4>>2]|1}xa=Ia+1|0;Ja=c[La>>2]|0;if((Ja|0)==-1){ya=xa;za=ja;Aa=ka;Ba=la;Ca=ma;Da=na;Ea=oa;Fa=pa;Ga=qa;Ha=ra;break a}else Ia=xa}}wa=J+(la<<4)+4|0;c[wa>>2]=c[wa>>2]&-2147483648|na&2147483647;c[J+(la<<4)>>2]=oa;c[J+(la<<4)+8>>2]=qa;c[J+(la<<4)+12>>2]=pa;xa=la+1|0;Oa=ja;Pa=ta;Qa=na;Ra=oa;Sa=ra;c:while(1){Ta=Oa;Ua=Pa;Va=Ra;Wa=Sa;d:while(1){Xa=Ta;Ya=Ua;Za=Wa;e:while(1){_a=Xa;$a=Ya;while(1){ab=c[$a>>2]|0;if((ab|0)==-1)break c;bb=w+(ab*12|0)|0;$a=x+(ab<<2)|0;cb=w+(ab*12|0)+8|0;db=a[cb>>0]|0;do if(db&16)if(!(db&2)){if(db&1){eb=_a;break}a[cb>>0]=db&239;c[z+(_a<<2)>>2]=c[bb>>2];eb=_a+1|0;break}else{if(!(db&4)){eb=_a;break}a[cb>>0]=db&239;c[z+(_a<<2)>>2]=c[g+(c[bb>>2]<<3)+4>>2]|1;eb=_a+1|0;break}else eb=_a;while(0);db=a[cb>>0]|0;if(db&1)break;if(!(db&2))break e;if(db&4)break d;else _a=eb}c[h+(ab<<2)>>2]=Za;c[C+(Za<<2)>>2]=(c[bb>>2]|0)+e;Xa=eb;Ya=$a;Za=Za+1|0}c[h+(ab<<2)>>2]=Va;c[D+(Va<<2)>>2]=(c[bb>>2]|0)+e;Ta=eb;Ua=$a;Va=Va+1|0;Wa=Za}Wa=c[bb>>2]|0;Ua=c[g+(Wa<<3)+4>>2]|0;c[E+(Qa<<2)>>2]=c[g+(Wa<<3)>>2]&-64;c[F+(Qa<<2)>>2]=Ua;Oa=eb;Pa=$a;Qa=Qa+1|0;Ra=Va;Sa=Za}Sa=0;Ra=j+(sa<<4)+4|0;Pa=ma;Oa=pa;Ua=qa;f:while(1){Wa=0;Ta=Sa;Ya=Ra;fb=Pa;Xa=Oa;g:while(1){gb=Wa;db=Ta;hb=Ya;ib=Xa;h:while(1){jb=db;kb=hb;lb=ib;while(1){mb=jb;nb=kb;while(1){ob=c[nb>>2]|0;if((ob|0)==-1)break f;nb=y+(ob<<2)|0;pb=c[f+(ob*12|0)>>2]|0;qb=c[f+(ob*12|0)+4>>2]|0;rb=(pb|0)!=-1;do if(gb){if(rb){sb=a[w+(pb*12|0)+8>>0]|0;if(!(sb&2))tb=(sb&1)!=0;else tb=0}else tb=1;if((qb|0)!=-1){sb=a[w+(qb*12|0)+8>>0]|0;if(!(sb&2))if(tb){ub=-1;vb=-1;wb=mb;xb=3;yb=(sb&1)!=0;zb=3;O=62}else{Ab=0;Bb=-1;Cb=-1;Db=mb;Eb=3;Fb=3}else{Gb=-1;Hb=mb;Ib=tb;Jb=3;Kb=0;O=61}}else{Gb=-1;Hb=mb;Ib=tb;Jb=3;Kb=1;O=61}}else{do if(rb){sb=a[w+(pb*12|0)+8>>0]|0;if(!(sb&2)){Lb=sb&1;Mb=c[h+(pb<<2)>>2]|0;Nb=mb;Ob=Lb<<24>>24!=0;Pb=Lb;break}Lb=c[w+(pb*12|0)>>2]|0;if(!(sb&4)){Mb=Lb;Nb=mb;Ob=0;Pb=2}else{Mb=c[g+(Lb<<3)>>2]|0;Nb=mb;Ob=0;Pb=2}}else{Mb=-1;Nb=1;Ob=1;Pb=3}while(0);if((qb|0)!=-1){Lb=a[w+(qb*12|0)+8>>0]|0;if(!(Lb&2)){sb=Lb&1;Qb=c[h+(qb<<2)>>2]|0;if(Ob){ub=Mb;vb=Qb;wb=Nb;xb=Pb;yb=sb<<24>>24!=0;zb=sb;O=62;break}else{Ab=0;Bb=Mb;Cb=Qb;Db=Nb;Eb=Pb;Fb=sb;break}}sb=c[w+(qb*12|0)>>2]|0;if(!(Lb&4))if(Ob){ub=Mb;vb=sb;wb=Nb;xb=Pb;yb=0;zb=2;O=62;break}else{Ab=0;Bb=Mb;Cb=sb;Db=Nb;Eb=Pb;Fb=2;break}else{Lb=c[g+(sb<<3)>>2]|0;if(Ob){ub=Mb;vb=Lb;wb=Nb;xb=Pb;yb=0;zb=2;O=62;break}else{Ab=0;Bb=Mb;Cb=Lb;Db=Nb;Eb=Pb;Fb=2;break}}}else{Gb=Mb;Hb=1;Ib=Ob;Jb=Pb;Kb=1;O=61}}while(0);if((O|0)==61){O=0;if(Ib){ub=Gb;vb=-1;wb=Hb;xb=Jb;yb=Kb;zb=3;O=62}else{Ab=0;Bb=Gb;Cb=-1;Db=Hb;Eb=Jb;Fb=3}}if((O|0)==62){O=0;Ab=yb;Bb=ub;Cb=vb;Db=wb;Eb=xb;Fb=zb}Rb=c[f+(ob*12|0)+8>>2]|0;Sb=Rb;qb=(Sb&3|0)!=0;if(!(qb|(Rb>>>0>=16>>>0|Ab)))break h;if(gb){gb=1;db=Db;hb=nb;ib=lb;continue h}if(!(qb|Ab))break g;if(!((Sb&1|0)==0|Ab))break;else mb=Db}c[H+(lb<<4)+12>>2]=Rb&-16;a[H+(lb<<4)+8>>0]=Eb;a[H+(lb<<4)+9>>0]=Fb;c[H+(lb<<4)>>2]=Bb;c[H+(lb<<4)+4>>2]=Cb;jb=Db;kb=nb;lb=lb+1|0}}c[B+(fb<<3)+4>>2]=ob;c[B+(fb<<3)>>2]=0;Wa=1;Ta=Db;Ya=nb;fb=fb+1|0;Xa=lb}c[G+(Ua<<4)+12>>2]=Sb&-16;a[G+(Ua<<4)+8>>0]=Eb;a[G+(Ua<<4)+9>>0]=Fb;c[G+(Ua<<4)>>2]=Bb;c[G+(Ua<<4)+4>>2]=Cb;Sa=Db;Ra=nb;Pa=fb;Oa=lb;Ua=Ua+1|0}if(gb){Oa=ka+1|0;c[J+(K-Oa<<4)+12>>2]=sa;ya=X;za=_a;Aa=Oa;Ba=la;Ca=fb;Da=na;Ea=oa;Fa=pa;Ga=qa;Ha=ra;break}else{c[wa>>2]=c[wa>>2]&2147483647|(mb&1)<<31;ya=X;za=_a;Aa=ka;Ba=xa;Ca=fb;Da=Qa;Ea=Va;Fa=lb;Ga=Ua;Ha=Za;break}}else{ya=X;za=ja;Aa=ka;Ba=la;Ca=ma;Da=na;Ea=oa;Fa=pa;Ga=qa;Ha=ra}while(0);ia=ia+-1&ia;if(!ia){Y=ya;Z=za;_=Aa;$=Ba;aa=Ca;ba=Da;ca=Ea;ea=Fa;fa=Ga;ga=Ha;break}else{X=ya;ja=za;ka=Aa;la=Ba;ma=Ca;na=Da;oa=Ea;pa=Fa;qa=Ga;ra=Ha}}}W=W+1|0;if((W|0)==(M|0))break;else{A=Y;N=Z;b=_;P=$;Q=aa;R=ba;S=ca;T=ea;U=fa;V=ga}}V=c[I>>2]|0;c[V+($<<4)>>2]=ca;U=V+($<<4)+4|0;c[U>>2]=c[U>>2]&-2147483648|ba&2147483647;U=c[I>>2]|0;c[U+($<<4)+8>>2]=fa;c[U+($<<4)+12>>2]=ea;c[m>>2]=Z;c[n>>2]=Y;c[o>>2]=aa;c[p>>2]=ga;c[q>>2]=ca;c[r>>2]=ba;c[s>>2]=fa;c[t>>2]=ea;c[u>>2]=$;c[v>>2]=_;i=l;return}function a1a(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;l=i;c[k+12>>2]=0;m=k+16|0;c[m>>2]=0;n=c[f+4>>2]|0;o=c[f+20>>2]|0;f=c[g+4>>2]|0;p=c[g+20>>2]|0;g=c[j+4>>2]|0;j=c[h+4>>2]|0;h=c[k+36>>2]|0;q=c[k+8>>2]|0;r=c[k+20>>2]|0;s=c[k+44>>2]|0;t=c[k+56>>2]|0;u=c[k+68>>2]|0;v=c[k+72>>2]|0;w=c[k+84>>2]|0;x=c[k+96>>2]|0;y=k+108|0;z=c[y>>2]|0;A=k+48|0;B=c[A>>2]|0;C=k+60|0;D=c[C>>2]|0;E=k+76|0;F=c[E>>2]|0;G=k+88|0;H=c[G>>2]|0;I=k+100|0;J=c[I>>2]|0;K=k+112|0;L=c[K>>2]|0;M=k+120|0;k=c[b>>2]|0;N=c[b+4>>2]&2147483647;while(1){b=N;N=N+-1|0;if(!b){O=1;break}P=c[k+(N<<2)>>2]|0;if(P){Q=4;break}}if((Q|0)==4){b=P>>>1|P;P=b>>>2|b;b=P>>>4|P;P=b>>>8|b;O=(((c[482792+((da(P>>>16|P,130329821)|0)>>>27<<2)>>2]|0)+(N<<5)|0)>>>5)+1|0}N=r+-1|0;r=0;P=L;L=F;F=D;D=J;J=H;H=B;B=0;while(1){b=c[k+(B<<2)>>2]|0;if(!b){R=r;S=P;T=L;U=F;V=D;W=J;X=H}else{Y=B<<5;Z=b;b=r;_=P;$=L;aa=F;ba=D;ca=J;ea=H;while(1){fa=c[425648+((da(Z&0-Z,125613361)|0)>>>27<<2)>>2]|Y;ga=j+(fa<<4)|0;ha=c[ga>>2]|0;ia=(ha|0)==-1;a:do if(ia){ja=b;ka=_;la=$;ma=aa;na=ba;oa=ca;pa=ea}else{qa=0;ra=ha;do{qa=d[n+(ra*12|0)+8>>0]|0|qa;ra=c[o+(ra<<2)>>2]|0}while((ra|0)!=-1);if(!(qa&8)){if(ia){ja=b;ka=_;la=$;ma=aa;na=ba;oa=ca;pa=ea;break}else{sa=b;ta=ha}while(1){ra=ta;while(1){ua=n+(ra*12|0)|0;va=o+(ra<<2)|0;wa=n+(ra*12|0)+8|0;xa=a[wa>>0]|0;if(!(xa&2)){if(!(xa&1)){Q=16;break}}else if(xa&4){Q=18;break}ra=c[va>>2]|0;if((ra|0)==-1){ja=sa;ka=_;la=$;ma=aa;na=ba;oa=ca;pa=ea;break a}}if((Q|0)==16){Q=0;a[wa>>0]=xa&255|16;c[q+(N-sa<<2)>>2]=c[ua>>2]}else if((Q|0)==18){Q=0;a[wa>>0]=xa&255|16;c[q+(N-sa<<2)>>2]=c[g+(c[ua>>2]<<3)+4>>2]|1}ra=sa+1|0;ta=c[va>>2]|0;if((ta|0)==-1){ja=ra;ka=_;la=$;ma=aa;na=ba;oa=ca;pa=ea;break a}else sa=ra}}qa=z+(_<<4)+4|0;c[qa>>2]=c[qa>>2]&-2147483648|$&2147483647;c[z+(_<<4)>>2]=aa;c[z+(_<<4)+8>>2]=ca;c[z+(_<<4)+12>>2]=ba;ra=_+1|0;ya=ga;za=$;Aa=aa;Ba=ea;b:while(1){Ca=ya;Da=Aa;Ea=Ba;c:while(1){Fa=Ca;Ga=Ea;d:while(1){Ha=Fa;while(1){Ia=c[Ha>>2]|0;if((Ia|0)==-1)break b;Ja=n+(Ia*12|0)|0;Ha=o+(Ia<<2)|0;Ka=a[n+(Ia*12|0)+8>>0]|0;if(Ka&1)break;if(!(Ka&2))break d;if(Ka&4)break c}c[h+(Ia<<2)>>2]=Ga;c[s+(Ga<<2)>>2]=(c[Ja>>2]|0)+e;Fa=Ha;Ga=Ga+1|0}c[h+(Ia<<2)>>2]=Da;c[t+(Da<<2)>>2]=(c[Ja>>2]|0)+e;Ca=Ha;Da=Da+1|0;Ea=Ga}Ea=c[Ja>>2]|0;Ca=c[g+(Ea<<3)+4>>2]|0;c[u+(za<<2)>>2]=c[g+(Ea<<3)>>2]&-64;c[v+(za<<2)>>2]=Ca;ya=Ha;za=za+1|0;Aa=Da;Ba=Ga}Ba=0;Aa=j+(fa<<4)+4|0;ya=ba;Ca=ca;e:while(1){Ea=Ba;Fa=Aa;La=Ca;f:while(1){Ma=Ea;Na=Fa;while(1){Ka=c[Na>>2]|0;if((Ka|0)==-1)break e;Na=p+(Ka<<2)|0;Oa=c[f+(Ka*12|0)>>2]|0;Pa=c[f+(Ka*12|0)+4>>2]|0;do if((Oa|0)!=-1){Qa=a[n+(Oa*12|0)+8>>0]|0;if(!(Qa&2)){Ra=Qa&1;Sa=c[h+(Oa<<2)>>2]|0;Ta=Ma;Ua=Ra<<24>>24==0;Va=Ra;break}Ra=c[n+(Oa*12|0)>>2]|0;if(!(Qa&4)){Sa=Ra;Ta=Ma;Ua=1;Va=2}else{Sa=c[g+(Ra<<3)>>2]|0;Ta=Ma;Ua=1;Va=2}}else{Sa=-1;Ta=1;Ua=0;Va=3}while(0);do if((Pa|0)!=-1){Oa=a[n+(Pa*12|0)+8>>0]|0;if(!(Oa&2)){Ra=Oa&1;Wa=c[h+(Pa<<2)>>2]|0;Xa=Ta;Ya=Ra<<24>>24==0;Za=Ra;break}Ra=c[n+(Pa*12|0)>>2]|0;if(!(Oa&4)){Wa=Ra;Xa=Ta;Ya=1;Za=2}else{Wa=c[g+(Ra<<3)>>2]|0;Xa=Ta;Ya=1;Za=2}}else{Wa=-1;Xa=1;Ya=0;Za=3}while(0);_a=c[f+(Ka*12|0)+8>>2]|0;$a=_a;Pa=(Ya|Ua)^1;if(!(($a&3|0)!=0|Pa))break;if(!(($a&1|0)==0|Pa))break f;else Ma=Xa}c[w+(La<<4)+12>>2]=$a&-16;a[w+(La<<4)+8>>0]=Va;a[w+(La<<4)+9>>0]=Za;c[w+(La<<4)>>2]=Sa;c[w+(La<<4)+4>>2]=Wa;Ea=Xa;Fa=Na;La=La+1|0}c[x+(ya<<4)+12>>2]=_a&-16;a[x+(ya<<4)+8>>0]=Va;a[x+(ya<<4)+9>>0]=Za;c[x+(ya<<4)>>2]=Sa;c[x+(ya<<4)+4>>2]=Wa;Ba=Xa;Aa=Na;ya=ya+1|0;Ca=La}c[qa>>2]=c[qa>>2]&2147483647|(Ma&1)<<31;ja=b;ka=ra;la=za;ma=Da;na=ya;oa=La;pa=Ga}while(0);Z=Z+-1&Z;if(!Z){R=ja;S=ka;T=la;U=ma;V=na;W=oa;X=pa;break}else{b=ja;_=ka;$=la;aa=ma;ba=na;ca=oa;ea=pa}}}B=B+1|0;if((B|0)==(O|0))break;else{r=R;P=S;L=T;F=U;D=V;J=W;H=X}}H=c[y>>2]|0;c[H+(S<<4)>>2]=U;J=H+(S<<4)+4|0;c[J>>2]=c[J>>2]&-2147483648|T&2147483647;J=c[y>>2]|0;c[J+(S<<4)+8>>2]=W;c[J+(S<<4)+12>>2]=V;c[m>>2]=R;c[A>>2]=X;c[C>>2]=U;c[E>>2]=T;c[G>>2]=W;c[I>>2]=V;c[K>>2]=S;c[M>>2]=0;i=l;return}function b1a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)dEb(b);e=b+4|0;f=b+264|0;g=c[f>>2]|0;h=c[b+268>>2]|0;j=g+(h<<2)|0;if(h){h=g;do{g=c[h>>2]|0;if(g)VJa(b,g+(0-(c[g+-4>>2]|0))|0);h=h+4|0}while((h|0)!=(j|0))}j=c[b+272>>2]|0;if(!((j&2147483647|0)!=0&(j|0)>-1)){i=d;return}j=c[f>>2]|0;if((e|0)==(j|0)){a[b+260>>0]=0;i=d;return}if(!j){i=d;return}VJa(e,j+(0-(c[j+-4>>2]|0))|0);i=d;return}function c1a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=UJa(a,(c[a+288>>2]|0)+67|0,498984,191)|0;if(!e)f=0;else{g=e+67&-64;c[g+-4>>2]=g-e;f=g}c[d>>2]=f;g=a+268|0;e=c[g>>2]|0;if((c[a+272>>2]&2147483647)>>>0>e>>>0){h=(c[a+264>>2]|0)+(e<<2)|0;if(h)c[h>>2]=f;c[g>>2]=e+1}else eEb(a+4|0,d)|0;d=f+((c[a+276>>2]|0)+-1<<6)|0;if(d>>>0<f>>>0){i=b;return}e=a+292|0;g=a+284|0;a=c[e>>2]|0;h=d;d=c[g>>2]|0;while(1){c[h>>2]=a;c[e>>2]=h;d=d+1|0;j=h+-64|0;if(j>>>0<f>>>0)break;else{k=h;h=j;a=k}}c[g>>2]=d;i=b;return}function d1a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=b;g=b+29|0;h=b+28|0;c[d>>2]=0;j=d+4|0;c[j>>2]=0;k=d+8|0;c[k>>2]=0;l=a+4|0;fEb(e,l);m=a+292|0;n=c[m>>2]|0;if(n){o=n;do{c[f>>2]=o;n=c[j>>2]|0;if((c[k>>2]&2147483647)>>>0>n>>>0){p=(c[d>>2]|0)+(n<<2)|0;if(p)c[p>>2]=o;c[j>>2]=n+1}else gEb(d,f)|0;o=c[c[m>>2]>>2]|0;c[m>>2]=o}while((o|0)!=0)}o=c[d>>2]|0;f=c[j>>2]|0;j=o+(f<<2)|0;n=a+276|0;p=c[n>>2]|0;q=o+(f-p<<2)|0;if(f>>>0>p>>>0?(hEb(o,f,g,a),g=e+4|0,hEb(c[e>>2]|0,c[g>>2]|0,h,a),h=a+268|0,c[h>>2]=0,p=c[e>>2]|0,r=c[g>>2]|0,g=p+(r<<2)|0,(r|0)!=0):0){r=a+288|0;s=a+272|0;t=a+264|0;u=a+284|0;v=o;w=p;while(1){p=c[w>>2]|0;a:do if(v>>>0<q>>>0){x=p;y=v;while(1){z=c[y>>2]|0;if(x>>>0<=z>>>0){A=x;B=y;break a}c[z>>2]=c[m>>2];c[m>>2]=z;c[u>>2]=(c[u>>2]|0)+1;z=y+4|0;C=c[w>>2]|0;if(z>>>0<q>>>0){x=C;y=z}else{A=C;B=z;break}}}else{A=p;B=v}while(0);if((A|0)==(c[B>>2]|0)?(p=c[n>>2]|0,((c[B+(p+-1<<2)>>2]|0)+64|0)==((c[r>>2]|0)+A|0)):0){if(!A)D=p;else{VJa(a,A+(0-(c[A+-4>>2]|0))|0);D=c[n>>2]|0}E=B+(D<<2)|0}else F=21;do if((F|0)==21){F=0;p=c[h>>2]|0;if((c[s>>2]&2147483647)>>>0<=p>>>0){eEb(l,w)|0;E=B;break}y=(c[t>>2]|0)+(p<<2)|0;if(y)c[y>>2]=A;c[h>>2]=p+1;E=B}while(0);w=w+4|0;if((w|0)==(g|0)){G=E;break}else v=E}}else G=o;if((G|0)!=(j|0)){E=a+284|0;a=(c[E>>2]|0)+((o+(f+-1<<2)+(0-G)|0)>>>2)|0;f=c[m>>2]|0;o=G;do{G=f;f=c[o>>2]|0;c[f>>2]=G;c[m>>2]=f;o=o+4|0}while((o|0)!=(j|0));c[E>>2]=a+1}a=c[e+8>>2]|0;if((a&2147483647|0)!=0&(a|0)>-1?(a=c[e>>2]|0,(a|0)!=0):0)VJa(e,a+(0-(c[a+-4>>2]|0))|0);a=c[k>>2]|0;if(!((a&2147483647|0)!=0&(a|0)>-1)){i=b;return}a=c[d>>2]|0;if(!a){i=b;return}VJa(d,a+(0-(c[a+-4>>2]|0))|0);i=b;return}function e1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=0,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;e=i;f=ea(g[b>>2]);h=ea(g[a>>2]);j=ea(f*h);k=b+4|0;l=ea(g[k>>2]);m=ea(g[a+4>>2]);n=ea(j+ea(l*m));o=b+8|0;j=ea(g[o>>2]);p=ea(g[a+8>>2]);q=ea(n+ea(j*p));n=ea(h-ea(f*q));f=ea(m-ea(l*q));l=ea(p-ea(j*q));g[c>>2]=n;a=c+4|0;g[a>>2]=f;r=c+8|0;g[r>>2]=l;q=ea(ea(ea(n*n)+ea(f*f))+ea(l*l));if(q>ea(.100000001)){j=ea(ea(1.0)/ea(T(ea(q))));q=ea(n*j);g[c>>2]=q;n=ea(j*f);g[a>>2]=n;f=ea(j*l);g[r>>2]=f;l=ea(g[k>>2]);j=ea(l*f);p=ea(g[o>>2]);m=ea(j-ea(p*n));j=ea(p*q);p=ea(g[b>>2]);h=ea(j-ea(f*p));f=ea(ea(n*p)-ea(l*q));g[d>>2]=m;g[d+4>>2]=h;g[d+8>>2]=f;i=e;return}f=ea(g[b>>2]);if(ea(S(ea(f)))<ea(.707106769)){h=ea(-ea(g[o>>2]));s=ea(0.0);t=h;u=ea(g[k>>2])}else{s=ea(-ea(g[k>>2]));t=f;u=ea(0.0)}g[c>>2]=s;g[a>>2]=t;g[r>>2]=u;f=ea(T(ea(ea(u*u)+ea(ea(t*t)+ea(s*s)))));if(f>ea(0.0)){h=ea(ea(1.0)/f);f=ea(s*h);g[c>>2]=f;m=ea(t*h);g[a>>2]=m;q=ea(u*h);g[r>>2]=q;v=q;w=m;x=f}else{v=u;w=t;x=s}s=ea(g[k>>2]);t=ea(v*s);u=ea(g[o>>2]);f=ea(t-ea(w*u));t=ea(x*u);u=ea(g[b>>2]);m=ea(t-ea(v*u));v=ea(ea(w*u)-ea(x*s));g[d>>2]=f;g[d+4>>2]=m;g[d+8>>2]=v;i=e;return}function f1a(a,d,f,g,h,j,k,l,m,n){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;o=i;p=f-(da(n,g)|0)|0;g=c[c[j>>2]>>2]|0;j=p+d|0;if((d|0)>0)q=p;else{i=o;return}do{p=b[g+(q<<3)+4>>1]|0;d=p&65535;n=c[g+(q<<3)>>2]|0;f=a+(n<<5)|0;r=p<<16>>16==0;if(!r){p=0;while(1){s=p+n|0;t=c[a+(s<<5)>>2]|0;u=c[a+(s<<5)+4>>2]|0;v=b[a+(s<<5)+28>>1]|0;if(v<<16>>16==-1)w=65535;else{x=(da(e[t+12>>1]|0,l)|0)+(v&65535)|0;w=x+(da(e[t+14>>1]|0,m)|0)|0}x=b[a+(s<<5)+30>>1]|0;if(x<<16>>16==-1)y=65535;else{s=(da(e[u+12>>1]|0,l)|0)+(x&65535)|0;y=s+(da(e[u+14>>1]|0,m)|0)|0}s=t+28|0;t=u+28|0;if(!((c[s>>2]|0)==(w|0)?(c[t>>2]|0)==(y|0):0))z=9;if((z|0)==9){while(1){z=0;if((c[s>>2]|0)==(w|0))break;else z=9}do{}while((c[t>>2]|0)!=(y|0))}t=p+1|0;if((t|0)<(d|0))p=t;else break}co[c[k+((b[g+(q<<3)+6>>1]&65535)<<2)>>2]&2047](f,d,h);if(!r){p=0;do{t=p+n|0;s=c[a+(t<<5)>>2]|0;u=c[a+(t<<5)+4>>2]|0;if((b[s+12>>1]|0)==-1)A=65535;else A=(c[s+28>>2]|0)+1|0;t=u+28|0;if((b[u+12>>1]|0)==-1)B=65535;else B=(c[t>>2]|0)+1|0;c[s+28>>2]=A;c[t>>2]=B;p=p+1|0}while((p|0)<(d|0))}}else co[c[k+((b[g+(q<<3)+6>>1]&65535)<<2)>>2]&2047](f,d,h);q=q+1|0}while((q|0)<(j|0));i=o;return}function g1a(a,d,f,g,h,j,k,l,m,n,o,p,q){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;r=i;s=f-(da(p,g)|0)|0;g=c[c[m>>2]>>2]|0;m=s+d|0;if((d|0)>0)t=s;else{i=r;return}do{s=b[g+(t<<3)+4>>1]|0;d=s&65535;p=c[g+(t<<3)>>2]|0;f=a+(p<<5)|0;u=s<<16>>16==0;if(!u){s=0;while(1){v=s+p|0;w=c[a+(v<<5)>>2]|0;x=c[a+(v<<5)+4>>2]|0;y=b[a+(v<<5)+28>>1]|0;if(y<<16>>16==-1)z=65535;else{A=(da(e[w+12>>1]|0,n)|0)+(y&65535)|0;z=A+(da(e[w+14>>1]|0,o)|0)|0}A=b[a+(v<<5)+30>>1]|0;if(A<<16>>16==-1)B=65535;else{v=(da(e[x+12>>1]|0,n)|0)+(A&65535)|0;B=v+(da(e[x+14>>1]|0,o)|0)|0}v=w+28|0;w=x+28|0;if(!((c[v>>2]|0)==(z|0)?(c[w>>2]|0)==(B|0):0))C=9;if((C|0)==9){while(1){C=0;if((c[v>>2]|0)==(z|0))break;else C=9}do{}while((c[w>>2]|0)!=(B|0))}w=s+1|0;if((w|0)<(d|0))s=w;else break}rn[c[q+((b[g+(t<<3)+6>>1]&65535)<<2)>>2]&127](f,d,h,j,k,l);if(!u){s=0;do{w=s+p|0;v=c[a+(w<<5)>>2]|0;x=c[a+(w<<5)+4>>2]|0;if((b[v+12>>1]|0)==-1)D=65535;else D=(c[v+28>>2]|0)+1|0;w=x+28|0;if((b[x+12>>1]|0)==-1)E=65535;else E=(c[w>>2]|0)+1|0;c[v+28>>2]=D;c[w>>2]=E;s=s+1|0}while((s|0)<(d|0))}}else rn[c[q+((b[g+(t<<3)+6>>1]&65535)<<2)>>2]&127](f,d,h,j,k,l);t=t+1|0}while((t|0)<(m|0));i=r;return}function h1a(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=0,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=Im,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=0,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=Im,Ud=Im,Vd=Im,Wd=Im,Xd=Im,Yd=Im,Zd=Im,_d=0,$d=0,ae=Im,be=Im,ce=Im,de=Im,ee=Im,fe=Im,ge=Im,he=Im,ie=Im,je=Im,ke=Im,le=Im,me=Im,ne=Im,oe=Im,pe=Im,qe=Im,re=Im,se=Im,te=Im,ue=Im,ve=Im,we=Im,xe=Im,ye=0,ze=Im,Ae=0,Be=Im,Ce=0,De=Im,Ee=0,Fe=Im,Ge=Im,He=Im,Ie=Im,Je=Im,Ke=Im,Le=Im,Me=Im,Ne=Im,Oe=Im,Pe=Im,Qe=Im,Re=Im,Se=Im,Te=Im,Ue=Im,Ve=Im,We=Im,Xe=Im,Ye=Im,Ze=Im,_e=Im,$e=Im,af=Im,bf=Im,cf=Im,df=Im,ef=Im,ff=Im,gf=Im,hf=Im,jf=Im,kf=Im,lf=Im,mf=Im,nf=Im,of=Im,pf=Im,qf=Im,rf=Im,sf=Im,tf=Im,uf=Im,vf=Im,wf=Im,xf=Im,yf=Im,zf=Im,Af=Im,Bf=Im,Cf=Im,Df=Im,Ef=Im,Ff=Im,Gf=Im,Hf=Im,If=Im,Jf=Im,Kf=Im,Lf=Im,Mf=Im,Nf=Im,Of=Im,Pf=Im,Qf=Im,Rf=Im,Sf=Im,Tf=Im,Uf=Im,Vf=Im,Wf=Im,Xf=Im,Yf=Im,Zf=Im,_f=Im,$f=Im,ag=Im,bg=Im,cg=Im,dg=Im,eg=Im,fg=0,gg=Im,hg=Im,ig=Im,jg=Im,kg=Im,lg=Im,mg=Im,ng=Im,og=Im,pg=Im,qg=Im,rg=Im,sg=Im,tg=Im,ug=Im,vg=Im,wg=Im,xg=Im,yg=Im,zg=Im,Ag=Im,Bg=Im,Cg=Im,Dg=Im,Eg=Im,Fg=Im,Gg=Im,Hg=Im,Ig=Im,Jg=Im,Kg=Im,Lg=Im,Mg=Im,Ng=Im,Og=Im,Pg=Im,Qg=Im,Rg=Im,Sg=Im,Tg=Im,Ug=Im,Vg=Im,Wg=Im,Xg=Im,Yg=Im,Zg=Im,_g=Im,$g=Im,ah=Im,bh=Im,ch=Im,dh=Im,eh=Im,fh=Im,gh=Im,hh=Im,ih=Im,jh=Im,kh=Im,lh=Im,mh=Im,nh=0,oh=0,ph=0,qh=0;f=i;i=i+80|0;h=f+64|0;j=f+48|0;k=f+32|0;l=f+16|0;m=f;n=c[d>>2]|0;o=c[d+4>>2]|0;p=c[d+32>>2]|0;q=c[d+36>>2]|0;r=c[d+64>>2]|0;s=c[d+68>>2]|0;t=c[d+96>>2]|0;u=c[d+100>>2]|0;v=ea(g[n>>2]);w=ea(g[n+4>>2]);x=ea(g[n+8>>2]);y=ea(g[o>>2]);z=ea(g[o+4>>2]);A=ea(g[o+8>>2]);B=n+16|0;C=ea(g[B>>2]);D=ea(g[B+4>>2]);E=ea(g[B+8>>2]);F=o+16|0;G=ea(g[F>>2]);H=ea(g[F+4>>2]);I=ea(g[F+8>>2]);J=ea(g[p>>2]);K=ea(g[p+4>>2]);L=ea(g[p+8>>2]);M=ea(g[q>>2]);N=ea(g[q+4>>2]);O=ea(g[q+8>>2]);P=p+16|0;Q=ea(g[P>>2]);R=ea(g[P+4>>2]);S=ea(g[P+8>>2]);T=q+16|0;U=ea(g[T>>2]);V=ea(g[T+4>>2]);W=ea(g[T+8>>2]);X=ea(g[r>>2]);Y=ea(g[r+4>>2]);Z=ea(g[r+8>>2]);_=ea(g[s>>2]);$=ea(g[s+4>>2]);aa=ea(g[s+8>>2]);ba=r+16|0;ca=ea(g[ba>>2]);da=ea(g[ba+4>>2]);fa=ea(g[ba+8>>2]);ga=s+16|0;ha=ea(g[ga>>2]);ia=ea(g[ga+4>>2]);ja=ea(g[ga+8>>2]);ka=ea(g[t>>2]);la=ea(g[t+4>>2]);ma=ea(g[t+8>>2]);na=ea(g[u>>2]);oa=ea(g[u+4>>2]);pa=ea(g[u+8>>2]);qa=t+16|0;ra=ea(g[qa>>2]);sa=ea(g[qa+4>>2]);ta=ea(g[qa+8>>2]);ua=u+16|0;va=ea(g[ua>>2]);wa=ea(g[ua+4>>2]);xa=ea(g[ua+8>>2]);ya=c[d+16>>2]|0;za=b[d+26>>1]|0;d=ya+((za&65535)<<4)|0;if(!(za<<16>>16)){Aa=ka;Ba=X;Ca=J;Da=v;Ea=la;Fa=Y;Ga=K;Ha=w;Ia=ma;Ja=Z;Ka=L;La=x;Ma=na;Na=_;Oa=M;Pa=y;Qa=oa;Ra=$;Sa=N;Ta=z;Ua=pa;Va=aa;Wa=O;Xa=A;Ya=ra;Za=ca;_a=Q;$a=C;ab=sa;bb=da;cb=R;db=D;eb=ta;fb=fa;gb=S;hb=E;ib=va;jb=ha;kb=U;lb=G;mb=wa;nb=ia;ob=V;pb=H;qb=xa;rb=ja;sb=W;tb=I;g[n>>2]=Da;ub=n+4|0;g[ub>>2]=Ha;vb=n+8|0;g[vb>>2]=La;g[p>>2]=Ca;wb=p+4|0;g[wb>>2]=Ga;xb=p+8|0;g[xb>>2]=Ka;g[r>>2]=Ba;yb=r+4|0;g[yb>>2]=Fa;zb=r+8|0;g[zb>>2]=Ja;g[t>>2]=Aa;Ab=t+4|0;g[Ab>>2]=Ea;Bb=t+8|0;g[Bb>>2]=Ia;g[o>>2]=Pa;Cb=o+4|0;g[Cb>>2]=Ta;Db=o+8|0;g[Db>>2]=Xa;g[q>>2]=Oa;Eb=q+4|0;g[Eb>>2]=Sa;Fb=q+8|0;g[Fb>>2]=Wa;g[s>>2]=Na;Gb=s+4|0;g[Gb>>2]=Ra;Hb=s+8|0;g[Hb>>2]=Va;g[u>>2]=Ma;Ib=u+4|0;g[Ib>>2]=Qa;Jb=u+8|0;g[Jb>>2]=Ua;g[B>>2]=$a;Kb=n+20|0;g[Kb>>2]=db;Lb=n+24|0;g[Lb>>2]=hb;g[P>>2]=_a;Mb=p+20|0;g[Mb>>2]=cb;Nb=p+24|0;g[Nb>>2]=gb;g[ba>>2]=Za;Ob=r+20|0;g[Ob>>2]=bb;Pb=r+24|0;g[Pb>>2]=fb;g[qa>>2]=Ya;Qb=t+20|0;g[Qb>>2]=ab;Rb=t+24|0;g[Rb>>2]=eb;g[F>>2]=lb;Sb=o+20|0;g[Sb>>2]=pb;Tb=o+24|0;g[Tb>>2]=tb;g[T>>2]=kb;Ub=q+20|0;g[Ub>>2]=ob;Vb=q+24|0;g[Vb>>2]=sb;g[ga>>2]=jb;Wb=s+20|0;g[Wb>>2]=nb;Xb=s+24|0;g[Xb>>2]=rb;g[ua>>2]=ib;Yb=u+20|0;g[Yb>>2]=mb;Zb=u+24|0;g[Zb>>2]=qb;i=f;return}za=e+1|0;za=j+4|0;_b=j+8|0;$b=j+12|0;ac=h+4|0;bc=h+8|0;cc=h+12|0;dc=l+4|0;ec=l+8|0;fc=l+12|0;gc=I;I=W;W=ja;ja=xa;xa=H;H=V;V=ia;ia=wa;wa=G;G=U;U=ha;ha=va;va=E;E=S;S=fa;fa=ta;ta=D;D=R;R=da;da=sa;sa=C;C=Q;Q=ca;ca=ra;ra=oa;oa=$;$=N;N=z;z=la;la=Y;Y=K;K=w;w=na;na=_;_=M;M=y;y=ka;ka=X;X=J;J=v;v=pa;pa=aa;aa=O;O=A;A=ma;ma=Z;Z=L;L=x;hc=ya;ic=ya+416|0;while(1){ya=hc+144|0;jc=a[hc+1>>0]|0;kc=jc&255;lc=a[hc+2>>0]|0;mc=lc&255;nc=ya+(kc*272|0)|0;x=ea(g[hc+64>>2]);oc=ea(g[hc+68>>2]);pc=ea(g[hc+72>>2]);qc=ea(g[hc+76>>2]);rc=ea(g[hc+80>>2]);sc=ea(g[hc+84>>2]);tc=ea(g[hc+88>>2]);uc=ea(g[hc+92>>2]);vc=ea(g[hc+96>>2]);wc=ea(g[hc+100>>2]);xc=ea(g[hc+104>>2]);yc=ea(g[hc+108>>2]);zc=ea(g[hc+112>>2]);Ac=ea(g[hc+116>>2]);Bc=ea(g[hc+120>>2]);Cc=ea(g[hc+124>>2]);Dc=ea(g[hc+128>>2]);Ec=ea(g[hc+132>>2]);Fc=ea(g[hc+136>>2]);Gc=ea(g[hc+140>>2]);if(!(jc<<24>>24)){Hc=ca;Ic=Q;Jc=C;Kc=sa;Lc=da;Mc=R;Nc=D;Oc=ta;Pc=fa;Qc=S;Rc=E;Sc=va;Tc=ha;Uc=U;Vc=G;Wc=wa;Xc=ia;Yc=V;Zc=H;_c=xa;$c=ja;ad=W;bd=I;cd=gc;dd=ea(0.0);ed=ea(0.0);fd=ea(0.0);gd=ea(0.0);hd=ea(0.0);id=ea(0.0);jd=ea(0.0);kd=ea(0.0);ld=ic}else{jc=kc*384|0;md=sa;nd=C;od=Q;pd=ca;qd=wa;rd=G;sd=U;td=ha;ud=ta;vd=D;wd=R;xd=da;yd=xa;zd=H;Ad=V;Bd=ia;Cd=va;Dd=E;Ed=S;Fd=fa;Gd=gc;Hd=I;Id=W;Jd=ja;Kd=ea(ea(ea(J*vc)+ea(K*zc))+ea(L*Dc));Ld=ea(ea(ea(X*wc)+ea(Y*Ac))+ea(Z*Ec));Md=ea(ea(ea(ka*xc)+ea(la*Bc))+ea(ma*Fc));Nd=ea(ea(ea(y*yc)+ea(z*Cc))+ea(A*Gc));Od=ea(ea(ea(M*vc)+ea(N*zc))+ea(O*Dc));Pd=ea(ea(ea(_*wc)+ea($*Ac))+ea(aa*Ec));Qd=ea(ea(ea(na*xc)+ea(oa*Bc))+ea(pa*Fc));Rd=ea(ea(ea(w*yc)+ea(ra*Cc))+ea(v*Gc));Sd=ea(0.0);Td=ea(0.0);Ud=ea(0.0);Vd=ea(0.0);Wd=ea(0.0);Xd=ea(0.0);Yd=ea(0.0);Zd=ea(0.0);_d=0;$d=ic;while(1){ae=ea(g[ya+(_d*272|0)+48>>2]);be=ea(g[ya+(_d*272|0)+52>>2]);ce=ea(g[ya+(_d*272|0)+56>>2]);de=ea(g[ya+(_d*272|0)+60>>2]);ee=ea(g[ya+(_d*272|0)+64>>2]);fe=ea(g[ya+(_d*272|0)+68>>2]);ge=ea(g[ya+(_d*272|0)+72>>2]);he=ea(g[ya+(_d*272|0)+76>>2]);ie=ea(g[ya+(_d*272|0)+80>>2]);je=ea(g[ya+(_d*272|0)+84>>2]);ke=ea(g[ya+(_d*272|0)+88>>2]);le=ea(g[ya+(_d*272|0)+92>>2]);me=ea(g[ya+(_d*272|0)+224>>2]);ne=ea(g[ya+(_d*272|0)+228>>2]);oe=ea(g[ya+(_d*272|0)+232>>2]);pe=ea(g[ya+(_d*272|0)+236>>2]);qe=ea(g[ya+(_d*272|0)+240>>2]);re=ea(g[ya+(_d*272|0)+244>>2]);se=ea(g[ya+(_d*272|0)+248>>2]);te=ea(g[ya+(_d*272|0)+252>>2]);ue=ea(g[ya+(_d*272|0)+256>>2]);ve=ea(g[ya+(_d*272|0)+260>>2]);we=ea(g[ya+(_d*272|0)+264>>2]);xe=ea(g[ya+(_d*272|0)+268>>2]);ye=ya+(_d*272|0)+112|0;ze=ea(g[ye>>2]);Ae=ya+(_d*272|0)+116|0;Be=ea(g[Ae>>2]);Ce=ya+(_d*272|0)+120|0;De=ea(g[Ce>>2]);Ee=ya+(_d*272|0)+124|0;Fe=ea(g[Ee>>2]);Ge=ea(g[ya+(_d*272|0)+96>>2]);He=ea(g[ya+(_d*272|0)+100>>2]);Ie=ea(g[ya+(_d*272|0)+104>>2]);Je=ea(g[ya+(_d*272|0)+108>>2]);Ke=ea(g[ya+(_d*272|0)+160>>2]);Le=ea(g[ya+(_d*272|0)+164>>2]);Me=ea(g[ya+(_d*272|0)+168>>2]);Ne=ea(g[ya+(_d*272|0)+172>>2]);Oe=ea(g[ya+(_d*272|0)>>2]);Pe=ea(g[ya+(_d*272|0)+4>>2]);Qe=ea(g[ya+(_d*272|0)+8>>2]);Re=ea(g[ya+(_d*272|0)+12>>2]);Se=ea(g[ya+(_d*272|0)+16>>2]);Te=ea(g[ya+(_d*272|0)+20>>2]);Ue=ea(g[ya+(_d*272|0)+24>>2]);Ve=ea(g[ya+(_d*272|0)+28>>2]);We=ea(g[ya+(_d*272|0)+32>>2]);Xe=ea(g[ya+(_d*272|0)+36>>2]);Ye=ea(g[ya+(_d*272|0)+40>>2]);Ze=ea(g[ya+(_d*272|0)+44>>2]);_e=ea(g[ya+(_d*272|0)+176>>2]);$e=ea(g[ya+(_d*272|0)+180>>2]);af=ea(g[ya+(_d*272|0)+184>>2]);bf=ea(g[ya+(_d*272|0)+188>>2]);cf=ea(g[ya+(_d*272|0)+192>>2]);df=ea(g[ya+(_d*272|0)+196>>2]);ef=ea(g[ya+(_d*272|0)+200>>2]);ff=ea(g[ya+(_d*272|0)+204>>2]);gf=ea(g[ya+(_d*272|0)+208>>2]);hf=ea(g[ya+(_d*272|0)+212>>2]);jf=ea(g[ya+(_d*272|0)+216>>2]);kf=ea(ea(ea(md*Oe)+ea(ud*Se))+ea(Cd*We));We=ea(ea(ea(nd*Pe)+ea(vd*Te))+ea(Dd*Xe));Xe=ea(ea(ea(od*Qe)+ea(wd*Ue))+ea(Ed*Ye));Ye=ea(ea(ea(pd*Re)+ea(xd*Ve))+ea(Fd*Ze));Ze=ea(ea(ea(qd*_e)+ea(yd*cf))+ea(Gd*gf));gf=ea(ea(ea(rd*$e)+ea(zd*df))+ea(Hd*hf));hf=ea(ea(ea(sd*af)+ea(Ad*ef))+ea(Id*jf));jf=ea(ea(ea(td*bf)+ea(Bd*ff))+ea(Jd*ea(g[ya+(_d*272|0)+220>>2])));ff=ea(g[ya+(_d*272|0)+144>>2]);bf=ea(g[ya+(_d*272|0)+148>>2]);ef=ea(g[ya+(_d*272|0)+152>>2]);af=ea(ff-ea(Ge*ea(ea(Kd+kf)-ea(Od+Ze))));Ze=ea(bf-ea(He*ea(ea(Ld+We)-ea(Pd+gf))));gf=ea(ef-ea(Ie*ea(ea(Md+Xe)-ea(Qd+hf))));hf=ea(ea(g[ya+(_d*272|0)+156>>2])-ea(Je*ea(ea(Nd+Ye)-ea(Rd+jf))));jf=ea(-ze);Ye=ea(-Be);Je=ea(-De);Xe=ea(-Fe);Ie=ea(ze+(af>jf?af:jf));jf=ea(Be+(Ze>Ye?Ze:Ye));Ye=ea(De+(gf>Je?gf:Je));Je=ea(Fe+(hf>Xe?hf:Xe));Xe=Ie<Ke?Ie:Ke;Ke=jf<Le?jf:Le;Le=Ye<Me?Ye:Me;Me=Je<Ne?Je:Ne;Ne=ea(Xe-ze);ze=ea(Ke-Be);Be=ea(Le-De);De=ea(Me-Fe);Sd=ea(Sd+Ne);Td=ea(Td+ze);Ud=ea(Ud+Be);Vd=ea(Vd+De);Kd=ea(Kd+ea(x*Ne));Ld=ea(Ld+ea(oc*ze));Md=ea(Md+ea(pc*Be));Nd=ea(Nd+ea(qc*De));Od=ea(Od+ea(rc*Ne));Pd=ea(Pd+ea(sc*ze));Qd=ea(Qd+ea(tc*Be));Rd=ea(Rd+ea(uc*De));md=ea(md+ea(ae*Ne));nd=ea(nd+ea(be*ze));od=ea(od+ea(ce*Be));pd=ea(pd+ea(de*De));qd=ea(qd+ea(me*Ne));rd=ea(rd+ea(ne*ze));sd=ea(sd+ea(oe*Be));td=ea(td+ea(pe*De));ud=ea(ud+ea(ee*Ne));vd=ea(vd+ea(fe*ze));wd=ea(wd+ea(ge*Be));xd=ea(xd+ea(he*De));yd=ea(yd+ea(qe*Ne));zd=ea(zd+ea(re*ze));Ad=ea(Ad+ea(se*Be));Bd=ea(Bd+ea(te*De));Cd=ea(Cd+ea(ie*Ne));Dd=ea(Dd+ea(je*ze));Ed=ea(Ed+ea(ke*Be));Fd=ea(Fd+ea(le*De));Gd=ea(Gd+ea(ue*Ne));Hd=ea(Hd+ea(ve*ze));Id=ea(Id+ea(we*Be));Jd=ea(Jd+ea(xe*De));g[ye>>2]=Xe;g[Ae>>2]=Ke;g[Ce>>2]=Le;g[Ee>>2]=Me;Wd=ea(Wd+Xe);Xd=ea(Xd+Ke);Yd=ea(Yd+Le);Zd=ea(Zd+Me);_d=_d+1|0;if((_d|0)==(kc|0))break;else $d=$d+384|0}Hc=pd;Ic=od;Jc=nd;Kc=md;Lc=xd;Mc=wd;Nc=vd;Oc=ud;Pc=Fd;Qc=Ed;Rc=Dd;Sc=Cd;Tc=td;Uc=sd;Vc=rd;Wc=qd;Xc=Bd;Yc=Ad;Zc=zd;_c=yd;$c=Jd;ad=Id;bd=Hd;cd=Gd;dd=Zd;ed=Yd;fd=Xd;gd=Wd;hd=Vd;id=Ud;jd=Td;kd=Sd;ld=ic+jc|0}Rd=ea(x*kd);Qd=ea(oc*jd);Pd=ea(pc*id);Od=ea(qc*hd);Nd=ea(rc*kd);Md=ea(sc*jd);Ld=ea(tc*id);Kd=ea(uc*hd);Me=ea(J+ea(vc*Rd));Le=ea(X+ea(wc*Qd));Ke=ea(ka+ea(xc*Pd));Xe=ea(y+ea(yc*Od));De=ea(M+ea(vc*Nd));xe=ea(_+ea(wc*Md));Be=ea(na+ea(xc*Ld));we=ea(w+ea(yc*Kd));ze=ea(K+ea(zc*Rd));ve=ea(Y+ea(Ac*Qd));Ne=ea(la+ea(Bc*Pd));ue=ea(z+ea(Cc*Od));le=ea(N+ea(zc*Nd));ke=ea($+ea(Ac*Md));je=ea(oa+ea(Bc*Ld));ie=ea(ra+ea(Cc*Kd));te=ea(L+ea(Dc*Rd));Rd=ea(Z+ea(Ec*Qd));Qd=ea(ma+ea(Fc*Pd));Pd=ea(A+ea(Gc*Od));Od=ea(O+ea(Dc*Nd));Nd=ea(aa+ea(Ec*Md));Md=ea(pa+ea(Fc*Ld));Ld=ea(v+ea(Gc*Kd));if((a[e>>0]|0)==0|lc<<24>>24==0){lf=Xe;mf=Ke;nf=Le;of=Me;pf=ue;qf=Ne;rf=ve;sf=ze;tf=Pd;uf=Qd;vf=Rd;wf=te;xf=we;yf=Be;zf=xe;Af=De;Bf=ie;Cf=je;Df=ke;Ef=le;Ff=Ld;Gf=Md;Hf=Nd;If=Od;Jf=Hc;Kf=Ic;Lf=Jc;Mf=Kc;Nf=Lc;Of=Mc;Pf=Nc;Qf=Oc;Rf=Pc;Sf=Qc;Tf=Rc;Uf=Sc;Vf=Tc;Wf=Uc;Xf=Vc;Yf=Wc;Zf=Xc;_f=Yc;$f=Zc;ag=_c;bg=$c;cg=ad;dg=bd;eg=cd;fg=ld}else{Kd=ea(g[hc+32>>2]);se=ea(g[hc+36>>2]);re=ea(g[hc+40>>2]);qe=ea(g[hc+44>>2]);he=ea(g[hc+48>>2]);ge=ea(g[hc+52>>2]);fe=ea(g[hc+56>>2]);ee=ea(gd*Kd);Kd=ea(fd*se);se=ea(ed*re);re=ea(dd*qe);qe=ea(gd*he);he=ea(fd*ge);ge=ea(ed*fe);fe=ea(dd*ea(g[hc+60>>2]));pe=ea(-qe);oe=ea(-he);ne=ea(-ge);me=ea(-fe);$d=mc*384|0;de=Me;Me=Le;Le=Ke;Ke=Xe;Xe=Kc;ce=Jc;be=Ic;ae=Hc;Fe=De;De=xe;xe=Be;Be=we;we=Wc;Je=Vc;Ye=Uc;jf=Tc;Ie=ze;ze=ve;ve=Ne;Ne=ue;ue=Oc;hf=Nc;gf=Mc;Ze=Lc;af=le;le=ke;ke=je;je=ie;ie=_c;ef=Zc;We=Yc;He=Xc;bf=te;te=Rd;Rd=Qd;Qd=Pd;Pd=Sc;kf=Rc;Ge=Qc;ff=Pc;df=Od;Od=Nd;Nd=Md;Md=Ld;Ld=cd;$e=bd;cf=ad;_e=$c;kc=0;_d=ld;while(1){Ve=ea(g[nc+(kc*336|0)+112>>2]);Re=ea(g[nc+(kc*336|0)+116>>2]);Ue=ea(g[nc+(kc*336|0)+120>>2]);Qe=ea(g[nc+(kc*336|0)+124>>2]);Te=ea(g[nc+(kc*336|0)+128>>2]);Pe=ea(g[nc+(kc*336|0)+132>>2]);Se=ea(g[nc+(kc*336|0)+136>>2]);Oe=ea(g[nc+(kc*336|0)+140>>2]);gg=ea(g[nc+(kc*336|0)+144>>2]);hg=ea(g[nc+(kc*336|0)+148>>2]);ig=ea(g[nc+(kc*336|0)+152>>2]);jg=ea(g[nc+(kc*336|0)+156>>2]);kg=ea(g[nc+(kc*336|0)+288>>2]);lg=ea(g[nc+(kc*336|0)+292>>2]);mg=ea(g[nc+(kc*336|0)+296>>2]);ng=ea(g[nc+(kc*336|0)+300>>2]);og=ea(g[nc+(kc*336|0)+304>>2]);pg=ea(g[nc+(kc*336|0)+308>>2]);qg=ea(g[nc+(kc*336|0)+312>>2]);rg=ea(g[nc+(kc*336|0)+316>>2]);sg=ea(g[nc+(kc*336|0)+320>>2]);tg=ea(g[nc+(kc*336|0)+324>>2]);ug=ea(g[nc+(kc*336|0)+328>>2]);vg=ea(g[nc+(kc*336|0)+332>>2]);ya=nc+(kc*336|0)+48|0;wg=ea(g[ya>>2]);Ee=nc+(kc*336|0)+52|0;xg=ea(g[Ee>>2]);Ce=nc+(kc*336|0)+56|0;yg=ea(g[Ce>>2]);Ae=nc+(kc*336|0)+60|0;zg=ea(g[Ae>>2]);Ag=ea(g[nc+(kc*336|0)+208>>2]);Bg=ea(g[nc+(kc*336|0)+212>>2]);Cg=ea(g[nc+(kc*336|0)+216>>2]);Dg=ea(g[nc+(kc*336|0)+220>>2]);Eg=ea(g[nc+(kc*336|0)>>2]);Fg=ea(g[nc+(kc*336|0)+4>>2]);Gg=ea(g[nc+(kc*336|0)+8>>2]);Hg=ea(g[nc+(kc*336|0)+12>>2]);Ig=ea(g[nc+(kc*336|0)+16>>2]);Jg=ea(g[nc+(kc*336|0)+20>>2]);Kg=ea(g[nc+(kc*336|0)+24>>2]);Lg=ea(g[nc+(kc*336|0)+28>>2]);Mg=ea(g[nc+(kc*336|0)+32>>2]);Ng=ea(g[nc+(kc*336|0)+36>>2]);Og=ea(g[nc+(kc*336|0)+40>>2]);Pg=ea(g[nc+(kc*336|0)+44>>2]);Qg=ea(g[nc+(kc*336|0)+64>>2]);Rg=ea(g[nc+(kc*336|0)+68>>2]);Sg=ea(g[nc+(kc*336|0)+72>>2]);Tg=ea(g[nc+(kc*336|0)+76>>2]);Ug=ea(g[nc+(kc*336|0)+80>>2]);Vg=ea(g[nc+(kc*336|0)+84>>2]);Wg=ea(g[nc+(kc*336|0)+88>>2]);Xg=ea(g[nc+(kc*336|0)+92>>2]);Yg=ea(g[nc+(kc*336|0)+96>>2]);Zg=ea(g[nc+(kc*336|0)+100>>2]);_g=ea(g[nc+(kc*336|0)+104>>2]);$g=ea(g[nc+(kc*336|0)+108>>2]);ah=ea(g[nc+(kc*336|0)+240>>2]);bh=ea(g[nc+(kc*336|0)+244>>2]);ch=ea(g[nc+(kc*336|0)+248>>2]);dh=ea(g[nc+(kc*336|0)+252>>2]);eh=ea(g[nc+(kc*336|0)+256>>2]);fh=ea(g[nc+(kc*336|0)+260>>2]);gh=ea(g[nc+(kc*336|0)+264>>2]);hh=ea(g[nc+(kc*336|0)+268>>2]);ih=ea(g[nc+(kc*336|0)+272>>2]);jh=ea(g[nc+(kc*336|0)+276>>2]);kh=ea(g[nc+(kc*336|0)+280>>2]);lh=ea(g[nc+(kc*336|0)+284>>2]);ye=nc+(kc*336|0)+176|0;c[m+0>>2]=c[ye+0>>2];c[m+4>>2]=c[ye+4>>2];c[m+8>>2]=c[ye+8>>2];c[m+12>>2]=c[ye+12>>2];mh=ea(ea(ea(ea(ea(de*Eg)+ea(Ie*Ig))+ea(bf*Mg))+ea(ea(ea(Xe*Qg)+ea(ue*Ug))+ea(Pd*Yg)))-ea(ea(ea(ea(Fe*Eg)+ea(af*Ig))+ea(df*Mg))+ea(ea(ea(we*ah)+ea(ie*eh))+ea(Ld*ih))));ih=ea(ea(ea(ea(ea(Me*Fg)+ea(ze*Jg))+ea(te*Ng))+ea(ea(ea(ce*Rg)+ea(hf*Vg))+ea(kf*Zg)))-ea(ea(ea(ea(De*Fg)+ea(le*Jg))+ea(Od*Ng))+ea(ea(ea(Je*bh)+ea(ef*fh))+ea($e*jh))));jh=ea(ea(ea(ea(ea(Le*Gg)+ea(ve*Kg))+ea(Rd*Og))+ea(ea(ea(be*Sg)+ea(gf*Wg))+ea(Ge*_g)))-ea(ea(ea(ea(xe*Gg)+ea(ke*Kg))+ea(Nd*Og))+ea(ea(ea(Ye*ch)+ea(We*gh))+ea(cf*kh))));kh=ea(ea(ea(ea(ea(Ke*Hg)+ea(Ne*Lg))+ea(Qd*Pg))+ea(ea(ea(ae*Tg)+ea(Ze*Xg))+ea(ff*$g)))-ea(ea(ea(ea(Be*Hg)+ea(je*Lg))+ea(Md*Pg))+ea(ea(ea(jf*dh)+ea(He*hh))+ea(_e*lh))));lh=ea(g[nc+(kc*336|0)+160>>2]);hh=ea(g[nc+(kc*336|0)+164>>2]);dh=ea(g[nc+(kc*336|0)+168>>2]);$g=ea(ea(wg-lh)-ea(Ag*mh));mh=ea(ea(xg-hh)-ea(Bg*ih));ih=ea(ea(yg-dh)-ea(Cg*jh));jh=ea(ea(zg-ea(g[nc+(kc*336|0)+172>>2]))-ea(Dg*kh));kh=ea(-$g);Dg=ea(-mh);Cg=ea(-ih);dh=ea(-jh);nh=($g>kh?$g:kh)>ee;oh=(mh>Dg?mh:Dg)>Kd;ph=(ih>Cg?ih:Cg)>se;qh=(jh>dh?jh:dh)>re;dh=$g<pe?pe:$g;Cg=mh<oe?oe:mh;Dg=ih<ne?ne:ih;kh=jh<me?me:jh;g[j>>2]=qe<dh?qe:dh;g[za>>2]=he<Cg?he:Cg;g[_b>>2]=ge<Dg?ge:Dg;g[$b>>2]=fe<kh?fe:kh;g[h>>2]=$g;g[ac>>2]=mh;g[bc>>2]=ih;g[cc>>2]=jh;jh=ea(g[(nh?j:h)>>2]);ih=ea(g[(oh?j:h)+4>>2]);mh=ea(g[(ph?j:h)+8>>2]);$g=ea(g[(qh?j:h)+12>>2]);c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];g[l>>2]=ea(1.0);g[dc>>2]=ea(1.0);g[ec>>2]=ea(1.0);g[fc>>2]=ea(1.0);kh=ea(g[(nh?l:k)>>2]);Dg=ea(g[(oh?l:k)+4>>2]);Cg=ea(g[(ph?l:k)+8>>2]);dh=ea(g[(qh?l:k)+12>>2]);Bg=ea(jh-wg);wg=ea(ih-xg);xg=ea(mh-yg);yg=ea($g-zg);g[ya>>2]=jh;g[Ee>>2]=ih;g[Ce>>2]=mh;g[Ae>>2]=$g;g[ye>>2]=kh;g[nc+(kc*336|0)+180>>2]=Dg;g[nc+(kc*336|0)+184>>2]=Cg;g[nc+(kc*336|0)+188>>2]=dh;dh=ea(x*Bg);Cg=ea(oc*wg);Dg=ea(pc*xg);kh=ea(qc*yg);$g=ea(rc*Bg);mh=ea(sc*wg);ih=ea(tc*xg);jh=ea(uc*yg);de=ea(de+ea(Eg*dh));Me=ea(Me+ea(Fg*Cg));Le=ea(Le+ea(Gg*Dg));Ke=ea(Ke+ea(Hg*kh));Fe=ea(Fe+ea(Eg*$g));De=ea(De+ea(Fg*mh));xe=ea(xe+ea(Gg*ih));Be=ea(Be+ea(Hg*jh));Xe=ea(Xe+ea(Ve*Bg));ce=ea(ce+ea(Re*wg));be=ea(be+ea(Ue*xg));ae=ea(ae+ea(Qe*yg));we=ea(we+ea(kg*Bg));Je=ea(Je+ea(lg*wg));Ye=ea(Ye+ea(mg*xg));jf=ea(jf+ea(ng*yg));Ie=ea(Ie+ea(Ig*dh));ze=ea(ze+ea(Jg*Cg));ve=ea(ve+ea(Kg*Dg));Ne=ea(Ne+ea(Lg*kh));af=ea(af+ea(Ig*$g));le=ea(le+ea(Jg*mh));ke=ea(ke+ea(Kg*ih));je=ea(je+ea(Lg*jh));ue=ea(ue+ea(Te*Bg));hf=ea(hf+ea(Pe*wg));gf=ea(gf+ea(Se*xg));Ze=ea(Ze+ea(Oe*yg));ie=ea(ie+ea(og*Bg));ef=ea(ef+ea(pg*wg));We=ea(We+ea(qg*xg));He=ea(He+ea(rg*yg));bf=ea(bf+ea(Mg*dh));te=ea(te+ea(Ng*Cg));Rd=ea(Rd+ea(Og*Dg));Qd=ea(Qd+ea(Pg*kh));df=ea(df+ea(Mg*$g));Od=ea(Od+ea(Ng*mh));Nd=ea(Nd+ea(Og*ih));Md=ea(Md+ea(Pg*jh));Pd=ea(Pd+ea(gg*Bg));kf=ea(kf+ea(hg*wg));Ge=ea(Ge+ea(ig*xg));ff=ea(ff+ea(jg*yg));Ld=ea(Ld+ea(sg*Bg));$e=ea($e+ea(tg*wg));cf=ea(cf+ea(ug*xg));_e=ea(_e+ea(vg*yg));ye=kc+1|0;if((ye|0)==(mc|0))break;else{kc=ye;_d=_d+384|0}}lf=Ke;mf=Le;nf=Me;of=de;pf=Ne;qf=ve;rf=ze;sf=Ie;tf=Qd;uf=Rd;vf=te;wf=bf;xf=Be;yf=xe;zf=De;Af=Fe;Bf=je;Cf=ke;Df=le;Ef=af;Ff=Md;Gf=Nd;Hf=Od;If=df;Jf=ae;Kf=be;Lf=ce;Mf=Xe;Nf=Ze;Of=gf;Pf=hf;Qf=ue;Rf=ff;Sf=Ge;Tf=kf;Uf=Pd;Vf=jf;Wf=Ye;Xf=Je;Yf=we;Zf=He;_f=We;$f=ef;ag=ie;bg=_e;cg=cf;dg=$e;eg=Ld;fg=ld+$d|0}hc=nc+(mc*336|0)|0;if(hc>>>0>=d>>>0){Aa=lf;Ba=mf;Ca=nf;Da=of;Ea=pf;Fa=qf;Ga=rf;Ha=sf;Ia=tf;Ja=uf;Ka=vf;La=wf;Ma=xf;Na=yf;Oa=zf;Pa=Af;Qa=Bf;Ra=Cf;Sa=Df;Ta=Ef;Ua=Ff;Va=Gf;Wa=Hf;Xa=If;Ya=Jf;Za=Kf;_a=Lf;$a=Mf;ab=Nf;bb=Of;cb=Pf;db=Qf;eb=Rf;fb=Sf;gb=Tf;hb=Uf;ib=Vf;jb=Wf;kb=Xf;lb=Yf;mb=Zf;nb=_f;ob=$f;pb=ag;qb=bg;rb=cg;sb=dg;tb=eg;break}else{gc=eg;I=dg;W=cg;ja=bg;xa=ag;H=$f;V=_f;ia=Zf;wa=Yf;G=Xf;U=Wf;ha=Vf;va=Uf;E=Tf;S=Sf;fa=Rf;ta=Qf;D=Pf;R=Of;da=Nf;sa=Mf;C=Lf;Q=Kf;ca=Jf;ra=Bf;oa=Cf;$=Df;N=Ef;z=pf;la=qf;Y=rf;K=sf;w=xf;na=yf;_=zf;M=Af;y=lf;ka=mf;X=nf;J=of;v=Ff;pa=Gf;aa=Hf;O=If;A=tf;ma=uf;Z=vf;L=wf;ic=fg}}g[n>>2]=Da;ub=n+4|0;g[ub>>2]=Ha;vb=n+8|0;g[vb>>2]=La;g[p>>2]=Ca;wb=p+4|0;g[wb>>2]=Ga;xb=p+8|0;g[xb>>2]=Ka;g[r>>2]=Ba;yb=r+4|0;g[yb>>2]=Fa;zb=r+8|0;g[zb>>2]=Ja;g[t>>2]=Aa;Ab=t+4|0;g[Ab>>2]=Ea;Bb=t+8|0;g[Bb>>2]=Ia;g[o>>2]=Pa;Cb=o+4|0;g[Cb>>2]=Ta;Db=o+8|0;g[Db>>2]=Xa;g[q>>2]=Oa;Eb=q+4|0;g[Eb>>2]=Sa;Fb=q+8|0;g[Fb>>2]=Wa;g[s>>2]=Na;Gb=s+4|0;g[Gb>>2]=Ra;Hb=s+8|0;g[Hb>>2]=Va;g[u>>2]=Ma;Ib=u+4|0;g[Ib>>2]=Qa;Jb=u+8|0;g[Jb>>2]=Ua;g[B>>2]=$a;Kb=n+20|0;g[Kb>>2]=db;Lb=n+24|0;g[Lb>>2]=hb;g[P>>2]=_a;Mb=p+20|0;g[Mb>>2]=cb;Nb=p+24|0;g[Nb>>2]=gb;g[ba>>2]=Za;Ob=r+20|0;g[Ob>>2]=bb;Pb=r+24|0;g[Pb>>2]=fb;g[qa>>2]=Ya;Qb=t+20|0;g[Qb>>2]=ab;Rb=t+24|0;g[Rb>>2]=eb;g[F>>2]=lb;Sb=o+20|0;g[Sb>>2]=pb;Tb=o+24|0;g[Tb>>2]=tb;g[T>>2]=kb;Ub=q+20|0;g[Ub>>2]=ob;Vb=q+24|0;g[Vb>>2]=sb;g[ga>>2]=jb;Wb=s+20|0;g[Wb>>2]=nb;Xb=s+24|0;g[Xb>>2]=rb;g[ua>>2]=ib;Yb=u+20|0;g[Yb>>2]=mb;Zb=u+24|0;g[Zb>>2]=qb;i=f;return}function i1a(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=Im,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=0,dc=0,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=0,rc=Im,sc=0,tc=Im,uc=0,vc=Im,wc=0,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=0,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=Im,Ud=Im,Vd=Im,Wd=Im,Xd=Im,Yd=Im,Zd=Im,_d=Im,$d=Im,ae=Im,be=Im,ce=0,de=0,ee=0,fe=0;f=i;i=i+80|0;h=f+64|0;j=f+48|0;k=f+32|0;l=f+16|0;m=f;n=c[d>>2]|0;o=c[d+32>>2]|0;p=c[d+64>>2]|0;q=c[d+96>>2]|0;r=c[d+16>>2]|0;s=b[d+26>>1]|0;d=r+((s&65535)<<4)|0;t=ea(g[n>>2]);u=ea(g[n+4>>2]);v=ea(g[n+8>>2]);w=n+16|0;x=ea(g[w>>2]);y=ea(g[w+4>>2]);z=ea(g[w+8>>2]);A=ea(g[o>>2]);B=ea(g[o+4>>2]);C=ea(g[o+8>>2]);D=o+16|0;E=ea(g[D>>2]);F=ea(g[D+4>>2]);G=ea(g[D+8>>2]);H=ea(g[p>>2]);I=ea(g[p+4>>2]);J=ea(g[p+8>>2]);K=p+16|0;L=ea(g[K>>2]);M=ea(g[K+4>>2]);N=ea(g[K+8>>2]);O=ea(g[q>>2]);P=ea(g[q+4>>2]);Q=ea(g[q+8>>2]);R=q+16|0;S=ea(g[R>>2]);T=ea(g[R+4>>2]);U=ea(g[R+8>>2]);if(!(s<<16>>16)){V=O;W=H;X=A;Y=t;Z=P;_=I;$=B;aa=u;ba=Q;ca=J;da=C;fa=v;ga=S;ha=L;ia=E;ja=x;ka=T;la=M;ma=F;na=y;oa=U;pa=N;qa=G;ra=z;g[n>>2]=Y;sa=n+4|0;g[sa>>2]=aa;ta=n+8|0;g[ta>>2]=fa;g[o>>2]=X;ua=o+4|0;g[ua>>2]=$;va=o+8|0;g[va>>2]=da;g[p>>2]=W;wa=p+4|0;g[wa>>2]=_;xa=p+8|0;g[xa>>2]=ca;g[q>>2]=V;ya=q+4|0;g[ya>>2]=Z;za=q+8|0;g[za>>2]=ba;g[w>>2]=ja;Aa=n+20|0;g[Aa>>2]=na;Ba=n+24|0;g[Ba>>2]=ra;g[D>>2]=ia;Ca=o+20|0;g[Ca>>2]=ma;Da=o+24|0;g[Da>>2]=qa;g[K>>2]=ha;Ea=p+20|0;g[Ea>>2]=la;Fa=p+24|0;g[Fa>>2]=pa;g[R>>2]=ga;Ga=q+20|0;g[Ga>>2]=ka;Ha=q+24|0;g[Ha>>2]=oa;i=f;return}s=e+1|0;s=j+4|0;Ia=j+8|0;Ja=j+12|0;Ka=h+4|0;La=h+8|0;Ma=h+12|0;Na=l+4|0;Oa=l+8|0;Pa=l+12|0;Qa=P;P=I;I=B;B=u;u=O;O=H;H=A;A=t;t=Q;Q=J;J=C;C=v;v=z;z=G;G=N;N=U;U=y;y=F;F=M;M=T;T=x;x=E;E=L;L=S;Ra=r;Sa=r+320|0;while(1){r=Ra+144|0;Ta=a[Ra+1>>0]|0;Ua=Ta&255;Va=a[Ra+2>>0]|0;Wa=Va&255;Xa=r+(Ua*176|0)|0;S=ea(g[Ra+64>>2]);Ya=ea(g[Ra+68>>2]);Za=ea(g[Ra+72>>2]);_a=ea(g[Ra+76>>2]);$a=ea(g[Ra+96>>2]);ab=ea(g[Ra+100>>2]);bb=ea(g[Ra+104>>2]);cb=ea(g[Ra+108>>2]);db=ea(g[Ra+112>>2]);eb=ea(g[Ra+116>>2]);fb=ea(g[Ra+120>>2]);gb=ea(g[Ra+124>>2]);hb=ea(g[Ra+128>>2]);ib=ea(g[Ra+132>>2]);jb=ea(g[Ra+136>>2]);kb=ea(g[Ra+140>>2]);if(!(Ta<<24>>24)){lb=L;mb=E;nb=x;ob=T;pb=M;qb=F;rb=y;sb=U;tb=N;ub=G;vb=z;wb=v;xb=ea(0.0);yb=ea(0.0);zb=ea(0.0);Ab=ea(0.0);Bb=ea(0.0);Cb=ea(0.0);Db=ea(0.0);Eb=ea(0.0);Fb=Sa}else{Ta=Ua<<8;Gb=T;Hb=x;Ib=E;Jb=L;Kb=U;Lb=y;Mb=F;Nb=M;Ob=v;Pb=z;Qb=G;Rb=N;Sb=ea(ea(ea(A*$a)+ea(B*db))+ea(C*hb));Tb=ea(ea(ea(H*ab)+ea(I*eb))+ea(J*ib));Ub=ea(ea(ea(O*bb)+ea(P*fb))+ea(Q*jb));Vb=ea(ea(ea(u*cb)+ea(Qa*gb))+ea(t*kb));Wb=ea(0.0);Xb=ea(0.0);Yb=ea(0.0);Zb=ea(0.0);_b=ea(0.0);$b=ea(0.0);ac=ea(0.0);bc=ea(0.0);cc=0;dc=Sa;while(1){ec=ea(g[r+(cc*176|0)+48>>2]);fc=ea(g[r+(cc*176|0)+52>>2]);gc=ea(g[r+(cc*176|0)+56>>2]);hc=ea(g[r+(cc*176|0)+60>>2]);ic=ea(g[r+(cc*176|0)+64>>2]);jc=ea(g[r+(cc*176|0)+68>>2]);kc=ea(g[r+(cc*176|0)+72>>2]);lc=ea(g[r+(cc*176|0)+76>>2]);mc=ea(g[r+(cc*176|0)+80>>2]);nc=ea(g[r+(cc*176|0)+84>>2]);oc=ea(g[r+(cc*176|0)+88>>2]);pc=ea(g[r+(cc*176|0)+92>>2]);qc=r+(cc*176|0)+112|0;rc=ea(g[qc>>2]);sc=r+(cc*176|0)+116|0;tc=ea(g[sc>>2]);uc=r+(cc*176|0)+120|0;vc=ea(g[uc>>2]);wc=r+(cc*176|0)+124|0;xc=ea(g[wc>>2]);yc=ea(g[r+(cc*176|0)+96>>2]);zc=ea(g[r+(cc*176|0)+100>>2]);Ac=ea(g[r+(cc*176|0)+104>>2]);Bc=ea(g[r+(cc*176|0)+108>>2]);Cc=ea(g[r+(cc*176|0)+160>>2]);Dc=ea(g[r+(cc*176|0)+164>>2]);Ec=ea(g[r+(cc*176|0)+168>>2]);Fc=ea(g[r+(cc*176|0)+172>>2]);Gc=ea(g[r+(cc*176|0)>>2]);Hc=ea(g[r+(cc*176|0)+4>>2]);Ic=ea(g[r+(cc*176|0)+8>>2]);Jc=ea(g[r+(cc*176|0)+12>>2]);Kc=ea(g[r+(cc*176|0)+16>>2]);Lc=ea(g[r+(cc*176|0)+20>>2]);Mc=ea(g[r+(cc*176|0)+24>>2]);Nc=ea(g[r+(cc*176|0)+28>>2]);Oc=ea(g[r+(cc*176|0)+32>>2]);Pc=ea(g[r+(cc*176|0)+36>>2]);Qc=ea(g[r+(cc*176|0)+40>>2]);Rc=ea(ea(ea(Gb*Gc)+ea(Kb*Kc))+ea(Ob*Oc));Oc=ea(ea(ea(Hb*Hc)+ea(Lb*Lc))+ea(Pb*Pc));Pc=ea(ea(ea(Ib*Ic)+ea(Mb*Mc))+ea(Qb*Qc));Qc=ea(ea(ea(Jb*Jc)+ea(Nb*Nc))+ea(Rb*ea(g[r+(cc*176|0)+44>>2])));Nc=ea(g[r+(cc*176|0)+144>>2]);Jc=ea(g[r+(cc*176|0)+148>>2]);Mc=ea(g[r+(cc*176|0)+152>>2]);Ic=ea(Nc-ea(yc*ea(Sb+Rc)));Rc=ea(Jc-ea(zc*ea(Tb+Oc)));Oc=ea(Mc-ea(Ac*ea(Ub+Pc)));Pc=ea(ea(g[r+(cc*176|0)+156>>2])-ea(Bc*ea(Vb+Qc)));Qc=ea(-rc);Bc=ea(-tc);Ac=ea(-vc);Mc=ea(-xc);zc=ea(rc+(Ic>Qc?Ic:Qc));Qc=ea(tc+(Rc>Bc?Rc:Bc));Bc=ea(vc+(Oc>Ac?Oc:Ac));Ac=ea(xc+(Pc>Mc?Pc:Mc));Mc=zc<Cc?zc:Cc;Cc=Qc<Dc?Qc:Dc;Dc=Bc<Ec?Bc:Ec;Ec=Ac<Fc?Ac:Fc;Fc=ea(Mc-rc);rc=ea(Cc-tc);tc=ea(Dc-vc);vc=ea(Ec-xc);Wb=ea(Wb+Fc);Xb=ea(Xb+rc);Yb=ea(Yb+tc);Zb=ea(Zb+vc);Sb=ea(Sb+ea(S*Fc));Tb=ea(Tb+ea(Ya*rc));Ub=ea(Ub+ea(Za*tc));Vb=ea(Vb+ea(_a*vc));Gb=ea(Gb+ea(ec*Fc));Hb=ea(Hb+ea(fc*rc));Ib=ea(Ib+ea(gc*tc));Jb=ea(Jb+ea(hc*vc));Kb=ea(Kb+ea(ic*Fc));Lb=ea(Lb+ea(jc*rc));Mb=ea(Mb+ea(kc*tc));Nb=ea(Nb+ea(lc*vc));Ob=ea(Ob+ea(mc*Fc));Pb=ea(Pb+ea(nc*rc));Qb=ea(Qb+ea(oc*tc));Rb=ea(Rb+ea(pc*vc));g[qc>>2]=Mc;g[sc>>2]=Cc;g[uc>>2]=Dc;g[wc>>2]=Ec;_b=ea(_b+Mc);$b=ea($b+Cc);ac=ea(ac+Dc);bc=ea(bc+Ec);cc=cc+1|0;if((cc|0)==(Ua|0))break;else dc=dc+256|0}lb=Jb;mb=Ib;nb=Hb;ob=Gb;pb=Nb;qb=Mb;rb=Lb;sb=Kb;tb=Rb;ub=Qb;vb=Pb;wb=Ob;xb=bc;yb=ac;zb=$b;Ab=_b;Bb=Zb;Cb=Yb;Db=Xb;Eb=Wb;Fb=Sa+Ta|0}Vb=ea(S*Eb);Ub=ea(Ya*Db);Tb=ea(Za*Cb);Sb=ea(_a*Bb);Ec=ea(A+ea($a*Vb));Dc=ea(H+ea(ab*Ub));Cc=ea(O+ea(bb*Tb));Mc=ea(u+ea(cb*Sb));vc=ea(B+ea(db*Vb));pc=ea(I+ea(eb*Ub));tc=ea(P+ea(fb*Tb));oc=ea(Qa+ea(gb*Sb));rc=ea(C+ea(hb*Vb));Vb=ea(J+ea(ib*Ub));Ub=ea(Q+ea(jb*Tb));Tb=ea(t+ea(kb*Sb));if((a[e>>0]|0)==0|Va<<24>>24==0){Sc=Mc;Tc=Cc;Uc=Dc;Vc=Ec;Wc=oc;Xc=tc;Yc=pc;Zc=vc;_c=Tb;$c=Ub;ad=Vb;bd=rc;cd=lb;dd=mb;ed=nb;fd=ob;gd=pb;hd=qb;id=rb;jd=sb;kd=tb;ld=ub;md=vb;nd=wb;od=Fb}else{Sb=ea(g[Ra+32>>2]);nc=ea(g[Ra+36>>2]);Fc=ea(g[Ra+40>>2]);mc=ea(g[Ra+44>>2]);lc=ea(g[Ra+48>>2]);kc=ea(g[Ra+52>>2]);jc=ea(g[Ra+56>>2]);ic=ea(Ab*Sb);Sb=ea(zb*nc);nc=ea(yb*Fc);Fc=ea(xb*mc);mc=ea(Ab*lc);lc=ea(zb*kc);kc=ea(yb*jc);jc=ea(xb*ea(g[Ra+60>>2]));hc=ea(-mc);gc=ea(-lc);fc=ea(-kc);ec=ea(-jc);dc=Wa*384|0;xc=Ec;Ec=Dc;Dc=Cc;Cc=Mc;Mc=ob;Ac=nb;Bc=mb;Qc=lb;zc=vc;vc=pc;pc=tc;tc=oc;oc=sb;Pc=rb;Oc=qb;Rc=pb;Ic=rc;rc=Vb;Vb=Ub;Ub=Tb;Tb=wb;Jc=vb;yc=ub;Nc=tb;Ua=0;cc=Fb;while(1){Lc=ea(g[Xa+(Ua*240|0)+112>>2]);Hc=ea(g[Xa+(Ua*240|0)+116>>2]);Kc=ea(g[Xa+(Ua*240|0)+120>>2]);Gc=ea(g[Xa+(Ua*240|0)+124>>2]);pd=ea(g[Xa+(Ua*240|0)+128>>2]);qd=ea(g[Xa+(Ua*240|0)+132>>2]);rd=ea(g[Xa+(Ua*240|0)+136>>2]);sd=ea(g[Xa+(Ua*240|0)+140>>2]);td=ea(g[Xa+(Ua*240|0)+144>>2]);ud=ea(g[Xa+(Ua*240|0)+148>>2]);vd=ea(g[Xa+(Ua*240|0)+152>>2]);wd=ea(g[Xa+(Ua*240|0)+156>>2]);r=Xa+(Ua*240|0)+48|0;xd=ea(g[r>>2]);wc=Xa+(Ua*240|0)+52|0;yd=ea(g[wc>>2]);uc=Xa+(Ua*240|0)+56|0;zd=ea(g[uc>>2]);sc=Xa+(Ua*240|0)+60|0;Ad=ea(g[sc>>2]);Bd=ea(g[Xa+(Ua*240|0)+208>>2]);Cd=ea(g[Xa+(Ua*240|0)+212>>2]);Dd=ea(g[Xa+(Ua*240|0)+216>>2]);Ed=ea(g[Xa+(Ua*240|0)+220>>2]);Fd=ea(g[Xa+(Ua*240|0)>>2]);Gd=ea(g[Xa+(Ua*240|0)+4>>2]);Hd=ea(g[Xa+(Ua*240|0)+8>>2]);Id=ea(g[Xa+(Ua*240|0)+12>>2]);Jd=ea(g[Xa+(Ua*240|0)+16>>2]);Kd=ea(g[Xa+(Ua*240|0)+20>>2]);Ld=ea(g[Xa+(Ua*240|0)+24>>2]);Md=ea(g[Xa+(Ua*240|0)+28>>2]);Nd=ea(g[Xa+(Ua*240|0)+32>>2]);Od=ea(g[Xa+(Ua*240|0)+36>>2]);Pd=ea(g[Xa+(Ua*240|0)+40>>2]);Qd=ea(g[Xa+(Ua*240|0)+44>>2]);Rd=ea(g[Xa+(Ua*240|0)+64>>2]);Sd=ea(g[Xa+(Ua*240|0)+68>>2]);Td=ea(g[Xa+(Ua*240|0)+72>>2]);Ud=ea(g[Xa+(Ua*240|0)+76>>2]);Vd=ea(g[Xa+(Ua*240|0)+80>>2]);Wd=ea(g[Xa+(Ua*240|0)+84>>2]);Xd=ea(g[Xa+(Ua*240|0)+88>>2]);Yd=ea(g[Xa+(Ua*240|0)+92>>2]);Zd=ea(g[Xa+(Ua*240|0)+96>>2]);_d=ea(g[Xa+(Ua*240|0)+100>>2]);$d=ea(g[Xa+(Ua*240|0)+104>>2]);ae=ea(g[Xa+(Ua*240|0)+108>>2]);qc=Xa+(Ua*240|0)+176|0;c[m+0>>2]=c[qc+0>>2];c[m+4>>2]=c[qc+4>>2];c[m+8>>2]=c[qc+8>>2];c[m+12>>2]=c[qc+12>>2];be=ea(ea(ea(ea(xc*Fd)+ea(zc*Jd))+ea(Ic*Nd))+ea(ea(ea(Mc*Rd)+ea(oc*Vd))+ea(Tb*Zd)));Zd=ea(ea(ea(ea(Ec*Gd)+ea(vc*Kd))+ea(rc*Od))+ea(ea(ea(Ac*Sd)+ea(Pc*Wd))+ea(Jc*_d)));_d=ea(ea(ea(ea(Dc*Hd)+ea(pc*Ld))+ea(Vb*Pd))+ea(ea(ea(Bc*Td)+ea(Oc*Xd))+ea(yc*$d)));$d=ea(ea(ea(ea(Cc*Id)+ea(tc*Md))+ea(Ub*Qd))+ea(ea(ea(Qc*Ud)+ea(Rc*Yd))+ea(Nc*ae)));ae=ea(g[Xa+(Ua*240|0)+160>>2]);Yd=ea(g[Xa+(Ua*240|0)+164>>2]);Ud=ea(g[Xa+(Ua*240|0)+168>>2]);Xd=ea(ea(xd-ae)-ea(Bd*be));be=ea(ea(yd-Yd)-ea(Cd*Zd));Zd=ea(ea(zd-Ud)-ea(Dd*_d));_d=ea(ea(Ad-ea(g[Xa+(Ua*240|0)+172>>2]))-ea(Ed*$d));$d=ea(-Xd);Ed=ea(-be);Dd=ea(-Zd);Ud=ea(-_d);ce=(Xd>$d?Xd:$d)>ic;de=(be>Ed?be:Ed)>Sb;ee=(Zd>Dd?Zd:Dd)>nc;fe=(_d>Ud?_d:Ud)>Fc;Ud=Xd<hc?hc:Xd;Dd=be<gc?gc:be;Ed=Zd<fc?fc:Zd;$d=_d<ec?ec:_d;g[j>>2]=mc<Ud?mc:Ud;g[s>>2]=lc<Dd?lc:Dd;g[Ia>>2]=kc<Ed?kc:Ed;g[Ja>>2]=jc<$d?jc:$d;g[h>>2]=Xd;g[Ka>>2]=be;g[La>>2]=Zd;g[Ma>>2]=_d;_d=ea(g[(ce?j:h)>>2]);Zd=ea(g[(de?j:h)+4>>2]);be=ea(g[(ee?j:h)+8>>2]);Xd=ea(g[(fe?j:h)+12>>2]);c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];g[l>>2]=ea(1.0);g[Na>>2]=ea(1.0);g[Oa>>2]=ea(1.0);g[Pa>>2]=ea(1.0);$d=ea(g[(ce?l:k)>>2]);Ed=ea(g[(de?l:k)+4>>2]);Dd=ea(g[(ee?l:k)+8>>2]);Ud=ea(g[(fe?l:k)+12>>2]);Cd=ea(_d-xd);xd=ea(Zd-yd);yd=ea(be-zd);zd=ea(Xd-Ad);Ad=ea(S*Cd);Yd=ea(Ya*xd);Bd=ea(Za*yd);ae=ea(_a*zd);xc=ea(xc+ea(Fd*Ad));Ec=ea(Ec+ea(Gd*Yd));Dc=ea(Dc+ea(Hd*Bd));Cc=ea(Cc+ea(Id*ae));Mc=ea(Mc+ea(Lc*Cd));Ac=ea(Ac+ea(Hc*xd));Bc=ea(Bc+ea(Kc*yd));Qc=ea(Qc+ea(Gc*zd));zc=ea(zc+ea(Jd*Ad));vc=ea(vc+ea(Kd*Yd));pc=ea(pc+ea(Ld*Bd));tc=ea(tc+ea(Md*ae));oc=ea(oc+ea(pd*Cd));Pc=ea(Pc+ea(qd*xd));Oc=ea(Oc+ea(rd*yd));Rc=ea(Rc+ea(sd*zd));Ic=ea(Ic+ea(Nd*Ad));rc=ea(rc+ea(Od*Yd));Vb=ea(Vb+ea(Pd*Bd));Ub=ea(Ub+ea(Qd*ae));Tb=ea(Tb+ea(td*Cd));Jc=ea(Jc+ea(ud*xd));yc=ea(yc+ea(vd*yd));Nc=ea(Nc+ea(wd*zd));g[r>>2]=_d;g[wc>>2]=Zd;g[uc>>2]=be;g[sc>>2]=Xd;g[qc>>2]=$d;g[Xa+(Ua*240|0)+180>>2]=Ed;g[Xa+(Ua*240|0)+184>>2]=Dd;g[Xa+(Ua*240|0)+188>>2]=Ud;qc=Ua+1|0;if((qc|0)==(Wa|0))break;else{Ua=qc;cc=cc+384|0}}Sc=Cc;Tc=Dc;Uc=Ec;Vc=xc;Wc=tc;Xc=pc;Yc=vc;Zc=zc;_c=Ub;$c=Vb;ad=rc;bd=Ic;cd=Qc;dd=Bc;ed=Ac;fd=Mc;gd=Rc;hd=Oc;id=Pc;jd=oc;kd=Nc;ld=yc;md=Jc;nd=Tb;od=Fb+dc|0}Ra=Xa+(Wa*240|0)|0;if(Ra>>>0>=d>>>0){V=Sc;W=Tc;X=Uc;Y=Vc;Z=Wc;_=Xc;$=Yc;aa=Zc;ba=_c;ca=$c;da=ad;fa=bd;ga=cd;ha=dd;ia=ed;ja=fd;ka=gd;la=hd;ma=id;na=jd;oa=kd;pa=ld;qa=md;ra=nd;break}else{Qa=Wc;P=Xc;I=Yc;B=Zc;u=Sc;O=Tc;H=Uc;A=Vc;t=_c;Q=$c;J=ad;C=bd;v=nd;z=md;G=ld;N=kd;U=jd;y=id;F=hd;M=gd;T=fd;x=ed;E=dd;L=cd;Sa=od}}g[n>>2]=Y;sa=n+4|0;g[sa>>2]=aa;ta=n+8|0;g[ta>>2]=fa;g[o>>2]=X;ua=o+4|0;g[ua>>2]=$;va=o+8|0;g[va>>2]=da;g[p>>2]=W;wa=p+4|0;g[wa>>2]=_;xa=p+8|0;g[xa>>2]=ca;g[q>>2]=V;ya=q+4|0;g[ya>>2]=Z;za=q+8|0;g[za>>2]=ba;g[w>>2]=ja;Aa=n+20|0;g[Aa>>2]=na;Ba=n+24|0;g[Ba>>2]=ra;g[D>>2]=ia;Ca=o+20|0;g[Ca>>2]=ma;Da=o+24|0;g[Da>>2]=qa;g[K>>2]=ha;Ea=p+20|0;g[Ea>>2]=la;Fa=p+24|0;g[Fa>>2]=pa;g[R>>2]=ga;Ga=q+20|0;g[Ga>>2]=ka;Ha=q+24|0;g[Ha>>2]=oa;i=f;return}function j1a(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im;h=i;j=b+((c&65535)<<4)|0;if(!(c<<16>>16)){i=h;return}c=b;do{b=a[c+1>>0]|0;k=b&255;l=a[c+2>>0]|0;m=l&255;n=(da(k,e)|0)+144|0;o=c+n|0;p=c;c=c+(n+(da(m,f)|0))|0;if(b<<24>>24){b=p+144|0;p=0;while(1){n=b+144|0;q=ea(g[n>>2]);r=b+148|0;s=ea(g[r>>2]);t=b+152|0;u=ea(g[t>>2]);v=b+156|0;w=ea(g[v>>2]);x=ea(g[b+128>>2]);y=ea(g[b+132>>2]);z=ea(g[b+136>>2]);A=ea(s-y);y=ea(u-z);z=ea(w-ea(g[b+140>>2]));g[n>>2]=ea(q-x);g[r>>2]=A;g[t>>2]=y;g[v>>2]=z;p=p+1|0;if((p|0)==(k|0))break;else b=b+e|0}}if(!((a[d>>0]|0)==0|l<<24>>24==0)){b=o;k=0;while(1){p=b+160|0;z=ea(g[p>>2]);v=b+164|0;y=ea(g[v>>2]);t=b+168|0;A=ea(g[t>>2]);r=b+172|0;x=ea(g[r>>2]);q=ea(g[b+192>>2]);w=ea(g[b+196>>2]);u=ea(g[b+200>>2]);s=ea(y-w);w=ea(A-u);u=ea(x-ea(g[b+204>>2]));g[p>>2]=ea(z-q);g[v>>2]=s;g[t>>2]=w;g[r>>2]=u;k=k+1|0;if((k|0)==(m|0))break;else b=b+f|0}}}while(c>>>0<j>>>0);i=h;return}function k1a(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=Im,X=Im,Y=Im,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=Im,ka=Im,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=Im,_b=0,$b=0,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=0,vc=Im,wc=0,xc=Im,yc=0,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im;b=i;d=c[a>>2]|0;e=c[a+4>>2]|0;f=c[a+32>>2]|0;h=c[a+36>>2]|0;j=c[a+64>>2]|0;k=c[a+68>>2]|0;l=c[a+96>>2]|0;m=c[a+100>>2]|0;n=c[a+16>>2]|0;o=ea(g[d>>2]);p=ea(g[d+4>>2]);q=ea(g[d+8>>2]);r=ea(g[e>>2]);s=ea(g[e+4>>2]);t=ea(g[e+8>>2]);a=d+16|0;u=ea(g[a>>2]);v=ea(g[a+4>>2]);w=ea(g[a+8>>2]);x=e+16|0;y=ea(g[x>>2]);z=ea(g[x+4>>2]);A=ea(g[x+8>>2]);B=ea(g[f>>2]);C=ea(g[f+4>>2]);D=ea(g[f+8>>2]);E=ea(g[h>>2]);F=ea(g[h+4>>2]);G=ea(g[h+8>>2]);H=f+16|0;I=ea(g[H>>2]);J=ea(g[H+4>>2]);K=ea(g[H+8>>2]);L=h+16|0;M=ea(g[L>>2]);N=ea(g[L+4>>2]);O=ea(g[L+8>>2]);P=ea(g[j>>2]);Q=ea(g[j+4>>2]);R=ea(g[j+8>>2]);S=ea(g[k>>2]);T=ea(g[k+4>>2]);U=ea(g[k+8>>2]);V=j+16|0;W=ea(g[V>>2]);X=ea(g[V+4>>2]);Y=ea(g[V+8>>2]);Z=k+16|0;_=ea(g[Z>>2]);$=ea(g[Z+4>>2]);aa=ea(g[Z+8>>2]);ba=ea(g[l>>2]);ca=ea(g[l+4>>2]);da=ea(g[l+8>>2]);fa=ea(g[m>>2]);ga=ea(g[m+4>>2]);ha=ea(g[m+8>>2]);ia=l+16|0;ja=ea(g[ia>>2]);ka=ea(g[ia+4>>2]);la=ea(g[ia+8>>2]);ma=m+16|0;na=ea(g[ma>>2]);oa=ea(g[ma+4>>2]);pa=ea(g[ma+8>>2]);qa=ea(g[n+48>>2]);ra=ea(g[n+52>>2]);sa=ea(g[n+56>>2]);ta=ea(g[n+60>>2]);ua=ea(g[n+64>>2]);va=ea(g[n+68>>2]);wa=ea(g[n+72>>2]);xa=ea(g[n+76>>2]);ya=c[n+4>>2]|0;if(!ya){za=ba;Aa=P;Ba=B;Ca=o;Da=ca;Ea=Q;Fa=C;Ga=p;Ha=da;Ia=R;Ja=D;Ka=q;La=fa;Ma=S;Na=E;Oa=r;Pa=ga;Qa=T;Ra=F;Sa=s;Ta=ha;Ua=U;Va=G;Wa=t;Xa=ja;Ya=W;Za=I;_a=u;$a=ka;ab=X;bb=J;cb=v;db=la;eb=Y;fb=K;gb=w;hb=na;ib=_;jb=M;kb=y;lb=oa;mb=$;nb=N;ob=z;pb=pa;qb=aa;rb=O;sb=A;g[d>>2]=Ca;tb=d+4|0;g[tb>>2]=Ga;ub=d+8|0;g[ub>>2]=Ka;g[f>>2]=Ba;vb=f+4|0;g[vb>>2]=Fa;wb=f+8|0;g[wb>>2]=Ja;g[j>>2]=Aa;xb=j+4|0;g[xb>>2]=Ea;yb=j+8|0;g[yb>>2]=Ia;g[l>>2]=za;zb=l+4|0;g[zb>>2]=Da;Ab=l+8|0;g[Ab>>2]=Ha;g[e>>2]=Oa;Bb=e+4|0;g[Bb>>2]=Sa;Cb=e+8|0;g[Cb>>2]=Wa;g[h>>2]=Na;Db=h+4|0;g[Db>>2]=Ra;Eb=h+8|0;g[Eb>>2]=Va;g[k>>2]=Ma;Fb=k+4|0;g[Fb>>2]=Qa;Gb=k+8|0;g[Gb>>2]=Ua;g[m>>2]=La;Hb=m+4|0;g[Hb>>2]=Pa;Ib=m+8|0;g[Ib>>2]=Ta;g[a>>2]=_a;Jb=d+20|0;g[Jb>>2]=cb;Kb=d+24|0;g[Kb>>2]=gb;g[H>>2]=Za;Lb=f+20|0;g[Lb>>2]=bb;Mb=f+24|0;g[Mb>>2]=fb;g[V>>2]=Ya;Nb=j+20|0;g[Nb>>2]=ab;Ob=j+24|0;g[Ob>>2]=eb;g[ia>>2]=Xa;Pb=l+20|0;g[Pb>>2]=$a;Qb=l+24|0;g[Qb>>2]=db;g[x>>2]=kb;Rb=e+20|0;g[Rb>>2]=ob;Sb=e+24|0;g[Sb>>2]=sb;g[L>>2]=jb;Tb=h+20|0;g[Tb>>2]=nb;Ub=h+24|0;g[Ub>>2]=rb;g[Z>>2]=ib;Vb=k+20|0;g[Vb>>2]=mb;Wb=k+24|0;g[Wb>>2]=qb;g[ma>>2]=hb;Xb=m+20|0;g[Xb>>2]=lb;Yb=m+24|0;g[Yb>>2]=pb;i=b;return}Zb=o;o=B;B=P;P=ba;ba=r;r=E;E=S;S=fa;fa=u;u=I;I=W;W=ja;ja=y;y=M;M=_;_=na;na=p;p=C;C=Q;Q=ca;ca=s;s=F;F=T;T=ga;ga=v;v=J;J=X;X=ka;ka=z;z=N;N=$;$=oa;oa=q;q=D;D=R;R=da;da=t;t=G;G=U;U=ha;ha=w;w=K;K=Y;Y=la;la=A;A=O;O=aa;aa=pa;_b=0;$b=n+128|0;while(1){pa=ea(g[$b+176>>2]);ac=ea(g[$b+180>>2]);bc=ea(g[$b+184>>2]);cc=ea(g[$b+188>>2]);dc=ea(g[$b+192>>2]);ec=ea(g[$b+196>>2]);fc=ea(g[$b+200>>2]);gc=ea(g[$b+204>>2]);hc=ea(g[$b+144>>2]);ic=ea(g[$b+148>>2]);jc=ea(g[$b+152>>2]);kc=ea(g[$b+156>>2]);lc=ea(g[$b+208>>2]);mc=ea(g[$b+212>>2]);nc=ea(g[$b+216>>2]);oc=ea(g[$b+220>>2]);pc=ea(g[$b+224>>2]);qc=ea(g[$b+228>>2]);rc=ea(g[$b+232>>2]);sc=ea(g[$b+236>>2]);n=$b+240|0;tc=ea(g[n>>2]);uc=$b+244|0;vc=ea(g[uc>>2]);wc=$b+248|0;xc=ea(g[wc>>2]);yc=$b+252|0;zc=ea(g[yc>>2]);Ac=ea(g[$b>>2]);Bc=ea(g[$b+4>>2]);Cc=ea(g[$b+8>>2]);Dc=ea(g[$b+12>>2]);Ec=ea(g[$b+16>>2]);Fc=ea(g[$b+20>>2]);Gc=ea(g[$b+24>>2]);Hc=ea(g[$b+28>>2]);Ic=ea(g[$b+32>>2]);Jc=ea(g[$b+36>>2]);Kc=ea(g[$b+40>>2]);Lc=ea(g[$b+44>>2]);Mc=ea(g[$b+272>>2]);Nc=ea(g[$b+276>>2]);Oc=ea(g[$b+280>>2]);Pc=ea(g[$b+284>>2]);Qc=ea(g[$b+288>>2]);Rc=ea(g[$b+292>>2]);Sc=ea(g[$b+296>>2]);Tc=ea(g[$b+300>>2]);Uc=ea(g[$b+304>>2]);Vc=ea(g[$b+308>>2]);Wc=ea(g[$b+312>>2]);Xc=ea(g[$b+316>>2]);Yc=ea(g[$b+48>>2]);Zc=ea(g[$b+52>>2]);_c=ea(g[$b+56>>2]);$c=ea(g[$b+60>>2]);ad=ea(g[$b+64>>2]);bd=ea(g[$b+68>>2]);cd=ea(g[$b+72>>2]);dd=ea(g[$b+76>>2]);ed=ea(g[$b+80>>2]);fd=ea(g[$b+84>>2]);gd=ea(g[$b+88>>2]);hd=ea(g[$b+92>>2]);id=ea(g[$b+320>>2]);jd=ea(g[$b+324>>2]);kd=ea(g[$b+328>>2]);ld=ea(g[$b+332>>2]);md=ea(g[$b+336>>2]);nd=ea(g[$b+340>>2]);od=ea(g[$b+344>>2]);pd=ea(g[$b+348>>2]);qd=ea(g[$b+352>>2]);rd=ea(g[$b+356>>2]);sd=ea(g[$b+360>>2]);td=ea(g[$b+364>>2]);ud=ea(g[$b+96>>2]);vd=ea(g[$b+100>>2]);wd=ea(g[$b+104>>2]);xd=ea(g[$b+108>>2]);yd=ea(g[$b+112>>2]);zd=ea(g[$b+116>>2]);Ad=ea(g[$b+120>>2]);Bd=ea(g[$b+124>>2]);Cd=ea(g[$b+128>>2]);Dd=ea(g[$b+132>>2]);Ed=ea(g[$b+136>>2]);Fd=ea(g[$b+140>>2]);Gd=ea(g[$b+368>>2]);Hd=ea(g[$b+372>>2]);Id=ea(g[$b+376>>2]);Jd=ea(g[$b+380>>2]);Kd=ea(g[$b+384>>2]);Ld=ea(g[$b+388>>2]);Md=ea(g[$b+392>>2]);Nd=ea(g[$b+396>>2]);Od=ea(g[$b+400>>2]);Pd=ea(g[$b+404>>2]);Qd=ea(g[$b+408>>2]);Rd=ea(g[$b+412>>2]);Sd=ea(ea(dc*tc)+ea(hc+ea(pa*ea(ea(ea(ea(ea(Zb*Ac)+ea(na*Ec))+ea(oa*Ic))+ea(ea(ea(fa*Yc)+ea(ga*ad))+ea(ha*ed)))-ea(ea(ea(ea(ba*Mc)+ea(ca*Qc))+ea(da*Uc))+ea(ea(ea(ja*id)+ea(ka*md))+ea(la*qd)))))));qd=ea(ea(ec*vc)+ea(ic+ea(ac*ea(ea(ea(ea(ea(o*Bc)+ea(p*Fc))+ea(q*Jc))+ea(ea(ea(u*Zc)+ea(v*bd))+ea(w*fd)))-ea(ea(ea(ea(r*Nc)+ea(s*Rc))+ea(t*Vc))+ea(ea(ea(y*jd)+ea(z*nd))+ea(A*rd)))))));rd=ea(ea(fc*xc)+ea(jc+ea(bc*ea(ea(ea(ea(ea(B*Cc)+ea(C*Gc))+ea(D*Kc))+ea(ea(ea(I*_c)+ea(J*cd))+ea(K*gd)))-ea(ea(ea(ea(E*Oc)+ea(F*Sc))+ea(G*Wc))+ea(ea(ea(M*kd)+ea(N*od))+ea(O*sd)))))));sd=ea(ea(gc*zc)+ea(kc+ea(cc*ea(ea(ea(ea(ea(P*Dc)+ea(Q*Hc))+ea(R*Lc))+ea(ea(ea(W*$c)+ea(X*dd))+ea(Y*hd)))-ea(ea(ea(ea(S*Pc)+ea(T*Tc))+ea(U*Xc))+ea(ea(ea(_*ld)+ea($*pd))+ea(aa*td)))))));td=pc<Sd?pc:Sd;Sd=qc<qd?qc:qd;qd=rc<rd?rc:rd;rd=sc<sd?sc:sd;sd=lc>td?lc:td;td=mc>Sd?mc:Sd;Sd=nc>qd?nc:qd;qd=oc>rd?oc:rd;rd=ea(sd-tc);tc=ea(td-vc);vc=ea(Sd-xc);xc=ea(qd-zc);g[n>>2]=sd;g[uc>>2]=td;g[wc>>2]=Sd;g[yc>>2]=qd;qd=ea(qa*rd);Sd=ea(ra*tc);td=ea(sa*vc);sd=ea(ta*xc);zc=ea(ua*rd);oc=ea(va*tc);nc=ea(wa*vc);mc=ea(xa*xc);lc=ea(Zb+ea(Ac*qd));Ac=ea(o+ea(Bc*Sd));Bc=ea(B+ea(Cc*td));Cc=ea(P+ea(Dc*sd));Dc=ea(ba+ea(Mc*zc));Mc=ea(r+ea(Nc*oc));Nc=ea(E+ea(Oc*nc));Oc=ea(S+ea(Pc*mc));Pc=ea(fa+ea(ud*rd));ud=ea(u+ea(vd*tc));vd=ea(I+ea(wd*vc));wd=ea(W+ea(xd*xc));xd=ea(ja+ea(rd*Gd));Gd=ea(y+ea(tc*Hd));Hd=ea(M+ea(vc*Id));Id=ea(_+ea(xc*Jd));Jd=ea(na+ea(Ec*qd));Ec=ea(p+ea(Fc*Sd));Fc=ea(C+ea(Gc*td));Gc=ea(Q+ea(Hc*sd));Hc=ea(ca+ea(Qc*zc));Qc=ea(s+ea(Rc*oc));Rc=ea(F+ea(Sc*nc));Sc=ea(T+ea(Tc*mc));Tc=ea(ga+ea(yd*rd));yd=ea(v+ea(zd*tc));zd=ea(J+ea(Ad*vc));Ad=ea(X+ea(Bd*xc));Bd=ea(ka+ea(rd*Kd));Kd=ea(z+ea(tc*Ld));Ld=ea(N+ea(vc*Md));Md=ea($+ea(xc*Nd));Nd=ea(oa+ea(Ic*qd));qd=ea(q+ea(Jc*Sd));Sd=ea(D+ea(Kc*td));td=ea(R+ea(Lc*sd));sd=ea(da+ea(Uc*zc));zc=ea(t+ea(Vc*oc));oc=ea(G+ea(Wc*nc));nc=ea(U+ea(Xc*mc));mc=ea(ha+ea(Cd*rd));Cd=ea(w+ea(Dd*tc));Dd=ea(K+ea(Ed*vc));Ed=ea(Y+ea(Fd*xc));Fd=ea(la+ea(rd*Od));Od=ea(A+ea(tc*Pd));Pd=ea(O+ea(vc*Qd));Qd=ea(aa+ea(xc*Rd));_b=_b+1|0;if((_b|0)==(ya|0)){za=Cc;Aa=Bc;Ba=Ac;Ca=lc;Da=Gc;Ea=Fc;Fa=Ec;Ga=Jd;Ha=td;Ia=Sd;Ja=qd;Ka=Nd;La=Oc;Ma=Nc;Na=Mc;Oa=Dc;Pa=Sc;Qa=Rc;Ra=Qc;Sa=Hc;Ta=nc;Ua=oc;Va=zc;Wa=sd;Xa=wd;Ya=vd;Za=ud;_a=Pc;$a=Ad;ab=zd;bb=yd;cb=Tc;db=Ed;eb=Dd;fb=Cd;gb=mc;hb=Id;ib=Hd;jb=Gd;kb=xd;lb=Md;mb=Ld;nb=Kd;ob=Bd;pb=Qd;qb=Pd;rb=Od;sb=Fd;break}else{Zb=lc;o=Ac;B=Bc;P=Cc;ba=Dc;r=Mc;E=Nc;S=Oc;fa=Pc;u=ud;I=vd;W=wd;ja=xd;y=Gd;M=Hd;_=Id;na=Jd;p=Ec;C=Fc;Q=Gc;ca=Hc;s=Qc;F=Rc;T=Sc;ga=Tc;v=yd;J=zd;X=Ad;ka=Bd;z=Kd;N=Ld;$=Md;oa=Nd;q=qd;D=Sd;R=td;da=sd;t=zc;G=oc;U=nc;ha=mc;w=Cd;K=Dd;Y=Ed;la=Fd;A=Od;O=Pd;aa=Qd;$b=$b+416|0}}g[d>>2]=Ca;tb=d+4|0;g[tb>>2]=Ga;ub=d+8|0;g[ub>>2]=Ka;g[f>>2]=Ba;vb=f+4|0;g[vb>>2]=Fa;wb=f+8|0;g[wb>>2]=Ja;g[j>>2]=Aa;xb=j+4|0;g[xb>>2]=Ea;yb=j+8|0;g[yb>>2]=Ia;g[l>>2]=za;zb=l+4|0;g[zb>>2]=Da;Ab=l+8|0;g[Ab>>2]=Ha;g[e>>2]=Oa;Bb=e+4|0;g[Bb>>2]=Sa;Cb=e+8|0;g[Cb>>2]=Wa;g[h>>2]=Na;Db=h+4|0;g[Db>>2]=Ra;Eb=h+8|0;g[Eb>>2]=Va;g[k>>2]=Ma;Fb=k+4|0;g[Fb>>2]=Qa;Gb=k+8|0;g[Gb>>2]=Ua;g[m>>2]=La;Hb=m+4|0;g[Hb>>2]=Pa;Ib=m+8|0;g[Ib>>2]=Ta;g[a>>2]=_a;Jb=d+20|0;g[Jb>>2]=cb;Kb=d+24|0;g[Kb>>2]=gb;g[H>>2]=Za;Lb=f+20|0;g[Lb>>2]=bb;Mb=f+24|0;g[Mb>>2]=fb;g[V>>2]=Ya;Nb=j+20|0;g[Nb>>2]=ab;Ob=j+24|0;g[Ob>>2]=eb;g[ia>>2]=Xa;Pb=l+20|0;g[Pb>>2]=$a;Qb=l+24|0;g[Qb>>2]=db;g[x>>2]=kb;Rb=e+20|0;g[Rb>>2]=ob;Sb=e+24|0;g[Sb>>2]=sb;g[L>>2]=jb;Tb=h+20|0;g[Tb>>2]=nb;Ub=h+24|0;g[Ub>>2]=rb;g[Z>>2]=ib;Vb=k+20|0;g[Vb>>2]=mb;Wb=k+24|0;g[Wb>>2]=qb;g[ma>>2]=hb;Xb=m+20|0;g[Xb>>2]=lb;Yb=m+24|0;g[Yb>>2]=pb;i=b;return}function l1a(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=Im,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=0,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=Im,ma=Im,na=Im,oa=0,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=0,Qc=0,Rc=0,Sc=0,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=0,Td=Im,Ud=Im,Vd=Im,Wd=Im,Xd=Im,Yd=Im,Zd=Im,_d=Im,$d=Im,ae=Im,be=Im,ce=Im,de=Im,ee=Im,fe=Im,ge=Im,he=Im,ie=Im,je=Im,ke=0,le=Im,me=0,ne=Im,oe=0,pe=Im,qe=0,re=Im,se=Im,te=Im,ue=Im,ve=Im,we=Im,xe=Im,ye=Im,ze=Im,Ae=Im,Be=Im,Ce=Im,De=Im,Ee=Im,Fe=Im,Ge=Im,He=Im,Ie=Im,Je=Im,Ke=Im,Le=Im,Me=Im,Ne=Im,Oe=Im,Pe=Im,Qe=Im,Re=Im,Se=Im,Te=Im,Ue=Im,Ve=Im,We=Im,Xe=Im,Ye=Im,Ze=Im,_e=Im,$e=Im,af=Im,bf=Im,cf=Im,df=Im;e=i;f=c[d>>2]|0;h=c[d+4>>2]|0;j=c[d+32>>2]|0;k=c[d+36>>2]|0;l=c[d+64>>2]|0;m=c[d+68>>2]|0;n=c[d+96>>2]|0;o=c[d+100>>2]|0;p=ea(g[f>>2]);q=ea(g[f+4>>2]);r=ea(g[f+8>>2]);s=ea(g[h>>2]);t=ea(g[h+4>>2]);u=ea(g[h+8>>2]);v=f+16|0;w=ea(g[v>>2]);x=ea(g[v+4>>2]);y=ea(g[v+8>>2]);z=h+16|0;A=ea(g[z>>2]);B=ea(g[z+4>>2]);C=ea(g[z+8>>2]);D=ea(g[j>>2]);E=ea(g[j+4>>2]);F=ea(g[j+8>>2]);G=ea(g[k>>2]);H=ea(g[k+4>>2]);I=ea(g[k+8>>2]);J=j+16|0;K=ea(g[J>>2]);L=ea(g[J+4>>2]);M=ea(g[J+8>>2]);N=k+16|0;O=ea(g[N>>2]);P=ea(g[N+4>>2]);Q=ea(g[N+8>>2]);R=ea(g[l>>2]);S=ea(g[l+4>>2]);T=ea(g[l+8>>2]);U=ea(g[m>>2]);V=ea(g[m+4>>2]);W=ea(g[m+8>>2]);X=l+16|0;Y=ea(g[X>>2]);Z=ea(g[X+4>>2]);_=ea(g[X+8>>2]);$=m+16|0;aa=ea(g[$>>2]);ba=ea(g[$+4>>2]);ca=ea(g[$+8>>2]);da=ea(g[n>>2]);fa=ea(g[n+4>>2]);ga=ea(g[n+8>>2]);ha=ea(g[o>>2]);ia=ea(g[o+4>>2]);ja=ea(g[o+8>>2]);ka=n+16|0;la=ea(g[ka>>2]);ma=ea(g[ka+4>>2]);na=ea(g[ka+8>>2]);oa=o+16|0;pa=ea(g[oa>>2]);qa=ea(g[oa+4>>2]);ra=ea(g[oa+8>>2]);sa=c[d+16>>2]|0;d=b[sa+2>>1]|0;ta=sa+(d&65535)|0;if(!(d<<16>>16)){ua=da;va=R;wa=D;xa=p;ya=fa;za=S;Aa=E;Ba=q;Ca=ga;Da=T;Ea=F;Fa=r;Ga=ha;Ha=U;Ia=G;Ja=s;Ka=ia;La=V;Ma=H;Na=t;Oa=ja;Pa=W;Qa=I;Ra=u;Sa=la;Ta=Y;Ua=K;Va=w;Wa=ma;Xa=Z;Ya=L;Za=x;_a=na;$a=_;ab=M;bb=y;cb=pa;db=aa;eb=O;fb=A;gb=qa;hb=ba;ib=P;jb=B;kb=ra;lb=ca;mb=Q;nb=C;g[f>>2]=xa;ob=f+4|0;g[ob>>2]=Ba;pb=f+8|0;g[pb>>2]=Fa;g[j>>2]=wa;qb=j+4|0;g[qb>>2]=Aa;rb=j+8|0;g[rb>>2]=Ea;g[l>>2]=va;sb=l+4|0;g[sb>>2]=za;tb=l+8|0;g[tb>>2]=Da;g[n>>2]=ua;ub=n+4|0;g[ub>>2]=ya;vb=n+8|0;g[vb>>2]=Ca;g[h>>2]=Ja;wb=h+4|0;g[wb>>2]=Na;xb=h+8|0;g[xb>>2]=Ra;g[k>>2]=Ia;yb=k+4|0;g[yb>>2]=Ma;zb=k+8|0;g[zb>>2]=Qa;g[m>>2]=Ha;Ab=m+4|0;g[Ab>>2]=La;Bb=m+8|0;g[Bb>>2]=Pa;g[o>>2]=Ga;Cb=o+4|0;g[Cb>>2]=Ka;Db=o+8|0;g[Db>>2]=Oa;g[v>>2]=Va;Eb=f+20|0;g[Eb>>2]=Za;Fb=f+24|0;g[Fb>>2]=bb;g[J>>2]=Ua;Gb=j+20|0;g[Gb>>2]=Ya;Hb=j+24|0;g[Hb>>2]=ab;g[X>>2]=Ta;Ib=l+20|0;g[Ib>>2]=Xa;Jb=l+24|0;g[Jb>>2]=$a;g[ka>>2]=Sa;Kb=n+20|0;g[Kb>>2]=Wa;Lb=n+24|0;g[Lb>>2]=_a;g[z>>2]=fb;Mb=h+20|0;g[Mb>>2]=jb;Nb=h+24|0;g[Nb>>2]=nb;g[N>>2]=eb;Ob=k+20|0;g[Ob>>2]=ib;Pb=k+24|0;g[Pb>>2]=mb;g[$>>2]=db;Qb=m+20|0;g[Qb>>2]=hb;Rb=m+24|0;g[Rb>>2]=lb;g[oa>>2]=cb;Sb=o+20|0;g[Sb>>2]=gb;Tb=o+24|0;g[Tb>>2]=kb;i=e;return}else{Ub=d;Vb=ia;Wb=V;Xb=H;Yb=t;Zb=fa;_b=S;$b=E;ac=q;bc=ha;cc=U;dc=G;ec=s;fc=da;gc=R;hc=D;ic=p;jc=ja;kc=W;lc=I;mc=u;nc=ga;oc=T;pc=F;qc=r;rc=C;sc=Q;tc=ca;uc=ra;vc=B;wc=P;xc=ba;yc=qa;zc=A;Ac=O;Bc=aa;Cc=pa;Dc=y;Ec=M;Fc=_;Gc=na;Hc=x;Ic=L;Jc=Z;Kc=ma;Lc=w;Mc=K;Nc=Y;Oc=la;Pc=sa}while(1){sa=Pc+((Ub&65535)+64)|0;d=Pc+112|0;Qc=a[Pc+1>>0]|0;Rc=Qc&255;Sc=d+(Rc*272|0)|0;la=ea(g[Pc+80>>2]);Y=ea(g[Pc+84>>2]);K=ea(g[Pc+88>>2]);w=ea(g[Pc+92>>2]);ma=ea(g[Pc+96>>2]);Z=ea(g[Pc+100>>2]);L=ea(g[Pc+104>>2]);x=ea(g[Pc+108>>2]);na=ea(g[Pc+32>>2]);_=ea(g[Pc+36>>2]);M=ea(g[Pc+40>>2]);y=ea(g[Pc+44>>2]);pa=ea(g[Pc+48>>2]);aa=ea(g[Pc+52>>2]);O=ea(g[Pc+56>>2]);A=ea(g[Pc+60>>2]);qa=ea(g[Pc+64>>2]);ba=ea(g[Pc+68>>2]);P=ea(g[Pc+72>>2]);B=ea(g[Pc+76>>2]);ra=ea(la*na);ca=ea(Y*_);Q=ea(K*M);C=ea(w*y);r=ea(ma*na);F=ea(Z*_);T=ea(L*M);ga=ea(x*y);u=ea(la*pa);I=ea(Y*aa);W=ea(K*O);ja=ea(w*A);p=ea(ma*pa);D=ea(Z*aa);R=ea(L*O);da=ea(x*A);s=ea(la*qa);G=ea(Y*ba);U=ea(K*P);ha=ea(w*B);q=ea(ma*qa);E=ea(Z*ba);S=ea(L*P);fa=ea(x*B);if(!(Qc<<24>>24)){Tc=Oc;Uc=Nc;Vc=Mc;Wc=Lc;Xc=Kc;Yc=Jc;Zc=Ic;_c=Hc;$c=Gc;ad=Fc;bd=Ec;cd=Dc;dd=Cc;ed=Bc;fd=Ac;gd=zc;hd=yc;id=xc;jd=wc;kd=vc;ld=uc;md=tc;nd=sc;od=rc;pd=ea(0.0);qd=ea(0.0);rd=ea(0.0);sd=ea(0.0)}else{t=Lc;H=Mc;V=Nc;ia=Oc;td=zc;ud=Ac;vd=Bc;wd=Cc;xd=Hc;yd=Ic;zd=Jc;Ad=Kc;Bd=vc;Cd=wc;Dd=xc;Ed=yc;Fd=Dc;Gd=Ec;Hd=Fc;Id=Gc;Jd=rc;Kd=sc;Ld=tc;Md=uc;Nd=ea(ea(ea(ic*na)+ea(ac*pa))+ea(qc*qa));Od=ea(ea(ea(hc*_)+ea($b*aa))+ea(pc*ba));Pd=ea(ea(ea(gc*M)+ea(_b*O))+ea(oc*P));Qd=ea(ea(ea(fc*y)+ea(Zb*A))+ea(nc*B));Rd=ea(ea(ea(ec*na)+ea(Yb*pa))+ea(mc*qa));qa=ea(ea(ea(dc*_)+ea(Xb*aa))+ea(lc*ba));ba=ea(ea(ea(cc*M)+ea(Wb*O))+ea(kc*P));P=ea(ea(ea(bc*y)+ea(Vb*A))+ea(jc*B));B=ea(0.0);A=ea(0.0);y=ea(0.0);O=ea(0.0);Qc=0;while(1){Sd=Qc+1|0;M=ea(g[d+(Qc*272|0)+48>>2]);aa=ea(g[d+(Qc*272|0)+52>>2]);_=ea(g[d+(Qc*272|0)+56>>2]);pa=ea(g[d+(Qc*272|0)+60>>2]);na=ea(g[d+(Qc*272|0)+64>>2]);Td=ea(g[d+(Qc*272|0)+68>>2]);Ud=ea(g[d+(Qc*272|0)+72>>2]);Vd=ea(g[d+(Qc*272|0)+76>>2]);Wd=ea(g[d+(Qc*272|0)+80>>2]);Xd=ea(g[d+(Qc*272|0)+84>>2]);Yd=ea(g[d+(Qc*272|0)+88>>2]);Zd=ea(g[d+(Qc*272|0)+92>>2]);_d=ea(g[d+(Qc*272|0)+224>>2]);$d=ea(g[d+(Qc*272|0)+228>>2]);ae=ea(g[d+(Qc*272|0)+232>>2]);be=ea(g[d+(Qc*272|0)+236>>2]);ce=ea(g[d+(Qc*272|0)+240>>2]);de=ea(g[d+(Qc*272|0)+244>>2]);ee=ea(g[d+(Qc*272|0)+248>>2]);fe=ea(g[d+(Qc*272|0)+252>>2]);ge=ea(g[d+(Qc*272|0)+256>>2]);he=ea(g[d+(Qc*272|0)+260>>2]);ie=ea(g[d+(Qc*272|0)+264>>2]);je=ea(g[d+(Qc*272|0)+268>>2]);ke=d+(Qc*272|0)+96|0;le=ea(g[ke>>2]);me=d+(Qc*272|0)+100|0;ne=ea(g[me>>2]);oe=d+(Qc*272|0)+104|0;pe=ea(g[oe>>2]);qe=d+(Qc*272|0)+108|0;re=ea(g[qe>>2]);se=ea(g[d+(Qc*272|0)+112>>2]);te=ea(g[d+(Qc*272|0)+116>>2]);ue=ea(g[d+(Qc*272|0)+120>>2]);ve=ea(g[d+(Qc*272|0)+124>>2]);we=ea(g[d+(Qc*272|0)+128>>2]);xe=ea(g[d+(Qc*272|0)+132>>2]);ye=ea(g[d+(Qc*272|0)+136>>2]);ze=ea(g[d+(Qc*272|0)+140>>2]);Ae=ea(g[d+(Qc*272|0)+144>>2]);Be=ea(g[d+(Qc*272|0)+148>>2]);Ce=ea(g[d+(Qc*272|0)+152>>2]);De=ea(g[d+(Qc*272|0)+156>>2]);Ee=ea(g[d+(Qc*272|0)+160>>2]);Fe=ea(g[d+(Qc*272|0)+164>>2]);Ge=ea(g[d+(Qc*272|0)+168>>2]);He=ea(g[d+(Qc*272|0)+172>>2]);Ie=ea(g[d+(Qc*272|0)>>2]);Je=ea(g[d+(Qc*272|0)+4>>2]);Ke=ea(g[d+(Qc*272|0)+8>>2]);Le=ea(g[d+(Qc*272|0)+12>>2]);Me=ea(g[d+(Qc*272|0)+16>>2]);Ne=ea(g[d+(Qc*272|0)+20>>2]);Oe=ea(g[d+(Qc*272|0)+24>>2]);Pe=ea(g[d+(Qc*272|0)+28>>2]);Qe=ea(g[d+(Qc*272|0)+32>>2]);Re=ea(g[d+(Qc*272|0)+36>>2]);Se=ea(g[d+(Qc*272|0)+40>>2]);Te=ea(g[d+(Qc*272|0)+44>>2]);Ue=ea(g[d+(Qc*272|0)+176>>2]);Ve=ea(g[d+(Qc*272|0)+180>>2]);We=ea(g[d+(Qc*272|0)+184>>2]);Xe=ea(g[d+(Qc*272|0)+188>>2]);Ye=ea(g[d+(Qc*272|0)+192>>2]);Ze=ea(g[d+(Qc*272|0)+196>>2]);_e=ea(g[d+(Qc*272|0)+200>>2]);$e=ea(g[d+(Qc*272|0)+204>>2]);af=ea(g[d+(Qc*272|0)+208>>2]);bf=ea(g[d+(Qc*272|0)+212>>2]);cf=ea(g[d+(Qc*272|0)+216>>2]);df=ea(ea(ea(se*we)-Ae)-ea(se*ea(ea(Nd+ea(ea(ea(t*Ie)+ea(xd*Me))+ea(Fd*Qe)))-ea(Rd+ea(ea(ea(td*Ue)+ea(Bd*Ye))+ea(Jd*af))))));af=ea(ea(ea(te*xe)-Be)-ea(te*ea(ea(Od+ea(ea(ea(H*Je)+ea(yd*Ne))+ea(Gd*Re)))-ea(qa+ea(ea(ea(ud*Ve)+ea(Cd*Ze))+ea(Kd*bf))))));bf=ea(ea(ea(ue*ye)-Ce)-ea(ue*ea(ea(Pd+ea(ea(ea(V*Ke)+ea(zd*Oe))+ea(Hd*Se)))-ea(ba+ea(ea(ea(vd*We)+ea(Dd*_e))+ea(Ld*cf))))));cf=ea(ea(ea(ve*ze)-De)-ea(ve*ea(ea(Qd+ea(ea(ea(ia*Le)+ea(Ad*Pe))+ea(Id*Te)))-ea(P+ea(ea(ea(wd*Xe)+ea(Ed*$e))+ea(Md*ea(g[d+(Qc*272|0)+220>>2])))))));$e=ea(-le);Xe=ea(-ne);Te=ea(-pe);Pe=ea(-re);Le=ea(le+(df>$e?df:$e));$e=ea(ne+(af>Xe?af:Xe));Xe=ea(pe+(bf>Te?bf:Te));Te=ea(re+(cf>Pe?cf:Pe));Pe=Le<Ee?Le:Ee;Ee=$e<Fe?$e:Fe;Fe=Xe<Ge?Xe:Ge;Ge=Te<He?Te:He;He=ea(Pe-le);le=ea(Ee-ne);ne=ea(Fe-pe);pe=ea(Ge-re);Nd=ea(Nd+ea(la*He));Od=ea(Od+ea(Y*le));Pd=ea(Pd+ea(K*ne));Qd=ea(Qd+ea(w*pe));Rd=ea(Rd+ea(ma*He));qa=ea(qa+ea(Z*le));ba=ea(ba+ea(L*ne));P=ea(P+ea(x*pe));re=ea(B+He);Te=ea(A+le);Xe=ea(y+ne);$e=ea(O+pe);Le=ea(t+ea(M*He));M=ea(H+ea(aa*le));aa=ea(V+ea(_*ne));_=ea(ia+ea(pa*pe));pa=ea(td+ea(_d*He));_d=ea(ud+ea($d*le));$d=ea(vd+ea(ae*ne));ae=ea(wd+ea(be*pe));be=ea(xd+ea(na*He));na=ea(yd+ea(Td*le));Td=ea(zd+ea(Ud*ne));Ud=ea(Ad+ea(Vd*pe));Vd=ea(Bd+ea(ce*He));ce=ea(Cd+ea(de*le));de=ea(Dd+ea(ee*ne));ee=ea(Ed+ea(fe*pe));fe=ea(Fd+ea(Wd*He));Wd=ea(Gd+ea(Xd*le));Xd=ea(Hd+ea(Yd*ne));Yd=ea(Id+ea(Zd*pe));Zd=ea(Jd+ea(ge*He));He=ea(Kd+ea(he*le));le=ea(Ld+ea(ie*ne));ne=ea(Md+ea(je*pe));g[ke>>2]=Pe;g[me>>2]=Ee;g[oe>>2]=Fe;g[qe>>2]=Ge;g[sa+(Qc<<4)>>2]=Pe;g[sa+(Qc<<4)+4>>2]=Ee;g[sa+(Qc<<4)+8>>2]=Fe;g[sa+(Qc<<4)+12>>2]=Ge;if((Sd|0)==(Rc|0)){Tc=_;Uc=aa;Vc=M;Wc=Le;Xc=Ud;Yc=Td;Zc=na;_c=be;$c=Yd;ad=Xd;bd=Wd;cd=fe;dd=ae;ed=$d;fd=_d;gd=pa;hd=ee;id=de;jd=ce;kd=Vd;ld=ne;md=le;nd=He;od=Zd;pd=$e;qd=Xe;rd=Te;sd=re;break}else{t=Le;H=M;V=aa;ia=_;td=pa;ud=_d;vd=$d;wd=ae;xd=be;yd=na;zd=Td;Ad=Ud;Bd=Vd;Cd=ce;Dd=de;Ed=ee;Fd=fe;Gd=Wd;Hd=Xd;Id=Yd;Jd=Zd;Kd=He;Ld=le;Md=ne;B=re;A=Te;y=Xe;O=$e;Qc=Sd}}}O=ea(ic+ea(ra*sd));y=ea(hc+ea(ca*rd));A=ea(gc+ea(Q*qd));B=ea(fc+ea(C*pd));Md=ea(ec+ea(r*sd));Ld=ea(dc+ea(F*rd));Kd=ea(cc+ea(T*qd));Jd=ea(bc+ea(ga*pd));Id=ea(ac+ea(u*sd));Hd=ea($b+ea(I*rd));Gd=ea(_b+ea(W*qd));Fd=ea(Zb+ea(ja*pd));Ed=ea(Yb+ea(p*sd));Dd=ea(Xb+ea(D*rd));Cd=ea(Wb+ea(R*qd));Bd=ea(Vb+ea(da*pd));Ad=ea(qc+ea(s*sd));zd=ea(pc+ea(G*rd));yd=ea(oc+ea(U*qd));xd=ea(nc+ea(ha*pd));wd=ea(mc+ea(q*sd));vd=ea(lc+ea(E*rd));ud=ea(kc+ea(S*qd));td=ea(jc+ea(fa*pd));if(Sc>>>0>=ta>>>0){ua=B;va=A;wa=y;xa=O;ya=Fd;za=Gd;Aa=Hd;Ba=Id;Ca=xd;Da=yd;Ea=zd;Fa=Ad;Ga=Jd;Ha=Kd;Ia=Ld;Ja=Md;Ka=Bd;La=Cd;Ma=Dd;Na=Ed;Oa=td;Pa=ud;Qa=vd;Ra=wd;Sa=Tc;Ta=Uc;Ua=Vc;Va=Wc;Wa=Xc;Xa=Yc;Ya=Zc;Za=_c;_a=$c;$a=ad;ab=bd;bb=cd;cb=dd;db=ed;eb=fd;fb=gd;gb=hd;hb=id;ib=jd;jb=kd;kb=ld;lb=md;mb=nd;nb=od;break}Ub=b[Sc+2>>1]|0;Vb=Bd;Wb=Cd;Xb=Dd;Yb=Ed;Zb=Fd;_b=Gd;$b=Hd;ac=Id;bc=Jd;cc=Kd;dc=Ld;ec=Md;fc=B;gc=A;hc=y;ic=O;jc=td;kc=ud;lc=vd;mc=wd;nc=xd;oc=yd;pc=zd;qc=Ad;rc=od;sc=nd;tc=md;uc=ld;vc=kd;wc=jd;xc=id;yc=hd;zc=gd;Ac=fd;Bc=ed;Cc=dd;Dc=cd;Ec=bd;Fc=ad;Gc=$c;Hc=_c;Ic=Zc;Jc=Yc;Kc=Xc;Lc=Wc;Mc=Vc;Nc=Uc;Oc=Tc;Pc=Sc}g[f>>2]=xa;ob=f+4|0;g[ob>>2]=Ba;pb=f+8|0;g[pb>>2]=Fa;g[j>>2]=wa;qb=j+4|0;g[qb>>2]=Aa;rb=j+8|0;g[rb>>2]=Ea;g[l>>2]=va;sb=l+4|0;g[sb>>2]=za;tb=l+8|0;g[tb>>2]=Da;g[n>>2]=ua;ub=n+4|0;g[ub>>2]=ya;vb=n+8|0;g[vb>>2]=Ca;g[h>>2]=Ja;wb=h+4|0;g[wb>>2]=Na;xb=h+8|0;g[xb>>2]=Ra;g[k>>2]=Ia;yb=k+4|0;g[yb>>2]=Ma;zb=k+8|0;g[zb>>2]=Qa;g[m>>2]=Ha;Ab=m+4|0;g[Ab>>2]=La;Bb=m+8|0;g[Bb>>2]=Pa;g[o>>2]=Ga;Cb=o+4|0;g[Cb>>2]=Ka;Db=o+8|0;g[Db>>2]=Oa;g[v>>2]=Va;Eb=f+20|0;g[Eb>>2]=Za;Fb=f+24|0;g[Fb>>2]=bb;g[J>>2]=Ua;Gb=j+20|0;g[Gb>>2]=Ya;Hb=j+24|0;g[Hb>>2]=ab;g[X>>2]=Ta;Ib=l+20|0;g[Ib>>2]=Xa;Jb=l+24|0;g[Jb>>2]=$a;g[ka>>2]=Sa;Kb=n+20|0;g[Kb>>2]=Wa;Lb=n+24|0;g[Lb>>2]=_a;g[z>>2]=fb;Mb=h+20|0;g[Mb>>2]=jb;Nb=h+24|0;g[Nb>>2]=nb;g[N>>2]=eb;Ob=k+20|0;g[Ob>>2]=ib;Pb=k+24|0;g[Pb>>2]=mb;g[$>>2]=db;Qb=m+20|0;g[Qb>>2]=hb;Rb=m+24|0;g[Rb>>2]=lb;g[oa>>2]=cb;Sb=o+20|0;g[Sb>>2]=gb;Tb=o+24|0;g[Tb>>2]=kb;i=e;return}function m1a(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=Im,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=0,$a=0,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=0,Tb=Im,Ub=0,Vb=Im,Wb=0,Xb=Im,Yb=0,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im;e=i;f=c[d>>2]|0;h=c[d+32>>2]|0;j=c[d+64>>2]|0;k=c[d+96>>2]|0;l=ea(g[f>>2]);m=ea(g[f+4>>2]);n=ea(g[f+8>>2]);o=f+16|0;p=ea(g[o>>2]);q=ea(g[o+4>>2]);r=ea(g[o+8>>2]);s=ea(g[h>>2]);t=ea(g[h+4>>2]);u=ea(g[h+8>>2]);v=h+16|0;w=ea(g[v>>2]);x=ea(g[v+4>>2]);y=ea(g[v+8>>2]);z=ea(g[j>>2]);A=ea(g[j+4>>2]);B=ea(g[j+8>>2]);C=j+16|0;D=ea(g[C>>2]);E=ea(g[C+4>>2]);F=ea(g[C+8>>2]);G=ea(g[k>>2]);H=ea(g[k+4>>2]);I=ea(g[k+8>>2]);J=k+16|0;K=ea(g[J>>2]);L=ea(g[J+4>>2]);M=ea(g[J+8>>2]);N=c[d+16>>2]|0;d=b[N+2>>1]|0;O=N+(d&65535)|0;if(!(d<<16>>16)){P=G;Q=z;R=s;S=l;T=H;U=A;V=t;W=m;X=I;Y=B;Z=u;_=n;$=K;aa=D;ba=w;ca=p;da=L;fa=E;ga=x;ha=q;ia=M;ja=F;ka=y;la=r;g[f>>2]=S;ma=f+4|0;g[ma>>2]=W;na=f+8|0;g[na>>2]=_;g[h>>2]=R;oa=h+4|0;g[oa>>2]=V;pa=h+8|0;g[pa>>2]=Z;g[j>>2]=Q;qa=j+4|0;g[qa>>2]=U;ra=j+8|0;g[ra>>2]=Y;g[k>>2]=P;sa=k+4|0;g[sa>>2]=T;ta=k+8|0;g[ta>>2]=X;g[o>>2]=ca;ua=f+20|0;g[ua>>2]=ha;va=f+24|0;g[va>>2]=la;g[v>>2]=ba;wa=h+20|0;g[wa>>2]=ga;xa=h+24|0;g[xa>>2]=ka;g[C>>2]=aa;ya=j+20|0;g[ya>>2]=fa;za=j+24|0;g[za>>2]=ja;g[J>>2]=$;Aa=k+20|0;g[Aa>>2]=da;Ba=k+24|0;g[Ba>>2]=ia;i=e;return}else{Ca=H;Da=A;Ea=t;Fa=m;Ga=G;Ha=z;Ia=s;Ja=l;Ka=I;La=B;Ma=u;Na=n;Oa=r;Pa=y;Qa=F;Ra=M;Sa=q;Ta=x;Ua=E;Va=L;Wa=p;Xa=w;Ya=D;Za=K;_a=d;$a=N}while(1){N=$a+((_a&65535)+64)|0;d=$a+112|0;ab=a[$a+1>>0]|0;bb=ab&255;cb=d+(bb*176|0)|0;K=ea(g[$a+80>>2]);D=ea(g[$a+84>>2]);w=ea(g[$a+88>>2]);p=ea(g[$a+92>>2]);L=ea(g[$a+32>>2]);E=ea(g[$a+36>>2]);x=ea(g[$a+40>>2]);q=ea(g[$a+44>>2]);M=ea(g[$a+48>>2]);F=ea(g[$a+52>>2]);y=ea(g[$a+56>>2]);r=ea(g[$a+60>>2]);n=ea(g[$a+64>>2]);u=ea(g[$a+68>>2]);B=ea(g[$a+72>>2]);I=ea(g[$a+76>>2]);l=ea(K*L);s=ea(D*E);z=ea(w*x);G=ea(p*q);m=ea(K*M);t=ea(D*F);A=ea(w*y);H=ea(p*r);db=ea(K*n);eb=ea(D*u);fb=ea(w*B);gb=ea(p*I);if(!(ab<<24>>24)){hb=Za;ib=Ya;jb=Xa;kb=Wa;lb=Va;mb=Ua;nb=Ta;ob=Sa;pb=Ra;qb=Qa;rb=Pa;sb=Oa;tb=ea(0.0);ub=ea(0.0);vb=ea(0.0);wb=ea(0.0)}else{xb=Wa;yb=Xa;zb=Ya;Ab=Za;Bb=Sa;Cb=Ta;Db=Ua;Eb=Va;Fb=Oa;Gb=Pa;Hb=Qa;Ib=Ra;Jb=ea(ea(ea(Ja*L)+ea(Fa*M))+ea(Na*n));n=ea(ea(ea(Ia*E)+ea(Ea*F))+ea(Ma*u));u=ea(ea(ea(Ha*x)+ea(Da*y))+ea(La*B));B=ea(ea(ea(Ga*q)+ea(Ca*r))+ea(Ka*I));I=ea(0.0);r=ea(0.0);q=ea(0.0);y=ea(0.0);ab=0;while(1){Kb=ab+1|0;x=ea(g[d+(ab*176|0)+48>>2]);F=ea(g[d+(ab*176|0)+52>>2]);E=ea(g[d+(ab*176|0)+56>>2]);M=ea(g[d+(ab*176|0)+60>>2]);L=ea(g[d+(ab*176|0)+64>>2]);Lb=ea(g[d+(ab*176|0)+68>>2]);Mb=ea(g[d+(ab*176|0)+72>>2]);Nb=ea(g[d+(ab*176|0)+76>>2]);Ob=ea(g[d+(ab*176|0)+80>>2]);Pb=ea(g[d+(ab*176|0)+84>>2]);Qb=ea(g[d+(ab*176|0)+88>>2]);Rb=ea(g[d+(ab*176|0)+92>>2]);Sb=d+(ab*176|0)+96|0;Tb=ea(g[Sb>>2]);Ub=d+(ab*176|0)+100|0;Vb=ea(g[Ub>>2]);Wb=d+(ab*176|0)+104|0;Xb=ea(g[Wb>>2]);Yb=d+(ab*176|0)+108|0;Zb=ea(g[Yb>>2]);_b=ea(g[d+(ab*176|0)+112>>2]);$b=ea(g[d+(ab*176|0)+116>>2]);ac=ea(g[d+(ab*176|0)+120>>2]);bc=ea(g[d+(ab*176|0)+124>>2]);cc=ea(g[d+(ab*176|0)+128>>2]);dc=ea(g[d+(ab*176|0)+132>>2]);ec=ea(g[d+(ab*176|0)+136>>2]);fc=ea(g[d+(ab*176|0)+140>>2]);gc=ea(g[d+(ab*176|0)+144>>2]);hc=ea(g[d+(ab*176|0)+148>>2]);ic=ea(g[d+(ab*176|0)+152>>2]);jc=ea(g[d+(ab*176|0)+156>>2]);kc=ea(g[d+(ab*176|0)+160>>2]);lc=ea(g[d+(ab*176|0)+164>>2]);mc=ea(g[d+(ab*176|0)+168>>2]);nc=ea(g[d+(ab*176|0)+172>>2]);oc=ea(g[d+(ab*176|0)>>2]);pc=ea(g[d+(ab*176|0)+4>>2]);qc=ea(g[d+(ab*176|0)+8>>2]);rc=ea(g[d+(ab*176|0)+12>>2]);sc=ea(g[d+(ab*176|0)+16>>2]);tc=ea(g[d+(ab*176|0)+20>>2]);uc=ea(g[d+(ab*176|0)+24>>2]);vc=ea(g[d+(ab*176|0)+28>>2]);wc=ea(g[d+(ab*176|0)+32>>2]);xc=ea(g[d+(ab*176|0)+36>>2]);yc=ea(g[d+(ab*176|0)+40>>2]);zc=ea(ea(ea(_b*cc)-gc)-ea(_b*ea(Jb+ea(ea(ea(xb*oc)+ea(Bb*sc))+ea(Fb*wc)))));wc=ea(ea(ea($b*dc)-hc)-ea($b*ea(n+ea(ea(ea(yb*pc)+ea(Cb*tc))+ea(Gb*xc)))));xc=ea(ea(ea(ac*ec)-ic)-ea(ac*ea(u+ea(ea(ea(zb*qc)+ea(Db*uc))+ea(Hb*yc)))));yc=ea(ea(ea(bc*fc)-jc)-ea(bc*ea(B+ea(ea(ea(Ab*rc)+ea(Eb*vc))+ea(Ib*ea(g[d+(ab*176|0)+44>>2]))))));vc=ea(-Tb);rc=ea(-Vb);bc=ea(-Xb);jc=ea(-Zb);fc=ea(Tb+(zc>vc?zc:vc));vc=ea(Vb+(wc>rc?wc:rc));rc=ea(Xb+(xc>bc?xc:bc));bc=ea(Zb+(yc>jc?yc:jc));jc=fc<kc?fc:kc;kc=vc<lc?vc:lc;lc=rc<mc?rc:mc;mc=bc<nc?bc:nc;nc=ea(jc-Tb);Tb=ea(kc-Vb);Vb=ea(lc-Xb);Xb=ea(mc-Zb);Jb=ea(Jb+ea(K*nc));n=ea(n+ea(D*Tb));u=ea(u+ea(w*Vb));B=ea(B+ea(p*Xb));Zb=ea(I+nc);bc=ea(r+Tb);rc=ea(q+Vb);vc=ea(y+Xb);fc=ea(xb+ea(x*nc));x=ea(yb+ea(F*Tb));F=ea(zb+ea(E*Vb));E=ea(Ab+ea(M*Xb));M=ea(Bb+ea(L*nc));L=ea(Cb+ea(Lb*Tb));Lb=ea(Db+ea(Mb*Vb));Mb=ea(Eb+ea(Nb*Xb));Nb=ea(Fb+ea(Ob*nc));nc=ea(Gb+ea(Pb*Tb));Tb=ea(Hb+ea(Qb*Vb));Vb=ea(Ib+ea(Rb*Xb));g[Sb>>2]=jc;g[Ub>>2]=kc;g[Wb>>2]=lc;g[Yb>>2]=mc;g[N+(ab<<4)>>2]=jc;g[N+(ab<<4)+4>>2]=kc;g[N+(ab<<4)+8>>2]=lc;g[N+(ab<<4)+12>>2]=mc;if((Kb|0)==(bb|0)){hb=E;ib=F;jb=x;kb=fc;lb=Mb;mb=Lb;nb=L;ob=M;pb=Vb;qb=Tb;rb=nc;sb=Nb;tb=vc;ub=rc;vb=bc;wb=Zb;break}else{xb=fc;yb=x;zb=F;Ab=E;Bb=M;Cb=L;Db=Lb;Eb=Mb;Fb=Nb;Gb=nc;Hb=Tb;Ib=Vb;I=Zb;r=bc;q=rc;y=vc;ab=Kb}}}y=ea(Ja+ea(l*wb));q=ea(Ia+ea(s*vb));r=ea(Ha+ea(z*ub));I=ea(Ga+ea(G*tb));Ib=ea(Fa+ea(m*wb));Hb=ea(Ea+ea(t*vb));Gb=ea(Da+ea(A*ub));Fb=ea(Ca+ea(H*tb));Eb=ea(Na+ea(db*wb));Db=ea(Ma+ea(eb*vb));Cb=ea(La+ea(fb*ub));Bb=ea(Ka+ea(gb*tb));if(cb>>>0>=O>>>0){P=I;Q=r;R=q;S=y;T=Fb;U=Gb;V=Hb;W=Ib;X=Bb;Y=Cb;Z=Db;_=Eb;$=hb;aa=ib;ba=jb;ca=kb;da=lb;fa=mb;ga=nb;ha=ob;ia=pb;ja=qb;ka=rb;la=sb;break}Ca=Fb;Da=Gb;Ea=Hb;Fa=Ib;Ga=I;Ha=r;Ia=q;Ja=y;Ka=Bb;La=Cb;Ma=Db;Na=Eb;Oa=sb;Pa=rb;Qa=qb;Ra=pb;Sa=ob;Ta=nb;Ua=mb;Va=lb;Wa=kb;Xa=jb;Ya=ib;Za=hb;_a=b[cb+2>>1]|0;$a=cb}g[f>>2]=S;ma=f+4|0;g[ma>>2]=W;na=f+8|0;g[na>>2]=_;g[h>>2]=R;oa=h+4|0;g[oa>>2]=V;pa=h+8|0;g[pa>>2]=Z;g[j>>2]=Q;qa=j+4|0;g[qa>>2]=U;ra=j+8|0;g[ra>>2]=Y;g[k>>2]=P;sa=k+4|0;g[sa>>2]=T;ta=k+8|0;g[ta>>2]=X;g[o>>2]=ca;ua=f+20|0;g[ua>>2]=ha;va=f+24|0;g[va>>2]=la;g[v>>2]=ba;wa=h+20|0;g[wa>>2]=ga;xa=h+24|0;g[xa>>2]=ka;g[C>>2]=aa;ya=j+20|0;g[ya>>2]=fa;za=j+24|0;g[za>>2]=ja;g[J>>2]=$;Aa=k+20|0;g[Aa>>2]=da;Ba=k+24|0;g[Ba>>2]=ia;i=e;return}function n1a(e){e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=Im,na=Im,oa=Im,pa=0,qa=Im,ra=Im,sa=Im,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=0,Qc=0,Rc=0,Sc=0,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=Im,Hd=Im,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=Im,Ud=Im,Vd=Im,Wd=Im,Xd=Im,Yd=Im,Zd=0,_d=0,$d=0,ae=Im,be=Im,ce=Im,de=Im,ee=Im,fe=Im,ge=Im,he=Im,ie=Im,je=Im,ke=Im,le=Im,me=Im,ne=Im,oe=Im,pe=Im,qe=Im,re=Im,se=Im,te=Im,ue=Im,ve=Im,we=Im,xe=Im,ye=Im,ze=Im,Ae=Im,Be=Im,Ce=Im,De=Im,Ee=Im,Fe=Im,Ge=Im,He=Im,Ie=Im,Je=Im,Ke=Im,Le=Im,Me=Im,Ne=Im,Oe=Im,Pe=Im,Qe=Im,Re=Im,Se=Im,Te=Im,Ue=Im,Ve=Im,We=Im,Xe=Im,Ye=Im,Ze=Im,_e=Im,$e=Im,af=Im,bf=Im,cf=Im,df=Im,ef=Im,ff=Im,gf=Im,hf=Im,jf=Im,kf=Im,lf=Im,mf=Im,nf=Im,of=Im,pf=Im,qf=0,rf=Im,sf=0,tf=Im,uf=0,vf=Im,wf=Im,xf=Im,yf=Im,zf=Im,Af=Im,Bf=Im,Cf=Im,Df=Im,Ef=Im,Ff=Im,Gf=Im,Hf=Im,If=Im,Jf=Im,Kf=Im,Lf=Im,Mf=Im,Nf=Im,Of=Im,Pf=Im,Qf=Im,Rf=Im,Sf=Im,Tf=Im,Uf=Im,Vf=Im,Wf=Im,Xf=Im,Yf=Im,Zf=Im,_f=Im,$f=Im;f=i;h=c[e>>2]|0;j=c[e+4>>2]|0;k=c[e+32>>2]|0;l=c[e+36>>2]|0;m=c[e+64>>2]|0;n=c[e+68>>2]|0;o=c[e+96>>2]|0;p=c[e+100>>2]|0;q=ea(g[h>>2]);r=ea(g[h+4>>2]);s=ea(g[h+8>>2]);t=ea(g[j>>2]);u=ea(g[j+4>>2]);v=ea(g[j+8>>2]);w=h+16|0;x=ea(g[w>>2]);y=ea(g[w+4>>2]);z=ea(g[w+8>>2]);A=j+16|0;B=ea(g[A>>2]);C=ea(g[A+4>>2]);D=ea(g[A+8>>2]);E=ea(g[k>>2]);F=ea(g[k+4>>2]);G=ea(g[k+8>>2]);H=ea(g[l>>2]);I=ea(g[l+4>>2]);J=ea(g[l+8>>2]);K=k+16|0;L=ea(g[K>>2]);M=ea(g[K+4>>2]);N=ea(g[K+8>>2]);O=l+16|0;P=ea(g[O>>2]);Q=ea(g[O+4>>2]);R=ea(g[O+8>>2]);S=ea(g[m>>2]);T=ea(g[m+4>>2]);U=ea(g[m+8>>2]);V=ea(g[n>>2]);W=ea(g[n+4>>2]);X=ea(g[n+8>>2]);Y=m+16|0;Z=ea(g[Y>>2]);_=ea(g[Y+4>>2]);$=ea(g[Y+8>>2]);aa=n+16|0;ba=ea(g[aa>>2]);ca=ea(g[aa+4>>2]);da=ea(g[aa+8>>2]);fa=ea(g[o>>2]);ga=ea(g[o+4>>2]);ha=ea(g[o+8>>2]);ia=ea(g[p>>2]);ja=ea(g[p+4>>2]);ka=ea(g[p+8>>2]);la=o+16|0;ma=ea(g[la>>2]);na=ea(g[la+4>>2]);oa=ea(g[la+8>>2]);pa=p+16|0;qa=ea(g[pa>>2]);ra=ea(g[pa+4>>2]);sa=ea(g[pa+8>>2]);ta=c[e+16>>2]|0;ua=b[e+26>>1]|0;e=ta+((ua&65535)<<4)|0;if(!(ua<<16>>16)){va=fa;wa=S;xa=E;ya=q;za=ga;Aa=T;Ba=F;Ca=r;Da=ha;Ea=U;Fa=G;Ga=s;Ha=ia;Ia=V;Ja=H;Ka=t;La=ja;Ma=W;Na=I;Oa=u;Pa=ka;Qa=X;Ra=J;Sa=v;Ta=ma;Ua=Z;Va=L;Wa=x;Xa=na;Ya=_;Za=M;_a=y;$a=oa;ab=$;bb=N;cb=z;db=qa;eb=ba;fb=P;gb=B;hb=ra;ib=ca;jb=Q;kb=C;lb=sa;mb=da;nb=R;ob=D;g[h>>2]=ya;pb=h+4|0;g[pb>>2]=Ca;qb=h+8|0;g[qb>>2]=Ga;g[k>>2]=xa;rb=k+4|0;g[rb>>2]=Ba;sb=k+8|0;g[sb>>2]=Fa;g[m>>2]=wa;tb=m+4|0;g[tb>>2]=Aa;ub=m+8|0;g[ub>>2]=Ea;g[o>>2]=va;vb=o+4|0;g[vb>>2]=za;wb=o+8|0;g[wb>>2]=Da;g[j>>2]=Ka;xb=j+4|0;g[xb>>2]=Oa;yb=j+8|0;g[yb>>2]=Sa;g[l>>2]=Ja;zb=l+4|0;g[zb>>2]=Na;Ab=l+8|0;g[Ab>>2]=Ra;g[n>>2]=Ia;Bb=n+4|0;g[Bb>>2]=Ma;Cb=n+8|0;g[Cb>>2]=Qa;g[p>>2]=Ha;Db=p+4|0;g[Db>>2]=La;Eb=p+8|0;g[Eb>>2]=Pa;g[w>>2]=Wa;Fb=h+20|0;g[Fb>>2]=_a;Gb=h+24|0;g[Gb>>2]=cb;g[K>>2]=Va;Hb=k+20|0;g[Hb>>2]=Za;Ib=k+24|0;g[Ib>>2]=bb;g[Y>>2]=Ua;Jb=m+20|0;g[Jb>>2]=Ya;Kb=m+24|0;g[Kb>>2]=ab;g[la>>2]=Ta;Lb=o+20|0;g[Lb>>2]=Xa;Mb=o+24|0;g[Mb>>2]=$a;g[A>>2]=gb;Nb=j+20|0;g[Nb>>2]=kb;Ob=j+24|0;g[Ob>>2]=ob;g[O>>2]=fb;Pb=l+20|0;g[Pb>>2]=jb;Qb=l+24|0;g[Qb>>2]=nb;g[aa>>2]=eb;Rb=n+20|0;g[Rb>>2]=ib;Sb=n+24|0;g[Sb>>2]=mb;g[pa>>2]=db;Tb=p+20|0;g[Tb>>2]=hb;Ub=p+24|0;g[Ub>>2]=lb;i=f;return}else{Vb=D;Wb=R;Xb=da;Yb=sa;Zb=C;_b=Q;$b=ca;ac=ra;bc=B;cc=P;dc=ba;ec=qa;fc=z;gc=N;hc=$;ic=oa;jc=y;kc=M;lc=_;mc=na;nc=x;oc=L;pc=Z;qc=ma;rc=v;sc=J;tc=X;uc=ka;vc=u;wc=I;xc=W;yc=ja;zc=t;Ac=H;Bc=V;Cc=ia;Dc=s;Ec=G;Fc=U;Gc=ha;Hc=r;Ic=F;Jc=T;Kc=ga;Lc=q;Mc=E;Nc=S;Oc=fa;Pc=ta}while(1){ta=Pc+64|0;ua=Pc+(((d[Pc+1>>0]|0)<<4)+64)|0;Qc=a[Pc+2>>0]|0;Rc=Qc&255;Sc=ua+(Rc*288|0)|0;fa=ea(g[Pc+16>>2]);S=ea(g[Pc+20>>2]);E=ea(g[Pc+24>>2]);q=ea(g[Pc+28>>2]);ga=ea(g[Pc+32>>2]);T=ea(g[Pc+36>>2]);F=ea(g[Pc+40>>2]);r=ea(g[Pc+44>>2]);ha=ea(g[Pc+48>>2]);U=ea(g[Pc+52>>2]);G=ea(g[Pc+56>>2]);s=ea(g[Pc+60>>2]);if(!(Qc<<24>>24)){Tc=Oc;Uc=Nc;Vc=Mc;Wc=Lc;Xc=Kc;Yc=Jc;Zc=Ic;_c=Hc;$c=Gc;ad=Fc;bd=Ec;cd=Dc;dd=Cc;ed=Bc;fd=Ac;gd=zc;hd=yc;id=xc;jd=wc;kd=vc;ld=uc;md=tc;nd=sc;od=rc;pd=qc;qd=pc;rd=oc;sd=nc;td=mc;ud=lc;vd=kc;wd=jc;xd=ic;yd=hc;zd=gc;Ad=fc;Bd=ec;Cd=dc;Dd=cc;Ed=bc;Fd=ac;Gd=$b;Hd=_b;Id=Zb;Jd=Yb;Kd=Xb;Ld=Wb;Md=Vb}else{Qc=Pc+12|0;ia=Lc;V=Mc;H=Nc;t=Oc;ja=nc;W=oc;I=pc;u=qc;ka=zc;X=Ac;J=Bc;v=Cc;ma=bc;Z=cc;L=dc;x=ec;na=Hc;_=Ic;M=Jc;y=Kc;oa=jc;$=kc;N=lc;z=mc;qa=vc;ba=wc;P=xc;B=yc;ra=Zb;ca=_b;Q=$b;C=ac;sa=Dc;da=Ec;R=Fc;D=Gc;Nd=fc;Od=gc;Pd=hc;Qd=ic;Rd=rc;Sd=sc;Td=tc;Ud=uc;Vd=Vb;Wd=Wb;Xd=Xb;Yd=Yb;Zd=0;while(1){_d=Zd+1|0;$d=Zd>>>(c[Qc>>2]|0);ae=ea(g[ta+($d<<4)>>2]);be=ea(g[ta+($d<<4)+4>>2]);ce=ea(g[ta+($d<<4)+8>>2]);de=ea(fa*ae);ae=ea(S*be);be=ea(E*ce);ce=ea(q*ea(g[ta+($d<<4)+12>>2]));ee=ea(-de);fe=ea(-ae);ge=ea(-be);he=ea(-ce);ie=ea(g[ua+(Zd*288|0)+96>>2]);je=ea(g[ua+(Zd*288|0)+100>>2]);ke=ea(g[ua+(Zd*288|0)+104>>2]);le=ea(g[ua+(Zd*288|0)+108>>2]);me=ea(g[ua+(Zd*288|0)+112>>2]);ne=ea(g[ua+(Zd*288|0)+116>>2]);oe=ea(g[ua+(Zd*288|0)+120>>2]);pe=ea(g[ua+(Zd*288|0)+124>>2]);qe=ea(g[ua+(Zd*288|0)+128>>2]);re=ea(g[ua+(Zd*288|0)+132>>2]);se=ea(g[ua+(Zd*288|0)+136>>2]);te=ea(g[ua+(Zd*288|0)+140>>2]);ue=ea(g[ua+(Zd*288|0)+240>>2]);ve=ea(g[ua+(Zd*288|0)+244>>2]);we=ea(g[ua+(Zd*288|0)+248>>2]);xe=ea(g[ua+(Zd*288|0)+252>>2]);ye=ea(g[ua+(Zd*288|0)+256>>2]);ze=ea(g[ua+(Zd*288|0)+260>>2]);Ae=ea(g[ua+(Zd*288|0)+264>>2]);Be=ea(g[ua+(Zd*288|0)+268>>2]);Ce=ea(g[ua+(Zd*288|0)+272>>2]);De=ea(g[ua+(Zd*288|0)+276>>2]);Ee=ea(g[ua+(Zd*288|0)+280>>2]);Fe=ea(g[ua+(Zd*288|0)+284>>2]);Ge=ea(g[ua+(Zd*288|0)>>2]);He=ea(g[ua+(Zd*288|0)+4>>2]);Ie=ea(g[ua+(Zd*288|0)+8>>2]);Je=ea(g[ua+(Zd*288|0)+12>>2]);Ke=ea(g[ua+(Zd*288|0)+16>>2]);Le=ea(g[ua+(Zd*288|0)+20>>2]);Me=ea(g[ua+(Zd*288|0)+24>>2]);Ne=ea(g[ua+(Zd*288|0)+28>>2]);Oe=ea(g[ua+(Zd*288|0)+32>>2]);Pe=ea(g[ua+(Zd*288|0)+36>>2]);Qe=ea(g[ua+(Zd*288|0)+40>>2]);Re=ea(g[ua+(Zd*288|0)+44>>2]);Se=ea(g[ua+(Zd*288|0)+48>>2]);Te=ea(g[ua+(Zd*288|0)+52>>2]);Ue=ea(g[ua+(Zd*288|0)+56>>2]);Ve=ea(g[ua+(Zd*288|0)+60>>2]);We=ea(g[ua+(Zd*288|0)+64>>2]);Xe=ea(g[ua+(Zd*288|0)+68>>2]);Ye=ea(g[ua+(Zd*288|0)+72>>2]);Ze=ea(g[ua+(Zd*288|0)+76>>2]);_e=ea(g[ua+(Zd*288|0)+80>>2]);$e=ea(g[ua+(Zd*288|0)+84>>2]);af=ea(g[ua+(Zd*288|0)+88>>2]);bf=ea(g[ua+(Zd*288|0)+92>>2]);cf=ea(g[ua+(Zd*288|0)+192>>2]);df=ea(g[ua+(Zd*288|0)+196>>2]);ef=ea(g[ua+(Zd*288|0)+200>>2]);ff=ea(g[ua+(Zd*288|0)+204>>2]);gf=ea(g[ua+(Zd*288|0)+208>>2]);hf=ea(g[ua+(Zd*288|0)+212>>2]);jf=ea(g[ua+(Zd*288|0)+216>>2]);kf=ea(g[ua+(Zd*288|0)+220>>2]);lf=ea(g[ua+(Zd*288|0)+224>>2]);mf=ea(g[ua+(Zd*288|0)+228>>2]);nf=ea(g[ua+(Zd*288|0)+232>>2]);of=ea(g[ua+(Zd*288|0)+236>>2]);$d=ua+(Zd*288|0)+144|0;pf=ea(g[$d>>2]);qf=ua+(Zd*288|0)+148|0;rf=ea(g[qf>>2]);sf=ua+(Zd*288|0)+152|0;tf=ea(g[sf>>2]);uf=ua+(Zd*288|0)+156|0;vf=ea(g[uf>>2]);wf=ea(g[ua+(Zd*288|0)+160>>2]);xf=ea(g[ua+(Zd*288|0)+164>>2]);yf=ea(g[ua+(Zd*288|0)+168>>2]);zf=ea(g[ua+(Zd*288|0)+172>>2]);Af=ea(g[ua+(Zd*288|0)+176>>2]);Bf=ea(g[ua+(Zd*288|0)+180>>2]);Cf=ea(g[ua+(Zd*288|0)+184>>2]);Df=ea(ga*Ge);Ef=ea(T*He);Ff=ea(F*Ie);Gf=ea(r*Je);Hf=ea(ha*Ge);If=ea(U*He);Jf=ea(G*Ie);Kf=ea(s*Je);Lf=ea(ga*Ke);Mf=ea(T*Le);Nf=ea(F*Me);Of=ea(r*Ne);Pf=ea(ha*Ke);Qf=ea(U*Le);Rf=ea(G*Me);Sf=ea(s*Ne);Tf=ea(ga*Oe);Uf=ea(T*Pe);Vf=ea(F*Qe);Wf=ea(r*Re);Xf=ea(ha*Oe);Yf=ea(U*Pe);Zf=ea(G*Qe);_f=ea(s*Re);$f=ea(ea(ea(ea(ea(ea(ea(ia*Ge)+ea(na*Ke))+ea(sa*Oe))+ea(ea(ea(ja*Se)+ea(oa*We))+ea(Nd*_e)))-ea(ea(ea(ea(ka*Ge)+ea(qa*Ke))+ea(Rd*Oe))+ea(ea(ea(ma*cf)+ea(ra*gf))+ea(Vd*lf))))*wf)+ea(pf-ea(wf*Af)));Af=ea(ea(ea(ea(ea(ea(ea(V*He)+ea(_*Le))+ea(da*Pe))+ea(ea(ea(W*Te)+ea($*Xe))+ea(Od*$e)))-ea(ea(ea(ea(X*He)+ea(ba*Le))+ea(Sd*Pe))+ea(ea(ea(Z*df)+ea(ca*hf))+ea(Wd*mf))))*xf)+ea(rf-ea(xf*Bf)));Bf=ea(ea(ea(ea(ea(ea(ea(H*Ie)+ea(M*Me))+ea(R*Qe))+ea(ea(ea(I*Ue)+ea(N*Ye))+ea(Pd*af)))-ea(ea(ea(ea(J*Ie)+ea(P*Me))+ea(Td*Qe))+ea(ea(ea(L*ef)+ea(Q*jf))+ea(Xd*nf))))*yf)+ea(tf-ea(yf*Cf)));Cf=ea(ea(ea(ea(ea(ea(ea(t*Je)+ea(y*Ne))+ea(D*Re))+ea(ea(ea(u*Ve)+ea(z*Ze))+ea(Qd*bf)))-ea(ea(ea(ea(v*Je)+ea(B*Ne))+ea(Ud*Re))+ea(ea(ea(x*ff)+ea(C*kf))+ea(Yd*of))))*zf)+ea(vf-ea(zf*ea(g[ua+(Zd*288|0)+188>>2]))));zf=$f<de?$f:de;de=Af<ae?Af:ae;ae=Bf<be?Bf:be;be=Cf<ce?Cf:ce;ce=zf>ee?zf:ee;ee=de>fe?de:fe;fe=ae>ge?ae:ge;ge=be>he?be:he;he=ea(ce-pf);pf=ea(ee-rf);rf=ea(fe-tf);tf=ea(ge-vf);vf=ea(ia+ea(Df*he));Df=ea(V+ea(Ef*pf));Ef=ea(H+ea(Ff*rf));Ff=ea(t+ea(Gf*tf));Gf=ea(ka+ea(Hf*he));Hf=ea(X+ea(If*pf));If=ea(J+ea(Jf*rf));Jf=ea(v+ea(Kf*tf));Kf=ea(ja+ea(ie*he));ie=ea(W+ea(je*pf));je=ea(I+ea(ke*rf));ke=ea(u+ea(le*tf));le=ea(ma+ea(ue*he));ue=ea(Z+ea(ve*pf));ve=ea(L+ea(we*rf));we=ea(x+ea(xe*tf));xe=ea(na+ea(Lf*he));Lf=ea(_+ea(Mf*pf));Mf=ea(M+ea(Nf*rf));Nf=ea(y+ea(Of*tf));Of=ea(qa+ea(Pf*he));Pf=ea(ba+ea(Qf*pf));Qf=ea(P+ea(Rf*rf));Rf=ea(B+ea(Sf*tf));Sf=ea(oa+ea(me*he));me=ea($+ea(ne*pf));ne=ea(N+ea(oe*rf));oe=ea(z+ea(pe*tf));pe=ea(ra+ea(ye*he));ye=ea(ca+ea(ze*pf));ze=ea(Q+ea(Ae*rf));Ae=ea(C+ea(Be*tf));Be=ea(sa+ea(Tf*he));Tf=ea(da+ea(Uf*pf));Uf=ea(R+ea(Vf*rf));Vf=ea(D+ea(Wf*tf));Wf=ea(Rd+ea(Xf*he));Xf=ea(Sd+ea(Yf*pf));Yf=ea(Td+ea(Zf*rf));Zf=ea(Ud+ea(_f*tf));_f=ea(Nd+ea(qe*he));qe=ea(Od+ea(re*pf));re=ea(Pd+ea(se*rf));se=ea(Qd+ea(te*tf));te=ea(Vd+ea(Ce*he));he=ea(Wd+ea(De*pf));pf=ea(Xd+ea(Ee*rf));rf=ea(Yd+ea(Fe*tf));g[$d>>2]=ce;g[qf>>2]=ee;g[sf>>2]=fe;g[uf>>2]=ge;if((_d|0)==(Rc|0)){Tc=Ff;Uc=Ef;Vc=Df;Wc=vf;Xc=Nf;Yc=Mf;Zc=Lf;_c=xe;$c=Vf;ad=Uf;bd=Tf;cd=Be;dd=Jf;ed=If;fd=Hf;gd=Gf;hd=Rf;id=Qf;jd=Pf;kd=Of;ld=Zf;md=Yf;nd=Xf;od=Wf;pd=ke;qd=je;rd=ie;sd=Kf;td=oe;ud=ne;vd=me;wd=Sf;xd=se;yd=re;zd=qe;Ad=_f;Bd=we;Cd=ve;Dd=ue;Ed=le;Fd=Ae;Gd=ze;Hd=ye;Id=pe;Jd=rf;Kd=pf;Ld=he;Md=te;break}else{ia=vf;V=Df;H=Ef;t=Ff;ja=Kf;W=ie;I=je;u=ke;ka=Gf;X=Hf;J=If;v=Jf;ma=le;Z=ue;L=ve;x=we;na=xe;_=Lf;M=Mf;y=Nf;oa=Sf;$=me;N=ne;z=oe;qa=Of;ba=Pf;P=Qf;B=Rf;ra=pe;ca=ye;Q=ze;C=Ae;sa=Be;da=Tf;R=Uf;D=Vf;Nd=_f;Od=qe;Pd=re;Qd=se;Rd=Wf;Sd=Xf;Td=Yf;Ud=Zf;Vd=te;Wd=he;Xd=pf;Yd=rf;Zd=_d}}}if(Sc>>>0<e>>>0){Vb=Md;Wb=Ld;Xb=Kd;Yb=Jd;Zb=Id;_b=Hd;$b=Gd;ac=Fd;bc=Ed;cc=Dd;dc=Cd;ec=Bd;fc=Ad;gc=zd;hc=yd;ic=xd;jc=wd;kc=vd;lc=ud;mc=td;nc=sd;oc=rd;pc=qd;qc=pd;rc=od;sc=nd;tc=md;uc=ld;vc=kd;wc=jd;xc=id;yc=hd;zc=gd;Ac=fd;Bc=ed;Cc=dd;Dc=cd;Ec=bd;Fc=ad;Gc=$c;Hc=_c;Ic=Zc;Jc=Yc;Kc=Xc;Lc=Wc;Mc=Vc;Nc=Uc;Oc=Tc;Pc=Sc}else{va=Tc;wa=Uc;xa=Vc;ya=Wc;za=Xc;Aa=Yc;Ba=Zc;Ca=_c;Da=$c;Ea=ad;Fa=bd;Ga=cd;Ha=dd;Ia=ed;Ja=fd;Ka=gd;La=hd;Ma=id;Na=jd;Oa=kd;Pa=ld;Qa=md;Ra=nd;Sa=od;Ta=pd;Ua=qd;Va=rd;Wa=sd;Xa=td;Ya=ud;Za=vd;_a=wd;$a=xd;ab=yd;bb=zd;cb=Ad;db=Bd;eb=Cd;fb=Dd;gb=Ed;hb=Fd;ib=Gd;jb=Hd;kb=Id;lb=Jd;mb=Kd;nb=Ld;ob=Md;break}}g[h>>2]=ya;pb=h+4|0;g[pb>>2]=Ca;qb=h+8|0;g[qb>>2]=Ga;g[k>>2]=xa;rb=k+4|0;g[rb>>2]=Ba;sb=k+8|0;g[sb>>2]=Fa;g[m>>2]=wa;tb=m+4|0;g[tb>>2]=Aa;ub=m+8|0;g[ub>>2]=Ea;g[o>>2]=va;vb=o+4|0;g[vb>>2]=za;wb=o+8|0;g[wb>>2]=Da;g[j>>2]=Ka;xb=j+4|0;g[xb>>2]=Oa;yb=j+8|0;g[yb>>2]=Sa;g[l>>2]=Ja;zb=l+4|0;g[zb>>2]=Na;Ab=l+8|0;g[Ab>>2]=Ra;g[n>>2]=Ia;Bb=n+4|0;g[Bb>>2]=Ma;Cb=n+8|0;g[Cb>>2]=Qa;g[p>>2]=Ha;Db=p+4|0;g[Db>>2]=La;Eb=p+8|0;g[Eb>>2]=Pa;g[w>>2]=Wa;Fb=h+20|0;g[Fb>>2]=_a;Gb=h+24|0;g[Gb>>2]=cb;g[K>>2]=Va;Hb=k+20|0;g[Hb>>2]=Za;Ib=k+24|0;g[Ib>>2]=bb;g[Y>>2]=Ua;Jb=m+20|0;g[Jb>>2]=Ya;Kb=m+24|0;g[Kb>>2]=ab;g[la>>2]=Ta;Lb=o+20|0;g[Lb>>2]=Xa;Mb=o+24|0;g[Mb>>2]=$a;g[A>>2]=gb;Nb=j+20|0;g[Nb>>2]=kb;Ob=j+24|0;g[Ob>>2]=ob;g[O>>2]=fb;Pb=l+20|0;g[Pb>>2]=jb;Qb=l+24|0;g[Qb>>2]=nb;g[aa>>2]=eb;Rb=n+20|0;g[Rb>>2]=ib;Sb=n+24|0;g[Sb>>2]=mb;g[pa>>2]=db;Tb=p+20|0;g[Tb>>2]=hb;Ub=p+24|0;g[Ub>>2]=lb;i=f;return}function o1a(e){e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=Im,M=Im,N=Im,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=0,Kb=0,Lb=0,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=0,Ec=Im,Fc=0,Gc=Im,Hc=0,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im;f=i;h=c[e>>2]|0;j=c[e+32>>2]|0;k=c[e+64>>2]|0;l=c[e+96>>2]|0;m=ea(g[h>>2]);n=ea(g[h+4>>2]);o=ea(g[h+8>>2]);p=h+16|0;q=ea(g[p>>2]);r=ea(g[p+4>>2]);s=ea(g[p+8>>2]);t=ea(g[j>>2]);u=ea(g[j+4>>2]);v=ea(g[j+8>>2]);w=j+16|0;x=ea(g[w>>2]);y=ea(g[w+4>>2]);z=ea(g[w+8>>2]);A=ea(g[k>>2]);B=ea(g[k+4>>2]);C=ea(g[k+8>>2]);D=k+16|0;E=ea(g[D>>2]);F=ea(g[D+4>>2]);G=ea(g[D+8>>2]);H=ea(g[l>>2]);I=ea(g[l+4>>2]);J=ea(g[l+8>>2]);K=l+16|0;L=ea(g[K>>2]);M=ea(g[K+4>>2]);N=ea(g[K+8>>2]);O=c[e+16>>2]|0;P=b[e+26>>1]|0;e=O+((P&65535)<<4)|0;if(!(P<<16>>16)){Q=H;R=A;S=t;T=m;U=I;V=B;W=u;X=n;Y=J;Z=C;_=v;$=o;aa=L;ba=E;ca=x;da=q;fa=M;ga=F;ha=y;ia=r;ja=N;ka=G;la=z;ma=s;g[h>>2]=T;na=h+4|0;g[na>>2]=X;oa=h+8|0;g[oa>>2]=$;g[j>>2]=S;pa=j+4|0;g[pa>>2]=W;qa=j+8|0;g[qa>>2]=_;g[k>>2]=R;ra=k+4|0;g[ra>>2]=V;sa=k+8|0;g[sa>>2]=Z;g[l>>2]=Q;ta=l+4|0;g[ta>>2]=U;ua=l+8|0;g[ua>>2]=Y;g[p>>2]=da;va=h+20|0;g[va>>2]=ia;wa=h+24|0;g[wa>>2]=ma;g[w>>2]=ca;xa=j+20|0;g[xa>>2]=ha;ya=j+24|0;g[ya>>2]=la;g[D>>2]=ba;za=k+20|0;g[za>>2]=ga;Aa=k+24|0;g[Aa>>2]=ka;g[K>>2]=aa;Ba=l+20|0;g[Ba>>2]=fa;Ca=l+24|0;g[Ca>>2]=ja;i=f;return}else{Da=s;Ea=z;Fa=G;Ga=N;Ha=r;Ia=y;Ja=F;Ka=M;La=q;Ma=x;Na=E;Oa=L;Pa=o;Qa=v;Ra=C;Sa=J;Ta=n;Ua=u;Va=B;Wa=I;Xa=m;Ya=t;Za=A;_a=H;$a=O}while(1){O=$a+64|0;P=$a+(((d[$a+1>>0]|0)<<4)+64)|0;ab=a[$a+2>>0]|0;bb=ab&255;cb=P+(bb*192|0)|0;H=ea(g[$a+16>>2]);A=ea(g[$a+20>>2]);t=ea(g[$a+24>>2]);m=ea(g[$a+28>>2]);I=ea(g[$a+32>>2]);B=ea(g[$a+36>>2]);u=ea(g[$a+40>>2]);n=ea(g[$a+44>>2]);if(!(ab<<24>>24)){db=_a;eb=Za;fb=Ya;gb=Xa;hb=Wa;ib=Va;jb=Ua;kb=Ta;lb=Sa;mb=Ra;nb=Qa;ob=Pa;pb=Oa;qb=Na;rb=Ma;sb=La;tb=Ka;ub=Ja;vb=Ia;wb=Ha;xb=Ga;yb=Fa;zb=Ea;Ab=Da}else{ab=$a+12|0;J=Xa;C=Ya;v=Za;o=_a;L=La;E=Ma;x=Na;q=Oa;M=Ta;F=Ua;y=Va;r=Wa;N=Ha;G=Ia;z=Ja;s=Ka;Bb=Pa;Cb=Qa;Db=Ra;Eb=Sa;Fb=Da;Gb=Ea;Hb=Fa;Ib=Ga;Jb=0;while(1){Kb=Jb+1|0;Lb=Jb>>>(c[ab>>2]|0);Mb=ea(g[O+(Lb<<4)>>2]);Nb=ea(g[O+(Lb<<4)+4>>2]);Ob=ea(g[O+(Lb<<4)+8>>2]);Pb=ea(H*Mb);Mb=ea(A*Nb);Nb=ea(t*Ob);Ob=ea(m*ea(g[O+(Lb<<4)+12>>2]));Qb=ea(-Pb);Rb=ea(-Mb);Sb=ea(-Nb);Tb=ea(-Ob);Ub=ea(g[P+(Jb*192|0)+96>>2]);Vb=ea(g[P+(Jb*192|0)+100>>2]);Wb=ea(g[P+(Jb*192|0)+104>>2]);Xb=ea(g[P+(Jb*192|0)+108>>2]);Yb=ea(g[P+(Jb*192|0)+112>>2]);Zb=ea(g[P+(Jb*192|0)+116>>2]);_b=ea(g[P+(Jb*192|0)+120>>2]);$b=ea(g[P+(Jb*192|0)+124>>2]);ac=ea(g[P+(Jb*192|0)+128>>2]);bc=ea(g[P+(Jb*192|0)+132>>2]);cc=ea(g[P+(Jb*192|0)+136>>2]);dc=ea(g[P+(Jb*192|0)+140>>2]);ec=ea(g[P+(Jb*192|0)>>2]);fc=ea(g[P+(Jb*192|0)+4>>2]);gc=ea(g[P+(Jb*192|0)+8>>2]);hc=ea(g[P+(Jb*192|0)+12>>2]);ic=ea(g[P+(Jb*192|0)+16>>2]);jc=ea(g[P+(Jb*192|0)+20>>2]);kc=ea(g[P+(Jb*192|0)+24>>2]);lc=ea(g[P+(Jb*192|0)+28>>2]);mc=ea(g[P+(Jb*192|0)+32>>2]);nc=ea(g[P+(Jb*192|0)+36>>2]);oc=ea(g[P+(Jb*192|0)+40>>2]);pc=ea(g[P+(Jb*192|0)+44>>2]);qc=ea(g[P+(Jb*192|0)+48>>2]);rc=ea(g[P+(Jb*192|0)+52>>2]);sc=ea(g[P+(Jb*192|0)+56>>2]);tc=ea(g[P+(Jb*192|0)+60>>2]);uc=ea(g[P+(Jb*192|0)+64>>2]);vc=ea(g[P+(Jb*192|0)+68>>2]);wc=ea(g[P+(Jb*192|0)+72>>2]);xc=ea(g[P+(Jb*192|0)+76>>2]);yc=ea(g[P+(Jb*192|0)+80>>2]);zc=ea(g[P+(Jb*192|0)+84>>2]);Ac=ea(g[P+(Jb*192|0)+88>>2]);Bc=ea(g[P+(Jb*192|0)+92>>2]);Lb=P+(Jb*192|0)+144|0;Cc=ea(g[Lb>>2]);Dc=P+(Jb*192|0)+148|0;Ec=ea(g[Dc>>2]);Fc=P+(Jb*192|0)+152|0;Gc=ea(g[Fc>>2]);Hc=P+(Jb*192|0)+156|0;Ic=ea(g[Hc>>2]);Jc=ea(g[P+(Jb*192|0)+160>>2]);Kc=ea(g[P+(Jb*192|0)+164>>2]);Lc=ea(g[P+(Jb*192|0)+168>>2]);Mc=ea(g[P+(Jb*192|0)+172>>2]);Nc=ea(g[P+(Jb*192|0)+176>>2]);Oc=ea(g[P+(Jb*192|0)+180>>2]);Pc=ea(g[P+(Jb*192|0)+184>>2]);Qc=ea(I*ec);Rc=ea(B*fc);Sc=ea(u*gc);Tc=ea(n*hc);Uc=ea(I*ic);Vc=ea(B*jc);Wc=ea(u*kc);Xc=ea(n*lc);Yc=ea(I*mc);Zc=ea(B*nc);_c=ea(u*oc);$c=ea(n*pc);ad=ea(ea(ea(ea(ea(ea(J*ec)+ea(M*ic))+ea(Bb*mc))+ea(ea(ea(L*qc)+ea(N*uc))+ea(Fb*yc)))*Jc)+ea(Cc-ea(Jc*Nc)));Nc=ea(ea(ea(ea(ea(ea(C*fc)+ea(F*jc))+ea(Cb*nc))+ea(ea(ea(E*rc)+ea(G*vc))+ea(Gb*zc)))*Kc)+ea(Ec-ea(Kc*Oc)));Oc=ea(ea(ea(ea(ea(ea(v*gc)+ea(y*kc))+ea(Db*oc))+ea(ea(ea(x*sc)+ea(z*wc))+ea(Hb*Ac)))*Lc)+ea(Gc-ea(Lc*Pc)));Pc=ea(ea(ea(ea(ea(ea(o*hc)+ea(r*lc))+ea(Eb*pc))+ea(ea(ea(q*tc)+ea(s*xc))+ea(Ib*Bc)))*Mc)+ea(Ic-ea(Mc*ea(g[P+(Jb*192|0)+188>>2]))));Mc=ad<Pb?ad:Pb;Pb=Nc<Mb?Nc:Mb;Mb=Oc<Nb?Oc:Nb;Nb=Pc<Ob?Pc:Ob;Ob=Mc>Qb?Mc:Qb;Qb=Pb>Rb?Pb:Rb;Rb=Mb>Sb?Mb:Sb;Sb=Nb>Tb?Nb:Tb;Tb=ea(Ob-Cc);Cc=ea(Qb-Ec);Ec=ea(Rb-Gc);Gc=ea(Sb-Ic);Ic=ea(J+ea(Qc*Tb));Qc=ea(C+ea(Rc*Cc));Rc=ea(v+ea(Sc*Ec));Sc=ea(o+ea(Tc*Gc));Tc=ea(L+ea(Ub*Tb));Ub=ea(E+ea(Vb*Cc));Vb=ea(x+ea(Wb*Ec));Wb=ea(q+ea(Xb*Gc));Xb=ea(M+ea(Uc*Tb));Uc=ea(F+ea(Vc*Cc));Vc=ea(y+ea(Wc*Ec));Wc=ea(r+ea(Xc*Gc));Xc=ea(N+ea(Yb*Tb));Yb=ea(G+ea(Zb*Cc));Zb=ea(z+ea(_b*Ec));_b=ea(s+ea($b*Gc));$b=ea(Bb+ea(Yc*Tb));Yc=ea(Cb+ea(Zc*Cc));Zc=ea(Db+ea(_c*Ec));_c=ea(Eb+ea($c*Gc));$c=ea(Fb+ea(ac*Tb));Tb=ea(Gb+ea(bc*Cc));Cc=ea(Hb+ea(cc*Ec));Ec=ea(Ib+ea(dc*Gc));g[Lb>>2]=Ob;g[Dc>>2]=Qb;g[Fc>>2]=Rb;g[Hc>>2]=Sb;if((Kb|0)==(bb|0)){db=Sc;eb=Rc;fb=Qc;gb=Ic;hb=Wc;ib=Vc;jb=Uc;kb=Xb;lb=_c;mb=Zc;nb=Yc;ob=$b;pb=Wb;qb=Vb;rb=Ub;sb=Tc;tb=_b;ub=Zb;vb=Yb;wb=Xc;xb=Ec;yb=Cc;zb=Tb;Ab=$c;break}else{J=Ic;C=Qc;v=Rc;o=Sc;L=Tc;E=Ub;x=Vb;q=Wb;M=Xb;F=Uc;y=Vc;r=Wc;N=Xc;G=Yb;z=Zb;s=_b;Bb=$b;Cb=Yc;Db=Zc;Eb=_c;Fb=$c;Gb=Tb;Hb=Cc;Ib=Ec;Jb=Kb}}}if(cb>>>0<e>>>0){Da=Ab;Ea=zb;Fa=yb;Ga=xb;Ha=wb;Ia=vb;Ja=ub;Ka=tb;La=sb;Ma=rb;Na=qb;Oa=pb;Pa=ob;Qa=nb;Ra=mb;Sa=lb;Ta=kb;Ua=jb;Va=ib;Wa=hb;Xa=gb;Ya=fb;Za=eb;_a=db;$a=cb}else{Q=db;R=eb;S=fb;T=gb;U=hb;V=ib;W=jb;X=kb;Y=lb;Z=mb;_=nb;$=ob;aa=pb;ba=qb;ca=rb;da=sb;fa=tb;ga=ub;ha=vb;ia=wb;ja=xb;ka=yb;la=zb;ma=Ab;break}}g[h>>2]=T;na=h+4|0;g[na>>2]=X;oa=h+8|0;g[oa>>2]=$;g[j>>2]=S;pa=j+4|0;g[pa>>2]=W;qa=j+8|0;g[qa>>2]=_;g[k>>2]=R;ra=k+4|0;g[ra>>2]=V;sa=k+8|0;g[sa>>2]=Z;g[l>>2]=Q;ta=l+4|0;g[ta>>2]=U;ua=l+8|0;g[ua>>2]=Y;g[p>>2]=da;va=h+20|0;g[va>>2]=ia;wa=h+24|0;g[wa>>2]=ma;g[w>>2]=ca;xa=j+20|0;g[xa>>2]=ha;ya=j+24|0;g[ya>>2]=la;g[D>>2]=ba;za=k+20|0;g[za>>2]=ga;Aa=k+24|0;g[Aa>>2]=ka;g[K>>2]=aa;Ba=l+20|0;g[Ba>>2]=fa;Ca=l+24|0;g[Ca>>2]=ja;i=f;return}function p1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?499912:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function q1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?499784:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<5)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2]);g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);g[k+28>>2]=ea(g[f+28>>2])}k=k+32|0;if(k>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function r1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*40|0,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?490240:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j*40|0)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=j+0|0;h=f+0|0;l=g+40|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(l|0))}j=j+40|0;if(j>>>0>=e>>>0)break;else f=f+40|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function s1a(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=ea(e);f=ea(f);h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;m=i;i=i+144|0;n=m+16|0;o=m;p=b+4096|0;c[p>>2]=0;q=ea(e+l);e=ea(g[j>>2]);r=j+4|0;s=ea(g[r>>2]);t=j+8|0;u=ea(g[t>>2]);v=j+12|0;w=ea(g[v>>2]);x=j+16|0;y=ea(g[x>>2]);z=j+20|0;A=ea(g[z>>2]);B=j+24|0;C=ea(g[B>>2]);D=j+28|0;E=ea(g[D>>2]);F=j+32|0;G=ea(g[F>>2]);H=j+36|0;I=ea(-ea(g[H>>2]));J=j+40|0;K=ea(-ea(g[J>>2]));L=j+44|0;M=ea(-ea(g[L>>2]));N=ea(s*K);O=ea(u*M);P=ea(ea(ea(w*I)+ea(y*K))+ea(A*M));Q=ea(E*K);K=ea(G*M);M=ea(g[k>>2]);R=ea(w*M);T=ea(g[k+4>>2]);U=ea(E*T);V=ea(R+ea(y*T));R=ea(g[k+8>>2]);W=ea(G*R);X=ea(V+ea(A*R));V=ea(g[k+12>>2]);Y=ea(w*V);Z=ea(g[k+16>>2]);_=ea(E*Z);$=ea(Y+ea(y*Z));Y=ea(g[k+20>>2]);aa=ea(G*Y);ba=ea($+ea(A*Y));$=ea(g[k+24>>2]);ca=ea(w*$);da=ea(g[k+28>>2]);fa=ea(E*da);ga=ea(ca+ea(y*da));ca=ea(g[k+32>>2]);ha=ea(G*ca);ia=ea(ga+ea(A*ca));ga=ea(g[k+36>>2]);ja=ea(w*ga);w=ea(C*ga);ka=ea(g[k+40>>2]);la=ea(ja+ea(y*ka));y=ea(w+ea(E*ka));E=ea(g[k+44>>2]);w=ea(P+ea(la+ea(A*E)));A=ea(f+l);f=ea(ea(ea(e*M)+ea(s*T))+ea(u*R));R=ea(ea(ea(C*M)+U)+W);W=ea(ea(ea(e*V)+ea(s*Z))+ea(u*Y));Y=ea(ea(ea(C*V)+_)+aa);aa=ea(ea(ea(e*$)+ea(s*da))+ea(u*ca));ca=ea(ea(ea(C*$)+fa)+ha);ha=ea(ea(ea(ea(e*I)+N)+O)+ea(ea(ea(e*ga)+ea(s*ka))+ea(u*E)));u=ea(ea(ea(ea(C*I)+Q)+K)+ea(y+ea(G*E)));E=ea(g[h>>2]);G=ea(f*E);f=ea(X*E);X=ea(R*E);E=ea(g[h+4>>2]);R=ea(W*E);W=ea(ba*E);ba=ea(Y*E);E=ea(g[h+8>>2]);Y=ea(aa*E);aa=ea(ia*E);ia=ea(ca*E);E=ea(ha-G);ca=ea(w-f);y=ea(u-X);K=ea(ha+G);G=ea(w+f);f=ea(u+X);X=ea(R+Y);u=ea(W+aa);w=ea(ba+ia);g[n>>2]=ea(E-X);g[n+4>>2]=ea(ca-u);g[n+8>>2]=ea(y-w);g[n+16>>2]=ea(K-X);g[n+20>>2]=ea(G-u);g[n+24>>2]=ea(f-w);g[n+96>>2]=ea(X+E);g[n+100>>2]=ea(u+ca);g[n+104>>2]=ea(w+y);g[n+112>>2]=ea(X+K);g[n+116>>2]=ea(u+G);g[n+120>>2]=ea(w+f);w=ea(R-Y);Y=ea(W-aa);aa=ea(ba-ia);g[n+32>>2]=ea(w+E);g[n+36>>2]=ea(Y+ca);g[n+40>>2]=ea(aa+y);g[n+48>>2]=ea(w+K);g[n+52>>2]=ea(Y+G);g[n+56>>2]=ea(aa+f);g[n+64>>2]=ea(E-w);g[n+68>>2]=ea(ca-Y);g[n+72>>2]=ea(y-aa);g[n+80>>2]=ea(K-w);g[n+84>>2]=ea(G-Y);g[n+88>>2]=ea(f-aa);aa=ea(-l);h=d+4|0;k=d+8|0;ma=0;do{f=ea(g[n+(ma<<4)>>2]);do if(f<aa){a[n+(ma<<4)+13>>0]=0;a[n+(ma<<4)+12>>0]=0}else{a[n+(ma<<4)+12>>0]=1;Y=ea(g[n+(ma<<4)+4>>2]);if(ea(S(ea(Y)))<=q?(G=ea(g[n+(ma<<4)+8>>2]),ea(S(ea(G)))<=A):0){a[n+(ma<<4)+13>>0]=1;na=c[p>>2]|0;if(na>>>0>63)break;w=ea(-f);c[p>>2]=na+1;g[b+(na<<6)>>2]=ea(g[d>>2]);g[b+(na<<6)+4>>2]=ea(g[h>>2]);g[b+(na<<6)+8>>2]=ea(g[k>>2]);g[b+(na<<6)+16>>2]=f;g[b+(na<<6)+20>>2]=Y;g[b+(na<<6)+24>>2]=G;g[b+(na<<6)+12>>2]=w;c[b+(na<<6)+48>>2]=-1;c[b+(na<<6)+52>>2]=-1;break}a[n+(ma<<4)+13>>0]=0}while(0);ma=ma+1|0}while((ma|0)!=8);aa=ea(-q);f=ea(-A);ma=500032;do{na=c[ma>>2]|0;oa=n+(na<<4)|0;pa=c[ma+4>>2]|0;ma=ma+8|0;qa=n+(pa<<4)|0;if(!((a[n+(na<<4)+12>>0]|0)==0?(a[n+(pa<<4)+12>>0]|0)==0:0))ra=15;do if((ra|0)==15){ra=0;if((a[n+(na<<4)+13>>0]|0)!=0?(a[n+(pa<<4)+13>>0]|0)!=0:0){sa=oa;ta=qa}else{w=ea(g[n+(na<<4)+4>>2]);ua=w>ea(g[n+(pa<<4)+4>>2]);va=ua?oa:qa;wa=ua?qa:oa;w=ea(g[wa+4>>2]);if((((w<q?(G=ea(g[va+4>>2]),G>=q):0)?(Y=ea(ea(q-w)/ea(G-w)),G=ea(g[wa+8>>2]),K=ea(G+ea(Y*ea(ea(g[va+8>>2])-G))),ea(S(ea(K)))<=A):0)?(G=ea(g[wa>>2]),y=ea(G+ea(Y*ea(ea(g[va>>2])-G))),ea(y+l)>=ea(0.0)):0)?(ua=c[p>>2]|0,ua>>>0<=63):0){G=ea(-y);c[p>>2]=ua+1;g[b+(ua<<6)>>2]=ea(g[d>>2]);g[b+(ua<<6)+4>>2]=ea(g[h>>2]);g[b+(ua<<6)+8>>2]=ea(g[k>>2]);g[b+(ua<<6)+16>>2]=y;g[b+(ua<<6)+20>>2]=q;g[b+(ua<<6)+24>>2]=K;g[b+(ua<<6)+12>>2]=G;c[b+(ua<<6)+48>>2]=-1;c[b+(ua<<6)+52>>2]=-1}if((((w<aa?(G=ea(g[va+4>>2]),G>=aa):0)?(K=ea(ea(aa-w)/ea(G-w)),w=ea(g[wa+8>>2]),G=ea(w+ea(K*ea(ea(g[va+8>>2])-w))),ea(S(ea(G)))<=A):0)?(w=ea(g[wa>>2]),y=ea(w+ea(K*ea(ea(g[va>>2])-w))),ea(y+l)>=ea(0.0)):0)?(ua=c[p>>2]|0,ua>>>0<=63):0){w=ea(-y);c[p>>2]=ua+1;g[b+(ua<<6)>>2]=ea(g[d>>2]);g[b+(ua<<6)+4>>2]=ea(g[h>>2]);g[b+(ua<<6)+8>>2]=ea(g[k>>2]);g[b+(ua<<6)+16>>2]=y;g[b+(ua<<6)+20>>2]=aa;g[b+(ua<<6)+24>>2]=G;g[b+(ua<<6)+12>>2]=w;c[b+(ua<<6)+48>>2]=-1;c[b+(ua<<6)+52>>2]=-1}w=ea(g[wa+8>>2]);ua=w>ea(g[va+8>>2]);xa=ua?wa:va;ya=ua?va:wa;w=ea(g[ya+8>>2]);if((((w<A?(G=ea(g[xa+8>>2]),G>=A):0)?(y=ea(ea(A-w)/ea(G-w)),G=ea(g[ya+4>>2]),K=ea(G+ea(y*ea(ea(g[xa+4>>2])-G))),ea(S(ea(K)))<=q):0)?(G=ea(g[ya>>2]),Y=ea(G+ea(y*ea(ea(g[xa>>2])-G))),ea(Y+l)>=ea(0.0)):0)?(wa=c[p>>2]|0,wa>>>0<=63):0){G=ea(-Y);c[p>>2]=wa+1;g[b+(wa<<6)>>2]=ea(g[d>>2]);g[b+(wa<<6)+4>>2]=ea(g[h>>2]);g[b+(wa<<6)+8>>2]=ea(g[k>>2]);g[b+(wa<<6)+16>>2]=Y;g[b+(wa<<6)+20>>2]=K;g[b+(wa<<6)+24>>2]=A;g[b+(wa<<6)+12>>2]=G;c[b+(wa<<6)+48>>2]=-1;c[b+(wa<<6)+52>>2]=-1}if((((w<f?(G=ea(g[xa+8>>2]),G>=f):0)?(K=ea(ea(f-w)/ea(G-w)),w=ea(g[ya+4>>2]),G=ea(w+ea(K*ea(ea(g[xa+4>>2])-w))),ea(S(ea(G)))<=q):0)?(w=ea(g[ya>>2]),Y=ea(w+ea(K*ea(ea(g[xa>>2])-w))),ea(Y+l)>=ea(0.0)):0)?(wa=c[p>>2]|0,wa>>>0<=63):0){w=ea(-Y);c[p>>2]=wa+1;g[b+(wa<<6)>>2]=ea(g[d>>2]);g[b+(wa<<6)+4>>2]=ea(g[h>>2]);g[b+(wa<<6)+8>>2]=ea(g[k>>2]);g[b+(wa<<6)+16>>2]=Y;g[b+(wa<<6)+20>>2]=G;g[b+(wa<<6)+24>>2]=f;g[b+(wa<<6)+12>>2]=w;c[b+(wa<<6)+48>>2]=-1;c[b+(wa<<6)+52>>2]=-1;sa=ya;ta=xa}else{sa=ya;ta=xa}}if(!((a[sa+12>>0]|0)==0?(a[ta+13>>0]|0)==0:0)){if(a[ta+12>>0]|0)break;if(a[sa+13>>0]|0)break}w=ea(g[sa>>2]);G=ea(-w);Y=ea(G/ea(ea(g[ta>>2])-w));w=ea(g[sa+4>>2]);G=ea(w+ea(Y*ea(ea(g[ta+4>>2])-w)));if((ea(S(ea(G)))<=q?(w=ea(g[sa+8>>2]),K=ea(w+ea(Y*ea(ea(g[ta+8>>2])-w))),ea(S(ea(K)))<=A):0)?(xa=c[p>>2]|0,xa>>>0<=63):0){c[p>>2]=xa+1;g[b+(xa<<6)>>2]=ea(g[d>>2]);g[b+(xa<<6)+4>>2]=ea(g[h>>2]);g[b+(xa<<6)+8>>2]=ea(g[k>>2]);g[b+(xa<<6)+16>>2]=ea(0.0);g[b+(xa<<6)+20>>2]=G;g[b+(xa<<6)+24>>2]=K;g[b+(xa<<6)+12>>2]=ea(0.0);c[b+(xa<<6)+48>>2]=-1;c[b+(xa<<6)+52>>2]=-1}}while(0)}while((ma|0)!=500128);ma=o+4|0;ta=o+8|0;sa=o+12|0;ra=0;oa=0;while(1){qa=c[500128+(oa<<4)>>2]|0;pa=n+(qa<<4)|0;c[o>>2]=pa;a:do if((((a[n+(qa<<4)+12>>0]|0)!=0?(na=c[500132+(oa<<4)>>2]|0,xa=n+(na<<4)|0,c[ma>>2]=xa,(a[n+(na<<4)+12>>0]|0)!=0):0)?(ya=c[500136+(oa<<4)>>2]|0,c[ta>>2]=n+(ya<<4),(a[n+(ya<<4)+12>>0]|0)!=0):0)?(wa=c[500140+(oa<<4)>>2]|0,va=n+(wa<<4)|0,c[sa>>2]=va,(a[n+(wa<<4)+12>>0]|0)!=0):0){if((((a[n+(qa<<4)+13>>0]|0)!=0?(a[n+(na<<4)+13>>0]|0)!=0:0)?(a[n+(ya<<4)+13>>0]|0)!=0:0)?(a[n+(wa<<4)+13>>0]|0)!=0:0){za=ra;break}b:do if(!(ra&1)){l=ea(g[n+(wa<<4)+4>>2]);K=ea(g[n+(wa<<4)+8>>2]);ya=pa;G=l;w=K;ua=1;while(1){Y=ea(g[ya+4>>2]);y=ea(g[ya+8>>2]);if(ea(ea(ea(f-w)*ea(Y-G))-ea(ea(aa-G)*ea(y-w)))>=ea(0.0)){Aa=ra;break b}if((ua|0)>=4)break;ya=c[o+(ua<<2)>>2]|0;G=Y;w=y;ua=ua+1|0}w=ea(g[pa>>2]);G=ea(g[n+(qa<<4)+4>>2]);y=ea(aa-G);Y=ea(g[n+(qa<<4)+8>>2]);ca=ea(f-Y);E=ea(ea(g[xa>>2])-w);ia=ea(ea(g[n+(na<<4)+4>>2])-G);ba=ea(ea(g[n+(na<<4)+8>>2])-Y);W=ea(w+ea(ea(E*ea(ea(y*ia)+ea(ca*ba)))/ea(ea(ea(E*E)+ea(ia*ia))+ea(ba*ba))));ba=ea(ea(g[va>>2])-w);w=ea(l-G);G=ea(K-Y);Y=ea(W+ea(ea(ea(ea(y*w)+ea(ca*G))*ba)/ea(ea(G*G)+ea(ea(w*w)+ea(ba*ba)))));if(Y>=ea(0.0)){ua=ra|1;ya=c[p>>2]|0;if(ya>>>0>63)Aa=ua;else{ba=ea(-Y);c[p>>2]=ya+1;g[b+(ya<<6)>>2]=ea(g[d>>2]);g[b+(ya<<6)+4>>2]=ea(g[h>>2]);g[b+(ya<<6)+8>>2]=ea(g[k>>2]);g[b+(ya<<6)+16>>2]=Y;g[b+(ya<<6)+20>>2]=aa;g[b+(ya<<6)+24>>2]=f;g[b+(ya<<6)+12>>2]=ba;c[b+(ya<<6)+48>>2]=-1;c[b+(ya<<6)+52>>2]=-1;Aa=ua}}else Aa=ra}else Aa=ra;while(0);c:do if(!(Aa&2)){ba=ea(g[n+(wa<<4)+4>>2]);Y=ea(g[n+(wa<<4)+8>>2]);ua=pa;w=ba;G=Y;ya=1;while(1){ca=ea(g[ua+4>>2]);y=ea(g[ua+8>>2]);if(ea(ea(ea(f-G)*ea(ca-w))-ea(ea(q-w)*ea(y-G)))>=ea(0.0)){Ba=Aa;break c}if((ya|0)>=4)break;ua=c[o+(ya<<2)>>2]|0;w=ca;G=y;ya=ya+1|0}G=ea(g[pa>>2]);w=ea(g[n+(qa<<4)+4>>2]);K=ea(q-w);l=ea(g[n+(qa<<4)+8>>2]);y=ea(f-l);ca=ea(ea(g[xa>>2])-G);W=ea(ea(g[n+(na<<4)+4>>2])-w);ia=ea(ea(g[n+(na<<4)+8>>2])-l);E=ea(G+ea(ea(ca*ea(ea(K*W)+ea(y*ia)))/ea(ea(ea(ca*ca)+ea(W*W))+ea(ia*ia))));ia=ea(ea(g[va>>2])-G);G=ea(ba-w);w=ea(Y-l);l=ea(E+ea(ea(ea(ea(K*G)+ea(y*w))*ia)/ea(ea(w*w)+ea(ea(G*G)+ea(ia*ia)))));if(l>=ea(0.0)){ya=Aa|2;ua=c[p>>2]|0;if(ua>>>0>63)Ba=ya;else{ia=ea(-l);c[p>>2]=ua+1;g[b+(ua<<6)>>2]=ea(g[d>>2]);g[b+(ua<<6)+4>>2]=ea(g[h>>2]);g[b+(ua<<6)+8>>2]=ea(g[k>>2]);g[b+(ua<<6)+16>>2]=l;g[b+(ua<<6)+20>>2]=q;g[b+(ua<<6)+24>>2]=f;g[b+(ua<<6)+12>>2]=ia;c[b+(ua<<6)+48>>2]=-1;c[b+(ua<<6)+52>>2]=-1;Ba=ya}}else Ba=Aa}else Ba=Aa;while(0);d:do if(!(Ba&4)){ia=ea(g[n+(wa<<4)+4>>2]);l=ea(g[n+(wa<<4)+8>>2]);ya=pa;G=ia;w=l;ua=1;while(1){y=ea(g[ya+4>>2]);K=ea(g[ya+8>>2]);if(ea(ea(ea(A-w)*ea(y-G))-ea(ea(aa-G)*ea(K-w)))>=ea(0.0)){Ca=Ba;break d}if((ua|0)>=4)break;ya=c[o+(ua<<2)>>2]|0;G=y;w=K;ua=ua+1|0}w=ea(g[pa>>2]);G=ea(g[n+(qa<<4)+4>>2]);Y=ea(aa-G);ba=ea(g[n+(qa<<4)+8>>2]);K=ea(A-ba);y=ea(ea(g[xa>>2])-w);E=ea(ea(g[n+(na<<4)+4>>2])-G);W=ea(ea(g[n+(na<<4)+8>>2])-ba);ca=ea(w+ea(ea(y*ea(ea(Y*E)+ea(K*W)))/ea(ea(ea(y*y)+ea(E*E))+ea(W*W))));W=ea(ea(g[va>>2])-w);w=ea(ia-G);G=ea(l-ba);ba=ea(ca+ea(ea(ea(ea(Y*w)+ea(K*G))*W)/ea(ea(G*G)+ea(ea(w*w)+ea(W*W)))));if(ba>=ea(0.0)){ua=Ba|4;ya=c[p>>2]|0;if(ya>>>0>63)Ca=ua;else{W=ea(-ba);c[p>>2]=ya+1;g[b+(ya<<6)>>2]=ea(g[d>>2]);g[b+(ya<<6)+4>>2]=ea(g[h>>2]);g[b+(ya<<6)+8>>2]=ea(g[k>>2]);g[b+(ya<<6)+16>>2]=ba;g[b+(ya<<6)+20>>2]=aa;g[b+(ya<<6)+24>>2]=A;g[b+(ya<<6)+12>>2]=W;c[b+(ya<<6)+48>>2]=-1;c[b+(ya<<6)+52>>2]=-1;Ca=ua}}else Ca=Ba}else Ca=Ba;while(0);if(!(Ca&8)){W=ea(g[n+(wa<<4)+4>>2]);ba=ea(g[n+(wa<<4)+8>>2]);ua=pa;w=W;G=ba;ya=1;while(1){K=ea(g[ua+4>>2]);Y=ea(g[ua+8>>2]);if(ea(ea(ea(A-G)*ea(K-w))-ea(ea(q-w)*ea(Y-G)))>=ea(0.0)){za=Ca;break a}if((ya|0)>=4)break;ua=c[o+(ya<<2)>>2]|0;w=K;G=Y;ya=ya+1|0}G=ea(g[pa>>2]);w=ea(g[n+(qa<<4)+4>>2]);Y=ea(q-w);K=ea(g[n+(qa<<4)+8>>2]);ca=ea(A-K);E=ea(ea(g[xa>>2])-G);y=ea(ea(g[n+(na<<4)+4>>2])-w);R=ea(ea(g[n+(na<<4)+8>>2])-K);u=ea(G+ea(ea(E*ea(ea(Y*y)+ea(ca*R)))/ea(ea(ea(E*E)+ea(y*y))+ea(R*R))));R=ea(ea(g[va>>2])-G);G=ea(W-w);w=ea(ba-K);K=ea(u+ea(ea(ea(ea(Y*G)+ea(ca*w))*R)/ea(ea(w*w)+ea(ea(G*G)+ea(R*R)))));if(K>=ea(0.0)){ya=Ca|8;ua=c[p>>2]|0;if(ua>>>0>63)za=ya;else{R=ea(-K);c[p>>2]=ua+1;g[b+(ua<<6)>>2]=ea(g[d>>2]);g[b+(ua<<6)+4>>2]=ea(g[h>>2]);g[b+(ua<<6)+8>>2]=ea(g[k>>2]);g[b+(ua<<6)+16>>2]=K;g[b+(ua<<6)+20>>2]=q;g[b+(ua<<6)+24>>2]=A;g[b+(ua<<6)+12>>2]=R;c[b+(ua<<6)+48>>2]=-1;c[b+(ua<<6)+52>>2]=-1;za=ya}}else za=Ca}else za=Ca}else za=ra;while(0);oa=oa+1|0;if(oa>>>0>5|(za|0)==15)break;else ra=za}za=c[p>>2]|0;if(!za){Da=0;i=m;return Da|0}else Ea=0;do{p=b+(Ea<<6)+16|0;A=ea(g[p>>2]);q=ea(A*ea(g[j>>2]));aa=ea(A*ea(g[r>>2]));f=ea(A*ea(g[t>>2]));ra=b+(Ea<<6)+20|0;A=ea(g[ra>>2]);R=ea(A*ea(g[v>>2]));K=ea(A*ea(g[x>>2]));G=ea(q+R);R=ea(aa+K);K=ea(f+ea(A*ea(g[z>>2])));oa=b+(Ea<<6)+24|0;A=ea(g[oa>>2]);f=ea(A*ea(g[B>>2]));aa=ea(A*ea(g[D>>2]));q=ea(G+f);f=ea(R+aa);aa=ea(K+ea(A*ea(g[F>>2])));A=ea(q+ea(g[H>>2]));q=ea(f+ea(g[J>>2]));f=ea(aa+ea(g[L>>2]));g[p>>2]=A;g[ra>>2]=q;g[oa>>2]=f;Ea=Ea+1|0}while(Ea>>>0<za>>>0);Da=za;i=m;return Da|0}function t1a(d,e,f,g){d=d|0;e=e|0;f=ea(f);g=ea(g);var h=0,j=0,k=Im,l=0,m=Im,n=Im,o=Im;h=i;j=c[d+36>>2]|0;if((a[j+(e<<2)+2>>0]|0)<0){k=ea(b[j+(e<<2)>>1]|0);l=(c[d+20>>2]|0)+e|0;m=ea(b[j+(l+1<<2)>>1]|0);if(g>f){n=ea(b[j+(e+1<<2)>>1]|0);o=ea(ea(ea(m-n)*f)+ea(k+ea(ea(n-k)*g)));i=h;return ea(o)}else{n=ea(b[j+(l<<2)>>1]|0);o=ea(ea(ea(m-n)*g)+ea(k+ea(ea(n-k)*f)));i=h;return ea(o)}}else{l=(c[d+20>>2]|0)+e|0;k=ea(b[j+(l<<2)>>1]|0);n=ea(b[j+(e+1<<2)>>1]|0);if(ea(f+g)<ea(1.0)){m=ea(b[j+(e<<2)>>1]|0);o=ea(ea(ea(k-m)*f)+ea(m+ea(ea(n-m)*g)));i=h;return ea(o)}else{m=ea(b[j+(l+1<<2)>>1]|0);o=ea(ea(ea(ea(1.0)-f)*ea(n-m))+ea(m+ea(ea(ea(1.0)-g)*ea(k-m))));i=h;return ea(o)}}return ea(0.0)}function u1a(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);var k=0,l=0,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0;k=i;l=c[e+12>>2]|0;m=ea(g[e>>2]);n=ea(g[e+4>>2]);o=ea(g[e+8>>2]);e=c[l+36>>2]|0;do if((a[e+(f<<2)+2>>0]|0)<0){p=b[e+(f<<2)>>1]|0;q=(c[l+20>>2]|0)+f|0;r=b[e+(q+1<<2)>>1]|0;if(!(j>=h)){s=b[e+(q<<2)>>1]|0;t=s-r|0;u=p-s|0;break}else{s=b[e+(f+1<<2)>>1]|0;t=p-s|0;u=s-r|0;break}}else{r=b[e+(f+1<<2)>>1]|0;s=(c[l+20>>2]|0)+f|0;p=b[e+(s<<2)>>1]|0;if(!(ea(h+j)<=ea(1.0))){q=b[e+(s+1<<2)>>1]|0;t=p-q|0;u=r-q|0;break}else{q=b[e+(f<<2)>>1]|0;t=q-r|0;u=q-p|0;break}}while(0);j=ea(m*ea(u|0));m=ea(o*ea(t|0));if(!(ea(g[l+40>>2])<=ea(0.0))){o=ea(-n);h=ea(-m);g[d>>2]=ea(-j);g[d+4>>2]=o;g[d+8>>2]=h;i=k;return}else{g[d>>2]=j;g[d+4>>2]=n;g[d+8>>2]=m;i=k;return}}function v1a(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=0,z=Im,A=Im,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=Im,za=Im,Aa=Im,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=0,Na=Im,Oa=0,Pa=0,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=0,lb=Im,mb=0,nb=Im;j=i;i=i+176|0;k=j+8|0;l=j+68|0;m=j+136|0;n=j;o=j+120|0;p=j+140|0;q=j+152|0;r=j+92|0;s=j+80|0;t=j+32|0;u=j+56|0;v=j+104|0;zRa(d,k);w=ea(g[f>>2]);x=ea(w-ea(g[e>>2]));w=ea(g[f+4>>2]);y=e+4|0;z=ea(w-ea(g[y>>2]));w=ea(g[f+8>>2]);f=e+8|0;A=ea(w-ea(g[f>>2]));g[l>>2]=x;B=l+4|0;g[B>>2]=z;C=l+8|0;g[C>>2]=A;if(!(RPa(k,k+12|0,e,l,ea(1.0),m,n)|0)){i=j;return}A=ea(g[m>>2]);z=ea(g[l>>2]);x=ea(A*z);w=ea(g[B>>2]);D=ea(A*w);E=ea(g[C>>2]);F=ea(A*E);A=ea(g[e>>2]);G=ea(x+A);x=ea(g[y>>2]);H=ea(D+x);D=ea(g[f>>2]);I=ea(F+D);F=ea(g[n>>2]);J=ea(A+ea(z*F));z=ea(x+ea(w*F));w=ea(D+ea(E*F));n=c[d+16>>2]|0;F=ea(g[n+12>>2]);E=ea(g[n+16>>2]);D=ea(g[n+8>>2]);n=c[d+12>>2]|0;f=c[n+20>>2]|0;y=c[n+16>>2]|0;x=ea(g[d>>2]);A=ea(ea(y+-1|0)*ea(.99999988));K=ea(ea(f+-1|0)*ea(.99999988));L=ea(G*x);e=L>ea(1.00000001e-07);G=e?L:ea(1.00000001e-07);L=ea(A+ea(0.0));A=G<L?G:L;G=ea(g[d+8>>2]);M=ea(I*G);e=M>ea(1.00000001e-07);I=e?M:ea(1.00000001e-07);M=ea(K+ea(0.0));K=I<M?I:M;I=ea(J*x);e=I>ea(1.00000001e-07);x=e?I:ea(1.00000001e-07);I=ea(w*G);e=I>ea(1.00000001e-07);G=e?I:ea(1.00000001e-07);I=ea((x<L?x:L)-A);L=ea((G<M?G:M)-K);M=ea(z-H);e=I>=ea(0.0);z=e?ea(1.0):ea(-1.0);e=L>=ea(0.0);G=e?ea(1.0):ea(-1.0);e=~~z;C=~~G;if(ea(S(ea(I)))<ea(1.00000001e-10))N=ea(z*ea(1.00000001e-10));else N=I;if(ea(S(ea(L)))<ea(1.00000001e-10))O=ea(G*ea(1.00000001e-10));else O=L;B=N>ea(0.0);if(B)P=ea(R(ea(A)));else P=ea(ca(ea(A)));l=~~P;m=O>ea(0.0);if(m)Q=ea(R(ea(K)));else Q=ea(ca(ea(K)));k=~~Q;if(B){Q=ea(ca(ea(A)));if(Q==A)U=ea(Q+ea(1.0));else U=Q}else{Q=ea(R(ea(A)));if(Q==A)U=ea(Q+ea(-1.0));else U=Q}if(m){Q=ea(ca(ea(K)));if(Q==K)V=ea(Q+ea(1.0));else V=Q}else{Q=ea(R(ea(K)));if(Q==K)V=ea(Q+ea(-1.0));else V=Q}Q=ea(ea(1.0)/ea(S(ea(N))));P=ea(ea(1.0)/ea(S(ea(O))));m=1-e|0;B=(1-C|0)/2|0;L=ea(f|0);I=ea(y|0);y=n+36|0;n=o+4|0;W=o+8|0;X=o+12|0;Y=o+(B+m<<2)|0;Z=o+(m+1-B<<2)|0;_=o+(2-m+B<<2)|0;$=o+(3-m-B<<2)|0;B=p+4|0;m=p+8|0;aa=q+4|0;ba=q+8|0;fa=r+4|0;ga=r+8|0;ha=s+4|0;ia=s+8|0;ja=t+4|0;ka=t+8|0;la=t+12|0;ma=t+16|0;na=t+20|0;x=ea(z*ea(.5));w=ea(G*ea(.5));J=ea(E*G);oa=u+4|0;pa=u+8|0;qa=v+4|0;ra=v+8|0;sa=ea(F*z);ta=ea(H+ea(M*ea(0.0)));ua=ea(0.0);va=ea(0.0);wa=ea(ea(U-A)/N);U=ea(ea(V-K)/O);xa=l;V=ea(l|0);l=k;ya=ea(k|0);while(1){k=wa<U;za=k?wa:U;Aa=ta;ta=ea(H+ea(M*za));Ba=(da(xa,f)|0)+l|0;Ca=xa+e|0;Da=(da(Ca,f)|0)+l|0;Ea=c[y>>2]|0;Fa=ea(D*ea(b[Ea+(Ba<<2)>>1]|0));g[o>>2]=Fa;Ga=ea(D*ea(b[Ea+(Ba+C<<2)>>1]|0));g[n>>2]=Ga;Ha=ea(D*ea(b[Ea+(Da<<2)>>1]|0));g[W>>2]=Ha;Ia=ea(D*ea(b[Ea+(Da+C<<2)>>1]|0));g[X>>2]=Ia;Ja=Fa<Ga?Fa:Ga;Ka=Ha<Ia?Ha:Ia;La=Fa>Ga?Fa:Ga;Ga=Ha>Ia?Ha:Ia;Ia=La>Ga?La:Ga;Ga=Aa>ta?Aa:ta;if(ea((Aa<ta?Aa:ta)+ea(-.0000999999974))>Ia){if(Ga<Ia)Ma=26}else if(Ga<Ia?1:!(ea(Ga+ea(.0000999999974))<(Ja<Ka?Ja:Ka)))Ma=26;if((Ma|0)==26){Ma=0;Ka=ea(g[Y>>2]);Ja=ea(g[Z>>2]);Ga=ea(g[_>>2]);Ia=ea(g[$>>2]);Aa=ea(z+V);La=V<Aa?V:Aa;Ha=V>Aa?V:Aa;Aa=ea(G+ya);Fa=ya<Aa?ya:Aa;Na=ya>Aa?ya:Aa;g[p>>2]=La;g[B>>2]=Ka;g[m>>2]=Fa;g[q>>2]=La;g[aa>>2]=Ja;g[ba>>2]=Na;g[r>>2]=Ha;g[fa>>2]=Ga;g[ga>>2]=Fa;g[s>>2]=Ha;g[ha>>2]=Ia;g[ia>>2]=Na;Da=l+C|0;Ba=(da((Ca|0)<(xa|0)?Ca:xa,f)|0)+((Da|0)<(l|0)?Da:l)|0;Da=(a[Ea+(Ba<<2)+2>>0]|0)<0;Ea=Da?s:r;Oa=Da?r:p;Pa=Da?q:s;Qa=Da?p:q;Na=ea(F*ea(g[Qa>>2]));Ia=ea(g[Qa+4>>2]);Ha=ea(E*ea(g[Qa+8>>2]));Fa=ea(F*ea(g[Pa>>2]));Ga=ea(g[Pa+4>>2]);Ja=ea(E*ea(g[Pa+8>>2]));La=ea(F*ea(g[Oa>>2]));Ka=ea(g[Oa+4>>2]);Aa=ea(E*ea(g[Oa+8>>2]));Ra=ea(F*ea(g[Ea>>2]));Sa=ea(g[Ea+4>>2]);Ta=ea(E*ea(g[Ea+8>>2]));Ua=ea(Na-La);Va=ea(Ia-Ka);Wa=ea(Ha-Aa);Xa=ea(Ra-La);Ya=ea(Sa-Ka);Za=ea(Ta-Aa);_a=ea(ea(Va*Za)-ea(Wa*Ya));$a=ea(ea(Wa*Xa)-ea(Ua*Za));Za=ea(ea(Ua*Ya)-ea(Va*Xa));Xa=ea(Ra-Fa);Ra=ea(Sa-Ga);Sa=ea(Ta-Ja);Ta=ea(Na-Fa);Na=ea(Ia-Ga);Ia=ea(Ha-Ja);Ha=ea(ea(Ia*Ra)-ea(Na*Sa));Va=ea(ea(Ta*Sa)-ea(Ia*Xa));Ia=ea(ea(Na*Xa)-ea(Ta*Ra));Ra=ea(ea(1.0)/ea(T(ea(ea(ea(_a*_a)+ea($a*$a))+ea(Za*Za)))));g[t>>2]=ea(_a*Ra);g[ja>>2]=ea(Ra*$a);g[ka>>2]=ea(Ra*Za);Za=ea(ea(1.0)/ea(T(ea(ea(ea(Ha*Ha)+ea(Va*Va))+ea(Ia*Ia)))));g[la>>2]=ea(Ha*Za);g[ma>>2]=ea(Za*Va);g[na>>2]=ea(Za*Ia);Ia=Da?ea(-1.0):ea(1.0);Za=ea(x+V);Va=ea(w+ya);Da=za<ea(1.0);Ha=Da?za:ea(1.0);Da=ua>va;Ra=Da?ua:va;$a=ea(A+ea(N*Ra));_a=ea(K+ea(O*Ra));Ea=ea(ea(_a-Va)+ea(ea($a-Za)*Ia))>ea(0.0)&1;Oa=ea(ea(ea(K+ea(O*Ha))-Va)+ea(ea(ea(A+ea(N*Ha))-Za)*Ia))>ea(0.0)&1;Pa=Ba<<1;Qa=Ea|Pa;ab=Oa|Pa;Pa=c[y>>2]|0;bb=(a[Pa+(Ba<<2)+2>>0]&127)==127&1;cb=(a[Pa+(Ba<<2)+3>>0]&127)==127&1;Ba=Qa>>>0>ab>>>0;if(Da){Ha=ea(g[n>>2]);db=J;eb=ea(Ha-ea(g[o>>2]));fb=ea(0.0)}else{Ha=ea(g[W>>2]);db=ea(0.0);eb=ea(Ha-ea(g[o>>2]));fb=sa}g[u>>2]=fb;g[oa>>2]=eb;g[pa>>2]=db;if(!((Ba?cb:bb)|0))iEb(h,d,t+(Ea*12|0)|0,u,ea(F*$a),ea(E*_a),ea(H+ea(M*Ra)),Qa)|0;if((ab|0)!=(Qa|0)&((Ba?bb:cb)|0)==0?(Ra=ea(O+ea(N*Ia)),ea(S(ea(Ra)))>ea(9.99999997e-07)):0){_a=ea(ea(ea(Va-K)+ea(ea(Za-A)*Ia))/Ra);Ra=ea(Ka-Ga);Ga=ea(Aa-Ja);g[v>>2]=ea(La-Fa);g[qa>>2]=Ra;g[ra>>2]=Ga;iEb(h,d,t+(Oa*12|0)|0,v,ea(F*ea(A+ea(N*_a))),ea(E*ea(K+ea(O*_a))),ea(H+ea(M*_a)),ab)|0}}if(k){_a=ea(Ca+e|0);if(!(!(_a<ea(0.0))&!(_a>=I))){Ma=40;break}gb=wa;hb=va;ib=ea(Q+wa);jb=U;kb=Ca;lb=ea(z+V);mb=l;nb=ya}else{Ca=l+C|0;_a=ea(Ca+C|0);if(!(!(_a<ea(0.0))&!(_a>=L))){Ma=40;break}gb=ua;hb=U;ib=wa;jb=ea(P+U);kb=xa;lb=V;mb=Ca;nb=ea(G+ya)}if(!(za<ea(.999899983))){Ma=40;break}else{ua=gb;va=hb;wa=ib;U=jb;xa=kb;V=lb;l=mb;ya=nb}}if((Ma|0)==40){i=j;return}}function w1a(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=0,y=0,z=0,A=0;j=i;k=c[a+12>>2]|0;l=c[k+36>>2]|0;m=ea(b[l+(e<<2)>>1]|0);if((f|0)!=0?(n=c[a+16>>2]|0,o=ea(g[n+12>>2]),p=ea(-o),q=ea(g[n+8>>2]),r=ea(q*ea(ea(b[l+(e-(c[k+20>>2]|0)<<2)>>1]|0)-m)),q=ea(g[d>>2]),s=ea(q*p),n=d+4|0,t=ea(g[n>>2]),u=ea(s+ea(t*r)),v=d+8|0,s=ea(g[v>>2]),w=ea(ea(s*ea(0.0))+u),w>ea(0.0)):0){u=ea(ea(1.0)/ea(ea(ea(o*o)+ea(r*r))+ea(0.0)));o=ea(ea(r*w)*u);r=ea(ea(w*ea(0.0))*u);g[d>>2]=ea(q-ea(ea(w*p)*u));g[n>>2]=ea(t-o);g[v>>2]=ea(s-r);x=1}else x=0;if(((c[k+16>>2]|0)+-1|0)>>>0>f>>>0?(f=c[a+16>>2]|0,r=ea(g[f+12>>2]),s=ea(g[f+8>>2]),o=ea(s*ea(ea(b[l+((c[k+20>>2]|0)+e<<2)>>1]|0)-m)),s=ea(g[d>>2]),t=ea(r*s),f=d+4|0,u=ea(g[f>>2]),p=ea(t+ea(u*o)),v=d+8|0,t=ea(g[v>>2]),w=ea(ea(t*ea(0.0))+p),w>ea(0.0)):0){p=ea(ea(1.0)/ea(ea(ea(r*r)+ea(o*o))+ea(0.0)));q=ea(ea(o*w)*p);o=ea(ea(w*ea(0.0))*p);g[d>>2]=ea(s-ea(ea(r*w)*p));g[f>>2]=ea(u-q);g[v>>2]=ea(t-o);y=1}else y=x;if((h|0)!=0?(x=c[a+16>>2]|0,o=ea(g[x+8>>2]),t=ea(o*ea(ea(b[l+(e+-1<<2)>>1]|0)-m)),o=ea(g[x+16>>2]),q=ea(-o),u=ea(g[d>>2]),p=ea(u*ea(0.0)),x=d+4|0,w=ea(g[x>>2]),r=ea(p+ea(t*w)),v=d+8|0,p=ea(g[v>>2]),s=ea(r+ea(p*q)),s>ea(0.0)):0){r=ea(ea(1.0)/ea(ea(o*o)+ea(ea(t*t)+ea(0.0))));o=ea(ea(t*s)*r);t=ea(ea(s*q)*r);g[d>>2]=ea(u-ea(ea(s*ea(0.0))*r));g[x>>2]=ea(w-o);g[v>>2]=ea(p-t);z=1}else z=y;if(((c[k+20>>2]|0)+-1|0)>>>0<=h>>>0){A=z;i=j;return A|0}h=c[a+16>>2]|0;t=ea(g[h+8>>2]);p=ea(t*ea(ea(b[l+(e+1<<2)>>1]|0)-m));m=ea(g[h+16>>2]);t=ea(g[d>>2]);o=ea(t*ea(0.0));h=d+4|0;w=ea(g[h>>2]);r=ea(o+ea(p*w));e=d+8|0;o=ea(g[e>>2]);s=ea(r+ea(m*o));if(!(s>ea(0.0))){A=z;i=j;return A|0}r=ea(ea(1.0)/ea(ea(m*m)+ea(ea(p*p)+ea(0.0))));u=ea(ea(p*s)*r);p=ea(ea(m*s)*r);g[d>>2]=ea(t-ea(ea(s*ea(0.0))*r));g[h>>2]=ea(w-u);g[e>>2]=ea(o-p);A=1;i=j;return A|0}function x1a(a,b,d,e,f,h){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;h=ea(h);var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=Im,x=Im,y=0,z=0,A=Im,B=Im,C=0,D=Im,E=0,F=Im,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im;j=i;i=i+64|0;k=j+44|0;l=j+32|0;m=j+20|0;n=j+8|0;o=j+4|0;p=j;q=ea(g[e+48>>2]);g[k>>2]=q;r=ea(g[e+52>>2]);g[k+4>>2]=r;s=ea(g[e+56>>2]);g[k+8>>2]=s;t=ea(-r);r=ea(-s);g[l>>2]=ea(-q);g[l+4>>2]=t;g[l+8>>2]=r;r=ea(g[e>>2]);t=ea(g[f>>2]);q=ea(r*t);u=e+4|0;s=ea(g[u>>2]);v=f+4|0;w=ea(g[v>>2]);x=ea(q+ea(s*w));y=e+8|0;q=ea(g[y>>2]);z=f+8|0;A=ea(g[z>>2]);B=ea(x+ea(q*A));C=e+12|0;x=ea(g[C>>2]);D=ea(t*x);E=e+16|0;F=ea(g[E>>2]);G=ea(D+ea(w*F));H=e+20|0;D=ea(g[H>>2]);I=ea(G+ea(A*D));J=e+24|0;G=ea(g[J>>2]);K=ea(t*G);L=e+28|0;t=ea(g[L>>2]);M=ea(K+ea(w*t));N=e+32|0;w=ea(g[N>>2]);K=ea(-I);I=ea(-ea(M+ea(A*w)));g[m>>2]=ea(-B);g[m+4>>2]=K;g[m+8>>2]=I;O=e+36|0;P=e+40|0;Q=e+44|0;R=n+4|0;S=n+8|0;I=ea(d+h);T=a+4096|0;h=r;r=s;s=q;q=x;x=F;F=D;D=G;G=t;t=w;U=0;while(1){V=b+(U*12|0)|0;w=ea(g[V>>2]);K=ea(w-ea(g[O>>2]));W=b+(U*12|0)+4|0;w=ea(g[W>>2]);B=ea(w-ea(g[P>>2]));X=b+(U*12|0)+8|0;w=ea(g[X>>2]);A=ea(w-ea(g[Q>>2]));w=ea(ea(ea(K*q)+ea(B*x))+ea(A*F));M=ea(ea(ea(K*D)+ea(B*G))+ea(A*t));g[n>>2]=ea(ea(ea(K*h)+ea(B*r))+ea(A*s));g[R>>2]=w;g[S>>2]=M;if(((QPa(l,k,n,m,o,p)|0)!=-1?(M=ea(g[o>>2]),M<I):0)?(Y=c[T>>2]|0,Y>>>0<=63):0){w=ea(g[z>>2]);A=ea(g[v>>2]);B=ea(g[f>>2]);K=ea(g[X>>2]);Z=ea(g[W>>2]);_=ea(M-d);$=ea(K-ea(M*w));w=ea(Z-ea(M*A));A=ea(ea(g[V>>2])-ea(M*B));c[T>>2]=Y+1;g[a+(Y<<6)>>2]=B;g[a+(Y<<6)+4>>2]=ea(g[v>>2]);g[a+(Y<<6)+8>>2]=ea(g[z>>2]);g[a+(Y<<6)+16>>2]=A;g[a+(Y<<6)+20>>2]=w;g[a+(Y<<6)+24>>2]=$;g[a+(Y<<6)+12>>2]=_;c[a+(Y<<6)+48>>2]=-1;c[a+(Y<<6)+52>>2]=-1}Y=U+1|0;if((Y|0)==2)break;_=ea(g[e>>2]);$=ea(g[u>>2]);w=ea(g[y>>2]);A=ea(g[C>>2]);B=ea(g[E>>2]);M=ea(g[H>>2]);Z=ea(g[J>>2]);K=ea(g[L>>2]);h=_;r=$;s=w;q=A;x=B;F=M;D=Z;G=K;t=ea(g[N>>2]);U=Y}i=j;return}function y1a(a,b,c,d,e,f,h,j,k,l,m,n,o,p,q,r){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=ea(k);l=ea(l);m=ea(m);n=ea(n);o=ea(o);p=ea(p);q=q|0;r=r|0;var s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0;s=i;t=ea(g[d>>2]);u=ea(t*k);v=ea(g[d+4>>2]);w=ea(u+ea(v*l));u=ea(g[d+8>>2]);x=ea(w+ea(u*m));w=ea(g[d+12>>2]);y=ea(w+x);if(ea(y*ea(w+ea(ea(ea(t*n)+ea(v*o))+ea(u*p))))>ea(0.0)){z=0;i=s;return z|0}w=ea(n-k);n=ea(o-l);o=ea(p-m);p=ea(ea(ea(w*t)+ea(n*v))+ea(o*u));if(p==ea(0.0)){z=0;i=s;return z|0}u=ea(y/p);p=ea(l-ea(n*u));n=ea(m-ea(o*u));g[r>>2]=ea(k-ea(w*u));d=r+4|0;g[d>>2]=p;A=r+8|0;g[A>>2]=n;n=ea(g[c+(e<<2)>>2]);p=ea(g[r+(f<<2)>>2]);u=ea(n*ea(p-ea(g[a+(f<<2)>>2])));p=ea(g[c+(f<<2)>>2]);n=ea(g[r+(e<<2)>>2]);w=ea(ea(u-ea(p*ea(n-ea(g[a+(e<<2)>>2]))))*h);g[q>>2]=w;if(w<ea(0.0)){z=0;i=s;return z|0}h=ea(g[j>>2]);n=ea(g[j+4>>2]);p=ea(w*h);h=ea(w*n);n=ea(w*ea(g[j+8>>2]));w=ea(ea(g[r>>2])-p);g[r>>2]=w;p=ea(ea(g[d>>2])-h);g[d>>2]=p;h=ea(ea(g[A>>2])-n);g[A>>2]=h;n=ea(ea(g[a>>2])-w);u=ea(n*ea(ea(g[b>>2])-w));w=ea(ea(g[a+4>>2])-p);n=ea(u+ea(w*ea(ea(g[b+4>>2])-p)));p=ea(ea(g[a+8>>2])-h);z=ea(n+ea(p*ea(ea(g[b+8>>2])-h)))<ea(0.0);i=s;return z|0}function z1a(b,f,h,j,k){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0;l=i;i=i+32|0;m=l;n=l+16|0;o=b+64|0;c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+80>>2]=0;h=b+16|0;g[h>>2]=ea(0.0);p=b+20|0;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];q=b+32|0;g[q>>2]=ea(0.0);r=b+36|0;c[r+0>>2]=c[n+0>>2];c[r+4>>2]=c[n+4>>2];c[r+8>>2]=c[n+8>>2];g[b+48>>2]=ea(0.0);s=b+52|0;c[s+0>>2]=c[n+0>>2];c[s+4>>2]=c[n+4>>2];c[s+8>>2]=c[n+8>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[b+192>>2]=f;o=f+40|0;s=f+39|0;c[b+200>>2]=(c[o>>2]|0)+((d[s>>0]|0)*20|0);t=f+38|0;a[b+204>>0]=a[t>>0]|0;u=ea(g[f+52>>2]);v=ea(g[f+56>>2]);w=ea(g[f+60>>2]);x=ea(g[j>>2]);y=ea(g[j+4>>2]);z=ea(u*x);x=ea(v*y);y=ea(w*ea(g[j+8>>2]));w=!(z<=x)?x:z;v=!(w<=y)?y:w;w=!(z>=x)?x:z;z=ea(v*ea(.200000003));x=ea((!(w>=y)?y:w)*ea(.0500000007));w=z>x?z:x;g[h>>2]=v>w?w:v;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];g[q>>2]=ea(v*ea(.100000001));c[r+0>>2]=c[m+0>>2];c[r+4>>2]=c[m+4>>2];c[r+8>>2]=c[m+8>>2];jEb(j,k,b+96|0,b+144|0);k=c[f+44>>2]|0;j=b+196|0;c[j>>2]=k;b=c[o>>2]|0;o=b+((d[s>>0]|0)*20|0)+(((d[t>>0]|0)*15|0)+((e[f+36>>1]|0)<<1))-b|0;if((o|0)>0){f=b;b=o;while(1){b=b+-128|0;if((b|0)<=0)break;else f=f+128|0}A=c[j>>2]|0}else A=k;if(!A){i=l;return}k=(c[A+8>>2]<<2)+(e[A+2>>1]|0)+(c[A+12>>2]|0)|0;if((k|0)<=0){i=l;return}j=c[A+4>>2]|0;A=k;while(1){A=A+-128|0;if((A|0)<=0)break;else j=j+128|0}i=l;return}function A1a(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=Im,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im;m=i;i=i+112|0;n=m+56|0;o=m+28|0;p=m;q=ea(ea(1.0)/ea(g[e>>2]));r=ea(ea(1.0)/ea(g[e+4>>2]));s=ea(ea(1.0)/ea(g[e+8>>2]));g[o>>2]=q;g[o+4>>2]=r;g[o+8>>2]=s;g[o+12>>2]=ea(g[e+12>>2]);g[o+16>>2]=ea(g[e+16>>2]);g[o+20>>2]=ea(g[e+20>>2]);g[o+24>>2]=ea(g[e+24>>2]);s=ea(g[b+16>>2]);r=ea(g[b+20>>2]);q=ea(s*ea(-2.0));s=ea(r*ea(-2.0));r=ea(ea(g[b+24>>2])*ea(-2.0));t=ea(g[b+12>>2]);u=ea(ea(t*t)+ea(-.5));v=ea(g[b>>2]);w=ea(q*v);x=ea(g[b+4>>2]);y=ea(w+ea(s*x));w=ea(g[b+8>>2]);z=ea(y+ea(r*w));y=ea(ea(v*z)+ea(ea(q*u)-ea(t*ea(ea(r*x)-ea(s*w)))));A=ea(ea(x*z)+ea(ea(s*u)-ea(t*ea(ea(q*w)-ea(r*v)))));B=ea(ea(ea(r*u)-ea(t*ea(ea(s*v)-ea(q*x))))+ea(w*z));z=ea(-x);x=ea(-w);g[p>>2]=ea(-v);g[p+4>>2]=z;g[p+8>>2]=x;g[p+12>>2]=t;g[p+16>>2]=y;g[p+20>>2]=A;g[p+24>>2]=B;r6a(n,o,p);B=ea(-ea(g[k>>2]));p=k+4|0;A=ea(-ea(g[p>>2]));o=k+8|0;y=ea(-ea(g[o>>2]));t=ea(g[n>>2]);x=ea(t*B);z=ea(g[n+4>>2]);v=ea(z*B);w=ea(g[n+8>>2]);q=ea(w*B);B=ea(g[n+12>>2]);s=ea(B*A);u=ea(g[n+16>>2]);r=ea(u*A);C=ea(g[n+20>>2]);D=ea(x+s);s=ea(v+r);r=ea(q+ea(C*A));A=ea(g[n+24>>2]);q=ea(A*y);v=ea(g[n+28>>2]);x=ea(v*y);E=ea(g[n+32>>2]);F=ea(D+q);q=ea(s+x);x=ea(r+ea(E*y));y=ea(j+l);if(!f){i=m;return}b=d+16|0;e=c[d+24>>2]|0;d=a+4096|0;l=ea(g[n+36>>2]);r=ea(g[n+40>>2]);s=ea(g[n+44>>2]);n=0;do{D=ea(g[h+(n*12|0)>>2]);G=ea(D*t);H=ea(D*z);I=ea(D*w);J=ea(g[h+(n*12|0)+4>>2]);K=ea(G+ea(J*B));G=ea(H+ea(J*u));H=ea(I+ea(J*C));I=ea(g[h+(n*12|0)+8>>2]);L=ea(ea(K+ea(I*A))+l);K=ea(ea(G+ea(I*v))+r);G=ea(ea(H+ea(I*E))+s);H=ea(3402823469999999843913219.0e14);M=ea(-3402823469999999843913219.0e14);N=c[b>>2]|0;O=e;a:while(1){P=M;Q=N;R=O;b:while(1){S=Q;T=R;while(1){U=S;S=S+-1|0;if(!U){V=12;break a}U=T;T=T+20|0;W=ea(g[U>>2]);X=ea(L*W);Y=ea(g[U+4>>2]);Z=ea(X+ea(K*Y));X=ea(g[U+8>>2]);_=ea(Z+ea(G*X));Z=ea(ea(g[U+12>>2])+_);_=ea(ea(ea(F*W)+ea(q*Y))+ea(x*X));$=ea(ea(-Z)/_);if(_>ea(1.00000001e-07))break b;if(_<ea(-1.00000001e-07))break;if(Z>ea(0.0))break a}P=P>$?P:$;Q=S;R=T}H=H<$?H:$;M=P;N=S;O=T}if(((V|0)==12?(V=0,P<H&P<y):0)?(O=c[d>>2]|0,O>>>0<=63):0){M=ea(g[o>>2]);G=ea(g[p>>2]);K=ea(g[k>>2]);L=ea(P-j);Z=ea(I-ea(P*M));M=ea(J-ea(P*G));G=ea(D-ea(P*K));c[d>>2]=O+1;g[a+(O<<6)>>2]=K;g[a+(O<<6)+4>>2]=ea(g[p>>2]);g[a+(O<<6)+8>>2]=ea(g[o>>2]);g[a+(O<<6)+16>>2]=G;g[a+(O<<6)+20>>2]=M;g[a+(O<<6)+24>>2]=Z;g[a+(O<<6)+12>>2]=L;c[a+(O<<6)+48>>2]=-1;c[a+(O<<6)+52>>2]=-1}n=n+1|0}while((n|0)!=(f|0));i=m;return}function B1a(a,b,c,d,e,f,h,j,k,l,m,n,o,p,q,r,s){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=ea(k);l=ea(l);m=ea(m);n=ea(n);o=ea(o);p=ea(p);q=q|0;r=r|0;s=ea(s);var t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0;t=i;u=ea(g[d>>2]);v=ea(u*k);w=ea(g[d+4>>2]);x=ea(v+ea(w*l));v=ea(g[d+8>>2]);y=ea(x+ea(v*m));x=ea(g[d+12>>2]);z=ea(x+y);if(ea(z*ea(x+ea(ea(ea(u*n)+ea(w*o))+ea(v*p))))>ea(0.0)){A=0;i=t;return A|0}x=ea(n-k);n=ea(o-l);o=ea(p-m);p=ea(ea(ea(x*u)+ea(n*w))+ea(o*v));if(p==ea(0.0)){A=0;i=t;return A|0}v=ea(z/p);p=ea(l-ea(n*v));n=ea(m-ea(o*v));g[r>>2]=ea(k-ea(x*v));d=r+4|0;g[d>>2]=p;B=r+8|0;g[B>>2]=n;n=ea(g[c+(e<<2)>>2]);p=ea(g[r+(f<<2)>>2]);v=ea(n*ea(p-ea(g[a+(f<<2)>>2])));p=ea(g[c+(f<<2)>>2]);n=ea(g[r+(e<<2)>>2]);x=ea(ea(v-ea(p*ea(n-ea(g[a+(e<<2)>>2]))))*h);g[q>>2]=x;if(x<s){A=0;i=t;return A|0}s=ea(g[j>>2]);h=ea(g[j+4>>2]);n=ea(x*s);s=ea(x*h);h=ea(x*ea(g[j+8>>2]));x=ea(ea(g[r>>2])-n);g[r>>2]=x;n=ea(ea(g[d>>2])-s);g[d>>2]=n;s=ea(ea(g[B>>2])-h);g[B>>2]=s;h=ea(ea(g[a>>2])-x);p=ea(h*ea(ea(g[b>>2])-x));x=ea(ea(g[a+4>>2])-n);h=ea(p+ea(x*ea(ea(g[b+4>>2])-n)));n=ea(ea(g[a+8>>2])-s);A=ea(h+ea(n*ea(ea(g[b+8>>2])-s)))<ea(0.0);i=t;return A|0}function C1a(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=(b>>>0)/3|0;h=a+16|0;j=a+20|0;k=c[j>>2]|0;l=(g>>>0)/(k>>>0)|0;m=(g>>>0)%(k>>>0)|0;n=(da(g,-3)|0)+b|0;if(!n){if(m>>>0>=(k+-1|0)>>>0){o=0;i=f;return o|0}if(!l)p=0;else{b=g-k|0;c[e>>2]=(d[(c[a+36>>2]|0)+(b<<2)+2>>0]|0)>>>7&255|b<<1;p=1}if(l>>>0>=((c[h>>2]|0)+-1|0)>>>0){o=p;i=f;return o|0}c[e+(p<<2)>>2]=(d[(c[a+36>>2]|0)+(g<<2)+2>>0]|0)>>>7&255|g<<1;o=p+1|0;i=f;return o|0}else if((n|0)==1){if(!(m>>>0<(k+-1|0)>>>0?l>>>0<((c[h>>2]|0)+-1|0)>>>0:0)){o=0;i=f;return o|0}p=g<<1;c[e>>2]=p;c[e+4>>2]=p|1;o=2;i=f;return o|0}else if((n|0)==2){if(l>>>0>=((c[h>>2]|0)+-1|0)>>>0){o=0;i=f;return o|0}if(!m){q=k;r=0}else{c[e>>2]=(g<<1)+-1;q=c[j>>2]|0;r=1}if(m>>>0>=(q+-1|0)>>>0){o=r;i=f;return o|0}c[e+(r<<2)>>2]=g<<1;o=r+1|0;i=f;return o|0}else{o=0;i=f;return o|0}return 0}function D1a(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=ea(k);l=ea(l);m=m|0;var n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=Im;d=i;i=i+16|0;n=d;if(h>l){l=ea(ea(g[e>>2])*ea(2.0));o=ea(ea(g[e+4>>2])*ea(2.0));p=ea(ea(g[e+8>>2])*ea(2.0));q=ea(g[f+12>>2]);r=ea(ea(q*q)+ea(-.5));s=ea(g[f>>2]);t=ea(l*s);u=ea(g[f+4>>2]);v=ea(t+ea(o*u));t=ea(g[f+8>>2]);w=ea(v+ea(p*t));v=ea(ea(s*w)+ea(ea(l*r)+ea(q*ea(ea(p*u)-ea(o*t)))));x=ea(ea(u*w)+ea(ea(o*r)+ea(q*ea(ea(l*t)-ea(p*s)))));y=ea(ea(ea(p*r)+ea(q*ea(ea(o*s)-ea(l*u))))+ea(t*w));g[a>>2]=v;e=a+4|0;g[e>>2]=x;z=a+8|0;g[z>>2]=y;w=ea(T(ea(ea(ea(v*v)+ea(x*x))+ea(y*y))));if(!(w>ea(0.0))){A=w;g[m>>2]=A;i=d;return}t=ea(ea(1.0)/w);g[a>>2]=ea(v*t);g[e>>2]=ea(x*t);g[z>>2]=ea(y*t);A=w;g[m>>2]=A;i=d;return}else{w=ea(g[b>>2]);t=ea(w*j);j=ea(g[b+8>>2]);y=ea(j*k);t6a(n,c[b+12>>2]|0,t,y,w,ea(g[b+4>>2]),j);j=ea(ea(g[n>>2])*ea(2.0));w=ea(ea(g[n+4>>2])*ea(2.0));y=ea(ea(g[n+8>>2])*ea(2.0));t=ea(g[f+12>>2]);k=ea(ea(t*t)+ea(-.5));x=ea(g[f>>2]);v=ea(j*x);u=ea(g[f+4>>2]);l=ea(v+ea(w*u));v=ea(g[f+8>>2]);s=ea(l+ea(y*v));l=ea(ea(x*s)+ea(ea(j*k)+ea(t*ea(ea(y*u)-ea(w*v)))));o=ea(ea(u*s)+ea(ea(w*k)+ea(t*ea(ea(j*v)-ea(y*x)))));q=ea(ea(ea(y*k)+ea(t*ea(ea(w*x)-ea(j*u))))+ea(v*s));g[a>>2]=l;f=a+4|0;g[f>>2]=o;n=a+8|0;g[n>>2]=q;s=ea(ea(ea(l*l)+ea(o*o))+ea(q*q));if(s>ea(0.0)){v=ea(ea(1.0)/ea(T(ea(s))));B=ea(l*v);C=ea(o*v);D=ea(q*v)}else{B=ea(0.0);C=ea(0.0);D=ea(0.0)}g[a>>2]=B;g[f>>2]=C;g[n>>2]=D;A=ea(T(ea(h)));g[m>>2]=A;i=d;return}}function E1a(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im;h=i;j=f>>>1;k=c[e+36>>2]|0;l=(a[k+(j<<2)+2>>0]|0)<0;m=(f&1|0)==0;do if(l)if(m){f=c[e+20>>2]|0;n=f+j|0;o=j;p=j+1+f|0;break}else{f=j+1|0;n=f;o=(c[e+20>>2]|0)+f|0;p=j;break}else if(m){n=j;o=j+1|0;p=(c[e+20>>2]|0)+j|0;break}else{f=c[e+20>>2]|0;q=j+1|0;n=f+q|0;o=f+j|0;p=q;break}while(0);j=b[k+(n<<2)>>1]|0;n=b[k+(o<<2)>>1]|0;o=b[k+(p<<2)>>1]|0;p=ea(g[e+40>>2])>=ea(0.0);r=p?ea(-1.0):ea(1.0);if(l)if(m){s=ea(r*ea(j-o|0));g[d>>2]=ea(ea(n-j|0)*r);g[d+4>>2]=r;g[d+8>>2]=s;i=h;return}else{s=ea(r*ea(o-j|0));g[d>>2]=ea(ea(j-n|0)*r);g[d+4>>2]=r;g[d+8>>2]=s;i=h;return}else if(m){s=ea(ea(j-n|0)*r);g[d>>2]=ea(r*ea(j-o|0));g[d+4>>2]=r;g[d+8>>2]=s;i=h;return}else{s=ea(ea(n-j|0)*r);g[d>>2]=ea(r*ea(o-j|0));g[d+4>>2]=r;g[d+8>>2]=s;i=h;return}}function F1a(a,b,f,h,j,l,m,n,o,p,q,r){a=a|0;b=b|0;f=f|0;h=h|0;j=j|0;l=l|0;m=ea(m);n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=Im,Ha=0,Ia=Im,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0;s=i;i=i+624|0;t=s+288|0;u=s+240|0;v=s+184|0;w=s+436|0;x=s+520|0;y=s+52|0;z=s+56|0;A=s+60|0;B=s+64|0;C=s+72|0;D=s+120|0;E=s+400|0;F=s+416|0;G=s+424|0;H=s+472|0;I=s+560|0;J=s+608|0;K=s+336|0;L=s+340|0;M=s+344|0;N=s+356|0;O=s+368|0;P=s+40|0;Q=s+28|0;R=s;U=s+16|0;V=s+384|0;W=s+168|0;X=s+412|0;Y=s+232|0;Z=s+420|0;_=s+236|0;$=ea(g[j>>2]);aa=ea($+$);ba=j+4|0;ca=ea(g[ba>>2]);da=ea(ca+ca);fa=j+8|0;ga=ea(g[fa>>2]);ha=ea(ga+ga);ia=j+12|0;ja=ea(g[ia>>2]);ka=ea(aa*ja);la=ea(da*ja);ma=ea(ja*ha);ja=ea($*aa);aa=ea($*da);na=ea($*ha);$=ea(ca*da);da=ea(ca*ha);ca=ea(ga*ha);g[C>>2]=ea(ea(ea(1.0)-$)-ca);oa=C+4|0;g[oa>>2]=ea(aa+ma);pa=C+8|0;g[pa>>2]=ea(na-la);qa=C+12|0;g[qa>>2]=ea(aa-ma);ma=ea(ea(1.0)-ja);ra=C+16|0;g[ra>>2]=ea(ma-ca);sa=C+20|0;g[sa>>2]=ea(da+ka);ta=C+24|0;g[ta>>2]=ea(na+la);ua=C+28|0;g[ua>>2]=ea(da-ka);va=C+32|0;g[va>>2]=ea(ma-$);wa=C+36|0;xa=C+40|0;ya=C+44|0;za=j+16|0;g[wa>>2]=ea(g[za>>2]);Aa=j+20|0;g[xa>>2]=ea(g[Aa>>2]);Ba=j+24|0;g[ya>>2]=ea(g[Ba>>2]);$=ea(g[l>>2]);ma=ea($+$);Ca=l+4|0;ka=ea(g[Ca>>2]);da=ea(ka+ka);Da=l+8|0;la=ea(g[Da>>2]);na=ea(la+la);Ea=l+12|0;ca=ea(g[Ea>>2]);ja=ea(ma*ca);aa=ea(da*ca);ha=ea(ca*na);ca=ea($*ma);ma=ea($*da);ga=ea($*na);$=ea(ka*da);da=ea(ka*na);ka=ea(la*na);na=ea(ea(ea(1.0)-$)-ka);g[D>>2]=na;la=ea(ma+ha);Fa=D+4|0;g[Fa>>2]=la;Ga=ea(ga-aa);Ha=D+8|0;g[Ha>>2]=Ga;Ia=ea(ma-ha);Ja=D+12|0;g[Ja>>2]=Ia;ha=ea(ea(1.0)-ca);ca=ea(ha-ka);Ka=D+16|0;g[Ka>>2]=ca;ka=ea(da+ja);La=D+20|0;g[La>>2]=ka;ma=ea(ga+aa);Ma=D+24|0;g[Ma>>2]=ma;aa=ea(da-ja);Na=D+28|0;g[Na>>2]=aa;ja=ea(ha-$);Oa=D+32|0;g[Oa>>2]=ja;Pa=l+16|0;$=ea(g[Pa>>2]);g[D+36>>2]=$;Qa=l+20|0;ha=ea(g[Qa>>2]);g[D+40>>2]=ha;Ra=l+24|0;da=ea(g[Ra>>2]);g[D+44>>2]=da;ga=ea(g[a>>2]);Sa=ea(ga*ea(g[C>>2]));Ta=ea(ga*ea(g[oa>>2]));Ua=ea(ga*ea(g[pa>>2]));ga=ea(g[a+4>>2]);Va=ea(ga*ea(g[qa>>2]));Wa=ea(ga*ea(g[ra>>2]));Xa=ea(Sa+Va);Va=ea(Ta+Wa);Wa=ea(Ua+ea(ga*ea(g[sa>>2])));ga=ea(g[a+8>>2]);Ua=ea(ga*ea(g[ta>>2]));Ta=ea(ga*ea(g[ua>>2]));Sa=ea(Xa+Ua);Ua=ea(Va+Ta);Ta=ea(Wa+ea(ga*ea(g[va>>2])));ga=ea(Sa+ea(g[wa>>2]));Sa=ea(Ua+ea(g[xa>>2]));Ua=ea(Ta+ea(g[ya>>2]));Ta=ea(g[b>>2]);Wa=ea(Ta*na);na=ea(Ta*la);la=ea(Ta*Ga);Ga=ea(g[b+4>>2]);Ta=ea(Wa+ea(Ga*Ia));Ia=ea(na+ea(Ga*ca));ca=ea(la+ea(Ga*ka));ka=ea(g[b+8>>2]);Ga=ea(ea(ea(Ia+ea(ka*aa))+ha)-Sa);Sa=ea(ea(da+ea(ca+ea(ka*ja)))-Ua);g[E>>2]=ea(ea(ea(Ta+ea(ka*ma))+$)-ga);Ya=E+4|0;g[Ya>>2]=Ga;Za=E+8|0;g[Za>>2]=Sa;_a=c[a+60>>2]|0;if(_a)In[_a&4095](c[a+12>>2]|0,c[a+28>>2]|0);_a=c[b+60>>2]|0;if(_a)In[_a&4095](c[b+12>>2]|0,c[b+28>>2]|0);rn[c[a+64>>2]&127](a,E,C,o,A,B);Sa=ea(g[A>>2]);Ga=ea(g[B>>2]);rn[c[b+64>>2]&127](b,E,D,p,y,z);ga=ea(Ga+m);$=ea(g[y>>2]);if(ga<$){$a=0;i=s;return $a|0}ga=ea(g[z>>2]);if(ea(ga+m)<Sa){$a=0;i=s;return $a|0}ma=ea(Ga-$);$=ea(ga-Sa);g[F>>2]=ma<$?ma:$;$=ea(g[l>>2]);ma=ea(-$);Sa=ea(g[Ca>>2]);ga=ea(-Sa);Ga=ea(g[Da>>2]);ka=ea(-Ga);Ta=ea(g[Ea>>2]);Ua=ea(g[za>>2]);ja=ea(g[Pa>>2]);ca=ea(Ua-ja);da=ea(g[Aa>>2]);ha=ea(g[Qa>>2]);aa=ea(da-ha);Ia=ea(g[Ba>>2]);la=ea(g[Ra>>2]);na=ea(ca*ea(2.0));ca=ea(aa*ea(2.0));aa=ea(ea(Ia-la)*ea(2.0));Wa=ea(ea(Ta*Ta)+ea(-.5));Va=ea(ea(ea(na*ma)+ea(ca*ga))+ea(aa*ka));Xa=ea(ea(Va*ma)+ea(ea(Wa*na)+ea(Ta*ea(ea(aa*ga)-ea(ca*ka)))));ab=ea(ea(Va*ga)+ea(ea(Wa*ca)+ea(Ta*ea(ea(na*ka)-ea(aa*ma)))));bb=ea(ea(ea(Wa*aa)+ea(Ta*ea(ea(ca*ma)-ea(na*ga))))+ea(Va*ka));Va=ea(g[j>>2]);na=ea(Ta*Va);ca=ea(g[ia>>2]);aa=ea(na+ea(ca*ma));na=ea(g[fa>>2]);Wa=ea(aa+ea(na*ga));aa=ea(g[ba>>2]);cb=ea(Wa-ea(aa*ka));Wa=ea(ea(ea(Va*ka)+ea(ea(ca*ga)+ea(Ta*aa)))-ea(na*ma));db=ea(ea(ea(aa*ma)+ea(ea(ca*ka)+ea(Ta*na)))-ea(Va*ga));eb=ea(Ta*ca);fb=ea(ea(ea(eb-ea(Va*ma))-ea(aa*ga))-ea(na*ka));ka=ea(-Va);Va=ea(-aa);aa=ea(-na);na=ea(ea(ja-Ua)*ea(2.0));Ua=ea(ea(ha-da)*ea(2.0));da=ea(ea(la-Ia)*ea(2.0));Ia=ea(ea(ca*ca)+ea(-.5));la=ea(ea(da*aa)+ea(ea(na*ka)+ea(Ua*Va)));ha=ea(ea(la*ka)+ea(ea(na*Ia)+ea(ca*ea(ea(da*Va)-ea(Ua*aa)))));ja=ea(ea(ea(Ua*Ia)+ea(ca*ea(ea(na*aa)-ea(da*ka))))+ea(la*Va));ga=ea(ea(ea(da*Ia)+ea(ca*ea(ea(Ua*ka)-ea(na*Va))))+ea(la*aa));la=ea(ea(ea(ea($*ca)+ea(Ta*ka))+ea(Ga*Va))-ea(Sa*aa));na=ea(ea(ea($*aa)+ea(ea(Sa*ca)+ea(Ta*Va)))-ea(Ga*ka));Ua=ea(ea(ea(Sa*ka)+ea(ea(Ga*ca)+ea(Ta*aa)))-ea($*Va));Ta=ea(ea(ea(eb-ea($*ka))-ea(Sa*Va))-ea(Ga*aa));aa=ea(cb+cb);Ga=ea(Wa+Wa);Va=ea(db+db);Sa=ea(aa*fb);ka=ea(fb*Ga);$=ea(fb*Va);fb=ea(cb*aa);aa=ea(cb*Ga);eb=ea(cb*Va);cb=ea(Wa*Ga);Ga=ea(Wa*Va);Wa=ea(db*Va);g[H>>2]=ea(ea(ea(1.0)-cb)-Wa);g[H+4>>2]=ea($+aa);g[H+8>>2]=ea(eb-ka);g[H+12>>2]=ea(aa-$);$=ea(ea(1.0)-fb);g[H+16>>2]=ea($-Wa);g[H+20>>2]=ea(Sa+Ga);g[H+24>>2]=ea(eb+ka);g[H+28>>2]=ea(Ga-Sa);g[H+32>>2]=ea($-cb);g[H+36>>2]=Xa;g[H+40>>2]=ab;g[H+44>>2]=bb;bb=ea(la+la);ab=ea(na+na);Xa=ea(Ua+Ua);cb=ea(Ta*bb);$=ea(Ta*ab);Sa=ea(Ta*Xa);Ta=ea(la*bb);bb=ea(la*ab);Ga=ea(la*Xa);la=ea(na*ab);ab=ea(na*Xa);na=ea(Ua*Xa);g[I>>2]=ea(ea(ea(1.0)-la)-na);g[I+4>>2]=ea(Sa+bb);g[I+8>>2]=ea(Ga-$);g[I+12>>2]=ea(bb-Sa);Sa=ea(ea(1.0)-Ta);g[I+16>>2]=ea(Sa-na);g[I+20>>2]=ea(ab+cb);g[I+24>>2]=ea(Ga+$);g[I+28>>2]=ea(ab-cb);g[I+32>>2]=ea(Sa-la);g[I+36>>2]=ha;g[I+40>>2]=ja;g[I+44>>2]=ga;Ba=x+4|0;Aa=x+8|0;za=v+4|0;z=v+8|0;y=w+4|0;B=w+8|0;A=G+4|0;_a=G+8|0;gb=a+24|0;hb=b+24|0;ib=R+4|0;jb=R+8|0;kb=R+12|0;lb=Q+4|0;mb=Q+8|0;nb=V+4|0;ob=V+8|0;pb=V+12|0;qb=U+4|0;rb=U+8|0;sb=n+4100|0;tb=W+4|0;ub=W+8|0;vb=t+4|0;wb=t+8|0;xb=t+12|0;yb=t+16|0;zb=t+20|0;Ab=t+24|0;Bb=t+28|0;Cb=t+32|0;Db=t+36|0;Eb=t+40|0;Fb=t+44|0;Gb=u+4|0;Hb=u+8|0;Ib=u+12|0;Jb=u+16|0;Kb=u+20|0;Lb=u+24|0;Mb=u+28|0;Nb=u+32|0;Ob=u+36|0;Pb=u+40|0;Qb=u+44|0;Rb=v+4|0;Sb=v+8|0;Tb=v+12|0;Ub=v+16|0;Vb=v+20|0;Wb=v+24|0;Xb=v+28|0;Yb=v+32|0;Zb=v+36|0;_b=v+40|0;$b=v+44|0;ac=a+28|0;bc=a+32|0;cc=b+28|0;dc=b+32|0;ec=p+36|0;fc=p+40|0;gc=p+44|0;hc=p+48|0;ic=p+52|0;jc=p+56|0;kc=p+60|0;lc=p+64|0;mc=p+68|0;nc=o+36|0;oc=o+40|0;pc=o+44|0;qc=o+48|0;rc=o+52|0;sc=o+56|0;tc=o+60|0;uc=o+64|0;vc=o+68|0;wc=b+68|0;xc=M+4|0;yc=M+8|0;zc=a+68|0;Ac=N+4|0;Bc=N+8|0;Cc=O+4|0;Dc=O+8|0;Ec=P+4|0;Fc=P+8|0;Gc=0;Hc=1;Ic=32767;Jc=32767;while(1){if(Hc){g[t>>2]=ea(3402823469999999843913219.0e14);g[u>>2]=ea(3402823469999999843913219.0e14);ga=ea(g[C>>2]);ja=ea(g[E>>2]);ha=ea(ga*ja);ga=ea(g[oa>>2]);la=ea(g[Ya>>2]);Sa=ea(ha+ea(ga*la));ga=ea(g[pa>>2]);ha=ea(g[Za>>2]);cb=ea(Sa+ea(ga*ha));ga=ea(ja*ea(g[qa>>2]));Sa=ea(ga+ea(la*ea(g[ra>>2])));ga=ea(Sa+ea(ha*ea(g[sa>>2])));Sa=ea(ja*ea(g[ta>>2]));ab=ea(Sa+ea(la*ea(g[ua>>2])));Sa=ea(ab+ea(ha*ea(g[va>>2])));ab=ea(-la);la=ea(-ha);g[x>>2]=ea(-ja);g[Ba>>2]=ab;g[Aa>>2]=la;if(!(kEb(a,b,C,D,o,p,I,cb,ga,Sa,t,v,K,m,x)|0)){$a=0;Kc=37;break}Sa=ea(g[D>>2]);ga=ea(g[E>>2]);cb=ea(Sa*ga);Sa=ea(g[Fa>>2]);la=ea(g[Ya>>2]);ab=ea(cb+ea(Sa*la));Sa=ea(g[Ha>>2]);cb=ea(g[Za>>2]);ja=ea(ab+ea(Sa*cb));Sa=ea(ga*ea(g[Ja>>2]));ab=ea(Sa+ea(la*ea(g[Ka>>2])));Sa=ea(ab+ea(cb*ea(g[La>>2])));ab=ea(ga*ea(g[Ma>>2]));ga=ea(ab+ea(la*ea(g[Na>>2])));if(!(kEb(b,a,D,C,p,o,H,ea(-ja),ea(-Sa),ea(-ea(ga+ea(cb*ea(g[Oa>>2])))),u,w,L,m,E)|0)){$a=0;Kc=37;break}cb=ea(g[t>>2]);ga=ea(g[v>>2]);Sa=ea(g[za>>2]);ja=ea(g[z>>2]);c[J>>2]=0;la=ea(g[u>>2]);if(la<cb){ab=ea(g[w>>2]);ha=ea(g[y>>2]);$=ea(g[B>>2]);c[J>>2]=1;Lc=ab;Mc=ha;Nc=$;Oc=la}else{Lc=ga;Mc=Sa;Nc=ja;Oc=cb}g[F>>2]=Oc;g[G>>2]=Lc;g[A>>2]=Mc;g[_a>>2]=Nc;Pc=Lc;Qc=Mc;Rc=Nc}else{if(!(lEb(f,h,a,b,C,D,o,p,H,I,E,K,L,F,G,J,m)|0)){$a=0;Kc=37;break}cb=ea(g[G>>2]);ja=ea(g[A>>2]);Pc=cb;Qc=ja;Rc=ea(g[_a>>2])}ja=ea(ea(g[E>>2])*Pc);cb=ea(ja+ea(ea(g[Ya>>2])*Qc));if(ea(cb+ea(ea(g[Za>>2])*Rc))<ea(0.0)){cb=ea(-Pc);ja=ea(-Qc);Sa=ea(-Rc);g[G>>2]=cb;g[A>>2]=ja;g[_a>>2]=Sa;Sc=cb;Tc=ja;Uc=Sa}else{Sc=Pc;Tc=Qc;Uc=Rc}Vc=c[J>>2]|0;if((Vc|0)==2){Wc=c[zc>>2]|0;Sa=ea(ea(g[C>>2])*Sc);ja=ea(Sa+ea(ea(g[oa>>2])*Tc));Sa=ea(ja+ea(ea(g[pa>>2])*Uc));ja=ea(Sc*ea(g[qa>>2]));cb=ea(ja+ea(Tc*ea(g[ra>>2])));ja=ea(cb+ea(Uc*ea(g[sa>>2])));cb=ea(Sc*ea(g[ta>>2]));ga=ea(cb+ea(Tc*ea(g[ua>>2])));cb=ea(ga+ea(Uc*ea(g[va>>2])));g[O>>2]=Sa;g[Cc>>2]=ja;g[Dc>>2]=cb;Xc=xo[Wc&2047](a,o,O)|0;Wc=c[wc>>2]|0;cb=ea(-Sc);ja=ea(-Tc);Sa=ea(-Uc);ga=ea(ea(g[D>>2])*cb);la=ea(ga+ea(ea(g[Fa>>2])*ja));ga=ea(la+ea(ea(g[Ha>>2])*Sa));la=ea(ea(g[Ja>>2])*cb);$=ea(la+ea(ea(g[Ka>>2])*ja));la=ea($+ea(ea(g[La>>2])*Sa));$=ea(ea(g[Ma>>2])*cb);cb=ea($+ea(ea(g[Na>>2])*ja));ja=ea(cb+ea(ea(g[Oa>>2])*Sa));g[P>>2]=ga;g[Ec>>2]=la;g[Fc>>2]=ja;Yc=Xc;Zc=xo[Wc&2047](b,p,P)|0}else if(!Vc){Wc=c[K>>2]|0;Xc=c[wc>>2]|0;ja=ea(-Sc);la=ea(-Tc);ga=ea(-Uc);Sa=ea(ea(g[D>>2])*ja);cb=ea(Sa+ea(ea(g[Fa>>2])*la));Sa=ea(cb+ea(ea(g[Ha>>2])*ga));cb=ea(ea(g[Ja>>2])*ja);$=ea(cb+ea(ea(g[Ka>>2])*la));cb=ea($+ea(ea(g[La>>2])*ga));$=ea(ea(g[Ma>>2])*ja);ja=ea($+ea(ea(g[Na>>2])*la));la=ea(ja+ea(ea(g[Oa>>2])*ga));g[M>>2]=Sa;g[xc>>2]=cb;g[yc>>2]=la;Yc=Wc;Zc=xo[Xc&2047](b,p,M)|0}else if((Vc|0)==1){Vc=c[zc>>2]|0;la=ea(ea(g[C>>2])*Sc);cb=ea(la+ea(ea(g[oa>>2])*Tc));la=ea(cb+ea(ea(g[pa>>2])*Uc));cb=ea(Sc*ea(g[qa>>2]));Sa=ea(cb+ea(Tc*ea(g[ra>>2])));cb=ea(Sa+ea(Uc*ea(g[sa>>2])));Sa=ea(Sc*ea(g[ta>>2]));ga=ea(Sa+ea(Tc*ea(g[ua>>2])));Sa=ea(ga+ea(Uc*ea(g[va>>2])));g[N>>2]=la;g[Ac>>2]=cb;g[Bc>>2]=Sa;Xc=xo[Vc&2047](a,o,N)|0;Yc=Xc;Zc=c[L>>2]|0}else{Yc=Ic;Zc=Jc}Xc=c[gb>>2]|0;Vc=Xc+(Yc*20|0)|0;Wc=c[hb>>2]|0;_c=Wc+(Zc*20|0)|0;Sa=ea(g[F>>2]);cb=ea(-Sa);$c=Sa>=ea(0.0);Sa=$c?ea(0.0):cb;if(q){$c=c[Vc>>2]|0;c[R>>2]=$c;ad=c[Xc+(Yc*20|0)+4>>2]|0;c[ib>>2]=ad;bd=c[Xc+(Yc*20|0)+8>>2]|0;c[jb>>2]=bd;c[kb>>2]=c[Xc+(Yc*20|0)+12>>2];cb=(c[k>>2]=$c,ea(g[k>>2]));la=ea(g[C>>2]);ga=ea(cb*la);ja=ea(g[oa>>2]);$=ea(cb*ja);ha=ea(g[pa>>2]);ab=ea(cb*ha);cb=(c[k>>2]=ad,ea(g[k>>2]));Ga=ea(g[qa>>2]);na=ea(cb*Ga);Ta=ea(g[ra>>2]);bb=ea(cb*Ta);Xa=ea(g[sa>>2]);Ua=ea(ga+na);na=ea($+bb);bb=ea(ab+ea(cb*Xa));cb=(c[k>>2]=bd,ea(g[k>>2]));ab=ea(g[ta>>2]);$=ea(cb*ab);ga=ea(g[ua>>2]);ka=ea(cb*ga);eb=ea(g[va>>2]);cd=la;dd=ja;ed=ha;fd=Ga;gd=Ta;hd=Xa;id=ab;jd=ga;kd=eb;ld=ea(bb+ea(cb*eb));md=ea(na+ka);nd=ea(Ua+$)}else{$=ea(g[Xc+(Yc*20|0)+12>>2]);Ua=ea(g[nc>>2]);ka=ea(g[Vc>>2]);na=ea(Ua*ka);Ua=ea(g[oc>>2]);eb=ea(g[Xc+(Yc*20|0)+4>>2]);cb=ea(na+ea(Ua*eb));Ua=ea(g[pc>>2]);na=ea(g[Xc+(Yc*20|0)+8>>2]);bb=ea(cb+ea(Ua*na));Ua=ea(ka*ea(g[qc>>2]));cb=ea(Ua+ea(eb*ea(g[rc>>2])));Ua=ea(cb+ea(na*ea(g[sc>>2])));cb=ea(ka*ea(g[tc>>2]));ka=ea(cb+ea(eb*ea(g[uc>>2])));eb=ea(ka+ea(na*ea(g[vc>>2])));na=ea(ea(1.0)/ea(T(ea(ea(ea(bb*bb)+ea(Ua*Ua))+ea(eb*eb)))));ka=ea(bb*na);bb=ea(Ua*na);Ua=ea(eb*na);g[R>>2]=ka;g[ib>>2]=bb;g[jb>>2]=Ua;g[kb>>2]=ea($*na);na=ea(g[C>>2]);$=ea(ka*na);eb=ea(g[oa>>2]);cb=ea(ka*eb);ga=ea(g[pa>>2]);ab=ea(ka*ga);ka=ea(g[qa>>2]);Xa=ea(bb*ka);Ta=ea(g[ra>>2]);Ga=ea(bb*Ta);ha=ea(g[sa>>2]);ja=ea($+Xa);Xa=ea(cb+Ga);Ga=ea(ab+ea(bb*ha));bb=ea(g[ta>>2]);ab=ea(Ua*bb);cb=ea(g[ua>>2]);$=ea(Ua*cb);la=ea(g[va>>2]);cd=na;dd=eb;ed=ga;fd=ka;gd=Ta;hd=ha;id=bb;jd=cb;kd=la;ld=ea(Ga+ea(Ua*la));md=ea(Xa+$);nd=ea(ja+ab)}g[Q>>2]=nd;g[lb>>2]=md;g[mb>>2]=ld;if(r){Vc=c[_c>>2]|0;c[V>>2]=Vc;bd=c[Wc+(Zc*20|0)+4>>2]|0;c[nb>>2]=bd;ad=c[Wc+(Zc*20|0)+8>>2]|0;c[ob>>2]=ad;c[pb>>2]=c[Wc+(Zc*20|0)+12>>2];ab=(c[k>>2]=Vc,ea(g[k>>2]));ja=ea(ab*ea(g[D>>2]));$=ea(ab*ea(g[Fa>>2]));Xa=ea(ab*ea(g[Ha>>2]));ab=(c[k>>2]=bd,ea(g[k>>2]));la=ea(ab*ea(g[Ja>>2]));Ua=ea(ab*ea(g[Ka>>2]));Ga=ea(ja+la);la=ea($+Ua);Ua=ea(Xa+ea(ab*ea(g[La>>2])));ab=(c[k>>2]=ad,ea(g[k>>2]));Xa=ea(ab*ea(g[Ma>>2]));$=ea(ab*ea(g[Na>>2]));od=ea(Ua+ea(ab*ea(g[Oa>>2])));pd=ea(la+$);qd=ea(Ga+Xa)}else{Xa=ea(g[Wc+(Zc*20|0)+12>>2]);Ga=ea(g[ec>>2]);$=ea(g[_c>>2]);la=ea(Ga*$);Ga=ea(g[fc>>2]);ab=ea(g[Wc+(Zc*20|0)+4>>2]);Ua=ea(la+ea(Ga*ab));Ga=ea(g[gc>>2]);la=ea(g[Wc+(Zc*20|0)+8>>2]);ja=ea(Ua+ea(Ga*la));Ga=ea($*ea(g[hc>>2]));Ua=ea(Ga+ea(ab*ea(g[ic>>2])));Ga=ea(Ua+ea(la*ea(g[jc>>2])));Ua=ea($*ea(g[kc>>2]));$=ea(Ua+ea(ab*ea(g[lc>>2])));ab=ea($+ea(la*ea(g[mc>>2])));la=ea(ea(1.0)/ea(T(ea(ea(ea(ja*ja)+ea(Ga*Ga))+ea(ab*ab)))));$=ea(ja*la);ja=ea(Ga*la);Ga=ea(ab*la);g[V>>2]=$;g[nb>>2]=ja;g[ob>>2]=Ga;g[pb>>2]=ea(Xa*la);la=ea($*ea(g[D>>2]));Xa=ea($*ea(g[Fa>>2]));ab=ea($*ea(g[Ha>>2]));$=ea(ja*ea(g[Ja>>2]));Ua=ea(ja*ea(g[Ka>>2]));cb=ea(la+$);$=ea(Xa+Ua);Ua=ea(ab+ea(ja*ea(g[La>>2])));ja=ea(Ga*ea(g[Ma>>2]));ab=ea(Ga*ea(g[Na>>2]));od=ea(Ua+ea(Ga*ea(g[Oa>>2])));pd=ea($+ab);qd=ea(cb+ja)}g[U>>2]=qd;g[qb>>2]=pd;g[rb>>2]=od;_c=ea(S(ea(ea(ea(nd*Sc)+ea(md*Tc))+ea(ld*Uc))))>ea(S(ea(ea(ea(Sc*qd)+ea(Tc*pd))+ea(Uc*od))));ja=ea(Sa+ea(g[sb>>2]));Sa=ea(-ja);cb=ea(Sc*Sa);ab=ea(Tc*Sa);$=ea(Uc*Sa);g[W>>2]=cb;g[tb>>2]=ab;g[ub>>2]=$;Sa=ea(ea(g[wa>>2])-cb);cb=ea(ea(g[xa>>2])-ab);ab=ea(ea(g[ya>>2])-$);g[t>>2]=cd;g[vb>>2]=dd;g[wb>>2]=ed;g[xb>>2]=fd;g[yb>>2]=gd;g[zb>>2]=hd;g[Ab>>2]=id;g[Bb>>2]=jd;g[Cb>>2]=kd;g[Db>>2]=Sa;g[Eb>>2]=cb;g[Fb>>2]=ab;$=ea(g[j>>2]);Ga=ea(g[ba>>2]);Ua=ea(g[fa>>2]);Xa=ea(g[ia>>2]);la=ea(g[l>>2]);bb=ea(-la);ha=ea(g[Ca>>2]);Ta=ea(-ha);ka=ea(g[Da>>2]);ga=ea(-ka);eb=ea(g[Ea>>2]);na=ea(g[Pa>>2]);Wa=ea(Sa-na);fb=ea(g[Qa>>2]);aa=ea(cb-fb);Va=ea(g[Ra>>2]);db=ea(Wa*ea(2.0));Wa=ea(aa*ea(2.0));aa=ea(ea(ab-Va)*ea(2.0));ca=ea(ea(eb*eb)+ea(-.5));Ia=ea(ea(ea(db*bb)+ea(Wa*Ta))+ea(aa*ga));da=ea(ea(Ia*bb)+ea(ea(ca*db)+ea(eb*ea(ea(aa*Ta)-ea(Wa*ga)))));ma=ea(ea(Ia*Ta)+ea(ea(ca*Wa)+ea(eb*ea(ea(db*ga)-ea(aa*bb)))));rd=ea(ea(ea(ca*aa)+ea(eb*ea(ea(Wa*bb)-ea(db*Ta))))+ea(Ia*ga));Ia=ea(ea(ea(Ua*Ta)+ea(ea(Xa*bb)+ea($*eb)))-ea(Ga*ga));db=ea(ea(ea($*ga)+ea(ea(Xa*Ta)+ea(Ga*eb)))-ea(Ua*bb));Wa=ea(ea(ea(Ga*bb)+ea(ea(Xa*ga)+ea(Ua*eb)))-ea($*Ta));aa=ea(Xa*eb);ca=ea(ea(ea(aa-ea($*bb))-ea(Ga*Ta))-ea(Ua*ga));ga=ea(-$);$=ea(-Ga);Ga=ea(-Ua);Ua=ea(ea(na-Sa)*ea(2.0));Sa=ea(ea(fb-cb)*ea(2.0));cb=ea(ea(Va-ab)*ea(2.0));ab=ea(ea(Xa*Xa)+ea(-.5));Va=ea(ea(ea(Ua*ga)+ea(Sa*$))+ea(cb*Ga));fb=ea(ea(Va*ga)+ea(ea(ab*Ua)+ea(Xa*ea(ea(cb*$)-ea(Sa*Ga)))));na=ea(ea(Va*$)+ea(ea(ab*Sa)+ea(Xa*ea(ea(Ua*Ga)-ea(cb*ga)))));Ta=ea(ea(ea(ab*cb)+ea(Xa*ea(ea(Sa*ga)-ea(Ua*$))))+ea(Va*Ga));Va=ea(ea(ea(ka*$)+ea(ea(Xa*la)+ea(eb*ga)))-ea(ha*Ga));Ua=ea(ea(ea(la*Ga)+ea(ea(Xa*ha)+ea(eb*$)))-ea(ka*ga));Sa=ea(ea(ea(ha*ga)+ea(ea(Xa*ka)+ea(eb*Ga)))-ea(la*$));eb=ea(ea(ea(aa-ea(la*ga))-ea(ha*$))-ea(ka*Ga));Ga=ea(Ia+Ia);ka=ea(db+db);$=ea(Wa+Wa);ha=ea(ca*Ga);ga=ea(ca*ka);la=ea(ca*$);ca=ea(Ia*Ga);Ga=ea(Ia*ka);aa=ea(Ia*$);Ia=ea(db*ka);ka=ea(db*$);db=ea(Wa*$);g[u>>2]=ea(ea(ea(1.0)-Ia)-db);g[Gb>>2]=ea(Ga+la);g[Hb>>2]=ea(aa-ga);g[Ib>>2]=ea(Ga-la);la=ea(ea(1.0)-ca);g[Jb>>2]=ea(la-db);g[Kb>>2]=ea(ka+ha);g[Lb>>2]=ea(aa+ga);g[Mb>>2]=ea(ka-ha);g[Nb>>2]=ea(la-Ia);g[Ob>>2]=da;g[Pb>>2]=ma;g[Qb>>2]=rd;rd=ea(Va+Va);ma=ea(Ua+Ua);da=ea(Sa+Sa);Ia=ea(eb*rd);la=ea(eb*ma);ha=ea(eb*da);eb=ea(Va*rd);rd=ea(Va*ma);ka=ea(Va*da);Va=ea(Ua*ma);ma=ea(Ua*da);Ua=ea(Sa*da);g[v>>2]=ea(ea(ea(1.0)-Va)-Ua);g[Rb>>2]=ea(rd+ha);g[Sb>>2]=ea(ka-la);g[Tb>>2]=ea(rd-ha);ha=ea(ea(1.0)-eb);g[Ub>>2]=ea(ha-Ua);g[Vb>>2]=ea(ma+Ia);g[Wb>>2]=ea(ka+la);g[Xb>>2]=ea(ma-Ia);g[Yb>>2]=ea(ha-Va);g[Zb>>2]=fb;g[_b>>2]=na;g[$b>>2]=Ta;ad=Xc+(Yc*20|0)+18|0;if(q){sd=0;td=0}else{bd=d[ad>>0]|0;Vc=i;i=i+((1*(bd*12|0)|0)+15&-16)|0;$c=i;i=i+((1*bd|0)+15&-16)|0;sd=Vc;td=$c}iOa(X,Y,sd,td,q,c[ac>>2]|0,(c[bc>>2]|0)+(e[Xc+(Yc*20|0)+16>>1]|0)|0,d[ad>>0]|0,o);Xc=Wc+(Zc*20|0)+18|0;if(r){ud=0;vd=0}else{$c=d[Xc>>0]|0;Vc=i;i=i+((1*($c*12|0)|0)+15&-16)|0;bd=i;i=i+((1*$c|0)+15&-16)|0;ud=Vc;vd=bd}iOa(Z,_,ud,vd,r,c[cc>>2]|0,(c[dc>>2]|0)+(e[Wc+(Zc*20|0)+16>>1]|0)|0,d[Xc>>0]|0,p);XNa(w,R);XNa(x,V);if(_c)if(YNa(d[ad>>0]|0,c[X>>2]|0,c[Y>>2]|0,t,R,w,d[Xc>>0]|0,c[Z>>2]|0,c[_>>2]|0,D,V,x,Q,u,v,-1,-1,n,1,W,ja)|0){wd=0;xd=1;yd=Hc}else Kc=35;else if(YNa(d[Xc>>0]|0,c[Z>>2]|0,c[_>>2]|0,D,V,x,d[ad>>0]|0,c[X>>2]|0,c[Y>>2]|0,t,R,w,U,v,u,-1,-1,n,0,W,ja)|0){wd=0;xd=1;yd=Hc}else Kc=35;if((Kc|0)==35){Kc=0;wd=Hc;xd=Hc&Gc;yd=0}if(wd){Gc=xd;Hc=yd;Ic=Yc;Jc=Zc}else{$a=xd;Kc=37;break}}if((Kc|0)==37){i=s;return $a|0}return 0}function G1a(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(HPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function H1a(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(IPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function I1a(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(JPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function J1a(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(KPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function K1a(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(LPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function L1a(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(MPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function M1a(b,d,f,h,j,k,l,m,n,o,p){b=b|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=0,ga=Im,ha=0,ia=Im,ja=0,ka=Im,la=0,ma=0,na=0,oa=Im,pa=0,qa=0,ra=Im,sa=0,ta=0,ua=Im,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im;q=i;i=i+1072|0;r=q+936|0;s=q+208|0;t=q+1028|0;u=q+920|0;v=q+1016|0;w=q+624|0;x=q+608|0;y=q+708|0;z=q+696|0;A=q+332|0;B=q+368|0;C=q+428|0;D=q+488|0;E=q+548|0;F=q+576|0;G=q+592|0;H=q+832|0;I=q+176|0;J=q;K=q+1040|0;L=q+720|0;M=q+736|0;N=q+752|0;O=q+768|0;P=q+772|0;Q=q+784|0;R=q+796|0;S=q+320|0;U=q+304|0;V=q+224|0;W=q+308|0;X=q+808|0;Y=q+820|0;Z=q+32|0;_=q+848|0;$=q+1052|0;aa=c[d>>2]|0;ba=aa+36|0;ca=aa+40|0;J0a(w,ca,aa+52|0);da=ea(g[b+56>>2]);fa=b+28|0;ga=ea(da-ea(g[fa>>2]));da=ea(g[b+60>>2]);ha=b+32|0;ia=ea(da-ea(g[ha>>2]));da=ea(g[b+64>>2]);ja=b+36|0;ka=ea(da-ea(g[ja>>2]));g[x>>2]=ga;g[x+4>>2]=ia;g[x+8>>2]=ka;la=d+40|0;ma=d+56|0;da=ea(g[ma>>2]);na=d+28|0;oa=ea(da-ea(g[na>>2]));pa=d+60|0;da=ea(g[pa>>2]);qa=d+32|0;ra=ea(da-ea(g[qa>>2]));sa=d+64|0;da=ea(g[sa>>2]);ta=d+36|0;ua=ea(da-ea(g[ta>>2]));g[y>>2]=oa;g[y+4>>2]=ra;g[y+8>>2]=ua;da=ea(ga-oa);oa=ea(ia-ra);ra=ea(ka-ua);g[z>>2]=da;va=z+4|0;g[va>>2]=oa;wa=z+8|0;g[wa>>2]=ra;ua=ea(T(ea(ea(ra*ra)+ea(ea(da*da)+ea(oa*oa)))));if(ua>ea(0.0)){ka=ea(ea(1.0)/ua);g[z>>2]=ea(da*ka);g[va>>2]=ea(oa*ka);g[wa>>2]=ea(ra*ka)}wa=b+12|0;ka=ea(g[wa>>2]);va=b+16|0;ia=ea(g[va>>2]);xa=b+20|0;ga=ea(g[xa>>2]);ya=b+24|0;za=ea(g[ya>>2]);Aa=ea(ka+ka);Ba=ea(ia+ia);Ca=ea(ga+ga);Da=ea(ka*Aa);ka=ea(ia*Ba);Ea=ea(ga*Ca);Fa=ea(Aa*ia);ia=ea(Aa*ga);Ga=ea(Aa*za);Aa=ea(Ba*ga);ga=ea(Ba*za);Ba=ea(Ca*za);za=ea(Fa+Ba);Ca=ea(ia-ga);g[A>>2]=ea(ea(ea(1.0)-ka)-Ea);g[A+4>>2]=za;g[A+8>>2]=Ca;Ca=ea(ea(1.0)-Da);Da=ea(Ca-Ea);Ea=ea(Aa+Ga);g[A+12>>2]=ea(Fa-Ba);g[A+16>>2]=Da;g[A+20>>2]=Ea;Ea=ea(Aa-Ga);Ga=ea(Ca-ka);g[A+24>>2]=ea(ia+ga);g[A+28>>2]=Ea;g[A+32>>2]=Ga;Ha=b+68|0;Ia=b+80|0;wLa(B,Ha,Ia,A,z,ua);if((ea(g[ca>>2])==ea(1.0)?ea(g[aa+44>>2])==ea(1.0):0)?ea(g[aa+48>>2])==ea(1.0):0){ua=ea(g[ma>>2]);Ga=ea(g[pa>>2]);Ea=ea(ua*ea(-2.0));ua=ea(Ga*ea(-2.0));Ga=ea(ea(g[sa>>2])*ea(-2.0));ga=ea(g[d+52>>2]);ia=ea(ea(ga*ga)+ea(-.5));ka=ea(g[la>>2]);Ca=ea(Ea*ka);Aa=ea(g[d+44>>2]);Da=ea(Ca+ea(ua*Aa));Ca=ea(g[d+48>>2]);Ba=ea(Da+ea(Ga*Ca));Da=ea(ea(ka*Ba)+ea(ea(Ea*ia)-ea(ga*ea(ea(Ga*Aa)-ea(ua*Ca)))));Fa=ea(ea(Aa*Ba)+ea(ea(ua*ia)-ea(ga*ea(ea(Ea*Ca)-ea(Ga*ka)))));za=ea(ea(ea(Ga*ia)-ea(ga*ea(ea(ua*ka)-ea(Ea*Aa))))+ea(Ca*Ba));Ba=ea(-Aa);Aa=ea(-Ca);g[E>>2]=ea(-ka);g[E+4>>2]=Ba;g[E+8>>2]=Aa;g[E+12>>2]=ga;g[E+16>>2]=Da;g[E+20>>2]=Fa;g[E+24>>2]=za;mEb(D,B,E);g[C>>2]=ea(g[D>>2]);g[C+4>>2]=ea(g[D+4>>2]);g[C+8>>2]=ea(g[D+8>>2]);g[C+12>>2]=ea(g[D+12>>2]);g[C+16>>2]=ea(g[D+16>>2]);g[C+20>>2]=ea(g[D+20>>2]);g[C+24>>2]=ea(g[D+24>>2]);g[C+28>>2]=ea(g[D+28>>2]);g[C+32>>2]=ea(g[D+32>>2]);g[C+36>>2]=ea(g[D+36>>2]);g[C+40>>2]=ea(g[D+40>>2]);g[C+44>>2]=ea(g[D+44>>2]);za=ea(g[D+48>>2]);g[C+48>>2]=za;Fa=ea(g[D+52>>2]);g[C+52>>2]=Fa;Da=ea(g[D+56>>2]);g[C+56>>2]=Da;Ja=za;Ka=Fa;La=Da}else{AOa(C,B,la,ca);Da=ea(g[C+48>>2]);Fa=ea(g[C+52>>2]);Ja=Da;Ka=Fa;La=ea(g[C+56>>2])}g[C+48>>2]=ea(Ja+l);g[C+52>>2]=ea(Ka+l);g[C+56>>2]=ea(La+l);ca=aa+76|0;aa=c[ca>>2]|0;c[F>>2]=c[aa+16>>2];c[F+4>>2]=aa+32;g[F+8>>2]=ea(g[aa+20>>2]);aLa(G);aa=i;i=i+256|0;fLa(G,64,aa,1);c[H+4>>2]=2;c[H>>2]=500264;c[H+8>>2]=G;vQa(C,1,F,H,1);H=G+4|0;F=c[H>>2]|0;if(!F){Ma=ea(3402823469999999843913219.0e14);dLa(G);i=q;return ea(Ma)}C=c[G+8>>2]|0;aa=c[(c[b>>2]|0)+36>>2]|0;g[I>>2]=ea(g[wa>>2]);g[I+4>>2]=ea(g[va>>2]);g[I+8>>2]=ea(g[xa>>2]);g[I+12>>2]=ea(g[ya>>2]);ya=I+16|0;g[ya>>2]=ea(g[fa>>2]);xa=I+20|0;g[xa>>2]=ea(g[ha>>2]);va=I+24|0;g[va>>2]=ea(g[ja>>2]);g[J>>2]=ea(g[k>>2]);wa=k+4|0;la=J+4|0;g[la>>2]=ea(g[wa>>2]);B=k+8|0;D=J+8|0;g[D>>2]=ea(g[B>>2]);E=k+12|0;sa=J+12|0;g[sa>>2]=ea(g[E>>2]);pa=k+16|0;ma=J+16|0;g[ma>>2]=ea(g[pa>>2]);z=k+20|0;A=J+20|0;g[A>>2]=ea(g[z>>2]);Na=k+24|0;Oa=J+24|0;g[Oa>>2]=ea(g[Na>>2]);Pa=(h|0)!=0;if(Pa?!(ea(g[(c[h+64>>2]|0)+124>>2])==ea(0.0)):0){g[J>>2]=ea(g[d+12>>2]);g[la>>2]=ea(g[d+16>>2]);g[D>>2]=ea(g[d+20>>2]);g[sa>>2]=ea(g[d+24>>2]);g[ma>>2]=ea(g[na>>2]);g[A>>2]=ea(g[qa>>2]);g[Oa>>2]=ea(g[ta>>2])}g[K>>2]=ea(g[Ia>>2]);g[K+4>>2]=ea(g[b+84>>2]);g[K+8>>2]=ea(g[b+88>>2]);La=ea(ea(g[Ha>>2])+l);Ka=ea(ea(g[b+72>>2])+l);Ja=ea(ea(g[b+76>>2])+l);g[L>>2]=La;g[L+4>>2]=Ka;g[L+8>>2]=Ja;aLa(M);Ha=i;i=i+256|0;fLa(M,64,Ha,1);Ha=c[H>>2]|0;Ia=M+4|0;ta=c[Ia>>2]|0;if((ta+Ha|0)>>>0>(c[M>>2]|0)>>>0){gLa(M,Ha)|0;Qa=c[Ia>>2]|0}else Qa=ta;c[Ia>>2]=Qa+Ha;aLa(N);Ha=i;i=i+256|0;fLa(N,64,Ha,1);Ha=c[H>>2]|0;H=N+4|0;Qa=c[H>>2]|0;if((Qa+Ha|0)>>>0>(c[N>>2]|0)>>>0){gLa(N,Ha)|0;Ra=c[H>>2]|0}else Ra=Qa;c[H>>2]=Ra+Ha;Ha=c[M+8>>2]|0;Ra=c[N+8>>2]|0;H=(f|0)!=0;if(H)Sa=ea(g[b+8>>2]);else Sa=ea(0.0);if(Pa)Ta=ea(g[d+8>>2]);else Ta=ea(0.0);if(H)Ua=ea(g[(c[f+60>>2]|0)+4>>2]);else Ua=ea(1.0);if(Pa)Va=ea(g[(c[h+60>>2]|0)+4>>2]);else Va=ea(1.0);Ja=ea((Sa>Ta?Sa:Ta)*(Ua<Va?Ua:Va));h=r+4|0;Pa=r+8|0;f=r+12|0;H=r+16|0;Qa=r+40|0;Ia=r+44|0;ta=r+48|0;Oa=r+52|0;qa=r+56|0;A=r+60|0;na=r+64|0;ma=P+4|0;sa=P+8|0;D=Q+4|0;la=Q+8|0;Wa=R+4|0;Xa=R+8|0;Ya=0;Za=0;while(1){_a=C+(Ya<<2)|0;c[r>>2]=ba;c[h>>2]=w;c[Pa>>2]=_a;c[f>>2]=1;c[H>>2]=O;g[Qa>>2]=ea(8507058669999999534545717.0e13);g[Ia>>2]=ea(8507058669999999534545717.0e13);g[ta>>2]=ea(8507058669999999534545717.0e13);g[Oa>>2]=ea(-8507058669999999534545717.0e13);g[qa>>2]=ea(-8507058669999999534545717.0e13);g[A>>2]=ea(-8507058669999999534545717.0e13);c[na+0>>2]=0;c[na+4>>2]=0;c[na+8>>2]=0;a[na+12>>0]=0;hza(P,r,0);Va=ea(ea(g[P>>2])*ea(2.0));Ua=ea(ea(g[ma>>2])*ea(2.0));Ta=ea(ea(g[sa>>2])*ea(2.0));Sa=ea(g[E>>2]);Ka=ea(ea(Sa*Sa)+ea(-.5));La=ea(g[k>>2]);Fa=ea(Va*La);Da=ea(g[wa>>2]);za=ea(Fa+ea(Ua*Da));Fa=ea(g[B>>2]);ga=ea(za+ea(Ta*Fa));if(ea(ea(ea(-ea(oa*ea(ea(Da*ga)+ea(ea(Ua*Ka)+ea(Sa*ea(ea(Va*Fa)-ea(Ta*La)))))))-ea(da*ea(ea(La*ga)+ea(ea(Va*Ka)+ea(Sa*ea(ea(Ta*Da)-ea(Ua*Fa)))))))-ea(ra*ea(ea(ea(Ta*Ka)+ea(Sa*ea(ea(Ua*La)-ea(Va*Da))))+ea(Fa*ga))))>=Ja?(gza(r,J),ga=ea(g[Qa>>2]),Fa=ea(g[Ia>>2]),Da=ea(g[ta>>2]),Va=ea(g[Oa>>2]),La=ea(g[qa>>2]),Ua=ea(g[A>>2]),Sa=ea(ea(Fa+La)*ea(.5)),Ka=ea(ea(Da+Ua)*ea(.5)),g[Q>>2]=ea(ea(ga+Va)*ea(.5)),g[D>>2]=Sa,g[la>>2]=Ka,Ka=ea(ea(ea(La-Fa)*ea(.5))+ea(.0199999996)),Fa=ea(ea(ea(Ua-Da)*ea(.5))+ea(.0199999996)),g[R>>2]=ea(ea(ea(Va-ga)*ea(.5))+ea(.0199999996)),g[Wa>>2]=Ka,g[Xa>>2]=Fa,Fa=ea(Yra(K,L,Q,R,x,y)),Fa<=ea(1.0)):0){a:do if(!Za)$a=0;else{ab=Za;while(1){bb=ab;ab=ab+-1|0;Ka=ea(g[Ra+(ab<<2)>>2]);if(Ka<=Fa){$a=bb;break a}g[Ra+(bb<<2)>>2]=Ka;c[Ha+(bb<<2)>>2]=c[Ha+(ab<<2)>>2];if(!ab){$a=0;break}}}while(0);c[Ha+($a<<2)>>2]=c[_a>>2];g[Ra+($a<<2)>>2]=Fa;cb=Za+1|0}else cb=Za;Ya=Ya+1|0;if((Ya|0)==(F|0))break;else Za=cb}Za=p+8756|0;c[Za>>2]=-1;Ja=ea(g[fa>>2]);ra=ea(g[ha>>2]);da=ea(g[ja>>2]);oa=ea(g[b+8>>2]);Ka=ea(oa*oa);ga=ea(g[pa>>2]);Va=ea(Ja-ga);Ja=ea(g[z>>2]);Da=ea(ra-Ja);ra=ea(g[Na>>2]);Ua=ea(Va*ea(2.0));Va=ea(Da*ea(2.0));Da=ea(ea(da-ra)*ea(2.0));da=ea(g[E>>2]);La=ea(ea(da*da)+ea(-.5));Sa=ea(g[k>>2]);Ta=ea(Ua*Sa);za=ea(g[wa>>2]);Aa=ea(Ta+ea(Va*za));Ta=ea(g[B>>2]);Ba=ea(Aa+ea(Da*Ta));Aa=ea(ea(za*Ba)+ea(ea(Va*La)-ea(da*ea(ea(Ua*Ta)-ea(Da*Sa)))));ka=ea(ea(ea(Da*La)-ea(da*ea(ea(Va*Sa)-ea(Ua*za))))+ea(Ta*Ba));g[S>>2]=ea(ea(Sa*Ba)+ea(ea(Ua*La)-ea(da*ea(ea(Da*za)-ea(Va*Ta)))));Na=S+4|0;g[Na>>2]=Aa;z=S+8|0;g[z>>2]=ka;ka=ea(ea(g[ya>>2])-ga);ga=ea(ea(g[xa>>2])-Ja);Ja=ea(ka*ea(2.0));ka=ea(ga*ea(2.0));ga=ea(ea(ea(g[va>>2])-ra)*ea(2.0));ra=ea(ea(ea(Ja*Sa)+ea(ka*za))+ea(ga*Ta));Aa=ea(ea(Sa*ra)+ea(ea(Ja*La)-ea(da*ea(ea(ga*za)-ea(ka*Ta)))));Va=ea(ea(za*ra)+ea(ea(ka*La)-ea(da*ea(ea(Ja*Ta)-ea(ga*Sa)))));Da=ea(ea(ea(ga*La)-ea(da*ea(ea(ka*Sa)-ea(Ja*za))))+ea(Ta*ra));if(!cb){db=ea(0.0);eb=ea(0.0);fb=ea(0.0);gb=ea(0.0);hb=ea(0.0);ib=ea(0.0);jb=da;kb=Sa;lb=za;mb=Ta;nb=ea(3402823469999999843913219.0e14)}else{va=V+4|0;xa=V+8|0;ya=V+12|0;pa=V+16|0;ja=V+40|0;ha=V+44|0;fa=V+48|0;F=V+52|0;Ya=V+56|0;$a=V+60|0;Ra=V+64|0;y=w+4|0;x=w+8|0;R=w+12|0;Q=w+16|0;L=w+20|0;K=w+24|0;Xa=w+28|0;Wa=w+32|0;la=Y+4|0;D=Y+8|0;A=Z+64|0;qa=Z+80|0;Oa=Z+16|0;ta=Z+20|0;Ia=Z+32|0;Qa=Z+36|0;sa=Z+48|0;ma=Z+52|0;P=Z+4|0;na=Z+8|0;O=Z+12|0;H=Z+96|0;f=Z+100|0;Pa=Z+104|0;h=Z+108|0;C=Z+112|0;ab=Z+116|0;bb=Z+120|0;ob=Z+124|0;pb=Z+128|0;qb=Z+132|0;rb=Z+136|0;sb=Z+140|0;tb=c[500224+(aa<<2)>>2]|0;aa=_+4|0;ub=_+8|0;vb=_+12|0;wb=_+16|0;xb=_+20|0;yb=_+24|0;zb=_+28|0;Ab=_+32|0;Bb=_+36|0;Cb=_+40|0;Db=_+44|0;Eb=_+48|0;Fb=_+52|0;Gb=_+56|0;Hb=_+60|0;Ib=_+64|0;Jb=_+68|0;Kb=$+4|0;Lb=$+8|0;Mb=X+4|0;Nb=X+8|0;Ob=r+4|0;Pb=r+8|0;Qb=s+4|0;Rb=s+8|0;Sb=v+4|0;Tb=v+8|0;Ta=ea(oa*ea(2.0));za=ea(0.0);Sa=ea(0.0);da=ea(0.0);ra=ea(0.0);Ja=ea(0.0);ka=ea(0.0);La=ea(3402823469999999843913219.0e14);Ub=0;while(1){Vb=Ha+(Ub<<2)|0;c[V>>2]=ba;c[va>>2]=w;c[xa>>2]=Vb;c[ya>>2]=1;c[pa>>2]=U;g[ja>>2]=ea(8507058669999999534545717.0e13);g[ha>>2]=ea(8507058669999999534545717.0e13);g[fa>>2]=ea(8507058669999999534545717.0e13);g[F>>2]=ea(-8507058669999999534545717.0e13);g[Ya>>2]=ea(-8507058669999999534545717.0e13);g[$a>>2]=ea(-8507058669999999534545717.0e13);c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;a[Ra+12>>0]=0;Wb=c[ca>>2]|0;Xb=c[Vb>>2]|0;Yb=c[Wb+12>>2]|0;if(!(a[Wb+156>>0]&2)){Zb=c[Wb+8>>2]|0;_b=Zb+((c[Yb+(Xb*12|0)>>2]|0)*12|0)|0;$b=Zb+((c[Yb+(Xb*12|0)+4>>2]|0)*12|0)|0;ac=Zb+((c[Yb+(Xb*12|0)+8>>2]|0)*12|0)|0}else{Zb=c[Wb+8>>2]|0;_b=Zb+((e[Yb+(Xb*6|0)>>1]|0)*12|0)|0;$b=Zb+((e[Yb+(Xb*6|0)+2>>1]|0)*12|0)|0;ac=Zb+((e[Yb+(Xb*6|0)+4>>1]|0)*12|0)|0}ga=ea(g[_b>>2]);Ua=ea(g[w>>2]);Ba=ea(ga*Ua);Ca=ea(g[y>>2]);Ea=ea(ga*Ca);ua=ea(g[x>>2]);ia=ea(ga*ua);ga=ea(g[_b+4>>2]);Ga=ea(g[R>>2]);bc=ea(ga*Ga);cc=ea(g[Q>>2]);dc=ea(ga*cc);ec=ea(g[L>>2]);fc=ea(Ba+bc);bc=ea(Ea+dc);dc=ea(ia+ea(ga*ec));ga=ea(g[_b+8>>2]);ia=ea(g[K>>2]);Ea=ea(ga*ia);Ba=ea(g[Xa>>2]);gc=ea(ga*Ba);hc=ea(g[Wa>>2]);ic=ea(fc+Ea);Ea=ea(bc+gc);gc=ea(dc+ea(ga*hc));g[Y>>2]=ic;g[la>>2]=Ea;g[D>>2]=gc;ga=ea(g[$b>>2]);dc=ea(ga*Ua);bc=ea(ga*Ca);fc=ea(ga*ua);ga=ea(g[$b+4>>2]);jc=ea(dc+ea(ga*Ga));dc=ea(bc+ea(ga*cc));bc=ea(fc+ea(ga*ec));ga=ea(g[$b+8>>2]);fc=ea(jc+ea(ga*ia));jc=ea(dc+ea(ga*Ba));dc=ea(bc+ea(ga*hc));ga=ea(g[ac>>2]);bc=ea(Ua*ga);Ua=ea(Ca*ga);Ca=ea(ua*ga);ga=ea(g[ac+4>>2]);ua=ea(bc+ea(Ga*ga));Ga=ea(Ua+ea(cc*ga));cc=ea(Ca+ea(ec*ga));ga=ea(g[ac+8>>2]);ec=ea(ua+ea(ia*ga));ia=ea(Ga+ea(Ba*ga));Ba=ea(cc+ea(hc*ga));c[qa>>2]=7;g[sa>>2]=ea(0.0);c[ma+0>>2]=c[r+0>>2];c[ma+4>>2]=c[r+4>>2];c[ma+8>>2]=c[r+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[A+0>>2]=c[s+0>>2];c[A+4>>2]=c[s+4>>2];c[A+8>>2]=c[s+8>>2];c[A+12>>2]=c[s+12>>2];ga=ea(ea(ia+ea(jc+Ea))*ea(.333332986));hc=ea(ea(Ba+ea(dc+gc))*ea(.333332986));g[Z>>2]=ea(ea(ec+ea(fc+ic))*ea(.333332986));g[P>>2]=ga;g[na>>2]=hc;g[O>>2]=ea(0.0);g[H>>2]=ic;g[f>>2]=Ea;g[Pa>>2]=gc;g[h>>2]=ea(0.0);g[C>>2]=fc;g[ab>>2]=jc;g[bb>>2]=dc;g[ob>>2]=ea(0.0);g[pb>>2]=ec;g[qb>>2]=ia;g[rb>>2]=Ba;g[sb>>2]=ea(0.0);g[Oa>>2]=ea(0.0);c[ta+0>>2]=c[t+0>>2];c[ta+4>>2]=c[t+4>>2];c[ta+8>>2]=c[t+8>>2];g[Ia>>2]=ea(3402823469999999843913219.0e14);c[Qa+0>>2]=c[u+0>>2];c[Qa+4>>2]=c[u+4>>2];c[Qa+8>>2]=c[u+8>>2];g[_>>2]=ea(1.0);g[aa>>2]=ea(0.0);g[ub>>2]=ea(0.0);g[vb>>2]=ea(0.0);g[wb>>2]=ea(1.0);g[xb>>2]=ea(0.0);g[yb>>2]=ea(0.0);g[zb>>2]=ea(0.0);g[Ab>>2]=ea(1.0);g[Bb>>2]=ea(1.0);g[Cb>>2]=ea(0.0);g[Db>>2]=ea(0.0);g[Eb>>2]=ea(0.0);g[Fb>>2]=ea(1.0);g[Gb>>2]=ea(0.0);g[Hb>>2]=ea(0.0);g[Ib>>2]=ea(0.0);g[Jb>>2]=ea(1.0);gc=ea(Om[tb&7](b,d,j,k,I,J,l,W,X,o,p,_,Z,ea(0.0)));if(gc<=ea(0.0)){Ea=ea(g[Y>>2]);ic=ea(fc-Ea);fc=ea(g[la>>2]);hc=ea(jc-fc);jc=ea(g[D>>2]);ga=ea(dc-jc);dc=ea(ec-Ea);ec=ea(ia-fc);ia=ea(Ba-jc);Ba=ea(ea(hc*ia)-ea(ec*ga));cc=ea(ea(dc*ga)-ea(ic*ia));Ga=ea(ea(ic*ec)-ea(dc*hc));ua=ea(hc+fc);hc=ea(ga+jc);g[r>>2]=ea(ic+Ea);g[Ob>>2]=ua;g[Pb>>2]=hc;hc=ea(ec+fc);fc=ea(ia+jc);g[s>>2]=ea(dc+Ea);g[Qb>>2]=hc;g[Rb>>2]=fc;JOa(v,S,Y,r,s,t,u);fc=ea(g[v>>2]);hc=ea(fc-ea(g[S>>2]));fc=ea(g[Sb>>2]);Ea=ea(fc-ea(g[Na>>2]));fc=ea(g[Tb>>2]);dc=ea(fc-ea(g[z>>2]));fc=ea(ea(ea(hc*hc)+ea(Ea*Ea))+ea(dc*dc));if(fc<Ka){dc=ea(T(ea(fc)));fc=ea(dc-oa);Ea=ea(Ba*ea(g[Y>>2]));hc=ea(Ea+ea(cc*ea(g[la>>2])));if(ea(ea(ea(Da*Ga)+ea(ea(Aa*Ba)+ea(Va*cc)))-ea(hc+ea(Ga*ea(g[D>>2]))))>ea(0.0))kc=ea(-ea(Ta-dc));else kc=fc}else kc=ea(0.0)}else kc=gc;if(kc<La){hza($,V,0);gc=ea(g[$>>2]);fc=ea(g[Kb>>2]);dc=ea(g[Lb>>2]);Ga=ea(g[X>>2]);hc=ea(g[Mb>>2]);cc=ea(g[Nb>>2]);c[Za>>2]=c[Vb>>2];lc=dc;mc=fc;nc=gc;oc=cc;pc=hc;qc=Ga;rc=kc}else{lc=ka;mc=Ja;nc=ra;oc=da;pc=Sa;qc=za;rc=La}Ub=Ub+1|0;if((Ub|0)==(cb|0))break;else{za=qc;Sa=pc;da=oc;ra=nc;Ja=mc;ka=lc;La=rc}}La=ea(g[E>>2]);ka=ea(g[k>>2]);Ja=ea(g[wa>>2]);db=lc;eb=mc;fb=nc;gb=oc;hb=pc;ib=qc;jb=La;kb=ka;lb=Ja;mb=ea(g[B>>2]);nb=rc}rc=ea(fb*ea(2.0));fb=ea(eb*ea(2.0));eb=ea(db*ea(2.0));db=ea(ea(jb*jb)+ea(-.5));Ja=ea(ea(ea(rc*kb)+ea(fb*lb))+ea(eb*mb));ka=ea(ea(lb*Ja)+ea(ea(fb*db)+ea(jb*ea(ea(rc*mb)-ea(eb*kb)))));La=ea(ea(ea(eb*db)+ea(jb*ea(ea(fb*kb)-ea(rc*lb))))+ea(mb*Ja));g[m>>2]=ea(ea(kb*Ja)+ea(ea(rc*db)+ea(jb*ea(ea(eb*lb)-ea(fb*mb)))));g[m+4>>2]=ka;g[m+8>>2]=La;g[n>>2]=ib;g[n+4>>2]=hb;g[n+8>>2]=gb;dLa(N);dLa(M);Ma=nb;dLa(G);i=q;return ea(Ma)}function N1a(a,b,d,e,f,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=0,R=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=Im,ia=0,ja=0,ka=0,la=0,ma=0,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=0,Ta=0,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im;o=i;i=i+880|0;p=o+744|0;q=o+208|0;r=o+656|0;s=o+360|0;t=o+240|0;u=o+264|0;v=o+224|0;w=o+736|0;x=o+348|0;y=o+284|0;z=o+296|0;A=o+320|0;B=o+720|0;C=o+864|0;D=o+780|0;E=o+372|0;F=o+384|0;G=o+176|0;H=o;I=o+252|0;J=o+668|0;K=o+336|0;L=o+704|0;M=o+32|0;N=o+792|0;O=c[b>>2]|0;c[u+12>>2]=c[O+40>>2];c[u+16>>2]=O+36;g[u+4>>2]=ea(ea(1.0)/ea(g[O+44>>2]));g[u>>2]=ea(ea(1.0)/ea(g[O+48>>2]));g[u+8>>2]=ea(ea(1.0)/ea(g[O+52>>2]));aLa(v);fLa(v,64,o+400|0,1);c[w>>2]=500288;c[w+4>>2]=v;O=v+4|0;if(c[O>>2]|0)c[O>>2]=0;P=ea(g[a+56>>2]);Q=a+28|0;R=ea(P-ea(g[Q>>2]));P=ea(g[a+60>>2]);U=a+32|0;V=ea(P-ea(g[U>>2]));P=ea(g[a+64>>2]);W=a+36|0;X=ea(P-ea(g[W>>2]));g[x>>2]=R;g[x+4>>2]=V;g[x+8>>2]=X;Y=b+12|0;P=ea(g[b+56>>2]);Z=b+28|0;_=ea(P-ea(g[Z>>2]));P=ea(g[b+60>>2]);$=b+32|0;aa=ea(P-ea(g[$>>2]));P=ea(g[b+64>>2]);ba=b+36|0;ca=ea(P-ea(g[ba>>2]));g[y>>2]=_;g[y+4>>2]=aa;g[y+8>>2]=ca;P=ea(R-_);_=ea(V-aa);aa=ea(X-ca);ca=ea(P*ea(.5));X=ea(_*ea(.5));V=ea(aa*ea(.5));R=ea(S(ea(ca)));da=ea(S(ea(X)));fa=ea(S(ea(V)));ga=a+68|0;ha=ea(R+ea(g[ga>>2]));ia=a+72|0;R=ea(da+ea(g[ia>>2]));ja=a+76|0;da=ea(ha+j);ha=ea(R+j);R=ea(ea(fa+ea(g[ja>>2]))+j);ka=a+80|0;fa=ea(ca+ea(g[ka>>2]));la=a+84|0;ca=ea(X+ea(g[la>>2]));ma=a+88|0;X=ea(V+ea(g[ma>>2]));V=ea(ca-ha);na=ea(X-R);oa=ea(da+fa);pa=ea(ha+ca);ca=ea(R+X);g[z>>2]=ea(fa-da);g[z+4>>2]=V;g[z+8>>2]=na;g[z+12>>2]=oa;g[z+16>>2]=pa;g[z+20>>2]=ca;KRa(u,h,z,1,w)|0;aLa(A);w=i;i=i+256|0;fLa(A,64,w,1);w=c[O>>2]|0;z=A+4|0;qa=c[z>>2]|0;if((qa+w|0)>>>0>(c[A>>2]|0)>>>0){gLa(A,w)|0;ra=c[z>>2]|0}else ra=qa;c[z>>2]=ra+w;aLa(B);w=i;i=i+256|0;fLa(B,64,w,1);w=c[O>>2]|0;ra=B+4|0;z=c[ra>>2]|0;if((z+w|0)>>>0>(c[B>>2]|0)>>>0){gLa(B,w)|0;sa=c[ra>>2]|0}else sa=z;c[ra>>2]=sa+w;w=c[A+8>>2]|0;sa=c[B+8>>2]|0;g[C>>2]=ea(g[ka>>2]);g[C+4>>2]=ea(g[la>>2]);g[C+8>>2]=ea(g[ma>>2]);ca=ea(ea(g[ga>>2])+j);pa=ea(ea(g[ia>>2])+j);oa=ea(ea(g[ja>>2])+j);ja=(d|0)!=0;if(ja)ta=ea(g[a+8>>2]);else ta=ea(0.0);ia=(e|0)!=0;if(ia)ua=ea(g[b+8>>2]);else ua=ea(0.0);if(ja)va=ea(g[(c[d+60>>2]|0)+4>>2]);else va=ea(1.0);if(ia)wa=ea(g[(c[e+60>>2]|0)+4>>2]);else wa=ea(1.0);na=ea((ta>ua?ta:ua)*(va<wa?va:wa));d=c[O>>2]|0;O=c[v+8>>2]|0;if(!d)xa=0;else{ja=p+12|0;ga=p+16|0;ma=p+4|0;la=p+20|0;ka=p+8|0;ra=p+24|0;z=p+28|0;qa=p+32|0;wa=ea(ca*ea(1.10000002));ca=ea(pa*ea(1.10000002));pa=ea(oa*ea(1.10000002));ya=D+4|0;za=D+8|0;Aa=E+4|0;Ba=E+8|0;Ca=F+4|0;Da=F+8|0;Ea=0;Fa=0;while(1){Ga=O+(Ea<<2)|0;LRa(u,Y,p,0,0,c[Ga>>2]|0,1,1)|0;oa=ea(g[ja>>2]);va=ea(g[p>>2]);ua=ea(oa-va);ta=ea(g[ga>>2]);V=ea(g[ma>>2]);da=ea(ta-V);fa=ea(g[la>>2]);X=ea(g[ka>>2]);R=ea(fa-X);ha=ea(g[ra>>2]);Ha=ea(ha-va);Ia=ea(g[z>>2]);Ja=ea(Ia-V);Ka=ea(g[qa>>2]);La=ea(Ka-X);Ma=ea(ea(da*La)-ea(R*Ja));Na=ea(ea(R*Ha)-ea(ua*La));La=ea(ea(ua*Ja)-ea(da*Ha));Ha=ea(-Ma);da=ea(-Na);Ja=ea(-La);ua=ea(T(ea(ea(La*La)+ea(ea(Ma*Ma)+ea(Na*Na)))));if(ua>ea(0.0)){Na=ea(ea(1.0)/ua);Oa=ea(Na*Ha);Pa=ea(Na*da);Qa=ea(Na*Ja)}else{Oa=Ha;Pa=da;Qa=Ja}if(ea(ea(aa*Qa)+ea(ea(_*Pa)+ea(P*Oa)))>=na?(Ra=va>ea(8507058669999999534545717.0e13),Ja=Ra?ea(8507058669999999534545717.0e13):va,Ra=V>ea(8507058669999999534545717.0e13),da=Ra?ea(8507058669999999534545717.0e13):V,Ra=X>ea(8507058669999999534545717.0e13),Ha=Ra?ea(8507058669999999534545717.0e13):X,Ra=va<ea(-8507058669999999534545717.0e13),Na=Ra?ea(-8507058669999999534545717.0e13):va,Ra=V<ea(-8507058669999999534545717.0e13),va=Ra?ea(-8507058669999999534545717.0e13):V,Ra=X<ea(-8507058669999999534545717.0e13),V=Ra?ea(-8507058669999999534545717.0e13):X,X=Ja<oa?Ja:oa,Ja=da<ta?da:ta,da=Ha<fa?Ha:fa,Ha=Na>oa?Na:oa,oa=va>ta?va:ta,ta=V>fa?V:fa,fa=X<ha?X:ha,X=Ja<Ia?Ja:Ia,Ja=da<Ka?da:Ka,da=Ha>ha?Ha:ha,ha=oa>Ia?oa:Ia,Ia=ta>Ka?ta:Ka,g[D>>2]=wa,g[ya>>2]=ca,g[za>>2]=pa,Ka=ea(ea(X+ha)*ea(.5)),ta=ea(ea(Ja+Ia)*ea(.5)),g[E>>2]=ea(ea(fa+da)*ea(.5)),g[Aa>>2]=Ka,g[Ba>>2]=ta,ta=ea(ea(ea(ea(ha-X)*ea(.5))+ea(.00999999977))*ea(1.10000002)),X=ea(ea(ea(ea(Ia-Ja)*ea(.5))+ea(.00999999977))*ea(1.10000002)),g[F>>2]=ea(ea(ea(ea(da-fa)*ea(.5))+ea(.00999999977))*ea(1.10000002)),g[Ca>>2]=ta,g[Da>>2]=X,X=ea(Yra(C,D,E,F,x,y)),X<=ea(1.0)):0){a:do if(!Fa)Sa=0;else{Ra=Fa;while(1){Ta=Ra;Ra=Ra+-1|0;ta=ea(g[sa+(Ra<<2)>>2]);if(ta<=X){Sa=Ta;break a}g[sa+(Ta<<2)>>2]=ta;c[w+(Ta<<2)>>2]=c[w+(Ra<<2)>>2];if(!Ra){Sa=0;break}}}while(0);c[w+(Sa<<2)>>2]=c[Ga>>2];g[sa+(Sa<<2)>>2]=X;Ua=Fa+1|0}else Ua=Fa;Ea=Ea+1|0;if((Ea|0)==(d|0)){xa=Ua;break}else Fa=Ua}}g[k>>2]=ea(0.0);Ua=k+4|0;g[Ua>>2]=ea(0.0);Fa=k+8|0;g[Fa>>2]=ea(0.0);g[l>>2]=ea(0.0);d=l+4|0;g[d>>2]=ea(0.0);Ea=l+8|0;g[Ea>>2]=ea(0.0);Sa=n+8756|0;c[Sa>>2]=-1;pa=ea(g[Q>>2]);ca=ea(g[U>>2]);wa=ea(g[W>>2]);na=ea(g[a+8>>2]);Oa=ea(na*na);W=c[(c[a>>2]|0)+36>>2]|0;g[G>>2]=ea(g[a+12>>2]);g[G+4>>2]=ea(g[a+16>>2]);g[G+8>>2]=ea(g[a+20>>2]);g[G+12>>2]=ea(g[a+24>>2]);g[G+16>>2]=pa;g[G+20>>2]=ca;g[G+24>>2]=wa;P=ea(g[h>>2]);g[H>>2]=P;U=h+4|0;Pa=ea(g[U>>2]);Q=H+4|0;g[Q>>2]=Pa;sa=h+8|0;_=ea(g[sa>>2]);y=H+8|0;g[y>>2]=_;x=h+12|0;Qa=ea(g[x>>2]);F=H+12|0;g[F>>2]=Qa;aa=ea(g[h+16>>2]);E=H+16|0;g[E>>2]=aa;ta=ea(g[h+20>>2]);D=H+20|0;g[D>>2]=ta;fa=ea(g[h+24>>2]);C=H+24|0;g[C>>2]=fa;if(ia?!(ea(g[(c[e+64>>2]|0)+124>>2])==ea(0.0)):0){g[H>>2]=ea(g[Y>>2]);g[Q>>2]=ea(g[b+16>>2]);g[y>>2]=ea(g[b+20>>2]);g[F>>2]=ea(g[b+24>>2]);g[E>>2]=ea(g[Z>>2]);g[D>>2]=ea(g[$>>2]);g[C>>2]=ea(g[ba>>2])}da=ea(ea(pa-aa)*ea(2.0));aa=ea(ea(ca-ta)*ea(2.0));ta=ea(ea(wa-fa)*ea(2.0));fa=ea(ea(Qa*Qa)+ea(-.5));wa=ea(ea(ea(da*P)+ea(aa*Pa))+ea(ta*_));ca=ea(ea(P*wa)+ea(ea(da*fa)-ea(Qa*ea(ea(ta*Pa)-ea(aa*_)))));pa=ea(ea(Pa*wa)+ea(ea(aa*fa)-ea(Qa*ea(ea(da*_)-ea(ta*P)))));Ja=ea(ea(ea(ta*fa)-ea(Qa*ea(ea(aa*P)-ea(da*Pa))))+ea(_*wa));g[I>>2]=ca;ba=I+4|0;g[ba>>2]=pa;C=I+8|0;g[C>>2]=Ja;if(!xa){Va=ea(0.0);Wa=ea(0.0);Xa=ea(0.0);Ya=ea(0.0);Za=ea(0.0);_a=ea(0.0);$a=Qa;ab=P;bb=Pa;cb=_;db=ea(3402823469999999843913219.0e14);eb=ea(Xa*ea(2.0));fb=ea(Wa*ea(2.0));gb=ea(Va*ea(2.0));hb=ea($a*$a);ib=ea(hb+ea(-.5));jb=ea(eb*ab);kb=ea(fb*bb);lb=ea(jb+kb);mb=ea(gb*cb);nb=ea(lb+mb);ob=ea(eb*ib);pb=ea(gb*bb);qb=ea(fb*cb);rb=ea(pb-qb);sb=ea($a*rb);tb=ea(ob+sb);ub=ea(ab*nb);vb=ea(ub+tb);wb=ea(fb*ib);xb=ea(eb*cb);yb=ea(gb*ab);zb=ea(xb-yb);Ab=ea($a*zb);Bb=ea(wb+Ab);Cb=ea(bb*nb);Db=ea(Cb+Bb);Eb=ea(gb*ib);Fb=ea(fb*ab);Gb=ea(eb*bb);Hb=ea(Fb-Gb);Ib=ea($a*Hb);Jb=ea(Eb+Ib);Kb=ea(cb*nb);Lb=ea(Jb+Kb);g[k>>2]=vb;g[Ua>>2]=Db;g[Fa>>2]=Lb;g[l>>2]=_a;g[d>>2]=Za;g[Ea>>2]=Ya;dLa(B);dLa(A);dLa(v);i=o;return ea(db)}$=J+4|0;D=J+8|0;Z=J+12|0;E=J+16|0;F=J+20|0;y=J+24|0;Q=J+28|0;e=J+32|0;ia=M+64|0;Da=M+80|0;Ca=M+16|0;Ba=M+20|0;Aa=M+32|0;za=M+36|0;ya=M+48|0;qa=M+52|0;z=M+4|0;ra=M+8|0;ka=M+12|0;la=M+96|0;ma=M+100|0;ga=M+104|0;ja=M+108|0;O=M+112|0;Ra=M+116|0;Ta=M+120|0;Mb=M+124|0;Nb=M+128|0;Ob=M+132|0;Pb=M+136|0;Qb=M+140|0;Rb=c[500224+(W<<2)>>2]|0;W=N+4|0;Sb=N+8|0;Tb=N+12|0;Ub=N+16|0;Vb=N+20|0;Wb=N+24|0;Xb=N+28|0;Yb=N+32|0;Zb=N+36|0;_b=N+40|0;$b=N+44|0;ac=N+48|0;bc=N+52|0;cc=N+56|0;dc=N+60|0;ec=N+64|0;fc=N+68|0;gc=L+4|0;hc=L+8|0;ic=p+4|0;jc=p+8|0;kc=q+4|0;lc=q+8|0;mc=t+4|0;nc=t+8|0;_=ea(na*ea(2.0));Pa=ea(0.0);P=ea(0.0);Qa=ea(0.0);wa=ea(0.0);da=ea(0.0);aa=ea(0.0);fa=ea(3402823469999999843913219.0e14);oc=0;while(1){pc=w+(oc<<2)|0;LRa(u,Y,J,0,0,c[pc>>2]|0,0,0)|0;ta=ea(g[J>>2]);Ia=ea(g[$>>2]);ha=ea(g[D>>2]);Ka=ea(g[Z>>2]);oa=ea(g[E>>2]);Ha=ea(g[F>>2]);V=ea(g[y>>2]);va=ea(g[Q>>2]);Na=ea(g[e>>2]);c[Da>>2]=7;g[ya>>2]=ea(0.0);c[qa+0>>2]=c[p+0>>2];c[qa+4>>2]=c[p+4>>2];c[qa+8>>2]=c[p+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[ia+0>>2]=c[q+0>>2];c[ia+4>>2]=c[q+4>>2];c[ia+8>>2]=c[q+8>>2];c[ia+12>>2]=c[q+12>>2];ua=ea(ea(ea(Ia+oa)+va)*ea(.333332986));Ma=ea(ea(ea(ha+Ha)+Na)*ea(.333332986));g[M>>2]=ea(ea(ea(ta+Ka)+V)*ea(.333332986));g[z>>2]=ua;g[ra>>2]=Ma;g[ka>>2]=ea(0.0);g[la>>2]=ta;g[ma>>2]=Ia;g[ga>>2]=ha;g[ja>>2]=ea(0.0);g[O>>2]=Ka;g[Ra>>2]=oa;g[Ta>>2]=Ha;g[Mb>>2]=ea(0.0);g[Nb>>2]=V;g[Ob>>2]=va;g[Pb>>2]=Na;g[Qb>>2]=ea(0.0);g[Ca>>2]=ea(0.0);c[Ba+0>>2]=c[r+0>>2];c[Ba+4>>2]=c[r+4>>2];c[Ba+8>>2]=c[r+8>>2];g[Aa>>2]=ea(3402823469999999843913219.0e14);c[za+0>>2]=c[s+0>>2];c[za+4>>2]=c[s+4>>2];c[za+8>>2]=c[s+8>>2];g[N>>2]=ea(1.0);g[W>>2]=ea(0.0);g[Sb>>2]=ea(0.0);g[Tb>>2]=ea(0.0);g[Ub>>2]=ea(1.0);g[Vb>>2]=ea(0.0);g[Wb>>2]=ea(0.0);g[Xb>>2]=ea(0.0);g[Yb>>2]=ea(1.0);g[Zb>>2]=ea(1.0);g[_b>>2]=ea(0.0);g[$b>>2]=ea(0.0);g[ac>>2]=ea(0.0);g[bc>>2]=ea(1.0);g[cc>>2]=ea(0.0);g[dc>>2]=ea(0.0);g[ec>>2]=ea(0.0);g[fc>>2]=ea(1.0);Na=ea(Om[Rb&7](a,b,f,h,G,H,j,K,L,m,n,N,M,ea(0.0)));if(Na<=ea(0.0)){va=ea(g[Z>>2]);V=ea(g[J>>2]);Ha=ea(va-V);va=ea(g[E>>2]);oa=ea(g[$>>2]);Ka=ea(va-oa);va=ea(g[F>>2]);ha=ea(g[D>>2]);Ia=ea(va-ha);va=ea(ea(g[y>>2])-V);ta=ea(ea(g[Q>>2])-oa);Ma=ea(ea(g[e>>2])-ha);ua=ea(Ka+oa);La=ea(Ia+ha);g[p>>2]=ea(Ha+V);g[ic>>2]=ua;g[jc>>2]=La;La=ea(ta+oa);oa=ea(Ma+ha);g[q>>2]=ea(va+V);g[kc>>2]=La;g[lc>>2]=oa;JOa(t,I,J,p,q,r,s);oa=ea(g[t>>2]);La=ea(oa-ea(g[I>>2]));oa=ea(g[mc>>2]);V=ea(oa-ea(g[ba>>2]));oa=ea(g[nc>>2]);ha=ea(oa-ea(g[C>>2]));oa=ea(ea(ea(La*La)+ea(V*V))+ea(ha*ha));if(oa<Oa){ha=ea(ea(Ka*Ma)-ea(Ia*ta));V=ea(ea(Ia*va)-ea(Ha*Ma));Ma=ea(ea(Ha*ta)-ea(Ka*va));va=ea(T(ea(oa)));oa=ea(va-na);Ka=ea(ha*ea(g[J>>2]));ta=ea(Ka+ea(V*ea(g[$>>2])));if(ea(ea(ea(Ja*Ma)+ea(ea(ca*ha)+ea(pa*V)))-ea(ta+ea(Ma*ea(g[D>>2]))))>ea(0.0))qc=ea(-ea(_-va));else qc=oa}else qc=ea(0.0)}else qc=Na;if(qc<fa){Na=ea(g[Z>>2]);oa=ea(g[J>>2]);va=ea(Na-oa);Na=ea(g[E>>2]);Ma=ea(g[$>>2]);ta=ea(Na-Ma);Na=ea(g[F>>2]);V=ea(g[D>>2]);ha=ea(Na-V);Na=ea(ea(g[y>>2])-oa);oa=ea(ea(g[Q>>2])-Ma);Ma=ea(ea(g[e>>2])-V);V=ea(ea(ta*Ma)-ea(ha*oa));Ka=ea(ea(ha*Na)-ea(va*Ma));Ma=ea(ea(va*oa)-ea(ta*Na));Na=ea(T(ea(ea(Ma*Ma)+ea(ea(V*V)+ea(Ka*Ka)))));if(Na>ea(0.0)){ta=ea(ea(1.0)/Na);rc=ea(Ma*ta);sc=ea(Ka*ta);tc=ea(V*ta)}else{rc=Ma;sc=Ka;tc=V}V=ea(g[L>>2]);Ka=ea(g[gc>>2]);Ma=ea(g[hc>>2]);c[Sa>>2]=c[pc>>2];uc=rc;vc=sc;wc=tc;xc=Ma;yc=Ka;zc=V;Ac=qc}else{uc=aa;vc=da;wc=wa;xc=Qa;yc=P;zc=Pa;Ac=fa}oc=oc+1|0;if((oc|0)==(xa|0))break;else{Pa=zc;P=yc;Qa=xc;wa=wc;da=vc;aa=uc;fa=Ac}}fa=ea(g[x>>2]);aa=ea(g[h>>2]);da=ea(g[U>>2]);Va=uc;Wa=vc;Xa=wc;Ya=xc;Za=yc;_a=zc;$a=fa;ab=aa;bb=da;cb=ea(g[sa>>2]);db=Ac;eb=ea(Xa*ea(2.0));fb=ea(Wa*ea(2.0));gb=ea(Va*ea(2.0));hb=ea($a*$a);ib=ea(hb+ea(-.5));jb=ea(eb*ab);kb=ea(fb*bb);lb=ea(jb+kb);mb=ea(gb*cb);nb=ea(lb+mb);ob=ea(eb*ib);pb=ea(gb*bb);qb=ea(fb*cb);rb=ea(pb-qb);sb=ea($a*rb);tb=ea(ob+sb);ub=ea(ab*nb);vb=ea(ub+tb);wb=ea(fb*ib);xb=ea(eb*cb);yb=ea(gb*ab);zb=ea(xb-yb);Ab=ea($a*zb);Bb=ea(wb+Ab);Cb=ea(bb*nb);Db=ea(Cb+Bb);Eb=ea(gb*ib);Fb=ea(fb*ab);Gb=ea(eb*bb);Hb=ea(Fb-Gb);Ib=ea($a*Hb);Jb=ea(Eb+Ib);Kb=ea(cb*nb);Lb=ea(Jb+Kb);g[k>>2]=vb;g[Ua>>2]=Db;g[Fa>>2]=Lb;g[l>>2]=_a;g[d>>2]=Za;g[Ea>>2]=Ya;dLa(B);dLa(A);dLa(v);i=o;return ea(db)}function O1a(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im;c=ea(g[b+96>>2]);d=ea(g[b+112>>2]);e=ea(g[b+128>>2]);f=ea(g[b+100>>2]);h=ea(g[b+116>>2]);i=ea(g[b+132>>2]);j=ea(g[b+104>>2]);k=ea(g[b+120>>2]);l=ea(g[b+136>>2]);m=ea(ea(c+c)*ea(.5));c=ea(ea(d+f)*ea(.5));f=ea(ea(e+j)*ea(.5));j=ea(ea(h+h)*ea(.5));h=ea(ea(i+k)*ea(.5));k=ea(ea(l+l)*ea(.5));l=ea(g[b>>2]);i=ea(g[b+16>>2]);e=ea(g[b+32>>2]);d=ea(g[b+4>>2]);n=ea(g[b+20>>2]);o=ea(g[b+36>>2]);p=ea(g[b+8>>2]);q=ea(g[b+24>>2]);r=ea(g[b+40>>2]);s=ea(ea(l+l)*ea(.5));l=ea(ea(i+d)*ea(.5));d=ea(ea(e+p)*ea(.5));p=ea(ea(n+n)*ea(.5));n=ea(ea(o+q)*ea(.5));q=ea(ea(r+r)*ea(.5));r=ea(ea(j*k)-ea(h*h));o=ea(ea(f*h)-ea(c*k));e=ea(ea(c*h)-ea(j*f));i=ea(ea(1.0)/ea(ea(f*e)+ea(ea(m*r)+ea(c*o))));t=ea(r*i);r=ea(o*i);o=ea(e*i);e=ea(ea(ea(m*k)-ea(f*f))*i);k=ea(ea(ea(c*f)-ea(m*h))*i);h=ea(ea(ea(m*j)-ea(c*c))*i);i=ea(g[b+48>>2]);c=ea(g[b+52>>2]);j=ea(g[b+56>>2]);m=ea(-i);f=ea(-c);u=ea(-j);v=ea(g[b+64>>2]);w=ea(g[b+68>>2]);x=ea(g[b+72>>2]);y=ea(-v);z=ea(-w);A=ea(-x);B=ea(g[b+80>>2]);C=ea(g[b+84>>2]);D=ea(g[b+88>>2]);E=ea(-B);F=ea(-C);G=ea(-D);H=ea(ea(ea(t*m)+ea(r*y))+ea(o*E));I=ea(ea(ea(t*f)+ea(r*z))+ea(o*F));J=ea(ea(ea(t*u)+ea(r*A))+ea(o*G));K=ea(ea(ea(r*m)+ea(e*y))+ea(k*E));L=ea(ea(ea(r*f)+ea(e*z))+ea(k*F));M=ea(ea(ea(r*u)+ea(e*A))+ea(k*G));N=ea(ea(ea(o*m)+ea(k*y))+ea(h*E));E=ea(ea(ea(o*f)+ea(k*z))+ea(h*F));F=ea(ea(ea(o*u)+ea(k*A))+ea(h*G));G=ea(s+ea(ea(B*N)+ea(ea(i*H)+ea(v*K))));s=ea(l+ea(ea(B*E)+ea(ea(i*I)+ea(v*L))));A=ea(d+ea(ea(B*F)+ea(ea(i*J)+ea(v*M))));v=ea(l+ea(ea(C*N)+ea(ea(c*H)+ea(w*K))));l=ea(p+ea(ea(C*E)+ea(ea(c*I)+ea(w*L))));p=ea(n+ea(ea(C*F)+ea(ea(c*J)+ea(w*M))));w=ea(d+ea(ea(D*N)+ea(ea(j*H)+ea(x*K))));d=ea(n+ea(ea(D*E)+ea(ea(j*I)+ea(x*L))));n=ea(q+ea(ea(D*F)+ea(ea(j*J)+ea(x*M))));x=ea(ea(l*n)-ea(d*p));j=ea(ea(w*p)-ea(v*n));p=ea(ea(v*d)-ea(w*l));D=ea(ea(1.0)/ea(ea(A*p)+ea(ea(G*x)+ea(s*j))));q=ea(D*x);x=ea(D*j);j=ea(D*p);p=ea(D*ea(ea(G*n)-ea(w*A)));A=ea(D*ea(ea(w*s)-ea(G*d)));d=ea(D*ea(ea(G*l)-ea(v*s)));s=ea(ea(J*j)+ea(ea(H*q)+ea(I*x)));v=ea(ea(J*A)+ea(ea(H*x)+ea(I*p)));l=ea(ea(J*d)+ea(ea(H*j)+ea(I*A)));G=ea(ea(M*j)+ea(ea(K*q)+ea(L*x)));D=ea(ea(M*A)+ea(ea(K*x)+ea(L*p)));w=ea(ea(M*d)+ea(ea(K*j)+ea(L*A)));n=ea(ea(F*j)+ea(ea(N*q)+ea(E*x)));c=ea(ea(F*A)+ea(ea(N*x)+ea(E*p)));C=ea(ea(F*d)+ea(ea(N*j)+ea(E*A)));i=ea(t+ea(ea(J*l)+ea(ea(H*s)+ea(I*v))));t=ea(r+ea(ea(M*l)+ea(ea(K*s)+ea(L*v))));B=ea(o+ea(ea(F*l)+ea(ea(N*s)+ea(E*v))));u=ea(r+ea(ea(J*w)+ea(ea(H*G)+ea(I*D))));r=ea(e+ea(ea(M*w)+ea(ea(K*G)+ea(L*D))));e=ea(k+ea(ea(F*w)+ea(ea(N*G)+ea(E*D))));z=ea(o+ea(ea(J*C)+ea(ea(H*n)+ea(I*c))));I=ea(k+ea(ea(M*C)+ea(ea(K*n)+ea(L*c))));L=ea(h+ea(ea(F*C)+ea(ea(N*n)+ea(E*c))));g[a>>2]=q;g[a+4>>2]=x;g[a+8>>2]=j;g[a+12>>2]=ea(0.0);g[a+16>>2]=x;g[a+20>>2]=p;g[a+24>>2]=A;g[a+28>>2]=ea(0.0);g[a+32>>2]=j;g[a+36>>2]=A;g[a+40>>2]=d;g[a+44>>2]=ea(0.0);g[a+48>>2]=s;g[a+52>>2]=v;g[a+56>>2]=l;g[a+60>>2]=ea(0.0);g[a+64>>2]=G;g[a+68>>2]=D;g[a+72>>2]=w;g[a+76>>2]=ea(0.0);g[a+80>>2]=n;g[a+84>>2]=c;g[a+88>>2]=C;g[a+92>>2]=ea(0.0);g[a+96>>2]=i;g[a+100>>2]=t;g[a+104>>2]=B;g[a+108>>2]=ea(0.0);g[a+112>>2]=u;g[a+116>>2]=r;g[a+120>>2]=e;g[a+124>>2]=ea(0.0);g[a+128>>2]=z;g[a+132>>2]=I;g[a+136>>2]=L;g[a+140>>2]=ea(0.0);return}function P1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im;e=ea(g[c>>2]);f=ea(g[c+4>>2]);h=ea(g[c+8>>2]);i=ea(g[c+16>>2]);j=ea(g[c+20>>2]);k=ea(g[c+24>>2]);l=ea(g[c+32>>2]);m=ea(g[c+36>>2]);n=ea(g[c+40>>2]);o=ea(g[c+48>>2]);p=ea(g[c+52>>2]);q=ea(g[c+56>>2]);r=ea(g[c+64>>2]);s=ea(g[c+68>>2]);t=ea(g[c+72>>2]);u=ea(g[c+80>>2]);v=ea(g[c+84>>2]);w=ea(g[c+88>>2]);x=ea(g[b>>2]);y=ea(e*x);z=ea(g[b+16>>2]);A=ea(y+ea(f*z));y=ea(g[b+32>>2]);B=ea(A+ea(h*y));A=ea(g[b+4>>2]);C=ea(e*A);D=ea(g[b+20>>2]);E=ea(C+ea(f*D));C=ea(g[b+36>>2]);F=ea(E+ea(h*C));E=ea(g[b+8>>2]);G=ea(e*E);H=ea(g[b+24>>2]);I=ea(G+ea(f*H));G=ea(g[b+40>>2]);J=ea(I+ea(h*G));I=ea(g[b+48>>2]);K=ea(i*I);L=ea(g[b+64>>2]);M=ea(K+ea(j*L));K=ea(g[b+80>>2]);N=ea(M+ea(k*K));M=ea(g[b+52>>2]);O=ea(i*M);P=ea(g[b+68>>2]);Q=ea(O+ea(j*P));O=ea(g[b+84>>2]);R=ea(Q+ea(k*O));Q=ea(g[b+56>>2]);S=ea(i*Q);T=ea(g[b+72>>2]);U=ea(S+ea(j*T));S=ea(g[b+88>>2]);V=ea(B+N);N=ea(F+R);R=ea(J+ea(U+ea(k*S)));U=ea(ea(ea(e*I)+ea(f*M))+ea(h*Q));J=ea(ea(ea(e*L)+ea(f*P))+ea(h*T));F=ea(ea(ea(e*K)+ea(f*O))+ea(h*S));B=ea(g[b+96>>2]);W=ea(i*B);X=ea(g[b+112>>2]);Y=ea(W+ea(j*X));W=ea(g[b+128>>2]);Z=ea(Y+ea(k*W));Y=ea(g[b+100>>2]);_=ea(i*Y);$=ea(g[b+116>>2]);aa=ea(_+ea(j*$));_=ea(g[b+132>>2]);ba=ea(aa+ea(k*_));aa=ea(g[b+104>>2]);ca=ea(i*aa);da=ea(g[b+120>>2]);fa=ea(ca+ea(j*da));ca=ea(g[b+136>>2]);ga=ea(U+Z);Z=ea(J+ba);ba=ea(F+ea(fa+ea(k*ca)));fa=ea(ea(ea(ea(l*x)+ea(m*z))+ea(n*y))+ea(ea(ea(o*I)+ea(p*L))+ea(q*K)));F=ea(ea(ea(ea(l*A)+ea(m*D))+ea(n*C))+ea(ea(ea(o*M)+ea(p*P))+ea(q*O)));J=ea(ea(ea(ea(l*E)+ea(m*H))+ea(n*G))+ea(ea(ea(o*Q)+ea(p*T))+ea(q*S)));U=ea(ea(ea(ea(l*I)+ea(m*M))+ea(n*Q))+ea(ea(ea(o*B)+ea(p*X))+ea(q*W)));ha=ea(ea(ea(ea(l*L)+ea(m*P))+ea(n*T))+ea(ea(ea(o*Y)+ea(p*$))+ea(q*_)));ia=ea(ea(ea(ea(l*K)+ea(m*O))+ea(n*S))+ea(ea(ea(o*aa)+ea(p*da))+ea(q*ca)));ja=ea(ea(ea(ea(r*x)+ea(s*z))+ea(t*y))+ea(ea(ea(u*I)+ea(v*L))+ea(w*K)));y=ea(ea(ea(ea(r*A)+ea(s*D))+ea(t*C))+ea(ea(ea(u*M)+ea(v*P))+ea(w*O)));C=ea(ea(ea(ea(r*E)+ea(s*H))+ea(t*G))+ea(ea(ea(u*Q)+ea(v*T))+ea(w*S)));G=ea(ea(ea(ea(r*I)+ea(s*M))+ea(t*Q))+ea(ea(ea(u*B)+ea(v*X))+ea(w*W)));W=ea(ea(ea(ea(r*L)+ea(s*P))+ea(t*T))+ea(ea(ea(u*Y)+ea(v*$))+ea(w*_)));_=ea(ea(ea(ea(r*K)+ea(s*O))+ea(t*S))+ea(ea(ea(u*aa)+ea(v*da))+ea(w*ca)));ca=ea(ea(ea(ea(e*V)+ea(f*N))+ea(h*R))+ea(ea(ea(i*ga)+ea(j*Z))+ea(k*ba)));da=ea(ea(ea(ea(e*fa)+ea(f*F))+ea(h*J))+ea(ea(ea(i*U)+ea(j*ha))+ea(k*ia)));aa=ea(ea(ea(ea(e*ja)+ea(f*y))+ea(h*C))+ea(ea(ea(i*G)+ea(j*W))+ea(k*_)));k=ea(ea(ea(ea(l*fa)+ea(m*F))+ea(n*J))+ea(ea(ea(o*U)+ea(p*ha))+ea(q*ia)));j=ea(ea(ea(ea(l*ja)+ea(m*y))+ea(n*C))+ea(ea(ea(o*G)+ea(p*W))+ea(q*_)));q=ea(ea(ea(ea(r*ja)+ea(s*y))+ea(t*C))+ea(ea(ea(u*G)+ea(v*W))+ea(w*_)));g[d>>2]=V;g[d+4>>2]=N;g[d+8>>2]=R;g[d+12>>2]=ea(0.0);g[d+16>>2]=ga;g[d+20>>2]=Z;g[d+24>>2]=ba;g[d+28>>2]=ea(0.0);g[d+32>>2]=fa;g[d+36>>2]=F;g[d+40>>2]=J;g[d+44>>2]=ea(0.0);g[d+48>>2]=U;g[d+52>>2]=ha;g[d+56>>2]=ia;g[d+60>>2]=ea(0.0);g[d+64>>2]=ja;g[d+68>>2]=y;g[d+72>>2]=C;g[d+76>>2]=ea(0.0);g[d+80>>2]=G;g[d+84>>2]=W;g[d+88>>2]=_;g[d+92>>2]=ea(0.0);g[a>>2]=ca;g[a+4>>2]=da;g[a+8>>2]=aa;g[a+12>>2]=ea(0.0);g[a+16>>2]=da;g[a+20>>2]=k;g[a+24>>2]=j;g[a+28>>2]=ea(0.0);g[a+32>>2]=aa;g[a+36>>2]=j;g[a+40>>2]=q;g[a+44>>2]=ea(0.0);return}function Q1a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im;f=ea(g[d>>2]);h=ea(g[d+4>>2]);i=ea(g[d+8>>2]);j=ea(g[d+16>>2]);k=ea(g[d+20>>2]);l=ea(g[d+24>>2]);m=ea(g[d+32>>2]);n=ea(g[d+36>>2]);o=ea(g[d+40>>2]);p=ea(g[d+48>>2]);q=ea(g[d+52>>2]);r=ea(g[d+56>>2]);s=ea(g[d+64>>2]);t=ea(g[d+68>>2]);u=ea(g[d+72>>2]);v=ea(g[d+80>>2]);w=ea(g[d+84>>2]);x=ea(g[d+88>>2]);y=ea(g[c>>2]);z=ea(g[c+4>>2]);A=ea(g[c+8>>2]);B=ea(g[c+16>>2]);C=ea(g[c+20>>2]);D=ea(g[c+24>>2]);E=ea(g[c+32>>2]);F=ea(g[c+36>>2]);G=ea(g[c+40>>2]);H=ea(ea(f*y)+ea(ea(m*z)+ea(s*A)));I=ea(ea(h*y)+ea(ea(n*z)+ea(t*A)));J=ea(ea(i*y)+ea(ea(o*z)+ea(u*A)));K=ea(ea(f*B)+ea(ea(m*C)+ea(s*D)));L=ea(ea(h*B)+ea(ea(n*C)+ea(t*D)));M=ea(ea(i*B)+ea(ea(o*C)+ea(u*D)));N=ea(ea(f*E)+ea(ea(m*F)+ea(s*G)));O=ea(ea(h*E)+ea(ea(n*F)+ea(t*G)));P=ea(ea(i*E)+ea(ea(o*F)+ea(u*G)));Q=ea(ea(j*y)+ea(ea(p*z)+ea(v*A)));R=ea(ea(k*y)+ea(ea(q*z)+ea(w*A)));S=ea(ea(l*y)+ea(ea(r*z)+ea(x*A)));A=ea(ea(j*B)+ea(ea(p*C)+ea(v*D)));z=ea(ea(k*B)+ea(ea(q*C)+ea(w*D)));y=ea(ea(l*B)+ea(ea(r*C)+ea(x*D)));D=ea(ea(j*E)+ea(ea(p*F)+ea(v*G)));C=ea(ea(k*E)+ea(ea(q*F)+ea(w*G)));B=ea(ea(l*E)+ea(ea(r*F)+ea(x*G)));G=ea(g[b>>2]);F=ea(g[b+4>>2]);E=ea(g[b+8>>2]);T=ea(g[b+16>>2]);U=ea(g[b+20>>2]);V=ea(g[b+24>>2]);W=ea(g[b+32>>2]);X=ea(g[b+36>>2]);Y=ea(g[b+40>>2]);Z=ea(g[b+48>>2]);_=ea(g[b+52>>2]);$=ea(g[b+56>>2]);aa=ea(g[b+64>>2]);ba=ea(g[b+68>>2]);ca=ea(g[b+72>>2]);da=ea(g[b+80>>2]);fa=ea(g[b+84>>2]);ga=ea(g[b+88>>2]);ha=ea(g[b+96>>2]);ia=ea(g[b+100>>2]);ja=ea(g[b+104>>2]);ka=ea(g[b+112>>2]);la=ea(g[b+116>>2]);ma=ea(g[b+120>>2]);na=ea(g[b+128>>2]);oa=ea(g[b+132>>2]);pa=ea(ea(ea(G-ea(f*H))-ea(m*K))-ea(s*N));G=ea(ea(ea(F-ea(f*I))-ea(m*L))-ea(s*O));F=ea(ea(ea(E-ea(f*J))-ea(m*M))-ea(s*P));s=ea(ea(ea(Z-ea(j*H))-ea(p*K))-ea(v*N));Z=ea(ea(ea(_-ea(j*I))-ea(p*L))-ea(v*O));_=ea(ea(ea($-ea(j*J))-ea(p*M))-ea(v*P));$=ea(ea(ea(ha-ea(j*Q))-ea(p*A))-ea(v*D));ha=ea(ea(ea(ia-ea(j*R))-ea(p*z))-ea(v*C));ia=ea(ea(ea(ja-ea(j*S))-ea(p*y))-ea(v*B));v=ea(ea(ea(T-ea(h*H))-ea(n*K))-ea(t*N));T=ea(ea(ea(U-ea(h*I))-ea(n*L))-ea(t*O));U=ea(ea(ea(V-ea(h*J))-ea(n*M))-ea(t*P));t=ea(ea(ea(aa-ea(k*H))-ea(q*K))-ea(w*N));aa=ea(ea(ea(ba-ea(k*I))-ea(q*L))-ea(w*O));ba=ea(ea(ea(ca-ea(k*J))-ea(q*M))-ea(w*P));ca=ea(ea(ea(ka-ea(k*Q))-ea(q*A))-ea(w*D));ka=ea(ea(ea(la-ea(k*R))-ea(q*z))-ea(w*C));la=ea(ea(ea(ma-ea(k*S))-ea(q*y))-ea(w*B));w=ea(ea(ea(W-ea(i*H))-ea(o*K))-ea(u*N));W=ea(ea(ea(X-ea(i*I))-ea(o*L))-ea(u*O));X=ea(ea(ea(Y-ea(i*J))-ea(o*M))-ea(u*P));u=ea(ea(ea(da-ea(l*H))-ea(r*K))-ea(x*N));da=ea(ea(ea(fa-ea(l*I))-ea(r*L))-ea(x*O));fa=ea(ea(ea(ga-ea(l*J))-ea(r*M))-ea(x*P));ga=ea(ea(ea(na-ea(l*Q))-ea(r*A))-ea(x*D));na=ea(ea(ea(oa-ea(l*R))-ea(r*z))-ea(x*C));oa=ea(ea(ea(ea(g[b+136>>2])-ea(l*S))-ea(r*y))-ea(x*B));g[e>>2]=H;g[e+4>>2]=I;g[e+8>>2]=J;g[e+12>>2]=ea(0.0);g[e+16>>2]=Q;g[e+20>>2]=R;g[e+24>>2]=S;g[e+28>>2]=ea(0.0);g[e+32>>2]=K;g[e+36>>2]=L;g[e+40>>2]=M;g[e+44>>2]=ea(0.0);g[e+48>>2]=A;g[e+52>>2]=z;g[e+56>>2]=y;g[e+60>>2]=ea(0.0);g[e+64>>2]=N;g[e+68>>2]=O;g[e+72>>2]=P;g[e+76>>2]=ea(0.0);g[e+80>>2]=D;g[e+84>>2]=C;g[e+88>>2]=B;g[e+92>>2]=ea(0.0);g[a>>2]=pa;g[a+4>>2]=G;g[a+8>>2]=F;g[a+12>>2]=ea(0.0);g[a+16>>2]=v;g[a+20>>2]=T;g[a+24>>2]=U;g[a+28>>2]=ea(0.0);g[a+32>>2]=w;g[a+36>>2]=W;g[a+40>>2]=X;g[a+44>>2]=ea(0.0);g[a+48>>2]=s;g[a+52>>2]=Z;g[a+56>>2]=_;g[a+60>>2]=ea(0.0);g[a+64>>2]=t;g[a+68>>2]=aa;g[a+72>>2]=ba;g[a+76>>2]=ea(0.0);g[a+80>>2]=u;g[a+84>>2]=da;g[a+88>>2]=fa;g[a+92>>2]=ea(0.0);g[a+96>>2]=$;g[a+100>>2]=ha;g[a+104>>2]=ia;g[a+108>>2]=ea(0.0);g[a+112>>2]=ca;g[a+116>>2]=ka;g[a+120>>2]=la;g[a+124>>2]=ea(0.0);g[a+128>>2]=ga;g[a+132>>2]=na;g[a+136>>2]=oa;g[a+140>>2]=ea(0.0);return}function R1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;d=ea(g[c>>2]);e=ea(g[c+4>>2]);f=ea(g[c+8>>2]);h=ea(d*ea(g[b>>2]));i=ea(h+ea(e*ea(g[b+16>>2])));h=ea(i+ea(f*ea(g[b+32>>2])));i=ea(d*ea(g[b+4>>2]));j=ea(i+ea(e*ea(g[b+20>>2])));i=ea(j+ea(f*ea(g[b+36>>2])));j=ea(d*ea(g[b+8>>2]));k=ea(j+ea(e*ea(g[b+24>>2])));j=ea(k+ea(f*ea(g[b+40>>2])));k=ea(g[c+16>>2]);l=ea(g[c+20>>2]);m=ea(g[c+24>>2]);n=ea(g[b+48>>2]);o=ea(k*n);p=ea(g[b+64>>2]);q=ea(o+ea(l*p));o=ea(g[b+80>>2]);r=ea(q+ea(m*o));q=ea(g[b+52>>2]);s=ea(k*q);t=ea(g[b+68>>2]);u=ea(s+ea(l*t));s=ea(g[b+84>>2]);v=ea(u+ea(m*s));u=ea(g[b+56>>2]);w=ea(k*u);x=ea(g[b+72>>2]);y=ea(w+ea(l*x));w=ea(g[b+88>>2]);z=ea(h+r);r=ea(i+v);v=ea(j+ea(y+ea(m*w)));y=ea(ea(ea(d*n)+ea(e*q))+ea(f*u));u=ea(ea(ea(d*p)+ea(e*t))+ea(f*x));x=ea(ea(ea(d*o)+ea(e*s))+ea(f*w));w=ea(k*ea(g[b+96>>2]));f=ea(w+ea(l*ea(g[b+112>>2])));w=ea(f+ea(m*ea(g[b+128>>2])));f=ea(k*ea(g[b+100>>2]));s=ea(f+ea(l*ea(g[b+116>>2])));f=ea(s+ea(m*ea(g[b+132>>2])));s=ea(k*ea(g[b+104>>2]));k=ea(s+ea(l*ea(g[b+120>>2])));l=ea(y+w);w=ea(u+f);f=ea(x+ea(k+ea(m*ea(g[b+136>>2]))));g[a>>2]=z;g[a+4>>2]=r;g[a+8>>2]=v;g[a+12>>2]=ea(0.0);g[a+16>>2]=l;g[a+20>>2]=w;g[a+24>>2]=f;g[a+28>>2]=ea(0.0);return}function S1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(-d);i=ea(-e);j=ea(-f);k=ea(g[c+48>>2]);l=ea(g[c+52>>2]);m=ea(g[c+56>>2]);n=ea(g[c+64>>2]);o=ea(g[c+68>>2]);p=ea(g[c+72>>2]);q=ea(g[c+80>>2]);r=ea(g[c+84>>2]);s=ea(g[c+88>>2]);t=ea(g[c>>2]);u=ea(g[c+4>>2]);v=ea(g[c+8>>2]);w=ea(g[c+12>>2]);x=ea(g[c+16>>2]);y=ea(g[c+20>>2]);z=ea(g[c+24>>2]);A=ea(g[c+28>>2]);B=ea(g[c+32>>2]);C=ea(g[c+36>>2]);D=ea(g[c+40>>2]);E=ea(g[c+44>>2]);F=ea(g[c+96>>2]);G=ea(g[c+100>>2]);H=ea(g[c+104>>2]);I=ea(g[c+112>>2]);J=ea(g[c+116>>2]);K=ea(g[c+120>>2]);L=ea(g[c+128>>2]);M=ea(g[c+132>>2]);N=ea(ea(x*j)+ea(B*e));O=ea(ea(y*j)+ea(C*e));P=ea(ea(z*j)+ea(D*e));Q=ea(ea(B*h)+ea(t*f));R=ea(ea(C*h)+ea(u*f));S=ea(ea(D*h)+ea(v*f));T=ea(ea(t*i)+ea(d*x));U=ea(ea(u*i)+ea(d*y));V=ea(ea(v*i)+ea(d*z));W=ea(ea(ea(k*ea(0.0))+ea(ea(l*j)+ea(m*e)))+ea(ea(ea(e*P)+ea(ea(O*j)+ea(N*ea(0.0))))*ea(.5)));X=ea(ea(ea(ea(o*ea(0.0))+ea(p*h))+ea(n*f))+ea(ea(ea(S*h)+ea(ea(R*ea(0.0))+ea(f*Q)))*ea(.5)));Y=ea(ea(ea(q*i)+ea(ea(d*r)+ea(s*ea(0.0))))+ea(ea(ea(V*ea(0.0))+ea(ea(T*i)+ea(d*U)))*ea(.5)));Z=ea(ea(ea(ea(ea(l*ea(0.0))+ea(m*h))+ea(k*f))+ea(ea(ea(P*h)+ea(ea(O*ea(0.0))+ea(f*N)))*ea(.5)))+ea(ea(ea(n*ea(0.0))+ea(ea(o*j)+ea(p*e)))+ea(ea(ea(e*S)+ea(ea(R*j)+ea(Q*ea(0.0))))*ea(.5))));_=ea(ea(ea(ea(ea(ea(T*ea(0.0))+ea(U*j))+ea(V*e))*ea(.5))+ea(ea(q*ea(0.0))+ea(ea(r*j)+ea(s*e))))+ea(ea(ea(k*i)+ea(ea(d*l)+ea(m*ea(0.0))))+ea(ea(ea(P*ea(0.0))+ea(ea(d*O)+ea(N*i)))*ea(.5))));e=ea(ea(ea(ea(ea(r*ea(0.0))+ea(s*h))+ea(q*f))+ea(ea(ea(V*h)+ea(ea(U*ea(0.0))+ea(T*f)))*ea(.5)))+ea(ea(ea(n*i)+ea(ea(d*o)+ea(p*ea(0.0))))+ea(ea(ea(S*ea(0.0))+ea(ea(d*R)+ea(Q*i)))*ea(.5))));i=ea(k+N);N=ea(l+O);O=ea(m+P);P=ea(n+Q);Q=ea(o+R);R=ea(p+S);S=ea(q+T);T=ea(r+U);U=ea(s+V);V=ea(F+ea(W+W));W=ea(G+Z);G=ea(H+_);H=ea(I+Z);Z=ea(J+ea(X+X));X=ea(K+e);K=ea(L+_);_=ea(M+e);e=ea(ea(Y+Y)+ea(g[c+136>>2]));g[a>>2]=t;g[a+4>>2]=u;g[a+8>>2]=v;g[a+12>>2]=w;g[a+16>>2]=x;g[a+20>>2]=y;g[a+24>>2]=z;g[a+28>>2]=A;g[a+32>>2]=B;g[a+36>>2]=C;g[a+40>>2]=D;g[a+44>>2]=E;g[a+48>>2]=i;g[a+52>>2]=N;g[a+56>>2]=O;g[a+60>>2]=ea(0.0);g[a+64>>2]=P;g[a+68>>2]=Q;g[a+72>>2]=R;g[a+76>>2]=ea(0.0);g[a+80>>2]=S;g[a+84>>2]=T;g[a+88>>2]=U;g[a+92>>2]=ea(0.0);g[a+96>>2]=V;g[a+100>>2]=W;g[a+104>>2]=G;g[a+108>>2]=ea(0.0);g[a+112>>2]=H;g[a+116>>2]=Z;g[a+120>>2]=X;g[a+124>>2]=ea(0.0);g[a+128>>2]=K;g[a+132>>2]=_;g[a+136>>2]=e;g[a+140>>2]=ea(0.0);return}function T1a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,i=Im,j=0,k=Im,l=0,m=Im,n=Im,o=0,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;h=e+16|0;i=ea(g[h>>2]);j=e+20|0;k=ea(g[j>>2]);l=e+24|0;m=ea(g[l>>2]);n=ea(g[e>>2]);o=e+4|0;p=ea(g[o>>2]);q=e+8|0;r=ea(g[q>>2]);s=ea(g[c+16>>2]);t=ea(g[c+20>>2]);u=ea(g[c+24>>2]);v=ea(i+ea(ea(p*u)-ea(r*t)));i=ea(k+ea(ea(r*s)-ea(n*u)));u=ea(m+ea(ea(n*t)-ea(p*s)));s=ea(g[f>>2]);p=ea(g[f+4>>2]);t=ea(v-s);s=ea(i-p);p=ea(u-ea(g[f+8>>2]));g[d>>2]=t;g[d+4>>2]=s;g[d+8>>2]=p;g[d+12>>2]=ea(0.0);u=ea(g[b>>2]);i=ea(g[b+4>>2]);v=ea(g[b+8>>2]);n=ea(g[b+32>>2]);m=ea(g[b+36>>2]);r=ea(g[b+40>>2]);k=ea(g[b+64>>2]);w=ea(g[b+68>>2]);x=ea(ea(t*u)+ea(ea(s*n)+ea(p*k)));k=ea(ea(t*i)+ea(ea(s*m)+ea(p*w)));w=ea(ea(t*v)+ea(ea(s*r)+ea(p*ea(g[b+72>>2]))));r=ea(g[b+16>>2]);v=ea(g[b+20>>2]);m=ea(g[b+24>>2]);i=ea(g[b+48>>2]);n=ea(g[b+52>>2]);u=ea(g[b+56>>2]);y=ea(g[b+80>>2]);z=ea(g[b+84>>2]);A=ea(ea(t*r)+ea(ea(s*i)+ea(p*y)));y=ea(ea(t*v)+ea(ea(s*n)+ea(p*z)));z=ea(ea(t*m)+ea(ea(s*u)+ea(p*ea(g[b+88>>2]))));p=ea(g[e>>2]);u=ea(g[o>>2]);s=ea(p-x);x=ea(u-k);k=ea(ea(g[q>>2])-w);w=ea(g[h>>2]);u=ea(g[j>>2]);p=ea(w-A);A=ea(u-y);y=ea(ea(g[l>>2])-z);z=ea(g[c>>2]);u=ea(g[c+4>>2]);w=ea(g[c+8>>2]);m=ea(p+ea(ea(k*u)-ea(x*w)));p=ea(A+ea(ea(s*w)-ea(k*z)));w=ea(y+ea(ea(x*z)-ea(s*u)));g[a>>2]=s;g[a+4>>2]=x;g[a+8>>2]=k;g[a+12>>2]=ea(0.0);g[a+16>>2]=m;g[a+20>>2]=p;g[a+24>>2]=w;g[a+28>>2]=ea(0.0);return}function U1a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;h=ea(g[c>>2]);i=ea(g[c+4>>2]);j=ea(-h);h=ea(-i);i=ea(-ea(g[c+8>>2]));k=ea(g[e>>2]);l=ea(g[e+4>>2]);m=ea(g[e+8>>2]);n=ea(g[e+16>>2]);o=ea(g[e+20>>2]);p=ea(g[e+24>>2]);q=ea(k+ea(ea(p*h)-ea(o*i)));k=ea(l+ea(ea(n*i)-ea(p*j)));i=ea(m+ea(ea(o*j)-ea(n*h)));h=ea(g[d>>2]);j=ea(g[d+4>>2]);m=ea(g[d+8>>2]);l=ea(h*ea(g[b+96>>2]));r=ea(l+ea(j*ea(g[b+112>>2])));l=ea(r+ea(m*ea(g[b+128>>2])));r=ea(h*ea(g[b+100>>2]));s=ea(r+ea(j*ea(g[b+116>>2])));r=ea(s+ea(m*ea(g[b+132>>2])));s=ea(h*ea(g[b+104>>2]));h=ea(s+ea(j*ea(g[b+120>>2])));j=ea(h+ea(m*ea(g[b+136>>2])));m=ea(g[b>>2]);h=ea(g[b+4>>2]);s=ea(ea(ea(q*m)+ea(k*h))+ea(i*ea(g[b+8>>2])));h=ea(g[b+16>>2]);m=ea(g[b+20>>2]);t=ea(s+ea(ea(ea(n*h)+ea(o*m))+ea(p*ea(g[b+24>>2]))));m=ea(g[b+32>>2]);h=ea(g[b+36>>2]);s=ea(ea(ea(q*m)+ea(k*h))+ea(i*ea(g[b+40>>2])));h=ea(g[b+48>>2]);m=ea(g[b+52>>2]);u=ea(s+ea(ea(ea(n*h)+ea(o*m))+ea(p*ea(g[b+56>>2]))));m=ea(g[b+64>>2]);h=ea(g[b+68>>2]);s=ea(ea(ea(q*m)+ea(k*h))+ea(i*ea(g[b+72>>2])));h=ea(g[b+80>>2]);m=ea(g[b+84>>2]);v=ea(l+t);t=ea(r+u);u=ea(j+ea(s+ea(ea(ea(n*h)+ea(o*m))+ea(p*ea(g[b+88>>2])))));m=ea(g[c+16>>2]);h=ea(g[c+20>>2]);s=ea(g[c+24>>2]);j=ea(k-ea(ea(v*s)-ea(m*u)));k=ea(i-ea(ea(t*m)-ea(v*h)));m=ea(n-v);v=ea(o-t);o=ea(p-u);g[a>>2]=ea(q-ea(ea(h*u)-ea(t*s)));g[a+4>>2]=j;g[a+8>>2]=k;g[a+12>>2]=ea(0.0);g[a+16>>2]=m;g[a+20>>2]=v;g[a+24>>2]=o;g[a+28>>2]=ea(0.0);return}function V1a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=Im,i=0,j=Im,k=0,l=Im,m=Im,n=0,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;f=e+16|0;h=ea(g[f>>2]);i=e+20|0;j=ea(g[i>>2]);k=e+24|0;l=ea(g[k>>2]);m=ea(g[e>>2]);n=e+4|0;o=ea(g[n>>2]);p=e+8|0;q=ea(g[p>>2]);r=ea(g[c+16>>2]);s=ea(g[c+20>>2]);t=ea(g[c+24>>2]);u=ea(h+ea(ea(o*t)-ea(q*s)));h=ea(j+ea(ea(q*r)-ea(m*t)));t=ea(l+ea(ea(m*s)-ea(o*r)));g[d>>2]=u;g[d+4>>2]=h;g[d+8>>2]=t;g[d+12>>2]=ea(0.0);r=ea(g[b>>2]);o=ea(g[b+4>>2]);s=ea(g[b+8>>2]);m=ea(g[b+32>>2]);l=ea(g[b+36>>2]);q=ea(g[b+40>>2]);j=ea(g[b+64>>2]);v=ea(g[b+68>>2]);w=ea(ea(u*r)+ea(ea(h*m)+ea(t*j)));j=ea(ea(u*o)+ea(ea(h*l)+ea(t*v)));v=ea(ea(u*s)+ea(ea(h*q)+ea(t*ea(g[b+72>>2]))));q=ea(g[b+16>>2]);s=ea(g[b+20>>2]);l=ea(g[b+24>>2]);o=ea(g[b+48>>2]);m=ea(g[b+52>>2]);r=ea(g[b+56>>2]);x=ea(g[b+80>>2]);y=ea(g[b+84>>2]);z=ea(ea(u*q)+ea(ea(h*o)+ea(t*x)));x=ea(ea(u*s)+ea(ea(h*m)+ea(t*y)));y=ea(ea(u*l)+ea(ea(h*r)+ea(t*ea(g[b+88>>2]))));t=ea(g[e>>2]);r=ea(g[n>>2]);h=ea(t-w);w=ea(r-j);j=ea(ea(g[p>>2])-v);v=ea(g[f>>2]);r=ea(g[i>>2]);t=ea(v-z);z=ea(r-x);x=ea(ea(g[k>>2])-y);y=ea(g[c>>2]);r=ea(g[c+4>>2]);v=ea(g[c+8>>2]);l=ea(t+ea(ea(j*r)-ea(w*v)));t=ea(z+ea(ea(h*v)-ea(j*y)));v=ea(x+ea(ea(w*y)-ea(h*r)));g[a>>2]=h;g[a+4>>2]=w;g[a+8>>2]=j;g[a+12>>2]=ea(0.0);g[a+16>>2]=l;g[a+20>>2]=t;g[a+24>>2]=v;g[a+28>>2]=ea(0.0);return}function W1a(d,f,h,j,k){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=Im,v=0,w=0,x=Im,y=Im,z=0,A=Im,B=0,C=0,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0;l=i;i=i+1280|0;m=l;n=l+1024|0;o=f+26|0;p=b[o>>1]|0;q=f+((p&65535)+144)|0;r=f+(e[f+10>>1]|0)|0;s=ea(g[j>>2]);t=j+4|0;u=ea(g[t>>2]);v=j+8|0;w=j+12|0;x=ea(-s);s=ea(-u);u=ea(-ea(g[v>>2]));g[j>>2]=x;g[t>>2]=s;g[v>>2]=u;g[w>>2]=ea(0.0);y=ea(g[k>>2]);z=k+4|0;A=ea(g[z>>2]);B=k+8|0;C=k+12|0;D=ea(-y);y=ea(-A);A=ea(-ea(g[B>>2]));g[k>>2]=D;g[z>>2]=y;g[B>>2]=A;g[C>>2]=ea(0.0);if(!h){E=p;F=x;G=s;H=u;I=D;J=y;K=A;L=0}else{M=s;s=u;u=x;x=D;D=y;y=A;p=h;h=0;while(1){A=ea(g[r+(p<<5)+16>>2]);N=ea(g[r+(p<<5)+20>>2]);O=ea(g[r+(p<<5)+24>>2]);P=ea(x+ea(ea(M*O)-ea(s*N)));Q=ea(D+ea(ea(s*A)-ea(u*O)));O=ea(y+ea(ea(u*N)-ea(M*A)));g[m+(h<<4)>>2]=P;g[m+(h<<4)+4>>2]=Q;g[m+(h<<4)+8>>2]=O;g[m+(h<<4)+12>>2]=ea(0.0);A=ea(g[q+(p*160|0)>>2]);N=ea(g[q+(p*160|0)+4>>2]);R=ea(g[q+(p*160|0)+8>>2]);S=ea(g[q+(p*160|0)+32>>2]);T=ea(g[q+(p*160|0)+36>>2]);U=ea(g[q+(p*160|0)+40>>2]);V=ea(g[q+(p*160|0)+64>>2]);W=ea(g[q+(p*160|0)+68>>2]);u=ea(ea(ea(u-ea(O*V))-ea(Q*S))-ea(A*P));M=ea(ea(ea(M-ea(O*W))-ea(Q*T))-ea(N*P));s=ea(ea(ea(s-ea(O*ea(g[q+(p*160|0)+72>>2])))-ea(Q*U))-ea(R*P));R=ea(g[q+(p*160|0)+16>>2]);U=ea(g[q+(p*160|0)+20>>2]);N=ea(g[q+(p*160|0)+24>>2]);T=ea(g[q+(p*160|0)+48>>2]);W=ea(g[q+(p*160|0)+52>>2]);A=ea(g[q+(p*160|0)+56>>2]);S=ea(g[q+(p*160|0)+80>>2]);V=ea(g[q+(p*160|0)+84>>2]);X=ea(ea(ea(x-ea(O*S))-ea(Q*T))-ea(P*R));R=ea(ea(ea(D-ea(O*V))-ea(Q*W))-ea(P*U));U=ea(ea(ea(y-ea(O*ea(g[q+(p*160|0)+88>>2])))-ea(Q*A))-ea(P*N));N=ea(g[r+(p<<5)>>2]);P=ea(g[r+(p<<5)+4>>2]);A=ea(g[r+(p<<5)+8>>2]);x=ea(X+ea(ea(P*s)-ea(A*M)));D=ea(R+ea(ea(A*u)-ea(N*s)));y=ea(U+ea(ea(N*M)-ea(P*u)));Y=h;h=h+1|0;c[n+(Y<<2)>>2]=p;Y=a[f+p+64>>0]|0;if(!(Y<<24>>24))break;else p=Y&255}g[k>>2]=x;g[z>>2]=D;g[B>>2]=y;g[j>>2]=u;g[t>>2]=M;g[v>>2]=s;g[w>>2]=ea(0.0);g[C>>2]=ea(0.0);E=b[o>>1]|0;F=u;G=M;H=s;I=x;J=D;K=y;L=h}h=E&65535;y=ea(F*ea(g[f+h>>2]));D=ea(y+ea(G*ea(g[f+(h+16)>>2])));y=ea(D+ea(H*ea(g[f+(h+32)>>2])));D=ea(F*ea(g[f+(h+4)>>2]));x=ea(D+ea(G*ea(g[f+(h+20)>>2])));D=ea(x+ea(H*ea(g[f+(h+36)>>2])));x=ea(F*ea(g[f+(h+8)>>2]));s=ea(x+ea(G*ea(g[f+(h+24)>>2])));x=ea(s+ea(H*ea(g[f+(h+40)>>2])));s=ea(g[f+(h+48)>>2]);M=ea(I*s);u=ea(g[f+(h+64)>>2]);P=ea(M+ea(J*u));M=ea(g[f+(h+80)>>2]);N=ea(P+ea(K*M));P=ea(g[f+(h+52)>>2]);U=ea(I*P);A=ea(g[f+(h+68)>>2]);R=ea(U+ea(J*A));U=ea(g[f+(h+84)>>2]);X=ea(R+ea(K*U));R=ea(g[f+(h+56)>>2]);Q=ea(I*R);O=ea(g[f+(h+72)>>2]);W=ea(Q+ea(J*O));Q=ea(g[f+(h+88)>>2]);V=ea(-ea(y+N));N=ea(-ea(D+X));X=ea(-ea(x+ea(W+ea(K*Q))));W=ea(ea(ea(F*s)+ea(G*P))+ea(H*R));R=ea(ea(ea(F*u)+ea(G*A))+ea(H*O));O=ea(ea(ea(F*M)+ea(G*U))+ea(H*Q));Q=ea(I*ea(g[f+(h+96)>>2]));H=ea(Q+ea(J*ea(g[f+(h+112)>>2])));Q=ea(H+ea(K*ea(g[f+(h+128)>>2])));H=ea(I*ea(g[f+(h+100)>>2]));U=ea(H+ea(J*ea(g[f+(h+116)>>2])));H=ea(U+ea(K*ea(g[f+(h+132)>>2])));U=ea(I*ea(g[f+(h+104)>>2]));I=ea(U+ea(J*ea(g[f+(h+120)>>2])));J=ea(-ea(W+Q));Q=ea(-ea(R+H));H=ea(-ea(O+ea(I+ea(K*ea(g[f+(h+136)>>2])))));if(!L){Z=X;_=N;$=V;aa=H;ba=Q;ca=J;g[d>>2]=$;da=d+4|0;g[da>>2]=_;fa=d+8|0;g[fa>>2]=Z;ga=d+12|0;g[ga>>2]=ea(0.0);ha=d+16|0;g[ha>>2]=ca;ia=d+20|0;g[ia>>2]=ba;ja=d+24|0;g[ja>>2]=aa;ka=d+28|0;g[ka>>2]=ea(0.0);i=l;return}else{la=H;ma=Q;na=J;oa=V;pa=N;qa=X;ra=L}while(1){ra=ra+-1|0;L=c[n+(ra<<2)>>2]|0;X=ea(g[r+(L<<5)>>2]);N=ea(g[r+(L<<5)+4>>2]);V=ea(g[r+(L<<5)+8>>2]);J=ea(oa-ea(ea(la*N)-ea(ma*V)));Q=ea(pa-ea(ea(na*V)-ea(la*X)));V=ea(qa-ea(ea(ma*X)-ea(na*N)));N=ea(g[q+(L*160|0)>>2]);X=ea(g[q+(L*160|0)+4>>2]);H=ea(ea(V*ea(g[q+(L*160|0)+8>>2]))+ea(ea(N*J)+ea(X*Q)));X=ea(g[q+(L*160|0)+32>>2]);N=ea(g[q+(L*160|0)+36>>2]);K=ea(ea(ea(J*X)+ea(Q*N))+ea(V*ea(g[q+(L*160|0)+40>>2])));N=ea(g[q+(L*160|0)+64>>2]);X=ea(g[q+(L*160|0)+68>>2]);I=ea(ea(ea(J*N)+ea(Q*X))+ea(V*ea(g[q+(L*160|0)+72>>2])));X=ea(g[q+(L*160|0)+16>>2]);N=ea(g[q+(L*160|0)+20>>2]);O=ea(ea(ea(na*X)+ea(ma*N))+ea(la*ea(g[q+(L*160|0)+24>>2])));N=ea(g[q+(L*160|0)+48>>2]);X=ea(g[q+(L*160|0)+52>>2]);R=ea(ea(ea(na*N)+ea(ma*X))+ea(la*ea(g[q+(L*160|0)+56>>2])));X=ea(g[q+(L*160|0)+80>>2]);N=ea(g[q+(L*160|0)+84>>2]);W=ea(H+O);O=ea(K+R);R=ea(I+ea(ea(ea(na*X)+ea(ma*N))+ea(la*ea(g[q+(L*160|0)+88>>2]))));N=ea(g[m+(ra<<4)>>2]);X=ea(g[m+(ra<<4)+4>>2]);I=ea(g[m+(ra<<4)+8>>2]);K=ea(N*ea(g[q+(L*160|0)+96>>2]));H=ea(K+ea(X*ea(g[q+(L*160|0)+112>>2])));K=ea(H+ea(I*ea(g[q+(L*160|0)+128>>2])));H=ea(N*ea(g[q+(L*160|0)+100>>2]));U=ea(H+ea(X*ea(g[q+(L*160|0)+116>>2])));H=ea(U+ea(I*ea(g[q+(L*160|0)+132>>2])));U=ea(N*ea(g[q+(L*160|0)+104>>2]));N=ea(U+ea(X*ea(g[q+(L*160|0)+120>>2])));X=ea(W+K);K=ea(O+H);H=ea(R+ea(N+ea(I*ea(g[q+(L*160|0)+136>>2]))));I=ea(g[r+(L<<5)+16>>2]);N=ea(g[r+(L<<5)+20>>2]);R=ea(g[r+(L<<5)+24>>2]);O=ea(J-ea(ea(N*H)-ea(K*R)));J=ea(Q-ea(ea(X*R)-ea(I*H)));R=ea(V-ea(ea(K*I)-ea(X*N)));N=ea(na-X);X=ea(ma-K);K=ea(la-H);if(!ra){Z=R;_=J;$=O;aa=K;ba=X;ca=N;break}else{la=K;ma=X;na=N;oa=O;pa=J;qa=R}}g[d>>2]=$;da=d+4|0;g[da>>2]=_;fa=d+8|0;g[fa>>2]=Z;ga=d+12|0;g[ga>>2]=ea(0.0);ha=d+16|0;g[ha>>2]=ca;ia=d+20|0;g[ia>>2]=ba;ja=d+24|0;g[ja>>2]=aa;ka=d+28|0;g[ka>>2]=ea(0.0);i=l;return}function X1a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im;f=i;i=i+240|0;h=f+144|0;j=f+48|0;k=f;P1a(k,b,c,h);l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(g[e>>2]);p=ea(g[k>>2]);e=k+4|0;q=ea(g[e>>2]);c=k+8|0;r=ea(ea(l*o)+p);p=ea(ea(m*o)+q);q=ea(ea(n*o)+ea(g[c>>2]));g[k>>2]=r;g[e>>2]=p;g[c>>2]=q;g[k+12>>2]=ea(0.0);n=ea(g[d+16>>2]);m=ea(g[d+20>>2]);l=ea(g[d+24>>2]);c=k+16|0;s=ea(g[c>>2]);e=k+20|0;t=ea(g[e>>2]);u=k+24|0;v=ea(ea(m*o)+t);t=ea(ea(l*o)+ea(g[u>>2]));g[c>>2]=ea(ea(n*o)+s);g[e>>2]=v;g[u>>2]=t;g[k+28>>2]=ea(0.0);s=ea(g[d+32>>2]);n=ea(g[d+36>>2]);l=ea(g[d+40>>2]);d=k+32|0;m=ea(g[d>>2]);u=k+36|0;w=ea(g[u>>2]);e=k+40|0;x=ea(ea(n*o)+w);w=ea(ea(l*o)+ea(g[e>>2]));g[d>>2]=ea(ea(s*o)+m);g[u>>2]=x;g[e>>2]=w;g[k+44>>2]=ea(0.0);x=ea(ea(1.0)/ea(T(ea(r))));r=ea(p*x);p=ea(q*x);q=ea(ea(1.0)/ea(T(ea(v-ea(r*r)))));v=ea(q*ea(t-ea(r*p)));t=ea(ea(1.0)/ea(T(ea(ea(w-ea(v*v))-ea(p*p)))));w=ea(ea(x*r)*q);r=ea(t*ea(ea(w*v)-ea(x*p)));p=ea(-w);w=ea(-ea(v*ea(q*t)));v=ea(g[h>>2]);m=ea(g[h+4>>2]);o=ea(g[h+8>>2]);s=ea(g[h+32>>2]);l=ea(g[h+36>>2]);n=ea(g[h+40>>2]);y=ea(g[h+64>>2]);z=ea(g[h+68>>2]);A=ea(g[h+72>>2]);B=ea(g[h+16>>2]);C=ea(g[h+20>>2]);D=ea(g[h+24>>2]);E=ea(g[h+48>>2]);F=ea(g[h+52>>2]);G=ea(g[h+56>>2]);H=ea(g[h+80>>2]);I=ea(g[h+84>>2]);J=ea(g[h+88>>2]);K=ea(x*m);L=ea(x*o);M=ea(x*B);N=ea(x*C);O=ea(x*D);g[j>>2]=ea(x*v);g[j+4>>2]=K;g[j+8>>2]=L;g[j+12>>2]=ea(0.0);g[j+16>>2]=M;g[j+20>>2]=N;g[j+24>>2]=O;g[j+28>>2]=ea(0.0);O=ea(ea(m*p)+ea(q*l));N=ea(ea(o*p)+ea(q*n));M=ea(ea(B*p)+ea(q*E));L=ea(ea(C*p)+ea(q*F));K=ea(ea(D*p)+ea(q*G));g[j+32>>2]=ea(ea(v*p)+ea(q*s));g[j+36>>2]=O;g[j+40>>2]=N;g[j+44>>2]=ea(0.0);g[j+48>>2]=M;g[j+52>>2]=L;g[j+56>>2]=K;g[j+60>>2]=ea(0.0);K=ea(ea(m*r)+ea(ea(l*w)+ea(t*z)));z=ea(ea(o*r)+ea(ea(n*w)+ea(t*A)));A=ea(ea(r*B)+ea(ea(E*w)+ea(t*H)));H=ea(ea(r*C)+ea(ea(F*w)+ea(t*I)));I=ea(ea(r*D)+ea(ea(G*w)+ea(t*J)));g[j+64>>2]=ea(ea(v*r)+ea(ea(s*w)+ea(t*y)));g[j+68>>2]=K;g[j+72>>2]=z;g[j+76>>2]=ea(0.0);g[j+80>>2]=A;g[j+84>>2]=H;g[j+88>>2]=I;g[j+92>>2]=ea(0.0);nEb(a,b,j);i=f;return}function Y1a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0;f=i;i=i+864|0;h=f+720|0;j=f+432|0;k=f+144|0;l=f+240|0;m=f+816|0;n=f;o=f+288|0;p=f+576|0;q=f+528|0;r=h+0|0;s=r+96|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));r=j+0|0;s=r+96|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));r=k+0|0;s=r+96|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));P1a(l,b,e,h);t=ea(g[l+16>>2]);u=ea(g[l+20>>2]);v=ea(g[l+24>>2]);w=ea(g[l+32>>2]);x=ea(g[l+36>>2]);y=ea(g[l+40>>2]);z=ea(ea(u*y)-ea(v*x));A=ea(ea(v*w)-ea(t*y));v=ea(ea(t*x)-ea(u*w));B=ea(g[l>>2]);C=ea(g[l+4>>2]);D=ea(g[l+8>>2]);E=ea(ea(1.0)/ea(ea(ea(B*z)+ea(A*C))+ea(v*D)));F=ea(A*E);A=ea(v*E);v=ea(E*ea(ea(y*B)-ea(w*D)));D=ea(E*ea(ea(w*C)-ea(x*B)));x=ea(E*ea(ea(u*B)-ea(t*C)));g[m>>2]=ea(z*E);l=m+4|0;g[l>>2]=F;e=m+8|0;g[e>>2]=A;g[m+12>>2]=ea(0.0);r=m+16|0;g[r>>2]=F;s=m+20|0;g[s>>2]=v;G=m+24|0;g[G>>2]=D;g[m+28>>2]=ea(0.0);H=m+32|0;g[H>>2]=A;I=m+36|0;g[I>>2]=D;J=m+40|0;g[J>>2]=x;g[m+44>>2]=ea(0.0);oEb(n,b,d);Q1a(o,n,m,h,j);c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];h=n+16|0;d=o+16|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];d=n+32|0;h=o+32|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];h=n+48|0;d=o+48|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];d=n+64|0;h=o+64|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];h=n+80|0;d=o+80|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];d=n+96|0;h=o+96|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];h=n+112|0;d=o+112|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];d=n+128|0;h=o+128|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];O1a(p,n);P1a(q,p,j,k);x=ea(g[m>>2]);D=ea(g[l>>2]);A=ea(g[e>>2]);v=ea(g[q>>2]);F=ea(g[q+4>>2]);E=ea(x+v);v=ea(D+F);F=ea(A+ea(g[q+8>>2]));A=ea(g[r>>2]);D=ea(g[s>>2]);x=ea(g[G>>2]);z=ea(g[q+16>>2]);C=ea(g[q+20>>2]);t=ea(A+z);z=ea(D+C);C=ea(x+ea(g[q+24>>2]));x=ea(g[H>>2]);D=ea(g[I>>2]);A=ea(g[J>>2]);B=ea(g[q+32>>2]);u=ea(g[q+36>>2]);w=ea(x+B);B=ea(D+u);u=ea(A+ea(g[q+40>>2]));A=ea(ea(z*u)-ea(C*B));D=ea(ea(C*w)-ea(t*u));C=ea(ea(t*B)-ea(z*w));x=ea(ea(1.0)/ea(ea(F*C)+ea(ea(E*A)+ea(v*D))));y=ea(x*D);D=ea(x*C);C=ea(x*ea(ea(E*u)-ea(F*w)));F=ea(x*ea(ea(v*w)-ea(E*B)));B=ea(ea(ea(E*z)-ea(v*t))*x);g[a>>2]=ea(x*A);g[a+4>>2]=y;g[a+8>>2]=D;g[a+12>>2]=ea(0.0);g[a+16>>2]=y;g[a+20>>2]=C;g[a+24>>2]=F;g[a+28>>2]=ea(0.0);g[a+32>>2]=D;g[a+36>>2]=F;g[a+40>>2]=B;g[a+44>>2]=ea(0.0);i=f;return}function Z1a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;h=ea(g[e>>2]);i=ea(g[e+4>>2]);j=ea(g[e+8>>2]);k=ea(g[e+16>>2]);l=ea(g[e+20>>2]);m=ea(g[e+24>>2]);n=ea(g[c>>2]);o=ea(g[c+4>>2]);p=ea(g[c+8>>2]);q=ea(h+ea(ea(l*p)-ea(m*o)));h=ea(i+ea(ea(m*n)-ea(k*p)));p=ea(j+ea(ea(k*o)-ea(l*n)));n=ea(g[d>>2]);o=ea(g[d+4>>2]);j=ea(g[d+8>>2]);i=ea(n*ea(g[b+96>>2]));r=ea(i+ea(o*ea(g[b+112>>2])));i=ea(r+ea(j*ea(g[b+128>>2])));r=ea(n*ea(g[b+100>>2]));s=ea(r+ea(o*ea(g[b+116>>2])));r=ea(s+ea(j*ea(g[b+132>>2])));s=ea(n*ea(g[b+104>>2]));n=ea(s+ea(o*ea(g[b+120>>2])));o=ea(n+ea(j*ea(g[b+136>>2])));j=ea(g[b>>2]);n=ea(g[b+4>>2]);s=ea(ea(ea(q*j)+ea(h*n))+ea(p*ea(g[b+8>>2])));n=ea(g[b+16>>2]);j=ea(g[b+20>>2]);t=ea(s+ea(ea(ea(k*n)+ea(l*j))+ea(m*ea(g[b+24>>2]))));j=ea(g[b+32>>2]);n=ea(g[b+36>>2]);s=ea(ea(ea(q*j)+ea(h*n))+ea(p*ea(g[b+40>>2])));n=ea(g[b+48>>2]);j=ea(g[b+52>>2]);u=ea(s+ea(ea(ea(k*n)+ea(l*j))+ea(m*ea(g[b+56>>2]))));j=ea(g[b+64>>2]);n=ea(g[b+68>>2]);s=ea(ea(ea(q*j)+ea(h*n))+ea(p*ea(g[b+72>>2])));n=ea(g[b+80>>2]);j=ea(g[b+84>>2]);v=ea(i+t);t=ea(r+u);u=ea(o+ea(s+ea(ea(ea(k*n)+ea(l*j))+ea(m*ea(g[b+88>>2])))));j=ea(g[c+16>>2]);n=ea(g[c+20>>2]);s=ea(g[c+24>>2]);o=ea(h-ea(ea(v*s)-ea(j*u)));h=ea(p-ea(ea(t*j)-ea(v*n)));j=ea(k-v);v=ea(l-t);l=ea(m-u);g[a>>2]=ea(q-ea(ea(n*u)-ea(t*s)));g[a+4>>2]=o;g[a+8>>2]=h;g[a+12>>2]=ea(0.0);g[a+16>>2]=j;g[a+20>>2]=v;g[a+24>>2]=l;g[a+28>>2]=ea(0.0);return}function _1a(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0,t=0;e=i;if(d){f=c[d+32>>2]|0;c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];if(f){h=0;j=d+48|0;while(1){a[b+h+48>>0]=h;d=j+16|0;k=c[j>>2]|0;l=b+(h*400|0)+448|0;c[l>>2]=k;if(k){m=0;do{n=d+(m*48|0)|0;o=ea(g[n>>2]);p=ea(g[n+4>>2]);q=ea(g[n+8>>2]);g[b+(h*400|0)+(m<<6)+64>>2]=o;g[b+(h*400|0)+(m<<6)+68>>2]=p;g[b+(h*400|0)+(m<<6)+72>>2]=q;g[b+(h*400|0)+(m<<6)+76>>2]=ea(0.0);n=d+(m*48|0)+16|0;q=ea(g[n>>2]);p=ea(g[n+4>>2]);o=ea(g[n+8>>2]);g[b+(h*400|0)+(m<<6)+80>>2]=q;g[b+(h*400|0)+(m<<6)+84>>2]=p;g[b+(h*400|0)+(m<<6)+88>>2]=o;g[b+(h*400|0)+(m<<6)+92>>2]=ea(0.0);n=d+(m*48|0)+32|0;o=ea(g[n>>2]);p=ea(g[n+4>>2]);q=ea(g[n+8>>2]);r=ea(g[n+12>>2]);g[b+(h*400|0)+(m<<6)+96>>2]=o;g[b+(h*400|0)+(m<<6)+100>>2]=p;g[b+(h*400|0)+(m<<6)+104>>2]=q;g[b+(h*400|0)+(m<<6)+108>>2]=r;c[b+(h*400|0)+(m<<6)+112>>2]=c[d+(m*48|0)+12>>2];m=m+1|0}while(m>>>0<(c[l>>2]|0)>>>0)}h=h+1|0;if((h|0)==(f|0))break;else j=j+((k*48|0)+16)|0}a[b+52>>0]=f;if(f>>>0<4)s=f;else{i=e;return}}else t=8}else{g[b+16>>2]=ea(3402823469999999843913219.0e14);g[b+20>>2]=ea(3402823469999999843913219.0e14);g[b+24>>2]=ea(3402823469999999843913219.0e14);g[b+28>>2]=ea(0.0);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);g[b+12>>2]=ea(1.0);t=8}if((t|0)==8){a[b+52>>0]=0;s=0}do{a[b+s+48>>0]=s;s=s+1|0}while((s|0)!=4);i=e;return}function $1a(d,e,f,h,j,k){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=0,R=Im,T=Im,U=0;l=i;if(!e){m=1;i=l;return m|0}n=ea(-ea(g[h>>2]));o=ea(-ea(g[h+4>>2]));p=ea(-ea(g[h+8>>2]));q=ea(g[h+12>>2]);r=ea(g[j+16>>2]);s=ea(r-ea(g[h+16>>2]));r=ea(g[j+20>>2]);t=ea(r-ea(g[h+20>>2]));r=ea(g[j+24>>2]);u=ea(s*ea(2.0));s=ea(t*ea(2.0));t=ea(ea(r-ea(g[h+24>>2]))*ea(2.0));r=ea(ea(q*q)+ea(-.5));v=ea(ea(ea(u*n)+ea(s*o))+ea(t*p));w=ea(ea(v*n)+ea(ea(r*u)+ea(q*ea(ea(t*o)-ea(s*p)))));x=ea(ea(v*o)+ea(ea(r*s)+ea(q*ea(ea(u*p)-ea(t*n)))));y=ea(ea(ea(r*t)+ea(q*ea(ea(s*n)-ea(u*o))))+ea(v*p));v=ea(g[j>>2]);u=ea(q*v);s=ea(g[j+12>>2]);t=ea(u+ea(s*n));u=ea(g[j+8>>2]);r=ea(t+ea(u*o));t=ea(g[j+4>>2]);z=ea(r-ea(t*p));r=ea(ea(ea(v*p)+ea(ea(s*o)+ea(q*t)))-ea(u*n));A=ea(ea(ea(t*n)+ea(ea(s*p)+ea(q*u)))-ea(v*o));B=ea(ea(ea(ea(q*s)-ea(v*n))-ea(t*o))-ea(u*p));if(!f){m=1;i=l;return m|0}p=ea(ea(B*B)+ea(-.5));j=d+4232|0;h=f;f=e;a:while(1){h=h+-1|0;e=f+96|0;do if((((a[f>>0]|0)==0?(C=f+16|0,D=b[C>>1]|0,D<<16>>16!=0):0)?(E=f+24|0,u=ea(g[E>>2]),F=f+28|0,o=ea(g[F>>2]),G=f+32|0,t=ea(g[G>>2]),H=f+36|0,n=ea(ea(g[H>>2])*ea(2.0)),I=f+40|0,v=ea(ea(g[I>>2])*ea(2.0)),J=f+44|0,s=ea(ea(g[J>>2])*ea(2.0)),q=ea(ea(ea(z*n)+ea(r*v))+ea(A*s)),ea(ea(t*ea(ea(ea(p*s)+ea(B*ea(ea(z*v)-ea(r*n))))+ea(A*q)))+ea(ea(u*ea(ea(z*q)+ea(ea(p*n)+ea(B*ea(ea(r*s)-ea(A*v))))))+ea(o*ea(ea(r*q)+ea(ea(p*v)+ea(B*ea(ea(A*n)-ea(z*s))))))))>ea(.999000012)):0)?(K=f+48|0,s=ea(g[K>>2]),L=f+52|0,n=ea(g[L>>2]),M=f+56|0,v=ea(g[M>>2]),N=f+72|0,q=ea(g[N>>2]),O=f+76|0,P=ea(g[O>>2]),Q=f+80|0,R=ea(q*ea(2.0)),q=ea(P*ea(2.0)),P=ea(ea(g[Q>>2])*ea(2.0)),T=ea(ea(ea(z*R)+ea(r*q))+ea(A*P)),ea(S(ea(ea(t*ea(v-ea(y+ea(ea(ea(p*P)+ea(B*ea(ea(z*q)-ea(r*R))))+ea(A*T)))))+ea(ea(u*ea(s-ea(w+ea(ea(z*T)+ea(ea(p*R)+ea(B*ea(ea(r*P)-ea(A*q))))))))+ea(o*ea(n-ea(x+ea(ea(r*T)+ea(ea(p*q)+ea(B*ea(ea(A*R)-ea(z*P))))))))))))<k):0){if(D<<16>>16==2?(P=ea(g[f+60>>2]),R=ea(g[f+64>>2]),q=ea(g[f+68>>2]),T=ea(g[f+84>>2]),n=ea(g[f+88>>2]),s=ea(T*ea(2.0)),T=ea(n*ea(2.0)),n=ea(ea(g[f+92>>2])*ea(2.0)),v=ea(ea(ea(z*s)+ea(r*T))+ea(A*n)),!(ea(S(ea(ea(t*ea(q-ea(y+ea(ea(ea(p*n)+ea(B*ea(ea(z*T)-ea(r*s))))+ea(A*v)))))+ea(ea(u*ea(P-ea(w+ea(ea(z*v)+ea(ea(p*s)+ea(B*ea(ea(r*n)-ea(A*T))))))))+ea(o*ea(R-ea(x+ea(ea(r*v)+ea(ea(p*T)+ea(B*ea(ea(A*s)-ea(z*n))))))))))))<k)):0)break;D=c[j>>2]|0;if((D|0)==32){m=0;U=13;break a}b[d+(D<<2)+4100>>1]=-1;b[d+(c[j>>2]<<2)+4102>>1]=-1;D=c[j>>2]|0;c[j>>2]=D+1;a[d+(D*96|0)+768>>0]=a[f>>0]|0;b[d+(D*96|0)+784>>1]=b[C>>1]|0;g[d+(D*96|0)+792>>2]=ea(g[E>>2]);g[d+(D*96|0)+796>>2]=ea(g[F>>2]);g[d+(D*96|0)+800>>2]=ea(g[G>>2]);g[d+(D*96|0)+804>>2]=ea(g[H>>2]);g[d+(D*96|0)+808>>2]=ea(g[I>>2]);g[d+(D*96|0)+812>>2]=ea(g[J>>2]);g[d+(D*96|0)+816>>2]=ea(g[K>>2]);g[d+(D*96|0)+820>>2]=ea(g[L>>2]);g[d+(D*96|0)+824>>2]=ea(g[M>>2]);g[d+(D*96|0)+828>>2]=ea(g[f+60>>2]);g[d+(D*96|0)+832>>2]=ea(g[f+64>>2]);g[d+(D*96|0)+836>>2]=ea(g[f+68>>2]);g[d+(D*96|0)+840>>2]=ea(g[N>>2]);g[d+(D*96|0)+844>>2]=ea(g[O>>2]);g[d+(D*96|0)+848>>2]=ea(g[Q>>2]);g[d+(D*96|0)+852>>2]=ea(g[f+84>>2]);g[d+(D*96|0)+856>>2]=ea(g[f+88>>2]);g[d+(D*96|0)+860>>2]=ea(g[f+92>>2]);b[d+(D*96|0)+788>>1]=b[f+20>>1]|0;b[d+(D*96|0)+786>>1]=b[f+18>>1]|0;b[d+(D*96|0)+790>>1]=b[f+22>>1]|0}while(0);if(!h){m=1;U=13;break}else f=e}if((U|0)==13){i=l;return m|0}return 0}function a2a(a,d,e,f,g,h,j){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;k=c[d+8728>>2]|0;l=b[a+22>>1]|0;if(k)if(!(l&24)){a=0;m=0;n=0;o=0;while(1){p=((c[d+(m<<2)+8464>>2]|0)!=65535&1)+n|0;q=c[d+(m<<2)+8336>>2]|0;if(q){r=o+32+(q*96|0)|0;s=q+a|0;if(!(b[d+(m*96|0)+5286>>1]&1)){q=b[d+(m*96|0)+5280>>1]|0;t=((q&65535)<<1)+s|0;u=((q&65535)*192|0)+r|0}else{t=s;u=r}}else{t=a;u=o}m=m+1|0;if(m>>>0>=k>>>0){v=t;w=p;x=u;break}else{a=t;n=p;o=u}}}else{u=0;o=0;n=0;t=0;while(1){a=((c[d+(o<<2)+8464>>2]|0)!=65535&1)+n|0;m=c[d+(o<<2)+8336>>2]|0;if(m){p=t+32+(m<<7)|0;r=m+u|0;if(!(b[d+(o*96|0)+5286>>1]&1)){m=b[d+(o*96|0)+5280>>1]|0;y=((m&65535)<<1)+r|0;z=((m&65535)<<8)+p|0}else{y=r;z=p}}else{y=u;z=t}o=o+1|0;if(o>>>0>=k>>>0){v=y;w=a;x=z;break}else{u=y;n=a;t=z}}}else{v=0;w=0;x=0}c[h>>2]=w;c[j>>2]=v;c[g>>2]=w*96;c[f>>2]=(l&130)==0?0:x+15&-16;i=e;return}function b2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?501672:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function c2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?489680:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function d2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?501672:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function e2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)b2a(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function f2a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(qTa()|0)>>2]|0;if(e){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=Bn[g&255](f,e,j?544576:544544,544464,111)|0;c[b>>2]=h;if(h)mTa(h)}else c[b>>2]=0;c[b+272>>2]=0;a[b+264>>0]=1;c[b+268>>2]=b+8;c[b+276>>2]=64;c[b+280>>2]=512;c[b+284>>2]=0;c[b+288>>2]=0;c[b+292>>2]=4096;c[b+296>>2]=0;c[b+568>>2]=0;a[b+560>>0]=1;c[b+564>>2]=b+304;c[b+572>>2]=64;c[b+576>>2]=256;c[b+580>>2]=0;c[b+584>>2]=0;c[b+588>>2]=4096;c[b+592>>2]=0;c[b+864>>2]=0;a[b+856>>0]=1;c[b+860>>2]=b+600;c[b+868>>2]=64;c[b+872>>2]=128;c[b+876>>2]=0;c[b+880>>2]=0;c[b+884>>2]=4096;c[b+888>>2]=0;i=d;return}function g2a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)pEb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function h2a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)qEb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function i2a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)rEb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function j2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+28|0;f=(c[b>>2]|0)==-1;h=a+16|0;j=c[h>>2]|0;k=ea(e>>>0);l=~~ea(k*ea(g[a+24>>2]))>>>0;m=e<<2;n=l<<2;o=n+m|0;p=(0-o&12)+o|0;o=UJa(a,p+n|0,529024,354)|0;n=o+m|0;q=o+p|0;PEi(o|0,-1,m|0)|0;if(!f){f=a+8|0;YEi(n|0,c[f>>2]|0,c[h>>2]<<2|0)|0;m=a+20|0;p=c[m>>2]|0;if(!p){r=f;s=m}else{t=a+4|0;u=e+-1|0;v=c[a+12>>2]|0;w=p;p=0;while(1){x=c[v+(p<<2)>>2]|0;if((x|0)==-1)y=w;else{z=c[t>>2]|0;A=x;do{x=z+(A<<2)|0;B=c[x>>2]|0;C=B+~(B<<15)|0;B=(C>>>10^C)*9|0;C=B>>>6^B;B=C+~(C<<11)|0;C=o+(((B>>>16^B)&u)<<2)|0;c[n+(A<<2)>>2]=c[C>>2];c[C>>2]=A;C=q+(A<<2)|0;if(C)c[C>>2]=c[x>>2];A=c[(c[f>>2]|0)+(A<<2)>>2]|0}while((A|0)!=-1);y=c[m>>2]|0}p=p+1|0;if(p>>>0>=y>>>0){r=f;s=m;break}else w=y}}}else{y=a+36|0;if(c[y>>2]|0){w=c[a+4>>2]|0;m=e+-1|0;f=0;do{p=w+(f<<2)|0;u=c[p>>2]|0;t=u+~(u<<15)|0;u=(t>>>10^t)*9|0;t=u>>>6^u;u=t+~(t<<11)|0;t=o+(((u>>>16^u)&m)<<2)|0;c[n+(f<<2)>>2]=c[t>>2];c[t>>2]=f;t=q+(f<<2)|0;if(t)c[t>>2]=c[p>>2];f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}r=a+8|0;s=a+20|0}VJa(a,c[a>>2]|0);c[a>>2]=o;c[a+12>>2]=o;c[s>>2]=e;c[r>>2]=n;c[a+4>>2]=q;c[h>>2]=l;h=l+-1|0;if(h>>>0>j>>>0)D=j;else{E=c[b>>2]|0;F=n+(h<<2)|0;c[F>>2]=E;c[b>>2]=j;i=d;return}do{l=D;D=D+1|0;c[n+(l<<2)>>2]=D}while((D|0)!=(h|0));E=c[b>>2]|0;F=n+(h<<2)|0;c[F>>2]=E;c[b>>2]=j;i=d;return}function k2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=k+~(k<<15)|0;m=(l>>>10^l)*9|0;l=m>>>6^m;m=l+~(l<<11)|0;l=(m>>>16^m)&h+-1;m=c[(c[b+12>>2]|0)+(l<<2)>>2]|0;if((m|0)==-1)n=l;else{o=c[b+4>>2]|0;p=b+8|0;q=m;while(1){r=o+(q<<2)|0;if((c[r>>2]|0)==(k|0))break;q=c[(c[p>>2]|0)+(q<<2)>>2]|0;if((q|0)==-1){n=l;break a}}a[e>>0]=1;s=r;i=f;return s|0}}else n=0;while(0);a[e>>0]=0;e=b+28|0;r=c[e>>2]|0;if((r|0)==-1){l=j?16:h<<1;if(h>>>0<l>>>0){j2a(b,l);t=c[e>>2]|0;u=c[g>>2]|0}else{t=-1;u=h}h=c[d>>2]|0;d=h+~(h<<15)|0;h=(d>>>10^d)*9|0;d=h>>>6^h;h=d+~(d<<11)|0;v=t;w=(h>>>16^h)&u+-1}else{v=r;w=n}n=(c[b+8>>2]|0)+(v<<2)|0;c[e>>2]=c[n>>2];e=(c[b+12>>2]|0)+(w<<2)|0;c[n>>2]=c[e>>2];c[e>>2]=v;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(v<<2)|0;i=f;return s|0}function l2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?502560:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function m2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=Im,f=Im,h=Im,i=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;e=ea(g[b+16>>2]);f=ea(g[b+20>>2]);h=ea(g[b+24>>2]);g[a+16>>2]=e;g[a+20>>2]=f;g[a+24>>2]=h;g[a+28>>2]=ea(0.0);h=ea(ea(g[c+4>>2])*d);f=ea(ea(g[c+8>>2])*d);e=ea(ea(g[c+12>>2])*d);g[a>>2]=h;c=a+4|0;g[c>>2]=f;i=a+8|0;g[i>>2]=e;g[a+12>>2]=ea(0.0);e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);d=ea(g[b+12>>2]);j=ea(e+e);k=ea(f+f);l=ea(h+h);m=ea(f*k);n=ea(h*l);o=ea(j*f);f=ea(j*h);p=ea(j*d);q=ea(k*h);h=ea(k*d);k=ea(l*d);d=ea(ea(ea(1.0)-m)-n);l=ea(o+k);r=ea(f-h);s=ea(o-k);k=ea(ea(1.0)-ea(e*j));j=ea(k-n);n=ea(q+p);e=ea(f+h);h=ea(q-p);p=ea(k-m);g[a+32>>2]=d;g[a+36>>2]=s;g[a+40>>2]=e;g[a+44>>2]=ea(0.0);g[a+48>>2]=l;g[a+52>>2]=j;g[a+56>>2]=h;g[a+60>>2]=ea(0.0);g[a+64>>2]=r;g[a+68>>2]=n;g[a+72>>2]=p;g[a+76>>2]=ea(0.0);m=ea(-d);k=ea(-s);q=ea(-e);f=ea((d>m?d:m)+ea(9.99999997e-07));m=ea((s>k?s:k)+ea(9.99999997e-07));k=ea((e>q?e:q)+ea(9.99999997e-07));q=ea(-l);e=ea(-j);s=ea(-h);d=ea((l>q?l:q)+ea(9.99999997e-07));q=ea((j>e?j:e)+ea(9.99999997e-07));e=ea((h>s?h:s)+ea(9.99999997e-07));s=ea(-r);h=ea(-n);j=ea(-p);l=ea((r>s?r:s)+ea(9.99999997e-07));s=ea((n>h?n:h)+ea(9.99999997e-07));h=ea((p>j?p:j)+ea(9.99999997e-07));g[a+80>>2]=f;g[a+84>>2]=m;g[a+88>>2]=k;g[a+92>>2]=ea(0.0);g[a+96>>2]=d;g[a+100>>2]=q;g[a+104>>2]=e;g[a+108>>2]=ea(0.0);g[a+112>>2]=l;g[a+116>>2]=s;g[a+120>>2]=h;g[a+124>>2]=ea(0.0);j=ea(g[a>>2]);p=ea(g[c>>2]);n=ea(g[i>>2]);r=ea(ea(ea(j*d)+ea(p*q))+ea(n*e));o=ea(ea(ea(j*l)+ea(p*s))+ea(n*h));g[a+128>>2]=ea(ea(ea(j*f)+ea(p*m))+ea(n*k));g[a+132>>2]=r;g[a+136>>2]=o;g[a+140>>2]=ea(0.0);o=ea(ea(n*f)+ea(j*k));r=ea(ea(p*f)+ea(j*m));g[a+144>>2]=ea(ea(n*m)+ea(p*k));g[a+148>>2]=o;g[a+152>>2]=r;g[a+156>>2]=ea(0.0);r=ea(ea(n*d)+ea(j*e));o=ea(ea(p*d)+ea(j*q));g[a+160>>2]=ea(ea(n*q)+ea(p*e));g[a+164>>2]=r;g[a+168>>2]=o;g[a+172>>2]=ea(0.0);o=ea(ea(n*l)+ea(j*h));r=ea(ea(p*l)+ea(j*s));g[a+176>>2]=ea(ea(n*s)+ea(p*h));g[a+180>>2]=o;g[a+184>>2]=r;g[a+188>>2]=ea(0.0);return}function n2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=i;i=i+1104|0;h=a+48|0;j=a+32|0;l=a+72|0;m=a+16|0;n=a;o=a+64|0;p=c[d+4>>2]|0;c[l>>2]=p;q=m+4|0;r=m+8|0;s=m+12|0;t=n+4|0;u=n+8|0;v=n+12|0;w=1;a:while(1){x=w+-1|0;y=c[l+(x<<2)>>2]|0;z=ea(g[y>>2]);A=ea(g[y+4>>2]);B=ea(g[y+8>>2]);C=ea((c[k>>2]=c[y+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));D=(g[k>>2]=z,c[k>>2]|0);E=(g[k>>2]=A,c[k>>2]|0);F=ea(ea(D&255|0)*C);G=ea(ea(E&255|0)*C);H=ea(ea((g[k>>2]=B,c[k>>2]|0)&255|0)*C);g[m>>2]=z;g[q>>2]=A;g[r>>2]=B;g[s>>2]=ea(0.0);g[n>>2]=F;g[t>>2]=G;g[u>>2]=H;g[v>>2]=ea(0.0);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];b:do if(yEb(e,j,h)|0){E=y;D=x;while(1){I=E+16|0;J=c[I>>2]|0;K=c[I+4>>2]|0;if(!((J&1|0)==0&0==0))break;I=VEi(J|0,K|0,21)|0;L=I&524287;E=p+(L*24|0)|0;I=D+1|0;c[l+(D<<2)>>2]=p+((L+1|0)*24|0);H=ea(g[E>>2]);G=ea(g[p+(L*24|0)+4>>2]);F=ea(g[p+(L*24|0)+8>>2]);B=ea((c[k>>2]=c[p+(L*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));L=(g[k>>2]=H,c[k>>2]|0);M=(g[k>>2]=G,c[k>>2]|0);A=ea(ea(L&255|0)*B);z=ea(ea(M&255|0)*B);C=ea(ea((g[k>>2]=F,c[k>>2]|0)&255|0)*B);g[m>>2]=H;g[q>>2]=G;g[r>>2]=F;g[s>>2]=ea(0.0);g[n>>2]=A;g[t>>2]=z;g[u>>2]=C;g[v>>2]=ea(0.0);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];if(!(yEb(e,j,h)|0)){N=I;break b}else D=I}E=c[d>>2]|0;I=VEi(J|0,K|0,21)|0;if(kn[c[c[f>>2]>>2]&511](f,o,b+(c[E+((I&524287)<<2)>>2]<<3)|0,1)|0)N=D;else{O=0;P=7;break a}}else N=x;while(0);if(!N){O=1;P=7;break}else w=N}if((P|0)==7){i=a;return O|0}return 0}function o2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;var f=0,h=Im,j=0,k=Im,l=0,m=Im,n=Im,o=0,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;f=i;h=ea(g[b>>2]);j=b+4|0;k=ea(g[j>>2]);l=b+8|0;m=ea(g[l>>2]);g[a>>2]=h;g[a+4>>2]=k;g[a+8>>2]=m;g[a+12>>2]=ea(0.0);n=ea(g[c>>2]);o=c+4|0;p=ea(g[o>>2]);q=c+8|0;r=ea(g[q>>2]);g[a+16>>2]=n;g[a+20>>2]=p;g[a+24>>2]=r;g[a+28>>2]=ea(0.0);g[a+32>>2]=p;g[a+36>>2]=r;g[a+40>>2]=n;g[a+44>>2]=ea(0.0);s=ea(g[e>>2]);t=ea(g[e+4>>2]);u=ea(g[e+8>>2]);g[a+48>>2]=s;g[a+52>>2]=t;g[a+56>>2]=u;g[a+60>>2]=ea(0.0);u=ea(-n);t=ea(-p);s=ea(-r);v=n>u?n:u;u=p>t?p:t;t=r>s?r:s;g[a+64>>2]=v;g[a+68>>2]=u;g[a+72>>2]=t;g[a+76>>2]=ea(0.0);g[a+80>>2]=u;g[a+84>>2]=t;g[a+88>>2]=v;g[a+92>>2]=ea(0.0);e=!(d>=ea(3402823469999999843913219.0e14));v=ea(g[c>>2]);do if(!e){if(v==ea(0.0))w=ea(g[b>>2]);else{c=v>=ea(0.0);w=c?ea(3402823469999999843913219.0e14):ea(-3402823469999999843913219.0e14)}t=ea(g[o>>2]);if(t==ea(0.0))x=ea(g[j>>2]);else{c=t>=ea(0.0);x=c?ea(3402823469999999843913219.0e14):ea(-3402823469999999843913219.0e14)}t=ea(g[q>>2]);if(t==ea(0.0)){y=w;z=x;A=ea(g[l>>2]);break}else{c=t>=ea(0.0);y=w;z=x;A=c?ea(3402823469999999843913219.0e14):ea(-3402823469999999843913219.0e14);break}}else{t=ea(v*d);u=ea(ea(g[o>>2])*d);s=ea(ea(g[q>>2])*d);r=ea(t+ea(g[b>>2]));t=ea(u+ea(g[j>>2]));y=r;z=t;A=ea(s+ea(g[l>>2]))}while(0);g[a+96>>2]=h<y?h:y;g[a+100>>2]=k<z?k:z;g[a+104>>2]=m<A?m:A;g[a+108>>2]=ea(0.0);g[a+112>>2]=h>y?h:y;g[a+116>>2]=k>z?k:z;g[a+120>>2]=m>A?m:A;g[a+124>>2]=ea(0.0);i=f;return}
function p2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=i;i=i+1104|0;h=a+48|0;j=a+32|0;l=a+16|0;m=a+72|0;n=a;o=a+64|0;p=c[d+4>>2]|0;c[m>>2]=p;q=n+4|0;r=n+8|0;s=n+12|0;t=l+4|0;u=l+8|0;v=l+12|0;w=1;a:while(1){x=w+-1|0;y=c[m+(x<<2)>>2]|0;z=ea(g[y>>2]);A=ea(g[y+4>>2]);B=ea(g[y+8>>2]);C=ea((c[k>>2]=c[y+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));D=(g[k>>2]=z,c[k>>2]|0);E=(g[k>>2]=A,c[k>>2]|0);F=ea(ea(E&255|0)*C);G=ea(ea((g[k>>2]=B,c[k>>2]|0)&255|0)*C);g[n>>2]=ea(ea(D&255|0)*C);g[q>>2]=F;g[r>>2]=G;g[s>>2]=ea(0.0);g[l>>2]=z;g[t>>2]=A;g[u>>2]=B;g[v>>2]=ea(0.0);c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];b:do if(zEb(e,j,h)|0){D=y;E=x;while(1){H=D+16|0;I=c[H>>2]|0;J=c[H+4>>2]|0;if(!((I&1|0)==0&0==0))break;H=VEi(I|0,J|0,21)|0;K=H&524287;D=p+(K*24|0)|0;H=E+1|0;c[m+(E<<2)>>2]=p+((K+1|0)*24|0);B=ea(g[D>>2]);A=ea(g[p+(K*24|0)+4>>2]);z=ea(g[p+(K*24|0)+8>>2]);G=ea((c[k>>2]=c[p+(K*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));K=(g[k>>2]=B,c[k>>2]|0);L=(g[k>>2]=A,c[k>>2]|0);F=ea(ea(L&255|0)*G);C=ea(ea((g[k>>2]=z,c[k>>2]|0)&255|0)*G);g[n>>2]=ea(ea(K&255|0)*G);g[q>>2]=F;g[r>>2]=C;g[s>>2]=ea(0.0);g[l>>2]=B;g[t>>2]=A;g[u>>2]=z;g[v>>2]=ea(0.0);c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];if(!(zEb(e,j,h)|0)){M=H;break b}else E=H}D=c[d>>2]|0;H=VEi(I|0,J|0,21)|0;if(kn[c[c[f>>2]>>2]&511](f,o,b+(c[D+((H&524287)<<2)>>2]<<3)|0,1)|0)M=E;else{N=0;O=7;break a}}else M=x;while(0);if(!M){N=1;O=7;break}else w=M}if((O|0)==7){i=a;return N|0}return 0}function q2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=0,S=0;a=i;i=i+1040|0;h=a+8|0;j=a;l=c[d+4>>2]|0;c[h>>2]=l;m=e+4|0;n=e+8|0;o=e+16|0;p=1;while(1){q=p+-1|0;r=c[h+(q<<2)>>2]|0;s=ea(g[r>>2]);t=ea(g[r+4>>2]);u=ea(g[r+8>>2]);v=ea((c[k>>2]=c[r+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));w=(g[k>>2]=s,c[k>>2]|0);x=(g[k>>2]=t,c[k>>2]|0);y=ea(ea(w&255|0)*v);z=ea(ea(x&255|0)*v);A=ea(ea((g[k>>2]=u,c[k>>2]|0)&255|0)*v);v=ea(g[e>>2]);B=ea(g[m>>2]);C=ea(g[n>>2]);D=ea(g[o>>2]);E=s;s=t;t=u;u=y;y=z;z=A;x=r;r=q;while(1){A=ea(v-E);F=ea(B-s);G=ea(C-t);H=ea(-u);I=ea(-y);J=ea(-z);K=A<u?A:u;L=F<y?F:y;M=G<z?G:z;N=ea(A-(K>H?K:H));H=ea(F-(L>I?L:I));I=ea(G-(M>J?M:J));if(!(D>=ea(ea(ea(N*N)+ea(H*H))+ea(I*I))))break;q=x+16|0;O=c[q>>2]|0;P=c[q+4>>2]|0;if(!((O&1|0)==0&0==0)){Q=5;break}q=VEi(O|0,P|0,21)|0;w=q&524287;q=l+(w*24|0)|0;c[h+(r<<2)>>2]=l+((w+1|0)*24|0);I=ea(g[q>>2]);H=ea(g[l+(w*24|0)+4>>2]);N=ea(g[l+(w*24|0)+8>>2]);J=ea((c[k>>2]=c[l+(w*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));w=(g[k>>2]=I,c[k>>2]|0);R=(g[k>>2]=H,c[k>>2]|0);E=I;s=H;t=N;u=ea(ea(w&255|0)*J);y=ea(ea(R&255|0)*J);z=ea(ea((g[k>>2]=N,c[k>>2]|0)&255|0)*J);x=q;r=r+1|0}if((Q|0)==5?(Q=0,x=c[d>>2]|0,q=VEi(O|0,P|0,21)|0,!(kn[c[c[f>>2]>>2]&511](f,j,b+(c[x+((q&524287)<<2)>>2]<<3)|0,1)|0)):0){S=0;Q=8;break}if(!r){S=1;Q=8;break}else p=r}if((Q|0)==8){i=a;return S|0}return 0}function r2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=0,U=0,V=0;a=i;i=i+1040|0;h=a+8|0;j=a;l=c[d+4>>2]|0;c[h>>2]=l;m=e+16|0;n=e+20|0;o=e+24|0;p=e+4|0;q=e+8|0;r=1;while(1){s=r+-1|0;t=c[h+(s<<2)>>2]|0;u=ea(g[t>>2]);v=ea(g[t+4>>2]);w=ea(g[t+8>>2]);x=ea((c[k>>2]=c[t+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));y=(g[k>>2]=u,c[k>>2]|0);z=(g[k>>2]=v,c[k>>2]|0);A=ea(ea(y&255|0)*x);B=ea(ea(z&255|0)*x);C=ea(ea((g[k>>2]=w,c[k>>2]|0)&255|0)*x);x=ea(g[m>>2]);D=ea(g[n>>2]);E=ea(g[o>>2]);F=ea(g[e>>2]);G=ea(g[p>>2]);H=ea(g[q>>2]);I=A;A=B;B=C;C=u;u=v;v=w;z=t;t=s;while(1){w=ea(I+x);J=ea(A+D);K=ea(B+E);L=ea(C-F);M=ea(u-G);N=ea(v-H);O=ea(-L);P=ea(-M);Q=ea(-N);if(!((w>=(L>O?L:O)?J>=(M>P?M:P):0)&K>=(N>Q?N:Q)))break;s=z+16|0;R=c[s>>2]|0;S=c[s+4>>2]|0;if(!((R&1|0)==0&0==0)){T=5;break}s=VEi(R|0,S|0,21)|0;y=s&524287;s=l+(y*24|0)|0;c[h+(t<<2)>>2]=l+((y+1|0)*24|0);Q=ea(g[s>>2]);N=ea(g[l+(y*24|0)+4>>2]);K=ea(g[l+(y*24|0)+8>>2]);P=ea((c[k>>2]=c[l+(y*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));y=(g[k>>2]=Q,c[k>>2]|0);U=(g[k>>2]=N,c[k>>2]|0);I=ea(ea(y&255|0)*P);A=ea(ea(U&255|0)*P);B=ea(ea((g[k>>2]=K,c[k>>2]|0)&255|0)*P);C=Q;u=N;v=K;z=s;t=t+1|0}if((T|0)==5?(T=0,z=c[d>>2]|0,s=VEi(R|0,S|0,21)|0,!(kn[c[c[f>>2]>>2]&511](f,j,b+(c[z+((s&524287)<<2)>>2]<<3)|0,1)|0)):0){V=0;T=8;break}if(!t){V=1;T=8;break}else r=t}if((T|0)==8){i=a;return V|0}return 0}function s2a(a,b,d,e,f,h,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=Im,Ma=Im,Na=0,Oa=0,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=Im,bb=Im,cb=Im,db=0,eb=0,fb=0,gb=0,hb=0;a=i;i=i+1168|0;m=a;n=a+136|0;o=a+128|0;o2a(m,e,f,ea(g[h>>2]),j);j=c[d+4>>2]|0;c[n>>2]=j;f=m+48|0;e=m+52|0;p=m+56|0;q=m+4|0;r=m+8|0;s=m+32|0;t=m+36|0;u=m+40|0;v=m+16|0;w=m+20|0;x=m+24|0;y=m+80|0;z=m+84|0;A=m+64|0;B=m+68|0;C=m+96|0;D=m+100|0;E=m+112|0;F=m+116|0;G=m+72|0;H=m+88|0;I=m+120|0;J=m+104|0;K=m+108|0;L=m+124|0;M=j;N=0;a:while(1){O=ea(g[M>>2]);P=ea(g[M+4>>2]);Q=ea(g[M+8>>2]);R=ea((c[k>>2]=c[M+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));S=(g[k>>2]=O,c[k>>2]|0);T=(g[k>>2]=P,c[k>>2]|0);U=ea(ea(S&255|0)*R);V=ea(ea(T&255|0)*R);W=ea(ea((g[k>>2]=Q,c[k>>2]|0)&255|0)*R);R=ea(g[f>>2]);X=ea(g[e>>2]);Y=ea(g[p>>2]);Z=ea(R+U);U=ea(X+V);V=ea(Y+W);W=ea(O+Z);_=ea(P+U);$=ea(O-Z);aa=ea(P-U);ba=ea(g[m>>2]);ca=ea(g[q>>2]);da=ea(g[r>>2]);fa=ea(ba-O);O=ea(ca-P);P=ea(da-Q);ga=ea(g[s>>2]);ha=ea(g[t>>2]);ia=ea(g[u>>2]);ja=ea(g[v>>2]);ka=ea(g[w>>2]);la=ea(g[x>>2]);ma=ea(ea(O*ja)-ea(fa*ga));na=ea(ea(P*ka)-ea(O*ha));O=ea(ea(fa*la)-ea(P*ia));P=ea(g[y>>2]);fa=ea(g[z>>2]);oa=ea(g[A>>2]);pa=ea(g[B>>2]);qa=ea(ea(Z*P)+ea(U*oa));ra=ea(ea(U*fa)+ea(V*pa));U=ea(g[C>>2]);sa=ea(g[D>>2]);ta=ea(g[E>>2]);ua=ea(g[F>>2]);va=ea(-ma);wa=ea(-na);xa=ea(-O);b:do if(qa>=(ma>va?ma:va)&(ta>=$&W>=U)&(ra>=(na>wa?na:wa)&(ua>=aa&_>=sa))?(ya=ea(g[G>>2]),za=ea(g[H>>2]),Aa=ea(V*za),Ba=ea(Z*ya),Ca=ea(Ba+Aa),Aa=ea(g[I>>2]),Ba=ea(Q-V),Da=ea(Q+V),Ea=ea(g[J>>2]),Ca>=(O>xa?O:xa)&(Aa>=Ba&Da>=Ea)):0){Da=ea(g[h>>2]);g[o>>2]=Da;T=M;S=N;c:while(1){Fa=T;while(1){Ga=Fa+16|0;Ha=c[Ga>>2]|0;Ia=c[Ga+4>>2]|0;if(!((Ha&1|0)==0&0==0))break c;Ga=VEi(Ha|0,Ia|0,21)|0;Ja=Ga&524287;Ga=j+(Ja*24|0)|0;Ka=ea(g[Ga>>2]);La=ea(g[j+(Ja*24|0)+4>>2]);Ma=ea(g[j+(Ja*24|0)+8>>2]);Ba=ea((c[k>>2]=c[j+(Ja*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));Na=(g[k>>2]=Ka,c[k>>2]|0);Oa=(g[k>>2]=La,c[k>>2]|0);Ca=ea(R+ea(ea(Na&255|0)*Ba));Pa=ea(X+ea(ea(Oa&255|0)*Ba));Qa=ea(Y+ea(ea((g[k>>2]=Ma,c[k>>2]|0)&255|0)*Ba));Ba=ea(Ka+Ca);Ra=ea(La+Pa);Sa=ea(Ka-Ca);Ta=ea(La-Pa);Ua=ea(ba-Ka);Va=ea(ca-La);Wa=ea(da-Ma);Xa=ea(ea(Va*ja)-ea(Ua*ga));Ya=ea(ea(Wa*ka)-ea(Va*ha));Va=ea(ea(Ua*la)-ea(Wa*ia));Wa=ea(ea(Ca*P)+ea(Pa*oa));Ua=ea(ea(Pa*fa)+ea(Qa*pa));Pa=ea(-Xa);Za=ea(-Ya);_a=ea(-Va);if(Wa>=(Xa>Pa?Xa:Pa)&(ta>=Sa&Ba>=U)&(Ua>=(Ya>Za?Ya:Za)&(ua>=Ta&Ra>=sa))){Ra=ea(Qa*za);Ta=ea(Ca*ya);$a=ea(Ta+Ra)>=(Va>_a?Va:_a)&(Aa>=ea(Ma-Qa)&ea(Ma+Qa)>=Ea)}else $a=0;Oa=Ja+1|0;Na=j+(Oa*24|0)|0;ab=ea(g[Na>>2]);bb=ea(g[j+(Oa*24|0)+4>>2]);cb=ea(g[j+(Oa*24|0)+8>>2]);Qa=ea((c[k>>2]=c[j+(Oa*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));Oa=(g[k>>2]=ab,c[k>>2]|0);db=(g[k>>2]=bb,c[k>>2]|0);_a=ea(R+ea(ea(Oa&255|0)*Qa));Va=ea(X+ea(ea(db&255|0)*Qa));Ra=ea(Y+ea(ea((g[k>>2]=cb,c[k>>2]|0)&255|0)*Qa));Qa=ea(ab+_a);Ta=ea(bb+Va);Ca=ea(ab-_a);Za=ea(bb-Va);Ya=ea(ba-ab);Ua=ea(ca-bb);Ba=ea(da-cb);Sa=ea(ea(Ua*ja)-ea(Ya*ga));Pa=ea(ea(Ba*ka)-ea(Ua*ha));Ua=ea(ea(Ya*la)-ea(Ba*ia));Ba=ea(ea(_a*P)+ea(Va*oa));Ya=ea(ea(Va*fa)+ea(Ra*pa));Va=ea(-Sa);Xa=ea(-Pa);Wa=ea(-Ua);if(Ba>=(Sa>Va?Sa:Va)&(ta>=Ca&Qa>=U)&(Ya>=(Pa>Xa?Pa:Xa)&(ua>=Za&Ta>=sa))){Ta=ea(Ra*za);Za=ea(_a*ya);db=ea(Za+Ta)>=(Ua>Wa?Ua:Wa)&(Aa>=ea(cb-Ra)&ea(cb+Ra)>=Ea);if($a&db)break;else eb=db}else eb=0;if($a|eb)Fa=$a?Ga:Na;else{fb=S;break b}}Fa=ea(ea(ea(ea(ab-Ka)*ja)+ea(ea(bb-La)*ka))+ea(ea(cb-Ma)*la))>ea(0.0)&1;c[n+(S<<2)>>2]=j+((Fa+Ja|0)*24|0);T=j+(((Fa^1)+Ja|0)*24|0)|0;S=S+1|0}T=c[d>>2]|0;Fa=VEi(Ha|0,Ia|0,21)|0;if(!(kn[c[c[l>>2]>>2]&511](l,o,b+(c[T+((Fa&524287)<<2)>>2]<<3)|0,1)|0)){gb=0;hb=18;break a}Ea=ea(g[o>>2]);if(Ea<Da){g[h>>2]=Ea;Aa=ea(g[v>>2]);ya=ea(g[w>>2]);za=ea(g[x>>2]);Ra=ea(g[m>>2]);Wa=ea(g[q>>2]);Ua=ea(g[r>>2]);Ta=ea(ea(Ea*Aa)+Ra);Aa=ea(ea(Ea*ya)+Wa);ya=ea(ea(Ea*za)+Ua);g[C>>2]=Ra<Ta?Ra:Ta;g[D>>2]=Wa<Aa?Wa:Aa;g[J>>2]=Ua<ya?Ua:ya;g[K>>2]=ea(0.0);g[E>>2]=Ra>Ta?Ra:Ta;g[F>>2]=Wa>Aa?Wa:Aa;g[I>>2]=Ua>ya?Ua:ya;g[L>>2]=ea(0.0);fb=S}else fb=S}else fb=N;while(0);Fa=fb+-1|0;if(!fb){gb=1;hb=18;break}M=c[n+(Fa<<2)>>2]|0;N=Fa}if((hb|0)==18){i=a;return gb|0}return 0}function t2a(a,b,d,e,f,h,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=0,_a=0,$a=0,ab=0,bb=0;a=i;i=i+1168|0;m=a;n=a+136|0;o=a+128|0;o2a(m,e,f,ea(g[h>>2]),j);j=c[d+4>>2]|0;c[n>>2]=j;f=m+4|0;e=m+8|0;p=m+32|0;q=m+36|0;r=m+40|0;s=m+16|0;t=m+20|0;u=m+24|0;v=m+80|0;w=m+84|0;x=m+64|0;y=m+68|0;z=m+96|0;A=m+100|0;B=m+112|0;C=m+116|0;D=m+72|0;E=m+88|0;F=m+120|0;G=m+104|0;H=m+108|0;I=m+124|0;J=j;K=0;a:while(1){L=ea(g[J>>2]);M=ea(g[J+4>>2]);N=ea(g[J+8>>2]);O=ea((c[k>>2]=c[J+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));P=(g[k>>2]=L,c[k>>2]|0);Q=(g[k>>2]=M,c[k>>2]|0);R=ea(ea(P&255|0)*O);S=ea(ea(Q&255|0)*O);T=ea(ea((g[k>>2]=N,c[k>>2]|0)&255|0)*O);O=ea(L+R);U=ea(M+S);V=ea(L-R);W=ea(M-S);X=ea(g[m>>2]);Y=ea(g[f>>2]);Z=ea(g[e>>2]);_=ea(X-L);L=ea(Y-M);M=ea(Z-N);$=ea(g[p>>2]);aa=ea(g[q>>2]);ba=ea(g[r>>2]);ca=ea(g[s>>2]);da=ea(g[t>>2]);fa=ea(g[u>>2]);ga=ea(ea(L*ca)-ea(_*$));ha=ea(ea(M*da)-ea(L*aa));L=ea(ea(_*fa)-ea(M*ba));M=ea(g[v>>2]);_=ea(g[w>>2]);ia=ea(g[x>>2]);ja=ea(g[y>>2]);ka=ea(ea(R*M)+ea(S*ia));la=ea(ea(S*_)+ea(T*ja));S=ea(g[z>>2]);ma=ea(g[A>>2]);na=ea(g[B>>2]);oa=ea(g[C>>2]);pa=ea(-ga);qa=ea(-ha);ra=ea(-L);b:do if(ka>=(ga>pa?ga:pa)&(na>=V&O>=S)&(la>=(ha>qa?ha:qa)&(oa>=W&U>=ma))?(sa=ea(g[D>>2]),ta=ea(g[E>>2]),ua=ea(T*ta),va=ea(R*sa),wa=ea(va+ua),ua=ea(g[F>>2]),va=ea(N-T),xa=ea(N+T),ya=ea(g[G>>2]),wa>=(L>ra?L:ra)&(ua>=va&xa>=ya)):0){xa=ea(g[h>>2]);g[o>>2]=xa;Q=J;P=K;c:while(1){za=Q;while(1){Aa=za+16|0;Ba=c[Aa>>2]|0;Ca=c[Aa+4>>2]|0;if(!((Ba&1|0)==0&0==0))break c;Aa=VEi(Ba|0,Ca|0,21)|0;Da=Aa&524287;Aa=j+(Da*24|0)|0;Ea=ea(g[Aa>>2]);Fa=ea(g[j+(Da*24|0)+4>>2]);Ga=ea(g[j+(Da*24|0)+8>>2]);va=ea((c[k>>2]=c[j+(Da*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));Ha=(g[k>>2]=Ea,c[k>>2]|0);Ia=(g[k>>2]=Fa,c[k>>2]|0);wa=ea(ea(Ha&255|0)*va);Ja=ea(ea(Ia&255|0)*va);Ka=ea(ea((g[k>>2]=Ga,c[k>>2]|0)&255|0)*va);va=ea(Ea+wa);La=ea(Fa+Ja);Ma=ea(Ea-wa);Na=ea(Fa-Ja);Oa=ea(X-Ea);Pa=ea(Y-Fa);Qa=ea(Z-Ga);Ra=ea(ea(Pa*ca)-ea(Oa*$));Sa=ea(ea(Qa*da)-ea(Pa*aa));Pa=ea(ea(Oa*fa)-ea(Qa*ba));Qa=ea(ea(wa*M)+ea(Ja*ia));Oa=ea(ea(Ja*_)+ea(Ka*ja));Ja=ea(-Ra);Ta=ea(-Sa);Ua=ea(-Pa);if(Qa>=(Ra>Ja?Ra:Ja)&(na>=Ma&va>=S)&(Oa>=(Sa>Ta?Sa:Ta)&(oa>=Na&La>=ma))){La=ea(Ka*ta);Na=ea(wa*sa);Va=ea(Na+La)>=(Pa>Ua?Pa:Ua)&(ua>=ea(Ga-Ka)&ea(Ga+Ka)>=ya)}else Va=0;Ia=Da+1|0;Ha=j+(Ia*24|0)|0;Wa=ea(g[Ha>>2]);Xa=ea(g[j+(Ia*24|0)+4>>2]);Ya=ea(g[j+(Ia*24|0)+8>>2]);Ka=ea((c[k>>2]=c[j+(Ia*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));Ia=(g[k>>2]=Wa,c[k>>2]|0);Za=(g[k>>2]=Xa,c[k>>2]|0);Ua=ea(ea(Ia&255|0)*Ka);Pa=ea(ea(Za&255|0)*Ka);La=ea(ea((g[k>>2]=Ya,c[k>>2]|0)&255|0)*Ka);Ka=ea(Wa+Ua);Na=ea(Xa+Pa);wa=ea(Wa-Ua);Ta=ea(Xa-Pa);Sa=ea(X-Wa);Oa=ea(Y-Xa);va=ea(Z-Ya);Ma=ea(ea(Oa*ca)-ea(Sa*$));Ja=ea(ea(va*da)-ea(Oa*aa));Oa=ea(ea(Sa*fa)-ea(va*ba));va=ea(ea(Ua*M)+ea(Pa*ia));Sa=ea(ea(Pa*_)+ea(La*ja));Pa=ea(-Ma);Ra=ea(-Ja);Qa=ea(-Oa);if(va>=(Ma>Pa?Ma:Pa)&(na>=wa&Ka>=S)&(Sa>=(Ja>Ra?Ja:Ra)&(oa>=Ta&Na>=ma))){Na=ea(La*ta);Ta=ea(Ua*sa);Za=ea(Ta+Na)>=(Oa>Qa?Oa:Qa)&(ua>=ea(Ya-La)&ea(Ya+La)>=ya);if(Va&Za)break;else _a=Za}else _a=0;if(Va|_a)za=Va?Aa:Ha;else{$a=P;break b}}za=ea(ea(ea(ea(Wa-Ea)*ca)+ea(ea(Xa-Fa)*da))+ea(ea(Ya-Ga)*fa))>ea(0.0)&1;c[n+(P<<2)>>2]=j+((za+Da|0)*24|0);Q=j+(((za^1)+Da|0)*24|0)|0;P=P+1|0}Q=c[d>>2]|0;za=VEi(Ba|0,Ca|0,21)|0;if(!(kn[c[c[l>>2]>>2]&511](l,o,b+(c[Q+((za&524287)<<2)>>2]<<3)|0,1)|0)){ab=0;bb=18;break a}ya=ea(g[o>>2]);if(ya<xa){g[h>>2]=ya;ua=ea(g[s>>2]);sa=ea(g[t>>2]);ta=ea(g[u>>2]);La=ea(g[m>>2]);Qa=ea(g[f>>2]);Oa=ea(g[e>>2]);Na=ea(ea(ya*ua)+La);ua=ea(ea(ya*sa)+Qa);sa=ea(ea(ya*ta)+Oa);g[z>>2]=La<Na?La:Na;g[A>>2]=Qa<ua?Qa:ua;g[G>>2]=Oa<sa?Oa:sa;g[H>>2]=ea(0.0);g[B>>2]=La>Na?La:Na;g[C>>2]=Qa>ua?Qa:ua;g[F>>2]=Oa>sa?Oa:sa;g[I>>2]=ea(0.0);$a=P}else $a=P}else $a=K;while(0);za=$a+-1|0;if(!$a){ab=1;bb=18;break}J=c[n+(za<<2)>>2]|0;K=za}if((bb|0)==18){i=a;return ab|0}return 0}function u2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;f=i;i=i+32|0;h=f;j=d+16|0;l=c[d>>2]|0;m=ea((l&255)>>>0);n=c[d+4>>2]|0;o=ea((n&255)>>>0);p=c[d+8>>2]|0;q=ea((p&255)>>>0);r=(c[k>>2]=c[j+4>>2]&-256,ea(g[k>>2]));s=ea(ea(m*r)*ea(.0000999999974));m=ea(ea(o*r)*ea(.0000999999974));o=ea(ea(r*q)*ea(.0000999999974));q=(c[k>>2]=l,ea(g[k>>2]));r=ea(q-s);t=(c[k>>2]=n,ea(g[k>>2]));u=ea(t-m);v=(c[k>>2]=p,ea(g[k>>2]));w=ea(v-o);x=ea(q+s);s=ea(t+m);m=ea(v+o);g[h>>2]=r;g[h+4>>2]=u;g[h+8>>2]=w;g[h+12>>2]=x;g[h+16>>2]=s;g[h+20>>2]=m;a[h+24>>0]=1;HKa(e,h)|0;h=j;p=c[h>>2]|0;if(!((p&1|0)==0&0==0)){i=f;return}n=VEi(p|0,c[h+4>>2]|0,21)|0;u2a(b,b+((n&524287)*24|0)|0,e);n=j;j=VEi(c[n>>2]|0,c[n+4>>2]|0,21)|0;n=j&524287;u2a(b,(n|0)==0?b:b+((n+1|0)*24|0)|0,e);i=f;return}function v2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+64|0;f=e+16|0;h=e;j=e+32|0;c[125696]=(c[125696]|0)+1;l=a+16|0;m=l;n=c[m>>2]|0;o=c[m+4>>2]|0;m=VEi(n|0,o|0,21)|0;p=m&524287;m=VEi(n|0,o|0,2)|0;q=m&524287;m=c[d+(p<<2)>>2]|0;r=c[b+20>>2]|0;s=ea(g[r+(m*24|0)>>2]);t=ea(g[r+(m*24|0)+4>>2]);u=ea(g[r+(m*24|0)+8>>2]);v=ea(g[r+(m*24|0)+12>>2]);w=ea(g[r+(m*24|0)+16>>2]);x=ea(g[r+(m*24|0)+20>>2]);if(q>>>0>1){y=s;z=v;A=u;B=x;C=t;D=w;m=1;while(1){E=c[d+(m+p<<2)>>2]|0;F=ea(g[r+(E*24|0)>>2]);G=ea(g[r+(E*24|0)+4>>2]);I=ea(g[r+(E*24|0)+8>>2]);J=y<F?y:F;F=C<G?C:G;G=A<I?A:I;I=ea(g[r+(E*24|0)+12>>2]);K=ea(g[r+(E*24|0)+16>>2]);L=ea(g[r+(E*24|0)+20>>2]);M=z>I?z:I;I=D>K?D:K;K=B>L?B:L;m=m+1|0;if((m|0)==(q|0)){N=J;O=M;P=G;Q=K;R=F;S=I;break}else{y=J;z=M;A=G;B=K;C=F;D=I}}}else{N=s;O=v;P=u;Q=x;R=t;S=w}g[j>>2]=N;g[j+4>>2]=R;g[j+8>>2]=P;g[j+12>>2]=O;g[j+16>>2]=S;g[j+20>>2]=Q;q=l;c[q>>2]=n|1;c[q+4>>2]=o;x2a(a,j,b,d)|0;j=N>ea(-9999999940000000065998519.0e8);w=j?N:ea(-9999999940000000065998519.0e8);j=R>ea(-9999999940000000065998519.0e8);N=j?R:ea(-9999999940000000065998519.0e8);j=P>ea(-9999999940000000065998519.0e8);R=j?P:ea(-9999999940000000065998519.0e8);j=O<ea(9999999940000000065998519.0e8);P=j?O:ea(9999999940000000065998519.0e8);j=S<ea(9999999940000000065998519.0e8);O=j?S:ea(9999999940000000065998519.0e8);j=Q<ea(9999999940000000065998519.0e8);S=j?Q:ea(9999999940000000065998519.0e8);Q=ea(ea(P+w)*ea(.5));t=ea(ea(O+N)*ea(.5));x=ea(ea(S+R)*ea(.5));u=ea(ea(P-w)*ea(.5));w=ea(ea(O-N)*ea(.5));N=ea(ea(S-R)*ea(.5));R=ea(Q*ea(.0000999999974));S=ea(t*ea(.0000999999974));O=ea(x*ea(.0000999999974));P=ea(-R);v=ea(-S);s=ea(-O);D=ea(u+ea((R>P?R:P)+ea(.0000999999974)));P=ea(w+ea((S>v?S:v)+ea(.0000999999974)));v=ea(N+ea((O>s?O:s)+ea(.0000999999974)));s=P>v?P:v;O=ea((D>s?D:s)*ea(.00392158423));s=ea(ea(O+ea(O*ea(.0000999999974)))*ea(1.0e4));j=(g[k>>2]=s,c[k>>2]|0);s=ea(ea(1.0)/O);o=~~ea(ea(s*D)+ea(1.0));q=~~ea(ea(s*P)+ea(1.0));n=~~ea(ea(s*v)+ea(1.0));m=Q==ea(0.0);r=t==ea(0.0);p=x==ea(0.0);g[h>>2]=ea(2.3509887e-38);g[h+4>>2]=ea(2.3509887e-38);g[h+8>>2]=ea(2.3509887e-38);g[h+12>>2]=ea(0.0);g[f>>2]=Q;g[f+4>>2]=t;g[f+8>>2]=x;g[f+12>>2]=ea(0.0);x=ea(g[(m?h:f)>>2]);t=ea(g[(r?h:f)+4>>2]);Q=ea(g[(p?h:f)+8>>2]);f=(g[k>>2]=x,c[k>>2]|0);h=(g[k>>2]=t,c[k>>2]|0);p=n|(g[k>>2]=Q,c[k>>2]|0)&-256;n=o|f&-256|0;f=q|h&-256|0;h=p|0;c[a>>2]=n;c[a+4>>2]=f;c[a+8>>2]=h;h=l;f=c[h>>2]|0;n=c[h+4>>2]|0;h=cFi(j>>>8|0,0,40)|0;j=l;c[j>>2]=h|f;c[j+4>>2]=H|n&255;j=c[b+12>>2]|0;if(!((f&1|0)==0&0==0)){T=l;U=T;V=c[U>>2]|0;W=T+4|0;X=W;Y=c[X>>2]|0;Z=VEi(V|0,Y|0,2)|0;_=H;$=Z&524287;aa=b+16|0;ba=c[aa>>2]|0;ca=$+ba|0;c[aa>>2]=ca;da=a;fa=j;ga=da-fa|0;ha=(ga|0)/24|0;ia=V&-2097149;ja=cFi(ha|0,0,2)|0;ka=H;la=ia|ja;ma=Y|ka;na=l;oa=na;c[oa>>2]=la;pa=na+4|0;qa=pa;c[qa>>2]=ma;i=e;return}h=VEi(f|0,n|0,21)|0;n=h&524287;h=(n|0)==0;f=h?j:j+((n+1|0)*24|0)|0;if(!h){v2a(j+(n*24|0)|0,b,d);h=j+(n*24|0)+16|0;n=h;p=c[n+4>>2]|0;q=c[n>>2]&-2097149;n=cFi((a-j|0)/24|0|0,0,2)|0;o=h;c[o>>2]=q|n;c[o+4>>2]=p|H}if((f|0)==(j|0)){T=l;U=T;V=c[U>>2]|0;W=T+4|0;X=W;Y=c[X>>2]|0;Z=VEi(V|0,Y|0,2)|0;_=H;$=Z&524287;aa=b+16|0;ba=c[aa>>2]|0;ca=$+ba|0;c[aa>>2]=ca;da=a;fa=j;ga=da-fa|0;ha=(ga|0)/24|0;ia=V&-2097149;ja=cFi(ha|0,0,2)|0;ka=H;la=ia|ja;ma=Y|ka;na=l;oa=na;c[oa>>2]=la;pa=na+4|0;qa=pa;c[qa>>2]=ma;i=e;return}v2a(f,b,d);d=f+16|0;f=d;p=c[f+4>>2]|0;o=c[f>>2]&-2097149;f=cFi((a-j|0)/24|0|0,0,2)|0;n=d;c[n>>2]=o|f;c[n+4>>2]=p|H;T=l;U=T;V=c[U>>2]|0;W=T+4|0;X=W;Y=c[X>>2]|0;Z=VEi(V|0,Y|0,2)|0;_=H;$=Z&524287;aa=b+16|0;ba=c[aa>>2]|0;ca=$+ba|0;c[aa>>2]=ca;da=a;fa=j;ga=da-fa|0;ha=(ga|0)/24|0;ia=V&-2097149;ja=cFi(ha|0,0,2)|0;ka=H;la=ia|ja;ma=Y|ka;na=l;oa=na;c[oa>>2]=la;pa=na+4|0;qa=pa;c[qa>>2]=ma;i=e;return}function w2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?503032:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function x2a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=0,na=0,oa=Im,pa=0,qa=0,ra=Im,sa=0,ta=0,ua=Im,va=0,wa=0,xa=Im,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;f=i;i=i+64|0;h=f+48|0;j=f+36|0;k=f+24|0;l=f+12|0;m=f;n=a+16|0;a=n;o=c[a>>2]|0;p=c[a+4>>2]|0;a=VEi(o|0,p|0,2)|0;q=H;r=a&524287;if((r|0)==1){s=cFi(a|0,q|0,1)|0;t=n;c[t>>2]=s&2|o&-3;c[t+4>>2]=p;u=1;i=f;return u|0}if((c[d>>2]|0)>>>0>=r>>>0){t=cFi(a|0,q|0,1)|0;s=n;c[s>>2]=t&2|o&-3;c[s+4>>2]=p;u=1;i=f;return u|0}s=c[d+4>>2]|0;a:do if(s&1){t=b+12|0;v=ea(g[t>>2]);w=ea(v-ea(g[b>>2]));v=ea(g[b+16>>2]);x=ea(v-ea(g[b+4>>2]));v=ea(g[b+20>>2]);y=ea(w*ea(.5));w=ea(x*ea(.5));x=ea(ea(v-ea(g[b+8>>2]))*ea(.5));g[h>>2]=y;g[h+4>>2]=w;g[h+8>>2]=x;z=w>y&1;A=x>ea(g[h+(z<<2)>>2]);B=A?2:z;x=ea(g[b+(B<<2)>>2]);y=ea(ea(x+ea(g[t+(B<<2)>>2]))*ea(.5));if(!((o&2097148|0)==0&0==0)){t=c[d+20>>2]|0;z=VEi(o|0,p|0,21)|0;A=z&524287;z=0;C=0;while(1){D=e+(C+A<<2)|0;E=c[D>>2]|0;x=ea(g[t+(E*24|0)+(B<<2)>>2]);if(ea(ea(x+ea(g[t+(E*24|0)+12+(B<<2)>>2]))*ea(.5))>y){F=e+(z+A<<2)|0;c[D>>2]=c[F>>2];c[F>>2]=E;G=z+1|0}else G=z;C=C+1|0;if(C>>>0>=r>>>0)break;else z=G}if(!((G|0)==0|(G|0)==(r|0))){I=o;J=p;K=G}else L=64}else L=64}else{if(s&2){y=ea(r>>>0);z=VEi(o|0,p|0,21)|0;C=z&524287;z=C+r|0;A=e+(z<<2)|0;if((C|0)<(z|0)){z=c[d+20>>2]|0;x=ea(0.0);w=ea(0.0);v=ea(0.0);B=e+(C<<2)|0;while(1){t=c[B>>2]|0;B=B+4|0;M=ea(g[z+(t*24|0)>>2]);N=ea(g[z+(t*24|0)+4>>2]);O=ea(g[z+(t*24|0)+8>>2]);P=ea(g[z+(t*24|0)+12>>2]);Q=ea(g[z+(t*24|0)+16>>2]);R=ea(x+ea(ea(M+P)*ea(.5)));P=ea(w+ea(ea(N+Q)*ea(.5)));Q=ea(v+ea(ea(O+ea(g[z+(t*24|0)+20>>2]))*ea(.5)));if(B>>>0>=A>>>0){S=Q;T=P;U=R;break}else{x=R;w=P;v=Q}}}else{S=ea(0.0);T=ea(0.0);U=ea(0.0)}v=ea(ea(1.0)/y);w=ea(U*v);x=ea(T*v);Q=ea(S*v);if(!r){V=ea(0.0);W=ea(0.0);X=ea(0.0)}else{B=c[d+20>>2]|0;v=ea(0.0);P=ea(0.0);R=ea(0.0);z=e+(C<<2)|0;while(1){t=c[z>>2]|0;z=z+4|0;O=ea(g[B+(t*24|0)>>2]);N=ea(g[B+(t*24|0)+4>>2]);M=ea(g[B+(t*24|0)+8>>2]);Y=ea(g[B+(t*24|0)+12>>2]);Z=ea(g[B+(t*24|0)+16>>2]);_=ea(ea(ea(O+Y)*ea(.5))-w);Y=ea(ea(ea(N+Z)*ea(.5))-x);Z=ea(ea(ea(M+ea(g[B+(t*24|0)+20>>2]))*ea(.5))-Q);M=ea(v+ea(_*_));_=ea(P+ea(Y*Y));Y=ea(R+ea(Z*Z));if((z|0)==(A|0)){V=Y;W=_;X=M;break}else{v=M;P=_;R=Y}}}R=ea(ea(1.0)/ea(y+ea(-1.0)));P=ea(X*R);v=ea(W*R);Q=ea(V*R);g[j>>2]=P;g[j+4>>2]=v;g[j+8>>2]=Q;A=v>P&1;z=Q>ea(g[j+(A<<2)>>2]);B=z?2:A;Q=ea(g[b+(B<<2)>>2]);P=ea(ea(Q+ea(g[b+12+(B<<2)>>2]))*ea(.5));if((o&2097148|0)==0&0==0){L=64;break}A=c[d+20>>2]|0;z=0;t=0;while(1){E=e+(t+C<<2)|0;F=c[E>>2]|0;Q=ea(g[A+(F*24|0)+(B<<2)>>2]);if(ea(ea(Q+ea(g[A+(F*24|0)+12+(B<<2)>>2]))*ea(.5))>P){D=e+(z+C<<2)|0;c[E>>2]=c[D>>2];c[D>>2]=F;$=z+1|0}else $=z;t=t+1|0;if(t>>>0>=r>>>0)break;else z=$}if(($|0)!=(r|0)&($|0)!=0){I=o;J=p;K=$;break}else{L=64;break}}if(s&8){P=ea(g[b>>2]);z=b+12|0;y=ea(ea(P+ea(g[z>>2]))*ea(.5));t=(o&2097148|0)==0&0==0;if(t)aa=0;else{C=c[d+20>>2]|0;B=VEi(o|0,p|0,21)|0;A=B&524287;B=a&524287;F=0;D=0;while(1){E=e+(D+A<<2)|0;ba=c[E>>2]|0;P=ea(g[C+(ba*24|0)>>2]);if(ea(ea(P+ea(g[C+(ba*24|0)+12>>2]))*ea(.5))>y){ca=e+(F+A<<2)|0;c[E>>2]=c[ca>>2];c[ca>>2]=ba;da=F+1|0}else da=F;D=D+1|0;if((D|0)==(B|0)){aa=da;break}else F=da}}y=ea(r>>>0);P=ea(ea(aa>>>0)/y);g[k>>2]=P;Q=ea(g[b+4>>2]);v=ea(ea(Q+ea(g[z+4>>2]))*ea(.5));if(t)fa=0;else{F=c[d+20>>2]|0;B=VEi(o|0,p|0,21)|0;D=B&524287;B=0;A=0;while(1){C=e+(A+D<<2)|0;ba=c[C>>2]|0;Q=ea(g[F+(ba*24|0)+4>>2]);if(ea(ea(Q+ea(g[F+(ba*24|0)+16>>2]))*ea(.5))>v){ca=e+(B+D<<2)|0;c[C>>2]=c[ca>>2];c[ca>>2]=ba;ga=B+1|0}else ga=B;A=A+1|0;if(A>>>0>=r>>>0){fa=ga;break}else B=ga}}v=ea(ea(fa>>>0)/y);B=k+4|0;g[B>>2]=v;Q=ea(g[b+8>>2]);R=ea(ea(Q+ea(g[z+8>>2]))*ea(.5));if(t)ha=0;else{A=c[d+20>>2]|0;D=VEi(o|0,p|0,21)|0;F=D&524287;D=0;ba=0;while(1){ca=e+(ba+F<<2)|0;C=c[ca>>2]|0;Q=ea(g[A+(C*24|0)+8>>2]);if(ea(ea(Q+ea(g[A+(C*24|0)+20>>2]))*ea(.5))>R){E=e+(D+F<<2)|0;c[ca>>2]=c[E>>2];c[E>>2]=C;ia=D+1|0}else ia=D;ba=ba+1|0;if(ba>>>0>=r>>>0){ha=ia;break}else D=ia}}R=ea(ea(ha>>>0)/y);Q=ea(P+ea(-.5));x=ea(Q*Q);g[k>>2]=x;Q=ea(v+ea(-.5));w=ea(Q*Q);g[B>>2]=w;Q=ea(R+ea(-.5));R=ea(Q*Q);g[k+8>>2]=R;D=w<x&1;ba=R<ea(g[k+(D<<2)>>2]);F=ba?2:D;R=ea(g[b+(F<<2)>>2]);x=ea(ea(R+ea(g[z+(F<<2)>>2]))*ea(.5));if(t){L=64;break}D=c[d+20>>2]|0;ba=VEi(o|0,p|0,21)|0;A=ba&524287;ba=0;C=0;while(1){E=e+(C+A<<2)|0;ca=c[E>>2]|0;R=ea(g[D+(ca*24|0)+(F<<2)>>2]);if(ea(ea(R+ea(g[D+(ca*24|0)+12+(F<<2)>>2]))*ea(.5))>x){ja=e+(ba+A<<2)|0;c[E>>2]=c[ja>>2];c[ja>>2]=ca;ka=ba+1|0}else ka=ba;C=C+1|0;if(C>>>0>=r>>>0)break;else ba=ka}if((ka|0)==0|(ka|0)==(r|0)){L=64;break}else{I=o;J=p;K=ka;break}}if(!(s&4)){if(s&16){I=o;J=p;K=r>>>1;break}ba=cFi(a|0,q|0,1)|0;C=n;c[C>>2]=ba&2|o&-3;c[C+4>>2]=p;u=0;i=f;return u|0}C=b+12|0;x=ea(g[C>>2]);v=ea(x-ea(g[b>>2]));x=ea(g[b+16>>2]);P=ea(x-ea(g[b+4>>2]));x=ea(g[b+20>>2]);y=ea(v*ea(.5));v=ea(P*ea(.5));P=ea(ea(x-ea(g[b+8>>2]))*ea(.5));g[l>>2]=y;g[l+4>>2]=v;g[l+8>>2]=P;c[m+0>>2]=c[135316];c[m+4>>2]=c[135317];c[m+8>>2]=c[135318];ba=m+4|0;if(y<v){c[m>>2]=1;c[ba>>2]=0;la=y;ma=0;na=1}else{la=v;ma=1;na=0}A=m+8|0;if(la<P){c[ba>>2]=2;c[A>>2]=ma;oa=P;pa=2;qa=ma}else{oa=la;pa=ma;qa=2}P=ea(g[l+(na<<2)>>2]);if(P<oa){c[m>>2]=pa;c[ba>>2]=na;ra=P;sa=na;ta=pa}else{ra=oa;sa=pa;ta=na}P=ea(g[l+(qa<<2)>>2]);if(ra<P){c[ba>>2]=qa;c[A>>2]=sa;ua=P;va=qa;wa=sa}else{ua=ra;va=sa;wa=qa}P=ea(g[l+(ta<<2)>>2]);if(P<ua){c[m>>2]=va;c[ba>>2]=ta;xa=P;ya=ta}else{xa=ua;ya=va}if(xa<ea(g[l+(wa<<2)>>2])){c[ba>>2]=wa;c[A>>2]=ya}A=d+20|0;ba=0;F=0;while(1){D=m+(ba<<2)|0;if((ba|0)==3){L=64;break a}else{za=F;Aa=1}while(1){if(!Aa){I=o;J=p;K=za;break a}t=c[D>>2]|0;P=ea(g[b+(t<<2)>>2]);v=ea(ea(P+ea(g[C+(t<<2)>>2]))*ea(.5));if((o&2097148|0)==0&0==0){Ba=0;break}z=c[A>>2]|0;B=VEi(o|0,p|0,21)|0;ca=B&524287;B=0;ja=0;while(1){E=e+(ja+ca<<2)|0;Ca=c[E>>2]|0;P=ea(g[z+(Ca*24|0)+(t<<2)>>2]);if(ea(ea(P+ea(g[z+(Ca*24|0)+12+(t<<2)>>2]))*ea(.5))>v){Da=e+(B+ca<<2)|0;c[E>>2]=c[Da>>2];c[Da>>2]=Ca;Ea=B+1|0}else Ea=B;ja=ja+1|0;if(ja>>>0>=r>>>0)break;else B=Ea}if(!Ea){Ba=0;break}if((Ea|0)==(r|0)){Ba=r;break}else{za=Ea;Aa=0}}ba=ba+1|0;F=Ba}}while(0);do if((L|0)==64){Ba=VEi(o|0,p|0,1)|0;Aa=Ba&2|o&-3;Ba=n;c[Ba>>2]=Aa;c[Ba+4>>2]=p;if(r>>>0>(c[d>>2]|0)>>>0){Ba=d+28|0;c[Ba>>2]=(c[Ba>>2]|0)+1;Ba=VEi(o|0,p|0,3)|0;I=Aa;J=p;K=Ba&262143;break}else{u=1;i=f;return u|0}}while(0);p=c[d+12>>2]|0;o=VEi(I|0,J|0,21)|0;r=o&524287;o=d+24|0;d=c[o>>2]|0;L=cFi(d|0,0,21)|0;Ba=n;c[Ba>>2]=L|I&2097150;c[Ba+4>>2]=H|J&-256;c[o>>2]=d+2;o=d&524287;d=p+(o*24|0)+16|0;J=c[d+4>>2]&-256;Ba=cFi(r|0,0,21)|0;I=H;L=cFi(K|0,0,2)|0;Aa=H;Ea=cFi(K|0,0,1)|0;za=d;c[za>>2]=L|Ea&2|Ba|1;c[za+4>>2]=Aa|I|J;J=((o|0)==0?p:p+((o+1|0)*24|0)|0)+16|0;o=J;p=c[o>>2]&2097151;I=c[o+4>>2]&-256;o=cFi(r+K|0,0,21)|0;r=p|o;o=I|H;I=J;c[I>>2]=r;c[I+4>>2]=o;I=n;n=VEi(c[I>>2]|0,c[I+4>>2]|0,2)|0;I=(n&524287)-K|0;K=cFi(I|0,0,2)|0;n=H;p=cFi(I|0,0,1)|0;I=J;c[I>>2]=r&-2097152|K|p&2|1;c[I+4>>2]=o|n;u=1;i=f;return u|0}function y2a(a,b,d,e,f,h,j,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im;q=i;i=i+32|0;r=q+16|0;s=q;t=c[f>>2]|0;if(t){u=ea(g[l>>2]);v=ea(g[l+4>>2]);w=ea(g[l+8>>2]);g[t>>2]=u;g[t+4>>2]=v;g[t+8>>2]=w;x=t+16|0;t=x;y=c[t>>2]|0;z=c[t+4>>2]&255;t=cFi((c[j+4>>2]|0)>>>8|0,0,40)|0;A=x;c[A>>2]=t|y;c[A+4>>2]=H|z;c[f>>2]=0}if(c[h>>2]|0){w=ea(g[m>>2]);v=ea(g[m+4>>2]);u=ea(g[m+8>>2]);B=ea(g[n>>2]);C=ea(g[n+4>>2]);D=ea(g[n+8>>2]);z=w>ea(-9999999940000000065998519.0e8);E=z?w:ea(-9999999940000000065998519.0e8);z=v>ea(-9999999940000000065998519.0e8);w=z?v:ea(-9999999940000000065998519.0e8);z=u>ea(-9999999940000000065998519.0e8);v=z?u:ea(-9999999940000000065998519.0e8);z=B<ea(9999999940000000065998519.0e8);u=z?B:ea(9999999940000000065998519.0e8);z=C<ea(9999999940000000065998519.0e8);B=z?C:ea(9999999940000000065998519.0e8);z=D<ea(9999999940000000065998519.0e8);C=z?D:ea(9999999940000000065998519.0e8);D=ea(ea(E+u)*ea(.5));F=ea(ea(w+B)*ea(.5));G=ea(ea(v+C)*ea(.5));I=ea(ea(u-E)*ea(.5));E=ea(ea(B-w)*ea(.5));w=ea(ea(C-v)*ea(.5));v=ea(D*ea(.0000999999974));C=ea(F*ea(.0000999999974));B=ea(G*ea(.0000999999974));u=ea(-v);J=ea(-C);K=ea(-B);L=ea(I+ea((v>u?v:u)+ea(.0000999999974)));u=ea(E+ea((C>J?C:J)+ea(.0000999999974)));J=ea(w+ea((B>K?B:K)+ea(.0000999999974)));K=u>J?u:J;B=ea((L>K?L:K)*ea(.00392158423));K=ea(ea(B+ea(B*ea(.0000999999974)))*ea(1.0e4));g[j>>2]=K;g[j+4>>2]=K;g[j+8>>2]=K;g[j+12>>2]=ea(0.0);K=ea(ea(1.0)/B);j=~~ea(ea(K*L)+ea(1.0));z=~~ea(ea(K*u)+ea(1.0));A=~~ea(ea(K*J)+ea(1.0));y=D==ea(0.0);t=F==ea(0.0);x=G==ea(0.0);g[s>>2]=ea(2.3509887e-38);g[s+4>>2]=ea(2.3509887e-38);g[s+8>>2]=ea(2.3509887e-38);g[s+12>>2]=ea(0.0);g[r>>2]=D;g[r+4>>2]=F;g[r+8>>2]=G;g[r+12>>2]=ea(0.0);G=ea(g[(y?s:r)>>2]);F=ea(g[(t?s:r)+4>>2]);D=ea(g[(x?s:r)+8>>2]);r=(g[k>>2]=G,c[k>>2]|0);s=(g[k>>2]=F,c[k>>2]|0);x=A|(g[k>>2]=D,c[k>>2]|0)&-256;A=j|r&-256|0;r=z|s&-256|0;s=x|0;c[l>>2]=A;c[l+4>>2]=r;c[l+8>>2]=s;g[l+12>>2]=ea(0.0);c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[p+12>>2]=c[n+12>>2];c[f>>2]=c[h>>2];c[h>>2]=0}l=a+(b*24|0)|0;s=a+(b*24|0)+16|0;b=c[s>>2]|0;r=VEi(b|0,c[s+4>>2]|0,21)|0;s=r&524287;if(!((b&1|0)==0&0==0)){if((b&2|0)==0&0==0){M=ea(2499999990000000085741769.0e8);N=ea(2499999990000000085741769.0e8);O=ea(2499999990000000085741769.0e8);P=ea(-2499999990000000085741769.0e8);Q=ea(-2499999990000000085741769.0e8);R=ea(-2499999990000000085741769.0e8)}else{b=c[e+(s<<2)>>2]|0;D=ea(g[d+(b*24|0)>>2]);F=ea(g[d+(b*24|0)+4>>2]);G=ea(g[d+(b*24|0)+8>>2]);J=ea(g[d+(b*24|0)+12>>2]);K=ea(g[d+(b*24|0)+16>>2]);M=D;N=F;O=G;P=J;Q=K;R=ea(g[d+(b*24|0)+20>>2])}g[m>>2]=M;g[m+4>>2]=N;g[m+8>>2]=O;g[m+12>>2]=ea(0.0);g[n>>2]=P;g[n+4>>2]=Q;g[n+8>>2]=R;g[n+12>>2]=ea(0.0);c[h>>2]=l;i=q;return}b=a+(s*24|0)|0;d=c[f>>2]|0;if((b|0)==(d|0)){R=ea(g[o>>2]);Q=ea(g[o+4>>2]);P=ea(g[o+8>>2]);O=ea(g[p>>2]);N=ea(g[p+4>>2]);S=R;T=Q;U=P;V=O;W=N;X=ea(g[p+8>>2])}else{N=ea(g[b>>2]);O=ea(g[a+(s*24|0)+4>>2]);P=ea(g[a+(s*24|0)+8>>2]);Q=ea((c[k>>2]=c[a+(s*24|0)+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));b=(g[k>>2]=N,c[k>>2]|0);f=(g[k>>2]=O,c[k>>2]|0);R=ea(ea(b&255|0)*Q);M=ea(ea(f&255|0)*Q);K=ea(ea((g[k>>2]=P,c[k>>2]|0)&255|0)*Q);S=ea(N-R);T=ea(O-M);U=ea(P-K);V=ea(N+R);W=ea(O+M);X=ea(P+K)}f=(s|0)==0?a:a+((s+1|0)*24|0)|0;if((f|0)==(d|0)){K=ea(g[o>>2]);P=ea(g[o+4>>2]);M=ea(g[o+8>>2]);O=ea(g[p>>2]);R=ea(g[p+4>>2]);Y=K;Z=P;_=M;$=O;aa=R;ba=ea(g[p+8>>2])}else{R=ea(g[f>>2]);O=ea(g[f+4>>2]);M=ea(g[f+8>>2]);P=ea((c[k>>2]=c[f+20>>2]&-256,ea(g[k>>2]))*ea(.0000999999974));f=(g[k>>2]=R,c[k>>2]|0);p=(g[k>>2]=O,c[k>>2]|0);K=ea(ea(f&255|0)*P);N=ea(ea(p&255|0)*P);Q=ea(ea((g[k>>2]=M,c[k>>2]|0)&255|0)*P);Y=ea(R-K);Z=ea(O-N);_=ea(M-Q);$=ea(R+K);aa=ea(O+N);ba=ea(M+Q)}g[m>>2]=Y<S?Y:S;g[m+4>>2]=Z<T?Z:T;g[m+8>>2]=_<U?_:U;g[m+12>>2]=ea(0.0);g[n>>2]=$>V?$:V;g[n+4>>2]=aa>W?aa:W;g[n+8>>2]=ba>X?ba:X;g[n+12>>2]=ea(0.0);c[h>>2]=l;i=q;return}function z2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+16|0;f=c[b>>2]|0;h=ea(e>>>0);j=~~ea(h*ea(g[a+24>>2]))>>>0;k=e<<2;l=(j<<2)+k|0;m=(0-l&12)+l|0;l=UJa(a,m+(j*12|0)|0,529024,354)|0;n=l+k|0;o=l+m|0;PEi(l|0,-1,k|0)|0;k=a+36|0;m=a+4|0;if(c[k>>2]|0){p=e+-1|0;q=0;do{r=c[m>>2]|0;s=c[r+(q*12|0)>>2]|0;t=_Ei(s|0,c[r+(q*12|0)+4>>2]|0,-1,~s|0)|0;s=H;u=VEi(t|0,s|0,22)|0;v=u^t;t=H^s;s=cFi(v|0,t|0,13)|0;u=_Ei(v|0,t|0,~s|0,~H|0)|0;s=H;t=VEi(u|0,s|0,8)|0;v=gFi(t^u|0,H^s|0,9,0)|0;s=H;u=VEi(v|0,s|0,15)|0;t=u^v;v=H^s;s=cFi(t|0,v|0,27)|0;u=_Ei(t|0,v|0,~s|0,~H|0)|0;s=H;v=VEi(u|0,s|0,31)|0;s=l+(((v^u)&p)<<2)|0;c[n+(q<<2)>>2]=c[s>>2];c[s>>2]=q;s=o+(q*12|0)|0;if(s){u=r+(q*12|0)|0;v=c[u+4>>2]|0;t=s;c[t>>2]=c[u>>2];c[t+4>>2]=v;c[o+(q*12|0)+8>>2]=c[r+(q*12|0)+8>>2]}q=q+1|0}while(q>>>0<(c[k>>2]|0)>>>0)}VJa(a,c[a>>2]|0);c[a>>2]=l;c[a+12>>2]=l;c[a+20>>2]=e;c[a+8>>2]=n;c[m>>2]=o;c[b>>2]=j;j=a+28|0;if((c[j>>2]|0)!=-1){i=d;return}c[j>>2]=f;i=d;return}function A2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=c[d+4>>2]|0;m=_Ei(k|0,l|0,-1,~k|0)|0;n=H;o=VEi(m|0,n|0,22)|0;p=o^m;m=H^n;n=cFi(p|0,m|0,13)|0;o=_Ei(p|0,m|0,~n|0,~H|0)|0;n=H;m=VEi(o|0,n|0,8)|0;p=gFi(m^o|0,H^n|0,9,0)|0;n=H;o=VEi(p|0,n|0,15)|0;m=o^p;p=H^n;n=cFi(m|0,p|0,27)|0;o=_Ei(m|0,p|0,~n|0,~H|0)|0;n=H;p=VEi(o|0,n|0,31)|0;n=(p^o)&h+-1;o=c[(c[b+12>>2]|0)+(n<<2)>>2]|0;if((o|0)==-1)q=n;else{p=c[b+4>>2]|0;m=b+8|0;r=o;while(1){if((c[p+(r*12|0)>>2]|0)==(k|0)?(c[p+(r*12|0)+4>>2]|0)==(l|0):0)break;o=c[(c[m>>2]|0)+(r<<2)>>2]|0;if((o|0)==-1){q=n;break a}else r=o}a[e>>0]=1;s=p+(r*12|0)|0;i=f;return s|0}}else q=0;while(0);a[e>>0]=0;e=b+36|0;if((c[e>>2]|0)==(c[b+16>>2]|0)){n=j?16:h<<1;if(h>>>0<n>>>0){z2a(b,n);t=c[g>>2]|0}else t=h;h=c[d>>2]|0;g=_Ei(h|0,c[d+4>>2]|0,-1,~h|0)|0;h=H;d=VEi(g|0,h|0,22)|0;n=d^g;g=H^h;h=cFi(n|0,g|0,13)|0;d=_Ei(n|0,g|0,~h|0,~H|0)|0;h=H;g=VEi(d|0,h|0,8)|0;n=gFi(g^d|0,H^h|0,9,0)|0;h=H;d=VEi(n|0,h|0,15)|0;g=d^n;n=H^h;h=cFi(g|0,n|0,27)|0;d=_Ei(g|0,n|0,~h|0,~H|0)|0;h=H;n=VEi(d|0,h|0,31)|0;u=(n^d)&t+-1}else u=q;q=b+28|0;t=c[q>>2]|0;c[q>>2]=t+1;q=(c[b+12>>2]|0)+(u<<2)|0;c[(c[b+8>>2]|0)+(t<<2)>>2]=c[q>>2];c[q>>2]=t;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(t*12|0)|0;i=f;return s|0}function B2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+20|0;f=c[e>>2]|0;if(!f){g=0;i=d;return g|0}h=c[b>>2]|0;j=c[b+4>>2]|0;b=_Ei(h|0,j|0,-1,~h|0)|0;k=H;l=VEi(b|0,k|0,22)|0;m=l^b;b=H^k;k=cFi(m|0,b|0,13)|0;l=_Ei(m|0,b|0,~k|0,~H|0)|0;k=H;b=VEi(l|0,k|0,8)|0;m=gFi(b^l|0,H^k|0,9,0)|0;k=H;l=VEi(m|0,k|0,15)|0;b=l^m;m=H^k;k=cFi(b|0,m|0,27)|0;l=_Ei(b|0,m|0,~k|0,~H|0)|0;k=H;m=VEi(l|0,k|0,31)|0;k=a+12|0;b=c[k>>2]|0;n=b+(((m^l)&f+-1)<<2)|0;f=c[n>>2]|0;if((f|0)==-1){g=0;i=d;return g|0}l=a+4|0;m=c[l>>2]|0;o=a+8|0;p=f;f=n;while(1){if((c[m+(p*12|0)>>2]|0)==(h|0)?(c[m+(p*12|0)+4>>2]|0)==(j|0):0)break;n=(c[o>>2]|0)+(p<<2)|0;q=c[n>>2]|0;if((q|0)==-1){g=0;r=15;break}else{p=q;f=n}}if((r|0)==15){i=d;return g|0}if((p|0)==-1){g=0;i=d;return g|0}r=c[o>>2]|0;c[f>>2]=c[r+(p<<2)>>2];f=a+36|0;j=(c[f>>2]|0)+-1|0;c[f>>2]=j;h=a+32|0;c[h>>2]=(c[h>>2]|0)+1;if((p|0)!=(j|0)){h=m+(p*12|0)|0;if(!h){s=b;t=r;u=j;v=m}else{r=m+(j*12|0)|0;b=c[r+4>>2]|0;n=h;c[n>>2]=c[r>>2];c[n+4>>2]=b;c[m+(p*12|0)+8>>2]=c[m+(j*12|0)+8>>2];s=c[k>>2]|0;t=c[o>>2]|0;u=c[f>>2]|0;v=c[l>>2]|0}c[t+(p<<2)>>2]=c[t+(u<<2)>>2];u=c[e>>2]|0;e=c[v+(p*12|0)>>2]|0;l=_Ei(e|0,c[v+(p*12|0)+4>>2]|0,-1,~e|0)|0;e=H;v=VEi(l|0,e|0,22)|0;o=v^l;l=H^e;e=cFi(o|0,l|0,13)|0;v=_Ei(o|0,l|0,~e|0,~H|0)|0;e=H;l=VEi(v|0,e|0,8)|0;o=gFi(l^v|0,H^e|0,9,0)|0;e=H;v=VEi(o|0,e|0,15)|0;l=v^o;o=H^e;e=cFi(l|0,o|0,27)|0;v=_Ei(l|0,o|0,~e|0,~H|0)|0;e=H;o=VEi(v|0,e|0,31)|0;e=s+(((o^v)&u+-1)<<2)|0;u=c[e>>2]|0;v=c[f>>2]|0;if((u|0)==(v|0))w=e;else{e=u;do{u=t+(e<<2)|0;e=c[u>>2]|0}while((e|0)!=(v|0));w=u}c[w>>2]=p}p=a+28|0;c[p>>2]=(c[p>>2]|0)+-1;g=1;i=d;return g|0}function C2a(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;f=a+4|0;h=a+8|0;j=a+12|0;l=a+16|0;m=a+176|0;n=a+180|0;o=a+184|0;p=a+144|0;q=a+148|0;r=a+152|0;s=a+112|0;t=a+116|0;u=a+120|0;v=a+80|0;w=a+84|0;x=a+88|0;y=a+48|0;z=a+52|0;A=a+56|0;B=0;do{C=d+(B*12|0)|0;D=c[a>>2]|0;E=c[f>>2]|0;F=c[h>>2]|0;G=c[j>>2]|0;H=c[l>>2]|0;if((E+D+F+G+H|0)>>>0<16)I=18056;else{if(!D)J=2139095032;else{K=ea(g[y>>2]);L=ea(K*ea(g[C>>2]));K=ea(g[z>>2]);M=ea(L+ea(K*ea(g[d+(B*12|0)+4>>2])));K=ea(g[A>>2]);L=ea(M+ea(K*ea(g[d+(B*12|0)+8>>2])));J=(g[k>>2]=L,c[k>>2]|0)&2147483640}if(!E)N=2139095033;else{L=ea(g[v>>2]);K=ea(L*ea(g[C>>2]));L=ea(g[w>>2]);M=ea(K+ea(L*ea(g[d+(B*12|0)+4>>2])));L=ea(g[x>>2]);K=ea(M+ea(L*ea(g[d+(B*12|0)+8>>2])));N=(g[k>>2]=K,c[k>>2]|0)&2147483640|1}if(!F)O=2139095034;else{K=ea(g[s>>2]);L=ea(K*ea(g[C>>2]));K=ea(g[t>>2]);M=ea(L+ea(K*ea(g[d+(B*12|0)+4>>2])));K=ea(g[u>>2]);L=ea(M+ea(K*ea(g[d+(B*12|0)+8>>2])));O=(g[k>>2]=L,c[k>>2]|0)&2147483640|2}if(!G)P=2139095035;else{L=ea(g[p>>2]);K=ea(L*ea(g[C>>2]));L=ea(g[q>>2]);M=ea(K+ea(L*ea(g[d+(B*12|0)+4>>2])));L=ea(g[r>>2]);K=ea(M+ea(L*ea(g[d+(B*12|0)+8>>2])));P=(g[k>>2]=K,c[k>>2]|0)&2147483640|3}if(!H)Q=2139095036;else{K=ea(g[m>>2]);L=ea(K*ea(g[C>>2]));K=ea(g[n>>2]);M=ea(L+ea(K*ea(g[d+(B*12|0)+4>>2])));K=ea(g[o>>2]);L=ea(M+ea(K*ea(g[d+(B*12|0)+8>>2])));Q=(g[k>>2]=L,c[k>>2]|0)&2147483640|4}C=N>>>0<J>>>0;H=C?N:J;G=C?J:N;C=O>>>0<G>>>0;F=C?O:G;E=C?G:O;G=P>>>0<E>>>0;C=G?P:E;D=G?E:P;E=Q>>>0<D>>>0;G=E?Q:D;R=E?D:Q;D=F>>>0<H>>>0;E=D?F:H;S=D?H:F;F=C>>>0<S>>>0;H=F?C:S;D=F?S:C;C=G>>>0<D>>>0;S=C?G:D;F=C?D:G;G=R>>>0<F>>>0;D=G?R:F;C=G?F:R;R=H>>>0<E>>>0;F=R?H:E;G=R?E:H;H=S>>>0<G>>>0;E=H?S:G;R=H?G:S;S=D>>>0<R>>>0;G=S?D:R;H=S?R:D;D=C>>>0<H>>>0;R=D?C:H;S=D?H:C;C=E>>>0<F>>>0;H=C?F:E;D=G>>>0<H>>>0;T=D?H:G;U=R>>>0<T>>>0;V=U?T:R;W=S>>>0<V>>>0;I=((D?G:H)<<3&56|(C?E:F)&7|(U?R:T)<<6&448|(W?S:V)<<9&3584|(W?V:S)<<12&28672)&65535}b[a+(B<<1)+208>>1]=I;B=B+1|0}while((B|0)!=8);i=e;return}function D2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;e=ea(g[c>>2]);f=ea(g[c+4>>2]);h=ea(g[c+8>>2]);g[a+16>>2]=e;g[a+20>>2]=f;g[a+24>>2]=h;g[a+28>>2]=ea(0.0);h=ea(g[d>>2]);f=ea(g[d+4>>2]);e=ea(g[d+8>>2]);g[a>>2]=h;d=a+4|0;g[d>>2]=f;c=a+8|0;g[c>>2]=e;g[a+12>>2]=ea(0.0);e=ea(g[b>>2]);f=ea(g[b+12>>2]);h=ea(g[b+24>>2]);i=ea(g[b+4>>2]);j=ea(g[b+16>>2]);k=ea(g[b+28>>2]);l=ea(g[b+8>>2]);m=ea(g[b+20>>2]);n=ea(g[b+32>>2]);g[a+32>>2]=e;g[a+36>>2]=f;g[a+40>>2]=h;g[a+44>>2]=ea(0.0);g[a+48>>2]=i;g[a+52>>2]=j;g[a+56>>2]=k;g[a+60>>2]=ea(0.0);g[a+64>>2]=l;g[a+68>>2]=m;g[a+72>>2]=n;g[a+76>>2]=ea(0.0);o=ea(-e);p=ea(-f);q=ea(-h);r=ea((e>o?e:o)+ea(9.99999997e-07));o=ea((f>p?f:p)+ea(9.99999997e-07));p=ea((h>q?h:q)+ea(9.99999997e-07));q=ea(-i);h=ea(-j);f=ea(-k);e=ea((i>q?i:q)+ea(9.99999997e-07));q=ea((j>h?j:h)+ea(9.99999997e-07));h=ea((k>f?k:f)+ea(9.99999997e-07));f=ea(-l);k=ea(-m);j=ea(-n);i=ea((l>f?l:f)+ea(9.99999997e-07));f=ea((m>k?m:k)+ea(9.99999997e-07));k=ea((n>j?n:j)+ea(9.99999997e-07));g[a+80>>2]=r;g[a+84>>2]=o;g[a+88>>2]=p;g[a+92>>2]=ea(0.0);g[a+96>>2]=e;g[a+100>>2]=q;g[a+104>>2]=h;g[a+108>>2]=ea(0.0);g[a+112>>2]=i;g[a+116>>2]=f;g[a+120>>2]=k;g[a+124>>2]=ea(0.0);j=ea(g[a>>2]);n=ea(g[d>>2]);m=ea(g[c>>2]);l=ea(ea(ea(j*e)+ea(n*q))+ea(m*h));h=ea(ea(ea(j*i)+ea(n*f))+ea(m*k));g[a+128>>2]=ea(ea(ea(j*r)+ea(n*o))+ea(m*p));g[a+132>>2]=l;g[a+136>>2]=h;g[a+140>>2]=ea(0.0);return}function E2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0;a=i;i=i+48|0;h=a+36|0;j=a;l=a+32|0;m=b+28|0;a:do if(c[m>>2]|0){n=j+4|0;o=j+8|0;p=j+16|0;q=j+20|0;r=j+24|0;s=0;while(1){c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;t=ea(g[b+(s*24|0)+160>>2]);u=ea(g[b+(s*24|0)+172>>2]);v=ea(t+u);w=ea(g[b+(s*24|0)+164>>2]);x=ea(g[b+(s*24|0)+176>>2]);y=ea(w+x);z=ea(g[b+(s*24|0)+168>>2]);A=ea(g[b+(s*24|0)+180>>2]);B=ea(y*ea(.5));y=ea(ea(z+A)*ea(.5));g[j>>2]=ea(v*ea(.5));g[n>>2]=B;g[o>>2]=y;y=ea(ea(x-w)*ea(.5));w=ea(ea(A-z)*ea(.5));g[p>>2]=ea(ea(u-t)*ea(.5));g[q>>2]=y;g[r>>2]=w;if((AEb(d,j)|0)!=0?(g[l>>2]=ea(-1.0),!(kn[c[c[e>>2]>>2]&511](e,l,b+(s<<3)+32|0,1)|0)):0){C=0;break}s=s+1|0;if(s>>>0>=(c[m>>2]|0)>>>0)break a}i=a;return C|0}while(0);if(!(c[b+584>>2]|0)){C=1;i=a;return C|0}if(!(AEb(d,b+608|0)|0)){C=1;i=a;return C|0}m=c[b+592>>2]|0;w=ea(g[f+(m<<2)>>2]);l=(g[k>>2]=w,c[k>>2]|0);w=ea(g[f+12+(m<<2)>>2]);m=(g[k>>2]=w,c[k>>2]|0);f=(l|0)<0?~l:l|-2147483648;l=(m|0)<0?~m:m|-2147483648;m=b+20|0;j=b+24|0;s=0;b:while(1){if((c[b+(s<<2)+640>>2]|0)!=0?(AEb(d,b+(s<<5)+688|0)|0)!=0:0){r=b+(s<<2)+660|0;q=0;do{if((c[b+(s*224|0)+(q<<2)+864>>2]|0)!=0?(AEb(d,b+(s*224|0)+(q<<5)+912|0)|0)!=0:0){p=b+(s*224|0)+(q<<2)+884|0;o=0;do{n=c[b+(s*1120|0)+(q*224|0)+(o<<2)+1984>>2]|0;c:do if((n|0)!=0?(AEb(d,b+(s*1120|0)+(q*224|0)+(o<<5)+2032|0)|0)!=0:0){D=(c[p>>2]|0)+(c[r>>2]|0)+(c[b+(s*1120|0)+(q*224|0)+(o<<2)+2004>>2]|0)|0;E=n;F=(c[m>>2]|0)+(D<<5)|0;G=(c[j>>2]|0)+(D<<3)|0;do{E=E+-1|0;D=F;F=F+32|0;if((c[D+28>>2]|0)>>>0>=f>>>0){if((c[D+12>>2]|0)>>>0>l>>>0)break c;if((AEb(d,D)|0)!=0?(g[h>>2]=ea(-1.0),!(kn[c[c[e>>2]>>2]&511](e,h,G,1)|0)):0){C=0;H=26;break b}}G=G+8|0}while((E|0)!=0)}while(0);o=o+1|0}while(o>>>0<5)}q=q+1|0}while(q>>>0<5)}s=s+1|0;if(s>>>0>=5){C=1;H=26;break}}if((H|0)==26){i=a;return C|0}return 0}function F2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=i;i=i+16|0;h=a+4|0;j=a;l=b+28|0;m=c[l>>2]|0;a:do if(m){n=d+12|0;o=d+4|0;p=d+16|0;q=d+8|0;r=d+20|0;s=m;t=0;while(1){u=ea(g[b+(t*24|0)+160>>2]);v=ea(g[b+(t*24|0)+172>>2]);w=ea(u+v);x=ea(g[b+(t*24|0)+164>>2]);y=ea(g[b+(t*24|0)+176>>2]);z=ea(x+y);A=ea(g[b+(t*24|0)+168>>2]);B=ea(g[b+(t*24|0)+180>>2]);C=ea(w*ea(.5));w=ea(z*ea(.5));z=ea(ea(A+B)*ea(.5));D=ea(ea(v-u)*ea(.5));u=ea(ea(y-x)*ea(.5));x=ea(ea(B-A)*ea(.5));A=ea(w-u);B=ea(z-x);y=ea(C+D);v=ea(w+u);u=ea(z+x);if(((((!(ea(g[d>>2])>y)?(y=ea(C-D),!(y>ea(g[n>>2]))):0)?!(ea(g[o>>2])>v):0)?!(A>ea(g[p>>2])):0)?!(ea(g[q>>2])>u):0)?!(B>ea(g[r>>2])):0){g[j>>2]=ea(-1.0);if(!(kn[c[c[e>>2]>>2]&511](e,j,b+(t<<3)+32|0,1)|0)){E=0;break}F=c[l>>2]|0}else F=s;t=t+1|0;if(t>>>0>=F>>>0)break a;else s=F}i=a;return E|0}while(0);if(!(c[b+584>>2]|0)){E=1;i=a;return E|0}B=ea(g[b+608>>2]);u=ea(g[b+624>>2]);A=ea(g[b+612>>2]);v=ea(g[b+628>>2]);y=ea(A-v);D=ea(g[b+616>>2]);C=ea(g[b+632>>2]);x=ea(D-C);z=ea(B+u);w=ea(A+v);v=ea(D+C);if(ea(g[d>>2])>z){E=1;i=a;return E|0}z=ea(B-u);F=d+12|0;if(z>ea(g[F>>2])){E=1;i=a;return E|0}l=d+4|0;if(ea(g[l>>2])>w){E=1;i=a;return E|0}j=d+16|0;if(y>ea(g[j>>2])){E=1;i=a;return E|0}m=d+8|0;if(ea(g[m>>2])>v){E=1;i=a;return E|0}s=d+20|0;if(x>ea(g[s>>2])){E=1;i=a;return E|0}t=c[b+592>>2]|0;x=ea(g[f+(t<<2)>>2]);r=(g[k>>2]=x,c[k>>2]|0);x=ea(g[f+12+(t<<2)>>2]);t=(g[k>>2]=x,c[k>>2]|0);f=(r|0)<0?~r:r|-2147483648;r=(t|0)<0?~t:t|-2147483648;t=b+20|0;q=b+24|0;p=0;b:while(1){if(((((((c[b+(p<<2)+640>>2]|0)!=0?(x=ea(g[b+(p<<5)+688>>2]),v=ea(g[b+(p<<5)+704>>2]),y=ea(g[b+(p<<5)+692>>2]),w=ea(g[b+(p<<5)+708>>2]),z=ea(y-w),u=ea(g[b+(p<<5)+696>>2]),B=ea(g[b+(p<<5)+712>>2]),C=ea(u-B),D=ea(x+v),A=ea(y+w),w=ea(u+B),!(ea(g[d>>2])>D)):0)?(D=ea(x-v),!(D>ea(g[F>>2]))):0)?!(ea(g[l>>2])>A):0)?!(z>ea(g[j>>2])):0)?!(ea(g[m>>2])>w):0)?!(C>ea(g[s>>2])):0){o=b+(p<<2)+660|0;n=0;do{do if(c[b+(p*224|0)+(n<<2)+864>>2]|0){C=ea(g[b+(p*224|0)+(n<<5)+912>>2]);w=ea(g[b+(p*224|0)+(n<<5)+928>>2]);z=ea(g[b+(p*224|0)+(n<<5)+916>>2]);A=ea(g[b+(p*224|0)+(n<<5)+932>>2]);D=ea(z-A);v=ea(g[b+(p*224|0)+(n<<5)+920>>2]);x=ea(g[b+(p*224|0)+(n<<5)+936>>2]);B=ea(v-x);u=ea(C+w);y=ea(z+A);A=ea(v+x);if(ea(g[d>>2])>u)break;u=ea(C-w);if(u>ea(g[F>>2]))break;if(ea(g[l>>2])>y)break;if(D>ea(g[j>>2]))break;if(ea(g[m>>2])>A)break;if(B>ea(g[s>>2]))break;G=b+(p*224|0)+(n<<2)+884|0;H=0;do{I=c[b+(p*1120|0)+(n*224|0)+(H<<2)+1984>>2]|0;c:do if(I){B=ea(g[b+(p*1120|0)+(n*224|0)+(H<<5)+2032>>2]);A=ea(g[b+(p*1120|0)+(n*224|0)+(H<<5)+2048>>2]);D=ea(g[b+(p*1120|0)+(n*224|0)+(H<<5)+2036>>2]);y=ea(g[b+(p*1120|0)+(n*224|0)+(H<<5)+2052>>2]);u=ea(D-y);w=ea(g[b+(p*1120|0)+(n*224|0)+(H<<5)+2040>>2]);C=ea(g[b+(p*1120|0)+(n*224|0)+(H<<5)+2056>>2]);x=ea(w-C);v=ea(B+A);z=ea(D+y);y=ea(w+C);if(ea(g[d>>2])>v)break;v=ea(B-A);if(v>ea(g[F>>2]))break;if(ea(g[l>>2])>z)break;if(u>ea(g[j>>2]))break;if(ea(g[m>>2])>y)break;if(x>ea(g[s>>2]))break;J=(c[G>>2]|0)+(c[o>>2]|0)+(c[b+(p*1120|0)+(n*224|0)+(H<<2)+2004>>2]|0)|0;K=I;L=(c[t>>2]|0)+(J<<5)|0;M=(c[q>>2]|0)+(J<<3)|0;do{K=K+-1|0;J=L;L=L+32|0;do if((c[J+28>>2]|0)>>>0>=f>>>0){if((c[J+12>>2]|0)>>>0>r>>>0)break c;x=ea(g[J>>2]);y=ea(g[J+16>>2]);u=ea(g[J+4>>2]);z=ea(g[J+20>>2]);v=ea(u-z);A=ea(g[J+8>>2]);B=ea(g[J+24>>2]);C=ea(A-B);w=ea(x+y);D=ea(u+z);z=ea(A+B);if(ea(g[d>>2])>w)break;w=ea(x-y);if(w>ea(g[F>>2]))break;if(ea(g[l>>2])>D)break;if(v>ea(g[j>>2]))break;if(ea(g[m>>2])>z)break;if(C>ea(g[s>>2]))break;g[h>>2]=ea(-1.0);if(!(kn[c[c[e>>2]>>2]&511](e,h,M,1)|0)){E=0;N=57;break b}}while(0);M=M+8|0}while((K|0)!=0)}while(0);H=H+1|0}while(H>>>0<5)}while(0);n=n+1|0}while(n>>>0<5)}p=p+1|0;if(p>>>0>=5){E=1;N=57;break}}if((N|0)==57){i=a;return E|0}return 0}function G2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;a=i;i=i+16|0;h=a+4|0;j=a;l=b+28|0;m=c[l>>2]|0;a:do if(m){n=d+4|0;o=d+8|0;p=d+16|0;q=m;r=0;while(1){s=ea(g[b+(r*24|0)+160>>2]);t=ea(g[b+(r*24|0)+172>>2]);u=ea(s+t);v=ea(g[b+(r*24|0)+164>>2]);w=ea(g[b+(r*24|0)+176>>2]);x=ea(v+w);y=ea(g[b+(r*24|0)+168>>2]);z=ea(g[b+(r*24|0)+180>>2]);A=ea(u*ea(.5));u=ea(x*ea(.5));x=ea(ea(y+z)*ea(.5));B=ea(ea(t-s)*ea(.5));s=ea(ea(w-v)*ea(.5));v=ea(ea(z-y)*ea(.5));y=ea(g[d>>2]);z=ea(g[n>>2]);w=ea(y-A);A=ea(z-u);u=ea(ea(g[o>>2])-x);x=ea(-B);z=ea(-s);y=ea(-v);t=w<B?w:B;B=A<s?A:s;s=u<v?u:v;v=ea(w-(t>x?t:x));x=ea(A-(B>z?B:z));z=ea(u-(s>y?s:y));if(!(ea(g[p>>2])>=ea(ea(ea(v*v)+ea(x*x))+ea(z*z))))C=q;else{g[j>>2]=ea(-1.0);if(!(kn[c[c[e>>2]>>2]&511](e,j,b+(r<<3)+32|0,1)|0)){D=0;break}C=c[l>>2]|0}r=r+1|0;if(r>>>0>=C>>>0)break a;else q=C}i=a;return D|0}while(0);if(!(c[b+584>>2]|0)){D=1;i=a;return D|0}z=ea(g[b+608>>2]);x=ea(g[b+612>>2]);v=ea(g[b+616>>2]);y=ea(g[b+624>>2]);s=ea(g[b+628>>2]);u=ea(g[b+632>>2]);B=ea(g[d>>2]);C=d+4|0;A=ea(g[C>>2]);l=d+8|0;t=ea(B-z);z=ea(A-x);x=ea(ea(g[l>>2])-v);v=ea(-y);A=ea(-s);B=ea(-u);w=t<y?t:y;y=z<s?z:s;s=x<u?x:u;u=ea(t-(w>v?w:v));v=ea(z-(y>A?y:A));A=ea(x-(s>B?s:B));j=d+16|0;if(!(ea(g[j>>2])>=ea(ea(ea(u*u)+ea(v*v))+ea(A*A)))){D=1;i=a;return D|0}m=c[b+592>>2]|0;A=ea(g[f+(m<<2)>>2]);q=(g[k>>2]=A,c[k>>2]|0);A=ea(g[f+12+(m<<2)>>2]);m=(g[k>>2]=A,c[k>>2]|0);f=(q|0)<0?~q:q|-2147483648;q=(m|0)<0?~m:m|-2147483648;m=b+20|0;r=b+24|0;p=0;b:while(1){if((c[b+(p<<2)+640>>2]|0)!=0?(A=ea(g[b+(p<<5)+688>>2]),v=ea(g[b+(p<<5)+692>>2]),u=ea(g[b+(p<<5)+696>>2]),B=ea(g[b+(p<<5)+704>>2]),s=ea(g[b+(p<<5)+708>>2]),x=ea(g[b+(p<<5)+712>>2]),y=ea(g[d>>2]),z=ea(g[C>>2]),w=ea(y-A),A=ea(z-v),v=ea(ea(g[l>>2])-u),u=ea(-B),z=ea(-s),y=ea(-x),t=w<B?w:B,B=A<s?A:s,s=v<x?v:x,x=ea(w-(t>u?t:u)),u=ea(A-(B>z?B:z)),z=ea(v-(s>y?s:y)),ea(g[j>>2])>=ea(ea(ea(x*x)+ea(u*u))+ea(z*z))):0){o=b+(p<<2)+660|0;n=0;do{if((c[b+(p*224|0)+(n<<2)+864>>2]|0)!=0?(z=ea(g[b+(p*224|0)+(n<<5)+912>>2]),u=ea(g[b+(p*224|0)+(n<<5)+916>>2]),x=ea(g[b+(p*224|0)+(n<<5)+920>>2]),y=ea(g[b+(p*224|0)+(n<<5)+928>>2]),s=ea(g[b+(p*224|0)+(n<<5)+932>>2]),v=ea(g[b+(p*224|0)+(n<<5)+936>>2]),B=ea(g[d>>2]),A=ea(g[C>>2]),t=ea(B-z),z=ea(A-u),u=ea(ea(g[l>>2])-x),x=ea(-y),A=ea(-s),B=ea(-v),w=t<y?t:y,y=z<s?z:s,s=u<v?u:v,v=ea(t-(w>x?w:x)),x=ea(z-(y>A?y:A)),A=ea(u-(s>B?s:B)),ea(g[j>>2])>=ea(ea(ea(v*v)+ea(x*x))+ea(A*A))):0){E=b+(p*224|0)+(n<<2)+884|0;F=0;do{G=c[b+(p*1120|0)+(n*224|0)+(F<<2)+1984>>2]|0;c:do if((G|0)!=0?(A=ea(g[b+(p*1120|0)+(n*224|0)+(F<<5)+2032>>2]),x=ea(g[b+(p*1120|0)+(n*224|0)+(F<<5)+2036>>2]),v=ea(g[b+(p*1120|0)+(n*224|0)+(F<<5)+2040>>2]),B=ea(g[b+(p*1120|0)+(n*224|0)+(F<<5)+2048>>2]),s=ea(g[b+(p*1120|0)+(n*224|0)+(F<<5)+2052>>2]),u=ea(g[b+(p*1120|0)+(n*224|0)+(F<<5)+2056>>2]),y=ea(g[d>>2]),z=ea(g[C>>2]),w=ea(y-A),A=ea(z-x),x=ea(ea(g[l>>2])-v),v=ea(-B),z=ea(-s),y=ea(-u),t=w<B?w:B,B=A<s?A:s,s=x<u?x:u,u=ea(w-(t>v?t:v)),v=ea(A-(B>z?B:z)),z=ea(x-(s>y?s:y)),ea(g[j>>2])>=ea(ea(ea(u*u)+ea(v*v))+ea(z*z))):0){H=(c[E>>2]|0)+(c[o>>2]|0)+(c[b+(p*1120|0)+(n*224|0)+(F<<2)+2004>>2]|0)|0;I=G;J=(c[m>>2]|0)+(H<<5)|0;K=(c[r>>2]|0)+(H<<3)|0;do{I=I+-1|0;H=J;J=J+32|0;if((c[H+28>>2]|0)>>>0>=f>>>0){if((c[H+12>>2]|0)>>>0>q>>>0)break c;z=ea(g[H>>2]);v=ea(g[H+4>>2]);u=ea(g[H+8>>2]);y=ea(g[H+16>>2]);s=ea(g[H+20>>2]);x=ea(g[H+24>>2]);B=ea(g[d>>2]);A=ea(g[C>>2]);t=ea(B-z);z=ea(A-v);v=ea(ea(g[l>>2])-u);u=ea(-y);A=ea(-s);B=ea(-x);w=t<y?t:y;y=z<s?z:s;s=v<x?v:x;x=ea(t-(w>u?w:u));u=ea(z-(y>A?y:A));A=ea(v-(s>B?s:B));if(ea(g[j>>2])>=ea(ea(ea(x*x)+ea(u*u))+ea(A*A))?(g[h>>2]=ea(-1.0),!(kn[c[c[e>>2]>>2]&511](e,h,K,1)|0)):0){D=0;L=27;break b}}K=K+8|0}while((I|0)!=0)}while(0);F=F+1|0}while(F>>>0<5)}n=n+1|0}while(n>>>0<5)}p=p+1|0;if(p>>>0>=5){D=1;L=27;break}}if((L|0)==27){i=a;return D|0}return 0}function H2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?503552:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function I2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+352|0;j=h+296|0;k=h+288|0;l=h+272|0;m=h+256|0;n=h;c[k>>2]=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;c[l>>2]=k;o=l+4|0;c[o>>2]=0;c[l+8>>2]=0;p=l+12|0;c[p>>2]=0;c[m>>2]=k;k=m+4|0;c[k>>2]=0;c[m+8>>2]=0;q=m+12|0;c[q>>2]=0;xGa(n);c[j>>2]=l;c[j+4>>2]=m;r=j+8|0;c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[j+20>>2]=d;c[j+24>>2]=e;c[j+28>>2]=f;c[j+32>>2]=g;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;BEb(n,j,0)|0;j=c[q>>2]|0;if((j&2147483647|0)!=0&(j|0)>-1?(j=c[k>>2]|0,(j|0)!=0):0){k=c[c[m>>2]>>2]|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,j)}j=c[p>>2]|0;if(!((j&2147483647|0)!=0&(j|0)>-1)){i=h;return}j=c[o>>2]|0;if(!j){i=h;return}o=c[c[l>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,j);i=h;return}function J2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+256|0;j=h+48|0;k=h+192|0;l=h;m=h+240|0;n=h+32|0;o=h+16|0;p=h+96|0;c[m>>2]=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;c[n>>2]=m;q=n+4|0;c[q>>2]=0;c[n+8>>2]=0;r=n+12|0;c[r>>2]=0;c[o>>2]=m;m=o+4|0;c[m>>2]=0;c[o+8>>2]=0;s=o+12|0;c[s>>2]=0;rHa(p);c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[j>>2]=n;c[j+4>>2]=o;t=j+8|0;c[t+0>>2]=c[l+0>>2];c[t+4>>2]=c[l+4>>2];c[t+8>>2]=c[l+8>>2];c[j+20>>2]=d;c[j+24>>2]=e;c[j+28>>2]=f;c[j+32>>2]=g;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;CEb(j,p,0);DEb(j,p+16|0,0);EEb(j,p+32|0,0);FEb(j,p+48|0,0);c[k>>2]=n;c[k+4>>2]=o;j=k+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[k+20>>2]=d;c[k+24>>2]=e;c[k+28>>2]=f;c[k+32>>2]=g;a[k+36>>0]=1;c[k+40>>2]=0;c[k+44>>2]=0;GEb(k,p+64|0,0);HEb(k,p+80|0,0);p=c[s>>2]|0;if((p&2147483647|0)!=0&(p|0)>-1?(p=c[m>>2]|0,(p|0)!=0):0){m=c[c[o>>2]>>2]|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,p)}p=c[r>>2]|0;if(!((p&2147483647|0)!=0&(p|0)>-1)){i=h;return}p=c[q>>2]|0;if(!p){i=h;return}q=c[c[n>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,p);i=h;return}function K2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+352|0;j=h+120|0;k=h+72|0;l=h+16|0;m=h+168|0;n=h;o=h+64|0;p=h+48|0;q=h+32|0;r=h+216|0;c[o>>2]=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;c[p>>2]=o;s=p+4|0;c[s>>2]=0;c[p+8>>2]=0;t=p+12|0;c[t>>2]=0;c[q>>2]=o;o=q+4|0;c[o>>2]=0;c[q+8>>2]=0;u=q+12|0;c[u>>2]=0;uHa(r);c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[j>>2]=p;c[j+4>>2]=q;v=j+8|0;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[j+20>>2]=d;c[j+24>>2]=e;c[j+28>>2]=f;c[j+32>>2]=g;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;IEb(j,r+36|0,0);JEb(j,r+52|0,0);c[k>>2]=p;c[k+4>>2]=q;j=k+8|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[k+20>>2]=d;c[k+24>>2]=e;c[k+28>>2]=f;c[k+32>>2]=g;a[k+36>>0]=1;c[k+40>>2]=0;c[k+44>>2]=0;KEb(k,r+80|0,0);c[m>>2]=p;c[m+4>>2]=q;k=m+8|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[m+20>>2]=d;c[m+24>>2]=e;c[m+28>>2]=f;c[m+32>>2]=g;a[m+36>>0]=1;c[m+40>>2]=0;c[m+44>>2]=0;LEb(m,r+108|0,0);r=c[u>>2]|0;if((r&2147483647|0)!=0&(r|0)>-1?(r=c[o>>2]|0,(r|0)!=0):0){o=c[c[q>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,r)}r=c[t>>2]|0;if(!((r&2147483647|0)!=0&(r|0)>-1)){i=h;return}r=c[s>>2]|0;if(!r){i=h;return}s=c[c[p>>2]>>2]|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,r);i=h;return}function L2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+208|0;j=h;k=h+180|0;l=h+56|0;m=h+28|0;uHa(l);c[j>>2]=b;c[j+4>>2]=e;c[j+8>>2]=d;c[j+12>>2]=f;c[j+16>>2]=g;c[j+20>>2]=0;c[j+24>>2]=0;n=MEb(l,j,0)|0;c[k>>2]=b;c[k+4>>2]=e;c[k+8>>2]=d;c[k+12>>2]=f;c[k+16>>2]=g;c[k+20>>2]=0;c[k+24>>2]=0;NEb(l,k,n)|0;c[m>>2]=b;n=m+4|0;c[n>>2]=e;c[m+8>>2]=d;c[m+12>>2]=f;c[m+16>>2]=g;c[m+20>>2]=0;c[m+24>>2]=0;g=l+108|0;a[k>>0]=0;c[k+4>>2]=0;l=k+8|0;c[l+0>>2]=c[g+0>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];l=c[g>>2]|0;g=b+8|0;f=c[g>>2]|0;if(f){d=f+-1|0;o=b+4|0;p=c[o>>2]|0;if(!(a[p+(d<<3)+4>>0]|0)){In[c[(c[e>>2]|0)+16>>2]&4095](e,c[p+(d<<3)>>2]|0);d=c[g>>2]|0;a[(c[o>>2]|0)+(d+-1<<3)+4>>0]=1;q=d}else q=f}else q=0;c[j>>2]=l;a[j+4>>0]=0;if((c[b+12>>2]&2147483647)>>>0>q>>>0){l=(c[b+4>>2]|0)+(q<<3)|0;if(!l)r=q;else{q=j;f=c[q+4>>2]|0;d=l;c[d>>2]=c[q>>2];c[d+4>>2]=f;r=c[g>>2]|0}c[g>>2]=r+1}else OAb(b,j)|0;OEb(m,k);k=c[m>>2]|0;m=k+8|0;j=c[m>>2]|0;if(!j){i=h;return}if(!(a[(c[k+4>>2]|0)+(j+-1<<3)+4>>0]|0))s=j;else{j=c[n>>2]|0;ko[c[(c[j>>2]|0)+20>>2]&4095](j);s=c[m>>2]|0}c[m>>2]=s+-1;i=h;return}function M2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+368|0;j=h+120|0;k=h+72|0;l=h+16|0;m=h+168|0;n=h;o=h+64|0;p=h+48|0;q=h+32|0;r=h+216|0;c[o>>2]=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;c[p>>2]=o;s=p+4|0;c[s>>2]=0;c[p+8>>2]=0;t=p+12|0;c[t>>2]=0;c[q>>2]=o;o=q+4|0;c[o>>2]=0;c[q+8>>2]=0;u=q+12|0;c[u>>2]=0;yHa(r);c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[j>>2]=p;c[j+4>>2]=q;v=j+8|0;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[j+20>>2]=d;c[j+24>>2]=e;c[j+28>>2]=f;c[j+32>>2]=g;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;PEb(j,r+36|0,0);QEb(j,r+52|0,0);c[k>>2]=p;c[k+4>>2]=q;j=k+8|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[k+20>>2]=d;c[k+24>>2]=e;c[k+28>>2]=f;c[k+32>>2]=g;a[k+36>>0]=1;c[k+40>>2]=0;c[k+44>>2]=0;REb(k,r+80|0,0);c[m>>2]=p;c[m+4>>2]=q;k=m+8|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[m+20>>2]=d;c[m+24>>2]=e;c[m+28>>2]=f;c[m+32>>2]=g;a[m+36>>0]=1;c[m+40>>2]=0;c[m+44>>2]=0;SEb(m,r+96|0,0);TEb(m,r+124|0,0);r=c[u>>2]|0;if((r&2147483647|0)!=0&(r|0)>-1?(r=c[o>>2]|0,(r|0)!=0):0){o=c[c[q>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,r)}r=c[t>>2]|0;if(!((r&2147483647|0)!=0&(r|0)>-1)){i=h;return}r=c[s>>2]|0;if(!r){i=h;return}s=c[c[p>>2]>>2]|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,r);i=h;return}function N2a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+240|0;g=f+212|0;h=f+184|0;j=f+44|0;k=f+16|0;l=f;c[l>>2]=c[d+8>>2];m=l+4|0;c[m>>2]=0;c[l+8>>2]=0;n=l+12|0;c[n>>2]=0;yHa(j);c[g>>2]=l;c[g+4>>2]=b;c[g+8>>2]=a;c[g+12>>2]=d;c[g+16>>2]=e;c[g+20>>2]=0;c[g+24>>2]=0;o=UEb(j,g,0)|0;c[h>>2]=l;c[h+4>>2]=b;c[h+8>>2]=a;c[h+12>>2]=d;c[h+16>>2]=e;c[h+20>>2]=0;c[h+24>>2]=0;VEb(j,h,o)|0;c[k>>2]=l;c[k+4>>2]=b;c[k+8>>2]=a;c[k+12>>2]=d;c[k+16>>2]=e;c[k+20>>2]=0;c[k+24>>2]=0;WEb(j,k,0)|0;k=c[n>>2]|0;if(!((k&2147483647|0)!=0&(k|0)>-1)){i=f;return}k=c[m>>2]|0;if(!k){i=f;return}m=c[c[l>>2]>>2]|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,k);i=f;return}function O2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+352|0;j=h+120|0;k=h+72|0;l=h+16|0;m=h+168|0;n=h;o=h+64|0;p=h+48|0;q=h+32|0;r=h+216|0;c[o>>2]=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;c[p>>2]=o;s=p+4|0;c[s>>2]=0;c[p+8>>2]=0;t=p+12|0;c[t>>2]=0;c[q>>2]=o;o=q+4|0;c[o>>2]=0;c[q+8>>2]=0;u=q+12|0;c[u>>2]=0;DHa(r);c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[j>>2]=p;c[j+4>>2]=q;v=j+8|0;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[j+20>>2]=d;c[j+24>>2]=e;c[j+28>>2]=f;c[j+32>>2]=g;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;XEb(j,r+36|0,0);YEb(j,r+52|0,0);c[k>>2]=p;c[k+4>>2]=q;j=k+8|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[k+20>>2]=d;c[k+24>>2]=e;c[k+28>>2]=f;c[k+32>>2]=g;a[k+36>>0]=1;c[k+40>>2]=0;c[k+44>>2]=0;ZEb(k,r+80|0,0);c[m>>2]=p;c[m+4>>2]=q;k=m+8|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[m+20>>2]=d;c[m+24>>2]=e;c[m+28>>2]=f;c[m+32>>2]=g;a[m+36>>0]=1;c[m+40>>2]=0;c[m+44>>2]=0;_Eb(m,r+108|0,0);r=c[u>>2]|0;if((r&2147483647|0)!=0&(r|0)>-1?(r=c[o>>2]|0,(r|0)!=0):0){o=c[c[q>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,r)}r=c[t>>2]|0;if(!((r&2147483647|0)!=0&(r|0)>-1)){i=h;return}r=c[s>>2]|0;if(!r){i=h;return}s=c[c[p>>2]>>2]|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,r);i=h;return}function P2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+208|0;j=h;k=h+180|0;l=h+56|0;m=h+28|0;DHa(l);c[j>>2]=b;c[j+4>>2]=e;c[j+8>>2]=d;c[j+12>>2]=f;c[j+16>>2]=g;c[j+20>>2]=0;c[j+24>>2]=0;n=$Eb(l,j,0)|0;c[k>>2]=b;c[k+4>>2]=e;c[k+8>>2]=d;c[k+12>>2]=f;c[k+16>>2]=g;c[k+20>>2]=0;c[k+24>>2]=0;aFb(l,k,n)|0;c[m>>2]=b;n=m+4|0;c[n>>2]=e;c[m+8>>2]=d;c[m+12>>2]=f;c[m+16>>2]=g;c[m+20>>2]=0;c[m+24>>2]=0;g=l+108|0;a[k>>0]=0;c[k+4>>2]=0;l=k+8|0;c[l+0>>2]=c[g+0>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];l=c[g>>2]|0;g=b+8|0;f=c[g>>2]|0;if(f){d=f+-1|0;o=b+4|0;p=c[o>>2]|0;if(!(a[p+(d<<3)+4>>0]|0)){In[c[(c[e>>2]|0)+16>>2]&4095](e,c[p+(d<<3)>>2]|0);d=c[g>>2]|0;a[(c[o>>2]|0)+(d+-1<<3)+4>>0]=1;q=d}else q=f}else q=0;c[j>>2]=l;a[j+4>>0]=0;if((c[b+12>>2]&2147483647)>>>0>q>>>0){l=(c[b+4>>2]|0)+(q<<3)|0;if(!l)r=q;else{q=j;f=c[q+4>>2]|0;d=l;c[d>>2]=c[q>>2];c[d+4>>2]=f;r=c[g>>2]|0}c[g>>2]=r+1}else OAb(b,j)|0;bFb(m,k);k=c[m>>2]|0;m=k+8|0;j=c[m>>2]|0;if(!j){i=h;return}if(!(a[(c[k+4>>2]|0)+(j+-1<<3)+4>>0]|0))s=j;else{j=c[n>>2]|0;ko[c[(c[j>>2]|0)+20>>2]&4095](j);s=c[m>>2]|0}c[m>>2]=s+-1;i=h;return}function Q2a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+304|0;j=h+48|0;k=h+248|0;l=h;m=h+296|0;n=h+32|0;o=h+16|0;p=h+96|0;c[m>>2]=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;c[n>>2]=m;q=n+4|0;c[q>>2]=0;c[n+8>>2]=0;r=n+12|0;c[r>>2]=0;c[o>>2]=m;m=o+4|0;c[m>>2]=0;c[o+8>>2]=0;s=o+12|0;c[s>>2]=0;OHa(p);c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[j>>2]=n;c[j+4>>2]=o;t=j+8|0;c[t+0>>2]=c[l+0>>2];c[t+4>>2]=c[l+4>>2];c[t+8>>2]=c[l+8>>2];c[j+20>>2]=d;c[j+24>>2]=e;c[j+28>>2]=f;c[j+32>>2]=g;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;cFb(j,p+36|0,0);dFb(j,p+52|0,0);c[k>>2]=n;c[k+4>>2]=o;l=k+8|0;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[k+20>>2]=d;c[k+24>>2]=e;c[k+28>>2]=f;c[k+32>>2]=g;a[k+36>>0]=1;c[k+40>>2]=0;c[k+44>>2]=0;a[j>>0]=0;eFb(k,0,p+68|0,j);a[j>>0]=0;fFb(k,1,p+92|0,j);a[j>>0]=0;gFb(k,2,p+116|0,j);j=c[s>>2]|0;if((j&2147483647|0)!=0&(j|0)>-1?(j=c[m>>2]|0,(j|0)!=0):0){m=c[c[o>>2]>>2]|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,j)}j=c[r>>2]|0;if(!((j&2147483647|0)!=0&(j|0)>-1)){i=h;return}j=c[q>>2]|0;if(!j){i=h;return}q=c[c[n>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,j);i=h;return}function R2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+36|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;hFb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+52|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[v+0>>2];c[b+4>>2]=c[v+4>>2];c[b+8>>2]=c[v+8>>2];c[b+12>>2]=c[v+12>>2];b=c[v>>2]|0;if(s){v=s+-1|0;u=c[t+4>>2]|0;if(!(a[u+(v<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[u+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=b;a[g+4>>0]=0;b=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[b>>2]|0}c[b>>2]=y+1}else OAb(w,g)|0;iFb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){z=e+5|0;i=f;return z|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){A=h;B=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;A=g;B=c[g+8>>2]|0}c[A+8>>2]=B+-1;z=e+5|0;i=f;return z|0}function S2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+68|0;k=c[j>>2]|0;l=c[d>>2]|0;m=c[l+8>>2]|0;if(m){n=m+-1|0;o=c[l+4>>2]|0;if(!(a[o+(n<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[o+(n<<3)>>2]|0);n=c[d>>2]|0;a[(c[n+4>>2]|0)+((c[n+8>>2]|0)+-1<<3)+4>>0]=1;n=c[d>>2]|0;q=n;r=c[n+8>>2]|0}else{q=l;r=m}}else{q=l;r=0}c[g>>2]=k;a[g+4>>0]=0;k=q+8|0;if((c[q+12>>2]&2147483647)>>>0>r>>>0){l=(c[q+4>>2]|0)+(r<<3)|0;if(!l)s=r;else{r=g;m=c[r+4>>2]|0;n=l;c[n>>2]=c[r>>2];c[n+4>>2]=m;s=c[k>>2]|0}c[k>>2]=s+1}else OAb(q,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=e;c[h+12>>2]=j;jFb(d,0,h,0);j=c[d>>2]|0;q=c[j+8>>2]|0;if(!q){t=0;u=j}else{if(!(a[(c[j+4>>2]|0)+(q+-1<<3)+4>>0]|0)){v=j;w=q}else{q=c[d+4>>2]|0;ko[c[(c[q>>2]|0)+20>>2]&4095](q);q=c[d>>2]|0;v=q;w=c[q+8>>2]|0}c[v+8>>2]=w+-1;w=c[d>>2]|0;t=c[w+8>>2]|0;u=w}w=b+92|0;v=e+1|0;q=c[w>>2]|0;if(t){j=t+-1|0;s=c[u+4>>2]|0;if(!(a[s+(j<<3)+4>>0]|0)){k=c[d+4>>2]|0;In[c[(c[k>>2]|0)+16>>2]&4095](k,c[s+(j<<3)>>2]|0);j=c[d>>2]|0;a[(c[j+4>>2]|0)+((c[j+8>>2]|0)+-1<<3)+4>>0]=1;j=c[d>>2]|0;x=j;y=c[j+8>>2]|0}else{x=u;y=t}}else{x=u;y=0}c[g>>2]=q;a[g+4>>0]=0;q=x+8|0;if((c[x+12>>2]&2147483647)>>>0>y>>>0){u=(c[x+4>>2]|0)+(y<<3)|0;if(!u)z=y;else{y=g;t=c[y+4>>2]|0;j=u;c[j>>2]=c[y>>2];c[j+4>>2]=t;z=c[q>>2]|0}c[q>>2]=z+1}else OAb(x,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=v;c[h+12>>2]=w;kFb(d,0,h,0);w=c[d>>2]|0;v=c[w+8>>2]|0;if(!v){A=0;B=w}else{if(!(a[(c[w+4>>2]|0)+(v+-1<<3)+4>>0]|0)){C=w;D=v}else{v=c[d+4>>2]|0;ko[c[(c[v>>2]|0)+20>>2]&4095](v);v=c[d>>2]|0;C=v;D=c[v+8>>2]|0}c[C+8>>2]=D+-1;D=c[d>>2]|0;A=c[D+8>>2]|0;B=D}D=b+116|0;b=e+2|0;C=c[D>>2]|0;if(A){v=A+-1|0;w=c[B+4>>2]|0;if(!(a[w+(v<<3)+4>>0]|0)){x=c[d+4>>2]|0;In[c[(c[x>>2]|0)+16>>2]&4095](x,c[w+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;E=v;F=c[v+8>>2]|0}else{E=B;F=A}}else{E=B;F=0}c[g>>2]=C;a[g+4>>0]=0;C=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){B=(c[E+4>>2]|0)+(F<<3)|0;if(!B)G=F;else{F=g;A=c[F+4>>2]|0;v=B;c[v>>2]=c[F>>2];c[v+4>>2]=A;G=c[C>>2]|0}c[C>>2]=G+1}else OAb(E,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=b;c[h+12>>2]=D;lFb(d,0,h,0);h=c[d>>2]|0;D=c[h+8>>2]|0;if(!D){H=e+4|0;i=f;return H|0}if(!(a[(c[h+4>>2]|0)+(D+-1<<3)+4>>0]|0)){I=h;J=D}else{D=c[d+4>>2]|0;ko[c[(c[D>>2]|0)+20>>2]&4095](D);D=c[d>>2]|0;I=D;J=c[D+8>>2]|0}c[I+8>>2]=J+-1;H=e+4|0;i=f;return H|0}function T2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=0,r=0,s=Im,t=0,u=Im,v=Im,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+2224|0;e=d+96|0;f=d;h=c[b+2116>>2]|0;j=(h|0)==0;if(!j){k=h;l=0;while(1){if(!k)m=0;else{YEi(e+(l*92|0)|0,b+(l*92|0)|0,k<<2|0)|0;m=k}l=l+1|0;if(l>>>0>=m>>>0)break;else k=m}k=e+2116|0;c[k>>2]=m;if(j)n=k;else{PEi(a|0,-1,h<<2|0)|0;n=k}}else{k=e+2116|0;c[k>>2]=0;n=k}k=h+-1|0;m=0;do{o=ea(0.0);l=0;do{p=ea(S(ea(g[e+(m*92|0)+(l<<2)>>2])));o=p>o?p:o;l=l+1|0}while(l>>>0<=k>>>0);g[f+(m<<2)>>2]=ea(ea(1.0)/o);m=m+1|0}while(m>>>0<=k>>>0);q=0;r=0;while(1){m=(r|0)==0;if(!m){l=0;do{b=e+(l*92|0)+(r<<2)|0;p=ea(g[b>>2]);if(!l)s=p;else{t=0;u=p;while(1){p=ea(g[e+(l*92|0)+(t<<2)>>2]);v=ea(u-ea(p*ea(g[e+(t*92|0)+(r<<2)>>2])));t=t+1|0;if((t|0)==(l|0)){s=v;break}else u=v}}g[b>>2]=s;l=l+1|0}while((l|0)!=(r|0));if(!m){o=ea(0.0);l=r;t=q;while(1){w=e+(l*92|0)+(r<<2)|0;x=0;u=ea(g[w>>2]);do{v=ea(g[e+(l*92|0)+(x<<2)>>2]);u=ea(u-ea(v*ea(g[e+(x*92|0)+(r<<2)>>2])));x=x+1|0}while((x|0)!=(r|0));g[w>>2]=u;v=ea(ea(g[f+(l<<2)>>2])*ea(S(ea(u))));x=!(v>=o);b=x?t:l;l=l+1|0;if(l>>>0>k>>>0){y=b;break}else{o=x?o:v;t=b}}}else{z=ea(0.0);A=0;B=q;C=20}}else{z=ea(0.0);A=0;B=q;C=20}if((C|0)==20)while(1){C=0;o=ea(g[e+(A*92|0)>>2]);v=ea(ea(g[f+(A<<2)>>2])*ea(S(ea(o))));t=!(v>=z);l=t?B:A;A=A+1|0;if(A>>>0>k>>>0){y=l;break}else{z=t?z:v;B=l;C=20}}if((r|0)!=(y|0)){if(!j){l=0;do{t=e+(y*92|0)+(l<<2)|0;v=ea(g[t>>2]);m=e+(r*92|0)+(l<<2)|0;g[t>>2]=ea(g[m>>2]);g[m>>2]=v;l=l+1|0}while((l|0)!=(h|0))}g[f+(y<<2)>>2]=ea(g[f+(r<<2)>>2])}c[a+(r<<2)>>2]=y;l=e+(r*92|0)+(r<<2)|0;v=ea(g[l>>2]);if(v==ea(0.0)){g[l>>2]=ea(9.99999968e-21);D=ea(9.99999968e-21)}else D=v;if((r|0)!=(k|0)){v=ea(ea(1.0)/D);l=r+1|0;if(l>>>0>k>>>0)E=l;else{m=l;do{t=e+(m*92|0)+(r<<2)|0;g[t>>2]=ea(v*ea(g[t>>2]));m=m+1|0}while(m>>>0<=k>>>0);E=l}}else E=r+1|0;if(E>>>0>k>>>0)break;else{q=y;r=E}}E=c[n>>2]|0;if(!E){F=0;G=a+2208|0;c[G>>2]=F;i=d;return}else{H=E;I=0}while(1){if(!H)J=0;else{YEi(a+(I*92|0)+92|0,e+(I*92|0)|0,H<<2|0)|0;J=H}I=I+1|0;if(I>>>0>=J>>>0){F=J;break}else H=J}G=a+2208|0;c[G>>2]=F;i=d;return}function U2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=0,s=Im;e=i;f=c[b+92>>2]|0;h=(f|0)==0;if(h){c[d+92>>2]=0;i=e;return}else j=0;do{g[d+(j<<2)>>2]=ea(g[b+(j<<2)>>2]);j=j+1|0}while((j|0)!=(f|0));c[d+92>>2]=f;if(h){i=e;return}else{k=0;l=-1}while(1){h=d+(c[a+(k<<2)>>2]<<2)|0;m=ea(g[h>>2]);j=d+(k<<2)|0;g[h>>2]=ea(g[j>>2]);if((l|0)==-1)if(m!=ea(0.0)){n=k;o=m}else{n=-1;o=m}else{h=k+-1|0;if(l>>>0>h>>>0){n=l;o=m}else{b=l;p=m;while(1){m=ea(g[a+(k*92|0)+(b<<2)+92>>2]);q=ea(p-ea(m*ea(g[d+(b<<2)>>2])));b=b+1|0;if(b>>>0>h>>>0){n=l;o=q;break}else p=q}}}g[j>>2]=o;k=k+1|0;if((k|0)==(f|0))break;else l=n}n=f+-1|0;if((n|0)>-1)r=n;else{i=e;return}while(1){f=d+(r<<2)|0;o=ea(g[f>>2]);l=r+1|0;if(l>>>0>n>>>0)s=o;else{k=l;p=o;while(1){o=ea(g[a+(r*92|0)+(k<<2)+92>>2]);q=ea(p-ea(o*ea(g[d+(k<<2)>>2])));k=k+1|0;if(k>>>0>n>>>0){s=q;break}else p=q}}g[f>>2]=ea(s/ea(g[a+(r*92|0)+(r<<2)+92>>2]));if((r|0)>0)r=r+-1|0;else break}i=e;return}function V2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d;f=c[b+12>>2]|0;c[a>>2]=f;g=a+4|0;h=c[b+4>>2]|0;c[g>>2]=h;c[a+8>>2]=c[b+8>>2];PEi(a+12|0,-1,2048)|0;if(!f){i=d;return};c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;b=0;j=0;k=2;while(1){l=0;m=0;while(1){n=(c[h+(l<<2)>>2]|0)>>>k;o=e+((n>>>5&7)<<2)|0;p=c[o>>2]|0;q=1<<(n&31);if(!(q&p)){c[o>>2]=q|p;r=m+1|0}else r=m;l=l+1|0;if(l>>>0>=f>>>0)break;else m=r}s=(r|0)==(f|0);if(r>>>0<=b>>>0){t=11;break}if(s){t=10;break}c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;m=k;b=r;k=k<<1;j=m}if((t|0)==10){u=a+2060|0;t=12}else if((t|0)==11){r=a+2060|0;if(s){u=r;t=12}else{v=r;w=j}}if((t|0)==12){v=u;w=k}c[v>>2]=w;if(!f){i=d;return}else{x=h;y=w;z=0}while(1){w=a+(((c[x+(z<<2)>>2]|0)>>>y&255)<<2)+12|0;c[a+(z<<2)+1036>>2]=c[w>>2];c[w>>2]=z;w=z+1|0;if(w>>>0>=(c[a>>2]|0)>>>0)break;x=c[g>>2]|0;y=c[v>>2]|0;z=w}i=d;return}function W2a(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;f=ea(g[a+4>>2]);h=ea(g[b+8>>2]);i=ea(f*h);j=ea(g[a+8>>2]);k=ea(g[b+4>>2]);l=ea(i-ea(j*k));i=ea(g[b>>2]);m=ea(j*i);j=ea(g[a>>2]);n=ea(m-ea(h*j));m=ea(ea(k*j)-ea(f*i));f=ea(ea(k*m)-ea(h*n));j=ea(ea(h*l)-ea(i*m));h=ea(ea(i*n)-ea(k*l));k=ea(T(ea(ea(m*m)+ea(ea(l*l)+ea(n*n)))));if(k>ea(0.0)){i=ea(ea(1.0)/k);o=ea(l*i);p=ea(n*i);q=ea(m*i)}else{o=l;p=n;q=m}m=ea(T(ea(ea(h*h)+ea(ea(f*f)+ea(j*j)))));if(m>ea(0.0)){n=ea(ea(1.0)/m);r=ea(f*n);s=ea(j*n);t=ea(h*n)}else{r=f;s=j;t=h}h=ea(+V(+c));j=ea(+W(+c));c=ea(ea(p*h)+ea(s*j));f=ea(ea(q*h)+ea(t*j));n=ea(ea(r*h)-ea(o*j));m=ea(ea(s*h)-ea(p*j));p=ea(ea(t*h)-ea(q*j));g[d>>2]=ea(ea(o*h)+ea(r*j));g[d+4>>2]=c;g[d+8>>2]=f;g[e>>2]=n;g[e+4>>2]=m;g[e+8>>2]=p;return}function X2a(a,b,d,e,f,h){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=Im;a=i;i=i+96|0;j=a;k=c[e+2116>>2]|0;c[j+92>>2]=k;l=(k|0)==0;if(l)m=ea(1.00000001e-10);else{n=ea(0.0);o=0;do{g[j+(o<<2)>>2]=ea(ea(1.0)/ea(g[e+(o*92|0)+(o<<2)>>2]));p=ea(g[f+(o<<2)>>2]);n=ea(n+ea(p*p));o=o+1|0}while((o|0)!=(k|0));m=ea(n+ea(1.00000001e-10))}if((b|0)!=0&d<ea(3402823469999999843913219.0e14))q=0;else{i=a;return}do{if(!l){o=0;do{if(!o)r=ea(0.0);else{s=0;n=ea(0.0);while(1){p=ea(g[e+(o*92|0)+(s<<2)>>2]);t=ea(n+ea(p*ea(g[h+(s<<2)>>2])));s=s+1|0;if((s|0)==(o|0)){r=t;break}else n=t}}s=o;o=o+1|0;if(o>>>0<k>>>0){u=o;n=ea(0.0);while(1){t=ea(g[e+(s*92|0)+(u<<2)>>2]);p=ea(n+ea(t*ea(g[h+(u<<2)>>2])));u=u+1|0;if((u|0)==(k|0)){v=p;break}else n=p}}else v=ea(0.0);n=ea(g[j+(s<<2)>>2]);g[h+(s<<2)>>2]=ea(n*ea(ea(ea(g[f+(s<<2)>>2])-r)-v))}while((o|0)!=(k|0));if(!l){o=0;n=ea(0.0);while(1){p=ea(-ea(g[f+(o<<2)>>2]));u=0;do{t=ea(g[e+(o*92|0)+(u<<2)>>2]);p=ea(p+ea(t*ea(g[h+(u<<2)>>2])));u=u+1|0}while((u|0)!=(k|0));t=ea(n+ea(p*p));o=o+1|0;if((o|0)==(k|0)){w=t;break}else n=t}}else w=ea(0.0)}else w=ea(0.0);q=q+1|0}while(q>>>0<b>>>0?ea(w/m)>d:0);i=a;return}function Y2a(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=0;e=i;f=ea(g[a+560>>2]);h=ea(g[a+572>>2]);j=ea(g[b+220>>2]);k=ea(g[b+268>>2]);l=ea((j>k?j:k)*c);if(l==ea(0.0)){m=ea(0.0);n=ea(0.0)}else{k=ea(S(ea(l)));j=ea(k+ea(f*ea(ea(+_(+(+ea(h/ea(ea(g[a+564>>2])+ea(h/ea(+X(+(+k)))))))))-k)));o=ea(-j);p=l>=ea(0.0);l=ea(-k);m=p?j:l;n=p?k:o}g[d>>2]=ea(m+ea(g[b+224>>2]));g[d+4>>2]=ea(n+ea(g[b+272>>2]));n=ea(g[b+316>>2]);m=ea(g[b+364>>2]);o=ea((n>m?n:m)*c);if(o==ea(0.0)){q=ea(0.0);r=ea(0.0);s=b+320|0;t=ea(g[s>>2]);u=ea(t-q);v=d+8|0;g[v>>2]=u;w=b+368|0;x=ea(g[w>>2]);y=ea(x-r);z=d+12|0;g[z>>2]=y;i=e;return}c=ea(S(ea(o)));m=ea(c+ea(f*ea(ea(+_(+(+ea(h/ea(ea(g[a+568>>2])+ea(h/ea(+X(+(+c)))))))))-c)));h=ea(-m);a=o>=ea(0.0);o=ea(-c);q=a?m:o;r=a?c:h;s=b+320|0;t=ea(g[s>>2]);u=ea(t-q);v=d+8|0;g[v>>2]=u;w=b+368|0;x=ea(g[w>>2]);y=ea(x-r);z=d+12|0;g[z>>2]=y;i=e;return}function Z2a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0;h=i;if(!f){i=h;return}else j=0;do{a[e+(j*148|0)+28>>0]=a[b+j+112>>0]|0;c[e+(j*148|0)+32>>2]=c[b+(j<<2)+116>>2];c[e+(j*148|0)+36>>2]=c[b+(j<<2)+132>>2];c[e+(j*148|0)+40>>2]=c[b+(j<<2)+148>>2];c[e+(j*148|0)+44>>2]=c[b+(j<<2)+164>>2];g[e+(j*148|0)+48>>2]=ea(g[b+(j*12|0)+180>>2]);g[e+(j*148|0)+52>>2]=ea(g[b+(j*12|0)+184>>2]);g[e+(j*148|0)+56>>2]=ea(g[b+(j*12|0)+188>>2]);g[e+(j*148|0)+60>>2]=ea(g[b+(j*12|0)+228>>2]);g[e+(j*148|0)+64>>2]=ea(g[b+(j*12|0)+232>>2]);g[e+(j*148|0)+68>>2]=ea(g[b+(j*12|0)+236>>2]);g[e+(j*148|0)+72>>2]=ea(g[b+(j<<2)+276>>2]);g[e+(j*148|0)+76>>2]=ea(g[b+(j<<2)+292>>2]);g[e+(j*148|0)+80>>2]=ea(g[b+(j<<2)+308>>2]);g[e+(j*148|0)+84>>2]=ea(g[b+(j*12|0)+324>>2]);g[e+(j*148|0)+88>>2]=ea(g[b+(j*12|0)+328>>2]);g[e+(j*148|0)+92>>2]=ea(g[b+(j*12|0)+332>>2]);g[e+(j*148|0)+96>>2]=ea(g[b+(j*12|0)+372>>2]);g[e+(j*148|0)+100>>2]=ea(g[b+(j*12|0)+376>>2]);g[e+(j*148|0)+104>>2]=ea(g[b+(j*12|0)+380>>2]);g[e+(j*148|0)+108>>2]=ea(g[b+(j<<2)+420>>2]);g[e+(j*148|0)+112>>2]=ea(g[b+(j<<2)+436>>2]);g[e+(j*148|0)+116>>2]=ea(g[d+(j<<2)>>2]);j=j+1|0}while((j|0)!=(f|0));i=h;return}function _2a(a,b,d,e){a=a|0;b=ea(b);d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;f=i;h=c[a+24>>2]|0;do if(b>ea(0.0))if(!h){j=1;break}else if((h|0)==3){j=4;break}else{j=h;break}else j=h;while(0);b=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);m=ea(g[d+12>>2]);n=ea(g[a+12>>2]);o=ea(g[a+16>>2]);p=ea(g[a+20>>2]);q=ea(g[a>>2]);r=ea(g[a+4>>2]);s=ea(g[a+8>>2]);t=ea(ea(1.0)-q);u=ea(ea(1.0)-r);v=ea(ea(1.0)-s);a=b<=ea(-0.0);w=a?ea(0.0):ea(1.0);a=b>=ea(0.0);x=a?w:ea(-1.0);a:do switch(j|0){case 3:{y=ea(q*r);z=ea(q*u);A=ea(t*s);B=ea(t*v);break}case 5:{y=ea(0.0);z=ea(0.0);A=s;B=v;break}case 0:{if(((x!=ea(0.0)?(a=k<=ea(-0.0),w=a?ea(0.0):ea(1.0),a=k>=ea(0.0),x==(a?w:ea(-1.0))):0)?(a=l<=ea(-0.0),w=a?ea(0.0):ea(1.0),a=l>=ea(0.0),x==(a?w:ea(-1.0))):0)?(a=m<=ea(-0.0),w=a?ea(0.0):ea(1.0),a=m>=ea(0.0),x==(a?w:ea(-1.0))):0){w=ea(S(ea(S(ea(b+k)))));C=ea(S(ea(S(ea(l+m)))));D=w>C?w:C;E=ea(D-ea(n*(w<C?w:C)));F=ea(E/D);a=E>=ea(0.0);E=a?F:ea(0.0);F=ea(ea(1.0)-E);D=ea(E+ea(1.0));a=ea(w-C)>=ea(0.0);C=ea(q*(a?F:D));w=ea(t*(a?D:F));F=ea(ea(1.0)/ea(C+w));D=ea(F*C);C=ea(F*w);w=ea(S(ea(b)));F=ea(S(ea(k)));E=w>F?w:F;G=ea(E-ea(o*(w<F?w:F)));H=ea(G/E);a=G>=ea(0.0);G=a?H:ea(0.0);H=ea(ea(1.0)-G);E=ea(G+ea(1.0));a=ea(w-F)>=ea(0.0);F=ea(r*(a?H:E));w=ea(u*(a?E:H));H=ea(ea(1.0)/ea(F+w));E=ea(H*F);F=ea(H*w);w=ea(S(ea(l)));H=ea(S(ea(m)));G=w>H?w:H;I=ea(G-ea(p*(w<H?w:H)));J=ea(I/G);a=I>=ea(0.0);I=a?J:ea(0.0);J=ea(ea(1.0)-I);G=ea(I+ea(1.0));a=ea(w-H)>=ea(0.0);H=ea(s*(a?J:G));w=ea(v*(a?G:J));J=ea(ea(1.0)/ea(H+w));y=ea(D*E);z=ea(D*F);A=ea(C*ea(J*H));B=ea(C*ea(J*w));break a}y=ea(q*r);z=ea(q*u);A=ea(t*s);B=ea(t*v);break}case 1:{if(x!=ea(0.0)?(a=k<=ea(-0.0),w=a?ea(0.0):ea(1.0),a=k>=ea(0.0),x==(a?w:ea(-1.0))):0){w=ea(S(ea(b)));J=ea(S(ea(k)));C=w>J?w:J;H=ea(C-ea(o*(w<J?w:J)));F=ea(H/C);a=H>=ea(0.0);H=a?F:ea(0.0);F=ea(ea(1.0)-H);C=ea(H+ea(1.0));a=ea(w-J)>=ea(0.0);J=ea(r*(a?F:C));w=ea(u*(a?C:F));F=ea(ea(1.0)/ea(J+w));y=ea(F*J);z=ea(F*w);A=ea(0.0);B=ea(0.0)}else{y=r;z=u;A=ea(0.0);B=ea(0.0)}break}case 2:{a=l<=ea(-0.0);w=a?ea(0.0):ea(1.0);a=l>=ea(0.0);F=a?w:ea(-1.0);if(F!=ea(0.0)?(a=m<=ea(-0.0),w=a?ea(0.0):ea(1.0),a=m>=ea(0.0),F==(a?w:ea(-1.0))):0){w=ea(S(ea(l)));F=ea(S(ea(m)));J=w>F?w:F;C=ea(J-ea(p*(w<F?w:F)));H=ea(C/J);a=C>=ea(0.0);C=a?H:ea(0.0);H=ea(ea(1.0)-C);J=ea(C+ea(1.0));a=ea(w-F)>=ea(0.0);F=ea(s*(a?H:J));w=ea(v*(a?J:H));H=ea(ea(1.0)/ea(F+w));y=ea(0.0);z=ea(0.0);A=ea(H*F);B=ea(H*w)}else{y=ea(0.0);z=ea(0.0);A=s;B=v}break}case 4:{y=r;z=u;A=ea(0.0);B=ea(0.0);break}default:{y=ea(0.0);z=ea(0.0);A=ea(0.0);B=ea(0.0)}}while(0);g[e>>2]=y;g[e+4>>2]=z;g[e+8>>2]=A;g[e+12>>2]=B;i=f;return}function $2a(a,b,c,d,e,f,h,j){a=ea(a);b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;var k=0,l=Im,m=Im,n=Im,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im;k=i;l=ea(a*e);a=ea(l*ea(g[c>>2]));m=ea(l*ea(g[c+4>>2]));n=ea(l*ea(g[c+8>>2]));g[f>>2]=ea(a+ea(g[f>>2]));c=f+4|0;g[c>>2]=ea(m+ea(g[c>>2]));o=f+8|0;g[o>>2]=ea(n+ea(g[o>>2]));n=ea(g[j>>2]);p=j+4|0;m=ea(g[p>>2]);q=j+8|0;a=ea(g[q>>2]);r=j+12|0;l=ea(g[r>>2]);s=ea(n+n);t=ea(m+m);u=ea(a+a);v=ea(m*t);w=ea(a*u);x=ea(s*m);m=ea(s*a);y=ea(s*l);z=ea(t*a);a=ea(t*l);t=ea(u*l);l=ea(ea(ea(1.0)-v)-w);u=ea(x+t);A=ea(m-a);B=ea(x-t);t=ea(ea(1.0)-ea(n*s));s=ea(t-w);w=ea(z+y);n=ea(m+a);a=ea(z-y);y=ea(t-v);v=ea(g[b>>2]);t=ea(v*l);z=ea(v*u);m=ea(v*A);v=ea(g[b+4>>2]);x=ea(v*B);C=ea(v*s);D=ea(v*w);v=ea(g[b+8>>2]);E=ea(n*v);F=ea(a*v);G=ea(ea(ea(l*t)+ea(B*x))+ea(n*E));n=ea(ea(ea(u*z)+ea(s*C))+ea(a*F));B=ea(ea(ea(A*m)+ea(w*D))+ea(y*ea(y*v)));v=ea(ea(ea(u*t)+ea(s*x))+ea(a*E));a=ea(ea(ea(A*t)+ea(w*x))+ea(y*E));E=ea(ea(ea(A*z)+ea(w*C))+ea(y*F));F=ea(ea(g[d>>2])*e);y=ea(ea(g[d+4>>2])*e);C=ea(ea(g[d+8>>2])*e);w=ea(ea(ea(F*G)+ea(y*v))+ea(a*C));G=ea(ea(ea(F*v)+ea(y*n))+ea(E*C));n=ea(ea(ea(F*a)+ea(y*E))+ea(B*C));g[h>>2]=ea(ea(g[h>>2])+w);d=h+4|0;g[d>>2]=ea(ea(g[d>>2])+G);b=h+8|0;g[b>>2]=ea(n+ea(g[b>>2]));n=ea(ea(g[f>>2])*e);G=ea(ea(g[c>>2])*e);w=ea(ea(g[o>>2])*e);o=j+16|0;g[o>>2]=ea(n+ea(g[o>>2]));o=j+20|0;g[o>>2]=ea(G+ea(g[o>>2]));o=j+24|0;g[o>>2]=ea(w+ea(g[o>>2]));w=ea(g[h>>2]);G=ea(g[d>>2]);n=ea(g[b>>2]);C=ea(g[j>>2]);B=ea(g[p>>2]);E=ea(g[q>>2]);y=ea(g[r>>2]);a=ea(e*ea(.5));e=ea(C+ea(a*ea(ea(ea(G*E)+ea(ea(C*ea(0.0))+ea(w*y)))-ea(n*B))));F=ea(B+ea(a*ea(ea(ea(n*C)+ea(ea(B*ea(0.0))+ea(G*y)))-ea(w*E))));v=ea(E+ea(a*ea(ea(ea(w*B)+ea(ea(E*ea(0.0))+ea(n*y)))-ea(G*C))));z=ea(y+ea(a*ea(ea(ea(ea(y*ea(0.0))-ea(w*C))-ea(G*B))-ea(n*E))));E=ea(T(ea(ea(z*z)+ea(ea(v*v)+ea(ea(e*e)+ea(F*F))))));if(!(E!=ea(0.0))){H=e;I=F;J=v;K=z;g[j>>2]=H;g[p>>2]=I;g[q>>2]=J;g[r>>2]=K;i=k;return}n=ea(ea(1.0)/E);H=ea(e*n);I=ea(F*n);J=ea(v*n);K=ea(z*n);g[j>>2]=H;g[p>>2]=I;g[q>>2]=J;g[r>>2]=K;i=k;return}function a3a(a,b){a=a|0;b=b|0;var d=0,e=0;g[a>>2]=ea(g[b>>2]);g[a+4>>2]=ea(g[b+4>>2]);g[a+8>>2]=ea(g[b+8>>2]);g[a+12>>2]=ea(g[b+12>>2]);g[a+16>>2]=ea(g[b+16>>2]);g[a+20>>2]=ea(g[b+20>>2]);g[a+24>>2]=ea(g[b+24>>2]);g[a+28>>2]=ea(g[b+28>>2]);g[a+32>>2]=ea(g[b+32>>2]);g[a+36>>2]=ea(g[b+36>>2]);g[a+40>>2]=ea(g[b+40>>2]);g[a+44>>2]=ea(g[b+44>>2]);g[a+48>>2]=ea(g[b+48>>2]);g[a+52>>2]=ea(g[b+52>>2]);g[a+56>>2]=ea(g[b+56>>2]);g[a+60>>2]=ea(g[b+60>>2]);g[a+64>>2]=ea(g[b+64>>2]);g[a+68>>2]=ea(g[b+68>>2]);g[a+72>>2]=ea(g[b+72>>2]);g[a+76>>2]=ea(g[b+76>>2]);g[a+80>>2]=ea(g[b+80>>2]);g[a+84>>2]=ea(g[b+84>>2]);g[a+88>>2]=ea(g[b+88>>2]);g[a+92>>2]=ea(g[b+92>>2]);d=a+96|0;e=b+96|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];g[a+116>>2]=ea(g[b+116>>2]);g[a+120>>2]=ea(g[b+120>>2]);g[a+124>>2]=ea(g[b+124>>2]);g[a+128>>2]=ea(g[b+128>>2]);g[a+132>>2]=ea(g[b+132>>2]);g[a+136>>2]=ea(g[b+136>>2]);g[a+140>>2]=ea(g[b+140>>2]);g[a+144>>2]=ea(g[b+144>>2]);g[a+148>>2]=ea(g[b+148>>2]);g[a+152>>2]=ea(g[b+152>>2]);g[a+156>>2]=ea(g[b+156>>2]);g[a+160>>2]=ea(g[b+160>>2]);g[a+164>>2]=ea(g[b+164>>2]);g[a+168>>2]=ea(g[b+168>>2]);g[a+172>>2]=ea(g[b+172>>2]);g[a+176>>2]=ea(g[b+176>>2]);g[a+180>>2]=ea(g[b+180>>2]);g[a+184>>2]=ea(g[b+184>>2]);g[a+188>>2]=ea(g[b+188>>2]);g[a+192>>2]=ea(g[b+192>>2]);g[a+196>>2]=ea(g[b+196>>2]);g[a+200>>2]=ea(g[b+200>>2]);g[a+204>>2]=ea(g[b+204>>2]);g[a+208>>2]=ea(g[b+208>>2]);e=a+212|0;d=b+212|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];g[a+232>>2]=ea(g[b+232>>2]);g[a+236>>2]=ea(g[b+236>>2]);g[a+240>>2]=ea(g[b+240>>2]);g[a+244>>2]=ea(g[b+244>>2]);g[a+248>>2]=ea(g[b+248>>2]);g[a+252>>2]=ea(g[b+252>>2]);g[a+256>>2]=ea(g[b+256>>2]);g[a+260>>2]=ea(g[b+260>>2]);g[a+264>>2]=ea(g[b+264>>2]);g[a+268>>2]=ea(g[b+268>>2]);g[a+272>>2]=ea(g[b+272>>2]);g[a+276>>2]=ea(g[b+276>>2]);g[a+280>>2]=ea(g[b+280>>2]);g[a+284>>2]=ea(g[b+284>>2]);g[a+288>>2]=ea(g[b+288>>2]);g[a+292>>2]=ea(g[b+292>>2]);g[a+296>>2]=ea(g[b+296>>2]);g[a+300>>2]=ea(g[b+300>>2]);g[a+304>>2]=ea(g[b+304>>2]);g[a+308>>2]=ea(g[b+308>>2]);g[a+312>>2]=ea(g[b+312>>2]);g[a+316>>2]=ea(g[b+316>>2]);g[a+320>>2]=ea(g[b+320>>2]);g[a+324>>2]=ea(g[b+324>>2]);d=a+328|0;e=b+328|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];return a|0}function b3a(a){a=a|0;var b=Im;b=ea(g[a+80>>2]);return ea(b)}function c3a(a,b){a=a|0;b=ea(b);g[a+80>>2]=b;return}function d3a(a){a=a|0;var b=Im;b=ea(g[a+84>>2]);return ea(b)}function e3a(a,b){a=a|0;b=ea(b);g[a+84>>2]=b;return}function f3a(a){a=a|0;var b=Im;b=ea(g[a+88>>2]);return ea(b)}function g3a(a,b){a=a|0;b=ea(b);g[a+88>>2]=b;return}function h3a(a){a=a|0;var b=Im;b=ea(g[a+92>>2]);return ea(b)}function i3a(a,b){a=a|0;b=ea(b);g[a+92>>2]=b;return}function j3a(a){a=a|0;var b=Im;b=ea(g[a+96>>2]);return ea(b)}function k3a(a,b){a=a|0;b=ea(b);g[a+96>>2]=b;return}function l3a(a){a=a|0;var b=Im;b=ea(g[a+100>>2]);return ea(b)}function m3a(a,b){a=a|0;b=ea(b);g[a+100>>2]=b;return}function n3a(a){a=a|0;var b=Im;b=ea(g[a+128>>2]);return ea(b)}function o3a(a,b){a=a|0;b=ea(b);g[a+128>>2]=b;return}function p3a(a){a=a|0;return c[a+132>>2]|0}function q3a(a,b){a=a|0;b=b|0;c[a+132>>2]=b;return}function r3a(a){a=a|0;var b=Im;b=ea(g[a+136>>2]);return ea(b)}function s3a(a,b){a=a|0;b=ea(b);g[a+136>>2]=b;return}function t3a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function u3a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function v3a(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function w3a(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function x3a(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function y3a(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function z3a(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function A3a(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function B3a(a){a=a|0;var b=Im;b=ea(g[a+16>>2]);return ea(b)}function C3a(a,b){a=a|0;b=ea(b);g[a+16>>2]=b;return}function D3a(a){a=a|0;var b=Im;b=ea(g[a+20>>2]);return ea(b)}function E3a(a,b){a=a|0;b=ea(b);g[a+20>>2]=b;return}function F3a(a){a=a|0;return c[a+24>>2]|0}function G3a(a,b){a=a|0;b=b|0;c[a+24>>2]=b;return}function H3a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function I3a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function J3a(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function K3a(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function L3a(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function M3a(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function N3a(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function O3a(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function P3a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function Q3a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function R3a(a){a=a|0;return c[a+4>>2]|0}function S3a(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function T3a(a){a=a|0;return c[a+8>>2]|0}function U3a(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function V3a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function W3a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function X3a(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function Y3a(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function Z3a(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function _3a(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function $3a(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function a4a(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function b4a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function c4a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function d4a(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function e4a(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function f4a(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function g4a(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function h4a(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function i4a(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function j4a(a){a=a|0;var b=Im;b=ea(g[a+16>>2]);return ea(b)}function k4a(a,b){a=a|0;b=ea(b);g[a+16>>2]=b;return}function l4a(a){a=a|0;var b=Im;b=ea(g[a+20>>2]);return ea(b)}function m4a(a,b){a=a|0;b=ea(b);g[a+20>>2]=b;return}function n4a(a){a=a|0;var b=Im;b=ea(g[a+24>>2]);return ea(b)}function o4a(a,b){a=a|0;b=ea(b);g[a+24>>2]=b;return}function p4a(a){a=a|0;var b=Im;b=ea(g[a+28>>2]);return ea(b)}function q4a(a,b){a=a|0;b=ea(b);g[a+28>>2]=b;return}function r4a(a){a=a|0;var b=Im;b=ea(g[a+32>>2]);return ea(b)}function s4a(a,b){a=a|0;b=ea(b);g[a+32>>2]=b;return}function t4a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function u4a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function v4a(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function w4a(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function x4a(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function y4a(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function z4a(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function A4a(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function B4a(a){a=a|0;var b=Im;b=ea(g[a+16>>2]);return ea(b)}function C4a(a,b){a=a|0;b=ea(b);g[a+16>>2]=b;return}function D4a(a){a=a|0;var b=Im;b=ea(g[a+20>>2]);return ea(b)}function E4a(a,b){a=a|0;b=ea(b);g[a+20>>2]=b;return}function F4a(a){a=a|0;var b=Im;b=ea(g[a+24>>2]);return ea(b)}function G4a(a,b){a=a|0;b=ea(b);g[a+24>>2]=b;return}function H4a(a){a=a|0;var b=Im;b=ea(g[a+28>>2]);return ea(b)}function I4a(a,b){a=a|0;b=ea(b);g[a+28>>2]=b;return}function J4a(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function K4a(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function L4a(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function M4a(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function N4a(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function O4a(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function P4a(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function Q4a(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function R4a(a){a=a|0;return c[a+40>>2]|0}function S4a(a,b){a=a|0;b=b|0;c[a+40>>2]=b;return}function T4a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+0|0;a=b+8|0;b=e+64|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));i=d;return}function U4a(a,b){a=a|0;b=b|0;var c=0;c=i;LEa(a+8|0,b)|0;i=c;return}function V4a(a,b){a=a|0;b=b|0;var d=0;d=b+72|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[a+28>>2]=c[d+28>>2];return}function W4a(a,b){a=a|0;b=b|0;var d=0;d=a+72|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];c[d+24>>2]=c[b+24>>2];c[d+28>>2]=c[b+28>>2];return}function X4a(b){b=b|0;return (a[b+64>>0]|0)!=0|0}function Y4a(b,c){b=b|0;c=c|0;a[b+64>>0]=c&1;return}function Z4a(b){b=b|0;return (a[b+65>>0]|0)!=0|0}function _4a(b,c){b=b|0;c=c|0;a[b+65>>0]=c&1;return}function $4a(b){b=b|0;return (a[b+66>>0]|0)!=0|0}function a5a(b,c){b=b|0;c=c|0;a[b+66>>0]=c&1;return}function b5a(a){a=a|0;return c[a+68>>2]|0}function c5a(a,b){a=a|0;b=b|0;c[a+68>>2]=b;return}function d5a(a){a=a|0;return c[a+72>>2]|0}function e5a(a,b){a=a|0;b=b|0;c[a+72>>2]=b;return}function f5a(a){a=a|0;var b=Im;b=ea(g[a+76>>2]);return ea(b)}function g5a(a,b){a=a|0;b=ea(b);g[a+76>>2]=b;return}function h5a(a){a=a|0;var b=Im;b=ea(g[a+80>>2]);return ea(b)}function i5a(a,b){a=a|0;b=ea(b);g[a+80>>2]=b;return}function j5a(a){a=a|0;var b=Im;b=ea(g[a+84>>2]);return ea(b)}function k5a(a,b){a=a|0;b=ea(b);g[a+84>>2]=b;return}function l5a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+0|0;a=b+128|0;b=e+96|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));i=d;return}function m5a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+128|0;a=b+0|0;b=e+96|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));i=d;return}function n5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+288>>2]|0;YEi(a|0,b+224|0,e<<3|0)|0;c[a+64>>2]=e;e=a+80|0;f=b+304|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];YEi(a+112|0,b+336|0,416)|0;f=a+528|0;a=b+752|0;b=f+48|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(b|0));i=d;return}function o5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+64|0;YEi(a+224|0,b|0,c[e>>2]<<3|0)|0;c[a+288>>2]=c[e>>2];e=a+304|0;f=b+80|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];YEi(a+336|0,b+112|0,416)|0;f=a+752|0;a=b+528|0;b=f+48|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(b|0));i=d;return}function p5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+288>>2]|0;YEi(a|0,b+224|0,e<<3|0)|0;c[a+64>>2]=e;e=a+80|0;f=b+304|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];YEi(a+112|0,b+336|0,416)|0;i=d;return}function q5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+64|0;YEi(a+224|0,b|0,c[e>>2]<<3|0)|0;c[a+288>>2]=c[e>>2];e=a+304|0;f=b+80|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];YEi(a+336|0,b+112|0,416)|0;i=d;return}function r5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+288>>2]|0;YEi(a|0,b+224|0,e<<3|0)|0;c[a+64>>2]=e;e=a+80|0;f=b+304|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];YEi(a+112|0,b+336|0,416)|0;f=a+528|0;a=b+752|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];i=d;return}function s5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+64|0;YEi(a+224|0,b|0,c[e>>2]<<3|0)|0;c[a+288>>2]=c[e>>2];e=a+304|0;f=b+80|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];YEi(a+336|0,b+112|0,416)|0;f=a+752|0;a=b+528|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];i=d;return}function t5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);g[a+(b<<3)+(c<<2)+16>>2]=d;return}function u5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im;d=ea(g[a+(b<<3)+(c<<2)+16>>2]);return ea(d)}function v5a(a,b,c){a=a|0;b=b|0;c=ea(c);g[a+(b<<2)>>2]=c;return}function w5a(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+(b<<2)>>2]);return ea(c)}function x5a(a){a=a|0;return c[a+64>>2]<<1|0}function y5a(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+16|0;k=j;l=c[h+4>>2]|0;if(!l){m=0;n=0;o=0;p=0;q=0;r=0}else{s=a*3|0;t=b*3|0;m=c[l+(s+2<<2)>>2]|0;n=c[l+(s+1<<2)>>2]|0;o=c[l+(s<<2)>>2]|0;p=c[l+(t+2<<2)>>2]|0;q=c[l+(t+1<<2)>>2]|0;r=c[l+(t<<2)>>2]|0}t=c[h+8>>2]|0;if(!t){u=o;v=n;w=m;x=r;y=q;z=p}else{p=a*3|0;q=b*3|0;u=e[t+(p<<1)>>1]|0;v=e[t+(p+1<<1)>>1]|0;w=e[t+(p+2<<1)>>1]|0;x=e[t+(q<<1)>>1]|0;y=e[t+(q+1<<1)>>1]|0;z=e[t+(q+2<<1)>>1]|0}q=(u|0)==(d|0);t=(v|0)==(f|0);if(!(q&t)?(p=(u|0)==(f|0),u=(v|0)==(d|0),!(p&u)):0){v=(w|0)==(f|0);r=(w|0)==(d|0);if(!(q&v|p&r))if(u&v)A=2;else A=t&r?2:-1;else A=1}else A=0;r=(x|0)==(d|0);t=(y|0)==(f|0);if(!(r&t)?(v=(x|0)==(f|0),x=(y|0)==(d|0),!(v&x)):0){y=(z|0)==(f|0);f=(z|0)==(d|0);if(!(r&y|v&f))if(x&y)B=2;else B=t&f?2:-1;else B=1}else B=0;f=A&255;if(A<<24>>24!=-1?(A=B&255,B<<24>>24!=-1):0){c[g+(a*12|0)+(f<<2)>>2]=A<<30|b;c[g+(b*12|0)+(A<<2)>>2]=f<<30|a;C=1;i=j;return C|0}dKa(bKa()|0,8,520600,709,521040,k);C=0;i=j;return C|0}function z5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?523368:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<5)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2];c[j+28>>2]=c[f+28>>2]}j=j+32|0;if(j>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function A5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<5,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?523368:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<5)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2]}j=j+32|0;if(j>>>0>=h>>>0)break;else k=k+32|0}n=c[l>>2]|0}else n=f;f=m+(n<<5)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o<<5)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o<<5)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o<<5)|0;i=d;return q|0}function B5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?523816:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<5)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2]);g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);h=f+24|0;j=c[h+4>>2]|0;m=k+24|0;c[m>>2]=c[h>>2];c[m+4>>2]=j}k=k+32|0;if(k>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function C5a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;f=i;i=i+144|0;h=f;j=h;c[j>>2]=0;c[j+4>>2]=0;j=h+4|0;a[j>>0]=0;k=f+8|0;c[h>>2]=k;l=d+-1|0;if((l|0)>0){d=e+4|0;m=0;n=k;k=32;o=0;p=0;q=l;a:while(1){l=q;r=p;s=o;while(1){if((l|0)>(r|0)){if((l-r|0)>>>0>=5)break;t=c[d>>2]|0;u=r;do{v=u;u=u+1|0;w=c[e>>2]|0;x=u;y=v;while(1){z=c[b+(x<<2)>>2]|0;A=ea(g[t+(z<<5)+(w<<2)>>2]);B=ea(A+ea(g[t+(z<<5)+16+(w<<2)>>2]));z=c[b+(y<<2)>>2]|0;A=ea(g[t+(z<<5)+(w<<2)>>2]);C=B<ea(A+ea(g[t+(z<<5)+16+(w<<2)>>2]));y=C?x:y;if((x|0)>=(l|0))break;else x=x+1|0}x=b+(y<<2)|0;w=b+(v<<2)|0;C=c[x>>2]|0;c[x>>2]=c[w>>2];c[w>>2]=C}while((u|0)!=(l|0))}if(!s)break a;u=s+-2|0;l=c[n+(s+-1<<2)>>2]|0;r=c[n+(u<<2)>>2]|0;s=u}mFb(b,r,l,e);u=l+-1|0;t=b+(u<<2)|0;C=c[d>>2]|0;w=r;x=u;while(1){u=c[e>>2]|0;D=c[t>>2]|0;A=ea(g[C+(D<<5)+(u<<2)>>2]);B=ea(A+ea(g[C+(D<<5)+16+(u<<2)>>2]));E=w;while(1){F=E+1|0;G=b+(F<<2)|0;H=c[G>>2]|0;A=ea(g[C+(H<<5)+(u<<2)>>2]);if(ea(A+ea(g[C+(H<<5)+16+(u<<2)>>2]))<B)E=F;else{I=x;break}}do{I=I+-1|0;J=b+(I<<2)|0;K=c[J>>2]|0;A=ea(g[C+(K<<5)+(u<<2)>>2])}while(B<ea(A+ea(g[C+(K<<5)+16+(u<<2)>>2])));if((F|0)>=(I|0))break;c[G>>2]=K;c[J>>2]=H;w=F;x=I}c[G>>2]=D;c[t>>2]=H;if((F-r|0)<(l-F|0)){if(s>>>0>=(k+-1|0)>>>0){x=k<<1;w=k<<3;if(!w)L=0;else{C=mKa()|0;u=c[(c[C>>2]|0)+8>>2]|0;z=pKa()|0;M=mo[c[(c[z>>2]|0)+24>>2]&4095](z)|0;L=Bn[u&255](C,w,M?541832:544544,523928,148)|0}YEi(L|0,n|0,s<<2|0)|0;if(m<<24>>24==0|(n|0)==0){N=L;O=1;P=x}else{M=mKa()|0;In[c[(c[M>>2]|0)+12>>2]&4095](M,n);N=L;O=1;P=x}}else{N=n;O=m;P=k}c[N+(s<<2)>>2]=r;c[N+(s+1<<2)>>2]=E;Q=O;R=N;S=P;T=E+2|0;U=l}else{x=E+2|0;if(s>>>0>=(k+-1|0)>>>0){M=k<<1;w=k<<3;if(!w)V=0;else{C=mKa()|0;u=c[(c[C>>2]|0)+8>>2]|0;z=pKa()|0;W=mo[c[(c[z>>2]|0)+24>>2]&4095](z)|0;V=Bn[u&255](C,w,W?541832:544544,523928,148)|0}YEi(V|0,n|0,s<<2|0)|0;if(m<<24>>24==0|(n|0)==0){X=V;Y=1;Z=M}else{W=mKa()|0;In[c[(c[W>>2]|0)+12>>2]&4095](W,n);X=V;Y=1;Z=M}}else{X=n;Y=m;Z=k}c[X+(s<<2)>>2]=x;c[X+(s+1<<2)>>2]=l;Q=Y;R=X;S=Z;T=r;U=E}m=Q;n=R;k=S;o=s+2|0;p=T;q=U}if(!(m<<24>>24==0|(n|0)==0)){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,n)}}if(!(a[j>>0]|0)){i=f;return}tKa(h,c[h>>2]|0);i=f;return}function D5a(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0;k=i;i=i+160|0;l=k+152|0;m=k+153|0;n=k+88|0;o=k+24|0;p=k+16|0;q=k;r=k+8|0;s=k+104|0;t=k+72|0;u=k+120|0;if(!j)v=1;else{w=c[h>>2]|0;x=j+1|0;v=w>>>0<x>>>0?x:w}c[h>>2]=v;c[n>>2]=1;v=n+4|0;c[v>>2]=2;w=n+8|0;c[w>>2]=3;x=n+12|0;c[x>>2]=4;do if(e>>>0>3){y=o+32|0;z=o+36|0;A=o+40|0;B=o+44|0;a[y>>0]=1;c[z>>2]=o;c[B>>2]=4;c[p>>2]=0;c[p+4>>2]=e;C=p;D=c[C+4>>2]|0;E=o;c[E>>2]=c[C>>2];c[E+4>>2]=D;c[A>>2]=1;D=q+4|0;E=r+4|0;C=b+8|0;F=0;do{G=c[A>>2]|0;H=c[z>>2]|0;if(!G)I=-1;else{J=0;K=ea(-3402823469999999843913219.0e14);L=-1;while(1){M=c[H+(J<<3)+4>>2]|0;if((M|0)!=1){N=c[H+(J<<3)>>2]|0;O=c[d+(N<<2)>>2]|0;P=c[C>>2]|0;Q=ea(g[P+(O<<5)>>2]);R=ea(g[P+(O<<5)+4>>2]);S=ea(g[P+(O<<5)+8>>2]);T=ea(g[P+(O<<5)+16>>2]);U=ea(g[P+(O<<5)+20>>2]);V=ea(g[P+(O<<5)+24>>2]);if(M>>>0>1){W=T;X=Q;Y=V;Z=S;_=R;$=U;O=1;while(1){aa=c[d+(O+N<<2)>>2]|0;ba=ea(g[P+(aa<<5)>>2]);ca=ea(g[P+(aa<<5)+4>>2]);da=ea(g[P+(aa<<5)+8>>2]);fa=X<ba?X:ba;ba=_<ca?_:ca;ca=Z<da?Z:da;da=ea(g[P+(aa<<5)+16>>2]);ga=ea(g[P+(aa<<5)+20>>2]);ha=ea(g[P+(aa<<5)+24>>2]);ia=W>da?W:da;da=$>ga?$:ga;ga=Y>ha?Y:ha;O=O+1|0;if((O|0)==(M|0)){ja=ia;ka=fa;la=ga;ma=ca;na=ba;oa=da;break}else{W=ia;X=fa;Y=ga;Z=ca;_=ba;$=da}}}else{ja=T;ka=Q;la=V;ma=S;na=R;oa=U}$=ea(ja-ka);_=ea(oa-na);Z=ea(la-ma);Y=ea(ea(M>>>0)*ea(ea(_*Z)+ea(ea($*_)+ea($*Z))));if(Y>K){pa=Y;qa=J}else{pa=K;qa=L}}else{pa=K;qa=L}J=J+1|0;if(J>>>0>=G>>>0){I=qa;break}else{K=pa;L=qa}}}L=c[H+(I<<3)>>2]|0;G=c[H+(I<<3)+4>>2]|0;J=nFb(b,d+(L<<2)|0,G)|0;c[q>>2]=L;c[D>>2]=J;O=c[A>>2]|0;if((c[B>>2]&2147483647)>>>0>O>>>0){P=(c[z>>2]|0)+(O<<3)|0;if(!P)ra=O;else{O=q;N=c[O+4>>2]|0;aa=P;c[aa>>2]=c[O>>2];c[aa+4>>2]=N;ra=c[A>>2]|0}N=ra+1|0;c[A>>2]=N;sa=N}else{oFb(o,q)|0;sa=c[A>>2]|0}N=J+L|0;c[r>>2]=N;c[E>>2]=G-J;if((c[B>>2]&2147483647)>>>0>sa>>>0){J=(c[z>>2]|0)+(sa<<3)|0;if(!J)ta=sa;else{G=r;L=c[G+4>>2]|0;aa=J;c[aa>>2]=c[G>>2];c[aa+4>>2]=L;ta=c[A>>2]|0}L=ta+1|0;c[A>>2]=L;ua=L}else{oFb(o,r)|0;ua=c[A>>2]|0}L=c[z>>2]|0;aa=ua+-1|0;c[A>>2]=aa;G=L+(aa<<3)|0;aa=c[G+4>>2]|0;J=L+(I<<3)|0;c[J>>2]=c[G>>2];c[J+4>>2]=aa;c[n+(F<<2)>>2]=N;F=F+1|0}while((F|0)!=3);F=c[B>>2]|0;if((F&2147483647|0)!=0&(F|0)>-1){F=c[z>>2]|0;if((o|0)==(F|0)){a[y>>0]=0;va=C;break}if(F){A=mKa()|0;In[c[(c[A>>2]|0)+12>>2]&4095](A,F);va=C}else va=C}else va=C}else{if(e>>>0<3){F=e;do{c[n+(F<<2)>>2]=e;F=F+1|0}while((F|0)!=3)}va=b+8|0}while(0);F$a(n,3,l,m);c[x>>2]=e;c[s>>2]=0;x=c[n>>2]|0;c[t>>2]=x;m=s+4|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=c[v>>2]|0;v=n-x|0;c[t+4>>2]=v;l=c[w>>2]|0;w=l-n|0;n=t+8|0;c[n>>2]=w;o=e-l|0;l=t+12|0;c[l>>2]=o;I=b+52|0;ua=u+4|0;r=u+8|0;ta=u+12|0;sa=u+16|0;q=u+20|0;ra=u+24|0;qa=u+28|0;p=f+8|0;F=f+4|0;C=d;y=x;z=0;B=(x>>>0<17?(c[523688+(c[I>>2]<<2)>>2]|0)>>>0>=e>>>0:0)&v>>>0<17&w>>>0<17&o>>>0<17;while(1){g[u>>2]=ea(8507058669999999534545717.0e13);g[ua>>2]=ea(8507058669999999534545717.0e13);g[r>>2]=ea(8507058669999999534545717.0e13);g[ta>>2]=ea(-8507058669999999534545717.0e13);g[sa>>2]=ea(-8507058669999999534545717.0e13);g[q>>2]=ea(-8507058669999999534545717.0e13);c[ra>>2]=-1;c[qa>>2]=0;do if(!y){g[u>>2]=ea(8507058669999999534545717.0e13);g[ua>>2]=ea(8507058669999999534545717.0e13);g[r>>2]=ea(8507058669999999534545717.0e13);g[ta>>2]=ea(-8507058669999999534545717.0e13);g[sa>>2]=ea(-8507058669999999534545717.0e13);g[q>>2]=ea(-8507058669999999534545717.0e13);c[ra>>2]=-1;c[qa>>2]=-1;wa=ea(8507058669999999534545717.0e13);xa=ea(8507058669999999534545717.0e13);ya=ea(8507058669999999534545717.0e13);za=ea(-8507058669999999534545717.0e13);Aa=ea(-8507058669999999534545717.0e13);Ba=ea(-8507058669999999534545717.0e13);Ca=B}else{o=c[s+(z<<2)>>2]|0;w=c[d+(o<<2)>>2]|0;e=c[va>>2]|0;pa=ea(g[e+(w<<5)>>2]);ma=ea(g[e+(w<<5)+4>>2]);la=ea(g[e+(w<<5)+8>>2]);na=ea(g[e+(w<<5)+16>>2]);oa=ea(g[e+(w<<5)+20>>2]);ka=ea(g[e+(w<<5)+24>>2]);ja=ea(na-pa);K=ea(oa-ma);Y=ea(ka-la);Z=ea(ea(K*Y)+ea(ea(ja*K)+ea(ja*Y)));if(y>>>0>1){Y=Z;ja=pa;K=ma;$=la;_=na;X=oa;W=ka;w=1;da=Z;while(1){A=c[d+(o+w<<2)>>2]|0;ba=ea(g[e+(A<<5)+16>>2]);ca=ea(g[e+(A<<5)+20>>2]);ga=ea(g[e+(A<<5)+24>>2]);fa=ea(g[e+(A<<5)>>2]);ia=ea(g[e+(A<<5)+4>>2]);ha=ea(g[e+(A<<5)+8>>2]);Da=ea(ba-fa);Ea=ea(ca-ia);Fa=ea(ga-ha);Ga=ea(ea(Ea*Fa)+ea(ea(Da*Ea)+ea(Da*Fa)));Fa=Y<Ga?Y:Ga;Da=da>Ga?da:Ga;Ga=ja<fa?ja:fa;fa=K<ia?K:ia;ia=$<ha?$:ha;ha=_>ba?_:ba;ba=X>ca?X:ca;ca=W>ga?W:ga;w=w+1|0;if((w|0)==(y|0)){Ha=ca;Ia=ba;Ja=ha;Ka=ia;La=fa;Ma=Ga;Na=Fa;Oa=Da;break}else{Y=Fa;ja=Ga;K=fa;$=ia;_=ha;X=ba;W=ca;da=Da}}}else{Ha=ka;Ia=oa;Ja=na;Ka=la;La=ma;Ma=pa;Na=Z;Oa=Z}g[u>>2]=Ma;g[ua>>2]=La;g[r>>2]=Ka;g[ta>>2]=Ja;g[sa>>2]=Ia;g[q>>2]=Ha;w=ea(Oa/Na)<ea(40.0);e=w&B;if((y>>>0>=3?!(w&y>>>0<4|e):0)?y>>>0>(c[523752+(c[I>>2]<<2)>>2]|0)>>>0:0){c[ra>>2]=-1;c[qa>>2]=0;wa=Ma;xa=La;ya=Ka;za=Ja;Aa=Ia;Ba=Ha;Ca=0;break}c[ra>>2]=(C-(c[b>>2]|0)>>2)+o;c[qa>>2]=y;wa=Ma;xa=La;ya=Ka;za=Ja;Aa=Ia;Ba=Ha;Ca=e}while(0);e=c[F>>2]|0;if((c[p>>2]&2147483647)>>>0>e>>>0){w=c[f>>2]|0;H=w+(e<<5)|0;if(!H)Pa=e;else{g[H>>2]=wa;g[w+(e<<5)+4>>2]=xa;g[w+(e<<5)+8>>2]=ya;g[w+(e<<5)+12>>2]=za;g[w+(e<<5)+16>>2]=Aa;g[w+(e<<5)+20>>2]=Ba;H=ra;A=c[H+4>>2]|0;E=w+(e<<5)+24|0;c[E>>2]=c[H>>2];c[E+4>>2]=A;Pa=c[F>>2]|0}c[F>>2]=Pa+1}else pFb(f,u)|0;A=z+1|0;if((A|0)==4)break;y=c[t+(A<<2)>>2]|0;z=A;B=Ca}if(Ca){i=k;return}Ca=c[F>>2]|0;B=Ca+-4|0;z=j+1|0;j=c[f>>2]|0;if(!(c[j+(B<<5)+28>>2]|0)){c[j+(B<<5)+24>>2]=Ca;D5a(b,d,x,f,h,z,j+(B<<5)|0);Qa=c[f>>2]|0}else Qa=j;j=Ca+-3|0;if(!(c[Qa+(j<<5)+28>>2]|0)){c[Qa+(j<<5)+24>>2]=c[F>>2];D5a(b,d+(c[m>>2]<<2)|0,v,f,h,z,Qa+(j<<5)|0);Ra=c[f>>2]|0}else Ra=Qa;Qa=Ca+-2|0;if(!(c[Ra+(Qa<<5)+28>>2]|0)){c[Ra+(Qa<<5)+24>>2]=c[F>>2];D5a(b,d+(c[s+8>>2]<<2)|0,c[n>>2]|0,f,h,z,Ra+(Qa<<5)|0);Sa=c[f>>2]|0}else Sa=Ra;Ra=Ca+-1|0;if(c[Sa+(Ra<<5)+28>>2]|0){i=k;return}c[Sa+(Ra<<5)+24>>2]=c[F>>2];D5a(b,d+(c[s+12>>2]<<2)|0,c[l>>2]|0,f,h,z,Sa+(Ra<<5)|0);i=k;return}function E5a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0;h=i;i=i+16|0;j=h;k=a+8|0;c[k>>2]=d;d=a+12|0;c[d>>2]=0;l=a+16|0;c[l>>2]=0;m=a+20|0;c[m>>2]=0;c[a>>2]=b+(e<<2);c[a+4>>2]=b;if(!e){n=f<ea(0.0);o=ea(f*ea(9.0));p=~~o>>>0;q=n?0:p;r=q>>>0<8;s=r?q:8;t=523328+(s<<2)|0;u=c[t>>2]|0;v=a+24|0;c[v>>2]=u;i=h;return}k_a(d,e);b=j+4|0;w=j+8|0;x=0;do{y=c[k>>2]|0;z=ea(g[y+(x<<5)>>2]);A=ea(z+ea(g[y+(x<<5)+16>>2]));z=ea(g[y+(x<<5)+4>>2]);B=ea(z+ea(g[y+(x<<5)+20>>2]));z=ea(g[y+(x<<5)+8>>2]);C=ea(z+ea(g[y+(x<<5)+24>>2]));g[j>>2]=A;g[b>>2]=B;g[w>>2]=C;y=c[l>>2]|0;if((c[m>>2]&2147483647)>>>0>y>>>0){D=c[d>>2]|0;E=D+(y*12|0)|0;if(E){g[E>>2]=A;g[D+(y*12|0)+4>>2]=B;g[D+(y*12|0)+8>>2]=C}c[l>>2]=y+1}else _Ua(d,j)|0;x=x+1|0}while((x|0)!=(e|0));n=f<ea(0.0);o=ea(f*ea(9.0));p=~~o>>>0;q=n?0:p;r=q>>>0<8;s=r?q:8;t=523328+(s<<2)|0;u=c[t>>2]|0;v=a+24|0;c[v>>2]=u;i=h;return}function F5a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im;k=i;i=i+64|0;l=k+48|0;m=k+16|0;n=k;if(!j)o=1;else{p=c[f>>2]|0;q=j+1|0;o=p>>>0<q>>>0?q:p}c[f>>2]=o;o=d>>>2;p=(o|0)==0?1:o;o=c[b>>2]|0;q=a+8|0;r=c[q>>2]|0;s=ea(g[r+(o<<5)+16>>2]);t=ea(g[r+(o<<5)+20>>2]);u=ea(g[r+(o<<5)+24>>2]);v=ea(g[r+(o<<5)>>2]);w=ea(g[r+(o<<5)+4>>2]);x=ea(g[r+(o<<5)+8>>2]);if(d>>>0>1){y=v;z=s;A=x;B=u;C=t;D=w;o=1;while(1){E=c[b+(o<<2)>>2]|0;F=ea(g[r+(E<<5)+16>>2]);G=ea(g[r+(E<<5)+20>>2]);H=ea(g[r+(E<<5)+24>>2]);I=z>F?z:F;F=C>G?C:G;G=B>H?B:H;H=ea(g[r+(E<<5)>>2]);J=ea(g[r+(E<<5)+4>>2]);K=ea(g[r+(E<<5)+8>>2]);L=y<H?y:H;H=D<J?D:J;J=A<K?A:K;o=o+1|0;if((o|0)==(d|0)){M=L;N=I;O=J;P=G;Q=F;R=H;break}else{y=L;z=I;A=J;B=G;C=F;D=H}}}else{M=v;N=s;O=x;P=u;Q=t;R=w}w=ea(N-M);M=ea(Q-R);R=ea(P-O);g[l>>2]=w;o=l+4|0;g[o>>2]=M;r=l+8|0;g[r>>2]=R;if(w>M&w>R)S=0;else S=M>R?1:2;E=c[a+12>>2]|0;T=e+4|0;U=c[T>>2]|0;qFb(e,U+4|0);V=(da(p,-3)|0)+d|0;W=(V|0)<0?0:V;V=d+-1|0;X=a+24|0;Y=j+1|0;j=m+4|0;Z=m+8|0;_=m+16|0;$=m+20|0;aa=m+24|0;ba=h+4|0;ca=h+8|0;fa=h+12|0;ga=h+16|0;ha=h+20|0;ia=h+24|0;ja=h+28|0;ka=m+16|0;la=a+4|0;ma=b;na=m+12|0;oa=m+28|0;pa=S;S=0;qa=0;while(1){ra=da(S,p)|0;if(S>>>0<3)if(ra>>>0<=V>>>0){sa=ra;ta=V;ua=p;a:while(1){va=ta;while(1){wa=b+((va+sa|0)>>>1<<2)|0;xa=c[wa>>2]|0;ya=b+(va<<2)|0;za=c[ya>>2]|0;c[ya>>2]=xa;c[wa>>2]=za;if(sa>>>0<va>>>0){R=ea(g[E+(xa*12|0)+(pa<<2)>>2]);xa=sa;za=sa;while(1){wa=b+(xa<<2)|0;Aa=c[wa>>2]|0;if(!(ea(g[E+(Aa*12|0)+(pa<<2)>>2])<=R))Ba=za;else{Ca=b+(za<<2)|0;Da=c[Ca>>2]|0;c[Ca>>2]=Aa;c[wa>>2]=Da;Ba=za+1|0}xa=xa+1|0;if((xa|0)==(va|0)){Ea=Ba;break}else za=Ba}}else Ea=sa;za=c[ya>>2]|0;xa=b+(Ea<<2)|0;c[ya>>2]=c[xa>>2];c[xa>>2]=za;za=Ea;do za=za+1|0;while(za>>>0<=va>>>0);Fa=Ea-sa+1|0;if((Fa|0)==(ua|0))break a;if(ua>>>0<Fa>>>0)va=Ea+-1|0;else break}sa=Ea+1|0;ta=va;ua=ua-Fa|0}R=ea(g[523312+(S<<2)>>2]);ua=l+(pa<<2)|0;g[ua>>2]=ea(R*ea(g[ua>>2]));R=ea(g[l>>2]);M=ea(g[o>>2]);w=ea(g[r>>2]);if(R>M&R>w){Ga=0;Ha=p}else{Ga=M>w?1:2;Ha=p}}else{Ga=pa;Ha=p}else{Ga=pa;Ha=W}ua=S+U|0;ta=c[e>>2]|0;qa=Ha+qa|0;do if(Ha>>>0<=(c[X>>2]|0)>>>0){if(qa>>>0>d>>>0){c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[ka+0>>2]=c[n+0>>2];c[ka+4>>2]=c[n+4>>2];c[ka+8>>2]=c[n+8>>2];c[ka+12>>2]=c[n+12>>2];c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];g[ta+(ua<<5)>>2]=ea(8507058669999999534545717.0e13);g[ta+(ua<<5)+4>>2]=ea(8507058669999999534545717.0e13);g[ta+(ua<<5)+8>>2]=ea(8507058669999999534545717.0e13);g[ta+(ua<<5)+12>>2]=ea(-8507058669999999534545717.0e13);g[ta+(ua<<5)+16>>2]=ea(-8507058669999999534545717.0e13);g[ta+(ua<<5)+20>>2]=ea(-8507058669999999534545717.0e13);c[ta+(ua<<5)+28>>2]=-1;c[ta+(ua<<5)+24>>2]=-1;break}c[ta+(ua<<5)+28>>2]=Ha;c[ta+(ua<<5)+24>>2]=(ma-(c[la>>2]|0)>>2)+ra;sa=c[q>>2]|0;za=sa+(c[b+(ra<<2)>>2]<<5)|0;c[m+0>>2]=c[za+0>>2];c[m+4>>2]=c[za+4>>2];c[m+8>>2]=c[za+8>>2];c[m+12>>2]=c[za+12>>2];c[m+16>>2]=c[za+16>>2];c[m+20>>2]=c[za+20>>2];c[m+24>>2]=c[za+24>>2];c[m+28>>2]=c[za+28>>2];if(Ha>>>0>1){w=ea(g[m>>2]);M=ea(g[j>>2]);R=ea(g[Z>>2]);O=ea(g[_>>2]);P=ea(g[$>>2]);Q=w;w=M;M=R;R=O;O=P;P=ea(g[aa>>2]);za=1;do{ya=c[b+(za+ra<<2)>>2]|0;N=ea(g[sa+(ya<<5)>>2]);t=ea(g[sa+(ya<<5)+4>>2]);u=ea(g[sa+(ya<<5)+8>>2]);Q=Q<N?Q:N;w=w<t?w:t;M=M<u?M:u;g[m>>2]=Q;g[j>>2]=w;g[Z>>2]=M;g[na>>2]=ea(0.0);u=ea(g[sa+(ya<<5)+16>>2]);t=ea(g[sa+(ya<<5)+20>>2]);N=ea(g[sa+(ya<<5)+24>>2]);R=R>u?R:u;O=O>t?O:t;P=P>N?P:N;g[_>>2]=R;g[$>>2]=O;g[aa>>2]=P;g[oa>>2]=ea(0.0);za=za+1|0}while((za|0)!=(Ha|0))}}else{c[ta+(ua<<5)+24>>2]=c[T>>2];c[ta+(ua<<5)+28>>2]=0;F5a(a,b+(ra<<2)|0,Ha,e,f,m,Y)}while(0);if(!S){c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[h+16>>2]=c[m+16>>2];c[h+20>>2]=c[m+20>>2];c[h+24>>2]=c[m+24>>2];c[h+28>>2]=c[m+28>>2];P=ea(g[m>>2]);O=ea(g[j>>2]);R=ea(g[Z>>2]);M=ea(g[_>>2]);w=ea(g[$>>2]);Ia=P;Ja=O;Ka=R;La=M;Ma=w;Na=ea(g[aa>>2])}else{w=ea(g[h>>2]);M=ea(g[ba>>2]);R=ea(g[ca>>2]);O=ea(g[m>>2]);P=ea(g[j>>2]);Q=ea(g[Z>>2]);g[h>>2]=w<O?w:O;g[ba>>2]=M<P?M:P;g[ca>>2]=R<Q?R:Q;g[fa>>2]=ea(0.0);R=ea(g[ga>>2]);M=ea(g[ha>>2]);w=ea(g[ia>>2]);N=ea(g[_>>2]);t=ea(g[$>>2]);u=ea(g[aa>>2]);g[ga>>2]=R>N?R:N;g[ha>>2]=M>t?M:t;g[ia>>2]=w>u?w:u;g[ja>>2]=ea(0.0);Ia=O;Ja=P;Ka=Q;La=N;Ma=t;Na=u}ra=c[e>>2]|0;g[ra+(ua<<5)>>2]=Ia;g[ra+(ua<<5)+4>>2]=Ja;g[ra+(ua<<5)+8>>2]=Ka;g[ra+(ua<<5)+12>>2]=La;g[ra+(ua<<5)+16>>2]=Ma;g[ra+(ua<<5)+20>>2]=Na;S=S+1|0;if((S|0)==4)break;else pa=Ga}i=k;return}function G5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b*28|0,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?523568:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j*28|0)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2]}j=j+28|0;if(j>>>0>=e>>>0)break;else f=f+28|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function H5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*28|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?523568:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*28|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2]}j=j+28|0;if(j>>>0>=h>>>0)break;else k=k+28|0}n=c[l>>2]|0}else n=f;f=m+(n*28|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o*28|0)|0;i=d;return q|0}b=c[a>>2]|0;if(!b){c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o*28|0)|0;i=d;return q|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b);c[a>>2]=m;c[e>>2]=g;o=c[l>>2]|0;p=o+1|0;c[l>>2]=p;q=m+(o*28|0)|0;i=d;return q|0}function I5a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;xIa(g,c[d>>2]|0,e,c[a>>2]|0,b,ea(0.0));h=c[g+4>>2]|0;if(!h){yIa(g);i=f;return}j=c[g>>2]|0;c[d>>2]=j;c[a>>2]=h;YEi(e|0,c[g+8>>2]|0,j*12|0)|0;j=c[g+12>>2]|0;k=0;do{l=k*3|0;c[b+(k*12|0)>>2]=c[j+(l<<2)>>2];c[b+(k*12|0)+4>>2]=c[j+(l+1<<2)>>2];c[b+(k*12|0)+8>>2]=c[j+(l+2<<2)>>2];k=k+1|0}while((k|0)!=(h|0));yIa(g);J5a(a,b,1)|0;K5a(c[d>>2]|0,e,c[a>>2]|0,b,1)|0;K5a(c[d>>2]|0,e,c[a>>2]|0,b,1)|0;J5a(a,b,1)|0;i=f;return}function J5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+12|0;g=e;h=c[a>>2]|0;if((h|0)==0|(b|0)==0){j=1;i=e;return j|0}k=i;i=i+((1*(h*12|0)|0)+15&-16)|0;l=0;do{c[k+(l*12|0)>>2]=c[b+(l*12|0)>>2];c[k+(l*12|0)+4>>2]=c[b+(l*12|0)+4>>2];c[k+(l*12|0)+8>>2]=c[b+(l*12|0)+8>>2];l=l+1|0}while(l>>>0<h>>>0);gIa(f,k,h);iIa(f,g)|0;h=c[g+4>>2]|0;k=h>>>0>=(c[a>>2]|0)>>>0;if(!(k|d^1)){c[a>>2]=h;if(!h)m=0;else{h=c[g>>2]|0;g=0;do{c[b+(g*12|0)>>2]=c[h+(g*12|0)>>2];c[b+(g*12|0)+4>>2]=c[h+(g*12|0)+4>>2];c[b+(g*12|0)+8>>2]=c[h+(g*12|0)+8>>2];g=g+1|0}while(g>>>0<(c[a>>2]|0)>>>0);m=0}}else m=k;hIa(f);j=m;i=e;return j|0}function K5a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0;h=i;if((a|0)==0|(b|0)==0|(d|0)==0|(e|0)==0){j=0;i=h;return j|0}k=ea(ea(1.0)/ea(a>>>0));l=ea(0.0);m=ea(0.0);n=ea(0.0);o=0;do{l=ea(l+ea(k*ea(g[b+(o*12|0)>>2])));m=ea(m+ea(k*ea(g[b+(o*12|0)+4>>2])));n=ea(n+ea(k*ea(g[b+(o*12|0)+8>>2])));o=o+1|0}while((o|0)!=(a|0));a=f^1;f=1;o=0;while(1){p=c[e+(o*12|0)>>2]|0;q=e+(o*12|0)+4|0;r=c[q>>2]|0;s=e+(o*12|0)+8|0;t=c[s>>2]|0;k=ea(g[b+(r*12|0)>>2]);u=ea(g[b+(p*12|0)>>2]);v=ea(k-u);k=ea(g[b+(r*12|0)+4>>2]);w=ea(g[b+(p*12|0)+4>>2]);x=ea(k-w);k=ea(g[b+(r*12|0)+8>>2]);y=ea(g[b+(p*12|0)+8>>2]);z=ea(k-y);k=ea(ea(g[b+(t*12|0)>>2])-u);A=ea(ea(g[b+(t*12|0)+4>>2])-w);B=ea(ea(g[b+(t*12|0)+8>>2])-y);C=ea(ea(x*B)-ea(z*A));D=ea(ea(z*k)-ea(v*B));B=ea(ea(v*A)-ea(x*k));k=ea(ea(B*B)+ea(ea(C*C)+ea(D*D)));if(k>ea(0.0)){x=ea(ea(1.0)/ea(T(ea(k))));E=ea(C*x);F=ea(D*x);G=ea(B*x)}else{E=ea(0.0);F=ea(0.0);G=ea(0.0)}p=!(ea(ea(ea(n*G)+ea(ea(m*F)+ea(l*E)))-ea(ea(y*G)+ea(ea(w*F)+ea(u*E))))>ea(0.0));if(p|a)H=p&f;else{c[q>>2]=t;c[s>>2]=r;H=0}o=o+1|0;if((o|0)==(d|0)){j=H;break}else f=H}i=h;return j|0}function L5a(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0;k=i;i=i+112|0;l=k;m=k+72|0;n=k+68|0;o=k+24|0;p=k+48|0;q=k+16|0;r=k+32|0;s=k+80|0;t=k+96|0;u=c[f+32>>2]|0;v=c[f>>2]|0;w=a[(c[f+20>>2]|0)+38>>0]|0;x=w&255;y=f+36|0;f=c[y>>2]|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p>>2]=u;c[p+4>>2]=f;c[p+8>>2]=0;c[p+12>>2]=v;g[p+16>>2]=ea(.00499999989);THa(q);if(!(UHa(q,p)|0)){z=0;RHa(q);i=k;return z|0}if(SHa(q)|0){z=0;RHa(q);i=k;return z|0}p=i;i=i+((1*u|0)+15&-16)|0;PEi(p|0,0,u|0)|0;v=i;i=i+((1*x|0)+15&-16)|0;PEi(v|0,0,x|0)|0;c[b>>2]=0;A=q+4|0;B=r+4|0;C=r+8|0;D=(f|0)==0;E=l+8|0;F=l+4|0;G=t+4|0;H=t+8|0;I=e+4|0;J=e+8|0;K=(h|0)==0;L=h+4|0;M=h+8|0;N=j+4|0;O=j+8|0;P=s+4|0;Q=s+8|0;R=0;a:while(1){if(R>>>0<u>>>0?(a[p+R>>0]|0)!=0:0){R=R+1|0;continue}if((R|0)==(u|0)){S=128;break}aLa(r);b:while(1){rFb(r,c[A>>2]|0,R,p);T=c[A>>2]|0;U=0;do{V=c[B>>2]|0;if(U>>>0>=V>>>0)break b;W=c[C>>2]|0;X=c[W+(U<<2)>>2]|0;U=U+1|0;c:do if(U>>>0<V>>>0){Y=U;while(1){Z=c[W+(Y<<2)>>2]|0;_=c[T+(Z*12|0)>>2]|0;if((_&536870911|0)==(X|0))$=(_&536870912|0)==0;else $=1;_=c[T+(Z*12|0)+4>>2]|0;if((_&536870911|0)==(X|0))aa=(_&536870912|0)==0&$;else aa=$;_=c[T+(Z*12|0)+8>>2]|0;if((_&536870911|0)==(X|0)){if(!((_&536870912|0)==0&aa)){ba=0;break c}}else if(!aa){ba=0;break c}Y=Y+1|0;if(Y>>>0>=V>>>0){ba=1;break}}}else ba=1;while(0);d:do if(D)ca=1;else{V=X*3|0;W=c[f+(V<<2)>>2]|0;Y=c[f+(V+1<<2)>>2]|0;_=c[f+(V+2<<2)>>2]|0;V=0;while(1){if(!(c[T+(X*12|0)+(V<<2)>>2]&536870912)){if(!V){da=1;fa=2;ga=W;ha=Y}else{Z=(V|0)==1;da=0;fa=Z?2:1;ga=Z?W:Y;ha=_}Z=c[T+(X*12|0)+(da<<2)>>2]&536870911;ia=sFb(X,ga,T,f,l,m)|0;if((ia&(sFb(Z,ga,T,f,n,o)|0)?(c[l>>2]|0)==(c[o>>2]|0):0)?(c[m>>2]|0)==(c[n>>2]|0):0){ca=0;break d}Z=c[T+(X*12|0)+(fa<<2)>>2]&536870911;ia=sFb(X,ha,T,f,l,m)|0;if((ia&(sFb(Z,ha,T,f,n,o)|0)?(c[l>>2]|0)==(c[o>>2]|0):0)?(c[m>>2]|0)==(c[n>>2]|0):0){ca=0;break d}}V=V+1|0;if(V>>>0>=3){ca=1;break}}}while(0)}while(ca&ba);if(!(c[B>>2]|0))continue;U=c[C>>2]|0;X=0;do{V=U+(X<<2)|0;_=c[V>>2]|0;Y=T+(_*12|0)|0;c[Y>>2]=c[Y>>2]|536870912;Y=T+(_*12|0)+4|0;c[Y>>2]=c[Y>>2]|536870912;Y=T+(_*12|0)+8|0;c[Y>>2]=c[Y>>2]|536870912;a[p+(c[V>>2]|0)>>0]=0;X=X+1|0;ja=c[B>>2]|0}while(X>>>0<ja>>>0);if(!ja)continue;c[B>>2]=0}aLa(s);if(c[B>>2]|0){X=0;do{T=c[(c[C>>2]|0)+(X<<2)>>2]|0;U=T*3|0;if(D){S=41;break a}V=c[f+(U<<2)>>2]|0;Y=c[f+(U+1<<2)>>2]|0;_=c[f+(U+2<<2)>>2]|0;U=c[A>>2]|0;if(!(c[U+(T*12|0)>>2]&536870912))ka=U;else{U=c[P>>2]|0;if((U|0)==(c[s>>2]|0)){gLa(s,1)|0;la=c[P>>2]|0}else la=U;c[P>>2]=la+1;U=c[Q>>2]|0;c[U+(la<<2)>>2]=V;W=c[P>>2]|0;if((W|0)==(c[s>>2]|0)){gLa(s,1)|0;ma=c[P>>2]|0;na=c[Q>>2]|0}else{ma=W;na=U}c[P>>2]=ma+1;c[na+(ma<<2)>>2]=Y;ka=c[A>>2]|0}if(!(c[ka+(T*12|0)+4>>2]&536870912))oa=ka;else{U=c[P>>2]|0;if((U|0)==(c[s>>2]|0)){gLa(s,1)|0;pa=c[P>>2]|0}else pa=U;c[P>>2]=pa+1;U=c[Q>>2]|0;c[U+(pa<<2)>>2]=V;V=c[P>>2]|0;if((V|0)==(c[s>>2]|0)){gLa(s,1)|0;qa=c[P>>2]|0;ra=c[Q>>2]|0}else{qa=V;ra=U}c[P>>2]=qa+1;c[ra+(qa<<2)>>2]=_;oa=c[A>>2]|0}if(c[oa+(T*12|0)+8>>2]&536870912){T=c[P>>2]|0;if((T|0)==(c[s>>2]|0)){gLa(s,1)|0;sa=c[P>>2]|0}else sa=T;c[P>>2]=sa+1;T=c[Q>>2]|0;c[T+(sa<<2)>>2]=Y;Y=c[P>>2]|0;if((Y|0)==(c[s>>2]|0)){gLa(s,1)|0;ta=c[P>>2]|0;ua=c[Q>>2]|0}else{ta=Y;ua=T}c[P>>2]=ta+1;c[ua+(ta<<2)>>2]=_}X=X+1|0}while(X>>>0<(c[B>>2]|0)>>>0)}aLa(t);bLa(l,s);X=c[F>>2]|0;_=X>>>1;e:do if(!_)va=X;else{T=c[E>>2]|0;Y=_;U=X;while(1){V=0;f:while(1){W=c[T+(V<<3)>>2]|0;Z=c[T+(V<<3)+4>>2]|0;ia=V+1|0;if(ia>>>0<Y>>>0)wa=ia;else{va=U;break e}while(1){xa=c[T+(wa<<3)>>2]|0;ya=c[T+(wa<<3)+4>>2]|0;if((xa|0)==(W|0)&(ya|0)==(Z|0))break f;if((ya|0)==(W|0)&(xa|0)==(Z|0))break f;xa=wa+1|0;if(xa>>>0<Y>>>0)wa=xa;else{V=ia;continue f}}}ia=wa<<1;Z=U+-1|0;c[F>>2]=Z;c[T+((ia|1)<<2)>>2]=c[T+(Z<<2)>>2];Z=(c[F>>2]|0)+-1|0;c[F>>2]=Z;c[T+(ia<<2)>>2]=c[T+(Z<<2)>>2];Z=V<<1;ia=(c[F>>2]|0)+-1|0;c[F>>2]=ia;c[T+((Z|1)<<2)>>2]=c[T+(ia<<2)>>2];ia=(c[F>>2]|0)+-1|0;c[F>>2]=ia;c[T+(Z<<2)>>2]=c[T+(ia<<2)>>2];ia=c[F>>2]|0;Y=ia>>>1;if(!Y){va=ia;break}else U=ia}}while(0);if(va>>>0>1?(X=c[E>>2]|0,(X|0)!=0):0){_=c[X>>2]|0;U=c[X+4>>2]|0;X=c[G>>2]|0;if((X|0)==(c[t>>2]|0)){gLa(t,1)|0;za=c[G>>2]|0}else za=X;c[G>>2]=za+1;X=c[H>>2]|0;c[X+(za<<2)>>2]=_;_=c[G>>2]|0;if((_|0)==(c[t>>2]|0)){gLa(t,1)|0;Aa=c[G>>2]|0;Ba=c[H>>2]|0}else{Aa=_;Ba=X}c[G>>2]=Aa+1;c[Ba+(Aa<<2)>>2]=U;X=(c[F>>2]|0)+-1|0;c[F>>2]=X;_=c[E>>2]|0;c[_+4>>2]=c[_+(X<<2)>>2];X=(c[F>>2]|0)+-1|0;c[F>>2]=X;c[_>>2]=c[_+(X<<2)>>2];Ca=c[F>>2]|0;Da=U}else{Ca=va;Da=-1}U=Ca>>>1;if(U){X=U;U=c[E>>2]|0;_=Da;while(1){if(!X){S=126;break a}else Ea=0;while(1){Fa=Ea<<1;Ga=c[U+(Fa<<2)>>2]|0;Ha=Fa|1;Ia=c[U+(Ha<<2)>>2]|0;if((Ga|0)==(_|0)){S=80;break}Ea=Ea+1|0;if((Ia|0)==(_|0)){S=85;break}if(Ea>>>0>=X>>>0){S=126;break a}}if((S|0)==80){S=0;Y=c[G>>2]|0;if((Y|0)==(c[t>>2]|0)){gLa(t,1)|0;Ja=c[G>>2]|0;Ka=c[E>>2]|0}else{Ja=Y;Ka=U}c[G>>2]=Ja+1;c[(c[H>>2]|0)+(Ja<<2)>>2]=Ia;Y=(c[F>>2]|0)+-1|0;c[F>>2]=Y;c[Ka+(Ha<<2)>>2]=c[Ka+(Y<<2)>>2];Y=(c[F>>2]|0)+-1|0;c[F>>2]=Y;c[Ka+(Fa<<2)>>2]=c[Ka+(Y<<2)>>2];La=Ka;Ma=Ia}else if((S|0)==85){S=0;Y=c[G>>2]|0;if((Y|0)==(c[t>>2]|0)){gLa(t,1)|0;Na=c[G>>2]|0;Oa=c[E>>2]|0}else{Na=Y;Oa=U}c[G>>2]=Na+1;c[(c[H>>2]|0)+(Na<<2)>>2]=Ga;Y=(c[F>>2]|0)+-1|0;c[F>>2]=Y;c[Oa+(Ha<<2)>>2]=c[Oa+(Y<<2)>>2];Y=(c[F>>2]|0)+-1|0;c[F>>2]=Y;c[Oa+(Fa<<2)>>2]=c[Oa+(Y<<2)>>2];La=Oa;Ma=Ga}X=(c[F>>2]|0)>>>1;if(!X)break;else{U=La;_=Ma}}}dLa(l);_=c[G>>2]|0;if(_){U=c[H>>2]|0;X=_+-1|0;_=(X|0)==0;if(!_){Y=0;do{T=v+(c[U+(Y<<2)>>2]|0)|0;a[T>>0]=(a[T>>0]|0)+1<<24>>24;Y=Y+1|0}while((Y|0)!=(X|0))}Y=c[I>>2]|0;if((Y|0)==(c[e>>2]|0)){gLa(e,1)|0;Pa=c[I>>2]|0}else Pa=Y;c[I>>2]=Pa+1;Y=c[J>>2]|0;c[Y+(Pa<<2)>>2]=X;if(!((U|0)==0|_)){T=c[I>>2]|0;if((T+X|0)>>>0>(c[e>>2]|0)>>>0){gLa(e,X)|0;Qa=c[J>>2]|0;Ra=c[I>>2]|0}else{Qa=Y;Ra=T}YEi(Qa+(Ra<<2)|0,U|0,X<<2|0)|0;c[I>>2]=(c[I>>2]|0)+X}c[b>>2]=(c[b>>2]|0)+1;if(!(c[B>>2]|0))Sa=0;else{T=0;while(1){Y=(c[(c[C>>2]|0)+(T<<2)>>2]|0)*3|0;if(D){S=100;break a}ia=c[f+(Y<<2)>>2]|0;Z=c[f+(Y+1<<2)>>2]|0;W=c[f+(Y+2<<2)>>2]|0;g:do if(!_){Y=0;xa=0;ya=0;Ta=0;do{Ua=c[U+(Ta<<2)>>2]|0;Y=(ia|0)==(Ua|0)|Y;xa=(Z|0)==(Ua|0)|xa;ya=(W|0)==(Ua|0)|ya;Ta=Ta+1|0;if(Y&xa&ya)break g}while(Ta>>>0<X>>>0);if(Y){Va=xa;Wa=ya;S=108}else{Xa=xa;Ya=ya;S=104}}else{Xa=0;Ya=0;S=104}while(0);do if((S|0)==104){S=0;if(eLa(j,ia,0)|0){Va=Xa;Wa=Ya;S=108;break}Ta=c[N>>2]|0;if((Ta|0)==(c[j>>2]|0)){gLa(j,1)|0;Za=c[N>>2]|0}else Za=Ta;c[N>>2]=Za+1;c[(c[O>>2]|0)+(Za<<2)>>2]=ia;if(Xa){_a=Ya;S=113}else{$a=Ya;S=109}}while(0);if((S|0)==108){S=0;if(Va){_a=Wa;S=113}else{$a=Wa;S=109}}do if((S|0)==109){S=0;if(eLa(j,Z,0)|0){_a=$a;S=113;break}ia=c[N>>2]|0;if((ia|0)==(c[j>>2]|0)){gLa(j,1)|0;ab=c[N>>2]|0}else ab=ia;c[N>>2]=ab+1;c[(c[O>>2]|0)+(ab<<2)>>2]=Z;if(!$a)S=114}while(0);if((S|0)==113?(S=0,!_a):0)S=114;do if((S|0)==114){S=0;if(eLa(j,W,0)|0)break;Z=c[N>>2]|0;if((Z|0)==(c[j>>2]|0)){gLa(j,1)|0;bb=c[N>>2]|0}else bb=Z;c[N>>2]=bb+1;c[(c[O>>2]|0)+(bb<<2)>>2]=W}while(0);T=T+1|0;W=c[B>>2]|0;if(T>>>0>=W>>>0){Sa=W;break}}}if(!K){T=c[L>>2]|0;if((T|0)==(c[h>>2]|0)){gLa(h,1)|0;cb=c[L>>2]|0}else cb=T;c[L>>2]=cb+1;T=c[M>>2]|0;c[T+(cb<<2)>>2]=Sa;X=c[C>>2]|0;U=c[B>>2]|0;if(!((X|0)==0|(U|0)==0)){_=c[L>>2]|0;if((_+U|0)>>>0>(c[h>>2]|0)>>>0){gLa(h,U)|0;db=c[M>>2]|0;eb=c[L>>2]|0}else{db=T;eb=_}YEi(db+(eb<<2)|0,X|0,U<<2|0)|0;c[L>>2]=(c[L>>2]|0)+U}}}dLa(t);dLa(s);dLa(r);R=0}if((S|0)==41)hi();else if((S|0)==100)hi();else if((S|0)==126){dLa(l);dKa(bKa()|0,8,524600,752,525592,l);dLa(t);dLa(s);dLa(r);z=0;RHa(q);i=k;return z|0}else if((S|0)==128){if(w<<24>>24){w=0;do{if((d[v+w>>0]|0)<3?!(eLa(j,w,0)|0):0){S=c[N>>2]|0;if((S|0)==(c[j>>2]|0)){gLa(j,1)|0;fb=c[N>>2]|0}else fb=S;c[N>>2]=fb+1;c[(c[O>>2]|0)+(fb<<2)>>2]=w}w=w+1|0}while((w|0)!=(x|0))}if((c[N>>2]|0)==0|K){z=1;RHa(q);i=k;return z|0}tFb(b,e,c[y>>2]|0,h,j);z=1;RHa(q);i=k;return z|0}return 0}function M5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0;e=i;f=b+4|0;h=b+8|0;j=a+4|0;k=a+8|0;if(!c){l=0;do l=l+1|0;while(l>>>0<8);m=1;i=e;return m|0}else{n=ea(0.0);o=ea(0.0);p=ea(0.0);q=0}a:while(1){switch(q|0){case 5:{r=ea(g[b>>2]);s=ea(g[f>>2]);t=ea(g[h>>2]);u=ea(ea(g[a>>2])-r);r=ea(s+ea(g[j>>2]));v=ea(ea(g[k>>2])-t);w=r;x=u;break}case 1:{u=ea(g[b>>2]);r=ea(g[f>>2]);t=ea(g[h>>2]);s=ea(u+ea(g[a>>2]));u=ea(r+ea(g[j>>2]));v=ea(ea(g[k>>2])-t);w=u;x=s;break}case 2:{s=ea(g[b>>2]);u=ea(g[f>>2]);t=ea(g[h>>2]);r=ea(s+ea(g[a>>2]));s=ea(ea(g[j>>2])-u);v=ea(t+ea(g[k>>2]));w=s;x=r;break}case 6:{r=ea(g[b>>2]);s=ea(g[f>>2]);t=ea(g[h>>2]);u=ea(ea(g[a>>2])-r);r=ea(ea(g[j>>2])-s);v=ea(t+ea(g[k>>2]));w=r;x=u;break}case 3:{u=ea(g[b>>2]);r=ea(g[f>>2]);t=ea(g[h>>2]);s=ea(u+ea(g[a>>2]));u=ea(ea(g[j>>2])-r);v=ea(ea(g[k>>2])-t);w=u;x=s;break}case 7:{s=ea(g[b>>2]);u=ea(g[f>>2]);t=ea(g[h>>2]);r=ea(ea(g[a>>2])-s);s=ea(ea(g[j>>2])-u);v=ea(ea(g[k>>2])-t);w=s;x=r;break}case 0:{r=ea(g[b>>2]);s=ea(g[f>>2]);t=ea(g[h>>2]);u=ea(r+ea(g[a>>2]));r=ea(s+ea(g[j>>2]));v=ea(t+ea(g[k>>2]));w=r;x=u;break}case 4:{u=ea(g[b>>2]);r=ea(g[f>>2]);t=ea(g[h>>2]);s=ea(ea(g[a>>2])-u);u=ea(r+ea(g[j>>2]));v=ea(t+ea(g[k>>2]));w=u;x=s;break}default:{v=n;w=p;x=o}}l=0;do{s=ea(g[d+(l*20|0)>>2]);u=ea(g[d+(l*20|0)+4>>2]);t=ea(ea(ea(x*s)+ea(w*u))+ea(v*ea(g[d+(l*20|0)+8>>2])));if(ea(ea(g[d+(l*20|0)+12>>2])+t)>ea(0.0)){m=0;y=16;break a}l=l+1|0}while(l>>>0<c>>>0);q=q+1|0;if(q>>>0>=8){m=1;y=16;break}else{n=v;o=x;p=w}}if((y|0)==16){i=e;return m|0}return 0}function N5a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=e;c[a+12>>2]=-1;c[a+16>>2]=-1;c[a+20>>2]=-1;e=f+4|0;c[a+24>>2]=c[e>>2];d=c[e>>2]|0;b=f+8|0;do if((d|0)==(c[b>>2]|0)){k=(d|0)==0?16:d<<1;l=c[f>>2]|0;c[b>>2]=k;m=UJa(h+1|0,k<<2,526608,153)|0;c[f>>2]=m;k=c[e>>2]|0;if((k|0)>0?(c[m>>2]=c[l>>2],(k|0)>1):0){m=1;do{c[(c[f>>2]|0)+(m<<2)>>2]=c[l+(m<<2)>>2];m=m+1|0}while((m|0)!=(k|0))}else n=6;if((n|0)==6?(l|0)==0:0){o=f;p=k;break}VJa(j,l);o=f;p=c[e>>2]|0}else{o=f;p=d}while(0);c[e>>2]=p+1;c[(c[o>>2]|0)+(p<<2)>>2]=a;c[a+28>>2]=-1;g[a+32>>2]=ea(0.0);i=h;return}function O5a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=0,X=0,Y=Im,Z=0,_=0,$=Im,aa=0,ba=0;f=i;i=i+32|0;h=f+12|0;j=f;k=(b|0)>0;l=d+4|0;m=d+8|0;n=h+4|0;o=h+8|0;p=j+4|0;q=j+8|0;a:while(1){r=c[e>>2]|0;if(k){s=0;t=-1;while(1){do if(!(c[r+(s<<2)>>2]|0))u=t;else{if((t|0)!=-1?(v=ea(g[a+(s*12|0)>>2]),w=ea(g[a+(s*12|0)+4>>2]),x=ea(g[a+(s*12|0)+8>>2]),y=ea(g[d>>2]),z=ea(g[l>>2]),A=ea(g[m>>2]),B=ea(ea(ea(v*y)+ea(w*z))+ea(x*A)),x=ea(g[a+(t*12|0)>>2]),w=ea(g[a+(t*12|0)+4>>2]),!(B>ea(ea(ea(y*x)+ea(z*w))+ea(A*ea(g[a+(t*12|0)+8>>2]))))):0){u=t;break}u=s}while(0);s=s+1|0;if((s|0)==(b|0)){C=u;break}else t=u}}else C=-1;if((c[r+(C<<2)>>2]|0)==3){D=C;E=37;break}A=ea(g[d>>2]);w=ea(g[l>>2]);z=ea(g[m>>2]);x=ea(z*ea(0.0));y=ea(w-x);B=ea(x-A);v=ea(A*ea(0.0));F=ea(w*ea(0.0));G=ea(v-F);g[h>>2]=y;g[n>>2]=B;g[o>>2]=G;H=ea(F-z);I=ea(x-v);v=ea(A-F);g[j>>2]=H;g[p>>2]=I;g[q>>2]=v;t=ea(T(ea(ea(G*G)+ea(ea(y*y)+ea(B*B)))))>ea(T(ea(ea(v*v)+ea(ea(H*H)+ea(I*I)))));s=t?h:j;I=ea(g[s>>2]);t=s+4|0;H=ea(g[t>>2]);J=s+8|0;v=ea(g[J>>2]);B=ea(T(ea(ea(ea(I*I)+ea(H*H))+ea(v*v))));if(B==ea(0.0)){Ec(526896)|0;y=ea(g[s>>2]);G=ea(g[t>>2]);F=ea(g[J>>2]);x=ea(g[d>>2]);K=ea(g[l>>2]);L=y;M=G;N=F;O=ea(.100000001);P=x;Q=K;R=ea(g[m>>2])}else{L=I;M=H;N=v;O=B;P=A;Q=w;R=z}z=ea(ea(1.0)/O);w=ea(L*z);A=ea(M*z);B=ea(N*z);z=ea(ea(A*R)-ea(B*Q));v=ea(ea(B*P)-ea(w*R));H=ea(ea(w*Q)-ea(A*P));J=-1;t=0;while(1){I=ea(t|0);K=ea(I*ea(.0174532924));x=ea(+W(+K));F=ea(+V(+K));K=ea(P+ea(ea(ea(w*x)+ea(z*F))*ea(.0250000004)));G=ea(Q+ea(ea(ea(A*x)+ea(v*F))*ea(.0250000004)));y=ea(R+ea(ea(ea(B*x)+ea(H*F))*ea(.0250000004)));if(k){s=c[e>>2]|0;S=0;U=-1;while(1){do if(!(c[s+(S<<2)>>2]|0))X=U;else{if((U|0)!=-1?(F=ea(g[a+(S*12|0)>>2]),x=ea(g[a+(S*12|0)+4>>2]),Y=ea(ea(ea(K*F)+ea(G*x))+ea(y*ea(g[a+(S*12|0)+8>>2]))),x=ea(g[a+(U*12|0)>>2]),F=ea(g[a+(U*12|0)+4>>2]),!(Y>ea(ea(ea(K*x)+ea(G*F))+ea(y*ea(g[a+(U*12|0)+8>>2]))))):0){X=U;break}X=S}while(0);S=S+1|0;if((S|0)==(b|0)){Z=X;break}else U=X}}else Z=-1;if((J|0)==(C|0)&(Z|0)==(C|0)){E=20;break a}b:do if(!((J|0)==-1|(J|0)==(Z|0))?(y=ea(I+ea(-40.0)),y<=I):0){if(k){_=J;$=y}else{U=J;G=y;while(1){if((U|0)==(C|0)&(C|0)==-1){aa=-1;E=33;break a}G=ea(G+ea(5.0));if(!(G<=I))break b;else U=-1}}while(1){G=ea($*ea(.0174532924));y=ea(+W(+G));K=ea(+V(+G));G=ea(P+ea(ea(ea(w*y)+ea(z*K))*ea(.0250000004)));F=ea(Q+ea(ea(ea(A*y)+ea(v*K))*ea(.0250000004)));x=ea(R+ea(ea(ea(B*y)+ea(H*K))*ea(.0250000004)));U=c[e>>2]|0;S=0;s=-1;while(1){do if(!(c[U+(S<<2)>>2]|0))ba=s;else{if((s|0)!=-1?(K=ea(g[a+(S*12|0)>>2]),y=ea(g[a+(S*12|0)+4>>2]),Y=ea(ea(ea(G*K)+ea(F*y))+ea(x*ea(g[a+(S*12|0)+8>>2]))),y=ea(g[a+(s*12|0)>>2]),K=ea(g[a+(s*12|0)+4>>2]),!(Y>ea(ea(ea(G*y)+ea(F*K))+ea(x*ea(g[a+(s*12|0)+8>>2]))))):0){ba=s;break}ba=S}while(0);S=S+1|0;if((S|0)==(b|0))break;else s=ba}if((_|0)==(C|0)&(ba|0)==(C|0)){aa=C;E=33;break a}$=ea($+ea(5.0));if(!($<=I))break;else _=ba}}while(0);t=t+45|0;if((t|0)>360)break;else J=Z}c[(c[e>>2]|0)+(C<<2)>>2]=0}if((E|0)==20){c[(c[e>>2]|0)+(C<<2)>>2]=3;D=C;i=f;return D|0}else if((E|0)==33){c[(c[e>>2]|0)+(aa<<2)>>2]=3;D=aa;i=f;return D|0}else if((E|0)==37){i=f;return D|0}return 0}function P5a(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+16|0;l=k;uFb(d,e,h,0,0,0);h=d+132|0;c[d>>2]=527064;c[d+116>>2]=527168;c[d+120>>2]=527224;c[d+124>>2]=527244;c[d+128>>2]=527284;c[h>>2]=527304;c[d+136>>2]=f;f=d+140|0;c[f>>2]=e;e=d+144|0;c[e>>2]=f;m=c[(qTa()|0)>>2]|0;n=c[c[e>>2]>>2]|0;o=Bn[c[(c[n>>2]|0)+8>>2]&255](n,m,527016,544464,111)|0;c[d+148>>2]=o;if(o)mTa(o);c[d+152>>2]=f;c[d+156>>2]=0;c[d+160>>2]=0;c[d+164>>2]=0;o=d+168|0;c[o>>2]=f;m=d+172|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;g[d+196>>2]=ea(.75);c[d+200>>2]=-1;c[d+204>>2]=0;c[d+208>>2]=0;VUa(o,64);o=d+212|0;c[o>>2]=f;m=d+216|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;g[d+240>>2]=ea(.75);c[d+244>>2]=-1;c[d+248>>2]=0;c[d+252>>2]=0;vFb(o,64);c[d+256>>2]=0;c[d+260>>2]=f;c[d+264>>2]=0;c[d+268>>2]=0;c[d+272>>2]=0;a[d+276>>0]=0;c[d+280>>2]=0;f=d+72|0;c[f>>2]=e;o=j;j=c[o>>2]|0;m=c[o+4>>2]|0;if(j){o=0;do{wFb(d,c[m+(o<<3)>>2]|0,b[m+(o<<3)+4>>1]|0,(a[m+(o<<3)+6>>0]|0)!=0);o=o+1|0}while((o|0)!=(j|0));j=c[f>>2]|0;if(!j){p=0;q=1;r=l}else{s=j;t=l;u=7}}else{s=e;t=l;u=7}if((u|0)==7){oTa(c[s+4>>2]|0);p=s;q=0;r=t}c[l>>2]=h;t=d+36|0;r=c[t>>2]|0;if((c[d+40>>2]&2147483647)>>>0>r>>>0){s=(c[d+32>>2]|0)+(r<<2)|0;if(s)c[s>>2]=h;c[t>>2]=r+1}else xFb(d+28|0,l)|0;a[d+76>>0]=1;if(q){i=k;return}pTa(c[p+4>>2]|0);i=k;return}function Q5a(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;if((d|0)!=0?(d+-1&d|0)==0:0)f=d;else{h=d>>>1|d;d=h>>>2|h;h=d>>>4|d;d=h>>>8|h;f=(d>>>16|d)+1|0}d=b+16|0;h=c[d>>2]|0;j=ea(f>>>0);k=~~ea(j*ea(g[b+24>>2]))>>>0;l=f<<2;m=(k<<2)+l|0;n=(0-m&12)+m|0;m=UJa(b,n+(k<<3)|0,529024,354)|0;o=m+l|0;p=m+n|0;PEi(m|0,-1,l|0)|0;l=b+36|0;n=b+4|0;if(c[l>>2]|0){q=f+-1|0;r=0;do{s=c[n>>2]|0;t=c[s+(r<<3)>>2]|0;u=a[t>>0]|0;if(!(u<<24>>24))v=5381;else{w=u;u=5381;x=t;while(1){y=u*33^w<<24>>24;x=x+1|0;w=a[x>>0]|0;if(!(w<<24>>24)){v=y;break}else u=y}}u=m+((v&q)<<2)|0;c[o+(r<<2)>>2]=c[u>>2];c[u>>2]=r;u=p+(r<<3)|0;if(u){c[u>>2]=t;c[p+(r<<3)+4>>2]=c[s+(r<<3)+4>>2]}r=r+1|0}while(r>>>0<(c[l>>2]|0)>>>0)}VJa(b,c[b>>2]|0);c[b>>2]=m;c[b+12>>2]=m;c[b+20>>2]=f;c[b+8>>2]=o;c[n>>2]=p;c[d>>2]=k;k=b+28|0;if((c[k>>2]|0)!=-1){i=e;return}c[k>>2]=h;i=e;return}function R5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?527904:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function S5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=b+20|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=a[k>>0]|0;if(!(l<<24>>24))m=5381;else{n=l;l=5381;o=k;while(1){p=l*33^n<<24>>24;o=o+1|0;n=a[o>>0]|0;if(!(n<<24>>24)){m=p;break}else l=p}}l=m&h+-1;n=c[(c[b+12>>2]|0)+(l<<2)>>2]|0;if((n|0)==-1)q=l;else{o=c[b+4>>2]|0;p=b+8|0;r=n;while(1){if(!(HEi(c[o+(r<<3)>>2]|0,k)|0))break;n=c[(c[p>>2]|0)+(r<<2)>>2]|0;if((n|0)==-1){q=l;break a}else r=n}a[e>>0]=1;s=o+(r<<3)|0;i=f;return s|0}}else q=0;while(0);a[e>>0]=0;e=b+36|0;if((c[e>>2]|0)==(c[b+16>>2]|0)){m=j?16:h<<1;if(h>>>0<m>>>0){Q5a(b,m);t=c[g>>2]|0}else t=h;h=c[d>>2]|0;d=a[h>>0]|0;if(!(d<<24>>24))u=5381;else{g=d;d=5381;m=h;while(1){h=d*33^g<<24>>24;m=m+1|0;g=a[m>>0]|0;if(!(g<<24>>24)){u=h;break}else d=h}}v=u&t+-1}else v=q;q=b+28|0;t=c[q>>2]|0;c[q>>2]=t+1;q=(c[b+12>>2]|0)+(v<<2)|0;c[(c[b+8>>2]|0)+(t<<2)>>2]=c[q>>2];c[q>>2]=t;c[e>>2]=(c[e>>2]|0)+1;e=b+32|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+4>>2]|0)+(t<<3)|0;i=f;return s|0}function T5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g*20|0,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?527784:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f*20|0)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2]}j=j+20|0;if(j>>>0>=h>>>0)break;else k=k+20|0}n=c[l>>2]|0}else n=f;f=m+(n*20|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2]}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g*20|0)|0}function U5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<3,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?528120:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<3)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j){n=k;o=c[n+4>>2]|0;p=j;c[p>>2]=c[n>>2];c[p+4>>2]=o}j=j+8|0;if(j>>>0>=h>>>0)break;else k=k+8|0}q=c[l>>2]|0}else q=f;f=m+(q<<3)|0;if(f){q=b;b=c[q+4>>2]|0;k=f;c[k>>2]=c[q>>2];c[k+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b)}c[a>>2]=m;c[e>>2]=g;g=c[l>>2]|0;c[l>>2]=g+1;i=d;return m+(g<<3)|0}function V5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;if((b|0)!=0?(b+-1&b|0)==0:0)e=b;else{f=b>>>1|b;b=f>>>2|f;f=b>>>4|b;b=f>>>8|f;e=(b>>>16|b)+1|0}b=a+16|0;f=c[b>>2]|0;h=ea(e>>>0);j=~~ea(h*ea(g[a+24>>2]))>>>0;k=e<<2;l=(j<<2)+k|0;m=(0-l&12)+l|0;l=c[132074]|0;n=mo[c[(c[l>>2]|0)+20>>2]&4095](l)|0;l=Bn[c[(c[n>>2]|0)+8>>2]&255](n,m+(j<<3)|0,529112,529024,354)|0;n=l+k|0;o=l+m|0;PEi(l|0,-1,k|0)|0;k=a+36|0;m=a+4|0;if(c[k>>2]|0){p=e+-1|0;q=0;do{r=c[m>>2]|0;s=c[r+(q<<3)>>2]|0;t=s;u=t+~(t<<15)|0;t=(u>>>10^u)*9|0;u=t>>>6^t;t=u+~(u<<11)|0;u=l+(((t>>>16^t)&p)<<2)|0;c[n+(q<<2)>>2]=c[u>>2];c[u>>2]=q;u=o+(q<<3)|0;if(u){c[u>>2]=s;c[o+(q<<3)+4>>2]=c[r+(q<<3)+4>>2]}q=q+1|0}while(q>>>0<(c[k>>2]|0)>>>0)}k=c[a>>2]|0;q=c[132074]|0;p=mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,k);c[a>>2]=l;c[a+12>>2]=l;c[a+20>>2]=e;c[a+8>>2]=n;c[m>>2]=o;c[b>>2]=j;j=a+28|0;if((c[j>>2]|0)!=-1){i=d;return}c[j>>2]=f;i=d;return}function W5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)X5a(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function X5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b)e=0;else e=UJa(a,b<<2,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<2)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f)c[f>>2]=c[h>>2];f=f+4|0;if(f>>>0>=g>>>0)break;else h=h+4|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function Y5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<4,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?422760:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<4)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);c[k+12>>2]=c[l+12>>2]}k=k+16|0;if(k>>>0>=j>>>0)break;else l=l+16|0}o=c[m>>2]|0}else o=f;f=n+(o<<4)|0;if(f){g[f>>2]=ea(g[b>>2]);g[n+(o<<4)+4>>2]=ea(g[b+4>>2]);g[n+(o<<4)+8>>2]=ea(g[b+8>>2]);c[n+(o<<4)+12>>2]=c[b+12>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p<<4)|0;i=d;return r|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p<<4)|0;i=d;return r|0}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,b);c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p<<4)|0;i=d;return r|0}function Z5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<5,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?422648:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<5)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);c[k+12>>2]=c[l+12>>2];g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);g[k+24>>2]=ea(g[l+24>>2]);c[k+28>>2]=c[l+28>>2]}k=k+32|0;if(k>>>0>=j>>>0)break;else l=l+32|0}o=c[m>>2]|0}else o=f;f=n+(o<<5)|0;if(f){g[f>>2]=ea(g[b>>2]);g[n+(o<<5)+4>>2]=ea(g[b+4>>2]);g[n+(o<<5)+8>>2]=ea(g[b+8>>2]);c[n+(o<<5)+12>>2]=c[b+12>>2];g[n+(o<<5)+16>>2]=ea(g[b+16>>2]);g[n+(o<<5)+20>>2]=ea(g[b+20>>2]);g[n+(o<<5)+24>>2]=ea(g[b+24>>2]);c[n+(o<<5)+28>>2]=c[b+28>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p<<5)|0;i=d;return r|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p<<5)|0;i=d;return r|0}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,b);c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p<<5)|0;i=d;return r|0}function _5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*48|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?422528:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*48|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);c[k+12>>2]=c[l+12>>2];g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);g[k+24>>2]=ea(g[l+24>>2]);c[k+28>>2]=c[l+28>>2];g[k+32>>2]=ea(g[l+32>>2]);g[k+36>>2]=ea(g[l+36>>2]);g[k+40>>2]=ea(g[l+40>>2]);c[k+44>>2]=c[l+44>>2]}k=k+48|0;if(k>>>0>=j>>>0)break;else l=l+48|0}o=c[m>>2]|0}else o=f;f=n+(o*48|0)|0;if(f){g[f>>2]=ea(g[b>>2]);g[n+(o*48|0)+4>>2]=ea(g[b+4>>2]);g[n+(o*48|0)+8>>2]=ea(g[b+8>>2]);c[n+(o*48|0)+12>>2]=c[b+12>>2];g[n+(o*48|0)+16>>2]=ea(g[b+16>>2]);g[n+(o*48|0)+20>>2]=ea(g[b+20>>2]);g[n+(o*48|0)+24>>2]=ea(g[b+24>>2]);c[n+(o*48|0)+28>>2]=c[b+28>>2];g[n+(o*48|0)+32>>2]=ea(g[b+32>>2]);g[n+(o*48|0)+36>>2]=ea(g[b+36>>2]);g[n+(o*48|0)+40>>2]=ea(g[b+40>>2]);c[n+(o*48|0)+44>>2]=c[b+44>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*48|0)|0;i=d;return r|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*48|0)|0;i=d;return r|0}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,b);c[a>>2]=n;c[e>>2]=h;p=c[m>>2]|0;q=p+1|0;c[m>>2]=q;r=n+(p*48|0)|0;i=d;return r|0}function $5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*24|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?422416:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*24|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);o=k+12|0;p=l+12|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2]}k=k+24|0;if(k>>>0>=j>>>0)break;else l=l+24|0}q=c[m>>2]|0}else q=f;f=n+(q*24|0)|0;if(f){g[f>>2]=ea(g[b>>2]);g[n+(q*24|0)+4>>2]=ea(g[b+4>>2]);g[n+(q*24|0)+8>>2]=ea(g[b+8>>2]);f=n+(q*24|0)+12|0;q=b+12|0;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2]}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;r=c[m>>2]|0;s=r+1|0;c[m>>2]=s;t=n+(r*24|0)|0;i=d;return t|0}q=c[a>>2]|0;if(!q){c[a>>2]=n;c[e>>2]=h;r=c[m>>2]|0;s=r+1|0;c[m>>2]=s;t=n+(r*24|0)|0;i=d;return t|0}f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,q);c[a>>2]=n;c[e>>2]=h;r=c[m>>2]|0;s=r+1|0;c[m>>2]=s;t=n+(r*24|0)|0;i=d;return t|0}function a6a(a,d,f,h,j,k,l,m,n){a=a|0;d=d|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=0,J=Im,K=0,L=Im,M=0,N=Im,O=0,P=Im,Q=0,R=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,_=0,$=Im,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im;o=i;i=i+80|0;p=o+64|0;q=o+52|0;r=o+40|0;s=o+4|0;t=o;if(!a){u=0;i=o;return u|0}v=ea(g[f>>2]);w=f+4|0;x=ea(g[w>>2]);y=f+8|0;z=ea(g[y>>2]);A=f+12|0;B=ea(g[A>>2]);C=f+16|0;D=ea(g[C>>2]);E=f+20|0;F=ea(g[E>>2]);G=f+24|0;H=ea(g[G>>2]);I=f+28|0;J=ea(g[I>>2]);K=f+32|0;L=ea(g[K>>2]);M=f+36|0;N=ea(g[M>>2]);O=f+40|0;P=ea(g[O>>2]);Q=f+44|0;R=ea(-N);N=ea(-P);P=ea(-ea(g[Q>>2]));U=ea(ea(ea(v*R)+ea(x*N))+ea(z*P));V=ea(ea(ea(B*R)+ea(D*N))+ea(F*P));W=ea(ea(ea(H*R)+ea(J*N))+ea(L*P));P=ea(g[h>>2]);N=ea(v*P);R=ea(B*P);X=ea(H*P);Y=h+4|0;P=ea(g[Y>>2]);Z=ea(N+ea(x*P));N=ea(R+ea(D*P));R=ea(X+ea(J*P));_=h+8|0;P=ea(g[_>>2]);X=ea(Z+ea(z*P));Z=ea(N+ea(F*P));N=ea(R+ea(L*P));g[p>>2]=X;g[p+4>>2]=Z;g[p+8>>2]=N;P=ea(X*j);R=ea(Z*j);$=ea(N*j);g[q>>2]=P;aa=q+4|0;g[aa>>2]=R;ba=q+8|0;g[ba>>2]=$;ca=k+40|0;g[ca>>2]=j;if(X!=ea(0.0))da=ea(ea(1.0)/P);else da=ea(0.0);if(Z!=ea(0.0))fa=ea(ea(1.0)/R);else fa=ea(0.0);if(N!=ea(0.0))ga=ea(ea(1.0)/$);else ga=ea(0.0);g[r>>2]=da;g[r+4>>2]=fa;g[r+8>>2]=ga;ga=ea(S(ea(X)));ha=f+48|0;X=ea(ga*ea(g[ha>>2]));ga=ea(S(ea(Z)));Z=ea(X+ea(ga*ea(g[f+52>>2])));ga=ea(S(ea(N)));N=ea(Z+ea(ga*ea(g[f+56>>2])));ga=ea(g[M>>2]);Z=ea(ga*ea(g[h>>2]));ga=ea(g[O>>2]);X=ea(Z+ea(ga*ea(g[Y>>2])));ga=ea(g[Q>>2]);Z=ea(X+ea(ga*ea(g[_>>2])));if(!n)ia=0;else ia=c[n>>2]|0;n=s+4|0;ja=s+8|0;ka=s+12|0;la=s+16|0;ma=s+20|0;na=s+24|0;oa=s+28|0;pa=s+32|0;qa=k+8|0;ra=0;ga=ea(1.0);sa=0;while(1){if(!ra)ta=ia;else ta=(ra|0)==(ia|0)?0:ra;X=ea(g[d+(ta*36|0)>>2]);g[s>>2]=X;fa=ea(g[d+(ta*36|0)+4>>2]);g[n>>2]=fa;da=ea(g[d+(ta*36|0)+8>>2]);g[ja>>2]=da;$=ea(g[d+(ta*36|0)+12>>2]);g[ka>>2]=$;R=ea(g[d+(ta*36|0)+16>>2]);g[la>>2]=R;P=ea(g[d+(ta*36|0)+20>>2]);g[ma>>2]=P;ua=ea(g[d+(ta*36|0)+24>>2]);g[na>>2]=ua;va=ea(g[d+(ta*36|0)+28>>2]);g[oa>>2]=va;wa=ea(g[d+(ta*36|0)+32>>2]);g[pa>>2]=wa;xa=ea(ga*j);ya=ea(g[h>>2]);za=ea(X*ya);Aa=ea(g[Y>>2]);Ba=ea(za+ea(fa*Aa));za=ea(g[_>>2]);Ca=ea(Ba+ea(da*za));Ba=ea(ea(ea(ya*$)+ea(Aa*R))+ea(za*P));Da=ea(ea(wa*za)+ea(ea(ya*ua)+ea(Aa*va)));Aa=Ca<Ba?Ca:Ba;if(((!((Aa<Da?Aa:Da)>ea(ea(N+ea(Z+xa))+ea(.00999999977)))?!(Ca<Z&Ba<Z&Da<Z):0)?(Da=ea(V+ea(ea(ea(B*X)+ea(D*fa))+ea(F*da))),Ba=ea(W+ea(ea(ea(H*X)+ea(J*fa))+ea(L*da))),g[s>>2]=ea(U+ea(ea(ea(v*X)+ea(x*fa))+ea(z*da))),g[n>>2]=Da,g[ja>>2]=Ba,Ba=ea(V+ea(ea(ea(B*$)+ea(D*R))+ea(F*P))),Da=ea(W+ea(ea(ea(H*$)+ea(J*R))+ea(L*P))),g[ka>>2]=ea(U+ea(ea(ea(v*$)+ea(x*R))+ea(z*P))),g[la>>2]=Ba,g[ma>>2]=Da,Da=ea(V+ea(ea(ea(B*ua)+ea(D*va))+ea(F*wa))),Ba=ea(W+ea(ea(ea(H*ua)+ea(J*va))+ea(L*wa))),g[na>>2]=ea(U+ea(ea(ea(v*ua)+ea(x*va))+ea(z*wa))),g[oa>>2]=Da,g[pa>>2]=Ba,g[t>>2]=ea(3402823469999999843913219.0e14),(UOa(s,ha,q,r,ga,t,m)|0)!=0):0)?(Ba=ea(g[t>>2]),Ba<=ga):0){if(Ba==ea(0.0)){Ea=18;break}g[ca>>2]=ea(Ba*j);c[qa>>2]=ta;Fa=Ba;Ga=1}else{Fa=ga;Ga=sa}ra=ra+1|0;if(ra>>>0>=a>>>0)break;else{ga=Fa;sa=Ga}}if((Ea|0)==18){b[k+12>>1]=6;g[ca>>2]=ea(0.0);c[qa>>2]=ta;Fa=ea(-ea(g[h>>2]));ga=ea(-ea(g[Y>>2]));j=ea(-ea(g[_>>2]));g[k+28>>2]=Fa;g[k+32>>2]=ga;g[k+36>>2]=j;u=1;i=o;return u|0}if(!Ga){u=0;i=o;return u|0}Ga=k+12|0;b[Ga>>1]=4;_=b[l>>1]|0;if(!(_&3))Ha=_;else{_=c[k+8>>2]|0;j=ea(g[d+(_*36|0)>>2]);ga=ea(g[d+(_*36|0)+4>>2]);Fa=ea(g[d+(_*36|0)+8>>2]);Z=ea(g[d+(_*36|0)+12>>2]);N=ea(g[d+(_*36|0)+16>>2]);Ba=ea(g[d+(_*36|0)+20>>2]);Da=ea(g[d+(_*36|0)+24>>2]);wa=ea(g[d+(_*36|0)+28>>2]);va=ea(g[d+(_*36|0)+32>>2]);ua=ea(V+ea(ea(ea(B*j)+ea(D*ga))+ea(F*Fa)));P=ea(W+ea(ea(ea(H*j)+ea(J*ga))+ea(L*Fa)));g[s>>2]=ea(U+ea(ea(ea(v*j)+ea(x*ga))+ea(z*Fa)));g[s+4>>2]=ua;g[s+8>>2]=P;P=ea(V+ea(ea(ea(B*Z)+ea(D*N))+ea(F*Ba)));ua=ea(W+ea(ea(ea(H*Z)+ea(J*N))+ea(L*Ba)));g[s+12>>2]=ea(U+ea(ea(ea(v*Z)+ea(x*N))+ea(z*Ba)));g[s+16>>2]=P;g[s+20>>2]=ua;ua=ea(V+ea(ea(ea(B*Da)+ea(D*wa))+ea(F*va)));F=ea(W+ea(ea(ea(H*Da)+ea(J*wa))+ea(L*va)));g[s+24>>2]=ea(U+ea(ea(ea(v*Da)+ea(x*wa))+ea(z*va)));g[s+28>>2]=ua;g[s+32>>2]=F;bPa(k,f,p,q,r,s);Ha=b[l>>1]|0}if(!(Ha&2))Ia=Ha;else{Ha=k+28|0;F=ea(g[Ha>>2]);ua=ea(F*F);s=k+32|0;va=ea(g[s>>2]);z=ea(ua+ea(va*va));r=k+36|0;ua=ea(g[r>>2]);wa=ea(T(ea(z+ea(ua*ua))));if(wa>ea(0.0)){z=ea(ea(1.0)/wa);wa=ea(F*z);g[Ha>>2]=wa;x=ea(va*z);g[s>>2]=x;Da=ea(ua*z);g[r>>2]=Da;Ja=wa;Ka=x;La=Da}else{Ja=F;Ka=va;La=ua}ua=ea(Ja*ea(g[q>>2]));va=ea(ua+ea(Ka*ea(g[aa>>2])));if(ea(va+ea(La*ea(g[ba>>2])))>ea(0.0)){va=ea(-Ja);ua=ea(-Ka);F=ea(-La);g[Ha>>2]=va;g[s>>2]=ua;g[r>>2]=F;Ma=va;Na=ua;Oa=F}else{Ma=Ja;Na=Ka;Oa=La}La=ea(Ma*ea(g[f>>2]));Ka=ea(Ma*ea(g[w>>2]));Ja=ea(Ma*ea(g[y>>2]));Ma=ea(Na*ea(g[A>>2]));F=ea(Na*ea(g[C>>2]));ua=ea(La+Ma);Ma=ea(Ka+F);F=ea(Ja+ea(Na*ea(g[E>>2])));Na=ea(Oa*ea(g[G>>2]));Ja=ea(Oa*ea(g[I>>2]));Ka=ea(Ma+Ja);Ja=ea(F+ea(Oa*ea(g[K>>2])));g[Ha>>2]=ea(ua+Na);g[s>>2]=Ka;g[r>>2]=Ja;b[Ga>>1]=e[Ga>>1]|0|2;Ia=b[l>>1]|0}if(!(Ia&1)){u=1;i=o;return u|0}Ia=k+16|0;Ja=ea(g[Ia>>2]);Ka=ea(Ja*ea(g[f>>2]));Na=ea(Ja*ea(g[w>>2]));ua=ea(Ja*ea(g[y>>2]));y=k+20|0;Ja=ea(g[y>>2]);Oa=ea(Ja*ea(g[A>>2]));F=ea(Ja*ea(g[C>>2]));Ma=ea(Ka+Oa);Oa=ea(Na+F);F=ea(ua+ea(Ja*ea(g[E>>2])));E=k+24|0;Ja=ea(g[E>>2]);ua=ea(Ja*ea(g[G>>2]));Na=ea(Ja*ea(g[I>>2]));Ka=ea(Ma+ua);ua=ea(Oa+Na);Na=ea(F+ea(Ja*ea(g[K>>2])));Ja=ea(Ka+ea(g[M>>2]));Ka=ea(ua+ea(g[O>>2]));ua=ea(Na+ea(g[Q>>2]));g[Ia>>2]=Ja;g[y>>2]=Ka;g[E>>2]=ua;b[Ga>>1]=e[Ga>>1]|0|1;u=1;i=o;return u|0}function b6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=Im,v=Im,w=Im;f=i;h=ea(g[b>>2]);j=ea(h-ea(g[a>>2]));h=ea(g[b+4>>2]);k=ea(h-ea(g[a+4>>2]));h=ea(g[b+8>>2]);l=ea(h-ea(g[a+8>>2]));g[c>>2]=j;a=c+4|0;g[a>>2]=k;b=c+8|0;g[b>>2]=l;h=ea(T(ea(ea(l*l)+ea(ea(j*j)+ea(k*k)))));if(h>ea(0.0)){m=ea(ea(1.0)/h);h=ea(j*m);g[c>>2]=h;n=ea(k*m);g[a>>2]=n;o=ea(l*m);g[b>>2]=o;p=n;q=o;r=h}else{p=k;q=l;r=j}if(!(ea(S(ea(p)))>ea(.999899983))){j=ea(p*ea(0.0));p=ea(q-j);l=ea(ea(r*ea(0.0))-ea(q*ea(0.0)));q=ea(j-r);g[d>>2]=p;s=d+4|0;g[s>>2]=l;t=d+8|0;g[t>>2]=q;r=ea(T(ea(ea(q*q)+ea(ea(p*p)+ea(l*l)))));if(r>ea(0.0)){j=ea(ea(1.0)/r);r=ea(p*j);g[d>>2]=r;k=ea(l*j);g[s>>2]=k;h=ea(q*j);g[t>>2]=h;u=h;v=k;w=r}else{u=q;v=l;w=p}}else{g[d>>2]=ea(1.0);g[d+4>>2]=ea(0.0);g[d+8>>2]=ea(0.0);u=ea(0.0);v=ea(0.0);w=ea(1.0)}p=ea(g[a>>2]);l=ea(u*p);q=ea(g[b>>2]);r=ea(l-ea(v*q));l=ea(w*q);q=ea(g[c>>2]);k=ea(l-ea(u*q));u=ea(ea(v*q)-ea(w*p));g[e>>2]=r;g[e+4>>2]=k;g[e+8>>2]=u;i=f;return}function c6a(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)fBb(a,b);c[a+4>>2]=b;i=d;return}function d6a(a,b,c,d,e,f,h){a=ea(a);b=ea(b);c=ea(c);d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=0;j=i;k=ea(ea(g[d>>2])*a);l=ea(k+ea(ea(g[d+4>>2])*b));k=ea(l+ea(ea(g[d+8>>2])*c));l=ea(ea(g[d+12>>2])*a);m=ea(l+ea(ea(g[d+16>>2])*b));l=ea(m+ea(ea(g[d+20>>2])*c));d=k>l;m=ea((d?l:k)-e);n=ea((d?k:l)+e);e=ea(ea(g[f+36>>2])*a);l=ea(e+ea(ea(g[f+40>>2])*b));e=ea(l+ea(ea(g[f+44>>2])*c));l=ea(ea(g[f>>2])*a);k=ea(l+ea(ea(g[f+4>>2])*b));l=ea(S(ea(k+ea(ea(g[f+8>>2])*c))));k=ea(l*ea(g[f+48>>2]));l=ea(ea(g[f+12>>2])*a);o=ea(l+ea(ea(g[f+16>>2])*b));l=ea(S(ea(o+ea(ea(g[f+20>>2])*c))));o=ea(k+ea(l*ea(g[f+52>>2])));l=ea(ea(g[f+24>>2])*a);a=ea(l+ea(ea(g[f+28>>2])*b));b=ea(S(ea(a+ea(ea(g[f+32>>2])*c))));c=ea(o+ea(b*ea(g[f+56>>2])));b=ea(e-c);o=ea(e+c);if(n<b|o<m){p=0;i=j;return p|0}c=ea(n-b);b=ea(o-m);g[h>>2]=c<b?c:b;p=1;i=j;return p|0}function e6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0;f=i;h=ea(g[c>>2]);j=c+4|0;k=ea(g[j>>2]);l=c+8|0;m=ea(g[l>>2]);n=ea(h*ea(g[d+36>>2]));o=ea(n+ea(k*ea(g[d+40>>2])));n=ea(o+ea(m*ea(g[d+44>>2])));o=ea(h*ea(g[d>>2]));p=ea(o+ea(k*ea(g[d+4>>2])));o=ea(S(ea(p+ea(m*ea(g[d+8>>2])))));p=ea(o*ea(g[d+48>>2]));o=ea(h*ea(g[d+12>>2]));q=ea(o+ea(k*ea(g[d+16>>2])));o=ea(S(ea(q+ea(m*ea(g[d+20>>2])))));q=ea(p+ea(o*ea(g[d+52>>2])));o=ea(h*ea(g[d+24>>2]));p=ea(o+ea(k*ea(g[d+28>>2])));o=ea(S(ea(p+ea(m*ea(g[d+32>>2])))));p=ea(q+ea(o*ea(g[d+56>>2])));o=ea(n-p);q=ea(n+p);p=ea(h*ea(g[e+36>>2]));n=ea(p+ea(k*ea(g[e+40>>2])));p=ea(n+ea(m*ea(g[e+44>>2])));n=ea(h*ea(g[e>>2]));r=ea(n+ea(k*ea(g[e+4>>2])));n=ea(S(ea(r+ea(m*ea(g[e+8>>2])))));r=ea(n*ea(g[e+48>>2]));n=ea(h*ea(g[e+12>>2]));s=ea(n+ea(k*ea(g[e+16>>2])));n=ea(S(ea(s+ea(m*ea(g[e+20>>2])))));s=ea(r+ea(n*ea(g[e+52>>2])));n=ea(h*ea(g[e+24>>2]));h=ea(n+ea(k*ea(g[e+28>>2])));k=ea(S(ea(h+ea(m*ea(g[e+32>>2])))));m=ea(s+ea(k*ea(g[e+56>>2])));k=ea(p-m);s=ea(p+m);if(q<k|s<o){t=0;i=f;return t|0}m=ea(q-k);k=ea(s-o);o=m<k?m:k;if(!(o<ea(g[b>>2]))){t=1;i=f;return t|0}g[b>>2]=o;g[a>>2]=ea(g[c>>2]);g[a+4>>2]=ea(g[j>>2]);g[a+8>>2]=ea(g[l>>2]);t=1;i=f;return t|0}function f6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=Im,x=Im,y=Im;e=i;if(!c){f=1;i=e;return f|0}else{h=ea(0.0);j=ea(0.0);k=ea(0.0);l=ea(0.0);m=ea(0.0);n=ea(0.0);o=0}do{p=ea(g[d+(o<<6)+12>>2]);q=ea(g[d+(o<<6)>>2]);r=ea(g[d+(o<<6)+4>>2]);s=ea(p*q);q=ea(p*r);r=ea(p*ea(g[d+(o<<6)+8>>2]));n=n<s?n:s;h=h<q?h:q;j=j<r?j:r;k=k>s?k:s;l=l>q?l:q;m=m>r?m:r;o=o+1|0}while((o|0)!=(c|0));c=n==ea(0.0);o=h==ea(0.0);d=j==ea(0.0);t=k==ea(0.0);u=l==ea(0.0);v=m==ea(0.0);r=ea(ea((c?k:n)+(t?n:k))*ea(.5));k=ea(ea((o?l:h)+(u?h:l))*ea(.5));l=ea(ea((d?m:j)+(v?j:m))*ea(.5));m=ea(ea(l*l)+ea(ea(k*k)+ea(r*r)));if(m<ea(1.00000001e-10)){f=0;i=e;return f|0}j=ea(T(ea(m)));if(m>ea(0.0)){m=ea(ea(1.0)/j);w=ea(r*m);x=ea(k*m);y=ea(l*m)}else{w=ea(0.0);x=ea(0.0);y=ea(0.0)}m=ea(-x);x=ea(-y);g[a>>2]=ea(-w);g[a+4>>2]=m;g[a+8>>2]=x;g[b>>2]=j;f=1;i=e;return f|0}function g6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?538464:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function h6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?538464:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function i6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?538224:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function j6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?538224:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function k6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?537976:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function l6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?537976:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function m6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?537720:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function n6a(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;d=i;e=ea(g[b>>2]);f=ea(e*ea(2.0));h=ea(g[b+12>>2]);j=ea(h*ea(2.0));k=ea(ea(e*f)+ea(ea(h*j)+ea(-1.0)));h=ea(g[b+8>>2]);e=ea(h*j);l=ea(g[b+4>>2]);m=ea(e+ea(f*l));e=ea(ea(f*h)-ea(j*l));l=ea(ea(g[b+16>>2])*k);j=ea(l+ea(m*ea(g[b+20>>2])));l=ea(j+ea(e*ea(g[b+24>>2])));j=ea(-l);h=ea(S(ea(k)));f=ea(S(ea(m)));n=ea(S(ea(e)));b=f<ea(9.99999997e-07);o=n<ea(9.99999997e-07);do if(h>ea(.999998986)&b&o)if(k>ea(0.0)){p=ea(-8507058669999999534545717.0e13);q=ea(-8507058669999999534545717.0e13);r=ea(-8507058669999999534545717.0e13);s=l;t=ea(8507058669999999534545717.0e13);u=ea(8507058669999999534545717.0e13)}else{p=j;q=ea(-8507058669999999534545717.0e13);r=ea(-8507058669999999534545717.0e13);s=ea(8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);u=ea(8507058669999999534545717.0e13)}else{v=h<ea(9.99999997e-07);if(v&f>ea(.999998986)&o){if(m>ea(0.0)){p=ea(-8507058669999999534545717.0e13);q=ea(-8507058669999999534545717.0e13);r=ea(-8507058669999999534545717.0e13);s=ea(8507058669999999534545717.0e13);t=l;u=ea(8507058669999999534545717.0e13);break}p=ea(-8507058669999999534545717.0e13);q=j;r=ea(-8507058669999999534545717.0e13);s=ea(8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);u=ea(8507058669999999534545717.0e13);break}if(v&b&n>ea(.999998986))if(e>ea(0.0)){p=ea(-8507058669999999534545717.0e13);q=ea(-8507058669999999534545717.0e13);r=ea(-8507058669999999534545717.0e13);s=ea(8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);u=l}else{p=ea(-8507058669999999534545717.0e13);q=ea(-8507058669999999534545717.0e13);r=j;s=ea(8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);u=ea(8507058669999999534545717.0e13)}else{p=ea(-8507058669999999534545717.0e13);q=ea(-8507058669999999534545717.0e13);r=ea(-8507058669999999534545717.0e13);s=ea(8507058669999999534545717.0e13);t=ea(8507058669999999534545717.0e13);u=ea(8507058669999999534545717.0e13)}}while(0);j=ea(q-c);q=ea(r-c);g[a>>2]=ea(p-c);g[a+4>>2]=j;g[a+8>>2]=q;q=ea(t+c);t=ea(u+c);g[a+12>>2]=ea(s+c);g[a+16>>2]=q;g[a+20>>2]=t;i=d;return}function o6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=Im,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im;f=i;h=ea(g[c>>2]);if(h==ea(1.0)){j=ea(g[c+4>>2]);if(j==ea(1.0)?ea(g[c+8>>2])==ea(1.0):0){k=ea(g[a>>2]);l=ea(k+k);m=ea(g[a+4>>2]);n=ea(m+m);o=ea(g[a+8>>2]);p=ea(o+o);q=ea(g[a+12>>2]);r=ea(l*q);s=ea(n*q);t=ea(q*p);q=ea(k*n);u=ea(k*p);v=ea(m*n);n=ea(m*p);m=ea(o*p);p=ea(ea(ea(1.0)-v)-m);o=ea(q+t);w=ea(u-s);x=ea(q-t);t=ea(ea(1.0)-ea(k*l));l=ea(t-m);m=ea(n+r);k=ea(u+s);s=ea(n-r);r=ea(t-v);v=ea(g[a+16>>2]);t=ea(g[a+20>>2]);n=ea(g[a+24>>2]);u=ea(g[b>>2]);y=b+12|0;q=ea(u+ea(g[y>>2]));z=b+4|0;u=ea(g[z>>2]);A=b+16|0;B=ea(u+ea(g[A>>2]));C=b+8|0;u=ea(g[C>>2]);D=b+20|0;E=ea(q*ea(.5));q=ea(B*ea(.5));B=ea(ea(u+ea(g[D>>2]))*ea(.5));u=ea(t+ea(ea(ea(o*E)+ea(l*q))+ea(s*B)));t=ea(n+ea(ea(ea(w*E)+ea(m*q))+ea(r*B)));g[d>>2]=ea(v+ea(ea(ea(p*E)+ea(x*q))+ea(k*B)));g[d+4>>2]=u;g[d+8>>2]=t;t=ea(g[y>>2]);u=ea(t-ea(g[b>>2]));t=ea(g[A>>2]);B=ea(t-ea(g[z>>2]));t=ea(g[D>>2]);q=ea(u*ea(.5));u=ea(B*ea(.5));B=ea(ea(t-ea(g[C>>2]))*ea(.5));t=ea(o*q);o=ea(w*q);w=ea(l*u);l=ea(m*u);m=ea(s*B);s=ea(r*B);g[e>>2]=ea(ea(ea(S(ea(p*q)))+ea(S(ea(x*u))))+ea(S(ea(k*B))));g[e+4>>2]=ea(ea(ea(S(ea(t)))+ea(S(ea(w))))+ea(S(ea(m))));g[e+8>>2]=ea(ea(ea(S(ea(o)))+ea(S(ea(l))))+ea(S(ea(s))));i=f;return}else F=j}else F=ea(g[c+4>>2]);j=ea(g[a>>2]);s=ea(g[a+4>>2]);l=ea(g[a+8>>2]);o=ea(g[a+12>>2]);m=ea(j+j);w=ea(s+s);t=ea(l+l);B=ea(s*w);k=ea(l*t);u=ea(m*s);s=ea(m*l);x=ea(m*o);q=ea(w*l);l=ea(w*o);w=ea(t*o);o=ea(ea(ea(1.0)-B)-k);t=ea(u+w);p=ea(s-l);r=ea(u-w);w=ea(ea(1.0)-ea(j*m));m=ea(w-k);k=ea(q+x);j=ea(s+l);l=ea(q-x);x=ea(w-B);B=ea(g[c+12>>2]);w=ea(g[c+16>>2]);q=ea(g[c+20>>2]);s=ea(g[c+24>>2]);u=ea(B+B);E=ea(w+w);v=ea(q+q);n=ea(w*E);G=ea(q*v);H=ea(u*w);w=ea(u*q);I=ea(u*s);J=ea(E*q);q=ea(E*s);E=ea(v*s);s=ea(ea(ea(1.0)-n)-G);v=ea(H+E);K=ea(w-q);L=ea(H-E);E=ea(ea(1.0)-ea(B*u));u=ea(E-G);G=ea(J+I);B=ea(w+q);q=ea(J-I);I=ea(E-n);n=ea(h*s);E=ea(h*L);J=ea(h*B);h=ea(F*v);w=ea(F*u);H=ea(F*q);F=ea(g[c+8>>2]);M=ea(F*K);N=ea(F*G);O=ea(I*F);F=ea(ea(K*M)+ea(ea(s*n)+ea(v*h)));P=ea(ea(K*N)+ea(ea(s*E)+ea(v*w)));Q=ea(ea(K*O)+ea(ea(s*J)+ea(v*H)));v=ea(ea(G*M)+ea(ea(L*n)+ea(u*h)));s=ea(ea(G*N)+ea(ea(L*E)+ea(u*w)));K=ea(ea(G*O)+ea(ea(L*J)+ea(u*H)));u=ea(ea(I*M)+ea(ea(B*n)+ea(q*h)));h=ea(ea(I*N)+ea(ea(B*E)+ea(q*w)));w=ea(ea(I*O)+ea(ea(B*J)+ea(q*H)));H=ea(ea(j*Q)+ea(ea(o*F)+ea(r*P)));q=ea(ea(l*Q)+ea(ea(t*F)+ea(m*P)));J=ea(ea(x*Q)+ea(ea(p*F)+ea(k*P)));P=ea(ea(j*K)+ea(ea(o*v)+ea(r*s)));F=ea(ea(l*K)+ea(ea(t*v)+ea(m*s)));Q=ea(ea(x*K)+ea(ea(p*v)+ea(k*s)));s=ea(ea(j*w)+ea(ea(o*u)+ea(r*h)));r=ea(ea(l*w)+ea(ea(t*u)+ea(m*h)));m=ea(ea(x*w)+ea(ea(p*u)+ea(k*h)));h=ea(g[a+16>>2]);k=ea(g[a+20>>2]);u=ea(g[a+24>>2]);p=ea(g[b>>2]);a=b+12|0;w=ea(p+ea(g[a>>2]));c=b+4|0;p=ea(g[c>>2]);C=b+16|0;x=ea(p+ea(g[C>>2]));D=b+8|0;p=ea(g[D>>2]);z=b+20|0;t=ea(w*ea(.5));w=ea(x*ea(.5));x=ea(ea(p+ea(g[z>>2]))*ea(.5));p=ea(k+ea(ea(ea(t*q)+ea(F*w))+ea(r*x)));k=ea(u+ea(ea(ea(t*J)+ea(Q*w))+ea(m*x)));g[d>>2]=ea(h+ea(ea(ea(t*H)+ea(P*w))+ea(s*x)));g[d+4>>2]=p;g[d+8>>2]=k;k=ea(g[a>>2]);p=ea(k-ea(g[b>>2]));k=ea(g[C>>2]);x=ea(k-ea(g[c>>2]));k=ea(g[z>>2]);w=ea(p*ea(.5));p=ea(x*ea(.5));x=ea(ea(k-ea(g[D>>2]))*ea(.5));k=ea(q*w);q=ea(J*w);J=ea(F*p);F=ea(Q*p);Q=ea(r*x);r=ea(m*x);g[e>>2]=ea(ea(ea(S(ea(H*w)))+ea(S(ea(P*p))))+ea(S(ea(s*x))));g[e+4>>2]=ea(ea(ea(S(ea(k)))+ea(S(ea(J))))+ea(S(ea(Q))));g[e+8>>2]=ea(ea(ea(S(ea(q)))+ea(S(ea(F))))+ea(S(ea(r))));i=f;return}function p6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function q6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function r6a(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=ea(g[b+12>>2]);e=ea(g[b+16>>2]);f=ea(g[b+20>>2]);h=ea(g[b+24>>2]);i=ea(d+d);j=ea(e+e);k=ea(f+f);l=ea(e*j);m=ea(f*k);n=ea(i*e);e=ea(i*f);o=ea(i*h);p=ea(j*f);f=ea(j*h);j=ea(k*h);h=ea(ea(ea(1.0)-l)-m);k=ea(n+j);q=ea(e-f);r=ea(n-j);j=ea(ea(1.0)-ea(d*i));i=ea(j-m);m=ea(p+o);d=ea(e+f);f=ea(p-o);o=ea(j-l);l=ea(g[b>>2]);j=ea(l*h);p=ea(l*r);e=ea(l*d);l=ea(g[b+4>>2]);n=ea(k*l);s=ea(i*l);t=ea(f*l);l=ea(g[b+8>>2]);u=ea(q*l);v=ea(m*l);w=ea(o*l);l=ea(ea(ea(h*j)+ea(k*n))+ea(q*u));x=ea(ea(ea(h*p)+ea(k*s))+ea(q*v));y=ea(ea(ea(h*e)+ea(k*t))+ea(q*w));q=ea(ea(ea(r*j)+ea(i*n))+ea(m*u));k=ea(ea(ea(r*p)+ea(i*s))+ea(m*v));h=ea(ea(ea(r*e)+ea(i*t))+ea(m*w));m=ea(ea(ea(d*j)+ea(f*n))+ea(o*u));u=ea(ea(ea(d*p)+ea(f*s))+ea(o*v));v=ea(ea(ea(d*e)+ea(f*t))+ea(o*w));w=ea(g[c>>2]);o=ea(g[c+4>>2]);t=ea(g[c+8>>2]);f=ea(g[c+12>>2]);e=ea(w+w);d=ea(o+o);s=ea(t+t);p=ea(o*d);n=ea(t*s);j=ea(e*o);o=ea(e*t);i=ea(e*f);r=ea(d*t);t=ea(d*f);d=ea(s*f);f=ea(ea(ea(1.0)-p)-n);s=ea(j+d);z=ea(o-t);A=ea(j-d);d=ea(ea(1.0)-ea(w*e));e=ea(d-n);n=ea(r+i);w=ea(o+t);t=ea(r-i);i=ea(d-p);p=ea(ea(m*z)+ea(ea(l*f)+ea(q*s)));d=ea(ea(u*z)+ea(ea(x*f)+ea(k*s)));r=ea(ea(v*z)+ea(ea(y*f)+ea(h*s)));s=ea(ea(m*n)+ea(ea(l*A)+ea(q*e)));f=ea(ea(u*n)+ea(ea(x*A)+ea(k*e)));z=ea(ea(v*n)+ea(ea(y*A)+ea(h*e)));e=ea(ea(m*i)+ea(ea(l*w)+ea(q*t)));A=ea(ea(u*i)+ea(ea(x*w)+ea(k*t)));n=ea(ea(v*i)+ea(ea(y*w)+ea(h*t)));t=ea(g[c+16>>2]);w=ea(l*t);l=ea(x*t);x=ea(y*t);t=ea(g[c+20>>2]);y=ea(w+ea(q*t));q=ea(l+ea(k*t));k=ea(x+ea(h*t));t=ea(g[c+24>>2]);h=ea(y+ea(m*t));m=ea(q+ea(u*t));u=ea(k+ea(v*t));g[a>>2]=p;g[a+4>>2]=d;g[a+8>>2]=r;g[a+12>>2]=s;g[a+16>>2]=f;g[a+20>>2]=z;g[a+24>>2]=e;g[a+28>>2]=A;g[a+32>>2]=n;g[a+36>>2]=h;g[a+40>>2]=m;g[a+44>>2]=u;return}function s6a(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=0,C=Im,D=Im,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=Im,Ia=0,Ja=Im,Ka=Im,La=0,Ma=Im,Na=0,Oa=Im;j=i;i=i+160|0;k=j+120|0;l=j+92|0;m=j+56|0;n=j+52|0;o=j+36|0;p=j+80|0;q=j+104|0;r=j+144|0;s=j+60|0;t=j+24|0;u=j+12|0;v=j+64|0;w=j;x=j+48|0;y=j+76|0;zRa(d,k);z=ea(g[f>>2]);A=ea(z-ea(g[e>>2]));z=ea(g[f+4>>2]);B=e+4|0;C=ea(z-ea(g[B>>2]));z=ea(g[f+8>>2]);f=e+8|0;D=ea(z-ea(g[f>>2]));g[l>>2]=A;E=l+4|0;g[E>>2]=C;F=l+8|0;g[F>>2]=D;if(!(RPa(k,k+12|0,e,l,ea(1.0),m,n)|0)){i=j;return}D=ea(g[m>>2]);C=ea(g[l>>2]);A=ea(D*C);z=ea(g[E>>2]);G=ea(D*z);H=ea(g[F>>2]);I=ea(D*H);D=ea(g[e>>2]);J=ea(A+D);A=ea(g[B>>2]);K=ea(G+A);G=ea(g[f>>2]);L=ea(I+G);I=ea(g[n>>2]);M=ea(D+ea(C*I));C=ea(A+ea(z*I));z=ea(G+ea(H*I));n=c[d+16>>2]|0;I=ea(g[n+12>>2]);H=ea(g[n+16>>2]);G=ea(g[n+8>>2]);n=c[d+12>>2]|0;f=c[n+20>>2]|0;B=c[n+16>>2]|0;A=ea(g[d>>2]);D=ea(ea(B+-1|0)*ea(.99999988));N=ea(ea(f+-1|0)*ea(.99999988));O=ea(J*A);e=O>ea(1.00000001e-07);P=e?O:ea(1.00000001e-07);Q=ea(D+ea(0.0));D=P<Q?P:Q;P=ea(g[d+8>>2]);U=ea(L*P);d=U>ea(1.00000001e-07);V=d?U:ea(1.00000001e-07);W=ea(N+ea(0.0));N=V<W?V:W;V=ea(M*A);d=V>ea(1.00000001e-07);X=d?V:ea(1.00000001e-07);V=ea(z*P);d=V>ea(1.00000001e-07);Y=d?V:ea(1.00000001e-07);V=ea((X<Q?X:Q)-D);Q=ea((Y<W?Y:W)-N);W=ea(C-K);d=V>=ea(0.0);C=d?ea(1.0):ea(-1.0);d=Q>=ea(0.0);Y=d?ea(1.0):ea(-1.0);d=~~C;e=~~Y;if(ea(S(ea(V)))<ea(1.00000001e-10))Z=ea(C*ea(1.00000001e-10));else Z=V;if(ea(S(ea(Q)))<ea(1.00000001e-10))_=ea(Y*ea(1.00000001e-10));else _=Q;g[o>>2]=O;g[o+4>>2]=K;g[o+8>>2]=U;U=ea(ea(M-J)*A);A=ea(ea(z-L)*P);P=ea(T(ea(ea(ea(W*W)+ea(U*U))+ea(A*A))));g[p>>2]=U;F=p+4|0;g[F>>2]=W;E=p+8|0;g[E>>2]=A;if(P>ea(9.99999968e-21)){L=ea(ea(1.0)/P);g[p>>2]=ea(L*U);g[F>>2]=ea(L*W);g[E>>2]=ea(L*A)}l=Z>ea(0.0);if(l)$=ea(R(ea(D)));else $=ea(ca(ea(D)));m=~~$;k=_>ea(0.0);if(k)aa=ea(R(ea(N)));else aa=ea(ca(ea(N)));ba=~~aa;if(l){aa=ea(ca(ea(D)));if(aa==D)fa=ea(aa+ea(1.0));else fa=aa}else{aa=ea(R(ea(D)));if(aa==D)fa=ea(aa+ea(-1.0));else fa=aa}if(k){aa=ea(ca(ea(N)));if(aa==N)ga=ea(aa+ea(1.0));else ga=aa}else{aa=ea(R(ea(N)));if(aa==N)ga=ea(aa+ea(-1.0));else ga=aa}aa=ea(ea(1.0)/ea(S(ea(Z))));$=ea(ea(1.0)/ea(S(ea(_))));k=1-d|0;l=(1-e|0)/2|0;ha=n+36|0;n=q+4|0;ia=q+8|0;ja=q+12|0;A=ea(B|0);L=ea(f|0);B=q+(l+k<<2)|0;ka=q+(k+1-l<<2)|0;la=q+(2-k+l<<2)|0;ma=q+(3-k-l<<2)|0;l=t+4|0;k=t+8|0;na=u+4|0;oa=u+8|0;pa=v+4|0;qa=v+8|0;ra=w+4|0;sa=w+8|0;U=ea(P+ea(.0000999999974));P=ea(K+ea(W*ea(0.0)));z=ea(ea(fa-D)/Z);Z=ea(ea(ga-N)/_);ta=m;_=ea(m|0);m=ba;ga=ea(ba|0);while(1){ba=z<Z;fa=ba?z:Z;J=P;P=ea(K+ea(W*fa));ua=(da(ta,f)|0)+m|0;va=ta+d|0;wa=(da(va,f)|0)+m|0;xa=c[ha>>2]|0;M=ea(G*ea(b[xa+(ua<<2)>>1]|0));g[q>>2]=M;O=ea(G*ea(b[xa+(ua+e<<2)>>1]|0));g[n>>2]=O;Q=ea(G*ea(b[xa+(wa<<2)>>1]|0));g[ia>>2]=Q;V=ea(G*ea(b[xa+(wa+e<<2)>>1]|0));g[ja>>2]=V;X=M<O?M:O;ya=Q<V?Q:V;za=M>O?M:O;O=Q>V?Q:V;if(!(ea((J<P?J:P)+ea(-.0000999999974))>(za>O?za:O))?!(ea((J>P?J:P)+ea(.0000999999974))<(X<ya?X:ya)):0){ya=ea(g[B>>2]);X=ea(g[ka>>2]);J=ea(g[la>>2]);O=ea(g[ma>>2]);za=ea(C+_);V=_<za?_:za;Q=_>za?_:za;za=ea(Y+ga);M=ga<za?ga:za;Aa=ga>za?ga:za;g[t>>2]=V;g[l>>2]=ya;g[k>>2]=M;g[u>>2]=V;g[na>>2]=X;g[oa>>2]=Aa;g[v>>2]=Q;g[pa>>2]=J;g[qa>>2]=M;g[w>>2]=Q;g[ra>>2]=O;g[sa>>2]=Aa;wa=m+e|0;Ba=(da((va|0)<(ta|0)?va:ta,f)|0)+((wa|0)<(m|0)?wa:m)|0;wa=(a[xa+(Ba<<2)+2>>0]|0)<0;xa=wa?t:u;ua=wa?u:w;Ca=wa?w:v;g[x>>2]=ea(3402823469999999843913219.0e14);g[y>>2]=ea(3402823469999999843913219.0e14);Da=WPa(o,p,wa?v:t,xa,Ca,x,r,s,ea(.0000999999974))|0;Aa=ea(g[x>>2]);if(!(!(Aa<=U)|Da&Aa>=ea(-.0000999999974)^1)?(a[(c[ha>>2]|0)+(Ba<<2)+2>>0]&127)!=127:0)Ea=1;else{g[x>>2]=ea(3402823469999999843913219.0e14);Ea=0}Da=WPa(o,p,ua,Ca,xa,y,r,s,ea(.0000999999974))|0;Aa=ea(g[y>>2]);if(!(!(Aa<=U)|Da&Aa>=ea(-.0000999999974)^1)?(a[(c[ha>>2]|0)+(Ba<<2)+3>>0]&127)!=127:0){Fa=Aa;Ga=1}else{g[y>>2]=ea(3402823469999999843913219.0e14);Fa=ea(3402823469999999843913219.0e14);Ga=0}if(Ea?(Ha=ea(g[x>>2]),Ha<=Fa):0){Ia=35;break}if(!(Ga^1|!(Fa<=ea(g[x>>2])))){Ia=37;break}}if(ba){Aa=ea(va+d|0);if(!(!(Aa<ea(0.0))&!(Aa>=A))){Ia=44;break}Ja=ea(aa+z);Ka=Z;La=va;Ma=ea(C+_);Na=m;Oa=ga}else{va=m+e|0;Aa=ea(va+e|0);if(!(!(Aa<ea(0.0))&!(Aa>=L))){Ia=44;break}Ja=z;Ka=ea($+Z);La=ta;Ma=_;Na=va;Oa=ea(Y+ga)}if(!(fa<ea(.999899983))){Ia=44;break}else{z=Ja;Z=Ka;ta=La;_=Ma;m=Na;ga=Oa}}if((Ia|0)==35){Oa=ea(I*ea(D+ea(Ha*ea(g[p>>2]))));ga=ea(K+ea(Ha*ea(g[F>>2])));Ma=ea(H*ea(N+ea(Ha*ea(g[E>>2]))));g[h>>2]=Oa;g[h+4>>2]=ga;g[h+8>>2]=Ma;c[h+12>>2]=Ba<<1;a[h+16>>0]=1;i=j;return}else if((Ia|0)==37){Ma=ea(I*ea(D+ea(Fa*ea(g[p>>2]))));D=ea(K+ea(Fa*ea(g[F>>2])));K=ea(H*ea(N+ea(Fa*ea(g[E>>2]))));g[h>>2]=Ma;g[h+4>>2]=D;g[h+8>>2]=K;c[h+12>>2]=Ba<<1|1;a[h+16>>0]=1;i=j;return}else if((Ia|0)==44){i=j;return}}function t6a(d,e,f,h,j,k,l){d=d|0;e=e|0;f=ea(f);h=ea(h);j=ea(j);k=ea(k);l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;m=i;i=i+16|0;n=m+4|0;o=m;p=xRa(e,f,h,n,o)|0;h=ea(g[n>>2]);f=ea(g[o>>2]);o=c[e+36>>2]|0;do if((a[o+(p<<2)+2>>0]|0)<0){n=b[o+(p<<2)>>1]|0;q=(c[e+20>>2]|0)+p|0;r=b[o+(q+1<<2)>>1]|0;if(!(f>=h)){s=b[o+(q<<2)>>1]|0;t=s-r|0;u=n-s|0;break}else{s=b[o+(p+1<<2)>>1]|0;t=n-s|0;u=s-r|0;break}}else{r=b[o+(p+1<<2)>>1]|0;s=(c[e+20>>2]|0)+p|0;n=b[o+(s<<2)>>1]|0;if(!(ea(h+f)<=ea(1.0))){q=b[o+(s+1<<2)>>1]|0;t=n-q|0;u=r-q|0;break}else{q=b[o+(p<<2)>>1]|0;t=q-r|0;u=q-n|0;break}}while(0);f=ea(ea(u|0)*j);j=ea(ea(t|0)*l);if(!(ea(g[e+40>>2])<=ea(0.0))){l=ea(-k);h=ea(-j);g[d>>2]=ea(-f);g[d+4>>2]=l;g[d+8>>2]=h;i=m;return}else{g[d>>2]=f;g[d+4>>2]=k;g[d+8>>2]=j;i=m;return}}function u6a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+160|0;h=f+88|0;j=f+24|0;k=f+12|0;l=f;m=c[a+36>>2]|0;n=a+4|0;if(ea(g[n>>2])==ea(1.0)?ea(g[a+8>>2])==ea(1.0):0)o=ea(g[a+12>>2])==ea(1.0);else o=0;g[h>>2]=ea(1.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);g[h+12>>2]=ea(0.0);g[h+16>>2]=ea(1.0);g[h+20>>2]=ea(0.0);g[h+24>>2]=ea(0.0);g[h+28>>2]=ea(0.0);g[h+32>>2]=ea(1.0);g[h+36>>2]=ea(1.0);g[h+40>>2]=ea(0.0);g[h+44>>2]=ea(0.0);g[h+48>>2]=ea(0.0);g[h+52>>2]=ea(1.0);g[h+56>>2]=ea(0.0);g[h+60>>2]=ea(0.0);g[h+64>>2]=ea(0.0);g[h+68>>2]=ea(1.0);if(!o)J0a(h,n,a+16|0);AOa(j,d,b,n);c[k>>2]=c[m+32>>2];c[k+4>>2]=m+48;g[k+8>>2]=ea(g[m+36>>2]);c[l+4>>2]=2;c[l>>2]=539296;c[l+8>>2]=e;vQa(j,1,k,l,1);i=f;return}function v6a(b,d,f,h,j,k){b=b|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=0;l=i;m=c[b+28>>2]|0;if(!(a[b+172>>0]&2)){n=c[m+(f*12|0)>>2]|0;o=c[m+(f*12|0)+4>>2]|0;p=c[m+(f*12|0)+8>>2]|0}else{n=e[m+(f*6|0)>>1]|0;o=e[m+(f*6|0)+2>>1]|0;p=e[m+(f*6|0)+4>>1]|0}m=c[b+24>>2]|0;q=ea(g[m+(n*12|0)>>2]);r=ea(q*ea(g[h>>2]));s=h+4|0;t=ea(q*ea(g[s>>2]));u=h+8|0;v=ea(q*ea(g[u>>2]));q=ea(g[m+(n*12|0)+4>>2]);w=h+12|0;x=ea(q*ea(g[w>>2]));y=h+16|0;z=ea(q*ea(g[y>>2]));A=h+20|0;B=ea(r+x);x=ea(t+z);z=ea(v+ea(q*ea(g[A>>2])));q=ea(g[m+(n*12|0)+8>>2]);C=h+24|0;v=ea(q*ea(g[C>>2]));D=h+28|0;t=ea(q*ea(g[D>>2]));E=h+32|0;r=ea(B+v);v=ea(x+t);t=ea(z+ea(q*ea(g[E>>2])));F=h+36|0;q=ea(r+ea(g[F>>2]));G=h+40|0;r=ea(v+ea(g[G>>2]));H=h+44|0;v=ea(t+ea(g[H>>2]));g[d>>2]=q;g[d+4>>2]=r;g[d+8>>2]=v;v=ea(g[m+(o*12|0)>>2]);r=ea(v*ea(g[h>>2]));q=ea(v*ea(g[s>>2]));t=ea(v*ea(g[u>>2]));v=ea(g[m+(o*12|0)+4>>2]);z=ea(v*ea(g[w>>2]));x=ea(v*ea(g[y>>2]));B=ea(r+z);z=ea(q+x);x=ea(t+ea(v*ea(g[A>>2])));v=ea(g[m+(o*12|0)+8>>2]);t=ea(v*ea(g[C>>2]));q=ea(v*ea(g[D>>2]));r=ea(B+t);t=ea(z+q);q=ea(x+ea(v*ea(g[E>>2])));v=ea(r+ea(g[F>>2]));r=ea(t+ea(g[G>>2]));t=ea(q+ea(g[H>>2]));g[d+12>>2]=v;g[d+16>>2]=r;g[d+20>>2]=t;t=ea(g[m+(p*12|0)>>2]);r=ea(t*ea(g[h>>2]));v=ea(t*ea(g[s>>2]));q=ea(t*ea(g[u>>2]));t=ea(g[m+(p*12|0)+4>>2]);x=ea(t*ea(g[w>>2]));z=ea(t*ea(g[y>>2]));B=ea(r+x);x=ea(v+z);z=ea(q+ea(t*ea(g[A>>2])));t=ea(g[m+(p*12|0)+8>>2]);q=ea(t*ea(g[C>>2]));v=ea(t*ea(g[D>>2]));r=ea(B+q);q=ea(x+v);v=ea(z+ea(t*ea(g[E>>2])));t=ea(r+ea(g[F>>2]));r=ea(q+ea(g[G>>2]));q=ea(v+ea(g[H>>2]));g[d+24>>2]=t;g[d+28>>2]=r;g[d+32>>2]=q;if(j){c[j>>2]=n;c[j+4>>2]=o;c[j+8>>2]=p}if(!k){i=l;return}p=c[b+184>>2]|0;if(!p){c[k>>2]=-1;c[k+4>>2]=-1;c[k+8>>2]=-1;i=l;return}else{b=f*3|0;c[k>>2]=c[p+(b<<2)>>2];c[k+4>>2]=c[p+(b+1<<2)>>2];c[k+8>>2]=c[p+(b+2<<2)>>2];i=l;return}}function w6a(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=ea(j);k=ea(k);l=ea(l);m=ea(m);var n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0;n=i;i=i+80|0;o=n;p=ea(f-ea(k*ea(.00999999977)));f=ea(h-ea(l*ea(.00999999977)));h=ea(j-ea(m*ea(.00999999977)));j=ea(p-ea(g[e+16>>2]));p=ea(f-ea(g[e+20>>2]));f=ea(j*ea(2.0));j=ea(p*ea(2.0));p=ea(ea(h-ea(g[e+24>>2]))*ea(2.0));h=ea(g[e+12>>2]);q=ea(ea(h*h)+ea(-.5));r=ea(g[e>>2]);s=ea(f*r);t=ea(g[e+4>>2]);u=ea(s+ea(j*t));s=ea(g[e+8>>2]);v=ea(u+ea(p*s));u=ea(ea(r*v)+ea(ea(f*q)-ea(h*ea(ea(p*t)-ea(j*s)))));w=ea(ea(t*v)+ea(ea(j*q)-ea(h*ea(ea(f*s)-ea(p*r)))));x=ea(ea(ea(p*q)-ea(h*ea(ea(j*r)-ea(f*t))))+ea(s*v));v=ea(k*ea(2.0));k=ea(l*ea(2.0));l=ea(m*ea(2.0));m=ea(ea(ea(v*r)+ea(k*t))+ea(l*s));f=ea(ea(r*m)+ea(ea(v*q)-ea(h*ea(ea(l*t)-ea(k*s)))));j=ea(ea(t*m)+ea(ea(k*q)-ea(h*ea(ea(v*s)-ea(l*r)))));p=ea(ea(ea(l*q)-ea(h*ea(ea(k*r)-ea(v*t))))+ea(s*m));J0a(o,a+4|0,a+16|0);a=c[d>>2]|0;if(!a){y=0;i=n;return y|0}d=c[b+40>>2]|0;m=ea(g[o+36>>2]);s=ea(g[o+40>>2]);t=ea(g[o+44>>2]);v=ea(g[o+48>>2]);r=ea(g[o+52>>2]);k=ea(g[o+56>>2]);h=ea(g[o+60>>2]);q=ea(g[o+64>>2]);l=ea(g[o+68>>2]);o=0;z=ea(3402823469999999843913219.0e14);b=0;while(1){A=ea(g[d+(o*20|0)+12>>2]);B=ea(g[d+(o*20|0)>>2]);C=ea(m*B);D=ea(g[d+(o*20|0)+4>>2]);E=ea(C+ea(s*D));C=ea(g[d+(o*20|0)+8>>2]);F=ea(E+ea(t*C));E=ea(ea(ea(B*v)+ea(D*r))+ea(C*k));G=ea(ea(ea(B*h)+ea(D*q))+ea(C*l));C=ea(ea(1.0)/ea(T(ea(ea(ea(F*F)+ea(E*E))+ea(G*G)))));D=ea(F*C);F=ea(E*C);E=ea(G*C);G=ea(ea(A*C)+ea(ea(x*E)+ea(ea(u*D)+ea(w*F))));if(!(G<ea(0.0))?(C=ea(G+ea(ea(ea(p*E)+ea(ea(f*D)+ea(j*F)))*ea(.00999999977))),C<z):0){H=C;I=o}else{H=z;I=b}o=o+1|0;if(o>>>0>=a>>>0){y=I;break}else{z=H;b=I}}i=n;return y|0}function x6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=0,q=Im,r=0,s=Im,t=0,u=0,v=Im,w=0,x=Im,y=0,z=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e;h=ea(g[c>>2]);j=ea(h*ea(g[d>>2]));k=d+4|0;l=ea(h*ea(g[k>>2]));m=d+8|0;n=ea(h*ea(g[m>>2]));o=a+36|0;h=ea(j*ea(g[o>>2]));p=a+40|0;q=ea(j*ea(g[p>>2]));r=a+44|0;s=ea(j*ea(g[r>>2]));t=a+48|0;j=ea(l*ea(g[t>>2]));u=a+52|0;v=ea(l*ea(g[u>>2]));w=a+56|0;x=ea(h+j);j=ea(q+v);v=ea(s+ea(l*ea(g[w>>2])));y=a+60|0;l=ea(n*ea(g[y>>2]));z=a+64|0;s=ea(n*ea(g[z>>2]));A=a+68|0;q=ea(j+s);s=ea(v+ea(n*ea(g[A>>2])));g[d>>2]=ea(x+l);g[k>>2]=q;g[m>>2]=s;m=c+4|0;s=ea(g[m>>2]);k=d+12|0;q=ea(s*ea(g[k>>2]));a=d+16|0;l=ea(s*ea(g[a>>2]));B=d+20|0;x=ea(s*ea(g[B>>2]));s=ea(q*ea(g[o>>2]));n=ea(q*ea(g[p>>2]));v=ea(q*ea(g[r>>2]));q=ea(l*ea(g[t>>2]));j=ea(l*ea(g[u>>2]));h=ea(s+q);q=ea(n+j);j=ea(v+ea(l*ea(g[w>>2])));l=ea(x*ea(g[y>>2]));v=ea(x*ea(g[z>>2]));n=ea(q+v);v=ea(j+ea(x*ea(g[A>>2])));g[k>>2]=ea(h+l);g[a>>2]=n;g[B>>2]=v;B=c+8|0;v=ea(g[B>>2]);a=d+24|0;n=ea(v*ea(g[a>>2]));k=d+28|0;l=ea(v*ea(g[k>>2]));C=d+32|0;h=ea(v*ea(g[C>>2]));v=ea(n*ea(g[o>>2]));x=ea(n*ea(g[p>>2]));j=ea(n*ea(g[r>>2]));n=ea(l*ea(g[t>>2]));q=ea(l*ea(g[u>>2]));s=ea(v+n);n=ea(x+q);q=ea(j+ea(l*ea(g[w>>2])));l=ea(h*ea(g[y>>2]));j=ea(h*ea(g[z>>2]));x=ea(n+j);j=ea(q+ea(h*ea(g[A>>2])));g[a>>2]=ea(s+l);g[k>>2]=x;g[C>>2]=j;j=ea(g[b>>2]);x=ea(j*ea(g[o>>2]));l=ea(j*ea(g[p>>2]));s=ea(j*ea(g[r>>2]));r=b+4|0;j=ea(g[r>>2]);h=ea(j*ea(g[t>>2]));q=ea(j*ea(g[u>>2]));n=ea(x+h);h=ea(l+q);q=ea(s+ea(j*ea(g[w>>2])));w=b+8|0;j=ea(g[w>>2]);s=ea(j*ea(g[y>>2]));l=ea(j*ea(g[z>>2]));x=ea(h+l);l=ea(q+ea(j*ea(g[A>>2])));g[b>>2]=ea(n+s);g[r>>2]=x;g[w>>2]=l;qKa(f,d);g[c>>2]=ea(g[f>>2]);g[m>>2]=ea(g[f+4>>2]);g[B>>2]=ea(g[f+8>>2]);i=e;return}function y6a(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im;e=i;i=i+224|0;f=e+60|0;h=e+132|0;j=e+184|0;k=e+192|0;l=e+156|0;m=e+180|0;n=e+188|0;o=e+204|0;p=e+208|0;q=e+48|0;r=e+144|0;s=e+72|0;t=e;u=e+84|0;v=e+168|0;w=e+96|0;x=c[b+4>>2]|0;y=ea(g[x>>2]);z=ea(y+y);A=ea(g[x+4>>2]);B=ea(A+A);C=ea(g[x+8>>2]);D=ea(C+C);E=ea(g[x+12>>2]);F=ea(z*E);G=ea(B*E);H=ea(E*D);E=ea(y*z);z=ea(y*B);I=ea(y*D);y=ea(A*B);B=ea(A*D);A=ea(C*D);g[t>>2]=ea(ea(ea(1.0)-y)-A);J=t+4|0;g[J>>2]=ea(z+H);K=t+8|0;g[K>>2]=ea(I-G);L=t+12|0;g[L>>2]=ea(z-H);H=ea(ea(1.0)-E);M=t+16|0;g[M>>2]=ea(H-A);N=t+20|0;g[N>>2]=ea(B+F);O=t+24|0;g[O>>2]=ea(I+G);P=t+28|0;g[P>>2]=ea(B-F);Q=t+32|0;g[Q>>2]=ea(H-y);R=t+36|0;g[R>>2]=ea(0.0);U=t+40|0;g[U>>2]=ea(0.0);V=t+44|0;g[V>>2]=ea(0.0);g[R>>2]=ea(g[x+16>>2]);g[U>>2]=ea(g[x+20>>2]);g[V>>2]=ea(g[x+24>>2]);x=b+8|0;W=c[x>>2]|0;y=ea(g[W>>2]);X=W+12|0;H=ea(y+ea(g[X>>2]));Y=W+4|0;y=ea(g[Y>>2]);Z=W+16|0;F=ea(y+ea(g[Z>>2]));_=W+8|0;y=ea(g[_>>2]);$=W+20|0;B=ea(F*ea(.5));F=ea(ea(y+ea(g[$>>2]))*ea(.5));g[u>>2]=ea(H*ea(.5));g[u+4>>2]=B;g[u+8>>2]=F;F=ea(g[W>>2]);B=ea(F-ea(g[X>>2]));F=ea(g[Y>>2]);H=ea(F-ea(g[Z>>2]));F=ea(g[_>>2]);y=ea(H*ea(.5));H=ea(ea(F-ea(g[$>>2]))*ea(.5));F=ea(S(ea(B*ea(.5))));B=ea(g[b+12>>2]);g[v>>2]=ea(F+B);g[v+4>>2]=ea(ea(S(ea(y)))+B);g[v+8>>2]=ea(ea(S(ea(H)))+B);$=c[d+848>>2]|0;if(!$){i=e;return 1}_=w+4|0;Z=w+8|0;Y=w+12|0;X=w+16|0;W=w+20|0;aa=w+24|0;ba=w+28|0;ca=w+32|0;da=b+20|0;fa=b+16|0;ga=w+12|0;ha=p+4|0;ia=p+8|0;ja=w+24|0;ka=q+4|0;la=q+8|0;ma=f+4|0;na=f+8|0;oa=r+4|0;pa=r+8|0;qa=f+4|0;ra=f+8|0;sa=h+4|0;ta=h+8|0;ua=k+4|0;va=k+8|0;wa=s+4|0;xa=s+8|0;ya=f+4|0;za=f+8|0;Aa=h+4|0;Ba=h+8|0;Ca=l+4|0;Da=l+8|0;Ea=k+4|0;Fa=k+8|0;Ga=$;$=d+832|0;Ha=d+768|0;Ia=d;do{Ga=Ga+-1|0;d=c[Ha>>2]|0;Ha=Ha+4|0;g[w>>2]=ea(g[Ia>>2]);g[_>>2]=ea(g[Ia+4>>2]);g[Z>>2]=ea(g[Ia+8>>2]);g[Y>>2]=ea(g[Ia+12>>2]);g[X>>2]=ea(g[Ia+16>>2]);g[W>>2]=ea(g[Ia+20>>2]);g[aa>>2]=ea(g[Ia+24>>2]);g[ba>>2]=ea(g[Ia+28>>2]);g[ca>>2]=ea(g[Ia+32>>2]);Ia=Ia+36|0;Ja=a[$>>0]|0;$=$+1|0;a:do if((XPa(u,v,w,Y,aa)|0)!=0?(Ka=c[x>>2]|0,B=ea(g[da>>2]),La=c[b>>2]|0,H=ea(g[fa>>2]),y=ea(g[ga>>2]),F=ea(g[w>>2]),G=ea(y-F),y=ea(g[X>>2]),I=ea(g[_>>2]),A=ea(y-I),y=ea(g[W>>2]),E=ea(g[Z>>2]),z=ea(y-E),g[p>>2]=G,g[ha>>2]=A,g[ia>>2]=z,z=ea(ea(g[ja>>2])-F),F=ea(ea(g[ba>>2])-I),I=ea(ea(g[ca>>2])-E),g[q>>2]=z,g[ka>>2]=F,g[la>>2]=I,Ma=Ka+12|0,I=ea(g[Ma>>2]),F=ea(I-ea(g[Ka>>2])),Na=Ka+16|0,I=ea(g[Na>>2]),Oa=Ka+4|0,z=ea(I-ea(g[Oa>>2])),Pa=Ka+20|0,I=ea(g[Pa>>2]),Qa=Ka+8|0,E=ea(I-ea(g[Qa>>2])),g[f>>2]=F,g[ma>>2]=z,g[na>>2]=E,E=ea(POa(Ka,f,w,p,q,m,n,o)),z=ea(B+H),!(E>=ea(z*z))):0){F=ea(g[ga>>2]);I=ea(g[w>>2]);A=ea(F-I);G=ea(g[X>>2]);y=ea(g[_>>2]);D=ea(G-y);C=ea(g[W>>2]);Ra=ea(g[Z>>2]);Sa=ea(C-Ra);Ta=ea(g[ja>>2]);Ua=ea(Ta-I);Va=ea(g[ba>>2]);Wa=ea(Va-y);Xa=ea(g[ca>>2]);Ya=ea(Xa-Ra);Za=ea(ea(D*Ya)-ea(Sa*Wa));_a=ea(ea(Sa*Ua)-ea(A*Ya));Ya=ea(ea(A*Wa)-ea(D*Ua));Ua=ea(ea(Ya*Ya)+ea(ea(Za*Za)+ea(_a*_a)));if(Ua>ea(0.0)){D=ea(ea(1.0)/ea(T(ea(Ua))));$a=ea(Za*D);ab=ea(_a*D);bb=ea(Ya*D)}else{$a=ea(0.0);ab=ea(0.0);bb=ea(0.0)}D=ea(ea(Ra*bb)+ea(ea(y*ab)+ea(I*$a)));Ya=ea(g[Ka>>2]);_a=ea(g[Ma>>2]);Za=ea(Ya+_a);Ua=ea(g[Oa>>2]);Wa=ea(g[Na>>2]);A=ea(Ua+Wa);Sa=ea(g[Qa>>2]);cb=ea(g[Pa>>2]);db=ea(Za*ea(.5));Za=ea(A*ea(.5));A=ea(ea(Sa+cb)*ea(.5));if(!(ea(ea(ea(ea($a*db)+ea(ab*Za))+ea(bb*A))-D)<ea(0.0))){if(E>ea(.00100000005)){E=ea(g[n>>2]);if(aOa(Ja,E,ea(g[o>>2]))|0){g[r>>2]=$a;g[oa>>2]=ab;g[pa>>2]=bb;E=ea(g[Ka>>2]);D=ea(g[Oa>>2]);eb=ea(g[Qa>>2]);fb=ea(g[Ma>>2]);gb=ea(g[Na>>2]);hb=E;ib=D;jb=eb;kb=fb;lb=gb;mb=ea(g[Pa>>2])}else{gb=ea(g[n>>2]);fb=ea(g[o>>2]);eb=ea(ea(ea(1.0)-gb)-fb);D=ea(eb*ea(g[w>>2]));E=ea(D+ea(gb*ea(g[ga>>2])));D=ea(E+ea(fb*ea(g[ja>>2])));E=ea(eb*ea(g[_>>2]));nb=ea(E+ea(gb*ea(g[X>>2])));E=ea(nb+ea(fb*ea(g[ba>>2])));nb=ea(eb*ea(g[Z>>2]));eb=ea(nb+ea(gb*ea(g[W>>2])));gb=ea(eb+ea(fb*ea(g[ca>>2])));fb=ea(g[m>>2]);eb=ea(g[Ma>>2]);nb=ea(g[Ka>>2]);ob=ea(eb-nb);pb=ea(g[Na>>2]);qb=ea(g[Oa>>2]);rb=ea(pb-qb);sb=ea(g[Pa>>2]);tb=ea(g[Qa>>2]);ub=ea(ea(nb+ea(fb*ob))-D);D=ea(ea(qb+ea(fb*rb))-E);E=ea(ea(tb+ea(fb*ea(sb-tb)))-gb);g[r>>2]=ub;g[oa>>2]=D;g[pa>>2]=E;gb=ea(T(ea(ea(ea(ub*ub)+ea(D*D))+ea(E*E))));if(gb==ea(0.0))break;fb=ea(ea(1.0)/gb);gb=ea(D*fb);D=ea(E*fb);g[r>>2]=ea(ub*fb);g[oa>>2]=gb;g[pa>>2]=D;hb=nb;ib=qb;jb=tb;kb=eb;lb=pb;mb=sb}g[f>>2]=hb;g[qa>>2]=ib;g[ra>>2]=jb;g[h>>2]=kb;g[sa>>2]=lb;g[ta>>2]=mb;sb=ea(kb-hb);pb=ea(lb-ib);eb=ea(mb-jb);tb=ea(T(ea(ea(eb*eb)+ea(ea(pb*pb)+ea(sb*sb)))));if(tb>ea(0.0)){qb=ea(ea(.00999999977)/tb);tb=ea(sb*qb);sb=ea(pb*qb);pb=ea(eb*qb);g[f>>2]=ea(hb-tb);g[qa>>2]=ea(ib-sb);g[ra>>2]=ea(jb-pb);g[h>>2]=ea(kb+tb);g[sa>>2]=ea(lb+sb);g[ta>>2]=ea(mb+pb)}Qa=La+4096|0;Pa=0;do{Oa=Pa;Pa=Pa+1|0;if((OPa(w+(Oa*12|0)|0,w+((Pa+(Oa>>>1)&3)*12|0)|0,r,f,h,j,k)|0?(pb=ea(g[j>>2]),pb<z):0)?(sb=ea(g[k>>2]),tb=ea(g[t>>2]),qb=ea(sb*tb),eb=ea(g[J>>2]),nb=ea(sb*eb),D=ea(g[K>>2]),gb=ea(sb*D),sb=ea(g[ua>>2]),fb=ea(g[L>>2]),ub=ea(sb*fb),E=ea(g[M>>2]),rb=ea(sb*E),ob=ea(g[N>>2]),vb=ea(qb+ub),ub=ea(nb+rb),rb=ea(gb+ea(sb*ob)),sb=ea(g[va>>2]),gb=ea(g[O>>2]),nb=ea(sb*gb),qb=ea(g[P>>2]),wb=ea(sb*qb),xb=ea(g[Q>>2]),yb=ea(vb+nb),nb=ea(ub+wb),wb=ea(rb+ea(sb*xb)),sb=ea(yb+ea(g[R>>2])),yb=ea(nb+ea(g[U>>2])),nb=ea(wb+ea(g[V>>2])),g[k>>2]=sb,g[ua>>2]=yb,g[va>>2]=nb,wb=ea(g[r>>2]),rb=ea(g[oa>>2]),ub=ea(g[pa>>2]),Oa=c[Qa>>2]|0,Oa>>>0<=63):0){vb=ea(pb-B);pb=ea(ea(ea(D*wb)+ea(ob*rb))+ea(xb*ub));xb=ea(ea(ea(eb*wb)+ea(E*rb))+ea(qb*ub));qb=ea(ea(ea(tb*wb)+ea(fb*rb))+ea(gb*ub));c[Qa>>2]=Oa+1;g[La+(Oa<<6)>>2]=qb;g[La+(Oa<<6)+4>>2]=xb;g[La+(Oa<<6)+8>>2]=pb;g[La+(Oa<<6)+16>>2]=sb;g[La+(Oa<<6)+20>>2]=yb;g[La+(Oa<<6)+24>>2]=nb;g[La+(Oa<<6)+12>>2]=vb;c[La+(Oa<<6)+48>>2]=-1;c[La+(Oa<<6)+52>>2]=d}}while((Pa|0)!=3);yFb(t,La,Ka,B,w,r,d,H);break}vb=ea(I-F);nb=ea(y-G);yb=ea(Ra-C);sb=ea(I-Ta);pb=ea(y-Va);xb=ea(Ra-Xa);qb=ea(ea(nb*xb)-ea(yb*pb));ub=ea(ea(yb*sb)-ea(vb*xb));xb=ea(ea(vb*pb)-ea(nb*sb));sb=ea(ea(xb*xb)+ea(ea(qb*qb)+ea(ub*ub)));if(sb>ea(0.0)){nb=ea(ea(1.0)/ea(T(ea(sb))));zb=ea(qb*nb);Ab=ea(ub*nb);Bb=ea(xb*nb)}else{zb=ea(0.0);Ab=ea(0.0);Bb=ea(0.0)}nb=ea(ea(ea(zb*Ya)+ea(Ab*Ua))+ea(Bb*Sa));xb=ea(ea(ea(zb*_a)+ea(Ab*Wa))+ea(Bb*cb));Pa=nb>xb;ub=ea((Pa?xb:nb)-z);qb=ea(z+(Pa?nb:xb));xb=ea(ea(ea(zb*I)+ea(Ab*y))+ea(Bb*Ra));nb=ea(ea(ea(zb*F)+ea(Ab*G))+ea(Bb*C));sb=xb<nb?xb:nb;pb=xb>nb?xb:nb;nb=ea(ea(ea(zb*Ta)+ea(Ab*Va))+ea(Bb*Xa));xb=sb<nb?sb:nb;sb=pb>nb?pb:nb;if(!(qb<xb|sb<ub)){nb=ea(qb-xb);xb=ea(sb-ub);ub=ea(_a-Ya);sb=ea(Wa-Ua);qb=ea(cb-Sa);pb=ea(ea(ea(ub*ub)+ea(sb*sb))+ea(qb*qb));if(pb>ea(0.0)){vb=ea(ea(1.0)/ea(T(ea(pb))));Cb=ea(sb*vb);Db=ea(qb*vb);Eb=ea(ub*vb)}else{Cb=ea(0.0);Db=ea(0.0);Eb=ea(0.0)}Pa=Ja&255;vb=nb<xb?nb:xb;xb=zb;nb=Ab;yb=Bb;Qa=0;while(1){do if(c[539480+(Qa<<2)>>2]&Pa){gb=ea(g[w+(Qa*12|0)>>2]);rb=ea(g[w+(Qa*12|0)+4>>2]);fb=ea(g[w+(Qa*12|0)+8>>2]);Oa=Qa+1|0;Na=Oa+(Qa>>>1)&3;wb=ea(g[w+(Na*12|0)>>2]);tb=ea(g[w+(Na*12|0)+4>>2]);E=ea(gb-wb);wb=ea(rb-tb);tb=ea(fb-ea(g[w+(Na*12|0)+8>>2]));fb=ea(ea(Cb*tb)-ea(Db*wb));rb=ea(ea(Db*E)-ea(Eb*tb));tb=ea(ea(Eb*wb)-ea(Cb*E));if((!(+ea(S(ea(fb)))>1.0e-06)?!(+ea(S(ea(rb)))>1.0e-06):0)?!(+ea(S(ea(tb)))>1.0e-06):0){Fb=Oa;Gb=xb;Hb=nb;Ib=yb;Jb=vb;break}E=ea(ea(tb*tb)+ea(ea(fb*fb)+ea(rb*rb)));if(E>ea(0.0)){wb=ea(ea(1.0)/ea(T(ea(E))));Kb=ea(fb*wb);Lb=ea(rb*wb);Mb=ea(tb*wb)}else{Kb=ea(0.0);Lb=ea(0.0);Mb=ea(0.0)}wb=ea(ea(ea(Kb*Ya)+ea(Lb*Ua))+ea(Mb*Sa));tb=ea(ea(ea(Kb*_a)+ea(Lb*Wa))+ea(Mb*cb));Na=wb>tb;rb=ea((Na?tb:wb)-z);fb=ea(z+(Na?wb:tb));tb=ea(ea(ea(Kb*I)+ea(Lb*y))+ea(Mb*Ra));wb=ea(ea(ea(Kb*F)+ea(Lb*G))+ea(Mb*C));E=tb<wb?tb:wb;gb=tb>wb?tb:wb;wb=ea(ea(ea(Kb*Ta)+ea(Lb*Va))+ea(Mb*Xa));tb=E<wb?E:wb;E=gb>wb?gb:wb;if(fb<tb|E<rb)break a;wb=ea(fb-tb);tb=ea(E-rb);rb=wb<tb?wb:tb;if(rb<vb){Fb=Oa;Gb=Kb;Hb=Lb;Ib=Mb;Jb=rb}else{Fb=Oa;Gb=xb;Hb=nb;Ib=yb;Jb=vb}}else{Fb=Qa+1|0;Gb=xb;Hb=nb;Ib=yb;Jb=vb}while(0);if(Fb>>>0<3){vb=Jb;xb=Gb;nb=Hb;yb=Ib;Qa=Fb}else break}if(ea(ea(ea(Gb*ea(db-ea(ea(ea(I+F)+Ta)*ea(.333333343))))+ea(Hb*ea(Za-ea(ea(ea(y+G)+Va)*ea(.333333343)))))+ea(Ib*ea(A-ea(ea(ea(Ra+C)+Xa)*ea(.333333343)))))<ea(0.0)){Nb=ea(-Gb);Ob=ea(-Hb);Pb=ea(-Ib)}else{Nb=Gb;Ob=Hb;Pb=Ib}g[s>>2]=Nb;g[wa>>2]=Ob;g[xa>>2]=Pb;g[f>>2]=Ya;g[ya>>2]=Ua;g[za>>2]=Sa;g[h>>2]=_a;g[Aa>>2]=Wa;g[Ba>>2]=cb;yb=ea(T(ea(pb)));if(yb>ea(0.0)){nb=ea(ea(.00999999977)/yb);yb=ea(ub*nb);xb=ea(sb*nb);vb=ea(qb*nb);g[f>>2]=ea(Ya-yb);g[ya>>2]=ea(Ua-xb);g[za>>2]=ea(Sa-vb);g[h>>2]=ea(_a+yb);g[Aa>>2]=ea(Wa+xb);g[Ba>>2]=ea(cb+vb)}Qa=La+4096|0;vb=ea(-Nb);xb=ea(-Ob);yb=ea(-Pb);Pa=0;do{Oa=Pa;Pa=Pa+1|0;g[l>>2]=vb;g[Ca>>2]=xb;g[Da>>2]=yb;if(OPa(w+(Oa*12|0)|0,w+((Pa+(Oa>>>1)&3)*12|0)|0,l,f,h,j,k)|0?(nb=ea(g[k>>2]),z=ea(g[t>>2]),rb=ea(nb*z),tb=ea(g[J>>2]),wb=ea(nb*tb),E=ea(g[K>>2]),fb=ea(nb*E),nb=ea(g[Ea>>2]),gb=ea(g[L>>2]),eb=ea(nb*gb),ob=ea(g[M>>2]),D=ea(nb*ob),Qb=ea(g[N>>2]),Rb=ea(rb+eb),eb=ea(wb+D),D=ea(fb+ea(nb*Qb)),nb=ea(g[Fa>>2]),fb=ea(g[O>>2]),wb=ea(nb*fb),rb=ea(g[P>>2]),Sb=ea(nb*rb),Tb=ea(g[Q>>2]),Ub=ea(Rb+wb),wb=ea(eb+Sb),Sb=ea(D+ea(nb*Tb)),nb=ea(Ub+ea(g[R>>2])),Ub=ea(wb+ea(g[U>>2])),wb=ea(Sb+ea(g[V>>2])),g[k>>2]=nb,g[Ea>>2]=Ub,g[Fa>>2]=wb,Oa=c[Qa>>2]|0,Oa>>>0<=63):0){Sb=ea(-ea(B+ea(g[j>>2])));D=ea(ea(ea(Nb*E)+ea(Ob*Qb))+ea(Pb*Tb));Tb=ea(ea(ea(Nb*tb)+ea(Ob*ob))+ea(Pb*rb));rb=ea(ea(ea(Nb*z)+ea(Ob*gb))+ea(Pb*fb));c[Qa>>2]=Oa+1;g[La+(Oa<<6)>>2]=rb;g[La+(Oa<<6)+4>>2]=Tb;g[La+(Oa<<6)+8>>2]=D;g[La+(Oa<<6)+16>>2]=nb;g[La+(Oa<<6)+20>>2]=Ub;g[La+(Oa<<6)+24>>2]=wb;g[La+(Oa<<6)+12>>2]=Sb;c[La+(Oa<<6)+48>>2]=-1;c[La+(Oa<<6)+52>>2]=d}}while((Pa|0)!=3);yFb(t,La,Ka,B,w,s,d,H)}}}while(0)}while((Ga|0)!=0);i=e;return 1}function z6a(b,f,h,j,l,m,n,o,p,q,r,s,t,u,v,w){b=b|0;f=f|0;h=h|0;j=j|0;l=ea(l);m=ea(m);n=ea(n);o=o|0;p=p|0;q=q|0;r=r|0;s=ea(s);t=t|0;u=u|0;v=v|0;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=0,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=0,Pa=0,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=0,kb=0,lb=Im,mb=Im,nb=Im,ob=Im,pb=0,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=0,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=0,Db=0,Eb=Im,Fb=Im,Gb=0,Hb=Im,Ib=Im,Jb=0,Kb=Im,Lb=Im,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=0,cc=Im,dc=Im,ec=Im,fc=Im,gc=0,hc=Im,ic=Im,jc=Im,kc=Im;x=i;i=i+3168|0;y=x+3132|0;z=x+56|0;A=x+52|0;B=x+48|0;C=x+36|0;D=x;E=c[b+16>>2]|0;F=i;i=i+((1*(E<<2)|0)+15&-16)|0;G=b+24|0;H=c[G>>2]|0;I=b+28|0;J=c[I>>2]|0;K=p+36|0;a:do if(w)if(!E){L=ea(0.0);M=ea(0.0);N=ea(0.0);O=ea(3402823469999999843913219.0e14);P=0;Q=-1}else{R=p+4|0;U=p+8|0;V=p+12|0;W=p+16|0;X=p+20|0;Y=p+24|0;Z=p+28|0;_=p+32|0;$=p+40|0;aa=p+44|0;ba=h+4|0;ca=h+8|0;da=h+12|0;fa=h+16|0;ga=h+20|0;ha=h+24|0;ia=h+28|0;ja=h+32|0;ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(3402823469999999843913219.0e14);oa=F;pa=0;qa=-1;while(1){ra=ea(g[H+(pa*20|0)>>2]);sa=ea(ra*l);ta=ea(g[H+(pa*20|0)+4>>2]);ua=ea(sa+ea(ta*m));sa=ea(g[H+(pa*20|0)+8>>2]);va=ea(ua+ea(sa*n));ua=ea(g[H+(pa*20|0)+12>>2]);if(!(ea(ua+va)<ea(0.0))){wa=oa+4|0;c[oa>>2]=pa;va=ea(ra*ea(g[p>>2]));xa=ea(ra*ea(g[R>>2]));ya=ea(ra*ea(g[U>>2]));za=ea(ta*ea(g[V>>2]));Aa=ea(ta*ea(g[W>>2]));Ba=ea(va+za);za=ea(xa+Aa);Aa=ea(ya+ea(ta*ea(g[X>>2])));ya=ea(sa*ea(g[Y>>2]));xa=ea(sa*ea(g[Z>>2]));va=ea(Ba+ya);ya=ea(za+xa);xa=ea(Aa+ea(sa*ea(g[_>>2])));Aa=ea(va*ea(g[K>>2]));za=ea(Aa+ea(ya*ea(g[$>>2])));Aa=ea(za+ea(xa*ea(g[aa>>2])));Ca=d[H+(pa*20|0)+19>>0]|0;za=ea(ra*ea(g[J+(Ca*12|0)>>2]));ra=ea(za+ea(ta*ea(g[J+(Ca*12|0)+4>>2])));ta=ea(Aa+ea(ra+ea(sa*ea(g[J+(Ca*12|0)+8>>2]))));sa=ea(Aa-ua);ua=ea(va*ea(g[h>>2]));Aa=ea(ua+ea(ya*ea(g[ba>>2])));ua=ea(Aa+ea(xa*ea(g[ca>>2])));Aa=ea(va*ea(g[da>>2]));ra=ea(Aa+ea(ya*ea(g[fa>>2])));Aa=ea(ra+ea(xa*ea(g[ga>>2])));ra=ua<Aa?ua:Aa;za=ua>Aa?ua:Aa;Aa=ea(va*ea(g[ha>>2]));ua=ea(Aa+ea(ya*ea(g[ia>>2])));Aa=ea(ua+ea(xa*ea(g[ja>>2])));ua=ra<Aa?ra:Aa;ra=za>Aa?za:Aa;if(ea(sa+s)<ua|ea(ra+s)<ta){Da=0;break}Aa=ea(sa-ua);ua=ea(ra-ta);ta=Aa<ua?Aa:ua;if(ta<na){Ea=ta;Fa=xa;Ga=ya;Ha=va;Ia=wa;Ja=pa}else{Ea=na;Fa=ka;Ga=la;Ha=ma;Ia=wa;Ja=qa}}else{Ea=na;Fa=ka;Ga=la;Ha=ma;Ia=oa;Ja=qa}pa=pa+1|0;if(pa>>>0>=E>>>0){Ka=Ea;La=Fa;Ma=Ga;Na=Ha;Oa=Ia;Pa=Ja;Qa=18;break a}else{ka=Fa;la=Ga;ma=Ha;na=Ea;oa=Ia;qa=Ja}}i=x;return Da|0}else{na=ea(g[r+36>>2]);ma=ea(na*l);la=ea(g[r+40>>2]);ka=ea(la*l);va=ea(g[r+44>>2]);ya=ea(va*l);xa=ea(g[r+48>>2]);ta=ea(xa*m);ua=ea(g[r+52>>2]);Aa=ea(ua*m);ra=ea(g[r+56>>2]);sa=ea(ma+ta);ta=ea(ka+Aa);Aa=ea(ya+ea(ra*m));ya=ea(g[r+60>>2]);ka=ea(ya*n);ma=ea(g[r+64>>2]);za=ea(ma*n);Ba=ea(g[r+68>>2]);Ra=ea(sa+ka);ka=ea(ta+za);za=ea(Aa+ea(Ba*n));if(!E){L=ea(0.0);M=ea(0.0);N=ea(0.0);O=ea(3402823469999999843913219.0e14);P=0;Q=-1}else{qa=p+4|0;oa=p+8|0;pa=p+12|0;ja=p+16|0;ia=p+20|0;ha=p+24|0;ga=p+28|0;fa=p+32|0;da=p+40|0;ca=p+44|0;ba=h+4|0;aa=h+8|0;$=h+12|0;_=h+16|0;Z=h+20|0;Y=h+24|0;X=h+28|0;W=h+32|0;Aa=ea(0.0);ta=ea(0.0);sa=ea(0.0);Sa=ea(3402823469999999843913219.0e14);V=F;U=-1;R=0;while(1){Ta=ea(g[H+(R*20|0)>>2]);Ua=ea(Ra*Ta);Va=ea(g[H+(R*20|0)+4>>2]);Wa=ea(Ua+ea(ka*Va));Ua=ea(g[H+(R*20|0)+8>>2]);Xa=ea(Wa+ea(za*Ua));Wa=ea(g[H+(R*20|0)+12>>2]);if(!(ea(Wa+Xa)<ea(0.0))){Xa=ea(ea(ea(Ta*na)+ea(Va*xa))+ea(Ua*ya));Ya=ea(ea(ea(Ta*la)+ea(Va*ua))+ea(Ua*ma));Za=ea(ea(ea(Ta*va)+ea(Va*ra))+ea(Ua*Ba));_a=ea(T(ea(ea(ea(Xa*Xa)+ea(Ya*Ya))+ea(Za*Za))));$a=ea(ea(1.0)/_a);if(_a>ea(0.0)){ab=ea(Xa*$a);bb=ea(Ya*$a);cb=ea(Za*$a)}else{ab=Xa;bb=Ya;cb=Za}wa=V+4|0;c[V>>2]=R;Za=ea(ab*ea(g[p>>2]));Ya=ea(ab*ea(g[qa>>2]));Xa=ea(ab*ea(g[oa>>2]));_a=ea(bb*ea(g[pa>>2]));db=ea(bb*ea(g[ja>>2]));eb=ea(Za+_a);_a=ea(Ya+db);db=ea(Xa+ea(bb*ea(g[ia>>2])));Xa=ea(cb*ea(g[ha>>2]));Ya=ea(cb*ea(g[ga>>2]));Za=ea(eb+Xa);Xa=ea(_a+Ya);Ya=ea(db+ea(cb*ea(g[fa>>2])));db=ea(Za*ea(g[K>>2]));_a=ea(db+ea(Xa*ea(g[da>>2])));db=ea(_a+ea(Ya*ea(g[ca>>2])));Ca=d[H+(R*20|0)+19>>0]|0;_a=ea(Ta*ea(g[J+(Ca*12|0)>>2]));Ta=ea(_a+ea(Va*ea(g[J+(Ca*12|0)+4>>2])));Va=ea(db+ea($a*ea(Ta+ea(Ua*ea(g[J+(Ca*12|0)+8>>2])))));Ua=ea(db-ea(Wa*$a));$a=ea(Za*ea(g[h>>2]));Wa=ea($a+ea(Xa*ea(g[ba>>2])));$a=ea(Wa+ea(Ya*ea(g[aa>>2])));Wa=ea(Za*ea(g[$>>2]));db=ea(Wa+ea(Xa*ea(g[_>>2])));Wa=ea(db+ea(Ya*ea(g[Z>>2])));db=$a<Wa?$a:Wa;Ta=$a>Wa?$a:Wa;Wa=ea(Za*ea(g[Y>>2]));$a=ea(Wa+ea(Xa*ea(g[X>>2])));Wa=ea($a+ea(Ya*ea(g[W>>2])));$a=db<Wa?db:Wa;db=Ta>Wa?Ta:Wa;if(ea(Ua+s)<$a|ea(db+s)<Va){Da=0;break}Wa=ea(Ua-$a);$a=ea(db-Va);Va=Wa<$a?Wa:$a;if(Va<Sa){fb=Va;gb=Ya;hb=Xa;ib=Za;jb=wa;kb=R}else{fb=Sa;gb=Aa;hb=ta;ib=sa;jb=wa;kb=U}}else{fb=Sa;gb=Aa;hb=ta;ib=sa;jb=V;kb=U}R=R+1|0;if(R>>>0>=E>>>0){Ka=fb;La=gb;Ma=hb;Na=ib;Oa=jb;Pa=kb;Qa=18;break a}else{Aa=gb;ta=hb;sa=ib;Sa=fb;V=jb;U=kb}}i=x;return Da|0}}while(0);b:do if((Qa|0)==18){kb=Oa-F>>2;if((Pa|0)==-1){jb=(E|0)==0;if(w){if(jb){L=La;M=Ma;N=Na;O=Ka;P=0;Q=-1;break}fb=ea(g[p>>2]);ib=ea(g[p+4>>2]);hb=ea(g[p+8>>2]);gb=ea(g[p+12>>2]);cb=ea(g[p+16>>2]);bb=ea(g[p+20>>2]);ab=ea(g[p+24>>2]);n=ea(g[p+28>>2]);m=ea(g[p+32>>2]);l=ea(g[K>>2]);Ea=ea(g[p+40>>2]);Ha=ea(g[p+44>>2]);Ga=ea(g[h>>2]);Fa=ea(g[h+4>>2]);Sa=ea(g[h+8>>2]);sa=ea(g[h+12>>2]);ta=ea(g[h+16>>2]);Aa=ea(g[h+20>>2]);Ba=ea(g[h+24>>2]);ra=ea(g[h+28>>2]);va=ea(g[h+32>>2]);ma=La;ua=Ma;la=Na;ya=Ka;Ja=-1;Ia=0;while(1){xa=ea(g[H+(Ia*20|0)>>2]);na=ea(xa*fb);za=ea(xa*ib);ka=ea(xa*hb);Ra=ea(g[H+(Ia*20|0)+4>>2]);Za=ea(na+ea(Ra*gb));na=ea(za+ea(Ra*cb));za=ea(ka+ea(Ra*bb));ka=ea(g[H+(Ia*20|0)+8>>2]);Xa=ea(Za+ea(ka*ab));Za=ea(na+ea(ka*n));na=ea(za+ea(ka*m));za=ea(ea(ea(Xa*l)+ea(Za*Ea))+ea(na*Ha));U=d[H+(Ia*20|0)+19>>0]|0;Ya=ea(xa*ea(g[J+(U*12|0)>>2]));xa=ea(Ya+ea(Ra*ea(g[J+(U*12|0)+4>>2])));Ra=ea(za+ea(xa+ea(ka*ea(g[J+(U*12|0)+8>>2]))));ka=ea(za-ea(g[H+(Ia*20|0)+12>>2]));za=ea(ea(ea(Xa*Ga)+ea(Za*Fa))+ea(na*Sa));xa=ea(ea(ea(Xa*sa)+ea(Za*ta))+ea(na*Aa));Ya=za<xa?za:xa;Va=za>xa?za:xa;xa=ea(ea(ea(Xa*Ba)+ea(Za*ra))+ea(na*va));za=Ya<xa?Ya:xa;Ya=Va>xa?Va:xa;if(ea(ka+s)<za|ea(Ya+s)<Ra){Da=0;break}xa=ea(ka-za);za=ea(Ya-Ra);Ra=xa<za?xa:za;if(Ra<ya){lb=Ra;mb=na;nb=Za;ob=Xa;pb=Ia}else{lb=ya;mb=ma;nb=ua;ob=la;pb=Ja}c[F+(Ia<<2)>>2]=Ia;Ia=Ia+1|0;if(Ia>>>0>=E>>>0){L=mb;M=nb;N=ob;O=lb;P=E;Q=pb;break b}else{ma=mb;ua=nb;la=ob;ya=lb;Ja=pb}}i=x;return Da|0}if(jb){L=La;M=Ma;N=Na;O=Ka;P=0;Q=-1}else{Ja=p+4|0;Ia=p+8|0;U=p+12|0;V=p+16|0;R=p+20|0;W=p+24|0;X=p+28|0;Y=p+32|0;Z=p+40|0;_=p+44|0;$=h+4|0;aa=h+8|0;ba=h+12|0;ca=h+16|0;da=h+20|0;fa=h+24|0;ga=h+28|0;ha=h+32|0;ya=ea(g[r+36>>2]);la=ea(g[r+40>>2]);ua=ea(g[r+44>>2]);ma=ea(g[r+48>>2]);va=ea(g[r+52>>2]);ra=ea(g[r+56>>2]);Ba=ea(g[r+60>>2]);Aa=ea(g[r+64>>2]);ta=ea(g[r+68>>2]);sa=La;Sa=Ma;Fa=Na;Ga=Ka;ia=-1;ja=0;while(1){Ha=ea(g[H+(ja*20|0)>>2]);Ea=ea(Ha*ya);l=ea(Ha*la);m=ea(Ha*ua);n=ea(g[H+(ja*20|0)+4>>2]);ab=ea(Ea+ea(n*ma));Ea=ea(l+ea(n*va));l=ea(m+ea(n*ra));m=ea(g[H+(ja*20|0)+8>>2]);bb=ea(ab+ea(m*Ba));ab=ea(Ea+ea(m*Aa));Ea=ea(l+ea(m*ta));l=ea(T(ea(ea(ea(bb*bb)+ea(ab*ab))+ea(Ea*Ea))));cb=ea(ea(1.0)/l);if(l>ea(0.0)){qb=ea(bb*cb);rb=ea(ab*cb);sb=ea(Ea*cb)}else{qb=bb;rb=ab;sb=Ea}Ea=ea(qb*ea(g[p>>2]));ab=ea(qb*ea(g[Ja>>2]));bb=ea(qb*ea(g[Ia>>2]));l=ea(rb*ea(g[U>>2]));gb=ea(rb*ea(g[V>>2]));hb=ea(Ea+l);l=ea(ab+gb);gb=ea(bb+ea(rb*ea(g[R>>2])));bb=ea(sb*ea(g[W>>2]));ab=ea(sb*ea(g[X>>2]));Ea=ea(hb+bb);bb=ea(l+ab);ab=ea(gb+ea(sb*ea(g[Y>>2])));gb=ea(Ea*ea(g[K>>2]));l=ea(gb+ea(bb*ea(g[Z>>2])));gb=ea(l+ea(ab*ea(g[_>>2])));pa=d[H+(ja*20|0)+19>>0]|0;l=ea(Ha*ea(g[J+(pa*12|0)>>2]));Ha=ea(l+ea(n*ea(g[J+(pa*12|0)+4>>2])));n=ea(gb+ea(cb*ea(Ha+ea(m*ea(g[J+(pa*12|0)+8>>2])))));m=ea(gb-ea(cb*ea(g[H+(ja*20|0)+12>>2])));cb=ea(Ea*ea(g[h>>2]));gb=ea(cb+ea(bb*ea(g[$>>2])));cb=ea(gb+ea(ab*ea(g[aa>>2])));gb=ea(Ea*ea(g[ba>>2]));Ha=ea(gb+ea(bb*ea(g[ca>>2])));gb=ea(Ha+ea(ab*ea(g[da>>2])));Ha=cb<gb?cb:gb;l=cb>gb?cb:gb;gb=ea(Ea*ea(g[fa>>2]));cb=ea(gb+ea(bb*ea(g[ga>>2])));gb=ea(cb+ea(ab*ea(g[ha>>2])));cb=Ha<gb?Ha:gb;Ha=l>gb?l:gb;if(ea(m+s)<cb|ea(Ha+s)<n){Da=0;break}gb=ea(m-cb);cb=ea(Ha-n);n=gb<cb?gb:cb;if(n<Ga){tb=n;ub=ab;vb=bb;wb=Ea;xb=ja}else{tb=Ga;ub=sa;vb=Sa;wb=Fa;xb=ia}c[F+(ja<<2)>>2]=ja;ja=ja+1|0;if(ja>>>0>=E>>>0){L=ub;M=vb;N=wb;O=tb;P=E;Q=xb;break b}else{sa=ub;Sa=vb;Fa=wb;Ga=tb;ia=xb}}i=x;return Da|0}}else{L=La;M=Ma;N=Na;O=Ka;P=kb;Q=Pa}}while(0);g[t>>2]=ea(0.0);Pa=t+4|0;g[Pa>>2]=ea(0.0);xb=t+8|0;g[xb>>2]=ea(0.0);g[u>>2]=ea(3402823469999999843913219.0e14);E=b+64|0;rn[c[E>>2]&127](b,j,p,r,y,z);Ka=ea(g[h>>2]);Na=ea(g[j>>2]);Ma=ea(Ka*Na);H=h+4|0;Ka=ea(g[H>>2]);J=j+4|0;La=ea(g[J>>2]);tb=ea(Ma+ea(Ka*La));K=h+8|0;Ka=ea(g[K>>2]);pb=j+8|0;Ma=ea(g[pb>>2]);wb=ea(tb+ea(Ka*Ma));w=h+12|0;Ka=ea(Na*ea(g[w>>2]));Oa=h+16|0;tb=ea(Ka+ea(La*ea(g[Oa>>2])));ia=h+20|0;Ka=ea(tb+ea(Ma*ea(g[ia>>2])));tb=wb<Ka?wb:Ka;vb=wb>Ka?wb:Ka;ja=h+24|0;Ka=ea(Na*ea(g[ja>>2]));ha=h+28|0;wb=ea(Ka+ea(La*ea(g[ha>>2])));ga=h+32|0;Ka=ea(wb+ea(Ma*ea(g[ga>>2])));wb=tb<Ka?tb:Ka;tb=vb>Ka?vb:Ka;Ka=ea(g[z>>2]);if(ea(Ka+s)<wb){Da=0;i=x;return Da|0}vb=ea(tb+s);ub=ea(g[y>>2]);if(vb<ub){Da=0;i=x;return Da|0}vb=ea(Ka-wb);wb=ea(tb-ub);ub=vb<wb?vb:wb;if(ub<ea(O+ea(.0000999999974))){yb=ub;zb=Na;Ab=La;Bb=Ma;Cb=1}else{yb=O;zb=N;Ab=M;Bb=L;Cb=0}a[v>>0]=Cb;if(yb<ea(g[u>>2])){g[u>>2]=yb;yb=ea(zb*ea(g[o>>2]));L=ea(zb*ea(g[o+4>>2]));M=ea(zb*ea(g[o+8>>2]));N=ea(Ab*ea(g[o+12>>2]));O=ea(Ab*ea(g[o+16>>2]));Ma=ea(yb+N);N=ea(L+O);O=ea(M+ea(Ab*ea(g[o+20>>2])));M=ea(Bb*ea(g[o+24>>2]));L=ea(Bb*ea(g[o+28>>2]));yb=ea(N+L);L=ea(O+ea(Bb*ea(g[o+32>>2])));g[t>>2]=ea(Ma+M);g[Pa>>2]=yb;g[xb>>2]=L}Cb=c[G>>2]|0;L=ea(g[Cb+(Q*20|0)>>2]);yb=ea(g[q>>2]);M=ea(L*yb);G=q+4|0;Ma=ea(g[G>>2]);O=ea(L*Ma);fa=q+8|0;N=ea(g[fa>>2]);La=ea(L*N);L=ea(g[Cb+(Q*20|0)+4>>2]);da=q+12|0;Na=ea(g[da>>2]);ub=ea(L*Na);ca=q+16|0;wb=ea(g[ca>>2]);vb=ea(L*wb);ba=q+20|0;tb=ea(g[ba>>2]);Ka=ea(M+ub);ub=ea(O+vb);vb=ea(La+ea(L*tb));L=ea(g[Cb+(Q*20|0)+8>>2]);aa=q+24|0;La=ea(g[aa>>2]);O=ea(L*La);$=q+28|0;M=ea(g[$>>2]);sb=ea(L*M);_=q+32|0;rb=ea(g[_>>2]);qb=ea(Ka+O);O=ea(ub+sb);sb=ea(vb+ea(L*rb));L=ea(g[r>>2]);vb=ea(qb*L);Z=r+4|0;ub=ea(g[Z>>2]);Ka=ea(qb*ub);Y=r+8|0;lb=ea(g[Y>>2]);ob=ea(qb*lb);X=r+12|0;nb=ea(g[X>>2]);mb=ea(O*nb);W=r+16|0;Ga=ea(g[W>>2]);Fa=ea(O*Ga);R=r+20|0;Sa=ea(g[R>>2]);sa=ea(vb+mb);mb=ea(Ka+Fa);Fa=ea(ob+ea(O*Sa));V=r+24|0;ob=ea(g[V>>2]);Ka=ea(sb*ob);U=r+28|0;vb=ea(g[U>>2]);ta=ea(sb*vb);Ia=r+32|0;Aa=ea(g[Ia>>2]);Ba=ea(sa+Ka);Ka=ea(mb+ta);ta=ea(Fa+ea(sb*Aa));Fa=ea(g[Cb+(Q*20|0)+12>>2]);Q=q+36|0;mb=ea(g[Q>>2]);sa=ea(qb*mb);Ja=q+40|0;qb=ea(g[Ja>>2]);ra=ea(sa+ea(O*qb));jb=q+44|0;O=ea(g[jb>>2]);sa=ea(Fa-ea(ra+ea(sb*O)));pa=f&255;do if(!(pa&8))Db=0;else{sb=ea(g[h>>2]);ra=ea(Ba*sb);Fa=ea(g[H>>2]);va=ea(ra+ea(Ka*Fa));ra=ea(g[K>>2]);f=!(ea(sa+ea(va+ea(ta*ra)))<=s);va=ea(g[w>>2]);if(f){ma=ea(Ba*va);ua=ea(g[Oa>>2]);la=ea(ma+ea(Ka*ua));ma=ea(g[ia>>2]);if(!(ea(sa+ea(la+ea(ta*ma)))<=s)){Db=0;break}else{Eb=ua;Fb=ma}}else{ma=ea(g[Oa>>2]);Eb=ma;Fb=ea(g[ia>>2])}ma=ea(Fa-Eb);Fa=ea(ra-Fb);g[y>>2]=ea(sb-va);g[y+4>>2]=ma;g[y+8>>2]=Fa;Db=1}while(0);do if(!(pa&16))Gb=Db;else{Fb=ea(g[w>>2]);Eb=ea(Ba*Fb);Fa=ea(g[Oa>>2]);ma=ea(Eb+ea(Ka*Fa));Eb=ea(g[ia>>2]);f=!(ea(sa+ea(ma+ea(ta*Eb)))<=s);ma=ea(g[ja>>2]);if(f){va=ea(Ba*ma);sb=ea(g[ha>>2]);ra=ea(va+ea(Ka*sb));va=ea(g[ga>>2]);if(!(ea(sa+ea(ra+ea(ta*va)))<=s)){Gb=Db;break}else{Hb=sb;Ib=va}}else{va=ea(g[ha>>2]);Hb=va;Ib=ea(g[ga>>2])}va=ea(Fa-Hb);Fa=ea(Eb-Ib);g[y+(Db*12|0)>>2]=ea(Fb-ma);g[y+(Db*12|0)+4>>2]=va;g[y+(Db*12|0)+8>>2]=Fa;Gb=Db+1|0}while(0);do if(!(pa&32))Jb=Gb;else{Ib=ea(g[ja>>2]);Hb=ea(Ba*Ib);Fa=ea(g[ha>>2]);va=ea(Hb+ea(Ka*Fa));Hb=ea(g[ga>>2]);Db=!(ea(sa+ea(va+ea(ta*Hb)))<=s);va=ea(g[h>>2]);if(Db){ma=ea(Ba*va);Fb=ea(g[H>>2]);Eb=ea(ma+ea(Ka*Fb));ma=ea(g[K>>2]);if(!(ea(sa+ea(Eb+ea(ta*ma)))<=s)){Jb=Gb;break}else{Kb=Fb;Lb=ma}}else{ma=ea(g[H>>2]);Kb=ma;Lb=ea(g[K>>2])}ma=ea(Fa-Kb);Fa=ea(Hb-Lb);g[y+(Gb*12|0)>>2]=ea(Ib-va);g[y+(Gb*12|0)+4>>2]=ma;g[y+(Gb*12|0)+8>>2]=Fa;Jb=Gb+1|0}while(0);Lb=ea(g[j>>2]);Kb=ea(yb*Lb);yb=ea(Ma*Lb);Ma=ea(N*Lb);Lb=ea(g[J>>2]);N=ea(Kb+ea(Na*Lb));Na=ea(yb+ea(wb*Lb));wb=ea(Ma+ea(tb*Lb));Lb=ea(g[pb>>2]);tb=ea(N+ea(La*Lb));La=ea(Na+ea(M*Lb));M=ea(wb+ea(rb*Lb));Lb=ea(ea(ob*M)+ea(ea(L*tb)+ea(nb*La)));nb=ea(ea(vb*M)+ea(ea(ub*tb)+ea(Ga*La)));Ga=ea(ea(Aa*M)+ea(ea(lb*tb)+ea(Sa*La)));Sa=ea(ea(g[j+12>>2])-ea(ea(O*M)+ea(ea(mb*tb)+ea(qb*La))));j=c[I>>2]|0;c[z>>2]=0;I=c[b+32>>2]|0;c:do if((P|0)!=0?(pb=p+4|0,J=p+8|0,Gb=p+12|0,pa=p+16|0,Db=p+20|0,f=p+24|0,oa=p+28|0,qa=p+32|0,wa=C+4|0,Ca=C+8|0,(Jb|0)!=0):0){Mb=F;Nb=P;while(1){Nb=Nb+-1|0;Ob=c[Mb>>2]|0;Pb=e[Cb+(Ob*20|0)+16>>1]|0;Qb=Cb+(Ob*20|0)+18|0;Ob=Jb;Rb=y;do{Ob=Ob+-1|0;Sb=a[Qb>>0]|0;Tb=Sb&255;if(Sb<<24>>24){Sb=Rb+8|0;Ub=Rb+4|0;Vb=0;do{Wb=d[I+(Vb+Pb)>>0]|0;Vb=Vb+1|0;Xb=d[I+((Vb>>>0>=Tb>>>0?0:Vb)+Pb)>>0]|0;La=ea(g[j+(Wb*12|0)>>2]);qb=ea(Lb*La);tb=ea(g[j+(Wb*12|0)+4>>2]);mb=ea(qb+ea(nb*tb));qb=ea(g[j+(Wb*12|0)+8>>2]);Wb=!(ea(Sa+ea(mb+ea(Ga*qb)))<=s);mb=ea(g[j+(Xb*12|0)>>2]);if(Wb){M=ea(Lb*mb);O=ea(g[j+(Xb*12|0)+4>>2]);lb=ea(M+ea(nb*O));M=ea(g[j+(Xb*12|0)+8>>2]);if(ea(Sa+ea(lb+ea(Ga*M)))<=s){Yb=O;Zb=M;Qa=65}}else{M=ea(g[j+(Xb*12|0)+4>>2]);Yb=M;Zb=ea(g[j+(Xb*12|0)+8>>2]);Qa=65}d:do if((Qa|0)==65){Qa=0;M=ea(La-mb);O=ea(tb-Yb);lb=ea(qb-Zb);Aa=ea(M*ea(g[r>>2]));ub=ea(M*ea(g[Z>>2]));vb=ea(M*ea(g[Y>>2]));M=ea(O*ea(g[X>>2]));L=ea(O*ea(g[W>>2]));ob=ea(Aa+M);M=ea(ub+L);L=ea(vb+ea(O*ea(g[R>>2])));O=ea(lb*ea(g[V>>2]));vb=ea(lb*ea(g[U>>2]));ub=ea(ob+O);O=ea(M+vb);vb=ea(L+ea(lb*ea(g[Ia>>2])));lb=ea(ub*ea(g[p>>2]));L=ea(ub*ea(g[pb>>2]));M=ea(ub*ea(g[J>>2]));ub=ea(O*ea(g[Gb>>2]));ob=ea(O*ea(g[pa>>2]));Aa=ea(lb+ub);ub=ea(L+ob);ob=ea(M+ea(O*ea(g[Db>>2])));O=ea(vb*ea(g[f>>2]));M=ea(vb*ea(g[oa>>2]));L=ea(Aa+O);O=ea(ub+M);M=ea(ob+ea(vb*ea(g[qa>>2])));vb=ea(g[Sb>>2]);ob=ea(O*vb);ub=ea(g[Ub>>2]);Aa=ea(ob-ea(M*ub));ob=ea(g[Rb>>2]);lb=ea(ea(M*ob)-ea(L*vb));vb=ea(ea(L*ub)-ea(O*ob));do if(!(+ea(S(ea(Aa)))>1.0e-06)){if(+ea(S(ea(lb)))>1.0e-06)break;if(!(+ea(S(ea(vb)))>1.0e-06))break d}while(0);ob=ea(ea(vb*vb)+ea(ea(Aa*Aa)+ea(lb*lb)));if(ob>ea(0.0)){O=ea(ea(1.0)/ea(T(ea(ob))));_b=ea(vb*O);$b=ea(lb*O);ac=ea(Aa*O)}else{_b=ea(0.0);$b=ea(0.0);ac=ea(0.0)}g[C>>2]=ac;g[wa>>2]=$b;g[Ca>>2]=_b;bOa(z,C)|0}while(0)}while((Vb|0)!=(Tb|0))}Rb=Rb+12|0}while((Ob|0)!=0);if(!Nb)break;else Mb=Mb+4|0}Mb=c[z>>2]|0;if(!Mb){bc=1;cc=ea(3402823469999999843913219.0e14);dc=zb;ec=Ab;fc=Bb;gc=D}else{qb=ea(g[h>>2]);tb=ea(g[q>>2]);mb=ea(qb*tb);La=ea(g[G>>2]);O=ea(qb*La);ob=ea(g[fa>>2]);ub=ea(qb*ob);qb=ea(g[H>>2]);L=ea(g[da>>2]);M=ea(qb*L);rb=ea(g[ca>>2]);wb=ea(qb*rb);Na=ea(g[ba>>2]);N=ea(mb+M);M=ea(O+wb);wb=ea(ub+ea(qb*Na));qb=ea(g[K>>2]);ub=ea(g[aa>>2]);O=ea(qb*ub);mb=ea(g[$>>2]);Ma=ea(qb*mb);yb=ea(g[_>>2]);Kb=ea(N+O);O=ea(M+Ma);Ma=ea(wb+ea(qb*yb));qb=ea(g[Q>>2]);wb=ea(Kb+qb);Kb=ea(g[Ja>>2]);M=ea(O+Kb);O=ea(g[jb>>2]);N=ea(Ma+O);g[D>>2]=wb;g[D+4>>2]=M;g[D+8>>2]=N;Ma=ea(g[w>>2]);ta=ea(tb*Ma);sa=ea(La*Ma);Ka=ea(ob*Ma);Ma=ea(g[Oa>>2]);Ba=ea(ta+ea(L*Ma));ta=ea(sa+ea(rb*Ma));sa=ea(Ka+ea(Na*Ma));Ma=ea(g[ia>>2]);Ka=ea(qb+ea(Ba+ea(ub*Ma)));Ba=ea(Kb+ea(ta+ea(mb*Ma)));ta=ea(O+ea(sa+ea(yb*Ma)));g[D+12>>2]=Ka;g[D+16>>2]=Ba;g[D+20>>2]=ta;Ma=ea(g[ja>>2]);sa=ea(tb*Ma);tb=ea(La*Ma);La=ea(ob*Ma);Ma=ea(g[ha>>2]);ob=ea(sa+ea(L*Ma));sa=ea(tb+ea(rb*Ma));tb=ea(La+ea(Na*Ma));Ma=ea(g[ga>>2]);La=ea(qb+ea(ob+ea(ub*Ma)));ob=ea(Kb+ea(sa+ea(mb*Ma)));sa=ea(O+ea(tb+ea(yb*Ma)));g[D+24>>2]=La;g[D+28>>2]=ob;g[D+32>>2]=sa;Nb=b+4|0;Ca=b+8|0;wa=b+44|0;qa=b+48|0;oa=b+52|0;f=b+40|0;Db=Mb;Ma=L;L=rb;rb=Na;Na=ub;ub=mb;mb=yb;yb=wb;wb=ea(3402823469999999843913219.0e14);tb=Bb;O=Ab;Kb=zb;Mb=z+4|0;while(1){pa=Db+-1|0;Gb=Mb+12|0;qb=ea(g[Mb>>2]);Fa=ea(qb*ea(g[q>>2]));ma=ea(qb*ea(g[G>>2]));va=ea(qb*ea(g[fa>>2]));J=Mb+4|0;qb=ea(g[J>>2]);Ib=ea(Fa+ea(qb*Ma));Fa=ea(ma+ea(qb*L));ma=ea(va+ea(qb*rb));pb=Mb+8|0;qb=ea(g[pb>>2]);va=ea(Ib+ea(qb*Na));Ib=ea(Fa+ea(qb*ub));Fa=ea(ma+ea(qb*mb));qb=ea(ea(ea(yb*va)+ea(Ib*M))+ea(Fa*N));ma=ea(ea(ea(va*Ka)+ea(Ib*Ba))+ea(Fa*ta));Hb=qb<ma?qb:ma;Fb=qb>ma?qb:ma;ma=ea(ea(ea(va*La)+ea(Ib*ob))+ea(Fa*sa));qb=ea(va*ea(g[b>>2]));Eb=ea(qb+ea(Ib*ea(g[Nb>>2])));qb=ea(Eb+ea(Fa*ea(g[Ca>>2])));kb=c[wa>>2]|(g[k>>2]=va,c[k>>2]|0)&-2147483648;Ob=c[qa>>2]|(g[k>>2]=Ib,c[k>>2]|0)&-2147483648;Rb=c[oa>>2]|(g[k>>2]=Fa,c[k>>2]|0)&-2147483648;Eb=ea(va*(c[k>>2]=kb,ea(g[k>>2])));va=ea(Eb+ea(Ib*(c[k>>2]=Ob,ea(g[k>>2]))));Ib=ea(va+ea(Fa*(c[k>>2]=Rb,ea(g[k>>2]))));Fa=ea(g[f>>2]);va=Ib>Fa?Ib:Fa;Fa=ea(ea(qb+va)-(Hb<ma?Hb:ma));Hb=ea((Fb>ma?Fb:ma)-ea(qb-va));if(!((Fa<Hb?Fa:Hb)>wb)){rn[c[E>>2]&127](b,Mb,p,r,A,B);Hb=ea(g[h>>2]);Fa=ea(g[Mb>>2]);va=ea(Hb*Fa);Hb=ea(g[H>>2]);qb=ea(g[J>>2]);ma=ea(va+ea(Hb*qb));Hb=ea(g[K>>2]);va=ea(g[pb>>2]);Fb=ea(ma+ea(Hb*va));Hb=ea(Fa*ea(g[w>>2]));ma=ea(Hb+ea(qb*ea(g[Oa>>2])));Hb=ea(ma+ea(va*ea(g[ia>>2])));ma=Fb<Hb?Fb:Hb;Ib=Fb>Hb?Fb:Hb;Hb=ea(Fa*ea(g[ja>>2]));Fa=ea(Hb+ea(qb*ea(g[ha>>2])));qb=ea(Fa+ea(va*ea(g[ga>>2])));va=ma<qb?ma:qb;ma=Ib>qb?Ib:qb;qb=ea(g[B>>2]);if(ea(qb+s)<va){bc=0;cc=wb;dc=Kb;ec=O;fc=tb;gc=D;break c}Ib=ea(ma+s);Fa=ea(g[A>>2]);if(Ib<Fa){bc=0;cc=wb;dc=Kb;ec=O;fc=tb;gc=D;break c}Ib=ea(qb-va);va=ea(ma-Fa);Fa=Ib<va?Ib:va;if(Fa<wb){va=ea(g[Mb>>2]);Ib=ea(g[J>>2]);hc=ea(g[pb>>2]);ic=Ib;jc=va;kc=Fa}else{hc=tb;ic=O;jc=Kb;kc=wb}}else{hc=tb;ic=O;jc=Kb;kc=wb}if(!pa){bc=1;cc=kc;dc=jc;ec=ic;fc=hc;gc=D;break c}Fa=ea(g[D>>2]);va=ea(g[da>>2]);Ib=ea(g[ca>>2]);ma=ea(g[ba>>2]);qb=ea(g[aa>>2]);Hb=ea(g[$>>2]);Db=pa;Ma=va;L=Ib;rb=ma;Na=qb;ub=Hb;mb=ea(g[_>>2]);yb=Fa;wb=kc;tb=hc;O=ic;Kb=jc;Mb=Gb}}}else Qa=72;while(0);if((Qa|0)==72){bc=1;cc=ea(3402823469999999843913219.0e14);dc=zb;ec=Ab;fc=Bb;gc=D}if(!bc){Da=0;i=x;return Da|0}if(!(cc<ea(g[u>>2]))){Da=1;i=x;return Da|0}g[u>>2]=cc;cc=ea(dc*ea(g[o>>2]));Bb=ea(dc*ea(g[o+4>>2]));Ab=ea(dc*ea(g[o+8>>2]));dc=ea(ec*ea(g[o+12>>2]));zb=ea(ec*ea(g[o+16>>2]));jc=ea(cc+dc);dc=ea(Bb+zb);zb=ea(Ab+ea(ec*ea(g[o+20>>2])));ec=ea(fc*ea(g[o+24>>2]));Ab=ea(fc*ea(g[o+28>>2]));Bb=ea(dc+Ab);Ab=ea(zb+ea(fc*ea(g[o+32>>2])));g[t>>2]=ea(jc+ec);g[Pa>>2]=Bb;g[xb>>2]=Ab;a[v>>0]=0;Da=1;i=x;return Da|0}function A6a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=b+1280|0;g=c[f>>2]|0;if((g|0)==128){h=0;i=e;return h|0}j=c[d>>2]|0;k=c[d+4>>2]|0;l=j<<16|k;m=l+~(l<<15)|0;l=(m>>>10^m)*9|0;m=l>>>6^l;l=m+~(m<<11)|0;m=b+((l>>>16^l)&127)+1152|0;l=a[m>>0]|0;n=l<<24>>24==-1;if(!n){o=l&255;p=l;while(1){if((c[b+(o<<3)>>2]|0)==(j|0)?(c[b+(o<<3)+4>>2]|0)==(k|0):0){h=0;q=12;break}l=a[b+o+1024>>0]|0;if(l<<24>>24==-1)break;else{o=l&255;p=l}}if((q|0)==12){i=e;return h|0}o=g&255;if(n){r=o;q=9}else a[b+(p&255)+1024>>0]=o}else{r=g&255;q=9}if((q|0)==9)a[m>>0]=r;a[b+(c[f>>2]|0)+1024>>0]=-1;r=c[f>>2]|0;c[f>>2]=r+1;f=d;d=c[f+4>>2]|0;m=b+(r<<3)|0;c[m>>2]=c[f>>2];c[m+4>>2]=d;h=1;i=e;return h|0}function B6a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=0,B=Im,C=Im,D=0,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0;p=i;i=i+7808|0;q=p+7696|0;r=p+88|0;s=p+12|0;t=p+40|0;u=p+7744|0;v=p;w=p+72|0;x=p+4488|0;y=ea(g[f>>2]);z=ea(y+y);A=f+4|0;B=ea(g[A>>2]);C=ea(B+B);D=f+8|0;E=ea(g[D>>2]);F=ea(E+E);G=f+12|0;H=ea(g[G>>2]);I=ea(z*H);J=ea(C*H);K=ea(H*F);H=ea(y*z);z=ea(y*C);L=ea(y*F);y=ea(B*C);C=ea(B*F);B=ea(E*F);g[q>>2]=ea(ea(ea(1.0)-y)-B);g[q+4>>2]=ea(z+K);g[q+8>>2]=ea(L-J);g[q+12>>2]=ea(z-K);K=ea(ea(1.0)-H);g[q+16>>2]=ea(K-B);g[q+20>>2]=ea(C+I);g[q+24>>2]=ea(L+J);g[q+28>>2]=ea(C-I);g[q+32>>2]=ea(K-y);M=f+16|0;y=ea(g[M>>2]);g[q+36>>2]=y;N=f+20|0;K=ea(g[N>>2]);g[q+40>>2]=K;O=f+24|0;I=ea(g[O>>2]);g[q+44>>2]=I;C=ea(g[h>>2]);J=ea(C+C);P=h+4|0;L=ea(g[P>>2]);B=ea(L+L);Q=h+8|0;H=ea(g[Q>>2]);z=ea(H+H);R=h+12|0;F=ea(g[R>>2]);E=ea(J*F);S=ea(B*F);T=ea(F*z);U=ea(C*J);J=ea(C*B);V=ea(C*z);W=ea(L*B);B=ea(L*z);X=ea(H*z);g[r>>2]=ea(ea(ea(1.0)-W)-X);g[r+4>>2]=ea(J+T);g[r+8>>2]=ea(V-S);g[r+12>>2]=ea(J-T);T=ea(ea(1.0)-U);g[r+16>>2]=ea(T-X);g[r+20>>2]=ea(B+E);g[r+24>>2]=ea(V+S);g[r+28>>2]=ea(B-E);g[r+32>>2]=ea(T-W);W=ea(g[h+16>>2]);g[r+36>>2]=W;T=ea(g[h+20>>2]);g[r+40>>2]=T;E=ea(g[h+24>>2]);g[r+44>>2]=E;B=ea(-C);C=ea(-L);L=ea(-H);H=ea(ea(y-W)*ea(2.0));y=ea(ea(K-T)*ea(2.0));K=ea(ea(I-E)*ea(2.0));I=ea(ea(F*F)+ea(-.5));S=ea(ea(ea(H*B)+ea(y*C))+ea(K*L));V=ea(ea(S*B)+ea(ea(I*H)+ea(F*ea(ea(K*C)-ea(y*L)))));X=ea(ea(S*C)+ea(ea(I*y)+ea(F*ea(ea(H*L)-ea(K*B)))));U=ea(ea(ea(I*K)+ea(F*ea(ea(y*B)-ea(H*C))))+ea(S*L));S=ea(g[f>>2]);H=ea(F*S);y=ea(g[G>>2]);K=ea(H+ea(y*B));H=ea(g[D>>2]);I=ea(K+ea(H*C));K=ea(g[A>>2]);J=ea(ea(ea(S*L)+ea(ea(y*C)+ea(F*K)))-ea(H*B));z=ea(ea(ea(K*B)+ea(ea(y*L)+ea(F*H)))-ea(S*C));Y=ea(ea(ea(ea(F*y)-ea(S*B))-ea(K*C))-ea(H*L));g[s>>2]=ea(I-ea(K*L));g[s+4>>2]=J;g[s+8>>2]=z;g[s+12>>2]=Y;g[s+16>>2]=V;g[s+20>>2]=X;g[s+24>>2]=U;U=ea(-S);S=ea(-K);K=ea(-H);H=ea(W-ea(g[M>>2]));W=ea(T-ea(g[N>>2]));T=ea(H*ea(2.0));H=ea(W*ea(2.0));W=ea(ea(E-ea(g[O>>2]))*ea(2.0));E=ea(ea(y*y)+ea(-.5));X=ea(ea(ea(T*U)+ea(H*S))+ea(W*K));V=ea(ea(X*U)+ea(ea(E*T)+ea(y*ea(ea(W*S)-ea(H*K)))));Y=ea(ea(X*S)+ea(ea(E*H)+ea(y*ea(ea(T*K)-ea(W*U)))));z=ea(ea(ea(E*W)+ea(y*ea(ea(H*U)-ea(T*S))))+ea(X*K));X=ea(g[h>>2]);T=ea(y*X);H=ea(g[R>>2]);W=ea(T+ea(H*U));T=ea(g[Q>>2]);E=ea(W+ea(T*S));W=ea(g[P>>2]);J=ea(ea(ea(X*K)+ea(ea(H*S)+ea(y*W)))-ea(T*U));L=ea(ea(ea(W*U)+ea(ea(H*K)+ea(y*T)))-ea(X*S));I=ea(ea(ea(ea(y*H)-ea(X*U))-ea(W*S))-ea(T*K));g[t>>2]=ea(E-ea(W*K));g[t+4>>2]=J;g[t+8>>2]=L;g[t+12>>2]=I;g[t+16>>2]=V;g[t+20>>2]=Y;g[t+24>>2]=z;zOa(u,d,j,f,q,r,m,o);d=c[e+40>>2]|0;c[v>>2]=c[d+16>>2];c[v+4>>2]=d+32;g[v+8>>2]=ea(g[d+20>>2]);aLa(w);fLa(w,1088,p+136|0,1);e=c[d+152>>2]|0;z=ea(g[k+4100>>2]);c[x+4>>2]=2;c[x>>2]=539560;P=x+856|0;c[P>>2]=0;Q=x+860|0;PNa(Q,w,s,t,b,q,r,l,j,n,z,f,h,k);c[x+3084>>2]=m;c[x+3088>>2]=e;a[x+3092>>0]=o&1;c[x+3096>>2]=d;ZPa(x+3100|0,u);vQa(u,0,v,x,1);v=c[P>>2]|0;if(!v){SNa(Q);Z=x+3080|0;_=a[Z>>0]|0;$=_<<24>>24!=0;dLa(w);i=p;return $|0}u=v;v=x+840|0;d=x+776|0;o=x+584|0;e=x+8|0;while(1){u=u+-1|0;RNa(Q,e,c[d>>2]|0,a[v>>0]|0,o)|0;if(!u)break;else{v=v+1|0;d=d+4|0;o=o+12|0;e=e+36|0}}c[P>>2]=0;SNa(Q);Z=x+3080|0;_=a[Z>>0]|0;$=_<<24>>24!=0;dLa(w);i=p;return $|0}function C6a(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im;n=i;i=i+6800|0;o=n+6752|0;p=n+2328|0;q=n+16|0;r=n+64|0;s=n+6772|0;t=n;u=n+96|0;v=n+6728|0;c[o+12>>2]=c[e+4>>2];c[o+16>>2]=e;g[o+4>>2]=ea(ea(1.0)/ea(g[e+8>>2]));g[o>>2]=ea(ea(1.0)/ea(g[e+12>>2]));g[o+8>>2]=ea(ea(1.0)/ea(g[e+16>>2]));w=ea(g[f>>2]);x=ea(w+w);e=f+4|0;y=ea(g[e>>2]);z=ea(y+y);A=f+8|0;B=ea(g[A>>2]);C=ea(B+B);D=f+12|0;E=ea(g[D>>2]);F=ea(x*E);G=ea(z*E);H=ea(E*C);E=ea(w*x);x=ea(w*z);I=ea(w*C);w=ea(y*z);z=ea(y*C);y=ea(B*C);g[p>>2]=ea(ea(ea(1.0)-w)-y);g[p+4>>2]=ea(x+H);g[p+8>>2]=ea(I-G);g[p+12>>2]=ea(x-H);H=ea(ea(1.0)-E);g[p+16>>2]=ea(H-y);g[p+20>>2]=ea(z+F);g[p+24>>2]=ea(I+G);g[p+28>>2]=ea(z-F);g[p+32>>2]=ea(H-w);J=f+16|0;w=ea(g[J>>2]);g[p+36>>2]=w;K=f+20|0;H=ea(g[K>>2]);g[p+40>>2]=H;L=f+24|0;F=ea(g[L>>2]);g[p+44>>2]=F;z=ea(g[h>>2]);G=ea(z+z);M=h+4|0;I=ea(g[M>>2]);y=ea(I+I);N=h+8|0;E=ea(g[N>>2]);x=ea(E+E);O=h+12|0;C=ea(g[O>>2]);B=ea(G*C);P=ea(y*C);Q=ea(C*x);R=ea(z*G);G=ea(z*y);S=ea(z*x);T=ea(I*y);y=ea(I*x);U=ea(E*x);g[q>>2]=ea(ea(ea(1.0)-T)-U);g[q+4>>2]=ea(G+Q);g[q+8>>2]=ea(S-P);g[q+12>>2]=ea(G-Q);Q=ea(ea(1.0)-R);g[q+16>>2]=ea(Q-U);g[q+20>>2]=ea(y+B);g[q+24>>2]=ea(S+P);g[q+28>>2]=ea(y-B);g[q+32>>2]=ea(Q-T);T=ea(g[h+16>>2]);g[q+36>>2]=T;Q=ea(g[h+20>>2]);g[q+40>>2]=Q;B=ea(g[h+24>>2]);g[q+44>>2]=B;y=ea(-z);z=ea(-I);I=ea(-E);E=ea(ea(w-T)*ea(2.0));w=ea(ea(H-Q)*ea(2.0));H=ea(ea(F-B)*ea(2.0));F=ea(ea(C*C)+ea(-.5));P=ea(ea(ea(E*y)+ea(w*z))+ea(H*I));S=ea(ea(P*y)+ea(ea(F*E)+ea(C*ea(ea(H*z)-ea(w*I)))));U=ea(ea(P*z)+ea(ea(F*w)+ea(C*ea(ea(E*I)-ea(H*y)))));R=ea(ea(ea(F*H)+ea(C*ea(ea(w*y)-ea(E*z))))+ea(P*I));P=ea(g[f>>2]);E=ea(C*P);w=ea(g[D>>2]);H=ea(E+ea(w*y));E=ea(g[A>>2]);F=ea(H+ea(E*z));H=ea(g[e>>2]);G=ea(ea(ea(P*I)+ea(ea(w*z)+ea(C*H)))-ea(E*y));x=ea(ea(ea(H*y)+ea(ea(w*I)+ea(C*E)))-ea(P*z));V=ea(ea(ea(ea(C*w)-ea(P*y))-ea(H*z))-ea(E*I));g[r>>2]=ea(F-ea(H*I));g[r+4>>2]=G;g[r+8>>2]=x;g[r+12>>2]=V;g[r+16>>2]=S;g[r+20>>2]=U;g[r+24>>2]=R;R=ea(-P);P=ea(-H);H=ea(-E);E=ea(T-ea(g[J>>2]));T=ea(Q-ea(g[K>>2]));Q=ea(E*ea(2.0));E=ea(T*ea(2.0));T=ea(ea(B-ea(g[L>>2]))*ea(2.0));B=ea(ea(w*w)+ea(-.5));U=ea(ea(ea(Q*R)+ea(E*P))+ea(T*H));S=ea(ea(U*R)+ea(ea(B*Q)+ea(w*ea(ea(T*P)-ea(E*H)))));V=ea(ea(U*P)+ea(ea(B*E)+ea(w*ea(ea(Q*H)-ea(T*R)))));x=ea(ea(ea(B*T)+ea(w*ea(ea(E*R)-ea(Q*P))))+ea(U*H));U=ea(g[h>>2]);Q=ea(w*U);E=ea(g[O>>2]);T=ea(Q+ea(E*R));Q=ea(g[N>>2]);B=ea(T+ea(Q*P));T=ea(g[M>>2]);G=ea(ea(ea(U*H)+ea(ea(E*P)+ea(w*T)))-ea(Q*R));I=ea(ea(ea(T*R)+ea(ea(E*H)+ea(w*Q)))-ea(U*P));F=ea(ea(ea(ea(w*E)-ea(U*R))-ea(T*P))-ea(Q*H));g[s>>2]=ea(B-ea(T*H));g[s+4>>2]=G;g[s+8>>2]=I;g[s+12>>2]=F;g[s+16>>2]=S;g[s+20>>2]=V;g[s+24>>2]=x;aLa(t);fLa(t,1088,n+2376|0,1);x=ea(g[k+4100>>2]);c[u>>2]=539536;M=u+4|0;PNa(M,t,r,s,b,p,q,l,j,m,x,f,h,k);c[u+2228>>2]=o;e_a(v,r,d);KRa(o,h,v,0,u)|0;SNa(M);M=(a[u+2224>>0]|0)!=0;dLa(t);i=n;return M|0}function D6a(a,b,c,e,f,h,j,k,l){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0;m=i;n=(h|0)==0;if(n){o=ea(-3402823469999999843913219.0e14);p=ea(-3402823469999999843913219.0e14);q=ea(3402823469999999843913219.0e14);r=ea(3402823469999999843913219.0e14)}else{s=l+4|0;t=l+8|0;u=l+12|0;v=l+16|0;w=l+20|0;x=0;y=ea(-3402823469999999843913219.0e14);z=ea(-3402823469999999843913219.0e14);A=ea(3402823469999999843913219.0e14);B=ea(3402823469999999843913219.0e14);while(1){C=d[k+x>>0]|0;D=ea(g[l>>2]);E=ea(g[j+(C*12|0)>>2]);F=ea(D*E);D=ea(g[s>>2]);G=ea(g[j+(C*12|0)+4>>2]);H=ea(F+ea(D*G));D=ea(g[t>>2]);F=ea(g[j+(C*12|0)+8>>2]);I=ea(H+ea(D*F));D=ea(E*ea(g[u>>2]));E=ea(D+ea(G*ea(g[v>>2])));G=ea(E+ea(F*ea(g[w>>2])));F=A<I?A:I;E=B<G?B:G;D=y>I?y:I;H=z>G?z:G;C=x<<1;g[f+(C<<2)>>2]=I;g[f+((C|1)<<2)>>2]=G;x=x+1|0;if((x|0)==(h|0)){o=D;p=H;q=F;r=E;break}else{y=D;z=H;A=F;B=E}}}B=ea(ea(o+q)*ea(.5));A=ea(ea(p+r)*ea(.5));z=ea(q+ea(-9.99999997e-07));q=ea(r+ea(-9.99999997e-07));r=ea(o+ea(9.99999997e-07));o=ea(p+ea(9.99999997e-07));if(n){J=ea(r-z);K=ea(o-q);g[a>>2]=z;g[b>>2]=q;g[c>>2]=J;g[e>>2]=K;i=m;return}else L=0;do{n=L<<1;x=f+(n<<2)|0;p=ea(g[x>>2]);w=f+((n|1)<<2)|0;y=ea(g[w>>2]);E=ea(y-A);F=ea(p-z);n=ea(p-B)>=ea(0.0);g[x>>2]=ea(F+(n?ea(9.99999997e-07):ea(-9.99999997e-07)));F=ea(y-q);n=E>=ea(0.0);g[w>>2]=ea(F+(n?ea(9.99999997e-07):ea(-9.99999997e-07)));L=L+1|0}while((L|0)!=(h|0));J=ea(r-z);K=ea(o-q);g[a>>2]=z;g[b>>2]=q;g[c>>2]=J;g[e>>2]=K;i=m;return}function E6a(b,d,e,f,h,j,l){b=b|0;d=d|0;e=ea(e);f=ea(f);h=ea(h);j=ea(j);l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0;m=i;n=(g[k>>2]=f,c[k>>2]|0);o=e<ea(0.0);p=o?2:0;o=f<ea(0.0);q=(o?p|8:p)|e>h;p=f>j?q|4:q;a[l>>0]=p;if(p){r=0;i=m;return r|0}if((d|0)==3){j=ea(g[b>>2]);h=ea(g[b+4>>2]);s=ea(ea(g[b+8>>2])-j);t=ea(ea(g[b+12>>2])-h);u=ea(ea(g[b+16>>2])-j);v=ea(ea(g[b+20>>2])-h);w=ea(ea(s*s)+ea(t*t));x=ea(ea(s*u)+ea(t*v));y=ea(ea(u*u)+ea(v*v));z=ea(e-j);j=ea(f-h);h=ea(ea(z*s)+ea(j*t));t=ea(ea(z*u)+ea(j*v));v=ea(ea(h*y)-ea(t*x));j=ea(ea(w*t)-ea(h*x));r=v>ea(0.0)&j>ea(0.0)&ea(ea(v+j)-ea(ea(w*y)-ea(x*x)))<ea(0.0);i=m;return r|0}p=d<<1;a:do if(!d)A=0;else{l=d;q=0;o=b+(p+-2<<2)|0;B=b;C=(c[b+(p+-1<<2)>>2]|0)>=(n|0)&1;while(1){l=l+-1|0;D=c[B+4>>2]|0;E=(D|0)>=(n|0);F=C;C=E&1;x=(c[k>>2]=D,ea(g[k>>2]));if((F|0)!=(C|0)?(y=ea(x-f),w=ea(g[o>>2]),j=ea(g[B>>2]),v=ea(y*ea(w-j)),w=ea(j-e),!(v>ea(w*ea(ea(g[o+4>>2])-x))^E)):0){if((q|0)==1){r=0;break}G=q+1|0}else G=q;if(!l){A=G;break a}else{E=B;q=G;B=B+8|0;o=E}}i=m;return r|0}while(0);r=(A&1|0)!=0;i=m;return r|0}function F6a(a,b,e,f,h,j){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0;k=i;i=i+160|0;l=k+64|0;m=k+32|0;n=k;o=a+4096|0;p=c[o>>2]|0;q=p-b|0;if(q>>>0<5){i=k;return}if((q|0)==(e|0)){if(e>>>0>1){r=0;s=ea(g[a+(b<<6)+12>>2]);t=1;while(1){u=ea(g[a+(t+b<<6)+12>>2]);v=s>u;w=v?t:r;t=t+1|0;if((t|0)==(e|0)){x=w;break}else{r=w;s=v?u:s}}}else x=0;r=e<<14&1073725440;e=0;t=0;v=1;while(1){w=t>>>16;y=e+b|0;z=w+b|0;g[a+(y<<6)>>2]=ea(g[a+(z<<6)>>2]);g[a+(y<<6)+4>>2]=ea(g[a+(z<<6)+4>>2]);g[a+(y<<6)+8>>2]=ea(g[a+(z<<6)+8>>2]);g[a+(y<<6)+12>>2]=ea(g[a+(z<<6)+12>>2]);g[a+(y<<6)+16>>2]=ea(g[a+(z<<6)+16>>2]);g[a+(y<<6)+20>>2]=ea(g[a+(z<<6)+20>>2]);g[a+(y<<6)+24>>2]=ea(g[a+(z<<6)+24>>2]);g[a+(y<<6)+28>>2]=ea(g[a+(z<<6)+28>>2]);g[a+(y<<6)+32>>2]=ea(g[a+(z<<6)+32>>2]);g[a+(y<<6)+36>>2]=ea(g[a+(z<<6)+36>>2]);g[a+(y<<6)+40>>2]=ea(g[a+(z<<6)+40>>2]);A=a+(y<<6)+44|0;y=a+(z<<6)+44|0;c[A+0>>2]=c[y+0>>2];c[A+4>>2]=c[y+4>>2];c[A+8>>2]=c[y+8>>2];c[A+12>>2]=c[y+12>>2];c[A+16>>2]=c[y+16>>2];v=v&(w|0)!=(x|0);e=e+1|0;if((e|0)==4)break;else t=t+r|0}r=b+4|0;if(v){v=x+b|0;g[a+(r<<6)>>2]=ea(g[a+(v<<6)>>2]);g[a+(r<<6)+4>>2]=ea(g[a+(v<<6)+4>>2]);g[a+(r<<6)+8>>2]=ea(g[a+(v<<6)+8>>2]);g[a+(r<<6)+12>>2]=ea(g[a+(v<<6)+12>>2]);g[a+(r<<6)+16>>2]=ea(g[a+(v<<6)+16>>2]);g[a+(r<<6)+20>>2]=ea(g[a+(v<<6)+20>>2]);g[a+(r<<6)+24>>2]=ea(g[a+(v<<6)+24>>2]);g[a+(r<<6)+28>>2]=ea(g[a+(v<<6)+28>>2]);g[a+(r<<6)+32>>2]=ea(g[a+(v<<6)+32>>2]);g[a+(r<<6)+36>>2]=ea(g[a+(v<<6)+36>>2]);g[a+(r<<6)+40>>2]=ea(g[a+(v<<6)+40>>2]);x=a+(r<<6)+44|0;t=a+(v<<6)+44|0;c[x+0>>2]=c[t+0>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];c[x+12>>2]=c[t+12>>2];c[x+16>>2]=c[t+16>>2];c[o>>2]=b+5;i=k;return}else{c[o>>2]=r;i=k;return}}g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(.923879504);g[l+16>>2]=ea(.382683456);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(.707106769);g[l+28>>2]=ea(.707106769);g[l+32>>2]=ea(0.0);g[l+36>>2]=ea(.382683426);g[l+40>>2]=ea(.923879504);g[l+44>>2]=ea(0.0);g[l+48>>2]=ea(-4.37113883e-08);g[l+52>>2]=ea(1.0);g[l+56>>2]=ea(0.0);g[l+60>>2]=ea(-.382683516);g[l+64>>2]=ea(.923879504);g[l+68>>2]=ea(0.0);g[l+72>>2]=ea(-.707106769);g[l+76>>2]=ea(.707106769);g[l+80>>2]=ea(0.0);g[l+84>>2]=ea(-.923879504);g[l+88>>2]=ea(.382683486);g[l+92>>2]=ea(0.0);g[m>>2]=ea(3402823469999999843913219.0e14);g[n>>2]=ea(-3402823469999999843913219.0e14);r=m+4|0;g[r>>2]=ea(3402823469999999843913219.0e14);t=n+4|0;g[t>>2]=ea(-3402823469999999843913219.0e14);x=m+8|0;g[x>>2]=ea(3402823469999999843913219.0e14);v=n+8|0;g[v>>2]=ea(-3402823469999999843913219.0e14);e=m+12|0;g[e>>2]=ea(3402823469999999843913219.0e14);w=n+12|0;g[w>>2]=ea(-3402823469999999843913219.0e14);y=m+16|0;g[y>>2]=ea(3402823469999999843913219.0e14);A=n+16|0;g[A>>2]=ea(-3402823469999999843913219.0e14);z=m+20|0;g[z>>2]=ea(3402823469999999843913219.0e14);B=n+20|0;g[B>>2]=ea(-3402823469999999843913219.0e14);C=m+24|0;g[C>>2]=ea(3402823469999999843913219.0e14);D=n+24|0;g[D>>2]=ea(-3402823469999999843913219.0e14);E=m+28|0;g[E>>2]=ea(3402823469999999843913219.0e14);F=n+28|0;g[F>>2]=ea(-3402823469999999843913219.0e14);G=(p|0)==(b|0);if(G){H=ea(-3402823469999999843913219.0e14);I=ea(3402823469999999843913219.0e14);J=ea(-3402823469999999843913219.0e14);K=ea(3402823469999999843913219.0e14);L=ea(-3402823469999999843913219.0e14);M=ea(3402823469999999843913219.0e14);N=ea(-3402823469999999843913219.0e14);O=ea(3402823469999999843913219.0e14);P=ea(-3402823469999999843913219.0e14);Q=ea(3402823469999999843913219.0e14);R=ea(-3402823469999999843913219.0e14);S=ea(3402823469999999843913219.0e14);T=ea(-3402823469999999843913219.0e14);U=ea(3402823469999999843913219.0e14);V=ea(-3402823469999999843913219.0e14);W=ea(3402823469999999843913219.0e14)}else{s=ea(g[f>>2]);u=ea(g[f+4>>2]);X=ea(g[f+12>>2]);Y=ea(g[f+16>>2]);Z=ea(g[f+24>>2]);_=ea(g[f+28>>2]);p=0;do{$=d[j+p>>0]|0;aa=ea(g[h+($*12|0)>>2]);ba=ea(aa*s);ca=ea(aa*u);aa=ea(g[h+($*12|0)+4>>2]);da=ea(ba+ea(aa*X));ba=ea(ca+ea(aa*Y));aa=ea(g[h+($*12|0)+8>>2]);ca=ea(da+ea(aa*Z));da=ea(ba+ea(aa*_));$=0;do{aa=ea(g[l+($*12|0)>>2]);ba=ea(ea(ca*aa)+ea(da*ea(g[l+($*12|0)+4>>2])));fa=m+($<<2)|0;aa=ea(g[fa>>2]);g[fa>>2]=aa<ba?aa:ba;fa=n+($<<2)|0;aa=ea(g[fa>>2]);g[fa>>2]=aa>ba?aa:ba;$=$+1|0}while(($|0)!=8);p=p+1|0}while((p|0)!=(q|0));_=ea(g[n>>2]);Z=ea(g[m>>2]);Y=ea(g[t>>2]);X=ea(g[r>>2]);u=ea(g[v>>2]);s=ea(g[x>>2]);da=ea(g[w>>2]);ca=ea(g[e>>2]);ba=ea(g[A>>2]);aa=ea(g[y>>2]);ga=ea(g[B>>2]);ha=ea(g[z>>2]);ia=ea(g[D>>2]);ja=ea(g[C>>2]);ka=ea(g[F>>2]);H=_;I=Z;J=Y;K=X;L=u;M=s;N=da;O=ca;P=ba;Q=aa;R=ga;S=ha;T=ia;U=ja;V=ka;W=ea(g[E>>2])}ka=ea(H-I);I=ea(J-K);E=I>ka;K=E?I:ka;ka=ea(L-M);F=ka>K;M=F?ka:K;K=ea(N-O);C=K>M;O=C?K:M;M=ea(P-Q);D=M>O;Q=D?M:O;O=ea(R-S);z=O>Q;S=z?O:Q;Q=ea(T-U);B=Q>S;y=ea(V-W)>(B?Q:S);A=y?7:B?6:z?5:D?4:C?3:F?2:E&1;S=ea(g[l+(A*12|0)>>2]);Q=ea(g[l+(A*12|0)+4>>2]);if(G){la=0;ma=0;na=0;oa=0}else{W=ea(g[f>>2]);V=ea(g[f+4>>2]);U=ea(g[f+12>>2]);T=ea(g[f+16>>2]);O=ea(g[f+24>>2]);R=ea(g[f+28>>2]);M=ea(-3402823469999999843913219.0e14);P=ea(-3402823469999999843913219.0e14);K=ea(3402823469999999843913219.0e14);N=ea(3402823469999999843913219.0e14);f=0;A=0;l=0;E=0;F=0;while(1){C=d[j+f>>0]|0;ka=ea(g[h+(C*12|0)>>2]);L=ea(ka*W);I=ea(ka*V);ka=ea(g[h+(C*12|0)+4>>2]);J=ea(L+ea(ka*U));L=ea(I+ea(ka*T));ka=ea(g[h+(C*12|0)+8>>2]);I=ea(J+ea(ka*O));J=ea(L+ea(ka*R));ka=ea(ea(S*I)+ea(Q*J));L=ea(ea(S*J)-ea(Q*I));C=ka<K;D=C?f:E;z=ka>M;B=z?f:A;y=L<N;e=y?f:F;w=L>P;x=w?f:l;f=f+1|0;if((f|0)==(q|0)){la=B;ma=x;na=D;oa=e;break}else{M=z?ka:M;P=w?L:P;K=C?ka:K;N=y?L:N;A=B;l=x;E=D;F=e}}}F=(la|0)==(na|0)?-1:la;la=(oa|0)==(na|0)|(oa|0)==(F|0)?-1:oa;oa=(ma|0)==(na|0)|(ma|0)==(F|0)|(ma|0)==(la|0)?-1:ma;if(G)pa=0;else{G=0;ma=0;while(1){if((G|0)==(na|0)|(G|0)==(F|0)|(G|0)==(la|0)|(G|0)==(oa|0)){E=ma+b|0;l=G+b|0;g[a+(E<<6)>>2]=ea(g[a+(l<<6)>>2]);g[a+(E<<6)+4>>2]=ea(g[a+(l<<6)+4>>2]);g[a+(E<<6)+8>>2]=ea(g[a+(l<<6)+8>>2]);g[a+(E<<6)+12>>2]=ea(g[a+(l<<6)+12>>2]);g[a+(E<<6)+16>>2]=ea(g[a+(l<<6)+16>>2]);g[a+(E<<6)+20>>2]=ea(g[a+(l<<6)+20>>2]);g[a+(E<<6)+24>>2]=ea(g[a+(l<<6)+24>>2]);g[a+(E<<6)+28>>2]=ea(g[a+(l<<6)+28>>2]);g[a+(E<<6)+32>>2]=ea(g[a+(l<<6)+32>>2]);g[a+(E<<6)+36>>2]=ea(g[a+(l<<6)+36>>2]);g[a+(E<<6)+40>>2]=ea(g[a+(l<<6)+40>>2]);A=a+(E<<6)+44|0;E=a+(l<<6)+44|0;c[A+0>>2]=c[E+0>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];c[A+16>>2]=c[E+16>>2];qa=ma+1|0}else qa=ma;G=G+1|0;if((G|0)==(q|0)){pa=qa;break}else ma=qa}}c[o>>2]=pa+b;i=k;return}function G6a(a,b,c,d,e,f,h,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);var o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0;o=i;p=ea(g[f>>2]);q=ea(g[b>>2]);r=ea(p*q);s=ea(g[f+4>>2]);t=ea(g[b+4>>2]);u=ea(r+ea(s*t));r=ea(g[f+8>>2]);v=ea(g[b+8>>2]);w=ea(u+ea(r*v));u=ea(g[b+12>>2]);x=ea(u+w);w=ea(g[h>>2]);y=ea(q*w);z=ea(g[h+4>>2]);A=ea(y+ea(t*z));y=ea(g[h+8>>2]);if(ea(x*ea(u+ea(A+ea(v*y))))>ea(0.0)){B=0;i=o;return B|0}A=ea(w-p);w=ea(z-s);z=ea(y-r);y=ea(ea(ea(A*q)+ea(w*t))+ea(z*v));if(y==ea(0.0)){B=0;i=o;return B|0}v=ea(x/y);y=ea(s-ea(w*v));w=ea(r-ea(z*v));g[k>>2]=ea(p-ea(A*v));h=k+4|0;g[h>>2]=y;b=k+8|0;g[b>>2]=w;w=ea(g[a+(l<<2)>>2]);y=ea(g[k+(m<<2)>>2]);v=ea(w*ea(y-ea(g[c+(m<<2)>>2])));y=ea(g[a+(m<<2)>>2]);w=ea(g[k+(l<<2)>>2]);A=ea(ea(v-ea(y*ea(w-ea(g[c+(l<<2)>>2]))))*n);g[j>>2]=A;if(A<ea(0.0)){B=0;i=o;return B|0}n=ea(g[e>>2]);w=ea(g[e+4>>2]);y=ea(A*n);n=ea(A*w);w=ea(A*ea(g[e+8>>2]));A=ea(ea(g[k>>2])-y);g[k>>2]=A;y=ea(ea(g[h>>2])-n);g[h>>2]=y;n=ea(ea(g[b>>2])-w);g[b>>2]=n;w=ea(ea(g[c>>2])-A);v=ea(w*ea(ea(g[d>>2])-A));A=ea(ea(g[c+4>>2])-y);w=ea(v+ea(A*ea(ea(g[d+4>>2])-y)));y=ea(ea(g[c+8>>2])-n);B=ea(w+ea(y*ea(ea(g[d+8>>2])-n)))<ea(0.0);i=o;return B|0}function H6a(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;e=i;i=i+80|0;f=e;h=e+32|0;j=e+52|0;k=e+12|0;l=e+64|0;m=e+68|0;n=e+28|0;o=e+48|0;p=e+44|0;q=e+16|0;r=ea(g[b+24>>2]);s=ea(r*r);t=b+28|0;u=c[t>>2]|0;v=d+848|0;if(!(c[v>>2]|0)){w=u;c[t>>2]=w;i=e;return}x=f+4|0;y=f+8|0;z=h+4|0;A=h+8|0;B=j+4|0;C=j+8|0;D=b+20|0;E=m+4|0;F=m+8|0;G=q+4|0;H=q+8|0;I=b+12|0;J=b+16|0;K=b+5280|0;L=b+5668|0;M=b+4|0;N=1;O=u;u=d+768|0;P=d+576|0;Q=d;while(1){d=u+4|0;R=c[u>>2]|0;g[f>>2]=ea(g[Q>>2]);g[x>>2]=ea(g[Q+4>>2]);g[y>>2]=ea(g[Q+8>>2]);g[h>>2]=ea(g[Q+12>>2]);g[z>>2]=ea(g[Q+16>>2]);g[A>>2]=ea(g[Q+20>>2]);S=Q+36|0;g[j>>2]=ea(g[Q+24>>2]);g[B>>2]=ea(g[Q+28>>2]);g[C>>2]=ea(g[Q+32>>2]);U=P+12|0;JOa(m,c[D>>2]|0,f,h,j,k,l);V=c[D>>2]|0;r=ea(g[m>>2]);W=ea(g[V>>2]);X=ea(r-W);r=ea(g[E>>2]);Y=ea(g[V+4>>2]);Z=ea(r-Y);r=ea(g[F>>2]);_=ea(g[V+8>>2]);$=ea(r-_);r=ea(ea(ea(X*X)+ea(Z*Z))+ea($*$));a:do if(r<s?($=ea(g[h>>2]),Z=ea(g[f>>2]),X=ea($-Z),$=ea(g[z>>2]),aa=ea(g[x>>2]),ba=ea($-aa),$=ea(g[A>>2]),ca=ea(g[y>>2]),da=ea($-ca),$=ea(ea(g[j>>2])-Z),fa=ea(ea(g[B>>2])-aa),ga=ea(ea(g[C>>2])-ca),ha=ea(ea(ba*ga)-ea(da*fa)),ia=ea(ea(da*$)-ea(X*ga)),ga=ea(ea(X*fa)-ea(ba*$)),!(ea(ea(_*ga)+ea(ea(W*ha)+ea(Y*ia)))<ea(ea(ca*ga)+ea(ea(Z*ha)+ea(aa*ia))))):0){aa=ea(ea(ga*ga)+ea(ea(ha*ha)+ea(ia*ia)));Z=ea(-ia);ca=ea(-ga);g[q>>2]=ea(-ha);g[G>>2]=Z;g[H>>2]=ca;if(VPa(V,q,f,h,j,n,o,p,ea(.0000999999974))|0?(ca=ea(g[n>>2]),ea(aa*ea(ca*ca))<s):0){ja=c[I>>2]|0;ka=c[D>>2]|0;Z=ea(ha*ca);$=ea(ia*ca);ba=ea(ga*ca);fa=ea(ea(g[ka>>2])-Z);Z=ea(ea(g[ka+4>>2])-$);$=ea(fa*ea(2.0));fa=ea(Z*ea(2.0));Z=ea(ea(ea(g[ka+8>>2])-ba)*ea(2.0));ba=ea(g[ja+12>>2]);X=ea(ea(ba*ba)+ea(-.5));da=ea(g[ja>>2]);la=ea($*da);ma=ea(g[ja+4>>2]);na=ea(la+ea(fa*ma));la=ea(g[ja+8>>2]);oa=ea(na+ea(Z*la));na=ea(T(ea(aa)));aa=ea(ea(1.0)/na);pa=ea(ha*ea(2.0));ha=ea(ia*ea(2.0));ia=ea(ga*ea(2.0));ga=ea(ea(ea(pa*da)+ea(ha*ma))+ea(ia*la));ka=c[J>>2]|0;qa=ka+4096|0;ra=c[qa>>2]|0;if(ra>>>0<=63){sa=ea(ea(ha*da)-ea(pa*ma));ta=ea(ea(pa*la)-ea(ia*da));ua=ea(ea(ia*ma)-ea(ha*la));va=ea(ea(fa*da)-ea($*ma));wa=ea(ea($*la)-ea(Z*da));xa=ea(ea(Z*ma)-ea(fa*la));ya=ea(la*ga);za=ea(ea(ia*X)+ea(ba*sa));sa=ea(ma*ga);ia=ea(ea(ha*X)+ea(ba*ta));ta=ea(da*ga);ga=ea(ea(pa*X)+ea(ba*ua));ua=ea(la*oa);la=ea(ea(Z*X)+ea(ba*va));va=ea(ma*oa);ma=ea(ea(fa*X)+ea(ba*wa));wa=ea(da*oa);oa=ea(ea($*X)+ea(ba*xa));xa=ea(g[(c[M>>2]|0)+4>>2]);ba=ea(ca*na);na=ea(za+ya);ya=ea(sa+ia);ia=ea(ta+ga);ga=ea(g[ja+24>>2]);ta=ea(g[ja+20>>2]);sa=ea(ba-xa);xa=ea(aa*na);na=ea(aa*ya);ya=ea(aa*ia);ia=ea(ea(la+ua)+ga);ga=ea(ea(va+ma)+ta);ta=ea(ea(wa+oa)+ea(g[ja+16>>2]));c[qa>>2]=ra+1;g[ka+(ra<<6)>>2]=ya;g[ka+(ra<<6)+4>>2]=na;g[ka+(ra<<6)+8>>2]=xa;g[ka+(ra<<6)+16>>2]=ta;g[ka+(ra<<6)+20>>2]=ga;g[ka+(ra<<6)+24>>2]=ia;g[ka+(ra<<6)+12>>2]=sa;c[ka+(ra<<6)+48>>2]=-1;c[ka+(ra<<6)+52>>2]=R}ra=c[P>>2]|0;ka=P+4|0;qa=c[ka>>2]|0;ja=P+8|0;Aa=c[ja>>2]|0;Ba=c[K>>2]|0;b:do if((Ba|0)==64)Ca=ra;else{Da=b+(R&63)+5216|0;Ea=a[Da>>0]|0;if(Ea<<24>>24==-1)a[Da>>0]=Ba;else{Da=Ea&255;Fa=Ea;while(1){if((c[b+(Da<<4)+4128>>2]|0)==(R|0)){Ca=ra;break b}Ea=a[b+Da+5152>>0]|0;if(Ea<<24>>24==-1)break;else{Da=Ea&255;Fa=Ea}}a[b+(Fa&255)+5152>>0]=Ba}a[b+(c[K>>2]|0)+5152>>0]=-1;Da=c[K>>2]|0;c[K>>2]=Da+1;c[b+(Da<<4)+4128>>2]=R;c[b+(Da<<4)+4132>>2]=ra;c[b+(Da<<4)+4136>>2]=qa;c[b+(Da<<4)+4140>>2]=Aa;Ca=c[P>>2]|0}while(0);Aa=c[L>>2]|0;if((Aa|0)==64){Ga=O;break}qa=b+(Ca&63)+5604|0;ra=a[qa>>0]|0;c:do if(ra<<24>>24==-1){a[qa>>0]=Aa;Ha=24}else{Ba=ra&255;Da=ra;while(1){if((c[b+(Ba<<2)+5284>>2]|0)==(Ca|0)){Ia=Aa;break c}Ea=a[b+Ba+5540>>0]|0;if(Ea<<24>>24==-1)break;else{Ba=Ea&255;Da=Ea}}a[b+(Da&255)+5540>>0]=Aa;Ha=24}while(0);if((Ha|0)==24){Ha=0;a[b+(c[L>>2]|0)+5540>>0]=-1;Aa=c[L>>2]|0;c[L>>2]=Aa+1;c[b+(Aa<<2)+5284>>2]=Ca;Ia=c[L>>2]|0}Aa=c[ka>>2]|0;if((Ia|0)==64){Ga=O;break}ra=b+(Aa&63)+5604|0;qa=a[ra>>0]|0;d:do if(qa<<24>>24==-1){a[ra>>0]=Ia;Ha=32}else{Ba=qa&255;Fa=qa;while(1){if((c[b+(Ba<<2)+5284>>2]|0)==(Aa|0)){Ja=Ia;break d}Ea=a[b+Ba+5540>>0]|0;if(Ea<<24>>24==-1)break;else{Ba=Ea&255;Fa=Ea}}a[b+(Fa&255)+5540>>0]=Ia;Ha=32}while(0);if((Ha|0)==32){Ha=0;a[b+(c[L>>2]|0)+5540>>0]=-1;qa=c[L>>2]|0;c[L>>2]=qa+1;c[b+(qa<<2)+5284>>2]=Aa;Ja=c[L>>2]|0}qa=c[ja>>2]|0;if((Ja|0)==64){Ga=O;break}ra=b+(qa&63)+5604|0;ka=a[ra>>0]|0;if(ka<<24>>24==-1)a[ra>>0]=Ja;else{ra=ka&255;Ba=ka;while(1){if((c[b+(ra<<2)+5284>>2]|0)==(qa|0)){Ga=O;break a}ka=a[b+ra+5540>>0]|0;if(ka<<24>>24==-1)break;else{ra=ka&255;Ba=ka}}a[b+(Ba&255)+5540>>0]=Ja}a[b+(c[L>>2]|0)+5540>>0]=-1;ra=c[L>>2]|0;c[L>>2]=ra+1;c[b+(ra<<2)+5284>>2]=qa;Ga=O;break}if(O>>>0<64){g[b+(O<<6)+32>>2]=ea(g[f>>2]);g[b+(O<<6)+36>>2]=ea(g[x>>2]);g[b+(O<<6)+40>>2]=ea(g[y>>2]);g[b+(O<<6)+44>>2]=ea(g[h>>2]);g[b+(O<<6)+48>>2]=ea(g[z>>2]);g[b+(O<<6)+52>>2]=ea(g[A>>2]);g[b+(O<<6)+56>>2]=ea(g[j>>2]);g[b+(O<<6)+60>>2]=ea(g[B>>2]);g[b+(O<<6)+64>>2]=ea(g[C>>2]);c[b+(O<<6)+84>>2]=c[P>>2];c[b+(O<<6)+88>>2]=c[P+4>>2];c[b+(O<<6)+92>>2]=c[P+8>>2];g[b+(O<<6)+68>>2]=ea(g[k>>2]);g[b+(O<<6)+72>>2]=ea(g[l>>2]);g[b+(O<<6)+76>>2]=r;c[b+(O<<6)+80>>2]=R;Ga=O+1|0}else Ga=O}else Ga=O;while(0);if(N>>>0>=(c[v>>2]|0)>>>0){w=Ga;break}N=N+1|0;O=Ga;u=d;P=U;Q=S}c[t>>2]=w;i=e;return}function I6a(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=Im,P=Im,Q=Im,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im;d=i;e=c[b+28>>2]|0;if(!e){i=d;return}f=b+16|0;h=c[f>>2]|0;j=c[h+4096>>2]|0;k=b+4|0;l=b+12|0;m=b+8|0;n=(j|0)==0;o=0;do{p=c[b+(o<<6)+80>>2]|0;q=c[b+(o<<6)+84>>2]|0;r=c[b+(o<<6)+88>>2]|0;s=c[b+(o<<6)+92>>2]|0;t=b+(o<<6)+68|0;u=ea(g[t>>2]);v=b+(o<<6)+72|0;w=$Na(u,ea(g[v>>2]))|0;u=ea(g[b+(o<<6)+44>>2]);x=ea(g[b+(o<<6)+32>>2]);y=ea(u-x);z=ea(g[b+(o<<6)+48>>2]);A=ea(g[b+(o<<6)+36>>2]);B=ea(z-A);C=ea(g[b+(o<<6)+52>>2]);D=ea(g[b+(o<<6)+40>>2]);E=ea(C-D);F=ea(g[b+(o<<6)+56>>2]);G=ea(F-x);H=ea(g[b+(o<<6)+60>>2]);I=ea(H-A);J=ea(g[b+(o<<6)+64>>2]);K=ea(J-D);L=ea(ea(B*K)-ea(E*I));M=ea(ea(E*G)-ea(y*K));K=ea(ea(y*I)-ea(B*G));G=ea(ea(K*K)+ea(ea(L*L)+ea(M*M)));N=G>ea(0.0);if(N){B=ea(ea(1.0)/ea(T(ea(G))));O=ea(L*B);P=ea(M*B);Q=ea(K*B)}else{O=ea(0.0);P=ea(0.0);Q=ea(0.0)}a:do switch(w|0){case 1:{R=a[b+(r&63)+5604>>0]|0;if(R<<24>>24==-1)S=48;else{U=R&255;while(1){if((c[b+(U<<2)+5284>>2]|0)==(r|0))break a;R=a[b+U+5540>>0]|0;if(R<<24>>24==-1){S=48;break}else U=R&255}}break}case 3:{if(n)S=48;else{U=0;while(1){R=c[h+(U<<6)+52>>2]|0;V=a[b+(R&63)+5216>>0]|0;b:do if(V<<24>>24==-1)W=0;else{X=V&255;while(1){Y=b+(X<<4)+4128|0;if((c[Y>>2]|0)==(R|0)){W=Y;break b}Y=a[b+X+5152>>0]|0;if(Y<<24>>24==-1){W=0;break}else X=Y&255}}while(0);R=c[W+4>>2]|0;if(!((!((R|0)==(q|0)|(R|0)==(r|0))?(R=c[W+8>>2]|0,!((R|0)==(q|0)|(R|0)==(r|0))):0)?(R=c[W+12>>2]|0,!((R|0)==(q|0)|(R|0)==(r|0))):0))S=26;if((S|0)==26?(S=0,B=ea(O*ea(g[h+(U<<6)>>2])),I=ea(B+ea(P*ea(g[h+(U<<6)+4>>2]))),ea(I+ea(Q*ea(g[h+(U<<6)+8>>2])))>ea(.949999988)):0)break a;U=U+1|0;if(U>>>0>=j>>>0){S=48;break}}}break}case 5:{if(n)S=48;else{U=0;while(1){R=c[h+(U<<6)+52>>2]|0;V=a[b+(R&63)+5216>>0]|0;c:do if(V<<24>>24==-1)Z=0;else{X=V&255;while(1){Y=b+(X<<4)+4128|0;if((c[Y>>2]|0)==(R|0)){Z=Y;break c}Y=a[b+X+5152>>0]|0;if(Y<<24>>24==-1){Z=0;break}else X=Y&255}}while(0);R=c[Z+4>>2]|0;if(!((!((R|0)==(q|0)|(R|0)==(s|0))?(R=c[Z+8>>2]|0,!((R|0)==(q|0)|(R|0)==(s|0))):0)?(R=c[Z+12>>2]|0,!((R|0)==(q|0)|(R|0)==(s|0))):0))S=46;if((S|0)==46?(S=0,I=ea(O*ea(g[h+(U<<6)>>2])),B=ea(I+ea(P*ea(g[h+(U<<6)+4>>2]))),ea(B+ea(Q*ea(g[h+(U<<6)+8>>2])))>ea(.949999988)):0)break a;U=U+1|0;if(U>>>0>=j>>>0){S=48;break}}}break}case 2:{U=a[b+(s&63)+5604>>0]|0;if(U<<24>>24==-1)S=48;else{R=U&255;while(1){if((c[b+(R<<2)+5284>>2]|0)==(s|0))break a;U=a[b+R+5540>>0]|0;if(U<<24>>24==-1){S=48;break}else R=U&255}}break}case 0:{R=a[b+(q&63)+5604>>0]|0;if(R<<24>>24==-1)S=48;else{U=R&255;while(1){if((c[b+(U<<2)+5284>>2]|0)==(q|0))break a;R=a[b+U+5540>>0]|0;if(R<<24>>24==-1){S=48;break}else U=R&255}}break}case 4:{if(n)S=48;else{U=0;while(1){R=c[h+(U<<6)+52>>2]|0;V=a[b+(R&63)+5216>>0]|0;d:do if(V<<24>>24==-1)_=0;else{X=V&255;while(1){Y=b+(X<<4)+4128|0;if((c[Y>>2]|0)==(R|0)){_=Y;break d}Y=a[b+X+5152>>0]|0;if(Y<<24>>24==-1){_=0;break}else X=Y&255}}while(0);R=c[_+4>>2]|0;if(!((!((R|0)==(r|0)|(R|0)==(s|0))?(R=c[_+8>>2]|0,!((R|0)==(r|0)|(R|0)==(s|0))):0)?(R=c[_+12>>2]|0,!((R|0)==(r|0)|(R|0)==(s|0))):0))S=36;if((S|0)==36?(S=0,B=ea(O*ea(g[h+(U<<6)>>2])),I=ea(B+ea(P*ea(g[h+(U<<6)+4>>2]))),ea(I+ea(Q*ea(g[h+(U<<6)+8>>2])))>ea(.949999988)):0)break a;U=U+1|0;if(U>>>0>=j>>>0){S=48;break}}}break}default:{}}while(0);if((S|0)==48){S=0;I=ea(g[b+(o<<6)+76>>2]);B=ea(g[t>>2]);y=ea(g[v>>2]);E=ea(T(ea(I)));I=ea(E-ea(g[(c[k>>2]|0)+4>>2]));E=ea(ea(ea(1.0)-B)-y);$=ea(ea(ea(E*x)+ea(B*u))+ea(y*F));aa=ea(ea(ea(E*A)+ea(B*z))+ea(y*H));ba=ea(ea(ea(E*D)+ea(B*C))+ea(y*J));s=c[l>>2]|0;y=ea($*ea(2.0));$=ea(aa*ea(2.0));aa=ea(ba*ea(2.0));ba=ea(g[s+12>>2]);B=ea(ea(ba*ba)+ea(-.5));E=ea(g[s>>2]);ca=ea(y*E);da=ea(g[s+4>>2]);fa=ea(ca+ea($*da));ca=ea(g[s+8>>2]);ga=ea(fa+ea(aa*ca));fa=ea(ea(E*ga)+ea(ea(y*B)+ea(ba*ea(ea(aa*da)-ea($*ca)))));ha=ea(ea(da*ga)+ea(ea($*B)+ea(ba*ea(ea(y*ca)-ea(aa*E)))));ia=ea(ea(ea(aa*B)+ea(ba*ea(ea($*E)-ea(y*da))))+ea(ca*ga));ga=ea(ea(g[s+16>>2])+fa);fa=ea(ea(g[s+20>>2])+ha);ha=ea(ea(g[s+24>>2])+ia);s=c[m>>2]|0;ia=ea(ea(g[s+16>>2])-ga);y=ea(ea(g[s+20>>2])-fa);$=ea(ea(g[s+24>>2])-ha);aa=ea(T(ea(ea(ea(ia*ia)+ea(y*y))+ea($*$))));if(aa<ea(.0000999999974)){if(N){ja=ea(ea(1.0)/ea(T(ea(G))));ka=ea(ea(L*ja)*ea(2.0));la=ea(ea(M*ja)*ea(2.0));ma=ea(ea(K*ja)*ea(2.0))}else{ka=ea(0.0);la=ea(0.0);ma=ea(0.0)}ja=ea(ea(ea(ka*E)+ea(la*da))+ea(ma*ca));na=ea(ea(E*ja)+ea(ea(ka*B)+ea(ba*ea(ea(ma*da)-ea(la*ca)))));oa=ea(ea(da*ja)+ea(ea(la*B)+ea(ba*ea(ea(ka*ca)-ea(ma*E)))));pa=ea(ea(ea(ma*B)+ea(ba*ea(ea(la*E)-ea(ka*da))))+ea(ca*ja))}else{ja=ea(ea(1.0)/aa);na=ea(ia*ja);oa=ea(y*ja);pa=ea($*ja)}s=c[f>>2]|0;r=s+4096|0;q=c[r>>2]|0;if(q>>>0<=63){c[r>>2]=q+1;g[s+(q<<6)>>2]=na;g[s+(q<<6)+4>>2]=oa;g[s+(q<<6)+8>>2]=pa;g[s+(q<<6)+16>>2]=ga;g[s+(q<<6)+20>>2]=fa;g[s+(q<<6)+24>>2]=ha;g[s+(q<<6)+12>>2]=I;c[s+(q<<6)+48>>2]=-1;c[s+(q<<6)+52>>2]=p}}o=o+1|0}while((o|0)!=(e|0));i=d;return}function J6a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=0,m=Im,n=0,o=Im,p=0,q=0,r=Im,s=0,t=Im,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=ea(g[c+48>>2]);h=ea(f*ea(g[c>>2]));j=ea(f*ea(g[c+4>>2]));k=ea(f*ea(g[c+8>>2]));f=ea(h*ea(g[b>>2]));l=b+4|0;m=ea(h*ea(g[l>>2]));n=b+8|0;o=ea(h*ea(g[n>>2]));p=b+12|0;h=ea(j*ea(g[p>>2]));q=b+16|0;r=ea(j*ea(g[q>>2]));s=b+20|0;t=ea(f+h);h=ea(m+r);r=ea(o+ea(j*ea(g[s>>2])));u=b+24|0;j=ea(k*ea(g[u>>2]));v=b+28|0;o=ea(k*ea(g[v>>2]));w=b+32|0;m=ea(h+o);o=ea(r+ea(k*ea(g[w>>2])));g[a>>2]=ea(t+j);g[a+4>>2]=m;g[a+8>>2]=o;o=ea(g[c+52>>2]);m=ea(o*ea(g[c+12>>2]));j=ea(o*ea(g[c+16>>2]));t=ea(o*ea(g[c+20>>2]));o=ea(m*ea(g[b>>2]));k=ea(m*ea(g[l>>2]));r=ea(m*ea(g[n>>2]));m=ea(j*ea(g[p>>2]));h=ea(j*ea(g[q>>2]));f=ea(o+m);m=ea(k+h);h=ea(r+ea(j*ea(g[s>>2])));j=ea(t*ea(g[u>>2]));r=ea(t*ea(g[v>>2]));k=ea(m+r);r=ea(h+ea(t*ea(g[w>>2])));g[a+12>>2]=ea(f+j);g[a+16>>2]=k;g[a+20>>2]=r;r=ea(g[c+56>>2]);k=ea(r*ea(g[c+24>>2]));j=ea(r*ea(g[c+28>>2]));f=ea(r*ea(g[c+32>>2]));r=ea(k*ea(g[b>>2]));t=ea(k*ea(g[l>>2]));h=ea(k*ea(g[n>>2]));k=ea(j*ea(g[p>>2]));m=ea(j*ea(g[q>>2]));o=ea(r+k);k=ea(t+m);m=ea(h+ea(j*ea(g[s>>2])));j=ea(f*ea(g[u>>2]));h=ea(f*ea(g[v>>2]));t=ea(k+h);h=ea(m+ea(f*ea(g[w>>2])));g[a+24>>2]=ea(o+j);g[a+28>>2]=t;g[a+32>>2]=h;h=ea(g[c+36>>2]);t=ea(h*ea(g[b>>2]));j=ea(h*ea(g[l>>2]));o=ea(h*ea(g[n>>2]));h=ea(g[c+40>>2]);f=ea(h*ea(g[p>>2]));m=ea(h*ea(g[q>>2]));k=ea(t+f);f=ea(j+m);m=ea(o+ea(h*ea(g[s>>2])));h=ea(g[c+44>>2]);o=ea(h*ea(g[u>>2]));j=ea(h*ea(g[v>>2]));t=ea(k+o);o=ea(f+j);j=ea(m+ea(h*ea(g[w>>2])));h=ea(t+ea(g[b+36>>2]));t=ea(o+ea(g[b+40>>2]));o=ea(j+ea(g[b+44>>2]));g[a+36>>2]=h;g[a+40>>2]=t;g[a+44>>2]=o;qKa(e,a);g[a+48>>2]=ea(g[e>>2]);g[a+52>>2]=ea(g[e+4>>2]);g[a+56>>2]=ea(g[e+8>>2]);i=d;return}function K6a(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im;j=i;k=c[a+12>>2]|0;l=ea(g[d>>2]);m=ea(g[b>>2]);n=ea(l*m);l=ea(g[d+4>>2]);o=b+4|0;p=ea(g[o>>2]);q=ea(n+ea(l*p));l=ea(g[d+8>>2]);r=b+8|0;n=ea(g[r>>2]);s=ea(q+ea(l*n));l=ea(m*ea(g[d+12>>2]));q=ea(l+ea(p*ea(g[d+16>>2])));l=ea(q+ea(n*ea(g[d+20>>2])));q=ea(m*ea(g[d+24>>2]));m=ea(q+ea(p*ea(g[d+28>>2])));p=ea(m+ea(n*ea(g[d+32>>2])));n=ea(s*ea(g[e>>2]));m=ea(s*ea(g[e+4>>2]));q=ea(s*ea(g[e+8>>2]));s=ea(l*ea(g[e+12>>2]));t=ea(l*ea(g[e+16>>2]));u=ea(n+s);s=ea(m+t);t=ea(q+ea(l*ea(g[e+20>>2])));l=ea(p*ea(g[e+24>>2]));q=ea(p*ea(g[e+28>>2]));m=ea(u+l);l=ea(s+q);q=ea(t+ea(p*ea(g[e+32>>2])));if(!k){v=ea(-3402823469999999843913219.0e14);w=ea(3402823469999999843913219.0e14)}else{e=k;k=c[a+28>>2]|0;p=ea(-3402823469999999843913219.0e14);t=ea(3402823469999999843913219.0e14);while(1){e=e+-1|0;s=ea(m*ea(g[k>>2]));u=ea(s+ea(l*ea(g[k+4>>2])));s=ea(u+ea(q*ea(g[k+8>>2])));u=t<s?t:s;n=p>s?p:s;if(!e){v=n;w=u;break}else{k=k+12|0;p=n;t=u}}}g[f>>2]=w;g[h>>2]=v;v=ea(g[d+36>>2]);w=ea(v*ea(g[b>>2]));v=ea(g[d+40>>2]);t=ea(w+ea(v*ea(g[o>>2])));v=ea(g[d+44>>2]);w=ea(t+ea(v*ea(g[r>>2])));g[f>>2]=ea(ea(g[f>>2])+w);g[h>>2]=ea(ea(g[h>>2])+w);i=j;return}function L6a(a,b,f,h,j,l){a=a|0;b=b|0;f=f|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=0,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=Im,G=0,H=0,I=0;m=i;i=i+48|0;n=m+32|0;o=m+28|0;p=m+24|0;q=m+12|0;r=m;s=c[a+28>>2]|0;t=ea(g[f>>2]);u=ea(g[b>>2]);v=ea(t*u);t=ea(g[f+4>>2]);w=b+4|0;x=ea(g[w>>2]);y=ea(v+ea(t*x));t=ea(g[f+8>>2]);z=b+8|0;v=ea(g[z>>2]);A=ea(y+ea(t*v));t=ea(u*ea(g[f+12>>2]));y=ea(t+ea(x*ea(g[f+16>>2])));t=ea(y+ea(v*ea(g[f+20>>2])));y=ea(u*ea(g[f+24>>2]));u=ea(y+ea(x*ea(g[f+28>>2])));x=ea(u+ea(v*ea(g[f+32>>2])));v=ea(A*ea(g[h>>2]));u=ea(A*ea(g[h+4>>2]));y=ea(A*ea(g[h+8>>2]));A=ea(t*ea(g[h+12>>2]));B=ea(t*ea(g[h+16>>2]));C=ea(v+A);A=ea(u+B);B=ea(y+ea(t*ea(g[h+20>>2])));t=ea(x*ea(g[h+24>>2]));y=ea(x*ea(g[h+28>>2]));u=ea(C+t);t=ea(A+y);y=ea(B+ea(x*ea(g[h+32>>2])));g[n>>2]=u;h=n+4|0;g[h>>2]=t;D=n+8|0;g[D>>2]=y;E=c[a+56>>2]|0;c[o>>2]=0;c[p>>2]=0;a=e[E>>1]|0;x=ea(-u);u=ea(-t);t=ea(-y);g[q>>2]=x;g[q+4>>2]=u;g[q+8>>2]=t;y=ea(S(ea(x)));B=ea(S(ea(u)));A=ea(S(ea(t)));if(B>y&B>A){F=B;G=1}else{H=A>y;F=H?A:y;G=H?2:0}y=ea(ea(1.0)/F);F=ea(g[q+(G<<2)>>2]);H=G+1+(G>>>1)|0;I=H&3;A=ea(y*ea(g[q+(I<<2)>>2]));B=ea(ea((a+-1|0)>>>0)*ea(.5));C=ea(B*ea(A+ea(1.0)));A=ea(B*ea(ea(y*ea(g[q+((H+1+(I>>>1)&3)<<2)>>2]))+ea(1.0)));I=~~C>>>0;H=~~A>>>0;q=(ea(A-ea(H>>>0))>ea(.5)&1)+H+(da(I+(da((g[k>>2]=F,c[k>>2]|0)>>>31|G<<1,a)|0)+(ea(C-ea(I>>>0))>ea(.5)&1)|0,a)|0)|0;a=c[E+4>>2]|0;c[o>>2]=d[a+q>>0];c[p>>2]=d[a+(q+(e[E+2>>1]|0))>>0];g[r>>2]=x;g[r+4>>2]=u;g[r+8>>2]=t;DOa(o,r,s,E);DOa(p,n,s,E);t=ea(g[f+36>>2]);u=ea(t*ea(g[b>>2]));t=ea(g[f+40>>2]);x=ea(u+ea(t*ea(g[w>>2])));t=ea(g[f+44>>2]);u=ea(x+ea(t*ea(g[z>>2])));z=c[o>>2]|0;t=ea(g[s+(z*12|0)>>2]);x=ea(g[n>>2]);C=ea(t*x);t=ea(g[s+(z*12|0)+4>>2]);F=ea(g[h>>2]);A=ea(C+ea(t*F));t=ea(g[s+(z*12|0)+8>>2]);C=ea(g[D>>2]);g[j>>2]=ea(u+ea(A+ea(t*C)));j=c[p>>2]|0;t=ea(ea(g[s+(j*12|0)>>2])*x);x=ea(t+ea(ea(g[s+(j*12|0)+4>>2])*F));g[l>>2]=ea(u+ea(x+ea(ea(g[s+(j*12|0)+8>>2])*C)));i=m;return}function M6a(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=Im,y=0,z=Im;f=i;h=ea(g[e>>2]);j=ea(h*ea(g[b>>2]));k=ea(h*ea(g[b+4>>2]));l=ea(h*ea(g[b+8>>2]));h=ea(g[e+4>>2]);m=ea(h*ea(g[b+12>>2]));n=ea(h*ea(g[b+16>>2]));o=ea(j+m);m=ea(k+n);n=ea(l+ea(h*ea(g[b+20>>2])));h=ea(g[e+8>>2]);l=ea(h*ea(g[b+24>>2]));k=ea(h*ea(g[b+28>>2]));j=ea(o+l);l=ea(m+k);k=ea(n+ea(h*ea(g[b+32>>2])));b=c[a+24>>2]|0;e=c[a+16>>2]|0;h=ea(j*ea(g[b>>2]));n=ea(h+ea(l*ea(g[b+4>>2])));h=ea(n+ea(k*ea(g[b+8>>2])));if(e>>>0>1){p=0;q=1;n=h;while(1){m=ea(j*ea(g[b+(q*20|0)>>2]));o=ea(m+ea(l*ea(g[b+(q*20|0)+4>>2])));m=ea(o+ea(k*ea(g[b+(q*20|0)+8>>2])));r=m>n;s=r?q:p;o=r?m:n;q=q+1|0;if((q|0)==(e|0)){t=s;u=o;break}else{p=s;n=o}}}else{t=0;u=h}p=c[a+20>>2]|0;e=c[a+36>>2]|0;if(!p){v=t;i=f;return v|0}a=-1;q=0;h=ea(u*u);while(1){s=q<<1;r=d[e+s>>0]|0;w=d[e+(s|1)>>0]|0;u=ea(g[b+(r*20|0)>>2]);n=ea(u+ea(g[b+(w*20|0)>>2]));u=ea(g[b+(r*20|0)+4>>2]);o=ea(u+ea(g[b+(w*20|0)+4>>2]));u=ea(g[b+(r*20|0)+8>>2]);m=ea(u+ea(g[b+(w*20|0)+8>>2]));u=ea(ea(ea(n*n)+ea(o*o))+ea(m*m));x=ea(ea(ea(j*n)+ea(l*o))+ea(k*m));if(x>=ea(0.0)?(m=ea(x*x),m>ea(h*u)):0){y=q;z=ea(m/u)}else{y=a;z=h}q=q+1|0;if((q|0)==(p|0))break;else{a=y;h=z}}if((y|0)==-1){v=t;i=f;return v|0}t=y<<1;y=d[e+t>>0]|0;a=d[e+(t|1)>>0]|0;z=ea(j*ea(g[b+(y*20|0)>>2]));h=ea(z+ea(l*ea(g[b+(y*20|0)+4>>2])));z=ea(h+ea(k*ea(g[b+(y*20|0)+8>>2])));h=ea(j*ea(g[b+(a*20|0)>>2]));j=ea(h+ea(l*ea(g[b+(a*20|0)+4>>2])));t=z>ea(j+ea(k*ea(g[b+(a*20|0)+8>>2])));v=t?y:a;i=f;return v|0}function N6a(a,b){a=a|0;b=b|0;return}function O6a(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;i=ea(g[d>>2]);j=ea(g[b>>2]);k=ea(i*j);i=ea(g[d+4>>2]);l=ea(g[b+4>>2]);m=ea(k+ea(i*l));i=ea(g[d+8>>2]);k=ea(g[b+8>>2]);n=ea(m+ea(i*k));i=ea(j*ea(g[d+12>>2]));m=ea(i+ea(l*ea(g[d+16>>2])));i=ea(m+ea(k*ea(g[d+20>>2])));m=ea(j*ea(g[d+24>>2]));o=ea(m+ea(l*ea(g[d+28>>2])));m=ea(o+ea(k*ea(g[d+32>>2])));b=c[a+56>>2]|0;o=ea(g[b>>2]);p=ea(-o);a=n>=ea(0.0);q=ea(g[b+4>>2]);r=ea(-q);e=i>=ea(0.0);s=ea(g[b+8>>2]);t=ea(-s);b=m>=ea(0.0);u=ea(j*ea(g[d+36>>2]));j=ea(u+ea(l*ea(g[d+40>>2])));l=ea(j+ea(k*ea(g[d+44>>2])));k=ea(ea(ea(n*(a?o:p))+ea(i*(e?q:r)))+ea(m*(b?s:t)));g[h>>2]=ea(k+l);g[f>>2]=ea(l-k);return}function P6a(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0;b=i;f=c[a+24>>2]|0;h=ea(g[f>>2]);j=ea(g[e>>2]);k=ea(h*j);h=ea(g[f+4>>2]);l=ea(g[e+4>>2]);m=ea(k+ea(h*l));h=ea(g[f+8>>2]);k=ea(g[e+8>>2]);n=ea(m+ea(h*k));h=ea(j*ea(g[f+20>>2]));m=ea(h+ea(l*ea(g[f+24>>2])));h=ea(m+ea(k*ea(g[f+28>>2])));e=h>n;m=e?h:n;n=ea(j*ea(g[f+40>>2]));h=ea(n+ea(l*ea(g[f+44>>2])));n=ea(h+ea(k*ea(g[f+48>>2])));a=n>m;h=a?n:m;m=ea(j*ea(g[f+60>>2]));n=ea(m+ea(l*ea(g[f+64>>2])));m=ea(n+ea(k*ea(g[f+68>>2])));o=m>h;n=o?m:h;h=ea(j*ea(g[f+80>>2]));m=ea(h+ea(l*ea(g[f+84>>2])));h=ea(m+ea(k*ea(g[f+88>>2])));p=h>n;m=p?h:n;n=ea(j*ea(g[f+100>>2]));h=ea(n+ea(l*ea(g[f+104>>2])));n=ea(h+ea(k*ea(g[f+108>>2])));q=n>m;r=q?5:p?4:o?3:a?2:e&1;e=-1;a=0;h=q?n:m;while(1){m=ea(ea(g[540896+(a*12|0)>>2])*j);n=ea(m+ea(ea(g[540900+(a*12|0)>>2])*l));m=ea(n+ea(ea(g[540904+(a*12|0)>>2])*k));q=m>h;e=q?a:e;a=a+1|0;if((a|0)==12)break;else h=q?m:h}if((e|0)==-1){s=r;i=b;return s|0}r=c[540476+(e<<3)>>2]|0;e=d[540568+r>>0]|0;a=d[r+540569>>0]|0;h=ea(ea(g[f+(e*20|0)>>2])*j);m=ea(h+ea(ea(g[f+(e*20|0)+4>>2])*l));h=ea(m+ea(ea(g[f+(e*20|0)+8>>2])*k));m=ea(j*ea(g[f+(a*20|0)>>2]));j=ea(m+ea(l*ea(g[f+(a*20|0)+4>>2])));r=h>ea(j+ea(k*ea(g[f+(a*20|0)+8>>2])));s=r?e:a;i=b;return s|0}function Q6a(a,b,c,d,e,f,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im;l=i;i=i+16|0;m=l;n=d+(b<<2)|0;o=ea(g[n>>2]);p=f+(b<<2)|0;q=ea(g[p>>2]);r=m+(b<<2)|0;g[r>>2]=ea(o+q);s=d+(c<<2)|0;o=ea(g[s>>2]);t=f+(c<<2)|0;u=ea(g[t>>2]);v=ea(o+u);g[m+(c<<2)>>2]=v;m=e+(a<<2)|0;o=ea(g[m>>2]);w=ea(g[r>>2]);x=ea(o*w);r=e+(b<<2)|0;y=ea(g[r>>2]);z=h+(a<<2)|0;A=ea(g[z>>2]);B=!(x>=ea(y*A));x=ea(o*v);C=e+(c<<2)|0;D=ea(g[C>>2]);e=x>=ea(A*D);if(!B){if(e){if(!j){i=l;return}g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);x=ea(ea(1.0)/ea(g[m>>2]));E=ea(g[r>>2]);F=ea(x*ea(E*ea(g[z>>2])));g[n>>2]=ea(ea(g[n>>2])-F);F=ea(g[C>>2]);E=ea(x*ea(F*ea(g[z>>2])));g[s>>2]=ea(ea(g[s>>2])-E);g[j>>2]=ea(-ea(x*ea(g[z>>2])));i=l;return}x=ea(ea(o*o)+ea(D*D));E=ea(o*A);F=ea(v*D);G=ea(ea(w*x)-ea(y*ea(E+F)));if(!(G<=ea(ea(x*ea(2.0))*q))){H=ea(ea(y*y)+x);I=ea(g[h+(b<<2)>>2]);J=ea(F+ea(E+ea(y*I)));K=ea(ea(-J)/H);H=ea(ea(ea(v*v)+ea(ea(A*A)+ea(I*I)))+ea(K*J));g[k>>2]=ea(ea(g[k>>2])+H);if(!j){i=l;return}g[j>>2]=K;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(g[p>>2]);g[s>>2]=ea(-ea(g[t>>2]));i=l;return}else{K=ea(G/x);G=ea(w-K);H=ea(F+ea(E+ea(y*G)));E=ea(ea(-H)/ea(ea(y*y)+x));x=ea(ea(ea(v*v)+ea(ea(A*A)+ea(G*G)))+ea(E*H));g[k>>2]=ea(ea(g[k>>2])+x);if(!j){i=l;return}g[j>>2]=E;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(K-ea(g[p>>2]));g[s>>2]=ea(-ea(g[t>>2]));i=l;return}}K=ea(o*o);if(e){E=ea(K+ea(y*y));x=ea(ea(w*y)+ea(o*A));H=ea(ea(v*E)-ea(D*x));if(!(H<=ea(ea(E*ea(2.0))*u))){G=ea(E+ea(D*D));F=ea(g[h+(c<<2)>>2]);J=ea(x+ea(D*F));I=ea(ea(-J)/G);G=ea(ea(ea(ea(w*w)+ea(A*A))+ea(F*F))+ea(I*J));g[k>>2]=ea(ea(g[k>>2])+G);if(!j){i=l;return}g[j>>2]=I;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(-ea(g[p>>2]));g[s>>2]=ea(g[t>>2]);i=l;return}else{I=ea(H/E);H=ea(v-I);G=ea(x+ea(D*H));x=ea(ea(-G)/ea(E+ea(D*D)));E=ea(ea(ea(ea(w*w)+ea(A*A))+ea(H*H))+ea(x*G));g[k>>2]=ea(ea(g[k>>2])+E);if(!j){i=l;return}g[j>>2]=x;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(-ea(g[p>>2]));g[s>>2]=ea(I-ea(g[t>>2]));i=l;return}}I=ea(D*D);x=ea(K+I);E=ea(o*A);o=ea(v*D);G=ea(ea(w*x)-ea(y*ea(E+o)));if(G>=ea(0.0))if(!(G<=ea(ea(x*ea(2.0))*q))){q=ea(ea(y*y)+x);H=ea(g[h+(b<<2)>>2]);J=ea(o+ea(E+ea(y*H)));F=ea(ea(-J)/q);q=ea(ea(ea(v*v)+ea(ea(A*A)+ea(H*H)))+ea(F*J));g[k>>2]=ea(ea(g[k>>2])+q);if(!j){i=l;return}g[j>>2]=F;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(g[p>>2]);g[s>>2]=ea(-ea(g[t>>2]));i=l;return}else{F=ea(G/x);G=ea(w-F);q=ea(o+ea(E+ea(y*G)));J=ea(ea(-q)/ea(ea(y*y)+x));x=ea(ea(ea(v*v)+ea(ea(A*A)+ea(G*G)))+ea(J*q));g[k>>2]=ea(ea(g[k>>2])+x);if(!j){i=l;return}g[j>>2]=J;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(F-ea(g[p>>2]));g[s>>2]=ea(-ea(g[t>>2]));i=l;return}F=ea(K+ea(y*y));K=ea(ea(w*y)+E);E=ea(ea(v*F)-ea(D*K));if(!(E>=ea(0.0))){y=ea(K+o);o=ea(ea(-y)/ea(F+I));J=ea(ea(ea(v*v)+ea(ea(w*w)+ea(A*A)))+ea(y*o));g[k>>2]=ea(ea(g[k>>2])+J);if(!j){i=l;return}g[j>>2]=o;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(-ea(g[p>>2]));g[s>>2]=ea(-ea(g[t>>2]));i=l;return}if(!(E<=ea(ea(F*ea(2.0))*u))){u=ea(F+I);o=ea(g[h+(c<<2)>>2]);J=ea(K+ea(D*o));y=ea(ea(-J)/u);u=ea(ea(ea(ea(w*w)+ea(A*A))+ea(o*o))+ea(y*J));g[k>>2]=ea(ea(g[k>>2])+u);if(!j){i=l;return}g[j>>2]=y;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(-ea(g[p>>2]));g[s>>2]=ea(g[t>>2]);i=l;return}else{y=ea(E/F);E=ea(v-y);v=ea(K+ea(D*E));D=ea(ea(-v)/ea(F+I));I=ea(ea(ea(ea(w*w)+ea(A*A))+ea(E*E))+ea(D*v));g[k>>2]=ea(ea(g[k>>2])+I);if(!j){i=l;return}g[j>>2]=D;g[d+(a<<2)>>2]=ea(g[f+(a<<2)>>2]);g[n>>2]=ea(-ea(g[p>>2]));g[s>>2]=ea(y-ea(g[t>>2]));i=l;return}}function R6a(a,b,c,d,e,f,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=Im,n=0,o=Im,p=Im,q=0,r=0,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;k=i;l=d+(a<<2)|0;m=ea(g[l>>2]);n=f+(a<<2)|0;o=ea(g[n>>2]);p=ea(m-o);q=d+(b<<2)|0;m=ea(g[q>>2]);r=f+(b<<2)|0;s=ea(g[r>>2]);t=ea(m-s);u=e+(b<<2)|0;m=ea(p*ea(g[u>>2]));b=e+(a<<2)|0;v=ea(t*ea(g[b>>2]));do if(!(m>=v)){g[q>>2]=s;w=ea(g[l>>2]);x=ea(w+ea(g[n>>2]));y=ea(g[u>>2]);z=ea(v-ea(y*x));if(!(z>=ea(0.0))){if(!h)break;A=ea(ea(1.0)/y);g[l>>2]=ea(w-ea(v*A));g[h>>2]=ea(-ea(t*A));break}else{A=ea(g[b>>2]);w=ea(ea(1.0)/ea(ea(y*y)+ea(A*A)));A=ea(ea(z*z)*w);g[j>>2]=ea(ea(g[j>>2])+A);if(!h)break;g[l>>2]=ea(-ea(g[n>>2]));A=ea(x*ea(g[b>>2]));g[h>>2]=ea(-ea(w*ea(A+ea(t*ea(g[u>>2])))));break}}else{g[l>>2]=o;A=ea(g[q>>2]);w=ea(A+ea(g[r>>2]));x=ea(g[b>>2]);z=ea(m-ea(x*w));if(!(z>=ea(0.0))){if(!h)break;y=ea(ea(1.0)/x);g[q>>2]=ea(A-ea(m*y));g[h>>2]=ea(-ea(p*y));break}else{y=ea(x*x);x=ea(g[u>>2]);A=ea(ea(1.0)/ea(y+ea(x*x)));x=ea(ea(z*z)*A);g[j>>2]=ea(ea(g[j>>2])+x);if(!h)break;g[q>>2]=ea(-ea(g[r>>2]));x=ea(p*ea(g[b>>2]));g[h>>2]=ea(-ea(A*ea(x+ea(w*ea(g[u>>2])))));break}}while(0);u=d+(c<<2)|0;p=ea(g[u>>2]);d=f+(c<<2)|0;m=ea(g[d>>2]);if(p<ea(-m)){o=ea(p+m);t=ea(o*o);g[j>>2]=ea(t+ea(g[j>>2]));g[u>>2]=ea(-ea(g[d>>2]));i=k;return}if(!(p>m)){i=k;return}t=ea(p-m);m=ea(t*t);g[j>>2]=ea(m+ea(g[j>>2]));g[u>>2]=ea(g[d>>2]);i=k;return}function S6a(b,c,e,f,h,j,k,l,m,n,o){b=b|0;c=ea(c);e=ea(e);f=ea(f);h=h|0;j=ea(j);k=ea(k);l=ea(l);m=m|0;n=n|0;o=o|0;var p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0;p=i;q=ea(ea(g[b>>2])*j);r=ea(q+ea(ea(g[b+4>>2])*k));q=ea(r+ea(ea(g[b+8>>2])*l));r=ea(ea(g[b+12>>2])*j);s=ea(r+ea(ea(g[b+16>>2])*k));r=ea(s+ea(ea(g[b+20>>2])*l));s=ea(ea(g[b+24>>2])*j);t=ea(s+ea(ea(g[b+28>>2])*k));s=ea(t+ea(ea(g[b+32>>2])*l));t=q<r?q:r;u=q>r?q:r;r=ea(ea(ea(ea(S(ea(j)))*c)+ea(ea(S(ea(k)))*e))+ea(ea(S(ea(l)))*f));f=ea(ea(-r)-(u>s?u:s));u=ea(r-(t<s?t:s));if(!(f<=ea(0.0)))v=0;else v=u>=ea(0.0);b=v&1;a[m>>0]=(d[m>>0]|0)&b;s=ea(ea(g[h>>2])*j);j=ea(s+ea(ea(g[h+4>>2])*k));k=ea(j+ea(ea(g[h+8>>2])*l));if(ea(S(ea(k)))<ea(9.99999997e-07)){w=b;i=p;return w|0}l=ea(ea(-1.0)/k);k=ea(f*l);f=ea(u*l);l=k<f?k:f;u=k>f?k:f;f=ea(g[o>>2]);if(l>f){w=0;i=p;return w|0}if(u<ea(g[n>>2])){w=0;i=p;return w|0}g[o>>2]=u<f?u:f;f=ea(g[n>>2]);g[n>>2]=l>f?l:f;w=1;i=p;return w|0}function T6a(a,b,c,d,e,f,h,j,k,l){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);h=ea(h);j=ea(j);k=k|0;l=l|0;var m=0,n=Im,o=0,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;m=i;n=ea(ea(g[k>>2])-c);o=k+4|0;p=ea(ea(g[o>>2])-d);q=k+8|0;r=ea(ea(g[q>>2])-e);s=ea(ea(ea(f*f)+ea(h*h))+ea(j*j));t=ea(g[l>>2]);u=ea(t*t);v=l+4|0;w=ea(g[v>>2]);x=ea(u+ea(w*w));y=l+8|0;u=ea(g[y>>2]);z=ea(x+ea(u*u));x=ea(ea(ea(t*f)+ea(w*h))+ea(u*j));A=ea(ea(ea(n*f)+ea(p*h))+ea(r*j));B=ea(ea(ea(n*t)+ea(p*w))+ea(r*u));u=ea(ea(s*z)-ea(x*x));if(u!=ea(0.0)?(r=ea(ea(ea(A*z)-ea(B*x))/u),!(r<ea(0.0))):0)if(r>ea(1.0))C=ea(1.0);else C=r;else C=ea(0.0);do if(z!=ea(0.0)){r=ea(ea(ea(x*C)-B)/z);if(r<ea(0.0)){if(!(s!=ea(0.0))){D=ea(0.0);E=ea(0.0);break}u=ea(A/s);if(u<ea(0.0)){D=ea(0.0);E=ea(0.0);break}if(!(u>ea(1.0))){D=u;E=ea(0.0);break}D=ea(1.0);E=ea(0.0);break}if(r>ea(1.0))if(s!=ea(0.0)?(u=ea(ea(A+x)/s),!(u<ea(0.0))):0)if(u>ea(1.0)){D=ea(1.0);E=ea(1.0)}else{D=u;E=ea(1.0)}else{D=ea(0.0);E=ea(1.0)}else{D=C;E=r}}else if(s!=ea(0.0)?(r=ea(A/s),!(r<ea(0.0))):0)if(r>ea(1.0)){D=ea(1.0);E=ea(0.0)}else{D=r;E=ea(0.0)}else{D=ea(0.0);E=ea(0.0)}while(0);s=ea(ea(D*h)+d);d=ea(ea(D*j)+e);g[a>>2]=ea(ea(D*f)+c);g[a+4>>2]=s;g[a+8>>2]=d;d=ea(E*ea(g[l>>2]));s=ea(E*ea(g[v>>2]));c=ea(E*ea(g[y>>2]));E=ea(d+ea(g[k>>2]));d=ea(s+ea(g[o>>2]));s=ea(c+ea(g[q>>2]));g[b>>2]=E;g[b+4>>2]=d;g[b+8>>2]=s;i=m;return}function U6a(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0;f=i;h=ea(g[e>>2]);j=ea(g[e+12>>2]);k=ea(h+j);l=ea(g[e+4>>2]);m=ea(g[e+16>>2]);n=ea(l+m);o=ea(g[e+8>>2]);p=ea(g[e+20>>2]);q=ea(o+p);r=ea(g[e+24>>2]);s=ea(k+r);k=ea(g[e+28>>2]);t=ea(n+k);n=ea(g[e+32>>2]);u=ea(s*ea(.333333343));s=ea(t*ea(.333333343));t=ea(ea(q+n)*ea(.333333343));q=ea(u-ea(g[a>>2]));v=ea(s-ea(g[a+4>>2]));w=ea(t-ea(g[a+8>>2]));x=ea(g[b>>2]);y=ea(q*x);z=ea(g[b+4>>2]);A=ea(y+ea(v*z));y=ea(g[b+8>>2]);B=ea(A+ea(w*y));b=B>ea(0.0);A=b?B:ea(0.0);B=A<c?A:c;c=ea(q-ea(x*B));x=ea(v-ea(z*B));z=ea(w-ea(y*B));B=ea(ea(ea(T(ea(ea(z*z)+ea(ea(c*c)+ea(x*x)))))-d)+ea(-.0000999999974));if(B<ea(0.0)){C=1;i=f;return C|0}d=ea(B*B);B=ea(u-h);h=ea(s-l);l=ea(t-o);o=ea(ea(ea(B*B)+ea(h*h))+ea(l*l));l=ea(u-j);j=ea(s-m);m=ea(t-p);p=ea(ea(ea(l*l)+ea(j*j))+ea(m*m));m=ea(u-r);r=ea(s-k);k=ea(t-n);n=ea(ea(ea(m*m)+ea(r*r))+ea(k*k));k=o>p?o:p;C=d<=(k>n?k:n);i=f;return C|0}function V6a(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im;n=i;i=i+352|0;o=n+160|0;p=n+208|0;q=n+16|0;r=n+304|0;s=n+144|0;t=n+64|0;u=n+80|0;v=n+224|0;w=n+256|0;x=n+288|0;y=n+320|0;z=n+336|0;A=n+176|0;B=n+192|0;C=n+32|0;D=n;E=n+96|0;F=n+112|0;G=n+240|0;H=n+48|0;I=n+128|0;J=n+272|0;c[k>>2]=3;K=ea(g[d>>2]);L=ea(g[d+4>>2]);M=ea(g[d+8>>2]);N=ea(g[b>>2]);O=ea(g[b+4>>2]);P=ea(g[b+8>>2]);Q=ea(K-N);R=ea(L-O);S=ea(M-P);T=ea(g[e>>2]);U=ea(g[e+4>>2]);V=ea(g[e+8>>2]);W=ea(T-N);X=ea(U-O);Y=ea(V-P);Z=ea(T-K);_=ea(U-L);$=ea(V-M);aa=ea(ea(ea(W*W)+ea(X*X))+ea(Y*Y));ba=ea(ea(ea(Z*Z)+ea(_*_))+ea($*$));if((aa>ba?ba:aa)<=ea(1.1920929e-07)){c[k>>2]=2;zFb(a,f,h,j,k,l,m);i=n;return}aa=ea(-N);N=ea(-O);O=ea(-P);P=ea(-K);K=ea(-L);L=ea(-M);M=ea(-T);T=ea(-U);U=ea(-V);V=ea(ea(ea(Q*aa)+ea(R*N))+ea(S*O));ba=ea(ea(ea(W*aa)+ea(X*N))+ea(Y*O));O=ea(ea(ea(Q*P)+ea(R*K))+ea(S*L));N=ea(ea(ea(W*P)+ea(X*K))+ea(Y*L));L=ea(ea(ea(Q*M)+ea(R*T))+ea(S*U));S=ea(ea(ea(W*M)+ea(X*T))+ea(Y*U));U=ea(N-O);Y=ea(L-S);k=!(V<=ea(0.0));f=ba<=ea(0.0);e=!(O>=ea(0.0));b=O>=N;d=S>=L;ca=k?0:f<<31>>31;if(e){da=1;fa=0}else{da=b^1;fa=b}b=S>=ea(0.0);e=d&b;ga=(ca|0)==0;ha=(ca|0)==0;ia=(ca|0)==0;ca=d&b^1;if(!(ga&(da&ca)|ha&(da&ca))?(e|da^1|ia^1)&(e|fa|f&(k^1)):0){c[r+0>>2]=c[h+0>>2];c[r+4>>2]=c[h+4>>2];c[r+8>>2]=c[h+8>>2];c[r+12>>2]=c[h+12>>2];k=h+16|0;c[p+0>>2]=c[k+0>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];k=h+32|0;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];T=ea(g[(da?o:p)>>2]);X=ea(g[(da?o:p)+4>>2]);M=ea(g[(da?o:p)+8>>2]);g[q>>2]=T;g[q+4>>2]=X;g[q+8>>2]=M;g[q+12>>2]=ea(0.0);M=ea(g[(ga?q:r)>>2]);X=ea(g[(ha?q:r)+4>>2]);T=ea(g[(ia?q:r)+8>>2]);c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];r=j+16|0;c[t+0>>2]=c[r+0>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[t+12>>2]=c[r+12>>2];r=j+32|0;c[s+0>>2]=c[r+0>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];c[s+12>>2]=c[r+12>>2];W=ea(g[(da?s:t)>>2]);R=ea(g[(da?s:t)+4>>2]);Q=ea(g[(da?s:t)+8>>2]);g[u>>2]=W;g[u+4>>2]=R;g[u+8>>2]=Q;g[u+12>>2]=ea(0.0);Q=ea(g[(ga?u:v)>>2]);R=ea(g[(ha?u:v)+4>>2]);W=ea(g[(ia?u:v)+8>>2]);g[l>>2]=M;g[l+4>>2]=X;g[l+8>>2]=T;g[l+12>>2]=ea(0.0);g[m>>2]=Q;g[m+4>>2]=R;g[m+8>>2]=W;g[m+12>>2]=ea(0.0);K=ea(X-R);R=ea(T-W);g[a>>2]=ea(M-Q);g[a+4>>2]=K;g[a+8>>2]=R;g[a+12>>2]=ea(0.0);i=n;return}R=ea(ea(O*S)-ea(N*L));K=ea(ea(ba*L)-ea(V*S));Q=ea(ea(V*N)-ea(ba*O));v=!(Q<=ea(0.0));u=!(R<=ea(0.0));ia=L>=S;ha=S<=ea(0.0);if(!(V>=ea(0.0)))ja=0;else ja=O<=ea(0.0);ga=v?0:ja<<31>>31;t=N>=O;if(u){ka=1;la=0}else{ka=ia&t^1;la=ia&t}t=ha&ba>=ea(0.0)&K<=ea(0.0);N=ea(V-O);O=ea(U+Y);Y=ea(ba-S);S=ea(R+ea(Q+K));R=ea(-N);L=ea(-O);M=ea(-Y);W=ea(-S);ha=(N>R?N:R)>ea(1.1920929e-07);ia=(O>L?O:L)>ea(1.1920929e-07);u=(Y>M?Y:M)>ea(1.1920929e-07);s=(S>W?S:W)>ea(1.1920929e-07);W=ea(ea(1.0)/O);O=ea(ea(1.0)/Y);Y=ea(ea(1.0)/S);g[x>>2]=ea(ea(1.0)/N);g[x+4>>2]=W;g[x+8>>2]=O;g[x+12>>2]=Y;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;Y=ea(g[(ha?x:w)>>2]);O=ea(g[(ia?x:w)+4>>2]);W=ea(g[(u?x:w)+8>>2]);N=ea(g[(s?x:w)+12>>2]);w=(ga|0)==0;x=(ga|0)==0;s=(ga|0)==0;ga=t^1;if(!(w&(ka&ga)|x&(ka&ga))?(t|ka^1|s^1)&(t|la|ja&(v^1)):0){S=ea(V*Y);Y=ea(U*O);O=ea(ba*W);v=h+16|0;c[z+0>>2]=c[v+0>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];c[z+12>>2]=c[v+12>>2];ja=h+32|0;c[y+0>>2]=c[ja+0>>2];c[y+4>>2]=c[ja+4>>2];c[y+8>>2]=c[ja+8>>2];c[y+12>>2]=c[ja+12>>2];W=ea(g[(w?y:z)>>2]);ba=ea(g[(x?y:z)+4>>2]);U=ea(g[(s?y:z)+8>>2]);z=j+16|0;c[B+0>>2]=c[z+0>>2];c[B+4>>2]=c[z+4>>2];c[B+8>>2]=c[z+8>>2];c[B+12>>2]=c[z+12>>2];y=j+32|0;c[A+0>>2]=c[y+0>>2];c[A+4>>2]=c[y+4>>2];c[A+8>>2]=c[y+8>>2];c[A+12>>2]=c[y+12>>2];V=ea(g[(w?A:B)>>2]);M=ea(g[(x?A:B)+4>>2]);L=ea(g[(s?A:B)+8>>2]);c[F+0>>2]=c[h+0>>2];c[F+4>>2]=c[h+4>>2];c[F+8>>2]=c[h+8>>2];c[F+12>>2]=c[h+12>>2];c[D+0>>2]=c[v+0>>2];c[D+4>>2]=c[v+4>>2];c[D+8>>2]=c[v+8>>2];c[D+12>>2]=c[v+12>>2];c[C+0>>2]=c[h+0>>2];c[C+4>>2]=c[h+4>>2];c[C+8>>2]=c[h+8>>2];c[C+12>>2]=c[h+12>>2];R=ea(g[(ka?C:D)>>2]);T=ea(g[(ka?C:D)+4>>2]);X=ea(g[(ka?C:D)+8>>2]);g[E>>2]=R;g[E+4>>2]=T;g[E+8>>2]=X;g[E+12>>2]=ea(0.0);X=ea(g[(w?E:F)>>2]);T=ea(g[(x?E:F)+4>>2]);R=ea(g[(s?E:F)+8>>2]);c[J+0>>2]=c[j+0>>2];c[J+4>>2]=c[j+4>>2];c[J+8>>2]=c[j+8>>2];c[J+12>>2]=c[j+12>>2];c[H+0>>2]=c[z+0>>2];c[H+4>>2]=c[z+4>>2];c[H+8>>2]=c[z+8>>2];c[H+12>>2]=c[z+12>>2];c[G+0>>2]=c[j+0>>2];c[G+4>>2]=c[j+4>>2];c[G+8>>2]=c[j+8>>2];c[G+12>>2]=c[j+12>>2];P=ea(g[(ka?G:H)>>2]);aa=ea(g[(ka?G:H)+4>>2]);$=ea(g[(ka?G:H)+8>>2]);g[I>>2]=P;g[I+4>>2]=aa;g[I+8>>2]=$;g[I+12>>2]=ea(0.0);$=ea(g[(w?I:J)>>2]);aa=ea(g[(x?I:J)+4>>2]);P=ea(g[(s?I:J)+8>>2]);_=ea(W-X);W=ea(ba-T);ba=ea(U-R);U=ea(V-$);V=ea(M-aa);M=ea(L-P);L=w?(ka?O:Y):S;S=ea(X+ea(L*_));_=ea(T+ea(L*W));W=ea(R+ea(L*ba));ba=ea($+ea(L*U));U=ea(aa+ea(L*V));V=ea(P+ea(L*M));g[l>>2]=S;g[l+4>>2]=_;g[l+8>>2]=W;g[l+12>>2]=ea(0.0);g[m>>2]=ba;g[m+4>>2]=U;g[m+8>>2]=V;g[m+12>>2]=ea(0.0);M=ea(_-U);U=ea(W-V);g[a>>2]=ea(S-ba);g[a+4>>2]=M;g[a+8>>2]=U;g[a+12>>2]=ea(0.0);i=n;return}U=ea(g[h+16>>2]);M=ea(g[h+20>>2]);ba=ea(g[h+24>>2]);S=ea(g[h>>2]);V=ea(g[h+4>>2]);W=ea(g[h+8>>2]);_=ea(U-S);U=ea(M-V);M=ea(ba-W);ba=ea(g[h+32>>2]);L=ea(g[h+36>>2]);P=ea(ba-S);ba=ea(L-V);L=ea(ea(g[h+40>>2])-W);aa=ea(g[j+16>>2]);$=ea(g[j+20>>2]);R=ea(g[j+24>>2]);T=ea(g[j>>2]);X=ea(g[j+4>>2]);Y=ea(g[j+8>>2]);O=ea(aa-T);aa=ea($-X);$=ea(R-Y);R=ea(g[j+32>>2]);Z=ea(g[j+36>>2]);ma=ea(K*N);K=ea(Q*N);N=ea(ea(ea(ma*_)+ea(K*P))+S);S=ea(ea(ea(ma*U)+ea(K*ba))+V);V=ea(ea(ea(ma*M)+ea(K*L))+W);W=ea(ea(ea(ma*O)+ea(K*ea(R-T)))+T);T=ea(ea(ea(ma*aa)+ea(K*ea(Z-X)))+X);X=ea(ea(ea(ma*$)+ea(K*ea(ea(g[j+40>>2])-Y)))+Y);g[l>>2]=N;g[l+4>>2]=S;g[l+8>>2]=V;g[l+12>>2]=ea(0.0);g[m>>2]=W;g[m+4>>2]=T;g[m+8>>2]=X;g[m+12>>2]=ea(0.0);Y=ea(S-T);T=ea(V-X);g[a>>2]=ea(N-W);g[a+4>>2]=Y;g[a+8>>2]=T;g[a+12>>2]=ea(0.0);i=n;return}function W6a(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;m=i;i=i+32|0;n=m+12|0;o=m;if(l){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];p=ea(g[b>>2]);q=ea(g[b+4>>2]);r=ea(g[b+8>>2]);s=ea(g[a>>2]);t=ea(g[a+4>>2]);u=ea(p-s);s=ea(q-t);t=ea(r-ea(g[a+8>>2]));r=ea(T(ea(ea(ea(u*u)+ea(s*s))+ea(t*t))));q=ea(ea(1.0)/r);p=ea(s*q);s=ea(t*q);g[j>>2]=ea(u*q);g[j+4>>2]=p;g[j+8>>2]=s;g[j+12>>2]=ea(0.0);g[k>>2]=ea(-r);l=k+4|0;c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];i=m;return}else{r=ea(g[b>>2]);n=b+4|0;s=ea(g[n>>2]);l=b+8|0;p=ea(g[l>>2]);q=ea(g[a>>2]);u=ea(g[a+4>>2]);t=ea(g[a+8>>2]);v=ea(r-q);r=ea(s-u);s=ea(p-t);p=ea(T(ea(ea(ea(v*v)+ea(r*r))+ea(s*s))));w=ea(ea(1.0)/p);x=ea(v*w);v=ea(r*w);r=ea(s*w);w=ea(g[d+16>>2]);s=(c[d+64>>2]|0)==0?ea(0.0):w;w=ea(g[e+16>>2]);y=(c[e+64>>2]|0)==0?ea(0.0):w;w=ea(s+y);z=ea(u-ea(v*s));u=ea(t-ea(r*s));g[f>>2]=ea(q-ea(x*s));g[f+4>>2]=z;g[f+8>>2]=u;g[f+12>>2]=ea(0.0);u=ea(g[b>>2]);z=ea(g[n>>2]);s=ea(ea(v*y)+z);z=ea(ea(r*y)+ea(g[l>>2]));g[h>>2]=ea(ea(x*y)+u);g[h+4>>2]=s;g[h+8>>2]=z;g[h+12>>2]=ea(0.0);g[k>>2]=ea(-ea(p+w));h=k+4|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];g[j>>2]=x;g[j+4>>2]=v;g[j+8>>2]=r;g[j+12>>2]=ea(0.0);i=m;return}}function X6a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+512|0;k=j;l=e+4|0;m=e+8|0;n=f+256|0;o=h+130|0;p=0;q=b;b=d;d=1;while(1){r=q+58|0;do if(!(a[r>>0]|0)){s=ea(g[q>>2]);t=ea(g[q+4>>2]);u=ea(g[q+8>>2]);v=ea(g[e>>2]);w=ea(g[l>>2]);x=ea(ea(ea(s*v)+ea(t*w))+ea(u*ea(g[m>>2])));if(ea(g[q+12>>2])>x){y=c[n>>2]|0;c[n>>2]=y+1;c[f+(y<<3)>>2]=q;c[f+(y<<3)+4>>2]=b;y=d+-2|0;z=(y|0)<0?0:y;A=c[k+(z<<3)>>2]|0;B=c[k+(z<<3)+4>>2]|0;C=p;break}a[r>>0]=1;z=c[601072+(b<<2)>>2]|0;y=c[601072+(z<<2)>>2]|0;c[k+(p<<3)>>2]=c[q+(y<<2)+40>>2];c[k+(p<<3)+4>>2]=a[q+y+52>>0];y=d+1|0;D=c[q+(z<<2)+40>>2]|0;E=a[q+z+52>>0]|0;if(!(a[q+59>>0]|0)){z=a[q+60>>0]|0;F=a[o>>0]|0;a[o>>0]=F+1<<24>>24;a[h+(F&255)+64>>0]=z;A=D;B=E;C=y}else{A=D;B=E;C=y}}else{y=d+-2|0;E=(y|0)<0?0:y;A=c[k+(E<<3)>>2]|0;B=c[k+(E<<3)+4>>2]|0;C=p}while(0);if(!C)break;else{p=C+-1|0;q=A;b=B;d=C}}i=j;return}function Y6a(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;n=i;o=ea(g[h+(d<<4)>>2]);p=ea(g[h+(d<<4)+4>>2]);q=ea(g[h+(d<<4)+8>>2]);r=ea(g[h+(e<<4)>>2]);s=ea(g[h+(e<<4)+4>>2]);t=ea(g[h+(e<<4)+8>>2]);u=ea(g[h+(f<<4)>>2]);v=ea(g[h+(f<<4)+4>>2]);w=ea(g[h+(f<<4)+8>>2]);x=ea(g[j+(d<<4)>>2]);y=ea(g[j+(d<<4)+4>>2]);z=ea(g[j+(d<<4)+8>>2]);A=ea(g[j+(e<<4)>>2]);B=ea(g[j+(e<<4)+4>>2]);C=ea(g[j+(e<<4)+8>>2]);D=ea(g[j+(f<<4)>>2]);E=ea(g[j+(f<<4)+4>>2]);F=ea(o-x);x=ea(p-y);y=ea(q-z);z=ea(ea(r-A)-F);A=ea(ea(s-B)-x);B=ea(ea(t-C)-y);C=ea(ea(u-D)-F);D=ea(ea(v-E)-x);E=ea(ea(w-ea(g[j+(f<<4)+8>>2]))-y);w=ea(ea(A*E)-ea(B*D));v=ea(ea(B*C)-ea(z*E));u=ea(ea(z*D)-ea(A*C));t=ea(ea(ea(z*z)+ea(A*A))+ea(B*B));s=ea(ea(ea(z*C)+ea(A*D))+ea(B*E));r=ea(ea(ea(C*C)+ea(D*D))+ea(E*E));g[b+28>>2]=ea(ea(y*u)+ea(ea(F*w)+ea(x*v)));g[b+16>>2]=w;g[b+20>>2]=v;g[b+24>>2]=u;u=ea(ea(ea(F*z)+ea(x*A))+ea(y*B));v=ea(ea(ea(F*C)+ea(x*D))+ea(y*E));w=ea(ea(t*r)-ea(s*s));q=ea(ea(1.0)/w);p=ea(ea(v*s)-ea(u*r));r=ea(ea(u*s)-ea(t*v));v=ea(F+ea(q*ea(ea(z*p)+ea(C*r))));C=ea(x+ea(q*ea(ea(A*p)+ea(D*r))));D=ea(y+ea(q*ea(ea(B*p)+ea(E*r))));E=ea(ea(D*D)+ea(ea(v*v)+ea(C*C)));g[b+12>>2]=E;g[b>>2]=v;g[b+4>>2]=C;g[b+8>>2]=D;c[m>>2]=w>=ea(-1.1920929e-07)&1;m=p>ea(-1.1920929e-07);if(r>ea(-1.1920929e-07))G=w>ea(p+r);else G=0;f=m?G<<31>>31:0;j=m&G;g[b+32>>2]=ea(q*p);g[b+36>>2]=ea(q*r);if(!(E>=ea(g[k>>2]))){H=0;I=(f|0)!=0;J=H&I;K=J<<31>>31;L=(f|0)!=0;M=H&L;N=M<<31>>31;O=(f|0)!=0;P=H&O;Q=P<<31>>31;R=H&j;S=R<<31>>31;c[a>>2]=K;T=a+4|0;c[T>>2]=N;U=a+8|0;c[U>>2]=Q;V=a+12|0;c[V>>2]=S;i=n;return}H=ea(g[l>>2])>=E;I=(f|0)!=0;J=H&I;K=J<<31>>31;L=(f|0)!=0;M=H&L;N=M<<31>>31;O=(f|0)!=0;P=H&O;Q=P<<31>>31;R=H&j;S=R<<31>>31;c[a>>2]=K;T=a+4|0;c[T>>2]=N;U=a+8|0;c[U>>2]=Q;V=a+12|0;c[V>>2]=S;i=n;return}function Z6a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;h=ea(g[d>>2]);i=ea(g[d+4>>2]);j=ea(g[d+8>>2]);k=ea(g[b>>2]);l=ea(g[b+4>>2]);m=ea(g[b+8>>2]);n=ea(h-k);o=ea(i-l);p=ea(j-m);q=ea(g[e>>2]);r=ea(g[e+4>>2]);s=ea(g[e+8>>2]);t=ea(q-k);u=ea(r-l);v=ea(s-m);w=ea(g[f>>2]);x=ea(g[f+4>>2]);y=ea(g[f+8>>2]);z=ea(w-k);A=ea(x-l);B=ea(y-m);C=ea(w-h);D=ea(x-i);E=ea(y-j);F=ea(q-h);G=ea(r-i);H=ea(s-j);I=ea(ea(o*v)-ea(p*u));J=ea(ea(p*t)-ea(n*v));K=ea(ea(n*u)-ea(o*t));L=ea(ea(u*B)-ea(v*A));M=ea(ea(v*z)-ea(t*B));v=ea(ea(t*A)-ea(u*z));u=ea(ea(p*A)-ea(o*B));t=ea(ea(n*B)-ea(p*z));p=ea(ea(o*z)-ea(n*A));A=ea(ea(H*D)-ea(G*E));n=ea(ea(F*E)-ea(H*C));H=ea(ea(G*C)-ea(F*D));f=(ea(ea(ea(m*v)+ea(ea(k*L)+ea(l*M)))*ea(ea(j*v)+ea(ea(h*L)+ea(i*M))))>=ea(-9.99999997e-07))<<31>>31;e=(ea(ea(ea(m*p)+ea(ea(k*u)+ea(l*t)))*ea(ea(s*p)+ea(ea(q*u)+ea(r*t))))>=ea(-9.99999997e-07))<<31>>31;b=(ea(ea(ea(j*H)+ea(ea(h*A)+ea(i*n)))*ea(ea(m*H)+ea(ea(k*A)+ea(l*n))))>=ea(-9.99999997e-07))<<31>>31;c[a>>2]=(ea(ea(ea(m*K)+ea(ea(k*I)+ea(l*J)))*ea(ea(K*y)+ea(ea(w*I)+ea(x*J))))>=ea(-9.99999997e-07))<<31>>31;c[a+4>>2]=f;c[a+8>>2]=e;c[a+12>>2]=b;return}function _6a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=Im,ka=0,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=Im,hb=Im,ib=0,jb=0,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=0,xb=0,yb=0,zb=0;q=i;i=i+592|0;r=q+128|0;s=q+48|0;t=q+16|0;u=q;v=q+288|0;w=q+64|0;x=q+80|0;y=q+492|0;z=q+536|0;A=q+384|0;B=q+144|0;C=q+160|0;D=q+224|0;E=q+400|0;F=q+520|0;G=q+504|0;H=q+320|0;I=q+112|0;J=q+336|0;K=q+488|0;L=q+368|0;M=q+32|0;N=q+304|0;O=q+352|0;P=q+476|0;Q=q+464|0;R=q+96|0;S=q+548|0;U=q+560|0;V=q+572|0;W=ea(g[f>>2]);X=ea(g[b+16>>2]);Y=ea(g[e+16>>2]);Z=ea(g[b+32>>2]);_=ea(g[e+32>>2]);$=ea((Z>_?_:Z)*ea(.100000001));c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;Z=ea(X+Y);_=ea(W+Z);c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];aa=ea($*$);$=ea(_*_);c[H+0>>2]=c[v+0>>2];c[H+4>>2]=c[v+4>>2];c[H+8>>2]=c[v+8>>2];c[H+12>>2]=c[v+12>>2];c[I+0>>2]=c[v+0>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];c[I+12>>2]=c[v+12>>2];c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];c[K>>2]=0;f=a[o>>0]|0;if(!(f<<24>>24)){_=ea(g[b>>2]);ba=ea(g[b+4>>2]);ca=ea(g[b+8>>2]);da=ea(g[e>>2]);fa=ea(g[e+4>>2]);ga=ea(_-da);da=ea(ba-fa);fa=ea(ca-ea(g[e+8>>2]));ha=ea(ea(ea(ga*ga)+ea(da*da))+ea(fa*fa))>ea(0.0);g[u>>2]=ga;g[u+4>>2]=da;g[u+8>>2]=fa;g[u+12>>2]=ea(0.0);g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ia=ha?u:t;fa=ea(g[ia>>2]);da=ea(g[ia+4>>2]);ja=ea(3402823469999999843913219.0e14);ka=1;la=ea(g[ia+8>>2]);ma=da;na=fa}else{c[L+0>>2]=c[v+0>>2];c[L+4>>2]=c[v+4>>2];c[L+8>>2]=c[v+8>>2];c[L+12>>2]=c[v+12>>2];c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];c[M+12>>2]=c[v+12>>2];c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];c[N+12>>2]=c[v+12>>2];v=b+96|0;ia=e+144|0;t=r+4|0;u=r+8|0;ha=r+12|0;oa=I+4|0;pa=I+8|0;qa=I+12|0;ra=H+4|0;sa=H+8|0;ta=J+4|0;ua=J+8|0;va=J+12|0;fa=ea(g[e+144>>2]);da=ea(g[e+148>>2]);ga=ea(g[e+152>>2]);wa=0;xa=0;while(1){ya=d[m+xa>>0]|0;c[F+(xa<<2)>>2]=ya;za=d[n+xa>>0]|0;c[G+(xa<<2)>>2]=za;Aa=v+(1-ya<<4)|0;c[H+0>>2]=c[Aa+0>>2];c[H+4>>2]=c[Aa+4>>2];c[H+8>>2]=c[Aa+8>>2];c[H+12>>2]=c[Aa+12>>2];Aa=c[540320+(za<<4)>>2]|0;ya=c[540324+(za<<4)>>2]|0;Ba=c[540328+(za<<4)>>2]|0;c[s+0>>2]=c[ia+0>>2];c[s+4>>2]=c[ia+4>>2];c[s+8>>2]=c[ia+8>>2];c[s+12>>2]=c[ia+12>>2];ca=ea(-da);ba=ea(-ga);g[r>>2]=ea(-fa);g[t>>2]=ca;g[u>>2]=ba;g[ha>>2]=ea(0.0);ba=ea(g[((Aa|0)==0?r:s)>>2]);ca=ea(g[((ya|0)==0?r:s)+4>>2]);_=ea(g[((Ba|0)==0?r:s)+8>>2]);g[I>>2]=ba;g[oa>>2]=ca;g[pa>>2]=_;g[qa>>2]=ea(0.0);Ca=ea(g[H>>2]);Da=ea(g[ra>>2]);Ea=ea(Da-ca);ca=ea(ea(g[sa>>2])-_);g[J>>2]=ea(Ca-ba);g[ta>>2]=Ea;g[ua>>2]=ca;g[va>>2]=ea(0.0);Ba=D+(wa<<4)|0;c[M+0>>2]=c[H+0>>2];c[M+4>>2]=c[H+4>>2];c[M+8>>2]=c[H+8>>2];c[M+12>>2]=c[H+12>>2];c[Ba+0>>2]=c[H+0>>2];c[Ba+4>>2]=c[H+4>>2];c[Ba+8>>2]=c[H+8>>2];c[Ba+12>>2]=c[H+12>>2];Ba=E+(wa<<4)|0;c[N+0>>2]=c[I+0>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];c[N+12>>2]=c[I+12>>2];c[Ba+0>>2]=c[I+0>>2];c[Ba+4>>2]=c[I+4>>2];c[Ba+8>>2]=c[I+8>>2];c[Ba+12>>2]=c[I+12>>2];Fa=wa+1|0;Ba=C+(wa<<4)|0;c[L+0>>2]=c[J+0>>2];c[L+4>>2]=c[J+4>>2];c[L+8>>2]=c[J+8>>2];c[L+12>>2]=c[J+12>>2];c[Ba+0>>2]=c[J+0>>2];c[Ba+4>>2]=c[J+4>>2];c[Ba+8>>2]=c[J+8>>2];c[Ba+12>>2]=c[J+12>>2];xa=xa+1|0;if(xa>>>0>=(f&255)>>>0)break;else wa=Fa}c[K>>2]=Fa;do if((wa|0)==3)qPa(O,C,D,E,F,G,L,M,N,K,w,x);else if(!wa){c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[x+0>>2]=c[N+0>>2];c[x+4>>2]=c[N+4>>2];c[x+8>>2]=c[N+8>>2];c[x+12>>2]=c[N+12>>2];c[O+0>>2]=c[L+0>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2];c[O+12>>2]=c[L+12>>2]}else if((wa|0)==2)V6a(O,C,C+16|0,L,C,D,E,K,w,x);else if((wa|0)==1){fa=ea(g[C>>2]);ga=ea(g[C+4>>2]);da=ea(g[C+8>>2]);ca=ea(g[L>>2]);Ea=ea(g[L+4>>2]);ba=ea(ca-fa);ca=ea(Ea-ga);Ea=ea(ea(g[L+8>>2])-da);Ca=ea(ea(ea(ba*ba)+ea(ca*ca))+ea(Ea*Ea));if(Ca==ea(0.0)){c[K>>2]=1;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[x+0>>2]=c[E+0>>2];c[x+4>>2]=c[E+4>>2];c[x+8>>2]=c[E+8>>2];c[x+12>>2]=c[E+12>>2];c[O+0>>2]=c[C+0>>2];c[O+4>>2]=c[C+4>>2];c[O+8>>2]=c[C+8>>2];c[O+12>>2]=c[C+12>>2];break}else{_=ea(ea(ea(-ea(ga*ca))-ea(fa*ba))-ea(da*Ea));Ea=ea(g[M>>2]);da=ea(g[M+4>>2]);ba=ea(g[M+8>>2]);fa=ea(g[D>>2]);ca=ea(g[D+4>>2]);ga=ea(g[D+8>>2]);Da=ea(Ea-fa);Ea=ea(da-ca);da=ea(ba-ga);ba=ea(g[N>>2]);Ga=ea(g[N+4>>2]);Ha=ea(g[N+8>>2]);Ia=ea(g[E>>2]);Ja=ea(g[E+4>>2]);Ka=ea(g[E+8>>2]);La=ea(ba-Ia);ba=ea(Ga-Ja);Ga=ea(Ha-Ka);Ha=ea(_/Ca);Fa=Ha>ea(1.0);Ca=Fa?ea(1.0):Ha;Fa=Ca>ea(0.0);Ha=Fa?Ca:ea(0.0);Ca=ea(fa+ea(Da*Ha));Da=ea(ca+ea(Ea*Ha));Ea=ea(ga+ea(da*Ha));da=ea(Ia+ea(La*Ha));La=ea(Ja+ea(ba*Ha));ba=ea(Ka+ea(Ga*Ha));g[w>>2]=Ca;g[w+4>>2]=Da;g[w+8>>2]=Ea;g[w+12>>2]=ea(0.0);g[x>>2]=da;g[x+4>>2]=La;g[x+8>>2]=ba;g[x+12>>2]=ea(0.0);Ha=ea(Da-La);La=ea(Ea-ba);g[O>>2]=ea(Ca-da);g[O+4>>2]=Ha;g[O+8>>2]=La;g[O+12>>2]=ea(0.0);break}}else{c[O+0>>2]=c[L+0>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2];c[O+12>>2]=c[L+12>>2]}while(0);La=ea(g[O>>2]);Ha=ea(g[O+4>>2]);da=ea(g[O+8>>2]);Ca=ea(ea(ea(La*La)+ea(Ha*Ha))+ea(da*da));c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];ja=Ca;ka=Ca>aa;la=da;ma=Ha;na=La}do if(ka){O=b+96|0;L=b+96|0;N=b+100|0;M=b+104|0;wa=b+112|0;Fa=b+112|0;f=b+116|0;xa=b+120|0;va=H+4|0;ua=H+8|0;ta=H+12|0;sa=e+144|0;ra=e+144|0;qa=e+148|0;pa=e+152|0;oa=r+4|0;ha=r+8|0;u=r+12|0;t=I+4|0;ia=I+8|0;v=I+12|0;Ba=J+4|0;ya=J+8|0;Aa=J+12|0;za=b+48|0;Ma=e+48|0;Na=R+4|0;Oa=R+8|0;Pa=C+4|0;Qa=C+8|0;Ra=D+4|0;Sa=D+8|0;Ta=E+4|0;Ua=E+8|0;Va=w+4|0;Wa=w+8|0;Xa=w+12|0;Ya=x+4|0;Za=x+8|0;_a=x+12|0;$a=R+12|0;ab=C+16|0;La=W;Ha=na;da=ma;Ca=la;ba=ja;while(1){c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];Ea=ea(-Ha);Da=ea(-da);Ga=ea(-Ca);bb=c[K>>2]|0;Ka=ea(g[L>>2]);Ja=ea(g[N>>2]);Ia=ea(ea(ea(Ka*Ea)+ea(Ja*Da))+ea(ea(g[M>>2])*Ga));Ja=ea(g[Fa>>2]);Ka=ea(g[f>>2]);cb=Ia>ea(ea(ea(Ja*Ea)+ea(Ka*Da))+ea(ea(g[xa>>2])*Ga));c[F+(bb<<2)>>2]=cb&1;c[s+0>>2]=c[O+0>>2];c[s+4>>2]=c[O+4>>2];c[s+8>>2]=c[O+8>>2];c[s+12>>2]=c[O+12>>2];c[r+0>>2]=c[wa+0>>2];c[r+4>>2]=c[wa+4>>2];c[r+8>>2]=c[wa+8>>2];c[r+12>>2]=c[wa+12>>2];db=cb?s:r;Ga=ea(g[db>>2]);Da=ea(g[db+4>>2]);Ka=ea(g[db+8>>2]);g[D+(bb<<4)>>2]=Ga;g[D+(bb<<4)+4>>2]=Da;g[D+(bb<<4)+8>>2]=Ka;g[D+(bb<<4)+12>>2]=ea(0.0);g[H>>2]=Ga;g[va>>2]=Da;g[ua>>2]=Ka;g[ta>>2]=ea(0.0);db=Ha>ea(0.0);cb=da>ea(0.0);eb=Ca>ea(0.0);c[G+(bb<<2)>>2]=eb<<31>>31<<2&4|db&1|cb<<31>>31<<1&2;c[s+0>>2]=c[sa+0>>2];c[s+4>>2]=c[sa+4>>2];c[s+8>>2]=c[sa+8>>2];c[s+12>>2]=c[sa+12>>2];Ea=ea(g[ra>>2]);Ja=ea(g[qa>>2]);Ia=ea(-Ja);Ja=ea(-ea(g[pa>>2]));g[r>>2]=ea(-Ea);g[oa>>2]=Ia;g[ha>>2]=Ja;g[u>>2]=ea(0.0);Ja=ea(g[(db?s:r)>>2]);Ia=ea(g[(cb?s:r)+4>>2]);Ea=ea(g[(eb?s:r)+8>>2]);g[E+(bb<<4)>>2]=Ja;g[E+(bb<<4)+4>>2]=Ia;g[E+(bb<<4)+8>>2]=Ea;g[E+(bb<<4)+12>>2]=ea(0.0);g[I>>2]=Ja;g[t>>2]=Ia;g[ia>>2]=Ea;g[v>>2]=ea(0.0);ga=ea(Ga-Ja);ca=ea(Da-Ia);fa=ea(Ka-Ea);g[J>>2]=ga;g[Ba>>2]=ca;g[ya>>2]=fa;g[Aa>>2]=ea(0.0);fb=c[K>>2]|0;c[K>>2]=fb+1;bb=C+(fb<<4)|0;c[bb+0>>2]=c[J+0>>2];c[bb+4>>2]=c[J+4>>2];c[bb+8>>2]=c[J+8>>2];c[bb+12>>2]=c[J+12>>2];_=ea(g[za>>2]);gb=ea(g[Ma>>2]);hb=_>gb?_:gb;La=La>hb?La:hb;hb=ea(Z+La);gb=ea(ea(ea(Ha*ga)+ea(da*ca))+ea(Ca*fa));bb=ea(gb*gb)>ea(ba*ea(hb*hb));if(gb>ea(0.0)){ib=bb;jb=bb^1}else{ib=0;jb=1}bb=ea(aa*ba)>=ea(ba-gb);if((bb|ib)&(bb|jb^1))break;do if((fb|0)==1){gb=ea(g[C>>2]);hb=ea(g[Pa>>2]);_=ea(g[Qa>>2]);kb=ea(ga-gb);lb=ea(ca-hb);mb=ea(fa-_);nb=ea(ea(ea(kb*kb)+ea(lb*lb))+ea(mb*mb));if(nb==ea(0.0)){c[K>>2]=1;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[x+0>>2]=c[E+0>>2];c[x+4>>2]=c[E+4>>2];c[x+8>>2]=c[E+8>>2];c[x+12>>2]=c[E+12>>2];c[R+0>>2]=c[C+0>>2];c[R+4>>2]=c[C+4>>2];c[R+8>>2]=c[C+8>>2];c[R+12>>2]=c[C+12>>2];break}else{ob=ea(ea(ea(-ea(hb*lb))-ea(gb*kb))-ea(_*mb));mb=ea(g[D>>2]);_=ea(g[Ra>>2]);kb=ea(g[Sa>>2]);gb=ea(Ga-mb);lb=ea(Da-_);hb=ea(Ka-kb);pb=ea(g[E>>2]);qb=ea(g[Ta>>2]);rb=ea(g[Ua>>2]);sb=ea(Ja-pb);tb=ea(Ia-qb);ub=ea(Ea-rb);vb=ea(ob/nb);bb=vb>ea(1.0);nb=bb?ea(1.0):vb;bb=nb>ea(0.0);vb=bb?nb:ea(0.0);nb=ea(mb+ea(gb*vb));gb=ea(_+ea(lb*vb));lb=ea(kb+ea(hb*vb));hb=ea(pb+ea(sb*vb));sb=ea(qb+ea(tb*vb));tb=ea(rb+ea(ub*vb));g[w>>2]=nb;g[Va>>2]=gb;g[Wa>>2]=lb;g[Xa>>2]=ea(0.0);g[x>>2]=hb;g[Ya>>2]=sb;g[Za>>2]=tb;g[_a>>2]=ea(0.0);vb=ea(gb-sb);sb=ea(lb-tb);g[R>>2]=ea(nb-hb);g[Na>>2]=vb;g[Oa>>2]=sb;g[$a>>2]=ea(0.0);break}}else if(!fb){c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[x+0>>2]=c[I+0>>2];c[x+4>>2]=c[I+4>>2];c[x+8>>2]=c[I+8>>2];c[x+12>>2]=c[I+12>>2];c[R+0>>2]=c[J+0>>2];c[R+4>>2]=c[J+4>>2];c[R+8>>2]=c[J+8>>2];c[R+12>>2]=c[J+12>>2]}else if((fb|0)==2)V6a(R,C,ab,J,C,D,E,K,w,x);else if((fb|0)==3)qPa(R,C,D,E,F,G,J,H,I,K,w,x);else{c[R+0>>2]=c[J+0>>2];c[R+4>>2]=c[J+4>>2];c[R+8>>2]=c[J+8>>2];c[R+12>>2]=c[J+12>>2]}while(0);Ea=ea(g[R>>2]);Ia=ea(g[Na>>2]);Ja=ea(g[Oa>>2]);Ka=ea(ea(ea(Ea*Ea)+ea(Ia*Ia))+ea(Ja*Ja));c[y+0>>2]=c[S+0>>2];c[y+4>>2]=c[S+4>>2];c[y+8>>2]=c[S+8>>2];wb=ba>Ka;if(Ka>aa^1|wb^1){xb=36;break}else{Ha=Ea;da=Ia;Ca=Ja;ba=Ka}}if((xb|0)==36){Oa=c[K>>2]|0;if(wb){yb=Oa;break}Na=Oa+-1|0;if((m|0)!=0?(a[o>>0]=Na,(Na|0)!=0):0){Oa=0;do{a[m+Oa>>0]=c[F+(Oa<<2)>>2];a[n+Oa>>0]=c[G+(Oa<<2)>>2];Oa=Oa+1|0}while((Oa|0)!=(Na|0))};c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];La=ea(g[w>>2]);Ka=ea(g[w+4>>2]);Ja=ea(g[w+8>>2]);Ia=ea(g[x>>2]);Ea=ea(g[x+4>>2]);Da=ea(g[x+8>>2]);Ga=ea(T(ea(ba)));fa=ea(ea(1.0)/Ga);ca=ea(ea(La-Ia)*fa);ga=ea(ea(Ka-Ea)*fa);sb=ea(ea(Ja-Da)*fa);if(p){fa=(c[b+64>>2]|0)==0?X:ea(0.0);vb=(c[e+64>>2]|0)==0?Y:ea(0.0);hb=ea(fa+vb);nb=ea(Ka-ea(ga*fa));tb=ea(Ja-ea(sb*fa));g[h>>2]=ea(La-ea(ca*fa));g[h+4>>2]=nb;g[h+8>>2]=tb;g[h+12>>2]=ea(0.0);tb=ea(ea(ga*vb)+Ea);nb=ea(ea(sb*vb)+Da);g[j>>2]=ea(ea(ca*vb)+Ia);g[j+4>>2]=tb;g[j+8>>2]=nb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ga-hb);Na=l+4|0;c[Na+0>>2]=c[U+0>>2];c[Na+4>>2]=c[U+4>>2];c[Na+8>>2]=c[U+8>>2]}else{hb=ea(Ka-ea(X*ga));Ka=ea(Ja-ea(X*sb));g[h>>2]=ea(La-ea(X*ca));g[h+4>>2]=hb;g[h+8>>2]=Ka;g[h+12>>2]=ea(0.0);Ka=ea(ea(Y*ga)+Ea);Ea=ea(ea(Y*sb)+Da);g[j>>2]=ea(ea(Y*ca)+Ia);g[j+4>>2]=Ka;g[j+8>>2]=Ea;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ga-Z);Na=l+4|0;c[Na+0>>2]=c[V+0>>2];c[Na+4>>2]=c[V+4>>2];c[Na+8>>2]=c[V+8>>2]}g[k>>2]=ca;g[k+4>>2]=ga;g[k+8>>2]=sb;g[k+12>>2]=ea(0.0);zb=$>=ba?1:3;i=q;return zb|0}if((m|0)!=0?(a[o>>0]=fb,(fb|0)!=0):0){Na=0;do{a[m+Na>>0]=c[F+(Na<<2)>>2];a[n+Na>>0]=c[G+(Na<<2)>>2];Na=Na+1|0}while((Na|0)!=(fb|0))}if(!(jb&(ib^1))){zb=0;i=q;return zb|0}sb=ea(T(ea(ba)));ga=ea(ea(1.0)/sb);ca=ea(Ha*ga);Ga=ea(da*ga);Ea=ea(Ca*ga);g[k>>2]=ca;g[k+4>>2]=Ga;g[k+8>>2]=Ea;g[k+12>>2]=ea(0.0);if(p){ga=(c[b+64>>2]|0)==0?X:ea(0.0);Ka=(c[e+64>>2]|0)==0?Y:ea(0.0);Ia=ea(ga+Ka);Da=ea(g[w>>2]);hb=ea(g[Va>>2]);La=ea(hb-ea(Ga*ga));hb=ea(ea(g[Wa>>2])-ea(Ea*ga));g[h>>2]=ea(Da-ea(ca*ga));g[h+4>>2]=La;g[h+8>>2]=hb;g[h+12>>2]=ea(0.0);hb=ea(g[x>>2]);La=ea(g[Ya>>2]);ga=ea(ea(Ga*Ka)+La);La=ea(ea(Ea*Ka)+ea(g[Za>>2]));g[j>>2]=ea(ea(ca*Ka)+hb);g[j+4>>2]=ga;g[j+8>>2]=La;g[j+12>>2]=ea(0.0);g[l>>2]=ea(sb-Ia);Na=l+4|0;c[Na+0>>2]=c[P+0>>2];c[Na+4>>2]=c[P+4>>2];c[Na+8>>2]=c[P+8>>2];zb=1;i=q;return zb|0}else{Ia=ea(g[w>>2]);La=ea(g[Va>>2]);ga=ea(La-ea(X*Ga));La=ea(ea(g[Wa>>2])-ea(X*Ea));g[h>>2]=ea(Ia-ea(X*ca));g[h+4>>2]=ga;g[h+8>>2]=La;g[h+12>>2]=ea(0.0);La=ea(g[x>>2]);ga=ea(g[Ya>>2]);Ia=ea(ea(Y*Ga)+ga);ga=ea(ea(Y*Ea)+ea(g[Za>>2]));g[j>>2]=ea(ea(Y*ca)+La);g[j+4>>2]=Ia;g[j+8>>2]=ga;g[j+12>>2]=ea(0.0);g[l>>2]=ea(sb-Z);Na=l+4|0;c[Na+0>>2]=c[Q+0>>2];c[Na+4>>2]=c[Q+4>>2];c[Na+8>>2]=c[Q+8>>2];zb=1;i=q;return zb|0}}else yb=c[K>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=yb,(yb|0)!=0):0){o=0;do{a[m+o>>0]=c[F+(o<<2)>>2];a[n+o>>0]=c[G+(o<<2)>>2];o=o+1|0}while((o|0)!=(yb|0))};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];zb=6;i=q;return zb|0}function $6a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=Im,la=0,ma=Im,na=Im,oa=Im,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=Im,kb=Im,lb=0,mb=0,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=0,Ab=0,Bb=0,Cb=0;q=i;i=i+592|0;r=q+128|0;s=q+48|0;t=q+16|0;u=q;v=q+288|0;w=q+64|0;x=q+80|0;y=q+492|0;z=q+536|0;A=q+384|0;B=q+144|0;C=q+160|0;D=q+224|0;E=q+400|0;F=q+520|0;G=q+504|0;H=q+320|0;I=q+112|0;J=q+336|0;K=q+488|0;L=q+368|0;M=q+32|0;N=q+304|0;O=q+352|0;P=q+476|0;Q=q+464|0;R=q+96|0;S=q+548|0;U=q+560|0;V=q+572|0;W=ea(g[f>>2]);X=ea(g[b+16>>2]);f=e+16|0;Y=ea(g[f>>2]);Z=ea(g[b+32>>2]);_=ea(g[e+32>>2]);$=ea((Z>_?_:Z)*ea(.100000001));c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;Z=ea(X+Y);_=ea(W+Z);c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];aa=ea($*$);$=ea(_*_);c[H+0>>2]=c[v+0>>2];c[H+4>>2]=c[v+4>>2];c[H+8>>2]=c[v+8>>2];c[H+12>>2]=c[v+12>>2];c[I+0>>2]=c[v+0>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];c[I+12>>2]=c[v+12>>2];c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];c[K>>2]=0;ba=a[o>>0]|0;if(!(ba<<24>>24)){_=ea(g[b>>2]);ca=ea(g[b+4>>2]);da=ea(g[b+8>>2]);fa=ea(g[e>>2]);ga=ea(g[e+4>>2]);ha=ea(_-fa);fa=ea(ca-ga);ga=ea(da-ea(g[e+8>>2]));ia=ea(ea(ea(ha*ha)+ea(fa*fa))+ea(ga*ga))>ea(0.0);g[u>>2]=ha;g[u+4>>2]=fa;g[u+8>>2]=ga;g[u+12>>2]=ea(0.0);g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ja=ia?u:t;ga=ea(g[ja>>2]);fa=ea(g[ja+4>>2]);ka=ea(3402823469999999843913219.0e14);la=1;ma=ea(g[ja+8>>2]);na=fa;oa=ga}else{c[L+0>>2]=c[v+0>>2];c[L+4>>2]=c[v+4>>2];c[L+8>>2]=c[v+8>>2];c[L+12>>2]=c[v+12>>2];c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];c[M+12>>2]=c[v+12>>2];c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];c[N+12>>2]=c[v+12>>2];v=b+96|0;ja=s+4|0;t=s+8|0;u=s+12|0;ia=r+4|0;pa=r+8|0;qa=r+12|0;ra=I+4|0;sa=I+8|0;ta=I+12|0;ua=H+4|0;va=H+8|0;wa=J+4|0;xa=J+8|0;ya=J+12|0;ga=ea(g[e+144>>2]);fa=ea(g[e+148>>2]);ha=ea(g[e+152>>2]);za=0;Aa=0;while(1){Ba=d[m+Aa>>0]|0;c[F+(Aa<<2)>>2]=Ba;Ca=d[n+Aa>>0]|0;c[G+(Aa<<2)>>2]=Ca;Da=v+(1-Ba<<4)|0;c[H+0>>2]=c[Da+0>>2];c[H+4>>2]=c[Da+4>>2];c[H+8>>2]=c[Da+8>>2];c[H+12>>2]=c[Da+12>>2];da=ea(ga-Y);ca=ea(fa-Y);_=ea(ha-Y);Da=c[540320+(Ca<<4)>>2]|0;Ba=c[540324+(Ca<<4)>>2]|0;Ea=c[540328+(Ca<<4)>>2]|0;Fa=ea(-da);Ga=ea(-ca);Ha=ea(-_);g[s>>2]=da;g[ja>>2]=ca;g[t>>2]=_;g[u>>2]=ea(0.0);g[r>>2]=Fa;g[ia>>2]=Ga;g[pa>>2]=Ha;g[qa>>2]=ea(0.0);Ha=ea(g[((Da|0)==0?r:s)>>2]);Ga=ea(g[((Ba|0)==0?r:s)+4>>2]);Fa=ea(g[((Ea|0)==0?r:s)+8>>2]);g[I>>2]=Ha;g[ra>>2]=Ga;g[sa>>2]=Fa;g[ta>>2]=ea(0.0);_=ea(g[H>>2]);ca=ea(g[ua>>2]);da=ea(ca-Ga);Ga=ea(ea(g[va>>2])-Fa);g[J>>2]=ea(_-Ha);g[wa>>2]=da;g[xa>>2]=Ga;g[ya>>2]=ea(0.0);Ea=D+(za<<4)|0;c[M+0>>2]=c[H+0>>2];c[M+4>>2]=c[H+4>>2];c[M+8>>2]=c[H+8>>2];c[M+12>>2]=c[H+12>>2];c[Ea+0>>2]=c[H+0>>2];c[Ea+4>>2]=c[H+4>>2];c[Ea+8>>2]=c[H+8>>2];c[Ea+12>>2]=c[H+12>>2];Ea=E+(za<<4)|0;c[N+0>>2]=c[I+0>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];c[N+12>>2]=c[I+12>>2];c[Ea+0>>2]=c[I+0>>2];c[Ea+4>>2]=c[I+4>>2];c[Ea+8>>2]=c[I+8>>2];c[Ea+12>>2]=c[I+12>>2];Ia=za+1|0;Ea=C+(za<<4)|0;c[L+0>>2]=c[J+0>>2];c[L+4>>2]=c[J+4>>2];c[L+8>>2]=c[J+8>>2];c[L+12>>2]=c[J+12>>2];c[Ea+0>>2]=c[J+0>>2];c[Ea+4>>2]=c[J+4>>2];c[Ea+8>>2]=c[J+8>>2];c[Ea+12>>2]=c[J+12>>2];Aa=Aa+1|0;if(Aa>>>0>=(ba&255)>>>0)break;else za=Ia}c[K>>2]=Ia;do if(!za){c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[x+0>>2]=c[N+0>>2];c[x+4>>2]=c[N+4>>2];c[x+8>>2]=c[N+8>>2];c[x+12>>2]=c[N+12>>2];c[O+0>>2]=c[L+0>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2];c[O+12>>2]=c[L+12>>2]}else if((za|0)==2)V6a(O,C,C+16|0,L,C,D,E,K,w,x);else if((za|0)==3)qPa(O,C,D,E,F,G,L,M,N,K,w,x);else if((za|0)==1){ha=ea(g[C>>2]);fa=ea(g[C+4>>2]);ga=ea(g[C+8>>2]);Ga=ea(g[L>>2]);da=ea(g[L+4>>2]);Ha=ea(Ga-ha);Ga=ea(da-fa);da=ea(ea(g[L+8>>2])-ga);_=ea(ea(ea(Ha*Ha)+ea(Ga*Ga))+ea(da*da));if(_==ea(0.0)){c[K>>2]=1;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[x+0>>2]=c[E+0>>2];c[x+4>>2]=c[E+4>>2];c[x+8>>2]=c[E+8>>2];c[x+12>>2]=c[E+12>>2];c[O+0>>2]=c[C+0>>2];c[O+4>>2]=c[C+4>>2];c[O+8>>2]=c[C+8>>2];c[O+12>>2]=c[C+12>>2];break}else{Fa=ea(ea(ea(-ea(fa*Ga))-ea(ha*Ha))-ea(ga*da));da=ea(g[M>>2]);ga=ea(g[M+4>>2]);Ha=ea(g[M+8>>2]);ha=ea(g[D>>2]);Ga=ea(g[D+4>>2]);fa=ea(g[D+8>>2]);ca=ea(da-ha);da=ea(ga-Ga);ga=ea(Ha-fa);Ha=ea(g[N>>2]);Ja=ea(g[N+4>>2]);Ka=ea(g[N+8>>2]);La=ea(g[E>>2]);Ma=ea(g[E+4>>2]);Na=ea(g[E+8>>2]);Oa=ea(Ha-La);Ha=ea(Ja-Ma);Ja=ea(Ka-Na);Ka=ea(Fa/_);Ia=Ka>ea(1.0);_=Ia?ea(1.0):Ka;Ia=_>ea(0.0);Ka=Ia?_:ea(0.0);_=ea(ha+ea(ca*Ka));ca=ea(Ga+ea(da*Ka));da=ea(fa+ea(ga*Ka));ga=ea(La+ea(Oa*Ka));Oa=ea(Ma+ea(Ha*Ka));Ha=ea(Na+ea(Ja*Ka));g[w>>2]=_;g[w+4>>2]=ca;g[w+8>>2]=da;g[w+12>>2]=ea(0.0);g[x>>2]=ga;g[x+4>>2]=Oa;g[x+8>>2]=Ha;g[x+12>>2]=ea(0.0);Ka=ea(ca-Oa);Oa=ea(da-Ha);g[O>>2]=ea(_-ga);g[O+4>>2]=Ka;g[O+8>>2]=Oa;g[O+12>>2]=ea(0.0);break}}else{c[O+0>>2]=c[L+0>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2];c[O+12>>2]=c[L+12>>2]}while(0);Oa=ea(g[O>>2]);Ka=ea(g[O+4>>2]);ga=ea(g[O+8>>2]);_=ea(ea(ea(Oa*Oa)+ea(Ka*Ka))+ea(ga*ga));c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];ka=_;la=_>aa;ma=ga;na=Ka;oa=Oa}do if(la){O=b+96|0;L=b+96|0;N=b+100|0;M=b+104|0;za=b+112|0;Ia=b+112|0;ba=b+116|0;Aa=b+120|0;ya=H+4|0;xa=H+8|0;wa=H+12|0;va=e+144|0;ua=e+148|0;ta=e+152|0;sa=s+4|0;ra=s+8|0;qa=s+12|0;pa=r+4|0;ia=r+8|0;u=r+12|0;t=I+4|0;ja=I+8|0;v=I+12|0;Ea=J+4|0;Ba=J+8|0;Da=J+12|0;Ca=b+48|0;Pa=e+48|0;Qa=R+4|0;Ra=R+8|0;Sa=C+4|0;Ta=C+8|0;Ua=D+4|0;Va=D+8|0;Wa=E+4|0;Xa=E+8|0;Ya=w+4|0;Za=w+8|0;_a=w+12|0;$a=x+4|0;ab=x+8|0;bb=x+12|0;cb=R+12|0;db=C+16|0;Oa=W;Ka=oa;ga=na;_=ma;Ha=ka;while(1){c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];da=ea(-Ka);ca=ea(-ga);Ja=ea(-_);eb=c[K>>2]|0;Na=ea(g[L>>2]);Ma=ea(g[N>>2]);La=ea(ea(ea(Na*da)+ea(Ma*ca))+ea(ea(g[M>>2])*Ja));Ma=ea(g[Ia>>2]);Na=ea(g[ba>>2]);fb=La>ea(ea(ea(Ma*da)+ea(Na*ca))+ea(ea(g[Aa>>2])*Ja));c[F+(eb<<2)>>2]=fb&1;c[s+0>>2]=c[O+0>>2];c[s+4>>2]=c[O+4>>2];c[s+8>>2]=c[O+8>>2];c[s+12>>2]=c[O+12>>2];c[r+0>>2]=c[za+0>>2];c[r+4>>2]=c[za+4>>2];c[r+8>>2]=c[za+8>>2];c[r+12>>2]=c[za+12>>2];gb=fb?s:r;Ja=ea(g[gb>>2]);ca=ea(g[gb+4>>2]);Na=ea(g[gb+8>>2]);g[D+(eb<<4)>>2]=Ja;g[D+(eb<<4)+4>>2]=ca;g[D+(eb<<4)+8>>2]=Na;g[D+(eb<<4)+12>>2]=ea(0.0);g[H>>2]=Ja;g[ya>>2]=ca;g[xa>>2]=Na;g[wa>>2]=ea(0.0);da=ea(g[va>>2]);Ma=ea(g[ua>>2]);La=ea(g[ta>>2]);fa=ea(g[f>>2]);Ga=ea(da-fa);da=ea(Ma-fa);Ma=ea(La-fa);gb=Ka>ea(0.0);fb=ga>ea(0.0);hb=_>ea(0.0);c[G+(eb<<2)>>2]=hb<<31>>31<<2&4|gb&1|fb<<31>>31<<1&2;fa=ea(-Ga);La=ea(-da);ha=ea(-Ma);g[s>>2]=Ga;g[sa>>2]=da;g[ra>>2]=Ma;g[qa>>2]=ea(0.0);g[r>>2]=fa;g[pa>>2]=La;g[ia>>2]=ha;g[u>>2]=ea(0.0);ha=ea(g[(gb?s:r)>>2]);La=ea(g[(fb?s:r)+4>>2]);fa=ea(g[(hb?s:r)+8>>2]);g[E+(eb<<4)>>2]=ha;g[E+(eb<<4)+4>>2]=La;g[E+(eb<<4)+8>>2]=fa;g[E+(eb<<4)+12>>2]=ea(0.0);g[I>>2]=ha;g[t>>2]=La;g[ja>>2]=fa;g[v>>2]=ea(0.0);Ma=ea(Ja-ha);da=ea(ca-La);Ga=ea(Na-fa);g[J>>2]=Ma;g[Ea>>2]=da;g[Ba>>2]=Ga;g[Da>>2]=ea(0.0);ib=c[K>>2]|0;c[K>>2]=ib+1;eb=C+(ib<<4)|0;c[eb+0>>2]=c[J+0>>2];c[eb+4>>2]=c[J+4>>2];c[eb+8>>2]=c[J+8>>2];c[eb+12>>2]=c[J+12>>2];Fa=ea(g[Ca>>2]);jb=ea(g[Pa>>2]);kb=Fa>jb?Fa:jb;Oa=Oa>kb?Oa:kb;kb=ea(Z+Oa);jb=ea(ea(ea(Ka*Ma)+ea(ga*da))+ea(_*Ga));eb=ea(jb*jb)>ea(Ha*ea(kb*kb));if(jb>ea(0.0)){lb=eb;mb=eb^1}else{lb=0;mb=1}eb=ea(aa*Ha)>=ea(Ha-jb);if((eb|lb)&(eb|mb^1))break;do if((ib|0)==2)V6a(R,C,db,J,C,D,E,K,w,x);else if((ib|0)==1){jb=ea(g[C>>2]);kb=ea(g[Sa>>2]);Fa=ea(g[Ta>>2]);nb=ea(Ma-jb);ob=ea(da-kb);pb=ea(Ga-Fa);qb=ea(ea(ea(nb*nb)+ea(ob*ob))+ea(pb*pb));if(qb==ea(0.0)){c[K>>2]=1;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[x+0>>2]=c[E+0>>2];c[x+4>>2]=c[E+4>>2];c[x+8>>2]=c[E+8>>2];c[x+12>>2]=c[E+12>>2];c[R+0>>2]=c[C+0>>2];c[R+4>>2]=c[C+4>>2];c[R+8>>2]=c[C+8>>2];c[R+12>>2]=c[C+12>>2];break}else{rb=ea(ea(ea(-ea(kb*ob))-ea(jb*nb))-ea(Fa*pb));pb=ea(g[D>>2]);Fa=ea(g[Ua>>2]);nb=ea(g[Va>>2]);jb=ea(Ja-pb);ob=ea(ca-Fa);kb=ea(Na-nb);sb=ea(g[E>>2]);tb=ea(g[Wa>>2]);ub=ea(g[Xa>>2]);vb=ea(ha-sb);wb=ea(La-tb);xb=ea(fa-ub);yb=ea(rb/qb);eb=yb>ea(1.0);qb=eb?ea(1.0):yb;eb=qb>ea(0.0);yb=eb?qb:ea(0.0);qb=ea(pb+ea(jb*yb));jb=ea(Fa+ea(ob*yb));ob=ea(nb+ea(kb*yb));kb=ea(sb+ea(vb*yb));vb=ea(tb+ea(wb*yb));wb=ea(ub+ea(xb*yb));g[w>>2]=qb;g[Ya>>2]=jb;g[Za>>2]=ob;g[_a>>2]=ea(0.0);g[x>>2]=kb;g[$a>>2]=vb;g[ab>>2]=wb;g[bb>>2]=ea(0.0);yb=ea(jb-vb);vb=ea(ob-wb);g[R>>2]=ea(qb-kb);g[Qa>>2]=yb;g[Ra>>2]=vb;g[cb>>2]=ea(0.0);break}}else if((ib|0)==3)qPa(R,C,D,E,F,G,J,H,I,K,w,x);else if(!ib){c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[x+0>>2]=c[I+0>>2];c[x+4>>2]=c[I+4>>2];c[x+8>>2]=c[I+8>>2];c[x+12>>2]=c[I+12>>2];c[R+0>>2]=c[J+0>>2];c[R+4>>2]=c[J+4>>2];c[R+8>>2]=c[J+8>>2];c[R+12>>2]=c[J+12>>2]}else{c[R+0>>2]=c[J+0>>2];c[R+4>>2]=c[J+4>>2];c[R+8>>2]=c[J+8>>2];c[R+12>>2]=c[J+12>>2]}while(0);fa=ea(g[R>>2]);La=ea(g[Qa>>2]);ha=ea(g[Ra>>2]);Na=ea(ea(ea(fa*fa)+ea(La*La))+ea(ha*ha));c[y+0>>2]=c[S+0>>2];c[y+4>>2]=c[S+4>>2];c[y+8>>2]=c[S+8>>2];zb=Ha>Na;if(Na>aa^1|zb^1){Ab=36;break}else{Ka=fa;ga=La;_=ha;Ha=Na}}if((Ab|0)==36){Ra=c[K>>2]|0;if(zb){Bb=Ra;break}Qa=Ra+-1|0;if((m|0)!=0?(a[o>>0]=Qa,(Qa|0)!=0):0){Ra=0;do{a[m+Ra>>0]=c[F+(Ra<<2)>>2];a[n+Ra>>0]=c[G+(Ra<<2)>>2];Ra=Ra+1|0}while((Ra|0)!=(Qa|0))};c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Oa=ea(g[w>>2]);Na=ea(g[w+4>>2]);ha=ea(g[w+8>>2]);La=ea(g[x>>2]);fa=ea(g[x+4>>2]);ca=ea(g[x+8>>2]);Ja=ea(T(ea(Ha)));Ga=ea(ea(1.0)/Ja);da=ea(ea(Oa-La)*Ga);Ma=ea(ea(Na-fa)*Ga);vb=ea(ea(ha-ca)*Ga);if(p){Ga=(c[b+64>>2]|0)==0?X:ea(0.0);yb=(c[e+64>>2]|0)==0?Y:ea(0.0);kb=ea(Ga+yb);qb=ea(Na-ea(Ma*Ga));wb=ea(ha-ea(vb*Ga));g[h>>2]=ea(Oa-ea(da*Ga));g[h+4>>2]=qb;g[h+8>>2]=wb;g[h+12>>2]=ea(0.0);wb=ea(ea(Ma*yb)+fa);qb=ea(ea(vb*yb)+ca);g[j>>2]=ea(ea(da*yb)+La);g[j+4>>2]=wb;g[j+8>>2]=qb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ja-kb);Qa=l+4|0;c[Qa+0>>2]=c[U+0>>2];c[Qa+4>>2]=c[U+4>>2];c[Qa+8>>2]=c[U+8>>2]}else{kb=ea(Na-ea(X*Ma));Na=ea(ha-ea(X*vb));g[h>>2]=ea(Oa-ea(X*da));g[h+4>>2]=kb;g[h+8>>2]=Na;g[h+12>>2]=ea(0.0);Na=ea(ea(Y*Ma)+fa);fa=ea(ea(Y*vb)+ca);g[j>>2]=ea(ea(Y*da)+La);g[j+4>>2]=Na;g[j+8>>2]=fa;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ja-Z);Qa=l+4|0;c[Qa+0>>2]=c[V+0>>2];c[Qa+4>>2]=c[V+4>>2];c[Qa+8>>2]=c[V+8>>2]}g[k>>2]=da;g[k+4>>2]=Ma;g[k+8>>2]=vb;g[k+12>>2]=ea(0.0);Cb=$>=Ha?1:3;i=q;return Cb|0}if((m|0)!=0?(a[o>>0]=ib,(ib|0)!=0):0){Qa=0;do{a[m+Qa>>0]=c[F+(Qa<<2)>>2];a[n+Qa>>0]=c[G+(Qa<<2)>>2];Qa=Qa+1|0}while((Qa|0)!=(ib|0))}if(!(mb&(lb^1))){Cb=0;i=q;return Cb|0}vb=ea(T(ea(Ha)));Ma=ea(ea(1.0)/vb);da=ea(Ka*Ma);Ja=ea(ga*Ma);fa=ea(_*Ma);g[k>>2]=da;g[k+4>>2]=Ja;g[k+8>>2]=fa;g[k+12>>2]=ea(0.0);if(p){Ma=(c[b+64>>2]|0)==0?X:ea(0.0);Na=(c[e+64>>2]|0)==0?Y:ea(0.0);La=ea(Ma+Na);ca=ea(g[w>>2]);kb=ea(g[Ya>>2]);Oa=ea(kb-ea(Ja*Ma));kb=ea(ea(g[Za>>2])-ea(fa*Ma));g[h>>2]=ea(ca-ea(da*Ma));g[h+4>>2]=Oa;g[h+8>>2]=kb;g[h+12>>2]=ea(0.0);kb=ea(g[x>>2]);Oa=ea(g[$a>>2]);Ma=ea(ea(Ja*Na)+Oa);Oa=ea(ea(fa*Na)+ea(g[ab>>2]));g[j>>2]=ea(ea(da*Na)+kb);g[j+4>>2]=Ma;g[j+8>>2]=Oa;g[j+12>>2]=ea(0.0);g[l>>2]=ea(vb-La);Qa=l+4|0;c[Qa+0>>2]=c[P+0>>2];c[Qa+4>>2]=c[P+4>>2];c[Qa+8>>2]=c[P+8>>2];Cb=1;i=q;return Cb|0}else{La=ea(g[w>>2]);Oa=ea(g[Ya>>2]);Ma=ea(Oa-ea(X*Ja));Oa=ea(ea(g[Za>>2])-ea(X*fa));g[h>>2]=ea(La-ea(X*da));g[h+4>>2]=Ma;g[h+8>>2]=Oa;g[h+12>>2]=ea(0.0);Oa=ea(g[x>>2]);Ma=ea(g[$a>>2]);La=ea(ea(Y*Ja)+Ma);Ma=ea(ea(Y*fa)+ea(g[ab>>2]));g[j>>2]=ea(ea(Y*da)+Oa);g[j+4>>2]=La;g[j+8>>2]=Ma;g[j+12>>2]=ea(0.0);g[l>>2]=ea(vb-Z);Qa=l+4|0;c[Qa+0>>2]=c[Q+0>>2];c[Qa+4>>2]=c[Q+4>>2];c[Qa+8>>2]=c[Q+8>>2];Cb=1;i=q;return Cb|0}}else Bb=c[K>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=Bb,(Bb|0)!=0):0){o=0;do{a[m+o>>0]=c[F+(o<<2)>>2];a[n+o>>0]=c[G+(o<<2)>>2];o=o+1|0}while((o|0)!=(Bb|0))};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];Cb=6;i=q;return Cb|0}function a7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=0,xb=0;q=i;i=i+624|0;r=q+144|0;s=q+368|0;t=q+16|0;u=q+304|0;v=q;w=q+64|0;x=q+80|0;y=q+524|0;z=q+568|0;A=q+384|0;B=q+416|0;C=q+160|0;D=q+176|0;E=q+240|0;F=q+432|0;G=q+552|0;H=q+536|0;I=q+112|0;J=q+336|0;K=q+48|0;L=q+520|0;M=q+400|0;N=q+128|0;O=q+320|0;P=q+32|0;Q=q+352|0;R=q+508|0;S=q+496|0;U=q+96|0;V=q+580|0;W=q+592|0;X=q+604|0;Y=ea(g[f>>2]);Z=ea(g[b+16>>2]);_=ea(g[e+16>>2]);$=ea(g[b+32>>2]);aa=ea(g[e+32>>2]);ba=ea(($>aa?aa:$)*ea(.100000001));c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;$=ea(Z+_);aa=ea(Y+$);c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];ca=ea(ba*ba);ba=ea(aa*aa);c[I+0>>2]=c[v+0>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];c[I+12>>2]=c[v+12>>2];c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];c[K+0>>2]=c[v+0>>2];c[K+4>>2]=c[v+4>>2];c[K+8>>2]=c[v+8>>2];c[K+12>>2]=c[v+12>>2];c[L>>2]=0;f=a[o>>0]|0;if(!(f<<24>>24)){aa=ea(g[b>>2]);da=ea(g[b+4>>2]);fa=ea(g[b+8>>2]);ga=ea(g[e>>2]);ha=ea(g[e+4>>2]);ia=ea(aa-ga);ga=ea(da-ha);ha=ea(fa-ea(g[e+8>>2]));ja=ea(ea(ea(ia*ia)+ea(ga*ga))+ea(ha*ha))>ea(0.0);g[s>>2]=ia;g[s+4>>2]=ga;g[s+8>>2]=ha;g[s+12>>2]=ea(0.0);g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ka=ja?s:r;ha=ea(g[ka>>2]);ga=ea(g[ka+4>>2]);ia=ea(g[ka+8>>2]);g[C>>2]=ha;g[C+4>>2]=ga;g[C+8>>2]=ia;g[C+12>>2]=ea(0.0);la=ea(3402823469999999843913219.0e14);ma=1;na=ia;oa=ga;pa=ha}else{c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];c[M+12>>2]=c[v+12>>2];c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];c[N+12>>2]=c[v+12>>2];c[O+0>>2]=c[v+0>>2];c[O+4>>2]=c[v+4>>2];c[O+8>>2]=c[v+8>>2];c[O+12>>2]=c[v+12>>2];v=b+96|0;ka=J+4|0;r=J+8|0;s=J+12|0;ja=I+4|0;qa=I+8|0;ra=K+4|0;sa=K+8|0;ta=K+12|0;ua=c[e+200>>2]|0;ha=ea(g[e+96>>2]);ga=ea(g[e+112>>2]);ia=ea(g[e+128>>2]);fa=ea(g[e+100>>2]);da=ea(g[e+116>>2]);aa=ea(g[e+132>>2]);va=ea(g[e+104>>2]);wa=ea(g[e+120>>2]);xa=ea(g[e+136>>2]);ya=0;za=0;while(1){Aa=d[m+za>>0]|0;c[G+(za<<2)>>2]=Aa;Ba=d[n+za>>0]|0;c[H+(za<<2)>>2]=Ba;Ca=v+(1-Aa<<4)|0;c[I+0>>2]=c[Ca+0>>2];c[I+4>>2]=c[Ca+4>>2];c[I+8>>2]=c[Ca+8>>2];c[I+12>>2]=c[Ca+12>>2];Da=ea(g[ua+(Ba*12|0)>>2]);Ea=ea(g[ua+(Ba*12|0)+4>>2]);Fa=ea(g[ua+(Ba*12|0)+8>>2]);Ga=ea(ea(ea(Da*ha)+ea(Ea*ga))+ea(Fa*ia));Ha=ea(ea(ea(Da*fa)+ea(Ea*da))+ea(Fa*aa));Ia=ea(ea(ea(Da*va)+ea(Ea*wa))+ea(Fa*xa));g[J>>2]=Ga;g[ka>>2]=Ha;g[r>>2]=Ia;g[s>>2]=ea(0.0);Fa=ea(g[I>>2]);Ea=ea(g[ja>>2]);Da=ea(Ea-Ha);Ha=ea(ea(g[qa>>2])-Ia);g[K>>2]=ea(Fa-Ga);g[ra>>2]=Da;g[sa>>2]=Ha;g[ta>>2]=ea(0.0);Ba=E+(ya<<4)|0;c[N+0>>2]=c[I+0>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];c[N+12>>2]=c[I+12>>2];c[Ba+0>>2]=c[I+0>>2];c[Ba+4>>2]=c[I+4>>2];c[Ba+8>>2]=c[I+8>>2];c[Ba+12>>2]=c[I+12>>2];Ba=F+(ya<<4)|0;c[O+0>>2]=c[J+0>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];c[O+12>>2]=c[J+12>>2];c[Ba+0>>2]=c[J+0>>2];c[Ba+4>>2]=c[J+4>>2];c[Ba+8>>2]=c[J+8>>2];c[Ba+12>>2]=c[J+12>>2];Ja=ya+1|0;Ba=D+(ya<<4)|0;c[M+0>>2]=c[K+0>>2];c[M+4>>2]=c[K+4>>2];c[M+8>>2]=c[K+8>>2];c[M+12>>2]=c[K+12>>2];c[Ba+0>>2]=c[K+0>>2];c[Ba+4>>2]=c[K+4>>2];c[Ba+8>>2]=c[K+8>>2];c[Ba+12>>2]=c[K+12>>2];za=za+1|0;if(za>>>0>=(f&255)>>>0)break;else ya=Ja}c[L>>2]=Ja;do if((ya|0)==3)qPa(P,D,E,F,G,H,M,N,O,L,w,x);else if(!ya){c[w+0>>2]=c[N+0>>2];c[w+4>>2]=c[N+4>>2];c[w+8>>2]=c[N+8>>2];c[w+12>>2]=c[N+12>>2];c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];c[x+12>>2]=c[O+12>>2];c[P+0>>2]=c[M+0>>2];c[P+4>>2]=c[M+4>>2];c[P+8>>2]=c[M+8>>2];c[P+12>>2]=c[M+12>>2]}else if((ya|0)==2)V6a(P,D,D+16|0,M,D,E,F,L,w,x);else if((ya|0)==1){xa=ea(g[D>>2]);wa=ea(g[D+4>>2]);va=ea(g[D+8>>2]);aa=ea(g[M>>2]);da=ea(g[M+4>>2]);fa=ea(aa-xa);aa=ea(da-wa);da=ea(ea(g[M+8>>2])-va);ia=ea(ea(ea(fa*fa)+ea(aa*aa))+ea(da*da));if(ia==ea(0.0)){c[L>>2]=1;c[w+0>>2]=c[E+0>>2];c[w+4>>2]=c[E+4>>2];c[w+8>>2]=c[E+8>>2];c[w+12>>2]=c[E+12>>2];c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[P+0>>2]=c[D+0>>2];c[P+4>>2]=c[D+4>>2];c[P+8>>2]=c[D+8>>2];c[P+12>>2]=c[D+12>>2];break}else{ga=ea(ea(ea(-ea(wa*aa))-ea(xa*fa))-ea(va*da));da=ea(g[N>>2]);va=ea(g[N+4>>2]);fa=ea(g[N+8>>2]);xa=ea(g[E>>2]);aa=ea(g[E+4>>2]);wa=ea(g[E+8>>2]);ha=ea(da-xa);da=ea(va-aa);va=ea(fa-wa);fa=ea(g[O>>2]);Ha=ea(g[O+4>>2]);Da=ea(g[O+8>>2]);Ga=ea(g[F>>2]);Fa=ea(g[F+4>>2]);Ia=ea(g[F+8>>2]);Ea=ea(fa-Ga);fa=ea(Ha-Fa);Ha=ea(Da-Ia);Da=ea(ga/ia);Ja=Da>ea(1.0);ia=Ja?ea(1.0):Da;Ja=ia>ea(0.0);Da=Ja?ia:ea(0.0);ia=ea(xa+ea(ha*Da));ha=ea(aa+ea(da*Da));da=ea(wa+ea(va*Da));va=ea(Ga+ea(Ea*Da));Ea=ea(Fa+ea(fa*Da));fa=ea(Ia+ea(Ha*Da));g[w>>2]=ia;g[w+4>>2]=ha;g[w+8>>2]=da;g[w+12>>2]=ea(0.0);g[x>>2]=va;g[x+4>>2]=Ea;g[x+8>>2]=fa;g[x+12>>2]=ea(0.0);Da=ea(ha-Ea);Ea=ea(da-fa);g[P>>2]=ea(ia-va);g[P+4>>2]=Da;g[P+8>>2]=Ea;g[P+12>>2]=ea(0.0);break}}else{c[P+0>>2]=c[M+0>>2];c[P+4>>2]=c[M+4>>2];c[P+8>>2]=c[M+8>>2];c[P+12>>2]=c[M+12>>2]}while(0);c[C+0>>2]=c[P+0>>2];c[C+4>>2]=c[P+4>>2];c[C+8>>2]=c[P+8>>2];c[C+12>>2]=c[P+12>>2];Ea=ea(g[C>>2]);Da=ea(g[C+4>>2]);va=ea(g[C+8>>2]);ia=ea(ea(ea(Ea*Ea)+ea(Da*Da))+ea(va*va));c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];la=ia;ma=ia>ca;na=va;oa=Da;pa=Ea}do if(ma){P=C+4|0;M=C+8|0;O=b+96|0;N=b+96|0;ya=b+100|0;Ja=b+104|0;f=b+112|0;za=b+112|0;ta=b+116|0;sa=b+120|0;ra=I+4|0;qa=I+8|0;ja=I+12|0;s=J+4|0;r=J+8|0;ka=K+4|0;ua=K+8|0;v=K+12|0;Ba=b+48|0;Ca=e+48|0;Aa=D+4|0;Ka=D+8|0;La=E+4|0;Ma=E+8|0;Na=F+4|0;Oa=F+8|0;Pa=w+4|0;Qa=w+8|0;Ra=w+12|0;Sa=x+4|0;Ta=x+8|0;Ua=x+12|0;Va=U+4|0;Wa=U+8|0;Xa=U+12|0;Ya=D+16|0;Ea=Y;Da=pa;va=oa;ia=na;fa=la;while(1){c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];da=ea(-Da);ha=ea(-va);Ha=ea(-ia);Za=c[L>>2]|0;Ia=ea(g[N>>2]);Fa=ea(g[ya>>2]);Ga=ea(ea(ea(Ia*da)+ea(Fa*ha))+ea(ea(g[Ja>>2])*Ha));Fa=ea(g[za>>2]);Ia=ea(g[ta>>2]);_a=Ga>ea(ea(ea(Fa*da)+ea(Ia*ha))+ea(ea(g[sa>>2])*Ha));c[G+(Za<<2)>>2]=_a&1;c[u+0>>2]=c[O+0>>2];c[u+4>>2]=c[O+4>>2];c[u+8>>2]=c[O+8>>2];c[u+12>>2]=c[O+12>>2];c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];$a=_a?u:t;Ha=ea(g[$a>>2]);ha=ea(g[$a+4>>2]);Ia=ea(g[$a+8>>2]);g[E+(Za<<4)>>2]=Ha;g[E+(Za<<4)+4>>2]=ha;g[E+(Za<<4)+8>>2]=Ia;g[E+(Za<<4)+12>>2]=ea(0.0);g[I>>2]=Ha;g[ra>>2]=ha;g[qa>>2]=Ia;g[ja>>2]=ea(0.0);AFb(Q,e,C,F+(Za<<4)|0,H+(Za<<2)|0);c[J+0>>2]=c[Q+0>>2];c[J+4>>2]=c[Q+4>>2];c[J+8>>2]=c[Q+8>>2];c[J+12>>2]=c[Q+12>>2];Ia=ea(g[I>>2]);ha=ea(g[ra>>2]);Ha=ea(g[qa>>2]);da=ea(g[J>>2]);Fa=ea(g[s>>2]);Ga=ea(g[r>>2]);wa=ea(Ia-da);aa=ea(ha-Fa);xa=ea(Ha-Ga);g[K>>2]=wa;g[ka>>2]=aa;g[ua>>2]=xa;g[v>>2]=ea(0.0);ab=c[L>>2]|0;c[L>>2]=ab+1;Za=D+(ab<<4)|0;c[Za+0>>2]=c[K+0>>2];c[Za+4>>2]=c[K+4>>2];c[Za+8>>2]=c[K+8>>2];c[Za+12>>2]=c[K+12>>2];ga=ea(g[Ba>>2]);bb=ea(g[Ca>>2]);cb=ga>bb?ga:bb;Ea=Ea>cb?Ea:cb;cb=ea($+Ea);bb=ea(fa*ea(cb*cb));db=ea(g[C>>2]);eb=ea(g[P>>2]);fb=ea(g[M>>2]);cb=ea(ea(ea(db*wa)+ea(eb*aa))+ea(fb*xa));Za=ea(cb*cb)>bb;if(cb>ea(0.0)){gb=Za;hb=Za^1}else{gb=0;hb=1}Za=ea(ca*fa)>=ea(fa-cb);if((Za|gb)&(Za|hb^1))break;do if((ab|0)==3)qPa(U,D,E,F,G,H,K,I,J,L,w,x);else if((ab|0)==2)V6a(U,D,Ya,K,D,E,F,L,w,x);else if((ab|0)==1){cb=ea(g[D>>2]);bb=ea(g[Aa>>2]);ga=ea(g[Ka>>2]);ib=ea(wa-cb);jb=ea(aa-bb);kb=ea(xa-ga);lb=ea(ea(ea(ib*ib)+ea(jb*jb))+ea(kb*kb));if(lb==ea(0.0)){c[L>>2]=1;c[w+0>>2]=c[E+0>>2];c[w+4>>2]=c[E+4>>2];c[w+8>>2]=c[E+8>>2];c[w+12>>2]=c[E+12>>2];c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[U+0>>2]=c[D+0>>2];c[U+4>>2]=c[D+4>>2];c[U+8>>2]=c[D+8>>2];c[U+12>>2]=c[D+12>>2];break}else{mb=ea(ea(ea(-ea(bb*jb))-ea(cb*ib))-ea(ga*kb));kb=ea(g[E>>2]);ga=ea(g[La>>2]);ib=ea(g[Ma>>2]);cb=ea(Ia-kb);jb=ea(ha-ga);bb=ea(Ha-ib);nb=ea(g[F>>2]);ob=ea(g[Na>>2]);pb=ea(g[Oa>>2]);qb=ea(da-nb);rb=ea(Fa-ob);sb=ea(Ga-pb);tb=ea(mb/lb);Za=tb>ea(1.0);lb=Za?ea(1.0):tb;Za=lb>ea(0.0);tb=Za?lb:ea(0.0);lb=ea(kb+ea(cb*tb));cb=ea(ga+ea(jb*tb));jb=ea(ib+ea(bb*tb));bb=ea(nb+ea(qb*tb));qb=ea(ob+ea(rb*tb));rb=ea(pb+ea(sb*tb));g[w>>2]=lb;g[Pa>>2]=cb;g[Qa>>2]=jb;g[Ra>>2]=ea(0.0);g[x>>2]=bb;g[Sa>>2]=qb;g[Ta>>2]=rb;g[Ua>>2]=ea(0.0);tb=ea(cb-qb);qb=ea(jb-rb);g[U>>2]=ea(lb-bb);g[Va>>2]=tb;g[Wa>>2]=qb;g[Xa>>2]=ea(0.0);break}}else if(!ab){c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[x+0>>2]=c[J+0>>2];c[x+4>>2]=c[J+4>>2];c[x+8>>2]=c[J+8>>2];c[x+12>>2]=c[J+12>>2];c[U+0>>2]=c[K+0>>2];c[U+4>>2]=c[K+4>>2];c[U+8>>2]=c[K+8>>2];c[U+12>>2]=c[K+12>>2]}else{c[U+0>>2]=c[K+0>>2];c[U+4>>2]=c[K+4>>2];c[U+8>>2]=c[K+8>>2];c[U+12>>2]=c[K+12>>2]}while(0);c[C+0>>2]=c[U+0>>2];c[C+4>>2]=c[U+4>>2];c[C+8>>2]=c[U+8>>2];c[C+12>>2]=c[U+12>>2];Da=ea(g[C>>2]);va=ea(g[P>>2]);ia=ea(g[M>>2]);Ga=ea(ea(ea(Da*Da)+ea(va*va))+ea(ia*ia));c[y+0>>2]=c[V+0>>2];c[y+4>>2]=c[V+4>>2];c[y+8>>2]=c[V+8>>2];ub=fa>Ga;if(Ga>ca^1|ub^1){vb=36;break}else fa=Ga}if((vb|0)==36){M=c[L>>2]|0;if(ub){wb=M;break}P=M+-1|0;if((m|0)!=0?(a[o>>0]=P,(P|0)!=0):0){M=0;do{a[m+M>>0]=c[G+(M<<2)>>2];a[n+M>>0]=c[H+(M<<2)>>2];M=M+1|0}while((M|0)!=(P|0))};c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];ia=ea(g[w>>2]);va=ea(g[w+4>>2]);Da=ea(g[w+8>>2]);Ea=ea(g[x>>2]);Ga=ea(g[x+4>>2]);Fa=ea(g[x+8>>2]);da=ea(ia-Ea);Ha=ea(va-Ga);ha=ea(Da-Fa);g[C>>2]=da;g[C+4>>2]=Ha;g[C+8>>2]=ha;g[C+12>>2]=ea(0.0);Ia=ea(T(ea(fa)));xa=ea(ea(1.0)/Ia);aa=ea(da*xa);da=ea(Ha*xa);Ha=ea(ha*xa);if(p){xa=(c[b+64>>2]|0)==0?Z:ea(0.0);ha=(c[e+64>>2]|0)==0?_:ea(0.0);wa=ea(xa+ha);qb=ea(va-ea(da*xa));tb=ea(Da-ea(Ha*xa));g[h>>2]=ea(ia-ea(aa*xa));g[h+4>>2]=qb;g[h+8>>2]=tb;g[h+12>>2]=ea(0.0);tb=ea(ea(da*ha)+Ga);qb=ea(ea(Ha*ha)+Fa);g[j>>2]=ea(ea(aa*ha)+Ea);g[j+4>>2]=tb;g[j+8>>2]=qb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ia-wa);P=l+4|0;c[P+0>>2]=c[W+0>>2];c[P+4>>2]=c[W+4>>2];c[P+8>>2]=c[W+8>>2]}else{wa=ea(va-ea(Z*da));va=ea(Da-ea(Z*Ha));g[h>>2]=ea(ia-ea(Z*aa));g[h+4>>2]=wa;g[h+8>>2]=va;g[h+12>>2]=ea(0.0);va=ea(ea(_*da)+Ga);Ga=ea(ea(_*Ha)+Fa);g[j>>2]=ea(ea(_*aa)+Ea);g[j+4>>2]=va;g[j+8>>2]=Ga;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ia-$);P=l+4|0;c[P+0>>2]=c[X+0>>2];c[P+4>>2]=c[X+4>>2];c[P+8>>2]=c[X+8>>2]}g[k>>2]=aa;g[k+4>>2]=da;g[k+8>>2]=Ha;g[k+12>>2]=ea(0.0);xb=ba>=fa?1:3;i=q;return xb|0}if((m|0)!=0?(a[o>>0]=ab,(ab|0)!=0):0){P=0;do{a[m+P>>0]=c[G+(P<<2)>>2];a[n+P>>0]=c[H+(P<<2)>>2];P=P+1|0}while((P|0)!=(ab|0))}if(!(hb&(gb^1))){xb=0;i=q;return xb|0}Ha=ea(T(ea(fa)));da=ea(ea(1.0)/Ha);aa=ea(db*da);Ia=ea(eb*da);Ga=ea(fb*da);g[k>>2]=aa;g[k+4>>2]=Ia;g[k+8>>2]=Ga;g[k+12>>2]=ea(0.0);if(p){da=(c[b+64>>2]|0)==0?Z:ea(0.0);va=(c[e+64>>2]|0)==0?_:ea(0.0);Ea=ea(da+va);Fa=ea(g[w>>2]);wa=ea(g[Pa>>2]);ia=ea(wa-ea(Ia*da));wa=ea(ea(g[Qa>>2])-ea(Ga*da));g[h>>2]=ea(Fa-ea(aa*da));g[h+4>>2]=ia;g[h+8>>2]=wa;g[h+12>>2]=ea(0.0);wa=ea(g[x>>2]);ia=ea(g[Sa>>2]);da=ea(ea(Ia*va)+ia);ia=ea(ea(Ga*va)+ea(g[Ta>>2]));g[j>>2]=ea(ea(aa*va)+wa);g[j+4>>2]=da;g[j+8>>2]=ia;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ha-Ea);P=l+4|0;c[P+0>>2]=c[R+0>>2];c[P+4>>2]=c[R+4>>2];c[P+8>>2]=c[R+8>>2];xb=1;i=q;return xb|0}else{Ea=ea(g[w>>2]);ia=ea(g[Pa>>2]);da=ea(ia-ea(Z*Ia));ia=ea(ea(g[Qa>>2])-ea(Z*Ga));g[h>>2]=ea(Ea-ea(Z*aa));g[h+4>>2]=da;g[h+8>>2]=ia;g[h+12>>2]=ea(0.0);ia=ea(g[x>>2]);da=ea(g[Sa>>2]);Ea=ea(ea(_*Ia)+da);da=ea(ea(_*Ga)+ea(g[Ta>>2]));g[j>>2]=ea(ea(_*aa)+ia);g[j+4>>2]=Ea;g[j+8>>2]=da;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ha-$);P=l+4|0;c[P+0>>2]=c[S+0>>2];c[P+4>>2]=c[S+4>>2];c[P+8>>2]=c[S+8>>2];xb=1;i=q;return xb|0}}else wb=c[L>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=wb,(wb|0)!=0):0){o=0;do{a[m+o>>0]=c[G+(o<<2)>>2];a[n+o>>0]=c[H+(o<<2)>>2];o=o+1|0}while((o|0)!=(wb|0))};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];xb=6;i=q;return xb|0}function b7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=0,xb=0;q=i;i=i+640|0;r=q+144|0;s=q+448|0;t=q+16|0;u=q+496|0;v=q;w=q+64|0;x=q+80|0;y=q+540|0;z=q+584|0;A=q+432|0;B=q+464|0;C=q+480|0;D=q+176|0;E=q+240|0;F=q+304|0;G=q+568|0;H=q+552|0;I=q+384|0;J=q+112|0;K=q+48|0;L=q+536|0;M=q+416|0;N=q+160|0;O=q+128|0;P=q+32|0;Q=q+368|0;R=q+400|0;S=q+524|0;U=q+512|0;V=q+96|0;W=q+596|0;X=q+608|0;Y=q+620|0;Z=ea(g[f>>2]);_=ea(g[b+16>>2]);$=ea(g[e+16>>2]);aa=ea(g[b+32>>2]);ba=ea(g[e+32>>2]);ca=ea((aa>ba?ba:aa)*ea(.100000001));c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;aa=ea(_+$);ba=ea(Z+aa);c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];da=ea(ca*ca);ca=ea(ba*ba);c[I+0>>2]=c[v+0>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];c[I+12>>2]=c[v+12>>2];c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];c[K+0>>2]=c[v+0>>2];c[K+4>>2]=c[v+4>>2];c[K+8>>2]=c[v+8>>2];c[K+12>>2]=c[v+12>>2];c[L>>2]=0;if(!(a[o>>0]|0)){ba=ea(g[b>>2]);fa=ea(g[b+4>>2]);ga=ea(g[b+8>>2]);ha=ea(g[e>>2]);ia=ea(g[e+4>>2]);ja=ea(ba-ha);ha=ea(fa-ia);ia=ea(ga-ea(g[e+8>>2]));f=ea(ea(ea(ja*ja)+ea(ha*ha))+ea(ia*ia))>ea(0.0);g[s>>2]=ja;g[s+4>>2]=ha;g[s+8>>2]=ia;g[s+12>>2]=ea(0.0);g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ka=f?s:r;ia=ea(g[ka>>2]);ha=ea(g[ka+4>>2]);ja=ea(g[ka+8>>2]);g[C>>2]=ia;g[C+4>>2]=ha;g[C+8>>2]=ja;g[C+12>>2]=ea(0.0);la=ea(3402823469999999843913219.0e14);ma=1;na=ja;oa=ha;pa=ia}else{c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];c[M+12>>2]=c[v+12>>2];c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];c[N+12>>2]=c[v+12>>2];c[O+0>>2]=c[v+0>>2];c[O+4>>2]=c[v+4>>2];c[O+8>>2]=c[v+8>>2];c[O+12>>2]=c[v+12>>2];v=b+96|0;ka=e+16|0;r=I+4|0;s=I+8|0;f=J+4|0;qa=J+8|0;ra=K+4|0;sa=K+8|0;ta=K+12|0;ua=0;do{va=d[m+ua>>0]|0;c[G+(ua<<2)>>2]=va;wa=d[n+ua>>0]|0;c[H+(ua<<2)>>2]=wa;xa=v+(1-va<<4)|0;c[I+0>>2]=c[xa+0>>2];c[I+4>>2]=c[xa+4>>2];c[I+8>>2]=c[xa+8>>2];c[I+12>>2]=c[xa+12>>2];BFb(P,e,wa,ka);c[J+0>>2]=c[P+0>>2];c[J+4>>2]=c[P+4>>2];c[J+8>>2]=c[P+8>>2];c[J+12>>2]=c[P+12>>2];ia=ea(g[I>>2]);ha=ea(g[r>>2]);ja=ea(g[s>>2]);ga=ea(g[J>>2]);fa=ea(g[f>>2]);ba=ea(ha-fa);fa=ea(ja-ea(g[qa>>2]));g[K>>2]=ea(ia-ga);g[ra>>2]=ba;g[sa>>2]=fa;g[ta>>2]=ea(0.0);ya=c[L>>2]|0;wa=E+(ya<<4)|0;c[N+0>>2]=c[I+0>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];c[N+12>>2]=c[I+12>>2];c[wa+0>>2]=c[I+0>>2];c[wa+4>>2]=c[I+4>>2];c[wa+8>>2]=c[I+8>>2];c[wa+12>>2]=c[I+12>>2];wa=F+(ya<<4)|0;c[O+0>>2]=c[J+0>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];c[O+12>>2]=c[J+12>>2];c[wa+0>>2]=c[J+0>>2];c[wa+4>>2]=c[J+4>>2];c[wa+8>>2]=c[J+8>>2];c[wa+12>>2]=c[J+12>>2];c[L>>2]=ya+1;wa=D+(ya<<4)|0;c[M+0>>2]=c[K+0>>2];c[M+4>>2]=c[K+4>>2];c[M+8>>2]=c[K+8>>2];c[M+12>>2]=c[K+12>>2];c[wa+0>>2]=c[K+0>>2];c[wa+4>>2]=c[K+4>>2];c[wa+8>>2]=c[K+8>>2];c[wa+12>>2]=c[K+12>>2];ua=ua+1|0}while(ua>>>0<(d[o>>0]|0)>>>0);do if(!ya){c[w+0>>2]=c[N+0>>2];c[w+4>>2]=c[N+4>>2];c[w+8>>2]=c[N+8>>2];c[w+12>>2]=c[N+12>>2];c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];c[x+12>>2]=c[O+12>>2];c[Q+0>>2]=c[M+0>>2];c[Q+4>>2]=c[M+4>>2];c[Q+8>>2]=c[M+8>>2];c[Q+12>>2]=c[M+12>>2]}else if((ya|0)==2)V6a(Q,D,D+16|0,M,D,E,F,L,w,x);else if((ya|0)==3)qPa(Q,D,E,F,G,H,M,N,O,L,w,x);else if((ya|0)==1){fa=ea(g[D>>2]);ba=ea(g[D+4>>2]);ga=ea(g[D+8>>2]);ia=ea(g[M>>2]);ja=ea(g[M+4>>2]);ha=ea(ia-fa);ia=ea(ja-ba);ja=ea(ea(g[M+8>>2])-ga);za=ea(ea(ea(ha*ha)+ea(ia*ia))+ea(ja*ja));if(za==ea(0.0)){c[L>>2]=1;c[w+0>>2]=c[E+0>>2];c[w+4>>2]=c[E+4>>2];c[w+8>>2]=c[E+8>>2];c[w+12>>2]=c[E+12>>2];c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[Q+0>>2]=c[D+0>>2];c[Q+4>>2]=c[D+4>>2];c[Q+8>>2]=c[D+8>>2];c[Q+12>>2]=c[D+12>>2];break}else{Aa=ea(ea(ea(-ea(ba*ia))-ea(fa*ha))-ea(ga*ja));ja=ea(g[N>>2]);ga=ea(g[N+4>>2]);ha=ea(g[N+8>>2]);fa=ea(g[E>>2]);ia=ea(g[E+4>>2]);ba=ea(g[E+8>>2]);Ba=ea(ja-fa);ja=ea(ga-ia);ga=ea(ha-ba);ha=ea(g[O>>2]);Ca=ea(g[O+4>>2]);Da=ea(g[O+8>>2]);Ea=ea(g[F>>2]);Fa=ea(g[F+4>>2]);Ga=ea(g[F+8>>2]);Ha=ea(ha-Ea);ha=ea(Ca-Fa);Ca=ea(Da-Ga);Da=ea(Aa/za);ua=Da>ea(1.0);za=ua?ea(1.0):Da;ua=za>ea(0.0);Da=ua?za:ea(0.0);za=ea(fa+ea(Ba*Da));Ba=ea(ia+ea(ja*Da));ja=ea(ba+ea(ga*Da));ga=ea(Ea+ea(Ha*Da));Ha=ea(Fa+ea(ha*Da));ha=ea(Ga+ea(Ca*Da));g[w>>2]=za;g[w+4>>2]=Ba;g[w+8>>2]=ja;g[w+12>>2]=ea(0.0);g[x>>2]=ga;g[x+4>>2]=Ha;g[x+8>>2]=ha;g[x+12>>2]=ea(0.0);Da=ea(Ba-Ha);Ha=ea(ja-ha);g[Q>>2]=ea(za-ga);g[Q+4>>2]=Da;g[Q+8>>2]=Ha;g[Q+12>>2]=ea(0.0);break}}else{c[Q+0>>2]=c[M+0>>2];c[Q+4>>2]=c[M+4>>2];c[Q+8>>2]=c[M+8>>2];c[Q+12>>2]=c[M+12>>2]}while(0);c[C+0>>2]=c[Q+0>>2];c[C+4>>2]=c[Q+4>>2];c[C+8>>2]=c[Q+8>>2];c[C+12>>2]=c[Q+12>>2];Ha=ea(g[C>>2]);Da=ea(g[C+4>>2]);ga=ea(g[C+8>>2]);za=ea(ea(ea(Ha*Ha)+ea(Da*Da))+ea(ga*ga));c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];la=za;ma=za>da;na=ga;oa=Da;pa=Ha}do if(ma){Q=C+4|0;M=C+8|0;O=b+96|0;N=b+96|0;ya=b+100|0;ua=b+104|0;ta=b+112|0;sa=b+112|0;ra=b+116|0;qa=b+120|0;f=I+4|0;s=I+8|0;r=I+12|0;P=J+4|0;ka=J+8|0;v=K+4|0;wa=K+8|0;xa=K+12|0;va=b+48|0;Ia=e+48|0;Ja=D+4|0;Ka=D+8|0;La=E+4|0;Ma=E+8|0;Na=F+4|0;Oa=F+8|0;Pa=w+4|0;Qa=w+8|0;Ra=w+12|0;Sa=x+4|0;Ta=x+8|0;Ua=x+12|0;Va=V+4|0;Wa=V+8|0;Xa=V+12|0;Ya=D+16|0;Ha=Z;Da=pa;ga=oa;za=na;ha=la;while(1){c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];ja=ea(-Da);Ba=ea(-ga);Ca=ea(-za);Za=c[L>>2]|0;Ga=ea(g[N>>2]);Fa=ea(g[ya>>2]);Ea=ea(ea(ea(Ga*ja)+ea(Fa*Ba))+ea(ea(g[ua>>2])*Ca));Fa=ea(g[sa>>2]);Ga=ea(g[ra>>2]);_a=Ea>ea(ea(ea(Fa*ja)+ea(Ga*Ba))+ea(ea(g[qa>>2])*Ca));c[G+(Za<<2)>>2]=_a&1;c[u+0>>2]=c[O+0>>2];c[u+4>>2]=c[O+4>>2];c[u+8>>2]=c[O+8>>2];c[u+12>>2]=c[O+12>>2];c[t+0>>2]=c[ta+0>>2];c[t+4>>2]=c[ta+4>>2];c[t+8>>2]=c[ta+8>>2];c[t+12>>2]=c[ta+12>>2];$a=_a?u:t;Ca=ea(g[$a>>2]);Ba=ea(g[$a+4>>2]);Ga=ea(g[$a+8>>2]);g[E+(Za<<4)>>2]=Ca;g[E+(Za<<4)+4>>2]=Ba;g[E+(Za<<4)+8>>2]=Ga;g[E+(Za<<4)+12>>2]=ea(0.0);g[I>>2]=Ca;g[f>>2]=Ba;g[s>>2]=Ga;g[r>>2]=ea(0.0);CFb(R,e,C,F+(Za<<4)|0,H+(Za<<2)|0);c[J+0>>2]=c[R+0>>2];c[J+4>>2]=c[R+4>>2];c[J+8>>2]=c[R+8>>2];c[J+12>>2]=c[R+12>>2];Ga=ea(g[I>>2]);Ba=ea(g[f>>2]);Ca=ea(g[s>>2]);ja=ea(g[J>>2]);Fa=ea(g[P>>2]);Ea=ea(g[ka>>2]);ba=ea(Ga-ja);ia=ea(Ba-Fa);fa=ea(Ca-Ea);g[K>>2]=ba;g[v>>2]=ia;g[wa>>2]=fa;g[xa>>2]=ea(0.0);ab=c[L>>2]|0;c[L>>2]=ab+1;Za=D+(ab<<4)|0;c[Za+0>>2]=c[K+0>>2];c[Za+4>>2]=c[K+4>>2];c[Za+8>>2]=c[K+8>>2];c[Za+12>>2]=c[K+12>>2];Aa=ea(g[va>>2]);bb=ea(g[Ia>>2]);cb=Aa>bb?Aa:bb;Ha=Ha>cb?Ha:cb;cb=ea(aa+Ha);bb=ea(ha*ea(cb*cb));db=ea(g[C>>2]);eb=ea(g[Q>>2]);fb=ea(g[M>>2]);cb=ea(ea(ea(db*ba)+ea(eb*ia))+ea(fb*fa));Za=ea(cb*cb)>bb;if(cb>ea(0.0)){gb=Za;hb=Za^1}else{gb=0;hb=1}Za=ea(da*ha)>=ea(ha-cb);if((Za|gb)&(Za|hb^1))break;do if((ab|0)==1){cb=ea(g[D>>2]);bb=ea(g[Ja>>2]);Aa=ea(g[Ka>>2]);ib=ea(ba-cb);jb=ea(ia-bb);kb=ea(fa-Aa);lb=ea(ea(ea(ib*ib)+ea(jb*jb))+ea(kb*kb));if(lb==ea(0.0)){c[L>>2]=1;c[w+0>>2]=c[E+0>>2];c[w+4>>2]=c[E+4>>2];c[w+8>>2]=c[E+8>>2];c[w+12>>2]=c[E+12>>2];c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[V+0>>2]=c[D+0>>2];c[V+4>>2]=c[D+4>>2];c[V+8>>2]=c[D+8>>2];c[V+12>>2]=c[D+12>>2];break}else{mb=ea(ea(ea(-ea(bb*jb))-ea(cb*ib))-ea(Aa*kb));kb=ea(g[E>>2]);Aa=ea(g[La>>2]);ib=ea(g[Ma>>2]);cb=ea(Ga-kb);jb=ea(Ba-Aa);bb=ea(Ca-ib);nb=ea(g[F>>2]);ob=ea(g[Na>>2]);pb=ea(g[Oa>>2]);qb=ea(ja-nb);rb=ea(Fa-ob);sb=ea(Ea-pb);tb=ea(mb/lb);Za=tb>ea(1.0);lb=Za?ea(1.0):tb;Za=lb>ea(0.0);tb=Za?lb:ea(0.0);lb=ea(kb+ea(cb*tb));cb=ea(Aa+ea(jb*tb));jb=ea(ib+ea(bb*tb));bb=ea(nb+ea(qb*tb));qb=ea(ob+ea(rb*tb));rb=ea(pb+ea(sb*tb));g[w>>2]=lb;g[Pa>>2]=cb;g[Qa>>2]=jb;g[Ra>>2]=ea(0.0);g[x>>2]=bb;g[Sa>>2]=qb;g[Ta>>2]=rb;g[Ua>>2]=ea(0.0);tb=ea(cb-qb);qb=ea(jb-rb);g[V>>2]=ea(lb-bb);g[Va>>2]=tb;g[Wa>>2]=qb;g[Xa>>2]=ea(0.0);break}}else if(!ab){c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[x+0>>2]=c[J+0>>2];c[x+4>>2]=c[J+4>>2];c[x+8>>2]=c[J+8>>2];c[x+12>>2]=c[J+12>>2];c[V+0>>2]=c[K+0>>2];c[V+4>>2]=c[K+4>>2];c[V+8>>2]=c[K+8>>2];c[V+12>>2]=c[K+12>>2]}else if((ab|0)==3)qPa(V,D,E,F,G,H,K,I,J,L,w,x);else if((ab|0)==2)V6a(V,D,Ya,K,D,E,F,L,w,x);else{c[V+0>>2]=c[K+0>>2];c[V+4>>2]=c[K+4>>2];c[V+8>>2]=c[K+8>>2];c[V+12>>2]=c[K+12>>2]}while(0);c[C+0>>2]=c[V+0>>2];c[C+4>>2]=c[V+4>>2];c[C+8>>2]=c[V+8>>2];c[C+12>>2]=c[V+12>>2];Da=ea(g[C>>2]);ga=ea(g[Q>>2]);za=ea(g[M>>2]);Ea=ea(ea(ea(Da*Da)+ea(ga*ga))+ea(za*za));c[y+0>>2]=c[W+0>>2];c[y+4>>2]=c[W+4>>2];c[y+8>>2]=c[W+8>>2];ub=ha>Ea;if(Ea>da^1|ub^1){vb=36;break}else ha=Ea}if((vb|0)==36){M=c[L>>2]|0;if(ub){wb=M;break}Q=M+-1|0;if((m|0)!=0?(a[o>>0]=Q,(Q|0)!=0):0){M=0;do{a[m+M>>0]=c[G+(M<<2)>>2];a[n+M>>0]=c[H+(M<<2)>>2];M=M+1|0}while((M|0)!=(Q|0))};c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];za=ea(g[w>>2]);ga=ea(g[w+4>>2]);Da=ea(g[w+8>>2]);Ha=ea(g[x>>2]);Ea=ea(g[x+4>>2]);Fa=ea(g[x+8>>2]);ja=ea(za-Ha);Ca=ea(ga-Ea);Ba=ea(Da-Fa);g[C>>2]=ja;g[C+4>>2]=Ca;g[C+8>>2]=Ba;g[C+12>>2]=ea(0.0);Ga=ea(T(ea(ha)));fa=ea(ea(1.0)/Ga);ia=ea(ja*fa);ja=ea(Ca*fa);Ca=ea(Ba*fa);if(p){fa=(c[b+64>>2]|0)==0?_:ea(0.0);Ba=(c[e+64>>2]|0)==0?$:ea(0.0);ba=ea(fa+Ba);qb=ea(ga-ea(ja*fa));tb=ea(Da-ea(Ca*fa));g[h>>2]=ea(za-ea(ia*fa));g[h+4>>2]=qb;g[h+8>>2]=tb;g[h+12>>2]=ea(0.0);tb=ea(ea(ja*Ba)+Ea);qb=ea(ea(Ca*Ba)+Fa);g[j>>2]=ea(ea(ia*Ba)+Ha);g[j+4>>2]=tb;g[j+8>>2]=qb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ga-ba);Q=l+4|0;c[Q+0>>2]=c[X+0>>2];c[Q+4>>2]=c[X+4>>2];c[Q+8>>2]=c[X+8>>2]}else{ba=ea(ga-ea(_*ja));ga=ea(Da-ea(_*Ca));g[h>>2]=ea(za-ea(_*ia));g[h+4>>2]=ba;g[h+8>>2]=ga;g[h+12>>2]=ea(0.0);ga=ea(ea($*ja)+Ea);Ea=ea(ea($*Ca)+Fa);g[j>>2]=ea(ea($*ia)+Ha);g[j+4>>2]=ga;g[j+8>>2]=Ea;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ga-aa);Q=l+4|0;c[Q+0>>2]=c[Y+0>>2];c[Q+4>>2]=c[Y+4>>2];c[Q+8>>2]=c[Y+8>>2]}g[k>>2]=ia;g[k+4>>2]=ja;g[k+8>>2]=Ca;g[k+12>>2]=ea(0.0);xb=ca>=ha?1:3;i=q;return xb|0}if((m|0)!=0?(a[o>>0]=ab,(ab|0)!=0):0){Q=0;do{a[m+Q>>0]=c[G+(Q<<2)>>2];a[n+Q>>0]=c[H+(Q<<2)>>2];Q=Q+1|0}while((Q|0)!=(ab|0))}if(!(hb&(gb^1))){xb=0;i=q;return xb|0}Ca=ea(T(ea(ha)));ja=ea(ea(1.0)/Ca);ia=ea(db*ja);Ga=ea(eb*ja);Ea=ea(fb*ja);g[k>>2]=ia;g[k+4>>2]=Ga;g[k+8>>2]=Ea;g[k+12>>2]=ea(0.0);if(p){ja=(c[b+64>>2]|0)==0?_:ea(0.0);ga=(c[e+64>>2]|0)==0?$:ea(0.0);Ha=ea(ja+ga);Fa=ea(g[w>>2]);ba=ea(g[Pa>>2]);za=ea(ba-ea(Ga*ja));ba=ea(ea(g[Qa>>2])-ea(Ea*ja));g[h>>2]=ea(Fa-ea(ia*ja));g[h+4>>2]=za;g[h+8>>2]=ba;g[h+12>>2]=ea(0.0);ba=ea(g[x>>2]);za=ea(g[Sa>>2]);ja=ea(ea(Ga*ga)+za);za=ea(ea(Ea*ga)+ea(g[Ta>>2]));g[j>>2]=ea(ea(ia*ga)+ba);g[j+4>>2]=ja;g[j+8>>2]=za;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ca-Ha);Q=l+4|0;c[Q+0>>2]=c[S+0>>2];c[Q+4>>2]=c[S+4>>2];c[Q+8>>2]=c[S+8>>2];xb=1;i=q;return xb|0}else{Ha=ea(g[w>>2]);za=ea(g[Pa>>2]);ja=ea(za-ea(_*Ga));za=ea(ea(g[Qa>>2])-ea(_*Ea));g[h>>2]=ea(Ha-ea(_*ia));g[h+4>>2]=ja;g[h+8>>2]=za;g[h+12>>2]=ea(0.0);za=ea(g[x>>2]);ja=ea(g[Sa>>2]);Ha=ea(ea($*Ga)+ja);ja=ea(ea($*Ea)+ea(g[Ta>>2]));g[j>>2]=ea(ea($*ia)+za);g[j+4>>2]=Ha;g[j+8>>2]=ja;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ca-aa);Q=l+4|0;c[Q+0>>2]=c[U+0>>2];c[Q+4>>2]=c[U+4>>2];c[Q+8>>2]=c[U+8>>2];xb=1;i=q;return xb|0}}else wb=c[L>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=wb,(wb|0)!=0):0){o=0;do{a[m+o>>0]=c[G+(o<<2)>>2];a[n+o>>0]=c[H+(o<<2)>>2];o=o+1|0}while((o|0)!=(wb|0))};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];xb=6;i=q;return xb|0}function c7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=Im,la=0,ma=Im,na=Im,oa=Im,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=Im,nb=Im,ob=Im,pb=0,qb=Im,rb=Im,sb=0,tb=0,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=0,Hb=0,Ib=0,Jb=0;q=i;i=i+608|0;r=q+16|0;s=q+464|0;t=q;u=q+128|0;v=q+416|0;w=q+64|0;x=q+80|0;y=q+512|0;z=q+544|0;A=q+432|0;B=q+448|0;C=q+160|0;D=q+176|0;E=q+240|0;F=q+304|0;G=q+496|0;H=q+528|0;I=q+112|0;J=q+384|0;K=q+48|0;L=q+492|0;M=q+144|0;N=q+368|0;O=q+32|0;P=q+400|0;Q=q+568|0;R=q+480|0;S=q+96|0;U=q+556|0;V=q+580|0;W=q+592|0;X=ea(g[f>>2]);Y=ea(g[b+16>>2]);Z=ea(g[e+16>>2]);_=ea(g[b+32>>2]);$=ea(g[e+32>>2]);aa=ea((_>$?$:_)*ea(.100000001));c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;_=ea(Y+Z);$=ea(X+_);c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];ba=ea(aa*aa);aa=ea($*$);c[I+0>>2]=c[v+0>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];c[I+12>>2]=c[v+12>>2];c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];c[K+0>>2]=c[v+0>>2];c[K+4>>2]=c[v+4>>2];c[K+8>>2]=c[v+8>>2];c[K+12>>2]=c[v+12>>2];c[L>>2]=0;f=a[o>>0]|0;if(!(f<<24>>24)){$=ea(g[b>>2]);ca=ea(g[b+4>>2]);da=ea(g[b+8>>2]);fa=ea(g[e>>2]);ga=ea(g[e+4>>2]);ha=ea($-fa);fa=ea(ca-ga);ga=ea(da-ea(g[e+8>>2]));ia=ea(ea(ea(ha*ha)+ea(fa*fa))+ea(ga*ga))>ea(0.0);g[s>>2]=ha;g[s+4>>2]=fa;g[s+8>>2]=ga;g[s+12>>2]=ea(0.0);g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ja=ia?s:r;ga=ea(g[ja>>2]);fa=ea(g[ja+4>>2]);ha=ea(g[ja+8>>2]);g[C>>2]=ga;g[C+4>>2]=fa;g[C+8>>2]=ha;g[C+12>>2]=ea(0.0);ka=ea(3402823469999999843913219.0e14);la=1;ma=ha;na=fa;oa=ga}else{c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];c[M+12>>2]=c[v+12>>2];c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];c[N+12>>2]=c[v+12>>2];c[O+0>>2]=c[v+0>>2];c[O+4>>2]=c[v+4>>2];c[O+8>>2]=c[v+8>>2];c[O+12>>2]=c[v+12>>2];v=b+96|0;ja=J+4|0;r=J+8|0;s=J+12|0;ia=I+4|0;pa=I+8|0;qa=K+4|0;ra=K+8|0;sa=K+12|0;ta=c[e+200>>2]|0;ua=0;va=0;while(1){wa=d[m+va>>0]|0;c[G+(va<<2)>>2]=wa;xa=d[n+va>>0]|0;c[H+(va<<2)>>2]=xa;ya=v+(1-wa<<4)|0;c[I+0>>2]=c[ya+0>>2];c[I+4>>2]=c[ya+4>>2];c[I+8>>2]=c[ya+8>>2];c[I+12>>2]=c[ya+12>>2];ga=ea(g[ta+(xa*12|0)>>2]);fa=ea(g[ta+(xa*12|0)+4>>2]);ha=ea(g[ta+(xa*12|0)+8>>2]);g[J>>2]=ga;g[ja>>2]=fa;g[r>>2]=ha;g[s>>2]=ea(0.0);da=ea(g[I>>2]);ca=ea(g[ia>>2]);$=ea(ca-fa);fa=ea(ea(g[pa>>2])-ha);g[K>>2]=ea(da-ga);g[qa>>2]=$;g[ra>>2]=fa;g[sa>>2]=ea(0.0);xa=E+(ua<<4)|0;c[N+0>>2]=c[I+0>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];c[N+12>>2]=c[I+12>>2];c[xa+0>>2]=c[I+0>>2];c[xa+4>>2]=c[I+4>>2];c[xa+8>>2]=c[I+8>>2];c[xa+12>>2]=c[I+12>>2];xa=F+(ua<<4)|0;c[O+0>>2]=c[J+0>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];c[O+12>>2]=c[J+12>>2];c[xa+0>>2]=c[J+0>>2];c[xa+4>>2]=c[J+4>>2];c[xa+8>>2]=c[J+8>>2];c[xa+12>>2]=c[J+12>>2];za=ua+1|0;xa=D+(ua<<4)|0;c[M+0>>2]=c[K+0>>2];c[M+4>>2]=c[K+4>>2];c[M+8>>2]=c[K+8>>2];c[M+12>>2]=c[K+12>>2];c[xa+0>>2]=c[K+0>>2];c[xa+4>>2]=c[K+4>>2];c[xa+8>>2]=c[K+8>>2];c[xa+12>>2]=c[K+12>>2];va=va+1|0;if(va>>>0>=(f&255)>>>0)break;else ua=za}c[L>>2]=za;do if((ua|0)==3)qPa(P,D,E,F,G,H,M,N,O,L,w,x);else if(!ua){c[w+0>>2]=c[N+0>>2];c[w+4>>2]=c[N+4>>2];c[w+8>>2]=c[N+8>>2];c[w+12>>2]=c[N+12>>2];c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];c[x+12>>2]=c[O+12>>2];c[P+0>>2]=c[M+0>>2];c[P+4>>2]=c[M+4>>2];c[P+8>>2]=c[M+8>>2];c[P+12>>2]=c[M+12>>2]}else if((ua|0)==2)V6a(P,D,D+16|0,M,D,E,F,L,w,x);else if((ua|0)==1){fa=ea(g[D>>2]);$=ea(g[D+4>>2]);ga=ea(g[D+8>>2]);da=ea(g[M>>2]);ha=ea(g[M+4>>2]);ca=ea(da-fa);da=ea(ha-$);ha=ea(ea(g[M+8>>2])-ga);Aa=ea(ea(ea(ca*ca)+ea(da*da))+ea(ha*ha));if(Aa==ea(0.0)){c[L>>2]=1;c[w+0>>2]=c[E+0>>2];c[w+4>>2]=c[E+4>>2];c[w+8>>2]=c[E+8>>2];c[w+12>>2]=c[E+12>>2];c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[P+0>>2]=c[D+0>>2];c[P+4>>2]=c[D+4>>2];c[P+8>>2]=c[D+8>>2];c[P+12>>2]=c[D+12>>2];break}else{Ba=ea(ea(ea(-ea($*da))-ea(fa*ca))-ea(ga*ha));ha=ea(g[N>>2]);ga=ea(g[N+4>>2]);ca=ea(g[N+8>>2]);fa=ea(g[E>>2]);da=ea(g[E+4>>2]);$=ea(g[E+8>>2]);Ca=ea(ha-fa);ha=ea(ga-da);ga=ea(ca-$);ca=ea(g[O>>2]);Da=ea(g[O+4>>2]);Ea=ea(g[O+8>>2]);Fa=ea(g[F>>2]);Ga=ea(g[F+4>>2]);Ha=ea(g[F+8>>2]);Ia=ea(ca-Fa);ca=ea(Da-Ga);Da=ea(Ea-Ha);Ea=ea(Ba/Aa);za=Ea>ea(1.0);Aa=za?ea(1.0):Ea;za=Aa>ea(0.0);Ea=za?Aa:ea(0.0);Aa=ea(fa+ea(Ca*Ea));Ca=ea(da+ea(ha*Ea));ha=ea($+ea(ga*Ea));ga=ea(Fa+ea(Ia*Ea));Ia=ea(Ga+ea(ca*Ea));ca=ea(Ha+ea(Da*Ea));g[w>>2]=Aa;g[w+4>>2]=Ca;g[w+8>>2]=ha;g[w+12>>2]=ea(0.0);g[x>>2]=ga;g[x+4>>2]=Ia;g[x+8>>2]=ca;g[x+12>>2]=ea(0.0);Ea=ea(Ca-Ia);Ia=ea(ha-ca);g[P>>2]=ea(Aa-ga);g[P+4>>2]=Ea;g[P+8>>2]=Ia;g[P+12>>2]=ea(0.0);break}}else{c[P+0>>2]=c[M+0>>2];c[P+4>>2]=c[M+4>>2];c[P+8>>2]=c[M+8>>2];c[P+12>>2]=c[M+12>>2]}while(0);c[C+0>>2]=c[P+0>>2];c[C+4>>2]=c[P+4>>2];c[C+8>>2]=c[P+8>>2];c[C+12>>2]=c[P+12>>2];Ia=ea(g[C>>2]);Ea=ea(g[C+4>>2]);ga=ea(g[C+8>>2]);Aa=ea(ea(ea(Ia*Ia)+ea(Ea*Ea))+ea(ga*ga));c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];ka=Aa;la=Aa>ba;ma=ga;na=Ea;oa=Ia}do if(la){P=C+4|0;M=C+8|0;O=b+96|0;N=b+96|0;ua=b+100|0;za=b+104|0;f=b+112|0;va=b+112|0;sa=b+116|0;ra=b+120|0;qa=I+4|0;pa=I+8|0;ia=I+12|0;s=e+196|0;r=e+200|0;ja=e+204|0;ta=J+4|0;v=J+8|0;xa=J+12|0;ya=K+4|0;wa=K+8|0;Ja=K+12|0;Ka=b+48|0;La=e+48|0;Ma=D+4|0;Na=D+8|0;Oa=E+4|0;Pa=E+8|0;Qa=F+4|0;Ra=F+8|0;Sa=w+4|0;Ta=w+8|0;Ua=w+12|0;Va=x+4|0;Wa=x+8|0;Xa=x+12|0;Ya=S+4|0;Za=S+8|0;_a=S+12|0;$a=D+16|0;Ia=X;Ea=oa;ga=na;Aa=ma;ca=ka;while(1){c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];ha=ea(-Ea);Ca=ea(-ga);Da=ea(-Aa);ab=c[L>>2]|0;Ha=ea(g[N>>2]);Ga=ea(g[ua>>2]);Fa=ea(ea(ea(Ha*ha)+ea(Ga*Ca))+ea(ea(g[za>>2])*Da));Ga=ea(g[va>>2]);Ha=ea(g[sa>>2]);bb=Fa>ea(ea(ea(Ga*ha)+ea(Ha*Ca))+ea(ea(g[ra>>2])*Da));c[G+(ab<<2)>>2]=bb&1;c[u+0>>2]=c[O+0>>2];c[u+4>>2]=c[O+4>>2];c[u+8>>2]=c[O+8>>2];c[u+12>>2]=c[O+12>>2];c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];cb=bb?u:t;Da=ea(g[cb>>2]);Ca=ea(g[cb+4>>2]);Ha=ea(g[cb+8>>2]);g[E+(ab<<4)>>2]=Da;g[E+(ab<<4)+4>>2]=Ca;g[E+(ab<<4)+8>>2]=Ha;g[E+(ab<<4)+12>>2]=ea(0.0);g[I>>2]=Da;g[qa>>2]=Ca;g[pa>>2]=Ha;g[ia>>2]=ea(0.0);cb=H+(ab<<2)|0;if(!(c[s>>2]|0)){bb=c[r>>2]|0;if((d[ja>>0]|0)>1){Ha=ea(g[bb+4>>2]);Ca=ea(ga*Ha);Ha=ea(Ea*ea(g[bb>>2]));db=bb;Da=ea(ea(Ca+Ha)+ea(Aa*ea(g[bb+8>>2])));eb=1;fb=0;while(1){gb=c[r>>2]|0;Ha=ea(g[gb+(eb*12|0)>>2]);Ca=ea(g[gb+(eb*12|0)+4>>2]);ha=ea(ea(ea(Ha*Ea)+ea(Ca*ga))+ea(ea(g[gb+(eb*12|0)+8>>2])*Aa));hb=ha>Da;ib=hb?eb:fb;jb=eb+1|0;if(jb>>>0<(d[ja>>0]|0)>>>0){db=gb;Da=hb?ha:Da;eb=jb;fb=ib}else{kb=ib;lb=gb;mb=Ea;nb=ga;ob=Aa;break}}}else{kb=0;lb=bb;mb=Ea;nb=ga;ob=Aa}}else{fb=DFb(e,C)|0;Da=ea(g[C>>2]);ha=ea(g[P>>2]);kb=fb;lb=c[r>>2]|0;mb=Da;nb=ha;ob=ea(g[M>>2])}c[cb>>2]=kb;ha=ea(g[lb+(kb*12|0)>>2]);Da=ea(g[lb+(kb*12|0)+4>>2]);Ca=ea(g[lb+(kb*12|0)+8>>2]);g[F+(ab<<4)>>2]=ha;g[F+(ab<<4)+4>>2]=Da;g[F+(ab<<4)+8>>2]=Ca;g[F+(ab<<4)+12>>2]=ea(0.0);g[J>>2]=ha;g[ta>>2]=Da;g[v>>2]=Ca;g[xa>>2]=ea(0.0);Ha=ea(g[I>>2]);Ga=ea(g[qa>>2]);Fa=ea(g[pa>>2]);$=ea(Ha-ha);da=ea(Ga-Da);fa=ea(Fa-Ca);g[K>>2]=$;g[ya>>2]=da;g[wa>>2]=fa;g[Ja>>2]=ea(0.0);pb=c[L>>2]|0;c[L>>2]=pb+1;fb=D+(pb<<4)|0;c[fb+0>>2]=c[K+0>>2];c[fb+4>>2]=c[K+4>>2];c[fb+8>>2]=c[K+8>>2];c[fb+12>>2]=c[K+12>>2];Ba=ea(g[Ka>>2]);qb=ea(g[La>>2]);rb=Ba>qb?Ba:qb;Ia=Ia>rb?Ia:rb;rb=ea(_+Ia);qb=ea(ea(ea(mb*$)+ea(nb*da))+ea(ob*fa));fb=ea(qb*qb)>ea(ca*ea(rb*rb));if(qb>ea(0.0)){sb=fb;tb=fb^1}else{sb=0;tb=1}fb=ea(ba*ca)>=ea(ca-qb);if((fb|sb)&(fb|tb^1))break;do if((pb|0)==3)qPa(S,D,E,F,G,H,K,I,J,L,w,x);else if((pb|0)==2)V6a(S,D,$a,K,D,E,F,L,w,x);else if(!pb){c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[x+0>>2]=c[J+0>>2];c[x+4>>2]=c[J+4>>2];c[x+8>>2]=c[J+8>>2];c[x+12>>2]=c[J+12>>2];c[S+0>>2]=c[K+0>>2];c[S+4>>2]=c[K+4>>2];c[S+8>>2]=c[K+8>>2];c[S+12>>2]=c[K+12>>2]}else if((pb|0)==1){qb=ea(g[D>>2]);rb=ea(g[Ma>>2]);Ba=ea(g[Na>>2]);ub=ea($-qb);vb=ea(da-rb);wb=ea(fa-Ba);xb=ea(ea(ea(ub*ub)+ea(vb*vb))+ea(wb*wb));if(xb==ea(0.0)){c[L>>2]=1;c[w+0>>2]=c[E+0>>2];c[w+4>>2]=c[E+4>>2];c[w+8>>2]=c[E+8>>2];c[w+12>>2]=c[E+12>>2];c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];c[S+0>>2]=c[D+0>>2];c[S+4>>2]=c[D+4>>2];c[S+8>>2]=c[D+8>>2];c[S+12>>2]=c[D+12>>2];break}else{yb=ea(ea(ea(-ea(rb*vb))-ea(qb*ub))-ea(Ba*wb));wb=ea(g[E>>2]);Ba=ea(g[Oa>>2]);ub=ea(g[Pa>>2]);qb=ea(Ha-wb);vb=ea(Ga-Ba);rb=ea(Fa-ub);zb=ea(g[F>>2]);Ab=ea(g[Qa>>2]);Bb=ea(g[Ra>>2]);Cb=ea(ha-zb);Db=ea(Da-Ab);Eb=ea(Ca-Bb);Fb=ea(yb/xb);fb=Fb>ea(1.0);xb=fb?ea(1.0):Fb;fb=xb>ea(0.0);Fb=fb?xb:ea(0.0);xb=ea(wb+ea(qb*Fb));qb=ea(Ba+ea(vb*Fb));vb=ea(ub+ea(rb*Fb));rb=ea(zb+ea(Cb*Fb));Cb=ea(Ab+ea(Db*Fb));Db=ea(Bb+ea(Eb*Fb));g[w>>2]=xb;g[Sa>>2]=qb;g[Ta>>2]=vb;g[Ua>>2]=ea(0.0);g[x>>2]=rb;g[Va>>2]=Cb;g[Wa>>2]=Db;g[Xa>>2]=ea(0.0);Fb=ea(qb-Cb);Cb=ea(vb-Db);g[S>>2]=ea(xb-rb);g[Ya>>2]=Fb;g[Za>>2]=Cb;g[_a>>2]=ea(0.0);break}}else{c[S+0>>2]=c[K+0>>2];c[S+4>>2]=c[K+4>>2];c[S+8>>2]=c[K+8>>2];c[S+12>>2]=c[K+12>>2]}while(0);c[C+0>>2]=c[S+0>>2];c[C+4>>2]=c[S+4>>2];c[C+8>>2]=c[S+8>>2];c[C+12>>2]=c[S+12>>2];Ea=ea(g[C>>2]);ga=ea(g[P>>2]);Aa=ea(g[M>>2]);Ca=ea(ea(ea(Ea*Ea)+ea(ga*ga))+ea(Aa*Aa));c[y+0>>2]=c[U+0>>2];c[y+4>>2]=c[U+4>>2];c[y+8>>2]=c[U+8>>2];Gb=ca>Ca;if(Ca>ba^1|Gb^1){Hb=41;break}else ca=Ca}if((Hb|0)==41){M=c[L>>2]|0;if(Gb){Ib=M;break}P=M+-1|0;if((m|0)!=0?(a[o>>0]=P,(P|0)!=0):0){M=0;do{a[m+M>>0]=c[G+(M<<2)>>2];a[n+M>>0]=c[H+(M<<2)>>2];M=M+1|0}while((M|0)!=(P|0))};c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Aa=ea(g[w>>2]);ga=ea(g[w+4>>2]);Ea=ea(g[w+8>>2]);Ia=ea(g[x>>2]);Ca=ea(g[x+4>>2]);Da=ea(g[x+8>>2]);ha=ea(Aa-Ia);Fa=ea(ga-Ca);Ga=ea(Ea-Da);g[C>>2]=ha;g[C+4>>2]=Fa;g[C+8>>2]=Ga;g[C+12>>2]=ea(0.0);Ha=ea(T(ea(ca)));fa=ea(ea(1.0)/Ha);da=ea(ha*fa);ha=ea(Fa*fa);Fa=ea(Ga*fa);if(p){fa=(c[b+64>>2]|0)==0?Y:ea(0.0);Ga=(c[e+64>>2]|0)==0?Z:ea(0.0);$=ea(fa+Ga);Cb=ea(ga-ea(ha*fa));Fb=ea(Ea-ea(Fa*fa));g[h>>2]=ea(Aa-ea(da*fa));g[h+4>>2]=Cb;g[h+8>>2]=Fb;g[h+12>>2]=ea(0.0);Fb=ea(ea(ha*Ga)+Ca);Cb=ea(ea(Fa*Ga)+Da);g[j>>2]=ea(ea(da*Ga)+Ia);g[j+4>>2]=Fb;g[j+8>>2]=Cb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ha-$);P=l+4|0;c[P+0>>2]=c[V+0>>2];c[P+4>>2]=c[V+4>>2];c[P+8>>2]=c[V+8>>2]}else{$=ea(ga-ea(Y*ha));ga=ea(Ea-ea(Y*Fa));g[h>>2]=ea(Aa-ea(Y*da));g[h+4>>2]=$;g[h+8>>2]=ga;g[h+12>>2]=ea(0.0);ga=ea(ea(Z*ha)+Ca);Ca=ea(ea(Z*Fa)+Da);g[j>>2]=ea(ea(Z*da)+Ia);g[j+4>>2]=ga;g[j+8>>2]=Ca;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ha-_);P=l+4|0;c[P+0>>2]=c[W+0>>2];c[P+4>>2]=c[W+4>>2];c[P+8>>2]=c[W+8>>2]}g[k>>2]=da;g[k+4>>2]=ha;g[k+8>>2]=Fa;g[k+12>>2]=ea(0.0);Jb=aa>=ca?1:3;i=q;return Jb|0}if((m|0)!=0?(a[o>>0]=pb,(pb|0)!=0):0){P=0;do{a[m+P>>0]=c[G+(P<<2)>>2];a[n+P>>0]=c[H+(P<<2)>>2];P=P+1|0}while((P|0)!=(pb|0))}if(!(tb&(sb^1))){Jb=0;i=q;return Jb|0}Fa=ea(T(ea(ca)));ha=ea(ea(1.0)/Fa);da=ea(mb*ha);Ha=ea(nb*ha);Ca=ea(ob*ha);g[k>>2]=da;g[k+4>>2]=Ha;g[k+8>>2]=Ca;g[k+12>>2]=ea(0.0);if(p){ha=(c[b+64>>2]|0)==0?Y:ea(0.0);ga=(c[e+64>>2]|0)==0?Z:ea(0.0);Ia=ea(ha+ga);Da=ea(g[w>>2]);$=ea(g[Sa>>2]);Aa=ea($-ea(Ha*ha));$=ea(ea(g[Ta>>2])-ea(Ca*ha));g[h>>2]=ea(Da-ea(da*ha));g[h+4>>2]=Aa;g[h+8>>2]=$;g[h+12>>2]=ea(0.0);$=ea(g[x>>2]);Aa=ea(g[Va>>2]);ha=ea(ea(Ha*ga)+Aa);Aa=ea(ea(Ca*ga)+ea(g[Wa>>2]));g[j>>2]=ea(ea(da*ga)+$);g[j+4>>2]=ha;g[j+8>>2]=Aa;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Fa-Ia);P=l+4|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];Jb=1;i=q;return Jb|0}else{Ia=ea(g[w>>2]);Aa=ea(g[Sa>>2]);ha=ea(Aa-ea(Y*Ha));Aa=ea(ea(g[Ta>>2])-ea(Y*Ca));g[h>>2]=ea(Ia-ea(Y*da));g[h+4>>2]=ha;g[h+8>>2]=Aa;g[h+12>>2]=ea(0.0);Aa=ea(g[x>>2]);ha=ea(g[Va>>2]);Ia=ea(ea(Z*Ha)+ha);ha=ea(ea(Z*Ca)+ea(g[Wa>>2]));g[j>>2]=ea(ea(Z*da)+Aa);g[j+4>>2]=Ia;g[j+8>>2]=ha;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Fa-_);P=l+4|0;c[P+0>>2]=c[R+0>>2];c[P+4>>2]=c[R+4>>2];c[P+8>>2]=c[R+8>>2];Jb=1;i=q;return Jb|0}}else Ib=c[L>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=Ib,(Ib|0)!=0):0){o=0;do{a[m+o>>0]=c[G+(o<<2)>>2];a[n+o>>0]=c[H+(o<<2)>>2];o=o+1|0}while((o|0)!=(Ib|0))};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];Jb=6;i=q;return Jb|0}function d7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=Im,Yb=Im,Zb=0,_b=0,$b=0,ac=0;q=i;i=i+528|0;r=q+272|0;s=q+400|0;t=q+304|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+416|0;y=q+440|0;z=q+336|0;A=q+128|0;B=q+192|0;C=q+456|0;D=q+472|0;E=q+488|0;F=q+256|0;G=q+80|0;H=q+112|0;I=q+16|0;J=q;K=q+32|0;L=q+320|0;M=q+428|0;N=q+288|0;O=q+492|0;P=q+504|0;Q=b+16|0;R=ea(g[Q>>2]);S=e+16|0;U=ea(g[S>>2]);V=ea(g[h>>2]);W=ea(g[b+32>>2]);X=ea(g[e+32>>2]);Y=ea((W>X?X:W)*ea(.100000001));W=ea(R+U);h=v+4|0;Z=v+8|0;_=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;$=w+4|0;aa=w+8|0;ba=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];X=ea(Y*Y);c[E>>2]=0;ca=a[p>>0]|0;if(!(ca<<24>>24)){Y=ea(g[f+48>>2]);da=ea(g[f+52>>2]);fa=ea(g[f+56>>2]);ga=ea(g[f+60>>2]);ha=ea(ea(ea(Y*Y)+ea(da*da))+ea(fa*fa))>ea(0.0);g[u>>2]=Y;g[u+4>>2]=da;g[u+8>>2]=fa;g[u+12>>2]=ga;g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ia=ha?u:t;ga=ea(g[ia>>2]);fa=ea(g[ia+4>>2]);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(0.0);ra=ea(3402823469999999843913219.0e14);sa=1;ta=ea(g[ia+8>>2]);ua=fa;va=ga}else{ia=F+4|0;t=F+8|0;u=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;ha=G+4|0;wa=G+8|0;xa=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ya=H+4|0;za=H+8|0;Aa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;ga=ea(g[b+144>>2]);fa=ea(g[b+148>>2]);da=ea(ga-R);ga=ea(fa-R);fa=ea(ea(g[b+152>>2])-R);Y=ea(-da);Ba=ea(-ga);Ca=ea(-fa);Da=s+4|0;Ea=s+8|0;Fa=s+12|0;Ga=r+4|0;Ha=r+8|0;Ia=r+12|0;Ja=ea(g[f+48>>2]);Ka=ea(g[f+52>>2]);La=ea(g[f+56>>2]);Ma=ea(g[f>>2]);Na=ea(g[f+16>>2]);Oa=ea(g[f+32>>2]);Pa=ea(g[f+4>>2]);Qa=ea(g[f+20>>2]);Ra=ea(g[f+36>>2]);Sa=ea(g[f+8>>2]);Ta=ea(g[f+24>>2]);Ua=ea(g[f+40>>2]);Va=ea(g[e+144>>2]);Wa=ea(g[e+148>>2]);Xa=ea(Va-U);Va=ea(Wa-U);Wa=ea(ea(g[e+152>>2])-U);Ya=ea(-Xa);Za=ea(-Va);_a=ea(-Wa);$a=s+4|0;ab=s+8|0;bb=s+12|0;cb=r+4|0;db=r+8|0;eb=r+12|0;fb=ca&255;ca=fb>>>0>1?fb:1;gb=0;hb=0;while(1){ib=d[n+hb>>0]|0;c[C+(hb<<2)>>2]=ib;jb=d[o+hb>>0]|0;c[D+(hb<<2)>>2]=jb;kb=c[540320+(ib<<4)>>2]|0;lb=c[540324+(ib<<4)>>2]|0;mb=c[540328+(ib<<4)>>2]|0;g[s>>2]=da;g[Da>>2]=ga;g[Ea>>2]=fa;g[Fa>>2]=ea(0.0);g[r>>2]=Y;g[Ga>>2]=Ba;g[Ha>>2]=Ca;g[Ia>>2]=ea(0.0);nb=ea(g[((kb|0)==0?r:s)>>2]);ob=ea(g[((lb|0)==0?r:s)+4>>2]);pb=ea(g[((mb|0)==0?r:s)+8>>2]);qb=ea(Ja+ea(ea(ea(nb*Ma)+ea(ob*Na))+ea(pb*Oa)));rb=ea(Ka+ea(ea(ea(nb*Pa)+ea(ob*Qa))+ea(pb*Ra)));sb=ea(La+ea(ea(ea(nb*Sa)+ea(ob*Ta))+ea(pb*Ua)));mb=c[540320+(jb<<4)>>2]|0;lb=c[540324+(jb<<4)>>2]|0;kb=c[540328+(jb<<4)>>2]|0;g[s>>2]=Xa;g[$a>>2]=Va;g[ab>>2]=Wa;g[bb>>2]=ea(0.0);g[r>>2]=Ya;g[cb>>2]=Za;g[db>>2]=_a;g[eb>>2]=ea(0.0);tb=ea(g[((mb|0)==0?r:s)>>2]);ub=ea(g[((lb|0)==0?r:s)+4>>2]);vb=ea(g[((kb|0)==0?r:s)+8>>2]);wb=ea(qb-tb);xb=ea(rb-ub);yb=ea(sb-vb);kb=A+(gb<<4)|0;g[G>>2]=qb;g[ha>>2]=rb;g[wa>>2]=sb;g[xa>>2]=ea(0.0);c[kb+0>>2]=c[G+0>>2];c[kb+4>>2]=c[G+4>>2];c[kb+8>>2]=c[G+8>>2];c[kb+12>>2]=c[G+12>>2];kb=B+(gb<<4)|0;g[H>>2]=tb;g[ya>>2]=ub;g[za>>2]=vb;g[Aa>>2]=ea(0.0);c[kb+0>>2]=c[H+0>>2];c[kb+4>>2]=c[H+4>>2];c[kb+8>>2]=c[H+8>>2];c[kb+12>>2]=c[H+12>>2];kb=z+(gb<<4)|0;g[F>>2]=wb;g[ia>>2]=xb;g[t>>2]=yb;g[u>>2]=ea(0.0);c[kb+0>>2]=c[F+0>>2];c[kb+4>>2]=c[F+4>>2];c[kb+8>>2]=c[F+8>>2];c[kb+12>>2]=c[F+12>>2];hb=hb+1|0;if(hb>>>0>=fb>>>0)break;else gb=gb+1|0}c[E>>2]=ca;do if((ca|0)==1){c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}else if((ca|0)==3)V6a(I,z,z+16|0,F,z,A,B,E,v,w);else if((ca|0)==4)qPa(I,z,A,B,C,D,F,G,H,E,v,w);else if((ca|0)==2){_a=ea(g[z>>2]);Za=ea(g[z+4>>2]);Ya=ea(g[z+8>>2]);Wa=ea(wb-_a);Va=ea(xb-Za);Xa=ea(yb-Ya);Ua=ea(ea(ea(Wa*Wa)+ea(Va*Va))+ea(Xa*Xa));if(Ua==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[I+0>>2]=c[z+0>>2];c[I+4>>2]=c[z+4>>2];c[I+8>>2]=c[z+8>>2];c[I+12>>2]=c[z+12>>2];break}else{Ta=ea(ea(ea(-ea(Za*Va))-ea(_a*Wa))-ea(Ya*Xa));Xa=ea(g[A>>2]);Ya=ea(g[A+4>>2]);Wa=ea(g[A+8>>2]);_a=ea(qb-Xa);Va=ea(rb-Ya);Za=ea(sb-Wa);Sa=ea(g[B>>2]);La=ea(g[B+4>>2]);Ra=ea(g[B+8>>2]);Qa=ea(tb-Sa);Pa=ea(ub-La);Ka=ea(vb-Ra);Oa=ea(Ta/Ua);gb=Oa>ea(1.0);Ua=gb?ea(1.0):Oa;gb=Ua>ea(0.0);Oa=gb?Ua:ea(0.0);Ua=ea(Xa+ea(_a*Oa));_a=ea(Ya+ea(Va*Oa));Va=ea(Wa+ea(Za*Oa));Za=ea(Sa+ea(Qa*Oa));Qa=ea(La+ea(Pa*Oa));Pa=ea(Ra+ea(Ka*Oa));g[v>>2]=Ua;g[h>>2]=_a;g[Z>>2]=Va;g[_>>2]=ea(0.0);g[w>>2]=Za;g[$>>2]=Qa;g[aa>>2]=Pa;g[ba>>2]=ea(0.0);Oa=ea(_a-Qa);Qa=ea(Va-Pa);g[I>>2]=ea(Ua-Za);g[I+4>>2]=Oa;g[I+8>>2]=Qa;g[I+12>>2]=ea(0.0);break}}else{c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}while(0);vb=ea(g[I>>2]);ub=ea(g[I+4>>2]);tb=ea(g[I+8>>2]);sb=ea(ea(ea(vb*vb)+ea(ub*ub))+ea(tb*tb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];rb=ea(g[v>>2]);qb=ea(g[h>>2]);yb=ea(g[Z>>2]);xb=ea(g[_>>2]);wb=ea(g[w>>2]);Qa=ea(g[$>>2]);Oa=ea(g[aa>>2]);ja=xb;ka=yb;la=qb;ma=rb;na=ea(g[ba>>2]);oa=Oa;pa=Qa;qa=wb;ra=sb;sa=sb>X;ta=tb;ua=ub;va=vb}do if(sa){I=b+144|0;F=b+148|0;ca=b+152|0;H=f+4|0;G=f+8|0;gb=f+16|0;fb=f+20|0;hb=f+24|0;u=f+32|0;t=f+36|0;ia=f+40|0;Aa=s+4|0;za=s+8|0;ya=s+12|0;xa=r+4|0;wa=r+8|0;ha=r+12|0;eb=f+48|0;db=f+52|0;cb=f+56|0;bb=J+4|0;ab=J+8|0;$a=J+12|0;Ia=e+144|0;Ha=e+148|0;Ga=e+152|0;Fa=s+4|0;Ea=s+8|0;Da=s+12|0;kb=r+4|0;lb=r+8|0;mb=r+12|0;jb=K+4|0;ib=K+8|0;zb=K+12|0;Ab=L+4|0;Bb=L+8|0;Cb=L+12|0;Db=b+48|0;Eb=e+48|0;Fb=N+4|0;Gb=N+8|0;Hb=z+4|0;Ib=z+8|0;Jb=A+4|0;Kb=A+8|0;Lb=B+4|0;Mb=B+8|0;Nb=N+12|0;Ob=z+16|0;vb=V;ub=va;tb=ua;sb=ta;wb=ra;Qa=ma;Oa=la;rb=ka;qb=ja;yb=qa;xb=pa;Za=oa;Ua=na;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Pa=ea(-ub);Va=ea(-tb);_a=ea(-sb);Pb=c[E>>2]|0;Qb=A+(Pb<<4)|0;Ka=ea(g[I>>2]);Ra=ea(g[F>>2]);La=ea(g[ca>>2]);Sa=ea(g[Q>>2]);Wa=ea(Ka-Sa);Ka=ea(Ra-Sa);Ra=ea(La-Sa);Sa=ea(g[f>>2]);La=ea(Sa*Pa);Ya=ea(g[H>>2]);Xa=ea(La+ea(Ya*Va));La=ea(g[G>>2]);Ta=ea(Xa+ea(La*_a));Xa=ea(g[gb>>2]);Na=ea(Xa*Pa);Ma=ea(g[fb>>2]);Ja=ea(Na+ea(Ma*Va));Na=ea(g[hb>>2]);Ca=ea(Ja+ea(Na*_a));Ja=ea(g[u>>2]);Ba=ea(Ja*Pa);Pa=ea(g[t>>2]);Y=ea(Ba+ea(Pa*Va));Va=ea(g[ia>>2]);Rb=Ta>ea(0.0);Sb=Ca>ea(0.0);Tb=ea(Y+ea(Va*_a))>ea(0.0);c[C+(Pb<<2)>>2]=Sb<<31>>31<<1&2|Rb&1|Tb<<31>>31<<2&4;_a=ea(-Wa);Y=ea(-Ka);Ca=ea(-Ra);g[s>>2]=Wa;g[Aa>>2]=Ka;g[za>>2]=Ra;g[ya>>2]=ea(0.0);g[r>>2]=_a;g[xa>>2]=Y;g[wa>>2]=Ca;g[ha>>2]=ea(0.0);Ca=ea(g[(Rb?s:r)>>2]);Y=ea(g[(Sb?s:r)+4>>2]);_a=ea(g[(Tb?s:r)+8>>2]);Ra=ea(g[eb>>2]);Ka=ea(g[db>>2]);Wa=ea(Ra+ea(ea(ea(Sa*Ca)+ea(Xa*Y))+ea(Ja*_a)));Ja=ea(Ka+ea(ea(ea(Ya*Ca)+ea(Ma*Y))+ea(Pa*_a)));Pa=ea(ea(ea(ea(La*Ca)+ea(Na*Y))+ea(Va*_a))+ea(g[cb>>2]));g[J>>2]=Wa;g[bb>>2]=Ja;g[ab>>2]=Pa;g[$a>>2]=ea(0.0);c[Qb+0>>2]=c[J+0>>2];c[Qb+4>>2]=c[J+4>>2];c[Qb+8>>2]=c[J+8>>2];c[Qb+12>>2]=c[J+12>>2];Qb=B+(Pb<<4)|0;_a=ea(g[Ia>>2]);Va=ea(g[Ha>>2]);Y=ea(g[Ga>>2]);Na=ea(g[S>>2]);Ca=ea(_a-Na);_a=ea(Va-Na);Va=ea(Y-Na);Tb=ub>ea(0.0);Sb=tb>ea(0.0);Rb=sb>ea(0.0);c[D+(Pb<<2)>>2]=Rb<<31>>31<<2&4|Tb&1|Sb<<31>>31<<1&2;Na=ea(-Ca);Y=ea(-_a);La=ea(-Va);g[s>>2]=Ca;g[Fa>>2]=_a;g[Ea>>2]=Va;g[Da>>2]=ea(0.0);g[r>>2]=Na;g[kb>>2]=Y;g[lb>>2]=La;g[mb>>2]=ea(0.0);La=ea(g[(Tb?s:r)>>2]);Y=ea(g[(Sb?s:r)+4>>2]);Na=ea(g[(Rb?s:r)+8>>2]);g[K>>2]=La;g[jb>>2]=Y;g[ib>>2]=Na;g[zb>>2]=ea(0.0);c[Qb+0>>2]=c[K+0>>2];c[Qb+4>>2]=c[K+4>>2];c[Qb+8>>2]=c[K+8>>2];c[Qb+12>>2]=c[K+12>>2];Va=ea(Wa-La);_a=ea(Ja-Y);Ca=ea(Pa-Na);g[L>>2]=Va;g[Ab>>2]=_a;g[Bb>>2]=Ca;g[Cb>>2]=ea(0.0);Ub=c[E>>2]|0;c[E>>2]=Ub+1;Qb=z+(Ub<<4)|0;c[Qb+0>>2]=c[L+0>>2];c[Qb+4>>2]=c[L+4>>2];c[Qb+8>>2]=c[L+8>>2];c[Qb+12>>2]=c[L+12>>2];Ma=ea(g[Db>>2]);Ya=ea(g[Eb>>2]);Ka=Ma>Ya?Ma:Ya;Ya=vb>Ka?vb:Ka;Ka=ea(W+Ya);Ma=ea(ea(ea(ub*Va)+ea(tb*_a))+ea(sb*Ca));Qb=ea(Ma*Ma)>ea(wb*ea(Ka*Ka));if(Ma>ea(0.0)){Vb=Qb;Wb=Qb^1}else{Vb=0;Wb=1}Qb=ea(X*wb)>=ea(wb-Ma);if((Qb|Vb)&(Qb|Wb^1))break;do if((Ub|0)==1){Ma=ea(g[z>>2]);Ka=ea(g[Hb>>2]);Xa=ea(g[Ib>>2]);Sa=ea(Va-Ma);Ra=ea(_a-Ka);Ta=ea(Ca-Xa);Ba=ea(ea(ea(Sa*Sa)+ea(Ra*Ra))+ea(Ta*Ta));if(Ba==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[N+0>>2]=c[z+0>>2];c[N+4>>2]=c[z+4>>2];c[N+8>>2]=c[z+8>>2];c[N+12>>2]=c[z+12>>2];break}else{fa=ea(ea(ea(-ea(Ka*Ra))-ea(Ma*Sa))-ea(Xa*Ta));Ta=ea(g[A>>2]);Xa=ea(g[Jb>>2]);Sa=ea(g[Kb>>2]);Ma=ea(Wa-Ta);Ra=ea(Ja-Xa);Ka=ea(Pa-Sa);ga=ea(g[B>>2]);da=ea(g[Lb>>2]);pb=ea(g[Mb>>2]);ob=ea(La-ga);nb=ea(Y-da);Xb=ea(Na-pb);Yb=ea(fa/Ba);Qb=Yb>ea(1.0);Ba=Qb?ea(1.0):Yb;Qb=Ba>ea(0.0);Yb=Qb?Ba:ea(0.0);Ba=ea(Ta+ea(Ma*Yb));Ma=ea(Xa+ea(Ra*Yb));Ra=ea(Sa+ea(Ka*Yb));Ka=ea(ga+ea(ob*Yb));ob=ea(da+ea(nb*Yb));nb=ea(pb+ea(Xb*Yb));g[v>>2]=Ba;g[h>>2]=Ma;g[Z>>2]=Ra;g[_>>2]=ea(0.0);g[w>>2]=Ka;g[$>>2]=ob;g[aa>>2]=nb;g[ba>>2]=ea(0.0);Yb=ea(Ma-ob);ob=ea(Ra-nb);g[N>>2]=ea(Ba-Ka);g[Fb>>2]=Yb;g[Gb>>2]=ob;g[Nb>>2]=ea(0.0);break}}else if(!Ub){c[v+0>>2]=c[J+0>>2];c[v+4>>2]=c[J+4>>2];c[v+8>>2]=c[J+8>>2];c[v+12>>2]=c[J+12>>2];c[w+0>>2]=c[K+0>>2];c[w+4>>2]=c[K+4>>2];c[w+8>>2]=c[K+8>>2];c[w+12>>2]=c[K+12>>2];c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}else if((Ub|0)==3)qPa(N,z,A,B,C,D,L,J,K,E,v,w);else if((Ub|0)==2)V6a(N,z,Ob,L,z,A,B,E,v,w);else{c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}while(0);Na=ea(g[N>>2]);Y=ea(g[Fb>>2]);La=ea(g[Gb>>2]);Pa=ea(ea(ea(Na*Na)+ea(Y*Y))+ea(La*La));c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];Zb=wb>Pa;if(Pa>X^1|Zb^1){_b=35;break}Ja=ea(g[v>>2]);Wa=ea(g[h>>2]);Ca=ea(g[Z>>2]);_a=ea(g[_>>2]);Va=ea(g[w>>2]);ob=ea(g[$>>2]);Yb=ea(g[aa>>2]);vb=Ya;ub=Na;tb=Y;sb=La;wb=Pa;Qa=Ja;Oa=Wa;rb=Ca;qb=_a;yb=Va;xb=ob;Za=Yb;Ua=ea(g[ba>>2])}if((_b|0)==35){Gb=c[E>>2]|0;if(Zb){$b=Gb;break}Fb=Gb+-1|0;if((n|0)!=0?(a[p>>0]=Fb,(Fb|0)!=0):0){Gb=0;do{a[n+Gb>>0]=c[C+(Gb<<2)>>2];a[o+Gb>>0]=c[D+(Gb<<2)>>2];Gb=Gb+1|0}while((Gb|0)!=(Fb|0))}g[v>>2]=Qa;g[h>>2]=Oa;g[Z>>2]=rb;g[_>>2]=qb;g[w>>2]=yb;g[$>>2]=xb;g[aa>>2]=Za;g[ba>>2]=Ua;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];vb=ea(T(ea(wb)));Yb=ea(ea(1.0)/vb);ob=ea(ea(Qa-yb)*Yb);Va=ea(ea(Oa-xb)*Yb);_a=ea(ea(rb-Za)*Yb);Yb=ea(Oa-ea(R*Va));Ca=ea(rb-ea(R*_a));g[j>>2]=ea(Qa-ea(R*ob));g[j+4>>2]=Yb;g[j+8>>2]=Ca;g[j+12>>2]=ea(0.0);Ca=ea(ea(U*Va)+xb);Yb=ea(ea(U*_a)+Za);g[k>>2]=ea(ea(U*ob)+yb);g[k+4>>2]=Ca;g[k+8>>2]=Yb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(vb-W);Fb=m+4|0;c[Fb+0>>2]=c[P+0>>2];c[Fb+4>>2]=c[P+4>>2];c[Fb+8>>2]=c[P+8>>2];g[l>>2]=ob;g[l+4>>2]=Va;g[l+8>>2]=_a;g[l+12>>2]=ea(0.0);ac=3;i=q;return ac|0}if((n|0)!=0?(a[p>>0]=Ub,(Ub|0)!=0):0){Fb=0;do{a[n+Fb>>0]=c[C+(Fb<<2)>>2];a[o+Fb>>0]=c[D+(Fb<<2)>>2];Fb=Fb+1|0}while((Fb|0)!=(Ub|0))}if(!(Wb&(Vb^1))){ac=0;i=q;return ac|0}yb=ea(T(ea(wb)));Za=ea(ea(1.0)/yb);xb=ea(ub*Za);Qa=ea(tb*Za);rb=ea(sb*Za);Za=ea(g[v>>2]);Oa=ea(g[h>>2]);Ua=ea(Oa-ea(R*Qa));Oa=ea(ea(g[Z>>2])-ea(R*rb));g[j>>2]=ea(Za-ea(R*xb));g[j+4>>2]=Ua;g[j+8>>2]=Oa;g[j+12>>2]=ea(0.0);Oa=ea(g[w>>2]);Ua=ea(g[$>>2]);Za=ea(ea(U*Qa)+Ua);Ua=ea(ea(U*rb)+ea(g[aa>>2]));g[k>>2]=ea(ea(U*xb)+Oa);g[k+4>>2]=Za;g[k+8>>2]=Ua;g[k+12>>2]=ea(0.0);g[m>>2]=ea(yb-W);Fb=m+4|0;c[Fb+0>>2]=c[M+0>>2];c[Fb+4>>2]=c[M+4>>2];c[Fb+8>>2]=c[M+8>>2];g[l>>2]=xb;g[l+4>>2]=Qa;g[l+8>>2]=rb;g[l+12>>2]=ea(0.0);ac=1;i=q;return ac|0}else $b=c[E>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=$b,($b|0)!=0):0){p=0;do{a[n+p>>0]=c[C+(p<<2)>>2];a[o+p>>0]=c[D+(p<<2)>>2];p=p+1|0}while((p|0)!=($b|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];ac=6;i=q;return ac|0}function e7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=0,Fb=0,Gb=0,Hb=Im,Ib=Im,Jb=Im,Kb=0,Lb=0,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=0,Vb=0,Wb=0,Xb=0;q=i;i=i+560|0;r=q+288|0;s=q+432|0;t=q+336|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+448|0;y=q+472|0;z=q+352|0;A=q+368|0;B=q+144|0;C=q+208|0;D=q+488|0;E=q+504|0;F=q+520|0;G=q+16|0;H=q+304|0;I=q+112|0;J=q+128|0;K=q;L=q+32|0;M=q+272|0;N=q+320|0;O=q+460|0;P=q+80|0;Q=q+524|0;R=q+536|0;S=b+16|0;U=ea(g[S>>2]);V=ea(g[e+16>>2]);W=ea(g[h>>2]);X=ea(g[b+32>>2]);Y=ea(g[e+32>>2]);Z=ea((X>Y?Y:X)*ea(.100000001));X=ea(U+V);h=v+4|0;_=v+8|0;$=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;aa=w+4|0;ba=w+8|0;ca=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Y=ea(Z*Z);c[F>>2]=0;if(!(a[p>>0]|0)){Z=ea(g[f+48>>2]);da=ea(g[f+52>>2]);fa=ea(g[f+56>>2]);ga=ea(g[f+60>>2]);ha=ea(ea(ea(Z*Z)+ea(da*da))+ea(fa*fa))>ea(0.0);g[u>>2]=Z;g[u+4>>2]=da;g[u+8>>2]=fa;g[u+12>>2]=ga;g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ia=ha?u:t;ga=ea(g[ia>>2]);fa=ea(g[ia+4>>2]);da=ea(g[ia+8>>2]);g[z>>2]=ga;g[z+4>>2]=fa;g[z+8>>2]=da;g[z+12>>2]=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(0.0);ra=ea(3402823469999999843913219.0e14);sa=1;ta=da;ua=fa;va=ga}else{ia=G+4|0;t=G+8|0;u=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ha=H+4|0;wa=H+8|0;xa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;ya=I+4|0;za=I+8|0;Aa=I+12|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;Ba=b+144|0;Ca=b+148|0;Da=b+152|0;Ea=s+4|0;Fa=s+8|0;Ga=s+12|0;Ha=r+4|0;Ia=r+8|0;Ja=r+12|0;Ka=f+48|0;La=f+52|0;Ma=f+56|0;Na=f+16|0;Oa=f+32|0;Pa=f+4|0;Qa=f+20|0;Ra=f+36|0;Sa=f+8|0;Ta=f+24|0;Ua=f+40|0;Va=e+16|0;Wa=J+4|0;Xa=J+8|0;Ya=J+12|0;ga=U;Za=0;while(1){_a=d[n+Za>>0]|0;c[D+(Za<<2)>>2]=_a;$a=d[o+Za>>0]|0;c[E+(Za<<2)>>2]=$a;fa=ea(g[Ba>>2]);da=ea(g[Ca>>2]);Z=ea(fa-ga);fa=ea(da-ga);da=ea(ea(g[Da>>2])-ga);ab=c[540320+(_a<<4)>>2]|0;bb=c[540324+(_a<<4)>>2]|0;cb=c[540328+(_a<<4)>>2]|0;db=ea(-Z);eb=ea(-fa);fb=ea(-da);g[s>>2]=Z;g[Ea>>2]=fa;g[Fa>>2]=da;g[Ga>>2]=ea(0.0);g[r>>2]=db;g[Ha>>2]=eb;g[Ia>>2]=fb;g[Ja>>2]=ea(0.0);fb=ea(g[((ab|0)==0?r:s)>>2]);eb=ea(g[((bb|0)==0?r:s)+4>>2]);db=ea(g[((cb|0)==0?r:s)+8>>2]);da=ea(g[Ka>>2]);fa=ea(g[La>>2]);Z=ea(g[Ma>>2]);gb=ea(fb*ea(g[f>>2]));hb=ea(gb+ea(eb*ea(g[Na>>2])));gb=ea(hb+ea(db*ea(g[Oa>>2])));hb=ea(fb*ea(g[Pa>>2]));ib=ea(hb+ea(eb*ea(g[Qa>>2])));hb=ea(ib+ea(db*ea(g[Ra>>2])));ib=ea(fb*ea(g[Sa>>2]));fb=ea(ib+ea(eb*ea(g[Ta>>2])));jb=ea(da+gb);kb=ea(fa+hb);lb=ea(Z+ea(fb+ea(db*ea(g[Ua>>2]))));BFb(J,e,$a,Va);mb=ea(g[J>>2]);nb=ea(g[Wa>>2]);ob=ea(g[Xa>>2]);db=ea(g[Ya>>2]);pb=ea(jb-mb);qb=ea(kb-nb);rb=ea(lb-ob);sb=c[F>>2]|0;$a=B+(sb<<4)|0;g[H>>2]=jb;g[ha>>2]=kb;g[wa>>2]=lb;g[xa>>2]=ea(0.0);c[$a+0>>2]=c[H+0>>2];c[$a+4>>2]=c[H+4>>2];c[$a+8>>2]=c[H+8>>2];c[$a+12>>2]=c[H+12>>2];$a=C+(sb<<4)|0;g[I>>2]=mb;g[ya>>2]=nb;g[za>>2]=ob;g[Aa>>2]=db;c[$a+0>>2]=c[I+0>>2];c[$a+4>>2]=c[I+4>>2];c[$a+8>>2]=c[I+8>>2];c[$a+12>>2]=c[I+12>>2];c[F>>2]=sb+1;$a=A+(sb<<4)|0;g[G>>2]=pb;g[ia>>2]=qb;g[t>>2]=rb;g[u>>2]=ea(0.0);c[$a+0>>2]=c[G+0>>2];c[$a+4>>2]=c[G+4>>2];c[$a+8>>2]=c[G+8>>2];c[$a+12>>2]=c[G+12>>2];$a=Za+1|0;if($a>>>0>=(d[p>>0]|0)>>>0)break;ga=ea(g[S>>2]);Za=$a}do if((sb|0)==3)qPa(K,A,B,C,D,E,G,H,I,F,v,w);else if((sb|0)==2)V6a(K,A,A+16|0,G,A,B,C,F,v,w);else if(!sb){c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}else if((sb|0)==1){ga=ea(g[A>>2]);db=ea(g[A+4>>2]);fb=ea(g[A+8>>2]);Z=ea(pb-ga);hb=ea(qb-db);fa=ea(rb-fb);gb=ea(ea(ea(Z*Z)+ea(hb*hb))+ea(fa*fa));if(gb==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[K+0>>2]=c[A+0>>2];c[K+4>>2]=c[A+4>>2];c[K+8>>2]=c[A+8>>2];c[K+12>>2]=c[A+12>>2];break}else{da=ea(ea(ea(-ea(db*hb))-ea(ga*Z))-ea(fb*fa));fa=ea(g[B>>2]);fb=ea(g[B+4>>2]);Z=ea(g[B+8>>2]);ga=ea(jb-fa);hb=ea(kb-fb);db=ea(lb-Z);eb=ea(g[C>>2]);ib=ea(g[C+4>>2]);tb=ea(g[C+8>>2]);ub=ea(mb-eb);vb=ea(nb-ib);wb=ea(ob-tb);xb=ea(da/gb);Za=xb>ea(1.0);gb=Za?ea(1.0):xb;Za=gb>ea(0.0);xb=Za?gb:ea(0.0);gb=ea(fa+ea(ga*xb));ga=ea(fb+ea(hb*xb));hb=ea(Z+ea(db*xb));db=ea(eb+ea(ub*xb));ub=ea(ib+ea(vb*xb));vb=ea(tb+ea(wb*xb));g[v>>2]=gb;g[h>>2]=ga;g[_>>2]=hb;g[$>>2]=ea(0.0);g[w>>2]=db;g[aa>>2]=ub;g[ba>>2]=vb;g[ca>>2]=ea(0.0);xb=ea(ga-ub);ub=ea(hb-vb);g[K>>2]=ea(gb-db);g[K+4>>2]=xb;g[K+8>>2]=ub;g[K+12>>2]=ea(0.0);break}}else{c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}while(0);c[z+0>>2]=c[K+0>>2];c[z+4>>2]=c[K+4>>2];c[z+8>>2]=c[K+8>>2];c[z+12>>2]=c[K+12>>2];ob=ea(g[z>>2]);nb=ea(g[z+4>>2]);mb=ea(g[z+8>>2]);lb=ea(ea(ea(ob*ob)+ea(nb*nb))+ea(mb*mb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];kb=ea(g[v>>2]);jb=ea(g[h>>2]);rb=ea(g[_>>2]);qb=ea(g[$>>2]);pb=ea(g[w>>2]);ub=ea(g[aa>>2]);xb=ea(g[ba>>2]);ja=qb;ka=rb;la=jb;ma=kb;na=ea(g[ca>>2]);oa=xb;pa=ub;qa=pb;ra=lb;sa=lb>Y;ta=mb;ua=nb;va=ob}do if(sa){K=z+4|0;G=z+8|0;sb=b+144|0;I=b+148|0;H=b+152|0;Za=f+4|0;u=f+8|0;t=f+16|0;ia=f+20|0;Aa=f+24|0;za=f+32|0;ya=f+36|0;xa=f+40|0;wa=s+4|0;ha=s+8|0;Ya=s+12|0;Xa=r+4|0;Wa=r+8|0;J=r+12|0;Va=f+48|0;Ua=f+52|0;Ta=f+56|0;Sa=L+4|0;Ra=L+8|0;Qa=L+12|0;Pa=M+4|0;Oa=M+8|0;Na=N+4|0;Ma=N+8|0;La=N+12|0;Ka=b+48|0;Ja=e+48|0;Ia=A+4|0;Ha=A+8|0;Ga=B+4|0;Fa=B+8|0;Ea=C+4|0;Da=C+8|0;Ca=P+4|0;Ba=P+8|0;$a=P+12|0;cb=A+16|0;ob=W;nb=va;mb=ua;lb=ta;pb=ra;ub=ma;xb=la;kb=ka;jb=ja;rb=qa;qb=pa;db=oa;gb=na;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];vb=ea(-nb);hb=ea(-mb);ga=ea(-lb);bb=c[F>>2]|0;ab=B+(bb<<4)|0;wb=ea(g[sb>>2]);tb=ea(g[I>>2]);ib=ea(g[H>>2]);eb=ea(g[S>>2]);Z=ea(wb-eb);wb=ea(tb-eb);tb=ea(ib-eb);eb=ea(g[f>>2]);ib=ea(eb*vb);fb=ea(g[Za>>2]);fa=ea(ib+ea(fb*hb));ib=ea(g[u>>2]);da=ea(fa+ea(ib*ga));fa=ea(g[t>>2]);yb=ea(fa*vb);zb=ea(g[ia>>2]);Ab=ea(yb+ea(zb*hb));yb=ea(g[Aa>>2]);Bb=ea(Ab+ea(yb*ga));Ab=ea(g[za>>2]);Cb=ea(Ab*vb);vb=ea(g[ya>>2]);Db=ea(Cb+ea(vb*hb));hb=ea(g[xa>>2]);_a=da>ea(0.0);Eb=Bb>ea(0.0);Fb=ea(Db+ea(hb*ga))>ea(0.0);c[D+(bb<<2)>>2]=Eb<<31>>31<<1&2|_a&1|Fb<<31>>31<<2&4;ga=ea(-Z);Db=ea(-wb);Bb=ea(-tb);g[s>>2]=Z;g[wa>>2]=wb;g[ha>>2]=tb;g[Ya>>2]=ea(0.0);g[r>>2]=ga;g[Xa>>2]=Db;g[Wa>>2]=Bb;g[J>>2]=ea(0.0);Bb=ea(g[(_a?s:r)>>2]);Db=ea(g[(Eb?s:r)+4>>2]);ga=ea(g[(Fb?s:r)+8>>2]);tb=ea(g[Va>>2]);wb=ea(g[Ua>>2]);Z=ea(wb+ea(ea(ea(fb*Bb)+ea(zb*Db))+ea(vb*ga)));vb=ea(ea(ea(ea(ib*Bb)+ea(yb*Db))+ea(hb*ga))+ea(g[Ta>>2]));g[L>>2]=ea(tb+ea(ea(ea(eb*Bb)+ea(fa*Db))+ea(Ab*ga)));g[Sa>>2]=Z;g[Ra>>2]=vb;g[Qa>>2]=ea(0.0);c[ab+0>>2]=c[L+0>>2];c[ab+4>>2]=c[L+4>>2];c[ab+8>>2]=c[L+8>>2];c[ab+12>>2]=c[L+12>>2];CFb(M,e,z,C+(bb<<4)|0,E+(bb<<2)|0);vb=ea(g[L>>2]);Z=ea(g[Sa>>2]);ga=ea(g[Ra>>2]);Ab=ea(g[M>>2]);Db=ea(g[Pa>>2]);fa=ea(g[Oa>>2]);Bb=ea(vb-Ab);eb=ea(Z-Db);tb=ea(ga-fa);g[N>>2]=Bb;g[Na>>2]=eb;g[Ma>>2]=tb;g[La>>2]=ea(0.0);Gb=c[F>>2]|0;c[F>>2]=Gb+1;bb=A+(Gb<<4)|0;c[bb+0>>2]=c[N+0>>2];c[bb+4>>2]=c[N+4>>2];c[bb+8>>2]=c[N+8>>2];c[bb+12>>2]=c[N+12>>2];hb=ea(g[Ka>>2]);yb=ea(g[Ja>>2]);ib=hb>yb?hb:yb;yb=ob>ib?ob:ib;ib=ea(X+yb);hb=ea(pb*ea(ib*ib));Hb=ea(g[z>>2]);Ib=ea(g[K>>2]);Jb=ea(g[G>>2]);ib=ea(ea(ea(Hb*Bb)+ea(Ib*eb))+ea(Jb*tb));bb=ea(ib*ib)>hb;if(ib>ea(0.0)){Kb=bb;Lb=bb^1}else{Kb=0;Lb=1}bb=ea(Y*pb)>=ea(pb-ib);if((bb|Kb)&(bb|Lb^1))break;do if((Gb|0)==1){ib=ea(g[A>>2]);hb=ea(g[Ia>>2]);zb=ea(g[Ha>>2]);fb=ea(Bb-ib);wb=ea(eb-hb);da=ea(tb-zb);Cb=ea(ea(ea(fb*fb)+ea(wb*wb))+ea(da*da));if(Cb==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[P+0>>2]=c[A+0>>2];c[P+4>>2]=c[A+4>>2];c[P+8>>2]=c[A+8>>2];c[P+12>>2]=c[A+12>>2];break}else{Mb=ea(ea(ea(-ea(hb*wb))-ea(ib*fb))-ea(zb*da));da=ea(g[B>>2]);zb=ea(g[Ga>>2]);fb=ea(g[Fa>>2]);ib=ea(vb-da);wb=ea(Z-zb);hb=ea(ga-fb);Nb=ea(g[C>>2]);Ob=ea(g[Ea>>2]);Pb=ea(g[Da>>2]);Qb=ea(Ab-Nb);Rb=ea(Db-Ob);Sb=ea(fa-Pb);Tb=ea(Mb/Cb);bb=Tb>ea(1.0);Cb=bb?ea(1.0):Tb;bb=Cb>ea(0.0);Tb=bb?Cb:ea(0.0);Cb=ea(da+ea(ib*Tb));ib=ea(zb+ea(wb*Tb));wb=ea(fb+ea(hb*Tb));hb=ea(Nb+ea(Qb*Tb));Qb=ea(Ob+ea(Rb*Tb));Rb=ea(Pb+ea(Sb*Tb));g[v>>2]=Cb;g[h>>2]=ib;g[_>>2]=wb;g[$>>2]=ea(0.0);g[w>>2]=hb;g[aa>>2]=Qb;g[ba>>2]=Rb;g[ca>>2]=ea(0.0);Tb=ea(ib-Qb);Qb=ea(wb-Rb);g[P>>2]=ea(Cb-hb);g[Ca>>2]=Tb;g[Ba>>2]=Qb;g[$a>>2]=ea(0.0);break}}else if((Gb|0)==3)qPa(P,A,B,C,D,E,N,L,M,F,v,w);else if((Gb|0)==2)V6a(P,A,cb,N,A,B,C,F,v,w);else if(!Gb){c[v+0>>2]=c[L+0>>2];c[v+4>>2]=c[L+4>>2];c[v+8>>2]=c[L+8>>2];c[v+12>>2]=c[L+12>>2];c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}else{c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}while(0);c[z+0>>2]=c[P+0>>2];c[z+4>>2]=c[P+4>>2];c[z+8>>2]=c[P+8>>2];c[z+12>>2]=c[P+12>>2];fa=ea(g[z>>2]);Db=ea(g[K>>2]);Ab=ea(g[G>>2]);ga=ea(ea(ea(fa*fa)+ea(Db*Db))+ea(Ab*Ab));c[x+0>>2]=c[Q+0>>2];c[x+4>>2]=c[Q+4>>2];c[x+8>>2]=c[Q+8>>2];Ub=pb>ga;if(ga>Y^1|Ub^1){Vb=36;break}Z=ea(g[v>>2]);vb=ea(g[h>>2]);tb=ea(g[_>>2]);eb=ea(g[$>>2]);Bb=ea(g[w>>2]);Qb=ea(g[aa>>2]);Tb=ea(g[ba>>2]);ob=yb;nb=fa;mb=Db;lb=Ab;pb=ga;ub=Z;xb=vb;kb=tb;jb=eb;rb=Bb;qb=Qb;db=Tb;gb=ea(g[ca>>2])}if((Vb|0)==36){G=c[F>>2]|0;if(Ub){Wb=G;break}K=G+-1|0;if((n|0)!=0?(a[p>>0]=K,(K|0)!=0):0){G=0;do{a[n+G>>0]=c[D+(G<<2)>>2];a[o+G>>0]=c[E+(G<<2)>>2];G=G+1|0}while((G|0)!=(K|0))}g[v>>2]=ub;g[h>>2]=xb;g[_>>2]=kb;g[$>>2]=jb;g[w>>2]=rb;g[aa>>2]=qb;g[ba>>2]=db;g[ca>>2]=gb;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];lb=ea(ub-rb);mb=ea(xb-qb);nb=ea(kb-db);g[z>>2]=lb;g[z+4>>2]=mb;g[z+8>>2]=nb;g[z+12>>2]=ea(0.0);ob=ea(T(ea(pb)));Tb=ea(ea(1.0)/ob);Qb=ea(lb*Tb);lb=ea(mb*Tb);mb=ea(nb*Tb);Tb=ea(xb-ea(U*lb));nb=ea(kb-ea(U*mb));g[j>>2]=ea(ub-ea(U*Qb));g[j+4>>2]=Tb;g[j+8>>2]=nb;g[j+12>>2]=ea(0.0);nb=ea(ea(V*lb)+qb);Tb=ea(ea(V*mb)+db);g[k>>2]=ea(ea(V*Qb)+rb);g[k+4>>2]=nb;g[k+8>>2]=Tb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(ob-X);K=m+4|0;c[K+0>>2]=c[R+0>>2];c[K+4>>2]=c[R+4>>2];c[K+8>>2]=c[R+8>>2];g[l>>2]=Qb;g[l+4>>2]=lb;g[l+8>>2]=mb;g[l+12>>2]=ea(0.0);Xb=3;i=q;return Xb|0}if((n|0)!=0?(a[p>>0]=Gb,(Gb|0)!=0):0){K=0;do{a[n+K>>0]=c[D+(K<<2)>>2];a[o+K>>0]=c[E+(K<<2)>>2];K=K+1|0}while((K|0)!=(Gb|0))}if(!(Lb&(Kb^1))){Xb=0;i=q;return Xb|0}rb=ea(T(ea(pb)));db=ea(ea(1.0)/rb);qb=ea(Hb*db);ub=ea(Ib*db);kb=ea(Jb*db);db=ea(g[v>>2]);xb=ea(g[h>>2]);gb=ea(xb-ea(U*ub));xb=ea(ea(g[_>>2])-ea(U*kb));g[j>>2]=ea(db-ea(U*qb));g[j+4>>2]=gb;g[j+8>>2]=xb;g[j+12>>2]=ea(0.0);xb=ea(g[w>>2]);gb=ea(g[aa>>2]);db=ea(ea(V*ub)+gb);gb=ea(ea(V*kb)+ea(g[ba>>2]));g[k>>2]=ea(ea(V*qb)+xb);g[k+4>>2]=db;g[k+8>>2]=gb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(rb-X);K=m+4|0;c[K+0>>2]=c[O+0>>2];c[K+4>>2]=c[O+4>>2];c[K+8>>2]=c[O+8>>2];g[l>>2]=qb;g[l+4>>2]=ub;g[l+8>>2]=kb;g[l+12>>2]=ea(0.0);Xb=1;i=q;return Xb|0}else Wb=c[F>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Wb,(Wb|0)!=0):0){p=0;do{a[n+p>>0]=c[D+(p<<2)>>2];a[o+p>>0]=c[E+(p<<2)>>2];p=p+1|0}while((p|0)!=(Wb|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Xb=6;i=q;return Xb|0}function f7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=0,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=Im,Rb=Im,Sb=Im,Tb=0,Ub=0,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=0,cc=0,dc=0,ec=0;q=i;i=i+560|0;r=q+288|0;s=q+432|0;t=q+336|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+448|0;y=q+472|0;z=q+352|0;A=q+368|0;B=q+144|0;C=q+208|0;D=q+488|0;E=q+504|0;F=q+520|0;G=q+16|0;H=q+304|0;I=q+112|0;J=q+128|0;K=q;L=q+32|0;M=q+272|0;N=q+320|0;O=q+460|0;P=q+80|0;Q=q+524|0;R=q+536|0;S=b+16|0;U=ea(g[S>>2]);V=ea(g[e+16>>2]);W=ea(g[h>>2]);X=ea(g[b+32>>2]);Y=ea(g[e+32>>2]);Z=ea((X>Y?Y:X)*ea(.100000001));X=ea(U+V);h=v+4|0;_=v+8|0;$=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;aa=w+4|0;ba=w+8|0;ca=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Y=ea(Z*Z);c[F>>2]=0;if(!(a[p>>0]|0)){Z=ea(g[f+48>>2]);da=ea(g[f+52>>2]);fa=ea(g[f+56>>2]);ga=ea(g[f+60>>2]);ha=ea(ea(ea(Z*Z)+ea(da*da))+ea(fa*fa))>ea(0.0);g[u>>2]=Z;g[u+4>>2]=da;g[u+8>>2]=fa;g[u+12>>2]=ga;g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ia=ha?u:t;ga=ea(g[ia>>2]);fa=ea(g[ia+4>>2]);da=ea(g[ia+8>>2]);g[z>>2]=ga;g[z+4>>2]=fa;g[z+8>>2]=da;g[z+12>>2]=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(0.0);ra=ea(3402823469999999843913219.0e14);sa=1;ta=da;ua=fa;va=ga}else{ia=G+4|0;t=G+8|0;u=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ha=H+4|0;wa=H+8|0;xa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;ya=I+4|0;za=I+8|0;Aa=I+12|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;Ba=b+144|0;Ca=b+148|0;Da=b+152|0;Ea=s+4|0;Fa=s+8|0;Ga=s+12|0;Ha=r+4|0;Ia=r+8|0;Ja=r+12|0;Ka=f+48|0;La=f+52|0;Ma=f+56|0;Na=f+16|0;Oa=f+32|0;Pa=f+4|0;Qa=f+20|0;Ra=f+36|0;Sa=f+8|0;Ta=f+24|0;Ua=f+40|0;Va=e+16|0;Wa=J+4|0;Xa=J+8|0;Ya=J+12|0;ga=U;Za=0;while(1){_a=d[n+Za>>0]|0;c[D+(Za<<2)>>2]=_a;$a=d[o+Za>>0]|0;c[E+(Za<<2)>>2]=$a;fa=ea(g[Ba>>2]);da=ea(g[Ca>>2]);Z=ea(fa-ga);fa=ea(da-ga);da=ea(ea(g[Da>>2])-ga);ab=c[540320+(_a<<4)>>2]|0;bb=c[540324+(_a<<4)>>2]|0;cb=c[540328+(_a<<4)>>2]|0;db=ea(-Z);eb=ea(-fa);fb=ea(-da);g[s>>2]=Z;g[Ea>>2]=fa;g[Fa>>2]=da;g[Ga>>2]=ea(0.0);g[r>>2]=db;g[Ha>>2]=eb;g[Ia>>2]=fb;g[Ja>>2]=ea(0.0);fb=ea(g[((ab|0)==0?r:s)>>2]);eb=ea(g[((bb|0)==0?r:s)+4>>2]);db=ea(g[((cb|0)==0?r:s)+8>>2]);da=ea(g[Ka>>2]);fa=ea(g[La>>2]);Z=ea(g[Ma>>2]);gb=ea(fb*ea(g[f>>2]));hb=ea(gb+ea(eb*ea(g[Na>>2])));gb=ea(hb+ea(db*ea(g[Oa>>2])));hb=ea(fb*ea(g[Pa>>2]));ib=ea(hb+ea(eb*ea(g[Qa>>2])));hb=ea(ib+ea(db*ea(g[Ra>>2])));ib=ea(fb*ea(g[Sa>>2]));fb=ea(ib+ea(eb*ea(g[Ta>>2])));jb=ea(da+gb);kb=ea(fa+hb);lb=ea(Z+ea(fb+ea(db*ea(g[Ua>>2]))));EFb(J,e,$a,Va);mb=ea(g[J>>2]);nb=ea(g[Wa>>2]);ob=ea(g[Xa>>2]);db=ea(g[Ya>>2]);pb=ea(jb-mb);qb=ea(kb-nb);rb=ea(lb-ob);sb=c[F>>2]|0;$a=B+(sb<<4)|0;g[H>>2]=jb;g[ha>>2]=kb;g[wa>>2]=lb;g[xa>>2]=ea(0.0);c[$a+0>>2]=c[H+0>>2];c[$a+4>>2]=c[H+4>>2];c[$a+8>>2]=c[H+8>>2];c[$a+12>>2]=c[H+12>>2];$a=C+(sb<<4)|0;g[I>>2]=mb;g[ya>>2]=nb;g[za>>2]=ob;g[Aa>>2]=db;c[$a+0>>2]=c[I+0>>2];c[$a+4>>2]=c[I+4>>2];c[$a+8>>2]=c[I+8>>2];c[$a+12>>2]=c[I+12>>2];c[F>>2]=sb+1;$a=A+(sb<<4)|0;g[G>>2]=pb;g[ia>>2]=qb;g[t>>2]=rb;g[u>>2]=ea(0.0);c[$a+0>>2]=c[G+0>>2];c[$a+4>>2]=c[G+4>>2];c[$a+8>>2]=c[G+8>>2];c[$a+12>>2]=c[G+12>>2];$a=Za+1|0;if($a>>>0>=(d[p>>0]|0)>>>0)break;ga=ea(g[S>>2]);Za=$a}do if(!sb){c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}else if((sb|0)==2)V6a(K,A,A+16|0,G,A,B,C,F,v,w);else if((sb|0)==3)qPa(K,A,B,C,D,E,G,H,I,F,v,w);else if((sb|0)==1){ga=ea(g[A>>2]);db=ea(g[A+4>>2]);fb=ea(g[A+8>>2]);Z=ea(pb-ga);hb=ea(qb-db);fa=ea(rb-fb);gb=ea(ea(ea(Z*Z)+ea(hb*hb))+ea(fa*fa));if(gb==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[K+0>>2]=c[A+0>>2];c[K+4>>2]=c[A+4>>2];c[K+8>>2]=c[A+8>>2];c[K+12>>2]=c[A+12>>2];break}else{da=ea(ea(ea(-ea(db*hb))-ea(ga*Z))-ea(fb*fa));fa=ea(g[B>>2]);fb=ea(g[B+4>>2]);Z=ea(g[B+8>>2]);ga=ea(jb-fa);hb=ea(kb-fb);db=ea(lb-Z);eb=ea(g[C>>2]);ib=ea(g[C+4>>2]);tb=ea(g[C+8>>2]);ub=ea(mb-eb);vb=ea(nb-ib);wb=ea(ob-tb);xb=ea(da/gb);Za=xb>ea(1.0);gb=Za?ea(1.0):xb;Za=gb>ea(0.0);xb=Za?gb:ea(0.0);gb=ea(fa+ea(ga*xb));ga=ea(fb+ea(hb*xb));hb=ea(Z+ea(db*xb));db=ea(eb+ea(ub*xb));ub=ea(ib+ea(vb*xb));vb=ea(tb+ea(wb*xb));g[v>>2]=gb;g[h>>2]=ga;g[_>>2]=hb;g[$>>2]=ea(0.0);g[w>>2]=db;g[aa>>2]=ub;g[ba>>2]=vb;g[ca>>2]=ea(0.0);xb=ea(ga-ub);ub=ea(hb-vb);g[K>>2]=ea(gb-db);g[K+4>>2]=xb;g[K+8>>2]=ub;g[K+12>>2]=ea(0.0);break}}else{c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}while(0);c[z+0>>2]=c[K+0>>2];c[z+4>>2]=c[K+4>>2];c[z+8>>2]=c[K+8>>2];c[z+12>>2]=c[K+12>>2];ob=ea(g[z>>2]);nb=ea(g[z+4>>2]);mb=ea(g[z+8>>2]);lb=ea(ea(ea(ob*ob)+ea(nb*nb))+ea(mb*mb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];kb=ea(g[v>>2]);jb=ea(g[h>>2]);rb=ea(g[_>>2]);qb=ea(g[$>>2]);pb=ea(g[w>>2]);ub=ea(g[aa>>2]);xb=ea(g[ba>>2]);ja=qb;ka=rb;la=jb;ma=kb;na=ea(g[ca>>2]);oa=xb;pa=ub;qa=pb;ra=lb;sa=lb>Y;ta=mb;ua=nb;va=ob}do if(sa){K=z+4|0;G=z+8|0;sb=b+144|0;I=b+148|0;H=b+152|0;Za=f+4|0;u=f+8|0;t=f+16|0;ia=f+20|0;Aa=f+24|0;za=f+32|0;ya=f+36|0;xa=f+40|0;wa=s+4|0;ha=s+8|0;Ya=s+12|0;Xa=r+4|0;Wa=r+8|0;J=r+12|0;Va=f+48|0;Ua=f+52|0;Ta=f+56|0;Sa=L+4|0;Ra=L+8|0;Qa=L+12|0;Pa=e+196|0;Oa=e+200|0;Na=e+204|0;Ma=e+16|0;La=M+4|0;Ka=M+8|0;Ja=N+4|0;Ia=N+8|0;Ha=N+12|0;Ga=b+48|0;Fa=e+48|0;Ea=A+4|0;Da=A+8|0;Ca=B+4|0;Ba=B+8|0;$a=C+4|0;cb=C+8|0;bb=P+4|0;ab=P+8|0;_a=P+12|0;yb=A+16|0;ob=W;nb=va;mb=ua;lb=ta;pb=ra;ub=ma;xb=la;kb=ka;jb=ja;rb=qa;qb=pa;db=oa;gb=na;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];vb=ea(-nb);hb=ea(-mb);ga=ea(-lb);zb=c[F>>2]|0;Ab=B+(zb<<4)|0;wb=ea(g[sb>>2]);tb=ea(g[I>>2]);ib=ea(g[H>>2]);eb=ea(g[S>>2]);Z=ea(wb-eb);wb=ea(tb-eb);tb=ea(ib-eb);eb=ea(g[f>>2]);ib=ea(eb*vb);fb=ea(g[Za>>2]);fa=ea(ib+ea(fb*hb));ib=ea(g[u>>2]);da=ea(fa+ea(ib*ga));fa=ea(g[t>>2]);Bb=ea(fa*vb);Cb=ea(g[ia>>2]);Db=ea(Bb+ea(Cb*hb));Bb=ea(g[Aa>>2]);Eb=ea(Db+ea(Bb*ga));Db=ea(g[za>>2]);Fb=ea(Db*vb);vb=ea(g[ya>>2]);Gb=ea(Fb+ea(vb*hb));hb=ea(g[xa>>2]);Hb=da>ea(0.0);Ib=Eb>ea(0.0);Jb=ea(Gb+ea(hb*ga))>ea(0.0);c[D+(zb<<2)>>2]=Ib<<31>>31<<1&2|Hb&1|Jb<<31>>31<<2&4;ga=ea(-Z);Gb=ea(-wb);Eb=ea(-tb);g[s>>2]=Z;g[wa>>2]=wb;g[ha>>2]=tb;g[Ya>>2]=ea(0.0);g[r>>2]=ga;g[Xa>>2]=Gb;g[Wa>>2]=Eb;g[J>>2]=ea(0.0);Eb=ea(g[(Hb?s:r)>>2]);Gb=ea(g[(Ib?s:r)+4>>2]);ga=ea(g[(Jb?s:r)+8>>2]);tb=ea(g[Va>>2]);wb=ea(g[Ua>>2]);Z=ea(wb+ea(ea(ea(fb*Eb)+ea(Cb*Gb))+ea(vb*ga)));vb=ea(ea(ea(ea(ib*Eb)+ea(Bb*Gb))+ea(hb*ga))+ea(g[Ta>>2]));g[L>>2]=ea(tb+ea(ea(ea(eb*Eb)+ea(fa*Gb))+ea(Db*ga)));g[Sa>>2]=Z;g[Ra>>2]=vb;g[Qa>>2]=ea(0.0);c[Ab+0>>2]=c[L+0>>2];c[Ab+4>>2]=c[L+4>>2];c[Ab+8>>2]=c[L+8>>2];c[Ab+12>>2]=c[L+12>>2];Ab=C+(zb<<4)|0;Jb=E+(zb<<2)|0;if(!(c[Pa>>2]|0)){zb=c[Oa>>2]|0;if((d[Na>>0]|0)>1){vb=ea(g[K>>2]);Z=ea(g[z>>2]);ga=ea(g[zb+4>>2]);Db=ea(vb*ga);ga=ea(Z*ea(g[zb>>2]));Gb=ea(g[G>>2]);Ib=zb;fa=ea(ea(Db+ga)+ea(Gb*ea(g[zb+8>>2])));zb=1;Hb=0;while(1){Kb=c[Oa>>2]|0;ga=ea(g[Kb+(zb*12|0)>>2]);Db=ea(g[Kb+(zb*12|0)+4>>2]);Eb=ea(ea(ea(ga*Z)+ea(Db*vb))+ea(ea(g[Kb+(zb*12|0)+8>>2])*Gb));Lb=Eb>fa;Mb=Lb?zb:Hb;Nb=zb+1|0;if(Nb>>>0<(d[Na>>0]|0)>>>0){Ib=Kb;fa=Lb?Eb:fa;zb=Nb;Hb=Mb}else{Ob=Mb;break}}}else Ob=0}else Ob=DFb(e,z)|0;c[Jb>>2]=Ob;EFb(M,e,Ob,Ma);c[Ab+0>>2]=c[M+0>>2];c[Ab+4>>2]=c[M+4>>2];c[Ab+8>>2]=c[M+8>>2];c[Ab+12>>2]=c[M+12>>2];fa=ea(g[L>>2]);Gb=ea(g[Sa>>2]);vb=ea(g[Ra>>2]);Z=ea(g[M>>2]);Eb=ea(g[La>>2]);Db=ea(g[Ka>>2]);ga=ea(fa-Z);eb=ea(Gb-Eb);tb=ea(vb-Db);g[N>>2]=ga;g[Ja>>2]=eb;g[Ia>>2]=tb;g[Ha>>2]=ea(0.0);Pb=c[F>>2]|0;c[F>>2]=Pb+1;Hb=A+(Pb<<4)|0;c[Hb+0>>2]=c[N+0>>2];c[Hb+4>>2]=c[N+4>>2];c[Hb+8>>2]=c[N+8>>2];c[Hb+12>>2]=c[N+12>>2];hb=ea(g[Ga>>2]);Bb=ea(g[Fa>>2]);ib=hb>Bb?hb:Bb;Bb=ob>ib?ob:ib;ib=ea(X+Bb);hb=ea(pb*ea(ib*ib));Qb=ea(g[z>>2]);Rb=ea(g[K>>2]);Sb=ea(g[G>>2]);ib=ea(ea(ea(Qb*ga)+ea(Rb*eb))+ea(Sb*tb));Hb=ea(ib*ib)>hb;if(ib>ea(0.0)){Tb=Hb;Ub=Hb^1}else{Tb=0;Ub=1}Hb=ea(Y*pb)>=ea(pb-ib);if((Hb|Tb)&(Hb|Ub^1))break;do if((Pb|0)==3)qPa(P,A,B,C,D,E,N,L,M,F,v,w);else if((Pb|0)==2)V6a(P,A,yb,N,A,B,C,F,v,w);else if(!Pb){c[v+0>>2]=c[L+0>>2];c[v+4>>2]=c[L+4>>2];c[v+8>>2]=c[L+8>>2];c[v+12>>2]=c[L+12>>2];c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}else if((Pb|0)==1){ib=ea(g[A>>2]);hb=ea(g[Ea>>2]);Cb=ea(g[Da>>2]);fb=ea(ga-ib);wb=ea(eb-hb);da=ea(tb-Cb);Fb=ea(ea(ea(fb*fb)+ea(wb*wb))+ea(da*da));if(Fb==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[P+0>>2]=c[A+0>>2];c[P+4>>2]=c[A+4>>2];c[P+8>>2]=c[A+8>>2];c[P+12>>2]=c[A+12>>2];break}else{Vb=ea(ea(ea(-ea(hb*wb))-ea(ib*fb))-ea(Cb*da));da=ea(g[B>>2]);Cb=ea(g[Ca>>2]);fb=ea(g[Ba>>2]);ib=ea(fa-da);wb=ea(Gb-Cb);hb=ea(vb-fb);Wb=ea(g[C>>2]);Xb=ea(g[$a>>2]);Yb=ea(g[cb>>2]);Zb=ea(Z-Wb);_b=ea(Eb-Xb);$b=ea(Db-Yb);ac=ea(Vb/Fb);Hb=ac>ea(1.0);Fb=Hb?ea(1.0):ac;Hb=Fb>ea(0.0);ac=Hb?Fb:ea(0.0);Fb=ea(da+ea(ib*ac));ib=ea(Cb+ea(wb*ac));wb=ea(fb+ea(hb*ac));hb=ea(Wb+ea(Zb*ac));Zb=ea(Xb+ea(_b*ac));_b=ea(Yb+ea($b*ac));g[v>>2]=Fb;g[h>>2]=ib;g[_>>2]=wb;g[$>>2]=ea(0.0);g[w>>2]=hb;g[aa>>2]=Zb;g[ba>>2]=_b;g[ca>>2]=ea(0.0);ac=ea(ib-Zb);Zb=ea(wb-_b);g[P>>2]=ea(Fb-hb);g[bb>>2]=ac;g[ab>>2]=Zb;g[_a>>2]=ea(0.0);break}}else{c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}while(0);c[z+0>>2]=c[P+0>>2];c[z+4>>2]=c[P+4>>2];c[z+8>>2]=c[P+8>>2];c[z+12>>2]=c[P+12>>2];Db=ea(g[z>>2]);Eb=ea(g[K>>2]);Z=ea(g[G>>2]);vb=ea(ea(ea(Db*Db)+ea(Eb*Eb))+ea(Z*Z));c[x+0>>2]=c[Q+0>>2];c[x+4>>2]=c[Q+4>>2];c[x+8>>2]=c[Q+8>>2];bc=pb>vb;if(vb>Y^1|bc^1){cc=41;break}Gb=ea(g[v>>2]);fa=ea(g[h>>2]);tb=ea(g[_>>2]);eb=ea(g[$>>2]);ga=ea(g[w>>2]);Zb=ea(g[aa>>2]);ac=ea(g[ba>>2]);ob=Bb;nb=Db;mb=Eb;lb=Z;pb=vb;ub=Gb;xb=fa;kb=tb;jb=eb;rb=ga;qb=Zb;db=ac;gb=ea(g[ca>>2])}if((cc|0)==41){G=c[F>>2]|0;if(bc){dc=G;break}K=G+-1|0;if((n|0)!=0?(a[p>>0]=K,(K|0)!=0):0){G=0;do{a[n+G>>0]=c[D+(G<<2)>>2];a[o+G>>0]=c[E+(G<<2)>>2];G=G+1|0}while((G|0)!=(K|0))}g[v>>2]=ub;g[h>>2]=xb;g[_>>2]=kb;g[$>>2]=jb;g[w>>2]=rb;g[aa>>2]=qb;g[ba>>2]=db;g[ca>>2]=gb;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];lb=ea(ub-rb);mb=ea(xb-qb);nb=ea(kb-db);g[z>>2]=lb;g[z+4>>2]=mb;g[z+8>>2]=nb;g[z+12>>2]=ea(0.0);ob=ea(T(ea(pb)));ac=ea(ea(1.0)/ob);Zb=ea(lb*ac);lb=ea(mb*ac);mb=ea(nb*ac);ac=ea(xb-ea(U*lb));nb=ea(kb-ea(U*mb));g[j>>2]=ea(ub-ea(U*Zb));g[j+4>>2]=ac;g[j+8>>2]=nb;g[j+12>>2]=ea(0.0);nb=ea(ea(V*lb)+qb);ac=ea(ea(V*mb)+db);g[k>>2]=ea(ea(V*Zb)+rb);g[k+4>>2]=nb;g[k+8>>2]=ac;g[k+12>>2]=ea(0.0);g[m>>2]=ea(ob-X);K=m+4|0;c[K+0>>2]=c[R+0>>2];c[K+4>>2]=c[R+4>>2];c[K+8>>2]=c[R+8>>2];g[l>>2]=Zb;g[l+4>>2]=lb;g[l+8>>2]=mb;g[l+12>>2]=ea(0.0);ec=3;i=q;return ec|0}if((n|0)!=0?(a[p>>0]=Pb,(Pb|0)!=0):0){K=0;do{a[n+K>>0]=c[D+(K<<2)>>2];a[o+K>>0]=c[E+(K<<2)>>2];K=K+1|0}while((K|0)!=(Pb|0))}if(!(Ub&(Tb^1))){ec=0;i=q;return ec|0}rb=ea(T(ea(pb)));db=ea(ea(1.0)/rb);qb=ea(Qb*db);ub=ea(Rb*db);kb=ea(Sb*db);db=ea(g[v>>2]);xb=ea(g[h>>2]);gb=ea(xb-ea(U*ub));xb=ea(ea(g[_>>2])-ea(U*kb));g[j>>2]=ea(db-ea(U*qb));g[j+4>>2]=gb;g[j+8>>2]=xb;g[j+12>>2]=ea(0.0);xb=ea(g[w>>2]);gb=ea(g[aa>>2]);db=ea(ea(V*ub)+gb);gb=ea(ea(V*kb)+ea(g[ba>>2]));g[k>>2]=ea(ea(V*qb)+xb);g[k+4>>2]=db;g[k+8>>2]=gb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(rb-X);K=m+4|0;c[K+0>>2]=c[O+0>>2];c[K+4>>2]=c[O+4>>2];c[K+8>>2]=c[O+8>>2];g[l>>2]=qb;g[l+4>>2]=ub;g[l+8>>2]=kb;g[l+12>>2]=ea(0.0);ec=1;i=q;return ec|0}else dc=c[F>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=dc,(dc|0)!=0):0){p=0;do{a[n+p>>0]=c[D+(p<<2)>>2];a[o+p>>0]=c[E+(p<<2)>>2];p=p+1|0}while((p|0)!=(dc|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];ec=6;i=q;return ec|0}function g7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=0,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=0,qb=0,rb=0,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=0,yb=0,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=0,Nb=0,Ob=0,Pb=0;q=i;i=i+576|0;r=q+304|0;s=q+448|0;t=q+16|0;u=q+48|0;v=q+128|0;w=q+64|0;x=q+464|0;y=q+488|0;z=q+352|0;A=q+384|0;B=q+144|0;C=q+208|0;D=q+504|0;E=q+520|0;F=q+536|0;G=q;H=q+96|0;I=q+112|0;J=q+336|0;K=q+368|0;L=q+32|0;M=q+288|0;N=q+272|0;O=q+320|0;P=q+476|0;Q=q+80|0;R=q+540|0;S=q+552|0;U=ea(g[b+16>>2]);V=ea(g[e+16>>2]);W=ea(g[h>>2]);X=ea(g[b+32>>2]);Y=ea(g[e+32>>2]);Z=ea((X>Y?Y:X)*ea(.100000001));X=ea(U+V);h=v+4|0;_=v+8|0;$=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;aa=w+4|0;ba=w+8|0;ca=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Y=ea(Z*Z);c[F>>2]=0;if(!(a[p>>0]|0)){Z=ea(g[f+48>>2]);da=ea(g[f+52>>2]);fa=ea(g[f+56>>2]);ga=ea(g[f+60>>2]);ha=ea(ea(ea(Z*Z)+ea(da*da))+ea(fa*fa))>ea(0.0);g[s>>2]=Z;g[s+4>>2]=da;g[s+8>>2]=fa;g[s+12>>2]=ga;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ia=ha?s:r;ga=ea(g[ia>>2]);fa=ea(g[ia+4>>2]);da=ea(g[ia+8>>2]);g[z>>2]=ga;g[z+4>>2]=fa;g[z+8>>2]=da;g[z+12>>2]=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(0.0);ra=ea(3402823469999999843913219.0e14);sa=1;ta=da;ua=fa;va=ga}else{ia=G+4|0;r=G+8|0;s=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ha=H+4|0;wa=H+8|0;xa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;ya=I+4|0;za=I+8|0;Aa=I+12|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;Ba=b+16|0;Ca=f+48|0;Da=f+52|0;Ea=f+56|0;Fa=J+4|0;Ga=J+8|0;Ha=f+16|0;Ia=f+32|0;Ja=f+4|0;Ka=f+20|0;La=f+36|0;Ma=f+8|0;Na=f+24|0;Oa=f+40|0;Pa=e+16|0;Qa=K+4|0;Ra=K+8|0;Sa=K+12|0;Ta=0;do{Ua=d[n+Ta>>0]|0;c[D+(Ta<<2)>>2]=Ua;Va=d[o+Ta>>0]|0;c[E+(Ta<<2)>>2]=Va;BFb(J,b,Ua,Ba);ga=ea(g[Ca>>2]);fa=ea(g[Da>>2]);da=ea(g[Ea>>2]);Z=ea(g[J>>2]);Wa=ea(g[Fa>>2]);Xa=ea(g[Ga>>2]);Ya=ea(Z*ea(g[f>>2]));Za=ea(Ya+ea(Wa*ea(g[Ha>>2])));Ya=ea(Za+ea(Xa*ea(g[Ia>>2])));Za=ea(Z*ea(g[Ja>>2]));_a=ea(Za+ea(Wa*ea(g[Ka>>2])));Za=ea(_a+ea(Xa*ea(g[La>>2])));_a=ea(Z*ea(g[Ma>>2]));Z=ea(_a+ea(Wa*ea(g[Na>>2])));$a=ea(ga+Ya);ab=ea(fa+Za);bb=ea(da+ea(Z+ea(Xa*ea(g[Oa>>2]))));BFb(K,e,Va,Pa);cb=ea(g[K>>2]);db=ea(g[Qa>>2]);eb=ea(g[Ra>>2]);Xa=ea(g[Sa>>2]);fb=ea($a-cb);gb=ea(ab-db);hb=ea(bb-eb);ib=c[F>>2]|0;Va=B+(ib<<4)|0;g[H>>2]=$a;g[ha>>2]=ab;g[wa>>2]=bb;g[xa>>2]=ea(0.0);c[Va+0>>2]=c[H+0>>2];c[Va+4>>2]=c[H+4>>2];c[Va+8>>2]=c[H+8>>2];c[Va+12>>2]=c[H+12>>2];Va=C+(ib<<4)|0;g[I>>2]=cb;g[ya>>2]=db;g[za>>2]=eb;g[Aa>>2]=Xa;c[Va+0>>2]=c[I+0>>2];c[Va+4>>2]=c[I+4>>2];c[Va+8>>2]=c[I+8>>2];c[Va+12>>2]=c[I+12>>2];c[F>>2]=ib+1;Va=A+(ib<<4)|0;g[G>>2]=fb;g[ia>>2]=gb;g[r>>2]=hb;g[s>>2]=ea(0.0);c[Va+0>>2]=c[G+0>>2];c[Va+4>>2]=c[G+4>>2];c[Va+8>>2]=c[G+8>>2];c[Va+12>>2]=c[G+12>>2];Ta=Ta+1|0}while(Ta>>>0<(d[p>>0]|0)>>>0);do if(!ib){c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[L+0>>2]=c[G+0>>2];c[L+4>>2]=c[G+4>>2];c[L+8>>2]=c[G+8>>2];c[L+12>>2]=c[G+12>>2]}else if((ib|0)==3)qPa(L,A,B,C,D,E,G,H,I,F,v,w);else if((ib|0)==2)V6a(L,A,A+16|0,G,A,B,C,F,v,w);else if((ib|0)==1){Xa=ea(g[A>>2]);Z=ea(g[A+4>>2]);da=ea(g[A+8>>2]);Za=ea(fb-Xa);fa=ea(gb-Z);Ya=ea(hb-da);ga=ea(ea(ea(Za*Za)+ea(fa*fa))+ea(Ya*Ya));if(ga==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[L+0>>2]=c[A+0>>2];c[L+4>>2]=c[A+4>>2];c[L+8>>2]=c[A+8>>2];c[L+12>>2]=c[A+12>>2];break}else{Wa=ea(ea(ea(-ea(Z*fa))-ea(Xa*Za))-ea(da*Ya));Ya=ea(g[B>>2]);da=ea(g[B+4>>2]);Za=ea(g[B+8>>2]);Xa=ea($a-Ya);fa=ea(ab-da);Z=ea(bb-Za);_a=ea(g[C>>2]);jb=ea(g[C+4>>2]);kb=ea(g[C+8>>2]);lb=ea(cb-_a);mb=ea(db-jb);nb=ea(eb-kb);ob=ea(Wa/ga);Ta=ob>ea(1.0);ga=Ta?ea(1.0):ob;Ta=ga>ea(0.0);ob=Ta?ga:ea(0.0);ga=ea(Ya+ea(Xa*ob));Xa=ea(da+ea(fa*ob));fa=ea(Za+ea(Z*ob));Z=ea(_a+ea(lb*ob));lb=ea(jb+ea(mb*ob));mb=ea(kb+ea(nb*ob));g[v>>2]=ga;g[h>>2]=Xa;g[_>>2]=fa;g[$>>2]=ea(0.0);g[w>>2]=Z;g[aa>>2]=lb;g[ba>>2]=mb;g[ca>>2]=ea(0.0);ob=ea(Xa-lb);lb=ea(fa-mb);g[L>>2]=ea(ga-Z);g[L+4>>2]=ob;g[L+8>>2]=lb;g[L+12>>2]=ea(0.0);break}}else{c[L+0>>2]=c[G+0>>2];c[L+4>>2]=c[G+4>>2];c[L+8>>2]=c[G+8>>2];c[L+12>>2]=c[G+12>>2]}while(0);c[z+0>>2]=c[L+0>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];c[z+12>>2]=c[L+12>>2];eb=ea(g[z>>2]);db=ea(g[z+4>>2]);cb=ea(g[z+8>>2]);bb=ea(ea(ea(eb*eb)+ea(db*db))+ea(cb*cb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];ab=ea(g[v>>2]);$a=ea(g[h>>2]);hb=ea(g[_>>2]);gb=ea(g[$>>2]);fb=ea(g[w>>2]);lb=ea(g[aa>>2]);ob=ea(g[ba>>2]);ja=gb;ka=hb;la=$a;ma=ab;na=ea(g[ca>>2]);oa=ob;pa=lb;qa=fb;ra=bb;sa=bb>Y;ta=cb;ua=db;va=eb}do if(sa){L=z+4|0;G=z+8|0;ib=f+4|0;I=f+8|0;H=f+16|0;Ta=f+20|0;s=f+24|0;r=f+32|0;ia=f+36|0;Aa=f+40|0;za=t+4|0;ya=t+8|0;xa=t+12|0;wa=f+48|0;ha=f+52|0;Sa=f+56|0;Ra=u+4|0;Qa=u+8|0;K=M+4|0;Pa=M+8|0;Oa=M+12|0;Na=N+4|0;Ma=N+8|0;La=O+4|0;Ka=O+8|0;Ja=O+12|0;Ia=b+48|0;Ha=e+48|0;Ga=A+4|0;Fa=A+8|0;J=B+4|0;Ea=B+8|0;Da=C+4|0;Ca=C+8|0;Ba=Q+4|0;Va=Q+8|0;Ua=Q+12|0;pb=A+16|0;eb=W;db=va;cb=ua;bb=ta;fb=ra;lb=ma;ob=la;ab=ka;$a=ja;hb=qa;gb=pa;Z=oa;ga=na;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];mb=ea(-db);fa=ea(-cb);Xa=ea(-bb);qb=c[F>>2]|0;rb=B+(qb<<4)|0;nb=ea(ea(g[f>>2])*mb);kb=ea(nb+ea(ea(g[ib>>2])*fa));nb=ea(kb+ea(ea(g[I>>2])*Xa));kb=ea(ea(g[H>>2])*mb);jb=ea(kb+ea(ea(g[Ta>>2])*fa));kb=ea(jb+ea(ea(g[s>>2])*Xa));jb=ea(ea(g[r>>2])*mb);mb=ea(jb+ea(ea(g[ia>>2])*fa));fa=ea(mb+ea(ea(g[Aa>>2])*Xa));g[t>>2]=nb;g[za>>2]=kb;g[ya>>2]=fa;g[xa>>2]=ea(0.0);CFb(u,b,t,rb,D+(qb<<2)|0);fa=ea(g[wa>>2]);kb=ea(g[ha>>2]);nb=ea(g[Sa>>2]);Xa=ea(g[u>>2]);mb=ea(g[Ra>>2]);jb=ea(g[Qa>>2]);_a=ea(Xa*ea(g[f>>2]));Za=ea(_a+ea(mb*ea(g[H>>2])));_a=ea(Za+ea(jb*ea(g[r>>2])));Za=ea(Xa*ea(g[ib>>2]));da=ea(Za+ea(mb*ea(g[Ta>>2])));Za=ea(da+ea(jb*ea(g[ia>>2])));da=ea(Xa*ea(g[I>>2]));Xa=ea(da+ea(mb*ea(g[s>>2])));mb=ea(kb+Za);Za=ea(nb+ea(Xa+ea(jb*ea(g[Aa>>2]))));g[M>>2]=ea(fa+_a);g[K>>2]=mb;g[Pa>>2]=Za;g[Oa>>2]=ea(0.0);c[rb+0>>2]=c[M+0>>2];c[rb+4>>2]=c[M+4>>2];c[rb+8>>2]=c[M+8>>2];c[rb+12>>2]=c[M+12>>2];rb=c[F>>2]|0;CFb(N,e,z,C+(rb<<4)|0,E+(rb<<2)|0);Za=ea(g[M>>2]);mb=ea(g[K>>2]);_a=ea(g[Pa>>2]);fa=ea(g[N>>2]);jb=ea(g[Na>>2]);Xa=ea(g[Ma>>2]);nb=ea(Za-fa);kb=ea(mb-jb);da=ea(_a-Xa);g[O>>2]=nb;g[La>>2]=kb;g[Ka>>2]=da;g[Ja>>2]=ea(0.0);sb=c[F>>2]|0;c[F>>2]=sb+1;rb=A+(sb<<4)|0;c[rb+0>>2]=c[O+0>>2];c[rb+4>>2]=c[O+4>>2];c[rb+8>>2]=c[O+8>>2];c[rb+12>>2]=c[O+12>>2];Ya=ea(g[Ia>>2]);Wa=ea(g[Ha>>2]);tb=Ya>Wa?Ya:Wa;Wa=eb>tb?eb:tb;tb=ea(X+Wa);Ya=ea(fb*ea(tb*tb));ub=ea(g[z>>2]);vb=ea(g[L>>2]);wb=ea(g[G>>2]);tb=ea(ea(ea(ub*nb)+ea(vb*kb))+ea(wb*da));rb=ea(tb*tb)>Ya;if(tb>ea(0.0)){xb=rb;yb=rb^1}else{xb=0;yb=1}rb=ea(Y*fb)>=ea(fb-tb);if((rb|xb)&(rb|yb^1))break;do if(!sb){c[v+0>>2]=c[M+0>>2];c[v+4>>2]=c[M+4>>2];c[v+8>>2]=c[M+8>>2];c[v+12>>2]=c[M+12>>2];c[w+0>>2]=c[N+0>>2];c[w+4>>2]=c[N+4>>2];c[w+8>>2]=c[N+8>>2];c[w+12>>2]=c[N+12>>2];c[Q+0>>2]=c[O+0>>2];c[Q+4>>2]=c[O+4>>2];c[Q+8>>2]=c[O+8>>2];c[Q+12>>2]=c[O+12>>2]}else if((sb|0)==1){tb=ea(g[A>>2]);Ya=ea(g[Ga>>2]);zb=ea(g[Fa>>2]);Ab=ea(nb-tb);Bb=ea(kb-Ya);Cb=ea(da-zb);Db=ea(ea(ea(Ab*Ab)+ea(Bb*Bb))+ea(Cb*Cb));if(Db==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[Q+0>>2]=c[A+0>>2];c[Q+4>>2]=c[A+4>>2];c[Q+8>>2]=c[A+8>>2];c[Q+12>>2]=c[A+12>>2];break}else{Eb=ea(ea(ea(-ea(Ya*Bb))-ea(tb*Ab))-ea(zb*Cb));Cb=ea(g[B>>2]);zb=ea(g[J>>2]);Ab=ea(g[Ea>>2]);tb=ea(Za-Cb);Bb=ea(mb-zb);Ya=ea(_a-Ab);Fb=ea(g[C>>2]);Gb=ea(g[Da>>2]);Hb=ea(g[Ca>>2]);Ib=ea(fa-Fb);Jb=ea(jb-Gb);Kb=ea(Xa-Hb);Lb=ea(Eb/Db);rb=Lb>ea(1.0);Db=rb?ea(1.0):Lb;rb=Db>ea(0.0);Lb=rb?Db:ea(0.0);Db=ea(Cb+ea(tb*Lb));tb=ea(zb+ea(Bb*Lb));Bb=ea(Ab+ea(Ya*Lb));Ya=ea(Fb+ea(Ib*Lb));Ib=ea(Gb+ea(Jb*Lb));Jb=ea(Hb+ea(Kb*Lb));g[v>>2]=Db;g[h>>2]=tb;g[_>>2]=Bb;g[$>>2]=ea(0.0);g[w>>2]=Ya;g[aa>>2]=Ib;g[ba>>2]=Jb;g[ca>>2]=ea(0.0);Lb=ea(tb-Ib);Ib=ea(Bb-Jb);g[Q>>2]=ea(Db-Ya);g[Ba>>2]=Lb;g[Va>>2]=Ib;g[Ua>>2]=ea(0.0);break}}else if((sb|0)==3)qPa(Q,A,B,C,D,E,O,M,N,F,v,w);else if((sb|0)==2)V6a(Q,A,pb,O,A,B,C,F,v,w);else{c[Q+0>>2]=c[O+0>>2];c[Q+4>>2]=c[O+4>>2];c[Q+8>>2]=c[O+8>>2];c[Q+12>>2]=c[O+12>>2]}while(0);c[z+0>>2]=c[Q+0>>2];c[z+4>>2]=c[Q+4>>2];c[z+8>>2]=c[Q+8>>2];c[z+12>>2]=c[Q+12>>2];Xa=ea(g[z>>2]);jb=ea(g[L>>2]);fa=ea(g[G>>2]);_a=ea(ea(ea(Xa*Xa)+ea(jb*jb))+ea(fa*fa));c[x+0>>2]=c[R+0>>2];c[x+4>>2]=c[R+4>>2];c[x+8>>2]=c[R+8>>2];Mb=fb>_a;if(_a>Y^1|Mb^1){Nb=35;break}mb=ea(g[v>>2]);Za=ea(g[h>>2]);da=ea(g[_>>2]);kb=ea(g[$>>2]);nb=ea(g[w>>2]);Ib=ea(g[aa>>2]);Lb=ea(g[ba>>2]);eb=Wa;db=Xa;cb=jb;bb=fa;fb=_a;lb=mb;ob=Za;ab=da;$a=kb;hb=nb;gb=Ib;Z=Lb;ga=ea(g[ca>>2])}if((Nb|0)==35){G=c[F>>2]|0;if(Mb){Ob=G;break}L=G+-1|0;if((n|0)!=0?(a[p>>0]=L,(L|0)!=0):0){G=0;do{a[n+G>>0]=c[D+(G<<2)>>2];a[o+G>>0]=c[E+(G<<2)>>2];G=G+1|0}while((G|0)!=(L|0))}g[v>>2]=lb;g[h>>2]=ob;g[_>>2]=ab;g[$>>2]=$a;g[w>>2]=hb;g[aa>>2]=gb;g[ba>>2]=Z;g[ca>>2]=ga;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];bb=ea(lb-hb);cb=ea(ob-gb);db=ea(ab-Z);g[z>>2]=bb;g[z+4>>2]=cb;g[z+8>>2]=db;g[z+12>>2]=ea(0.0);eb=ea(T(ea(fb)));Lb=ea(ea(1.0)/eb);Ib=ea(bb*Lb);bb=ea(cb*Lb);cb=ea(db*Lb);Lb=ea(ob-ea(U*bb));db=ea(ab-ea(U*cb));g[j>>2]=ea(lb-ea(U*Ib));g[j+4>>2]=Lb;g[j+8>>2]=db;g[j+12>>2]=ea(0.0);db=ea(ea(V*bb)+gb);Lb=ea(ea(V*cb)+Z);g[k>>2]=ea(ea(V*Ib)+hb);g[k+4>>2]=db;g[k+8>>2]=Lb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(eb-X);L=m+4|0;c[L+0>>2]=c[S+0>>2];c[L+4>>2]=c[S+4>>2];c[L+8>>2]=c[S+8>>2];g[l>>2]=Ib;g[l+4>>2]=bb;g[l+8>>2]=cb;g[l+12>>2]=ea(0.0);Pb=3;i=q;return Pb|0}if((n|0)!=0?(a[p>>0]=sb,(sb|0)!=0):0){L=0;do{a[n+L>>0]=c[D+(L<<2)>>2];a[o+L>>0]=c[E+(L<<2)>>2];L=L+1|0}while((L|0)!=(sb|0))}if(!(yb&(xb^1))){Pb=0;i=q;return Pb|0}hb=ea(T(ea(fb)));Z=ea(ea(1.0)/hb);gb=ea(ub*Z);lb=ea(vb*Z);ab=ea(wb*Z);Z=ea(g[v>>2]);ob=ea(g[h>>2]);ga=ea(ob-ea(U*lb));ob=ea(ea(g[_>>2])-ea(U*ab));g[j>>2]=ea(Z-ea(U*gb));g[j+4>>2]=ga;g[j+8>>2]=ob;g[j+12>>2]=ea(0.0);ob=ea(g[w>>2]);ga=ea(g[aa>>2]);Z=ea(ea(V*lb)+ga);ga=ea(ea(V*ab)+ea(g[ba>>2]));g[k>>2]=ea(ea(V*gb)+ob);g[k+4>>2]=Z;g[k+8>>2]=ga;g[k+12>>2]=ea(0.0);g[m>>2]=ea(hb-X);L=m+4|0;c[L+0>>2]=c[P+0>>2];c[L+4>>2]=c[P+4>>2];c[L+8>>2]=c[P+8>>2];g[l>>2]=gb;g[l+4>>2]=lb;g[l+8>>2]=ab;g[l+12>>2]=ea(0.0);Pb=1;i=q;return Pb|0}else Ob=c[F>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Ob,(Ob|0)!=0):0){p=0;do{a[n+p>>0]=c[D+(p<<2)>>2];a[o+p>>0]=c[E+(p<<2)>>2];p=p+1|0}while((p|0)!=(Ob|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Pb=6;i=q;return Pb|0}function h7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=0,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=Im,Fb=Im,Gb=Im,Hb=0,Ib=Im,Jb=0,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=0,Zb=0,_b=0,$b=0;q=i;i=i+576|0;r=q+304|0;s=q+448|0;t=q+16|0;u=q+48|0;v=q+128|0;w=q+64|0;x=q+464|0;y=q+488|0;z=q+352|0;A=q+384|0;B=q+144|0;C=q+208|0;D=q+504|0;E=q+520|0;F=q+536|0;G=q;H=q+96|0;I=q+112|0;J=q+336|0;K=q+368|0;L=q+32|0;M=q+288|0;N=q+272|0;O=q+320|0;P=q+476|0;Q=q+80|0;R=q+540|0;S=q+552|0;U=ea(g[b+16>>2]);V=ea(g[e+16>>2]);W=ea(g[h>>2]);X=ea(g[b+32>>2]);Y=ea(g[e+32>>2]);Z=ea((X>Y?Y:X)*ea(.100000001));X=ea(U+V);h=v+4|0;_=v+8|0;$=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;aa=w+4|0;ba=w+8|0;ca=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Y=ea(Z*Z);c[F>>2]=0;if(!(a[p>>0]|0)){Z=ea(g[f+48>>2]);da=ea(g[f+52>>2]);fa=ea(g[f+56>>2]);ga=ea(g[f+60>>2]);ha=ea(ea(ea(Z*Z)+ea(da*da))+ea(fa*fa))>ea(0.0);g[s>>2]=Z;g[s+4>>2]=da;g[s+8>>2]=fa;g[s+12>>2]=ga;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ia=ha?s:r;ga=ea(g[ia>>2]);fa=ea(g[ia+4>>2]);da=ea(g[ia+8>>2]);g[z>>2]=ga;g[z+4>>2]=fa;g[z+8>>2]=da;g[z+12>>2]=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(0.0);ra=ea(3402823469999999843913219.0e14);sa=1;ta=da;ua=fa;va=ga}else{ia=G+4|0;r=G+8|0;s=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ha=H+4|0;wa=H+8|0;xa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;ya=I+4|0;za=I+8|0;Aa=I+12|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;Ba=b+16|0;Ca=f+48|0;Da=f+52|0;Ea=f+56|0;Fa=J+4|0;Ga=J+8|0;Ha=f+16|0;Ia=f+32|0;Ja=f+4|0;Ka=f+20|0;La=f+36|0;Ma=f+8|0;Na=f+24|0;Oa=f+40|0;Pa=e+16|0;Qa=K+4|0;Ra=K+8|0;Sa=K+12|0;Ta=0;do{Ua=d[n+Ta>>0]|0;c[D+(Ta<<2)>>2]=Ua;Va=d[o+Ta>>0]|0;c[E+(Ta<<2)>>2]=Va;BFb(J,b,Ua,Ba);ga=ea(g[Ca>>2]);fa=ea(g[Da>>2]);da=ea(g[Ea>>2]);Z=ea(g[J>>2]);Wa=ea(g[Fa>>2]);Xa=ea(g[Ga>>2]);Ya=ea(Z*ea(g[f>>2]));Za=ea(Ya+ea(Wa*ea(g[Ha>>2])));Ya=ea(Za+ea(Xa*ea(g[Ia>>2])));Za=ea(Z*ea(g[Ja>>2]));_a=ea(Za+ea(Wa*ea(g[Ka>>2])));Za=ea(_a+ea(Xa*ea(g[La>>2])));_a=ea(Z*ea(g[Ma>>2]));Z=ea(_a+ea(Wa*ea(g[Na>>2])));$a=ea(ga+Ya);ab=ea(fa+Za);bb=ea(da+ea(Z+ea(Xa*ea(g[Oa>>2]))));EFb(K,e,Va,Pa);cb=ea(g[K>>2]);db=ea(g[Qa>>2]);eb=ea(g[Ra>>2]);Xa=ea(g[Sa>>2]);fb=ea($a-cb);gb=ea(ab-db);hb=ea(bb-eb);ib=c[F>>2]|0;Va=B+(ib<<4)|0;g[H>>2]=$a;g[ha>>2]=ab;g[wa>>2]=bb;g[xa>>2]=ea(0.0);c[Va+0>>2]=c[H+0>>2];c[Va+4>>2]=c[H+4>>2];c[Va+8>>2]=c[H+8>>2];c[Va+12>>2]=c[H+12>>2];Va=C+(ib<<4)|0;g[I>>2]=cb;g[ya>>2]=db;g[za>>2]=eb;g[Aa>>2]=Xa;c[Va+0>>2]=c[I+0>>2];c[Va+4>>2]=c[I+4>>2];c[Va+8>>2]=c[I+8>>2];c[Va+12>>2]=c[I+12>>2];c[F>>2]=ib+1;Va=A+(ib<<4)|0;g[G>>2]=fb;g[ia>>2]=gb;g[r>>2]=hb;g[s>>2]=ea(0.0);c[Va+0>>2]=c[G+0>>2];c[Va+4>>2]=c[G+4>>2];c[Va+8>>2]=c[G+8>>2];c[Va+12>>2]=c[G+12>>2];Ta=Ta+1|0}while(Ta>>>0<(d[p>>0]|0)>>>0);do if(!ib){c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[L+0>>2]=c[G+0>>2];c[L+4>>2]=c[G+4>>2];c[L+8>>2]=c[G+8>>2];c[L+12>>2]=c[G+12>>2]}else if((ib|0)==1){Xa=ea(g[A>>2]);Z=ea(g[A+4>>2]);da=ea(g[A+8>>2]);Za=ea(fb-Xa);fa=ea(gb-Z);Ya=ea(hb-da);ga=ea(ea(ea(Za*Za)+ea(fa*fa))+ea(Ya*Ya));if(ga==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[L+0>>2]=c[A+0>>2];c[L+4>>2]=c[A+4>>2];c[L+8>>2]=c[A+8>>2];c[L+12>>2]=c[A+12>>2];break}else{Wa=ea(ea(ea(-ea(Z*fa))-ea(Xa*Za))-ea(da*Ya));Ya=ea(g[B>>2]);da=ea(g[B+4>>2]);Za=ea(g[B+8>>2]);Xa=ea($a-Ya);fa=ea(ab-da);Z=ea(bb-Za);_a=ea(g[C>>2]);jb=ea(g[C+4>>2]);kb=ea(g[C+8>>2]);lb=ea(cb-_a);mb=ea(db-jb);nb=ea(eb-kb);ob=ea(Wa/ga);Ta=ob>ea(1.0);ga=Ta?ea(1.0):ob;Ta=ga>ea(0.0);ob=Ta?ga:ea(0.0);ga=ea(Ya+ea(Xa*ob));Xa=ea(da+ea(fa*ob));fa=ea(Za+ea(Z*ob));Z=ea(_a+ea(lb*ob));lb=ea(jb+ea(mb*ob));mb=ea(kb+ea(nb*ob));g[v>>2]=ga;g[h>>2]=Xa;g[_>>2]=fa;g[$>>2]=ea(0.0);g[w>>2]=Z;g[aa>>2]=lb;g[ba>>2]=mb;g[ca>>2]=ea(0.0);ob=ea(Xa-lb);lb=ea(fa-mb);g[L>>2]=ea(ga-Z);g[L+4>>2]=ob;g[L+8>>2]=lb;g[L+12>>2]=ea(0.0);break}}else if((ib|0)==2)V6a(L,A,A+16|0,G,A,B,C,F,v,w);else if((ib|0)==3)qPa(L,A,B,C,D,E,G,H,I,F,v,w);else{c[L+0>>2]=c[G+0>>2];c[L+4>>2]=c[G+4>>2];c[L+8>>2]=c[G+8>>2];c[L+12>>2]=c[G+12>>2]}while(0);c[z+0>>2]=c[L+0>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];c[z+12>>2]=c[L+12>>2];eb=ea(g[z>>2]);db=ea(g[z+4>>2]);cb=ea(g[z+8>>2]);bb=ea(ea(ea(eb*eb)+ea(db*db))+ea(cb*cb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];ab=ea(g[v>>2]);$a=ea(g[h>>2]);hb=ea(g[_>>2]);gb=ea(g[$>>2]);fb=ea(g[w>>2]);lb=ea(g[aa>>2]);ob=ea(g[ba>>2]);ja=gb;ka=hb;la=$a;ma=ab;na=ea(g[ca>>2]);oa=ob;pa=lb;qa=fb;ra=bb;sa=bb>Y;ta=cb;ua=db;va=eb}do if(sa){L=z+4|0;G=z+8|0;I=f+4|0;H=f+8|0;ib=f+16|0;Ta=f+20|0;s=f+24|0;r=f+32|0;ia=f+36|0;Aa=f+40|0;za=t+4|0;ya=t+8|0;xa=t+12|0;wa=f+48|0;ha=f+52|0;Sa=f+56|0;Ra=u+4|0;Qa=u+8|0;K=M+4|0;Pa=M+8|0;Oa=M+12|0;Na=e+196|0;Ma=e+200|0;La=e+204|0;Ka=e+16|0;Ja=N+4|0;Ia=N+8|0;Ha=O+4|0;Ga=O+8|0;Fa=O+12|0;J=b+48|0;Ea=e+48|0;Da=A+4|0;Ca=A+8|0;Ba=B+4|0;Va=B+8|0;Ua=C+4|0;pb=C+8|0;qb=Q+4|0;rb=Q+8|0;sb=Q+12|0;tb=A+16|0;eb=W;db=va;cb=ua;bb=ta;fb=ra;lb=ma;ob=la;ab=ka;$a=ja;hb=qa;gb=pa;Z=oa;ga=na;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];mb=ea(-db);fa=ea(-cb);Xa=ea(-bb);ub=c[F>>2]|0;vb=B+(ub<<4)|0;nb=ea(ea(g[f>>2])*mb);kb=ea(nb+ea(ea(g[I>>2])*fa));nb=ea(kb+ea(ea(g[H>>2])*Xa));kb=ea(ea(g[ib>>2])*mb);jb=ea(kb+ea(ea(g[Ta>>2])*fa));kb=ea(jb+ea(ea(g[s>>2])*Xa));jb=ea(ea(g[r>>2])*mb);mb=ea(jb+ea(ea(g[ia>>2])*fa));fa=ea(mb+ea(ea(g[Aa>>2])*Xa));g[t>>2]=nb;g[za>>2]=kb;g[ya>>2]=fa;g[xa>>2]=ea(0.0);CFb(u,b,t,vb,D+(ub<<2)|0);fa=ea(g[wa>>2]);kb=ea(g[ha>>2]);nb=ea(g[Sa>>2]);Xa=ea(g[u>>2]);mb=ea(g[Ra>>2]);jb=ea(g[Qa>>2]);_a=ea(Xa*ea(g[f>>2]));Za=ea(_a+ea(mb*ea(g[ib>>2])));_a=ea(Za+ea(jb*ea(g[r>>2])));Za=ea(Xa*ea(g[I>>2]));da=ea(Za+ea(mb*ea(g[Ta>>2])));Za=ea(da+ea(jb*ea(g[ia>>2])));da=ea(Xa*ea(g[H>>2]));Xa=ea(da+ea(mb*ea(g[s>>2])));mb=ea(kb+Za);Za=ea(nb+ea(Xa+ea(jb*ea(g[Aa>>2]))));g[M>>2]=ea(fa+_a);g[K>>2]=mb;g[Pa>>2]=Za;g[Oa>>2]=ea(0.0);c[vb+0>>2]=c[M+0>>2];c[vb+4>>2]=c[M+4>>2];c[vb+8>>2]=c[M+8>>2];c[vb+12>>2]=c[M+12>>2];vb=c[F>>2]|0;ub=C+(vb<<4)|0;wb=E+(vb<<2)|0;if(!(c[Na>>2]|0)){vb=c[Ma>>2]|0;if((d[La>>0]|0)>1){Za=ea(g[vb+4>>2]);mb=ea(cb*Za);Za=ea(db*ea(g[vb>>2]));xb=vb;_a=ea(ea(mb+Za)+ea(bb*ea(g[vb+8>>2])));vb=1;yb=0;while(1){zb=c[Ma>>2]|0;Za=ea(g[zb+(vb*12|0)>>2]);mb=ea(g[zb+(vb*12|0)+4>>2]);fa=ea(ea(ea(Za*db)+ea(mb*cb))+ea(ea(g[zb+(vb*12|0)+8>>2])*bb));Ab=fa>_a;Bb=Ab?vb:yb;Cb=vb+1|0;if(Cb>>>0<(d[La>>0]|0)>>>0){xb=zb;_a=Ab?fa:_a;vb=Cb;yb=Bb}else{Db=Bb;Eb=db;Fb=cb;Gb=bb;break}}}else{Db=0;Eb=db;Fb=cb;Gb=bb}}else{yb=DFb(e,z)|0;_a=ea(g[z>>2]);fa=ea(g[L>>2]);Db=yb;Eb=_a;Fb=fa;Gb=ea(g[G>>2])}c[wb>>2]=Db;EFb(N,e,Db,Ka);c[ub+0>>2]=c[N+0>>2];c[ub+4>>2]=c[N+4>>2];c[ub+8>>2]=c[N+8>>2];c[ub+12>>2]=c[N+12>>2];fa=ea(g[M>>2]);_a=ea(g[K>>2]);mb=ea(g[Pa>>2]);Za=ea(g[N>>2]);jb=ea(g[Ja>>2]);Xa=ea(g[Ia>>2]);nb=ea(fa-Za);kb=ea(_a-jb);da=ea(mb-Xa);g[O>>2]=nb;g[Ha>>2]=kb;g[Ga>>2]=da;g[Fa>>2]=ea(0.0);Hb=c[F>>2]|0;c[F>>2]=Hb+1;yb=A+(Hb<<4)|0;c[yb+0>>2]=c[O+0>>2];c[yb+4>>2]=c[O+4>>2];c[yb+8>>2]=c[O+8>>2];c[yb+12>>2]=c[O+12>>2];Ya=ea(g[J>>2]);Wa=ea(g[Ea>>2]);Ib=Ya>Wa?Ya:Wa;Wa=eb>Ib?eb:Ib;Ib=ea(X+Wa);Ya=ea(ea(ea(Eb*nb)+ea(Fb*kb))+ea(Gb*da));yb=ea(Ya*Ya)>ea(fb*ea(Ib*Ib));if(Ya>ea(0.0)){Jb=yb;Kb=yb^1}else{Jb=0;Kb=1}yb=ea(Y*fb)>=ea(fb-Ya);if((yb|Jb)&(yb|Kb^1))break;do if((Hb|0)==3)qPa(Q,A,B,C,D,E,O,M,N,F,v,w);else if((Hb|0)==2)V6a(Q,A,tb,O,A,B,C,F,v,w);else if((Hb|0)==1){Ya=ea(g[A>>2]);Ib=ea(g[Da>>2]);Lb=ea(g[Ca>>2]);Mb=ea(nb-Ya);Nb=ea(kb-Ib);Ob=ea(da-Lb);Pb=ea(ea(ea(Mb*Mb)+ea(Nb*Nb))+ea(Ob*Ob));if(Pb==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[Q+0>>2]=c[A+0>>2];c[Q+4>>2]=c[A+4>>2];c[Q+8>>2]=c[A+8>>2];c[Q+12>>2]=c[A+12>>2];break}else{Qb=ea(ea(ea(-ea(Ib*Nb))-ea(Ya*Mb))-ea(Lb*Ob));Ob=ea(g[B>>2]);Lb=ea(g[Ba>>2]);Mb=ea(g[Va>>2]);Ya=ea(fa-Ob);Nb=ea(_a-Lb);Ib=ea(mb-Mb);Rb=ea(g[C>>2]);Sb=ea(g[Ua>>2]);Tb=ea(g[pb>>2]);Ub=ea(Za-Rb);Vb=ea(jb-Sb);Wb=ea(Xa-Tb);Xb=ea(Qb/Pb);yb=Xb>ea(1.0);Pb=yb?ea(1.0):Xb;yb=Pb>ea(0.0);Xb=yb?Pb:ea(0.0);Pb=ea(Ob+ea(Ya*Xb));Ya=ea(Lb+ea(Nb*Xb));Nb=ea(Mb+ea(Ib*Xb));Ib=ea(Rb+ea(Ub*Xb));Ub=ea(Sb+ea(Vb*Xb));Vb=ea(Tb+ea(Wb*Xb));g[v>>2]=Pb;g[h>>2]=Ya;g[_>>2]=Nb;g[$>>2]=ea(0.0);g[w>>2]=Ib;g[aa>>2]=Ub;g[ba>>2]=Vb;g[ca>>2]=ea(0.0);Xb=ea(Ya-Ub);Ub=ea(Nb-Vb);g[Q>>2]=ea(Pb-Ib);g[qb>>2]=Xb;g[rb>>2]=Ub;g[sb>>2]=ea(0.0);break}}else if(!Hb){c[v+0>>2]=c[M+0>>2];c[v+4>>2]=c[M+4>>2];c[v+8>>2]=c[M+8>>2];c[v+12>>2]=c[M+12>>2];c[w+0>>2]=c[N+0>>2];c[w+4>>2]=c[N+4>>2];c[w+8>>2]=c[N+8>>2];c[w+12>>2]=c[N+12>>2];c[Q+0>>2]=c[O+0>>2];c[Q+4>>2]=c[O+4>>2];c[Q+8>>2]=c[O+8>>2];c[Q+12>>2]=c[O+12>>2]}else{c[Q+0>>2]=c[O+0>>2];c[Q+4>>2]=c[O+4>>2];c[Q+8>>2]=c[O+8>>2];c[Q+12>>2]=c[O+12>>2]}while(0);c[z+0>>2]=c[Q+0>>2];c[z+4>>2]=c[Q+4>>2];c[z+8>>2]=c[Q+8>>2];c[z+12>>2]=c[Q+12>>2];Xa=ea(g[z>>2]);jb=ea(g[L>>2]);Za=ea(g[G>>2]);mb=ea(ea(ea(Xa*Xa)+ea(jb*jb))+ea(Za*Za));c[x+0>>2]=c[R+0>>2];c[x+4>>2]=c[R+4>>2];c[x+8>>2]=c[R+8>>2];Yb=fb>mb;if(mb>Y^1|Yb^1){Zb=40;break}_a=ea(g[v>>2]);fa=ea(g[h>>2]);da=ea(g[_>>2]);kb=ea(g[$>>2]);nb=ea(g[w>>2]);Ub=ea(g[aa>>2]);Xb=ea(g[ba>>2]);eb=Wa;db=Xa;cb=jb;bb=Za;fb=mb;lb=_a;ob=fa;ab=da;$a=kb;hb=nb;gb=Ub;Z=Xb;ga=ea(g[ca>>2])}if((Zb|0)==40){G=c[F>>2]|0;if(Yb){_b=G;break}L=G+-1|0;if((n|0)!=0?(a[p>>0]=L,(L|0)!=0):0){G=0;do{a[n+G>>0]=c[D+(G<<2)>>2];a[o+G>>0]=c[E+(G<<2)>>2];G=G+1|0}while((G|0)!=(L|0))}g[v>>2]=lb;g[h>>2]=ob;g[_>>2]=ab;g[$>>2]=$a;g[w>>2]=hb;g[aa>>2]=gb;g[ba>>2]=Z;g[ca>>2]=ga;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];bb=ea(lb-hb);cb=ea(ob-gb);db=ea(ab-Z);g[z>>2]=bb;g[z+4>>2]=cb;g[z+8>>2]=db;g[z+12>>2]=ea(0.0);eb=ea(T(ea(fb)));Xb=ea(ea(1.0)/eb);Ub=ea(bb*Xb);bb=ea(cb*Xb);cb=ea(db*Xb);Xb=ea(ob-ea(U*bb));db=ea(ab-ea(U*cb));g[j>>2]=ea(lb-ea(U*Ub));g[j+4>>2]=Xb;g[j+8>>2]=db;g[j+12>>2]=ea(0.0);db=ea(ea(V*bb)+gb);Xb=ea(ea(V*cb)+Z);g[k>>2]=ea(ea(V*Ub)+hb);g[k+4>>2]=db;g[k+8>>2]=Xb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(eb-X);L=m+4|0;c[L+0>>2]=c[S+0>>2];c[L+4>>2]=c[S+4>>2];c[L+8>>2]=c[S+8>>2];g[l>>2]=Ub;g[l+4>>2]=bb;g[l+8>>2]=cb;g[l+12>>2]=ea(0.0);$b=3;i=q;return $b|0}if((n|0)!=0?(a[p>>0]=Hb,(Hb|0)!=0):0){L=0;do{a[n+L>>0]=c[D+(L<<2)>>2];a[o+L>>0]=c[E+(L<<2)>>2];L=L+1|0}while((L|0)!=(Hb|0))}if(!(Kb&(Jb^1))){$b=0;i=q;return $b|0}hb=ea(T(ea(fb)));Z=ea(ea(1.0)/hb);gb=ea(Eb*Z);lb=ea(Fb*Z);ab=ea(Gb*Z);Z=ea(g[v>>2]);ob=ea(g[h>>2]);ga=ea(ob-ea(U*lb));ob=ea(ea(g[_>>2])-ea(U*ab));g[j>>2]=ea(Z-ea(U*gb));g[j+4>>2]=ga;g[j+8>>2]=ob;g[j+12>>2]=ea(0.0);ob=ea(g[w>>2]);ga=ea(g[aa>>2]);Z=ea(ea(V*lb)+ga);ga=ea(ea(V*ab)+ea(g[ba>>2]));g[k>>2]=ea(ea(V*gb)+ob);g[k+4>>2]=Z;g[k+8>>2]=ga;g[k+12>>2]=ea(0.0);g[m>>2]=ea(hb-X);L=m+4|0;c[L+0>>2]=c[P+0>>2];c[L+4>>2]=c[P+4>>2];c[L+8>>2]=c[P+8>>2];g[l>>2]=gb;g[l+4>>2]=lb;g[l+8>>2]=ab;g[l+12>>2]=ea(0.0);$b=1;i=q;return $b|0}else _b=c[F>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=_b,(_b|0)!=0):0){p=0;do{a[n+p>>0]=c[D+(p<<2)>>2];a[o+p>>0]=c[E+(p<<2)>>2];p=p+1|0}while((p|0)!=(_b|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];$b=6;i=q;return $b|0}function i7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=Im,qb=Im,rb=Im,sb=Im,tb=0,ub=0,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=0,Jb=0,Kb=0,Lb=0;q=i;i=i+560|0;r=q+432|0;s=q+96|0;t=q+176|0;u=q+288|0;v=q+448|0;w=q+512|0;x=q+192|0;y=q+224|0;z=q+304|0;A=q+368|0;B=q+464|0;C=q+496|0;D=q+460|0;E=q+16|0;F=q+160|0;G=q+80|0;H=q+208|0;I=q+112|0;J=q+128|0;K=q;L=q+32|0;M=q+144|0;N=q+64|0;O=q+536|0;P=q+48|0;Q=q+480|0;R=q+524|0;S=ea(g[b+16>>2]);U=ea(g[e+16>>2]);V=ea(g[h>>2]);W=ea(g[b+32>>2]);X=ea(g[e+32>>2]);Y=ea((W>X?X:W)*ea(.100000001));W=ea(S+U);h=t+4|0;Z=t+8|0;_=t+12|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;$=u+4|0;aa=u+8|0;ba=u+12|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];X=ea(Y*Y);c[D>>2]=0;if(!(a[p>>0]|0)){Y=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(ea(ea(Y*Y)+ea(ca*ca))+ea(da*da))>ea(0.0);g[s>>2]=Y;g[s+4>>2]=ca;g[s+8>>2]=da;g[s+12>>2]=fa;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ha=ga?s:r;fa=ea(g[ha>>2]);da=ea(g[ha+4>>2]);ca=ea(g[ha+8>>2]);g[x>>2]=fa;g[x+4>>2]=da;g[x+8>>2]=ca;g[x+12>>2]=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(3402823469999999843913219.0e14);ra=1;sa=ca;ta=da;ua=fa}else{ha=E+4|0;r=E+8|0;s=E+12|0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;ga=F+4|0;va=F+8|0;wa=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;xa=G+4|0;ya=G+8|0;za=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;Aa=b+16|0;Ba=f+48|0;Ca=f+52|0;Da=f+56|0;Ea=H+4|0;Fa=H+8|0;Ga=f+16|0;Ha=f+32|0;Ia=f+4|0;Ja=f+20|0;Ka=f+36|0;La=f+8|0;Ma=f+24|0;Na=f+40|0;Oa=e+16|0;Pa=I+4|0;Qa=I+8|0;Ra=I+12|0;Sa=0;do{Ta=d[n+Sa>>0]|0;c[B+(Sa<<2)>>2]=Ta;Ua=d[o+Sa>>0]|0;c[C+(Sa<<2)>>2]=Ua;EFb(H,b,Ta,Aa);fa=ea(g[Ba>>2]);da=ea(g[Ca>>2]);ca=ea(g[Da>>2]);Y=ea(g[H>>2]);Va=ea(g[Ea>>2]);Wa=ea(g[Fa>>2]);Xa=ea(Y*ea(g[f>>2]));Ya=ea(Xa+ea(Va*ea(g[Ga>>2])));Xa=ea(Ya+ea(Wa*ea(g[Ha>>2])));Ya=ea(Y*ea(g[Ia>>2]));Za=ea(Ya+ea(Va*ea(g[Ja>>2])));Ya=ea(Za+ea(Wa*ea(g[Ka>>2])));Za=ea(Y*ea(g[La>>2]));Y=ea(Za+ea(Va*ea(g[Ma>>2])));_a=ea(fa+Xa);$a=ea(da+Ya);ab=ea(ca+ea(Y+ea(Wa*ea(g[Na>>2]))));BFb(I,e,Ua,Oa);bb=ea(g[I>>2]);cb=ea(g[Pa>>2]);db=ea(g[Qa>>2]);Wa=ea(g[Ra>>2]);eb=ea(_a-bb);fb=ea($a-cb);gb=ea(ab-db);hb=c[D>>2]|0;Ua=z+(hb<<4)|0;g[F>>2]=_a;g[ga>>2]=$a;g[va>>2]=ab;g[wa>>2]=ea(0.0);c[Ua+0>>2]=c[F+0>>2];c[Ua+4>>2]=c[F+4>>2];c[Ua+8>>2]=c[F+8>>2];c[Ua+12>>2]=c[F+12>>2];Ua=A+(hb<<4)|0;g[G>>2]=bb;g[xa>>2]=cb;g[ya>>2]=db;g[za>>2]=Wa;c[Ua+0>>2]=c[G+0>>2];c[Ua+4>>2]=c[G+4>>2];c[Ua+8>>2]=c[G+8>>2];c[Ua+12>>2]=c[G+12>>2];c[D>>2]=hb+1;Ua=y+(hb<<4)|0;g[E>>2]=eb;g[ha>>2]=fb;g[r>>2]=gb;g[s>>2]=ea(0.0);c[Ua+0>>2]=c[E+0>>2];c[Ua+4>>2]=c[E+4>>2];c[Ua+8>>2]=c[E+8>>2];c[Ua+12>>2]=c[E+12>>2];Sa=Sa+1|0}while(Sa>>>0<(d[p>>0]|0)>>>0);do if(!hb){c[t+0>>2]=c[F+0>>2];c[t+4>>2]=c[F+4>>2];c[t+8>>2]=c[F+8>>2];c[t+12>>2]=c[F+12>>2];c[u+0>>2]=c[G+0>>2];c[u+4>>2]=c[G+4>>2];c[u+8>>2]=c[G+8>>2];c[u+12>>2]=c[G+12>>2];c[J+0>>2]=c[E+0>>2];c[J+4>>2]=c[E+4>>2];c[J+8>>2]=c[E+8>>2];c[J+12>>2]=c[E+12>>2]}else if((hb|0)==2)V6a(J,y,y+16|0,E,y,z,A,D,t,u);else if((hb|0)==3)qPa(J,y,z,A,B,C,E,F,G,D,t,u);else if((hb|0)==1){Wa=ea(g[y>>2]);Y=ea(g[y+4>>2]);ca=ea(g[y+8>>2]);Ya=ea(eb-Wa);da=ea(fb-Y);Xa=ea(gb-ca);fa=ea(ea(ea(Ya*Ya)+ea(da*da))+ea(Xa*Xa));if(fa==ea(0.0)){c[D>>2]=1;c[t+0>>2]=c[z+0>>2];c[t+4>>2]=c[z+4>>2];c[t+8>>2]=c[z+8>>2];c[t+12>>2]=c[z+12>>2];c[u+0>>2]=c[A+0>>2];c[u+4>>2]=c[A+4>>2];c[u+8>>2]=c[A+8>>2];c[u+12>>2]=c[A+12>>2];c[J+0>>2]=c[y+0>>2];c[J+4>>2]=c[y+4>>2];c[J+8>>2]=c[y+8>>2];c[J+12>>2]=c[y+12>>2];break}else{Va=ea(ea(ea(-ea(Y*da))-ea(Wa*Ya))-ea(ca*Xa));Xa=ea(g[z>>2]);ca=ea(g[z+4>>2]);Ya=ea(g[z+8>>2]);Wa=ea(_a-Xa);da=ea($a-ca);Y=ea(ab-Ya);Za=ea(g[A>>2]);ib=ea(g[A+4>>2]);jb=ea(g[A+8>>2]);kb=ea(bb-Za);lb=ea(cb-ib);mb=ea(db-jb);nb=ea(Va/fa);Sa=nb>ea(1.0);fa=Sa?ea(1.0):nb;Sa=fa>ea(0.0);nb=Sa?fa:ea(0.0);fa=ea(Xa+ea(Wa*nb));Wa=ea(ca+ea(da*nb));da=ea(Ya+ea(Y*nb));Y=ea(Za+ea(kb*nb));kb=ea(ib+ea(lb*nb));lb=ea(jb+ea(mb*nb));g[t>>2]=fa;g[h>>2]=Wa;g[Z>>2]=da;g[_>>2]=ea(0.0);g[u>>2]=Y;g[$>>2]=kb;g[aa>>2]=lb;g[ba>>2]=ea(0.0);nb=ea(Wa-kb);kb=ea(da-lb);g[J>>2]=ea(fa-Y);g[J+4>>2]=nb;g[J+8>>2]=kb;g[J+12>>2]=ea(0.0);break}}else{c[J+0>>2]=c[E+0>>2];c[J+4>>2]=c[E+4>>2];c[J+8>>2]=c[E+8>>2];c[J+12>>2]=c[E+12>>2]}while(0);c[x+0>>2]=c[J+0>>2];c[x+4>>2]=c[J+4>>2];c[x+8>>2]=c[J+8>>2];c[x+12>>2]=c[J+12>>2];db=ea(g[x>>2]);cb=ea(g[x+4>>2]);bb=ea(g[x+8>>2]);ab=ea(ea(ea(db*db)+ea(cb*cb))+ea(bb*bb));c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];$a=ea(g[t>>2]);_a=ea(g[h>>2]);gb=ea(g[Z>>2]);fb=ea(g[_>>2]);eb=ea(g[u>>2]);kb=ea(g[$>>2]);nb=ea(g[aa>>2]);ia=fb;ja=gb;ka=_a;la=$a;ma=ea(g[ba>>2]);na=nb;oa=kb;pa=eb;qa=ab;ra=ab>X;sa=bb;ta=cb;ua=db}do if(ra){J=x+4|0;E=x+8|0;hb=K+4|0;G=K+8|0;F=K+12|0;Sa=L+4|0;s=L+8|0;r=M+4|0;ha=M+8|0;za=N+4|0;ya=N+8|0;xa=N+12|0;wa=b+48|0;va=e+48|0;ga=y+4|0;Ra=y+8|0;Qa=z+4|0;Pa=z+8|0;I=A+4|0;Oa=A+8|0;Na=P+4|0;Ma=P+8|0;La=P+12|0;Ka=y+16|0;db=V;cb=ua;bb=ta;ab=sa;eb=qa;kb=la;nb=ka;$a=ja;_a=ia;gb=pa;fb=oa;Y=na;fa=ma;while(1){c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];lb=ea(-bb);da=ea(-ab);g[K>>2]=ea(-cb);g[hb>>2]=lb;g[G>>2]=da;g[F>>2]=ea(0.0);Ja=c[D>>2]|0;GFb(L,b,K,f,z+(Ja<<4)|0,B+(Ja<<2)|0);Ja=c[D>>2]|0;CFb(M,e,x,A+(Ja<<4)|0,C+(Ja<<2)|0);da=ea(g[L>>2]);lb=ea(g[Sa>>2]);Wa=ea(g[s>>2]);mb=ea(g[M>>2]);jb=ea(g[r>>2]);ib=ea(g[ha>>2]);Za=ea(da-mb);Ya=ea(lb-jb);ca=ea(Wa-ib);g[N>>2]=Za;g[za>>2]=Ya;g[ya>>2]=ca;g[xa>>2]=ea(0.0);ob=c[D>>2]|0;c[D>>2]=ob+1;Ja=y+(ob<<4)|0;c[Ja+0>>2]=c[N+0>>2];c[Ja+4>>2]=c[N+4>>2];c[Ja+8>>2]=c[N+8>>2];c[Ja+12>>2]=c[N+12>>2];Xa=ea(g[wa>>2]);Va=ea(g[va>>2]);pb=Xa>Va?Xa:Va;Va=db>pb?db:pb;pb=ea(W+Va);Xa=ea(eb*ea(pb*pb));qb=ea(g[x>>2]);rb=ea(g[J>>2]);sb=ea(g[E>>2]);pb=ea(ea(ea(qb*Za)+ea(rb*Ya))+ea(sb*ca));Ja=ea(pb*pb)>Xa;if(pb>ea(0.0)){tb=Ja;ub=Ja^1}else{tb=0;ub=1}Ja=ea(X*eb)>=ea(eb-pb);if((Ja|tb)&(Ja|ub^1))break;do if(!ob){c[t+0>>2]=c[L+0>>2];c[t+4>>2]=c[L+4>>2];c[t+8>>2]=c[L+8>>2];c[t+12>>2]=c[L+12>>2];c[u+0>>2]=c[M+0>>2];c[u+4>>2]=c[M+4>>2];c[u+8>>2]=c[M+8>>2];c[u+12>>2]=c[M+12>>2];c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}else if((ob|0)==1){pb=ea(g[y>>2]);Xa=ea(g[ga>>2]);vb=ea(g[Ra>>2]);wb=ea(Za-pb);xb=ea(Ya-Xa);yb=ea(ca-vb);zb=ea(ea(ea(wb*wb)+ea(xb*xb))+ea(yb*yb));if(zb==ea(0.0)){c[D>>2]=1;c[t+0>>2]=c[z+0>>2];c[t+4>>2]=c[z+4>>2];c[t+8>>2]=c[z+8>>2];c[t+12>>2]=c[z+12>>2];c[u+0>>2]=c[A+0>>2];c[u+4>>2]=c[A+4>>2];c[u+8>>2]=c[A+8>>2];c[u+12>>2]=c[A+12>>2];c[P+0>>2]=c[y+0>>2];c[P+4>>2]=c[y+4>>2];c[P+8>>2]=c[y+8>>2];c[P+12>>2]=c[y+12>>2];break}else{Ab=ea(ea(ea(-ea(Xa*xb))-ea(pb*wb))-ea(vb*yb));yb=ea(g[z>>2]);vb=ea(g[Qa>>2]);wb=ea(g[Pa>>2]);pb=ea(da-yb);xb=ea(lb-vb);Xa=ea(Wa-wb);Bb=ea(g[A>>2]);Cb=ea(g[I>>2]);Db=ea(g[Oa>>2]);Eb=ea(mb-Bb);Fb=ea(jb-Cb);Gb=ea(ib-Db);Hb=ea(Ab/zb);Ja=Hb>ea(1.0);zb=Ja?ea(1.0):Hb;Ja=zb>ea(0.0);Hb=Ja?zb:ea(0.0);zb=ea(yb+ea(pb*Hb));pb=ea(vb+ea(xb*Hb));xb=ea(wb+ea(Xa*Hb));Xa=ea(Bb+ea(Eb*Hb));Eb=ea(Cb+ea(Fb*Hb));Fb=ea(Db+ea(Gb*Hb));g[t>>2]=zb;g[h>>2]=pb;g[Z>>2]=xb;g[_>>2]=ea(0.0);g[u>>2]=Xa;g[$>>2]=Eb;g[aa>>2]=Fb;g[ba>>2]=ea(0.0);Hb=ea(pb-Eb);Eb=ea(xb-Fb);g[P>>2]=ea(zb-Xa);g[Na>>2]=Hb;g[Ma>>2]=Eb;g[La>>2]=ea(0.0);break}}else if((ob|0)==2)V6a(P,y,Ka,N,y,z,A,D,t,u);else if((ob|0)==3)qPa(P,y,z,A,B,C,N,L,M,D,t,u);else{c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}while(0);c[x+0>>2]=c[P+0>>2];c[x+4>>2]=c[P+4>>2];c[x+8>>2]=c[P+8>>2];c[x+12>>2]=c[P+12>>2];ib=ea(g[x>>2]);jb=ea(g[J>>2]);mb=ea(g[E>>2]);Wa=ea(ea(ea(ib*ib)+ea(jb*jb))+ea(mb*mb));c[v+0>>2]=c[Q+0>>2];c[v+4>>2]=c[Q+4>>2];c[v+8>>2]=c[Q+8>>2];Ib=eb>Wa;if(Wa>X^1|Ib^1){Jb=35;break}lb=ea(g[t>>2]);da=ea(g[h>>2]);ca=ea(g[Z>>2]);Ya=ea(g[_>>2]);Za=ea(g[u>>2]);Eb=ea(g[$>>2]);Hb=ea(g[aa>>2]);db=Va;cb=ib;bb=jb;ab=mb;eb=Wa;kb=lb;nb=da;$a=ca;_a=Ya;gb=Za;fb=Eb;Y=Hb;fa=ea(g[ba>>2])}if((Jb|0)==35){E=c[D>>2]|0;if(Ib){Kb=E;break}J=E+-1|0;if((n|0)!=0?(a[p>>0]=J,(J|0)!=0):0){E=0;do{a[n+E>>0]=c[B+(E<<2)>>2];a[o+E>>0]=c[C+(E<<2)>>2];E=E+1|0}while((E|0)!=(J|0))}g[t>>2]=kb;g[h>>2]=nb;g[Z>>2]=$a;g[_>>2]=_a;g[u>>2]=gb;g[$>>2]=fb;g[aa>>2]=Y;g[ba>>2]=fa;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];ab=ea(kb-gb);bb=ea(nb-fb);cb=ea($a-Y);g[x>>2]=ab;g[x+4>>2]=bb;g[x+8>>2]=cb;g[x+12>>2]=ea(0.0);db=ea(T(ea(eb)));Hb=ea(ea(1.0)/db);Eb=ea(ab*Hb);ab=ea(bb*Hb);bb=ea(cb*Hb);Hb=ea(nb-ea(S*ab));cb=ea($a-ea(S*bb));g[j>>2]=ea(kb-ea(S*Eb));g[j+4>>2]=Hb;g[j+8>>2]=cb;g[j+12>>2]=ea(0.0);cb=ea(ea(U*ab)+fb);Hb=ea(ea(U*bb)+Y);g[k>>2]=ea(ea(U*Eb)+gb);g[k+4>>2]=cb;g[k+8>>2]=Hb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(db-W);J=m+4|0;c[J+0>>2]=c[R+0>>2];c[J+4>>2]=c[R+4>>2];c[J+8>>2]=c[R+8>>2];g[l>>2]=Eb;g[l+4>>2]=ab;g[l+8>>2]=bb;g[l+12>>2]=ea(0.0);Lb=3;i=q;return Lb|0}if((n|0)!=0?(a[p>>0]=ob,(ob|0)!=0):0){J=0;do{a[n+J>>0]=c[B+(J<<2)>>2];a[o+J>>0]=c[C+(J<<2)>>2];J=J+1|0}while((J|0)!=(ob|0))}if(!(ub&(tb^1))){Lb=0;i=q;return Lb|0}gb=ea(T(ea(eb)));Y=ea(ea(1.0)/gb);fb=ea(qb*Y);kb=ea(rb*Y);$a=ea(sb*Y);Y=ea(g[t>>2]);nb=ea(g[h>>2]);fa=ea(nb-ea(S*kb));nb=ea(ea(g[Z>>2])-ea(S*$a));g[j>>2]=ea(Y-ea(S*fb));g[j+4>>2]=fa;g[j+8>>2]=nb;g[j+12>>2]=ea(0.0);nb=ea(g[u>>2]);fa=ea(g[$>>2]);Y=ea(ea(U*kb)+fa);fa=ea(ea(U*$a)+ea(g[aa>>2]));g[k>>2]=ea(ea(U*fb)+nb);g[k+4>>2]=Y;g[k+8>>2]=fa;g[k+12>>2]=ea(0.0);g[m>>2]=ea(gb-W);J=m+4|0;c[J+0>>2]=c[O+0>>2];c[J+4>>2]=c[O+4>>2];c[J+8>>2]=c[O+8>>2];g[l>>2]=fb;g[l+4>>2]=kb;g[l+8>>2]=$a;g[l+12>>2]=ea(0.0);Lb=1;i=q;return Lb|0}else Kb=c[D>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Kb,(Kb|0)!=0):0){p=0;do{a[n+p>>0]=c[B+(p<<2)>>2];a[o+p>>0]=c[C+(p<<2)>>2];p=p+1|0}while((p|0)!=(Kb|0))};c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[j+12>>2]=c[t+12>>2];c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[k+12>>2]=c[u+12>>2];Lb=6;i=q;return Lb|0}function j7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=Im,qb=Im,rb=Im,sb=0,tb=Im,ub=0,vb=0,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=0,Kb=0,Lb=0,Mb=0;q=i;i=i+560|0;r=q+432|0;s=q+96|0;t=q+176|0;u=q+288|0;v=q+448|0;w=q+512|0;x=q+192|0;y=q+224|0;z=q+304|0;A=q+368|0;B=q+464|0;C=q+496|0;D=q+460|0;E=q+16|0;F=q+160|0;G=q+80|0;H=q+208|0;I=q+112|0;J=q+128|0;K=q;L=q+32|0;M=q+144|0;N=q+64|0;O=q+536|0;P=q+48|0;Q=q+480|0;R=q+524|0;S=ea(g[b+16>>2]);U=ea(g[e+16>>2]);V=ea(g[h>>2]);W=ea(g[b+32>>2]);X=ea(g[e+32>>2]);Y=ea((W>X?X:W)*ea(.100000001));W=ea(S+U);h=t+4|0;Z=t+8|0;_=t+12|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;$=u+4|0;aa=u+8|0;ba=u+12|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];X=ea(Y*Y);c[D>>2]=0;if(!(a[p>>0]|0)){Y=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(ea(ea(Y*Y)+ea(ca*ca))+ea(da*da))>ea(0.0);g[s>>2]=Y;g[s+4>>2]=ca;g[s+8>>2]=da;g[s+12>>2]=fa;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ha=ga?s:r;fa=ea(g[ha>>2]);da=ea(g[ha+4>>2]);ca=ea(g[ha+8>>2]);g[x>>2]=fa;g[x+4>>2]=da;g[x+8>>2]=ca;g[x+12>>2]=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(3402823469999999843913219.0e14);ra=1;sa=ca;ta=da;ua=fa}else{ha=E+4|0;r=E+8|0;s=E+12|0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;ga=F+4|0;va=F+8|0;wa=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;xa=G+4|0;ya=G+8|0;za=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;Aa=b+16|0;Ba=f+48|0;Ca=f+52|0;Da=f+56|0;Ea=H+4|0;Fa=H+8|0;Ga=f+16|0;Ha=f+32|0;Ia=f+4|0;Ja=f+20|0;Ka=f+36|0;La=f+8|0;Ma=f+24|0;Na=f+40|0;Oa=e+16|0;Pa=I+4|0;Qa=I+8|0;Ra=I+12|0;Sa=0;do{Ta=d[n+Sa>>0]|0;c[B+(Sa<<2)>>2]=Ta;Ua=d[o+Sa>>0]|0;c[C+(Sa<<2)>>2]=Ua;EFb(H,b,Ta,Aa);fa=ea(g[Ba>>2]);da=ea(g[Ca>>2]);ca=ea(g[Da>>2]);Y=ea(g[H>>2]);Va=ea(g[Ea>>2]);Wa=ea(g[Fa>>2]);Xa=ea(Y*ea(g[f>>2]));Ya=ea(Xa+ea(Va*ea(g[Ga>>2])));Xa=ea(Ya+ea(Wa*ea(g[Ha>>2])));Ya=ea(Y*ea(g[Ia>>2]));Za=ea(Ya+ea(Va*ea(g[Ja>>2])));Ya=ea(Za+ea(Wa*ea(g[Ka>>2])));Za=ea(Y*ea(g[La>>2]));Y=ea(Za+ea(Va*ea(g[Ma>>2])));_a=ea(fa+Xa);$a=ea(da+Ya);ab=ea(ca+ea(Y+ea(Wa*ea(g[Na>>2]))));EFb(I,e,Ua,Oa);bb=ea(g[I>>2]);cb=ea(g[Pa>>2]);db=ea(g[Qa>>2]);Wa=ea(g[Ra>>2]);eb=ea(_a-bb);fb=ea($a-cb);gb=ea(ab-db);hb=c[D>>2]|0;Ua=z+(hb<<4)|0;g[F>>2]=_a;g[ga>>2]=$a;g[va>>2]=ab;g[wa>>2]=ea(0.0);c[Ua+0>>2]=c[F+0>>2];c[Ua+4>>2]=c[F+4>>2];c[Ua+8>>2]=c[F+8>>2];c[Ua+12>>2]=c[F+12>>2];Ua=A+(hb<<4)|0;g[G>>2]=bb;g[xa>>2]=cb;g[ya>>2]=db;g[za>>2]=Wa;c[Ua+0>>2]=c[G+0>>2];c[Ua+4>>2]=c[G+4>>2];c[Ua+8>>2]=c[G+8>>2];c[Ua+12>>2]=c[G+12>>2];c[D>>2]=hb+1;Ua=y+(hb<<4)|0;g[E>>2]=eb;g[ha>>2]=fb;g[r>>2]=gb;g[s>>2]=ea(0.0);c[Ua+0>>2]=c[E+0>>2];c[Ua+4>>2]=c[E+4>>2];c[Ua+8>>2]=c[E+8>>2];c[Ua+12>>2]=c[E+12>>2];Sa=Sa+1|0}while(Sa>>>0<(d[p>>0]|0)>>>0);do if((hb|0)==1){Wa=ea(g[y>>2]);Y=ea(g[y+4>>2]);ca=ea(g[y+8>>2]);Ya=ea(eb-Wa);da=ea(fb-Y);Xa=ea(gb-ca);fa=ea(ea(ea(Ya*Ya)+ea(da*da))+ea(Xa*Xa));if(fa==ea(0.0)){c[D>>2]=1;c[t+0>>2]=c[z+0>>2];c[t+4>>2]=c[z+4>>2];c[t+8>>2]=c[z+8>>2];c[t+12>>2]=c[z+12>>2];c[u+0>>2]=c[A+0>>2];c[u+4>>2]=c[A+4>>2];c[u+8>>2]=c[A+8>>2];c[u+12>>2]=c[A+12>>2];c[J+0>>2]=c[y+0>>2];c[J+4>>2]=c[y+4>>2];c[J+8>>2]=c[y+8>>2];c[J+12>>2]=c[y+12>>2];break}else{Va=ea(ea(ea(-ea(Y*da))-ea(Wa*Ya))-ea(ca*Xa));Xa=ea(g[z>>2]);ca=ea(g[z+4>>2]);Ya=ea(g[z+8>>2]);Wa=ea(_a-Xa);da=ea($a-ca);Y=ea(ab-Ya);Za=ea(g[A>>2]);ib=ea(g[A+4>>2]);jb=ea(g[A+8>>2]);kb=ea(bb-Za);lb=ea(cb-ib);mb=ea(db-jb);nb=ea(Va/fa);Sa=nb>ea(1.0);fa=Sa?ea(1.0):nb;Sa=fa>ea(0.0);nb=Sa?fa:ea(0.0);fa=ea(Xa+ea(Wa*nb));Wa=ea(ca+ea(da*nb));da=ea(Ya+ea(Y*nb));Y=ea(Za+ea(kb*nb));kb=ea(ib+ea(lb*nb));lb=ea(jb+ea(mb*nb));g[t>>2]=fa;g[h>>2]=Wa;g[Z>>2]=da;g[_>>2]=ea(0.0);g[u>>2]=Y;g[$>>2]=kb;g[aa>>2]=lb;g[ba>>2]=ea(0.0);nb=ea(Wa-kb);kb=ea(da-lb);g[J>>2]=ea(fa-Y);g[J+4>>2]=nb;g[J+8>>2]=kb;g[J+12>>2]=ea(0.0);break}}else if((hb|0)==3)qPa(J,y,z,A,B,C,E,F,G,D,t,u);else if(!hb){c[t+0>>2]=c[F+0>>2];c[t+4>>2]=c[F+4>>2];c[t+8>>2]=c[F+8>>2];c[t+12>>2]=c[F+12>>2];c[u+0>>2]=c[G+0>>2];c[u+4>>2]=c[G+4>>2];c[u+8>>2]=c[G+8>>2];c[u+12>>2]=c[G+12>>2];c[J+0>>2]=c[E+0>>2];c[J+4>>2]=c[E+4>>2];c[J+8>>2]=c[E+8>>2];c[J+12>>2]=c[E+12>>2]}else if((hb|0)==2)V6a(J,y,y+16|0,E,y,z,A,D,t,u);else{c[J+0>>2]=c[E+0>>2];c[J+4>>2]=c[E+4>>2];c[J+8>>2]=c[E+8>>2];c[J+12>>2]=c[E+12>>2]}while(0);c[x+0>>2]=c[J+0>>2];c[x+4>>2]=c[J+4>>2];c[x+8>>2]=c[J+8>>2];c[x+12>>2]=c[J+12>>2];db=ea(g[x>>2]);cb=ea(g[x+4>>2]);bb=ea(g[x+8>>2]);ab=ea(ea(ea(db*db)+ea(cb*cb))+ea(bb*bb));c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];$a=ea(g[t>>2]);_a=ea(g[h>>2]);gb=ea(g[Z>>2]);fb=ea(g[_>>2]);eb=ea(g[u>>2]);kb=ea(g[$>>2]);nb=ea(g[aa>>2]);ia=fb;ja=gb;ka=_a;la=$a;ma=ea(g[ba>>2]);na=nb;oa=kb;pa=eb;qa=ab;ra=ab>X;sa=bb;ta=cb;ua=db}do if(ra){J=x+4|0;E=x+8|0;hb=K+4|0;G=K+8|0;F=K+12|0;Sa=e+196|0;s=e+200|0;r=e+204|0;ha=e+16|0;za=L+4|0;ya=L+8|0;xa=M+4|0;wa=M+8|0;va=N+4|0;ga=N+8|0;Ra=N+12|0;Qa=b+48|0;Pa=e+48|0;I=y+4|0;Oa=y+8|0;Na=z+4|0;Ma=z+8|0;La=A+4|0;Ka=A+8|0;Ja=P+4|0;Ia=P+8|0;Ha=P+12|0;Ga=y+16|0;db=V;cb=ua;bb=ta;ab=sa;eb=qa;kb=la;nb=ka;$a=ja;_a=ia;gb=pa;fb=oa;Y=na;fa=ma;while(1){c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];lb=ea(-bb);da=ea(-ab);g[K>>2]=ea(-cb);g[hb>>2]=lb;g[G>>2]=da;g[F>>2]=ea(0.0);Fa=c[D>>2]|0;GFb(L,b,K,f,z+(Fa<<4)|0,B+(Fa<<2)|0);Fa=c[D>>2]|0;Ea=A+(Fa<<4)|0;H=C+(Fa<<2)|0;if(!(c[Sa>>2]|0)){Fa=c[s>>2]|0;if((d[r>>0]|0)>1){da=ea(g[Fa+4>>2]);lb=ea(bb*da);da=ea(cb*ea(g[Fa>>2]));Da=Fa;Wa=ea(ea(lb+da)+ea(ab*ea(g[Fa+8>>2])));Fa=1;Ca=0;while(1){Ba=c[s>>2]|0;da=ea(g[Ba+(Fa*12|0)>>2]);lb=ea(g[Ba+(Fa*12|0)+4>>2]);mb=ea(ea(ea(da*cb)+ea(lb*bb))+ea(ea(g[Ba+(Fa*12|0)+8>>2])*ab));Aa=mb>Wa;Ua=Aa?Fa:Ca;Ta=Fa+1|0;if(Ta>>>0<(d[r>>0]|0)>>>0){Da=Ba;Wa=Aa?mb:Wa;Fa=Ta;Ca=Ua}else{ob=Ua;pb=cb;qb=bb;rb=ab;break}}}else{ob=0;pb=cb;qb=bb;rb=ab}}else{Ca=DFb(e,x)|0;Wa=ea(g[x>>2]);mb=ea(g[J>>2]);ob=Ca;pb=Wa;qb=mb;rb=ea(g[E>>2])}c[H>>2]=ob;EFb(M,e,ob,ha);c[Ea+0>>2]=c[M+0>>2];c[Ea+4>>2]=c[M+4>>2];c[Ea+8>>2]=c[M+8>>2];c[Ea+12>>2]=c[M+12>>2];mb=ea(g[L>>2]);Wa=ea(g[za>>2]);lb=ea(g[ya>>2]);da=ea(g[M>>2]);jb=ea(g[xa>>2]);ib=ea(g[wa>>2]);Za=ea(mb-da);Ya=ea(Wa-jb);ca=ea(lb-ib);g[N>>2]=Za;g[va>>2]=Ya;g[ga>>2]=ca;g[Ra>>2]=ea(0.0);sb=c[D>>2]|0;c[D>>2]=sb+1;Ca=y+(sb<<4)|0;c[Ca+0>>2]=c[N+0>>2];c[Ca+4>>2]=c[N+4>>2];c[Ca+8>>2]=c[N+8>>2];c[Ca+12>>2]=c[N+12>>2];Xa=ea(g[Qa>>2]);Va=ea(g[Pa>>2]);tb=Xa>Va?Xa:Va;Va=db>tb?db:tb;tb=ea(W+Va);Xa=ea(ea(ea(pb*Za)+ea(qb*Ya))+ea(rb*ca));Ca=ea(Xa*Xa)>ea(eb*ea(tb*tb));if(Xa>ea(0.0)){ub=Ca;vb=Ca^1}else{ub=0;vb=1}Ca=ea(X*eb)>=ea(eb-Xa);if((Ca|ub)&(Ca|vb^1))break;do if((sb|0)==1){Xa=ea(g[y>>2]);tb=ea(g[I>>2]);wb=ea(g[Oa>>2]);xb=ea(Za-Xa);yb=ea(Ya-tb);zb=ea(ca-wb);Ab=ea(ea(ea(xb*xb)+ea(yb*yb))+ea(zb*zb));if(Ab==ea(0.0)){c[D>>2]=1;c[t+0>>2]=c[z+0>>2];c[t+4>>2]=c[z+4>>2];c[t+8>>2]=c[z+8>>2];c[t+12>>2]=c[z+12>>2];c[u+0>>2]=c[A+0>>2];c[u+4>>2]=c[A+4>>2];c[u+8>>2]=c[A+8>>2];c[u+12>>2]=c[A+12>>2];c[P+0>>2]=c[y+0>>2];c[P+4>>2]=c[y+4>>2];c[P+8>>2]=c[y+8>>2];c[P+12>>2]=c[y+12>>2];break}else{Bb=ea(ea(ea(-ea(tb*yb))-ea(Xa*xb))-ea(wb*zb));zb=ea(g[z>>2]);wb=ea(g[Na>>2]);xb=ea(g[Ma>>2]);Xa=ea(mb-zb);yb=ea(Wa-wb);tb=ea(lb-xb);Cb=ea(g[A>>2]);Db=ea(g[La>>2]);Eb=ea(g[Ka>>2]);Fb=ea(da-Cb);Gb=ea(jb-Db);Hb=ea(ib-Eb);Ib=ea(Bb/Ab);Ca=Ib>ea(1.0);Ab=Ca?ea(1.0):Ib;Ca=Ab>ea(0.0);Ib=Ca?Ab:ea(0.0);Ab=ea(zb+ea(Xa*Ib));Xa=ea(wb+ea(yb*Ib));yb=ea(xb+ea(tb*Ib));tb=ea(Cb+ea(Fb*Ib));Fb=ea(Db+ea(Gb*Ib));Gb=ea(Eb+ea(Hb*Ib));g[t>>2]=Ab;g[h>>2]=Xa;g[Z>>2]=yb;g[_>>2]=ea(0.0);g[u>>2]=tb;g[$>>2]=Fb;g[aa>>2]=Gb;g[ba>>2]=ea(0.0);Ib=ea(Xa-Fb);Fb=ea(yb-Gb);g[P>>2]=ea(Ab-tb);g[Ja>>2]=Ib;g[Ia>>2]=Fb;g[Ha>>2]=ea(0.0);break}}else if((sb|0)==3)qPa(P,y,z,A,B,C,N,L,M,D,t,u);else if((sb|0)==2)V6a(P,y,Ga,N,y,z,A,D,t,u);else if(!sb){c[t+0>>2]=c[L+0>>2];c[t+4>>2]=c[L+4>>2];c[t+8>>2]=c[L+8>>2];c[t+12>>2]=c[L+12>>2];c[u+0>>2]=c[M+0>>2];c[u+4>>2]=c[M+4>>2];c[u+8>>2]=c[M+8>>2];c[u+12>>2]=c[M+12>>2];c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}else{c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}while(0);c[x+0>>2]=c[P+0>>2];c[x+4>>2]=c[P+4>>2];c[x+8>>2]=c[P+8>>2];c[x+12>>2]=c[P+12>>2];ib=ea(g[x>>2]);jb=ea(g[J>>2]);da=ea(g[E>>2]);lb=ea(ea(ea(ib*ib)+ea(jb*jb))+ea(da*da));c[v+0>>2]=c[Q+0>>2];c[v+4>>2]=c[Q+4>>2];c[v+8>>2]=c[Q+8>>2];Jb=eb>lb;if(lb>X^1|Jb^1){Kb=40;break}Wa=ea(g[t>>2]);mb=ea(g[h>>2]);ca=ea(g[Z>>2]);Ya=ea(g[_>>2]);Za=ea(g[u>>2]);Fb=ea(g[$>>2]);Ib=ea(g[aa>>2]);db=Va;cb=ib;bb=jb;ab=da;eb=lb;kb=Wa;nb=mb;$a=ca;_a=Ya;gb=Za;fb=Fb;Y=Ib;fa=ea(g[ba>>2])}if((Kb|0)==40){E=c[D>>2]|0;if(Jb){Lb=E;break}J=E+-1|0;if((n|0)!=0?(a[p>>0]=J,(J|0)!=0):0){E=0;do{a[n+E>>0]=c[B+(E<<2)>>2];a[o+E>>0]=c[C+(E<<2)>>2];E=E+1|0}while((E|0)!=(J|0))}g[t>>2]=kb;g[h>>2]=nb;g[Z>>2]=$a;g[_>>2]=_a;g[u>>2]=gb;g[$>>2]=fb;g[aa>>2]=Y;g[ba>>2]=fa;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];ab=ea(kb-gb);bb=ea(nb-fb);cb=ea($a-Y);g[x>>2]=ab;g[x+4>>2]=bb;g[x+8>>2]=cb;g[x+12>>2]=ea(0.0);db=ea(T(ea(eb)));Ib=ea(ea(1.0)/db);Fb=ea(ab*Ib);ab=ea(bb*Ib);bb=ea(cb*Ib);Ib=ea(nb-ea(S*ab));cb=ea($a-ea(S*bb));g[j>>2]=ea(kb-ea(S*Fb));g[j+4>>2]=Ib;g[j+8>>2]=cb;g[j+12>>2]=ea(0.0);cb=ea(ea(U*ab)+fb);Ib=ea(ea(U*bb)+Y);g[k>>2]=ea(ea(U*Fb)+gb);g[k+4>>2]=cb;g[k+8>>2]=Ib;g[k+12>>2]=ea(0.0);g[m>>2]=ea(db-W);J=m+4|0;c[J+0>>2]=c[R+0>>2];c[J+4>>2]=c[R+4>>2];c[J+8>>2]=c[R+8>>2];g[l>>2]=Fb;g[l+4>>2]=ab;g[l+8>>2]=bb;g[l+12>>2]=ea(0.0);Mb=3;i=q;return Mb|0}if((n|0)!=0?(a[p>>0]=sb,(sb|0)!=0):0){J=0;do{a[n+J>>0]=c[B+(J<<2)>>2];a[o+J>>0]=c[C+(J<<2)>>2];J=J+1|0}while((J|0)!=(sb|0))}if(!(vb&(ub^1))){Mb=0;i=q;return Mb|0}gb=ea(T(ea(eb)));Y=ea(ea(1.0)/gb);fb=ea(pb*Y);kb=ea(qb*Y);$a=ea(rb*Y);Y=ea(g[t>>2]);nb=ea(g[h>>2]);fa=ea(nb-ea(S*kb));nb=ea(ea(g[Z>>2])-ea(S*$a));g[j>>2]=ea(Y-ea(S*fb));g[j+4>>2]=fa;g[j+8>>2]=nb;g[j+12>>2]=ea(0.0);nb=ea(g[u>>2]);fa=ea(g[$>>2]);Y=ea(ea(U*kb)+fa);fa=ea(ea(U*$a)+ea(g[aa>>2]));g[k>>2]=ea(ea(U*fb)+nb);g[k+4>>2]=Y;g[k+8>>2]=fa;g[k+12>>2]=ea(0.0);g[m>>2]=ea(gb-W);J=m+4|0;c[J+0>>2]=c[O+0>>2];c[J+4>>2]=c[O+4>>2];c[J+8>>2]=c[O+8>>2];g[l>>2]=fb;g[l+4>>2]=kb;g[l+8>>2]=$a;g[l+12>>2]=ea(0.0);Mb=1;i=q;return Mb|0}else Lb=c[D>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Lb,(Lb|0)!=0):0){p=0;do{a[n+p>>0]=c[B+(p<<2)>>2];a[o+p>>0]=c[C+(p<<2)>>2];p=p+1|0}while((p|0)!=(Lb|0))};c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[j+12>>2]=c[t+12>>2];c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[k+12>>2]=c[u+12>>2];Mb=6;i=q;return Mb|0}function k7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=Im,Bb=0,Cb=0,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=0,Rb=0,Sb=0,Tb=0;q=i;i=i+528|0;r=q+272|0;s=q+400|0;t=q+304|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+416|0;y=q+440|0;z=q+336|0;A=q+128|0;B=q+192|0;C=q+456|0;D=q+472|0;E=q+488|0;F=q+256|0;G=q+80|0;H=q+112|0;I=q+16|0;J=q;K=q+32|0;L=q+320|0;M=q+428|0;N=q+288|0;O=q+492|0;P=q+504|0;Q=ea(g[b+16>>2]);R=ea(g[e+16>>2]);S=ea(g[h>>2]);U=ea(g[b+32>>2]);V=ea(g[e+32>>2]);W=ea((U>V?V:U)*ea(.100000001));U=ea(Q+R);h=v+4|0;X=v+8|0;Y=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;Z=w+4|0;_=w+8|0;$=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];V=ea(W*W);c[E>>2]=0;aa=a[p>>0]|0;if(!(aa<<24>>24)){W=ea(g[f+48>>2]);ba=ea(g[f+52>>2]);ca=ea(g[f+56>>2]);da=ea(g[f+60>>2]);fa=ea(ea(ea(W*W)+ea(ba*ba))+ea(ca*ca))>ea(0.0);g[s>>2]=W;g[s+4>>2]=ba;g[s+8>>2]=ca;g[s+12>>2]=da;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ga=fa?s:r;da=ea(g[ga>>2]);ca=ea(g[ga+4>>2]);ha=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(3402823469999999843913219.0e14);qa=1;ra=ea(g[ga+8>>2]);sa=ca;ta=da}else{ga=F+4|0;r=F+8|0;s=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;fa=G+4|0;ua=G+8|0;va=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;wa=H+4|0;xa=H+8|0;ya=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;da=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);ba=ea(g[f+56>>2]);W=ea(g[f>>2]);za=ea(g[f+16>>2]);Aa=ea(g[f+32>>2]);Ba=ea(g[f+4>>2]);Ca=ea(g[f+20>>2]);Da=ea(g[f+36>>2]);Ea=ea(g[f+8>>2]);Fa=ea(g[f+24>>2]);Ga=ea(g[f+40>>2]);Ha=e+96|0;Ia=aa&255;aa=Ia>>>0>1?Ia:1;Ja=0;Ka=0;while(1){La=d[n+Ka>>0]|0;c[C+(Ka<<2)>>2]=La;Ma=d[o+Ka>>0]|0;c[D+(Ka<<2)>>2]=Ma;Na=ea(g[b+(La<<4)+96>>2]);Oa=ea(g[b+(La<<4)+100>>2]);Pa=ea(g[b+(La<<4)+104>>2]);Qa=ea(da+ea(ea(ea(Na*W)+ea(Oa*za))+ea(Pa*Aa)));Ra=ea(ca+ea(ea(ea(Na*Ba)+ea(Oa*Ca))+ea(Pa*Da)));Sa=ea(ba+ea(ea(ea(Na*Ea)+ea(Oa*Fa))+ea(Pa*Ga)));La=1-Ma|0;Ta=ea(g[Ha+(La<<4)>>2]);Ua=ea(g[Ha+(La<<4)+4>>2]);Va=ea(g[Ha+(La<<4)+8>>2]);Pa=ea(g[Ha+(La<<4)+12>>2]);Wa=ea(Qa-Ta);Xa=ea(Ra-Ua);Ya=ea(Sa-Va);La=A+(Ja<<4)|0;g[G>>2]=Qa;g[fa>>2]=Ra;g[ua>>2]=Sa;g[va>>2]=ea(0.0);c[La+0>>2]=c[G+0>>2];c[La+4>>2]=c[G+4>>2];c[La+8>>2]=c[G+8>>2];c[La+12>>2]=c[G+12>>2];La=B+(Ja<<4)|0;g[H>>2]=Ta;g[wa>>2]=Ua;g[xa>>2]=Va;g[ya>>2]=Pa;c[La+0>>2]=c[H+0>>2];c[La+4>>2]=c[H+4>>2];c[La+8>>2]=c[H+8>>2];c[La+12>>2]=c[H+12>>2];La=z+(Ja<<4)|0;g[F>>2]=Wa;g[ga>>2]=Xa;g[r>>2]=Ya;g[s>>2]=ea(0.0);c[La+0>>2]=c[F+0>>2];c[La+4>>2]=c[F+4>>2];c[La+8>>2]=c[F+8>>2];c[La+12>>2]=c[F+12>>2];Ka=Ka+1|0;if(Ka>>>0>=Ia>>>0)break;else Ja=Ja+1|0}c[E>>2]=aa;do if((aa|0)==4)qPa(I,z,A,B,C,D,F,G,H,E,v,w);else if((aa|0)==1){c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}else if((aa|0)==3)V6a(I,z,z+16|0,F,z,A,B,E,v,w);else if((aa|0)==2){Ga=ea(g[z>>2]);Fa=ea(g[z+4>>2]);Ea=ea(g[z+8>>2]);ba=ea(Wa-Ga);Da=ea(Xa-Fa);Ca=ea(Ya-Ea);Ba=ea(ea(ea(ba*ba)+ea(Da*Da))+ea(Ca*Ca));if(Ba==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[I+0>>2]=c[z+0>>2];c[I+4>>2]=c[z+4>>2];c[I+8>>2]=c[z+8>>2];c[I+12>>2]=c[z+12>>2];break}else{ca=ea(ea(ea(-ea(Fa*Da))-ea(Ga*ba))-ea(Ea*Ca));Ca=ea(g[A>>2]);Ea=ea(g[A+4>>2]);ba=ea(g[A+8>>2]);Ga=ea(Qa-Ca);Da=ea(Ra-Ea);Fa=ea(Sa-ba);Aa=ea(g[B>>2]);za=ea(g[B+4>>2]);W=ea(g[B+8>>2]);da=ea(Ta-Aa);Pa=ea(Ua-za);Oa=ea(Va-W);Na=ea(ca/Ba);Ja=Na>ea(1.0);Ba=Ja?ea(1.0):Na;Ja=Ba>ea(0.0);Na=Ja?Ba:ea(0.0);Ba=ea(Ca+ea(Ga*Na));Ga=ea(Ea+ea(Da*Na));Da=ea(ba+ea(Fa*Na));Fa=ea(Aa+ea(da*Na));da=ea(za+ea(Pa*Na));Pa=ea(W+ea(Oa*Na));g[v>>2]=Ba;g[h>>2]=Ga;g[X>>2]=Da;g[Y>>2]=ea(0.0);g[w>>2]=Fa;g[Z>>2]=da;g[_>>2]=Pa;g[$>>2]=ea(0.0);Na=ea(Ga-da);da=ea(Da-Pa);g[I>>2]=ea(Ba-Fa);g[I+4>>2]=Na;g[I+8>>2]=da;g[I+12>>2]=ea(0.0);break}}else{c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}while(0);Va=ea(g[I>>2]);Ua=ea(g[I+4>>2]);Ta=ea(g[I+8>>2]);Sa=ea(ea(ea(Va*Va)+ea(Ua*Ua))+ea(Ta*Ta));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];Ra=ea(g[v>>2]);Qa=ea(g[h>>2]);Ya=ea(g[X>>2]);Xa=ea(g[Y>>2]);Wa=ea(g[w>>2]);da=ea(g[Z>>2]);Na=ea(g[_>>2]);ha=Xa;ia=Ya;ja=Qa;ka=Ra;la=ea(g[$>>2]);ma=Na;na=da;oa=Wa;pa=Sa;qa=Sa>V;ra=Ta;sa=Ua;ta=Va}do if(qa){I=f+4|0;F=f+8|0;aa=f+16|0;H=f+20|0;G=f+24|0;Ja=f+32|0;Ia=f+36|0;Ka=f+40|0;s=t+4|0;r=t+8|0;ga=t+12|0;ya=f+48|0;xa=f+52|0;wa=f+56|0;va=u+4|0;ua=u+8|0;fa=J+4|0;Ha=J+8|0;La=J+12|0;Ma=e+96|0;Za=e+96|0;_a=e+100|0;$a=e+104|0;ab=e+112|0;bb=e+112|0;cb=e+116|0;db=e+120|0;eb=K+4|0;fb=K+8|0;gb=K+12|0;hb=L+4|0;ib=L+8|0;jb=L+12|0;kb=b+48|0;lb=e+48|0;mb=N+4|0;nb=N+8|0;ob=z+4|0;pb=z+8|0;qb=A+4|0;rb=A+8|0;sb=B+4|0;tb=B+8|0;ub=N+12|0;vb=z+16|0;Va=S;Ua=ta;Ta=sa;Sa=ra;Wa=pa;da=ka;Na=ja;Ra=ia;Qa=ha;Ya=oa;Xa=na;Fa=ma;Ba=la;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Pa=ea(-Ua);Da=ea(-Ta);Ga=ea(-Sa);wb=c[E>>2]|0;xb=A+(wb<<4)|0;Oa=ea(ea(g[f>>2])*Pa);W=ea(Oa+ea(ea(g[I>>2])*Da));Oa=ea(W+ea(ea(g[F>>2])*Ga));W=ea(ea(g[aa>>2])*Pa);za=ea(W+ea(ea(g[H>>2])*Da));W=ea(za+ea(ea(g[G>>2])*Ga));za=ea(ea(g[Ja>>2])*Pa);Pa=ea(za+ea(ea(g[Ia>>2])*Da));Da=ea(Pa+ea(ea(g[Ka>>2])*Ga));g[t>>2]=Oa;g[s>>2]=W;g[r>>2]=Da;g[ga>>2]=ea(0.0);FFb(u,b,t,C+(wb<<2)|0);c[xb+0>>2]=c[u+0>>2];c[xb+4>>2]=c[u+4>>2];c[xb+8>>2]=c[u+8>>2];c[xb+12>>2]=c[u+12>>2];Da=ea(g[ya>>2]);W=ea(g[xa>>2]);Oa=ea(g[wa>>2]);Ga=ea(g[u>>2]);Pa=ea(g[va>>2]);za=ea(g[ua>>2]);Aa=ea(Ga*ea(g[f>>2]));ba=ea(Aa+ea(Pa*ea(g[aa>>2])));Aa=ea(ba+ea(za*ea(g[Ja>>2])));ba=ea(Ga*ea(g[I>>2]));Ea=ea(ba+ea(Pa*ea(g[H>>2])));ba=ea(Ea+ea(za*ea(g[Ia>>2])));Ea=ea(Ga*ea(g[F>>2]));Ga=ea(Ea+ea(Pa*ea(g[G>>2])));Pa=ea(Da+Aa);Aa=ea(W+ba);ba=ea(Oa+ea(Ga+ea(za*ea(g[Ka>>2]))));g[J>>2]=Pa;g[fa>>2]=Aa;g[Ha>>2]=ba;g[La>>2]=ea(0.0);yb=c[E>>2]|0;xb=B+(yb<<4)|0;za=ea(g[Za>>2]);Ga=ea(g[_a>>2]);Oa=ea(ea(ea(Ua*za)+ea(Ta*Ga))+ea(Sa*ea(g[$a>>2])));Ga=ea(g[bb>>2]);za=ea(g[cb>>2]);wb=Oa>ea(ea(ea(Ua*Ga)+ea(Ta*za))+ea(Sa*ea(g[db>>2])));c[D+(yb<<2)>>2]=wb&1;c[u+0>>2]=c[Ma+0>>2];c[u+4>>2]=c[Ma+4>>2];c[u+8>>2]=c[Ma+8>>2];c[u+12>>2]=c[Ma+12>>2];c[t+0>>2]=c[ab+0>>2];c[t+4>>2]=c[ab+4>>2];c[t+8>>2]=c[ab+8>>2];c[t+12>>2]=c[ab+12>>2];zb=wb?u:t;za=ea(g[zb>>2]);Ga=ea(g[zb+4>>2]);Oa=ea(g[zb+8>>2]);g[K>>2]=za;g[eb>>2]=Ga;g[fb>>2]=Oa;g[gb>>2]=ea(0.0);c[xb+0>>2]=c[K+0>>2];c[xb+4>>2]=c[K+4>>2];c[xb+8>>2]=c[K+8>>2];c[xb+12>>2]=c[K+12>>2];W=ea(Pa-za);Da=ea(Aa-Ga);Ea=ea(ba-Oa);g[L>>2]=W;g[hb>>2]=Da;g[ib>>2]=Ea;g[jb>>2]=ea(0.0);c[E>>2]=yb+1;xb=z+(yb<<4)|0;c[xb+0>>2]=c[L+0>>2];c[xb+4>>2]=c[L+4>>2];c[xb+8>>2]=c[L+8>>2];c[xb+12>>2]=c[L+12>>2];Ca=ea(g[kb>>2]);ca=ea(g[lb>>2]);Ab=Ca>ca?Ca:ca;ca=Va>Ab?Va:Ab;Ab=ea(U+ca);Ca=ea(ea(ea(Ua*W)+ea(Ta*Da))+ea(Sa*Ea));xb=ea(Ca*Ca)>ea(Wa*ea(Ab*Ab));if(Ca>ea(0.0)){Bb=xb;Cb=xb^1}else{Bb=0;Cb=1}xb=ea(V*Wa)>=ea(Wa-Ca);if((xb|Bb)&(xb|Cb^1))break;do if((yb|0)==1){Ca=ea(g[z>>2]);Ab=ea(g[ob>>2]);Db=ea(g[pb>>2]);Eb=ea(W-Ca);Fb=ea(Da-Ab);Gb=ea(Ea-Db);Hb=ea(ea(ea(Eb*Eb)+ea(Fb*Fb))+ea(Gb*Gb));if(Hb==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[N+0>>2]=c[z+0>>2];c[N+4>>2]=c[z+4>>2];c[N+8>>2]=c[z+8>>2];c[N+12>>2]=c[z+12>>2];break}else{Ib=ea(ea(ea(-ea(Ab*Fb))-ea(Ca*Eb))-ea(Db*Gb));Gb=ea(g[A>>2]);Db=ea(g[qb>>2]);Eb=ea(g[rb>>2]);Ca=ea(Pa-Gb);Fb=ea(Aa-Db);Ab=ea(ba-Eb);Jb=ea(g[B>>2]);Kb=ea(g[sb>>2]);Lb=ea(g[tb>>2]);Mb=ea(za-Jb);Nb=ea(Ga-Kb);Ob=ea(Oa-Lb);Pb=ea(Ib/Hb);xb=Pb>ea(1.0);Hb=xb?ea(1.0):Pb;xb=Hb>ea(0.0);Pb=xb?Hb:ea(0.0);Hb=ea(Gb+ea(Ca*Pb));Ca=ea(Db+ea(Fb*Pb));Fb=ea(Eb+ea(Ab*Pb));Ab=ea(Jb+ea(Mb*Pb));Mb=ea(Kb+ea(Nb*Pb));Nb=ea(Lb+ea(Ob*Pb));g[v>>2]=Hb;g[h>>2]=Ca;g[X>>2]=Fb;g[Y>>2]=ea(0.0);g[w>>2]=Ab;g[Z>>2]=Mb;g[_>>2]=Nb;g[$>>2]=ea(0.0);Pb=ea(Ca-Mb);Mb=ea(Fb-Nb);g[N>>2]=ea(Hb-Ab);g[mb>>2]=Pb;g[nb>>2]=Mb;g[ub>>2]=ea(0.0);break}}else if(!yb){c[v+0>>2]=c[J+0>>2];c[v+4>>2]=c[J+4>>2];c[v+8>>2]=c[J+8>>2];c[v+12>>2]=c[J+12>>2];c[w+0>>2]=c[K+0>>2];c[w+4>>2]=c[K+4>>2];c[w+8>>2]=c[K+8>>2];c[w+12>>2]=c[K+12>>2];c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}else if((yb|0)==2)V6a(N,z,vb,L,z,A,B,E,v,w);else if((yb|0)==3)qPa(N,z,A,B,C,D,L,J,K,E,v,w);else{c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}while(0);Oa=ea(g[N>>2]);Ga=ea(g[mb>>2]);za=ea(g[nb>>2]);ba=ea(ea(ea(Oa*Oa)+ea(Ga*Ga))+ea(za*za));c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];Qb=Wa>ba;if(ba>V^1|Qb^1){Rb=35;break}Aa=ea(g[v>>2]);Pa=ea(g[h>>2]);Ea=ea(g[X>>2]);Da=ea(g[Y>>2]);W=ea(g[w>>2]);Mb=ea(g[Z>>2]);Pb=ea(g[_>>2]);Va=ca;Ua=Oa;Ta=Ga;Sa=za;Wa=ba;da=Aa;Na=Pa;Ra=Ea;Qa=Da;Ya=W;Xa=Mb;Fa=Pb;Ba=ea(g[$>>2])}if((Rb|0)==35){nb=c[E>>2]|0;if(Qb){Sb=nb;break}mb=nb+-1|0;if((n|0)!=0?(a[p>>0]=mb,(mb|0)!=0):0){nb=0;do{a[n+nb>>0]=c[C+(nb<<2)>>2];a[o+nb>>0]=c[D+(nb<<2)>>2];nb=nb+1|0}while((nb|0)!=(mb|0))}g[v>>2]=da;g[h>>2]=Na;g[X>>2]=Ra;g[Y>>2]=Qa;g[w>>2]=Ya;g[Z>>2]=Xa;g[_>>2]=Fa;g[$>>2]=Ba;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];Va=ea(T(ea(Wa)));Pb=ea(ea(1.0)/Va);Mb=ea(ea(da-Ya)*Pb);W=ea(ea(Na-Xa)*Pb);Da=ea(ea(Ra-Fa)*Pb);Pb=ea(Na-ea(Q*W));Ea=ea(Ra-ea(Q*Da));g[j>>2]=ea(da-ea(Q*Mb));g[j+4>>2]=Pb;g[j+8>>2]=Ea;g[j+12>>2]=ea(0.0);Ea=ea(ea(R*W)+Xa);Pb=ea(ea(R*Da)+Fa);g[k>>2]=ea(ea(R*Mb)+Ya);g[k+4>>2]=Ea;g[k+8>>2]=Pb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(Va-U);mb=m+4|0;c[mb+0>>2]=c[P+0>>2];c[mb+4>>2]=c[P+4>>2];c[mb+8>>2]=c[P+8>>2];g[l>>2]=Mb;g[l+4>>2]=W;g[l+8>>2]=Da;g[l+12>>2]=ea(0.0);Tb=3;i=q;return Tb|0}if((n|0)!=0?(a[p>>0]=yb,(yb|0)!=0):0){mb=0;do{a[n+mb>>0]=c[C+(mb<<2)>>2];a[o+mb>>0]=c[D+(mb<<2)>>2];mb=mb+1|0}while((mb|0)!=(yb|0))}if(!(Cb&(Bb^1))){Tb=0;i=q;return Tb|0}Ya=ea(T(ea(Wa)));Fa=ea(ea(1.0)/Ya);Xa=ea(Ua*Fa);da=ea(Ta*Fa);Ra=ea(Sa*Fa);Fa=ea(g[v>>2]);Na=ea(g[h>>2]);Ba=ea(Na-ea(Q*da));Na=ea(ea(g[X>>2])-ea(Q*Ra));g[j>>2]=ea(Fa-ea(Q*Xa));g[j+4>>2]=Ba;g[j+8>>2]=Na;g[j+12>>2]=ea(0.0);Na=ea(g[w>>2]);Ba=ea(g[Z>>2]);Fa=ea(ea(R*da)+Ba);Ba=ea(ea(R*Ra)+ea(g[_>>2]));g[k>>2]=ea(ea(R*Xa)+Na);g[k+4>>2]=Fa;g[k+8>>2]=Ba;g[k+12>>2]=ea(0.0);g[m>>2]=ea(Ya-U);mb=m+4|0;c[mb+0>>2]=c[M+0>>2];c[mb+4>>2]=c[M+4>>2];c[mb+8>>2]=c[M+8>>2];g[l>>2]=Xa;g[l+4>>2]=da;g[l+8>>2]=Ra;g[l+12>>2]=ea(0.0);Tb=1;i=q;return Tb|0}else Sb=c[E>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Sb,(Sb|0)!=0):0){p=0;do{a[n+p>>0]=c[C+(p<<2)>>2];a[o+p>>0]=c[D+(p<<2)>>2];p=p+1|0}while((p|0)!=(Sb|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Tb=6;i=q;return Tb|0}function l7a(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=0,Vb=0,Wb=0,Xb=0;q=i;i=i+528|0;r=q+272|0;s=q+400|0;t=q+304|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+416|0;y=q+440|0;z=q+336|0;A=q+128|0;B=q+192|0;C=q+456|0;D=q+472|0;E=q+488|0;F=q+256|0;G=q+80|0;H=q+112|0;I=q+16|0;J=q;K=q+32|0;L=q+320|0;M=q+428|0;N=q+288|0;O=q+492|0;P=q+504|0;Q=ea(g[b+16>>2]);R=ea(g[e+16>>2]);S=ea(g[h>>2]);U=ea(g[b+32>>2]);V=ea(g[e+32>>2]);W=ea((U>V?V:U)*ea(.100000001));U=ea(Q+R);h=v+4|0;X=v+8|0;Y=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;Z=w+4|0;_=w+8|0;$=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];V=ea(W*W);c[E>>2]=0;aa=a[p>>0]|0;if(!(aa<<24>>24)){W=ea(g[f+48>>2]);ba=ea(g[f+52>>2]);ca=ea(g[f+56>>2]);da=ea(g[f+60>>2]);fa=ea(ea(ea(W*W)+ea(ba*ba))+ea(ca*ca))>ea(0.0);g[s>>2]=W;g[s+4>>2]=ba;g[s+8>>2]=ca;g[s+12>>2]=da;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ga=fa?s:r;da=ea(g[ga>>2]);ca=ea(g[ga+4>>2]);ha=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(3402823469999999843913219.0e14);qa=1;ra=ea(g[ga+8>>2]);sa=ca;ta=da}else{ga=F+4|0;r=F+8|0;s=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;fa=G+4|0;ua=G+8|0;va=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;wa=H+4|0;xa=H+8|0;ya=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;za=b+96|0;da=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);ba=ea(g[f+56>>2]);W=ea(g[f>>2]);Aa=ea(g[f+16>>2]);Ba=ea(g[f+32>>2]);Ca=ea(g[f+4>>2]);Da=ea(g[f+20>>2]);Ea=ea(g[f+36>>2]);Fa=ea(g[f+8>>2]);Ga=ea(g[f+24>>2]);Ha=ea(g[f+40>>2]);Ia=e+96|0;Ja=aa&255;aa=Ja>>>0>1?Ja:1;Ka=0;La=0;while(1){Ma=d[n+La>>0]|0;c[C+(La<<2)>>2]=Ma;Na=d[o+La>>0]|0;c[D+(La<<2)>>2]=Na;Oa=1-Ma|0;Pa=ea(g[za+(Oa<<4)>>2]);Qa=ea(g[za+(Oa<<4)+4>>2]);Ra=ea(g[za+(Oa<<4)+8>>2]);Sa=ea(da+ea(ea(ea(Pa*W)+ea(Qa*Aa))+ea(Ra*Ba)));Ta=ea(ca+ea(ea(ea(Pa*Ca)+ea(Qa*Da))+ea(Ra*Ea)));Ua=ea(ba+ea(ea(ea(Pa*Fa)+ea(Qa*Ga))+ea(Ra*Ha)));Oa=1-Na|0;Va=ea(g[Ia+(Oa<<4)>>2]);Wa=ea(g[Ia+(Oa<<4)+4>>2]);Xa=ea(g[Ia+(Oa<<4)+8>>2]);Ra=ea(g[Ia+(Oa<<4)+12>>2]);Ya=ea(Sa-Va);Za=ea(Ta-Wa);_a=ea(Ua-Xa);Oa=A+(Ka<<4)|0;g[G>>2]=Sa;g[fa>>2]=Ta;g[ua>>2]=Ua;g[va>>2]=ea(0.0);c[Oa+0>>2]=c[G+0>>2];c[Oa+4>>2]=c[G+4>>2];c[Oa+8>>2]=c[G+8>>2];c[Oa+12>>2]=c[G+12>>2];Oa=B+(Ka<<4)|0;g[H>>2]=Va;g[wa>>2]=Wa;g[xa>>2]=Xa;g[ya>>2]=Ra;c[Oa+0>>2]=c[H+0>>2];c[Oa+4>>2]=c[H+4>>2];c[Oa+8>>2]=c[H+8>>2];c[Oa+12>>2]=c[H+12>>2];Oa=z+(Ka<<4)|0;g[F>>2]=Ya;g[ga>>2]=Za;g[r>>2]=_a;g[s>>2]=ea(0.0);c[Oa+0>>2]=c[F+0>>2];c[Oa+4>>2]=c[F+4>>2];c[Oa+8>>2]=c[F+8>>2];c[Oa+12>>2]=c[F+12>>2];La=La+1|0;if(La>>>0>=Ja>>>0)break;else Ka=Ka+1|0}c[E>>2]=aa;do if((aa|0)==2){Ha=ea(g[z>>2]);Ga=ea(g[z+4>>2]);Fa=ea(g[z+8>>2]);ba=ea(Ya-Ha);Ea=ea(Za-Ga);Da=ea(_a-Fa);Ca=ea(ea(ea(ba*ba)+ea(Ea*Ea))+ea(Da*Da));if(Ca==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[I+0>>2]=c[z+0>>2];c[I+4>>2]=c[z+4>>2];c[I+8>>2]=c[z+8>>2];c[I+12>>2]=c[z+12>>2];break}else{ca=ea(ea(ea(-ea(Ga*Ea))-ea(Ha*ba))-ea(Fa*Da));Da=ea(g[A>>2]);Fa=ea(g[A+4>>2]);ba=ea(g[A+8>>2]);Ha=ea(Sa-Da);Ea=ea(Ta-Fa);Ga=ea(Ua-ba);Ba=ea(g[B>>2]);Aa=ea(g[B+4>>2]);W=ea(g[B+8>>2]);da=ea(Va-Ba);Ra=ea(Wa-Aa);Qa=ea(Xa-W);Pa=ea(ca/Ca);Ka=Pa>ea(1.0);Ca=Ka?ea(1.0):Pa;Ka=Ca>ea(0.0);Pa=Ka?Ca:ea(0.0);Ca=ea(Da+ea(Ha*Pa));Ha=ea(Fa+ea(Ea*Pa));Ea=ea(ba+ea(Ga*Pa));Ga=ea(Ba+ea(da*Pa));da=ea(Aa+ea(Ra*Pa));Ra=ea(W+ea(Qa*Pa));g[v>>2]=Ca;g[h>>2]=Ha;g[X>>2]=Ea;g[Y>>2]=ea(0.0);g[w>>2]=Ga;g[Z>>2]=da;g[_>>2]=Ra;g[$>>2]=ea(0.0);Pa=ea(Ha-da);da=ea(Ea-Ra);g[I>>2]=ea(Ca-Ga);g[I+4>>2]=Pa;g[I+8>>2]=da;g[I+12>>2]=ea(0.0);break}}else if((aa|0)==4)qPa(I,z,A,B,C,D,F,G,H,E,v,w);else if((aa|0)==3)V6a(I,z,z+16|0,F,z,A,B,E,v,w);else if((aa|0)==1){c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}else{c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}while(0);Xa=ea(g[I>>2]);Wa=ea(g[I+4>>2]);Va=ea(g[I+8>>2]);Ua=ea(ea(ea(Xa*Xa)+ea(Wa*Wa))+ea(Va*Va));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];Ta=ea(g[v>>2]);Sa=ea(g[h>>2]);_a=ea(g[X>>2]);Za=ea(g[Y>>2]);Ya=ea(g[w>>2]);da=ea(g[Z>>2]);Pa=ea(g[_>>2]);ha=Za;ia=_a;ja=Sa;ka=Ta;la=ea(g[$>>2]);ma=Pa;na=da;oa=Ya;pa=Ua;qa=Ua>V;ra=Va;sa=Wa;ta=Xa}do if(qa){I=f+4|0;F=f+8|0;H=f+16|0;G=f+20|0;aa=f+24|0;Ka=f+32|0;Ja=f+36|0;La=f+40|0;s=b+96|0;r=b+96|0;ga=b+100|0;ya=b+104|0;xa=b+112|0;wa=b+112|0;va=b+116|0;ua=b+120|0;fa=f+48|0;Ia=f+52|0;za=f+56|0;Oa=J+4|0;Na=J+8|0;Ma=J+12|0;$a=e+96|0;ab=e+96|0;bb=e+100|0;cb=e+104|0;db=e+112|0;eb=e+112|0;fb=e+116|0;gb=e+120|0;hb=K+4|0;ib=K+8|0;jb=K+12|0;kb=L+4|0;lb=L+8|0;mb=L+12|0;nb=b+48|0;ob=e+48|0;pb=N+4|0;qb=N+8|0;rb=z+4|0;sb=z+8|0;tb=A+4|0;ub=A+8|0;vb=B+4|0;wb=B+8|0;xb=N+12|0;yb=z+16|0;Xa=S;Wa=ta;Va=sa;Ua=ra;Ya=pa;da=ka;Pa=ja;Ta=ia;Sa=ha;_a=oa;Za=na;Ga=ma;Ca=la;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Ra=ea(-Wa);Ea=ea(-Va);Ha=ea(-Ua);zb=c[E>>2]|0;Ab=A+(zb<<4)|0;Qa=ea(g[f>>2]);W=ea(Qa*Ra);Aa=ea(g[I>>2]);Ba=ea(W+ea(Aa*Ea));W=ea(g[F>>2]);ba=ea(Ba+ea(W*Ha));Ba=ea(g[H>>2]);Fa=ea(Ba*Ra);Da=ea(g[G>>2]);ca=ea(Fa+ea(Da*Ea));Fa=ea(g[aa>>2]);Bb=ea(ca+ea(Fa*Ha));ca=ea(g[Ka>>2]);Cb=ea(ca*Ra);Ra=ea(g[Ja>>2]);Db=ea(Cb+ea(Ra*Ea));Ea=ea(g[La>>2]);Cb=ea(Db+ea(Ea*Ha));Ha=ea(g[r>>2]);Db=ea(g[ga>>2]);Eb=ea(ea(ea(ba*Ha)+ea(Bb*Db))+ea(Cb*ea(g[ya>>2])));Db=ea(g[wa>>2]);Ha=ea(g[va>>2]);Fb=Eb>ea(ea(ea(ba*Db)+ea(Bb*Ha))+ea(Cb*ea(g[ua>>2])));c[C+(zb<<2)>>2]=Fb&1;c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];c[u+12>>2]=c[s+12>>2];c[t+0>>2]=c[xa+0>>2];c[t+4>>2]=c[xa+4>>2];c[t+8>>2]=c[xa+8>>2];c[t+12>>2]=c[xa+12>>2];Gb=Fb?u:t;Cb=ea(g[Gb>>2]);Ha=ea(g[Gb+4>>2]);Bb=ea(g[Gb+8>>2]);Db=ea(g[fa>>2]);ba=ea(g[Ia>>2]);Eb=ea(ea(ea(ea(Qa*Cb)+ea(Ba*Ha))+ea(ca*Bb))+Db);Db=ea(ea(ea(ea(Aa*Cb)+ea(Da*Ha))+ea(Ra*Bb))+ba);ba=ea(ea(ea(ea(W*Cb)+ea(Fa*Ha))+ea(Ea*Bb))+ea(g[za>>2]));g[J>>2]=Eb;g[Oa>>2]=Db;g[Na>>2]=ba;g[Ma>>2]=ea(0.0);c[Ab+0>>2]=c[J+0>>2];c[Ab+4>>2]=c[J+4>>2];c[Ab+8>>2]=c[J+8>>2];c[Ab+12>>2]=c[J+12>>2];Ab=B+(zb<<4)|0;Bb=ea(g[ab>>2]);Ea=ea(g[bb>>2]);Ha=ea(ea(ea(Wa*Bb)+ea(Va*Ea))+ea(Ua*ea(g[cb>>2])));Ea=ea(g[eb>>2]);Bb=ea(g[fb>>2]);Gb=Ha>ea(ea(ea(Wa*Ea)+ea(Va*Bb))+ea(Ua*ea(g[gb>>2])));c[D+(zb<<2)>>2]=Gb&1;c[u+0>>2]=c[$a+0>>2];c[u+4>>2]=c[$a+4>>2];c[u+8>>2]=c[$a+8>>2];c[u+12>>2]=c[$a+12>>2];c[t+0>>2]=c[db+0>>2];c[t+4>>2]=c[db+4>>2];c[t+8>>2]=c[db+8>>2];c[t+12>>2]=c[db+12>>2];zb=Gb?u:t;Bb=ea(g[zb>>2]);Ea=ea(g[zb+4>>2]);Ha=ea(g[zb+8>>2]);g[K>>2]=Bb;g[hb>>2]=Ea;g[ib>>2]=Ha;g[jb>>2]=ea(0.0);c[Ab+0>>2]=c[K+0>>2];c[Ab+4>>2]=c[K+4>>2];c[Ab+8>>2]=c[K+8>>2];c[Ab+12>>2]=c[K+12>>2];Fa=ea(Eb-Bb);Cb=ea(Db-Ea);W=ea(ba-Ha);g[L>>2]=Fa;g[kb>>2]=Cb;g[lb>>2]=W;g[mb>>2]=ea(0.0);Hb=c[E>>2]|0;c[E>>2]=Hb+1;Ab=z+(Hb<<4)|0;c[Ab+0>>2]=c[L+0>>2];c[Ab+4>>2]=c[L+4>>2];c[Ab+8>>2]=c[L+8>>2];c[Ab+12>>2]=c[L+12>>2];Ra=ea(g[nb>>2]);Da=ea(g[ob>>2]);Aa=Ra>Da?Ra:Da;Da=Xa>Aa?Xa:Aa;Aa=ea(U+Da);Ra=ea(ea(ea(Wa*Fa)+ea(Va*Cb))+ea(Ua*W));Ab=ea(Ra*Ra)>ea(Ya*ea(Aa*Aa));if(Ra>ea(0.0)){Ib=Ab;Jb=Ab^1}else{Ib=0;Jb=1}Ab=ea(V*Ya)>=ea(Ya-Ra);if((Ab|Ib)&(Ab|Jb^1))break;do if((Hb|0)==3)qPa(N,z,A,B,C,D,L,J,K,E,v,w);else if((Hb|0)==2)V6a(N,z,yb,L,z,A,B,E,v,w);else if(!Hb){c[v+0>>2]=c[J+0>>2];c[v+4>>2]=c[J+4>>2];c[v+8>>2]=c[J+8>>2];c[v+12>>2]=c[J+12>>2];c[w+0>>2]=c[K+0>>2];c[w+4>>2]=c[K+4>>2];c[w+8>>2]=c[K+8>>2];c[w+12>>2]=c[K+12>>2];c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}else if((Hb|0)==1){Ra=ea(g[z>>2]);Aa=ea(g[rb>>2]);ca=ea(g[sb>>2]);Ba=ea(Fa-Ra);Qa=ea(Cb-Aa);Kb=ea(W-ca);Lb=ea(ea(ea(Ba*Ba)+ea(Qa*Qa))+ea(Kb*Kb));if(Lb==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[N+0>>2]=c[z+0>>2];c[N+4>>2]=c[z+4>>2];c[N+8>>2]=c[z+8>>2];c[N+12>>2]=c[z+12>>2];break}else{Mb=ea(ea(ea(-ea(Aa*Qa))-ea(Ra*Ba))-ea(ca*Kb));Kb=ea(g[A>>2]);ca=ea(g[tb>>2]);Ba=ea(g[ub>>2]);Ra=ea(Eb-Kb);Qa=ea(Db-ca);Aa=ea(ba-Ba);Nb=ea(g[B>>2]);Ob=ea(g[vb>>2]);Pb=ea(g[wb>>2]);Qb=ea(Bb-Nb);Rb=ea(Ea-Ob);Sb=ea(Ha-Pb);Tb=ea(Mb/Lb);Ab=Tb>ea(1.0);Lb=Ab?ea(1.0):Tb;Ab=Lb>ea(0.0);Tb=Ab?Lb:ea(0.0);Lb=ea(Kb+ea(Ra*Tb));Ra=ea(ca+ea(Qa*Tb));Qa=ea(Ba+ea(Aa*Tb));Aa=ea(Nb+ea(Qb*Tb));Qb=ea(Ob+ea(Rb*Tb));Rb=ea(Pb+ea(Sb*Tb));g[v>>2]=Lb;g[h>>2]=Ra;g[X>>2]=Qa;g[Y>>2]=ea(0.0);g[w>>2]=Aa;g[Z>>2]=Qb;g[_>>2]=Rb;g[$>>2]=ea(0.0);Tb=ea(Ra-Qb);Qb=ea(Qa-Rb);g[N>>2]=ea(Lb-Aa);g[pb>>2]=Tb;g[qb>>2]=Qb;g[xb>>2]=ea(0.0);break}}else{c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}while(0);Ha=ea(g[N>>2]);Ea=ea(g[pb>>2]);Bb=ea(g[qb>>2]);ba=ea(ea(ea(Ha*Ha)+ea(Ea*Ea))+ea(Bb*Bb));c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];Ub=Ya>ba;if(ba>V^1|Ub^1){Vb=35;break}Db=ea(g[v>>2]);Eb=ea(g[h>>2]);W=ea(g[X>>2]);Cb=ea(g[Y>>2]);Fa=ea(g[w>>2]);Qb=ea(g[Z>>2]);Tb=ea(g[_>>2]);Xa=Da;Wa=Ha;Va=Ea;Ua=Bb;Ya=ba;da=Db;Pa=Eb;Ta=W;Sa=Cb;_a=Fa;Za=Qb;Ga=Tb;Ca=ea(g[$>>2])}if((Vb|0)==35){qb=c[E>>2]|0;if(Ub){Wb=qb;break}pb=qb+-1|0;if((n|0)!=0?(a[p>>0]=pb,(pb|0)!=0):0){qb=0;do{a[n+qb>>0]=c[C+(qb<<2)>>2];a[o+qb>>0]=c[D+(qb<<2)>>2];qb=qb+1|0}while((qb|0)!=(pb|0))}g[v>>2]=da;g[h>>2]=Pa;g[X>>2]=Ta;g[Y>>2]=Sa;g[w>>2]=_a;g[Z>>2]=Za;g[_>>2]=Ga;g[$>>2]=Ca;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];Xa=ea(T(ea(Ya)));Tb=ea(ea(1.0)/Xa);Qb=ea(ea(da-_a)*Tb);Fa=ea(ea(Pa-Za)*Tb);Cb=ea(ea(Ta-Ga)*Tb);Tb=ea(Pa-ea(Q*Fa));W=ea(Ta-ea(Q*Cb));g[j>>2]=ea(da-ea(Q*Qb));g[j+4>>2]=Tb;g[j+8>>2]=W;g[j+12>>2]=ea(0.0);W=ea(ea(R*Fa)+Za);Tb=ea(ea(R*Cb)+Ga);g[k>>2]=ea(ea(R*Qb)+_a);g[k+4>>2]=W;g[k+8>>2]=Tb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(Xa-U);pb=m+4|0;c[pb+0>>2]=c[P+0>>2];c[pb+4>>2]=c[P+4>>2];c[pb+8>>2]=c[P+8>>2];g[l>>2]=Qb;g[l+4>>2]=Fa;g[l+8>>2]=Cb;g[l+12>>2]=ea(0.0);Xb=3;i=q;return Xb|0}if((n|0)!=0?(a[p>>0]=Hb,(Hb|0)!=0):0){pb=0;do{a[n+pb>>0]=c[C+(pb<<2)>>2];a[o+pb>>0]=c[D+(pb<<2)>>2];pb=pb+1|0}while((pb|0)!=(Hb|0))}if(!(Jb&(Ib^1))){Xb=0;i=q;return Xb|0}_a=ea(T(ea(Ya)));Ga=ea(ea(1.0)/_a);Za=ea(Wa*Ga);da=ea(Va*Ga);Ta=ea(Ua*Ga);Ga=ea(g[v>>2]);Pa=ea(g[h>>2]);Ca=ea(Pa-ea(Q*da));Pa=ea(ea(g[X>>2])-ea(Q*Ta));g[j>>2]=ea(Ga-ea(Q*Za));g[j+4>>2]=Ca;g[j+8>>2]=Pa;g[j+12>>2]=ea(0.0);Pa=ea(g[w>>2]);Ca=ea(g[Z>>2]);Ga=ea(ea(R*da)+Ca);Ca=ea(ea(R*Ta)+ea(g[_>>2]));g[k>>2]=ea(ea(R*Za)+Pa);g[k+4>>2]=Ga;g[k+8>>2]=Ca;g[k+12>>2]=ea(0.0);g[m>>2]=ea(_a-U);pb=m+4|0;c[pb+0>>2]=c[M+0>>2];c[pb+4>>2]=c[M+4>>2];c[pb+8>>2]=c[M+8>>2];g[l>>2]=Za;g[l+4>>2]=da;g[l+8>>2]=Ta;g[l+12>>2]=ea(0.0);Xb=1;i=q;return Xb|0}else Wb=c[E>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Wb,(Wb|0)!=0):0){p=0;do{a[n+p>>0]=c[C+(p<<2)>>2];a[o+p>>0]=c[D+(p<<2)>>2];p=p+1|0}while((p|0)!=(Wb|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Xb=6;i=q;return Xb|0}function m7a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im;k=i;i=i+272|0;l=k+176|0;m=k;n=k+64|0;o=k+144|0;p=k+128|0;q=k+160|0;r=k+48|0;s=k+96|0;t=k+80|0;u=k+32|0;v=k+16|0;w=k+112|0;x=k+252|0;y=k+240|0;z=k+228|0;A=k+216|0;B=k+204|0;C=k+192|0;c[f>>2]=3;D=ea(g[d>>2]);E=ea(g[d+4>>2]);F=ea(g[d+8>>2]);G=ea(g[b>>2]);f=b+4|0;H=ea(g[f>>2]);I=b+8|0;J=ea(g[I>>2]);K=ea(D-G);L=ea(E-H);M=ea(F-J);N=ea(g[e>>2]);O=ea(g[e+4>>2]);P=ea(g[e+8>>2]);Q=ea(N-G);R=ea(O-H);S=ea(P-J);T=ea(-G);G=ea(-H);H=ea(-J);J=ea(-D);D=ea(-E);E=ea(-F);F=ea(-N);N=ea(-O);O=ea(-P);P=ea(ea(ea(K*T)+ea(L*G))+ea(M*H));U=ea(ea(ea(Q*T)+ea(R*G))+ea(S*H));H=ea(ea(ea(K*J)+ea(L*D))+ea(M*E));G=ea(ea(ea(Q*J)+ea(R*D))+ea(S*E));E=ea(ea(ea(K*F)+ea(L*N))+ea(M*O));D=ea(ea(ea(Q*F)+ea(R*N))+ea(S*O));O=ea(G-H);N=ea(E-D);V=!(P<=ea(0.0));W=U<=ea(0.0);X=!(H>=ea(0.0));Y=H>=G;Z=!(D>=ea(0.0));_=D>=E;$=V?0:W<<31>>31;if(X){aa=1;ba=0}else{aa=Y^1;ba=Y}Y=_&(Z^1);X=($|0)==0;ca=($|0)==0;da=($|0)==0;$=Z|_^1;if(!(X&(aa&$)|ca&(aa&$))?(Y|aa^1|da^1)&(Y|ba|W&(V^1)):0){g[h>>2]=aa?ea(0.0):ea(1.0);V=h+4|0;c[V+0>>2]=c[x+0>>2];c[V+4>>2]=c[x+4>>2];c[V+8>>2]=c[x+8>>2];g[j>>2]=$?ea(0.0):ea(1.0);$=j+4|0;c[$+0>>2]=c[y+0>>2];c[$+4>>2]=c[y+4>>2];c[$+8>>2]=c[y+8>>2];c[o+0>>2]=c[b+0>>2];c[o+4>>2]=c[b+4>>2];c[o+8>>2]=c[b+8>>2];c[o+12>>2]=c[b+12>>2];c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];F=ea(g[(aa?l:m)>>2]);J=ea(g[(aa?l:m)+4>>2]);T=ea(g[(aa?l:m)+8>>2]);g[n>>2]=F;g[n+4>>2]=J;g[n+8>>2]=T;g[n+12>>2]=ea(0.0);T=ea(g[(X?n:o)>>2]);J=ea(g[(ca?n:o)+4>>2]);F=ea(g[(da?n:o)+8>>2]);g[a>>2]=T;g[a+4>>2]=J;g[a+8>>2]=F;g[a+12>>2]=ea(0.0);i=k;return}F=ea(ea(H*D)-ea(E*G));J=ea(ea(E*U)-ea(P*D));T=ea(ea(P*G)-ea(H*U));o=!(T<=ea(0.0));n=!(F<=ea(0.0));da=E>=D;ca=D<=ea(0.0);if(!(P>=ea(0.0)))fa=0;else fa=H<=ea(0.0);X=o?0:fa<<31>>31;m=G>=H;if(n){ga=1;ha=0}else{ga=da&m^1;ha=da&m}m=ca&U>=ea(0.0)&J<=ea(0.0);ca=(X|0)==0;da=(X|0)==0;n=(X|0)==0;G=ea(P-H);H=ea(O+N);N=ea(U-D);D=ea(F+ea(J+T));F=ea(-G);E=ea(-H);ia=ea(-N);ja=ea(-D);X=(G>F?G:F)>ea(1.1920929e-07);l=(H>E?H:E)>ea(1.1920929e-07);aa=(N>ia?N:ia)>ea(1.1920929e-07);y=(D>ja?D:ja)>ea(1.1920929e-07);ja=ea(ea(1.0)/H);H=ea(ea(1.0)/N);N=ea(ea(1.0)/D);g[q>>2]=ea(ea(1.0)/G);g[q+4>>2]=ja;g[q+8>>2]=H;g[q+12>>2]=N;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;N=ea(g[(X?q:p)>>2]);H=ea(g[(l?q:p)+4>>2]);ja=ea(g[(aa?q:p)+8>>2]);G=ea(g[(y?q:p)+12>>2]);p=m^1;if(!(ca&(ga&p)|da&(ga&p))?(m|ga^1|n^1)&(m|ha|fa&(o^1)):0){D=ea(P*N);N=ea(O*H);H=ea(U*ja);c[s+0>>2]=c[d+0>>2];c[s+4>>2]=c[d+4>>2];c[s+8>>2]=c[d+8>>2];c[s+12>>2]=c[d+12>>2];c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];ja=ea(g[(ca?r:s)>>2]);U=ea(g[(da?r:s)+4>>2]);O=ea(g[(n?r:s)+8>>2]);c[w+0>>2]=c[b+0>>2];c[w+4>>2]=c[b+4>>2];c[w+8>>2]=c[b+8>>2];c[w+12>>2]=c[b+12>>2];c[u+0>>2]=c[d+0>>2];c[u+4>>2]=c[d+4>>2];c[u+8>>2]=c[d+8>>2];c[u+12>>2]=c[d+12>>2];c[t+0>>2]=c[b+0>>2];c[t+4>>2]=c[b+4>>2];c[t+8>>2]=c[b+8>>2];c[t+12>>2]=c[b+12>>2];P=ea(g[(ga?t:u)>>2]);ia=ea(g[(ga?t:u)+4>>2]);E=ea(g[(ga?t:u)+8>>2]);g[v>>2]=P;g[v+4>>2]=ia;g[v+8>>2]=E;g[v+12>>2]=ea(0.0);E=ea(g[(ca?v:w)>>2]);ia=ea(g[(da?v:w)+4>>2]);P=ea(g[(n?v:w)+8>>2]);F=ea(ja-E);ja=ea(U-ia);U=ea(O-P);O=ga?H:N;H=ca?O:D;ka=ea(ea(1.0)-N);N=ga?ea(0.0):ka;g[h>>2]=ca?N:D;ga=h+4|0;c[ga+0>>2]=c[z+0>>2];c[ga+4>>2]=c[z+4>>2];c[ga+8>>2]=c[z+8>>2];g[j>>2]=ca?O:ea(0.0);ca=j+4|0;c[ca+0>>2]=c[A+0>>2];c[ca+4>>2]=c[A+4>>2];c[ca+8>>2]=c[A+8>>2];O=ea(ia+ea(H*ja));ja=ea(P+ea(H*U));g[a>>2]=ea(E+ea(H*F));g[a+4>>2]=O;g[a+8>>2]=ja;g[a+12>>2]=ea(0.0);i=k;return}ja=ea(J*G);J=ea(T*G);g[h>>2]=ja;A=h+4|0;c[A+0>>2]=c[B+0>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];g[j>>2]=J;B=j+4|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];G=ea(g[b>>2]);T=ea(g[f>>2]);O=ea(ea(ea(L*ja)+ea(R*J))+T);T=ea(ea(ea(M*ja)+ea(S*J))+ea(g[I>>2]));g[a>>2]=ea(ea(ea(K*ja)+ea(Q*J))+G);g[a+4>>2]=O;g[a+8>>2]=T;g[a+12>>2]=ea(0.0);i=k;return}function n7a(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;n=i;o=ea(g[b>>2]);p=ea(g[b+4>>2]);q=ea(g[b+8>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);t=ea(r-o);r=ea(s-p);s=ea(ea(g[d+8>>2])-q);u=ea(ea(ea(t*t)+ea(r*r))+ea(s*s));if(u==ea(0.0)){c[k>>2]=1;c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=n;return}else{v=ea(ea(ea(-ea(p*r))-ea(o*t))-ea(q*s));s=ea(g[f>>2]);q=ea(g[f+4>>2]);t=ea(g[f+8>>2]);o=ea(g[e>>2]);r=ea(g[e+4>>2]);p=ea(g[e+8>>2]);w=ea(s-o);s=ea(q-r);q=ea(t-p);t=ea(g[j>>2]);x=ea(g[j+4>>2]);y=ea(g[j+8>>2]);z=ea(g[h>>2]);A=ea(g[h+4>>2]);B=ea(g[h+8>>2]);C=ea(t-z);t=ea(x-A);x=ea(y-B);y=ea(v/u);h=y>ea(1.0);u=h?ea(1.0):y;h=u>ea(0.0);y=h?u:ea(0.0);u=ea(o+ea(w*y));w=ea(r+ea(s*y));s=ea(p+ea(q*y));q=ea(z+ea(C*y));C=ea(A+ea(t*y));t=ea(ea(x*y)+B);g[l>>2]=u;g[l+4>>2]=w;g[l+8>>2]=s;g[l+12>>2]=ea(0.0);g[m>>2]=q;g[m+4>>2]=C;g[m+8>>2]=t;g[m+12>>2]=ea(0.0);B=ea(w-C);C=ea(s-t);g[a>>2]=ea(u-q);g[a+4>>2]=B;g[a+8>>2]=C;g[a+12>>2]=ea(0.0);i=n;return}}function o7a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=Im,N=0,O=Im,P=Im,Q=0,R=0,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=0,bb=0;k=i;i=i+512|0;l=k+48|0;m=k+128|0;n=k+240|0;o=k+448|0;p=k+96|0;q=k+64|0;r=k+80|0;s=k+272|0;t=k+304|0;u=k+384|0;v=k+144|0;w=k+208|0;x=k+476|0;y=k+32|0;z=k;A=k+16|0;B=k+480|0;C=k+112|0;D=k+288|0;E=k+368|0;F=k+256|0;G=k+224|0;H=k+464|0;I=k+492|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[x>>2]=0;J=d+48|0;K=ea(g[J>>2]);L=d+52|0;M=ea(g[L>>2]);N=d+56|0;O=ea(g[N>>2]);P=ea(g[d+60>>2]);Q=ea(ea(ea(K*K)+ea(M*M))+ea(O*O))>ea(0.0);g[m>>2]=K;g[m+4>>2]=M;g[m+8>>2]=O;g[m+12>>2]=P;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);R=Q?m:l;P=ea(g[R>>2]);O=ea(g[R+4>>2]);M=ea(g[R+8>>2]);g[y>>2]=P;R=y+4|0;g[R>>2]=O;l=y+8|0;g[l>>2]=M;g[y+12>>2]=ea(0.0);K=ea(g[a+32>>2]);S=ea(g[b+32>>2]);U=ea((K>S?S:K)*ea(.100000001));K=ea(U*U);c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];c[z+12>>2]=c[w+12>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];w=d+4|0;m=d+8|0;Q=d+16|0;V=d+20|0;W=d+24|0;X=d+32|0;Y=d+36|0;Z=d+40|0;_=a+96|0;$=a+96|0;aa=a+100|0;ba=a+104|0;ca=a+112|0;da=a+112|0;fa=a+116|0;ga=a+120|0;a=E+4|0;ha=E+8|0;ia=F+4|0;ja=F+8|0;ka=F+12|0;la=z+4|0;ma=z+8|0;na=z+12|0;oa=t+4|0;pa=t+8|0;qa=u+4|0;ra=u+8|0;sa=v+4|0;ta=v+8|0;ua=A+4|0;va=A+8|0;wa=A+12|0;xa=G+4|0;ya=G+8|0;za=G+12|0;Aa=t+16|0;U=ea(3402823469999999843913219.0e14);S=P;P=O;O=M;while(1){c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];M=ea(-S);Ba=ea(-P);Ca=ea(-O);Da=ea(g[d>>2]);Ea=ea(Da*M);Fa=ea(g[w>>2]);Ga=ea(Ea+ea(Fa*Ba));Ea=ea(g[m>>2]);Ha=ea(Ga+ea(Ea*Ca));Ga=ea(g[Q>>2]);Ia=ea(Ga*M);Ja=ea(g[V>>2]);Ka=ea(Ia+ea(Ja*Ba));Ia=ea(g[W>>2]);La=ea(Ka+ea(Ia*Ca));Ka=ea(g[X>>2]);Ma=ea(Ka*M);M=ea(g[Y>>2]);Na=ea(Ma+ea(M*Ba));Ba=ea(g[Z>>2]);Ma=ea(Na+ea(Ba*Ca));Ca=ea(g[$>>2]);Na=ea(g[aa>>2]);Oa=ea(ea(ea(Ha*Ca)+ea(La*Na))+ea(Ma*ea(g[ba>>2])));Na=ea(g[da>>2]);Ca=ea(g[fa>>2]);Pa=Oa>ea(ea(ea(Ha*Na)+ea(La*Ca))+ea(Ma*ea(g[ga>>2])));c[o+0>>2]=c[_+0>>2];c[o+4>>2]=c[_+4>>2];c[o+8>>2]=c[_+8>>2];c[o+12>>2]=c[_+12>>2];c[n+0>>2]=c[ca+0>>2];c[n+4>>2]=c[ca+4>>2];c[n+8>>2]=c[ca+8>>2];c[n+12>>2]=c[ca+12>>2];Qa=Pa?o:n;Ma=ea(g[Qa>>2]);Ca=ea(g[Qa+4>>2]);La=ea(g[Qa+8>>2]);Na=ea(g[J>>2]);Ha=ea(g[L>>2]);Oa=ea(ea(ea(ea(Da*Ma)+ea(Ga*Ca))+ea(Ka*La))+Na);Na=ea(ea(ea(ea(Fa*Ma)+ea(Ja*Ca))+ea(M*La))+Ha);Ha=ea(ea(ea(ea(Ea*Ma)+ea(Ia*Ca))+ea(Ba*La))+ea(g[N>>2]));HFb(E,b,y);La=ea(g[E>>2]);Ba=ea(g[a>>2]);Ca=ea(g[ha>>2]);Ia=ea(Oa-La);Ma=ea(Na-Ba);Ea=ea(Ha-Ca);g[F>>2]=Ia;g[ia>>2]=Ma;g[ja>>2]=Ea;g[ka>>2]=ea(0.0);M=ea(g[y>>2]);Ja=ea(g[R>>2]);Fa=ea(U-ea(ea(ea(M*Ia)+ea(Ja*Ma))+ea(ea(g[l>>2])*Ea)));Qa=c[x>>2]|0;g[u+(Qa<<4)>>2]=Oa;g[u+(Qa<<4)+4>>2]=Na;g[u+(Qa<<4)+8>>2]=Ha;g[u+(Qa<<4)+12>>2]=ea(0.0);Pa=v+(Qa<<4)|0;c[Pa+0>>2]=c[E+0>>2];c[Pa+4>>2]=c[E+4>>2];c[Pa+8>>2]=c[E+8>>2];c[Pa+12>>2]=c[E+12>>2];c[x>>2]=Qa+1;Pa=t+(Qa<<4)|0;c[Pa+0>>2]=c[F+0>>2];c[Pa+4>>2]=c[F+4>>2];c[Pa+8>>2]=c[F+8>>2];c[Pa+12>>2]=c[F+12>>2];if(ea(U*ea(.000224999996))>Fa){Ra=3;break}do if((Qa|0)==2)V6a(G,t,Aa,F,t,u,v,x,z,A);else if(!Qa){g[z>>2]=Oa;g[la>>2]=Na;g[ma>>2]=Ha;g[na>>2]=ea(0.0);c[A+0>>2]=c[E+0>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}else if((Qa|0)==3)pPa(G,t,u,v,x,z,A);else if((Qa|0)==1){Fa=ea(g[t>>2]);Ja=ea(g[oa>>2]);M=ea(g[pa>>2]);Ka=ea(Ia-Fa);Ga=ea(Ma-Ja);Da=ea(Ea-M);Sa=ea(ea(ea(Ka*Ka)+ea(Ga*Ga))+ea(Da*Da));if(Sa==ea(0.0)){c[x>>2]=1;c[z+0>>2]=c[u+0>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];c[z+12>>2]=c[u+12>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[G+0>>2]=c[t+0>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[G+12>>2]=c[t+12>>2];break}else{Ta=ea(ea(ea(-ea(Ja*Ga))-ea(Fa*Ka))-ea(M*Da));Da=ea(g[u>>2]);M=ea(g[qa>>2]);Ka=ea(g[ra>>2]);Fa=ea(Oa-Da);Ga=ea(Na-M);Ja=ea(Ha-Ka);Ua=ea(g[v>>2]);Va=ea(g[sa>>2]);Wa=ea(g[ta>>2]);Xa=ea(La-Ua);Ya=ea(Ba-Va);Za=ea(Ca-Wa);_a=ea(Ta/Sa);Pa=_a>ea(1.0);Sa=Pa?ea(1.0):_a;Pa=Sa>ea(0.0);_a=Pa?Sa:ea(0.0);Sa=ea(Da+ea(Fa*_a));Fa=ea(M+ea(Ga*_a));Ga=ea(Ka+ea(Ja*_a));Ja=ea(Ua+ea(Xa*_a));Xa=ea(Va+ea(Ya*_a));Ya=ea(Wa+ea(Za*_a));g[z>>2]=Sa;g[la>>2]=Fa;g[ma>>2]=Ga;g[na>>2]=ea(0.0);g[A>>2]=Ja;g[ua>>2]=Xa;g[va>>2]=Ya;g[wa>>2]=ea(0.0);_a=ea(Fa-Xa);Xa=ea(Ga-Ya);g[G>>2]=ea(Sa-Ja);g[xa>>2]=_a;g[ya>>2]=Xa;g[za>>2]=ea(0.0);break}}else{c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}while(0);c[y+0>>2]=c[G+0>>2];c[y+4>>2]=c[G+4>>2];c[y+8>>2]=c[G+8>>2];c[y+12>>2]=c[G+12>>2];S=ea(g[y>>2]);P=ea(g[R>>2]);O=ea(g[l>>2]);$a=ea(ea(ea(S*S)+ea(P*P))+ea(O*O));c[B+0>>2]=c[H+0>>2];c[B+4>>2]=c[H+4>>2];c[B+8>>2]=c[H+8>>2];ab=U>$a;if(!($a>K)|ab^1){Ra=13;break}else U=$a}if((Ra|0)==3){K=ea(g[A>>2]);O=ea(g[ua>>2]);P=ea(g[va>>2]);S=ea(g[z>>2]);Ca=ea(g[la>>2]);Ba=ea(K-S);S=ea(O-Ca);Ca=ea(P-ea(g[ma>>2]));P=ea(ea(1.0)/ea(T(ea(ea(ea(Ba*Ba)+ea(S*S))+ea(Ca*Ca)))));O=ea(Ba*P);Ba=ea(S*P);S=ea(Ca*P);c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];g[j>>2]=U;H=j+4|0;c[H+0>>2]=c[B+0>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];g[h>>2]=O;g[h+4>>2]=Ba;g[h+8>>2]=S;g[h+12>>2]=ea(0.0);bb=0;i=k;return bb|0}else if((Ra|0)==13){c[q+0>>2]=c[z+0>>2];c[q+4>>2]=c[z+4>>2];c[q+8>>2]=c[z+8>>2];c[q+12>>2]=c[z+12>>2];c[p+0>>2]=c[C+0>>2];c[p+4>>2]=c[C+4>>2];c[p+8>>2]=c[C+8>>2];c[p+12>>2]=c[C+12>>2];C=ab?q:p;S=ea(g[C>>2]);Ba=ea(g[C+4>>2]);O=ea(g[C+8>>2]);g[z>>2]=S;g[la>>2]=Ba;g[ma>>2]=O;g[na>>2]=ea(0.0);c[s+0>>2]=c[A+0>>2];c[s+4>>2]=c[A+4>>2];c[s+8>>2]=c[A+8>>2];c[s+12>>2]=c[A+12>>2];c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[r+12>>2]=c[D+12>>2];D=ab?s:r;P=ea(g[D>>2]);Ca=ea(g[D+4>>2]);K=ea(g[D+8>>2]);g[A>>2]=P;g[ua>>2]=Ca;g[va>>2]=K;g[wa>>2]=ea(0.0);c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];La=ea(P-S);S=ea(Ca-Ba);Ba=ea(K-O);O=ea(ea(1.0)/ea(T(ea(ea(ea(La*La)+ea(S*S))+ea(Ba*Ba)))));K=ea(S*O);S=ea(Ba*O);g[h>>2]=ea(La*O);g[h+4>>2]=K;g[h+8>>2]=S;g[h+12>>2]=ea(0.0);g[j>>2]=ab?$a:U;h=j+4|0;c[h+0>>2]=c[I+0>>2];c[h+4>>2]=c[I+4>>2];c[h+8>>2]=c[I+8>>2];bb=ab?1:3;i=k;return bb|0}return 0}function p7a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=Im,N=0,O=Im,P=Im,Q=0,R=0,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=0,Oa=0,Pa=0,Qa=Im,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=0,bb=0;k=i;i=i+512|0;l=k+48|0;m=k+128|0;n=k+240|0;o=k+448|0;p=k+96|0;q=k+64|0;r=k+80|0;s=k+272|0;t=k+304|0;u=k+384|0;v=k+144|0;w=k+208|0;x=k+476|0;y=k+32|0;z=k;A=k+16|0;B=k+480|0;C=k+112|0;D=k+288|0;E=k+368|0;F=k+256|0;G=k+224|0;H=k+464|0;I=k+492|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[x>>2]=0;J=d+48|0;K=ea(g[J>>2]);L=d+52|0;M=ea(g[L>>2]);N=d+56|0;O=ea(g[N>>2]);P=ea(g[d+60>>2]);Q=ea(ea(ea(K*K)+ea(M*M))+ea(O*O))>ea(0.0);g[m>>2]=K;g[m+4>>2]=M;g[m+8>>2]=O;g[m+12>>2]=P;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);R=Q?m:l;P=ea(g[R>>2]);O=ea(g[R+4>>2]);M=ea(g[R+8>>2]);g[y>>2]=P;R=y+4|0;g[R>>2]=O;l=y+8|0;g[l>>2]=M;g[y+12>>2]=ea(0.0);K=ea(g[a+32>>2]);S=ea(g[b+32>>2]);U=ea((K>S?S:K)*ea(.100000001));K=ea(U*U);c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];c[z+12>>2]=c[w+12>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];w=d+4|0;m=d+8|0;Q=d+16|0;V=d+20|0;W=d+24|0;X=d+32|0;Y=d+36|0;Z=d+40|0;_=a+144|0;$=a+144|0;aa=a+148|0;ba=a+152|0;a=n+4|0;ca=n+8|0;da=n+12|0;fa=E+4|0;ga=E+8|0;ha=F+4|0;ia=F+8|0;ja=F+12|0;ka=z+4|0;la=z+8|0;ma=z+12|0;na=t+4|0;oa=t+8|0;pa=u+4|0;qa=u+8|0;ra=v+4|0;sa=v+8|0;ta=A+4|0;ua=A+8|0;va=A+12|0;wa=G+4|0;xa=G+8|0;ya=G+12|0;za=t+16|0;U=ea(3402823469999999843913219.0e14);S=P;P=O;O=M;while(1){c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];M=ea(-S);Aa=ea(-P);Ba=ea(-O);Ca=ea(g[d>>2]);Da=ea(Ca*M);Ea=ea(g[w>>2]);Fa=ea(Da+ea(Ea*Aa));Da=ea(g[m>>2]);Ga=ea(Fa+ea(Da*Ba));Fa=ea(g[Q>>2]);Ha=ea(Fa*M);Ia=ea(g[V>>2]);Ja=ea(Ha+ea(Ia*Aa));Ha=ea(g[W>>2]);Ka=ea(Ja+ea(Ha*Ba));Ja=ea(g[X>>2]);La=ea(Ja*M);M=ea(g[Y>>2]);Ma=ea(La+ea(M*Aa));Aa=ea(g[Z>>2]);Na=Ga>ea(0.0);Oa=Ka>ea(0.0);Pa=ea(Ma+ea(Aa*Ba))>ea(0.0);c[o+0>>2]=c[_+0>>2];c[o+4>>2]=c[_+4>>2];c[o+8>>2]=c[_+8>>2];c[o+12>>2]=c[_+12>>2];Ba=ea(g[$>>2]);Ma=ea(g[aa>>2]);Ka=ea(-Ma);Ma=ea(-ea(g[ba>>2]));g[n>>2]=ea(-Ba);g[a>>2]=Ka;g[ca>>2]=Ma;g[da>>2]=ea(0.0);Ma=ea(g[(Na?o:n)>>2]);Ka=ea(g[(Oa?o:n)+4>>2]);Ba=ea(g[(Pa?o:n)+8>>2]);Ga=ea(g[J>>2]);La=ea(g[L>>2]);Qa=ea(ea(ea(ea(Ca*Ma)+ea(Fa*Ka))+ea(Ja*Ba))+Ga);Ga=ea(ea(ea(ea(Ea*Ma)+ea(Ia*Ka))+ea(M*Ba))+La);La=ea(ea(ea(ea(Da*Ma)+ea(Ha*Ka))+ea(Aa*Ba))+ea(g[N>>2]));HFb(E,b,y);Ba=ea(g[E>>2]);Aa=ea(g[fa>>2]);Ka=ea(g[ga>>2]);Ha=ea(Qa-Ba);Ma=ea(Ga-Aa);Da=ea(La-Ka);g[F>>2]=Ha;g[ha>>2]=Ma;g[ia>>2]=Da;g[ja>>2]=ea(0.0);M=ea(g[y>>2]);Ia=ea(g[R>>2]);Ea=ea(U-ea(ea(ea(M*Ha)+ea(Ia*Ma))+ea(ea(g[l>>2])*Da)));Pa=c[x>>2]|0;g[u+(Pa<<4)>>2]=Qa;g[u+(Pa<<4)+4>>2]=Ga;g[u+(Pa<<4)+8>>2]=La;g[u+(Pa<<4)+12>>2]=ea(0.0);Oa=v+(Pa<<4)|0;c[Oa+0>>2]=c[E+0>>2];c[Oa+4>>2]=c[E+4>>2];c[Oa+8>>2]=c[E+8>>2];c[Oa+12>>2]=c[E+12>>2];c[x>>2]=Pa+1;Oa=t+(Pa<<4)|0;c[Oa+0>>2]=c[F+0>>2];c[Oa+4>>2]=c[F+4>>2];c[Oa+8>>2]=c[F+8>>2];c[Oa+12>>2]=c[F+12>>2];if(ea(U*ea(.000224999996))>Ea){Ra=3;break}do if(!Pa){g[z>>2]=Qa;g[ka>>2]=Ga;g[la>>2]=La;g[ma>>2]=ea(0.0);c[A+0>>2]=c[E+0>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}else if((Pa|0)==3)pPa(G,t,u,v,x,z,A);else if((Pa|0)==2)V6a(G,t,za,F,t,u,v,x,z,A);else if((Pa|0)==1){Ea=ea(g[t>>2]);Ia=ea(g[na>>2]);M=ea(g[oa>>2]);Ja=ea(Ha-Ea);Fa=ea(Ma-Ia);Ca=ea(Da-M);Sa=ea(ea(ea(Ja*Ja)+ea(Fa*Fa))+ea(Ca*Ca));if(Sa==ea(0.0)){c[x>>2]=1;c[z+0>>2]=c[u+0>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];c[z+12>>2]=c[u+12>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[G+0>>2]=c[t+0>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[G+12>>2]=c[t+12>>2];break}else{Ta=ea(ea(ea(-ea(Ia*Fa))-ea(Ea*Ja))-ea(M*Ca));Ca=ea(g[u>>2]);M=ea(g[pa>>2]);Ja=ea(g[qa>>2]);Ea=ea(Qa-Ca);Fa=ea(Ga-M);Ia=ea(La-Ja);Ua=ea(g[v>>2]);Va=ea(g[ra>>2]);Wa=ea(g[sa>>2]);Xa=ea(Ba-Ua);Ya=ea(Aa-Va);Za=ea(Ka-Wa);_a=ea(Ta/Sa);Oa=_a>ea(1.0);Sa=Oa?ea(1.0):_a;Oa=Sa>ea(0.0);_a=Oa?Sa:ea(0.0);Sa=ea(Ca+ea(Ea*_a));Ea=ea(M+ea(Fa*_a));Fa=ea(Ja+ea(Ia*_a));Ia=ea(Ua+ea(Xa*_a));Xa=ea(Va+ea(Ya*_a));Ya=ea(Wa+ea(Za*_a));g[z>>2]=Sa;g[ka>>2]=Ea;g[la>>2]=Fa;g[ma>>2]=ea(0.0);g[A>>2]=Ia;g[ta>>2]=Xa;g[ua>>2]=Ya;g[va>>2]=ea(0.0);_a=ea(Ea-Xa);Xa=ea(Fa-Ya);g[G>>2]=ea(Sa-Ia);g[wa>>2]=_a;g[xa>>2]=Xa;g[ya>>2]=ea(0.0);break}}else{c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}while(0);c[y+0>>2]=c[G+0>>2];c[y+4>>2]=c[G+4>>2];c[y+8>>2]=c[G+8>>2];c[y+12>>2]=c[G+12>>2];S=ea(g[y>>2]);P=ea(g[R>>2]);O=ea(g[l>>2]);$a=ea(ea(ea(S*S)+ea(P*P))+ea(O*O));c[B+0>>2]=c[H+0>>2];c[B+4>>2]=c[H+4>>2];c[B+8>>2]=c[H+8>>2];ab=U>$a;if(!($a>K)|ab^1){Ra=13;break}else U=$a}if((Ra|0)==3){K=ea(g[A>>2]);O=ea(g[ta>>2]);P=ea(g[ua>>2]);S=ea(g[z>>2]);Ka=ea(g[ka>>2]);Aa=ea(K-S);S=ea(O-Ka);Ka=ea(P-ea(g[la>>2]));P=ea(ea(1.0)/ea(T(ea(ea(ea(Aa*Aa)+ea(S*S))+ea(Ka*Ka)))));O=ea(Aa*P);Aa=ea(S*P);S=ea(Ka*P);c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];g[j>>2]=U;H=j+4|0;c[H+0>>2]=c[B+0>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];g[h>>2]=O;g[h+4>>2]=Aa;g[h+8>>2]=S;g[h+12>>2]=ea(0.0);bb=0;i=k;return bb|0}else if((Ra|0)==13){c[q+0>>2]=c[z+0>>2];c[q+4>>2]=c[z+4>>2];c[q+8>>2]=c[z+8>>2];c[q+12>>2]=c[z+12>>2];c[p+0>>2]=c[C+0>>2];c[p+4>>2]=c[C+4>>2];c[p+8>>2]=c[C+8>>2];c[p+12>>2]=c[C+12>>2];C=ab?q:p;S=ea(g[C>>2]);Aa=ea(g[C+4>>2]);O=ea(g[C+8>>2]);g[z>>2]=S;g[ka>>2]=Aa;g[la>>2]=O;g[ma>>2]=ea(0.0);c[s+0>>2]=c[A+0>>2];c[s+4>>2]=c[A+4>>2];c[s+8>>2]=c[A+8>>2];c[s+12>>2]=c[A+12>>2];c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[r+12>>2]=c[D+12>>2];D=ab?s:r;P=ea(g[D>>2]);Ka=ea(g[D+4>>2]);K=ea(g[D+8>>2]);g[A>>2]=P;g[ta>>2]=Ka;g[ua>>2]=K;g[va>>2]=ea(0.0);c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];Ba=ea(P-S);S=ea(Ka-Aa);Aa=ea(K-O);O=ea(ea(1.0)/ea(T(ea(ea(ea(Ba*Ba)+ea(S*S))+ea(Aa*Aa)))));K=ea(S*O);S=ea(Aa*O);g[h>>2]=ea(Ba*O);g[h+4>>2]=K;g[h+8>>2]=S;g[h+12>>2]=ea(0.0);g[j>>2]=ab?$a:U;h=j+4|0;c[h+0>>2]=c[I+0>>2];c[h+4>>2]=c[I+4>>2];c[h+8>>2]=c[I+8>>2];bb=ab?1:3;i=k;return bb|0}return 0}function q7a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=Im,N=0,O=Im,P=Im,Q=0,R=0,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=0,$a=0;k=i;i=i+512|0;l=k+48|0;m=k+128|0;n=k+240|0;o=k+448|0;p=k+96|0;q=k+64|0;r=k+80|0;s=k+272|0;t=k+304|0;u=k+384|0;v=k+144|0;w=k+208|0;x=k+476|0;y=k+32|0;z=k;A=k+16|0;B=k+480|0;C=k+112|0;D=k+288|0;E=k+368|0;F=k+256|0;G=k+224|0;H=k+464|0;I=k+492|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[x>>2]=0;J=d+48|0;K=ea(g[J>>2]);L=d+52|0;M=ea(g[L>>2]);N=d+56|0;O=ea(g[N>>2]);P=ea(g[d+60>>2]);Q=ea(ea(ea(K*K)+ea(M*M))+ea(O*O))>ea(0.0);g[m>>2]=K;g[m+4>>2]=M;g[m+8>>2]=O;g[m+12>>2]=P;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);R=Q?m:l;P=ea(g[R>>2]);O=ea(g[R+4>>2]);M=ea(g[R+8>>2]);g[y>>2]=P;R=y+4|0;g[R>>2]=O;l=y+8|0;g[l>>2]=M;g[y+12>>2]=ea(0.0);K=ea(g[a+32>>2]);S=ea(g[b+32>>2]);U=ea((K>S?S:K)*ea(.100000001));K=ea(U*U);c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];c[z+12>>2]=c[w+12>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];w=d+4|0;m=d+8|0;Q=d+16|0;V=d+20|0;W=d+24|0;X=d+32|0;Y=d+36|0;Z=d+40|0;_=n+4|0;$=n+8|0;aa=n+12|0;ba=o+4|0;ca=o+8|0;da=E+4|0;fa=E+8|0;ga=F+4|0;ha=F+8|0;ia=F+12|0;ja=z+4|0;ka=z+8|0;la=z+12|0;ma=t+4|0;na=t+8|0;oa=u+4|0;pa=u+8|0;qa=v+4|0;ra=v+8|0;sa=A+4|0;ta=A+8|0;ua=A+12|0;va=G+4|0;wa=G+8|0;xa=G+12|0;ya=t+16|0;U=ea(3402823469999999843913219.0e14);S=P;P=O;O=M;while(1){c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];M=ea(-S);za=ea(-P);Aa=ea(-O);Ba=ea(ea(g[d>>2])*M);Ca=ea(Ba+ea(ea(g[w>>2])*za));Ba=ea(Ca+ea(ea(g[m>>2])*Aa));Ca=ea(ea(g[Q>>2])*M);Da=ea(Ca+ea(ea(g[V>>2])*za));Ca=ea(Da+ea(ea(g[W>>2])*Aa));Da=ea(ea(g[X>>2])*M);M=ea(Da+ea(ea(g[Y>>2])*za));za=ea(M+ea(ea(g[Z>>2])*Aa));g[n>>2]=Ba;g[_>>2]=Ca;g[$>>2]=za;g[aa>>2]=ea(0.0);HFb(o,a,n);za=ea(g[J>>2]);Ca=ea(g[L>>2]);Ba=ea(g[N>>2]);Aa=ea(g[o>>2]);M=ea(g[ba>>2]);Da=ea(g[ca>>2]);Ea=ea(Aa*ea(g[d>>2]));Fa=ea(Ea+ea(M*ea(g[Q>>2])));Ea=ea(Fa+ea(Da*ea(g[X>>2])));Fa=ea(Aa*ea(g[w>>2]));Ga=ea(Fa+ea(M*ea(g[V>>2])));Fa=ea(Ga+ea(Da*ea(g[Y>>2])));Ga=ea(Aa*ea(g[m>>2]));Aa=ea(Ga+ea(M*ea(g[W>>2])));M=ea(za+Ea);Ea=ea(Ca+Fa);Fa=ea(Ba+ea(Aa+ea(Da*ea(g[Z>>2]))));HFb(E,b,y);Da=ea(g[E>>2]);Aa=ea(g[da>>2]);Ba=ea(g[fa>>2]);Ca=ea(M-Da);za=ea(Ea-Aa);Ga=ea(Fa-Ba);g[F>>2]=Ca;g[ga>>2]=za;g[ha>>2]=Ga;g[ia>>2]=ea(0.0);Ha=ea(g[y>>2]);Ia=ea(g[R>>2]);Ja=ea(U-ea(ea(ea(Ha*Ca)+ea(Ia*za))+ea(ea(g[l>>2])*Ga)));Ka=c[x>>2]|0;g[u+(Ka<<4)>>2]=M;g[u+(Ka<<4)+4>>2]=Ea;g[u+(Ka<<4)+8>>2]=Fa;g[u+(Ka<<4)+12>>2]=ea(0.0);La=v+(Ka<<4)|0;c[La+0>>2]=c[E+0>>2];c[La+4>>2]=c[E+4>>2];c[La+8>>2]=c[E+8>>2];c[La+12>>2]=c[E+12>>2];c[x>>2]=Ka+1;La=t+(Ka<<4)|0;c[La+0>>2]=c[F+0>>2];c[La+4>>2]=c[F+4>>2];c[La+8>>2]=c[F+8>>2];c[La+12>>2]=c[F+12>>2];if(ea(U*ea(.000224999996))>Ja){Ma=3;break}do if((Ka|0)==3)pPa(G,t,u,v,x,z,A);else if((Ka|0)==2)V6a(G,t,ya,F,t,u,v,x,z,A);else if((Ka|0)==1){Ja=ea(g[t>>2]);Ia=ea(g[ma>>2]);Ha=ea(g[na>>2]);Na=ea(Ca-Ja);Oa=ea(za-Ia);Pa=ea(Ga-Ha);Qa=ea(ea(ea(Na*Na)+ea(Oa*Oa))+ea(Pa*Pa));if(Qa==ea(0.0)){c[x>>2]=1;c[z+0>>2]=c[u+0>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];c[z+12>>2]=c[u+12>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[G+0>>2]=c[t+0>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[G+12>>2]=c[t+12>>2];break}else{Ra=ea(ea(ea(-ea(Ia*Oa))-ea(Ja*Na))-ea(Ha*Pa));Pa=ea(g[u>>2]);Ha=ea(g[oa>>2]);Na=ea(g[pa>>2]);Ja=ea(M-Pa);Oa=ea(Ea-Ha);Ia=ea(Fa-Na);Sa=ea(g[v>>2]);Ta=ea(g[qa>>2]);Ua=ea(g[ra>>2]);Va=ea(Da-Sa);Wa=ea(Aa-Ta);Xa=ea(Ba-Ua);Ya=ea(Ra/Qa);La=Ya>ea(1.0);Qa=La?ea(1.0):Ya;La=Qa>ea(0.0);Ya=La?Qa:ea(0.0);Qa=ea(Pa+ea(Ja*Ya));Ja=ea(Ha+ea(Oa*Ya));Oa=ea(Na+ea(Ia*Ya));Ia=ea(Sa+ea(Va*Ya));Va=ea(Ta+ea(Wa*Ya));Wa=ea(Ua+ea(Xa*Ya));g[z>>2]=Qa;g[ja>>2]=Ja;g[ka>>2]=Oa;g[la>>2]=ea(0.0);g[A>>2]=Ia;g[sa>>2]=Va;g[ta>>2]=Wa;g[ua>>2]=ea(0.0);Ya=ea(Ja-Va);Va=ea(Oa-Wa);g[G>>2]=ea(Qa-Ia);g[va>>2]=Ya;g[wa>>2]=Va;g[xa>>2]=ea(0.0);break}}else if(!Ka){g[z>>2]=M;g[ja>>2]=Ea;g[ka>>2]=Fa;g[la>>2]=ea(0.0);c[A+0>>2]=c[E+0>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}else{c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}while(0);c[y+0>>2]=c[G+0>>2];c[y+4>>2]=c[G+4>>2];c[y+8>>2]=c[G+8>>2];c[y+12>>2]=c[G+12>>2];S=ea(g[y>>2]);P=ea(g[R>>2]);O=ea(g[l>>2]);Za=ea(ea(ea(S*S)+ea(P*P))+ea(O*O));c[B+0>>2]=c[H+0>>2];c[B+4>>2]=c[H+4>>2];c[B+8>>2]=c[H+8>>2];_a=U>Za;if(!(Za>K)|_a^1){Ma=13;break}else U=Za}if((Ma|0)==3){K=ea(g[A>>2]);O=ea(g[sa>>2]);P=ea(g[ta>>2]);S=ea(g[z>>2]);Fa=ea(g[ja>>2]);Ea=ea(K-S);S=ea(O-Fa);Fa=ea(P-ea(g[ka>>2]));P=ea(ea(1.0)/ea(T(ea(ea(ea(Ea*Ea)+ea(S*S))+ea(Fa*Fa)))));O=ea(Ea*P);Ea=ea(S*P);S=ea(Fa*P);c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];g[j>>2]=U;H=j+4|0;c[H+0>>2]=c[B+0>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];g[h>>2]=O;g[h+4>>2]=Ea;g[h+8>>2]=S;g[h+12>>2]=ea(0.0);$a=0;i=k;return $a|0}else if((Ma|0)==13){c[q+0>>2]=c[z+0>>2];c[q+4>>2]=c[z+4>>2];c[q+8>>2]=c[z+8>>2];c[q+12>>2]=c[z+12>>2];c[p+0>>2]=c[C+0>>2];c[p+4>>2]=c[C+4>>2];c[p+8>>2]=c[C+8>>2];c[p+12>>2]=c[C+12>>2];C=_a?q:p;S=ea(g[C>>2]);Ea=ea(g[C+4>>2]);O=ea(g[C+8>>2]);g[z>>2]=S;g[ja>>2]=Ea;g[ka>>2]=O;g[la>>2]=ea(0.0);c[s+0>>2]=c[A+0>>2];c[s+4>>2]=c[A+4>>2];c[s+8>>2]=c[A+8>>2];c[s+12>>2]=c[A+12>>2];c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[r+12>>2]=c[D+12>>2];D=_a?s:r;P=ea(g[D>>2]);Fa=ea(g[D+4>>2]);K=ea(g[D+8>>2]);g[A>>2]=P;g[sa>>2]=Fa;g[ta>>2]=K;g[ua>>2]=ea(0.0);c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];M=ea(P-S);S=ea(Fa-Ea);Ea=ea(K-O);O=ea(ea(1.0)/ea(T(ea(ea(ea(M*M)+ea(S*S))+ea(Ea*Ea)))));K=ea(S*O);S=ea(Ea*O);g[h>>2]=ea(M*O);g[h+4>>2]=K;g[h+8>>2]=S;g[h+12>>2]=ea(0.0);g[j>>2]=_a?Za:U;h=j+4|0;c[h+0>>2]=c[I+0>>2];c[h+4>>2]=c[I+4>>2];c[h+8>>2]=c[I+8>>2];$a=_a?1:3;i=k;return $a|0}return 0}function r7a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=Im,Q=Im,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0;k=i;i=i+512|0;l=k+448|0;m=k+80|0;n=k+96|0;o=k+128|0;p=k+48|0;q=k+64|0;r=k+192|0;s=k+272|0;t=k+352|0;u=k+432|0;v=k+488|0;w=k+160|0;x=k+32|0;y=k;z=k+492|0;A=k+176|0;B=k+256|0;C=k+112|0;D=k+336|0;E=k+416|0;F=k+16|0;G=k+144|0;H=k+476|0;I=k+464|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[v>>2]=0;J=ea(g[d+48>>2]);K=ea(g[d+52>>2]);L=ea(g[d+56>>2]);M=ea(g[d+60>>2]);N=ea(ea(ea(J*J)+ea(K*K))+ea(L*L))>ea(0.0);g[m>>2]=J;g[m+4>>2]=K;g[m+8>>2]=L;g[m+12>>2]=M;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);O=N?m:l;M=ea(g[O>>2]);L=ea(g[O+4>>2]);K=ea(g[O+8>>2]);g[w>>2]=M;O=w+4|0;g[O>>2]=L;l=w+8|0;g[l>>2]=K;g[w+12>>2]=ea(0.0);J=ea(g[a+32>>2]);P=ea(g[b+32>>2]);Q=ea((J>P?P:J)*ea(.100000001));J=ea(Q*Q);c[x+0>>2]=c[u+0>>2];c[x+4>>2]=c[u+4>>2];c[x+8>>2]=c[u+8>>2];c[x+12>>2]=c[u+12>>2];c[y+0>>2]=c[u+0>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];c[y+12>>2]=c[u+12>>2];u=D+4|0;m=D+8|0;N=D+12|0;R=C+4|0;S=C+8|0;U=E+4|0;V=E+8|0;W=F+4|0;X=F+8|0;Y=F+12|0;Z=r+4|0;_=r+8|0;$=s+4|0;aa=s+8|0;ba=t+4|0;ca=t+8|0;da=x+4|0;fa=x+8|0;ga=x+12|0;ha=y+4|0;ia=y+8|0;ja=y+12|0;ka=G+4|0;la=G+8|0;ma=G+12|0;na=r+16|0;Q=M;M=L;L=K;K=ea(3402823469999999843913219.0e14);while(1){c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2];c[B+0>>2]=c[y+0>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];c[B+12>>2]=c[y+12>>2];P=ea(-M);oa=ea(-L);g[D>>2]=ea(-Q);g[u>>2]=P;g[m>>2]=oa;g[N>>2]=ea(0.0);IFb(C,a,D,d);HFb(E,b,w);oa=ea(g[C>>2]);P=ea(g[R>>2]);pa=ea(g[S>>2]);qa=ea(g[E>>2]);ra=ea(g[U>>2]);sa=ea(g[V>>2]);ta=ea(oa-qa);ua=ea(P-ra);va=ea(pa-sa);g[F>>2]=ta;g[W>>2]=ua;g[X>>2]=va;g[Y>>2]=ea(0.0);wa=ea(g[w>>2]);xa=ea(g[O>>2]);ya=ea(K-ea(ea(ea(wa*ta)+ea(xa*ua))+ea(ea(g[l>>2])*va)));za=c[v>>2]|0;Aa=s+(za<<4)|0;c[Aa+0>>2]=c[C+0>>2];c[Aa+4>>2]=c[C+4>>2];c[Aa+8>>2]=c[C+8>>2];c[Aa+12>>2]=c[C+12>>2];Aa=t+(za<<4)|0;c[Aa+0>>2]=c[E+0>>2];c[Aa+4>>2]=c[E+4>>2];c[Aa+8>>2]=c[E+8>>2];c[Aa+12>>2]=c[E+12>>2];c[v>>2]=za+1;Aa=r+(za<<4)|0;c[Aa+0>>2]=c[F+0>>2];c[Aa+4>>2]=c[F+4>>2];c[Aa+8>>2]=c[F+8>>2];c[Aa+12>>2]=c[F+12>>2];if(ea(K*ea(.000224999996))>ya){Ba=3;break}do if(!za){c[x+0>>2]=c[C+0>>2];c[x+4>>2]=c[C+4>>2];c[x+8>>2]=c[C+8>>2];c[x+12>>2]=c[C+12>>2];c[y+0>>2]=c[E+0>>2];c[y+4>>2]=c[E+4>>2];c[y+8>>2]=c[E+8>>2];c[y+12>>2]=c[E+12>>2];c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}else if((za|0)==1){ya=ea(g[r>>2]);xa=ea(g[Z>>2]);wa=ea(g[_>>2]);Ca=ea(ta-ya);Da=ea(ua-xa);Ea=ea(va-wa);Fa=ea(ea(ea(Ca*Ca)+ea(Da*Da))+ea(Ea*Ea));if(Fa==ea(0.0)){c[v>>2]=1;c[x+0>>2]=c[s+0>>2];c[x+4>>2]=c[s+4>>2];c[x+8>>2]=c[s+8>>2];c[x+12>>2]=c[s+12>>2];c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[G+0>>2]=c[r+0>>2];c[G+4>>2]=c[r+4>>2];c[G+8>>2]=c[r+8>>2];c[G+12>>2]=c[r+12>>2];break}else{Ga=ea(ea(ea(-ea(xa*Da))-ea(ya*Ca))-ea(wa*Ea));Ea=ea(g[s>>2]);wa=ea(g[$>>2]);Ca=ea(g[aa>>2]);ya=ea(oa-Ea);Da=ea(P-wa);xa=ea(pa-Ca);Ha=ea(g[t>>2]);Ia=ea(g[ba>>2]);Ja=ea(g[ca>>2]);Ka=ea(qa-Ha);La=ea(ra-Ia);Ma=ea(sa-Ja);Na=ea(Ga/Fa);Aa=Na>ea(1.0);Fa=Aa?ea(1.0):Na;Aa=Fa>ea(0.0);Na=Aa?Fa:ea(0.0);Fa=ea(Ea+ea(ya*Na));ya=ea(wa+ea(Da*Na));Da=ea(Ca+ea(xa*Na));xa=ea(Ha+ea(Ka*Na));Ka=ea(Ia+ea(La*Na));La=ea(Ja+ea(Ma*Na));g[x>>2]=Fa;g[da>>2]=ya;g[fa>>2]=Da;g[ga>>2]=ea(0.0);g[y>>2]=xa;g[ha>>2]=Ka;g[ia>>2]=La;g[ja>>2]=ea(0.0);Na=ea(ya-Ka);Ka=ea(Da-La);g[G>>2]=ea(Fa-xa);g[ka>>2]=Na;g[la>>2]=Ka;g[ma>>2]=ea(0.0);break}}else if((za|0)==3)pPa(G,r,s,t,v,x,y);else if((za|0)==2)V6a(G,r,na,F,r,s,t,v,x,y);else{c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2]}while(0);c[w+0>>2]=c[G+0>>2];c[w+4>>2]=c[G+4>>2];c[w+8>>2]=c[G+8>>2];c[w+12>>2]=c[G+12>>2];Q=ea(g[w>>2]);M=ea(g[O>>2]);L=ea(g[l>>2]);Oa=ea(ea(ea(Q*Q)+ea(M*M))+ea(L*L));c[z+0>>2]=c[H+0>>2];c[z+4>>2]=c[H+4>>2];c[z+8>>2]=c[H+8>>2];Pa=K>Oa;if(!(Oa>J)|Pa^1){Ba=13;break}else K=Oa}if((Ba|0)==3){J=ea(g[y>>2]);L=ea(g[ha>>2]);M=ea(g[ia>>2]);Q=ea(g[x>>2]);sa=ea(g[da>>2]);ra=ea(J-Q);Q=ea(L-sa);sa=ea(M-ea(g[fa>>2]));M=ea(ea(1.0)/ea(T(ea(ea(ea(ra*ra)+ea(Q*Q))+ea(sa*sa)))));L=ea(ra*M);ra=ea(Q*M);Q=ea(sa*M);c[e+0>>2]=c[x+0>>2];c[e+4>>2]=c[x+4>>2];c[e+8>>2]=c[x+8>>2];c[e+12>>2]=c[x+12>>2];c[f+0>>2]=c[y+0>>2];c[f+4>>2]=c[y+4>>2];c[f+8>>2]=c[y+8>>2];c[f+12>>2]=c[y+12>>2];g[j>>2]=K;H=j+4|0;c[H+0>>2]=c[z+0>>2];c[H+4>>2]=c[z+4>>2];c[H+8>>2]=c[z+8>>2];g[h>>2]=L;g[h+4>>2]=ra;g[h+8>>2]=Q;g[h+12>>2]=ea(0.0);Qa=0;i=k;return Qa|0}else if((Ba|0)==13){c[o+0>>2]=c[x+0>>2];c[o+4>>2]=c[x+4>>2];c[o+8>>2]=c[x+8>>2];c[o+12>>2]=c[x+12>>2];c[n+0>>2]=c[A+0>>2];c[n+4>>2]=c[A+4>>2];c[n+8>>2]=c[A+8>>2];c[n+12>>2]=c[A+12>>2];A=Pa?o:n;Q=ea(g[A>>2]);ra=ea(g[A+4>>2]);L=ea(g[A+8>>2]);g[x>>2]=Q;g[da>>2]=ra;g[fa>>2]=L;g[ga>>2]=ea(0.0);c[q+0>>2]=c[y+0>>2];c[q+4>>2]=c[y+4>>2];c[q+8>>2]=c[y+8>>2];c[q+12>>2]=c[y+12>>2];c[p+0>>2]=c[B+0>>2];c[p+4>>2]=c[B+4>>2];c[p+8>>2]=c[B+8>>2];c[p+12>>2]=c[B+12>>2];B=Pa?q:p;M=ea(g[B>>2]);sa=ea(g[B+4>>2]);J=ea(g[B+8>>2]);g[y>>2]=M;g[ha>>2]=sa;g[ia>>2]=J;g[ja>>2]=ea(0.0);c[e+0>>2]=c[x+0>>2];c[e+4>>2]=c[x+4>>2];c[e+8>>2]=c[x+8>>2];c[e+12>>2]=c[x+12>>2];c[f+0>>2]=c[y+0>>2];c[f+4>>2]=c[y+4>>2];c[f+8>>2]=c[y+8>>2];c[f+12>>2]=c[y+12>>2];qa=ea(M-Q);Q=ea(sa-ra);ra=ea(J-L);L=ea(ea(1.0)/ea(T(ea(ea(ea(qa*qa)+ea(Q*Q))+ea(ra*ra)))));J=ea(Q*L);Q=ea(ra*L);g[h>>2]=ea(qa*L);g[h+4>>2]=J;g[h+8>>2]=Q;g[h+12>>2]=ea(0.0);g[j>>2]=Pa?Oa:K;h=j+4|0;c[h+0>>2]=c[I+0>>2];c[h+4>>2]=c[I+4>>2];c[h+8>>2]=c[I+8>>2];Qa=Pa?1:3;i=k;return Qa|0}return 0}function s7a(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=0;j=i;i=i+512|0;k=j+48|0;l=j+128|0;m=j+240|0;n=j+448|0;o=j+96|0;p=j+64|0;q=j+80|0;r=j+272|0;s=j+304|0;t=j+384|0;u=j+144|0;v=j+208|0;w=j+476|0;x=j+32|0;y=j;z=j+16|0;A=j+480|0;B=j+112|0;C=j+288|0;D=j+368|0;E=j+256|0;F=j+224|0;G=j+464|0;H=j+492|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[w>>2]=0;I=ea(g[a>>2]);J=ea(g[a+4>>2]);K=ea(g[a+8>>2]);L=ea(g[b>>2]);M=ea(g[b+4>>2]);N=ea(I-L);L=ea(J-M);M=ea(K-ea(g[b+8>>2]));O=ea(ea(ea(N*N)+ea(L*L))+ea(M*M))>ea(0.0);g[l>>2]=N;g[l+4>>2]=L;g[l+8>>2]=M;g[l+12>>2]=ea(0.0);g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);P=O?l:k;M=ea(g[P>>2]);L=ea(g[P+4>>2]);N=ea(g[P+8>>2]);g[x>>2]=M;P=x+4|0;g[P>>2]=L;k=x+8|0;g[k>>2]=N;g[x+12>>2]=ea(0.0);K=ea(g[a+32>>2]);J=ea(g[b+32>>2]);I=ea((K>J?J:K)*ea(.100000001));K=ea(I*I);c[y+0>>2]=c[v+0>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];c[y+12>>2]=c[v+12>>2];c[z+0>>2]=c[v+0>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];c[z+12>>2]=c[v+12>>2];v=a+96|0;l=a+96|0;O=a+100|0;Q=a+104|0;R=a+112|0;S=a+112|0;U=a+116|0;V=a+120|0;a=D+4|0;W=D+8|0;X=E+4|0;Y=E+8|0;Z=E+12|0;_=y+4|0;$=y+8|0;aa=y+12|0;ba=s+4|0;ca=s+8|0;da=t+4|0;fa=t+8|0;ga=u+4|0;ha=u+8|0;ia=z+4|0;ja=z+8|0;ka=z+12|0;la=F+4|0;ma=F+8|0;na=F+12|0;oa=s+16|0;I=ea(3402823469999999843913219.0e14);J=M;M=L;L=N;while(1){c[B+0>>2]=c[y+0>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];c[B+12>>2]=c[y+12>>2];c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];N=ea(-J);pa=ea(-M);qa=ea(-L);ra=ea(g[l>>2]);sa=ea(g[O>>2]);ta=ea(ea(ea(ra*N)+ea(sa*pa))+ea(ea(g[Q>>2])*qa));sa=ea(g[S>>2]);ra=ea(g[U>>2]);ua=ta>ea(ea(ea(sa*N)+ea(ra*pa))+ea(ea(g[V>>2])*qa));c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];c[n+12>>2]=c[v+12>>2];c[m+0>>2]=c[R+0>>2];c[m+4>>2]=c[R+4>>2];c[m+8>>2]=c[R+8>>2];c[m+12>>2]=c[R+12>>2];va=ua?n:m;qa=ea(g[va>>2]);pa=ea(g[va+4>>2]);ra=ea(g[va+8>>2]);HFb(D,b,x);N=ea(g[D>>2]);sa=ea(g[a>>2]);ta=ea(g[W>>2]);wa=ea(qa-N);xa=ea(pa-sa);ya=ea(ra-ta);g[E>>2]=wa;g[X>>2]=xa;g[Y>>2]=ya;g[Z>>2]=ea(0.0);za=ea(g[x>>2]);Aa=ea(g[P>>2]);Ba=ea(I-ea(ea(ea(za*wa)+ea(Aa*xa))+ea(ea(g[k>>2])*ya)));va=c[w>>2]|0;g[t+(va<<4)>>2]=qa;g[t+(va<<4)+4>>2]=pa;g[t+(va<<4)+8>>2]=ra;g[t+(va<<4)+12>>2]=ea(0.0);ua=u+(va<<4)|0;c[ua+0>>2]=c[D+0>>2];c[ua+4>>2]=c[D+4>>2];c[ua+8>>2]=c[D+8>>2];c[ua+12>>2]=c[D+12>>2];c[w>>2]=va+1;ua=s+(va<<4)|0;c[ua+0>>2]=c[E+0>>2];c[ua+4>>2]=c[E+4>>2];c[ua+8>>2]=c[E+8>>2];c[ua+12>>2]=c[E+12>>2];if(ea(I*ea(.000224999996))>Ba){Ca=3;break}do if(!va){g[y>>2]=qa;g[_>>2]=pa;g[$>>2]=ra;g[aa>>2]=ea(0.0);c[z+0>>2]=c[D+0>>2];c[z+4>>2]=c[D+4>>2];c[z+8>>2]=c[D+8>>2];c[z+12>>2]=c[D+12>>2];c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2]}else if((va|0)==2)V6a(F,s,oa,E,s,t,u,w,y,z);else if((va|0)==3)pPa(F,s,t,u,w,y,z);else if((va|0)==1){Ba=ea(g[s>>2]);Aa=ea(g[ba>>2]);za=ea(g[ca>>2]);Da=ea(wa-Ba);Ea=ea(xa-Aa);Fa=ea(ya-za);Ga=ea(ea(ea(Da*Da)+ea(Ea*Ea))+ea(Fa*Fa));if(Ga==ea(0.0)){c[w>>2]=1;c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[z+0>>2]=c[u+0>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];c[z+12>>2]=c[u+12>>2];c[F+0>>2]=c[s+0>>2];c[F+4>>2]=c[s+4>>2];c[F+8>>2]=c[s+8>>2];c[F+12>>2]=c[s+12>>2];break}else{Ha=ea(ea(ea(-ea(Aa*Ea))-ea(Ba*Da))-ea(za*Fa));Fa=ea(g[t>>2]);za=ea(g[da>>2]);Da=ea(g[fa>>2]);Ba=ea(qa-Fa);Ea=ea(pa-za);Aa=ea(ra-Da);Ia=ea(g[u>>2]);Ja=ea(g[ga>>2]);Ka=ea(g[ha>>2]);La=ea(N-Ia);Ma=ea(sa-Ja);Na=ea(ta-Ka);Oa=ea(Ha/Ga);ua=Oa>ea(1.0);Ga=ua?ea(1.0):Oa;ua=Ga>ea(0.0);Oa=ua?Ga:ea(0.0);Ga=ea(Fa+ea(Ba*Oa));Ba=ea(za+ea(Ea*Oa));Ea=ea(Da+ea(Aa*Oa));Aa=ea(Ia+ea(La*Oa));La=ea(Ja+ea(Ma*Oa));Ma=ea(Ka+ea(Na*Oa));g[y>>2]=Ga;g[_>>2]=Ba;g[$>>2]=Ea;g[aa>>2]=ea(0.0);g[z>>2]=Aa;g[ia>>2]=La;g[ja>>2]=Ma;g[ka>>2]=ea(0.0);Oa=ea(Ba-La);La=ea(Ea-Ma);g[F>>2]=ea(Ga-Aa);g[la>>2]=Oa;g[ma>>2]=La;g[na>>2]=ea(0.0);break}}else{c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2]}while(0);c[x+0>>2]=c[F+0>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];J=ea(g[x>>2]);M=ea(g[P>>2]);L=ea(g[k>>2]);Pa=ea(ea(ea(J*J)+ea(M*M))+ea(L*L));c[A+0>>2]=c[G+0>>2];c[A+4>>2]=c[G+4>>2];c[A+8>>2]=c[G+8>>2];Qa=I>Pa;if(!(Pa>K)|Qa^1){Ca=13;break}else I=Pa}if((Ca|0)==3){K=ea(g[z>>2]);L=ea(g[ia>>2]);M=ea(g[ja>>2]);J=ea(g[y>>2]);ta=ea(g[_>>2]);sa=ea(K-J);J=ea(L-ta);ta=ea(M-ea(g[$>>2]));M=ea(ea(1.0)/ea(T(ea(ea(ea(sa*sa)+ea(J*J))+ea(ta*ta)))));L=ea(sa*M);sa=ea(J*M);J=ea(ta*M);c[d+0>>2]=c[y+0>>2];c[d+4>>2]=c[y+4>>2];c[d+8>>2]=c[y+8>>2];c[d+12>>2]=c[y+12>>2];c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];g[h>>2]=I;G=h+4|0;c[G+0>>2]=c[A+0>>2];c[G+4>>2]=c[A+4>>2];c[G+8>>2]=c[A+8>>2];g[f>>2]=L;g[f+4>>2]=sa;g[f+8>>2]=J;g[f+12>>2]=ea(0.0);Ra=0;i=j;return Ra|0}else if((Ca|0)==13){c[p+0>>2]=c[y+0>>2];c[p+4>>2]=c[y+4>>2];c[p+8>>2]=c[y+8>>2];c[p+12>>2]=c[y+12>>2];c[o+0>>2]=c[B+0>>2];c[o+4>>2]=c[B+4>>2];c[o+8>>2]=c[B+8>>2];c[o+12>>2]=c[B+12>>2];B=Qa?p:o;J=ea(g[B>>2]);sa=ea(g[B+4>>2]);L=ea(g[B+8>>2]);g[y>>2]=J;g[_>>2]=sa;g[$>>2]=L;g[aa>>2]=ea(0.0);c[r+0>>2]=c[z+0>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2];c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];C=Qa?r:q;M=ea(g[C>>2]);ta=ea(g[C+4>>2]);K=ea(g[C+8>>2]);g[z>>2]=M;g[ia>>2]=ta;g[ja>>2]=K;g[ka>>2]=ea(0.0);c[d+0>>2]=c[y+0>>2];c[d+4>>2]=c[y+4>>2];c[d+8>>2]=c[y+8>>2];c[d+12>>2]=c[y+12>>2];c[e+0>>2]=c[z+0>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];N=ea(M-J);J=ea(ta-sa);sa=ea(K-L);L=ea(ea(1.0)/ea(T(ea(ea(ea(N*N)+ea(J*J))+ea(sa*sa)))));K=ea(J*L);J=ea(sa*L);g[f>>2]=ea(N*L);g[f+4>>2]=K;g[f+8>>2]=J;g[f+12>>2]=ea(0.0);g[h>>2]=Qa?Pa:I;f=h+4|0;c[f+0>>2]=c[H+0>>2];c[f+4>>2]=c[H+4>>2];c[f+8>>2]=c[H+8>>2];Ra=Qa?1:3;i=j;return Ra|0}return 0}function t7a(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=0,jb=0;j=i;i=i+512|0;k=j+448|0;l=j+128|0;m=j+144|0;n=j+176|0;o=j+96|0;p=j+112|0;q=j+336|0;r=j+368|0;s=j+400|0;t=j+432|0;u=j+192|0;v=j+256|0;w=j+32|0;x=j;y=j+488|0;z=j+320|0;A=j+352|0;B=j+492|0;C=j+384|0;D=j+416|0;E=j+160|0;F=j+16|0;G=j+476|0;H=j+464|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[y>>2]=0;I=ea(g[a>>2]);J=ea(g[a+4>>2]);K=ea(g[a+8>>2]);L=ea(g[b>>2]);M=ea(g[b+4>>2]);N=ea(I-L);L=ea(J-M);M=ea(K-ea(g[b+8>>2]));O=ea(ea(ea(N*N)+ea(L*L))+ea(M*M))>ea(0.0);g[l>>2]=N;g[l+4>>2]=L;g[l+8>>2]=M;g[l+12>>2]=ea(0.0);g[k>>2]=ea(1.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(0.0);P=O?l:k;M=ea(g[P>>2]);L=ea(g[P+4>>2]);N=ea(g[P+8>>2]);K=ea(g[a+32>>2]);J=ea(g[b+32>>2]);I=ea((K>J?J:K)*ea(.100000001));K=ea(I*I);c[z+0>>2]=c[x+0>>2];c[z+4>>2]=c[x+4>>2];c[z+8>>2]=c[x+8>>2];c[z+12>>2]=c[x+12>>2];c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2];x=a+96|0;P=a+100|0;k=a+104|0;l=a+108|0;O=a+112|0;Q=a+116|0;R=a+120|0;S=a+124|0;U=a+128|0;V=a+132|0;W=a+136|0;X=a+140|0;a=n+4|0;Y=n+8|0;Z=n+12|0;_=m+4|0;$=m+8|0;aa=m+12|0;ba=p+4|0;ca=p+8|0;da=p+12|0;fa=o+4|0;ga=o+8|0;ha=o+12|0;ia=b+144|0;ja=b+144|0;ka=b+148|0;la=b+152|0;b=m+4|0;ma=m+8|0;na=m+12|0;oa=E+4|0;pa=E+8|0;qa=E+12|0;ra=F+4|0;sa=F+8|0;ta=z+4|0;ua=z+8|0;va=z+12|0;wa=A+4|0;xa=A+8|0;ya=A+12|0;za=u+4|0;Aa=u+8|0;Ba=v+4|0;Ca=v+8|0;Da=w+4|0;Ea=w+8|0;Fa=F+12|0;Ga=u+16|0;I=N;N=ea(3402823469999999843913219.0e14);J=M;M=L;while(1){c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];L=ea(-J);Ha=ea(-M);Ia=ea(-I);Ja=ea(g[x>>2]);Ka=ea(g[P>>2]);La=ea(g[k>>2]);Ma=ea(g[l>>2]);Na=ea(g[O>>2]);Oa=ea(g[Q>>2]);Pa=ea(g[R>>2]);Qa=ea(g[S>>2]);Ra=ea(g[U>>2]);Sa=ea(g[V>>2]);Ta=ea(g[W>>2]);Ua=ea(g[X>>2]);Va=ea(ea(ea(Ja*L)+ea(Ka*Ha))+ea(La*Ia));Wa=ea(ea(ea(Na*L)+ea(Oa*Ha))+ea(Pa*Ia));Xa=ea(ea(ea(Ra*L)+ea(Sa*Ha))+ea(Ta*Ia));if(Va>Wa)Ya=Va>Xa?p:o;else Ya=o;g[n>>2]=Na;g[a>>2]=Oa;g[Y>>2]=Pa;g[Z>>2]=Qa;g[m>>2]=Ra;g[_>>2]=Sa;g[$>>2]=Ta;g[aa>>2]=Ua;Za=Wa>Xa?n:m;Xa=ea(g[Za>>2]);Wa=ea(g[Za+4>>2]);Ua=ea(g[Za+8>>2]);g[p>>2]=Ja;g[ba>>2]=Ka;g[ca>>2]=La;g[da>>2]=Ma;g[o>>2]=Xa;g[fa>>2]=Wa;g[ga>>2]=Ua;g[ha>>2]=ea(0.0);Ua=ea(g[Ya>>2]);Wa=ea(g[Ya+4>>2]);Xa=ea(g[Ya+8>>2]);Za=J>ea(0.0);_a=M>ea(0.0);$a=I>ea(0.0);c[n+0>>2]=c[ia+0>>2];c[n+4>>2]=c[ia+4>>2];c[n+8>>2]=c[ia+8>>2];c[n+12>>2]=c[ia+12>>2];Ma=ea(g[ja>>2]);La=ea(g[ka>>2]);Ka=ea(-La);La=ea(-ea(g[la>>2]));g[m>>2]=ea(-Ma);g[b>>2]=Ka;g[ma>>2]=La;g[na>>2]=ea(0.0);La=ea(g[(Za?n:m)>>2]);Ka=ea(g[(_a?n:m)+4>>2]);Ma=ea(g[($a?n:m)+8>>2]);Ja=ea(Ua-La);Ta=ea(Wa-Ka);Sa=ea(Xa-Ma);g[E>>2]=Ja;g[oa>>2]=Ta;g[pa>>2]=Sa;g[qa>>2]=ea(0.0);Ra=ea(N-ea(ea(ea(J*Ja)+ea(M*Ta))+ea(I*Sa)));$a=c[y>>2]|0;g[v+($a<<4)>>2]=Ua;g[v+($a<<4)+4>>2]=Wa;g[v+($a<<4)+8>>2]=Xa;g[v+($a<<4)+12>>2]=ea(0.0);g[w+($a<<4)>>2]=La;g[w+($a<<4)+4>>2]=Ka;g[w+($a<<4)+8>>2]=Ma;g[w+($a<<4)+12>>2]=ea(0.0);c[y>>2]=$a+1;_a=u+($a<<4)|0;c[_a+0>>2]=c[E+0>>2];c[_a+4>>2]=c[E+4>>2];c[_a+8>>2]=c[E+8>>2];c[_a+12>>2]=c[E+12>>2];if(ea(N*ea(.000224999996))>Ra){ab=5;break}do if(($a|0)==3)pPa(F,u,v,w,y,z,A);else if(($a|0)==2)V6a(F,u,Ga,E,u,v,w,y,z,A);else if(($a|0)==1){Ra=ea(g[u>>2]);Qa=ea(g[za>>2]);Pa=ea(g[Aa>>2]);Oa=ea(Ja-Ra);Na=ea(Ta-Qa);Va=ea(Sa-Pa);Ia=ea(ea(ea(Oa*Oa)+ea(Na*Na))+ea(Va*Va));if(Ia==ea(0.0)){c[y>>2]=1;c[z+0>>2]=c[v+0>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];c[z+12>>2]=c[v+12>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[F+0>>2]=c[u+0>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];c[F+12>>2]=c[u+12>>2];break}else{Ha=ea(ea(ea(-ea(Qa*Na))-ea(Ra*Oa))-ea(Pa*Va));Va=ea(g[v>>2]);Pa=ea(g[Ba>>2]);Oa=ea(g[Ca>>2]);Ra=ea(Ua-Va);Na=ea(Wa-Pa);Qa=ea(Xa-Oa);L=ea(g[w>>2]);bb=ea(g[Da>>2]);cb=ea(g[Ea>>2]);db=ea(La-L);eb=ea(Ka-bb);fb=ea(Ma-cb);gb=ea(Ha/Ia);_a=gb>ea(1.0);Ia=_a?ea(1.0):gb;_a=Ia>ea(0.0);gb=_a?Ia:ea(0.0);Ia=ea(Va+ea(Ra*gb));Ra=ea(Pa+ea(Na*gb));Na=ea(Oa+ea(Qa*gb));Qa=ea(L+ea(db*gb));db=ea(bb+ea(eb*gb));eb=ea(cb+ea(fb*gb));g[z>>2]=Ia;g[ta>>2]=Ra;g[ua>>2]=Na;g[va>>2]=ea(0.0);g[A>>2]=Qa;g[wa>>2]=db;g[xa>>2]=eb;g[ya>>2]=ea(0.0);gb=ea(Ra-db);db=ea(Na-eb);g[F>>2]=ea(Ia-Qa);g[ra>>2]=gb;g[sa>>2]=db;g[Fa>>2]=ea(0.0);break}}else if(!$a){g[z>>2]=Ua;g[ta>>2]=Wa;g[ua>>2]=Xa;g[va>>2]=ea(0.0);g[A>>2]=La;g[wa>>2]=Ka;g[xa>>2]=Ma;g[ya>>2]=ea(0.0);c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2]}else{c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2]}while(0);J=ea(g[F>>2]);M=ea(g[ra>>2]);I=ea(g[sa>>2]);hb=ea(ea(ea(J*J)+ea(M*M))+ea(I*I));c[B+0>>2]=c[G+0>>2];c[B+4>>2]=c[G+4>>2];c[B+8>>2]=c[G+8>>2];ib=N>hb;if(!(hb>K)|ib^1){ab=15;break}else N=hb}if((ab|0)==5){K=ea(g[A>>2]);I=ea(g[wa>>2]);M=ea(g[xa>>2]);J=ea(g[z>>2]);Ma=ea(g[ta>>2]);Ka=ea(K-J);J=ea(I-Ma);Ma=ea(M-ea(g[ua>>2]));M=ea(ea(1.0)/ea(T(ea(ea(ea(Ka*Ka)+ea(J*J))+ea(Ma*Ma)))));I=ea(Ka*M);Ka=ea(J*M);J=ea(Ma*M);c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[d+12>>2]=c[z+12>>2];c[e+0>>2]=c[A+0>>2];c[e+4>>2]=c[A+4>>2];c[e+8>>2]=c[A+8>>2];c[e+12>>2]=c[A+12>>2];g[h>>2]=N;G=h+4|0;c[G+0>>2]=c[B+0>>2];c[G+4>>2]=c[B+4>>2];c[G+8>>2]=c[B+8>>2];g[f>>2]=I;g[f+4>>2]=Ka;g[f+8>>2]=J;g[f+12>>2]=ea(0.0);jb=0;i=j;return jb|0}else if((ab|0)==15){c[r+0>>2]=c[z+0>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2];c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];C=ib?r:q;J=ea(g[C>>2]);Ka=ea(g[C+4>>2]);I=ea(g[C+8>>2]);g[z>>2]=J;g[ta>>2]=Ka;g[ua>>2]=I;g[va>>2]=ea(0.0);c[t+0>>2]=c[A+0>>2];c[t+4>>2]=c[A+4>>2];c[t+8>>2]=c[A+8>>2];c[t+12>>2]=c[A+12>>2];c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[s+12>>2]=c[D+12>>2];D=ib?t:s;M=ea(g[D>>2]);Ma=ea(g[D+4>>2]);K=ea(g[D+8>>2]);g[A>>2]=M;g[wa>>2]=Ma;g[xa>>2]=K;g[ya>>2]=ea(0.0);c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[d+12>>2]=c[z+12>>2];c[e+0>>2]=c[A+0>>2];c[e+4>>2]=c[A+4>>2];c[e+8>>2]=c[A+8>>2];c[e+12>>2]=c[A+12>>2];La=ea(M-J);J=ea(Ma-Ka);Ka=ea(K-I);I=ea(ea(1.0)/ea(T(ea(ea(ea(La*La)+ea(J*J))+ea(Ka*Ka)))));K=ea(J*I);J=ea(Ka*I);g[f>>2]=ea(La*I);g[f+4>>2]=K;g[f+8>>2]=J;g[f+12>>2]=ea(0.0);g[h>>2]=ib?hb:N;f=h+4|0;c[f+0>>2]=c[H+0>>2];c[f+4>>2]=c[H+4>>2];c[f+8>>2]=c[H+8>>2];jb=ib?1:3;i=j;return jb|0}return 0}function u7a(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im;e=i;i=i+176|0;o=e+96|0;p=e+64|0;q=e+48|0;r=e+144|0;s=e+16|0;t=e;u=e+80|0;v=e+32|0;w=e+164|0;x=e+160|0;y=e+156|0;z=e+128|0;A=e+112|0;if(!(JFb(b,d,0,f,h,q,p,o,m)|0)){B=0;i=e;return B|0};c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];if(!(ea(g[q>>2])!=ea(0.0)|n^1)){m=ea(g[b+16>>2]);g[s>>2]=ea(ea(m+ea(g[d+16>>2]))*ea(100.0));g[v>>2]=ea(0.0);n=v+4|0;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];a[y>>0]=0;q=KFb(b,d,s,t,u,p,v,w,x,y,0)|0;do if((q|0)==6){a[z+4>>0]=0;c[z>>2]=541176;c[z+8>>2]=b;c[z+12>>2]=d;if(((cPa(b,d,z,w,x,a[y>>0]|0,t,u,p,v,0)|0)+-5|0)>>>0<2){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];break}else{m=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);E=ea(ea(1.0)/ea(T(ea(ea(ea(m*m)+ea(C*C))+ea(D*D)))));F=ea(-ea(C*E));C=ea(-ea(D*E));g[p>>2]=ea(-ea(m*E));g[p+4>>2]=F;g[p+8>>2]=C;g[p+12>>2]=ea(0.0);c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];g[v>>2]=ea(0.0);c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];break}}else if((q|0)==1){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}else{c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}while(0);C=ea(g[v>>2]);v=C<ea(0.0);g[j>>2]=v?C:ea(0.0);v=j+4|0;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2]};c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];B=1;i=e;return B|0}function v7a(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im;e=i;i=i+176|0;o=e+96|0;p=e+64|0;q=e+48|0;r=e+144|0;s=e+16|0;t=e;u=e+80|0;v=e+32|0;w=e+164|0;x=e+160|0;y=e+156|0;z=e+128|0;A=e+112|0;if(!(LFb(b,d,0,f,h,q,p,o,m)|0)){B=0;i=e;return B|0};c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];if(!(ea(g[q>>2])!=ea(0.0)|n^1)){m=ea(g[b+16>>2]);g[s>>2]=ea(ea(m+ea(g[d+16>>2]))*ea(100.0));g[v>>2]=ea(0.0);n=v+4|0;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];a[y>>0]=0;q=MFb(b,d,s,t,u,p,v,w,x,y,0)|0;do if((q|0)==6){a[z+4>>0]=0;c[z>>2]=541144;c[z+8>>2]=b;c[z+12>>2]=d;if(((cPa(b,d,z,w,x,a[y>>0]|0,t,u,p,v,0)|0)+-5|0)>>>0<2){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];break}else{m=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);E=ea(ea(1.0)/ea(T(ea(ea(ea(m*m)+ea(C*C))+ea(D*D)))));F=ea(-ea(C*E));C=ea(-ea(D*E));g[p>>2]=ea(-ea(m*E));g[p+4>>2]=F;g[p+8>>2]=C;g[p+12>>2]=ea(0.0);c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];g[v>>2]=ea(0.0);c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];break}}else if((q|0)==1){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}else{c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}while(0);C=ea(g[v>>2]);v=C<ea(0.0);g[j>>2]=v?C:ea(0.0);v=j+4|0;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2]};c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];B=1;i=e;return B|0}function w7a(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im;e=i;i=i+176|0;o=e+96|0;p=e+64|0;q=e+48|0;r=e+144|0;s=e+16|0;t=e;u=e+80|0;v=e+32|0;w=e+164|0;x=e+160|0;y=e+156|0;z=e+128|0;A=e+112|0;if(!(NFb(b,d,0,f,h,q,p,o,m)|0)){B=0;i=e;return B|0};c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];if(!(ea(g[q>>2])!=ea(0.0)|n^1)){m=ea(g[b+16>>2]);g[s>>2]=ea(ea(m+ea(g[d+16>>2]))*ea(100.0));g[v>>2]=ea(0.0);n=v+4|0;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];a[y>>0]=0;q=$6a(b,d,s,t,u,p,v,w,x,y,0)|0;do if((q|0)==1){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}else if((q|0)==6){a[z+4>>0]=0;c[z>>2]=541240;c[z+8>>2]=b;c[z+12>>2]=d;if(((cPa(b,d,z,w,x,a[y>>0]|0,t,u,p,v,0)|0)+-5|0)>>>0<2){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];break}else{m=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);E=ea(ea(1.0)/ea(T(ea(ea(ea(m*m)+ea(C*C))+ea(D*D)))));F=ea(-ea(C*E));C=ea(-ea(D*E));g[p>>2]=ea(-ea(m*E));g[p+4>>2]=F;g[p+8>>2]=C;g[p+12>>2]=ea(0.0);c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];g[v>>2]=ea(0.0);c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];break}}else{c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}while(0);C=ea(g[v>>2]);v=C<ea(0.0);g[j>>2]=v?C:ea(0.0);v=j+4|0;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2]};c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];B=1;i=e;return B|0}function x7a(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im;e=i;i=i+176|0;o=e+96|0;p=e+64|0;q=e+48|0;r=e+144|0;s=e+16|0;t=e;u=e+80|0;v=e+32|0;w=e+164|0;x=e+160|0;y=e+156|0;z=e+128|0;A=e+112|0;if(!(OFb(b,d,0,f,h,q,p,o,m)|0)){B=0;i=e;return B|0};c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];if(!(ea(g[q>>2])!=ea(0.0)|n^1)){m=ea(g[b+16>>2]);g[s>>2]=ea(ea(m+ea(g[d+16>>2]))*ea(100.0));g[v>>2]=ea(0.0);n=v+4|0;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];a[y>>0]=0;q=b7a(b,d,s,t,u,p,v,w,x,y,0)|0;do if((q|0)==1){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}else if((q|0)==6){a[z+4>>0]=0;c[z>>2]=541208;c[z+8>>2]=b;c[z+12>>2]=d;if(((cPa(b,d,z,w,x,a[y>>0]|0,t,u,p,v,0)|0)+-5|0)>>>0<2){c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];break}else{m=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);E=ea(ea(1.0)/ea(T(ea(ea(ea(m*m)+ea(C*C))+ea(D*D)))));F=ea(-ea(C*E));C=ea(-ea(D*E));g[p>>2]=ea(-ea(m*E));g[p+4>>2]=F;g[p+8>>2]=C;g[p+12>>2]=ea(0.0);c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];g[v>>2]=ea(0.0);c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];break}}else{c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2]}while(0);C=ea(g[v>>2]);v=C<ea(0.0);g[j>>2]=v?C:ea(0.0);v=j+4|0;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2]};c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];B=1;i=e;return B|0}function y7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(PFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=QFb(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541496;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function z7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(RFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=k7a(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541464;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function A7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(SFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=TFb(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541432;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function B7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(UFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=l7a(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541400;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function C7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(VFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=WFb(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541368;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function D7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(XFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=YFb(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541336;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function E7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(ZFb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=d7a(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541112;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function F7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;f=i;i=i+176|0;p=f+96|0;q=f+64|0;r=f+48|0;s=f+144|0;t=f+16|0;u=f;v=f+80|0;w=f+32|0;x=f+164|0;y=f+160|0;z=f+156|0;A=f+124|0;B=f+112|0;if(!(_Fb(b,d,e,0,h,j,r,q,p,n)|0)){C=0;i=f;return C|0};c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];if(!(ea(g[r>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[t>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[z>>0]=0;o=e7a(b,d,e,t,u,v,q,w,x,y,z)|0;do if((o|0)==1){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}else if((o|0)==6){a[A+4>>0]=0;c[A>>2]=541080;c[A+8>>2]=b;c[A+12>>2]=d;c[A+16>>2]=e;if(((cPa(b,d,A,x,y,a[z>>0]|0,u,v,q,w,0)|0)+-5|0)>>>0<2){c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];break}else{n=ea(g[j>>2]);D=ea(g[j+4>>2]);E=ea(g[j+8>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(D*D))+ea(E*E)))));G=ea(-ea(D*F));D=ea(-ea(E*F));g[q>>2]=ea(-ea(n*F));g[q+4>>2]=G;g[q+8>>2]=D;g[q+12>>2]=ea(0.0);c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];g[w>>2]=ea(0.0);t=w+4|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];break}}else{c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2]}while(0);D=ea(g[w>>2]);w=D<ea(0.0);g[k>>2]=w?D:ea(0.0);w=k+4|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]};c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];C=1;i=f;return C|0}function G7a(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im;p=i;i=i+176|0;q=p+96|0;r=p+64|0;s=p+48|0;t=p+144|0;u=p+16|0;v=p;w=p+80|0;x=p+32|0;y=p+164|0;z=p+160|0;A=p+156|0;B=p+124|0;C=p+112|0;if(!($Fb(b,d,e,f,h,j,s,r,q,n)|0)){D=0;i=p;return D|0};c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];c[k+12>>2]=c[s+12>>2];if(!(ea(g[s>>2])!=ea(0.0)|o^1)){n=ea(g[b+16>>2]);g[u>>2]=ea(ea(n+ea(g[d+16>>2]))*ea(100.0));a[A>>0]=0;o=g7a(b,d,e,u,v,w,r,x,y,z,A)|0;do if((o|0)==1){c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[q+12>>2]=c[v+12>>2]}else if((o|0)==6){a[B+4>>0]=0;c[B>>2]=541048;c[B+8>>2]=b;c[B+12>>2]=d;c[B+16>>2]=e;if(((cPa(b,d,B,y,z,a[A>>0]|0,v,w,r,x,0)|0)+-5|0)>>>0<2){c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[q+12>>2]=c[v+12>>2];break}else{n=ea(g[j>>2]);E=ea(g[j+4>>2]);F=ea(g[j+8>>2]);G=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(E*E))+ea(F*F)))));H=ea(-ea(E*G));E=ea(-ea(F*G));g[r>>2]=ea(-ea(n*G));g[r+4>>2]=H;g[r+8>>2]=E;g[r+12>>2]=ea(0.0);c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[q+12>>2]=c[v+12>>2];g[x>>2]=ea(0.0);u=x+4|0;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];break}}else{c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[q+12>>2]=c[v+12>>2]}while(0);E=ea(g[x>>2]);x=E<ea(0.0);g[k>>2]=x?E:ea(0.0);x=k+4|0;c[x+0>>2]=c[C+0>>2];c[x+4>>2]=c[C+4>>2];c[x+8>>2]=c[C+8>>2]};c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];c[m+12>>2]=c[q+12>>2];c[l+0>>2]=c[r+0>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];D=1;i=p;return D|0}function H7a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im;j=i;i=i+560|0;k=j+368|0;l=j+320|0;m=j;n=j+160|0;o=j+356|0;p=j+540|0;q=j+404|0;r=j+476|0;s=j+480|0;t=j+416|0;u=ea(g[f>>2]);if(u==ea(1.0)){v=ea(g[f+4>>2]);if(v==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0){w=l;c[w>>2]=0;c[w+4>>2]=0;c[l>>2]=c[d>>2];c[l+4>>2]=d+16;g[l+8>>2]=ea(g[d+4>>2]);c[m+4>>2]=2;c[m>>2]=542696;c[m+8>>2]=d;c[m+16>>2]=k;w=m+68|0;a[w>>0]=0;c[m+116>>2]=h;x=ea(g[b>>2]);y=ea(x-ea(g[e+16>>2]));x=ea(g[b+4>>2]);z=ea(x-ea(g[e+20>>2]));x=ea(g[b+8>>2]);A=ea(y*ea(2.0));y=ea(z*ea(2.0));z=ea(ea(x-ea(g[e+24>>2]))*ea(2.0));x=ea(g[e+12>>2]);B=ea(ea(x*x)+ea(-.5));C=ea(g[e>>2]);D=ea(A*C);E=ea(g[e+4>>2]);F=ea(D+ea(y*E));D=ea(g[e+8>>2]);G=ea(F+ea(z*D));F=ea(ea(C*G)+ea(ea(A*B)-ea(x*ea(ea(z*E)-ea(y*D)))));H=ea(ea(E*G)+ea(ea(y*B)-ea(x*ea(ea(A*D)-ea(z*C)))));I=ea(ea(ea(z*B)-ea(x*ea(ea(y*C)-ea(A*E))))+ea(D*G));g[m+76>>2]=F;g[m+80>>2]=H;g[m+84>>2]=I;G=ea(g[b+12>>2]);g[m+72>>2]=ea(G*G);g[n>>2]=F;g[n+4>>2]=H;g[n+8>>2]=I;g[o>>2]=ea(1.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0);J=G>ea(.00100000005);I=J?G:ea(.00100000005);g[p>>2]=I;g[p+4>>2]=I;g[p+8>>2]=I;yQa(n,o,ea(0.0),1,l,m,p);K=a[w>>0]|0;L=K<<24>>24!=0;i=j;return L|0}else M=v}else M=ea(g[f+4>>2]);v=ea(g[f+12>>2]);I=ea(g[f+16>>2]);G=ea(g[f+20>>2]);H=ea(g[f+24>>2]);F=ea(v+v);D=ea(I+I);E=ea(G+G);A=ea(I*D);C=ea(G*E);y=ea(F*I);I=ea(F*G);x=ea(F*H);B=ea(D*G);G=ea(D*H);D=ea(E*H);H=ea(ea(ea(1.0)-A)-C);E=ea(y+D);z=ea(I-G);N=ea(y-D);D=ea(ea(1.0)-ea(v*F));F=ea(D-C);C=ea(B+x);v=ea(I+G);G=ea(B-x);x=ea(D-A);A=ea(u*H);D=ea(u*N);B=ea(u*v);u=ea(E*M);I=ea(F*M);y=ea(G*M);M=ea(g[f+8>>2]);O=ea(z*M);P=ea(C*M);Q=ea(x*M);M=ea(ea(ea(H*D)+ea(E*I))+ea(z*P));R=ea(ea(ea(H*B)+ea(E*y))+ea(z*Q));S=ea(ea(ea(N*A)+ea(F*u))+ea(C*O));T=ea(ea(ea(N*D)+ea(F*I))+ea(C*P));U=ea(ea(ea(N*B)+ea(F*y))+ea(C*Q));C=ea(ea(ea(v*A)+ea(G*u))+ea(x*O));F=ea(ea(ea(v*D)+ea(G*I))+ea(x*P));P=ea(ea(ea(v*B)+ea(G*y))+ea(x*Q));g[k>>2]=ea(ea(ea(H*A)+ea(E*u))+ea(z*O));g[k+4>>2]=M;g[k+8>>2]=R;g[k+12>>2]=S;g[k+16>>2]=T;g[k+20>>2]=U;g[k+24>>2]=C;g[k+28>>2]=F;g[k+32>>2]=P;F0a(l,k);l=m;c[l>>2]=0;c[l+4>>2]=0;c[m>>2]=c[d>>2];c[m+4>>2]=d+16;g[m+8>>2]=ea(g[d+4>>2]);c[n+4>>2]=2;c[n>>2]=542672;c[n+8>>2]=d;c[n+16>>2]=k;k=n+68|0;a[k>>0]=0;c[n+116>>2]=h;P=ea(g[b>>2]);F=ea(P-ea(g[e+16>>2]));C=ea(g[b+4>>2]);U=ea(C-ea(g[e+20>>2]));T=ea(g[b+8>>2]);S=ea(F*ea(2.0));F=ea(U*ea(2.0));U=ea(ea(T-ea(g[e+24>>2]))*ea(2.0));R=ea(g[e+12>>2]);M=ea(ea(R*R)+ea(-.5));O=ea(g[e>>2]);z=ea(S*O);u=ea(g[e+4>>2]);E=ea(z+ea(F*u));z=ea(g[e+8>>2]);A=ea(E+ea(U*z));E=ea(ea(u*A)+ea(ea(F*M)-ea(R*ea(ea(S*z)-ea(U*O)))));H=ea(ea(ea(U*M)-ea(R*ea(ea(F*O)-ea(S*u))))+ea(z*A));g[n+76>>2]=ea(ea(O*A)+ea(ea(S*M)-ea(R*ea(ea(U*u)-ea(F*z)))));g[n+80>>2]=E;g[n+84>>2]=H;H=ea(g[b+12>>2]);g[n+72>>2]=ea(H*H);g[s>>2]=ea(1.0);g[s+4>>2]=ea(0.0);g[s+8>>2]=ea(0.0);g[s+12>>2]=ea(0.0);g[s+16>>2]=ea(1.0);g[s+20>>2]=ea(0.0);g[s+24>>2]=ea(0.0);g[s+28>>2]=ea(0.0);g[s+32>>2]=ea(1.0);g[s+36>>2]=P;g[s+40>>2]=C;g[s+44>>2]=T;g[s+48>>2]=H;g[s+52>>2]=H;g[s+56>>2]=H;AOa(t,s,e,f);aGb(t,o,q,p,r);yQa(o,p,ea(g[r>>2]),1,m,n,q);K=a[k>>0]|0;L=K<<24>>24!=0;i=j;return L|0}function I7a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im;j=i;i=i+512|0;k=j+476|0;l=j+320|0;m=j+160|0;n=j;o=j+416|0;p=j+356|0;q=ea(g[f>>2]);if(q==ea(1.0)){r=ea(g[f+4>>2]);if(r==ea(1.0)?ea(g[f+8>>2])==ea(1.0):0){s=l;c[s>>2]=0;c[s+4>>2]=0;c[l>>2]=c[d>>2];c[l+4>>2]=d+16;g[l+8>>2]=ea(g[d+4>>2]);c[m+4>>2]=2;c[m>>2]=542648;c[m+8>>2]=d;c[m+16>>2]=k;s=m+68|0;a[s>>0]=0;c[m+116>>2]=h;t=ea(g[b+24>>2]);g[m+72>>2]=ea(t*t);u=m+88|0;v=ea(g[b>>2]);w=ea(g[e+16>>2]);x=ea(v-w);v=ea(g[b+4>>2]);y=ea(g[e+20>>2]);z=ea(v-y);v=ea(g[b+8>>2]);A=ea(g[e+24>>2]);B=ea(x*ea(2.0));x=ea(z*ea(2.0));z=ea(ea(v-A)*ea(2.0));v=ea(g[e+12>>2]);C=ea(ea(v*v)+ea(-.5));D=ea(g[e>>2]);E=ea(B*D);F=ea(g[e+4>>2]);G=ea(E+ea(x*F));E=ea(g[e+8>>2]);H=ea(G+ea(z*E));G=ea(ea(D*H)+ea(ea(B*C)-ea(v*ea(ea(z*F)-ea(x*E)))));I=ea(ea(F*H)+ea(ea(x*C)-ea(v*ea(ea(B*E)-ea(z*D)))));J=ea(ea(ea(z*C)-ea(v*ea(ea(x*D)-ea(B*F))))+ea(E*H));g[u>>2]=G;g[m+92>>2]=I;g[m+96>>2]=J;H=ea(ea(g[b+12>>2])-w);w=ea(ea(g[b+16>>2])-y);y=ea(H*ea(2.0));H=ea(w*ea(2.0));w=ea(ea(ea(g[b+20>>2])-A)*ea(2.0));A=ea(ea(ea(D*y)+ea(F*H))+ea(E*w));B=ea(ea(D*A)+ea(ea(C*y)-ea(v*ea(ea(F*w)-ea(E*H)))));x=ea(ea(F*A)+ea(ea(C*H)-ea(v*ea(ea(E*y)-ea(D*w)))));z=ea(ea(ea(C*w)-ea(v*ea(ea(D*H)-ea(F*y))))+ea(E*A));g[m+100>>2]=B;g[m+104>>2]=x;g[m+108>>2]=z;g[m+112>>2]=t;g[n>>2]=t;g[n+4>>2]=t;g[n+8>>2]=t;t=ea(x-I);I=ea(z-J);g[o>>2]=ea(B-G);g[o+4>>2]=t;g[o+8>>2]=I;wQa(u,o,ea(1.0),1,l,m,n);K=a[s>>0]|0;L=K<<24>>24!=0;i=j;return L|0}else M=r}else M=ea(g[f+4>>2]);r=ea(g[f+12>>2]);I=ea(g[f+16>>2]);t=ea(g[f+20>>2]);G=ea(g[f+24>>2]);B=ea(r+r);J=ea(I+I);z=ea(t+t);x=ea(I*J);A=ea(t*z);E=ea(B*I);I=ea(B*t);y=ea(B*G);F=ea(J*t);t=ea(J*G);J=ea(z*G);G=ea(ea(ea(1.0)-x)-A);z=ea(E+J);H=ea(I-t);D=ea(E-J);J=ea(ea(1.0)-ea(r*B));B=ea(J-A);A=ea(F+y);r=ea(I+t);t=ea(F-y);y=ea(J-x);x=ea(q*G);J=ea(q*D);F=ea(q*r);q=ea(z*M);I=ea(B*M);E=ea(t*M);M=ea(g[f+8>>2]);v=ea(H*M);w=ea(A*M);C=ea(y*M);M=ea(ea(ea(G*J)+ea(z*I))+ea(H*w));N=ea(ea(ea(G*F)+ea(z*E))+ea(H*C));O=ea(ea(ea(D*x)+ea(B*q))+ea(A*v));P=ea(ea(ea(D*J)+ea(B*I))+ea(A*w));Q=ea(ea(ea(D*F)+ea(B*E))+ea(A*C));A=ea(ea(ea(r*x)+ea(t*q))+ea(y*v));B=ea(ea(ea(r*J)+ea(t*I))+ea(y*w));w=ea(ea(ea(r*F)+ea(t*E))+ea(y*C));g[k>>2]=ea(ea(ea(G*x)+ea(z*q))+ea(H*v));g[k+4>>2]=M;g[k+8>>2]=N;g[k+12>>2]=O;g[k+16>>2]=P;g[k+20>>2]=Q;g[k+24>>2]=A;g[k+28>>2]=B;g[k+32>>2]=w;F0a(l,k);l=m;c[l>>2]=0;c[l+4>>2]=0;c[m>>2]=c[d>>2];c[m+4>>2]=d+16;g[m+8>>2]=ea(g[d+4>>2]);c[n+4>>2]=2;c[n>>2]=542624;c[n+8>>2]=d;c[n+16>>2]=k;k=n+68|0;a[k>>0]=0;c[n+116>>2]=h;w=ea(g[b+24>>2]);g[n+72>>2]=ea(w*w);B=ea(g[b>>2]);A=ea(g[e+16>>2]);Q=ea(B-A);B=ea(g[b+4>>2]);P=ea(g[e+20>>2]);O=ea(B-P);B=ea(g[b+8>>2]);N=ea(g[e+24>>2]);M=ea(Q*ea(2.0));Q=ea(O*ea(2.0));O=ea(ea(B-N)*ea(2.0));B=ea(g[e+12>>2]);v=ea(ea(B*B)+ea(-.5));H=ea(g[e>>2]);q=ea(M*H);z=ea(g[e+4>>2]);x=ea(q+ea(Q*z));q=ea(g[e+8>>2]);G=ea(x+ea(O*q));x=ea(ea(z*G)+ea(ea(Q*v)-ea(B*ea(ea(M*q)-ea(O*H)))));C=ea(ea(ea(O*v)-ea(B*ea(ea(Q*H)-ea(M*z))))+ea(q*G));g[n+88>>2]=ea(ea(H*G)+ea(ea(M*v)-ea(B*ea(ea(O*z)-ea(Q*q)))));g[n+92>>2]=x;g[n+96>>2]=C;C=ea(ea(g[b+12>>2])-A);A=ea(ea(g[b+16>>2])-P);P=ea(C*ea(2.0));C=ea(A*ea(2.0));A=ea(ea(ea(g[b+20>>2])-N)*ea(2.0));N=ea(ea(ea(H*P)+ea(z*C))+ea(q*A));x=ea(ea(z*N)+ea(ea(v*C)-ea(B*ea(ea(q*P)-ea(H*A)))));Q=ea(ea(ea(v*A)-ea(B*ea(ea(H*C)-ea(z*P))))+ea(q*N));g[n+100>>2]=ea(ea(H*N)+ea(ea(v*P)-ea(B*ea(ea(z*A)-ea(q*C)))));g[n+104>>2]=x;g[n+108>>2]=Q;g[n+112>>2]=w;RKa(p,b);AOa(o,p,e,f);vQa(o,1,m,n,1);K=a[k>>0]|0;L=K<<24>>24!=0;i=j;return L|0}function J7a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im;j=i;i=i+512|0;k=j+224|0;l=j+448|0;m=j+384|0;n=j+64|0;o=j;p=j+484|0;if((ea(g[f>>2])==ea(1.0)?ea(g[f+4>>2])==ea(1.0):0)?ea(g[f+8>>2])==ea(1.0):0){q=m;c[q>>2]=0;c[q+4>>2]=0;c[m>>2]=c[d>>2];c[m+4>>2]=d+16;g[m+8>>2]=ea(g[d+4>>2]);r=ea(g[e+16>>2]);s=ea(g[e+20>>2]);t=ea(r*ea(-2.0));r=ea(s*ea(-2.0));s=ea(ea(g[e+24>>2])*ea(-2.0));u=ea(g[e+12>>2]);v=ea(ea(u*u)+ea(-.5));w=ea(g[e>>2]);x=ea(t*w);y=ea(g[e+4>>2]);z=ea(x+ea(r*y));x=ea(g[e+8>>2]);A=ea(z+ea(s*x));z=ea(ea(w*A)+ea(ea(t*v)-ea(u*ea(ea(s*y)-ea(r*x)))));B=ea(ea(y*A)+ea(ea(r*v)-ea(u*ea(ea(t*x)-ea(s*w)))));C=ea(ea(ea(s*v)-ea(u*ea(ea(r*w)-ea(t*y))))+ea(x*A));A=ea(-y);y=ea(-x);g[p>>2]=ea(-w);g[p+4>>2]=A;g[p+8>>2]=y;g[p+12>>2]=u;g[p+16>>2]=z;g[p+20>>2]=B;g[p+24>>2]=C;mEb(o,b,p);g[n>>2]=ea(g[o>>2]);g[n+4>>2]=ea(g[o+4>>2]);g[n+8>>2]=ea(g[o+8>>2]);g[n+12>>2]=ea(g[o+12>>2]);g[n+16>>2]=ea(g[o+16>>2]);g[n+20>>2]=ea(g[o+20>>2]);g[n+24>>2]=ea(g[o+24>>2]);g[n+28>>2]=ea(g[o+28>>2]);g[n+32>>2]=ea(g[o+32>>2]);p=n+36|0;g[p>>2]=ea(g[o+36>>2]);q=n+40|0;g[q>>2]=ea(g[o+40>>2]);D=n+44|0;g[D>>2]=ea(g[o+44>>2]);g[n+48>>2]=ea(g[o+48>>2]);g[n+52>>2]=ea(g[o+52>>2]);g[n+56>>2]=ea(g[o+56>>2]);F0a(k,n);C=ea(-ea(g[p>>2]));B=ea(-ea(g[q>>2]));z=ea(-ea(g[D>>2]));u=ea(g[k>>2]);y=ea(u*C);A=ea(g[k+4>>2]);w=ea(A*C);x=ea(g[k+8>>2]);t=ea(x*C);C=ea(g[k+12>>2]);r=ea(C*B);v=ea(g[k+16>>2]);s=ea(v*B);E=ea(g[k+20>>2]);F=ea(y+r);r=ea(w+s);s=ea(t+ea(E*B));B=ea(g[k+24>>2]);t=ea(B*z);w=ea(g[k+28>>2]);y=ea(w*z);G=ea(g[k+32>>2]);H=ea(F+t);t=ea(r+y);y=ea(s+ea(G*z));g[l>>2]=u;g[l+4>>2]=A;g[l+8>>2]=x;g[l+12>>2]=C;g[l+16>>2]=v;g[l+20>>2]=E;g[l+24>>2]=B;g[l+28>>2]=w;g[l+32>>2]=G;c[k+4>>2]=2;c[k>>2]=542600;c[k+8>>2]=d;c[k+16>>2]=l;D=k+68|0;a[D>>0]=0;c[k+116>>2]=h;G=ea(-t);t=ea(-y);g[k+144>>2]=ea(-H);g[k+148>>2]=G;g[k+152>>2]=t;g[k+156>>2]=ea(0.0);t=ea(g[b+48>>2]);G=ea(g[b+52>>2]);H=ea(g[b+56>>2]);g[k+128>>2]=t;g[k+132>>2]=G;g[k+136>>2]=H;g[k+140>>2]=ea(0.0);vQa(n,1,m,k,1);I=a[D>>0]|0;J=I<<24>>24!=0;i=j;return J|0}D=l;c[D>>2]=0;c[D+4>>2]=0;c[l>>2]=c[d>>2];c[l+4>>2]=d+16;g[l+8>>2]=ea(g[d+4>>2]);AOa(m,b,e,f);H=ea(g[e>>2]);G=ea(g[e+4>>2]);t=ea(g[e+8>>2]);y=ea(g[e+12>>2]);w=ea(H+H);B=ea(G+G);E=ea(t+t);v=ea(G*B);C=ea(t*E);x=ea(w*G);G=ea(w*t);A=ea(w*y);u=ea(B*t);t=ea(B*y);B=ea(E*y);y=ea(ea(ea(1.0)-v)-C);E=ea(x+B);z=ea(G-t);s=ea(x-B);B=ea(ea(1.0)-ea(H*w));w=ea(B-C);C=ea(u+A);H=ea(G+t);t=ea(u-A);A=ea(B-v);v=ea(g[f+12>>2]);B=ea(g[f+16>>2]);u=ea(g[f+20>>2]);G=ea(g[f+24>>2]);x=ea(v+v);r=ea(B+B);F=ea(u+u);K=ea(B*r);L=ea(u*F);M=ea(x*B);B=ea(x*u);N=ea(x*G);O=ea(r*u);u=ea(r*G);r=ea(F*G);G=ea(ea(ea(1.0)-K)-L);F=ea(M+r);P=ea(B-u);Q=ea(M-r);r=ea(ea(1.0)-ea(v*x));x=ea(r-L);L=ea(O+N);v=ea(B+u);u=ea(O-N);N=ea(r-K);K=ea(g[f>>2]);r=ea(K*G);O=ea(K*Q);B=ea(K*v);K=ea(g[f+4>>2]);M=ea(F*K);R=ea(x*K);S=ea(u*K);K=ea(g[f+8>>2]);T=ea(P*K);U=ea(L*K);V=ea(N*K);K=ea(ea(ea(G*r)+ea(F*M))+ea(P*T));W=ea(ea(ea(G*O)+ea(F*R))+ea(P*U));X=ea(ea(ea(G*B)+ea(F*S))+ea(P*V));P=ea(ea(ea(Q*r)+ea(x*M))+ea(L*T));F=ea(ea(ea(Q*O)+ea(x*R))+ea(L*U));G=ea(ea(ea(Q*B)+ea(x*S))+ea(L*V));L=ea(ea(ea(v*r)+ea(u*M))+ea(N*T));T=ea(ea(ea(v*O)+ea(u*R))+ea(N*U));U=ea(ea(ea(v*B)+ea(u*S))+ea(N*V));V=ea(ea(H*X)+ea(ea(y*K)+ea(s*W)));N=ea(ea(t*X)+ea(ea(E*K)+ea(w*W)));S=ea(ea(A*X)+ea(ea(z*K)+ea(C*W)));W=ea(ea(H*G)+ea(ea(y*P)+ea(s*F)));K=ea(ea(t*G)+ea(ea(E*P)+ea(w*F)));X=ea(ea(A*G)+ea(ea(z*P)+ea(C*F)));F=ea(ea(H*U)+ea(ea(y*L)+ea(s*T)));s=ea(ea(t*U)+ea(ea(E*L)+ea(w*T)));w=ea(ea(A*U)+ea(ea(z*L)+ea(C*T)));T=ea(g[b>>2]);C=ea(g[b+4>>2]);L=ea(g[b+8>>2]);z=ea(g[b+12>>2]);U=ea(g[b+16>>2]);A=ea(g[b+20>>2]);E=ea(g[b+24>>2]);t=ea(g[b+28>>2]);y=ea(g[b+32>>2]);H=ea(g[b+36>>2]);P=ea(g[b+40>>2]);G=ea(-H);H=ea(-P);P=ea(-ea(g[b+44>>2]));u=ea(ea(ea(T*G)+ea(C*H))+ea(L*P));B=ea(ea(ea(z*G)+ea(U*H))+ea(A*P));v=ea(ea(ea(E*G)+ea(t*H))+ea(y*P));P=ea(g[e+16>>2]);H=ea(g[e+20>>2]);G=ea(g[e+24>>2]);c[n+4>>2]=2;c[n>>2]=542576;c[n+8>>2]=d;c[n+16>>2]=k;k=n+68|0;a[k>>0]=0;c[n+116>>2]=h;R=ea(ea(S*A)+ea(ea(z*V)+ea(U*N)));O=ea(ea(ea(V*E)+ea(N*t))+ea(S*y));M=ea(ea(L*X)+ea(ea(T*W)+ea(C*K)));r=ea(ea(A*X)+ea(ea(z*W)+ea(U*K)));x=ea(ea(ea(W*E)+ea(K*t))+ea(X*y));X=ea(ea(L*w)+ea(ea(T*F)+ea(C*s)));K=ea(ea(A*w)+ea(ea(z*F)+ea(U*s)));W=ea(ea(ea(F*E)+ea(s*t))+ea(w*y));w=ea(u+ea(ea(ea(T*P)+ea(C*H))+ea(L*G)));u=ea(B+ea(ea(ea(z*P)+ea(U*H))+ea(A*G)));A=ea(v+ea(ea(ea(E*P)+ea(t*H))+ea(y*G)));g[n+20>>2]=ea(ea(L*S)+ea(ea(T*V)+ea(C*N)));g[n+24>>2]=R;g[n+28>>2]=O;g[n+32>>2]=M;g[n+36>>2]=r;g[n+40>>2]=x;g[n+44>>2]=X;g[n+48>>2]=K;g[n+52>>2]=W;g[n+56>>2]=w;g[n+60>>2]=u;g[n+64>>2]=A;h=n+144|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];A=ea(g[b+48>>2]);u=ea(g[b+52>>2]);w=ea(g[b+56>>2]);g[n+128>>2]=A;g[n+132>>2]=u;g[n+136>>2]=w;g[n+140>>2]=ea(0.0);vQa(m,1,l,n,1);I=a[k>>0]|0;J=I<<24>>24!=0;i=j;return J|0}function K7a(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im;m=i;i=i+320|0;n=m+272|0;o=m+48|0;p=m+288|0;q=m+16|0;r=m;s=m+64|0;t=m+32|0;u=m+304|0;c[b+4>>2]=2;c[b>>2]=542720;v=b+64|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;v=b+16|0;g[v>>2]=ea(1.0);w=b+20|0;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];x=b+36|0;g[x>>2]=ea(1.0);y=b+40|0;c[y+0>>2]=c[p+0>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];c[y+12>>2]=c[p+12>>2];z=b+56|0;g[z>>2]=ea(1.0);A=b+60|0;g[A>>2]=ea(0.0);B=b+160|0;c[b+176>>2]=0;g[b+112>>2]=ea(0.0);C=b+116|0;c[C+0>>2]=c[n+0>>2];c[C+4>>2]=c[n+4>>2];c[C+8>>2]=c[n+8>>2];g[b+128>>2]=ea(0.0);C=b+132|0;c[C+0>>2]=c[n+0>>2];c[C+4>>2]=c[n+4>>2];c[C+8>>2]=c[n+8>>2];g[b+144>>2]=ea(0.0);C=b+148|0;c[C+0>>2]=c[n+0>>2];c[C+4>>2]=c[n+4>>2];c[C+8>>2]=c[n+8>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[B+0>>2]=c[o+0>>2];c[B+4>>2]=c[o+4>>2];c[B+8>>2]=c[o+8>>2];c[B+12>>2]=c[o+12>>2];B=b+352|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[B+0>>2]=c[n+0>>2];c[B+4>>2]=c[n+4>>2];c[B+8>>2]=c[n+8>>2];c[B+12>>2]=c[n+12>>2];c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;n=b+304|0;g[n>>2]=ea(1.0);B=b+308|0;c[B+0>>2]=c[o+0>>2];c[B+4>>2]=c[o+4>>2];c[B+8>>2]=c[o+8>>2];c[B+12>>2]=c[o+12>>2];o=b+324|0;g[o>>2]=ea(1.0);C=b+328|0;c[C+0>>2]=c[p+0>>2];c[C+4>>2]=c[p+4>>2];c[C+8>>2]=c[p+8>>2];c[C+12>>2]=c[p+12>>2];p=b+344|0;g[p>>2]=ea(1.0);D=b+348|0;g[D>>2]=ea(0.0);a[b+432>>0]=0;E=b+433|0;F=k&1;a[E>>0]=F;if(!k){G=ea(g[f>>2]);H=ea(g[f+4>>2]);I=ea(g[f+8>>2]);J=ea(g[f+12>>2]);K=ea(g[f+16>>2]);L=ea(g[f+20>>2]);M=ea(g[f+24>>2]);N=ea(g[f+28>>2]);O=ea(g[f+32>>2]);g[b+384>>2]=G;g[b+388>>2]=H;g[b+392>>2]=I;g[b+396>>2]=ea(0.0);g[b+400>>2]=J;g[b+404>>2]=K;g[b+408>>2]=L;g[b+412>>2]=ea(0.0);g[b+416>>2]=M;g[b+420>>2]=N;g[b+424>>2]=O;g[b+428>>2]=ea(0.0)}O=ea(g[e>>2]);N=ea(g[e+4>>2]);M=ea(g[e+8>>2]);g[q>>2]=O;f=q+4|0;g[f>>2]=N;k=q+8|0;g[k>>2]=M;g[q+12>>2]=ea(0.0);P=e+12|0;M=ea(g[P>>2]);N=ea(g[P+4>>2]);O=ea(g[P+8>>2]);L=ea(g[P+12>>2]);g[r>>2]=M;g[r+4>>2]=N;g[r+8>>2]=O;g[r+12>>2]=L;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;z1a(s,d+16|0,t,q,r);YEi(b+96|0,s|0,205)|0;L=ea(-ea(g[h>>2]));O=ea(-ea(g[h+4>>2]));N=ea(-ea(g[h+8>>2]));M=ea(g[h+12>>2]);K=ea(g[j+16>>2]);J=ea(K-ea(g[h+16>>2]));K=ea(g[j+20>>2]);I=ea(K-ea(g[h+20>>2]));K=ea(g[j+24>>2]);H=ea(J*ea(2.0));J=ea(I*ea(2.0));I=ea(ea(K-ea(g[h+24>>2]))*ea(2.0));K=ea(ea(M*M)+ea(-.5));G=ea(ea(ea(H*L)+ea(J*O))+ea(I*N));Q=ea(ea(G*L)+ea(ea(K*H)+ea(M*ea(ea(I*O)-ea(J*N)))));R=ea(ea(G*O)+ea(ea(K*J)+ea(M*ea(ea(H*N)-ea(I*L)))));S=ea(ea(ea(K*I)+ea(M*ea(ea(J*L)-ea(H*O))))+ea(G*N));G=ea(g[j>>2]);H=ea(M*G);J=ea(g[j+12>>2]);I=ea(H+ea(J*L));H=ea(g[j+8>>2]);K=ea(I+ea(H*O));I=ea(g[j+4>>2]);T=ea(K-ea(I*N));K=ea(ea(ea(G*N)+ea(ea(J*O)+ea(M*I)))-ea(H*L));U=ea(ea(ea(I*L)+ea(ea(J*N)+ea(M*H)))-ea(G*O));V=ea(ea(ea(ea(M*J)-ea(G*L))-ea(I*O))-ea(H*N));N=ea(T+T);H=ea(K+K);O=ea(U+U);I=ea(K*H);L=ea(U*O);G=ea(N*K);K=ea(N*U);J=ea(N*V);M=ea(U*H);U=ea(V*H);H=ea(V*O);O=ea(ea(1.0)-ea(T*N));N=ea(G+H);T=ea(K-U);V=ea(G-H);H=ea(O-L);G=ea(J+M);W=ea(K+U);U=ea(M-J);J=ea(O-I);g[n>>2]=ea(ea(ea(1.0)-I)-L);g[B>>2]=N;g[b+312>>2]=T;g[b+316>>2]=ea(0.0);g[b+320>>2]=V;g[o>>2]=H;g[C>>2]=G;g[b+332>>2]=ea(0.0);g[b+336>>2]=W;g[b+340>>2]=U;g[p>>2]=J;g[D>>2]=ea(0.0);g[b+352>>2]=Q;g[b+356>>2]=R;g[b+360>>2]=S;g[b+364>>2]=ea(0.0);S=ea(g[d+68>>2]);R=ea(g[d+72>>2]);Q=ea(g[d+76>>2]);J=ea(g[q>>2]);U=ea(g[f>>2]);W=ea(S*J);J=ea(R*U);U=ea(Q*ea(g[k>>2]));Q=!(W<=J)?J:W;W=ea((!(Q<=U)?U:Q)*ea(.00999999977));g[b+368>>2]=ea(W*W);k=b+372|0;c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];a[E>>0]=F;W=ea(g[l>>2]);Q=ea(g[l+4>>2]);U=ea(g[l+8>>2]);J=ea(g[l+12>>2]);R=ea(g[l+16>>2]);S=ea(g[l+20>>2]);G=ea(g[l+24>>2]);H=ea(g[l+28>>2]);V=ea(g[l+32>>2]);T=ea(g[l+36>>2]);N=ea(g[l+40>>2]);L=ea(-T);T=ea(-N);N=ea(-ea(g[l+44>>2]));I=ea(ea(ea(W*L)+ea(Q*T))+ea(U*N));O=ea(ea(ea(J*L)+ea(R*T))+ea(S*N));M=ea(ea(ea(G*L)+ea(H*T))+ea(V*N));g[v>>2]=W;g[w>>2]=J;g[b+24>>2]=G;g[b+28>>2]=ea(0.0);g[b+32>>2]=Q;g[x>>2]=R;g[y>>2]=H;g[b+44>>2]=ea(0.0);g[b+48>>2]=U;g[b+52>>2]=S;g[z>>2]=V;g[A>>2]=ea(0.0);g[b+64>>2]=I;g[b+68>>2]=O;g[b+72>>2]=M;g[b+76>>2]=ea(0.0);M=ea(ea(g[l+48>>2])+ea(.00100000005));O=ea(ea(g[l+52>>2])+ea(.00100000005));I=ea(ea(g[l+56>>2])+ea(.00100000005));g[b+80>>2]=M;g[b+84>>2]=O;g[b+88>>2]=I;g[b+92>>2]=ea(0.0);i=m;return}function L7a(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0;m=i;i=i+192|0;n=m+172|0;o=m+144|0;p=m+160|0;q=m;if(!(a[d+40>>0]|0)){r=0;i=m;return r|0}if(!(a[d+41>>0]|0)){b[e+12>>1]=7;r=1;i=m;return r|0}if(!(b[c[d+36>>2]>>1]&512)){g[e+40>>2]=ea(0.0);s=c[d+32>>2]|0;t=ea(-ea(g[s>>2]));u=ea(-ea(g[s+4>>2]));v=ea(-ea(g[s+8>>2]));g[e+28>>2]=t;g[e+32>>2]=u;g[e+36>>2]=v;b[e+12>>1]=6;r=1;i=m;return r|0}s=c[d+28>>2]|0;v=ea(g[s>>2]);u=ea(g[s+4>>2]);t=ea(g[s+8>>2]);w=ea(g[s+12>>2]);x=ea(g[s+16>>2]);y=ea(g[s+20>>2]);z=ea(g[f+24>>2]);f=q+64|0;c[q+80>>2]=4;A=q+20|0;B=q+36|0;g[q+48>>2]=ea(0.0);C=q+52|0;c[C+0>>2]=c[n+0>>2];c[C+4>>2]=c[n+4>>2];c[C+8>>2]=c[n+8>>2];c[o+0>>2]=-1;c[o+4>>2]=-1;c[o+8>>2]=-1;c[o+12>>2]=-1;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];g[q+128>>2]=z;o=q+132|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];g[q+96>>2]=v;g[q+100>>2]=u;g[q+104>>2]=t;g[q+108>>2]=ea(0.0);g[q+112>>2]=w;g[q+116>>2]=x;g[q+120>>2]=y;g[q+124>>2]=ea(0.0);g[q+16>>2]=z;c[A+0>>2]=c[p+0>>2];c[A+4>>2]=c[p+4>>2];c[A+8>>2]=c[p+8>>2];g[q+32>>2]=z;c[B+0>>2]=c[p+0>>2];c[B+4>>2]=c[p+4>>2];c[B+8>>2]=c[p+8>>2];z=ea(ea(u+x)*ea(.5));x=ea(ea(t+y)*ea(.5));g[q>>2]=ea(ea(v+w)*ea(.5));g[q+4>>2]=z;g[q+8>>2]=x;g[q+12>>2]=ea(0.0);p=jNa(h,j,q,ea(g[s+24>>2]),l,k,e)|0;k=e+12|0;b[k>>1]=6;if(p){b[k>>1]=7;r=1;i=m;return r|0}else{g[e+40>>2]=ea(0.0);k=c[d+32>>2]|0;l=ea(-ea(g[k>>2]));x=ea(-ea(g[k+4>>2]));z=ea(-ea(g[k+8>>2]));g[e+28>>2]=l;g[e+32>>2]=x;g[e+36>>2]=z;r=1;i=m;return r|0}return 0}function M7a(e,f,h,j,k,l,m,n,o,p,q,r){e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;p=p|0;q=ea(q);r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0;s=i;i=i+128|0;t=s+64|0;u=s+96|0;v=s+80|0;w=s;x=s+112|0;y=s+48|0;z=s+16|0;A=s+32|0;c[e+4>>2]=2;c[e>>2]=542824;B=e+16|0;C=e+80|0;c[e+96>>2]=0;D=e+32|0;g[D>>2]=ea(0.0);E=e+36|0;c[E+0>>2]=c[u+0>>2];c[E+4>>2]=c[u+4>>2];c[E+8>>2]=c[u+8>>2];F=e+48|0;g[F>>2]=ea(0.0);G=e+52|0;c[G+0>>2]=c[u+0>>2];c[G+4>>2]=c[u+4>>2];c[G+8>>2]=c[u+8>>2];g[e+64>>2]=ea(0.0);H=e+68|0;c[H+0>>2]=c[u+0>>2];c[H+4>>2]=c[u+4>>2];c[H+8>>2]=c[u+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[C+0>>2]=c[t+0>>2];c[C+4>>2]=c[t+4>>2];c[C+8>>2]=c[t+8>>2];c[C+12>>2]=c[t+12>>2];C=e+272|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[C+0>>2]=c[t+0>>2];c[C+4>>2]=c[t+4>>2];c[C+8>>2]=c[t+8>>2];c[C+12>>2]=c[t+12>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;C=e+224|0;g[C>>2]=ea(1.0);H=e+228|0;c[H+0>>2]=c[u+0>>2];c[H+4>>2]=c[u+4>>2];c[H+8>>2]=c[u+8>>2];c[H+12>>2]=c[u+12>>2];I=e+244|0;g[I>>2]=ea(1.0);J=e+248|0;c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];v=e+264|0;g[v>>2]=ea(1.0);K=e+268|0;g[K>>2]=ea(0.0);c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;L=e+288|0;g[L>>2]=ea(0.0);M=e+292|0;g[M>>2]=ea(0.0);N=e+296|0;g[N>>2]=ea(0.0);O=e+300|0;g[O>>2]=ea(1.0);P=e+304|0;c[P+0>>2]=c[w+0>>2];c[P+4>>2]=c[w+4>>2];c[P+8>>2]=c[w+8>>2];c[P+12>>2]=c[w+12>>2];c[e+320>>2]=j;c[e+324>>2]=0;c[e+328>>2]=0;b[e+336>>1]=0;j=e+340|0;w=e+364|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;g[w>>2]=ea(3402823469999999843913219.0e14);g[e+416>>2]=ea(g[m>>2]);j=m+4|0;g[e+420>>2]=ea(g[j>>2]);P=m+8|0;g[e+424>>2]=ea(g[P>>2]);g[e+440>>2]=q;b[e+444>>1]=b[o>>1]|0;a[e+446>>0]=r&1;a[e+447>>0]=p&1;a[e+448>>0]=0;g[w>>2]=n;c[e+332>>2]=-1;q=ea(ea(g[m>>2])*ea(2.0));Q=ea(ea(g[j>>2])*ea(2.0));R=ea(ea(g[P>>2])*ea(2.0));S=ea(g[l+12>>2]);T=ea(ea(S*S)+ea(-.5));U=ea(g[l>>2]);V=ea(q*U);W=ea(g[l+4>>2]);X=ea(V+ea(Q*W));V=ea(g[l+8>>2]);Y=ea(X+ea(R*V));X=ea(ea(W*Y)+ea(ea(Q*T)-ea(S*ea(ea(q*V)-ea(R*U)))));Z=ea(ea(ea(R*T)-ea(S*ea(ea(Q*U)-ea(q*W))))+ea(V*Y));g[e+428>>2]=ea(ea(U*Y)+ea(ea(q*T)-ea(S*ea(ea(R*W)-ea(Q*V)))));g[e+432>>2]=X;g[e+436>>2]=Z;Z=ea(g[m>>2]);X=ea(g[j>>2]);V=ea(g[P>>2]);Q=ea(g[l>>2]);W=ea(g[l+4>>2]);R=ea(g[l+8>>2]);S=ea(g[l+12>>2]);P=l+16|0;T=ea(g[P>>2]);q=ea(g[P+4>>2]);Y=ea(g[P+8>>2]);U=ea(g[k>>2]);_=ea(g[k+4>>2]);$=ea(g[k+8>>2]);aa=ea(g[k+12>>2]);P=k+16|0;ba=ea(g[P>>2]);ca=ea(g[P+4>>2]);da=ea(g[P+8>>2]);fa=ea(-U);ga=ea(-_);ha=ea(-$);ia=ea(T-ba);T=ea(q-ca);q=ea(Y-da);Y=ea(ea(aa*aa)+ea(-.5));ja=ea(ea(ea(ia*fa)+ea(T*ga))+ea(q*ha));ka=ea(ea(ea(ja*fa)+ea(ea(Y*ia)+ea(aa*ea(ea(q*ga)-ea(T*ha)))))*ea(2.0));la=ea(ea(ea(ja*ga)+ea(ea(Y*T)+ea(aa*ea(ea(ia*ha)-ea(q*fa)))))*ea(2.0));ma=ea(ea(ea(ea(Y*q)+ea(aa*ea(ea(T*fa)-ea(ia*ga))))+ea(ja*ha))*ea(2.0));ja=ea(ea(S*aa)-ea(ea(ea(Q*fa)+ea(W*ga))+ea(R*ha)));ia=ea(ea(ea(R*ga)-ea(W*ha))+ea(ea(S*fa)+ea(Q*aa)));T=ea(ea(ea(Q*ha)-ea(R*fa))+ea(ea(S*ga)+ea(W*aa)));q=ea(ea(ea(W*fa)-ea(Q*ga))+ea(ea(R*aa)+ea(S*ha)));ha=ea(ia+ia);S=ea(T+T);R=ea(q+q);ga=ea(T*S);Q=ea(q*R);fa=ea(T*ha);T=ea(q*ha);W=ea(ja*ha);na=ea(q*S);q=ea(ja*S);S=ea(ja*R);R=ea(ea(1.0)-ea(ia*ha));ha=ea(fa+S);ia=ea(T-q);ja=ea(fa-S);S=ea(R-Q);fa=ea(na+W);oa=ea(T+q);q=ea(na-W);W=ea(R-ga);g[C>>2]=ea(ea(ea(1.0)-ga)-Q);g[H>>2]=ha;g[e+232>>2]=ia;g[e+236>>2]=ea(0.0);g[e+240>>2]=ja;g[I>>2]=S;g[J>>2]=fa;g[e+252>>2]=ea(0.0);g[e+256>>2]=oa;g[e+260>>2]=q;g[v>>2]=W;g[K>>2]=ea(0.0);g[e+272>>2]=ka;g[e+276>>2]=la;g[e+280>>2]=ma;g[e+284>>2]=ea(0.0);g[L>>2]=U;g[M>>2]=_;g[N>>2]=$;g[O>>2]=aa;g[e+304>>2]=ba;g[e+308>>2]=ca;g[e+312>>2]=da;g[e+316>>2]=ea(0.0);da=ea(-ea(Z*n));Z=ea(-ea(X*n));X=ea(-ea(V*n));V=ea(ea(ea(U*da)+ea(_*Z))+ea($*X));ca=ea(ea(ea(_*V)+ea(ea(Y*Z)-ea(aa*ea(ea($*da)-ea(U*X)))))*ea(2.0));ba=ea(ea(ea($*V)+ea(ea(Y*X)-ea(aa*ea(ea(U*Z)-ea(_*da)))))*ea(2.0));g[e+400>>2]=ea(ea(ea(U*V)+ea(ea(Y*da)-ea(aa*ea(ea(_*X)-ea($*Z)))))*ea(2.0));g[e+404>>2]=ca;g[e+408>>2]=ba;g[e+412>>2]=ea(0.0);g[e+384>>2]=n;O=e+388|0;c[O+0>>2]=c[x+0>>2];c[O+4>>2]=c[x+4>>2];c[O+8>>2]=c[x+8>>2];n=ea(g[h>>2]);ba=ea(g[h+4>>2]);ca=ea(g[h+8>>2]);g[y>>2]=n;g[y+4>>2]=ba;g[y+8>>2]=ca;g[y+12>>2]=ea(0.0);x=h+12|0;Z=ea(g[x>>2]);$=ea(g[x+4>>2]);X=ea(g[x+8>>2]);_=ea(g[x+12>>2]);g[z>>2]=Z;g[z+4>>2]=$;g[z+8>>2]=X;g[z+12>>2]=_;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;x=(c[f+40>>2]|0)+((d[f+39>>0]|0)*20|0)|0;_=ea(g[f+52>>2]);X=ea(g[f+56>>2]);$=ea(_*n);n=ea(X*ba);ba=ea(ea(g[f+60>>2])*ca);ca=!($<=n)?n:$;X=!(ca<=ba)?ba:ca;ca=!($>=n)?n:$;$=ea(X*ea(.200000003));n=ea((!(ca>=ba)?ba:ca)*ea(.0500000007));ca=$>n?$:n;g[D>>2]=X>ca?ca:X;c[E+0>>2]=c[u+0>>2];c[E+4>>2]=c[u+4>>2];c[E+8>>2]=c[u+8>>2];g[F>>2]=ea(X*ea(.100000001));c[G+0>>2]=c[t+0>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];jEb(y,z,e+112|0,e+160|0);c[e+216>>2]=x;a[e+220>>0]=a[f+38>>0]|0;c[B+0>>2]=c[A+0>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];c[B+12>>2]=c[A+12>>2];A=f+44|0;c[e+212>>2]=c[A>>2];c[e+208>>2]=f;if(!(c[A>>2]|0)){pa=e+449|0;a[pa>>0]=0;i=s;return}pa=e+449|0;a[pa>>0]=0;i=s;return}function N7a(a,b,d,f,h,j){a=a|0;b=b|0;d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0;k=i;i=i+48|0;l=k;if(j){j=a*3|0;m=e[f+(j<<1)>>1]|0;n=e[f+(j+1<<1)>>1]|0;o=e[f+(j+2<<1)>>1]|0}else{j=a*3|0;m=c[f+(j<<2)>>2]|0;n=c[f+(j+1<<2)>>2]|0;o=c[f+(j+2<<2)>>2]|0}p=ea(g[d+(m*12|0)>>2]);g[l>>2]=p;q=ea(g[d+(m*12|0)+4>>2]);g[l+4>>2]=q;r=ea(g[d+(m*12|0)+8>>2]);g[l+8>>2]=r;s=ea(g[d+(n*12|0)>>2]);g[l+12>>2]=s;t=ea(g[d+(n*12|0)+4>>2]);g[l+16>>2]=t;u=ea(g[d+(n*12|0)+8>>2]);g[l+20>>2]=u;v=ea(g[d+(o*12|0)>>2]);g[l+24>>2]=v;w=ea(g[d+(o*12|0)+4>>2]);g[l+28>>2]=w;n=l+32|0;g[n>>2]=ea(g[d+(o*12|0)+8>>2]);x=ea(p*ea(g[h>>2]));o=h+4|0;y=ea(p*ea(g[o>>2]));d=h+8|0;z=ea(p*ea(g[d>>2]));l=h+12|0;p=ea(q*ea(g[l>>2]));m=h+16|0;A=ea(q*ea(g[m>>2]));j=h+20|0;B=ea(x+p);p=ea(y+A);A=ea(z+ea(q*ea(g[j>>2])));f=h+24|0;q=ea(r*ea(g[f>>2]));a=h+28|0;z=ea(r*ea(g[a>>2]));C=h+32|0;y=ea(B+q);q=ea(p+z);z=ea(A+ea(r*ea(g[C>>2])));D=h+36|0;r=ea(y+ea(g[D>>2]));E=h+40|0;y=ea(q+ea(g[E>>2]));F=h+44|0;q=ea(z+ea(g[F>>2]));g[b>>2]=r;g[b+4>>2]=y;g[b+8>>2]=q;q=ea(s*ea(g[h>>2]));y=ea(s*ea(g[o>>2]));r=ea(s*ea(g[d>>2]));s=ea(t*ea(g[l>>2]));z=ea(t*ea(g[m>>2]));A=ea(q+s);s=ea(y+z);z=ea(r+ea(t*ea(g[j>>2])));t=ea(u*ea(g[f>>2]));r=ea(u*ea(g[a>>2]));y=ea(A+t);t=ea(s+r);r=ea(z+ea(u*ea(g[C>>2])));u=ea(y+ea(g[D>>2]));y=ea(t+ea(g[E>>2]));t=ea(r+ea(g[F>>2]));g[b+12>>2]=u;g[b+16>>2]=y;g[b+20>>2]=t;t=ea(v*ea(g[h>>2]));y=ea(v*ea(g[o>>2]));u=ea(v*ea(g[d>>2]));v=ea(w*ea(g[l>>2]));r=ea(w*ea(g[m>>2]));z=ea(t+v);v=ea(y+r);r=ea(u+ea(w*ea(g[j>>2])));w=ea(g[n>>2]);u=ea(w*ea(g[f>>2]));y=ea(w*ea(g[a>>2]));t=ea(z+u);u=ea(v+y);y=ea(r+ea(w*ea(g[C>>2])));w=ea(t+ea(g[D>>2]));t=ea(u+ea(g[E>>2]));u=ea(y+ea(g[F>>2]));g[b+24>>2]=w;g[b+28>>2]=t;g[b+32>>2]=u;i=k;return}function O7a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;g=i;f=d>>>1;e=(a[(c[b+36>>2]|0)+(f<<2)+2>>0]|0)<0;l=(d&1|0)==0;c[h>>2]=-1;if(e)if(l){c[j>>2]=d+1;c[k>>2]=-1;e=b+20|0;m=c[e>>2]|0;if(!((f>>>0)%(m>>>0)|0))n=m;else{c[h>>2]=d+-1;n=c[e>>2]|0}if(((f>>>0)/(n>>>0)|0|0)==((c[b+16>>2]|0)+-2|0)){i=g;return}c[k>>2]=n+f<<1|1;i=g;return}else{c[j>>2]=d+-1;c[k>>2]=-1;n=b+20|0;e=c[n>>2]|0;if(((f>>>0)%(e>>>0)|0)>>>0<(e+-2|0)>>>0){c[h>>2]=d+1;o=c[n>>2]|0}else o=e;if(f>>>0<(o+-1|0)>>>0){i=g;return}c[k>>2]=f-o<<1;i=g;return}else if(l){c[j>>2]=d+1;c[k>>2]=-1;l=b+20|0;o=c[l>>2]|0;if(f>>>0<(o+-1|0)>>>0)p=o;else{c[h>>2]=f-o<<1|1;p=c[l>>2]|0}if(!((f>>>0)%(p>>>0)|0)){i=g;return}c[k>>2]=d+-1;i=g;return}else{c[j>>2]=d+-1;c[k>>2]=-1;j=b+20|0;p=c[j>>2]|0;if(((f>>>0)/(p>>>0)|0|0)==((c[b+16>>2]|0)+-2|0))q=p;else{c[h>>2]=p+f<<1;q=c[j>>2]|0}if(((f>>>0)%(q>>>0)|0)>>>0>=(q+-2|0)>>>0){i=g;return}c[k>>2]=d+1;i=g;return}}function P7a(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=0,C=Im,D=Im,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=0,Ia=Im,Ja=Im,Ka=0,La=Im,Ma=0,Na=Im;j=i;i=i+160|0;k=j+120|0;l=j+92|0;m=j+56|0;n=j+52|0;o=j+36|0;p=j+80|0;q=j+104|0;r=j+144|0;s=j+60|0;t=j+24|0;u=j+12|0;v=j+64|0;w=j;x=j+48|0;y=j+76|0;zRa(d,k);z=ea(g[f>>2]);A=ea(z-ea(g[e>>2]));z=ea(g[f+4>>2]);B=e+4|0;C=ea(z-ea(g[B>>2]));z=ea(g[f+8>>2]);f=e+8|0;D=ea(z-ea(g[f>>2]));g[l>>2]=A;E=l+4|0;g[E>>2]=C;F=l+8|0;g[F>>2]=D;if(!(RPa(k,k+12|0,e,l,ea(1.0),m,n)|0)){i=j;return}D=ea(g[m>>2]);C=ea(g[l>>2]);A=ea(D*C);z=ea(g[E>>2]);G=ea(D*z);H=ea(g[F>>2]);I=ea(D*H);D=ea(g[e>>2]);J=ea(A+D);A=ea(g[B>>2]);K=ea(G+A);G=ea(g[f>>2]);L=ea(I+G);I=ea(g[n>>2]);M=ea(D+ea(C*I));C=ea(A+ea(z*I));z=ea(G+ea(H*I));I=ea(g[(c[d+16>>2]|0)+8>>2]);n=c[d+12>>2]|0;f=c[n+20>>2]|0;B=c[n+16>>2]|0;H=ea(g[d>>2]);G=ea(ea(B+-1|0)*ea(.99999988));A=ea(ea(f+-1|0)*ea(.99999988));D=ea(J*H);e=D>ea(1.00000001e-07);N=e?D:ea(1.00000001e-07);O=ea(G+ea(0.0));G=N<O?N:O;N=ea(g[d+8>>2]);P=ea(L*N);d=P>ea(1.00000001e-07);Q=d?P:ea(1.00000001e-07);U=ea(A+ea(0.0));A=Q<U?Q:U;Q=ea(M*H);d=Q>ea(1.00000001e-07);V=d?Q:ea(1.00000001e-07);Q=ea(z*N);d=Q>ea(1.00000001e-07);W=d?Q:ea(1.00000001e-07);Q=ea((V<O?V:O)-G);O=ea((W<U?W:U)-A);U=ea(C-K);d=Q>=ea(0.0);C=d?ea(1.0):ea(-1.0);d=O>=ea(0.0);W=d?ea(1.0):ea(-1.0);d=~~C;e=~~W;if(ea(S(ea(Q)))<ea(1.00000001e-10))X=ea(C*ea(1.00000001e-10));else X=Q;if(ea(S(ea(O)))<ea(1.00000001e-10))Y=ea(W*ea(1.00000001e-10));else Y=O;g[o>>2]=D;g[o+4>>2]=K;g[o+8>>2]=P;P=ea(ea(M-J)*H);H=ea(ea(z-L)*N);N=ea(T(ea(ea(ea(U*U)+ea(P*P))+ea(H*H))));g[p>>2]=P;F=p+4|0;g[F>>2]=U;E=p+8|0;g[E>>2]=H;if(N>ea(9.99999968e-21)){L=ea(ea(1.0)/N);g[p>>2]=ea(L*P);g[F>>2]=ea(L*U);g[E>>2]=ea(L*H)}E=X>ea(0.0);if(E)Z=ea(R(ea(G)));else Z=ea(ca(ea(G)));F=~~Z;l=Y>ea(0.0);if(l)_=ea(R(ea(A)));else _=ea(ca(ea(A)));m=~~_;if(E){_=ea(ca(ea(G)));if(_==G)$=ea(_+ea(1.0));else $=_}else{_=ea(R(ea(G)));if(_==G)$=ea(_+ea(-1.0));else $=_}if(l){_=ea(ca(ea(A)));if(_==A)aa=ea(_+ea(1.0));else aa=_}else{_=ea(R(ea(A)));if(_==A)aa=ea(_+ea(-1.0));else aa=_}_=ea(ea(1.0)/ea(S(ea(X))));Z=ea(ea(1.0)/ea(S(ea(Y))));l=1-d|0;E=(1-e|0)/2|0;H=ea(f|0);L=ea(B|0);B=n+36|0;n=q+4|0;k=q+8|0;ba=q+12|0;fa=q+(E+l<<2)|0;ga=q+(l+1-E<<2)|0;ha=q+(2-l+E<<2)|0;ia=q+(3-l-E<<2)|0;E=t+4|0;l=t+8|0;ja=u+4|0;ka=u+8|0;la=v+4|0;ma=v+8|0;na=w+4|0;oa=w+8|0;P=ea(N+ea(.0000999999974));N=ea(K+ea(U*ea(0.0)));z=ea(ea($-G)/X);X=ea(ea(aa-A)/Y);pa=F;Y=ea(F|0);F=m;A=ea(m|0);while(1){m=z<X;aa=m?z:X;G=N;N=ea(K+ea(U*aa));qa=(da(pa,f)|0)+F|0;ra=pa+d|0;sa=(da(ra,f)|0)+F|0;ta=c[B>>2]|0;$=ea(I*ea(b[ta+(qa<<2)>>1]|0));g[q>>2]=$;J=ea(I*ea(b[ta+(qa+e<<2)>>1]|0));g[n>>2]=J;M=ea(I*ea(b[ta+(sa<<2)>>1]|0));g[k>>2]=M;D=ea(I*ea(b[ta+(sa+e<<2)>>1]|0));g[ba>>2]=D;O=$<J?$:J;Q=M<D?M:D;V=$>J?$:J;J=M>D?M:D;do if(!(ea((G<N?G:N)+ea(-.0000999999974))>(V>J?V:J))?!(ea((G>N?G:N)+ea(.0000999999974))<(O<Q?O:Q)):0){D=ea(g[fa>>2]);M=ea(g[ga>>2]);$=ea(g[ha>>2]);ua=ea(g[ia>>2]);va=ea(C+Y);wa=Y<va?Y:va;xa=Y>va?Y:va;va=ea(W+A);ya=A<va?A:va;za=A>va?A:va;g[t>>2]=wa;g[E>>2]=D;g[l>>2]=ya;g[u>>2]=wa;g[ja>>2]=M;g[ka>>2]=za;g[v>>2]=xa;g[la>>2]=$;g[ma>>2]=ya;g[w>>2]=xa;g[na>>2]=ua;g[oa>>2]=za;sa=F+e|0;qa=(da((ra|0)<(pa|0)?ra:pa,f)|0)+((sa|0)<(F|0)?sa:F)|0;sa=(a[ta+(qa<<2)+2>>0]|0)<0;Aa=sa?t:u;Ba=sa?u:w;Ca=sa?w:v;g[x>>2]=ea(3402823469999999843913219.0e14);g[y>>2]=ea(3402823469999999843913219.0e14);Da=WPa(o,p,sa?v:t,Aa,Ca,x,r,s,ea(.0000999999974))|0;za=ea(g[x>>2]);if(!(!(za<=P)|Da&za>=ea(-.0000999999974)^1)?(a[(c[B>>2]|0)+(qa<<2)+2>>0]&127)!=127:0)Ea=1;else{g[x>>2]=ea(3402823469999999843913219.0e14);Ea=0}Da=WPa(o,p,Ba,Ca,Aa,y,r,s,ea(.0000999999974))|0;za=ea(g[y>>2]);if(!(!(za<=P)|Da&za>=ea(-.0000999999974)^1)?(a[(c[B>>2]|0)+(qa<<2)+3>>0]&127)!=127:0){Fa=za;Ga=1}else{g[y>>2]=ea(3402823469999999843913219.0e14);Fa=ea(3402823469999999843913219.0e14);Ga=0}if(!(Ea^1|!(ea(g[x>>2])<=Fa))){a[h>>0]=1;break}if(!(Ga^1|!(Fa<=ea(g[x>>2]))))a[h>>0]=1}while(0);if(m){Q=ea(ra+d|0);if(!(!(Q<ea(0.0))&!(Q>=L))){Ha=43;break}Ia=ea(_+z);Ja=X;Ka=ra;La=ea(C+Y);Ma=F;Na=A}else{ta=F+e|0;Q=ea(ta+e|0);if(!(!(Q<ea(0.0))&!(Q>=H))){Ha=43;break}Ia=z;Ja=ea(Z+X);Ka=pa;La=Y;Ma=ta;Na=ea(W+A)}if(!(aa<ea(.999899983))){Ha=43;break}else{z=Ia;X=Ja;pa=Ka;Y=La;F=Ma;A=Na}}if((Ha|0)==43){i=j;return}}function Q7a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=Im,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=0,Ha=0;j=i;i=i+240|0;k=j+16|0;l=j+200|0;m=j+32|0;n=j+224|0;o=j+232|0;p=j;q=j+192|0;r=j+228|0;zRa(b,l);s=ea(g[l>>2]);t=ea(g[h>>2]);u=ea(s-t);v=l+4|0;s=ea(g[v>>2]);w=ea(g[h+4>>2]);x=ea(s-w);y=l+8|0;s=ea(g[y>>2]);z=ea(g[h+8>>2]);A=ea(s-z);g[l>>2]=u;g[v>>2]=x;g[y>>2]=A;y=l+12|0;A=ea(ea(g[y>>2])+t);v=l+16|0;t=ea(ea(g[v>>2])+w);B=l+20|0;w=ea(ea(g[B>>2])+z);g[y>>2]=A;g[v>>2]=t;g[B>>2]=w;B=b+12|0;v=c[B>>2]|0;a[m>>0]=0;c[m+4>>2]=b;c[m+8>>2]=v;v=m+156|0;c[v>>2]=0;g[n>>2]=ea(0.0);g[o>>2]=ea(0.0);w=ea(g[e>>2]);t=ea(w-ea(g[d>>2]));w=ea(g[e+4>>2]);A=ea(w-ea(g[d+4>>2]));w=ea(g[e+8>>2]);C=d+8|0;z=ea(w-ea(g[C>>2]));g[p>>2]=t;g[p+4>>2]=A;D=p+8|0;g[D>>2]=z;if(!(RPa(l,y,d,p,ea(1.0),q,r)|0)){i=j;return}z=ea(g[q>>2]);A=ea(g[p>>2]);t=ea(z*A);w=ea(g[D>>2]);x=ea(z*w);z=ea(g[d>>2]);u=ea(t+z);t=ea(g[C>>2]);s=ea(x+t);x=ea(g[r>>2]);E=ea(z+ea(A*x));A=ea(t+ea(w*x));bGb(m,d,e,h,n,o);h=c[B>>2]|0;B=c[h+20>>2]|0;e=c[h+16>>2]|0;x=ea(g[b>>2]);w=ea(ea(e+-1|0)*ea(.99999988));t=ea(ea(B+-1|0)*ea(.99999988));z=ea(u*x);u=ea(g[n>>2]);F=ea(ea(1.00000001e-07)-u);G=z>F?z:F;z=ea(u+w);w=G<z?G:z;G=ea(g[b+8>>2]);H=ea(s*G);s=ea(g[o>>2]);I=ea(ea(1.00000001e-07)-s);J=H>I?H:I;H=ea(t+s);t=J<H?J:H;J=ea(E*x);x=J>F?J:F;F=ea(A*G);G=F>I?F:I;I=ea((x<z?x:z)-w);z=ea((G<H?G:H)-t);o=I>=ea(0.0);H=o?ea(1.0):ea(-1.0);o=z>=ea(0.0);G=o?ea(1.0):ea(-1.0);o=~~H;b=~~G;if(ea(S(ea(I)))<ea(1.00000001e-10))K=ea(H*ea(1.00000001e-10));else K=I;if(ea(S(ea(z)))<ea(1.00000001e-10))L=ea(G*ea(1.00000001e-10));else L=z;n=K>ea(0.0);if(n)M=ea(R(ea(w)));else M=ea(ca(ea(w)));h=~~M;d=L>ea(0.0);if(d)N=ea(R(ea(t)));else N=ea(ca(ea(t)));r=~~N;if(n){N=ea(ca(ea(w)));if(N==w)O=ea(N+ea(1.0));else O=N}else{N=ea(R(ea(w)));if(N==w)O=ea(N+ea(-1.0));else O=N}if(d){N=ea(ca(ea(t)));if(N==t)P=ea(N+ea(1.0));else P=N}else{N=ea(R(ea(t)));if(N==t)P=ea(N+ea(-1.0));else P=N}N=ea(ea(1.0)/ea(S(ea(K))));M=ea(ea(1.0)/ea(S(ea(L))));d=m+12|0;n=m+48|0;C=((o|0)<1)<<31>>31;D=m+52|0;p=((b|0)<1)<<31>>31;q=m+56|0;y=m+76|0;l=m+80|0;Q=m+84|0;T=m+88|0;U=m+16|0;V=m+60|0;W=m+64|0;X=m+20|0;Y=m+68|0;Z=m+72|0;_=m+92|0;$=m+32|0;aa=m+36|0;ba=m+40|0;fa=m+44|0;z=ea(ea(0.0)-u);G=ea(ea(e|0)+u);u=ea(ea(0.0)-s);I=ea(ea(B|0)+s);e=m+76|0;ga=m+60|0;ha=k+4|0;ia=k+8|0;ja=k+12|0;s=ea(ea(O-w)/K);K=ea(ea(P-t)/L);ka=h;h=r;a:while(1){r=s<K;L=r?s:K;if(!(a[m>>0]|0)){a[m>>0]=1;c[d>>2]=f;c[n>>2]=B;c[D>>2]=C;c[q>>2]=p;c[y>>2]=1;c[l>>2]=-1;c[Q>>2]=1;c[T>>2]=-1;la=c[U>>2]|0;ma=ka-la|0;c[V>>2]=ma;na=la+ka|0;c[W>>2]=na;la=c[X>>2]|0;c[Y>>2]=h-la;oa=la+h|0;c[Z>>2]=oa;la=C+ma|0;if((la|0)>(na+C|0))pa=f;else{ma=p;qa=oa;oa=C;ra=na;na=la;while(1){if((na|0)>=(c[$>>2]|0)){if((na|0)>=(c[aa>>2]|0))break;la=ma+(c[Y>>2]|0)|0;if((la|0)<=(qa+ma|0)){sa=ma;ta=qa;ua=la;while(1){if((ua|0)<(c[ba>>2]|0)){va=ta;wa=sa}else{if((ua|0)>=(c[fa>>2]|0)){xa=ta;ya=sa;break}if(!(cGb(m,(da(c[n>>2]|0,na)|0)+ua|0)|0)){za=53;break a}va=c[Z>>2]|0;wa=c[q>>2]|0}if((ua|0)>=(va+wa|0)){xa=va;ya=wa;break}sa=wa;ta=va;ua=ua+1|0}Aa=c[W>>2]|0;Ba=c[D>>2]|0;Ca=xa;Da=ya}else{Aa=ra;Ba=oa;Ca=qa;Da=ma}}else{Aa=ra;Ba=oa;Ca=qa;Da=ma}if((na|0)>=(Aa+Ba|0))break;ma=Da;qa=Ca;oa=Ba;ra=Aa;na=na+1|0}pa=c[d>>2]|0}if(!(xo[c[(c[pa>>2]|0)+8>>2]&2047](pa,c[v>>2]|0,_)|0)){za=53;break}c[v>>2]=0}else{na=c[U>>2]|0;ra=ka-na|0;c[e>>2]=ra;oa=na+ka|0;c[l>>2]=oa;na=c[X>>2]|0;qa=h-na|0;c[Q>>2]=qa;ma=na+h|0;c[T>>2]=ma;na=c[ga>>2]|0;if((ra|0)==(na|0)){ua=c[Y>>2]|0;if((qa|0)!=(ua|0)){a[k>>0]=1;c[ha>>2]=(qa|0)<(ua|0)?qa:ma;c[ia>>2]=ra;c[ja>>2]=oa}}else{a[k>>0]=0;c[ha>>2]=(ra|0)<(na|0)?ra:oa;c[ia>>2]=qa;c[ja>>2]=ma}if(!(dGb(m,k)|0)){za=53;break}ma=c[d>>2]|0;if(!(xo[c[(c[ma>>2]|0)+8>>2]&2047](ma,c[v>>2]|0,_)|0)){za=53;break}c[v>>2]=0;c[ga+0>>2]=c[e+0>>2];c[ga+4>>2]=c[e+4>>2];c[ga+8>>2]=c[e+8>>2];c[ga+12>>2]=c[e+12>>2]}if(r){ma=ka+o|0;t=ea(ma+o|0);if(!(!(t<z)&!(t>=G))){za=53;break}Ea=ea(N+s);Fa=K;Ga=ma;Ha=h}else{ma=h+b|0;t=ea(ma+b|0);if(!(!(t<u)&!(t>=I))){za=53;break}Ea=s;Fa=ea(M+K);Ga=ka;Ha=ma}if(L<ea(1.00010002)){s=Ea;K=Fa;ka=Ga;h=Ha}else{za=53;break}}if((za|0)==53){i=j;return}}function R7a(f,h,j,k,l,m,n,o,p,q,r,s){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);p=p|0;q=ea(q);r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im;t=i;i=i+128|0;u=t+64|0;v=t+96|0;w=t+80|0;x=t;y=t+112|0;z=t+48|0;A=t+16|0;B=t+32|0;c[f>>2]=544120;c[f+4>>2]=h;h=f+64|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;h=f+16|0;g[h>>2]=ea(1.0);C=f+20|0;c[C+0>>2]=c[v+0>>2];c[C+4>>2]=c[v+4>>2];c[C+8>>2]=c[v+8>>2];c[C+12>>2]=c[v+12>>2];D=f+36|0;g[D>>2]=ea(1.0);E=f+40|0;c[E+0>>2]=c[w+0>>2];c[E+4>>2]=c[w+4>>2];c[E+8>>2]=c[w+8>>2];c[E+12>>2]=c[w+12>>2];w=f+56|0;g[w>>2]=ea(1.0);F=f+60|0;g[F>>2]=ea(0.0);c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;G=f+80|0;g[G>>2]=ea(0.0);H=f+84|0;g[H>>2]=ea(0.0);I=f+88|0;g[I>>2]=ea(0.0);J=f+92|0;g[J>>2]=ea(1.0);K=f+96|0;c[K+0>>2]=c[x+0>>2];c[K+4>>2]=c[x+4>>2];c[K+8>>2]=c[x+8>>2];c[K+12>>2]=c[x+12>>2];x=f+112|0;K=f+176|0;c[f+192>>2]=0;L=f+128|0;g[L>>2]=ea(0.0);M=f+132|0;c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];N=f+144|0;g[N>>2]=ea(0.0);O=f+148|0;c[O+0>>2]=c[v+0>>2];c[O+4>>2]=c[v+4>>2];c[O+8>>2]=c[v+8>>2];g[f+160>>2]=ea(0.0);P=f+164|0;c[P+0>>2]=c[v+0>>2];c[P+4>>2]=c[v+4>>2];c[P+8>>2]=c[v+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[K+0>>2]=c[u+0>>2];c[K+4>>2]=c[u+4>>2];c[K+8>>2]=c[u+8>>2];c[K+12>>2]=c[u+12>>2];c[f+320>>2]=0;c[f+324>>2]=0;b[f+332>>1]=0;K=f+336|0;P=f+360|0;c[K+0>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;c[K+12>>2]=0;c[K+16>>2]=0;c[K+20>>2]=0;g[P>>2]=ea(3402823469999999843913219.0e14);g[f+400>>2]=ea(g[n>>2]);K=n+4|0;g[f+404>>2]=ea(g[K>>2]);Q=n+8|0;g[f+408>>2]=ea(g[Q>>2]);g[f+424>>2]=q;c[f+428>>2]=e[p>>1];a[f+432>>0]=r&1;a[f+433>>0]=s&1;a[f+434>>0]=0;a[f+435>>0]=0;c[f+328>>2]=-1;g[P>>2]=o;q=ea(g[n>>2]);R=ea(g[K>>2]);S=ea(g[Q>>2]);T=ea(g[m>>2]);U=ea(g[m+4>>2]);V=ea(g[m+8>>2]);W=ea(g[m+12>>2]);P=m+16|0;X=ea(g[P>>2]);Y=ea(g[P+4>>2]);Z=ea(g[P+8>>2]);_=ea(g[l>>2]);$=ea(g[l+4>>2]);aa=ea(g[l+8>>2]);ba=ea(g[l+12>>2]);P=l+16|0;ca=ea(g[P>>2]);da=ea(g[P+4>>2]);fa=ea(g[P+8>>2]);ga=ea(-_);ha=ea(-$);ia=ea(-aa);ja=ea(X-ca);X=ea(Y-da);Y=ea(Z-fa);Z=ea(ea(ba*ba)+ea(-.5));ka=ea(ea(ea(ja*ga)+ea(X*ha))+ea(Y*ia));la=ea(ea(ea(ka*ga)+ea(ea(Z*ja)+ea(ba*ea(ea(Y*ha)-ea(X*ia)))))*ea(2.0));ma=ea(ea(ea(ka*ha)+ea(ea(Z*X)+ea(ba*ea(ea(ja*ia)-ea(Y*ga)))))*ea(2.0));na=ea(ea(ea(ea(Z*Y)+ea(ba*ea(ea(X*ga)-ea(ja*ha))))+ea(ka*ia))*ea(2.0));ka=ea(ea(W*ba)-ea(ea(ea(T*ga)+ea(U*ha))+ea(V*ia)));ja=ea(ea(ea(V*ha)-ea(U*ia))+ea(ea(W*ga)+ea(T*ba)));X=ea(ea(ea(T*ia)-ea(V*ga))+ea(ea(W*ha)+ea(U*ba)));Y=ea(ea(ea(U*ga)-ea(T*ha))+ea(ea(V*ba)+ea(W*ia)));ia=ea(ja+ja);W=ea(X+X);V=ea(Y+Y);ha=ea(X*W);T=ea(Y*V);ga=ea(X*ia);X=ea(Y*ia);U=ea(ka*ia);oa=ea(Y*W);Y=ea(ka*W);W=ea(ka*V);V=ea(ea(1.0)-ea(ja*ia));ia=ea(ga+W);ja=ea(X-Y);ka=ea(ga-W);W=ea(V-T);ga=ea(oa+U);pa=ea(X+Y);Y=ea(oa-U);U=ea(V-ha);g[h>>2]=ea(ea(ea(1.0)-ha)-T);g[C>>2]=ia;g[f+24>>2]=ja;g[f+28>>2]=ea(0.0);g[f+32>>2]=ka;g[D>>2]=W;g[E>>2]=ga;g[f+44>>2]=ea(0.0);g[f+48>>2]=pa;g[f+52>>2]=Y;g[w>>2]=U;g[F>>2]=ea(0.0);g[f+64>>2]=la;g[f+68>>2]=ma;g[f+72>>2]=na;g[f+76>>2]=ea(0.0);g[G>>2]=_;g[H>>2]=$;g[I>>2]=aa;g[J>>2]=ba;g[f+96>>2]=ca;g[f+100>>2]=da;g[f+104>>2]=fa;g[f+108>>2]=ea(0.0);fa=ea(-ea(q*o));q=ea(-ea(R*o));R=ea(-ea(S*o));S=ea(ea(ea(_*fa)+ea($*q))+ea(aa*R));da=ea(ea(ea($*S)+ea(ea(Z*q)-ea(ba*ea(ea(aa*fa)-ea(_*R)))))*ea(2.0));ca=ea(ea(ea(aa*S)+ea(ea(Z*R)-ea(ba*ea(ea(_*q)-ea($*fa)))))*ea(2.0));g[f+368>>2]=ea(ea(ea(_*S)+ea(ea(Z*fa)-ea(ba*ea(ea($*R)-ea(aa*q)))))*ea(2.0));g[f+372>>2]=da;g[f+376>>2]=ca;g[f+380>>2]=ea(0.0);g[f+384>>2]=o;J=f+388|0;c[J+0>>2]=c[y+0>>2];c[J+4>>2]=c[y+4>>2];c[J+8>>2]=c[y+8>>2];o=ea(g[k>>2]);ca=ea(g[k+4>>2]);da=ea(g[k+8>>2]);g[z>>2]=o;g[z+4>>2]=ca;g[z+8>>2]=da;g[z+12>>2]=ea(0.0);y=k+12|0;q=ea(g[y>>2]);aa=ea(g[y+4>>2]);R=ea(g[y+8>>2]);$=ea(g[y+12>>2]);g[A>>2]=q;g[A+4>>2]=aa;g[A+8>>2]=R;g[A+12>>2]=$;$=ea(ea(g[n>>2])*ea(2.0));R=ea(ea(g[K>>2])*ea(2.0));aa=ea(ea(g[Q>>2])*ea(2.0));q=ea(g[m+12>>2]);ba=ea(ea(q*q)+ea(-.5));fa=ea(g[m>>2]);Z=ea($*fa);S=ea(g[m+4>>2]);_=ea(Z+ea(R*S));Z=ea(g[m+8>>2]);na=ea(_+ea(aa*Z));_=ea(ea(S*na)+ea(ea(R*ba)-ea(q*ea(ea($*Z)-ea(aa*fa)))));ma=ea(ea(ea(aa*ba)-ea(q*ea(ea(R*fa)-ea($*S))))+ea(Z*na));g[f+412>>2]=ea(ea(fa*na)+ea(ea($*ba)-ea(q*ea(ea(aa*S)-ea(R*Z)))));g[f+416>>2]=_;g[f+420>>2]=ma;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;m=(c[j+40>>2]|0)+((d[j+39>>0]|0)*20|0)|0;ma=ea(g[j+52>>2]);_=ea(g[j+56>>2]);Z=ea(ma*o);o=ea(_*ca);ca=ea(ea(g[j+60>>2])*da);da=!(Z<=o)?o:Z;_=!(da<=ca)?ca:da;da=!(Z>=o)?o:Z;Z=ea(_*ea(.200000003));o=ea((!(da>=ca)?ca:da)*ea(.0500000007));da=Z>o?Z:o;g[L>>2]=_>da?da:_;c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];g[N>>2]=ea(_*ea(.100000001));c[O+0>>2]=c[u+0>>2];c[O+4>>2]=c[u+4>>2];c[O+8>>2]=c[u+8>>2];jEb(z,A,f+208|0,f+256|0);c[f+312>>2]=m;a[f+316>>0]=a[j+38>>0]|0;c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];B=j+44|0;c[f+308>>2]=c[B>>2];c[f+304>>2]=j;if(!(c[B>>2]|0)){i=t;return}i=t;return}function S7a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=Im,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=0,Ha=0;j=i;i=i+240|0;k=j+16|0;l=j+200|0;m=j+32|0;n=j+224|0;o=j+232|0;p=j;q=j+192|0;r=j+228|0;zRa(b,l);s=ea(g[l>>2]);t=ea(g[h>>2]);u=ea(s-t);v=l+4|0;s=ea(g[v>>2]);w=ea(g[h+4>>2]);x=ea(s-w);y=l+8|0;s=ea(g[y>>2]);z=ea(g[h+8>>2]);A=ea(s-z);g[l>>2]=u;g[v>>2]=x;g[y>>2]=A;y=l+12|0;A=ea(ea(g[y>>2])+t);v=l+16|0;t=ea(ea(g[v>>2])+w);B=l+20|0;w=ea(ea(g[B>>2])+z);g[y>>2]=A;g[v>>2]=t;g[B>>2]=w;B=b+12|0;v=c[B>>2]|0;a[m>>0]=0;c[m+4>>2]=b;c[m+8>>2]=v;v=m+156|0;c[v>>2]=0;g[n>>2]=ea(0.0);g[o>>2]=ea(0.0);w=ea(g[e>>2]);t=ea(w-ea(g[d>>2]));w=ea(g[e+4>>2]);A=ea(w-ea(g[d+4>>2]));w=ea(g[e+8>>2]);C=d+8|0;z=ea(w-ea(g[C>>2]));g[p>>2]=t;g[p+4>>2]=A;D=p+8|0;g[D>>2]=z;if(!(RPa(l,y,d,p,ea(1.0),q,r)|0)){i=j;return}z=ea(g[q>>2]);A=ea(g[p>>2]);t=ea(z*A);w=ea(g[D>>2]);x=ea(z*w);z=ea(g[d>>2]);u=ea(t+z);t=ea(g[C>>2]);s=ea(x+t);x=ea(g[r>>2]);E=ea(z+ea(A*x));A=ea(t+ea(w*x));eGb(m,d,e,h,n,o);h=c[B>>2]|0;B=c[h+20>>2]|0;e=c[h+16>>2]|0;x=ea(g[b>>2]);w=ea(ea(e+-1|0)*ea(.99999988));t=ea(ea(B+-1|0)*ea(.99999988));z=ea(u*x);u=ea(g[n>>2]);F=ea(ea(1.00000001e-07)-u);G=z>F?z:F;z=ea(u+w);w=G<z?G:z;G=ea(g[b+8>>2]);H=ea(s*G);s=ea(g[o>>2]);I=ea(ea(1.00000001e-07)-s);J=H>I?H:I;H=ea(t+s);t=J<H?J:H;J=ea(E*x);x=J>F?J:F;F=ea(A*G);G=F>I?F:I;I=ea((x<z?x:z)-w);z=ea((G<H?G:H)-t);o=I>=ea(0.0);H=o?ea(1.0):ea(-1.0);o=z>=ea(0.0);G=o?ea(1.0):ea(-1.0);o=~~H;b=~~G;if(ea(S(ea(I)))<ea(1.00000001e-10))K=ea(H*ea(1.00000001e-10));else K=I;if(ea(S(ea(z)))<ea(1.00000001e-10))L=ea(G*ea(1.00000001e-10));else L=z;n=K>ea(0.0);if(n)M=ea(R(ea(w)));else M=ea(ca(ea(w)));h=~~M;d=L>ea(0.0);if(d)N=ea(R(ea(t)));else N=ea(ca(ea(t)));r=~~N;if(n){N=ea(ca(ea(w)));if(N==w)O=ea(N+ea(1.0));else O=N}else{N=ea(R(ea(w)));if(N==w)O=ea(N+ea(-1.0));else O=N}if(d){N=ea(ca(ea(t)));if(N==t)P=ea(N+ea(1.0));else P=N}else{N=ea(R(ea(t)));if(N==t)P=ea(N+ea(-1.0));else P=N}N=ea(ea(1.0)/ea(S(ea(K))));M=ea(ea(1.0)/ea(S(ea(L))));d=m+12|0;n=m+48|0;C=((o|0)<1)<<31>>31;D=m+52|0;p=((b|0)<1)<<31>>31;q=m+56|0;y=m+76|0;l=m+80|0;Q=m+84|0;T=m+88|0;U=m+16|0;V=m+60|0;W=m+64|0;X=m+20|0;Y=m+68|0;Z=m+72|0;_=m+92|0;$=m+32|0;aa=m+36|0;ba=m+40|0;fa=m+44|0;z=ea(ea(0.0)-u);G=ea(ea(e|0)+u);u=ea(ea(0.0)-s);I=ea(ea(B|0)+s);e=m+76|0;ga=m+60|0;ha=k+4|0;ia=k+8|0;ja=k+12|0;s=ea(ea(O-w)/K);K=ea(ea(P-t)/L);ka=h;h=r;a:while(1){r=s<K;L=r?s:K;if(!(a[m>>0]|0)){a[m>>0]=1;c[d>>2]=f;c[n>>2]=B;c[D>>2]=C;c[q>>2]=p;c[y>>2]=1;c[l>>2]=-1;c[Q>>2]=1;c[T>>2]=-1;la=c[U>>2]|0;ma=ka-la|0;c[V>>2]=ma;na=la+ka|0;c[W>>2]=na;la=c[X>>2]|0;c[Y>>2]=h-la;oa=la+h|0;c[Z>>2]=oa;la=C+ma|0;if((la|0)>(na+C|0))pa=f;else{ma=p;qa=oa;oa=C;ra=na;na=la;while(1){if((na|0)>=(c[$>>2]|0)){if((na|0)>=(c[aa>>2]|0))break;la=ma+(c[Y>>2]|0)|0;if((la|0)<=(qa+ma|0)){sa=ma;ta=qa;ua=la;while(1){if((ua|0)<(c[ba>>2]|0)){va=ta;wa=sa}else{if((ua|0)>=(c[fa>>2]|0)){xa=ta;ya=sa;break}if(!(fGb(m,(da(c[n>>2]|0,na)|0)+ua|0)|0)){za=53;break a}va=c[Z>>2]|0;wa=c[q>>2]|0}if((ua|0)>=(va+wa|0)){xa=va;ya=wa;break}sa=wa;ta=va;ua=ua+1|0}Aa=c[W>>2]|0;Ba=c[D>>2]|0;Ca=xa;Da=ya}else{Aa=ra;Ba=oa;Ca=qa;Da=ma}}else{Aa=ra;Ba=oa;Ca=qa;Da=ma}if((na|0)>=(Aa+Ba|0))break;ma=Da;qa=Ca;oa=Ba;ra=Aa;na=na+1|0}pa=c[d>>2]|0}if(!(xo[c[(c[pa>>2]|0)+8>>2]&2047](pa,c[v>>2]|0,_)|0)){za=53;break}c[v>>2]=0}else{na=c[U>>2]|0;ra=ka-na|0;c[e>>2]=ra;oa=na+ka|0;c[l>>2]=oa;na=c[X>>2]|0;qa=h-na|0;c[Q>>2]=qa;ma=na+h|0;c[T>>2]=ma;na=c[ga>>2]|0;if((ra|0)==(na|0)){ua=c[Y>>2]|0;if((qa|0)!=(ua|0)){a[k>>0]=1;c[ha>>2]=(qa|0)<(ua|0)?qa:ma;c[ia>>2]=ra;c[ja>>2]=oa}}else{a[k>>0]=0;c[ha>>2]=(ra|0)<(na|0)?ra:oa;c[ia>>2]=qa;c[ja>>2]=ma}if(!(gGb(m,k)|0)){za=53;break}ma=c[d>>2]|0;if(!(xo[c[(c[ma>>2]|0)+8>>2]&2047](ma,c[v>>2]|0,_)|0)){za=53;break}c[v>>2]=0;c[ga+0>>2]=c[e+0>>2];c[ga+4>>2]=c[e+4>>2];c[ga+8>>2]=c[e+8>>2];c[ga+12>>2]=c[e+12>>2]}if(r){ma=ka+o|0;t=ea(ma+o|0);if(!(!(t<z)&!(t>=G))){za=53;break}Ea=ea(N+s);Fa=K;Ga=ma;Ha=h}else{ma=h+b|0;t=ea(ma+b|0);if(!(!(t<u)&!(t>=I))){za=53;break}Ea=s;Fa=ea(M+K);Ga=ka;Ha=ma}if(L<ea(1.00010002)){s=Ea;K=Fa;ka=Ga;h=Ha}else{za=53;break}}if((za|0)==53){i=j;return}}function T7a(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=Im,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=0,Ha=0;j=i;i=i+240|0;k=j+16|0;l=j+200|0;m=j+32|0;n=j+224|0;o=j+232|0;p=j;q=j+192|0;r=j+228|0;zRa(b,l);s=ea(g[l>>2]);t=ea(g[h>>2]);u=ea(s-t);v=l+4|0;s=ea(g[v>>2]);w=ea(g[h+4>>2]);x=ea(s-w);y=l+8|0;s=ea(g[y>>2]);z=ea(g[h+8>>2]);A=ea(s-z);g[l>>2]=u;g[v>>2]=x;g[y>>2]=A;y=l+12|0;A=ea(ea(g[y>>2])+t);v=l+16|0;t=ea(ea(g[v>>2])+w);B=l+20|0;w=ea(ea(g[B>>2])+z);g[y>>2]=A;g[v>>2]=t;g[B>>2]=w;B=b+12|0;v=c[B>>2]|0;a[m>>0]=0;c[m+4>>2]=b;c[m+8>>2]=v;v=m+156|0;c[v>>2]=0;g[n>>2]=ea(0.0);g[o>>2]=ea(0.0);w=ea(g[e>>2]);t=ea(w-ea(g[d>>2]));w=ea(g[e+4>>2]);A=ea(w-ea(g[d+4>>2]));w=ea(g[e+8>>2]);C=d+8|0;z=ea(w-ea(g[C>>2]));g[p>>2]=t;g[p+4>>2]=A;D=p+8|0;g[D>>2]=z;if(!(RPa(l,y,d,p,ea(1.0),q,r)|0)){i=j;return}z=ea(g[q>>2]);A=ea(g[p>>2]);t=ea(z*A);w=ea(g[D>>2]);x=ea(z*w);z=ea(g[d>>2]);u=ea(t+z);t=ea(g[C>>2]);s=ea(x+t);x=ea(g[r>>2]);E=ea(z+ea(A*x));A=ea(t+ea(w*x));hGb(m,d,e,h,n,o);h=c[B>>2]|0;B=c[h+20>>2]|0;e=c[h+16>>2]|0;x=ea(g[b>>2]);w=ea(ea(e+-1|0)*ea(.99999988));t=ea(ea(B+-1|0)*ea(.99999988));z=ea(u*x);u=ea(g[n>>2]);F=ea(ea(1.00000001e-07)-u);G=z>F?z:F;z=ea(u+w);w=G<z?G:z;G=ea(g[b+8>>2]);H=ea(s*G);s=ea(g[o>>2]);I=ea(ea(1.00000001e-07)-s);J=H>I?H:I;H=ea(t+s);t=J<H?J:H;J=ea(E*x);x=J>F?J:F;F=ea(A*G);G=F>I?F:I;I=ea((x<z?x:z)-w);z=ea((G<H?G:H)-t);o=I>=ea(0.0);H=o?ea(1.0):ea(-1.0);o=z>=ea(0.0);G=o?ea(1.0):ea(-1.0);o=~~H;b=~~G;if(ea(S(ea(I)))<ea(1.00000001e-10))K=ea(H*ea(1.00000001e-10));else K=I;if(ea(S(ea(z)))<ea(1.00000001e-10))L=ea(G*ea(1.00000001e-10));else L=z;n=K>ea(0.0);if(n)M=ea(R(ea(w)));else M=ea(ca(ea(w)));h=~~M;d=L>ea(0.0);if(d)N=ea(R(ea(t)));else N=ea(ca(ea(t)));r=~~N;if(n){N=ea(ca(ea(w)));if(N==w)O=ea(N+ea(1.0));else O=N}else{N=ea(R(ea(w)));if(N==w)O=ea(N+ea(-1.0));else O=N}if(d){N=ea(ca(ea(t)));if(N==t)P=ea(N+ea(1.0));else P=N}else{N=ea(R(ea(t)));if(N==t)P=ea(N+ea(-1.0));else P=N}N=ea(ea(1.0)/ea(S(ea(K))));M=ea(ea(1.0)/ea(S(ea(L))));d=m+12|0;n=m+48|0;C=((o|0)<1)<<31>>31;D=m+52|0;p=((b|0)<1)<<31>>31;q=m+56|0;y=m+76|0;l=m+80|0;Q=m+84|0;T=m+88|0;U=m+16|0;V=m+60|0;W=m+64|0;X=m+20|0;Y=m+68|0;Z=m+72|0;_=m+92|0;$=m+32|0;aa=m+36|0;ba=m+40|0;fa=m+44|0;z=ea(ea(0.0)-u);G=ea(ea(e|0)+u);u=ea(ea(0.0)-s);I=ea(ea(B|0)+s);e=m+76|0;ga=m+60|0;ha=k+4|0;ia=k+8|0;ja=k+12|0;s=ea(ea(O-w)/K);K=ea(ea(P-t)/L);ka=h;h=r;a:while(1){r=s<K;L=r?s:K;if(!(a[m>>0]|0)){a[m>>0]=1;c[d>>2]=f;c[n>>2]=B;c[D>>2]=C;c[q>>2]=p;c[y>>2]=1;c[l>>2]=-1;c[Q>>2]=1;c[T>>2]=-1;la=c[U>>2]|0;ma=ka-la|0;c[V>>2]=ma;na=la+ka|0;c[W>>2]=na;la=c[X>>2]|0;c[Y>>2]=h-la;oa=la+h|0;c[Z>>2]=oa;la=C+ma|0;if((la|0)>(na+C|0))pa=f;else{ma=p;qa=oa;oa=C;ra=na;na=la;while(1){if((na|0)>=(c[$>>2]|0)){if((na|0)>=(c[aa>>2]|0))break;la=ma+(c[Y>>2]|0)|0;if((la|0)<=(qa+ma|0)){sa=ma;ta=qa;ua=la;while(1){if((ua|0)<(c[ba>>2]|0)){va=ta;wa=sa}else{if((ua|0)>=(c[fa>>2]|0)){xa=ta;ya=sa;break}if(!(iGb(m,(da(c[n>>2]|0,na)|0)+ua|0)|0)){za=53;break a}va=c[Z>>2]|0;wa=c[q>>2]|0}if((ua|0)>=(va+wa|0)){xa=va;ya=wa;break}sa=wa;ta=va;ua=ua+1|0}Aa=c[W>>2]|0;Ba=c[D>>2]|0;Ca=xa;Da=ya}else{Aa=ra;Ba=oa;Ca=qa;Da=ma}}else{Aa=ra;Ba=oa;Ca=qa;Da=ma}if((na|0)>=(Aa+Ba|0))break;ma=Da;qa=Ca;oa=Ba;ra=Aa;na=na+1|0}pa=c[d>>2]|0}if(!(xo[c[(c[pa>>2]|0)+8>>2]&2047](pa,c[v>>2]|0,_)|0)){za=53;break}c[v>>2]=0}else{na=c[U>>2]|0;ra=ka-na|0;c[e>>2]=ra;oa=na+ka|0;c[l>>2]=oa;na=c[X>>2]|0;qa=h-na|0;c[Q>>2]=qa;ma=na+h|0;c[T>>2]=ma;na=c[ga>>2]|0;if((ra|0)==(na|0)){ua=c[Y>>2]|0;if((qa|0)!=(ua|0)){a[k>>0]=1;c[ha>>2]=(qa|0)<(ua|0)?qa:ma;c[ia>>2]=ra;c[ja>>2]=oa}}else{a[k>>0]=0;c[ha>>2]=(ra|0)<(na|0)?ra:oa;c[ia>>2]=qa;c[ja>>2]=ma}if(!(jGb(m,k)|0)){za=53;break}ma=c[d>>2]|0;if(!(xo[c[(c[ma>>2]|0)+8>>2]&2047](ma,c[v>>2]|0,_)|0)){za=53;break}c[v>>2]=0;c[ga+0>>2]=c[e+0>>2];c[ga+4>>2]=c[e+4>>2];c[ga+8>>2]=c[e+8>>2];c[ga+12>>2]=c[e+12>>2]}if(r){ma=ka+o|0;t=ea(ma+o|0);if(!(!(t<z)&!(t>=G))){za=53;break}Ea=ea(N+s);Fa=K;Ga=ma;Ha=h}else{ma=h+b|0;t=ea(ma+b|0);if(!(!(t<u)&!(t>=I))){za=53;break}Ea=s;Fa=ea(M+K);Ga=ka;Ha=ma}if(L<ea(1.00010002)){s=Ea;K=Fa;ka=Ga;h=Ha}else{za=53;break}}if((za|0)==53){i=j;return}}function U7a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=Im,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=0,I=Im,J=0,K=Im,L=Im,M=0,N=0,O=0;f=i;h=ea(g[e>>2]);j=ea(h*h);e=b+32|0;k=a[e>>0]|0;if(!(k<<24>>24)){i=f;return}l=b+44|0;b=d+48|0;m=d+52|0;n=d+56|0;o=d+16|0;p=d+32|0;q=d+4|0;r=d+20|0;s=d+36|0;t=d+8|0;u=d+24|0;v=d+40|0;w=k&255;do{w=w+-1|0;k=c[l>>2]|0;h=ea(g[b>>2]);x=ea(g[m>>2]);y=ea(g[n>>2]);z=ea(g[k+(w*48|0)>>2]);A=ea(g[k+(w*48|0)+4>>2]);B=ea(g[k+(w*48|0)+8>>2]);C=ea(z*ea(g[d>>2]));D=ea(C+ea(A*ea(g[o>>2])));C=ea(D+ea(B*ea(g[p>>2])));D=ea(z*ea(g[q>>2]));E=ea(D+ea(A*ea(g[r>>2])));D=ea(E+ea(B*ea(g[s>>2])));E=ea(z*ea(g[t>>2]));z=ea(E+ea(A*ea(g[u>>2])));A=ea(h+C);C=ea(x+D);D=ea(y+ea(z+ea(B*ea(g[v>>2]))));B=ea(g[k+(w*48|0)+16>>2]);z=ea(g[k+(w*48|0)+20>>2]);y=ea(g[k+(w*48|0)+24>>2]);x=ea(A-B);h=ea(C-z);E=ea(D-y);F=k+(w*48|0)+32|0;G=ea(g[F>>2]);H=k+(w*48|0)+36|0;I=ea(g[H>>2]);J=k+(w*48|0)+40|0;K=ea(g[J>>2]);L=ea(ea(ea(x*G)+ea(h*I))+ea(E*K));E=ea(B-ea(A-ea(G*L)));A=ea(z-ea(C-ea(I*L)));C=ea(y-ea(D-ea(K*L)));if(ea(ea(C*C)+ea(ea(E*E)+ea(A*A)))>j){M=(a[e>>0]|0)+-1<<24>>24;a[e>>0]=M;N=k+(w*48|0)+0|0;O=k+((M&255)*48|0)+0|0;M=N+48|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(M|0))}else{g[F>>2]=G;g[H>>2]=I;g[J>>2]=K;g[k+(w*48|0)+44>>2]=L}}while((w|0)!=0);i=f;return}function V7a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,T=Im;f=i;i=i+96|0;h=f+80|0;j=f+64|0;k=f+48|0;l=f+32|0;m=f+16|0;n=f;o=ea(g[e>>2]);p=ea(g[e+4>>2]);q=ea(g[e+8>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);t=ea(g[d+8>>2]);u=ea(g[d+16>>2]);v=ea(g[d+20>>2]);w=ea(g[d+24>>2]);x=ea(g[d+28>>2]);y=ea(g[d+32>>2]);z=ea(g[d+36>>2]);A=ea(g[d+40>>2]);B=ea(g[d+44>>2]);C=ea(g[c>>2]);D=ea(g[c+4>>2]);E=ea(g[c+8>>2]);F=ea(ea(ea(r*C)+ea(s*D))+ea(t*E));G=ea(ea(ea(u*C)+ea(v*D))+ea(w*E));H=ea(ea(ea(y*C)+ea(z*D))+ea(A*E));E=ea(S(ea(F)));D=ea(S(ea(G)));C=ea(S(ea(H)));if(!(!(E>=D)|!(E>=C))){E=ea(g[d+12>>2]);c=F>ea(0.0);F=ea(-s);I=ea(-t);g[j>>2]=ea(-r);g[j+4>>2]=F;g[j+8>>2]=I;g[j+12>>2]=ea(0.0);g[h>>2]=r;g[h+4>>2]=s;g[h+8>>2]=t;g[h+12>>2]=E;e=c?j:h;E=ea(g[e>>2]);I=ea(g[e+4>>2]);F=ea(g[e+8>>2]);g[b>>2]=E;g[b+4>>2]=I;g[b+8>>2]=F;g[b+12>>2]=ea(0.0);F=ea(-o);I=c?F:o;F=ea(r*I);E=ea(s*I);J=ea(t*I);I=ea(p*u);K=ea(p*v);L=ea(p*w);M=ea(q*y);N=ea(q*z);O=ea(q*A);P=ea(g[d+48>>2]);Q=ea(g[d+52>>2]);R=ea(F+P);P=ea(E+Q);Q=ea(J+ea(g[d+56>>2]));J=ea(I+M);E=ea(K+N);F=ea(L+O);T=ea(I-M);M=ea(K-N);N=ea(L-O);O=ea(E+P);L=ea(F+Q);g[a>>2]=ea(J+R);g[a+4>>2]=O;g[a+8>>2]=L;g[a+12>>2]=ea(0.0);L=ea(M+P);O=ea(N+Q);g[a+16>>2]=ea(T+R);g[a+20>>2]=L;g[a+24>>2]=O;g[a+28>>2]=ea(0.0);O=ea(P-E);E=ea(Q-F);g[a+32>>2]=ea(R-J);g[a+36>>2]=O;g[a+40>>2]=E;g[a+44>>2]=ea(0.0);E=ea(P-M);M=ea(Q-N);g[a+48>>2]=ea(R-T);g[a+52>>2]=E;g[a+56>>2]=M;g[a+60>>2]=ea(0.0);i=f;return}if(!(D>=C)){c=H>ea(0.0);H=ea(-z);C=ea(-A);g[n>>2]=ea(-y);g[n+4>>2]=H;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);g[m>>2]=y;g[m+4>>2]=z;g[m+8>>2]=A;g[m+12>>2]=B;e=c?n:m;B=ea(g[e>>2]);C=ea(g[e+4>>2]);H=ea(g[e+8>>2]);g[b>>2]=B;g[b+4>>2]=C;g[b+8>>2]=H;g[b+12>>2]=ea(0.0);H=ea(-q);C=c?H:q;H=ea(o*r);B=ea(o*s);D=ea(o*t);M=ea(p*u);E=ea(p*v);T=ea(p*w);R=ea(y*C);N=ea(z*C);Q=ea(A*C);C=ea(g[d+48>>2]);P=ea(g[d+52>>2]);O=ea(R+C);C=ea(N+P);P=ea(Q+ea(g[d+56>>2]));Q=ea(H+M);N=ea(B+E);R=ea(D+T);J=ea(H-M);M=ea(B-E);E=ea(D-T);T=ea(N+C);D=ea(R+P);g[a>>2]=ea(Q+O);g[a+4>>2]=T;g[a+8>>2]=D;g[a+12>>2]=ea(0.0);D=ea(M+C);T=ea(E+P);g[a+16>>2]=ea(J+O);g[a+20>>2]=D;g[a+24>>2]=T;g[a+28>>2]=ea(0.0);T=ea(C-N);N=ea(P-R);g[a+32>>2]=ea(O-Q);g[a+36>>2]=T;g[a+40>>2]=N;g[a+44>>2]=ea(0.0);N=ea(C-M);M=ea(P-E);g[a+48>>2]=ea(O-J);g[a+52>>2]=N;g[a+56>>2]=M;g[a+60>>2]=ea(0.0);i=f;return}else{c=G>ea(0.0);G=ea(-v);M=ea(-w);g[l>>2]=ea(-u);g[l+4>>2]=G;g[l+8>>2]=M;g[l+12>>2]=ea(0.0);g[k>>2]=u;g[k+4>>2]=v;g[k+8>>2]=w;g[k+12>>2]=x;e=c?l:k;x=ea(g[e>>2]);M=ea(g[e+4>>2]);G=ea(g[e+8>>2]);g[b>>2]=x;g[b+4>>2]=M;g[b+8>>2]=G;g[b+12>>2]=ea(0.0);G=ea(-p);M=c?G:p;p=ea(o*r);r=ea(o*s);s=ea(o*t);t=ea(u*M);u=ea(v*M);v=ea(w*M);M=ea(q*y);y=ea(q*z);z=ea(q*A);A=ea(g[d+48>>2]);q=ea(g[d+52>>2]);w=ea(t+A);A=ea(u+q);q=ea(v+ea(g[d+56>>2]));v=ea(p+M);u=ea(r+y);t=ea(s+z);o=ea(p-M);M=ea(r-y);y=ea(s-z);z=ea(u+A);s=ea(t+q);g[a>>2]=ea(v+w);g[a+4>>2]=z;g[a+8>>2]=s;g[a+12>>2]=ea(0.0);s=ea(M+A);z=ea(y+q);g[a+16>>2]=ea(o+w);g[a+20>>2]=s;g[a+24>>2]=z;g[a+28>>2]=ea(0.0);z=ea(A-u);u=ea(q-t);g[a+32>>2]=ea(w-v);g[a+36>>2]=z;g[a+40>>2]=u;g[a+44>>2]=ea(0.0);u=ea(A-M);M=ea(q-y);g[a+48>>2]=ea(w-o);g[a+52>>2]=u;g[a+56>>2]=M;g[a+60>>2]=ea(0.0);i=f;return}}function W7a(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=0,M=Im,N=0,O=Im,P=Im,Q=Im,R=Im,S=0,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im;m=i;i=i+96|0;n=m;o=m+32|0;p=m+48|0;q=m+64|0;r=m+16|0;s=m+84|0;t=m+80|0;u=ea(g[b>>2]);v=ea(g[d>>2]);w=h+4|0;x=h+8|0;y=ea(3402823469999999843913219.0e14);z=ea(-3402823469999999843913219.0e14);A=ea(3402823469999999843913219.0e14);B=ea(-3402823469999999843913219.0e14);C=0;do{D=e+(C<<4)|0;E=ea(g[D>>2]);F=ea(g[e+(C<<4)+4>>2]);G=ea(g[e+(C<<4)+8>>2]);y=y<E?y:E;A=A<F?A:F;z=z>E?z:E;B=B>F?B:F;H=ea(-G);I=s+C|0;do if(ea(g[l>>2])>H){a[I>>0]=1;J=ea(-E);K=ea(-F);L=t+C|0;if((u>=(E>J?E:J)?!(v>=(F>K?F:K)):1)|!((G>H?G:H)<=ea(3402823469999999843913219.0e14))){a[L>>0]=0;break}else{a[L>>0]=1;L=c[k>>2]|0;g[j+(L*48|0)>>2]=E;g[j+(L*48|0)+4>>2]=F;g[j+(L*48|0)+8>>2]=ea(0.0);g[j+(L*48|0)+12>>2]=ea(0.0);L=j+((c[k>>2]|0)*48|0)+16|0;c[L+0>>2]=c[D+0>>2];c[L+4>>2]=c[D+4>>2];c[L+8>>2]=c[D+8>>2];c[L+12>>2]=c[D+12>>2];L=c[k>>2]|0;c[k>>2]=L+1;K=ea(g[h>>2]);J=ea(g[w>>2]);M=ea(g[x>>2]);g[j+(L*48|0)+32>>2]=K;g[j+(L*48|0)+36>>2]=J;g[j+(L*48|0)+40>>2]=M;g[j+(L*48|0)+44>>2]=H;break}}else{a[I>>0]=0;a[t+C>>0]=0}while(0);C=C+1|0}while((C|0)!=4);H=ea(-u);F=ea(-v);C=c[k>>2]|0;if((C|0)==4){i=m;return}I=f+8|0;E=ea(g[I>>2]);G=ea(g[b>>2]);M=ea(g[d>>2]);a:do if(!(G>z|y>G)?!(M>B|A>M):0){J=ea(g[e+52>>2]);D=0;L=0;N=3;while(1){K=J;J=ea(g[e+(D<<4)+4>>2]);if(K>M^J>M?(O=ea(g[e+(N<<4)>>2]),P=ea(J-K),Q=ea(G*P),R=ea(ea(P*O)+ea(ea(M-K)*ea(ea(g[e+(D<<4)>>2])-O))),S=!(P>ea(0.0)),(S?Q:R)>=(S?R:Q)):0){if((L|0)==1){T=G;break a}U=L+1|0}else U=L;S=D+1|0;if(S>>>0>=4)break;else{V=D;D=S;L=U;N=V}}if((U|0)!=0?(J=ea(g[f>>2]),Q=ea(g[f+4>>2]),R=ea(g[e>>2]),P=ea(g[e+4>>2]),O=ea(ea(ea(E*ea(g[e+8>>2]))+ea(ea(J*ea(R-G))+ea(Q*ea(P-M))))/E),P=ea(-O),ea(g[l>>2])>P):0){g[j+(C*48|0)>>2]=G;g[j+(C*48|0)+4>>2]=M;g[j+(C*48|0)+8>>2]=ea(0.0);g[j+(C*48|0)+12>>2]=ea(0.0);N=c[k>>2]|0;g[j+(N*48|0)+16>>2]=G;g[j+(N*48|0)+20>>2]=M;g[j+(N*48|0)+24>>2]=O;g[j+(N*48|0)+28>>2]=ea(0.0);N=c[k>>2]|0;c[k>>2]=N+1;O=ea(g[h>>2]);Q=ea(g[w>>2]);R=ea(g[x>>2]);g[j+(N*48|0)+32>>2]=O;g[j+(N*48|0)+36>>2]=Q;g[j+(N*48|0)+40>>2]=R;g[j+(N*48|0)+44>>2]=P;T=ea(g[b>>2])}else T=G}else T=G;while(0);b:do if(!(T>z|y>T)?!(B<F|A>F):0){G=ea(g[e+52>>2]);C=0;U=0;N=3;while(1){M=G;G=ea(g[e+(C<<4)+4>>2]);if(M>F^G>F?(P=ea(g[e+(N<<4)>>2]),R=ea(G-M),Q=ea(T*R),O=ea(ea(R*P)+ea(ea(F-M)*ea(ea(g[e+(C<<4)>>2])-P))),L=!(R>ea(0.0)),(L?Q:O)>=(L?O:Q)):0){if((U|0)==1)break b;W=U+1|0}else W=U;L=C+1|0;if(L>>>0>=4)break;else{D=C;C=L;U=W;N=D}}if((W|0)!=0?(G=ea(g[f>>2]),Q=ea(g[f+4>>2]),O=ea(g[I>>2]),R=ea(g[e>>2]),P=ea(g[e+4>>2]),M=ea(ea(ea(O*ea(g[e+8>>2]))+ea(ea(G*ea(R-T))+ea(Q*ea(v+P))))/E),P=ea(-M),ea(g[l>>2])>P):0){N=c[k>>2]|0;g[j+(N*48|0)>>2]=T;g[j+(N*48|0)+4>>2]=F;g[j+(N*48|0)+8>>2]=ea(0.0);g[j+(N*48|0)+12>>2]=ea(0.0);N=c[k>>2]|0;g[j+(N*48|0)+16>>2]=T;g[j+(N*48|0)+20>>2]=F;g[j+(N*48|0)+24>>2]=M;g[j+(N*48|0)+28>>2]=ea(0.0);N=c[k>>2]|0;c[k>>2]=N+1;M=ea(g[h>>2]);Q=ea(g[w>>2]);R=ea(g[x>>2]);g[j+(N*48|0)+32>>2]=M;g[j+(N*48|0)+36>>2]=Q;g[j+(N*48|0)+40>>2]=R;g[j+(N*48|0)+44>>2]=P}}while(0);T=ea(g[d>>2]);c:do if(!(z<H|y>H)){d:do if(!(T>B|A>T)){P=ea(g[e+52>>2]);W=0;N=0;U=3;while(1){R=P;P=ea(g[e+(W<<4)+4>>2]);if(R>T^P>T?(Q=ea(g[e+(U<<4)>>2]),M=ea(P-R),G=ea(M*H),O=ea(ea(M*Q)+ea(ea(T-R)*ea(ea(g[e+(W<<4)>>2])-Q))),C=!(M>ea(0.0)),(C?G:O)>=(C?O:G)):0){if((N|0)==1)break d;X=N+1|0}else X=N;C=W+1|0;if(C>>>0>=4)break;else{D=W;W=C;N=X;U=D}}if((X|0)!=0?(P=ea(g[f>>2]),G=ea(g[f+4>>2]),O=ea(g[I>>2]),M=ea(g[e>>2]),Q=ea(g[e+4>>2]),R=ea(ea(ea(O*ea(g[e+8>>2]))+ea(ea(P*ea(u+M))+ea(G*ea(Q-T))))/E),Q=ea(-R),ea(g[l>>2])>Q):0){U=c[k>>2]|0;g[j+(U*48|0)>>2]=H;g[j+(U*48|0)+4>>2]=T;g[j+(U*48|0)+8>>2]=ea(0.0);g[j+(U*48|0)+12>>2]=ea(0.0);U=c[k>>2]|0;g[j+(U*48|0)+16>>2]=H;g[j+(U*48|0)+20>>2]=T;g[j+(U*48|0)+24>>2]=R;g[j+(U*48|0)+28>>2]=ea(0.0);U=c[k>>2]|0;c[k>>2]=U+1;R=ea(g[h>>2]);G=ea(g[w>>2]);M=ea(g[x>>2]);g[j+(U*48|0)+32>>2]=R;g[j+(U*48|0)+36>>2]=G;g[j+(U*48|0)+40>>2]=M;g[j+(U*48|0)+44>>2]=Q}}while(0);if(!(B<F|A>F)){Q=ea(g[e+52>>2]);U=0;N=0;W=3;while(1){M=Q;Q=ea(g[e+(U<<4)+4>>2]);if(M>F^Q>F?(G=ea(g[e+(W<<4)>>2]),R=ea(Q-M),P=ea(R*H),O=ea(ea(R*G)+ea(ea(F-M)*ea(ea(g[e+(U<<4)>>2])-G))),D=!(R>ea(0.0)),(D?P:O)>=(D?O:P)):0){if((N|0)==1)break c;Y=N+1|0}else Y=N;D=U+1|0;if(D>>>0>=4)break;else{C=U;U=D;N=Y;W=C}}if((Y|0)!=0?(Q=ea(g[f>>2]),P=ea(g[f+4>>2]),O=ea(g[I>>2]),R=ea(g[e>>2]),G=ea(g[e+4>>2]),M=ea(ea(ea(O*ea(g[e+8>>2]))+ea(ea(Q*ea(u+R))+ea(P*ea(v+G))))/E),G=ea(-M),ea(g[l>>2])>G):0){W=c[k>>2]|0;g[j+(W*48|0)>>2]=H;g[j+(W*48|0)+4>>2]=F;g[j+(W*48|0)+8>>2]=ea(0.0);g[j+(W*48|0)+12>>2]=ea(0.0);W=c[k>>2]|0;g[j+(W*48|0)+16>>2]=H;g[j+(W*48|0)+20>>2]=F;g[j+(W*48|0)+24>>2]=M;g[j+(W*48|0)+28>>2]=ea(0.0);W=c[k>>2]|0;c[k>>2]=W+1;M=ea(g[h>>2]);P=ea(g[w>>2]);R=ea(g[x>>2]);g[j+(W*48|0)+32>>2]=M;g[j+(W*48|0)+36>>2]=P;g[j+(W*48|0)+40>>2]=R;g[j+(W*48|0)+44>>2]=G}}}while(0);E=ea(g[b>>2]);v=ea(g[d>>2]);d=n+4|0;b=n+8|0;l=n+12|0;I=q+4|0;f=q+8|0;Y=q+12|0;X=p+4|0;W=p+8|0;N=p+12|0;U=3;C=0;while(1){u=ea(g[e+(C<<4)>>2]);A=ea(g[e+(C<<4)+4>>2]);B=ea(g[e+(C<<4)+8>>2]);T=ea(g[e+(U<<4)>>2]);y=ea(g[e+(U<<4)+4>>2]);z=ea(g[e+(U<<4)+8>>2]);D=s+C|0;L=a[s+U>>0]|0;do if(!(a[D>>0]|0)){if(L<<24>>24)if(!(a[D>>0]|0)){Z=(a[t+U>>0]|0)!=0;_=0;$=60;break}else{aa=(a[t+C>>0]|0)!=0;$=59;break}}else{V=(a[t+C>>0]|0)!=0;if(!(L<<24>>24)){Z=0;_=V;$=60}else{aa=V;$=59}}while(0);if(($|0)==59?($=0,L=(a[t+U>>0]|0)!=0,!(aa&L)):0){Z=L;_=aa;$=60}if((($|0)==60?($=0,G=ea(T-u),R=ea(y-A),P=ea(z-B),M=ea(-G),Q=ea(-R),O=ea(-P),c[r+0>>2]=0,c[r+4>>2]=0,c[r+8>>2]=0,c[r+12>>2]=0,L=!((G>M?G:M)<ea(9.99999997e-07)),D=!((R>Q?R:Q)<ea(9.99999997e-07)),V=!((P>O?P:O)<ea(9.99999997e-07)),(L|!(u>E)&!(u<H))&(D|!(A>v)&!(A<F))&(V|!(B>ea(3402823469999999843913219.0e14))&!(B<ea(0.0)))):0)?(O=ea(ea(1.0)/G),Q=ea(ea(1.0)/R),M=ea(ea(1.0)/P),c[o+0>>2]=c[r+0>>2],c[o+4>>2]=c[r+4>>2],c[o+8>>2]=c[r+8>>2],c[o+12>>2]=c[r+12>>2],J=ea(ea(F-A)*Q),K=ea(ea(ea(0.0)-B)*M),g[n>>2]=ea(ea(H-u)*O),g[d>>2]=J,g[b>>2]=K,g[l>>2]=ea(0.0),K=ea(g[(L?n:o)>>2]),J=ea(g[(D?n:o)+4>>2]),ba=ea(g[(V?n:o)+8>>2]),ca=ea(ea(E-u)*O),O=ea(ea(v-A)*Q),Q=ea(ea(ea(3402823469999999843913219.0e14)-B)*M),g[q>>2]=ea(3402823469999999843913219.0e14),g[I>>2]=ea(3402823469999999843913219.0e14),g[f>>2]=ea(3402823469999999843913219.0e14),g[Y>>2]=ea(0.0),g[p>>2]=ca,g[X>>2]=O,g[W>>2]=Q,g[N>>2]=ea(0.0),Q=ea(g[(L?p:q)>>2]),O=ea(g[(D?p:q)+4>>2]),ca=ea(g[(V?p:q)+8>>2]),M=K<Q?K:Q,da=J<O?J:O,fa=ba<ca?ba:ca,ga=K>Q?K:Q,Q=J>O?J:O,O=ba>ca?ba:ca,ca=!(M>=da)?da:M,M=!(ca>=fa)?fa:ca,ca=!(ga<=Q)?Q:ga,ga=!(ca<=O)?O:ca,V=M>ea(0.0),ca=V?M:ea(0.0),V=ga<ea(1.0),M=V?ga:ea(1.0),!(ca>ea(1.0))&!(ca>M)):0){if(!_){ga=ea(u+ea(G*ca));O=ea(A+ea(R*ca));Q=ea(B+ea(P*ca));V=c[k>>2]|0;g[j+(V*48|0)>>2]=ga;g[j+(V*48|0)+4>>2]=O;g[j+(V*48|0)+8>>2]=ea(0.0);g[j+(V*48|0)+12>>2]=ea(0.0);V=c[k>>2]|0;g[j+(V*48|0)+16>>2]=ga;g[j+(V*48|0)+20>>2]=O;g[j+(V*48|0)+24>>2]=Q;g[j+(V*48|0)+28>>2]=ea(0.0);V=c[k>>2]|0;c[k>>2]=V+1;O=ea(g[h>>2]);ga=ea(g[w>>2]);ca=ea(g[x>>2]);fa=ea(-Q);g[j+(V*48|0)+32>>2]=O;g[j+(V*48|0)+36>>2]=ga;g[j+(V*48|0)+40>>2]=ca;g[j+(V*48|0)+44>>2]=fa}if(!Z){fa=ea(u+ea(G*M));G=ea(A+ea(R*M));R=ea(B+ea(P*M));V=c[k>>2]|0;g[j+(V*48|0)>>2]=fa;g[j+(V*48|0)+4>>2]=G;g[j+(V*48|0)+8>>2]=ea(0.0);g[j+(V*48|0)+12>>2]=ea(0.0);V=c[k>>2]|0;g[j+(V*48|0)+16>>2]=fa;g[j+(V*48|0)+20>>2]=G;g[j+(V*48|0)+24>>2]=R;g[j+(V*48|0)+28>>2]=ea(0.0);V=c[k>>2]|0;c[k>>2]=V+1;G=ea(g[h>>2]);fa=ea(g[w>>2]);M=ea(g[x>>2]);P=ea(-R);g[j+(V*48|0)+32>>2]=G;g[j+(V*48|0)+36>>2]=fa;g[j+(V*48|0)+40>>2]=M;g[j+(V*48|0)+44>>2]=P}}V=C+1|0;if((V|0)==4)break;else{D=C;C=V;U=D}}i=m;return}function X7a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;f=i;h=c[d+44>>2]|0;j=ea(g[h+32>>2]);k=ea(g[h+36>>2]);l=ea(g[h+40>>2]);m=a[d+32>>0]|0;if((m&255)>1){d=m&255;n=j;o=k;p=l;m=1;while(1){q=ea(g[h+(m*48|0)+32>>2]);r=ea(g[h+(m*48|0)+36>>2]);s=ea(n+q);q=ea(o+r);r=ea(p+ea(g[h+(m*48|0)+40>>2]));m=m+1|0;if(m>>>0>=d>>>0){t=r;u=q;v=s;break}else{n=s;o=q;p=r}}}else{t=l;u=k;v=j}j=ea(g[e>>2]);k=ea(g[e+4>>2]);l=ea(g[e+8>>2]);p=ea(g[e+12>>2]);o=ea(ea(p*p)+ea(-.5));n=ea(ea(ea(v*j)+ea(u*k))+ea(t*l));r=ea(ea(ea(j*n)+ea(ea(p*ea(ea(t*k)-ea(u*l)))+ea(v*o)))*ea(2.0));q=ea(ea(ea(k*n)+ea(ea(p*ea(ea(v*l)-ea(t*j)))+ea(u*o)))*ea(2.0));s=ea(ea(ea(l*n)+ea(ea(p*ea(ea(u*j)-ea(v*k)))+ea(t*o)))*ea(2.0));o=ea(ea(1.0)/ea(T(ea(ea(s*s)+ea(ea(r*r)+ea(q*q))))));t=ea(o*q);q=ea(o*s);g[b>>2]=ea(o*r);g[b+4>>2]=t;g[b+8>>2]=q;g[b+12>>2]=ea(0.0);i=f;return}function Y7a(b,d,e,f,h,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;r=i;i=i+560|0;s=r+488|0;t=r+128|0;u=r+416|0;v=r+80|0;w=r+16|0;x=r+352|0;y=r;FSa(t,b);GSa(t,s);c[s+32>>2]=544264;HSa(e,p,u);g[v>>2]=ea(1.0);t=v+4|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[v+20>>2]=ea(1.0);t=v+24|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[v+40>>2]=ea(1.0);g[v+44>>2]=ea(0.0);c[w+32>>2]=f;c[w+36>>2]=v;c[w+40>>2]=v;a[w+44>>0]=1;c[w>>2]=537520;c[w+48>>2]=d;c[x+32>>2]=h;c[x+36>>2]=e+96;c[x+40>>2]=e+144;a[x+44>>0]=p&1;if(p){c[x>>2]=537488;c[x+48>>2]=e}else{c[x>>2]=537456;c[x+48>>2]=e}e=c[k>>2]|0;if(!(tSa(s,u,w,x,j,k,o,n,q)|0)){z=0;i=r;return z|0}q=c[k>>2]|0;if((q|0)!=(e|0)&(e|0)!=0){e=q+-1|0;c[k>>2]=e;A=j+48|0;B=e}else{A=j;B=q}RSa(m,A,B);X7a(y,m,h);OSa(m,l,y,h);z=1;i=r;return z|0}function Z7a(b,d,e,f,h,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;r=i;i=i+416|0;s=r+336|0;t=r+112|0;u=r+64|0;v=r;FSa(t,e);GSa(t,s);g[u>>2]=ea(1.0);t=u+4|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[u+20>>2]=ea(1.0);t=u+24|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[u+40>>2]=ea(1.0);g[u+44>>2]=ea(0.0);c[v+32>>2]=j;c[v+36>>2]=u;c[v+40>>2]=u;a[v+44>>0]=1;c[v>>2]=537520;c[v+48>>2]=d;d=c[l>>2]|0;if(!(xSa(b,s,v,f,k,l,p,o,q)|0)){w=0;i=r;return w|0}q=c[l>>2]|0;if(d)if((q|0)==(d|0)){x=k;y=d}else{d=q+-1|0;c[l>>2]=d;x=k+48|0;y=d}else{x=k;y=q}YSa(n,x,y);z=ea(g[j>>2]);A=ea(g[j+4>>2]);B=ea(g[j+8>>2]);C=ea(g[j+12>>2]);D=ea(g[o>>2]);j=o+4|0;E=ea(g[j>>2]);y=o+8|0;F=ea(g[y>>2]);G=ea(ea(C*C)+ea(-.5));H=ea(ea(ea(z*D)+ea(A*E))+ea(B*F));I=ea(ea(ea(A*H)+ea(ea(G*E)+ea(C*ea(ea(B*D)-ea(z*F)))))*ea(2.0));J=ea(ea(ea(ea(G*F)+ea(C*ea(ea(z*E)-ea(A*D))))+ea(B*H))*ea(2.0));g[o>>2]=ea(ea(ea(z*H)+ea(ea(D*G)+ea(C*ea(ea(A*F)-ea(B*E)))))*ea(2.0));g[j>>2]=I;g[y>>2]=J;g[o+12>>2]=ea(0.0);QSa(n,m,o,h,b+128|0);w=1;i=r;return w|0}function _7a(b,d,e,f,h,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;r=i;i=i+144|0;s=r+64|0;t=r;HSa(d,m,s);c[t+32>>2]=h;c[t+36>>2]=d+96;c[t+40>>2]=d+144;a[t+44>>0]=m&1;if(m){c[t>>2]=537488;c[t+48>>2]=d}else{c[t>>2]=537456;c[t+48>>2]=d}d=c[k>>2]|0;if(!(ySa(b,s,t,e,j,k,p,o,q)|0)){u=0;i=r;return u|0}q=c[k>>2]|0;if((q|0)!=(d|0)&(d|0)!=0){d=q+-1|0;c[k>>2]=d;v=j+48|0;w=d}else{v=j;w=q}YSa(n,v,w);x=ea(g[h>>2]);y=ea(g[h+4>>2]);z=ea(g[h+8>>2]);A=ea(g[h+12>>2]);B=ea(g[o>>2]);h=o+4|0;C=ea(g[h>>2]);w=o+8|0;D=ea(g[w>>2]);E=ea(ea(A*A)+ea(-.5));F=ea(ea(ea(x*B)+ea(y*C))+ea(z*D));G=ea(ea(ea(y*F)+ea(ea(E*C)+ea(A*ea(ea(z*B)-ea(x*D)))))*ea(2.0));H=ea(ea(ea(ea(E*D)+ea(A*ea(ea(x*C)-ea(y*B))))+ea(z*F))*ea(2.0));g[o>>2]=ea(ea(ea(x*F)+ea(ea(B*E)+ea(A*ea(ea(y*D)-ea(z*C)))))*ea(2.0));g[h>>2]=G;g[w>>2]=H;g[o+12>>2]=ea(0.0);QSa(n,l,o,f,b+128|0);u=1;i=r;return u|0}function $7a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;k=i;i=i+80|0;l=k;m=k+56|0;n=k+16|0;o=k+44|0;p=k+32|0;q=a+2048|0;r=a;do{c[r+16>>2]=0;c[r+20>>2]=0;c[r+24>>2]=r;g[r+32>>2]=ea(3402823469999999843913219.0e14);s=r+36|0;c[s+0>>2]=c[l+0>>2];c[s+4>>2]=c[l+4>>2];c[s+8>>2]=c[l+8>>2];r=r+64|0}while((r|0)!=(q|0));q=a+2176|0;c[q+0>>2]=c[b+0>>2];c[q+4>>2]=c[b+4>>2];c[q+8>>2]=c[b+8>>2];c[q+12>>2]=c[b+12>>2];b=a+2192|0;c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[a+2208>>2]=e;c[a+2212>>2]=f;c[a+2216>>2]=h;c[a+2220>>2]=j;h=a+2304|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;l=a+2256|0;g[l>>2]=ea(1.0);h=a+2260|0;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];m=a+2276|0;g[m>>2]=ea(1.0);b=a+2280|0;c[b+0>>2]=c[n+0>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];c[b+12>>2]=c[n+12>>2];n=a+2296|0;g[n>>2]=ea(1.0);q=a+2300|0;g[q>>2]=ea(0.0);c[a+2328>>2]=0;c[a+2324>>2]=0;c[a+2332>>2]=0;t=ea(g[e>>2]);u=ea(g[e+4>>2]);v=ea(g[e+8>>2]);w=ea(g[e+12>>2]);x=ea(-t);t=ea(-u);u=ea(-v);v=ea(g[f+16>>2]);y=ea(g[f+20>>2]);z=ea(g[f+24>>2]);A=ea(g[e+16>>2]);B=ea(g[e+20>>2]);C=ea(v-A);A=ea(y-B);B=ea(z-ea(g[e+24>>2]));z=ea(ea(w*w)+ea(-.5));y=ea(ea(ea(C*x)+ea(A*t))+ea(B*u));v=ea(ea(ea(y*x)+ea(ea(z*C)+ea(w*ea(ea(B*t)-ea(A*u)))))*ea(2.0));D=ea(ea(ea(y*t)+ea(ea(z*A)+ea(w*ea(ea(C*u)-ea(B*x)))))*ea(2.0));E=ea(ea(ea(ea(z*B)+ea(w*ea(ea(A*x)-ea(C*t))))+ea(y*u))*ea(2.0));y=ea(g[f>>2]);C=ea(g[f+4>>2]);A=ea(g[f+8>>2]);B=ea(g[f+12>>2]);z=ea(ea(w*B)-ea(ea(ea(y*x)+ea(C*t))+ea(A*u)));F=ea(ea(ea(A*t)-ea(C*u))+ea(ea(w*y)+ea(B*x)));G=ea(ea(ea(y*u)-ea(A*x))+ea(ea(w*C)+ea(B*t)));H=ea(ea(ea(C*x)-ea(y*t))+ea(ea(w*A)+ea(B*u)));u=ea(F+F);B=ea(G+G);A=ea(H+H);w=ea(G*B);t=ea(H*A);y=ea(G*u);G=ea(H*u);x=ea(z*u);C=ea(H*B);H=ea(z*B);B=ea(z*A);A=ea(ea(1.0)-ea(F*u));u=ea(y+B);F=ea(G-H);z=ea(y-B);B=ea(A-t);y=ea(C+x);I=ea(G+H);H=ea(C-x);x=ea(A-w);g[l>>2]=ea(ea(ea(1.0)-w)-t);g[h>>2]=u;g[a+2264>>2]=F;g[a+2268>>2]=ea(0.0);g[a+2272>>2]=z;g[m>>2]=B;g[b>>2]=y;g[a+2284>>2]=ea(0.0);g[a+2288>>2]=I;g[a+2292>>2]=H;g[n>>2]=x;g[q>>2]=ea(0.0);g[a+2304>>2]=v;g[a+2308>>2]=D;g[a+2312>>2]=E;g[a+2316>>2]=ea(0.0);q=0;do{c[a+(q<<2)+2048>>2]=a+(q<<6);q=q+1|0}while((q|0)!=32);c[a+2320>>2]=j;E=ea(g[d>>2]);g[a+2240>>2]=ea(E*E);d=a+2244|0;c[d+0>>2]=c[o+0>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];g[a+2224>>2]=ea(.995999991);o=a+2228|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];i=k;return}function a8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=0,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;f=a+2324|0;if(!(c[f>>2]|0)){i=e;return}h=a+2328|0;j=c[h>>2]|0;if(j>>>0>1){k=j;l=1;while(1){m=a+(l+-1<<2)+2048|0;n=c[m>>2]|0;o=ea(g[n+32>>2]);p=a+(l<<2)+2048|0;q=c[p>>2]|0;r=q+32|0;if(o>ea(g[r>>2])){c[m>>2]=q;c[p>>2]=n;n=l+-2|0;a:do if((n|0)>-1){p=n;while(1){o=ea(g[r>>2]);m=a+(p<<2)+2048|0;s=c[m>>2]|0;if(o>=ea(g[s+32>>2]))break a;c[a+(p+1<<2)+2048>>2]=s;c[m>>2]=q;if((p|0)>0)p=p+-1|0;else break}}while(0);t=c[h>>2]|0}else t=k;l=l+1|0;if(l>>>0>=t>>>0){u=t;break}else k=t}}else u=j;j=a+2216|0;t=a+2048|0;k=a+2320|0;l=a+2224|0;if(u){q=0;do{r=c[a+(q<<2)+2048>>2]|0;n=r+24|0;c[n>>2]=r;c[r+20>>2]=r;p=(c[r+52>>2]|0)-(c[r+48>>2]|0)|0;c[r+56>>2]=p;c[r+16>>2]=0;m=r+4|0;s=r+8|0;v=q;while(1){if(!v)break;v=v+-1|0;w=c[a+(v<<2)+2048>>2]|0;o=ea(g[r>>2]);x=ea(g[m>>2]);y=ea(g[s>>2]);z=w+24|0;A=c[z>>2]|0;B=ea(g[A>>2]);C=ea(g[A+4>>2]);D=ea(ea(ea(o*B)+ea(x*C))+ea(y*ea(g[A+8>>2])));if(D>=ea(g[l>>2])){E=15;break}}if((E|0)==15){E=0;c[w+16>>2]=r;c[A+20>>2]=r;c[n>>2]=c[z>>2];s=(c[z>>2]|0)+56|0;c[s>>2]=(c[s>>2]|0)+p}q=q+1|0}while((q|0)!=(u|0));u=c[h>>2]|0;q=c[k>>2]|0;z=a+2240|0;if(!u){F=q;G=0;H=z}else{A=0;while(1){w=c[a+(A<<2)+2048>>2]|0;b:do if((w|0)!=0?(c[w+24>>2]|0)==(w|0):0){E=w;c:while(1){s=c[E+16>>2]|0;if(!s)break b;m=c[E+48>>2]|0;v=E+52|0;I=c[v>>2]|0;if(m>>>0>=I>>>0){E=s;continue}J=s+48|0;K=s+52|0;L=c[K>>2]|0;M=I;I=m;while(1){m=c[J>>2]|0;if(m>>>0<L>>>0){N=q+(I<<6)+16|0;O=q+(I<<6)+20|0;P=q+(I<<6)+24|0;Q=L;R=m;while(1){D=ea(g[q+(R<<6)+16>>2]);y=ea(g[q+(R<<6)+20>>2]);C=ea(g[q+(R<<6)+24>>2]);x=ea(g[N>>2]);B=ea(g[O>>2]);o=ea(D-x);x=ea(y-B);B=ea(C-ea(g[P>>2]));C=ea(ea(ea(o*o)+ea(x*x))+ea(B*B));if(ea(g[z>>2])>C){m=q+(R<<6)+0|0;S=q+(Q+-1<<6)+0|0;T=m+52|0;do{c[m>>2]=c[S>>2];m=m+4|0;S=S+4|0}while((m|0)<(T|0));S=(c[K>>2]|0)+-1|0;c[K>>2]=S;U=S;V=R+-1|0}else{U=Q;V=R}R=V+1|0;if(R>>>0>=U>>>0)break;else Q=U}W=c[v>>2]|0;X=U}else{W=M;X=L}Q=I+1|0;if(Q>>>0<W>>>0){L=X;M=W;I=Q}else{E=s;continue c}}}}while(0);A=A+1|0;if((A|0)==(u|0))break}F=c[k>>2]|0;G=c[h>>2]|0;H=z}}else{F=c[k>>2]|0;G=0;H=a+2240|0}bTa(c[j>>2]|0,F,c[f>>2]|0,t,G,H,l,b);c[f>>2]=0;c[h>>2]=0;if(d)Y=0;else{i=e;return}do{c[a+(Y<<2)+2048>>2]=a+(Y<<6);Y=Y+1|0}while((Y|0)!=32);i=e;return}function b8a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;h=f;j=a+2328|0;k=c[j>>2]|0;if((k|0)!=0?(l=k+-1|0,m=ea(g[a+(l<<6)>>2]),n=ea(g[a+(l<<6)+4>>2]),o=ea(g[a+(l<<6)+8>>2]),p=ea(g[b>>2]),q=ea(g[b+4>>2]),r=ea(ea(ea(m*p)+ea(n*q))+ea(o*ea(g[b+8>>2]))),r>ea(g[a+2224>>2])):0){s=c[a+(l<<6)+48>>2]|0;t=a+(l<<6)+52|0;u=c[t>>2]|0;v=a+2324|0;if(s>>>0<u>>>0){w=a+2320|0;x=a+2240|0;y=c[v>>2]|0;z=u;u=s;while(1){if(y>>>0>e>>>0){s=y;A=e;while(1){B=c[w>>2]|0;r=ea(g[B+(A<<6)+16>>2]);o=ea(g[B+(A<<6)+20>>2]);q=ea(g[B+(A<<6)+24>>2]);n=ea(g[B+(u<<6)+16>>2]);p=ea(g[B+(u<<6)+20>>2]);m=ea(r-n);n=ea(o-p);p=ea(q-ea(g[B+(u<<6)+24>>2]));q=ea(ea(ea(m*m)+ea(n*n))+ea(p*p));if(ea(g[x>>2])>q){q=ea(g[B+(u<<6)+44>>2]);if(q>ea(g[B+(A<<6)+44>>2])){C=B+(u<<6)+0|0;D=B+(A<<6)+0|0;E=C+52|0;do{c[C>>2]=c[D>>2];C=C+4|0;D=D+4|0}while((C|0)<(E|0));F=c[w>>2]|0;G=c[v>>2]|0}else{F=B;G=s}C=F+(A<<6)+0|0;D=F+(G+-1<<6)+0|0;E=C+52|0;do{c[C>>2]=c[D>>2];C=C+4|0;D=D+4|0}while((C|0)<(E|0));B=(c[v>>2]|0)+-1|0;c[v>>2]=B;H=B;I=A+-1|0}else{H=s;I=A}A=I+1|0;if(A>>>0>=H>>>0)break;else s=H}J=c[t>>2]|0;K=H}else{J=z;K=y}u=u+1|0;if(u>>>0>=J>>>0){L=K;break}else{y=K;z=J}}}else L=c[v>>2]|0;c[t>>2]=L;L=a+(l<<6)+32|0;q=ea(g[L>>2]);t=a+(l<<6)+36|0;p=ea(g[d>>2]);g[L>>2]=q>p?p:q;c[t+0>>2]=c[h+0>>2];c[t+4>>2]=c[h+4>>2];c[t+8>>2]=c[h+8>>2];i=f;return}c[a+(k<<6)+48>>2]=e;c[a+(k<<6)+52>>2]=c[a+2324>>2];e=a+(k<<6)+32|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[j>>2]=k+1;j=a+(k<<6)|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];i=f;return}function c8a(a,b,c,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im;p=i;i=i+32|0;q=p+16|0;r=p;s=ea(g[c>>2]);t=ea(g[c+4>>2]);u=ea(g[c+8>>2]);v=ea(g[b>>2]);w=ea(g[b+4>>2]);x=ea(g[b+8>>2]);y=ea(g[e>>2]);z=ea(g[e+4>>2]);A=ea(g[e+8>>2]);B=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);E=ea(g[k>>2]);F=ea(g[k+4>>2]);G=ea(g[k+8>>2]);H=ea(g[m>>2]);I=ea(g[m+4>>2]);J=ea(g[m+8>>2]);K=ea(g[d>>2]);L=ea(g[d+4>>2]);M=ea(g[d+8>>2]);N=ea(g[f>>2]);O=ea(g[f+4>>2]);P=ea(g[f+8>>2]);Q=ea(g[j>>2]);R=ea(g[j+4>>2]);S=ea(g[j+8>>2]);T=ea(g[l>>2]);U=ea(g[l+4>>2]);V=ea(g[l+8>>2]);W=ea(v-K);X=ea(v-N);Y=ea(v-Q);Z=ea(v-T);_=ea(w-L);$=ea(w-O);aa=ea(w-R);ba=ea(w-U);ca=ea(x-M);da=ea(x-P);fa=ea(x-S);ga=ea(x-V);ha=ea(ea(ea(s*s)+ea(t*t))+ea(u*u));ia=ea(ea(A*A)+ea(ea(y*y)+ea(z*z)));ja=ea(ea(D*D)+ea(ea(B*B)+ea(C*C)));ka=ea(ea(G*G)+ea(ea(E*E)+ea(F*F)));la=ea(ea(J*J)+ea(ea(H*H)+ea(I*I)));ma=ea(ea(u*A)+ea(ea(s*y)+ea(t*z)));na=ea(ea(u*D)+ea(ea(s*B)+ea(t*C)));oa=ea(ea(u*G)+ea(ea(s*E)+ea(t*F)));pa=ea(ea(u*J)+ea(ea(s*H)+ea(t*I)));qa=ea(ea(u*ca)+ea(ea(s*W)+ea(t*_)));ra=ea(ea(u*da)+ea(ea(s*X)+ea(t*$)));sa=ea(ea(u*fa)+ea(ea(s*Y)+ea(t*aa)));ta=ea(ea(u*ga)+ea(ea(s*Z)+ea(t*ba)));ua=ea(ea(A*ca)+ea(ea(y*W)+ea(z*_)));_=ea(ea(D*da)+ea(ea(B*X)+ea(C*$)));$=ea(ea(G*fa)+ea(ea(E*Y)+ea(F*aa)));aa=ea(ea(J*ga)+ea(ea(H*Z)+ea(I*ba)));ba=ea(ea(1.0)/ha);Z=ea(ea(1.0)/ia);ga=ea(ea(1.0)/ja);Y=ea(ea(1.0)/ka);fa=ea(ea(1.0)/la);X=ea(ea(ia*ha)-ea(ma*ma));da=ea(ea(ja*ha)-ea(na*na));W=ea(ea(ka*ha)-ea(oa*oa));ca=ea(ea(la*ha)-ea(pa*pa));ha=ea(ea(ea(ma*ua)-ea(ia*qa))/X);ia=ea(ea(ea(na*_)-ea(ja*ra))/da);ja=ea(ea(ea(oa*$)-ea(ka*sa))/W);ka=ea(ea(ea(pa*aa)-ea(la*ta))/ca);l=ha<ea(1.0);la=l?ha:ea(1.0);l=ia<ea(1.0);ha=l?ia:ea(1.0);l=ja<ea(1.0);ia=l?ja:ea(1.0);l=ka<ea(1.0);ja=l?ka:ea(1.0);l=la>ea(0.0);ka=l?la:ea(0.0);l=ha>ea(0.0);la=l?ha:ea(0.0);l=ia>ea(0.0);ha=l?ia:ea(0.0);l=ja>ea(0.0);ia=l?ja:ea(0.0);l=X<=ea(1.1920929e-07);j=da<=ea(1.1920929e-07);f=W<=ea(1.1920929e-07);d=ca<=ea(1.1920929e-07);g[r>>2]=ea(.5);g[r+4>>2]=ea(.5);g[r+8>>2]=ea(.5);g[r+12>>2]=ea(.5);g[q>>2]=ka;g[q+4>>2]=la;g[q+8>>2]=ha;g[q+12>>2]=ia;ia=ea(g[(l?r:q)>>2]);ha=ea(g[(j?r:q)+4>>2]);la=ea(g[(f?r:q)+8>>2]);ka=ea(Z*ea(ua+ea(ma*ia)));ia=ea(ga*ea(_+ea(na*ha)));ha=ea(Y*ea($+ea(oa*la)));la=ea(fa*ea(aa+ea(pa*ea(g[(d?r:q)+12>>2]))));q=ka<ea(1.0);aa=q?ka:ea(1.0);q=ia<ea(1.0);ka=q?ia:ea(1.0);q=ha<ea(1.0);ia=q?ha:ea(1.0);q=la<ea(1.0);ha=q?la:ea(1.0);q=aa>ea(0.0);la=q?aa:ea(0.0);q=ka>ea(0.0);aa=q?ka:ea(0.0);q=ia>ea(0.0);ka=q?ia:ea(0.0);q=ha>ea(0.0);ia=q?ha:ea(0.0);ha=ea(ba*ea(ea(ma*la)-qa));qa=ea(ba*ea(ea(na*aa)-ra));ra=ea(ba*ea(ea(oa*ka)-sa));sa=ea(ba*ea(ea(pa*ia)-ta));q=ha<ea(1.0);ta=q?ha:ea(1.0);q=qa<ea(1.0);ha=q?qa:ea(1.0);q=ra<ea(1.0);qa=q?ra:ea(1.0);q=sa<ea(1.0);ra=q?sa:ea(1.0);q=ta>ea(0.0);sa=q?ta:ea(0.0);q=ha>ea(0.0);ta=q?ha:ea(0.0);q=qa>ea(0.0);ha=q?qa:ea(0.0);q=ra>ea(0.0);qa=q?ra:ea(0.0);g[n>>2]=sa;g[n+4>>2]=ta;g[n+8>>2]=ha;g[n+12>>2]=qa;g[o>>2]=la;g[o+4>>2]=aa;g[o+8>>2]=ka;g[o+12>>2]=ia;ra=ea(ea(v+ea(s*sa))-ea(K+ea(y*la)));y=ea(ea(v+ea(s*ta))-ea(N+ea(B*aa)));B=ea(ea(v+ea(s*ha))-ea(Q+ea(E*ka)));E=ea(ea(v+ea(s*qa))-ea(T+ea(H*ia)));H=ea(ea(w+ea(t*sa))-ea(L+ea(z*la)));z=ea(ea(w+ea(t*ta))-ea(O+ea(C*aa)));C=ea(ea(w+ea(t*ha))-ea(R+ea(F*ka)));F=ea(ea(w+ea(t*qa))-ea(U+ea(I*ia)));I=ea(ea(x+ea(u*sa))-ea(M+ea(A*la)));la=ea(ea(x+ea(u*ta))-ea(P+ea(D*aa)));aa=ea(ea(x+ea(u*ha))-ea(S+ea(G*ka)));ka=ea(ea(x+ea(u*qa))-ea(V+ea(J*ia)));ia=ea(ea(y*y)+ea(ea(z*z)+ea(la*la)));la=ea(ea(B*B)+ea(ea(C*C)+ea(aa*aa)));aa=ea(ea(E*E)+ea(ea(F*F)+ea(ka*ka)));g[a>>2]=ea(ea(ra*ra)+ea(ea(H*H)+ea(I*I)));g[a+4>>2]=ia;g[a+8>>2]=la;g[a+12>>2]=aa;i=p;return}function d8a(b,d,e,f,g,h,j,k,l,m,n,o,p){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;q=i;i=i+288|0;r=q+216|0;s=q+144|0;t=q+80|0;u=q+16|0;v=q;HSa(b,g,r);HSa(d,h,s);c[t+32>>2]=e;c[t+36>>2]=b+96;c[t+40>>2]=b+144;a[t+44>>0]=g&1;if(g){c[t>>2]=537488;c[t+48>>2]=b}else{c[t>>2]=537456;c[t+48>>2]=b}c[u+32>>2]=f;c[u+36>>2]=d+96;c[u+40>>2]=d+144;a[u+44>>0]=h&1;if(h){c[u>>2]=537488;c[u+48>>2]=d}else{c[u>>2]=537456;c[u+48>>2]=d}d=c[k>>2]|0;if(!(tSa(r,s,t,u,j,k,o,n,p)|0)){w=0;i=q;return w|0}p=c[k>>2]|0;if((p|0)!=(d|0)&(d|0)!=0){d=p+-1|0;c[k>>2]=d;x=j+48|0;y=d}else{x=j;y=p}RSa(m,x,y);X7a(v,m,f);OSa(m,l,v,f);w=1;i=q;return w|0}function e8a(a,b,e,f,h,j,k,l,m,n,o,p){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=0;q=i;i=i+128|0;r=q+64|0;s=q+32|0;t=q+116|0;u=q;v=q+48|0;w=q+16|0;x=q+104|0;y=q+92|0;z=q+80|0;A=ea(g[n>>2]);B=n+4|0;C=ea(g[B>>2]);D=n+8|0;E=ea(g[D>>2]);F=n+12|0;G=ea(g[F>>2]);H=ea(g[j+48>>2]);I=ea(g[j+52>>2]);J=ea(g[j+56>>2]);K=ea(g[b>>2]);L=ea(g[b+4>>2]);M=ea(g[b+8>>2]);N=ea(K*ea(g[j>>2]));O=ea(N+ea(L*ea(g[j+16>>2])));N=ea(O+ea(M*ea(g[j+32>>2])));O=ea(K*ea(g[j+4>>2]));P=ea(O+ea(L*ea(g[j+20>>2])));O=ea(P+ea(M*ea(g[j+36>>2])));P=ea(K*ea(g[j+8>>2]));K=ea(P+ea(L*ea(g[j+24>>2])));L=ea(H+N);N=ea(I+O);O=ea(J+ea(K+ea(M*ea(g[j+40>>2]))));M=ea(g[b+40>>2]);K=ea(g[b+44>>2]);P=ea(g[b+48>>2]);Q=ea(g[b+52>>2]);R=ea(-K);S=ea(-P);U=ea(-Q);b=a+16|0;a:do if(!(c[b>>2]|0)){V=ea(3402823469999999843913219.0e14);W=G;X=E;Y=C;Z=A;_=0}else{j=a+24|0;$=a+28|0;aa=e+40|0;ba=h+16|0;ca=h+32|0;da=h+4|0;fa=h+20|0;ga=h+36|0;ha=h+8|0;ia=h+24|0;ja=h+40|0;ka=w+4|0;la=w+8|0;ma=w+12|0;na=s+4|0;oa=s+8|0;pa=s+12|0;qa=r+4|0;ra=r+8|0;sa=r+12|0;ta=u+4|0;ua=v+4|0;va=ea(3402823469999999843913219.0e14);wa=A;xa=C;ya=E;za=G;Aa=0;Ba=0;while(1){Ca=c[j>>2]|0;Da=d[Ca+(Ba*20|0)+19>>0]|0;Ea=c[$>>2]|0;Fa=ea(g[Ea+(Da*12|0)>>2]);Ga=ea(g[Ea+(Da*12|0)+4>>2]);Ha=ea(g[Ea+(Da*12|0)+8>>2]);Ia=ea(g[Ca+(Ba*20|0)+12>>2]);Ja=ea(g[Ca+(Ba*20|0)>>2]);Ka=ea(g[Ca+(Ba*20|0)+4>>2]);La=ea(g[Ca+(Ba*20|0)+8>>2]);Ca=c[aa>>2]|0;Ma=ea(Ja*ea(g[Ca>>2]));Na=ea(Ma+ea(Ka*ea(g[Ca+4>>2])));Ma=ea(Na+ea(La*ea(g[Ca+8>>2])));Na=ea(Ja*ea(g[Ca+16>>2]));Oa=ea(Na+ea(Ka*ea(g[Ca+20>>2])));Na=ea(Oa+ea(La*ea(g[Ca+24>>2])));Oa=ea(Ja*ea(g[Ca+32>>2]));Pa=ea(Oa+ea(Ka*ea(g[Ca+36>>2])));Oa=ea(Pa+ea(La*ea(g[Ca+40>>2])));Pa=ea(ea(1.0)/ea(T(ea(ea(ea(Ma*Ma)+ea(Na*Na))+ea(Oa*Oa)))));Qa=ea(ea(ea(ea(Fa*Ja)+ea(Ga*Ka))+ea(Ha*La))*Pa);La=ea(Ia*Pa);Ia=ea(-La);Ha=ea(Ma*Pa);Ma=ea(Na*Pa);Na=ea(Pa*Oa);Oa=ea(Ha*ea(g[h>>2]));Pa=ea(Oa+ea(Ma*ea(g[ba>>2])));Oa=ea(Pa+ea(Na*ea(g[ca>>2])));Pa=ea(Ha*ea(g[da>>2]));Ka=ea(Pa+ea(Ma*ea(g[fa>>2])));Pa=ea(Ka+ea(Na*ea(g[ga>>2])));Ka=ea(Ha*ea(g[ha>>2]));Ga=ea(Ka+ea(Ma*ea(g[ia>>2])));Ka=ea(Ga+ea(Na*ea(g[ja>>2])));g[w>>2]=Oa;g[ka>>2]=Pa;g[la>>2]=Ka;g[ma>>2]=ea(0.0);Ca=Oa>ea(0.0);Da=Pa>ea(0.0);Ea=Ka>ea(0.0);g[s>>2]=K;g[na>>2]=P;g[oa>>2]=Q;g[pa>>2]=ea(0.0);g[r>>2]=R;g[qa>>2]=S;g[ra>>2]=U;g[sa>>2]=ea(0.0);Ga=ea(g[(Ca?s:r)>>2]);Ja=ea(g[(Da?s:r)+4>>2]);Fa=ea(ea(ea(Ga*Oa)+ea(Ja*Pa))+ea(ea(g[(Ea?s:r)+8>>2])*Ka));Ka=Fa>M?Fa:M;Fa=ea(ea(O*Na)+ea(ea(L*Ha)+ea(N*Ma)));Pa=ea(Fa-Ka);Ja=ea(Fa+Ka);if(!(ea((Ja<Ia?Ja:Ia)-(Qa>Pa?Qa:Pa))>va)){Pa=ea(ea(J*Na)+ea(ea(H*Ha)+ea(I*Ma)));Dn[c[(c[f>>2]|0)+12>>2]&511](f,w,u,v);Ja=ea(Pa+ea(g[u>>2]));g[u>>2]=Ja;c[ta+0>>2]=c[x+0>>2];c[ta+4>>2]=c[x+4>>2];c[ta+8>>2]=c[x+8>>2];Ka=ea(Pa+ea(g[v>>2]));g[v>>2]=Ka;c[ua+0>>2]=c[y+0>>2];c[ua+4>>2]=c[y+4>>2];c[ua+8>>2]=c[y+8>>2];Pa=ea(g[k>>2]);if(Ja>ea(Pa-La)|Qa>ea(Pa+Ka)){Ra=0;break}Ka=ea(Ia-Ja);if(va>Ka){c[t+0>>2]=c[z+0>>2];c[t+4>>2]=c[z+4>>2];c[t+8>>2]=c[z+8>>2];Sa=Ka;Ta=ea(0.0);Ua=Na;Va=Ma;Wa=Ha;Xa=Ba}else{Sa=va;Ta=za;Ua=ya;Va=xa;Wa=wa;Xa=Aa}}else{Sa=va;Ta=za;Ua=ya;Va=xa;Wa=wa;Xa=Aa}Ba=Ba+1|0;if(Ba>>>0>=(c[b>>2]|0)>>>0){V=Sa;W=Ta;X=Ua;Y=Va;Z=Wa;_=Xa;break a}else{va=Sa;wa=Wa;xa=Va;ya=Ua;za=Ta;Aa=Xa}}i=q;return Ra|0}while(0);if(ea(g[l>>2])>V){Xa=l+4|0;g[n>>2]=Z;g[B>>2]=Y;g[D>>2]=X;g[F>>2]=W;g[l>>2]=V;c[Xa+0>>2]=c[t+0>>2];c[Xa+4>>2]=c[t+4>>2];c[Xa+8>>2]=c[t+8>>2];c[p>>2]=o}c[m>>2]=_;Ra=1;i=q;return Ra|0}function f8a(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=Im,V=0,W=Im,X=0,Y=Im,Z=Im,_=0,$=Im,aa=0,ba=0,ca=0,da=Im,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=Im,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=Im,Va=Im,Wa=0,Xa=Im,Ya=Im,Za=0,_a=0,$a=0,ab=Im,bb=Im,cb=0,db=0,eb=Im;n=i;i=i+6464|0;o=n+240|0;p=n+176|0;q=n+96|0;r=n+80|0;s=n+292|0;t=n+160|0;u=n+192|0;v=n+224|0;w=n+32|0;x=n+16|0;y=n+112|0;z=n+48|0;A=n;B=n+64|0;C=n+144|0;D=n+304|0;E=n+3380|0;F=n+208|0;G=n+128|0;H=n+280|0;I=n+268|0;J=n+256|0;K=ea(g[k>>2]);L=k+4|0;c[s+0>>2]=c[L+0>>2];c[s+4>>2]=c[L+4>>2];c[s+8>>2]=c[L+8>>2];M=ea(g[a>>2]);N=ea(g[a+4>>2]);O=ea(g[a+8>>2]);P=ea(g[b>>2]);Q=ea(g[b+4>>2]);R=ea(g[b+8>>2]);S=h+48|0;U=ea(g[S>>2]);V=h+52|0;W=ea(g[V>>2]);X=h+56|0;Y=ea(g[X>>2]);Z=ea(P*ea(g[h>>2]));_=h+16|0;$=ea(Z+ea(Q*ea(g[_>>2])));aa=h+32|0;Z=ea($+ea(R*ea(g[aa>>2])));ba=h+4|0;$=ea(P*ea(g[ba>>2]));ca=h+20|0;da=ea($+ea(Q*ea(g[ca>>2])));fa=h+36|0;$=ea(da+ea(R*ea(g[fa>>2])));ga=h+8|0;da=ea(P*ea(g[ga>>2]));ha=h+24|0;P=ea(da+ea(Q*ea(g[ha>>2])));ia=h+40|0;Q=ea(ea(U+Z)-M);M=ea(ea(W+$)-N);N=ea(ea(Y+ea(P+ea(R*ea(g[ia>>2]))))-O);O=ea(g[b+40>>2]);R=ea(g[b+44>>2]);P=ea(g[b+48>>2]);$=ea(g[b+52>>2]);Z=ea(-R);da=ea(-P);ja=ea(-$);ka=ea(g[a+40>>2]);la=ea(g[a+44>>2]);ma=ea(g[a+48>>2]);na=ea(g[a+52>>2]);oa=ea(-la);pa=ea(-ma);qa=ea(-na);g[x>>2]=Q;ra=x+4|0;g[ra>>2]=M;sa=x+8|0;g[sa>>2]=N;g[x+12>>2]=ea(0.0);co[c[(c[d>>2]|0)+8>>2]&2047](y,d,x);ta=ea(g[x>>2]);ua=ea(g[ra>>2]);va=ea(-ta);ta=ea(-ua);ua=ea(-ea(g[sa>>2]));wa=ea(ea(g[f>>2])*va);sa=f+16|0;xa=ea(wa+ea(ea(g[sa>>2])*ta));ra=f+32|0;wa=ea(xa+ea(ea(g[ra>>2])*ua));ya=f+4|0;xa=ea(ea(g[ya>>2])*va);za=f+20|0;Aa=ea(xa+ea(ea(g[za>>2])*ta));Ba=f+36|0;xa=ea(Aa+ea(ea(g[Ba>>2])*ua));Ca=f+8|0;Aa=ea(ea(g[Ca>>2])*va);Da=f+24|0;va=ea(Aa+ea(ea(g[Da>>2])*ta));Ea=f+40|0;ta=ea(va+ea(ea(g[Ea>>2])*ua));g[z>>2]=wa;g[z+4>>2]=xa;g[z+8>>2]=ta;g[z+12>>2]=ea(0.0);co[c[(c[e>>2]|0)+8>>2]&2047](A,e,z);ta=ea(g[f+48>>2]);xa=ea(g[f+52>>2]);wa=ea(g[f+56>>2]);ua=ea(g[y>>2]);va=ea(g[y+4>>2]);Aa=ea(g[y+8>>2]);Fa=ea(ua*ea(g[f>>2]));Ga=ea(Fa+ea(va*ea(g[sa>>2])));Fa=ea(Ga+ea(Aa*ea(g[ra>>2])));Ga=ea(ua*ea(g[ya>>2]));Ha=ea(Ga+ea(va*ea(g[za>>2])));Ga=ea(Ha+ea(Aa*ea(g[Ba>>2])));Ha=ea(ua*ea(g[Ca>>2]));ua=ea(Ha+ea(va*ea(g[Da>>2])));va=ea(xa+Ga);Ga=ea(wa+ea(ua+ea(Aa*ea(g[Ea>>2]))));g[B>>2]=ea(ta+Fa);g[B+4>>2]=va;g[B+8>>2]=Ga;g[B+12>>2]=ea(0.0);Ga=ea(g[S>>2]);va=ea(g[V>>2]);Fa=ea(g[X>>2]);ta=ea(g[A>>2]);Aa=ea(g[A+4>>2]);ua=ea(g[A+8>>2]);wa=ea(ta*ea(g[h>>2]));xa=ea(wa+ea(Aa*ea(g[_>>2])));wa=ea(xa+ea(ua*ea(g[aa>>2])));xa=ea(ta*ea(g[ba>>2]));Ha=ea(xa+ea(Aa*ea(g[ca>>2])));xa=ea(Ha+ea(ua*ea(g[fa>>2])));Ha=ea(ta*ea(g[ga>>2]));ta=ea(Ha+ea(Aa*ea(g[ha>>2])));Aa=ea(va+xa);xa=ea(Fa+ea(ta+ea(ua*ea(g[ia>>2]))));g[C>>2]=ea(Ga+wa);g[C+4>>2]=Aa;g[C+8>>2]=xa;g[C+12>>2]=ea(0.0);c[D>>2]=0;c[E>>2]=0;rSa(a,d,D,C,x);rSa(b,e,E,B,z);z=c[D>>2]|0;B=c[E>>2]|0;a:do if(z){b=F+4|0;x=F+8|0;C=F+12|0;a=G+4|0;A=G+8|0;X=G+12|0;V=p+4|0;S=p+8|0;y=p+12|0;Ia=o+4|0;Ja=o+8|0;Ka=o+12|0;La=r+4|0;Ma=r+8|0;Na=r+12|0;Oa=q+4|0;Pa=q+8|0;Qa=q+12|0;Ra=v+4|0;Sa=w+4|0;if(!B){Ta=0;while(1){Ta=Ta+1|0;if(Ta>>>0>=z>>>0){Ua=K;break a}}}else{Va=K;Wa=0}b:while(1){xa=ea(g[D+(Wa*12|0)+4>>2]);Aa=ea(g[D+(Wa*12|0)+8>>2]);wa=ea(g[D+(Wa*12|0)+12>>2]);Ga=Va;Ta=0;while(1){ua=ea(g[E+(Ta*12|0)+4>>2]);ta=ea(g[E+(Ta*12|0)+8>>2]);Fa=ea(g[E+(Ta*12|0)+12>>2]);va=ea(ua*ea(g[h>>2]));Ha=ea(va+ea(ta*ea(g[_>>2])));va=ea(Ha+ea(Fa*ea(g[aa>>2])));Ha=ea(ua*ea(g[ba>>2]));Xa=ea(Ha+ea(ta*ea(g[ca>>2])));Ha=ea(Xa+ea(Fa*ea(g[fa>>2])));Xa=ea(ua*ea(g[ga>>2]));ua=ea(Xa+ea(ta*ea(g[ha>>2])));ta=ea(ua+ea(Fa*ea(g[ia>>2])));Fa=ea(ea(Aa*ta)-ea(wa*Ha));ua=ea(ea(wa*va)-ea(xa*ta));ta=ea(ea(xa*Ha)-ea(Aa*va));va=ea(ea(ta*ta)+ea(ea(Fa*Fa)+ea(ua*ua)));if(!(va<ea(1.1920929e-07))?(Ha=ea(ea(1.0)/ea(T(ea(va)))),va=ea(Fa*Ha),Fa=ea(ua*Ha),ua=ea(ta*Ha),g[F>>2]=va,g[b>>2]=Fa,g[x>>2]=ua,g[C>>2]=ea(0.0),Ha=ea(va*ea(g[f>>2])),ta=ea(Ha+ea(Fa*ea(g[sa>>2]))),Ha=ea(ta+ea(ua*ea(g[ra>>2]))),ta=ea(va*ea(g[ya>>2])),Xa=ea(ta+ea(Fa*ea(g[za>>2]))),ta=ea(Xa+ea(ua*ea(g[Ba>>2]))),Xa=ea(va*ea(g[Ca>>2])),Ya=ea(Xa+ea(Fa*ea(g[Da>>2]))),Xa=ea(Ya+ea(ua*ea(g[Ea>>2]))),g[G>>2]=Ha,g[a>>2]=ta,g[A>>2]=Xa,g[X>>2]=ea(0.0),Za=Ha>ea(0.0),_a=ta>ea(0.0),$a=Xa>ea(0.0),g[p>>2]=R,g[V>>2]=P,g[S>>2]=$,g[y>>2]=ea(0.0),g[o>>2]=Z,g[Ia>>2]=da,g[Ja>>2]=ja,g[Ka>>2]=ea(0.0),Ya=ea(g[(Za?p:o)>>2]),ab=ea(g[(_a?p:o)+4>>2]),bb=ea(ea(ea(Ya*Ha)+ea(ab*ta))+ea(ea(g[($a?p:o)+8>>2])*Xa)),Xa=bb>O?bb:O,bb=ea(ea(ea(Q*va)+ea(M*Fa))+ea(N*ua)),ta=ea(bb-Xa),ab=ea(Xa+bb),$a=va>ea(0.0),_a=Fa>ea(0.0),Za=ua>ea(0.0),g[r>>2]=la,g[La>>2]=ma,g[Ma>>2]=na,g[Na>>2]=ea(0.0),g[q>>2]=oa,g[Oa>>2]=pa,g[Pa>>2]=qa,g[Qa>>2]=ea(0.0),bb=ea(g[($a?r:q)>>2]),Xa=ea(g[(_a?r:q)+4>>2]),Ha=ea(ea(ea(bb*va)+ea(Xa*Fa))+ea(ea(g[(Za?r:q)+8>>2])*ua)),ua=Ha>ka?Ha:ka,Ha=ea(-ua),!(ea((ua>ab?ab:ua)-(ta<Ha?Ha:ta))>Ga)):0){Dn[c[(c[d>>2]|0)+12>>2]&511](d,F,t,u);ta=ea(g[F>>2]);Ha=ea(g[b>>2]);ua=ea(ea(ea(U*ta)+ea(W*Ha))+ea(Y*ea(g[x>>2])));Dn[c[(c[e>>2]|0)+12>>2]&511](e,G,v,w);Ha=ea(ua+ea(g[v>>2]));g[v>>2]=Ha;c[Ra+0>>2]=c[H+0>>2];c[Ra+4>>2]=c[H+4>>2];c[Ra+8>>2]=c[H+8>>2];ta=ea(ua+ea(g[w>>2]));g[w>>2]=ta;c[Sa+0>>2]=c[I+0>>2];c[Sa+4>>2]=c[I+4>>2];c[Sa+8>>2]=c[I+8>>2];ua=ea(g[u>>2]);ab=ea(g[j>>2]);if(Ha>ea(ua+ab)){cb=0;db=14;break b}Fa=ea(ab+ta);if(ea(g[t>>2])>Fa){cb=0;db=14;break b}Fa=ea(ua-Ha);if(Ga>Fa){c[s+0>>2]=c[J+0>>2];c[s+4>>2]=c[J+4>>2];c[s+8>>2]=c[J+8>>2];c[l+0>>2]=c[F+0>>2];c[l+4>>2]=c[F+4>>2];c[l+8>>2]=c[F+8>>2];c[l+12>>2]=c[F+12>>2];c[m>>2]=2;eb=Fa}else eb=Ga}else eb=Ga;Ta=Ta+1|0;if(Ta>>>0>=B>>>0)break;else Ga=eb}Wa=Wa+1|0;if(Wa>>>0>=z>>>0){Ua=eb;break a}else Va=eb}if((db|0)==14){i=n;return cb|0}}else Ua=K;while(0);g[k>>2]=Ua;c[L+0>>2]=c[s+0>>2];c[L+4>>2]=c[s+4>>2];c[L+8>>2]=c[s+8>>2];cb=1;i=n;return cb|0}function g8a(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=0,z=0,A=Im,B=0;f=i;h=c[b+36>>2]|0;j=ea(g[e>>2]);k=ea(g[e+4>>2]);l=ea(g[e+8>>2]);m=ea(j*ea(g[h>>2]));n=ea(m+ea(k*ea(g[h+4>>2])));m=ea(n+ea(l*ea(g[h+8>>2])));n=ea(j*ea(g[h+16>>2]));o=ea(n+ea(k*ea(g[h+20>>2])));n=ea(o+ea(l*ea(g[h+24>>2])));o=ea(j*ea(g[h+32>>2]));j=ea(o+ea(k*ea(g[h+36>>2])));k=ea(j+ea(l*ea(g[h+40>>2])));l=ea(-m);j=ea(-n);o=ea(-k);h=c[a+24>>2]|0;p=ea(g[h>>2]);q=ea(g[h+4>>2]);r=ea(ea(ea(m*p)+ea(n*q))+ea(k*ea(g[h+8>>2])));e=c[a+16>>2]|0;if(e>>>0>1){q=r;b=0;s=1;while(1){p=ea(g[h+(s*20|0)>>2]);t=ea(g[h+(s*20|0)+4>>2]);u=ea(ea(ea(m*p)+ea(n*t))+ea(k*ea(g[h+(s*20|0)+8>>2])));v=q>u;t=v?u:q;w=v?s:b;s=s+1|0;if(s>>>0>=e>>>0){x=t;y=w;break}else{q=t;b=w}}}else{x=r;y=0}b=c[a+20>>2]|0;e=c[a+36>>2]|0;if(!b){z=y;i=f;return z|0}r=ea(x*x);a=-1;s=0;while(1){w=s<<1;v=d[e+w>>0]|0;x=ea(g[h+(v*20|0)>>2]);q=ea(g[h+(v*20|0)+4>>2]);k=ea(g[h+(v*20|0)+8>>2]);v=d[e+(w|1)>>0]|0;n=ea(g[h+(v*20|0)>>2]);m=ea(g[h+(v*20|0)+4>>2]);t=ea(x+n);n=ea(q+m);m=ea(k+ea(g[h+(v*20|0)+8>>2]));k=ea(ea(ea(t*t)+ea(n*n))+ea(m*m));q=ea(ea(ea(t*l)+ea(n*j))+ea(m*o));m=ea(q*q);if(q>=ea(0.0)&m>ea(r*k)){A=ea(m/k);B=s}else{A=r;B=a}s=s+1|0;if((s|0)==(b|0))break;else{r=A;a=B}}if((B|0)==-1){z=y;i=f;return z|0}y=B<<1;B=d[e+y>>0]|0;a=d[e+(y|1)>>0]|0;A=ea(g[h+(B*20|0)>>2]);r=ea(g[h+(B*20|0)+4>>2]);k=ea(g[h+(B*20|0)+8>>2]);m=ea(g[h+(a*20|0)>>2]);q=ea(g[h+(a*20|0)+4>>2]);y=ea(ea(ea(A*l)+ea(r*j))+ea(k*o))>ea(ea(ea(m*l)+ea(q*j))+ea(ea(g[h+(a*20|0)+8>>2])*o));z=y?B:a;i=f;return z|0}function h8a(b,f,h,j,k,l){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=0;m=i;i=i+112|0;n=m+60|0;o=m+32|0;p=m+16|0;q=m+72|0;r=m+96|0;s=m+48|0;t=m;u=m+84|0;v=f+16|0;a:do if(c[v>>2]|0){w=f+24|0;x=o+4|0;y=p+4|0;z=c[f+28>>2]|0;A=c[h+40>>2]|0;B=ea(g[b+96>>2]);C=ea(g[b+100>>2]);D=ea(g[b+104>>2]);E=ea(g[b+112>>2]);F=ea(g[b+116>>2]);G=ea(g[b+120>>2]);H=ea(g[b+128>>2]);I=ea(3402823469999999843913219.0e14);J=ea(0.0);K=ea(1.0);L=ea(0.0);M=0;while(1){N=c[w>>2]|0;O=d[N+(M*20|0)+19>>0]|0;P=ea(g[z+(O*12|0)>>2]);Q=ea(g[z+(O*12|0)+4>>2]);R=ea(g[z+(O*12|0)+8>>2]);S=ea(g[N+(M*20|0)+12>>2]);U=ea(g[N+(M*20|0)>>2]);V=ea(g[N+(M*20|0)+4>>2]);W=ea(g[N+(M*20|0)+8>>2]);X=ea(U*ea(g[A>>2]));Y=ea(X+ea(V*ea(g[A+4>>2])));X=ea(Y+ea(W*ea(g[A+8>>2])));Y=ea(U*ea(g[A+16>>2]));Z=ea(Y+ea(V*ea(g[A+20>>2])));Y=ea(Z+ea(W*ea(g[A+24>>2])));Z=ea(U*ea(g[A+32>>2]));_=ea(Z+ea(V*ea(g[A+36>>2])));Z=ea(_+ea(W*ea(g[A+40>>2])));_=ea(ea(1.0)/ea(T(ea(ea(ea(X*X)+ea(Y*Y))+ea(Z*Z)))));$=ea(X*_);X=ea(Y*_);Y=ea(_*Z);Z=ea(ea(ea(ea(P*U)+ea(Q*V))+ea(R*W))*_);g[o>>2]=Z;c[x+0>>2]=c[q+0>>2];c[x+4>>2]=c[q+4>>2];c[x+8>>2]=c[q+8>>2];W=ea(S*_);_=ea(-W);g[p>>2]=_;c[y+0>>2]=c[r+0>>2];c[y+4>>2]=c[r+4>>2];c[y+8>>2]=c[r+8>>2];S=ea(ea(ea($*B)+ea(X*C))+ea(Y*D));R=ea(ea(ea($*E)+ea(X*F))+ea(Y*G));N=S>R;V=ea((N?R:S)-H);Q=ea(g[j>>2]);if(V>ea(Q-W)){aa=0;ba=22;break}if(Z>ea(Q+ea(H+(N?S:R)))){aa=0;ba=22;break}R=ea(_-V);if(I>R){c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];ca=R;da=Y;fa=X;ga=$}else{ca=I;da=L;fa=K;ga=J}M=M+1|0;N=c[v>>2]|0;if(M>>>0>=N>>>0){ha=ca;ia=da;ja=fa;ka=ga;la=E;ma=B;na=F;oa=C;pa=G;qa=D;ra=N;break a}else{I=ca;J=ga;K=fa;L=da}}if((ba|0)==22){i=m;return aa|0}}else{L=ea(g[b+112>>2]);K=ea(g[b+116>>2]);J=ea(g[b+120>>2]);I=ea(g[b+96>>2]);D=ea(g[b+100>>2]);ha=ea(3402823469999999843913219.0e14);ia=ea(0.0);ja=ea(1.0);ka=ea(0.0);la=L;ma=I;na=K;oa=D;pa=J;qa=ea(g[b+104>>2]);ra=0}while(0);s=b+112|0;r=b+116|0;q=b+120|0;M=b+96|0;y=b+100|0;x=b+104|0;da=ea(la-ma);ma=ea(na-oa);oa=ea(pa-qa);b:do if(ra){A=f+24|0;z=f+32|0;w=f+28|0;N=h+40|0;O=t+4|0;sa=t+8|0;ta=t+12|0;ua=b+128|0;va=ra;qa=ka;pa=ja;na=ia;la=ea(0.0);fa=ha;wa=0;c:while(1){xa=c[A>>2]|0;ya=c[z>>2]|0;za=e[xa+(wa*20|0)+16>>1]|0;Aa=xa+(wa*20|0)+18|0;xa=a[Aa>>0]|0;if(!(xa<<24>>24)){Ba=fa;Ca=la;Da=na;Ea=pa;Fa=qa;Ga=va}else{ga=fa;ca=qa;J=pa;D=na;K=la;Ha=(xa&255)+-1|0;xa=0;while(1){Ia=d[ya+(xa+za)>>0]|0;Ja=c[w>>2]|0;I=ea(g[Ja+(Ia*12|0)>>2]);L=ea(g[Ja+(Ia*12|0)+4>>2]);G=ea(g[Ja+(Ia*12|0)+8>>2]);Ia=d[ya+(Ha+za)>>0]|0;C=ea(g[Ja+(Ia*12|0)>>2]);F=ea(g[Ja+(Ia*12|0)+4>>2]);B=ea(C-I);I=ea(F-L);L=ea(ea(g[Ja+(Ia*12|0)+8>>2])-G);Ia=c[N>>2]|0;G=ea(B*ea(g[Ia>>2]));F=ea(G+ea(I*ea(g[Ia+4>>2])));G=ea(F+ea(L*ea(g[Ia+8>>2])));F=ea(B*ea(g[Ia+16>>2]));C=ea(F+ea(I*ea(g[Ia+20>>2])));F=ea(C+ea(L*ea(g[Ia+24>>2])));C=ea(B*ea(g[Ia+32>>2]));B=ea(C+ea(I*ea(g[Ia+36>>2])));I=ea(B+ea(L*ea(g[Ia+40>>2])));L=ea(ea(ma*I)-ea(oa*F));B=ea(ea(oa*G)-ea(da*I));I=ea(ea(da*F)-ea(ma*G));G=ea(ea(1.0)/ea(T(ea(ea(I*I)+ea(ea(L*L)+ea(B*B))))));F=ea(G*B);B=ea(I*G);g[t>>2]=ea(G*L);g[O>>2]=F;g[sa>>2]=B;g[ta>>2]=ea(0.0);Dn[c[(c[h>>2]|0)+12>>2]&511](h,t,o,p);B=ea(g[M>>2]);F=ea(g[y>>2]);L=ea(g[x>>2]);G=ea(g[t>>2]);I=ea(g[O>>2]);C=ea(g[sa>>2]);E=ea(ea(ea(B*G)+ea(F*I))+ea(L*C));L=ea(g[s>>2]);F=ea(g[r>>2]);B=ea(ea(ea(G*L)+ea(I*F))+ea(C*ea(g[q>>2])));Ia=E>B;F=ea(g[ua>>2]);L=ea((Ia?B:E)-F);H=ea(g[p>>2]);$=ea(g[j>>2]);if(L>ea(H+$)){aa=0;ba=22;break c}X=ea($+ea(F+(Ia?E:B)));if(ea(g[o>>2])>X){aa=0;ba=22;break c}X=ea(H-L);if(ga>X){c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];Ka=X;La=ea(g[ta>>2]);Ma=C;Na=I;Oa=G}else{Ka=ga;La=K;Ma=D;Na=J;Oa=ca}Ia=xa+1|0;if(Ia>>>0<(d[Aa>>0]|0)>>>0){Ja=xa;ga=Ka;ca=Oa;J=Na;D=Ma;K=La;xa=Ia;Ha=Ja}else break}Ba=Ka;Ca=La;Da=Ma;Ea=Na;Fa=Oa;Ga=c[v>>2]|0}wa=wa+1|0;if(wa>>>0>=Ga>>>0){Pa=Ba;Qa=Ca;Ra=Da;Sa=Ea;Ta=Fa;Ua=n;break b}else{va=Ga;qa=Fa;pa=Ea;na=Da;la=Ca;fa=Ba}}if((ba|0)==22){i=m;return aa|0}}else{Pa=ha;Qa=ea(0.0);Ra=ia;Sa=ja;Ta=ka;Ua=n}while(0);g[l>>2]=Ta;g[l+4>>2]=Sa;g[l+8>>2]=Ra;g[l+12>>2]=Qa;g[k>>2]=Pa;l=k+4|0;c[l+0>>2]=c[Ua+0>>2];c[l+4>>2]=c[Ua+4>>2];c[l+8>>2]=c[Ua+8>>2];aa=1;i=m;return aa|0}function i8a(a,b){a=a|0;b=b|0;return}function j8a(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0;k=i;i=i+64|0;l=k+32|0;m=k+16|0;n=k;o=k+48|0;p=ea(g[a+112>>2]);q=ea(g[a+116>>2]);r=ea(g[a+120>>2]);s=ea(g[a+96>>2]);t=ea(g[a+100>>2]);u=ea(g[a+104>>2]);v=ea(p-s);p=ea(q-t);q=ea(r-u);r=ea(g[a+128>>2]);w=ea(g[a+132>>2]);x=ea(r-s);r=ea(w-t);w=ea(ea(g[a+136>>2])-u);y=ea(ea(p*w)-ea(q*r));z=ea(ea(q*x)-ea(v*w));w=ea(ea(v*r)-ea(p*x));x=ea(ea(1.0)/ea(T(ea(ea(w*w)+ea(ea(y*y)+ea(z*z))))));p=ea(x*y);y=ea(x*z);z=ea(w*x);g[n>>2]=p;g[n+4>>2]=y;g[n+8>>2]=z;g[n+12>>2]=ea(0.0);x=ea(ea(ea(p*s)+ea(y*t))+ea(z*u));Dn[c[(c[b>>2]|0)+12>>2]&511](b,n,l,m);u=ea(g[l>>2]);z=ea(g[d>>2]);if(u>ea(x+z)){A=0;i=k;return A|0}if(x>ea(z+ea(g[m>>2]))){A=0;i=k;return A|0}g[e>>2]=ea(ea(x-u)+ea(-1.1920929e-07));m=e+4|0;c[m+0>>2]=c[o+0>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[j>>2]=0;c[f>>2]=0;c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];A=1;i=k;return A|0}function k8a(b,e,f,h,j,k,l,m){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=Im,ra=Im,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=0;n=i;i=i+48|0;o=n+24|0;p=n+12|0;q=n;r=ea(g[l>>2]);s=l+4|0;t=ea(g[s>>2]);u=l+8|0;v=ea(g[u>>2]);w=l+12|0;x=ea(g[w>>2]);y=c[b+16>>2]|0;z=(y|0)==0;a:do if(!(a[f+44>>0]|0))if(!z){A=c[b+24>>2]|0;B=c[b+28>>2]|0;C=c[f+40>>2]|0;D=ea(g[C>>2]);E=ea(g[C+4>>2]);F=ea(g[C+8>>2]);G=ea(g[C+16>>2]);H=ea(g[C+20>>2]);I=ea(g[C+24>>2]);J=ea(g[C+32>>2]);K=ea(g[C+36>>2]);L=ea(g[C+40>>2]);C=c[e+48>>2]|0;M=ea(g[C+96>>2]);N=ea(g[C+100>>2]);O=ea(g[C+104>>2]);P=ea(g[C+112>>2]);Q=ea(g[C+116>>2]);R=ea(g[C+120>>2]);S=ea(g[C+128>>2]);U=ea(g[C+132>>2]);V=ea(g[C+136>>2]);W=ea(g[h>>2]);X=ea(3402823469999999843913219.0e14);Y=r;Z=t;_=v;$=x;C=0;aa=0;while(1){ba=d[A+(aa*20|0)+19>>0]|0;ca=ea(g[A+(aa*20|0)+12>>2]);da=ea(g[A+(aa*20|0)>>2]);fa=ea(g[A+(aa*20|0)+4>>2]);ga=ea(g[A+(aa*20|0)+8>>2]);ha=ea(ea(ea(da*D)+ea(fa*E))+ea(ga*F));ia=ea(ea(ea(da*G)+ea(fa*H))+ea(ga*I));ja=ea(ea(ea(da*J)+ea(fa*K))+ea(ga*L));ka=ea(ea(1.0)/ea(T(ea(ea(ea(ha*ha)+ea(ia*ia))+ea(ja*ja)))));la=ea(ca*ka);ca=ea(-la);ma=ea(ha*ka);ha=ea(ia*ka);ia=ea(ka*ja);ja=ea(ea(ea(ma*M)+ea(ha*N))+ea(ia*O));na=ea(ea(ea(ma*P)+ea(ha*Q))+ea(ia*R));oa=ea(ea(ea(ma*S)+ea(ha*U))+ea(ia*V));pa=na>oa;qa=pa?na:oa;ra=pa?oa:na;na=ja>ra?ra:ja;if(na>ea(W-la)){sa=0;ta=19;break}la=ea(g[B+(ba*12|0)+4>>2]);ra=ea(fa*la);la=ea(da*ea(g[B+(ba*12|0)>>2]));da=ea(ga*ea(g[B+(ba*12|0)+8>>2]));ga=ea(ra+la);if(ea(ka*ea(ga+da))>ea(W+(ja>qa?ja:qa))){sa=0;ta=19;break}qa=ea(ca-na);if(X>qa){c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];ua=qa;va=ea(0.0);wa=ia;xa=ha;ya=ma;za=aa}else{ua=X;va=$;wa=_;xa=Z;ya=Y;za=C}aa=aa+1|0;if(aa>>>0>=y>>>0){Aa=ua;Ba=ya;Ca=xa;Da=wa;Ea=va;Fa=za;break a}else{X=ua;Y=ya;Z=xa;_=wa;$=va;C=za}}if((ta|0)==19){i=n;return sa|0}}else{Aa=ea(3402823469999999843913219.0e14);Ba=r;Ca=t;Da=v;Ea=x;Fa=0}else if(!z){C=c[b+24>>2]|0;aa=c[b+28>>2]|0;B=c[e+48>>2]|0;$=ea(g[B+96>>2]);_=ea(g[B+100>>2]);Z=ea(g[B+104>>2]);Y=ea(g[B+112>>2]);X=ea(g[B+116>>2]);W=ea(g[B+120>>2]);V=ea(g[B+128>>2]);U=ea(g[B+132>>2]);S=ea(g[B+136>>2]);R=ea(g[h>>2]);Q=ea(3402823469999999843913219.0e14);P=r;O=t;N=v;M=x;B=0;A=0;while(1){ba=d[C+(A*20|0)+19>>0]|0;L=ea(g[C+(A*20|0)+12>>2]);K=ea(g[C+(A*20|0)>>2]);J=ea(g[C+(A*20|0)+4>>2]);I=ea(g[C+(A*20|0)+8>>2]);H=ea(-L);G=ea(ea(ea(K*$)+ea(J*_))+ea(I*Z));F=ea(ea(ea(K*Y)+ea(J*X))+ea(I*W));E=ea(ea(ea(K*V)+ea(J*U))+ea(I*S));pa=F>E;D=pa?F:E;ma=pa?E:F;F=G>ma?ma:G;if(F>ea(R-L)){sa=0;ta=19;break}L=ea(g[aa+(ba*12|0)+4>>2]);ma=ea(J*L);L=ea(K*ea(g[aa+(ba*12|0)>>2]));E=ea(g[aa+(ba*12|0)+8>>2]);if(ea(ea(ma+L)+ea(I*E))>ea(R+(G>D?G:D))){sa=0;ta=19;break}D=ea(H-F);if(Q>D){c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];Ga=D;Ha=ea(0.0);Ia=I;Ja=J;Ka=K;La=A}else{Ga=Q;Ha=M;Ia=N;Ja=O;Ka=P;La=B}A=A+1|0;if(A>>>0>=y>>>0){Aa=Ga;Ba=Ka;Ca=Ja;Da=Ia;Ea=Ha;Fa=La;break a}else{Q=Ga;P=Ka;O=Ja;N=Ia;M=Ha;B=La}}if((ta|0)==19){i=n;return sa|0}}else{Aa=ea(3402823469999999843913219.0e14);Ba=r;Ca=t;Da=v;Ea=x;Fa=0}while(0);if(ea(g[j>>2])>ea(Aa+ea(1.1920929e-07))){ta=j+4|0;g[l>>2]=Ba;g[s>>2]=Ca;g[u>>2]=Da;g[w>>2]=Ea;g[j>>2]=Aa;c[ta+0>>2]=c[o+0>>2];c[ta+4>>2]=c[o+4>>2];c[ta+8>>2]=c[o+8>>2];c[m>>2]=1}c[k>>2]=Fa;sa=1;i=n;return sa|0}function l8a(b,f,h,j,k,l,m,n,o){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=0,ta=Im,ua=Im;p=i;i=i+128|0;q=p+108|0;r=p+80|0;s=p+64|0;t=p+16|0;u=p;v=p+96|0;w=ea(g[m>>2]);x=m+4|0;c[q+0>>2]=c[x+0>>2];c[q+4>>2]=c[x+4>>2];c[q+8>>2]=c[x+8>>2];y=k+40|0;z=c[y>>2]|0;A=b+96|0;B=ea(g[A>>2]);C=b+100|0;D=ea(g[C>>2]);E=b+104|0;F=ea(g[E>>2]);G=ea(g[z>>2]);H=ea(B*G);I=ea(g[z+16>>2]);J=ea(H+ea(D*I));H=ea(g[z+32>>2]);K=ea(J+ea(F*H));J=ea(g[z+4>>2]);L=ea(B*J);M=ea(g[z+20>>2]);N=ea(L+ea(D*M));L=ea(g[z+36>>2]);O=ea(N+ea(F*L));N=ea(g[z+8>>2]);P=ea(B*N);B=ea(g[z+24>>2]);Q=ea(P+ea(D*B));D=ea(g[z+40>>2]);P=ea(Q+ea(F*D));F=ea(g[b+112>>2]);Q=ea(g[b+116>>2]);R=ea(g[b+120>>2]);S=ea(ea(ea(G*F)+ea(I*Q))+ea(H*R));U=ea(ea(ea(J*F)+ea(M*Q))+ea(L*R));V=ea(ea(ea(N*F)+ea(B*Q))+ea(D*R));R=ea(g[b+128>>2]);Q=ea(g[b+132>>2]);F=ea(g[b+136>>2]);W=ea(ea(ea(G*R)+ea(I*Q))+ea(H*F));H=ea(ea(ea(J*R)+ea(M*Q))+ea(L*F));L=ea(ea(ea(N*R)+ea(B*Q))+ea(D*F));b=f&255;if(!(b&32))X=0;else{F=ea(H-O);D=ea(L-P);g[t>>2]=ea(W-K);g[t+4>>2]=F;g[t+8>>2]=D;g[t+12>>2]=ea(0.0);X=1}if(!(b&8))Y=X;else{D=ea(O-U);F=ea(P-V);g[t+(X<<4)>>2]=ea(K-S);g[t+(X<<4)+4>>2]=D;g[t+(X<<4)+8>>2]=F;g[t+(X<<4)+12>>2]=ea(0.0);Y=X+1|0}if(!(b&16))Z=Y;else{F=ea(U-H);D=ea(V-L);g[t+(Y<<4)>>2]=ea(S-W);g[t+(Y<<4)+4>>2]=F;g[t+(Y<<4)+8>>2]=D;g[t+(Y<<4)+12>>2]=ea(0.0);Z=Y+1|0}if(!Z){_=1;i=p;return _|0}D=ea(S-K);S=ea(U-O);U=ea(V-P);V=ea(W-K);K=ea(H-O);O=ea(L-P);P=ea(ea(S*O)-ea(U*K));L=ea(ea(U*V)-ea(D*O));O=ea(ea(D*K)-ea(S*V));V=ea(ea(1.0)/ea(T(ea(ea(O*O)+ea(ea(P*P)+ea(L*L))))));S=ea(V*P);P=ea(V*L);L=ea(O*V);V=ea(g[A>>2]);O=ea(g[C>>2]);K=ea(ea(ea(V*S)+ea(P*O))+ea(L*ea(g[E>>2])));E=h+16|0;C=c[E>>2]|0;a:do if(C){A=h+24|0;Y=h+32|0;b=h+28|0;X=u+4|0;f=u+8|0;z=u+12|0;$=j+48|0;aa=C;O=w;ba=0;b:while(1){ca=c[A>>2]|0;da=c[Y>>2]|0;fa=e[ca+(ba*20|0)+16>>1]|0;V=ea(g[ca+(ba*20|0)>>2]);D=ea(g[ca+(ba*20|0)+4>>2]);if(!(ea(ea(ea(S*V)+ea(P*D))+ea(L*ea(g[ca+(ba*20|0)+8>>2])))>ea(0.0))?(ga=ca+(ba*20|0)+18|0,ca=a[ga>>0]|0,ca<<24>>24!=0):0){ha=ca;D=O;ia=(ca&255)+-1|0;ca=0;while(1){ja=d[da+(ca+fa)>>0]|0;ka=c[b>>2]|0;V=ea(g[ka+(ja*12|0)>>2]);U=ea(g[ka+(ja*12|0)+4>>2]);H=ea(g[ka+(ja*12|0)+8>>2]);ja=d[da+(ia+fa)>>0]|0;W=ea(g[ka+(ja*12|0)>>2]);F=ea(g[ka+(ja*12|0)+4>>2]);Q=ea(g[ka+(ja*12|0)+8>>2]);B=ea(ea(ea(ea(S*V)+ea(P*U))+ea(L*H))-K);R=ea(g[l>>2]);if(!(R>=B)?!(R>=ea(ea(ea(ea(S*W)+ea(P*F))+ea(L*Q))-K)):0){la=ha;ma=D}else{R=ea(W-V);V=ea(F-U);U=ea(Q-H);H=D;ja=0;while(1){Q=ea(g[t+(ja<<4)>>2]);F=ea(g[t+(ja<<4)+4>>2]);W=ea(g[t+(ja<<4)+8>>2]);B=ea(ea(V*W)-ea(U*F));N=ea(ea(U*Q)-ea(R*W));W=ea(ea(R*F)-ea(V*Q));Q=ea(-B);F=ea(-N);M=ea(-W);if(!(((B>Q?B:Q)<ea(9.99999997e-07)?(N>F?N:F)<ea(9.99999997e-07):0)&(W>M?W:M)<ea(9.99999997e-07))){ka=c[y>>2]|0;M=ea(B*ea(g[ka>>2]));F=ea(M+ea(N*ea(g[ka+4>>2])));M=ea(F+ea(W*ea(g[ka+8>>2])));F=ea(B*ea(g[ka+16>>2]));Q=ea(F+ea(N*ea(g[ka+20>>2])));F=ea(Q+ea(W*ea(g[ka+24>>2])));Q=ea(B*ea(g[ka+32>>2]));B=ea(Q+ea(N*ea(g[ka+36>>2])));N=ea(B+ea(W*ea(g[ka+40>>2])));W=ea(ea(1.0)/ea(T(ea(ea(ea(M*M)+ea(F*F))+ea(N*N)))));B=ea(M*W);M=ea(F*W);F=ea(N*W);g[u>>2]=B;g[X>>2]=M;g[f>>2]=F;g[z>>2]=ea(0.0);ka=c[$>>2]|0;W=ea(g[ka+96>>2]);N=ea(g[ka+100>>2]);Q=ea(g[ka+104>>2]);J=ea(g[ka+112>>2]);I=ea(g[ka+116>>2]);G=ea(g[ka+120>>2]);na=ea(g[ka+128>>2]);oa=ea(g[ka+132>>2]);pa=ea(ea(ea(W*B)+ea(N*M))+ea(Q*F));Q=ea(ea(ea(J*B)+ea(I*M))+ea(G*F));G=ea(ea(ea(na*B)+ea(oa*M))+ea(ea(g[ka+136>>2])*F));ka=Q>G;F=ka?Q:G;M=pa>F?pa:F;F=ka?G:Q;Dn[c[(c[k>>2]|0)+12>>2]&511](k,u,r,s);Q=ea(g[r>>2]);G=ea(g[l>>2]);if(Q>ea(M+G)){_=0;qa=22;break b}oa=ea(G+ea(g[s>>2]));if((pa>F?F:pa)>oa){_=0;qa=22;break b}oa=ea(M-Q);if(H>oa){c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];c[n+12>>2]=c[u+12>>2];c[o>>2]=2;ra=oa}else ra=H}else ra=H;ja=ja+1|0;if(ja>>>0>=Z>>>0)break;else H=ra}la=a[ga>>0]|0;ma=ra}ja=ca+1|0;if(ja>>>0<(la&255)>>>0){ka=ca;ha=la;D=ma;ca=ja;ia=ka}else break}sa=c[E>>2]|0;ta=ma}else{sa=aa;ta=O}ba=ba+1|0;if(ba>>>0>=sa>>>0){ua=ta;break a}else{aa=sa;O=ta}}if((qa|0)==22){i=p;return _|0}}else ua=w;while(0);g[m>>2]=ua;c[x+0>>2]=c[q+0>>2];c[x+4>>2]=c[q+4>>2];c[x+8>>2]=c[q+8>>2];_=1;i=p;return _|0}function m8a(b,f,h,j,k,l,m,n,o,p){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=Im,N=0,O=Im,P=0,Q=Im,R=Im,S=0,U=Im,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;q=i;i=i+112|0;r=q+48|0;s=q;t=q+96|0;u=c[n>>2]|0;MSa(r,p);v=(c[j+32>>2]|0)+(e[k+16>>1]|0)|0;w=k+18|0;x=d[w>>0]|0;y=(x<<4)+16|0;z=i;i=i+((1*y|0)+15&-16)|0;A=z+15&-16;z=i;i=i+((1*y|0)+15&-16)|0;y=i;i=i+((1*x|0)+15&-16)|0;B=b+96|0;c[s+0>>2]=c[B+0>>2];c[s+4>>2]=c[B+4>>2];c[s+8>>2]=c[B+8>>2];c[s+12>>2]=c[B+12>>2];B=s+16|0;C=b+112|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];C=s+32|0;B=b+128|0;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];c[C+12>>2]=c[B+12>>2];B=j+28|0;En[c[(c[l>>2]|0)+16>>2]&127](l,v,x,c[B>>2]|0,A);D=ea(g[r>>2]);x=r+16|0;E=ea(g[x>>2]);j=r+32|0;F=ea(g[j>>2]);C=r+4|0;G=ea(g[C>>2]);H=r+20|0;I=ea(g[H>>2]);J=r+36|0;K=ea(g[J>>2]);L=r+8|0;M=ea(g[L>>2]);N=r+24|0;O=ea(g[N>>2]);P=r+40|0;Q=ea(g[P>>2]);R=ea(g[s>>2]);S=s+4|0;U=ea(g[S>>2]);V=s+8|0;W=ea(g[V>>2]);X=ea(ea(ea(R*D)+ea(U*E))+ea(W*F));Y=ea(ea(ea(R*G)+ea(U*I))+ea(W*K));Z=ea(ea(ea(R*M)+ea(U*O))+ea(W*Q));g[s>>2]=X;g[S>>2]=Y;g[V>>2]=Z;g[s+12>>2]=ea(0.0);V=X>ea(3402823469999999843913219.0e14);W=V?ea(3402823469999999843913219.0e14):X;V=Y>ea(3402823469999999843913219.0e14);U=V?ea(3402823469999999843913219.0e14):Y;V=X<ea(-3402823469999999843913219.0e14);R=V?ea(-3402823469999999843913219.0e14):X;V=Y<ea(-3402823469999999843913219.0e14);X=V?ea(-3402823469999999843913219.0e14):Y;V=s+16|0;Y=ea(g[V>>2]);S=s+20|0;_=ea(g[S>>2]);$=s+24|0;aa=ea(g[$>>2]);ba=ea(ea(ea(Y*D)+ea(_*E))+ea(aa*F));ca=ea(ea(ea(Y*G)+ea(_*I))+ea(aa*K));da=ea(ea(ea(Y*M)+ea(_*O))+ea(aa*Q));g[V>>2]=ba;g[S>>2]=ca;g[$>>2]=da;g[s+28>>2]=ea(0.0);da=W<ba?W:ba;W=U<ca?U:ca;U=R>ba?R:ba;ba=X>ca?X:ca;$=s+32|0;ca=ea(g[$>>2]);S=s+36|0;X=ea(g[S>>2]);V=s+40|0;R=ea(g[V>>2]);aa=ea(ea(ea(ca*D)+ea(X*E))+ea(R*F));F=ea(ea(ea(ca*G)+ea(X*I))+ea(R*K));K=ea(ea(ea(ca*M)+ea(X*O))+ea(R*Q));g[$>>2]=aa;g[S>>2]=F;g[V>>2]=K;g[s+44>>2]=ea(0.0);V=z+15&-16;K=ea((da<aa?da:aa)+ea(-1.1920929e-07));da=ea((W<F?W:F)+ea(-1.1920929e-07));W=ea((U>aa?U:aa)+ea(1.1920929e-07));aa=ea((ba>F?ba:F)+ea(1.1920929e-07));F=ea(Z+ea(g[o>>2]));z=a[w>>0]|0;if(!(z<<24>>24)){fa=ea(-3402823469999999843913219.0e14);ga=ea(3402823469999999843913219.0e14);ha=ea(3402823469999999843913219.0e14);ia=ea(-3402823469999999843913219.0e14);ja=z&255;ka=0}else{z=p+4|0;$=p+8|0;la=b+96|0;ma=b+100|0;na=b+104|0;ba=ea(-3402823469999999843913219.0e14);U=ea(3402823469999999843913219.0e14);Q=ea(3402823469999999843913219.0e14);R=ea(-3402823469999999843913219.0e14);b=0;oa=0;while(1){pa=A+(b<<4)|0;O=ea(g[pa>>2]);qa=A+(b<<4)+4|0;X=ea(g[qa>>2]);ra=A+(b<<4)+8|0;M=ea(g[ra>>2]);sa=A+(b<<4)+12|0;ca=ea(g[sa>>2]);I=ea(O*ea(g[r>>2]));G=ea(I+ea(X*ea(g[x>>2])));I=ea(G+ea(M*ea(g[j>>2])));G=ea(O*ea(g[C>>2]));E=ea(G+ea(X*ea(g[H>>2])));G=ea(E+ea(M*ea(g[J>>2])));E=ea(O*ea(g[L>>2]));D=ea(E+ea(X*ea(g[N>>2])));E=ea(D+ea(M*ea(g[P>>2])));g[pa>>2]=I;g[qa>>2]=G;g[ra>>2]=E;g[sa>>2]=ea(0.0);g[V+(b<<4)>>2]=ea(E-Z);ta=V+(b<<4)+4|0;c[ta+0>>2]=c[t+0>>2];c[ta+4>>2]=c[t+4>>2];c[ta+8>>2]=c[t+8>>2];G=ea(g[pa>>2]);I=ea(g[qa>>2]);g[ra>>2]=Z;g[sa>>2]=ea(0.0);U=U<G?U:G;Q=Q<I?Q:I;ba=ba>G?ba:G;R=R>I?R:I;a:do if((F>E?(a[y+b>>0]=1,I=ea(g[pa>>2]),G=ea(g[qa>>2]),!(I>W|K>I)):0)?!(G>aa|da>G):0){D=ea(g[S>>2]);sa=0;ra=0;ta=2;while(1){_=D;D=ea(g[s+(sa<<4)+4>>2]);if(_>G^D>G?(Y=ea(g[s+(ta<<4)>>2]),ua=ea(D-_),va=ea(I*ua),wa=ea(ea(ua*Y)+ea(ea(G-_)*ea(ea(g[s+(sa<<4)>>2])-Y))),xa=!(ua>ea(0.0)),(xa?va:wa)>=(xa?wa:va)):0){if((ra|0)==1){ya=oa;break a}za=ra+1|0}else za=ra;xa=sa+1|0;if(xa>>>0>=3)break;else{Aa=sa;sa=xa;ra=za;ta=Aa}}if(za){G=ea(g[p>>2]);I=ea(g[z>>2]);D=ea(g[$>>2]);va=ea(g[la>>2]);wa=ea(g[ma>>2]);ua=ea(ea(ea(G*ea(va-O))+ea(I*ea(wa-X)))+ea(D*ea(ea(g[na>>2])-M)));wa=ea(O+ea(G*ua));va=ea(X+ea(I*ua));Y=ea(M+ea(D*ua));_=ea(-ua);ta=c[n>>2]|0;g[m+(ta<<6)>>2]=O;g[m+(ta<<6)+4>>2]=X;g[m+(ta<<6)+8>>2]=M;g[m+(ta<<6)+12>>2]=ca;ta=c[n>>2]|0;g[m+(ta<<6)+16>>2]=wa;g[m+(ta<<6)+20>>2]=va;g[m+(ta<<6)+24>>2]=Y;g[m+(ta<<6)+28>>2]=ea(0.0);ta=c[n>>2]|0;g[m+(ta<<6)+32>>2]=G;g[m+(ta<<6)+36>>2]=I;g[m+(ta<<6)+40>>2]=D;g[m+(ta<<6)+44>>2]=_;ta=c[n>>2]|0;c[n>>2]=ta+1;c[m+(ta<<6)+48>>2]=f;ya=oa+1|0}else ya=oa}else ya=oa;while(0);b=b+1|0;Ba=d[w>>0]|0;if(b>>>0>=Ba>>>0)break;else oa=ya}fa=ea(ba+ea(1.1920929e-07));ga=ea(U+ea(-1.1920929e-07));ha=ea(Q+ea(-1.1920929e-07));ia=ea(R+ea(1.1920929e-07));ja=Ba;ka=ya}if((ka|0)==(ja|0)){i=q;return}ja=c[l+40>>2]|0;R=ea(g[k>>2]);Q=ea(g[k+4>>2]);U=ea(g[k+8>>2]);ba=ea(R*ea(g[ja>>2]));da=ea(ba+ea(Q*ea(g[ja+4>>2])));ba=ea(da+ea(U*ea(g[ja+8>>2])));da=ea(R*ea(g[ja+16>>2]));aa=ea(da+ea(Q*ea(g[ja+20>>2])));da=ea(aa+ea(U*ea(g[ja+24>>2])));aa=ea(R*ea(g[ja+32>>2]));R=ea(aa+ea(Q*ea(g[ja+36>>2])));Q=ea(R+ea(U*ea(g[ja+40>>2])));U=ea(ea(1.0)/ea(T(ea(ea(ea(ba*ba)+ea(da*da))+ea(Q*Q)))));R=ea(ba*U);ba=ea(da*U);da=ea(Q*U);ja=c[l+36>>2]|0;l=d[v>>0]|0;v=c[B>>2]|0;U=ea(g[v+(l*12|0)>>2]);Q=ea(g[v+(l*12|0)+4>>2]);aa=ea(g[v+(l*12|0)+8>>2]);K=ea(U*ea(g[ja>>2]));W=ea(K+ea(Q*ea(g[ja+16>>2])));K=ea(W+ea(aa*ea(g[ja+32>>2])));W=ea(U*ea(g[ja+4>>2]));F=ea(W+ea(Q*ea(g[ja+20>>2])));W=ea(F+ea(aa*ea(g[ja+36>>2])));F=ea(U*ea(g[ja+8>>2]));U=ea(F+ea(Q*ea(g[ja+24>>2])));Q=ea(ea(ea(R*K)+ea(ba*W))+ea(da*ea(U+ea(aa*ea(g[ja+40>>2])))));ja=p+4|0;l=p+8|0;v=0;while(1){B=a[w>>0]|0;k=B&255;aa=ea(g[s+(v<<4)>>2]);U=ea(g[s+(v<<4)+4>>2]);b:do if(!(aa>fa|ga>aa)?!(U>ia|ha>U|B<<24>>24==0):0){ka=k+-1|0;W=ea(g[A+(ka<<4)+4>>2]);ya=0;Ba=0;oa=ka;while(1){K=W;W=ea(g[A+(ya<<4)+4>>2]);if(K>U^W>U?(F=ea(g[A+(oa<<4)>>2]),ca=ea(W-K),M=ea(aa*ca),X=ea(ea(ca*F)+ea(ea(U-K)*ea(ea(g[A+(ya<<4)>>2])-F))),ka=!(ca>ea(0.0)),(ka?M:X)>=(ka?X:M)):0){if((Ba|0)==1)break b;Ca=Ba+1|0}else Ca=Ba;ka=ya+1|0;if(ka>>>0>=k>>>0)break;else{b=ya;ya=ka;Ba=Ca;oa=b}}if((Ca|0)!=0?(W=ea(g[s+(v<<4)+8>>2]),M=ea(aa*ea(g[r>>2])),X=ea(M+ea(U*ea(g[C>>2]))),M=ea(X+ea(W*ea(g[L>>2]))),X=ea(aa*ea(g[x>>2])),ca=ea(X+ea(U*ea(g[H>>2]))),X=ea(ca+ea(W*ea(g[N>>2]))),ca=ea(aa*ea(g[j>>2])),F=ea(ca+ea(U*ea(g[J>>2]))),ca=ea(F+ea(W*ea(g[P>>2]))),W=ea(ea(ea(ea(R*M)+ea(ba*X))+ea(da*ca))-Q),!(W>ea(g[o>>2]))):0){F=ea(M-ea(R*W));K=ea(X-ea(ba*W));O=ea(ca-ea(da*W));W=ea(F-M);E=ea(K-X);_=ea(O-ca);D=ea(g[p>>2]);I=ea(g[ja>>2]);G=ea(g[l>>2]);Y=ea(ea(ea(W*D)+ea(E*I))+ea(_*G));oa=c[n>>2]|0;g[m+(oa<<6)>>2]=F;g[m+(oa<<6)+4>>2]=K;g[m+(oa<<6)+8>>2]=O;g[m+(oa<<6)+12>>2]=ea(0.0);oa=c[n>>2]|0;g[m+(oa<<6)+16>>2]=M;g[m+(oa<<6)+20>>2]=X;g[m+(oa<<6)+24>>2]=ca;g[m+(oa<<6)+28>>2]=ea(0.0);oa=c[n>>2]|0;g[m+(oa<<6)+32>>2]=D;g[m+(oa<<6)+36>>2]=I;g[m+(oa<<6)+40>>2]=G;g[m+(oa<<6)+44>>2]=Y;oa=c[n>>2]|0;c[n>>2]=oa+1;c[m+(oa<<6)+48>>2]=f}}while(0);v=v+1|0;if((v|0)==3){Da=0;Ea=h;break}}while(1){h=Ea&255;if(h&248){v=2;Ca=0;while(1){if((1<<v+3&h|0)!=0?(da=ea(g[s+(Ca<<4)>>2]),ba=ea(g[s+(Ca<<4)+4>>2]),R=ea(g[s+(v<<4)>>2]),Q=ea(g[s+(v<<4)+4>>2]),ha=da<R?da:R,ia=ba<Q?ba:Q,ga=da>R?da:R,fa=ba>Q?ba:Q,k=a[w>>0]|0,k<<24>>24!=0):0){B=k;oa=(k&255)+-1|0;k=0;while(1){if((a[y+k>>0]|0)==0?(a[y+oa>>0]|0)==0:0)Fa=B;else{U=ea(g[A+(k<<4)>>2]);aa=ea(g[A+(k<<4)+4>>2]);Y=ea(g[A+(oa<<4)>>2]);G=ea(g[A+(oa<<4)+4>>2]);if((((!(ha>(U>Y?U:Y)?1:(U<Y?U:Y)>ga)?!(ia>(aa>G?aa:G)?1:(aa<G?aa:G)>fa):0)?(I=ea(ea(ea(da-U)*ea(Q-aa))-ea(ea(R-U)*ea(ba-aa))),D=ea(ea(ea(da-Y)*ea(Q-G))-ea(ea(R-Y)*ea(ba-G))),ea(I*D)<ea(0.0)):0)?ea(ea(ea(ea(U-da)*ea(G-ba))-ea(ea(aa-ba)*ea(Y-da)))*ea(ea(ea(U-R)*ea(G-Q))-ea(ea(aa-Q)*ea(Y-R))))<ea(0.0):0)?(ca=ea(I*ea(ea(1.0)/ea(D-I))),I=ea(Z+ea(g[V+(k<<4)>>2])),D=ea(U-ea(ca*ea(Y-U))),U=ea(aa-ea(ca*ea(G-aa))),aa=ea(I-ea(ca*ea(ea(Z+ea(g[V+(oa<<4)>>2]))-I))),I=ea(ea(g[r>>2])*D),ca=ea(I+ea(ea(g[C>>2])*U)),I=ea(g[L>>2]),G=ea(D*ea(g[x>>2])),Y=ea(G+ea(U*ea(g[H>>2]))),G=ea(g[N>>2]),X=ea(D*ea(g[j>>2])),D=ea(X+ea(U*ea(g[J>>2]))),U=ea(g[P>>2]),X=ea(aa-Z),!(X>ea(g[o>>2]))):0){M=ea(D+ea(aa*U));O=ea(Y+ea(aa*G));K=ea(ca+ea(I*aa));aa=ea(D+ea(Z*U));U=ea(Y+ea(Z*G));G=ea(ca+ea(Z*I));I=ea(g[p>>2]);ca=ea(g[ja>>2]);Y=ea(g[l>>2]);Ba=c[n>>2]|0;g[m+(Ba<<6)>>2]=K;g[m+(Ba<<6)+4>>2]=O;g[m+(Ba<<6)+8>>2]=M;g[m+(Ba<<6)+12>>2]=ea(0.0);Ba=c[n>>2]|0;g[m+(Ba<<6)+16>>2]=G;g[m+(Ba<<6)+20>>2]=U;g[m+(Ba<<6)+24>>2]=aa;g[m+(Ba<<6)+28>>2]=ea(0.0);Ba=c[n>>2]|0;g[m+(Ba<<6)+32>>2]=I;g[m+(Ba<<6)+36>>2]=ca;g[m+(Ba<<6)+40>>2]=Y;g[m+(Ba<<6)+44>>2]=X;Ba=c[n>>2]|0;c[n>>2]=Ba+1;c[m+(Ba<<6)+48>>2]=f;Fa=a[w>>0]|0}else Fa=B}Ba=k+1|0;if(Ba>>>0<(Fa&255)>>>0){ya=k;B=Fa;k=Ba;oa=ya}else break}}oa=Ca+1|0;if((oa|0)==3)break;else{k=Ca;Ca=oa;v=k}}}if((u|0)!=(c[n>>2]|0)){Ga=46;break}Da=Da+1|0;if(Da>>>0>=2){Ga=46;break}else Ea=(h^255)&255}if((Ga|0)==46){i=q;return}}function n8a(b,f,h,j,k,l,m,n,o,p){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=Im,D=0,E=0,F=0,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;k=i;i=i+160|0;q=k+96|0;r=k+48|0;s=k;t=k+156|0;u=k+144|0;v=c[b+32>>2]|0;w=e[f+16>>1]|0;x=ea(g[p>>2]);y=p+4|0;z=ea(g[y>>2]);A=p+8|0;B=ea(g[A>>2]);C=ea(-z);MSa(q,p);D=f+18|0;f=d[D>>0]|0;E=i;i=i+((1*((f<<4)+16|0)|0)+15&-16)|0;F=E+15&-16;z=ea(-x);x=ea(-B);E=F;En[c[(c[l>>2]|0)+16>>2]&127](l,v+w|0,f,c[b+28>>2]|0,E);b=h+96|0;c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];f=r+16|0;w=h+112|0;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];f=r+32|0;v=h+128|0;c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];f=F;B=ea(g[F>>2]);G=ea(g[f+4>>2]);F=f+8|0;H=ea(g[F>>2]);f=q+16|0;l=q+32|0;I=q+4|0;J=q+20|0;K=q+36|0;L=q+8|0;M=q+24|0;N=q+40|0;if(!(a[D>>0]|0)){O=ea(-3402823469999999843913219.0e14);P=ea(3402823469999999843913219.0e14);Q=ea(3402823469999999843913219.0e14);R=ea(-3402823469999999843913219.0e14);S=H}else{U=ea(-3402823469999999843913219.0e14);V=ea(3402823469999999843913219.0e14);W=ea(3402823469999999843913219.0e14);X=ea(-3402823469999999843913219.0e14);Y=0;do{Z=E+(Y<<4)|0;_=ea(g[Z>>2]);$=E+(Y<<4)+4|0;aa=ea(g[$>>2]);ba=E+(Y<<4)+8|0;ca=ea(g[ba>>2]);da=ea(_*ea(g[q>>2]));fa=ea(da+ea(aa*ea(g[f>>2])));da=ea(fa+ea(ca*ea(g[l>>2])));fa=ea(_*ea(g[I>>2]));ga=ea(fa+ea(aa*ea(g[J>>2])));fa=ea(ga+ea(ca*ea(g[K>>2])));ga=ea(_*ea(g[L>>2]));_=ea(ga+ea(aa*ea(g[M>>2])));aa=ea(_+ea(ca*ea(g[N>>2])));g[Z>>2]=da;g[$>>2]=fa;g[ba>>2]=aa;g[E+(Y<<4)+12>>2]=ea(0.0);V=V<da?V:da;W=W<fa?W:fa;U=U>da?U:da;X=X>fa?X:fa;Y=Y+1|0}while(Y>>>0<(d[D>>0]|0)>>>0);fa=ea(V+ea(-1.1920929e-07));V=ea(W+ea(-1.1920929e-07));W=ea(U+ea(1.1920929e-07));U=ea(X+ea(1.1920929e-07));O=W;P=fa;Q=V;R=U;S=ea(g[F>>2])}U=ea(S+ea(g[o>>2]));V=ea(g[q>>2]);fa=ea(g[f>>2]);W=ea(g[l>>2]);X=ea(g[I>>2]);da=ea(g[J>>2]);aa=ea(g[K>>2]);ca=ea(g[L>>2]);_=ea(g[M>>2]);ga=ea(g[N>>2]);ha=ea(-3402823469999999843913219.0e14);ia=ea(3402823469999999843913219.0e14);ja=ea(3402823469999999843913219.0e14);ka=ea(-3402823469999999843913219.0e14);N=0;M=0;while(1){L=r+(N<<4)|0;la=ea(g[L>>2]);K=r+(N<<4)+4|0;ma=ea(g[K>>2]);J=r+(N<<4)+8|0;na=ea(g[J>>2]);I=r+(N<<4)+12|0;oa=ea(g[I>>2]);pa=ea(ea(ea(la*V)+ea(ma*fa))+ea(na*W));qa=ea(ea(ea(la*X)+ea(ma*da))+ea(na*aa));ra=ea(ea(ea(la*ca)+ea(ma*_))+ea(na*ga));g[s+(N<<4)>>2]=ea(ra-S);l=s+(N<<4)+4|0;c[l+0>>2]=c[u+0>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];g[L>>2]=pa;g[K>>2]=qa;g[J>>2]=S;g[I>>2]=ea(0.0);ia=ia<pa?ia:pa;ja=ja<qa?ja:qa;ha=ha>pa?ha:pa;ka=ka>qa?ka:qa;a:do if((U>ra?(a[t+N>>0]=1,I=a[D>>0]|0,J=I&255,!(pa>O|P>pa)):0)?!(qa>R|Q>qa|I<<24>>24==0):0){I=J+-1|0;sa=ea(g[E+(I<<4)+4>>2]);K=0;L=0;l=I;while(1){ta=sa;sa=ea(g[E+(K<<4)+4>>2]);if(ta>qa^sa>qa?(ua=ea(g[E+(l<<4)>>2]),va=ea(sa-ta),wa=ea(pa*va),xa=ea(ea(va*ua)+ea(ea(qa-ta)*ea(ea(g[E+(K<<4)>>2])-ua))),I=!(va>ea(0.0)),(I?wa:xa)>=(I?xa:wa)):0){if((L|0)==1){ya=M;break a}za=L+1|0}else za=L;I=K+1|0;if(I>>>0>=J>>>0)break;else{f=K;K=I;L=za;l=f}}if(za){sa=ea(g[p>>2]);wa=ea(g[y>>2]);xa=ea(g[A>>2]);va=ea(ea(ea(ea(la-B)*sa)+ea(ea(ma-G)*wa))+ea(ea(na-H)*xa));ua=ea(la-ea(sa*va));sa=ea(ma-ea(wa*va));wa=ea(na-ea(xa*va));l=c[n>>2]|0;g[m+(l<<6)>>2]=ua;g[m+(l<<6)+4>>2]=sa;g[m+(l<<6)+8>>2]=wa;g[m+(l<<6)+12>>2]=ea(0.0);l=c[n>>2]|0;g[m+(l<<6)+16>>2]=la;g[m+(l<<6)+20>>2]=ma;g[m+(l<<6)+24>>2]=na;g[m+(l<<6)+28>>2]=oa;l=c[n>>2]|0;g[m+(l<<6)+32>>2]=z;g[m+(l<<6)+36>>2]=C;g[m+(l<<6)+40>>2]=x;g[m+(l<<6)+44>>2]=va;l=c[n>>2]|0;c[n>>2]=l+1;c[m+(l<<6)+48>>2]=j;ya=M+1|0}else ya=M}else ya=M;while(0);N=N+1|0;if((N|0)==3)break;else M=ya}if((ya|0)==3){i=k;return}H=ea(ia+ea(-1.1920929e-07));ia=ea(ja+ea(-1.1920929e-07));ja=ea(ha+ea(1.1920929e-07));ha=ea(ka+ea(1.1920929e-07));ka=ea(g[h+112>>2]);ya=h+116|0;G=ea(g[ya>>2]);M=h+120|0;B=ea(g[M>>2]);Q=ea(g[h+96>>2]);N=h+100|0;R=ea(g[N>>2]);za=h+104|0;P=ea(g[za>>2]);O=ea(ka-Q);ka=ea(G-R);G=ea(B-P);B=ea(g[h+128>>2]);u=h+132|0;U=ea(g[u>>2]);l=h+136|0;oa=ea(B-Q);B=ea(U-R);U=ea(ea(g[l>>2])-P);na=ea(ea(ka*U)-ea(G*B));ma=ea(ea(G*oa)-ea(O*U));U=ea(ea(O*B)-ea(ka*oa));oa=ea(ea(1.0)/ea(T(ea(ea(U*U)+ea(ea(na*na)+ea(ma*ma))))));ka=ea(oa*na);na=ea(oa*ma);ma=ea(U*oa);oa=ea(ea(P*ma)+ea(ea(Q*ka)+ea(R*na)));h=a[D>>0]|0;if(!(h<<24>>24)){i=k;return}L=r+36|0;K=h;h=0;while(1){R=ea(g[E+(h<<4)>>2]);Q=ea(g[E+(h<<4)+4>>2]);b:do if(!(R>ja|H>R)?!(Q>ha|ia>Q):0){P=ea(g[L>>2]);J=0;f=0;I=2;while(1){U=P;P=ea(g[r+(J<<4)+4>>2]);if(U>Q^P>Q?(B=ea(g[r+(I<<4)>>2]),O=ea(P-U),G=ea(R*O),la=ea(ea(O*B)+ea(ea(Q-U)*ea(ea(g[r+(J<<4)>>2])-B))),q=!(O>ea(0.0)),(q?G:la)>=(q?la:G)):0){if((f|0)==1){Aa=K;break b}Ba=f+1|0}else Ba=f;q=J+1|0;if(q>>>0>=3)break;else{F=J;J=q;f=Ba;I=F}}if((Ba|0)!=0?(P=ea(g[E+(h<<4)+8>>2]),G=ea(ea(ea(R*V)+ea(Q*X))+ea(P*ca)),la=ea(ea(ea(R*fa)+ea(Q*da))+ea(P*_)),O=ea(ea(ea(R*W)+ea(Q*aa))+ea(P*ga)),P=ea(ea(ea(ea(ka*G)+ea(na*la))+ea(ma*O))-oa),!(P>ea(g[o>>2]))):0){B=ea(G-ea(ka*P));U=ea(la-ea(na*P));qa=ea(O-ea(ma*P));P=ea(g[w>>2]);pa=ea(g[ya>>2]);ra=ea(g[M>>2]);va=ea(g[b>>2]);wa=ea(g[N>>2]);sa=ea(g[za>>2]);ua=ea(P-va);P=ea(pa-wa);pa=ea(ra-sa);ra=ea(g[v>>2]);xa=ea(g[u>>2]);ta=ea(ra-va);ra=ea(xa-wa);xa=ea(ea(g[l>>2])-sa);Ca=ea(B-va);va=ea(U-wa);wa=ea(qa-sa);sa=ea(ea(ea(ua*ua)+ea(P*P))+ea(pa*pa));Da=ea(ea(ea(ua*ta)+ea(P*ra))+ea(pa*xa));Ea=ea(ea(ea(ta*ta)+ea(ra*ra))+ea(xa*xa));Fa=ea(ea(ea(ua*Ca)+ea(P*va))+ea(pa*wa));pa=ea(ea(ea(Ca*ta)+ea(va*ra))+ea(wa*xa));xa=ea(ea(1.0)/ea(ea(sa*Ea)-ea(Da*Da)));wa=ea(xa*ea(ea(Fa*Ea)-ea(Da*pa)));Ea=ea(xa*ea(ea(sa*pa)-ea(Fa*Da)));I=!(wa>=ea(0.0));if(!(Ea>=ea(0.0)))Ga=1;else Ga=!(ea(wa+Ea)<=ea(1.0));if(!(I|Ga)){Ea=ea(B-G);wa=ea(U-la);Da=ea(qa-O);Fa=ea(g[p>>2]);pa=ea(g[y>>2]);sa=ea(ea(ea(Ea*Fa)+ea(wa*pa))+ea(Da*ea(g[A>>2])));I=c[n>>2]|0;g[m+(I<<6)>>2]=G;g[m+(I<<6)+4>>2]=la;g[m+(I<<6)+8>>2]=O;g[m+(I<<6)+12>>2]=ea(0.0);I=c[n>>2]|0;g[m+(I<<6)+16>>2]=B;g[m+(I<<6)+20>>2]=U;g[m+(I<<6)+24>>2]=qa;g[m+(I<<6)+28>>2]=ea(0.0);I=c[n>>2]|0;g[m+(I<<6)+32>>2]=z;g[m+(I<<6)+36>>2]=C;g[m+(I<<6)+40>>2]=x;g[m+(I<<6)+44>>2]=sa;I=c[n>>2]|0;c[n>>2]=I+1;c[m+(I<<6)+48>>2]=j;Aa=a[D>>0]|0}else Aa=K}else Aa=K}else Aa=K;while(0);h=h+1|0;if(h>>>0>=(Aa&255)>>>0)break;else K=Aa}if(!(Aa<<24>>24)){i=k;return}else{Ha=Aa;Ia=Aa;Ja=2;Ka=0}while(1){if((a[t+Ka>>0]|0)==0?(a[t+Ja>>0]|0)==0:0){La=Ia;Ma=Ha}else{ma=ea(g[r+(Ka<<4)>>2]);na=ea(g[r+(Ka<<4)+4>>2]);ka=ea(g[r+(Ja<<4)>>2]);oa=ea(g[r+(Ja<<4)+4>>2]);ia=ma<ka?ma:ka;ha=na<oa?na:oa;H=ma>ka?ma:ka;ja=na>oa?na:oa;if(!(Ha<<24>>24)){La=Ia;Ma=0}else{Aa=s+(Ka<<4)|0;K=s+(Ja<<4)|0;h=Ia;A=(Ha&255)+-1|0;y=0;while(1){Q=ea(g[E+(y<<4)>>2]);R=ea(g[E+(y<<4)+4>>2]);sa=ea(g[E+(A<<4)>>2]);qa=ea(g[E+(A<<4)+4>>2]);if((((!((Q<sa?Q:sa)>H?1:ia>(Q>sa?Q:sa))?!((R<qa?R:qa)>ja?1:ha>(R>qa?R:qa)):0)?(U=ea(ea(ea(Q-ma)*ea(qa-na))-ea(ea(R-na)*ea(sa-ma))),B=ea(ea(ea(Q-ka)*ea(qa-oa))-ea(ea(R-oa)*ea(sa-ka))),ea(U*B)<ea(0.0)):0)?ea(ea(ea(ea(ma-Q)*ea(oa-R))-ea(ea(ka-Q)*ea(na-R)))*ea(ea(ea(ma-sa)*ea(oa-qa))-ea(ea(ka-sa)*ea(na-qa))))<ea(0.0):0)?(qa=ea(U*ea(ea(1.0)/ea(B-U))),U=ea(S+ea(g[Aa>>2])),B=ea(ma-ea(qa*ea(ka-ma))),sa=ea(na-ea(qa*ea(oa-na))),R=ea(U-ea(qa*ea(ea(S+ea(g[K>>2]))-U))),U=ea(ea(V*B)+ea(X*sa)),qa=ea(ea(B*fa)+ea(sa*da)),Q=ea(ea(B*W)+ea(sa*aa)),sa=ea(R-S),!(sa>ea(g[o>>2]))):0){B=ea(Q+ea(R*ga));O=ea(qa+ea(R*_));la=ea(U+ea(ca*R));R=ea(Q+ea(S*ga));Q=ea(qa+ea(S*_));qa=ea(U+ea(S*ca));p=c[n>>2]|0;g[m+(p<<6)>>2]=qa;g[m+(p<<6)+4>>2]=Q;g[m+(p<<6)+8>>2]=R;g[m+(p<<6)+12>>2]=ea(0.0);p=c[n>>2]|0;g[m+(p<<6)+16>>2]=la;g[m+(p<<6)+20>>2]=O;g[m+(p<<6)+24>>2]=B;g[m+(p<<6)+28>>2]=ea(0.0);p=c[n>>2]|0;g[m+(p<<6)+32>>2]=z;g[m+(p<<6)+36>>2]=C;g[m+(p<<6)+40>>2]=x;g[m+(p<<6)+44>>2]=sa;p=c[n>>2]|0;c[n>>2]=p+1;c[m+(p<<6)+48>>2]=j;Na=a[D>>0]|0}else Na=h;p=y+1|0;if(p>>>0<(Na&255)>>>0){Ga=y;h=Na;y=p;A=Ga}else{La=Na;Ma=Na;break}}}}A=Ka+1|0;if((A|0)==3)break;else{y=Ka;Ha=Ma;Ia=La;Ka=A;Ja=y}}i=k;return}function o8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=0,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;e=i;f=ea(g[b+32>>2]);h=ea(g[b+36>>2]);j=ea(g[b+40>>2]);k=c[b+384>>2]|0;if(k>>>0>1){l=f;m=h;n=j;o=1;while(1){p=ea(g[b+(o<<6)+32>>2]);q=ea(g[b+(o<<6)+36>>2]);r=ea(l+p);p=ea(m+q);q=ea(n+ea(g[b+(o<<6)+40>>2]));o=o+1|0;if(o>>>0>=k>>>0){s=q;t=p;u=r;break}else{l=r;m=p;n=q}}}else{s=j;t=h;u=f}f=ea(g[d>>2]);h=ea(g[d+4>>2]);j=ea(g[d+8>>2]);n=ea(g[d+12>>2]);m=ea(ea(n*n)+ea(-.5));l=ea(ea(ea(u*f)+ea(t*h))+ea(s*j));q=ea(ea(ea(f*l)+ea(ea(n*ea(ea(s*h)-ea(t*j)))+ea(u*m)))*ea(2.0));p=ea(ea(ea(h*l)+ea(ea(n*ea(ea(u*j)-ea(s*f)))+ea(t*m)))*ea(2.0));r=ea(ea(ea(j*l)+ea(ea(n*ea(ea(t*f)-ea(u*h)))+ea(s*m)))*ea(2.0));m=ea(ea(1.0)/ea(T(ea(ea(r*r)+ea(ea(q*q)+ea(p*p))))));s=ea(m*p);p=ea(m*r);g[a>>2]=ea(m*q);g[a+4>>2]=s;g[a+8>>2]=p;g[a+12>>2]=ea(0.0);i=e;return}function p8a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=mKa()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=pKa()|0;h=mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0;g=Bn[f&255](e,28,h?544576:544544,544464,111)|0;c[a>>2]=g;if(!g){i=b;return}Am(d|0)|0;_h(d|0,1)|0;Be(g|0,d|0)|0;Aj(d|0)|0;i=b;return}function q8a(a){a=a|0;return c[a+12>>2]|0}function r8a(a){a=a|0;var b=0;b=i;oT(a+8|0);i=b;return}function s8a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rT(a+8|0,b)|0;i=c;return d|0}function t8a(a){a=a|0;return a+416|0}function u8a(a){a=a|0;return c[a+408>>2]|0}function v8a(a,b){a=a|0;b=ea(b);if(b>ea(0.0))g[a+56>>2]=b;return}function w8a(a){a=a|0;var b=Im;b=ea(g[a+56>>2]);return ea(b)}function x8a(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function y8a(a){a=a|0;return c[a+16>>2]|0}function z8a(a){a=a|0;var b=Im;b=ea(g[a+52>>2]);return ea(b)}function A8a(a,b){a=a|0;b=ea(b);if(b>ea(0.0))g[a+52>>2]=b;return}function B8a(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+36>>2]);g[a+4>>2]=ea(g[b+40>>2]);g[a+8>>2]=ea(g[b+44>>2]);return}function C8a(a,b){a=a|0;b=b|0;var c=0;c=i;jT(a+8|0,b);i=c;return}function D8a(a){a=a|0;var b=Im;b=ea(g[a+48>>2]);return ea(b)}function E8a(a,b){a=a|0;b=ea(b);var c=0;c=i;if(!(b>ea(0.0))){i=c;return}g[a+48>>2]=b;i=c;return}function F8a(a){a=a|0;return c[a+464>>2]|0}function G8a(a){a=a|0;return c[a+88>>2]|0}function H8a(a,b){a=a|0;b=b|0;c[a+88>>2]=b;return}function I8a(a,b){a=a|0;b=b|0;var c=0;c=i;pT(a+8|0,b);i=c;return}function J8a(a,b){a=a|0;b=b|0;var c=0;c=i;qT(a+8|0,b);i=c;return}function K8a(a){a=a|0;var b=Im;b=ea(g[a+496>>2]);return ea(b)}function L8a(a){a=a|0;return a|0}function M8a(a){a=a|0;var b=Im;b=ea(g[a+-8+496>>2]);return ea(b)}function N8a(a){a=a|0;return a+-8|0}function O8a(a){a=a|0;return}function P8a(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Q8a(a){a=a|0;return c[a+12>>2]|0}function R8a(a){a=a|0;var b=0;b=i;oT(a+8|0);i=b;return}function S8a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rT(a+8|0,b)|0;i=c;return d|0}function T8a(a){a=a|0;return a+416|0}function U8a(a){a=a|0;return c[a+408>>2]|0}function V8a(a,b){a=a|0;b=ea(b);if(b>ea(0.0))g[a+56>>2]=b;return}function W8a(a){a=a|0;var b=Im;b=ea(g[a+56>>2]);return ea(b)}function X8a(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function Y8a(a){a=a|0;return c[a+16>>2]|0}function Z8a(a){a=a|0;var b=Im;b=ea(g[a+52>>2]);return ea(b)}function _8a(a,b){a=a|0;b=ea(b);if(b>ea(0.0))g[a+52>>2]=b;return}function $8a(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+36>>2]);g[a+4>>2]=ea(g[b+40>>2]);g[a+8>>2]=ea(g[b+44>>2]);return}function a9a(a,b){a=a|0;b=b|0;var c=0;c=i;jT(a+8|0,b);i=c;return}function b9a(a){a=a|0;var b=Im;b=ea(g[a+48>>2]);return ea(b)}function c9a(a,b){a=a|0;b=ea(b);var c=0;c=i;if(!(b>ea(0.0))){i=c;return}g[a+48>>2]=b;i=c;return}function d9a(a){a=a|0;return c[a+464>>2]|0}function e9a(a){a=a|0;return c[a+88>>2]|0}function f9a(a,b){a=a|0;b=b|0;c[a+88>>2]=b;return}function g9a(a,b){a=a|0;b=b|0;var c=0;c=i;pT(a+8|0,b);i=c;return}function h9a(a,b){a=a|0;b=b|0;var c=0;c=i;qT(a+8|0,b);i=c;return}function i9a(a){a=a|0;var b=Im;b=ea(g[a+496>>2]);return ea(b)}function j9a(a){a=a|0;var b=Im;b=ea(g[a+500>>2]);return ea(b)}function k9a(a){a=a|0;var b=Im,c=Im;b=ea(g[a+496>>2]);c=ea(b+ea(ea(g[a+500>>2])*ea(.5)));return ea(c)}function l9a(a){a=a|0;return a|0}function m9a(a){a=a|0;var b=0,c=Im,d=Im;b=a+-8|0;c=ea(g[b+496>>2]);d=ea(c+ea(ea(g[b+500>>2])*ea(.5)));return ea(d)}function n9a(a){a=a|0;return a+-8|0}function o9a(a){a=a|0;return}function p9a(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function q9a(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function r9a(a){a=a|0;return}function s9a(a){a=a|0;return}function t9a(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function u9a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+16|0;j=h;In[c[(c[e>>2]|0)+136>>2]&4095](j,e);if(a[j>>0]&4){k=0;i=h;return k|0}j=c[b+4>>2]|0;l=c[j+20>>2]|0;a:do if((l|0)!=0?(m=e,n=m+~(m<<15)|0,m=(n>>>10^n)*9|0,n=m>>>6^m,m=n+~(n<<11)|0,n=c[(c[j+12>>2]|0)+((l+-1&(m>>>16^m))<<2)>>2]|0,(n|0)!=-1):0){m=c[j+4>>2]|0;o=j+8|0;p=n;while(1){q=m+(p<<2)|0;if((c[q>>2]|0)==(e|0))break;p=c[(c[o>>2]|0)+(p<<2)>>2]|0;if((p|0)==-1)break a}if(q){k=0;i=h;return k|0}}while(0);q=c[b+8>>2]|0;if(!q){k=2;i=h;return k|0}k=Bn[c[c[q>>2]>>2]&255](q,d,e,f,g)|0;i=h;return k|0}function v9a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+8>>2]|0;if(!f){g=0;i=e;return g|0}g=xo[c[(c[f>>2]|0)+4>>2]&2047](f,b,d)|0;i=e;return g|0}function w9a(a){a=a|0;return}function x9a(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function y9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=Im,D=0;m=i;i=i+160|0;n=m+128|0;o=m+96|0;p=m+80|0;q=m+48|0;r=m;s=m+144|0;c[n>>2]=3;t=e+40|0;u=+h[j>>3];v=+h[j+8>>3];w=+h[j+16>>3];j=f+16|0;x=+h[j>>3];y=f+24|0;z=+h[y>>3];A=f+32|0;B=+h[A>>3];g[n+4>>2]=ea(g[t>>2]);g[n+8>>2]=ea(g[t+4>>2]);g[n+12>>2]=ea(g[e+48>>2]);g[o+16>>2]=ea(u-x);g[o+20>>2]=ea(v-z);g[o+24>>2]=ea(w-B);g[o>>2]=ea(g[d+228>>2]);g[o+4>>2]=ea(g[d+232>>2]);g[o+8>>2]=ea(g[d+236>>2]);g[o+12>>2]=ea(g[d+240>>2]);c[p>>2]=3;w=+h[f+40>>3];v=+h[f+48>>3];u=+h[f+56>>3];g[p+4>>2]=ea(g[f+64>>2]);g[p+8>>2]=ea(g[f+68>>2]);g[p+12>>2]=ea(g[f+72>>2]);g[q+16>>2]=ea(w-x);g[q+20>>2]=ea(v-z);g[q+24>>2]=ea(u-B);g[q>>2]=ea(g[f+76>>2]);g[q+4>>2]=ea(g[f+80>>2]);g[q+8>>2]=ea(g[f+84>>2]);g[q+12>>2]=ea(g[f+88>>2]);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=-1;b[r+12>>1]=0;f=r+16|0;e=r+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[e>>2]=ea(3402823469999999843913219.0e14);t=l+36|0;C=ea(g[t>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,n,o,p,q,r,s,ea(0.0))|0)){D=0;i=m;return D|0}C=ea(g[e>>2]);if(C>=ea(g[t>>2])){D=0;i=m;return D|0}g[l+24>>2]=ea(g[r+28>>2]);g[l+28>>2]=ea(g[r+32>>2]);g[l+32>>2]=ea(g[r+36>>2]);g[t>>2]=C;c[l+40>>2]=-1;c[l+44>>2]=-1;B=+ea(g[f>>2]);h[l>>3]=B+ +h[j>>3];B=+ea(g[r+20>>2]);h[l+8>>3]=B+ +h[y>>3];B=+ea(g[r+24>>2]);h[l+16>>3]=B+ +h[A>>3];D=1;i=m;return D|0}function z9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0,D=0.0,E=Im,F=0;m=i;i=i+176|0;n=m+112|0;o=m+88|0;p=m+100|0;q=m+72|0;r=m+12|0;s=m;t=m+40|0;u=m+160|0;c[q>>2]=3;v=e+40|0;w=+h[j>>3];x=+h[j+8>>3];y=+h[j+16>>3];j=f+16|0;z=+h[j>>3];A=f+24|0;B=+h[A>>3];C=f+32|0;D=+h[C>>3];g[q+4>>2]=ea(g[v>>2]);g[q+8>>2]=ea(g[v+4>>2]);g[q+12>>2]=ea(g[e+48>>2]);g[r+16>>2]=ea(w-z);g[r+20>>2]=ea(x-B);g[r+24>>2]=ea(y-D);g[r>>2]=ea(g[d+228>>2]);g[r+4>>2]=ea(g[d+232>>2]);g[r+8>>2]=ea(g[d+236>>2]);g[r+12>>2]=ea(g[d+240>>2]);c[s>>2]=2;e=s+8|0;g[e>>2]=ea(0.0);g[o>>2]=ea(+h[f+40>>3]-z);g[o+4>>2]=ea(+h[f+48>>3]-B);g[o+8>>2]=ea(+h[f+56>>3]-D);g[p>>2]=ea(+h[f+64>>3]-z);g[p+4>>2]=ea(+h[f+72>>3]-B);g[p+8>>2]=ea(+h[f+80>>3]-D);g[s+4>>2]=ea(g[f+88>>2]);vKa(n,o,p,e);g[t>>2]=ea(g[n>>2]);g[t+4>>2]=ea(g[n+4>>2]);g[t+8>>2]=ea(g[n+8>>2]);g[t+12>>2]=ea(g[n+12>>2]);g[t+16>>2]=ea(g[n+16>>2]);g[t+20>>2]=ea(g[n+20>>2]);g[t+24>>2]=ea(g[n+24>>2]);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;e=n+16|0;p=n+40|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[p>>2]=ea(3402823469999999843913219.0e14);o=l+36|0;E=ea(g[o>>2]);b[u>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,E,q,r,s,t,n,u,ea(0.0))|0)){F=0;i=m;return F|0}E=ea(g[p>>2]);if(E>=ea(g[o>>2])){F=0;i=m;return F|0}g[o>>2]=E;g[l+24>>2]=ea(g[n+28>>2]);g[l+28>>2]=ea(g[n+32>>2]);g[l+32>>2]=ea(g[n+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;D=+ea(g[e>>2]);h[l>>3]=D+ +h[j>>3];D=+ea(g[n+20>>2]);h[l+8>>3]=D+ +h[A>>3];D=+ea(g[n+24>>2]);h[l+16>>3]=D+ +h[C>>3];F=1;i=m;return F|0}function A9a(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im;k=i;i=i+48|0;l=k+32|0;m=k;n=c[d+40>>2]|0;if(!n){o=0;i=k;return o|0}p=(c[a+8>>2]|0)+((c[d+44>>2]|0)*36|0)|0;q=c[a+(c[a+96>>2]<<2)+100>>2]|0;c[l>>2]=3;r=b+40|0;g[l+4>>2]=ea(g[r>>2]);g[l+8>>2]=ea(g[r+4>>2]);g[l+12>>2]=ea(g[b+48>>2]);s=ea(+h[e>>3]-+h[d+16>>3]);t=ea(+h[e+8>>3]-+h[d+24>>3]);u=ea(+h[e+16>>3]-+h[d+32>>3]);g[m>>2]=ea(g[a+228>>2]);g[m+4>>2]=ea(g[a+232>>2]);g[m+8>>2]=ea(g[a+236>>2]);g[m+12>>2]=ea(g[a+240>>2]);g[m+16>>2]=s;g[m+20>>2]=t;g[m+24>>2]=u;o=kGb(a,d,j,f,l,m,n,p,q>>>0>=n>>>0?0:q)|0;i=k;return o|0}function B9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=Im,D=0;m=i;i=i+160|0;n=m+128|0;o=m+96|0;p=m+80|0;q=m+48|0;r=m;s=m+144|0;c[n>>2]=3;t=e+40|0;u=+h[j>>3];v=+h[j+8>>3];w=+h[j+16>>3];j=f+16|0;x=+h[j>>3];y=f+24|0;z=+h[y>>3];A=f+32|0;B=+h[A>>3];g[n+4>>2]=ea(g[t>>2]);g[n+8>>2]=ea(g[t+4>>2]);g[n+12>>2]=ea(g[e+48>>2]);g[o+16>>2]=ea(u-x);g[o+20>>2]=ea(v-z);g[o+24>>2]=ea(w-B);g[o>>2]=ea(g[d+228>>2]);g[o+4>>2]=ea(g[d+232>>2]);g[o+8>>2]=ea(g[d+236>>2]);g[o+12>>2]=ea(g[d+240>>2]);c[p>>2]=3;g[p+4>>2]=ea(g[f+52>>2]);g[p+8>>2]=ea(g[f+56>>2]);g[p+12>>2]=ea(g[f+60>>2]);g[q+16>>2]=ea(g[f+40>>2]);g[q+20>>2]=ea(g[f+44>>2]);g[q+24>>2]=ea(g[f+48>>2]);g[q>>2]=ea(g[f+64>>2]);g[q+4>>2]=ea(g[f+68>>2]);g[q+8>>2]=ea(g[f+72>>2]);g[q+12>>2]=ea(g[f+76>>2]);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=-1;b[r+12>>1]=0;f=r+16|0;e=r+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[e>>2]=ea(3402823469999999843913219.0e14);t=l+36|0;C=ea(g[t>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,n,o,p,q,r,s,ea(0.0))|0)){D=0;i=m;return D|0}C=ea(g[e>>2]);if(C>=ea(g[t>>2])){D=0;i=m;return D|0}g[l+24>>2]=ea(g[r+28>>2]);g[l+28>>2]=ea(g[r+32>>2]);g[l+32>>2]=ea(g[r+36>>2]);g[t>>2]=C;c[l+40>>2]=-1;c[l+44>>2]=-1;B=+ea(g[f>>2]);h[l>>3]=B+ +h[j>>3];B=+ea(g[r+20>>2]);h[l+8>>3]=B+ +h[y>>3];B=+ea(g[r+24>>2]);h[l+16>>3]=B+ +h[A>>3];D=1;i=m;return D|0}function C9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=Im,D=0;m=i;i=i+144|0;n=m+120|0;o=m+88|0;p=m+80|0;q=m+48|0;r=m;s=m+136|0;c[n>>2]=3;t=e+40|0;u=+h[j>>3];v=+h[j+8>>3];w=+h[j+16>>3];j=f+16|0;x=+h[j>>3];y=f+24|0;z=+h[y>>3];A=f+32|0;B=+h[A>>3];g[n+4>>2]=ea(g[t>>2]);g[n+8>>2]=ea(g[t+4>>2]);g[n+12>>2]=ea(g[e+48>>2]);g[o+16>>2]=ea(u-x);g[o+20>>2]=ea(v-z);g[o+24>>2]=ea(w-B);g[o>>2]=ea(g[d+228>>2]);g[o+4>>2]=ea(g[d+232>>2]);g[o+8>>2]=ea(g[d+236>>2]);g[o+12>>2]=ea(g[d+240>>2]);c[p>>2]=0;g[p+4>>2]=ea(g[f+52>>2]);g[q+16>>2]=ea(g[f+40>>2]);g[q+20>>2]=ea(g[f+44>>2]);g[q+24>>2]=ea(g[f+48>>2]);g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(1.0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=-1;b[r+12>>1]=0;f=r+16|0;e=r+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[e>>2]=ea(3402823469999999843913219.0e14);t=l+36|0;C=ea(g[t>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,n,o,p,q,r,s,ea(0.0))|0)){D=0;i=m;return D|0}g[t>>2]=ea(g[e>>2]);g[l+24>>2]=ea(g[r+28>>2]);g[l+28>>2]=ea(g[r+32>>2]);g[l+32>>2]=ea(g[r+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;B=+ea(g[f>>2]);h[l>>3]=B+ +h[j>>3];B=+ea(g[r+20>>2]);h[l+8>>3]=B+ +h[y>>3];B=+ea(g[r+24>>2]);h[l+16>>3]=B+ +h[A>>3];D=1;i=m;return D|0}function D9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=Im,D=0;m=i;i=i+144|0;n=m+88|0;o=m+72|0;p=m+40|0;q=m+28|0;r=m;s=m+136|0;c[o>>2]=3;t=e+40|0;u=+h[j>>3];v=+h[j+8>>3];w=+h[j+16>>3];j=f+16|0;x=+h[j>>3];y=f+24|0;z=+h[y>>3];A=f+32|0;B=+h[A>>3];g[o+4>>2]=ea(g[t>>2]);g[o+8>>2]=ea(g[t+4>>2]);g[o+12>>2]=ea(g[e+48>>2]);g[p+16>>2]=ea(u-x);g[p+20>>2]=ea(v-z);g[p+24>>2]=ea(w-B);g[p>>2]=ea(g[d+228>>2]);g[p+4>>2]=ea(g[d+232>>2]);g[p+8>>2]=ea(g[d+236>>2]);g[p+12>>2]=ea(g[d+240>>2]);c[q>>2]=2;e=q+8|0;g[e>>2]=ea(0.0);g[q+4>>2]=ea(g[f+64>>2]);vKa(n,f+40|0,f+52|0,e);g[r>>2]=ea(g[n>>2]);g[r+4>>2]=ea(g[n+4>>2]);g[r+8>>2]=ea(g[n+8>>2]);g[r+12>>2]=ea(g[n+12>>2]);g[r+16>>2]=ea(g[n+16>>2]);g[r+20>>2]=ea(g[n+20>>2]);g[r+24>>2]=ea(g[n+24>>2]);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;e=n+16|0;f=n+40|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[f>>2]=ea(3402823469999999843913219.0e14);t=l+36|0;C=ea(g[t>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,o,p,q,r,n,s,ea(0.0))|0)){D=0;i=m;return D|0}C=ea(g[f>>2]);if(C>=ea(g[t>>2])){D=0;i=m;return D|0}g[t>>2]=C;g[l+24>>2]=ea(g[n+28>>2]);g[l+28>>2]=ea(g[n+32>>2]);g[l+32>>2]=ea(g[n+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;B=+ea(g[e>>2]);h[l>>3]=B+ +h[j>>3];B=+ea(g[n+20>>2]);h[l+8>>3]=B+ +h[y>>3];B=+ea(g[n+24>>2]);h[l+16>>3]=B+ +h[A>>3];D=1;i=m;return D|0}function E9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0.0,B=0,C=Im,D=0;m=i;i=i+144|0;n=m+124|0;o=m+96|0;p=m+80|0;q=m+48|0;r=m;s=m+136|0;c[n>>2]=2;t=+h[j>>3];u=+h[j+8>>3];v=+h[j+16>>3];j=f+16|0;w=+h[j>>3];x=f+24|0;y=+h[x>>3];z=f+32|0;A=+h[z>>3];g[n+4>>2]=ea(g[e+40>>2]);g[n+8>>2]=ea(ea(g[e+44>>2])*ea(.5));g[o+16>>2]=ea(t-w);g[o+20>>2]=ea(u-y);g[o+24>>2]=ea(v-A);g[o>>2]=ea(g[d+228>>2]);g[o+4>>2]=ea(g[d+232>>2]);g[o+8>>2]=ea(g[d+236>>2]);g[o+12>>2]=ea(g[d+240>>2]);c[p>>2]=3;v=+h[f+40>>3];u=+h[f+48>>3];t=+h[f+56>>3];g[p+4>>2]=ea(g[f+64>>2]);g[p+8>>2]=ea(g[f+68>>2]);g[p+12>>2]=ea(g[f+72>>2]);g[q+16>>2]=ea(v-w);g[q+20>>2]=ea(u-y);g[q+24>>2]=ea(t-A);g[q>>2]=ea(g[f+76>>2]);g[q+4>>2]=ea(g[f+80>>2]);g[q+8>>2]=ea(g[f+84>>2]);g[q+12>>2]=ea(g[f+88>>2]);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=-1;b[r+12>>1]=0;f=r+16|0;e=r+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[e>>2]=ea(3402823469999999843913219.0e14);B=l+36|0;C=ea(g[B>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,n,o,p,q,r,s,ea(0.0))|0)){D=0;i=m;return D|0}C=ea(g[e>>2]);if(C>=ea(g[B>>2])){D=0;i=m;return D|0}g[B>>2]=C;g[l+24>>2]=ea(g[r+28>>2]);g[l+28>>2]=ea(g[r+32>>2]);g[l+32>>2]=ea(g[r+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;A=+ea(g[f>>2]);h[l>>3]=A+ +h[j>>3];A=+ea(g[r+20>>2]);h[l+8>>3]=A+ +h[x>>3];A=+ea(g[r+24>>2]);h[l+16>>3]=A+ +h[z>>3];D=1;i=m;return D|0}function F9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0,C=0.0,D=Im,E=0;m=i;i=i+160|0;n=m+104|0;o=m+80|0;p=m+92|0;q=m+68|0;r=m+12|0;s=m;t=m+40|0;u=m+152|0;c[q>>2]=2;v=+h[j>>3];w=+h[j+8>>3];x=+h[j+16>>3];j=f+16|0;y=+h[j>>3];z=f+24|0;A=+h[z>>3];B=f+32|0;C=+h[B>>3];g[q+4>>2]=ea(g[e+40>>2]);g[q+8>>2]=ea(ea(g[e+44>>2])*ea(.5));g[r+16>>2]=ea(v-y);g[r+20>>2]=ea(w-A);g[r+24>>2]=ea(x-C);g[r>>2]=ea(g[d+228>>2]);g[r+4>>2]=ea(g[d+232>>2]);g[r+8>>2]=ea(g[d+236>>2]);g[r+12>>2]=ea(g[d+240>>2]);c[s>>2]=2;e=s+8|0;g[e>>2]=ea(0.0);g[o>>2]=ea(+h[f+40>>3]-y);g[o+4>>2]=ea(+h[f+48>>3]-A);g[o+8>>2]=ea(+h[f+56>>3]-C);g[p>>2]=ea(+h[f+64>>3]-y);g[p+4>>2]=ea(+h[f+72>>3]-A);g[p+8>>2]=ea(+h[f+80>>3]-C);g[s+4>>2]=ea(g[f+88>>2]);vKa(n,o,p,e);g[t>>2]=ea(g[n>>2]);g[t+4>>2]=ea(g[n+4>>2]);g[t+8>>2]=ea(g[n+8>>2]);g[t+12>>2]=ea(g[n+12>>2]);g[t+16>>2]=ea(g[n+16>>2]);g[t+20>>2]=ea(g[n+20>>2]);g[t+24>>2]=ea(g[n+24>>2]);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;e=n+16|0;p=n+40|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[p>>2]=ea(3402823469999999843913219.0e14);o=l+36|0;D=ea(g[o>>2]);b[u>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,D,q,r,s,t,n,u,ea(0.0))|0)){E=0;i=m;return E|0}D=ea(g[p>>2]);if(D>=ea(g[o>>2])){E=0;i=m;return E|0}g[o>>2]=D;g[l+24>>2]=ea(g[n+28>>2]);g[l+28>>2]=ea(g[n+32>>2]);g[l+32>>2]=ea(g[n+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;C=+ea(g[e>>2]);h[l>>3]=C+ +h[j>>3];C=+ea(g[n+20>>2]);h[l+8>>3]=C+ +h[z>>3];C=+ea(g[n+24>>2]);h[l+16>>3]=C+ +h[B>>3];E=1;i=m;return E|0}function G9a(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0;k=i;i=i+48|0;l=k+28|0;m=k;n=c[d+40>>2]|0;if(!n){o=0;i=k;return o|0}p=(c[a+8>>2]|0)+((c[d+44>>2]|0)*36|0)|0;q=c[a+(c[a+96>>2]<<2)+100>>2]|0;c[l>>2]=2;r=+h[e>>3];s=+h[e+8>>3];t=+h[e+16>>3];u=+h[d+16>>3];v=+h[d+24>>3];w=+h[d+32>>3];g[l+4>>2]=ea(g[b+40>>2]);g[l+8>>2]=ea(ea(g[b+44>>2])*ea(.5));g[m+16>>2]=ea(r-u);g[m+20>>2]=ea(s-v);g[m+24>>2]=ea(t-w);g[m>>2]=ea(g[a+228>>2]);g[m+4>>2]=ea(g[a+232>>2]);g[m+8>>2]=ea(g[a+236>>2]);g[m+12>>2]=ea(g[a+240>>2]);o=kGb(a,d,j,f,l,m,n,p,q>>>0>=n>>>0?0:q)|0;i=k;return o|0}function H9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0.0,B=0,C=Im,D=0;m=i;i=i+144|0;n=m+124|0;o=m+96|0;p=m+80|0;q=m+48|0;r=m;s=m+136|0;c[n>>2]=2;t=+h[j>>3];u=+h[j+8>>3];v=+h[j+16>>3];j=f+16|0;w=+h[j>>3];x=f+24|0;y=+h[x>>3];z=f+32|0;A=+h[z>>3];g[n+4>>2]=ea(g[e+40>>2]);g[n+8>>2]=ea(ea(g[e+44>>2])*ea(.5));g[o+16>>2]=ea(t-w);g[o+20>>2]=ea(u-y);g[o+24>>2]=ea(v-A);g[o>>2]=ea(g[d+228>>2]);g[o+4>>2]=ea(g[d+232>>2]);g[o+8>>2]=ea(g[d+236>>2]);g[o+12>>2]=ea(g[d+240>>2]);c[p>>2]=3;g[p+4>>2]=ea(g[f+52>>2]);g[p+8>>2]=ea(g[f+56>>2]);g[p+12>>2]=ea(g[f+60>>2]);g[q+16>>2]=ea(g[f+40>>2]);g[q+20>>2]=ea(g[f+44>>2]);g[q+24>>2]=ea(g[f+48>>2]);g[q>>2]=ea(g[f+64>>2]);g[q+4>>2]=ea(g[f+68>>2]);g[q+8>>2]=ea(g[f+72>>2]);g[q+12>>2]=ea(g[f+76>>2]);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=-1;b[r+12>>1]=0;f=r+16|0;e=r+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[e>>2]=ea(3402823469999999843913219.0e14);B=l+36|0;C=ea(g[B>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,n,o,p,q,r,s,ea(0.0))|0)){D=0;i=m;return D|0}C=ea(g[e>>2]);if(C>=ea(g[B>>2])){D=0;i=m;return D|0}g[B>>2]=C;g[l+24>>2]=ea(g[r+28>>2]);g[l+28>>2]=ea(g[r+32>>2]);g[l+32>>2]=ea(g[r+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;A=+ea(g[f>>2]);h[l>>3]=A+ +h[j>>3];A=+ea(g[r+20>>2]);h[l+8>>3]=A+ +h[x>>3];A=+ea(g[r+24>>2]);h[l+16>>3]=A+ +h[z>>3];D=1;i=m;return D|0}function I9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=Im,D=Im,E=Im,F=0;m=i;i=i+144|0;n=m+48|0;o=m+72|0;p=m+104|0;q=m+112|0;r=m;s=m+60|0;t=m+140|0;c[n>>2]=2;u=+h[j>>3];v=+h[j+8>>3];w=+h[j+16>>3];j=f+16|0;x=+h[j>>3];y=f+24|0;z=+h[y>>3];A=f+32|0;B=+h[A>>3];g[n+4>>2]=ea(g[e+40>>2]);g[n+8>>2]=ea(ea(g[e+44>>2])*ea(.5));g[o+16>>2]=ea(u-x);g[o+20>>2]=ea(v-z);g[o+24>>2]=ea(w-B);g[o>>2]=ea(g[d+228>>2]);g[o+4>>2]=ea(g[d+232>>2]);g[o+8>>2]=ea(g[d+236>>2]);g[o+12>>2]=ea(g[d+240>>2]);c[p>>2]=0;g[p+4>>2]=ea(g[f+52>>2]);g[q+16>>2]=ea(g[f+40>>2]);g[q+20>>2]=ea(g[f+44>>2]);g[q+24>>2]=ea(g[f+48>>2]);g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(1.0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=-1;b[r+12>>1]=0;f=r+16|0;e=r+40|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;g[e>>2]=ea(3402823469999999843913219.0e14);C=ea(-ea(g[k>>2]));D=ea(-ea(g[k+4>>2]));E=ea(-ea(g[k+8>>2]));g[s>>2]=C;g[s+4>>2]=D;g[s+8>>2]=E;k=l+36|0;E=ea(g[k>>2]);b[t>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(s,E,p,q,n,o,r,t,ea(0.0))|0)){F=0;i=m;return F|0}E=ea(g[e>>2]);if(E>=ea(g[k>>2])){F=0;i=m;return F|0}g[k>>2]=E;g[l+24>>2]=ea(g[r+28>>2]);g[l+28>>2]=ea(g[r+32>>2]);g[l+32>>2]=ea(g[r+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;B=+ea(g[f>>2]);h[l>>3]=B+ +h[j>>3];B=+ea(g[r+20>>2]);h[l+8>>3]=B+ +h[y>>3];B=+ea(g[r+24>>2]);h[l+16>>3]=B+ +h[A>>3];F=1;i=m;return F|0}function J9a(d,e,f,j,k,l){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0.0,B=0,C=Im,D=0;m=i;i=i+144|0;n=m+80|0;o=m+68|0;p=m+40|0;q=m+28|0;r=m;s=m+128|0;c[o>>2]=2;t=+h[j>>3];u=+h[j+8>>3];v=+h[j+16>>3];j=f+16|0;w=+h[j>>3];x=f+24|0;y=+h[x>>3];z=f+32|0;A=+h[z>>3];g[o+4>>2]=ea(g[e+40>>2]);g[o+8>>2]=ea(ea(g[e+44>>2])*ea(.5));g[p+16>>2]=ea(t-w);g[p+20>>2]=ea(u-y);g[p+24>>2]=ea(v-A);g[p>>2]=ea(g[d+228>>2]);g[p+4>>2]=ea(g[d+232>>2]);g[p+8>>2]=ea(g[d+236>>2]);g[p+12>>2]=ea(g[d+240>>2]);c[q>>2]=2;e=q+8|0;g[e>>2]=ea(0.0);g[q+4>>2]=ea(g[f+64>>2]);vKa(n,f+40|0,f+52|0,e);g[r>>2]=ea(g[n>>2]);g[r+4>>2]=ea(g[n+4>>2]);g[r+8>>2]=ea(g[n+8>>2]);g[r+12>>2]=ea(g[n+12>>2]);g[r+16>>2]=ea(g[n+16>>2]);g[r+20>>2]=ea(g[n+20>>2]);g[r+24>>2]=ea(g[n+24>>2]);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;e=n+16|0;f=n+40|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[f>>2]=ea(3402823469999999843913219.0e14);B=l+36|0;C=ea(g[B>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(xLa(k,C,o,p,q,r,n,s,ea(0.0))|0)){D=0;i=m;return D|0}C=ea(g[f>>2]);if(C>=ea(g[B>>2])){D=0;i=m;return D|0}g[B>>2]=C;g[l+24>>2]=ea(g[n+28>>2]);g[l+28>>2]=ea(g[n+32>>2]);g[l+32>>2]=ea(g[n+36>>2]);c[l+40>>2]=-1;c[l+44>>2]=-1;A=+ea(g[e>>2]);h[l>>3]=A+ +h[j>>3];A=+ea(g[n+20>>2]);h[l+8>>3]=A+ +h[x>>3];A=+ea(g[n+24>>2]);h[l+16>>3]=A+ +h[z>>3];D=1;i=m;return D|0}function K9a(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function L9a(a){a=a|0;return}function M9a(a){a=a|0;return}function N9a(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function O9a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;d=i;b=pKa()|0;f=mo[c[(c[b>>2]|0)+4>>2]&4095](b)|0;En[c[(c[f>>2]|0)+8>>2]&127](f,2,422168,422264,136);f=_n[c[(c[a>>2]|0)+16>>2]&4095](a,e)|0;i=d;return f|0}function P9a(a){a=a|0;var b=0;b=i;gWa(a);i=b;return}function Q9a(a){a=a|0;var b=0;b=i;i=i+16|0;gWa(a);VJa(b,a);i=b;return}function R9a(a){a=a|0;return c[a+8>>2]|0}function S9a(a){a=a|0;return c[a+4>>2]|0}function T9a(a){a=a|0;return c[a+20>>2]|0}function U9a(a){a=a|0;return c[a+16>>2]|0}function V9a(a){a=a|0;return c[a+32>>2]|0}function W9a(a){a=a|0;return c[a+28>>2]|0}function X9a(a){a=a|0;return c[a+44>>2]|0}function Y9a(a){a=a|0;return c[a+40>>2]|0}function Z9a(a){a=a|0;c[a+8>>2]=0;c[a+20>>2]=0;c[a+32>>2]=0;c[a+44>>2]=0;c[a+56>>2]=0;return}function _9a(a){a=a|0;return (b[a+6>>1]&2)!=0|0}function $9a(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=b[d>>1]&b[c>>1];b[a+2>>1]=b[d+2>>1]&b[c+2>>1];b[a+4>>1]=b[d+4>>1]&b[c+4>>1];b[a+6>>1]=b[d+6>>1]&b[c+6>>1];return}function aab(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=b[d>>1]|b[c>>1];b[a+2>>1]=b[d+2>>1]|b[c+2>>1];b[a+4>>1]=b[d+4>>1]|b[c+4>>1];b[a+6>>1]=b[d+6>>1]|b[c+6>>1];return}function bab(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=b[d>>1]^b[c>>1];b[a+2>>1]=b[d+2>>1]^b[c+2>>1];b[a+4>>1]=b[d+4>>1]^b[c+4>>1];b[a+6>>1]=b[d+6>>1]^b[c+6>>1];return}function cab(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=b[d>>1]&b[c>>1]&65535^65535;b[a+2>>1]=b[d+2>>1]&b[c+2>>1]&65535^65535;b[a+4>>1]=b[d+4>>1]&b[c+4>>1]&65535^65535;b[a+6>>1]=b[d+6>>1]&b[c+6>>1]&65535^65535;return}function dab(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=(b[d>>1]|b[c>>1])&65535^65535;b[a+2>>1]=(b[d+2>>1]|b[c+2>>1])&65535^65535;b[a+4>>1]=(b[d+4>>1]|b[c+4>>1])&65535^65535;b[a+6>>1]=(b[d+6>>1]|b[c+6>>1])&65535^65535;return}function eab(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=(b[d>>1]^b[c>>1])&65535^65535;b[a+2>>1]=(b[d+2>>1]^b[c+2>>1])&65535^65535;b[a+4>>1]=(b[d+4>>1]^b[c+4>>1])&65535^65535;b[a+6>>1]=(b[d+6>>1]^b[c+6>>1])&65535^65535;return}function fab(a,c,d){a=a|0;c=c|0;d=d|0;b[a>>1]=b[d+4>>1]&b[c>>1];b[a+2>>1]=b[d+6>>1]&b[c+2>>1];b[a+4>>1]=b[d>>1]&b[c+4>>1];b[a+6>>1]=b[d+2>>1]&b[c+6>>1];return}function gab(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function hab(a){a=a|0;return}function iab(a){a=a|0;return}function jab(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function kab(a){a=a|0;return 428352}function lab(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(428352,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function mab(a){a=a|0;return 428736}function nab(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(428736,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function oab(a){a=a|0;return 428928}function pab(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(428928,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function qab(a,b){a=a|0;b=b|0;return}function rab(a){a=a|0;return 1}function sab(a){a=a|0;return 430464}function tab(a,b){a=a|0;b=b|0;var c=0;a=i;if((((HEi(430464,b)|0)!=0?(HEi(438352,b)|0)!=0:0)?(HEi(439088,b)|0)!=0:0)?(HEi(454712,b)|0)!=0:0)c=(HEi(b,543872)|0)==0;else c=1;i=a;return c|0}function uab(a){a=a|0;return 4}function vab(a){a=a|0;var b=0,c=0;b=i;c=LU(a)|0;i=b;return c|0}function wab(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function xab(a){a=a|0;return c[a+12>>2]|0}function yab(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+32|0;e=d;B2(e,b+20|0,b);f=ea(g[e>>2]);h=ea(g[e+12>>2]);j=ea(f+h);k=ea(g[e+4>>2]);l=ea(g[e+16>>2]);m=ea(k+l);n=ea(g[e+8>>2]);o=ea(g[e+20>>2]);p=ea(j*ea(.5));j=ea(m*ea(.5));m=ea(ea(n+o)*ea(.5));q=ea(ea(ea(h-f)*ea(.5))*c);f=ea(ea(ea(l-k)*ea(.5))*c);k=ea(ea(ea(o-n)*ea(.5))*c);c=ea(j-f);n=ea(m-k);o=ea(p+q);l=ea(j+f);f=ea(m+k);g[a>>2]=ea(p-q);g[a+4>>2]=c;g[a+8>>2]=n;g[a+12>>2]=o;g[a+16>>2]=l;g[a+20>>2]=f;i=d;return}function zab(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((b|0)==8)lGb(a,c);mGb(a,b,c);i=d;return}function Aab(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;lGb(d,(b[f>>1]&8)!=0);j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==2)if(!(a[(c[k>>2]|0)+2417>>0]|0))q=4;else r=k;else if((p|0)==3)r=k;else q=4;if((q|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[r>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[r>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function Bab(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&1)){b[a>>1]=b[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+8>>1]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;b[a>>1]=b[l>>1]|0;i=f;return}function Cab(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){g7(m,d);i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+2>>0]=d;r4(c[o>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function Dab(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;g=b+f|0;h=c[b+(f+4)>>2]|0;if(!(h&2)){j=(c[450992+((h>>>24&15)<<2)>>2]|0)+g+12|0;k=a[j>>0]|0;i=d;return k|0}l=b+(f+8)|0;f=c[l>>2]|0;if(!f){b=s4(c[g>>2]|0,h>>>24&15)|0;c[l>>2]=b;m=b}else m=f;j=m+2|0;k=a[j>>0]|0;i=d;return k|0}function Eab(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(KU(b)|0){dKa(bKa()|0,8,453312,198,453392,g);i=f;return}h=c[427044+(e[b+4>>1]<<2)>>2]|0;j=b+h|0;k=c[b+(h+4)>>2]|0;h=k>>>30;if((h|0)==3)l=6;else if((h|0)==2?(a[(c[j>>2]|0)+2417>>0]|0)!=0:0)l=6;else l=5;if((l|0)==5){a[(c[450992+((k>>>24&15)<<2)>>2]|0)+j+13>>0]=d;i=f;return}else if((l|0)==6){dKa(bKa()|0,8,453464,153,453544,g);i=f;return}}function Fab(b){b=b|0;var d=0;d=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;return a[(c[450992+(((c[b+(d+4)>>2]|0)>>>24&15)<<2)>>2]|0)+(b+d)+13>>0]|0}function Gab(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;if(!(k&4))l=(c[450992+((k>>>24&15)<<2)>>2]|0)+h+11|0;else{m=b+(g+8)|0;n=c[m>>2]|0;if(!n){o=s4(c[h>>2]|0,k>>>24&15)|0;c[m>>2]=o;p=o}else p=n;l=p+3|0}p=a[d>>0]|0;if((a[l>>0]|0)==p<<24>>24){i=f;return}l=c[j>>2]|0;d=l>>>24&15;n=(c[450992+(d<<2)>>2]|0)+h|0;o=l>>>30;if((o|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))q=10;else r=h;else if((o|0)==3)r=h;else q=10;if((q|0)==10){a[n+11>>0]=p;i=f;return}n=b+(g+8)|0;g=c[n>>2]|0;if(!g){b=s4(c[r>>2]|0,d)|0;c[n>>2]=b;s=b}else s=g;a[s+3>>0]=p;r4(c[r>>2]|0,h);c[j>>2]=c[j>>2]|4;i=f;return}function Hab(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&4)){a[b>>0]=a[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+11>>0]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;a[b>>0]=a[l+3>>0]|0;i=f;return}function Iab(a){a=a|0;var b=0,c=0;b=i;c=GU(a+12|0)|0;i=b;return c|0}function Jab(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j;if((b[d+24>>1]|0)==-1){l=0;i=j;return l|0}m=c[108764]|0;n=c[(c[m>>2]|0)+124>>2]|0;a[k>>0]=a[h>>0]|0;h=Km[n&127](m,e,f,g,1,k)|0;if(!h){l=0;i=j;return l|0}w2(d+20|0,h,d);G1(h);l=h;i=j;return l|0}function Kab(a,b){a=a|0;b=b|0;var c=0;c=i;w2(a+20|0,b,a);i=c;return}function Lab(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;x2(a+20|0,b,a,c);i=d;return}function Mab(a){a=a|0;return e[a+24>>1]|0|0}function Nab(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=A2(a+20|0,b,c,d)|0;i=e;return f|0}function Oab(a){a=a|0;var b=0,c=0;b=i;c=EU(a+12|0,0)|0;i=b;return c|0}function Pab(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=b+16|0;b=c[h>>2]|0;if(!b){j=0;i=g;return j|0}if(!(c[b+40>>2]|0)){j=0;i=g;return j|0}else{k=b;l=0;m=0}while(1){b=c[k+36>>2]|0;if((m>>>0>=e>>>0?1:(a[b+(l<<3)>>0]|0)!=0)|l>>>0<f>>>0){n=k;o=m}else{c[d+(m<<2)>>2]=c[b+(l<<3)+4>>2];n=c[h>>2]|0;o=m+1|0}l=l+1|0;if(l>>>0>=(c[n+40>>2]|0)>>>0){j=o;break}else{k=n;m=o}}i=g;return j|0}function Qab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;if(!(c[b+284>>2]&512))e=b+112|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+144|0}g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);g[a+12>>2]=ea(g[e+12>>2]);g[a+16>>2]=ea(g[e+16>>2]);g[a+20>>2]=ea(g[e+20>>2]);g[a+24>>2]=ea(g[e+24>>2]);i=d;return}function Rab(b,d){b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+48|0;if(d>ea(0.0))h=ea(ea(1.0)/d);else h=ea(0.0);j=b+64|0;k=c[b+52>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=6;if((n|0)==6){T8(j,h);i=e;return}j=b+56|0;n=c[j>>2]|0;if(!n){l=s4(c[m>>2]|0,k>>>24&15)|0;c[j>>2]=l;o=l}else o=n;g[o+92>>2]=h;r4(c[m>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|1;i=e;return}function Sab(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0,k=Im;b=i;if(!(c[a+284>>2]&1))d=ea(S8(a+64|0));else{e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=ea(g[j+92>>2])}if(!(d>ea(0.0))){k=ea(0.0);i=b;return ea(k)}k=ea(ea(1.0)/d);i=b;return ea(k)}function Tab(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0;b=i;if(!(c[a+284>>2]&1)){d=ea(S8(a+64|0));i=b;return ea(d)}e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=ea(g[j+92>>2]);i=b;return ea(d)}function Uab(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im;e=i;i=i+16|0;f=e;h=b+48|0;j=ea(g[d>>2]);if(j==ea(0.0))k=ea(0.0);else k=ea(ea(1.0)/j);j=ea(g[d+4>>2]);if(j==ea(0.0))l=ea(0.0);else l=ea(ea(1.0)/j);j=ea(g[d+8>>2]);if(j==ea(0.0))m=ea(0.0);else m=ea(ea(1.0)/j);g[f>>2]=k;d=f+4|0;g[d>>2]=l;n=f+8|0;g[n>>2]=m;o=b+64|0;p=c[b+52>>2]|0;q=p>>>30;if((q|0)==3)r=h;else if((q|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)r=h;else s=10;if((s|0)==10){V8(o,f);i=e;return}o=b+56|0;s=c[o>>2]|0;if(!s){q=s4(c[r>>2]|0,p>>>24&15)|0;c[o>>2]=q;t=q;u=ea(g[f>>2])}else{t=s;u=k}g[t+96>>2]=u;g[t+100>>2]=ea(g[d>>2]);g[t+104>>2]=ea(g[n>>2]);r4(c[r>>2]|0,h);h=b+284|0;c[h>>2]=c[h>>2]|2;i=e;return}function Vab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0;d=i;if(!(c[b+284>>2]&2))e=U8(b+64|0)|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+96|0}l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=ea(g[e+8>>2]);if(l==ea(0.0))o=ea(0.0);else o=ea(ea(1.0)/l);if(m==ea(0.0))p=ea(0.0);else p=ea(ea(1.0)/m);if(n==ea(0.0)){q=ea(0.0);g[a>>2]=o;r=a+4|0;g[r>>2]=p;s=a+8|0;g[s>>2]=q;i=d;return}q=ea(ea(1.0)/n);g[a>>2]=o;r=a+4|0;g[r>>2]=p;s=a+8|0;g[s>>2]=q;i=d;return}function Wab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;if(!(c[b+284>>2]&2))e=U8(b+64|0)|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+96|0}g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);i=d;return}function Xab(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+252>>2]);g[a+4>>2]=ea(g[b+256>>2]);g[a+8>>2]=ea(g[b+260>>2]);return}function Yab(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+264>>2]);g[a+4>>2]=ea(g[b+268>>2]);g[a+8>>2]=ea(g[b+272>>2]);return}function Zab(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[(c[a>>2]|0)+192>>2]&2047](a,b,d);i=e;return}function _ab(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[(c[b>>2]|0)+196>>2]|0;a[f>>0]=a[d>>0]|0;In[g&4095](b,f);i=e;return}function $ab(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f+1|0;h=f;if(!(c[b+284>>2]&4096)){j=a[b+108>>0]|0;a[g>>0]=j;k=j}else{j=b+56|0;l=c[j>>2]|0;if(!l){m=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[j>>2]=m;n=m}else n=l;l=a[n+268>>0]|0;a[g>>0]=l;k=l}if(e)a[h>>0]=k&255|d;else a[h>>0]=k&((d^255)&255);nGb(b,g,h);i=f;return}function abb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;if(!(c[b+284>>2]&4096))a[f>>0]=a[b+108>>0]|0;else{g=b+56|0;h=c[g>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[g>>2]=j;k=j}else k=h;a[f>>0]=a[k+268>>0]|0}nGb(b,f,d);i=e;return}function bbb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if(!(c[d+284>>2]&4096)){a[b>>0]=a[d+108>>0]|0;i=e;return}f=d+56|0;g=c[f>>2]|0;if(!g){h=s4(c[d+48>>2]|0,(c[d+52>>2]|0)>>>24&15)|0;c[f>>2]=h;j=h}else j=g;a[b>>0]=a[j+268>>0]|0;i=e;return}function cbb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if(!(c[d+284>>2]&4096)){a[b>>0]=a[d+108>>0]|0;i=e;return}f=d+56|0;g=c[f>>2]|0;if(!g){h=s4(c[d+48>>2]|0,(c[d+52>>2]|0)>>>24&15)|0;c[f>>2]=h;j=h}else j=g;a[b>>0]=a[j+268>>0]|0;i=e;return}function dbb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+48|0;h=b+64|0;j=c[b+52>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){L8(h,d);i=e;return}h=b+56|0;m=c[h>>2]|0;if(!m){k=s4(c[l>>2]|0,j>>>24&15)|0;c[h>>2]=k;n=k}else n=m;g[n+124>>2]=d;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|64;i=e;return}function ebb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;if(!(c[a+284>>2]&64)){d=a+140|0;e=ea(g[d>>2]);i=b;return ea(e)}f=a+56|0;h=c[f>>2]|0;if(!h){j=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;d=k+124|0;e=ea(g[d>>2]);i=b;return ea(e)}function fbb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+48|0;h=ea(-d);j=c[b+52>>2]|0;k=j>>>30;if((k|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))l=4;else m=f;else if((k|0)==3)m=f;else l=4;if((l|0)==4){g[b+156>>2]=h;i=e;return}l=b+56|0;k=c[l>>2]|0;if(!k){n=s4(c[m>>2]|0,j>>>24&15)|0;c[l>>2]=n;o=n}else o=k;g[o+172>>2]=h;r4(c[m>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|1024;i=e;return}function gbb(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=Im;b=i;if(!(c[a+284>>2]&1024))d=a+156|0;else{e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=j+172|0}k=ea(-ea(g[d>>2]));i=b;return ea(k)}function hbb(a){a=a|0;return}function ibb(a){a=a|0;return}function jbb(a){a=a|0;return 1}function kbb(a){a=a|0;var b=0,c=0;b=i;c=a+12|0;zU(c,a);y2(a+20|0,LU(a)|0);AU(c,a);i=b;return}function lbb(a){a=a|0;var b=0;b=i;c[a>>2]=429424;J8(a+64|0);c[a>>2]=429696;xKa(a+28|0);xKa(a+20|0);c[a>>2]=429968;MU(a);i=b;return}function mbb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=429424;J8(a+64|0);c[a>>2]=429696;xKa(a+28|0);xKa(a+20|0);c[a>>2]=429968;MU(a);VJa(b,a);i=b;return}function nbb(a,b){a=a|0;b=b|0;var c=0;c=i;v2(a+20|0,b);xU(a+12|0,b);i=c;return}function obb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+20|0;g=b[a+24>>1]|0;if(g<<16>>16!=1){if(g<<16>>16){h=c[f>>2]|0;j=4}}else{h=f;j=4}if((j|0)==4){j=g&65535;g=0;do{f=h+(g<<2)|0;k=c[f>>2]|0;if(!k)l=0;else{m=xo[c[c[d>>2]>>2]&2047](d,-2147483648,k)|0;c[f>>2]=m;l=m}fTa(l+16|0)|0;g=g+1|0}while((g|0)!=(j|0))}yU(a+12|0,d);i=e;return}function pbb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+20|0;g=a+24|0;a=b[g>>1]|0;if(!(a<<16>>16)){i=e;return}h=a&65535;j=a;a=0;while(1){if(j<<16>>16==1)k=f;else k=c[f>>2]|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,c[k+(a<<2)>>2]|0);l=a+1|0;if((l|0)==(h|0))break;j=b[g>>1]|0;a=l}i=e;return}function qbb(a){a=a|0;var b=0;b=i;c[a>>2]=429696;xKa(a+28|0);xKa(a+20|0);c[a>>2]=429968;MU(a);i=b;return}function rbb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=429696;xKa(a+28|0);xKa(a+20|0);c[a>>2]=429968;MU(a);VJa(b,a);i=b;return}function sbb(a,b){a=a|0;b=b|0;var c=0;c=i;w2(a+20|0,b,a);i=c;return}function tbb(a){a=a|0;var b=0;b=i;AU(a+12|0,a);i=b;return}function ubb(a){a=a|0;var b=0;b=i;c[a>>2]=429968;MU(a);i=b;return}function vbb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=429968;MU(a);VJa(b,a);i=b;return}function wbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;mGb(a,b,c);i=d;return}function xbb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==2)if(!(a[(c[k>>2]|0)+2417>>0]|0))q=4;else r=k;else if((p|0)==3)r=k;else q=4;if((q|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[r>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[r>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function ybb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=a[d>>0]|0;d=b+(g+4)|0;k=c[d>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))o=4;else p=h;else if((n|0)==3)p=h;else o=4;if((o|0)==4){a[m+11>>0]=j;i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[p>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+3>>0]=j;r4(c[p>>2]|0,h);c[d>>2]=c[d>>2]|4;i=f;return}function zbb(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a+12|0,b);i=c;return}function Abb(a,b){a=a|0;b=b|0;var c=0;c=i;yU(a+12|0,b);i=c;return}function Bbb(a){a=a|0;return}function Cbb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Dbb(a){a=a|0;return}function Ebb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Fbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;MKa(c[a+12>>2]|0,ea(g[a+4>>2]),b,d);i=e;return}function Gbb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;var h=0;h=i;NKa(c[a+12>>2]|0,ea(g[a+8>>2]),b,d,e,f);i=h;return}function Hbb(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=ea(e);f=f|0;var h=0;h=i;OKa(c[a+12>>2]|0,ea(g[a+8>>2]),b,d,e,f);i=h;return}function Ibb(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=ea(e);f=f|0;var h=0;h=i;PKa(c[a+12>>2]|0,ea(g[a+8>>2]),b,d,e,f);i=h;return}function Jbb(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0;f=i;QKa(c[a+12>>2]|0,ea(g[a+8>>2]),b,d,e);i=f;return}function Kbb(b,c){b=b|0;c=c|0;a[b+128>>0]=c&1;return}function Lbb(b){b=b|0;return (a[b+128>>0]|0)!=0|0}function Mbb(a){a=a|0;return a+44|0}function Nbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;d=b+128|0;if(a[d>>0]|0){f=0;i=e;return f|0}g=b+56|0;c[b+124>>2]=c[g>>2];c[b+72>>2]=c[b+64>>2];a[d>>0]=1;c[g>>2]=b+76;c[b+60>>2]=1;f=1;i=e;return f|0}function Obb(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+128>>0]|0)){i=d;return}e=b+64|0;a[b+68>>0]=(c[e>>2]|0)!=0&1;c[e>>2]=c[b+72>>2];c[b+56>>2]=c[b+124>>2];i=d;return}function Pbb(a){a=a|0;return}function Qbb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Rbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;d=b+64|0;if(a[d>>0]|0){f=0;i=e;return f|0}g=b+24|0;c[b+60>>2]=c[g>>2];c[b+40>>2]=c[b+32>>2];a[d>>0]=1;c[g>>2]=b+44;c[b+28>>2]=1;f=1;i=e;return f|0}function Sbb(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+64>>0]|0)){i=d;return}e=b+32|0;a[b+36>>0]=(c[e>>2]|0)!=0&1;c[e>>2]=c[b+40>>2];c[b+24>>2]=c[b+60>>2];i=d;return}function Tbb(a){a=a|0;return}function Ubb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Vbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;d=b+160|0;if(a[d>>0]|0){f=0;i=e;return f|0}g=b+72|0;c[b+156>>2]=c[g>>2];c[b+88>>2]=c[b+80>>2];a[d>>0]=1;c[g>>2]=b+92;c[b+76>>2]=1;f=1;i=e;return f|0}function Wbb(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+160>>0]|0)){i=d;return}e=b+80|0;a[b+84>>0]=(c[e>>2]|0)!=0&1;c[e>>2]=c[b+88>>2];c[b+72>>2]=c[b+156>>2];i=d;return}function Xbb(a){a=a|0;return}function Ybb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Zbb(a){a=a|0;return 510896}function _bb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(510896,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function $bb(a,b){a=a|0;b=b|0;return}function acb(a){a=a|0;return 1}function bcb(a){a=a|0;return 434928}function ccb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(434928,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function dcb(a,b){a=a|0;b=b|0;return}function ecb(a){a=a|0;return}function fcb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function gcb(a){a=a|0;var b=0;b=i;if(!a){i=b;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);i=b;return}function hcb(a){a=a|0;return}function icb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function jcb(a){a=a|0;return a+60|0}function kcb(a){a=a|0;return}function lcb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function mcb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=i;KZ(c[108764]|0,b,0,e?2:1);i=d;return}function ncb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;a=i;i=i+16|0;e=a;f=b[d+4>>1]|0;if(f<<16>>16==3){c[d+224>>2]=c[107930];aRa(d);YLa(c[107930]|0,d,1);g=1;i=a;return g|0}else if(f<<16>>16==1){c[d+112>>2]=c[107930];gMa(c[107930]|0,d,1);g=1;i=a;return g|0}else{dKa(bKa()|0,32,436280,67,436368,e);g=0;i=a;return g|0}return 0}function ocb(a){a=a|0;return}function pcb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function qcb(a){a=a|0;return 517768}function rcb(a,b){a=a|0;b=b|0;var c=0;a=i;if((((HEi(517768,b)|0)!=0?(HEi(438352,b)|0)!=0:0)?(HEi(439088,b)|0)!=0:0)?(HEi(454712,b)|0)!=0:0)c=(HEi(b,543872)|0)==0;else c=1;i=a;return c|0}function scb(a){a=a|0;return 1}function tcb(a){a=a|0;var b=0,c=0;b=i;c=LU(a)|0;i=b;return c|0}function ucb(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function vcb(a){a=a|0;return c[a+12>>2]|0}function wcb(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+32|0;e=d;B2(e,b+20|0,b);f=ea(g[e>>2]);h=ea(g[e+12>>2]);j=ea(f+h);k=ea(g[e+4>>2]);l=ea(g[e+16>>2]);m=ea(k+l);n=ea(g[e+8>>2]);o=ea(g[e+20>>2]);p=ea(j*ea(.5));j=ea(m*ea(.5));m=ea(ea(n+o)*ea(.5));q=ea(ea(ea(h-f)*ea(.5))*c);f=ea(ea(ea(l-k)*ea(.5))*c);k=ea(ea(ea(o-n)*ea(.5))*c);c=ea(j-f);n=ea(m-k);o=ea(p+q);l=ea(j+f);f=ea(m+k);g[a>>2]=ea(p-q);g[a+4>>2]=c;g[a+8>>2]=n;g[a+12>>2]=o;g[a+16>>2]=l;g[a+20>>2]=f;i=d;return}function xcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((b|0)==8)oGb(a,c);pGb(a,b,c);i=d;return}function ycb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;oGb(d,(b[f>>1]&8)!=0);j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==3)q=k;else if((p|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)q=k;else r=4;if((r|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[q>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[q>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function zcb(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&1)){b[a>>1]=b[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+8>>1]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;b[a>>1]=b[l>>1]|0;i=f;return}function Acb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){g7(m,d);i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+2>>0]=d;r4(c[o>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function Bcb(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;g=b+f|0;h=c[b+(f+4)>>2]|0;if(!(h&2)){j=(c[450992+((h>>>24&15)<<2)>>2]|0)+g+12|0;k=a[j>>0]|0;i=d;return k|0}l=b+(f+8)|0;f=c[l>>2]|0;if(!f){b=s4(c[g>>2]|0,h>>>24&15)|0;c[l>>2]=b;m=b}else m=f;j=m+2|0;k=a[j>>0]|0;i=d;return k|0}function Ccb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(KU(b)|0){dKa(bKa()|0,8,453312,198,453392,g);i=f;return}h=c[427044+(e[b+4>>1]<<2)>>2]|0;j=b+h|0;k=c[b+(h+4)>>2]|0;h=k>>>30;if((h|0)==2)if(!(a[(c[j>>2]|0)+2417>>0]|0))l=5;else l=6;else if((h|0)==3)l=6;else l=5;if((l|0)==5){a[(c[450992+((k>>>24&15)<<2)>>2]|0)+j+13>>0]=d;i=f;return}else if((l|0)==6){dKa(bKa()|0,8,453464,153,453544,g);i=f;return}}function Dcb(b){b=b|0;var d=0;d=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;return a[(c[450992+(((c[b+(d+4)>>2]|0)>>>24&15)<<2)>>2]|0)+(b+d)+13>>0]|0}function Ecb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;if(!(k&4))l=(c[450992+((k>>>24&15)<<2)>>2]|0)+h+11|0;else{m=b+(g+8)|0;n=c[m>>2]|0;if(!n){o=s4(c[h>>2]|0,k>>>24&15)|0;c[m>>2]=o;p=o}else p=n;l=p+3|0}p=a[d>>0]|0;if((a[l>>0]|0)==p<<24>>24){i=f;return}l=c[j>>2]|0;d=l>>>24&15;n=(c[450992+(d<<2)>>2]|0)+h|0;o=l>>>30;if((o|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))q=10;else r=h;else if((o|0)==3)r=h;else q=10;if((q|0)==10){a[n+11>>0]=p;i=f;return}n=b+(g+8)|0;g=c[n>>2]|0;if(!g){b=s4(c[r>>2]|0,d)|0;c[n>>2]=b;s=b}else s=g;a[s+3>>0]=p;r4(c[r>>2]|0,h);c[j>>2]=c[j>>2]|4;i=f;return}function Fcb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&4)){a[b>>0]=a[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+11>>0]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;a[b>>0]=a[l+3>>0]|0;i=f;return}function Gcb(a){a=a|0;var b=0,c=0;b=i;c=GU(a+12|0)|0;i=b;return c|0}function Hcb(a,b){a=a|0;b=b|0;var c=0;c=i;qGb(a,b);i=c;return}function Icb(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j;if((b[d+24>>1]|0)==-1){l=0;i=j;return l|0}m=c[108764]|0;n=c[(c[m>>2]|0)+124>>2]|0;a[k>>0]=a[h>>0]|0;h=Km[n&127](m,e,f,g,1,k)|0;if(!h){l=0;i=j;return l|0}w2(d+20|0,h,d);G1(h);l=h;i=j;return l|0}function Jcb(a,b){a=a|0;b=b|0;var c=0;c=i;w2(a+20|0,b,a);i=c;return}function Kcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;x2(a+20|0,b,a,c);i=d;return}function Lcb(a){a=a|0;return e[a+24>>1]|0|0}function Mcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=A2(a+20|0,b,c,d)|0;i=e;return f|0}function Ncb(a){a=a|0;var b=0,c=0;b=i;c=EU(a+12|0,0)|0;i=b;return c|0}function Ocb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=b+16|0;b=c[h>>2]|0;if(!b){j=0;i=g;return j|0}if(!(c[b+40>>2]|0)){j=0;i=g;return j|0}else{k=b;l=0;m=0}while(1){b=c[k+36>>2]|0;if((m>>>0>=e>>>0?1:(a[b+(l<<3)>>0]|0)!=0)|l>>>0<f>>>0){n=k;o=m}else{c[d+(m<<2)>>2]=c[b+(l<<3)+4>>2];n=c[h>>2]|0;o=m+1|0}l=l+1|0;if(l>>>0>=(c[n+40>>2]|0)>>>0){j=o;break}else{k=n;m=o}}i=g;return j|0}function Pcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;if(!(c[b+284>>2]&512))e=b+112|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+144|0}g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);g[a+12>>2]=ea(g[e+12>>2]);g[a+16>>2]=ea(g[e+16>>2]);g[a+20>>2]=ea(g[e+20>>2]);g[a+24>>2]=ea(g[e+24>>2]);i=d;return}function Qcb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+48|0;if(d>ea(0.0))h=ea(ea(1.0)/d);else h=ea(0.0);j=b+64|0;k=c[b+52>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=6;if((n|0)==6){T8(j,h);i=e;return}j=b+56|0;n=c[j>>2]|0;if(!n){l=s4(c[m>>2]|0,k>>>24&15)|0;c[j>>2]=l;o=l}else o=n;g[o+92>>2]=h;r4(c[m>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|1;i=e;return}function Rcb(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0,k=Im;b=i;if(!(c[a+284>>2]&1))d=ea(S8(a+64|0));else{e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=ea(g[j+92>>2])}if(!(d>ea(0.0))){k=ea(0.0);i=b;return ea(k)}k=ea(ea(1.0)/d);i=b;return ea(k)}function Scb(a){a=a|0;var b=0,d=Im,e=0,f=0,h=0,j=0;b=i;if(!(c[a+284>>2]&1)){d=ea(S8(a+64|0));i=b;return ea(d)}e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=ea(g[j+92>>2]);i=b;return ea(d)}function Tcb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im;e=i;i=i+16|0;f=e;h=b+48|0;j=ea(g[d>>2]);if(j==ea(0.0))k=ea(0.0);else k=ea(ea(1.0)/j);j=ea(g[d+4>>2]);if(j==ea(0.0))l=ea(0.0);else l=ea(ea(1.0)/j);j=ea(g[d+8>>2]);if(j==ea(0.0))m=ea(0.0);else m=ea(ea(1.0)/j);g[f>>2]=k;d=f+4|0;g[d>>2]=l;n=f+8|0;g[n>>2]=m;o=b+64|0;p=c[b+52>>2]|0;q=p>>>30;if((q|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))r=10;else s=h;else if((q|0)==3)s=h;else r=10;if((r|0)==10){V8(o,f);i=e;return}o=b+56|0;r=c[o>>2]|0;if(!r){q=s4(c[s>>2]|0,p>>>24&15)|0;c[o>>2]=q;t=q;u=ea(g[f>>2])}else{t=r;u=k}g[t+96>>2]=u;g[t+100>>2]=ea(g[d>>2]);g[t+104>>2]=ea(g[n>>2]);r4(c[s>>2]|0,h);h=b+284|0;c[h>>2]=c[h>>2]|2;i=e;return}function Ucb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0;d=i;if(!(c[b+284>>2]&2))e=U8(b+64|0)|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+96|0}l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=ea(g[e+8>>2]);if(l==ea(0.0))o=ea(0.0);else o=ea(ea(1.0)/l);if(m==ea(0.0))p=ea(0.0);else p=ea(ea(1.0)/m);if(n==ea(0.0)){q=ea(0.0);g[a>>2]=o;r=a+4|0;g[r>>2]=p;s=a+8|0;g[s>>2]=q;i=d;return}q=ea(ea(1.0)/n);g[a>>2]=o;r=a+4|0;g[r>>2]=p;s=a+8|0;g[s>>2]=q;i=d;return}function Vcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;if(!(c[b+284>>2]&2))e=U8(b+64|0)|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+96|0}g[a>>2]=ea(g[e>>2]);g[a+4>>2]=ea(g[e+4>>2]);g[a+8>>2]=ea(g[e+8>>2]);i=d;return}function Wcb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+252>>2]);g[a+4>>2]=ea(g[b+256>>2]);g[a+8>>2]=ea(g[b+260>>2]);return}function Xcb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+264>>2]);g[a+4>>2]=ea(g[b+268>>2]);g[a+8>>2]=ea(g[b+272>>2]);return}function Ycb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[(c[a>>2]|0)+192>>2]&2047](a,b,d);i=e;return}function Zcb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[(c[b>>2]|0)+196>>2]|0;a[f>>0]=a[d>>0]|0;In[g&4095](b,f);i=e;return}function _cb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f+1|0;h=f;if(!(c[b+284>>2]&4096)){j=a[b+108>>0]|0;a[g>>0]=j;k=j}else{j=b+56|0;l=c[j>>2]|0;if(!l){m=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[j>>2]=m;n=m}else n=l;l=a[n+268>>0]|0;a[g>>0]=l;k=l}if(e)a[h>>0]=k&255|d;else a[h>>0]=k&((d^255)&255);rGb(b,g,h);i=f;return}function $cb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;if(!(c[b+284>>2]&4096))a[f>>0]=a[b+108>>0]|0;else{g=b+56|0;h=c[g>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[g>>2]=j;k=j}else k=h;a[f>>0]=a[k+268>>0]|0}rGb(b,f,d);i=e;return}function adb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if(!(c[d+284>>2]&4096)){a[b>>0]=a[d+108>>0]|0;i=e;return}f=d+56|0;g=c[f>>2]|0;if(!g){h=s4(c[d+48>>2]|0,(c[d+52>>2]|0)>>>24&15)|0;c[f>>2]=h;j=h}else j=g;a[b>>0]=a[j+268>>0]|0;i=e;return}function bdb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if(!(c[d+284>>2]&4096)){a[b>>0]=a[d+108>>0]|0;i=e;return}f=d+56|0;g=c[f>>2]|0;if(!g){h=s4(c[d+48>>2]|0,(c[d+52>>2]|0)>>>24&15)|0;c[f>>2]=h;j=h}else j=g;a[b>>0]=a[j+268>>0]|0;i=e;return}function cdb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+48|0;h=b+64|0;j=c[b+52>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){L8(h,d);i=e;return}h=b+56|0;m=c[h>>2]|0;if(!m){k=s4(c[l>>2]|0,j>>>24&15)|0;c[h>>2]=k;n=k}else n=m;g[n+124>>2]=d;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|64;i=e;return}function ddb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;if(!(c[a+284>>2]&64)){d=a+140|0;e=ea(g[d>>2]);i=b;return ea(e)}f=a+56|0;h=c[f>>2]|0;if(!h){j=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;d=k+124|0;e=ea(g[d>>2]);i=b;return ea(e)}function edb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+48|0;h=ea(-d);j=c[b+52>>2]|0;k=j>>>30;if((k|0)==3)l=f;else if((k|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)l=f;else m=4;if((m|0)==4){g[b+156>>2]=h;i=e;return}m=b+56|0;k=c[m>>2]|0;if(!k){n=s4(c[l>>2]|0,j>>>24&15)|0;c[m>>2]=n;o=n}else o=k;g[o+172>>2]=h;r4(c[l>>2]|0,f);f=b+284|0;c[f>>2]=c[f>>2]|1024;i=e;return}function fdb(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=Im;b=i;if(!(c[a+284>>2]&1024))d=a+156|0;else{e=a+56|0;f=c[e>>2]|0;if(!f){h=s4(c[a+48>>2]|0,(c[a+52>>2]|0)>>>24&15)|0;c[e>>2]=h;j=h}else j=f;d=j+172|0}k=ea(-ea(g[d>>2]));i=b;return ea(k)}function gdb(a,b){a=a|0;b=b|0;var c=0;c=i;v2(a+20|0,b);xU(a+12|0,b);i=c;return}function hdb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+20|0;g=b[a+24>>1]|0;if(g<<16>>16!=1){if(g<<16>>16){h=c[f>>2]|0;j=4}}else{h=f;j=4}if((j|0)==4){j=g&65535;g=0;do{f=h+(g<<2)|0;k=c[f>>2]|0;if(!k)l=0;else{m=xo[c[c[d>>2]>>2]&2047](d,-2147483648,k)|0;c[f>>2]=m;l=m}fTa(l+16|0)|0;g=g+1|0}while((g|0)!=(j|0))}yU(a+12|0,d);i=e;return}function idb(a){a=a|0;var b=0,c=0;b=i;c=a+12|0;zU(c,a);y2(a+20|0,LU(a)|0);AU(c,a);i=b;return}function jdb(a){a=a|0;var b=0;b=i;c[a>>2]=437040;J8(a+64|0);c[a>>2]=437376;xKa(a+28|0);xKa(a+20|0);c[a>>2]=437712;MU(a);i=b;return}function kdb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=437040;J8(a+64|0);c[a>>2]=437376;xKa(a+28|0);xKa(a+20|0);c[a>>2]=437712;MU(a);VJa(b,a);i=b;return}function ldb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+20|0;g=a+24|0;a=b[g>>1]|0;if(!(a<<16>>16)){i=e;return}h=a&65535;j=a;a=0;while(1){if(j<<16>>16==1)k=f;else k=c[f>>2]|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,c[k+(a<<2)>>2]|0);l=a+1|0;if((l|0)==(h|0))break;j=b[g>>1]|0;a=l}i=e;return}function mdb(a){a=a|0;return}function ndb(a){a=a|0;return}function odb(a){a=a|0;var b=0;b=i;c[a>>2]=437376;xKa(a+28|0);xKa(a+20|0);c[a>>2]=437712;MU(a);i=b;return}function pdb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=437376;xKa(a+28|0);xKa(a+20|0);c[a>>2]=437712;MU(a);VJa(b,a);i=b;return}function qdb(a,b){a=a|0;b=b|0;var c=0;c=i;w2(a+20|0,b,a);i=c;return}function rdb(a){a=a|0;var b=0;b=i;AU(a+12|0,a);i=b;return}function sdb(a){a=a|0;var b=0;b=i;c[a>>2]=437712;MU(a);i=b;return}function tdb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=437712;MU(a);VJa(b,a);i=b;return}function udb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;pGb(a,b,c);i=d;return}function vdb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==2)if(!(a[(c[k>>2]|0)+2417>>0]|0))q=4;else r=k;else if((p|0)==3)r=k;else q=4;if((q|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[r>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[r>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function wdb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=a[d>>0]|0;d=b+(g+4)|0;k=c[d>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))o=4;else p=h;else if((n|0)==3)p=h;else o=4;if((o|0)==4){a[m+11>>0]=j;i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[p>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+3>>0]=j;r4(c[p>>2]|0,h);c[d>>2]=c[d>>2]|4;i=f;return}function xdb(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a+12|0,b);i=c;return}function ydb(a,b){a=a|0;b=b|0;var c=0;c=i;yU(a+12|0,b);i=c;return}function zdb(a){a=a|0;return}function Adb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Bdb(a){a=a|0;return 439104}function Cdb(a,b){a=a|0;b=b|0;var c=0;a=i;if(((HEi(439104,b)|0)!=0?(HEi(439088,b)|0)!=0:0)?(HEi(454712,b)|0)!=0:0)c=(HEi(b,543872)|0)==0;else c=1;i=a;return c|0}function Ddb(a){a=a|0;return 0}function Edb(a){a=a|0;var b=0,c=0;b=i;c=LU(a)|0;i=b;return c|0}function Fdb(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function Gdb(a){a=a|0;return c[a+12>>2]|0}function Hdb(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+32|0;e=d;B2(e,b+20|0,b);f=ea(g[e>>2]);h=ea(g[e+12>>2]);j=ea(f+h);k=ea(g[e+4>>2]);l=ea(g[e+16>>2]);m=ea(k+l);n=ea(g[e+8>>2]);o=ea(g[e+20>>2]);p=ea(j*ea(.5));j=ea(m*ea(.5));m=ea(ea(n+o)*ea(.5));q=ea(ea(ea(h-f)*ea(.5))*c);f=ea(ea(ea(l-k)*ea(.5))*c);k=ea(ea(ea(o-n)*ea(.5))*c);c=ea(j-f);n=ea(m-k);o=ea(p+q);l=ea(j+f);f=ea(m+k);g[a>>2]=ea(p-q);g[a+4>>2]=c;g[a+8>>2]=n;g[a+12>>2]=o;g[a+16>>2]=l;g[a+20>>2]=f;i=d;return}function Idb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((b|0)==8)sGb(a,c);tGb(a,b,c);i=d;return}function Jdb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;sGb(d,(b[f>>1]&8)!=0);j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==3)q=k;else if((p|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)q=k;else r=4;if((r|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[q>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[q>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function Kdb(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&1)){b[a>>1]=b[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+8>>1]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;b[a>>1]=b[l>>1]|0;i=f;return}function Ldb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){g7(m,d);i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+2>>0]=d;r4(c[o>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function Mdb(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;g=b+f|0;h=c[b+(f+4)>>2]|0;if(!(h&2)){j=(c[450992+((h>>>24&15)<<2)>>2]|0)+g+12|0;k=a[j>>0]|0;i=d;return k|0}l=b+(f+8)|0;f=c[l>>2]|0;if(!f){b=s4(c[g>>2]|0,h>>>24&15)|0;c[l>>2]=b;m=b}else m=f;j=m+2|0;k=a[j>>0]|0;i=d;return k|0}function Ndb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(KU(b)|0){dKa(bKa()|0,8,453312,198,453392,g);i=f;return}h=c[427044+(e[b+4>>1]<<2)>>2]|0;j=b+h|0;k=c[b+(h+4)>>2]|0;h=k>>>30;if((h|0)==2)if(!(a[(c[j>>2]|0)+2417>>0]|0))l=5;else l=6;else if((h|0)==3)l=6;else l=5;if((l|0)==5){a[(c[450992+((k>>>24&15)<<2)>>2]|0)+j+13>>0]=d;i=f;return}else if((l|0)==6){dKa(bKa()|0,8,453464,153,453544,g);i=f;return}}function Odb(b){b=b|0;var d=0;d=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;return a[(c[450992+(((c[b+(d+4)>>2]|0)>>>24&15)<<2)>>2]|0)+(b+d)+13>>0]|0}function Pdb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;if(!(k&4))l=(c[450992+((k>>>24&15)<<2)>>2]|0)+h+11|0;else{m=b+(g+8)|0;n=c[m>>2]|0;if(!n){o=s4(c[h>>2]|0,k>>>24&15)|0;c[m>>2]=o;p=o}else p=n;l=p+3|0}p=a[d>>0]|0;if((a[l>>0]|0)==p<<24>>24){i=f;return}l=c[j>>2]|0;d=l>>>24&15;n=(c[450992+(d<<2)>>2]|0)+h|0;o=l>>>30;if((o|0)==3)q=h;else if((o|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)q=h;else r=10;if((r|0)==10){a[n+11>>0]=p;i=f;return}n=b+(g+8)|0;g=c[n>>2]|0;if(!g){b=s4(c[q>>2]|0,d)|0;c[n>>2]=b;s=b}else s=g;a[s+3>>0]=p;r4(c[q>>2]|0,h);c[j>>2]=c[j>>2]|4;i=f;return}function Qdb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&4)){a[b>>0]=a[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+11>>0]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;a[b>>0]=a[l+3>>0]|0;i=f;return}function Rdb(a){a=a|0;var b=0,c=0;b=i;c=GU(a+12|0)|0;i=b;return c|0}function Sdb(a,b){a=a|0;b=b|0;var c=0;c=i;w2(a+20|0,b,a);i=c;return}function Tdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;x2(a+20|0,b,a,c);i=d;return}function Udb(a){a=a|0;return e[a+24>>1]|0|0}function Vdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=A2(a+20|0,b,c,d)|0;i=e;return f|0}function Wdb(a){a=a|0;var b=0,c=0;b=i;c=EU(a+12|0,0)|0;i=b;return c|0}function Xdb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=b+16|0;b=c[h>>2]|0;if(!b){j=0;i=g;return j|0}if(!(c[b+40>>2]|0)){j=0;i=g;return j|0}else{k=b;l=0;m=0}while(1){b=c[k+36>>2]|0;if((m>>>0>=e>>>0?1:(a[b+(l<<3)>>0]|0)!=0)|l>>>0<f>>>0){n=k;o=m}else{c[d+(m<<2)>>2]=c[b+(l<<3)+4>>2];n=c[h>>2]|0;o=m+1|0}l=l+1|0;if(l>>>0>=(c[n+40>>2]|0)>>>0){j=o;break}else{k=n;m=o}}i=g;return j|0}function Ydb(a,b){a=a|0;b=b|0;var c=0;c=i;v2(a+20|0,b);xU(a+12|0,b);i=c;return}function Zdb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+20|0;g=b[a+24>>1]|0;if(g<<16>>16!=1){if(g<<16>>16){h=c[f>>2]|0;j=4}}else{h=f;j=4}if((j|0)==4){j=g&65535;g=0;do{f=h+(g<<2)|0;k=c[f>>2]|0;if(!k)l=0;else{m=xo[c[c[d>>2]>>2]&2047](d,-2147483648,k)|0;c[f>>2]=m;l=m}fTa(l+16|0)|0;g=g+1|0}while((g|0)!=(j|0))}yU(a+12|0,d);i=e;return}function _db(a){a=a|0;var b=0,c=0;b=i;c=a+12|0;zU(c,a);y2(a+20|0,LU(a)|0);AU(c,a);i=b;return}function $db(a){a=a|0;var b=0;b=i;c[a>>2]=438680;xKa(a+28|0);xKa(a+20|0);c[a>>2]=438832;MU(a);i=b;return}function aeb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=438680;xKa(a+28|0);xKa(a+20|0);c[a>>2]=438832;MU(a);VJa(b,a);i=b;return}function beb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+20|0;g=a+24|0;a=b[g>>1]|0;if(!(a<<16>>16)){i=e;return}h=a&65535;j=a;a=0;while(1){if(j<<16>>16==1)k=f;else k=c[f>>2]|0;In[c[(c[d>>2]|0)+8>>2]&4095](d,c[k+(a<<2)>>2]|0);l=a+1|0;if((l|0)==(h|0))break;j=b[g>>1]|0;a=l}i=e;return}function ceb(a){a=a|0;return}function deb(a){a=a|0;return}function eeb(a){a=a|0;var b=0;b=i;AU(a+12|0,a);i=b;return}function feb(a){a=a|0;var b=0;b=i;c[a>>2]=438832;MU(a);i=b;return}function geb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=438832;MU(a);VJa(b,a);i=b;return}function heb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;tGb(a,b,c);i=d;return}function ieb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==3)q=k;else if((p|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)q=k;else r=4;if((r|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[q>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[q>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function jeb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=a[d>>0]|0;d=b+(g+4)|0;k=c[d>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){a[m+11>>0]=j;i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+3>>0]=j;r4(c[o>>2]|0,h);c[d>>2]=c[d>>2]|4;i=f;return}function keb(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a+12|0,b);i=c;return}function leb(a,b){a=a|0;b=b|0;var c=0;c=i;yU(a+12|0,b);i=c;return}function meb(a){a=a|0;return}function neb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function oeb(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[a>>2]|0)+244>>2]&4095](a,b);i=d;return}function peb(a){a=a|0;return c[a+3680>>2]|0}function qeb(a){a=a|0;return c[a+3680>>2]|0}function reb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function seb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function teb(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+32>>2]&4095](a);i=b;return}function ueb(a){a=a|0;return c[a+24>>2]|0}function veb(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;In[c[(c[d>>2]|0)+96>>2]&4095](d,a);i=b;return}function web(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;In[c[(c[d>>2]|0)+92>>2]&4095](d,a);i=b;return}function xeb(a){a=a|0;return c[a+16>>2]|0}function yeb(a){a=a|0;var b=0,d=0;b=i;d=c[a+12>>2]|0;if(!d){i=b;return}ko[c[(c[d>>2]|0)+20>>2]&4095](d);i=b;return}function zeb(a){a=a|0;var b=0,d=0;b=i;d=c[a+20>>2]|0;Gca(d+32|0,ea(g[d+3660>>2]),c[a+12>>2]|0);i=b;return}function Aeb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Beb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ceb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Deb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Eeb(a){a=a|0;return c[a+24>>2]|0}function Feb(a){a=a|0;var b=0,d=0;b=i;d=c[a+20>>2]|0;Jca(d+32|0,ea(g[d+3660>>2]),c[a+12>>2]|0);i=b;return}function Geb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Heb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Ieb(a){a=a|0;return c[a+24>>2]|0}function Jeb(a){a=a|0;var b=0,d=0;b=i;d=c[a+20>>2]|0;Eca(d+32|0,ea(g[d+3660>>2]),c[a+12>>2]|0);i=b;return}function Keb(a){a=a|0;var b=0;b=i;c0a(a);i=b;return}function Leb(a){a=a|0;var b=0;b=i;c0a(a);ACi(a);i=b;return}function Meb(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+32>>2]&4095](a);i=b;return}function Neb(a){a=a|0;return c[a+16>>2]|0}function Oeb(b){b=b|0;var d=0,e=0;d=i;e=b+88|0;oTa(c[e>>2]|0);fTa(b+12|0)|0;a[b+84>>0]=1;pTa(c[e>>2]|0);i=d;return}function Peb(a){a=a|0;return c[a+12>>2]|0}function Qeb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+88|0;oTa(c[e>>2]|0);f=b+76|0;g=c[f>>2]|0;if(g){h=b+72|0;j=0;do{k=c[(c[h>>2]|0)+(j<<2)>>2]|0;ko[c[(c[k>>2]|0)+20>>2]&4095](k);j=j+1|0}while((j|0)!=(g|0))}c[f>>2]=0;if(!(a[b+84>>0]|0)){gTa(b+12|0)|0;l=c[e>>2]|0;pTa(l);i=d;return}else{ko[c[(c[b>>2]|0)+20>>2]&4095](b);l=c[e>>2]|0;pTa(l);i=d;return}}function Reb(a){a=a|0;return}function Seb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Teb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ueb(a){a=a|0;return 445616}function Veb(a){a=a|0;var b=0,d=0;b=i;d=c[a+12>>2]|0;JTa(c[c[a+20>>2]>>2]|0);if(!d){i=b;return}ko[c[(c[d>>2]|0)+20>>2]&4095](d);i=b;return}function Web(a){a=a|0;return}function Xeb(a){a=a|0;return}function Yeb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Zeb(a){a=a|0;return}function _eb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function $eb(a){a=a|0;return}function afb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bfb(a){a=a|0;return 447192}function cfb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(447192,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function dfb(a){a=a|0;return}function efb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function ffb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=b+52|0;if((a[g>>0]|0)==0?(h=c[b+44>>2]|0,j=c[b+36>>2]|0,(c[j+(h<<2)+72>>2]|0)>>>0>=e>>>0):0){R2(j,h,d,e)|0;k=0;i=f;return k|0}h=b+48|0;if(e){j=0;do{c[(c[h>>2]|0)+(j<<3)>>2]=c[d+(j<<4)>>2];c[(c[h>>2]|0)+(j<<3)+4>>2]=c[d+(j<<4)+4>>2];j=j+1|0}while((j|0)!=(e|0))}j=c[b+40>>2]|0;co[c[c[j>>2]>>2]&2047](j,e,c[h>>2]|0);a[g>>0]=1;k=1;i=f;return k|0}function gfb(a){a=a|0;return}function hfb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function ifb(a){a=a|0;var b=0,d=0,e=0;b=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);AU(a+12|0,a);d=LU(a)|0;if(!d){e=a+20|0;v3(e);i=b;return}L0(d,a);g4(d+16|0,a+20|0,1);e=a+20|0;v3(e);i=b;return}function jfb(a){a=a|0;return 449336}function kfb(a,b){a=a|0;b=b|0;var c=0;a=i;if(((HEi(449336,b)|0)!=0?(HEi(450928,b)|0)!=0:0)?(HEi(454712,b)|0)!=0:0)c=(HEi(b,543872)|0)==0;else c=1;i=a;return c|0}function lfb(a){a=a|0;return 3}function mfb(a){a=a|0;var b=0,c=0;b=i;c=LU(a)|0;i=b;return c|0}function nfb(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function ofb(a){a=a|0;return c[a+12>>2]|0}function pfb(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;f=i;i=i+32|0;h=f;j=f+8|0;k=(c[d+24>>2]|0)>>>30;if((k|0)==3)l=3;else if((k|0)==2?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0)l=3;else l=4;if((l|0)==3)dKa(bKa()|0,2,449960,452,450048,h);else if((l|0)==4)Kha(j,d+32|0);m=ea(g[j>>2]);n=ea(g[j+12>>2]);o=ea(m+n);p=ea(g[j+4>>2]);q=ea(g[j+16>>2]);r=ea(p+q);s=ea(g[j+8>>2]);t=ea(g[j+20>>2]);u=ea(o*ea(.5));o=ea(r*ea(.5));r=ea(ea(s+t)*ea(.5));v=ea(ea(ea(n-m)*ea(.5))*e);m=ea(ea(ea(q-p)*ea(.5))*e);p=ea(ea(ea(t-s)*ea(.5))*e);e=ea(o-m);s=ea(r-p);t=ea(u+v);q=ea(o+m);m=ea(r+p);g[b>>2]=ea(u-v);g[b+4>>2]=e;g[b+8>>2]=s;g[b+12>>2]=t;g[b+16>>2]=q;g[b+20>>2]=m;i=f;return}function qfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;uGb(a,b,c);i=d;return}function rfb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==3)q=k;else if((p|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)q=k;else r=4;if((r|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[q>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[q>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function sfb(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&1)){b[a>>1]=b[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+8>>1]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;b[a>>1]=b[l>>1]|0;i=f;return}function tfb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){g7(m,d);i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+2>>0]=d;r4(c[o>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function ufb(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;g=b+f|0;h=c[b+(f+4)>>2]|0;if(!(h&2)){j=(c[450992+((h>>>24&15)<<2)>>2]|0)+g+12|0;k=a[j>>0]|0;i=d;return k|0}l=b+(f+8)|0;f=c[l>>2]|0;if(!f){b=s4(c[g>>2]|0,h>>>24&15)|0;c[l>>2]=b;m=b}else m=f;j=m+2|0;k=a[j>>0]|0;i=d;return k|0}function vfb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(KU(b)|0){dKa(bKa()|0,8,453312,198,453392,g);i=f;return}h=c[427044+(e[b+4>>1]<<2)>>2]|0;j=b+h|0;k=c[b+(h+4)>>2]|0;h=k>>>30;if((h|0)==2)if(!(a[(c[j>>2]|0)+2417>>0]|0))l=5;else l=6;else if((h|0)==3)l=6;else l=5;if((l|0)==5){a[(c[450992+((k>>>24&15)<<2)>>2]|0)+j+13>>0]=d;i=f;return}else if((l|0)==6){dKa(bKa()|0,8,453464,153,453544,g);i=f;return}}function wfb(b){b=b|0;var d=0;d=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;return a[(c[450992+(((c[b+(d+4)>>2]|0)>>>24&15)<<2)>>2]|0)+(b+d)+13>>0]|0}function xfb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=a[d>>0]|0;d=b+(g+4)|0;k=c[d>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))o=4;else p=h;else if((n|0)==3)p=h;else o=4;if((o|0)==4){a[m+11>>0]=j;i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[p>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+3>>0]=j;r4(c[p>>2]|0,h);c[d>>2]=c[d>>2]|4;i=f;return}function yfb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&4)){a[b>>0]=a[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+11>>0]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;a[b>>0]=a[l+3>>0]|0;i=f;return}function zfb(a){a=a|0;var b=0,c=0;b=i;c=GU(a+12|0)|0;i=b;return c|0}function Afb(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[e>>0]=a[c>>0]|0;c=vGb(b+20|0,e)|0;i=d;return c|0}function Bfb(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c;a[d>>0]=1;e=vGb(b+20|0,d)|0;i=c;return e|0}function Cfb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;if(!(c[d>>2]|0)){g=1;i=e;return g|0}h=a+20|0;j=c[a+24>>2]|0;if(!(j&32768))lha(f,a+32|0);else{k=a+28|0;a=c[k>>2]|0;if(!a){l=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=l;m=l}else m=a;b[f>>1]=b[m+76>>1]|0}g=C3(h,d)|0;i=e;return g|0}function Dfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if(!b){i=d;return}D3(a+20|0,b,c);i=d;return}function Efb(a){a=a|0;var b=0;b=i;E3(a+20|0);i=b;return}function Ffb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;if(!b){i=e;return}F3(a+20|0,b,c,d);i=e;return}function Gfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;if(!b){i=e;return}G3(a+20|0,b,c,d);i=e;return}function Hfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;if(!b){i=e;return}H3(a+20|0,b,c,d);i=e;return}function Ifb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+16|0;if(!(LU(a)|0)){dKa(bKa()|0,8,449616,436,449880,f);i=f;return}if(!b){i=f;return}I3(a+20|0,b,c,d,e);i=f;return}function Jfb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&128)){e=ea(_ga(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+12>>2]);i=b;return ea(e)}function Kfb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){$ga(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+12>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|128;i=e;return}function Lfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b+24>>2]|0;if(!(e&256))f=Lha(b+32|0)|0;else{h=b+28|0;j=c[h>>2]|0;if(!j){k=s4(c[b+20>>2]|0,e>>>24&15)|0;c[h>>2]=k;l=k}else l=j;f=l+16|0}g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);i=d;return}function Mfb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){Oga(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+16>>2]=ea(g[d>>2]);g[o+20>>2]=ea(g[d+4>>2]);g[o+24>>2]=ea(g[d+8>>2]);r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|256;i=e;return}function Nfb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;e=i;f=c[a+24>>2]|0;if(!(f&512))h=Mha(a+32|0)|0;else{j=a+28|0;k=c[j>>2]|0;if(!k){l=s4(c[a+20>>2]|0,f>>>24&15)|0;c[j>>2]=l;m=l}else m=k;h=m+28|0}n=ea(g[h>>2]);o=ea(g[h+4>>2]);p=ea(g[h+8>>2]);q=ea(g[h+12>>2]);g[b>>2]=n;g[b+4>>2]=o;g[b+8>>2]=p;g[d>>2]=q;i=e;return}function Ofb(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im;f=i;i=i+16|0;h=f;j=ea(g[d>>2]);g[h>>2]=j;k=h+4|0;g[k>>2]=ea(g[d+4>>2]);l=h+8|0;g[l>>2]=ea(g[d+8>>2]);d=h+12|0;g[d>>2]=e;m=b+20|0;n=b+32|0;o=b+24|0;p=c[o>>2]|0;q=p>>>30;if((q|0)==2)if(!(a[(c[m>>2]|0)+2417>>0]|0))r=4;else s=m;else if((q|0)==3)s=m;else r=4;if((r|0)==4){Nha(n,h);i=f;return}n=b+28|0;b=c[n>>2]|0;if(!b){r=s4(c[s>>2]|0,p>>>24&15)|0;c[n>>2]=r;t=r;u=ea(g[h>>2])}else{t=b;u=j}g[t+28>>2]=u;g[t+32>>2]=ea(g[k>>2]);g[t+36>>2]=ea(g[l>>2]);g[t+40>>2]=ea(g[d>>2]);r4(c[s>>2]|0,m);c[o>>2]=c[o>>2]|512;i=f;return}function Pfb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&1024)){e=ea(aha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+44>>2]);i=b;return ea(e)}function Qfb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){bha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+44>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|1024;i=e;return}function Rfb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&2048)){e=ea(cha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+48>>2]);i=b;return ea(e)}function Sfb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){dha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+48>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|2048;i=e;return}function Tfb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&4096)){e=ea(eha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+52>>2]);i=b;return ea(e)}function Ufb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){fha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+52>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|4096;i=e;return}function Vfb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&8192)){e=ea(gha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+56>>2]);i=b;return ea(e)}function Wfb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){hha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+56>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|8192;i=e;return}function Xfb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+20|0;g=b+32|0;h=b+24|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))l=4;else m=f;else if((k|0)==3)m=f;else l=4;if((l|0)==4){jha(g,d);i=e;return}g=b+28|0;b=c[g>>2]|0;if(!b){l=s4(c[m>>2]|0,j>>>24&15)|0;c[g>>2]=l;n=l}else n=b;b=n+60|0;c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];r4(c[m>>2]|0,f);c[h>>2]=c[h>>2]|16384;i=e;return}function Yfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+24>>2]|0;if(!(e&16384))f=iha(b+32|0)|0;else{g=b+28|0;h=c[g>>2]|0;if(!h){j=s4(c[b+20>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=k+60|0};c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function Zfb(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;dKa(bKa()|0,1,449616,611,449808,b);d=KU(a)|0;if(!d){i=b;return}In[c[(c[d>>2]|0)+212>>2]&4095](d,a);i=b;return}function _fb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+16|0;j=h;k=h+4|0;if((f|0)==16){dKa(bKa()|0,2,449616,627,449712,j);i=h;return}l=d+20|0;m=d+24|0;n=c[m>>2]|0;if(!(n&32768))lha(k,d+32|0);else{o=d+28|0;p=c[o>>2]|0;if(!p){q=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=q;r=q}else r=p;b[k>>1]=b[r+76>>1]|0}if(g){g=(e[k>>1]|f)&65535;b[k>>1]=g;s=g}else{g=b[k>>1]&((f^65535)&65535);b[k>>1]=g;s=g}g=d+32|0;k=c[m>>2]|0;f=k>>>30;if((f|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))t=14;else{u=l;t=15}else if((f|0)==3){u=l;t=15}else t=14;if((t|0)==14){b[j>>1]=s;mha(g,j)}else if((t|0)==15){t=d+28|0;j=c[t>>2]|0;if(!j){g=s4(c[u>>2]|0,k>>>24&15)|0;c[t>>2]=g;v=g}else v=j;b[v+76>>1]=s;r4(c[u>>2]|0,l);c[m>>2]=c[m>>2]|32768}if(!(LU(d)|0)){i=h;return}LU(d)|0;i=h;return}function $fb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[d+24>>2]|0;if(!(f&32768)){lha(a,d+32|0);i=e;return}g=d+28|0;h=c[g>>2]|0;if(!h){j=s4(c[d+20>>2]|0,f>>>24&15)|0;c[g>>2]=j;k=j}else k=h;b[a>>1]=b[k+76>>1]|0;i=e;return}function agb(a){a=a|0;var b=0,c=0;b=i;c=rha(a+32|0)|0;i=b;return c|0}function bgb(a){a=a|0;var b=0,c=Im;b=i;c=ea(sha(a+32|0));i=b;return ea(c)}function cgb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==2)g=2;else if((f|0)==3){i=e;return}if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}tha(b+32|0,d);i=e;return}function dgb(a){a=a|0;var b=0,c=Im;b=i;c=ea(uha(a+32|0));i=b;return ea(c)}function egb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==3){i=e;return}else if((f|0)==2)g=2;if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}vha(b+32|0,d);i=e;return}function fgb(a){a=a|0;var b=0,c=Im;b=i;c=ea(wha(a+32|0));i=b;return ea(c)}function ggb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==2)g=2;else if((f|0)==3){i=e;return}if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}xha(b+32|0,d);i=e;return}function hgb(a){a=a|0;var b=0,c=Im;b=i;c=ea(Aha(a+32|0));i=b;return ea(c)}function igb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==3){i=e;return}else if((f|0)==2)g=2;if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}Bha(b+32|0,d);i=e;return}function jgb(a,b){a=a|0;b=b|0;var c=0;c=i;pha(a,b+32|0);i=c;return}function kgb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+2|0;k=h;l=d+32|0;pha(k,l);if(g){g=(e[k>>1]|f)&65535;b[k>>1]=g;m=g}else{g=b[k>>1]&((f^65535)&65535);b[k>>1]=g;m=g}g=(c[d+24>>2]|0)>>>30;if((g|0)==3){i=h;return}else if((g|0)==2)n=5;if((n|0)==5?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0){i=h;return}b[j>>1]=m;qha(l,j);i=h;return}function lgb(a,b){a=a|0;b=b|0;var c=0;c=i;Qga(a+32|0,b);i=c;return}function mgb(a,b){a=a|0;b=b|0;var c=0;c=i;yU(a+12|0,b);i=c;return}function ngb(a,b){a=a|0;b=b|0;return}function ogb(b,c){b=b|0;c=c|0;a[b>>0]=a[c+201>>0]|0;return}function pgb(b){b=b|0;a[b+72>>0]=0;return}function qgb(a){a=a|0;return}function rgb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function sgb(b,c){b=b|0;c=c|0;a[b+201>>0]=a[c>>0]|0;return}function tgb(a){a=a|0;var b=0;b=i;c[a>>2]=448488;B3(a+20|0);c[a>>2]=448776;MU(a);i=b;return}function ugb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=448488;B3(a+20|0);c[a>>2]=448776;MU(a);VJa(b,a);i=b;return}function vgb(a){a=a|0;return 2}function wgb(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a+12|0,b);i=c;return}function xgb(a){a=a|0;var b=0;b=i;AU(a+12|0,a);i=b;return}function ygb(a){a=a|0;var b=0;b=i;c[a>>2]=448776;MU(a);i=b;return}function zgb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=448776;MU(a);VJa(b,a);i=b;return}function Agb(a){a=a|0;return}function Bgb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Cgb(a){a=a|0;var b=0,d=0,e=0;b=i;KZ(c[108764]|0,a,c[a+8>>2]|0,1);AU(a+12|0,a);d=LU(a)|0;if(!d){e=a+20|0;v3(e);i=b;return}L0(d,a);g4(d+16|0,a+20|0,1);e=a+20|0;v3(e);i=b;return}function Dgb(a){a=a|0;return 450944}function Egb(a,b){a=a|0;b=b|0;var c=0;a=i;if(((HEi(450944,b)|0)!=0?(HEi(450928,b)|0)!=0:0)?(HEi(454712,b)|0)!=0:0)c=(HEi(b,543872)|0)==0;else c=1;i=a;return c|0}function Fgb(a){a=a|0;return 2}function Ggb(a){a=a|0;var b=0,c=0;b=i;c=LU(a)|0;i=b;return c|0}function Hgb(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function Igb(a){a=a|0;return c[a+12>>2]|0}function Jgb(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;f=i;i=i+32|0;h=f;j=f+8|0;k=(c[d+24>>2]|0)>>>30;if((k|0)==2)if(!(a[(c[d+20>>2]|0)+2417>>0]|0))l=4;else l=3;else if((k|0)==3)l=3;else l=4;if((l|0)==3)dKa(bKa()|0,2,449960,452,450048,h);else if((l|0)==4)Kha(j,d+32|0);m=ea(g[j>>2]);n=ea(g[j+12>>2]);o=ea(m+n);p=ea(g[j+4>>2]);q=ea(g[j+16>>2]);r=ea(p+q);s=ea(g[j+8>>2]);t=ea(g[j+20>>2]);u=ea(o*ea(.5));o=ea(r*ea(.5));r=ea(ea(s+t)*ea(.5));v=ea(ea(ea(n-m)*ea(.5))*e);m=ea(ea(ea(q-p)*ea(.5))*e);p=ea(ea(ea(t-s)*ea(.5))*e);e=ea(o-m);s=ea(r-p);t=ea(u+v);q=ea(o+m);m=ea(r+p);g[b>>2]=ea(u-v);g[b+4>>2]=e;g[b+8>>2]=s;g[b+12>>2]=t;g[b+16>>2]=q;g[b+20>>2]=m;i=f;return}function Kgb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wGb(a,b,c);i=d;return}function Lgb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==3)q=k;else if((p|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0)q=k;else r=4;if((r|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[q>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[q>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function Mgb(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&1)){b[a>>1]=b[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+8>>1]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;b[a>>1]=b[l>>1]|0;i=f;return}function Ngb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){g7(m,d);i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+2>>0]=d;r4(c[o>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function Ogb(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;g=b+f|0;h=c[b+(f+4)>>2]|0;if(!(h&2)){j=(c[450992+((h>>>24&15)<<2)>>2]|0)+g+12|0;k=a[j>>0]|0;i=d;return k|0}l=b+(f+8)|0;f=c[l>>2]|0;if(!f){b=s4(c[g>>2]|0,h>>>24&15)|0;c[l>>2]=b;m=b}else m=f;j=m+2|0;k=a[j>>0]|0;i=d;return k|0}function Pgb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(KU(b)|0){dKa(bKa()|0,8,453312,198,453392,g);i=f;return}h=c[427044+(e[b+4>>1]<<2)>>2]|0;j=b+h|0;k=c[b+(h+4)>>2]|0;h=k>>>30;if((h|0)==2)if(!(a[(c[j>>2]|0)+2417>>0]|0))l=5;else l=6;else if((h|0)==3)l=6;else l=5;if((l|0)==5){a[(c[450992+((k>>>24&15)<<2)>>2]|0)+j+13>>0]=d;i=f;return}else if((l|0)==6){dKa(bKa()|0,8,453464,153,453544,g);i=f;return}}function Qgb(b){b=b|0;var d=0;d=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;return a[(c[450992+(((c[b+(d+4)>>2]|0)>>>24&15)<<2)>>2]|0)+(b+d)+13>>0]|0}function Rgb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=a[d>>0]|0;d=b+(g+4)|0;k=c[d>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){a[m+11>>0]=j;i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+3>>0]=j;r4(c[o>>2]|0,h);c[d>>2]=c[d>>2]|4;i=f;return}function Sgb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&4)){a[b>>0]=a[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+11>>0]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;a[b>>0]=a[l+3>>0]|0;i=f;return}function Tgb(a){a=a|0;var b=0,c=0;b=i;c=GU(a+12|0)|0;i=b;return c|0}function Ugb(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[e>>0]=a[c>>0]|0;c=vGb(b+20|0,e)|0;i=d;return c|0}function Vgb(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c;a[d>>0]=1;e=vGb(b+20|0,d)|0;i=c;return e|0}function Wgb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;if(!(c[d>>2]|0)){g=1;i=e;return g|0}h=a+20|0;j=c[a+24>>2]|0;if(!(j&32768))lha(f,a+32|0);else{k=a+28|0;a=c[k>>2]|0;if(!a){l=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=l;m=l}else m=a;b[f>>1]=b[m+76>>1]|0}g=C3(h,d)|0;i=e;return g|0}function Xgb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if(!b){i=d;return}D3(a+20|0,b,c);i=d;return}function Ygb(a){a=a|0;var b=0;b=i;E3(a+20|0);i=b;return}function Zgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;if(!b){i=e;return}F3(a+20|0,b,c,d);i=e;return}function _gb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;if(!b){i=e;return}G3(a+20|0,b,c,d);i=e;return}function $gb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;if(!b){i=e;return}H3(a+20|0,b,c,d);i=e;return}function ahb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+16|0;if(!(LU(a)|0)){dKa(bKa()|0,8,449616,436,449880,f);i=f;return}if(!b){i=f;return}I3(a+20|0,b,c,d,e);i=f;return}function bhb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&128)){e=ea(_ga(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+12>>2]);i=b;return ea(e)}function chb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){$ga(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+12>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|128;i=e;return}function dhb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b+24>>2]|0;if(!(e&256))f=Lha(b+32|0)|0;else{h=b+28|0;j=c[h>>2]|0;if(!j){k=s4(c[b+20>>2]|0,e>>>24&15)|0;c[h>>2]=k;l=k}else l=j;f=l+16|0}g[a>>2]=ea(g[f>>2]);g[a+4>>2]=ea(g[f+4>>2]);g[a+8>>2]=ea(g[f+8>>2]);i=d;return}function ehb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){Oga(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+16>>2]=ea(g[d>>2]);g[o+20>>2]=ea(g[d+4>>2]);g[o+24>>2]=ea(g[d+8>>2]);r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|256;i=e;return}function fhb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;e=i;f=c[a+24>>2]|0;if(!(f&512))h=Mha(a+32|0)|0;else{j=a+28|0;k=c[j>>2]|0;if(!k){l=s4(c[a+20>>2]|0,f>>>24&15)|0;c[j>>2]=l;m=l}else m=k;h=m+28|0}n=ea(g[h>>2]);o=ea(g[h+4>>2]);p=ea(g[h+8>>2]);q=ea(g[h+12>>2]);g[b>>2]=n;g[b+4>>2]=o;g[b+8>>2]=p;g[d>>2]=q;i=e;return}function ghb(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im;f=i;i=i+16|0;h=f;j=ea(g[d>>2]);g[h>>2]=j;k=h+4|0;g[k>>2]=ea(g[d+4>>2]);l=h+8|0;g[l>>2]=ea(g[d+8>>2]);d=h+12|0;g[d>>2]=e;m=b+20|0;n=b+32|0;o=b+24|0;p=c[o>>2]|0;q=p>>>30;if((q|0)==3)r=m;else if((q|0)==2?(a[(c[m>>2]|0)+2417>>0]|0)!=0:0)r=m;else s=4;if((s|0)==4){Nha(n,h);i=f;return}n=b+28|0;b=c[n>>2]|0;if(!b){s=s4(c[r>>2]|0,p>>>24&15)|0;c[n>>2]=s;t=s;u=ea(g[h>>2])}else{t=b;u=j}g[t+28>>2]=u;g[t+32>>2]=ea(g[k>>2]);g[t+36>>2]=ea(g[l>>2]);g[t+40>>2]=ea(g[d>>2]);r4(c[r>>2]|0,m);c[o>>2]=c[o>>2]|512;i=f;return}function hhb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&1024)){e=ea(aha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+44>>2]);i=b;return ea(e)}function ihb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){bha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+44>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|1024;i=e;return}function jhb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&2048)){e=ea(cha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+48>>2]);i=b;return ea(e)}function khb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){dha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+48>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|2048;i=e;return}function lhb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&4096)){e=ea(eha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+52>>2]);i=b;return ea(e)}function mhb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))m=4;else n=f;else if((l|0)==3)n=f;else m=4;if((m|0)==4){fha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){m=s4(c[n>>2]|0,k>>>24&15)|0;c[h>>2]=m;o=m}else o=b;g[o+52>>2]=d;r4(c[n>>2]|0,f);c[j>>2]=c[j>>2]|4096;i=e;return}function nhb(a){a=a|0;var b=0,d=0,e=Im,f=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!(d&8192)){e=ea(gha(a+32|0));i=b;return ea(e)}f=a+28|0;h=c[f>>2]|0;if(!h){j=s4(c[a+20>>2]|0,d>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=ea(g[k+56>>2]);i=b;return ea(e)}function ohb(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+20|0;h=b+32|0;j=b+24|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==3)m=f;else if((l|0)==2?(a[(c[f>>2]|0)+2417>>0]|0)!=0:0)m=f;else n=4;if((n|0)==4){hha(h,d);i=e;return}h=b+28|0;b=c[h>>2]|0;if(!b){n=s4(c[m>>2]|0,k>>>24&15)|0;c[h>>2]=n;o=n}else o=b;g[o+56>>2]=d;r4(c[m>>2]|0,f);c[j>>2]=c[j>>2]|8192;i=e;return}function phb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+20|0;g=b+32|0;h=b+24|0;j=c[h>>2]|0;k=j>>>30;if((k|0)==2)if(!(a[(c[f>>2]|0)+2417>>0]|0))l=4;else m=f;else if((k|0)==3)m=f;else l=4;if((l|0)==4){jha(g,d);i=e;return}g=b+28|0;b=c[g>>2]|0;if(!b){l=s4(c[m>>2]|0,j>>>24&15)|0;c[g>>2]=l;n=l}else n=b;b=n+60|0;c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];r4(c[m>>2]|0,f);c[h>>2]=c[h>>2]|16384;i=e;return}function qhb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+24>>2]|0;if(!(e&16384))f=iha(b+32|0)|0;else{g=b+28|0;h=c[g>>2]|0;if(!h){j=s4(c[b+20>>2]|0,e>>>24&15)|0;c[g>>2]=j;k=j}else k=h;f=k+60|0};c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function rhb(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;dKa(bKa()|0,1,449616,611,449808,b);d=KU(a)|0;if(!d){i=b;return}In[c[(c[d>>2]|0)+212>>2]&4095](d,a);i=b;return}function shb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+16|0;j=h;k=h+4|0;if((f|0)==16){dKa(bKa()|0,2,449616,627,449712,j);i=h;return}l=d+20|0;m=d+24|0;n=c[m>>2]|0;if(!(n&32768))lha(k,d+32|0);else{o=d+28|0;p=c[o>>2]|0;if(!p){q=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=q;r=q}else r=p;b[k>>1]=b[r+76>>1]|0}if(g){g=(e[k>>1]|f)&65535;b[k>>1]=g;s=g}else{g=b[k>>1]&((f^65535)&65535);b[k>>1]=g;s=g}g=d+32|0;k=c[m>>2]|0;f=k>>>30;if((f|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))t=14;else{u=l;t=15}else if((f|0)==3){u=l;t=15}else t=14;if((t|0)==14){b[j>>1]=s;mha(g,j)}else if((t|0)==15){t=d+28|0;j=c[t>>2]|0;if(!j){g=s4(c[u>>2]|0,k>>>24&15)|0;c[t>>2]=g;v=g}else v=j;b[v+76>>1]=s;r4(c[u>>2]|0,l);c[m>>2]=c[m>>2]|32768}if(!(LU(d)|0)){i=h;return}LU(d)|0;i=h;return}function thb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[d+24>>2]|0;if(!(f&32768)){lha(a,d+32|0);i=e;return}g=d+28|0;h=c[g>>2]|0;if(!h){j=s4(c[d+20>>2]|0,f>>>24&15)|0;c[g>>2]=j;k=j}else k=h;b[a>>1]=b[k+76>>1]|0;i=e;return}function uhb(a){a=a|0;var b=0,c=0;b=i;c=rha(a+32|0)|0;i=b;return c|0}function vhb(a){a=a|0;var b=0,c=Im;b=i;c=ea(sha(a+32|0));i=b;return ea(c)}function whb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==3){i=e;return}else if((f|0)==2)g=2;if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}tha(b+32|0,d);i=e;return}function xhb(a){a=a|0;var b=0,c=Im;b=i;c=ea(uha(a+32|0));i=b;return ea(c)}function yhb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==3){i=e;return}else if((f|0)==2)g=2;if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}vha(b+32|0,d);i=e;return}function zhb(a){a=a|0;var b=0,c=Im;b=i;c=ea(wha(a+32|0));i=b;return ea(c)}function Ahb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==3){i=e;return}else if((f|0)==2)g=2;if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}xha(b+32|0,d);i=e;return}function Bhb(a){a=a|0;var b=0,c=Im;b=i;c=ea(Aha(a+32|0));i=b;return ea(c)}function Chb(b,d){b=b|0;d=ea(d);var e=0,f=0,g=0;e=i;f=(c[b+24>>2]|0)>>>30;if((f|0)==2)g=2;else if((f|0)==3){i=e;return}if((g|0)==2?(a[(c[b+20>>2]|0)+2417>>0]|0)!=0:0){i=e;return}Bha(b+32|0,d);i=e;return}function Dhb(a,b){a=a|0;b=b|0;var c=0;c=i;pha(a,b+32|0);i=c;return}function Ehb(a,b){a=a|0;b=b|0;var c=0;c=i;Qga(a+32|0,b);i=c;return}function Fhb(a,b){a=a|0;b=b|0;var c=0;c=i;yU(a+12|0,b);i=c;return}function Ghb(a,b){a=a|0;b=b|0;return}function Hhb(a){a=a|0;var b=0;b=i;c[a>>2]=450176;B3(a+20|0);c[a>>2]=450432;MU(a);i=b;return}function Ihb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=450176;B3(a+20|0);c[a>>2]=450432;MU(a);VJa(b,a);i=b;return}function Jhb(a){a=a|0;return 2}function Khb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+2|0;k=h;l=d+32|0;pha(k,l);if(g){g=(e[k>>1]|f)&65535;b[k>>1]=g;m=g}else{g=b[k>>1]&((f^65535)&65535);b[k>>1]=g;m=g}g=(c[d+24>>2]|0)>>>30;if((g|0)==3){i=h;return}else if((g|0)==2)n=5;if((n|0)==5?(a[(c[d+20>>2]|0)+2417>>0]|0)!=0:0){i=h;return}b[j>>1]=m;qha(l,j);i=h;return}function Lhb(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a+12|0,b);i=c;return}function Mhb(a){a=a|0;var b=0;b=i;AU(a+12|0,a);i=b;return}function Nhb(a){a=a|0;var b=0;b=i;c[a>>2]=450432;MU(a);i=b;return}function Ohb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=450432;MU(a);VJa(b,a);i=b;return}function Phb(a){a=a|0;return}function Qhb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Rhb(a){a=a|0;return 454720}function Shb(a,b){a=a|0;b=b|0;var c=0;a=i;if((HEi(454720,b)|0)!=0?(HEi(454712,b)|0)!=0:0)c=(HEi(b,543872)|0)==0;else c=1;i=a;return c|0}function Thb(a){a=a|0;var b=0,c=0;b=i;c=LU(a)|0;i=b;return c|0}function Uhb(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function Vhb(a){a=a|0;return c[a+12>>2]|0}function Whb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;xGb(a,b,c);i=d;return}function Xhb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=b[f>>1]|0;f=c[427044+(e[d+4>>1]<<2)>>2]|0;k=d+f|0;l=d+(f+4)|0;m=c[l>>2]|0;n=m>>>24&15;o=(c[450992+(n<<2)>>2]|0)+k|0;p=m>>>30;if((p|0)==2)if(!(a[(c[k>>2]|0)+2417>>0]|0))q=4;else r=k;else if((p|0)==3)r=k;else q=4;if((q|0)==4){b[h>>1]=j;f7(o,h);i=g;return}h=d+(f+8)|0;f=c[h>>2]|0;if(!f){d=s4(c[r>>2]|0,n)|0;c[h>>2]=d;s=d}else s=f;b[s>>1]=j;r4(c[r>>2]|0,k);c[l>>2]=c[l>>2]|1;i=g;return}function Yhb(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&1)){b[a>>1]=b[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+8>>1]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;b[a>>1]=b[l>>1]|0;i=f;return}function Zhb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=b+(g+4)|0;k=c[j>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==3)o=h;else if((n|0)==2?(a[(c[h>>2]|0)+2417>>0]|0)!=0:0)o=h;else p=4;if((p|0)==4){g7(m,d);i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[o>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+2>>0]=d;r4(c[o>>2]|0,h);c[j>>2]=c[j>>2]|2;i=f;return}function _hb(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;g=b+f|0;h=c[b+(f+4)>>2]|0;if(!(h&2)){j=(c[450992+((h>>>24&15)<<2)>>2]|0)+g+12|0;k=a[j>>0]|0;i=d;return k|0}l=b+(f+8)|0;f=c[l>>2]|0;if(!f){b=s4(c[g>>2]|0,h>>>24&15)|0;c[l>>2]=b;m=b}else m=f;j=m+2|0;k=a[j>>0]|0;i=d;return k|0}function $hb(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if(KU(b)|0){dKa(bKa()|0,8,453312,198,453392,g);i=f;return}h=c[427044+(e[b+4>>1]<<2)>>2]|0;j=b+h|0;k=c[b+(h+4)>>2]|0;h=k>>>30;if((h|0)==2)if(!(a[(c[j>>2]|0)+2417>>0]|0))l=5;else l=6;else if((h|0)==3)l=6;else l=5;if((l|0)==5){a[(c[450992+((k>>>24&15)<<2)>>2]|0)+j+13>>0]=d;i=f;return}else if((l|0)==6){dKa(bKa()|0,8,453464,153,453544,g);i=f;return}}function aib(b){b=b|0;var d=0;d=c[427044+((e[b+4>>1]|0)<<2)>>2]|0;return a[(c[450992+(((c[b+(d+4)>>2]|0)>>>24&15)<<2)>>2]|0)+(b+d)+13>>0]|0}function bib(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[427044+(e[b+4>>1]<<2)>>2]|0;h=b+g|0;j=a[d>>0]|0;d=b+(g+4)|0;k=c[d>>2]|0;l=k>>>24&15;m=(c[450992+(l<<2)>>2]|0)+h|0;n=k>>>30;if((n|0)==2)if(!(a[(c[h>>2]|0)+2417>>0]|0))o=4;else p=h;else if((n|0)==3)p=h;else o=4;if((o|0)==4){a[m+11>>0]=j;i=f;return}m=b+(g+8)|0;g=c[m>>2]|0;if(!g){b=s4(c[p>>2]|0,l)|0;c[m>>2]=b;q=b}else q=g;a[q+3>>0]=j;r4(c[p>>2]|0,h);c[d>>2]=c[d>>2]|4;i=f;return}function cib(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[427044+((e[d+4>>1]|0)<<2)>>2]|0;h=d+g|0;j=c[d+(g+4)>>2]|0;if(!(j&4)){a[b>>0]=a[(c[450992+((j>>>24&15)<<2)>>2]|0)+h+11>>0]|0;i=f;return}k=d+(g+8)|0;g=c[k>>2]|0;if(!g){d=s4(c[h>>2]|0,j>>>24&15)|0;c[k>>2]=d;l=d}else l=g;a[b>>0]=a[l+3>>0]|0;i=f;return}function dib(a){a=a|0;var b=0,c=0;b=i;c=GU(a+12|0)|0;i=b;return c|0}function eib(a,b){a=a|0;b=b|0;var c=0;c=i;Jja(a+32|0,b);i=c;return}function fib(a){a=a|0;var b=0;b=i;AU(a+12|0,a);i=b;return}function gib(a){a=a|0;var b=0;b=i;c[a>>2]=453736;MU(a);i=b;return}function hib(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=453736;MU(a);VJa(b,a);i=b;return}function iib(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a+12|0,b);i=c;return}function jib(a,b){a=a|0;b=b|0;var c=0;c=i;yU(a+12|0,b);i=c;return}function kib(a){a=a|0;return}function lib(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function mib(a){a=a|0;return 462520}function nib(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(462520,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function oib(a,b){a=a|0;b=b|0;return}function pib(a){a=a|0;return}function qib(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function rib(b,c){b=b|0;c=c|0;a[b>>0]=a[c+20>>0]|0;return}function sib(a){a=a|0;return}function tib(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function uib(a){a=a|0;var b=0,d=0,e=0;b=i;d=_n[c[(c[a>>2]|0)+16>>2]&4095](a,0)|0;e=a+4|0;Oia(c[(c[e>>2]|0)+36>>2]|0,a,d);via(c[e>>2]|0,a);via(c[a+8>>2]|0,a);i=b;return}function vib(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;wia(c[d>>2]|0,a);wia(c[a+8>>2]|0,a);Pia(c[(c[d>>2]|0)+36>>2]|0,a);i=b;return}function wib(a,b){a=a|0;b=b|0;return 1}function xib(a,b){a=a|0;b=b|0;return 1}function yib(a){a=a|0;var c=0,d=0;c=i;d=a+6|0;if(b[d>>1]&2){Paa(a);b[d>>1]=(e[d>>1]|0)&65533}b[a+4>>1]=0;i=c;return}function zib(a){a=a|0;return}function Aib(a){a=a|0;return}function Bib(a,b,c){a=a|0;b=b|0;c=c|0;return}function Cib(a){a=a|0;return}function Dib(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function Eib(a){a=a|0;return 1}function Fib(a){a=a|0;return}function Gib(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a+-8|0);i=b;return}function Hib(a){a=a|0;return}function Iib(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Jib(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Kib(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Lib(a){a=a|0;return c[a+24>>2]|0}function Mib(a){a=a|0;var b=0;b=i;uda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Nib(a){a=a|0;return}function Oib(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Pib(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Qib(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Rib(a){a=a|0;return c[a+24>>2]|0}function Sib(a){a=a|0;var b=0;b=i;vda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Tib(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Uib(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Vib(a){a=a|0;return c[a+24>>2]|0}function Wib(a){a=a|0;var b=0;b=i;zda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Xib(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Yib(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Zib(a){a=a|0;return c[a+24>>2]|0}function _ib(a){a=a|0;var b=0;b=i;jda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function $ib(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function ajb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function bjb(a){a=a|0;return c[a+24>>2]|0}function cjb(a){a=a|0;var b=0;b=i;ida(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function djb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function ejb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function fjb(a){a=a|0;return c[a+24>>2]|0}function gjb(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[d+20>>2]|0;g=c[d+12>>2]|0;if((a[536682]|0)!=0?(d=c[f+1184>>2]|0,(d|0)!=0):0){h=f+1176|0;En[c[(c[d>>2]|0)+16>>2]&127](d,b[268340]|0,c[h>>2]|0,c[h+4>>2]|0,99999789)}h=f+144|0;if(!(c[h>>2]|0)){j=f+1212|0;k=c[j>>2]|0;l=k+1e3|0;m=c[l>>2]|0;Wsa(m,g,0);i=e;return}d=f+140|0;n=0;do{zla(_ia(c[(c[d>>2]|0)+(n<<2)>>2]|0)|0);n=n+1|0}while(n>>>0<(c[h>>2]|0)>>>0);j=f+1212|0;k=c[j>>2]|0;l=k+1e3|0;m=c[l>>2]|0;Wsa(m,g,0);i=e;return}function hjb(a){a=a|0;var b=0;b=i;c0a(a);i=b;return}function ijb(a){a=a|0;var b=0;b=i;i=i+16|0;c0a(a);VJa(b,a);i=b;return}function jjb(d){d=d|0;var e=0,f=0,g=0;e=i;f=c[d+92>>2]|0;d=f+1212|0;g=c[(c[d>>2]|0)+1e3>>2]|0;PEi(c[g+5916>>2]|0,0,c[g+5920>>2]<<2|0)|0;kda(f,0);Pca(f);bta(c[(c[d>>2]|0)+1e3>>2]|0);if(!(a[536682]|0)){i=e;return}d=c[f+1184>>2]|0;if(!d){i=e;return}g=f+1176|0;En[c[(c[d>>2]|0)+20>>2]&127](d,b[268340]|0,c[g>>2]|0,c[g+4>>2]|0,99999789);i=e;return}function kjb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function ljb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function mjb(a){a=a|0;return c[a+24>>2]|0}function njb(d){d=d|0;var e=0,f=0,h=0,j=0;e=i;f=c[d+20>>2]|0;h=c[d+12>>2]|0;if((a[536690]|0)!=0?(d=c[f+1184>>2]|0,(d|0)!=0):0){j=f+1176|0;En[c[(c[d>>2]|0)+16>>2]&127](d,b[268344]|0,c[j>>2]|0,c[j+4>>2]|0,99999789)}$sa(c[(c[f+1212>>2]|0)+1e3>>2]|0,ea(g[f+48>>2]),h);i=e;return}function ojb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function pjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function qjb(a){a=a|0;return c[a+24>>2]|0}function rjb(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[d+20>>2]|0;h=c[d+12>>2]|0;d=f+1184|0;if((a[536698]|0)!=0?(j=c[d>>2]|0,(j|0)!=0):0){k=f+1176|0;En[c[(c[j>>2]|0)+16>>2]&127](j,b[268348]|0,c[k>>2]|0,c[k+4>>2]|0,99999789)}k=c[(c[f+1212>>2]|0)+1e3>>2]|0;lda(f);j=c[d>>2]|0;d=f+1176|0;l=c[d>>2]|0;m=c[d+4>>2]|0;Dn[c[(c[j>>2]|0)+8>>2]&511](j,76,l,m);eta(k,ea(g[f+48>>2]),h);Dn[c[(c[j>>2]|0)+12>>2]&511](j,76,l,m);i=e;return}function sjb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function tjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function ujb(a){a=a|0;return c[a+24>>2]|0}function vjb(a){a=a|0;var b=0;b=i;nda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function wjb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function xjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function yjb(a){a=a|0;return c[a+24>>2]|0}function zjb(a){a=a|0;var b=0;b=i;oda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Ajb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Bjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Cjb(a){a=a|0;return c[a+24>>2]|0}function Djb(a){a=a|0;var b=0;b=i;pda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Ejb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Fjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Gjb(a){a=a|0;return c[a+24>>2]|0}function Hjb(a){a=a|0;var b=0;b=i;qda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Ijb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Jjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Kjb(a){a=a|0;return c[a+24>>2]|0}function Ljb(a){a=a|0;var b=0;b=i;wda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Mjb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Njb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Ojb(a){a=a|0;return c[a+24>>2]|0}function Pjb(a){a=a|0;var b=0;b=i;sda(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Qjb(a){a=a|0;var b=0;b=i;c0a(a);i=b;return}function Rjb(a){a=a|0;var b=0;b=i;i=i+16|0;c0a(a);VJa(b,a);i=b;return}function Sjb(a){a=a|0;var b=0,d=0;b=i;if(!(c[a+44>>2]|0))d=0;else d=c[c[a+40>>2]>>2]|0;Ada(c[a+92>>2]|0,d);i=b;return}function Tjb(a){a=a|0;var b=0;b=i;c0a(a);i=b;return}function Ujb(a){a=a|0;var b=0;b=i;i=i+16|0;c0a(a);VJa(b,a);i=b;return}function Vjb(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+92>>2]|0;a=d+132|0;if(!(c[a>>2]|0)){i=b;return}e=d+128|0;d=0;do{cia(c[(c[e>>2]|0)+(d<<2)>>2]|0);d=d+1|0}while(d>>>0<(c[a>>2]|0)>>>0);i=b;return}function Wjb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Xjb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Yjb(a){a=a|0;return c[a+24>>2]|0}function Zjb(d){d=d|0;var e=0,f=0,g=0;e=i;f=c[d+20>>2]|0;d=f+1212|0;if(c[f+132>>2]|0)xqa((c[(c[d>>2]|0)+1e3>>2]|0)+1448|0);Yia(c[d>>2]|0,0);if((a[536690]|0)!=0?(d=c[f+1184>>2]|0,(d|0)!=0):0){g=f+1176|0;En[c[(c[d>>2]|0)+20>>2]&127](d,b[268344]|0,c[g>>2]|0,c[g+4>>2]|0,99999789)}if(!(a[536674]|0)){i=e;return}g=c[f+1184>>2]|0;if(!g){i=e;return}d=f+1176|0;En[c[(c[g>>2]|0)+20>>2]&127](g,b[268336]|0,c[d>>2]|0,c[d+4>>2]|0,99999789);i=e;return}function _jb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function $jb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function akb(a){a=a|0;return c[a+24>>2]|0}function bkb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+20>>2]|0;a=d+144|0;if(c[a>>2]|0){e=d+140|0;f=0;do{vla(_ia(c[(c[e>>2]|0)+(f<<2)>>2]|0)|0);f=f+1|0}while(f>>>0<(c[a>>2]|0)>>>0)}a=c[d+160>>2]|0;if(a)ko[c[(c[a>>2]|0)+20>>2]&4095](a);a=c[d+164>>2]|0;if(!a){i=b;return}ko[c[(c[a>>2]|0)+20>>2]&4095](a);i=b;return}function ckb(a){a=a|0;c[a>>2]=474824;c[a+8>>2]=474868;return}function dkb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=474824;c[a+8>>2]=474868;VJa(b,a);i=b;return}function ekb(a){a=a|0;var b=0;b=a+-8|0;c[b>>2]=474824;c[b+8>>2]=474868;return}function fkb(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=a+-8|0;c[d>>2]=474824;c[d+8>>2]=474868;VJa(b,d);i=b;return}function gkb(d){d=d|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=d+6|0;if(b[g>>1]&2){Paa(d);b[g>>1]=e[g>>1]&65533}b[d+4>>1]=0;if(!(a[(c[d+40>>2]|0)+19>>0]|0)){g=d+36|0;if((a[(c[(c[g>>2]|0)+28>>2]|0)+64>>0]&4)==0?(h=d+46|0,(a[h>>0]|0)==0):0){j=d+32|0;k=Iga(c[j>>2]|0)|0;Zha(k,c[j>>2]|0,c[g>>2]|0,0);a[h>>0]=1;i=f;return}if(!(a[(c[(c[d+36>>2]|0)+28>>2]|0)+64>>0]&4)){i=f;return}}h=d+46|0;if(!(a[h>>0]|0)){i=f;return}g=d+32|0;j=Iga(c[g>>2]|0)|0;_ha(j,c[g>>2]|0,c[d+36>>2]|0,0,0);a[h>>0]=0;i=f;return}function hkb(a){a=a|0;return}function ikb(a){a=a|0;return}function jkb(a){a=a|0;return}function kkb(a){a=a|0;return}function lkb(a){a=a|0;return 0}function mkb(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=475264;c[a+372>>2]=443968;c[a+380>>2]=0;d=c[a+364>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+356>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}yGb(a+60|0);p7(a);i=b;return}function nkb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[a>>2]=475264;c[a+372>>2]=443968;c[a+380>>2]=0;e=c[a+364>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+356>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}yGb(a+60|0);p7(a);VJa(d,a);i=b;return}function okb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function pkb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function qkb(a){a=a|0;return c[a+24>>2]|0}function rkb(a){a=a|0;var b=0;b=i;nia(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function skb(a){a=a|0;return}function tkb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function ukb(a){a=a|0;return 0}function vkb(a){a=a|0;var b=0;b=i;c[a>>2]=48e4;Sla(a);i=b;return}function wkb(a){a=a|0;var b=0;b=i;c[a>>2]=48e4;Sla(a);i=b;return}function xkb(a){a=a|0;c[a>>2]=480016;return}function ykb(a){a=a|0;c[a>>2]=480016;return}function zkb(a){a=a|0;var b=0;b=i;c[a>>2]=480232;c[a+4>>2]=480648;Zla(a+16|0);c[a>>2]=48e4;Sla(a);i=b;return}function Akb(a){a=a|0;var b=0;b=i;c[a>>2]=480232;c[a+4>>2]=480648;Zla(a+16|0);c[a>>2]=48e4;Sla(a);i=b;return}function Bkb(a){a=a|0;return (c[a+20>>2]|0)+4|0}function Ckb(a){a=a|0;return (c[a+16>>2]|0)+4|0}function Dkb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+180|0;j=a+184|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+188>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+188>>2]=h;c[a+540>>2]=0;i=d;return}function Ekb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=0,h=Im,j=0,k=Im,l=0,m=Im,n=0,o=0,p=Im,q=0,r=Im;d=i;e=ea(g[b>>2]);f=a+164|0;h=ea(e-ea(g[f>>2]));j=b+4|0;k=ea(g[j>>2]);l=a+168|0;m=ea(k-ea(g[l>>2]));n=b+8|0;k=ea(g[n>>2]);o=a+172|0;p=ea(k-ea(g[o>>2]));q=b+12|0;k=ea(g[q>>2]);b=a+176|0;r=ea(k-ea(g[b>>2]));if(ea(ea(ea(ea(h*h)+ea(m*m))+ea(p*p))+ea(r*r))==ea(0.0)){i=d;return}g[f>>2]=e;g[l>>2]=ea(g[j>>2]);g[o>>2]=ea(g[n>>2]);g[b>>2]=ea(g[q>>2]);c[a+540>>2]=0;i=d;return}function Fkb(a){a=a|0;return a+180|0}function Gkb(a){a=a|0;return a+164|0}function Hkb(a){a=a|0;var b=0;g[a+192>>2]=ea(g[a+164>>2]);g[a+196>>2]=ea(g[a+168>>2]);g[a+200>>2]=ea(g[a+172>>2]);g[a+204>>2]=ea(g[a+176>>2]);g[a+208>>2]=ea(g[a+180>>2]);g[a+212>>2]=ea(g[a+184>>2]);g[a+216>>2]=ea(g[a+188>>2]);b=a+220|0;c[a+540>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;return}function Ikb(a,b){a=a|0;b=b|0;var c=Im,d=0,e=0,f=0;c=ea(g[b>>2]);d=a+208|0;g[d>>2]=ea(c+ea(g[d>>2]));d=b+4|0;c=ea(g[d>>2]);e=a+212|0;g[e>>2]=ea(c+ea(g[e>>2]));e=b+8|0;c=ea(g[e>>2]);f=a+216|0;g[f>>2]=ea(c+ea(g[f>>2]));c=ea(g[b>>2]);b=a+180|0;g[b>>2]=ea(c+ea(g[b>>2]));c=ea(g[d>>2]);d=a+184|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[e>>2]);e=a+188|0;g[e>>2]=ea(c+ea(g[e>>2]));return}function Jkb(a){a=a|0;var b=Im;b=ea(g[a+244>>2]);return ea(b)}function Kkb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+72|0;j=a+76|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+80>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+80>>2]=h;c[a+540>>2]=0;i=d;return}function Lkb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+72>>2]);g[a+4>>2]=ea(g[b+76>>2]);g[a+8>>2]=ea(g[b+80>>2]);return}function Mkb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=0;d=i;e=ea(ea(1.0)-ea(g[b>>2]));f=ea(ea(1.0)-ea(g[b+4>>2]));h=ea(ea(1.0)-ea(g[b+8>>2]));if(e!=ea(0.0))j=ea(+ba(+(+e))/.6931471824645996);else j=ea(-128.0);if(f!=ea(0.0))k=ea(+ba(+(+f))/.6931471824645996);else k=ea(-128.0);if(h!=ea(0.0))l=ea(+ba(+(+h))/.6931471824645996);else l=ea(-128.0);b=a+84|0;m=a+88|0;if((j==ea(g[b>>2])?k==ea(g[m>>2]):0)?l==ea(g[a+92>>2]):0){i=d;return}g[b>>2]=j;g[m>>2]=k;g[a+92>>2]=l;c[a+540>>2]=0;i=d;return}function Nkb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b+84>>2]);if(!(c<=ea(-128.0)))d=ea(+aa(+(+ea(c*ea(.693147182)))));else d=ea(0.0);c=ea(g[b+88>>2]);if(!(c<=ea(-128.0)))e=ea(+aa(+(+ea(c*ea(.693147182)))));else e=ea(0.0);c=ea(g[b+92>>2]);if(!(c<=ea(-128.0)))f=ea(+aa(+(+ea(c*ea(.693147182)))));else f=ea(0.0);c=ea(ea(1.0)-e);e=ea(ea(1.0)-f);g[a>>2]=ea(ea(1.0)-d);g[a+4>>2]=c;g[a+8>>2]=e;return}function Okb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=0;d=i;e=ea(ea(1.0)-ea(g[b>>2]));f=ea(ea(1.0)-ea(g[b+4>>2]));h=ea(ea(1.0)-ea(g[b+8>>2]));if(e!=ea(0.0))j=ea(+ba(+(+e))/.6931471824645996);else j=ea(-128.0);if(f!=ea(0.0))k=ea(+ba(+(+f))/.6931471824645996);else k=ea(-128.0);if(h!=ea(0.0))l=ea(+ba(+(+h))/.6931471824645996);else l=ea(-128.0);b=a+96|0;m=a+100|0;if((j==ea(g[b>>2])?k==ea(g[m>>2]):0)?l==ea(g[a+104>>2]):0){i=d;return}g[b>>2]=j;g[m>>2]=k;g[a+104>>2]=l;c[a+540>>2]=0;i=d;return}function Pkb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b+96>>2]);if(!(c<=ea(-128.0)))d=ea(+aa(+(+ea(c*ea(.693147182)))));else d=ea(0.0);c=ea(g[b+100>>2]);if(!(c<=ea(-128.0)))e=ea(+aa(+(+ea(c*ea(.693147182)))));else e=ea(0.0);c=ea(g[b+104>>2]);if(!(c<=ea(-128.0)))f=ea(+aa(+(+ea(c*ea(.693147182)))));else f=ea(0.0);c=ea(ea(1.0)-e);e=ea(ea(1.0)-f);g[a>>2]=ea(ea(1.0)-d);g[a+4>>2]=c;g[a+8>>2]=e;return}function Qkb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=0;d=i;e=ea(ea(1.0)-ea(g[b>>2]));f=ea(ea(1.0)-ea(g[b+4>>2]));h=ea(ea(1.0)-ea(g[b+8>>2]));if(e!=ea(0.0))j=ea(+ba(+(+e))/.6931471824645996);else j=ea(-128.0);if(f!=ea(0.0))k=ea(+ba(+(+f))/.6931471824645996);else k=ea(-128.0);if(h!=ea(0.0))l=ea(+ba(+(+h))/.6931471824645996);else l=ea(-128.0);b=a+108|0;m=a+112|0;if((j==ea(g[b>>2])?k==ea(g[m>>2]):0)?l==ea(g[a+116>>2]):0){i=d;return}g[b>>2]=j;g[m>>2]=k;g[a+116>>2]=l;c[a+540>>2]=0;i=d;return}function Rkb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b+108>>2]);if(!(c<=ea(-128.0)))d=ea(+aa(+(+ea(c*ea(.693147182)))));else d=ea(0.0);c=ea(g[b+112>>2]);if(!(c<=ea(-128.0)))e=ea(+aa(+(+ea(c*ea(.693147182)))));else e=ea(0.0);c=ea(g[b+116>>2]);if(!(c<=ea(-128.0)))f=ea(+aa(+(+ea(c*ea(.693147182)))));else f=ea(0.0);c=ea(ea(1.0)-e);e=ea(ea(1.0)-f);g[a>>2]=ea(ea(1.0)-d);g[a+4>>2]=c;g[a+8>>2]=e;return}function Skb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+120|0;j=a+124|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+128>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+128>>2]=h;c[a+540>>2]=0;i=d;return}function Tkb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+120>>2]);g[a+4>>2]=ea(g[b+124>>2]);g[a+8>>2]=ea(g[b+128>>2]);return}function Ukb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+132|0;j=a+136|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+140>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+140>>2]=h;c[a+540>>2]=0;i=d;return}function Vkb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+132>>2]);g[a+4>>2]=ea(g[b+136>>2]);g[a+8>>2]=ea(g[b+140>>2]);return}function Wkb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+144|0;j=a+148|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+152>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+152>>2]=h;c[a+540>>2]=0;i=d;return}function Xkb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+144>>2]);g[a+4>>2]=ea(g[b+148>>2]);g[a+8>>2]=ea(g[b+152>>2]);return}function Ykb(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=a+156|0;if(ea(g[f>>2])==b){i=d;return}g[f>>2]=b;f=e;c[f>>2]=0;c[f+4>>2]=0;zGb(a+248|0,0,e);c[a+260>>2]=0;c[a+540>>2]=0;i=d;return}function Zkb(a){a=a|0;var b=Im;b=ea(g[a+156>>2]);return ea(b)}function _kb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+160|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+540>>2]=0;i=d;return}function $kb(a){a=a|0;var b=Im;b=ea(g[a+160>>2]);return ea(b)}function alb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+248|0;f=a+264|0;c[f>>2]=b;g=c[e>>2]|0;h=a+260|0;j=c[h>>2]|0;if(j>>>0>b>>>0){k=j;j=g;l=b;do{l=(c[j>>2]|0)+l|0;c[j>>2]=l-k;k=c[h>>2]|0;j=j+((l>>>0<=k>>>0&1)<<3)|0}while(l>>>0<k>>>0);if((j|0)!=(g|0)?(k=a+252|0,AGb(e,g+(c[k>>2]<<3)-j>>3),g=c[e>>2]|0,e=c[k>>2]|0,k=g+(e<<3)|0,(e|0)>0):0){e=g;g=j;while(1){if(e){j=g;a=c[j+4>>2]|0;l=e;c[l>>2]=c[j>>2];c[l+4>>2]=a}e=e+8|0;if(e>>>0>=k>>>0)break;else g=g+8|0}}}g=c[h>>2]|0;k=c[f>>2]|0;c[h>>2]=g>>>0<k>>>0?g:k;i=d;return}function blb(a){a=a|0;return c[a+264>>2]|0}function clb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f=i;i=i+64|0;h=f+48|0;j=f+32|0;k=f+16|0;l=f;m=a+372|0;n=a+376|0;o=c[n>>2]|0;p=b+4|0;q=c[p>>2]|0;r=c[b>>2]|0;s=q-r>>4;t=d-e+o+s|0;u=(o|0)!=0;if((t|0)==0&(u^1)){i=f;return}if(u){u=o>>>0<t>>>0?t:o;v=c[a+380>>2]&2147483647;w=a+384|0;x=a+392|0;y=c[x>>2]|0;z=y&2147483647;if(u>>>0>(v>>>0<z>>>0?v:z)>>>0){if(v>>>0<t>>>0){r_a(m,t);A=c[x>>2]|0}else A=y;if((A&2147483647)>>>0<u>>>0)r_a(w,u)}A=a+388|0;y=c[A>>2]|0;a:do if(y>>>0<o>>>0){v=y;z=y;while(1){B=c[m>>2]|0;C=B+(z<<4)|0;if((c[x>>2]&2147483647)>>>0>v>>>0){D=c[w>>2]|0;E=D+(v<<4)|0;if(E){g[E>>2]=ea(g[C>>2]);g[D+(v<<4)+4>>2]=ea(g[B+(z<<4)+4>>2]);g[D+(v<<4)+8>>2]=ea(g[B+(z<<4)+8>>2]);g[D+(v<<4)+12>>2]=ea(g[B+(z<<4)+12>>2])}c[A>>2]=v+1}else I_a(w,C)|0;C=z+1|0;if((C|0)==(o|0))break a;v=c[A>>2]|0;z=C}}while(0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;t_a(m,u,h);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;t_a(w,u,j);j=t-o|0;if((t|0)==(o|0)){F=q;G=r}else{q=c[m>>2]|0;u=j+e|0;h=u>>>0>e>>>0;A=o>>>0>e>>>0;if(h)if(A){x=o;y=t;do{y=y+-1|0;x=x+-1|0;g[q+(y<<4)>>2]=ea(g[q+(x<<4)>>2]);g[q+(y<<4)+4>>2]=ea(g[q+(x<<4)+4>>2]);g[q+(y<<4)+8>>2]=ea(g[q+(x<<4)+8>>2]);g[q+(y<<4)+12>>2]=ea(g[q+(x<<4)+12>>2])}while(x>>>0>e>>>0);H=27}else H=32;else if(A){x=e;y=u;while(1){g[q+(y<<4)>>2]=ea(g[q+(x<<4)>>2]);g[q+(y<<4)+4>>2]=ea(g[q+(x<<4)+4>>2]);g[q+(y<<4)+8>>2]=ea(g[q+(x<<4)+8>>2]);g[q+(y<<4)+12>>2]=ea(g[q+(x<<4)+12>>2]);x=x+1|0;if((x|0)==(o|0)){H=27;break}else y=y+1|0}}else H=32;do if((H|0)==27){y=c[w>>2]|0;if(h){if(A){I=o;J=t}else{H=33;break}do{J=J+-1|0;I=I+-1|0;g[y+(J<<4)>>2]=ea(g[y+(I<<4)>>2]);g[y+(J<<4)+4>>2]=ea(g[y+(I<<4)+4>>2]);g[y+(J<<4)+8>>2]=ea(g[y+(I<<4)+8>>2]);g[y+(J<<4)+12>>2]=ea(g[y+(I<<4)+12>>2])}while(I>>>0>e>>>0);H=32}else{if(A){K=e;L=u}else break;while(1){g[y+(L<<4)>>2]=ea(g[y+(K<<4)>>2]);g[y+(L<<4)+4>>2]=ea(g[y+(K<<4)+4>>2]);g[y+(L<<4)+8>>2]=ea(g[y+(K<<4)+8>>2]);g[y+(L<<4)+12>>2]=ea(g[y+(K<<4)+12>>2]);K=K+1|0;if((K|0)==(o|0)){H=32;break}else L=L+1|0}}}while(0);if((H|0)==32?h:0)H=33;if((H|0)==33){H=s+d|0;h=e;do{L=h-d|0;g[q+(h<<4)>>2]=ea(g[r+(L<<4)>>2]);g[q+(h<<4)+4>>2]=ea(g[r+(L<<4)+4>>2]);g[q+(h<<4)+8>>2]=ea(g[r+(L<<4)+8>>2]);g[q+(h<<4)+12>>2]=ea(g[r+(L<<4)+12>>2]);h=h+1|0}while((h|0)!=(H|0))}H=a+360|0;h=c[H>>2]|0;q=a+364|0;L=c[q>>2]|0;b:do if(L){o=((j|0)>0?0:j)+e|0;K=h;u=h+(L<<3)|0;A=h;while(1){I=A+4|0;J=A;y=K;x=u;while(1){z=c[A>>2]|0;if(z>>>0<o>>>0)M=0;else{v=z+j|0;c[A>>2]=v;M=(v|0)<(o|0)}v=c[I>>2]|0;if(v>>>0<o>>>0)N=0;else{z=v+j|0;c[I>>2]=z;N=(z|0)<(o|0)}if(!(M|N))break;z=(c[q>>2]|0)+-1|0;c[q>>2]=z;v=y+(z<<3)|0;z=c[v+4>>2]|0;C=y+(J-y>>3<<3)|0;c[C>>2]=c[v>>2];c[C+4>>2]=z;z=c[H>>2]|0;C=z+(c[q>>2]<<3)|0;if((A|0)==(C|0))break b;else{y=z;x=C}}A=A+8|0;if((A|0)==(x|0))break;else{K=y;u=x}}}while(0);t_a(m,t,k);t_a(w,t,l);F=c[p>>2]|0;G=c[b>>2]|0}if((F|0)!=(G|0)){b=c[w>>2]|0;w=F-G>>4;F=0;do{p=F+d|0;g[b+(p<<4)>>2]=ea(g[G+(F<<4)>>2]);g[b+(p<<4)+4>>2]=ea(g[G+(F<<4)+4>>2]);g[b+(p<<4)+8>>2]=ea(g[G+(F<<4)+8>>2]);g[b+(p<<4)+12>>2]=ea(g[G+(F<<4)+12>>2]);F=F+1|0}while(F>>>0<w>>>0)}}else{s_a(m,s);s=c[m>>2]|0;m=c[n>>2]|0;n=s+(m<<4)|0;if((m|0)>0){m=s;s=r;while(1){if(m){g[m>>2]=ea(g[s>>2]);g[m+4>>2]=ea(g[s+4>>2]);g[m+8>>2]=ea(g[s+8>>2]);g[m+12>>2]=ea(g[s+12>>2])}m=m+16|0;if(m>>>0>=n>>>0)break;else s=s+16|0}}}c[a+540>>2]=0;i=f;return}function dlb(a){a=a|0;return c[a+376>>2]|0}function elb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+360|0;k=c[a+364>>2]|0;l=c[b>>2]|0;m=d-e+k+((c[b+4>>2]|0)-l>>2>>>1)|0;if((c[a+368>>2]&2147483647)>>>0<m>>>0)BGb(j,m);b=g;c[b>>2]=0;c[b+4>>2]=0;CGb(j,k>>>0<m>>>0?m:k,g);if((m|0)!=(k|0)){g=c[j>>2]|0;b=m-k+e|0;n=b>>>0>e>>>0;o=k>>>0>e>>>0;if(n)if(o){p=k;q=m;do{q=q+-1|0;p=p+-1|0;r=g+(p<<3)|0;s=c[r+4>>2]|0;t=g+(q<<3)|0;c[t>>2]=c[r>>2];c[t+4>>2]=s}while(p>>>0>e>>>0);u=9}else{v=e;u=10}else if(o){o=e;p=b;while(1){q=g+(o<<3)|0;o=o+1|0;s=c[q+4>>2]|0;t=g+(p<<3)|0;c[t>>2]=c[q>>2];c[t+4>>2]=s;if((o|0)==(k|0)){u=9;break}else p=p+1|0}}if((u|0)==9?n:0){v=e;u=10}if((u|0)==10)while(1){u=0;n=l+(v-d<<3)|0;p=c[n+4>>2]|0;k=(c[j>>2]|0)+(v<<3)|0;c[k>>2]=c[n>>2];c[k+4>>2]=p;v=v+1|0;if(v>>>0>=b>>>0)break;else u=10}u=h;c[u>>2]=0;c[u+4>>2]=0;CGb(j,m,h)}if(d>>>0>=e>>>0){w=a+540|0;c[w>>2]=0;i=f;return}h=d;do{m=l+(h-d<<3)|0;u=c[m+4>>2]|0;b=(c[j>>2]|0)+(h<<3)|0;c[b>>2]=c[m>>2];c[b+4>>2]=u;h=h+1|0}while((h|0)!=(e|0));w=a+540|0;c[w>>2]=0;i=f;return}function flb(a){a=a|0;return c[a+364>>2]|0}function glb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+64|0;h=f+48|0;j=f+32|0;k=f+16|0;l=f;m=a+408|0;n=a+412|0;o=c[n>>2]|0;p=c[b+4>>2]|0;q=c[b>>2]|0;b=p-q>>4;r=d-e+o+b|0;s=(o|0)!=0;if((r|0)==0&(s^1)){i=f;return}if(s){s=o>>>0<r>>>0?r:o;t=c[a+416>>2]&2147483647;u=a+420|0;v=a+428|0;w=c[v>>2]|0;x=w&2147483647;if(s>>>0>(t>>>0<x>>>0?t:x)>>>0){if(t>>>0<r>>>0){r_a(m,r);y=c[v>>2]|0}else y=w;if((y&2147483647)>>>0<s>>>0)r_a(u,s)}y=a+424|0;w=c[y>>2]|0;a:do if(w>>>0<o>>>0){t=w;x=w;while(1){z=c[m>>2]|0;A=z+(x<<4)|0;if((c[v>>2]&2147483647)>>>0>t>>>0){B=c[u>>2]|0;C=B+(t<<4)|0;if(C){g[C>>2]=ea(g[A>>2]);g[B+(t<<4)+4>>2]=ea(g[z+(x<<4)+4>>2]);g[B+(t<<4)+8>>2]=ea(g[z+(x<<4)+8>>2]);g[B+(t<<4)+12>>2]=ea(g[z+(x<<4)+12>>2])}c[y>>2]=t+1}else I_a(u,A)|0;A=x+1|0;if((A|0)==(o|0))break a;t=c[y>>2]|0;x=A}}while(0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;t_a(m,s,h);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;t_a(u,s,j);j=r-o|0;if((r|0)!=(o|0)){s=c[m>>2]|0;h=j+e|0;y=h>>>0>e>>>0;v=o>>>0>e>>>0;if(y)if(v){w=o;x=r;do{x=x+-1|0;w=w+-1|0;g[s+(x<<4)>>2]=ea(g[s+(w<<4)>>2]);g[s+(x<<4)+4>>2]=ea(g[s+(w<<4)+4>>2]);g[s+(x<<4)+8>>2]=ea(g[s+(w<<4)+8>>2]);g[s+(x<<4)+12>>2]=ea(g[s+(w<<4)+12>>2])}while(w>>>0>e>>>0);D=27}else D=32;else if(v){w=e;x=h;while(1){g[s+(x<<4)>>2]=ea(g[s+(w<<4)>>2]);g[s+(x<<4)+4>>2]=ea(g[s+(w<<4)+4>>2]);g[s+(x<<4)+8>>2]=ea(g[s+(w<<4)+8>>2]);g[s+(x<<4)+12>>2]=ea(g[s+(w<<4)+12>>2]);w=w+1|0;if((w|0)==(o|0)){D=27;break}else x=x+1|0}}else D=32;do if((D|0)==27){x=c[u>>2]|0;if(y){if(v){E=o;F=r}else{D=33;break}do{F=F+-1|0;E=E+-1|0;g[x+(F<<4)>>2]=ea(g[x+(E<<4)>>2]);g[x+(F<<4)+4>>2]=ea(g[x+(E<<4)+4>>2]);g[x+(F<<4)+8>>2]=ea(g[x+(E<<4)+8>>2]);g[x+(F<<4)+12>>2]=ea(g[x+(E<<4)+12>>2])}while(E>>>0>e>>>0);D=32}else{if(v){G=e;H=h}else break;while(1){g[x+(H<<4)>>2]=ea(g[x+(G<<4)>>2]);g[x+(H<<4)+4>>2]=ea(g[x+(G<<4)+4>>2]);g[x+(H<<4)+8>>2]=ea(g[x+(G<<4)+8>>2]);g[x+(H<<4)+12>>2]=ea(g[x+(G<<4)+12>>2]);G=G+1|0;if((G|0)==(o|0)){D=32;break}else H=H+1|0}}}while(0);if((D|0)==32?y:0)D=33;if((D|0)==33){D=b+d|0;y=e;do{H=y-d|0;g[s+(y<<4)>>2]=ea(g[q+(H<<4)>>2]);g[s+(y<<4)+4>>2]=ea(g[q+(H<<4)+4>>2]);g[s+(y<<4)+8>>2]=ea(g[q+(H<<4)+8>>2]);g[s+(y<<4)+12>>2]=ea(g[q+(H<<4)+12>>2]);y=y+1|0}while((y|0)!=(D|0))}D=(j|0)<0;y=1<<(D?j:0)+e;e=y+-1|0;s=c[a+396>>2]|0;H=a+400|0;o=c[H>>2]|0;b:do if(o){G=0-j|0;h=0-y|0;v=s+(o<<2)|0;E=s;while(1){F=E;c:do if(D){x=v;while(1){w=c[E>>2]|0;t=w>>>G&h|w&e;if(t){I=x;J=t;break c}t=(c[H>>2]|0)+-1|0;c[H>>2]=t;c[s+(F-s>>2<<2)>>2]=c[s+(t<<2)>>2];x=s+(c[H>>2]<<2)|0;if((E|0)==(x|0))break b}}else{x=v;while(1){t=c[E>>2]|0;w=(t&h)<<j|t&e;if(w){I=x;J=w;break c}w=(c[H>>2]|0)+-1|0;c[H>>2]=w;c[s+(F-s>>2<<2)>>2]=c[s+(w<<2)>>2];x=s+(c[H>>2]<<2)|0;if((E|0)==(x|0))break b}}while(0);c[E>>2]=J;E=E+4|0;if((E|0)==(I|0))break;else v=I}}while(0);t_a(m,r,k);t_a(u,r,l)}if((p|0)!=(q|0)){p=c[u>>2]|0;u=0;do{l=u+d|0;g[p+(l<<4)>>2]=ea(g[q+(u<<4)>>2]);g[p+(l<<4)+4>>2]=ea(g[q+(u<<4)+4>>2]);g[p+(l<<4)+8>>2]=ea(g[q+(u<<4)+8>>2]);g[p+(l<<4)+12>>2]=ea(g[q+(u<<4)+12>>2]);u=u+1|0}while(u>>>0<b>>>0)}}else{s_a(m,b);b=c[m>>2]|0;m=c[n>>2]|0;n=b+(m<<4)|0;if((m|0)>0){m=b;b=q;while(1){if(m){g[m>>2]=ea(g[b>>2]);g[m+4>>2]=ea(g[b+4>>2]);g[m+8>>2]=ea(g[b+8>>2]);g[m+12>>2]=ea(g[b+12>>2])}m=m+16|0;if(m>>>0>=n>>>0)break;else b=b+16|0}}}c[a+540>>2]=0;i=f;return}function hlb(a){a=a|0;return c[a+412>>2]|0}function ilb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+4|0;h=f;j=a+396|0;k=c[a+400>>2]|0;l=c[b>>2]|0;m=(c[b+4>>2]|0)-l>>2;b=d-e+k+m|0;if((c[a+404>>2]&2147483647)>>>0<b>>>0)L_a(j,b);c[g>>2]=0;f$a(j,k>>>0<b>>>0?b:k,g);if((b|0)==(k|0)){n=a+540|0;c[n>>2]=0;i=f;return}g=c[j>>2]|0;o=b-k+e|0;p=o>>>0>e>>>0;q=k>>>0>e>>>0;if(p)if(q){r=k;s=b;do{r=r+-1|0;s=s+-1|0;c[g+(s<<2)>>2]=c[g+(r<<2)>>2]}while(r>>>0>e>>>0);t=9}else t=10;else if(q){q=e;r=o;while(1){c[g+(r<<2)>>2]=c[g+(q<<2)>>2];q=q+1|0;if((q|0)==(k|0)){t=9;break}else r=r+1|0}}if((t|0)==9?p:0)t=10;if((t|0)==10){t=m+d|0;m=e;do{c[g+(m<<2)>>2]=c[l+(m-d<<2)>>2];m=m+1|0}while((m|0)!=(t|0))}c[h>>2]=0;f$a(j,b,h);n=a+540|0;c[n>>2]=0;i=f;return}function jlb(a){a=a|0;return c[a+400>>2]|0}function klb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+80|0;h=f+40|0;j=f;k=f+8|0;l=f+60|0;m=f+28|0;n=f+16|0;o=f+48|0;p=d*3|0;d=e*3|0;e=b;q=c[e+4>>2]|0;r=k;c[r>>2]=c[e>>2];c[r+4>>2]=q;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];ama(j,h,d-p|0);h=j;j=c[h>>2]|0;k=c[h+4>>2]|0;h=b;c[h>>2]=j;c[h+4>>2]=k;h=a+432|0;b=a+436|0;q=c[b>>2]|0;r=k;e=j;s=(k-j|0)/12|0;j=p-d+q+s|0;k=(q|0)!=0;if((j|0)==0&(k^1)){i=f;return}if(k){k=q>>>0<j>>>0?j:q;t=c[a+440>>2]&2147483647;u=a+444|0;v=a+452|0;w=c[v>>2]|0;x=w&2147483647;if(k>>>0>(t>>>0<x>>>0?t:x)>>>0){if(t>>>0<j>>>0){DDb(h,j);y=c[v>>2]|0}else y=w;if((y&2147483647)>>>0<k>>>0)DDb(u,k)}y=a+448|0;w=c[y>>2]|0;a:do if(w>>>0<q>>>0){t=w;x=w;while(1){z=c[h>>2]|0;A=z+(x*12|0)|0;if((c[v>>2]&2147483647)>>>0>t>>>0){B=c[u>>2]|0;C=B+(t*12|0)|0;if(C){g[C>>2]=ea(g[A>>2]);g[B+(t*12|0)+4>>2]=ea(g[z+(x*12|0)+4>>2]);g[B+(t*12|0)+8>>2]=ea(g[z+(x*12|0)+8>>2])}c[y>>2]=t+1}else EGb(u,A)|0;A=x+1|0;if((A|0)==(q|0))break a;t=c[y>>2]|0;x=A}}while(0);__a(h,k,l);__a(u,k,m);if((j|0)!=(q|0)){m=c[h>>2]|0;k=j-q+d|0;l=k>>>0>d>>>0;do if(l)if(q>>>0>d>>>0){y=q;v=j;do{v=v+-1|0;y=y+-1|0;g[m+(v*12|0)>>2]=ea(g[m+(y*12|0)>>2]);g[m+(v*12|0)+4>>2]=ea(g[m+(y*12|0)+4>>2]);g[m+(v*12|0)+8>>2]=ea(g[m+(y*12|0)+8>>2])}while(y>>>0>d>>>0);D=29}else{E=c[u>>2]|0;D=31;break}else if(d>>>0<q>>>0){y=d;v=k;while(1){g[m+(v*12|0)>>2]=ea(g[m+(y*12|0)>>2]);g[m+(v*12|0)+4>>2]=ea(g[m+(y*12|0)+4>>2]);g[m+(v*12|0)+8>>2]=ea(g[m+(y*12|0)+8>>2]);y=y+1|0;if((y|0)==(q|0)){D=29;break}else v=v+1|0}}else{F=c[u>>2]|0;D=30;break}while(0);if((D|0)==29){v=c[u>>2]|0;if(l){E=v;D=31}else{F=v;D=30}}if((D|0)==30){if(d>>>0<q>>>0){v=d;y=k;while(1){g[F+(y*12|0)>>2]=ea(g[F+(v*12|0)>>2]);g[F+(y*12|0)+4>>2]=ea(g[F+(v*12|0)+4>>2]);g[F+(y*12|0)+8>>2]=ea(g[F+(v*12|0)+8>>2]);v=v+1|0;if((v|0)==(q|0))break;else y=y+1|0}}}else if((D|0)==31?q>>>0>d>>>0:0){D=q;q=j;do{q=q+-1|0;D=D+-1|0;g[E+(q*12|0)>>2]=ea(g[E+(D*12|0)>>2]);g[E+(q*12|0)+4>>2]=ea(g[E+(D*12|0)+4>>2]);g[E+(q*12|0)+8>>2]=ea(g[E+(D*12|0)+8>>2])}while(D>>>0>d>>>0)}if(l){l=s+p|0;D=d;do{d=D-p|0;g[m+(D*12|0)>>2]=ea(g[e+(d*12|0)>>2]);g[m+(D*12|0)+4>>2]=ea(g[e+(d*12|0)+4>>2]);g[m+(D*12|0)+8>>2]=ea(g[e+(d*12|0)+8>>2]);D=D+1|0}while((D|0)!=(l|0))}__a(h,j,n);__a(u,j,o)}if((r|0)!=(e|0)){r=c[u>>2]|0;u=0;do{o=u+p|0;g[r+(o*12|0)>>2]=ea(g[e+(u*12|0)>>2]);g[r+(o*12|0)+4>>2]=ea(g[e+(u*12|0)+4>>2]);g[r+(o*12|0)+8>>2]=ea(g[e+(u*12|0)+8>>2]);u=u+1|0}while(u>>>0<s>>>0)}}else{DGb(h,s);s=c[h>>2]|0;h=c[b>>2]|0;b=s+(h*12|0)|0;if((h|0)>0){h=s;s=e;while(1){if(h){g[h>>2]=ea(g[s>>2]);g[h+4>>2]=ea(g[s+4>>2]);g[h+8>>2]=ea(g[s+8>>2])}h=h+12|0;if(h>>>0>=b>>>0)break;else s=s+12|0}}}c[a+540>>2]=0;i=f;return}function llb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+64|0;h=f+56|0;j=f+8|0;k=f;l=f+24|0;m=f+16|0;n=f+44|0;o=f+32|0;p=e*3|0;e=a+432|0;q=a+436|0;r=c[q>>2]|0;s=b;t=c[s+4>>2]|0;u=k;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=r-p|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];ama(j,h,t);k=j;j=c[k>>2]|0;u=c[k+4>>2]|0;k=b;c[k>>2]=j;c[k+4>>2]=u;k=d;b=c[k+4>>2]|0;s=m;c[s>>2]=c[k>>2];c[s+4>>2]=b;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];ama(l,h,t);t=l;l=c[t>>2]|0;h=c[t+4>>2]|0;t=d;c[t>>2]=l;c[t+4>>2]=h;h=c[q>>2]|0;t=u;d=j;m=(u-j|0)/12|0;j=p-r+h+m|0;u=l;if(!(j|h)){i=f;return}l=a+440|0;b=c[l>>2]&2147483647;s=a+444|0;k=a+452|0;v=c[k>>2]|0;w=v&2147483647;if(j>>>0>(b>>>0<w>>>0?b:w)>>>0){if(b>>>0<j>>>0){DDb(e,j);x=c[k>>2]|0}else x=v;if((x&2147483647)>>>0<j>>>0)DDb(s,j)}j=h-r+p|0;__a(e,j,n);__a(s,j,o);if((t|0)!=(d|0)){t=a+448|0;o=0;do{j=d+(o*12|0)|0;n=c[q>>2]|0;if((c[l>>2]&2147483647)>>>0>n>>>0){p=c[e>>2]|0;r=p+(n*12|0)|0;if(r){g[r>>2]=ea(g[j>>2]);g[p+(n*12|0)+4>>2]=ea(g[d+(o*12|0)+4>>2]);g[p+(n*12|0)+8>>2]=ea(g[d+(o*12|0)+8>>2])}c[q>>2]=n+1}else EGb(e,j)|0;j=u+(o*12|0)|0;n=c[t>>2]|0;if((c[k>>2]&2147483647)>>>0>n>>>0){p=c[s>>2]|0;r=p+(n*12|0)|0;if(r){g[r>>2]=ea(g[j>>2]);g[p+(n*12|0)+4>>2]=ea(g[u+(o*12|0)+4>>2]);g[p+(n*12|0)+8>>2]=ea(g[u+(o*12|0)+8>>2])}c[t>>2]=n+1}else EGb(s,j)|0;o=o+1|0}while(o>>>0<m>>>0)}c[a+540>>2]=0;i=f;return}function mlb(a){a=a|0;return ((c[a+436>>2]|0)>>>0)/3|0|0}function nlb(b){b=b|0;return (a[b+456>>0]|0)!=0|0}function olb(b,e){b=b|0;e=e|0;var f=0,g=0;f=i;g=b+456|0;if((e&1|0)==(d[g>>0]|0|0)){i=f;return}a[g>>0]=e&1;c[b+540>>2]=0;i=f;return}function plb(a){a=a|0;var b=Im;b=ea(g[a+460>>2]);return ea(b)}function qlb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+460|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+540>>2]=0;i=d;return}function rlb(a,b){a=a|0;b=ea(b);g[a+464>>2]=b;c[a+540>>2]=0;return}function slb(a){a=a|0;var b=Im;b=ea(g[a+464>>2]);return ea(b)}function tlb(a){a=a|0;return c[a+484>>2]|0}function ulb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+284|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+540>>2]=0;i=d;return}function vlb(a){a=a|0;var b=Im;b=ea(g[a+284>>2]);return ea(b)}function wlb(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0;d=i;e=ea(ea(1.0)-b);if(e!=ea(0.0))f=ea(+ba(+(+e))/.6931471824645996);else f=ea(-128.0);h=a+280|0;if(f==ea(g[h>>2])){i=d;return}g[h>>2]=f;c[a+540>>2]=0;i=d;return}function xlb(a){a=a|0;var b=Im,c=Im;b=ea(g[a+280>>2]);if(!(b<=ea(-128.0)))c=ea(+aa(+(+ea(b*ea(.693147182)))));else c=ea(0.0);b=ea(ea(1.0)-c);return ea(b)}function ylb(a,b){a=a|0;b=b|0;var d=0;d=i;c[b+540>>2]=0;_la(a,b+16|0,b+288|0);i=d;return}function zlb(a){a=a|0;var b=0;b=i;$la(a+288|0);c[a+540>>2]=0;i=b;return}function Alb(a){a=a|0;return c[a+292>>2]|0}function Blb(a,b,d){a=a|0;b=ea(b);d=ea(d);var e=0,f=0,h=0;e=i;f=a+312|0;h=a+316|0;if(ea(g[f>>2])==b?ea(g[h>>2])==d:0){i=e;return}g[f>>2]=b;g[h>>2]=d;c[a+540>>2]=0;i=e;return}function Clb(a){a=a|0;var b=Im;b=ea(g[a+312>>2]);return ea(b)}function Dlb(a){a=a|0;var b=Im;b=ea(g[a+316>>2]);return ea(b)}function Elb(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0;d=i;e=ea(ea(1.0)-b);if(e!=ea(0.0))f=ea(+ba(+(+e))/.6931471824645996);else f=ea(-128.0);h=a+320|0;if(f==ea(g[h>>2])){i=d;return}g[h>>2]=f;c[a+540>>2]=0;i=d;return}function Flb(a){a=a|0;var b=Im,c=Im;b=ea(g[a+320>>2]);if(!(b<=ea(-128.0)))c=ea(+aa(+(+ea(b*ea(.693147182)))));else c=ea(0.0);b=ea(ea(1.0)-c);return ea(b)}function Glb(a,b){a=a|0;b=b|0;var d=0;d=i;c[b+540>>2]=0;_la(a,b+16|0,b+324|0);i=d;return}function Hlb(a){a=a|0;var b=0;b=i;$la(a+324|0);c[a+540>>2]=0;i=b;return}function Ilb(a){a=a|0;return c[a+328>>2]|0}function Jlb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+16|0;e=a+384|0;f=a+388|0;g=c[f>>2]|0;if(g){h=a+372|0;j=c[h>>2]|0;c[h>>2]=c[e>>2];c[e>>2]=j;j=a+376|0;h=c[j>>2]|0;c[j>>2]=g;c[f>>2]=h;h=a+380|0;f=a+392|0;g=c[h>>2]|0;c[h>>2]=c[f>>2];c[f>>2]=g;t_a(e,0,b)}e=a+300|0;g=a+304|0;f=c[g>>2]|0;if(f){h=a+288|0;j=c[h>>2]|0;c[h>>2]=c[e>>2];c[e>>2]=j;j=a+292|0;h=c[j>>2]|0;c[j>>2]=f;c[g>>2]=h;h=a+296|0;g=a+308|0;f=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=f;t_a(e,0,d)}e=a+336|0;f=a+340|0;g=c[f>>2]|0;if(!g){k=a+540|0;c[k>>2]=0;i=b;return}h=a+324|0;j=c[h>>2]|0;c[h>>2]=c[e>>2];c[e>>2]=j;j=a+328|0;h=c[j>>2]|0;c[j>>2]=g;c[f>>2]=h;h=a+332|0;f=a+344|0;g=c[h>>2]|0;c[h>>2]=c[f>>2];c[f>>2]=g;t_a(e,0,d);k=a+540|0;c[k>>2]=0;i=b;return}function Klb(a){a=a|0;return c[a+352>>2]|0}function Llb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+496|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+540>>2]=0;i=d;return}function Mlb(a){a=a|0;var b=Im;b=ea(g[a+496>>2]);return ea(b)}function Nlb(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0;d=i;e=ea(ea(1.0)-b);if(e!=ea(0.0))f=ea(+ba(+(+e))/.6931471824645996);else f=ea(-128.0);h=a+500|0;if(f==ea(g[h>>2])){i=d;return}g[h>>2]=f;c[a+540>>2]=0;i=d;return}function Olb(a){a=a|0;var b=Im,c=Im;b=ea(g[a+500>>2]);if(!(b<=ea(-128.0)))c=ea(+aa(+(+ea(b*ea(.693147182)))));else c=ea(0.0);b=ea(ea(1.0)-c);return ea(b)}function Plb(a){a=a|0;return c[a+508>>2]|0}function Qlb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=a+516|0;f=c[b>>2]|0;s_a(e,(c[b+4>>2]|0)-f>>4);b=c[e>>2]|0;e=c[a+520>>2]|0;h=b+(e<<4)|0;if((e|0)>0){j=b;k=f}else{l=a+540|0;c[l>>2]=0;i=d;return}while(1){if(j){g[j>>2]=ea(g[k>>2]);g[j+4>>2]=ea(g[k+4>>2]);g[j+8>>2]=ea(g[k+8>>2]);g[j+12>>2]=ea(g[k+12>>2])}j=j+16|0;if(j>>>0>=h>>>0)break;else k=k+16|0}l=a+540|0;c[l>>2]=0;i=d;return}function Rlb(a){a=a|0;return c[a+520>>2]|0}function Slb(a){a=a|0;return a+48|0}function Tlb(a){a=a|0;return a+60|0}function Ulb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+536|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+540>>2]=0;i=d;return}function Vlb(a){a=a|0;var b=Im;b=ea(g[a+536>>2]);return ea(b)}function Wlb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+528|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;c[a+540>>2]=0;i=d;return}function Xlb(a){a=a|0;return c[a+528>>2]|0}function Ylb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+532|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;c[a+540>>2]=0;i=d;return}function Zlb(a){a=a|0;return c[a+532>>2]|0}function _lb(a){a=a|0;return c[a+540>>2]|0}function $lb(a){a=a|0;return (c[a+540>>2]|0)>>>0>=(c[a+532>>2]|0)>>>0|0}function amb(a){a=a|0;c[a+540>>2]=c[a+532>>2];return}function bmb(a){a=a|0;c[a+540>>2]=0;return}function cmb(a,b){a=a|0;b=b|0;c[a+548>>2]=b;return}function dmb(a){a=a|0;return c[a+548>>2]|0}function emb(a){a=a|0;var b=0,d=0;b=i;d=a+-4|0;c[d>>2]=480232;c[a>>2]=480648;Zla(a+12|0);c[d>>2]=48e4;Sla(d);i=b;return}function fmb(a){a=a|0;var b=0,d=0;b=i;d=a+-4|0;c[d>>2]=480232;c[a>>2]=480648;Zla(a+12|0);c[d>>2]=48e4;Sla(d);i=b;return}function gmb(a){a=a|0;return (c[a+16>>2]|0)+4|0}function hmb(a){a=a|0;return (c[a+12>>2]|0)+4|0}function imb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+176|0;j=a+180|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+184>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+184>>2]=h;c[a+536>>2]=0;i=d;return}function jmb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=0,h=Im,j=0,k=Im,l=0,m=Im,n=0,o=0,p=Im,q=0,r=Im;d=i;e=ea(g[b>>2]);f=a+160|0;h=ea(e-ea(g[f>>2]));j=b+4|0;k=ea(g[j>>2]);l=a+164|0;m=ea(k-ea(g[l>>2]));n=b+8|0;k=ea(g[n>>2]);o=a+168|0;p=ea(k-ea(g[o>>2]));q=b+12|0;k=ea(g[q>>2]);b=a+172|0;r=ea(k-ea(g[b>>2]));if(ea(ea(ea(ea(h*h)+ea(m*m))+ea(p*p))+ea(r*r))==ea(0.0)){i=d;return}g[f>>2]=e;g[l>>2]=ea(g[j>>2]);g[o>>2]=ea(g[n>>2]);g[b>>2]=ea(g[q>>2]);c[a+536>>2]=0;i=d;return}function kmb(a){a=a|0;return a+176|0}function lmb(a){a=a|0;return a+160|0}function mmb(a){a=a|0;var b=0;g[a+188>>2]=ea(g[a+160>>2]);g[a+192>>2]=ea(g[a+164>>2]);g[a+196>>2]=ea(g[a+168>>2]);g[a+200>>2]=ea(g[a+172>>2]);g[a+204>>2]=ea(g[a+176>>2]);g[a+208>>2]=ea(g[a+180>>2]);g[a+212>>2]=ea(g[a+184>>2]);b=a+216|0;c[a+536>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;return}function nmb(a,b){a=a|0;b=b|0;var c=Im,d=0,e=0,f=0;c=ea(g[b>>2]);d=a+204|0;g[d>>2]=ea(c+ea(g[d>>2]));d=b+4|0;c=ea(g[d>>2]);e=a+208|0;g[e>>2]=ea(c+ea(g[e>>2]));e=b+8|0;c=ea(g[e>>2]);f=a+212|0;g[f>>2]=ea(c+ea(g[f>>2]));c=ea(g[b>>2]);b=a+176|0;g[b>>2]=ea(c+ea(g[b>>2]));c=ea(g[d>>2]);d=a+180|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[e>>2]);e=a+184|0;g[e>>2]=ea(c+ea(g[e>>2]));return}function omb(a){a=a|0;var b=Im;b=ea(g[a+240>>2]);return ea(b)}function pmb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+68|0;j=a+72|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+76>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+76>>2]=h;c[a+536>>2]=0;i=d;return}function qmb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+68>>2]);g[a+4>>2]=ea(g[b+72>>2]);g[a+8>>2]=ea(g[b+76>>2]);return}function rmb(a,b){a=a|0;b=b|0;var c=0;c=i;Mkb(a+-4|0,b);i=c;return}function smb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b+80>>2]);if(!(c<=ea(-128.0)))d=ea(+aa(+(+ea(c*ea(.693147182)))));else d=ea(0.0);c=ea(g[b+84>>2]);if(!(c<=ea(-128.0)))e=ea(+aa(+(+ea(c*ea(.693147182)))));else e=ea(0.0);c=ea(g[b+88>>2]);if(!(c<=ea(-128.0)))f=ea(+aa(+(+ea(c*ea(.693147182)))));else f=ea(0.0);c=ea(ea(1.0)-e);e=ea(ea(1.0)-f);g[a>>2]=ea(ea(1.0)-d);g[a+4>>2]=c;g[a+8>>2]=e;return}function tmb(a,b){a=a|0;b=b|0;var c=0;c=i;Okb(a+-4|0,b);i=c;return}function umb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b+92>>2]);if(!(c<=ea(-128.0)))d=ea(+aa(+(+ea(c*ea(.693147182)))));else d=ea(0.0);c=ea(g[b+96>>2]);if(!(c<=ea(-128.0)))e=ea(+aa(+(+ea(c*ea(.693147182)))));else e=ea(0.0);c=ea(g[b+100>>2]);if(!(c<=ea(-128.0)))f=ea(+aa(+(+ea(c*ea(.693147182)))));else f=ea(0.0);c=ea(ea(1.0)-e);e=ea(ea(1.0)-f);g[a>>2]=ea(ea(1.0)-d);g[a+4>>2]=c;g[a+8>>2]=e;return}function vmb(a,b){a=a|0;b=b|0;var c=0;c=i;Qkb(a+-4|0,b);i=c;return}function wmb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b+104>>2]);if(!(c<=ea(-128.0)))d=ea(+aa(+(+ea(c*ea(.693147182)))));else d=ea(0.0);c=ea(g[b+108>>2]);if(!(c<=ea(-128.0)))e=ea(+aa(+(+ea(c*ea(.693147182)))));else e=ea(0.0);c=ea(g[b+112>>2]);if(!(c<=ea(-128.0)))f=ea(+aa(+(+ea(c*ea(.693147182)))));else f=ea(0.0);c=ea(ea(1.0)-e);e=ea(ea(1.0)-f);g[a>>2]=ea(ea(1.0)-d);g[a+4>>2]=c;g[a+8>>2]=e;return}function xmb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+116|0;j=a+120|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+124>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+124>>2]=h;c[a+536>>2]=0;i=d;return}function ymb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+116>>2]);g[a+4>>2]=ea(g[b+120>>2]);g[a+8>>2]=ea(g[b+124>>2]);return}function zmb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+128|0;j=a+132|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+136>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+136>>2]=h;c[a+536>>2]=0;i=d;return}function Amb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+128>>2]);g[a+4>>2]=ea(g[b+132>>2]);g[a+8>>2]=ea(g[b+136>>2]);return}function Bmb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,j=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);b=a+140|0;j=a+144|0;if((e==ea(g[b>>2])?f==ea(g[j>>2]):0)?h==ea(g[a+148>>2]):0){i=d;return}g[b>>2]=e;g[j>>2]=f;g[a+148>>2]=h;c[a+536>>2]=0;i=d;return}function Cmb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+140>>2]);g[a+4>>2]=ea(g[b+144>>2]);g[a+8>>2]=ea(g[b+148>>2]);return}function Dmb(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=a+152|0;if(ea(g[f>>2])==b){i=d;return}g[f>>2]=b;f=e;c[f>>2]=0;c[f+4>>2]=0;zGb(a+244|0,0,e);c[a+256>>2]=0;c[a+536>>2]=0;i=d;return}function Emb(a){a=a|0;var b=Im;b=ea(g[a+152>>2]);return ea(b)}function Fmb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+156|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+536>>2]=0;i=d;return}function Gmb(a){a=a|0;var b=Im;b=ea(g[a+156>>2]);return ea(b)}function Hmb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+244|0;f=a+260|0;c[f>>2]=b;g=c[e>>2]|0;h=a+256|0;j=c[h>>2]|0;if(j>>>0>b>>>0){k=j;j=g;l=b;do{l=(c[j>>2]|0)+l|0;c[j>>2]=l-k;k=c[h>>2]|0;j=j+((l>>>0<=k>>>0&1)<<3)|0}while(l>>>0<k>>>0);if((j|0)!=(g|0)?(k=a+248|0,AGb(e,g+(c[k>>2]<<3)-j>>3),g=c[e>>2]|0,e=c[k>>2]|0,k=g+(e<<3)|0,(e|0)>0):0){e=g;g=j;while(1){if(e){j=g;a=c[j+4>>2]|0;l=e;c[l>>2]=c[j>>2];c[l+4>>2]=a}e=e+8|0;if(e>>>0>=k>>>0)break;else g=g+8|0}}}g=c[h>>2]|0;k=c[f>>2]|0;c[h>>2]=g>>>0<k>>>0?g:k;i=d;return}function Imb(a){a=a|0;return c[a+260>>2]|0}function Jmb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];clb(a+-4|0,g,d,e);i=f;return}function Kmb(a){a=a|0;return c[a+372>>2]|0}function Lmb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];elb(a+-4|0,g,d,e);i=f;return}function Mmb(a){a=a|0;return c[a+360>>2]|0}function Nmb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];glb(a+-4|0,g,d,e);i=f;return}function Omb(a){a=a|0;return c[a+408>>2]|0}function Pmb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];ilb(a+-4|0,g,d,e);i=f;return}function Qmb(a){a=a|0;return c[a+396>>2]|0}function Rmb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];klb(a+-4|0,g,d,e);i=f;return}function Smb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+8|0;h=f;c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];llb(a+-4|0,h,g,e);i=f;return}function Tmb(a){a=a|0;return ((c[a+432>>2]|0)>>>0)/3|0|0}function Umb(b){b=b|0;return (a[b+452>>0]|0)!=0|0}function Vmb(b,e){b=b|0;e=e|0;var f=0,g=0;f=i;g=b+452|0;if((e&1|0)==(d[g>>0]|0|0)){i=f;return}a[g>>0]=e&1;c[b+536>>2]=0;i=f;return}function Wmb(a){a=a|0;var b=Im;b=ea(g[a+456>>2]);return ea(b)}function Xmb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+456|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+536>>2]=0;i=d;return}function Ymb(a,b){a=a|0;b=ea(b);g[a+460>>2]=b;c[a+536>>2]=0;return}function Zmb(a){a=a|0;var b=Im;b=ea(g[a+460>>2]);return ea(b)}function _mb(a){a=a|0;return c[a+480>>2]|0}function $mb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+280|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+536>>2]=0;i=d;return}function anb(a){a=a|0;var b=Im;b=ea(g[a+280>>2]);return ea(b)}function bnb(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0;d=i;e=ea(ea(1.0)-b);if(e!=ea(0.0))f=ea(+ba(+(+e))/.6931471824645996);else f=ea(-128.0);h=a+276|0;if(f==ea(g[h>>2])){i=d;return}g[h>>2]=f;c[a+536>>2]=0;i=d;return}function cnb(a){a=a|0;var b=Im,c=Im;b=ea(g[a+276>>2]);if(!(b<=ea(-128.0)))c=ea(+aa(+(+ea(b*ea(.693147182)))));else c=ea(0.0);b=ea(ea(1.0)-c);return ea(b)}function dnb(a,b){a=a|0;b=b|0;var d=0;d=i;c[b+536>>2]=0;_la(a,b+12|0,b+284|0);i=d;return}function enb(a){a=a|0;var b=0;b=i;$la(a+284|0);c[a+536>>2]=0;i=b;return}function fnb(a){a=a|0;return c[a+288>>2]|0}function gnb(a,b,d){a=a|0;b=ea(b);d=ea(d);var e=0,f=0,h=0;e=i;f=a+308|0;h=a+312|0;if(ea(g[f>>2])==b?ea(g[h>>2])==d:0){i=e;return}g[f>>2]=b;g[h>>2]=d;c[a+536>>2]=0;i=e;return}function hnb(a){a=a|0;var b=Im;b=ea(g[a+308>>2]);return ea(b)}function inb(a){a=a|0;var b=Im;b=ea(g[a+312>>2]);return ea(b)}function jnb(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0;d=i;e=ea(ea(1.0)-b);if(e!=ea(0.0))f=ea(+ba(+(+e))/.6931471824645996);else f=ea(-128.0);h=a+316|0;if(f==ea(g[h>>2])){i=d;return}g[h>>2]=f;c[a+536>>2]=0;i=d;return}function knb(a){a=a|0;var b=Im,c=Im;b=ea(g[a+316>>2]);if(!(b<=ea(-128.0)))c=ea(+aa(+(+ea(b*ea(.693147182)))));else c=ea(0.0);b=ea(ea(1.0)-c);return ea(b)}function lnb(a,b){a=a|0;b=b|0;var d=0;d=i;c[b+536>>2]=0;_la(a,b+12|0,b+320|0);i=d;return}function mnb(a){a=a|0;var b=0;b=i;$la(a+320|0);c[a+536>>2]=0;i=b;return}function nnb(a){a=a|0;return c[a+324>>2]|0}function onb(a){a=a|0;var b=0;b=i;Jlb(a+-4|0);i=b;return}function pnb(a){a=a|0;return c[a+348>>2]|0}function qnb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+492|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+536>>2]=0;i=d;return}function rnb(a){a=a|0;var b=Im;b=ea(g[a+492>>2]);return ea(b)}function snb(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=Im,h=0;d=i;e=ea(ea(1.0)-b);if(e!=ea(0.0))f=ea(+ba(+(+e))/.6931471824645996);else f=ea(-128.0);h=a+496|0;if(f==ea(g[h>>2])){i=d;return}g[h>>2]=f;c[a+536>>2]=0;i=d;return}function tnb(a){a=a|0;var b=Im,c=Im;b=ea(g[a+496>>2]);if(!(b<=ea(-128.0)))c=ea(+aa(+(+ea(b*ea(.693147182)))));else c=ea(0.0);b=ea(ea(1.0)-c);return ea(b)}function unb(a){a=a|0;return c[a+504>>2]|0}function vnb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=c[b>>2]|0;f=a+512|0;s_a(f,(c[b+4>>2]|0)-e>>4);b=c[f>>2]|0;f=c[a+516>>2]|0;h=b+(f<<4)|0;if((f|0)>0){j=b;k=e}else{l=a+536|0;c[l>>2]=0;i=d;return}while(1){if(j){g[j>>2]=ea(g[k>>2]);g[j+4>>2]=ea(g[k+4>>2]);g[j+8>>2]=ea(g[k+8>>2]);g[j+12>>2]=ea(g[k+12>>2])}j=j+16|0;if(j>>>0>=h>>>0)break;else k=k+16|0}l=a+536|0;c[l>>2]=0;i=d;return}function wnb(a){a=a|0;return c[a+516>>2]|0}function xnb(a){a=a|0;return a+44|0}function ynb(a){a=a|0;return a+56|0}function znb(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+532|0;if(ea(g[e>>2])==b){i=d;return}g[e>>2]=b;c[a+536>>2]=0;i=d;return}function Anb(a){a=a|0;var b=Im;b=ea(g[a+532>>2]);return ea(b)}function Bnb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+524|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;c[a+536>>2]=0;i=d;return}function Cnb(a){a=a|0;return c[a+524>>2]|0}function Dnb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+528|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;c[a+536>>2]=0;i=d;return}function Enb(a){a=a|0;return c[a+528>>2]|0}function Fnb(a){a=a|0;return c[a+536>>2]|0}function Gnb(a){a=a|0;return (c[a+536>>2]|0)>>>0>=(c[a+528>>2]|0)>>>0|0}function Hnb(a){a=a|0;c[a+536>>2]=c[a+528>>2];return}function Inb(a){a=a|0;c[a+536>>2]=0;return}function Jnb(a,b){a=a|0;b=b|0;c[a+544>>2]=b;return}function Knb(a){a=a|0;return c[a+544>>2]|0}function Lnb(a,b){a=a|0;b=ea(b);g[a+80>>2]=b;return}function Mnb(a){a=a|0;var b=Im;b=ea(g[a+80>>2]);return ea(b)}function Nnb(a,b){a=a|0;b=ea(b);g[a+84>>2]=b;return}function Onb(a){a=a|0;var b=Im;b=ea(g[a+84>>2]);return ea(b)}function Pnb(a,b){a=a|0;b=b|0;c[a+88>>2]=b;return}function Qnb(a){a=a|0;return c[a+88>>2]|0}function Rnb(a,b){a=a|0;b=b|0;c[a+92>>2]=b;return}function Snb(a){a=a|0;return 0}function Tnb(a,b){a=a|0;b=ea(b);g[a+-4+80>>2]=b;return}function Unb(a){a=a|0;var b=Im;b=ea(g[a+-4+80>>2]);return ea(b)}function Vnb(a,b){a=a|0;b=ea(b);g[a+-4+84>>2]=b;return}function Wnb(a){a=a|0;var b=Im;b=ea(g[a+-4+84>>2]);return ea(b)}function Xnb(a,b){a=a|0;b=b|0;c[a+-4+88>>2]=b;return}function Ynb(a){a=a|0;return c[a+-4+88>>2]|0}function Znb(a,b){a=a|0;b=b|0;c[a+-4+92>>2]=b;return}function _nb(a){a=a|0;return 0}function $nb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function aob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function cob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function dob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function eob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function fob(a){a=a|0;return 483552}function gob(a){a=a|0;return 483536}function hob(a){a=a|0;return 483512}function iob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function job(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function kob(a){a=a|0;return 483616}function lob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function mob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function nob(a){a=a|0;return 483592}function oob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function pob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function qob(a){a=a|0;return 483568}function rob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function sob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function tob(a){a=a|0;return 482968}function uob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function vob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function wob(a){a=a|0;return 482944}function xob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function yob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function zob(a){a=a|0;return 482920}function Aob(a){a=a|0;return 1}function Bob(b,d){b=b|0;d=d|0;c[d>>2]=0;c[d+4>>2]=0;a[d+8>>0]=0;return 1}function Cob(a){a=a|0;return 0}function Dob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Eob(a,b,c){a=a|0;b=b|0;c=c|0;return -1}function Fob(a,b){a=a|0;b=b|0;return 0}function Gob(a){a=a|0;return 0}function Hob(a){a=a|0;return 0}function Iob(a){a=a|0;return 0}function Job(a){a=a|0;return c[a+236>>2]|0}function Kob(a){a=a|0;return c[a+232>>2]|0}function Lob(a){a=a|0;return c[a+248>>2]|0}function Mob(a){a=a|0;return c[a+244>>2]|0}function Nob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Oob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Pob(a){a=a|0;return 484872}function Qob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Rob(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Sob(a){a=a|0;return c[a+24>>2]|0}function Tob(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+20>>2]|0;a=c[d+112>>2]|0;e=a<<7;f=d+100|0;g=c[f>>2]|0;if((c[g+(a<<3)+4>>2]|0)!=(0-e|0)){h=g;g=0;do{c[(c[h+(g>>>7<<3)>>2]|0)+((g&127)*20|0)+12>>2]=0;g=g+1|0;h=c[f>>2]|0}while(g>>>0<((c[h+(a<<3)+4>>2]|0)+e|0)>>>0)}c[d+128>>2]=0;c[(c[d+116>>2]|0)+4>>2]=0;jsa(d);BTa(c[(c[d+264>>2]|0)+224>>2]|0,c[d+252>>2]|0);i=b;return}function Uob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Vob(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Wob(a){a=a|0;return c[a+24>>2]|0}function Xob(a){a=a|0;var b=0;b=i;msa(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function Yob(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Zob(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function _ob(a){a=a|0;return c[a+24>>2]|0}function $ob(a){a=a|0;var b=0;b=i;lsa(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function apb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function bpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function cpb(a){a=a|0;return 487616}function dpb(d){d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=Im,oa=0,pa=0,qa=0,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=Im,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=Im,Ua=0,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;f=i;i=i+112|0;h=f+32|0;j=f;k=f+104|0;l=d+28|0;m=c[l>>2]|0;n=CTa(c[m+224>>2]|0)|0;if(!n){o=mKa()|0;p=c[(c[o>>2]|0)+8>>2]|0;q=pKa()|0;r=mo[c[(c[q>>2]|0)+24>>2]&4095](q)|0;q=Bn[p&255](o,9459,r?490864:544544,490760,82)|0;if(q){r=q+19&-16;c[r+-4>>2]=r-q;q=r;if(!r)s=q;else{pya(q,m);s=q}}else s=0}else s=n;n=c[d+48>>2]|0;q=(c[d+52>>2]|0)+n|0;m=c[d+56>>2]|0;r=q>>>0<m>>>0?q:m;m=d+24|0;if(n>>>0>=r>>>0){t=0;u=d+72|0;v=c[u>>2]|0;hTa(v,t)|0;w=c[l>>2]|0;x=w+224|0;y=c[x>>2]|0;BTa(y,s);i=f;return}q=d+20|0;o=d+36|0;p=d+76|0;z=d+68|0;A=d+77|0;B=d+64|0;C=j+4|0;D=j+8|0;E=j+12|0;F=j+16|0;G=j+20|0;H=j+24|0;I=h+4|0;J=h+8|0;K=h+12|0;L=h+4|0;M=h+8|0;N=h+24|0;O=h+28|0;P=h+32|0;Q=h+16|0;R=h+20|0;S=h+64|0;T=h+66|0;U=h+56|0;V=h+52|0;W=h+60|0;X=h+12|0;Y=h+48|0;Z=h+68|0;_=h+36|0;$=h+40|0;aa=h+44|0;ba=d+32|0;ca=n;n=c[d+60>>2]|0;da=0;while(1){fa=c[m>>2]|0;if(n>>>0>=fa>>>0){t=da;ga=89;break}ha=n+1|0;if(ha>>>0<fa>>>0){ia=c[q>>2]|0;ja=ha;while(1){ka=ja+1|0;if((c[(c[ia+(ja<<2)>>2]|0)+56>>2]|0)!=(ca|0)){la=ja;break}if(ka>>>0<fa>>>0)ja=ka;else{la=ka;break}}if(la>>>0>ha>>>0){FGb((c[q>>2]|0)+(n<<2)|0,la-n|0,k,h);ma=la}else ma=la}else ma=ha;a:do if(n>>>0<ma>>>0){ja=(ca|0)==0;fa=ca+-1|0;na=ea(g[o>>2]);ia=1;ka=n;oa=da;while(1){pa=c[(c[q>>2]|0)+(ka<<2)>>2]|0;qa=pa+28|0;ra=ea(g[qa>>2]);if(ra>ea(1.0)){sa=oa;break a}ta=c[pa>>2]|0;if(!ta)ua=0;else ua=(b[(c[ta+60>>2]|0)+2>>1]|0)==0;ta=pa+4|0;va=c[ta>>2]|0;if(!va)wa=0;else wa=(b[(c[va+60>>2]|0)+2>>1]|0)==0;b:do if(ua|wa){do if(!(c[pa+100>>2]|0)){ea(dsa(pa,s,na,0));va=ka+1|0;if(va>>>0>=ma>>>0){xa=ea(g[qa>>2]);break}ya=c[q>>2]|0;za=c[ya+(va<<2)>>2]|0;Aa=ea(g[za+28>>2]);Ba=ea(g[qa>>2]);if(Aa<Ba){Ca=Aa;Da=ya;ya=za;za=va;va=ka;while(1){if(!(Ca<Ba)){Ea=Da;Fa=va;break}c[Da+(va<<2)>>2]=ya;Ga=za+1|0;Ha=c[q>>2]|0;if(Ga>>>0>=ma>>>0){Ea=Ha;Fa=za;break}Ia=c[Ha+(Ga<<2)>>2]|0;Ja=za;Ca=ea(g[Ia+28>>2]);Da=Ha;ya=Ia;za=Ga;va=Ja}c[Ea+(Fa<<2)>>2]=pa;Ka=na;La=ia;Ma=ka+-1|0;Na=oa;break b}else xa=Ba}else xa=ra;while(0);do if((xa<=ea(3402823469999999843913219.0e14)?(a[pa+69>>0]|0)!=0:0)?(mta(c[l>>2]|0)|0)!=0:0){va=pa+36|0;g[h>>2]=ea(g[va>>2]);za=pa+40|0;g[L>>2]=ea(g[za>>2]);ya=pa+44|0;g[M>>2]=ea(g[ya>>2]);Da=pa+16|0;g[N>>2]=ea(g[Da>>2]);Ja=pa+20|0;g[O>>2]=ea(g[Ja>>2]);Ga=pa+24|0;g[P>>2]=ea(g[Ga>>2]);c[Q>>2]=-1;c[R>>2]=c[pa+72>>2];b[S>>1]=b[pa+76>>1]|0;b[T>>1]=b[pa+78>>1]|0;Ia=pa+80|0;g[U>>2]=ea(g[Ia>>2]);Ha=pa+84|0;g[V>>2]=ea(g[Ha>>2]);Oa=pa+88|0;g[W>>2]=ea(g[Oa>>2]);g[X>>2]=ea(0.0);g[Y>>2]=ea(3402823469999999843913219.0e14);c[Z>>2]=0;g[_>>2]=ea(0.0);g[$>>2]=ea(0.0);g[aa>>2]=ea(0.0);Pa=c[pa+8>>2]|0;Qa=c[pa+12>>2]|0;nsa(c[ba>>2]|0,h,1,c[Pa>>2]|0,c[Qa>>2]|0,c[Pa+4>>2]|0,c[Qa+4>>2]|0,c[pa>>2]|0,c[ta>>2]|0);if(ea(g[Y>>2])==ea(0.0)){g[qa>>2]=ea(3402823469999999843913219.0e14);Ka=na;La=ia;Ma=ka;Na=oa;break b}else{g[Ia>>2]=ea(g[U>>2]);g[Ha>>2]=ea(g[V>>2]);g[Oa>>2]=ea(g[W>>2]);g[va>>2]=ea(g[h>>2]);g[za>>2]=ea(g[L>>2]);g[ya>>2]=ea(g[M>>2]);g[Da>>2]=ea(g[N>>2]);g[Ja>>2]=ea(g[O>>2]);g[Ga>>2]=ea(g[P>>2]);break}}while(0);Ga=c[pa>>2]|0;if((Ga|0)!=0?(b[(c[Ga+60>>2]|0)+2>>1]|0)==0:0)Ra=0;else Ra=(Ga|0)!=0;Ga=c[ta>>2]|0;if((Ga|0)!=0?(b[(c[Ga+60>>2]|0)+2>>1]|0)==0:0)Sa=0;else Sa=(Ga|0)!=0;if(!(!(ea(g[qa>>2])<=ea(1.0))|Ra|Sa))a[pa+68>>0]=1;Ga=gsa(pa,na,(a[p>>0]|0)!=0)|0;Ca=ea(g[qa>>2]);if(Ca<ea(0.0)){g[qa>>2]=ea(0.0);Ta=ea(0.0)}else Ta=Ca;if(!(!(Ta<=ea(1.0))|Ga^1)){Ga=oa+1|0;Ja=c[z>>2]|0;if(ja)Ua=0;else Ua=e[Ja+(fa<<1)>>1]|0;Da=e[Ja+(ca<<1)>>1]|0;c:do if(Ta>ea(0.0)){if(Ua>>>0<Da>>>0){Ja=Ua;do{ya=c[(c[B>>2]|0)+(Ja<<2)>>2]|0;if(!(b[ya+2>>1]|0)){za=c[ya+8>>2]|0;Ca=ea(g[qa>>2]);ya=c[za+64>>2]|0;if(!(ea(g[ya+124>>2])==ea(0.0))){Aa=ea(ea(1.0)-Ca);va=za+48|0;Va=ea(Aa*ea(g[va>>2]));Oa=za+52|0;Wa=ea(Aa*ea(g[Oa>>2]));Ha=za+56|0;Xa=ea(Aa*ea(g[Ha>>2]));Aa=ea(Ca*ea(g[ya+16>>2]));Ya=ea(Ca*ea(g[ya+20>>2]));Za=ea(Va+Aa);Aa=ea(Wa+Ya);Ya=ea(Xa+ea(Ca*ea(g[ya+24>>2])));g[va>>2]=Za;g[Oa>>2]=Aa;g[Ha>>2]=Ya;Ha=za+32|0;g[j>>2]=ea(g[Ha>>2]);Oa=za+36|0;g[C>>2]=ea(g[Oa>>2]);va=za+40|0;g[D>>2]=ea(g[va>>2]);Ia=za+44|0;g[E>>2]=ea(g[Ia>>2]);g[F>>2]=Za;g[G>>2]=Aa;g[H>>2]=Ya;rKa(h,Ca,j,ya);g[Ha>>2]=ea(g[h>>2]);g[Oa>>2]=ea(g[I>>2]);g[va>>2]=ea(g[J>>2]);g[Ia>>2]=ea(g[K>>2])}Ia=c[za+60>>2]|0;za=Ia+4|0;Ca=ea(g[za>>2]);Ya=ea(Ca*ea(ea(1.0)-ea(g[qa>>2])));va=Ya>ea(.00999999977);g[za>>2]=va?Ya:ea(.00999999977);va=Ia+16|0;c[va>>2]=(c[va>>2]|0)+1}Ja=Ja+1|0}while((Ja|0)!=(Da|0));_a=ea(g[qa>>2])}else _a=Ta;Ba=ea(na-ea(na*_a));Ya=ea(ea(1.0)/ea(ea(1.0)-_a));Ja=ka+1|0;if(Ja>>>0>=ma>>>0){$a=Ba;break}va=c[q>>2]|0;Ca=_a;Ia=Ja;while(1){Ja=(c[va+(Ia<<2)>>2]|0)+28|0;g[Ja>>2]=ea(Ya*ea(ea(g[Ja>>2])-Ca));Ja=Ia+1|0;if((Ja|0)==(ma|0)){$a=Ba;break c}Ca=ea(g[qa>>2]);Ia=Ja}}else $a=na;while(0);do if(!(a[A>>0]|0)){if(a[(c[pa+52>>2]|0)+35>>0]|0)break;Da=c[pa>>2]|0;Ia=(Da|0)==0?0:Da;Da=c[ta>>2]|0;va=(Da|0)==0?0:Da;Da=ka+1|0;if(Da>>>0<ma>>>0)ab=Da;else break;do{Da=c[(c[q>>2]|0)+(ab<<2)>>2]|0;Ja=c[Da>>2]|0;za=(Ja|0)==0;if(za)bb=c[Da+8>>2]|0;else bb=Ja;Ja=c[Da+4>>2]|0;Oa=(Ja|0)==0;if(Oa)cb=c[Da+12>>2]|0;else cb=Ja;d:do if(za|Oa)db=ab;else{do if((bb|0)!=(Ia|0)|(cb|0)==(va|0)){if(!((cb|0)!=(Ia|0)|(bb|0)==(va|0)))break;if(!((bb|0)!=(va|0)|(cb|0)==(Ia|0)))break;if((cb|0)!=(va|0)|(bb|0)==(Ia|0)){db=ab;break d}}while(0);Ja=Da+92|0;if((ia|0)==(c[Ja>>2]|0)){db=ab;break}c[Ja>>2]=ia;Ca=ea(g[Da+28>>2]);Ba=ea(fsa(Da));if(Ba<Ca){Ja=ab+-1|0;if(Ja>>>0>ka>>>0){eb=Ja;fb=ab}else{db=ab;break}while(1){Ja=c[q>>2]|0;Ha=Ja+(eb<<2)|0;ya=c[Ha>>2]|0;if(!(ea(g[ya+28>>2])>Ba)){db=ab;break d}c[Ha>>2]=c[Ja+(fb<<2)>>2];c[(c[q>>2]|0)+(fb<<2)>>2]=ya;ya=eb+-1|0;if(ya>>>0>ka>>>0){Ja=eb;eb=ya;fb=Ja}else{db=ab;break d}}}if(!(Ba>Ca)){db=ab;break}Ja=ab+1|0;e:do if(Ja>>>0<ma>>>0){ya=Ja;Ha=ab;Qa=0;while(1){Pa=c[q>>2]|0;gb=Pa+(ya<<2)|0;hb=c[gb>>2]|0;if(!(ea(g[hb+28>>2])<Ba)){ib=Qa;break e}c[gb>>2]=c[Pa+(Ha<<2)>>2];c[(c[q>>2]|0)+(Ha<<2)>>2]=hb;hb=ya+1|0;if(hb>>>0<ma>>>0){Pa=ya;ya=hb;Qa=1;Ha=Pa}else{ib=1;break}}}else ib=0;while(0);db=ab-ib|0}while(0);ab=db+1|0}while(ab>>>0<ma>>>0)}while(0);Ka=$a;La=ia+1|0;Ma=ka;Na=Ga}else{Ka=na;La=ia;Ma=ka;Na=oa}}else{Ka=na;La=ia;Ma=ka;Na=oa}while(0);ka=Ma+1|0;if(ka>>>0>=ma>>>0){sa=Na;break}else{na=Ka;ia=La;oa=Na}}}else sa=da;while(0);ca=ca+1|0;if(ca>>>0>=r>>>0){t=sa;ga=89;break}else{n=ma;da=sa}}if((ga|0)==89){u=d+72|0;v=c[u>>2]|0;hTa(v,t)|0;w=c[l>>2]|0;x=w+224|0;y=c[x>>2]|0;BTa(y,s);i=f;return}}function epb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function fpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function gpb(a){a=a|0;return 487688}function hpb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+24|0;if(!(c[d>>2]|0)){i=b;return}e=a+20|0;a=0;do{f=c[(c[e>>2]|0)+(a<<2)>>2]|0;ea(fsa(f));c[f+92>>2]=0;a=a+1|0}while(a>>>0<(c[d>>2]|0)>>>0);i=b;return}function ipb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function jpb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function kpb(a){a=a|0;return c[a+24>>2]|0}function lpb(a){a=a|0;var b=0;b=i;_sa(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function mpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function npb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function opb(a){a=a|0;return c[a+24>>2]|0}function ppb(a){a=a|0;var b=0;b=i;Ysa(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function qpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function rpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function spb(a){a=a|0;return 489656}function tpb(a){a=a|0;var b=0,d=0;b=i;d=c[a+12>>2]|0;ko[c[c[a>>2]>>2]&4095](a);if(!d){i=b;return}ko[c[(c[d>>2]|0)+20>>2]&4095](d);i=b;return}function upb(b){b=b|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;f=b+156|0;h=c[f>>2]|0;j=c[h+6736>>2]|0;k=c[j+8>>2]|0;l=j;j=c[l>>2]|0;m=c[l+4>>2]|0;l=e[268316]|e[268317]<<16;n=(k|0)==0|(l&16711680|0)==0;if(n)o=h;else{Dn[c[(c[k>>2]|0)+8>>2]&511](k,l&65535,j,m);o=c[f>>2]|0}h=CTa(c[o+224>>2]|0)|0;if(!h){p=mKa()|0;q=c[(c[p>>2]|0)+8>>2]|0;r=pKa()|0;s=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=Bn[q&255](p,9459,s?490864:544544,490760,82)|0;if(r){s=r+19&-16;c[s+-4>>2]=s-r;r=s;if(!s)t=r;else{pya(r,o);t=r}}else t=0}else t=h;h=t+16|0;g[t+8764>>2]=ea(g[b+152>>2]);r=c[f>>2]|0;o=a[r+7376>>0]|0;a[t+8784>>0]=o;a[t+8787>>0]=a[r+7378>>0]|0;a[t+8785>>0]=a[r+7377>>0]|0;c[t+8776>>2]=c[r+7372>>2];c[t+8780>>2]=r+7384;r=c[b+148>>2]|0;s=t+9384|0;p=t+9388|0;q=t+9380|0;if(!(o<<24>>24)){o=0;u=0;v=0;a:while(1){w=o;x=v;while(1){y=w;while(1){if(y>>>0>=r>>>0)break a;z=y+1|0;A=b+(y<<2)+20|0;B=c[A>>2]|0;C=(e[B+114>>1]|0)&2;nAa(h,B+16|0);D=c[A>>2]|0;E=(e[D+114>>1]|0)&2;if(E<<16>>16==C<<16>>16)y=z;else break}y=c[D+76>>2]|0;C=(y+32|0)>>>5;if(C>>>0>(c[s>>2]&2147483647)>>>0){A=UJa(p,C<<2,543784,339)|0;B=c[q>>2]|0;if((B|0)!=0?(YEi(A|0,B|0,c[s>>2]<<2|0)|0,(c[s>>2]|0)>-1):0)VJa(p,c[q>>2]|0);B=c[s>>2]|0;PEi(A+((B&2147483647)<<2)|0,0,C-B<<2|0)|0;c[q>>2]=A;c[s>>2]=C;F=A}else F=c[q>>2]|0;A=F+(y>>>5<<2)|0;c[A>>2]=c[A>>2]|1<<(y&31);if(!(E<<16>>16))break;else{w=z;x=x+1|0}}o=z;u=u+1|0;v=x}v=t+9392|0;c[v>>2]=(c[v>>2]|0)+x;x=t+9396|0;c[x>>2]=(c[x>>2]|0)+u;BTa(c[(c[f>>2]|0)+224>>2]|0,t)}else{u=0;x=0;v=0;b:while(1){z=u;G=v;while(1){o=z;while(1){if(o>>>0>=r>>>0)break b;H=o+1|0;E=b+(o<<2)+20|0;F=c[E>>2]|0;D=(e[F+114>>1]|0)&2;oAa(h,F+16|0);I=c[E>>2]|0;J=(e[I+114>>1]|0)&2;if(J<<16>>16==D<<16>>16)o=H;else break}o=c[I+76>>2]|0;D=(o+32|0)>>>5;if(D>>>0>(c[s>>2]&2147483647)>>>0){E=UJa(p,D<<2,543784,339)|0;F=c[q>>2]|0;if((F|0)!=0?(YEi(E|0,F|0,c[s>>2]<<2|0)|0,(c[s>>2]|0)>-1):0)VJa(p,c[q>>2]|0);F=c[s>>2]|0;PEi(E+((F&2147483647)<<2)|0,0,D-F<<2|0)|0;c[q>>2]=E;c[s>>2]=D;K=E}else K=c[q>>2]|0;E=K+(o>>>5<<2)|0;c[E>>2]=c[E>>2]|1<<(o&31);if(!(J<<16>>16))break;else{z=H;G=G+1|0}}u=H;x=x+1|0;v=G}v=t+9392|0;c[v>>2]=(c[v>>2]|0)+G;G=t+9396|0;c[G>>2]=(c[G>>2]|0)+x;BTa(c[(c[f>>2]|0)+224>>2]|0,t)}if(n){i=d;return}Dn[c[(c[k>>2]|0)+12>>2]&511](k,l&65535,j,m);i=d;return}function vpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function wpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function xpb(a){a=a|0;return 490672}function ypb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function zpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Apb(a){a=a|0;return 490632}function Bpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Cpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Dpb(a){a=a|0;return 490744}function Epb(a){a=a|0;var b=0,d=Im,e=Im,f=Im,h=Im;b=i;d=ea(g[a+28>>2]);e=ea(g[a+24>>2]);f=ea(g[a+32>>2]);h=ea(g[a+36>>2]);Ita(c[a+20>>2]|0,0,c[a+48>>2]|0,0,c[a+60>>2]|0,c[a+52>>2]|0,d,e,f,h,c[a+64>>2]|0,c[a+56>>2]|0)|0;i=b;return}function Fpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Gpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Hpb(a){a=a|0;return 491032}function Ipb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+80|0;d=b;e=a+24|0;f=c[e>>2]|0;g=c[f+9144>>2]|0;h=c[f+9148>>2]|0;j=c[f+9156>>2]|0;k=c[f+9316>>2]|0;l=c[(c[a+20>>2]|0)+100>>2]|0;m=c[a+64>>2]|0;c[f+8952>>2]=h;c[(c[e>>2]|0)+8952>>2]=0;c[(c[e>>2]|0)+9092>>2]=0;c[(c[e>>2]|0)+9100>>2]=0;c[(c[e>>2]|0)+8956>>2]=0;c[(c[e>>2]|0)+9104>>2]=0;c[(c[e>>2]|0)+9096>>2]=0;if(!h){PEi((c[e>>2]|0)+8816|0,0,132)|0;i=b;return}else{c[d>>2]=l+(m<<5);m=c[e>>2]|0;c[d+8>>2]=c[m+9368>>2];c[d+16>>2]=g;c[d+24>>2]=j;c[d+12>>2]=c[m+9372>>2];c[d+4>>2]=c[a+48>>2];c[d+20>>2]=h;c[d+28>>2]=k-j>>5;c[d+32>>2]=c[m+9168>>2];c[d+40>>2]=c[m+9276>>2];j=d+44|0;c[j>>2]=0;k=d+52|0;c[k>>2]=0;h=d+48|0;c[h>>2]=0;c[d+56>>2]=m+9180;c[d+60>>2]=m+9192;c[d+64>>2]=m+8816;c[d+68>>2]=m+8960;m=qsa(d)|0;c[(c[e>>2]|0)+9284>>2]=m;c[(c[e>>2]|0)+8952>>2]=c[h>>2];c[(c[e>>2]|0)+9092>>2]=c[k>>2];c[(c[e>>2]|0)+9100>>2]=c[j>>2];i=b;return}}function Jpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Kpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Lpb(a){a=a|0;return 491192}
function Mpb(f){f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=Im,ta=0,ua=0,va=0,wa=0;h=i;i=i+16|0;j=h;k=f+24|0;l=c[k>>2]|0;m=c[l+9168>>2]|0;n=f+20|0;o=c[n>>2]|0;p=f+64|0;q=(c[o+100>>2]|0)+(c[p>>2]<<5)|0;r=c[o+112>>2]|0;o=c[l+8956>>2]|0;s=c[l+9252>>2]|0;if(!s){t=l;u=0;v=m;w=0;x=0}else{y=l;l=0;z=0;A=m;B=0;C=0;while(1){D=b[(c[y+9180>>2]|0)+(l<<3)+4>>1]|0;if(D<<16>>16){E=D+-1<<16>>16&65535;F=0;G=A;H=B;I=C;J=D;while(1){K=m+(H<<5)|0;if(!(b[m+(H<<5)+26>>1]|0)){L=G;M=I;N=J+-1<<16>>16}else{if((H|0)!=(I|0)){O=m+(I<<5)|0;c[O+0>>2]=c[K+0>>2];c[O+4>>2]=c[K+4>>2];c[O+8>>2]=c[K+8>>2];c[O+12>>2]=c[K+12>>2];c[O+16>>2]=c[K+16>>2];c[O+20>>2]=c[K+20>>2];c[O+24>>2]=c[K+24>>2];c[O+28>>2]=c[K+28>>2]}L=G+32|0;M=I+1|0;N=J}F=F+1<<16>>16;if((F&65535)>=(D&65535))break;else{G=L;H=H+1|0;I=M;J=N}}J=B+1+E|0;if(!(N<<16>>16)){P=z;Q=L;R=J;S=M}else{c[(c[(c[k>>2]|0)+9180>>2]|0)+(z<<3)>>2]=C;b[(c[(c[k>>2]|0)+9180>>2]|0)+(z<<3)+4>>1]=N;b[(c[(c[k>>2]|0)+9180>>2]|0)+(z<<3)+6>>1]=d[c[m+(C<<5)+16>>2]>>0]|0;P=z+1|0;Q=L;R=J;S=M}}else{P=z;Q=A;R=B;S=C}l=l+1|0;J=c[k>>2]|0;if((l|0)==(s|0)){t=J;u=P;v=Q;w=R;x=S;break}else{y=J;z=P;A=Q;B=R;C=S}}}S=v-m>>5;c[t+8952>>2]=S;t=c[k>>2]|0;v=c[t+9100>>2]|0;if(!v){T=t;U=u;V=x}else{C=t;t=0;R=u;B=w;w=x;while(1){x=c[C+9276>>2]|0;Q=c[x+(t<<4)+4>>2]|0;if(!Q){W=x;X=R;Y=B;Z=w}else{x=0;A=R;P=B;z=w;while(1){y=m+(P<<5)|0;if(!(b[m+(P<<5)+26>>1]|0)){_=A;$=z}else{s=c[(c[k>>2]|0)+9180>>2]|0;b[s+(A<<3)+4>>1]=1;c[s+(A<<3)>>2]=z;b[s+(A<<3)+6>>1]=d[c[m+(P<<5)+16>>2]>>0]|0;if((P|0)!=(z|0)){s=m+(z<<5)|0;c[s+0>>2]=c[y+0>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];c[s+12>>2]=c[y+12>>2];c[s+16>>2]=c[y+16>>2];c[s+20>>2]=c[y+20>>2];c[s+24>>2]=c[y+24>>2];c[s+28>>2]=c[y+28>>2]}_=A+1|0;$=z+1|0}x=x+1|0;if((x|0)==(Q|0))break;else{A=_;P=P+1|0;z=$}}W=c[(c[k>>2]|0)+9276>>2]|0;X=_;Y=B+Q|0;Z=$}c[W+(t<<4)>>2]=w;c[(c[(c[k>>2]|0)+9276>>2]|0)+(t<<4)+4>>2]=Z-w;t=t+1|0;z=c[k>>2]|0;if((t|0)==(v|0)){T=z;U=X;V=Z;break}else{C=z;R=X;B=Y;w=Z}}}c[T+9184>>2]=U;U=f+48|0;T=c[k>>2]|0;Z=tsa(q,c[U>>2]|0,c[T+9368>>2]|0,c[T+9372>>2]|0,m,S,c[T+9276>>2]|0,c[T+9100>>2]|0)|0;c[(c[k>>2]|0)+9092>>2]=V-S;c[(c[k>>2]|0)+9260>>2]=V;S=c[k>>2]|0;if(!(c[S+8776>>2]|0))aa=o;else{o=c[S+9156>>2]|0;T=S+9192|0;w=S+9196|0;c[w>>2]=0;Y=c[(c[k>>2]|0)+9184>>2]|0;if((c[S+9200>>2]&2147483647)>>>0<Y>>>0)X$a(T,Y);Y=c[T>>2]|0;if(!u){ba=Y;ca=0;da=o;fa=Y}else{S=0;B=0;X=o;R=Y;while(1){Y=c[(c[k>>2]|0)+9180>>2]|0;C=Y+(S<<3)|0;v=b[Y+(S<<3)+4>>1]|0;switch(b[Y+(S<<3)+6>>1]|0){case 8:case 7:{Y=c[C>>2]|0;t=c[m+(Y<<5)+16>>2]|0;W=e[t+2>>1]|0;$=t+W|0;t=a[$>>0]|0;_=((e[m+(Y<<5)+26>>1]<<4)-W|0)>>>4&65535;b[X+26>>1]=_;c[X+16>>2]=$;c[X>>2]=c[m+(Y<<5)>>2];c[X+4>>2]=c[m+(Y<<5)+4>>2];b[X+10>>1]=b[m+(Y<<5)+10>>1]|0;b[X+14>>1]=b[m+(Y<<5)+14>>1]|0;b[X+8>>1]=b[m+(Y<<5)+8>>1]|0;b[X+12>>1]=b[m+(Y<<5)+12>>1]|0;c[X+20>>2]=0;b[X+24>>1]=0;W=Y+1|0;b[X+58>>1]=_;c[X+48>>2]=$;c[X+32>>2]=c[m+(W<<5)>>2];c[X+36>>2]=c[m+(W<<5)+4>>2];b[X+42>>1]=b[m+(W<<5)+10>>1]|0;b[X+46>>1]=b[m+(W<<5)+14>>1]|0;b[X+40>>1]=b[m+(W<<5)+8>>1]|0;b[X+44>>1]=b[m+(W<<5)+12>>1]|0;c[X+52>>2]=0;b[X+56>>1]=0;W=Y+2|0;b[X+90>>1]=_;c[X+80>>2]=$;c[X+64>>2]=c[m+(W<<5)>>2];c[X+68>>2]=c[m+(W<<5)+4>>2];b[X+74>>1]=b[m+(W<<5)+10>>1]|0;b[X+78>>1]=b[m+(W<<5)+14>>1]|0;b[X+72>>1]=b[m+(W<<5)+8>>1]|0;b[X+76>>1]=b[m+(W<<5)+12>>1]|0;c[X+84>>2]=0;b[X+88>>1]=0;W=Y+3|0;b[X+122>>1]=_;c[X+112>>2]=$;c[X+96>>2]=c[m+(W<<5)>>2];c[X+100>>2]=c[m+(W<<5)+4>>2];b[X+106>>1]=b[m+(W<<5)+10>>1]|0;b[X+110>>1]=b[m+(W<<5)+14>>1]|0;b[X+104>>1]=b[m+(W<<5)+8>>1]|0;b[X+108>>1]=b[m+(W<<5)+12>>1]|0;c[X+116>>2]=0;b[X+120>>1]=0;c[R>>2]=B;b[R+4>>1]=v;b[R+6>>1]=t&255;ga=(v&65535)+B|0;ha=X+128|0;ia=R+8|0;break}case 5:case 3:case 1:{if(!(v<<16>>16)){ja=X;ka=0}else{t=v+-1<<16>>16&65535;W=c[C>>2]|0;C=X;$=0;while(1){_=W+$|0;Y=c[m+(_<<5)+16>>2]|0;z=e[Y+2>>1]|0;la=Y+z|0;b[C+26>>1]=((e[m+(_<<5)+26>>1]<<4)-z|0)>>>4;c[C+16>>2]=la;c[C>>2]=c[m+(_<<5)>>2];c[C+4>>2]=c[m+(_<<5)+4>>2];b[C+10>>1]=b[m+(_<<5)+10>>1]|0;b[C+14>>1]=b[m+(_<<5)+14>>1]|0;b[C+8>>1]=b[m+(_<<5)+8>>1]|0;b[C+12>>1]=b[m+(_<<5)+12>>1]|0;c[C+20>>2]=0;b[C+24>>1]=0;$=$+1|0;if(($&65535)<<16>>16==v<<16>>16)break;else C=C+32|0}ja=X+(t+1<<5)|0;ka=d[la>>0]|0}c[R>>2]=B;b[R+4>>1]=v;b[R+6>>1]=ka;ga=(v&65535)+B|0;ha=ja;ia=R+8|0;break}default:{ga=B;ha=X;ia=R}}S=S+1|0;if((S|0)==(u|0))break;else{B=ga;X=ha;R=ia}}ba=c[T>>2]|0;ca=ga;da=ha;fa=ia}ia=da-o>>5;c[(c[k>>2]|0)+8956>>2]=ia;c[w>>2]=fa-ba>>3;ba=c[k>>2]|0;usa(q,c[U>>2]|0,c[ba+9368>>2]|0,c[ba+9372>>2]|0,o,ia,c[ba+9280>>2]|0,c[ba+9104>>2]|0);c[(c[k>>2]|0)+9096>>2]=ca-ia;c[(c[k>>2]|0)+8956>>2]=ia;c[(c[k>>2]|0)+9264>>2]=ca;aa=ca}ca=c[(c[(c[n>>2]|0)+96>>2]|0)+6736>>2]|0;ia=c[ca+8>>2]|0;ba=ca;ca=c[ba>>2]|0;o=c[ba+4>>2]|0;Dn[c[(c[ia>>2]|0)+8>>2]&511](ia,85,ca,o);ba=c[k>>2]|0;fa=c[ba+9168>>2]|0;w=c[ba+9156>>2]|0;da=ba+9320|0;c[da+0>>2]=0;c[da+4>>2]=0;c[da+8>>2]=0;c[da+12>>2]=0;c[da+16>>2]=0;c[da+20>>2]=0;ha=ba+9324|0;ga=ba+9328|0;T=ba+9332|0;R=ba+9336|0;X=ba+9340|0;ba=c[f+8>>2]|0;B=mo[c[(c[ba>>2]|0)+16>>2]&4095](ba)|0;ba=mo[c[(c[B>>2]|0)+4>>2]&4095](B)|0;B=((V>>>0)/(((Z<<4)+16|0)>>>0)|0)+1|0;if((B>>>0<ba>>>0?B:ba)>>>0>1){B=f+12|0;u=f+56|0;S=f+32|0;ja=f+52|0;ka=f+28|0;la=~ba;ba=-2-((V>>>0)/(((Z<<4)+16|0)>>>0)|0)|0;Z=~(ba>>>0<la>>>0?la:ba);ba=c[(c[n>>2]|0)+96>>2]|0;la=1;do{m=c[ba+6732>>2]|0;oTa(c[m>>2]|0);C=vXa(m,140,16)|0;pTa(c[m>>2]|0);if(!C)ma=0;else{m=c[n>>2]|0;$=c[k>>2]|0;W=c[$+8776>>2]|0;Q=c[$+9292>>2]|0;_=c[$+9296>>2]|0;z=c[p>>2]|0;Y=c[U>>2]|0;P=c[$+9368>>2]|0;A=c[$+9372>>2]|0;x=c[$+9344>>2]|0;E=c[u>>2]|0;y=c[$+9132>>2]|0;s=c[$+9108>>2]|0;l=c[S>>2]|0;M=c[ja>>2]&2147483647;L=c[ka>>2]|0;b[C+4>>1]=-1;b[C+6>>1]=0;c[C+8>>2]=0;c[C>>2]=443968;c[C+12>>2]=0;c[C+16>>2]=0;c[C>>2]=491128;c[C+20>>2]=$+9180;c[C+24>>2]=$+9192;c[C+28>>2]=m;c[C+32>>2]=Q;c[C+36>>2]=_;c[C+40>>2]=q;c[C+44>>2]=r;c[C+48>>2]=z;c[C+52>>2]=Y;c[C+56>>2]=fa;c[C+60>>2]=w;c[C+64>>2]=P;c[C+68>>2]=y;c[C+72>>2]=s;c[C+76>>2]=l;c[C+80>>2]=M;c[C+84>>2]=V;c[C+88>>2]=aa;c[C+92>>2]=A;c[C+96>>2]=$+9400;c[C+100>>2]=da;c[C+104>>2]=X;c[C+108>>2]=ha;c[C+112>>2]=ga;c[C+116>>2]=T;c[C+120>>2]=R;c[C+124>>2]=x;c[C+128>>2]=E;c[C+132>>2]=W;c[C+136>>2]=L;ma=C}C=c[B>>2]|0;c[ma+16>>2]=1;L=ma+12|0;c[L>>2]=C;if(C){ko[c[(c[C>>2]|0)+16>>2]&4095](C);c[ma+8>>2]=c[(c[L>>2]|0)+8>>2]}ko[c[(c[ma>>2]|0)+20>>2]&4095](ma);la=la+1|0;na=c[n>>2]|0;ba=c[na+96>>2]|0}while((la|0)!=(Z|0));Z=c[ba+6736>>2]|0;ba=c[Z+8>>2]|0;la=Z;Z=c[la>>2]|0;ma=c[la+4>>2]|0;la=e[268296]|e[268297]<<16;B=(ba|0)==0|(la&16711680|0)==0;if(B)oa=na;else{Dn[c[(c[ba>>2]|0)+8>>2]&511](ba,la&65535,Z,ma);oa=c[n>>2]|0}na=c[k>>2]|0;ka=f+52|0;Go[c[489992+(c[na+8776>>2]<<2)>>2]&3](oa,c[na+9292>>2]|0,c[na+9296>>2]|0,q,r,c[p>>2]|0,c[U>>2]|0,c[na+9368>>2]|0,c[na+9372>>2]|0,fa,V,w,aa,da,X,ha,T,c[na+9344>>2]|0,c[f+56>>2]|0,ga,c[na+9132>>2]|0,c[na+9108>>2]|0,na+9400|0,c[f+32>>2]|0,c[ka>>2]&2147483647,R,na+9180|0,na+9192|0,c[f+28>>2]|0);if(!B)Dn[c[(c[ba>>2]|0)+12>>2]&511](ba,la&65535,Z,ma);ma=(c[ka>>2]&2147483647)+(c[U>>2]|0)|0;do{}while((c[R>>2]|0)<(ma|0));c[(c[k>>2]|0)+9300>>2]=c[ga>>2];pa=c[ia>>2]|0;qa=pa+12|0;ra=c[qa>>2]|0;Dn[ra&511](ia,85,ca,o);i=h;return}c[j>>2]=0;ga=c[k>>2]|0;ma=c[n>>2]|0;sa=ea(g[ma+124>>2]);Xn[c[499064+(c[ga+8776>>2]<<2)>>2]&7](c[ma+136>>2]|0,sa,c[ga+9292>>2]|0,c[ga+9296>>2]|0,q,r,c[p>>2]|0,c[U>>2]|0,c[ga+9368>>2]|0,c[ga+9372>>2]|0,fa,V,w,aa,ga+9180|0,ga+9192|0,c[ga+9132>>2]|0,c[ga+9344>>2]|0,c[f+56>>2]|0,j);c[(c[k>>2]|0)+9300>>2]=c[j>>2];if(c[U>>2]|0){j=f+28|0;ga=0;while(1){aa=c[k>>2]|0;w0a(c[(c[aa+9108>>2]|0)+(ga<<2)>>2]|0,c[(c[j>>2]|0)+(ga<<2)>>2]|0,(c[aa+9132>>2]|0)+(ga<<5)|0,ea(g[(c[n>>2]|0)+124>>2]));aa=ga+1|0;if(aa>>>0<(c[U>>2]|0)>>>0)ga=aa;else break}}ga=f+52|0;if(!(c[ga>>2]&2147483647)){pa=c[ia>>2]|0;qa=pa+12|0;ra=c[qa>>2]|0;Dn[ra&511](ia,85,ca,o);i=h;return}else ta=0;do{f=c[(c[k>>2]|0)+9368>>2]|0;U=c[(c[(c[n>>2]|0)+96>>2]|0)+6736>>2]|0;j=c[U+8>>2]|0;aa=U;U=c[aa>>2]|0;w=c[aa+4>>2]|0;aa=e[268392]|e[268393]<<16;V=(j|0)==0|(aa&16711680|0)==0;if(!V)Dn[c[(c[j>>2]|0)+8>>2]&511](j,aa&65535,U,w);if(c[125132]|0)Qza(f+(ta*40|0)|0,ea(g[(c[n>>2]|0)+124>>2]));fa=f+(ta*40|0)+36|0;p=b[fa>>1]|0;if(p<<16>>16){r=f+(ta*40|0)+4|0;f=p;p=0;while(1){q=(c[(c[r>>2]|0)+(p<<5)+16>>2]|0)+68|0;ma=c[q>>2]|0;R=c[q+4>>2]|0;if((R|0)==1073741823)ua=f;else{q=c[k>>2]|0;ka=q+9400|0;Z=(R+32|0)>>>5;la=q+9404|0;if(Z>>>0>(c[la>>2]&2147483647)>>>0){ba=q+9408|0;q=UJa(ba,Z<<2,543784,339)|0;B=c[ka>>2]|0;if((B|0)!=0?(YEi(q|0,B|0,c[la>>2]<<2|0)|0,(c[la>>2]|0)>-1):0)VJa(ba,c[ka>>2]|0);ba=c[la>>2]|0;PEi(q+((ba&2147483647)<<2)|0,0,Z-ba<<2|0)|0;c[ka>>2]=q;c[la>>2]=Z;va=b[fa>>1]|0;wa=q}else{va=f;wa=c[ka>>2]|0}ka=VEi(ma|0,R|0,37)|0;ma=wa+(ka<<2)|0;c[ma>>2]=c[ma>>2]|1<<(R&31);ua=va}p=p+1|0;if(p>>>0>=(ua&65535)>>>0)break;else f=ua}}if(!V)Dn[c[(c[j>>2]|0)+12>>2]&511](j,aa&65535,U,w);ta=ta+1|0}while(ta>>>0<(c[ga>>2]&2147483647)>>>0);pa=c[ia>>2]|0;qa=pa+12|0;ra=c[qa>>2]|0;Dn[ra&511](ia,85,ca,o);i=h;return}function Npb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Opb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ppb(a){a=a|0;return 491168}function Qpb(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;f=c[d>>2]|0;g=c[(c[f+96>>2]|0)+6736>>2]|0;h=c[g+8>>2]|0;j=g;g=c[j>>2]|0;k=c[j+4>>2]|0;j=e[268296]|e[268297]<<16;l=(h|0)==0|(j&16711680|0)==0;if(l)m=f;else{Dn[c[(c[h>>2]|0)+8>>2]&511](h,j&65535,g,k);m=c[d>>2]|0}Go[c[489992+(c[a+132>>2]<<2)>>2]&3](m,c[a+32>>2]|0,c[a+36>>2]|0,c[a+40>>2]|0,c[a+44>>2]|0,c[a+48>>2]|0,c[a+52>>2]|0,c[a+64>>2]|0,c[a+92>>2]|0,c[a+56>>2]|0,c[a+84>>2]|0,c[a+60>>2]|0,c[a+88>>2]|0,c[a+100>>2]|0,c[a+104>>2]|0,c[a+108>>2]|0,c[a+116>>2]|0,c[a+124>>2]|0,c[a+128>>2]|0,c[a+112>>2]|0,c[a+68>>2]|0,c[a+72>>2]|0,c[a+96>>2]|0,c[a+76>>2]|0,c[a+80>>2]|0,c[a+120>>2]|0,c[a+20>>2]|0,c[a+24>>2]|0,c[a+136>>2]|0);if(l){i=b;return}Dn[c[(c[h>>2]|0)+12>>2]&511](h,j&65535,g,k);i=b;return}function Rpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Spb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Tpb(a){a=a|0;return 491264}function Upb(a){a=a|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im;d=i;i=i+32|0;f=d+16|0;h=d;j=a+24|0;k=c[j>>2]|0;c[k+9424>>2]=c[k+9268>>2];k=a+20|0;l=c[k>>2]|0;m=c[l+100>>2]|0;n=c[a+64>>2]|0;o=c[l+112>>2]|0;l=c[j>>2]|0;p=a+48|0;q=c[p>>2]|0;if(!q)r=l;else{s=a+28|0;a=l+9404|0;t=l+9408|0;u=l+9400|0;l=q;q=0;while(1){v=c[(c[s>>2]|0)+(q<<2)>>2]|0;w=q+n|0;x=c[v+64>>2]|0;g[x+64>>2]=ea(g[m+(w<<5)>>2]);g[x+68>>2]=ea(g[m+(w<<5)+4>>2]);g[x+72>>2]=ea(g[m+(w<<5)+8>>2]);g[x+80>>2]=ea(g[m+(w<<5)+16>>2]);g[x+84>>2]=ea(g[m+(w<<5)+20>>2]);g[x+88>>2]=ea(g[m+(w<<5)+24>>2]);w=q+1|0;c[o+(w+n<<6)+40>>2]=0;x=c[v+72>>2]|0;if((x|0)!=1073741823){v=(x+32|0)>>>5;if(v>>>0>(c[a>>2]&2147483647)>>>0){y=UJa(t,v<<2,543784,339)|0;z=c[u>>2]|0;if((z|0)!=0?(YEi(y|0,z|0,c[a>>2]<<2|0)|0,(c[a>>2]|0)>-1):0)VJa(t,c[u>>2]|0);z=c[a>>2]|0;PEi(y+((z&2147483647)<<2)|0,0,v-z<<2|0)|0;c[u>>2]=y;c[a>>2]=v;A=y}else A=c[u>>2]|0;y=A+(x>>>5<<2)|0;c[y>>2]=c[y>>2]|1<<(x&31)}x=c[p>>2]|0;if(w>>>0<x>>>0){l=x;q=w}else break}r=c[j>>2]|0}q=r+9344|0;l=c[r+9300>>2]|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;u0a(q,l,h);h=r+9356|0;l=c[r+9360>>2]|0;p=r+9348|0;A=c[p>>2]|0;u=A+l|0;a=u+63&-64;if((c[r+9364>>2]&2147483647)>>>0<a>>>0)S$a(h,a);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;u0a(h,u,f);YEi((c[h>>2]|0)+(l<<4)|0,c[q>>2]|0,A<<4|0)|0;c[p>>2]=0;p=c[j>>2]|0;A=c[p+9208>>2]|0;if(!A){B=p;C=B+9208|0;c[C>>2]=0;D=c[j>>2]|0;E=D+328|0;F=c[E>>2]|0;G=D+316|0;UAa(F,G);H=c[k>>2]|0;I=H+96|0;J=c[I>>2]|0;K=c[j>>2]|0;L=J+224|0;M=c[L>>2]|0;BTa(M,K);i=d;return}else{N=p;O=0}while(1){p=c[N+9204>>2]|0;q=p+(O<<5)|0;l=p+(O<<5)+8|0;h=c[l>>2]|0;f=h+28|0;if(!(b[h+98>>1]&16))P=0;else P=(c[f>>2]|0)+((c[h+32>>2]|0)+15&-16)|0;u=b[h+20>>1]|0;c[f>>2]=c[p+(O<<5)+12>>2];f=c[l>>2]|0;c[f+32>>2]=c[p+(O<<5)+16>>2];b[f+20>>1]=c[p+(O<<5)+20>>2];h=b[p+(O<<5)+4>>1]|0;if((h&65535)>1){a=f;f=1;do{r=c[(c[(c[(c[j>>2]|0)+9216>>2]|0)+((c[q>>2]|0)+f<<2)>>2]|0)+12>>2]|0;c[r+56>>2]=c[a+40>>2];a=c[l>>2]|0;c[r+52>>2]=c[a+36>>2];f=f+1|0}while(f>>>0<(h&65535)>>>0)}if(!((P|0)==0|u<<16>>16==0)){h=u&65535;f=c[p+(O<<5)+28>>2]|0;a=0;l=0;r=0;t=c[q>>2]|0;while(1){n=e[f+(a<<1)>>1]|0;o=c[(c[j>>2]|0)+9216>>2]|0;m=l;s=r;w=t;x=c[(c[o+(t<<2)>>2]|0)+12>>2]|0;while(1){if(m>>>0>=n>>>0?(b[x+36>>1]|0)!=0:0)break;y=c[(c[o+(w<<2)>>2]|0)+12>>2]|0;v=n-m|0;z=e[y+36>>1]|0;Q=z-s|0;R=v>>>0<Q>>>0?v:Q;Q=R+s|0;v=(Q|0)==(z|0);m=R+m|0;s=v?0:Q;w=(v&1)+w|0;x=y}if(b[x+114>>1]&16){S=ea(g[P+(a<<2)>>2]);g[(c[x+44>>2]|0)+((c[x+48>>2]|0)+15&-16)+(s<<2)>>2]=S}a=a+1|0;if((a|0)==(h|0))break;else{l=m;r=s;t=w}}}O=O+1|0;t=c[j>>2]|0;if((O|0)==(A|0)){B=t;break}else N=t}C=B+9208|0;c[C>>2]=0;D=c[j>>2]|0;E=D+328|0;F=c[E>>2]|0;G=D+316|0;UAa(F,G);H=c[k>>2]|0;I=H+96|0;J=c[I>>2]|0;K=c[j>>2]|0;L=J+224|0;M=c[L>>2]|0;BTa(M,K);i=d;return}function Vpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Wpb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Xpb(a){a=a|0;return 491848}function Ypb(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im;b=i;GGb(a);HGb(a);d=a+20|0;e=c[d>>2]|0;f=c[a+64>>2]|0;h=(c[e+100>>2]|0)+(f<<5)|0;j=(c[e+112>>2]|0)+(f<<6)|0;f=c[(c[e+96>>2]|0)+6736>>2]|0;e=c[f+8>>2]|0;k=f;f=c[k>>2]|0;l=c[k+4>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,94,f,l);k=c[d>>2]|0;m=ea(g[k+124>>2]);d=c[a+24>>2]|0;Dta(k,m,c[d+9108>>2]|0,c[a+28>>2]|0,c[a+48>>2]|0,c[d+9120>>2]|0,h,j,c[d+9132>>2]|0,d+9292|0,d+9296|0,c[a+12>>2]|0);Dn[c[(c[e>>2]|0)+12>>2]&511](e,94,f,l);IGb(a);i=b;return}function Zpb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function _pb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function $pb(a){a=a|0;return 491512}function aqb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;d=a+68|0;e=(c[a+72>>2]|0)+(c[d>>2]|0)|0;f=a+20|0;g=c[(c[f>>2]|0)+96>>2]|0;h=CTa(c[g+224>>2]|0)|0;if(!h){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](j,9459,m?490864:544544,490760,82)|0;if(l){m=l+19&-16;c[m+-4>>2]=m-l;l=m;if(!m)n=l;else{pya(l,g);n=l}}else n=0}else n=h;c[n+352>>2]=0;c[n+356>>2]=0;c[n+336>>2]=0;c[n+340>>2]=0;h=c[d>>2]|0;if(h>>>0>=e>>>0){o=c[f>>2]|0;p=o+96|0;q=c[p>>2]|0;r=q+224|0;s=c[r>>2]|0;BTa(s,n);i=b;return}d=a+24|0;l=h;do{JGb(a,(c[(c[d>>2]|0)+9204>>2]|0)+(l<<5)|0,n);l=l+1|0}while((l|0)!=(e|0));o=c[f>>2]|0;p=o+96|0;q=c[p>>2]|0;r=q+224|0;s=c[r>>2]|0;BTa(s,n);i=b;return}function bqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function cqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function dqb(a){a=a|0;return c[a+24>>2]|0}function eqb(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;b=i;d=c[a+20>>2]|0;a=c[(c[d+96>>2]|0)+8>>2]|0;e=a+24|0;f=a+28|0;h=a+32|0;j=a+36|0;k=a+40|0;l=a+44|0;m=ea(g[e>>2]);n=ea(g[f>>2]);o=ea(g[h>>2]);p=ea(g[j>>2]);q=ea(g[k>>2]);r=m;m=n;n=o;o=p;p=q;q=ea(g[l>>2]);a=0;do{s=ea(g[d+(a*44|0)+120>>2]);r=r<s?r:s;s=ea(g[d+(a*44|0)+124>>2]);m=m<s?m:s;s=ea(g[d+(a*44|0)+128>>2]);n=n<s?n:s;g[e>>2]=r;g[f>>2]=m;g[h>>2]=n;s=ea(g[d+(a*44|0)+132>>2]);o=o>s?o:s;s=ea(g[d+(a*44|0)+136>>2]);p=p>s?p:s;s=ea(g[d+(a*44|0)+140>>2]);q=q>s?q:s;g[j>>2]=o;g[k>>2]=p;g[l>>2]=q;a=a+1|0}while((a|0)!=8);i=b;return}function fqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function gqb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function hqb(a){a=a|0;return 492224}function iqb(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;f=c[d>>2]|0;g=c[(c[(c[f+96>>2]|0)+4>>2]|0)+6736>>2]|0;h=c[g+8>>2]|0;j=g;g=c[j>>2]|0;k=c[j+4>>2]|0;j=e[268300]|e[268301]<<16;if((h|0)==0|(j&16711680|0)==0){Pta(f,c[a+24>>2]|0,0);i=b;return}else{Dn[c[(c[h>>2]|0)+8>>2]&511](h,j&65535,g,k);Pta(c[d>>2]|0,c[a+24>>2]|0,0);Dn[c[(c[h>>2]|0)+12>>2]&511](h,j&65535,g,k);i=b;return}}function jqb(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=Im,n=0,o=0,p=0;l=i;i=i+48|0;k=l;g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[h>>2]);g[k+16>>2]=ea(g[h+4>>2]);g[k+20>>2]=ea(g[h+8>>2]);g[k+24>>2]=ea(g[j>>2]);g[k+28>>2]=ea(g[j+4>>2]);g[k+32>>2]=ea(g[j+8>>2]);j=c[b+8>>2]|0;h=c[b+16>>2]|0;f=b+24|0;m=ea(g[b+96>>2]);n=c[b+104>>2]|0;if(h){o=c[b+12>>2]|0;p=0;while(1){_ta(j+((c[o>>2]|0)*176|0)|0,0,f,k,1,m,n);p=p+1|0;if((p|0)==(h|0))break;else o=o+4|0}}o=c[b+100>>2]|0;if(!o){i=l;return 1}b=d[o>>0]|0;h=b+1|0;if(h>>>0<10)c[(c[o+28>>2]|0)+(b<<2)>>2]=c[e+8>>2];a[o>>0]=h;i=l;return 1}function kqb(a){a=a|0;return}function lqb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function mqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function nqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function oqb(a){a=a|0;return c[a+24>>2]|0}function pqb(a){a=a|0;var b=0;b=i;mua(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function qqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function rqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function sqb(a){a=a|0;return c[a+24>>2]|0}function tqb(a){a=a|0;var b=0,d=0;b=i;d=c[a+20>>2]|0;a=d+128|0;lua(d,1,a);ko[c[(c[a>>2]|0)+20>>2]&4095](a);i=b;return}function uqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function vqb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function wqb(a){a=a|0;return 496952}function xqb(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+800|0;f=d;g=a+20|0;h=c[g>>2]|0;j=c[h>>2]|0;k=c[(c[j+4>>2]|0)+6736>>2]|0;l=c[k+8>>2]|0;m=k;k=c[m>>2]|0;n=c[m+4>>2]|0;m=e[268304]|e[268305]<<16;o=(l|0)==0|(m&16711680|0)==0;if(o){p=j;q=h}else{Dn[c[(c[l>>2]|0)+8>>2]&511](l,m&65535,k,n);h=c[g>>2]|0;p=c[h>>2]|0;q=h}h=c[a+24>>2]|0;a=c[p+72>>2]|0;p=c[a>>2]|0;g=c[a+20>>2]|0;a=c[q+4>>2]|0;j=c[q+96>>2]|0;r=b[q+(h<<2)+520>>1]|0;s=q+(h<<2)+522|0;t=b[s>>1]|0;if((r&65535)<(t&65535)){u=q+160|0;v=q+(h*44|0)+168|0;h=r&65535;w=t;t=r;while(1){r=p+(h<<4)|0;if((c[p+(h<<4)+8>>2]|0)==-1)x=w;else{vua(f,r,p,g,1024);nua(q,c[u>>2]|0,j,a,r,g+(h*216|0)|0,f,v);x=b[s>>1]|0}r=t+1<<16>>16;if((r&65535)<(x&65535)){h=r&65535;w=x;t=r}else break}}if(o){i=d;return}Dn[c[(c[l>>2]|0)+12>>2]&511](l,m&65535,k,n);i=d;return}function yqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497352;VJa(b,c[a+4>>2]|0);i=b;return}function zqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497352;VJa(b,c[a+4>>2]|0);ACi(a);i=b;return}function Aqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497376;VJa(b,c[a+4>>2]|0);i=b;return}function Bqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497376;VJa(b,c[a+4>>2]|0);ACi(a);i=b;return}function Cqb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=(b*12|0)+15&-16;f=(b<<2)+15&-16;g=e+f|0;h=UJa(d+1|0,g+f|0,497248,969)|0;f=h+e|0;e=h+g|0;g=a+4|0;j=c[g>>2]|0;if(!j){k=a+20|0;l=a+12|0;m=a+8|0}else{n=a+12|0;YEi(h|0,j|0,(c[n>>2]|0)*12|0)|0;j=a+8|0;YEi(f|0,c[j>>2]|0,c[n>>2]<<2|0)|0;o=a+20|0;YEi(e|0,c[o>>2]|0,c[n>>2]<<2|0)|0;VJa(d,c[g>>2]|0);k=o;l=n;m=j}c[g>>2]=h;c[m>>2]=f;c[k>>2]=e;k=c[l>>2]|0;m=a+16|0;a=b+-1|0;c[f+(a<<2)>>2]=c[m>>2];if(a>>>0>k>>>0)p=k;else{c[m>>2]=k;q=c[l>>2]|0;r=e+(q<<2)|0;s=b-q|0;t=s<<2;PEi(r|0,-1,t|0)|0;c[l>>2]=b;i=d;return}do{h=p;p=p+1|0;c[f+(h<<2)>>2]=p}while((p|0)!=(a|0));c[m>>2]=k;q=c[l>>2]|0;r=e+(q<<2)|0;s=b-q|0;t=s<<2;PEi(r|0,-1,t|0)|0;c[l>>2]=b;i=d;return}function Dqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497400;VJa(b,c[a+4>>2]|0);i=b;return}function Eqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497400;VJa(b,c[a+4>>2]|0);ACi(a);i=b;return}function Fqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497424;VJa(b,c[a+4>>2]|0);i=b;return}function Gqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=497424;VJa(b,c[a+4>>2]|0);ACi(a);i=b;return}function Hqb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=(b<<3)+15&-16;f=UJa(d+1|0,e+((b<<2)+15&-16)|0,497248,1116)|0;g=f+e|0;e=a+4|0;h=c[e>>2]|0;if(!h){j=a+12|0;k=a+8|0}else{l=a+12|0;YEi(f|0,h|0,c[l>>2]<<3|0)|0;h=a+8|0;YEi(g|0,c[h>>2]|0,c[l>>2]<<2|0)|0;VJa(d,c[e>>2]|0);j=l;k=h}c[e>>2]=f;c[k>>2]=g;k=c[j>>2]|0;f=a+16|0;a=b+-1|0;c[g+(a<<2)>>2]=c[f>>2];if(a>>>0>k>>>0)m=k;else{c[f>>2]=k;c[j>>2]=b;i=d;return}do{e=m;m=m+1|0;c[g+(e<<2)>>2]=m}while((m|0)!=(a|0));c[f>>2]=k;c[j>>2]=b;i=d;return}function Iqb(a){a=a|0;return 497560}function Jqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Kqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Lqb(a){a=a|0;return 497536}function Mqb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+12>>2]);g[a+4>>2]=ea(g[b+16>>2]);g[a+8>>2]=ea(g[b+20>>2]);g[a+12>>2]=ea(g[b+24>>2]);g[a+16>>2]=ea(g[b+28>>2]);g[a+20>>2]=ea(g[b+32>>2]);return}function Nqb(a,b){a=a|0;b=b|0;c[a+48>>2]=b;return}function Oqb(a){a=a|0;return c[a+48>>2]|0}function Pqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return}function Qqb(a){a=a|0;return}function Rqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Sqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Tqb(a){a=a|0;return c[a+24>>2]|0}function Uqb(a){a=a|0;var b=0,d=0;b=i;d=c[a+20>>2]|0;tua(c[d+72>>2]|0,c[d+36>>2]|0,c[(c[d+8>>2]|0)+48>>2]|0,c[a+12>>2]|0);i=b;return}function Vqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function Wqb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function Xqb(a){a=a|0;return c[a+24>>2]|0}function Yqb(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=c[a+20>>2]|0;a=d+1320|0;VJa(b,c[a>>2]|0);c[a>>2]=0;c[d+16>>2]=1;c[d+32>>2]=0;c[d+28>>2]=0;i=b;return}function Zqb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function _qb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function $qb(a){a=a|0;return c[a+24>>2]|0}function arb(a){a=a|0;var b=0;b=i;Xva(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function brb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function crb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function drb(a){a=a|0;return c[a+24>>2]|0}function erb(a){a=a|0;var b=0,d=0,e=0,f=Im,h=Im;b=i;d=c[a+20>>2]|0;e=c[a+12>>2]|0;if(!(c[d+40>>2]|0)){i=b;return}a=c[d+12>>2]|0;f=ea(ea(g[a+4>>2])*ea(.100000001));h=ea(f*f);f=ea(h*ea(h*h));h=ea(g[a+8>>2]);g[d+136>>2]=ea(ea(g[d+100>>2])*ea(h*ea(ea(45.0)/ea(f*ea(3.14159274)))));if(!(c[a+20>>2]&65536)){i=b;return}kua(d+80|0,e);i=b;return}function frb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function grb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function hrb(a){a=a|0;return c[a+24>>2]|0}function irb(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=c[a+20>>2]|0;a=d+1312|0;Wva(d,c[a>>2]|0,c[d+1316>>2]|0);d=c[a>>2]|0;if(!d){i=b;return}VJa(b,d);i=b;return}function jrb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function krb(a){a=a|0;var b=0;b=i;i=i+16|0;c[a>>2]=443968;c[a+8>>2]=0;VJa(b,a);i=b;return}function lrb(a){a=a|0;return c[a+24>>2]|0}function mrb(a){a=a|0;var b=0;b=i;Vva(c[a+20>>2]|0,c[a+12>>2]|0);i=b;return}function nrb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function orb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function prb(a){a=a|0;return 485016}function qrb(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function rrb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function srb(a){a=a|0;return 484992}function trb(a){a=a|0;return}function urb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function vrb(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im;o=i;i=i+384|0;n=o+176|0;m=o+240|0;b=o+288|0;r=o+16|0;s=o+368|0;t=o+320|0;u=o+352|0;v=o+272|0;w=o+256|0;x=o+160|0;y=o;z=o+304|0;A=c[a>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a=A+40|0;B=ea(g[a>>2]);A=r+64|0;c[r+80>>2]=4;C=r+20|0;D=r+36|0;g[r+48>>2]=ea(0.0);E=r+52|0;c[E+0>>2]=c[n+0>>2];c[E+4>>2]=c[n+4>>2];c[E+8>>2]=c[n+8>>2];E=r+96|0;F=r+112|0;c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];g[r+128>>2]=B;G=r+132|0;c[G+0>>2]=c[s+0>>2];c[G+4>>2]=c[s+4>>2];c[G+8>>2]=c[s+8>>2];c[E+0>>2]=c[b+0>>2];c[E+4>>2]=c[b+4>>2];c[E+8>>2]=c[b+8>>2];c[E+12>>2]=c[b+12>>2];c[F+0>>2]=c[b+0>>2];c[F+4>>2]=c[b+4>>2];c[F+8>>2]=c[b+8>>2];c[F+12>>2]=c[b+12>>2];g[r+16>>2]=B;c[C+0>>2]=c[s+0>>2];c[C+4>>2]=c[s+4>>2];c[C+8>>2]=c[s+8>>2];g[r+32>>2]=B;c[D+0>>2]=c[s+0>>2];c[D+4>>2]=c[s+4>>2];c[D+8>>2]=c[s+8>>2];c[m+0>>2]=-1;c[m+4>>2]=-1;c[m+8>>2]=-1;c[m+12>>2]=-1;c[A+0>>2]=c[m+0>>2];c[A+4>>2]=c[m+4>>2];c[A+8>>2]=c[m+8>>2];c[A+12>>2]=c[m+12>>2];B=ea(g[d>>2]);H=ea(g[d+4>>2]);I=ea(g[d+8>>2]);J=ea(g[d+12>>2]);m=f+16|0;K=ea(g[m>>2]);L=ea(g[m+4>>2]);M=ea(g[m+8>>2]);N=ea(g[e>>2]);O=ea(g[e+4>>2]);P=ea(g[e+8>>2]);Q=ea(g[e+12>>2]);m=h+16|0;R=ea(g[m>>2]);S=ea(g[m+4>>2]);T=ea(g[m+8>>2]);g[t>>2]=B;m=t+4|0;g[m>>2]=H;h=t+8|0;g[h>>2]=I;f=t+12|0;g[f>>2]=J;g[t+16>>2]=K;g[t+20>>2]=L;g[t+24>>2]=M;g[t+28>>2]=ea(0.0);U=ea(-B);B=ea(-H);H=ea(-I);I=ea(R-K);V=ea(S-L);W=ea(T-M);X=ea(ea(J*J)+ea(-.5));Y=ea(ea(ea(I*U)+ea(V*B))+ea(W*H));Z=ea(ea(ea(Y*B)+ea(ea(X*V)+ea(J*ea(ea(I*H)-ea(W*U)))))*ea(2.0));_=ea(ea(ea(ea(X*W)+ea(J*ea(ea(V*U)-ea(I*B))))+ea(Y*H))*ea(2.0));$=ea(ea(Q*J)-ea(ea(ea(N*U)+ea(O*B))+ea(P*H)));aa=ea(ea(ea(P*B)-ea(O*H))+ea(ea(Q*U)+ea(N*J)));ba=ea(ea(ea(N*H)-ea(P*U))+ea(ea(Q*B)+ea(O*J)));ca=ea(ea(ea(O*U)-ea(N*B))+ea(ea(P*J)+ea(Q*H)));g[n+48>>2]=ea(ea(ea(Y*U)+ea(ea(X*I)+ea(J*ea(ea(W*B)-ea(V*H)))))*ea(2.0));g[n+52>>2]=Z;g[n+56>>2]=_;g[n+60>>2]=ea(0.0);_=ea(aa+aa);Z=ea(ba+ba);H=ea(ca+ca);V=ea(ba*Z);B=ea(ca*H);W=ea(ba*_);ba=ea(ca*_);J=ea($*_);I=ea(ca*Z);ca=ea($*Z);Z=ea($*H);H=ea(ea(1.0)-ea(aa*_));_=ea(W+Z);aa=ea(ba-ca);$=ea(W-Z);Z=ea(H-B);W=ea(I+J);X=ea(ba+ca);ca=ea(I-J);J=ea(H-V);g[n>>2]=ea(ea(ea(1.0)-V)-B);g[n+4>>2]=_;g[n+8>>2]=aa;g[n+12>>2]=ea(0.0);g[n+16>>2]=$;g[n+20>>2]=Z;g[n+24>>2]=W;g[n+28>>2]=ea(0.0);g[n+32>>2]=X;g[n+36>>2]=ca;g[n+40>>2]=J;g[n+44>>2]=ea(0.0);g[u>>2]=q;q=ea(g[d+16>>2]);J=ea(g[d+20>>2]);ca=ea(g[d+24>>2]);X=ea(g[e+16>>2]);W=ea(g[e+20>>2]);Z=ea(q-K);K=ea(J-L);L=ea(ca-M);M=ea(X-R);R=ea(W-S);S=ea(ea(g[e+24>>2])-T);g[v>>2]=M;g[v+4>>2]=R;g[v+8>>2]=S;g[v+12>>2]=ea(0.0);T=ea(Z-M);M=ea(K-R);R=ea(L-S);S=ea(g[t>>2]);L=ea(g[m>>2]);K=ea(g[h>>2]);Z=ea(g[f>>2]);W=ea(ea(Z*Z)+ea(-.5));X=ea(ea(ea(T*S)+ea(M*L))+ea(R*K));ca=ea(ea(ea(L*X)+ea(ea(M*W)-ea(Z*ea(ea(T*K)-ea(S*R)))))*ea(2.0));J=ea(ea(ea(K*X)+ea(ea(R*W)-ea(Z*ea(ea(M*S)-ea(T*L)))))*ea(2.0));g[w>>2]=ea(ea(ea(S*X)+ea(ea(T*W)-ea(Z*ea(ea(R*L)-ea(M*K)))))*ea(2.0));g[w+4>>2]=ca;g[w+8>>2]=J;g[w+12>>2]=ea(0.0);if(!(KGb(p,r,n,t,v,u,b,w,x,y,z,ea(ea(g[a>>2])+j))|0)){da=ea(3402823469999999843913219.0e14);i=o;return ea(da)}j=ea(g[x>>2]);J=ea(g[y>>2]);ca=ea(g[y+4>>2]);K=ea(g[y+8>>2]);g[k>>2]=J;g[k+4>>2]=ca;g[k+8>>2]=K;K=ea(g[z>>2]);ca=ea(g[z+4>>2]);J=ea(g[z+8>>2]);g[l>>2]=K;g[l+4>>2]=ca;g[l+8>>2]=J;da=j;i=o;return ea(da)}function wrb(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);return ea(1.0e10)}function xrb(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im;o=i;i=i+384|0;n=o+48|0;m=o+112|0;b=o+160|0;r=o+368|0;s=o+176|0;t=o+320|0;u=o+352|0;v=o+144|0;w=o+128|0;x=o+32|0;y=o;z=o+16|0;A=c[a>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a=A+40|0;B=ea(g[a>>2]);C=ea(g[A+44>>2]);D=ea(C*ea(0.0));A=s+64|0;c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];c[s+80>>2]=4;E=s+20|0;F=s+36|0;g[s+48>>2]=ea(0.0);G=s+52|0;c[G+0>>2]=c[n+0>>2];c[G+4>>2]=c[n+4>>2];c[G+8>>2]=c[n+8>>2];g[s+128>>2]=B;G=s+132|0;c[G+0>>2]=c[r+0>>2];c[G+4>>2]=c[r+4>>2];c[G+8>>2]=c[r+8>>2];H=ea(D+ea(0.0));g[s+96>>2]=ea(C+ea(0.0));g[s+100>>2]=H;g[s+104>>2]=H;g[s+108>>2]=ea(0.0);H=ea(ea(0.0)-D);g[s+112>>2]=ea(ea(0.0)-C);g[s+116>>2]=H;g[s+120>>2]=H;g[s+124>>2]=ea(0.0);g[s+16>>2]=B;c[E+0>>2]=c[r+0>>2];c[E+4>>2]=c[r+4>>2];c[E+8>>2]=c[r+8>>2];g[s+32>>2]=B;c[F+0>>2]=c[r+0>>2];c[F+4>>2]=c[r+4>>2];c[F+8>>2]=c[r+8>>2];c[m+0>>2]=-1;c[m+4>>2]=-1;c[m+8>>2]=-1;c[m+12>>2]=-1;c[A+0>>2]=c[m+0>>2];c[A+4>>2]=c[m+4>>2];c[A+8>>2]=c[m+8>>2];c[A+12>>2]=c[m+12>>2];B=ea(g[d>>2]);H=ea(g[d+4>>2]);C=ea(g[d+8>>2]);D=ea(g[d+12>>2]);m=f+16|0;I=ea(g[m>>2]);J=ea(g[m+4>>2]);K=ea(g[m+8>>2]);L=ea(g[e>>2]);M=ea(g[e+4>>2]);N=ea(g[e+8>>2]);O=ea(g[e+12>>2]);m=h+16|0;P=ea(g[m>>2]);Q=ea(g[m+4>>2]);R=ea(g[m+8>>2]);g[t>>2]=B;m=t+4|0;g[m>>2]=H;h=t+8|0;g[h>>2]=C;f=t+12|0;g[f>>2]=D;g[t+16>>2]=I;g[t+20>>2]=J;g[t+24>>2]=K;g[t+28>>2]=ea(0.0);S=ea(-B);B=ea(-H);H=ea(-C);C=ea(P-I);T=ea(Q-J);U=ea(R-K);V=ea(ea(D*D)+ea(-.5));W=ea(ea(ea(C*S)+ea(T*B))+ea(U*H));X=ea(ea(ea(W*B)+ea(ea(V*T)+ea(D*ea(ea(C*H)-ea(U*S)))))*ea(2.0));Y=ea(ea(ea(ea(V*U)+ea(D*ea(ea(T*S)-ea(C*B))))+ea(W*H))*ea(2.0));Z=ea(ea(O*D)-ea(ea(ea(L*S)+ea(M*B))+ea(N*H)));_=ea(ea(ea(N*B)-ea(M*H))+ea(ea(O*S)+ea(L*D)));$=ea(ea(ea(L*H)-ea(N*S))+ea(ea(O*B)+ea(M*D)));aa=ea(ea(ea(M*S)-ea(L*B))+ea(ea(N*D)+ea(O*H)));g[n+48>>2]=ea(ea(ea(W*S)+ea(ea(V*C)+ea(D*ea(ea(U*B)-ea(T*H)))))*ea(2.0));g[n+52>>2]=X;g[n+56>>2]=Y;g[n+60>>2]=ea(0.0);Y=ea(_+_);X=ea($+$);H=ea(aa+aa);T=ea($*X);B=ea(aa*H);U=ea($*Y);$=ea(aa*Y);D=ea(Z*Y);C=ea(aa*X);aa=ea(Z*X);X=ea(Z*H);H=ea(ea(1.0)-ea(_*Y));Y=ea(U+X);_=ea($-aa);Z=ea(U-X);X=ea(H-B);U=ea(C+D);V=ea($+aa);aa=ea(C-D);D=ea(H-T);g[n>>2]=ea(ea(ea(1.0)-T)-B);g[n+4>>2]=Y;g[n+8>>2]=_;g[n+12>>2]=ea(0.0);g[n+16>>2]=Z;g[n+20>>2]=X;g[n+24>>2]=U;g[n+28>>2]=ea(0.0);g[n+32>>2]=V;g[n+36>>2]=aa;g[n+40>>2]=D;g[n+44>>2]=ea(0.0);g[u>>2]=q;q=ea(g[d+16>>2]);D=ea(g[d+20>>2]);aa=ea(g[d+24>>2]);V=ea(g[e+16>>2]);U=ea(g[e+20>>2]);X=ea(q-I);I=ea(D-J);J=ea(aa-K);K=ea(V-P);P=ea(U-Q);Q=ea(ea(g[e+24>>2])-R);g[v>>2]=K;g[v+4>>2]=P;g[v+8>>2]=Q;g[v+12>>2]=ea(0.0);R=ea(X-K);K=ea(I-P);P=ea(J-Q);Q=ea(g[t>>2]);J=ea(g[m>>2]);I=ea(g[h>>2]);X=ea(g[f>>2]);U=ea(ea(X*X)+ea(-.5));V=ea(ea(ea(R*Q)+ea(K*J))+ea(P*I));aa=ea(ea(ea(J*V)+ea(ea(K*U)-ea(X*ea(ea(R*I)-ea(Q*P)))))*ea(2.0));D=ea(ea(ea(I*V)+ea(ea(P*U)-ea(X*ea(ea(K*Q)-ea(R*J)))))*ea(2.0));g[w>>2]=ea(ea(ea(Q*V)+ea(ea(R*U)-ea(X*ea(ea(P*J)-ea(K*I)))))*ea(2.0));g[w+4>>2]=aa;g[w+8>>2]=D;g[w+12>>2]=ea(0.0);if(!(KGb(p,s,n,t,v,u,b,w,x,y,z,ea(ea(g[a>>2])+j))|0)){ba=ea(3402823469999999843913219.0e14);i=o;return ea(ba)}j=ea(g[x>>2]);D=ea(g[y>>2]);aa=ea(g[y+4>>2]);I=ea(g[y+8>>2]);g[k>>2]=D;g[k+4>>2]=aa;g[k+8>>2]=I;I=ea(g[z>>2]);aa=ea(g[z+4>>2]);D=ea(g[z+8>>2]);g[l>>2]=I;g[l+4>>2]=aa;g[l+8>>2]=D;ba=j;i=o;return ea(ba)}function yrb(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im;o=i;i=i+384|0;n=o;m=o+368|0;b=o+64|0;r=o+80|0;s=o+320|0;t=o+352|0;u=o+240|0;v=o+288|0;w=o+272|0;x=o+304|0;y=o+256|0;z=c[a>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;A=ea(g[z+40>>2]);B=ea(g[z+44>>2]);C=ea(g[z+48>>2]);z=r+64|0;c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];c[r+80>>2]=3;a=r+20|0;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];D=r+36|0;g[r+48>>2]=ea(0.0);E=r+52|0;c[E+0>>2]=c[m+0>>2];c[E+4>>2]=c[m+4>>2];c[E+8>>2]=c[m+8>>2];c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[z+0>>2]=c[n+0>>2];c[z+4>>2]=c[n+4>>2];c[z+8>>2]=c[n+8>>2];c[z+12>>2]=c[n+12>>2];g[r+144>>2]=A;g[r+148>>2]=B;g[r+152>>2]=C;g[r+156>>2]=ea(0.0);F=!(A<=B)?B:A;G=!(F<=C)?C:F;F=!(A>=B)?B:A;A=ea(G*ea(.150000006));B=ea((!(F>=C)?C:F)*ea(.0299999993));F=A>B?A:B;g[r+16>>2]=G>F?F:G;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];g[r+32>>2]=ea(G*ea(.0500000007));c[D+0>>2]=c[n+0>>2];c[D+4>>2]=c[n+4>>2];c[D+8>>2]=c[n+8>>2];G=ea(g[d>>2]);F=ea(g[d+4>>2]);B=ea(g[d+8>>2]);A=ea(g[d+12>>2]);D=f+16|0;C=ea(g[D>>2]);H=ea(g[D+4>>2]);I=ea(g[D+8>>2]);J=ea(g[e>>2]);K=ea(g[e+4>>2]);L=ea(g[e+8>>2]);M=ea(g[e+12>>2]);D=h+16|0;N=ea(g[D>>2]);O=ea(g[D+4>>2]);P=ea(g[D+8>>2]);g[s>>2]=G;D=s+4|0;g[D>>2]=F;h=s+8|0;g[h>>2]=B;f=s+12|0;g[f>>2]=A;g[s+16>>2]=C;g[s+20>>2]=H;g[s+24>>2]=I;g[s+28>>2]=ea(0.0);Q=ea(-G);G=ea(-F);F=ea(-B);B=ea(N-C);R=ea(O-H);S=ea(P-I);T=ea(ea(A*A)+ea(-.5));U=ea(ea(ea(B*Q)+ea(R*G))+ea(S*F));V=ea(ea(ea(U*G)+ea(ea(T*R)+ea(A*ea(ea(B*F)-ea(S*Q)))))*ea(2.0));W=ea(ea(ea(ea(T*S)+ea(A*ea(ea(R*Q)-ea(B*G))))+ea(U*F))*ea(2.0));X=ea(ea(M*A)-ea(ea(ea(J*Q)+ea(K*G))+ea(L*F)));Y=ea(ea(ea(L*G)-ea(K*F))+ea(ea(M*Q)+ea(J*A)));Z=ea(ea(ea(J*F)-ea(L*Q))+ea(ea(M*G)+ea(K*A)));_=ea(ea(ea(K*Q)-ea(J*G))+ea(ea(L*A)+ea(M*F)));g[n+48>>2]=ea(ea(ea(U*Q)+ea(ea(T*B)+ea(A*ea(ea(S*G)-ea(R*F)))))*ea(2.0));g[n+52>>2]=V;g[n+56>>2]=W;g[n+60>>2]=ea(0.0);W=ea(Y+Y);V=ea(Z+Z);F=ea(_+_);R=ea(Z*V);G=ea(_*F);S=ea(Z*W);Z=ea(_*W);A=ea(X*W);B=ea(_*V);_=ea(X*V);V=ea(X*F);F=ea(ea(1.0)-ea(Y*W));W=ea(S+V);Y=ea(Z-_);X=ea(S-V);V=ea(F-G);S=ea(B+A);T=ea(Z+_);_=ea(B-A);A=ea(F-R);g[n>>2]=ea(ea(ea(1.0)-R)-G);g[n+4>>2]=W;g[n+8>>2]=Y;g[n+12>>2]=ea(0.0);g[n+16>>2]=X;g[n+20>>2]=V;g[n+24>>2]=S;g[n+28>>2]=ea(0.0);g[n+32>>2]=T;g[n+36>>2]=_;g[n+40>>2]=A;g[n+44>>2]=ea(0.0);g[t>>2]=q;q=ea(g[d+16>>2]);A=ea(g[d+20>>2]);_=ea(g[d+24>>2]);T=ea(g[e+16>>2]);S=ea(g[e+20>>2]);V=ea(q-C);C=ea(A-H);H=ea(_-I);I=ea(T-N);N=ea(S-O);O=ea(ea(g[e+24>>2])-P);g[u>>2]=I;g[u+4>>2]=N;g[u+8>>2]=O;g[u+12>>2]=ea(0.0);P=ea(V-I);I=ea(C-N);N=ea(H-O);O=ea(g[s>>2]);H=ea(g[D>>2]);C=ea(g[h>>2]);V=ea(g[f>>2]);S=ea(ea(V*V)+ea(-.5));T=ea(ea(ea(P*O)+ea(I*H))+ea(N*C));_=ea(ea(ea(H*T)+ea(ea(I*S)-ea(V*ea(ea(P*C)-ea(O*N)))))*ea(2.0));A=ea(ea(ea(C*T)+ea(ea(N*S)-ea(V*ea(ea(I*O)-ea(P*H)))))*ea(2.0));g[v>>2]=ea(ea(ea(O*T)+ea(ea(P*S)-ea(V*ea(ea(N*H)-ea(I*C)))))*ea(2.0));g[v+4>>2]=_;g[v+8>>2]=A;g[v+12>>2]=ea(0.0);if(!(LGb(p,r,n,s,u,t,b,v,w,x,y,j)|0)){$=ea(3402823469999999843913219.0e14);i=o;return ea($)}j=ea(g[w>>2]);A=ea(g[x>>2]);_=ea(g[x+4>>2]);C=ea(g[x+8>>2]);g[k>>2]=A;g[k+4>>2]=_;g[k+8>>2]=C;C=ea(g[y>>2]);_=ea(g[y+4>>2]);A=ea(g[y+8>>2]);g[l>>2]=C;g[l+4>>2]=_;g[l+8>>2]=A;$=j;i=o;return ea($)}function zrb(a,b,d,e,f,h,j,k,l,m,n,o,p,q){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im;o=i;i=i+448|0;n=o+208|0;m=o+256|0;b=o+352|0;r=o;s=o+320|0;t=o+368|0;u=o+432|0;v=o+288|0;w=o+272|0;x=o+224|0;y=o+240|0;z=o+304|0;A=c[a>>2]|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;B=ea(g[A+40>>2]);C=ea(g[A+44>>2]);D=ea(g[A+48>>2]);g[m>>2]=B;g[m+4>>2]=C;g[m+8>>2]=D;g[m+12>>2]=ea(0.0);D=ea(g[A+52>>2]);C=ea(g[A+56>>2]);B=ea(g[A+60>>2]);E=ea(g[A+64>>2]);g[b>>2]=D;g[b+4>>2]=C;g[b+8>>2]=B;g[b+12>>2]=E;z1a(r,c[A+72>>2]|0,n,m,b);E=ea(g[d>>2]);B=ea(g[d+4>>2]);C=ea(g[d+8>>2]);D=ea(g[d+12>>2]);b=f+16|0;F=ea(g[b>>2]);G=ea(g[b+4>>2]);H=ea(g[b+8>>2]);I=ea(g[e>>2]);J=ea(g[e+4>>2]);K=ea(g[e+8>>2]);L=ea(g[e+12>>2]);b=h+16|0;M=ea(g[b>>2]);N=ea(g[b+4>>2]);O=ea(g[b+8>>2]);g[s>>2]=E;b=s+4|0;g[b>>2]=B;h=s+8|0;g[h>>2]=C;f=s+12|0;g[f>>2]=D;g[s+16>>2]=F;g[s+20>>2]=G;g[s+24>>2]=H;g[s+28>>2]=ea(0.0);P=ea(-E);E=ea(-B);B=ea(-C);C=ea(M-F);Q=ea(N-G);R=ea(O-H);S=ea(ea(D*D)+ea(-.5));T=ea(ea(ea(C*P)+ea(Q*E))+ea(R*B));U=ea(ea(ea(T*E)+ea(ea(S*Q)+ea(D*ea(ea(C*B)-ea(R*P)))))*ea(2.0));V=ea(ea(ea(ea(S*R)+ea(D*ea(ea(Q*P)-ea(C*E))))+ea(T*B))*ea(2.0));W=ea(ea(L*D)-ea(ea(ea(I*P)+ea(J*E))+ea(K*B)));X=ea(ea(ea(K*E)-ea(J*B))+ea(ea(L*P)+ea(I*D)));Y=ea(ea(ea(I*B)-ea(K*P))+ea(ea(L*E)+ea(J*D)));Z=ea(ea(ea(J*P)-ea(I*E))+ea(ea(K*D)+ea(L*B)));g[t+48>>2]=ea(ea(ea(T*P)+ea(ea(S*C)+ea(D*ea(ea(R*E)-ea(Q*B)))))*ea(2.0));g[t+52>>2]=U;g[t+56>>2]=V;g[t+60>>2]=ea(0.0);V=ea(X+X);U=ea(Y+Y);B=ea(Z+Z);Q=ea(Y*U);E=ea(Z*B);R=ea(Y*V);Y=ea(Z*V);D=ea(W*V);C=ea(Z*U);Z=ea(W*U);U=ea(W*B);B=ea(ea(1.0)-ea(X*V));V=ea(R+U);X=ea(Y-Z);W=ea(R-U);U=ea(B-E);R=ea(C+D);S=ea(Y+Z);Z=ea(C-D);D=ea(B-Q);g[t>>2]=ea(ea(ea(1.0)-Q)-E);g[t+4>>2]=V;g[t+8>>2]=X;g[t+12>>2]=ea(0.0);g[t+16>>2]=W;g[t+20>>2]=U;g[t+24>>2]=R;g[t+28>>2]=ea(0.0);g[t+32>>2]=S;g[t+36>>2]=Z;g[t+40>>2]=D;g[t+44>>2]=ea(0.0);g[u>>2]=q;q=ea(g[d+16>>2]);D=ea(g[d+20>>2]);Z=ea(g[d+24>>2]);S=ea(g[e+16>>2]);R=ea(g[e+20>>2]);U=ea(q-F);F=ea(D-G);G=ea(Z-H);H=ea(S-M);M=ea(R-N);N=ea(ea(g[e+24>>2])-O);g[v>>2]=H;g[v+4>>2]=M;g[v+8>>2]=N;g[v+12>>2]=ea(0.0);O=ea(U-H);H=ea(F-M);M=ea(G-N);N=ea(g[s>>2]);G=ea(g[b>>2]);F=ea(g[h>>2]);U=ea(g[f>>2]);R=ea(ea(U*U)+ea(-.5));S=ea(ea(ea(O*N)+ea(H*G))+ea(M*F));Z=ea(ea(ea(G*S)+ea(ea(H*R)-ea(U*ea(ea(O*F)-ea(N*M)))))*ea(2.0));D=ea(ea(ea(F*S)+ea(ea(M*R)-ea(U*ea(ea(H*N)-ea(O*G)))))*ea(2.0));g[w>>2]=ea(ea(ea(N*S)+ea(ea(O*R)-ea(U*ea(ea(M*G)-ea(H*F)))))*ea(2.0));g[w+4>>2]=Z;g[w+8>>2]=D;g[w+12>>2]=ea(0.0);if(!(MGb(p,r,t,s,v,u,n,w,x,y,z,j)|0)){_=ea(3402823469999999843913219.0e14);i=o;return ea(_)}j=ea(g[x>>2]);D=ea(g[y>>2]);Z=ea(g[y+4>>2]);F=ea(g[y+8>>2]);g[k>>2]=D;g[k+4>>2]=Z;g[k+8>>2]=F;F=ea(g[z>>2]);Z=ea(g[z+4>>2]);D=ea(g[z+8>>2]);g[l>>2]=F;g[l+4>>2]=Z;g[l+8>>2]=D;_=j;i=o;return ea(_)}function Arb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;g=c[a+8>>2]|0;a=c[b+8>>2]|0;b=g+4|0;f=c[b>>2]|0;if((f|0)==(c[g>>2]|0)){gLa(g,1)|0;j=c[b>>2]|0}else j=f;c[b>>2]=j+1;c[(c[g+8>>2]|0)+(j<<2)>>2]=a;i=h;return 1}function Brb(a){a=a|0;return}function Crb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Drb(a){a=a|0;return}function Erb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Frb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[a+4>>2]|0;if((d|0)==0|(b|0)==0){i=e;return 1}a=f+4|0;g=c[a>>2]|0;if((g+b|0)>>>0>(c[f>>2]|0)>>>0){gLa(f,b)|0;h=c[a>>2]|0}else h=g;YEi((c[f+8>>2]|0)+(h<<2)|0,d|0,b<<2|0)|0;c[a>>2]=(c[a>>2]|0)+b;i=e;return 1}function Grb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=0;k=i;i=i+144|0;h=k+48|0;f=k+36|0;e=k+24|0;l=k+12|0;m=k;n=c[b+20>>2]|0;c[h>>2]=c[b+16>>2];c[h+4>>2]=n;c[h+8>>2]=d+8;c[h+12>>2]=1;c[h+16>>2]=k+128;d=h+40|0;g[d>>2]=ea(8507058669999999534545717.0e13);n=h+44|0;g[n>>2]=ea(8507058669999999534545717.0e13);o=h+48|0;g[o>>2]=ea(8507058669999999534545717.0e13);p=h+52|0;g[p>>2]=ea(-8507058669999999534545717.0e13);q=h+56|0;g[q>>2]=ea(-8507058669999999534545717.0e13);r=h+60|0;g[r>>2]=ea(-8507058669999999534545717.0e13);s=h+64|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;a[s+12>>0]=0;s=b+36|0;t=c[s>>2]|0;hza(f,h,0);u=ea(ea(g[f>>2])*ea(2.0));v=ea(ea(g[f+4>>2])*ea(2.0));w=ea(ea(g[f+8>>2])*ea(2.0));x=ea(g[t+12>>2]);y=ea(ea(x*x)+ea(-.5));z=ea(g[t>>2]);A=ea(u*z);B=ea(g[t+4>>2]);C=ea(A+ea(v*B));A=ea(g[t+8>>2]);D=ea(C+ea(w*A));C=ea(ea(z*D)+ea(ea(u*y)+ea(x*ea(ea(w*B)-ea(v*A)))));E=ea(ea(B*D)+ea(ea(v*y)+ea(x*ea(ea(u*A)-ea(w*z)))));F=ea(ea(ea(w*y)+ea(x*ea(ea(v*z)-ea(u*B))))+ea(A*D));t=c[b+24>>2]|0;D=ea(ea(g[t>>2])*C);C=ea(ea(-ea(ea(g[t+4>>2])*E))-D);D=ea(C-ea(F*ea(g[t+8>>2])));if(!(D>=ea(g[b+12>>2]))){G=b+8|0;H=ea(g[G>>2]);I=H>ea(0.0);i=k;return I|0}else{gza(h,c[s>>2]|0);D=ea(g[d>>2]);F=ea(g[n>>2]);C=ea(g[o>>2]);E=ea(g[p>>2]);A=ea(g[q>>2]);B=ea(g[r>>2]);r=c[b+40>>2]|0;q=c[b+44>>2]|0;u=ea(ea(g[q>>2])*ea(1.10000002));z=ea(ea(g[q+4>>2])*ea(1.10000002));v=ea(ea(g[q+8>>2])*ea(1.10000002));g[e>>2]=u;g[e+4>>2]=z;g[e+8>>2]=v;v=ea(ea(F+A)*ea(.5));z=ea(ea(C+B)*ea(.5));g[l>>2]=ea(ea(D+E)*ea(.5));g[l+4>>2]=v;g[l+8>>2]=z;z=ea(ea(ea(ea(A-F)*ea(.5))+ea(.00999999977))*ea(1.10000002));F=ea(ea(ea(ea(B-C)*ea(.5))+ea(.00999999977))*ea(1.10000002));g[m>>2]=ea(ea(ea(ea(E-D)*ea(.5))+ea(.00999999977))*ea(1.10000002));g[m+4>>2]=z;g[m+8>>2]=F;F=ea(Yra(r,e,l,m,c[b+28>>2]|0,c[b+32>>2]|0));m=b+8|0;z=ea(g[m>>2]);D=z<F?z:F;g[m>>2]=D;g[j>>2]=D;G=m;H=ea(g[G>>2]);I=H>ea(0.0);i=k;return I|0}return 0}function Hrb(a){a=a|0;return}function Irb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Jrb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function Krb(a,b){a=a|0;b=b|0;return (c[a+7776>>2]|0)+(c[(c[a+7780>>2]|0)+(c[b>>2]<<2)>>2]<<3)|0}function Lrb(a,b){a=a|0;b=b|0;var c=0;c=i;fCa(a+7760|0,b);i=c;return}function Mrb(a,b){a=a|0;b=b|0;return (c[a+7632>>2]|0)+(c[(c[a+7636>>2]|0)+(c[b>>2]<<2)>>2]<<3)|0}function Nrb(a,b){a=a|0;b=b|0;var c=0;c=i;fCa(a+7616|0,b);i=c;return}function Orb(a,b){a=a|0;b=b|0;return (c[a+16>>2]|0)+(c[(c[a+20>>2]|0)+(c[b>>2]<<2)>>2]<<3)|0}function Prb(a){a=a|0;var b=0;b=i;iFa(a);i=b;return}function Qrb(a){a=a|0;return 515832}function Rrb(a){a=a|0;return}function Srb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Trb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(515832,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function Urb(a){a=a|0;return 515760}function Vrb(a){a=a|0;return}function Wrb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Xrb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(515760,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function Yrb(a){a=a|0;return 515784}function Zrb(a){a=a|0;return}function _rb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function $rb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(515784,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function asb(a){a=a|0;return 515808}function bsb(a){a=a|0;return}function csb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function dsb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(515808,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function esb(a){a=a|0;return c[a+4>>2]|0}function fsb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+24>>2]&4095](b,d);i=a;return}function gsb(a){a=a|0;return 0}function hsb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+28>>2]&4095](b,d);i=a;return}function isb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;co[c[(c[d>>2]|0)+8>>2]&2047](d,b,768);i=a;return}function jsb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;Dn[c[c[d>>2]>>2]&511](d,b,-2147483648,b);c[e>>2]=514920;c[e+4>>2]=d;In[c[(c[b>>2]|0)+24>>2]&4095](b,e);i=a;return}function ksb(a){a=a|0;return 768}function lsb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=jDa(b,c)|0;i=a;return d|0}function msb(a){a=a|0;return}function nsb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function osb(a){a=a|0;return}function psb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function qsb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+4>>2]|0;Dn[c[c[e>>2]>>2]&511](e,b,-2147483648,b);i=d;return}function rsb(a){a=a|0;return c[a+4>>2]|0}function ssb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+24>>2]&4095](b,d);i=a;return}function tsb(a){a=a|0;return 0}function usb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+28>>2]&4095](b,d);i=a;return}function vsb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;co[c[(c[d>>2]|0)+8>>2]&2047](d,b,144);i=a;return}function wsb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;Dn[c[c[d>>2]>>2]&511](d,b,-2147483648,b);c[e>>2]=514992;c[e+4>>2]=d;In[c[(c[b>>2]|0)+24>>2]&4095](b,e);i=a;return}function xsb(a){a=a|0;return 144}function ysb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=fDa(b,c)|0;i=a;return d|0}function zsb(a){a=a|0;return}function Asb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Bsb(a){a=a|0;return}function Csb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Dsb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+4>>2]|0;Dn[c[c[e>>2]>>2]&511](e,b,-2147483648,b);i=d;return}function Esb(a){a=a|0;return c[a+4>>2]|0}function Fsb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+24>>2]&4095](b,d);i=a;return}function Gsb(a){a=a|0;return 0}function Hsb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+28>>2]&4095](b,d);i=a;return}function Isb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;co[c[(c[d>>2]|0)+8>>2]&2047](d,b,768);i=a;return}function Jsb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;Dn[c[c[d>>2]>>2]&511](d,b,-2147483648,b);c[e>>2]=515064;c[e+4>>2]=d;In[c[(c[b>>2]|0)+24>>2]&4095](b,e);i=a;return}function Ksb(a){a=a|0;return 768}function Lsb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=lDa(b,c)|0;i=a;return d|0}function Msb(a){a=a|0;return}function Nsb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Osb(a){a=a|0;return}function Psb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Qsb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+4>>2]|0;Dn[c[c[e>>2]>>2]&511](e,b,-2147483648,b);i=d;return}function Rsb(a){a=a|0;return c[a+4>>2]|0}function Ssb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+24>>2]&4095](b,d);i=a;return}function Tsb(a){a=a|0;return 0}function Usb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;In[c[(c[b>>2]|0)+28>>2]&4095](b,d);i=a;return}function Vsb(a,b,d){a=a|0;b=b|0;d=d|0;a=i;co[c[(c[d>>2]|0)+8>>2]&2047](d,b,800);i=a;return}function Wsb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;Dn[c[c[d>>2]>>2]&511](d,b,-2147483648,b);c[e>>2]=515136;c[e+4>>2]=d;In[c[(c[b>>2]|0)+24>>2]&4095](b,e);i=a;return}function Xsb(a){a=a|0;return 800}function Ysb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hDa(b,c)|0;i=a;return d|0}function Zsb(a){a=a|0;return}function _sb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function $sb(a){a=a|0;return}function atb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function btb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+4>>2]|0;Dn[c[c[e>>2]>>2]&511](e,b,-2147483648,b);i=d;return}function ctb(a){a=a|0;return}function dtb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function etb(a){a=a|0;return 515808}function ftb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;rn[c[(c[a>>2]|0)+20>>2]&127](a,c[b+4>>2]|0,d,e,f,g);i=h;return}function gtb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=i;i=i+16|0;h=a;c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];K2a(h,d,b,e,g);i=a;return}function htb(a){a=a|0;return}function itb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function jtb(a){a=a|0;return 515760}function ktb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;rn[c[(c[a>>2]|0)+20>>2]&127](a,c[b+4>>2]|0,d,e,f,g);i=h;return}function ltb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=i;i=i+16|0;h=a;c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];M2a(h,d,b,e,g);i=a;return}function mtb(a){a=a|0;return}function ntb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function otb(a){a=a|0;return 515784}function ptb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;rn[c[(c[a>>2]|0)+20>>2]&127](a,c[b+4>>2]|0,d,e,f,g);i=h;return}function qtb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=i;i=i+16|0;h=a;c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];O2a(h,d,b,e,g);i=a;return}function rtb(a){a=a|0;return}function stb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function ttb(a){a=a|0;return 515832}function utb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;rn[c[(c[a>>2]|0)+20>>2]&127](a,c[b+4>>2]|0,d,e,f,g);i=h;return}function vtb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=i;i=i+16|0;h=a;c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];Q2a(h,d,b,e,g);i=a;return}function wtb(a){a=a|0;return 517936}function xtb(a){a=a|0;return}function ytb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function ztb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(517936,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function Atb(c,d,e,f,h,j,k){c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0;k=i;f=h+48|0;e=j+12|0;d=j+4|0;l=j+8|0;m=h+96|0;n=0;o=0;while(1){if(!(a[h+(n+112)>>0]|0))p=o;else{q=f+(n*12|0)|0;r=ea(ea(g[q>>2])*ea(2.0));s=f+(n*12|0)+4|0;t=ea(ea(g[s>>2])*ea(2.0));u=f+(n*12|0)+8|0;v=ea(ea(g[u>>2])*ea(2.0));w=ea(g[e>>2]);x=ea(ea(w*w)+ea(-.5));y=ea(g[j>>2]);z=ea(r*y);A=ea(g[d>>2]);B=ea(z+ea(t*A));z=ea(g[l>>2]);C=ea(B+ea(v*z));B=ea(ea(A*C)+ea(ea(t*x)+ea(w*ea(ea(r*z)-ea(v*y)))));D=ea(ea(ea(v*x)+ea(w*ea(ea(t*y)-ea(r*A))))+ea(z*C));g[c+(o*80|0)>>2]=ea(ea(y*C)+ea(ea(r*x)+ea(w*ea(ea(v*A)-ea(t*z)))));g[c+(o*80|0)+4>>2]=B;g[c+(o*80|0)+8>>2]=D;D=ea(g[h+(n*12|0)+4>>2]);B=ea(g[u>>2]);z=ea(D*B);t=ea(g[h+(n*12|0)+8>>2]);A=ea(g[s>>2]);v=ea(z-ea(t*A));z=ea(g[q>>2]);w=ea(t*z);t=ea(g[h+(n*12|0)>>2]);x=ea(v*ea(2.0));v=ea(ea(w-ea(B*t))*ea(2.0));B=ea(ea(ea(A*t)-ea(D*z))*ea(2.0));z=ea(g[e>>2]);D=ea(ea(z*z)+ea(-.5));t=ea(g[j>>2]);A=ea(x*t);w=ea(g[d>>2]);r=ea(A+ea(v*w));A=ea(g[l>>2]);C=ea(r+ea(B*A));r=ea(ea(w*C)+ea(ea(v*D)+ea(z*ea(ea(x*A)-ea(t*B)))));y=ea(ea(ea(B*D)+ea(z*ea(ea(t*v)-ea(x*w))))+ea(A*C));g[c+(o*80|0)+16>>2]=ea(ea(t*C)+ea(ea(x*D)+ea(z*ea(ea(B*w)-ea(v*A)))));g[c+(o*80|0)+20>>2]=r;g[c+(o*80|0)+24>>2]=y;g[c+(o*80|0)+12>>2]=ea(g[m+(n<<2)>>2]);g[c+(o*80|0)+32>>2]=ea(0.0);g[c+(o*80|0)+36>>2]=ea(0.0);g[c+(o*80|0)+40>>2]=ea(0.0);g[c+(o*80|0)+48>>2]=ea(0.0);g[c+(o*80|0)+52>>2]=ea(0.0);g[c+(o*80|0)+56>>2]=ea(0.0);g[c+(o*80|0)+44>>2]=ea(-3402823469999999843913219.0e14);g[c+(o*80|0)+60>>2]=ea(0.0);g[c+(o*80|0)+28>>2]=ea(0.0);p=o+1|0}n=n+1|0;if((n|0)==4)break;else o=p}o=h+116|0;n=h+164|0;m=h+212|0;l=0;d=p;while(1){if(!(a[h+(l+228)>>0]|0))E=d;else{p=n+(l*12|0)|0;g[c+(d*80|0)>>2]=ea(g[p>>2]);j=n+(l*12|0)+4|0;g[c+(d*80|0)+4>>2]=ea(g[j>>2]);e=n+(l*12|0)+8|0;g[c+(d*80|0)+8>>2]=ea(g[e>>2]);y=ea(g[o+(l*12|0)+4>>2]);r=ea(g[e>>2]);A=ea(y*r);v=ea(g[o+(l*12|0)+8>>2]);w=ea(g[j>>2]);B=ea(A-ea(v*w));A=ea(g[p>>2]);z=ea(v*A);v=ea(g[o+(l*12|0)>>2]);D=ea(z-ea(r*v));r=ea(ea(w*v)-ea(y*A));g[c+(d*80|0)+16>>2]=B;g[c+(d*80|0)+20>>2]=D;g[c+(d*80|0)+24>>2]=r;g[c+(d*80|0)+12>>2]=ea(0.0);g[c+(d*80|0)+32>>2]=ea(0.0);g[c+(d*80|0)+36>>2]=ea(0.0);g[c+(d*80|0)+40>>2]=ea(0.0);g[c+(d*80|0)+48>>2]=ea(0.0);g[c+(d*80|0)+52>>2]=ea(0.0);g[c+(d*80|0)+56>>2]=ea(0.0);g[c+(d*80|0)+44>>2]=ea(-3402823469999999843913219.0e14);g[c+(d*80|0)+60>>2]=ea(3402823469999999843913219.0e14);g[c+(d*80|0)+28>>2]=ea(g[m+(l<<2)>>2]);g[c+(d*80|0)+68>>2]=ea(1.0e3);b[c+(d*80|0)+76>>1]=3;E=d+1|0}l=l+1|0;if((l|0)==4)break;else d=E}d=h+232|0;l=h+280|0;m=h+328|0;o=0;n=E;while(1){if(!(a[h+(o+344)>>0]|0))F=n;else{E=l+(o*12|0)|0;g[c+(n*80|0)>>2]=ea(g[E>>2]);p=l+(o*12|0)+4|0;g[c+(n*80|0)+4>>2]=ea(g[p>>2]);j=l+(o*12|0)+8|0;g[c+(n*80|0)+8>>2]=ea(g[j>>2]);r=ea(g[d+(o*12|0)+4>>2]);D=ea(g[j>>2]);B=ea(r*D);A=ea(g[d+(o*12|0)+8>>2]);y=ea(g[p>>2]);v=ea(B-ea(A*y));B=ea(g[E>>2]);w=ea(A*B);A=ea(g[d+(o*12|0)>>2]);z=ea(w-ea(D*A));D=ea(ea(y*A)-ea(r*B));g[c+(n*80|0)+16>>2]=v;g[c+(n*80|0)+20>>2]=z;g[c+(n*80|0)+24>>2]=D;g[c+(n*80|0)+12>>2]=ea(0.0);g[c+(n*80|0)+32>>2]=ea(0.0);g[c+(n*80|0)+36>>2]=ea(0.0);g[c+(n*80|0)+40>>2]=ea(0.0);g[c+(n*80|0)+48>>2]=ea(0.0);g[c+(n*80|0)+52>>2]=ea(0.0);g[c+(n*80|0)+56>>2]=ea(0.0);g[c+(n*80|0)+44>>2]=ea(-3402823469999999843913219.0e14);g[c+(n*80|0)+60>>2]=ea(3402823469999999843913219.0e14);g[c+(n*80|0)+28>>2]=ea(g[m+(o<<2)>>2]);g[c+(n*80|0)+68>>2]=ea(1.0e3);b[c+(n*80|0)+76>>1]=3;F=n+1|0}o=o+1|0;if((o|0)==4)break;else n=F}i=k;return F|0}function Btb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function Ctb(a){a=a|0;return a+4|0}function Dtb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function Etb(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=b+356|0;b=(c[e>>2]|0)+112|0;a[b>>0]=(a[b>>0]|0)+-1<<24>>24;b=c[e>>2]|0;if(a[b+112>>0]|0){i=d;return}VJa(d,b);i=d;return}function Ftb(a,b){a=a|0;b=b|0;return}function Gtb(a,b){a=a|0;b=b|0;return}function Htb(a,b){a=a|0;b=b|0;c[b>>2]=1;return a|0}function Itb(a){a=a|0;return 0}function Jtb(a){a=a|0;return}function Ktb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ltb(a){a=a|0;return}function Mtb(a){a=a|0;var b=0;b=i;i=i+16|0;VJa(b,a);i=b;return}function Ntb(a){a=a|0;return 521992}function Otb(a){a=a|0;var b=0;b=i;XQa(a);i=b;return}function Ptb(a){a=a|0;var b=0;b=i;i=i+16|0;XQa(a);VJa(b,a);i=b;return}function Qtb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(521992,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function Rtb(a){a=a|0;return c[a+16>>2]|0}function Stb(a){a=a|0;return c[a+24>>2]|0}function Ttb(a){a=a|0;return c[a+20>>2]|0}function Utb(a){a=a|0;return c[a+28>>2]|0}function Vtb(b,c){b=b|0;c=c|0;a[b>>0]=a[c+172>>0]|0;return}function Wtb(a){a=a|0;return c[a+180>>2]|0}function Xtb(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+176>>2]|0;if(!f){g=-1;i=e;return g|0}g=b[f+(d<<1)>>1]|0;i=e;return g|0}function Ytb(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+144>>2]);g[a+4>>2]=ea(g[b+148>>2]);g[a+8>>2]=ea(g[b+152>>2]);g[a+12>>2]=ea(g[b+156>>2]);g[a+16>>2]=ea(g[b+160>>2]);g[a+20>>2]=ea(g[b+164>>2]);return}function Ztb(a,b){a=a|0;b=b|0;return}function _tb(a){a=a|0;var b=0;b=i;XQa(a+-8|0);i=b;return}function $tb(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=a+-8|0;XQa(c);VJa(b,c);i=b;return}function aub(a){a=a|0;return}function bub(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function cub(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[b>>2]=d<<5|(e<<1)+30&30|1;return}function dub(a){a=a|0;return 526400}function eub(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(526400,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function fub(a){a=a|0;return d[a+54>>0]|0|0}function gub(a){a=a|0;return (c[a+56>>2]|0)+((d[a+55>>0]|0)*20|0)|0}function hub(a){a=a|0;return (c[a+56>>2]|0)+((d[a+55>>0]|0)*20|0)+(((e[a+52>>1]|0)<<1)+((d[a+54>>0]|0)*15|0))|0}function iub(a){a=a|0;return d[a+55>>0]|0|0}function jub(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b+16>>2]);g[a+4>>2]=ea(g[b+20>>2]);g[a+8>>2]=ea(g[b+24>>2]);g[a+12>>2]=ea(g[b+28>>2]);g[a+16>>2]=ea(g[b+32>>2]);g[a+20>>2]=ea(g[b+36>>2]);return}function kub(a,b){a=a|0;b=b|0;return}function lub(a){a=a|0;var b=0;b=i;NGb(a);i=b;return}function mub(a){a=a|0;var b=0;b=i;NGb(a);ACi(a);i=b;return}function nub(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+72>>2]|0;e=(d|0)==0;if(!e)oTa(c[d+4>>2]|0);f=a+16|0;g=c[f>>2]|0;h=a+20|0;j=(c[h>>2]|0)-g|0;k=c[a+36>>2]|0;if(!k)l=g;else{m=a+32|0;n=0;do{o=c[(c[m>>2]|0)+(n<<2)>>2]|0;co[c[(c[o>>2]|0)+8>>2]&2047](o,g,j);n=n+1|0}while((n|0)!=(k|0));l=c[f>>2]|0}c[h>>2]=l;ko[c[(c[a>>2]|0)+16>>2]&4095](a);if(e){i=b;return}pTa(c[d+4>>2]|0);i=b;return}function oub(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+148|0;oTa(c[f>>2]|0);g=c[a+268>>2]|0;if(!g){h=c[f>>2]|0;pTa(h);i=e;return}j=a+264|0;a=0;do{k=c[(c[j>>2]|0)+(a<<2)>>2]|0;co[c[(c[k>>2]|0)+8>>2]&2047](k,b,d);a=a+1|0}while((a|0)!=(g|0));h=c[f>>2]|0;pTa(h);i=e;return}function pub(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=a+88|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=a+104|0;c[d>>2]=0;c[d+4>>2]=0;i=b;return}function qub(a,b){a=a|0;b=b|0;c[a+280>>2]=b;return}function rub(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=xo[c[(c[a>>2]|0)+28>>2]&2047](a,e,1)|0;i=d;return b|0}function sub(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;i=i+16|0;h=g;j=d+148|0;oTa(c[j>>2]|0);if(!f){k=0;l=c[j>>2]|0;pTa(l);i=g;return k|0}m=c[d+192>>2]|0;a:do if(m){n=c[e>>2]|0;o=a[n>>0]|0;if(!(o<<24>>24))p=5381;else{q=o;o=5381;r=n;while(1){s=o*33^q<<24>>24;r=r+1|0;q=a[r>>0]|0;if(!(q<<24>>24)){p=s;break}else o=s}}o=c[(c[d+184>>2]|0)+((p&m+-1)<<2)>>2]|0;if((o|0)!=-1){q=c[d+176>>2]|0;r=d+180|0;s=o;while(1){t=q+(s<<3)|0;if(!(HEi(c[t>>2]|0,n)|0))break;o=c[(c[r>>2]|0)+(s<<2)>>2]|0;if((o|0)==-1)break a;else s=o}if(t){k=b[(c[d+156>>2]|0)+(c[q+(s<<3)+4>>2]<<3)+4>>1]|0;l=c[j>>2]|0;pTa(l);i=g;return k|0}}}while(0);t=d+236|0;m=d+228|0;p=d+220|0;r=d+224|0;n=c[d+160>>2]&65535;do{n=n+1<<16>>16;o=n&65535;u=c[t>>2]|0;v=u+-1|0;if(!u){w=0;x=13;break}else{y=0;z=0}do{u=y+o|0;A=u&65535;B=u&65535;u=B+~(B<<15)|0;B=(u>>>10^u)*9|0;u=B>>>6^B;B=u+~(u<<11)|0;u=c[(c[m>>2]|0)+((v&(B>>>16^B))<<2)>>2]|0;b:do if((u|0)==-1)C=0;else{B=c[p>>2]|0;D=u;while(1){E=B+(D<<3)|0;if((b[E>>1]|0)==A<<16>>16){C=E;break b}D=c[(c[r>>2]|0)+(D<<2)>>2]|0;if((D|0)==-1){C=0;break}}}while(0);F=(C|0)!=0;z=z+1<<16>>16;y=z&65535}while(!(y>>>0>=f>>>0|F))}while(F);if((x|0)==13)while(1){x=0;w=w+1<<16>>16;if((w&65535)>>>0>=f>>>0)break;else x=13}x=c[d+268>>2]|0;w=n&65535;F=d+264|0;y=h+4|0;if(!x){z=0;C=1;while(1){wFb(d,c[e+(z<<2)>>2]|0,z+w&65535,1);r=C&65535;if(r>>>0>=f>>>0){k=n;break}z=r;C=C+1<<16>>16}l=c[j>>2]|0;pTa(l);i=g;return k|0}else{G=0;H=1}while(1){C=G+w|0;z=e+(G<<2)|0;wFb(d,c[z>>2]|0,C&65535,1);r=C&65535|65536;C=0;do{p=c[(c[F>>2]|0)+(C<<2)>>2]|0;m=c[(c[p>>2]|0)+16>>2]|0;c[h>>2]=c[z>>2];c[y>>2]=r;In[m&4095](p,h);C=C+1|0}while((C|0)!=(x|0));C=H&65535;if(C>>>0>=f>>>0){k=n;break}G=C;H=H+1<<16>>16}l=c[j>>2]|0;pTa(l);i=g;return k|0}function tub(a,b){a=a|0;b=b|0;c[a+256>>2]=b;return}function uub(a){a=a|0;return c[a+256>>2]|0}function vub(a){a=a|0;return c[a+136>>2]|0}function wub(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=b+148|0;oTa(c[g>>2]|0);c[f>>2]=d;h=b+268|0;j=c[h>>2]|0;if((c[b+272>>2]&2147483647)>>>0<=j>>>0){OGb(b+260|0,f)|0;k=b+276|0;a[k>>0]=1;l=c[g>>2]|0;pTa(l);i=e;return}f=(c[b+264>>2]|0)+(j<<2)|0;if(f)c[f>>2]=d;c[h>>2]=j+1;k=b+276|0;a[k>>0]=1;l=c[g>>2]|0;pTa(l);i=e;return}function xub(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+148|0;oTa(c[f>>2]|0);g=b+268|0;h=c[g>>2]|0;a:do if(!h)j=0;else{k=b+264|0;l=c[k>>2]|0;m=0;while(1){n=m+1|0;if((c[l+(m<<2)>>2]|0)==(d|0))break;if(n>>>0<h>>>0)m=n;else{j=h;break a}}ko[c[(c[d>>2]|0)+12>>2]&4095](d);l=(c[g>>2]|0)+-1|0;c[g>>2]=l;n=c[k>>2]|0;c[n+(m<<2)>>2]=c[n+(l<<2)>>2];j=l}while(0);a[b+276>>0]=(j|0)!=0&1;pTa(c[f>>2]|0);i=e;return}function yub(b){b=b|0;return (a[b+276>>0]|0)!=0|0}function zub(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+148|0;oTa(c[e>>2]|0);f=c[b+156>>2]|0;c[a>>2]=c[b+160>>2];c[a+4>>2]=f;pTa(c[e>>2]|0);i=d;return}function Aub(a){a=a|0;var b=0,d=0;b=i;d=c[a+140>>2]|0;ko[c[c[a>>2]>>2]&4095](a);In[c[(c[d>>2]|0)+12>>2]&4095](d,a);i=b;return}function Bub(a){a=a|0;return}function Cub(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h+2|0;k=h;b[k>>1]=e;e=d+280|0;if(c[e>>2]|0){l=PGb(d+212|0,k,j)|0;if((a[j>>0]|0)!=0|(l|0)==0)m=c[l+4>>2]|0;else{b[l>>1]=b[k>>1]|0;c[l+4>>2]=0;m=0}l=c[e>>2]|0;En[c[c[l>>2]>>2]&127](l,m,f,g,0)}if(!(a[d+276>>0]|0)){i=h;return}QGb(d,b[k>>1]|0,f,g);i=h;return}function Dub(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h+2|0;k=h;b[k>>1]=e;e=d+280|0;if(c[e>>2]|0){l=PGb(d+212|0,k,j)|0;if((a[j>>0]|0)!=0|(l|0)==0)m=c[l+4>>2]|0;else{b[l>>1]=b[k>>1]|0;c[l+4>>2]=0;m=0}l=c[e>>2]|0;En[c[(c[l>>2]|0)+4>>2]&127](l,m,f,g,0)}if(!(a[d+276>>0]|0)){i=h;return}RGb(d,b[k>>1]|0,f,g);i=h;return}function Eub(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+2|0;l=j;b[l>>1]=e;e=d+280|0;if(c[e>>2]|0){m=PGb(d+212|0,l,k)|0;if((a[k>>0]|0)!=0|(m|0)==0)n=c[m+4>>2]|0;else{b[m>>1]=b[l>>1]|0;c[m+4>>2]=0;n=0}m=c[e>>2]|0;En[c[c[m>>2]>>2]&127](m,n,f,g,h)}if(!(a[d+276>>0]|0)){i=j;return}SGb(d,b[l>>1]|0,f,g,h);i=j;return}function Fub(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+2|0;l=j;b[l>>1]=e;e=d+280|0;if(c[e>>2]|0){m=PGb(d+212|0,l,k)|0;if((a[k>>0]|0)!=0|(m|0)==0)n=c[m+4>>2]|0;else{b[m>>1]=b[l>>1]|0;c[m+4>>2]=0;n=0}m=c[e>>2]|0;En[c[(c[m>>2]|0)+4>>2]&127](m,n,f,g,h)}if(!(a[d+276>>0]|0)){i=j;return}TGb(d,b[l>>1]|0,f,g,h);i=j;return}function Gub(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+16|0;l=k+2|0;m=k;b[m>>1]=e;e=d+280|0;if(c[e>>2]|0){n=PGb(d+212|0,m,l)|0;if((a[l>>0]|0)!=0|(n|0)==0)o=c[n+4>>2]|0;else{b[n>>1]=b[m>>1]|0;c[n+4>>2]=0;o=0}n=c[e>>2]|0;Dn[c[(c[n>>2]|0)+8>>2]&511](n,o,h,j)}if(!(a[d+276>>0]|0)){i=k;return}o=b[m>>1]|0;UGb(d,o,LTa()|0,f,g,h,j);i=k;return}function Hub(b,c,d,e,f){b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(!(a[b+276>>0]|0)){i=g;return}h=QTa()|0;VGb(b,h,H,c,d,e,f);i=g;return}function Iub(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+72>>2]|0;e=(d|0)==0;if(!e)oTa(c[d+4>>2]|0);f=a+16|0;g=c[f>>2]|0;h=a+20|0;j=(c[h>>2]|0)-g|0;k=c[a+36>>2]|0;if(!k)l=g;else{m=a+32|0;n=0;do{o=c[(c[m>>2]|0)+(n<<2)>>2]|0;co[c[(c[o>>2]|0)+8>>2]&2047](o,g,j);n=n+1|0}while((n|0)!=(k|0));l=c[f>>2]|0}c[h>>2]=l;ko[c[(c[a>>2]|0)+16>>2]&4095](a);if(e){i=b;return}pTa(c[d+4>>2]|0);i=b;return}function Jub(a){a=a|0;var b=0;b=i;NGb(a+-116|0);i=b;return}function Kub(a){a=a|0;var b=0,c=0;b=i;c=a+-116|0;NGb(c);ACi(c);i=b;return}function Lub(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=b+32|0;oTa(c[g>>2]|0);c[f>>2]=d;h=b+152|0;j=c[h>>2]|0;if((c[b+156>>2]&2147483647)>>>0<=j>>>0){OGb(b+144|0,f)|0;k=b+160|0;a[k>>0]=1;l=c[g>>2]|0;pTa(l);i=e;return}f=(c[b+148>>2]|0)+(j<<2)|0;if(f)c[f>>2]=d;c[h>>2]=j+1;k=b+160|0;a[k>>0]=1;l=c[g>>2]|0;pTa(l);i=e;return}function Mub(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+32|0;oTa(c[f>>2]|0);g=b+152|0;h=c[g>>2]|0;a:do if(!h)j=0;else{k=b+148|0;l=c[k>>2]|0;m=0;while(1){n=m+1|0;if((c[l+(m<<2)>>2]|0)==(d|0))break;if(n>>>0<h>>>0)m=n;else{j=h;break a}}ko[c[(c[d>>2]|0)+12>>2]&4095](d);l=(c[g>>2]|0)+-1|0;c[g>>2]=l;n=c[k>>2]|0;c[n+(m<<2)>>2]=c[n+(l<<2)>>2];j=l}while(0);a[b+160>>0]=(j|0)!=0&1;pTa(c[f>>2]|0);i=e;return}function Nub(b){b=b|0;return (a[b+160>>0]|0)!=0|0}function Oub(a){a=a|0;return c[a+20>>2]|0}function Pub(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+-116|0;e=c[a+24>>2]|0;ko[c[c[d>>2]>>2]&4095](d);In[c[(c[e>>2]|0)+12>>2]&4095](e,d);i=b;return}function Qub(a,b){a=a|0;b=b|0;c[a+140>>2]=b;return}function Rub(a){a=a|0;return c[a+140>>2]|0}function Sub(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=a+-116|0;c[e>>2]=b;b=xo[c[(c[f>>2]|0)+28>>2]&2047](f,e,1)|0;i=d;return b|0}function Tub(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=sub(a+-116|0,b,c)|0;i=d;return e|0}function Uub(a,b){a=a|0;b=b|0;c[a+164>>2]=b;return}function Vub(a){a=a|0;var b=0;b=i;NGb(a+-120|0);i=b;return}function Wub(a){a=a|0;var b=0,c=0;b=i;c=a+-120|0;NGb(c);ACi(c);i=b;return}function Xub(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+28|0;oTa(c[e>>2]|0);f=c[b+36>>2]|0;c[a>>2]=c[b+40>>2];c[a+4>>2]=f;pTa(c[e>>2]|0);i=d;return}function Yub(a){a=a|0;var b=0;b=i;NGb(a+-124|0);i=b;return}function Zub(a){a=a|0;var b=0,c=0;b=i;c=a+-124|0;NGb(c);ACi(c);i=b;return}function _ub(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+2|0;k=h;l=d+-124|0;b[k>>1]=e;e=d+156|0;if(c[e>>2]|0){m=PGb(d+88|0,k,j)|0;if((a[j>>0]|0)!=0|(m|0)==0)n=c[m+4>>2]|0;else{b[m>>1]=b[k>>1]|0;c[m+4>>2]=0;n=0}m=c[e>>2]|0;En[c[c[m>>2]>>2]&127](m,n,f,g,0)}if(!(a[d+152>>0]|0)){i=h;return}QGb(l,b[k>>1]|0,f,g);i=h;return}function $ub(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+2|0;k=h;l=d+-124|0;b[k>>1]=e;e=d+156|0;if(c[e>>2]|0){m=PGb(d+88|0,k,j)|0;if((a[j>>0]|0)!=0|(m|0)==0)n=c[m+4>>2]|0;else{b[m>>1]=b[k>>1]|0;c[m+4>>2]=0;n=0}m=c[e>>2]|0;En[c[(c[m>>2]|0)+4>>2]&127](m,n,f,g,0)}if(!(a[d+152>>0]|0)){i=h;return}RGb(l,b[k>>1]|0,f,g);i=h;return}function avb(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j+2|0;l=j;m=d+-124|0;b[l>>1]=e;e=d+156|0;if(c[e>>2]|0){n=PGb(d+88|0,l,k)|0;if((a[k>>0]|0)!=0|(n|0)==0)o=c[n+4>>2]|0;else{b[n>>1]=b[l>>1]|0;c[n+4>>2]=0;o=0}n=c[e>>2]|0;En[c[c[n>>2]>>2]&127](n,o,f,g,h)}if(!(a[d+152>>0]|0)){i=j;return}SGb(m,b[l>>1]|0,f,g,h);i=j;return}function bvb(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j+2|0;l=j;m=d+-124|0;b[l>>1]=e;e=d+156|0;if(c[e>>2]|0){n=PGb(d+88|0,l,k)|0;if((a[k>>0]|0)!=0|(n|0)==0)o=c[n+4>>2]|0;else{b[n>>1]=b[l>>1]|0;c[n+4>>2]=0;o=0}n=c[e>>2]|0;En[c[(c[n>>2]|0)+4>>2]&127](n,o,f,g,h)}if(!(a[d+152>>0]|0)){i=j;return}TGb(m,b[l>>1]|0,f,g,h);i=j;return}function cvb(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+16|0;l=k+2|0;m=k;n=d+-124|0;b[m>>1]=e;e=d+156|0;if(c[e>>2]|0){o=PGb(d+88|0,m,l)|0;if((a[l>>0]|0)!=0|(o|0)==0)p=c[o+4>>2]|0;else{b[o>>1]=b[m>>1]|0;c[o+4>>2]=0;p=0}o=c[e>>2]|0;Dn[c[(c[o>>2]|0)+8>>2]&511](o,p,h,j)}if(!(a[d+152>>0]|0)){i=k;return}d=b[m>>1]|0;UGb(n,d,LTa()|0,f,g,h,j);i=k;return}function dvb(b,c,d,e,f){b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(!(a[b+152>>0]|0)){i=g;return}h=QTa()|0;VGb(b+-124|0,h,H,c,d,e,f);i=g;return}function evb(a){a=a|0;var b=0;b=i;NGb(a+-128|0);i=b;return}function fvb(a){a=a|0;var b=0,c=0;b=i;c=a+-128|0;NGb(c);ACi(c);i=b;return}function gvb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a+-128|0;e=c[a+-56>>2]|0;f=(e|0)==0;if(!f)oTa(c[e+4>>2]|0);g=a+-112|0;h=c[g>>2]|0;j=a+-108|0;k=(c[j>>2]|0)-h|0;l=c[a+-92>>2]|0;if(!l)m=h;else{n=a+-96|0;a=0;do{o=c[(c[n>>2]|0)+(a<<2)>>2]|0;co[c[(c[o>>2]|0)+8>>2]&2047](o,h,k);a=a+1|0}while((a|0)!=(l|0));m=c[g>>2]|0}c[j>>2]=m;ko[c[(c[d>>2]|0)+16>>2]&4095](d);if(f){i=b;return}pTa(c[e+4>>2]|0);i=b;return}function hvb(a){a=a|0;var b=0;b=i;NGb(a+-132|0);i=b;return}function ivb(a){a=a|0;var b=0,c=0;b=i;c=a+-132|0;NGb(c);ACi(c);i=b;return}function jvb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+16|0;oTa(c[f>>2]|0);g=c[a+136>>2]|0;if(!g){h=c[f>>2]|0;pTa(h);i=e;return}j=a+132|0;a=0;do{k=c[(c[j>>2]|0)+(a<<2)>>2]|0;co[c[(c[k>>2]|0)+8>>2]&2047](k,b,d);a=a+1|0}while((a|0)!=(g|0));h=c[f>>2]|0;pTa(h);i=e;return}function kvb(a){a=a|0;return}function lvb(a){a=a|0;var b=0;b=i;WGb(a);i=b;return}function mvb(a){a=a|0;var b=0;b=i;WGb(a);ACi(a);i=b;return}function nvb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[a+72>>2]|0;g=(f|0)==0;if(!g)oTa(c[f+4>>2]|0);a:do if(!((b|0)==0|(d|0)==0)){ko[c[(c[a>>2]|0)+16>>2]&4095](a);h=a+8|0;j=a+20|0;k=a+16|0;l=a+44|0;m=c[l>>2]|0;if(((c[j>>2]|0)+d-(c[k>>2]|0)|0)>>>0<m>>>0)n=m;else{ko[c[(c[a>>2]|0)+8>>2]&4095](a);n=c[l>>2]|0}if(n>>>0<=d>>>0){l=c[a+36>>2]|0;if(!l)break;m=a+32|0;o=0;while(1){p=c[(c[m>>2]|0)+(o<<2)>>2]|0;co[c[(c[p>>2]|0)+8>>2]&2047](p,b,d);o=o+1|0;if((o|0)==(l|0))break a}}l=c[j>>2]|0;o=c[k>>2]|0;m=o;p=l-m|0;q=p+d|0;r=a+24|0;if(((c[r>>2]|0)-m|0)>>>0>q>>>0){s=l;t=o}else{l=q<<1;if(!l){u=0;v=o}else{o=c[c[h>>2]>>2]|0;q=Bn[c[(c[o>>2]|0)+8>>2]&255](o,l,c[a+12>>2]|0,527352,117)|0;u=q;v=c[k>>2]|0}if((v|0)!=0?(YEi(u|0,v|0,p|0)|0,q=c[k>>2]|0,(q|0)!=0):0){o=c[c[h>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,q)}c[k>>2]=u;q=u+p|0;c[j>>2]=q;c[r>>2]=u+l;s=q;t=u}YEi(t+(s-t)|0,b|0,d|0)|0;c[j>>2]=(c[j>>2]|0)+d}while(0);if(g){i=e;return}pTa(c[f+4>>2]|0);i=e;return}function ovb(a){a=a|0;return}function pvb(a){a=a|0;var b=0;b=i;WGb(a);i=b;return}function qvb(a){a=a|0;var b=0;b=i;WGb(a);ACi(a);i=b;return}function rvb(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function svb(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function tvb(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function uvb(a){a=a|0;return c[a+4>>2]|0}function vvb(a){a=a|0;return c[a+8>>2]|0}function wvb(a){a=a|0;return c[a+12>>2]|0}function xvb(a){a=a|0;return a+8|0}function yvb(b){b=b|0;return (a[b+40>>0]|0)!=0|0}function zvb(b,c){b=b|0;c=c|0;a[b+40>>0]=c&1;return}function Avb(a){a=a|0;return}function Bvb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Cvb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+28>>2]|0;if(e){f=0;do{g=c[a+(f<<2)+8>>2]|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,b);f=f+1|0}while((f|0)!=(e|0))}e=c[a+4>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,b);i=d;return}function Dvb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+28|0;if((c[e>>2]|0)>>>0>=5){i=d;return}c[a+(c[e>>2]<<2)+8>>2]=b;c[e>>2]=(c[e>>2]|0)+1;i=d;return}function Evb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+28|0;if(!(c[e>>2]|0)){i=d;return}else f=0;while(1){g=a+(f<<2)+8|0;f=f+1|0;h=c[e>>2]|0;if((c[g>>2]|0)==(b|0))break;if(f>>>0>=h>>>0){j=5;break}}if((j|0)==5){i=d;return}c[g>>2]=c[a+(h+-1<<2)+8>>2];c[e>>2]=(c[e>>2]|0)+-1;i=d;return}function Fvb(a){a=a|0;return}function Gvb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Hvb(a){a=a|0;return}function Ivb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Jvb(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=0,J=0;h=i;i=i+96|0;j=h+48|0;k=h;l=h+84|0;if(!e){i=h;return 1}m=d+4|0;n=d+8|0;o=k+4|0;p=k+8|0;q=k+12|0;r=k+16|0;s=k+40|0;t=d+20|0;u=d+80|0;v=d+92|0;w=d+96|0;x=d+98|0;y=d+12|0;z=k+20|0;A=k+24|0;B=k+28|0;C=k+32|0;D=k+36|0;E=k+44|0;F=d+16|0;d=0;do{G=c[f+(d<<2)>>2]|0;LRa(c[m>>2]|0,c[n>>2]|0,j,0,0,G,1,1)|0;c[k>>2]=0;c[o>>2]=0;c[p>>2]=-1;b[q>>1]=0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;g[s>>2]=ea(3402823469999999843913219.0e14);H=ea(g[v>>2]);b[l>>1]=b[w>>1]|0;if(a6a(1,j,t,u,H,k,l,(a[x>>0]|0)!=0,0)|0?(H=ea(g[s>>2]),I=c[y>>2]|0,J=I+40|0,H<ea(g[J>>2])):0){c[I+0>>2]=c[k+0>>2];c[I+4>>2]=c[k+4>>2];c[I+8>>2]=c[k+8>>2];b[I+12>>1]=b[q>>1]|0;g[I+16>>2]=ea(g[r>>2]);g[I+20>>2]=ea(g[z>>2]);g[I+24>>2]=ea(g[A>>2]);g[I+28>>2]=ea(g[B>>2]);g[I+32>>2]=ea(g[C>>2]);g[I+36>>2]=ea(g[D>>2]);g[J>>2]=ea(g[s>>2]);c[I+44>>2]=c[E>>2];c[(c[y>>2]|0)+8>>2]=G;a[F>>0]=1}d=d+1|0}while((d|0)!=(e|0));i=h;return 1}function Kvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0;h=i;j=ea(g[c+4>>2]);k=ea(g[d+16>>2]);l=ea(g[d+20>>2]);m=ea(g[d+24>>2]);n=ea(g[e+4>>2]);o=ea(g[f+16>>2]);p=ea(g[f+20>>2]);q=ea(k-o);o=ea(l-p);p=ea(m-ea(g[f+24>>2]));m=ea(ea(ea(q*q)+ea(o*o))+ea(p*p));l=ea(j+n);if(m>ea(l*l)){r=0;i=h;return r|0}n=ea(T(ea(m)));if(m<ea(9.99999997e-07)){g[a>>2]=ea(1.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0)}else{m=ea(ea(1.0)/n);j=ea(o*m);o=ea(p*m);g[a>>2]=ea(q*m);g[a+4>>2]=j;g[a+8>>2]=o}o=ea(l-n);a=o>ea(0.0);g[b>>2]=a?o:ea(0.0);r=1;i=h;return r|0}function Lvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0;e=i;i=i+16|0;h=e;j=ea(g[c+4>>2]);k=ea(g[d+16>>2]);l=ea(g[d+20>>2]);m=ea(g[d+24>>2]);tLa(h,f);n=ea(g[h>>2]);o=ea(k*n);k=ea(g[h+4>>2]);p=ea(o+ea(l*k));l=ea(g[h+8>>2]);o=ea(p+ea(m*l));m=ea(ea(g[h+12>>2])+o);if(m>j){q=0;i=e;return q|0}g[a>>2]=n;g[a+4>>2]=k;g[a+8>>2]=l;l=ea(j-m);a=l>ea(0.0);g[b>>2]=a?l:ea(0.0);q=1;i=e;return q|0}function Mvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;h=i;i=i+48|0;j=h+16|0;k=h;l=ea(g[f>>2]);m=ea(l*ea(2.0));n=ea(g[f+12>>2]);o=ea(n*ea(2.0));p=ea(ea(l*m)+ea(ea(n*o)+ea(-1.0)));n=ea(g[f+8>>2]);l=ea(n*o);q=ea(g[f+4>>2]);r=ea(l+ea(m*q));l=ea(ea(m*n)-ea(o*q));q=ea(g[e+8>>2]);o=ea(q*p);p=ea(q*r);r=ea(q*l);l=ea(g[f+16>>2]);q=ea(l+o);n=ea(g[f+20>>2]);m=ea(n+p);s=ea(g[f+24>>2]);t=ea(r+s);g[j>>2]=q;g[j+4>>2]=m;g[j+8>>2]=t;t=ea(n-p);p=ea(s-r);g[j+12>>2]=ea(l-o);g[j+16>>2]=t;g[j+20>>2]=p;g[j+24>>2]=ea(g[e+4>>2]);p=ea(g[c+4>>2]);g[k>>2]=ea(g[d+16>>2]);g[k+4>>2]=ea(g[d+20>>2]);g[k+8>>2]=ea(g[d+24>>2]);g[k+12>>2]=p;d=DLa(a,b,k,j)|0;i=h;return d|0}function Nvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;h=i;i=i+80|0;j=h+16|0;k=h;g[j+36>>2]=ea(g[f+16>>2]);g[j+40>>2]=ea(g[f+20>>2]);g[j+44>>2]=ea(g[f+24>>2]);g[j+48>>2]=ea(g[e+4>>2]);g[j+52>>2]=ea(g[e+8>>2]);g[j+56>>2]=ea(g[e+12>>2]);l=ea(g[f>>2]);m=ea(g[f+4>>2]);n=ea(g[f+8>>2]);o=ea(g[f+12>>2]);p=ea(l+l);q=ea(m+m);r=ea(n+n);s=ea(m*q);t=ea(n*r);u=ea(p*m);m=ea(p*n);v=ea(p*o);w=ea(q*n);n=ea(q*o);q=ea(r*o);o=ea(u+q);r=ea(m-n);x=ea(u-q);q=ea(ea(1.0)-ea(l*p));p=ea(q-t);l=ea(w+v);u=ea(m+n);n=ea(w-v);v=ea(q-s);g[j>>2]=ea(ea(ea(1.0)-s)-t);g[j+4>>2]=o;g[j+8>>2]=r;g[j+12>>2]=x;g[j+16>>2]=p;g[j+20>>2]=l;g[j+24>>2]=u;g[j+28>>2]=n;g[j+32>>2]=v;v=ea(g[c+4>>2]);g[k>>2]=ea(g[d+16>>2]);g[k+4>>2]=ea(g[d+20>>2]);g[k+8>>2]=ea(g[d+24>>2]);g[k+12>>2]=v;d=ELa(a,b,k,j)|0;i=h;return d|0}function Ovb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im;h=i;i=i+16|0;j=h;k=ea(g[c+4>>2]);g[j>>2]=ea(g[d+16>>2]);g[j+4>>2]=ea(g[d+20>>2]);g[j+8>>2]=ea(g[d+24>>2]);g[j+12>>2]=k;d=JLa(a,b,j,e,f)|0;i=h;return d|0}function Pvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im;h=i;i=i+16|0;j=h;k=ea(g[c+4>>2]);g[j>>2]=ea(g[d+16>>2]);g[j+4>>2]=ea(g[d+20>>2]);g[j+8>>2]=ea(g[d+24>>2]);g[j+12>>2]=k;d=PLa(a,b,j,e,f)|0;i=h;return d|0}function Qvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im;h=i;i=i+16|0;j=h;k=ea(g[c+4>>2]);g[j>>2]=ea(g[d+16>>2]);g[j+4>>2]=ea(g[d+20>>2]);g[j+8>>2]=ea(g[d+24>>2]);g[j+12>>2]=k;d=SLa(a,b,j,e,f)|0;i=h;return d|0}function Rvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function Svb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0;c=i;i=i+16|0;h=c;j=ea(g[f>>2]);k=ea(j*ea(2.0));l=ea(g[f+12>>2]);m=ea(l*ea(2.0));n=ea(ea(j*k)+ea(ea(l*m)+ea(-1.0)));l=ea(g[f+8>>2]);j=ea(l*m);o=ea(g[f+4>>2]);p=ea(j+ea(k*o));j=ea(ea(k*l)-ea(m*o));o=ea(g[e+8>>2]);m=ea(o*n);n=ea(o*p);p=ea(o*j);j=ea(g[f+16>>2]);o=ea(j+m);l=ea(g[f+20>>2]);k=ea(l+n);q=ea(g[f+24>>2]);r=ea(p+q);s=ea(j-m);m=ea(l-n);n=ea(q-p);p=ea(g[e+4>>2]);tLa(h,d);q=ea(g[h>>2]);l=ea(o*q);o=ea(g[h+4>>2]);j=ea(l+ea(k*o));k=ea(g[h+8>>2]);l=ea(j+ea(r*k));r=ea(g[h+12>>2]);j=ea(r+l);l=ea(r+ea(ea(ea(s*q)+ea(m*o))+ea(n*k)));n=ea((j<l?j:l)-p);if(n>ea(0.0)){t=0;i=c;return t|0}p=ea(-o);o=ea(-k);g[a>>2]=ea(-q);g[a+4>>2]=p;g[a+8>>2]=o;o=ea(-n);a=n<ea(-0.0);g[b>>2]=a?o:ea(0.0);t=1;i=c;return t|0}function Tvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;c=i;i=i+80|0;h=c+16|0;j=c;g[h+36>>2]=ea(g[f+16>>2]);g[h+40>>2]=ea(g[f+20>>2]);g[h+44>>2]=ea(g[f+24>>2]);g[h+48>>2]=ea(g[e+4>>2]);g[h+52>>2]=ea(g[e+8>>2]);g[h+56>>2]=ea(g[e+12>>2]);k=ea(g[f>>2]);l=ea(g[f+4>>2]);m=ea(g[f+8>>2]);n=ea(g[f+12>>2]);o=ea(k+k);p=ea(l+l);q=ea(m+m);r=ea(l*p);s=ea(m*q);t=ea(o*l);l=ea(o*m);u=ea(o*n);v=ea(p*m);m=ea(p*n);p=ea(q*n);n=ea(t+p);q=ea(l-m);w=ea(t-p);p=ea(ea(1.0)-ea(k*o));o=ea(p-s);k=ea(v+u);t=ea(l+m);m=ea(v-u);u=ea(p-r);g[h>>2]=ea(ea(ea(1.0)-r)-s);g[h+4>>2]=n;g[h+8>>2]=q;g[h+12>>2]=w;g[h+16>>2]=o;g[h+20>>2]=k;g[h+24>>2]=t;g[h+28>>2]=m;g[h+32>>2]=u;tLa(j,d);d=NLa(a,b,j,h)|0;i=c;return d|0}function Uvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;c=i;i=i+16|0;g=c;tLa(g,d);d=OLa(a,b,g,e,f)|0;i=c;return d|0}function Vvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;h=i;i=i+64|0;j=h+28|0;k=h;l=ea(g[d>>2]);m=ea(l*ea(2.0));n=ea(g[d+12>>2]);o=ea(n*ea(2.0));p=ea(ea(l*m)+ea(ea(n*o)+ea(-1.0)));n=ea(g[d+8>>2]);l=ea(n*o);q=ea(g[d+4>>2]);r=ea(l+ea(m*q));l=ea(ea(m*n)-ea(o*q));q=ea(g[c+8>>2]);o=ea(q*p);p=ea(q*r);r=ea(q*l);l=ea(g[d+16>>2]);q=ea(l+o);n=ea(g[d+20>>2]);m=ea(n+p);s=ea(g[d+24>>2]);t=ea(r+s);g[j>>2]=q;g[j+4>>2]=m;g[j+8>>2]=t;t=ea(n-p);p=ea(s-r);g[j+12>>2]=ea(l-o);g[j+16>>2]=t;g[j+20>>2]=p;g[j+24>>2]=ea(g[c+4>>2]);p=ea(g[f>>2]);t=ea(p*ea(2.0));o=ea(g[f+12>>2]);l=ea(o*ea(2.0));r=ea(ea(p*t)+ea(ea(o*l)+ea(-1.0)));o=ea(g[f+8>>2]);p=ea(o*l);s=ea(g[f+4>>2]);n=ea(p+ea(t*s));p=ea(ea(t*o)-ea(l*s));s=ea(g[e+8>>2]);l=ea(s*r);r=ea(s*n);n=ea(s*p);p=ea(g[f+16>>2]);s=ea(p+l);o=ea(g[f+20>>2]);t=ea(o+r);m=ea(g[f+24>>2]);q=ea(n+m);g[k>>2]=s;g[k+4>>2]=t;g[k+8>>2]=q;q=ea(o-r);r=ea(m-n);g[k+12>>2]=ea(p-l);g[k+16>>2]=q;g[k+20>>2]=r;g[k+24>>2]=ea(g[e+4>>2]);e=FLa(a,b,j,k)|0;i=h;return e|0}function Wvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;h=i;i=i+96|0;j=h+60|0;k=h;l=ea(g[d>>2]);m=ea(l*ea(2.0));n=ea(g[d+12>>2]);o=ea(n*ea(2.0));p=ea(ea(l*m)+ea(ea(n*o)+ea(-1.0)));n=ea(g[d+8>>2]);l=ea(n*o);q=ea(g[d+4>>2]);r=ea(l+ea(m*q));l=ea(ea(m*n)-ea(o*q));q=ea(g[c+8>>2]);o=ea(q*p);p=ea(q*r);r=ea(q*l);l=ea(g[d+16>>2]);q=ea(l+o);n=ea(g[d+20>>2]);m=ea(n+p);s=ea(g[d+24>>2]);t=ea(r+s);g[j>>2]=q;g[j+4>>2]=m;g[j+8>>2]=t;t=ea(n-p);p=ea(s-r);g[j+12>>2]=ea(l-o);g[j+16>>2]=t;g[j+20>>2]=p;g[j+24>>2]=ea(g[c+4>>2]);g[k+36>>2]=ea(g[f+16>>2]);g[k+40>>2]=ea(g[f+20>>2]);g[k+44>>2]=ea(g[f+24>>2]);g[k+48>>2]=ea(g[e+4>>2]);g[k+52>>2]=ea(g[e+8>>2]);g[k+56>>2]=ea(g[e+12>>2]);p=ea(g[f>>2]);t=ea(g[f+4>>2]);o=ea(g[f+8>>2]);l=ea(g[f+12>>2]);r=ea(p+p);s=ea(t+t);n=ea(o+o);m=ea(t*s);q=ea(o*n);u=ea(r*t);t=ea(r*o);v=ea(r*l);w=ea(s*o);o=ea(s*l);s=ea(n*l);l=ea(u+s);n=ea(t-o);x=ea(u-s);s=ea(ea(1.0)-ea(p*r));r=ea(s-q);p=ea(w+v);u=ea(t+o);o=ea(w-v);v=ea(s-m);g[k>>2]=ea(ea(ea(1.0)-m)-q);g[k+4>>2]=l;g[k+8>>2]=n;g[k+12>>2]=x;g[k+16>>2]=r;g[k+20>>2]=p;g[k+24>>2]=u;g[k+28>>2]=o;g[k+32>>2]=v;f=GLa(a,b,j,k)|0;i=h;return f|0}function Xvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;h=i;i=i+32|0;j=h;k=ea(g[d>>2]);l=ea(k*ea(2.0));m=ea(g[d+12>>2]);n=ea(m*ea(2.0));o=ea(ea(k*l)+ea(ea(m*n)+ea(-1.0)));m=ea(g[d+8>>2]);k=ea(m*n);p=ea(g[d+4>>2]);q=ea(k+ea(l*p));k=ea(ea(l*m)-ea(n*p));p=ea(g[c+8>>2]);n=ea(p*o);o=ea(p*q);q=ea(p*k);k=ea(g[d+16>>2]);p=ea(k+n);m=ea(g[d+20>>2]);l=ea(m+o);r=ea(g[d+24>>2]);s=ea(q+r);g[j>>2]=p;g[j+4>>2]=l;g[j+8>>2]=s;s=ea(m-o);o=ea(r-q);g[j+12>>2]=ea(k-n);g[j+16>>2]=s;g[j+20>>2]=o;g[j+24>>2]=ea(g[c+4>>2]);c=KLa(a,b,j,d,e,f)|0;i=h;return c|0}function Yvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;h=i;i=i+32|0;j=h;k=ea(g[d>>2]);l=ea(k*ea(2.0));m=ea(g[d+12>>2]);n=ea(m*ea(2.0));o=ea(ea(k*l)+ea(ea(m*n)+ea(-1.0)));m=ea(g[d+8>>2]);k=ea(m*n);p=ea(g[d+4>>2]);q=ea(k+ea(l*p));k=ea(ea(l*m)-ea(n*p));p=ea(g[c+8>>2]);n=ea(p*o);o=ea(p*q);q=ea(p*k);k=ea(g[d+16>>2]);p=ea(k+n);m=ea(g[d+20>>2]);l=ea(m+o);r=ea(g[d+24>>2]);s=ea(q+r);g[j>>2]=p;g[j+4>>2]=l;g[j+8>>2]=s;s=ea(m-o);o=ea(r-q);g[j+12>>2]=ea(k-n);g[j+16>>2]=s;g[j+20>>2]=o;g[j+24>>2]=ea(g[c+4>>2]);c=QLa(a,b,j,e,f)|0;i=h;return c|0}function Zvb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;h=i;i=i+32|0;j=h;k=ea(g[d>>2]);l=ea(k*ea(2.0));m=ea(g[d+12>>2]);n=ea(m*ea(2.0));o=ea(ea(k*l)+ea(ea(m*n)+ea(-1.0)));m=ea(g[d+8>>2]);k=ea(m*n);p=ea(g[d+4>>2]);q=ea(k+ea(l*p));k=ea(ea(l*m)-ea(n*p));p=ea(g[c+8>>2]);n=ea(p*o);o=ea(p*q);q=ea(p*k);k=ea(g[d+16>>2]);p=ea(k+n);m=ea(g[d+20>>2]);l=ea(m+o);r=ea(g[d+24>>2]);s=ea(q+r);g[j>>2]=p;g[j+4>>2]=l;g[j+8>>2]=s;s=ea(m-o);o=ea(r-q);g[j+12>>2]=ea(k-n);g[j+16>>2]=s;g[j+20>>2]=o;g[j+24>>2]=ea(g[c+4>>2]);c=TLa(a,b,j,e,f)|0;i=h;return c|0}function _vb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;h=i;i=i+128|0;j=h+60|0;k=h;g[j+36>>2]=ea(g[d+16>>2]);g[j+40>>2]=ea(g[d+20>>2]);g[j+44>>2]=ea(g[d+24>>2]);g[j+48>>2]=ea(g[c+4>>2]);g[j+52>>2]=ea(g[c+8>>2]);g[j+56>>2]=ea(g[c+12>>2]);l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(g[d+12>>2]);p=ea(l+l);q=ea(m+m);r=ea(n+n);s=ea(m*q);t=ea(n*r);u=ea(p*m);m=ea(p*n);v=ea(p*o);w=ea(q*n);n=ea(q*o);q=ea(r*o);o=ea(u+q);r=ea(m-n);x=ea(u-q);q=ea(ea(1.0)-ea(l*p));p=ea(q-t);l=ea(w+v);u=ea(m+n);n=ea(w-v);v=ea(q-s);g[j>>2]=ea(ea(ea(1.0)-s)-t);g[j+4>>2]=o;g[j+8>>2]=r;g[j+12>>2]=x;g[j+16>>2]=p;g[j+20>>2]=l;g[j+24>>2]=u;g[j+28>>2]=n;g[j+32>>2]=v;g[k+36>>2]=ea(g[f+16>>2]);g[k+40>>2]=ea(g[f+20>>2]);g[k+44>>2]=ea(g[f+24>>2]);g[k+48>>2]=ea(g[e+4>>2]);g[k+52>>2]=ea(g[e+8>>2]);g[k+56>>2]=ea(g[e+12>>2]);v=ea(g[f>>2]);n=ea(g[f+4>>2]);u=ea(g[f+8>>2]);l=ea(g[f+12>>2]);p=ea(v+v);x=ea(n+n);r=ea(u+u);o=ea(n*x);t=ea(u*r);s=ea(p*n);n=ea(p*u);q=ea(p*l);w=ea(x*u);u=ea(x*l);x=ea(r*l);l=ea(s+x);r=ea(n-u);m=ea(s-x);x=ea(ea(1.0)-ea(v*p));p=ea(x-t);v=ea(w+q);s=ea(n+u);u=ea(w-q);q=ea(x-o);g[k>>2]=ea(ea(ea(1.0)-o)-t);g[k+4>>2]=l;g[k+8>>2]=r;g[k+12>>2]=m;g[k+16>>2]=p;g[k+20>>2]=v;g[k+24>>2]=s;g[k+28>>2]=u;g[k+32>>2]=q;f=HLa(a,b,j,k)|0;i=h;return f|0}function $vb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;h=i;i=i+64|0;j=h;g[j+36>>2]=ea(g[d+16>>2]);g[j+40>>2]=ea(g[d+20>>2]);g[j+44>>2]=ea(g[d+24>>2]);g[j+48>>2]=ea(g[c+4>>2]);g[j+52>>2]=ea(g[c+8>>2]);g[j+56>>2]=ea(g[c+12>>2]);k=ea(g[d>>2]);l=ea(g[d+4>>2]);m=ea(g[d+8>>2]);n=ea(g[d+12>>2]);o=ea(k+k);p=ea(l+l);q=ea(m+m);r=ea(l*p);s=ea(m*q);t=ea(o*l);l=ea(o*m);u=ea(o*n);v=ea(p*m);m=ea(p*n);p=ea(q*n);n=ea(t+p);q=ea(l-m);w=ea(t-p);p=ea(ea(1.0)-ea(k*o));o=ea(p-s);k=ea(v+u);t=ea(l+m);m=ea(v-u);u=ea(p-r);g[j>>2]=ea(ea(ea(1.0)-r)-s);g[j+4>>2]=n;g[j+8>>2]=q;g[j+12>>2]=w;g[j+16>>2]=o;g[j+20>>2]=k;g[j+24>>2]=t;g[j+28>>2]=m;g[j+32>>2]=u;d=LLa(a,b,j,e,f)|0;i=h;return d|0}function awb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;h=i;i=i+64|0;j=h;g[j+36>>2]=ea(g[d+16>>2]);g[j+40>>2]=ea(g[d+20>>2]);g[j+44>>2]=ea(g[d+24>>2]);g[j+48>>2]=ea(g[c+4>>2]);g[j+52>>2]=ea(g[c+8>>2]);g[j+56>>2]=ea(g[c+12>>2]);k=ea(g[d>>2]);l=ea(g[d+4>>2]);m=ea(g[d+8>>2]);n=ea(g[d+12>>2]);o=ea(k+k);p=ea(l+l);q=ea(m+m);r=ea(l*p);s=ea(m*q);t=ea(o*l);l=ea(o*m);u=ea(o*n);v=ea(p*m);m=ea(p*n);p=ea(q*n);n=ea(t+p);q=ea(l-m);w=ea(t-p);p=ea(ea(1.0)-ea(k*o));o=ea(p-s);k=ea(v+u);t=ea(l+m);m=ea(v-u);u=ea(p-r);g[j>>2]=ea(ea(ea(1.0)-r)-s);g[j+4>>2]=n;g[j+8>>2]=q;g[j+12>>2]=w;g[j+16>>2]=o;g[j+20>>2]=k;g[j+24>>2]=t;g[j+28>>2]=m;g[j+32>>2]=u;d=RLa(a,b,j,e,f)|0;i=h;return d|0}function bwb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;h=i;i=i+64|0;j=h;g[j+36>>2]=ea(g[d+16>>2]);g[j+40>>2]=ea(g[d+20>>2]);g[j+44>>2]=ea(g[d+24>>2]);g[j+48>>2]=ea(g[c+4>>2]);g[j+52>>2]=ea(g[c+8>>2]);g[j+56>>2]=ea(g[c+12>>2]);k=ea(g[d>>2]);l=ea(g[d+4>>2]);m=ea(g[d+8>>2]);n=ea(g[d+12>>2]);o=ea(k+k);p=ea(l+l);q=ea(m+m);r=ea(l*p);s=ea(m*q);t=ea(o*l);l=ea(o*m);u=ea(o*n);v=ea(p*m);m=ea(p*n);p=ea(q*n);n=ea(t+p);q=ea(l-m);w=ea(t-p);p=ea(ea(1.0)-ea(k*o));o=ea(p-s);k=ea(v+u);t=ea(l+m);m=ea(v-u);u=ea(p-r);g[j>>2]=ea(ea(ea(1.0)-r)-s);g[j+4>>2]=n;g[j+8>>2]=q;g[j+12>>2]=w;g[j+16>>2]=o;g[j+20>>2]=k;g[j+24>>2]=t;g[j+28>>2]=m;g[j+32>>2]=u;d=ULa(a,b,j,e,f)|0;i=h;return d|0}function cwb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=MLa(a,b,c,d,e,f)|0;i=g;return h|0}function dwb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+4240|0;k=j+4176|0;l=j+4120|0;m=j+4116|0;n=j;o=j+4112|0;c[k>>2]=-1;CLa(k,d);c[l>>2]=-1;CLa(l,f);c[m>>2]=0;f=n+4096|0;c[f>>2]=0;g[n+4100>>2]=ea(0.0);g[o>>2]=ea(0.0);if(!(TNa(k,l,e,h,o,m,n)|0)){p=0;i=j;return p|0}if(!(f6a(a,b,c[f>>2]|0,n)|0)){p=0;i=j;return p|0}p=(c[f>>2]|0)!=0;i=j;return p|0}function ewb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+4240|0;k=j+4176|0;l=j+4120|0;m=j+4116|0;n=j;o=j+4112|0;c[k>>2]=-1;CLa(k,d);c[l>>2]=-1;CLa(l,f);c[m>>2]=0;f=n+4096|0;c[f>>2]=0;g[n+4100>>2]=ea(0.0);g[o>>2]=ea(0.0);if(!(VNa(k,l,e,h,o,m,n)|0)){p=0;i=j;return p|0}if(!(f6a(a,b,c[f>>2]|0,n)|0)){p=0;i=j;return p|0}p=(c[f>>2]|0)!=0;i=j;return p|0}function fwb(a){a=a|0;return}function gwb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function hwb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;HFb(a,c[b+48>>2]|0,d);i=e;return}function iwb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;XGb(c[a+48>>2]|0,b,d,e);i=f;return}function jwb(a,b,e,f,h){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;j=i;k=c[a+48>>2]|0;if(!e){i=j;return}a=k+96|0;l=k+112|0;m=k+128|0;n=k+100|0;o=k+116|0;p=k+132|0;q=k+104|0;r=k+120|0;s=k+136|0;k=0;do{t=d[b+k>>0]|0;u=ea(g[f+(t*12|0)>>2]);v=ea(g[f+(t*12|0)+4>>2]);w=ea(g[f+(t*12|0)+8>>2]);x=ea(u*ea(g[a>>2]));y=ea(x+ea(v*ea(g[l>>2])));x=ea(y+ea(w*ea(g[m>>2])));y=ea(u*ea(g[n>>2]));z=ea(y+ea(v*ea(g[o>>2])));y=ea(z+ea(w*ea(g[p>>2])));z=ea(u*ea(g[q>>2]));u=ea(z+ea(v*ea(g[r>>2])));v=ea(u+ea(w*ea(g[s>>2])));g[h+(k<<4)>>2]=x;g[h+(k<<4)+4>>2]=y;g[h+(k<<4)+8>>2]=v;g[h+(k<<4)+12>>2]=ea(0.0);k=k+1|0}while((k|0)!=(e|0));i=j;return}function kwb(a){a=a|0;return}function lwb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function mwb(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0;f=i;h=c[b+48>>2]|0;if(!(c[h+196>>2]|0)){b=h+200|0;j=c[b>>2]|0;k=e+4|0;l=e+8|0;m=h+204|0;if((d[m>>0]|0)>1){n=ea(g[k>>2]);o=ea(g[e>>2]);p=ea(g[j+4>>2]);q=ea(n*p);p=ea(o*ea(g[j>>2]));o=ea(g[l>>2]);r=j;n=ea(ea(q+p)+ea(o*ea(g[j+8>>2])));s=1;t=0;while(1){u=c[b>>2]|0;o=ea(g[u+(s*12|0)>>2]);p=ea(g[u+(s*12|0)+4>>2]);q=ea(g[u+(s*12|0)+8>>2]);v=ea(g[e>>2]);w=ea(g[k>>2]);x=ea(ea(ea(o*v)+ea(p*w))+ea(q*ea(g[l>>2])));y=x>n;z=y?s:t;A=s+1|0;if(A>>>0<(d[m>>0]|0)>>>0){r=u;n=y?x:n;s=A;t=z}else{B=z;C=u;break}}}else{B=0;C=j}}else{j=DFb(h,e)|0;B=j;C=c[h+200>>2]|0}n=ea(g[C+(B*12|0)>>2]);x=ea(g[C+(B*12|0)+4>>2]);q=ea(g[C+(B*12|0)+8>>2]);g[a>>2]=n;g[a+4>>2]=x;g[a+8>>2]=q;g[a+12>>2]=ea(0.0);i=f;return}function nwb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;YGb(c[a+48>>2]|0,b,d,e);i=f;return}function owb(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im;a=i;if(!c){i=a;return}else h=0;do{j=d[b+h>>0]|0;k=ea(g[e+(j*12|0)>>2]);l=ea(g[e+(j*12|0)+4>>2]);m=ea(g[e+(j*12|0)+8>>2]);g[f+(h<<4)>>2]=k;g[f+(h<<4)+4>>2]=l;g[f+(h<<4)+8>>2]=m;g[f+(h<<4)+12>>2]=ea(0.0);h=h+1|0}while((h|0)!=(c|0));i=a;return}function pwb(a){a=a|0;return}function qwb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function rwb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=0,n=0,o=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[b+48>>2]|0;k=ea(g[d>>2]);l=ea(g[d+4>>2]);b=k>ea(0.0);m=l>ea(0.0);n=ea(g[d+8>>2])>ea(0.0);d=j+144|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];l=ea(g[j+144>>2]);k=ea(g[j+148>>2]);o=ea(-k);k=ea(-ea(g[j+152>>2]));g[f>>2]=ea(-l);g[f+4>>2]=o;g[f+8>>2]=k;g[f+12>>2]=ea(0.0);k=ea(g[(b?h:f)>>2]);o=ea(g[(m?h:f)+4>>2]);l=ea(g[(n?h:f)+8>>2]);g[a>>2]=k;g[a+4>>2]=o;g[a+8>>2]=l;g[a+12>>2]=ea(0.0);i=e;return}function swb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=Im,t=Im,u=Im;f=i;i=i+64|0;h=f+16|0;j=f;k=f+44|0;l=f+32|0;m=c[a+48>>2]|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(g[b+8>>2]);b=n>ea(0.0);a=o>ea(0.0);q=p>ea(0.0);r=m+144|0;c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[j+12>>2]=c[r+12>>2];s=ea(g[m+144>>2]);t=ea(g[m+148>>2]);u=ea(-t);t=ea(-ea(g[m+152>>2]));g[h>>2]=ea(-s);g[h+4>>2]=u;g[h+8>>2]=t;g[h+12>>2]=ea(0.0);t=ea(g[(b?j:h)>>2]);u=ea(g[(a?j:h)+4>>2]);s=ea(ea(ea(n*t)+ea(o*u))+ea(p*ea(g[(q?j:h)+8>>2])));g[e>>2]=s;h=e+4|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];g[d>>2]=ea(-s);k=d+4|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];i=f;return}function twb(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im;a=i;if(!c){i=a;return}else h=0;do{j=d[b+h>>0]|0;k=ea(g[e+(j*12|0)>>2]);l=ea(g[e+(j*12|0)+4>>2]);m=ea(g[e+(j*12|0)+8>>2]);g[f+(h<<4)>>2]=k;g[f+(h<<4)+4>>2]=l;g[f+(h<<4)+8>>2]=m;g[f+(h<<4)+12>>2]=ea(0.0);h=h+1|0}while((h|0)!=(c|0));i=a;return}function uwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im;f=ea(g[d+16>>2]);h=ea(f-ea(g[b+16>>2]));f=ea(g[d+20>>2]);i=ea(f-ea(g[b+20>>2]));f=ea(g[d+24>>2]);j=ea(f-ea(g[b+24>>2]));f=ea(ea(ea(h*h)+ea(i*i))+ea(j*j));j=ea(g[a+4>>2]);i=ea(j+ea(g[c+4>>2]));c=f<=ea(i*i);return c|0}function vwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=Im,h=Im,j=Im;e=i;i=i+16|0;c=e;tLa(c,d);f=ea(g[b+16>>2]);h=ea(f*ea(g[c>>2]));f=ea(g[b+20>>2]);j=ea(h+ea(f*ea(g[c+4>>2])));f=ea(g[b+24>>2]);h=ea(j+ea(f*ea(g[c+8>>2])));f=ea(ea(g[c+12>>2])+h);c=f<=ea(g[a+4>>2]);i=e;return c|0}function wwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;e=i;i=i+32|0;f=e;h=ea(g[d>>2]);j=ea(h*ea(2.0));k=ea(g[d+12>>2]);l=ea(k*ea(2.0));m=ea(ea(h*j)+ea(ea(k*l)+ea(-1.0)));k=ea(g[d+8>>2]);h=ea(k*l);n=ea(g[d+4>>2]);o=ea(h+ea(j*n));h=ea(ea(j*k)-ea(l*n));n=ea(g[c+8>>2]);l=ea(n*m);m=ea(n*o);o=ea(n*h);h=ea(g[d+16>>2]);n=ea(h+l);k=ea(g[d+20>>2]);j=ea(k+m);p=ea(g[d+24>>2]);q=ea(o+p);g[f>>2]=n;g[f+4>>2]=j;g[f+8>>2]=q;q=ea(k-m);m=ea(p-o);g[f+12>>2]=ea(h-l);g[f+16>>2]=q;g[f+20>>2]=m;m=ea(g[a+4>>2]);q=ea(m+ea(g[c+4>>2]));c=ea(IOa(f,f+12|0,b+16|0,0))<=ea(q*q);i=e;return c|0}function xwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;e=i;i=i+80|0;f=e+16|0;h=e;g[f+36>>2]=ea(g[d+16>>2]);g[f+40>>2]=ea(g[d+20>>2]);g[f+44>>2]=ea(g[d+24>>2]);g[f+48>>2]=ea(g[c+4>>2]);g[f+52>>2]=ea(g[c+8>>2]);g[f+56>>2]=ea(g[c+12>>2]);j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);m=ea(g[d+12>>2]);n=ea(j+j);o=ea(k+k);p=ea(l+l);q=ea(k*o);r=ea(l*p);s=ea(n*k);k=ea(n*l);t=ea(n*m);u=ea(o*l);l=ea(o*m);o=ea(p*m);m=ea(s+o);p=ea(k-l);v=ea(s-o);o=ea(ea(1.0)-ea(j*n));n=ea(o-r);j=ea(u+t);s=ea(k+l);l=ea(u-t);t=ea(o-q);g[f>>2]=ea(ea(ea(1.0)-q)-r);g[f+4>>2]=m;g[f+8>>2]=p;g[f+12>>2]=v;g[f+16>>2]=n;g[f+20>>2]=j;g[f+24>>2]=s;g[f+28>>2]=l;g[f+32>>2]=t;t=ea(g[a+4>>2]);g[h>>2]=ea(g[b+16>>2]);g[h+4>>2]=ea(g[b+20>>2]);g[h+8>>2]=ea(g[b+24>>2]);g[h+12>>2]=t;b=qMa(h,f)|0;i=e;return b|0}function ywb(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im;j=i;i=i+16|0;k=j;l=c[e+32>>2]|0;m=(h|0)==0;if(!m?(n=(b[h+12>>1]|0)==2?h:0,(n|0)!=0):0){o=ea(g[n>>2]);p=ea(g[n+4>>2]);q=o;r=p;s=ea(g[n+8>>2])}else{q=ea(0.0);r=ea(0.0);s=ea(1.0)}p=ea(g[a+4>>2]);g[k>>2]=ea(g[d+16>>2]);g[k+4>>2]=ea(g[d+20>>2]);g[k+8>>2]=ea(g[d+24>>2]);g[k+12>>2]=p;d=rMa(k,l,e+4|0,f,0)|0;if(!(m|d^1)){g[h>>2]=q;g[h+4>>2]=r;g[h+8>>2]=s}if(m){i=j;return d|0}m=h+12|0;if(d){b[m>>1]=2;i=j;return d|0}else{b[m>>1]=0;i=j;return d|0}return 0}function zwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+16|0;dKa(bKa()|0,8,538928,991,539008,e);i=e;return 0}function Awb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Bwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0;e=i;i=i+16|0;a=e;f=ea(g[d>>2]);h=ea(f*ea(2.0));j=ea(g[d+12>>2]);k=ea(j*ea(2.0));l=ea(ea(f*h)+ea(ea(j*k)+ea(-1.0)));j=ea(g[d+8>>2]);f=ea(j*k);m=ea(g[d+4>>2]);n=ea(f+ea(h*m));f=ea(ea(h*j)-ea(k*m));m=ea(g[c+8>>2]);k=ea(m*l);l=ea(m*n);n=ea(m*f);f=ea(g[d+16>>2]);m=ea(f+k);j=ea(g[d+20>>2]);h=ea(j+l);o=ea(g[d+24>>2]);p=ea(n+o);q=ea(g[c+4>>2]);tLa(a,b);r=ea(g[a>>2]);s=ea(m*r);m=ea(g[a+4>>2]);t=ea(s+ea(h*m));h=ea(g[a+8>>2]);s=ea(t+ea(p*h));p=ea(g[a+12>>2]);if(ea(p+s)<=q){u=1;i=e;return u|0}u=ea(p+ea(ea(ea(ea(f-k)*r)+ea(ea(j-l)*m))+ea(ea(o-n)*h)))<=q;i=e;return u|0}function Cwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0;e=i;i=i+16|0;a=e;f=ea(g[d>>2]);h=ea(f+f);j=ea(g[d+4>>2]);k=ea(j+j);l=ea(g[d+8>>2]);m=ea(l+l);n=ea(g[d+12>>2]);o=ea(h*n);p=ea(k*n);q=ea(n*m);n=ea(f*k);r=ea(f*m);s=ea(j*k);k=ea(j*m);j=ea(l*m);m=ea(ea(ea(1.0)-s)-j);l=ea(n+q);t=ea(r-p);u=ea(n-q);q=ea(ea(1.0)-ea(f*h));h=ea(q-j);j=ea(k+o);f=ea(r+p);p=ea(k-o);o=ea(q-s);s=ea(g[d+16>>2]);q=ea(g[d+20>>2]);k=ea(g[d+24>>2]);tLa(a,b);r=ea(g[c+4>>2]);n=ea(g[c+8>>2]);v=ea(g[c+12>>2]);w=ea(g[a>>2]);x=ea(g[a+4>>2]);y=ea(g[a+8>>2]);z=ea(g[a+12>>2]);a=-1;a:while(1){A=ea(ea(a|0)*r);B=ea(m*A);C=ea(l*A);D=ea(t*A);c=-1;while(1){A=ea(ea(c|0)*n);E=ea(B+ea(u*A));F=ea(C+ea(h*A));G=ea(D+ea(j*A));b=-1;while(1){A=ea(ea(b|0)*v);if(ea(z+ea(ea(y*ea(k+ea(G+ea(o*A))))+ea(ea(w*ea(s+ea(E+ea(f*A))))+ea(x*ea(q+ea(F+ea(p*A)))))))<=ea(0.0)){H=1;I=8;break a}if((b|0)<0)b=b+2|0;else break}if((c|0)<0)c=c+2|0;else break}if((a|0)<0)a=a+2|0;else{H=0;I=8;break}}if((I|0)==8){i=e;return H|0}return 0}function Dwb(a,b,f,h,j){a=a|0;b=b|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=Im,Q=0,R=Im,S=Im,T=0;j=i;i=i+96|0;a=j+12|0;k=j+56|0;l=j+16|0;m=j+60|0;n=j+80|0;o=j;p=j+28|0;q=j+64|0;r=c[f+32>>2]|0;s=ea(g[h+16>>2]);t=ea(g[h+20>>2]);u=ea(s*ea(-2.0));s=ea(t*ea(-2.0));t=ea(ea(g[h+24>>2])*ea(-2.0));v=ea(g[h+12>>2]);w=ea(ea(v*v)+ea(-.5));x=ea(g[h>>2]);y=ea(u*x);z=ea(g[h+4>>2]);A=ea(y+ea(s*z));y=ea(g[h+8>>2]);B=ea(A+ea(t*y));A=ea(ea(x*B)+ea(ea(u*w)-ea(v*ea(ea(t*z)-ea(s*y)))));C=ea(ea(z*B)+ea(ea(s*w)-ea(v*ea(ea(u*y)-ea(t*x)))));D=ea(ea(ea(t*w)-ea(v*ea(ea(s*x)-ea(u*z))))+ea(y*B));B=ea(-x);x=ea(-z);z=ea(-y);y=ea(ea(g[b+16>>2])*ea(2.0));u=ea(ea(g[b+20>>2])*ea(2.0));s=ea(ea(g[b+24>>2])*ea(2.0));t=ea(ea(ea(y*B)+ea(u*x))+ea(s*z));E=ea(A+ea(ea(t*B)+ea(ea(w*y)+ea(v*ea(ea(s*x)-ea(u*z))))));A=ea(C+ea(ea(t*x)+ea(ea(w*u)+ea(v*ea(ea(y*z)-ea(s*B))))));C=ea(D+ea(ea(ea(w*s)+ea(v*ea(ea(u*B)-ea(y*x))))+ea(t*z)));t=ea(g[b>>2]);y=ea(v*t);u=ea(g[b+12>>2]);s=ea(y+ea(u*B));y=ea(g[b+8>>2]);w=ea(s+ea(y*x));s=ea(g[b+4>>2]);D=ea(ea(ea(t*z)+ea(ea(u*x)+ea(v*s)))-ea(y*B));F=ea(ea(ea(s*B)+ea(ea(u*z)+ea(v*y)))-ea(t*x));G=ea(ea(ea(ea(v*u)-ea(t*B))-ea(s*x))-ea(y*z));g[p>>2]=ea(w-ea(s*z));g[p+4>>2]=D;g[p+8>>2]=F;g[p+12>>2]=G;g[p+16>>2]=E;g[p+20>>2]=A;g[p+24>>2]=C;tLa(q,p);C=ea(g[f+16>>2]);A=ea(g[f+20>>2]);E=ea(g[f+24>>2]);G=ea(g[f+28>>2]);F=ea(C+C);D=ea(A+A);z=ea(E+E);s=ea(A*D);w=ea(E*z);y=ea(F*A);A=ea(F*E);x=ea(F*G);B=ea(D*E);E=ea(D*G);D=ea(z*G);G=ea(ea(ea(1.0)-s)-w);z=ea(y+D);t=ea(A-E);u=ea(y-D);D=ea(ea(1.0)-ea(C*F));F=ea(D-w);w=ea(B+x);C=ea(A+E);E=ea(B-x);x=ea(D-s);s=ea(g[f+4>>2]);D=ea(s*G);B=ea(s*u);A=ea(s*C);s=ea(g[f+8>>2]);y=ea(z*s);v=ea(F*s);H=ea(E*s);s=ea(g[f+12>>2]);I=ea(t*s);J=ea(w*s);K=ea(x*s);s=ea(ea(ea(G*D)+ea(z*y))+ea(t*I));L=ea(ea(ea(G*B)+ea(z*v))+ea(t*J));M=ea(ea(ea(G*A)+ea(z*H))+ea(t*K));t=ea(ea(ea(u*D)+ea(F*y))+ea(w*I));z=ea(ea(ea(u*B)+ea(F*v))+ea(w*J));G=ea(ea(ea(u*A)+ea(F*H))+ea(w*K));w=ea(ea(ea(C*D)+ea(E*y))+ea(x*I));I=ea(ea(ea(C*B)+ea(E*v))+ea(x*J));J=ea(ea(ea(C*A)+ea(E*H))+ea(x*K));K=ea(g[q>>2]);x=ea(g[q+4>>2]);H=ea(g[q+8>>2]);E=ea(ea(w*H)+ea(ea(K*s)+ea(x*t)));t=ea(ea(I*H)+ea(ea(K*L)+ea(x*z)));z=ea(ea(J*H)+ea(ea(K*M)+ea(x*G)));g[l>>2]=E;f=l+4|0;g[f>>2]=t;p=l+8|0;g[p>>2]=z;b=(c[r+56>>2]|0)+((d[r+55>>0]|0)*20|0)|0;h=r+60|0;N=c[h>>2]|0;if(N){O=e[N>>1]|0;N=COa(l,a,k)|0;G=ea(ea((O+-1|0)>>>0)*ea(.5));x=ea(G*ea(ea(g[a>>2])+ea(1.0)));a=(da((~~ea(x+ea(.5))>>>0)+(da(N,O)|0)|0,O)|0)+(~~ea(ea(G*ea(ea(g[k>>2])+ea(1.0)))+ea(.5))>>>0)|0;k=c[h>>2]|0;O=c[k+4>>2]|0;c[m>>2]=d[O+a>>0];c[n>>2]=d[O+((e[k+2>>1]|0)+a)>>0];G=ea(-ea(g[l>>2]));x=ea(-ea(g[f>>2]));M=ea(-ea(g[p>>2]));g[o>>2]=G;g[o+4>>2]=x;g[o+8>>2]=M;DOa(m,o,b,k);DOa(n,l,b,c[h>>2]|0);h=c[m>>2]|0;M=ea(g[b+(h*12|0)>>2]);x=ea(M*ea(g[l>>2]));M=ea(g[b+(h*12|0)+4>>2]);G=ea(x+ea(M*ea(g[f>>2])));M=ea(g[b+(h*12|0)+8>>2]);P=ea(G+ea(M*ea(g[p>>2])));Q=q+12|0;R=ea(g[Q>>2]);S=ea(-R);T=P<=S;i=j;return T|0}p=d[r+54>>0]|0;r=b;M=ea(3402823469999999843913219.0e14);while(1){p=p+-1|0;G=ea(E*ea(g[r>>2]));x=ea(G+ea(t*ea(g[r+4>>2])));G=ea(x+ea(z*ea(g[r+8>>2])));x=M<G?M:G;if(!p){P=x;break}else{r=r+12|0;M=x}}Q=q+12|0;R=ea(g[Q>>2]);S=ea(-R);T=P<=S;i=j;return T|0}function Ewb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Fwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;e=i;i=i+80|0;f=e+60|0;h=e+48|0;j=e+24|0;k=e;l=ea(g[b>>2]);m=ea(l*ea(2.0));n=ea(g[b+12>>2]);o=ea(n*ea(2.0));p=ea(ea(l*m)+ea(ea(n*o)+ea(-1.0)));n=ea(g[b+8>>2]);l=ea(n*o);q=ea(g[b+4>>2]);r=ea(l+ea(m*q));l=ea(ea(m*n)-ea(o*q));q=ea(g[a+8>>2]);o=ea(q*p);p=ea(q*r);r=ea(q*l);l=ea(g[b+16>>2]);q=ea(l+o);n=ea(g[b+20>>2]);m=ea(n+p);s=ea(g[b+24>>2]);t=ea(r+s);g[j>>2]=q;g[j+4>>2]=m;g[j+8>>2]=t;u=ea(l-o);o=ea(n-p);p=ea(s-r);g[j+12>>2]=u;g[j+16>>2]=o;g[j+20>>2]=p;r=ea(g[d>>2]);s=ea(r*ea(2.0));n=ea(g[d+12>>2]);l=ea(n*ea(2.0));v=ea(ea(r*s)+ea(ea(n*l)+ea(-1.0)));n=ea(g[d+8>>2]);r=ea(n*l);w=ea(g[d+4>>2]);x=ea(r+ea(s*w));r=ea(ea(s*n)-ea(l*w));w=ea(g[c+8>>2]);l=ea(w*v);v=ea(w*x);x=ea(w*r);r=ea(g[d+16>>2]);w=ea(r+l);n=ea(g[d+20>>2]);s=ea(n+v);y=ea(g[d+24>>2]);z=ea(x+y);g[k>>2]=w;g[k+4>>2]=s;g[k+8>>2]=z;A=ea(r-l);l=ea(n-v);v=ea(y-x);g[k+12>>2]=A;g[k+16>>2]=l;g[k+20>>2]=v;x=ea(o-m);m=ea(p-t);g[f>>2]=ea(u-q);g[f+4>>2]=x;g[f+8>>2]=m;m=ea(l-s);s=ea(v-z);g[h>>2]=ea(A-w);g[h+4>>2]=m;g[h+8>>2]=s;s=ea(MOa(j,f,k,h,0,0));m=ea(g[a+4>>2]);w=ea(m+ea(g[c+4>>2]));c=s<=ea(w*w);i=e;return c|0}function Gwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0;e=i;i=i+128|0;f=e+96|0;h=e+32|0;j=e+16|0;k=e;l=ea(g[b>>2]);m=ea(l*ea(2.0));n=ea(g[b+12>>2]);o=ea(n*ea(2.0));p=ea(ea(l*m)+ea(ea(n*o)+ea(-1.0)));n=ea(g[b+8>>2]);l=ea(n*o);q=ea(g[b+4>>2]);r=ea(l+ea(m*q));l=ea(ea(m*n)-ea(o*q));q=ea(g[a+8>>2]);o=ea(q*p);p=ea(q*r);r=ea(q*l);l=ea(g[b+16>>2]);q=ea(l+o);n=ea(g[b+20>>2]);m=ea(n+p);s=ea(g[b+24>>2]);t=ea(r+s);g[f>>2]=q;g[f+4>>2]=m;g[f+8>>2]=t;u=ea(l-o);o=ea(n-p);p=ea(s-r);g[f+12>>2]=u;g[f+16>>2]=o;g[f+20>>2]=p;b=d+16|0;v=c+4|0;g[h+36>>2]=ea(g[b>>2]);g[h+40>>2]=ea(g[d+20>>2]);g[h+44>>2]=ea(g[d+24>>2]);g[h+48>>2]=ea(g[v>>2]);g[h+52>>2]=ea(g[c+8>>2]);g[h+56>>2]=ea(g[c+12>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);n=ea(g[d+8>>2]);l=ea(g[d+12>>2]);w=ea(r+r);x=ea(s+s);y=ea(n+n);z=ea(s*x);A=ea(n*y);B=ea(w*s);s=ea(w*n);C=ea(w*l);D=ea(x*n);n=ea(x*l);x=ea(y*l);l=ea(B+x);y=ea(s-n);E=ea(B-x);x=ea(ea(1.0)-ea(r*w));w=ea(x-A);r=ea(D+C);B=ea(s+n);n=ea(D-C);C=ea(x-z);g[h>>2]=ea(ea(ea(1.0)-z)-A);g[h+4>>2]=l;g[h+8>>2]=y;g[h+12>>2]=E;g[h+16>>2]=w;g[h+20>>2]=r;g[h+24>>2]=B;g[h+28>>2]=n;g[h+32>>2]=C;d=a+4|0;C=ea(g[d>>2]);g[j>>2]=q;g[j+4>>2]=m;g[j+8>>2]=t;g[j+12>>2]=C;if(qMa(j,h)|0){F=1;i=e;return F|0}g[k>>2]=u;g[k+4>>2]=o;g[k+8>>2]=p;g[k+12>>2]=C;if(qMa(k,h)|0){F=1;i=e;return F|0}C=ea(LOa(f,f+12|0,b,v,h,0,0));p=ea(g[d>>2]);F=C<=ea(p*p);i=e;return F|0}function Hwb(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im;j=i;k=c[e+32>>2]|0;l=(h|0)==0;if(!l?(m=(b[h+12>>1]|0)==2?h:0,(m|0)!=0):0){n=ea(g[m>>2]);o=ea(g[m+4>>2]);p=n;q=o;r=ea(g[m+8>>2])}else{p=ea(0.0);q=ea(0.0);r=ea(1.0)}m=sMa(a,d,k,e+4|0,f,0)|0;if(!(l|m^1)){g[h>>2]=p;g[h+4>>2]=q;g[h+8>>2]=r}if(l){i=j;return m|0}l=h+12|0;if(m){b[l>>1]=2;i=j;return m|0}else{b[l>>1]=0;i=j;return m|0}return 0}function Iwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0;e=i;i=i+80|0;f=e+36|0;h=e;j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(g[b+8>>2]);m=ea(g[b+12>>2]);n=ea(j+j);o=ea(k+k);p=ea(l+l);q=ea(j*n);j=ea(k*o);r=ea(l*p);s=ea(n*k);k=ea(n*l);t=ea(n*m);n=ea(o*l);l=ea(o*m);o=ea(p*m);m=ea(s+o);p=ea(k-l);g[f>>2]=ea(ea(ea(1.0)-j)-r);g[f+4>>2]=m;g[f+8>>2]=p;p=ea(ea(1.0)-q);q=ea(p-r);r=ea(n+t);g[f+12>>2]=ea(s-o);g[f+16>>2]=q;g[f+20>>2]=r;r=ea(n-t);t=ea(p-j);g[f+24>>2]=ea(k+l);g[f+28>>2]=r;g[f+32>>2]=t;t=ea(g[d>>2]);r=ea(g[d+4>>2]);l=ea(g[d+8>>2]);k=ea(g[d+12>>2]);j=ea(t+t);p=ea(r+r);n=ea(l+l);q=ea(t*j);t=ea(r*p);o=ea(l*n);s=ea(j*r);r=ea(j*l);m=ea(j*k);j=ea(p*l);l=ea(p*k);p=ea(n*k);k=ea(s+p);n=ea(r-l);g[h>>2]=ea(ea(ea(1.0)-t)-o);g[h+4>>2]=k;g[h+8>>2]=n;n=ea(ea(1.0)-q);q=ea(n-o);o=ea(j+m);g[h+12>>2]=ea(s-p);g[h+16>>2]=q;g[h+20>>2]=o;o=ea(j-m);m=ea(n-t);g[h+24>>2]=ea(r+l);g[h+28>>2]=o;g[h+32>>2]=m;u=NPa(a+4|0,b+16|0,f,c+4|0,d+16|0,h,1)|0;i=e;return u|0}function Jwb(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im;j=i;k=c[e+32>>2]|0;l=(h|0)==0;if(!l?(m=(b[h+12>>1]|0)==2?h:0,(m|0)!=0):0){n=ea(g[m>>2]);o=ea(g[m+4>>2]);p=n;q=o;r=ea(g[m+8>>2])}else{p=ea(0.0);q=ea(0.0);r=ea(1.0)}m=tMa(a,d,k,e+4|0,f,0)|0;if(!(l|m^1)){g[h>>2]=p;g[h+4>>2]=q;g[h+8>>2]=r}if(l){i=j;return m|0}l=h+12|0;if(m){b[l>>1]=2;i=j;return m|0}else{b[l>>1]=0;i=j;return m|0}return 0}function Kwb(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im;j=i;i=i+640|0;k=j+416|0;l=j+336|0;m=j+272|0;n=j+256|0;o=j+320|0;p=j+352|0;q=j+432|0;r=j+32|0;s=j+16|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;t=c[a+32>>2]|0;u=c[e+32>>2]|0;v=ea(g[a+4>>2]);w=ea(g[a+8>>2]);x=ea(g[a+12>>2]);g[l>>2]=v;y=l+4|0;g[y>>2]=w;z=l+8|0;g[z>>2]=x;g[l+12>>2]=ea(0.0);x=ea(g[a+16>>2]);w=ea(g[a+20>>2]);v=ea(g[a+24>>2]);A=ea(g[a+28>>2]);g[m>>2]=x;g[m+4>>2]=w;g[m+8>>2]=v;g[m+12>>2]=A;A=ea(g[e+4>>2]);v=ea(g[e+8>>2]);w=ea(g[e+12>>2]);g[n>>2]=A;a=n+4|0;g[a>>2]=v;B=n+8|0;g[B>>2]=w;g[n+12>>2]=ea(0.0);w=ea(g[e+16>>2]);v=ea(g[e+20>>2]);A=ea(g[e+24>>2]);x=ea(g[e+28>>2]);g[o>>2]=w;g[o+4>>2]=v;g[o+8>>2]=A;g[o+12>>2]=x;x=ea(g[d>>2]);A=ea(g[d+4>>2]);v=ea(g[d+8>>2]);w=ea(g[d+12>>2]);e=d+16|0;C=ea(g[e>>2]);D=ea(g[e+4>>2]);E=ea(g[e+8>>2]);F=ea(g[f>>2]);G=ea(g[f+4>>2]);H=ea(g[f+8>>2]);I=ea(g[f+12>>2]);e=f+16|0;J=ea(g[e>>2]);K=ea(g[e+4>>2]);L=ea(-F);F=ea(-G);G=ea(-H);H=ea(C-J);J=ea(D-K);K=ea(E-ea(g[e+8>>2]));E=ea(ea(I*I)+ea(-.5));D=ea(ea(ea(H*L)+ea(J*F))+ea(K*G));C=ea(ea(ea(D*F)+ea(ea(E*J)+ea(I*ea(ea(H*G)-ea(K*L)))))*ea(2.0));M=ea(ea(ea(ea(E*K)+ea(I*ea(ea(J*L)-ea(H*F))))+ea(D*G))*ea(2.0));N=ea(ea(w*I)-ea(ea(ea(x*L)+ea(A*F))+ea(v*G)));O=ea(ea(ea(v*F)-ea(A*G))+ea(ea(w*L)+ea(x*I)));P=ea(ea(ea(x*G)-ea(v*L))+ea(ea(w*F)+ea(A*I)));Q=ea(ea(ea(A*L)-ea(x*F))+ea(ea(v*I)+ea(w*G)));g[p+48>>2]=ea(ea(ea(D*L)+ea(ea(E*H)+ea(I*ea(ea(K*F)-ea(J*G)))))*ea(2.0));g[p+52>>2]=C;g[p+56>>2]=M;g[p+60>>2]=ea(0.0);M=ea(O+O);C=ea(P+P);G=ea(Q+Q);J=ea(P*C);F=ea(Q*G);K=ea(P*M);P=ea(Q*M);I=ea(N*M);H=ea(Q*C);Q=ea(N*C);C=ea(N*G);G=ea(ea(1.0)-ea(O*M));M=ea(K+C);O=ea(P-Q);N=ea(K-C);C=ea(G-F);K=ea(H+I);E=ea(P+Q);Q=ea(H-I);I=ea(G-J);g[p>>2]=ea(ea(ea(1.0)-J)-F);g[p+4>>2]=M;g[p+8>>2]=O;g[p+12>>2]=ea(0.0);g[p+16>>2]=N;g[p+20>>2]=C;g[p+24>>2]=K;g[p+28>>2]=ea(0.0);g[p+32>>2]=E;g[p+36>>2]=Q;g[p+40>>2]=I;g[p+44>>2]=ea(0.0);z1a(q,t+16|0,k,l,m);z1a(r,u+16|0,k,n,o);I=ea(g[t+68>>2]);Q=ea(g[t+72>>2]);E=ea(g[t+76>>2]);K=ea(g[l>>2]);C=ea(g[y>>2]);N=ea(I*K);K=ea(Q*C);C=ea(E*ea(g[z>>2]));E=!(N<=K)?K:N;N=ea((!(E<=C)?C:E)*ea(.00999999977));E=ea(g[u+68>>2]);C=ea(g[u+72>>2]);K=ea(g[u+76>>2]);Q=ea(g[n>>2]);I=ea(g[a>>2]);O=ea(E*Q);Q=ea(C*I);I=ea(K*ea(g[B>>2]));K=!(O<=Q)?Q:O;O=ea(N+ea((!(K<=I)?I:K)*ea(.00999999977)));g[s>>2]=ea(O*O);B=(zPa(q,r,p,s,j+288|0,j+240|0,j+304|0,j)|0)==1;if(!h){i=j;return B|0}s=h+12|0;if(B){b[s>>1]=2;i=j;return B|0}else{b[s>>1]=0;i=j;return B|0}return 0}function Lwb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Mwb(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0;l=i;i=i+64|0;k=l;m=e+44|0;n=ea(g[m>>2]);o=ea(g[e+48>>2]);p=ea(ea(ea(1.0)-n)-o);q=ea(g[f>>2]);r=f+4|0;s=ea(g[r>>2]);t=f+8|0;u=ea(p*q);q=ea(p*s);s=ea(p*ea(g[t>>2]));p=ea(g[h>>2]);v=h+4|0;w=ea(g[v>>2]);x=h+8|0;y=ea(u+ea(n*p));p=ea(q+ea(n*w));w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[j>>2]);z=j+4|0;s=ea(g[z>>2]);A=j+8|0;q=ea(y+ea(o*n));n=ea(p+ea(o*s));s=ea(w+ea(o*ea(g[A>>2])));c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];B=k+12|0;b[B>>1]=b[e+12>>1]|0;C=k+16|0;g[C>>2]=ea(g[e+16>>2]);D=k+20|0;g[D>>2]=ea(g[e+20>>2]);E=k+24|0;g[E>>2]=ea(g[e+24>>2]);F=k+28|0;g[F>>2]=ea(g[e+28>>2]);G=k+32|0;g[G>>2]=ea(g[e+32>>2]);H=k+36|0;g[H>>2]=ea(g[e+36>>2]);I=k+40|0;g[I>>2]=ea(g[e+40>>2]);e=k+44|0;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];m=d+24|0;J=c[m>>2]|0;K=c[d+20>>2]|0;o=ea(q*ea(2.0));q=ea(n*ea(2.0));n=ea(s*ea(2.0));s=ea(g[K+24>>2]);w=ea(ea(s*s)+ea(-.5));p=ea(g[K+12>>2]);y=ea(o*p);u=ea(g[K+16>>2]);L=ea(y+ea(q*u));y=ea(g[K+20>>2]);M=ea(L+ea(n*y));L=ea(ea(p*M)+ea(ea(o*w)+ea(s*ea(ea(n*u)-ea(q*y)))));N=ea(ea(u*M)+ea(ea(q*w)+ea(s*ea(ea(o*y)-ea(n*p)))));O=ea(ea(ea(n*w)+ea(s*ea(ea(q*p)-ea(o*u))))+ea(y*M));M=ea(ea(g[K>>2])*L);L=ea(ea(g[K+4>>2])*N);N=ea(M*ea(2.0));M=ea(L*ea(2.0));L=ea(ea(ea(g[K+8>>2])*O)*ea(2.0));O=ea(ea(y*L)+ea(ea(p*N)+ea(u*M)));o=ea(ea(ea(p*O)+ea(ea(w*N)-ea(s*ea(ea(u*L)-ea(y*M)))))*ea(2.0));q=ea(ea(ea(u*O)+ea(ea(w*M)-ea(s*ea(ea(y*N)-ea(p*L)))))*ea(2.0));n=ea(ea(ea(ea(w*L)-ea(s*ea(ea(p*M)-ea(u*N))))+ea(y*O))*ea(2.0));O=ea(g[J+12>>2]);y=ea(ea(O*O)+ea(-.5));N=ea(g[J>>2]);u=ea(N*o);M=ea(g[J+4>>2]);p=ea(u+ea(M*q));u=ea(g[J+8>>2]);s=ea(ea(u*n)+p);p=ea(ea(N*s)+ea(ea(y*o)+ea(O*ea(ea(M*n)-ea(u*q)))));L=ea(ea(M*s)+ea(ea(y*q)+ea(O*ea(ea(u*o)-ea(N*n)))));w=ea(ea(ea(y*n)+ea(O*ea(ea(N*q)-ea(M*o))))+ea(u*s));s=ea(ea(g[J+16>>2])+p);p=ea(ea(g[J+20>>2])+L);L=ea(ea(g[J+24>>2])+w);g[C>>2]=s;g[D>>2]=p;g[E>>2]=L;b[B>>1]=13;g[F>>2]=ea(0.0);g[G>>2]=ea(0.0);g[H>>2]=ea(0.0);if(c[d+32>>2]&2){L=ea(g[h>>2]);p=ea(g[f>>2]);s=ea(L-p);L=ea(g[v>>2]);w=ea(g[r>>2]);u=ea(L-w);L=ea(g[x>>2]);o=ea(g[t>>2]);M=ea(L-o);L=ea(ea(g[j>>2])-p);p=ea(ea(g[z>>2])-w);w=ea(ea(g[A>>2])-o);o=ea(ea(u*w)-ea(M*p));q=ea(ea(M*L)-ea(s*w));w=ea(ea(s*p)-ea(u*L));A=c[d+28>>2]|0;if(!A){z=c[m>>2]|0;L=ea(o*ea(2.0));u=ea(q*ea(2.0));p=ea(w*ea(2.0));s=ea(g[z+12>>2]);M=ea(ea(s*s)+ea(-.5));N=ea(g[z>>2]);O=ea(L*N);n=ea(g[z+4>>2]);y=ea(O+ea(u*n));O=ea(g[z+8>>2]);P=ea(y+ea(p*O));y=ea(ea(N*P)+ea(ea(L*M)+ea(s*ea(ea(p*n)-ea(u*O)))));Q=ea(ea(n*P)+ea(ea(u*M)+ea(s*ea(ea(L*O)-ea(p*N)))));R=ea(ea(ea(p*M)+ea(s*ea(ea(u*N)-ea(L*n))))+ea(O*P));g[F>>2]=y;g[G>>2]=Q;g[H>>2]=R;U=y;V=Q;W=R}else{R=ea(o*ea(g[A>>2]));Q=ea(R+ea(q*ea(g[A+4>>2])));R=ea(Q+ea(w*ea(g[A+8>>2])));Q=ea(o*ea(g[A+12>>2]));y=ea(Q+ea(q*ea(g[A+16>>2])));Q=ea(y+ea(w*ea(g[A+20>>2])));y=ea(o*ea(g[A+24>>2]));o=ea(y+ea(q*ea(g[A+28>>2])));q=ea(o+ea(w*ea(g[A+32>>2])));g[F>>2]=R;g[G>>2]=Q;U=R;V=Q;W=q}g[H>>2]=W;q=ea(T(ea(ea(W*W)+ea(ea(U*U)+ea(V*V)))));if(q>ea(0.0)){Q=ea(ea(1.0)/q);q=ea(U*Q);g[F>>2]=q;R=ea(V*Q);g[G>>2]=R;w=ea(W*Q);g[H>>2]=w;X=q;Y=R;Z=w}else{X=U;Y=V;Z=W}if((a[d+48>>0]|0)!=0?(A=c[d+44>>2]|0,W=ea(X*ea(g[A>>2])),V=ea(W+ea(Y*ea(g[A+4>>2]))),ea(V+ea(Z*ea(g[A+8>>2])))>ea(0.0)):0){V=ea(-Y);Y=ea(-Z);g[F>>2]=ea(-X);g[G>>2]=V;g[H>>2]=Y}b[B>>1]=15}A=c[d+36>>2]|0;if(A){_=_n[A&4095](k,c[d+40>>2]|0)|0;i=l;return _|0}A=d+12|0;z=c[A>>2]|0;if((z|0)==(c[d+16>>2]|0)){a[d+49>>0]=1;_=0;i=l;return _|0}m=c[d+8>>2]|0;a:do if(!z)$=0;else{Y=ea(g[I>>2]);d=0;while(1){if(+ea(S(ea(ea(g[m+(d<<6)+40>>2])-Y)))<.0001){_=1;break}d=d+1|0;if(d>>>0>=z>>>0){$=z;break a}}i=l;return _|0}while(0);c[A>>2]=$+1;A=m+($<<6)|0;c[A+0>>2]=c[k+0>>2];c[A+4>>2]=c[k+4>>2];c[A+8>>2]=c[k+8>>2];b[m+($<<6)+12>>1]=b[B>>1]|0;g[m+($<<6)+16>>2]=ea(g[C>>2]);g[m+($<<6)+20>>2]=ea(g[D>>2]);g[m+($<<6)+24>>2]=ea(g[E>>2]);g[m+($<<6)+28>>2]=ea(g[F>>2]);g[m+($<<6)+32>>2]=ea(g[G>>2]);g[m+($<<6)+36>>2]=ea(g[H>>2]);g[m+($<<6)+40>>2]=ea(g[I>>2]);I=m+($<<6)+44|0;c[I+0>>2]=c[e+0>>2];c[I+4>>2]=c[e+4>>2];c[I+8>>2]=c[e+8>>2];c[I+12>>2]=c[e+12>>2];c[I+16>>2]=c[e+16>>2];_=1;i=l;return _|0}function Nwb(a){a=a|0;return}function Owb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Pwb(a){a=a|0;return}function Qwb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Rwb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!b){i=e;return 1}f=a+4|0;a=0;do{g=c[d+(a<<2)>>2]|0;h=c[f>>2]|0;j=h+4|0;k=c[j>>2]|0;if((k|0)==(c[h>>2]|0)){gLa(h,1)|0;l=c[j>>2]|0}else l=k;c[j>>2]=l+1;c[(c[h+8>>2]|0)+(l<<2)>>2]=g;a=a+1|0}while((a|0)!=(b|0));i=e;return 1}function Swb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;g=c[a+8>>2]|0;a=c[b+8>>2]|0;b=g+4|0;f=c[b>>2]|0;if((f|0)==(c[g>>2]|0)){gLa(g,1)|0;j=c[b>>2]|0}else j=f;c[b>>2]=j+1;c[(c[g+8>>2]|0)+(j<<2)>>2]=a;i=h;return 1}function Twb(a){a=a|0;return}function Uwb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Vwb(a){a=a|0;return}function Wwb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Xwb(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0;h=i;i=i+960|0;j=h+96|0;k=h+84|0;l=h+48|0;m=h+36|0;n=h;o=j+848|0;c[o>>2]=0;p=(e+15|0)>>>4;if(!p){i=h;return 1}q=b+4|0;r=b+28|0;s=b+8|0;b=l+12|0;t=l+16|0;u=l+4|0;v=l+20|0;w=l+8|0;x=l+24|0;y=l+28|0;z=l+32|0;A=n+12|0;B=n+16|0;C=n+4|0;D=n+20|0;E=n+8|0;F=n+24|0;G=n+28|0;H=n+32|0;I=k+4|0;J=k+8|0;K=0;L=f;f=e;while(1){c[o>>2]=0;e=f>>>0<16?f:16;if(!e)M=L;else{N=f>>>0<16;O=e;P=L;do{O=O+-1|0;Q=c[P>>2]|0;P=P+4|0;LRa(c[r>>2]|0,c[s>>2]|0,l,k,m,Q,0,0)|0;R=ea(g[b>>2]);S=ea(g[l>>2]);U=ea(R-S);R=ea(g[t>>2]);V=ea(g[u>>2]);W=ea(R-V);R=ea(g[v>>2]);X=ea(g[w>>2]);Y=ea(R-X);R=ea(ea(g[x>>2])-S);S=ea(ea(g[y>>2])-V);V=ea(ea(g[z>>2])-X);X=ea(ea(W*V)-ea(Y*S));Z=ea(ea(Y*R)-ea(U*V));V=ea(ea(U*S)-ea(W*R));R=ea(T(ea(ea(V*V)+ea(ea(X*X)+ea(Z*Z)))));if(R>ea(0.0)){W=ea(ea(1.0)/R);_=ea(X*W);$=ea(Z*W);aa=ea(V*W)}else{_=X;$=Z;aa=V}ba=0;ca=0;while(1){da=c[m+(ba<<2)>>2]|0;if((da|0)!=-1){LRa(c[r>>2]|0,c[s>>2]|0,n,0,0,da,0,0)|0;V=ea(g[A>>2]);Z=ea(g[n>>2]);X=ea(V-Z);V=ea(g[B>>2]);W=ea(g[C>>2]);R=ea(V-W);V=ea(g[D>>2]);S=ea(g[E>>2]);U=ea(V-S);V=ea(ea(g[F>>2])-Z);Y=ea(ea(g[G>>2])-W);fa=ea(ea(g[H>>2])-S);ga=ea(ea(R*fa)-ea(U*Y));ha=ea(ea(U*V)-ea(X*fa));fa=ea(ea(X*Y)-ea(R*V));da=d[539600+ba>>0]|0;V=ea(ea(g[l+(da*12|0)>>2])-Z);Z=ea(ea(g[l+(da*12|0)+4>>2])-W);if(ea(ea(ea(ga*V)+ea(ha*Z))+ea(fa*ea(ea(g[l+(da*12|0)+8>>2])-S)))<ea(0.0)){S=ea(T(ea(ea(fa*fa)+ea(ea(ga*ga)+ea(ha*ha)))));if(S>ea(0.0)){Z=ea(ea(1.0)/S);ia=ea(ga*Z);ja=ea(ha*Z);ka=ea(fa*Z)}else{ia=ga;ja=ha;ka=fa}if(ea(ea(aa*ka)+ea(ea($*ja)+ea(_*ia)))<ea(.999000012))la=(1<<ba+3|ca&255)&255;else la=ca}else la=ca}else la=(1<<ba+3|ca&255)&255;ba=ba+1|0;if((ba|0)==3)break;else ca=la}ca=c[o>>2]|0;c[o>>2]=ca+1;ba=ca*3|0;g[j+(ba*12|0)>>2]=ea(g[l>>2]);g[j+(ba*12|0)+4>>2]=ea(g[u>>2]);g[j+(ba*12|0)+8>>2]=ea(g[w>>2]);da=ba+1|0;g[j+(da*12|0)>>2]=ea(g[b>>2]);g[j+(da*12|0)+4>>2]=ea(g[t>>2]);g[j+(da*12|0)+8>>2]=ea(g[v>>2]);ma=ba+2|0;g[j+(ma*12|0)>>2]=ea(g[x>>2]);g[j+(ma*12|0)+4>>2]=ea(g[y>>2]);g[j+(ma*12|0)+8>>2]=ea(g[z>>2]);c[j+(ba<<2)+576>>2]=c[k>>2];c[j+(da<<2)+576>>2]=c[I>>2];c[j+(ma<<2)+576>>2]=c[J>>2];c[j+(ca<<2)+768>>2]=Q;a[j+ca+832>>0]=la}while((O|0)!=0);M=L+((N?f:16)<<2)|0}f=f-e|0;y6a(q,j)|0;K=K+1|0;if(K>>>0>=p>>>0)break;else L=M}i=h;return 1}function Ywb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;j=i;i=i+48|0;l=j;if(!(a[b+40>>0]|0)){m=c[b+36>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[m>>2]));p=m+4|0;q=ea(n*ea(g[p>>2]));r=m+8|0;s=ea(n*ea(g[r>>2]));n=ea(g[e+4>>2]);t=m+12|0;u=ea(n*ea(g[t>>2]));v=m+16|0;w=ea(n*ea(g[v>>2]));x=m+20|0;y=ea(o+u);u=ea(q+w);w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[e+8>>2]);z=m+24|0;s=ea(n*ea(g[z>>2]));A=m+28|0;q=ea(n*ea(g[A>>2]));B=m+32|0;o=ea(y+s);s=ea(u+q);q=ea(w+ea(n*ea(g[B>>2])));g[l>>2]=o;g[l+4>>2]=s;g[l+8>>2]=q;n=ea(g[f>>2]);w=ea(n*ea(g[m>>2]));u=ea(n*ea(g[p>>2]));y=ea(n*ea(g[r>>2]));n=ea(g[f+4>>2]);C=ea(n*ea(g[t>>2]));D=ea(n*ea(g[v>>2]));E=ea(w+C);C=ea(u+D);D=ea(y+ea(n*ea(g[x>>2])));n=ea(g[f+8>>2]);y=ea(n*ea(g[z>>2]));u=ea(n*ea(g[A>>2]));w=ea(E+y);y=ea(C+u);u=ea(D+ea(n*ea(g[B>>2])));g[l+12>>2]=w;g[l+16>>2]=y;g[l+20>>2]=u;n=ea(g[h>>2]);D=ea(n*ea(g[m>>2]));C=ea(n*ea(g[p>>2]));E=ea(n*ea(g[r>>2]));n=ea(g[h+4>>2]);F=ea(n*ea(g[t>>2]));G=ea(n*ea(g[v>>2]));H=ea(D+F);F=ea(C+G);G=ea(E+ea(n*ea(g[x>>2])));n=ea(g[h+8>>2]);E=ea(n*ea(g[z>>2]));C=ea(n*ea(g[A>>2]));D=ea(H+E);E=ea(F+C);C=ea(G+ea(n*ea(g[B>>2])));g[l+24>>2]=D;g[l+28>>2]=E;g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}else{o=ea(g[e>>2]);g[l>>2]=o;s=ea(g[e+4>>2]);g[l+4>>2]=s;q=ea(g[e+8>>2]);g[l+8>>2]=q;w=ea(g[f>>2]);g[l+12>>2]=w;y=ea(g[f+4>>2]);g[l+16>>2]=y;u=ea(g[f+8>>2]);g[l+20>>2]=u;D=ea(g[h>>2]);g[l+24>>2]=D;E=ea(g[h+4>>2]);g[l+28>>2]=E;C=ea(g[h+8>>2]);g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}h=c[d+8>>2]|0;d=c[(c[b+896>>2]|0)+152>>2]|0;if(!d)R=56;else R=a[d+h>>0]|0;d=b+892|0;f=c[d>>2]|0;if((f|0)!=16){S=f;T=Q;U=P;V=O;W=N;X=M;Y=L;Z=K;_=J;$=I;aa=S+1|0;c[d>>2]=aa;ba=S*3|0;ca=b+(ba*12|0)+44|0;g[ca>>2]=T;da=b+(ba*12|0)+48|0;g[da>>2]=U;fa=b+(ba*12|0)+52|0;g[fa>>2]=V;ga=ba+1|0;ha=b+(ga*12|0)+44|0;g[ha>>2]=W;ia=b+(ga*12|0)+48|0;g[ia>>2]=X;ja=b+(ga*12|0)+52|0;g[ja>>2]=Y;ka=ba+2|0;la=b+(ka*12|0)+44|0;g[la>>2]=Z;ma=b+(ka*12|0)+48|0;g[ma>>2]=_;na=b+(ka*12|0)+52|0;g[na>>2]=$;oa=c[k>>2]|0;pa=b+(ba<<2)+620|0;c[pa>>2]=oa;qa=k+4|0;ra=c[qa>>2]|0;sa=b+(ga<<2)+620|0;c[sa>>2]=ra;ta=k+8|0;ua=c[ta>>2]|0;va=b+(ka<<2)+620|0;c[va>>2]=ua;wa=b+(S<<2)+812|0;c[wa>>2]=h;xa=b+S+876|0;a[xa>>0]=R;i=j;return 1}y6a(b+8|0,b+44|0)|0;c[d>>2]=0;I=ea(g[l>>2]);J=ea(g[l+4>>2]);K=ea(g[l+8>>2]);L=ea(g[l+12>>2]);M=ea(g[l+16>>2]);N=ea(g[l+20>>2]);O=ea(g[l+24>>2]);P=ea(g[l+28>>2]);S=0;T=I;U=J;V=K;W=L;X=M;Y=N;Z=O;_=P;$=ea(g[l+32>>2]);aa=S+1|0;c[d>>2]=aa;ba=S*3|0;ca=b+(ba*12|0)+44|0;g[ca>>2]=T;da=b+(ba*12|0)+48|0;g[da>>2]=U;fa=b+(ba*12|0)+52|0;g[fa>>2]=V;ga=ba+1|0;ha=b+(ga*12|0)+44|0;g[ha>>2]=W;ia=b+(ga*12|0)+48|0;g[ia>>2]=X;ja=b+(ga*12|0)+52|0;g[ja>>2]=Y;ka=ba+2|0;la=b+(ka*12|0)+44|0;g[la>>2]=Z;ma=b+(ka*12|0)+48|0;g[ma>>2]=_;na=b+(ka*12|0)+52|0;g[na>>2]=$;oa=c[k>>2]|0;pa=b+(ba<<2)+620|0;c[pa>>2]=oa;qa=k+4|0;ra=c[qa>>2]|0;sa=b+(ga<<2)+620|0;c[sa>>2]=ra;ta=k+8|0;ua=c[ta>>2]|0;va=b+(ka<<2)+620|0;c[va>>2]=ua;wa=b+(S<<2)+812|0;c[wa>>2]=h;xa=b+S+876|0;a[xa>>0]=R;i=j;return 1}function Zwb(a){a=a|0;return}function _wb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function $wb(a){a=a|0;return}function axb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bxb(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0;h=i;i=i+960|0;j=h+96|0;k=h+84|0;l=h+48|0;m=h+36|0;n=h;o=j+848|0;c[o>>2]=0;p=(e+15|0)>>>4;if(!p){i=h;return 1}q=b+4|0;r=j+832|0;s=j+768|0;t=j+576|0;u=b+2228|0;v=b+2216|0;b=l+12|0;w=l+16|0;x=l+4|0;y=l+20|0;z=l+8|0;A=l+24|0;B=l+28|0;C=l+32|0;D=n+12|0;E=n+16|0;F=n+4|0;G=n+20|0;H=n+8|0;I=n+24|0;J=n+28|0;K=n+32|0;L=k+4|0;M=k+8|0;N=0;O=f;f=e;while(1){c[o>>2]=0;e=f>>>0<16?f:16;a:do if(e){P=f>>>0<16;Q=e;R=O;do{Q=Q+-1|0;S=c[R>>2]|0;R=R+4|0;LRa(c[u>>2]|0,c[v>>2]|0,l,k,m,S,0,0)|0;U=ea(g[b>>2]);V=ea(g[l>>2]);W=ea(U-V);U=ea(g[w>>2]);X=ea(g[x>>2]);Y=ea(U-X);U=ea(g[y>>2]);Z=ea(g[z>>2]);_=ea(U-Z);U=ea(ea(g[A>>2])-V);V=ea(ea(g[B>>2])-X);X=ea(ea(g[C>>2])-Z);Z=ea(ea(Y*X)-ea(_*V));$=ea(ea(_*U)-ea(W*X));X=ea(ea(W*V)-ea(Y*U));U=ea(T(ea(ea(X*X)+ea(ea(Z*Z)+ea($*$)))));if(U>ea(0.0)){Y=ea(ea(1.0)/U);aa=ea(Z*Y);ba=ea($*Y);ca=ea(X*Y)}else{aa=Z;ba=$;ca=X}da=0;fa=0;while(1){ga=c[m+(da<<2)>>2]|0;if((ga|0)!=-1){LRa(c[u>>2]|0,c[v>>2]|0,n,0,0,ga,0,0)|0;X=ea(g[D>>2]);$=ea(g[n>>2]);Z=ea(X-$);X=ea(g[E>>2]);Y=ea(g[F>>2]);U=ea(X-Y);X=ea(g[G>>2]);V=ea(g[H>>2]);W=ea(X-V);X=ea(ea(g[I>>2])-$);_=ea(ea(g[J>>2])-Y);ha=ea(ea(g[K>>2])-V);ia=ea(ea(U*ha)-ea(W*_));ja=ea(ea(W*X)-ea(Z*ha));ha=ea(ea(Z*_)-ea(U*X));ga=d[539600+da>>0]|0;X=ea(ea(g[l+(ga*12|0)>>2])-$);$=ea(ea(g[l+(ga*12|0)+4>>2])-Y);if(ea(ea(ea(ia*X)+ea(ja*$))+ea(ha*ea(ea(g[l+(ga*12|0)+8>>2])-V)))<ea(0.0)){V=ea(T(ea(ea(ha*ha)+ea(ea(ia*ia)+ea(ja*ja)))));if(V>ea(0.0)){$=ea(ea(1.0)/V);ka=ea(ia*$);la=ea(ja*$);ma=ea(ha*$)}else{ka=ia;la=ja;ma=ha}if(ea(ea(ca*ma)+ea(ea(ba*la)+ea(aa*ka)))<ea(.999000012))na=(1<<da+3|fa&255)&255;else na=fa}else na=fa}else na=(1<<da+3|fa&255)&255;da=da+1|0;if((da|0)==3)break;else fa=na}fa=c[o>>2]|0;c[o>>2]=fa+1;da=fa*3|0;g[j+(da*12|0)>>2]=ea(g[l>>2]);g[j+(da*12|0)+4>>2]=ea(g[x>>2]);g[j+(da*12|0)+8>>2]=ea(g[z>>2]);ga=da+1|0;g[j+(ga*12|0)>>2]=ea(g[b>>2]);g[j+(ga*12|0)+4>>2]=ea(g[w>>2]);g[j+(ga*12|0)+8>>2]=ea(g[y>>2]);oa=da+2|0;g[j+(oa*12|0)>>2]=ea(g[A>>2]);g[j+(oa*12|0)+4>>2]=ea(g[B>>2]);g[j+(oa*12|0)+8>>2]=ea(g[C>>2]);c[j+(da<<2)+576>>2]=c[k>>2];c[j+(ga<<2)+576>>2]=c[L>>2];c[j+(oa<<2)+576>>2]=c[M>>2];c[j+(fa<<2)+768>>2]=S;a[j+fa+832>>0]=na}while((Q|0)!=0);Q=O+((P?f:16)<<2)|0;R=c[o>>2]|0;if(!R)pa=Q;else{fa=R;R=r;oa=s;ga=t;da=j;while(1){qa=fa+-1|0;RNa(q,da,c[oa>>2]|0,a[R>>0]|0,ga)|0;if(!qa){pa=Q;break a}fa=qa;R=R+1|0;oa=oa+4|0;ga=ga+12|0;da=da+36|0}}}else pa=O;while(0);f=f-e|0;N=N+1|0;if(N>>>0>=p>>>0)break;else O=pa}i=h;return 1}function cxb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im;j=i;i=i+48|0;l=j;if(!(_Pa(b+3100|0,e,f,h)|0)){i=j;return 1}if(!(a[b+3092>>0]|0)){m=c[b+3084>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[m>>2]));p=m+4|0;q=ea(n*ea(g[p>>2]));r=m+8|0;s=ea(n*ea(g[r>>2]));n=ea(g[e+4>>2]);t=m+12|0;u=ea(n*ea(g[t>>2]));v=m+16|0;w=ea(n*ea(g[v>>2]));x=m+20|0;y=ea(o+u);u=ea(q+w);w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[e+8>>2]);z=m+24|0;s=ea(n*ea(g[z>>2]));A=m+28|0;q=ea(n*ea(g[A>>2]));B=m+32|0;o=ea(y+s);s=ea(u+q);q=ea(w+ea(n*ea(g[B>>2])));g[l>>2]=o;g[l+4>>2]=s;g[l+8>>2]=q;n=ea(g[f>>2]);w=ea(n*ea(g[m>>2]));u=ea(n*ea(g[p>>2]));y=ea(n*ea(g[r>>2]));n=ea(g[f+4>>2]);C=ea(n*ea(g[t>>2]));D=ea(n*ea(g[v>>2]));E=ea(w+C);C=ea(u+D);D=ea(y+ea(n*ea(g[x>>2])));n=ea(g[f+8>>2]);y=ea(n*ea(g[z>>2]));u=ea(n*ea(g[A>>2]));w=ea(E+y);y=ea(C+u);u=ea(D+ea(n*ea(g[B>>2])));g[l+12>>2]=w;g[l+16>>2]=y;g[l+20>>2]=u;n=ea(g[h>>2]);D=ea(n*ea(g[m>>2]));C=ea(n*ea(g[p>>2]));E=ea(n*ea(g[r>>2]));n=ea(g[h+4>>2]);F=ea(n*ea(g[t>>2]));G=ea(n*ea(g[v>>2]));H=ea(D+F);F=ea(C+G);G=ea(E+ea(n*ea(g[x>>2])));n=ea(g[h+8>>2]);E=ea(n*ea(g[z>>2]));C=ea(n*ea(g[A>>2]));D=ea(H+E);E=ea(F+C);C=ea(G+ea(n*ea(g[B>>2])));g[l+24>>2]=D;g[l+28>>2]=E;g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}else{o=ea(g[e>>2]);g[l>>2]=o;s=ea(g[e+4>>2]);g[l+4>>2]=s;q=ea(g[e+8>>2]);g[l+8>>2]=q;w=ea(g[f>>2]);g[l+12>>2]=w;y=ea(g[f+4>>2]);g[l+16>>2]=y;u=ea(g[f+8>>2]);g[l+20>>2]=u;D=ea(g[h>>2]);g[l+24>>2]=D;E=ea(g[h+4>>2]);g[l+28>>2]=E;C=ea(g[h+8>>2]);g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}h=c[d+8>>2]|0;d=b+856|0;f=c[d>>2]|0;if((f|0)==16){e=b+860|0;B=16;A=b+840|0;z=b+776|0;x=b+584|0;v=b+8|0;while(1){B=B+-1|0;RNa(e,v,c[z>>2]|0,a[A>>0]|0,x)|0;if(!B)break;else{A=A+1|0;z=z+4|0;x=x+12|0;v=v+36|0}}c[d>>2]=0;o=ea(g[l>>2]);s=ea(g[l+4>>2]);q=ea(g[l+8>>2]);w=ea(g[l+12>>2]);y=ea(g[l+16>>2]);u=ea(g[l+20>>2]);D=ea(g[l+24>>2]);E=ea(g[l+28>>2]);R=0;S=o;T=s;U=q;V=w;W=y;X=u;Y=D;Z=E;_=ea(g[l+32>>2])}else{R=f;S=Q;T=P;U=O;V=N;W=M;X=L;Y=K;Z=J;_=I}f=a[(c[b+3088>>2]|0)+h>>0]|0;c[d>>2]=R+1;d=R*3|0;g[b+(d*12|0)+8>>2]=S;g[b+(d*12|0)+12>>2]=T;g[b+(d*12|0)+16>>2]=U;l=d+1|0;g[b+(l*12|0)+8>>2]=V;g[b+(l*12|0)+12>>2]=W;g[b+(l*12|0)+16>>2]=X;v=d+2|0;g[b+(v*12|0)+8>>2]=Y;g[b+(v*12|0)+12>>2]=Z;g[b+(v*12|0)+16>>2]=_;c[b+(d<<2)+584>>2]=c[k>>2];c[b+(l<<2)+584>>2]=c[k+4>>2];c[b+(v<<2)+584>>2]=c[k+8>>2];c[b+(R<<2)+776>>2]=h;a[b+R+840>>0]=f;i=j;return 1}function dxb(a){a=a|0;return}function exb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function fxb(a){a=a|0;return}function gxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function hxb(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0;h=i;i=i+960|0;j=h+96|0;k=h+84|0;l=h+48|0;m=h+36|0;n=h;o=j+848|0;c[o>>2]=0;p=(e+15|0)>>>4;if(!p){i=h;return 1}q=b+4|0;r=l+12|0;s=l+16|0;t=l+4|0;u=l+20|0;v=l+8|0;w=l+24|0;x=l+28|0;y=l+32|0;z=b+5676|0;A=b+16|0;b=n+12|0;B=n+16|0;C=n+4|0;D=n+20|0;E=n+8|0;F=n+24|0;G=n+28|0;H=n+32|0;I=k+4|0;J=k+8|0;K=0;L=f;f=e;while(1){c[o>>2]=0;e=f>>>0<16?f:16;if(!e)M=L;else{N=f>>>0<16;O=e;P=L;do{O=O+-1|0;Q=c[P>>2]|0;P=P+4|0;R=ea(ea(g[r>>2])-ea(0.0));S=ea(g[s>>2]);U=ea(g[t>>2]);V=ea(S-U);S=ea(g[u>>2]);W=ea(g[v>>2]);X=ea(S-W);S=ea(ea(g[w>>2])-ea(0.0));Y=ea(ea(g[x>>2])-U);U=ea(ea(g[y>>2])-W);W=ea(ea(V*U)-ea(X*Y));Z=ea(ea(X*S)-ea(R*U));U=ea(ea(R*Y)-ea(V*S));S=ea(T(ea(ea(U*U)+ea(ea(W*W)+ea(Z*Z)))));if(S>ea(0.0)){V=ea(ea(1.0)/S);_=ea(W*V);$=ea(Z*V);aa=ea(U*V)}else{_=W;$=Z;aa=U}LRa(c[z>>2]|0,c[A>>2]|0,l,k,m,Q,0,0)|0;ba=0;ca=0;while(1){da=c[m+(ba<<2)>>2]|0;if((da|0)!=-1){LRa(c[z>>2]|0,c[A>>2]|0,n,0,0,da,0,0)|0;U=ea(g[b>>2]);Z=ea(g[n>>2]);W=ea(U-Z);U=ea(g[B>>2]);V=ea(g[C>>2]);S=ea(U-V);U=ea(g[D>>2]);Y=ea(g[E>>2]);R=ea(U-Y);U=ea(ea(g[F>>2])-Z);X=ea(ea(g[G>>2])-V);fa=ea(ea(g[H>>2])-Y);ga=ea(ea(S*fa)-ea(R*X));ha=ea(ea(R*U)-ea(W*fa));fa=ea(ea(W*X)-ea(S*U));da=d[539600+ba>>0]|0;U=ea(ea(g[l+(da*12|0)>>2])-Z);Z=ea(ea(g[l+(da*12|0)+4>>2])-V);if(ea(ea(ea(ga*U)+ea(ha*Z))+ea(fa*ea(ea(g[l+(da*12|0)+8>>2])-Y)))<ea(0.0)){Y=ea(T(ea(ea(fa*fa)+ea(ea(ga*ga)+ea(ha*ha)))));if(Y>ea(0.0)){Z=ea(ea(1.0)/Y);ia=ea(ga*Z);ja=ea(ha*Z);ka=ea(fa*Z)}else{ia=ga;ja=ha;ka=fa}if(ea(ea(aa*ka)+ea(ea($*ja)+ea(_*ia)))<ea(.999000012))la=(1<<ba+3|ca&255)&255;else la=ca}else la=ca}else la=(1<<ba+3|ca&255)&255;ba=ba+1|0;if((ba|0)==3)break;else ca=la}ca=c[o>>2]|0;c[o>>2]=ca+1;ba=ca*3|0;g[j+(ba*12|0)>>2]=ea(g[l>>2]);g[j+(ba*12|0)+4>>2]=ea(g[t>>2]);g[j+(ba*12|0)+8>>2]=ea(g[v>>2]);da=ba+1|0;g[j+(da*12|0)>>2]=ea(g[r>>2]);g[j+(da*12|0)+4>>2]=ea(g[s>>2]);g[j+(da*12|0)+8>>2]=ea(g[u>>2]);ma=ba+2|0;g[j+(ma*12|0)>>2]=ea(g[w>>2]);g[j+(ma*12|0)+4>>2]=ea(g[x>>2]);g[j+(ma*12|0)+8>>2]=ea(g[y>>2]);c[j+(ba<<2)+576>>2]=c[k>>2];c[j+(da<<2)+576>>2]=c[I>>2];c[j+(ma<<2)+576>>2]=c[J>>2];c[j+(ca<<2)+768>>2]=Q;a[j+ca+832>>0]=la}while((O|0)!=0);M=L+((N?f:16)<<2)|0}f=f-e|0;H6a(q,j);K=K+1|0;if(K>>>0>=p>>>0)break;else L=M}i=h;return 1}function ixb(a){a=a|0;return}function jxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function kxb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;j=i;i=i+48|0;l=j;if(!(a[b+5688>>0]|0)){m=c[b+5684>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[m>>2]));p=m+4|0;q=ea(n*ea(g[p>>2]));r=m+8|0;s=ea(n*ea(g[r>>2]));n=ea(g[e+4>>2]);t=m+12|0;u=ea(n*ea(g[t>>2]));v=m+16|0;w=ea(n*ea(g[v>>2]));x=m+20|0;y=ea(o+u);u=ea(q+w);w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[e+8>>2]);z=m+24|0;s=ea(n*ea(g[z>>2]));A=m+28|0;q=ea(n*ea(g[A>>2]));B=m+32|0;o=ea(y+s);s=ea(u+q);q=ea(w+ea(n*ea(g[B>>2])));g[l>>2]=o;g[l+4>>2]=s;g[l+8>>2]=q;n=ea(g[f>>2]);w=ea(n*ea(g[m>>2]));u=ea(n*ea(g[p>>2]));y=ea(n*ea(g[r>>2]));n=ea(g[f+4>>2]);C=ea(n*ea(g[t>>2]));D=ea(n*ea(g[v>>2]));E=ea(w+C);C=ea(u+D);D=ea(y+ea(n*ea(g[x>>2])));n=ea(g[f+8>>2]);y=ea(n*ea(g[z>>2]));u=ea(n*ea(g[A>>2]));w=ea(E+y);y=ea(C+u);u=ea(D+ea(n*ea(g[B>>2])));g[l+12>>2]=w;g[l+16>>2]=y;g[l+20>>2]=u;n=ea(g[h>>2]);D=ea(n*ea(g[m>>2]));C=ea(n*ea(g[p>>2]));E=ea(n*ea(g[r>>2]));n=ea(g[h+4>>2]);F=ea(n*ea(g[t>>2]));G=ea(n*ea(g[v>>2]));H=ea(D+F);F=ea(C+G);G=ea(E+ea(n*ea(g[x>>2])));n=ea(g[h+8>>2]);E=ea(n*ea(g[z>>2]));C=ea(n*ea(g[A>>2]));D=ea(H+E);E=ea(F+C);C=ea(G+ea(n*ea(g[B>>2])));g[l+24>>2]=D;g[l+28>>2]=E;g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}else{o=ea(g[e>>2]);g[l>>2]=o;s=ea(g[e+4>>2]);g[l+4>>2]=s;q=ea(g[e+8>>2]);g[l+8>>2]=q;w=ea(g[f>>2]);g[l+12>>2]=w;y=ea(g[f+4>>2]);g[l+16>>2]=y;u=ea(g[f+8>>2]);g[l+20>>2]=u;D=ea(g[h>>2]);g[l+24>>2]=D;E=ea(g[h+4>>2]);g[l+28>>2]=E;C=ea(g[h+8>>2]);g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}h=c[d+8>>2]|0;d=a[(c[(c[b+5680>>2]|0)+152>>2]|0)+h>>0]|0;f=b+6540|0;e=c[f>>2]|0;if((e|0)!=16){R=e;S=Q;T=P;U=O;V=N;W=M;X=L;Y=K;Z=J;_=I;$=R+1|0;c[f>>2]=$;aa=R*3|0;ba=b+(aa*12|0)+5692|0;g[ba>>2]=S;ca=b+(aa*12|0)+5696|0;g[ca>>2]=T;da=b+(aa*12|0)+5700|0;g[da>>2]=U;fa=aa+1|0;ga=b+(fa*12|0)+5692|0;g[ga>>2]=V;ha=b+(fa*12|0)+5696|0;g[ha>>2]=W;ia=b+(fa*12|0)+5700|0;g[ia>>2]=X;ja=aa+2|0;ka=b+(ja*12|0)+5692|0;g[ka>>2]=Y;la=b+(ja*12|0)+5696|0;g[la>>2]=Z;ma=b+(ja*12|0)+5700|0;g[ma>>2]=_;na=c[k>>2]|0;oa=b+(aa<<2)+6268|0;c[oa>>2]=na;pa=k+4|0;qa=c[pa>>2]|0;ra=b+(fa<<2)+6268|0;c[ra>>2]=qa;sa=k+8|0;ta=c[sa>>2]|0;ua=b+(ja<<2)+6268|0;c[ua>>2]=ta;va=b+(R<<2)+6460|0;c[va>>2]=h;wa=b+R+6524|0;a[wa>>0]=d;i=j;return 1}H6a(b+8|0,b+5692|0);c[f>>2]=0;I=ea(g[l>>2]);J=ea(g[l+4>>2]);K=ea(g[l+8>>2]);L=ea(g[l+12>>2]);M=ea(g[l+16>>2]);N=ea(g[l+20>>2]);O=ea(g[l+24>>2]);P=ea(g[l+28>>2]);R=0;S=I;T=J;U=K;V=L;W=M;X=N;Y=O;Z=P;_=ea(g[l+32>>2]);$=R+1|0;c[f>>2]=$;aa=R*3|0;ba=b+(aa*12|0)+5692|0;g[ba>>2]=S;ca=b+(aa*12|0)+5696|0;g[ca>>2]=T;da=b+(aa*12|0)+5700|0;g[da>>2]=U;fa=aa+1|0;ga=b+(fa*12|0)+5692|0;g[ga>>2]=V;ha=b+(fa*12|0)+5696|0;g[ha>>2]=W;ia=b+(fa*12|0)+5700|0;g[ia>>2]=X;ja=aa+2|0;ka=b+(ja*12|0)+5692|0;g[ka>>2]=Y;la=b+(ja*12|0)+5696|0;g[la>>2]=Z;ma=b+(ja*12|0)+5700|0;g[ma>>2]=_;na=c[k>>2]|0;oa=b+(aa<<2)+6268|0;c[oa>>2]=na;pa=k+4|0;qa=c[pa>>2]|0;ra=b+(fa<<2)+6268|0;c[ra>>2]=qa;sa=k+8|0;ta=c[sa>>2]|0;ua=b+(ja<<2)+6268|0;c[ua>>2]=ta;va=b+(R<<2)+6460|0;c[va>>2]=h;wa=b+R+6524|0;a[wa>>0]=d;i=j;return 1}function lxb(a){a=a|0;return}function mxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function nxb(a){a=a|0;return}function oxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function pxb(a){a=a|0;return}function qxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function rxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;i=c[a+16>>2]|0;j=c[a+8>>2]|0;k=c[j+200>>2]|0;l=ea(g[k+(b*12|0)>>2]);m=ea(g[k+(b*12|0)+4>>2]);n=ea(g[k+(b*12|0)+8>>2]);o=ea(l*ea(g[j+96>>2]));p=ea(o+ea(m*ea(g[j+112>>2])));o=ea(p+ea(n*ea(g[j+128>>2])));p=ea(l*ea(g[j+100>>2]));q=ea(p+ea(m*ea(g[j+116>>2])));p=ea(q+ea(n*ea(g[j+132>>2])));q=ea(l*ea(g[j+104>>2]));l=ea(q+ea(m*ea(g[j+120>>2])));m=ea(l+ea(n*ea(g[j+136>>2])));n=ea(g[i+48>>2]);l=ea(g[i+52>>2]);q=ea(g[i+56>>2]);r=ea(o*ea(g[i>>2]));s=ea(r+ea(p*ea(g[i+16>>2])));r=ea(s+ea(m*ea(g[i+32>>2])));s=ea(o*ea(g[i+4>>2]));t=ea(s+ea(p*ea(g[i+20>>2])));s=ea(t+ea(m*ea(g[i+36>>2])));t=ea(o*ea(g[i+8>>2]));o=ea(t+ea(p*ea(g[i+24>>2])));p=ea(n+r);r=ea(l+s);s=ea(q+ea(o+ea(m*ea(g[i+40>>2]))));i=c[a+12>>2]|0;a=c[i+200>>2]|0;m=ea(g[a+(d*12|0)>>2]);o=ea(g[a+(d*12|0)+4>>2]);q=ea(g[a+(d*12|0)+8>>2]);l=ea(m*ea(g[i+96>>2]));n=ea(l+ea(o*ea(g[i+112>>2])));l=ea(n+ea(q*ea(g[i+128>>2])));n=ea(m*ea(g[i+100>>2]));t=ea(n+ea(o*ea(g[i+116>>2])));n=ea(t+ea(q*ea(g[i+132>>2])));t=ea(m*ea(g[i+104>>2]));m=ea(t+ea(o*ea(g[i+120>>2])));o=ea(m+ea(q*ea(g[i+136>>2])));g[e>>2]=p;g[e+4>>2]=r;g[e+8>>2]=s;g[e+12>>2]=ea(0.0);g[f>>2]=l;g[f+4>>2]=n;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);q=ea(r-n);n=ea(s-o);g[h>>2]=ea(p-l);g[h+4>>2]=q;g[h+8>>2]=n;g[h+12>>2]=ea(0.0);return}function sxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;m=c[a+8>>2]|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(-n);n=ea(-o);o=ea(-ea(g[b+8>>2]));q=c[a+16>>2]|0;r=ea(ea(g[q>>2])*p);s=q+4|0;t=ea(r+ea(ea(g[s>>2])*n));u=q+8|0;r=ea(t+ea(ea(g[u>>2])*o));v=q+16|0;t=ea(ea(g[v>>2])*p);w=q+20|0;x=ea(t+ea(ea(g[w>>2])*n));y=q+24|0;t=ea(x+ea(ea(g[y>>2])*o));z=q+32|0;x=ea(ea(g[z>>2])*p);A=q+36|0;p=ea(x+ea(ea(g[A>>2])*n));B=q+40|0;n=ea(p+ea(ea(g[B>>2])*o));g[j>>2]=r;g[j+4>>2]=t;g[j+8>>2]=n;g[j+12>>2]=ea(0.0);HFb(k,m,j);n=ea(g[q+48>>2]);t=ea(g[q+52>>2]);r=ea(g[q+56>>2]);o=ea(g[k>>2]);p=ea(g[k+4>>2]);x=ea(g[k+8>>2]);C=ea(o*ea(g[q>>2]));D=ea(C+ea(p*ea(g[v>>2])));C=ea(D+ea(x*ea(g[z>>2])));D=ea(o*ea(g[s>>2]));E=ea(D+ea(p*ea(g[w>>2])));D=ea(E+ea(x*ea(g[A>>2])));E=ea(o*ea(g[u>>2]));o=ea(E+ea(p*ea(g[y>>2])));p=ea(n+C);C=ea(t+D);D=ea(r+ea(o+ea(x*ea(g[B>>2]))));HFb(l,c[a+12>>2]|0,b);g[d>>2]=p;g[d+4>>2]=C;g[d+8>>2]=D;g[d+12>>2]=ea(0.0);c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];x=ea(g[l>>2]);o=ea(g[l+4>>2]);r=ea(C-o);o=ea(D-ea(g[l+8>>2]));g[f>>2]=ea(p-x);g[f+4>>2]=r;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);i=h;return}function txb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function uxb(a){a=a|0;return}function vxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function wxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;j=i;i=i+32|0;k=j+16|0;l=j;m=c[a+16>>2]|0;n=c[a+8>>2]|0;o=c[540320+(b<<4)>>2]|0;p=c[540324+(b<<4)>>2]|0;q=c[540328+(b<<4)>>2]|0;b=n+144|0;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];r=ea(g[n+144>>2]);s=ea(g[n+148>>2]);t=ea(-s);s=ea(-ea(g[n+152>>2]));g[k>>2]=ea(-r);g[k+4>>2]=t;g[k+8>>2]=s;g[k+12>>2]=ea(0.0);s=ea(g[((o|0)==0?k:l)>>2]);t=ea(g[((p|0)==0?k:l)+4>>2]);r=ea(g[((q|0)==0?k:l)+8>>2]);u=ea(g[m+48>>2]);v=ea(g[m+52>>2]);w=ea(g[m+56>>2]);x=ea(s*ea(g[m>>2]));y=ea(x+ea(t*ea(g[m+16>>2])));x=ea(y+ea(r*ea(g[m+32>>2])));y=ea(s*ea(g[m+4>>2]));z=ea(y+ea(t*ea(g[m+20>>2])));y=ea(z+ea(r*ea(g[m+36>>2])));z=ea(s*ea(g[m+8>>2]));s=ea(z+ea(t*ea(g[m+24>>2])));t=ea(u+x);x=ea(v+y);y=ea(w+ea(s+ea(r*ea(g[m+40>>2]))));m=c[a+12>>2]|0;a=c[m+200>>2]|0;r=ea(g[a+(d*12|0)>>2]);s=ea(g[a+(d*12|0)+4>>2]);w=ea(g[a+(d*12|0)+8>>2]);v=ea(r*ea(g[m+96>>2]));u=ea(v+ea(s*ea(g[m+112>>2])));v=ea(u+ea(w*ea(g[m+128>>2])));u=ea(r*ea(g[m+100>>2]));z=ea(u+ea(s*ea(g[m+116>>2])));u=ea(z+ea(w*ea(g[m+132>>2])));z=ea(r*ea(g[m+104>>2]));r=ea(z+ea(s*ea(g[m+120>>2])));s=ea(r+ea(w*ea(g[m+136>>2])));g[e>>2]=t;g[e+4>>2]=x;g[e+8>>2]=y;g[e+12>>2]=ea(0.0);g[f>>2]=v;g[f+4>>2]=u;g[f+8>>2]=s;g[f+12>>2]=ea(0.0);w=ea(x-u);u=ea(y-s);g[h>>2]=ea(t-v);g[h+4>>2]=w;g[h+8>>2]=u;g[h+12>>2]=ea(0.0);i=j;return}function xxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=Im;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;m=c[a+8>>2]|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(-n);n=ea(-o);o=ea(-ea(g[b+8>>2]));q=c[a+16>>2]|0;r=ea(g[q>>2]);s=ea(r*p);t=ea(g[q+4>>2]);u=ea(s+ea(t*n));s=ea(g[q+8>>2]);v=ea(u+ea(s*o));u=ea(g[q+16>>2]);w=ea(u*p);x=ea(g[q+20>>2]);y=ea(w+ea(x*n));w=ea(g[q+24>>2]);z=ea(y+ea(w*o));y=ea(g[q+32>>2]);A=ea(y*p);p=ea(g[q+36>>2]);B=ea(A+ea(p*n));n=ea(g[q+40>>2]);C=v>ea(0.0);D=z>ea(0.0);E=ea(B+ea(n*o))>ea(0.0);F=m+144|0;c[k+0>>2]=c[F+0>>2];c[k+4>>2]=c[F+4>>2];c[k+8>>2]=c[F+8>>2];c[k+12>>2]=c[F+12>>2];o=ea(g[m+144>>2]);B=ea(g[m+148>>2]);z=ea(-B);B=ea(-ea(g[m+152>>2]));g[j>>2]=ea(-o);g[j+4>>2]=z;g[j+8>>2]=B;g[j+12>>2]=ea(0.0);B=ea(g[(C?k:j)>>2]);z=ea(g[(D?k:j)+4>>2]);o=ea(g[(E?k:j)+8>>2]);v=ea(g[q+48>>2]);A=ea(g[q+52>>2]);G=ea(ea(ea(ea(r*B)+ea(u*z))+ea(y*o))+v);v=ea(ea(ea(ea(t*B)+ea(x*z))+ea(p*o))+A);A=ea(ea(ea(ea(s*B)+ea(w*z))+ea(n*o))+ea(g[q+56>>2]));HFb(l,c[a+12>>2]|0,b);g[d>>2]=G;g[d+4>>2]=v;g[d+8>>2]=A;g[d+12>>2]=ea(0.0);c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];o=ea(g[l>>2]);n=ea(g[l+4>>2]);z=ea(v-n);n=ea(A-ea(g[l+8>>2]));g[f>>2]=ea(G-o);g[f+4>>2]=z;g[f+8>>2]=n;g[f+12>>2]=ea(0.0);i=h;return}function yxb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function zxb(a){a=a|0;return}function Axb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Bxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;j=i;i=i+32|0;k=j+16|0;l=j;m=c[a+16>>2]|0;n=c[a+8>>2]|0;o=c[540320+(b<<4)>>2]|0;p=c[540324+(b<<4)>>2]|0;q=c[540328+(b<<4)>>2]|0;b=n+144|0;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];r=ea(g[n+144>>2]);s=ea(g[n+148>>2]);t=ea(-s);s=ea(-ea(g[n+152>>2]));g[k>>2]=ea(-r);g[k+4>>2]=t;g[k+8>>2]=s;g[k+12>>2]=ea(0.0);s=ea(g[((o|0)==0?k:l)>>2]);t=ea(g[((p|0)==0?k:l)+4>>2]);r=ea(g[((q|0)==0?k:l)+8>>2]);u=ea(g[m+48>>2]);v=ea(g[m+52>>2]);w=ea(g[m+56>>2]);x=ea(s*ea(g[m>>2]));y=ea(x+ea(t*ea(g[m+16>>2])));x=ea(y+ea(r*ea(g[m+32>>2])));y=ea(s*ea(g[m+4>>2]));z=ea(y+ea(t*ea(g[m+20>>2])));y=ea(z+ea(r*ea(g[m+36>>2])));z=ea(s*ea(g[m+8>>2]));s=ea(z+ea(t*ea(g[m+24>>2])));t=ea(u+x);x=ea(v+y);y=ea(w+ea(s+ea(r*ea(g[m+40>>2]))));m=c[a+12>>2]|0;a=c[540320+(d<<4)>>2]|0;q=c[540324+(d<<4)>>2]|0;p=c[540328+(d<<4)>>2]|0;d=m+144|0;c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];r=ea(g[m+144>>2]);s=ea(g[m+148>>2]);w=ea(-s);s=ea(-ea(g[m+152>>2]));g[k>>2]=ea(-r);g[k+4>>2]=w;g[k+8>>2]=s;g[k+12>>2]=ea(0.0);s=ea(g[((a|0)==0?k:l)>>2]);w=ea(g[((q|0)==0?k:l)+4>>2]);r=ea(g[((p|0)==0?k:l)+8>>2]);g[e>>2]=t;g[e+4>>2]=x;g[e+8>>2]=y;g[e+12>>2]=ea(0.0);g[f>>2]=s;g[f+4>>2]=w;g[f+8>>2]=r;g[f+12>>2]=ea(0.0);v=ea(x-w);w=ea(y-r);g[h>>2]=ea(t-s);g[h+4>>2]=v;g[h+8>>2]=w;g[h+12>>2]=ea(0.0);i=j;return}function Cxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=Im;h=i;i=i+32|0;j=h+16|0;k=h;l=c[a+8>>2]|0;m=ea(g[b>>2]);n=b+4|0;o=ea(g[n>>2]);p=b+8|0;q=ea(-m);m=ea(-o);o=ea(-ea(g[p>>2]));r=c[a+16>>2]|0;s=ea(g[r>>2]);t=ea(s*q);u=ea(g[r+4>>2]);v=ea(t+ea(u*m));t=ea(g[r+8>>2]);w=ea(v+ea(t*o));v=ea(g[r+16>>2]);x=ea(v*q);y=ea(g[r+20>>2]);z=ea(x+ea(y*m));x=ea(g[r+24>>2]);A=ea(z+ea(x*o));z=ea(g[r+32>>2]);B=ea(z*q);q=ea(g[r+36>>2]);C=ea(B+ea(q*m));m=ea(g[r+40>>2]);D=w>ea(0.0);E=A>ea(0.0);F=ea(C+ea(m*o))>ea(0.0);G=l+144|0;c[k+0>>2]=c[G+0>>2];c[k+4>>2]=c[G+4>>2];c[k+8>>2]=c[G+8>>2];c[k+12>>2]=c[G+12>>2];o=ea(g[l+144>>2]);C=ea(g[l+148>>2]);A=ea(-C);C=ea(-ea(g[l+152>>2]));g[j>>2]=ea(-o);g[j+4>>2]=A;g[j+8>>2]=C;g[j+12>>2]=ea(0.0);C=ea(g[(D?k:j)>>2]);A=ea(g[(E?k:j)+4>>2]);o=ea(g[(F?k:j)+8>>2]);w=ea(g[r+48>>2]);B=ea(g[r+52>>2]);H=ea(ea(ea(ea(s*C)+ea(v*A))+ea(z*o))+w);w=ea(ea(ea(ea(u*C)+ea(y*A))+ea(q*o))+B);B=ea(ea(ea(ea(t*C)+ea(x*A))+ea(m*o))+ea(g[r+56>>2]));r=c[a+12>>2]|0;o=ea(g[b>>2]);m=ea(g[n>>2]);n=o>ea(0.0);b=m>ea(0.0);a=ea(g[p>>2])>ea(0.0);p=r+144|0;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];m=ea(g[r+144>>2]);o=ea(g[r+148>>2]);A=ea(-o);o=ea(-ea(g[r+152>>2]));g[j>>2]=ea(-m);g[j+4>>2]=A;g[j+8>>2]=o;g[j+12>>2]=ea(0.0);o=ea(g[(n?k:j)>>2]);A=ea(g[(b?k:j)+4>>2]);m=ea(g[(a?k:j)+8>>2]);g[d>>2]=H;g[d+4>>2]=w;g[d+8>>2]=B;g[d+12>>2]=ea(0.0);g[e>>2]=o;g[e+4>>2]=A;g[e+8>>2]=m;g[e+12>>2]=ea(0.0);x=ea(w-A);A=ea(B-m);g[f>>2]=ea(H-o);g[f+4>>2]=x;g[f+8>>2]=A;g[f+12>>2]=ea(0.0);i=h;return}function Dxb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function Exb(a){a=a|0;return}function Fxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Gxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;i=c[a+8>>2]|0;j=ea(g[i+(b<<4)+96>>2]);k=ea(g[i+(b<<4)+100>>2]);l=ea(g[i+(b<<4)+104>>2]);m=ea(g[i+(b<<4)+108>>2]);b=c[a+12>>2]|0;a=c[b+200>>2]|0;n=ea(g[a+(d*12|0)>>2]);o=ea(g[a+(d*12|0)+4>>2]);p=ea(g[a+(d*12|0)+8>>2]);q=ea(n*ea(g[b+96>>2]));r=ea(q+ea(o*ea(g[b+112>>2])));q=ea(r+ea(p*ea(g[b+128>>2])));r=ea(n*ea(g[b+100>>2]));s=ea(r+ea(o*ea(g[b+116>>2])));r=ea(s+ea(p*ea(g[b+132>>2])));s=ea(n*ea(g[b+104>>2]));n=ea(s+ea(o*ea(g[b+120>>2])));o=ea(n+ea(p*ea(g[b+136>>2])));g[e>>2]=j;g[e+4>>2]=k;g[e+8>>2]=l;g[e+12>>2]=m;g[f>>2]=q;g[f+4>>2]=r;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);m=ea(k-r);r=ea(l-o);g[h>>2]=ea(j-q);g[h+4>>2]=m;g[h+8>>2]=r;g[h+12>>2]=ea(0.0);return}function Hxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0;h=i;i=i+80|0;j=h+64|0;k=h+48|0;l=h+32|0;m=h+16|0;n=h;o=c[a+8>>2]|0;p=ea(g[b>>2]);q=ea(g[b+4>>2]);r=ea(-p);p=ea(-q);q=ea(-ea(g[b+8>>2]));s=ea(g[o+96>>2]);t=ea(g[o+100>>2]);u=ea(g[o+104>>2]);v=ea(g[o+108>>2]);w=ea(g[o+112>>2]);x=ea(g[o+116>>2]);y=ea(g[o+120>>2]);z=ea(g[o+124>>2]);A=ea(g[o+128>>2]);B=ea(g[o+132>>2]);C=ea(g[o+136>>2]);D=ea(g[o+140>>2]);E=ea(ea(ea(s*r)+ea(t*p))+ea(u*q));F=ea(ea(ea(w*r)+ea(x*p))+ea(y*q));G=ea(ea(ea(A*r)+ea(B*p))+ea(C*q));if(E>F)H=E>G?m:l;else H=l;g[k>>2]=w;g[k+4>>2]=x;g[k+8>>2]=y;g[k+12>>2]=z;g[j>>2]=A;g[j+4>>2]=B;g[j+8>>2]=C;g[j+12>>2]=D;o=F>G?k:j;G=ea(g[o>>2]);F=ea(g[o+4>>2]);D=ea(g[o+8>>2]);g[m>>2]=s;g[m+4>>2]=t;g[m+8>>2]=u;g[m+12>>2]=v;g[l>>2]=G;g[l+4>>2]=F;g[l+8>>2]=D;g[l+12>>2]=ea(0.0);D=ea(g[H>>2]);F=ea(g[H+4>>2]);G=ea(g[H+8>>2]);HFb(n,c[a+12>>2]|0,b);g[d>>2]=D;g[d+4>>2]=F;g[d+8>>2]=G;g[d+12>>2]=ea(0.0);c[e+0>>2]=c[n+0>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];v=ea(g[n>>2]);u=ea(g[n+4>>2]);t=ea(F-u);u=ea(G-ea(g[n+8>>2]));g[f>>2]=ea(D-v);g[f+4>>2]=t;g[f+8>>2]=u;g[f+12>>2]=ea(0.0);i=h;return}function Ixb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im;d=c[b+8>>2]|0;e=ea(g[d>>2]);f=ea(g[d+4>>2]);h=ea(g[d+8>>2]);d=c[b+12>>2]|0;i=ea(g[d>>2]);j=ea(g[d+4>>2]);k=ea(f-j);j=ea(h-ea(g[d+8>>2]));g[a>>2]=ea(e-i);g[a+4>>2]=k;g[a+8>>2]=j;g[a+12>>2]=ea(0.0);return}function Jxb(a){a=a|0;return}function Kxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Lxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=Im,u=Im;j=i;i=i+32|0;k=j+16|0;l=j;m=c[a+8>>2]|0;n=ea(g[m+(b<<4)+96>>2]);o=ea(g[m+(b<<4)+100>>2]);p=ea(g[m+(b<<4)+104>>2]);q=ea(g[m+(b<<4)+108>>2]);b=c[a+12>>2]|0;a=c[540320+(d<<4)>>2]|0;m=c[540324+(d<<4)>>2]|0;r=c[540328+(d<<4)>>2]|0;d=b+144|0;c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];s=ea(g[b+144>>2]);t=ea(g[b+148>>2]);u=ea(-t);t=ea(-ea(g[b+152>>2]));g[k>>2]=ea(-s);g[k+4>>2]=u;g[k+8>>2]=t;g[k+12>>2]=ea(0.0);t=ea(g[((a|0)==0?k:l)>>2]);u=ea(g[((m|0)==0?k:l)+4>>2]);s=ea(g[((r|0)==0?k:l)+8>>2]);g[e>>2]=n;g[e+4>>2]=o;g[e+8>>2]=p;g[e+12>>2]=q;g[f>>2]=t;g[f+4>>2]=u;g[f+8>>2]=s;g[f+12>>2]=ea(0.0);q=ea(o-u);u=ea(p-s);g[h>>2]=ea(n-t);g[h+4>>2]=q;g[h+8>>2]=u;g[h+12>>2]=ea(0.0);i=j;return}function Mxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0;h=i;i=i+64|0;j=h+48|0;k=h+32|0;l=h+16|0;m=h;n=c[a+8>>2]|0;o=ea(g[b>>2]);p=ea(g[b+4>>2]);q=ea(g[b+8>>2]);r=ea(-o);s=ea(-p);t=ea(-q);u=ea(g[n+96>>2]);v=ea(g[n+100>>2]);w=ea(g[n+104>>2]);x=ea(g[n+108>>2]);y=ea(g[n+112>>2]);z=ea(g[n+116>>2]);A=ea(g[n+120>>2]);B=ea(g[n+124>>2]);C=ea(g[n+128>>2]);D=ea(g[n+132>>2]);E=ea(g[n+136>>2]);F=ea(g[n+140>>2]);G=ea(ea(ea(u*r)+ea(v*s))+ea(w*t));H=ea(ea(ea(y*r)+ea(z*s))+ea(A*t));I=ea(ea(ea(C*r)+ea(D*s))+ea(E*t));if(G>H)J=G>I?m:l;else J=l;g[k>>2]=y;g[k+4>>2]=z;g[k+8>>2]=A;g[k+12>>2]=B;g[j>>2]=C;g[j+4>>2]=D;g[j+8>>2]=E;g[j+12>>2]=F;n=H>I?k:j;I=ea(g[n>>2]);H=ea(g[n+4>>2]);F=ea(g[n+8>>2]);g[m>>2]=u;g[m+4>>2]=v;g[m+8>>2]=w;g[m+12>>2]=x;g[l>>2]=I;g[l+4>>2]=H;g[l+8>>2]=F;g[l+12>>2]=ea(0.0);F=ea(g[J>>2]);H=ea(g[J+4>>2]);I=ea(g[J+8>>2]);J=c[a+12>>2]|0;a=o>ea(0.0);l=p>ea(0.0);m=q>ea(0.0);n=J+144|0;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];q=ea(g[J+144>>2]);p=ea(g[J+148>>2]);o=ea(-p);p=ea(-ea(g[J+152>>2]));g[j>>2]=ea(-q);g[j+4>>2]=o;g[j+8>>2]=p;g[j+12>>2]=ea(0.0);p=ea(g[(a?k:j)>>2]);o=ea(g[(l?k:j)+4>>2]);q=ea(g[(m?k:j)+8>>2]);g[d>>2]=F;g[d+4>>2]=H;g[d+8>>2]=I;g[d+12>>2]=ea(0.0);g[e>>2]=p;g[e+4>>2]=o;g[e+8>>2]=q;g[e+12>>2]=ea(0.0);x=ea(H-o);o=ea(I-q);g[f>>2]=ea(F-p);g[f+4>>2]=x;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);i=h;return}function Nxb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im;d=c[b+8>>2]|0;e=ea(g[d>>2]);f=ea(g[d+4>>2]);h=ea(g[d+8>>2]);d=c[b+12>>2]|0;i=ea(g[d>>2]);j=ea(g[d+4>>2]);k=ea(f-j);j=ea(h-ea(g[d+8>>2]));g[a>>2]=ea(e-i);g[a+4>>2]=k;g[a+8>>2]=j;g[a+12>>2]=ea(0.0);return}function Oxb(a){a=a|0;return}function Pxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Qxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;i=1-b|0;b=(c[a+8>>2]|0)+96|0;j=ea(g[b+(i<<4)>>2]);k=ea(g[b+(i<<4)+4>>2]);l=ea(g[b+(i<<4)+8>>2]);m=ea(g[b+(i<<4)+12>>2]);i=c[a+12>>2]|0;a=c[i+200>>2]|0;n=ea(g[a+(d*12|0)>>2]);o=ea(g[a+(d*12|0)+4>>2]);p=ea(g[a+(d*12|0)+8>>2]);q=ea(n*ea(g[i+96>>2]));r=ea(q+ea(o*ea(g[i+112>>2])));q=ea(r+ea(p*ea(g[i+128>>2])));r=ea(n*ea(g[i+100>>2]));s=ea(r+ea(o*ea(g[i+116>>2])));r=ea(s+ea(p*ea(g[i+132>>2])));s=ea(n*ea(g[i+104>>2]));n=ea(s+ea(o*ea(g[i+120>>2])));o=ea(n+ea(p*ea(g[i+136>>2])));g[e>>2]=j;g[e+4>>2]=k;g[e+8>>2]=l;g[e+12>>2]=m;g[f>>2]=q;g[f+4>>2]=r;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);m=ea(k-r);r=ea(l-o);g[h>>2]=ea(j-q);g[h+4>>2]=m;g[h+8>>2]=r;g[h+12>>2]=ea(0.0);return}function Rxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=0,v=0;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;m=c[a+8>>2]|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(-n);n=ea(-o);o=ea(-ea(g[b+8>>2]));q=m+96|0;r=ea(g[m+96>>2]);s=ea(g[m+100>>2]);t=ea(ea(ea(r*p)+ea(s*n))+ea(ea(g[m+104>>2])*o));u=m+112|0;s=ea(g[m+112>>2]);r=ea(g[m+116>>2]);v=t>ea(ea(ea(s*p)+ea(r*n))+ea(ea(g[m+120>>2])*o));c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[j+0>>2]=c[u+0>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];u=v?k:j;o=ea(g[u>>2]);n=ea(g[u+4>>2]);r=ea(g[u+8>>2]);HFb(l,c[a+12>>2]|0,b);g[d>>2]=o;g[d+4>>2]=n;g[d+8>>2]=r;g[d+12>>2]=ea(0.0);c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];p=ea(g[l>>2]);s=ea(g[l+4>>2]);t=ea(n-s);s=ea(r-ea(g[l+8>>2]));g[f>>2]=ea(o-p);g[f+4>>2]=t;g[f+8>>2]=s;g[f+12>>2]=ea(0.0);i=h;return}function Sxb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im;d=c[b+8>>2]|0;e=ea(g[d>>2]);f=ea(g[d+4>>2]);h=ea(g[d+8>>2]);d=c[b+12>>2]|0;i=ea(g[d>>2]);j=ea(g[d+4>>2]);k=ea(f-j);j=ea(h-ea(g[d+8>>2]));g[a>>2]=ea(e-i);g[a+4>>2]=k;g[a+8>>2]=j;g[a+12>>2]=ea(0.0);return}function Txb(a){a=a|0;return}function Uxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Vxb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=Im,u=Im;j=i;i=i+32|0;k=j+16|0;l=j;m=1-b|0;b=(c[a+8>>2]|0)+96|0;n=ea(g[b+(m<<4)>>2]);o=ea(g[b+(m<<4)+4>>2]);p=ea(g[b+(m<<4)+8>>2]);q=ea(g[b+(m<<4)+12>>2]);m=c[a+12>>2]|0;a=c[540320+(d<<4)>>2]|0;b=c[540324+(d<<4)>>2]|0;r=c[540328+(d<<4)>>2]|0;d=m+144|0;c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];s=ea(g[m+144>>2]);t=ea(g[m+148>>2]);u=ea(-t);t=ea(-ea(g[m+152>>2]));g[k>>2]=ea(-s);g[k+4>>2]=u;g[k+8>>2]=t;g[k+12>>2]=ea(0.0);t=ea(g[((a|0)==0?k:l)>>2]);u=ea(g[((b|0)==0?k:l)+4>>2]);s=ea(g[((r|0)==0?k:l)+8>>2]);g[e>>2]=n;g[e+4>>2]=o;g[e+8>>2]=p;g[e+12>>2]=q;g[f>>2]=t;g[f+4>>2]=u;g[f+8>>2]=s;g[f+12>>2]=ea(0.0);q=ea(o-u);u=ea(p-s);g[h>>2]=ea(n-t);g[h+4>>2]=q;g[h+8>>2]=u;g[h+12>>2]=ea(0.0);i=j;return}function Wxb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0;h=i;i=i+32|0;j=h+16|0;k=h;l=c[a+8>>2]|0;m=ea(g[b>>2]);n=ea(g[b+4>>2]);o=ea(g[b+8>>2]);p=ea(-m);q=ea(-n);r=ea(-o);b=l+96|0;s=ea(g[l+96>>2]);t=ea(g[l+100>>2]);u=ea(ea(ea(s*p)+ea(t*q))+ea(ea(g[l+104>>2])*r));v=l+112|0;t=ea(g[l+112>>2]);s=ea(g[l+116>>2]);w=u>ea(ea(ea(t*p)+ea(s*q))+ea(ea(g[l+120>>2])*r));c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];v=w?k:j;r=ea(g[v>>2]);q=ea(g[v+4>>2]);s=ea(g[v+8>>2]);v=c[a+12>>2]|0;a=m>ea(0.0);w=n>ea(0.0);b=o>ea(0.0);l=v+144|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];o=ea(g[v+144>>2]);n=ea(g[v+148>>2]);m=ea(-n);n=ea(-ea(g[v+152>>2]));g[j>>2]=ea(-o);g[j+4>>2]=m;g[j+8>>2]=n;g[j+12>>2]=ea(0.0);n=ea(g[(a?k:j)>>2]);m=ea(g[(w?k:j)+4>>2]);o=ea(g[(b?k:j)+8>>2]);g[d>>2]=r;g[d+4>>2]=q;g[d+8>>2]=s;g[d+12>>2]=ea(0.0);g[e>>2]=n;g[e+4>>2]=m;g[e+8>>2]=o;g[e+12>>2]=ea(0.0);p=ea(q-m);m=ea(s-o);g[f>>2]=ea(r-n);g[f+4>>2]=p;g[f+8>>2]=m;g[f+12>>2]=ea(0.0);i=h;return}function Xxb(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im;d=c[b+8>>2]|0;e=ea(g[d>>2]);f=ea(g[d+4>>2]);h=ea(g[d+8>>2]);d=c[b+12>>2]|0;i=ea(g[d>>2]);j=ea(g[d+4>>2]);k=ea(f-j);j=ea(h-ea(g[d+8>>2]));g[a>>2]=ea(e-i);g[a+4>>2]=k;g[a+8>>2]=j;g[a+12>>2]=ea(0.0);return}function Yxb(a){a=a|0;return}function Zxb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function _xb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;i=c[a+16>>2]|0;j=1-b|0;b=(c[a+8>>2]|0)+96|0;k=ea(g[b+(j<<4)>>2]);l=ea(g[b+(j<<4)+4>>2]);m=ea(g[b+(j<<4)+8>>2]);n=ea(g[i+48>>2]);o=ea(g[i+52>>2]);p=ea(g[i+56>>2]);q=ea(k*ea(g[i>>2]));r=ea(q+ea(l*ea(g[i+16>>2])));q=ea(r+ea(m*ea(g[i+32>>2])));r=ea(k*ea(g[i+4>>2]));s=ea(r+ea(l*ea(g[i+20>>2])));r=ea(s+ea(m*ea(g[i+36>>2])));s=ea(k*ea(g[i+8>>2]));k=ea(s+ea(l*ea(g[i+24>>2])));l=ea(n+q);q=ea(o+r);r=ea(p+ea(k+ea(m*ea(g[i+40>>2]))));i=c[a+12>>2]|0;a=c[i+200>>2]|0;m=ea(g[a+(d*12|0)>>2]);k=ea(g[a+(d*12|0)+4>>2]);p=ea(g[a+(d*12|0)+8>>2]);o=ea(m*ea(g[i+96>>2]));n=ea(o+ea(k*ea(g[i+112>>2])));o=ea(n+ea(p*ea(g[i+128>>2])));n=ea(m*ea(g[i+100>>2]));s=ea(n+ea(k*ea(g[i+116>>2])));n=ea(s+ea(p*ea(g[i+132>>2])));s=ea(m*ea(g[i+104>>2]));m=ea(s+ea(k*ea(g[i+120>>2])));k=ea(m+ea(p*ea(g[i+136>>2])));g[e>>2]=l;g[e+4>>2]=q;g[e+8>>2]=r;g[e+12>>2]=ea(0.0);g[f>>2]=o;g[f+4>>2]=n;g[f+8>>2]=k;g[f+12>>2]=ea(0.0);p=ea(q-n);n=ea(r-k);g[h>>2]=ea(l-o);g[h+4>>2]=p;g[h+8>>2]=n;g[h+12>>2]=ea(0.0);return}function $xb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=Im,E=0,F=0;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;m=c[a+8>>2]|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(-n);n=ea(-o);o=ea(-ea(g[b+8>>2]));q=c[a+16>>2]|0;r=ea(g[q>>2]);s=ea(r*p);t=ea(g[q+4>>2]);u=ea(s+ea(t*n));s=ea(g[q+8>>2]);v=ea(u+ea(s*o));u=ea(g[q+16>>2]);w=ea(u*p);x=ea(g[q+20>>2]);y=ea(w+ea(x*n));w=ea(g[q+24>>2]);z=ea(y+ea(w*o));y=ea(g[q+32>>2]);A=ea(y*p);p=ea(g[q+36>>2]);B=ea(A+ea(p*n));n=ea(g[q+40>>2]);A=ea(B+ea(n*o));C=m+96|0;o=ea(g[m+96>>2]);B=ea(g[m+100>>2]);D=ea(ea(ea(v*o)+ea(z*B))+ea(A*ea(g[m+104>>2])));E=m+112|0;B=ea(g[m+112>>2]);o=ea(g[m+116>>2]);F=D>ea(ea(ea(v*B)+ea(z*o))+ea(A*ea(g[m+120>>2])));c[k+0>>2]=c[C+0>>2];c[k+4>>2]=c[C+4>>2];c[k+8>>2]=c[C+8>>2];c[k+12>>2]=c[C+12>>2];c[j+0>>2]=c[E+0>>2];c[j+4>>2]=c[E+4>>2];c[j+8>>2]=c[E+8>>2];c[j+12>>2]=c[E+12>>2];E=F?k:j;A=ea(g[E>>2]);o=ea(g[E+4>>2]);z=ea(g[E+8>>2]);B=ea(g[q+48>>2]);v=ea(g[q+52>>2]);D=ea(ea(ea(ea(r*A)+ea(u*o))+ea(y*z))+B);B=ea(ea(ea(ea(t*A)+ea(x*o))+ea(p*z))+v);v=ea(ea(ea(ea(s*A)+ea(w*o))+ea(n*z))+ea(g[q+56>>2]));HFb(l,c[a+12>>2]|0,b);g[d>>2]=D;g[d+4>>2]=B;g[d+8>>2]=v;g[d+12>>2]=ea(0.0);c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];z=ea(g[l>>2]);n=ea(g[l+4>>2]);o=ea(B-n);n=ea(v-ea(g[l+8>>2]));g[f>>2]=ea(D-z);g[f+4>>2]=o;g[f+8>>2]=n;g[f+12>>2]=ea(0.0);i=h;return}function ayb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function byb(a){a=a|0;return}function cyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function dyb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;j=i;i=i+32|0;k=j+16|0;l=j;m=c[a+16>>2]|0;n=1-b|0;b=(c[a+8>>2]|0)+96|0;o=ea(g[b+(n<<4)>>2]);p=ea(g[b+(n<<4)+4>>2]);q=ea(g[b+(n<<4)+8>>2]);r=ea(g[m+48>>2]);s=ea(g[m+52>>2]);t=ea(g[m+56>>2]);u=ea(o*ea(g[m>>2]));v=ea(u+ea(p*ea(g[m+16>>2])));u=ea(v+ea(q*ea(g[m+32>>2])));v=ea(o*ea(g[m+4>>2]));w=ea(v+ea(p*ea(g[m+20>>2])));v=ea(w+ea(q*ea(g[m+36>>2])));w=ea(o*ea(g[m+8>>2]));o=ea(w+ea(p*ea(g[m+24>>2])));p=ea(r+u);u=ea(s+v);v=ea(t+ea(o+ea(q*ea(g[m+40>>2]))));m=c[a+12>>2]|0;a=c[540320+(d<<4)>>2]|0;n=c[540324+(d<<4)>>2]|0;b=c[540328+(d<<4)>>2]|0;d=m+144|0;c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];q=ea(g[m+144>>2]);o=ea(g[m+148>>2]);t=ea(-o);o=ea(-ea(g[m+152>>2]));g[k>>2]=ea(-q);g[k+4>>2]=t;g[k+8>>2]=o;g[k+12>>2]=ea(0.0);o=ea(g[((a|0)==0?k:l)>>2]);t=ea(g[((n|0)==0?k:l)+4>>2]);q=ea(g[((b|0)==0?k:l)+8>>2]);g[e>>2]=p;g[e+4>>2]=u;g[e+8>>2]=v;g[e+12>>2]=ea(0.0);g[f>>2]=o;g[f+4>>2]=t;g[f+8>>2]=q;g[f+12>>2]=ea(0.0);s=ea(u-t);t=ea(v-q);g[h>>2]=ea(p-o);g[h+4>>2]=s;g[h+8>>2]=t;g[h+12>>2]=ea(0.0);i=j;return}function eyb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=0,G=0;h=i;i=i+32|0;j=h+16|0;k=h;l=c[a+8>>2]|0;m=ea(g[b>>2]);n=b+4|0;o=ea(g[n>>2]);p=b+8|0;q=ea(-m);m=ea(-o);o=ea(-ea(g[p>>2]));r=c[a+16>>2]|0;s=ea(g[r>>2]);t=ea(s*q);u=ea(g[r+4>>2]);v=ea(t+ea(u*m));t=ea(g[r+8>>2]);w=ea(v+ea(t*o));v=ea(g[r+16>>2]);x=ea(v*q);y=ea(g[r+20>>2]);z=ea(x+ea(y*m));x=ea(g[r+24>>2]);A=ea(z+ea(x*o));z=ea(g[r+32>>2]);B=ea(z*q);q=ea(g[r+36>>2]);C=ea(B+ea(q*m));m=ea(g[r+40>>2]);B=ea(C+ea(m*o));D=l+96|0;o=ea(g[l+96>>2]);C=ea(g[l+100>>2]);E=ea(ea(ea(w*o)+ea(A*C))+ea(B*ea(g[l+104>>2])));F=l+112|0;C=ea(g[l+112>>2]);o=ea(g[l+116>>2]);G=E>ea(ea(ea(w*C)+ea(A*o))+ea(B*ea(g[l+120>>2])));c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];c[j+0>>2]=c[F+0>>2];c[j+4>>2]=c[F+4>>2];c[j+8>>2]=c[F+8>>2];c[j+12>>2]=c[F+12>>2];F=G?k:j;B=ea(g[F>>2]);o=ea(g[F+4>>2]);A=ea(g[F+8>>2]);C=ea(g[r+48>>2]);w=ea(g[r+52>>2]);E=ea(ea(ea(ea(s*B)+ea(v*o))+ea(z*A))+C);C=ea(ea(ea(ea(u*B)+ea(y*o))+ea(q*A))+w);w=ea(ea(ea(ea(t*B)+ea(x*o))+ea(m*A))+ea(g[r+56>>2]));r=c[a+12>>2]|0;A=ea(g[b>>2]);m=ea(g[n>>2]);n=A>ea(0.0);b=m>ea(0.0);a=ea(g[p>>2])>ea(0.0);p=r+144|0;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];m=ea(g[r+144>>2]);A=ea(g[r+148>>2]);o=ea(-A);A=ea(-ea(g[r+152>>2]));g[j>>2]=ea(-m);g[j+4>>2]=o;g[j+8>>2]=A;g[j+12>>2]=ea(0.0);A=ea(g[(n?k:j)>>2]);o=ea(g[(b?k:j)+4>>2]);m=ea(g[(a?k:j)+8>>2]);g[d>>2]=E;g[d+4>>2]=C;g[d+8>>2]=w;g[d+12>>2]=ea(0.0);g[e>>2]=A;g[e+4>>2]=o;g[e+8>>2]=m;g[e+12>>2]=ea(0.0);x=ea(C-o);o=ea(w-m);g[f>>2]=ea(E-A);g[f+4>>2]=x;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);i=h;return}function fyb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function gyb(a){a=a|0;return}function hyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function iyb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;i=c[a+16>>2]|0;j=1-b|0;b=(c[a+8>>2]|0)+96|0;k=ea(g[b+(j<<4)>>2]);l=ea(g[b+(j<<4)+4>>2]);m=ea(g[b+(j<<4)+8>>2]);n=ea(g[i+48>>2]);o=ea(g[i+52>>2]);p=ea(g[i+56>>2]);q=ea(k*ea(g[i>>2]));r=ea(q+ea(l*ea(g[i+16>>2])));q=ea(r+ea(m*ea(g[i+32>>2])));r=ea(k*ea(g[i+4>>2]));s=ea(r+ea(l*ea(g[i+20>>2])));r=ea(s+ea(m*ea(g[i+36>>2])));s=ea(k*ea(g[i+8>>2]));k=ea(s+ea(l*ea(g[i+24>>2])));l=ea(n+q);q=ea(o+r);r=ea(p+ea(k+ea(m*ea(g[i+40>>2]))));i=1-d|0;d=(c[a+12>>2]|0)+96|0;m=ea(g[d+(i<<4)>>2]);k=ea(g[d+(i<<4)+4>>2]);p=ea(g[d+(i<<4)+8>>2]);o=ea(g[d+(i<<4)+12>>2]);g[e>>2]=l;g[e+4>>2]=q;g[e+8>>2]=r;g[e+12>>2]=ea(0.0);g[f>>2]=m;g[f+4>>2]=k;g[f+8>>2]=p;g[f+12>>2]=o;o=ea(q-k);k=ea(r-p);g[h>>2]=ea(l-m);g[h+4>>2]=o;g[h+8>>2]=k;g[h+12>>2]=ea(0.0);return}function jyb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=0,G=0;h=i;i=i+32|0;j=h+16|0;k=h;l=c[a+8>>2]|0;m=ea(g[b>>2]);n=b+4|0;o=ea(g[n>>2]);p=b+8|0;q=ea(-m);m=ea(-o);o=ea(-ea(g[p>>2]));r=c[a+16>>2]|0;s=ea(g[r>>2]);t=ea(s*q);u=ea(g[r+4>>2]);v=ea(t+ea(u*m));t=ea(g[r+8>>2]);w=ea(v+ea(t*o));v=ea(g[r+16>>2]);x=ea(v*q);y=ea(g[r+20>>2]);z=ea(x+ea(y*m));x=ea(g[r+24>>2]);A=ea(z+ea(x*o));z=ea(g[r+32>>2]);B=ea(z*q);q=ea(g[r+36>>2]);C=ea(B+ea(q*m));m=ea(g[r+40>>2]);B=ea(C+ea(m*o));D=l+96|0;o=ea(g[l+96>>2]);C=ea(g[l+100>>2]);E=ea(ea(ea(w*o)+ea(A*C))+ea(B*ea(g[l+104>>2])));F=l+112|0;C=ea(g[l+112>>2]);o=ea(g[l+116>>2]);G=E>ea(ea(ea(w*C)+ea(A*o))+ea(B*ea(g[l+120>>2])));c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];c[j+0>>2]=c[F+0>>2];c[j+4>>2]=c[F+4>>2];c[j+8>>2]=c[F+8>>2];c[j+12>>2]=c[F+12>>2];F=G?k:j;B=ea(g[F>>2]);o=ea(g[F+4>>2]);A=ea(g[F+8>>2]);C=ea(g[r+48>>2]);w=ea(g[r+52>>2]);E=ea(ea(ea(ea(s*B)+ea(v*o))+ea(z*A))+C);C=ea(ea(ea(ea(u*B)+ea(y*o))+ea(q*A))+w);w=ea(ea(ea(ea(t*B)+ea(x*o))+ea(m*A))+ea(g[r+56>>2]));r=c[a+12>>2]|0;a=r+96|0;A=ea(g[r+96>>2]);m=ea(g[r+100>>2]);o=ea(g[r+104>>2]);x=ea(g[b>>2]);B=ea(g[n>>2]);t=ea(g[p>>2]);q=ea(ea(ea(A*x)+ea(m*B))+ea(o*t));p=r+112|0;o=ea(g[r+112>>2]);m=ea(g[r+116>>2]);n=q>ea(ea(ea(x*o)+ea(B*m))+ea(t*ea(g[r+120>>2])));c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];p=n?k:j;t=ea(g[p>>2]);m=ea(g[p+4>>2]);B=ea(g[p+8>>2]);g[d>>2]=E;g[d+4>>2]=C;g[d+8>>2]=w;g[d+12>>2]=ea(0.0);g[e>>2]=t;g[e+4>>2]=m;g[e+8>>2]=B;g[e+12>>2]=ea(0.0);o=ea(C-m);m=ea(w-B);g[f>>2]=ea(E-t);g[f+4>>2]=o;g[f+8>>2]=m;g[f+12>>2]=ea(0.0);i=h;return}function kyb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function lyb(a){a=a|0;return}function myb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function nyb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;i=c[a+16>>2]|0;j=c[a+8>>2]|0;k=ea(g[j+(b<<4)+96>>2]);l=ea(g[j+(b<<4)+100>>2]);m=ea(g[j+(b<<4)+104>>2]);n=ea(g[i+48>>2]);o=ea(g[i+52>>2]);p=ea(g[i+56>>2]);q=ea(k*ea(g[i>>2]));r=ea(q+ea(l*ea(g[i+16>>2])));q=ea(r+ea(m*ea(g[i+32>>2])));r=ea(k*ea(g[i+4>>2]));s=ea(r+ea(l*ea(g[i+20>>2])));r=ea(s+ea(m*ea(g[i+36>>2])));s=ea(k*ea(g[i+8>>2]));k=ea(s+ea(l*ea(g[i+24>>2])));l=ea(n+q);q=ea(o+r);r=ea(p+ea(k+ea(m*ea(g[i+40>>2]))));i=c[a+12>>2]|0;a=c[i+200>>2]|0;m=ea(g[a+(d*12|0)>>2]);k=ea(g[a+(d*12|0)+4>>2]);p=ea(g[a+(d*12|0)+8>>2]);o=ea(m*ea(g[i+96>>2]));n=ea(o+ea(k*ea(g[i+112>>2])));o=ea(n+ea(p*ea(g[i+128>>2])));n=ea(m*ea(g[i+100>>2]));s=ea(n+ea(k*ea(g[i+116>>2])));n=ea(s+ea(p*ea(g[i+132>>2])));s=ea(m*ea(g[i+104>>2]));m=ea(s+ea(k*ea(g[i+120>>2])));k=ea(m+ea(p*ea(g[i+136>>2])));g[e>>2]=l;g[e+4>>2]=q;g[e+8>>2]=r;g[e+12>>2]=ea(0.0);g[f>>2]=o;g[f+4>>2]=n;g[f+8>>2]=k;g[f+12>>2]=ea(0.0);p=ea(q-n);n=ea(r-k);g[h>>2]=ea(l-o);g[h+4>>2]=p;g[h+8>>2]=n;g[h+12>>2]=ea(0.0);return}function oyb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;m=c[a+8>>2]|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(-o);o=ea(-ea(g[b+8>>2]));g[k>>2]=ea(-n);g[k+4>>2]=p;g[k+8>>2]=o;g[k+12>>2]=ea(0.0);IFb(j,m,k,c[a+16>>2]|0);HFb(l,c[a+12>>2]|0,b);c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];o=ea(g[j>>2]);p=ea(g[j+4>>2]);n=ea(g[j+8>>2]);q=ea(g[l>>2]);r=ea(g[l+4>>2]);s=ea(p-r);r=ea(n-ea(g[l+8>>2]));g[f>>2]=ea(o-q);g[f+4>>2]=s;g[f+8>>2]=r;g[f+12>>2]=ea(0.0);i=h;return}function pyb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function qyb(a){a=a|0;return}function ryb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function syb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;i=c[a+16>>2]|0;j=c[a+8>>2]|0;k=ea(g[j+(b<<4)+96>>2]);l=ea(g[j+(b<<4)+100>>2]);m=ea(g[j+(b<<4)+104>>2]);n=ea(g[i+48>>2]);o=ea(g[i+52>>2]);p=ea(g[i+56>>2]);q=ea(k*ea(g[i>>2]));r=ea(q+ea(l*ea(g[i+16>>2])));q=ea(r+ea(m*ea(g[i+32>>2])));r=ea(k*ea(g[i+4>>2]));s=ea(r+ea(l*ea(g[i+20>>2])));r=ea(s+ea(m*ea(g[i+36>>2])));s=ea(k*ea(g[i+8>>2]));k=ea(s+ea(l*ea(g[i+24>>2])));l=ea(n+q);q=ea(o+r);r=ea(p+ea(k+ea(m*ea(g[i+40>>2]))));i=1-d|0;d=(c[a+12>>2]|0)+96|0;m=ea(g[d+(i<<4)>>2]);k=ea(g[d+(i<<4)+4>>2]);p=ea(g[d+(i<<4)+8>>2]);o=ea(g[d+(i<<4)+12>>2]);g[e>>2]=l;g[e+4>>2]=q;g[e+8>>2]=r;g[e+12>>2]=ea(0.0);g[f>>2]=m;g[f+4>>2]=k;g[f+8>>2]=p;g[f+12>>2]=o;o=ea(q-k);k=ea(r-p);g[h>>2]=ea(l-m);g[h+4>>2]=o;g[h+8>>2]=k;g[h+12>>2]=ea(0.0);return}function tyb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=Im;h=i;i=i+64|0;j=h+48|0;k=h+32|0;l=h+16|0;m=h;n=c[a+8>>2]|0;o=ea(g[b>>2]);p=b+4|0;q=ea(g[p>>2]);r=b+8|0;s=ea(-q);q=ea(-ea(g[r>>2]));g[m>>2]=ea(-o);g[m+4>>2]=s;g[m+8>>2]=q;g[m+12>>2]=ea(0.0);IFb(l,n,m,c[a+16>>2]|0);m=c[a+12>>2]|0;a=m+96|0;q=ea(g[m+96>>2]);s=ea(g[m+100>>2]);o=ea(g[m+104>>2]);t=ea(g[b>>2]);u=ea(g[p>>2]);v=ea(g[r>>2]);w=ea(ea(ea(q*t)+ea(s*u))+ea(o*v));r=m+112|0;o=ea(g[m+112>>2]);s=ea(g[m+116>>2]);p=w>ea(ea(ea(t*o)+ea(u*s))+ea(v*ea(g[m+120>>2])));c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[j+12>>2]=c[r+12>>2];r=p?k:j;v=ea(g[r>>2]);s=ea(g[r+4>>2]);u=ea(g[r+8>>2]);c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];g[e>>2]=v;g[e+4>>2]=s;g[e+8>>2]=u;g[e+12>>2]=ea(0.0);o=ea(g[l>>2]);t=ea(g[l+4>>2]);w=ea(t-s);s=ea(ea(g[l+8>>2])-u);g[f>>2]=ea(o-v);g[f+4>>2]=w;g[f+8>>2]=s;g[f+12>>2]=ea(0.0);i=h;return}function uyb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function vyb(a){a=a|0;return}function wyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function xyb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;j=i;i=i+32|0;k=j+16|0;l=j;m=c[a+16>>2]|0;n=c[a+8>>2]|0;o=ea(g[n+(b<<4)+96>>2]);p=ea(g[n+(b<<4)+100>>2]);q=ea(g[n+(b<<4)+104>>2]);r=ea(g[m+48>>2]);s=ea(g[m+52>>2]);t=ea(g[m+56>>2]);u=ea(o*ea(g[m>>2]));v=ea(u+ea(p*ea(g[m+16>>2])));u=ea(v+ea(q*ea(g[m+32>>2])));v=ea(o*ea(g[m+4>>2]));w=ea(v+ea(p*ea(g[m+20>>2])));v=ea(w+ea(q*ea(g[m+36>>2])));w=ea(o*ea(g[m+8>>2]));o=ea(w+ea(p*ea(g[m+24>>2])));p=ea(r+u);u=ea(s+v);v=ea(t+ea(o+ea(q*ea(g[m+40>>2]))));m=c[a+12>>2]|0;a=c[540320+(d<<4)>>2]|0;b=c[540324+(d<<4)>>2]|0;n=c[540328+(d<<4)>>2]|0;d=m+144|0;c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];q=ea(g[m+144>>2]);o=ea(g[m+148>>2]);t=ea(-o);o=ea(-ea(g[m+152>>2]));g[k>>2]=ea(-q);g[k+4>>2]=t;g[k+8>>2]=o;g[k+12>>2]=ea(0.0);o=ea(g[((a|0)==0?k:l)>>2]);t=ea(g[((b|0)==0?k:l)+4>>2]);q=ea(g[((n|0)==0?k:l)+8>>2]);g[e>>2]=p;g[e+4>>2]=u;g[e+8>>2]=v;g[e+12>>2]=ea(0.0);g[f>>2]=o;g[f+4>>2]=t;g[f+8>>2]=q;g[f+12>>2]=ea(0.0);s=ea(u-t);t=ea(v-q);g[h>>2]=ea(p-o);g[h+4>>2]=s;g[h+8>>2]=t;g[h+12>>2]=ea(0.0);i=j;return}function yyb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im;h=i;i=i+64|0;j=h+48|0;k=h+32|0;l=h+16|0;m=h;n=c[a+8>>2]|0;o=ea(g[b>>2]);p=b+4|0;q=ea(g[p>>2]);r=b+8|0;s=ea(-q);q=ea(-ea(g[r>>2]));g[m>>2]=ea(-o);g[m+4>>2]=s;g[m+8>>2]=q;g[m+12>>2]=ea(0.0);IFb(l,n,m,c[a+16>>2]|0);m=c[a+12>>2]|0;q=ea(g[b>>2]);s=ea(g[p>>2]);p=q>ea(0.0);b=s>ea(0.0);a=ea(g[r>>2])>ea(0.0);r=m+144|0;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];s=ea(g[m+144>>2]);q=ea(g[m+148>>2]);o=ea(-q);q=ea(-ea(g[m+152>>2]));g[j>>2]=ea(-s);g[j+4>>2]=o;g[j+8>>2]=q;g[j+12>>2]=ea(0.0);q=ea(g[(p?k:j)>>2]);o=ea(g[(b?k:j)+4>>2]);s=ea(g[(a?k:j)+8>>2]);c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];g[e>>2]=q;g[e+4>>2]=o;g[e+8>>2]=s;g[e+12>>2]=ea(0.0);t=ea(g[l>>2]);u=ea(g[l+4>>2]);v=ea(u-o);o=ea(ea(g[l+8>>2])-s);g[f>>2]=ea(t-q);g[f+4>>2]=v;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);i=h;return}function zyb(a,b){a=a|0;b=b|0;var d=0;d=(c[b+16>>2]|0)+48|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function Ayb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im;e=c[a+4>>2]|0;a=c[e+200>>2]|0;f=ea(g[a+(b*12|0)>>2]);h=ea(g[a+(b*12|0)+4>>2]);i=ea(g[a+(b*12|0)+8>>2]);j=ea(f*ea(g[e+96>>2]));k=ea(j+ea(h*ea(g[e+112>>2])));j=ea(k+ea(i*ea(g[e+128>>2])));k=ea(f*ea(g[e+100>>2]));l=ea(k+ea(h*ea(g[e+116>>2])));k=ea(l+ea(i*ea(g[e+132>>2])));l=ea(f*ea(g[e+104>>2]));f=ea(l+ea(h*ea(g[e+120>>2])));h=ea(f+ea(i*ea(g[e+136>>2])));g[d>>2]=j;g[d+4>>2]=k;g[d+8>>2]=h;g[d+12>>2]=ea(0.0);return}function Byb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;HFb(a,c[b+4>>2]|0,d);i=e;return}function Cyb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;HFb(a,c[b+4>>2]|0,d);i=e;return}function Dyb(a){a=a|0;return}function Eyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Fyb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;e=c[a+8>>2]|0;f=c[a+4>>2]|0;a=c[f+200>>2]|0;h=ea(g[a+(b*12|0)>>2]);i=ea(g[a+(b*12|0)+4>>2]);j=ea(g[a+(b*12|0)+8>>2]);k=ea(h*ea(g[f+96>>2]));l=ea(k+ea(i*ea(g[f+112>>2])));k=ea(l+ea(j*ea(g[f+128>>2])));l=ea(h*ea(g[f+100>>2]));m=ea(l+ea(i*ea(g[f+116>>2])));l=ea(m+ea(j*ea(g[f+132>>2])));m=ea(h*ea(g[f+104>>2]));h=ea(m+ea(i*ea(g[f+120>>2])));i=ea(h+ea(j*ea(g[f+136>>2])));j=ea(g[e+48>>2]);h=ea(g[e+52>>2]);m=ea(g[e+56>>2]);n=ea(k*ea(g[e>>2]));o=ea(n+ea(l*ea(g[e+16>>2])));n=ea(o+ea(i*ea(g[e+32>>2])));o=ea(k*ea(g[e+4>>2]));p=ea(o+ea(l*ea(g[e+20>>2])));o=ea(p+ea(i*ea(g[e+36>>2])));p=ea(k*ea(g[e+8>>2]));k=ea(p+ea(l*ea(g[e+24>>2])));l=ea(h+o);o=ea(m+ea(k+ea(i*ea(g[e+40>>2]))));g[d>>2]=ea(j+n);g[d+4>>2]=l;g[d+8>>2]=o;g[d+12>>2]=ea(0.0);return}function Gyb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[b+4>>2]|0;k=c[b+8>>2]|0;l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(l*ea(g[k>>2]));d=k+4|0;p=ea(o+ea(m*ea(g[d>>2])));b=k+8|0;o=ea(p+ea(n*ea(g[b>>2])));q=k+16|0;p=ea(l*ea(g[q>>2]));r=k+20|0;s=ea(p+ea(m*ea(g[r>>2])));t=k+24|0;p=ea(s+ea(n*ea(g[t>>2])));u=k+32|0;s=ea(l*ea(g[u>>2]));v=k+36|0;l=ea(s+ea(m*ea(g[v>>2])));w=k+40|0;m=ea(l+ea(n*ea(g[w>>2])));g[f>>2]=o;g[f+4>>2]=p;g[f+8>>2]=m;g[f+12>>2]=ea(0.0);HFb(h,j,f);m=ea(g[k+48>>2]);p=ea(g[k+52>>2]);o=ea(g[k+56>>2]);n=ea(g[h>>2]);l=ea(g[h+4>>2]);s=ea(g[h+8>>2]);x=ea(n*ea(g[k>>2]));y=ea(x+ea(l*ea(g[q>>2])));x=ea(y+ea(s*ea(g[u>>2])));y=ea(n*ea(g[d>>2]));z=ea(y+ea(l*ea(g[r>>2])));y=ea(z+ea(s*ea(g[v>>2])));z=ea(n*ea(g[b>>2]));n=ea(z+ea(l*ea(g[t>>2])));l=ea(p+y);y=ea(o+ea(n+ea(s*ea(g[w>>2]))));g[a>>2]=ea(m+x);g[a+4>>2]=l;g[a+8>>2]=y;g[a+12>>2]=ea(0.0);i=e;return}function Hyb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[b+4>>2]|0;k=c[b+8>>2]|0;l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(l*ea(g[k>>2]));d=k+4|0;p=ea(o+ea(m*ea(g[d>>2])));b=k+8|0;o=ea(p+ea(n*ea(g[b>>2])));q=k+16|0;p=ea(l*ea(g[q>>2]));r=k+20|0;s=ea(p+ea(m*ea(g[r>>2])));t=k+24|0;p=ea(s+ea(n*ea(g[t>>2])));u=k+32|0;s=ea(l*ea(g[u>>2]));v=k+36|0;l=ea(s+ea(m*ea(g[v>>2])));w=k+40|0;m=ea(l+ea(n*ea(g[w>>2])));g[f>>2]=o;g[f+4>>2]=p;g[f+8>>2]=m;g[f+12>>2]=ea(0.0);HFb(h,j,f);m=ea(g[k+48>>2]);p=ea(g[k+52>>2]);o=ea(g[k+56>>2]);n=ea(g[h>>2]);l=ea(g[h+4>>2]);s=ea(g[h+8>>2]);x=ea(n*ea(g[k>>2]));y=ea(x+ea(l*ea(g[q>>2])));x=ea(y+ea(s*ea(g[u>>2])));y=ea(n*ea(g[d>>2]));z=ea(y+ea(l*ea(g[r>>2])));y=ea(z+ea(s*ea(g[v>>2])));z=ea(n*ea(g[b>>2]));n=ea(z+ea(l*ea(g[t>>2])));l=ea(p+y);y=ea(o+ea(n+ea(s*ea(g[w>>2]))));g[a>>2]=ea(m+x);g[a+4>>2]=l;g[a+8>>2]=y;g[a+12>>2]=ea(0.0);i=e;return}function Iyb(a){a=a|0;return}function Jyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Kyb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[a+8>>2]|0;k=c[a+4>>2]|0;a=c[540320+(b<<4)>>2]|0;l=c[540324+(b<<4)>>2]|0;m=c[540328+(b<<4)>>2]|0;b=k+144|0;c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];n=ea(g[k+144>>2]);o=ea(g[k+148>>2]);p=ea(-o);o=ea(-ea(g[k+152>>2]));g[f>>2]=ea(-n);g[f+4>>2]=p;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);o=ea(g[((a|0)==0?f:h)>>2]);p=ea(g[((l|0)==0?f:h)+4>>2]);n=ea(g[((m|0)==0?f:h)+8>>2]);q=ea(g[j+48>>2]);r=ea(g[j+52>>2]);s=ea(g[j+56>>2]);t=ea(o*ea(g[j>>2]));u=ea(t+ea(p*ea(g[j+16>>2])));t=ea(u+ea(n*ea(g[j+32>>2])));u=ea(o*ea(g[j+4>>2]));v=ea(u+ea(p*ea(g[j+20>>2])));u=ea(v+ea(n*ea(g[j+36>>2])));v=ea(o*ea(g[j+8>>2]));o=ea(v+ea(p*ea(g[j+24>>2])));p=ea(r+u);u=ea(s+ea(o+ea(n*ea(g[j+40>>2]))));g[d>>2]=ea(q+t);g[d+4>>2]=p;g[d+8>>2]=u;g[d+12>>2]=ea(0.0);i=e;return}function Lyb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[b+4>>2]|0;k=c[b+8>>2]|0;l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(g[k>>2]);p=ea(l*o);q=ea(g[k+4>>2]);r=ea(p+ea(m*q));p=ea(g[k+8>>2]);s=ea(r+ea(n*p));r=ea(g[k+16>>2]);t=ea(l*r);u=ea(g[k+20>>2]);v=ea(t+ea(m*u));t=ea(g[k+24>>2]);w=ea(v+ea(n*t));v=ea(g[k+32>>2]);x=ea(l*v);l=ea(g[k+36>>2]);y=ea(x+ea(m*l));m=ea(g[k+40>>2]);d=s>ea(0.0);b=w>ea(0.0);z=ea(y+ea(n*m))>ea(0.0);A=j+144|0;c[h+0>>2]=c[A+0>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[h+12>>2]=c[A+12>>2];n=ea(g[j+144>>2]);y=ea(g[j+148>>2]);w=ea(-y);y=ea(-ea(g[j+152>>2]));g[f>>2]=ea(-n);g[f+4>>2]=w;g[f+8>>2]=y;g[f+12>>2]=ea(0.0);y=ea(g[(d?h:f)>>2]);w=ea(g[(b?h:f)+4>>2]);n=ea(g[(z?h:f)+8>>2]);s=ea(g[k+48>>2]);x=ea(g[k+52>>2]);B=ea(ea(ea(ea(q*y)+ea(u*w))+ea(l*n))+x);x=ea(ea(ea(ea(p*y)+ea(t*w))+ea(m*n))+ea(g[k+56>>2]));g[a>>2]=ea(ea(ea(ea(o*y)+ea(r*w))+ea(v*n))+s);g[a+4>>2]=B;g[a+8>>2]=x;g[a+12>>2]=ea(0.0);i=e;return}function Myb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[b+4>>2]|0;k=c[b+8>>2]|0;l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(g[k>>2]);p=ea(l*o);q=ea(g[k+4>>2]);r=ea(p+ea(m*q));p=ea(g[k+8>>2]);s=ea(r+ea(n*p));r=ea(g[k+16>>2]);t=ea(l*r);u=ea(g[k+20>>2]);v=ea(t+ea(m*u));t=ea(g[k+24>>2]);w=ea(v+ea(n*t));v=ea(g[k+32>>2]);x=ea(l*v);l=ea(g[k+36>>2]);y=ea(x+ea(m*l));m=ea(g[k+40>>2]);d=s>ea(0.0);b=w>ea(0.0);z=ea(y+ea(n*m))>ea(0.0);A=j+144|0;c[h+0>>2]=c[A+0>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[h+12>>2]=c[A+12>>2];n=ea(g[j+144>>2]);y=ea(g[j+148>>2]);w=ea(-y);y=ea(-ea(g[j+152>>2]));g[f>>2]=ea(-n);g[f+4>>2]=w;g[f+8>>2]=y;g[f+12>>2]=ea(0.0);y=ea(g[(d?h:f)>>2]);w=ea(g[(b?h:f)+4>>2]);n=ea(g[(z?h:f)+8>>2]);s=ea(g[k+48>>2]);x=ea(g[k+52>>2]);B=ea(ea(ea(ea(q*y)+ea(u*w))+ea(l*n))+x);x=ea(ea(ea(ea(p*y)+ea(t*w))+ea(m*n))+ea(g[k+56>>2]));g[a>>2]=ea(ea(ea(ea(o*y)+ea(r*w))+ea(v*n))+s);g[a+4>>2]=B;g[a+8>>2]=x;g[a+12>>2]=ea(0.0);i=e;return}function Nyb(a){a=a|0;return}function Oyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Pyb(a){a=a|0;return}function Qyb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ryb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0;f=i;i=i+112|0;h=f+76|0;j=f+48|0;k=f+36|0;l=f+24|0;m=f+12|0;n=f;if(a[b+68>>0]|0){if(!d){o=1;i=f;return o|0}p=b+60|0;q=b+52|0;r=b+64|0;s=b+56|0;t=b+48|0;u=e;v=d;while(1){v=v+-1|0;w=c[u>>2]|0;x=c[p>>2]|0;if(x>>>0>=(c[q>>2]|0)>>>0)break;y=c[r>>2]|0;if(y>>>0<(c[s>>2]|0)>>>0)c[r>>2]=y+1;else{c[p>>2]=x+1;c[(c[t>>2]|0)+(x<<2)>>2]=w}if(!v){o=1;z=19;break}else u=u+4|0}if((z|0)==19){i=f;return o|0}a[b+69>>0]=1;o=0;i=f;return o|0}A=ea(g[b+32>>2]);B=ea(g[b+36>>2]);C=ea(g[b+40>>2]);D=ea(g[b+44>>2]);E=ea(g[b+8>>2]);F=ea(g[b+12>>2]);G=ea(g[b+16>>2]);if(!d){o=1;i=f;return o|0}u=b+4|0;v=j+4|0;t=j+8|0;p=j+12|0;r=j+16|0;s=j+20|0;q=j+24|0;w=h+4|0;x=h+8|0;H=ea(ea(D*D)+ea(-.5));y=k+4|0;I=k+8|0;J=h+12|0;K=h+16|0;L=h+20|0;M=l+4|0;N=l+8|0;O=h+24|0;P=h+28|0;Q=h+32|0;R=m+4|0;S=m+8|0;T=n+4|0;U=n+8|0;V=b+20|0;W=b+60|0;X=b+52|0;Y=b+64|0;Z=b+56|0;_=b+48|0;$=0;a:while(1){aa=c[u>>2]|0;g[j>>2]=ea(0.0);g[v>>2]=ea(0.0);g[t>>2]=ea(0.0);g[p>>2]=ea(1.0);g[r>>2]=ea(0.0);g[s>>2]=ea(0.0);g[q>>2]=ea(0.0);ba=e+($<<2)|0;LRa(aa,j,h,0,0,c[ba>>2]|0,0,0)|0;ca=ea(ea(g[h>>2])-E);da=ea(ea(g[w>>2])-F);fa=ea(ca*ea(2.0));ca=ea(da*ea(2.0));da=ea(ea(ea(g[x>>2])-G)*ea(2.0));ga=ea(ea(ea(A*fa)+ea(B*ca))+ea(C*da));ha=ea(ea(B*ga)+ea(ea(H*ca)-ea(D*ea(ea(C*fa)-ea(A*da)))));ia=ea(ea(ea(H*da)-ea(D*ea(ea(A*ca)-ea(B*fa))))+ea(C*ga));g[k>>2]=ea(ea(A*ga)+ea(ea(H*fa)-ea(D*ea(ea(B*da)-ea(C*ca)))));g[y>>2]=ha;g[I>>2]=ia;ia=ea(ea(g[J>>2])-E);ha=ea(ea(g[K>>2])-F);ca=ea(ia*ea(2.0));ia=ea(ha*ea(2.0));ha=ea(ea(ea(g[L>>2])-G)*ea(2.0));da=ea(ea(ea(A*ca)+ea(B*ia))+ea(C*ha));fa=ea(ea(B*da)+ea(ea(H*ia)-ea(D*ea(ea(C*ca)-ea(A*ha)))));ga=ea(ea(ea(H*ha)-ea(D*ea(ea(A*ia)-ea(B*ca))))+ea(C*da));g[l>>2]=ea(ea(A*da)+ea(ea(H*ca)-ea(D*ea(ea(B*ha)-ea(C*ia)))));g[M>>2]=fa;g[N>>2]=ga;ga=ea(ea(g[O>>2])-E);fa=ea(ea(g[P>>2])-F);ia=ea(ga*ea(2.0));ga=ea(fa*ea(2.0));fa=ea(ea(ea(g[Q>>2])-G)*ea(2.0));ha=ea(ea(ea(A*ia)+ea(B*ga))+ea(C*fa));ca=ea(ea(B*ha)+ea(ea(H*ga)-ea(D*ea(ea(C*ia)-ea(A*fa)))));da=ea(ea(ea(H*fa)-ea(D*ea(ea(A*ga)-ea(B*ia))))+ea(C*ha));g[m>>2]=ea(ea(A*ha)+ea(ea(H*ia)-ea(D*ea(ea(B*fa)-ea(C*ga)))));g[R>>2]=ca;g[S>>2]=da;g[n>>2]=ea(0.0);g[T>>2]=ea(0.0);g[U>>2]=ea(0.0);do if(XPa(n,V,k,l,m)|0){aa=c[ba>>2]|0;ja=c[W>>2]|0;if(ja>>>0>=(c[X>>2]|0)>>>0)break a;ka=c[Y>>2]|0;if(ka>>>0<(c[Z>>2]|0)>>>0){c[Y>>2]=ka+1;break}else{c[W>>2]=ja+1;c[(c[_>>2]|0)+(ja<<2)>>2]=aa;break}}while(0);$=$+1|0;if($>>>0>=d>>>0){o=1;z=19;break}}if((z|0)==19){i=f;return o|0}a[b+69>>0]=1;o=0;i=f;return o|0}function Syb(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=0,Ha=Im,Ia=0,Ja=Im,Ka=Im,La=0,Ma=Im,Na=0,Oa=Im,Pa=Im,Qa=0,Ra=Im,Sa=0,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=0;k=i;i=i+176|0;l=k+96|0;m=k+80|0;n=k+32|0;o=k+64|0;p=k+16|0;q=k;r=k+48|0;s=k+160|0;c[l>>2]=0;c[l+4>>2]=0;t=l+8|0;c[t>>2]=-1;u=l+12|0;b[u>>1]=0;v=l+16|0;w=l+40|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;g[w>>2]=ea(3402823469999999843913219.0e14);x=l+44|0;g[x>>2]=ea(0.0);y=l+48|0;g[y>>2]=ea(0.0);if(!f){z=1;i=k;return z|0}A=d+16|0;B=d+20|0;C=d+24|0;D=m+4|0;E=m+8|0;F=d+192|0;G=d+196|0;H=d+200|0;I=p+4|0;J=p+8|0;K=p+12|0;L=q+4|0;M=q+8|0;N=q+12|0;O=d+208|0;P=d+224|0;Q=d+64|0;R=d+181|0;S=d+12|0;T=d+108|0;U=d+68|0;V=d+80|0;W=d+84|0;X=l+20|0;Y=d+88|0;Z=l+24|0;_=d+92|0;$=l+28|0;aa=d+96|0;ba=l+32|0;ca=d+100|0;da=l+36|0;fa=d+104|0;ga=d+112|0;ha=d+132|0;ia=d+136|0;ja=d+140|0;ka=d+144|0;la=d+148|0;ma=d+152|0;na=d+156|0;oa=d+160|0;pa=d+164|0;qa=d+168|0;ra=d+172|0;sa=d+176|0;ta=d+180|0;d=0;a:while(1){ua=c[h+(d<<2)>>2]|0;va=(ua>>>1&15)+1|0;wa=ua>>>5;ua=0;do{xa=ua+wa|0;ya=c[c[B>>2]>>2]|0;if(!(c[A>>2]|0)){za=ya+(xa*12|0)|0;Aa=c[za>>2]|0;Ba=c[za+4>>2]|0;Ca=c[za+8>>2]|0}else{za=ya+(xa*6|0)|0;Aa=e[za>>1]|0;Ba=e[za+2>>1]|0;Ca=e[za+4>>1]|0}za=c[c[C>>2]>>2]|0;ya=za+(Aa*12|0)|0;Da=za+(Ba*12|0)|0;Ea=za+(Ca*12|0)|0;c[m>>2]=Aa;c[D>>2]=Ba;c[E>>2]=Ca;Fa=ea(g[ya>>2]);Ga=za+(Aa*12|0)+4|0;Ha=ea(g[Ga>>2]);Ia=za+(Aa*12|0)+8|0;Ja=ea(g[Ia>>2]);Ka=ea(g[Da>>2]);La=za+(Ba*12|0)+4|0;Ma=ea(g[La>>2]);Na=za+(Ba*12|0)+8|0;Oa=ea(g[Na>>2]);Pa=ea(g[Ea>>2]);Qa=za+(Ca*12|0)+4|0;Ra=ea(g[Qa>>2]);Sa=za+(Ca*12|0)+8|0;Ta=ea(g[Sa>>2]);Ua=Fa<Ka?Fa:Ka;Va=Ha<Ma?Ha:Ma;Wa=Ja<Oa?Ja:Oa;Xa=Fa>Ka?Fa:Ka;Ka=Ha>Ma?Ha:Ma;Ma=Ja>Oa?Ja:Oa;Oa=ea(g[F>>2]);Ja=ea(g[G>>2]);Ha=ea(g[H>>2]);Fa=ea((Va<Ra?Va:Ra)-Ja);Va=ea((Wa<Ta?Wa:Ta)-Ha);g[p>>2]=ea((Ua<Pa?Ua:Pa)-Oa);g[I>>2]=Fa;g[J>>2]=Va;g[K>>2]=ea(0.0);Va=ea((Ka>Ra?Ka:Ra)+Ja);Ja=ea((Ma>Ta?Ma:Ta)+Ha);g[q>>2]=ea((Xa>Pa?Xa:Pa)+Oa);g[L>>2]=Va;g[M>>2]=Ja;g[N>>2]=ea(0.0);g[r>>2]=ea(g[Q>>2]);if(SPa(p,q,O,P,r,n,o)|0){Ja=ea(g[Q>>2]);g[w>>2]=Ja;g[y>>2]=ea(0.0);g[x>>2]=ea(0.0);c[t>>2]=xa;b[u>>1]=5;if(!(a[R>>0]|0)){g[s>>2]=ea(g[j>>2]);xa=c[S>>2]|0;if(!(gn[c[c[xa>>2]>>2]&127](xa,l,ya,Da,Ea,s,m)|0)){z=0;Ya=17;break a}Va=ea(g[s>>2]);if(Va<ea(g[j>>2])){g[j>>2]=Va;g[Q>>2]=Va}}else if(Ja<ea(g[T>>2])){c[U+0>>2]=c[l+0>>2];c[U+4>>2]=c[l+4>>2];c[U+8>>2]=c[l+8>>2];b[V>>1]=5;g[W>>2]=ea(g[v>>2]);g[Y>>2]=ea(g[X>>2]);g[_>>2]=ea(g[Z>>2]);g[aa>>2]=ea(g[$>>2]);g[ca>>2]=ea(g[ba>>2]);g[fa>>2]=ea(g[da>>2]);g[T>>2]=Ja;c[ga+0>>2]=c[x+0>>2];c[ga+4>>2]=c[x+4>>2];c[ga+8>>2]=c[x+8>>2];c[ga+12>>2]=c[x+12>>2];c[ga+16>>2]=c[x+16>>2];Va=ea(g[j>>2]);g[j>>2]=Ja<Va?Ja:Va;g[ha>>2]=ea(g[ya>>2]);g[ia>>2]=ea(g[Ga>>2]);g[ja>>2]=ea(g[Ia>>2]);g[ka>>2]=ea(g[Da>>2]);g[la>>2]=ea(g[La>>2]);g[ma>>2]=ea(g[Na>>2]);g[na>>2]=ea(g[Ea>>2]);g[oa>>2]=ea(g[Qa>>2]);g[pa>>2]=ea(g[Sa>>2]);c[qa>>2]=c[m>>2];c[ra>>2]=c[D>>2];c[sa>>2]=c[E>>2];a[ta>>0]=1}if(!(c[(c[S>>2]|0)+4>>2]|0)){z=0;Ya=17;break a}}ua=ua+1|0}while(ua>>>0<va>>>0);d=d+1|0;if(d>>>0>=f>>>0){z=1;Ya=17;break}}if((Ya|0)==17){i=k;return z|0}return 0}function Tyb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542384;c[b+4>>2]=542408;if(!(a[b+180>>0]|0)){i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;i=d;return}function Uyb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542384;c[b+4>>2]=542408;if(!(a[b+180>>0]|0)){ACi(b);i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;ACi(b);i=d;return}function Vyb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=Syb(a,b,c,d)|0;i=d;return e|0}function Wyb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=Syb(a+-4|0,b,c,d)|0;i=d;return e|0}function Xyb(a){a=a|0;return}function Yyb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542384;c[e+4>>2]=542408;if(!(a[e+180>>0]|0)){i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;i=d;return}function Zyb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542384;c[e+4>>2]=542408;if(!(a[e+180>>0]|0)){ACi(e);i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;ACi(e);i=d;return}function _yb(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=0,ra=Im;k=i;i=i+80|0;l=k+16|0;m=k+4|0;n=k;c[l>>2]=0;c[l+4>>2]=0;o=l+8|0;c[o>>2]=-1;p=l+12|0;b[p>>1]=0;q=l+16|0;r=l+40|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;g[r>>2]=ea(3402823469999999843913219.0e14);s=l+44|0;g[s>>2]=ea(0.0);g[l+48>>2]=ea(0.0);if(!f){t=1;i=k;return t|0}u=d+16|0;v=d+20|0;w=d+24|0;x=m+4|0;y=m+8|0;z=d+32|0;A=d+64|0;B=d+181|0;C=d+12|0;D=d+108|0;E=d+68|0;F=d+80|0;G=d+84|0;H=l+20|0;I=d+88|0;J=l+24|0;K=d+92|0;L=l+28|0;M=d+96|0;N=l+32|0;O=d+100|0;P=l+36|0;Q=d+104|0;R=d+112|0;S=d+132|0;T=d+136|0;U=d+140|0;V=d+144|0;W=d+148|0;X=d+152|0;Y=d+156|0;Z=d+160|0;_=d+164|0;$=d+168|0;aa=d+172|0;ba=d+176|0;ca=d+180|0;d=0;a:while(1){da=c[h+(d<<2)>>2]|0;fa=(da>>>1&15)+1|0;ga=da>>>5;da=0;do{ha=da+ga|0;ia=c[c[v>>2]>>2]|0;if(!(c[u>>2]|0)){ja=ia+(ha*12|0)|0;ka=c[ja>>2]|0;la=c[ja+4>>2]|0;ma=c[ja+8>>2]|0}else{ja=ia+(ha*6|0)|0;ka=e[ja>>1]|0;la=e[ja+2>>1]|0;ma=e[ja+4>>1]|0}ja=c[c[w>>2]>>2]|0;ia=ja+(ka*12|0)|0;na=ja+(la*12|0)|0;oa=ja+(ma*12|0)|0;c[m>>2]=ka;c[x>>2]=la;c[y>>2]=ma;if((ZGb(z,ia,na,oa,l)|0)!=0?(pa=ea(g[r>>2]),pa<=ea(g[A>>2])):0){c[o>>2]=ha;b[p>>1]=5;if(!(a[B>>0]|0)){g[n>>2]=ea(g[j>>2]);ha=c[C>>2]|0;if(!(gn[c[c[ha>>2]>>2]&127](ha,l,ia,na,oa,n,m)|0)){t=0;qa=18;break a}ra=ea(g[n>>2]);if(ra<ea(g[j>>2])){g[j>>2]=ra;g[A>>2]=ra}}else if(pa<ea(g[D>>2])){c[E+0>>2]=c[l+0>>2];c[E+4>>2]=c[l+4>>2];c[E+8>>2]=c[l+8>>2];b[F>>1]=5;g[G>>2]=ea(g[q>>2]);g[I>>2]=ea(g[H>>2]);g[K>>2]=ea(g[J>>2]);g[M>>2]=ea(g[L>>2]);g[O>>2]=ea(g[N>>2]);g[Q>>2]=ea(g[P>>2]);g[D>>2]=pa;c[R+0>>2]=c[s+0>>2];c[R+4>>2]=c[s+4>>2];c[R+8>>2]=c[s+8>>2];c[R+12>>2]=c[s+12>>2];c[R+16>>2]=c[s+16>>2];ra=ea(g[j>>2]);g[j>>2]=pa<ra?pa:ra;g[S>>2]=ea(g[ia>>2]);g[T>>2]=ea(g[ja+(ka*12|0)+4>>2]);g[U>>2]=ea(g[ja+(ka*12|0)+8>>2]);g[V>>2]=ea(g[na>>2]);g[W>>2]=ea(g[ja+(la*12|0)+4>>2]);g[X>>2]=ea(g[ja+(la*12|0)+8>>2]);g[Y>>2]=ea(g[oa>>2]);g[Z>>2]=ea(g[ja+(ma*12|0)+4>>2]);g[_>>2]=ea(g[ja+(ma*12|0)+8>>2]);c[$>>2]=c[m>>2];c[aa>>2]=c[x>>2];c[ba>>2]=c[y>>2];a[ca>>0]=1}if(!(c[(c[C>>2]|0)+4>>2]|0)){t=0;qa=18;break a}}da=da+1|0}while(da>>>0<fa>>>0);d=d+1|0;if(d>>>0>=f>>>0){t=1;qa=18;break}}if((qa|0)==18){i=k;return t|0}return 0}function $yb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542432;c[b+4>>2]=542456;if(!(a[b+180>>0]|0)){i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;i=d;return}function azb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542432;c[b+4>>2]=542456;if(!(a[b+180>>0]|0)){ACi(b);i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;ACi(b);i=d;return}function bzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=_yb(a,b,c,d)|0;i=d;return e|0}function czb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=_yb(a+-4|0,b,c,d)|0;i=d;return e|0}function dzb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542432;c[e+4>>2]=542456;if(!(a[e+180>>0]|0)){i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;i=d;return}function ezb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542432;c[e+4>>2]=542456;if(!(a[e+180>>0]|0)){ACi(e);i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;ACi(e);i=d;return}function fzb(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im;k=i;i=i+80|0;l=k+16|0;m=k+4|0;n=k;c[l>>2]=0;c[l+4>>2]=0;o=l+8|0;c[o>>2]=-1;p=l+12|0;b[p>>1]=0;q=l+16|0;r=l+40|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;g[r>>2]=ea(3402823469999999843913219.0e14);s=l+44|0;g[s>>2]=ea(0.0);g[l+48>>2]=ea(0.0);if(!f){t=1;i=k;return t|0}u=d+16|0;v=d+20|0;w=d+24|0;x=m+4|0;y=m+8|0;z=d+181|0;A=d+12|0;B=d+64|0;C=d+108|0;D=d+68|0;E=d+80|0;F=d+84|0;G=l+20|0;H=d+88|0;I=l+24|0;J=d+92|0;K=l+28|0;L=d+96|0;M=l+32|0;N=d+100|0;O=l+36|0;P=d+104|0;Q=d+112|0;R=d+132|0;S=d+136|0;T=d+140|0;U=d+144|0;V=d+148|0;W=d+152|0;X=d+156|0;Y=d+160|0;Z=d+164|0;_=d+168|0;$=d+172|0;aa=d+176|0;ba=d+180|0;d=0;a:while(1){ca=c[h+(d<<2)>>2]|0;da=(ca>>>1&15)+1|0;fa=ca>>>5;ca=0;do{ga=ca+fa|0;ha=c[c[v>>2]>>2]|0;if(!(c[u>>2]|0)){ia=ha+(ga*12|0)|0;ja=c[ia>>2]|0;ka=c[ia+4>>2]|0;la=c[ia+8>>2]|0}else{ia=ha+(ga*6|0)|0;ja=e[ia>>1]|0;ka=e[ia+2>>1]|0;la=e[ia+4>>1]|0}ia=c[c[w>>2]>>2]|0;ha=ia+(ja*12|0)|0;ma=ia+(ka*12|0)|0;na=ia+(la*12|0)|0;c[m>>2]=ja;c[x>>2]=ka;c[y>>2]=la;c[o>>2]=ga;b[p>>1]=5;if(!(a[z>>0]|0)){g[n>>2]=ea(g[j>>2]);ga=c[A>>2]|0;if(!(gn[c[c[ga>>2]>>2]&127](ga,l,ha,ma,na,n,m)|0)){t=0;oa=16;break a}pa=ea(g[n>>2]);if(pa<ea(g[j>>2])){g[j>>2]=pa;g[B>>2]=pa}}else{pa=ea(g[r>>2]);if(pa<ea(g[C>>2])){c[D+0>>2]=c[l+0>>2];c[D+4>>2]=c[l+4>>2];c[D+8>>2]=c[l+8>>2];b[E>>1]=5;g[F>>2]=ea(g[q>>2]);g[H>>2]=ea(g[G>>2]);g[J>>2]=ea(g[I>>2]);g[L>>2]=ea(g[K>>2]);g[N>>2]=ea(g[M>>2]);g[P>>2]=ea(g[O>>2]);g[C>>2]=pa;c[Q+0>>2]=c[s+0>>2];c[Q+4>>2]=c[s+4>>2];c[Q+8>>2]=c[s+8>>2];c[Q+12>>2]=c[s+12>>2];c[Q+16>>2]=c[s+16>>2];qa=ea(g[j>>2]);g[j>>2]=pa<qa?pa:qa;g[R>>2]=ea(g[ha>>2]);g[S>>2]=ea(g[ia+(ja*12|0)+4>>2]);g[T>>2]=ea(g[ia+(ja*12|0)+8>>2]);g[U>>2]=ea(g[ma>>2]);g[V>>2]=ea(g[ia+(ka*12|0)+4>>2]);g[W>>2]=ea(g[ia+(ka*12|0)+8>>2]);g[X>>2]=ea(g[na>>2]);g[Y>>2]=ea(g[ia+(la*12|0)+4>>2]);g[Z>>2]=ea(g[ia+(la*12|0)+8>>2]);c[_>>2]=ja;c[$>>2]=ka;c[aa>>2]=la;a[ba>>0]=1}}ca=ca+1|0;if(!(c[(c[A>>2]|0)+4>>2]|0)){t=0;oa=16;break a}}while(ca>>>0<da>>>0);d=d+1|0;if(d>>>0>=f>>>0){t=1;oa=16;break}}if((oa|0)==16){i=k;return t|0}return 0}function gzb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542480;c[b+4>>2]=542504;if(!(a[b+180>>0]|0)){i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;i=d;return}function hzb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542480;c[b+4>>2]=542504;if(!(a[b+180>>0]|0)){ACi(b);i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;ACi(b);i=d;return}function izb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=fzb(a,b,c,d)|0;i=d;return e|0}function jzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=fzb(a+-4|0,b,c,d)|0;i=d;return e|0}function kzb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542480;c[e+4>>2]=542504;if(!(a[e+180>>0]|0)){i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;i=d;return}function lzb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542480;c[e+4>>2]=542504;if(!(a[e+180>>0]|0)){ACi(e);i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;ACi(e);i=d;return}function mzb(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im;k=i;i=i+80|0;l=k+16|0;m=k+4|0;n=k;c[l>>2]=0;c[l+4>>2]=0;o=l+8|0;c[o>>2]=-1;p=l+12|0;b[p>>1]=0;q=l+16|0;r=l+40|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;g[r>>2]=ea(3402823469999999843913219.0e14);s=l+44|0;g[s>>2]=ea(0.0);g[l+48>>2]=ea(0.0);if(!f){t=1;i=k;return t|0}u=d+16|0;v=d+20|0;w=d+24|0;x=m+4|0;y=m+8|0;z=d+181|0;A=d+12|0;B=d+64|0;C=d+108|0;D=d+68|0;E=d+80|0;F=d+84|0;G=l+20|0;H=d+88|0;I=l+24|0;J=d+92|0;K=l+28|0;L=d+96|0;M=l+32|0;N=d+100|0;O=l+36|0;P=d+104|0;Q=d+112|0;R=d+132|0;S=d+136|0;T=d+140|0;U=d+144|0;V=d+148|0;W=d+152|0;X=d+156|0;Y=d+160|0;Z=d+164|0;_=d+168|0;$=d+172|0;aa=d+176|0;ba=d+180|0;d=0;a:while(1){ca=c[h+(d<<2)>>2]|0;da=(ca>>>1&15)+1|0;fa=ca>>>5;ca=0;do{ga=ca+fa|0;ha=c[c[v>>2]>>2]|0;if(!(c[u>>2]|0)){ia=ha+(ga*12|0)|0;ja=c[ia>>2]|0;ka=c[ia+4>>2]|0;la=c[ia+8>>2]|0}else{ia=ha+(ga*6|0)|0;ja=e[ia>>1]|0;ka=e[ia+2>>1]|0;la=e[ia+4>>1]|0}ia=c[c[w>>2]>>2]|0;ha=ia+(ja*12|0)|0;ma=ia+(ka*12|0)|0;na=ia+(la*12|0)|0;c[m>>2]=ja;c[x>>2]=ka;c[y>>2]=la;c[o>>2]=ga;b[p>>1]=5;if(!(a[z>>0]|0)){g[n>>2]=ea(g[j>>2]);ga=c[A>>2]|0;if(!(gn[c[c[ga>>2]>>2]&127](ga,l,ha,ma,na,n,m)|0)){t=0;oa=16;break a}pa=ea(g[n>>2]);if(pa<ea(g[j>>2])){g[j>>2]=pa;g[B>>2]=pa}}else{pa=ea(g[r>>2]);if(pa<ea(g[C>>2])){c[D+0>>2]=c[l+0>>2];c[D+4>>2]=c[l+4>>2];c[D+8>>2]=c[l+8>>2];b[E>>1]=5;g[F>>2]=ea(g[q>>2]);g[H>>2]=ea(g[G>>2]);g[J>>2]=ea(g[I>>2]);g[L>>2]=ea(g[K>>2]);g[N>>2]=ea(g[M>>2]);g[P>>2]=ea(g[O>>2]);g[C>>2]=pa;c[Q+0>>2]=c[s+0>>2];c[Q+4>>2]=c[s+4>>2];c[Q+8>>2]=c[s+8>>2];c[Q+12>>2]=c[s+12>>2];c[Q+16>>2]=c[s+16>>2];qa=ea(g[j>>2]);g[j>>2]=pa<qa?pa:qa;g[R>>2]=ea(g[ha>>2]);g[S>>2]=ea(g[ia+(ja*12|0)+4>>2]);g[T>>2]=ea(g[ia+(ja*12|0)+8>>2]);g[U>>2]=ea(g[ma>>2]);g[V>>2]=ea(g[ia+(ka*12|0)+4>>2]);g[W>>2]=ea(g[ia+(ka*12|0)+8>>2]);g[X>>2]=ea(g[na>>2]);g[Y>>2]=ea(g[ia+(la*12|0)+4>>2]);g[Z>>2]=ea(g[ia+(la*12|0)+8>>2]);c[_>>2]=ja;c[$>>2]=ka;c[aa>>2]=la;a[ba>>0]=1}}ca=ca+1|0;if(!(c[(c[A>>2]|0)+4>>2]|0)){t=0;oa=16;break a}}while(ca>>>0<da>>>0);d=d+1|0;if(d>>>0>=f>>>0){t=1;oa=16;break}}if((oa|0)==16){i=k;return t|0}return 0}function nzb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542528;c[b+4>>2]=542552;if(!(a[b+180>>0]|0)){i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;i=d;return}function ozb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=542528;c[b+4>>2]=542552;if(!(a[b+180>>0]|0)){ACi(b);i=d;return}e=c[b+12>>2]|0;gn[c[c[e>>2]>>2]&127](e,b+68|0,b+132|0,b+144|0,b+156|0,b+64|0,b+168|0)|0;ACi(b);i=d;return}function pzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=mzb(a,b,c,d)|0;i=d;return e|0}function qzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=mzb(a+-4|0,b,c,d)|0;i=d;return e|0}function rzb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542528;c[e+4>>2]=542552;if(!(a[e+180>>0]|0)){i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;i=d;return}function szb(b){b=b|0;var d=0,e=0;d=i;e=b+-4|0;c[e>>2]=542528;c[e+4>>2]=542552;if(!(a[e+180>>0]|0)){ACi(e);i=d;return}b=c[e+12>>2]|0;gn[c[c[b>>2]>>2]&127](b,e+68|0,e+132|0,e+144|0,e+156|0,e+64|0,e+168|0)|0;ACi(e);i=d;return}function tzb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0;k=i;i=i+48|0;j=k+32|0;l=k+16|0;m=k;n=ea(g[e>>2]);o=ea(g[b+20>>2]);p=ea(n*o);q=ea(g[b+24>>2]);r=ea(n*q);s=ea(g[b+28>>2]);t=ea(n*s);n=ea(g[e+4>>2]);u=ea(g[b+32>>2]);v=ea(n*u);w=ea(g[b+36>>2]);x=ea(n*w);y=ea(g[b+40>>2]);z=ea(p+v);v=ea(r+x);x=ea(t+ea(n*y));n=ea(g[e+8>>2]);t=ea(g[b+44>>2]);r=ea(n*t);p=ea(g[b+48>>2]);A=ea(n*p);B=ea(g[b+52>>2]);C=ea(z+r);r=ea(v+A);A=ea(x+ea(n*B));n=ea(g[b+56>>2]);x=ea(C+n);C=ea(g[b+60>>2]);v=ea(r+C);r=ea(g[b+64>>2]);z=ea(A+r);g[j>>2]=x;g[j+4>>2]=v;g[j+8>>2]=z;g[j+12>>2]=ea(0.0);z=ea(g[f>>2]);v=ea(z*o);x=ea(z*q);A=ea(z*s);z=ea(g[f+4>>2]);D=ea(v+ea(z*u));v=ea(x+ea(z*w));x=ea(A+ea(z*y));z=ea(g[f+8>>2]);A=ea(ea(v+ea(z*p))+C);v=ea(ea(x+ea(z*B))+r);g[l>>2]=ea(ea(D+ea(z*t))+n);g[l+4>>2]=A;g[l+8>>2]=v;g[l+12>>2]=ea(0.0);v=ea(g[h>>2]);A=ea(v*o);o=ea(v*q);q=ea(v*s);s=ea(g[h+4>>2]);v=ea(A+ea(s*u));u=ea(o+ea(s*w));w=ea(q+ea(s*y));y=ea(g[h+8>>2]);s=ea(ea(u+ea(y*p))+C);C=ea(ea(w+ea(y*B))+r);g[m>>2]=ea(ea(v+ea(y*t))+n);g[m+4>>2]=s;g[m+8>>2]=C;g[m+12>>2]=ea(0.0);if(!(YPa(b+144|0,b+128|0,j,l,m)|0)){E=1;i=k;return E|0}a[b+68>>0]=1;m=c[b+116>>2]|0;if(!m){E=0;i=k;return E|0}b=c[d+8>>2]|0;d=m+4|0;l=c[d>>2]|0;if(l>>>0>=(c[m+8>>2]|0)>>>0){a[m+20>>0]=1;E=1;i=k;return E|0}j=m+16|0;h=c[j>>2]|0;if(h>>>0<(c[m+12>>2]|0)>>>0){c[j>>2]=h+1;E=1;i=k;return E|0}else{c[d>>2]=l+1;c[(c[m>>2]|0)+(l<<2)>>2]=b;E=1;i=k;return E|0}return 0}function uzb(a){a=a|0;return}function vzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function wzb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=0,C=0;k=i;i=i+48|0;j=k+32|0;l=k+16|0;m=k;n=c[b+16>>2]|0;o=ea(g[e>>2]);p=ea(o*ea(g[n>>2]));q=n+4|0;r=ea(o*ea(g[q>>2]));s=n+8|0;t=ea(o*ea(g[s>>2]));o=ea(g[e+4>>2]);u=n+12|0;v=ea(o*ea(g[u>>2]));w=n+16|0;x=ea(o*ea(g[w>>2]));y=n+20|0;z=ea(p+v);v=ea(r+x);x=ea(t+ea(o*ea(g[y>>2])));o=ea(g[e+8>>2]);e=n+24|0;t=ea(o*ea(g[e>>2]));A=n+28|0;r=ea(o*ea(g[A>>2]));B=n+32|0;p=ea(v+r);r=ea(x+ea(o*ea(g[B>>2])));g[j>>2]=ea(z+t);g[j+4>>2]=p;g[j+8>>2]=r;g[j+12>>2]=ea(0.0);r=ea(g[f>>2]);p=ea(r*ea(g[n>>2]));t=ea(r*ea(g[q>>2]));z=ea(r*ea(g[s>>2]));r=ea(g[f+4>>2]);o=ea(r*ea(g[u>>2]));x=ea(r*ea(g[w>>2]));v=ea(p+o);o=ea(t+x);x=ea(z+ea(r*ea(g[y>>2])));r=ea(g[f+8>>2]);z=ea(r*ea(g[e>>2]));t=ea(r*ea(g[A>>2]));p=ea(o+t);t=ea(x+ea(r*ea(g[B>>2])));g[l>>2]=ea(v+z);g[l+4>>2]=p;g[l+8>>2]=t;g[l+12>>2]=ea(0.0);t=ea(g[h>>2]);p=ea(t*ea(g[n>>2]));z=ea(t*ea(g[q>>2]));v=ea(t*ea(g[s>>2]));t=ea(g[h+4>>2]);r=ea(t*ea(g[u>>2]));x=ea(t*ea(g[w>>2]));o=ea(p+r);r=ea(z+x);x=ea(v+ea(t*ea(g[y>>2])));t=ea(g[h+8>>2]);v=ea(t*ea(g[e>>2]));z=ea(t*ea(g[A>>2]));p=ea(r+z);z=ea(x+ea(t*ea(g[B>>2])));g[m>>2]=ea(o+v);g[m+4>>2]=p;g[m+8>>2]=z;g[m+12>>2]=ea(0.0);if(!(YPa(b+144|0,b+128|0,j,l,m)|0)){C=1;i=k;return C|0}a[b+68>>0]=1;m=c[b+116>>2]|0;if(!m){C=0;i=k;return C|0}b=c[d+8>>2]|0;d=m+4|0;l=c[d>>2]|0;if(l>>>0>=(c[m+8>>2]|0)>>>0){a[m+20>>0]=1;C=1;i=k;return C|0}j=m+16|0;B=c[j>>2]|0;if(B>>>0<(c[m+12>>2]|0)>>>0){c[j>>2]=B+1;C=1;i=k;return C|0}else{c[d>>2]=l+1;c[(c[m>>2]|0)+(l<<2)>>2]=b;C=1;i=k;return C|0}return 0}function xzb(a){a=a|0;return}function yzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function zzb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=0,F=0;k=i;i=i+128|0;j=k+16|0;l=k+64|0;m=k+32|0;n=k;o=k+48|0;p=k+96|0;q=c[b+16>>2]|0;r=ea(g[e>>2]);s=ea(r*ea(g[q>>2]));t=q+4|0;u=ea(r*ea(g[t>>2]));v=q+8|0;w=ea(r*ea(g[v>>2]));r=ea(g[e+4>>2]);x=q+12|0;y=ea(r*ea(g[x>>2]));z=q+16|0;A=ea(r*ea(g[z>>2]));B=q+20|0;C=ea(s+y);y=ea(u+A);A=ea(w+ea(r*ea(g[B>>2])));r=ea(g[e+8>>2]);e=q+24|0;w=ea(r*ea(g[e>>2]));D=q+28|0;u=ea(r*ea(g[D>>2]));E=q+32|0;s=ea(y+u);u=ea(A+ea(r*ea(g[E>>2])));g[j>>2]=ea(C+w);g[j+4>>2]=s;g[j+8>>2]=u;g[j+12>>2]=ea(0.0);u=ea(g[f>>2]);s=ea(u*ea(g[q>>2]));w=ea(u*ea(g[t>>2]));C=ea(u*ea(g[v>>2]));u=ea(g[f+4>>2]);r=ea(u*ea(g[x>>2]));A=ea(u*ea(g[z>>2]));y=ea(s+r);r=ea(w+A);A=ea(C+ea(u*ea(g[B>>2])));u=ea(g[f+8>>2]);C=ea(u*ea(g[e>>2]));w=ea(u*ea(g[D>>2]));s=ea(r+w);w=ea(A+ea(u*ea(g[E>>2])));g[l>>2]=ea(y+C);g[l+4>>2]=s;g[l+8>>2]=w;g[l+12>>2]=ea(0.0);w=ea(g[h>>2]);s=ea(w*ea(g[q>>2]));C=ea(w*ea(g[t>>2]));y=ea(w*ea(g[v>>2]));w=ea(g[h+4>>2]);u=ea(w*ea(g[x>>2]));A=ea(w*ea(g[z>>2]));r=ea(s+u);u=ea(C+A);A=ea(y+ea(w*ea(g[B>>2])));w=ea(g[h+8>>2]);y=ea(w*ea(g[e>>2]));C=ea(w*ea(g[D>>2]));s=ea(u+C);C=ea(A+ea(w*ea(g[E>>2])));g[m>>2]=ea(r+y);g[m+4>>2]=s;g[m+8>>2]=C;g[m+12>>2]=ea(0.0);C=ea(g[b+88>>2]);s=ea(g[b+92>>2]);y=ea(g[b+96>>2]);g[n>>2]=C;g[n+4>>2]=s;g[n+8>>2]=y;g[n+12>>2]=ea(0.0);y=ea(g[b+100>>2]);s=ea(g[b+104>>2]);C=ea(g[b+108>>2]);g[o>>2]=y;g[o+4>>2]=s;g[o+8>>2]=C;g[o+12>>2]=ea(0.0);QOa(p,n,o,j,l,m,k+80|0,k+112|0);C=ea(g[p>>2]);if(!(C<=ea(g[b+72>>2]))){F=1;i=k;return F|0}a[b+68>>0]=1;p=c[b+116>>2]|0;if(!p){F=0;i=k;return F|0}b=c[d+8>>2]|0;d=p+4|0;m=c[d>>2]|0;if(m>>>0>=(c[p+8>>2]|0)>>>0){a[p+20>>0]=1;F=1;i=k;return F|0}l=p+16|0;j=c[l>>2]|0;if(j>>>0<(c[p+12>>2]|0)>>>0){c[l>>2]=j+1;F=1;i=k;return F|0}else{c[d>>2]=m+1;c[(c[p>>2]|0)+(m<<2)>>2]=b;F=1;i=k;return F|0}return 0}function Azb(a){a=a|0;return}function Bzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Czb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=0;k=i;i=i+128|0;j=k+16|0;l=k+64|0;m=k+32|0;n=k;o=k+48|0;p=k+96|0;q=ea(g[e>>2]);r=ea(g[e+4>>2]);s=ea(g[e+8>>2]);g[j>>2]=q;g[j+4>>2]=r;g[j+8>>2]=s;g[j+12>>2]=ea(0.0);s=ea(g[f>>2]);r=ea(g[f+4>>2]);q=ea(g[f+8>>2]);g[l>>2]=s;g[l+4>>2]=r;g[l+8>>2]=q;g[l+12>>2]=ea(0.0);q=ea(g[h>>2]);r=ea(g[h+4>>2]);s=ea(g[h+8>>2]);g[m>>2]=q;g[m+4>>2]=r;g[m+8>>2]=s;g[m+12>>2]=ea(0.0);s=ea(g[b+88>>2]);r=ea(g[b+92>>2]);q=ea(g[b+96>>2]);g[n>>2]=s;g[n+4>>2]=r;g[n+8>>2]=q;g[n+12>>2]=ea(0.0);q=ea(g[b+100>>2]);r=ea(g[b+104>>2]);s=ea(g[b+108>>2]);g[o>>2]=q;g[o+4>>2]=r;g[o+8>>2]=s;g[o+12>>2]=ea(0.0);QOa(p,n,o,j,l,m,k+80|0,k+112|0);s=ea(g[p>>2]);if(!(s<=ea(g[b+72>>2]))){t=1;i=k;return t|0}a[b+68>>0]=1;p=c[b+116>>2]|0;if(!p){t=0;i=k;return t|0}b=c[d+8>>2]|0;d=p+4|0;m=c[d>>2]|0;if(m>>>0>=(c[p+8>>2]|0)>>>0){a[p+20>>0]=1;t=1;i=k;return t|0}l=p+16|0;j=c[l>>2]|0;if(j>>>0<(c[p+12>>2]|0)>>>0){c[l>>2]=j+1;t=1;i=k;return t|0}else{c[d>>2]=m+1;c[(c[p>>2]|0)+(m<<2)>>2]=b;t=1;i=k;return t|0}return 0}function Dzb(a){a=a|0;return}function Ezb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Fzb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=0,E=0;k=i;i=i+128|0;j=k+16|0;l=k+64|0;m=k+32|0;n=k+48|0;o=k+96|0;p=c[b+16>>2]|0;q=ea(g[e>>2]);r=ea(q*ea(g[p>>2]));s=p+4|0;t=ea(q*ea(g[s>>2]));u=p+8|0;v=ea(q*ea(g[u>>2]));q=ea(g[e+4>>2]);w=p+12|0;x=ea(q*ea(g[w>>2]));y=p+16|0;z=ea(q*ea(g[y>>2]));A=p+20|0;B=ea(r+x);x=ea(t+z);z=ea(v+ea(q*ea(g[A>>2])));q=ea(g[e+8>>2]);e=p+24|0;v=ea(q*ea(g[e>>2]));C=p+28|0;t=ea(q*ea(g[C>>2]));D=p+32|0;r=ea(x+t);t=ea(z+ea(q*ea(g[D>>2])));g[j>>2]=ea(B+v);g[j+4>>2]=r;g[j+8>>2]=t;g[j+12>>2]=ea(0.0);t=ea(g[f>>2]);r=ea(t*ea(g[p>>2]));v=ea(t*ea(g[s>>2]));B=ea(t*ea(g[u>>2]));t=ea(g[f+4>>2]);q=ea(t*ea(g[w>>2]));z=ea(t*ea(g[y>>2]));x=ea(r+q);q=ea(v+z);z=ea(B+ea(t*ea(g[A>>2])));t=ea(g[f+8>>2]);B=ea(t*ea(g[e>>2]));v=ea(t*ea(g[C>>2]));r=ea(q+v);v=ea(z+ea(t*ea(g[D>>2])));g[l>>2]=ea(x+B);g[l+4>>2]=r;g[l+8>>2]=v;g[l+12>>2]=ea(0.0);v=ea(g[h>>2]);r=ea(v*ea(g[p>>2]));B=ea(v*ea(g[s>>2]));x=ea(v*ea(g[u>>2]));v=ea(g[h+4>>2]);t=ea(v*ea(g[w>>2]));z=ea(v*ea(g[y>>2]));q=ea(r+t);t=ea(B+z);z=ea(x+ea(v*ea(g[A>>2])));v=ea(g[h+8>>2]);x=ea(v*ea(g[e>>2]));B=ea(v*ea(g[C>>2]));r=ea(t+B);B=ea(z+ea(v*ea(g[D>>2])));g[m>>2]=ea(q+x);g[m+4>>2]=r;g[m+8>>2]=B;g[m+12>>2]=ea(0.0);B=ea(g[b+76>>2]);r=ea(g[b+80>>2]);x=ea(g[b+84>>2]);g[o>>2]=B;g[o+4>>2]=r;g[o+8>>2]=x;g[o+12>>2]=ea(0.0);KOa(n,o,j,l,m,k+80|0,k+112|0,k);x=ea(g[n>>2]);if(!(x<=ea(g[b+72>>2]))){E=1;i=k;return E|0}a[b+68>>0]=1;n=c[b+116>>2]|0;if(!n){E=0;i=k;return E|0}b=c[d+8>>2]|0;d=n+4|0;m=c[d>>2]|0;if(m>>>0>=(c[n+8>>2]|0)>>>0){a[n+20>>0]=1;E=1;i=k;return E|0}l=n+16|0;j=c[l>>2]|0;if(j>>>0<(c[n+12>>2]|0)>>>0){c[l>>2]=j+1;E=1;i=k;return E|0}else{c[d>>2]=m+1;c[(c[n>>2]|0)+(m<<2)>>2]=b;E=1;i=k;return E|0}return 0}function Gzb(a){a=a|0;return}function Hzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Izb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=0;k=i;i=i+128|0;j=k+16|0;l=k+64|0;m=k+32|0;n=k+48|0;o=k+96|0;p=ea(g[e>>2]);q=ea(g[e+4>>2]);r=ea(g[e+8>>2]);g[j>>2]=p;g[j+4>>2]=q;g[j+8>>2]=r;g[j+12>>2]=ea(0.0);r=ea(g[f>>2]);q=ea(g[f+4>>2]);p=ea(g[f+8>>2]);g[l>>2]=r;g[l+4>>2]=q;g[l+8>>2]=p;g[l+12>>2]=ea(0.0);p=ea(g[h>>2]);q=ea(g[h+4>>2]);r=ea(g[h+8>>2]);g[m>>2]=p;g[m+4>>2]=q;g[m+8>>2]=r;g[m+12>>2]=ea(0.0);r=ea(g[b+76>>2]);q=ea(g[b+80>>2]);p=ea(g[b+84>>2]);g[o>>2]=r;g[o+4>>2]=q;g[o+8>>2]=p;g[o+12>>2]=ea(0.0);KOa(n,o,j,l,m,k+80|0,k+112|0,k);p=ea(g[n>>2]);if(!(p<=ea(g[b+72>>2]))){s=1;i=k;return s|0}a[b+68>>0]=1;n=c[b+116>>2]|0;if(!n){s=0;i=k;return s|0}b=c[d+8>>2]|0;d=n+4|0;m=c[d>>2]|0;if(m>>>0>=(c[n+8>>2]|0)>>>0){a[n+20>>0]=1;s=1;i=k;return s|0}l=n+16|0;j=c[l>>2]|0;if(j>>>0<(c[n+12>>2]|0)>>>0){c[l>>2]=j+1;s=1;i=k;return s|0}else{c[d>>2]=m+1;c[(c[n>>2]|0)+(m<<2)>>2]=b;s=1;i=k;return s|0}return 0}function Jzb(a){a=a|0;return}function Kzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Lzb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0;k=i;i=i+272|0;j=k+248|0;d=k+48|0;l=k+224|0;m=k+236|0;n=k+80|0;o=k+32|0;p=ea(g[e>>2]);q=ea(g[e+4>>2]);r=ea(g[e+8>>2]);s=ea(g[f>>2]);t=ea(g[f+4>>2]);u=ea(g[f+8>>2]);v=ea(g[h>>2]);w=ea(g[h+4>>2]);x=ea(g[h+8>>2]);y=ea(g[b+64>>2]);z=ea(g[b+68>>2]);A=ea(g[b+72>>2]);B=ea(g[b+16>>2]);C=ea(p*B);D=ea(g[b+32>>2]);E=ea(C+ea(q*D));C=ea(g[b+48>>2]);F=ea(E+ea(r*C));E=ea(g[b+20>>2]);G=ea(p*E);H=ea(g[b+36>>2]);I=ea(G+ea(q*H));G=ea(g[b+52>>2]);J=ea(I+ea(r*G));I=ea(g[b+24>>2]);K=ea(p*I);L=ea(g[b+40>>2]);M=ea(K+ea(q*L));K=ea(g[b+56>>2]);N=ea(y+F);F=ea(z+J);J=ea(A+ea(M+ea(r*K)));M=ea(y+ea(ea(ea(s*B)+ea(t*D))+ea(u*C)));O=ea(z+ea(ea(ea(s*E)+ea(t*H))+ea(u*G)));P=ea(A+ea(ea(ea(s*I)+ea(t*L))+ea(u*K)));Q=ea(y+ea(ea(ea(v*B)+ea(w*D))+ea(x*C)));C=ea(z+ea(ea(ea(v*E)+ea(w*H))+ea(x*G)));G=ea(A+ea(ea(ea(v*I)+ea(w*L))+ea(x*K)));K=N<M?N:M;L=F<O?F:O;I=J<P?J:P;A=N>M?N:M;M=F>O?F:O;O=J>P?J:P;P=ea(g[b+80>>2]);J=ea(g[b+84>>2]);F=ea(g[b+88>>2]);if(((L<C?L:C)>J?1:(M>C?M:C)<ea(-J))|((K<Q?K:Q)>P?1:(A>Q?A:Q)<ea(-P))|((I<G?I:G)>F?1:(O>G?O:G)<ea(-F))){R=1;i=k;return R|0}if(!(a[b+433>>0]|0)){F=ea(g[b+384>>2]);G=ea(p*F);O=ea(g[b+400>>2]);I=ea(G+ea(q*O));G=ea(g[b+416>>2]);P=ea(I+ea(r*G));I=ea(g[b+388>>2]);Q=ea(p*I);A=ea(g[b+404>>2]);K=ea(Q+ea(q*A));Q=ea(g[b+420>>2]);J=ea(K+ea(r*Q));K=ea(g[b+392>>2]);C=ea(p*K);M=ea(g[b+408>>2]);L=ea(C+ea(q*M));C=ea(g[b+424>>2]);S=P;T=ea(ea(ea(s*F)+ea(t*O))+ea(u*G));U=J;V=ea(ea(ea(s*I)+ea(t*A))+ea(u*Q));W=ea(L+ea(r*C));X=ea(ea(ea(s*K)+ea(t*M))+ea(u*C));Y=ea(ea(ea(v*F)+ea(w*O))+ea(x*G));Z=ea(ea(ea(v*I)+ea(w*A))+ea(x*Q));_=ea(ea(ea(v*K)+ea(w*M))+ea(x*C))}else{S=p;T=s;U=q;V=t;W=r;X=u;Y=v;Z=w;_=x}h=n+64|0;c[n+80>>2]=7;f=n+20|0;e=n+36|0;g[n+48>>2]=ea(0.0);$=n+52|0;c[$+0>>2]=c[j+0>>2];c[$+4>>2]=c[j+4>>2];c[$+8>>2]=c[j+8>>2];c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];x=ea(ea(ea(U+V)+Z)*ea(.333332986));w=ea(ea(ea(W+X)+_)*ea(.333332986));g[n>>2]=ea(ea(ea(S+T)+Y)*ea(.333332986));g[n+4>>2]=x;g[n+8>>2]=w;g[n+12>>2]=ea(0.0);g[n+96>>2]=S;g[n+100>>2]=U;g[n+104>>2]=W;g[n+108>>2]=ea(0.0);g[n+112>>2]=T;g[n+116>>2]=V;g[n+120>>2]=X;g[n+124>>2]=ea(0.0);g[n+128>>2]=Y;g[n+132>>2]=Z;g[n+136>>2]=_;g[n+140>>2]=ea(0.0);g[n+16>>2]=ea(0.0);c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];g[n+32>>2]=ea(3402823469999999843913219.0e14);c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];if((vPa(n,b+96|0,b+304|0,k+64|0,k,k+16|0,o)|0)!=1?(_=ea(g[b+368>>2]),!(_>=ea(g[o>>2]))):0){R=1;i=k;return R|0}a[b+432>>0]=1;R=0;i=k;return R|0}function Mzb(a){a=a|0;return}function Nzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ozb(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=0,$=0,aa=Im;l=i;i=i+288|0;k=l+264|0;m=l+64|0;n=l+240|0;o=l+252|0;p=l+16|0;q=l+224|0;r=l+80|0;s=l;t=l+32|0;u=l+48|0;v=c[d+320>>2]|0;w=ea(g[f>>2]);x=ea(g[v>>2]);y=ea(w*x);z=ea(g[v+4>>2]);A=ea(w*z);B=ea(g[v+8>>2]);C=ea(w*B);w=ea(g[f+4>>2]);D=ea(g[v+12>>2]);E=ea(w*D);F=ea(g[v+16>>2]);G=ea(w*F);H=ea(g[v+20>>2]);I=ea(y+E);E=ea(A+G);G=ea(C+ea(w*H));w=ea(g[f+8>>2]);C=ea(g[v+24>>2]);A=ea(w*C);y=ea(g[v+28>>2]);J=ea(w*y);K=ea(g[v+32>>2]);L=ea(I+A);A=ea(E+J);J=ea(G+ea(w*K));w=ea(g[h>>2]);G=ea(x*w);E=ea(z*w);I=ea(B*w);w=ea(g[h+4>>2]);M=ea(G+ea(D*w));G=ea(E+ea(F*w));E=ea(I+ea(H*w));w=ea(g[h+8>>2]);I=ea(M+ea(C*w));M=ea(G+ea(y*w));G=ea(E+ea(K*w));w=ea(g[j>>2]);E=ea(x*w);x=ea(z*w);z=ea(B*w);w=ea(g[j+4>>2]);B=ea(E+ea(D*w));D=ea(x+ea(F*w));F=ea(z+ea(H*w));w=ea(g[j+8>>2]);H=ea(B+ea(C*w));C=ea(D+ea(y*w));y=ea(F+ea(K*w));j=d+364|0;w=ea(g[j>>2]);h=d+16|0;v=d+400|0;K=ea(g[d+440>>2]);f=d+448|0;F=ea(I-L);D=ea(M-A);B=ea(G-J);z=ea(H-I);x=ea(C-M);E=ea(y-G);if((a[d+447>>0]|0)==0?(N=ea(ea(F*x)-ea(D*z)),O=ea(ea(B*z)-ea(F*E)),F=ea(ea(D*E)-ea(B*x)),x=ea(F*ea(g[d+428>>2])),F=ea(x+ea(O*ea(g[d+432>>2]))),ea(F+ea(N*ea(g[d+436>>2])))<=ea(0.0)):0){P=1;i=l;return P|0};c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[q>>2]=ea(0.0);N=ea(g[d+272>>2]);F=ea(g[d+276>>2]);O=ea(g[d+280>>2]);x=ea(g[d+224>>2]);B=ea(L*x);E=ea(g[d+240>>2]);D=ea(B+ea(A*E));B=ea(g[d+256>>2]);z=ea(D+ea(J*B));D=ea(g[d+228>>2]);Q=ea(L*D);R=ea(g[d+244>>2]);S=ea(Q+ea(A*R));Q=ea(g[d+260>>2]);U=ea(S+ea(J*Q));S=ea(g[d+232>>2]);V=ea(L*S);L=ea(g[d+248>>2]);W=ea(V+ea(A*L));A=ea(g[d+264>>2]);V=ea(N+z);z=ea(F+U);U=ea(O+ea(W+ea(J*A)));J=ea(N+ea(ea(ea(I*x)+ea(M*E))+ea(G*B)));W=ea(F+ea(ea(ea(I*D)+ea(M*R))+ea(G*Q)));X=ea(O+ea(ea(ea(I*S)+ea(M*L))+ea(G*A)));G=ea(N+ea(ea(ea(H*x)+ea(C*E))+ea(y*B)));B=ea(F+ea(ea(ea(H*D)+ea(C*R))+ea(y*Q)));Q=ea(O+ea(ea(ea(H*S)+ea(C*L))+ea(y*A)));Y=r+64|0;c[r+80>>2]=7;Z=r+20|0;_=r+36|0;g[r+48>>2]=ea(0.0);$=r+52|0;c[$+0>>2]=c[k+0>>2];c[$+4>>2]=c[k+4>>2];c[$+8>>2]=c[k+8>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[Y+0>>2]=c[m+0>>2];c[Y+4>>2]=c[m+4>>2];c[Y+8>>2]=c[m+8>>2];c[Y+12>>2]=c[m+12>>2];A=ea(ea(B+ea(z+W))*ea(.333332986));y=ea(ea(Q+ea(U+X))*ea(.333332986));g[r>>2]=ea(ea(G+ea(V+J))*ea(.333332986));g[r+4>>2]=A;g[r+8>>2]=y;g[r+12>>2]=ea(0.0);g[r+96>>2]=V;g[r+100>>2]=z;g[r+104>>2]=U;g[r+108>>2]=ea(0.0);g[r+112>>2]=J;g[r+116>>2]=W;g[r+120>>2]=X;g[r+124>>2]=ea(0.0);g[r+128>>2]=G;g[r+132>>2]=B;g[r+136>>2]=Q;g[r+140>>2]=ea(0.0);g[r+16>>2]=ea(0.0);c[Z+0>>2]=c[n+0>>2];c[Z+4>>2]=c[n+4>>2];c[Z+8>>2]=c[n+8>>2];g[r+32>>2]=ea(3402823469999999843913219.0e14);c[_+0>>2]=c[o+0>>2];c[_+4>>2]=c[o+4>>2];c[_+8>>2]=c[o+8>>2];if(!(BPa(r,h,q,p,v,s,u,t,K,0)|0)){P=1;i=l;return P|0}K=ea(g[d+288>>2]);Q=ea(g[d+292>>2]);B=ea(g[d+296>>2]);G=ea(g[d+300>>2]);X=ea(g[d+304>>2]);W=ea(g[d+308>>2]);J=ea(g[d+312>>2]);U=ea(g[t>>2]);z=ea(g[t+4>>2]);V=ea(g[t+8>>2]);y=ea(ea(G*G)+ea(-.5));A=ea(ea(ea(K*U)+ea(Q*z))+ea(B*V));L=ea(X+ea(ea(ea(K*A)+ea(ea(y*U)+ea(G*ea(ea(Q*V)-ea(B*z)))))*ea(2.0)));X=ea(W+ea(ea(ea(Q*A)+ea(ea(y*z)+ea(G*ea(ea(B*U)-ea(K*V)))))*ea(2.0)));W=ea(J+ea(ea(ea(ea(y*V)+ea(G*ea(ea(K*z)-ea(Q*U))))+ea(B*A))*ea(2.0)));A=ea(g[u>>2]);U=ea(g[u+4>>2]);z=ea(g[u+8>>2]);V=ea(ea(ea(K*A)+ea(Q*U))+ea(B*z));J=ea(ea(ea(K*V)+ea(ea(y*A)+ea(G*ea(ea(Q*z)-ea(B*U)))))*ea(2.0));C=ea(ea(ea(Q*V)+ea(ea(y*U)+ea(G*ea(ea(B*A)-ea(K*z)))))*ea(2.0));S=ea(ea(ea(ea(y*z)+ea(G*ea(ea(K*U)-ea(Q*A))))+ea(B*V))*ea(2.0));V=ea(ea(1.0)/ea(T(ea(ea(S*S)+ea(ea(J*J)+ea(C*C))))));B=ea(V*J);J=ea(V*C);C=ea(V*S);S=ea(g[q>>2]);V=ea(g[s>>2]);do if(!(S>=V)){A=ea(V*ea(g[d+384>>2]));if(A<w){b[d+336>>1]=7;g[d+340>>2]=L;g[d+344>>2]=X;g[d+348>>2]=W;g[d+352>>2]=B;g[d+356>>2]=J;g[d+360>>2]=C;g[j>>2]=A;aa=A;break}else{P=1;i=l;return P|0}}else{b[d+336>>1]=6;g[j>>2]=ea(0.0);A=ea(-ea(g[d+416>>2]));Q=ea(-ea(g[d+420>>2]));U=ea(-ea(g[d+424>>2]));g[d+352>>2]=A;g[d+356>>2]=Q;g[d+360>>2]=U;a[f>>0]=1;aa=ea(0.0)}while(0);a[d+449>>0]=1;c[d+332>>2]=c[e+8>>2];if(a[d+446>>0]|0){P=0;i=l;return P|0}if(!(aa==ea(0.0))){P=1;i=l;return P|0}P=(b[d+444>>1]&32)!=0;i=l;return P|0}function Pzb(a){a=a|0;return}function Qzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Rzb(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=0,K=Im,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im;l=i;i=i+480|0;m=l+400|0;n=l+192|0;o=l+448|0;p=l+460|0;q=l+472|0;r=l;s=l+176|0;t=l+224|0;u=l+16|0;v=l+384|0;w=l+208|0;x=l+160|0;y=l+436|0;z=d+72|0;if(b[c[z>>2]>>1]&256){A=c[d+8>>2]|0;B=ea(g[f>>2]);C=ea(B*ea(g[A>>2]));D=A+4|0;E=ea(B*ea(g[D>>2]));F=A+8|0;G=ea(B*ea(g[F>>2]));B=ea(g[f+4>>2]);H=A+12|0;I=ea(B*ea(g[H>>2]));J=A+16|0;K=ea(B*ea(g[J>>2]));L=A+20|0;M=ea(C+I);I=ea(E+K);K=ea(G+ea(B*ea(g[L>>2])));B=ea(g[f+8>>2]);N=A+24|0;G=ea(B*ea(g[N>>2]));O=A+28|0;E=ea(B*ea(g[O>>2]));P=A+32|0;C=ea(M+G);G=ea(I+E);E=ea(K+ea(B*ea(g[P>>2])));Q=A+36|0;B=ea(C+ea(g[Q>>2]));R=A+40|0;C=ea(G+ea(g[R>>2]));S=A+44|0;G=ea(E+ea(g[S>>2]));g[m>>2]=B;T=m+4|0;g[T>>2]=C;U=m+8|0;g[U>>2]=G;G=ea(g[h>>2]);C=ea(G*ea(g[A>>2]));B=ea(G*ea(g[D>>2]));E=ea(G*ea(g[F>>2]));G=ea(g[h+4>>2]);K=ea(G*ea(g[H>>2]));I=ea(G*ea(g[J>>2]));M=ea(C+K);K=ea(B+I);I=ea(E+ea(G*ea(g[L>>2])));G=ea(g[h+8>>2]);E=ea(G*ea(g[N>>2]));B=ea(G*ea(g[O>>2]));C=ea(M+E);E=ea(K+B);B=ea(I+ea(G*ea(g[P>>2])));G=ea(C+ea(g[Q>>2]));C=ea(E+ea(g[R>>2]));E=ea(B+ea(g[S>>2]));V=m+12|0;g[V>>2]=G;W=m+16|0;g[W>>2]=C;X=m+20|0;g[X>>2]=E;E=ea(g[j>>2]);C=ea(E*ea(g[A>>2]));G=ea(E*ea(g[D>>2]));B=ea(E*ea(g[F>>2]));E=ea(g[j+4>>2]);I=ea(E*ea(g[H>>2]));K=ea(E*ea(g[J>>2]));M=ea(C+I);I=ea(G+K);K=ea(B+ea(E*ea(g[L>>2])));E=ea(g[j+8>>2]);B=ea(E*ea(g[N>>2]));G=ea(E*ea(g[O>>2]));C=ea(M+B);B=ea(I+G);G=ea(K+ea(E*ea(g[P>>2])));E=ea(C+ea(g[Q>>2]));C=ea(B+ea(g[R>>2]));B=ea(G+ea(g[S>>2]));S=m+24|0;g[S>>2]=E;R=m+28|0;g[R>>2]=C;Q=m+32|0;g[Q>>2]=B;g[q>>2]=ea(3402823469999999843913219.0e14);P=d+12|0;B=ea(g[P>>2]);if(!(UOa(m,(c[d+52>>2]|0)+48|0,c[d+64>>2]|0,d+196|0,B,q,(a[d+48>>0]|0)!=0)|0)){Y=1;i=l;return Y|0}B=ea(g[q>>2]);if(!(B<=ea(g[P>>2]))){Y=1;i=l;return Y|0}g[P>>2]=B;g[k>>2]=B;C=ea(g[m>>2]);E=ea(g[T>>2]);G=ea(g[U>>2]);g[d+128>>2]=C;g[d+132>>2]=E;g[d+136>>2]=G;g[d+140>>2]=ea(0.0);U=c[d+68>>2]|0;K=ea(-ea(g[U>>2]));I=ea(-ea(g[U+4>>2]));M=ea(-ea(g[U+8>>2]));g[d+144>>2]=K;g[d+148>>2]=I;g[d+152>>2]=M;g[d+156>>2]=ea(0.0);a[d+76>>0]=1;c[d+192>>2]=c[e+8>>2];g[d+84>>2]=C;g[d+88>>2]=E;g[d+92>>2]=G;g[d+96>>2]=ea(g[V>>2]);g[d+100>>2]=ea(g[W>>2]);g[d+104>>2]=ea(g[X>>2]);g[d+108>>2]=ea(g[S>>2]);g[d+112>>2]=ea(g[R>>2]);g[d+116>>2]=ea(g[Q>>2]);if(!(B==ea(0.0))){Y=1;i=l;return Y|0}a[d+77>>0]=1;Y=0;i=l;return Y|0};c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;g[s>>2]=ea(0.0);Q=c[d+52>>2]|0;B=ea(g[Q+48>>2]);G=ea(g[Q+52>>2]);E=ea(g[Q+56>>2]);Q=t+64|0;c[t+0>>2]=c[r+0>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[t+12>>2]=c[r+12>>2];c[t+80>>2]=3;R=t+20|0;c[R+0>>2]=c[o+0>>2];c[R+4>>2]=c[o+4>>2];c[R+8>>2]=c[o+8>>2];S=t+36|0;g[t+48>>2]=ea(0.0);X=t+52|0;c[X+0>>2]=c[o+0>>2];c[X+4>>2]=c[o+4>>2];c[X+8>>2]=c[o+8>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[Q+0>>2]=c[m+0>>2];c[Q+4>>2]=c[m+4>>2];c[Q+8>>2]=c[m+8>>2];c[Q+12>>2]=c[m+12>>2];g[t+144>>2]=B;g[t+148>>2]=G;g[t+152>>2]=E;g[t+156>>2]=ea(0.0);C=!(B<=G)?G:B;M=!(C<=E)?E:C;C=!(B>=G)?G:B;B=ea(M*ea(.150000006));G=ea((!(C>=E)?E:C)*ea(.0299999993));C=B>G?B:G;g[t+16>>2]=M>C?C:M;c[R+0>>2]=c[o+0>>2];c[R+4>>2]=c[o+4>>2];c[R+8>>2]=c[o+8>>2];g[t+32>>2]=ea(M*ea(.0500000007));c[S+0>>2]=c[m+0>>2];c[S+4>>2]=c[m+4>>2];c[S+8>>2]=c[m+8>>2];S=c[d+8>>2]|0;M=ea(g[f>>2]);C=ea(g[S>>2]);G=ea(M*C);B=ea(g[S+4>>2]);E=ea(M*B);I=ea(g[S+8>>2]);K=ea(M*I);M=ea(g[f+4>>2]);Z=ea(g[S+12>>2]);_=ea(M*Z);$=ea(g[S+16>>2]);aa=ea(M*$);ba=ea(g[S+20>>2]);ca=ea(G+_);_=ea(E+aa);aa=ea(K+ea(M*ba));M=ea(g[f+8>>2]);K=ea(g[S+24>>2]);E=ea(M*K);G=ea(g[S+28>>2]);da=ea(M*G);fa=ea(g[S+32>>2]);ga=ea(ca+E);E=ea(_+da);da=ea(aa+ea(M*fa));M=ea(g[S+36>>2]);aa=ea(ga+M);ga=ea(g[S+40>>2]);_=ea(E+ga);E=ea(g[S+44>>2]);ca=ea(da+E);da=ea(g[h>>2]);ha=ea(C*da);ia=ea(B*da);ja=ea(I*da);da=ea(g[h+4>>2]);ka=ea(ha+ea(Z*da));ha=ea(ia+ea($*da));ia=ea(ja+ea(ba*da));da=ea(g[h+8>>2]);ja=ea(M+ea(ka+ea(K*da)));ka=ea(ga+ea(ha+ea(G*da)));ha=ea(E+ea(ia+ea(fa*da)));da=ea(g[j>>2]);ia=ea(C*da);C=ea(B*da);B=ea(I*da);da=ea(g[j+4>>2]);I=ea(ia+ea(Z*da));Z=ea(C+ea($*da));$=ea(B+ea(ba*da));da=ea(g[j+8>>2]);ba=ea(M+ea(I+ea(K*da)));K=ea(ga+ea(Z+ea(G*da)));G=ea(E+ea($+ea(fa*da)));da=ea(ba-ja);fa=ea(K-ka);$=ea(G-ha);E=ea(aa-ja);Z=ea(_-ka);ga=ea(ca-ha);if((a[d+48>>0]|0)==0?(I=ea(ea(Z*da)-ea(E*fa)),M=ea(ea(E*$)-ea(ga*da)),da=ea(ea(ga*fa)-ea(Z*$)),$=ea(g[d+176>>2]),Z=ea(g[d+180>>2]),fa=ea(ea(ea(da*$)+ea(M*Z))+ea(I*ea(g[d+184>>2]))),fa>=ea(g[s>>2])):0){Y=1;i=l;return Y|0}j=u+64|0;c[u+80>>2]=7;h=u+20|0;S=u+36|0;g[u+48>>2]=ea(0.0);f=u+52|0;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];fa=ea(ea(ea(_+ka)+K)*ea(.333332986));I=ea(ea(ea(ca+ha)+G)*ea(.333332986));g[u>>2]=ea(ea(ea(aa+ja)+ba)*ea(.333332986));g[u+4>>2]=fa;g[u+8>>2]=I;g[u+12>>2]=ea(0.0);g[u+96>>2]=aa;g[u+100>>2]=_;g[u+104>>2]=ca;g[u+108>>2]=ea(0.0);g[u+112>>2]=ja;g[u+116>>2]=ka;g[u+120>>2]=ha;g[u+124>>2]=ea(0.0);g[u+128>>2]=ba;g[u+132>>2]=K;g[u+136>>2]=G;g[u+140>>2]=ea(0.0);g[u+16>>2]=ea(0.0);c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];g[u+32>>2]=ea(3402823469999999843913219.0e14);c[S+0>>2]=c[p+0>>2];c[S+4>>2]=c[p+4>>2];c[S+8>>2]=c[p+8>>2];if(!(APa(u,t,s,r,d+176|0,v,x,w,ea(g[d+80>>2]),0)|0)){Y=1;i=l;return Y|0}a[d+76>>0]=1;r=d+128|0;c[r+0>>2]=c[w+0>>2];c[r+4>>2]=c[w+4>>2];c[r+8>>2]=c[w+8>>2];c[r+12>>2]=c[w+12>>2];c[d+192>>2]=c[e+8>>2];G=ea(g[s>>2]);K=ea(g[v>>2]);if(G>=K){a[d+77>>0]=1;g[k>>2]=ea(0.0);v=d+32|0;c[v+0>>2]=c[s+0>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];c[v+12>>2]=c[s+12>>2];g[d+12>>2]=ea(0.0);s=c[d+68>>2]|0;G=ea(-ea(g[s>>2]));ba=ea(-ea(g[s+4>>2]));ha=ea(-ea(g[s+8>>2]));g[d+144>>2]=G;g[d+148>>2]=ba;g[d+152>>2]=ha;g[d+156>>2]=ea(0.0);Y=(b[c[z>>2]>>1]&32)!=0;i=l;return Y|0}z=d+12|0;ha=ea(K*ea(g[z>>2]));g[z>>2]=ha;z=d+176|0;ba=ea(g[z>>2]);s=d+180|0;G=ea(g[s>>2]);v=d+184|0;ka=ea(G*K);G=ea(ea(g[v>>2])*K);g[z>>2]=ea(ba*K);g[s>>2]=ka;g[v>>2]=G;g[d+188>>2]=ea(0.0);v=d+32|0;s=d+36|0;g[v>>2]=ea(ea(g[v>>2])*K);c[s+0>>2]=c[y+0>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];y=d+144|0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];c[y+12>>2]=c[x+12>>2];if(!(ha<ea(g[k>>2]))){Y=1;i=l;return Y|0}g[k>>2]=ha;Y=1;i=l;return Y|0}function Szb(a){a=a|0;return}function Tzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Uzb(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=0,G=0,H=0,I=0,J=0;l=i;i=i+80|0;m=l+32|0;n=l+28|0;o=l+16|0;p=l+4|0;q=l+68|0;r=c[d+12>>2]|0;s=ea(g[f>>2]);t=ea(s*ea(g[r>>2]));u=r+4|0;v=ea(s*ea(g[u>>2]));w=r+8|0;x=ea(s*ea(g[w>>2]));s=ea(g[f+4>>2]);y=r+12|0;z=ea(s*ea(g[y>>2]));A=r+16|0;B=ea(s*ea(g[A>>2]));C=r+20|0;D=ea(t+z);z=ea(v+B);B=ea(x+ea(s*ea(g[C>>2])));s=ea(g[f+8>>2]);f=r+24|0;x=ea(s*ea(g[f>>2]));E=r+28|0;v=ea(s*ea(g[E>>2]));F=r+32|0;t=ea(D+x);x=ea(z+v);v=ea(B+ea(s*ea(g[F>>2])));G=r+36|0;s=ea(t+ea(g[G>>2]));H=r+40|0;t=ea(x+ea(g[H>>2]));I=r+44|0;x=ea(v+ea(g[I>>2]));g[m>>2]=s;g[m+4>>2]=t;g[m+8>>2]=x;x=ea(g[h>>2]);t=ea(x*ea(g[r>>2]));s=ea(x*ea(g[u>>2]));v=ea(x*ea(g[w>>2]));x=ea(g[h+4>>2]);B=ea(x*ea(g[y>>2]));z=ea(x*ea(g[A>>2]));D=ea(t+B);B=ea(s+z);z=ea(v+ea(x*ea(g[C>>2])));x=ea(g[h+8>>2]);v=ea(x*ea(g[f>>2]));s=ea(x*ea(g[E>>2]));t=ea(D+v);v=ea(B+s);s=ea(z+ea(x*ea(g[F>>2])));x=ea(t+ea(g[G>>2]));t=ea(v+ea(g[H>>2]));v=ea(s+ea(g[I>>2]));g[m+12>>2]=x;g[m+16>>2]=t;g[m+20>>2]=v;v=ea(g[j>>2]);t=ea(v*ea(g[r>>2]));x=ea(v*ea(g[u>>2]));s=ea(v*ea(g[w>>2]));v=ea(g[j+4>>2]);z=ea(v*ea(g[y>>2]));B=ea(v*ea(g[A>>2]));D=ea(t+z);z=ea(x+B);B=ea(s+ea(v*ea(g[C>>2])));v=ea(g[j+8>>2]);s=ea(v*ea(g[f>>2]));x=ea(v*ea(g[E>>2]));t=ea(D+s);s=ea(z+x);x=ea(B+ea(v*ea(g[F>>2])));v=ea(t+ea(g[G>>2]));t=ea(s+ea(g[H>>2]));s=ea(x+ea(g[I>>2]));g[m+24>>2]=v;g[m+28>>2]=t;g[m+32>>2]=s;I=c[d+28>>2]|0;H=c[d+32>>2]|0;G=d+20|0;s=ea(g[G>>2]);F=d+8|0;E=(c[F>>2]|0)+12|0;f=d+36|0;b[q>>1]=b[c[f>>2]>>1]|0;do if(XOa(1,m,I,H,s,0,E,n,p,o,l,q,(a[d+24>>0]|0)!=0,0)|0?(t=ea(g[n>>2]),t<ea(g[(c[F>>2]|0)+40>>2])):0){g[G>>2]=t;g[k>>2]=t;g[(c[F>>2]|0)+40>>2]=t;j=c[F>>2]|0;g[j+28>>2]=ea(g[p>>2]);g[j+32>>2]=ea(g[p+4>>2]);g[j+36>>2]=ea(g[p+8>>2]);j=c[F>>2]|0;g[j+16>>2]=ea(g[o>>2]);g[j+20>>2]=ea(g[o+4>>2]);g[j+24>>2]=ea(g[o+8>>2]);c[(c[F>>2]|0)+8>>2]=c[e+8>>2];a[d+40>>0]=1;if(ea(g[n>>2])==ea(0.0)){a[d+41>>0]=1;J=(b[c[f>>2]>>1]&32)!=0;i=l;return J|0}else{if(!(b[c[f>>2]>>1]&64))break;else J=0;i=l;return J|0}}while(0);J=1;i=l;return J|0}function Vzb(a){a=a|0;return}function Wzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Xzb(a){a=a|0;return}function Yzb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Zzb(a){a=a|0;return 543856}function _zb(a,b){a=a|0;b=b|0;var c=0;a=i;if(!(HEi(543856,b)|0))c=1;else c=(HEi(b,543872)|0)==0;i=a;return c|0}function $zb(a){a=a|0;return c[a+16>>2]|0}function aAb(a){a=a|0;return c[a+20>>2]|0}function bAb(a){a=a|0;return c[a+52>>2]|0}function cAb(a){a=a|0;return 4}function dAb(a){a=a|0;var b=Im;b=ea(g[a+40>>2]);return ea(b)}function eAb(a){a=a|0;var b=Im;b=ea(g[a+44>>2]);return ea(b)}function fAb(a,c){a=a|0;c=c|0;b[a>>1]=b[c+48>>1]|0;return}function gAb(a,b,c){a=a|0;b=ea(b);c=ea(c);var d=0,e=0,f=Im,h=Im,j=Im;d=i;e=b>ea(0.0);f=e?b:ea(0.0);e=c>ea(0.0);b=e?c:ea(0.0);c=ea(ea(1.0)-ea(ea(S(ea(f+ea(1.0))))*ea(9.99999997e-07)));h=ea(ea(1.0)-ea(ea(S(ea(b+ea(1.0))))*ea(9.99999997e-07)));j=ea(ea(g[a+24>>2])+c);c=f<j?f:j;j=ea(ea(g[a+28>>2])+h);h=b<j?b:j;j=ea(R(ea(c)));b=ea(c-j);c=ea(R(ea(h)));f=ea(h-c);h=ea(t1a(a,~~ea(c+ea(j*ea(g[a+32>>2])))>>>0,b,f));i=d;return ea(h)}function hAb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=b>>>1;f=c[a+36>>2]|0;if(!(b&1))g=f+(e<<2)+2|0;else g=f+(e<<2)+3|0;return (d[g>>0]|0)&127|0}function iAb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;E1a(a,b,c);i=d;return}function jAb(a,b){a=a|0;b=b|0;return}function kAb(a){a=a|0;return}function lAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function mAb(a){a=a|0;return}function nAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function oAb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im,Ua=Im;f=i;i=i+336|0;h=f+316|0;j=f+64|0;k=f+256|0;l=f+304|0;m=f+16|0;n=f;o=f+240|0;p=f+32|0;q=f+48|0;r=f+224|0;s=f+268|0;t=f+80|0;g[m>>2]=ea(0.0);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;u=b+48|0;v=ea(g[u>>2]);w=b+52|0;x=ea(g[w>>2]);y=b+56|0;z=ea(g[y>>2]);g[o>>2]=v;A=o+4|0;g[A>>2]=x;B=o+8|0;g[B>>2]=z;g[o+12>>2]=ea(0.0);a:do if(!d){C=b+68|0;D=12}else{E=b+12|0;F=b+8|0;G=s+4|0;H=s+8|0;I=s+12|0;J=s+16|0;K=s+20|0;L=s+24|0;M=s+28|0;N=s+32|0;O=b+4|0;P=b+69|0;Q=t+64|0;R=t+80|0;S=t+16|0;U=t+20|0;V=t+32|0;W=t+36|0;X=t+48|0;Y=t+52|0;Z=t+4|0;_=t+8|0;$=t+12|0;aa=t+96|0;ba=t+100|0;ca=t+104|0;da=t+108|0;fa=t+112|0;ga=t+116|0;ha=t+120|0;ia=t+124|0;ja=t+128|0;ka=t+132|0;la=t+136|0;ma=t+140|0;na=b+16|0;oa=b+64|0;pa=b+68|0;qa=b+32|0;ra=b+32|0;sa=b+60|0;ta=r+4|0;ua=r+8|0;va=q+4|0;wa=q+8|0;xa=0;while(1){ya=c[e+(xa<<2)>>2]|0;LRa(c[E>>2]|0,c[F>>2]|0,s,0,0,ya,1,1)|0;z=ea(g[s>>2]);x=ea(g[G>>2]);v=ea(g[H>>2]);za=ea(g[I>>2]);Aa=ea(g[J>>2]);Ba=ea(g[K>>2]);Ca=ea(g[L>>2]);Da=ea(g[M>>2]);Ea=ea(g[N>>2]);Fa=c[O>>2]|0;Ga=ea(g[Fa>>2]);Ha=ea(g[Fa+4>>2]);Ia=ea(g[Fa+8>>2]);Ja=ea(g[Fa+12>>2]);Ka=ea(g[Fa+16>>2]);La=ea(g[Fa+20>>2]);Ma=ea(g[Fa+24>>2]);Na=ea(ea(Ja*Ja)+ea(-.5));Oa=ea(ea(ea(z*Ga)+ea(x*Ha))+ea(v*Ia));Pa=ea(Ka+ea(ea(ea(Ga*Oa)+ea(ea(Ja*ea(ea(v*Ha)-ea(x*Ia)))+ea(z*Na)))*ea(2.0)));Qa=ea(La+ea(ea(ea(Ha*Oa)+ea(ea(Ja*ea(ea(z*Ia)-ea(v*Ga)))+ea(x*Na)))*ea(2.0)));Ra=ea(Ma+ea(ea(ea(Ia*Oa)+ea(ea(Ja*ea(ea(x*Ga)-ea(z*Ha)))+ea(v*Na)))*ea(2.0)));v=ea(ea(ea(za*Ga)+ea(Aa*Ha))+ea(Ba*Ia));z=ea(Ka+ea(ea(ea(Ga*v)+ea(ea(Ja*ea(ea(Ba*Ha)-ea(Aa*Ia)))+ea(za*Na)))*ea(2.0)));x=ea(La+ea(ea(ea(Ha*v)+ea(ea(Ja*ea(ea(za*Ia)-ea(Ba*Ga)))+ea(Aa*Na)))*ea(2.0)));Oa=ea(Ma+ea(ea(ea(Ia*v)+ea(ea(Ja*ea(ea(Aa*Ga)-ea(za*Ha)))+ea(Ba*Na)))*ea(2.0)));Ba=ea(ea(ea(Ca*Ga)+ea(Da*Ha))+ea(Ea*Ia));za=ea(Ka+ea(ea(ea(Ga*Ba)+ea(ea(Ja*ea(ea(Ea*Ha)-ea(Da*Ia)))+ea(Ca*Na)))*ea(2.0)));Ka=ea(La+ea(ea(ea(Ha*Ba)+ea(ea(Ja*ea(ea(Ca*Ia)-ea(Ea*Ga)))+ea(Da*Na)))*ea(2.0)));La=ea(Ma+ea(ea(ea(Ia*Ba)+ea(ea(Ja*ea(ea(Da*Ga)-ea(Ca*Ha)))+ea(Ea*Na)))*ea(2.0)));if(!((a[P>>0]|0)==0?(Na=ea(za-z),Ea=ea(Ka-x),Ha=ea(La-Oa),Ca=ea(Pa-z),Ga=ea(Qa-x),Da=ea(Ra-Oa),Ja=ea(ea(Ea*Da)-ea(Ha*Ga)),Ba=ea(ea(Ha*Ca)-ea(Da*Na)),Da=ea(ea(Ga*Na)-ea(Ea*Ca)),Ca=ea(g[o>>2]),Ea=ea(g[A>>2]),Na=ea(ea(ea(Ja*Ca)+ea(Ba*Ea))+ea(Da*ea(g[B>>2]))),Na>=ea(g[m>>2])):0))D=6;if((D|0)==6?(D=0,c[R>>2]=7,g[X>>2]=ea(0.0),c[Y+0>>2]=c[h+0>>2],c[Y+4>>2]=c[h+4>>2],c[Y+8>>2]=c[h+8>>2],c[j+0>>2]=0,c[j+4>>2]=0,c[j+8>>2]=0,c[j+12>>2]=0,c[Q+0>>2]=c[j+0>>2],c[Q+4>>2]=c[j+4>>2],c[Q+8>>2]=c[j+8>>2],c[Q+12>>2]=c[j+12>>2],Na=ea(ea(Ka+ea(Qa+x))*ea(.333332986)),Da=ea(ea(La+ea(Ra+Oa))*ea(.333332986)),g[t>>2]=ea(ea(za+ea(Pa+z))*ea(.333332986)),g[Z>>2]=Na,g[_>>2]=Da,g[$>>2]=ea(0.0),g[aa>>2]=Pa,g[ba>>2]=Qa,g[ca>>2]=Ra,g[da>>2]=ea(0.0),g[fa>>2]=z,g[ga>>2]=x,g[ha>>2]=Oa,g[ia>>2]=ea(0.0),g[ja>>2]=za,g[ka>>2]=Ka,g[la>>2]=La,g[ma>>2]=ea(0.0),g[S>>2]=ea(0.0),c[U+0>>2]=c[k+0>>2],c[U+4>>2]=c[k+4>>2],c[U+8>>2]=c[k+8>>2],g[V>>2]=ea(3402823469999999843913219.0e14),c[W+0>>2]=c[l+0>>2],c[W+4>>2]=c[l+4>>2],c[W+8>>2]=c[l+8>>2],APa(t,c[na>>2]|0,m,n,o,p,r,q,ea(g[oa>>2]),0)|0):0){a[pa>>0]=1;La=ea(g[p>>2]);if(!(La>ea(g[m>>2])))break;if(ea(g[qa>>2])>La){c[ra+0>>2]=c[p+0>>2];c[ra+4>>2]=c[p+4>>2];c[ra+8>>2]=c[p+8>>2];c[ra+12>>2]=c[p+12>>2];Fa=c[sa>>2]|0;g[Fa+40>>2]=La;La=ea(g[r>>2]);Ka=ea(g[ta>>2]);za=ea(g[ua>>2]);g[Fa+28>>2]=La;g[Fa+32>>2]=Ka;g[Fa+36>>2]=za;za=ea(g[q>>2]);Ka=ea(g[va>>2]);La=ea(g[wa>>2]);g[Fa+16>>2]=za;g[Fa+20>>2]=Ka;g[Fa+24>>2]=La;c[Fa+8>>2]=ya}}xa=xa+1|0;if(xa>>>0>=d>>>0){C=pa;D=12;break a}}pa=c[sa>>2]|0;g[pa+40>>2]=ea(0.0);c[pa+8>>2]=ya;a[b+70>>0]=1}while(0);if((D|0)==12?(a[C>>0]|0)==0:0){i=f;return 1}C=c[b+60>>2]|0;b=C+28|0;La=ea(g[b>>2]);Ka=ea(La*La);D=C+32|0;za=ea(g[D>>2]);Oa=ea(Ka+ea(za*za));ya=C+36|0;Ka=ea(g[ya>>2]);x=ea(T(ea(Oa+ea(Ka*Ka))));if(x>ea(0.0)){Oa=ea(ea(1.0)/x);x=ea(La*Oa);g[b>>2]=x;z=ea(za*Oa);g[D>>2]=z;Ra=ea(Ka*Oa);g[ya>>2]=Ra;Sa=x;Ta=z;Ua=Ra}else{Sa=La;Ta=za;Ua=Ka}Ka=ea(Sa*ea(g[u>>2]));za=ea(Ka+ea(Ta*ea(g[w>>2])));if(!(ea(za+ea(Ua*ea(g[y>>2])))>ea(0.0))){i=f;return 1}za=ea(-Ta);Ta=ea(-Ua);g[b>>2]=ea(-Sa);g[D>>2]=za;g[ya>>2]=Ta;i=f;return 1}function pAb(a){a=a|0;return}function qAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function rAb(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=0;h=i;i=i+352|0;j=h+292|0;k=h+224|0;l=h+280|0;m=h+268|0;n=h+32|0;o=h;p=h+80|0;q=h+16|0;r=h+48|0;s=h+64|0;t=h+240|0;u=h+304|0;g[t>>2]=ea(0.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(1.0);g[t+16>>2]=ea(0.0);g[t+20>>2]=ea(0.0);g[t+24>>2]=ea(0.0);if(!e){v=1;i=h;return v|0}w=d+4|0;x=d+112|0;y=d+368|0;z=d+360|0;A=d+433|0;B=d+424|0;C=d+434|0;D=u+4|0;E=u+8|0;F=u+12|0;G=u+16|0;H=u+20|0;I=u+24|0;J=u+28|0;K=u+32|0;L=d+412|0;M=d+416|0;N=d+420|0;O=d+64|0;P=d+68|0;Q=d+72|0;R=d+16|0;S=d+32|0;U=d+48|0;V=d+20|0;W=d+36|0;X=d+52|0;Y=d+24|0;Z=d+40|0;_=d+56|0;$=p+64|0;aa=p+80|0;ba=p+16|0;ca=p+20|0;da=p+32|0;fa=p+36|0;ga=p+48|0;ha=p+52|0;ia=p+4|0;ja=p+8|0;ka=p+12|0;la=p+96|0;ma=p+100|0;na=p+104|0;oa=p+108|0;pa=p+112|0;qa=p+116|0;ra=p+120|0;sa=p+124|0;ta=p+128|0;ua=p+132|0;va=p+136|0;wa=p+140|0;xa=d+80|0;ya=d+84|0;za=d+88|0;Aa=d+92|0;Ba=d+96|0;Ca=d+100|0;Da=d+104|0;Ea=r+4|0;Fa=r+8|0;Ga=s+4|0;Ha=s+8|0;Ia=d+384|0;Ja=d+332|0;Ka=d+336|0;La=d+340|0;Ma=d+344|0;Na=d+348|0;Oa=d+352|0;Pa=d+356|0;Qa=d+435|0;Ra=d+328|0;Sa=d+432|0;Ta=d+400|0;Ua=d+404|0;Va=d+408|0;d=0;a:while(1){Wa=f+(d<<2)|0;LRa(c[w>>2]|0,t,u,0,0,c[Wa>>2]|0,0,0)|0;Xa=ea(g[z>>2]);Ya=ea(g[B>>2]);Za=ea(g[u>>2]);_a=ea(g[D>>2]);$a=ea(g[E>>2]);ab=ea(g[F>>2]);bb=ea(g[G>>2]);cb=ea(g[H>>2]);db=ea(g[I>>2]);eb=ea(g[J>>2]);fb=ea(g[K>>2]);gb=ea(ab-Za);hb=ea(bb-_a);ib=ea(cb-$a);jb=ea(db-ab);kb=ea(eb-bb);lb=ea(fb-cb);if(!((a[A>>0]|0)==0?(mb=ea(ea(gb*kb)-ea(hb*jb)),nb=ea(ea(ib*jb)-ea(gb*lb)),gb=ea(ea(hb*lb)-ea(ib*kb)),kb=ea(gb*ea(g[L>>2])),gb=ea(kb+ea(nb*ea(g[M>>2]))),ea(gb+ea(mb*ea(g[N>>2])))<=ea(0.0)):0))ob=5;do if((ob|0)==5?(ob=0,c[n+0>>2]=0,c[n+4>>2]=0,c[n+8>>2]=0,c[n+12>>2]=0,g[o>>2]=ea(0.0),mb=ea(g[O>>2]),gb=ea(g[P>>2]),nb=ea(g[Q>>2]),kb=ea(g[R>>2]),ib=ea(Za*kb),lb=ea(g[S>>2]),hb=ea(ib+ea(_a*lb)),ib=ea(g[U>>2]),jb=ea(hb+ea($a*ib)),hb=ea(g[V>>2]),pb=ea(Za*hb),qb=ea(g[W>>2]),rb=ea(pb+ea(_a*qb)),pb=ea(g[X>>2]),sb=ea(rb+ea($a*pb)),rb=ea(g[Y>>2]),tb=ea(Za*rb),ub=ea(g[Z>>2]),vb=ea(tb+ea(_a*ub)),tb=ea(g[_>>2]),wb=ea(mb+jb),jb=ea(gb+sb),sb=ea(nb+ea(vb+ea($a*tb))),vb=ea(mb+ea(ea(ea(ab*kb)+ea(bb*lb))+ea(cb*ib))),xb=ea(gb+ea(ea(ea(ab*hb)+ea(bb*qb))+ea(cb*pb))),yb=ea(nb+ea(ea(ea(ab*rb)+ea(bb*ub))+ea(cb*tb))),zb=ea(mb+ea(ea(ea(db*kb)+ea(eb*lb))+ea(fb*ib))),ib=ea(gb+ea(ea(ea(db*hb)+ea(eb*qb))+ea(fb*pb))),pb=ea(nb+ea(ea(ea(db*rb)+ea(eb*ub))+ea(fb*tb))),c[aa>>2]=7,g[ga>>2]=ea(0.0),c[ha+0>>2]=c[j+0>>2],c[ha+4>>2]=c[j+4>>2],c[ha+8>>2]=c[j+8>>2],c[k+0>>2]=0,c[k+4>>2]=0,c[k+8>>2]=0,c[k+12>>2]=0,c[$+0>>2]=c[k+0>>2],c[$+4>>2]=c[k+4>>2],c[$+8>>2]=c[k+8>>2],c[$+12>>2]=c[k+12>>2],tb=ea(ea(ib+ea(jb+xb))*ea(.333332986)),ub=ea(ea(pb+ea(sb+yb))*ea(.333332986)),g[p>>2]=ea(ea(zb+ea(wb+vb))*ea(.333332986)),g[ia>>2]=tb,g[ja>>2]=ub,g[ka>>2]=ea(0.0),g[la>>2]=wb,g[ma>>2]=jb,g[na>>2]=sb,g[oa>>2]=ea(0.0),g[pa>>2]=vb,g[qa>>2]=xb,g[ra>>2]=yb,g[sa>>2]=ea(0.0),g[ta>>2]=zb,g[ua>>2]=ib,g[va>>2]=pb,g[wa>>2]=ea(0.0),g[ba>>2]=ea(0.0),c[ca+0>>2]=c[l+0>>2],c[ca+4>>2]=c[l+4>>2],c[ca+8>>2]=c[l+8>>2],g[da>>2]=ea(3402823469999999843913219.0e14),c[fa+0>>2]=c[m+0>>2],c[fa+4>>2]=c[m+4>>2],c[fa+8>>2]=c[m+8>>2],BPa(p,x,o,n,y,q,s,r,Ya,0)|0):0){pb=ea(g[xa>>2]);ib=ea(g[ya>>2]);zb=ea(g[za>>2]);yb=ea(g[Aa>>2]);xb=ea(g[Ba>>2]);vb=ea(g[Ca>>2]);sb=ea(g[Da>>2]);jb=ea(g[r>>2]);wb=ea(g[Ea>>2]);ub=ea(g[Fa>>2]);tb=ea(ea(yb*yb)+ea(-.5));rb=ea(ea(ea(pb*jb)+ea(ib*wb))+ea(zb*ub));nb=ea(xb+ea(ea(ea(pb*rb)+ea(ea(tb*jb)+ea(yb*ea(ea(ib*ub)-ea(zb*wb)))))*ea(2.0)));xb=ea(vb+ea(ea(ea(ib*rb)+ea(ea(tb*wb)+ea(yb*ea(ea(zb*jb)-ea(pb*ub)))))*ea(2.0)));vb=ea(sb+ea(ea(ea(ea(tb*ub)+ea(yb*ea(ea(pb*wb)-ea(ib*jb))))+ea(zb*rb))*ea(2.0)));rb=ea(g[s>>2]);jb=ea(g[Ga>>2]);wb=ea(g[Ha>>2]);ub=ea(ea(ea(pb*rb)+ea(ib*jb))+ea(zb*wb));sb=ea(ea(ea(pb*ub)+ea(ea(tb*rb)+ea(yb*ea(ea(ib*wb)-ea(zb*jb)))))*ea(2.0));qb=ea(ea(ea(ib*ub)+ea(ea(tb*jb)+ea(yb*ea(ea(zb*rb)-ea(pb*wb)))))*ea(2.0));hb=ea(ea(ea(ea(tb*wb)+ea(yb*ea(ea(pb*jb)-ea(ib*rb))))+ea(zb*ub))*ea(2.0));ub=ea(ea(1.0)/ea(T(ea(ea(hb*hb)+ea(ea(sb*sb)+ea(qb*qb))))));zb=ea(ub*sb);sb=ea(ub*qb);qb=ea(ub*hb);hb=ea(g[o>>2]);ub=ea(g[q>>2]);if(!(hb>=ub)){hb=ea(ub*ea(g[Ia>>2]));if(!(hb<Xa))break;b[Ja>>1]=7;g[Ka>>2]=nb;g[La>>2]=xb;g[Ma>>2]=vb;g[Na>>2]=zb;g[Oa>>2]=sb;g[Pa>>2]=qb;g[z>>2]=hb;Ab=hb==ea(0.0)}else{b[Ja>>1]=6;g[z>>2]=ea(0.0);hb=ea(-ea(g[Ta>>2]));qb=ea(-ea(g[Ua>>2]));sb=ea(-ea(g[Va>>2]));g[Na>>2]=hb;g[Oa>>2]=qb;g[Pa>>2]=sb;a[C>>0]=1;Ab=1}a[Qa>>0]=1;c[Ra>>2]=c[Wa>>2];if((a[Sa>>0]|0)!=0|Ab){v=0;ob=12;break a}}while(0);d=d+1|0;if(d>>>0>=e>>>0){v=1;ob=12;break}}if((ob|0)==12){i=h;return v|0}return 0}function sAb(a){a=a|0;return}function tAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function uAb(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0;h=i;i=i+2352|0;j=h+40|0;k=h+28|0;l=h+16|0;m=h+4|0;n=h;o=h+32|0;if(e){p=d+32|0;q=d+28|0;r=0;do{LRa(c[p>>2]|0,c[q>>2]|0,j+(r*36|0)|0,0,0,c[f+(r<<2)>>2]|0,1,1)|0;r=r+1|0}while((r|0)!=(e|0))}c[k>>2]=-1;g[n>>2]=ea(3402823469999999843913219.0e14);r=c[d+4>>2]|0;q=c[d+8>>2]|0;s=ea(g[d+12>>2]);p=d+16|0;t=(c[p>>2]|0)+12|0;b[o>>1]=b[c[d+20>>2]>>1]|0;if(!(XOa(e,j,r,q,s,0,t,n,l,m,k,o,(a[d+36>>0]|0)!=0,0)|0)){i=h;return 1}s=ea(g[n>>2]);o=c[p>>2]|0;p=o+40|0;if(!(s<=ea(g[p>>2]))){i=h;return 1}c[o+8>>2]=c[f+(c[k>>2]<<2)>>2];g[o+28>>2]=ea(g[l>>2]);g[o+32>>2]=ea(g[l+4>>2]);g[o+36>>2]=ea(g[l+8>>2]);g[o+16>>2]=ea(g[m>>2]);g[o+20>>2]=ea(g[m+4>>2]);g[o+24>>2]=ea(g[m+8>>2]);g[p>>2]=ea(g[n>>2]);a[d+24>>0]=1;if(!(ea(g[n>>2])==ea(0.0))){i=h;return 1}a[d+25>>0]=1;i=h;return 1}function vAb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;j=i;i=i+48|0;l=j;if(!(a[b+16>>0]|0)){m=c[b+8>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[m>>2]));p=m+4|0;q=ea(n*ea(g[p>>2]));r=m+8|0;s=ea(n*ea(g[r>>2]));n=ea(g[e+4>>2]);t=m+12|0;u=ea(n*ea(g[t>>2]));v=m+16|0;w=ea(n*ea(g[v>>2]));x=m+20|0;y=ea(o+u);u=ea(q+w);w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[e+8>>2]);z=m+24|0;s=ea(n*ea(g[z>>2]));A=m+28|0;q=ea(n*ea(g[A>>2]));B=m+32|0;o=ea(y+s);s=ea(u+q);q=ea(w+ea(n*ea(g[B>>2])));g[l>>2]=o;g[l+4>>2]=s;g[l+8>>2]=q;n=ea(g[f>>2]);w=ea(n*ea(g[m>>2]));u=ea(n*ea(g[p>>2]));y=ea(n*ea(g[r>>2]));n=ea(g[f+4>>2]);C=ea(n*ea(g[t>>2]));D=ea(n*ea(g[v>>2]));E=ea(w+C);C=ea(u+D);D=ea(y+ea(n*ea(g[x>>2])));n=ea(g[f+8>>2]);y=ea(n*ea(g[z>>2]));u=ea(n*ea(g[A>>2]));w=ea(E+y);y=ea(C+u);u=ea(D+ea(n*ea(g[B>>2])));g[l+12>>2]=w;g[l+16>>2]=y;g[l+20>>2]=u;n=ea(g[h>>2]);D=ea(n*ea(g[m>>2]));C=ea(n*ea(g[p>>2]));E=ea(n*ea(g[r>>2]));n=ea(g[h+4>>2]);F=ea(n*ea(g[t>>2]));G=ea(n*ea(g[v>>2]));H=ea(D+F);F=ea(C+G);G=ea(E+ea(n*ea(g[x>>2])));n=ea(g[h+8>>2]);E=ea(n*ea(g[z>>2]));C=ea(n*ea(g[A>>2]));D=ea(H+E);E=ea(F+C);C=ea(G+ea(n*ea(g[B>>2])));g[l+24>>2]=D;g[l+28>>2]=E;g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}else{o=ea(g[e>>2]);g[l>>2]=o;s=ea(g[e+4>>2]);g[l+4>>2]=s;q=ea(g[e+8>>2]);g[l+8>>2]=q;w=ea(g[f>>2]);g[l+12>>2]=w;y=ea(g[f+4>>2]);g[l+16>>2]=y;u=ea(g[f+8>>2]);g[l+20>>2]=u;D=ea(g[h>>2]);g[l+24>>2]=D;E=ea(g[h+4>>2]);g[l+28>>2]=E;C=ea(g[h+8>>2]);g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}h=c[d+8>>2]|0;d=c[b+12>>2]|0;if(!d)R=56;else R=a[d+h>>0]|0;d=b+868|0;f=c[d>>2]|0;if((f|0)!=16){S=f;T=Q;U=P;V=O;W=N;X=M;Y=L;Z=K;_=J;$=I;aa=S+1|0;c[d>>2]=aa;ba=S*3|0;ca=b+(ba*12|0)+20|0;g[ca>>2]=T;da=b+(ba*12|0)+24|0;g[da>>2]=U;fa=b+(ba*12|0)+28|0;g[fa>>2]=V;ga=ba+1|0;ha=b+(ga*12|0)+20|0;g[ha>>2]=W;ia=b+(ga*12|0)+24|0;g[ia>>2]=X;ja=b+(ga*12|0)+28|0;g[ja>>2]=Y;ka=ba+2|0;la=b+(ka*12|0)+20|0;g[la>>2]=Z;ma=b+(ka*12|0)+24|0;g[ma>>2]=_;na=b+(ka*12|0)+28|0;g[na>>2]=$;oa=c[k>>2]|0;pa=b+(ba<<2)+596|0;c[pa>>2]=oa;qa=k+4|0;ra=c[qa>>2]|0;sa=b+(ga<<2)+596|0;c[sa>>2]=ra;ta=k+8|0;ua=c[ta>>2]|0;va=b+(ka<<2)+596|0;c[va>>2]=ua;wa=b+(S<<2)+788|0;c[wa>>2]=h;xa=b+S+852|0;a[xa>>0]=R;i=j;return 1}f=b+880|0;e=16;B=b+852|0;A=b+788|0;z=b+596|0;x=b+20|0;while(1){e=e+-1|0;lSa(f,x,c[A>>2]|0,a[B>>0]|0,z)|0;if(!e)break;else{B=B+1|0;A=A+4|0;z=z+12|0;x=x+36|0}}c[d>>2]=0;I=ea(g[l>>2]);J=ea(g[l+4>>2]);K=ea(g[l+8>>2]);L=ea(g[l+12>>2]);M=ea(g[l+16>>2]);N=ea(g[l+20>>2]);O=ea(g[l+24>>2]);P=ea(g[l+28>>2]);S=0;T=I;U=J;V=K;W=L;X=M;Y=N;Z=O;_=P;$=ea(g[l+32>>2]);aa=S+1|0;c[d>>2]=aa;ba=S*3|0;ca=b+(ba*12|0)+20|0;g[ca>>2]=T;da=b+(ba*12|0)+24|0;g[da>>2]=U;fa=b+(ba*12|0)+28|0;g[fa>>2]=V;ga=ba+1|0;ha=b+(ga*12|0)+20|0;g[ha>>2]=W;ia=b+(ga*12|0)+24|0;g[ia>>2]=X;ja=b+(ga*12|0)+28|0;g[ja>>2]=Y;ka=ba+2|0;la=b+(ka*12|0)+20|0;g[la>>2]=Z;ma=b+(ka*12|0)+24|0;g[ma>>2]=_;na=b+(ka*12|0)+28|0;g[na>>2]=$;oa=c[k>>2]|0;pa=b+(ba<<2)+596|0;c[pa>>2]=oa;qa=k+4|0;ra=c[qa>>2]|0;sa=b+(ga<<2)+596|0;c[sa>>2]=ra;ta=k+8|0;ua=c[ta>>2]|0;va=b+(ka<<2)+596|0;c[va>>2]=ua;wa=b+(S<<2)+788|0;c[wa>>2]=h;xa=b+S+852|0;a[xa>>0]=R;i=j;return 1}function wAb(a){a=a|0;return}function xAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function yAb(a){a=a|0;return}function zAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function AAb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0;e=i;i=i+64|0;f=e+48|0;h=e+32|0;j=e+16|0;k=e;l=c[b+48>>2]|0;m=ea(g[l+96>>2]);n=ea(g[l+100>>2]);o=ea(g[l+104>>2]);p=ea(g[l+108>>2]);q=ea(g[l+112>>2]);r=ea(g[l+116>>2]);s=ea(g[l+120>>2]);t=ea(g[l+124>>2]);u=ea(g[l+128>>2]);v=ea(g[l+132>>2]);w=ea(g[l+136>>2]);x=ea(g[l+140>>2]);y=ea(g[d>>2]);z=ea(g[d+4>>2]);A=ea(g[d+8>>2]);B=ea(ea(ea(m*y)+ea(n*z))+ea(o*A));C=ea(ea(ea(q*y)+ea(r*z))+ea(s*A));D=ea(ea(ea(u*y)+ea(v*z))+ea(w*A));if(B>C)E=B>D?k:j;else E=j;g[h>>2]=q;g[h+4>>2]=r;g[h+8>>2]=s;g[h+12>>2]=t;g[f>>2]=u;g[f+4>>2]=v;g[f+8>>2]=w;g[f+12>>2]=x;d=C>D?h:f;D=ea(g[d>>2]);C=ea(g[d+4>>2]);x=ea(g[d+8>>2]);g[k>>2]=m;g[k+4>>2]=n;g[k+8>>2]=o;g[k+12>>2]=p;g[j>>2]=D;g[j+4>>2]=C;g[j+8>>2]=x;g[j+12>>2]=ea(0.0);x=ea(g[E>>2]);C=ea(g[E+4>>2]);D=ea(g[E+8>>2]);g[a>>2]=x;g[a+4>>2]=C;g[a+8>>2]=D;g[a+12>>2]=ea(0.0);i=e;return}function BAb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;f=i;i=i+32|0;h=f+12|0;j=f;k=c[a+48>>2]|0;l=ea(g[k+96>>2]);m=ea(g[k+100>>2]);n=ea(g[k+104>>2]);o=ea(g[k+112>>2]);p=ea(g[k+116>>2]);q=ea(g[k+120>>2]);r=ea(g[k+128>>2]);s=ea(g[k+132>>2]);t=ea(g[k+136>>2]);u=ea(g[b>>2]);v=ea(g[b+4>>2]);w=ea(g[b+8>>2]);x=ea(ea(ea(l*u)+ea(m*v))+ea(n*w));n=ea(ea(ea(o*u)+ea(p*v))+ea(q*w));q=ea(ea(ea(r*u)+ea(s*v))+ea(t*w));b=n>q;w=b?n:q;g[e>>2]=x>w?x:w;k=e+4|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];w=b?q:n;g[d>>2]=x>w?w:x;b=d+4|0;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];i=f;return}function CAb(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im;a=i;if(!c){i=a;return}else h=0;do{j=d[b+h>>0]|0;k=ea(g[e+(j*12|0)>>2]);l=ea(g[e+(j*12|0)+4>>2]);m=ea(g[e+(j*12|0)+8>>2]);g[f+(h<<4)>>2]=k;g[f+(h<<4)+4>>2]=l;g[f+(h<<4)+8>>2]=m;g[f+(h<<4)+12>>2]=ea(0.0);h=h+1|0}while((h|0)!=(c|0));i=a;return}function DAb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im;j=i;i=i+48|0;l=j;if(!(_Pa(b+4560|0,e,f,h)|0)){i=j;return 1}if(!(a[b+16>>0]|0)){m=c[b+8>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[m>>2]));p=m+4|0;q=ea(n*ea(g[p>>2]));r=m+8|0;s=ea(n*ea(g[r>>2]));n=ea(g[e+4>>2]);t=m+12|0;u=ea(n*ea(g[t>>2]));v=m+16|0;w=ea(n*ea(g[v>>2]));x=m+20|0;y=ea(o+u);u=ea(q+w);w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[e+8>>2]);z=m+24|0;s=ea(n*ea(g[z>>2]));A=m+28|0;q=ea(n*ea(g[A>>2]));B=m+32|0;o=ea(y+s);s=ea(u+q);q=ea(w+ea(n*ea(g[B>>2])));g[l>>2]=o;g[l+4>>2]=s;g[l+8>>2]=q;n=ea(g[f>>2]);w=ea(n*ea(g[m>>2]));u=ea(n*ea(g[p>>2]));y=ea(n*ea(g[r>>2]));n=ea(g[f+4>>2]);C=ea(n*ea(g[t>>2]));D=ea(n*ea(g[v>>2]));E=ea(w+C);C=ea(u+D);D=ea(y+ea(n*ea(g[x>>2])));n=ea(g[f+8>>2]);y=ea(n*ea(g[z>>2]));u=ea(n*ea(g[A>>2]));w=ea(E+y);y=ea(C+u);u=ea(D+ea(n*ea(g[B>>2])));g[l+12>>2]=w;g[l+16>>2]=y;g[l+20>>2]=u;n=ea(g[h>>2]);D=ea(n*ea(g[m>>2]));C=ea(n*ea(g[p>>2]));E=ea(n*ea(g[r>>2]));n=ea(g[h+4>>2]);F=ea(n*ea(g[t>>2]));G=ea(n*ea(g[v>>2]));H=ea(D+F);F=ea(C+G);G=ea(E+ea(n*ea(g[x>>2])));n=ea(g[h+8>>2]);E=ea(n*ea(g[z>>2]));C=ea(n*ea(g[A>>2]));D=ea(H+E);E=ea(F+C);C=ea(G+ea(n*ea(g[B>>2])));g[l+24>>2]=D;g[l+28>>2]=E;g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}else{o=ea(g[e>>2]);g[l>>2]=o;s=ea(g[e+4>>2]);g[l+4>>2]=s;q=ea(g[e+8>>2]);g[l+8>>2]=q;w=ea(g[f>>2]);g[l+12>>2]=w;y=ea(g[f+4>>2]);g[l+16>>2]=y;u=ea(g[f+8>>2]);g[l+20>>2]=u;D=ea(g[h>>2]);g[l+24>>2]=D;E=ea(g[h+4>>2]);g[l+28>>2]=E;C=ea(g[h+8>>2]);g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}h=c[d+8>>2]|0;d=c[b+12>>2]|0;if(!d)R=56;else R=a[d+h>>0]|0;d=b+868|0;f=c[d>>2]|0;if((f|0)==16){e=b+880|0;B=16;A=b+852|0;z=b+788|0;x=b+596|0;v=b+20|0;while(1){B=B+-1|0;eSa(e,v,c[z>>2]|0,a[A>>0]|0,x)|0;if(!B)break;else{A=A+1|0;z=z+4|0;x=x+12|0;v=v+36|0}}c[d>>2]=0;o=ea(g[l>>2]);s=ea(g[l+4>>2]);q=ea(g[l+8>>2]);w=ea(g[l+12>>2]);y=ea(g[l+16>>2]);u=ea(g[l+20>>2]);D=ea(g[l+24>>2]);E=ea(g[l+28>>2]);S=0;T=o;U=s;V=q;W=w;X=y;Y=u;Z=D;_=E;$=ea(g[l+32>>2])}else{S=f;T=Q;U=P;V=O;W=N;X=M;Y=L;Z=K;_=J;$=I}c[d>>2]=S+1;d=S*3|0;g[b+(d*12|0)+20>>2]=T;g[b+(d*12|0)+24>>2]=U;g[b+(d*12|0)+28>>2]=V;f=d+1|0;g[b+(f*12|0)+20>>2]=W;g[b+(f*12|0)+24>>2]=X;g[b+(f*12|0)+28>>2]=Y;l=d+2|0;g[b+(l*12|0)+20>>2]=Z;g[b+(l*12|0)+24>>2]=_;g[b+(l*12|0)+28>>2]=$;c[b+(d<<2)+596>>2]=c[k>>2];c[b+(f<<2)+596>>2]=c[k+4>>2];c[b+(l<<2)+596>>2]=c[k+8>>2];c[b+(S<<2)+788>>2]=h;a[b+S+852>>0]=R;i=j;return 1}function EAb(a){a=a|0;return}function FAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function GAb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;j=i;i=i+48|0;l=j;if(!(a[b+16>>0]|0)){m=c[b+8>>2]|0;n=ea(g[e>>2]);o=ea(n*ea(g[m>>2]));p=m+4|0;q=ea(n*ea(g[p>>2]));r=m+8|0;s=ea(n*ea(g[r>>2]));n=ea(g[e+4>>2]);t=m+12|0;u=ea(n*ea(g[t>>2]));v=m+16|0;w=ea(n*ea(g[v>>2]));x=m+20|0;y=ea(o+u);u=ea(q+w);w=ea(s+ea(n*ea(g[x>>2])));n=ea(g[e+8>>2]);z=m+24|0;s=ea(n*ea(g[z>>2]));A=m+28|0;q=ea(n*ea(g[A>>2]));B=m+32|0;o=ea(y+s);s=ea(u+q);q=ea(w+ea(n*ea(g[B>>2])));g[l>>2]=o;g[l+4>>2]=s;g[l+8>>2]=q;n=ea(g[f>>2]);w=ea(n*ea(g[m>>2]));u=ea(n*ea(g[p>>2]));y=ea(n*ea(g[r>>2]));n=ea(g[f+4>>2]);C=ea(n*ea(g[t>>2]));D=ea(n*ea(g[v>>2]));E=ea(w+C);C=ea(u+D);D=ea(y+ea(n*ea(g[x>>2])));n=ea(g[f+8>>2]);y=ea(n*ea(g[z>>2]));u=ea(n*ea(g[A>>2]));w=ea(E+y);y=ea(C+u);u=ea(D+ea(n*ea(g[B>>2])));g[l+12>>2]=w;g[l+16>>2]=y;g[l+20>>2]=u;n=ea(g[h>>2]);D=ea(n*ea(g[m>>2]));C=ea(n*ea(g[p>>2]));E=ea(n*ea(g[r>>2]));n=ea(g[h+4>>2]);F=ea(n*ea(g[t>>2]));G=ea(n*ea(g[v>>2]));H=ea(D+F);F=ea(C+G);G=ea(E+ea(n*ea(g[x>>2])));n=ea(g[h+8>>2]);E=ea(n*ea(g[z>>2]));C=ea(n*ea(g[A>>2]));D=ea(H+E);E=ea(F+C);C=ea(G+ea(n*ea(g[B>>2])));g[l+24>>2]=D;g[l+28>>2]=E;g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}else{o=ea(g[e>>2]);g[l>>2]=o;s=ea(g[e+4>>2]);g[l+4>>2]=s;q=ea(g[e+8>>2]);g[l+8>>2]=q;w=ea(g[f>>2]);g[l+12>>2]=w;y=ea(g[f+4>>2]);g[l+16>>2]=y;u=ea(g[f+8>>2]);g[l+20>>2]=u;D=ea(g[h>>2]);g[l+24>>2]=D;E=ea(g[h+4>>2]);g[l+28>>2]=E;C=ea(g[h+8>>2]);g[l+32>>2]=C;I=C;J=E;K=D;L=u;M=y;N=w;O=q;P=s;Q=o}h=c[d+8>>2]|0;d=c[b+12>>2]|0;if(!d)R=56;else R=a[d+h>>0]|0;d=b+868|0;f=c[d>>2]|0;if((f|0)!=16){S=f;T=Q;U=P;V=O;W=N;X=M;Y=L;Z=K;_=J;$=I;aa=S+1|0;c[d>>2]=aa;ba=S*3|0;ca=b+(ba*12|0)+20|0;g[ca>>2]=T;da=b+(ba*12|0)+24|0;g[da>>2]=U;fa=b+(ba*12|0)+28|0;g[fa>>2]=V;ga=ba+1|0;ha=b+(ga*12|0)+20|0;g[ha>>2]=W;ia=b+(ga*12|0)+24|0;g[ia>>2]=X;ja=b+(ga*12|0)+28|0;g[ja>>2]=Y;ka=ba+2|0;la=b+(ka*12|0)+20|0;g[la>>2]=Z;ma=b+(ka*12|0)+24|0;g[ma>>2]=_;na=b+(ka*12|0)+28|0;g[na>>2]=$;oa=c[k>>2]|0;pa=b+(ba<<2)+596|0;c[pa>>2]=oa;qa=k+4|0;ra=c[qa>>2]|0;sa=b+(ga<<2)+596|0;c[sa>>2]=ra;ta=k+8|0;ua=c[ta>>2]|0;va=b+(ka<<2)+596|0;c[va>>2]=ua;wa=b+(S<<2)+788|0;c[wa>>2]=h;xa=b+S+852|0;a[xa>>0]=R;i=j;return 1}f=b+880|0;e=16;B=b+852|0;A=b+788|0;z=b+596|0;x=b+20|0;while(1){e=e+-1|0;gSa(f,x,c[A>>2]|0,a[B>>0]|0,z)|0;if(!e)break;else{B=B+1|0;A=A+4|0;z=z+12|0;x=x+36|0}}c[d>>2]=0;I=ea(g[l>>2]);J=ea(g[l+4>>2]);K=ea(g[l+8>>2]);L=ea(g[l+12>>2]);M=ea(g[l+16>>2]);N=ea(g[l+20>>2]);O=ea(g[l+24>>2]);P=ea(g[l+28>>2]);S=0;T=I;U=J;V=K;W=L;X=M;Y=N;Z=O;_=P;$=ea(g[l+32>>2]);aa=S+1|0;c[d>>2]=aa;ba=S*3|0;ca=b+(ba*12|0)+20|0;g[ca>>2]=T;da=b+(ba*12|0)+24|0;g[da>>2]=U;fa=b+(ba*12|0)+28|0;g[fa>>2]=V;ga=ba+1|0;ha=b+(ga*12|0)+20|0;g[ha>>2]=W;ia=b+(ga*12|0)+24|0;g[ia>>2]=X;ja=b+(ga*12|0)+28|0;g[ja>>2]=Y;ka=ba+2|0;la=b+(ka*12|0)+20|0;g[la>>2]=Z;ma=b+(ka*12|0)+24|0;g[ma>>2]=_;na=b+(ka*12|0)+28|0;g[na>>2]=$;oa=c[k>>2]|0;pa=b+(ba<<2)+596|0;c[pa>>2]=oa;qa=k+4|0;ra=c[qa>>2]|0;sa=b+(ga<<2)+596|0;c[sa>>2]=ra;ta=k+8|0;ua=c[ta>>2]|0;va=b+(ka<<2)+596|0;c[va>>2]=ua;wa=b+(S<<2)+788|0;c[wa>>2]=h;xa=b+S+852|0;a[xa>>0]=R;i=j;return 1}function HAb(a){a=a|0;return}function IAb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function JAb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*36|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?420304:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*36|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2]);g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);g[k+28>>2]=ea(g[f+28>>2]);g[k+32>>2]=ea(g[f+32>>2])}k=k+36|0;if(k>>>0>=e>>>0)break;else f=f+36|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function KAb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!d)f=0;else{g=mKa()|0;h=c[(c[g>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;f=Bn[h&255](g,d,k?543296:544544,537640,558)|0}k=c[b+4>>2]|0;g=f+k|0;h=c[b>>2]|0;if((k|0)>0){k=f;j=h;while(1){if(k)a[k>>0]=a[j>>0]|0;k=k+1|0;if((k|0)==(g|0))break;else j=j+1|0}l=c[b>>2]|0}else l=h;h=b+8|0;if((c[h>>2]|0)<0|(l|0)==0){c[b>>2]=f;c[h>>2]=d;i=e;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,l);c[b>>2]=f;c[h>>2]=d;i=e;return}function LAb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0;d=i;e=ea(g[b+4>>2]);f=ea(S(ea(e)));h=ea(g[b+8>>2]);j=ea(S(ea(h)));k=ea(g[c+4>>2]);l=ea(g[c+8>>2]);if(!(k>=l)){if(f<ea(9.99999997e-07)){if(h>ea(0.0))m=l;else m=ea(-l);g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=m;i=d;return}}else if(j<ea(9.99999997e-07)){if(e>ea(0.0))n=k;else n=ea(-k);g[a>>2]=ea(0.0);g[a+4>>2]=n;g[a+8>>2]=ea(0.0);i=d;return}n=ea(g[c>>2]);m=ea(n*n);o=ea(k*k);p=ea(l*l);q=ea(n*ea(0.0));n=ea(f*k);f=ea(j*l);j=ea(n-o);r=ea(f-p);s=ea(q*ea(0.0));q=ea(ea(s*s)*ea(0.0));c=0;s=j>r?j:r;while(1){t=ea(ea(1.0)/ea(o+s));u=ea(ea(1.0)/ea(p+s));r=ea(n*t);j=ea(f*u);v=ea(r*r);r=ea(j*j);j=ea(ea(v+r)+ea(-1.0));if(j<ea(.0000999999974)){w=12;break}s=ea(s-ea(j/ea(ea(ea(q+ea(t*v))+ea(u*r))*ea(-2.0))));c=c+1|0;if(c>>>0>=20){w=14;break}}if((w|0)==12){q=ea(t*ea(o*e));s=ea(u*ea(p*h));g[a>>2]=ea(ea(m*ea(g[b>>2]))*ea(0.0));g[a+4>>2]=q;g[a+8>>2]=s;i=d;return}else if((w|0)==14){s=ea(t*ea(o*e));e=ea(u*ea(p*h));h=ea(s/k);k=ea(e/l);l=ea(ea(1.0)/ea(T(ea(ea(h*h)+ea(k*k)))));k=ea(s*l);s=ea(e*l);g[a>>2]=ea(ea(ea(m*ea(g[b>>2]))*ea(0.0))*l);g[a+4>>2]=k;g[a+8>>2]=s;i=d;return}}function MAb(b,d,e,f,h,j,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=0,ac=0,bc=0,cc=0,dc=Im,ec=Im,fc=0,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=0,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=0,bd=0,cd=Im,dd=Im,ed=Im,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=Im,md=Im,nd=Im,od=Im;m=i;i=i+512|0;n=m;o=m+296|0;p=m+120|0;q=m+136|0;r=m+52|0;s=m+500|0;t=m+332|0;u=m+400|0;v=m+444|0;w=m+216|0;x=m+268|0;y=m+36|0;z=m+56|0;A=m+232|0;B=m+48|0;C=m+84|0;D=m+384|0;E=m+408|0;F=m+472|0;G=q+64|0;H=q+68|0;I=q+72|0;c[I>>2]=0;J=q+76|0;a[G>>0]=1;c[H>>2]=q;c[J>>2]=16;K=mo[c[(c[d>>2]|0)+104>>2]&4095](d)|0;c[r>>2]=0;_Gb(q,K,r);kn[c[(c[d>>2]|0)+108>>2]&511](d,c[H>>2]|0,c[I>>2]|0,0)|0;d=(e|0)!=0;r=d?e:f;L=ea(g[r>>2]);a:do if(((g[k>>2]=L,c[k>>2]|0)&2139095040)>>>0<2139095040){do if(c[I>>2]|0){e=u+4|0;K=t+48|0;M=t+4|0;N=t+8|0;O=t+12|0;P=t+16|0;Q=t+20|0;R=t+24|0;S=t+28|0;T=t+32|0;U=t+36|0;V=t+40|0;W=t+44|0;X=v+4|0;Y=v+8|0;Z=v+12|0;_=n+4|0;$=n+8|0;aa=n+12|0;ba=n+16|0;ca=n+20|0;da=n+24|0;fa=n+28|0;ga=n+32|0;ha=v+16|0;ia=w+4|0;ja=w+8|0;ka=w+12|0;la=x+4|0;ma=x+8|0;na=x+12|0;oa=n+4|0;pa=n+8|0;qa=n+12|0;ra=n+16|0;sa=n+20|0;ta=n+24|0;ua=n+28|0;va=n+32|0;wa=x+16|0;xa=y+4|0;ya=y+8|0;za=z+4|0;Aa=z+8|0;Ba=z+12|0;Ca=n+4|0;Da=n+8|0;Ea=n+12|0;Fa=n+16|0;Ga=n+20|0;Ha=n+24|0;Ia=n+28|0;Ja=n+32|0;Ka=z+16|0;La=A+4|0;Ma=A+8|0;Na=A+12|0;Oa=A+16|0;Pa=A+20|0;Qa=A+24|0;Ra=A+28|0;Sa=A+32|0;Ta=A+4|0;Ua=C+4|0;Va=C+8|0;Wa=C+12|0;Xa=C+16|0;Ya=C+20|0;Za=C+24|0;_a=C+28|0;$a=C+32|0;ab=D+4|0;bb=D+8|0;cb=F+4|0;db=F+8|0;eb=F+12|0;fb=n+4|0;gb=n+8|0;hb=n+12|0;ib=n+16|0;jb=n+20|0;kb=n+24|0;lb=n+28|0;mb=n+32|0;nb=F+16|0;ob=A+16|0;pb=n+12|0;qb=pb+4|0;rb=n+32|0;sb=n+4|0;tb=n+8|0;ub=pb+8|0;pb=o+4|0;vb=o+8|0;wb=o+12|0;xb=o+16|0;yb=o+20|0;zb=o+24|0;Ab=o+28|0;Bb=o+32|0;Cb=p+4|0;Db=p+8|0;Eb=p+12|0;Fb=E+4|0;Gb=E+8|0;Hb=E+12|0;Ib=E+16|0;Jb=E+20|0;Kb=E+24|0;Lb=E+28|0;Mb=E+32|0;Nb=ea(0.0);Ob=ea(0.0);Pb=ea(0.0);Qb=ea(0.0);Rb=ea(0.0);Sb=ea(0.0);Tb=ea(0.0);Ub=ea(0.0);Vb=ea(0.0);Wb=ea(0.0);Xb=ea(0.0);Yb=ea(0.0);Zb=ea(0.0);_b=L;$b=0;ac=0;while(1){bc=c[(c[H>>2]|0)+($b<<2)>>2]|0;In[c[(c[bc>>2]|0)+136>>2]&4095](s,bc);if((a[s>>0]&1)!=0|j){if(b){if(ac>>>0>=h>>>0){cc=10;break}dc=ea(g[r+(ac<<2)>>2]);if(((g[k>>2]=dc,c[k>>2]|0)&2139095040)>>>0<2139095040)ec=dc;else{cc=9;break}}else ec=_b;bc=c[(c[H>>2]|0)+($b<<2)>>2]|0;fc=mo[c[(c[bc>>2]|0)+24>>2]&4095](bc)|0;if(!fc){c[u>>2]=0;g[e>>2]=ea(0.0);bc=c[(c[H>>2]|0)+($b<<2)>>2]|0;_n[c[(c[bc>>2]|0)+40>>2]&4095](bc,u)|0;bc=c[(c[H>>2]|0)+($b<<2)>>2]|0;In[c[(c[bc>>2]|0)+72>>2]&4095](v,bc);dc=ea(g[e>>2]);gc=ea(dc*ea(dc*ea(dc*ea(4.18879032))));hc=ea(ea(dc*ea(dc*gc))*ea(.400000006));g[K>>2]=gc;g[t>>2]=hc;g[M>>2]=ea(0.0);g[N>>2]=ea(0.0);g[O>>2]=ea(0.0);g[P>>2]=hc;g[Q>>2]=ea(0.0);g[R>>2]=ea(0.0);g[S>>2]=ea(0.0);g[T>>2]=hc;g[U>>2]=ea(0.0);g[V>>2]=ea(0.0);g[W>>2]=ea(0.0);hc=ea(g[v>>2]);gc=ea(g[X>>2]);dc=ea(g[Y>>2]);ic=ea(g[Z>>2]);jc=ea(hc+hc);kc=ea(gc+gc);lc=ea(dc+dc);mc=ea(hc*jc);hc=ea(gc*kc);nc=ea(dc*lc);oc=ea(jc*gc);gc=ea(jc*dc);pc=ea(jc*ic);jc=ea(kc*dc);dc=ea(kc*ic);kc=ea(lc*ic);ic=ea(oc+kc);lc=ea(gc-dc);g[n>>2]=ea(ea(ea(1.0)-hc)-nc);g[_>>2]=ic;g[$>>2]=lc;lc=ea(ea(1.0)-mc);mc=ea(lc-nc);nc=ea(jc+pc);g[aa>>2]=ea(oc-kc);g[ba>>2]=mc;g[ca>>2]=nc;nc=ea(jc-pc);pc=ea(lc-hc);g[da>>2]=ea(gc+dc);g[fa>>2]=nc;g[ga>>2]=pc;$Gb(t,n);lU(t,ha)}else if((fc|0)==4){c[A>>2]=4;g[La>>2]=ea(1.0);g[Ma>>2]=ea(1.0);g[Na>>2]=ea(1.0);g[Oa>>2]=ea(0.0);g[Pa>>2]=ea(0.0);g[Qa>>2]=ea(0.0);g[Ra>>2]=ea(1.0);c[Sa>>2]=0;bc=c[(c[H>>2]|0)+($b<<2)>>2]|0;_n[c[(c[bc>>2]|0)+52>>2]&4095](bc,A)|0;bc=c[Sa>>2]|0;Dn[c[(c[bc>>2]|0)+48>>2]&511](bc,B,C,D);pc=ea(g[Ta>>2]);bc=pc==ea(1.0);nc=ea(g[Ma>>2]);qc=bc&nc==ea(1.0);if(qc&ea(g[Na>>2])==ea(1.0)){dc=ea(g[C>>2]);gc=ea(g[Ua>>2]);hc=ea(g[Va>>2]);lc=ea(g[Wa>>2]);jc=ea(g[Xa>>2]);mc=ea(g[Ya>>2]);kc=ea(g[Za>>2]);oc=ea(g[_a>>2]);rc=dc;sc=gc;tc=hc;uc=lc;vc=jc;wc=mc;xc=kc;yc=oc;zc=ea(g[$a>>2])}else{oc=ea(pc*nc);kc=ea(g[Na>>2]);mc=ea(oc*kc);g[B>>2]=ea(ea(g[B>>2])*mc);mc=ea(ea(g[D>>2])*ea(2.0));oc=ea(ea(g[ab>>2])*ea(2.0));jc=ea(ea(g[bb>>2])*ea(2.0));lc=ea(g[Ra>>2]);hc=ea(ea(lc*lc)+ea(-.5));gc=ea(g[ob>>2]);dc=ea(mc*gc);ic=ea(g[Pa>>2]);Ac=ea(dc+ea(oc*ic));dc=ea(g[Qa>>2]);Bc=ea(Ac+ea(jc*dc));Ac=ea(ea(pc*ea(ea(gc*Bc)+ea(ea(mc*hc)+ea(lc*ea(ea(jc*ic)-ea(oc*dc))))))*ea(2.0));pc=ea(ea(nc*ea(ea(ic*Bc)+ea(ea(oc*hc)+ea(lc*ea(ea(mc*dc)-ea(jc*gc))))))*ea(2.0));nc=ea(ea(kc*ea(ea(ea(jc*hc)+ea(lc*ea(ea(oc*gc)-ea(mc*ic))))+ea(dc*Bc)))*ea(2.0));Bc=ea(ea(dc*nc)+ea(ea(gc*Ac)+ea(ic*pc)));mc=ea(ea(ic*Bc)+ea(ea(hc*pc)-ea(lc*ea(ea(dc*Ac)-ea(gc*nc)))));oc=ea(ea(ea(hc*nc)-ea(lc*ea(ea(gc*pc)-ea(ic*Ac))))+ea(dc*Bc));g[D>>2]=ea(ea(gc*Bc)+ea(ea(hc*Ac)-ea(lc*ea(ea(ic*nc)-ea(dc*pc)))));g[ab>>2]=mc;g[bb>>2]=oc;aHb(n,C,ob);oc=ea(g[n>>2]);mc=ea(g[qb>>2]);pc=ea(g[rb>>2]);dc=ea(ea(ea(oc*ea(.5))+ea(mc*ea(.5)))+ea(pc*ea(.5)));nc=ea(dc-oc);oc=ea(dc-mc);mc=ea(dc-pc);pc=ea(g[Ta>>2]);dc=ea(pc*nc);nc=ea(g[Ma>>2]);ic=ea(nc*oc);oc=ea(g[Na>>2]);lc=ea(pc*dc);dc=ea(nc*ic);ic=ea(oc*ea(mc*oc));mc=ea(dc+ic);Ac=ea(ic+lc);ic=ea(lc+dc);dc=ea(nc*ea(pc*ea(g[sb>>2])));lc=ea(oc*ea(pc*ea(g[tb>>2])));hc=ea(ea(pc*nc)*oc);pc=ea(hc*dc);dc=ea(hc*lc);lc=ea(hc*Ac);Ac=ea(hc*ea(oc*ea(nc*ea(g[ub>>2]))));nc=ea(hc*ic);g[o>>2]=ea(hc*mc);g[pb>>2]=pc;g[vb>>2]=dc;g[wb>>2]=pc;g[xb>>2]=lc;g[yb>>2]=Ac;g[zb>>2]=dc;g[Ab>>2]=Ac;g[Bb>>2]=nc;nc=ea(-ea(g[ob>>2]));Ac=ea(-ea(g[Pa>>2]));dc=ea(-ea(g[Qa>>2]));lc=ea(g[Ra>>2]);g[p>>2]=nc;g[Cb>>2]=Ac;g[Db>>2]=dc;g[Eb>>2]=lc;aHb(E,o,p);lc=ea(g[E>>2]);g[C>>2]=lc;dc=ea(g[Fb>>2]);g[Ua>>2]=dc;Ac=ea(g[Gb>>2]);g[Va>>2]=Ac;nc=ea(g[Hb>>2]);g[Wa>>2]=nc;pc=ea(g[Ib>>2]);g[Xa>>2]=pc;mc=ea(g[Jb>>2]);g[Ya>>2]=mc;hc=ea(g[Kb>>2]);g[Za>>2]=hc;ic=ea(g[Lb>>2]);g[_a>>2]=ic;oc=ea(g[Mb>>2]);g[$a>>2]=oc;rc=lc;sc=dc;tc=Ac;uc=nc;vc=pc;wc=mc;xc=hc;yc=ic;zc=oc}oc=ea(g[B>>2]);ic=ea(g[D>>2]);hc=ea(g[ab>>2]);mc=ea(g[bb>>2]);g[t>>2]=rc;g[M>>2]=sc;g[N>>2]=tc;g[O>>2]=uc;g[P>>2]=vc;g[Q>>2]=wc;g[R>>2]=xc;g[S>>2]=yc;g[T>>2]=zc;g[U>>2]=ic;g[V>>2]=hc;g[W>>2]=mc;g[K>>2]=oc;qc=c[(c[H>>2]|0)+($b<<2)>>2]|0;In[c[(c[qc>>2]|0)+72>>2]&4095](F,qc);oc=ea(g[F>>2]);mc=ea(g[cb>>2]);hc=ea(g[db>>2]);ic=ea(g[eb>>2]);pc=ea(oc+oc);nc=ea(mc+mc);Ac=ea(hc+hc);dc=ea(oc*pc);oc=ea(mc*nc);lc=ea(hc*Ac);Bc=ea(pc*mc);mc=ea(pc*hc);gc=ea(pc*ic);pc=ea(nc*hc);hc=ea(nc*ic);nc=ea(Ac*ic);ic=ea(Bc+nc);Ac=ea(mc-hc);g[n>>2]=ea(ea(ea(1.0)-oc)-lc);g[fb>>2]=ic;g[gb>>2]=Ac;Ac=ea(ea(1.0)-dc);dc=ea(Ac-lc);lc=ea(pc+gc);g[hb>>2]=ea(Bc-nc);g[ib>>2]=dc;g[jb>>2]=lc;lc=ea(pc-gc);gc=ea(Ac-oc);g[kb>>2]=ea(mc+hc);g[lb>>2]=lc;g[mb>>2]=gc;$Gb(t,n);lU(t,nb)}else if((fc|0)==2){c[y>>2]=2;g[xa>>2]=ea(0.0);g[ya>>2]=ea(0.0);qc=c[(c[H>>2]|0)+($b<<2)>>2]|0;_n[c[(c[qc>>2]|0)+44>>2]&4095](qc,y)|0;qc=c[(c[H>>2]|0)+($b<<2)>>2]|0;In[c[(c[qc>>2]|0)+72>>2]&4095](z,qc);gc=ea(g[xa>>2]);lc=ea(g[ya>>2]);hc=ea(gc*ea(gc*ea(3.14159274)));mc=ea(ea(ea(gc*ea(gc*gc))*ea(8.0))/ea(15.0));oc=ea(gc*ea(gc*lc));Ac=ea(hc*ea(mc+oc));pc=ea(lc*lc);dc=ea(hc*ea(ea(ea(ea(lc*pc)*ea(2.0))/ea(3.0))+ea(ea(ea(ea(gc*pc)*ea(4.0))/ea(3.0))+ea(mc+ea(ea(oc*ea(3.0))*ea(.5))))));g[K>>2]=ea(ea(gc*ea(gc*ea(gc*ea(4.18879032))))+ea(hc*ea(lc*ea(2.0))));g[t>>2]=Ac;g[M>>2]=ea(0.0);g[N>>2]=ea(0.0);g[O>>2]=ea(0.0);g[P>>2]=dc;g[Q>>2]=ea(0.0);g[R>>2]=ea(0.0);g[S>>2]=ea(0.0);g[T>>2]=dc;g[U>>2]=ea(0.0);g[V>>2]=ea(0.0);g[W>>2]=ea(0.0);dc=ea(g[z>>2]);Ac=ea(g[za>>2]);lc=ea(g[Aa>>2]);hc=ea(g[Ba>>2]);gc=ea(dc+dc);oc=ea(Ac+Ac);mc=ea(lc+lc);pc=ea(dc*gc);dc=ea(Ac*oc);nc=ea(lc*mc);Bc=ea(gc*Ac);Ac=ea(gc*lc);ic=ea(gc*hc);gc=ea(oc*lc);lc=ea(oc*hc);oc=ea(mc*hc);hc=ea(Bc+oc);mc=ea(Ac-lc);g[n>>2]=ea(ea(ea(1.0)-dc)-nc);g[Ca>>2]=hc;g[Da>>2]=mc;mc=ea(ea(1.0)-pc);pc=ea(mc-nc);nc=ea(gc+ic);g[Ea>>2]=ea(Bc-oc);g[Fa>>2]=pc;g[Ga>>2]=nc;nc=ea(gc-ic);ic=ea(mc-dc);g[Ha>>2]=ea(Ac+lc);g[Ia>>2]=nc;g[Ja>>2]=ic;$Gb(t,n);lU(t,Ka)}else if((fc|0)==3){c[w>>2]=3;g[ia>>2]=ea(0.0);g[ja>>2]=ea(0.0);g[ka>>2]=ea(0.0);fc=c[(c[H>>2]|0)+($b<<2)>>2]|0;_n[c[(c[fc>>2]|0)+36>>2]&4095](fc,w)|0;fc=c[(c[H>>2]|0)+($b<<2)>>2]|0;In[c[(c[fc>>2]|0)+72>>2]&4095](x,fc);ic=ea(g[ia>>2]);fc=ic!=ea(0.0);nc=fc?ic:ea(1.0);lc=ea(g[ja>>2]);if(lc!=ea(0.0))Cc=ea(lc*nc);else Cc=nc;nc=ea(g[ka>>2]);if(nc!=ea(0.0))Dc=ea(Cc*nc);else Dc=Cc;Ac=ea(Dc*ea(8.0));dc=ea(Ac*ea(.333333343));mc=ea(ic*ic);ic=ea(lc*lc);lc=ea(nc*nc);nc=ea(ea(ic+lc)*dc);gc=ea(ea(mc+lc)*dc);lc=ea(ea(mc+ic)*dc);g[K>>2]=Ac;g[t>>2]=nc;g[M>>2]=ea(0.0);g[N>>2]=ea(0.0);g[O>>2]=ea(0.0);g[P>>2]=gc;g[Q>>2]=ea(0.0);g[R>>2]=ea(0.0);g[S>>2]=ea(0.0);g[T>>2]=lc;g[U>>2]=ea(0.0);g[V>>2]=ea(0.0);g[W>>2]=ea(0.0);lc=ea(g[x>>2]);gc=ea(g[la>>2]);nc=ea(g[ma>>2]);Ac=ea(g[na>>2]);dc=ea(lc+lc);ic=ea(gc+gc);mc=ea(nc+nc);pc=ea(lc*dc);lc=ea(gc*ic);oc=ea(nc*mc);Bc=ea(dc*gc);gc=ea(dc*nc);hc=ea(dc*Ac);dc=ea(ic*nc);nc=ea(ic*Ac);ic=ea(mc*Ac);Ac=ea(Bc+ic);mc=ea(gc-nc);g[n>>2]=ea(ea(ea(1.0)-lc)-oc);g[oa>>2]=Ac;g[pa>>2]=mc;mc=ea(ea(1.0)-pc);pc=ea(mc-oc);oc=ea(dc+hc);g[qa>>2]=ea(Bc-ic);g[ra>>2]=pc;g[sa>>2]=oc;oc=ea(dc-hc);hc=ea(mc-lc);g[ta>>2]=ea(gc+nc);g[ua>>2]=oc;g[va>>2]=hc;$Gb(t,n);lU(t,wa)}else{cc=29;break}do if(!d){hc=ea(g[K>>2]);if(b){oc=ea(ec/hc);nc=ea(oc*ea(g[t>>2]));g[t>>2]=nc;gc=ea(oc*ea(g[M>>2]));g[M>>2]=gc;lc=ea(oc*ea(g[N>>2]));g[N>>2]=lc;mc=ea(oc*ea(g[O>>2]));g[O>>2]=mc;dc=ea(oc*ea(g[P>>2]));g[P>>2]=dc;pc=ea(oc*ea(g[Q>>2]));g[Q>>2]=pc;ic=ea(oc*ea(g[R>>2]));g[R>>2]=ic;Bc=ea(oc*ea(g[S>>2]));g[S>>2]=Bc;Ac=ea(oc*ea(g[T>>2]));g[T>>2]=Ac;jc=ea(oc*hc);g[K>>2]=jc;Ec=jc;Fc=nc;Gc=gc;Hc=lc;Ic=mc;Jc=dc;Kc=pc;Lc=ic;Mc=Bc;Nc=Ac;break}else{Ac=ea(g[t>>2]);Bc=ea(g[M>>2]);ic=ea(g[N>>2]);pc=ea(g[O>>2]);dc=ea(g[P>>2]);mc=ea(g[Q>>2]);lc=ea(g[R>>2]);gc=ea(g[S>>2]);Ec=hc;Fc=Ac;Gc=Bc;Hc=ic;Ic=pc;Jc=dc;Kc=mc;Lc=lc;Mc=gc;Nc=ea(g[T>>2]);break}}else{gc=ea(ec*ea(g[t>>2]));g[t>>2]=gc;lc=ea(ec*ea(g[M>>2]));g[M>>2]=lc;mc=ea(ec*ea(g[N>>2]));g[N>>2]=mc;dc=ea(ec*ea(g[O>>2]));g[O>>2]=dc;pc=ea(ec*ea(g[P>>2]));g[P>>2]=pc;ic=ea(ec*ea(g[Q>>2]));g[Q>>2]=ic;Bc=ea(ec*ea(g[R>>2]));g[R>>2]=Bc;Ac=ea(ec*ea(g[S>>2]));g[S>>2]=Ac;hc=ea(ec*ea(g[T>>2]));g[T>>2]=hc;nc=ea(ec*ea(g[K>>2]));g[K>>2]=nc;Ec=nc;Fc=gc;Gc=lc;Hc=mc;Ic=dc;Jc=pc;Kc=ic;Lc=Bc;Mc=Ac;Nc=hc}while(0);hc=ea(Nb+Ec);Ac=ea(Nb*Ob);Bc=ea(Nb*Pb);ic=ea(Nb*Qb);pc=ea(Ec*ea(g[U>>2]));dc=ea(Ec*ea(g[V>>2]));mc=ea(ea(1.0)/hc);Oc=hc;Pc=ea(Rb+Fc);Qc=ea(Sb+Gc);Rc=ea(Tb+Hc);Sc=ea(Ub+Ic);Tc=ea(Vb+Jc);Uc=ea(Wb+Kc);Vc=ea(Xb+Lc);Wc=ea(Yb+Mc);Xc=ea(Zb+Nc);Yc=ea(mc*ea(ic+ea(Ec*ea(g[W>>2]))));Zc=ea(mc*ea(Bc+dc));_c=ea(ea(Ac+pc)*mc);$c=ec;ad=ac+1|0}else{Oc=Nb;Pc=Rb;Qc=Sb;Rc=Tb;Sc=Ub;Tc=Vb;Uc=Wb;Vc=Xb;Wc=Yb;Xc=Zb;Yc=Qb;Zc=Pb;_c=Ob;$c=_b;ad=ac}$b=$b+1|0;if($b>>>0>=(c[I>>2]|0)>>>0){cc=31;break}else{Nb=Oc;Ob=_c;Pb=Zc;Qb=Yc;Rb=Pc;Sb=Qc;Tb=Rc;Ub=Sc;Vb=Tc;Wb=Uc;Xb=Vc;Yb=Wc;Zb=Xc;_b=$c;ac=ad}}if((cc|0)==9){dKa(bKa()|0,4,425800,148,426304,n);bd=0;break a}else if((cc|0)==10){dKa(bKa()|0,4,425800,155,426376,n);bd=0;break a}else if((cc|0)==29){dKa(bKa()|0,4,425800,234,426472,n);bd=0;break a}else if((cc|0)==31){if((ad|0)==0|(f|0)==0|b){cd=Yc;dd=Zc;ed=_c;fd=Pc;gd=Qc;hd=Rc;id=Sc;jd=Tc;kd=Uc;ld=Vc;md=Wc;nd=Xc;od=Oc;break}_b=ea($c/Oc);cd=Yc;dd=Zc;ed=_c;fd=ea(Pc*_b);gd=ea(Qc*_b);hd=ea(Rc*_b);id=ea(Sc*_b);jd=ea(Tc*_b);kd=ea(Uc*_b);ld=ea(Vc*_b);md=ea(Wc*_b);nd=ea(Xc*_b);od=ea(Oc*_b);break}}else{cd=ea(0.0);dd=ea(0.0);ed=ea(0.0);fd=ea(0.0);gd=ea(0.0);hd=ea(0.0);id=ea(0.0);jd=ea(0.0);kd=ea(0.0);ld=ea(0.0);md=ea(0.0);nd=ea(0.0);od=ea(0.0)}while(0);g[l>>2]=fd;g[l+4>>2]=gd;g[l+8>>2]=hd;g[l+12>>2]=id;g[l+16>>2]=jd;g[l+20>>2]=kd;g[l+24>>2]=ld;g[l+28>>2]=md;g[l+32>>2]=nd;g[l+36>>2]=ed;g[l+40>>2]=dd;g[l+44>>2]=cd;g[l+48>>2]=od;bd=1}else{dKa(bKa()|0,4,425800,130,426304,n);bd=0}while(0);n=c[J>>2]|0;if(!((n&2147483647|0)!=0&(n|0)>-1)){i=m;return bd|0}n=c[H>>2]|0;if((q|0)==(n|0)){a[G>>0]=0;i=m;return bd|0}if(!n){i=m;return bd|0}G=mKa()|0;In[c[(c[G>>2]|0)+12>>2]&4095](G,n);i=m;return bd|0}function NAb(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;l=i;i=i+192|0;m=l;n=l+40|0;o=l+116|0;p=l+80|0;q=l+128|0;r=l+12|0;s=l+56|0;t=l+152|0;if(h){u=ea(-ea(g[f>>2]));v=ea(-ea(g[f+4>>2]));w=ea(-ea(g[f+8>>2]));g[n>>2]=u;g[n+4>>2]=v;g[n+8>>2]=w;lU(a,n)}else{n=a+36|0;w=ea(g[n>>2]);h=a+40|0;v=ea(g[h>>2]);x=a+44|0;u=ea(g[x>>2]);g[f>>2]=w;g[f+4>>2]=v;g[f+8>>2]=u;u=ea(-ea(g[n>>2]));v=ea(-ea(g[h>>2]));w=ea(-ea(g[x>>2]));g[m>>2]=u;g[m+4>>2]=v;g[m+8>>2]=w;lU(a,m)}g[e>>2]=ea(g[a+48>>2]);g[p>>2]=ea(g[a>>2]);g[p+4>>2]=ea(g[a+4>>2]);g[p+8>>2]=ea(g[a+8>>2]);g[p+12>>2]=ea(g[a+12>>2]);g[p+16>>2]=ea(g[a+16>>2]);g[p+20>>2]=ea(g[a+20>>2]);g[p+24>>2]=ea(g[a+24>>2]);g[p+28>>2]=ea(g[a+28>>2]);g[p+32>>2]=ea(g[a+32>>2]);wKa(o,p,d);w=ea(g[o>>2]);g[b>>2]=w;v=ea(g[o+4>>2]);p=b+4|0;g[p>>2]=v;u=ea(g[o+8>>2]);o=b+8|0;g[o>>2]=u;if(w>ea(0.0)?v>ea(0.0)&u>ea(0.0):0){i=l;return}a=bKa()|0;c[m>>2]=k;dKa(a,2,425800,86,426168,m);go[c[(c[j>>2]|0)+40>>2]&63](q,j,ea(1.00999999));In[c[(c[j>>2]|0)+84>>2]&4095](r,j);u=ea(g[r+16>>2]);v=ea(g[r+20>>2]);w=ea(u*ea(-2.0));u=ea(v*ea(-2.0));v=ea(ea(g[r+24>>2])*ea(-2.0));y=ea(g[r+12>>2]);z=ea(ea(y*y)+ea(-.5));A=ea(g[r>>2]);B=ea(w*A);C=ea(g[r+4>>2]);D=ea(B+ea(u*C));B=ea(g[r+8>>2]);E=ea(D+ea(v*B));D=ea(ea(A*E)+ea(ea(w*z)-ea(y*ea(ea(v*C)-ea(u*B)))));F=ea(ea(C*E)+ea(ea(u*z)-ea(y*ea(ea(w*B)-ea(v*A)))));G=ea(ea(ea(v*z)-ea(y*ea(ea(u*A)-ea(w*C))))+ea(B*E));E=ea(-C);C=ea(-B);g[t>>2]=ea(-A);g[t+4>>2]=E;g[t+8>>2]=C;g[t+12>>2]=y;g[t+16>>2]=D;g[t+20>>2]=F;g[t+24>>2]=G;e_a(s,t,q);G=ea(g[s>>2]);g[q>>2]=G;F=ea(g[s+4>>2]);g[q+4>>2]=F;D=ea(g[s+8>>2]);g[q+8>>2]=D;y=ea(g[s+12>>2]);g[q+12>>2]=y;C=ea(g[s+16>>2]);g[q+16>>2]=C;E=ea(g[s+20>>2]);g[q+20>>2]=E;A=ea(ea(y-G)*ea(.5));G=ea(ea(C-F)*ea(.5));F=ea(ea(E-D)*ea(.5));q=A!=ea(0.0);D=q?A:ea(1.0);if(G!=ea(0.0))H=ea(G*D);else H=D;if(F!=ea(0.0))I=ea(F*H);else I=H;H=ea(I*ea(8.0));I=ea(H*ea(.333333343));D=ea(A*A);A=ea(G*G);G=ea(F*F);F=ea(ea(A+G)*I);E=ea(ea(D+G)*I);G=ea(ea(D+A)*I);I=ea(ea(g[e>>2])/H);H=ea(I*E);E=ea(I*G);g[b>>2]=ea(I*F);g[p>>2]=H;g[o>>2]=E;g[d>>2]=ea(0.0);g[d+4>>2]=ea(0.0);g[d+8>>2]=ea(0.0);g[d+12>>2]=ea(1.0);i=l;return}function OAb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+12|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else{f=c[c[a>>2]>>2]|0;h=Bn[c[(c[f>>2]|0)+8>>2]&255](f,g<<3,527016,537640,558)|0}f=a+8|0;j=c[f>>2]|0;k=h+(j<<3)|0;l=a+4|0;if((j|0)>0){m=h;n=c[l>>2]|0;while(1){if(m){o=n;p=c[o+4>>2]|0;q=m;c[q>>2]=c[o>>2];c[q+4>>2]=p}m=m+8|0;if(m>>>0>=k>>>0)break;else n=n+8|0}r=c[f>>2]|0}else r=j;j=h+(r<<3)|0;if(j){r=b;b=c[r+4>>2]|0;n=j;c[n>>2]=c[r>>2];c[n+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[l>>2]|0,(b|0)!=0):0){n=c[c[a>>2]>>2]|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,b)}c[l>>2]=h;c[e>>2]=g;g=c[f>>2]|0;c[f>>2]=g+1;i=d;return h+(g<<3)|0}function PAb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+272|0;f=b;h=b+8|0;j=c[e>>2]|0;k=a[j>>0]|0;a:do if(!(k<<24>>24))l=j;else{m=j;n=k;while(1){o=m+1|0;if(!(FDi(n&255)|0)){l=m;break a}n=a[o>>0]|0;if(!(n<<24>>24)){l=o;break}else m=o}}while(0);PEi(h|0,0,256)|0;k=h+255|0;c[f>>2]=k;j=a[l>>0]|0;b:do if(!(j<<24>>24))p=h;else{m=l;n=j;o=h;while(1){q=(FDi(n&255)|0)==0;if(!(q&o>>>0<(c[f>>2]|0)>>>0)){p=o;break b}q=o+1|0;a[o>>0]=a[m>>0]|0;m=m+1|0;n=a[m>>0]|0;if(!(n<<24>>24)){p=q;break}else o=q}}while(0);a[p>>0]=0;r=ea(+yEi(h,f));p=(e|0)==0;if(p)s=0;else{j=l+((c[f>>2]|0)-h)|0;c[e>>2]=j;s=j}g[d>>2]=r;j=d+4|0;l=a[s>>0]|0;c:do if(!(l<<24>>24))t=s;else{o=s;n=l;while(1){m=o+1|0;if(!(FDi(n&255)|0)){t=o;break c}n=a[m>>0]|0;if(!(n<<24>>24)){t=m;break}else o=m}}while(0);PEi(h|0,0,256)|0;c[f>>2]=k;l=a[t>>0]|0;d:do if(!(l<<24>>24))u=h;else{s=t;o=l;n=h;while(1){m=(FDi(o&255)|0)==0;if(!(m&n>>>0<(c[f>>2]|0)>>>0)){u=n;break d}m=n+1|0;a[n>>0]=a[s>>0]|0;s=s+1|0;o=a[s>>0]|0;if(!(o<<24>>24)){u=m;break}else n=m}}while(0);a[u>>0]=0;r=ea(+yEi(h,f));if(p)v=0;else{u=t+((c[f>>2]|0)-h)|0;c[e>>2]=u;v=u}g[j>>2]=r;j=d+8|0;d=a[v>>0]|0;e:do if(!(d<<24>>24))w=v;else{u=v;t=d;while(1){l=u+1|0;if(!(FDi(t&255)|0)){w=u;break e}t=a[l>>0]|0;if(!(t<<24>>24)){w=l;break}else u=l}}while(0);PEi(h|0,0,256)|0;c[f>>2]=k;k=a[w>>0]|0;f:do if(!(k<<24>>24))x=h;else{d=w;v=k;u=h;while(1){t=(FDi(v&255)|0)==0;if(!(t&u>>>0<(c[f>>2]|0)>>>0)){x=u;break f}t=u+1|0;a[u>>0]=a[d>>0]|0;d=d+1|0;v=a[d>>0]|0;if(!(v<<24>>24)){x=t;break}else u=t}}while(0);a[x>>0]=0;r=ea(+yEi(h,f));if(p){g[j>>2]=r;i=b;return}c[e>>2]=w+((c[f>>2]|0)-h);g[j>>2]=r;i=b;return}function QAb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+12|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else{f=c[c[a>>2]>>2]|0;h=Bn[c[(c[f>>2]|0)+8>>2]&255](f,g<<2,527016,537640,558)|0}f=a+8|0;j=c[f>>2]|0;k=h+(j<<2)|0;l=a+4|0;if((j|0)>0){m=h;n=c[l>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=k>>>0)break;else n=n+4|0}o=c[f>>2]|0}else o=j;j=h+(o<<2)|0;if(j)c[j>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[l>>2]|0,(b|0)!=0):0){j=c[c[a>>2]>>2]|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,b)}c[l>>2]=h;c[e>>2]=g;g=c[f>>2]|0;c[f>>2]=g+1;i=d;return h+(g<<2)|0}function RAb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=b+24|0;h=c[g>>2]|0;j=(h|0)==0;a:do if(!j){k=c[d>>2]|0;l=a[k>>0]|0;if(!(l<<24>>24))m=5381;else{n=l;l=5381;o=k;while(1){p=l*33^n<<24>>24;o=o+1|0;n=a[o>>0]|0;if(!(n<<24>>24)){m=p;break}else l=p}}l=m&h+-1;n=c[(c[b+16>>2]|0)+(l<<2)>>2]|0;if((n|0)==-1)q=l;else{o=c[b+8>>2]|0;p=b+12|0;r=n;while(1){if(!(HEi(c[o+(r<<3)>>2]|0,k)|0))break;n=c[(c[p>>2]|0)+(r<<2)>>2]|0;if((n|0)==-1){q=l;break a}else r=n}a[e>>0]=1;s=o+(r<<3)|0;i=f;return s|0}}else q=0;while(0);a[e>>0]=0;e=b+40|0;if((c[e>>2]|0)==(c[b+20>>2]|0)){m=j?16:h<<1;if(h>>>0<m>>>0){VUa(b,m);t=c[g>>2]|0}else t=h;h=c[d>>2]|0;d=a[h>>0]|0;if(!(d<<24>>24))u=5381;else{g=d;d=5381;m=h;while(1){h=d*33^g<<24>>24;m=m+1|0;g=a[m>>0]|0;if(!(g<<24>>24)){u=h;break}else d=h}}v=u&t+-1}else v=q;q=b+32|0;t=c[q>>2]|0;c[q>>2]=t+1;q=(c[b+16>>2]|0)+(v<<2)|0;c[(c[b+12>>2]|0)+(t<<2)>>2]=c[q>>2];c[q>>2]=t;c[e>>2]=(c[e>>2]|0)+1;e=b+36|0;c[e>>2]=(c[e>>2]|0)+1;s=(c[b+8>>2]|0)+(t<<3)|0;i=f;return s|0}function SAb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;d=i;if(!(c[b+236>>2]&2))e=U8(b+16|0)|0;else{f=b+8|0;h=c[f>>2]|0;if(!h){j=s4(c[b>>2]|0,(c[b+4>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+96|0}l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=ea(g[e+8>>2]);o=ea(g[b+176>>2]);p=ea(g[b+180>>2]);q=ea(g[b+184>>2]);r=ea(g[b+188>>2]);s=ea(o+o);t=ea(p+p);u=ea(q+q);v=ea(p*t);w=ea(q*u);x=ea(s*p);p=ea(s*q);y=ea(s*r);z=ea(t*q);q=ea(t*r);t=ea(u*r);r=ea(ea(ea(1.0)-v)-w);u=ea(x+t);A=ea(p-q);B=ea(x-t);t=ea(ea(1.0)-ea(o*s));s=ea(t-w);w=ea(z+y);o=ea(p+q);q=ea(z-y);y=ea(t-v);v=ea(l*r);t=ea(l*u);z=ea(l*A);l=ea(m*B);p=ea(m*s);x=ea(m*w);m=ea(n*o);C=ea(n*q);D=ea(n*y);g[a>>2]=ea(ea(o*m)+ea(ea(r*v)+ea(B*l)));b=a+12|0;g[b+4>>2]=ea(ea(q*C)+ea(ea(u*t)+ea(s*p)));e=a+24|0;g[e+8>>2]=ea(ea(y*D)+ea(ea(A*z)+ea(w*x)));x=ea(ea(q*m)+ea(ea(u*v)+ea(s*l)));g[a+4>>2]=x;g[b>>2]=x;x=ea(ea(y*m)+ea(ea(A*v)+ea(w*l)));g[a+8>>2]=x;g[e>>2]=x;x=ea(ea(y*C)+ea(ea(A*t)+ea(w*p)));g[b+8>>2]=x;g[e+4>>2]=x;i=d;return}function TAb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im;f=i;h=c[b+4>>2]|0;j=h>>>30;if((j|0)==2){k=c[b>>2]|0;if(!(a[k+2416>>0]|0)){l=k;m=4}}else if((j|0)!=3){l=c[b>>2]|0;m=4}if((m|0)==4){N8(b+16|0,c[l+1256>>2]|0,d,e);i=f;return}l=b+8|0;m=c[l>>2]|0;if(!m){j=s4(c[b>>2]|0,h>>>24&15)|0;c[l>>2]=j;n=j}else n=m;m=n+232|0;if(d){j=n+220|0;o=ea(g[d>>2]);g[j>>2]=ea(o+ea(g[j>>2]));o=ea(g[d+4>>2]);j=n+224|0;g[j>>2]=ea(o+ea(g[j>>2]));o=ea(g[d+8>>2]);d=n+228|0;g[d>>2]=ea(o+ea(g[d>>2]))}if(e){o=ea(g[e>>2]);g[m>>2]=ea(o+ea(g[m>>2]));o=ea(g[e+4>>2]);m=n+236|0;g[m>>2]=ea(o+ea(g[m>>2]));o=ea(g[e+8>>2]);e=n+240|0;g[e>>2]=ea(o+ea(g[e>>2]))}r4(c[b>>2]|0,b);e=b+236|0;c[e>>2]=c[e>>2]|16384;i=f;return}function UAb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im;f=i;h=c[b+4>>2]|0;j=h>>>30;if((j|0)==2){k=c[b>>2]|0;if(!(a[k+2416>>0]|0)){l=k;m=4}}else if((j|0)!=3){l=c[b>>2]|0;m=4}if((m|0)==4){Q8(b+16|0,c[l+1256>>2]|0,d,e);i=f;return}l=b+8|0;m=c[l>>2]|0;if(!m){j=s4(c[b>>2]|0,h>>>24&15)|0;c[l>>2]=j;n=j}else n=m;m=n+256|0;if(d){j=n+244|0;o=ea(g[d>>2]);g[j>>2]=ea(o+ea(g[j>>2]));o=ea(g[d+4>>2]);j=n+248|0;g[j>>2]=ea(o+ea(g[j>>2]));o=ea(g[d+8>>2]);d=n+252|0;g[d>>2]=ea(o+ea(g[d>>2]))}if(e){o=ea(g[e>>2]);g[m>>2]=ea(o+ea(g[m>>2]));o=ea(g[e+4>>2]);m=n+260|0;g[m>>2]=ea(o+ea(g[m>>2]));o=ea(g[e+8>>2]);e=n+264|0;g[e>>2]=ea(o+ea(g[e>>2]))}r4(c[b>>2]|0,b);e=b+236|0;c[e>>2]=c[e>>2]|32768;i=f;return}function VAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+4|0;f=d;g=d+17|0;h=d+16|0;c[e>>2]=0;j=e+4|0;c[j>>2]=0;k=e+8|0;c[k>>2]=0;l=b+292|0;m=c[l>>2]|0;if(!m){n=0;o=0}else{p=0;q=0;r=m;while(1){c[f>>2]=r;if(p>>>0>q>>>0){m=(c[e>>2]|0)+(q<<2)|0;if(m)c[m>>2]=r;c[j>>2]=q+1}else YAb(e,f)|0;m=c[c[l>>2]>>2]|0;c[l>>2]=m;if(!m)break;p=c[k>>2]&2147483647;q=c[j>>2]|0;r=m}n=c[e>>2]|0;o=c[j>>2]|0}ZAb(n,o,g,b);g=b+264|0;j=b+268|0;ZAb(c[g>>2]|0,c[j>>2]|0,h,b);h=c[g>>2]|0;g=c[j>>2]|0;j=h+(g<<2)|0;if(g){g=b+276|0;b=n;e=h;while(1){h=c[e>>2]|0;r=h+((c[g>>2]|0)*48|0)|0;if((h|0)==(r|0))s=b;else{q=b;p=h;while(1){if((q|0)!=(n+(o<<2)|0)?(c[q>>2]|0)==(p|0):0)t=q+4|0;else u=16;do if((u|0)==16){u=0;h=c[p+44>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1){h=c[p+36>>2]|0;if((p|0)==(h|0)){a[p+32>>0]=0;t=q;break}if(h){l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,h);t=q}else t=q}else t=q}while(0);p=p+48|0;if((p|0)==(r|0)){s=t;break}else q=t}}e=e+4|0;if((e|0)==(j|0))break;else b=s}}s=c[k>>2]|0;if((s|0)<0|(s&2147483647|0)==0|(n|0)==0){i=d;return}s=mKa()|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,n);i=d;return}function WAb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?432584:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function XAb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?432584:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function YAb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?432584:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function ZAb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?432584:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?432584:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function _Ab(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if(!e)g=0;else{h=e<<1;j=d+8|0;if(!((a[j>>0]|0)==0&h>>>0<9))if(!h)k=0;else{l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;k=Bn[m&255](l,h,o?541936:544544,537640,558)|0}else{a[j>>0]=1;k=d}g=k}k=c[d+16>>2]|0;j=g+(k<<1)|0;o=d+12|0;if((k|0)>0){k=g;h=c[o>>2]|0;while(1){if(k)b[k>>1]=b[h>>1]|0;k=k+2|0;if(k>>>0>=j>>>0)break;else h=h+2|0}}h=d+20|0;if((c[h>>2]|0)<=-1){c[o>>2]=g;c[h>>2]=e;i=f;return}j=c[o>>2]|0;if((d|0)==(j|0)){a[d+8>>0]=0;c[o>>2]=g;c[h>>2]=e;i=f;return}if(!j){c[o>>2]=g;c[h>>2]=e;i=f;return}d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,j);c[o>>2]=g;c[h>>2]=e;i=f;return}function $Ab(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b>>2]|0;h=ea(g[f+2844>>2]);j=b+4|0;k=c[j>>2]|0;l=k>>>30;if((l|0)==2){if(!(a[f+2416>>0]|0))m=3}else if((l|0)!=3)m=3;if((m|0)==3){g9(b+16|0,c[f+1256>>2]|0,d,h);c[b+232>>2]=0;g[b+228>>2]=h;i=e;return}l=b+8|0;n=c[l>>2]|0;if(!n){o=s4(f,k>>>24&15)|0;c[l>>2]=o;p=o;q=c[b>>2]|0}else{p=n;q=f}g[p+192>>2]=ea(g[d>>2]);g[p+196>>2]=ea(g[d+4>>2]);g[p+200>>2]=ea(g[d+8>>2]);g[p+204>>2]=ea(g[d+12>>2]);g[p+208>>2]=ea(g[d+16>>2]);g[p+212>>2]=ea(g[d+20>>2]);g[p+216>>2]=ea(g[d+24>>2]);r4(q,b);q=b+236|0;c[q>>2]=c[q>>2]|8192;d=(c[j>>2]|0)>>>30;if((d|0)==3){r=c[b>>2]|0;m=10}else if((d|0)==2?(d=c[b>>2]|0,(a[d+2416>>0]|0)!=0):0){r=d;m=10}else m=9;if((m|0)==9){c[b+232>>2]=0;g[b+228>>2]=h;e9(b+16|0,h,1);i=e;return}else if((m|0)==10){c[b+232>>2]=0;g[b+228>>2]=h;r4(r,b);c[q>>2]=c[q>>2]&-7340033|5242880;i=e;return}}function aBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=a+4|0;f=a+8|0;if(c[f>>2]|0){g=0;do{VJa(d,c[(c[e>>2]|0)+(g<<2)>>2]|0);g=g+1|0}while(g>>>0<(c[f>>2]|0)>>>0)}f=c[a+12>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[e>>2]|0,(f|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,f)}nTa(c[a>>2]|0);f=c[a>>2]|0;if(!f){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,f);i=b;return}function bBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;aBb(a+2340|0);c[a+2312>>2]=443968;c[a+2320>>2]=0;c[a+2284>>2]=443968;c[a+2292>>2]=0;c[a+2256>>2]=443968;c[a+2264>>2]=0;c0a(a+2160|0);c[a+2132>>2]=443968;c[a+2140>>2]=0;c[a+2104>>2]=443968;c[a+2112>>2]=0;c[a+2076>>2]=443968;c[a+2084>>2]=0;c[a+2048>>2]=443968;c[a+2056>>2]=0;c[a+2020>>2]=443968;c[a+2028>>2]=0;c[a+1992>>2]=443968;c[a+2e3>>2]=0;c[a+1964>>2]=443968;c[a+1972>>2]=0;e=a+1948|0;f=c[e>>2]|0;g=c[a+1952>>2]|0;h=f+(g*28|0)|0;if((g|0)>0){g=f;do{ko[c[c[g>>2]>>2]&4095](g);g=g+28|0}while(g>>>0<h>>>0)}h=c[a+1956>>2]|0;if((h&2147483647|0)!=0&(h|0)>-1?(h=c[e>>2]|0,(h|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,h)}h=a+1936|0;e=c[h>>2]|0;g=c[a+1940>>2]|0;f=e+(g*28|0)|0;if((g|0)>0){g=e;do{ko[c[c[g>>2]>>2]&4095](g);g=g+28|0}while(g>>>0<f>>>0)}f=c[a+1944>>2]|0;if((f&2147483647|0)!=0&(f|0)>-1?(f=c[h>>2]|0,(f|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,f)}f=a+1924|0;h=c[f>>2]|0;g=c[a+1928>>2]|0;e=h+(g*28|0)|0;if((g|0)>0){g=h;do{ko[c[c[g>>2]>>2]&4095](g);g=g+28|0}while(g>>>0<e>>>0)}e=c[a+1932>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[f>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}c[a+1896>>2]=443968;c[a+1904>>2]=0;c0a(a+1800|0);c0a(a+1704|0);c0a(a+1612|0);c[a+1584>>2]=443968;c[a+1592>>2]=0;c[a+1556>>2]=443968;c[a+1564>>2]=0;c0a(a+1464|0);e=c[a+1280>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+1272>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+1260>>2]|0;if((e|0)!=0?(c[a+1264>>2]|0)>-1:0)VJa(a+1268|0,e);e=c[a+1256>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+1248>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+1172>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+1164>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+1156>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+1148>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+1144>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+1136>>2]|0,(e|0)!=0):0){f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,e)}e=c[a+1120>>2]|0;if(e)VJa(d,e+(0-(c[e+-4>>2]|0))|0);dHb(a+792|0);eHb(a+496|0);fHb(a+200|0);e=c[a+196>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+188>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+184>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+176>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+148>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+140>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+136>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+128>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+124>>2]|0;if((e&2147483647|0)!=0&(e|0)>-1?(e=c[a+116>>2]|0,(e|0)!=0):0){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,e)}e=c[a+112>>2]|0;do if((e&2147483647|0)!=0&(e|0)>-1){d=c[a+104>>2]|0;if(!d)break;f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}while(0);e=c[a+92>>2]|0;do if((e&2147483647|0)!=0&(e|0)>-1){d=c[a+84>>2]|0;if(!d)break;f=mKa()|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,d)}while(0);e=c[a+76>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=b;return}e=c[a+68>>2]|0;if(!e){i=b;return}a=mKa()|0;In[c[(c[a>>2]|0)+12>>2]&4095](a,e);i=b;return}function cBb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(!d)f=0;else{h=d*24|0;j=b+192|0;if(!((a[j>>0]|0)==0&h>>>0<193))if(!h)k=0;else{l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;k=Bn[m&255](l,h,o?443480:544544,537640,558)|0}else{a[j>>0]=1;k=b}f=k}k=c[b+200>>2]|0;j=f+(k*24|0)|0;o=b+196|0;if((k|0)>0){k=f;h=c[o>>2]|0;while(1){if(k){g[k>>2]=ea(g[h>>2]);g[k+4>>2]=ea(g[h+4>>2]);g[k+8>>2]=ea(g[h+8>>2]);g[k+12>>2]=ea(g[h+12>>2]);g[k+16>>2]=ea(g[h+16>>2]);g[k+20>>2]=ea(g[h+20>>2])}k=k+24|0;if(k>>>0>=j>>>0)break;else h=h+24|0}}h=b+204|0;if((c[h>>2]|0)<=-1){c[o>>2]=f;c[h>>2]=d;i=e;return}j=c[o>>2]|0;if((b|0)==(j|0)){a[b+192>>0]=0;c[o>>2]=f;c[h>>2]=d;i=e;return}if(!j){c[o>>2]=f;c[h>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,j);c[o>>2]=f;c[h>>2]=d;i=e;return}function dBb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f+4|0;h=f;j=f+8|0;k=b+4|0;l=c[k>>2]|0;m=l>>>30;if((m|0)==2){if(!(a[(c[b>>2]|0)+2417>>0]|0))n=3}else if((m|0)!=3)n=3;if((n|0)==3){if(!e){i=f;return}n=b;m=l;o=0;while(1){p=(c[450992+((m>>>24&15)<<2)>>2]|0)+n|0;q=(c[d+(o<<2)>>2]|0)+16|0;c[h>>2]=128;a[j>>0]=0;Yba(p,q,h,j);q=o+1|0;if((q|0)==(e|0))break;m=c[k>>2]|0;o=q}i=f;return}o=b+8|0;m=c[o>>2]|0;if(!m){j=s4(c[b>>2]|0,l>>>24&15)|0;c[o>>2]=j;r=j}else r=m;m=r+88|0;j=c[m>>2]|0;o=(j|0)==0;if((e|0)==1){if(o){c[r+84>>2]=c[d>>2];c[m>>2]=1;r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|32;i=f;return}l=c[b>>2]|0;h=l+2500|0;n=c[l+2504>>2]|0;c[g>>2]=0;vWa(h,n+2|0,g);l=c[h>>2]|0;h=l+(n<<2)|0;if(!h){i=f;return}q=r+84|0;c[h>>2]=c[q>>2];c[l+(n+1<<2)>>2]=c[d>>2];c[q>>2]=n;c[m>>2]=2;r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|32;i=f;return}if(o){o=c[b>>2]|0;n=o+2500|0;q=c[o+2504>>2]|0;c[g>>2]=0;vWa(n,q+e|0,g);o=c[n>>2]|0;if(!(o+(q<<2)|0)){i=f;return}if(e){n=0;do{c[o+(n+q<<2)>>2]=c[d+(n<<2)>>2];n=n+1|0}while((n|0)!=(e|0))}c[r+84>>2]=q;c[m>>2]=e;r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|32;i=f;return}q=j+e|0;j=c[b>>2]|0;n=j+2500|0;o=c[j+2504>>2]|0;c[g>>2]=0;vWa(n,o+q|0,g);g=c[n>>2]|0;if(!(g+(o<<2)|0)){i=f;return}n=r+84|0;r=c[n>>2]|0;j=c[(c[b>>2]|0)+2500>>2]|0;l=c[m>>2]|0;if(l){h=0;do{c[g+(h+o<<2)>>2]=c[j+(h+r<<2)>>2];h=h+1|0}while((h|0)!=(l|0))}if(e){h=l+o|0;l=0;do{c[g+(h+l<<2)>>2]=c[d+(l<<2)>>2];l=l+1|0}while((l|0)!=(e|0))}c[n>>2]=o;c[m>>2]=q;r4(c[b>>2]|0,b);c[k>>2]=c[k>>2]|32;i=f;return}function eBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?422760:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);c[k+12>>2]=c[f+12>>2]}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function fBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?422648:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<5)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);c[k+12>>2]=c[f+12>>2];g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);c[k+28>>2]=c[f+28>>2]}k=k+32|0;if(k>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function gBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*48|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?422528:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*48|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);c[k+12>>2]=c[f+12>>2];g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);c[k+28>>2]=c[f+28>>2];g[k+32>>2]=ea(g[f+32>>2]);g[k+36>>2]=ea(g[f+36>>2]);g[k+40>>2]=ea(g[f+40>>2]);c[k+44>>2]=c[f+44>>2]}k=k+48|0;if(k>>>0>=e>>>0)break;else f=f+48|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function hBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*24|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?422416:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*24|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);h=k+12|0;j=f+12|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2]}k=k+24|0;if(k>>>0>=e>>>0)break;else f=f+24|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function iBb(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+80|0;o=n+48|0;p=n+32|0;q=n+66|0;r=n+64|0;s=n+16|0;t=n;u=a[h+18>>0]|0;v=d+12|0;w=c[v>>2]|0;if(u<<24>>24!=(a[(c[450992+(((c[w+4>>2]|0)>>>24&15)<<2)>>2]|0)+w+13>>0]|0)){co[c[(c[k>>2]|0)+136>>2]&2047](q,k,u);u=a[q>>0]|0;q=c[v>>2]|0;v=c[q+4>>2]|0;if(!(v&4))x=(c[450992+((v>>>24&15)<<2)>>2]|0)+q+11|0;else{k=q+8|0;w=c[k>>2]|0;if(!w){y=s4(c[q>>2]|0,v>>>24&15)|0;c[k>>2]=y;z=y}else z=w;x=z+3|0}if(!((u&8&a[x>>0])<<24>>24)){A=0;i=n;return A|0}}x=(l|0)!=0;if((!x?(u=c[h>>2]|0,z=c[h+4>>2]|0,w=c[h+8>>2]|0,y=c[h+12>>2]|0,(z|u|w|y|0)!=0):0)?(k=c[d+8>>2]|0,(c[k+20>>2]&z|c[k+16>>2]&u|c[k+24>>2]&w|c[k+28>>2]&y|0)==0):0){A=0;i=n;return A|0}if(!(b[g>>1]&4)){A=1;i=n;return A|0}g=(j|0)!=0;if(!(g|x)){A=1;i=n;return A|0}b[r>>1]=b[m>>1]|0;if(!g){g=c[l+8>>2]|0;if(g){c[s+0>>2]=c[h+0>>2];c[s+4>>2]=c[h+4>>2];c[s+8>>2]=c[h+8>>2];c[s+12>>2]=c[h+12>>2];x=(c[d+8>>2]|0)+16|0;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[t+12>>2]=c[x+12>>2];x=c[l>>2]|0;y=c[l+4>>2]|0;c[p+0>>2]=c[s+0>>2];c[p+4>>2]=c[s+4>>2];c[p+8>>2]=c[s+8>>2];c[p+12>>2]=c[s+12>>2];c[o+0>>2]=c[t+0>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];c[f>>2]=Bn[g&255](p,o,x,y,r)|0}}else c[f>>2]=Bn[c[c[j>>2]>>2]&255](j,h,c[d+4>>2]|0,c[d>>2]|0,r)|0;b[m>>1]=e[r>>1]&432|b[m>>1]&-433;A=1;i=n;return A|0}function jBb(a,d,e,f,h,j,k,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=0,P=Im,Q=0,R=0,S=0;n=i;i=i+96|0;k=n;p=n+48|0;q=n+72|0;r=n+36|0;s=n+4|0;t=n+84|0;u=n+8|0;v=n+94|0;w=n+92|0;x=n+90|0;y=n+88|0;z=c[d+12>>2]|0;A=d+16|0;B=c[A>>2]|0;C=ea(g[o>>2]);D=ea(g[o+4>>2]);E=ea(g[o+8>>2]);F=ea(g[o+12>>2]);G=ea(g[o+16>>2]);H=ea(g[o+20>>2]);oMa(f,p,h,ea(0.0),0);I=ea(ea(F-C)*ea(.5));C=ea(ea(G-D)*ea(.5));D=ea(ea(H-E)*ea(.5));E=ea(g[p+12>>2]);H=ea(g[p>>2]);G=ea(E-H);F=ea(g[p+16>>2]);J=ea(g[p+4>>2]);K=ea(F-J);L=ea(g[p+20>>2]);M=ea(g[p+8>>2]);N=ea(ea(I+ea(G*ea(.5)))*ea(1.00999999));G=ea(ea(C+ea(K*ea(.5)))*ea(1.00999999));K=ea(ea(D+ea(ea(L-M)*ea(.5)))*ea(1.00999999));D=ea(ea(E+H)*ea(.5));H=ea(ea(F+J)*ea(.5));J=ea(ea(L+M)*ea(.5));M=ea(H-G);L=ea(J-K);g[q>>2]=ea(D-N);g[q+4>>2]=M;g[q+8>>2]=L;L=ea(G+H);H=ea(K+J);g[r>>2]=ea(N+D);g[r+4>>2]=L;g[r+8>>2]=H;p=d+4|0;if(!(RPa(q,r,(c[A>>2]|0)+16|0,c[p>>2]|0,m,s,t)|0)){H=ea(g[s>>2]);L=ea(g[t>>2]);if(H>L){O=0;i=n;return O|0}else P=L}else P=ea(g[t>>2]);t=c[p>>2]|0;L=P<m?P:m;m=ea(g[d+20>>2]);d=c[a+4>>2]|0;a=c[z>>2]|0;if((a|0)==2){p=b[j>>1]|0;s=c[f>>2]|0;if(!(p&256))Q=d+(s<<2)|0;else Q=d+(s<<2)+28|0;s=c[Q>>2]|0;b[w>>1]=p;O=(Pm[s&31](f,h,e+148|0,t,L,l,w,m)|0)&1;i=n;return O|0}else if(!a){P=ea(g[z+4>>2]);w=B+16|0;g[u>>2]=ea(g[w>>2]);s=B+20|0;g[u+4>>2]=ea(g[s>>2]);p=B+24|0;g[u+8>>2]=ea(g[p>>2]);g[u+12>>2]=ea(g[w>>2]);g[u+16>>2]=ea(g[s>>2]);g[u+20>>2]=ea(g[p>>2]);g[u+24>>2]=P;p=b[j>>1]|0;s=c[f>>2]|0;if(!(p&256))R=d+(s<<2)|0;else R=d+(s<<2)+28|0;s=c[R>>2]|0;b[v>>1]=p;O=(Pm[s&31](f,h,u,t,L,l,v,m)|0)&1;i=n;return O|0}else if((a|0)==3){v=b[j>>1]|0;u=c[f>>2]|0;if(!(v&256))S=d+(u<<2)+56|0;else S=d+(u<<2)+84|0;u=c[S>>2]|0;b[x>>1]=v;O=(Pm[u&31](f,h,e+148|0,t,L,l,x,m)|0)&1;i=n;return O|0}else if((a|0)==4){a=c[d+(c[f>>2]<<2)+112>>2]|0;b[y>>1]=b[j>>1]|0;O=(Cn[a&7](f,h,z,B,t,L,l,y,m)|0)&1;i=n;return O|0}else{dKa(bKa()|0,4,445640,301,445992,k);O=0;i=n;return O|0}return 0}function kBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+28|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+16|0;if(!((a[k>>0]|0)==0&g>>>0<17))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?452136:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+24|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+20|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+16>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function lBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b+44|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<3;k=b+32|0;if(!((a[k>>0]|0)==0&g>>>0<33))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?452008:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+40|0;k=c[l>>2]|0;p=j+(k<<3)|0;g=b+36|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m){o=n;q=c[o+4>>2]|0;r=m;c[r>>2]=c[o>>2];c[r+4>>2]=q}m=m+8|0;if(m>>>0>=p>>>0)break;else n=n+8|0}s=c[l>>2]|0}else s=k;k=j+(s<<3)|0;if(k){s=d;d=c[s+4>>2]|0;n=k;c[n>>2]=c[s>>2];c[n+4>>2]=d}do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+32>>0]=0;break}if(d){n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,d)}}while(0);c[g>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h<<3)|0}function mBb(d,f,g,h,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=i;i=i+16|0;n=m+3|0;o=m+2|0;p=m;q=h+18|0;r=a[q>>0]|0;s=c[d>>2]|0;if(r<<24>>24!=(mo[c[(c[s>>2]|0)+68>>2]&4095](s)|0)<<24>>24?(co[c[(c[k>>2]|0)+136>>2]&2047](n,k,a[q>>0]|0),q=a[n>>0]|0,n=c[d>>2]|0,In[c[(c[n>>2]|0)+76>>2]&4095](o,n),(q&8&a[o>>0])<<24>>24==0):0){t=0;i=m;return t|0}o=c[h>>2]|0;q=c[h+4>>2]|0;n=c[h+8>>2]|0;k=c[h+12>>2]|0;if((q|o|n|k|0)!=0?(s=c[d+4>>2]|0,(c[s+52>>2]&q|c[s+48>>2]&o|c[s+56>>2]&n|c[s+60>>2]&k|0)==0):0){t=0;i=m;return t|0}if(!j){t=d;i=m;return t|0}if(!(b[g>>1]&4)){t=d;i=m;return t|0}b[p>>1]=b[l>>1]|0;c[f>>2]=Bn[c[c[j>>2]>>2]&255](j,h,c[d+4>>2]|0,c[d>>2]|0,p)|0;b[l>>1]=(e[p>>1]|0)&432|b[l>>1]&-433;t=d;i=m;return t|0}function nBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+832|0;f=e+816|0;g=e+544|0;h=e+272|0;j=e;if(b){k=g+256|0;a[k>>0]=0;YWa(g,b+272|0);b=o2()|0;Zba(d+16|0)|0;l=b+-16|0;m=R_(d,f)|0;n=c[d>>2]|0;if(m){o=b+-12|0;b=0;do{p=c[(c[f>>2]|0)+(b<<2)>>2]|0;q=p+o|0;r=c[q>>2]|0;if((r&251658240|0)==16777216){c[q>>2]=r&1073741823|-2147483648;c[p+l>>2]=n}b=b+1|0}while((b|0)!=(m|0))}m=c[g+268>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=e;return}m=c[g+260>>2]|0;if((g|0)==(m|0)){a[k>>0]=0;i=e;return}if(!m){i=e;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,m);i=e;return}m=h+256|0;k=h+260|0;c[h+264>>2]=0;g=h+268|0;a[m>>0]=1;c[k>>2]=h;c[g>>2]=64;b=j+256|0;a[b>>0]=0;YWa(j,h);n=o2()|0;Zba(d+16|0)|0;l=n+-16|0;o=R_(d,f)|0;p=c[d>>2]|0;if(o){d=n+-12|0;n=0;do{r=c[(c[f>>2]|0)+(n<<2)>>2]|0;q=r+d|0;s=c[q>>2]|0;if((s&251658240|0)==16777216){c[q>>2]=s&1073741823|-2147483648;c[r+l>>2]=p}n=n+1|0}while((n|0)!=(o|0))}o=c[j+268>>2]|0;do if((o&2147483647|0)!=0&(o|0)>-1){n=c[j+260>>2]|0;if((j|0)==(n|0)){a[b>>0]=0;break}if(n){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,n)}}while(0);b=c[g>>2]|0;if(!((b&2147483647|0)!=0&(b|0)>-1)){i=e;return}b=c[k>>2]|0;if((h|0)==(b|0)){a[m>>0]=0;i=e;return}if(!b){i=e;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,b);i=e;return}function oBb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=b+16|0;Zba(h)|0;Wda(a,h,d,e);e=c[d+260>>2]|0;h=c[d+264>>2]|0;if(!h){i=f;return}d=(c[b>>2]|0)+2448|0;b=0;do{a=(c[e+(b<<2)>>2]|0)+-16|0;j=a+4|0;k=c[j>>2]|0;if(!(k&268435456))l=k;else{A4(a);c[g>>2]=a;TWa(d,g)|0;l=c[j>>2]|0}if((l&251658240|0)==16777216){c[j>>2]=l&1073741823;c[a>>2]=0}r2(a);b=b+1|0}while((b|0)!=(h|0));i=f;return}function pBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+816|0;f=e+544|0;g=e+272|0;h=e;if(b){j=f+256|0;a[j>>0]=0;YWa(f,b+272|0);gHb(d);b=c[f+268>>2]|0;if(!((b&2147483647|0)!=0&(b|0)>-1)){i=e;return}b=c[f+260>>2]|0;if((f|0)==(b|0)){a[j>>0]=0;i=e;return}if(!b){i=e;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,b);i=e;return}b=g+256|0;j=g+260|0;c[g+264>>2]=0;f=g+268|0;a[b>>0]=1;c[j>>2]=g;c[f>>2]=64;k=h+256|0;a[k>>0]=0;YWa(h,g);gHb(d);d=c[h+268>>2]|0;do if((d&2147483647|0)!=0&(d|0)>-1){l=c[h+260>>2]|0;if((h|0)==(l|0)){a[k>>0]=0;break}if(l){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,l)}}while(0);k=c[f>>2]|0;if(!((k&2147483647|0)!=0&(k|0)>-1)){i=e;return}k=c[j>>2]|0;if((g|0)==(k|0)){a[b>>0]=0;i=e;return}if(!k){i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,k);i=e;return}function qBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+832|0;f=e+816|0;g=e+544|0;h=e+272|0;j=e;if(b){k=g+256|0;a[k>>0]=0;YWa(g,b+272|0);b=o2()|0;Zba(d+16|0)|0;l=b+-16|0;m=E_(d,f)|0;n=c[d>>2]|0;if(m){o=b+-12|0;b=0;do{p=c[(c[f>>2]|0)+(b<<2)>>2]|0;q=p+o|0;r=c[q>>2]|0;if((r&251658240|0)==16777216){c[q>>2]=r&1073741823|-2147483648;c[p+l>>2]=n}b=b+1|0}while((b|0)!=(m|0))}m=c[g+268>>2]|0;if(!((m&2147483647|0)!=0&(m|0)>-1)){i=e;return}m=c[g+260>>2]|0;if((g|0)==(m|0)){a[k>>0]=0;i=e;return}if(!m){i=e;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,m);i=e;return}m=h+256|0;k=h+260|0;c[h+264>>2]=0;g=h+268|0;a[m>>0]=1;c[k>>2]=h;c[g>>2]=64;b=j+256|0;a[b>>0]=0;YWa(j,h);n=o2()|0;Zba(d+16|0)|0;l=n+-16|0;o=E_(d,f)|0;p=c[d>>2]|0;if(o){d=n+-12|0;n=0;do{r=c[(c[f>>2]|0)+(n<<2)>>2]|0;q=r+d|0;s=c[q>>2]|0;if((s&251658240|0)==16777216){c[q>>2]=s&1073741823|-2147483648;c[r+l>>2]=p}n=n+1|0}while((n|0)!=(o|0))}o=c[j+268>>2]|0;do if((o&2147483647|0)!=0&(o|0)>-1){n=c[j+260>>2]|0;if((j|0)==(n|0)){a[b>>0]=0;break}if(n){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,n)}}while(0);b=c[g>>2]|0;if(!((b&2147483647|0)!=0&(b|0)>-1)){i=e;return}b=c[k>>2]|0;if((h|0)==(b|0)){a[m>>0]=0;i=e;return}if(!b){i=e;return}m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,b);i=e;return}function rBb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=b+16|0;Zba(h)|0;Yda(a,h,d,e);e=c[d+260>>2]|0;h=c[d+264>>2]|0;if(!h){i=f;return}d=(c[b>>2]|0)+2448|0;b=0;do{a=(c[e+(b<<2)>>2]|0)+-16|0;j=a+4|0;k=c[j>>2]|0;if(!(k&268435456))l=k;else{A4(a);c[g>>2]=a;TWa(d,g)|0;l=c[j>>2]|0}if((l&251658240|0)==16777216){c[j>>2]=l&1073741823;c[a>>2]=0}r2(a);b=b+1|0}while((b|0)!=(h|0));i=f;return}function sBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+816|0;f=e+544|0;g=e+272|0;h=e;if(b){j=f+256|0;a[j>>0]=0;YWa(f,b+272|0);hHb(d);b=c[f+268>>2]|0;if(!((b&2147483647|0)!=0&(b|0)>-1)){i=e;return}b=c[f+260>>2]|0;if((f|0)==(b|0)){a[j>>0]=0;i=e;return}if(!b){i=e;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,b);i=e;return}b=g+256|0;j=g+260|0;c[g+264>>2]=0;f=g+268|0;a[b>>0]=1;c[j>>2]=g;c[f>>2]=64;k=h+256|0;a[k>>0]=0;YWa(h,g);hHb(d);d=c[h+268>>2]|0;do if((d&2147483647|0)!=0&(d|0)>-1){l=c[h+260>>2]|0;if((h|0)==(l|0)){a[k>>0]=0;break}if(l){m=mKa()|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,l)}}while(0);k=c[f>>2]|0;if(!((k&2147483647|0)!=0&(k|0)>-1)){i=e;return}k=c[j>>2]|0;if((g|0)==(k|0)){a[b>>0]=0;i=e;return}if(!k){i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,k);i=e;return}function tBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?452248:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function uBb(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+16|0;f=e+4|0;g=e;h=e+8|0;j=d+4|0;k=c[j>>2]|0;do if(k&32){l=c[d>>2]|0;m=k>>>24&15;n=(c[450992+(m<<2)>>2]|0)+d|0;o=d+8|0;p=c[o>>2]|0;if(!p){q=s4(l,m)|0;c[o>>2]=q;r=q}else r=p;p=r+88|0;q=c[p>>2]|0;o=r+84|0;if((q|0)!=1)if(!q)break;else s=(c[l+2500>>2]|0)+(c[o>>2]<<2)|0;else s=o;o=0;do{l=c[s+(o<<2)>>2]|0;q=l+16|0;m=c[l+4>>2]|0;if(!(m&64))t=l+80|0;else{u=l+8|0;v=c[u>>2]|0;if(!v){w=s4(c[l>>2]|0,m>>>24&15)|0;c[u>>2]=w;x=w}else x=v;t=x+116|0}if(a[t>>0]&5){c[g>>2]=128;a[h>>0]=0;Yba(n,q,g,h)}o=o+1|0}while(o>>>0<(c[p>>2]|0)>>>0)}while(0);if(k&8){k=d+8|0;h=c[k>>2]|0;if(!h){g=s4(c[d>>2]|0,(c[j>>2]|0)>>>24&15)|0;c[k>>2]=g;y=g}else y=h;h=c[j>>2]|0;g=d;Zba((c[450992+((h>>>24&15)<<2)>>2]|0)+g|0)|0;t=y+4|0;x=y+28|0;s=c[x>>2]|0;a:do if(s){r=y+24|0;if((h&-1073741824|0)==-1073741824){p=s;o=0;while(1){n=c[(c[r>>2]|0)+(o<<2)>>2]|0;q=n+4|0;v=c[q>>2]|0;if((v&251658240|0)==16777216){w=c[d>>2]|0;c[q>>2]=v&1073741823;c[n>>2]=w;z=c[x>>2]|0}else z=p;o=o+1|0;if(o>>>0>=z>>>0)break a;else p=z}}else A=0;do{p=c[(c[r>>2]|0)+(A<<2)>>2]|0;o=p+4|0;w=c[o>>2]|0;if((w&251658240|0)==16777216){n=c[d>>2]|0;c[o>>2]=w&1073741823|-2147483648;c[p>>2]=n}n=c[j>>2]|0;if(!(n&1))B=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;else{w=c[k>>2]|0;if(!w){o=s4(c[d>>2]|0,n>>>24&15)|0;c[k>>2]=o;C=o}else C=w;B=C}if(!(b[B>>1]&8)){Vba((c[450992+(((c[j>>2]|0)>>>24&15)<<2)>>2]|0)+g|0,p+16|0);q2(p)}A=A+1|0}while(A>>>0<(c[x>>2]|0)>>>0)}while(0);c[f>>2]=0;iHb(t,0,f);jHb(t,c[x>>2]|0)}x=c[j>>2]|0;if(!(x&7)){i=e;return}t=x>>>24&15;A=(c[450992+(t<<2)>>2]|0)+d|0;g=d+8|0;B=c[g>>2]|0;if(!B){C=s4(c[d>>2]|0,t)|0;c[g>>2]=C;D=c[j>>2]|0;E=C}else{D=x;E=B}if(!(D&1))F=D;else{b[f>>1]=b[E>>1]|0;f7(A,f);F=c[j>>2]|0}if(!(F&2))G=F;else{g7(A,a[E+2>>0]|0);G=c[j>>2]|0}if(!(G&4)){i=e;return}a[A+11>>0]=a[E+3>>0]|0;i=e;return}function vBb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+44>>2]&2147483647)>>>0<b>>>0)wBb(a,b);f=c[a+36>>2]|0;g=a+40|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function wBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<3;h=b+32|0;if(!((a[h>>0]|0)==0&g>>>0<33))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?452008:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+40>>2]|0;h=f+(j<<3)|0;n=b+36|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j){k=g;l=c[k+4>>2]|0;m=j;c[m>>2]=c[k>>2];c[m+4>>2]=l}j=j+8|0;if(j>>>0>=h>>>0)break;else g=g+8|0}}g=b+44|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+32>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function xBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<3,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?453600:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<3)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=f;h=c[g+4>>2]|0;l=j;c[l>>2]=c[g>>2];c[l+4>>2]=h}j=j+8|0;if(j>>>0>=e>>>0)break;else f=f+8|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function yBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?463144:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<5)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];g=j+16|0;h=f+16|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2]}j=j+32|0;if(j>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function zBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*48|0,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?462904:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j*48|0)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){g=j+0|0;h=f+0|0;l=g+48|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(l|0))}j=j+48|0;if(j>>>0>=e>>>0)break;else f=f+48|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function ABb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?463656:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function BBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?463656:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function CBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?463656:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function DBb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?463656:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?463656:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function EBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?463872:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function FBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?463872:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function GBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?463872:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function HBb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?463872:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?463872:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function IBb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=(d+b|0)/2|0;h=a+(g*12|0)|0;j=a+(b*12|0)|0;k=a+(g*12|0)+8|0;g=a+(b*12|0)+8|0;l=c[g>>2]|0;if((c[k>>2]|0)>>>0>l>>>0){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];m=c[g>>2]|0}else m=l;l=a+(d*12|0)|0;g=a+(d*12|0)+8|0;n=c[g>>2]|0;if(n>>>0>m>>>0){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];o=c[g>>2]|0}else o=n;if(o>>>0>(c[k>>2]|0)>>>0){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];p=h}else p=h;h=d+-1|0;d=a+(h*12|0)|0;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[p+0>>2]=c[d+0>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];p=a+(h*12|0)+8|0;l=b;b=h;while(1){h=c[p>>2]|0;q=l;do{q=q+1|0;r=a+(q*12|0)|0}while((c[a+(q*12|0)+8>>2]|0)>>>0>h>>>0);s=b;do{s=s+-1|0;t=a+(s*12|0)|0}while(h>>>0>(c[a+(s*12|0)+8>>2]|0)>>>0);if((q|0)>=(s|0))break;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];l=q;b=s}c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];i=e;return q|0}function JBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?464552:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function KBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?464552:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function LBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?464552:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function MBb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?464552:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?464552:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function NBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else mCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}nCb(m,n,f,a);f=a+264|0;h=a+268|0;nCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+((c[f>>2]|0)*48|0)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{ko[c[c[o>>2]>>2]&4095](o);s=p}o=o+48|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function OBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else eCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}fCb(m,n,f,a);f=a+264|0;h=a+268|0;fCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+((c[f>>2]|0)*40|0)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{ko[c[c[o>>2]>>2]&4095](o);s=p}o=o+40|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function PBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else tCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}uCb(m,n,f,a);f=a+264|0;h=a+268|0;uCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*36|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+36|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function QBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else aCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}bCb(m,n,f,a);f=a+264|0;h=a+268|0;bCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+((c[f>>2]|0)*60|0)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{ko[c[c[o>>2]>>2]&4095](o);s=p}o=o+60|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function RBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else pCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}qCb(m,n,f,a);f=a+264|0;h=a+268|0;qCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+((c[f>>2]|0)*68|0)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{ko[c[c[o>>2]>>2]&4095](o);s=p}o=o+68|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function SBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else jCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}kCb(m,n,f,a);f=a+264|0;h=a+268|0;kCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*24|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+24|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function TBb(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+32|0;e=d+4|0;f=d;g=d+17|0;h=d+16|0;c[e>>2]=0;j=e+4|0;c[j>>2]=0;k=e+8|0;c[k>>2]=0;l=a+292|0;m=c[l>>2]|0;if(!m){n=0;o=0}else{p=0;q=0;r=m;while(1){c[f>>2]=r;if(p>>>0>q>>>0){m=(c[e>>2]|0)+(q<<2)|0;if(m)c[m>>2]=r;c[j>>2]=q+1}else VBb(e,f)|0;m=c[c[l>>2]>>2]|0;c[l>>2]=m;if(!m)break;p=c[k>>2]&2147483647;q=c[j>>2]|0;r=m}n=c[e>>2]|0;o=c[j>>2]|0}WBb(n,o,g,a);g=a+264|0;j=a+268|0;WBb(c[g>>2]|0,c[j>>2]|0,h,a);h=c[g>>2]|0;g=c[j>>2]|0;j=h+(g<<2)|0;if(g){g=a+276|0;a=n;e=h;while(1){h=c[e>>2]|0;r=h+((c[g>>2]|0)*24|0)|0;if((h|0)==(r|0))s=a;else{q=a;p=h;while(1){if((q|0)!=(n+(o<<2)|0)?(c[q>>2]|0)==(p|0):0)t=q+4|0;else{if(c[p+20>>2]|0)l7(p);h=(c[p>>2]|0)+46|0;b[h>>1]=(b[h>>1]|0)+-1<<16>>16;h=(c[p+4>>2]|0)+46|0;b[h>>1]=(b[h>>1]|0)+-1<<16>>16;t=q}p=p+24|0;if((p|0)==(r|0)){s=t;break}else q=t}}e=e+4|0;if((e|0)==(j|0))break;else a=s}}s=c[k>>2]|0;if((s|0)<0|(s&2147483647|0)==0|(n|0)==0){i=d;return}s=mKa()|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,n);i=d;return}function UBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?465552:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function VBb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465552:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function WBb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?465552:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?465552:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function XBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?465552:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function YBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?465128:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function ZBb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?464960:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function _Bb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?465808:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function $Bb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?465952:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function aCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465952:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function bCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?465952:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?465952:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function cCb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?465952:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function dCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?465808:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function eCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465808:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function fCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?465808:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?465808:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function gCb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?465672:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function hCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?466224:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function iCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?465128:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function jCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465128:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function kCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?465128:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?465128:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function lCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?464960:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function mCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?464960:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function nCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?464960:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?464960:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function oCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?465672:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function pCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465672:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function qCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?465672:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?465672:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function rCb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?465256:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function sCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?465256:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function tCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?465256:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function uCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?465256:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?465256:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function vCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+160|0;e=f+136|0;g=f;h=g;c[h>>2]=0;c[h+4>>2]=0;h=g+4|0;a[h>>0]=0;j=f+8|0;c[g>>2]=j;k=d+-1|0;if((k|0)>0){d=0;l=j;j=32;m=0;n=0;o=k;a:while(1){k=n;p=m;q=o;while(1){if((q|0)>(k|0)){if((q-k|0)>>>0<5)r=k;else break;do{s=r;r=r+1|0;t=r;u=s;while(1){u=(c[b+(t*12|0)>>2]|0)>>>0<(c[b+(u*12|0)>>2]|0)>>>0?t:u;if((t|0)>=(q|0))break;else t=t+1|0}t=b+(u*12|0)|0;v=b+(s*12|0)|0;c[e+0>>2]=c[t+0>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[v+0>>2]=c[e+0>>2];c[v+4>>2]=c[e+4>>2];c[v+8>>2]=c[e+8>>2]}while((r|0)!=(q|0))}if(!p)break a;v=c[l+(p+-1<<2)>>2]|0;t=p+-2|0;k=c[l+(t<<2)>>2]|0;p=t;q=v}v=b+(((q+k|0)/2|0)*12|0)|0;t=b+(k*12|0)|0;w=c[t>>2]|0;if((c[v>>2]|0)>>>0<w>>>0){c[e+0>>2]=c[t+0>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[v+0>>2]=c[e+0>>2];c[v+4>>2]=c[e+4>>2];c[v+8>>2]=c[e+8>>2];x=c[t>>2]|0}else x=w;w=b+(q*12|0)|0;y=c[w>>2]|0;if(y>>>0<x>>>0){c[e+0>>2]=c[t+0>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[t+0>>2]=c[w+0>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];c[w+0>>2]=c[e+0>>2];c[w+4>>2]=c[e+4>>2];c[w+8>>2]=c[e+8>>2];z=c[w>>2]|0}else z=y;if(z>>>0<(c[v>>2]|0)>>>0){c[e+0>>2]=c[v+0>>2];c[e+4>>2]=c[v+4>>2];c[e+8>>2]=c[v+8>>2];c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[w+0>>2]=c[e+0>>2];c[w+4>>2]=c[e+4>>2];c[w+8>>2]=c[e+8>>2];A=v}else A=v;v=q+-1|0;w=b+(v*12|0)|0;c[e+0>>2]=c[A+0>>2];c[e+4>>2]=c[A+4>>2];c[e+8>>2]=c[A+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[w+0>>2]=c[e+0>>2];c[w+4>>2]=c[e+4>>2];c[w+8>>2]=c[e+8>>2];y=k;t=v;while(1){v=c[w>>2]|0;B=y;while(1){C=B+1|0;D=b+(C*12|0)|0;if((c[D>>2]|0)>>>0<v>>>0)B=C;else{E=t;break}}do{E=E+-1|0;F=b+(E*12|0)|0}while(v>>>0<(c[F>>2]|0)>>>0);if((C|0)>=(E|0))break;c[e+0>>2]=c[D+0>>2];c[e+4>>2]=c[D+4>>2];c[e+8>>2]=c[D+8>>2];c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[F+0>>2]=c[e+0>>2];c[F+4>>2]=c[e+4>>2];c[F+8>>2]=c[e+8>>2];y=C;t=E}c[e+0>>2]=c[D+0>>2];c[e+4>>2]=c[D+4>>2];c[e+8>>2]=c[D+8>>2];c[D+0>>2]=c[w+0>>2];c[D+4>>2]=c[w+4>>2];c[D+8>>2]=c[w+8>>2];c[w+0>>2]=c[e+0>>2];c[w+4>>2]=c[e+4>>2];c[w+8>>2]=c[e+8>>2];if((C-k|0)<(q-C|0)){if(p>>>0>=(j+-1|0)>>>0){t=j<<1;y=j<<3;if(!y)G=0;else{v=mKa()|0;H=c[(c[v>>2]|0)+8>>2]|0;I=pKa()|0;J=mo[c[(c[I>>2]|0)+24>>2]&4095](I)|0;G=Bn[H&255](v,y,J?468392:544544,523928,148)|0}YEi(G|0,l|0,p<<2|0)|0;if(d<<24>>24==0|(l|0)==0){K=1;L=t;M=G}else{J=mKa()|0;In[c[(c[J>>2]|0)+12>>2]&4095](J,l);K=1;L=t;M=G}}else{K=d;L=j;M=l}c[M+(p<<2)>>2]=k;c[M+(p+1<<2)>>2]=B;N=K;O=M;P=L;Q=B+2|0;R=q}else{t=B+2|0;if(p>>>0>=(j+-1|0)>>>0){J=j<<1;y=j<<3;if(!y)S=0;else{v=mKa()|0;H=c[(c[v>>2]|0)+8>>2]|0;I=pKa()|0;T=mo[c[(c[I>>2]|0)+24>>2]&4095](I)|0;S=Bn[H&255](v,y,T?468392:544544,523928,148)|0}YEi(S|0,l|0,p<<2|0)|0;if(d<<24>>24==0|(l|0)==0){U=S;V=1;W=J}else{T=mKa()|0;In[c[(c[T>>2]|0)+12>>2]&4095](T,l);U=S;V=1;W=J}}else{U=l;V=d;W=j}c[U+(p<<2)>>2]=t;c[U+(p+1<<2)>>2]=q;N=V;O=U;P=W;Q=k;R=B}d=N;l=O;j=P;m=p+2|0;n=Q;o=R}if(!(d<<24>>24==0|(l|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,l)}}if(!(a[h>>0]|0)){i=f;return}tKa(g,c[g>>2]|0);i=f;return}function wCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else GBb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}HBb(m,n,f,a);f=a+264|0;h=a+268|0;HBb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*48|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+48|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function xCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else LBb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}MBb(m,n,f,a);f=a+264|0;h=a+268|0;MBb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+((c[f>>2]|0)*40|0)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{ko[c[(c[o>>2]|0)+8>>2]&4095](o);s=p}o=o+40|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function yCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else CCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}DCb(m,n,f,a);f=a+264|0;h=a+268|0;DCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+(c[f>>2]<<7)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{Daa(o);s=p}o=o+128|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function zCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else CBb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}DBb(m,n,f,a);f=a+264|0;h=a+268|0;DBb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<6)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+64|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function ACb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?470608:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function BCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?470608:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function CCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?470608:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function DCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?470608:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?470608:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function ECb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?469928:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function FCb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?469776:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function GCb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?469624:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function HCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?469928:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function ICb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?469928:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function JCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?469928:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?469928:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function KCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?469776:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function LCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?469776:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function MCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?469776:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?469776:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function NCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?469624:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function OCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?469624:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function PCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?469624:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?469624:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function QCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*36|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?474320:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*36|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){o=l;p=c[o+4>>2]|0;q=k;c[q>>2]=c[o>>2];c[q+4>>2]=p;g[k+8>>2]=ea(g[l+8>>2]);g[k+12>>2]=ea(g[l+12>>2]);g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);g[k+24>>2]=ea(g[l+24>>2]);g[k+28>>2]=ea(g[l+28>>2]);g[k+32>>2]=ea(g[l+32>>2])}k=k+36|0;if(k>>>0>=j>>>0)break;else l=l+36|0}r=c[m>>2]|0}else r=f;f=n+(r*36|0)|0;if(f){l=b;j=c[l+4>>2]|0;k=f;c[k>>2]=c[l>>2];c[k+4>>2]=j;g[n+(r*36|0)+8>>2]=ea(g[b+8>>2]);g[n+(r*36|0)+12>>2]=ea(g[b+12>>2]);g[n+(r*36|0)+16>>2]=ea(g[b+16>>2]);g[n+(r*36|0)+20>>2]=ea(g[b+20>>2]);g[n+(r*36|0)+24>>2]=ea(g[b+24>>2]);g[n+(r*36|0)+28>>2]=ea(g[b+28>>2]);g[n+(r*36|0)+32>>2]=ea(g[b+32>>2])}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s*36|0)|0;i=d;return u|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s*36|0)|0;i=d;return u|0}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,b);c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s*36|0)|0;i=d;return u|0}function RCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im;h=i;j=c[e+52>>2]|0;if(!(a[e+50>>0]|0)){g[b+(d*28|0)+4>>2]=ea(g[j+16>>2]);g[b+(d*28|0)+8>>2]=ea(g[j+20>>2]);g[b+(d*28|0)+12>>2]=ea(g[j+24>>2]);g[b+(d*28|0)+16>>2]=ea(g[j+28>>2]);g[b+(d*28|0)+20>>2]=ea(g[j+32>>2]);g[b+(d*28|0)+24>>2]=ea(g[j+36>>2]);g[b+(d*28|0)+28>>2]=ea(g[j+40>>2]);i=h;return}k=b+(d*28|0)+4|0;if(f){f=e+64|0;l=ea(g[f+32>>2]);m=ea(g[f+36>>2]);n=ea(g[f+40>>2]);o=ea(g[f+44>>2]);p=ea(g[f+48>>2]);q=ea(g[f+52>>2]);r=ea(g[f+56>>2]);s=ea(g[j+64>>2]);t=ea(g[j+68>>2]);u=ea(s*ea(-2.0));s=ea(t*ea(-2.0));t=ea(ea(g[j+72>>2])*ea(-2.0));v=ea(g[j+60>>2]);w=ea(ea(v*v)+ea(-.5));x=ea(g[j+48>>2]);y=ea(u*x);z=ea(g[j+52>>2]);A=ea(y+ea(s*z));y=ea(g[j+56>>2]);B=ea(A+ea(t*y));A=ea(-x);C=ea(-z);D=ea(-y);E=ea(ea(ea(x*B)+ea(ea(u*w)-ea(v*ea(ea(t*z)-ea(s*y)))))*ea(2.0));F=ea(ea(ea(z*B)+ea(ea(s*w)-ea(v*ea(ea(u*y)-ea(t*x)))))*ea(2.0));G=ea(ea(ea(ea(t*w)-ea(v*ea(ea(s*x)-ea(u*z))))+ea(y*B))*ea(2.0));B=ea(ea(o*o)+ea(-.5));y=ea(ea(n*G)+ea(ea(l*E)+ea(m*F)));z=ea(p+ea(ea(l*y)+ea(ea(B*E)+ea(o*ea(ea(m*G)-ea(n*F))))));p=ea(q+ea(ea(m*y)+ea(ea(B*F)+ea(o*ea(ea(n*E)-ea(l*G))))));q=ea(r+ea(ea(ea(B*G)+ea(o*ea(ea(l*F)-ea(m*E))))+ea(n*y)));y=ea(ea(ea(n*A)+ea(ea(m*v)+ea(o*C)))-ea(l*D));E=ea(ea(ea(l*C)+ea(ea(n*v)+ea(o*D)))-ea(m*A));F=ea(ea(ea(ea(o*v)-ea(l*A))-ea(m*C))-ea(n*D));g[k>>2]=ea(ea(ea(ea(l*v)+ea(o*A))+ea(m*D))-ea(n*C));g[b+(d*28|0)+8>>2]=y;g[b+(d*28|0)+12>>2]=E;g[b+(d*28|0)+16>>2]=F;g[b+(d*28|0)+20>>2]=z;g[b+(d*28|0)+24>>2]=p;g[b+(d*28|0)+28>>2]=q;i=h;return}else{q=ea(g[j+64>>2]);p=ea(g[j+68>>2]);z=ea(q*ea(-2.0));q=ea(p*ea(-2.0));p=ea(ea(g[j+72>>2])*ea(-2.0));F=ea(g[j+60>>2]);E=ea(ea(F*F)+ea(-.5));y=ea(g[j+48>>2]);C=ea(z*y);n=ea(g[j+52>>2]);D=ea(C+ea(q*n));C=ea(g[j+56>>2]);m=ea(D+ea(p*C));D=ea(-y);A=ea(-n);o=ea(-C);v=ea(ea(ea(y*m)+ea(ea(z*E)-ea(F*ea(ea(p*n)-ea(q*C)))))*ea(2.0));l=ea(ea(ea(n*m)+ea(ea(q*E)-ea(F*ea(ea(z*C)-ea(p*y)))))*ea(2.0));G=ea(ea(ea(ea(p*E)-ea(F*ea(ea(q*y)-ea(z*n))))+ea(C*m))*ea(2.0));m=ea(g[j+28>>2]);C=ea(ea(m*m)+ea(-.5));n=ea(g[j+16>>2]);z=ea(n*v);y=ea(g[j+20>>2]);q=ea(z+ea(y*l));z=ea(g[j+24>>2]);E=ea(ea(z*G)+q);q=ea(ea(n*E)+ea(ea(C*v)+ea(m*ea(ea(y*G)-ea(z*l)))));p=ea(ea(y*E)+ea(ea(C*l)+ea(m*ea(ea(z*v)-ea(n*G)))));B=ea(ea(ea(C*G)+ea(m*ea(ea(n*l)-ea(y*v))))+ea(z*E));E=ea(ea(g[j+32>>2])+q);q=ea(ea(g[j+36>>2])+p);p=ea(ea(g[j+40>>2])+B);B=ea(ea(ea(z*D)+ea(ea(m*A)+ea(F*y)))-ea(n*o));v=ea(ea(ea(n*A)+ea(ea(m*o)+ea(F*z)))-ea(y*D));l=ea(ea(ea(ea(F*m)-ea(n*D))-ea(y*A))-ea(z*o));g[k>>2]=ea(ea(ea(ea(m*D)+ea(F*n))+ea(y*o))-ea(z*A));g[b+(d*28|0)+8>>2]=B;g[b+(d*28|0)+12>>2]=v;g[b+(d*28|0)+16>>2]=l;g[b+(d*28|0)+20>>2]=E;g[b+(d*28|0)+24>>2]=q;g[b+(d*28|0)+28>>2]=p;i=h;return}}function SCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?475528:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function TCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?475528:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function UCb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?475528:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?475528:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function VCb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?475528:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function WCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b)e=0;else e=sKa(a,b<<2,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<2)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f)c[f>>2]=c[h>>2];f=f+4|0;if(f>>>0>=g>>>0)break;else h=h+4|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}tKa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function XCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(!b)e=0;else e=sKa(a,b<<3,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<3)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f){j=h;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k}f=f+8|0;if(f>>>0>=g>>>0)break;else h=h+8|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}tKa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function YCb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b)e=0;else e=sKa(a,b<<2,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<2)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f)c[f>>2]=c[h>>2];f=f+4|0;if(f>>>0>=g>>>0)break;else h=h+4|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}tKa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function ZCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else kDb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}lDb(m,n,f,a);f=a+264|0;h=a+268|0;lDb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<7)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+128|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function _Cb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else hDb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}iDb(m,n,f,a);f=a+264|0;h=a+268|0;iDb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<6)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+64|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function $Cb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else eDb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}fDb(m,n,f,a);f=a+264|0;h=a+268|0;fDb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<5)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+32|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function aDb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?476552:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function bDb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?476416:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function cDb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?476280:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function dDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?476552:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function eDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?476552:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function fDb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?476552:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?476552:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function gDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?476416:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function hDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?476416:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function iDb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?476416:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?476416:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function jDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?476280:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function kDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?476280:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function lDb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?476280:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?476280:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function mDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?477984:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function nDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?477848:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function oDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?477712:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function pDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b*36|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?477576:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*36|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2]);g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);g[k+28>>2]=ea(g[f+28>>2]);g[k+32>>2]=ea(g[f+32>>2])}k=k+36|0;if(k>>>0>=e>>>0)break;else f=f+36|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function qDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?477424:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function rDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;if((b|0)!=0?(e=b<<4,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?477264:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k<<4)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[f>>2]);g[k+4>>2]=ea(g[f+4>>2]);g[k+8>>2]=ea(g[f+8>>2]);g[k+12>>2]=ea(g[f+12>>2])}k=k+16|0;if(k>>>0>=e>>>0)break;else f=f+16|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function sDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?478352:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function tDb(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)!=0?(g=d<<2,(g|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,g,l?479224:544544,537640,558)|0}else m=0;l=c[a+4>>2]|0;g=m+(l<<2)|0;if((l|0)>0){l=m;h=c[a>>2]|0;while(1){if(l){j=e[h>>1]|e[h+2>>1]<<16;b[l>>1]=j;b[l+2>>1]=j>>>16}l=l+4|0;if(l>>>0>=g>>>0)break;else h=h+4|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=m;c[h>>2]=d;i=f;return}g=c[a>>2]|0;if(!g){c[a>>2]=m;c[h>>2]=d;i=f;return}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,g);c[a>>2]=m;c[h>>2]=d;i=f;return}function uDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?479096:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function vDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(!b)e=0;else e=UJa(a,b<<3,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<3)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f){j=h;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k}f=f+8|0;if(f>>>0>=g>>>0)break;else h=h+8|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function wDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b)e=0;else e=UJa(a,b*20|0,537640,558)|0;f=c[a+4>>2]|0;g=e+(f*20|0)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2]}f=f+20|0;if(f>>>0>=g>>>0)break;else h=h+20|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function xDb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,l=Im,m=Im,n=0,o=Im,p=0,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0;h=i;j=ea(g[d>>2]);l=ea(g[b>>2]);m=ea(j-l);n=d+4|0;o=ea(g[n>>2]);p=b+4|0;q=ea(g[p>>2]);r=ea(o-q);s=d+8|0;t=ea(g[s>>2]);u=b+8|0;v=ea(g[u>>2]);w=ea(t-v);x=d+12|0;t=ea(g[x>>2]);y=b+12|0;z=ea(g[y>>2]);A=ea(t-z);B=ea(ea(ea(m*m)+ea(r*r))+ea(w*w));C=ea(g[a+16>>2]);if(((B>C?B>ea(g[a+20>>2]):0)?B>ea(g[a+24>>2]):0)?B>ea(g[a+28>>2]):0){i=h;return}D=ea(g[f>>2]);E=ea(D-ea(g[e>>2]));D=ea(g[f+4>>2]);F=ea(D-ea(g[e+4>>2]));D=ea(g[f+8>>2]);G=ea(D-ea(g[e+8>>2]));D=ea(ea(ea(E*E)+ea(F*F))+ea(G*G));if(((C>D?ea(g[a+20>>2])>D:0)?ea(g[a+24>>2])>D:0)?ea(g[a+28>>2])>D:0){i=h;return}D=ea(ea(1.0)/ea(T(ea(B))));B=ea(D*ea(g[a>>2]));C=ea(D*ea(g[a+4>>2]));G=ea(D*ea(g[a+8>>2]));F=ea(D*ea(g[a+12>>2]));D=ea(z+ea(g[120284]));E=ea(z+ea(g[120285]));H=ea(z+ea(g[120286]));I=ea(ea(1.0)/ea(t+D));D=ea(ea(1.0)/ea(t+E));E=ea(ea(1.0)/ea(t+H));H=ea(ea(1.0)/ea(t+ea(z+ea(g[120287]))));J=ea(I*ea(g[a+32>>2]));I=ea(D*ea(g[a+36>>2]));D=ea(E*ea(g[a+40>>2]));E=ea(ea(m-ea(m*B))*J);J=ea(ea(r-ea(r*C))*I);I=ea(ea(w-ea(w*G))*D);D=ea(ea(A-ea(A*F))*ea(H*ea(g[a+44>>2])));a=(g[k>>2]=E,c[k>>2]|0);e=(g[k>>2]=J,c[k>>2]|0);f=(g[k>>2]=I,c[k>>2]|0);K=c[120283]&(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=c[120280]&a,ea(g[k>>2]));I=ea(z*D);J=(c[k>>2]=c[120281]&e,ea(g[k>>2]));E=ea(z*J);H=(c[k>>2]=c[120282]&f,ea(g[k>>2]));F=ea(z*H);A=(c[k>>2]=K,ea(g[k>>2]));G=ea(I+l);l=ea(E+q);q=ea(F+v);v=ea(z+ea(z*A));z=ea(G);G=ea(l);l=ea(q);q=ea(v);g[b>>2]=z;g[p>>2]=G;g[u>>2]=l;g[y>>2]=q;q=ea(t*H);H=ea(t*A);A=ea(j-ea(t*D));D=ea(o-ea(t*J));J=ea(ea(g[s>>2])-q);q=ea(ea(g[x>>2])-H);H=ea(A);A=ea(D);D=ea(J);J=ea(q);g[d>>2]=H;g[n>>2]=A;g[s>>2]=D;g[x>>2]=J;i=h;return}function yDb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=Im,j=Im,l=Im,m=Im,n=0,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0;f=i;h=ea(g[d>>2]);j=ea(g[b>>2]);l=ea(h-j);e=d+4|0;m=ea(g[e>>2]);n=b+4|0;o=ea(g[n>>2]);p=ea(m-o);q=d+8|0;r=ea(g[q>>2]);s=b+8|0;t=ea(g[s>>2]);u=ea(r-t);v=d+12|0;r=ea(g[v>>2]);w=b+12|0;x=ea(g[w>>2]);y=ea(r-x);z=ea(ea(ea(l*l)+ea(p*p))+ea(u*u));if(((z>ea(g[a+16>>2])?z>ea(g[a+20>>2]):0)?z>ea(g[a+24>>2]):0)?z>ea(g[a+28>>2]):0){i=f;return}A=ea(ea(1.0)/ea(T(ea(z))));z=ea(A*ea(g[a>>2]));B=ea(A*ea(g[a+4>>2]));C=ea(A*ea(g[a+8>>2]));D=ea(A*ea(g[a+12>>2]));A=ea(x+ea(g[120284]));E=ea(x+ea(g[120285]));F=ea(x+ea(g[120286]));G=ea(ea(1.0)/ea(r+A));A=ea(ea(1.0)/ea(r+E));E=ea(ea(1.0)/ea(r+F));F=ea(ea(1.0)/ea(r+ea(x+ea(g[120287]))));H=ea(G*ea(g[a+32>>2]));G=ea(A*ea(g[a+36>>2]));A=ea(E*ea(g[a+40>>2]));E=ea(ea(l-ea(l*z))*H);H=ea(ea(p-ea(p*B))*G);G=ea(ea(u-ea(u*C))*A);A=ea(ea(y-ea(y*D))*ea(F*ea(g[a+44>>2])));a=(g[k>>2]=E,c[k>>2]|0);I=(g[k>>2]=H,c[k>>2]|0);J=(g[k>>2]=G,c[k>>2]|0);K=c[120283]&(g[k>>2]=A,c[k>>2]|0);A=(c[k>>2]=c[120280]&a,ea(g[k>>2]));G=ea(x*A);H=(c[k>>2]=c[120281]&I,ea(g[k>>2]));E=ea(x*H);F=(c[k>>2]=c[120282]&J,ea(g[k>>2]));D=ea(x*F);y=(c[k>>2]=K,ea(g[k>>2]));C=ea(G+j);j=ea(E+o);o=ea(D+t);t=ea(x+ea(x*y));x=ea(C);C=ea(j);j=ea(o);o=ea(t);g[b>>2]=x;g[n>>2]=C;g[s>>2]=j;g[w>>2]=o;o=ea(r*F);F=ea(r*y);y=ea(h-ea(r*A));A=ea(m-ea(r*H));H=ea(ea(g[q>>2])-o);o=ea(ea(g[v>>2])-F);F=ea(y);y=ea(A);A=ea(H);H=ea(o);g[d>>2]=F;g[e>>2]=y;g[q>>2]=A;g[v>>2]=H;i=f;return}function zDb(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+32|0;j=h+20|0;k=h;kHb(a,d,f,g);l=f+-1|0;f=a+(l*40|0)|0;m=d;d=l;while(1){n=m;do n=n+1|0;while(_n[c[g>>2]&4095](a+(n*40|0)|0,f)|0);o=d;do o=o+-1|0;while(_n[c[g>>2]&4095](f,a+(o*40|0)|0)|0);if((n|0)>=(o|0))break;p=a+(n*40|0)+4|0;q=p;r=q;s=e[r>>1]|e[r+2>>1]<<16;r=q+4|0;q=e[r>>1]|e[r+2>>1]<<16;r=a+(n*40|0)+12|0;t=a+(n*40|0)+16|0;c[j>>2]=c[t>>2];u=c[r>>2]|0;v=a+(n*40|0)+20|0;c[k+0>>2]=c[v+0>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];c[k+16>>2]=c[v+16>>2];w=a+(o*40|0)+4|0;x=w;y=x;z=e[y>>1]|e[y+2>>1]<<16;y=x+4|0;x=e[y>>1]|e[y+2>>1]<<16;y=p;p=y;b[p>>1]=z;b[p+2>>1]=z>>>16;z=y+4|0;b[z>>1]=x;b[z+2>>1]=x>>>16;x=a+(o*40|0)+12|0;c[r>>2]=c[x>>2];r=a+(o*40|0)+16|0;c[t>>2]=c[r>>2];t=a+(o*40|0)+20|0;c[v+0>>2]=c[t+0>>2];c[v+4>>2]=c[t+4>>2];c[v+8>>2]=c[t+8>>2];c[v+12>>2]=c[t+12>>2];c[v+16>>2]=c[t+16>>2];v=w;w=v;b[w>>1]=s;b[w+2>>1]=s>>>16;s=v+4|0;b[s>>1]=q;b[s+2>>1]=q>>>16;c[x>>2]=u;c[r>>2]=c[j>>2];c[t+0>>2]=c[k+0>>2];c[t+4>>2]=c[k+4>>2];c[t+8>>2]=c[k+8>>2];c[t+12>>2]=c[k+12>>2];c[t+16>>2]=c[k+16>>2];m=n;d=o}o=a+(n*40|0)+4|0;d=o;m=d;f=e[m>>1]|e[m+2>>1]<<16;m=d+4|0;d=e[m>>1]|e[m+2>>1]<<16;m=a+(n*40|0)+12|0;g=a+(n*40|0)+16|0;c[j>>2]=c[g>>2];t=c[m>>2]|0;r=a+(n*40|0)+20|0;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[k+16>>2]=c[r+16>>2];u=a+(l*40|0)+4|0;x=u;q=x;s=e[q>>1]|e[q+2>>1]<<16;q=x+4|0;x=e[q>>1]|e[q+2>>1]<<16;q=o;o=q;b[o>>1]=s;b[o+2>>1]=s>>>16;s=q+4|0;b[s>>1]=x;b[s+2>>1]=x>>>16;x=a+(l*40|0)+12|0;c[m>>2]=c[x>>2];m=a+(l*40|0)+16|0;c[g>>2]=c[m>>2];g=a+(l*40|0)+20|0;c[r+0>>2]=c[g+0>>2];c[r+4>>2]=c[g+4>>2];c[r+8>>2]=c[g+8>>2];c[r+12>>2]=c[g+12>>2];c[r+16>>2]=c[g+16>>2];r=u;u=r;b[u>>1]=f;b[u+2>>1]=f>>>16;f=r+4|0;b[f>>1]=d;b[f+2>>1]=d>>>16;c[x>>2]=t;c[m>>2]=c[j>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];i=h;return n|0}function ADb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;if((b|0)!=0?(e=b*76|0,(e|0)!=0):0){f=mKa()|0;h=c[(c[f>>2]|0)+8>>2]|0;j=pKa()|0;k=mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0;l=Bn[h&255](f,e,k?481672:544544,537640,558)|0}else l=0;k=c[a+4>>2]|0;e=l+(k*76|0)|0;if((k|0)>0){k=l;f=c[a>>2]|0;while(1){if(k){c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];g[k+16>>2]=ea(g[f+16>>2]);g[k+20>>2]=ea(g[f+20>>2]);g[k+24>>2]=ea(g[f+24>>2]);g[k+28>>2]=ea(g[f+28>>2]);g[k+32>>2]=ea(g[f+32>>2]);g[k+36>>2]=ea(g[f+36>>2]);g[k+40>>2]=ea(g[f+40>>2]);g[k+44>>2]=ea(g[f+44>>2]);g[k+48>>2]=ea(g[f+48>>2]);g[k+52>>2]=ea(g[f+52>>2]);g[k+56>>2]=ea(g[f+56>>2]);g[k+60>>2]=ea(g[f+60>>2]);g[k+64>>2]=ea(g[f+64>>2]);h=f+68|0;j=c[h+4>>2]|0;m=k+68|0;c[m>>2]=c[h>>2];c[m+4>>2]=j}k=k+76|0;if(k>>>0>=e>>>0)break;else f=f+76|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=l;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=l;c[f>>2]=b;i=d;return}k=mKa()|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,e);c[a>>2]=l;c[f>>2]=b;i=d;return}function BDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h*76|0,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?481672:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f*76|0)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);g[k+24>>2]=ea(g[l+24>>2]);g[k+28>>2]=ea(g[l+28>>2]);g[k+32>>2]=ea(g[l+32>>2]);g[k+36>>2]=ea(g[l+36>>2]);g[k+40>>2]=ea(g[l+40>>2]);g[k+44>>2]=ea(g[l+44>>2]);g[k+48>>2]=ea(g[l+48>>2]);g[k+52>>2]=ea(g[l+52>>2]);g[k+56>>2]=ea(g[l+56>>2]);g[k+60>>2]=ea(g[l+60>>2]);g[k+64>>2]=ea(g[l+64>>2]);o=l+68|0;p=c[o+4>>2]|0;q=k+68|0;c[q>>2]=c[o>>2];c[q+4>>2]=p}k=k+76|0;if(k>>>0>=j>>>0)break;else l=l+76|0}r=c[m>>2]|0}else r=f;f=n+(r*76|0)|0;if(f){c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];g[n+(r*76|0)+16>>2]=ea(g[b+16>>2]);g[n+(r*76|0)+20>>2]=ea(g[b+20>>2]);g[n+(r*76|0)+24>>2]=ea(g[b+24>>2]);g[n+(r*76|0)+28>>2]=ea(g[b+28>>2]);g[n+(r*76|0)+32>>2]=ea(g[b+32>>2]);g[n+(r*76|0)+36>>2]=ea(g[b+36>>2]);g[n+(r*76|0)+40>>2]=ea(g[b+40>>2]);g[n+(r*76|0)+44>>2]=ea(g[b+44>>2]);g[n+(r*76|0)+48>>2]=ea(g[b+48>>2]);g[n+(r*76|0)+52>>2]=ea(g[b+52>>2]);g[n+(r*76|0)+56>>2]=ea(g[b+56>>2]);g[n+(r*76|0)+60>>2]=ea(g[b+60>>2]);g[n+(r*76|0)+64>>2]=ea(g[b+64>>2]);f=b+68|0;b=c[f+4>>2]|0;l=n+(r*76|0)+68|0;c[l>>2]=c[f>>2];c[l+4>>2]=b}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s*76|0)|0;i=d;return u|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s*76|0)|0;i=d;return u|0}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,b);c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s*76|0)|0;i=d;return u|0}function CDb(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e;h=a+16|0;j=c[h>>2]|0;k=j>>>0>b>>>0?b:j;j=a+4|0;b=c[j>>2]|0;if((b|0)!=0?(l=b+-1|0,m=c[a>>2]|0,!(ea(g[m+(l<<3)+4>>2])!=d)):0){n=m+(l<<3)|0;c[n>>2]=(c[n>>2]|0)+k;o=a}else p=3;do if((p|0)==3){c[f>>2]=k;g[f+4>>2]=d;if((c[a+8>>2]&2147483647)>>>0<=b>>>0){lHb(a,f)|0;o=a;break}n=(c[a>>2]|0)+(b<<3)|0;if(!n)q=b;else{l=f;m=c[l+4>>2]|0;r=n;c[r>>2]=c[l>>2];c[r+4>>2]=m;q=c[j>>2]|0}c[j>>2]=q+1;o=a}while(0);q=a+12|0;f=(c[q>>2]|0)+k|0;c[q>>2]=f;k=c[o>>2]|0;b=c[h>>2]|0;if(b>>>0<f>>>0){s=f;t=k;u=b}else{v=c[q>>2]|0;w=c[h>>2]|0;x=v>>>0<w>>>0;y=x?v:w;c[q>>2]=y;i=e;return}do{u=(c[t>>2]|0)+u|0;c[t>>2]=u-s;s=c[q>>2]|0;t=t+((u>>>0<=s>>>0&1)<<3)|0}while(u>>>0<s>>>0);if((t|0)==(k|0)){v=c[q>>2]|0;w=c[h>>2]|0;x=v>>>0<w>>>0;y=x?v:w;c[q>>2]=y;i=e;return}AGb(a,k+(c[j>>2]<<3)-t>>3);k=c[o>>2]|0;o=c[j>>2]|0;j=k+(o<<3)|0;if((o|0)>0){z=k;A=t}else{v=c[q>>2]|0;w=c[h>>2]|0;x=v>>>0<w>>>0;y=x?v:w;c[q>>2]=y;i=e;return}while(1){if(z){t=A;k=c[t+4>>2]|0;o=z;c[o>>2]=c[t>>2];c[o+4>>2]=k}z=z+8|0;if(z>>>0>=j>>>0)break;else A=A+8|0}v=c[q>>2]|0;w=c[h>>2]|0;x=v>>>0<w>>>0;y=x?v:w;c[q>>2]=y;i=e;return}function DDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;if(!b)e=0;else e=UJa(a,b*12|0,537640,558)|0;f=c[a+4>>2]|0;h=e+(f*12|0)|0;if((f|0)>0){f=e;j=c[a>>2]|0;while(1){if(f){g[f>>2]=ea(g[j>>2]);g[f+4>>2]=ea(g[j+4>>2]);g[f+8>>2]=ea(g[j+8>>2])}f=f+12|0;if(f>>>0>=h>>>0)break;else j=j+12|0}}j=a+8|0;if((c[j>>2]|0)<=-1){c[a>>2]=e;c[j>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[j>>2]=b;i=d;return}function EDb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else HDb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}IDb(m,n,f,a);f=a+264|0;h=a+268|0;IDb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*40|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+40|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function FDb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?483640:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function GDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?483640:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function HDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?483640:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function IDb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?483640:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?483640:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function JDb(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im;d=ea(g[a>>2]);e=ea(g[a+4>>2]);f=ea(g[a+8>>2]);h=ea(g[c+96>>2]);i=ea(d*h);d=ea(e*h);e=ea(f*h);h=ea(g[b>>2]);f=ea(g[b+4>>2]);j=ea(ea(ea(i*h)+ea(d*f))+ea(e*ea(g[b+8>>2])));e=ea(g[a+32>>2]);f=ea(g[a+36>>2]);d=ea(g[a+40>>2]);h=ea(g[c+112>>2]);i=ea(e*h);e=ea(f*h);f=ea(d*h);h=ea(g[b+32>>2]);d=ea(g[b+36>>2]);k=ea(ea(ea(i*h)+ea(e*d))+ea(f*ea(g[b+40>>2])));f=ea(g[a+16>>2]);d=ea(g[a+20>>2]);e=ea(g[a+24>>2]);h=ea(f*ea(g[c>>2]));i=ea(h+ea(d*ea(g[c+16>>2])));h=ea(i+ea(e*ea(g[c+32>>2])));i=ea(f*ea(g[c+4>>2]));l=ea(i+ea(d*ea(g[c+20>>2])));i=ea(l+ea(e*ea(g[c+36>>2])));l=ea(f*ea(g[c+8>>2]));f=ea(l+ea(d*ea(g[c+24>>2])));d=ea(f+ea(e*ea(g[c+40>>2])));e=ea(g[b+16>>2]);f=ea(g[b+20>>2]);l=ea(ea(ea(h*e)+ea(i*f))+ea(d*ea(g[b+24>>2])));d=ea(g[a+48>>2]);f=ea(g[a+52>>2]);i=ea(g[a+56>>2]);e=ea(d*ea(g[c+48>>2]));h=ea(e+ea(f*ea(g[c+64>>2])));e=ea(h+ea(i*ea(g[c+80>>2])));h=ea(d*ea(g[c+52>>2]));m=ea(h+ea(f*ea(g[c+68>>2])));h=ea(m+ea(i*ea(g[c+84>>2])));m=ea(d*ea(g[c+56>>2]));d=ea(m+ea(f*ea(g[c+72>>2])));f=ea(d+ea(i*ea(g[c+88>>2])));i=ea(g[b+48>>2]);d=ea(g[b+52>>2]);m=ea(ea(j+k)+ea(l+ea(ea(ea(e*i)+ea(h*d))+ea(f*ea(g[b+56>>2])))));return ea(m)}function KDb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else QDb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}RDb(m,n,f,a);f=a+264|0;h=a+268|0;RDb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*96|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+96|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function LDb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else TDb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}UDb(m,n,f,a);f=a+264|0;h=a+268|0;UDb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*240|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+240|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function MDb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+9400>>2]|0;if((d|0)!=0?(c[a+9404>>2]|0)>-1:0)VJa(a+9408|0,d);d=c[a+9380>>2]|0;if((d|0)!=0?(c[a+9384>>2]|0)>-1:0)VJa(a+9388|0,d);d=c[a+9376>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9368>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9364>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9356>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9352>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9344>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9248>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9240>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9236>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9228>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9224>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9216>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9212>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9204>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9200>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9192>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9188>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9180>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9176>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9168>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9164>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9156>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9152>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9144>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9140>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9132>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9128>>2]|0;if((d&2147483647|0)!=0&(d|0)>-1?(d=c[a+9120>>2]|0,(d|0)!=0):0){e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d)}d=c[a+9116>>2]|0;if(!((d&2147483647|0)!=0&(d|0)>-1)){f=a+16|0;ZAa(f);i=b;return}d=c[a+9108>>2]|0;if(!d){f=a+16|0;ZAa(f);i=b;return}e=mKa()|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,d);f=a+16|0;ZAa(f);i=b;return}function NDb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?488768:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function ODb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?488608:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+264|0;k=c[l>>2]|0;p=j+(k<<2)|0;g=b+260|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=p>>>0)break;else n=n+4|0}}if(p)c[p>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;q=k;break}if(d){p=mKa()|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,d);q=c[l>>2]|0}else q=k}else q=k;while(0);c[g>>2]=j;c[f>>2]=h;c[l>>2]=q+1;i=e;return j+(q<<2)|0}function PDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?488768:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function QDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?488768:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function RDb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?488768:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?488768:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function SDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=e<<2;if(!g){h=0;j=e}else{e=mKa()|0;k=c[(c[e>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;l=Bn[k&255](e,g,m?488608:544544,537640,558)|0;h=l;j=c[f>>2]|0}c[a>>2]=h;a=h+(j<<2)|0;if((j|0)<=0){i=d;return}j=h;h=c[b+260>>2]|0;while(1){if(j)c[j>>2]=c[h>>2];j=j+4|0;if(j>>>0>=a>>>0)break;else h=h+4|0}i=d;return}function TDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?488608:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function UDb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?488608:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?488608:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function VDb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=mKa()|0,f=c[(c[e>>2]|0)+8>>2]|0,h=pKa()|0,j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0,h=Bn[f&255](e,(b*56|0)+19|0,j?492048:544544,537640,558)|0,(h|0)!=0):0){j=h+19&-16;c[j+-4>>2]=j-h;k=j}else k=0;j=c[a+4>>2]|0;h=k+(j*56|0)|0;if((j|0)>0){j=k;e=c[a>>2]|0;while(1){if(j){g[j>>2]=ea(g[e>>2]);g[j+4>>2]=ea(g[e+4>>2]);g[j+8>>2]=ea(g[e+8>>2]);g[j+12>>2]=ea(g[e+12>>2]);g[j+16>>2]=ea(g[e+16>>2]);g[j+20>>2]=ea(g[e+20>>2]);g[j+24>>2]=ea(g[e+24>>2]);g[j+28>>2]=ea(g[e+28>>2]);g[j+32>>2]=ea(g[e+32>>2]);g[j+36>>2]=ea(g[e+36>>2]);g[j+40>>2]=ea(g[e+40>>2]);g[j+44>>2]=ea(g[e+44>>2]);g[j+48>>2]=ea(g[e+48>>2]);g[j+52>>2]=ea(g[e+52>>2])}j=j+56|0;if(j>>>0>=h>>>0)break;else e=e+56|0}}e=a+8|0;if((c[e>>2]|0)<=-1){c[a>>2]=k;c[e>>2]=b;i=d;return}h=c[a>>2]|0;if(!h){c[a>>2]=k;c[e>>2]=b;i=d;return}j=h+(0-(c[h+-4>>2]|0))|0;if(!j){c[a>>2]=k;c[e>>2]=b;i=d;return}h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,j);c[a>>2]=k;c[e>>2]=b;i=d;return}function WDb(a,d,f,h,j,k,l,m,n,o){a=a|0;d=d|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=Im,E=Im,F=Im;p=i;i=i+16|0;q=p;r=d+28|0;s=e[r>>1]|e[r+2>>1]<<16;t=s>>>16;u=a+44|0;v=a+0|0;w=v+44|0;do{c[v>>2]=0;v=v+4|0}while((v|0)<(w|0));g[u>>2]=ea(1.0);g[a+92>>2]=h;u=a+48|0;g[u>>2]=ea(g[d>>2]);v=a+52|0;g[v>>2]=ea(g[d+4>>2]);w=a+56|0;g[w>>2]=ea(g[d+8>>2]);x=a+60|0;b[x>>1]=s&65529;b[a+62>>1]=s>>>17&16|t&65487;c[a+76>>2]=n;t=a+96|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;h=ea(g[o+64>>2]);y=ea(h*ea(g[d+16>>2]));z=ea(h*ea(g[d+20>>2]));A=ea(h*ea(g[d+24>>2]));g[q>>2]=y;s=q+4|0;g[s>>2]=z;B=q+8|0;g[B>>2]=A;if((b[d+30>>1]&3)!=0?(d=a+108|0,mHb(a+48|0,q,f,d,a,a+32|0,c[a+140>>2]|0,c[a+156>>2]|0,l,m,j,k,n,o,r)|0):0){if(!(c[d>>2]|0))C=e[x>>1]|0|2;else{h=ea(y-ea(g[q>>2]));y=ea(z-ea(g[s>>2]));z=ea(A-ea(g[B>>2]));A=ea(g[o+68>>2]);D=ea(y*A);y=ea(z*A);g[t>>2]=ea(h*A);g[a+100>>2]=D;g[a+104>>2]=y;C=e[x>>1]|0|4}b[x>>1]=C;C=a+12|0;c[C>>2]=c[C>>2]|4}y=ea(g[u>>2]);D=ea(g[q>>2]);A=ea(y+D);y=ea(g[v>>2]);h=ea(g[s>>2]);z=ea(y+h);y=ea(g[w>>2]);E=ea(g[B>>2]);F=ea(y+E);g[a+64>>2]=A;g[a+68>>2]=z;g[a+72>>2]=F;F=ea(g[o+68>>2]);z=ea(F*h);h=ea(F*E);g[a+80>>2]=ea(F*D);g[a+84>>2]=z;g[a+88>>2]=h;i=p;return}function XDb(a,c,d,f,h){a=a|0;c=c|0;d=d|0;f=f|0;h=h|0;var j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0;j=i;if(d){k=ea(g[f>>2]);l=ea(g[c+80>>2]);m=ea(k*l);d=f+4|0;n=ea(g[d>>2]);o=ea(g[c+84>>2]);p=ea(m+ea(n*o));q=f+8|0;m=ea(g[q>>2]);r=ea(g[c+88>>2]);s=ea(p+ea(m*r));p=ea(o-ea(n*s));n=ea(r-ea(m*s));g[a+16>>2]=ea(l-ea(k*s));g[a+20>>2]=p;g[a+24>>2]=n;n=ea(g[c+64>>2]);p=ea(g[f>>2]);s=ea(n*p);k=ea(g[c+68>>2]);l=ea(g[d>>2]);m=ea(s+ea(k*l));s=ea(g[c+72>>2]);r=ea(g[q>>2]);o=ea(m+ea(s*r));m=ea(ea(g[f+12>>2])+o);o=ea(n-ea(p*m));p=ea(k-ea(l*m));l=ea(s-ea(r*m));g[a>>2]=o;g[a+4>>2]=p;g[a+8>>2]=l;m=ea(g[h>>2]);f=h+4|0;r=ea(g[f>>2]);q=h+8|0;s=ea(g[q>>2]);g[h>>2]=m<o?m:o;g[f>>2]=r<p?r:p;g[q>>2]=s<l?s:l;q=h+12|0;s=ea(g[q>>2]);f=h+16|0;r=ea(g[f>>2]);d=h+20|0;m=ea(g[d>>2]);g[q>>2]=s>o?s:o;g[f>>2]=r>p?r:p;g[d>>2]=m>l?m:l;t=a+28|0;u=c+60|0;v=e[u>>1]|e[u+2>>1]<<16;b[t>>1]=v;b[t+2>>1]=v>>>16;i=j;return}else{g[a+16>>2]=ea(g[c+80>>2]);g[a+20>>2]=ea(g[c+84>>2]);g[a+24>>2]=ea(g[c+88>>2]);d=c+64|0;g[a>>2]=ea(g[d>>2]);f=c+68|0;g[a+4>>2]=ea(g[f>>2]);q=c+72|0;g[a+8>>2]=ea(g[q>>2]);l=ea(g[h>>2]);m=ea(g[d>>2]);w=h+4|0;p=ea(g[w>>2]);r=ea(g[f>>2]);x=h+8|0;o=ea(g[x>>2]);s=ea(g[q>>2]);g[h>>2]=l<m?l:m;g[w>>2]=p<r?p:r;g[x>>2]=o<s?o:s;x=h+12|0;s=ea(g[x>>2]);o=ea(g[d>>2]);d=h+16|0;r=ea(g[d>>2]);p=ea(g[f>>2]);f=h+20|0;m=ea(g[f>>2]);l=ea(g[q>>2]);g[x>>2]=s>o?s:o;g[d>>2]=r>p?r:p;g[f>>2]=m>l?m:l;t=a+28|0;u=c+60|0;v=e[u>>1]|e[u+2>>1]<<16;b[t>>1]=v;b[t+2>>1]=v>>>16;i=j;return}}function YDb(a,d,f,h,j,k,l){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=0,B=0,C=0,D=0;m=i;n=ea(g[d>>2]);o=ea(g[d+4>>2]);p=ea(g[d+8>>2]);q=ea(n*ea(g[f>>2]));r=ea(q+ea(o*ea(g[f+4>>2])));q=ea(r+ea(p*ea(g[f+8>>2])));f=a+62|0;d=e[f>>1]|0;if(!(d&1)){s=c[a+140>>2]|0;g[s>>2]=n;g[s+4>>2]=o;g[s+8>>2]=p;g[s+12>>2]=q;g[k>>2]=ea(g[h>>2]);g[k+4>>2]=ea(g[h+4>>2]);g[k+8>>2]=ea(g[h+8>>2]);c[k+12>>2]=j;b[f>>1]=d|5;i=m;return}if(!(d&2)){s=c[a+156>>2]|0;g[s>>2]=n;g[s+4>>2]=o;g[s+8>>2]=p;g[s+12>>2]=q;g[l>>2]=ea(g[h>>2]);g[l+4>>2]=ea(g[h+4>>2]);g[l+8>>2]=ea(g[h+8>>2]);c[l+12>>2]=j;b[f>>1]=d|10;i=m;return}s=c[a+140>>2]|0;r=ea(g[s>>2]);t=ea(g[a+48>>2]);u=ea(r*t);v=s+4|0;r=ea(g[v>>2]);w=ea(g[a+52>>2]);x=ea(u+ea(r*w));y=s+8|0;r=ea(g[y>>2]);u=ea(g[a+56>>2]);z=ea(x+ea(r*u));A=s+12|0;r=ea(z-ea(g[A>>2]));B=c[a+156>>2]|0;z=ea(t*ea(g[B>>2]));a=B+4|0;x=ea(z+ea(w*ea(g[a>>2])));C=B+8|0;z=ea(x+ea(u*ea(g[C>>2])));D=B+12|0;x=ea(z-ea(g[D>>2]));z=ea(ea(ea(ea(n*t)+ea(o*w))+ea(p*u))-q);if(r<x){if(!(z<x)){i=m;return}g[B>>2]=n;g[a>>2]=o;g[C>>2]=p;g[D>>2]=q;g[l>>2]=ea(g[h>>2]);g[l+4>>2]=ea(g[h+4>>2]);g[l+8>>2]=ea(g[h+8>>2]);c[l+12>>2]=j;b[f>>1]=d|8;i=m;return}else{if(!(z<r)){i=m;return}g[s>>2]=n;g[v>>2]=o;g[y>>2]=p;g[A>>2]=q;g[k>>2]=ea(g[h>>2]);g[k+4>>2]=ea(g[h+4>>2]);g[k+8>>2]=ea(g[h+8>>2]);c[k+12>>2]=j;b[f>>1]=d|4;i=m;return}}function ZDb(a,d,f){a=a|0;d=d|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=0,v=Im,w=0,x=0,y=0,z=0;h=i;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);m=ea(j*ea(g[f>>2]));n=ea(m+ea(k*ea(g[f+4>>2])));m=ea(n+ea(l*ea(g[f+8>>2])));f=a+62|0;d=e[f>>1]|0;if(!(d&1)){o=c[a+140>>2]|0;g[o>>2]=j;g[o+4>>2]=k;g[o+8>>2]=l;g[o+12>>2]=m;b[f>>1]=d|1;i=h;return}if(!(d&2)){o=c[a+156>>2]|0;g[o>>2]=j;g[o+4>>2]=k;g[o+8>>2]=l;g[o+12>>2]=m;b[f>>1]=d|2;i=h;return}o=c[a+140>>2]|0;n=ea(g[o>>2]);p=ea(g[a+48>>2]);q=ea(n*p);r=o+4|0;n=ea(g[r>>2]);s=ea(g[a+52>>2]);t=ea(q+ea(n*s));u=o+8|0;n=ea(g[u>>2]);q=ea(g[a+56>>2]);v=ea(t+ea(n*q));w=o+12|0;n=ea(v-ea(g[w>>2]));x=c[a+156>>2]|0;v=ea(p*ea(g[x>>2]));a=x+4|0;t=ea(v+ea(s*ea(g[a>>2])));y=x+8|0;v=ea(t+ea(q*ea(g[y>>2])));z=x+12|0;t=ea(v-ea(g[z>>2]));v=ea(ea(ea(ea(j*p)+ea(k*s))+ea(l*q))-m);if(n<t){if(!(v<t)){i=h;return}g[x>>2]=j;g[a>>2]=k;g[y>>2]=l;g[z>>2]=m;b[f>>1]=d&65525|2;i=h;return}else{if(!(v<n)){i=h;return}g[o>>2]=j;g[r>>2]=k;g[u>>2]=l;g[w>>2]=m;b[f>>1]=d&65530|1;i=h;return}}function _Db(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=0,O=Im,P=Im,Q=Im,R=0;j=i;k=a+62|0;l=b[k>>1]|0;m=l&65535;a:do if(!(m&1)){n=ea(ea(g[e>>2])*ea(2.0));o=ea(ea(g[e+4>>2])*ea(2.0));p=ea(ea(g[e+8>>2])*ea(2.0));q=ea(g[h+12>>2]);r=ea(ea(q*q)+ea(-.5));s=ea(g[h>>2]);t=ea(n*s);u=ea(g[h+4>>2]);v=ea(t+ea(o*u));t=ea(g[h+8>>2]);w=ea(v+ea(p*t));v=ea(ea(s*w)+ea(ea(n*r)+ea(q*ea(ea(p*u)-ea(o*t)))));x=ea(ea(u*w)+ea(ea(o*r)+ea(q*ea(ea(n*t)-ea(p*s)))));y=ea(ea(ea(p*r)+ea(q*ea(ea(o*s)-ea(n*u))))+ea(t*w));w=ea(ea(g[f>>2])*ea(2.0));n=ea(ea(g[f+4>>2])*ea(2.0));o=ea(ea(g[f+8>>2])*ea(2.0));p=ea(ea(ea(s*w)+ea(u*n))+ea(t*o));z=ea(ea(s*p)+ea(ea(r*w)+ea(q*ea(ea(u*o)-ea(t*n)))));A=ea(ea(u*p)+ea(ea(r*n)+ea(q*ea(ea(t*w)-ea(s*o)))));B=ea(ea(ea(r*o)+ea(q*ea(ea(s*n)-ea(u*w))))+ea(t*p));p=ea(ea(g[h+16>>2])+z);z=ea(ea(g[h+20>>2])+A);A=ea(ea(y*ea(ea(g[h+24>>2])+B))+ea(ea(v*p)+ea(x*z)));C=v;D=c[a+140>>2]|0;E=x;F=y;G=A;H=b[k>>1]|0}else{do if(m&2){A=ea(ea(g[a+112>>2])*ea(2.0));y=ea(ea(g[a+116>>2])*ea(2.0));x=ea(ea(g[a+120>>2])*ea(2.0));v=ea(g[h+12>>2]);z=ea(ea(v*v)+ea(-.5));p=ea(g[h>>2]);B=ea(A*p);t=ea(g[h+4>>2]);w=ea(B+ea(y*t));B=ea(g[h+8>>2]);u=ea(w+ea(x*B));w=ea(ea(p*u)+ea(ea(A*z)+ea(v*ea(ea(x*t)-ea(y*B)))));n=ea(ea(t*u)+ea(ea(y*z)+ea(v*ea(ea(A*B)-ea(x*p)))));s=ea(ea(ea(x*z)+ea(v*ea(ea(y*p)-ea(A*t))))+ea(B*u));u=ea(g[h+16>>2]);A=ea(u+w);w=ea(g[h+20>>2]);y=ea(w+n);n=ea(g[h+24>>2]);x=ea(n+s);I=c[a+140>>2]|0;s=ea(ea(g[I>>2])*A);q=ea(s+ea(ea(g[I+4>>2])*y));s=ea(q+ea(x*ea(g[I+8>>2])));q=ea(s-ea(g[I+12>>2]));J=c[a+156>>2]|0;s=ea(A*ea(g[J>>2]));A=ea(s+ea(y*ea(g[J+4>>2])));y=ea(A+ea(x*ea(g[J+8>>2])));x=ea(y-ea(g[J+12>>2]));y=ea(g[d>>2]);if(q<x)if(y<x){x=ea(ea(g[e>>2])*ea(2.0));A=ea(ea(g[e+4>>2])*ea(2.0));s=ea(ea(g[e+8>>2])*ea(2.0));o=ea(ea(ea(p*x)+ea(t*A))+ea(B*s));r=ea(ea(p*o)+ea(ea(z*x)+ea(v*ea(ea(t*s)-ea(B*A)))));K=ea(ea(t*o)+ea(ea(z*A)+ea(v*ea(ea(B*x)-ea(p*s)))));L=ea(ea(ea(z*s)+ea(v*ea(ea(p*A)-ea(t*x))))+ea(B*o));o=ea(ea(g[f>>2])*ea(2.0));x=ea(ea(g[f+4>>2])*ea(2.0));A=ea(ea(g[f+8>>2])*ea(2.0));s=ea(ea(ea(p*o)+ea(t*x))+ea(B*A));M=r;N=J;O=K;P=L;Q=ea(ea(L*ea(n+ea(ea(ea(z*A)+ea(v*ea(ea(p*x)-ea(t*o))))+ea(B*s))))+ea(ea(r*ea(u+ea(ea(p*s)+ea(ea(z*o)+ea(v*ea(ea(t*A)-ea(B*x)))))))+ea(K*ea(w+ea(ea(t*s)+ea(ea(z*x)+ea(v*ea(ea(B*o)-ea(p*A)))))))));R=l;break}else{i=j;return}else if(y<q){q=ea(ea(g[e>>2])*ea(2.0));y=ea(ea(g[e+4>>2])*ea(2.0));A=ea(ea(g[e+8>>2])*ea(2.0));o=ea(ea(ea(p*q)+ea(t*y))+ea(B*A));x=ea(ea(p*o)+ea(ea(z*q)+ea(v*ea(ea(t*A)-ea(B*y)))));s=ea(ea(t*o)+ea(ea(z*y)+ea(v*ea(ea(B*q)-ea(p*A)))));K=ea(ea(ea(z*A)+ea(v*ea(ea(p*y)-ea(t*q))))+ea(B*o));o=ea(ea(g[f>>2])*ea(2.0));q=ea(ea(g[f+4>>2])*ea(2.0));y=ea(ea(g[f+8>>2])*ea(2.0));A=ea(ea(ea(p*o)+ea(t*q))+ea(B*y));C=x;D=I;E=s;F=K;G=ea(ea(K*ea(n+ea(ea(ea(z*y)+ea(v*ea(ea(p*q)-ea(t*o))))+ea(B*A))))+ea(ea(x*ea(u+ea(ea(p*A)+ea(ea(z*o)+ea(v*ea(ea(t*y)-ea(B*q)))))))+ea(s*ea(w+ea(ea(t*A)+ea(ea(z*q)+ea(v*ea(ea(B*o)-ea(p*y)))))))));H=l;break a}else{i=j;return}}else{y=ea(ea(g[e>>2])*ea(2.0));p=ea(ea(g[e+4>>2])*ea(2.0));o=ea(ea(g[e+8>>2])*ea(2.0));B=ea(g[h+12>>2]);v=ea(ea(B*B)+ea(-.5));q=ea(g[h>>2]);z=ea(y*q);A=ea(g[h+4>>2]);t=ea(z+ea(p*A));z=ea(g[h+8>>2]);w=ea(t+ea(o*z));t=ea(ea(q*w)+ea(ea(y*v)+ea(B*ea(ea(o*A)-ea(p*z)))));s=ea(ea(A*w)+ea(ea(p*v)+ea(B*ea(ea(y*z)-ea(o*q)))));u=ea(ea(ea(o*v)+ea(B*ea(ea(p*q)-ea(y*A))))+ea(z*w));w=ea(ea(g[f>>2])*ea(2.0));y=ea(ea(g[f+4>>2])*ea(2.0));p=ea(ea(g[f+8>>2])*ea(2.0));o=ea(ea(ea(q*w)+ea(A*y))+ea(z*p));x=ea(ea(q*o)+ea(ea(v*w)+ea(B*ea(ea(A*p)-ea(z*y)))));n=ea(ea(A*o)+ea(ea(v*y)+ea(B*ea(ea(z*w)-ea(q*p)))));K=ea(ea(ea(v*p)+ea(B*ea(ea(q*y)-ea(A*w))))+ea(z*o));o=ea(ea(g[h+16>>2])+x);x=ea(ea(g[h+20>>2])+n);n=ea(ea(u*ea(ea(g[h+24>>2])+K))+ea(ea(t*o)+ea(s*x)));M=t;N=c[a+156>>2]|0;O=s;P=u;Q=n;R=b[k>>1]|0}while(0);g[N>>2]=M;g[N+4>>2]=O;g[N+8>>2]=P;g[N+12>>2]=Q;b[k>>1]=R&65525|2;i=j;return}while(0);g[D>>2]=C;g[D+4>>2]=E;g[D+8>>2]=F;g[D+12>>2]=G;b[k>>1]=H&65530|1;i=j;return}function $Db(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=g;j=(f|0)==0;if(j){k=0;l=-1;m=-1}else{n=0;o=0;p=-1;q=-1;while(1){r=c[d+(n<<2)>>2]|0;s=r>>>0<p>>>0;t=s?n:q;u=s?r:p;s=r>>>0>o>>>0?r:o;n=n+1|0;if((n|0)==(f|0)){k=s;l=u;m=t;break}else{o=s;p=u;q=t}}}if((k-l|0)>>>0>=1024){v=0;i=g;return v|0}if(!j){j=0;do{b[h+(j<<1)>>1]=(c[d+(j<<2)>>2]|0)-l;j=j+1|0}while((j|0)!=(f|0))}b[h+(m<<1)>>1]=b[h+(f+-1<<1)>>1]|0;b[a>>1]=l;l=e[h+2>>1]|0;b[a+2>>1]=l>>>4|(e[h>>1]|0)<<6;f=e[h+6>>1]|0;b[a+4>>1]=(e[h+4>>1]|0)<<2|l<<12|f>>>8;l=e[h+8>>1]|0;b[a+6>>1]=l>>>2|f<<8;f=e[h+12>>1]|0;b[a+8>>1]=(e[h+10>>1]|0)<<4|l<<14|f>>>6;b[a+10>>1]=f<<10|(e[h+14>>1]|0);v=1;i=g;return v|0}function aEb(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=Im,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=0,cb=Im,db=Im,eb=Im,fb=0,gb=Im,hb=Im,ib=Im,jb=0,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im;l=i;i=i+320|0;m=l+64|0;n=l+160|0;o=l+128|0;p=l+224|0;q=l+304|0;r=l;s=l+144|0;t=l+240|0;if(!h){i=l;return}u=j+52|0;v=j+24|0;w=j+44|0;x=j+28|0;y=j+36|0;z=j+48|0;A=j+40|0;j=m+4|0;B=m+8|0;C=m+12|0;D=m+16|0;E=m+20|0;F=m+24|0;G=m+28|0;H=m+32|0;I=m+36|0;J=m+40|0;K=m+44|0;L=m+48|0;M=m+52|0;N=m+56|0;O=m+60|0;P=n+16|0;Q=n+32|0;R=n+48|0;S=r+4|0;U=r+8|0;V=r+12|0;W=r+16|0;X=r+20|0;Y=r+24|0;Z=r+28|0;_=r+32|0;$=r+36|0;aa=r+40|0;ba=r+44|0;ca=r+48|0;da=r+52|0;fa=r+56|0;ga=r+60|0;ha=s+4|0;ia=s+8|0;ja=s+12|0;ka=n+16|0;la=n+32|0;ma=n+4|0;na=n+20|0;oa=n+36|0;pa=n+8|0;qa=n+24|0;ra=n+40|0;sa=n+12|0;ta=n+28|0;ua=n+44|0;va=t+4|0;wa=t+8|0;xa=t+12|0;ya=t+16|0;za=t+20|0;Aa=t+24|0;Ba=t+28|0;Ca=t+32|0;Da=t+36|0;Ea=t+40|0;Fa=t+44|0;Ga=t+48|0;Ha=0;while(1){Ia=c[f+(Ha<<2)>>2]|0;Ja=d+(Ia<<5)|0;Ka=Ha+2|0;La=c[f+(Ha+1<<2)>>2]|0;Ma=La>>>2;if(!Ma)Na=Ka;else{Oa=ea(g[Ja>>2]);Pa=ea(g[Ja+4>>2]);Qa=ea(g[Ja+8>>2]);Ra=ea(g[Ja+12>>2]);g[m>>2]=Oa;g[j>>2]=Oa;g[B>>2]=Oa;g[C>>2]=Oa;g[D>>2]=Pa;g[E>>2]=Pa;g[F>>2]=Pa;g[G>>2]=Pa;g[H>>2]=Qa;g[I>>2]=Qa;g[J>>2]=Qa;g[K>>2]=Qa;g[L>>2]=Ra;g[M>>2]=Ra;g[N>>2]=Ra;g[O>>2]=Ra;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[P+0>>2]=c[o+0>>2];c[P+4>>2]=c[o+4>>2];c[P+8>>2]=c[o+8>>2];c[P+12>>2]=c[o+12>>2];c[Q+0>>2]=c[p+0>>2];c[Q+4>>2]=c[p+4>>2];c[Q+8>>2]=c[p+8>>2];c[Q+12>>2]=c[p+12>>2];c[R+0>>2]=c[q+0>>2];c[R+4>>2]=c[q+4>>2];c[R+8>>2]=c[q+8>>2];c[R+12>>2]=c[q+12>>2];Sa=d+(Ia<<5)+16|0;Qa=ea(g[Sa>>2]);Pa=ea(g[Sa+4>>2]);Oa=ea(g[Sa+8>>2]);Ta=ea(g[Sa+12>>2]);g[r>>2]=Qa;g[S>>2]=Qa;g[U>>2]=Qa;g[V>>2]=Qa;g[W>>2]=Pa;g[X>>2]=Pa;g[Y>>2]=Pa;g[Z>>2]=Pa;g[_>>2]=Oa;g[$>>2]=Oa;g[aa>>2]=Oa;g[ba>>2]=Oa;g[ca>>2]=Ta;g[da>>2]=Ta;g[fa>>2]=Ta;g[ga>>2]=Ta;Ta=ea(ea(1.0)/Ra);g[s>>2]=Ta;g[ha>>2]=Ta;g[ia>>2]=Ta;g[ja>>2]=Ta;Sa=Ma<<2;Ua=0;Va=Ka;while(1){Wa=c[f+(Va<<2)>>2]|0;Xa=c[f+(Va+1<<2)>>2]|0;Ya=c[f+(Va+2<<2)>>2]|0;Za=c[f+(Va+3<<2)>>2]|0;_a=b+(Wa*12|0)|0;Ta=ea(g[_a>>2]);Ra=ea(g[_a+4>>2]);Oa=ea(g[_a+8>>2]);$a=b+(Xa*12|0)|0;Pa=ea(g[$a>>2]);Qa=ea(g[$a+4>>2]);ab=ea(g[$a+8>>2]);bb=b+(Ya*12|0)|0;cb=ea(g[bb>>2]);db=ea(g[bb+4>>2]);eb=ea(g[bb+8>>2]);fb=b+(Za*12|0)|0;gb=ea(g[fb>>2]);hb=ea(g[fb+4>>2]);ib=ea(g[fb+8>>2]);g[t>>2]=Ta;g[va>>2]=Pa;g[wa>>2]=cb;g[xa>>2]=gb;g[ya>>2]=Ra;g[za>>2]=Qa;g[Aa>>2]=db;g[Ba>>2]=hb;g[Ca>>2]=Oa;g[Da>>2]=ab;g[Ea>>2]=eb;g[Fa>>2]=ib;c[Ga+0>>2]=0;c[Ga+4>>2]=0;c[Ga+8>>2]=0;c[Ga+12>>2]=0;nHb(n,t,e+(Wa<<5)|0,e+(Xa<<5)|0,e+(Ya<<5)|0,e+(Za<<5)|0,m,r,s,k);ib=ea(g[t>>2]);eb=ea(g[ya>>2]);ab=ea(g[Ca>>2]);Oa=ea(g[va>>2]);hb=ea(g[za>>2]);db=ea(g[Da>>2]);Qa=ea(g[wa>>2]);Ra=ea(g[Aa>>2]);gb=ea(g[Ea>>2]);cb=ea(g[xa>>2]);Pa=ea(g[Ba>>2]);Ta=ea(g[Fa>>2]);g[_a>>2]=ib;g[b+(Wa*12|0)+4>>2]=eb;g[b+(Wa*12|0)+8>>2]=ab;g[$a>>2]=Oa;g[b+(Xa*12|0)+4>>2]=hb;g[b+(Xa*12|0)+8>>2]=db;g[bb>>2]=Qa;g[b+(Ya*12|0)+4>>2]=Ra;g[b+(Ya*12|0)+8>>2]=gb;g[fb>>2]=cb;g[b+(Za*12|0)+4>>2]=Pa;g[b+(Za*12|0)+8>>2]=Ta;Ua=Ua+1|0;if(Ua>>>0>=Ma>>>0)break;else Va=Va+4|0}Ta=ea(g[n>>2]);Pa=ea(g[ka>>2]);cb=ea(g[la>>2]);gb=ea(g[ma>>2]);Ra=ea(g[na>>2]);Qa=ea(g[oa>>2]);db=ea(g[pa>>2]);hb=ea(g[qa>>2]);Oa=ea(g[ra>>2]);ab=ea(g[sa>>2]);eb=ea(g[ta>>2]);ib=ea(ea(Ta+gb)+ea(db+ab));ab=ea(ea(Pa+Ra)+ea(hb+eb));eb=ea(ea(cb+Qa)+ea(Oa+ea(g[ua>>2])));Va=a+(Ia*12|0)|0;g[Va>>2]=ea(ib+ea(g[Va>>2]));Va=a+(Ia*12|0)+4|0;g[Va>>2]=ea(ab+ea(g[Va>>2]));Va=a+(Ia*12|0)+8|0;g[Va>>2]=ea(eb+ea(g[Va>>2]));Na=Ka+Sa|0}Va=Ma<<2;Ua=La-Va|0;if((La|0)==(Va|0))jb=Na;else{eb=ea(g[Ja>>2]);ab=ea(g[d+(Ia<<5)+4>>2]);ib=ea(g[d+(Ia<<5)+8>>2]);Oa=ea(g[u>>2]);Qa=ea(g[v>>2]);cb=ea(g[d+(Ia<<5)+12>>2]);hb=ea(g[w>>2]);Ra=ea(cb-hb);Va=Ra>ea(0.0);Pa=Va?Ra:ea(0.0);Ra=ea(g[x>>2]);db=ea(Qa*ea(2.0));gb=ea(g[y>>2]);Ta=ea(g[z>>2]);kb=ea(g[A>>2]);lb=ea(g[d+(Ia<<5)+16>>2]);mb=ea(g[d+(Ia<<5)+20>>2]);nb=ea(g[d+(Ia<<5)+24>>2]);Va=a+(Ia*12|0)|0;Za=a+(Ia*12|0)+4|0;fb=a+(Ia*12|0)+8|0;ob=ea(ea(1.0)/cb);cb=ea(g[Va>>2]);pb=ea(g[Za>>2]);qb=ea(g[fb>>2]);Ya=La-(Ma<<2)|0;bb=Ya>>>0>1?Ya:1;rb=cb;cb=pb;pb=qb;Ya=0;Xa=Na;while(1){$a=c[f+(Xa<<2)>>2]|0;qb=ea(eb-ea(g[e+($a<<5)>>2]));sb=ea(ab-ea(g[e+($a<<5)+4>>2]));tb=ea(ib-ea(g[e+($a<<5)+8>>2]));ub=ea(Oa*ea(ea(ea(qb*qb)+ea(sb*sb))+ea(tb*tb)));vb=ea(ea(1.0)/ea(T(ea(ub))));wb=ea(vb*ub);ub=ea(Qa-wb);xb=ea(g[e+($a<<5)+12>>2]);yb=ea(xb-hb);Wa=yb>ea(0.0);zb=ea(ea(Pa+(Wa?yb:ea(0.0)))*ea(gb*ea(wb+ea(ea(vb*Ra)-db))));vb=ea(Ta*ea(qb*zb));qb=ea(Ta*ea(sb*zb));sb=ea(Ta*ea(tb*zb));zb=ea(ub*kb);ub=ea(ea(g[e+($a<<5)+16>>2])-lb);tb=ea(ea(g[e+($a<<5)+20>>2])-mb);wb=ea(vb+ea(zb*ea(Ta*ub)));ub=ea(qb+ea(zb*ea(Ta*tb)));tb=ea(sb+ea(zb*ea(Ta*ea(ea(g[e+($a<<5)+24>>2])-nb))));zb=ea(ea(1.0)/xb);rb=ea(ea(wb*zb)+rb);cb=ea(ea(zb*ub)+cb);pb=ea(pb+ea(zb*tb));zb=ea(wb*ob);wb=ea(ub*ob);ub=ea(tb*ob);Wa=b+($a*12|0)|0;g[Wa>>2]=ea(ea(g[Wa>>2])-zb);Wa=b+($a*12|0)+4|0;g[Wa>>2]=ea(ea(g[Wa>>2])-wb);Wa=b+($a*12|0)+8|0;g[Wa>>2]=ea(ea(g[Wa>>2])-ub);Ya=Ya+1|0;if(Ya>>>0>=Ua>>>0)break;else Xa=Xa+1|0}g[Va>>2]=rb;g[Za>>2]=cb;g[fb>>2]=pb;jb=Na+bb|0}if(jb>>>0<h>>>0)Ha=jb;else break}i=l;return}function bEb(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=0,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=0,Va=0,Wa=Im,Xa=0,Ya=0,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=0,fb=Im;k=i;i=i+240|0;l=k+176|0;m=k+112|0;n=k+96|0;o=k+80|0;p=k+64|0;q=k;if(!f){i=k;return}r=h+52|0;s=h+24|0;t=h+44|0;u=h+28|0;v=h+36|0;w=h+48|0;x=h+40|0;h=l+4|0;y=l+8|0;z=l+12|0;A=l+16|0;B=l+20|0;C=l+24|0;D=l+28|0;E=l+32|0;F=l+36|0;G=l+40|0;H=l+44|0;I=l+48|0;J=l+52|0;K=l+56|0;L=l+60|0;M=m+16|0;N=m+32|0;O=m+48|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;U=q+20|0;V=q+24|0;W=q+28|0;X=q+32|0;Y=q+36|0;Z=q+40|0;_=q+44|0;$=q+48|0;aa=q+52|0;ba=q+56|0;ca=q+60|0;da=m+16|0;fa=m+32|0;ga=m+4|0;ha=m+20|0;ia=m+36|0;ja=m+8|0;ka=m+24|0;la=m+40|0;ma=m+12|0;na=m+28|0;oa=m+44|0;pa=0;while(1){qa=c[e+(pa<<2)>>2]|0;ra=b+(qa<<5)|0;sa=pa+2|0;ta=c[e+(pa+1<<2)>>2]|0;ua=ta>>>2;if(!ua)va=sa;else{wa=ea(g[ra>>2]);xa=ea(g[ra+4>>2]);ya=ea(g[ra+8>>2]);za=ea(g[ra+12>>2]);g[l>>2]=wa;g[h>>2]=wa;g[y>>2]=wa;g[z>>2]=wa;g[A>>2]=xa;g[B>>2]=xa;g[C>>2]=xa;g[D>>2]=xa;g[E>>2]=ya;g[F>>2]=ya;g[G>>2]=ya;g[H>>2]=ya;g[I>>2]=za;g[J>>2]=za;g[K>>2]=za;g[L>>2]=za;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[M+0>>2]=c[n+0>>2];c[M+4>>2]=c[n+4>>2];c[M+8>>2]=c[n+8>>2];c[M+12>>2]=c[n+12>>2];c[N+0>>2]=c[o+0>>2];c[N+4>>2]=c[o+4>>2];c[N+8>>2]=c[o+8>>2];c[N+12>>2]=c[o+12>>2];c[O+0>>2]=c[p+0>>2];c[O+4>>2]=c[p+4>>2];c[O+8>>2]=c[p+8>>2];c[O+12>>2]=c[p+12>>2];Aa=b+(qa<<5)+16|0;za=ea(g[Aa>>2]);ya=ea(g[Aa+4>>2]);xa=ea(g[Aa+8>>2]);wa=ea(g[Aa+12>>2]);g[q>>2]=za;g[P>>2]=za;g[Q>>2]=za;g[R>>2]=za;g[S>>2]=ya;g[U>>2]=ya;g[V>>2]=ya;g[W>>2]=ya;g[X>>2]=xa;g[Y>>2]=xa;g[Z>>2]=xa;g[_>>2]=xa;g[$>>2]=wa;g[aa>>2]=wa;g[ba>>2]=wa;g[ca>>2]=wa;Aa=ua<<2;Ba=0;Ca=sa;while(1){oHb(m,d+(c[e+(Ca<<2)>>2]<<5)|0,d+(c[e+(Ca+1<<2)>>2]<<5)|0,d+(c[e+(Ca+2<<2)>>2]<<5)|0,d+(c[e+(Ca+3<<2)>>2]<<5)|0,l,q,j);Ba=Ba+1|0;if(Ba>>>0>=ua>>>0)break;else Ca=Ca+4|0}wa=ea(g[m>>2]);xa=ea(g[da>>2]);ya=ea(g[fa>>2]);za=ea(g[ga>>2]);Da=ea(g[ha>>2]);Ea=ea(g[ia>>2]);Fa=ea(g[ja>>2]);Ga=ea(g[ka>>2]);Ha=ea(g[la>>2]);Ia=ea(g[ma>>2]);Ja=ea(g[na>>2]);Ka=ea(ea(wa+za)+ea(Fa+Ia));Ia=ea(ea(xa+Da)+ea(Ga+Ja));Ja=ea(ea(ya+Ea)+ea(Ha+ea(g[oa>>2])));Ca=a+(qa*12|0)|0;g[Ca>>2]=ea(Ka+ea(g[Ca>>2]));Ca=a+(qa*12|0)+4|0;g[Ca>>2]=ea(Ia+ea(g[Ca>>2]));Ca=a+(qa*12|0)+8|0;g[Ca>>2]=ea(Ja+ea(g[Ca>>2]));va=sa+Aa|0}Ca=ua<<2;Ba=ta-Ca|0;if((ta|0)==(Ca|0))La=va;else{Ja=ea(g[ra>>2]);Ia=ea(g[b+(qa<<5)+4>>2]);Ka=ea(g[b+(qa<<5)+8>>2]);Ha=ea(g[r>>2]);Ea=ea(g[s>>2]);ya=ea(g[b+(qa<<5)+12>>2]);Ga=ea(g[t>>2]);Da=ea(ya-Ga);Ca=Da>ea(0.0);ya=Ca?Da:ea(0.0);Da=ea(g[u>>2]);xa=ea(Ea*ea(2.0));Fa=ea(g[v>>2]);za=ea(g[w>>2]);wa=ea(g[x>>2]);Ma=ea(g[b+(qa<<5)+16>>2]);Na=ea(g[b+(qa<<5)+20>>2]);Oa=ea(g[b+(qa<<5)+24>>2]);Ca=a+(qa*12|0)|0;Pa=a+(qa*12|0)+4|0;Qa=a+(qa*12|0)+8|0;Ra=ea(g[Ca>>2]);Sa=ea(g[Pa>>2]);Ta=ea(g[Qa>>2]);Ua=ta-(ua<<2)|0;Va=Ua>>>0>1?Ua:1;Wa=Ra;Ra=Sa;Sa=Ta;Ua=0;Xa=va;while(1){Ya=c[e+(Xa<<2)>>2]|0;Ta=ea(Ja-ea(g[d+(Ya<<5)>>2]));Za=ea(Ia-ea(g[d+(Ya<<5)+4>>2]));_a=ea(Ka-ea(g[d+(Ya<<5)+8>>2]));$a=ea(Ha*ea(ea(ea(Ta*Ta)+ea(Za*Za))+ea(_a*_a)));ab=ea(ea(1.0)/ea(T(ea($a))));bb=ea(ab*$a);$a=ea(Ea-bb);cb=ea(g[d+(Ya<<5)+12>>2]);db=ea(cb-Ga);eb=db>ea(0.0);fb=ea(ea(ya+(eb?db:ea(0.0)))*ea(Fa*ea(bb+ea(ea(ab*Da)-xa))));ab=ea(za*ea(Ta*fb));Ta=ea(za*ea(Za*fb));Za=ea(za*ea(_a*fb));fb=ea($a*wa);$a=ea(ea(g[d+(Ya<<5)+16>>2])-Ma);_a=ea(ea(g[d+(Ya<<5)+20>>2])-Na);bb=ea(ea(1.0)/cb);Wa=ea(ea(ea(ab+ea(fb*ea(za*$a)))*bb)+Wa);Ra=ea(ea(bb*ea(Ta+ea(fb*ea(za*_a))))+Ra);Sa=ea(Sa+ea(bb*ea(Za+ea(fb*ea(za*ea(ea(g[d+(Ya<<5)+24>>2])-Oa))))));Ua=Ua+1|0;if(Ua>>>0>=Ba>>>0)break;else Xa=Xa+1|0}g[Ca>>2]=Wa;g[Pa>>2]=Ra;g[Qa>>2]=Sa;La=va+Va|0}if(La>>>0<f>>>0)pa=La;else break}i=k;return}function cEb(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;l=i;m=c[d+4>>2]|0;n=c[e+4>>2]|0;o=c[d+20>>2]|0;d=c[e+20>>2]|0;e=f+12|0;PEi(g|0,-1,c[e>>2]<<2|0)|0;PEi(h|0,-1,c[e>>2]<<2|0)|0;PEi(j|0,-1,c[e>>2]<<2|0)|0;if(!b){i=l;return}e=f+4|0;p=f+16|0;q=f+8|0;r=f+20|0;f=(k|0)==0;s=0;do{t=c[a+(s<<2)>>2]|0;u=c[e>>2]|0;v=c[u+(t<<4)>>2]|0;w=c[u+(t<<4)+4>>2]|0;x=u+(t<<4)|0;c[x+0>>2]=-1;c[x+4>>2]=-1;c[x+8>>2]=-1;c[x+12>>2]=-1;x=c[q>>2]|0;c[x+(t<<2)>>2]=c[p>>2];c[p>>2]=t;u=(c[r>>2]|0)+(t>>>5<<2)|0;c[u>>2]=c[u>>2]&~(1<<(t&31));t=(v|0)==-1;a:do if(!t){u=x;y=v;while(1){z=c[p>>2]|0;A=u+(z<<2)|0;c[p>>2]=c[A>>2];c[A>>2]=-1;A=(c[e>>2]|0)+(z<<4)|0;c[A+0>>2]=-1;c[A+4>>2]=-1;c[A+8>>2]=-1;c[A+12>>2]=-1;A=(c[r>>2]|0)+(z>>>5<<2)|0;c[A>>2]=c[A>>2]|1<<(z&31);A=o+(y<<2)|0;c[g+(y<<2)>>2]=c[A>>2];c[h+(y<<2)>>2]=z;c[j+(z<<2)>>2]=-1;z=c[A>>2]|0;if((z|0)==-1)break a;u=c[q>>2]|0;y=z}}while(0);x=(w|0)==-1;if(!x){y=w;do{u=y;y=c[d+(y<<2)>>2]|0;z=c[n+(u*12|0)>>2]|0;A=c[n+(u*12|0)+4>>2]|0;if((z|0)!=-1?(u=c[h+(z<<2)>>2]|0,(u|0)!=-1):0){z=0;B=u;while(1){u=z+1|0;C=c[j+(B<<2)>>2]|0;if((C|0)==-1){D=u;E=B;break}else{z=u;B=C}}}else{D=0;E=-1}do if((A|0)!=-1?(B=c[h+(A<<2)>>2]|0,(B|0)!=-1):0){z=0;C=B;while(1){z=z+1|0;B=c[j+(C<<2)>>2]|0;if((B|0)==-1)break;else C=B}if(!((E|0)==-1|(C|0)==-1|(E|0)==(C|0)))if(D>>>0<z>>>0){c[j+(E<<2)>>2]=C;break}else{c[j+(C<<2)>>2]=E;break}}while(0)}while((y|0)!=-1)}b:do if(!t){y=c[e>>2]|0;A=v;do{B=c[h+(A<<2)>>2]|0;if((B|0)==-1)F=-1;else{u=B;while(1){B=c[j+(u<<2)>>2]|0;if((B|0)==-1){F=u;break}else u=B}}c[m+(A*12|0)+4>>2]=F;u=y+(F<<4)|0;c[o+(A<<2)>>2]=c[u>>2];c[u>>2]=A;u=y+(F<<4)+8|0;C=c[u>>2]|0;c[u>>2]=(C|0)==-1?A:C;A=c[g+(A<<2)>>2]|0}while((A|0)!=-1);if(!t){if(f){A=v;while(1){y=c[h+(A<<2)>>2]|0;C=c[e>>2]|0;if((c[C+(y<<4)>>2]|0)==-1){u=C+(y<<4)|0;c[u+0>>2]=-1;c[u+4>>2]=-1;c[u+8>>2]=-1;c[u+12>>2]=-1;c[(c[q>>2]|0)+(y<<2)>>2]=c[p>>2];c[p>>2]=y;u=(c[r>>2]|0)+(y>>>5<<2)|0;c[u>>2]=c[u>>2]&~(1<<(y&31))}A=c[g+(A<<2)>>2]|0;if((A|0)==-1)break b}}else G=v;do{A=c[h+(G<<2)>>2]|0;y=c[e>>2]|0;if((c[y+(A<<4)>>2]|0)==-1){u=y+(A<<4)|0;c[u+0>>2]=-1;c[u+4>>2]=-1;c[u+8>>2]=-1;c[u+12>>2]=-1;c[(c[q>>2]|0)+(A<<2)>>2]=c[p>>2];c[p>>2]=A;u=~(1<<(A&31));y=A>>>5;C=(c[r>>2]|0)+(y<<2)|0;c[C>>2]=c[C>>2]&u;C=(c[k>>2]|0)+(y<<2)|0;c[C>>2]=c[C>>2]&u}else{u=(c[k>>2]|0)+(A>>>5<<2)|0;c[u>>2]=c[u>>2]|1<<(A&31)}G=c[g+(G<<2)>>2]|0}while((G|0)!=-1)}}while(0);if(!x){v=w;do{t=d+(v<<2)|0;A=v;v=c[t>>2]|0;u=c[n+(A*12|0)>>2]|0;C=c[n+(A*12|0)+4>>2]|0;if((u|0)==-1){if((C|0)!=-1){y=c[m+(C*12|0)+4>>2]|0;C=c[e>>2]|0;z=C+(y<<4)+4|0;c[t>>2]=c[z>>2];c[z>>2]=A;z=C+(y<<4)+12|0;y=c[z>>2]|0;c[z>>2]=(y|0)==-1?A:y}}else{y=c[m+(u*12|0)+4>>2]|0;u=c[e>>2]|0;z=u+(y<<4)+4|0;c[t>>2]=c[z>>2];c[z>>2]=A;z=u+(y<<4)+12|0;y=c[z>>2]|0;c[z>>2]=(y|0)==-1?A:y}}while((v|0)!=-1)}s=s+1|0}while((s|0)!=(b|0));i=l;return}function dEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else gEb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}hEb(m,n,f,a);f=a+264|0;n=a+268|0;hEb(c[f>>2]|0,c[n>>2]|0,g,a);g=c[f>>2]|0;f=c[n>>2]|0;n=g+(f<<2)|0;if(f){f=a+276|0;a=c[d>>2]|0;m=g;while(1){g=c[m>>2]|0;q=g+(c[f>>2]<<6)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=((c[d>>2]|0)+(c[h>>2]<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else s=p;o=o+64|0;if((o|0)==(q|0)){r=s;break}else p=s}}m=m+4|0;if((m|0)==(n|0))break;else a=r}}r=c[j>>2]|0;if(!((r&2147483647|0)!=0&(r|0)>-1)){i=b;return}r=c[d>>2]|0;if(!r){i=b;return}VJa(d,r+(0-(c[r+-4>>2]|0))|0);i=b;return}function eEb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+268|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<2;k=b+256|0;if(!((a[k>>0]|0)==0&g>>>0<257)){l=UJa(b,g+67|0,537640,558)|0;if(!l)m=0;else{g=l+67&-64;c[g+-4>>2]=g-l;m=g}}else{a[k>>0]=1;m=b}j=m}m=b+264|0;k=c[m>>2]|0;g=j+(k<<2)|0;l=b+260|0;if((k|0)>0){n=j;o=c[l>>2]|0;while(1){if(n)c[n>>2]=c[o>>2];n=n+4|0;if(n>>>0>=g>>>0)break;else o=o+4|0}}if(g)c[g>>2]=c[d>>2];do if((c[f>>2]|0)>-1){d=c[l>>2]|0;if((b|0)==(d|0)){a[b+256>>0]=0;p=k;break}if(d){VJa(b,d+(0-(c[d+-4>>2]|0))|0);p=c[m>>2]|0}else p=k}else p=k;while(0);c[l>>2]=j;c[f>>2]=h;c[m>>2]=p+1;i=e;return j+(p<<2)|0}function fEb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b+264>>2]|0;if(!e){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}c[a+8>>2]=e;f=a+4|0;c[f>>2]=e;g=UJa(a,(e<<2)+67|0,537640,558)|0;if(!g)h=0;else{e=g+67&-64;c[e+-4>>2]=e-g;h=e}c[a>>2]=h;a=c[f>>2]|0;f=h+(a<<2)|0;if((a|0)<=0){i=d;return}a=h;h=c[b+260>>2]|0;while(1){if(a)c[a>>2]=c[h>>2];a=a+4|0;if(a>>>0>=f>>>0)break;else h=h+4|0}i=d;return}function gEb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=UJa(a,(g<<2)+67|0,537640,558)|0,(f|0)!=0):0){h=f+67&-64;c[h+-4>>2]=h-f;j=h}else j=0;h=a+4|0;f=c[h>>2]|0;k=j+(f<<2)|0;if((f|0)>0){l=j;m=c[a>>2]|0;while(1){if(l)c[l>>2]=c[m>>2];l=l+4|0;if(l>>>0>=k>>>0)break;else m=m+4|0}}if(k)c[k>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){VJa(a,b+(0-(c[b+-4>>2]|0))|0);n=c[h>>2]|0}else n=f;c[a>>2]=j;c[e>>2]=g;c[h>>2]=n+1;i=d;return j+(n<<2)|0}function hEb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+160|0;e=f;g=f+136|0;h=e;c[h>>2]=0;c[h+4>>2]=0;h=e+4|0;a[h>>0]=0;j=f+8|0;c[e>>2]=j;k=g+4|0;c[k>>2]=0;l=g+8|0;c[l>>2]=32;m=g+12|0;c[m>>2]=j;n=g+16|0;a[n>>0]=0;o=d+-1|0;if((o|0)>0){d=0;p=o;o=0;q=j;a:while(1){b:do if((p|0)>(d|0)){j=b+(d<<2)|0;r=o;s=q;t=p;while(1){if((t-d|0)>>>0<5){u=d;v=6;break}w=b+(((t+d|0)/2|0)<<2)|0;x=c[w>>2]|0;y=c[j>>2]|0;if(x>>>0<y>>>0){c[j>>2]=x;c[w>>2]=y;z=y;A=c[j>>2]|0}else{z=x;A=y}y=b+(t<<2)|0;x=c[y>>2]|0;if(x>>>0<A>>>0){c[j>>2]=x;c[y>>2]=A;B=A;C=c[w>>2]|0}else{B=x;C=z}if(B>>>0<C>>>0){c[w>>2]=B;c[y>>2]=C;D=c[w>>2]|0}else D=C;y=t+-1|0;x=b+(y<<2)|0;c[w>>2]=c[x>>2];c[x>>2]=D;w=D;E=d;F=y;while(1){G=E;while(1){H=G+1|0;I=b+(H<<2)|0;J=c[I>>2]|0;if(J>>>0<w>>>0)G=H;else{K=F;break}}do{K=K+-1|0;L=b+(K<<2)|0;M=c[L>>2]|0}while(w>>>0<M>>>0);if((H|0)>=(K|0))break;c[I>>2]=M;c[L>>2]=J;w=c[x>>2]|0;E=H;F=K}c[I>>2]=w;c[x>>2]=J;if((H-d|0)<(t-H|0))break;F=G+2|0;E=c[k>>2]|0;y=c[l>>2]|0;if(E>>>0<(y+-1|0)>>>0){N=r;O=E;P=s}else{c[l>>2]=y<<1;E=UJa(g,(y<<3)+67|0,523928,148)|0;if(!E)Q=0;else{y=E+67&-64;c[y+-4>>2]=y-E;Q=y}YEi(Q|0,c[m>>2]|0,c[k>>2]<<2|0)|0;if((a[n>>0]|0)!=0?(y=c[m>>2]|0,(y|0)!=0):0)VJa(g,y+(0-(c[y+-4>>2]|0))|0);a[n>>0]=1;c[m>>2]=Q;N=1;O=c[k>>2]|0;P=Q}c[k>>2]=O+1;c[P+(O<<2)>>2]=F;F=c[k>>2]|0;c[k>>2]=F+1;c[P+(F<<2)>>2]=t;if((G|0)>(d|0)){r=N;s=P;t=G}else{R=N;S=P;break b}}if((v|0)==6)while(1){v=0;j=u;u=u+1|0;F=u;y=j;while(1){y=(c[b+(F<<2)>>2]|0)>>>0<(c[b+(y<<2)>>2]|0)>>>0?F:y;if((F|0)>=(t|0))break;else F=F+1|0}F=b+(y<<2)|0;x=b+(j<<2)|0;w=c[F>>2]|0;c[F>>2]=c[x>>2];c[x>>2]=w;if((u|0)==(t|0)){R=r;S=s;break b}else v=6}w=c[k>>2]|0;x=c[l>>2]|0;if(w>>>0<(x+-1|0)>>>0){T=r;U=w;V=s}else{c[l>>2]=x<<1;w=UJa(g,(x<<3)+67|0,523928,148)|0;if(!w)W=0;else{x=w+67&-64;c[x+-4>>2]=x-w;W=x}YEi(W|0,c[m>>2]|0,c[k>>2]<<2|0)|0;if((a[n>>0]|0)!=0?(x=c[m>>2]|0,(x|0)!=0):0)VJa(g,x+(0-(c[x+-4>>2]|0))|0);a[n>>0]=1;c[m>>2]=W;T=1;U=c[k>>2]|0;V=W}c[k>>2]=U+1;c[V+(U<<2)>>2]=d;x=c[k>>2]|0;c[k>>2]=x+1;c[V+(x<<2)>>2]=G;d=G+2|0;p=t;o=T;q=V;continue a}else{R=o;S=q}while(0);x=c[k>>2]|0;if(!x)break;w=x+-1|0;c[k>>2]=w;F=c[S+(w<<2)>>2]|0;w=x+-2|0;c[k>>2]=w;d=c[S+(w<<2)>>2]|0;p=F;o=R;q=S}if(!(R<<24>>24==0|(S|0)==0))VJa(g,S+(0-(c[S+-4>>2]|0))|0)}if(!(a[h>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function iEb(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=ea(j);k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;l=i;i=i+16|0;m=l+4|0;n=l;o=a+68|0;if((c[o>>2]|0)==-1){c[o>>2]=k;i=l;return 1}p=c[b+12>>2]|0;q=ea(g[(c[b+16>>2]|0)+8>>2]);r=ea(ea(g[b>>2])*f);s=xRa(p,r,ea(ea(g[b+8>>2])*h),m,n)|0;r=ea(g[m>>2]);t=ea(j-ea(q*ea(t1a(p,s,r,ea(g[n>>2])))));r=ea(g[a+64>>2]);q=ea(g[p+40>>2]);if(!(q<=ea(0.0))|!(t<=r)|!(q<=t)){if(!(q>ea(0.0))){i=l;return 1}if(!(t>ea(-r)&q>t)){i=l;return 1}}r=ea(g[e+4>>2]);u=ea(g[a+8>>2]);v=ea(r*u);w=ea(g[e+8>>2]);x=ea(g[a+4>>2]);y=ea(v-ea(w*x));v=ea(g[a>>2]);z=ea(w*v);w=ea(g[e>>2]);A=ea(z-ea(u*w));u=ea(ea(x*w)-ea(r*v));if(A<ea(0.0)){B=ea(-A);C=ea(-y);D=ea(-u)}else{B=A;C=y;D=u}if(B<ea(0.0)){i=l;return 1}u=ea(ea(D*D)+ea(ea(B*B)+ea(C*C)));if(!(u>ea(0.0))){i=l;return 1}C=ea(t*ea(B*ea(ea(1.0)/ea(T(ea(u))))));if(q>ea(0.0))E=ea(-C);else E=C;e=c[a+12>>2]|0;C=ea(g[a+16>>2]);q=ea(g[a+20>>2]);u=ea(g[a+24>>2]);B=ea(g[a+28>>2]);t=ea(g[a+32>>2]);D=ea(g[a+36>>2]);y=ea(g[a+40>>2]);A=ea(g[a+44>>2]);v=ea(g[a+48>>2]);r=ea(g[d>>2]);w=ea(g[d+4>>2]);x=ea(g[d+8>>2]);d=e+4096|0;p=c[d>>2]|0;if(p>>>0<=63){z=ea(v*h);F=ea(A*h);G=ea(y*h);h=ea(ea(u*f)+ea(D*j));H=ea(ea(q*f)+ea(t*j));I=ea(ea(C*f)+ea(B*j));j=ea(v*x);v=ea(A*x);A=ea(y*x);x=ea(ea(u*r)+ea(D*w));D=ea(ea(q*r)+ea(t*w));t=ea(ea(C*r)+ea(B*w));w=ea(g[a+60>>2]);B=ea(g[a+56>>2]);r=ea(x+j);j=ea(D+v);v=ea(t+A);A=ea(ea(h+z)+w);w=ea(ea(H+F)+B);B=ea(ea(I+G)+ea(g[a+52>>2]));c[d>>2]=p+1;g[e+(p<<6)>>2]=v;g[e+(p<<6)+4>>2]=j;g[e+(p<<6)+8>>2]=r;g[e+(p<<6)+16>>2]=B;g[e+(p<<6)+20>>2]=w;g[e+(p<<6)+24>>2]=A;g[e+(p<<6)+12>>2]=E;c[e+(p<<6)+48>>2]=-1;c[e+(p<<6)+52>>2]=k}c[o>>2]=k;i=l;return 1}function jEb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);i=ea(g[b+12>>2]);j=ea(e+e);k=ea(f+f);l=ea(h+h);m=ea(f*k);n=ea(h*l);o=ea(j*f);f=ea(j*h);p=ea(j*i);q=ea(k*h);h=ea(k*i);k=ea(l*i);i=ea(ea(1.0)-ea(e*j));j=ea(ea(ea(1.0)-m)-n);e=ea(o+k);l=ea(f-h);r=ea(o-k);k=ea(i-n);n=ea(q+p);o=ea(f+h);h=ea(q-p);p=ea(i-m);m=ea(g[a>>2]);b=a+4|0;i=ea(m*j);q=ea(m*r);f=ea(m*o);m=ea(g[b>>2]);s=a+8|0;t=ea(e*m);u=ea(m*k);v=ea(m*h);m=ea(g[s>>2]);w=ea(l*m);x=ea(n*m);y=ea(p*m);m=ea(ea(ea(j*q)+ea(e*u))+ea(l*x));z=ea(ea(ea(j*f)+ea(e*v))+ea(l*y));A=ea(ea(ea(r*i)+ea(k*t))+ea(n*w));B=ea(ea(ea(r*q)+ea(k*u))+ea(n*x));C=ea(ea(ea(r*f)+ea(k*v))+ea(n*y));D=ea(ea(ea(o*i)+ea(h*t))+ea(p*w));E=ea(ea(ea(o*q)+ea(h*u))+ea(p*x));x=ea(ea(ea(o*f)+ea(h*v))+ea(p*y));g[c>>2]=ea(ea(ea(j*i)+ea(e*t))+ea(l*w));g[c+4>>2]=m;g[c+8>>2]=z;g[c+12>>2]=ea(0.0);g[c+16>>2]=A;g[c+20>>2]=B;g[c+24>>2]=C;g[c+28>>2]=ea(0.0);g[c+32>>2]=D;g[c+36>>2]=E;g[c+40>>2]=x;g[c+44>>2]=ea(0.0);x=ea(g[a>>2]);E=ea(g[b>>2]);D=ea(ea(1.0)/x);x=ea(ea(1.0)/E);E=ea(ea(1.0)/ea(g[s>>2]));C=ea(j*D);B=ea(r*D);A=ea(o*D);D=ea(e*x);z=ea(k*x);m=ea(h*x);x=ea(l*E);w=ea(n*E);t=ea(p*E);E=ea(ea(ea(j*B)+ea(e*z))+ea(l*w));i=ea(ea(ea(j*A)+ea(e*m))+ea(l*t));y=ea(ea(ea(r*C)+ea(k*D))+ea(n*x));v=ea(ea(ea(r*B)+ea(k*z))+ea(n*w));f=ea(ea(ea(r*A)+ea(k*m))+ea(n*t));n=ea(ea(ea(o*C)+ea(h*D))+ea(p*x));k=ea(ea(ea(o*B)+ea(h*z))+ea(p*w));w=ea(ea(ea(o*A)+ea(h*m))+ea(p*t));g[d>>2]=ea(ea(ea(j*C)+ea(e*D))+ea(l*x));g[d+4>>2]=E;g[d+8>>2]=i;g[d+12>>2]=ea(0.0);g[d+16>>2]=y;g[d+20>>2]=v;g[d+24>>2]=f;g[d+28>>2]=ea(0.0);g[d+32>>2]=n;g[d+36>>2]=k;g[d+40>>2]=w;g[d+44>>2]=ea(0.0);return}function kEb(a,b,e,f,h,j,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=ea(m);n=ea(n);o=ea(o);p=p|0;q=q|0;r=r|0;s=ea(s);t=t|0;var u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=Im,F=0,G=Im,H=0,I=0,J=Im,K=0,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;u=i;i=i+32|0;v=u+16|0;w=u+12|0;x=u;c[r>>2]=-1;y=c[a+16>>2]|0;z=c[a+24>>2]|0;A=c[a+28>>2]|0;B=h+36|0;C=ea(ea(g[B>>2])*m);D=h+40|0;E=ea(ea(g[D>>2])*m);F=h+44|0;G=ea(ea(g[F>>2])*m);H=h+48|0;m=ea(ea(g[H>>2])*n);I=h+52|0;J=ea(ea(g[I>>2])*n);K=h+56|0;L=ea(C+m);m=ea(E+J);J=ea(G+ea(ea(g[K>>2])*n));M=h+60|0;n=ea(ea(g[M>>2])*o);N=h+64|0;G=ea(ea(g[N>>2])*o);O=h+68|0;E=ea(L+n);n=ea(m+G);G=ea(J+ea(ea(g[O>>2])*o));if(!y){P=1;i=u;return P|0}h=x+4|0;Q=x+8|0;R=e+4|0;S=e+8|0;U=e+12|0;V=e+16|0;W=e+20|0;X=e+24|0;Y=e+28|0;Z=e+32|0;_=f+4|0;$=f+8|0;aa=f+12|0;ba=f+16|0;ca=f+20|0;da=f+24|0;fa=f+28|0;ga=f+32|0;ha=t+4|0;ia=t+8|0;ja=a+44|0;ka=a+48|0;la=a+52|0;ma=b+44|0;na=b+48|0;oa=b+52|0;pa=a+40|0;a=b+40|0;qa=b+64|0;ra=q+4|0;sa=q+8|0;ta=0;while(1){ua=z+(ta*20|0)|0;o=ea(g[ua>>2]);J=ea(E*o);va=z+(ta*20|0)+4|0;m=ea(g[va>>2]);L=ea(J+ea(n*m));wa=z+(ta*20|0)+8|0;J=ea(g[wa>>2]);if(!(ea(L+ea(G*J))<ea(0.0))){L=ea(o*ea(g[B>>2]));C=ea(o*ea(g[D>>2]));xa=ea(o*ea(g[F>>2]));o=ea(m*ea(g[H>>2]));ya=ea(m*ea(g[I>>2]));za=ea(L+o);o=ea(C+ya);ya=ea(xa+ea(m*ea(g[K>>2])));m=ea(J*ea(g[M>>2]));xa=ea(J*ea(g[N>>2]));C=ea(za+m);m=ea(o+xa);xa=ea(ya+ea(J*ea(g[O>>2])));g[x>>2]=C;g[h>>2]=m;g[Q>>2]=xa;J=ea(T(ea(ea(xa*xa)+ea(ea(C*C)+ea(m*m)))));if(J>ea(0.0)){ya=ea(ea(1.0)/J);o=ea(C*ya);g[x>>2]=o;za=ea(m*ya);g[h>>2]=za;L=ea(xa*ya);g[Q>>2]=L;Aa=o;Ba=za;Ca=L}else{Aa=C;Ba=m;Ca=xa}xa=ea(g[e>>2]);m=ea(Aa*xa);C=ea(g[R>>2]);L=ea(Aa*C);za=ea(g[S>>2]);o=ea(Aa*za);ya=ea(g[U>>2]);Da=ea(Ba*ya);Ea=ea(g[V>>2]);Fa=ea(Ba*Ea);Ga=ea(g[W>>2]);Ha=ea(m+Da);Da=ea(L+Fa);Fa=ea(o+ea(Ba*Ga));o=ea(g[X>>2]);L=ea(Ca*o);m=ea(g[Y>>2]);Ia=ea(Ca*m);Ja=ea(g[Z>>2]);Ka=ea(Ha+L);L=ea(Da+Ia);Ia=ea(Fa+ea(Ca*Ja));Fa=ea(g[p>>2]);Da=ea(ea(ea(xa*Ka)+ea(C*L))+ea(za*Ia));za=ea(ea(ea(ya*Ka)+ea(Ea*L))+ea(Ga*Ia));Ga=ea(ea(ea(o*Ka)+ea(m*L))+ea(Ja*Ia));La=(g[k>>2]=Da,c[k>>2]|0);Ma=(g[k>>2]=za,c[k>>2]|0);Na=(g[k>>2]=Ga,c[k>>2]|0);Ja=ea(Ka*ea(g[f>>2]));m=ea(Ja+ea(L*ea(g[_>>2])));Ja=ea(m+ea(Ia*ea(g[$>>2])));m=ea(Ka*ea(g[aa>>2]));o=ea(m+ea(L*ea(g[ba>>2])));m=ea(o+ea(Ia*ea(g[ca>>2])));o=ea(Ka*ea(g[da>>2]));Ea=ea(o+ea(L*ea(g[fa>>2])));o=ea(Ea+ea(Ia*ea(g[ga>>2])));Oa=(g[k>>2]=Ja,c[k>>2]|0);Pa=(g[k>>2]=m,c[k>>2]|0);Ea=ea(Ka*ea(g[t>>2]));ya=ea(Ea+ea(L*ea(g[ha>>2])));Ea=ea(ya+ea(Ia*ea(g[ia>>2])));Qa=c[oa>>2]|(g[k>>2]=o,c[k>>2]|0)&-2147483648;ya=ea(Da*(c[k>>2]=c[ja>>2]|La&-2147483648,ea(g[k>>2])));Da=ea(ya+ea(za*(c[k>>2]=c[ka>>2]|Ma&-2147483648,ea(g[k>>2]))));za=ea(Da+ea(Ga*(c[k>>2]=c[la>>2]|Na&-2147483648,ea(g[k>>2]))));Ga=ea(Ja*(c[k>>2]=c[ma>>2]|Oa&-2147483648,ea(g[k>>2])));Ja=ea(Ga+ea(m*(c[k>>2]=c[na>>2]|Pa&-2147483648,ea(g[k>>2]))));m=ea(Ja+ea(o*(c[k>>2]=Qa,ea(g[k>>2]))));o=ea(g[pa>>2]);Ja=ea(g[a>>2]);Ga=ea((za>o?za:o)+(m>Ja?m:Ja));Ja=ea(Ea+Ga);m=ea(Ga-Ea);if(!((Ja<m?Ja:m)>Fa)){Fa=ea(ea(1.0)/J);Qa=d[z+(ta*20|0)+19>>0]|0;J=ea(g[ua>>2]);m=ea(J*ea(g[A+(Qa*12|0)>>2]));J=ea(g[va>>2]);Ja=ea(m+ea(J*ea(g[A+(Qa*12|0)+4>>2])));J=ea(g[wa>>2]);m=ea(Fa*ea(Ja+ea(J*ea(g[A+(Qa*12|0)+8>>2]))));J=ea(Fa*ea(g[z+(ta*20|0)+12>>2]));Fa=ea(-J);rn[c[qa>>2]&127](b,x,l,j,v,w);Ja=ea(s-J);J=ea(g[v>>2]);if(Ja<J){P=0;Ra=12;break}Ja=ea(g[w>>2]);if(ea(Ja+s)<m){P=0;Ra=12;break}Ea=ea(Fa-J);J=ea(Ja-m);m=Ea<J?Ea:J;if(m<ea(g[p>>2])){g[q>>2]=Ka;g[ra>>2]=L;g[sa>>2]=Ia;g[p>>2]=m;c[r>>2]=ta}}}ta=ta+1|0;if(ta>>>0>=y>>>0){P=1;Ra=12;break}}if((Ra|0)==12){i=u;return P|0}return 0}function lEb(a,b,d,e,f,h,j,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=ea(u);var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=0,U=0,V=Im,W=Im,X=0,Y=0,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=0,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=0,Ua=0,Va=Im,Wa=Im,Xa=0,Ya=0,Za=0,_a=0,$a=Im;v=i;i=i+6320|0;w=v+6224|0;x=v+6208|0;y=v+6252|0;z=v+6308|0;A=v+6164|0;B=v+6248|0;C=v+6256|0;D=v+6296|0;E=v+6312|0;F=v+6316|0;G=v+6152|0;H=v+3076|0;I=v;J=v+6232|0;K=v+6168|0;L=v+6184|0;M=v+6272|0;N=v+6212|0;O=ea(g[f>>2]);P=ea(g[o>>2]);Q=ea(O*P);R=f+4|0;O=ea(g[R>>2]);U=o+4|0;V=ea(g[U>>2]);W=ea(Q+ea(O*V));X=f+8|0;O=ea(g[X>>2]);Y=o+8|0;Q=ea(g[Y>>2]);Z=ea(W+ea(O*Q));_=f+12|0;O=ea(P*ea(g[_>>2]));$=f+16|0;W=ea(O+ea(V*ea(g[$>>2])));aa=f+20|0;O=ea(W+ea(Q*ea(g[aa>>2])));ba=f+24|0;W=ea(P*ea(g[ba>>2]));ca=f+28|0;da=ea(W+ea(V*ea(g[ca>>2])));fa=f+32|0;W=ea(da+ea(Q*ea(g[fa>>2])));ga=i;i=i+((1*(c[d+16>>2]<<2)|0)+15&-16)|0;g[B>>2]=ea(3402823469999999843913219.0e14);da=ea(-V);V=ea(-Q);g[D>>2]=ea(-P);g[D+4>>2]=da;g[D+8>>2]=V;if(!(pHb(d,e,f,h,j,l,n,Z,O,W,B,C,p,ga,A,u,D)|0)){ha=0;i=v;return ha|0}W=ea(g[h>>2]);O=ea(g[o>>2]);Z=ea(W*O);D=h+4|0;W=ea(g[D>>2]);V=ea(g[U>>2]);da=ea(Z+ea(W*V));ia=h+8|0;W=ea(g[ia>>2]);Z=ea(g[Y>>2]);P=ea(da+ea(W*Z));ja=h+12|0;W=ea(O*ea(g[ja>>2]));ka=h+16|0;da=ea(W+ea(V*ea(g[ka>>2])));la=h+20|0;W=ea(da+ea(Z*ea(g[la>>2])));ma=h+24|0;da=ea(O*ea(g[ma>>2]));na=h+28|0;O=ea(da+ea(V*ea(g[na>>2])));oa=h+32|0;V=ea(O+ea(Z*ea(g[oa>>2])));pa=i;i=i+((1*(c[e+16>>2]<<2)|0)+15&-16)|0;g[F>>2]=ea(3402823469999999843913219.0e14);if(!(pHb(e,d,h,f,l,j,m,ea(-P),ea(-W),ea(-V),F,G,q,pa,E,u,o)|0)){ha=0;i=v;return ha|0}V=ea(g[B>>2]);W=ea(g[C>>2]);P=ea(g[C+4>>2]);Z=ea(g[C+8>>2]);c[t>>2]=0;O=ea(g[F>>2]);if(O<V){da=ea(g[G>>2]);Q=ea(g[G+4>>2]);qa=ea(g[G+8>>2]);c[t>>2]=1;ra=qa;sa=Q;ta=da;ua=O}else{ra=Z;sa=P;ta=W;ua=V}c[H>>2]=0;c[I>>2]=0;G=c[p>>2]|0;p=d+24|0;F=c[p>>2]|0;C=c[q>>2]|0;q=e+24|0;B=c[q>>2]|0;V=ea(g[F+(G*20|0)+12>>2]);va=J+12|0;W=ea(g[j+36>>2]);P=ea(g[F+(G*20|0)>>2]);Z=ea(W*P);W=ea(g[j+40>>2]);O=ea(g[F+(G*20|0)+4>>2]);da=ea(Z+ea(W*O));W=ea(g[j+44>>2]);Z=ea(g[F+(G*20|0)+8>>2]);Q=ea(da+ea(W*Z));W=ea(P*ea(g[j+48>>2]));da=ea(W+ea(O*ea(g[j+52>>2])));W=ea(da+ea(Z*ea(g[j+56>>2])));da=ea(P*ea(g[j+60>>2]));P=ea(da+ea(O*ea(g[j+64>>2])));O=ea(P+ea(Z*ea(g[j+68>>2])));Z=ea(ea(1.0)/ea(T(ea(ea(ea(Q*Q)+ea(W*W))+ea(O*O)))));P=ea(Q*Z);Q=ea(W*Z);W=ea(O*Z);g[J>>2]=P;G=J+4|0;g[G>>2]=Q;F=J+8|0;g[F>>2]=W;O=ea(V*Z);g[va>>2]=O;Z=ea(g[B+(C*20|0)+12>>2]);V=ea(g[l+36>>2]);da=ea(g[B+(C*20|0)>>2]);qa=ea(V*da);V=ea(g[l+40>>2]);wa=ea(g[B+(C*20|0)+4>>2]);xa=ea(qa+ea(V*wa));V=ea(g[l+44>>2]);qa=ea(g[B+(C*20|0)+8>>2]);ya=ea(xa+ea(V*qa));V=ea(da*ea(g[l+48>>2]));xa=ea(V+ea(wa*ea(g[l+52>>2])));V=ea(xa+ea(qa*ea(g[l+56>>2])));xa=ea(da*ea(g[l+60>>2]));da=ea(xa+ea(wa*ea(g[l+64>>2])));wa=ea(da+ea(qa*ea(g[l+68>>2])));qa=ea(ea(1.0)/ea(T(ea(ea(ea(ya*ya)+ea(V*V))+ea(wa*wa)))));da=ea(ya*qa);ya=ea(V*qa);V=ea(wa*qa);g[K>>2]=da;C=K+4|0;g[C>>2]=ya;wa=ea(Z*qa);qa=ea(P*ea(g[m>>2]));Z=ea(P*ea(g[m+4>>2]));xa=ea(P*ea(g[m+8>>2]));P=ea(Q*ea(g[m+12>>2]));za=ea(Q*ea(g[m+16>>2]));Aa=ea(qa+P);P=ea(Z+za);za=ea(xa+ea(Q*ea(g[m+20>>2])));Q=ea(W*ea(g[m+24>>2]));xa=ea(W*ea(g[m+28>>2]));Z=ea(Aa+Q);Q=ea(P+xa);xa=ea(za+ea(W*ea(g[m+32>>2])));W=ea(Z*ea(g[m+36>>2]));za=ea(W+ea(Q*ea(g[m+40>>2])));W=ea(O-ea(za+ea(xa*ea(g[m+44>>2]))));g[J>>2]=Z;g[G>>2]=Q;g[F>>2]=xa;g[va>>2]=W;W=ea(da*ea(g[n>>2]));xa=ea(da*ea(g[n+4>>2]));Q=ea(da*ea(g[n+8>>2]));da=ea(ya*ea(g[n+12>>2]));Z=ea(ya*ea(g[n+16>>2]));za=ea(W+da);da=ea(xa+Z);Z=ea(Q+ea(ya*ea(g[n+20>>2])));ya=ea(V*ea(g[n+24>>2]));Q=ea(V*ea(g[n+28>>2]));xa=ea(za+ya);ya=ea(da+Q);Q=ea(Z+ea(V*ea(g[n+32>>2])));V=ea(xa*ea(g[n+36>>2]));Z=ea(V+ea(ya*ea(g[n+40>>2])));V=ea(wa-ea(Z+ea(Q*ea(g[n+44>>2]))));g[K>>2]=xa;g[C>>2]=ya;g[K+8>>2]=Q;g[K+12>>2]=V;V=ea(g[a>>2]);Q=ea(g[a+4>>2]);ya=ea(g[a+8>>2]);xa=ea(g[a+12>>2]);Z=ea(g[a+16>>2]);wa=ea(g[a+20>>2]);da=ea(g[b>>2]);za=ea(g[b+4>>2]);W=ea(g[b+8>>2]);O=ea(g[b+12>>2]);P=ea(g[b+16>>2]);Aa=ea(g[b+20>>2]);g[L>>2]=ea(V-u);g[L+4>>2]=ea(Q-u);g[L+8>>2]=ea(ya-u);g[M>>2]=ea(da-u);g[M+4>>2]=ea(za-u);g[M+8>>2]=ea(W-u);g[L+12>>2]=ea(xa+u);g[L+16>>2]=ea(Z+u);g[L+20>>2]=ea(wa+u);g[M+12>>2]=ea(O+u);g[M+16>>2]=ea(P+u);g[M+20>>2]=ea(Aa+u);qHb(H,ga,c[A>>2]|0,c[p>>2]|0,c[d+28>>2]|0,c[d+32>>2]|0,f,K,m,M,u,j);qHb(I,pa,c[E>>2]|0,c[q>>2]|0,c[e+28>>2]|0,c[e+32>>2]|0,h,J,n,L,u,l);L=c[H>>2]|0;n=c[I>>2]|0;a:do if(!L){Ba=ra;Ca=sa;Da=ta;Ea=ua}else{J=N+4|0;q=N+8|0;E=d+44|0;pa=d+48|0;M=d+52|0;m=e+44|0;K=e+48|0;p=e+52|0;A=d+40|0;ga=e+40|0;b=d+64|0;a=e+64|0;if(!n){C=0;while(1){C=C+1|0;if(C>>>0>=L>>>0){Ba=ra;Ca=sa;Da=ta;Ea=ua;break a}}}else{Fa=ea(0.0);Ga=ta;Ha=sa;Ia=ra;Ja=ua;Ka=0}b:while(1){C=H+(Ka*12|0)+8|0;va=H+(Ka*12|0)+12|0;F=H+(Ka*12|0)+4|0;Aa=Ia;P=Ha;O=Ga;wa=Fa;Z=Ja;G=0;while(1){xa=ea(g[C>>2]);W=ea(g[I+(G*12|0)+12>>2]);za=ea(xa*W);da=ea(g[va>>2]);ya=ea(g[I+(G*12|0)+8>>2]);Q=ea(za-ea(da*ya));za=ea(g[I+(G*12|0)+4>>2]);V=ea(da*za);da=ea(g[F>>2]);qa=ea(V-ea(W*da));W=ea(ea(ya*da)-ea(xa*za));g[N>>2]=Q;g[J>>2]=qa;g[q>>2]=W;if((!(+ea(S(ea(Q)))>1.0e-06)?!(+ea(S(ea(qa)))>1.0e-06):0)?!(+ea(S(ea(W)))>1.0e-06):0){La=wa;Ma=O;Na=P;Oa=Aa;Pa=Z}else{za=ea(ea(ea(Q*Q)+ea(qa*qa))+ea(W*W));if(za>ea(0.0)){xa=ea(ea(1.0)/ea(T(ea(za))));Qa=ea(Q*xa);Ra=ea(qa*xa);Sa=ea(W*xa)}else{Qa=ea(0.0);Ra=ea(0.0);Sa=ea(0.0)}g[N>>2]=Qa;g[J>>2]=Ra;g[q>>2]=Sa;xa=ea(g[o>>2]);W=ea(g[U>>2]);qa=ea(g[Y>>2]);Q=ea(ea(g[f>>2])*Qa);za=ea(Q+ea(ea(g[R>>2])*Ra));Q=ea(za+ea(Sa*ea(g[X>>2])));za=ea(Qa*ea(g[_>>2]));da=ea(za+ea(Ra*ea(g[$>>2])));za=ea(da+ea(Sa*ea(g[aa>>2])));da=ea(Qa*ea(g[ba>>2]));ya=ea(da+ea(Ra*ea(g[ca>>2])));da=ea(ya+ea(Sa*ea(g[fa>>2])));B=(g[k>>2]=Q,c[k>>2]|0);Ta=(g[k>>2]=za,c[k>>2]|0);Ua=(g[k>>2]=da,c[k>>2]|0);ya=ea(Qa*ea(g[h>>2]));V=ea(ya+ea(Ra*ea(g[D>>2])));ya=ea(V+ea(Sa*ea(g[ia>>2])));V=ea(Qa*ea(g[ja>>2]));Va=ea(V+ea(Ra*ea(g[ka>>2])));V=ea(Va+ea(Sa*ea(g[la>>2])));Va=ea(Qa*ea(g[ma>>2]));Wa=ea(Va+ea(Ra*ea(g[na>>2])));Va=ea(Wa+ea(Sa*ea(g[oa>>2])));Xa=(g[k>>2]=ya,c[k>>2]|0);Ya=(g[k>>2]=V,c[k>>2]|0);Wa=ea(ea(ea(-ea(W*Ra))-ea(xa*Qa))-ea(Sa*qa));Za=c[p>>2]|(g[k>>2]=Va,c[k>>2]|0)&-2147483648;qa=ea(Q*(c[k>>2]=c[E>>2]|B&-2147483648,ea(g[k>>2])));Q=ea(qa+ea(za*(c[k>>2]=c[pa>>2]|Ta&-2147483648,ea(g[k>>2]))));za=ea(Q+ea(da*(c[k>>2]=c[M>>2]|Ua&-2147483648,ea(g[k>>2]))));da=ea(ya*(c[k>>2]=c[m>>2]|Xa&-2147483648,ea(g[k>>2])));ya=ea(da+ea(V*(c[k>>2]=c[K>>2]|Ya&-2147483648,ea(g[k>>2]))));V=ea(ya+ea(Va*(c[k>>2]=Za,ea(g[k>>2]))));Va=ea(g[A>>2]);ya=ea(g[ga>>2]);da=ea((za>Va?za:Va)+(V>ya?V:ya));ya=ea(Wa+da);V=ea(da-Wa);if(!((ya<V?ya:V)>Z)){rn[c[b>>2]&127](d,N,f,j,y,z);V=ea(g[y>>2]);ya=ea(g[z>>2]);rn[c[a>>2]&127](e,N,h,l,w,x);Wa=ea(ya+u);da=ea(g[w>>2]);if(!(Wa<da)?(Wa=ea(g[x>>2]),!(ea(Wa+u)<V)):0){Va=ea(ya-da);da=ea(Wa-V);_a=1;$a=Va<da?Va:da}else{_a=0;$a=wa}if(!_a){ha=0;break b}if($a<Z){da=ea(g[N>>2]);Va=ea(g[J>>2]);V=ea(g[q>>2]);c[t>>2]=2;La=$a;Ma=da;Na=Va;Oa=V;Pa=$a}else{La=$a;Ma=O;Na=P;Oa=Aa;Pa=Z}}else{La=wa;Ma=O;Na=P;Oa=Aa;Pa=Z}}G=G+1|0;if(G>>>0>=n>>>0)break;else{Aa=Oa;P=Na;O=Ma;wa=La;Z=Pa}}Ka=Ka+1|0;if(Ka>>>0>=L>>>0){Ba=Oa;Ca=Na;Da=Ma;Ea=Pa;break a}else{Fa=La;Ga=Ma;Ha=Na;Ia=Oa;Ja=Pa}}i=v;return ha|0}while(0);g[r>>2]=Ea;g[s>>2]=Da;g[s+4>>2]=Ca;g[s+8>>2]=Ba;ha=1;i=v;return ha|0}function mEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=0,i=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=0,q=Im,r=Im,s=Im;d=ea(ea(g[b>>2])*ea(2.0));e=ea(ea(g[b+4>>2])*ea(2.0));f=ea(ea(g[b+8>>2])*ea(2.0));h=c+12|0;i=ea(g[h>>2]);j=ea(ea(i*i)+ea(-.5));k=ea(g[c>>2]);l=ea(d*k);m=c+4|0;n=ea(g[m>>2]);o=ea(l+ea(e*n));p=c+8|0;l=ea(g[p>>2]);q=ea(o+ea(f*l));o=ea(ea(n*q)+ea(ea(e*j)+ea(i*ea(ea(d*l)-ea(f*k)))));r=ea(ea(ea(f*j)+ea(i*ea(ea(e*k)-ea(d*n))))+ea(l*q));g[a>>2]=ea(ea(k*q)+ea(ea(d*j)+ea(i*ea(ea(f*n)-ea(e*l)))));g[a+4>>2]=o;g[a+8>>2]=r;r=ea(ea(g[b+12>>2])*ea(2.0));o=ea(ea(g[b+16>>2])*ea(2.0));e=ea(ea(g[b+20>>2])*ea(2.0));f=ea(ea(ea(r*k)+ea(o*n))+ea(e*l));d=ea(ea(n*f)+ea(ea(o*j)+ea(i*ea(ea(r*l)-ea(e*k)))));q=ea(ea(ea(e*j)+ea(i*ea(ea(o*k)-ea(r*n))))+ea(l*f));g[a+12>>2]=ea(ea(k*f)+ea(ea(r*j)+ea(i*ea(ea(e*n)-ea(o*l)))));g[a+16>>2]=d;g[a+20>>2]=q;q=ea(ea(g[b+24>>2])*ea(2.0));d=ea(ea(g[b+28>>2])*ea(2.0));o=ea(ea(g[b+32>>2])*ea(2.0));e=ea(ea(ea(q*k)+ea(d*n))+ea(o*l));r=ea(ea(n*e)+ea(ea(d*j)+ea(i*ea(ea(q*l)-ea(o*k)))));f=ea(ea(ea(o*j)+ea(i*ea(ea(d*k)-ea(q*n))))+ea(l*e));g[a+24>>2]=ea(ea(k*e)+ea(ea(q*j)+ea(i*ea(ea(o*n)-ea(d*l)))));g[a+28>>2]=r;g[a+32>>2]=f;f=ea(ea(g[b+36>>2])*ea(2.0));r=ea(ea(g[b+40>>2])*ea(2.0));l=ea(ea(g[b+44>>2])*ea(2.0));d=ea(g[h>>2]);n=ea(ea(d*d)+ea(-.5));o=ea(g[c>>2]);i=ea(f*o);j=ea(g[m>>2]);q=ea(i+ea(r*j));i=ea(g[p>>2]);e=ea(q+ea(l*i));q=ea(ea(o*e)+ea(ea(f*n)+ea(d*ea(ea(l*j)-ea(r*i)))));k=ea(ea(j*e)+ea(ea(r*n)+ea(d*ea(ea(f*i)-ea(l*o)))));s=ea(ea(ea(l*n)+ea(d*ea(ea(r*o)-ea(f*j))))+ea(i*e));e=ea(ea(g[c+16>>2])+q);q=ea(ea(g[c+20>>2])+k);k=ea(ea(g[c+24>>2])+s);g[a+36>>2]=e;g[a+40>>2]=q;g[a+44>>2]=k;g[a+48>>2]=ea(g[b+48>>2]);g[a+52>>2]=ea(g[b+52>>2]);g[a+56>>2]=ea(g[b+56>>2]);return}function nEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im;d=ea(g[c>>2]);e=ea(g[c+4>>2]);f=ea(g[c+8>>2]);h=ea(g[c+16>>2]);i=ea(g[c+20>>2]);j=ea(g[c+24>>2]);k=ea(g[c+32>>2]);l=ea(g[c+36>>2]);m=ea(g[c+40>>2]);n=ea(g[c+48>>2]);o=ea(g[c+52>>2]);p=ea(g[c+56>>2]);q=ea(g[c+64>>2]);r=ea(g[c+68>>2]);s=ea(g[c+72>>2]);t=ea(g[c+80>>2]);u=ea(g[c+84>>2]);v=ea(g[c+88>>2]);w=ea(g[b>>2]);x=ea(g[b+4>>2]);y=ea(g[b+8>>2]);z=ea(g[b+16>>2]);A=ea(g[b+20>>2]);B=ea(g[b+24>>2]);C=ea(g[b+32>>2]);D=ea(g[b+36>>2]);E=ea(g[b+40>>2]);F=ea(g[b+48>>2]);G=ea(g[b+52>>2]);H=ea(g[b+56>>2]);I=ea(g[b+64>>2]);J=ea(g[b+68>>2]);K=ea(g[b+72>>2]);L=ea(g[b+80>>2]);M=ea(g[b+84>>2]);N=ea(g[b+88>>2]);O=ea(g[b+96>>2]);P=ea(g[b+100>>2]);Q=ea(g[b+104>>2]);R=ea(g[b+112>>2]);S=ea(g[b+116>>2]);T=ea(g[b+120>>2]);U=ea(g[b+128>>2]);V=ea(g[b+132>>2]);W=ea(d*e);X=ea(d*f);Y=ea(h*i);Z=ea(h*j);_=ea(e*f);$=ea(i*j);aa=ea(k*l);ba=ea(k*m);ca=ea(n*o);da=ea(n*p);fa=ea(l*m);ga=ea(o*p);ha=ea(q*r);ia=ea(q*s);ja=ea(ea(ea(x-W)-aa)-ha);x=ea(ea(ea(y-X)-ba)-ia);y=ea(ea(ea(F-ea(d*h))-ea(k*n))-ea(q*t));F=ea(ea(ea(G-ea(e*h))-ea(l*n))-ea(r*t));G=ea(ea(ea(H-ea(f*h))-ea(m*n))-ea(s*t));H=ea(t*u);ka=ea(t*v);la=ea(ea(ea(O-ea(h*h))-ea(n*n))-ea(t*t));t=ea(ea(ea(P-Y)-ca)-H);P=ea(ea(ea(Q-Z)-da)-ka);Q=ea(r*s);n=ea(ea(ea(z-W)-aa)-ha);ha=ea(ea(ea(A-ea(e*e))-ea(l*l))-ea(r*r));A=ea(ea(ea(B-_)-fa)-Q);B=ea(ea(ea(I-ea(d*i))-ea(k*o))-ea(q*u));I=ea(ea(ea(J-ea(e*i))-ea(l*o))-ea(r*u));J=ea(ea(ea(K-ea(f*i))-ea(m*o))-ea(s*u));K=ea(u*v);aa=ea(ea(ea(R-Y)-ca)-H);H=ea(ea(ea(S-ea(i*i))-ea(o*o))-ea(u*u));u=ea(ea(ea(T-$)-ga)-K);T=ea(ea(ea(C-X)-ba)-ia);ia=ea(ea(ea(D-_)-fa)-Q);Q=ea(ea(ea(E-ea(f*f))-ea(m*m))-ea(s*s));E=ea(ea(ea(L-ea(d*j))-ea(k*p))-ea(q*v));L=ea(ea(ea(M-ea(e*j))-ea(l*p))-ea(r*v));r=ea(ea(ea(N-ea(f*j))-ea(m*p))-ea(s*v));s=ea(ea(ea(U-Z)-da)-ka);ka=ea(ea(ea(V-$)-ga)-K);K=ea(ea(ea(ea(g[b+136>>2])-ea(j*j))-ea(p*p))-ea(v*v));g[a>>2]=ea(ea(ea(w-ea(d*d))-ea(k*k))-ea(q*q));g[a+4>>2]=ja;g[a+8>>2]=x;g[a+12>>2]=ea(0.0);g[a+16>>2]=n;g[a+20>>2]=ha;g[a+24>>2]=A;g[a+28>>2]=ea(0.0);g[a+32>>2]=T;g[a+36>>2]=ia;g[a+40>>2]=Q;g[a+44>>2]=ea(0.0);g[a+48>>2]=y;g[a+52>>2]=F;g[a+56>>2]=G;g[a+60>>2]=ea(0.0);g[a+64>>2]=B;g[a+68>>2]=I;g[a+72>>2]=J;g[a+76>>2]=ea(0.0);g[a+80>>2]=E;g[a+84>>2]=L;g[a+88>>2]=r;g[a+92>>2]=ea(0.0);g[a+96>>2]=la;g[a+100>>2]=t;g[a+104>>2]=P;g[a+108>>2]=ea(0.0);g[a+112>>2]=aa;g[a+116>>2]=H;g[a+120>>2]=u;g[a+124>>2]=ea(0.0);g[a+128>>2]=s;g[a+132>>2]=ka;g[a+136>>2]=K;g[a+140>>2]=ea(0.0);return}function oEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[c>>2]);i=ea(g[c+4>>2]);j=ea(d+h);h=ea(e+i);i=ea(f+ea(g[c+8>>2]));f=ea(g[b+16>>2]);e=ea(g[b+20>>2]);d=ea(g[b+24>>2]);k=ea(g[c+16>>2]);l=ea(g[c+20>>2]);m=ea(f+k);k=ea(e+l);l=ea(d+ea(g[c+24>>2]));d=ea(g[b+32>>2]);e=ea(g[b+36>>2]);f=ea(g[b+40>>2]);n=ea(g[c+32>>2]);o=ea(g[c+36>>2]);p=ea(d+n);n=ea(e+o);o=ea(f+ea(g[c+40>>2]));f=ea(g[b+48>>2]);e=ea(g[b+52>>2]);d=ea(g[b+56>>2]);q=ea(g[c+48>>2]);r=ea(g[c+52>>2]);s=ea(f+q);q=ea(e+r);r=ea(d+ea(g[c+56>>2]));d=ea(g[b+64>>2]);e=ea(g[b+68>>2]);f=ea(g[b+72>>2]);t=ea(g[c+64>>2]);u=ea(g[c+68>>2]);v=ea(d+t);t=ea(e+u);u=ea(f+ea(g[c+72>>2]));f=ea(g[b+80>>2]);e=ea(g[b+84>>2]);d=ea(g[b+88>>2]);w=ea(g[c+80>>2]);x=ea(g[c+84>>2]);y=ea(f+w);w=ea(e+x);x=ea(d+ea(g[c+88>>2]));d=ea(g[b+96>>2]);e=ea(g[b+100>>2]);f=ea(g[b+104>>2]);z=ea(g[c+96>>2]);A=ea(g[c+100>>2]);B=ea(d+z);z=ea(e+A);A=ea(f+ea(g[c+104>>2]));f=ea(g[b+112>>2]);e=ea(g[b+116>>2]);d=ea(g[b+120>>2]);C=ea(g[c+112>>2]);D=ea(g[c+116>>2]);E=ea(f+C);C=ea(e+D);D=ea(d+ea(g[c+120>>2]));d=ea(g[b+128>>2]);e=ea(g[b+132>>2]);f=ea(g[b+136>>2]);F=ea(g[c+128>>2]);G=ea(g[c+132>>2]);H=ea(d+F);F=ea(e+G);G=ea(f+ea(g[c+136>>2]));g[a>>2]=j;g[a+4>>2]=h;g[a+8>>2]=i;g[a+12>>2]=ea(0.0);g[a+16>>2]=m;g[a+20>>2]=k;g[a+24>>2]=l;g[a+28>>2]=ea(0.0);g[a+32>>2]=p;g[a+36>>2]=n;g[a+40>>2]=o;g[a+44>>2]=ea(0.0);g[a+48>>2]=s;g[a+52>>2]=q;g[a+56>>2]=r;g[a+60>>2]=ea(0.0);g[a+64>>2]=v;g[a+68>>2]=t;g[a+72>>2]=u;g[a+76>>2]=ea(0.0);g[a+80>>2]=y;g[a+84>>2]=w;g[a+88>>2]=x;g[a+92>>2]=ea(0.0);g[a+96>>2]=B;g[a+100>>2]=z;g[a+104>>2]=A;g[a+108>>2]=ea(0.0);g[a+112>>2]=E;g[a+116>>2]=C;g[a+120>>2]=D;g[a+124>>2]=ea(0.0);g[a+128>>2]=H;g[a+132>>2]=F;g[a+136>>2]=G;g[a+140>>2]=ea(0.0);return}function pEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else wEb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}xEb(m,n,f,a);f=a+264|0;h=a+268|0;xEb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<5)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+32|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function qEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else uEb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}vEb(m,n,f,a);f=a+264|0;h=a+268|0;vEb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<4)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+16|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function rEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else sEb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}tEb(m,n,f,a);f=a+264|0;h=a+268|0;tEb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<3)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+8|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function sEb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?502168:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function tEb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?502168:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?502168:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function uEb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?502032:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function vEb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?502032:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?502032:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function wEb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if((g|0)!=0?(f=g<<2,(f|0)!=0):0){h=mKa()|0;j=c[(c[h>>2]|0)+8>>2]|0;k=pKa()|0;l=mo[c[(c[k>>2]|0)+24>>2]&4095](k)|0;m=Bn[j&255](h,f,l?501896:544544,537640,558)|0}else m=0;l=a+4|0;f=c[l>>2]|0;h=m+(f<<2)|0;if((f|0)>0){j=m;k=c[a>>2]|0;while(1){if(j)c[j>>2]=c[k>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else k=k+4|0}}if(h)c[h>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[a>>2]|0,(b|0)!=0):0){h=mKa()|0;In[c[(c[h>>2]|0)+12>>2]&4095](h,b);n=c[l>>2]|0}else n=f;c[a>>2]=m;c[e>>2]=g;c[l>>2]=n+1;i=d;return m+(n<<2)|0}function xEb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+144|0;e=f;g=e;c[g>>2]=0;c[g+4>>2]=0;g=e+4|0;a[g>>0]=0;h=f+8|0;c[e>>2]=h;j=d+-1|0;if((j|0)>0){d=0;k=h;h=32;l=0;m=0;n=j;a:while(1){j=m;o=l;p=n;while(1){if((p|0)>(j|0)){if((p-j|0)>>>0<5)q=j;else break;do{r=q;q=q+1|0;s=q;t=r;while(1){t=(c[b+(s<<2)>>2]|0)>>>0<(c[b+(t<<2)>>2]|0)>>>0?s:t;if((s|0)>=(p|0))break;else s=s+1|0}s=b+(t<<2)|0;u=b+(r<<2)|0;v=c[s>>2]|0;c[s>>2]=c[u>>2];c[u>>2]=v}while((q|0)!=(p|0))}if(!o)break a;v=c[k+(o+-1<<2)>>2]|0;u=o+-2|0;j=c[k+(u<<2)>>2]|0;o=u;p=v}v=b+(((p+j|0)/2|0)<<2)|0;u=b+(j<<2)|0;s=c[v>>2]|0;w=c[u>>2]|0;if(s>>>0<w>>>0){c[u>>2]=s;c[v>>2]=w;x=w;y=c[u>>2]|0}else{x=s;y=w}w=b+(p<<2)|0;s=c[w>>2]|0;if(s>>>0<y>>>0){c[u>>2]=s;c[w>>2]=y;z=y;A=c[v>>2]|0}else{z=s;A=x}if(z>>>0<A>>>0){c[v>>2]=z;c[w>>2]=A;B=c[v>>2]|0}else B=A;w=p+-1|0;s=b+(w<<2)|0;c[v>>2]=c[s>>2];c[s>>2]=B;v=B;u=j;C=w;while(1){D=u;while(1){E=D+1|0;F=b+(E<<2)|0;G=c[F>>2]|0;if(G>>>0<v>>>0)D=E;else{H=C;break}}do{H=H+-1|0;I=b+(H<<2)|0;J=c[I>>2]|0}while(v>>>0<J>>>0);if((E|0)>=(H|0))break;c[F>>2]=J;c[I>>2]=G;v=c[s>>2]|0;u=E;C=H}c[F>>2]=v;c[s>>2]=G;if((E-j|0)<(p-E|0)){if(o>>>0>=(h+-1|0)>>>0){C=h<<1;u=h<<3;if(!u)K=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;N=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;K=Bn[L&255](w,u,N?501896:544544,523928,148)|0}YEi(K|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){O=1;P=C;Q=K}else{N=mKa()|0;In[c[(c[N>>2]|0)+12>>2]&4095](N,k);O=1;P=C;Q=K}}else{O=d;P=h;Q=k}c[Q+(o<<2)>>2]=j;c[Q+(o+1<<2)>>2]=D;R=O;S=Q;T=P;U=D+2|0;V=p}else{C=D+2|0;if(o>>>0>=(h+-1|0)>>>0){N=h<<1;u=h<<3;if(!u)W=0;else{w=mKa()|0;L=c[(c[w>>2]|0)+8>>2]|0;M=pKa()|0;X=mo[c[(c[M>>2]|0)+24>>2]&4095](M)|0;W=Bn[L&255](w,u,X?501896:544544,523928,148)|0}YEi(W|0,k|0,o<<2|0)|0;if(d<<24>>24==0|(k|0)==0){Y=W;Z=1;_=N}else{X=mKa()|0;In[c[(c[X>>2]|0)+12>>2]&4095](X,k);Y=W;Z=1;_=N}}else{Y=k;Z=d;_=h}c[Y+(o<<2)>>2]=C;c[Y+(o+1<<2)>>2]=p;R=Z;S=Y;T=_;U=j;V=D}d=R;k=S;h=T;l=o+2|0;m=U;n=V}if(!(d<<24>>24==0|(k|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,k)}}if(!(a[g>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function yEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im;d=i;e=ea(g[a+16>>2]);f=ea(g[a+20>>2]);h=ea(g[a+24>>2]);j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(e-j);j=ea(f-k);k=ea(h-ea(g[b+8>>2]));h=ea(g[c>>2]);f=ea(g[c+4>>2]);e=ea(g[c+8>>2]);m=ea(g[a+128>>2]);n=ea(g[a+132>>2]);o=ea(h+m);m=ea(f+n);n=ea(e+ea(g[a+136>>2]));if(l>o|j>m|k>n|l<ea(-o)|j<ea(-m)|k<ea(-n)){p=0;i=d;return p|0}n=ea(g[a+32>>2]);m=ea(g[a+36>>2]);o=ea(g[a+40>>2]);q=ea(g[a+48>>2]);r=ea(g[a+52>>2]);s=ea(g[a+56>>2]);t=ea(g[a+64>>2]);u=ea(g[a+68>>2]);v=ea(g[a+72>>2]);w=ea(g[a+80>>2]);x=ea(g[a+84>>2]);y=ea(g[a+88>>2]);z=ea(g[a+96>>2]);A=ea(g[a+100>>2]);B=ea(g[a+104>>2]);C=ea(g[a+112>>2]);D=ea(g[a+116>>2]);E=ea(g[a+120>>2]);F=ea(ea(ea(l*n)+ea(j*q))+ea(k*t));G=ea(ea(ea(l*m)+ea(j*r))+ea(k*u));H=ea(ea(ea(l*o)+ea(j*s))+ea(k*v));I=ea(g[a>>2]);J=ea(g[a+4>>2]);K=ea(ea(C*e)+ea(ea(z*f)+ea(ea(w*h)+I)));I=ea(ea(D*e)+ea(ea(A*f)+ea(ea(x*h)+J)));J=ea(ea(E*e)+ea(ea(B*f)+ea(ea(y*h)+ea(g[a+8>>2]))));if(F>K|G>I|H>J|F<ea(-K)|G<ea(-I)|H<ea(-J)){p=0;i=d;return p|0}J=ea(ea(k*q)-ea(j*t));H=ea(ea(k*r)-ea(j*u));I=ea(ea(k*s)-ea(j*v));G=ea(g[a+144>>2]);K=ea(g[a+148>>2]);F=ea(ea(z*e)+ea(ea(C*f)+G));G=ea(ea(A*e)+ea(ea(D*f)+K));K=ea(ea(B*e)+ea(ea(E*f)+ea(g[a+152>>2])));L=ea(-F);M=ea(-G);N=ea(-K);O=ea(ea(l*t)-ea(k*n));t=ea(ea(l*u)-ea(k*m));u=ea(ea(l*v)-ea(k*o));k=ea(g[a+160>>2]);v=ea(g[a+164>>2]);P=ea(ea(w*e)+ea(ea(C*h)+k));k=ea(ea(x*e)+ea(ea(D*h)+v));v=ea(ea(y*e)+ea(ea(E*h)+ea(g[a+168>>2])));E=ea(-P);e=ea(-k);D=ea(-v);C=ea(ea(j*n)-ea(l*q));q=ea(ea(j*m)-ea(l*r));r=ea(ea(j*o)-ea(l*s));s=ea(g[a+176>>2]);l=ea(g[a+180>>2]);o=ea(ea(w*f)+ea(ea(z*h)+s));s=ea(ea(x*f)+ea(ea(A*h)+l));l=ea(ea(y*f)+ea(ea(B*h)+ea(g[a+184>>2])));p=(C<ea(-o)|C>o|(O<E|O>P)|(J<L|J>F)|(q<ea(-s)|q>s|(t<e|t>k)|(H<M|H>G))|(r<ea(-l)|r>l|(u<D|u>v)|(I<N|I>K)))&1^1;i=d;return p|0}function zEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0;d=i;e=ea(g[c>>2]);f=ea(g[c+4>>2]);h=ea(g[c+8>>2]);j=ea(g[a+48>>2]);k=ea(g[a+52>>2]);l=ea(e+j);j=ea(f+k);k=ea(h+ea(g[a+56>>2]));h=ea(g[b>>2]);f=ea(g[b+4>>2]);e=ea(g[b+8>>2]);m=ea(l+h);n=ea(j+f);o=ea(h-l);p=ea(f-j);q=ea(g[a>>2]);r=ea(g[a+4>>2]);s=ea(q-h);h=ea(r-f);f=ea(ea(g[a+8>>2])-e);r=ea(g[a+32>>2]);q=ea(g[a+36>>2]);t=ea(g[a+40>>2]);u=ea(g[a+16>>2]);v=ea(g[a+20>>2]);w=ea(ea(h*u)-ea(s*r));r=ea(ea(f*v)-ea(h*q));q=ea(ea(s*ea(g[a+24>>2]))-ea(f*t));t=ea(g[a+80>>2]);f=ea(g[a+84>>2]);s=ea(g[a+64>>2]);h=ea(ea(l*t)+ea(j*s));s=ea(ea(j*f)+ea(k*ea(g[a+68>>2])));f=ea(g[a+96>>2]);j=ea(g[a+100>>2]);t=ea(g[a+112>>2]);v=ea(g[a+116>>2]);u=ea(-w);x=ea(-r);y=ea(-q);if(!(h>=(w>u?w:u)&(t>=o&m>=f)&(s>=(r>x?r:x)&(v>=p&n>=j)))){z=0;A=z&1;i=d;return A|0}j=ea(g[a+72>>2]);n=ea(k*ea(g[a+88>>2]));p=ea(l*j);j=ea(p+n);n=ea(g[a+120>>2]);p=ea(e-k);l=ea(k+e);z=j>=(q>y?q:y)&(n>=p?l>=ea(g[a+104>>2]):0);A=z&1;i=d;return A|0}function AEb(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0;c=i;d=ea(g[b+16>>2]);e=ea(g[b+20>>2]);f=ea(g[b+24>>2]);h=ea(g[a+16>>2]);j=ea(g[a+20>>2]);k=ea(g[a+24>>2]);l=ea(g[b>>2]);m=ea(g[b+4>>2]);n=ea(h-l);l=ea(j-m);m=ea(k-ea(g[b+8>>2]));k=ea(g[a+128>>2]);j=ea(g[a+132>>2]);h=ea(d+k);k=ea(e+j);j=ea(f+ea(g[a+136>>2]));if(n>h|l>k|m>j|n<ea(-h)|l<ea(-k)|m<ea(-j)){o=0;i=c;return o|0}j=ea(g[a+32>>2]);k=ea(g[a+36>>2]);h=ea(g[a+40>>2]);p=ea(g[a+48>>2]);q=ea(g[a+52>>2]);r=ea(g[a+56>>2]);s=ea(g[a+64>>2]);t=ea(g[a+68>>2]);u=ea(g[a+72>>2]);v=ea(g[a+80>>2]);w=ea(g[a+84>>2]);x=ea(g[a+88>>2]);y=ea(g[a+96>>2]);z=ea(g[a+100>>2]);A=ea(g[a+104>>2]);B=ea(g[a+112>>2]);C=ea(g[a+116>>2]);D=ea(g[a+120>>2]);E=ea(ea(ea(n*j)+ea(l*p))+ea(m*s));s=ea(ea(ea(n*k)+ea(l*q))+ea(m*t));t=ea(ea(ea(n*h)+ea(l*r))+ea(m*u));u=ea(g[a>>2]);m=ea(g[a+4>>2]);r=ea(ea(f*B)+ea(ea(e*y)+ea(ea(d*v)+u)));u=ea(ea(f*C)+ea(ea(e*z)+ea(ea(d*w)+m)));m=ea(ea(f*D)+ea(ea(e*A)+ea(ea(d*x)+ea(g[a+8>>2]))));if(E>r|s>u|t>m|E<ea(-r)|s<ea(-u))F=0;else F=!(t<ea(-m));o=F&1;i=c;return o|0}function BEb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+176|0;f=e;PEi(f|0,0,164)|0;PFa(f);rHb(c,d+1|0,b+12|0,f);PEi(f|0,0,168)|0;LFa(f);sHb(c,d+2|0,b+36|0,f);PEi(f|0,0,140)|0;TFa(f);tHb(c,d+3|0,b+60|0,f);a[f>>0]=0;uHb(c,d+4|0,b+84|0,f);a[f>>0]=0;vHb(c,d+5|0,b+108|0,f);a[f>>0]=0;wHb(c,d+6|0,b+132|0,f);a[f>>0]=0;xHb(c,d+7|0,b+156|0,f);a[f>>0]=0;yHb(c,d+8|0,b+180|0,f);a[f>>0]=0;zHb(c,d+9|0,b+204|0,f);AHb(c,b+228|0,0);i=e;return d+12|0}function CEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+176|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];BHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=0;else k=c[d>>2]|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,144)|0;qFa(f);CHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function DEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];BHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=112;else j=(c[d>>2]|0)+112|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=657;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}DHb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function EEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];BHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=256;else j=(c[d>>2]|0)+256|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=658;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}EHb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function FEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];BHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=272;else j=(c[d>>2]|0)+272|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=659;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}FHb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function GEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];BHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=528;else j=(c[d>>2]|0)+528|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=662;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}GHb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function HEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];BHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=560;else j=(c[d>>2]|0)+560|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=663;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}HHb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function IEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+288|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];IHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=12;else k=(c[d>>2]|0)+12|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,256)|0;xGa(f);JHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function JEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+96|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];IHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=76;else k=(c[d>>2]|0)+76|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+72|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));GGa(f);KHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function KEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+320|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];IHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=112;else k=(c[d>>2]|0)+112|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,296)|0;dHa(f);LHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function LEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+128|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];IHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=212;else k=(c[d>>2]|0)+212|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+96|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));rHa(f);MHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function MEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+36|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;NHb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+52|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[v+0>>2];c[b+4>>2]=c[v+4>>2];c[b+8>>2]=c[v+8>>2];c[b+12>>2]=c[v+12>>2];b=c[v>>2]|0;if(s){v=s+-1|0;u=c[t+4>>2]|0;if(!(a[u+(v<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[u+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=b;a[g+4>>0]=0;b=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[b>>2]|0}c[b>>2]=y+1}else OAb(w,g)|0;OHb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){z=e+5|0;i=f;return z|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){A=h;B=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;A=g;B=c[g+8>>2]|0}c[A+8>>2]=B+-1;z=e+5|0;i=f;return z|0}function NEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+80|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];b=c[j>>2]|0;j=c[d>>2]|0;k=c[j+8>>2]|0;if(k){l=k+-1|0;m=c[j+4>>2]|0;if(!(a[m+(l<<3)+4>>0]|0)){n=c[d+4>>2]|0;In[c[(c[n>>2]|0)+16>>2]&4095](n,c[m+(l<<3)>>2]|0);l=c[d>>2]|0;a[(c[l+4>>2]|0)+((c[l+8>>2]|0)+-1<<3)+4>>0]=1;l=c[d>>2]|0;o=l;p=c[l+8>>2]|0}else{o=j;p=k}}else{o=j;p=0}c[g>>2]=b;a[g+4>>0]=0;b=o+8|0;if((c[o+12>>2]&2147483647)>>>0>p>>>0){j=(c[o+4>>2]|0)+(p<<3)|0;if(!j)q=p;else{p=g;k=c[p+4>>2]|0;l=j;c[l>>2]=c[p>>2];c[l+4>>2]=k;q=c[b>>2]|0}c[b>>2]=q+1}else OAb(o,g)|0;PHb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){r=e+2|0;i=f;return r|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){s=h;t=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;s=g;t=c[g+8>>2]|0}c[s+8>>2]=t+-1;r=e+2|0;i=f;return r|0}function OEb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+832|0;f=e+800|0;g=e+704|0;h=e+672|0;j=e+96|0;k=e;l=c[b+24>>2]|0;if(!l)m=212;else m=(c[l>>2]|0)+212|0;a[d>>0]=1;c[d+4>>2]=m;m=c[b+20>>2]|0;if(m)c[m>>2]=(c[m>>2]|0)+1;m=k+0|0;l=m+96|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(l|0));rHa(k);In[c[d+16>>2]&4095](j,c[b+8>>2]|0);d=c[b>>2]|0;k=c[b+4>>2]|0;m=c[b+12>>2]|0;l=c[b+16>>2]|0;rHa(g);c[f>>2]=d;c[f+4>>2]=k;c[f+8>>2]=j;c[f+12>>2]=m;c[f+16>>2]=l;c[f+20>>2]=0;c[f+24>>2]=0;QHb(g,f,0)|0;c[h>>2]=d;c[h+4>>2]=k;c[h+8>>2]=j;c[h+12>>2]=m;c[h+16>>2]=l;c[h+20>>2]=0;c[h+24>>2]=0;RHb(g,h,0)|0;i=e;return}function PEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+288|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];SHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=12;else k=(c[d>>2]|0)+12|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,256)|0;xGa(f);THb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function QEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+96|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];SHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=76;else k=(c[d>>2]|0)+76|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+72|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));GGa(f);UHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function REb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+320|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];SHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=112;else k=(c[d>>2]|0)+112|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,296)|0;dHa(f);VHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function SEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];SHb(b,c[d>>2]|0);WHb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function TEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+96|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];SHb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=216;else k=(c[d>>2]|0)+216|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+64|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));mHa(f);XHb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function UEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+36|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;YHb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+52|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[v+0>>2];c[b+4>>2]=c[v+4>>2];c[b+8>>2]=c[v+8>>2];c[b+12>>2]=c[v+12>>2];b=c[v>>2]|0;if(s){v=s+-1|0;u=c[t+4>>2]|0;if(!(a[u+(v<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[u+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=b;a[g+4>>0]=0;b=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[b>>2]|0}c[b>>2]=y+1}else OAb(w,g)|0;ZHb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){z=e+5|0;i=f;return z|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){A=h;B=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;A=g;B=c[g+8>>2]|0}c[A+8>>2]=B+-1;z=e+5|0;i=f;return z|0}function VEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+80|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];b=c[j>>2]|0;j=c[d>>2]|0;k=c[j+8>>2]|0;if(k){l=k+-1|0;m=c[j+4>>2]|0;if(!(a[m+(l<<3)+4>>0]|0)){n=c[d+4>>2]|0;In[c[(c[n>>2]|0)+16>>2]&4095](n,c[m+(l<<3)>>2]|0);l=c[d>>2]|0;a[(c[l+4>>2]|0)+((c[l+8>>2]|0)+-1<<3)+4>>0]=1;l=c[d>>2]|0;o=l;p=c[l+8>>2]|0}else{o=j;p=k}}else{o=j;p=0}c[g>>2]=b;a[g+4>>0]=0;b=o+8|0;if((c[o+12>>2]&2147483647)>>>0>p>>>0){j=(c[o+4>>2]|0)+(p<<3)|0;if(!j)q=p;else{p=g;k=c[p+4>>2]|0;l=j;c[l>>2]=c[p>>2];c[l+4>>2]=k;q=c[b>>2]|0}c[b>>2]=q+1}else OAb(o,g)|0;_Hb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){r=e+2|0;i=f;return r|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){s=h;t=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;s=g;t=c[g+8>>2]|0}c[s+8>>2]=t+-1;r=e+2|0;i=f;return r|0}function WEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+32|0;g=f;h=f+8|0;j=c[b+104>>2]|0;k=c[b+96>>2]|0;l=c[d>>2]|0;m=c[l+8>>2]|0;if(m){n=m+-1|0;o=c[l+4>>2]|0;if(!(a[o+(n<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[o+(n<<3)>>2]|0);n=c[d>>2]|0;a[(c[n+4>>2]|0)+((c[n+8>>2]|0)+-1<<3)+4>>0]=1;n=c[d>>2]|0;q=n;r=c[n+8>>2]|0}else{q=l;r=m}}else{q=l;r=0}c[g>>2]=k;a[g+4>>0]=0;k=q+8|0;if((c[q+12>>2]&2147483647)>>>0>r>>>0){l=(c[q+4>>2]|0)+(r<<3)|0;if(!l)s=r;else{r=g;m=c[r+4>>2]|0;n=l;c[n>>2]=c[r>>2];c[n+4>>2]=m;s=c[k>>2]|0}c[k>>2]=s+1}else OAb(q,g)|0;q=c[d+20>>2]|0;if(q)c[q>>2]=(c[q>>2]|0)+1;q=d+4|0;s=c[q>>2]|0;k=c[d>>2]|0;m=c[k+8>>2]|0;if(!m)t=515864;else t=c[(c[k+4>>2]|0)+(m+-1<<3)>>2]|0;m=mo[j&4095](c[d+8>>2]|0)|0;if(517392){j=517392;k=517368;do{if((c[k+4>>2]|0)==(m|0))co[c[(c[s>>2]|0)+8>>2]&2047](s,t,j);k=k+8|0;j=c[k>>2]|0}while((j|0)!=0)}j=c[d>>2]|0;k=c[j+8>>2]|0;if(!k){u=0;v=j}else{if(!(a[(c[j+4>>2]|0)+(k+-1<<3)+4>>0]|0)){w=k;x=j}else{j=c[q>>2]|0;ko[c[(c[j>>2]|0)+20>>2]&4095](j);j=c[d>>2]|0;w=c[j+8>>2]|0;x=j}c[x+8>>2]=w+-1;w=c[d>>2]|0;u=c[w+8>>2]|0;v=w}w=b+124|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[w+0>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];c[b+12>>2]=c[w+12>>2];b=c[w>>2]|0;if(u){w=u+-1|0;x=c[v+4>>2]|0;if(!(a[x+(w<<3)+4>>0]|0)){j=c[q>>2]|0;In[c[(c[j>>2]|0)+16>>2]&4095](j,c[x+(w<<3)>>2]|0);w=c[d>>2]|0;a[(c[w+4>>2]|0)+((c[w+8>>2]|0)+-1<<3)+4>>0]=1;w=c[d>>2]|0;y=w;z=c[w+8>>2]|0}else{y=v;z=u}}else{y=v;z=0}c[g>>2]=b;a[g+4>>0]=0;b=y+8|0;if((c[y+12>>2]&2147483647)>>>0>z>>>0){v=(c[y+4>>2]|0)+(z<<3)|0;if(!v)A=z;else{z=g;u=c[z+4>>2]|0;w=v;c[w>>2]=c[z>>2];c[w+4>>2]=u;A=c[b>>2]|0}c[b>>2]=A+1}else OAb(y,g)|0;$Hb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){B=e+3|0;i=f;return B|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){C=h;D=g}else{g=c[q>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;C=g;D=c[g+8>>2]|0}c[C+8>>2]=D+-1;B=e+3|0;i=f;return B|0}function XEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+288|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];aIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=12;else k=(c[d>>2]|0)+12|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,256)|0;xGa(f);bIb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function YEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+96|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];aIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=76;else k=(c[d>>2]|0)+76|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+72|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));GGa(f);cIb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function ZEb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+320|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];aIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=112;else k=(c[d>>2]|0)+112|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,296)|0;dHa(f);dIb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function _Eb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+112|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];aIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=212;else k=(c[d>>2]|0)+212|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+80|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));BHa(f);eIb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function $Eb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+36|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;fIb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+52|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[v+0>>2];c[b+4>>2]=c[v+4>>2];c[b+8>>2]=c[v+8>>2];c[b+12>>2]=c[v+12>>2];b=c[v>>2]|0;if(s){v=s+-1|0;u=c[t+4>>2]|0;if(!(a[u+(v<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[u+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=b;a[g+4>>0]=0;b=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[b>>2]|0}c[b>>2]=y+1}else OAb(w,g)|0;gIb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){z=e+5|0;i=f;return z|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){A=h;B=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;A=g;B=c[g+8>>2]|0}c[A+8>>2]=B+-1;z=e+5|0;i=f;return z|0}function aFb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+80|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];b=c[j>>2]|0;j=c[d>>2]|0;k=c[j+8>>2]|0;if(k){l=k+-1|0;m=c[j+4>>2]|0;if(!(a[m+(l<<3)+4>>0]|0)){n=c[d+4>>2]|0;In[c[(c[n>>2]|0)+16>>2]&4095](n,c[m+(l<<3)>>2]|0);l=c[d>>2]|0;a[(c[l+4>>2]|0)+((c[l+8>>2]|0)+-1<<3)+4>>0]=1;l=c[d>>2]|0;o=l;p=c[l+8>>2]|0}else{o=j;p=k}}else{o=j;p=0}c[g>>2]=b;a[g+4>>0]=0;b=o+8|0;if((c[o+12>>2]&2147483647)>>>0>p>>>0){j=(c[o+4>>2]|0)+(p<<3)|0;if(!j)q=p;else{p=g;k=c[p+4>>2]|0;l=j;c[l>>2]=c[p>>2];c[l+4>>2]=k;q=c[b>>2]|0}c[b>>2]=q+1}else OAb(o,g)|0;hIb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){r=e+2|0;i=f;return r|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){s=h;t=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;s=g;t=c[g+8>>2]|0}c[s+8>>2]=t+-1;r=e+2|0;i=f;return r|0}function bFb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+768|0;f=e+736|0;g=e+656|0;h=e+624|0;j=e+80|0;k=e;l=c[b+24>>2]|0;if(!l)m=212;else m=(c[l>>2]|0)+212|0;a[d>>0]=1;c[d+4>>2]=m;m=c[b+20>>2]|0;if(m)c[m>>2]=(c[m>>2]|0)+1;m=k+0|0;l=m+80|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(l|0));BHa(k);In[c[d+16>>2]&4095](j,c[b+8>>2]|0);d=c[b>>2]|0;k=c[b+4>>2]|0;m=c[b+12>>2]|0;l=c[b+16>>2]|0;BHa(g);c[f>>2]=d;c[f+4>>2]=k;c[f+8>>2]=j;c[f+12>>2]=m;c[f+16>>2]=l;c[f+20>>2]=0;c[f+24>>2]=0;iIb(g,f,0)|0;c[h>>2]=d;c[h+4>>2]=k;c[h+8>>2]=j;c[h+12>>2]=m;c[h+16>>2]=l;c[h+20>>2]=0;c[h+24>>2]=0;jIb(g,h,0)|0;i=e;return}function cFb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+288|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];kIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=12;else k=(c[d>>2]|0)+12|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,256)|0;xGa(f);lIb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function dFb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+96|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];kIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=76;else k=(c[d>>2]|0)+76|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;k=f+0|0;h=k+72|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));GGa(f);mIb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function eFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;kIb(b,c[e>>2]|0);a[g>>0]=0;c[g+4>>2]=0;c[g+8>>2]=d;c[g+12>>2]=e;nIb(b,0,g,0);g=c[b>>2]|0;e=c[g+8>>2]|0;if(!e){a[b+36>>0]=1;i=f;return}d=e+-1|0;h=c[g+4>>2]|0;if((a[h+(d<<3)+4>>0]|0)!=0?(a[h+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;j=d;k=c[d+8>>2]|0}else{j=g;k=e}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;e=b+36|0;a[e>>0]=1;if(!j){i=f;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=f;return}a[e>>0]=0;i=f;return}function fFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;kIb(b,c[e>>2]|0);a[g>>0]=0;c[g+4>>2]=0;c[g+8>>2]=d;c[g+12>>2]=e;oIb(b,0,g,0);g=c[b>>2]|0;e=c[g+8>>2]|0;if(!e){a[b+36>>0]=1;i=f;return}d=e+-1|0;h=c[g+4>>2]|0;if((a[h+(d<<3)+4>>0]|0)!=0?(a[h+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;j=d;k=c[d+8>>2]|0}else{j=g;k=e}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;e=b+36|0;a[e>>0]=1;if(!j){i=f;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=f;return}a[e>>0]=0;i=f;return}function gFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;kIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;pIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function hFb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+608|0;f=e+352|0;g=e+320|0;h=e+256|0;j=e;k=c[b+24>>2]|0;if(!k)l=12;else l=(c[k>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,256)|0;xGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;xGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;qIb(f,g,0)|0;i=e;return}function iFb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+208|0;f=e+136|0;g=e+104|0;h=e+72|0;j=e;k=c[b+24>>2]|0;if(!k)l=76;else l=(c[k>>2]|0)+76|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+72|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;rIb(f,g,0)|0;i=e;return}function jFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function kFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function lFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function mFb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=Im,q=0,r=0,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;h=a+(((d+b|0)/2|0)<<2)|0;j=a+(b<<2)|0;b=c[h>>2]|0;k=c[e+4>>2]|0;l=c[e>>2]|0;m=ea(g[k+(b<<5)+(l<<2)>>2]);n=ea(m+ea(g[k+(b<<5)+16+(l<<2)>>2]));o=c[j>>2]|0;m=ea(g[k+(o<<5)+(l<<2)>>2]);p=ea(g[k+(o<<5)+16+(l<<2)>>2]);if(n<ea(m+p)){c[j>>2]=b;c[h>>2]=o;q=c[e>>2]|0;r=c[j>>2]|0;n=ea(g[k+(r<<5)+(q<<2)>>2]);s=q;t=n;u=ea(g[k+(r<<5)+16+(q<<2)>>2]);v=r;w=o}else{s=l;t=m;u=p;v=o;w=b}b=a+(d<<2)|0;o=c[b>>2]|0;p=ea(g[k+(o<<5)+(s<<2)>>2]);m=ea(g[k+(o<<5)+16+(s<<2)>>2]);if(ea(p+m)<ea(t+u)){c[j>>2]=o;c[b>>2]=v;j=c[e>>2]|0;u=ea(g[k+(v<<5)+(j<<2)>>2]);t=ea(g[k+(v<<5)+16+(j<<2)>>2]);x=u;y=t;z=c[h>>2]|0;A=j;B=v}else{x=p;y=m;z=w;A=s;B=o}m=ea(x+y);y=ea(g[k+(z<<5)+(A<<2)>>2]);if(!(m<ea(y+ea(g[k+(z<<5)+16+(A<<2)>>2])))){C=z;D=d+-1|0;E=a+(D<<2)|0;F=c[E>>2]|0;c[h>>2]=F;c[E>>2]=C;i=f;return}c[h>>2]=B;c[b>>2]=z;C=c[h>>2]|0;D=d+-1|0;E=a+(D<<2)|0;F=c[E>>2]|0;c[h>>2]=F;c[E>>2]=C;i=f;return}function nFb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=Im,ua=0,va=Im,wa=0,xa=0;e=i;i=i+64|0;f=e+49|0;h=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;if(d>>>0<2){n=0;i=e;return n|0}if((d|0)==2){n=1;i=e;return n|0}o=d>>>0>3;p=o?2:1;q=d-p|0;r=c[a+32>>2]|0;c[l>>2]=r;c[l+4>>2]=c[a+36>>2];c[l+8>>2]=c[a+40>>2];s=c[a+20>>2]|0;c[m>>2]=s;c[m+4>>2]=c[a+24>>2];c[m+8>>2]=c[a+28>>2];t=a+8|0;u=a+48|0;v=a+4|0;w=(p|0)>(q|0);x=d+-1|0;y=d+-2|0;z=(y|0)>(q|0);A=d>>>1;B=q-p|0;C=B+1|0;D=(B|0)>-1;B=a+12|0;E=a+16|0;F=a+44|0;a=d+1-(p<<1)|0;G=s;s=r;r=0;while(1){if((c[u>>2]|0)==(d|0)){H=c[v>>2]|0;I=0;do{c[H+(I<<2)>>2]=c[G+(I<<2)>>2];I=I+1|0}while((I|0)!=(d|0))}else{I=c[F>>2]|0;H=0;do{c[I+(H<<2)>>2]=c[s+(c[b+(H<<2)>>2]<<2)>>2];H=H+1|0}while((H|0)!=(d|0));F$a(c[F>>2]|0,d,f,h);H=c[F>>2]|0;I=c[v>>2]|0;J=0;do{c[I+(J<<2)>>2]=c[G+(c[H+(J<<2)>>2]<<2)>>2];J=J+1|0}while((J|0)!=(d|0))}J=c[v>>2]|0;H=c[J>>2]|0;I=c[t>>2]|0;K=ea(g[I+(H<<5)>>2]);L=ea(g[I+(H<<5)+4>>2]);M=ea(g[I+(H<<5)+8>>2]);N=ea(g[I+(H<<5)+16>>2]);O=ea(g[I+(H<<5)+20>>2]);P=ea(g[I+(H<<5)+24>>2]);if(o){Q=K;R=N;S=M;T=P;U=O;V=L;H=1;while(1){W=c[J+(H<<2)>>2]|0;X=ea(g[I+(W<<5)>>2]);Y=ea(g[I+(W<<5)+4>>2]);Z=ea(g[I+(W<<5)+8>>2]);_=Q<X?Q:X;X=V<Y?V:Y;Y=S<Z?S:Z;Z=ea(g[I+(W<<5)+16>>2]);$=ea(g[I+(W<<5)+20>>2]);aa=ea(g[I+(W<<5)+24>>2]);ba=R>Z?R:Z;Z=U>$?U:$;$=T>aa?T:aa;H=H+1|0;if((H|0)>=(p|0)){ca=_;da=ba;fa=Y;ga=$;ha=X;ia=Z;break}else{Q=_;R=ba;S=Y;T=$;U=Z;V=X}}}else{ca=K;da=N;fa=M;ga=P;ha=L;ia=O}if(!w){H=c[B>>2]|0;V=ca;U=da;T=fa;S=ga;R=ha;Q=ia;W=0;ja=p;while(1){ka=c[J+(ja<<2)>>2]|0;X=ea(g[I+(ka<<5)>>2]);Z=ea(g[I+(ka<<5)+4>>2]);$=ea(g[I+(ka<<5)+8>>2]);V=V<X?V:X;R=R<Z?R:Z;T=T<$?T:$;$=ea(g[I+(ka<<5)+16>>2]);Z=ea(g[I+(ka<<5)+20>>2]);X=ea(g[I+(ka<<5)+24>>2]);U=U>$?U:$;Q=Q>Z?Q:Z;S=S>X?S:X;X=ea(U-V);Z=ea(Q-R);$=ea(S-T);g[H+(W<<2)>>2]=ea(ea(Z*$)+ea(ea(X*Z)+ea(X*$)));W=W+1|0;if((W|0)==(a|0))break;else ja=ja+1|0}}ja=c[J+(x<<2)>>2]|0;T=ea(g[I+(ja<<5)>>2]);S=ea(g[I+(ja<<5)+4>>2]);R=ea(g[I+(ja<<5)+8>>2]);Q=ea(g[I+(ja<<5)+16>>2]);V=ea(g[I+(ja<<5)+20>>2]);U=ea(g[I+(ja<<5)+24>>2]);if(z){O=Q;L=T;P=U;M=R;N=S;K=V;ja=y;while(1){W=c[J+(ja<<2)>>2]|0;$=ea(g[I+(W<<5)>>2]);X=ea(g[I+(W<<5)+4>>2]);Z=ea(g[I+(W<<5)+8>>2]);Y=L<$?L:$;$=N<X?N:X;X=M<Z?M:Z;Z=ea(g[I+(W<<5)+16>>2]);ba=ea(g[I+(W<<5)+20>>2]);_=ea(g[I+(W<<5)+24>>2]);aa=O>Z?O:Z;Z=K>ba?K:ba;ba=P>_?P:_;ja=ja+-1|0;if((ja|0)<=(q|0)){la=aa;ma=Y;na=ba;oa=X;pa=$;qa=Z;break}else{O=aa;L=Y;P=ba;M=X;N=$;K=Z}}}else{la=Q;ma=T;na=U;oa=R;pa=S;qa=V}if(!w){ja=c[E>>2]|0;K=la;N=ma;M=na;P=oa;L=pa;O=qa;W=0;H=q;while(1){ka=c[J+(H<<2)>>2]|0;Z=ea(g[I+(ka<<5)>>2]);$=ea(g[I+(ka<<5)+4>>2]);X=ea(g[I+(ka<<5)+8>>2]);N=N<Z?N:Z;L=L<$?L:$;P=P<X?P:X;X=ea(g[I+(ka<<5)+16>>2]);$=ea(g[I+(ka<<5)+20>>2]);Z=ea(g[I+(ka<<5)+24>>2]);K=K>X?K:X;O=O>$?O:$;M=M>Z?M:Z;Z=ea(K-N);$=ea(O-L);X=ea(M-P);g[ja+(W<<2)>>2]=ea(ea($*X)+ea(ea(Z*$)+ea(Z*X)));if((H|0)<=(p|0))break;else{W=W+1|0;H=H+-1|0}}}if(D){H=c[B>>2]|0;W=c[E>>2]|0;ja=0;P=ea(3402823469999999843913219.0e14);I=0;while(1){J=ja+p|0;M=ea(J|0);ka=C-ja+-1|0;L=ea(ka+p|0);O=ea(M*ea(g[H+(ja<<2)>>2]));M=ea(O+ea(L*ea(g[W+(ka<<2)>>2])));if(!(M<P))if(M<=P?(ka=J-A|0,ra=I-A|0,(((ka|0)>-1?ka:0-ka|0)|0)<(((ra|0)>-1?ra:0-ra|0)|0)):0)sa=26;else{ta=P;ua=I}else sa=26;if((sa|0)==26){sa=0;ta=M;ua=J}ja=ja+1|0;if((ja|0)>=(C|0)){va=ta;wa=ua;break}else{P=ta;I=ua}}}else{va=ea(3402823469999999843913219.0e14);wa=0}g[j+(r<<2)>>2]=va;c[k+(r<<2)>>2]=wa;I=r+1|0;if((I|0)==3)break;G=c[m+(I<<2)>>2]|0;s=c[l+(I<<2)>>2]|0;r=I}va=ea(g[j>>2]);ta=ea(g[j+4>>2]);qa=ea(g[j+8>>2]);if(!(va<=ta)|!(va<=qa))if(!(ta<=qa))xa=2;else xa=1;else xa=0;j=c[l+(xa<<2)>>2]|0;l=c[m+(xa<<2)>>2]|0;if((c[u>>2]|0)==(d|0)){u=0;do{c[b+(u<<2)>>2]=c[l+(u<<2)>>2];u=u+1|0}while((u|0)!=(d|0))}else{u=c[F>>2]|0;m=0;do{c[u+(m<<2)>>2]=c[j+(c[b+(m<<2)>>2]<<2)>>2];m=m+1|0}while((m|0)!=(d|0));F$a(c[F>>2]|0,d,f,h);h=c[F>>2]|0;F=0;do{c[b+(F<<2)>>2]=c[l+(c[h+(F<<2)>>2]<<2)>>2];F=F+1|0}while((F|0)!=(d|0))}F=c[k+(xa<<2)>>2]|0;n=(d|0)==3&(F|0)==0?1:F;i=e;return n|0}function oFb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b+44|0;g=c[f>>2]|0;h=(g&2147483647|0)==0?1:g<<1;if(!h)j=0;else{g=h<<3;k=b+32|0;if(!((a[k>>0]|0)==0&g>>>0<33))if(!g)l=0;else{m=mKa()|0;n=c[(c[m>>2]|0)+8>>2]|0;o=pKa()|0;p=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;l=Bn[n&255](m,g,p?524016:544544,537640,558)|0}else{a[k>>0]=1;l=b}j=l}l=b+40|0;k=c[l>>2]|0;p=j+(k<<3)|0;g=b+36|0;if((k|0)>0){m=j;n=c[g>>2]|0;while(1){if(m){o=n;q=c[o+4>>2]|0;r=m;c[r>>2]=c[o>>2];c[r+4>>2]=q}m=m+8|0;if(m>>>0>=p>>>0)break;else n=n+8|0}s=c[l>>2]|0}else s=k;k=j+(s<<3)|0;if(k){s=d;d=c[s+4>>2]|0;n=k;c[n>>2]=c[s>>2];c[n+4>>2]=d}do if((c[f>>2]|0)>-1){d=c[g>>2]|0;if((b|0)==(d|0)){a[b+32>>0]=0;break}if(d){n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,d)}}while(0);c[g>>2]=j;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=h+1;i=e;return j+(h<<3)|0}function pFb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if((h|0)!=0?(f=h<<5,(f|0)!=0):0){j=mKa()|0;k=c[(c[j>>2]|0)+8>>2]|0;l=pKa()|0;m=mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0;n=Bn[k&255](j,f,m?523816:544544,537640,558)|0}else n=0;m=a+4|0;f=c[m>>2]|0;j=n+(f<<5)|0;if((f|0)>0){k=n;l=c[a>>2]|0;while(1){if(k){g[k>>2]=ea(g[l>>2]);g[k+4>>2]=ea(g[l+4>>2]);g[k+8>>2]=ea(g[l+8>>2]);g[k+12>>2]=ea(g[l+12>>2]);g[k+16>>2]=ea(g[l+16>>2]);g[k+20>>2]=ea(g[l+20>>2]);o=l+24|0;p=c[o+4>>2]|0;q=k+24|0;c[q>>2]=c[o>>2];c[q+4>>2]=p}k=k+32|0;if(k>>>0>=j>>>0)break;else l=l+32|0}r=c[m>>2]|0}else r=f;f=n+(r<<5)|0;if(f){g[f>>2]=ea(g[b>>2]);g[n+(r<<5)+4>>2]=ea(g[b+4>>2]);g[n+(r<<5)+8>>2]=ea(g[b+8>>2]);g[n+(r<<5)+12>>2]=ea(g[b+12>>2]);g[n+(r<<5)+16>>2]=ea(g[b+16>>2]);g[n+(r<<5)+20>>2]=ea(g[b+20>>2]);f=b+24|0;b=c[f+4>>2]|0;l=n+(r<<5)+24|0;c[l>>2]=c[f>>2];c[l+4>>2]=b}if((c[e>>2]|0)<=-1){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s<<5)|0;i=d;return u|0}b=c[a>>2]|0;if(!b){c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s<<5)|0;i=d;return u|0}l=mKa()|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,b);c[a>>2]=n;c[e>>2]=h;s=c[m>>2]|0;t=s+1|0;c[m>>2]=t;u=n+(s<<5)|0;i=d;return u|0}function qFb(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)B5a(a,b);c[a+4>>2]=b;i=d;return}function rFb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;h=f+e|0;if(a[h>>0]|0){i=g;return}j=b+4|0;k=b+8|0;l=h;h=e;while(1){a[l>>0]=1;e=c[j>>2]|0;if((e|0)==(c[b>>2]|0)){gLa(b,1)|0;m=c[j>>2]|0}else m=e;c[j>>2]=m+1;c[(c[k>>2]|0)+(m<<2)>>2]=h;e=c[d+(h*12|0)>>2]|0;if(!(e&536870912))rFb(b,d,e&536870911,f);e=c[d+(h*12|0)+4>>2]|0;if(!(e&536870912))rFb(b,d,e&536870911,f);e=c[d+(h*12|0)+8>>2]|0;h=e&536870911;if(e&536870912){n=11;break}l=f+h|0;if(a[l>>0]|0){n=11;break}}if((n|0)==11){i=g;return}}function sFb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+16|0;j=h;k=j+4|0;l=a;m=1;n=a;a:while(1){o=l;p=n;b:while(1){q=o*3|0;r=c[e+(q<<2)>>2]|0;s=c[e+(q+1<<2)>>2]|0;c[j>>2]=1;c[k>>2]=2;if((r|0)!=(b|0))if((s|0)==(b|0)){c[j>>2]=0;c[k>>2]=2;t=0;u=2}else{t=1;u=2}else{c[j>>2]=0;c[k>>2]=1;t=0;u=1}v=c[d+(o*12|0)+(t<<2)>>2]|0;w=(c[d+(o*12|0)+(u<<2)>>2]&536870912|0)==0;if(v&536870912){x=8;break}if(!w){x=16;break}if((o|0)==(a|0)){y=0;x=21;break a}s=(p|0)==(a|0);r=v;q=1;while(1){z=r&536870911;if(!((z|0)!=(a|0)|s)){y=0;x=21;break a}if((z|0)!=(p|0)){A=o;o=z;p=A;continue b}if(q>>>0>=2){A=p;p=A;continue b}r=c[d+(o*12|0)+(c[j+(q<<2)>>2]<<2)>>2]|0;q=q+1|0}}if((x|0)==8){x=0;if(w){B=v;C=u}else{y=0;x=21;break}}else if((x|0)==16){x=0;c[j>>2]=u;c[k>>2]=t;B=c[d+(o*12|0)+(u<<2)>>2]|0;C=t}q=(B&536870912|0)==0;r=q&m;if(!(q|m)){x=18;break}q=c[d+(o*12|0)+(C<<2)>>2]|0;if(q&536870912){l=o;m=r;n=p;continue}s=q&536870911;q=(s|0)==(a|0);l=q?o:s;m=r;n=q?p:o}if((x|0)==18){c[f>>2]=B&536870911;c[g>>2]=o;y=1;i=h;return y|0}else if((x|0)==21){i=h;return y|0}return 0}function tFb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h;m=c[b>>2]|0;n=i;i=i+((1*m|0)+15&-16)|0;PEi(n|0,0,m|0)|0;m=g+4|0;aLa(j);o=c[m>>2]|0;if(!o){dLa(j);i=h;return}p=d+8|0;q=j+8|0;r=g+8|0;g=j+4|0;s=c[b>>2]|0;t=o;o=s;u=s;s=0;v=0;while(1){t=t+-1|0;if(!o){w=u;x=0;y=0}else{z=u;A=c[p>>2]|0;B=0;C=0;while(1){D=c[A>>2]|0;E=0;while(1){if(E>>>0>=D>>>0){F=z;G=B;break}E=E+1|0;if((c[(c[r>>2]|0)+(t<<2)>>2]|0)==(c[A+(E<<2)>>2]|0)){H=9;break}}if((H|0)==9){H=0;E=c[g>>2]|0;if((E|0)==(c[j>>2]|0)){gLa(j,1)|0;I=c[g>>2]|0}else I=E;c[g>>2]=I+1;E=c[q>>2]|0;c[E+(I<<2)>>2]=C;J=c[g>>2]|0;if((J|0)==(c[j>>2]|0)){gLa(j,1)|0;K=c[g>>2]|0;L=c[q>>2]|0}else{K=J;L=E}c[g>>2]=K+1;c[L+(K<<2)>>2]=D;F=c[b>>2]|0;G=B+1|0}C=C+1|0;if(C>>>0>=F>>>0){w=F;x=F;y=G;break}else{z=F;A=A+(D+1<<2)|0;B=G}}}B=v;v=y+v|0;if(B>>>0<v>>>0){A=c[q>>2]|0;z=B;B=s;while(1){C=(c[A+((z<<1|1)<<2)>>2]|0)==3|B;z=z+1|0;if((z|0)==(v|0)){M=C;break}else B=C}}else M=s;if(!t)break;else{o=x;u=w;s=M}}if(!M){dLa(j);i=h;return}if(c[m>>2]|0)c[m>>2]=0;if(v){m=c[j+8>>2]|0;M=0;do{a[n+(c[m+(M<<1<<2)>>2]|0)>>0]=1;M=M+1|0}while((M|0)!=(v|0))}aLa(k);aLa(l);if(!(c[b>>2]|0))N=0;else{v=k+4|0;M=k+8|0;m=l+4|0;s=l+8|0;w=c[d+8>>2]|0;u=c[f+8>>2]|0;x=0;o=0;while(1){t=c[w>>2]|0;q=c[u>>2]|0;if(!(a[n+x>>0]|0)){y=o+1|0;G=c[v>>2]|0;if((G|0)==(c[k>>2]|0)){gLa(k,1)|0;O=c[v>>2]|0}else O=G;c[v>>2]=O+1;G=c[M>>2]|0;c[G+(O<<2)>>2]=t;if(t){F=G;G=0;while(1){G=G+1|0;K=c[w+(G<<2)>>2]|0;L=c[v>>2]|0;if((L|0)==(c[k>>2]|0)){gLa(k,1)|0;P=c[v>>2]|0;Q=c[M>>2]|0}else{P=L;Q=F}c[v>>2]=P+1;c[Q+(P<<2)>>2]=K;if((G|0)==(t|0))break;else F=Q}}F=c[m>>2]|0;if((F|0)==(c[l>>2]|0)){gLa(l,1)|0;R=c[m>>2]|0}else R=F;c[m>>2]=R+1;F=c[s>>2]|0;c[F+(R<<2)>>2]=q;if(!q)S=y;else{G=F;F=0;while(1){F=F+1|0;K=c[u+(F<<2)>>2]|0;L=c[m>>2]|0;if((L|0)==(c[l>>2]|0)){gLa(l,1)|0;T=c[m>>2]|0;U=c[s>>2]|0}else{T=L;U=G}c[m>>2]=T+1;c[U+(T<<2)>>2]=K;if((F|0)==(q|0)){S=y;break}else G=U}}}else if(!q)S=o;else{G=0;do{G=G+1|0;y=c[u+(G<<2)>>2]|0;F=c[v>>2]|0;if((F|0)==(c[k>>2]|0)){gLa(k,1)|0;V=c[v>>2]|0}else V=F;c[v>>2]=V+1;F=c[M>>2]|0;c[F+(V<<2)>>2]=3;K=y*3|0;L=c[e+(K<<2)>>2]|0;g=c[v>>2]|0;if((g|0)==(c[k>>2]|0)){gLa(k,1)|0;W=c[v>>2]|0;X=c[M>>2]|0}else{W=g;X=F}c[v>>2]=W+1;c[X+(W<<2)>>2]=L;L=c[e+(K+1<<2)>>2]|0;F=c[v>>2]|0;if((F|0)==(c[k>>2]|0)){gLa(k,1)|0;Y=c[v>>2]|0;Z=c[M>>2]|0}else{Y=F;Z=X}c[v>>2]=Y+1;c[Z+(Y<<2)>>2]=L;L=c[e+(K+2<<2)>>2]|0;K=c[v>>2]|0;if((K|0)==(c[k>>2]|0)){gLa(k,1)|0;_=c[v>>2]|0;$=c[M>>2]|0}else{_=K;$=Z}c[v>>2]=_+1;c[$+(_<<2)>>2]=L;L=c[m>>2]|0;if((L|0)==(c[l>>2]|0)){gLa(l,1)|0;aa=c[m>>2]|0}else aa=L;c[m>>2]=aa+1;L=c[s>>2]|0;c[L+(aa<<2)>>2]=1;K=c[m>>2]|0;if((K|0)==(c[l>>2]|0)){gLa(l,1)|0;ba=c[m>>2]|0;ca=c[s>>2]|0}else{ba=K;ca=L}c[m>>2]=ba+1;c[ca+(ba<<2)>>2]=y}while((G|0)!=(q|0));S=o+q|0}x=x+1|0;if(x>>>0>=(c[b>>2]|0)>>>0){N=S;break}else{w=w+(t+1<<2)|0;u=u+(q+1<<2)|0;o=S}}}hLa(d)|0;hLa(f)|0;cLa(d,k);cLa(f,l);c[b>>2]=N;dLa(l);dLa(k);dLa(j);i=h;return}function uFb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;c[b>>2]=527328;f=b+4|0;c[f>>2]=d;d=b+8|0;c[d>>2]=f;j=b+12|0;c[j>>2]=527440;k=b+16|0;c[k>>2]=0;l=b+20|0;c[l>>2]=0;m=b+24|0;c[m>>2]=0;c[b+28>>2]=f;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+44>>2]=e;c[b+72>>2]=g;a[b+76>>0]=0;c[b+80>>2]=d;g=e+68|0;e=c[k>>2]|0;f=e;n=(c[l>>2]|0)-f|0;if(((c[m>>2]|0)-f|0)>>>0>g>>>0){c[b>>2]=527488;o=b+88|0;p=o+0|0;q=p+24|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(q|0));i=h;return}f=g<<1;if(!f){r=0;s=e}else{e=c[c[d>>2]>>2]|0;g=Bn[c[(c[e>>2]|0)+8>>2]&255](e,f,c[j>>2]|0,527352,117)|0;r=g;s=c[k>>2]|0}if((s|0)!=0?(YEi(r|0,s|0,n|0)|0,s=c[k>>2]|0,(s|0)!=0):0){g=c[c[d>>2]>>2]|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,s)}c[k>>2]=r;c[l>>2]=r+n;c[m>>2]=r+f;c[b>>2]=527488;o=b+88|0;p=o+0|0;q=p+24|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(q|0));i=h;return}function vFb(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;if((d|0)!=0?(d+-1&d|0)==0:0)f=d;else{h=d>>>1|d;d=h>>>2|h;h=d>>>4|d;d=h>>>8|h;f=(d>>>16|d)+1|0}d=a+20|0;h=c[d>>2]|0;j=ea(f>>>0);k=~~ea(j*ea(g[a+28>>2]))>>>0;l=f<<2;m=(k<<2)+l|0;n=(0-m&12)+m|0;m=c[c[a>>2]>>2]|0;o=Bn[c[(c[m>>2]|0)+8>>2]&255](m,n+(k<<3)|0,527016,529024,354)|0;m=o+l|0;p=o+n|0;PEi(o|0,-1,l|0)|0;l=a+40|0;if(c[l>>2]|0){n=a+8|0;q=f+-1|0;r=0;do{s=c[n>>2]|0;t=b[s+(r<<3)>>1]|0;u=t&65535;v=u+~(u<<15)|0;u=(v>>>10^v)*9|0;v=u>>>6^u;u=v+~(v<<11)|0;v=o+(((u>>>16^u)&q)<<2)|0;c[m+(r<<2)>>2]=c[v>>2];c[v>>2]=r;v=p+(r<<3)|0;if(v){b[v>>1]=t;c[p+(r<<3)+4>>2]=c[s+(r<<3)+4>>2]}r=r+1|0}while(r>>>0<(c[l>>2]|0)>>>0)}l=a+4|0;r=c[l>>2]|0;if(r){q=c[c[a>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,r)}c[l>>2]=o;c[a+16>>2]=o;c[a+24>>2]=f;c[a+12>>2]=m;c[a+8>>2]=p;c[d>>2]=k;k=a+32|0;if((c[k>>2]|0)!=-1){i=e;return}c[k>>2]=h;i=e;return}function wFb(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+16|0;j=h+8|0;k=h+12|0;l=h;m=d+148|0;oTa(c[m>>2]|0);b[j>>1]=f;n=PGb(d+212|0,j,k)|0;if(!((a[k>>0]|0)!=0|(n|0)==0)){b[n>>1]=b[j>>1]|0;c[n+4>>2]=e}n=d+160|0;o=c[n>>2]|0;c[j>>2]=e;p=RAb(d+168|0,j,k)|0;if(!((a[k>>0]|0)!=0|(p|0)==0)){c[p>>2]=c[j>>2];c[p+4>>2]=o}c[l>>2]=e;c[l+4>>2]=(g&1)<<16|f&65535;f=c[n>>2]|0;if((c[d+164>>2]&2147483647)>>>0<=f>>>0){tIb(d+152|0,l)|0;q=c[m>>2]|0;pTa(q);i=h;return}g=(c[d+156>>2]|0)+(f<<3)|0;if(!g)r=f;else{f=l;l=c[f+4>>2]|0;d=g;c[d>>2]=c[f>>2];c[d+4>>2]=l;r=c[n>>2]|0}c[n>>2]=r+1;q=c[m>>2]|0;pTa(q);i=h;return}function xFb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+12|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else{f=c[c[a>>2]>>2]|0;h=Bn[c[(c[f>>2]|0)+8>>2]&255](f,g<<2,527016,537640,558)|0}f=a+8|0;j=c[f>>2]|0;k=h+(j<<2)|0;l=a+4|0;if((j|0)>0){m=h;n=c[l>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=k>>>0)break;else n=n+4|0}}if(k)c[k>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[l>>2]|0,(b|0)!=0):0){k=c[c[a>>2]>>2]|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b);o=c[f>>2]|0}else o=j;c[l>>2]=h;c[e>>2]=g;c[f>>2]=o+1;i=d;return h+(o<<2)|0}function yFb(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im;l=i;i=i+32|0;m=l+20|0;n=l+16|0;o=l+12|0;p=l;q=h+4|0;r=h+8|0;s=p+4|0;t=p+8|0;u=f+12|0;v=f+24|0;w=ea(e+k);x=a+4|0;y=a+8|0;z=a+12|0;A=a+16|0;B=a+20|0;C=a+24|0;D=a+28|0;E=a+32|0;F=b+4096|0;G=a+44|0;H=a+40|0;I=a+36|0;J=0;do{K=d+(J*12|0)|0;k=ea(-ea(g[h>>2]));L=ea(-ea(g[q>>2]));M=ea(-ea(g[r>>2]));g[p>>2]=k;g[s>>2]=L;g[t>>2]=M;if((VPa(K,p,f,u,v,m,n,o,ea(0.0))|0?(M=ea(g[m>>2]),M<w):0)?(L=ea(g[h>>2]),k=ea(g[q>>2]),N=ea(g[r>>2]),O=ea(M*L),P=ea(M*k),Q=ea(M*N),R=ea(ea(g[K>>2])-O),O=ea(ea(g[d+(J*12|0)+4>>2])-P),P=ea(ea(g[d+(J*12|0)+8>>2])-Q),Q=ea(g[a>>2]),S=ea(g[x>>2]),T=ea(g[y>>2]),U=ea(g[z>>2]),V=ea(g[A>>2]),W=ea(g[B>>2]),X=ea(g[C>>2]),Y=ea(g[D>>2]),Z=ea(g[E>>2]),K=c[F>>2]|0,K>>>0<=63):0){_=ea(P*Z);$=ea(P*Y);aa=ea(P*X);P=ea(ea(R*T)+ea(O*W));ba=ea(ea(R*S)+ea(O*V));ca=ea(ea(R*Q)+ea(O*U));O=ea(Z*N);Z=ea(Y*N);Y=ea(X*N);N=ea(ea(T*L)+ea(W*k));W=ea(ea(S*L)+ea(V*k));V=ea(ea(Q*L)+ea(U*k));k=ea(g[G>>2]);U=ea(g[H>>2]);L=ea(M-e);M=ea(N+O);O=ea(W+Z);Z=ea(V+Y);Y=ea(ea(P+_)+k);k=ea(ea(ba+$)+U);U=ea(ea(ca+aa)+ea(g[I>>2]));c[F>>2]=K+1;g[b+(K<<6)>>2]=Z;g[b+(K<<6)+4>>2]=O;g[b+(K<<6)+8>>2]=M;g[b+(K<<6)+16>>2]=U;g[b+(K<<6)+20>>2]=k;g[b+(K<<6)+24>>2]=Y;g[b+(K<<6)+12>>2]=L;c[b+(K<<6)+48>>2]=-1;c[b+(K<<6)+52>>2]=j}J=J+1|0}while((J|0)!=2);i=l;return}function zFb(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im;k=i;l=ea(g[b>>2]);m=ea(g[b+4>>2]);n=ea(g[b+8>>2]);o=ea(g[b+16>>2]);p=ea(g[b+20>>2]);q=ea(o-l);o=ea(p-m);p=ea(ea(g[b+24>>2])-n);r=ea(ea(ea(q*q)+ea(o*o))+ea(p*p));s=r==ea(0.0);t=ea(ea(ea(ea(-ea(m*o))-ea(l*q))-ea(n*p))/r);u=t>ea(1.0);r=u?ea(1.0):t;u=r>ea(0.0);t=u?r:ea(0.0);r=s?ea(0.0):t;if(s){c[f>>2]=1;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=k;return}else{t=ea(g[e+8>>2]);p=ea(g[e+4>>2]);n=ea(g[e>>2]);q=ea(g[e+24>>2]);l=ea(g[e+20>>2]);o=ea(g[e+16>>2]);m=ea(g[d+8>>2]);v=ea(g[d+4>>2]);w=ea(g[d>>2]);x=ea(g[d+24>>2]);y=ea(g[d+20>>2]);z=ea(w+ea(r*ea(ea(g[d+16>>2])-w)));w=ea(ea(r*ea(y-v))+v);v=ea(ea(r*ea(x-m))+m);m=ea(ea(r*ea(o-n))+n);n=ea(ea(r*ea(l-p))+p);p=ea(ea(r*ea(q-t))+t);g[h>>2]=z;g[h+4>>2]=w;g[h+8>>2]=v;g[h+12>>2]=ea(0.0);g[j>>2]=m;g[j+4>>2]=n;g[j+8>>2]=p;g[j+12>>2]=ea(0.0);t=ea(w-n);n=ea(v-p);g[a>>2]=ea(z-m);g[a+4>>2]=t;g[a+8>>2]=n;g[a+12>>2]=ea(0.0);i=k;return}}function AFb(a,b,e,f,h){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=0;j=i;i=i+16|0;k=j;l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=ea(g[e+8>>2]);e=b+96|0;o=ea(l*ea(g[e>>2]));p=b+100|0;q=ea(o+ea(m*ea(g[p>>2])));r=b+104|0;o=ea(q+ea(n*ea(g[r>>2])));s=b+112|0;q=ea(l*ea(g[s>>2]));t=b+116|0;u=ea(q+ea(m*ea(g[t>>2])));v=b+120|0;q=ea(u+ea(n*ea(g[v>>2])));w=b+128|0;u=ea(l*ea(g[w>>2]));x=b+132|0;l=ea(u+ea(m*ea(g[x>>2])));y=b+136|0;m=ea(l+ea(n*ea(g[y>>2])));g[k>>2]=o;g[k+4>>2]=q;g[k+8>>2]=m;g[k+12>>2]=ea(0.0);if(!(c[b+196>>2]|0)){z=b+200|0;A=c[z>>2]|0;B=b+204|0;if((d[B>>0]|0)>1){n=ea(g[A+4>>2]);l=ea(q*n);n=ea(o*ea(g[A>>2]));C=A;u=ea(ea(l+n)+ea(m*ea(g[A+8>>2])));D=1;E=0;while(1){F=c[z>>2]|0;n=ea(g[F+(D*12|0)>>2]);l=ea(g[F+(D*12|0)+4>>2]);G=ea(ea(ea(n*o)+ea(l*q))+ea(ea(g[F+(D*12|0)+8>>2])*m));H=G>u;I=H?D:E;J=D+1|0;if(J>>>0<(d[B>>0]|0)>>>0){C=F;u=H?G:u;D=J;E=I}else{K=I;L=F;break}}}else{K=0;L=A}}else{A=DFb(b,k)|0;K=A;L=c[b+200>>2]|0}c[h>>2]=K;u=ea(g[L+(K*12|0)>>2]);m=ea(g[L+(K*12|0)+4>>2]);q=ea(g[L+(K*12|0)+8>>2]);o=ea(u*ea(g[e>>2]));G=ea(o+ea(m*ea(g[s>>2])));o=ea(G+ea(q*ea(g[w>>2])));G=ea(u*ea(g[p>>2]));l=ea(G+ea(m*ea(g[t>>2])));G=ea(l+ea(q*ea(g[x>>2])));l=ea(u*ea(g[r>>2]));u=ea(l+ea(m*ea(g[v>>2])));m=ea(u+ea(q*ea(g[y>>2])));g[a>>2]=o;g[a+4>>2]=G;g[a+8>>2]=m;g[a+12>>2]=ea(0.0);c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];i=j;return}function BFb(a,b,f,h){a=a|0;b=b|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;j=i;i=i+16|0;k=j;l=c[b+192>>2]|0;m=c[l+40>>2]|0;n=m+((d[l+39>>0]|0)*20|0)|0;o=((e[l+36>>1]|0)<<1)+((d[l+38>>0]|0)*12|0)|0;l=c[b+200>>2]|0;p=ea(g[l+(f*12|0)>>2]);q=ea(g[l+(f*12|0)+4>>2]);r=ea(g[l+(f*12|0)+8>>2]);s=ea(p*ea(g[b+96>>2]));t=ea(s+ea(q*ea(g[b+112>>2])));s=ea(t+ea(r*ea(g[b+128>>2])));t=ea(p*ea(g[b+100>>2]));u=ea(t+ea(q*ea(g[b+116>>2])));t=ea(u+ea(r*ea(g[b+132>>2])));u=ea(p*ea(g[b+104>>2]));p=ea(u+ea(q*ea(g[b+120>>2])));q=ea(p+ea(r*ea(g[b+136>>2])));l=f*3|0;f=d[n+(o+l)>>0]|0;v=d[n+(l+1+o)>>0]|0;w=d[n+(l+2+o)>>0]|0;r=ea(g[m+(f*20|0)>>2]);p=ea(g[m+(f*20|0)+4>>2]);u=ea(g[m+(f*20|0)+8>>2]);x=ea(g[b+144>>2]);y=ea(r*x);z=ea(g[b+148>>2]);A=ea(y+ea(p*z));y=ea(g[b+152>>2]);B=ea(A+ea(u*y));A=ea(g[b+160>>2]);C=ea(r*A);D=ea(g[b+164>>2]);E=ea(C+ea(p*D));C=ea(g[b+168>>2]);F=ea(E+ea(u*C));E=ea(g[b+176>>2]);G=ea(r*E);r=ea(g[b+180>>2]);H=ea(G+ea(p*r));p=ea(g[b+184>>2]);G=ea(H+ea(u*p));u=ea(ea(1.0)/ea(T(ea(ea(ea(B*B)+ea(F*F))+ea(G*G)))));H=ea(B*u);B=ea(F*u);F=ea(G*u);u=ea(g[m+(v*20|0)>>2]);G=ea(g[m+(v*20|0)+4>>2]);I=ea(g[m+(v*20|0)+8>>2]);J=ea(ea(ea(x*u)+ea(z*G))+ea(y*I));K=ea(ea(ea(A*u)+ea(D*G))+ea(C*I));L=ea(ea(ea(E*u)+ea(r*G))+ea(p*I));I=ea(ea(1.0)/ea(T(ea(ea(L*L)+ea(ea(J*J)+ea(K*K))))));G=ea(J*I);J=ea(K*I);K=ea(L*I);I=ea(g[m+(w*20|0)>>2]);L=ea(g[m+(w*20|0)+4>>2]);u=ea(g[m+(w*20|0)+8>>2]);M=ea(ea(ea(x*I)+ea(z*L))+ea(y*u));y=ea(ea(ea(A*I)+ea(D*L))+ea(C*u));C=ea(ea(ea(E*I)+ea(r*L))+ea(p*u));u=ea(ea(1.0)/ea(T(ea(ea(C*C)+ea(ea(M*M)+ea(y*y))))));p=ea(M*u);M=ea(y*u);y=ea(C*u);u=ea(g[h>>2]);C=ea(u-ea(ea(q*F)+ea(ea(s*H)+ea(t*B))));L=ea(u-ea(ea(q*K)+ea(ea(s*G)+ea(t*J))));r=ea(u-ea(ea(q*y)+ea(ea(s*p)+ea(t*M))));I=ea(ea(J*y)-ea(K*M));E=ea(ea(K*p)-ea(G*y));D=ea(ea(G*M)-ea(J*p));A=ea(ea(p*L)-ea(G*r));G=ea(ea(M*L)-ea(J*r));J=ea(ea(y*L)-ea(K*r));r=ea(ea(1.0)/ea(ea(F*D)+ea(ea(H*I)+ea(B*E))));K=ea(r*ea(ea(ea(B*J)-ea(F*G))-ea(C*I)));I=ea(r*ea(ea(ea(F*A)-ea(H*J))-ea(C*E)));E=ea(r*ea(ea(ea(H*G)-ea(B*A))-ea(C*D)));g[a>>2]=K;g[a+4>>2]=I;g[a+8>>2]=E;g[a+12>>2]=ea(0.0);D=ea(s-K);K=ea(t-I);I=ea(q-E);g[b+48>>2]=ea(ea(T(ea(ea(ea(D*D)+ea(K*K))+ea(I*I))))-u);a=b+52|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];i=j;return}function CFb(a,b,e,f,h){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0;j=i;i=i+16|0;k=j;l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=ea(g[e+8>>2]);o=ea(l*ea(g[b+96>>2]));p=ea(o+ea(m*ea(g[b+100>>2])));o=ea(p+ea(n*ea(g[b+104>>2])));p=ea(l*ea(g[b+112>>2]));q=ea(p+ea(m*ea(g[b+116>>2])));p=ea(q+ea(n*ea(g[b+120>>2])));q=ea(l*ea(g[b+128>>2]));l=ea(q+ea(m*ea(g[b+132>>2])));m=ea(l+ea(n*ea(g[b+136>>2])));g[k>>2]=o;g[k+4>>2]=p;g[k+8>>2]=m;g[k+12>>2]=ea(0.0);if(!(c[b+196>>2]|0)){e=b+200|0;r=c[e>>2]|0;s=b+204|0;if((d[s>>0]|0)>1){n=ea(g[r+4>>2]);l=ea(p*n);n=ea(o*ea(g[r>>2]));t=r;q=ea(ea(l+n)+ea(m*ea(g[r+8>>2])));r=1;u=0;while(1){v=c[e>>2]|0;n=ea(g[v+(r*12|0)>>2]);l=ea(g[v+(r*12|0)+4>>2]);w=ea(ea(ea(n*o)+ea(l*p))+ea(ea(g[v+(r*12|0)+8>>2])*m));x=w>q;y=x?r:u;z=r+1|0;if(z>>>0<(d[s>>0]|0)>>>0){t=v;q=x?w:q;r=z;u=y}else{A=y;break}}}else A=0}else A=DFb(b,k)|0;c[h>>2]=A;BFb(a,b,A,b+16|0);c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];i=j;return}function DFb(a,f){a=a|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=0,C=Im,D=Im,E=0;h=i;i=i+64|0;j=h+52|0;k=h+48|0;l=h+16|0;m=h;n=a+196|0;o=c[n>>2]|0;p=c[o+16>>2]|0;q=c[o+20>>2]|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0;r=ea(g[f>>2]);s=f+4|0;t=ea(g[s>>2]);u=f+8|0;v=ea(g[u>>2]);g[m>>2]=r;g[m+4>>2]=t;g[m+8>>2]=v;w=e[o>>1]|0;o=COa(m,j,k)|0;v=ea(ea((w+-1|0)>>>0)*ea(.5));t=ea(v*ea(ea(g[j>>2])+ea(1.0)));j=(da((~~ea(t+ea(.5))>>>0)+(da(o,w)|0)|0,w)|0)+(~~ea(ea(v*ea(ea(g[k>>2])+ea(1.0)))+ea(.5))>>>0)|0;k=d[(c[(c[n>>2]|0)+4>>2]|0)+j>>0]|0;j=c[a+200>>2]|0;v=ea(g[j+(k*12|0)>>2]);t=ea(g[j+(k*12|0)+4>>2]);r=ea(g[j+(k*12|0)+8>>2]);x=ea(g[f>>2]);y=ea(g[s>>2]);z=ea(g[u>>2]);A=ea(ea(ea(v*x)+ea(t*y))+ea(r*z));u=k;while(1){k=b[p+(u<<2)>>1]|0;s=e[p+(u<<2)+2>>1]|0;if(!(k<<16>>16)){B=9;break}f=k&65535;r=A;k=0;a=u;while(1){n=d[q+(k+s)>>0]|0;t=ea(g[j+(n*12|0)>>2]);v=ea(g[j+(n*12|0)+4>>2]);C=ea(ea(ea(t*x)+ea(v*y))+ea(ea(g[j+(n*12|0)+8>>2])*z));if(C>r?(w=1<<(n&31),o=l+(n>>>5<<2)|0,m=c[o>>2]|0,(m&w|0)==0):0){c[o>>2]=m|w;D=C;E=n}else{D=r;E=a}k=k+1|0;if((k|0)==(f|0))break;else{r=D;a=E}}if((E|0)==(u|0)){B=9;break}else{A=D;u=E}}if((B|0)==9){i=h;return u|0}return 0}function EFb(a,b,f,h){a=a|0;b=b|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;j=i;i=i+16|0;k=j;l=c[b+192>>2]|0;m=c[l+40>>2]|0;n=m+((d[l+39>>0]|0)*20|0)|0;o=((e[l+36>>1]|0)<<1)+((d[l+38>>0]|0)*12|0)|0;l=c[b+200>>2]|0;p=ea(g[l+(f*12|0)>>2]);q=ea(g[l+(f*12|0)+4>>2]);r=ea(g[l+(f*12|0)+8>>2]);l=f*3|0;f=d[n+(o+l)>>0]|0;s=d[n+(l+1+o)>>0]|0;t=d[n+(l+2+o)>>0]|0;u=ea(g[m+(f*20|0)>>2]);v=ea(g[m+(f*20|0)+4>>2]);w=ea(g[m+(f*20|0)+8>>2]);x=ea(ea(1.0)/ea(T(ea(ea(ea(u*u)+ea(v*v))+ea(w*w)))));y=ea(u*x);u=ea(v*x);v=ea(w*x);x=ea(g[m+(s*20|0)>>2]);w=ea(g[m+(s*20|0)+4>>2]);z=ea(g[m+(s*20|0)+8>>2]);A=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(w*w))+ea(z*z)))));B=ea(x*A);x=ea(w*A);w=ea(z*A);A=ea(g[m+(t*20|0)>>2]);z=ea(g[m+(t*20|0)+4>>2]);C=ea(g[m+(t*20|0)+8>>2]);D=ea(ea(1.0)/ea(T(ea(ea(ea(A*A)+ea(z*z))+ea(C*C)))));E=ea(A*D);A=ea(z*D);z=ea(C*D);D=ea(g[h>>2]);C=ea(D-ea(ea(r*v)+ea(ea(p*y)+ea(q*u))));F=ea(D-ea(ea(r*w)+ea(ea(p*B)+ea(q*x))));G=ea(D-ea(ea(r*z)+ea(ea(p*E)+ea(q*A))));D=ea(ea(x*z)-ea(w*A));H=ea(ea(w*E)-ea(B*z));I=ea(ea(B*A)-ea(x*E));J=ea(ea(E*F)-ea(B*G));B=ea(ea(A*F)-ea(x*G));x=ea(ea(z*F)-ea(w*G));G=ea(ea(1.0)/ea(ea(v*I)+ea(ea(y*D)+ea(u*H))));w=ea(G*ea(ea(ea(u*x)-ea(v*B))-ea(C*D)));D=ea(G*ea(ea(ea(v*J)-ea(y*x))-ea(C*H)));H=ea(G*ea(ea(ea(y*B)-ea(u*J))-ea(C*I)));g[a>>2]=w;g[a+4>>2]=D;g[a+8>>2]=H;g[a+12>>2]=ea(0.0);I=ea(p-w);w=ea(q-D);D=ea(r-H);g[b+48>>2]=ea(T(ea(ea(ea(I*I)+ea(w*w))+ea(D*D))));a=b+52|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];i=j;return}function FFb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0;f=i;i=i+128|0;h=f+16|0;j=f+64|0;k=f+32|0;l=f+80|0;m=f+112|0;n=f;o=f+48|0;p=f+96|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[n>>2]=1;c[n+4>>2]=1;c[n+8>>2]=1;c[n+12>>2]=1;c[o>>2]=2;c[o+4>>2]=2;c[o+8>>2]=2;c[o+12>>2]=2;q=ea(g[b+96>>2]);r=ea(g[b+100>>2]);s=ea(g[b+104>>2]);t=ea(g[b+108>>2]);u=ea(g[b+112>>2]);v=ea(g[b+116>>2]);w=ea(g[b+120>>2]);x=ea(g[b+124>>2]);y=ea(g[b+128>>2]);z=ea(g[b+132>>2]);A=ea(g[b+136>>2]);B=ea(g[b+140>>2]);C=ea(g[d>>2]);D=ea(g[d+4>>2]);E=ea(g[d+8>>2]);F=ea(ea(ea(q*C)+ea(r*D))+ea(s*E));G=ea(ea(ea(u*C)+ea(v*D))+ea(w*E));H=ea(ea(ea(y*C)+ea(z*D))+ea(A*E));d=F>H;if(F>G){I=d^1;J=d?l:k}else{I=1;J=k}d=G>H;b=d?n:o;o=c[b+4>>2]|0;n=c[b+8>>2]|0;K=c[b+12>>2]|0;c[p>>2]=c[b>>2];c[p+4>>2]=o;c[p+8>>2]=n;c[p+12>>2]=K;c[e>>2]=c[(I?p:m)>>2];g[j>>2]=u;g[j+4>>2]=v;g[j+8>>2]=w;g[j+12>>2]=x;g[h>>2]=y;g[h+4>>2]=z;g[h+8>>2]=A;g[h+12>>2]=B;m=d?j:h;B=ea(g[m>>2]);A=ea(g[m+4>>2]);z=ea(g[m+8>>2]);g[l>>2]=q;g[l+4>>2]=r;g[l+8>>2]=s;g[l+12>>2]=t;g[k>>2]=B;g[k+4>>2]=A;g[k+8>>2]=z;g[k+12>>2]=ea(0.0);z=ea(g[(I?k:l)>>2]);A=ea(g[J+4>>2]);B=ea(g[J+8>>2]);g[a>>2]=z;g[a+4>>2]=A;g[a+8>>2]=B;g[a+12>>2]=ea(0.0);i=f;return}function GFb(a,b,e,f,h,j){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=Im,M=Im;k=i;i=i+32|0;l=k+16|0;m=k;n=ea(g[e>>2]);o=ea(g[e+4>>2]);p=ea(g[e+8>>2]);q=ea(n*ea(g[f>>2]));e=f+4|0;r=ea(q+ea(o*ea(g[e>>2])));s=f+8|0;q=ea(r+ea(p*ea(g[s>>2])));t=f+16|0;r=ea(n*ea(g[t>>2]));u=f+20|0;v=ea(r+ea(o*ea(g[u>>2])));w=f+24|0;r=ea(v+ea(p*ea(g[w>>2])));x=f+32|0;v=ea(n*ea(g[x>>2]));y=f+36|0;n=ea(v+ea(o*ea(g[y>>2])));z=f+40|0;o=ea(n+ea(p*ea(g[z>>2])));g[l>>2]=q;g[l+4>>2]=r;g[l+8>>2]=o;g[l+12>>2]=ea(0.0);if(!(c[b+196>>2]|0)){A=b+200|0;B=c[A>>2]|0;C=b+204|0;if((d[C>>0]|0)>1){p=ea(g[B+4>>2]);n=ea(r*p);p=ea(q*ea(g[B>>2]));D=B;v=ea(ea(n+p)+ea(o*ea(g[B+8>>2])));B=1;E=0;while(1){F=c[A>>2]|0;p=ea(g[F+(B*12|0)>>2]);n=ea(g[F+(B*12|0)+4>>2]);G=ea(ea(ea(p*q)+ea(n*r))+ea(ea(g[F+(B*12|0)+8>>2])*o));H=G>v;I=H?B:E;J=B+1|0;if(J>>>0<(d[C>>0]|0)>>>0){D=F;v=H?G:v;B=J;E=I}else{K=I;break}}}else K=0}else K=DFb(b,l)|0;c[j>>2]=K;EFb(m,b,K,b+16|0);c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];v=ea(g[f+48>>2]);o=ea(g[f+52>>2]);r=ea(g[f+56>>2]);q=ea(g[m>>2]);G=ea(g[m+4>>2]);n=ea(g[m+8>>2]);p=ea(q*ea(g[f>>2]));L=ea(p+ea(G*ea(g[t>>2])));p=ea(L+ea(n*ea(g[x>>2])));L=ea(q*ea(g[e>>2]));M=ea(L+ea(G*ea(g[u>>2])));L=ea(M+ea(n*ea(g[y>>2])));M=ea(q*ea(g[s>>2]));q=ea(M+ea(G*ea(g[w>>2])));G=ea(o+L);L=ea(r+ea(q+ea(n*ea(g[z>>2]))));g[a>>2]=ea(v+p);g[a+4>>2]=G;g[a+8>>2]=L;g[a+12>>2]=ea(0.0);c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];i=k;return}function HFb(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=Im,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=0,H=0,I=0,J=0;f=i;i=i+16|0;h=f;j=ea(g[e>>2]);k=ea(g[e+4>>2]);l=ea(g[e+8>>2]);e=b+96|0;m=ea(j*ea(g[e>>2]));n=b+100|0;o=ea(m+ea(k*ea(g[n>>2])));p=b+104|0;m=ea(o+ea(l*ea(g[p>>2])));q=b+112|0;o=ea(j*ea(g[q>>2]));r=b+116|0;s=ea(o+ea(k*ea(g[r>>2])));t=b+120|0;o=ea(s+ea(l*ea(g[t>>2])));u=b+128|0;s=ea(j*ea(g[u>>2]));v=b+132|0;j=ea(s+ea(k*ea(g[v>>2])));w=b+136|0;k=ea(j+ea(l*ea(g[w>>2])));g[h>>2]=m;g[h+4>>2]=o;g[h+8>>2]=k;g[h+12>>2]=ea(0.0);if(!(c[b+196>>2]|0)){x=b+200|0;y=c[x>>2]|0;z=b+204|0;if((d[z>>0]|0)>1){l=ea(g[y+4>>2]);j=ea(o*l);l=ea(m*ea(g[y>>2]));A=y;s=ea(ea(j+l)+ea(k*ea(g[y+8>>2])));B=1;C=0;while(1){D=c[x>>2]|0;l=ea(g[D+(B*12|0)>>2]);j=ea(g[D+(B*12|0)+4>>2]);E=ea(ea(ea(l*m)+ea(j*o))+ea(ea(g[D+(B*12|0)+8>>2])*k));F=E>s;G=F?B:C;H=B+1|0;if(H>>>0<(d[z>>0]|0)>>>0){A=D;s=F?E:s;B=H;C=G}else{I=G;J=D;break}}}else{I=0;J=y}}else{y=DFb(b,h)|0;I=y;J=c[b+200>>2]|0}s=ea(g[J+(I*12|0)>>2]);k=ea(g[J+(I*12|0)+4>>2]);o=ea(g[J+(I*12|0)+8>>2]);m=ea(s*ea(g[e>>2]));E=ea(m+ea(k*ea(g[q>>2])));m=ea(E+ea(o*ea(g[u>>2])));E=ea(s*ea(g[n>>2]));j=ea(E+ea(k*ea(g[r>>2])));E=ea(j+ea(o*ea(g[v>>2])));j=ea(s*ea(g[p>>2]));s=ea(j+ea(k*ea(g[t>>2])));k=ea(s+ea(o*ea(g[w>>2])));g[a>>2]=m;g[a+4>>2]=E;g[a+8>>2]=k;g[a+12>>2]=ea(0.0);i=f;return}function IFb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0;e=i;i=i+64|0;f=e+48|0;h=e+32|0;j=e+16|0;k=e;l=ea(g[c>>2]);m=ea(g[c+4>>2]);n=ea(g[c+8>>2]);o=ea(g[d>>2]);p=ea(l*o);q=ea(g[d+4>>2]);r=ea(p+ea(m*q));p=ea(g[d+8>>2]);s=ea(r+ea(n*p));r=ea(g[d+16>>2]);t=ea(l*r);u=ea(g[d+20>>2]);v=ea(t+ea(m*u));t=ea(g[d+24>>2]);w=ea(v+ea(n*t));v=ea(g[d+32>>2]);x=ea(l*v);l=ea(g[d+36>>2]);y=ea(x+ea(m*l));m=ea(g[d+40>>2]);x=ea(y+ea(n*m));n=ea(g[b+96>>2]);y=ea(g[b+100>>2]);z=ea(g[b+104>>2]);A=ea(g[b+108>>2]);B=ea(g[b+112>>2]);C=ea(g[b+116>>2]);D=ea(g[b+120>>2]);E=ea(g[b+124>>2]);F=ea(g[b+128>>2]);G=ea(g[b+132>>2]);H=ea(g[b+136>>2]);I=ea(g[b+140>>2]);J=ea(ea(ea(s*n)+ea(w*y))+ea(x*z));K=ea(ea(ea(s*B)+ea(w*C))+ea(x*D));L=ea(ea(ea(s*F)+ea(w*G))+ea(x*H));if(J>K)M=J>L?k:j;else M=j;g[h>>2]=B;g[h+4>>2]=C;g[h+8>>2]=D;g[h+12>>2]=E;g[f>>2]=F;g[f+4>>2]=G;g[f+8>>2]=H;g[f+12>>2]=I;b=K>L?h:f;L=ea(g[b>>2]);K=ea(g[b+4>>2]);I=ea(g[b+8>>2]);g[k>>2]=n;g[k+4>>2]=y;g[k+8>>2]=z;g[k+12>>2]=A;g[j>>2]=L;g[j+4>>2]=K;g[j+8>>2]=I;g[j+12>>2]=ea(0.0);I=ea(g[M>>2]);K=ea(g[M+4>>2]);L=ea(g[M+8>>2]);A=ea(g[d+48>>2]);z=ea(g[d+52>>2]);y=ea(z+ea(ea(ea(I*q)+ea(K*u))+ea(L*l)));l=ea(ea(g[d+56>>2])+ea(ea(ea(I*p)+ea(K*t))+ea(L*m)));g[a>>2]=ea(A+ea(ea(ea(I*o)+ea(K*r))+ea(L*v)));g[a+4>>2]=y;g[a+8>>2]=l;g[a+12>>2]=ea(0.0);i=e;return}function JFb(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=0,N=Im,O=Im,P=0,Q=Im,R=0,S=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=0,fa=Im,ga=0,ha=Im,ia=0,ja=Im,ka=0,la=Im,ma=0,na=Im,oa=0,pa=Im,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=0,_b=0,$b=0,ac=0,bc=Im,cc=Im,dc=0,ec=0,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=0,Lc=Im,Mc=Im,Nc=Im,Oc=0;d=i;i=i+512|0;m=d+32|0;n=d+80|0;o=d+96|0;p=d+176|0;q=d+48|0;r=d+64|0;s=d+240|0;t=d+320|0;u=d+400|0;v=d+432|0;w=d+192|0;x=d+208|0;y=d+448|0;z=d+464|0;A=d+488|0;B=d+500|0;C=d+256|0;D=d+112|0;E=d+336|0;F=d+416|0;G=d+224|0;H=d+16|0;I=d+476|0;J=d;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];K=ea(g[f>>2]);z=f+4|0;L=ea(g[z>>2]);M=f+8|0;N=ea(g[M>>2]);O=ea(g[e>>2]);P=e+4|0;Q=ea(g[P>>2]);R=e+8|0;S=ea(ea(K*ea(0.0))+O);O=ea(ea(L*ea(0.0))+Q);Q=ea(ea(N*ea(0.0))+ea(g[R>>2]));c[B>>2]=1;N=ea(g[a>>2]);L=ea(g[a+4>>2]);K=ea(g[a+8>>2]);U=ea(g[b>>2]);V=ea(g[b+4>>2]);W=ea(N-U);U=ea(L-V);V=ea(K-ea(g[b+8>>2]));X=ea(ea(ea(W*W)+ea(U*U))+ea(V*V))>ea(1.1920929e-07);g[n>>2]=W;g[n+4>>2]=U;g[n+8>>2]=V;g[n+12>>2]=ea(0.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);Y=X?n:m;V=ea(g[Y>>2]);U=ea(g[Y+4>>2]);W=ea(g[Y+8>>2]);K=ea(ea(1.0)/ea(T(ea(ea(ea(V*V)+ea(U*U))+ea(W*W)))));L=ea(V*K);V=ea(U*K);U=ea(W*K);K=ea(-L);W=ea(-V);N=ea(-U);Y=a+96|0;Z=ea(g[Y>>2]);m=a+100|0;_=ea(g[m>>2]);n=a+104|0;$=ea(g[n>>2]);X=a+108|0;aa=ea(g[X>>2]);ba=a+112|0;ca=ea(g[ba>>2]);da=a+116|0;fa=ea(g[da>>2]);ga=a+120|0;ha=ea(g[ga>>2]);ia=a+124|0;ja=ea(g[ia>>2]);ka=a+128|0;la=ea(g[ka>>2]);ma=a+132|0;na=ea(g[ma>>2]);oa=a+136|0;pa=ea(g[oa>>2]);qa=a+140|0;ra=ea(g[qa>>2]);sa=ea(ea(ea(Z*K)+ea(_*W))+ea($*N));ta=ea(ea(ea(ca*K)+ea(fa*W))+ea(ha*N));ua=ea(ea(ea(la*K)+ea(na*W))+ea(pa*N));if(sa>ta)va=sa>ua?r:q;else va=q;g[p>>2]=ca;g[p+4>>2]=fa;g[p+8>>2]=ha;g[p+12>>2]=ja;g[o>>2]=la;g[o+4>>2]=na;g[o+8>>2]=pa;g[o+12>>2]=ra;wa=ta>ua?p:o;ua=ea(g[wa>>2]);ta=ea(g[wa+4>>2]);ra=ea(g[wa+8>>2]);g[r>>2]=Z;g[r+4>>2]=_;g[r+8>>2]=$;g[r+12>>2]=aa;g[q>>2]=ua;g[q+4>>2]=ta;g[q+8>>2]=ra;g[q+12>>2]=ea(0.0);ra=ea(g[va>>2]);ta=ea(g[va+4>>2]);ua=ea(g[va+8>>2]);va=L>ea(0.0);wa=V>ea(0.0);xa=U>ea(0.0);ya=b+144|0;c[p+0>>2]=c[ya+0>>2];c[p+4>>2]=c[ya+4>>2];c[p+8>>2]=c[ya+8>>2];c[p+12>>2]=c[ya+12>>2];za=b+144|0;U=ea(g[za>>2]);Aa=b+148|0;V=ea(g[Aa>>2]);Ba=b+152|0;L=ea(-V);V=ea(-ea(g[Ba>>2]));g[o>>2]=ea(-U);g[o+4>>2]=L;g[o+8>>2]=V;g[o+12>>2]=ea(0.0);V=ea(g[(va?p:o)>>2]);L=ea(g[(wa?p:o)+4>>2]);U=ea(g[(xa?p:o)+8>>2]);aa=ea(ra-V);$=ea(ta-L);_=ea(ua-U);g[C>>2]=aa;xa=C+4|0;g[xa>>2]=$;wa=C+8|0;g[wa>>2]=_;va=C+12|0;g[va>>2]=ea(0.0);Ca=C+16|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];Da=C+32|0;c[Da+0>>2]=c[y+0>>2];c[Da+4>>2]=c[y+4>>2];c[Da+8>>2]=c[y+8>>2];c[Da+12>>2]=c[y+12>>2];Da=C+48|0;c[Da+0>>2]=c[y+0>>2];c[Da+4>>2]=c[y+4>>2];c[Da+8>>2]=c[y+8>>2];c[Da+12>>2]=c[y+12>>2];g[D>>2]=ra;Da=D+4|0;g[Da>>2]=ta;Ea=D+8|0;g[Ea>>2]=ua;g[D+12>>2]=ea(0.0);Fa=D+16|0;c[Fa+0>>2]=c[y+0>>2];c[Fa+4>>2]=c[y+4>>2];c[Fa+8>>2]=c[y+8>>2];c[Fa+12>>2]=c[y+12>>2];Fa=D+32|0;c[Fa+0>>2]=c[y+0>>2];c[Fa+4>>2]=c[y+4>>2];c[Fa+8>>2]=c[y+8>>2];c[Fa+12>>2]=c[y+12>>2];Fa=D+48|0;c[Fa+0>>2]=c[y+0>>2];c[Fa+4>>2]=c[y+4>>2];c[Fa+8>>2]=c[y+8>>2];c[Fa+12>>2]=c[y+12>>2];g[E>>2]=V;Fa=E+4|0;g[Fa>>2]=L;Ga=E+8|0;g[Ga>>2]=U;Ha=E+12|0;g[Ha>>2]=ea(0.0);Ia=E+16|0;c[Ia+0>>2]=c[y+0>>2];c[Ia+4>>2]=c[y+4>>2];c[Ia+8>>2]=c[y+8>>2];c[Ia+12>>2]=c[y+12>>2];Ia=E+32|0;c[Ia+0>>2]=c[y+0>>2];c[Ia+4>>2]=c[y+4>>2];c[Ia+8>>2]=c[y+8>>2];c[Ia+12>>2]=c[y+12>>2];Ia=E+48|0;c[Ia+0>>2]=c[y+0>>2];c[Ia+4>>2]=c[y+4>>2];c[Ia+8>>2]=c[y+8>>2];c[Ia+12>>2]=c[y+12>>2];Z=ea(-aa);pa=ea(-$);na=ea(-_);c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];la=ea(g[a+32>>2]);ja=ea(g[b+32>>2]);ha=ea((la>ja?ja:la)*ea(.100000001));la=ea(ha*ha);ha=ea(ea(l*l)+la);g[G>>2]=ra;b=G+4|0;g[b>>2]=ta;y=G+8|0;g[y>>2]=ua;Ia=G+12|0;g[Ia>>2]=ea(0.0);g[H>>2]=V;Ja=H+4|0;g[Ja>>2]=L;Ka=H+8|0;g[Ka>>2]=U;La=H+12|0;g[La>>2]=ea(0.0);U=ea(ea(ea(aa*aa)+ea($*$))+ea(_*_));a:do if(U>la){Ma=p+4|0;Na=p+8|0;Oa=p+12|0;Pa=o+4|0;Qa=o+8|0;Ra=o+12|0;Sa=r+4|0;Ta=r+8|0;Ua=r+12|0;Va=q+4|0;Wa=q+8|0;Xa=q+12|0;Ya=o+4|0;Za=o+8|0;_a=o+12|0;$a=F+4|0;ab=F+8|0;bb=F+12|0;cb=E+16|0;db=E+20|0;eb=E+24|0;fb=E+28|0;gb=E+32|0;hb=E+36|0;ib=E+40|0;jb=E+44|0;kb=D+16|0;lb=D+20|0;mb=D+24|0;nb=C+16|0;ob=C+20|0;pb=C+24|0;qb=C+28|0;rb=D+32|0;sb=D+36|0;tb=D+40|0;ub=C+32|0;vb=C+36|0;wb=C+40|0;xb=C+44|0;yb=o+4|0;zb=o+8|0;Ab=o+12|0;Bb=J+4|0;Cb=J+8|0;Db=J+12|0;_=Z;$=pa;aa=na;L=S;V=O;ja=Q;fa=ea(0.0);ca=ea(0.0);sa=ua;N=ta;W=ra;K=Z;Eb=pa;Fb=na;Gb=U;while(1){Hb=ea(ea(1.0)/ea(T(ea(ea(aa*aa)+ea(ea($*$)+ea(_*_))))));Ib=ea(_*Hb);Jb=ea($*Hb);Kb=ea(aa*Hb);Hb=ea(g[Y>>2]);Lb=ea(g[m>>2]);Mb=ea(g[n>>2]);Nb=ea(g[X>>2]);Ob=ea(g[ba>>2]);Pb=ea(g[da>>2]);Qb=ea(g[ga>>2]);Rb=ea(g[ia>>2]);Sb=ea(g[ka>>2]);Tb=ea(g[ma>>2]);Ub=ea(g[oa>>2]);Vb=ea(g[qa>>2]);Wb=ea(ea(ea(Ib*Hb)+ea(Jb*Lb))+ea(Kb*Mb));Xb=ea(ea(ea(Ib*Ob)+ea(Jb*Pb))+ea(Kb*Qb));Yb=ea(ea(ea(Ib*Sb)+ea(Jb*Tb))+ea(Kb*Ub));if(Wb>Xb)Zb=Wb>Yb?r:q;else Zb=q;g[p>>2]=Ob;g[Ma>>2]=Pb;g[Na>>2]=Qb;g[Oa>>2]=Rb;g[o>>2]=Sb;g[Pa>>2]=Tb;g[Qa>>2]=Ub;g[Ra>>2]=Vb;_b=Xb>Yb?p:o;Yb=ea(g[_b>>2]);Xb=ea(g[_b+4>>2]);Vb=ea(g[_b+8>>2]);g[r>>2]=Hb;g[Sa>>2]=Lb;g[Ta>>2]=Mb;g[Ua>>2]=Nb;g[q>>2]=Yb;g[Va>>2]=Xb;g[Wa>>2]=Vb;g[Xa>>2]=ea(0.0);Vb=ea(g[Zb>>2]);Xb=ea(g[Zb+4>>2]);Yb=ea(g[Zb+8>>2]);_b=Ib<ea(-0.0);$b=Jb<ea(-0.0);ac=Kb<ea(-0.0);c[p+0>>2]=c[ya+0>>2];c[p+4>>2]=c[ya+4>>2];c[p+8>>2]=c[ya+8>>2];c[p+12>>2]=c[ya+12>>2];Nb=ea(g[za>>2]);Mb=ea(g[Aa>>2]);Lb=ea(-Nb);Nb=ea(-Mb);Mb=ea(-ea(g[Ba>>2]));g[o>>2]=Lb;g[Ya>>2]=Nb;g[Za>>2]=Mb;g[_a>>2]=ea(0.0);Hb=ea(g[(_b?p:o)>>2]);Ub=ea(g[($b?p:o)+4>>2]);Tb=ea(L+Hb);Hb=ea(V+Ub);Ub=ea(ja+ea(g[(ac?p:o)+8>>2]));Sb=ea(Vb-Tb);Rb=ea(Xb-Hb);Qb=ea(Yb-Ub);g[F>>2]=Sb;g[$a>>2]=Rb;g[ab>>2]=Qb;g[bb>>2]=ea(0.0);Pb=ea(ea(ea(ea(-ea(Jb*Rb))-ea(Ib*Sb))-ea(Kb*Qb))-l);Ob=ea(g[f>>2]);Wb=ea(g[z>>2]);bc=ea(g[M>>2]);cc=ea(ea(ea(Ib*Ob)+ea(Jb*Wb))+ea(Kb*bc));if(Pb>ea(0.0)){if(cc>=ea(0.0)){dc=0;ec=26;break}Kb=ea(fa-ea(Pb/cc));c[A+0>>2]=c[I+0>>2];c[A+4>>2]=c[I+4>>2];c[A+8>>2]=c[I+8>>2];if(Kb>fa){if(Kb>ea(1.0)){dc=0;ec=26;break}cc=ea(g[e>>2]);Pb=ea(g[P>>2]);Jb=ea(ea(Kb*Ob)+cc);cc=ea(ea(Kb*Wb)+Pb);Pb=ea(ea(Kb*bc)+ea(g[R>>2]));bc=ea(Jb-L);Wb=ea(cc-V);Ob=ea(Pb-ja);Ib=ea(g[E>>2]);fc=ea(g[Fa>>2]);gc=ea(bc+Ib);Ib=ea(Wb+fc);fc=ea(Ob+ea(g[Ga>>2]));hc=ea(g[cb>>2]);ic=ea(g[db>>2]);jc=ea(bc+hc);hc=ea(Wb+ic);ic=ea(Ob+ea(g[eb>>2]));kc=ea(g[gb>>2]);lc=ea(g[hb>>2]);mc=ea(bc+kc);kc=ea(Wb+lc);lc=ea(Ob+ea(g[ib>>2]));g[E>>2]=gc;g[Fa>>2]=Ib;g[Ga>>2]=fc;g[Ha>>2]=ea(0.0);g[cb>>2]=jc;g[db>>2]=hc;g[eb>>2]=ic;g[fb>>2]=ea(0.0);g[gb>>2]=mc;g[hb>>2]=kc;g[ib>>2]=lc;g[jb>>2]=ea(0.0);Ob=ea(g[D>>2]);Wb=ea(g[Da>>2]);bc=ea(Wb-Ib);Ib=ea(ea(g[Ea>>2])-fc);g[C>>2]=ea(Ob-gc);g[xa>>2]=bc;g[wa>>2]=Ib;g[va>>2]=ea(0.0);Ib=ea(g[kb>>2]);bc=ea(g[lb>>2]);gc=ea(bc-hc);hc=ea(ea(g[mb>>2])-ic);g[nb>>2]=ea(Ib-jc);g[ob>>2]=gc;g[pb>>2]=hc;g[qb>>2]=ea(0.0);hc=ea(g[rb>>2]);gc=ea(g[sb>>2]);jc=ea(gc-kc);kc=ea(ea(g[tb>>2])-lc);g[ub>>2]=ea(hc-mc);g[vb>>2]=jc;g[wb>>2]=kc;g[xb>>2]=ea(0.0);c[p+0>>2]=c[ya+0>>2];c[p+4>>2]=c[ya+4>>2];c[p+8>>2]=c[ya+8>>2];c[p+12>>2]=c[ya+12>>2];g[o>>2]=Lb;g[yb>>2]=Nb;g[zb>>2]=Mb;g[Ab>>2]=ea(0.0);Mb=ea(g[(_b?p:o)>>2]);Nb=ea(g[($b?p:o)+4>>2]);Lb=ea(Jb+Mb);Mb=ea(cc+Nb);Nb=ea(Pb+ea(g[(ac?p:o)+8>>2]));kc=ea(Vb-Lb);jc=ea(Xb-Mb);mc=ea(Yb-Nb);g[F>>2]=kc;g[$a>>2]=jc;g[ab>>2]=mc;g[bb>>2]=ea(0.0);nc=Lb;oc=Mb;pc=Nb;qc=kc;rc=jc;sc=mc;tc=ea(3402823469999999843913219.0e14);uc=Kb;vc=Pb;wc=cc;xc=Jb;yc=aa;zc=$;Ac=_}else{nc=Tb;oc=Hb;pc=Ub;qc=Sb;rc=Rb;sc=Qb;tc=Gb;uc=Kb;vc=ja;wc=V;xc=L;yc=Fb;zc=Eb;Ac=K}}else{nc=Tb;oc=Hb;pc=Ub;qc=Sb;rc=Rb;sc=Qb;tc=Gb;uc=fa;vc=ja;wc=V;xc=L;yc=Fb;zc=Eb;Ac=K}ac=c[B>>2]|0;g[D+(ac<<4)>>2]=Vb;g[D+(ac<<4)+4>>2]=Xb;g[D+(ac<<4)+8>>2]=Yb;g[D+(ac<<4)+12>>2]=ea(0.0);g[E+(ac<<4)>>2]=nc;g[E+(ac<<4)+4>>2]=oc;g[E+(ac<<4)+8>>2]=pc;g[E+(ac<<4)+12>>2]=ea(0.0);c[B>>2]=ac+1;$b=C+(ac<<4)|0;c[$b+0>>2]=c[F+0>>2];c[$b+4>>2]=c[F+4>>2];c[$b+8>>2]=c[F+8>>2];c[$b+12>>2]=c[F+12>>2];do if(!ac){g[G>>2]=Vb;g[b>>2]=Xb;g[y>>2]=Yb;g[Ia>>2]=ea(0.0);g[H>>2]=nc;g[Ja>>2]=oc;g[Ka>>2]=pc;g[La>>2]=ea(0.0);c[J+0>>2]=c[F+0>>2];c[J+4>>2]=c[F+4>>2];c[J+8>>2]=c[F+8>>2];c[J+12>>2]=c[F+12>>2]}else if((ac|0)==2)V6a(J,C,Ca,F,C,D,E,B,G,H);else if((ac|0)==1){Qb=ea(g[C>>2]);Rb=ea(g[xa>>2]);Sb=ea(g[wa>>2]);Ub=ea(qc-Qb);Hb=ea(rc-Rb);Tb=ea(sc-Sb);Kb=ea(ea(ea(Ub*Ub)+ea(Hb*Hb))+ea(Tb*Tb));if(Kb==ea(0.0)){c[B>>2]=1;c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[J+0>>2]=c[C+0>>2];c[J+4>>2]=c[C+4>>2];c[J+8>>2]=c[C+8>>2];c[J+12>>2]=c[C+12>>2];break}else{Jb=ea(ea(ea(-ea(Rb*Hb))-ea(Qb*Ub))-ea(Sb*Tb));Tb=ea(g[D>>2]);Sb=ea(g[Da>>2]);Ub=ea(g[Ea>>2]);Qb=ea(Vb-Tb);Hb=ea(Xb-Sb);Rb=ea(Yb-Ub);cc=ea(g[E>>2]);Pb=ea(g[Fa>>2]);mc=ea(g[Ga>>2]);jc=ea(nc-cc);kc=ea(oc-Pb);Nb=ea(pc-mc);Mb=ea(Jb/Kb);$b=Mb>ea(1.0);Kb=$b?ea(1.0):Mb;$b=Kb>ea(0.0);Mb=$b?Kb:ea(0.0);Kb=ea(Tb+ea(Qb*Mb));Qb=ea(Sb+ea(Hb*Mb));Hb=ea(Ub+ea(Rb*Mb));Rb=ea(cc+ea(jc*Mb));jc=ea(Pb+ea(kc*Mb));kc=ea(mc+ea(Nb*Mb));g[G>>2]=Kb;g[b>>2]=Qb;g[y>>2]=Hb;g[Ia>>2]=ea(0.0);g[H>>2]=Rb;g[Ja>>2]=jc;g[Ka>>2]=kc;g[La>>2]=ea(0.0);Mb=ea(Qb-jc);jc=ea(Hb-kc);g[J>>2]=ea(Kb-Rb);g[Bb>>2]=Mb;g[Cb>>2]=jc;g[Db>>2]=ea(0.0);break}}else if((ac|0)==3)pPa(J,C,D,E,B,G,H);else{c[J+0>>2]=c[F+0>>2];c[J+4>>2]=c[F+4>>2];c[J+8>>2]=c[F+8>>2];c[J+12>>2]=c[F+12>>2]}while(0);Yb=ea(g[J>>2]);Xb=ea(g[Bb>>2]);Vb=ea(g[Cb>>2]);jc=ea(-Yb);Mb=ea(-Xb);Rb=ea(-Vb);Kb=ea(ea(ea(Yb*Yb)+ea(Xb*Xb))+ea(Vb*Vb));ac=tc>Kb;$b=ac<<31>>31;if(!(Kb>ha)){Bc=uc;Cc=ca;Dc=sa;Ec=N;Fc=W;Gc=Rb;Hc=Mb;Ic=jc;Jc=Kb;Kc=$b;Lc=yc;Mc=zc;Nc=Ac;break a}if(!ac){Bc=uc;Cc=ca;Dc=sa;Ec=N;Fc=W;Gc=Rb;Hc=Mb;Ic=jc;Jc=Kb;Kc=$b;Lc=yc;Mc=zc;Nc=Ac;break a}Vb=ea(g[G>>2]);Xb=ea(g[b>>2]);Yb=ea(g[y>>2]);_=jc;$=Mb;aa=Rb;L=xc;V=wc;ja=vc;fa=uc;ca=ea(g[Ia>>2]);sa=Yb;N=Xb;W=Vb;K=Ac;Eb=zc;Fb=yc;Gb=Kb}if((ec|0)==26){i=d;return dc|0}}else{Bc=ea(0.0);Cc=ea(0.0);Dc=ua;Ec=ta;Fc=ra;Gc=na;Hc=pa;Ic=Z;Jc=U;Kc=-1;Lc=na;Mc=pa;Nc=Z}while(0);ec=c[a+64>>2]|0;J=c[a+68>>2]|0;F=c[a+72>>2]|0;if(Jc>la)Oc=(Kc|0)==0?s:t;else Oc=s;g[t>>2]=Ic;g[t+4>>2]=Hc;g[t+8>>2]=Gc;g[t+12>>2]=ea(0.0);g[s>>2]=Nc;g[s+4>>2]=Mc;g[s+8>>2]=Lc;g[s+12>>2]=ea(0.0);Lc=ea(g[Oc>>2]);Mc=ea(g[Oc+4>>2]);Nc=ea(g[Oc+8>>2]);Gc=ea(ea(1.0)/ea(T(ea(ea(ea(Lc*Lc)+ea(Mc*Mc))+ea(Nc*Nc)))));Hc=ea(-ea(Lc*Gc));Lc=ea(-ea(Mc*Gc));Mc=ea(-ea(Nc*Gc));g[j>>2]=Hc;g[j+4>>2]=Lc;g[j+8>>2]=Mc;g[j+12>>2]=ea(0.0);g[h>>2]=Bc;j=h+4|0;c[j+0>>2]=c[A+0>>2];c[j+4>>2]=c[A+4>>2];c[j+8>>2]=c[A+8>>2];c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];g[u>>2]=Fc;g[u+4>>2]=Ec;g[u+8>>2]=Dc;g[u+12>>2]=Cc;A=(Kc|0)==0?u:v;Cc=ea(g[A>>2]);Dc=ea(g[A+4>>2]);Ec=ea(g[A+8>>2]);g[G>>2]=Cc;g[b>>2]=Dc;g[y>>2]=Ec;g[Ia>>2]=ea(0.0);Fc=ea(g[a+16>>2]);Bc=ea(Cc-ea(Fc*Hc));Hc=ea(Dc-ea(Fc*Lc));Lc=ea(Ec-ea(Fc*Mc));c[w+0>>2]=c[G+0>>2];c[w+4>>2]=c[G+4>>2];c[w+8>>2]=c[G+8>>2];c[w+12>>2]=c[G+12>>2];g[x>>2]=Bc;g[x+4>>2]=Hc;g[x+8>>2]=Lc;g[x+12>>2]=ea(0.0);Lc=ea(g[((ec|0)==0?w:x)>>2]);Hc=ea(g[((J|0)==0?w:x)+4>>2]);Bc=ea(g[((F|0)==0?w:x)+8>>2]);g[k>>2]=Lc;g[k+4>>2]=Hc;g[k+8>>2]=Bc;g[k+12>>2]=ea(0.0);dc=1;i=d;return dc|0}function KFb(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=0,ma=Im,na=0,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=Im,fb=Im,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=0,xb=0;q=i;i=i+624|0;r=q+480|0;s=q+176|0;t=q+192|0;u=q+240|0;v=q+416|0;w=q+160|0;x=q+336|0;y=q+524|0;z=q+500|0;A=q+432|0;B=q+464|0;C=q+256|0;D=q+80|0;E=q;F=q+576|0;G=q+536|0;H=q+352|0;I=q+208|0;J=q+384|0;K=q+496|0;L=q+224|0;M=q+448|0;N=q+144|0;O=q+320|0;P=q+64|0;Q=q+400|0;R=q+592|0;S=q+604|0;U=q+368|0;V=q+564|0;W=q+552|0;X=q+512|0;Y=ea(g[f>>2]);Z=ea(g[b+16>>2]);f=e+16|0;_=ea(g[f>>2]);$=ea(g[b+32>>2]);aa=ea(g[e+32>>2]);ba=ea(($>aa?aa:$)*ea(.100000001));c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;$=ea(Z+_);aa=ea(Y+$);c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[v+0>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];c[A+12>>2]=c[v+12>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];ca=ea(ba*ba);ba=ea(aa*aa);c[H+0>>2]=c[v+0>>2];c[H+4>>2]=c[v+4>>2];c[H+8>>2]=c[v+8>>2];c[H+12>>2]=c[v+12>>2];c[I+0>>2]=c[v+0>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];c[I+12>>2]=c[v+12>>2];c[J+0>>2]=c[v+0>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];c[J+12>>2]=c[v+12>>2];c[K>>2]=0;da=a[o>>0]|0;if(!(da<<24>>24)){aa=ea(g[b>>2]);fa=ea(g[b+4>>2]);ga=ea(g[b+8>>2]);ha=ea(g[e>>2]);ia=ea(g[e+4>>2]);ja=ea(aa-ha);ha=ea(fa-ia);ia=ea(ga-ea(g[e+8>>2]));ka=ea(ea(ea(ja*ja)+ea(ha*ha))+ea(ia*ia))>ea(0.0);g[u>>2]=ja;g[u+4>>2]=ha;g[u+8>>2]=ia;g[u+12>>2]=ea(0.0);g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);la=ka?u:t;ia=ea(g[la>>2]);ha=ea(g[la+4>>2]);ma=ea(3402823469999999843913219.0e14);na=1;oa=ea(g[la+8>>2]);pa=ha;qa=ia}else{c[L+0>>2]=c[v+0>>2];c[L+4>>2]=c[v+4>>2];c[L+8>>2]=c[v+8>>2];c[L+12>>2]=c[v+12>>2];c[M+0>>2]=c[v+0>>2];c[M+4>>2]=c[v+4>>2];c[M+8>>2]=c[v+8>>2];c[M+12>>2]=c[v+12>>2];c[N+0>>2]=c[v+0>>2];c[N+4>>2]=c[v+4>>2];c[N+8>>2]=c[v+8>>2];c[N+12>>2]=c[v+12>>2];v=s+4|0;la=s+8|0;t=s+12|0;u=r+4|0;ka=r+8|0;ra=r+12|0;sa=I+4|0;ta=I+8|0;ua=I+12|0;va=H+4|0;wa=H+8|0;xa=J+4|0;ya=J+8|0;za=J+12|0;ia=ea(g[e+144>>2]);ha=ea(g[e+148>>2]);ja=ea(g[e+152>>2]);Aa=0;Ba=0;while(1){Ca=d[m+Ba>>0]|0;c[F+(Ba<<2)>>2]=Ca;Da=d[n+Ba>>0]|0;c[G+(Ba<<2)>>2]=Da;Ea=b+(Ca<<4)+96|0;c[H+0>>2]=c[Ea+0>>2];c[H+4>>2]=c[Ea+4>>2];c[H+8>>2]=c[Ea+8>>2];c[H+12>>2]=c[Ea+12>>2];ga=ea(ia-_);fa=ea(ha-_);aa=ea(ja-_);Ea=c[540320+(Da<<4)>>2]|0;Ca=c[540324+(Da<<4)>>2]|0;Fa=c[540328+(Da<<4)>>2]|0;Ga=ea(-ga);Ha=ea(-fa);Ia=ea(-aa);g[s>>2]=ga;g[v>>2]=fa;g[la>>2]=aa;g[t>>2]=ea(0.0);g[r>>2]=Ga;g[u>>2]=Ha;g[ka>>2]=Ia;g[ra>>2]=ea(0.0);Ia=ea(g[((Ea|0)==0?r:s)>>2]);Ha=ea(g[((Ca|0)==0?r:s)+4>>2]);Ga=ea(g[((Fa|0)==0?r:s)+8>>2]);g[I>>2]=Ia;g[sa>>2]=Ha;g[ta>>2]=Ga;g[ua>>2]=ea(0.0);aa=ea(g[H>>2]);fa=ea(g[va>>2]);ga=ea(fa-Ha);Ha=ea(ea(g[wa>>2])-Ga);g[J>>2]=ea(aa-Ia);g[xa>>2]=ga;g[ya>>2]=Ha;g[za>>2]=ea(0.0);Fa=D+(Aa<<4)|0;c[M+0>>2]=c[H+0>>2];c[M+4>>2]=c[H+4>>2];c[M+8>>2]=c[H+8>>2];c[M+12>>2]=c[H+12>>2];c[Fa+0>>2]=c[H+0>>2];c[Fa+4>>2]=c[H+4>>2];c[Fa+8>>2]=c[H+8>>2];c[Fa+12>>2]=c[H+12>>2];Fa=E+(Aa<<4)|0;c[N+0>>2]=c[I+0>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];c[N+12>>2]=c[I+12>>2];c[Fa+0>>2]=c[I+0>>2];c[Fa+4>>2]=c[I+4>>2];c[Fa+8>>2]=c[I+8>>2];c[Fa+12>>2]=c[I+12>>2];Ja=Aa+1|0;Fa=C+(Aa<<4)|0;c[L+0>>2]=c[J+0>>2];c[L+4>>2]=c[J+4>>2];c[L+8>>2]=c[J+8>>2];c[L+12>>2]=c[J+12>>2];c[Fa+0>>2]=c[J+0>>2];c[Fa+4>>2]=c[J+4>>2];c[Fa+8>>2]=c[J+8>>2];c[Fa+12>>2]=c[J+12>>2];Ba=Ba+1|0;if(Ba>>>0>=(da&255)>>>0)break;else Aa=Ja}c[K>>2]=Ja;do if(!Aa){c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[x+0>>2]=c[N+0>>2];c[x+4>>2]=c[N+4>>2];c[x+8>>2]=c[N+8>>2];c[x+12>>2]=c[N+12>>2];c[O+0>>2]=c[L+0>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2];c[O+12>>2]=c[L+12>>2]}else if((Aa|0)==2)V6a(O,C,C+16|0,L,C,D,E,K,w,x);else if((Aa|0)==3)qPa(O,C,D,E,F,G,L,M,N,K,w,x);else if((Aa|0)==1){ja=ea(g[C>>2]);ha=ea(g[C+4>>2]);ia=ea(g[C+8>>2]);Ha=ea(g[L>>2]);ga=ea(g[L+4>>2]);Ia=ea(Ha-ja);Ha=ea(ga-ha);ga=ea(ea(g[L+8>>2])-ia);aa=ea(ea(ea(Ia*Ia)+ea(Ha*Ha))+ea(ga*ga));if(aa==ea(0.0)){c[K>>2]=1;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[x+0>>2]=c[E+0>>2];c[x+4>>2]=c[E+4>>2];c[x+8>>2]=c[E+8>>2];c[x+12>>2]=c[E+12>>2];c[O+0>>2]=c[C+0>>2];c[O+4>>2]=c[C+4>>2];c[O+8>>2]=c[C+8>>2];c[O+12>>2]=c[C+12>>2];break}else{Ga=ea(ea(ea(-ea(ha*Ha))-ea(ja*Ia))-ea(ia*ga));ga=ea(g[M>>2]);ia=ea(g[M+4>>2]);Ia=ea(g[M+8>>2]);ja=ea(g[D>>2]);Ha=ea(g[D+4>>2]);ha=ea(g[D+8>>2]);fa=ea(ga-ja);ga=ea(ia-Ha);ia=ea(Ia-ha);Ia=ea(g[N>>2]);Ka=ea(g[N+4>>2]);La=ea(g[N+8>>2]);Ma=ea(g[E>>2]);Na=ea(g[E+4>>2]);Oa=ea(g[E+8>>2]);Pa=ea(Ia-Ma);Ia=ea(Ka-Na);Ka=ea(La-Oa);La=ea(Ga/aa);Ja=La>ea(1.0);aa=Ja?ea(1.0):La;Ja=aa>ea(0.0);La=Ja?aa:ea(0.0);aa=ea(ja+ea(fa*La));fa=ea(Ha+ea(ga*La));ga=ea(ha+ea(ia*La));ia=ea(Ma+ea(Pa*La));Pa=ea(Na+ea(Ia*La));Ia=ea(Oa+ea(Ka*La));g[w>>2]=aa;g[w+4>>2]=fa;g[w+8>>2]=ga;g[w+12>>2]=ea(0.0);g[x>>2]=ia;g[x+4>>2]=Pa;g[x+8>>2]=Ia;g[x+12>>2]=ea(0.0);La=ea(fa-Pa);Pa=ea(ga-Ia);g[O>>2]=ea(aa-ia);g[O+4>>2]=La;g[O+8>>2]=Pa;g[O+12>>2]=ea(0.0);break}}else{c[O+0>>2]=c[L+0>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2];c[O+12>>2]=c[L+12>>2]}while(0);Pa=ea(g[O>>2]);La=ea(g[O+4>>2]);ia=ea(g[O+8>>2]);aa=ea(ea(ea(Pa*Pa)+ea(La*La))+ea(ia*ia));c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];ma=aa;na=aa>ca;oa=ia;pa=La;qa=Pa}do if(na){O=Q+4|0;L=Q+8|0;N=Q+12|0;M=e+144|0;Aa=e+148|0;Ja=e+152|0;da=s+4|0;Ba=s+8|0;za=s+12|0;ya=r+4|0;xa=r+8|0;wa=r+12|0;va=I+4|0;ua=I+8|0;ta=I+12|0;sa=H+4|0;ra=H+8|0;ka=J+4|0;u=J+8|0;t=J+12|0;la=b+48|0;v=e+48|0;Fa=U+4|0;Ca=U+8|0;Ea=C+4|0;Da=C+8|0;Qa=D+4|0;Ra=D+8|0;Sa=E+4|0;Ta=E+8|0;Ua=w+4|0;Va=w+8|0;Wa=w+12|0;Xa=x+4|0;Ya=x+8|0;Za=x+12|0;_a=U+12|0;$a=C+16|0;Pa=Y;La=qa;ia=pa;aa=oa;Ia=ma;while(1){c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[B+0>>2]=c[x+0>>2];c[B+4>>2]=c[x+4>>2];c[B+8>>2]=c[x+8>>2];c[B+12>>2]=c[x+12>>2];ga=ea(-ia);fa=ea(-aa);g[Q>>2]=ea(-La);g[O>>2]=ga;g[L>>2]=fa;g[N>>2]=ea(0.0);ab=c[K>>2]|0;bb=D+(ab<<4)|0;FFb(P,b,Q,F+(ab<<2)|0);c[bb+0>>2]=c[P+0>>2];c[bb+4>>2]=c[P+4>>2];c[bb+8>>2]=c[P+8>>2];c[bb+12>>2]=c[P+12>>2];c[H+0>>2]=c[P+0>>2];c[H+4>>2]=c[P+4>>2];c[H+8>>2]=c[P+8>>2];c[H+12>>2]=c[P+12>>2];cb=c[K>>2]|0;fa=ea(g[M>>2]);ga=ea(g[Aa>>2]);Ka=ea(g[Ja>>2]);Oa=ea(g[f>>2]);Na=ea(fa-Oa);fa=ea(ga-Oa);ga=ea(Ka-Oa);bb=La>ea(0.0);ab=ia>ea(0.0);db=aa>ea(0.0);c[G+(cb<<2)>>2]=db<<31>>31<<2&4|bb&1|ab<<31>>31<<1&2;Oa=ea(-Na);Ka=ea(-fa);Ma=ea(-ga);g[s>>2]=Na;g[da>>2]=fa;g[Ba>>2]=ga;g[za>>2]=ea(0.0);g[r>>2]=Oa;g[ya>>2]=Ka;g[xa>>2]=Ma;g[wa>>2]=ea(0.0);Ma=ea(g[(bb?s:r)>>2]);Ka=ea(g[(ab?s:r)+4>>2]);Oa=ea(g[(db?s:r)+8>>2]);g[E+(cb<<4)>>2]=Ma;g[E+(cb<<4)+4>>2]=Ka;g[E+(cb<<4)+8>>2]=Oa;g[E+(cb<<4)+12>>2]=ea(0.0);g[I>>2]=Ma;g[va>>2]=Ka;g[ua>>2]=Oa;g[ta>>2]=ea(0.0);ga=ea(g[H>>2]);fa=ea(g[sa>>2]);Na=ea(g[ra>>2]);ha=ea(ga-Ma);Ha=ea(fa-Ka);ja=ea(Na-Oa);g[J>>2]=ha;g[ka>>2]=Ha;g[u>>2]=ja;g[t>>2]=ea(0.0);c[K>>2]=cb+1;db=C+(cb<<4)|0;c[db+0>>2]=c[J+0>>2];c[db+4>>2]=c[J+4>>2];c[db+8>>2]=c[J+8>>2];c[db+12>>2]=c[J+12>>2];Ga=ea(g[la>>2]);eb=ea(g[v>>2]);fb=Ga>eb?Ga:eb;Pa=Pa>fb?Pa:fb;fb=ea($+Pa);eb=ea(ea(ea(La*ha)+ea(ia*Ha))+ea(aa*ja));db=ea(eb*eb)>ea(Ia*ea(fb*fb));if(eb>ea(0.0)){gb=db;hb=db^1}else{gb=0;hb=1}db=ea(ca*Ia)>=ea(Ia-eb);if((db|gb)&(db|hb^1))break;do if((cb|0)==1){eb=ea(g[C>>2]);fb=ea(g[Ea>>2]);Ga=ea(g[Da>>2]);ib=ea(ha-eb);jb=ea(Ha-fb);kb=ea(ja-Ga);lb=ea(ea(ea(ib*ib)+ea(jb*jb))+ea(kb*kb));if(lb==ea(0.0)){c[K>>2]=1;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[x+0>>2]=c[E+0>>2];c[x+4>>2]=c[E+4>>2];c[x+8>>2]=c[E+8>>2];c[x+12>>2]=c[E+12>>2];c[U+0>>2]=c[C+0>>2];c[U+4>>2]=c[C+4>>2];c[U+8>>2]=c[C+8>>2];c[U+12>>2]=c[C+12>>2];break}else{mb=ea(ea(ea(-ea(fb*jb))-ea(eb*ib))-ea(Ga*kb));kb=ea(g[D>>2]);Ga=ea(g[Qa>>2]);ib=ea(g[Ra>>2]);eb=ea(ga-kb);jb=ea(fa-Ga);fb=ea(Na-ib);nb=ea(g[E>>2]);ob=ea(g[Sa>>2]);pb=ea(g[Ta>>2]);qb=ea(Ma-nb);rb=ea(Ka-ob);sb=ea(Oa-pb);tb=ea(mb/lb);db=tb>ea(1.0);lb=db?ea(1.0):tb;db=lb>ea(0.0);tb=db?lb:ea(0.0);lb=ea(kb+ea(eb*tb));eb=ea(Ga+ea(jb*tb));jb=ea(ib+ea(fb*tb));fb=ea(nb+ea(qb*tb));qb=ea(ob+ea(rb*tb));rb=ea(pb+ea(sb*tb));g[w>>2]=lb;g[Ua>>2]=eb;g[Va>>2]=jb;g[Wa>>2]=ea(0.0);g[x>>2]=fb;g[Xa>>2]=qb;g[Ya>>2]=rb;g[Za>>2]=ea(0.0);tb=ea(eb-qb);qb=ea(jb-rb);g[U>>2]=ea(lb-fb);g[Fa>>2]=tb;g[Ca>>2]=qb;g[_a>>2]=ea(0.0);break}}else if(!cb){c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[x+0>>2]=c[I+0>>2];c[x+4>>2]=c[I+4>>2];c[x+8>>2]=c[I+8>>2];c[x+12>>2]=c[I+12>>2];c[U+0>>2]=c[J+0>>2];c[U+4>>2]=c[J+4>>2];c[U+8>>2]=c[J+8>>2];c[U+12>>2]=c[J+12>>2]}else if((cb|0)==3)qPa(U,C,D,E,F,G,J,H,I,K,w,x);else if((cb|0)==2)V6a(U,C,$a,J,C,D,E,K,w,x);else{c[U+0>>2]=c[J+0>>2];c[U+4>>2]=c[J+4>>2];c[U+8>>2]=c[J+8>>2];c[U+12>>2]=c[J+12>>2]}while(0);Oa=ea(g[U>>2]);Ka=ea(g[Fa>>2]);Ma=ea(g[Ca>>2]);Na=ea(ea(ea(Oa*Oa)+ea(Ka*Ka))+ea(Ma*Ma));c[y+0>>2]=c[V+0>>2];c[y+4>>2]=c[V+4>>2];c[y+8>>2]=c[V+8>>2];ub=Ia>Na;if(Na>ca^1|ub^1){vb=36;break}else{La=Oa;ia=Ka;aa=Ma;Ia=Na}}if((vb|0)==36){Ca=c[K>>2]|0;if(ub){wb=Ca;break}Fa=Ca+-1|0;if((m|0)!=0?(a[o>>0]=Fa,(Fa|0)!=0):0){Ca=0;do{a[m+Ca>>0]=c[F+(Ca<<2)>>2];a[n+Ca>>0]=c[G+(Ca<<2)>>2];Ca=Ca+1|0}while((Ca|0)!=(Fa|0))};c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[x+0>>2]=c[B+0>>2];c[x+4>>2]=c[B+4>>2];c[x+8>>2]=c[B+8>>2];c[x+12>>2]=c[B+12>>2];c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Pa=ea(g[w>>2]);Na=ea(g[w+4>>2]);Ma=ea(g[w+8>>2]);Ka=ea(g[x>>2]);Oa=ea(g[x+4>>2]);fa=ea(g[x+8>>2]);ga=ea(T(ea(Ia)));ja=ea(ea(1.0)/ga);Ha=ea(ea(Pa-Ka)*ja);ha=ea(ea(Na-Oa)*ja);qb=ea(ea(Ma-fa)*ja);if(p){ja=(c[b+64>>2]|0)==0?Z:ea(0.0);tb=(c[e+64>>2]|0)==0?_:ea(0.0);fb=ea(ja+tb);lb=ea(Na-ea(ha*ja));rb=ea(Ma-ea(qb*ja));g[h>>2]=ea(Pa-ea(Ha*ja));g[h+4>>2]=lb;g[h+8>>2]=rb;g[h+12>>2]=ea(0.0);rb=ea(ea(ha*tb)+Oa);lb=ea(ea(qb*tb)+fa);g[j>>2]=ea(ea(Ha*tb)+Ka);g[j+4>>2]=rb;g[j+8>>2]=lb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(ga-fb);Fa=l+4|0;c[Fa+0>>2]=c[W+0>>2];c[Fa+4>>2]=c[W+4>>2];c[Fa+8>>2]=c[W+8>>2]}else{fb=ea(Na-ea(Z*ha));Na=ea(Ma-ea(Z*qb));g[h>>2]=ea(Pa-ea(Z*Ha));g[h+4>>2]=fb;g[h+8>>2]=Na;g[h+12>>2]=ea(0.0);Na=ea(ea(_*ha)+Oa);Oa=ea(ea(_*qb)+fa);g[j>>2]=ea(ea(_*Ha)+Ka);g[j+4>>2]=Na;g[j+8>>2]=Oa;g[j+12>>2]=ea(0.0);g[l>>2]=ea(ga-$);Fa=l+4|0;c[Fa+0>>2]=c[X+0>>2];c[Fa+4>>2]=c[X+4>>2];c[Fa+8>>2]=c[X+8>>2]}g[k>>2]=Ha;g[k+4>>2]=ha;g[k+8>>2]=qb;g[k+12>>2]=ea(0.0);xb=ba>=Ia?1:3;i=q;return xb|0}if((m|0)!=0?(a[o>>0]=cb,(cb|0)!=0):0){Fa=0;do{a[m+Fa>>0]=c[F+(Fa<<2)>>2];a[n+Fa>>0]=c[G+(Fa<<2)>>2];Fa=Fa+1|0}while((Fa|0)!=(cb|0))}if(!(hb&(gb^1))){xb=0;i=q;return xb|0}qb=ea(T(ea(Ia)));ha=ea(ea(1.0)/qb);Ha=ea(La*ha);ga=ea(ia*ha);Oa=ea(aa*ha);g[k>>2]=Ha;g[k+4>>2]=ga;g[k+8>>2]=Oa;g[k+12>>2]=ea(0.0);if(p){ha=(c[b+64>>2]|0)==0?Z:ea(0.0);Na=(c[e+64>>2]|0)==0?_:ea(0.0);Ka=ea(ha+Na);fa=ea(g[w>>2]);fb=ea(g[Ua>>2]);Pa=ea(fb-ea(ga*ha));fb=ea(ea(g[Va>>2])-ea(Oa*ha));g[h>>2]=ea(fa-ea(Ha*ha));g[h+4>>2]=Pa;g[h+8>>2]=fb;g[h+12>>2]=ea(0.0);fb=ea(g[x>>2]);Pa=ea(g[Xa>>2]);ha=ea(ea(ga*Na)+Pa);Pa=ea(ea(Oa*Na)+ea(g[Ya>>2]));g[j>>2]=ea(ea(Ha*Na)+fb);g[j+4>>2]=ha;g[j+8>>2]=Pa;g[j+12>>2]=ea(0.0);g[l>>2]=ea(qb-Ka);Fa=l+4|0;c[Fa+0>>2]=c[R+0>>2];c[Fa+4>>2]=c[R+4>>2];c[Fa+8>>2]=c[R+8>>2];xb=1;i=q;return xb|0}else{Ka=ea(g[w>>2]);Pa=ea(g[Ua>>2]);ha=ea(Pa-ea(Z*ga));Pa=ea(ea(g[Va>>2])-ea(Z*Oa));g[h>>2]=ea(Ka-ea(Z*Ha));g[h+4>>2]=ha;g[h+8>>2]=Pa;g[h+12>>2]=ea(0.0);Pa=ea(g[x>>2]);ha=ea(g[Xa>>2]);Ka=ea(ea(_*ga)+ha);ha=ea(ea(_*Oa)+ea(g[Ya>>2]));g[j>>2]=ea(ea(_*Ha)+Pa);g[j+4>>2]=Ka;g[j+8>>2]=ha;g[j+12>>2]=ea(0.0);g[l>>2]=ea(qb-$);Fa=l+4|0;c[Fa+0>>2]=c[S+0>>2];c[Fa+4>>2]=c[S+4>>2];c[Fa+8>>2]=c[S+8>>2];xb=1;i=q;return xb|0}}else wb=c[K>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=wb,(wb|0)!=0):0){o=0;do{a[m+o>>0]=c[F+(o<<2)>>2];a[n+o>>0]=c[G+(o<<2)>>2];o=o+1|0}while((o|0)!=(wb|0))};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];xb=6;i=q;return xb|0}function LFb(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=0,S=Im,U=Im,V=0,W=Im,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=Im,da=0,fa=Im,ga=0,ha=Im,ia=0,ja=Im,ka=0,la=Im,ma=0,na=Im,oa=0,pa=Im,qa=0,ra=Im,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=0,$b=0,ac=0,bc=0,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=0,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=0,Ic=Im,Jc=Im,Kc=Im,Lc=0;d=i;i=i+592|0;m=d+528|0;n=d+256|0;o=d;p=d+480|0;q=d+16|0;r=d+112|0;s=d+128|0;t=d+144|0;u=d+160|0;v=d+432|0;w=d+464|0;x=d+496|0;y=d+512|0;z=d+544|0;A=d+556|0;B=d+580|0;C=d+336|0;D=d+32|0;E=d+352|0;F=d+48|0;G=d+176|0;H=d+416|0;I=d+240|0;J=d+448|0;K=d+272|0;L=d+320|0;M=d+568|0;N=d+304|0;O=d+288|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];P=ea(g[f>>2]);z=f+4|0;Q=ea(g[z>>2]);R=f+8|0;S=ea(g[R>>2]);U=ea(g[e>>2]);V=e+4|0;W=ea(g[V>>2]);X=e+8|0;Y=ea(ea(P*ea(0.0))+U);U=ea(ea(Q*ea(0.0))+W);W=ea(ea(S*ea(0.0))+ea(g[X>>2]));c[B>>2]=1;S=ea(g[a>>2]);Q=ea(g[a+4>>2]);P=ea(g[a+8>>2]);Z=ea(g[b>>2]);_=ea(g[b+4>>2]);$=ea(S-Z);Z=ea(Q-_);_=ea(P-ea(g[b+8>>2]));aa=ea(ea(ea($*$)+ea(Z*Z))+ea(_*_))>ea(1.1920929e-07);g[n>>2]=$;g[n+4>>2]=Z;g[n+8>>2]=_;g[n+12>>2]=ea(0.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);ba=aa?n:m;_=ea(g[ba>>2]);Z=ea(g[ba+4>>2]);$=ea(g[ba+8>>2]);P=ea(ea(1.0)/ea(T(ea(ea(ea(_*_)+ea(Z*Z))+ea($*$)))));Q=ea(_*P);_=ea(Z*P);Z=ea($*P);g[C>>2]=Q;g[C+4>>2]=_;g[C+8>>2]=Z;g[C+12>>2]=ea(0.0);P=ea(-Q);Q=ea(-_);_=ea(-Z);ba=a+96|0;Z=ea(g[ba>>2]);m=a+100|0;$=ea(g[m>>2]);n=a+104|0;S=ea(g[n>>2]);aa=a+108|0;ca=ea(g[aa>>2]);da=a+112|0;fa=ea(g[da>>2]);ga=a+116|0;ha=ea(g[ga>>2]);ia=a+120|0;ja=ea(g[ia>>2]);ka=a+124|0;la=ea(g[ka>>2]);ma=a+128|0;na=ea(g[ma>>2]);oa=a+132|0;pa=ea(g[oa>>2]);qa=a+136|0;ra=ea(g[qa>>2]);sa=a+140|0;ta=ea(g[sa>>2]);ua=ea(ea(ea(Z*P)+ea($*Q))+ea(S*_));va=ea(ea(ea(fa*P)+ea(ha*Q))+ea(ja*_));wa=ea(ea(ea(na*P)+ea(pa*Q))+ea(ra*_));if(ua>va)xa=ua>wa?r:q;else xa=q;g[p>>2]=fa;g[p+4>>2]=ha;g[p+8>>2]=ja;g[p+12>>2]=la;g[o>>2]=na;g[o+4>>2]=pa;g[o+8>>2]=ra;g[o+12>>2]=ta;ya=va>wa?p:o;wa=ea(g[ya>>2]);va=ea(g[ya+4>>2]);ta=ea(g[ya+8>>2]);g[r>>2]=Z;g[r+4>>2]=$;g[r+8>>2]=S;g[r+12>>2]=ca;g[q>>2]=wa;g[q+4>>2]=va;g[q+8>>2]=ta;g[q+12>>2]=ea(0.0);ta=ea(g[xa>>2]);va=ea(g[xa+4>>2]);wa=ea(g[xa+8>>2]);HFb(D,b,C);ca=ea(g[D>>2]);S=ea(g[D+4>>2]);$=ea(ta-ca);ca=ea(va-S);S=ea(wa-ea(g[D+8>>2]));g[E>>2]=$;C=E+4|0;g[C>>2]=ca;xa=E+8|0;g[xa>>2]=S;ya=E+12|0;g[ya>>2]=ea(0.0);za=E+16|0;c[za+0>>2]=c[y+0>>2];c[za+4>>2]=c[y+4>>2];c[za+8>>2]=c[y+8>>2];c[za+12>>2]=c[y+12>>2];Aa=E+32|0;c[Aa+0>>2]=c[y+0>>2];c[Aa+4>>2]=c[y+4>>2];c[Aa+8>>2]=c[y+8>>2];c[Aa+12>>2]=c[y+12>>2];Aa=E+48|0;c[Aa+0>>2]=c[y+0>>2];c[Aa+4>>2]=c[y+4>>2];c[Aa+8>>2]=c[y+8>>2];c[Aa+12>>2]=c[y+12>>2];g[F>>2]=ta;Aa=F+4|0;g[Aa>>2]=va;Ba=F+8|0;g[Ba>>2]=wa;g[F+12>>2]=ea(0.0);Ca=F+16|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];Ca=F+32|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];Ca=F+48|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];Ca=G+16|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];Ca=G+32|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];Ca=G+48|0;c[Ca+0>>2]=c[y+0>>2];c[Ca+4>>2]=c[y+4>>2];c[Ca+8>>2]=c[y+8>>2];c[Ca+12>>2]=c[y+12>>2];Z=ea(-$);ra=ea(-ca);pa=ea(-S);c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];na=ea(g[a+32>>2]);la=ea(g[b+32>>2]);ja=ea((na>la?la:na)*ea(.100000001));na=ea(ja*ja);ja=ea(ea(l*l)+na);g[I>>2]=ta;y=I+4|0;g[y>>2]=va;Ca=I+8|0;g[Ca>>2]=wa;Da=I+12|0;g[Da>>2]=ea(0.0);c[J+0>>2]=c[D+0>>2];c[J+4>>2]=c[D+4>>2];c[J+8>>2]=c[D+8>>2];c[J+12>>2]=c[D+12>>2];la=ea(ea(ea($*$)+ea(ca*ca))+ea(S*S));a:do if(la>na){D=K+4|0;Ea=K+8|0;Fa=K+12|0;Ga=p+4|0;Ha=p+8|0;Ia=p+12|0;Ja=o+4|0;Ka=o+8|0;La=o+12|0;Ma=r+4|0;Na=r+8|0;Oa=r+12|0;Pa=q+4|0;Qa=q+8|0;Ra=q+12|0;Sa=L+4|0;Ta=L+8|0;Ua=H+4|0;Va=H+8|0;Wa=H+12|0;Xa=G+4|0;Ya=G+8|0;Za=G+12|0;_a=G+16|0;$a=G+20|0;ab=G+24|0;bb=G+28|0;cb=G+32|0;db=G+36|0;eb=G+40|0;fb=G+44|0;gb=F+16|0;hb=F+20|0;ib=F+24|0;jb=E+16|0;kb=E+20|0;lb=E+24|0;mb=E+28|0;nb=F+32|0;ob=F+36|0;pb=F+40|0;qb=E+32|0;rb=E+36|0;sb=E+40|0;tb=E+44|0;ub=N+4|0;vb=N+8|0;wb=O+4|0;xb=O+8|0;yb=J+4|0;zb=J+8|0;Ab=J+12|0;Bb=O+12|0;S=Z;ca=ra;$=pa;ha=Y;fa=U;ua=W;_=ea(0.0);Q=ea(0.0);P=wa;Cb=va;Db=ta;Eb=Z;Fb=ra;Gb=pa;Hb=la;while(1){Ib=ea(ea(1.0)/ea(T(ea(ea($*$)+ea(ea(ca*ca)+ea(S*S))))));Jb=ea(S*Ib);Kb=ea(ca*Ib);Lb=ea($*Ib);Ib=ea(-Kb);Mb=ea(-Lb);g[K>>2]=ea(-Jb);g[D>>2]=Ib;g[Ea>>2]=Mb;g[Fa>>2]=ea(0.0);Mb=ea(g[ba>>2]);Ib=ea(g[m>>2]);Nb=ea(g[n>>2]);Ob=ea(g[aa>>2]);Pb=ea(g[da>>2]);Qb=ea(g[ga>>2]);Rb=ea(g[ia>>2]);Sb=ea(g[ka>>2]);Tb=ea(g[ma>>2]);Ub=ea(g[oa>>2]);Vb=ea(g[qa>>2]);Wb=ea(g[sa>>2]);Xb=ea(ea(ea(Jb*Mb)+ea(Kb*Ib))+ea(Lb*Nb));Yb=ea(ea(ea(Jb*Pb)+ea(Kb*Qb))+ea(Lb*Rb));Zb=ea(ea(ea(Jb*Tb)+ea(Kb*Ub))+ea(Lb*Vb));if(Xb>Yb)_b=Xb>Zb?r:q;else _b=q;g[p>>2]=Pb;g[Ga>>2]=Qb;g[Ha>>2]=Rb;g[Ia>>2]=Sb;g[o>>2]=Tb;g[Ja>>2]=Ub;g[Ka>>2]=Vb;g[La>>2]=Wb;$b=Yb>Zb?p:o;Zb=ea(g[$b>>2]);Yb=ea(g[$b+4>>2]);Wb=ea(g[$b+8>>2]);g[r>>2]=Mb;g[Ma>>2]=Ib;g[Na>>2]=Nb;g[Oa>>2]=Ob;g[q>>2]=Zb;g[Pa>>2]=Yb;g[Qa>>2]=Wb;g[Ra>>2]=ea(0.0);Wb=ea(g[_b>>2]);Yb=ea(g[_b+4>>2]);Zb=ea(g[_b+8>>2]);HFb(L,b,K);Ob=ea(g[L>>2]);Nb=ea(g[Sa>>2]);Ib=ea(ha+Ob);Ob=ea(fa+Nb);Nb=ea(ua+ea(g[Ta>>2]));Mb=ea(Wb-Ib);Vb=ea(Yb-Ob);Ub=ea(Zb-Nb);g[H>>2]=Mb;g[Ua>>2]=Vb;g[Va>>2]=Ub;g[Wa>>2]=ea(0.0);Tb=ea(ea(ea(ea(-ea(Kb*Vb))-ea(Jb*Mb))-ea(Lb*Ub))-l);Sb=ea(g[f>>2]);Rb=ea(g[z>>2]);Qb=ea(g[R>>2]);Pb=ea(ea(ea(Jb*Sb)+ea(Kb*Rb))+ea(Lb*Qb));if(Tb>ea(0.0)){if(Pb>=ea(0.0)){ac=0;bc=26;break}Lb=ea(_-ea(Tb/Pb));c[A+0>>2]=c[M+0>>2];c[A+4>>2]=c[M+4>>2];c[A+8>>2]=c[M+8>>2];if(Lb>_){if(Lb>ea(1.0)){ac=0;bc=26;break}Pb=ea(g[e>>2]);Tb=ea(g[V>>2]);Kb=ea(ea(Lb*Sb)+Pb);Pb=ea(ea(Lb*Rb)+Tb);Tb=ea(ea(Lb*Qb)+ea(g[X>>2]));Qb=ea(Kb-ha);Rb=ea(Pb-fa);Sb=ea(Tb-ua);Jb=ea(g[G>>2]);Xb=ea(g[Xa>>2]);cc=ea(Qb+Jb);Jb=ea(Rb+Xb);Xb=ea(Sb+ea(g[Ya>>2]));dc=ea(g[_a>>2]);ec=ea(g[$a>>2]);fc=ea(Qb+dc);dc=ea(Rb+ec);ec=ea(Sb+ea(g[ab>>2]));gc=ea(g[cb>>2]);hc=ea(g[db>>2]);ic=ea(Qb+gc);gc=ea(Rb+hc);hc=ea(Sb+ea(g[eb>>2]));g[G>>2]=cc;g[Xa>>2]=Jb;g[Ya>>2]=Xb;g[Za>>2]=ea(0.0);g[_a>>2]=fc;g[$a>>2]=dc;g[ab>>2]=ec;g[bb>>2]=ea(0.0);g[cb>>2]=ic;g[db>>2]=gc;g[eb>>2]=hc;g[fb>>2]=ea(0.0);Sb=ea(g[F>>2]);Rb=ea(g[Aa>>2]);Qb=ea(Rb-Jb);Jb=ea(ea(g[Ba>>2])-Xb);g[E>>2]=ea(Sb-cc);g[C>>2]=Qb;g[xa>>2]=Jb;g[ya>>2]=ea(0.0);Jb=ea(g[gb>>2]);Qb=ea(g[hb>>2]);cc=ea(Qb-dc);dc=ea(ea(g[ib>>2])-ec);g[jb>>2]=ea(Jb-fc);g[kb>>2]=cc;g[lb>>2]=dc;g[mb>>2]=ea(0.0);dc=ea(g[nb>>2]);cc=ea(g[ob>>2]);fc=ea(cc-gc);gc=ea(ea(g[pb>>2])-hc);g[qb>>2]=ea(dc-ic);g[rb>>2]=fc;g[sb>>2]=gc;g[tb>>2]=ea(0.0);HFb(N,b,K);gc=ea(g[N>>2]);fc=ea(g[ub>>2]);ic=ea(Kb+gc);gc=ea(Pb+fc);fc=ea(Tb+ea(g[vb>>2]));dc=ea(Wb-ic);hc=ea(Yb-gc);cc=ea(Zb-fc);g[H>>2]=dc;g[Ua>>2]=hc;g[Va>>2]=cc;g[Wa>>2]=ea(0.0);jc=ic;kc=gc;lc=fc;mc=dc;nc=hc;oc=cc;pc=ea(3402823469999999843913219.0e14);qc=Lb;rc=Tb;sc=Pb;tc=Kb;uc=$;vc=ca;wc=S}else{jc=Ib;kc=Ob;lc=Nb;mc=Mb;nc=Vb;oc=Ub;pc=Hb;qc=Lb;rc=ua;sc=fa;tc=ha;uc=Gb;vc=Fb;wc=Eb}}else{jc=Ib;kc=Ob;lc=Nb;mc=Mb;nc=Vb;oc=Ub;pc=Hb;qc=_;rc=ua;sc=fa;tc=ha;uc=Gb;vc=Fb;wc=Eb}$b=c[B>>2]|0;g[F+($b<<4)>>2]=Wb;g[F+($b<<4)+4>>2]=Yb;g[F+($b<<4)+8>>2]=Zb;g[F+($b<<4)+12>>2]=ea(0.0);g[G+($b<<4)>>2]=jc;g[G+($b<<4)+4>>2]=kc;g[G+($b<<4)+8>>2]=lc;g[G+($b<<4)+12>>2]=ea(0.0);c[B>>2]=$b+1;xc=E+($b<<4)|0;c[xc+0>>2]=c[H+0>>2];c[xc+4>>2]=c[H+4>>2];c[xc+8>>2]=c[H+8>>2];c[xc+12>>2]=c[H+12>>2];do if(!$b){g[I>>2]=Wb;g[y>>2]=Yb;g[Ca>>2]=Zb;g[Da>>2]=ea(0.0);g[J>>2]=jc;g[yb>>2]=kc;g[zb>>2]=lc;g[Ab>>2]=ea(0.0);c[O+0>>2]=c[H+0>>2];c[O+4>>2]=c[H+4>>2];c[O+8>>2]=c[H+8>>2];c[O+12>>2]=c[H+12>>2]}else if(($b|0)==3)pPa(O,E,F,G,B,I,J);else if(($b|0)==1){Ub=ea(g[E>>2]);Vb=ea(g[C>>2]);Mb=ea(g[xa>>2]);Nb=ea(mc-Ub);Ob=ea(nc-Vb);Ib=ea(oc-Mb);Lb=ea(ea(ea(Nb*Nb)+ea(Ob*Ob))+ea(Ib*Ib));if(Lb==ea(0.0)){c[B>>2]=1;c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[J+0>>2]=c[G+0>>2];c[J+4>>2]=c[G+4>>2];c[J+8>>2]=c[G+8>>2];c[J+12>>2]=c[G+12>>2];c[O+0>>2]=c[E+0>>2];c[O+4>>2]=c[E+4>>2];c[O+8>>2]=c[E+8>>2];c[O+12>>2]=c[E+12>>2];break}else{Kb=ea(ea(ea(-ea(Vb*Ob))-ea(Ub*Nb))-ea(Mb*Ib));Ib=ea(g[F>>2]);Mb=ea(g[Aa>>2]);Nb=ea(g[Ba>>2]);Ub=ea(Wb-Ib);Ob=ea(Yb-Mb);Vb=ea(Zb-Nb);Pb=ea(g[G>>2]);Tb=ea(g[Xa>>2]);cc=ea(g[Ya>>2]);hc=ea(jc-Pb);dc=ea(kc-Tb);fc=ea(lc-cc);gc=ea(Kb/Lb);xc=gc>ea(1.0);Lb=xc?ea(1.0):gc;xc=Lb>ea(0.0);gc=xc?Lb:ea(0.0);Lb=ea(Ib+ea(Ub*gc));Ub=ea(Mb+ea(Ob*gc));Ob=ea(Nb+ea(Vb*gc));Vb=ea(Pb+ea(hc*gc));hc=ea(Tb+ea(dc*gc));dc=ea(cc+ea(fc*gc));g[I>>2]=Lb;g[y>>2]=Ub;g[Ca>>2]=Ob;g[Da>>2]=ea(0.0);g[J>>2]=Vb;g[yb>>2]=hc;g[zb>>2]=dc;g[Ab>>2]=ea(0.0);gc=ea(Ub-hc);hc=ea(Ob-dc);g[O>>2]=ea(Lb-Vb);g[wb>>2]=gc;g[xb>>2]=hc;g[Bb>>2]=ea(0.0);break}}else if(($b|0)==2)V6a(O,E,za,H,E,F,G,B,I,J);else{c[O+0>>2]=c[H+0>>2];c[O+4>>2]=c[H+4>>2];c[O+8>>2]=c[H+8>>2];c[O+12>>2]=c[H+12>>2]}while(0);Zb=ea(g[O>>2]);Yb=ea(g[wb>>2]);Wb=ea(g[xb>>2]);hc=ea(-Zb);gc=ea(-Yb);Vb=ea(-Wb);Lb=ea(ea(ea(Zb*Zb)+ea(Yb*Yb))+ea(Wb*Wb));$b=pc>Lb;xc=$b<<31>>31;if(!(Lb>ja)){yc=qc;zc=Q;Ac=P;Bc=Cb;Cc=Db;Dc=Vb;Ec=gc;Fc=hc;Gc=Lb;Hc=xc;Ic=uc;Jc=vc;Kc=wc;break a}if(!$b){yc=qc;zc=Q;Ac=P;Bc=Cb;Cc=Db;Dc=Vb;Ec=gc;Fc=hc;Gc=Lb;Hc=xc;Ic=uc;Jc=vc;Kc=wc;break a}Wb=ea(g[I>>2]);Yb=ea(g[y>>2]);Zb=ea(g[Ca>>2]);S=hc;ca=gc;$=Vb;ha=tc;fa=sc;ua=rc;_=qc;Q=ea(g[Da>>2]);P=Zb;Cb=Yb;Db=Wb;Eb=wc;Fb=vc;Gb=uc;Hb=Lb}if((bc|0)==26){i=d;return ac|0}}else{yc=ea(0.0);zc=ea(0.0);Ac=wa;Bc=va;Cc=ta;Dc=pa;Ec=ra;Fc=Z;Gc=la;Hc=-1;Ic=pa;Jc=ra;Kc=Z}while(0);bc=c[a+64>>2]|0;O=c[a+68>>2]|0;H=c[a+72>>2]|0;if(Gc>na)Lc=(Hc|0)==0?s:t;else Lc=s;g[t>>2]=Fc;g[t+4>>2]=Ec;g[t+8>>2]=Dc;g[t+12>>2]=ea(0.0);g[s>>2]=Kc;g[s+4>>2]=Jc;g[s+8>>2]=Ic;g[s+12>>2]=ea(0.0);Ic=ea(g[Lc>>2]);Jc=ea(g[Lc+4>>2]);Kc=ea(g[Lc+8>>2]);Dc=ea(ea(1.0)/ea(T(ea(ea(ea(Ic*Ic)+ea(Jc*Jc))+ea(Kc*Kc)))));Ec=ea(-ea(Ic*Dc));Ic=ea(-ea(Jc*Dc));Jc=ea(-ea(Kc*Dc));g[j>>2]=Ec;g[j+4>>2]=Ic;g[j+8>>2]=Jc;g[j+12>>2]=ea(0.0);g[h>>2]=yc;j=h+4|0;c[j+0>>2]=c[A+0>>2];c[j+4>>2]=c[A+4>>2];c[j+8>>2]=c[A+8>>2];c[v+0>>2]=c[I+0>>2];c[v+4>>2]=c[I+4>>2];c[v+8>>2]=c[I+8>>2];c[v+12>>2]=c[I+12>>2];g[u>>2]=Cc;g[u+4>>2]=Bc;g[u+8>>2]=Ac;g[u+12>>2]=zc;A=(Hc|0)==0?u:v;zc=ea(g[A>>2]);Ac=ea(g[A+4>>2]);Bc=ea(g[A+8>>2]);g[I>>2]=zc;g[y>>2]=Ac;g[Ca>>2]=Bc;g[Da>>2]=ea(0.0);Cc=ea(g[a+16>>2]);yc=ea(zc-ea(Cc*Ec));Ec=ea(Ac-ea(Cc*Ic));Ic=ea(Bc-ea(Cc*Jc));c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];g[x>>2]=yc;g[x+4>>2]=Ec;g[x+8>>2]=Ic;g[x+12>>2]=ea(0.0);Ic=ea(g[((bc|0)==0?w:x)>>2]);Ec=ea(g[((O|0)==0?w:x)+4>>2]);yc=ea(g[((H|0)==0?w:x)+8>>2]);g[k>>2]=Ic;g[k+4>>2]=Ec;g[k+8>>2]=yc;g[k+12>>2]=ea(0.0);ac=1;i=d;return ac|0}function MFb(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=0,ob=0,pb=0,qb=0;q=i;i=i+640|0;r=q+496|0;s=q+96|0;t=q+240|0;u=q+352|0;v=q+144|0;w=q+540|0;x=q+516|0;y=q+272|0;z=q+304|0;A=q+336|0;B=q+368|0;C=q+432|0;D=q+176|0;E=q+592|0;F=q+552|0;G=q+16|0;H=q+256|0;I=q+112|0;J=q+512|0;K=q+48|0;L=q+128|0;M=q+320|0;N=q+160|0;O=q+288|0;P=q;Q=q+32|0;R=q+80|0;S=q+608|0;U=q+620|0;V=q+64|0;W=q+580|0;X=q+568|0;Y=q+528|0;Z=ea(g[f>>2]);_=ea(g[b+16>>2]);$=ea(g[e+16>>2]);aa=ea(g[b+32>>2]);ba=ea(g[e+32>>2]);ca=ea((aa>ba?ba:aa)*ea(.100000001));c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;aa=ea(_+$);ba=ea(Z+aa);c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];c[u+12>>2]=c[t+12>>2];c[v+0>>2]=c[t+0>>2];c[v+4>>2]=c[t+4>>2];c[v+8>>2]=c[t+8>>2];c[v+12>>2]=c[t+12>>2];c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[y+0>>2]=c[t+0>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[z+0>>2]=c[t+0>>2];c[z+4>>2]=c[t+4>>2];c[z+8>>2]=c[t+8>>2];c[z+12>>2]=c[t+12>>2];da=ea(ca*ca);ca=ea(ba*ba);c[G+0>>2]=c[t+0>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[G+12>>2]=c[t+12>>2];c[H+0>>2]=c[t+0>>2];c[H+4>>2]=c[t+4>>2];c[H+8>>2]=c[t+8>>2];c[H+12>>2]=c[t+12>>2];c[I+0>>2]=c[t+0>>2];c[I+4>>2]=c[t+4>>2];c[I+8>>2]=c[t+8>>2];c[I+12>>2]=c[t+12>>2];c[J>>2]=0;if(!(a[o>>0]|0)){ba=ea(g[b>>2]);fa=ea(g[b+4>>2]);ga=ea(g[b+8>>2]);ha=ea(g[e>>2]);ia=ea(g[e+4>>2]);ja=ea(ba-ha);ha=ea(fa-ia);ia=ea(ga-ea(g[e+8>>2]));f=ea(ea(ea(ja*ja)+ea(ha*ha))+ea(ia*ia))>ea(0.0);g[s>>2]=ja;g[s+4>>2]=ha;g[s+8>>2]=ia;g[s+12>>2]=ea(0.0);g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ka=f?s:r;ia=ea(g[ka>>2]);ha=ea(g[ka+4>>2]);ja=ea(g[ka+8>>2]);g[A>>2]=ia;g[A+4>>2]=ha;g[A+8>>2]=ja;g[A+12>>2]=ea(0.0);la=ea(3402823469999999843913219.0e14);ma=1;na=ja;oa=ha;pa=ia}else{c[K+0>>2]=c[t+0>>2];c[K+4>>2]=c[t+4>>2];c[K+8>>2]=c[t+8>>2];c[K+12>>2]=c[t+12>>2];c[L+0>>2]=c[t+0>>2];c[L+4>>2]=c[t+4>>2];c[L+8>>2]=c[t+8>>2];c[L+12>>2]=c[t+12>>2];c[M+0>>2]=c[t+0>>2];c[M+4>>2]=c[t+4>>2];c[M+8>>2]=c[t+8>>2];c[M+12>>2]=c[t+12>>2];t=e+16|0;ka=G+4|0;r=G+8|0;s=H+4|0;f=H+8|0;qa=I+4|0;ra=I+8|0;sa=I+12|0;ta=0;do{ua=d[m+ta>>0]|0;c[E+(ta<<2)>>2]=ua;va=d[n+ta>>0]|0;c[F+(ta<<2)>>2]=va;wa=b+(ua<<4)+96|0;c[G+0>>2]=c[wa+0>>2];c[G+4>>2]=c[wa+4>>2];c[G+8>>2]=c[wa+8>>2];c[G+12>>2]=c[wa+12>>2];BFb(N,e,va,t);c[H+0>>2]=c[N+0>>2];c[H+4>>2]=c[N+4>>2];c[H+8>>2]=c[N+8>>2];c[H+12>>2]=c[N+12>>2];ia=ea(g[G>>2]);ha=ea(g[ka>>2]);ja=ea(g[r>>2]);ga=ea(g[H>>2]);fa=ea(g[s>>2]);ba=ea(ha-fa);fa=ea(ja-ea(g[f>>2]));g[I>>2]=ea(ia-ga);g[qa>>2]=ba;g[ra>>2]=fa;g[sa>>2]=ea(0.0);xa=c[J>>2]|0;va=C+(xa<<4)|0;c[L+0>>2]=c[G+0>>2];c[L+4>>2]=c[G+4>>2];c[L+8>>2]=c[G+8>>2];c[L+12>>2]=c[G+12>>2];c[va+0>>2]=c[G+0>>2];c[va+4>>2]=c[G+4>>2];c[va+8>>2]=c[G+8>>2];c[va+12>>2]=c[G+12>>2];va=D+(xa<<4)|0;c[M+0>>2]=c[H+0>>2];c[M+4>>2]=c[H+4>>2];c[M+8>>2]=c[H+8>>2];c[M+12>>2]=c[H+12>>2];c[va+0>>2]=c[H+0>>2];c[va+4>>2]=c[H+4>>2];c[va+8>>2]=c[H+8>>2];c[va+12>>2]=c[H+12>>2];c[J>>2]=xa+1;va=B+(xa<<4)|0;c[K+0>>2]=c[I+0>>2];c[K+4>>2]=c[I+4>>2];c[K+8>>2]=c[I+8>>2];c[K+12>>2]=c[I+12>>2];c[va+0>>2]=c[I+0>>2];c[va+4>>2]=c[I+4>>2];c[va+8>>2]=c[I+8>>2];c[va+12>>2]=c[I+12>>2];ta=ta+1|0}while(ta>>>0<(d[o>>0]|0)>>>0);do if((xa|0)==2)V6a(O,B,B+16|0,K,B,C,D,J,u,v);else if(!xa){c[u+0>>2]=c[L+0>>2];c[u+4>>2]=c[L+4>>2];c[u+8>>2]=c[L+8>>2];c[u+12>>2]=c[L+12>>2];c[v+0>>2]=c[M+0>>2];c[v+4>>2]=c[M+4>>2];c[v+8>>2]=c[M+8>>2];c[v+12>>2]=c[M+12>>2];c[O+0>>2]=c[K+0>>2];c[O+4>>2]=c[K+4>>2];c[O+8>>2]=c[K+8>>2];c[O+12>>2]=c[K+12>>2]}else if((xa|0)==3)qPa(O,B,C,D,E,F,K,L,M,J,u,v);else if((xa|0)==1){fa=ea(g[B>>2]);ba=ea(g[B+4>>2]);ga=ea(g[B+8>>2]);ia=ea(g[K>>2]);ja=ea(g[K+4>>2]);ha=ea(ia-fa);ia=ea(ja-ba);ja=ea(ea(g[K+8>>2])-ga);ya=ea(ea(ea(ha*ha)+ea(ia*ia))+ea(ja*ja));if(ya==ea(0.0)){c[J>>2]=1;c[u+0>>2]=c[C+0>>2];c[u+4>>2]=c[C+4>>2];c[u+8>>2]=c[C+8>>2];c[u+12>>2]=c[C+12>>2];c[v+0>>2]=c[D+0>>2];c[v+4>>2]=c[D+4>>2];c[v+8>>2]=c[D+8>>2];c[v+12>>2]=c[D+12>>2];c[O+0>>2]=c[B+0>>2];c[O+4>>2]=c[B+4>>2];c[O+8>>2]=c[B+8>>2];c[O+12>>2]=c[B+12>>2];break}else{za=ea(ea(ea(-ea(ba*ia))-ea(fa*ha))-ea(ga*ja));ja=ea(g[L>>2]);ga=ea(g[L+4>>2]);ha=ea(g[L+8>>2]);fa=ea(g[C>>2]);ia=ea(g[C+4>>2]);ba=ea(g[C+8>>2]);Aa=ea(ja-fa);ja=ea(ga-ia);ga=ea(ha-ba);ha=ea(g[M>>2]);Ba=ea(g[M+4>>2]);Ca=ea(g[M+8>>2]);Da=ea(g[D>>2]);Ea=ea(g[D+4>>2]);Fa=ea(g[D+8>>2]);Ga=ea(ha-Da);ha=ea(Ba-Ea);Ba=ea(Ca-Fa);Ca=ea(za/ya);ta=Ca>ea(1.0);ya=ta?ea(1.0):Ca;ta=ya>ea(0.0);Ca=ta?ya:ea(0.0);ya=ea(fa+ea(Aa*Ca));Aa=ea(ia+ea(ja*Ca));ja=ea(ba+ea(ga*Ca));ga=ea(Da+ea(Ga*Ca));Ga=ea(Ea+ea(ha*Ca));ha=ea(Fa+ea(Ba*Ca));g[u>>2]=ya;g[u+4>>2]=Aa;g[u+8>>2]=ja;g[u+12>>2]=ea(0.0);g[v>>2]=ga;g[v+4>>2]=Ga;g[v+8>>2]=ha;g[v+12>>2]=ea(0.0);Ca=ea(Aa-Ga);Ga=ea(ja-ha);g[O>>2]=ea(ya-ga);g[O+4>>2]=Ca;g[O+8>>2]=Ga;g[O+12>>2]=ea(0.0);break}}else{c[O+0>>2]=c[K+0>>2];c[O+4>>2]=c[K+4>>2];c[O+8>>2]=c[K+8>>2];c[O+12>>2]=c[K+12>>2]}while(0);c[A+0>>2]=c[O+0>>2];c[A+4>>2]=c[O+4>>2];c[A+8>>2]=c[O+8>>2];c[A+12>>2]=c[O+12>>2];Ga=ea(g[A>>2]);Ca=ea(g[A+4>>2]);ga=ea(g[A+8>>2]);ya=ea(ea(ea(Ga*Ga)+ea(Ca*Ca))+ea(ga*ga));c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];la=ya;ma=ya>da;na=ga;oa=Ca;pa=Ga}do if(ma){O=A+4|0;K=A+8|0;M=Q+4|0;L=Q+8|0;xa=Q+12|0;ta=G+4|0;sa=G+8|0;ra=H+4|0;qa=H+8|0;f=I+4|0;s=I+8|0;r=I+12|0;ka=b+48|0;N=e+48|0;t=B+4|0;va=B+8|0;wa=C+4|0;ua=C+8|0;Ha=D+4|0;Ia=D+8|0;Ja=u+4|0;Ka=u+8|0;La=u+12|0;Ma=v+4|0;Na=v+8|0;Oa=v+12|0;Pa=V+4|0;Qa=V+8|0;Ra=V+12|0;Sa=B+16|0;Ga=Z;Ca=pa;ga=oa;ya=na;ha=la;while(1){c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[y+0>>2]=c[u+0>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];c[y+12>>2]=c[u+12>>2];c[z+0>>2]=c[v+0>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];c[z+12>>2]=c[v+12>>2];ja=ea(-ga);Aa=ea(-ya);g[Q>>2]=ea(-Ca);g[M>>2]=ja;g[L>>2]=Aa;g[xa>>2]=ea(0.0);Ta=c[J>>2]|0;Ua=C+(Ta<<4)|0;FFb(P,b,Q,E+(Ta<<2)|0);c[Ua+0>>2]=c[P+0>>2];c[Ua+4>>2]=c[P+4>>2];c[Ua+8>>2]=c[P+8>>2];c[Ua+12>>2]=c[P+12>>2];c[G+0>>2]=c[P+0>>2];c[G+4>>2]=c[P+4>>2];c[G+8>>2]=c[P+8>>2];c[G+12>>2]=c[P+12>>2];Ua=c[J>>2]|0;CFb(R,e,A,D+(Ua<<4)|0,F+(Ua<<2)|0);c[H+0>>2]=c[R+0>>2];c[H+4>>2]=c[R+4>>2];c[H+8>>2]=c[R+8>>2];c[H+12>>2]=c[R+12>>2];Aa=ea(g[G>>2]);ja=ea(g[ta>>2]);Ba=ea(g[sa>>2]);Fa=ea(g[H>>2]);Ea=ea(g[ra>>2]);Da=ea(g[qa>>2]);ba=ea(Aa-Fa);ia=ea(ja-Ea);fa=ea(Ba-Da);g[I>>2]=ba;g[f>>2]=ia;g[s>>2]=fa;g[r>>2]=ea(0.0);Va=c[J>>2]|0;c[J>>2]=Va+1;Ua=B+(Va<<4)|0;c[Ua+0>>2]=c[I+0>>2];c[Ua+4>>2]=c[I+4>>2];c[Ua+8>>2]=c[I+8>>2];c[Ua+12>>2]=c[I+12>>2];za=ea(g[ka>>2]);Wa=ea(g[N>>2]);Xa=za>Wa?za:Wa;Ga=Ga>Xa?Ga:Xa;Xa=ea(aa+Ga);Wa=ea(ha*ea(Xa*Xa));Ya=ea(g[A>>2]);Za=ea(g[O>>2]);_a=ea(g[K>>2]);Xa=ea(ea(ea(Ya*ba)+ea(Za*ia))+ea(_a*fa));Ua=ea(Xa*Xa)>Wa;if(Xa>ea(0.0)){$a=Ua;ab=Ua^1}else{$a=0;ab=1}Ua=ea(da*ha)>=ea(ha-Xa);if((Ua|$a)&(Ua|ab^1))break;do if((Va|0)==3)qPa(V,B,C,D,E,F,I,G,H,J,u,v);else if(!Va){c[u+0>>2]=c[G+0>>2];c[u+4>>2]=c[G+4>>2];c[u+8>>2]=c[G+8>>2];c[u+12>>2]=c[G+12>>2];c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[V+0>>2]=c[I+0>>2];c[V+4>>2]=c[I+4>>2];c[V+8>>2]=c[I+8>>2];c[V+12>>2]=c[I+12>>2]}else if((Va|0)==2)V6a(V,B,Sa,I,B,C,D,J,u,v);else if((Va|0)==1){Xa=ea(g[B>>2]);Wa=ea(g[t>>2]);za=ea(g[va>>2]);bb=ea(ba-Xa);cb=ea(ia-Wa);db=ea(fa-za);eb=ea(ea(ea(bb*bb)+ea(cb*cb))+ea(db*db));if(eb==ea(0.0)){c[J>>2]=1;c[u+0>>2]=c[C+0>>2];c[u+4>>2]=c[C+4>>2];c[u+8>>2]=c[C+8>>2];c[u+12>>2]=c[C+12>>2];c[v+0>>2]=c[D+0>>2];c[v+4>>2]=c[D+4>>2];c[v+8>>2]=c[D+8>>2];c[v+12>>2]=c[D+12>>2];c[V+0>>2]=c[B+0>>2];c[V+4>>2]=c[B+4>>2];c[V+8>>2]=c[B+8>>2];c[V+12>>2]=c[B+12>>2];break}else{fb=ea(ea(ea(-ea(Wa*cb))-ea(Xa*bb))-ea(za*db));db=ea(g[C>>2]);za=ea(g[wa>>2]);bb=ea(g[ua>>2]);Xa=ea(Aa-db);cb=ea(ja-za);Wa=ea(Ba-bb);gb=ea(g[D>>2]);hb=ea(g[Ha>>2]);ib=ea(g[Ia>>2]);jb=ea(Fa-gb);kb=ea(Ea-hb);lb=ea(Da-ib);mb=ea(fb/eb);Ua=mb>ea(1.0);eb=Ua?ea(1.0):mb;Ua=eb>ea(0.0);mb=Ua?eb:ea(0.0);eb=ea(db+ea(Xa*mb));Xa=ea(za+ea(cb*mb));cb=ea(bb+ea(Wa*mb));Wa=ea(gb+ea(jb*mb));jb=ea(hb+ea(kb*mb));kb=ea(ib+ea(lb*mb));g[u>>2]=eb;g[Ja>>2]=Xa;g[Ka>>2]=cb;g[La>>2]=ea(0.0);g[v>>2]=Wa;g[Ma>>2]=jb;g[Na>>2]=kb;g[Oa>>2]=ea(0.0);mb=ea(Xa-jb);jb=ea(cb-kb);g[V>>2]=ea(eb-Wa);g[Pa>>2]=mb;g[Qa>>2]=jb;g[Ra>>2]=ea(0.0);break}}else{c[V+0>>2]=c[I+0>>2];c[V+4>>2]=c[I+4>>2];c[V+8>>2]=c[I+8>>2];c[V+12>>2]=c[I+12>>2]}while(0);c[A+0>>2]=c[V+0>>2];c[A+4>>2]=c[V+4>>2];c[A+8>>2]=c[V+8>>2];c[A+12>>2]=c[V+12>>2];Ca=ea(g[A>>2]);ga=ea(g[O>>2]);ya=ea(g[K>>2]);Da=ea(ea(ea(Ca*Ca)+ea(ga*ga))+ea(ya*ya));c[w+0>>2]=c[W+0>>2];c[w+4>>2]=c[W+4>>2];c[w+8>>2]=c[W+8>>2];nb=ha>Da;if(Da>da^1|nb^1){ob=36;break}else ha=Da}if((ob|0)==36){K=c[J>>2]|0;if(nb){pb=K;break}O=K+-1|0;if((m|0)!=0?(a[o>>0]=O,(O|0)!=0):0){K=0;do{a[m+K>>0]=c[E+(K<<2)>>2];a[n+K>>0]=c[F+(K<<2)>>2];K=K+1|0}while((K|0)!=(O|0))};c[u+0>>2]=c[y+0>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];c[u+12>>2]=c[y+12>>2];c[v+0>>2]=c[z+0>>2];c[v+4>>2]=c[z+4>>2];c[v+8>>2]=c[z+8>>2];c[v+12>>2]=c[z+12>>2];c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];ya=ea(g[u>>2]);ga=ea(g[u+4>>2]);Ca=ea(g[u+8>>2]);Ga=ea(g[v>>2]);Da=ea(g[v+4>>2]);Ea=ea(g[v+8>>2]);Fa=ea(ya-Ga);Ba=ea(ga-Da);ja=ea(Ca-Ea);g[A>>2]=Fa;g[A+4>>2]=Ba;g[A+8>>2]=ja;g[A+12>>2]=ea(0.0);Aa=ea(T(ea(ha)));fa=ea(ea(1.0)/Aa);ia=ea(Fa*fa);Fa=ea(Ba*fa);Ba=ea(ja*fa);if(p){fa=(c[b+64>>2]|0)==0?_:ea(0.0);ja=(c[e+64>>2]|0)==0?$:ea(0.0);ba=ea(fa+ja);jb=ea(ga-ea(Fa*fa));mb=ea(Ca-ea(Ba*fa));g[h>>2]=ea(ya-ea(ia*fa));g[h+4>>2]=jb;g[h+8>>2]=mb;g[h+12>>2]=ea(0.0);mb=ea(ea(Fa*ja)+Da);jb=ea(ea(Ba*ja)+Ea);g[j>>2]=ea(ea(ia*ja)+Ga);g[j+4>>2]=mb;g[j+8>>2]=jb;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Aa-ba);O=l+4|0;c[O+0>>2]=c[X+0>>2];c[O+4>>2]=c[X+4>>2];c[O+8>>2]=c[X+8>>2]}else{ba=ea(ga-ea(_*Fa));ga=ea(Ca-ea(_*Ba));g[h>>2]=ea(ya-ea(_*ia));g[h+4>>2]=ba;g[h+8>>2]=ga;g[h+12>>2]=ea(0.0);ga=ea(ea($*Fa)+Da);Da=ea(ea($*Ba)+Ea);g[j>>2]=ea(ea($*ia)+Ga);g[j+4>>2]=ga;g[j+8>>2]=Da;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Aa-aa);O=l+4|0;c[O+0>>2]=c[Y+0>>2];c[O+4>>2]=c[Y+4>>2];c[O+8>>2]=c[Y+8>>2]}g[k>>2]=ia;g[k+4>>2]=Fa;g[k+8>>2]=Ba;g[k+12>>2]=ea(0.0);qb=ca>=ha?1:3;i=q;return qb|0}if((m|0)!=0?(a[o>>0]=Va,(Va|0)!=0):0){O=0;do{a[m+O>>0]=c[E+(O<<2)>>2];a[n+O>>0]=c[F+(O<<2)>>2];O=O+1|0}while((O|0)!=(Va|0))}if(!(ab&($a^1))){qb=0;i=q;return qb|0}Ba=ea(T(ea(ha)));Fa=ea(ea(1.0)/Ba);ia=ea(Ya*Fa);Aa=ea(Za*Fa);Da=ea(_a*Fa);g[k>>2]=ia;g[k+4>>2]=Aa;g[k+8>>2]=Da;g[k+12>>2]=ea(0.0);if(p){Fa=(c[b+64>>2]|0)==0?_:ea(0.0);ga=(c[e+64>>2]|0)==0?$:ea(0.0);Ga=ea(Fa+ga);Ea=ea(g[u>>2]);ba=ea(g[Ja>>2]);ya=ea(ba-ea(Aa*Fa));ba=ea(ea(g[Ka>>2])-ea(Da*Fa));g[h>>2]=ea(Ea-ea(ia*Fa));g[h+4>>2]=ya;g[h+8>>2]=ba;g[h+12>>2]=ea(0.0);ba=ea(g[v>>2]);ya=ea(g[Ma>>2]);Fa=ea(ea(Aa*ga)+ya);ya=ea(ea(Da*ga)+ea(g[Na>>2]));g[j>>2]=ea(ea(ia*ga)+ba);g[j+4>>2]=Fa;g[j+8>>2]=ya;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ba-Ga);O=l+4|0;c[O+0>>2]=c[S+0>>2];c[O+4>>2]=c[S+4>>2];c[O+8>>2]=c[S+8>>2];qb=1;i=q;return qb|0}else{Ga=ea(g[u>>2]);ya=ea(g[Ja>>2]);Fa=ea(ya-ea(_*Aa));ya=ea(ea(g[Ka>>2])-ea(_*Da));g[h>>2]=ea(Ga-ea(_*ia));g[h+4>>2]=Fa;g[h+8>>2]=ya;g[h+12>>2]=ea(0.0);ya=ea(g[v>>2]);Fa=ea(g[Ma>>2]);Ga=ea(ea($*Aa)+Fa);Fa=ea(ea($*Da)+ea(g[Na>>2]));g[j>>2]=ea(ea($*ia)+ya);g[j+4>>2]=Ga;g[j+8>>2]=Fa;g[j+12>>2]=ea(0.0);g[l>>2]=ea(Ba-aa);O=l+4|0;c[O+0>>2]=c[U+0>>2];c[O+4>>2]=c[U+4>>2];c[O+8>>2]=c[U+8>>2];qb=1;i=q;return qb|0}}else pb=c[J>>2]|0;while(0);if((m|0)!=0?(a[o>>0]=pb,(pb|0)!=0):0){o=0;do{a[m+o>>0]=c[E+(o<<2)>>2];a[n+o>>0]=c[F+(o<<2)>>2];o=o+1|0}while((o|0)!=(pb|0))};c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];qb=6;i=q;return qb|0}function NFb(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=0,L=Im,M=Im,N=0,O=Im,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=0,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=0,Qb=0,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=0,vc=Im,wc=Im,xc=Im,yc=0;d=i;i=i+480|0;m=d+416|0;n=d+272|0;o=d+192|0;p=d+208|0;q=d+48|0;r=d+256|0;s=d+288|0;t=d+368|0;u=d+400|0;v=d+224|0;w=d+32|0;x=d+432|0;y=d+456|0;z=d+468|0;A=d+64|0;B=d+128|0;C=d+304|0;D=d+384|0;E=d+240|0;F=d;G=d+444|0;H=d+16|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];I=ea(g[f>>2]);x=f+4|0;J=ea(g[x>>2]);K=f+8|0;L=ea(g[K>>2]);M=ea(g[e>>2]);N=e+4|0;O=ea(g[N>>2]);P=e+8|0;Q=ea(g[P>>2]);c[z>>2]=1;R=ea(g[a>>2]);S=ea(g[a+4>>2]);U=ea(g[a+8>>2]);V=ea(g[b>>2]);W=ea(g[b+4>>2]);X=ea(R-V);V=ea(S-W);W=ea(U-ea(g[b+8>>2]));Y=ea(ea(ea(X*X)+ea(V*V))+ea(W*W))>ea(1.1920929e-07);g[n>>2]=X;g[n+4>>2]=V;g[n+8>>2]=W;g[n+12>>2]=ea(0.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);Z=Y?n:m;W=ea(g[Z>>2]);V=ea(g[Z+4>>2]);X=ea(g[Z+8>>2]);U=ea(ea(1.0)/ea(T(ea(ea(ea(W*W)+ea(V*V))+ea(X*X)))));S=ea(W*U);W=ea(V*U);V=ea(X*U);U=ea(-S);X=ea(-W);R=ea(-V);Z=a+96|0;m=a+96|0;_=ea(g[m>>2]);n=a+100|0;$=ea(g[n>>2]);Y=a+104|0;aa=ea(ea(ea(_*U)+ea($*X))+ea(ea(g[Y>>2])*R));ba=a+112|0;ca=a+112|0;$=ea(g[ca>>2]);da=a+116|0;_=ea(g[da>>2]);fa=a+120|0;ga=aa>ea(ea(ea($*U)+ea(_*X))+ea(ea(g[fa>>2])*R));c[p+0>>2]=c[Z+0>>2];c[p+4>>2]=c[Z+4>>2];c[p+8>>2]=c[Z+8>>2];c[p+12>>2]=c[Z+12>>2];c[o+0>>2]=c[ba+0>>2];c[o+4>>2]=c[ba+4>>2];c[o+8>>2]=c[ba+8>>2];c[o+12>>2]=c[ba+12>>2];ha=ga?p:o;R=ea(g[ha>>2]);X=ea(g[ha+4>>2]);_=ea(g[ha+8>>2]);ha=S>ea(0.0);ga=W>ea(0.0);ia=V>ea(0.0);ja=b+144|0;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];ka=b+144|0;V=ea(g[ka>>2]);la=b+148|0;W=ea(g[la>>2]);ma=b+152|0;S=ea(-W);W=ea(-ea(g[ma>>2]));g[o>>2]=ea(-V);g[o+4>>2]=S;g[o+8>>2]=W;g[o+12>>2]=ea(0.0);W=ea(g[(ha?p:o)>>2]);S=ea(g[(ga?p:o)+4>>2]);V=ea(g[(ia?p:o)+8>>2]);U=ea(R-W);$=ea(X-S);aa=ea(_-V);g[A>>2]=U;ia=A+4|0;g[ia>>2]=$;ga=A+8|0;g[ga>>2]=aa;ha=A+12|0;g[ha>>2]=ea(0.0);na=A+16|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];oa=A+32|0;c[oa+0>>2]=c[w+0>>2];c[oa+4>>2]=c[w+4>>2];c[oa+8>>2]=c[w+8>>2];c[oa+12>>2]=c[w+12>>2];oa=A+48|0;c[oa+0>>2]=c[w+0>>2];c[oa+4>>2]=c[w+4>>2];c[oa+8>>2]=c[w+8>>2];c[oa+12>>2]=c[w+12>>2];g[B>>2]=R;oa=B+4|0;g[oa>>2]=X;pa=B+8|0;g[pa>>2]=_;g[B+12>>2]=ea(0.0);qa=B+16|0;c[qa+0>>2]=c[w+0>>2];c[qa+4>>2]=c[w+4>>2];c[qa+8>>2]=c[w+8>>2];c[qa+12>>2]=c[w+12>>2];qa=B+32|0;c[qa+0>>2]=c[w+0>>2];c[qa+4>>2]=c[w+4>>2];c[qa+8>>2]=c[w+8>>2];c[qa+12>>2]=c[w+12>>2];qa=B+48|0;c[qa+0>>2]=c[w+0>>2];c[qa+4>>2]=c[w+4>>2];c[qa+8>>2]=c[w+8>>2];c[qa+12>>2]=c[w+12>>2];g[C>>2]=W;qa=C+4|0;g[qa>>2]=S;ra=C+8|0;g[ra>>2]=V;sa=C+12|0;g[sa>>2]=ea(0.0);ta=C+16|0;c[ta+0>>2]=c[w+0>>2];c[ta+4>>2]=c[w+4>>2];c[ta+8>>2]=c[w+8>>2];c[ta+12>>2]=c[w+12>>2];ta=C+32|0;c[ta+0>>2]=c[w+0>>2];c[ta+4>>2]=c[w+4>>2];c[ta+8>>2]=c[w+8>>2];c[ta+12>>2]=c[w+12>>2];ta=C+48|0;c[ta+0>>2]=c[w+0>>2];c[ta+4>>2]=c[w+4>>2];c[ta+8>>2]=c[w+8>>2];c[ta+12>>2]=c[w+12>>2];ua=ea(-U);va=ea(-$);wa=ea(-aa);c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];xa=ea(g[a+32>>2]);ya=ea(g[b+32>>2]);za=ea((xa>ya?ya:xa)*ea(.100000001));xa=ea(za*za);za=ea(ea(l*l)+xa);g[E>>2]=R;b=E+4|0;g[b>>2]=X;w=E+8|0;g[w>>2]=_;ta=E+12|0;g[ta>>2]=ea(0.0);g[F>>2]=W;Aa=F+4|0;g[Aa>>2]=S;Ba=F+8|0;g[Ba>>2]=V;Ca=F+12|0;g[Ca>>2]=ea(0.0);V=ea(ea(ea(U*U)+ea($*$))+ea(aa*aa));a:do if(V>xa){Da=o+4|0;Ea=o+8|0;Fa=o+12|0;Ga=D+4|0;Ha=D+8|0;Ia=D+12|0;Ja=C+16|0;Ka=C+20|0;La=C+24|0;Ma=C+28|0;Na=C+32|0;Oa=C+36|0;Pa=C+40|0;Qa=C+44|0;Ra=B+16|0;Sa=B+20|0;Ta=B+24|0;Ua=A+16|0;Va=A+20|0;Wa=A+24|0;Xa=A+28|0;Ya=B+32|0;Za=B+36|0;_a=B+40|0;$a=A+32|0;ab=A+36|0;bb=A+40|0;cb=A+44|0;db=o+4|0;eb=o+8|0;fb=o+12|0;gb=H+4|0;hb=H+8|0;ib=H+12|0;aa=ua;$=va;U=wa;S=ea(ea(I*ea(0.0))+M);W=ea(ea(J*ea(0.0))+O);ya=ea(ea(L*ea(0.0))+Q);jb=ea(0.0);kb=ea(0.0);lb=_;mb=X;nb=R;ob=ua;pb=va;qb=wa;rb=V;while(1){sb=ea(ea(1.0)/ea(T(ea(ea(U*U)+ea(ea($*$)+ea(aa*aa))))));tb=ea(aa*sb);ub=ea($*sb);vb=ea(U*sb);sb=ea(g[m>>2]);wb=ea(g[n>>2]);xb=ea(ea(ea(tb*sb)+ea(ub*wb))+ea(vb*ea(g[Y>>2])));wb=ea(g[ca>>2]);sb=ea(g[da>>2]);yb=xb>ea(ea(ea(tb*wb)+ea(ub*sb))+ea(vb*ea(g[fa>>2])));c[p+0>>2]=c[Z+0>>2];c[p+4>>2]=c[Z+4>>2];c[p+8>>2]=c[Z+8>>2];c[p+12>>2]=c[Z+12>>2];c[o+0>>2]=c[ba+0>>2];c[o+4>>2]=c[ba+4>>2];c[o+8>>2]=c[ba+8>>2];c[o+12>>2]=c[ba+12>>2];zb=yb?p:o;sb=ea(g[zb>>2]);wb=ea(g[zb+4>>2]);xb=ea(g[zb+8>>2]);zb=tb<ea(-0.0);yb=ub<ea(-0.0);Ab=vb<ea(-0.0);c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];Bb=ea(g[ka>>2]);Cb=ea(g[la>>2]);Db=ea(-Bb);Bb=ea(-Cb);Cb=ea(-ea(g[ma>>2]));g[o>>2]=Db;g[Da>>2]=Bb;g[Ea>>2]=Cb;g[Fa>>2]=ea(0.0);Eb=ea(g[(zb?p:o)>>2]);Fb=ea(g[(yb?p:o)+4>>2]);Gb=ea(S+Eb);Eb=ea(W+Fb);Fb=ea(ya+ea(g[(Ab?p:o)+8>>2]));Hb=ea(sb-Gb);Ib=ea(wb-Eb);Jb=ea(xb-Fb);g[D>>2]=Hb;g[Ga>>2]=Ib;g[Ha>>2]=Jb;g[Ia>>2]=ea(0.0);Kb=ea(ea(ea(ea(-ea(ub*Ib))-ea(tb*Hb))-ea(vb*Jb))-l);Lb=ea(g[f>>2]);Mb=ea(g[x>>2]);Nb=ea(g[K>>2]);Ob=ea(ea(ea(tb*Lb)+ea(ub*Mb))+ea(vb*Nb));if(Kb>ea(0.0)){if(Ob>=ea(0.0)){Pb=0;Qb=22;break}vb=ea(jb-ea(Kb/Ob));c[y+0>>2]=c[G+0>>2];c[y+4>>2]=c[G+4>>2];c[y+8>>2]=c[G+8>>2];if(vb>jb){if(vb>ea(1.0)){Pb=0;Qb=22;break}Ob=ea(g[e>>2]);Kb=ea(g[N>>2]);ub=ea(ea(vb*Lb)+Ob);Ob=ea(ea(vb*Mb)+Kb);Kb=ea(ea(vb*Nb)+ea(g[P>>2]));Nb=ea(ub-S);Mb=ea(Ob-W);Lb=ea(Kb-ya);tb=ea(g[C>>2]);Rb=ea(g[qa>>2]);Sb=ea(Nb+tb);tb=ea(Mb+Rb);Rb=ea(Lb+ea(g[ra>>2]));Tb=ea(g[Ja>>2]);Ub=ea(g[Ka>>2]);Vb=ea(Nb+Tb);Tb=ea(Mb+Ub);Ub=ea(Lb+ea(g[La>>2]));Wb=ea(g[Na>>2]);Xb=ea(g[Oa>>2]);Yb=ea(Nb+Wb);Wb=ea(Mb+Xb);Xb=ea(Lb+ea(g[Pa>>2]));g[C>>2]=Sb;g[qa>>2]=tb;g[ra>>2]=Rb;g[sa>>2]=ea(0.0);g[Ja>>2]=Vb;g[Ka>>2]=Tb;g[La>>2]=Ub;g[Ma>>2]=ea(0.0);g[Na>>2]=Yb;g[Oa>>2]=Wb;g[Pa>>2]=Xb;g[Qa>>2]=ea(0.0);Lb=ea(g[B>>2]);Mb=ea(g[oa>>2]);Nb=ea(Mb-tb);tb=ea(ea(g[pa>>2])-Rb);g[A>>2]=ea(Lb-Sb);g[ia>>2]=Nb;g[ga>>2]=tb;g[ha>>2]=ea(0.0);tb=ea(g[Ra>>2]);Nb=ea(g[Sa>>2]);Sb=ea(Nb-Tb);Tb=ea(ea(g[Ta>>2])-Ub);g[Ua>>2]=ea(tb-Vb);g[Va>>2]=Sb;g[Wa>>2]=Tb;g[Xa>>2]=ea(0.0);Tb=ea(g[Ya>>2]);Sb=ea(g[Za>>2]);Vb=ea(Sb-Wb);Wb=ea(ea(g[_a>>2])-Xb);g[$a>>2]=ea(Tb-Yb);g[ab>>2]=Vb;g[bb>>2]=Wb;g[cb>>2]=ea(0.0);c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];g[o>>2]=Db;g[db>>2]=Bb;g[eb>>2]=Cb;g[fb>>2]=ea(0.0);Cb=ea(g[(zb?p:o)>>2]);Bb=ea(g[(yb?p:o)+4>>2]);Db=ea(ub+Cb);Cb=ea(Ob+Bb);Bb=ea(Kb+ea(g[(Ab?p:o)+8>>2]));Wb=ea(sb-Db);Vb=ea(wb-Cb);Yb=ea(xb-Bb);g[D>>2]=Wb;g[Ga>>2]=Vb;g[Ha>>2]=Yb;g[Ia>>2]=ea(0.0);Zb=Db;_b=Cb;$b=Bb;ac=Wb;bc=Vb;cc=Yb;dc=ea(3402823469999999843913219.0e14);ec=vb;fc=Kb;gc=Ob;hc=ub;ic=U;jc=$;kc=aa}else{Zb=Gb;_b=Eb;$b=Fb;ac=Hb;bc=Ib;cc=Jb;dc=rb;ec=vb;fc=ya;gc=W;hc=S;ic=qb;jc=pb;kc=ob}}else{Zb=Gb;_b=Eb;$b=Fb;ac=Hb;bc=Ib;cc=Jb;dc=rb;ec=jb;fc=ya;gc=W;hc=S;ic=qb;jc=pb;kc=ob}Ab=c[z>>2]|0;g[B+(Ab<<4)>>2]=sb;g[B+(Ab<<4)+4>>2]=wb;g[B+(Ab<<4)+8>>2]=xb;g[B+(Ab<<4)+12>>2]=ea(0.0);g[C+(Ab<<4)>>2]=Zb;g[C+(Ab<<4)+4>>2]=_b;g[C+(Ab<<4)+8>>2]=$b;g[C+(Ab<<4)+12>>2]=ea(0.0);c[z>>2]=Ab+1;yb=A+(Ab<<4)|0;c[yb+0>>2]=c[D+0>>2];c[yb+4>>2]=c[D+4>>2];c[yb+8>>2]=c[D+8>>2];c[yb+12>>2]=c[D+12>>2];do if((Ab|0)==3)pPa(H,A,B,C,z,E,F);else if(!Ab){g[E>>2]=sb;g[b>>2]=wb;g[w>>2]=xb;g[ta>>2]=ea(0.0);g[F>>2]=Zb;g[Aa>>2]=_b;g[Ba>>2]=$b;g[Ca>>2]=ea(0.0);c[H+0>>2]=c[D+0>>2];c[H+4>>2]=c[D+4>>2];c[H+8>>2]=c[D+8>>2];c[H+12>>2]=c[D+12>>2]}else if((Ab|0)==1){Jb=ea(g[A>>2]);Ib=ea(g[ia>>2]);Hb=ea(g[ga>>2]);Fb=ea(ac-Jb);Eb=ea(bc-Ib);Gb=ea(cc-Hb);vb=ea(ea(ea(Fb*Fb)+ea(Eb*Eb))+ea(Gb*Gb));if(vb==ea(0.0)){c[z>>2]=1;c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[H+0>>2]=c[A+0>>2];c[H+4>>2]=c[A+4>>2];c[H+8>>2]=c[A+8>>2];c[H+12>>2]=c[A+12>>2];break}else{ub=ea(ea(ea(-ea(Ib*Eb))-ea(Jb*Fb))-ea(Hb*Gb));Gb=ea(g[B>>2]);Hb=ea(g[oa>>2]);Fb=ea(g[pa>>2]);Jb=ea(sb-Gb);Eb=ea(wb-Hb);Ib=ea(xb-Fb);Ob=ea(g[C>>2]);Kb=ea(g[qa>>2]);Yb=ea(g[ra>>2]);Vb=ea(Zb-Ob);Wb=ea(_b-Kb);Bb=ea($b-Yb);Cb=ea(ub/vb);yb=Cb>ea(1.0);vb=yb?ea(1.0):Cb;yb=vb>ea(0.0);Cb=yb?vb:ea(0.0);vb=ea(Gb+ea(Jb*Cb));Jb=ea(Hb+ea(Eb*Cb));Eb=ea(Fb+ea(Ib*Cb));Ib=ea(Ob+ea(Vb*Cb));Vb=ea(Kb+ea(Wb*Cb));Wb=ea(Yb+ea(Bb*Cb));g[E>>2]=vb;g[b>>2]=Jb;g[w>>2]=Eb;g[ta>>2]=ea(0.0);g[F>>2]=Ib;g[Aa>>2]=Vb;g[Ba>>2]=Wb;g[Ca>>2]=ea(0.0);Cb=ea(Jb-Vb);Vb=ea(Eb-Wb);g[H>>2]=ea(vb-Ib);g[gb>>2]=Cb;g[hb>>2]=Vb;g[ib>>2]=ea(0.0);break}}else if((Ab|0)==2)V6a(H,A,na,D,A,B,C,z,E,F);else{c[H+0>>2]=c[D+0>>2];c[H+4>>2]=c[D+4>>2];c[H+8>>2]=c[D+8>>2];c[H+12>>2]=c[D+12>>2]}while(0);xb=ea(g[H>>2]);wb=ea(g[gb>>2]);sb=ea(g[hb>>2]);Vb=ea(-xb);Cb=ea(-wb);Ib=ea(-sb);vb=ea(ea(ea(xb*xb)+ea(wb*wb))+ea(sb*sb));Ab=dc>vb;yb=Ab<<31>>31;if(!(vb>za)){lc=ec;mc=kb;nc=lb;oc=mb;pc=nb;qc=Ib;rc=Cb;sc=Vb;tc=vb;uc=yb;vc=ic;wc=jc;xc=kc;break a}if(!Ab){lc=ec;mc=kb;nc=lb;oc=mb;pc=nb;qc=Ib;rc=Cb;sc=Vb;tc=vb;uc=yb;vc=ic;wc=jc;xc=kc;break a}sb=ea(g[E>>2]);wb=ea(g[b>>2]);xb=ea(g[w>>2]);aa=Vb;$=Cb;U=Ib;S=hc;W=gc;ya=fc;jb=ec;kb=ea(g[ta>>2]);lb=xb;mb=wb;nb=sb;ob=kc;pb=jc;qb=ic;rb=vb}if((Qb|0)==22){i=d;return Pb|0}}else{lc=ea(0.0);mc=ea(0.0);nc=_;oc=X;pc=R;qc=wa;rc=va;sc=ua;tc=V;uc=-1;vc=wa;wc=va;xc=ua}while(0);Qb=c[a+64>>2]|0;H=c[a+68>>2]|0;D=c[a+72>>2]|0;if(tc>xa)yc=(uc|0)==0?q:r;else yc=q;g[r>>2]=sc;g[r+4>>2]=rc;g[r+8>>2]=qc;g[r+12>>2]=ea(0.0);g[q>>2]=xc;g[q+4>>2]=wc;g[q+8>>2]=vc;g[q+12>>2]=ea(0.0);vc=ea(g[yc>>2]);wc=ea(g[yc+4>>2]);xc=ea(g[yc+8>>2]);qc=ea(ea(1.0)/ea(T(ea(ea(ea(vc*vc)+ea(wc*wc))+ea(xc*xc)))));rc=ea(-ea(vc*qc));vc=ea(-ea(wc*qc));wc=ea(-ea(xc*qc));g[j>>2]=rc;g[j+4>>2]=vc;g[j+8>>2]=wc;g[j+12>>2]=ea(0.0);g[h>>2]=lc;j=h+4|0;c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[t+0>>2]=c[E+0>>2];c[t+4>>2]=c[E+4>>2];c[t+8>>2]=c[E+8>>2];c[t+12>>2]=c[E+12>>2];g[s>>2]=pc;g[s+4>>2]=oc;g[s+8>>2]=nc;g[s+12>>2]=mc;y=(uc|0)==0?s:t;mc=ea(g[y>>2]);nc=ea(g[y+4>>2]);oc=ea(g[y+8>>2]);g[E>>2]=mc;g[b>>2]=nc;g[w>>2]=oc;g[ta>>2]=ea(0.0);pc=ea(g[a+16>>2]);lc=ea(mc-ea(pc*rc));rc=ea(nc-ea(pc*vc));vc=ea(oc-ea(pc*wc));c[u+0>>2]=c[E+0>>2];c[u+4>>2]=c[E+4>>2];c[u+8>>2]=c[E+8>>2];c[u+12>>2]=c[E+12>>2];g[v>>2]=lc;g[v+4>>2]=rc;g[v+8>>2]=vc;g[v+12>>2]=ea(0.0);vc=ea(g[((Qb|0)==0?u:v)>>2]);rc=ea(g[((H|0)==0?u:v)+4>>2]);lc=ea(g[((D|0)==0?u:v)+8>>2]);g[k>>2]=vc;g[k+4>>2]=rc;g[k+8>>2]=lc;g[k+12>>2]=ea(0.0);Pb=1;i=d;return Pb|0}function OFb(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=0,Q=Im,R=Im,S=0,U=Im,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=0,Nb=0,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=0,sc=Im,tc=Im,uc=Im,vc=0;d=i;i=i+560|0;m=d+496|0;n=d+16|0;o=d;p=d+448|0;q=d+192|0;r=d+64|0;s=d+80|0;t=d+96|0;u=d+400|0;v=d+432|0;w=d+464|0;x=d+512|0;y=d+524|0;z=d+548|0;A=d+256|0;B=d+32|0;C=d+272|0;D=d+112|0;E=d+336|0;F=d+48|0;G=d+176|0;H=d+416|0;I=d+208|0;J=d+240|0;K=d+536|0;L=d+224|0;M=d+480|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];N=ea(g[f>>2]);x=f+4|0;O=ea(g[x>>2]);P=f+8|0;Q=ea(g[P>>2]);R=ea(g[e>>2]);S=e+4|0;U=ea(g[S>>2]);V=e+8|0;W=ea(g[V>>2]);c[z>>2]=1;X=ea(g[a>>2]);Y=ea(g[a+4>>2]);Z=ea(g[a+8>>2]);_=ea(g[b>>2]);$=ea(g[b+4>>2]);aa=ea(X-_);_=ea(Y-$);$=ea(Z-ea(g[b+8>>2]));ba=ea(ea(ea(aa*aa)+ea(_*_))+ea($*$))>ea(1.1920929e-07);g[n>>2]=aa;g[n+4>>2]=_;g[n+8>>2]=$;g[n+12>>2]=ea(0.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=ea(0.0);ca=ba?n:m;$=ea(g[ca>>2]);_=ea(g[ca+4>>2]);aa=ea(g[ca+8>>2]);Z=ea(ea(1.0)/ea(T(ea(ea(ea($*$)+ea(_*_))+ea(aa*aa)))));Y=ea($*Z);$=ea(_*Z);_=ea(aa*Z);g[A>>2]=Y;g[A+4>>2]=$;g[A+8>>2]=_;g[A+12>>2]=ea(0.0);Z=ea(-Y);Y=ea(-$);$=ea(-_);ca=a+96|0;m=a+96|0;_=ea(g[m>>2]);n=a+100|0;aa=ea(g[n>>2]);ba=a+104|0;X=ea(ea(ea(_*Z)+ea(aa*Y))+ea(ea(g[ba>>2])*$));da=a+112|0;fa=a+112|0;aa=ea(g[fa>>2]);ga=a+116|0;_=ea(g[ga>>2]);ha=a+120|0;ia=X>ea(ea(ea(aa*Z)+ea(_*Y))+ea(ea(g[ha>>2])*$));c[p+0>>2]=c[ca+0>>2];c[p+4>>2]=c[ca+4>>2];c[p+8>>2]=c[ca+8>>2];c[p+12>>2]=c[ca+12>>2];c[o+0>>2]=c[da+0>>2];c[o+4>>2]=c[da+4>>2];c[o+8>>2]=c[da+8>>2];c[o+12>>2]=c[da+12>>2];ja=ia?p:o;$=ea(g[ja>>2]);Y=ea(g[ja+4>>2]);_=ea(g[ja+8>>2]);HFb(B,b,A);Z=ea(g[B>>2]);aa=ea(g[B+4>>2]);X=ea($-Z);Z=ea(Y-aa);aa=ea(_-ea(g[B+8>>2]));g[C>>2]=X;A=C+4|0;g[A>>2]=Z;ja=C+8|0;g[ja>>2]=aa;ia=C+12|0;g[ia>>2]=ea(0.0);ka=C+16|0;c[ka+0>>2]=c[w+0>>2];c[ka+4>>2]=c[w+4>>2];c[ka+8>>2]=c[w+8>>2];c[ka+12>>2]=c[w+12>>2];la=C+32|0;c[la+0>>2]=c[w+0>>2];c[la+4>>2]=c[w+4>>2];c[la+8>>2]=c[w+8>>2];c[la+12>>2]=c[w+12>>2];la=C+48|0;c[la+0>>2]=c[w+0>>2];c[la+4>>2]=c[w+4>>2];c[la+8>>2]=c[w+8>>2];c[la+12>>2]=c[w+12>>2];g[D>>2]=$;la=D+4|0;g[la>>2]=Y;ma=D+8|0;g[ma>>2]=_;g[D+12>>2]=ea(0.0);na=D+16|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];na=D+32|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];na=D+48|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];na=E+16|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];na=E+32|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];na=E+48|0;c[na+0>>2]=c[w+0>>2];c[na+4>>2]=c[w+4>>2];c[na+8>>2]=c[w+8>>2];c[na+12>>2]=c[w+12>>2];oa=ea(-X);pa=ea(-Z);qa=ea(-aa);c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];ra=ea(g[a+32>>2]);sa=ea(g[b+32>>2]);ta=ea((ra>sa?sa:ra)*ea(.100000001));ra=ea(ta*ta);ta=ea(ea(l*l)+ra);g[G>>2]=$;w=G+4|0;g[w>>2]=Y;na=G+8|0;g[na>>2]=_;ua=G+12|0;g[ua>>2]=ea(0.0);c[H+0>>2]=c[B+0>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];c[H+12>>2]=c[B+12>>2];sa=ea(ea(ea(X*X)+ea(Z*Z))+ea(aa*aa));a:do if(sa>ra){B=I+4|0;va=I+8|0;wa=I+12|0;xa=J+4|0;ya=J+8|0;za=F+4|0;Aa=F+8|0;Ba=F+12|0;Ca=E+4|0;Da=E+8|0;Ea=E+12|0;Fa=E+16|0;Ga=E+20|0;Ha=E+24|0;Ia=E+28|0;Ja=E+32|0;Ka=E+36|0;La=E+40|0;Ma=E+44|0;Na=D+16|0;Oa=D+20|0;Pa=D+24|0;Qa=C+16|0;Ra=C+20|0;Sa=C+24|0;Ta=C+28|0;Ua=D+32|0;Va=D+36|0;Wa=D+40|0;Xa=C+32|0;Ya=C+36|0;Za=C+40|0;_a=C+44|0;$a=L+4|0;ab=L+8|0;bb=M+4|0;cb=M+8|0;db=H+4|0;eb=H+8|0;fb=H+12|0;gb=M+12|0;aa=oa;Z=pa;X=qa;hb=ea(ea(N*ea(0.0))+R);ib=ea(ea(O*ea(0.0))+U);jb=ea(ea(Q*ea(0.0))+W);kb=ea(0.0);lb=ea(0.0);mb=_;nb=Y;ob=$;pb=oa;qb=pa;rb=qa;sb=sa;while(1){tb=ea(ea(1.0)/ea(T(ea(ea(X*X)+ea(ea(Z*Z)+ea(aa*aa))))));ub=ea(aa*tb);vb=ea(Z*tb);wb=ea(X*tb);tb=ea(-vb);xb=ea(-wb);g[I>>2]=ea(-ub);g[B>>2]=tb;g[va>>2]=xb;g[wa>>2]=ea(0.0);xb=ea(g[m>>2]);tb=ea(g[n>>2]);yb=ea(ea(ea(ub*xb)+ea(vb*tb))+ea(wb*ea(g[ba>>2])));tb=ea(g[fa>>2]);xb=ea(g[ga>>2]);zb=yb>ea(ea(ea(ub*tb)+ea(vb*xb))+ea(wb*ea(g[ha>>2])));c[p+0>>2]=c[ca+0>>2];c[p+4>>2]=c[ca+4>>2];c[p+8>>2]=c[ca+8>>2];c[p+12>>2]=c[ca+12>>2];c[o+0>>2]=c[da+0>>2];c[o+4>>2]=c[da+4>>2];c[o+8>>2]=c[da+8>>2];c[o+12>>2]=c[da+12>>2];Ab=zb?p:o;xb=ea(g[Ab>>2]);tb=ea(g[Ab+4>>2]);yb=ea(g[Ab+8>>2]);HFb(J,b,I);Bb=ea(g[J>>2]);Cb=ea(g[xa>>2]);Db=ea(hb+Bb);Bb=ea(ib+Cb);Cb=ea(jb+ea(g[ya>>2]));Eb=ea(xb-Db);Fb=ea(tb-Bb);Gb=ea(yb-Cb);g[F>>2]=Eb;g[za>>2]=Fb;g[Aa>>2]=Gb;g[Ba>>2]=ea(0.0);Hb=ea(ea(ea(ea(-ea(vb*Fb))-ea(ub*Eb))-ea(wb*Gb))-l);Ib=ea(g[f>>2]);Jb=ea(g[x>>2]);Kb=ea(g[P>>2]);Lb=ea(ea(ea(ub*Ib)+ea(vb*Jb))+ea(wb*Kb));if(Hb>ea(0.0)){if(Lb>=ea(0.0)){Mb=0;Nb=22;break}wb=ea(kb-ea(Hb/Lb));c[y+0>>2]=c[K+0>>2];c[y+4>>2]=c[K+4>>2];c[y+8>>2]=c[K+8>>2];if(wb>kb){if(wb>ea(1.0)){Mb=0;Nb=22;break}Lb=ea(g[e>>2]);Hb=ea(g[S>>2]);vb=ea(ea(wb*Ib)+Lb);Lb=ea(ea(wb*Jb)+Hb);Hb=ea(ea(wb*Kb)+ea(g[V>>2]));Kb=ea(vb-hb);Jb=ea(Lb-ib);Ib=ea(Hb-jb);ub=ea(g[E>>2]);Ob=ea(g[Ca>>2]);Pb=ea(Kb+ub);ub=ea(Jb+Ob);Ob=ea(Ib+ea(g[Da>>2]));Qb=ea(g[Fa>>2]);Rb=ea(g[Ga>>2]);Sb=ea(Kb+Qb);Qb=ea(Jb+Rb);Rb=ea(Ib+ea(g[Ha>>2]));Tb=ea(g[Ja>>2]);Ub=ea(g[Ka>>2]);Vb=ea(Kb+Tb);Tb=ea(Jb+Ub);Ub=ea(Ib+ea(g[La>>2]));g[E>>2]=Pb;g[Ca>>2]=ub;g[Da>>2]=Ob;g[Ea>>2]=ea(0.0);g[Fa>>2]=Sb;g[Ga>>2]=Qb;g[Ha>>2]=Rb;g[Ia>>2]=ea(0.0);g[Ja>>2]=Vb;g[Ka>>2]=Tb;g[La>>2]=Ub;g[Ma>>2]=ea(0.0);Ib=ea(g[D>>2]);Jb=ea(g[la>>2]);Kb=ea(Jb-ub);ub=ea(ea(g[ma>>2])-Ob);g[C>>2]=ea(Ib-Pb);g[A>>2]=Kb;g[ja>>2]=ub;g[ia>>2]=ea(0.0);ub=ea(g[Na>>2]);Kb=ea(g[Oa>>2]);Pb=ea(Kb-Qb);Qb=ea(ea(g[Pa>>2])-Rb);g[Qa>>2]=ea(ub-Sb);g[Ra>>2]=Pb;g[Sa>>2]=Qb;g[Ta>>2]=ea(0.0);Qb=ea(g[Ua>>2]);Pb=ea(g[Va>>2]);Sb=ea(Pb-Tb);Tb=ea(ea(g[Wa>>2])-Ub);g[Xa>>2]=ea(Qb-Vb);g[Ya>>2]=Sb;g[Za>>2]=Tb;g[_a>>2]=ea(0.0);HFb(L,b,I);Tb=ea(g[L>>2]);Sb=ea(g[$a>>2]);Vb=ea(vb+Tb);Tb=ea(Lb+Sb);Sb=ea(Hb+ea(g[ab>>2]));Qb=ea(xb-Vb);Ub=ea(tb-Tb);Pb=ea(yb-Sb);g[F>>2]=Qb;g[za>>2]=Ub;g[Aa>>2]=Pb;g[Ba>>2]=ea(0.0);Wb=Vb;Xb=Tb;Yb=Sb;Zb=Qb;_b=Ub;$b=Pb;ac=ea(3402823469999999843913219.0e14);bc=wb;cc=Hb;dc=Lb;ec=vb;fc=X;gc=Z;hc=aa}else{Wb=Db;Xb=Bb;Yb=Cb;Zb=Eb;_b=Fb;$b=Gb;ac=sb;bc=wb;cc=jb;dc=ib;ec=hb;fc=rb;gc=qb;hc=pb}}else{Wb=Db;Xb=Bb;Yb=Cb;Zb=Eb;_b=Fb;$b=Gb;ac=sb;bc=kb;cc=jb;dc=ib;ec=hb;fc=rb;gc=qb;hc=pb}Ab=c[z>>2]|0;g[D+(Ab<<4)>>2]=xb;g[D+(Ab<<4)+4>>2]=tb;g[D+(Ab<<4)+8>>2]=yb;g[D+(Ab<<4)+12>>2]=ea(0.0);g[E+(Ab<<4)>>2]=Wb;g[E+(Ab<<4)+4>>2]=Xb;g[E+(Ab<<4)+8>>2]=Yb;g[E+(Ab<<4)+12>>2]=ea(0.0);c[z>>2]=Ab+1;zb=C+(Ab<<4)|0;c[zb+0>>2]=c[F+0>>2];c[zb+4>>2]=c[F+4>>2];c[zb+8>>2]=c[F+8>>2];c[zb+12>>2]=c[F+12>>2];do if(!Ab){g[G>>2]=xb;g[w>>2]=tb;g[na>>2]=yb;g[ua>>2]=ea(0.0);g[H>>2]=Wb;g[db>>2]=Xb;g[eb>>2]=Yb;g[fb>>2]=ea(0.0);c[M+0>>2]=c[F+0>>2];c[M+4>>2]=c[F+4>>2];c[M+8>>2]=c[F+8>>2];c[M+12>>2]=c[F+12>>2]}else if((Ab|0)==1){Gb=ea(g[C>>2]);Fb=ea(g[A>>2]);Eb=ea(g[ja>>2]);Cb=ea(Zb-Gb);Bb=ea(_b-Fb);Db=ea($b-Eb);wb=ea(ea(ea(Cb*Cb)+ea(Bb*Bb))+ea(Db*Db));if(wb==ea(0.0)){c[z>>2]=1;c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[M+0>>2]=c[C+0>>2];c[M+4>>2]=c[C+4>>2];c[M+8>>2]=c[C+8>>2];c[M+12>>2]=c[C+12>>2];break}else{vb=ea(ea(ea(-ea(Fb*Bb))-ea(Gb*Cb))-ea(Eb*Db));Db=ea(g[D>>2]);Eb=ea(g[la>>2]);Cb=ea(g[ma>>2]);Gb=ea(xb-Db);Bb=ea(tb-Eb);Fb=ea(yb-Cb);Lb=ea(g[E>>2]);Hb=ea(g[Ca>>2]);Pb=ea(g[Da>>2]);Ub=ea(Wb-Lb);Qb=ea(Xb-Hb);Sb=ea(Yb-Pb);Tb=ea(vb/wb);zb=Tb>ea(1.0);wb=zb?ea(1.0):Tb;zb=wb>ea(0.0);Tb=zb?wb:ea(0.0);wb=ea(Db+ea(Gb*Tb));Gb=ea(Eb+ea(Bb*Tb));Bb=ea(Cb+ea(Fb*Tb));Fb=ea(Lb+ea(Ub*Tb));Ub=ea(Hb+ea(Qb*Tb));Qb=ea(Pb+ea(Sb*Tb));g[G>>2]=wb;g[w>>2]=Gb;g[na>>2]=Bb;g[ua>>2]=ea(0.0);g[H>>2]=Fb;g[db>>2]=Ub;g[eb>>2]=Qb;g[fb>>2]=ea(0.0);Tb=ea(Gb-Ub);Ub=ea(Bb-Qb);g[M>>2]=ea(wb-Fb);g[bb>>2]=Tb;g[cb>>2]=Ub;g[gb>>2]=ea(0.0);break}}else if((Ab|0)==2)V6a(M,C,ka,F,C,D,E,z,G,H);else if((Ab|0)==3)pPa(M,C,D,E,z,G,H);else{c[M+0>>2]=c[F+0>>2];c[M+4>>2]=c[F+4>>2];c[M+8>>2]=c[F+8>>2];c[M+12>>2]=c[F+12>>2]}while(0);yb=ea(g[M>>2]);tb=ea(g[bb>>2]);xb=ea(g[cb>>2]);Ub=ea(-yb);Tb=ea(-tb);Fb=ea(-xb);wb=ea(ea(ea(yb*yb)+ea(tb*tb))+ea(xb*xb));Ab=ac>wb;zb=Ab<<31>>31;if(!(wb>ta)){ic=bc;jc=lb;kc=mb;lc=nb;mc=ob;nc=Fb;oc=Tb;pc=Ub;qc=wb;rc=zb;sc=fc;tc=gc;uc=hc;break a}if(!Ab){ic=bc;jc=lb;kc=mb;lc=nb;mc=ob;nc=Fb;oc=Tb;pc=Ub;qc=wb;rc=zb;sc=fc;tc=gc;uc=hc;break a}xb=ea(g[G>>2]);tb=ea(g[w>>2]);yb=ea(g[na>>2]);aa=Ub;Z=Tb;X=Fb;hb=ec;ib=dc;jb=cc;kb=bc;lb=ea(g[ua>>2]);mb=yb;nb=tb;ob=xb;pb=hc;qb=gc;rb=fc;sb=wb}if((Nb|0)==22){i=d;return Mb|0}}else{ic=ea(0.0);jc=ea(0.0);kc=_;lc=Y;mc=$;nc=qa;oc=pa;pc=oa;qc=sa;rc=-1;sc=qa;tc=pa;uc=oa}while(0);Nb=c[a+64>>2]|0;M=c[a+68>>2]|0;F=c[a+72>>2]|0;if(qc>ra)vc=(rc|0)==0?q:r;else vc=q;g[r>>2]=pc;g[r+4>>2]=oc;g[r+8>>2]=nc;g[r+12>>2]=ea(0.0);g[q>>2]=uc;g[q+4>>2]=tc;g[q+8>>2]=sc;g[q+12>>2]=ea(0.0);sc=ea(g[vc>>2]);tc=ea(g[vc+4>>2]);uc=ea(g[vc+8>>2]);nc=ea(ea(1.0)/ea(T(ea(ea(ea(sc*sc)+ea(tc*tc))+ea(uc*uc)))));oc=ea(-ea(sc*nc));sc=ea(-ea(tc*nc));tc=ea(-ea(uc*nc));g[j>>2]=oc;g[j+4>>2]=sc;g[j+8>>2]=tc;g[j+12>>2]=ea(0.0);g[h>>2]=ic;j=h+4|0;c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[t+0>>2]=c[G+0>>2];c[t+4>>2]=c[G+4>>2];c[t+8>>2]=c[G+8>>2];c[t+12>>2]=c[G+12>>2];g[s>>2]=mc;g[s+4>>2]=lc;g[s+8>>2]=kc;g[s+12>>2]=jc;y=(rc|0)==0?s:t;jc=ea(g[y>>2]);kc=ea(g[y+4>>2]);lc=ea(g[y+8>>2]);g[G>>2]=jc;g[w>>2]=kc;g[na>>2]=lc;g[ua>>2]=ea(0.0);mc=ea(g[a+16>>2]);ic=ea(jc-ea(mc*oc));oc=ea(kc-ea(mc*sc));sc=ea(lc-ea(mc*tc));c[u+0>>2]=c[G+0>>2];c[u+4>>2]=c[G+4>>2];c[u+8>>2]=c[G+8>>2];c[u+12>>2]=c[G+12>>2];g[v>>2]=ic;g[v+4>>2]=oc;g[v+8>>2]=sc;g[v+12>>2]=ea(0.0);sc=ea(g[((Nb|0)==0?u:v)>>2]);oc=ea(g[((M|0)==0?u:v)+4>>2]);ic=ea(g[((F|0)==0?u:v)+8>>2]);g[k>>2]=sc;g[k+4>>2]=oc;g[k+8>>2]=ic;g[k+12>>2]=ea(0.0);Mb=1;i=d;return Mb|0}function PFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=0,R=Im,S=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=0,ba=Im,ca=Im,da=0,fa=0,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=0,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=0,Mb=0,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=0,nc=Im,oc=Im,pc=Im,qc=0;e=i;i=i+560|0;n=e+496|0;o=e+16|0;p=e;q=e+448|0;r=e+192|0;s=e+64|0;t=e+80|0;u=e+96|0;v=e+400|0;w=e+432|0;x=e+464|0;y=e+512|0;z=e+536|0;A=e+548|0;B=e+256|0;C=e+32|0;D=e+272|0;E=e+112|0;F=e+336|0;G=e+48|0;H=e+176|0;I=e+416|0;J=e+208|0;K=e+240|0;L=e+224|0;M=e+524|0;N=e+480|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];O=ea(g[h>>2]);y=h+4|0;P=ea(g[y>>2]);Q=h+8|0;R=ea(g[Q>>2]);S=ea(g[f>>2]);U=f+4|0;V=ea(g[U>>2]);W=f+8|0;X=ea(g[W>>2]);c[A>>2]=1;Y=d+48|0;Z=ea(g[d+48>>2]);_=ea(g[d+52>>2]);$=ea(g[d+56>>2]);aa=ea(ea(ea(Z*Z)+ea(_*_))+ea($*$))>ea(1.1920929e-07);c[o+0>>2]=c[Y+0>>2];c[o+4>>2]=c[Y+4>>2];c[o+8>>2]=c[Y+8>>2];c[o+12>>2]=c[Y+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);Y=aa?o:n;$=ea(g[Y>>2]);_=ea(g[Y+4>>2]);Z=ea(g[Y+8>>2]);ba=ea(ea(1.0)/ea(T(ea(ea(ea($*$)+ea(_*_))+ea(Z*Z)))));ca=ea($*ba);$=ea(_*ba);_=ea(Z*ba);ba=ea(-$);Z=ea(-_);g[C>>2]=ea(-ca);g[C+4>>2]=ba;g[C+8>>2]=Z;g[C+12>>2]=ea(0.0);IFb(B,a,C,d);C=ca>ea(0.0);Y=$>ea(0.0);n=_>ea(0.0);o=b+144|0;c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];c[q+12>>2]=c[o+12>>2];aa=b+144|0;_=ea(g[aa>>2]);da=b+148|0;$=ea(g[da>>2]);fa=b+152|0;ca=ea(-$);$=ea(-ea(g[fa>>2]));g[p>>2]=ea(-_);g[p+4>>2]=ca;g[p+8>>2]=$;g[p+12>>2]=ea(0.0);$=ea(g[(C?q:p)>>2]);ca=ea(g[(Y?q:p)+4>>2]);_=ea(g[(n?q:p)+8>>2]);Z=ea(g[B>>2]);ba=ea(g[B+4>>2]);ga=ea(Z-$);Z=ea(ba-ca);ba=ea(ea(g[B+8>>2])-_);g[D>>2]=ga;n=D+4|0;g[n>>2]=Z;Y=D+8|0;g[Y>>2]=ba;C=D+12|0;g[C>>2]=ea(0.0);ha=D+16|0;c[ha+0>>2]=c[x+0>>2];c[ha+4>>2]=c[x+4>>2];c[ha+8>>2]=c[x+8>>2];c[ha+12>>2]=c[x+12>>2];ia=D+32|0;c[ia+0>>2]=c[x+0>>2];c[ia+4>>2]=c[x+4>>2];c[ia+8>>2]=c[x+8>>2];c[ia+12>>2]=c[x+12>>2];ia=D+48|0;c[ia+0>>2]=c[x+0>>2];c[ia+4>>2]=c[x+4>>2];c[ia+8>>2]=c[x+8>>2];c[ia+12>>2]=c[x+12>>2];c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];ia=E+16|0;c[ia+0>>2]=c[x+0>>2];c[ia+4>>2]=c[x+4>>2];c[ia+8>>2]=c[x+8>>2];c[ia+12>>2]=c[x+12>>2];ia=E+32|0;c[ia+0>>2]=c[x+0>>2];c[ia+4>>2]=c[x+4>>2];c[ia+8>>2]=c[x+8>>2];c[ia+12>>2]=c[x+12>>2];ia=E+48|0;c[ia+0>>2]=c[x+0>>2];c[ia+4>>2]=c[x+4>>2];c[ia+8>>2]=c[x+8>>2];c[ia+12>>2]=c[x+12>>2];g[F>>2]=$;ia=F+4|0;g[ia>>2]=ca;ja=F+8|0;g[ja>>2]=_;ka=F+12|0;g[ka>>2]=ea(0.0);la=F+16|0;c[la+0>>2]=c[x+0>>2];c[la+4>>2]=c[x+4>>2];c[la+8>>2]=c[x+8>>2];c[la+12>>2]=c[x+12>>2];la=F+32|0;c[la+0>>2]=c[x+0>>2];c[la+4>>2]=c[x+4>>2];c[la+8>>2]=c[x+8>>2];c[la+12>>2]=c[x+12>>2];la=F+48|0;c[la+0>>2]=c[x+0>>2];c[la+4>>2]=c[x+4>>2];c[la+8>>2]=c[x+8>>2];c[la+12>>2]=c[x+12>>2];ma=ea(-ga);na=ea(-Z);oa=ea(-ba);c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];pa=ea(g[a+32>>2]);qa=ea(g[b+32>>2]);ra=ea((pa>qa?qa:pa)*ea(.100000001));pa=ea(ra*ra);ra=ea(ea(m*m)+pa);c[H+0>>2]=c[B+0>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];c[H+12>>2]=c[B+12>>2];g[I>>2]=$;b=I+4|0;g[b>>2]=ca;x=I+8|0;g[x>>2]=_;la=I+12|0;g[la>>2]=ea(0.0);_=ea(ea(ea(ga*ga)+ea(Z*Z))+ea(ba*ba));c[J+0>>2]=c[B+0>>2];c[J+4>>2]=c[B+4>>2];c[J+8>>2]=c[B+8>>2];c[J+12>>2]=c[B+12>>2];a:do if(_>pa){B=K+4|0;sa=K+8|0;ta=K+12|0;ua=L+4|0;va=L+8|0;wa=L+12|0;xa=p+4|0;ya=p+8|0;za=p+12|0;Aa=G+4|0;Ba=G+8|0;Ca=G+12|0;Da=F+16|0;Ea=F+20|0;Fa=F+24|0;Ga=F+28|0;Ha=F+32|0;Ia=F+36|0;Ja=F+40|0;Ka=F+44|0;La=E+4|0;Ma=E+8|0;Na=E+16|0;Oa=E+20|0;Pa=E+24|0;Qa=D+16|0;Ra=D+20|0;Sa=D+24|0;Ta=D+28|0;Ua=E+32|0;Va=E+36|0;Wa=E+40|0;Xa=D+32|0;Ya=D+36|0;Za=D+40|0;_a=D+44|0;$a=p+4|0;ab=p+8|0;bb=p+12|0;cb=N+4|0;db=N+8|0;eb=H+4|0;fb=H+8|0;gb=H+12|0;hb=N+12|0;ba=ma;Z=na;ga=oa;ca=ea(ea(O*ea(0.0))+S);$=ea(ea(P*ea(0.0))+V);qa=ea(ea(R*ea(0.0))+X);ib=ea(0.0);jb=ma;kb=na;lb=oa;mb=_;while(1){c[J+0>>2]=c[H+0>>2];c[J+4>>2]=c[H+4>>2];c[J+8>>2]=c[H+8>>2];c[J+12>>2]=c[H+12>>2];nb=ea(ea(1.0)/ea(T(ea(ea(ga*ga)+ea(ea(Z*Z)+ea(ba*ba))))));ob=ea(ba*nb);pb=ea(Z*nb);qb=ea(ga*nb);g[K>>2]=ob;g[B>>2]=pb;g[sa>>2]=qb;g[ta>>2]=ea(0.0);IFb(L,a,K,d);nb=ea(g[L>>2]);rb=ea(g[ua>>2]);sb=ea(g[va>>2]);tb=ea(g[wa>>2]);ub=ob<ea(-0.0);vb=pb<ea(-0.0);wb=qb<ea(-0.0);c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];c[q+12>>2]=c[o+12>>2];qb=ea(g[aa>>2]);pb=ea(g[da>>2]);ob=ea(-qb);qb=ea(-pb);pb=ea(-ea(g[fa>>2]));g[p>>2]=ob;g[xa>>2]=qb;g[ya>>2]=pb;g[za>>2]=ea(0.0);xb=ea(g[(ub?q:p)>>2]);yb=ea(g[(vb?q:p)+4>>2]);zb=ea(ca+xb);xb=ea($+yb);yb=ea(qa+ea(g[(wb?q:p)+8>>2]));Ab=ea(nb-zb);Bb=ea(rb-xb);Cb=ea(sb-yb);g[G>>2]=Ab;g[Aa>>2]=Bb;g[Ba>>2]=Cb;g[Ca>>2]=ea(0.0);Db=ea(g[K>>2]);Eb=ea(g[B>>2]);Fb=ea(g[sa>>2]);Gb=ea(ea(ea(ea(-ea(Bb*Eb))-ea(Ab*Db))-ea(Cb*Fb))-m);Hb=ea(g[h>>2]);Ib=ea(g[y>>2]);Jb=ea(g[Q>>2]);Kb=ea(ea(ea(Db*Hb)+ea(Eb*Ib))+ea(Fb*Jb));if(Gb>ea(0.0)){if(Kb>=ea(0.0)){Lb=0;Mb=21;break}Fb=ea(ib-ea(Gb/Kb));c[z+0>>2]=c[M+0>>2];c[z+4>>2]=c[M+4>>2];c[z+8>>2]=c[M+8>>2];if(Fb>ib){if(Fb>ea(1.0)){Lb=0;Mb=21;break}Kb=ea(g[f>>2]);Gb=ea(g[U>>2]);Eb=ea(ea(Fb*Hb)+Kb);Kb=ea(ea(Fb*Ib)+Gb);Gb=ea(ea(Fb*Jb)+ea(g[W>>2]));Jb=ea(Eb-ca);Ib=ea(Kb-$);Hb=ea(Gb-qa);Db=ea(g[F>>2]);Nb=ea(g[ia>>2]);Ob=ea(Jb+Db);Db=ea(Ib+Nb);Nb=ea(Hb+ea(g[ja>>2]));Pb=ea(g[Da>>2]);Qb=ea(g[Ea>>2]);Rb=ea(Jb+Pb);Pb=ea(Ib+Qb);Qb=ea(Hb+ea(g[Fa>>2]));Sb=ea(g[Ha>>2]);Tb=ea(g[Ia>>2]);Ub=ea(Jb+Sb);Sb=ea(Ib+Tb);Tb=ea(Hb+ea(g[Ja>>2]));g[F>>2]=Ob;g[ia>>2]=Db;g[ja>>2]=Nb;g[ka>>2]=ea(0.0);g[Da>>2]=Rb;g[Ea>>2]=Pb;g[Fa>>2]=Qb;g[Ga>>2]=ea(0.0);g[Ha>>2]=Ub;g[Ia>>2]=Sb;g[Ja>>2]=Tb;g[Ka>>2]=ea(0.0);Hb=ea(g[E>>2]);Ib=ea(g[La>>2]);Jb=ea(Ib-Db);Db=ea(ea(g[Ma>>2])-Nb);g[D>>2]=ea(Hb-Ob);g[n>>2]=Jb;g[Y>>2]=Db;g[C>>2]=ea(0.0);Db=ea(g[Na>>2]);Jb=ea(g[Oa>>2]);Ob=ea(Jb-Pb);Pb=ea(ea(g[Pa>>2])-Qb);g[Qa>>2]=ea(Db-Rb);g[Ra>>2]=Ob;g[Sa>>2]=Pb;g[Ta>>2]=ea(0.0);Pb=ea(g[Ua>>2]);Ob=ea(g[Va>>2]);Rb=ea(Ob-Sb);Sb=ea(ea(g[Wa>>2])-Tb);g[Xa>>2]=ea(Pb-Ub);g[Ya>>2]=Rb;g[Za>>2]=Sb;g[_a>>2]=ea(0.0);c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];c[q+12>>2]=c[o+12>>2];g[p>>2]=ob;g[$a>>2]=qb;g[ab>>2]=pb;g[bb>>2]=ea(0.0);pb=ea(g[(ub?q:p)>>2]);qb=ea(g[(vb?q:p)+4>>2]);ob=ea(Eb+pb);pb=ea(Kb+qb);qb=ea(Gb+ea(g[(wb?q:p)+8>>2]));Sb=ea(nb-ob);Rb=ea(rb-pb);Ub=ea(sb-qb);g[G>>2]=Sb;g[Aa>>2]=Rb;g[Ba>>2]=Ub;g[Ca>>2]=ea(0.0);Vb=ob;Wb=pb;Xb=qb;Yb=Sb;Zb=Rb;_b=Ub;$b=ea(3402823469999999843913219.0e14);ac=Fb;bc=Gb;cc=Kb;dc=Eb;ec=ga;fc=Z;gc=ba}else{Vb=zb;Wb=xb;Xb=yb;Yb=Ab;Zb=Bb;_b=Cb;$b=mb;ac=Fb;bc=qa;cc=$;dc=ca;ec=lb;fc=kb;gc=jb}}else{Vb=zb;Wb=xb;Xb=yb;Yb=Ab;Zb=Bb;_b=Cb;$b=mb;ac=ib;bc=qa;cc=$;dc=ca;ec=lb;fc=kb;gc=jb}wb=c[A>>2]|0;g[E+(wb<<4)>>2]=nb;g[E+(wb<<4)+4>>2]=rb;g[E+(wb<<4)+8>>2]=sb;g[E+(wb<<4)+12>>2]=tb;g[F+(wb<<4)>>2]=Vb;g[F+(wb<<4)+4>>2]=Wb;g[F+(wb<<4)+8>>2]=Xb;g[F+(wb<<4)+12>>2]=ea(0.0);c[A>>2]=wb+1;vb=D+(wb<<4)|0;c[vb+0>>2]=c[G+0>>2];c[vb+4>>2]=c[G+4>>2];c[vb+8>>2]=c[G+8>>2];c[vb+12>>2]=c[G+12>>2];do if(!wb){g[H>>2]=nb;g[eb>>2]=rb;g[fb>>2]=sb;g[gb>>2]=tb;g[I>>2]=Vb;g[b>>2]=Wb;g[x>>2]=Xb;g[la>>2]=ea(0.0);c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}else if((wb|0)==2)V6a(N,D,ha,G,D,E,F,A,H,I);else if((wb|0)==3)pPa(N,D,E,F,A,H,I);else if((wb|0)==1){Cb=ea(g[D>>2]);Bb=ea(g[n>>2]);Ab=ea(g[Y>>2]);yb=ea(Yb-Cb);xb=ea(Zb-Bb);zb=ea(_b-Ab);Fb=ea(ea(ea(yb*yb)+ea(xb*xb))+ea(zb*zb));if(Fb==ea(0.0)){c[A>>2]=1;c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[N+0>>2]=c[D+0>>2];c[N+4>>2]=c[D+4>>2];c[N+8>>2]=c[D+8>>2];c[N+12>>2]=c[D+12>>2];break}else{Eb=ea(ea(ea(-ea(Bb*xb))-ea(Cb*yb))-ea(Ab*zb));zb=ea(g[E>>2]);Ab=ea(g[La>>2]);yb=ea(g[Ma>>2]);Cb=ea(nb-zb);xb=ea(rb-Ab);Bb=ea(sb-yb);Kb=ea(g[F>>2]);Gb=ea(g[ia>>2]);Ub=ea(g[ja>>2]);Rb=ea(Vb-Kb);Sb=ea(Wb-Gb);qb=ea(Xb-Ub);pb=ea(Eb/Fb);vb=pb>ea(1.0);Fb=vb?ea(1.0):pb;vb=Fb>ea(0.0);pb=vb?Fb:ea(0.0);Fb=ea(zb+ea(Cb*pb));Cb=ea(Ab+ea(xb*pb));xb=ea(yb+ea(Bb*pb));Bb=ea(Kb+ea(Rb*pb));Rb=ea(Gb+ea(Sb*pb));Sb=ea(Ub+ea(qb*pb));g[H>>2]=Fb;g[eb>>2]=Cb;g[fb>>2]=xb;g[gb>>2]=ea(0.0);g[I>>2]=Bb;g[b>>2]=Rb;g[x>>2]=Sb;g[la>>2]=ea(0.0);pb=ea(Cb-Rb);Rb=ea(xb-Sb);g[N>>2]=ea(Fb-Bb);g[cb>>2]=pb;g[db>>2]=Rb;g[hb>>2]=ea(0.0);break}}else{c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}while(0);sb=ea(g[N>>2]);rb=ea(g[cb>>2]);nb=ea(g[db>>2]);tb=ea(-sb);Rb=ea(-rb);pb=ea(-nb);Bb=ea(ea(ea(sb*sb)+ea(rb*rb))+ea(nb*nb));wb=$b>Bb;vb=wb<<31>>31;if(!(Bb>ra)){hc=ac;ic=pb;jc=Rb;kc=tb;lc=Bb;mc=vb;nc=ec;oc=fc;pc=gc;break a}if(wb){ba=tb;Z=Rb;ga=pb;ca=dc;$=cc;qa=bc;ib=ac;jb=gc;kb=fc;lb=ec;mb=Bb}else{hc=ac;ic=pb;jc=Rb;kc=tb;lc=Bb;mc=vb;nc=ec;oc=fc;pc=gc;break a}}if((Mb|0)==21){i=e;return Lb|0}}else{hc=ea(0.0);ic=oa;jc=na;kc=ma;lc=_;mc=-1;nc=oa;oc=na;pc=ma}while(0);Mb=c[a+64>>2]|0;N=c[a+68>>2]|0;G=c[a+72>>2]|0;if(lc>pa)qc=(mc|0)==0?r:s;else qc=r;g[s>>2]=kc;g[s+4>>2]=jc;g[s+8>>2]=ic;g[s+12>>2]=ea(0.0);g[r>>2]=pc;g[r+4>>2]=oc;g[r+8>>2]=nc;g[r+12>>2]=ea(0.0);nc=ea(g[qc>>2]);oc=ea(g[qc+4>>2]);pc=ea(g[qc+8>>2]);ic=ea(ea(1.0)/ea(T(ea(ea(ea(nc*nc)+ea(oc*oc))+ea(pc*pc)))));jc=ea(-ea(nc*ic));nc=ea(-ea(oc*ic));oc=ea(-ea(pc*ic));g[k>>2]=jc;g[k+4>>2]=nc;g[k+8>>2]=oc;g[k+12>>2]=ea(0.0);g[j>>2]=hc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[H+0>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];c[u+12>>2]=c[H+12>>2];c[t+0>>2]=c[J+0>>2];c[t+4>>2]=c[J+4>>2];c[t+8>>2]=c[J+8>>2];c[t+12>>2]=c[J+12>>2];J=(mc|0)==0?t:u;hc=ea(g[J>>2]);ic=ea(g[J+4>>2]);pc=ea(g[J+8>>2]);g[H>>2]=hc;g[H+4>>2]=ic;g[H+8>>2]=pc;g[H+12>>2]=ea(0.0);kc=ea(g[a+16>>2]);pa=ea(hc-ea(kc*jc));jc=ea(ic-ea(kc*nc));nc=ea(pc-ea(kc*oc));c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];g[w>>2]=pa;g[w+4>>2]=jc;g[w+8>>2]=nc;g[w+12>>2]=ea(0.0);nc=ea(g[((Mb|0)==0?v:w)>>2]);jc=ea(g[((N|0)==0?v:w)+4>>2]);pa=ea(g[((G|0)==0?v:w)+8>>2]);g[l>>2]=nc;g[l+4>>2]=jc;g[l+8>>2]=pa;g[l+12>>2]=ea(0.0);Lb=1;i=e;return Lb|0}function QFb(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=0,eb=0,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=0,Ub=0,Vb=0,Wb=0;q=i;i=i+528|0;r=q+272|0;s=q+400|0;t=q+304|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+416|0;y=q+440|0;z=q+336|0;A=q+128|0;B=q+192|0;C=q+456|0;D=q+472|0;E=q+488|0;F=q+256|0;G=q+80|0;H=q+112|0;I=q+16|0;J=q;K=q+32|0;L=q+320|0;M=q+428|0;N=q+288|0;O=q+492|0;P=q+504|0;Q=ea(g[b+16>>2]);R=e+16|0;S=ea(g[R>>2]);U=ea(g[h>>2]);V=ea(g[b+32>>2]);W=ea(g[e+32>>2]);X=ea((V>W?W:V)*ea(.100000001));V=ea(Q+S);h=v+4|0;Y=v+8|0;Z=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;_=w+4|0;$=w+8|0;aa=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];W=ea(X*X);c[E>>2]=0;ba=a[p>>0]|0;if(!(ba<<24>>24)){X=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(ea(ea(X*X)+ea(ca*ca))+ea(da*da))>ea(0.0);g[u>>2]=X;g[u+4>>2]=ca;g[u+8>>2]=da;g[u+12>>2]=fa;g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ha=ga?u:t;fa=ea(g[ha>>2]);da=ea(g[ha+4>>2]);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(3402823469999999843913219.0e14);ra=1;sa=ea(g[ha+8>>2]);ta=da;ua=fa}else{ha=F+4|0;t=F+8|0;u=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;ga=G+4|0;va=G+8|0;wa=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;xa=H+4|0;ya=H+8|0;za=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;fa=ea(g[f+48>>2]);da=ea(g[f+52>>2]);ca=ea(g[f+56>>2]);X=ea(g[f>>2]);Aa=ea(g[f+16>>2]);Ba=ea(g[f+32>>2]);Ca=ea(g[f+4>>2]);Da=ea(g[f+20>>2]);Ea=ea(g[f+36>>2]);Fa=ea(g[f+8>>2]);Ga=ea(g[f+24>>2]);Ha=ea(g[f+40>>2]);Ia=ea(g[e+144>>2]);Ja=ea(g[e+148>>2]);Ka=ea(Ia-S);Ia=ea(Ja-S);Ja=ea(ea(g[e+152>>2])-S);La=ea(-Ka);Ma=ea(-Ia);Na=ea(-Ja);Oa=s+4|0;Pa=s+8|0;Qa=s+12|0;Ra=r+4|0;Sa=r+8|0;Ta=r+12|0;Ua=ba&255;ba=Ua>>>0>1?Ua:1;Va=0;Wa=0;while(1){Xa=d[n+Wa>>0]|0;c[C+(Wa<<2)>>2]=Xa;Ya=d[o+Wa>>0]|0;c[D+(Wa<<2)>>2]=Ya;Za=ea(g[b+(Xa<<4)+96>>2]);_a=ea(g[b+(Xa<<4)+100>>2]);$a=ea(g[b+(Xa<<4)+104>>2]);ab=ea(fa+ea(ea(ea(Za*X)+ea(_a*Aa))+ea($a*Ba)));bb=ea(da+ea(ea(ea(Za*Ca)+ea(_a*Da))+ea($a*Ea)));cb=ea(ca+ea(ea(ea(Za*Fa)+ea(_a*Ga))+ea($a*Ha)));Xa=c[540320+(Ya<<4)>>2]|0;db=c[540324+(Ya<<4)>>2]|0;eb=c[540328+(Ya<<4)>>2]|0;g[s>>2]=Ka;g[Oa>>2]=Ia;g[Pa>>2]=Ja;g[Qa>>2]=ea(0.0);g[r>>2]=La;g[Ra>>2]=Ma;g[Sa>>2]=Na;g[Ta>>2]=ea(0.0);fb=ea(g[((Xa|0)==0?r:s)>>2]);gb=ea(g[((db|0)==0?r:s)+4>>2]);hb=ea(g[((eb|0)==0?r:s)+8>>2]);ib=ea(ab-fb);jb=ea(bb-gb);kb=ea(cb-hb);eb=A+(Va<<4)|0;g[G>>2]=ab;g[ga>>2]=bb;g[va>>2]=cb;g[wa>>2]=ea(0.0);c[eb+0>>2]=c[G+0>>2];c[eb+4>>2]=c[G+4>>2];c[eb+8>>2]=c[G+8>>2];c[eb+12>>2]=c[G+12>>2];eb=B+(Va<<4)|0;g[H>>2]=fb;g[xa>>2]=gb;g[ya>>2]=hb;g[za>>2]=ea(0.0);c[eb+0>>2]=c[H+0>>2];c[eb+4>>2]=c[H+4>>2];c[eb+8>>2]=c[H+8>>2];c[eb+12>>2]=c[H+12>>2];eb=z+(Va<<4)|0;g[F>>2]=ib;g[ha>>2]=jb;g[t>>2]=kb;g[u>>2]=ea(0.0);c[eb+0>>2]=c[F+0>>2];c[eb+4>>2]=c[F+4>>2];c[eb+8>>2]=c[F+8>>2];c[eb+12>>2]=c[F+12>>2];Wa=Wa+1|0;if(Wa>>>0>=Ua>>>0)break;else Va=Va+1|0}c[E>>2]=ba;do if((ba|0)==3)V6a(I,z,z+16|0,F,z,A,B,E,v,w);else if((ba|0)==1){c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}else if((ba|0)==2){Na=ea(g[z>>2]);Ma=ea(g[z+4>>2]);La=ea(g[z+8>>2]);Ja=ea(ib-Na);Ia=ea(jb-Ma);Ka=ea(kb-La);Ha=ea(ea(ea(Ja*Ja)+ea(Ia*Ia))+ea(Ka*Ka));if(Ha==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[I+0>>2]=c[z+0>>2];c[I+4>>2]=c[z+4>>2];c[I+8>>2]=c[z+8>>2];c[I+12>>2]=c[z+12>>2];break}else{Ga=ea(ea(ea(-ea(Ma*Ia))-ea(Na*Ja))-ea(La*Ka));Ka=ea(g[A>>2]);La=ea(g[A+4>>2]);Ja=ea(g[A+8>>2]);Na=ea(ab-Ka);Ia=ea(bb-La);Ma=ea(cb-Ja);Fa=ea(g[B>>2]);ca=ea(g[B+4>>2]);Ea=ea(g[B+8>>2]);Da=ea(fb-Fa);Ca=ea(gb-ca);da=ea(hb-Ea);Ba=ea(Ga/Ha);Va=Ba>ea(1.0);Ha=Va?ea(1.0):Ba;Va=Ha>ea(0.0);Ba=Va?Ha:ea(0.0);Ha=ea(Ka+ea(Na*Ba));Na=ea(La+ea(Ia*Ba));Ia=ea(Ja+ea(Ma*Ba));Ma=ea(Fa+ea(Da*Ba));Da=ea(ca+ea(Ca*Ba));Ca=ea(Ea+ea(da*Ba));g[v>>2]=Ha;g[h>>2]=Na;g[Y>>2]=Ia;g[Z>>2]=ea(0.0);g[w>>2]=Ma;g[_>>2]=Da;g[$>>2]=Ca;g[aa>>2]=ea(0.0);Ba=ea(Na-Da);Da=ea(Ia-Ca);g[I>>2]=ea(Ha-Ma);g[I+4>>2]=Ba;g[I+8>>2]=Da;g[I+12>>2]=ea(0.0);break}}else if((ba|0)==4)qPa(I,z,A,B,C,D,F,G,H,E,v,w);else{c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}while(0);hb=ea(g[I>>2]);gb=ea(g[I+4>>2]);fb=ea(g[I+8>>2]);cb=ea(ea(ea(hb*hb)+ea(gb*gb))+ea(fb*fb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];bb=ea(g[v>>2]);ab=ea(g[h>>2]);kb=ea(g[Y>>2]);jb=ea(g[Z>>2]);ib=ea(g[w>>2]);Da=ea(g[_>>2]);Ba=ea(g[$>>2]);ia=jb;ja=kb;ka=ab;la=bb;ma=ea(g[aa>>2]);na=Ba;oa=Da;pa=ib;qa=cb;ra=cb>W;sa=fb;ta=gb;ua=hb}do if(ra){I=f+4|0;F=f+8|0;H=f+16|0;G=f+20|0;ba=f+24|0;Va=f+32|0;Ua=f+36|0;Wa=f+40|0;u=r+4|0;t=r+8|0;ha=r+12|0;za=f+48|0;ya=f+52|0;xa=f+56|0;wa=s+4|0;va=s+8|0;ga=J+4|0;Ta=J+8|0;Sa=J+12|0;Ra=e+144|0;Qa=e+148|0;Pa=e+152|0;Oa=s+4|0;eb=s+8|0;db=s+12|0;Xa=r+4|0;Ya=r+8|0;lb=r+12|0;mb=K+4|0;nb=K+8|0;ob=K+12|0;pb=L+4|0;qb=L+8|0;rb=L+12|0;sb=b+48|0;tb=e+48|0;ub=N+4|0;vb=N+8|0;wb=z+4|0;xb=z+8|0;yb=A+4|0;zb=A+8|0;Ab=B+4|0;Bb=B+8|0;Cb=N+12|0;Db=z+16|0;hb=U;gb=ua;fb=ta;cb=sa;ib=qa;Da=la;Ba=ka;bb=ja;ab=ia;kb=pa;jb=oa;Ma=na;Ha=ma;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Ca=ea(-gb);Ia=ea(-fb);Na=ea(-cb);Eb=c[E>>2]|0;Fb=A+(Eb<<4)|0;da=ea(ea(g[f>>2])*Ca);Ea=ea(da+ea(ea(g[I>>2])*Ia));da=ea(Ea+ea(ea(g[F>>2])*Na));Ea=ea(ea(g[H>>2])*Ca);ca=ea(Ea+ea(ea(g[G>>2])*Ia));Ea=ea(ca+ea(ea(g[ba>>2])*Na));ca=ea(ea(g[Va>>2])*Ca);Ca=ea(ca+ea(ea(g[Ua>>2])*Ia));Ia=ea(Ca+ea(ea(g[Wa>>2])*Na));g[r>>2]=da;g[u>>2]=Ea;g[t>>2]=Ia;g[ha>>2]=ea(0.0);FFb(s,b,r,C+(Eb<<2)|0);c[Fb+0>>2]=c[s+0>>2];c[Fb+4>>2]=c[s+4>>2];c[Fb+8>>2]=c[s+8>>2];c[Fb+12>>2]=c[s+12>>2];Ia=ea(g[za>>2]);Ea=ea(g[ya>>2]);da=ea(g[xa>>2]);Na=ea(g[s>>2]);Ca=ea(g[wa>>2]);ca=ea(g[va>>2]);Fa=ea(Na*ea(g[f>>2]));Ja=ea(Fa+ea(Ca*ea(g[H>>2])));Fa=ea(Ja+ea(ca*ea(g[Va>>2])));Ja=ea(Na*ea(g[I>>2]));La=ea(Ja+ea(Ca*ea(g[G>>2])));Ja=ea(La+ea(ca*ea(g[Ua>>2])));La=ea(Na*ea(g[F>>2]));Na=ea(La+ea(Ca*ea(g[ba>>2])));Ca=ea(Ia+Fa);Fa=ea(Ea+Ja);Ja=ea(da+ea(Na+ea(ca*ea(g[Wa>>2]))));g[J>>2]=Ca;g[ga>>2]=Fa;g[Ta>>2]=Ja;g[Sa>>2]=ea(0.0);Gb=c[E>>2]|0;Fb=B+(Gb<<4)|0;ca=ea(g[Ra>>2]);Na=ea(g[Qa>>2]);da=ea(g[Pa>>2]);Ea=ea(g[R>>2]);Ia=ea(ca-Ea);ca=ea(Na-Ea);Na=ea(da-Ea);Eb=gb>ea(0.0);Hb=fb>ea(0.0);Ib=cb>ea(0.0);c[D+(Gb<<2)>>2]=Ib<<31>>31<<2&4|Eb&1|Hb<<31>>31<<1&2;Ea=ea(-Ia);da=ea(-ca);La=ea(-Na);g[s>>2]=Ia;g[Oa>>2]=ca;g[eb>>2]=Na;g[db>>2]=ea(0.0);g[r>>2]=Ea;g[Xa>>2]=da;g[Ya>>2]=La;g[lb>>2]=ea(0.0);La=ea(g[(Eb?s:r)>>2]);da=ea(g[(Hb?s:r)+4>>2]);Ea=ea(g[(Ib?s:r)+8>>2]);g[K>>2]=La;g[mb>>2]=da;g[nb>>2]=Ea;g[ob>>2]=ea(0.0);c[Fb+0>>2]=c[K+0>>2];c[Fb+4>>2]=c[K+4>>2];c[Fb+8>>2]=c[K+8>>2];c[Fb+12>>2]=c[K+12>>2];Na=ea(Ca-La);ca=ea(Fa-da);Ia=ea(Ja-Ea);g[L>>2]=Na;g[pb>>2]=ca;g[qb>>2]=Ia;g[rb>>2]=ea(0.0);c[E>>2]=Gb+1;Fb=z+(Gb<<4)|0;c[Fb+0>>2]=c[L+0>>2];c[Fb+4>>2]=c[L+4>>2];c[Fb+8>>2]=c[L+8>>2];c[Fb+12>>2]=c[L+12>>2];Ka=ea(g[sb>>2]);Ga=ea(g[tb>>2]);Aa=Ka>Ga?Ka:Ga;Ga=hb>Aa?hb:Aa;Aa=ea(V+Ga);Ka=ea(ea(ea(gb*Na)+ea(fb*ca))+ea(cb*Ia));Fb=ea(Ka*Ka)>ea(ib*ea(Aa*Aa));if(Ka>ea(0.0)){Jb=Fb;Kb=Fb^1}else{Jb=0;Kb=1}Fb=ea(W*ib)>=ea(ib-Ka);if((Fb|Jb)&(Fb|Kb^1))break;do if(!Gb){c[v+0>>2]=c[J+0>>2];c[v+4>>2]=c[J+4>>2];c[v+8>>2]=c[J+8>>2];c[v+12>>2]=c[J+12>>2];c[w+0>>2]=c[K+0>>2];c[w+4>>2]=c[K+4>>2];c[w+8>>2]=c[K+8>>2];c[w+12>>2]=c[K+12>>2];c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}else if((Gb|0)==3)qPa(N,z,A,B,C,D,L,J,K,E,v,w);else if((Gb|0)==1){Ka=ea(g[z>>2]);Aa=ea(g[wb>>2]);X=ea(g[xb>>2]);fa=ea(Na-Ka);$a=ea(ca-Aa);_a=ea(Ia-X);Za=ea(ea(ea(fa*fa)+ea($a*$a))+ea(_a*_a));if(Za==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[N+0>>2]=c[z+0>>2];c[N+4>>2]=c[z+4>>2];c[N+8>>2]=c[z+8>>2];c[N+12>>2]=c[z+12>>2];break}else{Lb=ea(ea(ea(-ea(Aa*$a))-ea(Ka*fa))-ea(X*_a));_a=ea(g[A>>2]);X=ea(g[yb>>2]);fa=ea(g[zb>>2]);Ka=ea(Ca-_a);$a=ea(Fa-X);Aa=ea(Ja-fa);Mb=ea(g[B>>2]);Nb=ea(g[Ab>>2]);Ob=ea(g[Bb>>2]);Pb=ea(La-Mb);Qb=ea(da-Nb);Rb=ea(Ea-Ob);Sb=ea(Lb/Za);Fb=Sb>ea(1.0);Za=Fb?ea(1.0):Sb;Fb=Za>ea(0.0);Sb=Fb?Za:ea(0.0);Za=ea(_a+ea(Ka*Sb));Ka=ea(X+ea($a*Sb));$a=ea(fa+ea(Aa*Sb));Aa=ea(Mb+ea(Pb*Sb));Pb=ea(Nb+ea(Qb*Sb));Qb=ea(Ob+ea(Rb*Sb));g[v>>2]=Za;g[h>>2]=Ka;g[Y>>2]=$a;g[Z>>2]=ea(0.0);g[w>>2]=Aa;g[_>>2]=Pb;g[$>>2]=Qb;g[aa>>2]=ea(0.0);Sb=ea(Ka-Pb);Pb=ea($a-Qb);g[N>>2]=ea(Za-Aa);g[ub>>2]=Sb;g[vb>>2]=Pb;g[Cb>>2]=ea(0.0);break}}else if((Gb|0)==2)V6a(N,z,Db,L,z,A,B,E,v,w);else{c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}while(0);Ea=ea(g[N>>2]);da=ea(g[ub>>2]);La=ea(g[vb>>2]);Ja=ea(ea(ea(Ea*Ea)+ea(da*da))+ea(La*La));c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];Tb=ib>Ja;if(Ja>W^1|Tb^1){Ub=35;break}Fa=ea(g[v>>2]);Ca=ea(g[h>>2]);Ia=ea(g[Y>>2]);ca=ea(g[Z>>2]);Na=ea(g[w>>2]);Pb=ea(g[_>>2]);Sb=ea(g[$>>2]);hb=Ga;gb=Ea;fb=da;cb=La;ib=Ja;Da=Fa;Ba=Ca;bb=Ia;ab=ca;kb=Na;jb=Pb;Ma=Sb;Ha=ea(g[aa>>2])}if((Ub|0)==35){vb=c[E>>2]|0;if(Tb){Vb=vb;break}ub=vb+-1|0;if((n|0)!=0?(a[p>>0]=ub,(ub|0)!=0):0){vb=0;do{a[n+vb>>0]=c[C+(vb<<2)>>2];a[o+vb>>0]=c[D+(vb<<2)>>2];vb=vb+1|0}while((vb|0)!=(ub|0))}g[v>>2]=Da;g[h>>2]=Ba;g[Y>>2]=bb;g[Z>>2]=ab;g[w>>2]=kb;g[_>>2]=jb;g[$>>2]=Ma;g[aa>>2]=Ha;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];hb=ea(T(ea(ib)));Sb=ea(ea(1.0)/hb);Pb=ea(ea(Da-kb)*Sb);Na=ea(ea(Ba-jb)*Sb);ca=ea(ea(bb-Ma)*Sb);Sb=ea(Ba-ea(Q*Na));Ia=ea(bb-ea(Q*ca));g[j>>2]=ea(Da-ea(Q*Pb));g[j+4>>2]=Sb;g[j+8>>2]=Ia;g[j+12>>2]=ea(0.0);Ia=ea(ea(S*Na)+jb);Sb=ea(ea(S*ca)+Ma);g[k>>2]=ea(ea(S*Pb)+kb);g[k+4>>2]=Ia;g[k+8>>2]=Sb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(hb-V);ub=m+4|0;c[ub+0>>2]=c[P+0>>2];c[ub+4>>2]=c[P+4>>2];c[ub+8>>2]=c[P+8>>2];g[l>>2]=Pb;g[l+4>>2]=Na;g[l+8>>2]=ca;g[l+12>>2]=ea(0.0);Wb=3;i=q;return Wb|0}if((n|0)!=0?(a[p>>0]=Gb,(Gb|0)!=0):0){ub=0;do{a[n+ub>>0]=c[C+(ub<<2)>>2];a[o+ub>>0]=c[D+(ub<<2)>>2];ub=ub+1|0}while((ub|0)!=(Gb|0))}if(!(Kb&(Jb^1))){Wb=0;i=q;return Wb|0}kb=ea(T(ea(ib)));Ma=ea(ea(1.0)/kb);jb=ea(gb*Ma);Da=ea(fb*Ma);bb=ea(cb*Ma);Ma=ea(g[v>>2]);Ba=ea(g[h>>2]);Ha=ea(Ba-ea(Q*Da));Ba=ea(ea(g[Y>>2])-ea(Q*bb));g[j>>2]=ea(Ma-ea(Q*jb));g[j+4>>2]=Ha;g[j+8>>2]=Ba;g[j+12>>2]=ea(0.0);Ba=ea(g[w>>2]);Ha=ea(g[_>>2]);Ma=ea(ea(S*Da)+Ha);Ha=ea(ea(S*bb)+ea(g[$>>2]));g[k>>2]=ea(ea(S*jb)+Ba);g[k+4>>2]=Ma;g[k+8>>2]=Ha;g[k+12>>2]=ea(0.0);g[m>>2]=ea(kb-V);ub=m+4|0;c[ub+0>>2]=c[M+0>>2];c[ub+4>>2]=c[M+4>>2];c[ub+8>>2]=c[M+8>>2];g[l>>2]=jb;g[l+4>>2]=Da;g[l+8>>2]=bb;g[l+12>>2]=ea(0.0);Wb=1;i=q;return Wb|0}else Vb=c[E>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Vb,(Vb|0)!=0):0){p=0;do{a[n+p>>0]=c[C+(p<<2)>>2];a[o+p>>0]=c[D+(p<<2)>>2];p=p+1|0}while((p|0)!=(Vb|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Wb=6;i=q;return Wb|0}function RFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=0,R=Im,S=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=0,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=0,wb=0,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=0,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=0,hc=Im,ic=Im,jc=Im,kc=0;e=i;i=i+560|0;n=e+496|0;o=e+16|0;p=e;q=e+448|0;r=e+192|0;s=e+64|0;t=e+80|0;u=e+96|0;v=e+400|0;w=e+432|0;x=e+464|0;y=e+512|0;z=e+536|0;A=e+548|0;B=e+256|0;C=e+32|0;D=e+272|0;E=e+112|0;F=e+336|0;G=e+48|0;H=e+176|0;I=e+416|0;J=e+208|0;K=e+240|0;L=e+224|0;M=e+524|0;N=e+480|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];O=ea(g[h>>2]);y=h+4|0;P=ea(g[y>>2]);Q=h+8|0;R=ea(g[Q>>2]);S=ea(g[f>>2]);U=f+4|0;V=ea(g[U>>2]);W=f+8|0;X=ea(g[W>>2]);c[A>>2]=1;Y=d+48|0;Z=ea(g[d+48>>2]);_=ea(g[d+52>>2]);$=ea(g[d+56>>2]);aa=ea(ea(ea(Z*Z)+ea(_*_))+ea($*$))>ea(1.1920929e-07);c[o+0>>2]=c[Y+0>>2];c[o+4>>2]=c[Y+4>>2];c[o+8>>2]=c[Y+8>>2];c[o+12>>2]=c[Y+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);Y=aa?o:n;$=ea(g[Y>>2]);_=ea(g[Y+4>>2]);Z=ea(g[Y+8>>2]);ba=ea(ea(1.0)/ea(T(ea(ea(ea($*$)+ea(_*_))+ea(Z*Z)))));ca=ea($*ba);$=ea(_*ba);_=ea(Z*ba);ba=ea(-$);Z=ea(-_);g[C>>2]=ea(-ca);g[C+4>>2]=ba;g[C+8>>2]=Z;g[C+12>>2]=ea(0.0);IFb(B,a,C,d);C=b+96|0;Y=b+96|0;Z=ea(g[Y>>2]);n=b+100|0;ba=ea(g[n>>2]);o=b+104|0;da=ea(ea(ea(ca*Z)+ea($*ba))+ea(_*ea(g[o>>2])));aa=b+112|0;fa=b+112|0;ba=ea(g[fa>>2]);ga=b+116|0;Z=ea(g[ga>>2]);ha=b+120|0;ia=da>ea(ea(ea(ca*ba)+ea($*Z))+ea(_*ea(g[ha>>2])));c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];c[p+0>>2]=c[aa+0>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];c[p+12>>2]=c[aa+12>>2];ja=ia?q:p;_=ea(g[ja>>2]);Z=ea(g[ja+4>>2]);$=ea(g[ja+8>>2]);ba=ea(g[B>>2]);ca=ea(g[B+4>>2]);da=ea(ba-_);ba=ea(ca-Z);ca=ea(ea(g[B+8>>2])-$);g[D>>2]=da;ja=D+4|0;g[ja>>2]=ba;ia=D+8|0;g[ia>>2]=ca;ka=D+12|0;g[ka>>2]=ea(0.0);la=D+16|0;c[la+0>>2]=c[x+0>>2];c[la+4>>2]=c[x+4>>2];c[la+8>>2]=c[x+8>>2];c[la+12>>2]=c[x+12>>2];ma=D+32|0;c[ma+0>>2]=c[x+0>>2];c[ma+4>>2]=c[x+4>>2];c[ma+8>>2]=c[x+8>>2];c[ma+12>>2]=c[x+12>>2];ma=D+48|0;c[ma+0>>2]=c[x+0>>2];c[ma+4>>2]=c[x+4>>2];c[ma+8>>2]=c[x+8>>2];c[ma+12>>2]=c[x+12>>2];c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];ma=E+16|0;c[ma+0>>2]=c[x+0>>2];c[ma+4>>2]=c[x+4>>2];c[ma+8>>2]=c[x+8>>2];c[ma+12>>2]=c[x+12>>2];ma=E+32|0;c[ma+0>>2]=c[x+0>>2];c[ma+4>>2]=c[x+4>>2];c[ma+8>>2]=c[x+8>>2];c[ma+12>>2]=c[x+12>>2];ma=E+48|0;c[ma+0>>2]=c[x+0>>2];c[ma+4>>2]=c[x+4>>2];c[ma+8>>2]=c[x+8>>2];c[ma+12>>2]=c[x+12>>2];g[F>>2]=_;ma=F+4|0;g[ma>>2]=Z;na=F+8|0;g[na>>2]=$;oa=F+12|0;g[oa>>2]=ea(0.0);pa=F+16|0;c[pa+0>>2]=c[x+0>>2];c[pa+4>>2]=c[x+4>>2];c[pa+8>>2]=c[x+8>>2];c[pa+12>>2]=c[x+12>>2];pa=F+32|0;c[pa+0>>2]=c[x+0>>2];c[pa+4>>2]=c[x+4>>2];c[pa+8>>2]=c[x+8>>2];c[pa+12>>2]=c[x+12>>2];pa=F+48|0;c[pa+0>>2]=c[x+0>>2];c[pa+4>>2]=c[x+4>>2];c[pa+8>>2]=c[x+8>>2];c[pa+12>>2]=c[x+12>>2];qa=ea(-da);ra=ea(-ba);sa=ea(-ca);c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];ta=ea(g[a+32>>2]);ua=ea(g[b+32>>2]);va=ea((ta>ua?ua:ta)*ea(.100000001));ta=ea(va*va);va=ea(ea(m*m)+ta);c[H+0>>2]=c[B+0>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];c[H+12>>2]=c[B+12>>2];g[I>>2]=_;b=I+4|0;g[b>>2]=Z;x=I+8|0;g[x>>2]=$;pa=I+12|0;g[pa>>2]=ea(0.0);$=ea(ea(ea(da*da)+ea(ba*ba))+ea(ca*ca));c[J+0>>2]=c[B+0>>2];c[J+4>>2]=c[B+4>>2];c[J+8>>2]=c[B+8>>2];c[J+12>>2]=c[B+12>>2];a:do if($>ta){B=K+4|0;wa=K+8|0;xa=K+12|0;ya=L+4|0;za=L+8|0;Aa=L+12|0;Ba=G+4|0;Ca=G+8|0;Da=G+12|0;Ea=F+16|0;Fa=F+20|0;Ga=F+24|0;Ha=F+28|0;Ia=F+32|0;Ja=F+36|0;Ka=F+40|0;La=F+44|0;Ma=E+4|0;Na=E+8|0;Oa=E+16|0;Pa=E+20|0;Qa=E+24|0;Ra=D+16|0;Sa=D+20|0;Ta=D+24|0;Ua=D+28|0;Va=E+32|0;Wa=E+36|0;Xa=E+40|0;Ya=D+32|0;Za=D+36|0;_a=D+40|0;$a=D+44|0;ab=N+4|0;bb=N+8|0;cb=H+4|0;db=H+8|0;eb=H+12|0;fb=N+12|0;ca=qa;ba=ra;da=sa;Z=ea(ea(O*ea(0.0))+S);_=ea(ea(P*ea(0.0))+V);ua=ea(ea(R*ea(0.0))+X);gb=ea(0.0);hb=qa;ib=ra;jb=sa;kb=$;while(1){c[J+0>>2]=c[H+0>>2];c[J+4>>2]=c[H+4>>2];c[J+8>>2]=c[H+8>>2];c[J+12>>2]=c[H+12>>2];lb=ea(ea(1.0)/ea(T(ea(ea(da*da)+ea(ea(ba*ba)+ea(ca*ca))))));mb=ea(ca*lb);nb=ea(ba*lb);ob=ea(da*lb);g[K>>2]=mb;g[B>>2]=nb;g[wa>>2]=ob;g[xa>>2]=ea(0.0);lb=ea(-mb);mb=ea(-nb);nb=ea(-ob);IFb(L,a,K,d);ob=ea(g[L>>2]);pb=ea(g[ya>>2]);qb=ea(g[za>>2]);rb=ea(g[Aa>>2]);sb=ea(g[Y>>2]);tb=ea(g[n>>2]);ub=ea(ea(ea(sb*lb)+ea(tb*mb))+ea(ea(g[o>>2])*nb));tb=ea(g[fa>>2]);sb=ea(g[ga>>2]);vb=ub>ea(ea(ea(tb*lb)+ea(sb*mb))+ea(ea(g[ha>>2])*nb));c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];c[p+0>>2]=c[aa+0>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];c[p+12>>2]=c[aa+12>>2];wb=vb?q:p;nb=ea(g[wb>>2]);mb=ea(g[wb+4>>2]);sb=ea(Z+nb);nb=ea(_+mb);mb=ea(ua+ea(g[wb+8>>2]));lb=ea(ob-sb);tb=ea(pb-nb);ub=ea(qb-mb);g[G>>2]=lb;g[Ba>>2]=tb;g[Ca>>2]=ub;g[Da>>2]=ea(0.0);xb=ea(g[K>>2]);yb=ea(g[B>>2]);zb=ea(g[wa>>2]);Ab=ea(ea(ea(ea(-ea(tb*yb))-ea(lb*xb))-ea(ub*zb))-m);Bb=ea(g[h>>2]);Cb=ea(g[y>>2]);Db=ea(g[Q>>2]);Eb=ea(ea(ea(xb*Bb)+ea(yb*Cb))+ea(zb*Db));if(Ab>ea(0.0)){if(Eb>=ea(0.0)){Fb=0;Gb=21;break}zb=ea(gb-ea(Ab/Eb));c[z+0>>2]=c[M+0>>2];c[z+4>>2]=c[M+4>>2];c[z+8>>2]=c[M+8>>2];if(zb>gb){if(zb>ea(1.0)){Fb=0;Gb=21;break}Eb=ea(g[f>>2]);Ab=ea(g[U>>2]);yb=ea(ea(zb*Bb)+Eb);Eb=ea(ea(zb*Cb)+Ab);Ab=ea(ea(zb*Db)+ea(g[W>>2]));Db=ea(yb-Z);Cb=ea(Eb-_);Bb=ea(Ab-ua);xb=ea(g[F>>2]);Hb=ea(g[ma>>2]);Ib=ea(Db+xb);xb=ea(Cb+Hb);Hb=ea(Bb+ea(g[na>>2]));Jb=ea(g[Ea>>2]);Kb=ea(g[Fa>>2]);Lb=ea(Db+Jb);Jb=ea(Cb+Kb);Kb=ea(Bb+ea(g[Ga>>2]));Mb=ea(g[Ia>>2]);Nb=ea(g[Ja>>2]);Ob=ea(Db+Mb);Mb=ea(Cb+Nb);Nb=ea(Bb+ea(g[Ka>>2]));g[F>>2]=Ib;g[ma>>2]=xb;g[na>>2]=Hb;g[oa>>2]=ea(0.0);g[Ea>>2]=Lb;g[Fa>>2]=Jb;g[Ga>>2]=Kb;g[Ha>>2]=ea(0.0);g[Ia>>2]=Ob;g[Ja>>2]=Mb;g[Ka>>2]=Nb;g[La>>2]=ea(0.0);Bb=ea(g[E>>2]);Cb=ea(g[Ma>>2]);Db=ea(Cb-xb);xb=ea(ea(g[Na>>2])-Hb);g[D>>2]=ea(Bb-Ib);g[ja>>2]=Db;g[ia>>2]=xb;g[ka>>2]=ea(0.0);xb=ea(g[Oa>>2]);Db=ea(g[Pa>>2]);Ib=ea(Db-Jb);Jb=ea(ea(g[Qa>>2])-Kb);g[Ra>>2]=ea(xb-Lb);g[Sa>>2]=Ib;g[Ta>>2]=Jb;g[Ua>>2]=ea(0.0);Jb=ea(g[Va>>2]);Ib=ea(g[Wa>>2]);Lb=ea(Ib-Mb);Mb=ea(ea(g[Xa>>2])-Nb);g[Ya>>2]=ea(Jb-Ob);g[Za>>2]=Lb;g[_a>>2]=Mb;g[$a>>2]=ea(0.0);c[q+0>>2]=c[C+0>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];c[p+0>>2]=c[aa+0>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];c[p+12>>2]=c[aa+12>>2];wb=vb?q:p;Mb=ea(g[wb>>2]);Lb=ea(g[wb+4>>2]);Ob=ea(yb+Mb);Mb=ea(Eb+Lb);Lb=ea(Ab+ea(g[wb+8>>2]));Jb=ea(ob-Ob);Nb=ea(pb-Mb);Ib=ea(qb-Lb);g[G>>2]=Jb;g[Ba>>2]=Nb;g[Ca>>2]=Ib;g[Da>>2]=ea(0.0);Pb=Ob;Qb=Mb;Rb=Lb;Sb=Jb;Tb=Nb;Ub=Ib;Vb=ea(3402823469999999843913219.0e14);Wb=zb;Xb=Ab;Yb=Eb;Zb=yb;_b=da;$b=ba;ac=ca}else{Pb=sb;Qb=nb;Rb=mb;Sb=lb;Tb=tb;Ub=ub;Vb=kb;Wb=zb;Xb=ua;Yb=_;Zb=Z;_b=jb;$b=ib;ac=hb}}else{Pb=sb;Qb=nb;Rb=mb;Sb=lb;Tb=tb;Ub=ub;Vb=kb;Wb=gb;Xb=ua;Yb=_;Zb=Z;_b=jb;$b=ib;ac=hb}wb=c[A>>2]|0;g[E+(wb<<4)>>2]=ob;g[E+(wb<<4)+4>>2]=pb;g[E+(wb<<4)+8>>2]=qb;g[E+(wb<<4)+12>>2]=rb;g[F+(wb<<4)>>2]=Pb;g[F+(wb<<4)+4>>2]=Qb;g[F+(wb<<4)+8>>2]=Rb;g[F+(wb<<4)+12>>2]=ea(0.0);c[A>>2]=wb+1;vb=D+(wb<<4)|0;c[vb+0>>2]=c[G+0>>2];c[vb+4>>2]=c[G+4>>2];c[vb+8>>2]=c[G+8>>2];c[vb+12>>2]=c[G+12>>2];do if((wb|0)==2)V6a(N,D,la,G,D,E,F,A,H,I);else if((wb|0)==3)pPa(N,D,E,F,A,H,I);else if(!wb){g[H>>2]=ob;g[cb>>2]=pb;g[db>>2]=qb;g[eb>>2]=rb;g[I>>2]=Pb;g[b>>2]=Qb;g[x>>2]=Rb;g[pa>>2]=ea(0.0);c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}else if((wb|0)==1){ub=ea(g[D>>2]);tb=ea(g[ja>>2]);lb=ea(g[ia>>2]);mb=ea(Sb-ub);nb=ea(Tb-tb);sb=ea(Ub-lb);zb=ea(ea(ea(mb*mb)+ea(nb*nb))+ea(sb*sb));if(zb==ea(0.0)){c[A>>2]=1;c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[N+0>>2]=c[D+0>>2];c[N+4>>2]=c[D+4>>2];c[N+8>>2]=c[D+8>>2];c[N+12>>2]=c[D+12>>2];break}else{yb=ea(ea(ea(-ea(tb*nb))-ea(ub*mb))-ea(lb*sb));sb=ea(g[E>>2]);lb=ea(g[Ma>>2]);mb=ea(g[Na>>2]);ub=ea(ob-sb);nb=ea(pb-lb);tb=ea(qb-mb);Eb=ea(g[F>>2]);Ab=ea(g[ma>>2]);Ib=ea(g[na>>2]);Nb=ea(Pb-Eb);Jb=ea(Qb-Ab);Lb=ea(Rb-Ib);Mb=ea(yb/zb);vb=Mb>ea(1.0);zb=vb?ea(1.0):Mb;vb=zb>ea(0.0);Mb=vb?zb:ea(0.0);zb=ea(sb+ea(ub*Mb));ub=ea(lb+ea(nb*Mb));nb=ea(mb+ea(tb*Mb));tb=ea(Eb+ea(Nb*Mb));Nb=ea(Ab+ea(Jb*Mb));Jb=ea(Ib+ea(Lb*Mb));g[H>>2]=zb;g[cb>>2]=ub;g[db>>2]=nb;g[eb>>2]=ea(0.0);g[I>>2]=tb;g[b>>2]=Nb;g[x>>2]=Jb;g[pa>>2]=ea(0.0);Mb=ea(ub-Nb);Nb=ea(nb-Jb);g[N>>2]=ea(zb-tb);g[ab>>2]=Mb;g[bb>>2]=Nb;g[fb>>2]=ea(0.0);break}}else{c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}while(0);qb=ea(g[N>>2]);pb=ea(g[ab>>2]);ob=ea(g[bb>>2]);rb=ea(-qb);Nb=ea(-pb);Mb=ea(-ob);tb=ea(ea(ea(qb*qb)+ea(pb*pb))+ea(ob*ob));wb=Vb>tb;vb=wb<<31>>31;if(!(tb>va)){bc=Wb;cc=Mb;dc=Nb;ec=rb;fc=tb;gc=vb;hc=_b;ic=$b;jc=ac;break a}if(wb){ca=rb;ba=Nb;da=Mb;Z=Zb;_=Yb;ua=Xb;gb=Wb;hb=ac;ib=$b;jb=_b;kb=tb}else{bc=Wb;cc=Mb;dc=Nb;ec=rb;fc=tb;gc=vb;hc=_b;ic=$b;jc=ac;break a}}if((Gb|0)==21){i=e;return Fb|0}}else{bc=ea(0.0);cc=sa;dc=ra;ec=qa;fc=$;gc=-1;hc=sa;ic=ra;jc=qa}while(0);Gb=c[a+64>>2]|0;N=c[a+68>>2]|0;G=c[a+72>>2]|0;if(fc>ta)kc=(gc|0)==0?r:s;else kc=r;g[s>>2]=ec;g[s+4>>2]=dc;g[s+8>>2]=cc;g[s+12>>2]=ea(0.0);g[r>>2]=jc;g[r+4>>2]=ic;g[r+8>>2]=hc;g[r+12>>2]=ea(0.0);hc=ea(g[kc>>2]);ic=ea(g[kc+4>>2]);jc=ea(g[kc+8>>2]);cc=ea(ea(1.0)/ea(T(ea(ea(ea(hc*hc)+ea(ic*ic))+ea(jc*jc)))));dc=ea(-ea(hc*cc));hc=ea(-ea(ic*cc));ic=ea(-ea(jc*cc));g[k>>2]=dc;g[k+4>>2]=hc;g[k+8>>2]=ic;g[k+12>>2]=ea(0.0);g[j>>2]=bc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[H+0>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];c[u+12>>2]=c[H+12>>2];c[t+0>>2]=c[J+0>>2];c[t+4>>2]=c[J+4>>2];c[t+8>>2]=c[J+8>>2];c[t+12>>2]=c[J+12>>2];J=(gc|0)==0?t:u;bc=ea(g[J>>2]);cc=ea(g[J+4>>2]);jc=ea(g[J+8>>2]);g[H>>2]=bc;g[H+4>>2]=cc;g[H+8>>2]=jc;g[H+12>>2]=ea(0.0);ec=ea(g[a+16>>2]);ta=ea(bc-ea(ec*dc));dc=ea(cc-ea(ec*hc));hc=ea(jc-ea(ec*ic));c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];g[w>>2]=ta;g[w+4>>2]=dc;g[w+8>>2]=hc;g[w+12>>2]=ea(0.0);hc=ea(g[((Gb|0)==0?v:w)>>2]);dc=ea(g[((N|0)==0?v:w)+4>>2]);ta=ea(g[((G|0)==0?v:w)+8>>2]);g[l>>2]=hc;g[l+4>>2]=dc;g[l+8>>2]=ta;g[l+12>>2]=ea(0.0);Fb=1;i=e;return Fb|0}function SFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,U=0,V=Im,W=Im,X=0,Y=Im,Z=0,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=0,Fb=0,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=0,bc=0,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=0,ic=Im,jc=Im,kc=Im,lc=0;e=i;i=i+608|0;n=e+272|0;o=e+480|0;p=e+208|0;q=e+224|0;r=e+16|0;s=e+112|0;t=e+128|0;u=e+144|0;v=e+160|0;w=e+560|0;x=e+572|0;y=e+596|0;z=e+528|0;A=e+240|0;B=e+256|0;C=e+544|0;D=e+288|0;E=e+352|0;F=e+32|0;G=e+96|0;H=e+416|0;I=e+176|0;J=e+192|0;K=e+448|0;L=e;M=e+512|0;N=e+496|0;O=e+584|0;P=e+464|0;Q=e+432|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];R=ea(g[h>>2]);w=h+4|0;S=ea(g[w>>2]);U=h+8|0;V=ea(g[U>>2]);W=ea(g[f>>2]);X=f+4|0;Y=ea(g[X>>2]);Z=f+8|0;_=ea(g[Z>>2]);c[y>>2]=1;$=d+48|0;aa=ea(g[d+48>>2]);ba=ea(g[d+52>>2]);ca=ea(g[d+56>>2]);da=ea(ea(ea(aa*aa)+ea(ba*ba))+ea(ca*ca))>ea(1.1920929e-07);c[o+0>>2]=c[$+0>>2];c[o+4>>2]=c[$+4>>2];c[o+8>>2]=c[$+8>>2];c[o+12>>2]=c[$+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);$=da?o:n;ca=ea(g[$>>2]);ba=ea(g[$+4>>2]);aa=ea(g[$+8>>2]);fa=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(ba*ba))+ea(aa*aa)))));ga=ea(ca*fa);ca=ea(ba*fa);ba=ea(aa*fa);g[z>>2]=ga;g[z+4>>2]=ca;g[z+8>>2]=ba;g[z+12>>2]=ea(0.0);fa=ea(-ca);ca=ea(-ba);g[B>>2]=ea(-ga);g[B+4>>2]=fa;g[B+8>>2]=ca;g[B+12>>2]=ea(0.0);IFb(A,a,B,d);HFb(C,b,z);ca=ea(g[A>>2]);fa=ea(g[A+4>>2]);ga=ea(g[A+8>>2]);ba=ea(g[C>>2]);aa=ea(g[C+4>>2]);ha=ea(ca-ba);ba=ea(fa-aa);aa=ea(ga-ea(g[C+8>>2]));g[D>>2]=ha;z=D+4|0;g[z>>2]=ba;B=D+8|0;g[B>>2]=aa;$=D+12|0;g[$>>2]=ea(0.0);n=D+16|0;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];c[n+12>>2]=c[v+12>>2];o=D+32|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];o=D+48|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];c[E+0>>2]=c[A+0>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];o=E+16|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];o=E+32|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];o=E+48|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];o=F+16|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];o=F+32|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];o=F+48|0;c[o+0>>2]=c[v+0>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];ga=ea(-ha);fa=ea(-ba);ca=ea(-aa);c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];ia=ea(g[a+32>>2]);ja=ea(g[b+32>>2]);ka=ea((ia>ja?ja:ia)*ea(.100000001));ia=ea(ka*ka);ka=ea(ea(m*m)+ia);c[H+0>>2]=c[A+0>>2];c[H+4>>2]=c[A+4>>2];c[H+8>>2]=c[A+8>>2];c[H+12>>2]=c[A+12>>2];c[I+0>>2]=c[C+0>>2];c[I+4>>2]=c[C+4>>2];c[I+8>>2]=c[C+8>>2];c[I+12>>2]=c[C+12>>2];ja=ea(ea(ea(ha*ha)+ea(ba*ba))+ea(aa*aa));c[J+0>>2]=c[A+0>>2];c[J+4>>2]=c[A+4>>2];c[J+8>>2]=c[A+8>>2];c[J+12>>2]=c[A+12>>2];a:do if(ja>ia){A=K+4|0;C=K+8|0;v=K+12|0;o=L+4|0;da=L+8|0;la=L+12|0;ma=M+4|0;na=M+8|0;oa=M+12|0;pa=N+4|0;qa=N+8|0;ra=G+4|0;sa=G+8|0;ta=G+12|0;ua=F+4|0;va=F+8|0;wa=F+12|0;xa=F+16|0;ya=F+20|0;za=F+24|0;Aa=F+28|0;Ba=F+32|0;Ca=F+36|0;Da=F+40|0;Ea=F+44|0;Fa=E+4|0;Ga=E+8|0;Ha=E+16|0;Ia=E+20|0;Ja=E+24|0;Ka=D+16|0;La=D+20|0;Ma=D+24|0;Na=D+28|0;Oa=E+32|0;Pa=E+36|0;Qa=E+40|0;Ra=D+32|0;Sa=D+36|0;Ta=D+40|0;Ua=D+44|0;Va=P+4|0;Wa=P+8|0;Xa=Q+4|0;Ya=Q+8|0;Za=H+4|0;_a=H+8|0;$a=H+12|0;ab=I+4|0;bb=I+8|0;cb=I+12|0;db=Q+12|0;aa=ga;ba=fa;ha=ca;eb=ea(ea(R*ea(0.0))+W);fb=ea(ea(S*ea(0.0))+Y);gb=ea(ea(V*ea(0.0))+_);hb=ea(0.0);ib=ga;jb=fa;kb=ca;lb=ja;while(1){c[J+0>>2]=c[H+0>>2];c[J+4>>2]=c[H+4>>2];c[J+8>>2]=c[H+8>>2];c[J+12>>2]=c[H+12>>2];mb=ea(ea(1.0)/ea(T(ea(ea(ha*ha)+ea(ea(ba*ba)+ea(aa*aa))))));nb=ea(aa*mb);ob=ea(ba*mb);pb=ea(ha*mb);g[K>>2]=nb;g[A>>2]=ob;g[C>>2]=pb;g[v>>2]=ea(0.0);mb=ea(-ob);ob=ea(-pb);g[L>>2]=ea(-nb);g[o>>2]=mb;g[da>>2]=ob;g[la>>2]=ea(0.0);IFb(M,a,K,d);ob=ea(g[M>>2]);mb=ea(g[ma>>2]);nb=ea(g[na>>2]);pb=ea(g[oa>>2]);HFb(N,b,L);qb=ea(g[N>>2]);rb=ea(g[pa>>2]);sb=ea(eb+qb);qb=ea(fb+rb);rb=ea(gb+ea(g[qa>>2]));tb=ea(ob-sb);ub=ea(mb-qb);vb=ea(nb-rb);g[G>>2]=tb;g[ra>>2]=ub;g[sa>>2]=vb;g[ta>>2]=ea(0.0);wb=ea(g[K>>2]);xb=ea(g[A>>2]);yb=ea(g[C>>2]);zb=ea(ea(ea(ea(-ea(ub*xb))-ea(tb*wb))-ea(vb*yb))-m);Ab=ea(g[h>>2]);Bb=ea(g[w>>2]);Cb=ea(g[U>>2]);Db=ea(ea(ea(wb*Ab)+ea(xb*Bb))+ea(yb*Cb));if(zb>ea(0.0)){if(Db>=ea(0.0)){Eb=0;Fb=21;break}yb=ea(hb-ea(zb/Db));c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];if(yb>hb){if(yb>ea(1.0)){Eb=0;Fb=21;break}Db=ea(g[f>>2]);zb=ea(g[X>>2]);xb=ea(ea(yb*Ab)+Db);Db=ea(ea(yb*Bb)+zb);zb=ea(ea(yb*Cb)+ea(g[Z>>2]));Cb=ea(xb-eb);Bb=ea(Db-fb);Ab=ea(zb-gb);wb=ea(g[F>>2]);Gb=ea(g[ua>>2]);Hb=ea(Cb+wb);wb=ea(Bb+Gb);Gb=ea(Ab+ea(g[va>>2]));Ib=ea(g[xa>>2]);Jb=ea(g[ya>>2]);Kb=ea(Cb+Ib);Ib=ea(Bb+Jb);Jb=ea(Ab+ea(g[za>>2]));Lb=ea(g[Ba>>2]);Mb=ea(g[Ca>>2]);Nb=ea(Cb+Lb);Lb=ea(Bb+Mb);Mb=ea(Ab+ea(g[Da>>2]));g[F>>2]=Hb;g[ua>>2]=wb;g[va>>2]=Gb;g[wa>>2]=ea(0.0);g[xa>>2]=Kb;g[ya>>2]=Ib;g[za>>2]=Jb;g[Aa>>2]=ea(0.0);g[Ba>>2]=Nb;g[Ca>>2]=Lb;g[Da>>2]=Mb;g[Ea>>2]=ea(0.0);Ab=ea(g[E>>2]);Bb=ea(g[Fa>>2]);Cb=ea(Bb-wb);wb=ea(ea(g[Ga>>2])-Gb);g[D>>2]=ea(Ab-Hb);g[z>>2]=Cb;g[B>>2]=wb;g[$>>2]=ea(0.0);wb=ea(g[Ha>>2]);Cb=ea(g[Ia>>2]);Hb=ea(Cb-Ib);Ib=ea(ea(g[Ja>>2])-Jb);g[Ka>>2]=ea(wb-Kb);g[La>>2]=Hb;g[Ma>>2]=Ib;g[Na>>2]=ea(0.0);Ib=ea(g[Oa>>2]);Hb=ea(g[Pa>>2]);Kb=ea(Hb-Lb);Lb=ea(ea(g[Qa>>2])-Mb);g[Ra>>2]=ea(Ib-Nb);g[Sa>>2]=Kb;g[Ta>>2]=Lb;g[Ua>>2]=ea(0.0);HFb(P,b,L);Lb=ea(g[P>>2]);Kb=ea(g[Va>>2]);Nb=ea(xb+Lb);Lb=ea(Db+Kb);Kb=ea(zb+ea(g[Wa>>2]));Ib=ea(ob-Nb);Mb=ea(mb-Lb);Hb=ea(nb-Kb);g[G>>2]=Ib;g[ra>>2]=Mb;g[sa>>2]=Hb;g[ta>>2]=ea(0.0);Ob=Nb;Pb=Lb;Qb=Kb;Rb=Ib;Sb=Mb;Tb=Hb;Ub=ea(3402823469999999843913219.0e14);Vb=yb;Wb=zb;Xb=Db;Yb=xb;Zb=ha;_b=ba;$b=aa}else{Ob=sb;Pb=qb;Qb=rb;Rb=tb;Sb=ub;Tb=vb;Ub=lb;Vb=yb;Wb=gb;Xb=fb;Yb=eb;Zb=kb;_b=jb;$b=ib}}else{Ob=sb;Pb=qb;Qb=rb;Rb=tb;Sb=ub;Tb=vb;Ub=lb;Vb=hb;Wb=gb;Xb=fb;Yb=eb;Zb=kb;_b=jb;$b=ib}ac=c[y>>2]|0;g[E+(ac<<4)>>2]=ob;g[E+(ac<<4)+4>>2]=mb;g[E+(ac<<4)+8>>2]=nb;g[E+(ac<<4)+12>>2]=pb;g[F+(ac<<4)>>2]=Ob;g[F+(ac<<4)+4>>2]=Pb;g[F+(ac<<4)+8>>2]=Qb;g[F+(ac<<4)+12>>2]=ea(0.0);c[y>>2]=ac+1;bc=D+(ac<<4)|0;c[bc+0>>2]=c[G+0>>2];c[bc+4>>2]=c[G+4>>2];c[bc+8>>2]=c[G+8>>2];c[bc+12>>2]=c[G+12>>2];do if((ac|0)==1){vb=ea(g[D>>2]);ub=ea(g[z>>2]);tb=ea(g[B>>2]);rb=ea(Rb-vb);qb=ea(Sb-ub);sb=ea(Tb-tb);yb=ea(ea(ea(rb*rb)+ea(qb*qb))+ea(sb*sb));if(yb==ea(0.0)){c[y>>2]=1;c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[Q+0>>2]=c[D+0>>2];c[Q+4>>2]=c[D+4>>2];c[Q+8>>2]=c[D+8>>2];c[Q+12>>2]=c[D+12>>2];break}else{xb=ea(ea(ea(-ea(ub*qb))-ea(vb*rb))-ea(tb*sb));sb=ea(g[E>>2]);tb=ea(g[Fa>>2]);rb=ea(g[Ga>>2]);vb=ea(ob-sb);qb=ea(mb-tb);ub=ea(nb-rb);Db=ea(g[F>>2]);zb=ea(g[ua>>2]);Hb=ea(g[va>>2]);Mb=ea(Ob-Db);Ib=ea(Pb-zb);Kb=ea(Qb-Hb);Lb=ea(xb/yb);bc=Lb>ea(1.0);yb=bc?ea(1.0):Lb;bc=yb>ea(0.0);Lb=bc?yb:ea(0.0);yb=ea(sb+ea(vb*Lb));vb=ea(tb+ea(qb*Lb));qb=ea(rb+ea(ub*Lb));ub=ea(Db+ea(Mb*Lb));Mb=ea(zb+ea(Ib*Lb));Ib=ea(Hb+ea(Kb*Lb));g[H>>2]=yb;g[Za>>2]=vb;g[_a>>2]=qb;g[$a>>2]=ea(0.0);g[I>>2]=ub;g[ab>>2]=Mb;g[bb>>2]=Ib;g[cb>>2]=ea(0.0);Lb=ea(vb-Mb);Mb=ea(qb-Ib);g[Q>>2]=ea(yb-ub);g[Xa>>2]=Lb;g[Ya>>2]=Mb;g[db>>2]=ea(0.0);break}}else if((ac|0)==2)V6a(Q,D,n,G,D,E,F,y,H,I);else if(!ac){g[H>>2]=ob;g[Za>>2]=mb;g[_a>>2]=nb;g[$a>>2]=pb;g[I>>2]=Ob;g[ab>>2]=Pb;g[bb>>2]=Qb;g[cb>>2]=ea(0.0);c[Q+0>>2]=c[G+0>>2];c[Q+4>>2]=c[G+4>>2];c[Q+8>>2]=c[G+8>>2];c[Q+12>>2]=c[G+12>>2]}else if((ac|0)==3)pPa(Q,D,E,F,y,H,I);else{c[Q+0>>2]=c[G+0>>2];c[Q+4>>2]=c[G+4>>2];c[Q+8>>2]=c[G+8>>2];c[Q+12>>2]=c[G+12>>2]}while(0);pb=ea(g[Q>>2]);nb=ea(g[Xa>>2]);mb=ea(g[Ya>>2]);ob=ea(-pb);Mb=ea(-nb);Lb=ea(-mb);ub=ea(ea(ea(pb*pb)+ea(nb*nb))+ea(mb*mb));ac=Ub>ub;bc=ac<<31>>31;if(!(ub>ka)){cc=Vb;dc=Lb;ec=Mb;fc=ob;gc=ub;hc=bc;ic=Zb;jc=_b;kc=$b;break a}if(ac){aa=ob;ba=Mb;ha=Lb;eb=Yb;fb=Xb;gb=Wb;hb=Vb;ib=$b;jb=_b;kb=Zb;lb=ub}else{cc=Vb;dc=Lb;ec=Mb;fc=ob;gc=ub;hc=bc;ic=Zb;jc=_b;kc=$b;break a}}if((Fb|0)==21){i=e;return Eb|0}}else{cc=ea(0.0);dc=ca;ec=fa;fc=ga;gc=ja;hc=-1;ic=ca;jc=fa;kc=ga}while(0);Fb=c[a+64>>2]|0;Q=c[a+68>>2]|0;G=c[a+72>>2]|0;if(gc>ia)lc=(hc|0)==0?p:q;else lc=p;g[q>>2]=fc;g[q+4>>2]=ec;g[q+8>>2]=dc;g[q+12>>2]=ea(0.0);g[p>>2]=kc;g[p+4>>2]=jc;g[p+8>>2]=ic;g[p+12>>2]=ea(0.0);ic=ea(g[lc>>2]);jc=ea(g[lc+4>>2]);kc=ea(g[lc+8>>2]);dc=ea(ea(1.0)/ea(T(ea(ea(ea(ic*ic)+ea(jc*jc))+ea(kc*kc)))));ec=ea(-ea(ic*dc));ic=ea(-ea(jc*dc));jc=ea(-ea(kc*dc));g[k>>2]=ec;g[k+4>>2]=ic;g[k+8>>2]=jc;g[k+12>>2]=ea(0.0);g[j>>2]=cc;k=j+4|0;c[k+0>>2]=c[x+0>>2];c[k+4>>2]=c[x+4>>2];c[k+8>>2]=c[x+8>>2];c[s+0>>2]=c[H+0>>2];c[s+4>>2]=c[H+4>>2];c[s+8>>2]=c[H+8>>2];c[s+12>>2]=c[H+12>>2];c[r+0>>2]=c[J+0>>2];c[r+4>>2]=c[J+4>>2];c[r+8>>2]=c[J+8>>2];c[r+12>>2]=c[J+12>>2];J=(hc|0)==0?r:s;cc=ea(g[J>>2]);dc=ea(g[J+4>>2]);kc=ea(g[J+8>>2]);g[H>>2]=cc;g[H+4>>2]=dc;g[H+8>>2]=kc;g[H+12>>2]=ea(0.0);fc=ea(g[a+16>>2]);ia=ea(cc-ea(fc*ec));ec=ea(dc-ea(fc*ic));ic=ea(kc-ea(fc*jc));c[t+0>>2]=c[H+0>>2];c[t+4>>2]=c[H+4>>2];c[t+8>>2]=c[H+8>>2];c[t+12>>2]=c[H+12>>2];g[u>>2]=ia;g[u+4>>2]=ec;g[u+8>>2]=ic;g[u+12>>2]=ea(0.0);ic=ea(g[((Fb|0)==0?t:u)>>2]);ec=ea(g[((Q|0)==0?t:u)+4>>2]);ia=ea(g[((G|0)==0?t:u)+8>>2]);g[l>>2]=ic;g[l+4>>2]=ec;g[l+8>>2]=ia;g[l+12>>2]=ea(0.0);Eb=1;i=e;return Eb|0}function TFb(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=0,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=Im,ub=Im,vb=Im,wb=Im,xb=0,yb=0,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=0,Nb=0,Ob=0,Pb=0;q=i;i=i+560|0;r=q+288|0;s=q+432|0;t=q+336|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+448|0;y=q+472|0;z=q+352|0;A=q+368|0;B=q+144|0;C=q+208|0;D=q+488|0;E=q+504|0;F=q+520|0;G=q+16|0;H=q+304|0;I=q+112|0;J=q+128|0;K=q;L=q+32|0;M=q+272|0;N=q+320|0;O=q+460|0;P=q+80|0;Q=q+524|0;R=q+536|0;S=ea(g[b+16>>2]);U=ea(g[e+16>>2]);V=ea(g[h>>2]);W=ea(g[b+32>>2]);X=ea(g[e+32>>2]);Y=ea((W>X?X:W)*ea(.100000001));W=ea(S+U);h=v+4|0;Z=v+8|0;_=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;$=w+4|0;aa=w+8|0;ba=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];X=ea(Y*Y);c[F>>2]=0;if(!(a[p>>0]|0)){Y=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(ea(ea(Y*Y)+ea(ca*ca))+ea(da*da))>ea(0.0);g[s>>2]=Y;g[s+4>>2]=ca;g[s+8>>2]=da;g[s+12>>2]=fa;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ha=ga?s:r;fa=ea(g[ha>>2]);da=ea(g[ha+4>>2]);ca=ea(g[ha+8>>2]);g[z>>2]=fa;g[z+4>>2]=da;g[z+8>>2]=ca;g[z+12>>2]=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(3402823469999999843913219.0e14);ra=1;sa=ca;ta=da;ua=fa}else{ha=G+4|0;r=G+8|0;s=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ga=H+4|0;va=H+8|0;wa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;xa=I+4|0;ya=I+8|0;za=I+12|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;Aa=f+48|0;Ba=f+52|0;Ca=f+56|0;Da=f+16|0;Ea=f+32|0;Fa=f+4|0;Ga=f+20|0;Ha=f+36|0;Ia=f+8|0;Ja=f+24|0;Ka=f+40|0;La=e+16|0;Ma=J+4|0;Na=J+8|0;Oa=J+12|0;Pa=0;do{Qa=d[n+Pa>>0]|0;c[D+(Pa<<2)>>2]=Qa;Ra=d[o+Pa>>0]|0;c[E+(Pa<<2)>>2]=Ra;fa=ea(g[b+(Qa<<4)+96>>2]);da=ea(g[b+(Qa<<4)+100>>2]);ca=ea(g[b+(Qa<<4)+104>>2]);Y=ea(g[Aa>>2]);Sa=ea(g[Ba>>2]);Ta=ea(g[Ca>>2]);Ua=ea(fa*ea(g[f>>2]));Va=ea(Ua+ea(da*ea(g[Da>>2])));Ua=ea(Va+ea(ca*ea(g[Ea>>2])));Va=ea(fa*ea(g[Fa>>2]));Wa=ea(Va+ea(da*ea(g[Ga>>2])));Va=ea(Wa+ea(ca*ea(g[Ha>>2])));Wa=ea(fa*ea(g[Ia>>2]));fa=ea(Wa+ea(da*ea(g[Ja>>2])));Xa=ea(Y+Ua);Ya=ea(Sa+Va);Za=ea(Ta+ea(fa+ea(ca*ea(g[Ka>>2]))));BFb(J,e,Ra,La);_a=ea(g[J>>2]);$a=ea(g[Ma>>2]);ab=ea(g[Na>>2]);ca=ea(g[Oa>>2]);bb=ea(Xa-_a);cb=ea(Ya-$a);db=ea(Za-ab);eb=c[F>>2]|0;Ra=B+(eb<<4)|0;g[H>>2]=Xa;g[ga>>2]=Ya;g[va>>2]=Za;g[wa>>2]=ea(0.0);c[Ra+0>>2]=c[H+0>>2];c[Ra+4>>2]=c[H+4>>2];c[Ra+8>>2]=c[H+8>>2];c[Ra+12>>2]=c[H+12>>2];Ra=C+(eb<<4)|0;g[I>>2]=_a;g[xa>>2]=$a;g[ya>>2]=ab;g[za>>2]=ca;c[Ra+0>>2]=c[I+0>>2];c[Ra+4>>2]=c[I+4>>2];c[Ra+8>>2]=c[I+8>>2];c[Ra+12>>2]=c[I+12>>2];c[F>>2]=eb+1;Ra=A+(eb<<4)|0;g[G>>2]=bb;g[ha>>2]=cb;g[r>>2]=db;g[s>>2]=ea(0.0);c[Ra+0>>2]=c[G+0>>2];c[Ra+4>>2]=c[G+4>>2];c[Ra+8>>2]=c[G+8>>2];c[Ra+12>>2]=c[G+12>>2];Pa=Pa+1|0}while(Pa>>>0<(d[p>>0]|0)>>>0);do if((eb|0)==1){ca=ea(g[A>>2]);fa=ea(g[A+4>>2]);Ta=ea(g[A+8>>2]);Va=ea(bb-ca);Sa=ea(cb-fa);Ua=ea(db-Ta);Y=ea(ea(ea(Va*Va)+ea(Sa*Sa))+ea(Ua*Ua));if(Y==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[K+0>>2]=c[A+0>>2];c[K+4>>2]=c[A+4>>2];c[K+8>>2]=c[A+8>>2];c[K+12>>2]=c[A+12>>2];break}else{da=ea(ea(ea(-ea(fa*Sa))-ea(ca*Va))-ea(Ta*Ua));Ua=ea(g[B>>2]);Ta=ea(g[B+4>>2]);Va=ea(g[B+8>>2]);ca=ea(Xa-Ua);Sa=ea(Ya-Ta);fa=ea(Za-Va);Wa=ea(g[C>>2]);fb=ea(g[C+4>>2]);gb=ea(g[C+8>>2]);hb=ea(_a-Wa);ib=ea($a-fb);jb=ea(ab-gb);kb=ea(da/Y);Pa=kb>ea(1.0);Y=Pa?ea(1.0):kb;Pa=Y>ea(0.0);kb=Pa?Y:ea(0.0);Y=ea(Ua+ea(ca*kb));ca=ea(Ta+ea(Sa*kb));Sa=ea(Va+ea(fa*kb));fa=ea(Wa+ea(hb*kb));hb=ea(fb+ea(ib*kb));ib=ea(gb+ea(jb*kb));g[v>>2]=Y;g[h>>2]=ca;g[Z>>2]=Sa;g[_>>2]=ea(0.0);g[w>>2]=fa;g[$>>2]=hb;g[aa>>2]=ib;g[ba>>2]=ea(0.0);kb=ea(ca-hb);hb=ea(Sa-ib);g[K>>2]=ea(Y-fa);g[K+4>>2]=kb;g[K+8>>2]=hb;g[K+12>>2]=ea(0.0);break}}else if((eb|0)==3)qPa(K,A,B,C,D,E,G,H,I,F,v,w);else if((eb|0)==2)V6a(K,A,A+16|0,G,A,B,C,F,v,w);else if(!eb){c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}else{c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}while(0);c[z+0>>2]=c[K+0>>2];c[z+4>>2]=c[K+4>>2];c[z+8>>2]=c[K+8>>2];c[z+12>>2]=c[K+12>>2];ab=ea(g[z>>2]);$a=ea(g[z+4>>2]);_a=ea(g[z+8>>2]);Za=ea(ea(ea(ab*ab)+ea($a*$a))+ea(_a*_a));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];Ya=ea(g[v>>2]);Xa=ea(g[h>>2]);db=ea(g[Z>>2]);cb=ea(g[_>>2]);bb=ea(g[w>>2]);hb=ea(g[$>>2]);kb=ea(g[aa>>2]);ia=cb;ja=db;ka=Xa;la=Ya;ma=ea(g[ba>>2]);na=kb;oa=hb;pa=bb;qa=Za;ra=Za>X;sa=_a;ta=$a;ua=ab}do if(ra){K=z+4|0;G=z+8|0;I=f+4|0;H=f+8|0;eb=f+16|0;Pa=f+20|0;s=f+24|0;r=f+32|0;ha=f+36|0;za=f+40|0;ya=t+4|0;xa=t+8|0;wa=t+12|0;va=f+48|0;ga=f+52|0;Oa=f+56|0;Na=u+4|0;Ma=u+8|0;J=L+4|0;La=L+8|0;Ka=L+12|0;Ja=M+4|0;Ia=M+8|0;Ha=N+4|0;Ga=N+8|0;Fa=N+12|0;Ea=b+48|0;Da=e+48|0;Ca=A+4|0;Ba=A+8|0;Aa=B+4|0;Ra=B+8|0;Qa=C+4|0;lb=C+8|0;mb=P+4|0;nb=P+8|0;ob=P+12|0;pb=A+16|0;ab=V;$a=ua;_a=ta;Za=sa;bb=qa;hb=la;kb=ka;Ya=ja;Xa=ia;db=pa;cb=oa;fa=na;Y=ma;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];ib=ea(-$a);Sa=ea(-_a);ca=ea(-Za);qb=c[F>>2]|0;rb=B+(qb<<4)|0;jb=ea(ea(g[f>>2])*ib);gb=ea(jb+ea(ea(g[I>>2])*Sa));jb=ea(gb+ea(ea(g[H>>2])*ca));gb=ea(ea(g[eb>>2])*ib);fb=ea(gb+ea(ea(g[Pa>>2])*Sa));gb=ea(fb+ea(ea(g[s>>2])*ca));fb=ea(ea(g[r>>2])*ib);ib=ea(fb+ea(ea(g[ha>>2])*Sa));Sa=ea(ib+ea(ea(g[za>>2])*ca));g[t>>2]=jb;g[ya>>2]=gb;g[xa>>2]=Sa;g[wa>>2]=ea(0.0);FFb(u,b,t,D+(qb<<2)|0);c[rb+0>>2]=c[u+0>>2];c[rb+4>>2]=c[u+4>>2];c[rb+8>>2]=c[u+8>>2];c[rb+12>>2]=c[u+12>>2];Sa=ea(g[va>>2]);gb=ea(g[ga>>2]);jb=ea(g[Oa>>2]);ca=ea(g[u>>2]);ib=ea(g[Na>>2]);fb=ea(g[Ma>>2]);Wa=ea(ca*ea(g[f>>2]));Va=ea(Wa+ea(ib*ea(g[eb>>2])));Wa=ea(Va+ea(fb*ea(g[r>>2])));Va=ea(ca*ea(g[I>>2]));Ta=ea(Va+ea(ib*ea(g[Pa>>2])));Va=ea(Ta+ea(fb*ea(g[ha>>2])));Ta=ea(ca*ea(g[H>>2]));ca=ea(Ta+ea(ib*ea(g[s>>2])));ib=ea(gb+Va);Va=ea(jb+ea(ca+ea(fb*ea(g[za>>2]))));g[L>>2]=ea(Sa+Wa);g[J>>2]=ib;g[La>>2]=Va;g[Ka>>2]=ea(0.0);rb=c[F>>2]|0;CFb(M,e,z,C+(rb<<4)|0,E+(rb<<2)|0);Va=ea(g[L>>2]);ib=ea(g[J>>2]);Wa=ea(g[La>>2]);Sa=ea(g[M>>2]);fb=ea(g[Ja>>2]);ca=ea(g[Ia>>2]);jb=ea(Va-Sa);gb=ea(ib-fb);Ta=ea(Wa-ca);g[N>>2]=jb;g[Ha>>2]=gb;g[Ga>>2]=Ta;g[Fa>>2]=ea(0.0);sb=c[F>>2]|0;c[F>>2]=sb+1;rb=A+(sb<<4)|0;c[rb+0>>2]=c[N+0>>2];c[rb+4>>2]=c[N+4>>2];c[rb+8>>2]=c[N+8>>2];c[rb+12>>2]=c[N+12>>2];Ua=ea(g[Ea>>2]);da=ea(g[Da>>2]);tb=Ua>da?Ua:da;da=ab>tb?ab:tb;tb=ea(W+da);Ua=ea(bb*ea(tb*tb));ub=ea(g[z>>2]);vb=ea(g[K>>2]);wb=ea(g[G>>2]);tb=ea(ea(ea(ub*jb)+ea(vb*gb))+ea(wb*Ta));rb=ea(tb*tb)>Ua;if(tb>ea(0.0)){xb=rb;yb=rb^1}else{xb=0;yb=1}rb=ea(X*bb)>=ea(bb-tb);if((rb|xb)&(rb|yb^1))break;do if((sb|0)==3)qPa(P,A,B,C,D,E,N,L,M,F,v,w);else if((sb|0)==1){tb=ea(g[A>>2]);Ua=ea(g[Ca>>2]);zb=ea(g[Ba>>2]);Ab=ea(jb-tb);Bb=ea(gb-Ua);Cb=ea(Ta-zb);Db=ea(ea(ea(Ab*Ab)+ea(Bb*Bb))+ea(Cb*Cb));if(Db==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[P+0>>2]=c[A+0>>2];c[P+4>>2]=c[A+4>>2];c[P+8>>2]=c[A+8>>2];c[P+12>>2]=c[A+12>>2];break}else{Eb=ea(ea(ea(-ea(Ua*Bb))-ea(tb*Ab))-ea(zb*Cb));Cb=ea(g[B>>2]);zb=ea(g[Aa>>2]);Ab=ea(g[Ra>>2]);tb=ea(Va-Cb);Bb=ea(ib-zb);Ua=ea(Wa-Ab);Fb=ea(g[C>>2]);Gb=ea(g[Qa>>2]);Hb=ea(g[lb>>2]);Ib=ea(Sa-Fb);Jb=ea(fb-Gb);Kb=ea(ca-Hb);Lb=ea(Eb/Db);rb=Lb>ea(1.0);Db=rb?ea(1.0):Lb;rb=Db>ea(0.0);Lb=rb?Db:ea(0.0);Db=ea(Cb+ea(tb*Lb));tb=ea(zb+ea(Bb*Lb));Bb=ea(Ab+ea(Ua*Lb));Ua=ea(Fb+ea(Ib*Lb));Ib=ea(Gb+ea(Jb*Lb));Jb=ea(Hb+ea(Kb*Lb));g[v>>2]=Db;g[h>>2]=tb;g[Z>>2]=Bb;g[_>>2]=ea(0.0);g[w>>2]=Ua;g[$>>2]=Ib;g[aa>>2]=Jb;g[ba>>2]=ea(0.0);Lb=ea(tb-Ib);Ib=ea(Bb-Jb);g[P>>2]=ea(Db-Ua);g[mb>>2]=Lb;g[nb>>2]=Ib;g[ob>>2]=ea(0.0);break}}else if((sb|0)==2)V6a(P,A,pb,N,A,B,C,F,v,w);else if(!sb){c[v+0>>2]=c[L+0>>2];c[v+4>>2]=c[L+4>>2];c[v+8>>2]=c[L+8>>2];c[v+12>>2]=c[L+12>>2];c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}else{c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}while(0);c[z+0>>2]=c[P+0>>2];c[z+4>>2]=c[P+4>>2];c[z+8>>2]=c[P+8>>2];c[z+12>>2]=c[P+12>>2];ca=ea(g[z>>2]);fb=ea(g[K>>2]);Sa=ea(g[G>>2]);Wa=ea(ea(ea(ca*ca)+ea(fb*fb))+ea(Sa*Sa));c[x+0>>2]=c[Q+0>>2];c[x+4>>2]=c[Q+4>>2];c[x+8>>2]=c[Q+8>>2];Mb=bb>Wa;if(Wa>X^1|Mb^1){Nb=35;break}ib=ea(g[v>>2]);Va=ea(g[h>>2]);Ta=ea(g[Z>>2]);gb=ea(g[_>>2]);jb=ea(g[w>>2]);Ib=ea(g[$>>2]);Lb=ea(g[aa>>2]);ab=da;$a=ca;_a=fb;Za=Sa;bb=Wa;hb=ib;kb=Va;Ya=Ta;Xa=gb;db=jb;cb=Ib;fa=Lb;Y=ea(g[ba>>2])}if((Nb|0)==35){G=c[F>>2]|0;if(Mb){Ob=G;break}K=G+-1|0;if((n|0)!=0?(a[p>>0]=K,(K|0)!=0):0){G=0;do{a[n+G>>0]=c[D+(G<<2)>>2];a[o+G>>0]=c[E+(G<<2)>>2];G=G+1|0}while((G|0)!=(K|0))}g[v>>2]=hb;g[h>>2]=kb;g[Z>>2]=Ya;g[_>>2]=Xa;g[w>>2]=db;g[$>>2]=cb;g[aa>>2]=fa;g[ba>>2]=Y;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];Za=ea(hb-db);_a=ea(kb-cb);$a=ea(Ya-fa);g[z>>2]=Za;g[z+4>>2]=_a;g[z+8>>2]=$a;g[z+12>>2]=ea(0.0);ab=ea(T(ea(bb)));Lb=ea(ea(1.0)/ab);Ib=ea(Za*Lb);Za=ea(_a*Lb);_a=ea($a*Lb);Lb=ea(kb-ea(S*Za));$a=ea(Ya-ea(S*_a));g[j>>2]=ea(hb-ea(S*Ib));g[j+4>>2]=Lb;g[j+8>>2]=$a;g[j+12>>2]=ea(0.0);$a=ea(ea(U*Za)+cb);Lb=ea(ea(U*_a)+fa);g[k>>2]=ea(ea(U*Ib)+db);g[k+4>>2]=$a;g[k+8>>2]=Lb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(ab-W);K=m+4|0;c[K+0>>2]=c[R+0>>2];c[K+4>>2]=c[R+4>>2];c[K+8>>2]=c[R+8>>2];g[l>>2]=Ib;g[l+4>>2]=Za;g[l+8>>2]=_a;g[l+12>>2]=ea(0.0);Pb=3;i=q;return Pb|0}if((n|0)!=0?(a[p>>0]=sb,(sb|0)!=0):0){K=0;do{a[n+K>>0]=c[D+(K<<2)>>2];a[o+K>>0]=c[E+(K<<2)>>2];K=K+1|0}while((K|0)!=(sb|0))}if(!(yb&(xb^1))){Pb=0;i=q;return Pb|0}db=ea(T(ea(bb)));fa=ea(ea(1.0)/db);cb=ea(ub*fa);hb=ea(vb*fa);Ya=ea(wb*fa);fa=ea(g[v>>2]);kb=ea(g[h>>2]);Y=ea(kb-ea(S*hb));kb=ea(ea(g[Z>>2])-ea(S*Ya));g[j>>2]=ea(fa-ea(S*cb));g[j+4>>2]=Y;g[j+8>>2]=kb;g[j+12>>2]=ea(0.0);kb=ea(g[w>>2]);Y=ea(g[$>>2]);fa=ea(ea(U*hb)+Y);Y=ea(ea(U*Ya)+ea(g[aa>>2]));g[k>>2]=ea(ea(U*cb)+kb);g[k+4>>2]=fa;g[k+8>>2]=Y;g[k+12>>2]=ea(0.0);g[m>>2]=ea(db-W);K=m+4|0;c[K+0>>2]=c[O+0>>2];c[K+4>>2]=c[O+4>>2];c[K+8>>2]=c[O+8>>2];g[l>>2]=cb;g[l+4>>2]=hb;g[l+8>>2]=Ya;g[l+12>>2]=ea(0.0);Pb=1;i=q;return Pb|0}else Ob=c[F>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Ob,(Ob|0)!=0):0){p=0;do{a[n+p>>0]=c[D+(p<<2)>>2];a[o+p>>0]=c[E+(p<<2)>>2];p=p+1|0}while((p|0)!=(Ob|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Pb=6;i=q;return Pb|0}function UFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=0,M=Im,N=Im,O=0,P=Im,Q=0,R=Im,S=0,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=0,Yb=0,Zb=0,_b=0,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=0,Bc=Im,Cc=Im,Dc=Im,Ec=0;e=i;i=i+480|0;n=e+416|0;o=e+272|0;p=e+192|0;q=e+208|0;r=e+48|0;s=e+256|0;t=e+288|0;u=e+368|0;v=e+400|0;w=e+224|0;x=e+32|0;y=e+432|0;z=e+456|0;A=e+468|0;B=e+64|0;C=e+128|0;D=e+304|0;E=e+384|0;F=e+240|0;G=e;H=e+444|0;I=e+16|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];J=ea(g[h>>2]);y=h+4|0;K=ea(g[y>>2]);L=h+8|0;M=ea(g[L>>2]);N=ea(g[f>>2]);O=f+4|0;P=ea(g[O>>2]);Q=f+8|0;R=ea(g[Q>>2]);c[A>>2]=1;S=d+48|0;U=d+48|0;V=ea(g[U>>2]);W=d+52|0;X=ea(g[W>>2]);Y=d+56|0;Z=ea(g[Y>>2]);_=ea(ea(ea(V*V)+ea(X*X))+ea(Z*Z))>ea(1.1920929e-07);c[o+0>>2]=c[S+0>>2];c[o+4>>2]=c[S+4>>2];c[o+8>>2]=c[S+8>>2];c[o+12>>2]=c[S+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);S=_?o:n;Z=ea(g[S>>2]);X=ea(g[S+4>>2]);V=ea(g[S+8>>2]);$=ea(ea(1.0)/ea(T(ea(ea(ea(Z*Z)+ea(X*X))+ea(V*V)))));aa=ea(Z*$);Z=ea(X*$);X=ea(V*$);$=ea(-aa);V=ea(-Z);ba=ea(-X);ca=ea(g[d>>2]);da=ea(ca*$);S=d+4|0;fa=ea(g[S>>2]);ga=ea(da+ea(fa*V));n=d+8|0;da=ea(g[n>>2]);ha=ea(ga+ea(da*ba));o=d+16|0;ga=ea(g[o>>2]);ia=ea(ga*$);_=d+20|0;ja=ea(g[_>>2]);ka=ea(ia+ea(ja*V));la=d+24|0;ia=ea(g[la>>2]);ma=ea(ka+ea(ia*ba));na=d+32|0;ka=ea(g[na>>2]);oa=ea(ka*$);pa=d+36|0;$=ea(g[pa>>2]);qa=ea(oa+ea($*V));ra=d+40|0;V=ea(g[ra>>2]);oa=ea(qa+ea(V*ba));sa=a+96|0;ta=a+96|0;ba=ea(g[ta>>2]);ua=a+100|0;qa=ea(g[ua>>2]);va=a+104|0;wa=ea(ea(ea(ha*ba)+ea(ma*qa))+ea(oa*ea(g[va>>2])));xa=a+112|0;ya=a+112|0;qa=ea(g[ya>>2]);za=a+116|0;ba=ea(g[za>>2]);Aa=a+120|0;Ba=wa>ea(ea(ea(ha*qa)+ea(ma*ba))+ea(oa*ea(g[Aa>>2])));c[q+0>>2]=c[sa+0>>2];c[q+4>>2]=c[sa+4>>2];c[q+8>>2]=c[sa+8>>2];c[q+12>>2]=c[sa+12>>2];c[p+0>>2]=c[xa+0>>2];c[p+4>>2]=c[xa+4>>2];c[p+8>>2]=c[xa+8>>2];c[p+12>>2]=c[xa+12>>2];Ca=Ba?q:p;oa=ea(g[Ca>>2]);ba=ea(g[Ca+4>>2]);ma=ea(g[Ca+8>>2]);qa=ea(g[U>>2]);ha=ea(g[W>>2]);wa=ea(ea(ea(ea(ca*oa)+ea(ga*ba))+ea(ka*ma))+qa);qa=ea(ea(ea(ea(fa*oa)+ea(ja*ba))+ea($*ma))+ha);ha=ea(ea(ea(ea(da*oa)+ea(ia*ba))+ea(V*ma))+ea(g[Y>>2]));Ca=b+96|0;Ba=b+96|0;ma=ea(g[Ba>>2]);Da=b+100|0;V=ea(g[Da>>2]);Ea=b+104|0;ba=ea(ea(ea(aa*ma)+ea(Z*V))+ea(X*ea(g[Ea>>2])));Fa=b+112|0;Ga=b+112|0;V=ea(g[Ga>>2]);Ha=b+116|0;ma=ea(g[Ha>>2]);Ia=b+120|0;Ja=ba>ea(ea(ea(aa*V)+ea(Z*ma))+ea(X*ea(g[Ia>>2])));c[q+0>>2]=c[Ca+0>>2];c[q+4>>2]=c[Ca+4>>2];c[q+8>>2]=c[Ca+8>>2];c[q+12>>2]=c[Ca+12>>2];c[p+0>>2]=c[Fa+0>>2];c[p+4>>2]=c[Fa+4>>2];c[p+8>>2]=c[Fa+8>>2];c[p+12>>2]=c[Fa+12>>2];Ka=Ja?q:p;X=ea(g[Ka>>2]);ma=ea(g[Ka+4>>2]);Z=ea(g[Ka+8>>2]);V=ea(wa-X);aa=ea(qa-ma);ba=ea(ha-Z);g[B>>2]=V;Ka=B+4|0;g[Ka>>2]=aa;Ja=B+8|0;g[Ja>>2]=ba;La=B+12|0;g[La>>2]=ea(0.0);Ma=B+16|0;c[Ma+0>>2]=c[x+0>>2];c[Ma+4>>2]=c[x+4>>2];c[Ma+8>>2]=c[x+8>>2];c[Ma+12>>2]=c[x+12>>2];Na=B+32|0;c[Na+0>>2]=c[x+0>>2];c[Na+4>>2]=c[x+4>>2];c[Na+8>>2]=c[x+8>>2];c[Na+12>>2]=c[x+12>>2];Na=B+48|0;c[Na+0>>2]=c[x+0>>2];c[Na+4>>2]=c[x+4>>2];c[Na+8>>2]=c[x+8>>2];c[Na+12>>2]=c[x+12>>2];g[C>>2]=wa;Na=C+4|0;g[Na>>2]=qa;Oa=C+8|0;g[Oa>>2]=ha;g[C+12>>2]=ea(0.0);Pa=C+16|0;c[Pa+0>>2]=c[x+0>>2];c[Pa+4>>2]=c[x+4>>2];c[Pa+8>>2]=c[x+8>>2];c[Pa+12>>2]=c[x+12>>2];Pa=C+32|0;c[Pa+0>>2]=c[x+0>>2];c[Pa+4>>2]=c[x+4>>2];c[Pa+8>>2]=c[x+8>>2];c[Pa+12>>2]=c[x+12>>2];Pa=C+48|0;c[Pa+0>>2]=c[x+0>>2];c[Pa+4>>2]=c[x+4>>2];c[Pa+8>>2]=c[x+8>>2];c[Pa+12>>2]=c[x+12>>2];g[D>>2]=X;Pa=D+4|0;g[Pa>>2]=ma;Qa=D+8|0;g[Qa>>2]=Z;Ra=D+12|0;g[Ra>>2]=ea(0.0);Sa=D+16|0;c[Sa+0>>2]=c[x+0>>2];c[Sa+4>>2]=c[x+4>>2];c[Sa+8>>2]=c[x+8>>2];c[Sa+12>>2]=c[x+12>>2];Sa=D+32|0;c[Sa+0>>2]=c[x+0>>2];c[Sa+4>>2]=c[x+4>>2];c[Sa+8>>2]=c[x+8>>2];c[Sa+12>>2]=c[x+12>>2];Sa=D+48|0;c[Sa+0>>2]=c[x+0>>2];c[Sa+4>>2]=c[x+4>>2];c[Sa+8>>2]=c[x+8>>2];c[Sa+12>>2]=c[x+12>>2];ia=ea(-V);oa=ea(-aa);da=ea(-ba);c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];$=ea(g[a+32>>2]);ja=ea(g[b+32>>2]);fa=ea(($>ja?ja:$)*ea(.100000001));$=ea(fa*fa);fa=ea(ea(m*m)+$);g[F>>2]=wa;b=F+4|0;g[b>>2]=qa;x=F+8|0;g[x>>2]=ha;Sa=F+12|0;g[Sa>>2]=ea(0.0);g[G>>2]=X;Ta=G+4|0;g[Ta>>2]=ma;Ua=G+8|0;g[Ua>>2]=Z;Va=G+12|0;g[Va>>2]=ea(0.0);Z=ea(ea(ea(V*V)+ea(aa*aa))+ea(ba*ba));a:do if(Z>$){Wa=E+4|0;Xa=E+8|0;Ya=E+12|0;Za=D+16|0;_a=D+20|0;$a=D+24|0;ab=D+28|0;bb=D+32|0;cb=D+36|0;db=D+40|0;eb=D+44|0;fb=C+16|0;gb=C+20|0;hb=C+24|0;ib=B+16|0;jb=B+20|0;kb=B+24|0;lb=B+28|0;mb=C+32|0;nb=C+36|0;ob=C+40|0;pb=B+32|0;qb=B+36|0;rb=B+40|0;sb=B+44|0;tb=I+4|0;ub=I+8|0;vb=I+12|0;ba=ia;aa=oa;V=da;ma=ea(ea(J*ea(0.0))+N);X=ea(ea(K*ea(0.0))+P);ja=ea(ea(M*ea(0.0))+R);ka=ea(0.0);ga=ea(0.0);ca=ha;wb=qa;xb=wa;yb=ia;zb=oa;Ab=da;Bb=Z;while(1){Cb=ea(ea(1.0)/ea(T(ea(ea(V*V)+ea(ea(aa*aa)+ea(ba*ba))))));Db=ea(ba*Cb);Eb=ea(aa*Cb);Fb=ea(V*Cb);Cb=ea(-Db);Gb=ea(-Eb);Hb=ea(-Fb);Ib=ea(g[d>>2]);Jb=ea(Db*Ib);Kb=ea(g[S>>2]);Lb=ea(Jb+ea(Eb*Kb));Jb=ea(g[n>>2]);Mb=ea(Lb+ea(Fb*Jb));Lb=ea(g[o>>2]);Nb=ea(Db*Lb);Ob=ea(g[_>>2]);Pb=ea(Nb+ea(Eb*Ob));Nb=ea(g[la>>2]);Qb=ea(Pb+ea(Fb*Nb));Pb=ea(g[na>>2]);Rb=ea(Db*Pb);Sb=ea(g[pa>>2]);Tb=ea(Rb+ea(Eb*Sb));Rb=ea(g[ra>>2]);Ub=ea(Tb+ea(Fb*Rb));Tb=ea(g[ta>>2]);Vb=ea(g[ua>>2]);Wb=ea(ea(ea(Mb*Tb)+ea(Qb*Vb))+ea(Ub*ea(g[va>>2])));Vb=ea(g[ya>>2]);Tb=ea(g[za>>2]);Xb=Wb>ea(ea(ea(Mb*Vb)+ea(Qb*Tb))+ea(Ub*ea(g[Aa>>2])));c[q+0>>2]=c[sa+0>>2];c[q+4>>2]=c[sa+4>>2];c[q+8>>2]=c[sa+8>>2];c[q+12>>2]=c[sa+12>>2];c[p+0>>2]=c[xa+0>>2];c[p+4>>2]=c[xa+4>>2];c[p+8>>2]=c[xa+8>>2];c[p+12>>2]=c[xa+12>>2];Yb=Xb?q:p;Ub=ea(g[Yb>>2]);Tb=ea(g[Yb+4>>2]);Qb=ea(g[Yb+8>>2]);Vb=ea(g[U>>2]);Mb=ea(g[W>>2]);Wb=ea(ea(ea(ea(Ib*Ub)+ea(Lb*Tb))+ea(Pb*Qb))+Vb);Vb=ea(ea(ea(ea(Kb*Ub)+ea(Ob*Tb))+ea(Sb*Qb))+Mb);Mb=ea(ea(ea(ea(Jb*Ub)+ea(Nb*Tb))+ea(Rb*Qb))+ea(g[Y>>2]));Qb=ea(g[Ba>>2]);Rb=ea(g[Da>>2]);Tb=ea(ea(ea(Qb*Cb)+ea(Rb*Gb))+ea(ea(g[Ea>>2])*Hb));Rb=ea(g[Ga>>2]);Qb=ea(g[Ha>>2]);Yb=Tb>ea(ea(ea(Rb*Cb)+ea(Qb*Gb))+ea(ea(g[Ia>>2])*Hb));c[q+0>>2]=c[Ca+0>>2];c[q+4>>2]=c[Ca+4>>2];c[q+8>>2]=c[Ca+8>>2];c[q+12>>2]=c[Ca+12>>2];c[p+0>>2]=c[Fa+0>>2];c[p+4>>2]=c[Fa+4>>2];c[p+8>>2]=c[Fa+8>>2];c[p+12>>2]=c[Fa+12>>2];Xb=Yb?q:p;Hb=ea(g[Xb>>2]);Gb=ea(g[Xb+4>>2]);Qb=ea(ma+Hb);Hb=ea(X+Gb);Gb=ea(ja+ea(g[Xb+8>>2]));Cb=ea(Wb-Qb);Rb=ea(Vb-Hb);Tb=ea(Mb-Gb);g[E>>2]=Cb;g[Wa>>2]=Rb;g[Xa>>2]=Tb;g[Ya>>2]=ea(0.0);Nb=ea(ea(ea(ea(-ea(Eb*Rb))-ea(Db*Cb))-ea(Fb*Tb))-m);Ub=ea(g[h>>2]);Jb=ea(g[y>>2]);Sb=ea(g[L>>2]);Ob=ea(ea(ea(Db*Ub)+ea(Eb*Jb))+ea(Fb*Sb));if(Nb>ea(0.0)){if(Ob>=ea(0.0)){Zb=0;_b=22;break}Fb=ea(ka-ea(Nb/Ob));c[z+0>>2]=c[H+0>>2];c[z+4>>2]=c[H+4>>2];c[z+8>>2]=c[H+8>>2];if(Fb>ka){if(Fb>ea(1.0)){Zb=0;_b=22;break}Ob=ea(g[f>>2]);Nb=ea(g[O>>2]);Eb=ea(ea(Fb*Ub)+Ob);Ob=ea(ea(Fb*Jb)+Nb);Nb=ea(ea(Fb*Sb)+ea(g[Q>>2]));Sb=ea(Eb-ma);Jb=ea(Ob-X);Ub=ea(Nb-ja);Db=ea(g[D>>2]);Kb=ea(g[Pa>>2]);Pb=ea(Sb+Db);Db=ea(Jb+Kb);Kb=ea(Ub+ea(g[Qa>>2]));Lb=ea(g[Za>>2]);Ib=ea(g[_a>>2]);$b=ea(Sb+Lb);Lb=ea(Jb+Ib);Ib=ea(Ub+ea(g[$a>>2]));ac=ea(g[bb>>2]);bc=ea(g[cb>>2]);cc=ea(Sb+ac);ac=ea(Jb+bc);bc=ea(Ub+ea(g[db>>2]));g[D>>2]=Pb;g[Pa>>2]=Db;g[Qa>>2]=Kb;g[Ra>>2]=ea(0.0);g[Za>>2]=$b;g[_a>>2]=Lb;g[$a>>2]=Ib;g[ab>>2]=ea(0.0);g[bb>>2]=cc;g[cb>>2]=ac;g[db>>2]=bc;g[eb>>2]=ea(0.0);Ub=ea(g[C>>2]);Jb=ea(g[Na>>2]);Sb=ea(Jb-Db);Db=ea(ea(g[Oa>>2])-Kb);g[B>>2]=ea(Ub-Pb);g[Ka>>2]=Sb;g[Ja>>2]=Db;g[La>>2]=ea(0.0);Db=ea(g[fb>>2]);Sb=ea(g[gb>>2]);Pb=ea(Sb-Lb);Lb=ea(ea(g[hb>>2])-Ib);g[ib>>2]=ea(Db-$b);g[jb>>2]=Pb;g[kb>>2]=Lb;g[lb>>2]=ea(0.0);Lb=ea(g[mb>>2]);Pb=ea(g[nb>>2]);$b=ea(Pb-ac);ac=ea(ea(g[ob>>2])-bc);g[pb>>2]=ea(Lb-cc);g[qb>>2]=$b;g[rb>>2]=ac;g[sb>>2]=ea(0.0);c[q+0>>2]=c[Ca+0>>2];c[q+4>>2]=c[Ca+4>>2];c[q+8>>2]=c[Ca+8>>2];c[q+12>>2]=c[Ca+12>>2];c[p+0>>2]=c[Fa+0>>2];c[p+4>>2]=c[Fa+4>>2];c[p+8>>2]=c[Fa+8>>2];c[p+12>>2]=c[Fa+12>>2];Xb=Yb?q:p;ac=ea(g[Xb>>2]);$b=ea(g[Xb+4>>2]);cc=ea(Eb+ac);ac=ea(Ob+$b);$b=ea(Nb+ea(g[Xb+8>>2]));Lb=ea(Wb-cc);bc=ea(Vb-ac);Pb=ea(Mb-$b);g[E>>2]=Lb;g[Wa>>2]=bc;g[Xa>>2]=Pb;g[Ya>>2]=ea(0.0);dc=cc;ec=ac;fc=$b;gc=Lb;hc=bc;ic=Pb;jc=ea(3402823469999999843913219.0e14);kc=Fb;lc=Nb;mc=Ob;nc=Eb;oc=V;pc=aa;qc=ba}else{dc=Qb;ec=Hb;fc=Gb;gc=Cb;hc=Rb;ic=Tb;jc=Bb;kc=Fb;lc=ja;mc=X;nc=ma;oc=Ab;pc=zb;qc=yb}}else{dc=Qb;ec=Hb;fc=Gb;gc=Cb;hc=Rb;ic=Tb;jc=Bb;kc=ka;lc=ja;mc=X;nc=ma;oc=Ab;pc=zb;qc=yb}Xb=c[A>>2]|0;g[C+(Xb<<4)>>2]=Wb;g[C+(Xb<<4)+4>>2]=Vb;g[C+(Xb<<4)+8>>2]=Mb;g[C+(Xb<<4)+12>>2]=ea(0.0);g[D+(Xb<<4)>>2]=dc;g[D+(Xb<<4)+4>>2]=ec;g[D+(Xb<<4)+8>>2]=fc;g[D+(Xb<<4)+12>>2]=ea(0.0);c[A>>2]=Xb+1;Yb=B+(Xb<<4)|0;c[Yb+0>>2]=c[E+0>>2];c[Yb+4>>2]=c[E+4>>2];c[Yb+8>>2]=c[E+8>>2];c[Yb+12>>2]=c[E+12>>2];do if((Xb|0)==2)V6a(I,B,Ma,E,B,C,D,A,F,G);else if((Xb|0)==1){Tb=ea(g[B>>2]);Rb=ea(g[Ka>>2]);Cb=ea(g[Ja>>2]);Gb=ea(gc-Tb);Hb=ea(hc-Rb);Qb=ea(ic-Cb);Fb=ea(ea(ea(Gb*Gb)+ea(Hb*Hb))+ea(Qb*Qb));if(Fb==ea(0.0)){c[A>>2]=1;c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];c[I+0>>2]=c[B+0>>2];c[I+4>>2]=c[B+4>>2];c[I+8>>2]=c[B+8>>2];c[I+12>>2]=c[B+12>>2];break}else{Eb=ea(ea(ea(-ea(Rb*Hb))-ea(Tb*Gb))-ea(Cb*Qb));Qb=ea(g[C>>2]);Cb=ea(g[Na>>2]);Gb=ea(g[Oa>>2]);Tb=ea(Wb-Qb);Hb=ea(Vb-Cb);Rb=ea(Mb-Gb);Ob=ea(g[D>>2]);Nb=ea(g[Pa>>2]);Pb=ea(g[Qa>>2]);bc=ea(dc-Ob);Lb=ea(ec-Nb);$b=ea(fc-Pb);ac=ea(Eb/Fb);Yb=ac>ea(1.0);Fb=Yb?ea(1.0):ac;Yb=Fb>ea(0.0);ac=Yb?Fb:ea(0.0);Fb=ea(Qb+ea(Tb*ac));Tb=ea(Cb+ea(Hb*ac));Hb=ea(Gb+ea(Rb*ac));Rb=ea(Ob+ea(bc*ac));bc=ea(Nb+ea(Lb*ac));Lb=ea(Pb+ea($b*ac));g[F>>2]=Fb;g[b>>2]=Tb;g[x>>2]=Hb;g[Sa>>2]=ea(0.0);g[G>>2]=Rb;g[Ta>>2]=bc;g[Ua>>2]=Lb;g[Va>>2]=ea(0.0);ac=ea(Tb-bc);bc=ea(Hb-Lb);g[I>>2]=ea(Fb-Rb);g[tb>>2]=ac;g[ub>>2]=bc;g[vb>>2]=ea(0.0);break}}else if(!Xb){g[F>>2]=Wb;g[b>>2]=Vb;g[x>>2]=Mb;g[Sa>>2]=ea(0.0);g[G>>2]=dc;g[Ta>>2]=ec;g[Ua>>2]=fc;g[Va>>2]=ea(0.0);c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2]}else if((Xb|0)==3)pPa(I,B,C,D,A,F,G);else{c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2]}while(0);Mb=ea(g[I>>2]);Vb=ea(g[tb>>2]);Wb=ea(g[ub>>2]);bc=ea(-Mb);ac=ea(-Vb);Rb=ea(-Wb);Fb=ea(ea(ea(Mb*Mb)+ea(Vb*Vb))+ea(Wb*Wb));Xb=jc>Fb;Yb=Xb<<31>>31;if(!(Fb>fa)){rc=kc;sc=ga;tc=ca;uc=wb;vc=xb;wc=Rb;xc=ac;yc=bc;zc=Fb;Ac=Yb;Bc=oc;Cc=pc;Dc=qc;break a}if(!Xb){rc=kc;sc=ga;tc=ca;uc=wb;vc=xb;wc=Rb;xc=ac;yc=bc;zc=Fb;Ac=Yb;Bc=oc;Cc=pc;Dc=qc;break a}Wb=ea(g[F>>2]);Vb=ea(g[b>>2]);Mb=ea(g[x>>2]);ba=bc;aa=ac;V=Rb;ma=nc;X=mc;ja=lc;ka=kc;ga=ea(g[Sa>>2]);ca=Mb;wb=Vb;xb=Wb;yb=qc;zb=pc;Ab=oc;Bb=Fb}if((_b|0)==22){i=e;return Zb|0}}else{rc=ea(0.0);sc=ea(0.0);tc=ha;uc=qa;vc=wa;wc=da;xc=oa;yc=ia;zc=Z;Ac=-1;Bc=da;Cc=oa;Dc=ia}while(0);_b=c[a+64>>2]|0;I=c[a+68>>2]|0;E=c[a+72>>2]|0;if(zc>$)Ec=(Ac|0)==0?r:s;else Ec=r;g[s>>2]=yc;g[s+4>>2]=xc;g[s+8>>2]=wc;g[s+12>>2]=ea(0.0);g[r>>2]=Dc;g[r+4>>2]=Cc;g[r+8>>2]=Bc;g[r+12>>2]=ea(0.0);Bc=ea(g[Ec>>2]);Cc=ea(g[Ec+4>>2]);Dc=ea(g[Ec+8>>2]);wc=ea(ea(1.0)/ea(T(ea(ea(ea(Bc*Bc)+ea(Cc*Cc))+ea(Dc*Dc)))));xc=ea(-ea(Bc*wc));Bc=ea(-ea(Cc*wc));Cc=ea(-ea(Dc*wc));g[k>>2]=xc;g[k+4>>2]=Bc;g[k+8>>2]=Cc;g[k+12>>2]=ea(0.0);g[j>>2]=rc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[F+0>>2];c[u+4>>2]=c[F+4>>2];c[u+8>>2]=c[F+8>>2];c[u+12>>2]=c[F+12>>2];g[t>>2]=vc;g[t+4>>2]=uc;g[t+8>>2]=tc;g[t+12>>2]=sc;z=(Ac|0)==0?t:u;sc=ea(g[z>>2]);tc=ea(g[z+4>>2]);uc=ea(g[z+8>>2]);g[F>>2]=sc;g[b>>2]=tc;g[x>>2]=uc;g[Sa>>2]=ea(0.0);vc=ea(g[a+16>>2]);rc=ea(sc-ea(vc*xc));xc=ea(tc-ea(vc*Bc));Bc=ea(uc-ea(vc*Cc));c[v+0>>2]=c[F+0>>2];c[v+4>>2]=c[F+4>>2];c[v+8>>2]=c[F+8>>2];c[v+12>>2]=c[F+12>>2];g[w>>2]=rc;g[w+4>>2]=xc;g[w+8>>2]=Bc;g[w+12>>2]=ea(0.0);Bc=ea(g[((_b|0)==0?v:w)>>2]);xc=ea(g[((I|0)==0?v:w)+4>>2]);rc=ea(g[((E|0)==0?v:w)+8>>2]);g[l>>2]=Bc;g[l+4>>2]=xc;g[l+8>>2]=rc;g[l+12>>2]=ea(0.0);Zb=1;i=e;return Zb|0}function VFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=0,M=Im,N=Im,O=0,P=Im,Q=0,R=Im,S=0,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=0,Xb=0,Yb=0,Zb=Im,_b=Im,$b=0,ac=0,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=0,Hc=Im,Ic=Im,Jc=Im,Kc=0;e=i;i=i+480|0;n=e+416|0;o=e+272|0;p=e+192|0;q=e+208|0;r=e+48|0;s=e+256|0;t=e+288|0;u=e+368|0;v=e+400|0;w=e+224|0;x=e+32|0;y=e+432|0;z=e+456|0;A=e+468|0;B=e+64|0;C=e+128|0;D=e+304|0;E=e+384|0;F=e+240|0;G=e;H=e+444|0;I=e+16|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];J=ea(g[h>>2]);y=h+4|0;K=ea(g[y>>2]);L=h+8|0;M=ea(g[L>>2]);N=ea(g[f>>2]);O=f+4|0;P=ea(g[O>>2]);Q=f+8|0;R=ea(g[Q>>2]);c[A>>2]=1;S=d+48|0;U=d+48|0;V=ea(g[U>>2]);W=d+52|0;X=ea(g[W>>2]);Y=d+56|0;Z=ea(g[Y>>2]);_=ea(ea(ea(V*V)+ea(X*X))+ea(Z*Z))>ea(1.1920929e-07);c[o+0>>2]=c[S+0>>2];c[o+4>>2]=c[S+4>>2];c[o+8>>2]=c[S+8>>2];c[o+12>>2]=c[S+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);S=_?o:n;Z=ea(g[S>>2]);X=ea(g[S+4>>2]);V=ea(g[S+8>>2]);$=ea(ea(1.0)/ea(T(ea(ea(ea(Z*Z)+ea(X*X))+ea(V*V)))));aa=ea(Z*$);Z=ea(X*$);X=ea(V*$);$=ea(-aa);V=ea(-Z);ba=ea(-X);ca=ea(g[d>>2]);da=ea(ca*$);S=d+4|0;fa=ea(g[S>>2]);ga=ea(da+ea(fa*V));n=d+8|0;da=ea(g[n>>2]);ha=ea(ga+ea(da*ba));o=d+16|0;ga=ea(g[o>>2]);ia=ea(ga*$);_=d+20|0;ja=ea(g[_>>2]);ka=ea(ia+ea(ja*V));la=d+24|0;ia=ea(g[la>>2]);ma=ea(ka+ea(ia*ba));na=d+32|0;ka=ea(g[na>>2]);oa=ea(ka*$);pa=d+36|0;$=ea(g[pa>>2]);qa=ea(oa+ea($*V));ra=d+40|0;V=ea(g[ra>>2]);oa=ea(qa+ea(V*ba));sa=a+96|0;ta=a+96|0;ba=ea(g[ta>>2]);ua=a+100|0;qa=ea(g[ua>>2]);va=a+104|0;wa=ea(ea(ea(ha*ba)+ea(ma*qa))+ea(oa*ea(g[va>>2])));xa=a+112|0;ya=a+112|0;qa=ea(g[ya>>2]);za=a+116|0;ba=ea(g[za>>2]);Aa=a+120|0;Ba=wa>ea(ea(ea(ha*qa)+ea(ma*ba))+ea(oa*ea(g[Aa>>2])));c[q+0>>2]=c[sa+0>>2];c[q+4>>2]=c[sa+4>>2];c[q+8>>2]=c[sa+8>>2];c[q+12>>2]=c[sa+12>>2];c[p+0>>2]=c[xa+0>>2];c[p+4>>2]=c[xa+4>>2];c[p+8>>2]=c[xa+8>>2];c[p+12>>2]=c[xa+12>>2];Ca=Ba?q:p;oa=ea(g[Ca>>2]);ba=ea(g[Ca+4>>2]);ma=ea(g[Ca+8>>2]);qa=ea(g[U>>2]);ha=ea(g[W>>2]);wa=ea(ea(ea(ea(ca*oa)+ea(ga*ba))+ea(ka*ma))+qa);qa=ea(ea(ea(ea(fa*oa)+ea(ja*ba))+ea($*ma))+ha);ha=ea(ea(ea(ea(da*oa)+ea(ia*ba))+ea(V*ma))+ea(g[Y>>2]));Ca=aa>ea(0.0);Ba=Z>ea(0.0);Da=X>ea(0.0);Ea=b+144|0;c[q+0>>2]=c[Ea+0>>2];c[q+4>>2]=c[Ea+4>>2];c[q+8>>2]=c[Ea+8>>2];c[q+12>>2]=c[Ea+12>>2];Fa=b+144|0;X=ea(g[Fa>>2]);Ga=b+148|0;Z=ea(g[Ga>>2]);Ha=b+152|0;aa=ea(-Z);Z=ea(-ea(g[Ha>>2]));g[p>>2]=ea(-X);g[p+4>>2]=aa;g[p+8>>2]=Z;g[p+12>>2]=ea(0.0);Z=ea(g[(Ca?q:p)>>2]);aa=ea(g[(Ba?q:p)+4>>2]);X=ea(g[(Da?q:p)+8>>2]);ma=ea(wa-Z);V=ea(qa-aa);ba=ea(ha-X);g[B>>2]=ma;Da=B+4|0;g[Da>>2]=V;Ba=B+8|0;g[Ba>>2]=ba;Ca=B+12|0;g[Ca>>2]=ea(0.0);Ia=B+16|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];Ja=B+32|0;c[Ja+0>>2]=c[x+0>>2];c[Ja+4>>2]=c[x+4>>2];c[Ja+8>>2]=c[x+8>>2];c[Ja+12>>2]=c[x+12>>2];Ja=B+48|0;c[Ja+0>>2]=c[x+0>>2];c[Ja+4>>2]=c[x+4>>2];c[Ja+8>>2]=c[x+8>>2];c[Ja+12>>2]=c[x+12>>2];g[C>>2]=wa;Ja=C+4|0;g[Ja>>2]=qa;Ka=C+8|0;g[Ka>>2]=ha;g[C+12>>2]=ea(0.0);La=C+16|0;c[La+0>>2]=c[x+0>>2];c[La+4>>2]=c[x+4>>2];c[La+8>>2]=c[x+8>>2];c[La+12>>2]=c[x+12>>2];La=C+32|0;c[La+0>>2]=c[x+0>>2];c[La+4>>2]=c[x+4>>2];c[La+8>>2]=c[x+8>>2];c[La+12>>2]=c[x+12>>2];La=C+48|0;c[La+0>>2]=c[x+0>>2];c[La+4>>2]=c[x+4>>2];c[La+8>>2]=c[x+8>>2];c[La+12>>2]=c[x+12>>2];g[D>>2]=Z;La=D+4|0;g[La>>2]=aa;Ma=D+8|0;g[Ma>>2]=X;Na=D+12|0;g[Na>>2]=ea(0.0);Oa=D+16|0;c[Oa+0>>2]=c[x+0>>2];c[Oa+4>>2]=c[x+4>>2];c[Oa+8>>2]=c[x+8>>2];c[Oa+12>>2]=c[x+12>>2];Oa=D+32|0;c[Oa+0>>2]=c[x+0>>2];c[Oa+4>>2]=c[x+4>>2];c[Oa+8>>2]=c[x+8>>2];c[Oa+12>>2]=c[x+12>>2];Oa=D+48|0;c[Oa+0>>2]=c[x+0>>2];c[Oa+4>>2]=c[x+4>>2];c[Oa+8>>2]=c[x+8>>2];c[Oa+12>>2]=c[x+12>>2];ia=ea(-ma);oa=ea(-V);da=ea(-ba);c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];$=ea(g[a+32>>2]);ja=ea(g[b+32>>2]);fa=ea(($>ja?ja:$)*ea(.100000001));$=ea(fa*fa);fa=ea(ea(m*m)+$);g[F>>2]=wa;b=F+4|0;g[b>>2]=qa;x=F+8|0;g[x>>2]=ha;Oa=F+12|0;g[Oa>>2]=ea(0.0);g[G>>2]=Z;Pa=G+4|0;g[Pa>>2]=aa;Qa=G+8|0;g[Qa>>2]=X;Ra=G+12|0;g[Ra>>2]=ea(0.0);X=ea(ea(ea(ma*ma)+ea(V*V))+ea(ba*ba));a:do if(X>$){Sa=p+4|0;Ta=p+8|0;Ua=p+12|0;Va=E+4|0;Wa=E+8|0;Xa=E+12|0;Ya=D+16|0;Za=D+20|0;_a=D+24|0;$a=D+28|0;ab=D+32|0;bb=D+36|0;cb=D+40|0;db=D+44|0;eb=C+16|0;fb=C+20|0;gb=C+24|0;hb=B+16|0;ib=B+20|0;jb=B+24|0;kb=B+28|0;lb=C+32|0;mb=C+36|0;nb=C+40|0;ob=B+32|0;pb=B+36|0;qb=B+40|0;rb=B+44|0;sb=p+4|0;tb=p+8|0;ub=p+12|0;vb=I+4|0;wb=I+8|0;xb=I+12|0;ba=ia;V=oa;ma=da;aa=ea(ea(J*ea(0.0))+N);Z=ea(ea(K*ea(0.0))+P);ja=ea(ea(M*ea(0.0))+R);ka=ea(0.0);ga=ea(0.0);ca=ha;yb=qa;zb=wa;Ab=ia;Bb=oa;Cb=da;Db=X;while(1){Eb=ea(ea(1.0)/ea(T(ea(ea(ma*ma)+ea(ea(V*V)+ea(ba*ba))))));Fb=ea(ba*Eb);Gb=ea(V*Eb);Hb=ea(ma*Eb);Eb=ea(g[d>>2]);Ib=ea(Fb*Eb);Jb=ea(g[S>>2]);Kb=ea(Ib+ea(Gb*Jb));Ib=ea(g[n>>2]);Lb=ea(Kb+ea(Hb*Ib));Kb=ea(g[o>>2]);Mb=ea(Fb*Kb);Nb=ea(g[_>>2]);Ob=ea(Mb+ea(Gb*Nb));Mb=ea(g[la>>2]);Pb=ea(Ob+ea(Hb*Mb));Ob=ea(g[na>>2]);Qb=ea(Fb*Ob);Rb=ea(g[pa>>2]);Sb=ea(Qb+ea(Gb*Rb));Qb=ea(g[ra>>2]);Tb=ea(Sb+ea(Hb*Qb));Sb=ea(g[ta>>2]);Ub=ea(g[ua>>2]);Vb=ea(ea(ea(Lb*Sb)+ea(Pb*Ub))+ea(Tb*ea(g[va>>2])));Ub=ea(g[ya>>2]);Sb=ea(g[za>>2]);Wb=Vb>ea(ea(ea(Lb*Ub)+ea(Pb*Sb))+ea(Tb*ea(g[Aa>>2])));c[q+0>>2]=c[sa+0>>2];c[q+4>>2]=c[sa+4>>2];c[q+8>>2]=c[sa+8>>2];c[q+12>>2]=c[sa+12>>2];c[p+0>>2]=c[xa+0>>2];c[p+4>>2]=c[xa+4>>2];c[p+8>>2]=c[xa+8>>2];c[p+12>>2]=c[xa+12>>2];Xb=Wb?q:p;Tb=ea(g[Xb>>2]);Sb=ea(g[Xb+4>>2]);Pb=ea(g[Xb+8>>2]);Ub=ea(g[U>>2]);Lb=ea(g[W>>2]);Vb=ea(ea(ea(ea(Eb*Tb)+ea(Kb*Sb))+ea(Ob*Pb))+Ub);Ub=ea(ea(ea(ea(Jb*Tb)+ea(Nb*Sb))+ea(Rb*Pb))+Lb);Lb=ea(ea(ea(ea(Ib*Tb)+ea(Mb*Sb))+ea(Qb*Pb))+ea(g[Y>>2]));Xb=Fb<ea(-0.0);Wb=Gb<ea(-0.0);Yb=Hb<ea(-0.0);c[q+0>>2]=c[Ea+0>>2];c[q+4>>2]=c[Ea+4>>2];c[q+8>>2]=c[Ea+8>>2];c[q+12>>2]=c[Ea+12>>2];Pb=ea(g[Fa>>2]);Qb=ea(g[Ga>>2]);Sb=ea(-Pb);Pb=ea(-Qb);Qb=ea(-ea(g[Ha>>2]));g[p>>2]=Sb;g[Sa>>2]=Pb;g[Ta>>2]=Qb;g[Ua>>2]=ea(0.0);Mb=ea(g[(Xb?q:p)>>2]);Tb=ea(g[(Wb?q:p)+4>>2]);Ib=ea(aa+Mb);Mb=ea(Z+Tb);Tb=ea(ja+ea(g[(Yb?q:p)+8>>2]));Rb=ea(Vb-Ib);Nb=ea(Ub-Mb);Jb=ea(Lb-Tb);g[E>>2]=Rb;g[Va>>2]=Nb;g[Wa>>2]=Jb;g[Xa>>2]=ea(0.0);Ob=ea(ea(ea(ea(-ea(Gb*Nb))-ea(Fb*Rb))-ea(Hb*Jb))-m);Kb=ea(g[h>>2]);Eb=ea(g[y>>2]);Zb=ea(g[L>>2]);_b=ea(ea(ea(Fb*Kb)+ea(Gb*Eb))+ea(Hb*Zb));if(Ob>ea(0.0)){if(_b>=ea(0.0)){$b=0;ac=22;break}Hb=ea(ka-ea(Ob/_b));c[z+0>>2]=c[H+0>>2];c[z+4>>2]=c[H+4>>2];c[z+8>>2]=c[H+8>>2];if(Hb>ka){if(Hb>ea(1.0)){$b=0;ac=22;break}_b=ea(g[f>>2]);Ob=ea(g[O>>2]);Gb=ea(ea(Hb*Kb)+_b);_b=ea(ea(Hb*Eb)+Ob);Ob=ea(ea(Hb*Zb)+ea(g[Q>>2]));Zb=ea(Gb-aa);Eb=ea(_b-Z);Kb=ea(Ob-ja);Fb=ea(g[D>>2]);bc=ea(g[La>>2]);cc=ea(Zb+Fb);Fb=ea(Eb+bc);bc=ea(Kb+ea(g[Ma>>2]));dc=ea(g[Ya>>2]);ec=ea(g[Za>>2]);fc=ea(Zb+dc);dc=ea(Eb+ec);ec=ea(Kb+ea(g[_a>>2]));gc=ea(g[ab>>2]);hc=ea(g[bb>>2]);ic=ea(Zb+gc);gc=ea(Eb+hc);hc=ea(Kb+ea(g[cb>>2]));g[D>>2]=cc;g[La>>2]=Fb;g[Ma>>2]=bc;g[Na>>2]=ea(0.0);g[Ya>>2]=fc;g[Za>>2]=dc;g[_a>>2]=ec;g[$a>>2]=ea(0.0);g[ab>>2]=ic;g[bb>>2]=gc;g[cb>>2]=hc;g[db>>2]=ea(0.0);Kb=ea(g[C>>2]);Eb=ea(g[Ja>>2]);Zb=ea(Eb-Fb);Fb=ea(ea(g[Ka>>2])-bc);g[B>>2]=ea(Kb-cc);g[Da>>2]=Zb;g[Ba>>2]=Fb;g[Ca>>2]=ea(0.0);Fb=ea(g[eb>>2]);Zb=ea(g[fb>>2]);cc=ea(Zb-dc);dc=ea(ea(g[gb>>2])-ec);g[hb>>2]=ea(Fb-fc);g[ib>>2]=cc;g[jb>>2]=dc;g[kb>>2]=ea(0.0);dc=ea(g[lb>>2]);cc=ea(g[mb>>2]);fc=ea(cc-gc);gc=ea(ea(g[nb>>2])-hc);g[ob>>2]=ea(dc-ic);g[pb>>2]=fc;g[qb>>2]=gc;g[rb>>2]=ea(0.0);c[q+0>>2]=c[Ea+0>>2];c[q+4>>2]=c[Ea+4>>2];c[q+8>>2]=c[Ea+8>>2];c[q+12>>2]=c[Ea+12>>2];g[p>>2]=Sb;g[sb>>2]=Pb;g[tb>>2]=Qb;g[ub>>2]=ea(0.0);Qb=ea(g[(Xb?q:p)>>2]);Pb=ea(g[(Wb?q:p)+4>>2]);Sb=ea(Gb+Qb);Qb=ea(_b+Pb);Pb=ea(Ob+ea(g[(Yb?q:p)+8>>2]));gc=ea(Vb-Sb);fc=ea(Ub-Qb);ic=ea(Lb-Pb);g[E>>2]=gc;g[Va>>2]=fc;g[Wa>>2]=ic;g[Xa>>2]=ea(0.0);jc=Sb;kc=Qb;lc=Pb;mc=gc;nc=fc;oc=ic;pc=ea(3402823469999999843913219.0e14);qc=Hb;rc=Ob;sc=_b;tc=Gb;uc=ma;vc=V;wc=ba}else{jc=Ib;kc=Mb;lc=Tb;mc=Rb;nc=Nb;oc=Jb;pc=Db;qc=Hb;rc=ja;sc=Z;tc=aa;uc=Cb;vc=Bb;wc=Ab}}else{jc=Ib;kc=Mb;lc=Tb;mc=Rb;nc=Nb;oc=Jb;pc=Db;qc=ka;rc=ja;sc=Z;tc=aa;uc=Cb;vc=Bb;wc=Ab}Yb=c[A>>2]|0;g[C+(Yb<<4)>>2]=Vb;g[C+(Yb<<4)+4>>2]=Ub;g[C+(Yb<<4)+8>>2]=Lb;g[C+(Yb<<4)+12>>2]=ea(0.0);g[D+(Yb<<4)>>2]=jc;g[D+(Yb<<4)+4>>2]=kc;g[D+(Yb<<4)+8>>2]=lc;g[D+(Yb<<4)+12>>2]=ea(0.0);c[A>>2]=Yb+1;Wb=B+(Yb<<4)|0;c[Wb+0>>2]=c[E+0>>2];c[Wb+4>>2]=c[E+4>>2];c[Wb+8>>2]=c[E+8>>2];c[Wb+12>>2]=c[E+12>>2];do if((Yb|0)==2)V6a(I,B,Ia,E,B,C,D,A,F,G);else if(!Yb){g[F>>2]=Vb;g[b>>2]=Ub;g[x>>2]=Lb;g[Oa>>2]=ea(0.0);g[G>>2]=jc;g[Pa>>2]=kc;g[Qa>>2]=lc;g[Ra>>2]=ea(0.0);c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2]}else if((Yb|0)==1){Jb=ea(g[B>>2]);Nb=ea(g[Da>>2]);Rb=ea(g[Ba>>2]);Tb=ea(mc-Jb);Mb=ea(nc-Nb);Ib=ea(oc-Rb);Hb=ea(ea(ea(Tb*Tb)+ea(Mb*Mb))+ea(Ib*Ib));if(Hb==ea(0.0)){c[A>>2]=1;c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];c[I+0>>2]=c[B+0>>2];c[I+4>>2]=c[B+4>>2];c[I+8>>2]=c[B+8>>2];c[I+12>>2]=c[B+12>>2];break}else{Gb=ea(ea(ea(-ea(Nb*Mb))-ea(Jb*Tb))-ea(Rb*Ib));Ib=ea(g[C>>2]);Rb=ea(g[Ja>>2]);Tb=ea(g[Ka>>2]);Jb=ea(Vb-Ib);Mb=ea(Ub-Rb);Nb=ea(Lb-Tb);_b=ea(g[D>>2]);Ob=ea(g[La>>2]);ic=ea(g[Ma>>2]);fc=ea(jc-_b);gc=ea(kc-Ob);Pb=ea(lc-ic);Qb=ea(Gb/Hb);Wb=Qb>ea(1.0);Hb=Wb?ea(1.0):Qb;Wb=Hb>ea(0.0);Qb=Wb?Hb:ea(0.0);Hb=ea(Ib+ea(Jb*Qb));Jb=ea(Rb+ea(Mb*Qb));Mb=ea(Tb+ea(Nb*Qb));Nb=ea(_b+ea(fc*Qb));fc=ea(Ob+ea(gc*Qb));gc=ea(ic+ea(Pb*Qb));g[F>>2]=Hb;g[b>>2]=Jb;g[x>>2]=Mb;g[Oa>>2]=ea(0.0);g[G>>2]=Nb;g[Pa>>2]=fc;g[Qa>>2]=gc;g[Ra>>2]=ea(0.0);Qb=ea(Jb-fc);fc=ea(Mb-gc);g[I>>2]=ea(Hb-Nb);g[vb>>2]=Qb;g[wb>>2]=fc;g[xb>>2]=ea(0.0);break}}else if((Yb|0)==3)pPa(I,B,C,D,A,F,G);else{c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2]}while(0);Lb=ea(g[I>>2]);Ub=ea(g[vb>>2]);Vb=ea(g[wb>>2]);fc=ea(-Lb);Qb=ea(-Ub);Nb=ea(-Vb);Hb=ea(ea(ea(Lb*Lb)+ea(Ub*Ub))+ea(Vb*Vb));Yb=pc>Hb;Wb=Yb<<31>>31;if(!(Hb>fa)){xc=qc;yc=ga;zc=ca;Ac=yb;Bc=zb;Cc=Nb;Dc=Qb;Ec=fc;Fc=Hb;Gc=Wb;Hc=uc;Ic=vc;Jc=wc;break a}if(!Yb){xc=qc;yc=ga;zc=ca;Ac=yb;Bc=zb;Cc=Nb;Dc=Qb;Ec=fc;Fc=Hb;Gc=Wb;Hc=uc;Ic=vc;Jc=wc;break a}Vb=ea(g[F>>2]);Ub=ea(g[b>>2]);Lb=ea(g[x>>2]);ba=fc;V=Qb;ma=Nb;aa=tc;Z=sc;ja=rc;ka=qc;ga=ea(g[Oa>>2]);ca=Lb;yb=Ub;zb=Vb;Ab=wc;Bb=vc;Cb=uc;Db=Hb}if((ac|0)==22){i=e;return $b|0}}else{xc=ea(0.0);yc=ea(0.0);zc=ha;Ac=qa;Bc=wa;Cc=da;Dc=oa;Ec=ia;Fc=X;Gc=-1;Hc=da;Ic=oa;Jc=ia}while(0);ac=c[a+64>>2]|0;I=c[a+68>>2]|0;E=c[a+72>>2]|0;if(Fc>$)Kc=(Gc|0)==0?r:s;else Kc=r;g[s>>2]=Ec;g[s+4>>2]=Dc;g[s+8>>2]=Cc;g[s+12>>2]=ea(0.0);g[r>>2]=Jc;g[r+4>>2]=Ic;g[r+8>>2]=Hc;g[r+12>>2]=ea(0.0);Hc=ea(g[Kc>>2]);Ic=ea(g[Kc+4>>2]);Jc=ea(g[Kc+8>>2]);Cc=ea(ea(1.0)/ea(T(ea(ea(ea(Hc*Hc)+ea(Ic*Ic))+ea(Jc*Jc)))));Dc=ea(-ea(Hc*Cc));Hc=ea(-ea(Ic*Cc));Ic=ea(-ea(Jc*Cc));g[k>>2]=Dc;g[k+4>>2]=Hc;g[k+8>>2]=Ic;g[k+12>>2]=ea(0.0);g[j>>2]=xc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[F+0>>2];c[u+4>>2]=c[F+4>>2];c[u+8>>2]=c[F+8>>2];c[u+12>>2]=c[F+12>>2];g[t>>2]=Bc;g[t+4>>2]=Ac;g[t+8>>2]=zc;g[t+12>>2]=yc;z=(Gc|0)==0?t:u;yc=ea(g[z>>2]);zc=ea(g[z+4>>2]);Ac=ea(g[z+8>>2]);g[F>>2]=yc;g[b>>2]=zc;g[x>>2]=Ac;g[Oa>>2]=ea(0.0);Bc=ea(g[a+16>>2]);xc=ea(yc-ea(Bc*Dc));Dc=ea(zc-ea(Bc*Hc));Hc=ea(Ac-ea(Bc*Ic));c[v+0>>2]=c[F+0>>2];c[v+4>>2]=c[F+4>>2];c[v+8>>2]=c[F+8>>2];c[v+12>>2]=c[F+12>>2];g[w>>2]=xc;g[w+4>>2]=Dc;g[w+8>>2]=Hc;g[w+12>>2]=ea(0.0);Hc=ea(g[((ac|0)==0?v:w)>>2]);Dc=ea(g[((I|0)==0?v:w)+4>>2]);xc=ea(g[((E|0)==0?v:w)+8>>2]);g[l>>2]=Hc;g[l+4>>2]=Dc;g[l+8>>2]=xc;g[l+12>>2]=ea(0.0);$b=1;i=e;return $b|0}function WFb(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=0,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=0,Yb=0,Zb=0,_b=0;q=i;i=i+528|0;r=q+272|0;s=q+400|0;t=q+304|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+416|0;y=q+440|0;z=q+336|0;A=q+128|0;B=q+192|0;C=q+456|0;D=q+472|0;E=q+488|0;F=q+256|0;G=q+80|0;H=q+112|0;I=q+16|0;J=q;K=q+32|0;L=q+320|0;M=q+428|0;N=q+288|0;O=q+492|0;P=q+504|0;Q=ea(g[b+16>>2]);R=e+16|0;S=ea(g[R>>2]);U=ea(g[h>>2]);V=ea(g[b+32>>2]);W=ea(g[e+32>>2]);X=ea((V>W?W:V)*ea(.100000001));V=ea(Q+S);h=v+4|0;Y=v+8|0;Z=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;_=w+4|0;$=w+8|0;aa=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];W=ea(X*X);c[E>>2]=0;ba=a[p>>0]|0;if(!(ba<<24>>24)){X=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(ea(ea(X*X)+ea(ca*ca))+ea(da*da))>ea(0.0);g[u>>2]=X;g[u+4>>2]=ca;g[u+8>>2]=da;g[u+12>>2]=fa;g[t>>2]=ea(1.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(0.0);ha=ga?u:t;fa=ea(g[ha>>2]);da=ea(g[ha+4>>2]);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(3402823469999999843913219.0e14);ra=1;sa=ea(g[ha+8>>2]);ta=da;ua=fa}else{ha=F+4|0;t=F+8|0;u=F+12|0;c[F+0>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;c[F+12>>2]=0;ga=G+4|0;va=G+8|0;wa=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;xa=H+4|0;ya=H+8|0;za=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;Aa=b+96|0;fa=ea(g[f+48>>2]);da=ea(g[f+52>>2]);ca=ea(g[f+56>>2]);X=ea(g[f>>2]);Ba=ea(g[f+16>>2]);Ca=ea(g[f+32>>2]);Da=ea(g[f+4>>2]);Ea=ea(g[f+20>>2]);Fa=ea(g[f+36>>2]);Ga=ea(g[f+8>>2]);Ha=ea(g[f+24>>2]);Ia=ea(g[f+40>>2]);Ja=ea(g[e+144>>2]);Ka=ea(g[e+148>>2]);La=ea(Ja-S);Ja=ea(Ka-S);Ka=ea(ea(g[e+152>>2])-S);Ma=ea(-La);Na=ea(-Ja);Oa=ea(-Ka);Pa=s+4|0;Qa=s+8|0;Ra=s+12|0;Sa=r+4|0;Ta=r+8|0;Ua=r+12|0;Va=ba&255;ba=Va>>>0>1?Va:1;Wa=0;Xa=0;while(1){Ya=d[n+Xa>>0]|0;c[C+(Xa<<2)>>2]=Ya;Za=d[o+Xa>>0]|0;c[D+(Xa<<2)>>2]=Za;_a=1-Ya|0;$a=ea(g[Aa+(_a<<4)>>2]);ab=ea(g[Aa+(_a<<4)+4>>2]);bb=ea(g[Aa+(_a<<4)+8>>2]);cb=ea(fa+ea(ea(ea($a*X)+ea(ab*Ba))+ea(bb*Ca)));db=ea(da+ea(ea(ea($a*Da)+ea(ab*Ea))+ea(bb*Fa)));eb=ea(ca+ea(ea(ea($a*Ga)+ea(ab*Ha))+ea(bb*Ia)));_a=c[540320+(Za<<4)>>2]|0;Ya=c[540324+(Za<<4)>>2]|0;fb=c[540328+(Za<<4)>>2]|0;g[s>>2]=La;g[Pa>>2]=Ja;g[Qa>>2]=Ka;g[Ra>>2]=ea(0.0);g[r>>2]=Ma;g[Sa>>2]=Na;g[Ta>>2]=Oa;g[Ua>>2]=ea(0.0);gb=ea(g[((_a|0)==0?r:s)>>2]);hb=ea(g[((Ya|0)==0?r:s)+4>>2]);ib=ea(g[((fb|0)==0?r:s)+8>>2]);jb=ea(cb-gb);kb=ea(db-hb);lb=ea(eb-ib);fb=A+(Wa<<4)|0;g[G>>2]=cb;g[ga>>2]=db;g[va>>2]=eb;g[wa>>2]=ea(0.0);c[fb+0>>2]=c[G+0>>2];c[fb+4>>2]=c[G+4>>2];c[fb+8>>2]=c[G+8>>2];c[fb+12>>2]=c[G+12>>2];fb=B+(Wa<<4)|0;g[H>>2]=gb;g[xa>>2]=hb;g[ya>>2]=ib;g[za>>2]=ea(0.0);c[fb+0>>2]=c[H+0>>2];c[fb+4>>2]=c[H+4>>2];c[fb+8>>2]=c[H+8>>2];c[fb+12>>2]=c[H+12>>2];fb=z+(Wa<<4)|0;g[F>>2]=jb;g[ha>>2]=kb;g[t>>2]=lb;g[u>>2]=ea(0.0);c[fb+0>>2]=c[F+0>>2];c[fb+4>>2]=c[F+4>>2];c[fb+8>>2]=c[F+8>>2];c[fb+12>>2]=c[F+12>>2];Xa=Xa+1|0;if(Xa>>>0>=Va>>>0)break;else Wa=Wa+1|0}c[E>>2]=ba;do if((ba|0)==2){Oa=ea(g[z>>2]);Na=ea(g[z+4>>2]);Ma=ea(g[z+8>>2]);Ka=ea(jb-Oa);Ja=ea(kb-Na);La=ea(lb-Ma);Ia=ea(ea(ea(Ka*Ka)+ea(Ja*Ja))+ea(La*La));if(Ia==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[I+0>>2]=c[z+0>>2];c[I+4>>2]=c[z+4>>2];c[I+8>>2]=c[z+8>>2];c[I+12>>2]=c[z+12>>2];break}else{Ha=ea(ea(ea(-ea(Na*Ja))-ea(Oa*Ka))-ea(Ma*La));La=ea(g[A>>2]);Ma=ea(g[A+4>>2]);Ka=ea(g[A+8>>2]);Oa=ea(cb-La);Ja=ea(db-Ma);Na=ea(eb-Ka);Ga=ea(g[B>>2]);ca=ea(g[B+4>>2]);Fa=ea(g[B+8>>2]);Ea=ea(gb-Ga);Da=ea(hb-ca);da=ea(ib-Fa);Ca=ea(Ha/Ia);Wa=Ca>ea(1.0);Ia=Wa?ea(1.0):Ca;Wa=Ia>ea(0.0);Ca=Wa?Ia:ea(0.0);Ia=ea(La+ea(Oa*Ca));Oa=ea(Ma+ea(Ja*Ca));Ja=ea(Ka+ea(Na*Ca));Na=ea(Ga+ea(Ea*Ca));Ea=ea(ca+ea(Da*Ca));Da=ea(Fa+ea(da*Ca));g[v>>2]=Ia;g[h>>2]=Oa;g[Y>>2]=Ja;g[Z>>2]=ea(0.0);g[w>>2]=Na;g[_>>2]=Ea;g[$>>2]=Da;g[aa>>2]=ea(0.0);Ca=ea(Oa-Ea);Ea=ea(Ja-Da);g[I>>2]=ea(Ia-Na);g[I+4>>2]=Ca;g[I+8>>2]=Ea;g[I+12>>2]=ea(0.0);break}}else if((ba|0)==1){c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];c[w+0>>2]=c[H+0>>2];c[w+4>>2]=c[H+4>>2];c[w+8>>2]=c[H+8>>2];c[w+12>>2]=c[H+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}else if((ba|0)==4)qPa(I,z,A,B,C,D,F,G,H,E,v,w);else if((ba|0)==3)V6a(I,z,z+16|0,F,z,A,B,E,v,w);else{c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2]}while(0);ib=ea(g[I>>2]);hb=ea(g[I+4>>2]);gb=ea(g[I+8>>2]);eb=ea(ea(ea(ib*ib)+ea(hb*hb))+ea(gb*gb));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];db=ea(g[v>>2]);cb=ea(g[h>>2]);lb=ea(g[Y>>2]);kb=ea(g[Z>>2]);jb=ea(g[w>>2]);Ea=ea(g[_>>2]);Ca=ea(g[$>>2]);ia=kb;ja=lb;ka=cb;la=db;ma=ea(g[aa>>2]);na=Ca;oa=Ea;pa=jb;qa=eb;ra=eb>W;sa=gb;ta=hb;ua=ib}do if(ra){I=f+4|0;F=f+8|0;ba=f+16|0;H=f+20|0;G=f+24|0;Wa=f+32|0;Va=f+36|0;Xa=f+40|0;u=b+96|0;t=b+96|0;ha=b+100|0;za=b+104|0;ya=b+112|0;xa=b+112|0;wa=b+116|0;va=b+120|0;ga=f+48|0;Ua=f+52|0;Ta=f+56|0;Sa=J+4|0;Ra=J+8|0;Qa=J+12|0;Pa=e+144|0;Aa=e+148|0;fb=e+152|0;Ya=s+4|0;_a=s+8|0;Za=s+12|0;mb=r+4|0;nb=r+8|0;ob=r+12|0;pb=K+4|0;qb=K+8|0;rb=K+12|0;sb=L+4|0;tb=L+8|0;ub=L+12|0;vb=b+48|0;wb=e+48|0;xb=N+4|0;yb=N+8|0;zb=z+4|0;Ab=z+8|0;Bb=A+4|0;Cb=A+8|0;Db=B+4|0;Eb=B+8|0;Fb=N+12|0;Gb=z+16|0;ib=U;hb=ua;gb=ta;eb=sa;jb=qa;Ea=la;Ca=ka;db=ja;cb=ia;lb=pa;kb=oa;Na=na;Ia=ma;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];Da=ea(-hb);Ja=ea(-gb);Oa=ea(-eb);Hb=c[E>>2]|0;Ib=A+(Hb<<4)|0;da=ea(g[f>>2]);Fa=ea(da*Da);ca=ea(g[I>>2]);Ga=ea(Fa+ea(ca*Ja));Fa=ea(g[F>>2]);Ka=ea(Ga+ea(Fa*Oa));Ga=ea(g[ba>>2]);Ma=ea(Ga*Da);La=ea(g[H>>2]);Ha=ea(Ma+ea(La*Ja));Ma=ea(g[G>>2]);Ba=ea(Ha+ea(Ma*Oa));Ha=ea(g[Wa>>2]);X=ea(Ha*Da);Da=ea(g[Va>>2]);fa=ea(X+ea(Da*Ja));Ja=ea(g[Xa>>2]);X=ea(fa+ea(Ja*Oa));Oa=ea(g[t>>2]);fa=ea(g[ha>>2]);bb=ea(ea(ea(Ka*Oa)+ea(Ba*fa))+ea(X*ea(g[za>>2])));fa=ea(g[xa>>2]);Oa=ea(g[wa>>2]);Jb=bb>ea(ea(ea(Ka*fa)+ea(Ba*Oa))+ea(X*ea(g[va>>2])));c[C+(Hb<<2)>>2]=Jb&1;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[r+0>>2]=c[ya+0>>2];c[r+4>>2]=c[ya+4>>2];c[r+8>>2]=c[ya+8>>2];c[r+12>>2]=c[ya+12>>2];Kb=Jb?s:r;X=ea(g[Kb>>2]);Oa=ea(g[Kb+4>>2]);Ba=ea(g[Kb+8>>2]);fa=ea(g[ga>>2]);Ka=ea(g[Ua>>2]);bb=ea(ea(ea(ea(da*X)+ea(Ga*Oa))+ea(Ha*Ba))+fa);fa=ea(ea(ea(ea(ca*X)+ea(La*Oa))+ea(Da*Ba))+Ka);Ka=ea(ea(ea(ea(Fa*X)+ea(Ma*Oa))+ea(Ja*Ba))+ea(g[Ta>>2]));g[J>>2]=bb;g[Sa>>2]=fa;g[Ra>>2]=Ka;g[Qa>>2]=ea(0.0);c[Ib+0>>2]=c[J+0>>2];c[Ib+4>>2]=c[J+4>>2];c[Ib+8>>2]=c[J+8>>2];c[Ib+12>>2]=c[J+12>>2];Ib=B+(Hb<<4)|0;Ba=ea(g[Pa>>2]);Ja=ea(g[Aa>>2]);Oa=ea(g[fb>>2]);Ma=ea(g[R>>2]);X=ea(Ba-Ma);Ba=ea(Ja-Ma);Ja=ea(Oa-Ma);Kb=hb>ea(0.0);Jb=gb>ea(0.0);Lb=eb>ea(0.0);c[D+(Hb<<2)>>2]=Lb<<31>>31<<2&4|Kb&1|Jb<<31>>31<<1&2;Ma=ea(-X);Oa=ea(-Ba);Fa=ea(-Ja);g[s>>2]=X;g[Ya>>2]=Ba;g[_a>>2]=Ja;g[Za>>2]=ea(0.0);g[r>>2]=Ma;g[mb>>2]=Oa;g[nb>>2]=Fa;g[ob>>2]=ea(0.0);Fa=ea(g[(Kb?s:r)>>2]);Oa=ea(g[(Jb?s:r)+4>>2]);Ma=ea(g[(Lb?s:r)+8>>2]);g[K>>2]=Fa;g[pb>>2]=Oa;g[qb>>2]=Ma;g[rb>>2]=ea(0.0);c[Ib+0>>2]=c[K+0>>2];c[Ib+4>>2]=c[K+4>>2];c[Ib+8>>2]=c[K+8>>2];c[Ib+12>>2]=c[K+12>>2];Ja=ea(bb-Fa);Ba=ea(fa-Oa);X=ea(Ka-Ma);g[L>>2]=Ja;g[sb>>2]=Ba;g[tb>>2]=X;g[ub>>2]=ea(0.0);Mb=c[E>>2]|0;c[E>>2]=Mb+1;Ib=z+(Mb<<4)|0;c[Ib+0>>2]=c[L+0>>2];c[Ib+4>>2]=c[L+4>>2];c[Ib+8>>2]=c[L+8>>2];c[Ib+12>>2]=c[L+12>>2];Da=ea(g[vb>>2]);La=ea(g[wb>>2]);ca=Da>La?Da:La;La=ib>ca?ib:ca;ca=ea(V+La);Da=ea(ea(ea(hb*Ja)+ea(gb*Ba))+ea(eb*X));Ib=ea(Da*Da)>ea(jb*ea(ca*ca));if(Da>ea(0.0)){Nb=Ib;Ob=Ib^1}else{Nb=0;Ob=1}Ib=ea(W*jb)>=ea(jb-Da);if((Ib|Nb)&(Ib|Ob^1))break;do if((Mb|0)==3)qPa(N,z,A,B,C,D,L,J,K,E,v,w);else if(!Mb){c[v+0>>2]=c[J+0>>2];c[v+4>>2]=c[J+4>>2];c[v+8>>2]=c[J+8>>2];c[v+12>>2]=c[J+12>>2];c[w+0>>2]=c[K+0>>2];c[w+4>>2]=c[K+4>>2];c[w+8>>2]=c[K+8>>2];c[w+12>>2]=c[K+12>>2];c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}else if((Mb|0)==1){Da=ea(g[z>>2]);ca=ea(g[zb>>2]);Ha=ea(g[Ab>>2]);Ga=ea(Ja-Da);da=ea(Ba-ca);ab=ea(X-Ha);$a=ea(ea(ea(Ga*Ga)+ea(da*da))+ea(ab*ab));if($a==ea(0.0)){c[E>>2]=1;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];c[w+12>>2]=c[B+12>>2];c[N+0>>2]=c[z+0>>2];c[N+4>>2]=c[z+4>>2];c[N+8>>2]=c[z+8>>2];c[N+12>>2]=c[z+12>>2];break}else{Pb=ea(ea(ea(-ea(ca*da))-ea(Da*Ga))-ea(Ha*ab));ab=ea(g[A>>2]);Ha=ea(g[Bb>>2]);Ga=ea(g[Cb>>2]);Da=ea(bb-ab);da=ea(fa-Ha);ca=ea(Ka-Ga);Qb=ea(g[B>>2]);Rb=ea(g[Db>>2]);Sb=ea(g[Eb>>2]);Tb=ea(Fa-Qb);Ub=ea(Oa-Rb);Vb=ea(Ma-Sb);Wb=ea(Pb/$a);Ib=Wb>ea(1.0);$a=Ib?ea(1.0):Wb;Ib=$a>ea(0.0);Wb=Ib?$a:ea(0.0);$a=ea(ab+ea(Da*Wb));Da=ea(Ha+ea(da*Wb));da=ea(Ga+ea(ca*Wb));ca=ea(Qb+ea(Tb*Wb));Tb=ea(Rb+ea(Ub*Wb));Ub=ea(Sb+ea(Vb*Wb));g[v>>2]=$a;g[h>>2]=Da;g[Y>>2]=da;g[Z>>2]=ea(0.0);g[w>>2]=ca;g[_>>2]=Tb;g[$>>2]=Ub;g[aa>>2]=ea(0.0);Wb=ea(Da-Tb);Tb=ea(da-Ub);g[N>>2]=ea($a-ca);g[xb>>2]=Wb;g[yb>>2]=Tb;g[Fb>>2]=ea(0.0);break}}else if((Mb|0)==2)V6a(N,z,Gb,L,z,A,B,E,v,w);else{c[N+0>>2]=c[L+0>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];c[N+12>>2]=c[L+12>>2]}while(0);Ma=ea(g[N>>2]);Oa=ea(g[xb>>2]);Fa=ea(g[yb>>2]);Ka=ea(ea(ea(Ma*Ma)+ea(Oa*Oa))+ea(Fa*Fa));c[x+0>>2]=c[O+0>>2];c[x+4>>2]=c[O+4>>2];c[x+8>>2]=c[O+8>>2];Xb=jb>Ka;if(Ka>W^1|Xb^1){Yb=35;break}fa=ea(g[v>>2]);bb=ea(g[h>>2]);X=ea(g[Y>>2]);Ba=ea(g[Z>>2]);Ja=ea(g[w>>2]);Tb=ea(g[_>>2]);Wb=ea(g[$>>2]);ib=La;hb=Ma;gb=Oa;eb=Fa;jb=Ka;Ea=fa;Ca=bb;db=X;cb=Ba;lb=Ja;kb=Tb;Na=Wb;Ia=ea(g[aa>>2])}if((Yb|0)==35){yb=c[E>>2]|0;if(Xb){Zb=yb;break}xb=yb+-1|0;if((n|0)!=0?(a[p>>0]=xb,(xb|0)!=0):0){yb=0;do{a[n+yb>>0]=c[C+(yb<<2)>>2];a[o+yb>>0]=c[D+(yb<<2)>>2];yb=yb+1|0}while((yb|0)!=(xb|0))}g[v>>2]=Ea;g[h>>2]=Ca;g[Y>>2]=db;g[Z>>2]=cb;g[w>>2]=lb;g[_>>2]=kb;g[$>>2]=Na;g[aa>>2]=Ia;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];ib=ea(T(ea(jb)));Wb=ea(ea(1.0)/ib);Tb=ea(ea(Ea-lb)*Wb);Ja=ea(ea(Ca-kb)*Wb);Ba=ea(ea(db-Na)*Wb);Wb=ea(Ca-ea(Q*Ja));X=ea(db-ea(Q*Ba));g[j>>2]=ea(Ea-ea(Q*Tb));g[j+4>>2]=Wb;g[j+8>>2]=X;g[j+12>>2]=ea(0.0);X=ea(ea(S*Ja)+kb);Wb=ea(ea(S*Ba)+Na);g[k>>2]=ea(ea(S*Tb)+lb);g[k+4>>2]=X;g[k+8>>2]=Wb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(ib-V);xb=m+4|0;c[xb+0>>2]=c[P+0>>2];c[xb+4>>2]=c[P+4>>2];c[xb+8>>2]=c[P+8>>2];g[l>>2]=Tb;g[l+4>>2]=Ja;g[l+8>>2]=Ba;g[l+12>>2]=ea(0.0);_b=3;i=q;return _b|0}if((n|0)!=0?(a[p>>0]=Mb,(Mb|0)!=0):0){xb=0;do{a[n+xb>>0]=c[C+(xb<<2)>>2];a[o+xb>>0]=c[D+(xb<<2)>>2];xb=xb+1|0}while((xb|0)!=(Mb|0))}if(!(Ob&(Nb^1))){_b=0;i=q;return _b|0}lb=ea(T(ea(jb)));Na=ea(ea(1.0)/lb);kb=ea(hb*Na);Ea=ea(gb*Na);db=ea(eb*Na);Na=ea(g[v>>2]);Ca=ea(g[h>>2]);Ia=ea(Ca-ea(Q*Ea));Ca=ea(ea(g[Y>>2])-ea(Q*db));g[j>>2]=ea(Na-ea(Q*kb));g[j+4>>2]=Ia;g[j+8>>2]=Ca;g[j+12>>2]=ea(0.0);Ca=ea(g[w>>2]);Ia=ea(g[_>>2]);Na=ea(ea(S*Ea)+Ia);Ia=ea(ea(S*db)+ea(g[$>>2]));g[k>>2]=ea(ea(S*kb)+Ca);g[k+4>>2]=Na;g[k+8>>2]=Ia;g[k+12>>2]=ea(0.0);g[m>>2]=ea(lb-V);xb=m+4|0;c[xb+0>>2]=c[M+0>>2];c[xb+4>>2]=c[M+4>>2];c[xb+8>>2]=c[M+8>>2];g[l>>2]=kb;g[l+4>>2]=Ea;g[l+8>>2]=db;g[l+12>>2]=ea(0.0);_b=1;i=q;return _b|0}else Zb=c[E>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Zb,(Zb|0)!=0):0){p=0;do{a[n+p>>0]=c[C+(p<<2)>>2];a[o+p>>0]=c[D+(p<<2)>>2];p=p+1|0}while((p|0)!=(Zb|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];_b=6;i=q;return _b|0}function XFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=0,R=Im,S=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=0,sa=Im,ta=0,ua=0,va=0,wa=0,xa=0,ya=Im,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=0,Yb=0,Zb=0,_b=0,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=0,Ec=Im,Fc=Im,Gc=Im,Hc=0;e=i;i=i+560|0;n=e+496|0;o=e+16|0;p=e;q=e+448|0;r=e+192|0;s=e+64|0;t=e+80|0;u=e+96|0;v=e+400|0;w=e+432|0;x=e+464|0;y=e+512|0;z=e+524|0;A=e+548|0;B=e+256|0;C=e+32|0;D=e+272|0;E=e+112|0;F=e+336|0;G=e+48|0;H=e+176|0;I=e+416|0;J=e+208|0;K=e+240|0;L=e+536|0;M=e+224|0;N=e+480|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];O=ea(g[h>>2]);y=h+4|0;P=ea(g[y>>2]);Q=h+8|0;R=ea(g[Q>>2]);S=ea(g[f>>2]);U=f+4|0;V=ea(g[U>>2]);W=f+8|0;X=ea(g[W>>2]);c[A>>2]=1;Y=d+48|0;Z=d+48|0;_=ea(g[Z>>2]);$=d+52|0;aa=ea(g[$>>2]);ba=d+56|0;ca=ea(g[ba>>2]);da=ea(ea(ea(_*_)+ea(aa*aa))+ea(ca*ca))>ea(1.1920929e-07);c[o+0>>2]=c[Y+0>>2];c[o+4>>2]=c[Y+4>>2];c[o+8>>2]=c[Y+8>>2];c[o+12>>2]=c[Y+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);Y=da?o:n;ca=ea(g[Y>>2]);aa=ea(g[Y+4>>2]);_=ea(g[Y+8>>2]);fa=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(aa*aa))+ea(_*_)))));ga=ea(ca*fa);ca=ea(aa*fa);aa=ea(_*fa);g[B>>2]=ga;g[B+4>>2]=ca;g[B+8>>2]=aa;g[B+12>>2]=ea(0.0);fa=ea(-ga);ga=ea(-ca);ca=ea(-aa);aa=ea(g[d>>2]);_=ea(aa*fa);Y=d+4|0;ha=ea(g[Y>>2]);ia=ea(_+ea(ha*ga));n=d+8|0;_=ea(g[n>>2]);ja=ea(ia+ea(_*ca));o=d+16|0;ia=ea(g[o>>2]);ka=ea(ia*fa);da=d+20|0;la=ea(g[da>>2]);ma=ea(ka+ea(la*ga));na=d+24|0;ka=ea(g[na>>2]);oa=ea(ma+ea(ka*ca));pa=d+32|0;ma=ea(g[pa>>2]);qa=ea(ma*fa);ra=d+36|0;fa=ea(g[ra>>2]);sa=ea(qa+ea(fa*ga));ta=d+40|0;ga=ea(g[ta>>2]);qa=ea(sa+ea(ga*ca));ua=a+96|0;va=a+96|0;ca=ea(g[va>>2]);wa=a+100|0;sa=ea(g[wa>>2]);xa=a+104|0;ya=ea(ea(ea(ja*ca)+ea(oa*sa))+ea(qa*ea(g[xa>>2])));za=a+112|0;Aa=a+112|0;sa=ea(g[Aa>>2]);Ba=a+116|0;ca=ea(g[Ba>>2]);Ca=a+120|0;Da=ya>ea(ea(ea(ja*sa)+ea(oa*ca))+ea(qa*ea(g[Ca>>2])));c[q+0>>2]=c[ua+0>>2];c[q+4>>2]=c[ua+4>>2];c[q+8>>2]=c[ua+8>>2];c[q+12>>2]=c[ua+12>>2];c[p+0>>2]=c[za+0>>2];c[p+4>>2]=c[za+4>>2];c[p+8>>2]=c[za+8>>2];c[p+12>>2]=c[za+12>>2];Ea=Da?q:p;qa=ea(g[Ea>>2]);ca=ea(g[Ea+4>>2]);oa=ea(g[Ea+8>>2]);sa=ea(g[Z>>2]);ja=ea(g[$>>2]);ya=ea(ea(ea(ea(aa*qa)+ea(ia*ca))+ea(ma*oa))+sa);sa=ea(ea(ea(ea(ha*qa)+ea(la*ca))+ea(fa*oa))+ja);ja=ea(ea(ea(ea(_*qa)+ea(ka*ca))+ea(ga*oa))+ea(g[ba>>2]));HFb(C,b,B);oa=ea(g[C>>2]);ga=ea(g[C+4>>2]);ca=ea(ya-oa);oa=ea(sa-ga);ga=ea(ja-ea(g[C+8>>2]));g[D>>2]=ca;B=D+4|0;g[B>>2]=oa;Ea=D+8|0;g[Ea>>2]=ga;Da=D+12|0;g[Da>>2]=ea(0.0);Fa=D+16|0;c[Fa+0>>2]=c[x+0>>2];c[Fa+4>>2]=c[x+4>>2];c[Fa+8>>2]=c[x+8>>2];c[Fa+12>>2]=c[x+12>>2];Ga=D+32|0;c[Ga+0>>2]=c[x+0>>2];c[Ga+4>>2]=c[x+4>>2];c[Ga+8>>2]=c[x+8>>2];c[Ga+12>>2]=c[x+12>>2];Ga=D+48|0;c[Ga+0>>2]=c[x+0>>2];c[Ga+4>>2]=c[x+4>>2];c[Ga+8>>2]=c[x+8>>2];c[Ga+12>>2]=c[x+12>>2];g[E>>2]=ya;Ga=E+4|0;g[Ga>>2]=sa;Ha=E+8|0;g[Ha>>2]=ja;g[E+12>>2]=ea(0.0);Ia=E+16|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];Ia=E+32|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];Ia=E+48|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];Ia=F+16|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];Ia=F+32|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];Ia=F+48|0;c[Ia+0>>2]=c[x+0>>2];c[Ia+4>>2]=c[x+4>>2];c[Ia+8>>2]=c[x+8>>2];c[Ia+12>>2]=c[x+12>>2];ka=ea(-ca);qa=ea(-oa);_=ea(-ga);c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];fa=ea(g[a+32>>2]);la=ea(g[b+32>>2]);ha=ea((fa>la?la:fa)*ea(.100000001));fa=ea(ha*ha);ha=ea(ea(m*m)+fa);g[H>>2]=ya;x=H+4|0;g[x>>2]=sa;Ia=H+8|0;g[Ia>>2]=ja;Ja=H+12|0;g[Ja>>2]=ea(0.0);c[I+0>>2]=c[C+0>>2];c[I+4>>2]=c[C+4>>2];c[I+8>>2]=c[C+8>>2];c[I+12>>2]=c[C+12>>2];la=ea(ea(ea(ca*ca)+ea(oa*oa))+ea(ga*ga));a:do if(la>fa){C=J+4|0;Ka=J+8|0;La=J+12|0;Ma=K+4|0;Na=K+8|0;Oa=G+4|0;Pa=G+8|0;Qa=G+12|0;Ra=F+4|0;Sa=F+8|0;Ta=F+12|0;Ua=F+16|0;Va=F+20|0;Wa=F+24|0;Xa=F+28|0;Ya=F+32|0;Za=F+36|0;_a=F+40|0;$a=F+44|0;ab=E+16|0;bb=E+20|0;cb=E+24|0;db=D+16|0;eb=D+20|0;fb=D+24|0;gb=D+28|0;hb=E+32|0;ib=E+36|0;jb=E+40|0;kb=D+32|0;lb=D+36|0;mb=D+40|0;nb=D+44|0;ob=M+4|0;pb=M+8|0;qb=N+4|0;rb=N+8|0;sb=I+4|0;tb=I+8|0;ub=I+12|0;vb=N+12|0;ga=ka;oa=qa;ca=_;ma=ea(ea(O*ea(0.0))+S);ia=ea(ea(P*ea(0.0))+V);aa=ea(ea(R*ea(0.0))+X);wb=ea(0.0);xb=ea(0.0);yb=ja;zb=sa;Ab=ya;Bb=ka;Cb=qa;Db=_;Eb=la;while(1){Fb=ea(ea(1.0)/ea(T(ea(ea(ca*ca)+ea(ea(oa*oa)+ea(ga*ga))))));Gb=ea(ga*Fb);Hb=ea(oa*Fb);Ib=ea(ca*Fb);Fb=ea(-Hb);Jb=ea(-Ib);g[J>>2]=ea(-Gb);g[C>>2]=Fb;g[Ka>>2]=Jb;g[La>>2]=ea(0.0);Jb=ea(g[d>>2]);Fb=ea(Gb*Jb);Kb=ea(g[Y>>2]);Lb=ea(Fb+ea(Hb*Kb));Fb=ea(g[n>>2]);Mb=ea(Lb+ea(Ib*Fb));Lb=ea(g[o>>2]);Nb=ea(Gb*Lb);Ob=ea(g[da>>2]);Pb=ea(Nb+ea(Hb*Ob));Nb=ea(g[na>>2]);Qb=ea(Pb+ea(Ib*Nb));Pb=ea(g[pa>>2]);Rb=ea(Gb*Pb);Sb=ea(g[ra>>2]);Tb=ea(Rb+ea(Hb*Sb));Rb=ea(g[ta>>2]);Ub=ea(Tb+ea(Ib*Rb));Tb=ea(g[va>>2]);Vb=ea(g[wa>>2]);Wb=ea(ea(ea(Mb*Tb)+ea(Qb*Vb))+ea(Ub*ea(g[xa>>2])));Vb=ea(g[Aa>>2]);Tb=ea(g[Ba>>2]);Xb=Wb>ea(ea(ea(Mb*Vb)+ea(Qb*Tb))+ea(Ub*ea(g[Ca>>2])));c[q+0>>2]=c[ua+0>>2];c[q+4>>2]=c[ua+4>>2];c[q+8>>2]=c[ua+8>>2];c[q+12>>2]=c[ua+12>>2];c[p+0>>2]=c[za+0>>2];c[p+4>>2]=c[za+4>>2];c[p+8>>2]=c[za+8>>2];c[p+12>>2]=c[za+12>>2];Yb=Xb?q:p;Ub=ea(g[Yb>>2]);Tb=ea(g[Yb+4>>2]);Qb=ea(g[Yb+8>>2]);Vb=ea(g[Z>>2]);Mb=ea(g[$>>2]);Wb=ea(ea(ea(ea(Jb*Ub)+ea(Lb*Tb))+ea(Pb*Qb))+Vb);Vb=ea(ea(ea(ea(Kb*Ub)+ea(Ob*Tb))+ea(Sb*Qb))+Mb);Mb=ea(ea(ea(ea(Fb*Ub)+ea(Nb*Tb))+ea(Rb*Qb))+ea(g[ba>>2]));HFb(K,b,J);Qb=ea(g[K>>2]);Rb=ea(g[Ma>>2]);Tb=ea(ma+Qb);Qb=ea(ia+Rb);Rb=ea(aa+ea(g[Na>>2]));Nb=ea(Wb-Tb);Ub=ea(Vb-Qb);Fb=ea(Mb-Rb);g[G>>2]=Nb;g[Oa>>2]=Ub;g[Pa>>2]=Fb;g[Qa>>2]=ea(0.0);Sb=ea(ea(ea(ea(-ea(Hb*Ub))-ea(Gb*Nb))-ea(Ib*Fb))-m);Ob=ea(g[h>>2]);Kb=ea(g[y>>2]);Pb=ea(g[Q>>2]);Lb=ea(ea(ea(Gb*Ob)+ea(Hb*Kb))+ea(Ib*Pb));if(Sb>ea(0.0)){if(Lb>=ea(0.0)){Zb=0;_b=22;break}Ib=ea(wb-ea(Sb/Lb));c[z+0>>2]=c[L+0>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];if(Ib>wb){if(Ib>ea(1.0)){Zb=0;_b=22;break}Lb=ea(g[f>>2]);Sb=ea(g[U>>2]);Hb=ea(ea(Ib*Ob)+Lb);Lb=ea(ea(Ib*Kb)+Sb);Sb=ea(ea(Ib*Pb)+ea(g[W>>2]));Pb=ea(Hb-ma);Kb=ea(Lb-ia);Ob=ea(Sb-aa);Gb=ea(g[F>>2]);Jb=ea(g[Ra>>2]);$b=ea(Pb+Gb);Gb=ea(Kb+Jb);Jb=ea(Ob+ea(g[Sa>>2]));ac=ea(g[Ua>>2]);bc=ea(g[Va>>2]);cc=ea(Pb+ac);ac=ea(Kb+bc);bc=ea(Ob+ea(g[Wa>>2]));dc=ea(g[Ya>>2]);ec=ea(g[Za>>2]);fc=ea(Pb+dc);dc=ea(Kb+ec);ec=ea(Ob+ea(g[_a>>2]));g[F>>2]=$b;g[Ra>>2]=Gb;g[Sa>>2]=Jb;g[Ta>>2]=ea(0.0);g[Ua>>2]=cc;g[Va>>2]=ac;g[Wa>>2]=bc;g[Xa>>2]=ea(0.0);g[Ya>>2]=fc;g[Za>>2]=dc;g[_a>>2]=ec;g[$a>>2]=ea(0.0);Ob=ea(g[E>>2]);Kb=ea(g[Ga>>2]);Pb=ea(Kb-Gb);Gb=ea(ea(g[Ha>>2])-Jb);g[D>>2]=ea(Ob-$b);g[B>>2]=Pb;g[Ea>>2]=Gb;g[Da>>2]=ea(0.0);Gb=ea(g[ab>>2]);Pb=ea(g[bb>>2]);$b=ea(Pb-ac);ac=ea(ea(g[cb>>2])-bc);g[db>>2]=ea(Gb-cc);g[eb>>2]=$b;g[fb>>2]=ac;g[gb>>2]=ea(0.0);ac=ea(g[hb>>2]);$b=ea(g[ib>>2]);cc=ea($b-dc);dc=ea(ea(g[jb>>2])-ec);g[kb>>2]=ea(ac-fc);g[lb>>2]=cc;g[mb>>2]=dc;g[nb>>2]=ea(0.0);HFb(M,b,J);dc=ea(g[M>>2]);cc=ea(g[ob>>2]);fc=ea(Hb+dc);dc=ea(Lb+cc);cc=ea(Sb+ea(g[pb>>2]));ac=ea(Wb-fc);ec=ea(Vb-dc);$b=ea(Mb-cc);g[G>>2]=ac;g[Oa>>2]=ec;g[Pa>>2]=$b;g[Qa>>2]=ea(0.0);gc=fc;hc=dc;ic=cc;jc=ac;kc=ec;lc=$b;mc=ea(3402823469999999843913219.0e14);nc=Ib;oc=Sb;pc=Lb;qc=Hb;rc=ca;sc=oa;tc=ga}else{gc=Tb;hc=Qb;ic=Rb;jc=Nb;kc=Ub;lc=Fb;mc=Eb;nc=Ib;oc=aa;pc=ia;qc=ma;rc=Db;sc=Cb;tc=Bb}}else{gc=Tb;hc=Qb;ic=Rb;jc=Nb;kc=Ub;lc=Fb;mc=Eb;nc=wb;oc=aa;pc=ia;qc=ma;rc=Db;sc=Cb;tc=Bb}Yb=c[A>>2]|0;g[E+(Yb<<4)>>2]=Wb;g[E+(Yb<<4)+4>>2]=Vb;g[E+(Yb<<4)+8>>2]=Mb;g[E+(Yb<<4)+12>>2]=ea(0.0);g[F+(Yb<<4)>>2]=gc;g[F+(Yb<<4)+4>>2]=hc;g[F+(Yb<<4)+8>>2]=ic;g[F+(Yb<<4)+12>>2]=ea(0.0);c[A>>2]=Yb+1;Xb=D+(Yb<<4)|0;c[Xb+0>>2]=c[G+0>>2];c[Xb+4>>2]=c[G+4>>2];c[Xb+8>>2]=c[G+8>>2];c[Xb+12>>2]=c[G+12>>2];do if((Yb|0)==2)V6a(N,D,Fa,G,D,E,F,A,H,I);else if(!Yb){g[H>>2]=Wb;g[x>>2]=Vb;g[Ia>>2]=Mb;g[Ja>>2]=ea(0.0);g[I>>2]=gc;g[sb>>2]=hc;g[tb>>2]=ic;g[ub>>2]=ea(0.0);c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}else if((Yb|0)==1){Fb=ea(g[D>>2]);Ub=ea(g[B>>2]);Nb=ea(g[Ea>>2]);Rb=ea(jc-Fb);Qb=ea(kc-Ub);Tb=ea(lc-Nb);Ib=ea(ea(ea(Rb*Rb)+ea(Qb*Qb))+ea(Tb*Tb));if(Ib==ea(0.0)){c[A>>2]=1;c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[N+0>>2]=c[D+0>>2];c[N+4>>2]=c[D+4>>2];c[N+8>>2]=c[D+8>>2];c[N+12>>2]=c[D+12>>2];break}else{Hb=ea(ea(ea(-ea(Ub*Qb))-ea(Fb*Rb))-ea(Nb*Tb));Tb=ea(g[E>>2]);Nb=ea(g[Ga>>2]);Rb=ea(g[Ha>>2]);Fb=ea(Wb-Tb);Qb=ea(Vb-Nb);Ub=ea(Mb-Rb);Lb=ea(g[F>>2]);Sb=ea(g[Ra>>2]);$b=ea(g[Sa>>2]);ec=ea(gc-Lb);ac=ea(hc-Sb);cc=ea(ic-$b);dc=ea(Hb/Ib);Xb=dc>ea(1.0);Ib=Xb?ea(1.0):dc;Xb=Ib>ea(0.0);dc=Xb?Ib:ea(0.0);Ib=ea(Tb+ea(Fb*dc));Fb=ea(Nb+ea(Qb*dc));Qb=ea(Rb+ea(Ub*dc));Ub=ea(Lb+ea(ec*dc));ec=ea(Sb+ea(ac*dc));ac=ea($b+ea(cc*dc));g[H>>2]=Ib;g[x>>2]=Fb;g[Ia>>2]=Qb;g[Ja>>2]=ea(0.0);g[I>>2]=Ub;g[sb>>2]=ec;g[tb>>2]=ac;g[ub>>2]=ea(0.0);dc=ea(Fb-ec);ec=ea(Qb-ac);g[N>>2]=ea(Ib-Ub);g[qb>>2]=dc;g[rb>>2]=ec;g[vb>>2]=ea(0.0);break}}else if((Yb|0)==3)pPa(N,D,E,F,A,H,I);else{c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}while(0);Mb=ea(g[N>>2]);Vb=ea(g[qb>>2]);Wb=ea(g[rb>>2]);ec=ea(-Mb);dc=ea(-Vb);Ub=ea(-Wb);Ib=ea(ea(ea(Mb*Mb)+ea(Vb*Vb))+ea(Wb*Wb));Yb=mc>Ib;Xb=Yb<<31>>31;if(!(Ib>ha)){uc=nc;vc=xb;wc=yb;xc=zb;yc=Ab;zc=Ub;Ac=dc;Bc=ec;Cc=Ib;Dc=Xb;Ec=rc;Fc=sc;Gc=tc;break a}if(!Yb){uc=nc;vc=xb;wc=yb;xc=zb;yc=Ab;zc=Ub;Ac=dc;Bc=ec;Cc=Ib;Dc=Xb;Ec=rc;Fc=sc;Gc=tc;break a}Wb=ea(g[H>>2]);Vb=ea(g[x>>2]);Mb=ea(g[Ia>>2]);ga=ec;oa=dc;ca=Ub;ma=qc;ia=pc;aa=oc;wb=nc;xb=ea(g[Ja>>2]);yb=Mb;zb=Vb;Ab=Wb;Bb=tc;Cb=sc;Db=rc;Eb=Ib}if((_b|0)==22){i=e;return Zb|0}}else{uc=ea(0.0);vc=ea(0.0);wc=ja;xc=sa;yc=ya;zc=_;Ac=qa;Bc=ka;Cc=la;Dc=-1;Ec=_;Fc=qa;Gc=ka}while(0);_b=c[a+64>>2]|0;N=c[a+68>>2]|0;G=c[a+72>>2]|0;if(Cc>fa)Hc=(Dc|0)==0?r:s;else Hc=r;g[s>>2]=Bc;g[s+4>>2]=Ac;g[s+8>>2]=zc;g[s+12>>2]=ea(0.0);g[r>>2]=Gc;g[r+4>>2]=Fc;g[r+8>>2]=Ec;g[r+12>>2]=ea(0.0);Ec=ea(g[Hc>>2]);Fc=ea(g[Hc+4>>2]);Gc=ea(g[Hc+8>>2]);zc=ea(ea(1.0)/ea(T(ea(ea(ea(Ec*Ec)+ea(Fc*Fc))+ea(Gc*Gc)))));Ac=ea(-ea(Ec*zc));Ec=ea(-ea(Fc*zc));Fc=ea(-ea(Gc*zc));g[k>>2]=Ac;g[k+4>>2]=Ec;g[k+8>>2]=Fc;g[k+12>>2]=ea(0.0);g[j>>2]=uc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[H+0>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];c[u+12>>2]=c[H+12>>2];g[t>>2]=yc;g[t+4>>2]=xc;g[t+8>>2]=wc;g[t+12>>2]=vc;z=(Dc|0)==0?t:u;vc=ea(g[z>>2]);wc=ea(g[z+4>>2]);xc=ea(g[z+8>>2]);g[H>>2]=vc;g[x>>2]=wc;g[Ia>>2]=xc;g[Ja>>2]=ea(0.0);yc=ea(g[a+16>>2]);uc=ea(vc-ea(yc*Ac));Ac=ea(wc-ea(yc*Ec));Ec=ea(xc-ea(yc*Fc));c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];g[w>>2]=uc;g[w+4>>2]=Ac;g[w+8>>2]=Ec;g[w+12>>2]=ea(0.0);Ec=ea(g[((_b|0)==0?v:w)>>2]);Ac=ea(g[((N|0)==0?v:w)+4>>2]);uc=ea(g[((G|0)==0?v:w)+8>>2]);g[l>>2]=Ec;g[l+4>>2]=Ac;g[l+8>>2]=uc;g[l+12>>2]=ea(0.0);Zb=1;i=e;return Zb|0}function YFb(b,e,f,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=0,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=Im,wb=Im,xb=Im,yb=Im,zb=0,Ab=0,Bb=0,Cb=Im,Db=Im,Eb=Im,Fb=0,Gb=0,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=0,Sb=0,Tb=0,Ub=0;q=i;i=i+560|0;r=q+288|0;s=q+432|0;t=q+336|0;u=q+48|0;v=q+96|0;w=q+64|0;x=q+448|0;y=q+472|0;z=q+352|0;A=q+368|0;B=q+144|0;C=q+208|0;D=q+488|0;E=q+504|0;F=q+520|0;G=q+16|0;H=q+304|0;I=q+112|0;J=q+128|0;K=q;L=q+32|0;M=q+272|0;N=q+320|0;O=q+460|0;P=q+80|0;Q=q+524|0;R=q+536|0;S=ea(g[b+16>>2]);U=ea(g[e+16>>2]);V=ea(g[h>>2]);W=ea(g[b+32>>2]);X=ea(g[e+32>>2]);Y=ea((W>X?X:W)*ea(.100000001));W=ea(S+U);h=v+4|0;Z=v+8|0;_=v+12|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;$=w+4|0;aa=w+8|0;ba=w+12|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];X=ea(Y*Y);c[F>>2]=0;if(!(a[p>>0]|0)){Y=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(ea(ea(Y*Y)+ea(ca*ca))+ea(da*da))>ea(0.0);g[s>>2]=Y;g[s+4>>2]=ca;g[s+8>>2]=da;g[s+12>>2]=fa;g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(0.0);ha=ga?s:r;fa=ea(g[ha>>2]);da=ea(g[ha+4>>2]);ca=ea(g[ha+8>>2]);g[z>>2]=fa;g[z+4>>2]=da;g[z+8>>2]=ca;g[z+12>>2]=ea(0.0);ia=ea(0.0);ja=ea(0.0);ka=ea(0.0);la=ea(0.0);ma=ea(0.0);na=ea(0.0);oa=ea(0.0);pa=ea(0.0);qa=ea(3402823469999999843913219.0e14);ra=1;sa=ca;ta=da;ua=fa}else{ha=G+4|0;r=G+8|0;s=G+12|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;ga=H+4|0;va=H+8|0;wa=H+12|0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;xa=I+4|0;ya=I+8|0;za=I+12|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;Aa=b+96|0;Ba=f+48|0;Ca=f+52|0;Da=f+56|0;Ea=f+16|0;Fa=f+32|0;Ga=f+4|0;Ha=f+20|0;Ia=f+36|0;Ja=f+8|0;Ka=f+24|0;La=f+40|0;Ma=e+16|0;Na=J+4|0;Oa=J+8|0;Pa=J+12|0;Qa=0;do{Ra=d[n+Qa>>0]|0;c[D+(Qa<<2)>>2]=Ra;Sa=d[o+Qa>>0]|0;c[E+(Qa<<2)>>2]=Sa;Ta=1-Ra|0;fa=ea(g[Aa+(Ta<<4)>>2]);da=ea(g[Aa+(Ta<<4)+4>>2]);ca=ea(g[Aa+(Ta<<4)+8>>2]);Y=ea(g[Ba>>2]);Ua=ea(g[Ca>>2]);Va=ea(g[Da>>2]);Wa=ea(fa*ea(g[f>>2]));Xa=ea(Wa+ea(da*ea(g[Ea>>2])));Wa=ea(Xa+ea(ca*ea(g[Fa>>2])));Xa=ea(fa*ea(g[Ga>>2]));Ya=ea(Xa+ea(da*ea(g[Ha>>2])));Xa=ea(Ya+ea(ca*ea(g[Ia>>2])));Ya=ea(fa*ea(g[Ja>>2]));fa=ea(Ya+ea(da*ea(g[Ka>>2])));Za=ea(Y+Wa);_a=ea(Ua+Xa);$a=ea(Va+ea(fa+ea(ca*ea(g[La>>2]))));BFb(J,e,Sa,Ma);ab=ea(g[J>>2]);bb=ea(g[Na>>2]);cb=ea(g[Oa>>2]);ca=ea(g[Pa>>2]);db=ea(Za-ab);eb=ea(_a-bb);fb=ea($a-cb);gb=c[F>>2]|0;Sa=B+(gb<<4)|0;g[H>>2]=Za;g[ga>>2]=_a;g[va>>2]=$a;g[wa>>2]=ea(0.0);c[Sa+0>>2]=c[H+0>>2];c[Sa+4>>2]=c[H+4>>2];c[Sa+8>>2]=c[H+8>>2];c[Sa+12>>2]=c[H+12>>2];Sa=C+(gb<<4)|0;g[I>>2]=ab;g[xa>>2]=bb;g[ya>>2]=cb;g[za>>2]=ca;c[Sa+0>>2]=c[I+0>>2];c[Sa+4>>2]=c[I+4>>2];c[Sa+8>>2]=c[I+8>>2];c[Sa+12>>2]=c[I+12>>2];c[F>>2]=gb+1;Sa=A+(gb<<4)|0;g[G>>2]=db;g[ha>>2]=eb;g[r>>2]=fb;g[s>>2]=ea(0.0);c[Sa+0>>2]=c[G+0>>2];c[Sa+4>>2]=c[G+4>>2];c[Sa+8>>2]=c[G+8>>2];c[Sa+12>>2]=c[G+12>>2];Qa=Qa+1|0}while(Qa>>>0<(d[p>>0]|0)>>>0);do if((gb|0)==1){ca=ea(g[A>>2]);fa=ea(g[A+4>>2]);Va=ea(g[A+8>>2]);Xa=ea(db-ca);Ua=ea(eb-fa);Wa=ea(fb-Va);Y=ea(ea(ea(Xa*Xa)+ea(Ua*Ua))+ea(Wa*Wa));if(Y==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[K+0>>2]=c[A+0>>2];c[K+4>>2]=c[A+4>>2];c[K+8>>2]=c[A+8>>2];c[K+12>>2]=c[A+12>>2];break}else{da=ea(ea(ea(-ea(fa*Ua))-ea(ca*Xa))-ea(Va*Wa));Wa=ea(g[B>>2]);Va=ea(g[B+4>>2]);Xa=ea(g[B+8>>2]);ca=ea(Za-Wa);Ua=ea(_a-Va);fa=ea($a-Xa);Ya=ea(g[C>>2]);hb=ea(g[C+4>>2]);ib=ea(g[C+8>>2]);jb=ea(ab-Ya);kb=ea(bb-hb);lb=ea(cb-ib);mb=ea(da/Y);Qa=mb>ea(1.0);Y=Qa?ea(1.0):mb;Qa=Y>ea(0.0);mb=Qa?Y:ea(0.0);Y=ea(Wa+ea(ca*mb));ca=ea(Va+ea(Ua*mb));Ua=ea(Xa+ea(fa*mb));fa=ea(Ya+ea(jb*mb));jb=ea(hb+ea(kb*mb));kb=ea(ib+ea(lb*mb));g[v>>2]=Y;g[h>>2]=ca;g[Z>>2]=Ua;g[_>>2]=ea(0.0);g[w>>2]=fa;g[$>>2]=jb;g[aa>>2]=kb;g[ba>>2]=ea(0.0);mb=ea(ca-jb);jb=ea(Ua-kb);g[K>>2]=ea(Y-fa);g[K+4>>2]=mb;g[K+8>>2]=jb;g[K+12>>2]=ea(0.0);break}}else if((gb|0)==2)V6a(K,A,A+16|0,G,A,B,C,F,v,w);else if(!gb){c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];c[w+0>>2]=c[I+0>>2];c[w+4>>2]=c[I+4>>2];c[w+8>>2]=c[I+8>>2];c[w+12>>2]=c[I+12>>2];c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}else if((gb|0)==3)qPa(K,A,B,C,D,E,G,H,I,F,v,w);else{c[K+0>>2]=c[G+0>>2];c[K+4>>2]=c[G+4>>2];c[K+8>>2]=c[G+8>>2];c[K+12>>2]=c[G+12>>2]}while(0);c[z+0>>2]=c[K+0>>2];c[z+4>>2]=c[K+4>>2];c[z+8>>2]=c[K+8>>2];c[z+12>>2]=c[K+12>>2];cb=ea(g[z>>2]);bb=ea(g[z+4>>2]);ab=ea(g[z+8>>2]);$a=ea(ea(ea(cb*cb)+ea(bb*bb))+ea(ab*ab));c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];_a=ea(g[v>>2]);Za=ea(g[h>>2]);fb=ea(g[Z>>2]);eb=ea(g[_>>2]);db=ea(g[w>>2]);jb=ea(g[$>>2]);mb=ea(g[aa>>2]);ia=eb;ja=fb;ka=Za;la=_a;ma=ea(g[ba>>2]);na=mb;oa=jb;pa=db;qa=$a;ra=$a>X;sa=ab;ta=bb;ua=cb}do if(ra){K=z+4|0;G=z+8|0;I=f+4|0;H=f+8|0;gb=f+16|0;Qa=f+20|0;s=f+24|0;r=f+32|0;ha=f+36|0;za=f+40|0;ya=b+96|0;xa=b+96|0;wa=b+100|0;va=b+104|0;ga=b+112|0;Pa=b+112|0;Oa=b+116|0;Na=b+120|0;J=f+48|0;Ma=f+52|0;La=f+56|0;Ka=L+4|0;Ja=L+8|0;Ia=L+12|0;Ha=M+4|0;Ga=M+8|0;Fa=N+4|0;Ea=N+8|0;Da=N+12|0;Ca=b+48|0;Ba=e+48|0;Aa=A+4|0;Sa=A+8|0;Ta=B+4|0;Ra=B+8|0;nb=C+4|0;ob=C+8|0;pb=P+4|0;qb=P+8|0;rb=P+12|0;sb=A+16|0;cb=V;bb=ua;ab=ta;$a=sa;db=qa;jb=la;mb=ka;_a=ja;Za=ia;fb=pa;eb=oa;fa=na;Y=ma;while(1){c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];kb=ea(-bb);Ua=ea(-ab);ca=ea(-$a);tb=c[F>>2]|0;ub=B+(tb<<4)|0;lb=ea(g[f>>2]);ib=ea(lb*kb);hb=ea(g[I>>2]);Ya=ea(ib+ea(hb*Ua));ib=ea(g[H>>2]);Xa=ea(Ya+ea(ib*ca));Ya=ea(g[gb>>2]);Va=ea(Ya*kb);Wa=ea(g[Qa>>2]);da=ea(Va+ea(Wa*Ua));Va=ea(g[s>>2]);vb=ea(da+ea(Va*ca));da=ea(g[r>>2]);wb=ea(da*kb);kb=ea(g[ha>>2]);xb=ea(wb+ea(kb*Ua));Ua=ea(g[za>>2]);wb=ea(xb+ea(Ua*ca));ca=ea(g[xa>>2]);xb=ea(g[wa>>2]);yb=ea(ea(ea(Xa*ca)+ea(vb*xb))+ea(wb*ea(g[va>>2])));xb=ea(g[Pa>>2]);ca=ea(g[Oa>>2]);zb=yb>ea(ea(ea(Xa*xb)+ea(vb*ca))+ea(wb*ea(g[Na>>2])));c[D+(tb<<2)>>2]=zb&1;c[u+0>>2]=c[ya+0>>2];c[u+4>>2]=c[ya+4>>2];c[u+8>>2]=c[ya+8>>2];c[u+12>>2]=c[ya+12>>2];c[t+0>>2]=c[ga+0>>2];c[t+4>>2]=c[ga+4>>2];c[t+8>>2]=c[ga+8>>2];c[t+12>>2]=c[ga+12>>2];Ab=zb?u:t;wb=ea(g[Ab>>2]);ca=ea(g[Ab+4>>2]);vb=ea(g[Ab+8>>2]);xb=ea(g[J>>2]);Xa=ea(g[Ma>>2]);yb=ea(ea(ea(ea(hb*wb)+ea(Wa*ca))+ea(kb*vb))+Xa);Xa=ea(ea(ea(ea(ib*wb)+ea(Va*ca))+ea(Ua*vb))+ea(g[La>>2]));g[L>>2]=ea(ea(ea(ea(lb*wb)+ea(Ya*ca))+ea(da*vb))+xb);g[Ka>>2]=yb;g[Ja>>2]=Xa;g[Ia>>2]=ea(0.0);c[ub+0>>2]=c[L+0>>2];c[ub+4>>2]=c[L+4>>2];c[ub+8>>2]=c[L+8>>2];c[ub+12>>2]=c[L+12>>2];CFb(M,e,z,C+(tb<<4)|0,E+(tb<<2)|0);Xa=ea(g[L>>2]);yb=ea(g[Ka>>2]);xb=ea(g[Ja>>2]);vb=ea(g[M>>2]);da=ea(g[Ha>>2]);ca=ea(g[Ga>>2]);Ya=ea(Xa-vb);wb=ea(yb-da);lb=ea(xb-ca);g[N>>2]=Ya;g[Fa>>2]=wb;g[Ea>>2]=lb;g[Da>>2]=ea(0.0);Bb=c[F>>2]|0;c[F>>2]=Bb+1;tb=A+(Bb<<4)|0;c[tb+0>>2]=c[N+0>>2];c[tb+4>>2]=c[N+4>>2];c[tb+8>>2]=c[N+8>>2];c[tb+12>>2]=c[N+12>>2];Ua=ea(g[Ca>>2]);Va=ea(g[Ba>>2]);ib=Ua>Va?Ua:Va;Va=cb>ib?cb:ib;ib=ea(W+Va);Ua=ea(db*ea(ib*ib));Cb=ea(g[z>>2]);Db=ea(g[K>>2]);Eb=ea(g[G>>2]);ib=ea(ea(ea(Cb*Ya)+ea(Db*wb))+ea(Eb*lb));tb=ea(ib*ib)>Ua;if(ib>ea(0.0)){Fb=tb;Gb=tb^1}else{Fb=0;Gb=1}tb=ea(X*db)>=ea(db-ib);if((tb|Fb)&(tb|Gb^1))break;do if(!Bb){c[v+0>>2]=c[L+0>>2];c[v+4>>2]=c[L+4>>2];c[v+8>>2]=c[L+8>>2];c[v+12>>2]=c[L+12>>2];c[w+0>>2]=c[M+0>>2];c[w+4>>2]=c[M+4>>2];c[w+8>>2]=c[M+8>>2];c[w+12>>2]=c[M+12>>2];c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}else if((Bb|0)==1){ib=ea(g[A>>2]);Ua=ea(g[Aa>>2]);kb=ea(g[Sa>>2]);Wa=ea(Ya-ib);hb=ea(wb-Ua);Hb=ea(lb-kb);Ib=ea(ea(ea(Wa*Wa)+ea(hb*hb))+ea(Hb*Hb));if(Ib==ea(0.0)){c[F>>2]=1;c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];c[P+0>>2]=c[A+0>>2];c[P+4>>2]=c[A+4>>2];c[P+8>>2]=c[A+8>>2];c[P+12>>2]=c[A+12>>2];break}else{Jb=ea(ea(ea(-ea(Ua*hb))-ea(ib*Wa))-ea(kb*Hb));Hb=ea(g[B>>2]);kb=ea(g[Ta>>2]);Wa=ea(g[Ra>>2]);ib=ea(Xa-Hb);hb=ea(yb-kb);Ua=ea(xb-Wa);Kb=ea(g[C>>2]);Lb=ea(g[nb>>2]);Mb=ea(g[ob>>2]);Nb=ea(vb-Kb);Ob=ea(da-Lb);Pb=ea(ca-Mb);Qb=ea(Jb/Ib);tb=Qb>ea(1.0);Ib=tb?ea(1.0):Qb;tb=Ib>ea(0.0);Qb=tb?Ib:ea(0.0);Ib=ea(Hb+ea(ib*Qb));ib=ea(kb+ea(hb*Qb));hb=ea(Wa+ea(Ua*Qb));Ua=ea(Kb+ea(Nb*Qb));Nb=ea(Lb+ea(Ob*Qb));Ob=ea(Mb+ea(Pb*Qb));g[v>>2]=Ib;g[h>>2]=ib;g[Z>>2]=hb;g[_>>2]=ea(0.0);g[w>>2]=Ua;g[$>>2]=Nb;g[aa>>2]=Ob;g[ba>>2]=ea(0.0);Qb=ea(ib-Nb);Nb=ea(hb-Ob);g[P>>2]=ea(Ib-Ua);g[pb>>2]=Qb;g[qb>>2]=Nb;g[rb>>2]=ea(0.0);break}}else if((Bb|0)==2)V6a(P,A,sb,N,A,B,C,F,v,w);else if((Bb|0)==3)qPa(P,A,B,C,D,E,N,L,M,F,v,w);else{c[P+0>>2]=c[N+0>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];c[P+12>>2]=c[N+12>>2]}while(0);c[z+0>>2]=c[P+0>>2];c[z+4>>2]=c[P+4>>2];c[z+8>>2]=c[P+8>>2];c[z+12>>2]=c[P+12>>2];ca=ea(g[z>>2]);da=ea(g[K>>2]);vb=ea(g[G>>2]);xb=ea(ea(ea(ca*ca)+ea(da*da))+ea(vb*vb));c[x+0>>2]=c[Q+0>>2];c[x+4>>2]=c[Q+4>>2];c[x+8>>2]=c[Q+8>>2];Rb=db>xb;if(xb>X^1|Rb^1){Sb=35;break}yb=ea(g[v>>2]);Xa=ea(g[h>>2]);lb=ea(g[Z>>2]);wb=ea(g[_>>2]);Ya=ea(g[w>>2]);Nb=ea(g[$>>2]);Qb=ea(g[aa>>2]);cb=Va;bb=ca;ab=da;$a=vb;db=xb;jb=yb;mb=Xa;_a=lb;Za=wb;fb=Ya;eb=Nb;fa=Qb;Y=ea(g[ba>>2])}if((Sb|0)==35){G=c[F>>2]|0;if(Rb){Tb=G;break}K=G+-1|0;if((n|0)!=0?(a[p>>0]=K,(K|0)!=0):0){G=0;do{a[n+G>>0]=c[D+(G<<2)>>2];a[o+G>>0]=c[E+(G<<2)>>2];G=G+1|0}while((G|0)!=(K|0))}g[v>>2]=jb;g[h>>2]=mb;g[Z>>2]=_a;g[_>>2]=Za;g[w>>2]=fb;g[$>>2]=eb;g[aa>>2]=fa;g[ba>>2]=Y;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];$a=ea(jb-fb);ab=ea(mb-eb);bb=ea(_a-fa);g[z>>2]=$a;g[z+4>>2]=ab;g[z+8>>2]=bb;g[z+12>>2]=ea(0.0);cb=ea(T(ea(db)));Qb=ea(ea(1.0)/cb);Nb=ea($a*Qb);$a=ea(ab*Qb);ab=ea(bb*Qb);Qb=ea(mb-ea(S*$a));bb=ea(_a-ea(S*ab));g[j>>2]=ea(jb-ea(S*Nb));g[j+4>>2]=Qb;g[j+8>>2]=bb;g[j+12>>2]=ea(0.0);bb=ea(ea(U*$a)+eb);Qb=ea(ea(U*ab)+fa);g[k>>2]=ea(ea(U*Nb)+fb);g[k+4>>2]=bb;g[k+8>>2]=Qb;g[k+12>>2]=ea(0.0);g[m>>2]=ea(cb-W);K=m+4|0;c[K+0>>2]=c[R+0>>2];c[K+4>>2]=c[R+4>>2];c[K+8>>2]=c[R+8>>2];g[l>>2]=Nb;g[l+4>>2]=$a;g[l+8>>2]=ab;g[l+12>>2]=ea(0.0);Ub=3;i=q;return Ub|0}if((n|0)!=0?(a[p>>0]=Bb,(Bb|0)!=0):0){K=0;do{a[n+K>>0]=c[D+(K<<2)>>2];a[o+K>>0]=c[E+(K<<2)>>2];K=K+1|0}while((K|0)!=(Bb|0))}if(!(Gb&(Fb^1))){Ub=0;i=q;return Ub|0}fb=ea(T(ea(db)));fa=ea(ea(1.0)/fb);eb=ea(Cb*fa);jb=ea(Db*fa);_a=ea(Eb*fa);fa=ea(g[v>>2]);mb=ea(g[h>>2]);Y=ea(mb-ea(S*jb));mb=ea(ea(g[Z>>2])-ea(S*_a));g[j>>2]=ea(fa-ea(S*eb));g[j+4>>2]=Y;g[j+8>>2]=mb;g[j+12>>2]=ea(0.0);mb=ea(g[w>>2]);Y=ea(g[$>>2]);fa=ea(ea(U*jb)+Y);Y=ea(ea(U*_a)+ea(g[aa>>2]));g[k>>2]=ea(ea(U*eb)+mb);g[k+4>>2]=fa;g[k+8>>2]=Y;g[k+12>>2]=ea(0.0);g[m>>2]=ea(fb-W);K=m+4|0;c[K+0>>2]=c[O+0>>2];c[K+4>>2]=c[O+4>>2];c[K+8>>2]=c[O+8>>2];g[l>>2]=eb;g[l+4>>2]=jb;g[l+8>>2]=_a;g[l+12>>2]=ea(0.0);Ub=1;i=q;return Ub|0}else Tb=c[F>>2]|0;while(0);if((n|0)!=0?(a[p>>0]=Tb,(Tb|0)!=0):0){p=0;do{a[n+p>>0]=c[D+(p<<2)>>2];a[o+p>>0]=c[E+(p<<2)>>2];p=p+1|0}while((p|0)!=(Tb|0))};c[j+0>>2]=c[v+0>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];Ub=6;i=q;return Ub|0}function ZFb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=0,M=Im,N=Im,O=0,P=Im,Q=0,R=Im,S=0,U=0,V=Im,W=0,X=Im,Y=0,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=0,Tb=0,Ub=0,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=0,$b=0,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=0,Gc=Im,Hc=Im,Ic=Im,Jc=0;e=i;i=i+480|0;n=e+416|0;o=e+272|0;p=e+192|0;q=e+208|0;r=e+48|0;s=e+256|0;t=e+288|0;u=e+368|0;v=e+400|0;w=e+224|0;x=e+32|0;y=e+432|0;z=e+456|0;A=e+468|0;B=e+64|0;C=e+128|0;D=e+304|0;E=e+384|0;F=e+240|0;G=e;H=e+444|0;I=e+16|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];J=ea(g[h>>2]);y=h+4|0;K=ea(g[y>>2]);L=h+8|0;M=ea(g[L>>2]);N=ea(g[f>>2]);O=f+4|0;P=ea(g[O>>2]);Q=f+8|0;R=ea(g[Q>>2]);c[A>>2]=1;S=d+48|0;U=d+48|0;V=ea(g[U>>2]);W=d+52|0;X=ea(g[W>>2]);Y=d+56|0;Z=ea(g[Y>>2]);_=ea(ea(ea(V*V)+ea(X*X))+ea(Z*Z))>ea(1.1920929e-07);c[o+0>>2]=c[S+0>>2];c[o+4>>2]=c[S+4>>2];c[o+8>>2]=c[S+8>>2];c[o+12>>2]=c[S+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);S=_?o:n;Z=ea(g[S>>2]);X=ea(g[S+4>>2]);V=ea(g[S+8>>2]);$=ea(ea(1.0)/ea(T(ea(ea(ea(Z*Z)+ea(X*X))+ea(V*V)))));aa=ea(Z*$);Z=ea(X*$);X=ea(V*$);$=ea(-aa);V=ea(-Z);ba=ea(-X);ca=ea(g[d>>2]);da=ea(ca*$);S=d+4|0;fa=ea(g[S>>2]);ga=ea(da+ea(fa*V));n=d+8|0;da=ea(g[n>>2]);ha=ea(ga+ea(da*ba));o=d+16|0;ga=ea(g[o>>2]);ia=ea(ga*$);_=d+20|0;ja=ea(g[_>>2]);ka=ea(ia+ea(ja*V));la=d+24|0;ia=ea(g[la>>2]);ma=ea(ka+ea(ia*ba));na=d+32|0;ka=ea(g[na>>2]);oa=ea(ka*$);pa=d+36|0;$=ea(g[pa>>2]);qa=ea(oa+ea($*V));ra=d+40|0;V=ea(g[ra>>2]);sa=ha>ea(0.0);ta=ma>ea(0.0);ua=ea(qa+ea(V*ba))>ea(0.0);va=a+144|0;c[q+0>>2]=c[va+0>>2];c[q+4>>2]=c[va+4>>2];c[q+8>>2]=c[va+8>>2];c[q+12>>2]=c[va+12>>2];wa=a+144|0;ba=ea(g[wa>>2]);xa=a+148|0;qa=ea(g[xa>>2]);ya=a+152|0;ma=ea(-qa);qa=ea(-ea(g[ya>>2]));g[p>>2]=ea(-ba);g[p+4>>2]=ma;g[p+8>>2]=qa;g[p+12>>2]=ea(0.0);qa=ea(g[(sa?q:p)>>2]);ma=ea(g[(ta?q:p)+4>>2]);ba=ea(g[(ua?q:p)+8>>2]);ha=ea(g[U>>2]);oa=ea(g[W>>2]);za=ea(ea(ea(ea(ca*qa)+ea(ga*ma))+ea(ka*ba))+ha);ha=ea(ea(ea(ea(fa*qa)+ea(ja*ma))+ea($*ba))+oa);oa=ea(ea(ea(ea(da*qa)+ea(ia*ma))+ea(V*ba))+ea(g[Y>>2]));ua=aa>ea(0.0);ta=Z>ea(0.0);sa=X>ea(0.0);Aa=b+144|0;c[q+0>>2]=c[Aa+0>>2];c[q+4>>2]=c[Aa+4>>2];c[q+8>>2]=c[Aa+8>>2];c[q+12>>2]=c[Aa+12>>2];Ba=b+144|0;X=ea(g[Ba>>2]);Ca=b+148|0;Z=ea(g[Ca>>2]);Da=b+152|0;aa=ea(-Z);Z=ea(-ea(g[Da>>2]));g[p>>2]=ea(-X);g[p+4>>2]=aa;g[p+8>>2]=Z;g[p+12>>2]=ea(0.0);Z=ea(g[(ua?q:p)>>2]);aa=ea(g[(ta?q:p)+4>>2]);X=ea(g[(sa?q:p)+8>>2]);ba=ea(za-Z);V=ea(ha-aa);ma=ea(oa-X);g[B>>2]=ba;sa=B+4|0;g[sa>>2]=V;ta=B+8|0;g[ta>>2]=ma;ua=B+12|0;g[ua>>2]=ea(0.0);Ea=B+16|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];Fa=B+32|0;c[Fa+0>>2]=c[x+0>>2];c[Fa+4>>2]=c[x+4>>2];c[Fa+8>>2]=c[x+8>>2];c[Fa+12>>2]=c[x+12>>2];Fa=B+48|0;c[Fa+0>>2]=c[x+0>>2];c[Fa+4>>2]=c[x+4>>2];c[Fa+8>>2]=c[x+8>>2];c[Fa+12>>2]=c[x+12>>2];g[C>>2]=za;Fa=C+4|0;g[Fa>>2]=ha;Ga=C+8|0;g[Ga>>2]=oa;g[C+12>>2]=ea(0.0);Ha=C+16|0;c[Ha+0>>2]=c[x+0>>2];c[Ha+4>>2]=c[x+4>>2];c[Ha+8>>2]=c[x+8>>2];c[Ha+12>>2]=c[x+12>>2];Ha=C+32|0;c[Ha+0>>2]=c[x+0>>2];c[Ha+4>>2]=c[x+4>>2];c[Ha+8>>2]=c[x+8>>2];c[Ha+12>>2]=c[x+12>>2];Ha=C+48|0;c[Ha+0>>2]=c[x+0>>2];c[Ha+4>>2]=c[x+4>>2];c[Ha+8>>2]=c[x+8>>2];c[Ha+12>>2]=c[x+12>>2];g[D>>2]=Z;Ha=D+4|0;g[Ha>>2]=aa;Ia=D+8|0;g[Ia>>2]=X;Ja=D+12|0;g[Ja>>2]=ea(0.0);Ka=D+16|0;c[Ka+0>>2]=c[x+0>>2];c[Ka+4>>2]=c[x+4>>2];c[Ka+8>>2]=c[x+8>>2];c[Ka+12>>2]=c[x+12>>2];Ka=D+32|0;c[Ka+0>>2]=c[x+0>>2];c[Ka+4>>2]=c[x+4>>2];c[Ka+8>>2]=c[x+8>>2];c[Ka+12>>2]=c[x+12>>2];Ka=D+48|0;c[Ka+0>>2]=c[x+0>>2];c[Ka+4>>2]=c[x+4>>2];c[Ka+8>>2]=c[x+8>>2];c[Ka+12>>2]=c[x+12>>2];ia=ea(-ba);qa=ea(-V);da=ea(-ma);c[E+0>>2]=c[B+0>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];c[E+12>>2]=c[B+12>>2];$=ea(g[a+32>>2]);ja=ea(g[b+32>>2]);fa=ea(($>ja?ja:$)*ea(.100000001));$=ea(fa*fa);fa=ea(ea(m*m)+$);g[F>>2]=za;b=F+4|0;g[b>>2]=ha;x=F+8|0;g[x>>2]=oa;Ka=F+12|0;g[Ka>>2]=ea(0.0);g[G>>2]=Z;La=G+4|0;g[La>>2]=aa;Ma=G+8|0;g[Ma>>2]=X;Na=G+12|0;g[Na>>2]=ea(0.0);X=ea(ea(ea(ba*ba)+ea(V*V))+ea(ma*ma));a:do if(X>$){Oa=p+4|0;Pa=p+8|0;Qa=p+12|0;Ra=p+4|0;Sa=p+8|0;Ta=p+12|0;Ua=E+4|0;Va=E+8|0;Wa=E+12|0;Xa=D+16|0;Ya=D+20|0;Za=D+24|0;_a=D+28|0;$a=D+32|0;ab=D+36|0;bb=D+40|0;cb=D+44|0;db=C+16|0;eb=C+20|0;fb=C+24|0;gb=B+16|0;hb=B+20|0;ib=B+24|0;jb=B+28|0;kb=C+32|0;lb=C+36|0;mb=C+40|0;nb=B+32|0;ob=B+36|0;pb=B+40|0;qb=B+44|0;rb=p+4|0;sb=p+8|0;tb=p+12|0;ub=I+4|0;vb=I+8|0;wb=I+12|0;ma=ia;V=qa;ba=da;aa=ea(ea(J*ea(0.0))+N);Z=ea(ea(K*ea(0.0))+P);ja=ea(ea(M*ea(0.0))+R);ka=ea(0.0);ga=ea(0.0);ca=oa;xb=ha;yb=za;zb=ia;Ab=qa;Bb=da;Cb=X;while(1){Db=ea(ea(1.0)/ea(T(ea(ea(ba*ba)+ea(ea(V*V)+ea(ma*ma))))));Eb=ea(ma*Db);Fb=ea(V*Db);Gb=ea(ba*Db);Db=ea(g[d>>2]);Hb=ea(Eb*Db);Ib=ea(g[S>>2]);Jb=ea(Hb+ea(Fb*Ib));Hb=ea(g[n>>2]);Kb=ea(Jb+ea(Gb*Hb));Jb=ea(g[o>>2]);Lb=ea(Eb*Jb);Mb=ea(g[_>>2]);Nb=ea(Lb+ea(Fb*Mb));Lb=ea(g[la>>2]);Ob=ea(Nb+ea(Gb*Lb));Nb=ea(g[na>>2]);Pb=ea(Eb*Nb);Qb=ea(g[pa>>2]);Rb=ea(Pb+ea(Fb*Qb));Pb=ea(g[ra>>2]);Sb=Kb>ea(0.0);Tb=Ob>ea(0.0);Ub=ea(Rb+ea(Gb*Pb))>ea(0.0);c[q+0>>2]=c[va+0>>2];c[q+4>>2]=c[va+4>>2];c[q+8>>2]=c[va+8>>2];c[q+12>>2]=c[va+12>>2];Rb=ea(g[wa>>2]);Ob=ea(g[xa>>2]);Kb=ea(-Ob);Ob=ea(-ea(g[ya>>2]));g[p>>2]=ea(-Rb);g[Oa>>2]=Kb;g[Pa>>2]=Ob;g[Qa>>2]=ea(0.0);Ob=ea(g[(Sb?q:p)>>2]);Kb=ea(g[(Tb?q:p)+4>>2]);Rb=ea(g[(Ub?q:p)+8>>2]);Vb=ea(g[U>>2]);Wb=ea(g[W>>2]);Xb=ea(ea(ea(ea(Db*Ob)+ea(Jb*Kb))+ea(Nb*Rb))+Vb);Vb=ea(ea(ea(ea(Ib*Ob)+ea(Mb*Kb))+ea(Qb*Rb))+Wb);Wb=ea(ea(ea(ea(Hb*Ob)+ea(Lb*Kb))+ea(Pb*Rb))+ea(g[Y>>2]));Ub=Eb<ea(-0.0);Tb=Fb<ea(-0.0);Sb=Gb<ea(-0.0);c[q+0>>2]=c[Aa+0>>2];c[q+4>>2]=c[Aa+4>>2];c[q+8>>2]=c[Aa+8>>2];c[q+12>>2]=c[Aa+12>>2];Rb=ea(g[Ba>>2]);Pb=ea(g[Ca>>2]);Kb=ea(-Rb);Rb=ea(-Pb);Pb=ea(-ea(g[Da>>2]));g[p>>2]=Kb;g[Ra>>2]=Rb;g[Sa>>2]=Pb;g[Ta>>2]=ea(0.0);Lb=ea(g[(Ub?q:p)>>2]);Ob=ea(g[(Tb?q:p)+4>>2]);Hb=ea(aa+Lb);Lb=ea(Z+Ob);Ob=ea(ja+ea(g[(Sb?q:p)+8>>2]));Qb=ea(Xb-Hb);Mb=ea(Vb-Lb);Ib=ea(Wb-Ob);g[E>>2]=Qb;g[Ua>>2]=Mb;g[Va>>2]=Ib;g[Wa>>2]=ea(0.0);Nb=ea(ea(ea(ea(-ea(Fb*Mb))-ea(Eb*Qb))-ea(Gb*Ib))-m);Jb=ea(g[h>>2]);Db=ea(g[y>>2]);Yb=ea(g[L>>2]);Zb=ea(ea(ea(Eb*Jb)+ea(Fb*Db))+ea(Gb*Yb));if(Nb>ea(0.0)){if(Zb>=ea(0.0)){_b=0;$b=22;break}Gb=ea(ka-ea(Nb/Zb));c[z+0>>2]=c[H+0>>2];c[z+4>>2]=c[H+4>>2];c[z+8>>2]=c[H+8>>2];if(Gb>ka){if(Gb>ea(1.0)){_b=0;$b=22;break}Zb=ea(g[f>>2]);Nb=ea(g[O>>2]);Fb=ea(ea(Gb*Jb)+Zb);Zb=ea(ea(Gb*Db)+Nb);Nb=ea(ea(Gb*Yb)+ea(g[Q>>2]));Yb=ea(Fb-aa);Db=ea(Zb-Z);Jb=ea(Nb-ja);Eb=ea(g[D>>2]);ac=ea(g[Ha>>2]);bc=ea(Yb+Eb);Eb=ea(Db+ac);ac=ea(Jb+ea(g[Ia>>2]));cc=ea(g[Xa>>2]);dc=ea(g[Ya>>2]);ec=ea(Yb+cc);cc=ea(Db+dc);dc=ea(Jb+ea(g[Za>>2]));fc=ea(g[$a>>2]);gc=ea(g[ab>>2]);hc=ea(Yb+fc);fc=ea(Db+gc);gc=ea(Jb+ea(g[bb>>2]));g[D>>2]=bc;g[Ha>>2]=Eb;g[Ia>>2]=ac;g[Ja>>2]=ea(0.0);g[Xa>>2]=ec;g[Ya>>2]=cc;g[Za>>2]=dc;g[_a>>2]=ea(0.0);g[$a>>2]=hc;g[ab>>2]=fc;g[bb>>2]=gc;g[cb>>2]=ea(0.0);Jb=ea(g[C>>2]);Db=ea(g[Fa>>2]);Yb=ea(Db-Eb);Eb=ea(ea(g[Ga>>2])-ac);g[B>>2]=ea(Jb-bc);g[sa>>2]=Yb;g[ta>>2]=Eb;g[ua>>2]=ea(0.0);Eb=ea(g[db>>2]);Yb=ea(g[eb>>2]);bc=ea(Yb-cc);cc=ea(ea(g[fb>>2])-dc);g[gb>>2]=ea(Eb-ec);g[hb>>2]=bc;g[ib>>2]=cc;g[jb>>2]=ea(0.0);cc=ea(g[kb>>2]);bc=ea(g[lb>>2]);ec=ea(bc-fc);fc=ea(ea(g[mb>>2])-gc);g[nb>>2]=ea(cc-hc);g[ob>>2]=ec;g[pb>>2]=fc;g[qb>>2]=ea(0.0);c[q+0>>2]=c[Aa+0>>2];c[q+4>>2]=c[Aa+4>>2];c[q+8>>2]=c[Aa+8>>2];c[q+12>>2]=c[Aa+12>>2];g[p>>2]=Kb;g[rb>>2]=Rb;g[sb>>2]=Pb;g[tb>>2]=ea(0.0);Pb=ea(g[(Ub?q:p)>>2]);Rb=ea(g[(Tb?q:p)+4>>2]);Kb=ea(Fb+Pb);Pb=ea(Zb+Rb);Rb=ea(Nb+ea(g[(Sb?q:p)+8>>2]));fc=ea(Xb-Kb);ec=ea(Vb-Pb);hc=ea(Wb-Rb);g[E>>2]=fc;g[Ua>>2]=ec;g[Va>>2]=hc;g[Wa>>2]=ea(0.0);ic=Kb;jc=Pb;kc=Rb;lc=fc;mc=ec;nc=hc;oc=ea(3402823469999999843913219.0e14);pc=Gb;qc=Nb;rc=Zb;sc=Fb;tc=ba;uc=V;vc=ma}else{ic=Hb;jc=Lb;kc=Ob;lc=Qb;mc=Mb;nc=Ib;oc=Cb;pc=Gb;qc=ja;rc=Z;sc=aa;tc=Bb;uc=Ab;vc=zb}}else{ic=Hb;jc=Lb;kc=Ob;lc=Qb;mc=Mb;nc=Ib;oc=Cb;pc=ka;qc=ja;rc=Z;sc=aa;tc=Bb;uc=Ab;vc=zb}Sb=c[A>>2]|0;g[C+(Sb<<4)>>2]=Xb;g[C+(Sb<<4)+4>>2]=Vb;g[C+(Sb<<4)+8>>2]=Wb;g[C+(Sb<<4)+12>>2]=ea(0.0);g[D+(Sb<<4)>>2]=ic;g[D+(Sb<<4)+4>>2]=jc;g[D+(Sb<<4)+8>>2]=kc;g[D+(Sb<<4)+12>>2]=ea(0.0);c[A>>2]=Sb+1;Tb=B+(Sb<<4)|0;c[Tb+0>>2]=c[E+0>>2];c[Tb+4>>2]=c[E+4>>2];c[Tb+8>>2]=c[E+8>>2];c[Tb+12>>2]=c[E+12>>2];do if((Sb|0)==2)V6a(I,B,Ea,E,B,C,D,A,F,G);else if(!Sb){g[F>>2]=Xb;g[b>>2]=Vb;g[x>>2]=Wb;g[Ka>>2]=ea(0.0);g[G>>2]=ic;g[La>>2]=jc;g[Ma>>2]=kc;g[Na>>2]=ea(0.0);c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2]}else if((Sb|0)==3)pPa(I,B,C,D,A,F,G);else if((Sb|0)==1){Ib=ea(g[B>>2]);Mb=ea(g[sa>>2]);Qb=ea(g[ta>>2]);Ob=ea(lc-Ib);Lb=ea(mc-Mb);Hb=ea(nc-Qb);Gb=ea(ea(ea(Ob*Ob)+ea(Lb*Lb))+ea(Hb*Hb));if(Gb==ea(0.0)){c[A>>2]=1;c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];c[I+0>>2]=c[B+0>>2];c[I+4>>2]=c[B+4>>2];c[I+8>>2]=c[B+8>>2];c[I+12>>2]=c[B+12>>2];break}else{Fb=ea(ea(ea(-ea(Mb*Lb))-ea(Ib*Ob))-ea(Qb*Hb));Hb=ea(g[C>>2]);Qb=ea(g[Fa>>2]);Ob=ea(g[Ga>>2]);Ib=ea(Xb-Hb);Lb=ea(Vb-Qb);Mb=ea(Wb-Ob);Zb=ea(g[D>>2]);Nb=ea(g[Ha>>2]);hc=ea(g[Ia>>2]);ec=ea(ic-Zb);fc=ea(jc-Nb);Rb=ea(kc-hc);Pb=ea(Fb/Gb);Tb=Pb>ea(1.0);Gb=Tb?ea(1.0):Pb;Tb=Gb>ea(0.0);Pb=Tb?Gb:ea(0.0);Gb=ea(Hb+ea(Ib*Pb));Ib=ea(Qb+ea(Lb*Pb));Lb=ea(Ob+ea(Mb*Pb));Mb=ea(Zb+ea(ec*Pb));ec=ea(Nb+ea(fc*Pb));fc=ea(hc+ea(Rb*Pb));g[F>>2]=Gb;g[b>>2]=Ib;g[x>>2]=Lb;g[Ka>>2]=ea(0.0);g[G>>2]=Mb;g[La>>2]=ec;g[Ma>>2]=fc;g[Na>>2]=ea(0.0);Pb=ea(Ib-ec);ec=ea(Lb-fc);g[I>>2]=ea(Gb-Mb);g[ub>>2]=Pb;g[vb>>2]=ec;g[wb>>2]=ea(0.0);break}}else{c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2]}while(0);Wb=ea(g[I>>2]);Vb=ea(g[ub>>2]);Xb=ea(g[vb>>2]);ec=ea(-Wb);Pb=ea(-Vb);Mb=ea(-Xb);Gb=ea(ea(ea(Wb*Wb)+ea(Vb*Vb))+ea(Xb*Xb));Sb=oc>Gb;Tb=Sb<<31>>31;if(!(Gb>fa)){wc=pc;xc=ga;yc=ca;zc=xb;Ac=yb;Bc=Mb;Cc=Pb;Dc=ec;Ec=Gb;Fc=Tb;Gc=tc;Hc=uc;Ic=vc;break a}if(!Sb){wc=pc;xc=ga;yc=ca;zc=xb;Ac=yb;Bc=Mb;Cc=Pb;Dc=ec;Ec=Gb;Fc=Tb;Gc=tc;Hc=uc;Ic=vc;break a}Xb=ea(g[F>>2]);Vb=ea(g[b>>2]);Wb=ea(g[x>>2]);ma=ec;V=Pb;ba=Mb;aa=sc;Z=rc;ja=qc;ka=pc;ga=ea(g[Ka>>2]);ca=Wb;xb=Vb;yb=Xb;zb=vc;Ab=uc;Bb=tc;Cb=Gb}if(($b|0)==22){i=e;return _b|0}}else{wc=ea(0.0);xc=ea(0.0);yc=oa;zc=ha;Ac=za;Bc=da;Cc=qa;Dc=ia;Ec=X;Fc=-1;Gc=da;Hc=qa;Ic=ia}while(0);$b=c[a+64>>2]|0;I=c[a+68>>2]|0;E=c[a+72>>2]|0;if(Ec>$)Jc=(Fc|0)==0?r:s;else Jc=r;g[s>>2]=Dc;g[s+4>>2]=Cc;g[s+8>>2]=Bc;g[s+12>>2]=ea(0.0);g[r>>2]=Ic;g[r+4>>2]=Hc;g[r+8>>2]=Gc;g[r+12>>2]=ea(0.0);Gc=ea(g[Jc>>2]);Hc=ea(g[Jc+4>>2]);Ic=ea(g[Jc+8>>2]);Bc=ea(ea(1.0)/ea(T(ea(ea(ea(Gc*Gc)+ea(Hc*Hc))+ea(Ic*Ic)))));Cc=ea(-ea(Gc*Bc));Gc=ea(-ea(Hc*Bc));Hc=ea(-ea(Ic*Bc));g[k>>2]=Cc;g[k+4>>2]=Gc;g[k+8>>2]=Hc;g[k+12>>2]=ea(0.0);g[j>>2]=wc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[F+0>>2];c[u+4>>2]=c[F+4>>2];c[u+8>>2]=c[F+8>>2];c[u+12>>2]=c[F+12>>2];g[t>>2]=Ac;g[t+4>>2]=zc;g[t+8>>2]=yc;g[t+12>>2]=xc;z=(Fc|0)==0?t:u;xc=ea(g[z>>2]);yc=ea(g[z+4>>2]);zc=ea(g[z+8>>2]);g[F>>2]=xc;g[b>>2]=yc;g[x>>2]=zc;g[Ka>>2]=ea(0.0);Ac=ea(g[a+16>>2]);wc=ea(xc-ea(Ac*Cc));Cc=ea(yc-ea(Ac*Gc));Gc=ea(zc-ea(Ac*Hc));c[v+0>>2]=c[F+0>>2];c[v+4>>2]=c[F+4>>2];c[v+8>>2]=c[F+8>>2];c[v+12>>2]=c[F+12>>2];g[w>>2]=wc;g[w+4>>2]=Cc;g[w+8>>2]=Gc;g[w+12>>2]=ea(0.0);Gc=ea(g[(($b|0)==0?v:w)>>2]);Cc=ea(g[((I|0)==0?v:w)+4>>2]);wc=ea(g[((E|0)==0?v:w)+8>>2]);g[l>>2]=Gc;g[l+4>>2]=Cc;g[l+8>>2]=wc;g[l+12>>2]=ea(0.0);_b=1;i=e;return _b|0}
function _Fb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=0,R=Im,S=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=Im,pa=0,qa=Im,ra=0,sa=Im,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=0,Ub=0,Vb=0,Wb=Im,Xb=Im,Yb=Im,Zb=0,_b=0,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=0,Ec=Im,Fc=Im,Gc=Im,Hc=0;e=i;i=i+560|0;n=e+496|0;o=e+16|0;p=e;q=e+448|0;r=e+192|0;s=e+64|0;t=e+80|0;u=e+96|0;v=e+400|0;w=e+432|0;x=e+464|0;y=e+512|0;z=e+524|0;A=e+548|0;B=e+256|0;C=e+32|0;D=e+272|0;E=e+112|0;F=e+336|0;G=e+48|0;H=e+176|0;I=e+416|0;J=e+208|0;K=e+240|0;L=e+536|0;M=e+224|0;N=e+480|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];O=ea(g[h>>2]);y=h+4|0;P=ea(g[y>>2]);Q=h+8|0;R=ea(g[Q>>2]);S=ea(g[f>>2]);U=f+4|0;V=ea(g[U>>2]);W=f+8|0;X=ea(g[W>>2]);c[A>>2]=1;Y=d+48|0;Z=d+48|0;_=ea(g[Z>>2]);$=d+52|0;aa=ea(g[$>>2]);ba=d+56|0;ca=ea(g[ba>>2]);da=ea(ea(ea(_*_)+ea(aa*aa))+ea(ca*ca))>ea(1.1920929e-07);c[o+0>>2]=c[Y+0>>2];c[o+4>>2]=c[Y+4>>2];c[o+8>>2]=c[Y+8>>2];c[o+12>>2]=c[Y+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);Y=da?o:n;ca=ea(g[Y>>2]);aa=ea(g[Y+4>>2]);_=ea(g[Y+8>>2]);fa=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(aa*aa))+ea(_*_)))));ga=ea(ca*fa);ca=ea(aa*fa);aa=ea(_*fa);g[B>>2]=ga;g[B+4>>2]=ca;g[B+8>>2]=aa;g[B+12>>2]=ea(0.0);fa=ea(-ga);ga=ea(-ca);ca=ea(-aa);aa=ea(g[d>>2]);_=ea(aa*fa);Y=d+4|0;ha=ea(g[Y>>2]);ia=ea(_+ea(ha*ga));n=d+8|0;_=ea(g[n>>2]);ja=ea(ia+ea(_*ca));o=d+16|0;ia=ea(g[o>>2]);ka=ea(ia*fa);da=d+20|0;la=ea(g[da>>2]);ma=ea(ka+ea(la*ga));na=d+24|0;ka=ea(g[na>>2]);oa=ea(ma+ea(ka*ca));pa=d+32|0;ma=ea(g[pa>>2]);qa=ea(ma*fa);ra=d+36|0;fa=ea(g[ra>>2]);sa=ea(qa+ea(fa*ga));ta=d+40|0;ga=ea(g[ta>>2]);ua=ja>ea(0.0);va=oa>ea(0.0);wa=ea(sa+ea(ga*ca))>ea(0.0);xa=a+144|0;c[q+0>>2]=c[xa+0>>2];c[q+4>>2]=c[xa+4>>2];c[q+8>>2]=c[xa+8>>2];c[q+12>>2]=c[xa+12>>2];ya=a+144|0;ca=ea(g[ya>>2]);za=a+148|0;sa=ea(g[za>>2]);Aa=a+152|0;oa=ea(-sa);sa=ea(-ea(g[Aa>>2]));g[p>>2]=ea(-ca);g[p+4>>2]=oa;g[p+8>>2]=sa;g[p+12>>2]=ea(0.0);sa=ea(g[(ua?q:p)>>2]);oa=ea(g[(va?q:p)+4>>2]);ca=ea(g[(wa?q:p)+8>>2]);ja=ea(g[Z>>2]);qa=ea(g[$>>2]);Ba=ea(ea(ea(ea(aa*sa)+ea(ia*oa))+ea(ma*ca))+ja);ja=ea(ea(ea(ea(ha*sa)+ea(la*oa))+ea(fa*ca))+qa);qa=ea(ea(ea(ea(_*sa)+ea(ka*oa))+ea(ga*ca))+ea(g[ba>>2]));HFb(C,b,B);ca=ea(g[C>>2]);ga=ea(g[C+4>>2]);oa=ea(Ba-ca);ca=ea(ja-ga);ga=ea(qa-ea(g[C+8>>2]));g[D>>2]=oa;B=D+4|0;g[B>>2]=ca;wa=D+8|0;g[wa>>2]=ga;va=D+12|0;g[va>>2]=ea(0.0);ua=D+16|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];Ca=D+32|0;c[Ca+0>>2]=c[x+0>>2];c[Ca+4>>2]=c[x+4>>2];c[Ca+8>>2]=c[x+8>>2];c[Ca+12>>2]=c[x+12>>2];Ca=D+48|0;c[Ca+0>>2]=c[x+0>>2];c[Ca+4>>2]=c[x+4>>2];c[Ca+8>>2]=c[x+8>>2];c[Ca+12>>2]=c[x+12>>2];g[E>>2]=Ba;Ca=E+4|0;g[Ca>>2]=ja;Da=E+8|0;g[Da>>2]=qa;g[E+12>>2]=ea(0.0);Ea=E+16|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];Ea=E+32|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];Ea=E+48|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];Ea=F+16|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];Ea=F+32|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];Ea=F+48|0;c[Ea+0>>2]=c[x+0>>2];c[Ea+4>>2]=c[x+4>>2];c[Ea+8>>2]=c[x+8>>2];c[Ea+12>>2]=c[x+12>>2];ka=ea(-oa);sa=ea(-ca);_=ea(-ga);c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];fa=ea(g[a+32>>2]);la=ea(g[b+32>>2]);ha=ea((fa>la?la:fa)*ea(.100000001));fa=ea(ha*ha);ha=ea(ea(m*m)+fa);g[H>>2]=Ba;x=H+4|0;g[x>>2]=ja;Ea=H+8|0;g[Ea>>2]=qa;Fa=H+12|0;g[Fa>>2]=ea(0.0);c[I+0>>2]=c[C+0>>2];c[I+4>>2]=c[C+4>>2];c[I+8>>2]=c[C+8>>2];c[I+12>>2]=c[C+12>>2];la=ea(ea(ea(oa*oa)+ea(ca*ca))+ea(ga*ga));a:do if(la>fa){C=J+4|0;Ga=J+8|0;Ha=J+12|0;Ia=p+4|0;Ja=p+8|0;Ka=p+12|0;La=K+4|0;Ma=K+8|0;Na=G+4|0;Oa=G+8|0;Pa=G+12|0;Qa=F+4|0;Ra=F+8|0;Sa=F+12|0;Ta=F+16|0;Ua=F+20|0;Va=F+24|0;Wa=F+28|0;Xa=F+32|0;Ya=F+36|0;Za=F+40|0;_a=F+44|0;$a=E+16|0;ab=E+20|0;bb=E+24|0;cb=D+16|0;db=D+20|0;eb=D+24|0;fb=D+28|0;gb=E+32|0;hb=E+36|0;ib=E+40|0;jb=D+32|0;kb=D+36|0;lb=D+40|0;mb=D+44|0;nb=M+4|0;ob=M+8|0;pb=N+4|0;qb=N+8|0;rb=I+4|0;sb=I+8|0;tb=I+12|0;ub=N+12|0;ga=ka;ca=sa;oa=_;ma=ea(ea(O*ea(0.0))+S);ia=ea(ea(P*ea(0.0))+V);aa=ea(ea(R*ea(0.0))+X);vb=ea(0.0);wb=ea(0.0);xb=qa;yb=ja;zb=Ba;Ab=ka;Bb=sa;Cb=_;Db=la;while(1){Eb=ea(ea(1.0)/ea(T(ea(ea(oa*oa)+ea(ea(ca*ca)+ea(ga*ga))))));Fb=ea(ga*Eb);Gb=ea(ca*Eb);Hb=ea(oa*Eb);Eb=ea(-Gb);Ib=ea(-Hb);g[J>>2]=ea(-Fb);g[C>>2]=Eb;g[Ga>>2]=Ib;g[Ha>>2]=ea(0.0);Ib=ea(g[d>>2]);Eb=ea(Fb*Ib);Jb=ea(g[Y>>2]);Kb=ea(Eb+ea(Gb*Jb));Eb=ea(g[n>>2]);Lb=ea(Kb+ea(Hb*Eb));Kb=ea(g[o>>2]);Mb=ea(Fb*Kb);Nb=ea(g[da>>2]);Ob=ea(Mb+ea(Gb*Nb));Mb=ea(g[na>>2]);Pb=ea(Ob+ea(Hb*Mb));Ob=ea(g[pa>>2]);Qb=ea(Fb*Ob);Rb=ea(g[ra>>2]);Sb=ea(Qb+ea(Gb*Rb));Qb=ea(g[ta>>2]);Tb=Lb>ea(0.0);Ub=Pb>ea(0.0);Vb=ea(Sb+ea(Hb*Qb))>ea(0.0);c[q+0>>2]=c[xa+0>>2];c[q+4>>2]=c[xa+4>>2];c[q+8>>2]=c[xa+8>>2];c[q+12>>2]=c[xa+12>>2];Sb=ea(g[ya>>2]);Pb=ea(g[za>>2]);Lb=ea(-Pb);Pb=ea(-ea(g[Aa>>2]));g[p>>2]=ea(-Sb);g[Ia>>2]=Lb;g[Ja>>2]=Pb;g[Ka>>2]=ea(0.0);Pb=ea(g[(Tb?q:p)>>2]);Lb=ea(g[(Ub?q:p)+4>>2]);Sb=ea(g[(Vb?q:p)+8>>2]);Wb=ea(g[Z>>2]);Xb=ea(g[$>>2]);Yb=ea(ea(ea(ea(Ib*Pb)+ea(Kb*Lb))+ea(Ob*Sb))+Wb);Wb=ea(ea(ea(ea(Jb*Pb)+ea(Nb*Lb))+ea(Rb*Sb))+Xb);Xb=ea(ea(ea(ea(Eb*Pb)+ea(Mb*Lb))+ea(Qb*Sb))+ea(g[ba>>2]));HFb(K,b,J);Sb=ea(g[K>>2]);Qb=ea(g[La>>2]);Lb=ea(ma+Sb);Sb=ea(ia+Qb);Qb=ea(aa+ea(g[Ma>>2]));Mb=ea(Yb-Lb);Pb=ea(Wb-Sb);Eb=ea(Xb-Qb);g[G>>2]=Mb;g[Na>>2]=Pb;g[Oa>>2]=Eb;g[Pa>>2]=ea(0.0);Rb=ea(ea(ea(ea(-ea(Gb*Pb))-ea(Fb*Mb))-ea(Hb*Eb))-m);Nb=ea(g[h>>2]);Jb=ea(g[y>>2]);Ob=ea(g[Q>>2]);Kb=ea(ea(ea(Fb*Nb)+ea(Gb*Jb))+ea(Hb*Ob));if(Rb>ea(0.0)){if(Kb>=ea(0.0)){Zb=0;_b=22;break}Hb=ea(vb-ea(Rb/Kb));c[z+0>>2]=c[L+0>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];if(Hb>vb){if(Hb>ea(1.0)){Zb=0;_b=22;break}Kb=ea(g[f>>2]);Rb=ea(g[U>>2]);Gb=ea(ea(Hb*Nb)+Kb);Kb=ea(ea(Hb*Jb)+Rb);Rb=ea(ea(Hb*Ob)+ea(g[W>>2]));Ob=ea(Gb-ma);Jb=ea(Kb-ia);Nb=ea(Rb-aa);Fb=ea(g[F>>2]);Ib=ea(g[Qa>>2]);$b=ea(Ob+Fb);Fb=ea(Jb+Ib);Ib=ea(Nb+ea(g[Ra>>2]));ac=ea(g[Ta>>2]);bc=ea(g[Ua>>2]);cc=ea(Ob+ac);ac=ea(Jb+bc);bc=ea(Nb+ea(g[Va>>2]));dc=ea(g[Xa>>2]);ec=ea(g[Ya>>2]);fc=ea(Ob+dc);dc=ea(Jb+ec);ec=ea(Nb+ea(g[Za>>2]));g[F>>2]=$b;g[Qa>>2]=Fb;g[Ra>>2]=Ib;g[Sa>>2]=ea(0.0);g[Ta>>2]=cc;g[Ua>>2]=ac;g[Va>>2]=bc;g[Wa>>2]=ea(0.0);g[Xa>>2]=fc;g[Ya>>2]=dc;g[Za>>2]=ec;g[_a>>2]=ea(0.0);Nb=ea(g[E>>2]);Jb=ea(g[Ca>>2]);Ob=ea(Jb-Fb);Fb=ea(ea(g[Da>>2])-Ib);g[D>>2]=ea(Nb-$b);g[B>>2]=Ob;g[wa>>2]=Fb;g[va>>2]=ea(0.0);Fb=ea(g[$a>>2]);Ob=ea(g[ab>>2]);$b=ea(Ob-ac);ac=ea(ea(g[bb>>2])-bc);g[cb>>2]=ea(Fb-cc);g[db>>2]=$b;g[eb>>2]=ac;g[fb>>2]=ea(0.0);ac=ea(g[gb>>2]);$b=ea(g[hb>>2]);cc=ea($b-dc);dc=ea(ea(g[ib>>2])-ec);g[jb>>2]=ea(ac-fc);g[kb>>2]=cc;g[lb>>2]=dc;g[mb>>2]=ea(0.0);HFb(M,b,J);dc=ea(g[M>>2]);cc=ea(g[nb>>2]);fc=ea(Gb+dc);dc=ea(Kb+cc);cc=ea(Rb+ea(g[ob>>2]));ac=ea(Yb-fc);ec=ea(Wb-dc);$b=ea(Xb-cc);g[G>>2]=ac;g[Na>>2]=ec;g[Oa>>2]=$b;g[Pa>>2]=ea(0.0);gc=fc;hc=dc;ic=cc;jc=ac;kc=ec;lc=$b;mc=ea(3402823469999999843913219.0e14);nc=Hb;oc=Rb;pc=Kb;qc=Gb;rc=oa;sc=ca;tc=ga}else{gc=Lb;hc=Sb;ic=Qb;jc=Mb;kc=Pb;lc=Eb;mc=Db;nc=Hb;oc=aa;pc=ia;qc=ma;rc=Cb;sc=Bb;tc=Ab}}else{gc=Lb;hc=Sb;ic=Qb;jc=Mb;kc=Pb;lc=Eb;mc=Db;nc=vb;oc=aa;pc=ia;qc=ma;rc=Cb;sc=Bb;tc=Ab}Vb=c[A>>2]|0;g[E+(Vb<<4)>>2]=Yb;g[E+(Vb<<4)+4>>2]=Wb;g[E+(Vb<<4)+8>>2]=Xb;g[E+(Vb<<4)+12>>2]=ea(0.0);g[F+(Vb<<4)>>2]=gc;g[F+(Vb<<4)+4>>2]=hc;g[F+(Vb<<4)+8>>2]=ic;g[F+(Vb<<4)+12>>2]=ea(0.0);c[A>>2]=Vb+1;Ub=D+(Vb<<4)|0;c[Ub+0>>2]=c[G+0>>2];c[Ub+4>>2]=c[G+4>>2];c[Ub+8>>2]=c[G+8>>2];c[Ub+12>>2]=c[G+12>>2];do if((Vb|0)==1){Eb=ea(g[D>>2]);Pb=ea(g[B>>2]);Mb=ea(g[wa>>2]);Qb=ea(jc-Eb);Sb=ea(kc-Pb);Lb=ea(lc-Mb);Hb=ea(ea(ea(Qb*Qb)+ea(Sb*Sb))+ea(Lb*Lb));if(Hb==ea(0.0)){c[A>>2]=1;c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[N+0>>2]=c[D+0>>2];c[N+4>>2]=c[D+4>>2];c[N+8>>2]=c[D+8>>2];c[N+12>>2]=c[D+12>>2];break}else{Gb=ea(ea(ea(-ea(Pb*Sb))-ea(Eb*Qb))-ea(Mb*Lb));Lb=ea(g[E>>2]);Mb=ea(g[Ca>>2]);Qb=ea(g[Da>>2]);Eb=ea(Yb-Lb);Sb=ea(Wb-Mb);Pb=ea(Xb-Qb);Kb=ea(g[F>>2]);Rb=ea(g[Qa>>2]);$b=ea(g[Ra>>2]);ec=ea(gc-Kb);ac=ea(hc-Rb);cc=ea(ic-$b);dc=ea(Gb/Hb);Ub=dc>ea(1.0);Hb=Ub?ea(1.0):dc;Ub=Hb>ea(0.0);dc=Ub?Hb:ea(0.0);Hb=ea(Lb+ea(Eb*dc));Eb=ea(Mb+ea(Sb*dc));Sb=ea(Qb+ea(Pb*dc));Pb=ea(Kb+ea(ec*dc));ec=ea(Rb+ea(ac*dc));ac=ea($b+ea(cc*dc));g[H>>2]=Hb;g[x>>2]=Eb;g[Ea>>2]=Sb;g[Fa>>2]=ea(0.0);g[I>>2]=Pb;g[rb>>2]=ec;g[sb>>2]=ac;g[tb>>2]=ea(0.0);dc=ea(Eb-ec);ec=ea(Sb-ac);g[N>>2]=ea(Hb-Pb);g[pb>>2]=dc;g[qb>>2]=ec;g[ub>>2]=ea(0.0);break}}else if((Vb|0)==2)V6a(N,D,ua,G,D,E,F,A,H,I);else if((Vb|0)==3)pPa(N,D,E,F,A,H,I);else if(!Vb){g[H>>2]=Yb;g[x>>2]=Wb;g[Ea>>2]=Xb;g[Fa>>2]=ea(0.0);g[I>>2]=gc;g[rb>>2]=hc;g[sb>>2]=ic;g[tb>>2]=ea(0.0);c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}else{c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}while(0);Xb=ea(g[N>>2]);Wb=ea(g[pb>>2]);Yb=ea(g[qb>>2]);ec=ea(-Xb);dc=ea(-Wb);Pb=ea(-Yb);Hb=ea(ea(ea(Xb*Xb)+ea(Wb*Wb))+ea(Yb*Yb));Vb=mc>Hb;Ub=Vb<<31>>31;if(!(Hb>ha)){uc=nc;vc=wb;wc=xb;xc=yb;yc=zb;zc=Pb;Ac=dc;Bc=ec;Cc=Hb;Dc=Ub;Ec=rc;Fc=sc;Gc=tc;break a}if(!Vb){uc=nc;vc=wb;wc=xb;xc=yb;yc=zb;zc=Pb;Ac=dc;Bc=ec;Cc=Hb;Dc=Ub;Ec=rc;Fc=sc;Gc=tc;break a}Yb=ea(g[H>>2]);Wb=ea(g[x>>2]);Xb=ea(g[Ea>>2]);ga=ec;ca=dc;oa=Pb;ma=qc;ia=pc;aa=oc;vb=nc;wb=ea(g[Fa>>2]);xb=Xb;yb=Wb;zb=Yb;Ab=tc;Bb=sc;Cb=rc;Db=Hb}if((_b|0)==22){i=e;return Zb|0}}else{uc=ea(0.0);vc=ea(0.0);wc=qa;xc=ja;yc=Ba;zc=_;Ac=sa;Bc=ka;Cc=la;Dc=-1;Ec=_;Fc=sa;Gc=ka}while(0);_b=c[a+64>>2]|0;N=c[a+68>>2]|0;G=c[a+72>>2]|0;if(Cc>fa)Hc=(Dc|0)==0?r:s;else Hc=r;g[s>>2]=Bc;g[s+4>>2]=Ac;g[s+8>>2]=zc;g[s+12>>2]=ea(0.0);g[r>>2]=Gc;g[r+4>>2]=Fc;g[r+8>>2]=Ec;g[r+12>>2]=ea(0.0);Ec=ea(g[Hc>>2]);Fc=ea(g[Hc+4>>2]);Gc=ea(g[Hc+8>>2]);zc=ea(ea(1.0)/ea(T(ea(ea(ea(Ec*Ec)+ea(Fc*Fc))+ea(Gc*Gc)))));Ac=ea(-ea(Ec*zc));Ec=ea(-ea(Fc*zc));Fc=ea(-ea(Gc*zc));g[k>>2]=Ac;g[k+4>>2]=Ec;g[k+8>>2]=Fc;g[k+12>>2]=ea(0.0);g[j>>2]=uc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[H+0>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];c[u+12>>2]=c[H+12>>2];g[t>>2]=yc;g[t+4>>2]=xc;g[t+8>>2]=wc;g[t+12>>2]=vc;z=(Dc|0)==0?t:u;vc=ea(g[z>>2]);wc=ea(g[z+4>>2]);xc=ea(g[z+8>>2]);g[H>>2]=vc;g[x>>2]=wc;g[Ea>>2]=xc;g[Fa>>2]=ea(0.0);yc=ea(g[a+16>>2]);uc=ea(vc-ea(yc*Ac));Ac=ea(wc-ea(yc*Ec));Ec=ea(xc-ea(yc*Fc));c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];g[w>>2]=uc;g[w+4>>2]=Ac;g[w+8>>2]=Ec;g[w+12>>2]=ea(0.0);Ec=ea(g[((_b|0)==0?v:w)>>2]);Ac=ea(g[((N|0)==0?v:w)+4>>2]);uc=ea(g[((G|0)==0?v:w)+8>>2]);g[l>>2]=Ec;g[l+4>>2]=Ac;g[l+8>>2]=uc;g[l+12>>2]=ea(0.0);Zb=1;i=e;return Zb|0}function $Fb(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=0,R=Im,S=Im,U=0,V=Im,W=0,X=Im,Y=0,Z=0,_=Im,$=0,aa=Im,ba=0,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=Im,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=Im,rb=Im,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=Im,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=0,Ub=0,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=0,qc=0,rc=Im,sc=Im,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=0,Bc=Im,Cc=Im,Dc=Im,Ec=0;e=i;i=i+560|0;n=e+496|0;o=e+16|0;p=e;q=e+448|0;r=e+192|0;s=e+64|0;t=e+80|0;u=e+96|0;v=e+400|0;w=e+432|0;x=e+464|0;y=e+512|0;z=e+524|0;A=e+548|0;B=e+256|0;C=e+32|0;D=e+272|0;E=e+112|0;F=e+336|0;G=e+48|0;H=e+176|0;I=e+416|0;J=e+208|0;K=e+240|0;L=e+536|0;M=e+224|0;N=e+480|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];O=ea(g[h>>2]);y=h+4|0;P=ea(g[y>>2]);Q=h+8|0;R=ea(g[Q>>2]);S=ea(g[f>>2]);U=f+4|0;V=ea(g[U>>2]);W=f+8|0;X=ea(g[W>>2]);c[A>>2]=1;Y=d+48|0;Z=d+48|0;_=ea(g[Z>>2]);$=d+52|0;aa=ea(g[$>>2]);ba=d+56|0;ca=ea(g[ba>>2]);da=ea(ea(ea(_*_)+ea(aa*aa))+ea(ca*ca))>ea(1.1920929e-07);c[o+0>>2]=c[Y+0>>2];c[o+4>>2]=c[Y+4>>2];c[o+8>>2]=c[Y+8>>2];c[o+12>>2]=c[Y+12>>2];g[n>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(0.0);Y=da?o:n;ca=ea(g[Y>>2]);aa=ea(g[Y+4>>2]);_=ea(g[Y+8>>2]);fa=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(aa*aa))+ea(_*_)))));ga=ea(ca*fa);ca=ea(aa*fa);aa=ea(_*fa);g[B>>2]=ga;g[B+4>>2]=ca;g[B+8>>2]=aa;g[B+12>>2]=ea(0.0);fa=ea(-ga);ga=ea(-ca);ca=ea(-aa);aa=ea(ea(g[d>>2])*fa);Y=d+4|0;_=ea(aa+ea(ea(g[Y>>2])*ga));n=d+8|0;aa=ea(_+ea(ea(g[n>>2])*ca));o=d+16|0;_=ea(ea(g[o>>2])*fa);da=d+20|0;ha=ea(_+ea(ea(g[da>>2])*ga));ia=d+24|0;_=ea(ha+ea(ea(g[ia>>2])*ca));ja=d+32|0;ha=ea(ea(g[ja>>2])*fa);ka=d+36|0;fa=ea(ha+ea(ea(g[ka>>2])*ga));la=d+40|0;ga=ea(fa+ea(ea(g[la>>2])*ca));g[p>>2]=aa;g[p+4>>2]=_;g[p+8>>2]=ga;g[p+12>>2]=ea(0.0);HFb(q,a,p);ga=ea(g[Z>>2]);_=ea(g[$>>2]);aa=ea(g[ba>>2]);ca=ea(g[q>>2]);fa=ea(g[q+4>>2]);ha=ea(g[q+8>>2]);ma=ea(ca*ea(g[d>>2]));na=ea(ma+ea(fa*ea(g[o>>2])));ma=ea(na+ea(ha*ea(g[ja>>2])));na=ea(ca*ea(g[Y>>2]));oa=ea(na+ea(fa*ea(g[da>>2])));na=ea(oa+ea(ha*ea(g[ka>>2])));oa=ea(ca*ea(g[n>>2]));ca=ea(oa+ea(fa*ea(g[ia>>2])));fa=ea(ga+ma);ma=ea(_+na);na=ea(aa+ea(ca+ea(ha*ea(g[la>>2]))));HFb(C,b,B);ha=ea(g[C>>2]);ca=ea(g[C+4>>2]);aa=ea(fa-ha);ha=ea(ma-ca);ca=ea(na-ea(g[C+8>>2]));g[D>>2]=aa;B=D+4|0;g[B>>2]=ha;pa=D+8|0;g[pa>>2]=ca;qa=D+12|0;g[qa>>2]=ea(0.0);ra=D+16|0;c[ra+0>>2]=c[x+0>>2];c[ra+4>>2]=c[x+4>>2];c[ra+8>>2]=c[x+8>>2];c[ra+12>>2]=c[x+12>>2];sa=D+32|0;c[sa+0>>2]=c[x+0>>2];c[sa+4>>2]=c[x+4>>2];c[sa+8>>2]=c[x+8>>2];c[sa+12>>2]=c[x+12>>2];sa=D+48|0;c[sa+0>>2]=c[x+0>>2];c[sa+4>>2]=c[x+4>>2];c[sa+8>>2]=c[x+8>>2];c[sa+12>>2]=c[x+12>>2];g[E>>2]=fa;sa=E+4|0;g[sa>>2]=ma;ta=E+8|0;g[ta>>2]=na;g[E+12>>2]=ea(0.0);ua=E+16|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];ua=E+32|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];ua=E+48|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];ua=F+16|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];ua=F+32|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];ua=F+48|0;c[ua+0>>2]=c[x+0>>2];c[ua+4>>2]=c[x+4>>2];c[ua+8>>2]=c[x+8>>2];c[ua+12>>2]=c[x+12>>2];_=ea(-aa);ga=ea(-ha);oa=ea(-ca);c[G+0>>2]=c[D+0>>2];c[G+4>>2]=c[D+4>>2];c[G+8>>2]=c[D+8>>2];c[G+12>>2]=c[D+12>>2];va=ea(g[a+32>>2]);wa=ea(g[b+32>>2]);xa=ea((va>wa?wa:va)*ea(.100000001));va=ea(xa*xa);xa=ea(ea(m*m)+va);g[H>>2]=fa;x=H+4|0;g[x>>2]=ma;ua=H+8|0;g[ua>>2]=na;ya=H+12|0;g[ya>>2]=ea(0.0);c[I+0>>2]=c[C+0>>2];c[I+4>>2]=c[C+4>>2];c[I+8>>2]=c[C+8>>2];c[I+12>>2]=c[C+12>>2];wa=ea(ea(ea(aa*aa)+ea(ha*ha))+ea(ca*ca));a:do if(wa>va){C=J+4|0;za=J+8|0;Aa=J+12|0;Ba=p+4|0;Ca=p+8|0;Da=p+12|0;Ea=q+4|0;Fa=q+8|0;Ga=K+4|0;Ha=K+8|0;Ia=G+4|0;Ja=G+8|0;Ka=G+12|0;La=F+4|0;Ma=F+8|0;Na=F+12|0;Oa=F+16|0;Pa=F+20|0;Qa=F+24|0;Ra=F+28|0;Sa=F+32|0;Ta=F+36|0;Ua=F+40|0;Va=F+44|0;Wa=E+16|0;Xa=E+20|0;Ya=E+24|0;Za=D+16|0;_a=D+20|0;$a=D+24|0;ab=D+28|0;bb=E+32|0;cb=E+36|0;db=E+40|0;eb=D+32|0;fb=D+36|0;gb=D+40|0;hb=D+44|0;ib=M+4|0;jb=M+8|0;kb=N+4|0;lb=N+8|0;mb=I+4|0;nb=I+8|0;ob=I+12|0;pb=N+12|0;ca=_;ha=ga;aa=oa;qb=ea(ea(O*ea(0.0))+S);rb=ea(ea(P*ea(0.0))+V);sb=ea(ea(R*ea(0.0))+X);tb=ea(0.0);ub=ea(0.0);vb=na;wb=ma;xb=fa;yb=_;zb=ga;Ab=oa;Bb=wa;while(1){Cb=ea(ea(1.0)/ea(T(ea(ea(aa*aa)+ea(ea(ha*ha)+ea(ca*ca))))));Db=ea(ca*Cb);Eb=ea(ha*Cb);Fb=ea(aa*Cb);Cb=ea(-Eb);Gb=ea(-Fb);g[J>>2]=ea(-Db);g[C>>2]=Cb;g[za>>2]=Gb;g[Aa>>2]=ea(0.0);Gb=ea(Db*ea(g[d>>2]));Cb=ea(Gb+ea(Eb*ea(g[Y>>2])));Gb=ea(Cb+ea(Fb*ea(g[n>>2])));Cb=ea(Db*ea(g[o>>2]));Hb=ea(Cb+ea(Eb*ea(g[da>>2])));Cb=ea(Hb+ea(Fb*ea(g[ia>>2])));Hb=ea(Db*ea(g[ja>>2]));Ib=ea(Hb+ea(Eb*ea(g[ka>>2])));Hb=ea(Ib+ea(Fb*ea(g[la>>2])));g[p>>2]=Gb;g[Ba>>2]=Cb;g[Ca>>2]=Hb;g[Da>>2]=ea(0.0);HFb(q,a,p);Hb=ea(g[Z>>2]);Cb=ea(g[$>>2]);Gb=ea(g[ba>>2]);Ib=ea(g[q>>2]);Jb=ea(g[Ea>>2]);Kb=ea(g[Fa>>2]);Lb=ea(Ib*ea(g[d>>2]));Mb=ea(Lb+ea(Jb*ea(g[o>>2])));Lb=ea(Mb+ea(Kb*ea(g[ja>>2])));Mb=ea(Ib*ea(g[Y>>2]));Nb=ea(Mb+ea(Jb*ea(g[da>>2])));Mb=ea(Nb+ea(Kb*ea(g[ka>>2])));Nb=ea(Ib*ea(g[n>>2]));Ib=ea(Nb+ea(Jb*ea(g[ia>>2])));Jb=ea(Hb+Lb);Lb=ea(Cb+Mb);Mb=ea(Gb+ea(Ib+ea(Kb*ea(g[la>>2]))));HFb(K,b,J);Kb=ea(g[K>>2]);Ib=ea(g[Ga>>2]);Gb=ea(qb+Kb);Kb=ea(rb+Ib);Ib=ea(sb+ea(g[Ha>>2]));Cb=ea(Jb-Gb);Hb=ea(Lb-Kb);Nb=ea(Mb-Ib);g[G>>2]=Cb;g[Ia>>2]=Hb;g[Ja>>2]=Nb;g[Ka>>2]=ea(0.0);Ob=ea(ea(ea(ea(-ea(Eb*Hb))-ea(Db*Cb))-ea(Fb*Nb))-m);Pb=ea(g[h>>2]);Qb=ea(g[y>>2]);Rb=ea(g[Q>>2]);Sb=ea(ea(ea(Db*Pb)+ea(Eb*Qb))+ea(Fb*Rb));if(Ob>ea(0.0)){if(Sb>=ea(0.0)){Tb=0;Ub=22;break}Fb=ea(tb-ea(Ob/Sb));c[z+0>>2]=c[L+0>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];if(Fb>tb){if(Fb>ea(1.0)){Tb=0;Ub=22;break}Sb=ea(g[f>>2]);Ob=ea(g[U>>2]);Eb=ea(ea(Fb*Pb)+Sb);Sb=ea(ea(Fb*Qb)+Ob);Ob=ea(ea(Fb*Rb)+ea(g[W>>2]));Rb=ea(Eb-qb);Qb=ea(Sb-rb);Pb=ea(Ob-sb);Db=ea(g[F>>2]);Vb=ea(g[La>>2]);Wb=ea(Rb+Db);Db=ea(Qb+Vb);Vb=ea(Pb+ea(g[Ma>>2]));Xb=ea(g[Oa>>2]);Yb=ea(g[Pa>>2]);Zb=ea(Rb+Xb);Xb=ea(Qb+Yb);Yb=ea(Pb+ea(g[Qa>>2]));_b=ea(g[Sa>>2]);$b=ea(g[Ta>>2]);ac=ea(Rb+_b);_b=ea(Qb+$b);$b=ea(Pb+ea(g[Ua>>2]));g[F>>2]=Wb;g[La>>2]=Db;g[Ma>>2]=Vb;g[Na>>2]=ea(0.0);g[Oa>>2]=Zb;g[Pa>>2]=Xb;g[Qa>>2]=Yb;g[Ra>>2]=ea(0.0);g[Sa>>2]=ac;g[Ta>>2]=_b;g[Ua>>2]=$b;g[Va>>2]=ea(0.0);Pb=ea(g[E>>2]);Qb=ea(g[sa>>2]);Rb=ea(Qb-Db);Db=ea(ea(g[ta>>2])-Vb);g[D>>2]=ea(Pb-Wb);g[B>>2]=Rb;g[pa>>2]=Db;g[qa>>2]=ea(0.0);Db=ea(g[Wa>>2]);Rb=ea(g[Xa>>2]);Wb=ea(Rb-Xb);Xb=ea(ea(g[Ya>>2])-Yb);g[Za>>2]=ea(Db-Zb);g[_a>>2]=Wb;g[$a>>2]=Xb;g[ab>>2]=ea(0.0);Xb=ea(g[bb>>2]);Wb=ea(g[cb>>2]);Zb=ea(Wb-_b);_b=ea(ea(g[db>>2])-$b);g[eb>>2]=ea(Xb-ac);g[fb>>2]=Zb;g[gb>>2]=_b;g[hb>>2]=ea(0.0);HFb(M,b,J);_b=ea(g[M>>2]);Zb=ea(g[ib>>2]);ac=ea(Eb+_b);_b=ea(Sb+Zb);Zb=ea(Ob+ea(g[jb>>2]));Xb=ea(Jb-ac);$b=ea(Lb-_b);Wb=ea(Mb-Zb);g[G>>2]=Xb;g[Ia>>2]=$b;g[Ja>>2]=Wb;g[Ka>>2]=ea(0.0);bc=ac;cc=_b;dc=Zb;ec=Xb;fc=$b;gc=Wb;hc=ea(3402823469999999843913219.0e14);ic=Fb;jc=Ob;kc=Sb;lc=Eb;mc=aa;nc=ha;oc=ca}else{bc=Gb;cc=Kb;dc=Ib;ec=Cb;fc=Hb;gc=Nb;hc=Bb;ic=Fb;jc=sb;kc=rb;lc=qb;mc=Ab;nc=zb;oc=yb}}else{bc=Gb;cc=Kb;dc=Ib;ec=Cb;fc=Hb;gc=Nb;hc=Bb;ic=tb;jc=sb;kc=rb;lc=qb;mc=Ab;nc=zb;oc=yb}pc=c[A>>2]|0;g[E+(pc<<4)>>2]=Jb;g[E+(pc<<4)+4>>2]=Lb;g[E+(pc<<4)+8>>2]=Mb;g[E+(pc<<4)+12>>2]=ea(0.0);g[F+(pc<<4)>>2]=bc;g[F+(pc<<4)+4>>2]=cc;g[F+(pc<<4)+8>>2]=dc;g[F+(pc<<4)+12>>2]=ea(0.0);c[A>>2]=pc+1;qc=D+(pc<<4)|0;c[qc+0>>2]=c[G+0>>2];c[qc+4>>2]=c[G+4>>2];c[qc+8>>2]=c[G+8>>2];c[qc+12>>2]=c[G+12>>2];do if(!pc){g[H>>2]=Jb;g[x>>2]=Lb;g[ua>>2]=Mb;g[ya>>2]=ea(0.0);g[I>>2]=bc;g[mb>>2]=cc;g[nb>>2]=dc;g[ob>>2]=ea(0.0);c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}else if((pc|0)==3)pPa(N,D,E,F,A,H,I);else if((pc|0)==1){Nb=ea(g[D>>2]);Hb=ea(g[B>>2]);Cb=ea(g[pa>>2]);Ib=ea(ec-Nb);Kb=ea(fc-Hb);Gb=ea(gc-Cb);Fb=ea(ea(ea(Ib*Ib)+ea(Kb*Kb))+ea(Gb*Gb));if(Fb==ea(0.0)){c[A>>2]=1;c[H+0>>2]=c[E+0>>2];c[H+4>>2]=c[E+4>>2];c[H+8>>2]=c[E+8>>2];c[H+12>>2]=c[E+12>>2];c[I+0>>2]=c[F+0>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[N+0>>2]=c[D+0>>2];c[N+4>>2]=c[D+4>>2];c[N+8>>2]=c[D+8>>2];c[N+12>>2]=c[D+12>>2];break}else{Eb=ea(ea(ea(-ea(Hb*Kb))-ea(Nb*Ib))-ea(Cb*Gb));Gb=ea(g[E>>2]);Cb=ea(g[sa>>2]);Ib=ea(g[ta>>2]);Nb=ea(Jb-Gb);Kb=ea(Lb-Cb);Hb=ea(Mb-Ib);Sb=ea(g[F>>2]);Ob=ea(g[La>>2]);Wb=ea(g[Ma>>2]);$b=ea(bc-Sb);Xb=ea(cc-Ob);Zb=ea(dc-Wb);_b=ea(Eb/Fb);qc=_b>ea(1.0);Fb=qc?ea(1.0):_b;qc=Fb>ea(0.0);_b=qc?Fb:ea(0.0);Fb=ea(Gb+ea(Nb*_b));Nb=ea(Cb+ea(Kb*_b));Kb=ea(Ib+ea(Hb*_b));Hb=ea(Sb+ea($b*_b));$b=ea(Ob+ea(Xb*_b));Xb=ea(Wb+ea(Zb*_b));g[H>>2]=Fb;g[x>>2]=Nb;g[ua>>2]=Kb;g[ya>>2]=ea(0.0);g[I>>2]=Hb;g[mb>>2]=$b;g[nb>>2]=Xb;g[ob>>2]=ea(0.0);_b=ea(Nb-$b);$b=ea(Kb-Xb);g[N>>2]=ea(Fb-Hb);g[kb>>2]=_b;g[lb>>2]=$b;g[pb>>2]=ea(0.0);break}}else if((pc|0)==2)V6a(N,D,ra,G,D,E,F,A,H,I);else{c[N+0>>2]=c[G+0>>2];c[N+4>>2]=c[G+4>>2];c[N+8>>2]=c[G+8>>2];c[N+12>>2]=c[G+12>>2]}while(0);Mb=ea(g[N>>2]);Lb=ea(g[kb>>2]);Jb=ea(g[lb>>2]);$b=ea(-Mb);_b=ea(-Lb);Hb=ea(-Jb);Fb=ea(ea(ea(Mb*Mb)+ea(Lb*Lb))+ea(Jb*Jb));pc=hc>Fb;qc=pc<<31>>31;if(!(Fb>xa)){rc=ic;sc=ub;tc=vb;uc=wb;vc=xb;wc=Hb;xc=_b;yc=$b;zc=Fb;Ac=qc;Bc=mc;Cc=nc;Dc=oc;break a}if(!pc){rc=ic;sc=ub;tc=vb;uc=wb;vc=xb;wc=Hb;xc=_b;yc=$b;zc=Fb;Ac=qc;Bc=mc;Cc=nc;Dc=oc;break a}Jb=ea(g[H>>2]);Lb=ea(g[x>>2]);Mb=ea(g[ua>>2]);ca=$b;ha=_b;aa=Hb;qb=lc;rb=kc;sb=jc;tb=ic;ub=ea(g[ya>>2]);vb=Mb;wb=Lb;xb=Jb;yb=oc;zb=nc;Ab=mc;Bb=Fb}if((Ub|0)==22){i=e;return Tb|0}}else{rc=ea(0.0);sc=ea(0.0);tc=na;uc=ma;vc=fa;wc=oa;xc=ga;yc=_;zc=wa;Ac=-1;Bc=oa;Cc=ga;Dc=_}while(0);Ub=c[a+64>>2]|0;N=c[a+68>>2]|0;G=c[a+72>>2]|0;if(zc>va)Ec=(Ac|0)==0?r:s;else Ec=r;g[s>>2]=yc;g[s+4>>2]=xc;g[s+8>>2]=wc;g[s+12>>2]=ea(0.0);g[r>>2]=Dc;g[r+4>>2]=Cc;g[r+8>>2]=Bc;g[r+12>>2]=ea(0.0);Bc=ea(g[Ec>>2]);Cc=ea(g[Ec+4>>2]);Dc=ea(g[Ec+8>>2]);wc=ea(ea(1.0)/ea(T(ea(ea(ea(Bc*Bc)+ea(Cc*Cc))+ea(Dc*Dc)))));xc=ea(-ea(Bc*wc));Bc=ea(-ea(Cc*wc));Cc=ea(-ea(Dc*wc));g[k>>2]=xc;g[k+4>>2]=Bc;g[k+8>>2]=Cc;g[k+12>>2]=ea(0.0);g[j>>2]=rc;k=j+4|0;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[u+0>>2]=c[H+0>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];c[u+12>>2]=c[H+12>>2];g[t>>2]=vc;g[t+4>>2]=uc;g[t+8>>2]=tc;g[t+12>>2]=sc;z=(Ac|0)==0?t:u;sc=ea(g[z>>2]);tc=ea(g[z+4>>2]);uc=ea(g[z+8>>2]);g[H>>2]=sc;g[x>>2]=tc;g[ua>>2]=uc;g[ya>>2]=ea(0.0);vc=ea(g[a+16>>2]);rc=ea(sc-ea(vc*xc));xc=ea(tc-ea(vc*Bc));Bc=ea(uc-ea(vc*Cc));c[v+0>>2]=c[H+0>>2];c[v+4>>2]=c[H+4>>2];c[v+8>>2]=c[H+8>>2];c[v+12>>2]=c[H+12>>2];g[w>>2]=rc;g[w+4>>2]=xc;g[w+8>>2]=Bc;g[w+12>>2]=ea(0.0);Bc=ea(g[((Ub|0)==0?v:w)>>2]);xc=ea(g[((N|0)==0?v:w)+4>>2]);rc=ea(g[((G|0)==0?v:w)+8>>2]);g[l>>2]=Bc;g[l+4>>2]=xc;g[l+8>>2]=rc;g[l+12>>2]=ea(0.0);Tb=1;i=e;return Tb|0}function aGb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;f=i;h=a+48|0;j=ea(g[h>>2]);k=ea(g[a+52>>2]);l=ea(g[a+56>>2]);if(!(j>=(k>l?k:l)))if(!(k>=l)){m=2;n=0;o=1}else{m=1;n=0;o=2}else{m=0;n=1;o=2}l=ea(g[h+(m<<2)>>2]);k=ea(l*ea(g[a+(m*12|0)>>2]));j=ea(l*ea(g[a+(m*12|0)+4>>2]));p=ea(l*ea(g[a+(m*12|0)+8>>2]));l=ea(S(ea(g[a+(n*12|0)>>2])));q=ea(S(ea(g[a+(n*12|0)+4>>2])));r=ea(S(ea(g[a+(n*12|0)+8>>2])));s=ea(g[h+(n<<2)>>2]);t=ea(l*s);l=ea(q*s);q=ea(r*s);s=ea(S(ea(g[a+(o*12|0)>>2])));r=ea(S(ea(g[a+(o*12|0)+4>>2])));u=ea(S(ea(g[a+(o*12|0)+8>>2])));v=ea(g[h+(o<<2)>>2]);w=ea(s*v);s=ea(r*v);r=ea(u*v);v=ea(ea(g[a+36>>2])-k);u=ea(ea(g[a+40>>2])-j);x=ea(ea(g[a+44>>2])-p);g[b>>2]=v;g[b+4>>2]=u;g[b+8>>2]=x;x=ea(ea(l+s)+ea(.00100000005));s=ea(ea(q+r)+ea(.00100000005));g[c>>2]=ea(ea(t+w)+ea(.00100000005));g[c+4>>2]=x;g[c+8>>2]=s;g[e>>2]=ea(2.0);g[d>>2]=k;g[d+4>>2]=j;g[d+8>>2]=p;i=f;return}function bGb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=0,q=0,r=Im,s=Im,t=0,u=Im,v=Im;i=d+4|0;j=ea(g[i>>2]);k=b+4|0;l=ea(g[k>>2]);m=e+4|0;n=ea((j<l?j:l)-ea(g[m>>2]));o=a+4|0;p=c[o>>2]|0;q=p+4|0;g[a+24>>2]=ea(n*ea(g[q>>2]));n=ea(g[i>>2]);l=ea(g[k>>2]);j=ea(ea(g[m>>2])+(n>l?n:l));g[a+28>>2]=ea(j*ea(g[q>>2]));q=c[a+8>>2]|0;j=ea(g[d>>2]);l=ea(g[b>>2]);n=ea(g[e>>2]);r=ea((j<l?j:l)-n);s=ea(g[p>>2]);m=~~ea(R(ea(r*s)));k=q+16|0;i=(c[k>>2]|0)+-2|0;t=(m|0)>0?m:0;c[a+32>>2]=(t|0)>(i|0)?i:t;t=~~ea(ca(ea(ea(n+(j>l?j:l))*s)));i=(c[k>>2]|0)+-1|0;k=(t|0)>0?t:0;c[a+36>>2]=(k|0)>(i|0)?i:k;l=ea(g[d+8>>2]);j=ea(g[b+8>>2]);b=e+8|0;r=ea(g[b>>2]);u=ea((l<j?l:j)-r);v=ea(g[p+8>>2]);p=~~ea(R(ea(u*v)));e=q+20|0;q=(c[e>>2]|0)+-2|0;d=(p|0)>0?p:0;c[a+40>>2]=(d|0)>(q|0)?q:d;d=~~ea(ca(ea(ea(r+(l>j?l:j))*v)));q=(c[e>>2]|0)+-1|0;e=(d|0)>0?d:0;c[a+44>>2]=(e|0)>(q|0)?q:e;g[f>>2]=ea(ca(ea(n*s)));s=ea(g[b>>2]);n=ea(ca(ea(s*ea(g[(c[o>>2]|0)+8>>2]))));g[h>>2]=n;c[a+16>>2]=~~ea(g[f>>2])+1;c[a+20>>2]=~~n+1;return}function cGb(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0;f=i;h=d+8|0;j=c[(c[h>>2]|0)+36>>2]|0;k=ea(b[j+(e<<2)>>1]|0);l=ea(b[j+(e+1<<2)>>1]|0);m=(c[d+48>>2]|0)+e|0;n=ea(b[j+(m<<2)>>1]|0);o=ea(b[j+(m+1<<2)>>1]|0);p=ea(g[d+28>>2]);if(p<k&p<l&p<n&p<o){q=1;i=f;return q|0}p=ea(g[d+24>>2]);if(p>k&p>l&p>n&p>o){q=1;i=f;return q|0}if((a[j+(e<<2)+2>>0]&127)==127)r=j;else{j=e<<1;m=d+156|0;s=c[m>>2]|0;do if((s|0)==16){t=c[d+12>>2]|0;if(xo[c[(c[t>>2]|0)+8>>2]&2047](t,16,d+92|0)|0){c[m>>2]=0;u=0;break}else{q=0;i=f;return q|0}}else u=s;while(0);c[d+(u<<2)+92>>2]=j;c[m>>2]=(c[m>>2]|0)+1;r=c[(c[h>>2]|0)+36>>2]|0}if((a[r+(e<<2)+3>>0]&127)==127){q=1;i=f;return q|0}r=e<<1|1;e=d+156|0;h=c[e>>2]|0;do if((h|0)==16){m=c[d+12>>2]|0;if(xo[c[(c[m>>2]|0)+8>>2]&2047](m,16,d+92|0)|0){c[e>>2]=0;v=0;break}else{q=0;i=f;return q|0}}else v=h;while(0);c[d+(v<<2)+92>>2]=r;c[e>>2]=(c[e>>2]|0)+1;q=1;i=f;return q|0}function dGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[d+8>>2]|0;g=d+12|0;h=c[g>>2]|0;if((f|0)>(h|0)){j=1;i=e;return j|0}k=c[d+4>>2]|0;if(!(a[d>>0]|0)){d=(c[b+52>>2]|0)+k|0;if((d|0)<(c[b+32>>2]|0)){j=1;i=e;return j|0}if((d|0)>=(c[b+36>>2]|0)){j=1;i=e;return j|0}l=b+56|0;m=c[l>>2]|0;n=m+f|0;o=b+44|0;if((n|0)>(m+h|0)){j=1;i=e;return j|0}p=b+40|0;q=b+48|0;r=m;m=h;s=n;while(1){if((s|0)>=(c[o>>2]|0)){j=1;t=23;break}if((s|0)<(c[p>>2]|0)){u=r;v=m}else{if(!(cGb(b,(da(c[q>>2]|0,d)|0)+s|0)|0)){j=0;t=23;break}u=c[l>>2]|0;v=c[g>>2]|0}if((s|0)>=(u+v|0)){j=1;t=23;break}r=u;m=v;s=s+1|0}if((t|0)==23){i=e;return j|0}}else{s=(c[b+56>>2]|0)+k|0;if((s|0)<(c[b+40>>2]|0)){j=1;i=e;return j|0}if((s|0)>=(c[b+44>>2]|0)){j=1;i=e;return j|0}k=b+52|0;v=c[k>>2]|0;m=v+f|0;f=b+36|0;if((m|0)>(v+h|0)){j=1;i=e;return j|0}u=b+32|0;r=b+48|0;l=v;v=h;h=m;while(1){if((h|0)>=(c[f>>2]|0)){j=1;t=23;break}if((h|0)<(c[u>>2]|0)){w=l;x=v}else{if(!(cGb(b,(da(c[r>>2]|0,h)|0)+s|0)|0)){j=0;t=23;break}w=c[k>>2]|0;x=c[g>>2]|0}if((h|0)>=(w+x|0)){j=1;t=23;break}l=w;v=x;h=h+1|0}if((t|0)==23){i=e;return j|0}}return 0}function eGb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=0,q=0,r=Im,s=Im,t=0,u=Im,v=Im;i=d+4|0;j=ea(g[i>>2]);k=b+4|0;l=ea(g[k>>2]);m=e+4|0;n=ea((j<l?j:l)-ea(g[m>>2]));o=a+4|0;p=c[o>>2]|0;q=p+4|0;g[a+24>>2]=ea(n*ea(g[q>>2]));n=ea(g[i>>2]);l=ea(g[k>>2]);j=ea(ea(g[m>>2])+(n>l?n:l));g[a+28>>2]=ea(j*ea(g[q>>2]));q=c[a+8>>2]|0;j=ea(g[d>>2]);l=ea(g[b>>2]);n=ea(g[e>>2]);r=ea((j<l?j:l)-n);s=ea(g[p>>2]);m=~~ea(R(ea(r*s)));k=q+16|0;i=(c[k>>2]|0)+-2|0;t=(m|0)>0?m:0;c[a+32>>2]=(t|0)>(i|0)?i:t;t=~~ea(ca(ea(ea(n+(j>l?j:l))*s)));i=(c[k>>2]|0)+-1|0;k=(t|0)>0?t:0;c[a+36>>2]=(k|0)>(i|0)?i:k;l=ea(g[d+8>>2]);j=ea(g[b+8>>2]);b=e+8|0;r=ea(g[b>>2]);u=ea((l<j?l:j)-r);v=ea(g[p+8>>2]);p=~~ea(R(ea(u*v)));e=q+20|0;q=(c[e>>2]|0)+-2|0;d=(p|0)>0?p:0;c[a+40>>2]=(d|0)>(q|0)?q:d;d=~~ea(ca(ea(ea(r+(l>j?l:j))*v)));q=(c[e>>2]|0)+-1|0;e=(d|0)>0?d:0;c[a+44>>2]=(e|0)>(q|0)?q:e;g[f>>2]=ea(ca(ea(n*s)));s=ea(g[b>>2]);n=ea(ca(ea(s*ea(g[(c[o>>2]|0)+8>>2]))));g[h>>2]=n;c[a+16>>2]=~~ea(g[f>>2])+1;c[a+20>>2]=~~n+1;return}function fGb(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0;f=i;h=d+8|0;j=c[(c[h>>2]|0)+36>>2]|0;k=ea(b[j+(e<<2)>>1]|0);l=ea(b[j+(e+1<<2)>>1]|0);m=(c[d+48>>2]|0)+e|0;n=ea(b[j+(m<<2)>>1]|0);o=ea(b[j+(m+1<<2)>>1]|0);p=ea(g[d+28>>2]);if(p<k&p<l&p<n&p<o){q=1;i=f;return q|0}p=ea(g[d+24>>2]);if(p>k&p>l&p>n&p>o){q=1;i=f;return q|0}if((a[j+(e<<2)+2>>0]&127)==127)r=j;else{j=e<<1;m=d+156|0;s=c[m>>2]|0;do if((s|0)==16){t=c[d+12>>2]|0;if(xo[c[(c[t>>2]|0)+8>>2]&2047](t,16,d+92|0)|0){c[m>>2]=0;u=0;break}else{q=0;i=f;return q|0}}else u=s;while(0);c[d+(u<<2)+92>>2]=j;c[m>>2]=(c[m>>2]|0)+1;r=c[(c[h>>2]|0)+36>>2]|0}if((a[r+(e<<2)+3>>0]&127)==127){q=1;i=f;return q|0}r=e<<1|1;e=d+156|0;h=c[e>>2]|0;do if((h|0)==16){m=c[d+12>>2]|0;if(xo[c[(c[m>>2]|0)+8>>2]&2047](m,16,d+92|0)|0){c[e>>2]=0;v=0;break}else{q=0;i=f;return q|0}}else v=h;while(0);c[d+(v<<2)+92>>2]=r;c[e>>2]=(c[e>>2]|0)+1;q=1;i=f;return q|0}function gGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[d+8>>2]|0;g=d+12|0;h=c[g>>2]|0;if((f|0)>(h|0)){j=1;i=e;return j|0}k=c[d+4>>2]|0;if(!(a[d>>0]|0)){d=(c[b+52>>2]|0)+k|0;if((d|0)<(c[b+32>>2]|0)){j=1;i=e;return j|0}if((d|0)>=(c[b+36>>2]|0)){j=1;i=e;return j|0}l=b+56|0;m=c[l>>2]|0;n=m+f|0;o=b+44|0;if((n|0)>(m+h|0)){j=1;i=e;return j|0}p=b+40|0;q=b+48|0;r=m;m=h;s=n;while(1){if((s|0)>=(c[o>>2]|0)){j=1;t=23;break}if((s|0)<(c[p>>2]|0)){u=r;v=m}else{if(!(fGb(b,(da(c[q>>2]|0,d)|0)+s|0)|0)){j=0;t=23;break}u=c[l>>2]|0;v=c[g>>2]|0}if((s|0)>=(u+v|0)){j=1;t=23;break}r=u;m=v;s=s+1|0}if((t|0)==23){i=e;return j|0}}else{s=(c[b+56>>2]|0)+k|0;if((s|0)<(c[b+40>>2]|0)){j=1;i=e;return j|0}if((s|0)>=(c[b+44>>2]|0)){j=1;i=e;return j|0}k=b+52|0;v=c[k>>2]|0;m=v+f|0;f=b+36|0;if((m|0)>(v+h|0)){j=1;i=e;return j|0}u=b+32|0;r=b+48|0;l=v;v=h;h=m;while(1){if((h|0)>=(c[f>>2]|0)){j=1;t=23;break}if((h|0)<(c[u>>2]|0)){w=l;x=v}else{if(!(fGb(b,(da(c[r>>2]|0,h)|0)+s|0)|0)){j=0;t=23;break}w=c[k>>2]|0;x=c[g>>2]|0}if((h|0)>=(w+x|0)){j=1;t=23;break}l=w;v=x;h=h+1|0}if((t|0)==23){i=e;return j|0}}return 0}function hGb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=0,q=0,r=Im,s=Im,t=0,u=Im,v=Im;i=d+4|0;j=ea(g[i>>2]);k=b+4|0;l=ea(g[k>>2]);m=e+4|0;n=ea((j<l?j:l)-ea(g[m>>2]));o=a+4|0;p=c[o>>2]|0;q=p+4|0;g[a+24>>2]=ea(n*ea(g[q>>2]));n=ea(g[i>>2]);l=ea(g[k>>2]);j=ea(ea(g[m>>2])+(n>l?n:l));g[a+28>>2]=ea(j*ea(g[q>>2]));q=c[a+8>>2]|0;j=ea(g[d>>2]);l=ea(g[b>>2]);n=ea(g[e>>2]);r=ea((j<l?j:l)-n);s=ea(g[p>>2]);m=~~ea(R(ea(r*s)));k=q+16|0;i=(c[k>>2]|0)+-2|0;t=(m|0)>0?m:0;c[a+32>>2]=(t|0)>(i|0)?i:t;t=~~ea(ca(ea(ea(n+(j>l?j:l))*s)));i=(c[k>>2]|0)+-1|0;k=(t|0)>0?t:0;c[a+36>>2]=(k|0)>(i|0)?i:k;l=ea(g[d+8>>2]);j=ea(g[b+8>>2]);b=e+8|0;r=ea(g[b>>2]);u=ea((l<j?l:j)-r);v=ea(g[p+8>>2]);p=~~ea(R(ea(u*v)));e=q+20|0;q=(c[e>>2]|0)+-2|0;d=(p|0)>0?p:0;c[a+40>>2]=(d|0)>(q|0)?q:d;d=~~ea(ca(ea(ea(r+(l>j?l:j))*v)));q=(c[e>>2]|0)+-1|0;e=(d|0)>0?d:0;c[a+44>>2]=(e|0)>(q|0)?q:e;g[f>>2]=ea(ca(ea(n*s)));s=ea(g[b>>2]);n=ea(ca(ea(s*ea(g[(c[o>>2]|0)+8>>2]))));g[h>>2]=n;c[a+16>>2]=~~ea(g[f>>2])+1;c[a+20>>2]=~~n+1;return}function iGb(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0;f=i;h=d+8|0;j=c[(c[h>>2]|0)+36>>2]|0;k=ea(b[j+(e<<2)>>1]|0);l=ea(b[j+(e+1<<2)>>1]|0);m=(c[d+48>>2]|0)+e|0;n=ea(b[j+(m<<2)>>1]|0);o=ea(b[j+(m+1<<2)>>1]|0);p=ea(g[d+28>>2]);if(p<k&p<l&p<n&p<o){q=1;i=f;return q|0}p=ea(g[d+24>>2]);if(p>k&p>l&p>n&p>o){q=1;i=f;return q|0}if((a[j+(e<<2)+2>>0]&127)==127)r=j;else{j=e<<1;m=d+156|0;s=c[m>>2]|0;do if((s|0)==16){t=c[d+12>>2]|0;if(xo[c[(c[t>>2]|0)+8>>2]&2047](t,16,d+92|0)|0){c[m>>2]=0;u=0;break}else{q=0;i=f;return q|0}}else u=s;while(0);c[d+(u<<2)+92>>2]=j;c[m>>2]=(c[m>>2]|0)+1;r=c[(c[h>>2]|0)+36>>2]|0}if((a[r+(e<<2)+3>>0]&127)==127){q=1;i=f;return q|0}r=e<<1|1;e=d+156|0;h=c[e>>2]|0;do if((h|0)==16){m=c[d+12>>2]|0;if(xo[c[(c[m>>2]|0)+8>>2]&2047](m,16,d+92|0)|0){c[e>>2]=0;v=0;break}else{q=0;i=f;return q|0}}else v=h;while(0);c[d+(v<<2)+92>>2]=r;c[e>>2]=(c[e>>2]|0)+1;q=1;i=f;return q|0}function jGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[d+8>>2]|0;g=d+12|0;h=c[g>>2]|0;if((f|0)>(h|0)){j=1;i=e;return j|0}k=c[d+4>>2]|0;if(!(a[d>>0]|0)){d=(c[b+52>>2]|0)+k|0;if((d|0)<(c[b+32>>2]|0)){j=1;i=e;return j|0}if((d|0)>=(c[b+36>>2]|0)){j=1;i=e;return j|0}l=b+56|0;m=c[l>>2]|0;n=m+f|0;o=b+44|0;if((n|0)>(m+h|0)){j=1;i=e;return j|0}p=b+40|0;q=b+48|0;r=m;m=h;s=n;while(1){if((s|0)>=(c[o>>2]|0)){j=1;t=23;break}if((s|0)<(c[p>>2]|0)){u=r;v=m}else{if(!(iGb(b,(da(c[q>>2]|0,d)|0)+s|0)|0)){j=0;t=23;break}u=c[l>>2]|0;v=c[g>>2]|0}if((s|0)>=(u+v|0)){j=1;t=23;break}r=u;m=v;s=s+1|0}if((t|0)==23){i=e;return j|0}}else{s=(c[b+56>>2]|0)+k|0;if((s|0)<(c[b+40>>2]|0)){j=1;i=e;return j|0}if((s|0)>=(c[b+44>>2]|0)){j=1;i=e;return j|0}k=b+52|0;v=c[k>>2]|0;m=v+f|0;f=b+36|0;if((m|0)>(v+h|0)){j=1;i=e;return j|0}u=b+32|0;r=b+48|0;l=v;v=h;h=m;while(1){if((h|0)>=(c[f>>2]|0)){j=1;t=23;break}if((h|0)<(c[u>>2]|0)){w=l;x=v}else{if(!(iGb(b,(da(c[r>>2]|0,h)|0)+s|0)|0)){j=0;t=23;break}w=c[k>>2]|0;x=c[g>>2]|0}if((h|0)>=(w+x|0)){j=1;t=23;break}l=w;v=x;h=h+1|0}if((t|0)==23){i=e;return j|0}}return 0}function kGb(d,e,f,j,k,l,m,n,o){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0.0;p=i;i=i+64|0;q=p+48|0;r=p;s=p+52|0;c[q>>2]=o;c[r>>2]=0;c[r+4>>2]=0;o=r+8|0;c[o>>2]=-1;b[r+12>>1]=0;t=r+16|0;u=r+40|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t+20>>2]=0;g[u>>2]=ea(3402823469999999843913219.0e14);v=f+36|0;w=ea(g[v>>2]);b[s>>1]=(a[d+283>>0]|0)==0?7:263;if(!(uQa(j,w,k,l,m,n,r,s,q,ea(0.0))|0)){x=0;i=p;return x|0}w=ea(g[u>>2]);if(w>=ea(g[v>>2])){x=0;i=p;return x|0}g[v>>2]=w;g[f+24>>2]=ea(g[r+28>>2]);g[f+28>>2]=ea(g[r+32>>2]);g[f+32>>2]=ea(g[r+36>>2]);y=+ea(g[t>>2]);h[f>>3]=y+ +h[e+16>>3];y=+ea(g[r+20>>2]);h[f+8>>3]=y+ +h[e+24>>3];y=+ea(g[r+24>>2]);h[f+16>>3]=y+ +h[e+32>>3];r=c[o>>2]|0;c[d+(c[d+96>>2]<<2)+100>>2]=r;o=e+44|0;c[f+40>>2]=(c[o>>2]|0)+r;c[f+44>>2]=c[(c[d+20>>2]|0)+(r+(c[o>>2]|0)<<2)>>2];x=1;i=p;return x|0}function lGb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+16|0;h=g;j=KU(d)|0;k=d+4|0;l=c[427044+(e[k>>1]<<2)>>2]|0;m=d+l|0;n=c[d+(l+4)>>2]|0;if(!(n&1))o=(c[450992+((n>>>24&15)<<2)>>2]|0)+m+8|0;else{p=d+(l+8)|0;l=c[p>>2]|0;if(!l){q=s4(c[m>>2]|0,n>>>24&15)|0;c[p>>2]=q;r=q}else r=l;o=r}r=b[o>>1]|0;o=r&65535;l=(o&8|0)!=0;if(l^1|f){if(l|f^1){i=g;return}if(j)HU(d+12|0);f=(o|8)&65535;o=c[427044+(e[k>>1]<<2)>>2]|0;l=d+o|0;q=d+(o+4)|0;p=c[q>>2]|0;n=p>>>24&15;m=(c[450992+(n<<2)>>2]|0)+l|0;s=p>>>30;if((s|0)==3){t=l;u=24}else if((s|0)==2?(a[(c[l>>2]|0)+2417>>0]|0)!=0:0){t=l;u=24}else u=23;if((u|0)==23){b[h>>1]=f;f7(m,h)}else if((u|0)==24){m=d+(o+8)|0;o=c[m>>2]|0;if(!o){s=s4(c[t>>2]|0,n)|0;c[m>>2]=s;v=s}else v=o;b[v>>1]=f;r4(c[t>>2]|0,l);c[q>>2]=c[q>>2]|1}ko[c[(c[d>>2]|0)+252>>2]&4095](d);i=g;return}else{ko[c[(c[d>>2]|0)+256>>2]&4095](d);q=r&-9;r=c[427044+(e[k>>1]<<2)>>2]|0;k=d+r|0;l=d+(r+4)|0;t=c[l>>2]|0;f=t>>>24&15;v=(c[450992+(f<<2)>>2]|0)+k|0;o=t>>>30;if((o|0)==3){w=k;u=11}else if((o|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0){w=k;u=11}else u=10;if((u|0)==10){b[h>>1]=q;f7(v,h)}else if((u|0)==11){u=d+(r+8)|0;r=c[u>>2]|0;if(!r){h=s4(c[w>>2]|0,f)|0;c[u>>2]=h;x=h}else x=r;b[x>>1]=q;r4(c[w>>2]|0,k);c[l>>2]=c[l>>2]|1}if(!j){i=g;return}if(!(c[d+16>>2]|0)){i=g;return}IU(d+12|0);i=g;return}}function mGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=c[427044+(e[d+4>>1]<<2)>>2]|0;l=d+k|0;m=d+(k+4)|0;n=c[m>>2]|0;o=(n&1|0)==0;if(g){if(o){g=l;p=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;q=g;r=n}else{g=d+(k+8)|0;s=c[g>>2]|0;if(!s){t=s4(c[l>>2]|0,n>>>24&15)|0;c[g>>2]=t;u=c[m>>2]|0;v=t}else{u=n;v=s}p=v;q=l;r=u}u=(e[p>>1]|f)&65535;p=r>>>24&15;v=(c[450992+(p<<2)>>2]|0)+q|0;q=r>>>30;if((q|0)==3)w=l;else if((q|0)==2?(a[(c[l>>2]|0)+2417>>0]|0)!=0:0)w=l;else x=10;if((x|0)==10){b[j>>1]=u;f7(v,j);i=h;return}v=d+(k+8)|0;q=c[v>>2]|0;if(!q){r=s4(c[w>>2]|0,p)|0;c[v>>2]=r;y=r}else y=q;b[y>>1]=u;r4(c[w>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}else{if(o){o=l;z=(c[450992+((n>>>24&15)<<2)>>2]|0)+o+8|0;A=o;B=n}else{o=d+(k+8)|0;w=c[o>>2]|0;if(!w){u=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=u;C=c[m>>2]|0;D=u}else{C=n;D=w}z=D;A=l;B=C}C=b[z>>1]&((f^65535)&65535);f=B>>>24&15;z=(c[450992+(f<<2)>>2]|0)+A|0;A=B>>>30;if((A|0)==3)E=l;else if((A|0)==2?(a[(c[l>>2]|0)+2417>>0]|0)!=0:0)E=l;else x=22;if((x|0)==22){b[j>>1]=C;f7(z,j);i=h;return}j=d+(k+8)|0;k=c[j>>2]|0;if(!k){d=s4(c[E>>2]|0,f)|0;c[j>>2]=d;F=d}else F=k;b[F>>1]=C;r4(c[E>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}}function nGb(e,f,h){e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+64|0;k=j;l=j+61|0;m=j+32|0;n=j+4|0;o=j+60|0;p=e+48|0;q=LU(e)|0;r=a[f>>0]|0;s=(r&1)!=0;t=(a[h>>0]&1)!=0;u=t^1;do if(s&u){v=e+20|0;w=b[e+24>>1]|0;x=w&65535;if(w<<16>>16!=1)if(!(w<<16>>16))y=r;else{z=c[v>>2]|0;A=5}else{z=v;A=5}do if((A|0)==5){w=0;while(1){B=z+(w<<2)|0;C=c[B>>2]|0;In[c[(c[C>>2]|0)+136>>2]&4095](l,C);if((a[l>>0]&1)!=0?(C=c[(c[B>>2]|0)+116>>2]|0,(C|0)==6|(C|0)==1|(C|0)==5):0)break;w=w+1|0;if(w>>>0>=x>>>0){A=10;break}}if((A|0)==10){y=a[f>>0]|0;break}dKa(bKa()|0,4,436784,484,436864,k);i=j;return}while(0);do if(y&2){if(!(c[e+284>>2]&8192)){if((c[e+52>>2]&-1073741824|0)==-1073741824)break;D=(l9(e+64|0,m)|0)^1}else{x=e+56|0;w=c[x>>2]|0;if(!w){C=s4(c[p>>2]|0,(c[e+52>>2]|0)>>>24&15)|0;c[x>>2]=C;E=C}else E=w;g[m>>2]=ea(g[E+192>>2]);g[m+4>>2]=ea(g[E+196>>2]);g[m+8>>2]=ea(g[E+200>>2]);g[m+12>>2]=ea(g[E+204>>2]);g[m+16>>2]=ea(g[E+208>>2]);g[m+20>>2]=ea(g[E+212>>2]);g[m+24>>2]=ea(g[E+216>>2]);D=0}if(!(D|(q|0)==0)){G2(v,q+3376|0);w=q+3400|0;c[w>>2]=(c[w>>2]|0)+1}}while(0);v=e+64|0;if((c[e+52>>2]&-1073741824|0)==1073741824?(w=e+220|0,(c[w>>2]|0)!=0):0){C=h9(v,1)|0;x=(c[w>>2]|0)==0;if(C){if(x)break;c9(v,c[(c[p>>2]|0)+1256>>2]|0,1);break}if((!x?h9(v,0)|0:0)?(c[w>>2]|0)!=0:0)c9(v,c[(c[p>>2]|0)+1256>>2]|0,0)}}else if(t&(s^1)){if((mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0)==4){dKa(bKa()|0,4,436784,505,436952,k);i=j;return}v=e+64|0;if((((c[e+52>>2]&-1073741824|0)==1073741824?(w=e+220|0,(c[w>>2]|0)!=0):0)?h9(v,0)|0:0)?(c[w>>2]|0)!=0:0)O8(v,c[(c[p>>2]|0)+1256>>2]|0,1,0)|0}while(0);do if(!(s^1|u)?((d[f>>0]|0)&2)<<24>>24!=((d[h>>0]|0)&2)<<24>>24:0){if(!(c[e+284>>2]&8192)){if((c[e+52>>2]&-1073741824|0)==-1073741824)break;F=(l9(e+64|0,n)|0)^1}else{k=e+56|0;t=c[k>>2]|0;if(!t){D=s4(c[p>>2]|0,(c[e+52>>2]|0)>>>24&15)|0;c[k>>2]=D;G=D}else G=t;g[n>>2]=ea(g[G+192>>2]);g[n+4>>2]=ea(g[G+196>>2]);g[n+8>>2]=ea(g[G+200>>2]);g[n+12>>2]=ea(g[G+204>>2]);g[n+16>>2]=ea(g[G+208>>2]);g[n+20>>2]=ea(g[G+212>>2]);g[n+24>>2]=ea(g[G+216>>2]);F=0}if(!(F|(q|0)==0)){G2(e+20|0,q+3376|0);t=q+3400|0;c[t>>2]=(c[t>>2]|0)+1}}while(0);a[o>>0]=a[h>>0]|0;uIb(p,o);i=j;return}function oGb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+16|0;h=g;j=KU(d)|0;k=d+4|0;l=c[427044+(e[k>>1]<<2)>>2]|0;m=d+l|0;n=c[d+(l+4)>>2]|0;if(!(n&1))o=(c[450992+((n>>>24&15)<<2)>>2]|0)+m+8|0;else{p=d+(l+8)|0;l=c[p>>2]|0;if(!l){q=s4(c[m>>2]|0,n>>>24&15)|0;c[p>>2]=q;r=q}else r=l;o=r}r=b[o>>1]|0;o=r&65535;l=(o&8|0)!=0;if(l^1|f){if(l|f^1){i=g;return}if(j)HU(d+12|0);f=(o|8)&65535;o=c[427044+(e[k>>1]<<2)>>2]|0;l=d+o|0;q=d+(o+4)|0;p=c[q>>2]|0;n=p>>>24&15;m=(c[450992+(n<<2)>>2]|0)+l|0;s=p>>>30;if((s|0)==3){t=l;u=24}else if((s|0)==2?(a[(c[l>>2]|0)+2417>>0]|0)!=0:0){t=l;u=24}else u=23;if((u|0)==23){b[h>>1]=f;f7(m,h)}else if((u|0)==24){m=d+(o+8)|0;o=c[m>>2]|0;if(!o){s=s4(c[t>>2]|0,n)|0;c[m>>2]=s;v=s}else v=o;b[v>>1]=f;r4(c[t>>2]|0,l);c[q>>2]=c[q>>2]|1}ko[c[(c[d>>2]|0)+320>>2]&4095](d);i=g;return}else{ko[c[(c[d>>2]|0)+324>>2]&4095](d);q=r&-9;r=c[427044+(e[k>>1]<<2)>>2]|0;k=d+r|0;l=d+(r+4)|0;t=c[l>>2]|0;f=t>>>24&15;v=(c[450992+(f<<2)>>2]|0)+k|0;o=t>>>30;if((o|0)==2)if(!(a[(c[k>>2]|0)+2417>>0]|0))u=10;else{w=k;u=11}else if((o|0)==3){w=k;u=11}else u=10;if((u|0)==10){b[h>>1]=q;f7(v,h)}else if((u|0)==11){u=d+(r+8)|0;r=c[u>>2]|0;if(!r){h=s4(c[w>>2]|0,f)|0;c[u>>2]=h;x=h}else x=r;b[x>>1]=q;r4(c[w>>2]|0,k);c[l>>2]=c[l>>2]|1}if(!j){i=g;return}if(!(c[d+16>>2]|0)){i=g;return}IU(d+12|0);i=g;return}}function pGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=c[427044+(e[d+4>>1]<<2)>>2]|0;l=d+k|0;m=d+(k+4)|0;n=c[m>>2]|0;o=(n&1|0)==0;if(g){if(o){g=l;p=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;q=g;r=n}else{g=d+(k+8)|0;s=c[g>>2]|0;if(!s){t=s4(c[l>>2]|0,n>>>24&15)|0;c[g>>2]=t;u=c[m>>2]|0;v=t}else{u=n;v=s}p=v;q=l;r=u}u=(e[p>>1]|f)&65535;p=r>>>24&15;v=(c[450992+(p<<2)>>2]|0)+q|0;q=r>>>30;if((q|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))w=10;else x=l;else if((q|0)==3)x=l;else w=10;if((w|0)==10){b[j>>1]=u;f7(v,j);i=h;return}v=d+(k+8)|0;q=c[v>>2]|0;if(!q){r=s4(c[x>>2]|0,p)|0;c[v>>2]=r;y=r}else y=q;b[y>>1]=u;r4(c[x>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}else{if(o){o=l;z=(c[450992+((n>>>24&15)<<2)>>2]|0)+o+8|0;A=o;B=n}else{o=d+(k+8)|0;x=c[o>>2]|0;if(!x){u=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=u;C=c[m>>2]|0;D=u}else{C=n;D=x}z=D;A=l;B=C}C=b[z>>1]&((f^65535)&65535);f=B>>>24&15;z=(c[450992+(f<<2)>>2]|0)+A|0;A=B>>>30;if((A|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))w=22;else E=l;else if((A|0)==3)E=l;else w=22;if((w|0)==22){b[j>>1]=C;f7(z,j);i=h;return}j=d+(k+8)|0;k=c[j>>2]|0;if(!k){d=s4(c[E>>2]|0,f)|0;c[j>>2]=d;F=d}else F=k;b[F>>1]=C;r4(c[E>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}}function qGb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=i;if(!(c[b+284>>2]&512))e=b+112|0;else{f=b+56|0;h=c[f>>2]|0;if(!h){j=s4(c[b+48>>2]|0,(c[b+52>>2]|0)>>>24&15)|0;c[f>>2]=j;k=j}else k=h;e=k+144|0}l=ea(g[e+16>>2]);m=ea(g[e+20>>2]);n=ea(l*ea(-2.0));l=ea(m*ea(-2.0));m=ea(ea(g[e+24>>2])*ea(-2.0));o=ea(g[e+12>>2]);p=ea(ea(o*o)+ea(-.5));q=ea(g[e>>2]);r=ea(n*q);s=ea(g[e+4>>2]);t=ea(r+ea(l*s));r=ea(g[e+8>>2]);u=ea(t+ea(m*r));t=ea(-q);v=ea(-s);w=ea(-r);x=ea(ea(ea(q*u)+ea(ea(n*p)-ea(o*ea(ea(m*s)-ea(l*r)))))*ea(2.0));y=ea(ea(ea(s*u)+ea(ea(l*p)-ea(o*ea(ea(n*r)-ea(m*q)))))*ea(2.0));z=ea(ea(ea(ea(m*p)-ea(o*ea(ea(l*q)-ea(n*s))))+ea(r*u))*ea(2.0));u=ea(g[b+236>>2]);r=ea(ea(u*u)+ea(-.5));s=ea(g[b+224>>2]);n=ea(s*x);q=ea(g[b+228>>2]);l=ea(n+ea(q*y));n=ea(g[b+232>>2]);p=ea(ea(n*z)+l);l=ea(ea(s*p)+ea(ea(r*x)+ea(u*ea(ea(q*z)-ea(n*y)))));m=ea(ea(q*p)+ea(ea(r*y)+ea(u*ea(ea(n*x)-ea(s*z)))));A=ea(ea(ea(r*z)+ea(u*ea(ea(s*y)-ea(q*x))))+ea(n*p));p=ea(ea(g[b+240>>2])+l);l=ea(ea(g[b+244>>2])+m);m=ea(ea(g[b+248>>2])+A);A=ea(ea(ea(n*t)+ea(ea(u*v)+ea(o*q)))-ea(s*w));x=ea(ea(ea(s*v)+ea(ea(u*w)+ea(o*n)))-ea(q*t));y=ea(ea(ea(ea(o*u)-ea(s*t))-ea(q*v))-ea(n*w));g[a>>2]=ea(ea(ea(ea(u*t)+ea(o*s))+ea(q*w))-ea(n*v));g[a+4>>2]=A;g[a+8>>2]=x;g[a+12>>2]=y;g[a+16>>2]=p;g[a+20>>2]=l;g[a+24>>2]=m;i=d;return}function rGb(e,f,h){e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+64|0;k=j;l=j+61|0;m=j+32|0;n=j+4|0;o=j+60|0;p=e+48|0;q=LU(e)|0;r=a[f>>0]|0;s=(r&1)!=0;t=(a[h>>0]&1)!=0;u=t^1;do if(s&u){v=e+20|0;w=b[e+24>>1]|0;x=w&65535;if(w<<16>>16!=1)if(!(w<<16>>16))y=r;else{z=c[v>>2]|0;A=5}else{z=v;A=5}do if((A|0)==5){w=0;while(1){B=z+(w<<2)|0;C=c[B>>2]|0;In[c[(c[C>>2]|0)+136>>2]&4095](l,C);if((a[l>>0]&1)!=0?(C=c[(c[B>>2]|0)+116>>2]|0,(C|0)==6|(C|0)==1|(C|0)==5):0)break;w=w+1|0;if(w>>>0>=x>>>0){A=10;break}}if((A|0)==10){y=a[f>>0]|0;break}dKa(bKa()|0,4,436784,484,436864,k);i=j;return}while(0);do if(y&2){if(!(c[e+284>>2]&8192)){if((c[e+52>>2]&-1073741824|0)==-1073741824)break;D=(l9(e+64|0,m)|0)^1}else{x=e+56|0;w=c[x>>2]|0;if(!w){C=s4(c[p>>2]|0,(c[e+52>>2]|0)>>>24&15)|0;c[x>>2]=C;E=C}else E=w;g[m>>2]=ea(g[E+192>>2]);g[m+4>>2]=ea(g[E+196>>2]);g[m+8>>2]=ea(g[E+200>>2]);g[m+12>>2]=ea(g[E+204>>2]);g[m+16>>2]=ea(g[E+208>>2]);g[m+20>>2]=ea(g[E+212>>2]);g[m+24>>2]=ea(g[E+216>>2]);D=0}if(!(D|(q|0)==0)){G2(v,q+3376|0);w=q+3400|0;c[w>>2]=(c[w>>2]|0)+1}}while(0);v=e+64|0;if((c[e+52>>2]&-1073741824|0)==1073741824?(w=e+220|0,(c[w>>2]|0)!=0):0){C=h9(v,1)|0;x=(c[w>>2]|0)==0;if(C){if(x)break;c9(v,c[(c[p>>2]|0)+1256>>2]|0,1);break}if((!x?h9(v,0)|0:0)?(c[w>>2]|0)!=0:0)c9(v,c[(c[p>>2]|0)+1256>>2]|0,0)}}else if(t&(s^1)){if((mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0)==4){dKa(bKa()|0,4,436784,505,436952,k);i=j;return}v=e+64|0;if((((c[e+52>>2]&-1073741824|0)==1073741824?(w=e+220|0,(c[w>>2]|0)!=0):0)?h9(v,0)|0:0)?(c[w>>2]|0)!=0:0)O8(v,c[(c[p>>2]|0)+1256>>2]|0,1,0)|0}while(0);do if(!(s^1|u)?((d[f>>0]|0)&2)<<24>>24!=((d[h>>0]|0)&2)<<24>>24:0){if(!(c[e+284>>2]&8192)){if((c[e+52>>2]&-1073741824|0)==-1073741824)break;F=(l9(e+64|0,n)|0)^1}else{k=e+56|0;t=c[k>>2]|0;if(!t){D=s4(c[p>>2]|0,(c[e+52>>2]|0)>>>24&15)|0;c[k>>2]=D;G=D}else G=t;g[n>>2]=ea(g[G+192>>2]);g[n+4>>2]=ea(g[G+196>>2]);g[n+8>>2]=ea(g[G+200>>2]);g[n+12>>2]=ea(g[G+204>>2]);g[n+16>>2]=ea(g[G+208>>2]);g[n+20>>2]=ea(g[G+212>>2]);g[n+24>>2]=ea(g[G+216>>2]);F=0}if(!(F|(q|0)==0)){G2(e+20|0,q+3376|0);t=q+3400|0;c[t>>2]=(c[t>>2]|0)+1}}while(0);a[o>>0]=a[h>>0]|0;uIb(p,o);i=j;return}function sGb(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+16|0;h=g;j=KU(d)|0;k=d+4|0;l=c[427044+(e[k>>1]<<2)>>2]|0;m=d+l|0;n=c[d+(l+4)>>2]|0;if(!(n&1))o=(c[450992+((n>>>24&15)<<2)>>2]|0)+m+8|0;else{p=d+(l+8)|0;l=c[p>>2]|0;if(!l){q=s4(c[m>>2]|0,n>>>24&15)|0;c[p>>2]=q;r=q}else r=l;o=r}r=b[o>>1]|0;o=r&65535;l=(o&8|0)!=0;if(l^1|f){if(l|f^1){i=g;return}if(j)HU(d+12|0);f=(o|8)&65535;o=c[427044+(e[k>>1]<<2)>>2]|0;l=d+o|0;q=d+(o+4)|0;p=c[q>>2]|0;n=p>>>24&15;m=(c[450992+(n<<2)>>2]|0)+l|0;s=p>>>30;if((s|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))t=23;else{u=l;t=24}else if((s|0)==3){u=l;t=24}else t=23;if((t|0)==23){b[h>>1]=f;f7(m,h)}else if((t|0)==24){m=d+(o+8)|0;o=c[m>>2]|0;if(!o){s=s4(c[u>>2]|0,n)|0;c[m>>2]=s;v=s}else v=o;b[v>>1]=f;r4(c[u>>2]|0,l);c[q>>2]=c[q>>2]|1}ko[c[(c[d>>2]|0)+132>>2]&4095](d);i=g;return}else{ko[c[(c[d>>2]|0)+136>>2]&4095](d);q=r&-9;r=c[427044+(e[k>>1]<<2)>>2]|0;k=d+r|0;l=d+(r+4)|0;u=c[l>>2]|0;f=u>>>24&15;v=(c[450992+(f<<2)>>2]|0)+k|0;o=u>>>30;if((o|0)==3){w=k;t=11}else if((o|0)==2?(a[(c[k>>2]|0)+2417>>0]|0)!=0:0){w=k;t=11}else t=10;if((t|0)==10){b[h>>1]=q;f7(v,h)}else if((t|0)==11){t=d+(r+8)|0;r=c[t>>2]|0;if(!r){h=s4(c[w>>2]|0,f)|0;c[t>>2]=h;x=h}else x=r;b[x>>1]=q;r4(c[w>>2]|0,k);c[l>>2]=c[l>>2]|1}if(!j){i=g;return}if(!(c[d+16>>2]|0)){i=g;return}IU(d+12|0);i=g;return}}function tGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=c[427044+(e[d+4>>1]<<2)>>2]|0;l=d+k|0;m=d+(k+4)|0;n=c[m>>2]|0;o=(n&1|0)==0;if(g){if(o){g=l;p=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;q=g;r=n}else{g=d+(k+8)|0;s=c[g>>2]|0;if(!s){t=s4(c[l>>2]|0,n>>>24&15)|0;c[g>>2]=t;u=c[m>>2]|0;v=t}else{u=n;v=s}p=v;q=l;r=u}u=(e[p>>1]|f)&65535;p=r>>>24&15;v=(c[450992+(p<<2)>>2]|0)+q|0;q=r>>>30;if((q|0)==3)w=l;else if((q|0)==2?(a[(c[l>>2]|0)+2417>>0]|0)!=0:0)w=l;else x=10;if((x|0)==10){b[j>>1]=u;f7(v,j);i=h;return}v=d+(k+8)|0;q=c[v>>2]|0;if(!q){r=s4(c[w>>2]|0,p)|0;c[v>>2]=r;y=r}else y=q;b[y>>1]=u;r4(c[w>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}else{if(o){o=l;z=(c[450992+((n>>>24&15)<<2)>>2]|0)+o+8|0;A=o;B=n}else{o=d+(k+8)|0;w=c[o>>2]|0;if(!w){u=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=u;C=c[m>>2]|0;D=u}else{C=n;D=w}z=D;A=l;B=C}C=b[z>>1]&((f^65535)&65535);f=B>>>24&15;z=(c[450992+(f<<2)>>2]|0)+A|0;A=B>>>30;if((A|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))x=22;else E=l;else if((A|0)==3)E=l;else x=22;if((x|0)==22){b[j>>1]=C;f7(z,j);i=h;return}j=d+(k+8)|0;k=c[j>>2]|0;if(!k){d=s4(c[E>>2]|0,f)|0;c[j>>2]=d;F=d}else F=k;b[F>>1]=C;r4(c[E>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}}function uGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=c[427044+(e[d+4>>1]<<2)>>2]|0;l=d+k|0;m=d+(k+4)|0;n=c[m>>2]|0;o=(n&1|0)==0;if(g){if(o){g=l;p=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;q=g;r=n}else{g=d+(k+8)|0;s=c[g>>2]|0;if(!s){t=s4(c[l>>2]|0,n>>>24&15)|0;c[g>>2]=t;u=c[m>>2]|0;v=t}else{u=n;v=s}p=v;q=l;r=u}u=(e[p>>1]|f)&65535;p=r>>>24&15;v=(c[450992+(p<<2)>>2]|0)+q|0;q=r>>>30;if((q|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))w=10;else x=l;else if((q|0)==3)x=l;else w=10;if((w|0)==10){b[j>>1]=u;f7(v,j);i=h;return}v=d+(k+8)|0;q=c[v>>2]|0;if(!q){r=s4(c[x>>2]|0,p)|0;c[v>>2]=r;y=r}else y=q;b[y>>1]=u;r4(c[x>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}else{if(o){o=l;z=(c[450992+((n>>>24&15)<<2)>>2]|0)+o+8|0;A=o;B=n}else{o=d+(k+8)|0;x=c[o>>2]|0;if(!x){u=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=u;C=c[m>>2]|0;D=u}else{C=n;D=x}z=D;A=l;B=C}C=b[z>>1]&((f^65535)&65535);f=B>>>24&15;z=(c[450992+(f<<2)>>2]|0)+A|0;A=B>>>30;if((A|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))w=22;else E=l;else if((A|0)==3)E=l;else w=22;if((w|0)==22){b[j>>1]=C;f7(z,j);i=h;return}j=d+(k+8)|0;k=c[j>>2]|0;if(!k){d=s4(c[E>>2]|0,f)|0;c[j>>2]=d;F=d}else F=k;b[F>>1]=C;r4(c[E>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}}function vGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+4>>2]|0)>>>30;if((h|0)==2){if(a[(c[b>>2]|0)+2417>>0]|0)j=3}else if((h|0)==3)j=3;if((j|0)==3){dKa(bKa()|0,8,449960,313,448208,f);k=0;i=e;return k|0}j=b+152|0;h=c[j>>2]|0;if(!h){l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;n=Bn[m&255](l,204,o?448344:544544,449960,319)|0;c[n+16>>2]=0;c[n+20>>2]=12;c[n+24>>2]=0;c[n+28>>2]=12;c[n+32>>2]=0;c[n+36>>2]=4;c[n+40>>2]=0;c[n+44>>2]=2;c[n+48>>2]=0;c[n+52>>2]=12;c[n+56>>2]=0;c[n+60>>2]=12;c[n+64>>2]=0;c[n+68>>2]=4;c[n>>2]=448320;a[n+72>>0]=0;a[n+201>>0]=1;UEi(n+73|0,3129952,128)|0;c[j>>2]=n;p=n}else p=h;h=p+72|0;if(!(a[h>>0]|0))q=p+73|0;else{n=bKa()|0;o=p+73|0;c[f>>2]=448272;c[f+4>>2]=o;dKa(n,8,451512,67,451608,f);q=o}UEi(q|0,448272,128)|0;a[p+200>>0]=0;a[h>>0]=1;h=c[j>>2]|0;p=c[(c[h>>2]|0)+16>>2]|0;a[g>>0]=a[d>>0]|0;In[p&4095](h,g);Jha(b+12|0,c[j>>2]|0);k=c[j>>2]|0;i=e;return k|0}function wGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=c[427044+(e[d+4>>1]<<2)>>2]|0;l=d+k|0;m=d+(k+4)|0;n=c[m>>2]|0;o=(n&1|0)==0;if(g){if(o){g=l;p=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;q=g;r=n}else{g=d+(k+8)|0;s=c[g>>2]|0;if(!s){t=s4(c[l>>2]|0,n>>>24&15)|0;c[g>>2]=t;u=c[m>>2]|0;v=t}else{u=n;v=s}p=v;q=l;r=u}u=(e[p>>1]|f)&65535;p=r>>>24&15;v=(c[450992+(p<<2)>>2]|0)+q|0;q=r>>>30;if((q|0)==3)w=l;else if((q|0)==2?(a[(c[l>>2]|0)+2417>>0]|0)!=0:0)w=l;else x=10;if((x|0)==10){b[j>>1]=u;f7(v,j);i=h;return}v=d+(k+8)|0;q=c[v>>2]|0;if(!q){r=s4(c[w>>2]|0,p)|0;c[v>>2]=r;y=r}else y=q;b[y>>1]=u;r4(c[w>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}else{if(o){o=l;z=(c[450992+((n>>>24&15)<<2)>>2]|0)+o+8|0;A=o;B=n}else{o=d+(k+8)|0;w=c[o>>2]|0;if(!w){u=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=u;C=c[m>>2]|0;D=u}else{C=n;D=w}z=D;A=l;B=C}C=b[z>>1]&((f^65535)&65535);f=B>>>24&15;z=(c[450992+(f<<2)>>2]|0)+A|0;A=B>>>30;if((A|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))x=22;else E=l;else if((A|0)==3)E=l;else x=22;if((x|0)==22){b[j>>1]=C;f7(z,j);i=h;return}j=d+(k+8)|0;k=c[j>>2]|0;if(!k){d=s4(c[E>>2]|0,f)|0;c[j>>2]=d;F=d}else F=k;b[F>>1]=C;r4(c[E>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}}function xGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h;k=c[427044+(e[d+4>>1]<<2)>>2]|0;l=d+k|0;m=d+(k+4)|0;n=c[m>>2]|0;o=(n&1|0)==0;if(g){if(o){g=l;p=(c[450992+((n>>>24&15)<<2)>>2]|0)+g+8|0;q=g;r=n}else{g=d+(k+8)|0;s=c[g>>2]|0;if(!s){t=s4(c[l>>2]|0,n>>>24&15)|0;c[g>>2]=t;u=c[m>>2]|0;v=t}else{u=n;v=s}p=v;q=l;r=u}u=(e[p>>1]|f)&65535;p=r>>>24&15;v=(c[450992+(p<<2)>>2]|0)+q|0;q=r>>>30;if((q|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))w=10;else x=l;else if((q|0)==3)x=l;else w=10;if((w|0)==10){b[j>>1]=u;f7(v,j);i=h;return}v=d+(k+8)|0;q=c[v>>2]|0;if(!q){r=s4(c[x>>2]|0,p)|0;c[v>>2]=r;y=r}else y=q;b[y>>1]=u;r4(c[x>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}else{if(o){o=l;z=(c[450992+((n>>>24&15)<<2)>>2]|0)+o+8|0;A=o;B=n}else{o=d+(k+8)|0;x=c[o>>2]|0;if(!x){u=s4(c[l>>2]|0,n>>>24&15)|0;c[o>>2]=u;C=c[m>>2]|0;D=u}else{C=n;D=x}z=D;A=l;B=C}C=b[z>>1]&((f^65535)&65535);f=B>>>24&15;z=(c[450992+(f<<2)>>2]|0)+A|0;A=B>>>30;if((A|0)==2)if(!(a[(c[l>>2]|0)+2417>>0]|0))w=22;else E=l;else if((A|0)==3)E=l;else w=22;if((w|0)==22){b[j>>1]=C;f7(z,j);i=h;return}j=d+(k+8)|0;k=c[j>>2]|0;if(!k){d=s4(c[E>>2]|0,f)|0;c[j>>2]=d;F=d}else F=k;b[F>>1]=C;r4(c[E>>2]|0,l);c[m>>2]=c[m>>2]|1;i=h;return}}function yGb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)vIb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function zGb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)vDb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function AGb(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)vDb(a,b);c[a+4>>2]=b;i=d;return}function BGb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(!b)e=0;else e=UJa(a,b<<3,537640,558)|0;f=c[a+4>>2]|0;g=e+(f<<3)|0;if((f|0)>0){f=e;h=c[a>>2]|0;while(1){if(f){j=h;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k}f=f+8|0;if(f>>>0>=g>>>0)break;else h=h+8|0}}h=a+8|0;if((c[h>>2]|0)<=-1){c[a>>2]=e;c[h>>2]=b;i=d;return}VJa(a,c[a>>2]|0);c[a>>2]=e;c[h>>2]=b;i=d;return}function CGb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)BGb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<3)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<3)|0;do{if(j){a=d;f=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=f}j=j+8|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function DGb(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)DDb(a,b);c[a+4>>2]=b;i=d;return}function EGb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a+8|0;f=c[e>>2]|0;h=(f&2147483647|0)==0?1:f<<1;if(!h)j=0;else j=UJa(a,h*12|0,537640,558)|0;f=a+4|0;k=c[f>>2]|0;l=j+(k*12|0)|0;if((k|0)>0){m=j;n=c[a>>2]|0;while(1){if(m){g[m>>2]=ea(g[n>>2]);g[m+4>>2]=ea(g[n+4>>2]);g[m+8>>2]=ea(g[n+8>>2])}m=m+12|0;if(m>>>0>=l>>>0)break;else n=n+12|0}}if(l){g[l>>2]=ea(g[b>>2]);g[j+(k*12|0)+4>>2]=ea(g[b+4>>2]);g[j+(k*12|0)+8>>2]=ea(g[b+8>>2])}if((c[e>>2]|0)<=-1){o=k;c[a>>2]=j;c[e>>2]=h;p=o+1|0;c[f>>2]=p;q=j+(o*12|0)|0;i=d;return q|0}VJa(a,c[a>>2]|0);o=c[f>>2]|0;c[a>>2]=j;c[e>>2]=h;p=o+1|0;c[f>>2]=p;q=j+(o*12|0)|0;i=d;return q|0}function FGb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=Im,z=0,A=0,B=Im,C=0,D=0,E=0,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0;f=i;i=i+144|0;e=f;h=e;c[h>>2]=0;c[h+4>>2]=0;h=e+4|0;a[h>>0]=0;j=f+8|0;c[e>>2]=j;k=d+-1|0;if((k|0)>0){d=0;l=j;j=32;m=0;n=0;o=k;a:while(1){k=n;p=m;q=o;while(1){if((q|0)>(k|0)){if((q-k|0)>>>0<5)r=k;else break;do{s=r;r=r+1|0;t=r;u=s;while(1){v=c[b+(t<<2)>>2]|0;w=ea(g[v+28>>2]);x=c[b+(u<<2)>>2]|0;y=ea(g[x+28>>2]);if(!(w<y))if(w==y?(c[v+4>>2]|0)!=0:0)z=(c[x+4>>2]|0)==0?t:u;else z=u;else z=t;if((t|0)>=(q|0))break;t=t+1|0;u=z}u=b+(z<<2)|0;t=b+(s<<2)|0;x=c[u>>2]|0;c[u>>2]=c[t>>2];c[t>>2]=x}while((r|0)!=(q|0))}if(!p)break a;x=c[l+(p+-1<<2)>>2]|0;t=p+-2|0;k=c[l+(t<<2)>>2]|0;p=t;q=x}x=b+(((q+k|0)/2|0)<<2)|0;t=b+(k<<2)|0;u=c[x>>2]|0;y=ea(g[u+28>>2]);v=c[t>>2]|0;w=ea(g[v+28>>2]);if(!(y<w))if((y==w?(c[u+4>>2]|0)!=0:0)?(c[v+4>>2]|0)==0:0)A=17;else{B=w;C=u;D=v}else A=17;if((A|0)==17){A=0;c[t>>2]=u;c[x>>2]=v;u=c[t>>2]|0;B=ea(g[u+28>>2]);C=v;D=u}u=b+(q<<2)|0;v=c[u>>2]|0;w=ea(g[v+28>>2]);if(!(w<B))if((w==B?(c[v+4>>2]|0)!=0:0)?(c[D+4>>2]|0)==0:0)A=22;else{E=C;F=w;G=v}else A=22;if((A|0)==22){A=0;c[t>>2]=v;c[u>>2]=D;E=c[x>>2]|0;F=B;G=D}w=ea(g[E+28>>2]);if(!(F<w))if((F==w?(c[G+4>>2]|0)!=0:0)?(c[E+4>>2]|0)==0:0)A=27;else H=E;else A=27;if((A|0)==27){A=0;c[x>>2]=G;c[u>>2]=E;H=c[x>>2]|0}u=q+-1|0;v=b+(u<<2)|0;c[x>>2]=c[v>>2];c[v>>2]=H;x=H;t=k;I=u;while(1){w=ea(g[x+28>>2]);u=x+4|0;J=t;while(1){K=J+1|0;L=b+(K<<2)|0;M=c[L>>2]|0;y=ea(g[M+28>>2]);if(y<w){J=K;continue}if(!(y==w)){N=I;break}if(!(c[M+4>>2]|0)){N=I;break}if(!(c[u>>2]|0))J=K;else{N=I;break}}while(1){O=N;N=N+-1|0;P=b+(N<<2)|0;Q=c[P>>2]|0;y=ea(g[Q+28>>2]);if(w<y){N=N;continue}if(!(w==y))break;if(!(c[u>>2]|0))break;if(c[Q+4>>2]|0)break}if((K|0)>=(N|0))break;c[L>>2]=Q;c[P>>2]=M;x=c[v>>2]|0;t=K;I=N}c[L>>2]=x;c[v>>2]=M;if((K-k|0)<(q-K|0)){if(p>>>0>=(j+-1|0)>>>0){I=j<<1;t=j<<3;if(!t)R=0;else{u=mKa()|0;O=c[(c[u>>2]|0)+8>>2]|0;S=pKa()|0;T=mo[c[(c[S>>2]|0)+24>>2]&4095](S)|0;R=Bn[O&255](u,t,T?485464:544544,523928,148)|0}YEi(R|0,l|0,p<<2|0)|0;if(d<<24>>24==0|(l|0)==0){U=R;V=1;W=I}else{T=mKa()|0;In[c[(c[T>>2]|0)+12>>2]&4095](T,l);U=R;V=1;W=I}}else{U=l;V=d;W=j}c[U+(p<<2)>>2]=k;c[U+(p+1<<2)>>2]=J;X=V;Y=U;Z=W;_=J+2|0;$=q}else{I=J+2|0;if(p>>>0>=(j+-1|0)>>>0){T=j<<1;t=j<<3;if(!t)aa=0;else{u=mKa()|0;O=c[(c[u>>2]|0)+8>>2]|0;S=pKa()|0;ba=mo[c[(c[S>>2]|0)+24>>2]&4095](S)|0;aa=Bn[O&255](u,t,ba?485464:544544,523928,148)|0}YEi(aa|0,l|0,p<<2|0)|0;if(d<<24>>24==0|(l|0)==0){ca=aa;da=1;fa=T}else{ba=mKa()|0;In[c[(c[ba>>2]|0)+12>>2]&4095](ba,l);ca=aa;da=1;fa=T}}else{ca=l;da=d;fa=j}c[ca+(p<<2)>>2]=I;c[ca+(p+1<<2)>>2]=q;X=da;Y=ca;Z=fa;_=k;$=J}d=X;l=Y;j=Z;m=p+2|0;n=_;o=$}if(!(d<<24>>24==0|(l|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,l)}}if(!(a[h>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function GGb(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;d=a+20|0;f=c[(c[(c[d>>2]|0)+96>>2]|0)+6736>>2]|0;h=c[f+8>>2]|0;j=f;f=c[j>>2]|0;k=c[j+4>>2]|0;j=e[268288]|e[268289]<<16;l=(h|0)==0|(j&16711680|0)==0;if(!l)Dn[c[(c[h>>2]|0)+8>>2]&511](h,j&65535,f,k);m=a+24|0;c[(c[m>>2]|0)+9292>>2]=0;c[(c[m>>2]|0)+9296>>2]=0;c[(c[m>>2]|0)+9268>>2]=0;n=c[m>>2]|0;c[n+9308>>2]=c[n+9144>>2];n=c[m>>2]|0;c[n+9316>>2]=c[n+9156>>2];c[(c[m>>2]|0)+8952>>2]=0;c[(c[m>>2]|0)+9100>>2]=0;c[(c[m>>2]|0)+9092>>2]=0;c[(c[m>>2]|0)+8956>>2]=0;c[(c[m>>2]|0)+9104>>2]=0;c[(c[m>>2]|0)+9096>>2]=0;n=c[(c[(c[d>>2]|0)+96>>2]|0)+6736>>2]|0;d=c[n+8>>2]|0;o=n;n=c[o>>2]|0;p=c[o+4>>2]|0;Dn[c[(c[d>>2]|0)+8>>2]&511](d,83,n,p);o=c[a+52>>2]&2147483647;if(!o)q=0;else{r=c[a+32>>2]|0;s=0;t=0;while(1){u=(e[(c[c[r+(s<<2)>>2]>>2]|0)+36>>1]|0)+t|0;s=s+1|0;if(s>>>0>=o>>>0){q=u;break}else t=u}}t=c[m>>2]|0;s=c[a+56>>2]|0;r=a+48|0;qya(t,c[r>>2]|0,s,s+q+(c[a+60>>2]|0)|0,(c[t+8776>>2]|0)==0?0:s,o);o=c[m>>2]|0;m=c[o+9108>>2]|0;s=c[o+9120>>2]|0;o=c[r>>2]|0;if(o){t=a+28|0;a=c[t>>2]|0;q=o;o=0;while(1){c[m+(o<<2)>>2]=c[(c[(c[t>>2]|0)+(o<<2)>>2]|0)+64>>2];u=c[t>>2]|0;v=c[u+(o<<2)>>2]|0;g[s+(o<<5)>>2]=ea(g[v>>2]);g[s+(o<<5)+4>>2]=ea(g[v+4>>2]);g[s+(o<<5)+8>>2]=ea(g[v+8>>2]);g[s+(o<<5)+12>>2]=ea(0.0);g[s+(o<<5)+16>>2]=ea(g[v+16>>2]);g[s+(o<<5)+20>>2]=ea(g[v+20>>2]);g[s+(o<<5)+24>>2]=ea(g[v+24>>2]);g[s+(o<<5)+28>>2]=ea(0.0);v=o+1|0;w=c[r>>2]|0;if(v>>>0<w>>>0){a=u;q=w;o=v}else break}}Dn[c[(c[d>>2]|0)+12>>2]&511](d,83,n,p);if(l){i=b;return}Dn[c[(c[h>>2]|0)+12>>2]&511](h,j&65535,f,k);i=b;return}function HGb(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;b=i;i=i+16|0;d=b;f=a+24|0;h=c[f>>2]|0;j=c[h+9368>>2]|0;c[h+336>>2]=0;c[h+340>>2]=0;h=a+52|0;if(!(c[h>>2]&2147483647)){k=0;l=0;m=0;n=c[f>>2]|0;o=n+9292|0;iTa(o,l)|0;p=c[f>>2]|0;q=p+9296|0;iTa(q,m)|0;r=c[f>>2]|0;s=r+9304|0;c[s>>2]=k;i=b;return}t=a+32|0;u=a+20|0;a=0;v=0;w=0;x=0;while(1){y=c[(c[t>>2]|0)+(a<<2)>>2]|0;z=j+(a*40|0)|0;A=z+0|0;B=(c[y>>2]|0)+0|0;C=A+40|0;do{c[A>>2]=c[B>>2];A=A+4|0;B=B+4|0}while((A|0)<(C|0));B=c[u>>2]|0;A=c[f>>2]|0;if(!(c[125130]|0)){D=0;E=A}else{C=Kza(z,ea(g[B+124>>2]),A+332|0,c[A+9308>>2]|0,d,c[(c[B+96>>2]|0)+6736>>2]|0,A+316|0)|0;D=C;E=c[f>>2]|0}C=E+9308|0;c[C>>2]=(c[C>>2]|0)+(D<<5);C=(c[f>>2]|0)+9268|0;c[C>>2]=(c[C>>2]|0)+(c[d>>2]|0);C=e[j+(a*40|0)+32>>1]|0;A=v>>>0<C>>>0?C:v;C=e[(c[(c[y>>2]|0)+24>>2]|0)+12>>1]|0;B=C>>>8;F=B>>>0<x>>>0?x:B;B=C&255;C=B>>>0<w>>>0?w:B;a=a+1|0;if(a>>>0>=(c[h>>2]&2147483647)>>>0){k=A;l=C;m=F;break}else{v=A;w=C;x=F}}n=c[f>>2]|0;o=n+9292|0;iTa(o,l)|0;p=c[f>>2]|0;q=p+9296|0;iTa(q,m)|0;r=c[f>>2]|0;s=r+9304|0;c[s>>2]=k;i=b;return}function IGb(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;f=i;i=i+48|0;g=f+41|0;h=f+40|0;j=f+32|0;k=f;l=d+24|0;m=c[(c[l>>2]|0)+9308>>2]|0;n=d+48|0;o=d+60|0;if(!(c[o>>2]|0)){p=m;q=m}else{r=d+20|0;s=d+44|0;t=m;m=0;do{xta(c[r>>2]|0,t,(c[s>>2]|0)+(m<<4)|0);c[t+16>>2]=c[(c[s>>2]|0)+(m<<4)+12>>2];b[t+26>>1]=2;t=t+32|0;m=m+1|0}while(m>>>0<(c[o>>2]|0)>>>0);p=c[(c[l>>2]|0)+9308>>2]|0;q=t}wIb(p,q-p>>5,h,g);c[(c[l>>2]|0)+9220>>2]=0;g=c[l>>2]|0;h=d+56|0;p=c[h>>2]|0;if((c[g+9224>>2]&2147483647)>>>0<p>>>0){xIb(g+9216|0,p);u=c[l>>2]|0;v=c[h>>2]|0}else{u=g;v=p}c[u+9220>>2]=v;c[(c[l>>2]|0)+9232>>2]=0;v=c[l>>2]|0;u=c[h>>2]|0;if((c[v+9236>>2]&2147483647)>>>0<u>>>0){xIb(v+9228|0,u);w=c[l>>2]|0;x=c[h>>2]|0}else{w=v;x=u}c[w+9232>>2]=x;x=c[l>>2]|0;w=c[x+9216>>2]|0;c[x+9208>>2]=0;if(!(c[h>>2]|0)){y=q;z=c[l>>2]|0;A=z+9144|0;B=c[A>>2]|0;C=y;D=B;E=C-D|0;F=E>>5;G=z+9148|0;c[G>>2]=F;H=c[l>>2]|0;I=H+9144|0;J=c[I>>2]|0;K=J;L=C-K|0;M=L>>5;N=H+9172|0;c[N>>2]=M;i=f;return}c[(c[l>>2]|0)+9244>>2]=0;x=d+20|0;u=c[(c[x>>2]|0)+152>>2]|0;v=d+64|0;c[j>>2]=1-(c[v>>2]|0)+(u<<1);c[j+4>>2]=1;p=u+1+(c[n>>2]|0)|0;u=c[l>>2]|0;if((c[u+9248>>2]&2147483647)>>>0<p>>>0){yUa(u+9240|0,p);O=c[l>>2]|0}else O=u;c[O+9244>>2]=p;O=p<<2;PEi(c[(c[l>>2]|0)+9240>>2]|0,0,O|0)|0;p=c[h>>2]|0;if(!p)P=0;else{u=c[d+40>>2]|0;g=p;p=0;while(1){t=a[u+(p<<4)+8>>0]|0;if(t<<24>>24==2)Q=g;else{o=(c[(c[l>>2]|0)+9240>>2]|0)+((c[j+((t&255)<<2)>>2]|0)+(c[u+(p<<4)>>2]|0)<<2)|0;c[o>>2]=(c[o>>2]|0)+1;Q=c[h>>2]|0}p=p+1|0;if(p>>>0>=Q>>>0){P=Q;break}else g=Q}}Q=c[l>>2]|0;g=c[Q+9244>>2]|0;if(!g){R=P;S=0}else{P=Q;Q=g;g=0;while(1){p=Q+-1|0;u=(c[P+9240>>2]|0)+(p<<2)|0;o=c[u>>2]|0;c[u>>2]=g;T=o+g|0;if(!p)break;P=c[l>>2]|0;Q=p;g=T}R=c[h>>2]|0;S=T}if(R){T=d+40|0;g=R;R=0;Q=S;while(1){S=c[T>>2]|0;P=S+(R<<4)|0;p=a[S+(R<<4)+8>>0]|0;if(p<<24>>24==2){c[(c[(c[l>>2]|0)+9228>>2]|0)+(Q<<2)>>2]=P;U=g;V=Q+1|0}else{S=c[l>>2]|0;o=(c[S+9240>>2]|0)+((c[j+((p&255)<<2)>>2]|0)+(c[P>>2]|0)<<2)|0;p=c[o>>2]|0;c[o>>2]=p+1;c[(c[S+9228>>2]|0)+(p<<2)>>2]=P;U=c[h>>2]|0;V=Q}R=R+1|0;if(R>>>0>=U>>>0)break;else{g=U;Q=V}}}PEi(c[(c[l>>2]|0)+9240>>2]|0,0,O|0)|0;O=c[h>>2]|0;V=c[l>>2]|0;if(!O){W=V;X=0}else{Q=V;V=O;O=0;while(1){U=c[(c[Q+9228>>2]|0)+(O<<2)>>2]|0;g=a[U+9>>0]|0;if(g<<24>>24==3){Y=0;Z=30}else if(g<<24>>24==2){_=V;$=Q}else{Y=(c[j+((g&255)<<2)>>2]|0)+(c[U+4>>2]|0)|0;Z=30}if((Z|0)==30){Z=0;U=(c[Q+9240>>2]|0)+(Y<<2)|0;c[U>>2]=(c[U>>2]|0)+1;_=c[h>>2]|0;$=c[l>>2]|0}O=O+1|0;if(O>>>0>=_>>>0){W=$;X=_;break}else{Q=$;V=_}}}_=c[W+9244>>2]|0;if(!_){aa=X;ba=W;ca=0}else{X=W;W=_;_=0;while(1){V=W+-1|0;$=(c[X+9240>>2]|0)+(V<<2)|0;Q=c[$>>2]|0;c[$>>2]=_;da=Q+_|0;if(!V)break;X=c[l>>2]|0;W=V;_=da}aa=c[h>>2]|0;ba=c[l>>2]|0;ca=da}if(!aa){ea=ba;fa=0}else{da=ba;ba=aa;aa=0;_=ca;while(1){ca=c[(c[da+9228>>2]|0)+(aa<<2)>>2]|0;W=a[ca+9>>0]|0;if(W<<24>>24==3){ga=0;Z=39}else if(W<<24>>24==2){c[w+(_<<2)>>2]=ca;ha=ba;ia=_+1|0}else{ga=(c[j+((W&255)<<2)>>2]|0)+(c[ca+4>>2]|0)|0;Z=39}if((Z|0)==39){Z=0;W=(c[da+9240>>2]|0)+(ga<<2)|0;X=c[W>>2]|0;c[W>>2]=X+1;c[w+(X<<2)>>2]=ca;ha=c[h>>2]|0;ia=_}aa=aa+1|0;ca=c[l>>2]|0;if(aa>>>0>=ha>>>0){ea=ca;fa=ha;break}else{da=ca;ba=ha;_=ia}}}c[ea+9312>>2]=q;ea=(c[l>>2]|0)+9204|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;yIb(ea,fa,k);c[(c[l>>2]|0)+9208>>2]=c[h>>2];xta(c[x>>2]|0,q,c[w>>2]|0);c[q+16>>2]=c[(c[w>>2]|0)+12>>2];b[q+26>>1]=1;k=e[(c[(c[w>>2]|0)+12>>2]|0)+36>>1]|0;fa=c[h>>2]|0;if(fa>>>0>1){ea=1;ia=k;_=q;ha=0;ba=q;da=0;while(1){aa=_+32|0;ga=w+(ea<<2)|0;xta(c[x>>2]|0,aa,c[ga>>2]|0);j=c[(c[ga>>2]|0)+12>>2]|0;c[_+48>>2]=j;b[_+58>>1]=1;if(((((c[ba>>2]|0)==(c[aa>>2]|0)?(c[ba+4>>2]|0)==(c[_+36>>2]|0):0)?(b[ba+8>>1]|0)==-1:0)?(b[ba+12>>1]|0)==-1:0)?((e[j+36>>1]|0)+ia|0)>>>0<=64:0){ja=ia;ka=_;la=ha;ma=ba;na=da}else Z=48;do if((Z|0)==48){Z=0;ga=ea-da|0;if(!ia){c[ba+0>>2]=c[aa+0>>2];c[ba+4>>2]=c[aa+4>>2];c[ba+8>>2]=c[aa+8>>2];c[ba+12>>2]=c[aa+12>>2];c[ba+16>>2]=c[aa+16>>2];c[ba+20>>2]=c[aa+20>>2];c[ba+24>>2]=c[aa+24>>2];c[ba+28>>2]=c[aa+28>>2];ja=0;ka=_;la=ha;ma=ba;na=ea;break}if(ga>>>0>1){ca=c[(c[l>>2]|0)+9204>>2]|0;c[ca+(ha<<5)>>2]=da;b[ca+(ha<<5)+4>>1]=ga;b[ca+(ha<<5)+6>>1]=ia;ga=c[(c[w+(da<<2)>>2]|0)+12>>2]|0;c[ca+(ha<<5)+8>>2]=ga+16;X=ga+44|0;c[ca+(ha<<5)+12>>2]=c[X>>2];W=ga+48|0;c[ca+(ha<<5)+16>>2]=c[W>>2];c[ca+(ha<<5)+20>>2]=e[ga+36>>1];if(!(b[ga+114>>1]&16))oa=0;else oa=(c[X>>2]|0)+((c[W>>2]|0)+15&-16)|0;c[ca+(ha<<5)+24>>2]=oa;ja=0;ka=aa;la=ha+1|0;ma=aa;na=ea}else{ja=0;ka=aa;la=ha;ma=aa;na=ea}}while(0);aa=(e[j+36>>1]|0)+ja|0;ea=ea+1|0;ca=c[h>>2]|0;if(ea>>>0>=ca>>>0){pa=ca;qa=aa;ra=ka;sa=la;ta=na;break}else{ia=aa;_=ka;ha=la;ba=ma;da=na}}}else{pa=fa;qa=k;ra=q;sa=0;ta=0}q=pa-ta|0;if(!qa){ua=ra;va=sa}else{if(q>>>0>1){pa=c[(c[l>>2]|0)+9204>>2]|0;c[pa+(sa<<5)>>2]=ta;b[pa+(sa<<5)+4>>1]=q;b[pa+(sa<<5)+6>>1]=qa;qa=c[(c[w+(ta<<2)>>2]|0)+12>>2]|0;c[pa+(sa<<5)+8>>2]=qa+16;ta=qa+44|0;c[pa+(sa<<5)+12>>2]=c[ta>>2];w=qa+48|0;c[pa+(sa<<5)+16>>2]=c[w>>2];c[pa+(sa<<5)+20>>2]=e[qa+36>>1];if(!(b[qa+114>>1]&16))wa=0;else wa=(c[ta>>2]|0)+((c[w>>2]|0)+15&-16)|0;c[pa+(sa<<5)+24>>2]=wa;xa=sa+1|0}else xa=sa;ua=ra+32|0;va=xa}c[(c[l>>2]|0)+9208>>2]=va;if(!va){y=ua;z=c[l>>2]|0;A=z+9144|0;B=c[A>>2]|0;C=y;D=B;E=C-D|0;F=E>>5;G=z+9148|0;c[G>>2]=F;H=c[l>>2]|0;I=H+9144|0;J=c[I>>2]|0;K=J;L=C-K|0;M=L>>5;N=H+9172|0;c[N>>2]=M;i=f;return}xa=d+12|0;ra=d+28|0;d=0;do{sa=c[(c[(c[x>>2]|0)+96>>2]|0)+6732>>2]|0;oTa(c[sa>>2]|0);wa=vXa(sa,76,16)|0;pTa(c[sa>>2]|0);if(!wa)ya=0;else{sa=c[x>>2]|0;pa=c[l>>2]|0;w=c[v>>2]|0;ta=va-d|0;b[wa+4>>1]=-1;b[wa+6>>1]=0;c[wa+8>>2]=0;c[wa>>2]=443968;c[wa+12>>2]=0;c[wa+16>>2]=0;c[wa>>2]=491344;c[wa+20>>2]=sa;c[wa+24>>2]=pa;pa=wa+28|0;c[pa+0>>2]=c[ra+0>>2];c[pa+4>>2]=c[ra+4>>2];c[pa+8>>2]=c[ra+8>>2];c[pa+12>>2]=c[ra+12>>2];c[pa+16>>2]=c[ra+16>>2];pa=wa+48|0;c[pa+0>>2]=c[n+0>>2];c[pa+4>>2]=c[n+4>>2];c[pa+8>>2]=c[n+8>>2];c[pa+12>>2]=c[n+12>>2];c[wa+64>>2]=w;c[wa+68>>2]=d;c[wa+72>>2]=ta>>>0>8?8:ta;ya=wa}wa=c[xa>>2]|0;c[ya+16>>2]=1;ta=ya+12|0;c[ta>>2]=wa;if(wa){ko[c[(c[wa>>2]|0)+16>>2]&4095](wa);c[ya+8>>2]=c[(c[ta>>2]|0)+8>>2]}ko[c[(c[ya>>2]|0)+20>>2]&4095](ya);d=d+8|0}while(d>>>0<va>>>0);y=ua;z=c[l>>2]|0;A=z+9144|0;B=c[A>>2]|0;C=y;D=B;E=C-D|0;F=E>>5;G=z+9148|0;c[G>>2]=F;H=c[l>>2]|0;I=H+9144|0;J=c[I>>2]|0;K=J;L=C-K|0;M=L>>5;N=H+9172|0;c[N>>2]=M;i=f;return}function JGb(d,f,h){d=d|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;j=i;i=i+1536|0;k=j+1216|0;l=j+4|0;m=j+1472|0;n=j;o=h+16|0;p=b[f+4>>1]|0;if(!(p<<16>>16)){q=0;r=0}else{s=d+24|0;t=l+4|0;u=l+8|0;v=l+36|0;w=l+40|0;x=l+44|0;y=l+12|0;z=l+60|0;A=l+56|0;B=l+64|0;C=l+48|0;D=l+52|0;E=l+24|0;F=l+28|0;G=l+16|0;H=l+32|0;I=0;J=0;K=0;while(1){L=c[(c[(c[(c[s>>2]|0)+9216>>2]|0)+((c[f>>2]|0)+I<<2)>>2]|0)+12>>2]|0;M=c[L+44>>2]|0;N=c[L+48>>2]|0;g[l>>2]=ea(0.0);g[t>>2]=ea(0.0);g[u>>2]=ea(0.0);c[v>>2]=N;c[w>>2]=0;c[x>>2]=0;c[y>>2]=M;if(!N){O=0;P=0;Q=0;R=0;S=0;T=1}else{U=b[M+2>>1]|0;V=U&65535;W=V&2;X=(W|0)!=0;Y=V&1;if(X)Z=72;else Z=Y<<3|16;O=M+(W<<3|4)|0;P=(Y|0)!=0;Q=X;R=X?4:32;S=Z;T=(U&4)!=0}c[z>>2]=Q&1;c[A>>2]=P&1;c[B>>2]=T&1;c[C>>2]=R;c[D>>2]=S;c[E>>2]=O;c[F>>2]=O;c[G>>2]=O;if(!T){U=O;X=M;if((U-X|0)>>>0<N>>>0){M=O;Y=0;W=0;V=O;_=U;U=K;while(1){c[E>>2]=V;if((_-X|0)>>>0<N>>>0){$=e[V>>1]|0;c[w>>2]=$;aa=V+((da(S,$)|0)+R)|0;c[F>>2]=aa;ba=V+R|0;c[G>>2]=ba;c[x>>2]=0;ca=ba;fa=0;ga=aa;ha=$}else{c[F>>2]=V;ca=M;fa=W;ga=V;ha=Y}if(fa>>>0<ha>>>0){$=V+20|0;aa=V+16|0;ba=V+24|0;ia=V+4|0;ja=V+28|0;ka=V+30|0;la=fa+1|0;ma=ha>>>0>la>>>0?ha:la;la=U+ma|0;na=da(S,ma-fa|0)|0;oa=ca+(da(S,ma+-1-fa|0)|0)|0;pa=fa;qa=ca;ra=U;while(1){pa=pa+1|0;if(Q){g[h+(ra<<6)+456>>2]=ea(g[qa+56>>2]);g[h+(ra<<6)+444>>2]=ea(g[qa+52>>2]);sa=qa+60|0}else{g[h+(ra<<6)+456>>2]=ea(g[$>>2]);g[h+(ra<<6)+444>>2]=ea(g[aa>>2]);sa=ba}g[h+(ra<<6)+460>>2]=ea(g[sa>>2]);if(P){c[h+(ra<<6)+448>>2]=c[qa+16>>2];ta=c[qa+20>>2]|0}else{c[h+(ra<<6)+448>>2]=-1;ta=-1}c[h+(ra<<6)+452>>2]=ta;if(Q){g[h+(ra<<6)+428>>2]=ea(g[qa+48>>2]);ua=qa+36|0}else{g[h+(ra<<6)+428>>2]=ea(3402823469999999843913219.0e14);ua=l}g[h+(ra<<6)+432>>2]=ea(g[ua>>2]);g[h+(ra<<6)+436>>2]=ea(g[ua+4>>2]);g[h+(ra<<6)+440>>2]=ea(g[ua+8>>2]);va=Q?qa+24|0:ia;g[h+(ra<<6)+400>>2]=ea(g[va>>2]);g[h+(ra<<6)+404>>2]=ea(g[va+4>>2]);g[h+(ra<<6)+408>>2]=ea(g[va+8>>2]);g[h+(ra<<6)+416>>2]=ea(g[qa>>2]);g[h+(ra<<6)+420>>2]=ea(g[qa+4>>2]);g[h+(ra<<6)+424>>2]=ea(g[qa+8>>2]);g[h+(ra<<6)+412>>2]=ea(g[qa+12>>2]);if(Q){b[k+(ra<<2)>>1]=b[qa+64>>1]|0;wa=qa+66|0}else{b[k+(ra<<2)>>1]=b[ja>>1]|0;wa=ka}b[k+(ra<<2)+2>>1]=b[wa>>1]|0;if(pa>>>0>=ha>>>0)break;else{qa=qa+S|0;ra=ra+1|0}}ra=ca+na|0;c[x>>2]=ma;c[G>>2]=ra;c[H>>2]=oa;xa=ra;ya=ma;za=la-fa|0}else{xa=ca;ya=fa;za=U}_=ga;if((_-X|0)>>>0>=N>>>0){Aa=za;break}else{M=xa;Y=ha;W=ya;V=ga;U=za}}}else Aa=K;if(J){Ba=1;Ca=Aa}else{Ba=(b[L+114>>1]&16)!=0;Ca=Aa}}else{Ba=J;Ca=K}I=I+1|0;if(I>>>0>=(p&65535)>>>0){q=Ba;r=Ca;break}else{J=Ba;K=Ca}}}Ca=h+400|0;K=l+168|0;c[K>>2]=0;c[l+1196>>2]=0;c[l+1200>>2]=Ca;c[l+1204>>2]=k;c[l+1208>>2]=r;zIb(l);Ba=m+0|0;J=Ba+64|0;do{a[Ba>>0]=0;Ba=Ba+1|0}while((Ba|0)<(J|0));Ba=c[K>>2]|0;if(!Ba)Da=0;else{K=0;J=0;while(1){p=c[l+(K*28|0)>>2]|0;if(!p)Ea=J;else{I=p>>>0>1?p:1;Aa=0;do{a[m+(c[l+(K*28|0)+(Aa<<2)+4>>2]|0)>>0]=1;Aa=Aa+1|0}while(Aa>>>0<p>>>0);Ea=J+I|0}K=K+1|0;if(K>>>0>=Ba>>>0){Da=Ea;break}else J=Ea}}Ea=h+332|0;J=d+24|0;d=c[J>>2]|0;Ba=(Da<<1)+15&-16;do if(Ba>>>0>16384)Fa=QAa(c[Ea>>2]|0,Ba)|0;else{Da=h+336|0;K=c[Da>>2]|0;l=h+340|0;if((K|0)!=0?(p=c[l>>2]|0,Aa=p+Ba|0,Aa>>>0<=16384):0){c[l>>2]=Aa;Fa=K+p|0;break}p=SAa(c[Ea>>2]|0,d+316|0)|0;c[Da>>2]=p;c[l>>2]=Ba;Fa=p}while(0);c[f+28>>2]=Fa;if(r){Ba=0;d=0;while(1){if(!(a[m+Ba>>0]|0))Ga=d;else{if((d|0)!=(Ba|0)){g[h+(d<<6)+400>>2]=ea(g[h+(Ba<<6)+400>>2]);g[h+(d<<6)+404>>2]=ea(g[h+(Ba<<6)+404>>2]);g[h+(d<<6)+408>>2]=ea(g[h+(Ba<<6)+408>>2]);g[h+(d<<6)+412>>2]=ea(g[h+(Ba<<6)+412>>2]);g[h+(d<<6)+416>>2]=ea(g[h+(Ba<<6)+416>>2]);g[h+(d<<6)+420>>2]=ea(g[h+(Ba<<6)+420>>2]);g[h+(d<<6)+424>>2]=ea(g[h+(Ba<<6)+424>>2]);g[h+(d<<6)+428>>2]=ea(g[h+(Ba<<6)+428>>2]);g[h+(d<<6)+432>>2]=ea(g[h+(Ba<<6)+432>>2]);g[h+(d<<6)+436>>2]=ea(g[h+(Ba<<6)+436>>2]);g[h+(d<<6)+440>>2]=ea(g[h+(Ba<<6)+440>>2]);Ea=h+(d<<6)+444|0;p=h+(Ba<<6)+444|0;c[Ea+0>>2]=c[p+0>>2];c[Ea+4>>2]=c[p+4>>2];c[Ea+8>>2]=c[p+8>>2];c[Ea+12>>2]=c[p+12>>2];c[Ea+16>>2]=c[p+16>>2];p=k+(d<<2)|0;Ea=k+(Ba<<2)|0;l=e[Ea>>1]|e[Ea+2>>1]<<16;b[p>>1]=l;b[p+2>>1]=l>>>16}b[Fa+(d<<1)>>1]=Ba;Ga=d+1|0}Ba=Ba+1|0;if((Ba|0)==(r|0))break;else d=Ga}if(Ga)if(q){Ha=Ga<<2;Ia=Ga;Ja=Ia&65535;Ka=f+8|0;La=c[Ka>>2]|0;Ma=La+20|0;b[Ma>>1]=Ja;Na=La+28|0;Oa=La+32|0;Pa=La+98|0;Qa=La+80|0;Ra=c[Qa>>2]|0;Sa=La+22|0;Ta=b[Sa>>1]|0;Ua=Ta&128;Va=Ua<<16>>16!=0;Wa=c[J>>2]|0;Xa=(Wa|0)==0;Ya=Wa+16|0;Za=Xa?0:Ya;xAa(Ca,Ia,o,Ma,Na,Oa,n,Ha,Pa,Ra,Va,0,k,0,1,Za,0)|0;i=j;return}else _a=Ga;else _a=0}else _a=0;Ha=0;Ia=_a;Ja=Ia&65535;Ka=f+8|0;La=c[Ka>>2]|0;Ma=La+20|0;b[Ma>>1]=Ja;Na=La+28|0;Oa=La+32|0;Pa=La+98|0;Qa=La+80|0;Ra=c[Qa>>2]|0;Sa=La+22|0;Ta=b[Sa>>1]|0;Ua=Ta&128;Va=Ua<<16>>16!=0;Wa=c[J>>2]|0;Xa=(Wa|0)==0;Ya=Wa+16|0;Za=Xa?0:Ya;xAa(Ca,Ia,o,Ma,Na,Oa,n,Ha,Pa,Ra,Va,0,k,0,1,Za,0)|0;i=j;return}function KGb(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(FPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function LGb(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(EPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function MGb(a,b,d,e,f,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);var p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;p=i;i=i+48|0;q=p+32|0;r=p+16|0;s=p;if(!(GPa(a,b,d,h,j,k,q,s,r,o,1)|0)){t=0;i=p;return t|0}o=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);w=ea(g[q>>2]);f=w>ea(0.0);x=f?w:ea(0.0);w=ea(g[e>>2]);f=e+4|0;y=ea(g[f>>2]);k=e+8|0;z=ea(g[k>>2]);j=e+12|0;A=ea(g[j>>2]);B=ea(g[e+16>>2]);C=ea(g[e+20>>2]);D=ea(g[e+24>>2]);E=ea(g[r>>2]);F=ea(g[r+4>>2]);G=ea(g[r+8>>2]);H=ea(ea(A*A)+ea(-.5));I=ea(ea(ea(w*E)+ea(y*F))+ea(z*G));J=ea(ea(u*x)+ea(C+ea(ea(ea(y*I)+ea(ea(H*F)+ea(A*ea(ea(z*E)-ea(w*G)))))*ea(2.0))));C=ea(ea(v*x)+ea(D+ea(ea(ea(ea(H*G)+ea(A*ea(ea(w*F)-ea(y*E))))+ea(z*I))*ea(2.0))));g[n>>2]=ea(ea(o*x)+ea(B+ea(ea(ea(w*I)+ea(ea(H*E)+ea(A*ea(ea(y*G)-ea(z*F)))))*ea(2.0))));g[n+4>>2]=J;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);C=ea(g[e>>2]);J=ea(g[f>>2]);F=ea(g[k>>2]);z=ea(g[j>>2]);G=ea(g[s>>2]);y=ea(g[s+4>>2]);A=ea(g[s+8>>2]);E=ea(ea(z*z)+ea(-.5));H=ea(ea(ea(C*G)+ea(J*y))+ea(F*A));I=ea(ea(ea(J*H)+ea(ea(E*y)+ea(z*ea(ea(F*G)-ea(C*A)))))*ea(2.0));w=ea(ea(ea(ea(E*A)+ea(z*ea(ea(C*y)-ea(J*G))))+ea(F*H))*ea(2.0));g[m>>2]=ea(ea(ea(C*H)+ea(ea(G*E)+ea(z*ea(ea(J*A)-ea(F*y)))))*ea(2.0));g[m+4>>2]=I;g[m+8>>2]=w;g[m+12>>2]=ea(0.0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];t=1;i=p;return t|0}function NGb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;c[b>>2]=527064;e=b+116|0;c[e>>2]=527168;c[b+120>>2]=527224;c[b+124>>2]=527244;c[b+128>>2]=527284;f=b+132|0;c[f>>2]=527304;g=b+256|0;h=c[g>>2]|0;if(h)In[c[(c[h>>2]|0)+16>>2]&4095](h,e);c[g>>2]=0;g=c[b+72>>2]|0;e=(g|0)==0;if(!e)oTa(c[g+4>>2]|0);h=b+36|0;j=c[h>>2]|0;a:do if(!j)k=0;else{l=b+32|0;m=c[l>>2]|0;n=0;while(1){o=n+1|0;if((c[m+(n<<2)>>2]|0)==(f|0))break;if(o>>>0<j>>>0)n=o;else{k=j;break a}}ko[c[(c[f>>2]|0)+12>>2]&4095](f);m=(c[h>>2]|0)+-1|0;c[h>>2]=m;o=c[l>>2]|0;c[o+(n<<2)>>2]=c[o+(m<<2)>>2];k=m}while(0);a[b+76>>0]=(k|0)!=0&1;if(!e)pTa(c[g+4>>2]|0);g=c[b+272>>2]|0;if((g&2147483647|0)!=0&(g|0)>-1?(g=c[b+264>>2]|0,(g|0)!=0):0){e=c[c[b+260>>2]>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,g)}g=c[b+216>>2]|0;if(g){e=c[c[b+212>>2]>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,g)}g=c[b+172>>2]|0;if(g){e=c[c[b+168>>2]>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,g)}g=c[b+164>>2]|0;if((g&2147483647|0)!=0&(g|0)>-1?(g=c[b+156>>2]|0,(g|0)!=0):0){e=c[c[b+152>>2]>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,g)}g=b+148|0;nTa(c[g>>2]|0);e=c[g>>2]|0;if(!e){WGb(b);i=d;return}g=c[c[b+144>>2]>>2]|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,e);WGb(b);i=d;return}function OGb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+12|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else{f=c[c[a>>2]>>2]|0;h=Bn[c[(c[f>>2]|0)+8>>2]&255](f,g<<2,527016,537640,558)|0}f=a+8|0;j=c[f>>2]|0;k=h+(j<<2)|0;l=a+4|0;if((j|0)>0){m=h;n=c[l>>2]|0;while(1){if(m)c[m>>2]=c[n>>2];m=m+4|0;if(m>>>0>=k>>>0)break;else n=n+4|0}}if(k)c[k>>2]=c[b>>2];if((c[e>>2]|0)>-1?(b=c[l>>2]|0,(b|0)!=0):0){k=c[c[a>>2]>>2]|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,b);o=c[f>>2]|0}else o=j;c[l>>2]=h;c[e>>2]=g;c[f>>2]=o+1;i=d;return h+(o<<2)|0}function PGb(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;j=d+24|0;k=c[j>>2]|0;l=(k|0)==0;a:do if(!l){m=b[f>>1]|0;n=m&65535;o=n+~(n<<15)|0;n=(o>>>10^o)*9|0;o=n>>>6^n;n=o+~(o<<11)|0;o=(n>>>16^n)&k+-1;n=c[(c[d+16>>2]|0)+(o<<2)>>2]|0;if((n|0)==-1)p=o;else{q=c[d+8>>2]|0;r=d+12|0;s=n;while(1){if((b[q+(s<<3)>>1]|0)==m<<16>>16)break;n=c[(c[r>>2]|0)+(s<<2)>>2]|0;if((n|0)==-1){p=o;break a}else s=n}a[g>>0]=1;t=q+(s<<3)|0;i=h;return t|0}}else p=0;while(0);a[g>>0]=0;g=d+40|0;if((c[g>>2]|0)==(c[d+20>>2]|0)){o=l?16:k<<1;if(k>>>0<o>>>0){vFb(d,o);u=c[j>>2]|0}else u=k;k=e[f>>1]|0;f=k+~(k<<15)|0;k=(f>>>10^f)*9|0;f=k>>>6^k;k=f+~(f<<11)|0;v=(k>>>16^k)&u+-1}else v=p;p=d+32|0;u=c[p>>2]|0;c[p>>2]=u+1;p=(c[d+16>>2]|0)+(v<<2)|0;c[(c[d+12>>2]|0)+(u<<2)>>2]=c[p>>2];c[p>>2]=u;c[g>>2]=(c[g>>2]|0)+1;g=d+36|0;c[g>>2]=(c[g>>2]|0)+1;t=(c[d+8>>2]|0)+(u<<3)|0;i=h;return t|0}function QGb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g;k=LTa()|0;l=QTa()|0;m=H;n=c[b+72>>2]|0;o=(n|0)==0;if(!o)oTa(c[n+4>>2]|0);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;p=j;c[p>>2]=e;c[p+4>>2]=f;c[j+8>>2]=k;a[j+12>>0]=2;a[j+13>>0]=0;p=j+16|0;c[p>>2]=l;c[p+4>>2]=m;p=b+88|0;if((((c[b+96>>2]|0)==(k|0)?(k=p,(c[k>>2]|0)==(e|0)?(c[k+4>>2]|0)==(f|0):0):0)?(a[b+100>>0]|0)==2:0)?(a[b+101>>0]|0)==0:0){f=h;c[f>>2]=l;c[f+4>>2]=m;AIb(b,3,d,h)}else{c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];BIb(b,1,d,j)}if(o){i=g;return}pTa(c[n+4>>2]|0);i=g;return}function RGb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g;k=LTa()|0;l=QTa()|0;m=H;n=c[b+72>>2]|0;o=(n|0)==0;if(!o)oTa(c[n+4>>2]|0);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;p=j;c[p>>2]=e;c[p+4>>2]=f;c[j+8>>2]=k;a[j+12>>0]=2;a[j+13>>0]=0;p=j+16|0;c[p>>2]=l;c[p+4>>2]=m;p=b+88|0;if((((c[b+96>>2]|0)==(k|0)?(k=p,(c[k>>2]|0)==(e|0)?(c[k+4>>2]|0)==(f|0):0):0)?(a[b+100>>0]|0)==2:0)?(a[b+101>>0]|0)==0:0){f=h;c[f>>2]=l;c[f+4>>2]=m;CIb(b,4,d,h)}else{c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];DIb(b,2,d,j)}if(o){i=g;return}pTa(c[n+4>>2]|0);i=g;return}function SGb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h;l=QTa()|0;m=H;n=c[b+72>>2]|0;o=(n|0)==0;if(!o)oTa(c[n+4>>2]|0);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;p=k;c[p>>2]=e;c[p+4>>2]=f;c[k+8>>2]=g;a[k+12>>0]=0;a[k+13>>0]=0;p=k+16|0;c[p>>2]=l;c[p+4>>2]=m;p=b+88|0;if((((c[b+96>>2]|0)==(g|0)?(g=p,(c[g>>2]|0)==(e|0)?(c[g+4>>2]|0)==(f|0):0):0)?(a[b+100>>0]|0)==0:0)?(a[b+101>>0]|0)==0:0){f=j;c[f>>2]=l;c[f+4>>2]=m;AIb(b,3,d,j)}else{c[p+0>>2]=c[k+0>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];BIb(b,1,d,k)}if(o){i=h;return}pTa(c[n+4>>2]|0);i=h;return}function TGb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h;l=QTa()|0;m=H;n=c[b+72>>2]|0;o=(n|0)==0;if(!o)oTa(c[n+4>>2]|0);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;p=k;c[p>>2]=e;c[p+4>>2]=f;c[k+8>>2]=g;a[k+12>>0]=0;a[k+13>>0]=0;p=k+16|0;c[p>>2]=l;c[p+4>>2]=m;p=b+88|0;if((((c[b+96>>2]|0)==(g|0)?(g=p,(c[g>>2]|0)==(e|0)?(c[g+4>>2]|0)==(f|0):0):0)?(a[b+100>>0]|0)==0:0)?(a[b+101>>0]|0)==0:0){f=j;c[f>>2]=l;c[f+4>>2]=m;CIb(b,4,d,j)}else{c[p+0>>2]=c[k+0>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];DIb(b,2,d,k)}if(o){i=h;return}pTa(c[n+4>>2]|0);i=h;return}function UGb(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=i;i=i+32|0;m=l;n=l+24|0;o=d+72|0;p=c[o>>2]|0;q=(p|0)==0;if(!q)oTa(c[p+4>>2]|0);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;r=m+8|0;c[r>>2]=g;c[r+4>>2]=h;c[m+16>>2]=f;a[n>>0]=5;f=n+1|0;b[n+2>>1]=e;a[f>>0]=3;e=m;c[e>>2]=j;c[e+4>>2]=k;if(!(h>>>0<0|(h|0)==0&g>>>0<256))if(h>>>0<0|(h|0)==0&g>>>0<65536)s=7;else s=h>>>0<1|(h|0)==1&g>>>0<0?11:15;else s=3;a[f>>0]=s;s=d+80|0;EIb(n,s);FIb(m,s,n);n=d+20|0;s=c[n>>2]|0;m=d+16|0;f=c[m>>2]|0;if((s-f|0)>>>0>=(c[d+44>>2]|0)>>>0){g=c[o>>2]|0;o=(g|0)==0;if(o){t=s;u=f}else{oTa(c[g+4>>2]|0);t=c[n>>2]|0;u=c[m>>2]|0}f=t-u|0;t=c[d+36>>2]|0;if(!t)v=u;else{s=d+32|0;h=0;do{k=c[(c[s>>2]|0)+(h<<2)>>2]|0;co[c[(c[k>>2]|0)+8>>2]&2047](k,u,f);h=h+1|0}while((h|0)!=(t|0));v=c[m>>2]|0}c[n>>2]=v;ko[c[(c[d>>2]|0)+16>>2]&4095](d);if(!o)pTa(c[g+4>>2]|0)}if(q){i=l;return}pTa(c[p+4>>2]|0);i=l;return}function VGb(d,e,f,h,j,k,l){d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=i;i=i+32|0;n=m;o=m+24|0;p=d+72|0;q=c[p>>2]|0;r=(q|0)==0;if(!r)oTa(c[q+4>>2]|0);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;s=n;c[s>>2]=e;c[s+4>>2]=f;g[n+8>>2]=h;c[n+12>>2]=j;c[n+16>>2]=k;c[n+20>>2]=l;a[o>>0]=6;a[o+1>>0]=-1;b[o+2>>1]=0;l=d+20|0;j=c[l>>2]|0;f=d+16|0;s=c[f>>2]|0;e=d+44|0;if((j+k-s|0)>>>0>=(c[e>>2]|0)>>>0){k=c[p>>2]|0;t=(k|0)==0;if(t){u=j;v=s}else{oTa(c[k+4>>2]|0);u=c[l>>2]|0;v=c[f>>2]|0}s=u-v|0;u=c[d+36>>2]|0;if(!u)w=v;else{j=d+32|0;x=0;do{y=c[(c[j>>2]|0)+(x<<2)>>2]|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,v,s);x=x+1|0}while((x|0)!=(u|0));w=c[f>>2]|0}c[l>>2]=w;ko[c[(c[d>>2]|0)+16>>2]&4095](d);if(!t)pTa(c[k+4>>2]|0)}k=d+80|0;EIb(o,k);GIb(n,k,0);k=c[l>>2]|0;n=c[f>>2]|0;if((k-n|0)>>>0>=(c[e>>2]|0)>>>0){e=c[p>>2]|0;p=(e|0)==0;if(p){z=k;A=n}else{oTa(c[e+4>>2]|0);z=c[l>>2]|0;A=c[f>>2]|0}n=z-A|0;z=c[d+36>>2]|0;if(!z)B=A;else{k=d+32|0;o=0;do{t=c[(c[k>>2]|0)+(o<<2)>>2]|0;co[c[(c[t>>2]|0)+8>>2]&2047](t,A,n);o=o+1|0}while((o|0)!=(z|0));B=c[f>>2]|0}c[l>>2]=B;ko[c[(c[d>>2]|0)+16>>2]&4095](d);if(!p)pTa(c[e+4>>2]|0)}if(r){i=m;return}pTa(c[q+4>>2]|0);i=m;return}function WGb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;c[b>>2]=527328;e=b+36|0;f=c[e>>2]|0;if(f){g=b+32|0;h=b+72|0;j=b+76|0;k=f;do{f=c[c[g>>2]>>2]|0;l=c[h>>2]|0;m=(l|0)==0;if(m)n=k;else{oTa(c[l+4>>2]|0);n=c[e>>2]|0}a:do if(!n)o=0;else{p=c[g>>2]|0;q=0;while(1){r=q+1|0;if((c[p+(q<<2)>>2]|0)==(f|0))break;if(r>>>0<n>>>0)q=r;else{o=n;break a}}ko[c[(c[f>>2]|0)+12>>2]&4095](f);p=(c[e>>2]|0)+-1|0;c[e>>2]=p;r=c[g>>2]|0;c[r+(q<<2)>>2]=c[r+(p<<2)>>2];o=p}while(0);a[j>>0]=(o|0)!=0&1;if(!m)pTa(c[l+4>>2]|0);k=c[e>>2]|0}while((k|0)!=0)}k=c[b+40>>2]|0;if((k&2147483647|0)!=0&(k|0)>-1?(k=c[b+32>>2]|0,(k|0)!=0):0){e=c[c[b+28>>2]>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,k)}k=c[b+16>>2]|0;if(!k){i=d;return}e=c[c[b+8>>2]>>2]|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,k);i=d;return}function XGb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=0,x=0,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im;f=i;i=i+64|0;h=f+16|0;j=f;k=f+44|0;l=f+32|0;if(!(c[a+196>>2]|0)){IIb(a,b,d,e);i=f;return}else{m=ea(g[b>>2]);n=b+4|0;o=ea(g[n>>2]);p=b+8|0;q=ea(g[p>>2]);r=a+96|0;s=ea(m*ea(g[r>>2]));t=a+100|0;u=ea(s+ea(o*ea(g[t>>2])));v=a+104|0;s=ea(u+ea(q*ea(g[v>>2])));w=a+112|0;u=ea(m*ea(g[w>>2]));x=a+116|0;y=ea(u+ea(o*ea(g[x>>2])));z=a+120|0;u=ea(y+ea(q*ea(g[z>>2])));A=a+128|0;y=ea(m*ea(g[A>>2]));B=a+132|0;m=ea(y+ea(o*ea(g[B>>2])));C=a+136|0;o=ea(m+ea(q*ea(g[C>>2])));g[h>>2]=s;D=h+4|0;g[D>>2]=u;E=h+8|0;g[E>>2]=o;g[h+12>>2]=ea(0.0);F=DFb(a,h)|0;o=ea(g[h>>2]);u=ea(g[D>>2]);s=ea(-u);u=ea(-ea(g[E>>2]));g[j>>2]=ea(-o);g[j+4>>2]=s;g[j+8>>2]=u;g[j+12>>2]=ea(0.0);E=DFb(a,j)|0;j=c[a+200>>2]|0;u=ea(g[j+(F*12|0)>>2]);s=ea(g[j+(F*12|0)+4>>2]);o=ea(g[j+(F*12|0)+8>>2]);q=ea(g[r>>2]);m=ea(u*q);y=ea(g[w>>2]);G=ea(m+ea(s*y));m=ea(g[A>>2]);H=ea(G+ea(o*m));G=ea(g[t>>2]);I=ea(u*G);J=ea(g[x>>2]);K=ea(I+ea(s*J));I=ea(g[B>>2]);L=ea(K+ea(o*I));K=ea(g[v>>2]);M=ea(u*K);u=ea(g[z>>2]);N=ea(M+ea(s*u));s=ea(g[C>>2]);M=ea(N+ea(o*s));o=ea(g[j+(E*12|0)>>2]);N=ea(g[j+(E*12|0)+4>>2]);O=ea(g[j+(E*12|0)+8>>2]);P=ea(ea(ea(q*o)+ea(y*N))+ea(m*O));m=ea(ea(ea(G*o)+ea(J*N))+ea(I*O));I=ea(ea(ea(K*o)+ea(u*N))+ea(s*O));O=ea(g[b>>2]);s=ea(g[n>>2]);g[d>>2]=ea(ea(ea(O*P)+ea(s*m))+ea(I*ea(g[p>>2])));E=d+4|0;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];I=ea(g[b>>2]);m=ea(g[n>>2]);g[e>>2]=ea(ea(ea(H*I)+ea(L*m))+ea(M*ea(g[p>>2])));p=e+4|0;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];i=f;return}}function YGb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;h=i;i=i+96|0;j=h+28|0;k=h+52|0;l=h+64|0;m=h+76|0;n=h;o=h+16|0;p=h+40|0;if(c[a+196>>2]|0){q=DFb(a,b)|0;r=ea(g[b>>2]);s=b+4|0;t=ea(g[s>>2]);u=b+8|0;v=ea(-t);t=ea(-ea(g[u>>2]));g[n>>2]=ea(-r);g[n+4>>2]=v;g[n+8>>2]=t;g[n+12>>2]=ea(0.0);w=DFb(a,n)|0;n=c[a+200>>2]|0;t=ea(g[n+(q*12|0)>>2]);v=ea(g[n+(q*12|0)+4>>2]);r=ea(g[n+(q*12|0)+8>>2]);x=ea(g[n+(w*12|0)>>2]);y=ea(g[n+(w*12|0)+4>>2]);z=ea(g[n+(w*12|0)+8>>2]);A=ea(g[b>>2]);B=ea(g[s>>2]);g[e>>2]=ea(ea(ea(x*A)+ea(y*B))+ea(z*ea(g[u>>2])));w=e+4|0;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];z=ea(g[b>>2]);B=ea(g[s>>2]);g[f>>2]=ea(ea(ea(t*z)+ea(v*B))+ea(r*ea(g[u>>2])));u=f+4|0;c[u+0>>2]=c[p+0>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];i=h;return}p=a+200|0;u=c[p>>2]|0;r=ea(g[u>>2]);B=ea(g[u+4>>2]);v=ea(g[u+8>>2]);z=ea(g[b>>2]);s=b+4|0;t=ea(g[s>>2]);o=b+8|0;y=ea(ea(ea(r*z)+ea(B*t))+ea(v*ea(g[o>>2])));c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];w=a+204|0;if((d[w>>0]|0)>1){v=y;a=u;t=y;u=1;while(1){n=c[p>>2]|0;B=ea(g[n+(u*12|0)>>2]);z=ea(g[n+(u*12|0)+4>>2]);r=ea(g[n+(u*12|0)+8>>2]);A=ea(g[b>>2]);x=ea(g[s>>2]);C=ea(ea(ea(B*A)+ea(z*x))+ea(r*ea(g[o>>2])));r=C>t?C:t;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];x=C>v?v:C;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];q=u+1|0;if(q>>>0<(d[w>>0]|0)>>>0){v=x;a=n;t=r;u=q}else{D=x;E=r;break}}}else{D=y;E=y}g[e>>2]=D;u=e+4|0;c[u+0>>2]=c[k+0>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];g[f>>2]=E;k=f+4|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];i=h;return}function ZGb(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;h=i;j=ea(g[d>>2]);k=ea(g[c>>2]);l=ea(j-k);j=ea(g[d+4>>2]);m=ea(g[c+4>>2]);n=ea(j-m);j=ea(g[d+8>>2]);o=ea(g[c+8>>2]);p=ea(j-o);j=ea(ea(g[e>>2])-k);q=ea(ea(g[e+4>>2])-m);r=ea(ea(g[e+8>>2])-o);s=ea(g[b+16>>2]);t=ea(s*r);u=ea(g[b+20>>2]);v=ea(t-ea(q*u));t=ea(j*u);w=ea(g[b+12>>2]);x=ea(t-ea(r*w));t=ea(ea(q*w)-ea(j*s));y=ea(ea(p*t)+ea(ea(l*v)+ea(n*x)));z=ea(g[b+28>>2]);if(!(a[b+24>>0]|0)){if(y<z){A=0;i=h;return A|0}B=ea(ea(g[b>>2])-k);C=ea(ea(g[b+4>>2])-m);D=ea(ea(g[b+8>>2])-o);E=ea(ea(ea(v*B)+ea(x*C))+ea(t*D));F=ea(-z);if(E<F){A=0;i=h;return A|0}G=ea(z+y);if(E>G){A=0;i=h;return A|0}H=ea(ea(p*C)-ea(n*D));I=ea(ea(l*D)-ea(p*B));D=ea(ea(n*B)-ea(l*C));C=ea(ea(u*D)+ea(ea(w*H)+ea(s*I)));if(C<F|ea(E+C)>G){A=0;i=h;return A|0}G=ea(ea(r*D)+ea(ea(j*H)+ea(q*I)));if(G<F){A=0;i=h;return A|0}F=ea(ea(1.0)/y);g[f+40>>2]=ea(G*F);g[f+44>>2]=ea(E*F);g[f+48>>2]=ea(C*F);A=1;i=h;return A|0}else{if(ea(S(ea(y)))<z){A=0;i=h;return A|0}F=ea(ea(1.0)/y);y=ea(ea(g[b>>2])-k);k=ea(ea(g[b+4>>2])-m);m=ea(ea(g[b+8>>2])-o);o=ea(F*ea(ea(ea(v*y)+ea(x*k))+ea(t*m)));t=ea(-z);if(o<t){A=0;i=h;return A|0}x=ea(z+ea(1.0));if(o>x){A=0;i=h;return A|0}z=ea(ea(p*k)-ea(n*m));v=ea(ea(l*m)-ea(p*y));p=ea(ea(n*y)-ea(l*k));k=ea(F*ea(ea(u*p)+ea(ea(w*z)+ea(s*v))));if(k<t|ea(o+k)>x){A=0;i=h;return A|0}x=ea(F*ea(ea(r*p)+ea(ea(j*z)+ea(q*v))));if(x<t){A=0;i=h;return A|0}g[f+40>>2]=x;g[f+44>>2]=o;g[f+48>>2]=k;A=1;i=h;return A|0}return 0}function _Gb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+76>>2]&2147483647)>>>0<b>>>0)JIb(a,b);f=c[a+68>>2]|0;g=a+72|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function $Gb(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=0,h=Im,i=Im,j=0,k=Im,l=Im,m=0,n=0,o=Im,p=Im,q=0,r=Im,s=Im,t=0,u=Im,v=Im,w=0,x=0,y=0,z=Im,A=0,B=Im,C=Im,D=0,E=0,F=Im,G=0,H=0,I=Im,J=Im,K=0,L=Im,M=0,N=Im,O=Im,P=Im;c=ea(g[a>>2]);d=ea(g[b>>2]);e=ea(c*d);f=b+4|0;h=ea(g[f>>2]);i=ea(c*h);j=b+8|0;k=ea(g[j>>2]);l=ea(c*k);m=a+4|0;c=ea(g[m>>2]);n=b+12|0;o=ea(g[n>>2]);p=ea(c*o);q=b+16|0;r=ea(g[q>>2]);s=ea(c*r);t=b+20|0;u=ea(g[t>>2]);v=ea(e+p);p=ea(i+s);s=ea(l+ea(c*u));w=a+8|0;c=ea(g[w>>2]);x=b+24|0;l=ea(g[x>>2]);i=ea(c*l);y=b+28|0;e=ea(g[y>>2]);z=ea(c*e);A=b+32|0;B=ea(g[A>>2]);C=ea(v+i);i=ea(p+z);z=ea(s+ea(c*B));D=a+12|0;c=ea(g[D>>2]);s=ea(d*c);p=ea(h*c);v=ea(k*c);E=a+16|0;c=ea(g[E>>2]);F=ea(s+ea(o*c));s=ea(p+ea(r*c));p=ea(v+ea(u*c));G=a+20|0;c=ea(g[G>>2]);v=ea(F+ea(l*c));F=ea(s+ea(e*c));s=ea(p+ea(B*c));H=a+24|0;c=ea(g[H>>2]);p=ea(d*c);I=ea(h*c);J=ea(k*c);K=a+28|0;c=ea(g[K>>2]);L=ea(p+ea(o*c));p=ea(I+ea(r*c));I=ea(J+ea(u*c));M=a+32|0;c=ea(g[M>>2]);J=ea(L+ea(l*c));L=ea(p+ea(e*c));p=ea(I+ea(B*c));c=ea(ea(ea(d*i)+ea(o*F))+ea(l*L));I=ea(ea(ea(d*z)+ea(o*s))+ea(l*p));N=ea(ea(ea(h*C)+ea(r*v))+ea(e*J));O=ea(ea(ea(h*i)+ea(r*F))+ea(e*L));P=ea(ea(ea(h*z)+ea(r*s))+ea(e*p));e=ea(ea(ea(k*C)+ea(u*v))+ea(B*J));r=ea(ea(ea(k*i)+ea(u*F))+ea(B*L));L=ea(ea(ea(k*z)+ea(u*s))+ea(B*p));g[a>>2]=ea(ea(ea(d*C)+ea(o*v))+ea(l*J));g[m>>2]=c;g[w>>2]=I;g[D>>2]=N;g[E>>2]=O;g[G>>2]=P;g[H>>2]=e;g[K>>2]=r;g[M>>2]=L;M=a+36|0;L=ea(g[M>>2]);r=ea(L*ea(g[b>>2]));e=ea(L*ea(g[f>>2]));P=ea(L*ea(g[j>>2]));j=a+40|0;L=ea(g[j>>2]);O=ea(L*ea(g[n>>2]));N=ea(L*ea(g[q>>2]));I=ea(r+O);O=ea(e+N);N=ea(P+ea(L*ea(g[t>>2])));t=a+44|0;L=ea(g[t>>2]);P=ea(L*ea(g[x>>2]));e=ea(L*ea(g[y>>2]));r=ea(O+e);e=ea(N+ea(L*ea(g[A>>2])));g[M>>2]=ea(I+P);g[j>>2]=r;g[t>>2]=e;return}function aHb(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=ea(g[c>>2]);e=ea(g[c+4>>2]);f=ea(g[c+8>>2]);h=ea(g[c+12>>2]);i=ea(d+d);j=ea(e+e);k=ea(f+f);l=ea(e*j);m=ea(f*k);n=ea(i*e);e=ea(i*f);o=ea(i*h);p=ea(j*f);f=ea(j*h);j=ea(k*h);h=ea(ea(ea(1.0)-l)-m);k=ea(n+j);q=ea(e-f);r=ea(n-j);j=ea(ea(1.0)-ea(d*i));i=ea(j-m);m=ea(p+o);d=ea(e+f);f=ea(p-o);o=ea(j-l);l=ea(g[b>>2]);j=ea(l*h);p=ea(l*k);e=ea(l*q);l=ea(g[b+4>>2]);n=ea(j+ea(l*r));j=ea(p+ea(l*i));p=ea(e+ea(l*m));l=ea(g[b+8>>2]);e=ea(n+ea(d*l));n=ea(j+ea(f*l));j=ea(p+ea(o*l));l=ea(g[b+12>>2]);p=ea(h*l);s=ea(k*l);t=ea(q*l);l=ea(g[b+16>>2]);u=ea(p+ea(r*l));p=ea(s+ea(i*l));s=ea(t+ea(m*l));l=ea(g[b+20>>2]);t=ea(u+ea(d*l));u=ea(p+ea(f*l));p=ea(s+ea(o*l));l=ea(g[b+24>>2]);s=ea(h*l);v=ea(k*l);w=ea(q*l);l=ea(g[b+28>>2]);x=ea(s+ea(r*l));s=ea(v+ea(i*l));v=ea(w+ea(m*l));l=ea(g[b+32>>2]);w=ea(x+ea(d*l));x=ea(s+ea(f*l));s=ea(v+ea(o*l));l=ea(ea(ea(h*n)+ea(r*u))+ea(d*x));v=ea(ea(ea(h*j)+ea(r*p))+ea(d*s));y=ea(ea(ea(k*e)+ea(i*t))+ea(f*w));z=ea(ea(ea(k*n)+ea(i*u))+ea(f*x));A=ea(ea(ea(k*j)+ea(i*p))+ea(f*s));f=ea(ea(ea(q*e)+ea(m*t))+ea(o*w));i=ea(ea(ea(q*n)+ea(m*u))+ea(o*x));x=ea(ea(ea(q*j)+ea(m*p))+ea(o*s));g[a>>2]=ea(ea(ea(h*e)+ea(r*t))+ea(d*w));g[a+4>>2]=l;g[a+8>>2]=v;g[a+12>>2]=y;g[a+16>>2]=z;g[a+20>>2]=A;g[a+24>>2]=f;g[a+28>>2]=i;g[a+32>>2]=x;return}function bHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[d>>2]|0;j=g+0|0;k=j+128|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));c[f>>2]=h;TUa(g,0,515888,f)|0;if(a[g>>0]|0){h=c[c[b>>2]>>2]|0;l=SEi(g|0)|0;xo[h&2047](b,g,l)|0}xo[c[c[b>>2]>>2]&2047](b,1076904,1)|0;l=c[d+4>>2]|0;j=g+0|0;k=j+128|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));c[f>>2]=l;TUa(g,0,515888,f)|0;if(a[g>>0]|0){l=c[c[b>>2]>>2]|0;h=SEi(g|0)|0;xo[l&2047](b,g,h)|0}xo[c[c[b>>2]>>2]&2047](b,1076904,1)|0;h=c[d+8>>2]|0;j=g+0|0;k=j+128|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));c[f>>2]=h;TUa(g,0,515888,f)|0;if(a[g>>0]|0){h=c[c[b>>2]>>2]|0;l=SEi(g|0)|0;xo[h&2047](b,g,l)|0}xo[c[c[b>>2]>>2]&2047](b,1076904,1)|0;l=c[d+12>>2]|0;j=g+0|0;k=j+128|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));c[f>>2]=l;TUa(g,0,515888,f)|0;if(!(a[g>>0]|0)){i=e;return b|0}f=c[c[b>>2]>>2]|0;l=SEi(g|0)|0;xo[f&2047](b,g,l)|0;i=e;return b|0}function cHb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+12|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else{f=c[c[a>>2]>>2]|0;h=Bn[c[(c[f>>2]|0)+8>>2]&255](f,g<<3,527016,537640,558)|0}f=a+8|0;j=c[f>>2]|0;k=h+(j<<3)|0;l=a+4|0;if((j|0)>0){m=h;n=c[l>>2]|0;while(1){if(m){o=n;p=c[o+4>>2]|0;q=m;c[q>>2]=c[o>>2];c[q+4>>2]=p}m=m+8|0;if(m>>>0>=k>>>0)break;else n=n+8|0}r=c[f>>2]|0}else r=j;j=h+(r<<3)|0;if(j){r=b;b=c[r+4>>2]|0;n=j;c[n>>2]=c[r>>2];c[n+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[l>>2]|0,(b|0)!=0):0){n=c[c[a>>2]>>2]|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,b)}c[l>>2]=h;c[e>>2]=g;g=c[f>>2]|0;c[f>>2]=g+1;i=d;return h+(g<<3)|0}function dHb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)KIb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function eHb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)LIb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function fHb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(c[b+280>>2]|0)MIb(b);e=b+264|0;f=c[e>>2]|0;g=c[b+268>>2]|0;h=f+(g<<2)|0;if(g){g=f;do{f=c[g>>2]|0;if(f){j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,f)}g=g+4|0}while((g|0)!=(h|0))}h=c[b+272>>2]|0;if(!((h&2147483647|0)!=0&(h|0)>-1)){i=d;return}h=c[e>>2]|0;if((b+4|0)==(h|0)){a[b+260>>0]=0;i=d;return}if(!h){i=d;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);i=d;return}function gHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+4|0;e=b;f=o2()|0;Zba(a+16|0)|0;g=f+-16|0;h=R_(a,e)|0;if(!h){i=b;return}j=f+-12|0;f=(c[a>>2]|0)+2448|0;a=0;do{k=c[(c[e>>2]|0)+(a<<2)>>2]|0;l=k+g|0;m=k+j|0;k=c[m>>2]|0;if(!(k&268435456))n=k;else{A4(l);c[d>>2]=l;TWa(f,d)|0;n=c[m>>2]|0}if((n&251658240|0)==16777216){c[m>>2]=n&1073741823;c[l>>2]=0}a=a+1|0}while((a|0)!=(h|0));i=b;return}function hHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+4|0;e=b;f=o2()|0;Zba(a+16|0)|0;g=f+-16|0;h=E_(a,e)|0;if(!h){i=b;return}j=f+-12|0;f=(c[a>>2]|0)+2448|0;a=0;do{k=c[(c[e>>2]|0)+(a<<2)>>2]|0;l=k+g|0;m=k+j|0;k=c[m>>2]|0;if(!(k&268435456))n=k;else{A4(l);c[d>>2]=l;TWa(f,d)|0;n=c[m>>2]|0}if((n&251658240|0)==16777216){c[m>>2]=n&1073741823;c[l>>2]=0}a=a+1|0}while((a|0)!=(h|0));i=b;return}function iHb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+28>>2]&2147483647)>>>0<b>>>0)jHb(a,b);f=c[a+20>>2]|0;g=a+24|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function jHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<2;h=b+16|0;if(!((a[h>>0]|0)==0&g>>>0<17))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?452136:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+24>>2]|0;h=f+(j<<2)|0;n=b+20|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j)c[j>>2]=c[g>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else g=g+4|0}}g=b+28|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+16>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function kHb(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+32|0;j=h+20|0;k=h;l=(f+d|0)/2|0;m=a+(l*40|0)|0;n=a+(d*40|0)|0;if(_n[c[g>>2]&4095](m,n)|0){o=a+(d*40|0)+4|0;p=o;q=p;r=e[q>>1]|e[q+2>>1]<<16;q=p+4|0;p=e[q>>1]|e[q+2>>1]<<16;q=a+(d*40|0)+12|0;s=a+(d*40|0)+16|0;c[j>>2]=c[s>>2];t=c[q>>2]|0;u=a+(d*40|0)+20|0;c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[k+12>>2]=c[u+12>>2];c[k+16>>2]=c[u+16>>2];v=a+(l*40|0)+4|0;w=v;x=w;y=e[x>>1]|e[x+2>>1]<<16;x=w+4|0;w=e[x>>1]|e[x+2>>1]<<16;x=o;o=x;b[o>>1]=y;b[o+2>>1]=y>>>16;y=x+4|0;b[y>>1]=w;b[y+2>>1]=w>>>16;w=a+(l*40|0)+12|0;c[q>>2]=c[w>>2];q=a+(l*40|0)+16|0;c[s>>2]=c[q>>2];s=a+(l*40|0)+20|0;c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];c[u+12>>2]=c[s+12>>2];c[u+16>>2]=c[s+16>>2];u=v;v=u;b[v>>1]=r;b[v+2>>1]=r>>>16;r=u+4|0;b[r>>1]=p;b[r+2>>1]=p>>>16;c[w>>2]=t;c[q>>2]=c[j>>2];c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];c[s+12>>2]=c[k+12>>2];c[s+16>>2]=c[k+16>>2]}s=a+(f*40|0)|0;if(_n[c[g>>2]&4095](s,n)|0){n=a+(d*40|0)+4|0;q=n;t=q;w=e[t>>1]|e[t+2>>1]<<16;t=q+4|0;q=e[t>>1]|e[t+2>>1]<<16;t=a+(d*40|0)+12|0;p=a+(d*40|0)+16|0;c[j>>2]=c[p>>2];r=c[t>>2]|0;u=a+(d*40|0)+20|0;c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[k+12>>2]=c[u+12>>2];c[k+16>>2]=c[u+16>>2];d=a+(f*40|0)+4|0;v=d;y=v;x=e[y>>1]|e[y+2>>1]<<16;y=v+4|0;v=e[y>>1]|e[y+2>>1]<<16;y=n;n=y;b[n>>1]=x;b[n+2>>1]=x>>>16;x=y+4|0;b[x>>1]=v;b[x+2>>1]=v>>>16;v=a+(f*40|0)+12|0;c[t>>2]=c[v>>2];t=a+(f*40|0)+16|0;c[p>>2]=c[t>>2];p=a+(f*40|0)+20|0;c[u+0>>2]=c[p+0>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];c[u+12>>2]=c[p+12>>2];c[u+16>>2]=c[p+16>>2];u=d;d=u;b[d>>1]=w;b[d+2>>1]=w>>>16;w=u+4|0;b[w>>1]=q;b[w+2>>1]=q>>>16;c[v>>2]=r;c[t>>2]=c[j>>2];c[p+0>>2]=c[k+0>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];c[p+16>>2]=c[k+16>>2]}if(_n[c[g>>2]&4095](s,m)|0){m=a+(l*40|0)+4|0;s=m;g=s;p=e[g>>1]|e[g+2>>1]<<16;g=s+4|0;s=e[g>>1]|e[g+2>>1]<<16;g=a+(l*40|0)+12|0;t=a+(l*40|0)+16|0;c[j>>2]=c[t>>2];r=c[g>>2]|0;v=a+(l*40|0)+20|0;c[k+0>>2]=c[v+0>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];c[k+16>>2]=c[v+16>>2];q=a+(f*40|0)+4|0;w=q;u=w;d=e[u>>1]|e[u+2>>1]<<16;u=w+4|0;w=e[u>>1]|e[u+2>>1]<<16;u=m;x=u;b[x>>1]=d;b[x+2>>1]=d>>>16;d=u+4|0;b[d>>1]=w;b[d+2>>1]=w>>>16;w=a+(f*40|0)+12|0;c[g>>2]=c[w>>2];d=a+(f*40|0)+16|0;c[t>>2]=c[d>>2];u=a+(f*40|0)+20|0;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];x=q;q=x;b[q>>1]=p;b[q+2>>1]=p>>>16;p=x+4|0;b[p>>1]=s;b[p+2>>1]=s>>>16;c[w>>2]=r;c[d>>2]=c[j>>2];c[u+0>>2]=c[k+0>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];c[u+12>>2]=c[k+12>>2];c[u+16>>2]=c[k+16>>2];z=g;A=t;B=v;C=m}else{z=a+(l*40|0)+12|0;A=a+(l*40|0)+16|0;B=a+(l*40|0)+20|0;C=a+(l*40|0)+4|0}l=f+-1|0;f=C;m=f;v=e[m>>1]|e[m+2>>1]<<16;m=f+4|0;f=e[m>>1]|e[m+2>>1]<<16;c[j>>2]=c[A>>2];m=c[z>>2]|0;c[k+0>>2]=c[B+0>>2];c[k+4>>2]=c[B+4>>2];c[k+8>>2]=c[B+8>>2];c[k+12>>2]=c[B+12>>2];c[k+16>>2]=c[B+16>>2];t=a+(l*40|0)+4|0;g=t;u=g;d=e[u>>1]|e[u+2>>1]<<16;u=g+4|0;g=e[u>>1]|e[u+2>>1]<<16;u=C;C=u;b[C>>1]=d;b[C+2>>1]=d>>>16;d=u+4|0;b[d>>1]=g;b[d+2>>1]=g>>>16;g=a+(l*40|0)+12|0;c[z>>2]=c[g>>2];z=a+(l*40|0)+16|0;c[A>>2]=c[z>>2];A=a+(l*40|0)+20|0;c[B+0>>2]=c[A+0>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];c[B+12>>2]=c[A+12>>2];c[B+16>>2]=c[A+16>>2];B=t;t=B;b[t>>1]=v;b[t+2>>1]=v>>>16;v=B+4|0;b[v>>1]=f;b[v+2>>1]=f>>>16;c[g>>2]=m;c[z>>2]=c[j>>2];c[A+0>>2]=c[k+0>>2];c[A+4>>2]=c[k+4>>2];c[A+8>>2]=c[k+8>>2];c[A+12>>2]=c[k+12>>2];c[A+16>>2]=c[k+16>>2];i=h;return}function lHb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else h=UJa(a,g<<3,537640,558)|0;f=a+4|0;j=c[f>>2]|0;k=h+(j<<3)|0;if((j|0)>0){l=h;m=c[a>>2]|0;while(1){if(l){n=m;o=c[n+4>>2]|0;p=l;c[p>>2]=c[n>>2];c[p+4>>2]=o}l=l+8|0;if(l>>>0>=k>>>0)break;else m=m+8|0}q=c[f>>2]|0}else q=j;j=h+(q<<3)|0;if(j){q=b;b=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=b}if((c[e>>2]|0)<=-1){c[a>>2]=h;c[e>>2]=g;r=c[f>>2]|0;s=r+1|0;c[f>>2]=s;t=h+(r<<3)|0;i=d;return t|0}VJa(a,c[a>>2]|0);c[a>>2]=h;c[e>>2]=g;r=c[f>>2]|0;s=r+1|0;c[f>>2]=s;t=h+(r<<3)|0;i=d;return t|0}function mHb(a,d,e,f,h,j,k,l,m,n,o,p,q,r,s){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=Im,B=0,C=0,D=Im,E=Im,F=0,G=Im,H=0,I=Im,J=Im,K=Im,L=0,M=Im,N=0,O=0,P=0,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=Im,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im;t=i;i=i+48|0;u=t+24|0;v=t+12|0;w=t;x=ea(g[d>>2]);g[u>>2]=x;y=u+4|0;z=d+4|0;A=ea(g[z>>2]);g[y>>2]=A;B=u+8|0;C=d+8|0;D=ea(g[C>>2]);g[B>>2]=D;E=ea(ea(g[a>>2])+x);F=a+4|0;G=ea(ea(g[F>>2])+A);H=a+8|0;I=ea(D+ea(g[H>>2]));J=ea(g[k>>2]);K=ea(E*J);L=k+4|0;M=ea(K+ea(G*ea(g[L>>2])));N=k+8|0;K=ea(M+ea(I*ea(g[N>>2])));do if(!(b[s+2>>1]&2)){O=k+12|0;if(!(K<ea(g[O>>2]))){P=0;i=t;return P|0}c[f>>2]=m;g[h>>2]=J;g[h+4>>2]=ea(g[L>>2]);g[h+8>>2]=ea(g[N>>2]);g[j>>2]=ea(g[o>>2]);g[j+4>>2]=ea(g[o+4>>2]);g[j+8>>2]=ea(g[o+8>>2]);M=ea(g[r+68>>2]);Q=ea(M*A);R=ea(M*D);g[v>>2]=ea(M*x);g[v+4>>2]=Q;g[v+8>>2]=R;y0a(u,v,e,k,o,q,r);R=ea(g[r+64>>2]);Q=ea(R*ea(g[u>>2]));g[u>>2]=Q;M=ea(R*ea(g[y>>2]));g[y>>2]=M;U=ea(R*ea(g[B>>2]));g[B>>2]=U;R=ea(g[a>>2]);V=ea(R+Q);W=ea(g[F>>2]);X=ea(W+M);Y=ea(g[H>>2]);Z=ea(U+Y);_=ea(g[k>>2]);$=ea(V*_);aa=ea(g[L>>2]);ba=ea($+ea(X*aa));$=ea(g[N>>2]);ca=ea(ba+ea(Z*$));ba=ea(g[O>>2]);if(ba>ca){da=ea(ea(ba-ca)*ea(1.00999999));ca=ea(ea(V+ea(_*da))-R);R=ea(ea(X+ea(aa*da))-W);W=ea(ea(Z+ea($*da))-Y);g[u>>2]=ca;g[y>>2]=R;g[B>>2]=W;fa=ca;ga=R;ha=W;ia=21}else{ja=Q;ka=M;la=U}}else{U=ea(g[l>>2]);M=ea(E*U);O=l+4|0;Q=ea(M+ea(G*ea(g[O>>2])));ma=l+8|0;M=ea(Q+ea(I*ea(g[ma>>2])));na=k+12|0;oa=K<ea(g[na>>2]);pa=l+12|0;qa=M<ea(g[pa>>2]);do if(!oa)if(qa){c[f>>2]=n;g[h>>2]=U;g[h+4>>2]=ea(g[O>>2]);g[h+8>>2]=ea(g[ma>>2]);g[j>>2]=ea(g[p>>2]);g[j+4>>2]=ea(g[p+4>>2]);g[j+8>>2]=ea(g[p+8>>2]);break}else{P=0;i=t;return P|0}else{c[f>>2]=m;g[h>>2]=J;g[h+4>>2]=ea(g[L>>2]);g[h+8>>2]=ea(g[N>>2]);g[j>>2]=ea(g[o>>2]);g[j+4>>2]=ea(g[o+4>>2]);g[j+8>>2]=ea(g[o+8>>2])}while(0);if(oa&qa){U=ea(ea(1.0)-ea(g[r+20>>2]));M=ea(x*U);g[u>>2]=M;Q=ea(U*A);g[y>>2]=Q;ra=M;sa=Q;ta=ea(U*D)}else{U=ea(g[r+68>>2]);Q=ea(U*A);M=ea(U*D);g[w>>2]=ea(U*x);g[w+4>>2]=Q;g[w+8>>2]=M;y0a(u,w,e,h,j,q,r);M=ea(g[r+64>>2]);Q=ea(M*ea(g[u>>2]));g[u>>2]=Q;U=ea(M*ea(g[y>>2]));g[y>>2]=U;ra=Q;sa=U;ta=ea(M*ea(g[B>>2]))}g[B>>2]=ta;M=ea(g[a>>2]);U=ea(M+ra);Q=ea(g[F>>2]);W=ea(Q+sa);R=ea(g[H>>2]);ca=ea(R+ta);Y=ea(g[k>>2]);da=ea(U*Y);$=ea(g[L>>2]);Z=ea(da+ea(W*$));da=ea(g[N>>2]);aa=ea(Z+ea(ca*da));Z=ea(g[l>>2]);X=ea(Y*Z);_=ea(g[O>>2]);V=ea(X+ea($*_));X=ea(g[ma>>2]);ba=ea(V+ea(da*X));if(ea(S(ea(ba)))>ea(.999998986)){V=ea(g[na>>2]);if(!(aa<V)){ja=ra;ka=sa;la=ta;break}ua=ea(ea(V-aa)*ea(1.00999999));V=ea(ea(U+ea(Y*ua))-M);va=ea(ea(W+ea($*ua))-Q);wa=ea(ea(ca+ea(da*ua))-R);g[u>>2]=V;g[y>>2]=va;g[B>>2]=wa;fa=V;ga=va;ha=wa;ia=21;break}wa=ea(ea(ea(U*Z)+ea(W*_))+ea(ca*X));va=ea(g[na>>2]);V=ea(va-aa);ua=ea(g[pa>>2]);xa=ea(ua-wa);if(aa<va|wa<ua){if(!(ea(ea(ea(ea(U+ea(Z*xa))*Y)+ea(ea(W+ea(_*xa))*$))+ea(ea(ca+ea(X*xa))*da))<va)){va=ea(xa*ea(1.00010002));wa=ea(ea(U+ea(va*Z))-M);aa=ea(ea(W+ea(va*_))-Q);ya=ea(ea(ca+ea(va*X))-R);g[u>>2]=wa;g[y>>2]=aa;g[B>>2]=ya;fa=wa;ga=aa;ha=ya;ia=21;break}if(ea(ea(ea(ea(U+ea(Y*V))*Z)+ea(ea(W+ea($*V))*_))+ea(ea(ca+ea(da*V))*X))<ua){ua=ea(ea(1.0)/ea(ea(1.0)-ea(ba*ba)));ya=ea(ea(V-ea(ba*xa))*ua);aa=ea(ea(xa-ea(ba*V))*ua);ua=ea(ea(U+ea(ea(Y*ya)+ea(Z*aa)))-M);ba=ea(ea(W+ea(ea($*ya)+ea(_*aa)))-Q);xa=ea(ea(ca+ea(ea(da*ya)+ea(X*aa)))-R);aa=ea(ea(xa*xa)+ea(ea(ua*ua)+ea(ba*ba)));ya=ea(ea(ea(ea($+_)*ea(.5))*ea(.0000999999974))*aa);_=ea(ea(ea(ea(da+X)*ea(.5))*ea(.0000999999974))*aa);X=ea(ua+ea(ea(ea(ea(Y+Z)*ea(.5))*ea(.0000999999974))*aa));g[u>>2]=X;aa=ea(ba+ya);g[y>>2]=aa;ya=ea(xa+_);g[B>>2]=ya;fa=X;ga=aa;ha=ya;ia=21;break}else{ya=ea(V*ea(1.00010002));V=ea(ea(U+ea(ya*Y))-M);M=ea(ea(W+ea(ya*$))-Q);Q=ea(ea(ca+ea(ya*da))-R);g[u>>2]=V;g[y>>2]=M;g[B>>2]=Q;fa=V;ga=M;ha=Q;ia=21;break}}else{ja=ra;ka=sa;la=ta}}while(0);if((ia|0)==21){ta=ea(g[d>>2]);sa=ea(ta*ta);ta=ea(g[z>>2]);ra=ea(sa+ea(ta*ta));ta=ea(g[C>>2]);sa=ea(ra+ea(ta*ta));ta=ea(ea(ea(fa*fa)+ea(ga*ga))+ea(ha*ha));if(ta>sa){ra=ea(ea(T(ea(sa)))*ea(ea(1.0)/ea(T(ea(ta)))));ta=ea(fa*ra);g[u>>2]=ta;sa=ea(ga*ra);g[y>>2]=sa;x=ea(ra*ha);g[B>>2]=x;ja=ta;ka=sa;la=x}else{ja=fa;ka=ga;la=ha}}g[d>>2]=ja;g[z>>2]=ka;g[C>>2]=la;P=1;i=t;return P|0}function nHb(a,b,c,d,e,f,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im;l=ea(g[c>>2]);m=ea(g[c+4>>2]);n=ea(g[c+8>>2]);o=ea(g[c+12>>2]);p=ea(g[d>>2]);q=ea(g[d+4>>2]);r=ea(g[d+8>>2]);s=ea(g[d+12>>2]);t=ea(g[e>>2]);u=ea(g[e+4>>2]);v=ea(g[e+8>>2]);w=ea(g[e+12>>2]);x=ea(g[f>>2]);y=ea(g[f+4>>2]);z=ea(g[f+8>>2]);A=ea(g[f+12>>2]);B=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);E=ea(B-l);l=ea(C-p);p=ea(D-t);t=ea(ea(g[h+12>>2])-x);x=ea(g[h+16>>2]);D=ea(g[h+20>>2]);C=ea(g[h+24>>2]);B=ea(x-m);m=ea(D-q);q=ea(C-u);u=ea(ea(g[h+28>>2])-y);y=ea(g[h+32>>2]);C=ea(g[h+36>>2]);D=ea(g[h+40>>2]);x=ea(y-n);n=ea(C-r);r=ea(D-v);v=ea(ea(g[h+44>>2])-z);z=ea(ea(ea(E*E)+ea(B*B))+ea(x*x));D=ea(ea(ea(l*l)+ea(m*m))+ea(n*n));C=ea(ea(ea(p*p)+ea(q*q))+ea(r*r));y=ea(ea(ea(t*t)+ea(u*u))+ea(v*v));F=ea(g[k+16>>2]);G=ea(g[k+20>>2]);H=ea(g[k+24>>2]);I=ea(z*F);F=ea(D*G);G=ea(C*H);H=ea(y*ea(g[k+28>>2]));y=ea(ea(1.0)/ea(T(ea(I))));C=ea(ea(1.0)/ea(T(ea(F))));D=ea(ea(1.0)/ea(T(ea(G))));z=ea(ea(1.0)/ea(T(ea(H))));J=ea(I*y);I=ea(F*C);F=ea(G*D);G=ea(H*z);H=ea(g[k+32>>2]);K=ea(g[k+36>>2]);L=ea(g[k+40>>2]);M=ea(g[k+44>>2]);N=ea(H-J);O=ea(K-I);P=ea(L-F);Q=ea(M-G);R=c+16|0;S=ea(g[R>>2]);U=ea(g[R+4>>2]);V=ea(g[R+8>>2]);R=d+16|0;W=ea(g[R>>2]);X=ea(g[R+4>>2]);Y=ea(g[R+8>>2]);R=e+16|0;Z=ea(g[R>>2]);_=ea(g[R+4>>2]);$=ea(g[R+8>>2]);R=f+16|0;aa=ea(g[R>>2]);ba=ea(g[R+4>>2]);ca=ea(g[R+8>>2]);da=ea(g[h+48>>2]);fa=ea(g[h+52>>2]);ga=ea(g[h+56>>2]);ha=ea(g[h+60>>2]);ia=ea(g[k+112>>2]);ja=ea(g[k+116>>2]);ka=ea(g[k+120>>2]);la=ea(g[k+124>>2]);ma=ea(da-ia);da=ea(fa-ja);fa=ea(ga-ka);ga=ea(ha-la);ha=ea(o-ia);ia=ea(s-ja);ja=ea(w-ka);ka=ea(A-la);h=ma>ea(0.0);la=h?ma:ea(0.0);h=da>ea(0.0);ma=h?da:ea(0.0);h=fa>ea(0.0);da=h?fa:ea(0.0);h=ga>ea(0.0);fa=h?ga:ea(0.0);h=ha>ea(0.0);ga=h?ha:ea(0.0);h=ia>ea(0.0);ha=h?ia:ea(0.0);h=ja>ea(0.0);ia=h?ja:ea(0.0);h=ka>ea(0.0);ja=ea(la+ga);ga=ea(ma+ha);ha=ea(da+ia);ia=ea(fa+(h?ka:ea(0.0)));ka=ea(H+H);H=ea(K+K);K=ea(L+L);L=ea(M+M);M=ea(g[k+48>>2]);fa=ea(g[k+52>>2]);da=ea(g[k+56>>2]);ma=ea(ea(J+ea(y*M))-ka);ka=ea(ea(I+ea(C*fa))-H);H=ea(ea(F+ea(D*da))-K);K=ea(ea(G+ea(z*ea(g[k+60>>2])))-L);L=ea(g[k+80>>2]);z=ea(g[k+84>>2]);G=ea(g[k+88>>2]);da=ea(ja*ea(ma*L));L=ea(ga*ea(ka*z));z=ea(ha*ea(H*G));G=ea(ia*ea(K*ea(g[k+92>>2])));K=ea(g[k>>2]);ia=ea(g[k+4>>2]);H=ea(g[k+8>>2]);ha=ea(g[k+12>>2]);ka=ea(da*K);da=ea(L*ia);L=ea(z*H);z=ea(G*ha);G=ea(E*ka);E=ea(l*da);l=ea(p*L);p=ea(t*z);t=ea(B*ka);B=ea(m*da);m=ea(q*L);q=ea(u*z);u=ea(x*ka);ka=ea(n*da);da=ea(r*L);L=ea(v*z);z=ea(g[k+96>>2]);v=ea(g[k+100>>2]);r=ea(g[k+104>>2]);n=ea(K*ea(N*z));z=ea(ia*ea(O*v));v=ea(H*ea(P*r));r=ea(ha*ea(Q*ea(g[k+108>>2])));Q=ea(g[i>>2]);ha=ea(g[i+4>>2]);P=ea(g[i+8>>2]);H=ea(S-Q);Q=ea(W-ha);ha=ea(Z-P);P=ea(aa-ea(g[i+12>>2]));aa=ea(g[i+16>>2]);Z=ea(g[i+20>>2]);W=ea(g[i+24>>2]);S=ea(U-aa);aa=ea(X-Z);Z=ea(_-W);W=ea(ba-ea(g[i+28>>2]));ba=ea(g[i+32>>2]);_=ea(g[i+36>>2]);X=ea(g[i+40>>2]);U=ea(G+ea(n*H));H=ea(E+ea(z*Q));Q=ea(l+ea(v*ha));ha=ea(p+ea(r*P));P=ea(t+ea(n*S));S=ea(B+ea(z*aa));aa=ea(m+ea(v*Z));Z=ea(q+ea(r*W));W=ea(u+ea(n*ea(V-ba)));ba=ea(ka+ea(z*ea(Y-_)));_=ea(da+ea(v*ea($-X)));X=ea(L+ea(r*ea(ca-ea(g[i+44>>2]))));ca=ea(g[j>>2]);i=j+4|0;r=ea(g[i>>2]);k=j+8|0;L=ea(g[k>>2]);h=j+12|0;$=ea(g[h>>2]);v=ea(g[b>>2]);R=b+4|0;da=ea(g[R>>2]);f=b+8|0;Y=ea(g[f>>2]);e=b+12|0;z=ea(da-ea(H*r));r=ea(Y-ea(Q*L));L=ea(ea(g[e>>2])-ea(ha*$));g[b>>2]=ea(v-ea(U*ca));g[R>>2]=z;g[f>>2]=r;g[e>>2]=L;L=ea(g[j>>2]);r=ea(g[i>>2]);z=ea(g[k>>2]);ca=ea(g[h>>2]);e=b+16|0;v=ea(g[e>>2]);f=b+20|0;$=ea(g[f>>2]);R=b+24|0;Y=ea(g[R>>2]);d=b+28|0;da=ea($-ea(S*r));r=ea(Y-ea(aa*z));z=ea(ea(g[d>>2])-ea(Z*ca));g[e>>2]=ea(v-ea(P*L));g[f>>2]=da;g[R>>2]=r;g[d>>2]=z;z=ea(g[j>>2]);r=ea(g[i>>2]);da=ea(g[k>>2]);L=ea(g[h>>2]);h=b+32|0;v=ea(g[h>>2]);k=b+36|0;ca=ea(g[k>>2]);i=b+40|0;Y=ea(g[i>>2]);j=b+44|0;$=ea(ca-ea(ba*r));r=ea(Y-ea(_*da));da=ea(ea(g[j>>2])-ea(X*L));g[h>>2]=ea(v-ea(W*z));g[k>>2]=$;g[i>>2]=r;g[j>>2]=da;da=ea(ea(1.0)/o);o=ea(ea(1.0)/s);s=ea(ea(1.0)/w);w=ea(ea(1.0)/A);A=ea(g[a>>2]);j=a+4|0;r=ea(g[j>>2]);i=a+8|0;$=ea(g[i>>2]);k=a+12|0;z=ea(ea(H*o)+r);r=ea(ea(Q*s)+$);$=ea(ea(ha*w)+ea(g[k>>2]));g[a>>2]=ea(ea(U*da)+A);g[j>>2]=z;g[i>>2]=r;g[k>>2]=$;k=a+16|0;$=ea(g[k>>2]);i=a+20|0;r=ea(g[i>>2]);j=a+24|0;z=ea(g[j>>2]);h=a+28|0;A=ea(ea(S*o)+r);r=ea(ea(aa*s)+z);z=ea(ea(Z*w)+ea(g[h>>2]));g[k>>2]=ea(ea(P*da)+$);g[i>>2]=A;g[j>>2]=r;g[h>>2]=z;h=a+32|0;z=ea(g[h>>2]);j=a+36|0;r=ea(g[j>>2]);i=a+40|0;A=ea(g[i>>2]);k=a+44|0;$=ea(ea(ba*o)+r);r=ea(ea(_*s)+A);A=ea(ea(X*w)+ea(g[k>>2]));g[h>>2]=ea(ea(W*da)+z);g[j>>2]=$;g[i>>2]=r;g[k>>2]=A;return}function oHb(a,b,c,d,e,f,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;i=i|0;var j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im;j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(g[b+8>>2]);m=ea(g[b+12>>2]);n=ea(g[c>>2]);o=ea(g[c+4>>2]);p=ea(g[c+8>>2]);q=ea(g[c+12>>2]);r=ea(g[d>>2]);s=ea(g[d+4>>2]);t=ea(g[d+8>>2]);u=ea(g[d+12>>2]);v=ea(g[e>>2]);w=ea(g[e+4>>2]);x=ea(g[e+8>>2]);y=ea(g[e+12>>2]);z=ea(g[f>>2]);A=ea(g[f+4>>2]);B=ea(g[f+8>>2]);C=ea(z-j);j=ea(A-n);n=ea(B-r);r=ea(ea(g[f+12>>2])-v);v=ea(g[f+16>>2]);B=ea(g[f+20>>2]);A=ea(g[f+24>>2]);z=ea(v-k);k=ea(B-o);o=ea(A-s);s=ea(ea(g[f+28>>2])-w);w=ea(g[f+32>>2]);A=ea(g[f+36>>2]);B=ea(g[f+40>>2]);v=ea(w-l);l=ea(A-p);p=ea(B-t);t=ea(ea(g[f+44>>2])-x);x=ea(ea(ea(C*C)+ea(z*z))+ea(v*v));B=ea(ea(ea(j*j)+ea(k*k))+ea(l*l));A=ea(ea(ea(n*n)+ea(o*o))+ea(p*p));w=ea(ea(ea(r*r)+ea(s*s))+ea(t*t));D=ea(g[i+16>>2]);E=ea(g[i+20>>2]);F=ea(g[i+24>>2]);G=ea(x*D);D=ea(B*E);E=ea(A*F);F=ea(w*ea(g[i+28>>2]));w=ea(ea(1.0)/ea(T(ea(G))));A=ea(ea(1.0)/ea(T(ea(D))));B=ea(ea(1.0)/ea(T(ea(E))));x=ea(ea(1.0)/ea(T(ea(F))));H=ea(G*w);G=ea(D*A);D=ea(E*B);E=ea(F*x);F=ea(g[i+32>>2]);I=ea(g[i+36>>2]);J=ea(g[i+40>>2]);K=ea(g[i+44>>2]);L=ea(F-H);M=ea(I-G);N=ea(J-D);O=ea(K-E);P=b+16|0;Q=ea(g[P>>2]);R=ea(g[P+4>>2]);S=ea(g[P+8>>2]);P=c+16|0;U=ea(g[P>>2]);V=ea(g[P+4>>2]);W=ea(g[P+8>>2]);P=d+16|0;X=ea(g[P>>2]);Y=ea(g[P+4>>2]);Z=ea(g[P+8>>2]);P=e+16|0;_=ea(g[P>>2]);$=ea(g[P+4>>2]);aa=ea(g[P+8>>2]);ba=ea(g[f+48>>2]);ca=ea(g[f+52>>2]);da=ea(g[f+56>>2]);fa=ea(g[f+60>>2]);ga=ea(g[i+112>>2]);ha=ea(g[i+116>>2]);ia=ea(g[i+120>>2]);ja=ea(g[i+124>>2]);ka=ea(ba-ga);ba=ea(ca-ha);ca=ea(da-ia);da=ea(fa-ja);fa=ea(m-ga);ga=ea(q-ha);ha=ea(u-ia);ia=ea(y-ja);f=ka>ea(0.0);ja=f?ka:ea(0.0);f=ba>ea(0.0);ka=f?ba:ea(0.0);f=ca>ea(0.0);ba=f?ca:ea(0.0);f=da>ea(0.0);ca=f?da:ea(0.0);f=fa>ea(0.0);da=f?fa:ea(0.0);f=ga>ea(0.0);fa=f?ga:ea(0.0);f=ha>ea(0.0);ga=f?ha:ea(0.0);f=ia>ea(0.0);ha=ea(ja+da);da=ea(ka+fa);fa=ea(ba+ga);ga=ea(ca+(f?ia:ea(0.0)));ia=ea(F+F);F=ea(I+I);I=ea(J+J);J=ea(K+K);K=ea(g[i+48>>2]);ca=ea(g[i+52>>2]);ba=ea(g[i+56>>2]);ka=ea(ea(H+ea(w*K))-ia);ia=ea(ea(G+ea(A*ca))-F);F=ea(ea(D+ea(B*ba))-I);I=ea(ea(E+ea(x*ea(g[i+60>>2])))-J);J=ea(g[i+80>>2]);x=ea(g[i+84>>2]);E=ea(g[i+88>>2]);ba=ea(ha*ea(ka*J));J=ea(da*ea(ia*x));x=ea(fa*ea(F*E));E=ea(ga*ea(I*ea(g[i+92>>2])));I=ea(g[i>>2]);ga=ea(g[i+4>>2]);F=ea(g[i+8>>2]);fa=ea(g[i+12>>2]);ia=ea(ba*I);ba=ea(J*ga);J=ea(x*F);x=ea(E*fa);E=ea(C*ia);C=ea(j*ba);j=ea(n*J);n=ea(r*x);r=ea(z*ia);z=ea(k*ba);k=ea(o*J);o=ea(s*x);s=ea(v*ia);ia=ea(l*ba);ba=ea(p*J);J=ea(t*x);x=ea(g[i+96>>2]);t=ea(g[i+100>>2]);p=ea(g[i+104>>2]);l=ea(I*ea(L*x));x=ea(ga*ea(M*t));t=ea(F*ea(N*p));p=ea(fa*ea(O*ea(g[i+108>>2])));O=ea(g[h>>2]);fa=ea(g[h+4>>2]);N=ea(g[h+8>>2]);F=ea(Q-O);O=ea(U-fa);fa=ea(X-N);N=ea(_-ea(g[h+12>>2]));_=ea(g[h+16>>2]);X=ea(g[h+20>>2]);U=ea(g[h+24>>2]);Q=ea(R-_);_=ea(V-X);X=ea(Y-U);U=ea($-ea(g[h+28>>2]));$=ea(g[h+32>>2]);Y=ea(g[h+36>>2]);V=ea(g[h+40>>2]);R=ea(ea(1.0)/m);m=ea(ea(1.0)/q);q=ea(ea(1.0)/u);u=ea(ea(1.0)/y);y=ea(ea(E+ea(l*F))*R);F=ea(ea(C+ea(x*O))*m);O=ea(ea(j+ea(t*fa))*q);fa=ea(ea(n+ea(p*N))*u);N=ea(ea(r+ea(l*Q))*R);Q=ea(ea(z+ea(x*_))*m);_=ea(ea(k+ea(t*X))*q);X=ea(ea(o+ea(p*U))*u);U=ea(ea(s+ea(l*ea(S-$)))*R);R=ea(ea(ia+ea(x*ea(W-Y)))*m);m=ea(ea(ba+ea(t*ea(Z-V)))*q);q=ea(ea(J+ea(p*ea(aa-ea(g[h+44>>2]))))*u);u=ea(g[a>>2]);h=a+4|0;aa=ea(g[h>>2]);i=a+8|0;p=ea(g[i>>2]);f=a+12|0;J=ea(F+aa);aa=ea(O+p);p=ea(fa+ea(g[f>>2]));g[a>>2]=ea(y+u);g[h>>2]=J;g[i>>2]=aa;g[f>>2]=p;f=a+16|0;p=ea(g[f>>2]);i=a+20|0;aa=ea(g[i>>2]);h=a+24|0;J=ea(g[h>>2]);P=a+28|0;u=ea(Q+aa);aa=ea(_+J);J=ea(X+ea(g[P>>2]));g[f>>2]=ea(N+p);g[i>>2]=u;g[h>>2]=aa;g[P>>2]=J;P=a+32|0;J=ea(g[P>>2]);h=a+36|0;aa=ea(g[h>>2]);i=a+40|0;u=ea(g[i>>2]);f=a+44|0;p=ea(R+aa);aa=ea(m+u);u=ea(q+ea(g[f>>2]));g[P>>2]=ea(U+J);g[h>>2]=p;g[i>>2]=aa;g[f>>2]=u;return}function pHb(a,b,e,f,h,j,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=ea(m);n=ea(n);o=ea(o);p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=ea(u);v=v|0;var w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=0,I=Im,J=0,K=0,L=Im,M=0,N=Im,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;w=i;i=i+32|0;x=w+16|0;y=w+12|0;z=w;c[r>>2]=-1;A=c[a+16>>2]|0;B=c[a+28>>2]|0;C=c[a+24>>2]|0;D=h+36|0;E=ea(ea(g[D>>2])*m);F=h+40|0;G=ea(ea(g[F>>2])*m);H=h+44|0;I=ea(ea(g[H>>2])*m);J=h+48|0;m=ea(ea(g[J>>2])*n);K=h+52|0;L=ea(ea(g[K>>2])*n);M=h+56|0;N=ea(E+m);m=ea(G+L);L=ea(I+ea(ea(g[M>>2])*n));O=h+60|0;n=ea(ea(g[O>>2])*o);P=h+64|0;I=ea(ea(g[P>>2])*o);Q=h+68|0;G=ea(N+n);n=ea(m+I);I=ea(L+ea(ea(g[Q>>2])*o));h=A*20|0;if(h){R=0;while(1){S=R+128|0;if(S>>>0<h>>>0)R=S;else break}}a:do if(A){R=z+4|0;h=z+8|0;S=e+4|0;U=e+8|0;V=e+12|0;W=e+16|0;X=e+20|0;Y=e+24|0;Z=e+28|0;_=e+32|0;$=f+4|0;aa=f+8|0;ba=f+12|0;ca=f+16|0;da=f+20|0;fa=f+24|0;ga=f+28|0;ha=f+32|0;ia=v+4|0;ja=v+8|0;ka=a+44|0;la=a+48|0;ma=a+52|0;na=b+44|0;oa=b+48|0;pa=b+52|0;qa=a+40|0;ra=b+40|0;sa=b+64|0;ta=q+4|0;ua=q+8|0;va=0;wa=s;while(1){xa=C+(va*20|0)|0;o=ea(g[xa>>2]);L=ea(G*o);ya=C+(va*20|0)+4|0;m=ea(g[ya>>2]);N=ea(L+ea(n*m));za=C+(va*20|0)+8|0;L=ea(g[za>>2]);if(!(ea(N+ea(I*L))<ea(0.0))){N=ea(o*ea(g[D>>2]));E=ea(o*ea(g[F>>2]));Aa=ea(o*ea(g[H>>2]));o=ea(m*ea(g[J>>2]));Ba=ea(m*ea(g[K>>2]));Ca=ea(N+o);o=ea(E+Ba);Ba=ea(Aa+ea(m*ea(g[M>>2])));m=ea(L*ea(g[O>>2]));Aa=ea(L*ea(g[P>>2]));E=ea(Ca+m);m=ea(o+Aa);Aa=ea(Ba+ea(L*ea(g[Q>>2])));g[z>>2]=E;g[R>>2]=m;g[h>>2]=Aa;L=ea(T(ea(ea(Aa*Aa)+ea(ea(E*E)+ea(m*m)))));if(L>ea(0.0)){Ba=ea(ea(1.0)/L);o=ea(E*Ba);g[z>>2]=o;Ca=ea(m*Ba);g[R>>2]=Ca;N=ea(Aa*Ba);g[h>>2]=N;Da=o;Ea=Ca;Fa=N}else{Da=E;Ea=m;Fa=Aa}Aa=ea(g[e>>2]);m=ea(Da*Aa);E=ea(g[S>>2]);N=ea(Da*E);Ca=ea(g[U>>2]);o=ea(Da*Ca);Ba=ea(g[V>>2]);Ga=ea(Ea*Ba);Ha=ea(g[W>>2]);Ia=ea(Ea*Ha);Ja=ea(g[X>>2]);Ka=ea(m+Ga);Ga=ea(N+Ia);Ia=ea(o+ea(Ea*Ja));o=ea(g[Y>>2]);N=ea(Fa*o);m=ea(g[Z>>2]);La=ea(Fa*m);Ma=ea(g[_>>2]);Na=ea(Ka+N);N=ea(Ga+La);La=ea(Ia+ea(Fa*Ma));Ia=ea(g[p>>2]);Ga=ea(ea(ea(Aa*Na)+ea(E*N))+ea(Ca*La));Ca=ea(ea(ea(Ba*Na)+ea(Ha*N))+ea(Ja*La));Ja=ea(ea(ea(o*Na)+ea(m*N))+ea(Ma*La));Oa=(g[k>>2]=Ga,c[k>>2]|0);Pa=(g[k>>2]=Ca,c[k>>2]|0);Qa=(g[k>>2]=Ja,c[k>>2]|0);Ma=ea(Na*ea(g[f>>2]));m=ea(Ma+ea(N*ea(g[$>>2])));Ma=ea(m+ea(La*ea(g[aa>>2])));m=ea(Na*ea(g[ba>>2]));o=ea(m+ea(N*ea(g[ca>>2])));m=ea(o+ea(La*ea(g[da>>2])));o=ea(Na*ea(g[fa>>2]));Ha=ea(o+ea(N*ea(g[ga>>2])));o=ea(Ha+ea(La*ea(g[ha>>2])));Ra=(g[k>>2]=Ma,c[k>>2]|0);Sa=(g[k>>2]=m,c[k>>2]|0);Ha=ea(Na*ea(g[v>>2]));Ba=ea(Ha+ea(N*ea(g[ia>>2])));Ha=ea(Ba+ea(La*ea(g[ja>>2])));Ta=c[pa>>2]|(g[k>>2]=o,c[k>>2]|0)&-2147483648;Ba=ea(Ga*(c[k>>2]=c[ka>>2]|Oa&-2147483648,ea(g[k>>2])));Ga=ea(Ba+ea(Ca*(c[k>>2]=c[la>>2]|Pa&-2147483648,ea(g[k>>2]))));Ca=ea(Ga+ea(Ja*(c[k>>2]=c[ma>>2]|Qa&-2147483648,ea(g[k>>2]))));Ja=ea(Ma*(c[k>>2]=c[na>>2]|Ra&-2147483648,ea(g[k>>2])));Ma=ea(Ja+ea(m*(c[k>>2]=c[oa>>2]|Sa&-2147483648,ea(g[k>>2]))));m=ea(Ma+ea(o*(c[k>>2]=Ta,ea(g[k>>2]))));o=ea(g[qa>>2]);Ma=ea(g[ra>>2]);Ja=ea((Ca>o?Ca:o)+(m>Ma?m:Ma));Ma=ea(Ha+Ja);m=ea(Ja-Ha);if(!((Ma<m?Ma:m)>Ia)){Ta=wa+4|0;c[wa>>2]=va;Ia=ea(ea(1.0)/L);Sa=d[C+(va*20|0)+19>>0]|0;L=ea(g[xa>>2]);m=ea(L*ea(g[B+(Sa*12|0)>>2]));L=ea(g[ya>>2]);Ma=ea(m+ea(L*ea(g[B+(Sa*12|0)+4>>2])));L=ea(g[za>>2]);m=ea(Ia*ea(Ma+ea(L*ea(g[B+(Sa*12|0)+8>>2]))));L=ea(Ia*ea(g[C+(va*20|0)+12>>2]));Ia=ea(-L);rn[c[sa>>2]&127](b,z,l,j,x,y);Ma=ea(u-L);L=ea(g[x>>2]);if(Ma<L){Ua=0;Va=16;break}Ma=ea(g[y>>2]);if(ea(Ma+u)<m){Ua=0;Va=16;break}Ha=ea(Ia-L);L=ea(Ma-m);m=Ha<L?Ha:L;if(m<ea(g[p>>2])){g[q>>2]=Na;g[ta>>2]=N;g[ua>>2]=La;g[p>>2]=m;c[r>>2]=va;Wa=Ta}else Wa=Ta}else Wa=wa}else Wa=wa;va=va+1|0;if(va>>>0>=A>>>0){Xa=Wa;break a}else wa=Wa}if((Va|0)==16){i=w;return Ua|0}}else Xa=s;while(0);c[t>>2]=Xa-s>>2;Ua=1;i=w;return Ua|0}function qHb(b,f,h,j,k,l,m,n,o,p,q,r){b=b|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=Im,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=Im;s=i;i=i+16|0;t=s;if(!h){i=s;return}u=r+4|0;v=r+8|0;w=r+12|0;x=r+16|0;y=r+20|0;z=r+24|0;A=r+28|0;B=r+32|0;C=n+4|0;D=n+8|0;E=n+12|0;F=o+12|0;G=o+24|0;H=p+12|0;I=o+36|0;J=o+4|0;K=F+4|0;L=G+4|0;M=p+16|0;N=p+4|0;O=I+4|0;P=o+8|0;Q=F+8|0;R=G+8|0;U=p+20|0;V=p+8|0;W=I+8|0;X=m+4|0;Y=m+8|0;Z=m+12|0;_=m+16|0;$=m+20|0;aa=m+24|0;ba=m+28|0;ca=m+32|0;da=t+4|0;fa=t+8|0;ga=f;f=h;do{f=f+-1|0;h=c[ga>>2]|0;ga=ga+4|0;ha=e[j+(h*20|0)+16>>1]|0;ia=a[j+(h*20|0)+18>>0]|0;h=ia&255;ja=d[l+ha>>0]|0;ka=ea(g[k+(ja*12|0)>>2]);la=ea(g[r>>2]);ma=ea(ka*la);na=ea(g[u>>2]);oa=ea(ka*na);pa=ea(g[v>>2]);qa=ea(ka*pa);ka=ea(g[k+(ja*12|0)+4>>2]);ra=ea(g[w>>2]);sa=ea(ka*ra);ta=ea(g[x>>2]);ua=ea(ka*ta);va=ea(g[y>>2]);wa=ea(ma+sa);sa=ea(oa+ua);ua=ea(qa+ea(ka*va));ka=ea(g[k+(ja*12|0)+8>>2]);qa=ea(g[z>>2]);oa=ea(ka*qa);ma=ea(g[A>>2]);xa=ea(ka*ma);ya=ea(g[B>>2]);za=ea(wa+oa);oa=ea(sa+xa);xa=ea(ua+ea(ka*ya));a:do if(ia<<24>>24){ka=ea(g[C>>2]);ua=ea(g[n>>2]);sa=ea(g[D>>2]);wa=ea(xa*sa);Aa=ea(ea(za*ua)+ea(oa*ka));Ba=ea(g[E>>2]);Ca=la;Da=na;Ea=pa;Fa=ra;Ga=ta;Ha=va;Ia=qa;Ja=ma;Ka=ya;La=ua;ua=ka;ka=sa;sa=Ba;Ma=za;Na=oa;Oa=xa;ja=ea(Ba+ea(Aa+wa))<=q;Pa=1;while(1){Qa=d[l+((Pa>>>0>=h>>>0?0:Pa)+ha)>>0]|0;wa=ea(g[k+(Qa*12|0)>>2]);Aa=ea(wa*Ca);Ba=ea(wa*Da);Ra=ea(wa*Ea);wa=ea(g[k+(Qa*12|0)+4>>2]);Sa=ea(Aa+ea(wa*Fa));Aa=ea(Ba+ea(wa*Ga));Ba=ea(Ra+ea(wa*Ha));wa=ea(g[k+(Qa*12|0)+8>>2]);Ra=ea(Sa+ea(wa*Ia));Sa=ea(Aa+ea(wa*Ja));Aa=ea(Ba+ea(wa*Ka));Qa=ea(sa+ea(ea(ea(Ra*La)+ea(Sa*ua))+ea(Aa*ka)))<=q;if((((((ja|Qa?(wa=ea(Ra-Ma),Ba=ea(g[o>>2]),Ta=ea(wa*Ba),Ua=ea(Sa-Na),Va=ea(g[F>>2]),Wa=ea(Ta+ea(Ua*Va)),Ta=ea(Aa-Oa),Xa=ea(g[G>>2]),Ya=ea(Wa+ea(Ta*Xa)),Wa=ea(g[H>>2]),Za=ea(g[p>>2]),_a=ea(Wa-Za),$a=ea(Ma+Ra),ab=ea(Na+Sa),bb=ea(Oa+Aa),cb=ea(ea(ea($a*Ba)+ea(ab*Va))+ea(bb*Xa)),Xa=ea(ea(cb+ea(ea(g[I>>2])*ea(2.0)))-ea(Wa+Za)),Za=ea(S(ea(Ya))),!(ea(S(ea(Xa)))>ea(_a+Za))):0)?(Wa=ea(g[J>>2]),cb=ea(wa*Wa),Va=ea(g[K>>2]),Ba=ea(cb+ea(Ua*Va)),cb=ea(g[L>>2]),db=ea(Ba+ea(Ta*cb)),Ba=ea(g[M>>2]),eb=ea(g[N>>2]),fb=ea(Ba-eb),gb=ea(ea(ea($a*Wa)+ea(ab*Va))+ea(bb*cb)),cb=ea(ea(gb+ea(ea(g[O>>2])*ea(2.0)))-ea(Ba+eb)),eb=ea(S(ea(db))),!(ea(S(ea(cb)))>ea(fb+eb))):0)?(Ba=ea(g[P>>2]),gb=ea(wa*Ba),wa=ea(g[Q>>2]),Va=ea(gb+ea(Ua*wa)),Ua=ea(g[R>>2]),gb=ea(Va+ea(Ta*Ua)),Ta=ea(g[U>>2]),Va=ea(g[V>>2]),Wa=ea(Ta-Va),hb=ea(ea(ea($a*Ba)+ea(ab*wa))+ea(bb*Ua)),Ua=ea(ea(hb+ea(ea(g[W>>2])*ea(2.0)))-ea(Ta+Va)),Va=ea(S(ea(gb))),!(ea(S(ea(Ua)))>ea(Wa+Va))):0)?!(ea(S(ea(ea(db*Ua)-ea(cb*gb))))>ea(ea(eb*Wa)+ea(fb*Va))):0)?!(ea(S(ea(ea(Xa*gb)-ea(Ya*Ua))))>ea(ea(Za*Wa)+ea(_a*Va))):0)?!(ea(S(ea(ea(Ya*cb)-ea(Xa*db))))>ea(ea(Za*fb)+ea(_a*eb))):0){eb=ea(Ma-Ra);_a=ea(Na-Sa);fb=ea(Oa-Aa);Za=ea(eb*ea(g[m>>2]));db=ea(eb*ea(g[X>>2]));Xa=ea(eb*ea(g[Y>>2]));eb=ea(_a*ea(g[Z>>2]));cb=ea(_a*ea(g[_>>2]));Ya=ea(Za+eb);eb=ea(db+cb);cb=ea(Xa+ea(_a*ea(g[$>>2])));_a=ea(fb*ea(g[aa>>2]));Xa=ea(fb*ea(g[ba>>2]));db=ea(Ya+_a);_a=ea(eb+Xa);Xa=ea(cb+ea(fb*ea(g[ca>>2])));fb=ea(ea(ea(db*db)+ea(_a*_a))+ea(Xa*Xa));if(fb>ea(0.0)){cb=ea(ea(1.0)/ea(T(ea(fb))));ib=ea(Xa*cb);jb=ea(_a*cb);kb=ea(db*cb)}else{ib=ea(0.0);jb=ea(0.0);kb=ea(0.0)}g[t>>2]=kb;g[da>>2]=jb;g[fa>>2]=ib;bOa(b,t)|0}if((Pa|0)==(h|0))break a;cb=ea(g[r>>2]);db=ea(g[u>>2]);_a=ea(g[v>>2]);Xa=ea(g[w>>2]);fb=ea(g[x>>2]);eb=ea(g[y>>2]);Ya=ea(g[z>>2]);Za=ea(g[A>>2]);Va=ea(g[B>>2]);Wa=ea(g[n>>2]);Ua=ea(g[C>>2]);gb=ea(g[D>>2]);Ca=cb;Da=db;Ea=_a;Fa=Xa;Ga=fb;Ha=eb;Ia=Ya;Ja=Za;Ka=Va;La=Wa;ua=Ua;ka=gb;sa=ea(g[E>>2]);Ma=Ra;Na=Sa;Oa=Aa;ja=Qa;Pa=Pa+1|0}}while(0)}while((f|0)!=0);i=s;return}function rHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;NIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;OIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function sHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;NIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;PIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function tHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;NIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;QIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function uHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;NIb(b,c[e>>2]|0);a[g>>0]=0;c[g+4>>2]=0;c[g+8>>2]=d;c[g+12>>2]=e;RIb(b,0,g,0);g=c[b>>2]|0;e=c[g+8>>2]|0;if(!e){a[b+36>>0]=1;i=f;return}d=e+-1|0;h=c[g+4>>2]|0;if((a[h+(d<<3)+4>>0]|0)!=0?(a[h+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;j=d;k=c[d+8>>2]|0}else{j=g;k=e}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;e=b+36|0;a[e>>0]=1;if(!j){i=f;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=f;return}a[e>>0]=0;i=f;return}function vHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;NIb(b,c[e>>2]|0);a[g>>0]=0;c[g+4>>2]=0;c[g+8>>2]=d;c[g+12>>2]=e;SIb(b,0,g,0);g=c[b>>2]|0;e=c[g+8>>2]|0;if(!e){a[b+36>>0]=1;i=f;return}d=e+-1|0;h=c[g+4>>2]|0;if((a[h+(d<<3)+4>>0]|0)!=0?(a[h+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;j=d;k=c[d+8>>2]|0}else{j=g;k=e}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;e=b+36|0;a[e>>0]=1;if(!j){i=f;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=f;return}a[e>>0]=0;i=f;return}function wHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;NIb(b,c[e>>2]|0);a[g>>0]=0;c[g+4>>2]=0;c[g+8>>2]=d;c[g+12>>2]=e;TIb(b,0,g,0);g=c[b>>2]|0;e=c[g+8>>2]|0;if(!e){a[b+36>>0]=1;i=f;return}d=e+-1|0;h=c[g+4>>2]|0;if((a[h+(d<<3)+4>>0]|0)!=0?(a[h+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;j=d;k=c[d+8>>2]|0}else{j=g;k=e}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;e=b+36|0;a[e>>0]=1;if(!j){i=f;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=f;return}a[e>>0]=0;i=f;return}function xHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;NIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;UIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function yHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;NIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;VIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function zHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;NIb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;WIb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function AHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];NIb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=0;else j=c[d>>2]|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=619;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}XIb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function BHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function CHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+288|0;g=d+272|0;h=d+224|0;j=d+112|0;k=d;l=c[b>>2]|0;m=c[l+8>>2]|0;if((m|0)!=0?(n=m+-1|0,o=c[l+4>>2]|0,l=o+(n<<3)|0,(a[o+(n<<3)+4>>0]|0)==0):0){n=b+36|0;if(!(a[n>>0]|0)){p=m;q=o;r=0}else{o=c[b+20>>2]|0;m=(_n[c[(c[o>>2]|0)+16>>2]&4095](o,c[l>>2]|0)|0)&1;a[n>>0]=m;l=c[b>>2]|0;p=c[l+8>>2]|0;q=c[l+4>>2]|0;r=m}a[q+(p+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[n>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}n=b+24|0;In[c[e+16>>2]&4095](j,c[n>>2]|0);r=b+8|0;p=c[b+4>>2]|0;q=c[b+20>>2]|0;m=c[b+28>>2]|0;l=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=p;p=h+8|0;c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[h+20>>2]=q;c[h+24>>2]=j;c[h+28>>2]=m;c[h+32>>2]=l;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;YIb(h,2,f+24|0,g);ZIb(h,f+48|0,0);_Ib(h,f+64|0,0);$Ib(h,f+80|0,0);aJb(h,f+96|0,0);bJb(h,f+112|0,0);cJb(h,f+128|0,0);f=c[n>>2]|0;n=c[j+64>>2]|0;YEi(k|0,j|0,n<<3|0)|0;c[k+64>>2]=n;n=k+80|0;h=j+80|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[n+12>>2]=c[h+12>>2];c[n+16>>2]=c[h+16>>2];c[n+20>>2]=c[h+20>>2];c[n+24>>2]=c[h+24>>2];c[n+28>>2]=c[h+28>>2];In[c[e+20>>2]&4095](f,k);i=d;return}function DHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+400|0;f=d+352|0;g=d;h=d+208|0;j=d+144|0;k=j+0|0;l=k+64|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));tFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;dJb(f,0,j,515160,0);eJb(f,j+16|0,0);fJb(f,j+32|0,0);gJb(f,j+48|0,0);j=c[m>>2]|0;YEi(g|0,h|0,144)|0;In[c[e+20>>2]&4095](j,g);i=d;return}function EHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+128|0;f=d+80|0;g=d;h=d+64|0;j=d+16|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));GFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;hJb(f,j,0);iJb(f,j+16|0,0);jJb(f,j+32|0,0);j=c[m>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];In[c[e+20>>2]&4095](j,g);i=d;return}function FHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+608|0;f=d+560|0;g=d;h=d+304|0;j=d+256|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));AFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;kJb(f,j,0);lJb(f,0,j+16|0,515160,0);mJb(f,0,j+32|0,515160,0);j=c[m>>2]|0;YEi(g|0,h|0,256)|0;In[c[e+20>>2]&4095](j,g);i=d;return}function GHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+224|0;f=d+176|0;g=d;h=d+144|0;j=d+32|0;k=j+0|0;l=k+112|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));BFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;nJb(f,j,0);oJb(f,j+16|0,0);pJb(f,j+32|0,0);qJb(f,j+48|0,0);rJb(f,j+64|0,0);sJb(f,j+80|0,0);tJb(f,j+96|0,0);j=c[m>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[g+16>>2]=c[h+16>>2];c[g+20>>2]=c[h+20>>2];c[g+24>>2]=c[h+24>>2];c[g+28>>2]=c[h+28>>2];In[c[e+20>>2]&4095](j,g);i=d;return}function HHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+144|0;f=d+96|0;g=d;h=d+80|0;j=d+16|0;k=j+0|0;l=k+64|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));FFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;uJb(f,j,0);vJb(f,j+16|0,0);wJb(f,j+32|0,0);xJb(f,j+48|0,0);j=c[m>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];In[c[e+20>>2]&4095](j,g);i=d;return}function IHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function JHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;g=d+64|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;BEb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+64|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function KHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+112|0;g=d+80|0;h=d+32|0;j=d;k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](j,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=o;o=h+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[h+20>>2]=p;c[h+24>>2]=j;c[h+28>>2]=l;c[h+32>>2]=k;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;yJb(h,1,f+12|0,g);a[g>>0]=0;zJb(h,2,f+36|0,g);f=c[m>>2]|0;m=c[e+20>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];In[m&4095](f,g);i=d;return}function LHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+192|0;g=d+96|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;AJb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+96|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function MHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+2368|0;g=d+1792|0;h=d+16|0;j=d+1744|0;k=d;l=d+1168|0;m=d+592|0;n=c[b>>2]|0;o=c[n+8>>2]|0;if((o|0)!=0?(p=o+-1|0,q=c[n+4>>2]|0,n=q+(p<<3)|0,(a[q+(p<<3)+4>>0]|0)==0):0){p=b+36|0;if(!(a[p>>0]|0)){r=o;s=q;t=0}else{q=c[b+20>>2]|0;o=(_n[c[(c[q>>2]|0)+16>>2]&4095](q,c[n>>2]|0)|0)&1;a[p>>0]=o;n=c[b>>2]|0;r=c[n+8>>2]|0;s=c[n+4>>2]|0;t=o}a[s+(r+-1<<3)+5>>0]=t;t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=a[p>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}p=b+24|0;In[c[e+16>>2]&4095](l,c[p>>2]|0);t=b+8|0;c[k+0>>2]=c[t+0>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];r=c[b>>2]|0;s=c[b+4>>2]|0;o=c[b+20>>2]|0;n=c[b+28>>2]|0;q=c[b+32>>2]|0;c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[g>>2]=r;c[g+4>>2]=s;t=g+8|0;c[t+0>>2]=c[k+0>>2];c[t+4>>2]=c[k+4>>2];c[t+8>>2]=c[k+8>>2];c[g+20>>2]=o;c[g+24>>2]=l;c[g+28>>2]=n;c[g+32>>2]=q;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;CEb(g,f,0);DEb(g,f+16|0,0);EEb(g,f+32|0,0);FEb(g,f+48|0,0);c[j>>2]=r;c[j+4>>2]=s;s=j+8|0;c[s+0>>2]=c[h+0>>2];c[s+4>>2]=c[h+4>>2];c[s+8>>2]=c[h+8>>2];c[j+20>>2]=o;c[j+24>>2]=l;c[j+28>>2]=n;c[j+32>>2]=q;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;GEb(j,f+64|0,0);HEb(j,f+80|0,0);f=c[p>>2]|0;p=c[l+64>>2]|0;j=p<<3;YEi(m|0,l|0,j|0)|0;c[m+64>>2]=p;q=m+80|0;n=l+80|0;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[q+16>>2]=c[n+16>>2];c[q+20>>2]=c[n+20>>2];c[q+24>>2]=c[n+24>>2];c[q+28>>2]=c[n+28>>2];q=l+112|0;YEi(m+112|0,q|0,416)|0;o=l+528|0;l=m+528|0;s=o+0|0;r=l+48|0;do{c[l>>2]=c[s>>2];l=l+4|0;s=s+4|0}while((l|0)<(r|0));YEi(h|0,m|0,j|0)|0;c[h+64>>2]=p;m=h+80|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];c[m+24>>2]=c[n+24>>2];c[m+28>>2]=c[n+28>>2];YEi(h+112|0,q|0,416)|0;l=h+528|0;s=o+0|0;r=l+48|0;do{c[l>>2]=c[s>>2];l=l+4|0;s=s+4|0}while((l|0)<(r|0));m=c[e+20>>2]|0;YEi(g|0,h|0,j|0)|0;c[g+64>>2]=p;p=g+80|0;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[p+12>>2]=c[n+12>>2];c[p+16>>2]=c[n+16>>2];c[p+20>>2]=c[n+20>>2];c[p+24>>2]=c[n+24>>2];c[p+28>>2]=c[n+28>>2];YEi(g+112|0,q|0,416)|0;l=g+528|0;s=o+0|0;r=l+48|0;do{c[l>>2]=c[s>>2];l=l+4|0;s=s+4|0}while((l|0)<(r|0));In[m&4095](f,g);i=d;return}function NHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+608|0;f=e+352|0;g=e+320|0;h=e+256|0;j=e;k=c[b+24>>2]|0;if(!k)l=12;else l=(c[k>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,256)|0;xGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;xGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;qIb(f,g,0)|0;i=e;return}function OHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+208|0;f=e+136|0;g=e+104|0;h=e+72|0;j=e;k=c[b+24>>2]|0;if(!k)l=76;else l=(c[k>>2]|0)+76|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+72|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;rIb(f,g,0)|0;i=e;return}function PHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+720|0;f=e+424|0;g=e+392|0;h=e+296|0;j=e;k=c[b+24>>2]|0;if(!k)l=112;else l=(c[k>>2]|0)+112|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,296)|0;dHa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;dHa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;BJb(f,g,0)|0;i=e;return}function QHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;CJb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+16|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;DJb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+32|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;EJb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+48|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[J+0>>2];c[b+4>>2]=c[J+4>>2];c[b+8>>2]=c[J+8>>2];c[b+12>>2]=c[J+12>>2];b=c[J>>2]|0;if(G){J=G+-1|0;I=c[H+4>>2]|0;if(!(a[I+(J<<3)+4>>0]|0)){F=c[d+4>>2]|0;In[c[(c[F>>2]|0)+16>>2]&4095](F,c[I+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=b;a[g+4>>0]=0;b=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[b>>2]|0}c[b>>2]=M+1}else OAb(K,g)|0;FJb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){N=e+4|0;i=f;return N|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){O=h;P=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;O=g;P=c[g+8>>2]|0}c[O+8>>2]=P+-1;N=e+4|0;i=f;return N|0}function RHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+64|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;GJb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+80|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[v+0>>2];c[b+4>>2]=c[v+4>>2];c[b+8>>2]=c[v+8>>2];c[b+12>>2]=c[v+12>>2];b=c[v>>2]|0;if(s){v=s+-1|0;u=c[t+4>>2]|0;if(!(a[u+(v<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[u+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=b;a[g+4>>0]=0;b=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[b>>2]|0}c[b>>2]=y+1}else OAb(w,g)|0;HJb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){z=e+2|0;i=f;return z|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){A=h;B=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;A=g;B=c[g+8>>2]|0}c[A+8>>2]=B+-1;z=e+2|0;i=f;return z|0}function SHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function THb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;g=d+64|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;BEb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+64|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function UHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+112|0;g=d+80|0;h=d+32|0;j=d;k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](j,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=o;o=h+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[h+20>>2]=p;c[h+24>>2]=j;c[h+28>>2]=l;c[h+32>>2]=k;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;yJb(h,1,f+12|0,g);a[g>>0]=0;zJb(h,2,f+36|0,g);f=c[m>>2]|0;m=c[e+20>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];In[m&4095](f,g);i=d;return}function VHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+192|0;g=d+96|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;AJb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+96|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function WHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=208;else h=(c[g>>2]|0)+208|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}a:do if(!517392)l=0;else{f=517392;j=0;while(1){h=j+1|0;if(!(GEi(f,k)|0))break;f=c[517368+(h<<3)>>2]|0;if(!f){l=0;break a}else j=h}l=c[517372+(j<<3)>>2]|0}while(0);In[c[d+20>>2]&4095](c[b+24>>2]|0,l);i=e;return}function XHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+2112|0;g=d+1584|0;h=d+1056|0;j=d+528|0;k=d;l=c[b>>2]|0;m=c[l+8>>2]|0;if((m|0)!=0?(n=m+-1|0,o=c[l+4>>2]|0,l=o+(n<<3)|0,(a[o+(n<<3)+4>>0]|0)==0):0){n=b+36|0;if(!(a[n>>0]|0)){p=m;q=o;r=0}else{o=c[b+20>>2]|0;m=(_n[c[(c[o>>2]|0)+16>>2]&4095](o,c[l>>2]|0)|0)&1;a[n>>0]=m;l=c[b>>2]|0;p=c[l+8>>2]|0;q=c[l+4>>2]|0;r=m}a[q+(p+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[n>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}n=b+24|0;In[c[e+16>>2]&4095](j,c[n>>2]|0);r=b+8|0;p=c[b+4>>2]|0;q=c[b+20>>2]|0;m=c[b+28>>2]|0;l=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=p;p=g+8|0;c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[g+20>>2]=q;c[g+24>>2]=j;c[g+28>>2]=m;c[g+32>>2]=l;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;IJb(g,f,0);JJb(g,f+16|0,0);KJb(g,f+32|0,0);LJb(g,f+48|0,0);f=c[n>>2]|0;n=c[j+64>>2]|0;l=n<<3;YEi(k|0,j|0,l|0)|0;c[k+64>>2]=n;m=k+80|0;q=j+80|0;c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];c[m+12>>2]=c[q+12>>2];c[m+16>>2]=c[q+16>>2];c[m+20>>2]=c[q+20>>2];c[m+24>>2]=c[q+24>>2];c[m+28>>2]=c[q+28>>2];m=j+112|0;YEi(k+112|0,m|0,416)|0;YEi(h|0,k|0,l|0)|0;c[h+64>>2]=n;k=h+80|0;c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[k+16>>2]=c[q+16>>2];c[k+20>>2]=c[q+20>>2];c[k+24>>2]=c[q+24>>2];c[k+28>>2]=c[q+28>>2];YEi(h+112|0,m|0,416)|0;k=c[e+20>>2]|0;YEi(g|0,h|0,l|0)|0;c[g+64>>2]=n;n=g+80|0;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];c[n+24>>2]=c[q+24>>2];c[n+28>>2]=c[q+28>>2];YEi(g+112|0,m|0,416)|0;In[k&4095](f,g);i=d;return}function YHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+608|0;f=e+352|0;g=e+320|0;h=e+256|0;j=e;k=c[b+24>>2]|0;if(!k)l=12;else l=(c[k>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,256)|0;xGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;xGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;qIb(f,g,0)|0;i=e;return}function ZHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+208|0;f=e+136|0;g=e+104|0;h=e+72|0;j=e;k=c[b+24>>2]|0;if(!k)l=76;else l=(c[k>>2]|0)+76|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+72|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;rIb(f,g,0)|0;i=e;return}function _Hb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+720|0;f=e+424|0;g=e+392|0;h=e+296|0;j=e;k=c[b+24>>2]|0;if(!k)l=112;else l=(c[k>>2]|0)+112|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,296)|0;dHa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;dHa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;BJb(f,g,0)|0;i=e;return}function $Hb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+688|0;f=e+624|0;g=e+592|0;h=e+64|0;j=e;k=c[b+24>>2]|0;if(!k)l=216;else l=(c[k>>2]|0)+216|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+64|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));mHa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;mHa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;MJb(f,g,0)|0;i=e;return}function aIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function bIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;g=d+64|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;BEb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+64|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function cIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+112|0;g=d+80|0;h=d+32|0;j=d;k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](j,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=o;o=h+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[h+20>>2]=p;c[h+24>>2]=j;c[h+28>>2]=l;c[h+32>>2]=k;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;yJb(h,1,f+12|0,g);a[g>>0]=0;zJb(h,2,f+36|0,g);f=c[m>>2]|0;m=c[e+20>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];In[m&4095](f,g);i=d;return}function dIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+192|0;g=d+96|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;AJb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+96|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function eIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+2240|0;g=d+1696|0;h=d+16|0;j=d+1648|0;k=d;l=d+1104|0;m=d+560|0;n=c[b>>2]|0;o=c[n+8>>2]|0;if((o|0)!=0?(p=o+-1|0,q=c[n+4>>2]|0,n=q+(p<<3)|0,(a[q+(p<<3)+4>>0]|0)==0):0){p=b+36|0;if(!(a[p>>0]|0)){r=o;s=q;t=0}else{q=c[b+20>>2]|0;o=(_n[c[(c[q>>2]|0)+16>>2]&4095](q,c[n>>2]|0)|0)&1;a[p>>0]=o;n=c[b>>2]|0;r=c[n+8>>2]|0;s=c[n+4>>2]|0;t=o}a[s+(r+-1<<3)+5>>0]=t;t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=a[p>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}p=b+24|0;In[c[e+16>>2]&4095](l,c[p>>2]|0);t=b+8|0;c[k+0>>2]=c[t+0>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];r=c[b>>2]|0;s=c[b+4>>2]|0;o=c[b+20>>2]|0;n=c[b+28>>2]|0;q=c[b+32>>2]|0;c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[g>>2]=r;c[g+4>>2]=s;t=g+8|0;c[t+0>>2]=c[k+0>>2];c[t+4>>2]=c[k+4>>2];c[t+8>>2]=c[k+8>>2];c[g+20>>2]=o;c[g+24>>2]=l;c[g+28>>2]=n;c[g+32>>2]=q;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;NJb(g,f,0);OJb(g,f+16|0,0);PJb(g,f+32|0,0);QJb(g,f+48|0,0);c[j>>2]=r;c[j+4>>2]=s;s=j+8|0;c[s+0>>2]=c[h+0>>2];c[s+4>>2]=c[h+4>>2];c[s+8>>2]=c[h+8>>2];c[j+20>>2]=o;c[j+24>>2]=l;c[j+28>>2]=n;c[j+32>>2]=q;a[j+36>>0]=1;c[j+40>>2]=0;c[j+44>>2]=0;RJb(j,f+64|0,0);f=c[p>>2]|0;p=c[l+64>>2]|0;j=p<<3;YEi(m|0,l|0,j|0)|0;c[m+64>>2]=p;q=m+80|0;n=l+80|0;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[q+16>>2]=c[n+16>>2];c[q+20>>2]=c[n+20>>2];c[q+24>>2]=c[n+24>>2];c[q+28>>2]=c[n+28>>2];q=l+112|0;YEi(m+112|0,q|0,416)|0;o=m+528|0;s=l+528|0;c[o+0>>2]=c[s+0>>2];c[o+4>>2]=c[s+4>>2];c[o+8>>2]=c[s+8>>2];c[o+12>>2]=c[s+12>>2];YEi(h|0,m|0,j|0)|0;c[h+64>>2]=p;m=h+80|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];c[m+24>>2]=c[n+24>>2];c[m+28>>2]=c[n+28>>2];YEi(h+112|0,q|0,416)|0;m=h+528|0;c[m+0>>2]=c[s+0>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];m=c[e+20>>2]|0;YEi(g|0,h|0,j|0)|0;c[g+64>>2]=p;p=g+80|0;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];c[p+12>>2]=c[n+12>>2];c[p+16>>2]=c[n+16>>2];c[p+20>>2]=c[n+20>>2];c[p+24>>2]=c[n+24>>2];c[p+28>>2]=c[n+28>>2];YEi(g+112|0,q|0,416)|0;q=g+528|0;c[q+0>>2]=c[s+0>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];c[q+12>>2]=c[s+12>>2];In[m&4095](f,g);i=d;return}function fIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+608|0;f=e+352|0;g=e+320|0;h=e+256|0;j=e;k=c[b+24>>2]|0;if(!k)l=12;else l=(c[k>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,256)|0;xGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;xGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;qIb(f,g,0)|0;i=e;return}function gIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+208|0;f=e+136|0;g=e+104|0;h=e+72|0;j=e;k=c[b+24>>2]|0;if(!k)l=76;else l=(c[k>>2]|0)+76|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+72|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GGa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GGa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;rIb(f,g,0)|0;i=e;return}function hIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+720|0;f=e+424|0;g=e+392|0;h=e+296|0;j=e;k=c[b+24>>2]|0;if(!k)l=112;else l=(c[k>>2]|0)+112|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,296)|0;dHa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;dHa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;BJb(f,g,0)|0;i=e;return}function iIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;SJb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+16|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;TJb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+32|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;UJb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+48|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[J+0>>2];c[b+4>>2]=c[J+4>>2];c[b+8>>2]=c[J+8>>2];c[b+12>>2]=c[J+12>>2];b=c[J>>2]|0;if(G){J=G+-1|0;I=c[H+4>>2]|0;if(!(a[I+(J<<3)+4>>0]|0)){F=c[d+4>>2]|0;In[c[(c[F>>2]|0)+16>>2]&4095](F,c[I+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=b;a[g+4>>0]=0;b=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[b>>2]|0}c[b>>2]=M+1}else OAb(K,g)|0;VJb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){N=e+4|0;i=f;return N|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){O=h;P=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;O=g;P=c[g+8>>2]|0}c[O+8>>2]=P+-1;N=e+4|0;i=f;return N|0}function jIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+72>>2]|0;k=c[b+64>>2]|0;b=c[d>>2]|0;l=c[b+8>>2]|0;if(l){m=l+-1|0;n=c[b+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=b;q=l}}else{p=b;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){b=(c[p+4>>2]|0)+(q<<3)|0;if(!b)r=q;else{q=g;l=c[q+4>>2]|0;m=b;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;p=c[d+20>>2]|0;if(p)c[p>>2]=(c[p>>2]|0)+1;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;EFa(h);In[j&4095](g,c[d+8>>2]|0);j=d+4|0;WJb(c[d>>2]|0,g,c[j>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0);g=c[d>>2]|0;h=c[g+8>>2]|0;if(!h){s=e+1|0;i=f;return s|0}if(!(a[(c[g+4>>2]|0)+(h+-1<<3)+4>>0]|0)){t=g;u=h}else{h=c[j>>2]|0;ko[c[(c[h>>2]|0)+20>>2]&4095](h);h=c[d>>2]|0;t=h;u=c[h+8>>2]|0}c[t+8>>2]=u+-1;s=e+1|0;i=f;return s|0}function kIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function lIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;g=d+64|0;h=d;j=c[b>>2]|0;k=c[j+8>>2]|0;if((k|0)!=0?(l=k+-1|0,m=c[j+4>>2]|0,j=m+(l<<3)|0,(a[m+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){n=k;o=m;p=0}else{m=c[b+20>>2]|0;k=(_n[c[(c[m>>2]|0)+16>>2]&4095](m,c[j>>2]|0)|0)&1;a[l>>0]=k;j=c[b>>2]|0;n=c[j+8>>2]|0;o=c[j+4>>2]|0;p=k}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}l=b+24|0;In[c[e+16>>2]&4095](h,c[l>>2]|0);p=b+8|0;n=c[b+4>>2]|0;o=c[b+20>>2]|0;k=c[b+28>>2]|0;j=c[b+32>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=n;n=g+8|0;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[g+20>>2]=o;c[g+24>>2]=h;c[g+28>>2]=k;c[g+32>>2]=j;a[g+36>>0]=1;c[g+40>>2]=0;c[g+44>>2]=0;BEb(f,g,0)|0;f=c[l>>2]|0;l=c[e+20>>2]|0;e=g+0|0;j=h+0|0;h=e+64|0;do{c[e>>2]=c[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(h|0));In[l&4095](f,g);i=d;return}function mIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+112|0;g=d+80|0;h=d+32|0;j=d;k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](j,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=o;o=h+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[h+20>>2]=p;c[h+24>>2]=j;c[h+28>>2]=l;c[h+32>>2]=k;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;yJb(h,1,f+12|0,g);a[g>>0]=0;zJb(h,2,f+36|0,g);f=c[m>>2]|0;m=c[e+20>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];In[m&4095](f,g);i=d;return}function nIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){XJb(b);i=f;return}kIb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){XJb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){XJb(b);i=f;return}}function oIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){XJb(b);i=f;return}kIb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){XJb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){XJb(b);i=f;return}}function pIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){XJb(b);i=f;return}kIb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){XJb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){XJb(b);i=f;return}}function qIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;f=i;i=i+208|0;g=f;h=f+176|0;j=f+8|0;k=b+12|0;l=e+1|0;PEi(j|0,0,164)|0;PFa(j);m=c[k>>2]|0;n=c[d>>2]|0;o=c[n+8>>2]|0;if(o){p=o+-1|0;q=c[n+4>>2]|0;if(!(a[q+(p<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[q+(p<<3)>>2]|0);p=c[d>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=1;p=c[d>>2]|0;s=p;t=c[p+8>>2]|0}else{s=n;t=o}}else{s=n;t=0}c[g>>2]=m;a[g+4>>0]=0;m=s+8|0;if((c[s+12>>2]&2147483647)>>>0>t>>>0){n=(c[s+4>>2]|0)+(t<<3)|0;if(!n)u=t;else{t=g;o=c[t+4>>2]|0;p=n;c[p>>2]=c[t>>2];c[p+4>>2]=o;u=c[m>>2]|0}c[m>>2]=u+1}else OAb(s,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=l;c[h+12>>2]=k;YJb(d,0,h,0);k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){if(!(a[(c[k+4>>2]|0)+(l+-1<<3)+4>>0]|0)){v=k;w=l}else{l=c[d+4>>2]|0;ko[c[(c[l>>2]|0)+20>>2]&4095](l);l=c[d>>2]|0;v=l;w=c[l+8>>2]|0}c[v+8>>2]=w+-1}w=b+36|0;v=e+2|0;PEi(j|0,0,168)|0;LFa(j);l=c[w>>2]|0;k=c[d>>2]|0;s=c[k+8>>2]|0;if(s){u=s+-1|0;m=c[k+4>>2]|0;if(!(a[m+(u<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[m+(u<<3)>>2]|0);u=c[d>>2]|0;a[(c[u+4>>2]|0)+((c[u+8>>2]|0)+-1<<3)+4>>0]=1;u=c[d>>2]|0;x=u;y=c[u+8>>2]|0}else{x=k;y=s}}else{x=k;y=0}c[g>>2]=l;a[g+4>>0]=0;l=x+8|0;if((c[x+12>>2]&2147483647)>>>0>y>>>0){k=(c[x+4>>2]|0)+(y<<3)|0;if(!k)z=y;else{y=g;s=c[y+4>>2]|0;u=k;c[u>>2]=c[y>>2];c[u+4>>2]=s;z=c[l>>2]|0}c[l>>2]=z+1}else OAb(x,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=v;c[h+12>>2]=w;ZJb(d,0,h,0);w=c[d>>2]|0;v=c[w+8>>2]|0;if(v){if(!(a[(c[w+4>>2]|0)+(v+-1<<3)+4>>0]|0)){A=w;B=v}else{v=c[d+4>>2]|0;ko[c[(c[v>>2]|0)+20>>2]&4095](v);v=c[d>>2]|0;A=v;B=c[v+8>>2]|0}c[A+8>>2]=B+-1}B=b+60|0;A=e+3|0;PEi(j|0,0,140)|0;TFa(j);j=c[B>>2]|0;v=c[d>>2]|0;w=c[v+8>>2]|0;if(w){x=w+-1|0;z=c[v+4>>2]|0;if(!(a[z+(x<<3)+4>>0]|0)){l=c[d+4>>2]|0;In[c[(c[l>>2]|0)+16>>2]&4095](l,c[z+(x<<3)>>2]|0);x=c[d>>2]|0;a[(c[x+4>>2]|0)+((c[x+8>>2]|0)+-1<<3)+4>>0]=1;x=c[d>>2]|0;C=x;D=c[x+8>>2]|0}else{C=v;D=w}}else{C=v;D=0}c[g>>2]=j;a[g+4>>0]=0;j=C+8|0;if((c[C+12>>2]&2147483647)>>>0>D>>>0){v=(c[C+4>>2]|0)+(D<<3)|0;if(!v)E=D;else{D=g;w=c[D+4>>2]|0;x=v;c[x>>2]=c[D>>2];c[x+4>>2]=w;E=c[j>>2]|0}c[j>>2]=E+1}else OAb(C,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=A;c[h+12>>2]=B;_Jb(d,0,h,0);B=c[d>>2]|0;A=c[B+8>>2]|0;if(!A)F=B;else{if(!(a[(c[B+4>>2]|0)+(A+-1<<3)+4>>0]|0)){G=B;H=A}else{A=c[d+4>>2]|0;ko[c[(c[A>>2]|0)+20>>2]&4095](A);A=c[d>>2]|0;G=A;H=c[A+8>>2]|0}c[G+8>>2]=H+-1;F=c[d>>2]|0}H=b+84|0;G=e+4|0;A=c[H>>2]|0;B=c[F+8>>2]|0;if(B){C=B+-1|0;E=c[F+4>>2]|0;if(!(a[E+(C<<3)+4>>0]|0)){j=c[d+4>>2]|0;In[c[(c[j>>2]|0)+16>>2]&4095](j,c[E+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;I=C;J=c[C+8>>2]|0}else{I=F;J=B}}else{I=F;J=0}c[g>>2]=A;a[g+4>>0]=0;A=I+8|0;if((c[I+12>>2]&2147483647)>>>0>J>>>0){F=(c[I+4>>2]|0)+(J<<3)|0;if(!F)K=J;else{J=g;B=c[J+4>>2]|0;C=F;c[C>>2]=c[J>>2];c[C+4>>2]=B;K=c[A>>2]|0}c[A>>2]=K+1}else OAb(I,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=G;c[h+12>>2]=H;$Jb(d,0,h,0);H=c[d>>2]|0;G=c[H+8>>2]|0;if(!G){L=0;M=H}else{if(!(a[(c[H+4>>2]|0)+(G+-1<<3)+4>>0]|0)){N=H;O=G}else{G=c[d+4>>2]|0;ko[c[(c[G>>2]|0)+20>>2]&4095](G);G=c[d>>2]|0;N=G;O=c[G+8>>2]|0}c[N+8>>2]=O+-1;O=c[d>>2]|0;L=c[O+8>>2]|0;M=O}O=b+108|0;N=e+5|0;G=c[O>>2]|0;if(L){H=L+-1|0;I=c[M+4>>2]|0;if(!(a[I+(H<<3)+4>>0]|0)){K=c[d+4>>2]|0;In[c[(c[K>>2]|0)+16>>2]&4095](K,c[I+(H<<3)>>2]|0);H=c[d>>2]|0;a[(c[H+4>>2]|0)+((c[H+8>>2]|0)+-1<<3)+4>>0]=1;H=c[d>>2]|0;P=H;Q=c[H+8>>2]|0}else{P=M;Q=L}}else{P=M;Q=0}c[g>>2]=G;a[g+4>>0]=0;G=P+8|0;if((c[P+12>>2]&2147483647)>>>0>Q>>>0){M=(c[P+4>>2]|0)+(Q<<3)|0;if(!M)R=Q;else{Q=g;L=c[Q+4>>2]|0;H=M;c[H>>2]=c[Q>>2];c[H+4>>2]=L;R=c[G>>2]|0}c[G>>2]=R+1}else OAb(P,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=N;c[h+12>>2]=O;aKb(d,0,h,0);O=c[d>>2]|0;N=c[O+8>>2]|0;if(!N){S=0;T=O}else{if(!(a[(c[O+4>>2]|0)+(N+-1<<3)+4>>0]|0)){U=O;V=N}else{N=c[d+4>>2]|0;ko[c[(c[N>>2]|0)+20>>2]&4095](N);N=c[d>>2]|0;U=N;V=c[N+8>>2]|0}c[U+8>>2]=V+-1;V=c[d>>2]|0;S=c[V+8>>2]|0;T=V}V=b+132|0;U=e+6|0;N=c[V>>2]|0;if(S){O=S+-1|0;P=c[T+4>>2]|0;if(!(a[P+(O<<3)+4>>0]|0)){R=c[d+4>>2]|0;In[c[(c[R>>2]|0)+16>>2]&4095](R,c[P+(O<<3)>>2]|0);O=c[d>>2]|0;a[(c[O+4>>2]|0)+((c[O+8>>2]|0)+-1<<3)+4>>0]=1;O=c[d>>2]|0;W=O;X=c[O+8>>2]|0}else{W=T;X=S}}else{W=T;X=0}c[g>>2]=N;a[g+4>>0]=0;N=W+8|0;if((c[W+12>>2]&2147483647)>>>0>X>>>0){T=(c[W+4>>2]|0)+(X<<3)|0;if(!T)Y=X;else{X=g;S=c[X+4>>2]|0;O=T;c[O>>2]=c[X>>2];c[O+4>>2]=S;Y=c[N>>2]|0}c[N>>2]=Y+1}else OAb(W,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=U;c[h+12>>2]=V;bKb(d,0,h,0);V=c[d>>2]|0;U=c[V+8>>2]|0;if(!U){Z=0;_=V}else{if(!(a[(c[V+4>>2]|0)+(U+-1<<3)+4>>0]|0)){$=V;aa=U}else{U=c[d+4>>2]|0;ko[c[(c[U>>2]|0)+20>>2]&4095](U);U=c[d>>2]|0;$=U;aa=c[U+8>>2]|0}c[$+8>>2]=aa+-1;aa=c[d>>2]|0;Z=c[aa+8>>2]|0;_=aa}aa=b+156|0;$=e+7|0;U=c[aa>>2]|0;do if(!Z){ba=_;ca=0}else{V=Z+-1|0;W=c[_+4>>2]|0;if(a[W+(V<<3)+4>>0]|0){ba=_;ca=Z;break}Y=c[d+4>>2]|0;In[c[(c[Y>>2]|0)+16>>2]&4095](Y,c[W+(V<<3)>>2]|0);V=c[d>>2]|0;a[(c[V+4>>2]|0)+((c[V+8>>2]|0)+-1<<3)+4>>0]=1;V=c[d>>2]|0;ba=V;ca=c[V+8>>2]|0}while(0);c[g>>2]=U;a[g+4>>0]=0;U=ba+8|0;if((c[ba+12>>2]&2147483647)>>>0>ca>>>0){Z=(c[ba+4>>2]|0)+(ca<<3)|0;if(!Z)da=ca;else{ca=g;_=c[ca+4>>2]|0;V=Z;c[V>>2]=c[ca>>2];c[V+4>>2]=_;da=c[U>>2]|0}c[U>>2]=da+1}else OAb(ba,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=$;c[h+12>>2]=aa;cKb(d,0,h,0);aa=c[d>>2]|0;$=c[aa+8>>2]|0;if(!$){ea=0;fa=aa}else{if(!(a[(c[aa+4>>2]|0)+($+-1<<3)+4>>0]|0)){ga=aa;ha=$}else{$=c[d+4>>2]|0;ko[c[(c[$>>2]|0)+20>>2]&4095]($);$=c[d>>2]|0;ga=$;ha=c[$+8>>2]|0}c[ga+8>>2]=ha+-1;ha=c[d>>2]|0;ea=c[ha+8>>2]|0;fa=ha}ha=b+180|0;ga=e+8|0;$=c[ha>>2]|0;do if(!ea){ia=fa;ja=0}else{aa=ea+-1|0;ba=c[fa+4>>2]|0;if(a[ba+(aa<<3)+4>>0]|0){ia=fa;ja=ea;break}da=c[d+4>>2]|0;In[c[(c[da>>2]|0)+16>>2]&4095](da,c[ba+(aa<<3)>>2]|0);aa=c[d>>2]|0;a[(c[aa+4>>2]|0)+((c[aa+8>>2]|0)+-1<<3)+4>>0]=1;aa=c[d>>2]|0;ia=aa;ja=c[aa+8>>2]|0}while(0);c[g>>2]=$;a[g+4>>0]=0;$=ia+8|0;if((c[ia+12>>2]&2147483647)>>>0>ja>>>0){ea=(c[ia+4>>2]|0)+(ja<<3)|0;if(!ea)ka=ja;else{ja=g;fa=c[ja+4>>2]|0;aa=ea;c[aa>>2]=c[ja>>2];c[aa+4>>2]=fa;ka=c[$>>2]|0}c[$>>2]=ka+1}else OAb(ia,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=ga;c[h+12>>2]=ha;dKb(d,0,h,0);ha=c[d>>2]|0;ga=c[ha+8>>2]|0;if(!ga){la=0;ma=ha}else{if(!(a[(c[ha+4>>2]|0)+(ga+-1<<3)+4>>0]|0)){na=ha;oa=ga}else{ga=c[d+4>>2]|0;ko[c[(c[ga>>2]|0)+20>>2]&4095](ga);ga=c[d>>2]|0;na=ga;oa=c[ga+8>>2]|0}c[na+8>>2]=oa+-1;oa=c[d>>2]|0;la=c[oa+8>>2]|0;ma=oa}oa=b+204|0;na=e+9|0;ga=c[oa>>2]|0;do if(!la){pa=ma;qa=0}else{ha=la+-1|0;ia=c[ma+4>>2]|0;if(a[ia+(ha<<3)+4>>0]|0){pa=ma;qa=la;break}ka=c[d+4>>2]|0;In[c[(c[ka>>2]|0)+16>>2]&4095](ka,c[ia+(ha<<3)>>2]|0);ha=c[d>>2]|0;a[(c[ha+4>>2]|0)+((c[ha+8>>2]|0)+-1<<3)+4>>0]=1;ha=c[d>>2]|0;pa=ha;qa=c[ha+8>>2]|0}while(0);c[g>>2]=ga;a[g+4>>0]=0;ga=pa+8|0;if((c[pa+12>>2]&2147483647)>>>0>qa>>>0){la=(c[pa+4>>2]|0)+(qa<<3)|0;if(!la)ra=qa;else{qa=g;ma=c[qa+4>>2]|0;ha=la;c[ha>>2]=c[qa>>2];c[ha+4>>2]=ma;ra=c[ga>>2]|0}c[ga>>2]=ra+1}else OAb(pa,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=na;c[h+12>>2]=oa;eKb(d,0,h,0);oa=c[d>>2]|0;na=c[oa+8>>2]|0;if(!na){sa=0;ta=oa}else{if(!(a[(c[oa+4>>2]|0)+(na+-1<<3)+4>>0]|0)){ua=oa;va=na}else{na=c[d+4>>2]|0;ko[c[(c[na>>2]|0)+20>>2]&4095](na);na=c[d>>2]|0;ua=na;va=c[na+8>>2]|0}c[ua+8>>2]=va+-1;va=c[d>>2]|0;sa=c[va+8>>2]|0;ta=va}va=b+228|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[va+0>>2];c[b+4>>2]=c[va+4>>2];c[b+8>>2]=c[va+8>>2];c[b+12>>2]=c[va+12>>2];b=c[va>>2]|0;do if(!sa){wa=ta;xa=0}else{va=sa+-1|0;ua=c[ta+4>>2]|0;if(a[ua+(va<<3)+4>>0]|0){wa=ta;xa=sa;break}na=c[d+4>>2]|0;In[c[(c[na>>2]|0)+16>>2]&4095](na,c[ua+(va<<3)>>2]|0);va=c[d>>2]|0;a[(c[va+4>>2]|0)+((c[va+8>>2]|0)+-1<<3)+4>>0]=1;va=c[d>>2]|0;wa=va;xa=c[va+8>>2]|0}while(0);c[g>>2]=b;a[g+4>>0]=0;b=wa+8|0;if((c[wa+12>>2]&2147483647)>>>0>xa>>>0){sa=(c[wa+4>>2]|0)+(xa<<3)|0;if(!sa)ya=xa;else{xa=g;ta=c[xa+4>>2]|0;va=sa;c[va>>2]=c[xa>>2];c[va+4>>2]=ta;ya=c[b>>2]|0}c[b>>2]=ya+1}else OAb(wa,g)|0;fKb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){za=e+12|0;i=f;return za|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){Aa=h;Ba=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;Aa=g;Ba=c[g+8>>2]|0}c[Aa+8>>2]=Ba+-1;za=e+12|0;i=f;return za|0}function rIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+12|0;k=e+1|0;l=c[j>>2]|0;m=c[d>>2]|0;n=c[m+8>>2]|0;if(n){o=n+-1|0;p=c[m+4>>2]|0;if(!(a[p+(o<<3)+4>>0]|0)){q=c[d+4>>2]|0;In[c[(c[q>>2]|0)+16>>2]&4095](q,c[p+(o<<3)>>2]|0);o=c[d>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=1;o=c[d>>2]|0;r=o;s=c[o+8>>2]|0}else{r=m;s=n}}else{r=m;s=0}c[g>>2]=l;a[g+4>>0]=0;l=r+8|0;if((c[r+12>>2]&2147483647)>>>0>s>>>0){m=(c[r+4>>2]|0)+(s<<3)|0;if(!m)t=s;else{s=g;n=c[s+4>>2]|0;o=m;c[o>>2]=c[s>>2];c[o+4>>2]=n;t=c[l>>2]|0}c[l>>2]=t+1}else OAb(r,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=k;c[h+12>>2]=j;gKb(d,0,h,0);j=c[d>>2]|0;k=c[j+8>>2]|0;if(!k){u=0;v=j}else{if(!(a[(c[j+4>>2]|0)+(k+-1<<3)+4>>0]|0)){w=j;x=k}else{k=c[d+4>>2]|0;ko[c[(c[k>>2]|0)+20>>2]&4095](k);k=c[d>>2]|0;w=k;x=c[k+8>>2]|0}c[w+8>>2]=x+-1;x=c[d>>2]|0;u=c[x+8>>2]|0;v=x}x=b+36|0;b=e+2|0;w=c[x>>2]|0;if(u){k=u+-1|0;j=c[v+4>>2]|0;if(!(a[j+(k<<3)+4>>0]|0)){r=c[d+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[j+(k<<3)>>2]|0);k=c[d>>2]|0;a[(c[k+4>>2]|0)+((c[k+8>>2]|0)+-1<<3)+4>>0]=1;k=c[d>>2]|0;y=k;z=c[k+8>>2]|0}else{y=v;z=u}}else{y=v;z=0}c[g>>2]=w;a[g+4>>0]=0;w=y+8|0;if((c[y+12>>2]&2147483647)>>>0>z>>>0){v=(c[y+4>>2]|0)+(z<<3)|0;if(!v)A=z;else{z=g;u=c[z+4>>2]|0;k=v;c[k>>2]=c[z>>2];c[k+4>>2]=u;A=c[w>>2]|0}c[w>>2]=A+1}else OAb(y,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=b;c[h+12>>2]=x;hKb(d,0,h,0);h=c[d>>2]|0;x=c[h+8>>2]|0;if(!x){B=e+4|0;i=f;return B|0}if(!(a[(c[h+4>>2]|0)+(x+-1<<3)+4>>0]|0)){C=h;D=x}else{x=c[d+4>>2]|0;ko[c[(c[x>>2]|0)+20>>2]&4095](x);x=c[d>>2]|0;C=x;D=c[x+8>>2]|0}c[C+8>>2]=D+-1;B=e+4|0;i=f;return B|0}function sIb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;if((c[a+32>>2]&2147483647)>>>0<b>>>0)iKb(a,b);f=c[a+24>>2]|0;h=a+28|0;a=c[h>>2]|0;j=f+(b<<2)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=f+(a<<2)|0;do{if(k)g[k>>2]=ea(g[d>>2]);k=k+4|0}while(k>>>0<j>>>0);c[h>>2]=b;i=e;return}function tIb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+12|0;f=c[e>>2]|0;g=(f&2147483647|0)==0?1:f<<1;if(!g)h=0;else{f=c[c[a>>2]>>2]|0;h=Bn[c[(c[f>>2]|0)+8>>2]&255](f,g<<3,527016,537640,558)|0}f=a+8|0;j=c[f>>2]|0;k=h+(j<<3)|0;l=a+4|0;if((j|0)>0){m=h;n=c[l>>2]|0;while(1){if(m){o=n;p=c[o+4>>2]|0;q=m;c[q>>2]=c[o>>2];c[q+4>>2]=p}m=m+8|0;if(m>>>0>=k>>>0)break;else n=n+8|0}r=c[f>>2]|0}else r=j;j=h+(r<<3)|0;if(j){r=b;b=c[r+4>>2]|0;n=j;c[n>>2]=c[r>>2];c[n+4>>2]=b}if((c[e>>2]|0)>-1?(b=c[l>>2]|0,(b|0)!=0):0){n=c[c[a>>2]>>2]|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,b)}c[l>>2]=h;c[e>>2]=g;g=c[f>>2]|0;c[f>>2]=g+1;i=d;return h+(g<<3)|0}function uIb(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;h=b+236|0;if(!(c[h>>2]&4096))j=b+60|0;else{k=b+8|0;l=c[k>>2]|0;if(!l){m=s4(c[b>>2]|0,(c[b+4>>2]|0)>>>24&15)|0;c[k>>2]=m;n=m}else n=l;j=n+268|0}n=d[e>>0]&1;l=(a[j>>0]&1)!=0;j=(n|0)!=0&(l^1);m=l&(n|0)==0;n=b+4|0;l=(c[n>>2]|0)>>>30;if((l|0)==2){if(!(a[(c[b>>2]|0)+2417>>0]|0))o=8}else if((l|0)!=3)o=8;if((o|0)==8){if(j){c[b+232>>2]=1;o=b+204|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0}o=c[b>>2]|0;if(!o)p=0;else p=c[o+1256>>2]|0;a[g>>0]=a[e>>0]|0;a9(b+16|0,p,g);i=f;return}if(!j){if(m)c[h>>2]=c[h>>2]&-8193}else eVa(b);m=b+8|0;j=c[m>>2]|0;if(!j){g=s4(c[b>>2]|0,(c[n>>2]|0)>>>24&15)|0;c[m>>2]=g;q=g}else q=j;a[q+268>>0]=a[e>>0]|0;r4(c[b>>2]|0,b);c[h>>2]=c[h>>2]|4096;i=f;return}function vIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else TCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}UCb(m,n,f,a);f=a+264|0;h=a+268|0;UCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=a+276|0;a=m;d=g;while(1){g=c[d>>2]|0;q=g+((c[f>>2]|0)*52|0)|0;if((g|0)==(q|0))r=a;else{p=a;o=g;while(1){if((p|0)!=(m+(n<<2)|0)?(c[p>>2]|0)==(o|0):0)s=p+4|0;else{ko[c[c[o>>2]>>2]&4095](o);s=p}o=o+52|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else a=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function wIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+176|0;g=f+136|0;h=f;j=h;c[j>>2]=0;c[j+4>>2]=0;j=h+4|0;a[j>>0]=0;k=f+8|0;c[h>>2]=k;l=d+-1|0;if((l|0)>0){d=0;m=0;n=0;o=l;l=k;k=32;a:while(1){p=n;q=m;r=o;while(1){if((r|0)>(p|0)){if((r-p|0)>>>0<5)s=p;else break;do{t=s;s=s+1|0;u=s;v=t;while(1){v=(c[(c[b+(u<<5)+16>>2]|0)+56>>2]|0)>>>0>(c[(c[b+(v<<5)+16>>2]|0)+56>>2]|0)>>>0?u:v;if((u|0)>=(r|0))break;else u=u+1|0}u=b+(v<<5)|0;w=b+(t<<5)|0;c[g+0>>2]=c[u+0>>2];c[g+4>>2]=c[u+4>>2];c[g+8>>2]=c[u+8>>2];c[g+12>>2]=c[u+12>>2];c[g+16>>2]=c[u+16>>2];c[g+20>>2]=c[u+20>>2];c[g+24>>2]=c[u+24>>2];c[g+28>>2]=c[u+28>>2];c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];c[u+16>>2]=c[w+16>>2];c[u+20>>2]=c[w+20>>2];c[u+24>>2]=c[w+24>>2];c[u+28>>2]=c[w+28>>2];c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];c[w+16>>2]=c[g+16>>2];c[w+20>>2]=c[g+20>>2];c[w+24>>2]=c[g+24>>2];c[w+28>>2]=c[g+28>>2]}while((s|0)!=(r|0))}if(!q)break a;w=c[l+(q+-1<<2)>>2]|0;u=q+-2|0;p=c[l+(u<<2)>>2]|0;q=u;r=w}w=jKb(b,p,r,e)|0;if((w-p|0)<(r-w|0)){u=w+-1|0;if(q>>>0>=(k+-1|0)>>>0){x=k<<1;y=k<<3;if(!y)z=0;else{A=mKa()|0;B=c[(c[A>>2]|0)+8>>2]|0;C=pKa()|0;D=mo[c[(c[C>>2]|0)+24>>2]&4095](C)|0;z=Bn[B&255](A,y,D?490104:544544,523928,148)|0}YEi(z|0,l|0,q<<2|0)|0;if(d<<24>>24==0|(l|0)==0){E=1;F=x;G=z}else{D=mKa()|0;In[c[(c[D>>2]|0)+12>>2]&4095](D,l);E=1;F=x;G=z}}else{E=d;F=k;G=l}c[G+(q<<2)>>2]=p;c[G+(q+1<<2)>>2]=u;H=E;I=w+1|0;J=r;K=G;L=F}else{u=w+1|0;if(q>>>0>=(k+-1|0)>>>0){x=k<<1;D=k<<3;if(!D)M=0;else{y=mKa()|0;A=c[(c[y>>2]|0)+8>>2]|0;B=pKa()|0;C=mo[c[(c[B>>2]|0)+24>>2]&4095](B)|0;M=Bn[A&255](y,D,C?490104:544544,523928,148)|0}YEi(M|0,l|0,q<<2|0)|0;if(d<<24>>24==0|(l|0)==0){N=1;O=x;P=M}else{C=mKa()|0;In[c[(c[C>>2]|0)+12>>2]&4095](C,l);N=1;O=x;P=M}}else{N=d;O=k;P=l}c[P+(q<<2)>>2]=u;c[P+(q+1<<2)>>2]=r;H=N;I=p;J=w+-1|0;K=P;L=O}d=H;m=q+2|0;n=I;o=J;l=K;k=L}if(!(d<<24>>24==0|(l|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,l)}}if(!(a[j>>0]|0)){i=f;return}tKa(h,c[h>>2]|0);i=f;return}function xIb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<2,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?491696:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<2)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j)c[j>>2]=c[f>>2];j=j+4|0;if(j>>>0>=e>>>0)break;else f=f+4|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function yIb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+8>>2]&2147483647)>>>0<b>>>0)kKb(a,b);f=c[a>>2]|0;g=a+4|0;a=c[g>>2]|0;h=f+(b<<5)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<5)|0;do{if(j){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];c[j+24>>2]=c[d+24>>2];c[j+28>>2]=c[d+28>>2]}j=j+32|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function zIb(d){d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=0,T=Im,U=Im,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=Im,ha=0,ia=0,ja=Im,ka=0,la=0,ma=0;f=i;i=i+128|0;h=f+56|0;j=f+48|0;k=f+24|0;l=f;m=d+1200|0;n=c[m>>2]|0;g[d+172>>2]=ea(g[n>>2]);g[d+176>>2]=ea(g[n+4>>2]);g[d+180>>2]=ea(g[n+8>>2]);c[d+184>>2]=0;b[d+192>>1]=0;b[d+196>>1]=0;g[d+188>>2]=ea(g[n+12>>2]);b[d+198>>1]=0;n=d+1208|0;o=c[n>>2]|0;a:do if(o>>>0>1){p=d+1204|0;q=1;r=o;s=1;t=1;while(1){u=t&65535;b:do if(!(t<<16>>16))v=-1;else{w=c[p>>2]|0;x=b[w+(q<<2)>>1]|0;y=w+(q<<2)+2|0;z=u;while(1){z=z+-1|0;A=e[d+(z*28|0)+192>>1]|0;if(((b[w+(A<<2)>>1]|0)==x<<16>>16?(b[w+(A<<2)+2>>1]|0)==(b[y>>1]|0):0)?(A=c[m>>2]|0,B=ea(g[d+(z*28|0)+172>>2]),C=ea(B*ea(g[A+(q<<6)>>2])),B=ea(g[d+(z*28|0)+176>>2]),D=ea(C+ea(B*ea(g[A+(q<<6)+4>>2]))),B=ea(g[d+(z*28|0)+180>>2]),ea(D+ea(B*ea(g[A+(q<<6)+8>>2])))>=ea(.995000004)):0){v=z;break b}if(!z){v=-1;break}}}while(0);z=u+-1|0;if((v|0)==(z|0)){E=r;F=t}else{b[d+(z*28|0)+194>>1]=q-(e[d+(z*28|0)+192>>1]|0);if(t<<16>>16==32){G=q;H=32;break a}z=d+(u*28|0)+172|0;b[d+(u*28|0)+192>>1]=s;c[d+(u*28|0)+184>>2]=0;if((v|0)==-1){b[d+(u*28|0)+196>>1]=t;y=c[m>>2]|0;g[z>>2]=ea(g[y+(q<<6)>>2]);g[d+(u*28|0)+176>>2]=ea(g[y+(q<<6)+4>>2]);g[d+(u*28|0)+180>>2]=ea(g[y+(q<<6)+8>>2]);g[d+(u*28|0)+188>>2]=ea(g[(c[m>>2]|0)+(q<<6)+12>>2]);b[d+(u*28|0)+198>>1]=t}else{y=b[d+(v*28|0)+196>>1]|0;c[d+(v*28|0)+184>>2]=z;g[z>>2]=ea(g[d+(v*28|0)+172>>2]);g[d+(u*28|0)+176>>2]=ea(g[d+(v*28|0)+176>>2]);g[d+(u*28|0)+180>>2]=ea(g[d+(v*28|0)+180>>2]);z=d+((y&65535)*28|0)+188|0;B=ea(g[z>>2]);D=ea(g[(c[m>>2]|0)+(q<<6)+12>>2]);C=B<D?B:D;g[d+(u*28|0)+188>>2]=C;g[z>>2]=C;b[d+(u*28|0)+196>>1]=y;b[d+(u*28|0)+198>>1]=t}E=c[n>>2]|0;F=t+1<<16>>16}s=s+1<<16>>16;y=s&65535;if(y>>>0>=E>>>0){G=y;H=F;break}else{q=y;r=E;t=F}}}else{G=1;H=1}while(0);F=H&65535;E=F+-1|0;b[d+(E*28|0)+194>>1]=G-(e[d+(E*28|0)+192>>1]|0);E=H<<16>>16==0;if(E){a[j>>0]=0;lKb(d+1068|0,F,j,h);I=0;J=d+168|0;c[J>>2]=I;i=f;return}else K=0;do{c[d+(K<<2)+1068>>2]=d+(K*28|0)+172;K=K+1|0}while((K|0)!=(F|0));a[j>>0]=0;lKb(d+1068|0,F,j,h);if(E){I=0;J=d+168|0;c[J>>2]=I;i=f;return}E=l+16|0;j=0;K=0;c:while(1){H=d+(j<<2)+1068|0;G=c[H>>2]|0;d:do if((b[G+24>>1]|0)==(b[G+26>>1]|0)){if((K|0)==6){I=6;L=74;break c}n=K+1|0;v=d+(K*28|0)|0;o=(G|0)==0;e:do if(o)M=0;else{t=0;r=G;do{t=(e[r+22>>1]|0)+t|0;r=c[r+12>>2]|0}while((r|0)!=0);if(t>>>0<7){if(o){M=t;break}else{N=0;O=G}while(1){r=b[O+22>>1]|0;if(!(r<<16>>16))P=N;else{q=e[O+20>>1]|0;s=r&65535;r=s>>>0>1?s:1;p=0;y=N;while(1){c[d+(K*28|0)+(y<<2)+4>>2]=q+p;p=p+1|0;if(p>>>0>=s>>>0)break;else y=y+1|0}P=N+r|0}O=c[O+12>>2]|0;if(!O){M=t;break e}else N=P}}if(o)Q=0;else{C=ea(0.0);t=0;y=G;while(1){s=b[y+22>>1]|0;if(!(s<<16>>16)){R=C;S=t}else{p=e[y+20>>1]|0;q=c[m>>2]|0;z=s&65535;s=0;D=C;w=t;while(1){x=p+s|0;B=ea(g[q+(x<<6)+16>>2]);T=ea(B*B);B=ea(g[q+(x<<6)+20>>2]);U=ea(T+ea(B*B));B=ea(g[q+(x<<6)+24>>2]);T=ea(U+ea(B*B));A=D<T;V=A?x:w;B=A?T:D;s=s+1|0;if(s>>>0>=z>>>0){R=B;S=V;break}else{D=B;w=V}}}y=c[y+12>>2]|0;if(!y){Q=S;break}else{C=R;t=S}}}c[d+(K*28|0)+4>>2]=Q;t=c[m>>2]|0;C=ea(g[t+(Q<<6)+16>>2]);D=ea(g[t+(Q<<6)+20>>2]);B=ea(g[t+(Q<<6)+24>>2]);y=c[H>>2]|0;if(!y)W=Q;else{w=Q;T=ea(0.0);z=y;while(1){y=b[z+22>>1]|0;if(!(y<<16>>16)){X=w;Y=T}else{s=e[z+20>>1]|0;q=y&65535;y=0;p=w;U=T;while(1){r=s+y|0;Z=ea(C-ea(g[t+(r<<6)+16>>2]));_=ea(D-ea(g[t+(r<<6)+20>>2]));$=ea(B-ea(g[t+(r<<6)+24>>2]));aa=ea(ea(ea(Z*Z)+ea(_*_))+ea($*$));V=aa>U;A=V?r:p;$=V?aa:U;y=y+1|0;if(y>>>0>=q>>>0){X=A;Y=$;break}else{p=A;U=$}}}z=c[z+12>>2]|0;if(!z){W=X;break}else{w=X;T=Y}}}c[d+(K*28|0)+8>>2]=W;w=c[m>>2]|0;T=ea(g[w+(W<<6)+16>>2]);U=ea(g[w+(W<<6)+20>>2]);$=ea(C-T);T=ea(D-U);U=ea(B-ea(g[w+(W<<6)+24>>2]));z=c[H>>2]|0;aa=ea(g[z+8>>2]);_=ea(T*aa);Z=ea(g[z+4>>2]);ba=ea(_-ea(U*Z));_=ea(g[z>>2]);ca=ea(ea(U*_)-ea($*aa));aa=ea(ea($*Z)-ea(T*_));if(!z)da=W;else{t=W;_=ea(0.0);p=z;while(1){z=b[p+22>>1]|0;if(!(z<<16>>16)){fa=t;ga=_}else{q=e[p+20>>1]|0;y=z&65535;z=0;s=t;T=_;while(1){A=q+z|0;Z=ea(ea(g[w+(A<<6)+16>>2])-C);$=ea(ea(g[w+(A<<6)+20>>2])-D);U=ea(ea(ea(ba*Z)+ea(ca*$))+ea(aa*ea(ea(g[w+(A<<6)+24>>2])-B)));V=U>T;r=V?A:s;$=V?U:T;z=z+1|0;if(z>>>0>=y>>>0){fa=r;ga=$;break}else{s=r;T=$}}}p=c[p+12>>2]|0;if(!p){da=fa;break}else{t=fa;_=ga}}}c[d+(K*28|0)+12>>2]=da;t=c[H>>2]|0;if(!t)ha=da;else{p=da;_=ea(0.0);w=t;while(1){t=b[w+22>>1]|0;if(!(t<<16>>16)){ia=p;ja=_}else{s=e[w+20>>1]|0;y=c[m>>2]|0;z=t&65535;t=0;q=p;T=_;while(1){r=s+t|0;$=ea(ea(g[y+(r<<6)+16>>2])-C);U=ea(ea(g[y+(r<<6)+20>>2])-D);Z=ea(ea(ea(-ea(ca*U))-ea(ba*$))-ea(aa*ea(ea(g[y+(r<<6)+24>>2])-B)));V=Z>T;A=V?r:q;$=V?Z:T;t=t+1|0;if(t>>>0>=z>>>0){ia=A;ja=$;break}else{q=A;T=$}}}w=c[w+12>>2]|0;if(!w){ha=ia;break}else{p=ia;_=ja}}}c[d+(K*28|0)+16>>2]=ha;p=c[m>>2]|0;w=K*7|0;q=d+(w<<2)+4|0;c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];g[k>>2]=ea(ea(g[p+(Q<<6)+12>>2])+ea(-.00100000005));g[k+4>>2]=ea(ea(g[p+(W<<6)+12>>2])+ea(-.00100000005));g[k+8>>2]=ea(ea(g[p+(da<<6)+12>>2])+ea(-.00100000005));g[k+12>>2]=ea(ea(g[p+(ha<<6)+12>>2])+ea(-.00100000005));z=c[H>>2]|0;if(z){t=z;do{z=b[t+22>>1]|0;if(z<<16>>16){y=e[t+20>>1]|0;s=z&65535;z=0;do{A=y+z|0;_=ea(g[p+(A<<6)+16>>2]);B=ea(g[p+(A<<6)+20>>2]);aa=ea(g[p+(A<<6)+24>>2]);ba=ea(ea(g[p+(Q<<6)+16>>2])-_);ca=ea(ea(g[p+(Q<<6)+20>>2])-B);D=ea(ea(g[p+(Q<<6)+24>>2])-aa);C=ea(ea(ea(ba*ba)+ea(ca*ca))+ea(D*D));V=C<ea(3402823469999999843913219.0e14);D=V?C:ea(3402823469999999843913219.0e14);C=ea(ea(g[p+(W<<6)+16>>2])-_);ca=ea(ea(g[p+(W<<6)+20>>2])-B);ba=ea(ea(g[p+(W<<6)+24>>2])-aa);T=ea(ea(ea(C*C)+ea(ca*ca))+ea(ba*ba));V=D>T;ba=V?T:D;D=ea(ea(g[p+(da<<6)+16>>2])-_);T=ea(ea(g[p+(da<<6)+20>>2])-B);ca=ea(ea(g[p+(da<<6)+24>>2])-aa);C=ea(ea(ea(D*D)+ea(T*T))+ea(ca*ca));r=ba>C;ca=ea(ea(g[p+(ha<<6)+16>>2])-_);_=ea(ea(g[p+(ha<<6)+20>>2])-B);B=ea(ea(g[p+(ha<<6)+24>>2])-aa);x=(r?C:ba)>ea(ea(ea(ca*ca)+ea(_*_))+ea(B*B));ka=x?3:r?2:V&1;V=k+(ka<<2)|0;B=ea(g[V>>2]);_=ea(g[p+(A<<6)+12>>2]);if(B>_){c[l+(ka<<2)>>2]=A;g[V>>2]=_}z=z+1|0}while(z>>>0<s>>>0)}t=c[t+12>>2]|0}while((t|0)!=0)}t=h+0|0;p=t+64|0;do{a[t>>0]=0;t=t+1|0}while((t|0)<(p|0));c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];c[q+12>>2]=c[l+12>>2];a[h+(c[l>>2]|0)>>0]=1;a[h+(c[l+4>>2]|0)>>0]=1;a[h+(c[l+8>>2]|0)>>0]=1;a[h+(c[l+12>>2]|0)>>0]=1;t=E;c[t>>2]=0;c[t+4>>2]=0;g[k+16>>2]=ea(3402823469999999843913219.0e14);g[k+20>>2]=ea(3402823469999999843913219.0e14);t=c[H>>2]|0;if(t){p=t;do{t=b[p+22>>1]|0;if(t<<16>>16){s=e[p+20>>1]|0;z=t&65535;t=0;do{y=s+t|0;f:do if(!(a[h+y>>0]|0)){_=ea(g[(c[m>>2]|0)+(y<<6)+12>>2]);V=4;while(1){la=k+(V<<2)|0;A=V+1|0;if(_<ea(g[la>>2]))break;if(A>>>0<6)V=A;else break f}if(V>>>0<5){A=5;do{ka=A;A=A+-1|0;g[k+(ka<<2)>>2]=ea(g[k+(A<<2)>>2]);c[l+(ka<<2)>>2]=c[l+(A<<2)>>2]}while(A>>>0>V>>>0)}g[la>>2]=_;c[l+(V<<2)>>2]=y}while(0);t=t+1|0}while(t>>>0<z>>>0)}p=c[p+12>>2]|0}while((p|0)!=0)}p=E;q=c[p+4>>2]|0;z=d+(w+4<<2)+4|0;c[z>>2]=c[p>>2];c[z+4>>2]=q;c[v>>2]=6;ma=n;break d}while(0);c[v>>2]=M;ma=n}else ma=K;while(0);j=j+1|0;if(j>>>0>=F>>>0){I=ma;L=74;break}else K=ma}if((L|0)==74){J=d+168|0;c[J>>2]=I;i=f;return}}function AIb(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+16|0;k=j;a[k>>0]=f;f=k+1|0;b[k+2>>1]=g;g=h;l=c[g>>2]|0;m=c[g+4>>2]|0;g=e+104|0;n=g;o=c[n>>2]|0;p=c[n+4>>2]|0;a[f>>0]=3;if((o|0)==0&(p|0)==0){q=l;r=m}else{n=ZEi(l|0,m|0,o|0,p|0)|0;p=H;if(!(p>>>0<0|(p|0)==0&n>>>0<256))if(p>>>0<0|(p|0)==0&n>>>0<65536)s=1;else s=p>>>0<1|(p|0)==1&n>>>0<0?2:3;else s=0;a[f>>0]=s;o=(s|0)==3;q=o?l:n;r=o?m:p}p=h;c[p>>2]=q;c[p+4>>2]=r;r=g;c[r>>2]=l;c[r+4>>2]=m;m=e+80|0;EIb(k,m);HIb(m,0,h,(d[f>>0]|0)&3);f=e+20|0;h=c[f>>2]|0;m=e+16|0;k=c[m>>2]|0;if((h-k|0)>>>0<(c[e+44>>2]|0)>>>0){i=j;return}r=c[e+72>>2]|0;l=(r|0)==0;if(l){t=h;u=k}else{oTa(c[r+4>>2]|0);t=c[f>>2]|0;u=c[m>>2]|0}k=t-u|0;t=c[e+36>>2]|0;if(!t)v=u;else{h=e+32|0;g=0;do{p=c[(c[h>>2]|0)+(g<<2)>>2]|0;co[c[(c[p>>2]|0)+8>>2]&2047](p,u,k);g=g+1|0}while((g|0)!=(t|0));v=c[m>>2]|0}c[f>>2]=v;ko[c[(c[e>>2]|0)+16>>2]&4095](e);if(l){i=j;return}pTa(c[r+4>>2]|0);i=j;return}function BIb(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;a[k>>0]=f;f=k+1|0;b[k+2>>1]=g;g=h+16|0;l=g;m=c[l>>2]|0;n=c[l+4>>2]|0;l=e+104|0;o=l;p=c[o>>2]|0;q=c[o+4>>2]|0;a[f>>0]=3;if((p|0)==0&(q|0)==0){r=m;s=n;t=3}else{o=ZEi(m|0,n|0,p|0,q|0)|0;q=H;if(!(q>>>0<0|(q|0)==0&o>>>0<256))if(q>>>0<0|(q|0)==0&o>>>0<65536)u=1;else u=q>>>0<1|(q|0)==1&o>>>0<0?2:3;else u=0;a[f>>0]=u;p=(u|0)==3;r=p?m:o;s=p?n:q;t=u}u=g;c[u>>2]=r;c[u+4>>2]=s;s=h;u=c[s>>2]|0;r=c[s+4>>2]|0;if(!(r>>>0<0|(r|0)==0&u>>>0<256))if(r>>>0<0|(r|0)==0&u>>>0<65536)v=4;else v=r>>>0<1|(r|0)==1&u>>>0<0?8:12;else v=0;a[f>>0]=t|v;v=l;c[v>>2]=m;c[v+4>>2]=n;n=e+80|0;EIb(k,n);k=d[f>>0]|0;mKb(h,n,k>>>2&3);HIb(n,0,g,k&3);k=e+20|0;g=c[k>>2]|0;n=e+16|0;h=c[n>>2]|0;if((g-h|0)>>>0<(c[e+44>>2]|0)>>>0){i=j;return}f=c[e+72>>2]|0;v=(f|0)==0;if(v){w=g;x=h}else{oTa(c[f+4>>2]|0);w=c[k>>2]|0;x=c[n>>2]|0}h=w-x|0;w=c[e+36>>2]|0;if(!w)y=x;else{g=e+32|0;m=0;do{l=c[(c[g>>2]|0)+(m<<2)>>2]|0;co[c[(c[l>>2]|0)+8>>2]&2047](l,x,h);m=m+1|0}while((m|0)!=(w|0));y=c[n>>2]|0}c[k>>2]=y;ko[c[(c[e>>2]|0)+16>>2]&4095](e);if(v){i=j;return}pTa(c[f+4>>2]|0);i=j;return}function CIb(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+16|0;k=j;a[k>>0]=f;f=k+1|0;b[k+2>>1]=g;g=h;l=c[g>>2]|0;m=c[g+4>>2]|0;g=e+104|0;n=g;o=c[n>>2]|0;p=c[n+4>>2]|0;a[f>>0]=3;if((o|0)==0&(p|0)==0){q=l;r=m}else{n=ZEi(l|0,m|0,o|0,p|0)|0;p=H;if(!(p>>>0<0|(p|0)==0&n>>>0<256))if(p>>>0<0|(p|0)==0&n>>>0<65536)s=1;else s=p>>>0<1|(p|0)==1&n>>>0<0?2:3;else s=0;a[f>>0]=s;o=(s|0)==3;q=o?l:n;r=o?m:p}p=h;c[p>>2]=q;c[p+4>>2]=r;r=g;c[r>>2]=l;c[r+4>>2]=m;m=e+80|0;EIb(k,m);HIb(m,0,h,(d[f>>0]|0)&3);f=e+20|0;h=c[f>>2]|0;m=e+16|0;k=c[m>>2]|0;if((h-k|0)>>>0<(c[e+44>>2]|0)>>>0){i=j;return}r=c[e+72>>2]|0;l=(r|0)==0;if(l){t=h;u=k}else{oTa(c[r+4>>2]|0);t=c[f>>2]|0;u=c[m>>2]|0}k=t-u|0;t=c[e+36>>2]|0;if(!t)v=u;else{h=e+32|0;g=0;do{p=c[(c[h>>2]|0)+(g<<2)>>2]|0;co[c[(c[p>>2]|0)+8>>2]&2047](p,u,k);g=g+1|0}while((g|0)!=(t|0));v=c[m>>2]|0}c[f>>2]=v;ko[c[(c[e>>2]|0)+16>>2]&4095](e);if(l){i=j;return}pTa(c[r+4>>2]|0);i=j;return}function DIb(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;a[k>>0]=f;f=k+1|0;b[k+2>>1]=g;g=h+16|0;l=g;m=c[l>>2]|0;n=c[l+4>>2]|0;l=e+104|0;o=l;p=c[o>>2]|0;q=c[o+4>>2]|0;a[f>>0]=3;if((p|0)==0&(q|0)==0){r=m;s=n;t=3}else{o=ZEi(m|0,n|0,p|0,q|0)|0;q=H;if(!(q>>>0<0|(q|0)==0&o>>>0<256))if(q>>>0<0|(q|0)==0&o>>>0<65536)u=1;else u=q>>>0<1|(q|0)==1&o>>>0<0?2:3;else u=0;a[f>>0]=u;p=(u|0)==3;r=p?m:o;s=p?n:q;t=u}u=g;c[u>>2]=r;c[u+4>>2]=s;s=h;u=c[s>>2]|0;r=c[s+4>>2]|0;if(!(r>>>0<0|(r|0)==0&u>>>0<256))if(r>>>0<0|(r|0)==0&u>>>0<65536)v=4;else v=r>>>0<1|(r|0)==1&u>>>0<0?8:12;else v=0;a[f>>0]=t|v;v=l;c[v>>2]=m;c[v+4>>2]=n;n=e+80|0;EIb(k,n);k=d[f>>0]|0;mKb(h,n,k>>>2&3);HIb(n,0,g,k&3);k=e+20|0;g=c[k>>2]|0;n=e+16|0;h=c[n>>2]|0;if((g-h|0)>>>0<(c[e+44>>2]|0)>>>0){i=j;return}f=c[e+72>>2]|0;v=(f|0)==0;if(v){w=g;x=h}else{oTa(c[f+4>>2]|0);w=c[k>>2]|0;x=c[n>>2]|0}h=w-x|0;w=c[e+36>>2]|0;if(!w)y=x;else{g=e+32|0;m=0;do{l=c[(c[g>>2]|0)+(m<<2)>>2]|0;co[c[(c[l>>2]|0)+8>>2]&2047](l,x,h);m=m+1|0}while((m|0)!=(w|0));y=c[n>>2]|0}c[k>>2]=y;ko[c[(c[e>>2]|0)+16>>2]&4095](e);if(v){i=j;return}pTa(c[f+4>>2]|0);i=j;return}function EIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;f=c[d>>2]|0;g=a[b>>0]|0;h=f+12|0;j=c[h>>2]|0;k=f+8|0;l=c[k>>2]|0;m=l;n=j-m|0;o=n+1|0;p=f+16|0;if(((c[p>>2]|0)-m|0)>>>0>o>>>0)q=j;else{j=o<<1;if(!j){r=0;s=l}else{l=c[c[f>>2]>>2]|0;o=Bn[c[(c[l>>2]|0)+8>>2]&255](l,j,c[f+4>>2]|0,527352,117)|0;r=o;s=c[k>>2]|0}if((s|0)!=0?(YEi(r|0,s|0,n|0)|0,s=c[k>>2]|0,(s|0)!=0):0){o=c[c[f>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,s)}c[k>>2]=r;k=r+n|0;c[h>>2]=k;c[p>>2]=r+j;q=k}a[q>>0]=g;c[h>>2]=(c[h>>2]|0)+1;h=c[d>>2]|0;g=a[b+1>>0]|0;q=h+12|0;k=c[q>>2]|0;j=h+8|0;r=c[j>>2]|0;p=r;n=k-p|0;s=n+1|0;o=h+16|0;if(((c[o>>2]|0)-p|0)>>>0>s>>>0)t=k;else{k=s<<1;if(!k){u=0;v=r}else{r=c[c[h>>2]>>2]|0;s=Bn[c[(c[r>>2]|0)+8>>2]&255](r,k,c[h+4>>2]|0,527352,117)|0;u=s;v=c[j>>2]|0}if((v|0)!=0?(YEi(u|0,v|0,n|0)|0,v=c[j>>2]|0,(v|0)!=0):0){s=c[c[h>>2]>>2]|0;In[c[(c[s>>2]|0)+12>>2]&4095](s,v)}c[j>>2]=u;j=u+n|0;c[q>>2]=j;c[o>>2]=u+k;t=j}a[t>>0]=g;c[q>>2]=(c[q>>2]|0)+1;q=b+2|0;b=c[d>>2]|0;d=b+12|0;g=c[d>>2]|0;t=b+8|0;j=c[t>>2]|0;k=j;u=g-k|0;o=u+2|0;n=b+16|0;if(((c[n>>2]|0)-k|0)>>>0>o>>>0){w=g;x=a[q>>0]|0;a[w>>0]=x;y=q+1|0;z=a[y>>0]|0;A=w+1|0;a[A>>0]=z;B=c[d>>2]|0;C=B+2|0;c[d>>2]=C;i=e;return}g=o<<1;if(!g){D=0;E=j}else{j=c[c[b>>2]>>2]|0;o=Bn[c[(c[j>>2]|0)+8>>2]&255](j,g,c[b+4>>2]|0,527352,117)|0;D=o;E=c[t>>2]|0}if((E|0)!=0?(YEi(D|0,E|0,u|0)|0,E=c[t>>2]|0,(E|0)!=0):0){o=c[c[b>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,E)}c[t>>2]=D;t=D+u|0;c[d>>2]=t;c[n>>2]=D+g;w=t;x=a[q>>0]|0;a[w>>0]=x;y=q+1|0;z=a[y>>0]|0;A=w+1|0;a[A>>0]=z;B=c[d>>2]|0;C=B+2|0;c[d>>2]=C;i=e;return}function FIb(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;h=f+1|0;HIb(e,0,b,(d[h>>0]|0)&3);HIb(e,0,b+8|0,(d[h>>0]|0)>>>2&3);h=b+16|0;b=c[e>>2]|0;e=b+12|0;f=c[e>>2]|0;j=b+8|0;k=c[j>>2]|0;l=k;m=f-l|0;n=m+4|0;o=b+16|0;if(((c[o>>2]|0)-l|0)>>>0>n>>>0)p=f;else{f=n<<1;if(!f){q=0;r=k}else{k=c[c[b>>2]>>2]|0;n=Bn[c[(c[k>>2]|0)+8>>2]&255](k,f,c[b+4>>2]|0,527352,117)|0;q=n;r=c[j>>2]|0}if((r|0)!=0?(YEi(q|0,r|0,m|0)|0,r=c[j>>2]|0,(r|0)!=0):0){n=c[c[b>>2]>>2]|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,r)}c[j>>2]=q;j=q+m|0;c[e>>2]=j;c[o>>2]=q+f;p=j}a[p>>0]=a[h>>0]|0;a[p+1>>0]=a[h+1>>0]|0;a[p+2>>0]=a[h+2>>0]|0;a[p+3>>0]=a[h+3>>0]|0;c[e>>2]=(c[e>>2]|0)+4;i=g;return}function GIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;nKb(c[d>>2]|0,b);f=b+8|0;g=c[d>>2]|0;h=g+12|0;j=c[h>>2]|0;k=g+8|0;l=c[k>>2]|0;m=l;n=j-m|0;o=n+4|0;p=g+16|0;if(((c[p>>2]|0)-m|0)>>>0>o>>>0)q=j;else{j=o<<1;if(!j){r=0;s=l}else{l=c[c[g>>2]>>2]|0;o=Bn[c[(c[l>>2]|0)+8>>2]&255](l,j,c[g+4>>2]|0,527352,117)|0;r=o;s=c[k>>2]|0}if((s|0)!=0?(YEi(r|0,s|0,n|0)|0,s=c[k>>2]|0,(s|0)!=0):0){o=c[c[g>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,s)}c[k>>2]=r;k=r+n|0;c[h>>2]=k;c[p>>2]=r+j;q=k}a[q>>0]=a[f>>0]|0;a[q+1>>0]=a[f+1>>0]|0;a[q+2>>0]=a[f+2>>0]|0;a[q+3>>0]=a[f+3>>0]|0;c[h>>2]=(c[h>>2]|0)+4;h=c[b+12>>2]|0;f=b+16|0;q=c[f>>2]|0;k=q&255;j=q>>>8&255;r=q>>>16&255;p=q>>>24;n=p&255;s=c[d>>2]|0;o=s+12|0;g=c[o>>2]|0;l=s+8|0;m=c[l>>2]|0;t=m;u=g-t|0;v=u+4|0;w=s+16|0;if(((c[w>>2]|0)-t|0)>>>0>v>>>0)x=g;else{g=v<<1;if(!g){y=0;z=m}else{m=c[c[s>>2]>>2]|0;v=Bn[c[(c[m>>2]|0)+8>>2]&255](m,g,c[s+4>>2]|0,527352,117)|0;y=v;z=c[l>>2]|0}if((z|0)!=0?(YEi(y|0,z|0,u|0)|0,z=c[l>>2]|0,(z|0)!=0):0){v=c[c[s>>2]>>2]|0;In[c[(c[v>>2]|0)+12>>2]&4095](v,z)}c[l>>2]=y;l=y+u|0;c[o>>2]=l;c[w>>2]=y+g;x=l}a[x>>0]=k;a[x+1>>0]=j;a[x+2>>0]=r;a[x+3>>0]=n;c[o>>2]=(c[o>>2]|0)+4;o=q&16777215|p<<24;if((o|0)!=0?(p=c[d>>2]|0,(h|0)!=0):0){q=p+12|0;n=c[q>>2]|0;x=p+8|0;r=c[x>>2]|0;j=r;k=n-j|0;l=k+o|0;g=p+16|0;if(((c[g>>2]|0)-j|0)>>>0>l>>>0){A=n;B=r}else{n=l<<1;if(!n){C=0;D=r}else{r=c[c[p>>2]>>2]|0;l=Bn[c[(c[r>>2]|0)+8>>2]&255](r,n,c[p+4>>2]|0,527352,117)|0;C=l;D=c[x>>2]|0}if((D|0)!=0?(YEi(C|0,D|0,k|0)|0,D=c[x>>2]|0,(D|0)!=0):0){l=c[c[p>>2]>>2]|0;In[c[(c[l>>2]|0)+12>>2]&4095](l,D)}c[x>>2]=C;x=C+k|0;c[q>>2]=x;c[g>>2]=C+n;A=x;B=C}YEi(B+(A-B)|0,h|0,o|0)|0;c[q>>2]=(c[q>>2]|0)+o}o=c[d>>2]|0;q=o+12|0;h=c[q>>2]|0;B=o+8|0;A=c[B>>2]|0;C=A;x=h-C|0;n=x+4|0;g=o+16|0;if(((c[g>>2]|0)-C|0)>>>0>n>>>0)E=h;else{h=n<<1;if(!h){F=0;G=A}else{A=c[c[o>>2]>>2]|0;n=Bn[c[(c[A>>2]|0)+8>>2]&255](A,h,c[o+4>>2]|0,527352,117)|0;F=n;G=c[B>>2]|0}if((G|0)!=0?(YEi(F|0,G|0,x|0)|0,G=c[B>>2]|0,(G|0)!=0):0){n=c[c[o>>2]>>2]|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,G)}c[B>>2]=F;B=F+x|0;c[q>>2]=B;c[g>>2]=F+h;E=B}a[E>>0]=a[f>>0]|0;a[E+1>>0]=a[f+1>>0]|0;a[E+2>>0]=a[f+2>>0]|0;a[E+3>>0]=a[f+3>>0]|0;c[q>>2]=(c[q>>2]|0)+4;q=b+20|0;b=c[d>>2]|0;d=b+12|0;f=c[d>>2]|0;E=b+8|0;B=c[E>>2]|0;h=B;F=f-h|0;g=F+4|0;x=b+16|0;if(((c[x>>2]|0)-h|0)>>>0>g>>>0){H=f;I=a[q>>0]|0;a[H>>0]=I;J=q+1|0;K=a[J>>0]|0;L=H+1|0;a[L>>0]=K;M=q+2|0;N=a[M>>0]|0;O=H+2|0;a[O>>0]=N;P=q+3|0;Q=a[P>>0]|0;R=H+3|0;a[R>>0]=Q;S=c[d>>2]|0;T=S+4|0;c[d>>2]=T;i=e;return}f=g<<1;if(!f){U=0;V=B}else{B=c[c[b>>2]>>2]|0;g=Bn[c[(c[B>>2]|0)+8>>2]&255](B,f,c[b+4>>2]|0,527352,117)|0;U=g;V=c[E>>2]|0}if((V|0)!=0?(YEi(U|0,V|0,F|0)|0,V=c[E>>2]|0,(V|0)!=0):0){g=c[c[b>>2]>>2]|0;In[c[(c[g>>2]|0)+12>>2]&4095](g,V)}c[E>>2]=U;E=U+F|0;c[d>>2]=E;c[x>>2]=U+f;H=E;I=a[q>>0]|0;a[H>>0]=I;J=q+1|0;K=a[J>>0]|0;L=H+1|0;a[L>>0]=K;M=q+2|0;N=a[M>>0]|0;O=H+2|0;a[O>>0]=N;P=q+3|0;Q=a[P>>0]|0;R=H+3|0;a[R>>0]=Q;S=c[d>>2]|0;T=S+4|0;c[d>>2]=T;i=e;return}function HIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;if((f|0)==1){g=c[e>>2]|0;h=g&255;j=(g&65535)>>>8&255;g=c[b>>2]|0;k=g+12|0;l=c[k>>2]|0;m=g+8|0;n=c[m>>2]|0;o=n;p=l-o|0;q=p+2|0;r=g+16|0;if(((c[r>>2]|0)-o|0)>>>0>q>>>0)s=l;else{l=q<<1;if(!l){t=0;u=n}else{n=c[c[g>>2]>>2]|0;q=Bn[c[(c[n>>2]|0)+8>>2]&255](n,l,c[g+4>>2]|0,527352,117)|0;t=q;u=c[m>>2]|0}if((u|0)!=0?(YEi(t|0,u|0,p|0)|0,u=c[m>>2]|0,(u|0)!=0):0){q=c[c[g>>2]>>2]|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,u)}c[m>>2]=t;m=t+p|0;c[k>>2]=m;c[r>>2]=t+l;s=m}a[s>>0]=h;a[s+1>>0]=j;c[k>>2]=(c[k>>2]|0)+2;i=d;return}else if(!f){k=c[e>>2]&255;j=c[b>>2]|0;s=j+12|0;h=c[s>>2]|0;m=j+8|0;l=c[m>>2]|0;t=l;r=h-t|0;p=r+1|0;u=j+16|0;if(((c[u>>2]|0)-t|0)>>>0>p>>>0)v=h;else{h=p<<1;if(!h){w=0;x=l}else{l=c[c[j>>2]>>2]|0;p=Bn[c[(c[l>>2]|0)+8>>2]&255](l,h,c[j+4>>2]|0,527352,117)|0;w=p;x=c[m>>2]|0}if((x|0)!=0?(YEi(w|0,x|0,r|0)|0,x=c[m>>2]|0,(x|0)!=0):0){p=c[c[j>>2]>>2]|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,x)}c[m>>2]=w;m=w+r|0;c[s>>2]=m;c[u>>2]=w+h;v=m}a[v>>0]=k;c[s>>2]=(c[s>>2]|0)+1;i=d;return}else if((f|0)==2){f=c[e>>2]|0;s=f&255;k=f>>>8&255;v=f>>>16&255;m=f>>>24&255;f=c[b>>2]|0;h=f+12|0;w=c[h>>2]|0;u=f+8|0;r=c[u>>2]|0;x=r;p=w-x|0;j=p+4|0;l=f+16|0;if(((c[l>>2]|0)-x|0)>>>0>j>>>0)y=w;else{w=j<<1;if(!w){z=0;A=r}else{r=c[c[f>>2]>>2]|0;j=Bn[c[(c[r>>2]|0)+8>>2]&255](r,w,c[f+4>>2]|0,527352,117)|0;z=j;A=c[u>>2]|0}if((A|0)!=0?(YEi(z|0,A|0,p|0)|0,A=c[u>>2]|0,(A|0)!=0):0){j=c[c[f>>2]>>2]|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,A)}c[u>>2]=z;u=z+p|0;c[h>>2]=u;c[l>>2]=z+w;y=u}a[y>>0]=s;a[y+1>>0]=k;a[y+2>>0]=v;a[y+3>>0]=m;c[h>>2]=(c[h>>2]|0)+4;i=d;return}else{nKb(c[b>>2]|0,e);i=d;return}}function IIb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=0;h=i;i=i+48|0;j=h+36|0;k=h+24|0;l=h+12|0;m=h;n=a+200|0;o=c[n>>2]|0;p=ea(g[o>>2]);q=ea(g[o+4>>2]);r=ea(g[o+8>>2]);s=ea(g[b>>2]);t=b+4|0;u=ea(g[t>>2]);v=b+8|0;w=ea(ea(ea(p*s)+ea(q*u))+ea(r*ea(g[v>>2])));c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];x=a+204|0;if((d[x>>0]|0)<=1){y=w;z=w;g[e>>2]=y;A=e+4|0;c[A+0>>2]=c[k+0>>2];c[A+4>>2]=c[k+4>>2];c[A+8>>2]=c[k+8>>2];g[f>>2]=z;B=f+4|0;c[B+0>>2]=c[j+0>>2];c[B+4>>2]=c[j+4>>2];c[B+8>>2]=c[j+8>>2];i=h;return}C=a+96|0;D=a+112|0;E=a+128|0;F=a+100|0;G=a+116|0;H=a+132|0;I=a+104|0;J=a+120|0;K=a+136|0;r=w;a=o;u=w;o=1;while(1){L=c[n>>2]|0;w=ea(g[L+(o*12|0)>>2]);q=ea(g[L+(o*12|0)+4>>2]);s=ea(g[L+(o*12|0)+8>>2]);p=ea(w*ea(g[C>>2]));M=ea(p+ea(q*ea(g[D>>2])));p=ea(M+ea(s*ea(g[E>>2])));M=ea(w*ea(g[F>>2]));N=ea(M+ea(q*ea(g[G>>2])));M=ea(N+ea(s*ea(g[H>>2])));N=ea(w*ea(g[I>>2]));w=ea(N+ea(q*ea(g[J>>2])));q=ea(w+ea(s*ea(g[K>>2])));s=ea(g[b>>2]);w=ea(g[t>>2]);N=ea(ea(ea(p*s)+ea(M*w))+ea(q*ea(g[v>>2])));q=N>u?N:u;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];w=N>r?r:N;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];O=o+1|0;if(O>>>0<(d[x>>0]|0)>>>0){r=w;a=L;u=q;o=O}else{y=w;z=q;break}}g[e>>2]=y;A=e+4|0;c[A+0>>2]=c[k+0>>2];c[A+4>>2]=c[k+4>>2];c[A+8>>2]=c[k+8>>2];g[f>>2]=z;B=f+4|0;c[B+0>>2]=c[j+0>>2];c[B+4>>2]=c[j+4>>2];c[B+8>>2]=c[j+8>>2];i=h;return}function JIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<2;h=b+64|0;if(!((a[h>>0]|0)==0&g>>>0<65))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?426544:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+72>>2]|0;h=f+(j<<2)|0;n=b+68|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j)c[j>>2]=c[g>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else g=g+4|0}}g=b+76|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+64>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function KIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else OCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}PCb(m,n,f,a);f=a+264|0;h=a+268|0;PCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f*384|0)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+384|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function LIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else LCb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}MCb(m,n,f,a);f=a+264|0;h=a+268|0;MCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<8)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+256|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function MIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+4|0;e=b;f=b+17|0;g=b+16|0;c[d>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=a+292|0;l=c[k>>2]|0;if(!l){m=0;n=0}else{o=0;p=0;q=l;while(1){c[e>>2]=q;if(o>>>0>p>>>0){l=(c[d>>2]|0)+(p<<2)|0;if(l)c[l>>2]=q;c[h>>2]=p+1}else ICb(d,e)|0;l=c[c[k>>2]>>2]|0;c[k>>2]=l;if(!l)break;o=c[j>>2]&2147483647;p=c[h>>2]|0;q=l}m=c[d>>2]|0;n=c[h>>2]|0}JCb(m,n,f,a);f=a+264|0;h=a+268|0;JCb(c[f>>2]|0,c[h>>2]|0,g,a);g=c[f>>2]|0;f=c[h>>2]|0;h=g+(f<<2)|0;if(f){f=c[a+276>>2]|0;a=m+(n<<2)|0;n=m;d=g;while(1){g=c[d>>2]|0;q=g+(f<<7)|0;if((g|0)==(q|0))r=n;else{p=n;o=g;while(1){if((p|0)==(a|0))s=a;else s=(c[p>>2]|0)==(o|0)?p+4|0:p;o=o+128|0;if((o|0)==(q|0)){r=s;break}else p=s}}d=d+4|0;if((d|0)==(h|0))break;else n=r}}r=c[j>>2]|0;if((r|0)<0|(r&2147483647|0)==0|(m|0)==0){i=b;return}r=mKa()|0;In[c[(c[r>>2]|0)+12>>2]&4095](r,m);i=b;return}function NIb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function OIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+144|0;h=d+96|0;j=d;k=d+48|0;l=b+4|0;m=c[l>>2]|0;n=c[(c[b>>2]|0)+8>>2]|0;c[h>>2]=n;o=m+8|0;p=c[o>>2]|0;if((c[m+12>>2]&2147483647)>>>0>p>>>0){q=(c[m+4>>2]|0)+(p<<2)|0;if(!q)r=p;else{c[q>>2]=n;r=c[o>>2]|0}c[o>>2]=r+1}else QAb(m,h)|0;m=c[b>>2]|0;r=c[m+8>>2]|0;if((r|0)!=0?(o=r+-1|0,n=c[m+4>>2]|0,m=n+(o<<3)|0,(a[n+(o<<3)+4>>0]|0)==0):0){o=b+36|0;if(!(a[o>>0]|0)){s=r;t=n;u=0}else{n=c[b+20>>2]|0;r=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[m>>2]|0)|0)&1;a[o>>0]=r;m=c[b>>2]|0;s=c[m+8>>2]|0;t=c[m+4>>2]|0;u=r}a[t+(s+-1<<3)+5>>0]=u;u=c[b>>2]|0;a[(c[u+4>>2]|0)+((c[u+8>>2]|0)+-1<<3)+4>>0]=a[o>>0]|0}o=b+36|0;if(!(a[o>>0]|0)){wKb(b);i=d;return}NIb(b,515152);if(!(a[o>>0]|0))v=0;else{u=c[b+20>>2]|0;s=(mo[c[(c[u>>2]|0)+20>>2]&4095](u)|0)&1;a[o>>0]=s;v=s}s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+5>>0]=v;v=c[b>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=a[o>>0]|0;if(!(a[o>>0]|0)){wKb(b);i=d;return}v=k+4|0;s=k+8|0;u=k+12|0;t=k+16|0;r=k+32|0;m=k+36|0;n=b+8|0;q=b+20|0;p=b+28|0;w=b+32|0;x=h+4|0;y=h+8|0;z=h+20|0;A=h+24|0;B=h+28|0;C=h+32|0;D=h+36|0;E=h+40|0;F=h+44|0;G=f+36|0;H=f+52|0;I=f+68|0;J=f+84|0;K=f+100|0;L=f+116|0;M=f+132|0;N=f+148|0;f=b+24|0;O=e+12|0;e=0;while(1){g[k>>2]=ea(0.0);g[v>>2]=ea(0.0);g[s>>2]=ea(.300000012);g[u>>2]=ea(.100000001);c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[r>>2]=ea(1.0);g[m>>2]=ea(1.0);P=c[l>>2]|0;Q=c[q>>2]|0;R=c[p>>2]|0;S=c[w>>2]|0;c[h>>2]=c[b>>2];c[x>>2]=P;c[y+0>>2]=c[n+0>>2];c[y+4>>2]=c[n+4>>2];c[y+8>>2]=c[n+8>>2];c[z>>2]=Q;c[A>>2]=k;c[B>>2]=R;c[C>>2]=S;a[D>>0]=1;c[E>>2]=0;c[F>>2]=0;oKb(h,G,0);pKb(h,H,0);qKb(h,I,0);rKb(h,J,0);sKb(h,K,0);tKb(h,L,0);uKb(h,M,0);vKb(h,N,0);S=c[f>>2]|0;R=j+0|0;Q=k+0|0;P=R+48|0;do{c[R>>2]=c[Q>>2];R=R+4|0;Q=Q+4|0}while((R|0)<(P|0));T=c[(c[O>>2]|0)+8>>2]|0;R=h+0|0;Q=j+0|0;P=R+48|0;do{c[R>>2]=c[Q>>2];R=R+4|0;Q=Q+4|0}while((R|0)<(P|0));co[T&2047](S,e,h);if(!(a[o>>0]|0)){U=18;break}Q=c[q>>2]|0;if(mo[c[(c[Q>>2]|0)+24>>2]&4095](Q)|0)e=e+1|0;else{U=18;break}}if((U|0)==18){wKb(b);i=d;return}}function PIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+144|0;h=d+96|0;j=d;k=d+48|0;l=b+4|0;m=c[l>>2]|0;n=c[(c[b>>2]|0)+8>>2]|0;c[h>>2]=n;o=m+8|0;p=c[o>>2]|0;if((c[m+12>>2]&2147483647)>>>0>p>>>0){q=(c[m+4>>2]|0)+(p<<2)|0;if(!q)r=p;else{c[q>>2]=n;r=c[o>>2]|0}c[o>>2]=r+1}else QAb(m,h)|0;m=c[b>>2]|0;r=c[m+8>>2]|0;if((r|0)!=0?(o=r+-1|0,n=c[m+4>>2]|0,m=n+(o<<3)|0,(a[n+(o<<3)+4>>0]|0)==0):0){o=b+36|0;if(!(a[o>>0]|0)){s=r;t=n;u=0}else{n=c[b+20>>2]|0;r=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[m>>2]|0)|0)&1;a[o>>0]=r;m=c[b>>2]|0;s=c[m+8>>2]|0;t=c[m+4>>2]|0;u=r}a[t+(s+-1<<3)+5>>0]=u;u=c[b>>2]|0;a[(c[u+4>>2]|0)+((c[u+8>>2]|0)+-1<<3)+4>>0]=a[o>>0]|0}o=b+36|0;if(!(a[o>>0]|0)){wKb(b);i=d;return}NIb(b,515152);if(!(a[o>>0]|0))v=0;else{u=c[b+20>>2]|0;s=(mo[c[(c[u>>2]|0)+20>>2]&4095](u)|0)&1;a[o>>0]=s;v=s}s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+5>>0]=v;v=c[b>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=a[o>>0]|0;if(!(a[o>>0]|0)){wKb(b);i=d;return}v=k+4|0;s=k+8|0;u=k+12|0;t=k+16|0;r=k+20|0;m=k+24|0;n=b+8|0;q=b+20|0;p=b+28|0;w=b+32|0;x=h+4|0;y=h+8|0;z=h+20|0;A=h+24|0;B=h+28|0;C=h+32|0;D=h+36|0;E=h+40|0;F=h+44|0;G=f+24|0;H=f+40|0;I=f+56|0;J=f+72|0;K=f+88|0;L=f+104|0;M=f+120|0;N=f+136|0;O=f+152|0;f=b+24|0;P=e+12|0;e=0;while(1){g[k>>2]=ea(0.0);g[v>>2]=ea(0.0);g[s>>2]=ea(20.0);g[u>>2]=ea(0.0);g[t>>2]=ea(.25);g[r>>2]=ea(1500.0);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;Q=c[l>>2]|0;R=c[q>>2]|0;S=c[p>>2]|0;T=c[w>>2]|0;c[h>>2]=c[b>>2];c[x>>2]=Q;c[y+0>>2]=c[n+0>>2];c[y+4>>2]=c[n+4>>2];c[y+8>>2]=c[n+8>>2];c[z>>2]=R;c[A>>2]=k;c[B>>2]=S;c[C>>2]=T;a[D>>0]=1;c[E>>2]=0;c[F>>2]=0;xKb(h,G,0);yKb(h,H,0);zKb(h,I,0);AKb(h,J,0);BKb(h,K,0);CKb(h,L,0);DKb(h,M,0);EKb(h,N,0);FKb(h,O,0);T=c[f>>2]|0;S=j+0|0;R=k+0|0;Q=S+48|0;do{c[S>>2]=c[R>>2];S=S+4|0;R=R+4|0}while((S|0)<(Q|0));U=c[(c[P>>2]|0)+8>>2]|0;S=h+0|0;R=j+0|0;Q=S+48|0;do{c[S>>2]=c[R>>2];S=S+4|0;R=R+4|0}while((S|0)<(Q|0));co[U&2047](T,e,h);if(!(a[o>>0]|0)){V=18;break}R=c[q>>2]|0;if(mo[c[(c[R>>2]|0)+24>>2]&4095](R)|0)e=e+1|0;else{V=18;break}}if((V|0)==18){wKb(b);i=d;return}}function QIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+192|0;h=d+128|0;j=d;k=d+64|0;l=b+4|0;m=c[l>>2]|0;n=c[(c[b>>2]|0)+8>>2]|0;c[h>>2]=n;o=m+8|0;p=c[o>>2]|0;if((c[m+12>>2]&2147483647)>>>0>p>>>0){q=(c[m+4>>2]|0)+(p<<2)|0;if(!q)r=p;else{c[q>>2]=n;r=c[o>>2]|0}c[o>>2]=r+1}else QAb(m,h)|0;m=c[b>>2]|0;r=c[m+8>>2]|0;if((r|0)!=0?(o=r+-1|0,n=c[m+4>>2]|0,m=n+(o<<3)|0,(a[n+(o<<3)+4>>0]|0)==0):0){o=b+36|0;if(!(a[o>>0]|0)){s=r;t=n;u=0}else{n=c[b+20>>2]|0;r=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[m>>2]|0)|0)&1;a[o>>0]=r;m=c[b>>2]|0;s=c[m+8>>2]|0;t=c[m+4>>2]|0;u=r}a[t+(s+-1<<3)+5>>0]=u;u=c[b>>2]|0;a[(c[u+4>>2]|0)+((c[u+8>>2]|0)+-1<<3)+4>>0]=a[o>>0]|0}o=b+36|0;if(!(a[o>>0]|0)){wKb(b);i=d;return}NIb(b,515152);if(!(a[o>>0]|0))v=0;else{u=c[b+20>>2]|0;s=(mo[c[(c[u>>2]|0)+20>>2]&4095](u)|0)&1;a[o>>0]=s;v=s}s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+5>>0]=v;v=c[b>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=a[o>>0]|0;if(!(a[o>>0]|0)){wKb(b);i=d;return}v=k+4|0;s=k+8|0;u=k+12|0;t=k+40|0;r=k+16|0;m=k+20|0;n=k+24|0;q=k+28|0;p=k+32|0;w=k+36|0;x=k+44|0;y=k+48|0;z=k+52|0;A=b+8|0;B=b+20|0;C=b+28|0;D=b+32|0;E=h+4|0;F=h+8|0;G=h+20|0;H=h+24|0;I=h+28|0;J=h+32|0;K=h+36|0;L=h+40|0;M=h+44|0;N=f+36|0;O=f+52|0;P=f+68|0;Q=f+84|0;R=f+100|0;S=f+116|0;T=f+132|0;U=f+136|0;f=b+24|0;V=e+12|0;e=0;while(1){g[k>>2]=ea(2.0);g[v>>2]=ea(17.9049301);g[s>>2]=ea(1.0e3);g[u>>2]=ea(5.72957754);c[t>>2]=0;g[r>>2]=ea(0.0);g[m>>2]=ea(1.0);g[n>>2]=ea(.100000001);g[q>>2]=ea(1.0);g[p>>2]=ea(1.0);g[w>>2]=ea(1.0);g[x>>2]=ea(.00100000005);g[y>>2]=ea(10.0);g[z>>2]=ea(1.11111116);W=c[l>>2]|0;X=c[B>>2]|0;Y=c[C>>2]|0;Z=c[D>>2]|0;c[h>>2]=c[b>>2];c[E>>2]=W;c[F+0>>2]=c[A+0>>2];c[F+4>>2]=c[A+4>>2];c[F+8>>2]=c[A+8>>2];c[G>>2]=X;c[H>>2]=k;c[I>>2]=Y;c[J>>2]=Z;a[K>>0]=1;c[L>>2]=0;c[M>>2]=0;GKb(h,N,0);HKb(h,O,0);IKb(h,P,0);JKb(h,Q,0);KKb(h,R,0);LKb(h,0,S,c[T>>2]|0,c[U>>2]|0);Z=c[f>>2]|0;Y=j+0|0;X=k+0|0;W=Y+64|0;do{c[Y>>2]=c[X>>2];Y=Y+4|0;X=X+4|0}while((Y|0)<(W|0));_=c[(c[V>>2]|0)+8>>2]|0;Y=h+0|0;X=j+0|0;W=Y+64|0;do{c[Y>>2]=c[X>>2];Y=Y+4|0;X=X+4|0}while((Y|0)<(W|0));co[_&2047](Z,e,h);if(!(a[o>>0]|0)){$=18;break}X=c[B>>2]|0;if(mo[c[(c[X>>2]|0)+24>>2]&4095](X)|0)e=e+1|0;else{$=18;break}}if(($|0)==18){wKb(b);i=d;return}}function RIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0;f=i;i=i+32|0;d=f+16|0;h=f+12|0;j=f;k=c[b+4>>2]|0;l=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=l;m=k+8|0;n=c[m>>2]|0;if((c[k+12>>2]&2147483647)>>>0>n>>>0){o=(c[k+4>>2]|0)+(n<<2)|0;if(!o)p=n;else{c[o>>2]=l;p=c[m>>2]|0}c[m>>2]=p+1}else QAb(k,d)|0;k=c[b>>2]|0;p=c[k+8>>2]|0;if((p|0)!=0?(m=p+-1|0,l=c[k+4>>2]|0,k=l+(m<<3)|0,(a[l+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){q=p;r=l;s=0}else{l=c[b+20>>2]|0;p=(_n[c[(c[l>>2]|0)+16>>2]&4095](l,c[k>>2]|0)|0)&1;a[m>>0]=p;k=c[b>>2]|0;q=c[k+8>>2]|0;r=c[k+4>>2]|0;s=p}a[r+(q+-1<<3)+5>>0]=s;s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}m=b+36|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}NIb(b,515152);if(!(a[m>>0]|0))t=0;else{s=c[b+20>>2]|0;q=(mo[c[(c[s>>2]|0)+20>>2]&4095](s)|0)&1;a[m>>0]=q;t=q}q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+5>>0]=t;t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}t=b+20|0;q=b+24|0;s=j+4|0;r=j+8|0;p=e+12|0;e=d+4|0;k=d+8|0;u=ea(0.0);v=ea(0.0);w=ea(0.0);l=0;while(1){o=c[t>>2]|0;n=mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0;if(((n|0)!=0?(a[n>>0]|0)!=0:0)?(c[h>>2]=n,(a[n>>0]|0)!=0):0){PAb(0,j,h);x=ea(g[j>>2]);y=ea(g[s>>2]);z=x;A=y;B=ea(g[r>>2])}else{z=w;A=v;B=u}n=c[q>>2]|0;o=c[(c[p>>2]|0)+8>>2]|0;g[d>>2]=z;g[e>>2]=A;g[k>>2]=B;co[o&2047](n,l,d);if(!(a[m>>0]|0)){C=22;break}n=c[t>>2]|0;if(mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0){u=B;v=A;w=z;l=l+1|0}else{C=22;break}}if((C|0)==22){wKb(b);i=f;return}}function SIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0;f=i;i=i+32|0;d=f+16|0;h=f+12|0;j=f;k=c[b+4>>2]|0;l=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=l;m=k+8|0;n=c[m>>2]|0;if((c[k+12>>2]&2147483647)>>>0>n>>>0){o=(c[k+4>>2]|0)+(n<<2)|0;if(!o)p=n;else{c[o>>2]=l;p=c[m>>2]|0}c[m>>2]=p+1}else QAb(k,d)|0;k=c[b>>2]|0;p=c[k+8>>2]|0;if((p|0)!=0?(m=p+-1|0,l=c[k+4>>2]|0,k=l+(m<<3)|0,(a[l+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){q=p;r=l;s=0}else{l=c[b+20>>2]|0;p=(_n[c[(c[l>>2]|0)+16>>2]&4095](l,c[k>>2]|0)|0)&1;a[m>>0]=p;k=c[b>>2]|0;q=c[k+8>>2]|0;r=c[k+4>>2]|0;s=p}a[r+(q+-1<<3)+5>>0]=s;s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}m=b+36|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}NIb(b,515152);if(!(a[m>>0]|0))t=0;else{s=c[b+20>>2]|0;q=(mo[c[(c[s>>2]|0)+20>>2]&4095](s)|0)&1;a[m>>0]=q;t=q}q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+5>>0]=t;t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}t=b+20|0;q=b+24|0;s=j+4|0;r=j+8|0;p=e+12|0;e=d+4|0;k=d+8|0;u=ea(0.0);v=ea(0.0);w=ea(0.0);l=0;while(1){o=c[t>>2]|0;n=mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0;if(((n|0)!=0?(a[n>>0]|0)!=0:0)?(c[h>>2]=n,(a[n>>0]|0)!=0):0){PAb(0,j,h);x=ea(g[j>>2]);y=ea(g[s>>2]);z=x;A=y;B=ea(g[r>>2])}else{z=w;A=v;B=u}n=c[q>>2]|0;o=c[(c[p>>2]|0)+8>>2]|0;g[d>>2]=z;g[e>>2]=A;g[k>>2]=B;co[o&2047](n,l,d);if(!(a[m>>0]|0)){C=22;break}n=c[t>>2]|0;if(mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0){u=B;v=A;w=z;l=l+1|0}else{C=22;break}}if((C|0)==22){wKb(b);i=f;return}}function TIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0;f=i;i=i+32|0;d=f+16|0;h=f+12|0;j=f;k=c[b+4>>2]|0;l=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=l;m=k+8|0;n=c[m>>2]|0;if((c[k+12>>2]&2147483647)>>>0>n>>>0){o=(c[k+4>>2]|0)+(n<<2)|0;if(!o)p=n;else{c[o>>2]=l;p=c[m>>2]|0}c[m>>2]=p+1}else QAb(k,d)|0;k=c[b>>2]|0;p=c[k+8>>2]|0;if((p|0)!=0?(m=p+-1|0,l=c[k+4>>2]|0,k=l+(m<<3)|0,(a[l+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){q=p;r=l;s=0}else{l=c[b+20>>2]|0;p=(_n[c[(c[l>>2]|0)+16>>2]&4095](l,c[k>>2]|0)|0)&1;a[m>>0]=p;k=c[b>>2]|0;q=c[k+8>>2]|0;r=c[k+4>>2]|0;s=p}a[r+(q+-1<<3)+5>>0]=s;s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}m=b+36|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}NIb(b,515152);if(!(a[m>>0]|0))t=0;else{s=c[b+20>>2]|0;q=(mo[c[(c[s>>2]|0)+20>>2]&4095](s)|0)&1;a[m>>0]=q;t=q}q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+5>>0]=t;t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}t=b+20|0;q=b+24|0;s=j+4|0;r=j+8|0;p=e+12|0;e=d+4|0;k=d+8|0;u=ea(0.0);v=ea(0.0);w=ea(0.0);l=0;while(1){o=c[t>>2]|0;n=mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0;if(((n|0)!=0?(a[n>>0]|0)!=0:0)?(c[h>>2]=n,(a[n>>0]|0)!=0):0){PAb(0,j,h);x=ea(g[j>>2]);y=ea(g[s>>2]);z=x;A=y;B=ea(g[r>>2])}else{z=w;A=v;B=u}n=c[q>>2]|0;o=c[(c[p>>2]|0)+8>>2]|0;g[d>>2]=z;g[e>>2]=A;g[k>>2]=B;co[o&2047](n,l,d);if(!(a[m>>0]|0)){C=22;break}n=c[t>>2]|0;if(mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0){u=B;v=A;w=z;l=l+1|0}else{C=22;break}}if((C|0)==22){wKb(b);i=f;return}}function UIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0;f=i;i=i+32|0;d=f+16|0;h=f+12|0;j=f;k=c[b+4>>2]|0;l=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=l;m=k+8|0;n=c[m>>2]|0;if((c[k+12>>2]&2147483647)>>>0>n>>>0){o=(c[k+4>>2]|0)+(n<<2)|0;if(!o)p=n;else{c[o>>2]=l;p=c[m>>2]|0}c[m>>2]=p+1}else QAb(k,d)|0;k=c[b>>2]|0;p=c[k+8>>2]|0;if((p|0)!=0?(m=p+-1|0,l=c[k+4>>2]|0,k=l+(m<<3)|0,(a[l+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){q=p;r=l;s=0}else{l=c[b+20>>2]|0;p=(_n[c[(c[l>>2]|0)+16>>2]&4095](l,c[k>>2]|0)|0)&1;a[m>>0]=p;k=c[b>>2]|0;q=c[k+8>>2]|0;r=c[k+4>>2]|0;s=p}a[r+(q+-1<<3)+5>>0]=s;s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}m=b+36|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}NIb(b,515152);if(!(a[m>>0]|0))t=0;else{s=c[b+20>>2]|0;q=(mo[c[(c[s>>2]|0)+20>>2]&4095](s)|0)&1;a[m>>0]=q;t=q}q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+5>>0]=t;t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0;if(!(a[m>>0]|0)){wKb(b);i=f;return}t=b+20|0;q=b+24|0;s=j+4|0;r=j+8|0;p=e+12|0;e=d+4|0;k=d+8|0;u=ea(0.0);v=ea(0.0);w=ea(0.0);l=0;while(1){o=c[t>>2]|0;n=mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0;if(((n|0)!=0?(a[n>>0]|0)!=0:0)?(c[h>>2]=n,(a[n>>0]|0)!=0):0){PAb(0,j,h);x=ea(g[j>>2]);y=ea(g[s>>2]);z=x;A=y;B=ea(g[r>>2])}else{z=w;A=v;B=u}n=c[q>>2]|0;o=c[(c[p>>2]|0)+8>>2]|0;g[d>>2]=z;g[e>>2]=A;g[k>>2]=B;co[o&2047](n,l,d);if(!(a[m>>0]|0)){C=22;break}n=c[t>>2]|0;if(mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0){u=B;v=A;w=z;l=l+1|0}else{C=22;break}}if((C|0)==22){wKb(b);i=f;return}}function VIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;d=f;g=c[b+4>>2]|0;h=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=h;j=g+8|0;k=c[j>>2]|0;if((c[g+12>>2]&2147483647)>>>0>k>>>0){l=(c[g+4>>2]|0)+(k<<2)|0;if(!l)m=k;else{c[l>>2]=h;m=c[j>>2]|0}c[j>>2]=m+1}else QAb(g,d)|0;g=c[b>>2]|0;m=c[g+8>>2]|0;if((m|0)!=0?(j=m+-1|0,h=c[g+4>>2]|0,g=h+(j<<3)|0,(a[h+(j<<3)+4>>0]|0)==0):0){j=b+36|0;if(!(a[j>>0]|0)){n=m;o=h;p=0}else{h=c[b+20>>2]|0;m=(_n[c[(c[h>>2]|0)+16>>2]&4095](h,c[g>>2]|0)|0)&1;a[j>>0]=m;g=c[b>>2]|0;n=c[g+8>>2]|0;o=c[g+4>>2]|0;p=m}a[o+(n+-1<<3)+5>>0]=p;p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0}j=b+36|0;if(!(a[j>>0]|0)){wKb(b);i=f;return}NIb(b,515152);if(!(a[j>>0]|0))q=0;else{p=c[b+20>>2]|0;n=(mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0)&1;a[j>>0]=n;q=n}n=c[b>>2]|0;a[(c[n+4>>2]|0)+((c[n+8>>2]|0)+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;if(!(a[j>>0]|0)){wKb(b);i=f;return}q=b+20|0;n=b+24|0;p=e+12|0;e=0;o=0;while(1){m=c[q>>2]|0;g=mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0;if((g|0)!=0?(a[g>>0]|0)!=0:0){c[d>>2]=g;r=CEi(g,d,10)|0}else r=e;co[c[(c[p>>2]|0)+8>>2]&2047](c[n>>2]|0,o,r);if(!(a[j>>0]|0)){s=21;break}g=c[q>>2]|0;if(mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0){e=r;o=o+1|0}else{s=21;break}}if((s|0)==21){wKb(b);i=f;return}}function WIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+48|0;d=f+24|0;g=f;h=f+16|0;j=c[b+4>>2]|0;k=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=k;l=j+8|0;m=c[l>>2]|0;if((c[j+12>>2]&2147483647)>>>0>m>>>0){n=(c[j+4>>2]|0)+(m<<2)|0;if(!n)o=m;else{c[n>>2]=k;o=c[l>>2]|0}c[l>>2]=o+1}else QAb(j,d)|0;j=c[b>>2]|0;o=c[j+8>>2]|0;if((o|0)!=0?(l=o+-1|0,k=c[j+4>>2]|0,j=k+(l<<3)|0,(a[k+(l<<3)+4>>0]|0)==0):0){l=b+36|0;if(!(a[l>>0]|0)){p=o;q=k;r=0}else{k=c[b+20>>2]|0;o=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[j>>2]|0)|0)&1;a[l>>0]=o;j=c[b>>2]|0;p=c[j+8>>2]|0;q=c[j+4>>2]|0;r=o}a[q+(p+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0}l=b+36|0;if(!(a[l>>0]|0)){wKb(b);i=f;return}NIb(b,515152);if(!(a[l>>0]|0))s=0;else{r=c[b+20>>2]|0;p=(mo[c[(c[r>>2]|0)+20>>2]&4095](r)|0)&1;a[l>>0]=p;s=p}p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+5>>0]=s;s=c[b>>2]|0;a[(c[s+4>>2]|0)+((c[s+8>>2]|0)+-1<<3)+4>>0]=a[l>>0]|0;if(!(a[l>>0]|0)){wKb(b);i=f;return}s=b+20|0;p=b+24|0;r=g+4|0;q=g+8|0;o=g+12|0;j=e+12|0;e=0;while(1){k=c[s>>2]|0;n=mo[c[(c[k>>2]|0)+36>>2]&4095](k)|0;if((n|0)!=0?(a[n>>0]|0)!=0:0){c[h>>2]=n;k=CEi(n,h,10)|0;n=CEi(c[h>>2]|0,h,10)|0;m=CEi(c[h>>2]|0,h,10)|0;t=k;u=n;v=m;w=CEi(c[h>>2]|0,0,10)|0}else{t=0;u=0;v=0;w=0}m=c[p>>2]|0;c[g>>2]=t;c[r>>2]=u;c[q>>2]=v;c[o>>2]=w;n=c[(c[j>>2]|0)+8>>2]|0;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];co[n&2047](m,e,d);if(!(a[l>>0]|0)){x=21;break}m=c[s>>2]|0;if(mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0)e=e+1|0;else{x=21;break}}if((x|0)==21){wKb(b);i=f;return}}function XIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+192|0;f=d+144|0;g=d;h=d+112|0;j=d+32|0;k=j+0|0;l=k+76|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));IFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;MKb(f,j+12|0,0);NKb(f,j+28|0,0);OKb(f,j+44|0,0);PKb(f,j+60|0,0);j=c[m>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[g+16>>2]=c[h+16>>2];c[g+20>>2]=c[h+20>>2];c[g+24>>2]=c[h+24>>2];c[g+28>>2]=c[h+28>>2];In[c[e+20>>2]&4095](j,g);i=d;return}function YIb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;QKb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;RKb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function ZIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;QKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(SKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function _Ib(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;QKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(SKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function $Ib(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;QKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(SKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function aJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;QKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(SKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function bJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;QKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(SKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function cJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;QKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(SKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function dJb(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+16|0;d=h+4|0;j=h;TKb(b,c[e>>2]|0);c[j>>2]=527;k=c[b+40>>2]|0;l=(k|0)==0?j:k;k=c[f>>2]|0;if(!k)m=b;else{j=b+24|0;n=e+8|0;e=b+36|0;o=b+20|0;p=f;f=k;do{TKb(b,f);k=c[p+4>>2]|0;if(UKb(b,d)|0){q=ea(g[d>>2]);go[c[n>>2]&63](c[j>>2]|0,k,q)}k=c[b>>2]|0;r=c[k+8>>2]|0;if(r){s=r+-1|0;t=c[k+4>>2]|0;if((a[t+(s<<3)+4>>0]|0)!=0?(a[t+(s<<3)+5>>0]|0)!=0:0){s=c[o>>2]|0;mo[c[(c[s>>2]|0)+40>>2]&4095](s)|0;s=c[b>>2]|0;u=s;v=c[s+8>>2]|0}else{u=k;v=r}c[u+8>>2]=v+-1;r=c[b>>2]|0;k=c[r+8>>2]|0;a[e>>0]=1;if((k|0)!=0?(a[(c[r+4>>2]|0)+(k+-1<<3)+5>>0]|0)==0:0)a[e>>0]=0}else a[e>>0]=1;c[l>>2]=(c[l>>2]|0)+1;p=p+8|0;f=c[p>>2]|0}while((f|0)!=0);m=b}f=c[m>>2]|0;p=c[f+8>>2]|0;if(!p){a[b+36>>0]=1;i=h;return}l=p+-1|0;e=c[f+4>>2]|0;if((a[e+(l<<3)+4>>0]|0)!=0?(a[e+(l<<3)+5>>0]|0)!=0:0){l=c[b+20>>2]|0;mo[c[(c[l>>2]|0)+40>>2]&4095](l)|0;l=c[m>>2]|0;w=l;x=c[l+8>>2]|0}else{w=f;x=p}c[w+8>>2]=x+-1;x=c[m>>2]|0;m=c[x+8>>2]|0;w=b+36|0;a[w>>0]=1;if(!m){i=h;return}if(a[(c[x+4>>2]|0)+(m+-1<<3)+5>>0]|0){i=h;return}a[w>>0]=0;i=h;return}function eJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;TKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(UKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function fJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];TKb(b,c[d>>2]|0);VKb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function gJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;TKb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(UKb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function hJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];WKb(b,c[d>>2]|0);XKb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function iJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];WKb(b,c[d>>2]|0);YKb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function jJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];WKb(b,c[d>>2]|0);ZKb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function kJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;_Kb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if($Kb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function lJb(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+16|0;d=h+4|0;j=h;_Kb(b,c[e>>2]|0);c[j>>2]=534;k=c[b+40>>2]|0;l=(k|0)==0?j:k;k=c[f>>2]|0;if(!k)m=b;else{j=b+24|0;n=e+8|0;e=b+36|0;o=b+20|0;p=f;f=k;do{_Kb(b,f);k=c[p+4>>2]|0;if($Kb(b,d)|0){q=ea(g[d>>2]);go[c[n>>2]&63](c[j>>2]|0,k,q)}k=c[b>>2]|0;r=c[k+8>>2]|0;if(r){s=r+-1|0;t=c[k+4>>2]|0;if((a[t+(s<<3)+4>>0]|0)!=0?(a[t+(s<<3)+5>>0]|0)!=0:0){s=c[o>>2]|0;mo[c[(c[s>>2]|0)+40>>2]&4095](s)|0;s=c[b>>2]|0;u=s;v=c[s+8>>2]|0}else{u=k;v=r}c[u+8>>2]=v+-1;r=c[b>>2]|0;k=c[r+8>>2]|0;a[e>>0]=1;if((k|0)!=0?(a[(c[r+4>>2]|0)+(k+-1<<3)+5>>0]|0)==0:0)a[e>>0]=0}else a[e>>0]=1;c[l>>2]=(c[l>>2]|0)+1;p=p+8|0;f=c[p>>2]|0}while((f|0)!=0);m=b}f=c[m>>2]|0;p=c[f+8>>2]|0;if(!p){a[b+36>>0]=1;i=h;return}l=p+-1|0;e=c[f+4>>2]|0;if((a[e+(l<<3)+4>>0]|0)!=0?(a[e+(l<<3)+5>>0]|0)!=0:0){l=c[b+20>>2]|0;mo[c[(c[l>>2]|0)+40>>2]&4095](l)|0;l=c[m>>2]|0;w=l;x=c[l+8>>2]|0}else{w=f;x=p}c[w+8>>2]=x+-1;x=c[m>>2]|0;m=c[x+8>>2]|0;w=b+36|0;a[w>>0]=1;if(!m){i=h;return}if(a[(c[x+4>>2]|0)+(m+-1<<3)+5>>0]|0){i=h;return}a[w>>0]=0;i=h;return}function mJb(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+16|0;d=h+4|0;j=h;_Kb(b,c[e>>2]|0);c[j>>2]=535;k=c[b+40>>2]|0;l=(k|0)==0?j:k;k=c[f>>2]|0;if(!k)m=b;else{j=b+24|0;n=e+8|0;e=b+36|0;o=b+20|0;p=f;f=k;do{_Kb(b,f);k=c[p+4>>2]|0;if($Kb(b,d)|0){q=ea(g[d>>2]);go[c[n>>2]&63](c[j>>2]|0,k,q)}k=c[b>>2]|0;r=c[k+8>>2]|0;if(r){s=r+-1|0;t=c[k+4>>2]|0;if((a[t+(s<<3)+4>>0]|0)!=0?(a[t+(s<<3)+5>>0]|0)!=0:0){s=c[o>>2]|0;mo[c[(c[s>>2]|0)+40>>2]&4095](s)|0;s=c[b>>2]|0;u=s;v=c[s+8>>2]|0}else{u=k;v=r}c[u+8>>2]=v+-1;r=c[b>>2]|0;k=c[r+8>>2]|0;a[e>>0]=1;if((k|0)!=0?(a[(c[r+4>>2]|0)+(k+-1<<3)+5>>0]|0)==0:0)a[e>>0]=0}else a[e>>0]=1;c[l>>2]=(c[l>>2]|0)+1;p=p+8|0;f=c[p>>2]|0}while((f|0)!=0);m=b}f=c[m>>2]|0;p=c[f+8>>2]|0;if(!p){a[b+36>>0]=1;i=h;return}l=p+-1|0;e=c[f+4>>2]|0;if((a[e+(l<<3)+4>>0]|0)!=0?(a[e+(l<<3)+5>>0]|0)!=0:0){l=c[b+20>>2]|0;mo[c[(c[l>>2]|0)+40>>2]&4095](l)|0;l=c[m>>2]|0;w=l;x=c[l+8>>2]|0}else{w=f;x=p}c[w+8>>2]=x+-1;x=c[m>>2]|0;m=c[x+8>>2]|0;w=b+36|0;a[w>>0]=1;if(!m){i=h;return}if(a[(c[x+4>>2]|0)+(m+-1<<3)+5>>0]|0){i=h;return}a[w>>0]=0;i=h;return}function nJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;aLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(bLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function oJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;aLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(bLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function pJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;aLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(bLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function qJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;aLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(bLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function rJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;aLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(bLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function sJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;aLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(bLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function tJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];aLb(b,c[d>>2]|0);cLb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function uJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;dLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(eLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function vJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;dLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(eLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function wJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;dLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(eLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function xJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;dLb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(eLb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function yJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;fLb(b,c[e>>2]|0);a[g>>0]=0;c[g+4>>2]=0;c[g+8>>2]=d;c[g+12>>2]=e;gLb(b,0,g,0);g=c[b>>2]|0;e=c[g+8>>2]|0;if(!e){a[b+36>>0]=1;i=f;return}d=e+-1|0;h=c[g+4>>2]|0;if((a[h+(d<<3)+4>>0]|0)!=0?(a[h+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;j=d;k=c[d+8>>2]|0}else{j=g;k=e}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;e=b+36|0;a[e>>0]=1;if(!j){i=f;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=f;return}a[e>>0]=0;i=f;return}function zJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;fLb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;hLb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function AJb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;a[f>>0]=0;iLb(c,d,b,f);jLb(c,b+24|0,0);kLb(c,b+40|0,0);lLb(c,b+56|0,0);mLb(c,b+72|0,0);nLb(c,b+88|0,0);oLb(c,b+104|0,0);pLb(c,b+120|0,0);qLb(c,b+136|0,0);rLb(c,b+152|0,0);sLb(c,b+168|0,0);tLb(c,b+184|0,0);uLb(c,b+200|0,0);vLb(c,b+216|0,0);wLb(c,b+232|0,0);xLb(c,b+248|0,0);yLb(c,b+264|0,0);zLb(c,b+280|0,0);i=e;return d+18|0}function BJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0;f=i;i=i+32|0;g=f;h=f+8|0;j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=e;c[h+12>>2]=b;ALb(d,0,h,0);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+24|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;BLb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+40|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;CLb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+56|0;a[h>>0]=0;c[h+4>>2]=0;I=h+8|0;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];I=c[J>>2]|0;if(G){J=G+-1|0;F=c[H+4>>2]|0;if(!(a[F+(J<<3)+4>>0]|0)){D=c[d+4>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[F+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=I;a[g+4>>0]=0;I=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[I>>2]|0}c[I>>2]=M+1}else OAb(K,g)|0;DLb(d,h);K=c[d>>2]|0;M=c[K+8>>2]|0;if(!M){N=0;O=K}else{if(!(a[(c[K+4>>2]|0)+(M+-1<<3)+4>>0]|0)){P=K;Q=M}else{M=c[d+4>>2]|0;ko[c[(c[M>>2]|0)+20>>2]&4095](M);M=c[d>>2]|0;P=M;Q=c[M+8>>2]|0}c[P+8>>2]=Q+-1;Q=c[d>>2]|0;N=c[Q+8>>2]|0;O=Q}Q=b+72|0;a[h>>0]=0;c[h+4>>2]=0;P=h+8|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];c[P+12>>2]=c[Q+12>>2];P=c[Q>>2]|0;if(N){Q=N+-1|0;M=c[O+4>>2]|0;if(!(a[M+(Q<<3)+4>>0]|0)){K=c[d+4>>2]|0;In[c[(c[K>>2]|0)+16>>2]&4095](K,c[M+(Q<<3)>>2]|0);Q=c[d>>2]|0;a[(c[Q+4>>2]|0)+((c[Q+8>>2]|0)+-1<<3)+4>>0]=1;Q=c[d>>2]|0;R=Q;S=c[Q+8>>2]|0}else{R=O;S=N}}else{R=O;S=0}c[g>>2]=P;a[g+4>>0]=0;P=R+8|0;if((c[R+12>>2]&2147483647)>>>0>S>>>0){O=(c[R+4>>2]|0)+(S<<3)|0;if(!O)T=S;else{S=g;N=c[S+4>>2]|0;Q=O;c[Q>>2]=c[S>>2];c[Q+4>>2]=N;T=c[P>>2]|0}c[P>>2]=T+1}else OAb(R,g)|0;ELb(d,h);R=c[d>>2]|0;T=c[R+8>>2]|0;if(!T){U=0;V=R}else{if(!(a[(c[R+4>>2]|0)+(T+-1<<3)+4>>0]|0)){W=R;X=T}else{T=c[d+4>>2]|0;ko[c[(c[T>>2]|0)+20>>2]&4095](T);T=c[d>>2]|0;W=T;X=c[T+8>>2]|0}c[W+8>>2]=X+-1;X=c[d>>2]|0;U=c[X+8>>2]|0;V=X}X=b+88|0;a[h>>0]=0;c[h+4>>2]=0;W=h+8|0;c[W+0>>2]=c[X+0>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];c[W+12>>2]=c[X+12>>2];W=c[X>>2]|0;if(U){X=U+-1|0;T=c[V+4>>2]|0;if(!(a[T+(X<<3)+4>>0]|0)){R=c[d+4>>2]|0;In[c[(c[R>>2]|0)+16>>2]&4095](R,c[T+(X<<3)>>2]|0);X=c[d>>2]|0;a[(c[X+4>>2]|0)+((c[X+8>>2]|0)+-1<<3)+4>>0]=1;X=c[d>>2]|0;Y=X;Z=c[X+8>>2]|0}else{Y=V;Z=U}}else{Y=V;Z=0}c[g>>2]=W;a[g+4>>0]=0;W=Y+8|0;if((c[Y+12>>2]&2147483647)>>>0>Z>>>0){V=(c[Y+4>>2]|0)+(Z<<3)|0;if(!V)_=Z;else{Z=g;U=c[Z+4>>2]|0;X=V;c[X>>2]=c[Z>>2];c[X+4>>2]=U;_=c[W>>2]|0}c[W>>2]=_+1}else OAb(Y,g)|0;FLb(d,h);Y=c[d>>2]|0;_=c[Y+8>>2]|0;if(!_){$=0;aa=Y}else{if(!(a[(c[Y+4>>2]|0)+(_+-1<<3)+4>>0]|0)){ba=Y;ca=_}else{_=c[d+4>>2]|0;ko[c[(c[_>>2]|0)+20>>2]&4095](_);_=c[d>>2]|0;ba=_;ca=c[_+8>>2]|0}c[ba+8>>2]=ca+-1;ca=c[d>>2]|0;$=c[ca+8>>2]|0;aa=ca}ca=b+104|0;a[h>>0]=0;c[h+4>>2]=0;ba=h+8|0;c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];ba=c[ca>>2]|0;do if(!$){da=aa;ea=0}else{ca=$+-1|0;_=c[aa+4>>2]|0;if(a[_+(ca<<3)+4>>0]|0){da=aa;ea=$;break}Y=c[d+4>>2]|0;In[c[(c[Y>>2]|0)+16>>2]&4095](Y,c[_+(ca<<3)>>2]|0);ca=c[d>>2]|0;a[(c[ca+4>>2]|0)+((c[ca+8>>2]|0)+-1<<3)+4>>0]=1;ca=c[d>>2]|0;da=ca;ea=c[ca+8>>2]|0}while(0);c[g>>2]=ba;a[g+4>>0]=0;ba=da+8|0;if((c[da+12>>2]&2147483647)>>>0>ea>>>0){$=(c[da+4>>2]|0)+(ea<<3)|0;if(!$)fa=ea;else{ea=g;aa=c[ea+4>>2]|0;ca=$;c[ca>>2]=c[ea>>2];c[ca+4>>2]=aa;fa=c[ba>>2]|0}c[ba>>2]=fa+1}else OAb(da,g)|0;GLb(d,h);da=c[d>>2]|0;fa=c[da+8>>2]|0;if(!fa){ga=0;ha=da}else{if(!(a[(c[da+4>>2]|0)+(fa+-1<<3)+4>>0]|0)){ia=da;ja=fa}else{fa=c[d+4>>2]|0;ko[c[(c[fa>>2]|0)+20>>2]&4095](fa);fa=c[d>>2]|0;ia=fa;ja=c[fa+8>>2]|0}c[ia+8>>2]=ja+-1;ja=c[d>>2]|0;ga=c[ja+8>>2]|0;ha=ja}ja=b+120|0;a[h>>0]=0;c[h+4>>2]=0;ia=h+8|0;c[ia+0>>2]=c[ja+0>>2];c[ia+4>>2]=c[ja+4>>2];c[ia+8>>2]=c[ja+8>>2];c[ia+12>>2]=c[ja+12>>2];ia=c[ja>>2]|0;do if(!ga){ka=ha;la=0}else{ja=ga+-1|0;fa=c[ha+4>>2]|0;if(a[fa+(ja<<3)+4>>0]|0){ka=ha;la=ga;break}da=c[d+4>>2]|0;In[c[(c[da>>2]|0)+16>>2]&4095](da,c[fa+(ja<<3)>>2]|0);ja=c[d>>2]|0;a[(c[ja+4>>2]|0)+((c[ja+8>>2]|0)+-1<<3)+4>>0]=1;ja=c[d>>2]|0;ka=ja;la=c[ja+8>>2]|0}while(0);c[g>>2]=ia;a[g+4>>0]=0;ia=ka+8|0;if((c[ka+12>>2]&2147483647)>>>0>la>>>0){ga=(c[ka+4>>2]|0)+(la<<3)|0;if(!ga)ma=la;else{la=g;ha=c[la+4>>2]|0;ja=ga;c[ja>>2]=c[la>>2];c[ja+4>>2]=ha;ma=c[ia>>2]|0}c[ia>>2]=ma+1}else OAb(ka,g)|0;HLb(d,h);ka=c[d>>2]|0;ma=c[ka+8>>2]|0;if(!ma){na=0;oa=ka}else{if(!(a[(c[ka+4>>2]|0)+(ma+-1<<3)+4>>0]|0)){pa=ka;qa=ma}else{ma=c[d+4>>2]|0;ko[c[(c[ma>>2]|0)+20>>2]&4095](ma);ma=c[d>>2]|0;pa=ma;qa=c[ma+8>>2]|0}c[pa+8>>2]=qa+-1;qa=c[d>>2]|0;na=c[qa+8>>2]|0;oa=qa}qa=b+136|0;a[h>>0]=0;c[h+4>>2]=0;pa=h+8|0;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];c[pa+12>>2]=c[qa+12>>2];pa=c[qa>>2]|0;do if(!na){ra=oa;sa=0}else{qa=na+-1|0;ma=c[oa+4>>2]|0;if(a[ma+(qa<<3)+4>>0]|0){ra=oa;sa=na;break}ka=c[d+4>>2]|0;In[c[(c[ka>>2]|0)+16>>2]&4095](ka,c[ma+(qa<<3)>>2]|0);qa=c[d>>2]|0;a[(c[qa+4>>2]|0)+((c[qa+8>>2]|0)+-1<<3)+4>>0]=1;qa=c[d>>2]|0;ra=qa;sa=c[qa+8>>2]|0}while(0);c[g>>2]=pa;a[g+4>>0]=0;pa=ra+8|0;if((c[ra+12>>2]&2147483647)>>>0>sa>>>0){na=(c[ra+4>>2]|0)+(sa<<3)|0;if(!na)ta=sa;else{sa=g;oa=c[sa+4>>2]|0;qa=na;c[qa>>2]=c[sa>>2];c[qa+4>>2]=oa;ta=c[pa>>2]|0}c[pa>>2]=ta+1}else OAb(ra,g)|0;ILb(d,h);ra=c[d>>2]|0;ta=c[ra+8>>2]|0;if(!ta){ua=0;va=ra}else{if(!(a[(c[ra+4>>2]|0)+(ta+-1<<3)+4>>0]|0)){wa=ra;xa=ta}else{ta=c[d+4>>2]|0;ko[c[(c[ta>>2]|0)+20>>2]&4095](ta);ta=c[d>>2]|0;wa=ta;xa=c[ta+8>>2]|0}c[wa+8>>2]=xa+-1;xa=c[d>>2]|0;ua=c[xa+8>>2]|0;va=xa}xa=b+152|0;a[h>>0]=0;c[h+4>>2]=0;wa=h+8|0;c[wa+0>>2]=c[xa+0>>2];c[wa+4>>2]=c[xa+4>>2];c[wa+8>>2]=c[xa+8>>2];c[wa+12>>2]=c[xa+12>>2];wa=c[xa>>2]|0;do if(!ua){ya=va;za=0}else{xa=ua+-1|0;ta=c[va+4>>2]|0;if(a[ta+(xa<<3)+4>>0]|0){ya=va;za=ua;break}ra=c[d+4>>2]|0;In[c[(c[ra>>2]|0)+16>>2]&4095](ra,c[ta+(xa<<3)>>2]|0);xa=c[d>>2]|0;a[(c[xa+4>>2]|0)+((c[xa+8>>2]|0)+-1<<3)+4>>0]=1;xa=c[d>>2]|0;ya=xa;za=c[xa+8>>2]|0}while(0);c[g>>2]=wa;a[g+4>>0]=0;wa=ya+8|0;if((c[ya+12>>2]&2147483647)>>>0>za>>>0){ua=(c[ya+4>>2]|0)+(za<<3)|0;if(!ua)Aa=za;else{za=g;va=c[za+4>>2]|0;xa=ua;c[xa>>2]=c[za>>2];c[xa+4>>2]=va;Aa=c[wa>>2]|0}c[wa>>2]=Aa+1}else OAb(ya,g)|0;JLb(d,h);ya=c[d>>2]|0;Aa=c[ya+8>>2]|0;if(!Aa){Ba=0;Ca=ya}else{if(!(a[(c[ya+4>>2]|0)+(Aa+-1<<3)+4>>0]|0)){Da=ya;Ea=Aa}else{Aa=c[d+4>>2]|0;ko[c[(c[Aa>>2]|0)+20>>2]&4095](Aa);Aa=c[d>>2]|0;Da=Aa;Ea=c[Aa+8>>2]|0}c[Da+8>>2]=Ea+-1;Ea=c[d>>2]|0;Ba=c[Ea+8>>2]|0;Ca=Ea}Ea=b+168|0;a[h>>0]=0;c[h+4>>2]=0;Da=h+8|0;c[Da+0>>2]=c[Ea+0>>2];c[Da+4>>2]=c[Ea+4>>2];c[Da+8>>2]=c[Ea+8>>2];c[Da+12>>2]=c[Ea+12>>2];Da=c[Ea>>2]|0;do if(!Ba){Fa=Ca;Ga=0}else{Ea=Ba+-1|0;Aa=c[Ca+4>>2]|0;if(a[Aa+(Ea<<3)+4>>0]|0){Fa=Ca;Ga=Ba;break}ya=c[d+4>>2]|0;In[c[(c[ya>>2]|0)+16>>2]&4095](ya,c[Aa+(Ea<<3)>>2]|0);Ea=c[d>>2]|0;a[(c[Ea+4>>2]|0)+((c[Ea+8>>2]|0)+-1<<3)+4>>0]=1;Ea=c[d>>2]|0;Fa=Ea;Ga=c[Ea+8>>2]|0}while(0);c[g>>2]=Da;a[g+4>>0]=0;Da=Fa+8|0;if((c[Fa+12>>2]&2147483647)>>>0>Ga>>>0){Ba=(c[Fa+4>>2]|0)+(Ga<<3)|0;if(!Ba)Ha=Ga;else{Ga=g;Ca=c[Ga+4>>2]|0;Ea=Ba;c[Ea>>2]=c[Ga>>2];c[Ea+4>>2]=Ca;Ha=c[Da>>2]|0}c[Da>>2]=Ha+1}else OAb(Fa,g)|0;KLb(d,h);Fa=c[d>>2]|0;Ha=c[Fa+8>>2]|0;if(!Ha){Ia=0;Ja=Fa}else{if(!(a[(c[Fa+4>>2]|0)+(Ha+-1<<3)+4>>0]|0)){Ka=Fa;La=Ha}else{Ha=c[d+4>>2]|0;ko[c[(c[Ha>>2]|0)+20>>2]&4095](Ha);Ha=c[d>>2]|0;Ka=Ha;La=c[Ha+8>>2]|0}c[Ka+8>>2]=La+-1;La=c[d>>2]|0;Ia=c[La+8>>2]|0;Ja=La}La=b+184|0;a[h>>0]=0;c[h+4>>2]=0;Ka=h+8|0;c[Ka+0>>2]=c[La+0>>2];c[Ka+4>>2]=c[La+4>>2];c[Ka+8>>2]=c[La+8>>2];c[Ka+12>>2]=c[La+12>>2];Ka=c[La>>2]|0;do if(!Ia){Ma=Ja;Na=0}else{La=Ia+-1|0;Ha=c[Ja+4>>2]|0;if(a[Ha+(La<<3)+4>>0]|0){Ma=Ja;Na=Ia;break}Fa=c[d+4>>2]|0;In[c[(c[Fa>>2]|0)+16>>2]&4095](Fa,c[Ha+(La<<3)>>2]|0);La=c[d>>2]|0;a[(c[La+4>>2]|0)+((c[La+8>>2]|0)+-1<<3)+4>>0]=1;La=c[d>>2]|0;Ma=La;Na=c[La+8>>2]|0}while(0);c[g>>2]=Ka;a[g+4>>0]=0;Ka=Ma+8|0;if((c[Ma+12>>2]&2147483647)>>>0>Na>>>0){Ia=(c[Ma+4>>2]|0)+(Na<<3)|0;if(!Ia)Oa=Na;else{Na=g;Ja=c[Na+4>>2]|0;La=Ia;c[La>>2]=c[Na>>2];c[La+4>>2]=Ja;Oa=c[Ka>>2]|0}c[Ka>>2]=Oa+1}else OAb(Ma,g)|0;LLb(d,h);Ma=c[d>>2]|0;Oa=c[Ma+8>>2]|0;if(!Oa){Pa=0;Qa=Ma}else{if(!(a[(c[Ma+4>>2]|0)+(Oa+-1<<3)+4>>0]|0)){Ra=Ma;Sa=Oa}else{Oa=c[d+4>>2]|0;ko[c[(c[Oa>>2]|0)+20>>2]&4095](Oa);Oa=c[d>>2]|0;Ra=Oa;Sa=c[Oa+8>>2]|0}c[Ra+8>>2]=Sa+-1;Sa=c[d>>2]|0;Pa=c[Sa+8>>2]|0;Qa=Sa}Sa=b+200|0;a[h>>0]=0;c[h+4>>2]=0;Ra=h+8|0;c[Ra+0>>2]=c[Sa+0>>2];c[Ra+4>>2]=c[Sa+4>>2];c[Ra+8>>2]=c[Sa+8>>2];c[Ra+12>>2]=c[Sa+12>>2];Ra=c[Sa>>2]|0;do if(!Pa){Ta=Qa;Ua=0}else{Sa=Pa+-1|0;Oa=c[Qa+4>>2]|0;if(a[Oa+(Sa<<3)+4>>0]|0){Ta=Qa;Ua=Pa;break}Ma=c[d+4>>2]|0;In[c[(c[Ma>>2]|0)+16>>2]&4095](Ma,c[Oa+(Sa<<3)>>2]|0);Sa=c[d>>2]|0;a[(c[Sa+4>>2]|0)+((c[Sa+8>>2]|0)+-1<<3)+4>>0]=1;Sa=c[d>>2]|0;Ta=Sa;Ua=c[Sa+8>>2]|0}while(0);c[g>>2]=Ra;a[g+4>>0]=0;Ra=Ta+8|0;if((c[Ta+12>>2]&2147483647)>>>0>Ua>>>0){Pa=(c[Ta+4>>2]|0)+(Ua<<3)|0;if(!Pa)Va=Ua;else{Ua=g;Qa=c[Ua+4>>2]|0;Sa=Pa;c[Sa>>2]=c[Ua>>2];c[Sa+4>>2]=Qa;Va=c[Ra>>2]|0}c[Ra>>2]=Va+1}else OAb(Ta,g)|0;MLb(d,h);Ta=c[d>>2]|0;Va=c[Ta+8>>2]|0;if(!Va){Wa=0;Xa=Ta}else{if(!(a[(c[Ta+4>>2]|0)+(Va+-1<<3)+4>>0]|0)){Ya=Ta;Za=Va}else{Va=c[d+4>>2]|0;ko[c[(c[Va>>2]|0)+20>>2]&4095](Va);Va=c[d>>2]|0;Ya=Va;Za=c[Va+8>>2]|0}c[Ya+8>>2]=Za+-1;Za=c[d>>2]|0;Wa=c[Za+8>>2]|0;Xa=Za}Za=b+216|0;a[h>>0]=0;c[h+4>>2]=0;Ya=h+8|0;c[Ya+0>>2]=c[Za+0>>2];c[Ya+4>>2]=c[Za+4>>2];c[Ya+8>>2]=c[Za+8>>2];c[Ya+12>>2]=c[Za+12>>2];Ya=c[Za>>2]|0;do if(!Wa){_a=Xa;$a=0}else{Za=Wa+-1|0;Va=c[Xa+4>>2]|0;if(a[Va+(Za<<3)+4>>0]|0){_a=Xa;$a=Wa;break}Ta=c[d+4>>2]|0;In[c[(c[Ta>>2]|0)+16>>2]&4095](Ta,c[Va+(Za<<3)>>2]|0);Za=c[d>>2]|0;a[(c[Za+4>>2]|0)+((c[Za+8>>2]|0)+-1<<3)+4>>0]=1;Za=c[d>>2]|0;_a=Za;$a=c[Za+8>>2]|0}while(0);c[g>>2]=Ya;a[g+4>>0]=0;Ya=_a+8|0;if((c[_a+12>>2]&2147483647)>>>0>$a>>>0){Wa=(c[_a+4>>2]|0)+($a<<3)|0;if(!Wa)ab=$a;else{$a=g;Xa=c[$a+4>>2]|0;Za=Wa;c[Za>>2]=c[$a>>2];c[Za+4>>2]=Xa;ab=c[Ya>>2]|0}c[Ya>>2]=ab+1}else OAb(_a,g)|0;NLb(d,h);_a=c[d>>2]|0;ab=c[_a+8>>2]|0;if(!ab){bb=0;cb=_a}else{if(!(a[(c[_a+4>>2]|0)+(ab+-1<<3)+4>>0]|0)){db=_a;eb=ab}else{ab=c[d+4>>2]|0;ko[c[(c[ab>>2]|0)+20>>2]&4095](ab);ab=c[d>>2]|0;db=ab;eb=c[ab+8>>2]|0}c[db+8>>2]=eb+-1;eb=c[d>>2]|0;bb=c[eb+8>>2]|0;cb=eb}eb=b+232|0;a[h>>0]=0;c[h+4>>2]=0;db=h+8|0;c[db+0>>2]=c[eb+0>>2];c[db+4>>2]=c[eb+4>>2];c[db+8>>2]=c[eb+8>>2];c[db+12>>2]=c[eb+12>>2];db=c[eb>>2]|0;do if(!bb){fb=cb;gb=0}else{eb=bb+-1|0;ab=c[cb+4>>2]|0;if(a[ab+(eb<<3)+4>>0]|0){fb=cb;gb=bb;break}_a=c[d+4>>2]|0;In[c[(c[_a>>2]|0)+16>>2]&4095](_a,c[ab+(eb<<3)>>2]|0);eb=c[d>>2]|0;a[(c[eb+4>>2]|0)+((c[eb+8>>2]|0)+-1<<3)+4>>0]=1;eb=c[d>>2]|0;fb=eb;gb=c[eb+8>>2]|0}while(0);c[g>>2]=db;a[g+4>>0]=0;db=fb+8|0;if((c[fb+12>>2]&2147483647)>>>0>gb>>>0){bb=(c[fb+4>>2]|0)+(gb<<3)|0;if(!bb)hb=gb;else{gb=g;cb=c[gb+4>>2]|0;eb=bb;c[eb>>2]=c[gb>>2];c[eb+4>>2]=cb;hb=c[db>>2]|0}c[db>>2]=hb+1}else OAb(fb,g)|0;OLb(d,h);fb=c[d>>2]|0;hb=c[fb+8>>2]|0;if(!hb){ib=0;jb=fb}else{if(!(a[(c[fb+4>>2]|0)+(hb+-1<<3)+4>>0]|0)){kb=fb;lb=hb}else{hb=c[d+4>>2]|0;ko[c[(c[hb>>2]|0)+20>>2]&4095](hb);hb=c[d>>2]|0;kb=hb;lb=c[hb+8>>2]|0}c[kb+8>>2]=lb+-1;lb=c[d>>2]|0;ib=c[lb+8>>2]|0;jb=lb}lb=b+248|0;a[h>>0]=0;c[h+4>>2]=0;kb=h+8|0;c[kb+0>>2]=c[lb+0>>2];c[kb+4>>2]=c[lb+4>>2];c[kb+8>>2]=c[lb+8>>2];c[kb+12>>2]=c[lb+12>>2];kb=c[lb>>2]|0;do if(!ib){mb=jb;nb=0}else{lb=ib+-1|0;hb=c[jb+4>>2]|0;if(a[hb+(lb<<3)+4>>0]|0){mb=jb;nb=ib;break}fb=c[d+4>>2]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[hb+(lb<<3)>>2]|0);lb=c[d>>2]|0;a[(c[lb+4>>2]|0)+((c[lb+8>>2]|0)+-1<<3)+4>>0]=1;lb=c[d>>2]|0;mb=lb;nb=c[lb+8>>2]|0}while(0);c[g>>2]=kb;a[g+4>>0]=0;kb=mb+8|0;if((c[mb+12>>2]&2147483647)>>>0>nb>>>0){ib=(c[mb+4>>2]|0)+(nb<<3)|0;if(!ib)ob=nb;else{nb=g;jb=c[nb+4>>2]|0;lb=ib;c[lb>>2]=c[nb>>2];c[lb+4>>2]=jb;ob=c[kb>>2]|0}c[kb>>2]=ob+1}else OAb(mb,g)|0;PLb(d,h);mb=c[d>>2]|0;ob=c[mb+8>>2]|0;if(!ob){pb=0;qb=mb}else{if(!(a[(c[mb+4>>2]|0)+(ob+-1<<3)+4>>0]|0)){rb=mb;sb=ob}else{ob=c[d+4>>2]|0;ko[c[(c[ob>>2]|0)+20>>2]&4095](ob);ob=c[d>>2]|0;rb=ob;sb=c[ob+8>>2]|0}c[rb+8>>2]=sb+-1;sb=c[d>>2]|0;pb=c[sb+8>>2]|0;qb=sb}sb=b+264|0;a[h>>0]=0;c[h+4>>2]=0;rb=h+8|0;c[rb+0>>2]=c[sb+0>>2];c[rb+4>>2]=c[sb+4>>2];c[rb+8>>2]=c[sb+8>>2];c[rb+12>>2]=c[sb+12>>2];rb=c[sb>>2]|0;do if(!pb){tb=qb;ub=0}else{sb=pb+-1|0;ob=c[qb+4>>2]|0;if(a[ob+(sb<<3)+4>>0]|0){tb=qb;ub=pb;break}mb=c[d+4>>2]|0;In[c[(c[mb>>2]|0)+16>>2]&4095](mb,c[ob+(sb<<3)>>2]|0);sb=c[d>>2]|0;a[(c[sb+4>>2]|0)+((c[sb+8>>2]|0)+-1<<3)+4>>0]=1;sb=c[d>>2]|0;tb=sb;ub=c[sb+8>>2]|0}while(0);c[g>>2]=rb;a[g+4>>0]=0;rb=tb+8|0;if((c[tb+12>>2]&2147483647)>>>0>ub>>>0){pb=(c[tb+4>>2]|0)+(ub<<3)|0;if(!pb)vb=ub;else{ub=g;qb=c[ub+4>>2]|0;sb=pb;c[sb>>2]=c[ub>>2];c[sb+4>>2]=qb;vb=c[rb>>2]|0}c[rb>>2]=vb+1}else OAb(tb,g)|0;QLb(d,h);tb=c[d>>2]|0;vb=c[tb+8>>2]|0;if(!vb){wb=0;xb=tb}else{if(!(a[(c[tb+4>>2]|0)+(vb+-1<<3)+4>>0]|0)){yb=tb;zb=vb}else{vb=c[d+4>>2]|0;ko[c[(c[vb>>2]|0)+20>>2]&4095](vb);vb=c[d>>2]|0;yb=vb;zb=c[vb+8>>2]|0}c[yb+8>>2]=zb+-1;zb=c[d>>2]|0;wb=c[zb+8>>2]|0;xb=zb}zb=b+280|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[zb+0>>2];c[b+4>>2]=c[zb+4>>2];c[b+8>>2]=c[zb+8>>2];c[b+12>>2]=c[zb+12>>2];b=c[zb>>2]|0;do if(!wb){Ab=xb;Bb=0}else{zb=wb+-1|0;yb=c[xb+4>>2]|0;if(a[yb+(zb<<3)+4>>0]|0){Ab=xb;Bb=wb;break}vb=c[d+4>>2]|0;In[c[(c[vb>>2]|0)+16>>2]&4095](vb,c[yb+(zb<<3)>>2]|0);zb=c[d>>2]|0;a[(c[zb+4>>2]|0)+((c[zb+8>>2]|0)+-1<<3)+4>>0]=1;zb=c[d>>2]|0;Ab=zb;Bb=c[zb+8>>2]|0}while(0);c[g>>2]=b;a[g+4>>0]=0;b=Ab+8|0;if((c[Ab+12>>2]&2147483647)>>>0>Bb>>>0){wb=(c[Ab+4>>2]|0)+(Bb<<3)|0;if(!wb)Cb=Bb;else{Bb=g;xb=c[Bb+4>>2]|0;zb=wb;c[zb>>2]=c[Bb>>2];c[zb+4>>2]=xb;Cb=c[b>>2]|0}c[b>>2]=Cb+1}else OAb(Ab,g)|0;RLb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){Db=e+18|0;i=f;return Db|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){Eb=h;Fb=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;Eb=g;Fb=c[g+8>>2]|0}c[Eb+8>>2]=Fb+-1;Db=e+18|0;i=f;return Db|0}function CJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+432|0;f=e+288|0;g=e+256|0;h=e+144|0;j=e;k=c[b+24>>2]|0;if(!k)l=0;else l=c[k>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,144)|0;qFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;qFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;SLb(f,g,0)|0;i=e;return}function DJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+304|0;f=e+240|0;g=e+208|0;h=e+64|0;j=e;k=c[b+24>>2]|0;if(!k)l=112;else l=(c[k>>2]|0)+112|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+64|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));tFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;tFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;TLb(f,g,0)|0;i=e;return}function EJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e+96|0;g=e+64|0;h=e+48|0;j=e;k=c[b+24>>2]|0;if(!k)l=256;else l=(c[k>>2]|0)+256|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;ULb(f,g,0)|0;i=e;return}function FJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+384|0;f=e+336|0;g=e+304|0;h=e+48|0;j=e;k=c[b+24>>2]|0;if(!k)l=272;else l=(c[k>>2]|0)+272|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));AFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;AFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;VLb(f,g,0)|0;i=e;return}function GJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+288|0;f=e+176|0;g=e+144|0;h=e+112|0;j=e;k=c[b+24>>2]|0;if(!k)l=528;else l=(c[k>>2]|0)+528|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+112|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));BFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;BFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;WLb(f,g,0)|0;i=e;return}function HJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+176|0;f=e+112|0;g=e+80|0;h=e+64|0;j=e;k=c[b+24>>2]|0;if(!k)l=560;else l=(c[k>>2]|0)+560|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+64|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));FFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;FFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;XLb(f,g,0)|0;i=e;return}function IJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+176|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];YLb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=0;else k=c[d>>2]|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,144)|0;qFa(f);ZLb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function JJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];YLb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=112;else j=(c[d>>2]|0)+112|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=657;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}_Lb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function KJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];YLb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=256;else j=(c[d>>2]|0)+256|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=658;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}$Lb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function LJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];YLb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=272;else j=(c[d>>2]|0)+272|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=659;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}aMb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function MJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;bMb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+16|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;cMb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+32|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;dMb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+48|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[J+0>>2];c[b+4>>2]=c[J+4>>2];c[b+8>>2]=c[J+8>>2];c[b+12>>2]=c[J+12>>2];b=c[J>>2]|0;if(G){J=G+-1|0;I=c[H+4>>2]|0;if(!(a[I+(J<<3)+4>>0]|0)){F=c[d+4>>2]|0;In[c[(c[F>>2]|0)+16>>2]&4095](F,c[I+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=b;a[g+4>>0]=0;b=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[b>>2]|0}c[b>>2]=M+1}else OAb(K,g)|0;eMb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){N=e+4|0;i=f;return N|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){O=h;P=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;O=g;P=c[g+8>>2]|0}c[O+8>>2]=P+-1;N=e+4|0;i=f;return N|0}function NJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+176|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];fMb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=0;else k=c[d>>2]|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;PEi(f|0,0,144)|0;qFa(f);gMb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function OJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];fMb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=112;else j=(c[d>>2]|0)+112|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=657;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}hMb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function PJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];fMb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=256;else j=(c[d>>2]|0)+256|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=658;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}iMb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function QJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;a[f>>0]=0;g=f+4|0;c[g>>2]=0;h=f+8|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];fMb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)j=272;else j=(c[d>>2]|0)+272|0;a[f>>0]=1;c[g>>2]=j;j=c[b+40>>2]|0;if(!j)k=659;else{g=c[j>>2]|0;c[j>>2]=g+1;k=g}jMb(b,k,f);f=c[b>>2]|0;k=c[f+8>>2]|0;if(!k){a[b+36>>0]=1;i=e;return}g=k+-1|0;j=c[f+4>>2]|0;if((a[j+(g<<3)+4>>0]|0)!=0?(a[j+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;l=g;m=c[g+8>>2]|0}else{l=f;m=k}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;k=b+36|0;a[k>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[k>>0]=0;i=e;return}function RJb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+24|0;g=e;a[g>>0]=0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];fMb(b,c[d>>2]|0);d=c[b+44>>2]|0;if(!d)k=528;else k=(c[d>>2]|0)+528|0;a[g>>0]=1;c[h>>2]=k;k=c[b+40>>2]|0;if(k)c[k>>2]=(c[k>>2]|0)+1;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;EFa(f);kMb(b,0,g,f);f=c[b>>2]|0;g=c[f+8>>2]|0;if(!g){a[b+36>>0]=1;i=e;return}k=g+-1|0;h=c[f+4>>2]|0;if((a[h+(k<<3)+4>>0]|0)!=0?(a[h+(k<<3)+5>>0]|0)!=0:0){k=c[b+20>>2]|0;mo[c[(c[k>>2]|0)+40>>2]&4095](k)|0;k=c[b>>2]|0;l=k;m=c[k+8>>2]|0}else{l=f;m=g}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;g=b+36|0;a[g>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[g>>0]=0;i=e;return}function SJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+432|0;f=e+288|0;g=e+256|0;h=e+144|0;j=e;k=c[b+24>>2]|0;if(!k)l=0;else l=c[k>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,144)|0;qFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;qFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;SLb(f,g,0)|0;i=e;return}function TJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+304|0;f=e+240|0;g=e+208|0;h=e+64|0;j=e;k=c[b+24>>2]|0;if(!k)l=112;else l=(c[k>>2]|0)+112|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+64|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));tFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;tFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;TLb(f,g,0)|0;i=e;return}function UJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e+96|0;g=e+64|0;h=e+48|0;j=e;k=c[b+24>>2]|0;if(!k)l=256;else l=(c[k>>2]|0)+256|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;ULb(f,g,0)|0;i=e;return}function VJb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+384|0;f=e+336|0;g=e+304|0;h=e+48|0;j=e;k=c[b+24>>2]|0;if(!k)l=272;else l=(c[k>>2]|0)+272|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));AFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;AFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;VLb(f,g,0)|0;i=e;return}function WJb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+80|0;j=h;k=h+56|0;l=h+40|0;m=h+8|0;EFa(l);c[m>>2]=b;n=m+4|0;c[n>>2]=e;c[m+8>>2]=d;c[m+12>>2]=f;c[m+16>>2]=g;c[m+20>>2]=0;c[m+24>>2]=0;a[k>>0]=0;c[k+4>>2]=0;g=k+8|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];g=c[l>>2]|0;l=b+8|0;f=c[l>>2]|0;if(f){d=f+-1|0;o=b+4|0;p=c[o>>2]|0;if(!(a[p+(d<<3)+4>>0]|0)){In[c[(c[e>>2]|0)+16>>2]&4095](e,c[p+(d<<3)>>2]|0);d=c[l>>2]|0;a[(c[o>>2]|0)+(d+-1<<3)+4>>0]=1;q=d}else q=f}else q=0;c[j>>2]=g;a[j+4>>0]=0;if((c[b+12>>2]&2147483647)>>>0>q>>>0){g=(c[b+4>>2]|0)+(q<<3)|0;if(!g)r=q;else{q=j;f=c[q+4>>2]|0;d=g;c[d>>2]=c[q>>2];c[d+4>>2]=f;r=c[l>>2]|0}c[l>>2]=r+1}else OAb(b,j)|0;lMb(m,k);k=c[m>>2]|0;m=k+8|0;j=c[m>>2]|0;if(!j){i=h;return}if(!(a[(c[k+4>>2]|0)+(j+-1<<3)+4>>0]|0))s=j;else{j=c[n>>2]|0;ko[c[(c[j>>2]|0)+20>>2]&4095](j);s=c[m>>2]|0}c[m>>2]=s+-1;i=h;return}function XJb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+4|0;f=c[e>>2]|0;g=c[f+8>>2]|0;if(!g){i=d;return}h=c[(c[f+4>>2]|0)+(g+-1<<2)>>2]|0;j=c[b>>2]|0;k=c[j+8>>2]|0;if(k>>>0>h>>>0){l=b+36|0;m=b+20|0;n=k;k=j;do{if(!n){o=5;break}j=n+-1|0;p=c[k+4>>2]|0;if((a[p+(j<<3)+4>>0]|0)!=0?(a[p+(j<<3)+5>>0]|0)!=0:0){j=c[m>>2]|0;mo[c[(c[j>>2]|0)+40>>2]&4095](j)|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=k;r=n}c[q+8>>2]=r+-1;k=c[b>>2]|0;n=c[k+8>>2]|0;a[l>>0]=1;if(!n)break;if(!(a[(c[k+4>>2]|0)+(n+-1<<3)+5>>0]|0))a[l>>0]=0}while(n>>>0>h>>>0);if((o|0)==5)a[l>>0]=1;l=c[e>>2]|0;s=l;t=c[l+8>>2]|0}else{s=f;t=g}c[s+8>>2]=t+-1;i=d;return}function YJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+752|0;d=f;h=f+584|0;j=f+328|0;k=f+664|0;l=f+712|0;m=f+616|0;n=f+164|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=j+240|0;r=j+244|0;c[j+248>>2]=0;s=j+252|0;a[q>>0]=1;c[r>>2]=j;c[s>>2]=5;g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(.300000012);g[k+12>>2]=ea(.100000001);t=k+16|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;g[k+32>>2]=ea(1.0);g[k+36>>2]=ea(1.0);mMb(j,e,k);if(e){k=d+4|0;t=b+4|0;u=b+12|0;v=b+16|0;w=h+4|0;x=h+8|0;y=h+12|0;z=h+16|0;A=h+20|0;B=h+24|0;C=0;do{D=l+0|0;E=D+32|0;do{a[D>>0]=0;D=D+1|0}while((D|0)<(E|0));c[d>>2]=C;TUa(l,0,515856,d)|0;D=c[b>>2]|0;E=c[D+8>>2]|0;if(E){F=E+-1|0;G=c[D+4>>2]|0;if(!(a[G+(F<<3)+4>>0]|0)){H=c[t>>2]|0;In[c[(c[H>>2]|0)+16>>2]&4095](H,c[G+(F<<3)>>2]|0);F=c[b>>2]|0;a[(c[F+4>>2]|0)+((c[F+8>>2]|0)+-1<<3)+4>>0]=1;F=c[b>>2]|0;I=F;J=c[F+8>>2]|0}else{I=D;J=E}}else{I=D;J=0}c[d>>2]=l;a[k>>0]=0;D=I+8|0;if((c[I+12>>2]&2147483647)>>>0>J>>>0){E=(c[I+4>>2]|0)+(J<<3)|0;if(!E)K=J;else{F=d;G=c[F+4>>2]|0;H=E;c[H>>2]=c[F>>2];c[H+4>>2]=G;K=c[D>>2]|0}c[D>>2]=K+1}else OAb(I,d)|0;co[c[(c[p>>2]|0)+12>>2]&2047](m,c[o>>2]|0,C);PEi(n|0,0,164)|0;PFa(n);D=c[b>>2]|0;G=c[t>>2]|0;H=c[u>>2]|0;F=c[v>>2]|0;PFa(d);c[h>>2]=D;c[w>>2]=G;c[x>>2]=m;c[y>>2]=H;c[z>>2]=F;c[A>>2]=0;c[B>>2]=0;nMb(d,h,0)|0;F=c[b>>2]|0;H=c[F+8>>2]|0;if(H){if(!(a[(c[F+4>>2]|0)+(H+-1<<3)+4>>0]|0)){L=F;M=H}else{H=c[t>>2]|0;ko[c[(c[H>>2]|0)+20>>2]&4095](H);H=c[b>>2]|0;L=H;M=c[H+8>>2]|0}c[L+8>>2]=M+-1}C=C+1|0}while((C|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((j|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function ZJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+752|0;d=f;h=f+592|0;j=f+336|0;k=f+672|0;l=f+720|0;m=f+624|0;n=f+168|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=j+240|0;r=j+244|0;c[j+248>>2]=0;s=j+252|0;a[q>>0]=1;c[r>>2]=j;c[s>>2]=5;g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(20.0);g[k+12>>2]=ea(0.0);g[k+16>>2]=ea(.25);g[k+20>>2]=ea(1500.0);t=k+24|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;oMb(j,e,k);if(e){k=d+4|0;t=b+4|0;u=b+12|0;v=b+16|0;w=h+4|0;x=h+8|0;y=h+12|0;z=h+16|0;A=h+20|0;B=h+24|0;C=0;do{D=l+0|0;E=D+32|0;do{a[D>>0]=0;D=D+1|0}while((D|0)<(E|0));c[d>>2]=C;TUa(l,0,515856,d)|0;D=c[b>>2]|0;E=c[D+8>>2]|0;if(E){F=E+-1|0;G=c[D+4>>2]|0;if(!(a[G+(F<<3)+4>>0]|0)){H=c[t>>2]|0;In[c[(c[H>>2]|0)+16>>2]&4095](H,c[G+(F<<3)>>2]|0);F=c[b>>2]|0;a[(c[F+4>>2]|0)+((c[F+8>>2]|0)+-1<<3)+4>>0]=1;F=c[b>>2]|0;I=F;J=c[F+8>>2]|0}else{I=D;J=E}}else{I=D;J=0}c[d>>2]=l;a[k>>0]=0;D=I+8|0;if((c[I+12>>2]&2147483647)>>>0>J>>>0){E=(c[I+4>>2]|0)+(J<<3)|0;if(!E)K=J;else{F=d;G=c[F+4>>2]|0;H=E;c[H>>2]=c[F>>2];c[H+4>>2]=G;K=c[D>>2]|0}c[D>>2]=K+1}else OAb(I,d)|0;co[c[(c[p>>2]|0)+12>>2]&2047](m,c[o>>2]|0,C);PEi(n|0,0,168)|0;LFa(n);D=c[b>>2]|0;G=c[t>>2]|0;H=c[u>>2]|0;F=c[v>>2]|0;LFa(d);c[h>>2]=D;c[w>>2]=G;c[x>>2]=m;c[y>>2]=H;c[z>>2]=F;c[A>>2]=0;c[B>>2]=0;pMb(d,h,0)|0;F=c[b>>2]|0;H=c[F+8>>2]|0;if(H){if(!(a[(c[F+4>>2]|0)+(H+-1<<3)+4>>0]|0)){L=F;M=H}else{H=c[t>>2]|0;ko[c[(c[H>>2]|0)+20>>2]&4095](H);H=c[b>>2]|0;L=H;M=c[H+8>>2]|0}c[L+8>>2]=M+-1}C=C+1|0}while((C|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((j|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function _Jb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+816|0;d=f;h=f+616|0;j=f+280|0;k=f+712|0;l=f+776|0;m=f+648|0;n=f+140|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=j+320|0;r=j+324|0;c[j+328>>2]=0;s=j+332|0;a[q>>0]=1;c[r>>2]=j;c[s>>2]=5;g[k>>2]=ea(2.0);g[k+4>>2]=ea(17.9049301);g[k+8>>2]=ea(1.0e3);g[k+12>>2]=ea(5.72957754);c[k+40>>2]=0;g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(1.0);g[k+24>>2]=ea(.100000001);g[k+28>>2]=ea(1.0);g[k+32>>2]=ea(1.0);g[k+36>>2]=ea(1.0);g[k+44>>2]=ea(.00100000005);g[k+48>>2]=ea(10.0);g[k+52>>2]=ea(1.11111116);qMb(j,e,k);if(e){k=d+4|0;t=b+4|0;u=b+12|0;v=b+16|0;w=h+4|0;x=h+8|0;y=h+12|0;z=h+16|0;A=h+20|0;B=h+24|0;C=0;do{D=l+0|0;E=D+32|0;do{a[D>>0]=0;D=D+1|0}while((D|0)<(E|0));c[d>>2]=C;TUa(l,0,515856,d)|0;D=c[b>>2]|0;E=c[D+8>>2]|0;if(E){F=E+-1|0;G=c[D+4>>2]|0;if(!(a[G+(F<<3)+4>>0]|0)){H=c[t>>2]|0;In[c[(c[H>>2]|0)+16>>2]&4095](H,c[G+(F<<3)>>2]|0);F=c[b>>2]|0;a[(c[F+4>>2]|0)+((c[F+8>>2]|0)+-1<<3)+4>>0]=1;F=c[b>>2]|0;I=F;J=c[F+8>>2]|0}else{I=D;J=E}}else{I=D;J=0}c[d>>2]=l;a[k>>0]=0;D=I+8|0;if((c[I+12>>2]&2147483647)>>>0>J>>>0){E=(c[I+4>>2]|0)+(J<<3)|0;if(!E)K=J;else{F=d;G=c[F+4>>2]|0;H=E;c[H>>2]=c[F>>2];c[H+4>>2]=G;K=c[D>>2]|0}c[D>>2]=K+1}else OAb(I,d)|0;co[c[(c[p>>2]|0)+12>>2]&2047](m,c[o>>2]|0,C);PEi(n|0,0,140)|0;TFa(n);D=c[b>>2]|0;G=c[t>>2]|0;H=c[u>>2]|0;F=c[v>>2]|0;TFa(d);c[h>>2]=D;c[w>>2]=G;c[x>>2]=m;c[y>>2]=H;c[z>>2]=F;c[A>>2]=0;c[B>>2]=0;rMb(d,h,0)|0;F=c[b>>2]|0;H=c[F+8>>2]|0;if(H){if(!(a[(c[F+4>>2]|0)+(H+-1<<3)+4>>0]|0)){L=F;M=H}else{H=c[t>>2]|0;ko[c[(c[H>>2]|0)+20>>2]&4095](H);H=c[b>>2]|0;L=H;M=c[H+8>>2]|0}c[L+8>>2]=M+-1}C=C+1|0}while((C|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((j|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function $Jb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+160|0;d=f;h=f+108|0;j=f+32|0;k=f+120|0;l=f+8|0;m=b+8|0;n=e+12|0;e=mo[c[(c[n>>2]|0)+20>>2]&4095](c[m>>2]|0)|0;o=j+60|0;p=j+64|0;c[j+68>>2]=0;q=j+72|0;a[o>>0]=1;c[p>>2]=j;c[q>>2]=5;sMb(j,e,f+20|0);if(e){r=d+4|0;s=b+4|0;t=b+12|0;u=h+4|0;v=l+4|0;w=h+8|0;x=l+8|0;y=0;do{z=k+0|0;A=z+32|0;do{a[z>>0]=0;z=z+1|0}while((z|0)<(A|0));c[d>>2]=y;TUa(k,0,515856,d)|0;z=c[b>>2]|0;A=c[z+8>>2]|0;if(A){B=A+-1|0;C=c[z+4>>2]|0;if(!(a[C+(B<<3)+4>>0]|0)){D=c[s>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[C+(B<<3)>>2]|0);B=c[b>>2]|0;a[(c[B+4>>2]|0)+((c[B+8>>2]|0)+-1<<3)+4>>0]=1;B=c[b>>2]|0;E=B;F=c[B+8>>2]|0}else{E=z;F=A}}else{E=z;F=0}c[d>>2]=k;a[r>>0]=0;z=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){A=(c[E+4>>2]|0)+(F<<3)|0;if(!A)G=F;else{B=d;C=c[B+4>>2]|0;D=A;c[D>>2]=c[B>>2];c[D+4>>2]=C;G=c[z>>2]|0}c[z>>2]=G+1}else OAb(E,d)|0;co[c[(c[n>>2]|0)+12>>2]&2047](l,c[m>>2]|0,y);z=c[s>>2]|0;C=c[t>>2]|0;D=c[b>>2]|0;B=c[D+8>>2]|0;if(!B)H=515864;else H=c[(c[D+4>>2]|0)+(B+-1<<3)>>2]|0;g[h>>2]=ea(g[l>>2]);g[u>>2]=ea(g[v>>2]);g[w>>2]=ea(g[x>>2]);ZUa(C,h)|0;a[d>>0]=0;xo[c[c[C>>2]>>2]&2047](C,d,1)|0;co[c[(c[z>>2]|0)+8>>2]&2047](z,H,c[C+20>>2]|0);c[C+16>>2]=0;c[C+12>>2]=0;C=c[b>>2]|0;z=c[C+8>>2]|0;if(z){if(!(a[(c[C+4>>2]|0)+(z+-1<<3)+4>>0]|0)){I=C;J=z}else{z=c[s>>2]|0;ko[c[(c[z>>2]|0)+20>>2]&4095](z);z=c[b>>2]|0;I=z;J=c[z+8>>2]|0}c[I+8>>2]=J+-1}y=y+1|0}while((y|0)!=(e|0))}e=c[q>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[p>>2]|0;if((j|0)==(e|0)){a[o>>0]=0;i=f;return}if(!e){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,e);i=f;return}function aKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+160|0;d=f;h=f+108|0;j=f+32|0;k=f+120|0;l=f+8|0;m=b+8|0;n=e+12|0;e=mo[c[(c[n>>2]|0)+20>>2]&4095](c[m>>2]|0)|0;o=j+60|0;p=j+64|0;c[j+68>>2]=0;q=j+72|0;a[o>>0]=1;c[p>>2]=j;c[q>>2]=5;sMb(j,e,f+20|0);if(e){r=d+4|0;s=b+4|0;t=b+12|0;u=h+4|0;v=l+4|0;w=h+8|0;x=l+8|0;y=0;do{z=k+0|0;A=z+32|0;do{a[z>>0]=0;z=z+1|0}while((z|0)<(A|0));c[d>>2]=y;TUa(k,0,515856,d)|0;z=c[b>>2]|0;A=c[z+8>>2]|0;if(A){B=A+-1|0;C=c[z+4>>2]|0;if(!(a[C+(B<<3)+4>>0]|0)){D=c[s>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[C+(B<<3)>>2]|0);B=c[b>>2]|0;a[(c[B+4>>2]|0)+((c[B+8>>2]|0)+-1<<3)+4>>0]=1;B=c[b>>2]|0;E=B;F=c[B+8>>2]|0}else{E=z;F=A}}else{E=z;F=0}c[d>>2]=k;a[r>>0]=0;z=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){A=(c[E+4>>2]|0)+(F<<3)|0;if(!A)G=F;else{B=d;C=c[B+4>>2]|0;D=A;c[D>>2]=c[B>>2];c[D+4>>2]=C;G=c[z>>2]|0}c[z>>2]=G+1}else OAb(E,d)|0;co[c[(c[n>>2]|0)+12>>2]&2047](l,c[m>>2]|0,y);z=c[s>>2]|0;C=c[t>>2]|0;D=c[b>>2]|0;B=c[D+8>>2]|0;if(!B)H=515864;else H=c[(c[D+4>>2]|0)+(B+-1<<3)>>2]|0;g[h>>2]=ea(g[l>>2]);g[u>>2]=ea(g[v>>2]);g[w>>2]=ea(g[x>>2]);ZUa(C,h)|0;a[d>>0]=0;xo[c[c[C>>2]>>2]&2047](C,d,1)|0;co[c[(c[z>>2]|0)+8>>2]&2047](z,H,c[C+20>>2]|0);c[C+16>>2]=0;c[C+12>>2]=0;C=c[b>>2]|0;z=c[C+8>>2]|0;if(z){if(!(a[(c[C+4>>2]|0)+(z+-1<<3)+4>>0]|0)){I=C;J=z}else{z=c[s>>2]|0;ko[c[(c[z>>2]|0)+20>>2]&4095](z);z=c[b>>2]|0;I=z;J=c[z+8>>2]|0}c[I+8>>2]=J+-1}y=y+1|0}while((y|0)!=(e|0))}e=c[q>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[p>>2]|0;if((j|0)==(e|0)){a[o>>0]=0;i=f;return}if(!e){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,e);i=f;return}function bKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+160|0;d=f;h=f+108|0;j=f+32|0;k=f+120|0;l=f+8|0;m=b+8|0;n=e+12|0;e=mo[c[(c[n>>2]|0)+20>>2]&4095](c[m>>2]|0)|0;o=j+60|0;p=j+64|0;c[j+68>>2]=0;q=j+72|0;a[o>>0]=1;c[p>>2]=j;c[q>>2]=5;sMb(j,e,f+20|0);if(e){r=d+4|0;s=b+4|0;t=b+12|0;u=h+4|0;v=l+4|0;w=h+8|0;x=l+8|0;y=0;do{z=k+0|0;A=z+32|0;do{a[z>>0]=0;z=z+1|0}while((z|0)<(A|0));c[d>>2]=y;TUa(k,0,515856,d)|0;z=c[b>>2]|0;A=c[z+8>>2]|0;if(A){B=A+-1|0;C=c[z+4>>2]|0;if(!(a[C+(B<<3)+4>>0]|0)){D=c[s>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[C+(B<<3)>>2]|0);B=c[b>>2]|0;a[(c[B+4>>2]|0)+((c[B+8>>2]|0)+-1<<3)+4>>0]=1;B=c[b>>2]|0;E=B;F=c[B+8>>2]|0}else{E=z;F=A}}else{E=z;F=0}c[d>>2]=k;a[r>>0]=0;z=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){A=(c[E+4>>2]|0)+(F<<3)|0;if(!A)G=F;else{B=d;C=c[B+4>>2]|0;D=A;c[D>>2]=c[B>>2];c[D+4>>2]=C;G=c[z>>2]|0}c[z>>2]=G+1}else OAb(E,d)|0;co[c[(c[n>>2]|0)+12>>2]&2047](l,c[m>>2]|0,y);z=c[s>>2]|0;C=c[t>>2]|0;D=c[b>>2]|0;B=c[D+8>>2]|0;if(!B)H=515864;else H=c[(c[D+4>>2]|0)+(B+-1<<3)>>2]|0;g[h>>2]=ea(g[l>>2]);g[u>>2]=ea(g[v>>2]);g[w>>2]=ea(g[x>>2]);ZUa(C,h)|0;a[d>>0]=0;xo[c[c[C>>2]>>2]&2047](C,d,1)|0;co[c[(c[z>>2]|0)+8>>2]&2047](z,H,c[C+20>>2]|0);c[C+16>>2]=0;c[C+12>>2]=0;C=c[b>>2]|0;z=c[C+8>>2]|0;if(z){if(!(a[(c[C+4>>2]|0)+(z+-1<<3)+4>>0]|0)){I=C;J=z}else{z=c[s>>2]|0;ko[c[(c[z>>2]|0)+20>>2]&4095](z);z=c[b>>2]|0;I=z;J=c[z+8>>2]|0}c[I+8>>2]=J+-1}y=y+1|0}while((y|0)!=(e|0))}e=c[q>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[p>>2]|0;if((j|0)==(e|0)){a[o>>0]=0;i=f;return}if(!e){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,e);i=f;return}function cKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+160|0;d=f;h=f+108|0;j=f+32|0;k=f+120|0;l=f+8|0;m=b+8|0;n=e+12|0;e=mo[c[(c[n>>2]|0)+20>>2]&4095](c[m>>2]|0)|0;o=j+60|0;p=j+64|0;c[j+68>>2]=0;q=j+72|0;a[o>>0]=1;c[p>>2]=j;c[q>>2]=5;sMb(j,e,f+20|0);if(e){r=d+4|0;s=b+4|0;t=b+12|0;u=h+4|0;v=l+4|0;w=h+8|0;x=l+8|0;y=0;do{z=k+0|0;A=z+32|0;do{a[z>>0]=0;z=z+1|0}while((z|0)<(A|0));c[d>>2]=y;TUa(k,0,515856,d)|0;z=c[b>>2]|0;A=c[z+8>>2]|0;if(A){B=A+-1|0;C=c[z+4>>2]|0;if(!(a[C+(B<<3)+4>>0]|0)){D=c[s>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[C+(B<<3)>>2]|0);B=c[b>>2]|0;a[(c[B+4>>2]|0)+((c[B+8>>2]|0)+-1<<3)+4>>0]=1;B=c[b>>2]|0;E=B;F=c[B+8>>2]|0}else{E=z;F=A}}else{E=z;F=0}c[d>>2]=k;a[r>>0]=0;z=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){A=(c[E+4>>2]|0)+(F<<3)|0;if(!A)G=F;else{B=d;C=c[B+4>>2]|0;D=A;c[D>>2]=c[B>>2];c[D+4>>2]=C;G=c[z>>2]|0}c[z>>2]=G+1}else OAb(E,d)|0;co[c[(c[n>>2]|0)+12>>2]&2047](l,c[m>>2]|0,y);z=c[s>>2]|0;C=c[t>>2]|0;D=c[b>>2]|0;B=c[D+8>>2]|0;if(!B)H=515864;else H=c[(c[D+4>>2]|0)+(B+-1<<3)>>2]|0;g[h>>2]=ea(g[l>>2]);g[u>>2]=ea(g[v>>2]);g[w>>2]=ea(g[x>>2]);ZUa(C,h)|0;a[d>>0]=0;xo[c[c[C>>2]>>2]&2047](C,d,1)|0;co[c[(c[z>>2]|0)+8>>2]&2047](z,H,c[C+20>>2]|0);c[C+16>>2]=0;c[C+12>>2]=0;C=c[b>>2]|0;z=c[C+8>>2]|0;if(z){if(!(a[(c[C+4>>2]|0)+(z+-1<<3)+4>>0]|0)){I=C;J=z}else{z=c[s>>2]|0;ko[c[(c[z>>2]|0)+20>>2]&4095](z);z=c[b>>2]|0;I=z;J=c[z+8>>2]|0}c[I+8>>2]=J+-1}y=y+1|0}while((y|0)!=(e|0))}e=c[q>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[p>>2]|0;if((j|0)==(e|0)){a[o>>0]=0;i=f;return}if(!e){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,e);i=f;return}function dKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+208|0;d=f;g=f+80|0;h=f+12|0;j=f+8|0;k=f+48|0;l=b+8|0;m=e+12|0;e=mo[c[(c[m>>2]|0)+20>>2]&4095](c[l>>2]|0)|0;n=h+20|0;o=h+24|0;c[h+28>>2]=0;p=h+32|0;a[n>>0]=1;c[o>>2]=h;c[p>>2]=5;c[j>>2]=0;tMb(h,e,j);if(e){j=d+4|0;q=b+4|0;r=b+12|0;s=0;do{t=k+0|0;u=t+32|0;do{a[t>>0]=0;t=t+1|0}while((t|0)<(u|0));c[d>>2]=s;TUa(k,0,515856,d)|0;v=c[b>>2]|0;w=c[v+8>>2]|0;if(w){x=w+-1|0;y=c[v+4>>2]|0;if(!(a[y+(x<<3)+4>>0]|0)){z=c[q>>2]|0;In[c[(c[z>>2]|0)+16>>2]&4095](z,c[y+(x<<3)>>2]|0);x=c[b>>2]|0;a[(c[x+4>>2]|0)+((c[x+8>>2]|0)+-1<<3)+4>>0]=1;x=c[b>>2]|0;A=x;B=c[x+8>>2]|0}else{A=v;B=w}}else{A=v;B=0}c[d>>2]=k;a[j>>0]=0;v=A+8|0;if((c[A+12>>2]&2147483647)>>>0>B>>>0){w=(c[A+4>>2]|0)+(B<<3)|0;if(!w)C=B;else{x=d;y=c[x+4>>2]|0;z=w;c[z>>2]=c[x>>2];c[z+4>>2]=y;C=c[v>>2]|0}c[v>>2]=C+1}else OAb(A,d)|0;v=_n[c[(c[m>>2]|0)+12>>2]&4095](c[l>>2]|0,s)|0;y=c[q>>2]|0;z=c[r>>2]|0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(!w)D=515864;else D=c[(c[x+4>>2]|0)+(w+-1<<3)>>2]|0;t=g+0|0;u=t+128|0;do{a[t>>0]=0;t=t+1|0}while((t|0)<(u|0));c[d>>2]=v;TUa(g,0,516008,d)|0;if(a[g>>0]|0){t=c[c[z>>2]>>2]|0;u=SEi(g|0)|0;xo[t&2047](z,g,u)|0}a[d>>0]=0;xo[c[c[z>>2]>>2]&2047](z,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,D,c[z+20>>2]|0);c[z+16>>2]=0;c[z+12>>2]=0;u=c[b>>2]|0;t=c[u+8>>2]|0;if(t){if(!(a[(c[u+4>>2]|0)+(t+-1<<3)+4>>0]|0)){E=u;F=t}else{t=c[q>>2]|0;ko[c[(c[t>>2]|0)+20>>2]&4095](t);t=c[b>>2]|0;E=t;F=c[t+8>>2]|0}c[E+8>>2]=F+-1}s=s+1|0}while((s|0)!=(e|0))}e=c[p>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[o>>2]|0;if((h|0)==(e|0)){a[n>>0]=0;i=f;return}if(!e){i=f;return}n=mKa()|0;In[c[(c[n>>2]|0)+12>>2]&4095](n,e);i=f;return}function eKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+192|0;d=f+16|0;g=f;h=f+56|0;j=f+40|0;k=f+152|0;l=f+24|0;m=b+8|0;n=e+12|0;e=mo[c[(c[n>>2]|0)+20>>2]&4095](c[m>>2]|0)|0;o=h+80|0;p=h+84|0;c[h+88>>2]=0;q=h+92|0;a[o>>0]=1;c[p>>2]=h;c[q>>2]=5;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;uMb(h,e,j);if(e){j=d+4|0;r=b+4|0;s=b+12|0;t=0;do{u=k+0|0;v=u+32|0;do{a[u>>0]=0;u=u+1|0}while((u|0)<(v|0));c[d>>2]=t;TUa(k,0,515856,d)|0;u=c[b>>2]|0;v=c[u+8>>2]|0;if(v){w=v+-1|0;x=c[u+4>>2]|0;if(!(a[x+(w<<3)+4>>0]|0)){y=c[r>>2]|0;In[c[(c[y>>2]|0)+16>>2]&4095](y,c[x+(w<<3)>>2]|0);w=c[b>>2]|0;a[(c[w+4>>2]|0)+((c[w+8>>2]|0)+-1<<3)+4>>0]=1;w=c[b>>2]|0;z=w;A=c[w+8>>2]|0}else{z=u;A=v}}else{z=u;A=0}c[d>>2]=k;a[j>>0]=0;u=z+8|0;if((c[z+12>>2]&2147483647)>>>0>A>>>0){v=(c[z+4>>2]|0)+(A<<3)|0;if(!v)B=A;else{w=d;x=c[w+4>>2]|0;y=v;c[y>>2]=c[w>>2];c[y+4>>2]=x;B=c[u>>2]|0}c[u>>2]=B+1}else OAb(z,d)|0;co[c[(c[n>>2]|0)+12>>2]&2047](l,c[m>>2]|0,t);u=c[r>>2]|0;x=c[s>>2]|0;y=c[b>>2]|0;w=c[y+8>>2]|0;if(!w)C=515864;else C=c[(c[y+4>>2]|0)+(w+-1<<3)>>2]|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];bHb(x,g)|0;a[d>>0]=0;xo[c[c[x>>2]>>2]&2047](x,d,1)|0;co[c[(c[u>>2]|0)+8>>2]&2047](u,C,c[x+20>>2]|0);c[x+16>>2]=0;c[x+12>>2]=0;x=c[b>>2]|0;u=c[x+8>>2]|0;if(u){if(!(a[(c[x+4>>2]|0)+(u+-1<<3)+4>>0]|0)){D=x;E=u}else{u=c[r>>2]|0;ko[c[(c[u>>2]|0)+20>>2]&4095](u);u=c[b>>2]|0;D=u;E=c[u+8>>2]|0}c[D+8>>2]=E+-1}t=t+1|0}while((t|0)!=(e|0))}e=c[q>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[p>>2]|0;if((h|0)==(e|0)){a[o>>0]=0;i=f;return}if(!e){i=f;return}o=mKa()|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,e);i=f;return}function fKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+224|0;f=e+140|0;g=e+112|0;h=e+80|0;j=e;k=c[b+24>>2]|0;if(!k)l=0;else l=c[k>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+76|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));IFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;IFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;vMb(f,g,0)|0;i=e;return}function gKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function hKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function iKb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(!d)f=0;else{h=d<<2;j=b+20|0;if(!((a[j>>0]|0)==0&h>>>0<21))if(!h)k=0;else{l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;k=Bn[m&255](l,h,o?526520:544544,537640,558)|0}else{a[j>>0]=1;k=b}f=k}k=c[b+28>>2]|0;j=f+(k<<2)|0;o=b+24|0;if((k|0)>0){k=f;h=c[o>>2]|0;while(1){if(k)g[k>>2]=ea(g[h>>2]);k=k+4|0;if(k>>>0>=j>>>0)break;else h=h+4|0}}h=b+32|0;if((c[h>>2]|0)<=-1){c[o>>2]=f;c[h>>2]=d;i=e;return}j=c[o>>2]|0;if((b|0)==(j|0)){a[b+20>>0]=0;c[o>>2]=f;c[h>>2]=d;i=e;return}if(!j){c[o>>2]=f;c[h>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,j);c[o>>2]=f;c[h>>2]=d;i=e;return}function jKb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=(d+b|0)/2|0;h=a+(g<<5)|0;j=a+(b<<5)|0;k=a+(g<<5)+16|0;g=a+(b<<5)+16|0;l=c[(c[g>>2]|0)+56>>2]|0;if((c[(c[k>>2]|0)+56>>2]|0)>>>0>l>>>0){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];c[j+16>>2]=c[h+16>>2];c[j+20>>2]=c[h+20>>2];c[j+24>>2]=c[h+24>>2];c[j+28>>2]=c[h+28>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];c[h+20>>2]=c[f+20>>2];c[h+24>>2]=c[f+24>>2];c[h+28>>2]=c[f+28>>2];m=c[(c[g>>2]|0)+56>>2]|0}else m=l;l=a+(d<<5)|0;g=a+(d<<5)+16|0;n=c[(c[g>>2]|0)+56>>2]|0;if(n>>>0>m>>>0){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[j+16>>2]=c[l+16>>2];c[j+20>>2]=c[l+20>>2];c[j+24>>2]=c[l+24>>2];c[j+28>>2]=c[l+28>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[l+16>>2]=c[f+16>>2];c[l+20>>2]=c[f+20>>2];c[l+24>>2]=c[f+24>>2];c[l+28>>2]=c[f+28>>2];o=c[(c[g>>2]|0)+56>>2]|0}else o=n;if(o>>>0>(c[(c[k>>2]|0)+56>>2]|0)>>>0){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];c[f+24>>2]=c[h+24>>2];c[f+28>>2]=c[h+28>>2];c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[h+16>>2]=c[l+16>>2];c[h+20>>2]=c[l+20>>2];c[h+24>>2]=c[l+24>>2];c[h+28>>2]=c[l+28>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[l+16>>2]=c[f+16>>2];c[l+20>>2]=c[f+20>>2];c[l+24>>2]=c[f+24>>2];c[l+28>>2]=c[f+28>>2];p=h}else p=h;h=d+-1|0;d=a+(h<<5)|0;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];c[p+0>>2]=c[d+0>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];c[p+16>>2]=c[d+16>>2];c[p+20>>2]=c[d+20>>2];c[p+24>>2]=c[d+24>>2];c[p+28>>2]=c[d+28>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];p=a+(h<<5)+16|0;l=b;b=h;while(1){h=c[(c[p>>2]|0)+56>>2]|0;q=l;do{q=q+1|0;r=a+(q<<5)|0}while((c[(c[a+(q<<5)+16>>2]|0)+56>>2]|0)>>>0>h>>>0);s=b;do{s=s+-1|0;t=a+(s<<5)|0}while(h>>>0>(c[(c[a+(s<<5)+16>>2]|0)+56>>2]|0)>>>0);if((q|0)>=(s|0))break;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];c[r+24>>2]=c[t+24>>2];c[r+28>>2]=c[t+28>>2];c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];c[t+16>>2]=c[f+16>>2];c[t+20>>2]=c[f+20>>2];c[t+24>>2]=c[f+24>>2];c[t+28>>2]=c[f+28>>2];l=q;b=s}c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];c[r+0>>2]=c[d+0>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];c[r+16>>2]=c[d+16>>2];c[r+20>>2]=c[d+20>>2];c[r+24>>2]=c[d+24>>2];c[r+28>>2]=c[d+28>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];i=e;return q|0}function kKb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;if((b|0)!=0?(e=b<<5,(e|0)!=0):0){f=mKa()|0;g=c[(c[f>>2]|0)+8>>2]|0;h=pKa()|0;j=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;k=Bn[g&255](f,e,j?491552:544544,537640,558)|0}else k=0;j=c[a+4>>2]|0;e=k+(j<<5)|0;if((j|0)>0){j=k;f=c[a>>2]|0;while(1){if(j){c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2];c[j+28>>2]=c[f+28>>2]}j=j+32|0;if(j>>>0>=e>>>0)break;else f=f+32|0}}f=a+8|0;if((c[f>>2]|0)<=-1){c[a>>2]=k;c[f>>2]=b;i=d;return}e=c[a>>2]|0;if(!e){c[a>>2]=k;c[f>>2]=b;i=d;return}j=mKa()|0;In[c[(c[j>>2]|0)+12>>2]&4095](j,e);c[a>>2]=k;c[f>>2]=b;i=d;return}function lKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=Im,A=0,B=Im,C=0,D=0,E=0,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;f=i;i=i+144|0;e=f;h=e;c[h>>2]=0;c[h+4>>2]=0;h=e+4|0;a[h>>0]=0;j=f+8|0;c[e>>2]=j;k=d+-1|0;if((k|0)>0){d=0;l=j;j=32;m=0;n=0;o=k;a:while(1){k=n;p=m;q=o;while(1){if((q|0)>(k|0)){if((q-k|0)>>>0<5)r=k;else break;do{s=r;r=r+1|0;t=r;u=s;while(1){v=ea(g[(c[b+(t<<2)>>2]|0)+16>>2]);w=v<ea(g[(c[b+(u<<2)>>2]|0)+16>>2]);u=w?t:u;if((t|0)>=(q|0))break;else t=t+1|0}t=b+(u<<2)|0;w=b+(s<<2)|0;x=c[t>>2]|0;c[t>>2]=c[w>>2];c[w>>2]=x}while((r|0)!=(q|0))}if(!p)break a;x=c[l+(p+-1<<2)>>2]|0;w=p+-2|0;k=c[l+(w<<2)>>2]|0;p=w;q=x}x=b+(((q+k|0)/2|0)<<2)|0;w=c[x>>2]|0;t=b+(k<<2)|0;y=c[t>>2]|0;v=ea(g[w+16>>2]);z=ea(g[y+16>>2]);if(v<z){c[t>>2]=w;c[x>>2]=y;A=c[t>>2]|0;B=ea(g[A+16>>2]);C=y;D=A}else{B=z;C=w;D=y}y=b+(q<<2)|0;w=c[y>>2]|0;z=ea(g[w+16>>2]);if(z<B){c[t>>2]=w;c[y>>2]=D;E=c[x>>2]|0;F=B;G=D}else{E=C;F=z;G=w}if(F<ea(g[E+16>>2])){c[x>>2]=G;c[y>>2]=E;H=c[x>>2]|0}else H=E;y=q+-1|0;w=b+(y<<2)|0;c[x>>2]=c[w>>2];c[w>>2]=H;x=H;t=k;A=y;while(1){z=ea(g[x+16>>2]);I=t;while(1){J=I+1|0;K=b+(J<<2)|0;L=c[K>>2]|0;if(ea(g[L+16>>2])<z)I=J;else{M=A;break}}do{M=M+-1|0;N=b+(M<<2)|0;O=c[N>>2]|0}while(z<ea(g[O+16>>2]));if((J|0)>=(M|0))break;c[K>>2]=O;c[N>>2]=L;x=c[w>>2]|0;t=J;A=M}c[K>>2]=x;c[w>>2]=L;if((J-k|0)<(q-J|0)){if(p>>>0>=(j+-1|0)>>>0){A=j<<1;t=j<<3;if(!t)P=0;else{y=mKa()|0;Q=c[(c[y>>2]|0)+8>>2]|0;R=pKa()|0;S=mo[c[(c[R>>2]|0)+24>>2]&4095](R)|0;P=Bn[Q&255](y,t,S?491384:544544,523928,148)|0}YEi(P|0,l|0,p<<2|0)|0;if(d<<24>>24==0|(l|0)==0){T=P;U=1;V=A}else{S=mKa()|0;In[c[(c[S>>2]|0)+12>>2]&4095](S,l);T=P;U=1;V=A}}else{T=l;U=d;V=j}c[T+(p<<2)>>2]=k;c[T+(p+1<<2)>>2]=I;W=U;X=T;Y=V;Z=I+2|0;_=q}else{A=I+2|0;if(p>>>0>=(j+-1|0)>>>0){S=j<<1;t=j<<3;if(!t)$=0;else{y=mKa()|0;Q=c[(c[y>>2]|0)+8>>2]|0;R=pKa()|0;aa=mo[c[(c[R>>2]|0)+24>>2]&4095](R)|0;$=Bn[Q&255](y,t,aa?491384:544544,523928,148)|0}YEi($|0,l|0,p<<2|0)|0;if(d<<24>>24==0|(l|0)==0){ba=$;ca=1;da=S}else{aa=mKa()|0;In[c[(c[aa>>2]|0)+12>>2]&4095](aa,l);ba=$;ca=1;da=S}}else{ba=l;ca=d;da=j}c[ba+(p<<2)>>2]=A;c[ba+(p+1<<2)>>2]=q;W=ca;X=ba;Y=da;Z=k;_=I}d=W;l=X;j=Y;m=p+2|0;n=Z;o=_}if(!(d<<24>>24==0|(l|0)==0)){d=mKa()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,l)}}if(!(a[h>>0]|0)){i=f;return}tKa(e,c[e>>2]|0);i=f;return}function mKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=b+8|0;h=c[d>>2]|0;j=h+12|0;k=c[j>>2]|0;l=h+8|0;m=c[l>>2]|0;n=m;o=k-n|0;p=o+4|0;q=h+16|0;if(((c[q>>2]|0)-n|0)>>>0>p>>>0)r=k;else{k=p<<1;if(!k){s=0;t=m}else{m=c[c[h>>2]>>2]|0;p=Bn[c[(c[m>>2]|0)+8>>2]&255](m,k,c[h+4>>2]|0,527352,117)|0;s=p;t=c[l>>2]|0}if((t|0)!=0?(YEi(s|0,t|0,o|0)|0,t=c[l>>2]|0,(t|0)!=0):0){p=c[c[h>>2]>>2]|0;In[c[(c[p>>2]|0)+12>>2]&4095](p,t)}c[l>>2]=s;l=s+o|0;c[j>>2]=l;c[q>>2]=s+k;r=l}a[r>>0]=a[g>>0]|0;a[r+1>>0]=a[g+1>>0]|0;a[r+2>>0]=a[g+2>>0]|0;a[r+3>>0]=a[g+3>>0]|0;c[j>>2]=(c[j>>2]|0)+4;HIb(d,0,b,e);e=c[d>>2]|0;j=a[b+12>>0]|0;g=e+12|0;r=c[g>>2]|0;l=e+8|0;k=c[l>>2]|0;s=k;q=r-s|0;o=q+1|0;t=e+16|0;if(((c[t>>2]|0)-s|0)>>>0>o>>>0)u=r;else{r=o<<1;if(!r){v=0;w=k}else{k=c[c[e>>2]>>2]|0;o=Bn[c[(c[k>>2]|0)+8>>2]&255](k,r,c[e+4>>2]|0,527352,117)|0;v=o;w=c[l>>2]|0}if((w|0)!=0?(YEi(v|0,w|0,q|0)|0,w=c[l>>2]|0,(w|0)!=0):0){o=c[c[e>>2]>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,w)}c[l>>2]=v;l=v+q|0;c[g>>2]=l;c[t>>2]=v+r;u=l}a[u>>0]=j;c[g>>2]=(c[g>>2]|0)+1;g=c[d>>2]|0;d=a[b+13>>0]|0;b=g+12|0;j=c[b>>2]|0;u=g+8|0;l=c[u>>2]|0;r=l;v=j-r|0;t=v+1|0;q=g+16|0;if(((c[q>>2]|0)-r|0)>>>0>t>>>0){x=j;a[x>>0]=d;y=c[b>>2]|0;z=y+1|0;c[b>>2]=z;i=f;return}j=t<<1;if(!j){A=0;B=l}else{l=c[c[g>>2]>>2]|0;t=Bn[c[(c[l>>2]|0)+8>>2]&255](l,j,c[g+4>>2]|0,527352,117)|0;A=t;B=c[u>>2]|0}if((B|0)!=0?(YEi(A|0,B|0,v|0)|0,B=c[u>>2]|0,(B|0)!=0):0){t=c[c[g>>2]>>2]|0;In[c[(c[t>>2]|0)+12>>2]&4095](t,B)}c[u>>2]=A;u=A+v|0;c[b>>2]=u;c[q>>2]=A+j;x=u;a[x>>0]=d;y=c[b>>2]|0;z=y+1|0;c[b>>2]=z;i=f;return}function nKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+12|0;g=c[f>>2]|0;h=b+8|0;j=c[h>>2]|0;k=j;l=g-k|0;m=l+8|0;n=b+16|0;if(((c[n>>2]|0)-k|0)>>>0>m>>>0)o=g;else{g=m<<1;if(!g){p=0;q=j}else{j=c[c[b>>2]>>2]|0;m=Bn[c[(c[j>>2]|0)+8>>2]&255](j,g,c[b+4>>2]|0,527352,117)|0;p=m;q=c[h>>2]|0}if((q|0)!=0?(YEi(p|0,q|0,l|0)|0,q=c[h>>2]|0,(q|0)!=0):0){m=c[c[b>>2]>>2]|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,q)}c[h>>2]=p;h=p+l|0;c[f>>2]=h;c[n>>2]=p+g;o=h}a[o>>0]=a[d>>0]|0;a[o+1>>0]=a[d+1>>0]|0;a[o+2>>0]=a[d+2>>0]|0;a[o+3>>0]=a[d+3>>0]|0;a[o+4>>0]=a[d+4>>0]|0;a[o+5>>0]=a[d+5>>0]|0;a[o+6>>0]=a[d+6>>0]|0;a[o+7>>0]=a[d+7>>0]|0;c[f>>2]=(c[f>>2]|0)+8;i=e;return}function oKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function pKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function qKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function rKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function sKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function tKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function uKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function vKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;wMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(xMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function wKb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+4|0;f=c[e>>2]|0;g=c[f+8>>2]|0;if(!g){i=d;return}h=c[(c[f+4>>2]|0)+(g+-1<<2)>>2]|0;j=c[b>>2]|0;k=c[j+8>>2]|0;if(k>>>0>h>>>0){l=b+36|0;m=b+20|0;n=k;k=j;do{if(!n){o=5;break}j=n+-1|0;p=c[k+4>>2]|0;if((a[p+(j<<3)+4>>0]|0)!=0?(a[p+(j<<3)+5>>0]|0)!=0:0){j=c[m>>2]|0;mo[c[(c[j>>2]|0)+40>>2]&4095](j)|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=k;r=n}c[q+8>>2]=r+-1;k=c[b>>2]|0;n=c[k+8>>2]|0;a[l>>0]=1;if(!n)break;if(!(a[(c[k+4>>2]|0)+(n+-1<<3)+5>>0]|0))a[l>>0]=0}while(n>>>0>h>>>0);if((o|0)==5)a[l>>0]=1;l=c[e>>2]|0;s=l;t=c[l+8>>2]|0}else{s=f;t=g}c[s+8>>2]=t+-1;i=d;return}function xKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function yKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function zKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function AKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function BKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function CKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function DKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function EKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function FKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;yMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(zMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function GKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;AMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(BMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function HKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;AMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(BMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function IKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;AMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(BMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function JKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;AMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(BMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function KKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];AMb(b,c[d>>2]|0);CMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function LKb(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+80|0;j=d;k=d+4|0;l=d+40|0;m=d+8|0;AMb(b,c[e>>2]|0);c[k>>2]=602;n=c[b+40>>2]|0;o=(n|0)==0?k:n;if(!f)p=c[b>>2]|0;else{n=(h|0)==0;k=b+36|0;q=b+20|0;r=b+24|0;s=e+8|0;e=0;do{t=l+0|0;u=t+32|0;do{a[t>>0]=0;t=t+1|0}while((t|0)<(u|0));c[j>>2]=e;TUa(l,0,516200,j)|0;AMb(b,l);if(!n){v=0;do{t=m+0|0;u=t+32|0;do{a[t>>0]=0;t=t+1|0}while((t|0)<(u|0));c[j>>2]=v;TUa(m,0,516208,j)|0;AMb(b,m);if(BMb(b,j)|0){w=ea(g[j>>2]);so[c[s>>2]&15](c[r>>2]|0,e,v,w)}x=c[b>>2]|0;y=c[x+8>>2]|0;if(y){z=y+-1|0;A=c[x+4>>2]|0;if((a[A+(z<<3)+4>>0]|0)!=0?(a[A+(z<<3)+5>>0]|0)!=0:0){z=c[q>>2]|0;mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;z=c[b>>2]|0;B=z;C=c[z+8>>2]|0}else{B=x;C=y}c[B+8>>2]=C+-1;y=c[b>>2]|0;x=c[y+8>>2]|0;a[k>>0]=1;if((x|0)!=0?(a[(c[y+4>>2]|0)+(x+-1<<3)+5>>0]|0)==0:0)a[k>>0]=0}else a[k>>0]=1;c[o>>2]=(c[o>>2]|0)+1;v=v+1|0}while((v|0)!=(h|0))}v=c[b>>2]|0;t=c[v+8>>2]|0;if(t){u=t+-1|0;x=c[v+4>>2]|0;if((a[x+(u<<3)+4>>0]|0)!=0?(a[x+(u<<3)+5>>0]|0)!=0:0){u=c[q>>2]|0;mo[c[(c[u>>2]|0)+40>>2]&4095](u)|0;u=c[b>>2]|0;D=u;E=c[u+8>>2]|0}else{D=v;E=t}c[D+8>>2]=E+-1;t=c[b>>2]|0;u=c[t+8>>2]|0;a[k>>0]=1;if((u|0)!=0?(a[(c[t+4>>2]|0)+(u+-1<<3)+5>>0]|0)==0:0){a[k>>0]=0;F=t}else F=t}else{a[k>>0]=1;F=v}e=e+1|0}while((e|0)!=(f|0));p=F}F=c[p+8>>2]|0;if(!F){a[b+36>>0]=1;i=d;return}f=F+-1|0;e=c[p+4>>2]|0;if((a[e+(f<<3)+4>>0]|0)!=0?(a[e+(f<<3)+5>>0]|0)!=0:0){f=c[b+20>>2]|0;mo[c[(c[f>>2]|0)+40>>2]&4095](f)|0;f=c[b>>2]|0;G=f;H=c[f+8>>2]|0}else{G=p;H=F}c[G+8>>2]=H+-1;H=c[b>>2]|0;G=c[H+8>>2]|0;F=b+36|0;a[F>>0]=1;if(!G){i=d;return}if(a[(c[H+4>>2]|0)+(G+-1<<3)+5>>0]|0){i=d;return}a[F>>0]=0;i=d;return}function MKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;DMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(EMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function NKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;DMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(EMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function OKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;DMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(EMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function PKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;DMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(EMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function QKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function RKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){FMb(b);i=f;return}QKb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){FMb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){FMb(b);i=f;return}}function SKb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function TKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function UKb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function VKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=132;else j=(c[h>>2]|0)+132|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function WKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function XKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im;e=i;i=i+272|0;f=e+8|0;g=e;h=c[b+44>>2]|0;if(!h)j=0;else j=c[h>>2]|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,f)|0;l=c[f>>2]|0;j=k?l:0;if(!j){i=e;return}k=a[j>>0]|0;if(!(k<<24>>24)){i=e;return}j=l;l=k;while(1){k=j+1|0;if(!(FDi(l&255)|0)){m=j;break}l=a[k>>0]|0;if(!(l<<24>>24)){m=k;break}else j=k}PEi(f|0,0,256)|0;c[g>>2]=f+255;j=a[m>>0]|0;a:do if(!(j<<24>>24))n=f;else{l=m;k=j;h=f;while(1){o=(FDi(k&255)|0)==0;if(!(o&h>>>0<(c[g>>2]|0)>>>0)){n=h;break a}o=h+1|0;a[h>>0]=a[l>>0]|0;l=l+1|0;k=a[l>>0]|0;if(!(k<<24>>24)){n=o;break}else h=o}}while(0);a[n>>0]=0;p=ea(+yEi(f,g));Fn[c[d+20>>2]&255](c[b+24>>2]|0,p);i=e;return}function YKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=4;else h=(c[g>>2]|0)+4|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}a:do if(!517336)l=0;else{f=517336;j=0;while(1){h=j+1|0;if(!(GEi(f,k)|0))break;f=c[517312+(h<<3)>>2]|0;if(!f){l=0;break a}else j=h}l=c[517316+(j<<3)>>2]|0}while(0);In[c[d+20>>2]&4095](c[b+24>>2]|0,l);i=e;return}function ZKb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=8;else j=(c[h>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function _Kb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function $Kb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function aLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function bLb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function cLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=24;else h=(c[g>>2]|0)+24|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}a:do if(!517488)l=0;else{f=517488;j=0;while(1){h=j+1|0;if(!(GEi(f,k)|0))break;f=c[517424+(h<<3)>>2]|0;if(!f){l=0;break a}else j=h}l=c[517428+(j<<3)>>2]|0}while(0);In[c[d+20>>2]&4095](c[b+24>>2]|0,l);i=e;return}function dLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function eLb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function fLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function gLb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){GMb(b);i=f;return}fLb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){GMb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){GMb(b);i=f;return}}function hLb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){GMb(b);i=f;return}fLb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){GMb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){GMb(b);i=f;return}}function iLb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;HMb(b,c[e>>2]|0);a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;IMb(b,0,h,f);f=c[b>>2]|0;h=c[f+8>>2]|0;if(!h){a[b+36>>0]=1;i=g;return}e=h+-1|0;d=c[f+4>>2]|0;if((a[d+(e<<3)+4>>0]|0)!=0?(a[d+(e<<3)+5>>0]|0)!=0:0){e=c[b+20>>2]|0;mo[c[(c[e>>2]|0)+40>>2]&4095](e)|0;e=c[b>>2]|0;j=e;k=c[e+8>>2]|0}else{j=f;k=h}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;h=b+36|0;a[h>>0]=1;if(!j){i=g;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=g;return}a[h>>0]=0;i=g;return}function jLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;c[f>>2]=0;d=b+36|0;if(a[d>>0]|0){h=c[b+20>>2]|0;j=c[b>>2]|0;k=c[j+8>>2]|0;if(!k)l=515864;else l=c[(c[j+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[h>>2]|0)+8>>2]&2047](h,l,f)|0;l=k?c[f>>2]|0:0;if((l|0)!=0?(a[l>>0]|0)!=0:0){f=(GEi(l,3655040)|0)==0;In[g&4095](c[b+24>>2]|0,f);m=b}else m=b}else m=b;f=c[m>>2]|0;g=c[f+8>>2]|0;if(!g){a[d>>0]=1;i=e;return}l=g+-1|0;k=c[f+4>>2]|0;if((a[k+(l<<3)+4>>0]|0)!=0?(a[k+(l<<3)+5>>0]|0)!=0:0){l=c[b+20>>2]|0;mo[c[(c[l>>2]|0)+40>>2]&4095](l)|0;l=c[m>>2]|0;n=l;o=c[l+8>>2]|0}else{n=f;o=g}c[n+8>>2]=o+-1;o=c[m>>2]|0;m=c[o+8>>2]|0;a[d>>0]=1;if(!m){i=e;return}if(a[(c[o+4>>2]|0)+(m+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function kLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);JMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function lLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);KMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function mLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);LMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function nLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);MMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function oLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(NMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function pLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);OMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function qLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(NMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function rLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(NMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function sLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);PMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function tLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);QMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function uLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);RMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function vLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);SMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function wLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];HMb(b,c[d>>2]|0);TMb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function xLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(NMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function yLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(NMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function zLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[d+12>>2]|0;HMb(b,c[d>>2]|0);d=c[b+40>>2]|0;if(d)c[d>>2]=(c[d>>2]|0)+1;if(NMb(b,f)|0){j=ea(g[f>>2]);Fn[h&255](c[b+24>>2]|0,j)}h=c[b>>2]|0;f=c[h+8>>2]|0;if(!f){a[b+36>>0]=1;i=e;return}d=f+-1|0;k=c[h+4>>2]|0;if((a[k+(d<<3)+4>>0]|0)!=0?(a[k+(d<<3)+5>>0]|0)!=0:0){d=c[b+20>>2]|0;mo[c[(c[d>>2]|0)+40>>2]&4095](d)|0;d=c[b>>2]|0;l=d;m=c[d+8>>2]|0}else{l=h;m=f}c[l+8>>2]=m+-1;m=c[b>>2]|0;l=c[m+8>>2]|0;f=b+36|0;a[f>>0]=1;if(!l){i=e;return}if(a[(c[m+4>>2]|0)+(l+-1<<3)+5>>0]|0){i=e;return}a[f>>0]=0;i=e;return}function ALb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function BLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+24>>2]|0;if(!g)h=0;else h=c[g>>2]|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+20>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;h=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;g=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)k=515864;else k=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;b=h?3655040:3655072;if(a[b>>0]|0){h=c[c[g>>2]>>2]|0;j=SEi(b|0)|0;xo[h&2047](g,b,j)|0}a[f>>0]=0;xo[c[c[g>>2]>>2]&2047](g,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,k,c[g+20>>2]|0);c[g+16>>2]=0;c[g+12>>2]=0;i=e;return}function CLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+24>>2]|0;if(!g)h=1;else h=(c[g>>2]|0)+1|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+20>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;h=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;g=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)k=515864;else k=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;b=h?3655040:3655072;if(a[b>>0]|0){h=c[c[g>>2]>>2]|0;j=SEi(b|0)|0;xo[h&2047](g,b,j)|0}a[f>>0]=0;xo[c[c[g>>2]>>2]&2047](g,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,k,c[g+20>>2]|0);c[g+16>>2]=0;c[g+12>>2]=0;i=e;return}function DLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+24>>2]|0;if(!g)h=2;else h=(c[g>>2]|0)+2|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+20>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;h=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;g=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)k=515864;else k=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;b=h?3655040:3655072;if(a[b>>0]|0){h=c[c[g>>2]>>2]|0;j=SEi(b|0)|0;xo[h&2047](g,b,j)|0}a[f>>0]=0;xo[c[c[g>>2]>>2]&2047](g,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,k,c[g+20>>2]|0);c[g+16>>2]=0;c[g+12>>2]=0;i=e;return}function ELb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=4;else j=(c[h>>2]|0)+4|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function FLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=8;else j=(c[h>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function GLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function HLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=16;else j=(c[h>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function ILb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=20;else l=(c[j>>2]|0)+20|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function JLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=24;else l=(c[j>>2]|0)+24|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function KLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+24>>2]|0;if(!g)h=28;else h=(c[g>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+20>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;h=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;g=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)k=515864;else k=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;b=h?3655040:3655072;if(a[b>>0]|0){h=c[c[g>>2]>>2]|0;j=SEi(b|0)|0;xo[h&2047](g,b,j)|0}a[f>>0]=0;xo[c[c[g>>2]>>2]&2047](g,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,k,c[g+20>>2]|0);c[g+16>>2]=0;c[g+12>>2]=0;i=e;return}function LLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+24>>2]|0;if(!g)h=29;else h=(c[g>>2]|0)+29|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+20>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;h=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;g=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)k=515864;else k=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;b=h?3655040:3655072;if(a[b>>0]|0){h=c[c[g>>2]>>2]|0;j=SEi(b|0)|0;xo[h&2047](g,b,j)|0}a[f>>0]=0;xo[c[c[g>>2]>>2]&2047](g,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,k,c[g+20>>2]|0);c[g+16>>2]=0;c[g+12>>2]=0;i=e;return}function MLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+24>>2]|0;if(!g)h=30;else h=(c[g>>2]|0)+30|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+20>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;h=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;g=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)k=515864;else k=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;b=h?3655040:3655072;if(a[b>>0]|0){h=c[c[g>>2]>>2]|0;j=SEi(b|0)|0;xo[h&2047](g,b,j)|0}a[f>>0]=0;xo[c[c[g>>2]>>2]&2047](g,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,k,c[g+20>>2]|0);c[g+16>>2]=0;c[g+12>>2]=0;i=e;return}function NLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=32;else j=(c[h>>2]|0)+32|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function OLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=36;else j=(c[h>>2]|0)+36|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function PLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=40;else l=(c[j>>2]|0)+40|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function QLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=44;else l=(c[j>>2]|0)+44|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function RLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=48;else l=(c[j>>2]|0)+48|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function SLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+24|0;k=e+2|0;l=c[j>>2]|0;m=c[d>>2]|0;n=c[m+8>>2]|0;if(n){o=n+-1|0;p=c[m+4>>2]|0;if(!(a[p+(o<<3)+4>>0]|0)){q=c[d+4>>2]|0;In[c[(c[q>>2]|0)+16>>2]&4095](q,c[p+(o<<3)>>2]|0);o=c[d>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=1;o=c[d>>2]|0;r=o;s=c[o+8>>2]|0}else{r=m;s=n}}else{r=m;s=0}c[g>>2]=l;a[g+4>>0]=0;l=r+8|0;if((c[r+12>>2]&2147483647)>>>0>s>>>0){m=(c[r+4>>2]|0)+(s<<3)|0;if(!m)t=s;else{s=g;n=c[s+4>>2]|0;o=m;c[o>>2]=c[s>>2];c[o+4>>2]=n;t=c[l>>2]|0}c[l>>2]=t+1}else OAb(r,g)|0;a[h>>0]=0;c[h+4>>2]=0;c[h+8>>2]=k;c[h+12>>2]=j;UMb(d,0,h,0);j=c[d>>2]|0;k=c[j+8>>2]|0;if(!k){u=0;v=j}else{if(!(a[(c[j+4>>2]|0)+(k+-1<<3)+4>>0]|0)){w=j;x=k}else{k=c[d+4>>2]|0;ko[c[(c[k>>2]|0)+20>>2]&4095](k);k=c[d>>2]|0;w=k;x=c[k+8>>2]|0}c[w+8>>2]=x+-1;x=c[d>>2]|0;u=c[x+8>>2]|0;v=x}x=b+48|0;a[h>>0]=0;c[h+4>>2]=0;w=h+8|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];w=c[x>>2]|0;if(u){x=u+-1|0;k=c[v+4>>2]|0;if(!(a[k+(x<<3)+4>>0]|0)){j=c[d+4>>2]|0;In[c[(c[j>>2]|0)+16>>2]&4095](j,c[k+(x<<3)>>2]|0);x=c[d>>2]|0;a[(c[x+4>>2]|0)+((c[x+8>>2]|0)+-1<<3)+4>>0]=1;x=c[d>>2]|0;y=x;z=c[x+8>>2]|0}else{y=v;z=u}}else{y=v;z=0}c[g>>2]=w;a[g+4>>0]=0;w=y+8|0;if((c[y+12>>2]&2147483647)>>>0>z>>>0){v=(c[y+4>>2]|0)+(z<<3)|0;if(!v)A=z;else{z=g;u=c[z+4>>2]|0;x=v;c[x>>2]=c[z>>2];c[x+4>>2]=u;A=c[w>>2]|0}c[w>>2]=A+1}else OAb(y,g)|0;VMb(d,h);y=c[d>>2]|0;A=c[y+8>>2]|0;if(!A){B=0;C=y}else{if(!(a[(c[y+4>>2]|0)+(A+-1<<3)+4>>0]|0)){D=y;E=A}else{A=c[d+4>>2]|0;ko[c[(c[A>>2]|0)+20>>2]&4095](A);A=c[d>>2]|0;D=A;E=c[A+8>>2]|0}c[D+8>>2]=E+-1;E=c[d>>2]|0;B=c[E+8>>2]|0;C=E}E=b+64|0;a[h>>0]=0;c[h+4>>2]=0;D=h+8|0;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];c[D+12>>2]=c[E+12>>2];D=c[E>>2]|0;if(B){E=B+-1|0;A=c[C+4>>2]|0;if(!(a[A+(E<<3)+4>>0]|0)){y=c[d+4>>2]|0;In[c[(c[y>>2]|0)+16>>2]&4095](y,c[A+(E<<3)>>2]|0);E=c[d>>2]|0;a[(c[E+4>>2]|0)+((c[E+8>>2]|0)+-1<<3)+4>>0]=1;E=c[d>>2]|0;F=E;G=c[E+8>>2]|0}else{F=C;G=B}}else{F=C;G=0}c[g>>2]=D;a[g+4>>0]=0;D=F+8|0;if((c[F+12>>2]&2147483647)>>>0>G>>>0){C=(c[F+4>>2]|0)+(G<<3)|0;if(!C)H=G;else{G=g;B=c[G+4>>2]|0;E=C;c[E>>2]=c[G>>2];c[E+4>>2]=B;H=c[D>>2]|0}c[D>>2]=H+1}else OAb(F,g)|0;WMb(d,h);F=c[d>>2]|0;H=c[F+8>>2]|0;if(!H){I=0;J=F}else{if(!(a[(c[F+4>>2]|0)+(H+-1<<3)+4>>0]|0)){K=F;L=H}else{H=c[d+4>>2]|0;ko[c[(c[H>>2]|0)+20>>2]&4095](H);H=c[d>>2]|0;K=H;L=c[H+8>>2]|0}c[K+8>>2]=L+-1;L=c[d>>2]|0;I=c[L+8>>2]|0;J=L}L=b+80|0;a[h>>0]=0;c[h+4>>2]=0;K=h+8|0;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];K=c[L>>2]|0;if(I){L=I+-1|0;H=c[J+4>>2]|0;if(!(a[H+(L<<3)+4>>0]|0)){F=c[d+4>>2]|0;In[c[(c[F>>2]|0)+16>>2]&4095](F,c[H+(L<<3)>>2]|0);L=c[d>>2]|0;a[(c[L+4>>2]|0)+((c[L+8>>2]|0)+-1<<3)+4>>0]=1;L=c[d>>2]|0;M=L;N=c[L+8>>2]|0}else{M=J;N=I}}else{M=J;N=0}c[g>>2]=K;a[g+4>>0]=0;K=M+8|0;if((c[M+12>>2]&2147483647)>>>0>N>>>0){J=(c[M+4>>2]|0)+(N<<3)|0;if(!J)O=N;else{N=g;I=c[N+4>>2]|0;L=J;c[L>>2]=c[N>>2];c[L+4>>2]=I;O=c[K>>2]|0}c[K>>2]=O+1}else OAb(M,g)|0;XMb(d,h);M=c[d>>2]|0;O=c[M+8>>2]|0;if(!O){P=0;Q=M}else{if(!(a[(c[M+4>>2]|0)+(O+-1<<3)+4>>0]|0)){R=M;S=O}else{O=c[d+4>>2]|0;ko[c[(c[O>>2]|0)+20>>2]&4095](O);O=c[d>>2]|0;R=O;S=c[O+8>>2]|0}c[R+8>>2]=S+-1;S=c[d>>2]|0;P=c[S+8>>2]|0;Q=S}S=b+96|0;a[h>>0]=0;c[h+4>>2]=0;R=h+8|0;c[R+0>>2]=c[S+0>>2];c[R+4>>2]=c[S+4>>2];c[R+8>>2]=c[S+8>>2];c[R+12>>2]=c[S+12>>2];R=c[S>>2]|0;if(P){S=P+-1|0;O=c[Q+4>>2]|0;if(!(a[O+(S<<3)+4>>0]|0)){M=c[d+4>>2]|0;In[c[(c[M>>2]|0)+16>>2]&4095](M,c[O+(S<<3)>>2]|0);S=c[d>>2]|0;a[(c[S+4>>2]|0)+((c[S+8>>2]|0)+-1<<3)+4>>0]=1;S=c[d>>2]|0;T=S;U=c[S+8>>2]|0}else{T=Q;U=P}}else{T=Q;U=0}c[g>>2]=R;a[g+4>>0]=0;R=T+8|0;if((c[T+12>>2]&2147483647)>>>0>U>>>0){Q=(c[T+4>>2]|0)+(U<<3)|0;if(!Q)V=U;else{U=g;P=c[U+4>>2]|0;S=Q;c[S>>2]=c[U>>2];c[S+4>>2]=P;V=c[R>>2]|0}c[R>>2]=V+1}else OAb(T,g)|0;YMb(d,h);T=c[d>>2]|0;V=c[T+8>>2]|0;if(!V){W=0;X=T}else{if(!(a[(c[T+4>>2]|0)+(V+-1<<3)+4>>0]|0)){Y=T;Z=V}else{V=c[d+4>>2]|0;ko[c[(c[V>>2]|0)+20>>2]&4095](V);V=c[d>>2]|0;Y=V;Z=c[V+8>>2]|0}c[Y+8>>2]=Z+-1;Z=c[d>>2]|0;W=c[Z+8>>2]|0;X=Z}Z=b+112|0;a[h>>0]=0;c[h+4>>2]=0;Y=h+8|0;c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];Y=c[Z>>2]|0;if(W){Z=W+-1|0;V=c[X+4>>2]|0;if(!(a[V+(Z<<3)+4>>0]|0)){T=c[d+4>>2]|0;In[c[(c[T>>2]|0)+16>>2]&4095](T,c[V+(Z<<3)>>2]|0);Z=c[d>>2]|0;a[(c[Z+4>>2]|0)+((c[Z+8>>2]|0)+-1<<3)+4>>0]=1;Z=c[d>>2]|0;_=Z;$=c[Z+8>>2]|0}else{_=X;$=W}}else{_=X;$=0}c[g>>2]=Y;a[g+4>>0]=0;Y=_+8|0;if((c[_+12>>2]&2147483647)>>>0>$>>>0){X=(c[_+4>>2]|0)+($<<3)|0;if(!X)aa=$;else{$=g;W=c[$+4>>2]|0;Z=X;c[Z>>2]=c[$>>2];c[Z+4>>2]=W;aa=c[Y>>2]|0}c[Y>>2]=aa+1}else OAb(_,g)|0;ZMb(d,h);_=c[d>>2]|0;aa=c[_+8>>2]|0;if(!aa){ba=0;ca=_}else{if(!(a[(c[_+4>>2]|0)+(aa+-1<<3)+4>>0]|0)){da=_;ea=aa}else{aa=c[d+4>>2]|0;ko[c[(c[aa>>2]|0)+20>>2]&4095](aa);aa=c[d>>2]|0;da=aa;ea=c[aa+8>>2]|0}c[da+8>>2]=ea+-1;ea=c[d>>2]|0;ba=c[ea+8>>2]|0;ca=ea}ea=b+128|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[ea+0>>2];c[b+4>>2]=c[ea+4>>2];c[b+8>>2]=c[ea+8>>2];c[b+12>>2]=c[ea+12>>2];b=c[ea>>2]|0;do if(!ba){fa=ca;ga=0}else{ea=ba+-1|0;da=c[ca+4>>2]|0;if(a[da+(ea<<3)+4>>0]|0){fa=ca;ga=ba;break}aa=c[d+4>>2]|0;In[c[(c[aa>>2]|0)+16>>2]&4095](aa,c[da+(ea<<3)>>2]|0);ea=c[d>>2]|0;a[(c[ea+4>>2]|0)+((c[ea+8>>2]|0)+-1<<3)+4>>0]=1;ea=c[d>>2]|0;fa=ea;ga=c[ea+8>>2]|0}while(0);c[g>>2]=b;a[g+4>>0]=0;b=fa+8|0;if((c[fa+12>>2]&2147483647)>>>0>ga>>>0){ba=(c[fa+4>>2]|0)+(ga<<3)|0;if(!ba)ha=ga;else{ga=g;ca=c[ga+4>>2]|0;ea=ba;c[ea>>2]=c[ga>>2];c[ea+4>>2]=ca;ha=c[b>>2]|0}c[b>>2]=ha+1}else OAb(fa,g)|0;_Mb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){ia=e+9|0;i=f;return ia|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){ja=h;ka=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;ja=g;ka=c[g+8>>2]|0}c[ja+8>>2]=ka+-1;ia=e+9|0;i=f;return ia|0}function TLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+32|0;g=f;h=f+8|0;$Mb(d,0,b,516608,0);j=b+16|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;aNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+32|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;bNb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+48|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[C+0>>2];c[b+4>>2]=c[C+4>>2];c[b+8>>2]=c[C+8>>2];c[b+12>>2]=c[C+12>>2];b=c[C>>2]|0;if(z){C=z+-1|0;B=c[A+4>>2]|0;if(!(a[B+(C<<3)+4>>0]|0)){y=c[d+4>>2]|0;In[c[(c[y>>2]|0)+16>>2]&4095](y,c[B+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=b;a[g+4>>0]=0;b=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[b>>2]|0}c[b>>2]=F+1}else OAb(D,g)|0;cNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){G=e+4|0;i=f;return G|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){H=h;I=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;H=g;I=c[g+8>>2]|0}c[H+8>>2]=I+-1;G=e+4|0;i=f;return G|0}function ULb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;dNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=c[b+24>>2]|0;u=c[b+16>>2]|0;if(s){r=s+-1|0;p=c[t+4>>2]|0;if(!(a[p+(r<<3)+4>>0]|0)){j=c[d+4>>2]|0;In[c[(c[j>>2]|0)+16>>2]&4095](j,c[p+(r<<3)>>2]|0);r=c[d>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=1;r=c[d>>2]|0;w=r;x=c[r+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;r=t;c[r>>2]=c[x>>2];c[r+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;w=c[d+20>>2]|0;if(w)c[w>>2]=(c[w>>2]|0)+1;w=d+4|0;y=c[w>>2]|0;u=c[d>>2]|0;s=c[u+8>>2]|0;if(!s)z=515864;else z=c[(c[u+4>>2]|0)+(s+-1<<3)>>2]|0;s=mo[v&4095](c[d+8>>2]|0)|0;if(517336){v=517336;u=517312;do{if((c[u+4>>2]|0)==(s|0))co[c[(c[y>>2]|0)+8>>2]&2047](y,z,v);u=u+8|0;v=c[u>>2]|0}while((v|0)!=0)}v=c[d>>2]|0;u=c[v+8>>2]|0;if(!u){A=0;B=v}else{if(!(a[(c[v+4>>2]|0)+(u+-1<<3)+4>>0]|0)){C=v;D=u}else{u=c[w>>2]|0;ko[c[(c[u>>2]|0)+20>>2]&4095](u);u=c[d>>2]|0;C=u;D=c[u+8>>2]|0}c[C+8>>2]=D+-1;D=c[d>>2]|0;A=c[D+8>>2]|0;B=D}D=b+32|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[D+0>>2];c[b+4>>2]=c[D+4>>2];c[b+8>>2]=c[D+8>>2];c[b+12>>2]=c[D+12>>2];b=c[D>>2]|0;if(A){D=A+-1|0;C=c[B+4>>2]|0;if(!(a[C+(D<<3)+4>>0]|0)){u=c[w>>2]|0;In[c[(c[u>>2]|0)+16>>2]&4095](u,c[C+(D<<3)>>2]|0);D=c[d>>2]|0;a[(c[D+4>>2]|0)+((c[D+8>>2]|0)+-1<<3)+4>>0]=1;D=c[d>>2]|0;E=D;F=c[D+8>>2]|0}else{E=B;F=A}}else{E=B;F=0}c[g>>2]=b;a[g+4>>0]=0;b=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){B=(c[E+4>>2]|0)+(F<<3)|0;if(!B)G=F;else{F=g;A=c[F+4>>2]|0;D=B;c[D>>2]=c[F>>2];c[D+4>>2]=A;G=c[b>>2]|0}c[b>>2]=G+1}else OAb(E,g)|0;eNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){H=e+3|0;i=f;return H|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){I=h;J=g}else{g=c[w>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;I=g;J=c[g+8>>2]|0}c[I+8>>2]=J+-1;H=e+3|0;i=f;return H|0}function VLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;fNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(g){if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){s=h;t=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;s=g;t=c[g+8>>2]|0}c[s+8>>2]=t+-1}gNb(d,0,b+16|0,516608,0);hNb(d,0,b+32|0,516608,0);i=f;return e+3|0}function WLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;iNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+16|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;jNb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+32|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;kNb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+48|0;a[h>>0]=0;c[h+4>>2]=0;I=h+8|0;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];I=c[J>>2]|0;if(G){J=G+-1|0;F=c[H+4>>2]|0;if(!(a[F+(J<<3)+4>>0]|0)){D=c[d+4>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[F+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=I;a[g+4>>0]=0;I=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[I>>2]|0}c[I>>2]=M+1}else OAb(K,g)|0;lNb(d,h);K=c[d>>2]|0;M=c[K+8>>2]|0;if(!M){N=0;O=K}else{if(!(a[(c[K+4>>2]|0)+(M+-1<<3)+4>>0]|0)){P=K;Q=M}else{M=c[d+4>>2]|0;ko[c[(c[M>>2]|0)+20>>2]&4095](M);M=c[d>>2]|0;P=M;Q=c[M+8>>2]|0}c[P+8>>2]=Q+-1;Q=c[d>>2]|0;N=c[Q+8>>2]|0;O=Q}Q=b+64|0;a[h>>0]=0;c[h+4>>2]=0;P=h+8|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];c[P+12>>2]=c[Q+12>>2];P=c[Q>>2]|0;if(N){Q=N+-1|0;M=c[O+4>>2]|0;if(!(a[M+(Q<<3)+4>>0]|0)){K=c[d+4>>2]|0;In[c[(c[K>>2]|0)+16>>2]&4095](K,c[M+(Q<<3)>>2]|0);Q=c[d>>2]|0;a[(c[Q+4>>2]|0)+((c[Q+8>>2]|0)+-1<<3)+4>>0]=1;Q=c[d>>2]|0;R=Q;S=c[Q+8>>2]|0}else{R=O;S=N}}else{R=O;S=0}c[g>>2]=P;a[g+4>>0]=0;P=R+8|0;if((c[R+12>>2]&2147483647)>>>0>S>>>0){O=(c[R+4>>2]|0)+(S<<3)|0;if(!O)T=S;else{S=g;N=c[S+4>>2]|0;Q=O;c[Q>>2]=c[S>>2];c[Q+4>>2]=N;T=c[P>>2]|0}c[P>>2]=T+1}else OAb(R,g)|0;mNb(d,h);R=c[d>>2]|0;T=c[R+8>>2]|0;if(!T){U=0;V=R}else{if(!(a[(c[R+4>>2]|0)+(T+-1<<3)+4>>0]|0)){W=R;X=T}else{T=c[d+4>>2]|0;ko[c[(c[T>>2]|0)+20>>2]&4095](T);T=c[d>>2]|0;W=T;X=c[T+8>>2]|0}c[W+8>>2]=X+-1;X=c[d>>2]|0;U=c[X+8>>2]|0;V=X}X=b+80|0;a[h>>0]=0;c[h+4>>2]=0;W=h+8|0;c[W+0>>2]=c[X+0>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];c[W+12>>2]=c[X+12>>2];W=c[X>>2]|0;if(U){X=U+-1|0;T=c[V+4>>2]|0;if(!(a[T+(X<<3)+4>>0]|0)){R=c[d+4>>2]|0;In[c[(c[R>>2]|0)+16>>2]&4095](R,c[T+(X<<3)>>2]|0);X=c[d>>2]|0;a[(c[X+4>>2]|0)+((c[X+8>>2]|0)+-1<<3)+4>>0]=1;X=c[d>>2]|0;Y=X;Z=c[X+8>>2]|0}else{Y=V;Z=U}}else{Y=V;Z=0}c[g>>2]=W;a[g+4>>0]=0;W=Y+8|0;if((c[Y+12>>2]&2147483647)>>>0>Z>>>0){V=(c[Y+4>>2]|0)+(Z<<3)|0;if(!V)_=Z;else{Z=g;U=c[Z+4>>2]|0;X=V;c[X>>2]=c[Z>>2];c[X+4>>2]=U;_=c[W>>2]|0}c[W>>2]=_+1}else OAb(Y,g)|0;nNb(d,h);h=c[d>>2]|0;Y=c[h+8>>2]|0;if(!Y){$=0;aa=h}else{if(!(a[(c[h+4>>2]|0)+(Y+-1<<3)+4>>0]|0)){ba=h;ca=Y}else{Y=c[d+4>>2]|0;ko[c[(c[Y>>2]|0)+20>>2]&4095](Y);Y=c[d>>2]|0;ba=Y;ca=c[Y+8>>2]|0}c[ba+8>>2]=ca+-1;ca=c[d>>2]|0;$=c[ca+8>>2]|0;aa=ca}ca=c[b+104>>2]|0;ba=c[b+96>>2]|0;do if(!$){da=aa;ea=0}else{b=$+-1|0;Y=c[aa+4>>2]|0;if(a[Y+(b<<3)+4>>0]|0){da=aa;ea=$;break}h=c[d+4>>2]|0;In[c[(c[h>>2]|0)+16>>2]&4095](h,c[Y+(b<<3)>>2]|0);b=c[d>>2]|0;a[(c[b+4>>2]|0)+((c[b+8>>2]|0)+-1<<3)+4>>0]=1;b=c[d>>2]|0;da=b;ea=c[b+8>>2]|0}while(0);c[g>>2]=ba;a[g+4>>0]=0;ba=da+8|0;if((c[da+12>>2]&2147483647)>>>0>ea>>>0){$=(c[da+4>>2]|0)+(ea<<3)|0;if(!$)fa=ea;else{ea=g;aa=c[ea+4>>2]|0;b=$;c[b>>2]=c[ea>>2];c[b+4>>2]=aa;fa=c[ba>>2]|0}c[ba>>2]=fa+1}else OAb(da,g)|0;g=c[d+20>>2]|0;if(g)c[g>>2]=(c[g>>2]|0)+1;g=d+4|0;da=c[g>>2]|0;fa=c[d>>2]|0;ba=c[fa+8>>2]|0;if(!ba)ga=515864;else ga=c[(c[fa+4>>2]|0)+(ba+-1<<3)>>2]|0;ba=mo[ca&4095](c[d+8>>2]|0)|0;if(517488){ca=517488;fa=517424;do{if((c[fa+4>>2]|0)==(ba|0))co[c[(c[da>>2]|0)+8>>2]&2047](da,ga,ca);fa=fa+8|0;ca=c[fa>>2]|0}while((ca|0)!=0)}ca=c[d>>2]|0;fa=c[ca+8>>2]|0;if(!fa){ha=e+7|0;i=f;return ha|0}if(!(a[(c[ca+4>>2]|0)+(fa+-1<<3)+4>>0]|0)){ia=ca;ja=fa}else{fa=c[g>>2]|0;ko[c[(c[fa>>2]|0)+20>>2]&4095](fa);fa=c[d>>2]|0;ia=fa;ja=c[fa+8>>2]|0}c[ia+8>>2]=ja+-1;ha=e+7|0;i=f;return ha|0}function XLb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+32|0;g=f;h=f+8|0;a[h>>0]=0;c[h+4>>2]=0;j=h+8|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];j=c[b>>2]|0;k=c[d>>2]|0;l=c[k+8>>2]|0;if(l){m=l+-1|0;n=c[k+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=k;q=l}}else{p=k;q=0}c[g>>2]=j;a[g+4>>0]=0;j=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){k=(c[p+4>>2]|0)+(q<<3)|0;if(!k)r=q;else{q=g;l=c[q+4>>2]|0;m=k;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[j>>2]|0}c[j>>2]=r+1}else OAb(p,g)|0;oNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+16|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;pNb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+32|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;qNb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+48|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[J+0>>2];c[b+4>>2]=c[J+4>>2];c[b+8>>2]=c[J+8>>2];c[b+12>>2]=c[J+12>>2];b=c[J>>2]|0;if(G){J=G+-1|0;I=c[H+4>>2]|0;if(!(a[I+(J<<3)+4>>0]|0)){F=c[d+4>>2]|0;In[c[(c[F>>2]|0)+16>>2]&4095](F,c[I+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=b;a[g+4>>0]=0;b=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[b>>2]|0}c[b>>2]=M+1}else OAb(K,g)|0;rNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){N=e+4|0;i=f;return N|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){O=h;P=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;O=g;P=c[g+8>>2]|0}c[O+8>>2]=P+-1;N=e+4|0;i=f;return N|0}function YLb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function ZLb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+288|0;g=d+272|0;h=d+224|0;j=d+112|0;k=d;l=c[b>>2]|0;m=c[l+8>>2]|0;if((m|0)!=0?(n=m+-1|0,o=c[l+4>>2]|0,l=o+(n<<3)|0,(a[o+(n<<3)+4>>0]|0)==0):0){n=b+36|0;if(!(a[n>>0]|0)){p=m;q=o;r=0}else{o=c[b+20>>2]|0;m=(_n[c[(c[o>>2]|0)+16>>2]&4095](o,c[l>>2]|0)|0)&1;a[n>>0]=m;l=c[b>>2]|0;p=c[l+8>>2]|0;q=c[l+4>>2]|0;r=m}a[q+(p+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[n>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}n=b+24|0;In[c[e+16>>2]&4095](j,c[n>>2]|0);r=b+8|0;p=c[b+4>>2]|0;q=c[b+20>>2]|0;m=c[b+28>>2]|0;l=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=p;p=h+8|0;c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[h+20>>2]=q;c[h+24>>2]=j;c[h+28>>2]=m;c[h+32>>2]=l;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;YIb(h,2,f+24|0,g);ZIb(h,f+48|0,0);_Ib(h,f+64|0,0);$Ib(h,f+80|0,0);aJb(h,f+96|0,0);bJb(h,f+112|0,0);cJb(h,f+128|0,0);f=c[n>>2]|0;n=c[j+64>>2]|0;YEi(k|0,j|0,n<<3|0)|0;c[k+64>>2]=n;n=k+80|0;h=j+80|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[n+12>>2]=c[h+12>>2];c[n+16>>2]=c[h+16>>2];c[n+20>>2]=c[h+20>>2];c[n+24>>2]=c[h+24>>2];c[n+28>>2]=c[h+28>>2];In[c[e+20>>2]&4095](f,k);i=d;return}function _Lb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+400|0;f=d+352|0;g=d;h=d+208|0;j=d+144|0;k=j+0|0;l=k+64|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));tFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;dJb(f,0,j,515160,0);eJb(f,j+16|0,0);fJb(f,j+32|0,0);gJb(f,j+48|0,0);j=c[m>>2]|0;YEi(g|0,h|0,144)|0;In[c[e+20>>2]&4095](j,g);i=d;return}function $Lb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+128|0;f=d+80|0;g=d;h=d+64|0;j=d+16|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));GFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;hJb(f,j,0);iJb(f,j+16|0,0);jJb(f,j+32|0,0);j=c[m>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];In[c[e+20>>2]&4095](j,g);i=d;return}function aMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+608|0;f=d+560|0;g=d;h=d+304|0;j=d+256|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));AFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;kJb(f,j,0);lJb(f,0,j+16|0,515160,0);mJb(f,0,j+32|0,515160,0);j=c[m>>2]|0;YEi(g|0,h|0,256)|0;In[c[e+20>>2]&4095](j,g);i=d;return}function bMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+432|0;f=e+288|0;g=e+256|0;h=e+144|0;j=e;k=c[b+24>>2]|0;if(!k)l=0;else l=c[k>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;PEi(j|0,0,144)|0;qFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;qFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;SLb(f,g,0)|0;i=e;return}function cMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+304|0;f=e+240|0;g=e+208|0;h=e+64|0;j=e;k=c[b+24>>2]|0;if(!k)l=112;else l=(c[k>>2]|0)+112|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+64|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));tFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;tFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;TLb(f,g,0)|0;i=e;return}function dMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e+96|0;g=e+64|0;h=e+48|0;j=e;k=c[b+24>>2]|0;if(!k)l=256;else l=(c[k>>2]|0)+256|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));GFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;GFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;ULb(f,g,0)|0;i=e;return}function eMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+384|0;f=e+336|0;g=e+304|0;h=e+48|0;j=e;k=c[b+24>>2]|0;if(!k)l=272;else l=(c[k>>2]|0)+272|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;l=j+0|0;k=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(k|0));AFa(j);In[c[d+16>>2]&4095](h,c[b+8>>2]|0);d=c[b>>2]|0;j=c[b+4>>2]|0;l=c[b+12>>2]|0;k=c[b+16>>2]|0;AFa(f);c[g>>2]=d;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=l;c[g+16>>2]=k;c[g+20>>2]=0;c[g+24>>2]=0;VLb(f,g,0)|0;i=e;return}function fMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function gMb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+288|0;g=d+272|0;h=d+224|0;j=d+112|0;k=d;l=c[b>>2]|0;m=c[l+8>>2]|0;if((m|0)!=0?(n=m+-1|0,o=c[l+4>>2]|0,l=o+(n<<3)|0,(a[o+(n<<3)+4>>0]|0)==0):0){n=b+36|0;if(!(a[n>>0]|0)){p=m;q=o;r=0}else{o=c[b+20>>2]|0;m=(_n[c[(c[o>>2]|0)+16>>2]&4095](o,c[l>>2]|0)|0)&1;a[n>>0]=m;l=c[b>>2]|0;p=c[l+8>>2]|0;q=c[l+4>>2]|0;r=m}a[q+(p+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[n>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}n=b+24|0;In[c[e+16>>2]&4095](j,c[n>>2]|0);r=b+8|0;p=c[b+4>>2]|0;q=c[b+20>>2]|0;m=c[b+28>>2]|0;l=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=p;p=h+8|0;c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[h+20>>2]=q;c[h+24>>2]=j;c[h+28>>2]=m;c[h+32>>2]=l;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;a[g>>0]=0;YIb(h,2,f+24|0,g);ZIb(h,f+48|0,0);_Ib(h,f+64|0,0);$Ib(h,f+80|0,0);aJb(h,f+96|0,0);bJb(h,f+112|0,0);cJb(h,f+128|0,0);f=c[n>>2]|0;n=c[j+64>>2]|0;YEi(k|0,j|0,n<<3|0)|0;c[k+64>>2]=n;n=k+80|0;h=j+80|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[n+12>>2]=c[h+12>>2];c[n+16>>2]=c[h+16>>2];c[n+20>>2]=c[h+20>>2];c[n+24>>2]=c[h+24>>2];c[n+28>>2]=c[h+28>>2];In[c[e+20>>2]&4095](f,k);i=d;return}function hMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+400|0;f=d+352|0;g=d;h=d+208|0;j=d+144|0;k=j+0|0;l=k+64|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));tFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;dJb(f,0,j,515160,0);eJb(f,j+16|0,0);fJb(f,j+32|0,0);gJb(f,j+48|0,0);j=c[m>>2]|0;YEi(g|0,h|0,144)|0;In[c[e+20>>2]&4095](j,g);i=d;return}function iMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+128|0;f=d+80|0;g=d;h=d+64|0;j=d+16|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));GFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;hJb(f,j,0);iJb(f,j+16|0,0);jJb(f,j+32|0,0);j=c[m>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];In[c[e+20>>2]&4095](j,g);i=d;return}function jMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+608|0;f=d+560|0;g=d;h=d+304|0;j=d+256|0;k=j+0|0;l=k+48|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));AFa(j);k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](h,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=o;o=f+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[f+20>>2]=p;c[f+24>>2]=h;c[f+28>>2]=l;c[f+32>>2]=k;a[f+36>>0]=1;c[f+40>>2]=0;c[f+44>>2]=0;kJb(f,j,0);lJb(f,0,j+16|0,515160,0);mJb(f,0,j+32|0,515160,0);j=c[m>>2]|0;YEi(g|0,h|0,256)|0;In[c[e+20>>2]&4095](j,g);i=d;return}function kMb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+80|0;g=d;h=d+32|0;j=d+16|0;k=c[b>>2]|0;l=c[k+8>>2]|0;if((l|0)!=0?(m=l+-1|0,n=c[k+4>>2]|0,k=n+(m<<3)|0,(a[n+(m<<3)+4>>0]|0)==0):0){m=b+36|0;if(!(a[m>>0]|0)){o=l;p=n;q=0}else{n=c[b+20>>2]|0;l=(_n[c[(c[n>>2]|0)+16>>2]&4095](n,c[k>>2]|0)|0)&1;a[m>>0]=l;k=c[b>>2]|0;o=c[k+8>>2]|0;p=c[k+4>>2]|0;q=l}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[m>>0]|0}if(!(a[b+36>>0]|0)){i=d;return}m=b+24|0;In[c[e+16>>2]&4095](j,c[m>>2]|0);q=b+8|0;o=c[b+4>>2]|0;p=c[b+20>>2]|0;l=c[b+28>>2]|0;k=c[b+32>>2]|0;c[h>>2]=c[b>>2];c[h+4>>2]=o;o=h+8|0;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[h+20>>2]=p;c[h+24>>2]=j;c[h+28>>2]=l;c[h+32>>2]=k;a[h+36>>0]=1;c[h+40>>2]=0;c[h+44>>2]=0;sNb(h,f,0);f=c[m>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];In[c[e+20>>2]&4095](f,g);i=d;return}function lMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=0;else j=c[h>>2]|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function mMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+252>>2]&2147483647)>>>0<b>>>0)tNb(a,b);f=c[a+244>>2]|0;g=a+248|0;a=c[g>>2]|0;h=f+(b*48|0)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a*48|0)|0;do{if(j){a=j+0|0;f=d+0|0;k=a+48|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(k|0))}j=j+48|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function nMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+36|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;uNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+52|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;vNb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+68|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;wNb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+84|0;a[h>>0]=0;c[h+4>>2]=0;I=h+8|0;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];I=c[J>>2]|0;if(G){J=G+-1|0;F=c[H+4>>2]|0;if(!(a[F+(J<<3)+4>>0]|0)){D=c[d+4>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[F+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=I;a[g+4>>0]=0;I=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[I>>2]|0}c[I>>2]=M+1}else OAb(K,g)|0;xNb(d,h);K=c[d>>2]|0;M=c[K+8>>2]|0;if(!M){N=0;O=K}else{if(!(a[(c[K+4>>2]|0)+(M+-1<<3)+4>>0]|0)){P=K;Q=M}else{M=c[d+4>>2]|0;ko[c[(c[M>>2]|0)+20>>2]&4095](M);M=c[d>>2]|0;P=M;Q=c[M+8>>2]|0}c[P+8>>2]=Q+-1;Q=c[d>>2]|0;N=c[Q+8>>2]|0;O=Q}Q=b+100|0;a[h>>0]=0;c[h+4>>2]=0;P=h+8|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];c[P+12>>2]=c[Q+12>>2];P=c[Q>>2]|0;if(N){Q=N+-1|0;M=c[O+4>>2]|0;if(!(a[M+(Q<<3)+4>>0]|0)){K=c[d+4>>2]|0;In[c[(c[K>>2]|0)+16>>2]&4095](K,c[M+(Q<<3)>>2]|0);Q=c[d>>2]|0;a[(c[Q+4>>2]|0)+((c[Q+8>>2]|0)+-1<<3)+4>>0]=1;Q=c[d>>2]|0;R=Q;S=c[Q+8>>2]|0}else{R=O;S=N}}else{R=O;S=0}c[g>>2]=P;a[g+4>>0]=0;P=R+8|0;if((c[R+12>>2]&2147483647)>>>0>S>>>0){O=(c[R+4>>2]|0)+(S<<3)|0;if(!O)T=S;else{S=g;N=c[S+4>>2]|0;Q=O;c[Q>>2]=c[S>>2];c[Q+4>>2]=N;T=c[P>>2]|0}c[P>>2]=T+1}else OAb(R,g)|0;yNb(d,h);R=c[d>>2]|0;T=c[R+8>>2]|0;if(!T){U=0;V=R}else{if(!(a[(c[R+4>>2]|0)+(T+-1<<3)+4>>0]|0)){W=R;X=T}else{T=c[d+4>>2]|0;ko[c[(c[T>>2]|0)+20>>2]&4095](T);T=c[d>>2]|0;W=T;X=c[T+8>>2]|0}c[W+8>>2]=X+-1;X=c[d>>2]|0;U=c[X+8>>2]|0;V=X}X=b+116|0;a[h>>0]=0;c[h+4>>2]=0;W=h+8|0;c[W+0>>2]=c[X+0>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];c[W+12>>2]=c[X+12>>2];W=c[X>>2]|0;if(U){X=U+-1|0;T=c[V+4>>2]|0;if(!(a[T+(X<<3)+4>>0]|0)){R=c[d+4>>2]|0;In[c[(c[R>>2]|0)+16>>2]&4095](R,c[T+(X<<3)>>2]|0);X=c[d>>2]|0;a[(c[X+4>>2]|0)+((c[X+8>>2]|0)+-1<<3)+4>>0]=1;X=c[d>>2]|0;Y=X;Z=c[X+8>>2]|0}else{Y=V;Z=U}}else{Y=V;Z=0}c[g>>2]=W;a[g+4>>0]=0;W=Y+8|0;if((c[Y+12>>2]&2147483647)>>>0>Z>>>0){V=(c[Y+4>>2]|0)+(Z<<3)|0;if(!V)_=Z;else{Z=g;U=c[Z+4>>2]|0;X=V;c[X>>2]=c[Z>>2];c[X+4>>2]=U;_=c[W>>2]|0}c[W>>2]=_+1}else OAb(Y,g)|0;zNb(d,h);Y=c[d>>2]|0;_=c[Y+8>>2]|0;if(!_){$=0;aa=Y}else{if(!(a[(c[Y+4>>2]|0)+(_+-1<<3)+4>>0]|0)){ba=Y;ca=_}else{_=c[d+4>>2]|0;ko[c[(c[_>>2]|0)+20>>2]&4095](_);_=c[d>>2]|0;ba=_;ca=c[_+8>>2]|0}c[ba+8>>2]=ca+-1;ca=c[d>>2]|0;$=c[ca+8>>2]|0;aa=ca}ca=b+132|0;a[h>>0]=0;c[h+4>>2]=0;ba=h+8|0;c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];ba=c[ca>>2]|0;do if(!$){da=aa;ea=0}else{ca=$+-1|0;_=c[aa+4>>2]|0;if(a[_+(ca<<3)+4>>0]|0){da=aa;ea=$;break}Y=c[d+4>>2]|0;In[c[(c[Y>>2]|0)+16>>2]&4095](Y,c[_+(ca<<3)>>2]|0);ca=c[d>>2]|0;a[(c[ca+4>>2]|0)+((c[ca+8>>2]|0)+-1<<3)+4>>0]=1;ca=c[d>>2]|0;da=ca;ea=c[ca+8>>2]|0}while(0);c[g>>2]=ba;a[g+4>>0]=0;ba=da+8|0;if((c[da+12>>2]&2147483647)>>>0>ea>>>0){$=(c[da+4>>2]|0)+(ea<<3)|0;if(!$)fa=ea;else{ea=g;aa=c[ea+4>>2]|0;ca=$;c[ca>>2]=c[ea>>2];c[ca+4>>2]=aa;fa=c[ba>>2]|0}c[ba>>2]=fa+1}else OAb(da,g)|0;ANb(d,h);da=c[d>>2]|0;fa=c[da+8>>2]|0;if(!fa){ga=0;ha=da}else{if(!(a[(c[da+4>>2]|0)+(fa+-1<<3)+4>>0]|0)){ia=da;ja=fa}else{fa=c[d+4>>2]|0;ko[c[(c[fa>>2]|0)+20>>2]&4095](fa);fa=c[d>>2]|0;ia=fa;ja=c[fa+8>>2]|0}c[ia+8>>2]=ja+-1;ja=c[d>>2]|0;ga=c[ja+8>>2]|0;ha=ja}ja=b+148|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[ja+0>>2];c[b+4>>2]=c[ja+4>>2];c[b+8>>2]=c[ja+8>>2];c[b+12>>2]=c[ja+12>>2];b=c[ja>>2]|0;do if(!ga){ka=ha;la=0}else{ja=ga+-1|0;ia=c[ha+4>>2]|0;if(a[ia+(ja<<3)+4>>0]|0){ka=ha;la=ga;break}fa=c[d+4>>2]|0;In[c[(c[fa>>2]|0)+16>>2]&4095](fa,c[ia+(ja<<3)>>2]|0);ja=c[d>>2]|0;a[(c[ja+4>>2]|0)+((c[ja+8>>2]|0)+-1<<3)+4>>0]=1;ja=c[d>>2]|0;ka=ja;la=c[ja+8>>2]|0}while(0);c[g>>2]=b;a[g+4>>0]=0;b=ka+8|0;if((c[ka+12>>2]&2147483647)>>>0>la>>>0){ga=(c[ka+4>>2]|0)+(la<<3)|0;if(!ga)ma=la;else{la=g;ha=c[la+4>>2]|0;ja=ga;c[ja>>2]=c[la>>2];c[ja+4>>2]=ha;ma=c[b>>2]|0}c[b>>2]=ma+1}else OAb(ka,g)|0;BNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){na=e+11|0;i=f;return na|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){oa=h;pa=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;oa=g;pa=c[g+8>>2]|0}c[oa+8>>2]=pa+-1;na=e+11|0;i=f;return na|0}function oMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+252>>2]&2147483647)>>>0<b>>>0)CNb(a,b);f=c[a+244>>2]|0;g=a+248|0;a=c[g>>2]|0;h=f+(b*48|0)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a*48|0)|0;do{if(j){a=j+0|0;f=d+0|0;k=a+48|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(k|0))}j=j+48|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function pMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+24|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;DNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+40|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;ENb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+56|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;FNb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+72|0;a[h>>0]=0;c[h+4>>2]=0;I=h+8|0;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];I=c[J>>2]|0;if(G){J=G+-1|0;F=c[H+4>>2]|0;if(!(a[F+(J<<3)+4>>0]|0)){D=c[d+4>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[F+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=I;a[g+4>>0]=0;I=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[I>>2]|0}c[I>>2]=M+1}else OAb(K,g)|0;GNb(d,h);K=c[d>>2]|0;M=c[K+8>>2]|0;if(!M){N=0;O=K}else{if(!(a[(c[K+4>>2]|0)+(M+-1<<3)+4>>0]|0)){P=K;Q=M}else{M=c[d+4>>2]|0;ko[c[(c[M>>2]|0)+20>>2]&4095](M);M=c[d>>2]|0;P=M;Q=c[M+8>>2]|0}c[P+8>>2]=Q+-1;Q=c[d>>2]|0;N=c[Q+8>>2]|0;O=Q}Q=b+88|0;a[h>>0]=0;c[h+4>>2]=0;P=h+8|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];c[P+12>>2]=c[Q+12>>2];P=c[Q>>2]|0;if(N){Q=N+-1|0;M=c[O+4>>2]|0;if(!(a[M+(Q<<3)+4>>0]|0)){K=c[d+4>>2]|0;In[c[(c[K>>2]|0)+16>>2]&4095](K,c[M+(Q<<3)>>2]|0);Q=c[d>>2]|0;a[(c[Q+4>>2]|0)+((c[Q+8>>2]|0)+-1<<3)+4>>0]=1;Q=c[d>>2]|0;R=Q;S=c[Q+8>>2]|0}else{R=O;S=N}}else{R=O;S=0}c[g>>2]=P;a[g+4>>0]=0;P=R+8|0;if((c[R+12>>2]&2147483647)>>>0>S>>>0){O=(c[R+4>>2]|0)+(S<<3)|0;if(!O)T=S;else{S=g;N=c[S+4>>2]|0;Q=O;c[Q>>2]=c[S>>2];c[Q+4>>2]=N;T=c[P>>2]|0}c[P>>2]=T+1}else OAb(R,g)|0;HNb(d,h);R=c[d>>2]|0;T=c[R+8>>2]|0;if(!T){U=0;V=R}else{if(!(a[(c[R+4>>2]|0)+(T+-1<<3)+4>>0]|0)){W=R;X=T}else{T=c[d+4>>2]|0;ko[c[(c[T>>2]|0)+20>>2]&4095](T);T=c[d>>2]|0;W=T;X=c[T+8>>2]|0}c[W+8>>2]=X+-1;X=c[d>>2]|0;U=c[X+8>>2]|0;V=X}X=b+104|0;a[h>>0]=0;c[h+4>>2]=0;W=h+8|0;c[W+0>>2]=c[X+0>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];c[W+12>>2]=c[X+12>>2];W=c[X>>2]|0;if(U){X=U+-1|0;T=c[V+4>>2]|0;if(!(a[T+(X<<3)+4>>0]|0)){R=c[d+4>>2]|0;In[c[(c[R>>2]|0)+16>>2]&4095](R,c[T+(X<<3)>>2]|0);X=c[d>>2]|0;a[(c[X+4>>2]|0)+((c[X+8>>2]|0)+-1<<3)+4>>0]=1;X=c[d>>2]|0;Y=X;Z=c[X+8>>2]|0}else{Y=V;Z=U}}else{Y=V;Z=0}c[g>>2]=W;a[g+4>>0]=0;W=Y+8|0;if((c[Y+12>>2]&2147483647)>>>0>Z>>>0){V=(c[Y+4>>2]|0)+(Z<<3)|0;if(!V)_=Z;else{Z=g;U=c[Z+4>>2]|0;X=V;c[X>>2]=c[Z>>2];c[X+4>>2]=U;_=c[W>>2]|0}c[W>>2]=_+1}else OAb(Y,g)|0;INb(d,h);Y=c[d>>2]|0;_=c[Y+8>>2]|0;if(!_){$=0;aa=Y}else{if(!(a[(c[Y+4>>2]|0)+(_+-1<<3)+4>>0]|0)){ba=Y;ca=_}else{_=c[d+4>>2]|0;ko[c[(c[_>>2]|0)+20>>2]&4095](_);_=c[d>>2]|0;ba=_;ca=c[_+8>>2]|0}c[ba+8>>2]=ca+-1;ca=c[d>>2]|0;$=c[ca+8>>2]|0;aa=ca}ca=b+120|0;a[h>>0]=0;c[h+4>>2]=0;ba=h+8|0;c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];ba=c[ca>>2]|0;do if(!$){da=aa;ea=0}else{ca=$+-1|0;_=c[aa+4>>2]|0;if(a[_+(ca<<3)+4>>0]|0){da=aa;ea=$;break}Y=c[d+4>>2]|0;In[c[(c[Y>>2]|0)+16>>2]&4095](Y,c[_+(ca<<3)>>2]|0);ca=c[d>>2]|0;a[(c[ca+4>>2]|0)+((c[ca+8>>2]|0)+-1<<3)+4>>0]=1;ca=c[d>>2]|0;da=ca;ea=c[ca+8>>2]|0}while(0);c[g>>2]=ba;a[g+4>>0]=0;ba=da+8|0;if((c[da+12>>2]&2147483647)>>>0>ea>>>0){$=(c[da+4>>2]|0)+(ea<<3)|0;if(!$)fa=ea;else{ea=g;aa=c[ea+4>>2]|0;ca=$;c[ca>>2]=c[ea>>2];c[ca+4>>2]=aa;fa=c[ba>>2]|0}c[ba>>2]=fa+1}else OAb(da,g)|0;JNb(d,h);da=c[d>>2]|0;fa=c[da+8>>2]|0;if(!fa){ga=0;ha=da}else{if(!(a[(c[da+4>>2]|0)+(fa+-1<<3)+4>>0]|0)){ia=da;ja=fa}else{fa=c[d+4>>2]|0;ko[c[(c[fa>>2]|0)+20>>2]&4095](fa);fa=c[d>>2]|0;ia=fa;ja=c[fa+8>>2]|0}c[ia+8>>2]=ja+-1;ja=c[d>>2]|0;ga=c[ja+8>>2]|0;ha=ja}ja=b+136|0;a[h>>0]=0;c[h+4>>2]=0;ia=h+8|0;c[ia+0>>2]=c[ja+0>>2];c[ia+4>>2]=c[ja+4>>2];c[ia+8>>2]=c[ja+8>>2];c[ia+12>>2]=c[ja+12>>2];ia=c[ja>>2]|0;do if(!ga){ka=ha;la=0}else{ja=ga+-1|0;fa=c[ha+4>>2]|0;if(a[fa+(ja<<3)+4>>0]|0){ka=ha;la=ga;break}da=c[d+4>>2]|0;In[c[(c[da>>2]|0)+16>>2]&4095](da,c[fa+(ja<<3)>>2]|0);ja=c[d>>2]|0;a[(c[ja+4>>2]|0)+((c[ja+8>>2]|0)+-1<<3)+4>>0]=1;ja=c[d>>2]|0;ka=ja;la=c[ja+8>>2]|0}while(0);c[g>>2]=ia;a[g+4>>0]=0;ia=ka+8|0;if((c[ka+12>>2]&2147483647)>>>0>la>>>0){ga=(c[ka+4>>2]|0)+(la<<3)|0;if(!ga)ma=la;else{la=g;ha=c[la+4>>2]|0;ja=ga;c[ja>>2]=c[la>>2];c[ja+4>>2]=ha;ma=c[ia>>2]|0}c[ia>>2]=ma+1}else OAb(ka,g)|0;KNb(d,h);ka=c[d>>2]|0;ma=c[ka+8>>2]|0;if(!ma){na=0;oa=ka}else{if(!(a[(c[ka+4>>2]|0)+(ma+-1<<3)+4>>0]|0)){pa=ka;qa=ma}else{ma=c[d+4>>2]|0;ko[c[(c[ma>>2]|0)+20>>2]&4095](ma);ma=c[d>>2]|0;pa=ma;qa=c[ma+8>>2]|0}c[pa+8>>2]=qa+-1;qa=c[d>>2]|0;na=c[qa+8>>2]|0;oa=qa}qa=b+152|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[qa+0>>2];c[b+4>>2]=c[qa+4>>2];c[b+8>>2]=c[qa+8>>2];c[b+12>>2]=c[qa+12>>2];b=c[qa>>2]|0;do if(!na){ra=oa;sa=0}else{qa=na+-1|0;pa=c[oa+4>>2]|0;if(a[pa+(qa<<3)+4>>0]|0){ra=oa;sa=na;break}ma=c[d+4>>2]|0;In[c[(c[ma>>2]|0)+16>>2]&4095](ma,c[pa+(qa<<3)>>2]|0);qa=c[d>>2]|0;a[(c[qa+4>>2]|0)+((c[qa+8>>2]|0)+-1<<3)+4>>0]=1;qa=c[d>>2]|0;ra=qa;sa=c[qa+8>>2]|0}while(0);c[g>>2]=b;a[g+4>>0]=0;b=ra+8|0;if((c[ra+12>>2]&2147483647)>>>0>sa>>>0){na=(c[ra+4>>2]|0)+(sa<<3)|0;if(!na)ta=sa;else{sa=g;oa=c[sa+4>>2]|0;qa=na;c[qa>>2]=c[sa>>2];c[qa+4>>2]=oa;ta=c[b>>2]|0}c[b>>2]=ta+1}else OAb(ra,g)|0;LNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){ua=e+11|0;i=f;return ua|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){va=h;wa=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;va=g;wa=c[g+8>>2]|0}c[va+8>>2]=wa+-1;ua=e+11|0;i=f;return ua|0}function qMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((c[a+332>>2]&2147483647)>>>0<b>>>0)MNb(a,b);f=c[a+324>>2]|0;g=a+328|0;a=c[g>>2]|0;h=f+(b<<6)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<6)|0;do{if(j){a=j+0|0;f=d+0|0;k=a+64|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(k|0))}j=j+64|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function rMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+36|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;NNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+52|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;ONb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+68|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;PNb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+84|0;a[h>>0]=0;c[h+4>>2]=0;I=h+8|0;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];I=c[J>>2]|0;if(G){J=G+-1|0;F=c[H+4>>2]|0;if(!(a[F+(J<<3)+4>>0]|0)){D=c[d+4>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[F+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=I;a[g+4>>0]=0;I=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[I>>2]|0}c[I>>2]=M+1}else OAb(K,g)|0;QNb(d,h);K=c[d>>2]|0;M=c[K+8>>2]|0;if(!M){N=0;O=K}else{if(!(a[(c[K+4>>2]|0)+(M+-1<<3)+4>>0]|0)){P=K;Q=M}else{M=c[d+4>>2]|0;ko[c[(c[M>>2]|0)+20>>2]&4095](M);M=c[d>>2]|0;P=M;Q=c[M+8>>2]|0}c[P+8>>2]=Q+-1;Q=c[d>>2]|0;N=c[Q+8>>2]|0;O=Q}Q=b+100|0;a[h>>0]=0;c[h+4>>2]=0;P=h+8|0;c[P+0>>2]=c[Q+0>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];c[P+12>>2]=c[Q+12>>2];P=c[Q>>2]|0;if(N){Q=N+-1|0;M=c[O+4>>2]|0;if(!(a[M+(Q<<3)+4>>0]|0)){K=c[d+4>>2]|0;In[c[(c[K>>2]|0)+16>>2]&4095](K,c[M+(Q<<3)>>2]|0);Q=c[d>>2]|0;a[(c[Q+4>>2]|0)+((c[Q+8>>2]|0)+-1<<3)+4>>0]=1;Q=c[d>>2]|0;R=Q;S=c[Q+8>>2]|0}else{R=O;S=N}}else{R=O;S=0}c[g>>2]=P;a[g+4>>0]=0;P=R+8|0;if((c[R+12>>2]&2147483647)>>>0>S>>>0){O=(c[R+4>>2]|0)+(S<<3)|0;if(!O)T=S;else{S=g;N=c[S+4>>2]|0;Q=O;c[Q>>2]=c[S>>2];c[Q+4>>2]=N;T=c[P>>2]|0}c[P>>2]=T+1}else OAb(R,g)|0;RNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){U=b+116|0;V=b+132|0;W=c[V>>2]|0;X=b+136|0;Y=c[X>>2]|0;SNb(d,0,U,W,Y);Z=e+9|0;i=f;return Z|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){_=h;$=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;_=g;$=c[g+8>>2]|0}c[_+8>>2]=$+-1;U=b+116|0;V=b+132|0;W=c[V>>2]|0;X=b+136|0;Y=c[X>>2]|0;SNb(d,0,U,W,Y);Z=e+9|0;i=f;return Z|0}function sMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;if((c[a+72>>2]&2147483647)>>>0<b>>>0)TNb(a,b);f=c[a+64>>2]|0;h=a+68|0;a=c[h>>2]|0;j=f+(b*12|0)|0;if((a|0)>=(b|0)){c[h>>2]=b;i=e;return}k=d+4|0;l=d+8|0;m=f+(a*12|0)|0;do{if(m){g[m>>2]=ea(g[d>>2]);g[m+4>>2]=ea(g[k>>2]);g[m+8>>2]=ea(g[l>>2])}m=m+12|0}while(m>>>0<j>>>0);c[h>>2]=b;i=e;return}function tMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+32>>2]&2147483647)>>>0<b>>>0)UNb(a,b);f=c[a+24>>2]|0;g=a+28|0;a=c[g>>2]|0;h=f+(b<<2)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<2)|0;do{if(j)c[j>>2]=c[d>>2];j=j+4|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function uMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[a+92>>2]&2147483647)>>>0<b>>>0)VNb(a,b);f=c[a+84>>2]|0;g=a+88|0;a=c[g>>2]|0;h=f+(b<<4)|0;if((a|0)>=(b|0)){c[g>>2]=b;i=e;return}j=f+(a<<4)|0;do{if(j){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2]}j=j+16|0}while(j>>>0<h>>>0);c[g>>2]=b;i=e;return}function vMb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;f=i;i=i+32|0;g=f;h=f+8|0;j=b+12|0;a[h>>0]=0;c[h+4>>2]=0;k=h+8|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];k=c[j>>2]|0;j=c[d>>2]|0;l=c[j+8>>2]|0;if(l){m=l+-1|0;n=c[j+4>>2]|0;if(!(a[n+(m<<3)+4>>0]|0)){o=c[d+4>>2]|0;In[c[(c[o>>2]|0)+16>>2]&4095](o,c[n+(m<<3)>>2]|0);m=c[d>>2]|0;a[(c[m+4>>2]|0)+((c[m+8>>2]|0)+-1<<3)+4>>0]=1;m=c[d>>2]|0;p=m;q=c[m+8>>2]|0}else{p=j;q=l}}else{p=j;q=0}c[g>>2]=k;a[g+4>>0]=0;k=p+8|0;if((c[p+12>>2]&2147483647)>>>0>q>>>0){j=(c[p+4>>2]|0)+(q<<3)|0;if(!j)r=q;else{q=g;l=c[q+4>>2]|0;m=j;c[m>>2]=c[q>>2];c[m+4>>2]=l;r=c[k>>2]|0}c[k>>2]=r+1}else OAb(p,g)|0;WNb(d,h);p=c[d>>2]|0;r=c[p+8>>2]|0;if(!r){s=0;t=p}else{if(!(a[(c[p+4>>2]|0)+(r+-1<<3)+4>>0]|0)){u=p;v=r}else{r=c[d+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[d>>2]|0;u=r;v=c[r+8>>2]|0}c[u+8>>2]=v+-1;v=c[d>>2]|0;s=c[v+8>>2]|0;t=v}v=b+28|0;a[h>>0]=0;c[h+4>>2]=0;u=h+8|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];u=c[v>>2]|0;if(s){v=s+-1|0;r=c[t+4>>2]|0;if(!(a[r+(v<<3)+4>>0]|0)){p=c[d+4>>2]|0;In[c[(c[p>>2]|0)+16>>2]&4095](p,c[r+(v<<3)>>2]|0);v=c[d>>2]|0;a[(c[v+4>>2]|0)+((c[v+8>>2]|0)+-1<<3)+4>>0]=1;v=c[d>>2]|0;w=v;x=c[v+8>>2]|0}else{w=t;x=s}}else{w=t;x=0}c[g>>2]=u;a[g+4>>0]=0;u=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){t=(c[w+4>>2]|0)+(x<<3)|0;if(!t)y=x;else{x=g;s=c[x+4>>2]|0;v=t;c[v>>2]=c[x>>2];c[v+4>>2]=s;y=c[u>>2]|0}c[u>>2]=y+1}else OAb(w,g)|0;XNb(d,h);w=c[d>>2]|0;y=c[w+8>>2]|0;if(!y){z=0;A=w}else{if(!(a[(c[w+4>>2]|0)+(y+-1<<3)+4>>0]|0)){B=w;C=y}else{y=c[d+4>>2]|0;ko[c[(c[y>>2]|0)+20>>2]&4095](y);y=c[d>>2]|0;B=y;C=c[y+8>>2]|0}c[B+8>>2]=C+-1;C=c[d>>2]|0;z=c[C+8>>2]|0;A=C}C=b+44|0;a[h>>0]=0;c[h+4>>2]=0;B=h+8|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];B=c[C>>2]|0;if(z){C=z+-1|0;y=c[A+4>>2]|0;if(!(a[y+(C<<3)+4>>0]|0)){w=c[d+4>>2]|0;In[c[(c[w>>2]|0)+16>>2]&4095](w,c[y+(C<<3)>>2]|0);C=c[d>>2]|0;a[(c[C+4>>2]|0)+((c[C+8>>2]|0)+-1<<3)+4>>0]=1;C=c[d>>2]|0;D=C;E=c[C+8>>2]|0}else{D=A;E=z}}else{D=A;E=0}c[g>>2]=B;a[g+4>>0]=0;B=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){A=(c[D+4>>2]|0)+(E<<3)|0;if(!A)F=E;else{E=g;z=c[E+4>>2]|0;C=A;c[C>>2]=c[E>>2];c[C+4>>2]=z;F=c[B>>2]|0}c[B>>2]=F+1}else OAb(D,g)|0;YNb(d,h);D=c[d>>2]|0;F=c[D+8>>2]|0;if(!F){G=0;H=D}else{if(!(a[(c[D+4>>2]|0)+(F+-1<<3)+4>>0]|0)){I=D;J=F}else{F=c[d+4>>2]|0;ko[c[(c[F>>2]|0)+20>>2]&4095](F);F=c[d>>2]|0;I=F;J=c[F+8>>2]|0}c[I+8>>2]=J+-1;J=c[d>>2]|0;G=c[J+8>>2]|0;H=J}J=b+60|0;a[h>>0]=0;c[h+4>>2]=0;b=h+8|0;c[b+0>>2]=c[J+0>>2];c[b+4>>2]=c[J+4>>2];c[b+8>>2]=c[J+8>>2];c[b+12>>2]=c[J+12>>2];b=c[J>>2]|0;if(G){J=G+-1|0;I=c[H+4>>2]|0;if(!(a[I+(J<<3)+4>>0]|0)){F=c[d+4>>2]|0;In[c[(c[F>>2]|0)+16>>2]&4095](F,c[I+(J<<3)>>2]|0);J=c[d>>2]|0;a[(c[J+4>>2]|0)+((c[J+8>>2]|0)+-1<<3)+4>>0]=1;J=c[d>>2]|0;K=J;L=c[J+8>>2]|0}else{K=H;L=G}}else{K=H;L=0}c[g>>2]=b;a[g+4>>0]=0;b=K+8|0;if((c[K+12>>2]&2147483647)>>>0>L>>>0){H=(c[K+4>>2]|0)+(L<<3)|0;if(!H)M=L;else{L=g;G=c[L+4>>2]|0;J=H;c[J>>2]=c[L>>2];c[J+4>>2]=G;M=c[b>>2]|0}c[b>>2]=M+1}else OAb(K,g)|0;ZNb(d,h);h=c[d>>2]|0;g=c[h+8>>2]|0;if(!g){N=e+5|0;i=f;return N|0}if(!(a[(c[h+4>>2]|0)+(g+-1<<3)+4>>0]|0)){O=h;P=g}else{g=c[d+4>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[d>>2]|0;O=g;P=c[g+8>>2]|0}c[O+8>>2]=P+-1;N=e+5|0;i=f;return N|0}function wMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function xMb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function yMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function zMb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function AMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function BMb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function CMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=28;else j=(c[h>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function DMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function EMb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function FMb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+4|0;f=c[e>>2]|0;g=c[f+8>>2]|0;if(!g){i=d;return}h=c[(c[f+4>>2]|0)+(g+-1<<2)>>2]|0;j=c[b>>2]|0;k=c[j+8>>2]|0;if(k>>>0>h>>>0){l=b+36|0;m=b+20|0;n=k;k=j;do{if(!n){o=5;break}j=n+-1|0;p=c[k+4>>2]|0;if((a[p+(j<<3)+4>>0]|0)!=0?(a[p+(j<<3)+5>>0]|0)!=0:0){j=c[m>>2]|0;mo[c[(c[j>>2]|0)+40>>2]&4095](j)|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=k;r=n}c[q+8>>2]=r+-1;k=c[b>>2]|0;n=c[k+8>>2]|0;a[l>>0]=1;if(!n)break;if(!(a[(c[k+4>>2]|0)+(n+-1<<3)+5>>0]|0))a[l>>0]=0}while(n>>>0>h>>>0);if((o|0)==5)a[l>>0]=1;l=c[e>>2]|0;s=l;t=c[l+8>>2]|0}else{s=f;t=g}c[s+8>>2]=t+-1;i=d;return}function GMb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+4|0;f=c[e>>2]|0;g=c[f+8>>2]|0;if(!g){i=d;return}h=c[(c[f+4>>2]|0)+(g+-1<<2)>>2]|0;j=c[b>>2]|0;k=c[j+8>>2]|0;if(k>>>0>h>>>0){l=b+36|0;m=b+20|0;n=k;k=j;do{if(!n){o=5;break}j=n+-1|0;p=c[k+4>>2]|0;if((a[p+(j<<3)+4>>0]|0)!=0?(a[p+(j<<3)+5>>0]|0)!=0:0){j=c[m>>2]|0;mo[c[(c[j>>2]|0)+40>>2]&4095](j)|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=k;r=n}c[q+8>>2]=r+-1;k=c[b>>2]|0;n=c[k+8>>2]|0;a[l>>0]=1;if(!n)break;if(!(a[(c[k+4>>2]|0)+(n+-1<<3)+5>>0]|0))a[l>>0]=0}while(n>>>0>h>>>0);if((o|0)==5)a[l>>0]=1;l=c[e>>2]|0;s=l;t=c[l+8>>2]|0}else{s=f;t=g}c[s+8>>2]=t+-1;i=d;return}function HMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function IMb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=0;f=i;i=i+272|0;d=f+8|0;g=f;h=c[b+4>>2]|0;j=c[(c[b>>2]|0)+8>>2]|0;c[d>>2]=j;k=h+8|0;l=c[k>>2]|0;if((c[h+12>>2]&2147483647)>>>0>l>>>0){m=(c[h+4>>2]|0)+(l<<2)|0;if(!m)n=l;else{c[m>>2]=j;n=c[k>>2]|0}c[k>>2]=n+1}else QAb(h,d)|0;h=c[b>>2]|0;n=c[h+8>>2]|0;if((n|0)!=0?(k=n+-1|0,j=c[h+4>>2]|0,h=j+(k<<3)|0,(a[j+(k<<3)+4>>0]|0)==0):0){k=b+36|0;if(!(a[k>>0]|0)){o=n;p=j;q=0}else{j=c[b+20>>2]|0;n=(_n[c[(c[j>>2]|0)+16>>2]&4095](j,c[h>>2]|0)|0)&1;a[k>>0]=n;h=c[b>>2]|0;o=c[h+8>>2]|0;p=c[h+4>>2]|0;q=n}a[p+(o+-1<<3)+5>>0]=q;q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0}k=b+36|0;if(!(a[k>>0]|0)){_Nb(b);i=f;return}HMb(b,515152);if(!(a[k>>0]|0))r=0;else{q=c[b+20>>2]|0;o=(mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)&1;a[k>>0]=o;r=o}o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+5>>0]=r;r=c[b>>2]|0;a[(c[r+4>>2]|0)+((c[r+8>>2]|0)+-1<<3)+4>>0]=a[k>>0]|0;if(!(a[k>>0]|0)){_Nb(b);i=f;return}r=b+20|0;o=b+24|0;q=e+12|0;e=d+255|0;s=ea(0.0);p=0;while(1){n=c[r>>2]|0;h=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;if((h|0)!=0?(n=a[h>>0]|0,n<<24>>24!=0):0){j=h;h=n;while(1){n=j+1|0;if(!(FDi(h&255)|0)){t=j;break}h=a[n>>0]|0;if(!(h<<24>>24)){t=n;break}else j=n}PEi(d|0,0,256)|0;c[g>>2]=e;j=a[t>>0]|0;a:do if(!(j<<24>>24))u=d;else{h=t;n=j;m=d;while(1){l=(FDi(n&255)|0)==0;if(!(l&m>>>0<(c[g>>2]|0)>>>0)){u=m;break a}l=m+1|0;a[m>>0]=a[h>>0]|0;h=h+1|0;n=a[h>>0]|0;if(!(n<<24>>24)){u=l;break}else m=l}}while(0);a[u>>0]=0;v=ea(+yEi(d,g))}else v=s;go[c[(c[q>>2]|0)+8>>2]&63](c[o>>2]|0,p,v);if(!(a[k>>0]|0)){w=26;break}j=c[r>>2]|0;if(mo[c[(c[j>>2]|0)+24>>2]&4095](j)|0){s=v;p=p+1|0}else{w=26;break}}if((w|0)==26){_Nb(b);i=f;return}}function JMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=1;else h=(c[g>>2]|0)+1|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}f=(GEi(k,3655040)|0)==0;In[c[d+20>>2]&4095](c[b+24>>2]|0,f);i=e;return}function KMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=2;else h=(c[g>>2]|0)+2|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}f=(GEi(k,3655040)|0)==0;In[c[d+20>>2]&4095](c[b+24>>2]|0,f);i=e;return}function LMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=4;else j=(c[h>>2]|0)+4|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function MMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=8;else j=(c[h>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function NMb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+272|0;f=e+8|0;h=e;c[f>>2]=0;if(!(a[b+36>>0]|0)){j=0;i=e;return j|0}k=c[b+20>>2]|0;l=c[b>>2]|0;b=c[l+8>>2]|0;if(!b)m=515864;else m=c[(c[l+4>>2]|0)+(b+-1<<3)>>2]|0;b=xo[c[(c[k>>2]|0)+8>>2]&2047](k,m,f)|0;m=c[f>>2]|0;k=b?m:0;if(!k){j=0;i=e;return j|0}b=a[k>>0]|0;if(!(b<<24>>24)){j=0;i=e;return j|0}k=m;m=b;while(1){b=k+1|0;if(!(FDi(m&255)|0)){n=k;break}m=a[b>>0]|0;if(!(m<<24>>24)){n=b;break}else k=b}PEi(f|0,0,256)|0;c[h>>2]=f+255;k=a[n>>0]|0;a:do if(!(k<<24>>24))o=f;else{m=n;b=k;l=f;while(1){p=(FDi(b&255)|0)==0;if(!(p&l>>>0<(c[h>>2]|0)>>>0)){o=l;break a}p=l+1|0;a[l>>0]=a[m>>0]|0;m=m+1|0;b=a[m>>0]|0;if(!(b<<24>>24)){o=p;break}else l=p}}while(0);a[o>>0]=0;g[d>>2]=ea(+yEi(f,h));j=1;i=e;return j|0}function OMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=16;else j=(c[h>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function PMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=28;else h=(c[g>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}f=(GEi(k,3655040)|0)==0;In[c[d+20>>2]&4095](c[b+24>>2]|0,f);i=e;return}function QMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=29;else h=(c[g>>2]|0)+29|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}f=(GEi(k,3655040)|0)==0;In[c[d+20>>2]&4095](c[b+24>>2]|0,f);i=e;return}function RMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+44>>2]|0;if(!g)h=30;else h=(c[g>>2]|0)+30|0;a[d>>0]=1;c[d+4>>2]=h;h=c[b+40>>2]|0;if(h)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}h=c[b+20>>2]|0;g=c[b>>2]|0;j=c[g+8>>2]|0;if(!j)k=515864;else k=c[(c[g+4>>2]|0)+(j+-1<<3)>>2]|0;j=xo[c[(c[h>>2]|0)+8>>2]&2047](h,k,f)|0;k=j?c[f>>2]|0:0;if(!k){i=e;return}if(!(a[k>>0]|0)){i=e;return}f=(GEi(k,3655040)|0)==0;In[c[d+20>>2]&4095](c[b+24>>2]|0,f);i=e;return}function SMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=32;else j=(c[h>>2]|0)+32|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function TMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=36;else j=(c[h>>2]|0)+36|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function UMb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0.0,J=0,K=0;f=i;i=i+208|0;d=f;j=f+80|0;l=f+12|0;m=f+8|0;n=f+48|0;o=b+8|0;p=e+12|0;e=mo[c[(c[p>>2]|0)+20>>2]&4095](c[o>>2]|0)|0;q=l+20|0;r=l+24|0;c[l+28>>2]=0;s=l+32|0;a[q>>0]=1;c[r>>2]=l;c[s>>2]=5;g[m>>2]=ea(0.0);sIb(l,e,m);if(e){m=d+4|0;t=b+4|0;u=b+12|0;v=0;do{w=n+0|0;x=w+32|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));c[d>>2]=v;TUa(n,0,515856,d)|0;y=c[b>>2]|0;z=c[y+8>>2]|0;if(z){A=z+-1|0;B=c[y+4>>2]|0;if(!(a[B+(A<<3)+4>>0]|0)){C=c[t>>2]|0;In[c[(c[C>>2]|0)+16>>2]&4095](C,c[B+(A<<3)>>2]|0);A=c[b>>2]|0;a[(c[A+4>>2]|0)+((c[A+8>>2]|0)+-1<<3)+4>>0]=1;A=c[b>>2]|0;D=A;E=c[A+8>>2]|0}else{D=y;E=z}}else{D=y;E=0}c[d>>2]=n;a[m>>0]=0;y=D+8|0;if((c[D+12>>2]&2147483647)>>>0>E>>>0){z=(c[D+4>>2]|0)+(E<<3)|0;if(!z)F=E;else{A=d;B=c[A+4>>2]|0;C=z;c[C>>2]=c[A>>2];c[C+4>>2]=B;F=c[y>>2]|0}c[y>>2]=F+1}else OAb(D,d)|0;G=ea(Um[c[(c[p>>2]|0)+12>>2]&63](c[o>>2]|0,v));y=c[t>>2]|0;B=c[u>>2]|0;C=c[b>>2]|0;A=c[C+8>>2]|0;if(!A)H=515864;else H=c[(c[C+4>>2]|0)+(A+-1<<3)>>2]|0;I=+G;w=j+0|0;x=w+128|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(x|0));h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){w=c[c[B>>2]>>2]|0;x=SEi(j|0)|0;xo[w&2047](B,j,x)|0}a[d>>0]=0;xo[c[c[B>>2]>>2]&2047](B,d,1)|0;co[c[(c[y>>2]|0)+8>>2]&2047](y,H,c[B+20>>2]|0);c[B+16>>2]=0;c[B+12>>2]=0;x=c[b>>2]|0;w=c[x+8>>2]|0;if(w){if(!(a[(c[x+4>>2]|0)+(w+-1<<3)+4>>0]|0)){J=x;K=w}else{w=c[t>>2]|0;ko[c[(c[w>>2]|0)+20>>2]&4095](w);w=c[b>>2]|0;J=w;K=c[w+8>>2]|0}c[J+8>>2]=K+-1}v=v+1|0}while((v|0)!=(e|0))}e=c[s>>2]|0;if(!((e&2147483647|0)!=0&(e|0)>-1)){i=f;return}e=c[r>>2]|0;if((l|0)==(e|0)){a[q>>0]=0;i=f;return}if(!e){i=f;return}q=mKa()|0;In[c[(c[q>>2]|0)+12>>2]&4095](q,e);i=f;return}function VMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=8;else l=(c[j>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function WMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function XMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=16;else l=(c[j>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function YMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=20;else l=(c[j>>2]|0)+20|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function ZMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=24;else l=(c[j>>2]|0)+24|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function _Mb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=28;else l=(c[j>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function $Mb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0.0,C=0,D=0,E=0,F=0;g=i;i=i+144|0;d=g;j=g+16|0;l=g+8|0;m=c[e>>2]|0;n=c[b>>2]|0;o=c[n+8>>2]|0;if(o){p=o+-1|0;q=c[n+4>>2]|0;if(!(a[q+(p<<3)+4>>0]|0)){r=c[b+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[q+(p<<3)>>2]|0);p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=1;p=c[b>>2]|0;s=p;t=c[p+8>>2]|0}else{s=n;t=o}}else{s=n;t=0}c[d>>2]=m;a[d+4>>0]=0;m=s+8|0;if((c[s+12>>2]&2147483647)>>>0>t>>>0){n=(c[s+4>>2]|0)+(t<<3)|0;if(!n)u=t;else{t=d;o=c[t+4>>2]|0;p=n;c[p>>2]=c[t>>2];c[p+4>>2]=o;u=c[m>>2]|0}c[m>>2]=u+1}else OAb(s,d)|0;c[l>>2]=527;s=c[b+20>>2]|0;u=(s|0)==0?l:s;s=c[f>>2]|0;if(s){l=d+4|0;m=b+8|0;o=e+12|0;e=b+4|0;p=b+12|0;t=f;f=s;do{s=c[b>>2]|0;n=c[s+8>>2]|0;if(n){q=n+-1|0;r=c[s+4>>2]|0;if(!(a[r+(q<<3)+4>>0]|0)){v=c[e>>2]|0;In[c[(c[v>>2]|0)+16>>2]&4095](v,c[r+(q<<3)>>2]|0);q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=1;q=c[b>>2]|0;w=q;x=c[q+8>>2]|0}else{w=s;x=n}}else{w=s;x=0}c[d>>2]=f;a[l>>0]=0;s=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){n=(c[w+4>>2]|0)+(x<<3)|0;if(!n)y=x;else{q=d;r=c[q+4>>2]|0;v=n;c[v>>2]=c[q>>2];c[v+4>>2]=r;y=c[s>>2]|0}c[s>>2]=y+1}else OAb(w,d)|0;z=ea(Um[c[o>>2]&63](c[m>>2]|0,c[t+4>>2]|0));s=c[e>>2]|0;r=c[p>>2]|0;v=c[b>>2]|0;q=c[v+8>>2]|0;if(!q)A=515864;else A=c[(c[v+4>>2]|0)+(q+-1<<3)>>2]|0;B=+z;q=j+0|0;v=q+128|0;do{a[q>>0]=0;q=q+1|0}while((q|0)<(v|0));h[k>>3]=B;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){q=c[c[r>>2]>>2]|0;v=SEi(j|0)|0;xo[q&2047](r,j,v)|0}a[d>>0]=0;xo[c[c[r>>2]>>2]&2047](r,d,1)|0;co[c[(c[s>>2]|0)+8>>2]&2047](s,A,c[r+20>>2]|0);c[r+16>>2]=0;c[r+12>>2]=0;v=c[b>>2]|0;q=c[v+8>>2]|0;if(q){if(!(a[(c[v+4>>2]|0)+(q+-1<<3)+4>>0]|0)){C=v;D=q}else{q=c[e>>2]|0;ko[c[(c[q>>2]|0)+20>>2]&4095](q);q=c[b>>2]|0;C=q;D=c[q+8>>2]|0}c[C+8>>2]=D+-1}c[u>>2]=(c[u>>2]|0)+1;t=t+8|0;f=c[t>>2]|0}while((f|0)!=0)}f=c[b>>2]|0;t=c[f+8>>2]|0;if(!t){i=g;return}if(!(a[(c[f+4>>2]|0)+(t+-1<<3)+4>>0]|0)){E=f;F=t}else{t=c[b+4>>2]|0;ko[c[(c[t>>2]|0)+20>>2]&4095](t);t=c[b>>2]|0;E=t;F=c[t+8>>2]|0}c[E+8>>2]=F+-1;i=g;return}function aNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=128;else l=(c[j>>2]|0)+128|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function bNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=132;else j=(c[h>>2]|0)+132|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function cNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=136;else l=(c[j>>2]|0)+136|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function dNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=0;else l=c[j>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function eNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=8;else j=(c[h>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function fNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=0;else l=c[j>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function gNb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0.0,C=0,D=0,E=0,F=0;g=i;i=i+144|0;d=g;j=g+16|0;l=g+8|0;m=c[e>>2]|0;n=c[b>>2]|0;o=c[n+8>>2]|0;if(o){p=o+-1|0;q=c[n+4>>2]|0;if(!(a[q+(p<<3)+4>>0]|0)){r=c[b+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[q+(p<<3)>>2]|0);p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=1;p=c[b>>2]|0;s=p;t=c[p+8>>2]|0}else{s=n;t=o}}else{s=n;t=0}c[d>>2]=m;a[d+4>>0]=0;m=s+8|0;if((c[s+12>>2]&2147483647)>>>0>t>>>0){n=(c[s+4>>2]|0)+(t<<3)|0;if(!n)u=t;else{t=d;o=c[t+4>>2]|0;p=n;c[p>>2]=c[t>>2];c[p+4>>2]=o;u=c[m>>2]|0}c[m>>2]=u+1}else OAb(s,d)|0;c[l>>2]=534;s=c[b+20>>2]|0;u=(s|0)==0?l:s;s=c[f>>2]|0;if(s){l=d+4|0;m=b+8|0;o=e+12|0;e=b+4|0;p=b+12|0;t=f;f=s;do{s=c[b>>2]|0;n=c[s+8>>2]|0;if(n){q=n+-1|0;r=c[s+4>>2]|0;if(!(a[r+(q<<3)+4>>0]|0)){v=c[e>>2]|0;In[c[(c[v>>2]|0)+16>>2]&4095](v,c[r+(q<<3)>>2]|0);q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=1;q=c[b>>2]|0;w=q;x=c[q+8>>2]|0}else{w=s;x=n}}else{w=s;x=0}c[d>>2]=f;a[l>>0]=0;s=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){n=(c[w+4>>2]|0)+(x<<3)|0;if(!n)y=x;else{q=d;r=c[q+4>>2]|0;v=n;c[v>>2]=c[q>>2];c[v+4>>2]=r;y=c[s>>2]|0}c[s>>2]=y+1}else OAb(w,d)|0;z=ea(Um[c[o>>2]&63](c[m>>2]|0,c[t+4>>2]|0));s=c[e>>2]|0;r=c[p>>2]|0;v=c[b>>2]|0;q=c[v+8>>2]|0;if(!q)A=515864;else A=c[(c[v+4>>2]|0)+(q+-1<<3)>>2]|0;B=+z;q=j+0|0;v=q+128|0;do{a[q>>0]=0;q=q+1|0}while((q|0)<(v|0));h[k>>3]=B;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){q=c[c[r>>2]>>2]|0;v=SEi(j|0)|0;xo[q&2047](r,j,v)|0}a[d>>0]=0;xo[c[c[r>>2]>>2]&2047](r,d,1)|0;co[c[(c[s>>2]|0)+8>>2]&2047](s,A,c[r+20>>2]|0);c[r+16>>2]=0;c[r+12>>2]=0;v=c[b>>2]|0;q=c[v+8>>2]|0;if(q){if(!(a[(c[v+4>>2]|0)+(q+-1<<3)+4>>0]|0)){C=v;D=q}else{q=c[e>>2]|0;ko[c[(c[q>>2]|0)+20>>2]&4095](q);q=c[b>>2]|0;C=q;D=c[q+8>>2]|0}c[C+8>>2]=D+-1}c[u>>2]=(c[u>>2]|0)+1;t=t+8|0;f=c[t>>2]|0}while((f|0)!=0)}f=c[b>>2]|0;t=c[f+8>>2]|0;if(!t){i=g;return}if(!(a[(c[f+4>>2]|0)+(t+-1<<3)+4>>0]|0)){E=f;F=t}else{t=c[b+4>>2]|0;ko[c[(c[t>>2]|0)+20>>2]&4095](t);t=c[b>>2]|0;E=t;F=c[t+8>>2]|0}c[E+8>>2]=F+-1;i=g;return}function hNb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0.0,C=0,D=0,E=0,F=0;g=i;i=i+144|0;d=g;j=g+16|0;l=g+8|0;m=c[e>>2]|0;n=c[b>>2]|0;o=c[n+8>>2]|0;if(o){p=o+-1|0;q=c[n+4>>2]|0;if(!(a[q+(p<<3)+4>>0]|0)){r=c[b+4>>2]|0;In[c[(c[r>>2]|0)+16>>2]&4095](r,c[q+(p<<3)>>2]|0);p=c[b>>2]|0;a[(c[p+4>>2]|0)+((c[p+8>>2]|0)+-1<<3)+4>>0]=1;p=c[b>>2]|0;s=p;t=c[p+8>>2]|0}else{s=n;t=o}}else{s=n;t=0}c[d>>2]=m;a[d+4>>0]=0;m=s+8|0;if((c[s+12>>2]&2147483647)>>>0>t>>>0){n=(c[s+4>>2]|0)+(t<<3)|0;if(!n)u=t;else{t=d;o=c[t+4>>2]|0;p=n;c[p>>2]=c[t>>2];c[p+4>>2]=o;u=c[m>>2]|0}c[m>>2]=u+1}else OAb(s,d)|0;c[l>>2]=535;s=c[b+20>>2]|0;u=(s|0)==0?l:s;s=c[f>>2]|0;if(s){l=d+4|0;m=b+8|0;o=e+12|0;e=b+4|0;p=b+12|0;t=f;f=s;do{s=c[b>>2]|0;n=c[s+8>>2]|0;if(n){q=n+-1|0;r=c[s+4>>2]|0;if(!(a[r+(q<<3)+4>>0]|0)){v=c[e>>2]|0;In[c[(c[v>>2]|0)+16>>2]&4095](v,c[r+(q<<3)>>2]|0);q=c[b>>2]|0;a[(c[q+4>>2]|0)+((c[q+8>>2]|0)+-1<<3)+4>>0]=1;q=c[b>>2]|0;w=q;x=c[q+8>>2]|0}else{w=s;x=n}}else{w=s;x=0}c[d>>2]=f;a[l>>0]=0;s=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){n=(c[w+4>>2]|0)+(x<<3)|0;if(!n)y=x;else{q=d;r=c[q+4>>2]|0;v=n;c[v>>2]=c[q>>2];c[v+4>>2]=r;y=c[s>>2]|0}c[s>>2]=y+1}else OAb(w,d)|0;z=ea(Um[c[o>>2]&63](c[m>>2]|0,c[t+4>>2]|0));s=c[e>>2]|0;r=c[p>>2]|0;v=c[b>>2]|0;q=c[v+8>>2]|0;if(!q)A=515864;else A=c[(c[v+4>>2]|0)+(q+-1<<3)>>2]|0;B=+z;q=j+0|0;v=q+128|0;do{a[q>>0]=0;q=q+1|0}while((q|0)<(v|0));h[k>>3]=B;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];TUa(j,0,515880,d)|0;if(a[j>>0]|0){q=c[c[r>>2]>>2]|0;v=SEi(j|0)|0;xo[q&2047](r,j,v)|0}a[d>>0]=0;xo[c[c[r>>2]>>2]&2047](r,d,1)|0;co[c[(c[s>>2]|0)+8>>2]&2047](s,A,c[r+20>>2]|0);c[r+16>>2]=0;c[r+12>>2]=0;v=c[b>>2]|0;q=c[v+8>>2]|0;if(q){if(!(a[(c[v+4>>2]|0)+(q+-1<<3)+4>>0]|0)){C=v;D=q}else{q=c[e>>2]|0;ko[c[(c[q>>2]|0)+20>>2]&4095](q);q=c[b>>2]|0;C=q;D=c[q+8>>2]|0}c[C+8>>2]=D+-1}c[u>>2]=(c[u>>2]|0)+1;t=t+8|0;f=c[t>>2]|0}while((f|0)!=0)}f=c[b>>2]|0;t=c[f+8>>2]|0;if(!t){i=g;return}if(!(a[(c[f+4>>2]|0)+(t+-1<<3)+4>>0]|0)){E=f;F=t}else{t=c[b+4>>2]|0;ko[c[(c[t>>2]|0)+20>>2]&4095](t);t=c[b>>2]|0;E=t;F=c[t+8>>2]|0}c[E+8>>2]=F+-1;i=g;return}function iNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=0;else l=c[j>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function jNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=4;else l=(c[j>>2]|0)+4|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function kNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=8;else l=(c[j>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function lNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function mNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=16;else l=(c[j>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function nNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=20;else l=(c[j>>2]|0)+20|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function oNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=0;else l=c[j>>2]|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function pNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=4;else l=(c[j>>2]|0)+4|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function qNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=8;else l=(c[j>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function rNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function sNb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;a[f>>0]=0;c[f+4>>2]=0;g=f+8|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];$Nb(b,c[d>>2]|0);aOb(b,f);f=c[b>>2]|0;d=c[f+8>>2]|0;if(!d){a[b+36>>0]=1;i=e;return}g=d+-1|0;h=c[f+4>>2]|0;if((a[h+(g<<3)+4>>0]|0)!=0?(a[h+(g<<3)+5>>0]|0)!=0:0){g=c[b+20>>2]|0;mo[c[(c[g>>2]|0)+40>>2]&4095](g)|0;g=c[b>>2]|0;j=g;k=c[g+8>>2]|0}else{j=f;k=d}c[j+8>>2]=k+-1;k=c[b>>2]|0;j=c[k+8>>2]|0;d=b+36|0;a[d>>0]=1;if(!j){i=e;return}if(a[(c[k+4>>2]|0)+(j+-1<<3)+5>>0]|0){i=e;return}a[d>>0]=0;i=e;return}function tNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d*48|0;h=b+240|0;if(!((a[h>>0]|0)==0&g>>>0<241))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?516472:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+248>>2]|0;h=f+(j*48|0)|0;n=b+244|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j){k=j+0|0;l=g+0|0;m=k+48|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0))}j=j+48|0;if(j>>>0>=h>>>0)break;else g=g+48|0}}g=b+252|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+240>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function uNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=8;else l=(c[j>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function vNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function wNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=16;else l=(c[j>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function xNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=20;else l=(c[j>>2]|0)+20|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function yNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=24;else l=(c[j>>2]|0)+24|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function zNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=28;else l=(c[j>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function ANb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=32;else l=(c[j>>2]|0)+32|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function BNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=36;else l=(c[j>>2]|0)+36|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function CNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d*48|0;h=b+240|0;if(!((a[h>>0]|0)==0&g>>>0<241))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?516344:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+248>>2]|0;h=f+(j*48|0)|0;n=b+244|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j){k=j+0|0;l=g+0|0;m=k+48|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0))}j=j+48|0;if(j>>>0>=h>>>0)break;else g=g+48|0}}g=b+252|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+240>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function DNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=8;else l=(c[j>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function ENb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function FNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=16;else l=(c[j>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function GNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=20;else l=(c[j>>2]|0)+20|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function HNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=24;else l=(c[j>>2]|0)+24|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function INb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=28;else l=(c[j>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function JNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=32;else l=(c[j>>2]|0)+32|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function KNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=36;else l=(c[j>>2]|0)+36|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function LNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=40;else l=(c[j>>2]|0)+40|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function MNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<6;h=b+320|0;if(!((a[h>>0]|0)==0&g>>>0<321))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?516216:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+328>>2]|0;h=f+(j<<6)|0;n=b+324|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j){k=j+0|0;l=g+0|0;m=k+64|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0))}j=j+64|0;if(j>>>0>=h>>>0)break;else g=g+64|0}}g=b+332|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+320>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function NNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function ONb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=16;else l=(c[j>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function PNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=20;else l=(c[j>>2]|0)+20|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function QNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=24;else l=(c[j>>2]|0)+24|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function RNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+144|0;f=e;g=e+8|0;h=c[b+24>>2]|0;if(!h)j=28;else j=(c[h>>2]|0)+28|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+20>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;j=mo[c[d+16>>2]&4095](c[b+8>>2]|0)|0;d=c[b+4>>2]|0;h=c[b+12>>2]|0;k=c[b>>2]|0;b=c[k+8>>2]|0;if(!b)l=515864;else l=c[(c[k+4>>2]|0)+(b+-1<<3)>>2]|0;b=g+0|0;k=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(k|0));c[f>>2]=j;TUa(g,0,515888,f)|0;if(a[g>>0]|0){j=c[c[h>>2]>>2]|0;b=SEi(g|0)|0;xo[j&2047](h,g,b)|0}a[f>>0]=0;xo[c[c[h>>2]>>2]&2047](h,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,l,c[h+20>>2]|0);c[h+16>>2]=0;c[h+12>>2]=0;i=e;return}function SNb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+224|0;j=d+8|0;l=d+88|0;m=d;n=d+16|0;o=d+56|0;p=d+24|0;q=c[e>>2]|0;r=c[b>>2]|0;s=c[r+8>>2]|0;if(s){t=s+-1|0;u=c[r+4>>2]|0;if(!(a[u+(t<<3)+4>>0]|0)){v=c[b+4>>2]|0;In[c[(c[v>>2]|0)+16>>2]&4095](v,c[u+(t<<3)>>2]|0);t=c[b>>2]|0;a[(c[t+4>>2]|0)+((c[t+8>>2]|0)+-1<<3)+4>>0]=1;t=c[b>>2]|0;w=t;x=c[t+8>>2]|0}else{w=r;x=s}}else{w=r;x=0}c[j>>2]=q;a[j+4>>0]=0;q=w+8|0;if((c[w+12>>2]&2147483647)>>>0>x>>>0){r=(c[w+4>>2]|0)+(x<<3)|0;if(!r)y=x;else{x=j;s=c[x+4>>2]|0;t=r;c[t>>2]=c[x>>2];c[t+4>>2]=s;y=c[q>>2]|0}c[q>>2]=y+1}else OAb(w,j)|0;c[n>>2]=602;w=c[b+20>>2]|0;y=(w|0)==0?n:w;if(f){w=m+4|0;n=(g|0)==0;q=b+4|0;s=j+4|0;t=b+8|0;x=e+12|0;e=b+12|0;r=0;do{u=o+0|0;v=u+32|0;do{a[u>>0]=0;u=u+1|0}while((u|0)<(v|0));c[j>>2]=r;TUa(o,0,516200,j)|0;z=c[b>>2]|0;A=c[z+8>>2]|0;if(A){B=A+-1|0;C=c[z+4>>2]|0;if(!(a[C+(B<<3)+4>>0]|0)){D=c[q>>2]|0;In[c[(c[D>>2]|0)+16>>2]&4095](D,c[C+(B<<3)>>2]|0);B=c[b>>2]|0;a[(c[B+4>>2]|0)+((c[B+8>>2]|0)+-1<<3)+4>>0]=1;B=c[b>>2]|0;E=B;F=c[B+8>>2]|0}else{E=z;F=A}}else{E=z;F=0}c[m>>2]=o;a[w>>0]=0;z=E+8|0;if((c[E+12>>2]&2147483647)>>>0>F>>>0){A=(c[E+4>>2]|0)+(F<<3)|0;if(!A)G=F;else{B=m;C=c[B+4>>2]|0;D=A;c[D>>2]=c[B>>2];c[D+4>>2]=C;G=c[z>>2]|0}c[z>>2]=G+1}else OAb(E,m)|0;if(!n){z=0;do{u=p+0|0;v=u+32|0;do{a[u>>0]=0;u=u+1|0}while((u|0)<(v|0));c[j>>2]=z;TUa(p,0,516208,j)|0;C=c[b>>2]|0;D=c[C+8>>2]|0;if(D){B=D+-1|0;A=c[C+4>>2]|0;if(!(a[A+(B<<3)+4>>0]|0)){H=c[q>>2]|0;In[c[(c[H>>2]|0)+16>>2]&4095](H,c[A+(B<<3)>>2]|0);B=c[b>>2]|0;a[(c[B+4>>2]|0)+((c[B+8>>2]|0)+-1<<3)+4>>0]=1;B=c[b>>2]|0;I=B;J=c[B+8>>2]|0}else{I=C;J=D}}else{I=C;J=0}c[j>>2]=p;a[s>>0]=0;C=I+8|0;if((c[I+12>>2]&2147483647)>>>0>J>>>0){D=(c[I+4>>2]|0)+(J<<3)|0;if(!D)K=J;else{B=j;A=c[B+4>>2]|0;H=D;c[H>>2]=c[B>>2];c[H+4>>2]=A;K=c[C>>2]|0}c[C>>2]=K+1}else OAb(I,j)|0;L=ea(tn[c[x>>2]&15](c[t>>2]|0,r,z));C=c[q>>2]|0;A=c[e>>2]|0;H=c[b>>2]|0;B=c[H+8>>2]|0;if(!B)M=515864;else M=c[(c[H+4>>2]|0)+(B+-1<<3)>>2]|0;N=+L;u=l+0|0;v=u+128|0;do{a[u>>0]=0;u=u+1|0}while((u|0)<(v|0));h[k>>3]=N;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];TUa(l,0,515880,j)|0;if(a[l>>0]|0){B=c[c[A>>2]>>2]|0;H=SEi(l|0)|0;xo[B&2047](A,l,H)|0}a[j>>0]=0;xo[c[c[A>>2]>>2]&2047](A,j,1)|0;co[c[(c[C>>2]|0)+8>>2]&2047](C,M,c[A+20>>2]|0);c[A+16>>2]=0;c[A+12>>2]=0;H=c[b>>2]|0;B=c[H+8>>2]|0;if(B){if(!(a[(c[H+4>>2]|0)+(B+-1<<3)+4>>0]|0)){O=H;P=B}else{B=c[q>>2]|0;ko[c[(c[B>>2]|0)+20>>2]&4095](B);B=c[b>>2]|0;O=B;P=c[B+8>>2]|0}c[O+8>>2]=P+-1}c[y>>2]=(c[y>>2]|0)+1;z=z+1|0}while((z|0)!=(g|0))}z=c[b>>2]|0;u=c[z+8>>2]|0;if(u){if(!(a[(c[z+4>>2]|0)+(u+-1<<3)+4>>0]|0)){Q=z;R=u}else{u=c[q>>2]|0;ko[c[(c[u>>2]|0)+20>>2]&4095](u);u=c[b>>2]|0;Q=u;R=c[u+8>>2]|0}c[Q+8>>2]=R+-1}r=r+1|0}while((r|0)!=(f|0))}f=c[b>>2]|0;r=c[f+8>>2]|0;if(!r){i=d;return}if(!(a[(c[f+4>>2]|0)+(r+-1<<3)+4>>0]|0)){S=f;T=r}else{r=c[b+4>>2]|0;ko[c[(c[r>>2]|0)+20>>2]&4095](r);r=c[b>>2]|0;S=r;T=c[r+8>>2]|0}c[S+8>>2]=T+-1;i=d;return}function TNb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(!d)f=0;else{h=d*12|0;j=b+60|0;if(!((a[j>>0]|0)==0&h>>>0<61))if(!h)k=0;else{l=mKa()|0;m=c[(c[l>>2]|0)+8>>2]|0;n=pKa()|0;o=mo[c[(c[n>>2]|0)+24>>2]&4095](n)|0;k=Bn[m&255](l,h,o?516096:544544,537640,558)|0}else{a[j>>0]=1;k=b}f=k}k=c[b+68>>2]|0;j=f+(k*12|0)|0;o=b+64|0;if((k|0)>0){k=f;h=c[o>>2]|0;while(1){if(k){g[k>>2]=ea(g[h>>2]);g[k+4>>2]=ea(g[h+4>>2]);g[k+8>>2]=ea(g[h+8>>2])}k=k+12|0;if(k>>>0>=j>>>0)break;else h=h+12|0}}h=b+72|0;if((c[h>>2]|0)<=-1){c[o>>2]=f;c[h>>2]=d;i=e;return}j=c[o>>2]|0;if((b|0)==(j|0)){a[b+60>>0]=0;c[o>>2]=f;c[h>>2]=d;i=e;return}if(!j){c[o>>2]=f;c[h>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,j);c[o>>2]=f;c[h>>2]=d;i=e;return}function UNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<2;h=b+20|0;if(!((a[h>>0]|0)==0&g>>>0<21))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?516016:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+28>>2]|0;h=f+(j<<2)|0;n=b+24|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j)c[j>>2]=c[g>>2];j=j+4|0;if(j>>>0>=h>>>0)break;else g=g+4|0}}g=b+32|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+20>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function VNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!d)f=0;else{g=d<<4;h=b+80|0;if(!((a[h>>0]|0)==0&g>>>0<81))if(!g)j=0;else{k=mKa()|0;l=c[(c[k>>2]|0)+8>>2]|0;m=pKa()|0;n=mo[c[(c[m>>2]|0)+24>>2]&4095](m)|0;j=Bn[l&255](k,g,n?515896:544544,537640,558)|0}else{a[h>>0]=1;j=b}f=j}j=c[b+88>>2]|0;h=f+(j<<4)|0;n=b+84|0;if((j|0)>0){j=f;g=c[n>>2]|0;while(1){if(j){c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2]}j=j+16|0;if(j>>>0>=h>>>0)break;else g=g+16|0}}g=b+92|0;if((c[g>>2]|0)<=-1){c[n>>2]=f;c[g>>2]=d;i=e;return}h=c[n>>2]|0;if((b|0)==(h|0)){a[b+80>>0]=0;c[n>>2]=f;c[g>>2]=d;i=e;return}if(!h){c[n>>2]=f;c[g>>2]=d;i=e;return}b=mKa()|0;In[c[(c[b>>2]|0)+12>>2]&4095](b,h);c[n>>2]=f;c[g>>2]=d;i=e;return}function WNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=4;else l=(c[j>>2]|0)+4|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function XNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=8;else l=(c[j>>2]|0)+8|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function YNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=12;else l=(c[j>>2]|0)+12|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function ZNb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=Im,n=0,o=0.0;e=i;i=i+144|0;f=e;g=e+8|0;j=c[b+24>>2]|0;if(!j)l=16;else l=(c[j>>2]|0)+16|0;a[d>>0]=1;c[d+4>>2]=l;l=c[b+20>>2]|0;if(l)c[l>>2]=(c[l>>2]|0)+1;m=ea(Kn[c[d+16>>2]&255](c[b+8>>2]|0));d=c[b+4>>2]|0;l=c[b+12>>2]|0;j=c[b>>2]|0;b=c[j+8>>2]|0;if(!b)n=515864;else n=c[(c[j+4>>2]|0)+(b+-1<<3)>>2]|0;o=+m;b=g+0|0;j=b+128|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(j|0));h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];TUa(g,0,515880,f)|0;if(a[g>>0]|0){b=c[c[l>>2]>>2]|0;j=SEi(g|0)|0;xo[b&2047](l,g,j)|0}a[f>>0]=0;xo[c[c[l>>2]>>2]&2047](l,f,1)|0;co[c[(c[d>>2]|0)+8>>2]&2047](d,n,c[l+20>>2]|0);c[l+16>>2]=0;c[l+12>>2]=0;i=e;return}function _Nb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+4|0;f=c[e>>2]|0;g=c[f+8>>2]|0;if(!g){i=d;return}h=c[(c[f+4>>2]|0)+(g+-1<<2)>>2]|0;j=c[b>>2]|0;k=c[j+8>>2]|0;if(k>>>0>h>>>0){l=b+36|0;m=b+20|0;n=k;k=j;do{if(!n){o=5;break}j=n+-1|0;p=c[k+4>>2]|0;if((a[p+(j<<3)+4>>0]|0)!=0?(a[p+(j<<3)+5>>0]|0)!=0:0){j=c[m>>2]|0;mo[c[(c[j>>2]|0)+40>>2]&4095](j)|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=k;r=n}c[q+8>>2]=r+-1;k=c[b>>2]|0;n=c[k+8>>2]|0;a[l>>0]=1;if(!n)break;if(!(a[(c[k+4>>2]|0)+(n+-1<<3)+5>>0]|0))a[l>>0]=0}while(n>>>0>h>>>0);if((o|0)==5)a[l>>0]=1;l=c[e>>2]|0;s=l;t=c[l+8>>2]|0}else{s=f;t=g}c[s+8>>2]=t+-1;i=d;return}function $Nb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b>>2]|0;h=c[g+8>>2]|0;if(h){j=h+-1|0;k=c[g+4>>2]|0;l=k+(j<<3)|0;if(!(a[k+(j<<3)+4>>0]|0)){j=b+36|0;if(!(a[j>>0]|0)){m=h;n=k;o=0}else{k=c[b+20>>2]|0;p=(_n[c[(c[k>>2]|0)+16>>2]&4095](k,c[l>>2]|0)|0)&1;a[j>>0]=p;l=c[b>>2]|0;m=c[l+8>>2]|0;n=c[l+4>>2]|0;o=p}a[n+(m+-1<<3)+5>>0]=o;o=c[b>>2]|0;a[(c[o+4>>2]|0)+((c[o+8>>2]|0)+-1<<3)+4>>0]=a[j>>0]|0;j=c[b>>2]|0;q=j;r=c[j+8>>2]|0}else{q=g;r=h}}else{q=g;r=0}g=a[b+36>>0]|0;c[f>>2]=d;a[f+4>>0]=0;a[f+5>>0]=g;g=q+8|0;if((c[q+12>>2]&2147483647)>>>0<=r>>>0){cHb(q,f)|0;i=e;return}d=(c[q+4>>2]|0)+(r<<3)|0;if(!d)s=r;else{r=f;f=c[r+4>>2]|0;q=d;c[q>>2]=c[r>>2];c[q+4>>2]=f;s=c[g>>2]|0}c[g>>2]=s+1;i=e;return}function aOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b+44>>2]|0;if(!h)j=0;else j=c[h>>2]|0;a[d>>0]=1;c[d+4>>2]=j;j=c[b+40>>2]|0;if(j)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=0;if(!(a[b+36>>0]|0)){i=e;return}j=c[b+20>>2]|0;h=c[b>>2]|0;k=c[h+8>>2]|0;if(!k)l=515864;else l=c[(c[h+4>>2]|0)+(k+-1<<3)>>2]|0;k=xo[c[(c[j>>2]|0)+8>>2]&2047](j,l,g)|0;l=k?c[g>>2]|0:0;if(!l){i=e;return}if(!(a[l>>0]|0)){i=e;return}c[f>>2]=l;g=CEi(l,f,10)|0;In[c[d+20>>2]&4095](c[b+24>>2]|0,g);i=e;return}function bOb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;d=i;i=i+16|0;h=d+4|0;j=d;k=c[b>>2]|0;b=fOb()|0;c[j>>2]=k;c[h+0>>2]=c[j+0>>2];j=gOb(b,a,e,h,0,f,g)|0;i=d;return j|0}function cOb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=fOb()|0;c[k>>2]=c[d>>2];c[j+0>>2]=c[k+0>>2];k=gOb(l,a,b,j,e,f,g)|0;i=h;return k|0}function dOb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=i;i=i+16|0;f=g+4|0;e=g;d=c[b>>2]|0;b=fOb()|0;c[e>>2]=d;c[f+0>>2]=c[e+0>>2];kOb(b,a,f);i=g;return}function eOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=fOb()|0;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];kOb(g,a,e);i=d;return}function fOb(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[137496]|0;if(d){e=d;i=b;return e|0}LVc();d=c[137494]|0;f=d+3168|0;c[137494]=f;if(f>>>0>(549976|0)>>>0)hi();if(!d)g=0;else{c[d>>2]=0;a[d+5>>0]=0;a[d+6>>0]=0;c[d+8>>2]=0;c[d+12>>2]=0;PEi(d+2276|0,0,816)|0;PEi(d+20|0,0,196)|0;f=c[137494]|0;h=f+80|0;c[137494]=h;if(h>>>0>(549976|0)>>>0)hi();if(!f)j=0;else{bPb(f,1048576,0,1,0,549992);j=f}f=d+16|0;c[f>>2]=j;c[d+2268>>2]=0;j=0;do{h=j;j=j+1|0;c[d+(h<<2)+220>>2]=j}while((j|0)!=512);j=c[f>>2]|0;f=0;do{c[d+(f<<3)+2276>>2]=j;f=f+1|0}while((f|0)!=102);c[d+3092>>2]=-1;g=d}c[137496]=g;e=g;i=b;return e|0}function gOb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k+8|0;m=k+4|0;n=k;o=(d|0)==0?1:d;d=(e+-1|15)+1|0;e=c[f>>2]|0;f=(e|0)<102;if(f)p=c[b+(e<<3)+2280>>2]&2;else p=0;if(!(a[b+6>>0]|0)){if(p){p=b+20|0;c[p>>2]=(c[p>>2]|0)+1}p=c[b+16>>2]|0;q=xo[c[(c[p>>2]|0)+8>>2]&2047](p,o,d)|0;i=k;return q|0}if((e|0)==89){p=DPb(c[b+8>>2]|0,o,d)|0;if(p){q=p;i=k;return q|0}c[n>>2]=0;c[l+0>>2]=c[n+0>>2];q=gOb(b,o,d,l,g,h,j)|0;i=k;return q|0}if(f)r=b+(e<<3)+2276|0;else r=b+(e+-102<<2)+220|0;b=c[r>>2]|0;r=xo[c[(c[b>>2]|0)+8>>2]&2047](b,o,d)|0;if(!((r|0)!=0|(g&1|0)==0)){q=0;i=k;return q|0}if(r){q=r;i=k;return q|0}c[m>>2]=e;c[l+0>>2]=c[m+0>>2];tOb(o,d,l,j,h);q=0;i=k;return q|0}function hOb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+4|0;l=j;m=fOb()|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];l=iOb(m,a,b,d,k,f,g,h)|0;i=j;return l|0}function iOb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+32|0;m=l+20|0;n=l+16|0;o=l+12|0;p=l+8|0;q=l+4|0;r=l;if(!d){c[o>>2]=c[g>>2];c[m+0>>2]=c[o+0>>2];s=gOb(b,e,f,m,h,j,k)|0;i=l;return s|0}if(!e){c[p>>2]=c[g>>2];c[m+0>>2]=c[p+0>>2];kOb(b,d,m);s=0;i=l;return s|0}p=(f+-1|15)+1|0;if(!(a[b+6>>0]|0)){f=c[b+16>>2]|0;s=kn[c[(c[f>>2]|0)+12>>2]&511](f,d,e,p)|0;i=l;return s|0}f=c[g>>2]|0;do if((f|0)<102){if(!(c[b+(f<<3)+2280>>2]&2)){t=b+(f<<3)+2276|0;break}if((f|0)==89)u=EPb(c[b+8>>2]|0,d,e,p)|0;else{g=c[b+(f<<3)+2276>>2]|0;u=kn[c[(c[g>>2]|0)+12>>2]&511](g,d,e,p)|0}if(u){s=u;i=l;return s|0}c[q>>2]=0;c[m+0>>2]=c[q+0>>2];s=iOb(b,d,e,p,m,h,j,k)|0;i=l;return s|0}else t=b+(f+-102<<2)+220|0;while(0);q=c[t>>2]|0;if(_n[c[(c[q>>2]|0)+24>>2]&4095](q,d)|0){t=kn[c[(c[q>>2]|0)+12>>2]&511](q,d,e,p)|0;if(!((h&1|0)==0|(t|0)!=0)){s=0;i=l;return s|0}if(t){s=t;i=l;return s|0}c[n>>2]=f;c[m+0>>2]=c[n+0>>2];tOb(e,p,m,k,j);s=0;i=l;return s|0}c[r>>2]=f;c[m+0>>2]=c[r+0>>2];r=gOb(b,e,p,m,h,j,k)|0;if(!((h&1|0)==0|(r|0)!=0)){s=0;i=l;return s|0}a:do if((c[b>>2]|0)>0){h=0;while(1){k=b+(h<<2)+24|0;j=c[k>>2]|0;if(((j|0)!=0?mo[c[(c[j>>2]|0)+32>>2]&4095](j)|0:0)?(j=c[k>>2]|0,_n[c[(c[j>>2]|0)+24>>2]&4095](j,d)|0):0){v=k;break a}h=h+1|0;if((h|0)>=(c[b>>2]|0)){w=23;break}}}else w=23;while(0);b:do if((w|0)==23){h=b+16|0;k=c[h>>2]|0;if(_n[c[(c[k>>2]|0)+24>>2]&4095](k,d)|0)v=h;else{h=0;do{k=b+(h<<2)+220|0;j=c[k>>2]|0;if(j>>>0>512>>>0?_n[c[(c[j>>2]|0)+24>>2]&4095](j,d)|0:0){v=k;break b}h=h+1|0}while((h|0)<512);h=b+8|0;k=c[h>>2]|0;_n[c[(c[k>>2]|0)+24>>2]&4095](k,d)|0;v=h}}while(0);w=c[v>>2]|0;v=_n[c[(c[w>>2]|0)+28>>2]&4095](w,d)|0;YEi(r|0,d|0,(v>>>0<e>>>0?v:e)|0)|0;jOb(b,d);s=r;i=l;return s|0}function jOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!d){i=e;return}a:do if((c[b>>2]|0)>0){f=0;while(1){g=b+(f<<2)+24|0;h=c[g>>2]|0;if(((h|0)!=0?mo[c[(c[h>>2]|0)+32>>2]&4095](h)|0:0)?(h=c[g>>2]|0,_n[c[(c[h>>2]|0)+24>>2]&4095](h,d)|0):0){j=g;k=13;break a}f=f+1|0;if((f|0)>=(c[b>>2]|0)){k=7;break}}}else k=7;while(0);b:do if((k|0)==7){f=b+16|0;g=c[f>>2]|0;if(!(_n[c[(c[g>>2]|0)+24>>2]&4095](g,d)|0)){g=0;do{h=b+(g<<2)+220|0;l=c[h>>2]|0;if(l>>>0>512>>>0?_n[c[(c[l>>2]|0)+24>>2]&4095](l,d)|0:0){j=h;k=13;break b}g=g+1|0}while((g|0)<512);g=b+8|0;h=c[g>>2]|0;if((h|0)!=0?_n[c[(c[h>>2]|0)+24>>2]&4095](h,d)|0:0){j=g;k=13}}else{j=f;k=13}}while(0);if((k|0)==13?(k=c[j>>2]|0,(k|0)!=0):0){In[c[(c[k>>2]|0)+16>>2]&4095](k,d);i=e;return}if(!(a[b+6>>0]|0)){i=e;return}BDi(d);i=e;return}function kOb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f+4|0;h=f;if(!d){i=f;return}j=c[e>>2]|0;e=(j|0)<102;if(e)k=(c[b+(j<<3)+2280>>2]&2|0)!=0;else k=0;if(!(a[b+6>>0]|0)){if(k){l=b+20|0;c[l>>2]=(c[l>>2]|0)+-1}jOb(b,d);i=f;return}if(!k){if(e)m=b+(j<<3)+2276|0;else m=b+(j+-102<<2)+220|0;k=c[m>>2]|0;if(_n[c[(c[k>>2]|0)+20>>2]&4095](k,d)|0){i=f;return}jOb(b,d);i=f;return}if((j|0)==89){if(GPb(c[b+8>>2]|0,d)|0){i=f;return}c[h>>2]=0;c[g+0>>2]=c[h+0>>2];kOb(b,d,g);i=f;return}if(e)n=b+(j<<3)+2276|0;else n=b+(j+-102<<2)+220|0;j=c[n>>2]|0;In[c[(c[j>>2]|0)+16>>2]&4095](j,d);i=f;return}function lOb(){var a=0;a=i;mOb(fOb()|0,0);i=a;return}function mOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(a[b+5>>0]|0)){nOb(b);h=131072}else h=65536;j=c[153072]|0;k=fOb()|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];g=gOb(k,64,16,f,0,3653512,848)|0;pPb(g,(d|0)==0?h:d,550024);d=c[b+8>>2]|0;In[c[(c[d>>2]|0)+68>>2]&4095](d,g);i=e;return}function nOb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[137494]|0;f=e+80|0;c[137494]=f;if(f>>>0>(549976|0)>>>0)hi();if(!e)g=0;else{TOb(e,550008);g=e}e=c[b>>2]|0;c[b>>2]=e+1;c[b+(e<<2)+24>>2]=g;e=0;do{c[b+(e<<3)+2276>>2]=g;e=e+1|0}while((e|0)!=102);e=c[137494]|0;g=e+544|0;c[137494]=g;if(g>>>0>(549976|0)>>>0)hi();if(!e)h=0;else{APb(e,550024);h=e}c[b+8>>2]=h;c[b+2988>>2]=h;h=b+2992|0;c[h>>2]=c[h>>2]|2;h=c[137494]|0;e=h+64|0;c[137494]=e;if(e>>>0>(549976|0)>>>0)hi();if(!h)j=0;else{SPb(h,262144,64,550048);j=h}h=c[b>>2]|0;c[b>>2]=h+1;c[b+(h<<2)+24>>2]=j;c[b+2996>>2]=j;j=b+3e3|0;c[j>>2]=c[j>>2]|2;j=b+3008|0;c[j>>2]=c[j>>2]|2;j=c[137494]|0;h=j+80|0;c[137494]=h;if(h>>>0>(549976|0)>>>0)hi();if(!j)k=0;else{TOb(j,550064);k=j}j=c[b>>2]|0;c[b>>2]=j+1;c[b+(j<<2)+24>>2]=k;j=c[137494]|0;h=j+80|0;c[137494]=h;if(h>>>0>(549976|0)>>>0)hi();if(!j)l=0;else{TOb(j,550088);l=j}j=c[b>>2]|0;c[b>>2]=j+1;c[b+(j<<2)+24>>2]=l;j=c[137494]|0;h=j+80|0;c[137494]=h;if(h>>>0>(549976|0)>>>0)hi();if(!j)m=0;else{TOb(j,550104);m=j}j=c[b>>2]|0;c[b>>2]=j+1;c[b+(j<<2)+24>>2]=m;c[b+2380>>2]=l;c[b+2364>>2]=l;c[b+2340>>2]=l;c[b+2356>>2]=l;c[b+2348>>2]=l;c[b+2332>>2]=l;c[b+2612>>2]=k;c[b+2684>>2]=m;c[b+2676>>2]=m;c[b+2668>>2]=m;a[b+5>>0]=1;a[b+6>>0]=1;i=d;return}function oOb(a){a=a|0;var b=0,c=0;b=i;c=ADi(a)|0;i=b;return c|0}function pOb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=da(b,a)|0;a=ADi(d)|0;if(a)PEi(a|0,0,d|0)|0;i=c;return a|0}function qOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=DDi(a,b)|0;i=c;return d|0}function rOb(a,b){a=a|0;b=b|0;b=i;if(a)BDi(a);i=b;return}function sOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;In[c[(c[e>>2]|0)+76>>2]&4095](e,b);if((c[a>>2]|0)>0)f=0;else{i=d;return}do{e=c[a+(f<<2)+24>>2]|0;In[c[(c[e>>2]|0)+76>>2]&4095](e,b);f=f+1|0}while((f|0)<(c[a>>2]|0));i=d;return}function tOb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=i;i=i+80|0;j=h;k=h+40|0;l=h+44|0;m=h+48|0;n=h+24|0;o=h+12|0;p=h+28|0;q=h+52|0;r=h+64|0;s=h+76|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;yOb(o,30720);zOb(p,550120,j);t=a[p>>0]|0;if(!(t&1)){u=(t&255)>>>1;v=p+1|0}else{u=c[p+4>>2]|0;v=c[p+8>>2]|0}t=a[o>>0]|0;if(!(t&1)){w=t;x=10}else{t=c[o>>2]|0;w=t&255;x=(t&-2)+-1|0}if(!(w&1))y=(w&255)>>>1;else y=c[o+4>>2]|0;if((x-y|0)>>>0>=u>>>0){if(u){if(!(w&1))z=o+1|0;else z=c[o+8>>2]|0;YEi(z+y|0,v|0,u|0)|0;w=y+u|0;if(!(a[o>>0]&1))a[o>>0]=w<<1;else c[o+4>>2]=w;a[z+w>>0]=0}}else AOb(o,x,u-x+y|0,y,y,0,u,v);if(a[p>>0]&1){v=c[p+8>>2]|0;p=fOb()|0;c[k>>2]=89;c[j+0>>2]=c[k+0>>2];kOb(p,v,j)}fOb()|0;v=c[e>>2]|0;if((v|0)<102)A=c[613888+(v<<2)>>2]|0;else A=2861280;c[j>>2]=b;c[j+4>>2]=d;c[j+8>>2]=A;zOb(q,550176,j);A=a[q>>0]|0;if(!(A&1)){B=q+1|0;C=(A&255)>>>1}else{B=c[q+8>>2]|0;C=c[q+4>>2]|0}A=a[o>>0]|0;if(!(A&1)){D=A;E=10}else{A=c[o>>2]|0;D=A&255;E=(A&-2)+-1|0}if(!(D&1))F=(D&255)>>>1;else F=c[o+4>>2]|0;if((E-F|0)>>>0>=C>>>0){if(C){if(!(D&1))G=o+1|0;else G=c[o+8>>2]|0;YEi(G+F|0,B|0,C|0)|0;D=F+C|0;if(!(a[o>>0]&1))a[o>>0]=D<<1;else c[o+4>>2]=D;a[G+D>>0]=0}}else AOb(o,E,C-E+F|0,F,F,0,C,B);if(a[q>>0]&1){B=c[q+8>>2]|0;q=fOb()|0;c[l>>2]=89;c[j+0>>2]=c[l+0>>2];kOb(q,B,j)}c[j>>2]=f;c[j+4>>2]=g;zOb(r,550240,j);g=a[r>>0]|0;if(!(g&1)){H=(g&255)>>>1;I=r+1|0}else{H=c[r+4>>2]|0;I=c[r+8>>2]|0}g=a[o>>0]|0;if(!(g&1)){J=g;K=10}else{g=c[o>>2]|0;J=g&255;K=(g&-2)+-1|0}if(!(J&1))L=(J&255)>>>1;else L=c[o+4>>2]|0;if((K-L|0)>>>0>=H>>>0){if(H){if(!(J&1))M=o+1|0;else M=c[o+8>>2]|0;YEi(M+L|0,I|0,H|0)|0;J=L+H|0;if(!(a[o>>0]&1))a[o>>0]=J<<1;else c[o+4>>2]=J;a[M+J>>0]=0}}else AOb(o,K,H-K+L|0,L,L,0,H,I);if(a[r>>0]&1){I=c[r+8>>2]|0;r=fOb()|0;c[m>>2]=89;c[j+0>>2]=c[m+0>>2];kOb(r,I,j)}c[s>>2]=v;c[j+0>>2]=c[s+0>>2];uOb(o,j);if(!(a[o>>0]&1))N=o+1|0;else N=c[o+8>>2]|0;c[j>>2]=N;Ird(550280,j);if(!(a[o>>0]&1))O=o+1|0;else O=c[o+8>>2]|0;Krd(O,0,3653512,963,32785,0,0,0);if(!(a[o>>0]&1)){i=h;return}O=c[o+8>>2]|0;o=fOb()|0;c[n>>2]=89;c[j+0>>2]=c[n+0>>2];kOb(o,O,j);i=h;return}function uOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+16|0;h=fOb()|0;BOb(b,550288)|0;if((c[h>>2]|0)<=0){i=d;return}j=g+1|0;k=g+8|0;l=b+1|0;m=b+4|0;n=b+8|0;o=g+4|0;p=0;do{q=c[h+(p<<2)+24>>2]|0;if(q){r=c[q+4>>2]|0;s=mo[c[(c[q>>2]|0)+40>>2]&4095](q)|0;t=mo[c[(c[q>>2]|0)+48>>2]&4095](q)|0;u=mo[c[(c[q>>2]|0)+44>>2]&4095](q)|0;c[e>>2]=r;c[e+4>>2]=s;c[e+8>>2]=t;c[e+12>>2]=u;zOb(g,550312,e);u=a[g>>0]|0;if(!(u&1)){v=(u&255)>>>1;w=j}else{v=c[o>>2]|0;w=c[k>>2]|0}u=a[b>>0]|0;if(!(u&1)){x=u;y=10}else{u=c[b>>2]|0;x=u&255;y=(u&-2)+-1|0}if(!(x&1))z=(x&255)>>>1;else z=c[m>>2]|0;if((y-z|0)>>>0>=v>>>0){if(v){u=(x&1)==0?l:c[n>>2]|0;YEi(u+z|0,w|0,v|0)|0;t=z+v|0;if(!(a[b>>0]&1))a[b>>0]=t<<1;else c[m>>2]=t;a[u+t>>0]=0}}else AOb(b,y,v-y+z|0,z,z,0,v,w);if(a[g>>0]&1){t=c[k>>2]|0;u=fOb()|0;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];kOb(u,t,e)}}p=p+1|0}while((p|0)<(c[h>>2]|0));i=d;return}function vOb(a){a=a|0;return}function wOb(a){a=a|0;return}function xOb(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b>>2]|0;if((d|0)<102)e=a+(d<<3)+2276|0;else e=a+(d+-102<<2)+220|0;return c[e>>2]|0}function yOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;if(d>>>0>2147483631)ori(b);j=a[b>>0]|0;if(!(j&1)){k=j;l=10}else{j=c[b>>2]|0;k=j&255;l=(j&-2)+-1|0}if(!(k&1))m=(k&255)>>>1;else m=c[b+4>>2]|0;j=m>>>0>d>>>0?m:d;if(j>>>0<11)n=10;else n=(j+16&-16)+-1|0;if((n|0)==(l|0)){i=e;return}do if((n|0)!=10){j=n+1|0;if(n>>>0>l>>>0){d=fOb()|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];o=gOb(d,j,16,f,0,3653512,80)|0}else{d=fOb()|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];o=gOb(d,j,16,f,0,3653512,80)|0}j=a[b>>0]|0;if(!(j&1)){p=j;q=o;r=1;s=b+1|0;t=0;break}else{p=j;q=o;r=1;s=c[b+8>>2]|0;t=1;break}}else{p=k;q=b+1|0;r=0;s=c[b+8>>2]|0;t=1}while(0);if(!(p&1))u=(p&255)>>>1;else u=c[b+4>>2]|0;YEi(q|0,s|0,u+1|0)|0;if(t){t=fOb()|0;c[h>>2]=89;c[f+0>>2]=c[h+0>>2];kOb(t,s,f)}if(r){c[b>>2]=n+1|1;c[b+4>>2]=m;c[b+8>>2]=q;i=e;return}else{a[b>>0]=m<<1;i=e;return}}function zOb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+10272|0;g=f+20|0;h=f+16|0;j=f+24|0;k=f;c[k>>2]=e;Ksd(j,10240,d,k);k=SEi(j|0)|0;if(k>>>0>2147483631)ori(b);if(k>>>0<11){a[b>>0]=k<<1;l=b+1|0;YEi(l|0,j|0,k|0)|0;m=l+k|0;a[m>>0]=0;i=f;return}else{d=k+16&-16;e=fOb()|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];h=gOb(e,d,16,g,0,3653512,80)|0;c[b+8>>2]=h;c[b>>2]=d|1;c[b+4>>2]=k;l=h;YEi(l|0,j|0,k|0)|0;m=l+k|0;a[m>>0]=0;i=f;return}}function AOb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+16|0;m=l+4|0;n=l;if((2147483630-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))o=b+1|0;else o=c[b+8>>2]|0;if(d>>>0<1073741799){p=e+d|0;e=d<<1;q=p>>>0<e>>>0?e:p;if(q>>>0<11)r=11;else r=q+16&-16}else r=2147483631;q=fOb()|0;c[n>>2]=89;c[m+0>>2]=c[n+0>>2];p=gOb(q,r,16,m,0,3653512,80)|0;if(g)YEi(p|0,o|0,g|0)|0;if(j)YEi(p+g|0,k|0,j|0)|0;k=f-h|0;if((k|0)!=(g|0))YEi(p+(j+g)|0,o+(h+g)|0,k-g|0)|0;if((d|0)==10){s=b+8|0;c[s>>2]=p;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=p+u|0;a[w>>0]=0;i=l;return}d=fOb()|0;c[n>>2]=89;c[m+0>>2]=c[n+0>>2];kOb(d,o,m);s=b+8|0;c[s>>2]=p;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=p+u|0;a[w>>0]=0;i=l;return}function BOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=SEi(d|0)|0;g=a[b>>0]|0;if(!(g&1)){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+-1|0;j=g&255}if(!(j&1))k=(j&255)>>>1;else k=c[b+4>>2]|0;if((h-k|0)>>>0<f>>>0){AOb(b,h,f-h+k|0,k,k,0,f,d);i=e;return b|0}if(!f){i=e;return b|0}if(!(j&1))l=b+1|0;else l=c[b+8>>2]|0;YEi(l+k|0,d|0,f|0)|0;d=k+f|0;if(!(a[b>>0]&1))a[b>>0]=d<<1;else c[b+4>>2]=d;a[l+d>>0]=0;i=e;return b|0}function COb(a,b){a=a|0;b=b|0;c[a>>2]=550376;c[a+4>>2]=b;b=a+12|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[137616]=(c[137616]|0)+1;c[a+8>>2]=c[137616];return}function DOb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!(_n[c[(c[a>>2]|0)+24>>2]&4095](a,b)|0)){e=0;i=d;return e|0}In[c[(c[a>>2]|0)+16>>2]&4095](a,b);e=1;i=d;return e|0}function EOb(a){a=a|0;return}function FOb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function GOb(a){a=a|0;return 1}function HOb(a){a=a|0;return 1}function IOb(a){a=a|0;return c[a+16>>2]|0}function JOb(a){a=a|0;return c[a+20>>2]|0}function KOb(a){a=a|0;return c[a+24>>2]|0}function LOb(a){a=a|0;return c[a+28>>2]|0}function MOb(a){a=a|0;return c[a+12>>2]|0}function NOb(a,b,c){a=a|0;b=b|0;c=c|0;return}function OOb(a,b,c){a=a|0;b=b|0;c=c|0;return}function POb(a,b){a=a|0;b=b|0;return}function QOb(a){a=a|0;return}function ROb(a,b){a=a|0;b=b|0;return}function SOb(a){a=a|0;return 0}function TOb(a,b){a=a|0;b=b|0;var d=0;d=i;COb(a,b);c[a>>2]=550480;b=a+32|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));i=d;return}function UOb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=mPb(b+3+d|0)|0;if(!f){g=0;i=e;return g|0}h=-4-f&d+-1;d=f+h|0;if(!h){c[d>>2]=c[d>>2]&-2;j=0;k=d}else{PEi(f|0,-86,h|0)|0;c[d>>2]=c[d>>2]|1;c[f+(h+-4)>>2]=h;j=1;k=d}c[k>>2]=j|b<<1;b=f+(h+4)|0;h=(c[d>>2]|0)>>>1;d=a+16|0;f=(c[d>>2]|0)+h|0;c[d>>2]=f;d=a+28|0;c[d>>2]=(c[d>>2]|0)+19;d=a+24|0;if(f>>>0>(c[d>>2]|0)>>>0)c[d>>2]=f;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+20|0;c[f>>2]=h+19+(c[f>>2]|0);ZOb(a,b)|0;g=b;i=e;return g|0}function VOb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;if(!b){g=xo[c[(c[a>>2]|0)+8>>2]&2047](a,d,e)|0;i=f;return g|0}h=b+-4|0;j=c[h>>2]|0;if(!(j&1))k=0;else k=c[b+-8>>2]|0;l=j>>>1;j=a+16|0;c[j>>2]=(c[j>>2]|0)-l;m=a+28|0;c[m>>2]=(c[m>>2]|0)+-19;n=a+12|0;c[n>>2]=(c[n>>2]|0)+-1;o=a+20|0;c[o>>2]=-19-l+(c[o>>2]|0);_Ob(a,b)|0;l=c[h>>2]|0;h=l>>>1;if(!(l&1))p=0;else p=c[b+-8>>2]|0;l=nPb(b+(-4-k)|0,d+3+e|0,h+23|0)|0;if(!l){g=0;i=f;return g|0}k=-4-l&e+-1;if((k|0)!=(p|0))aFi(l+(k+4)|0,l+(p+4)|0,(h>>>0>d>>>0?d:h)|0)|0;h=l+k|0;if(!k){c[h>>2]=c[h>>2]&-2;q=0;r=h}else{PEi(l|0,-86,k|0)|0;c[h>>2]=c[h>>2]|1;c[l+(k+-4)>>2]=k;q=1;r=h}c[r>>2]=q|d<<1;d=l+(k+4)|0;k=(c[h>>2]|0)>>>1;h=(c[j>>2]|0)+k|0;c[j>>2]=h;c[m>>2]=(c[m>>2]|0)+19;m=a+24|0;if(h>>>0>(c[m>>2]|0)>>>0)c[m>>2]=h;c[n>>2]=(c[n>>2]|0)+1;c[o>>2]=k+19+(c[o>>2]|0);ZOb(a,d)|0;g=d;i=f;return g|0}function WOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!b){i=d;return}e=b+-4|0;f=c[e>>2]|0;if(!(f&1))g=0;else g=c[b+-8>>2]|0;h=f>>>1;f=a+16|0;c[f>>2]=(c[f>>2]|0)-h;f=a+28|0;c[f>>2]=(c[f>>2]|0)+-19;f=a+12|0;c[f>>2]=(c[f>>2]|0)+-1;f=a+20|0;c[f>>2]=-19-h+(c[f>>2]|0);_Ob(a,b)|0;oPb(b+(-4-g)|0,((c[e>>2]|0)>>>1)+23|0);i=d;return}function XOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b;b=e>>>18&127;f=e>>>13&31;g=e>>>9&15;h=e>>>4&31;j=c[a+36>>2]|0;if((((j|0)!=0?(a=c[j+(e>>>25<<2)>>2]|0,(a|0)!=0):0)?(e=c[a+(b<<2)>>2]|0,(e|0)!=0):0)?(b=c[e+(f<<2)>>2]|0,(b|0)!=0):0)k=(c[b+(g<<2)>>2]&1<<h|0)!=0;else k=0;i=d;return k|0}function YOb(a,b){a=a|0;b=b|0;return (c[b+-4>>2]|0)>>>1|0}function ZOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=b;b=a+36|0;f=e>>>25;g=e>>>18&127;h=e>>>13&31;j=c[b>>2]|0;if(!j){k=pOb(129,4)|0;c[b>>2]=k;l=a+28|0;c[l>>2]=(c[l>>2]|0)+516;c[k+512>>2]=0;m=c[b>>2]|0}else m=j;j=c[m+(f<<2)>>2]|0;if(!j){m=pOb(129,4)|0;c[(c[b>>2]|0)+(f<<2)>>2]=m;m=a+28|0;c[m>>2]=(c[m>>2]|0)+516;c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+512>>2]=0;n=c[(c[b>>2]|0)+(f<<2)>>2]|0}else n=j;j=c[n+(g<<2)>>2]|0;if(!j){n=pOb(33,4)|0;c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]=n;n=a+28|0;c[n>>2]=(c[n>>2]|0)+132;c[(c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0)+128>>2]=0;o=c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0}else o=j;j=c[o+(h<<2)>>2]|0;if(!j){n=pOb(17,4)|0;c[(c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0)+(h<<2)>>2]=n;n=a+28|0;c[n>>2]=(c[n>>2]|0)+68;n=c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0;a=c[n+(h<<2)>>2]|0;c[a+64>>2]=0;p=a;q=1;r=n}else{p=j;q=(c[j+64>>2]|0)+1|0;r=o}c[p+64>>2]=q;q=r+128|0;c[q>>2]=(c[q>>2]|0)+4;q=(c[(c[b>>2]|0)+(f<<2)>>2]|0)+512|0;c[q>>2]=(c[q>>2]|0)+4;q=(c[b>>2]|0)+512|0;c[q>>2]=(c[q>>2]|0)+4;q=(c[(c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0)+(h<<2)>>2]|0)+((e>>>9&15)<<2)|0;c[q>>2]=c[q>>2]|1<<(e>>>4&31);i=d;return 1}function _Ob(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=b;b=a+36|0;f=e>>>25;g=e>>>18&127;h=e>>>13&31;j=c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0;k=c[j+(h<<2)>>2]|0;l=k+((e>>>9&15)<<2)|0;c[l>>2]=c[l>>2]&~(1<<(e>>>4&31));e=k+64|0;l=(c[e>>2]|0)+-1|0;c[e>>2]=l;if(!l){l=a+28|0;c[l>>2]=(c[l>>2]|0)+-68;rOb(k,68);c[(c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0)+(h<<2)>>2]=0;m=c[(c[(c[b>>2]|0)+(f<<2)>>2]|0)+(g<<2)>>2]|0}else m=j;j=m+128|0;c[j>>2]=(c[j>>2]|0)+-4;j=(c[(c[b>>2]|0)+(f<<2)>>2]|0)+512|0;c[j>>2]=(c[j>>2]|0)+-4;j=(c[b>>2]|0)+512|0;c[j>>2]=(c[j>>2]|0)+-4;i=d;return 1}function $Ob(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function aPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function bPb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;COb(b,h);c[b>>2]=550576;c[b+32>>2]=g;g=b+40|0;c[g>>2]=g;c[b+44>>2]=g;g=b+48|0;c[g>>2]=g;c[b+52>>2]=g;a[b+57>>0]=f&1;c[b+36>>2]=e;c[b+60>>2]=d;c[b+64>>2]=0;i=j;return}function cPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;c[a>>2]=550576;d=a+40|0;e=a+44|0;f=c[e>>2]|0;if((f|0)==(d|0))g=f;else{h=f;do{oPb(c[h+12>>2]|0,c[h+16>>2]|0);h=c[h+4>>2]|0}while((h|0)!=(d|0));g=c[e>>2]|0}if((g|0)!=(d|0)){h=g;do{g=h+4|0;f=h;h=c[g>>2]|0;c[f>>2]=0;c[g>>2]=0}while((h|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;e=a+52|0;h=c[e>>2]|0;g=a+48|0;if((h|0)==(g|0))j=h;else{a=h;do{oPb(c[a+12>>2]|0,c[a+16>>2]|0);a=c[a+4>>2]|0}while((a|0)!=(g|0));j=c[e>>2]|0}if((j|0)==(g|0)){c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}else k=j;do{j=k+4|0;e=k;k=c[j>>2]|0;c[e>>2]=0;c[j>>2]=0}while((k|0)!=(g|0));c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}function dPb(a){a=a|0;var b=0;b=i;cPb(a);i=b;return}function ePb(a){a=a|0;var b=0;b=i;cPb(a);ACi(a);i=b;return}function fPb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+16|0;g=f;h=d+-1+e&0-e;if(h>>>0>32){j=h>>>0>2097151;k=h>>>(j?21:5);l=j?16:0;if(!(k&65280)){m=k;n=l}else{m=k>>>8;n=l|8}if(!(m&240)){o=m;p=n}else{o=m>>>4;p=n+4|0}n=1<<(a[595568+o>>0]|0)+p;q=h+-1+n&0-n}else q=h;h=b+60|0;n=c[h>>2]|0;if(n>>>0>d>>>0?(p=b+36|0,o=b+40|0,m=b+48|0,l=(c[p>>2]|0)>>>0>q>>>0?o:m,k=c[l+4>>2]|0,(k|0)!=(l|0)):0){l=cqe(c[k+8>>2]|0,e,q)|0;if(!l){r=c[h>>2]|0;s=11}else{t=o;u=m;v=p;w=l;x=q}}else{r=n;s=11}a:do if((s|0)==11){if(r>>>2>>>0>d>>>0){n=b+36|0;l=b+40|0;p=b+48|0;m=(c[n>>2]|0)>>>0>q>>>0?l:p;o=c[m>>2]|0;b:do if((o|0)!=(m|0)){k=o;while(1){j=cqe(c[k+8>>2]|0,e,q)|0;if(j){y=k;z=j;break}k=c[k>>2]|0;if((k|0)==(m|0))break b}k=c[m+4>>2]|0;if((y|0)==(k|0)){t=l;u=p;v=n;w=z;x=q;break a}j=c[y>>2]|0;A=y+4|0;if(j){c[j+4>>2]=c[A>>2];c[c[A>>2]>>2]=j;c[y>>2]=0;c[A>>2]=0}j=c[k>>2]|0;c[y>>2]=j;c[A>>2]=k;c[j+4>>2]=y;c[c[A>>2]>>2]=y;if(z){t=l;u=p;v=n;w=z;x=q;break a}}while(0);o=c[h>>2]|0;A=d<<1;if(o>>>0>A>>>0){j=o;do{B=mPb(j)|0;j=j>>>((B|0)==0&1);C=(B|0)!=0}while(j>>>0>A>>>0&(C^1));if(C){A=b+20|0;c[A>>2]=(c[A>>2]|0)+j;A=mPb(24)|0;o=A+4|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;c[A+20>>2]=0;c[A+12>>2]=B;c[A+16>>2]=j;c[A+8>>2]=aqe(B,j)|0;c[A+20>>2]=0;k=c[m+4>>2]|0;if((A|0)!=(k|0)){D=c[A>>2]|0;if(D){c[D+4>>2]=c[o>>2];c[c[o>>2]>>2]=D;c[A>>2]=0;c[o>>2]=0}D=c[k>>2]|0;c[A>>2]=D;c[o>>2]=k;c[D+4>>2]=A;c[c[o>>2]>>2]=A}A=cqe(c[(c[((c[n>>2]|0)>>>0>q>>>0?l:p)+4>>2]|0)+8>>2]|0,e,q)|0;if(A){t=l;u=p;v=n;w=A;x=q;break}}}}A=d+3+e|0;o=mPb(20)|0;D=mPb(A)|0;c[o+4>>2]=D;if(!D){Ird(550664,g);oPb(o,20);E=0;i=f;return E|0}k=o+12|0;c[k>>2]=A;c[o+16>>2]=d;F=b+20|0;c[F>>2]=(c[F>>2]|0)+d;F=b+64|0;c[o>>2]=c[F>>2];c[F>>2]=o;if(!o){t=b+40|0;u=b+48|0;v=b+36|0;w=D;x=A;break}A=-4-D&e+-1;F=D+A|0;if(!A){c[F>>2]=c[F>>2]&-2;G=0;H=F}else{PEi(D|0,-86,A|0)|0;c[F>>2]=c[F>>2]|1;c[D+(A+-4)>>2]=A;G=1;H=F}c[H>>2]=G|d<<1;F=D+(A+4)|0;c[o+8>>2]=F;o=(c[k>>2]|0)-d|0;k=b+16|0;A=(c[k>>2]|0)+d|0;c[k>>2]=A;k=b+28|0;c[k>>2]=o+(c[k>>2]|0);k=b+24|0;if(A>>>0>(c[k>>2]|0)>>>0)c[k>>2]=A;A=b+12|0;c[A>>2]=(c[A>>2]|0)+1;E=F;i=f;return E|0}while(0);d=(c[((c[v>>2]|0)>>>0>x>>>0?t:u)+4>>2]|0)+20|0;c[d>>2]=(c[d>>2]|0)+1;d=$pe(w)|0;u=b+16|0;t=(c[u>>2]|0)+d|0;c[u>>2]=t;u=b+24|0;if(t>>>0>(c[u>>2]|0)>>>0)c[u>>2]=t;t=b+12|0;c[t>>2]=(c[t>>2]|0)+1;E=w;i=f;return E|0}function gPb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if(!b){g=xo[c[(c[a>>2]|0)+8>>2]&2047](a,d,e)|0;i=f;return g|0}if(!d){In[c[(c[a>>2]|0)+16>>2]&4095](a,b);g=0;i=f;return g|0}h=c[a+44>>2]|0;j=a+40|0;a:do if((h|0)==(j|0))k=9;else{l=h;while(1){m=c[l+12>>2]|0;if(m>>>0<=b>>>0?(m+(c[l+16>>2]|0)|0)>>>0>b>>>0:0){n=l;k=13;break a}l=c[l+4>>2]|0;if((l|0)==(j|0)){k=9;break}}}while(0);b:do if((k|0)==9){j=c[a+52>>2]|0;h=a+48|0;if((j|0)==(h|0))k=19;else{l=j;while(1){j=c[l+12>>2]|0;if(j>>>0<=b>>>0?(j+(c[l+16>>2]|0)|0)>>>0>b>>>0:0){n=l;k=13;break b}l=c[l+4>>2]|0;if((l|0)==(h|0)){k=19;break}}}}while(0);do if((k|0)==13)if(!n)k=19;else{h=$pe(b)|0;l=eqe(c[n+8>>2]|0,b,e,d+-1+e&0-e)|0;if(!l)if(!h){k=19;break}else{o=h;break}j=$pe(l)|0;m=a+16|0;p=(c[m>>2]|0)+j|0;c[m>>2]=p;j=a+24|0;if(p>>>0>(c[j>>2]|0)>>>0)c[j>>2]=p;c[m>>2]=p-h;g=l;i=f;return g|0}while(0);if((k|0)==19)o=(c[b+-4>>2]|0)>>>1;k=xo[c[(c[a>>2]|0)+8>>2]&2047](a,d,e)|0;if(k)YEi(k|0,b|0,(o>>>0>d>>>0?d:o)|0)|0;In[c[(c[a>>2]|0)+16>>2]&4095](a,b);g=k;i=f;return g|0}function hPb(a,b){a=a|0;b=b|0;var d=0;d=i;_n[c[(c[a>>2]|0)+20>>2]&4095](a,b)|0;i=d;return}function iPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;if(!b){e=1;i=d;return e|0}f=c[a+44>>2]|0;g=a+40|0;a:do if((f|0)==(g|0))h=6;else{j=f;while(1){k=c[j+12>>2]|0;if(k>>>0<=b>>>0?(k+(c[j+16>>2]|0)|0)>>>0>b>>>0:0){l=j;h=10;break a}j=c[j+4>>2]|0;if((j|0)==(g|0)){h=6;break}}}while(0);b:do if((h|0)==6?(g=c[a+52>>2]|0,f=a+48|0,(g|0)!=(f|0)):0){j=g;do{g=c[j+12>>2]|0;if(g>>>0<=b>>>0?(g+(c[j+16>>2]|0)|0)>>>0>b>>>0:0){l=j;h=10;break b}j=c[j+4>>2]|0}while((j|0)!=(f|0))}while(0);if((h|0)==10?(l|0)!=0:0){f=$pe(b)|0;j=a+16|0;c[j>>2]=(c[j>>2]|0)-f;f=a+12|0;c[f>>2]=(c[f>>2]|0)+-1;f=l+20|0;c[f>>2]=(c[f>>2]|0)+-1;dqe(c[l+8>>2]|0,b);if(c[f>>2]|0){e=1;i=d;return e|0}f=c[l>>2]|0;if(f){j=l+4|0;c[f+4>>2]=c[j>>2];c[c[j>>2]>>2]=f;c[l>>2]=0;c[j>>2]=0}j=l+16|0;oPb(c[l+12>>2]|0,c[j>>2]|0);f=a+20|0;c[f>>2]=(c[f>>2]|0)-(c[j>>2]|0);oPb(l,24);e=1;i=d;return e|0}l=a+64|0;j=c[l>>2]|0;if(!j){e=0;i=d;return e|0}else{m=j;n=0}while(1){if((c[m+8>>2]|0)==(b|0)){o=m;p=n;break}j=c[m>>2]|0;if(!j){e=0;h=22;break}else{f=m;m=j;n=f}}if((h|0)==22){i=d;return e|0}h=c[o+16>>2]|0;n=c[o+12>>2]|0;m=a+16|0;c[m>>2]=(c[m>>2]|0)-h;m=a+28|0;c[m>>2]=h-n+(c[m>>2]|0);m=a+12|0;c[m>>2]=(c[m>>2]|0)+-1;m=c[o>>2]|0;if(!p)c[l>>2]=m;else c[p>>2]=m;m=a+20|0;c[m>>2]=(c[m>>2]|0)-h;oPb(c[o+4>>2]|0,n);oPb(o,20);e=1;i=d;return e|0}function jPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a+44>>2]|0;f=a+40|0;a:do if((e|0)==(f|0))g=5;else{h=e;while(1){j=c[h+12>>2]|0;if(j>>>0<=b>>>0?(j+(c[h+16>>2]|0)|0)>>>0>b>>>0:0){k=h;g=9;break a}h=c[h+4>>2]|0;if((h|0)==(f|0)){g=5;break}}}while(0);b:do if((g|0)==5?(f=c[a+52>>2]|0,e=a+48|0,(f|0)!=(e|0)):0){h=f;do{f=c[h+12>>2]|0;if(f>>>0<=b>>>0?(f+(c[h+16>>2]|0)|0)>>>0>b>>>0:0){k=h;g=9;break b}h=c[h+4>>2]|0}while((h|0)!=(e|0))}while(0);if((g|0)==9?(k|0)!=0:0){l=1;i=d;return l|0}k=c[a+64>>2]|0;if(!k){l=0;i=d;return l|0}else m=k;while(1){if((c[m+8>>2]|0)==(b|0)){l=1;g=13;break}m=c[m>>2]|0;if(!m){l=0;g=13;break}}if((g|0)==13){i=d;return l|0}return 0}function kPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+44>>2]|0;f=a+40|0;a:do if((e|0)==(f|0))g=5;else{h=e;while(1){j=c[h+12>>2]|0;if(j>>>0<=b>>>0?(j+(c[h+16>>2]|0)|0)>>>0>b>>>0:0){k=h;g=9;break a}h=c[h+4>>2]|0;if((h|0)==(f|0)){g=5;break}}}while(0);b:do if((g|0)==5?(f=c[a+52>>2]|0,e=a+48|0,(f|0)!=(e|0)):0){h=f;do{f=c[h+12>>2]|0;if(f>>>0<=b>>>0?(f+(c[h+16>>2]|0)|0)>>>0>b>>>0:0){k=h;g=9;break b}h=c[h+4>>2]|0}while((h|0)!=(e|0))}while(0);if((g|0)==9?(k|0)!=0:0){l=$pe(b)|0;i=d;return l|0}l=(c[b+-4>>2]|0)>>>1;i=d;return l|0}function lPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+44|0;e=c[d>>2]|0;f=a+40|0;if((e|0)!=(f|0)){g=e;do g=c[g+4>>2]|0;while((g|0)!=(f|0))}g=a+52|0;e=c[g>>2]|0;h=a+48|0;if((e|0)!=(h|0)){a=e;do a=c[a+4>>2]|0;while((a|0)!=(h|0))}a=c[d>>2]|0;if((a|0)!=(f|0)){d=a;do{_pe(c[d+8>>2]|0,335,0);d=c[d+4>>2]|0}while((d|0)!=(f|0))}f=c[g>>2]|0;if((f|0)==(h|0)){i=b;return 1}else j=f;do{_pe(c[j+8>>2]|0,335,0);j=c[j+4>>2]|0}while((j|0)!=(h|0));i=b;return 1}function mPb(a){a=a|0;var b=0,c=0;b=i;c=oOb(a)|0;i=b;return c|0}function nPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=qOb(a,b,c)|0;i=d;return e|0}function oPb(a,b){a=a|0;b=b|0;var c=0;c=i;rOb(a,b);i=c;return}function pPb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;COb(a,d);c[a>>2]=550752;d=a+32|0;c[d>>2]=0;c[a+36>>2]=b;c[a+40>>2]=0;c[d>>2]=oOb(b)|0;c[a+20>>2]=b;b=a+48|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=e;return}function qPb(a){a=a|0;var b=0;b=i;c[a>>2]=550752;rOb(c[a+32>>2]|0,c[a+36>>2]|0);i=b;return}function rPb(a){a=a|0;var b=0;b=i;c[a>>2]=550752;rOb(c[a+32>>2]|0,c[a+36>>2]|0);ACi(a);i=b;return}function sPb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+4|0;g=e;h=(d&7|0)!=0?8:d;d=0-h|0;j=h+7&d;k=a+40|0;l=c[k>>2]|0;if(!l){m=c[a+32>>2]|0;n=m;o=m}else{n=l+((c[l+-4>>2]|0)>>>1)|0;o=c[a+32>>2]|0}l=h+-1|0;m=n+l&d;n=m;p=m-o|0;o=c[a+36>>2]|0;if(o>>>0>p>>>0?(o-p|0)>>>0>=(b+-1+h+j&d)>>>0:0){d=n+j|0;c[n+(j+-4)>>2]=b<<1;c[n+(j+-8)>>2]=c[k>>2];c[k>>2]=d;k=a+16|0;j=(c[k>>2]|0)+b|0;c[k>>2]=j;k=a+28|0;c[k>>2]=(c[k>>2]|0)+8;k=a+24|0;if(j>>>0>(c[k>>2]|0)>>>0)c[k>>2]=j;j=a+12|0;c[j>>2]=(c[j>>2]|0)+1;q=d;i=e;return q|0}d=fOb()|0;c[g>>2]=c[153138];c[f+0>>2]=c[g+0>>2];g=xOb(d,f)|0;f=xo[c[(c[g>>2]|0)+8>>2]&2047](g,b,(l|15)+1|0)|0;if(!f){q=0;i=e;return q|0}l=_n[c[(c[g>>2]|0)+28>>2]&4095](g,f)|0;g=a+48|0;b=g;d=_Ei(c[b>>2]|0,c[b+4>>2]|0,l|0,0)|0;l=H;b=g;c[b>>2]=d;c[b+4>>2]=l;b=a+56|0;a=b;g=c[a+4>>2]|0;if(!((l|0)>(g|0)|((l|0)==(g|0)?d>>>0>(c[a>>2]|0)>>>0:0))){q=f;i=e;return q|0}a=b;c[a>>2]=d;c[a+4>>2]=l;q=f;i=e;return q|0}function tPb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f+4|0;h=f;j=(e&7|0)!=0?8:e;if(!b){k=xo[c[(c[a>>2]|0)+8>>2]&2047](a,d,j)|0;i=f;return k|0}e=a+40|0;l=c[e>>2]|0;if(!l){m=c[a+32>>2]|0;n=m;o=m}else{n=l+((c[l+-4>>2]|0)>>>1)|0;o=c[a+32>>2]|0}l=j+-1|0;m=0-j|0;p=(n+l&m)-o|0;o=a+36|0;n=c[o>>2]|0;q=n>>>0<p>>>0?0:n-p|0;p=_n[c[(c[a>>2]|0)+28>>2]&4095](a,b)|0;n=c[a+32>>2]|0;if(n>>>0<=b>>>0?(n+(c[o>>2]|0)|0)>>>0>b>>>0:0){o=p>>>0<d>>>0;if(!((c[e>>2]|0)!=(b|0)&o)?((q+p|0)>>>0>d>>>0?(l+b&m|0)==(b|0):0):0){m=b+-4|0;c[m>>2]=c[m>>2]&1|d<<1;m=a+16|0;q=(c[m>>2]|0)-p|0;e=a+12|0;n=c[e>>2]|0;c[e>>2]=n+-1;r=q+d|0;c[m>>2]=r;m=a+24|0;if(r>>>0>(c[m>>2]|0)>>>0)c[m>>2]=r;c[e>>2]=n;k=b;i=f;return k|0}n=xo[c[(c[a>>2]|0)+8>>2]&2047](a,d,j)|0;if(n)YEi(n|0,b|0,(o?p:d)|0)|0;In[c[(c[a>>2]|0)+16>>2]&4095](a,b);k=n;i=f;return k|0}n=fOb()|0;c[h>>2]=c[153138];c[g+0>>2]=c[h+0>>2];h=xOb(n,g)|0;g=_n[c[(c[h>>2]|0)+28>>2]&4095](h,b)|0;n=kn[c[(c[h>>2]|0)+12>>2]&511](h,b,d,(l|15)+1|0)|0;if(n){l=_n[c[(c[h>>2]|0)+28>>2]&4095](h,n)|0;h=a+48|0;d=h;b=_Ei(c[d>>2]|0,c[d+4>>2]|0,l|0,0)|0;l=H;d=h;c[d>>2]=b;c[d+4>>2]=l;d=a+56|0;h=d;p=c[h>>2]|0;o=c[h+4>>2]|0;if((l|0)>(o|0)|(l|0)==(o|0)&b>>>0>p>>>0){h=d;c[h>>2]=b;c[h+4>>2]=l;s=b;t=l;u=l;v=b}else{s=b;t=l;u=o;v=p}}else{p=a+48|0;o=a+56|0;s=c[p>>2]|0;t=c[p+4>>2]|0;u=c[o+4>>2]|0;v=c[o>>2]|0}o=ZEi(s|0,t|0,g|0,0)|0;g=H;t=a+48|0;c[t>>2]=o;c[t+4>>2]=g;if(!((g|0)>(u|0)|(g|0)==(u|0)&o>>>0>v>>>0)){k=n;i=f;return k|0}v=a+56|0;c[v>>2]=o;c[v+4>>2]=g;k=n;i=f;return k|0}function uPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return 1}g=a+40|0;if((c[g>>2]|0)==(b|0)){h=_n[c[(c[a>>2]|0)+28>>2]&4095](a,b)|0;j=a+16|0;c[j>>2]=(c[j>>2]|0)-h;h=a+28|0;c[h>>2]=(c[h>>2]|0)+-8;h=a+12|0;c[h>>2]=(c[h>>2]|0)+-1;h=c[g>>2]|0;while(1){h=c[h+-8>>2]|0;c[g>>2]=h;if(!h){k=12;break}if(!(c[h+-4>>2]&1)){k=12;break}}if((k|0)==12){i=d;return 1}}k=c[a+32>>2]|0;if(k>>>0<=b>>>0?(k+(c[a+36>>2]|0)|0)>>>0>b>>>0:0){k=_n[c[(c[a>>2]|0)+28>>2]&4095](a,b)|0;h=a+16|0;c[h>>2]=(c[h>>2]|0)-k;k=a+28|0;c[k>>2]=(c[k>>2]|0)+-8;k=a+12|0;c[k>>2]=(c[k>>2]|0)+-1;k=b+-4|0;c[k>>2]=c[k>>2]|1;i=d;return 1}k=fOb()|0;c[f>>2]=c[153138];c[e+0>>2]=c[f+0>>2];f=xOb(k,e)|0;e=_n[c[(c[f>>2]|0)+28>>2]&4095](f,b)|0;k=a+48|0;h=k;g=ZEi(c[h>>2]|0,c[h+4>>2]|0,e|0,0)|0;e=H;h=k;c[h>>2]=g;c[h+4>>2]=e;h=a+56|0;a=h;k=c[a+4>>2]|0;if((e|0)>(k|0)|((e|0)==(k|0)?g>>>0>(c[a>>2]|0)>>>0:0)){a=h;c[a>>2]=g;c[a+4>>2]=e}In[c[(c[f>>2]|0)+16>>2]&4095](f,b);i=d;return 1}function vPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;if(c[a+40>>2]|0){i=b;return}d=a+48|0;e=d;if(!((c[e>>2]|0)==0&(c[e+4>>2]|0)==0)){i=b;return}e=a+56|0;f=c[e>>2]|0;g=c[e+4>>2]|0;if((f|0)==0&(g|0)==0){i=b;return}e=a+36|0;h=c[e>>2]|0;j=_Ei(h|0,0,f|0,g|0)|0;if(j>>>0>1){g=1;while(1){f=g>>>0<1048577?g<<1:g+1048576|0;if(f>>>0<j>>>0)g=f;else{k=f;break}}}else k=1;g=a+32|0;rOb(c[g>>2]|0,h);c[g>>2]=oOb(k)|0;c[e>>2]=k;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}function wPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;f=fOb()|0;c[e>>2]=c[153138];c[d+0>>2]=c[e+0>>2];e=xOb(f,d)|0;d=_n[c[(c[e>>2]|0)+24>>2]&4095](e,b)|0;i=a;return d|0}function xPb(a,b){a=a|0;b=b|0;var d=0;d=i;_n[c[(c[a>>2]|0)+20>>2]&4095](a,b)|0;i=d;return}function yPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a+40>>2]|0;if((b|0)!=0&(g|0)==(b|0)){h=1;i=d;return h|0}if(((g|0)!=0?(g=c[a+32>>2]|0,g>>>0<=b>>>0):0)?(g+(c[a+36>>2]|0)|0)>>>0>b>>>0:0){h=1;i=d;return h|0}a=fOb()|0;c[f>>2]=c[153138];c[e+0>>2]=c[f+0>>2];f=xOb(a,e)|0;h=_n[c[(c[f>>2]|0)+24>>2]&4095](f,b)|0;i=d;return h|0}function zPb(a,b){a=a|0;b=b|0;return (c[b+-4>>2]|0)>>>1|0}function APb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;COb(a,b);c[a>>2]=550848;if(!(c[137734]|0))e=1;else{Krd(550944,0,3653512,19,1,0,0,0);e=(c[137734]|0)+1|0}c[137734]=e;PEi(a+32|0,0,512)|0;i=d;return}function BPb(a){a=a|0;c[a>>2]=550848;c[137734]=(c[137734]|0)+-1;return}function CPb(a){a=a|0;var b=0;b=i;c[a>>2]=550848;c[137734]=(c[137734]|0)+-1;ACi(a);i=b;return}function DPb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;e=c[137756]|0;if(!e)f=0;else f=sPb(e,b,d)|0;i=a;return f|0}function EPb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;f=c[137756]|0;if(!f)g=0;else g=tPb(f,b,d,e)|0;i=a;return g|0}function FPb(a,b){a=a|0;b=b|0;var d=0;a=i;d=c[137756]|0;_n[c[(c[d>>2]|0)+20>>2]&4095](d,b)|0;i=a;return}function GPb(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;d=c[137756]|0;if(!d)e=0;else e=uPb(d,b)|0;i=a;return e|0}function HPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[137756]|0;if(d){e=c[d+40>>2]|0;if((b|0)!=0&(e|0)==(b|0)){f=1;i=a;return f|0}if(((e|0)!=0?(e=c[d+32>>2]|0,e>>>0<=b>>>0):0)?(e+(c[d+36>>2]|0)|0)>>>0>b>>>0:0){f=1;i=a;return f|0}if(wPb(d,b)|0){f=1;i=a;return f|0}}f=0;i=a;return f|0}function IPb(a,b){a=a|0;b=b|0;return (c[b+-4>>2]|0)>>>1|0}function JPb(a){a=a|0;return (c[137756]|0)!=0|0}function KPb(a){a=a|0;return 1}function LPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=0;e=0;while(1){f=c[a+(e<<2)+32>>2]|0;if(!f)g=d;else g=(c[f+16>>2]|0)+d|0;e=e+1|0;if((e|0)==128){h=g;break}else d=g}i=b;return h|0}function MPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=0;e=0;while(1){f=c[a+(d<<2)+32>>2]|0;if(!f)g=e;else g=(c[f+28>>2]|0)+e|0;d=d+1|0;if((d|0)==128){h=g;break}else e=g}i=b;return h|0}function NPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=0;e=0;while(1){f=c[a+(d<<2)+32>>2]|0;if(!f)g=e;else g=(c[f+20>>2]|0)+e|0;d=d+1|0;if((d|0)==128){h=g;break}else e=g}i=b;return h|0}function OPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;c[137756]=b;e=0;while(1){f=a+(e<<2)+32|0;e=e+1|0;if(!(c[f>>2]|0)){g=f;break}if((e|0)>=128){h=5;break}}if((h|0)==5){i=d;return}c[g>>2]=b;i=d;return}function PPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[137756]|0;c[137756]=0;g=0;do{h=a+(g<<2)+32|0;g=g+1|0;if((c[h>>2]|0)==(f|0)){j=h;k=4;break}}while((g|0)<128);if((k|0)==4)c[j>>2]=0;j=c[153072]|0;if(f)ko[c[c[f>>2]>>2]&4095](f);c[e>>2]=j;c[d+0>>2]=c[e+0>>2];eOb(f,d);i=b;return}function QPb(a,b){a=a|0;b=b|0;var d=0;a=i;d=c[137756]|0;if(!d){i=a;return}In[c[(c[d>>2]|0)+76>>2]&4095](d,b);i=a;return}function RPb(){var b=0,d=0;b=i;if(a[551032]|0){i=b;return}c[137756]=0;d=551032;c[d>>2]=1;c[d+4>>2]=0;i=b;return}function SPb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;COb(a,e);c[a>>2]=551048;e=a+36|0;c[e>>2]=-1;g=a+40|0;c[g>>2]=0;c[a+44>>2]=0;h=a+48|0;c[h>>2]=b;b=a+52|0;c[b>>2]=d;fOb()|0;d=a+32|0;c[d>>2]=oOb((c[b>>2]|0)*12|0)|0;a=c[g>>2]|0;a:do if((a|0)>0){j=0;while(1){if((j|0)!=(c[e>>2]|0)?(k=(c[d>>2]|0)+(j*12|0)+8|0,c[k>>2]=c[k>>2],(c[k>>2]|0)==0):0){l=j;break}j=j+1|0;if((j|0)>=(a|0))break a}c[(c[d>>2]|0)+(l*12|0)+4>>2]=0;c[e>>2]=l;i=f;return}while(0);if((a|0)>=(c[b>>2]|0)){i=f;return}fOb()|0;b=oOb(c[h>>2]|0)|0;if(!b){i=f;return}h=c[d>>2]|0;c[h+(a*12|0)>>2]=b;c[h+(a*12|0)+8>>2]=0;c[(c[d>>2]|0)+(a*12|0)+4>>2]=0;c[g>>2]=(c[g>>2]|0)+1;c[e>>2]=a;i=f;return}function TPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=551048;d=a+40|0;e=a+32|0;if((c[d>>2]|0)>0){f=a+48|0;g=0;do{fOb()|0;rOb(c[(c[e>>2]|0)+(g*12|0)>>2]|0,c[f>>2]|0);g=g+1|0}while((g|0)<(c[d>>2]|0))}c[d>>2]=0;fOb()|0;rOb(c[e>>2]|0,(c[a+52>>2]|0)*12|0);i=b;return}function UPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=551048;d=a+40|0;e=a+32|0;if((c[d>>2]|0)>0){f=a+48|0;g=0;do{fOb()|0;rOb(c[(c[e>>2]|0)+(g*12|0)>>2]|0,c[f>>2]|0);g=g+1|0}while((g|0)<(c[d>>2]|0))}c[d>>2]=0;fOb()|0;rOb(c[e>>2]|0,(c[a+52>>2]|0)*12|0);ACi(a);i=b;return}function VPb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+11+d|0;j=a+48|0;a:do if((h|0)<(c[j>>2]|0)?(k=a+36|0,c[k>>2]=c[k>>2],l=c[k>>2]|0,(l|0)!=-1):0){m=a+32|0;n=a+40|0;o=a+52|0;p=l;b:while(1){l=(c[m>>2]|0)+(p*12|0)+8|0;c[l>>2]=(c[l>>2]|0)+1;l=(c[m>>2]|0)+(p*12|0)+4|0;c[l>>2]=(c[l>>2]|0)+h;q=c[l>>2]|0;l=c[m>>2]|0;if((q|0)<=(c[j>>2]|0)){r=p;s=q;t=l;u=17;break}q=l+(p*12|0)+8|0;c[q>>2]=(c[q>>2]|0)+-1;c[k>>2]=c[k>>2];c:do if((p|0)==(c[k>>2]|0)){q=c[n>>2]|0;d:do if((q|0)>0){l=0;while(1){if((l|0)!=(c[k>>2]|0)?(v=(c[m>>2]|0)+(l*12|0)+8|0,c[v>>2]=c[v>>2],(c[v>>2]|0)==0):0){w=l;break}l=l+1|0;if((l|0)>=(q|0))break d}c[(c[m>>2]|0)+(w*12|0)+4>>2]=0;c[k>>2]=w;break c}while(0);if((q|0)<(c[o>>2]|0)?(fOb()|0,l=oOb(c[j>>2]|0)|0,(l|0)!=0):0){v=c[m>>2]|0;c[v+(q*12|0)>>2]=l;c[v+(q*12|0)+8>>2]=0;c[(c[m>>2]|0)+(q*12|0)+4>>2]=0;c[n>>2]=(c[n>>2]|0)+1;c[k>>2]=q;break}if((c[k>>2]|0)==(p|0)){u=16;break b}}while(0);c[k>>2]=c[k>>2];p=c[k>>2]|0;if((p|0)==-1){x=-1;u=18;break a}}if((u|0)==16){c[k>>2]=-1;x=-1;u=18;break}else if((u|0)==17){p=(c[t+(r*12|0)>>2]|0)+(s-h)|0;if(!p){x=r;u=18;break}else{y=r;z=p;break}}}else{x=-1;u=18}while(0);if((u|0)==18){u=a+44|0;c[u>>2]=(c[u>>2]|0)+1;c[g>>2]=c[153138];c[f+0>>2]=c[g+0>>2];g=cOb(h,16,f,0,3653512,126)|0;if(!g){A=0;i=e;return A|0}else{y=x;z=g}}g=d+-1+(z+12)&0-d;d=g;c[d+-12>>2]=b;b=d+-8|0;x=g-z<<9;c[b>>2]=x;c[d+-4>>2]=-892407795;if((y|0)==-1)B=1;else B=y<<1&510;c[b>>2]=x|B;A=d;i=e;return A|0}function WPb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;c[g>>2]=d;h=b+-12|0;if((c[h>>2]|0)>>>0>=d>>>0?(b+-1+e&0-e|0)==(b|0):0){j=b;i=f;return j|0}k=xo[c[(c[a>>2]|0)+8>>2]&2047](a,d,e)|0;if(!k){j=0;i=f;return j|0}YEi(k|0,b|0,c[((c[h>>2]|0)>>>0>d>>>0?g:h)>>2]|0)|0;In[c[(c[a>>2]|0)+16>>2]&4095](a,b);j=k;i=f;return j|0}function XPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b+-4>>2]=-842150451;g=c[b+-8>>2]|0;if(g&1){c[f>>2]=c[153138];c[e+0>>2]=c[f+0>>2];eOb(b+(0-(g>>>9))|0,e);e=a+44|0;c[e>>2]=(c[e>>2]|0)+-1;i=d;return}e=g>>>1&255;g=a+32|0;b=(c[g>>2]|0)+(e*12|0)+8|0;c[b>>2]=(c[b>>2]|0)+-1;if(c[b>>2]|0){i=d;return}b=a+36|0;c[b>>2]=c[b>>2];if((c[b>>2]|0)!=-1){i=d;return}c[b>>2]=c[b>>2];if((c[b>>2]|0)!=-1){i=d;return}c[(c[g>>2]|0)+(e*12|0)+4>>2]=0;c[b>>2]=e;i=d;return}function YPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+40|0;c[g>>2]=c[g>>2];h=c[g>>2]|0;a:do if((h|0)>0){g=c[a+32>>2]|0;j=a+48|0;k=0;while(1){l=c[g+(k*12|0)>>2]|0;if(l>>>0<=b>>>0?(l+(c[j>>2]|0)|0)>>>0>b>>>0:0){m=1;break}k=k+1|0;if((k|0)>=(h|0))break a}i=d;return m|0}while(0);h=a+44|0;c[h>>2]=c[h>>2];if((c[h>>2]|0)<=0){m=0;i=d;return m|0}h=fOb()|0;c[f>>2]=c[153138];c[e+0>>2]=c[f+0>>2];f=xOb(h,e)|0;m=_n[c[(c[f>>2]|0)+24>>2]&4095](f,b)|0;i=d;return m|0}function ZPb(a,b){a=a|0;b=b|0;return c[b+-12>>2]|0}function _Pb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+40|0;c[d>>2]=c[d>>2];e=c[d>>2]|0;if((e|0)<=0){f=0;i=b;return f|0}d=a+32|0;a=c[d>>2]|0;g=0;h=0;while(1){j=a+(g*12|0)+8|0;c[j>>2]=c[j>>2];if((c[j>>2]|0)>0){j=(c[d>>2]|0)+(g*12|0)+4|0;c[j>>2]=c[j>>2];k=(c[j>>2]|0)+h|0}else k=h;g=g+1|0;if((g|0)==(e|0)){f=k;break}else h=k}i=b;return f|0}function $Pb(a){a=a|0;var b=0,d=0;b=a+40|0;c[b>>2]=c[b>>2];d=da(c[a+48>>2]|0,c[b>>2]|0)|0;return d|0}function aQb(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[a>>2]|0)+16>>2]&4095](a,b);i=d;return 1}function bQb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+32|0;b=a+8|0;d=a+16|0;e=a+20|0;f=a+24|0;g=a+4|0;h=a;j=a+12|0;c[e>>2]=c[153106];c[b+0>>2]=c[e+0>>2];c[137790]=bOb(4,b,1,16,3653512,104)|0;c[f>>2]=c[153106];c[b+0>>2]=c[f+0>>2];f=bOb(12,b,0,16,3653512,106)|0;e=f+4|0;c[e>>2]=0;c[f+8>>2]=0;c[f>>2]=e;c[137792]=f;c[g>>2]=c[153106];c[b+0>>2]=c[g+0>>2];g=bOb(12,b,0,16,3653512,107)|0;f=g+4|0;c[f>>2]=0;c[g+8>>2]=0;c[g>>2]=f;c[137794]=g;c[h>>2]=c[153106];c[b+0>>2]=c[h+0>>2];h=bOb(16,b,0,16,3653512,108)|0;c[h>>2]=c[153106];c[h+8>>2]=0;c[h+12>>2]=0;c[h+4>>2]=0;c[137796]=h;c[j>>2]=c[153106];c[b+0>>2]=c[j+0>>2];j=bOb(16,b,0,16,3653512,109)|0;c[j>>2]=c[153106];c[j+8>>2]=0;c[j+12>>2]=0;c[j+4>>2]=0;c[137798]=j;c[d>>2]=c[153106];c[b+0>>2]=c[d+0>>2];d=bOb(52,b,0,16,3653512,900)|0;bRb(d,131072);c[137784]=d;i=a;return}function cQb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+12|0;d=a+8|0;e=a+4|0;f=a;g=c[137784]|0;h=c[153106]|0;if((g|0)!=0?(j=c[g+28>>2]|0,(j|0)!=0):0){c[f>>2]=57;c[b+0>>2]=c[f+0>>2];eOb(j,b)}c[d>>2]=h;c[b+0>>2]=c[d+0>>2];eOb(g,b);c[137784]=0;g=c[137792]|0;h=c[153106]|0;if(g)cRb(g,c[g+4>>2]|0);c[d>>2]=h;c[b+0>>2]=c[d+0>>2];eOb(g,b);c[137792]=0;g=c[137794]|0;h=c[153106]|0;if(g)dRb(g,c[g+4>>2]|0);c[d>>2]=h;c[b+0>>2]=c[d+0>>2];eOb(g,b);c[137794]=0;g=c[137796]|0;h=c[153106]|0;if(g){j=c[g+4>>2]|0;c[d>>2]=c[g>>2];c[b+0>>2]=c[d+0>>2];eOb(j,b)}c[e>>2]=h;c[b+0>>2]=c[e+0>>2];eOb(g,b);c[137796]=0;g=c[137798]|0;h=c[153106]|0;if(!g){c[e>>2]=h;c[b+0>>2]=c[e+0>>2];eOb(g,b);c[137798]=0;k=c[137790]|0;l=c[153106]|0;c[d>>2]=l;c[b+0>>2]=c[d+0>>2];eOb(k,b);c[137790]=0;i=a;return}j=c[g+4>>2]|0;c[d>>2]=c[g>>2];c[b+0>>2]=c[d+0>>2];eOb(j,b);c[e>>2]=h;c[b+0>>2]=c[e+0>>2];eOb(g,b);c[137798]=0;k=c[137790]|0;l=c[153106]|0;c[d>>2]=l;c[b+0>>2]=c[d+0>>2];eOb(k,b);c[137790]=0;i=a;return}function dQb(){return}function eQb(){return}function fQb(a,b){a=a|0;b=b|0;var c=0;c=i;Ted(kfd()|0,a,b);i=c;return}function gQb(a,b){a=a|0;b=b|0;var c=0;c=i;Qed(kfd()|0,a,b);i=c;return}function hQb(a){a=a|0;var b=0,c=0;b=i;if((a|0)<1){c=0;i=b;return c|0}c=_ed(kfd()|0,a,-1)|0;i=b;return c|0}function iQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(b){f=cfd(kfd()|0,a)|0;i=d;return f|0}else{c[e>>2]=a;f=eRb(e)|0;i=d;return f|0}return 0}function jQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b;Oed(kfd()|0,a,0);c[e>>2]=a;a=c[137784]|0;if(!a){i=b;return}do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);f=c[d>>2]|0;g=c[a+28>>2]|0;if((f|0)==-1){h=g+(c[a+32>>2]<<3)|0;break}else{h=g+(f<<3)|0;break}}else h=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((h|0)==((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)){i=b;return}a=c[h+4>>2]|0;if(!a){i=b;return}qQb(a);h=c[a+8>>2]&4095;ko[c[c[a>>2]>>2]&4095](a);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function kQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if(!a){i=b;return}f=a+8|0;if(c[f>>2]&1048576){g=kfd()|0;Oed(g,c[a+4>>2]|0,1)}qQb(a);g=c[f>>2]&4095;ko[c[c[a>>2]>>2]&4095](a);c[e>>2]=g;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function lQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a>>2]=551208;d=a+8|0;e=c[d>>2]&-2097152|c[b>>2]&4095;c[a+4>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[d>>2]=e;return}function mQb(a){a=a|0;var b=0,d=0,e=0;b=i;d=mo[c[(c[a>>2]|0)+52>>2]&4095](a)|0;e=a+8|0;c[e>>2]=c[e>>2]&2097151|d<<21;i=b;return a|0}function nQb(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+16|0;e=c[137784]|0;c[d>>2]=c[a+4>>2];c[d+4>>2]=a;gRb(b,e,d);i=b;return}function oQb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=mo[c[(c[a>>2]|0)+52>>2]&4095](a)|0;f=a+8|0;c[f>>2]=c[f>>2]&2097151|e<<21;e=c[137784]|0;c[d>>2]=c[a+4>>2];c[d+4>>2]=a;gRb(b,e,d);i=b;return}function pQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+16|0;e=(c[137826]|0)+-2|0;c[137826]=e;f=a+4|0;c[f>>2]=e;e=mo[c[(c[a>>2]|0)+52>>2]&4095](a)|0;g=a+8|0;c[g>>2]=c[g>>2]&2097151|e<<21;e=c[137784]|0;c[d>>2]=c[f>>2];c[d+4>>2]=a;gRb(b,e,d);i=b;return a|0}function qQb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b+12|0;if(c[g>>2]|0){eSb(c[g>>2]|0,b,2);h=ZRb()|0;bSb(h,c[g>>2]|0);c[g>>2]=0}g=c[137784]|0;h=b+4|0;c[f>>2]=c[h>>2];j=g+4|0;do if((c[g+36>>2]|0)!=(c[j>>2]|0)){fRb(e,g,f);k=c[e>>2]|0;l=c[g+28>>2]|0;m=c[g+32>>2]|0;if((k|0)==-1){n=l;o=m;p=l+(m<<3)|0;break}else{n=l;o=m;p=l+(k<<3)|0;break}}else{k=c[g+28>>2]|0;l=c[g+32>>2]|0;n=k;o=l;p=k+(l<<3)|0}while(0);if((p|0)!=(n+(o<<3)|0)){o=g+12|0;n=c[o+4>>2]|0;e=p;c[e>>2]=c[o>>2];c[e+4>>2]=n;c[j>>2]=(c[j>>2]|0)+1;a[g+48>>0]=1}if(0)fa(c[h>>2]|0);ko[c[(c[b>>2]|0)+8>>2]&4095](b);c[h>>2]=0;h=c[b+20>>2]|0;if(!h){i=d;return}Hrc(h,0);In[c[(c[b>>2]|0)+56>>2]&4095](b,0);i=d;return}function rQb(a){a=a|0;return}function sQb(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function tQb(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[d>>2]=c[d>>2]&-1048577|(b&1)<<20;return}function uQb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(b){c[a+16>>2]=Bsc(b)|0;c[a+20>>2]=b;i=d;return}b=a+20|0;e=c[b>>2]|0;if(!e){i=d;return}Frc(e,0);e=a+16|0;Csc(c[e>>2]|0);c[e>>2]=0;c[b>>2]=0;i=d;return}function vQb(){var a=0,b=0;a=i;i=i+16|0;b=a;rri(b,3126408,6);wQb(0,-1,b,24,0,1,0);xri(b);i=a;return}function wQb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+16|0;l=k+4|0;m=k;c[l>>2]=b;n=c[137794]|0;o=c[n+4>>2]|0;p=n+4|0;q=(o|0)==0;if(!q){r=p;s=o;a:while(1){t=s;while(1){if((c[t+16>>2]|0)>=(b|0)){u=t;break}t=c[t+4>>2]|0;if(!t){v=r;break a}}s=c[u>>2]|0;if(!s){v=u;break}else r=u}if((v|0)!=(p|0)?(c[v+16>>2]|0)<=(b|0):0){i=k;return}if(!q){q=p;v=o;b:while(1){o=v;while(1){if((c[o+16>>2]|0)>=(d|0)){w=o;break}o=c[o+4>>2]|0;if(!o){x=q;break b}}v=c[w>>2]|0;if(!v){x=w;break}else q=w}if((x|0)!=(p|0)?(c[x+16>>2]|0)<=(d|0):0)y=x;else z=15}else z=15}else z=15;if((z|0)==15)y=p;p=hRb(n,l)|0;c[p>>2]=(y|0)==((c[137794]|0)+4|0)?0:y+20|0;c[p+4>>2]=g;g=p+12|0;yri(g,e)|0;c[p+8>>2]=b;a[p+28>>0]=h&1;c[p+24>>2]=f;a[p+29>>0]=j&1;j=c[137792]|0;if(!(a[g>>0]&1))A=g+1|0;else A=c[p+20>>2]|0;c[m>>2]=A;c[(iRb(j,m)|0)>>2]=b;i=k;return}function xQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=c[137794]|0;e=c[d+4>>2]|0;f=d+4|0;if(e){d=f;g=e;a:while(1){e=g;while(1){if((c[e+16>>2]|0)>=(a|0)){h=e;break}e=c[e+4>>2]|0;if(!e){j=d;break a}}g=c[h>>2]|0;if(!g){j=h;break}else d=h}if((j|0)!=(f|0)?(c[j+16>>2]|0)<=(a|0):0)k=j;else l=8}else l=8;if((l|0)==8)k=f;i=b;return ((k|0)==(f|0)?0:k+20|0)|0}function yQb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=f+24|0;h=f+8|0;j=f+4|0;k=f;l=c[137794]|0;m=c[l+4>>2]|0;n=l+4|0;if(!m){o=0;i=f;return o|0}else{p=n;q=m}a:while(1){m=q;while(1){if((c[m+16>>2]|0)>=(a|0)){r=m;break}m=c[m+4>>2]|0;if(!m){s=p;break a}}q=c[r>>2]|0;if(!q){s=r;break}else p=r}if((s|0)==(n|0)){o=0;i=f;return o|0}if((s|0)==(n|0)?1:(c[s+16>>2]|0)>(a|0)){o=0;i=f;return o|0}a=c[s+24>>2]|0;if(!a){o=0;i=f;return o|0}s=c[d>>2]|0;if(!b){c[k>>2]=s;c[g+0>>2]=c[k+0>>2];k=_n[a&4095](g,e)|0;d=(c[137826]|0)+-2|0;c[137826]=d;n=k+4|0;c[n>>2]=d;d=mo[c[(c[k>>2]|0)+52>>2]&4095](k)|0;r=k+8|0;c[r>>2]=c[r>>2]&2097151|d<<21;if((e|0)==2){d=c[137784]|0;c[g>>2]=c[n>>2];c[g+4>>2]=k;gRb(h,d,g);o=k;i=f;return o|0}else{d=c[137784]|0;c[g>>2]=c[n>>2];c[g+4>>2]=k;gRb(h,d,g);o=k;i=f;return o|0}}c[j>>2]=s;c[g+0>>2]=c[j+0>>2];j=_n[a&4095](g,e)|0;if(!j){o=0;i=f;return o|0}a=j+4|0;c[a>>2]=b;b=mo[c[(c[j>>2]|0)+52>>2]&4095](j)|0;s=j+8|0;c[s>>2]=c[s>>2]&2097151|b<<21;if((e|0)==2){b=mo[c[(c[j>>2]|0)+52>>2]&4095](j)|0;c[s>>2]=c[s>>2]&2097151|b<<21;b=c[137784]|0;c[g>>2]=c[a>>2];c[g+4>>2]=j;gRb(h,b,g);o=j;i=f;return o|0}else if(!e){e=c[137784]|0;c[g>>2]=c[a>>2];c[g+4>>2]=j;gRb(h,e,g);o=j;i=f;return o|0}else{o=j;i=f;return o|0}return 0}function zQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if((b|0)<=0){i=d;return}f=0;do{g=a+(f<<2)|0;fRb(e,c[137784]|0,g);if((c[e>>2]|0)!=-1)c[g>>2]=0;f=f+1|0}while((f|0)!=(b|0));i=d;return}function AQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=c[137794]|0;h=c[g>>2]|0;if((h|0)==(g+4|0)){i=f;return}g=d+4|0;j=d+8|0;if(e)k=h;else{e=h;while(1){h=e+16|0;l=c[h>>2]|0;m=(da(c[137788]|0,l)|0)+b|0;n=m>>5;do if(1<<m-(n<<5)&c[(c[137786]|0)+(n<<2)>>2]){o=c[g>>2]|0;if((o|0)==(c[j>>2]|0)){JO(d,h);break}if(o)c[o>>2]=l;c[g>>2]=o+4}while(0);l=c[e+4>>2]|0;if(!l){h=e;while(1){n=c[h+8>>2]|0;if((c[n>>2]|0)==(h|0)){p=n;break}else h=n}}else{h=l;while(1){n=c[h>>2]|0;if(!n){p=h;break}else h=n}}if((p|0)==((c[137794]|0)+4|0))break;else e=p}i=f;return}while(1){p=k+16|0;e=c[p>>2]|0;h=(da(c[137788]|0,e)|0)+b|0;l=h>>5;do if((1<<h-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0?(a[k+48>>0]|0)==0:0){n=c[g>>2]|0;if((n|0)==(c[j>>2]|0)){JO(d,p);break}if(n)c[n>>2]=e;c[g>>2]=n+4}while(0);e=c[k+4>>2]|0;if(!e){p=k;while(1){l=c[p+8>>2]|0;if((c[l>>2]|0)==(p|0)){q=l;break}else p=l}}else{p=e;while(1){l=c[p>>2]|0;if(!l){q=p;break}else p=l}}if((q|0)==((c[137794]|0)+4|0))break;else k=q}i=f;return}function BQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+3|0;h=f+2|0;j=c[137784]|0;a[h+0>>0]=a[f+1>>0]|0;a[g+0>>0]=a[f+0>>0]|0;k=jRb(j,b,h,d,e,g)|0;i=f;return k|0}function CQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+3|0;h=f+2|0;j=c[137784]|0;a[h+0>>0]=a[f+1>>0]|0;a[g+0>>0]=a[f+0>>0]|0;k=kRb(j,b,h,d,e,g)|0;i=f;return k|0}function DQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+16|0;g=f;h=f+4|0;j=c[137784]|0;k=c[j+28>>2]|0;l=c[j+32>>2]|0;m=k+(l<<3)|0;a:do if(!l){n=k;o=8}else{p=c[j+20>>2]|0;q=j+8|0;r=j+4|0;s=j+12|0;t=k;while(1){u=c[t>>2]|0;if((p|0)!=(u|0)){if(!(a[q>>0]|0)){n=t;o=8;break a}if(!(c[r>>2]|0)){n=t;o=8;break a}if((c[s>>2]|0)!=(u|0)){n=t;o=8;break a}}t=t+8|0;if((t|0)==(m|0)){v=0;break}}}while(0);if((o|0)==8)if((n|0)==(m|0))v=0;else{o=j+20|0;k=j+8|0;l=j+4|0;t=j+12|0;j=(d|0)==0;s=d+8|0;r=d+12|0;q=d+4|0;p=n;n=0;while(1){u=c[p+4>>2]|0;w=(da(c[137788]|0,(c[u+8>>2]|0)>>>21)|0)+b|0;x=w>>5;if(!(1<<w-(x<<5)&c[(c[137786]|0)+(x<<2)>>2]))y=n;else{if(!j){x=(c[s>>2]|0)+1|0;c[s>>2]=x;w=c[r>>2]|0;z=w&2147483647;if(x>>>0>z>>>0){A=w<<1;B=(A|0)==0?1:A;do if(z>>>0<B>>>0)if((w|0)>-1){c[r>>2]=B;A=c[d>>2]|0;c[h>>2]=c[q>>2];c[g+0>>2]=c[h+0>>2];c[d>>2]=hOb(A,B<<2,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[q>>2];c[g+0>>2]=c[h+0>>2];A=cOb(B<<2,4,g,0,3653512,352)|0;YEi(A|0,c[d>>2]|0,c[s>>2]<<2|0)|0;c[r>>2]=B;c[d>>2]=A;break}while(0);C=c[s>>2]|0}else C=x;c[(c[d>>2]|0)+(C+-1<<2)>>2]=u}y=n+1|0}B=p+8|0;b:do if((B|0)==(m|0))D=m;else{w=c[o>>2]|0;z=B;A=p;while(1){E=c[A+8>>2]|0;if((w|0)!=(E|0)){if(!(a[k>>0]|0)){D=z;break b}if(!(c[l>>2]|0)){D=z;break b}if((c[t>>2]|0)!=(E|0)){D=z;break b}}E=A+16|0;if((E|0)==(m|0)){D=m;break}else{F=z;z=E;A=F}}}while(0);B=c[137784]|0;if((D|0)==((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)){v=y;break}else{p=D;n=y}}}if(!((d|0)!=0&e)){i=f;return v|0}e=c[d>>2]|0;lRb(e,e+(c[d+8>>2]<<2)|0,g);i=f;return v|0}function EQb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;if(!(a[551328]|0)){c[137828]=0;c[137829]=0;c[137830]=0;a[551328]=1}e=c[137794]|0;f=c[e+4>>2]|0;g=e+4|0;if(f){e=g;h=f;a:while(1){f=h;while(1){if((c[f+16>>2]|0)>=(b|0)){j=f;break}f=c[f+4>>2]|0;if(!f){k=e;break a}}h=c[j>>2]|0;if(!h){k=j;break}else e=j}if((k|0)!=(g|0)?(c[k+16>>2]|0)<=(b|0):0)l=k;else m=10}else m=10;if((m|0)==10)l=g;i=d;return ((l|0)==(g|0)?551312:l+32|0)|0}function FQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=c[137792]|0;e=c[d+4>>2]|0;f=d+4|0;if(!e){g=-1;i=b;return g|0}else{h=f;j=e}a:while(1){e=j;while(1){if((HEi(c[e+16>>2]|0,a)|0)>=0){k=e;break}e=c[e+4>>2]|0;if(!e){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)==(f|0)){g=-1;i=b;return g|0}if((HEi(a,c[l+16>>2]|0)|0)<0|(l|0)==(f|0)){g=-1;i=b;return g|0}g=c[l+20>>2]|0;i=b;return g|0}function GQb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=(c[b+8>>2]|0)>>>21;if(!(a[551328]|0)){c[137828]=0;c[137829]=0;c[137830]=0;a[551328]=1}b=c[137794]|0;f=c[b+4>>2]|0;g=b+4|0;if(f){b=g;h=f;a:while(1){f=h;while(1){if((c[f+16>>2]|0)>=(e|0)){j=f;break}f=c[f+4>>2]|0;if(!f){k=b;break a}}h=c[j>>2]|0;if(!h){k=j;break}else b=j}if((k|0)!=(g|0)?(c[k+16>>2]|0)<=(e|0):0)l=k;else m=10}else m=10;if((m|0)==10)l=g;i=d;return ((l|0)==(g|0)?551312:l+32|0)|0}function HQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=c[137794]|0;e=c[d+4>>2]|0;f=d+4|0;if(e){d=f;g=e;a:while(1){e=g;while(1){if((c[e+16>>2]|0)>=(a|0)){h=e;break}e=c[e+4>>2]|0;if(!e){j=d;break a}}g=c[h>>2]|0;if(!g){j=h;break}else d=h}if((j|0)!=(f|0)?(c[j+16>>2]|0)<=(a|0):0)k=j;else l=8}else l=8;if((l|0)==8)k=f;f=c[k+20>>2]|0;if(!f){m=0;i=b;return m|0}m=c[f+8>>2]|0;i=b;return m|0}function IQb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a=i;b=c[137834]|0;if(!b){i=a;return}d=b+4|0;e=c[d>>2]|0;f=c[b>>2]|0;if((e|0)!=(f|0)){g=e;e=f;f=0;while(1){h=c[e+(f*20|0)>>2]|0;if(!h){j=g;k=e}else{eo[h&511]();j=c[d>>2]|0;k=c[b>>2]|0}f=f+1|0;if(f>>>0>=((j-k|0)/20|0)>>>0)break;else{g=j;e=k}}}c[137788]=301;mRb(c[137798]|0,90601,0);c[137786]=c[(c[137798]|0)+4>>2];mRb(c[137796]|0,c[137788]|0,0);if(!(c[137788]|0)){i=a;return}k=c[137794]|0;e=c[k+4>>2]|0;j=0;do{g=k+4|0;f=(e|0)==0;if(!f){b=g;d=e;a:while(1){h=d;while(1){if((c[h+16>>2]|0)>=(j|0)){l=h;break}h=c[h+4>>2]|0;if(!h){m=b;break a}}d=c[l>>2]|0;if(!d){m=l;break}else b=l}if((m|0)!=(g|0)?(j|0)>=(c[m+16>>2]|0):0){b=1<<(j&31);d=c[(c[137796]|0)+4>>2]|0;if((m|0)==(g|0)){n=m;o=b;p=d;q=18}else{h=d+(j>>>5<<2)|0;c[h>>2]=c[h>>2]|b;r=m;s=d;t=b}}else q=15}else q=15;if((q|0)==15){q=0;n=g;o=1<<(j&31);p=c[(c[137796]|0)+4>>2]|0;q=18}if((q|0)==18){q=0;b=p+(j>>>5<<2)|0;c[b>>2]=c[b>>2]&~o;r=n;s=p;t=o}b=c[137788]|0;if(c[s+(j>>>5<<2)>>2]&t)if(!b)u=0;else{d=r+20|0;h=b;v=0;while(1){do if(!f){w=g;x=e;b:while(1){y=x;while(1){if((c[y+16>>2]|0)>=(v|0)){z=y;break}y=c[y+4>>2]|0;if(!y){A=w;break b}}x=c[z>>2]|0;if(!x){A=z;break}else w=z}if((A|0)!=(g|0)?!((A|0)==(g|0)?1:(v|0)<(c[A+16>>2]|0)):0){w=c[137798]|0;x=(da(h,j)|0)+v|0;y=A+20|0;B=d;while(1){if((B|0)==(y|0)){q=32;break}B=c[B>>2]|0;if(!B){q=33;break}}if((q|0)==32){q=0;B=(c[w+4>>2]|0)+(x>>>5<<2)|0;c[B>>2]=c[B>>2]|1<<(x&31);break}else if((q|0)==33){q=0;B=(c[w+4>>2]|0)+(x>>>5<<2)|0;c[B>>2]=c[B>>2]&~(1<<(x&31));break}}}while(0);v=v+1|0;B=c[137788]|0;if(v>>>0>=B>>>0){u=B;break}else h=B}}else u=b;j=j+1|0}while(j>>>0<u>>>0);i=a;return}function JQb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;b=c[137834]|0;d=b+4|0;e=c[d>>2]|0;f=c[b>>2]|0;if((e|0)==(f|0)){i=a;return}else{g=e;h=f;j=0}while(1){f=c[h+(j*20|0)+8>>2]|0;if(!f){k=g;l=h}else{eo[f&511]();k=c[d>>2]|0;l=c[b>>2]|0}j=j+1|0;if(j>>>0>=((k-l|0)/20|0)>>>0)break;else{g=k;h=l}}i=a;return}function KQb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;b=c[137834]|0;d=b+4|0;e=c[d>>2]|0;f=c[b>>2]|0;if((e|0)==(f|0)){i=a;return}else{g=e;h=f;j=0}while(1){f=c[h+(j*20|0)+12>>2]|0;if(!f){k=g;l=h}else{eo[f&511]();k=c[d>>2]|0;l=c[b>>2]|0}j=j+1|0;if(j>>>0>=((k-l|0)/20|0)>>>0)break;else{g=k;h=l}}i=a;return}function LQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=ZRb()|0;g=a+12|0;c[g>>2]=aSb(f,b,d,c[g>>2]|0)|0;i=e;return}function MQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=ZRb()|0;g=a+12|0;c[g>>2]=dSb(f,c[g>>2]|0,b,d)|0;i=e;return}function NQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=cSb(c[a+12>>2]|0,b,d)|0;i=e;return f|0}function OQb(a,b){a=a|0;b=b|0;var d=0;d=i;eSb(c[a+12>>2]|0,a,b);i=d;return}function PQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;c[e>>2]=a;f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(d,f,e);g=c[d>>2]|0;h=c[f+28>>2]|0;if((g|0)==-1){j=h+(c[f+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if((j|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(c[j+4>>2]|0)!=0:0){k=1;i=b;return k|0}}k=gfd(kfd()|0,a)|0;i=b;return k|0}function QQb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+528|0;h=g;j=g+4|0;k=g+8|0;l=c[137834]|0;if(!l){c[j>>2]=c[153106];c[h+0>>2]=c[j+0>>2];j=bOb(12,h,0,16,3653512,1269)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[137834]=j;m=j}else m=l;l=m+4|0;j=c[l>>2]|0;n=c[m>>2]|0;o=(j-n|0)/20|0;do if((o|0)<=(a|0)){p=a+1|0;if(p>>>0>o>>>0){nRb(m,p-o|0);break}if(p>>>0<o>>>0?(q=n+(p*20|0)|0,(j|0)!=(q|0)):0)c[l>>2]=j+(~(((j+-20-q|0)>>>0)/20|0)*20|0)}while(0);j=c[137834]|0;l=c[j>>2]|0;if((((c[l+(a*20|0)>>2]|0)==0?(c[l+(a*20|0)+8>>2]|0)==0:0)?(c[l+(a*20|0)+12>>2]|0)==0:0)?(c[l+(a*20|0)+16>>2]|0)==0:0){r=l;s=r+(a*20|0)|0;c[s>>2]=b;t=r+(a*20|0)+8|0;c[t>>2]=d;u=r+(a*20|0)+12|0;c[u>>2]=e;v=r+(a*20|0)+16|0;c[v>>2]=f;i=g;return}c[h>>2]=a;rEi(k,512,551344,h)|0;Krd(k,0,3653512,1279,32785,0,0,0);r=c[j>>2]|0;s=r+(a*20|0)|0;c[s>>2]=b;t=r+(a*20|0)+8|0;c[t>>2]=d;u=r+(a*20|0)+12|0;c[u>>2]=e;v=r+(a*20|0)+16|0;c[v>>2]=f;i=g;return}function RQb(b){b=b|0;a[551408]=b&1;return}function SQb(){return (a[551408]|0)!=0|0}function TQb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+8>>2]&4095;ko[c[c[a>>2]>>2]&4095](a);c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function UQb(){if((c[137826]|0)>-1e4)c[137826]=-1e4;return}function VQb(a){a=a|0;return c[a+8>>2]&4095|0}function WQb(a){a=a|0;return 0}function XQb(a,b){a=a|0;b=b|0;return}function YQb(a,b){a=a|0;b=b|0;return}function ZQb(a,b){a=a|0;b=b|0;return}function _Qb(a,b){a=a|0;b=b|0;return}function $Qb(a,b){a=a|0;b=b|0;return}function aRb(a,b){a=a|0;b=b|0;return}function bRb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e+4|0;g=e;c[b+4>>2]=0;h=b+8|0;a[h>>0]=0;j=b+9|0;a[j>>0]=0;k=b+12|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;k=32;while(1){if(k>>>0>=d>>>0?(l=ea(k>>>0),m=ea(l*ea(.5)),!(m<=ea(0.0))):0){n=l;o=m;p=k;break}k=k<<1}k=b+32|0;c[k>>2]=p;c[b+36>>2]=0;c[b+44>>2]=~~o>>>0;c[b+40>>2]=~~ea(n*ea(.200000003))>>>0;a[b+48>>0]=0;a[j>>0]=1;j=b+20|0;d=j;c[d>>2]=-1;c[d+4>>2]=0;c[g>>2]=57;c[f+0>>2]=c[g+0>>2];g=cOb(p<<3,16,f,0,3653512,80)|0;c[b+28>>2]=g;f=g+(c[k>>2]<<3)|0;if((g|0)==(f|0)){HRb(b);a[h>>0]=1;q=b+12|0;r=q;s=r;c[s>>2]=-2;t=r+4|0;u=t;c[u>>2]=0;i=e;return}else v=g;do{if(v){g=j;k=c[g+4>>2]|0;p=v;c[p>>2]=c[g>>2];c[p+4>>2]=k}v=v+8|0}while((v|0)!=(f|0));HRb(b);a[h>>0]=1;q=b+12|0;r=q;s=r;c[s>>2]=-2;t=r+4|0;u=t;c[u>>2]=0;i=e;return}function cRb(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{cRb(a,c[b>>2]|0);cRb(a,c[b+4>>2]|0);ACi(b);i=d;return}}function dRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}dRb(a,c[b>>2]|0);dRb(a,c[b+4>>2]|0);xri(b+32|0);c[f>>2]=1;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function eRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[a>>2]|0;if(!f){g=0;i=b;return g|0}c[e>>2]=f;f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(d,f,e);h=c[d>>2]|0;j=c[f+28>>2]|0;if((h|0)==-1){k=j+(c[f+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if((k|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(f=c[k+4>>2]|0,(f|0)!=0):0){g=f;i=b;return g|0}}f=c[a>>2]|0;if((f|0)<1){g=0;i=b;return g|0}g=_ed(kfd()|0,f,-1)|0;i=b;return g|0}function fRb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=(c[d+32>>2]|0)+-1|0;h=c[e>>2]|0;e=h+2127912214+(h<<12)|0;j=e^-949894596^e>>>19;e=j+374761393+(j<<5)|0;j=e+-744332180^e<<9;e=j+-42973499+(j<<3)|0;j=(e^-1252372727^e>>>16)&g;e=c[d+28>>2]|0;k=c[d+20>>2]|0;l=c[e+(j<<3)>>2]|0;a:do if((k|0)==(l|0)){m=j;n=5}else{o=d+4|0;p=d+12|0;b:do if(!(a[d+8>>0]|0)){q=l;r=j;s=0;while(1){if((h|0)==(q|0)){t=r;break b}s=s+1|0;u=s+r&g;q=c[e+(u<<3)>>2]|0;if((k|0)==(q|0)){m=u;n=5;break a}else r=u}}else{r=l;q=-1;s=j;u=0;while(1){if((c[o>>2]|0)!=0?(c[p>>2]|0)==(r|0):0)v=(q|0)==-1?s:q;else if((h|0)==(r|0)){t=s;break b}else v=q;u=u+1|0;w=u+s&g;r=c[e+(w<<3)>>2]|0;if((k|0)==(r|0)){x=v;y=w;break}else{q=v;s=w}}c[b>>2]=-1;s=b+4|0;if((x|0)==-1){z=y;A=s;break a}c[s>>2]=x;i=f;return}while(0);c[b>>2]=t;c[b+4>>2]=-1;i=f;return}while(0);if((n|0)==5){c[b>>2]=-1;z=m;A=b+4|0}c[A>>2]=z;i=f;return}function gRb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;IRb(d,1,0);fRb(g,d,e);h=c[g>>2]|0;if((h|0)!=-1){j=c[d+28>>2]|0;k=j+(c[d+32>>2]<<3)|0;c[b>>2]=d;c[b+4>>2]=j+(h<<3);c[b+8>>2]=k;a[b+12>>0]=0;i=f;return}k=c[g+4>>2]|0;if(((a[d+8>>0]|0)!=0?(g=d+4|0,h=c[g>>2]|0,(h|0)!=0):0)?(j=c[d+28>>2]|0,(c[d+12>>2]|0)==(c[j+(k<<3)>>2]|0)):0){c[g>>2]=h+-1;l=j}else{j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;l=c[d+28>>2]|0}j=l+(k<<3)|0;if(!j)m=l;else{l=e;e=c[l+4>>2]|0;h=j;c[h>>2]=c[l>>2];c[h+4>>2]=e;m=c[d+28>>2]|0}e=m+(c[d+32>>2]<<3)|0;c[b>>2]=d;c[b+4>>2]=m+(k<<3);c[b+8>>2]=e;a[b+12>>0]=1;i=f;return}function hRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+4|0;j=c[h>>2]|0;do if(j){k=c[b>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((k|0)<(m|0)){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((m|0)>=(k|0)){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=a+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=g;x=w+20|0;i=d;return x|0}c[f>>2]=1;c[e+0>>2]=c[f+0>>2];f=cOb(52,16,e,0,3653512,80)|0;c[f+16>>2]=c[b>>2];b=f+20|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=v;c[u>>2]=f;v=c[c[a>>2]>>2]|0;if(!v)y=f;else{c[a>>2]=v;y=c[u>>2]|0}GN(c[h>>2]|0,y);y=a+8|0;c[y>>2]=(c[y>>2]|0)+1;w=f;x=w+20|0;i=d;return x|0}function iRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=c[b>>2]|0;j=g;while(1){k=c[j+16>>2]|0;if((HEi(h,k)|0)<0){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if((HEi(k,h)|0)>=0){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=a+4|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+20|0;i=d;return v|0}e=xCi(24)|0;c[e+16>>2]=c[b>>2];c[e+20>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=c[c[a>>2]>>2]|0;if(!t)w=e;else{c[a>>2]=t;w=c[s>>2]|0}GN(c[f>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;u=e;v=u+20|0;i=d;return v|0}function jRb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+16|0;e=h;j=b+28|0;k=c[j>>2]|0;l=b+32|0;m=c[l>>2]|0;n=k+(m<<3)|0;o=(m|0)==0;if(!f){a:do if(o)p=k;else{m=c[b+20>>2]|0;q=(c[b+4>>2]|0)!=0&(a[b+8>>0]|0)!=0;r=c[b+12>>2]|0;s=k;while(1){t=c[s>>2]|0;if(!((m|0)==(t|0)|q&(r|0)==(t|0))){p=s;break a}s=s+8|0;if((s|0)==(n|0)){u=0;break}}i=h;return u|0}while(0);if((p|0)==(n|0)){u=0;i=h;return u|0}s=c[137788]|0;r=c[137786]|0;q=c[b+20>>2]|0;m=(c[b+4>>2]|0)!=0&(a[b+8>>0]|0)!=0;t=c[b+12>>2]|0;v=p;p=0;b:while(1){w=(da((c[(c[v+4>>2]|0)+8>>2]|0)>>>21,s)|0)+d|0;x=w>>5;y=((1<<w-(x<<5)&c[r+(x<<2)>>2]|0)!=0&1)+p|0;x=v+8|0;if((x|0)==(n|0)){u=y;z=35;break}c:do if(m){w=x;A=v;while(1){B=c[A+8>>2]|0;if(!((q|0)==(B|0)|(t|0)==(B|0))){C=w;break c}B=A+16|0;if((B|0)==(n|0)){u=y;z=35;break b}else{D=w;w=B;A=D}}}else{A=x;w=v;while(1){if((q|0)!=(c[w+8>>2]|0)){C=A;break c}D=w+16|0;if((D|0)==(n|0)){u=y;z=35;break b}else{B=A;A=D;w=B}}}while(0);if((C|0)==(n|0)){u=y;z=35;break}else{v=C;p=y}}if((z|0)==35){i=h;return u|0}}d:do if(o)E=k;else{z=c[b+20>>2]|0;p=(c[b+4>>2]|0)!=0&(a[b+8>>0]|0)!=0;C=c[b+12>>2]|0;v=k;while(1){q=c[v>>2]|0;if(!((z|0)==(q|0)|p&(C|0)==(q|0))){E=v;break d}v=v+8|0;if((v|0)==(n|0)){u=0;break}}i=h;return u|0}while(0);if((E|0)==(n|0)){u=0;i=h;return u|0}k=b+20|0;o=b+8|0;v=b+4|0;C=b+12|0;b=f+4|0;p=f+8|0;z=E;E=0;while(1){y=(da(c[137788]|0,(c[(c[z+4>>2]|0)+8>>2]|0)>>>21)|0)+d|0;q=y>>5;if(!(1<<y-(q<<5)&c[(c[137786]|0)+(q<<2)>>2]))F=E;else{q=c[b>>2]|0;if((q|0)==(c[p>>2]|0))JO(f,z);else{if(q)c[q>>2]=c[z>>2];c[b>>2]=q+4}F=E+1|0}q=z+8|0;e:do if((q|0)==(n|0))G=n;else{y=c[k>>2]|0;t=(c[v>>2]|0)!=0&(a[o>>0]|0)!=0;m=c[C>>2]|0;r=z;s=q;while(1){x=c[r+8>>2]|0;if(!((y|0)==(x|0)|t&(m|0)==(x|0))){G=s;break e}x=r+16|0;if((x|0)==(n|0)){G=n;break}else{w=s;s=x;r=w}}}while(0);if((G|0)==((c[j>>2]|0)+(c[l>>2]<<3)|0)){H=F;break}else{z=G;E=F}}if(!((H|0)!=0&g)){u=H;i=h;return u|0}JRb(c[f>>2]|0,c[f+4>>2]|0,e);u=H;i=h;return u|0}function kRb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;i=i+16|0;e=h;j=b+28|0;k=c[j>>2]|0;l=b+32|0;m=c[l>>2]|0;n=k+(m<<3)|0;o=(m|0)==0;if(!f){a:do if(o)p=k;else{m=c[b+20>>2]|0;q=(c[b+4>>2]|0)!=0&(a[b+8>>0]|0)!=0;r=c[b+12>>2]|0;s=k;while(1){t=c[s>>2]|0;if(!((m|0)==(t|0)|q&(r|0)==(t|0))){p=s;break a}s=s+8|0;if((s|0)==(n|0)){u=0;break}}i=h;return u|0}while(0);if((p|0)==(n|0)){u=0;i=h;return u|0}s=c[137788]|0;r=c[137786]|0;q=c[b+20>>2]|0;m=(c[b+4>>2]|0)!=0&(a[b+8>>0]|0)!=0;t=c[b+12>>2]|0;v=p;p=0;b:while(1){w=(da((c[(c[v+4>>2]|0)+8>>2]|0)>>>21,s)|0)+d|0;x=w>>5;y=((1<<w-(x<<5)&c[r+(x<<2)>>2]|0)!=0&1)+p|0;x=v+8|0;if((x|0)==(n|0)){u=y;z=35;break}c:do if(m){w=x;A=v;while(1){B=c[A+8>>2]|0;if(!((q|0)==(B|0)|(t|0)==(B|0))){C=w;break c}B=A+16|0;if((B|0)==(n|0)){u=y;z=35;break b}else{D=w;w=B;A=D}}}else{A=x;w=v;while(1){if((q|0)!=(c[w+8>>2]|0)){C=A;break c}D=w+16|0;if((D|0)==(n|0)){u=y;z=35;break b}else{B=A;A=D;w=B}}}while(0);if((C|0)==(n|0)){u=y;z=35;break}else{v=C;p=y}}if((z|0)==35){i=h;return u|0}}d:do if(o)E=k;else{z=c[b+20>>2]|0;p=(c[b+4>>2]|0)!=0&(a[b+8>>0]|0)!=0;C=c[b+12>>2]|0;v=k;while(1){q=c[v>>2]|0;if(!((z|0)==(q|0)|p&(C|0)==(q|0))){E=v;break d}v=v+8|0;if((v|0)==(n|0)){u=0;break}}i=h;return u|0}while(0);if((E|0)==(n|0)){u=0;i=h;return u|0}k=b+20|0;o=b+8|0;v=b+4|0;C=b+12|0;b=f+4|0;p=f+8|0;z=E;E=0;while(1){y=z+4|0;q=c[y>>2]|0;t=(da(c[137788]|0,(c[q+8>>2]|0)>>>21)|0)+d|0;m=t>>5;if(!(1<<t-(m<<5)&c[(c[137786]|0)+(m<<2)>>2]))F=E;else{m=c[b>>2]|0;if((m|0)==(c[p>>2]|0))KRb(f,y);else{if(!m)G=0;else{c[m>>2]=q;G=c[b>>2]|0}c[b>>2]=G+4}F=E+1|0}q=z+8|0;e:do if((q|0)==(n|0))H=n;else{m=c[k>>2]|0;y=(c[v>>2]|0)!=0&(a[o>>0]|0)!=0;t=c[C>>2]|0;r=z;s=q;while(1){x=c[r+8>>2]|0;if(!((m|0)==(x|0)|y&(t|0)==(x|0))){H=s;break e}x=r+16|0;if((x|0)==(n|0)){H=n;break}else{w=s;s=x;r=w}}}while(0);if((H|0)==((c[j>>2]|0)+(c[l>>2]<<3)|0)){I=F;break}else{z=H;E=F}}if(!((I|0)!=0&g)){u=I;i=h;return u|0}lRb(c[f>>2]|0,c[f+4>>2]|0,e);u=I;i=h;return u|0}function lRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-4|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>2;switch(l|0){case 3:{m=h;n=g;o=6;break a;break}case 4:{p=h;q=g;o=14;break a;break}case 2:{r=h;s=g;o=4;break a;break}case 5:{t=h;u=g;o=26;break a;break}case 1:case 0:{o=86;break a;break}default:{}}if((k|0)<124){v=h;w=a;o=28;break a}x=(l|0)/2|0;y=h+(x<<2)|0;do if((k|0)<=3996){z=c[y>>2]|0;A=c[h>>2]|0;B=c[z+4>>2]|0;C=c[A+4>>2]|0;D=c[g>>2]|0;E=(c[D+4>>2]|0)<(B|0);if((B|0)>=(C|0)){if(!E){F=0;break}c[y>>2]=D;c[g>>2]=z;B=c[y>>2]|0;G=c[h>>2]|0;if((c[B+4>>2]|0)>=(c[G+4>>2]|0)){F=1;break}c[h>>2]=B;c[y>>2]=G;F=2;break}if(E){c[h>>2]=D;c[g>>2]=A;F=1;break}c[h>>2]=z;c[y>>2]=A;z=c[g>>2]|0;if((c[z+4>>2]|0)<(C|0)){c[y>>2]=z;c[g>>2]=A;F=2}else F=1}else{A=(l|0)/4|0;F=LRb(h,h+(A<<2)|0,y,h+(A+x<<2)|0,g,d)|0}while(0);x=c[h>>2]|0;l=c[x+4>>2]|0;k=c[(c[y>>2]|0)+4>>2]|0;do if((l|0)<(k|0)){H=g;I=F}else{A=a;z=g;while(1){C=A+-8|0;if((h|0)==(C|0))break;D=c[C>>2]|0;if((c[D+4>>2]|0)<(k|0)){J=D;K=C;o=68;break}else{D=z;z=C;A=D}}if((o|0)==68){o=0;c[h>>2]=J;c[K>>2]=x;H=K;I=F+1|0;break}A=h+4|0;z=c[g>>2]|0;if((l|0)<(c[z+4>>2]|0))L=A;else{if((A|0)==(g|0)){o=86;break a}else{M=h;N=A}while(1){A=c[N>>2]|0;D=M+8|0;if((l|0)<(c[A+4>>2]|0)){O=A;P=N;break}if((D|0)==(g|0)){o=86;break a}else{A=N;N=D;M=A}}c[P>>2]=z;c[g>>2]=O;L=P+4|0}if((L|0)==(g|0)){o=86;break a}else{Q=L;R=g}while(1){A=c[(c[h>>2]|0)+4>>2]|0;D=Q;while(1){C=c[D>>2]|0;E=D+4|0;if((A|0)<(c[C+4>>2]|0)){S=C;T=E;U=D;break}else D=E}D=R;while(1){E=D+-4|0;C=c[E>>2]|0;if((A|0)<(c[C+4>>2]|0))D=E;else{V=E;W=C;break}}if(U>>>0>=V>>>0){h=U;continue b}c[U>>2]=W;c[V>>2]=S;Q=T;R=V}}while(0);l=h+4|0;c:do if(l>>>0<H>>>0){x=l;k=H;z=y;D=I;while(1){A=c[(c[z>>2]|0)+4>>2]|0;C=x;while(1){E=c[C>>2]|0;G=C+4|0;if((c[E+4>>2]|0)<(A|0))C=G;else{X=E;Y=G;Z=C;break}}C=k;while(1){G=C+-4|0;E=c[G>>2]|0;if((c[E+4>>2]|0)<(A|0)){_=G;$=E;break}else C=G}if(Z>>>0>_>>>0){aa=Z;ba=z;ca=D;break c}c[Z>>2]=$;c[_>>2]=X;x=Y;k=_;z=(z|0)==(Z|0)?_:z;D=D+1|0}}else{aa=l;ba=y;ca=I}while(0);if((aa|0)!=(ba|0)?(y=c[ba>>2]|0,l=c[aa>>2]|0,(c[y+4>>2]|0)<(c[l+4>>2]|0)):0){c[aa>>2]=y;c[ba>>2]=l;da=ca+1|0}else da=ca;if(!da){ea=MRb(h,aa,d)|0;l=aa+4|0;if(MRb(l,a,d)|0){o=81;break}if(ea){h=l;continue}}l=aa;if((l-j|0)>=(b-l|0)){fa=h;ga=aa;o=85;break}lRb(h,aa,d);h=aa+4|0}if((o|0)==81){o=0;if(ea){o=86;break}else{f=h;a=aa;continue}}else if((o|0)==85){o=0;lRb(ga+4|0,a,d);f=fa;a=ga;continue}}if((o|0)==4){ga=c[s>>2]|0;a=c[r>>2]|0;if((c[ga+4>>2]|0)>=(c[a+4>>2]|0)){i=e;return}c[r>>2]=ga;c[s>>2]=a;i=e;return}else if((o|0)==6){a=m+4|0;s=c[a>>2]|0;ga=c[m>>2]|0;r=c[s+4>>2]|0;fa=c[ga+4>>2]|0;f=c[n>>2]|0;aa=(c[f+4>>2]|0)<(r|0);if((r|0)>=(fa|0)){if(!aa){i=e;return}c[a>>2]=f;c[n>>2]=s;r=c[a>>2]|0;ea=c[m>>2]|0;if((c[r+4>>2]|0)>=(c[ea+4>>2]|0)){i=e;return}c[m>>2]=r;c[a>>2]=ea;i=e;return}if(aa){c[m>>2]=f;c[n>>2]=ga;i=e;return}c[m>>2]=s;c[a>>2]=ga;s=c[n>>2]|0;if((c[s+4>>2]|0)>=(fa|0)){i=e;return}c[a>>2]=s;c[n>>2]=ga;i=e;return}else if((o|0)==14){ga=p+4|0;n=p+8|0;s=c[ga>>2]|0;a=c[p>>2]|0;fa=c[s+4>>2]|0;m=c[a+4>>2]|0;f=c[n>>2]|0;aa=c[f+4>>2]|0;ea=(aa|0)<(fa|0);do if((fa|0)<(m|0)){if(ea){c[p>>2]=f;c[n>>2]=a;ha=a;break}c[p>>2]=s;c[ga>>2]=a;if((aa|0)<(m|0)){c[ga>>2]=f;c[n>>2]=a;ha=a}else ha=f}else if(ea){c[ga>>2]=f;c[n>>2]=s;if((aa|0)<(m|0)){c[p>>2]=f;c[ga>>2]=a;ha=s}else ha=s}else ha=f;while(0);f=c[q>>2]|0;if((c[f+4>>2]|0)>=(c[ha+4>>2]|0)){i=e;return}c[n>>2]=f;c[q>>2]=ha;ha=c[n>>2]|0;q=c[ga>>2]|0;f=c[ha+4>>2]|0;if((f|0)>=(c[q+4>>2]|0)){i=e;return}c[ga>>2]=ha;c[n>>2]=q;q=c[p>>2]|0;if((f|0)>=(c[q+4>>2]|0)){i=e;return}c[p>>2]=ha;c[ga>>2]=q;i=e;return}else if((o|0)==26){LRb(t,t+4|0,t+8|0,t+12|0,u,d)|0;i=e;return}else if((o|0)==28){d=v+8|0;u=v+4|0;t=c[u>>2]|0;q=c[v>>2]|0;ga=c[t+4>>2]|0;ha=c[q+4>>2]|0;p=c[d>>2]|0;f=c[p+4>>2]|0;n=(f|0)<(ga|0);do if((ga|0)<(ha|0)){if(n){c[v>>2]=p;c[d>>2]=q;ia=q;break}c[v>>2]=t;c[u>>2]=q;if((f|0)<(ha|0)){c[u>>2]=p;c[d>>2]=q;ia=q}else ia=p}else if(n){c[u>>2]=p;c[d>>2]=t;if((f|0)<(ha|0)){c[v>>2]=p;c[u>>2]=q;ia=t}else ia=t}else ia=p;while(0);p=v+12|0;if((p|0)==(w|0)){i=e;return}else{ja=ia;ka=p;la=d}while(1){d=c[ka>>2]|0;p=c[d+4>>2]|0;if((p|0)<(c[ja+4>>2]|0)){ia=ja;t=ka;q=la;while(1){c[t>>2]=ia;if((q|0)==(v|0)){ma=v;break}u=q+-4|0;ia=c[u>>2]|0;if((p|0)>=(c[ia+4>>2]|0)){ma=q;break}else{ha=q;q=u;t=ha}}c[ma>>2]=d}t=ka+4|0;if((t|0)==(w|0))break;q=ka;ja=c[ka>>2]|0;ka=t;la=q}i=e;return}else if((o|0)==86){i=e;return}}function mRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=a+8|0;if((c[l>>2]|0)==(b|0)){i=e;return}if(!b){c[l>>2]=0;c[a+12>>2]=0;m=a+4|0;n=c[m>>2]|0;c[g>>2]=c[a>>2];c[f+0>>2]=c[g+0>>2];eOb(n,f);c[m>>2]=0;i=e;return}m=(b+31|0)>>>5;n=m<<2;c[h>>2]=c[a>>2];c[f+0>>2]=c[h+0>>2];h=cOb(n,4,f,0,3653512,399)|0;g=a+4|0;o=c[g>>2]|0;if((c[l>>2]|0)>>>0<=b>>>0){p=a+12|0;aFi(h|0,o|0,c[p>>2]<<2|0)|0;q=d<<31>>31;r=c[p>>2]|0;s=m-r<<2;if((s|0)>0){t=s>>2;s=h+(r<<2)|0;while(1){c[s>>2]=q;t=t+-1|0;if((t|0)<=0)break;else s=s+4|0}u=c[p>>2]|0}else u=r;r=c[g>>2]|0;c[g>>2]=h;s=c[l>>2]|0;a:do if(s>>>0<u<<5>>>0){t=h;q=s;while(1){v=1<<(q&31);if(d){w=t+(q>>>5<<2)|0;c[w>>2]=c[w>>2]|v}else{w=t+(q>>>5<<2)|0;c[w>>2]=c[w>>2]&~v}v=q+1|0;if(v>>>0>=c[p>>2]<<5>>>0)break a;t=c[g>>2]|0;q=v}}while(0);if(!r)x=p;else{c[k>>2]=c[a>>2];c[f+0>>2]=c[k+0>>2];eOb(r,f);x=p}}else{aFi(h|0,o|0,n|0)|0;n=c[g>>2]|0;c[g>>2]=h;c[j>>2]=c[a>>2];c[f+0>>2]=c[j+0>>2];eOb(n,f);x=a+12|0}c[l>>2]=b;c[x>>2]=m;x=b&31;if(!x){i=e;return}b=(c[g>>2]|0)+(m+-1<<2)|0;c[b>>2]=c[b>>2]&~(-1<<x);i=e;return}function nRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/20|0)>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;o=c[j>>2]|0}n=o+20|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=((l-m|0)/20|0)+b|0;if((n|0)<0)vxi(a);l=m;m=(h-l|0)/20|0;if(m>>>0<1073741823){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/20|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=((c[j>>2]|0)-l|0)/20|0;u=10}if((u|0)==10){c[f>>2]=1;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s*20|0,16,e,0,3653512,80)|0;r=t}t=b;b=q+(r*20|0)|0;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;v=b}s=v+20|0;t=t+-1|0;if(!t){w=s;break}else b=s}b=c[a>>2]|0;t=(c[j>>2]|0)-b|0;v=q+((((t|0)/-20|0)+r|0)*20|0)|0;YEi(v|0,b|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=v;c[j>>2]=w;c[g>>2]=q+(p*20|0);if(!t){i=d;return}c[f>>2]=1;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function oRb(a){a=a|0;return}function pRb(a,b){a=a|0;b=b|0;return}function qRb(a){a=a|0;return}function rRb(a){a=a|0;return}function sRb(a){a=a|0;return}function tRb(a){a=a|0;return}function uRb(a){a=a|0;return 3653512}function vRb(a,b){a=a|0;b=b|0;return}function wRb(a){a=a|0;return 0}function xRb(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[d>>2]=c[d>>2]&-1032193|b<<14&1032192;return}function yRb(a){a=a|0;return 0}function zRb(a){a=a|0;return 0}function ARb(a,b){a=a|0;b=b|0;return}function BRb(a,b){a=a|0;b=b|0;return}function CRb(a,b){a=a|0;b=b|0;return}function DRb(a,b){a=a|0;b=b|0;return}function ERb(a,b){a=a|0;b=b|0;return}function FRb(a,b){a=a|0;b=b|0;return}function GRb(a,b){a=a|0;b=b|0;return}function HRb(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e;j=d+4|0;if(!(c[j>>2]|0)){i=e;return}k=h+4|0;c[k>>2]=0;l=h+8|0;m=d+8|0;a[l>>0]=a[m>>0]|0;n=h+9|0;o=d+9|0;a[n>>0]=a[o>>0]|0;p=h+12|0;q=d+12|0;r=q;s=c[r+4>>2]|0;t=p;c[t>>2]=c[r>>2];c[t+4>>2]=s;s=h+20|0;t=d+20|0;r=t;u=c[r+4>>2]|0;v=s;c[v>>2]=c[r>>2];c[v+4>>2]=u;u=h+28|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;a[u+20>>0]=0;NRb(h,d,0);v=c[j>>2]|0;c[j>>2]=c[k>>2];c[k>>2]=v;v=a[m>>0]|0;k=b[l>>1]|0;a[m>>0]=k;a[l>>0]=v;v=a[o>>0]|0;a[o>>0]=(k&65535)>>>8;a[n>>0]=v;v=q;n=c[v>>2]|0;k=c[v+4>>2]|0;v=p;o=c[v+4>>2]|0;l=q;c[l>>2]=c[v>>2];c[l+4>>2]=o;o=p;c[o>>2]=n;c[o+4>>2]=k;k=t;o=c[k>>2]|0;n=c[k+4>>2]|0;k=s;p=c[k+4>>2]|0;l=t;c[l>>2]=c[k>>2];c[l+4>>2]=p;p=s;c[p>>2]=o;c[p+4>>2]=n;n=d+28|0;p=c[n>>2]|0;c[n>>2]=c[u>>2];c[u>>2]=p;u=d+32|0;n=h+32|0;o=c[u>>2]|0;s=c[n>>2]|0;c[u>>2]=s;c[n>>2]=o;n=d+36|0;u=h+36|0;l=c[n>>2]|0;c[n>>2]=c[u>>2];c[u>>2]=l;w=ea(s>>>0);c[d+44>>2]=~~ea(w*ea(.5))>>>0;c[d+40>>2]=~~ea(w*ea(.200000003))>>>0;a[d+48>>0]=0;w=ea(o>>>0);c[h+44>>2]=~~ea(w*ea(.5))>>>0;c[h+40>>2]=~~ea(w*ea(.200000003))>>>0;a[h+48>>0]=0;if(!p){i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(p,f);i=e;return}function IRb(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+64|0;h=g+56|0;j=g+52|0;k=g;l=d+48|0;if(a[l>>0]|0)ORb(d);m=d+32|0;n=c[m>>2]|0;o=c[d+36>>2]|0;if(n>>>0>f>>>0?(o+e|0)>>>0<=(c[d+44>>2]|0)>>>0:0){i=g;return}p=d+36|0;q=o+e|0;r=ea(q>>>0);e=32;while(1){if(e>>>0>=f>>>0?!(r>=ea(ea(e>>>0)*ea(.5))):0){s=e;break}e=e<<1}if(s>>>0<=n>>>0){i=g;return}n=d+4|0;r=ea((q-(c[n>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=f>>>0?!(r>=ea(ea(q>>>0)*ea(.5))):0){t=q;break}q=q<<1}q=k+4|0;c[q>>2]=0;f=k+8|0;s=d+8|0;a[f>>0]=a[s>>0]|0;e=k+9|0;o=d+9|0;a[e>>0]=a[o>>0]|0;u=k+12|0;v=d+12|0;w=v;x=c[w+4>>2]|0;y=u;c[y>>2]=c[w>>2];c[y+4>>2]=x;x=k+20|0;y=d+20|0;w=y;z=c[w+4>>2]|0;A=x;c[A>>2]=c[w>>2];c[A+4>>2]=z;z=k+28|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;a[z+20>>0]=0;NRb(k,d,t);t=c[n>>2]|0;c[n>>2]=c[q>>2];c[q>>2]=t;t=a[s>>0]|0;q=b[f>>1]|0;a[s>>0]=q;a[f>>0]=t;t=a[o>>0]|0;a[o>>0]=(q&65535)>>>8;a[e>>0]=t;t=v;e=c[t>>2]|0;q=c[t+4>>2]|0;t=u;o=c[t+4>>2]|0;f=v;c[f>>2]=c[t>>2];c[f+4>>2]=o;o=u;c[o>>2]=e;c[o+4>>2]=q;q=y;o=c[q>>2]|0;e=c[q+4>>2]|0;q=x;u=c[q+4>>2]|0;f=y;c[f>>2]=c[q>>2];c[f+4>>2]=u;u=x;c[u>>2]=o;c[u+4>>2]=e;e=d+28|0;u=c[e>>2]|0;c[e>>2]=c[z>>2];c[z>>2]=u;z=k+32|0;e=c[m>>2]|0;o=c[z>>2]|0;c[m>>2]=o;c[z>>2]=e;z=k+36|0;m=c[p>>2]|0;c[p>>2]=c[z>>2];c[z>>2]=m;r=ea(o>>>0);c[d+44>>2]=~~ea(r*ea(.5))>>>0;c[d+40>>2]=~~ea(r*ea(.200000003))>>>0;a[l>>0]=0;r=ea(e>>>0);c[k+44>>2]=~~ea(r*ea(.5))>>>0;c[k+40>>2]=~~ea(r*ea(.200000003))>>>0;a[k+48>>0]=0;if(!u){i=g;return}c[j>>2]=57;c[h+0>>2]=c[j+0>>2];eOb(u,h);i=g;return}function JRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-4|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>2;switch(l|0){case 3:{m=h;n=g;o=6;break a;break}case 2:{p=h;q=g;o=4;break a;break}case 4:{r=h;s=g;o=14;break a;break}case 5:{t=h;u=g;o=26;break a;break}case 1:case 0:{o=86;break a;break}default:{}}if((k|0)<124){v=h;w=a;o=28;break a}x=(l|0)/2|0;y=h+(x<<2)|0;do if((k|0)<=3996){z=c[y>>2]|0;A=c[h>>2]|0;B=c[g>>2]|0;C=(B|0)<(z|0);if((z|0)>=(A|0)){if(!C){D=0;break}c[y>>2]=B;c[g>>2]=z;E=c[y>>2]|0;F=c[h>>2]|0;if((E|0)>=(F|0)){D=1;break}c[h>>2]=E;c[y>>2]=F;D=2;break}if(C){c[h>>2]=B;c[g>>2]=A;D=1;break}c[h>>2]=z;c[y>>2]=A;z=c[g>>2]|0;if((z|0)<(A|0)){c[y>>2]=z;c[g>>2]=A;D=2}else D=1}else{A=(l|0)/4|0;D=PRb(h,h+(A<<2)|0,y,h+(A+x<<2)|0,g,d)|0}while(0);x=c[h>>2]|0;l=c[y>>2]|0;do if((x|0)<(l|0)){G=g;H=D}else{k=a;A=g;while(1){z=k+-8|0;if((h|0)==(z|0))break;B=c[z>>2]|0;if((B|0)<(l|0)){I=B;J=z;o=68;break}else{B=A;A=z;k=B}}if((o|0)==68){o=0;c[h>>2]=I;c[J>>2]=x;G=J;H=D+1|0;break}k=h+4|0;A=c[g>>2]|0;if((x|0)<(A|0))K=k;else{if((k|0)==(g|0)){o=86;break a}else{L=h;M=k}while(1){k=c[M>>2]|0;B=L+8|0;if((x|0)<(k|0)){N=k;O=M;break}if((B|0)==(g|0)){o=86;break a}else{k=M;M=B;L=k}}c[O>>2]=A;c[g>>2]=N;K=O+4|0}if((K|0)==(g|0)){o=86;break a}else{P=K;Q=g}while(1){k=c[h>>2]|0;B=P;while(1){z=c[B>>2]|0;C=B+4|0;if((k|0)<(z|0)){R=z;S=C;T=B;break}else B=C}B=Q;while(1){C=B+-4|0;z=c[C>>2]|0;if((k|0)<(z|0))B=C;else{U=C;V=z;break}}if(T>>>0>=U>>>0){h=T;continue b}c[T>>2]=V;c[U>>2]=R;P=S;Q=U}}while(0);x=h+4|0;c:do if(x>>>0<G>>>0){l=x;A=G;B=y;k=H;while(1){z=c[B>>2]|0;C=l;while(1){F=c[C>>2]|0;E=C+4|0;if((F|0)<(z|0))C=E;else{W=F;X=E;Y=C;break}}C=A;while(1){E=C+-4|0;F=c[E>>2]|0;if((F|0)<(z|0)){Z=E;_=F;break}else C=E}if(Y>>>0>Z>>>0){$=Y;aa=B;ba=k;break c}c[Y>>2]=_;c[Z>>2]=W;l=X;A=Z;B=(B|0)==(Y|0)?Z:B;k=k+1|0}}else{$=x;aa=y;ba=H}while(0);if(($|0)!=(aa|0)?(y=c[aa>>2]|0,x=c[$>>2]|0,(y|0)<(x|0)):0){c[$>>2]=y;c[aa>>2]=x;ca=ba+1|0}else ca=ba;if(!ca){da=QRb(h,$,d)|0;x=$+4|0;if(QRb(x,a,d)|0){o=81;break}if(da){h=x;continue}}x=$;if((x-j|0)>=(b-x|0)){ea=h;fa=$;o=85;break}JRb(h,$,d);h=$+4|0}if((o|0)==81){o=0;if(da){o=86;break}else{f=h;a=$;continue}}else if((o|0)==85){o=0;JRb(fa+4|0,a,d);f=ea;a=fa;continue}}if((o|0)==4){fa=c[q>>2]|0;a=c[p>>2]|0;if((fa|0)>=(a|0)){i=e;return}c[p>>2]=fa;c[q>>2]=a;i=e;return}else if((o|0)==6){a=m+4|0;q=c[a>>2]|0;fa=c[m>>2]|0;p=c[n>>2]|0;ea=(p|0)<(q|0);if((q|0)>=(fa|0)){if(!ea){i=e;return}c[a>>2]=p;c[n>>2]=q;f=c[a>>2]|0;$=c[m>>2]|0;if((f|0)>=($|0)){i=e;return}c[m>>2]=f;c[a>>2]=$;i=e;return}if(ea){c[m>>2]=p;c[n>>2]=fa;i=e;return}c[m>>2]=q;c[a>>2]=fa;q=c[n>>2]|0;if((q|0)>=(fa|0)){i=e;return}c[a>>2]=q;c[n>>2]=fa;i=e;return}else if((o|0)==14){fa=r+4|0;n=r+8|0;q=c[fa>>2]|0;a=c[r>>2]|0;m=c[n>>2]|0;p=(m|0)<(q|0);do if((q|0)<(a|0)){if(p){c[r>>2]=m;c[n>>2]=a;ga=a;break}c[r>>2]=q;c[fa>>2]=a;if((m|0)<(a|0)){c[fa>>2]=m;c[n>>2]=a;ga=a}else ga=m}else if(p){c[fa>>2]=m;c[n>>2]=q;if((m|0)<(a|0)){c[r>>2]=m;c[fa>>2]=a;ga=q}else ga=q}else ga=m;while(0);m=c[s>>2]|0;if((m|0)>=(ga|0)){i=e;return}c[n>>2]=m;c[s>>2]=ga;ga=c[n>>2]|0;s=c[fa>>2]|0;if((ga|0)>=(s|0)){i=e;return}c[fa>>2]=ga;c[n>>2]=s;s=c[r>>2]|0;if((ga|0)>=(s|0)){i=e;return}c[r>>2]=ga;c[fa>>2]=s;i=e;return}else if((o|0)==26){PRb(t,t+4|0,t+8|0,t+12|0,u,d)|0;i=e;return}else if((o|0)==28){d=v+8|0;u=v+4|0;t=c[u>>2]|0;s=c[v>>2]|0;fa=c[d>>2]|0;ga=(fa|0)<(t|0);do if((t|0)<(s|0)){if(ga){c[v>>2]=fa;c[d>>2]=s;ha=s;break}c[v>>2]=t;c[u>>2]=s;if((fa|0)<(s|0)){c[u>>2]=fa;c[d>>2]=s;ha=s}else ha=fa}else if(ga){c[u>>2]=fa;c[d>>2]=t;if((fa|0)<(s|0)){c[v>>2]=fa;c[u>>2]=s;ha=t}else ha=t}else ha=fa;while(0);fa=v+12|0;if((fa|0)==(w|0)){i=e;return}else{ia=ha;ja=fa;ka=d}while(1){d=c[ja>>2]|0;if((d|0)<(ia|0)){fa=ia;ha=ja;t=ka;while(1){c[ha>>2]=fa;if((t|0)==(v|0)){la=v;break}s=t+-4|0;fa=c[s>>2]|0;if((d|0)>=(fa|0)){la=t;break}else{u=t;t=s;ha=u}}c[la>>2]=d}ha=ja+4|0;if((ha|0)==(w|0))break;t=ja;ia=c[ja>>2]|0;ja=ha;ka=t}i=e;return}else if((o|0)==86){i=e;return}}function KRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function LRb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;h=c[b>>2]|0;j=c[a>>2]|0;k=c[h+4>>2]|0;l=c[j+4>>2]|0;m=c[d>>2]|0;n=(c[m+4>>2]|0)<(k|0);do if((k|0)<(l|0)){if(n){c[a>>2]=m;c[d>>2]=j;o=1;p=j;break}c[a>>2]=h;c[b>>2]=j;q=c[d>>2]|0;if((c[q+4>>2]|0)<(l|0)){c[b>>2]=q;c[d>>2]=j;o=2;p=j}else{o=1;p=q}}else if(n){c[b>>2]=m;c[d>>2]=h;q=c[b>>2]|0;r=c[a>>2]|0;if((c[q+4>>2]|0)<(c[r+4>>2]|0)){c[a>>2]=q;c[b>>2]=r;o=2;p=c[d>>2]|0}else{o=1;p=h}}else{o=0;p=m}while(0);m=c[e>>2]|0;if((c[m+4>>2]|0)<(c[p+4>>2]|0)){c[d>>2]=m;c[e>>2]=p;p=o+1|0;m=c[d>>2]|0;h=c[b>>2]|0;if((c[m+4>>2]|0)<(c[h+4>>2]|0)){c[b>>2]=m;c[d>>2]=h;h=c[b>>2]|0;m=c[a>>2]|0;if((c[h+4>>2]|0)<(c[m+4>>2]|0)){c[a>>2]=h;c[b>>2]=m;s=o+3|0}else s=o+2|0}else s=p}else s=o;o=c[f>>2]|0;p=c[e>>2]|0;if((c[o+4>>2]|0)>=(c[p+4>>2]|0)){t=s;i=g;return t|0}c[e>>2]=o;c[f>>2]=p;p=c[e>>2]|0;f=c[d>>2]|0;if((c[p+4>>2]|0)>=(c[f+4>>2]|0)){t=s+1|0;i=g;return t|0}c[d>>2]=p;c[e>>2]=f;f=c[d>>2]|0;e=c[b>>2]|0;if((c[f+4>>2]|0)>=(c[e+4>>2]|0)){t=s+2|0;i=g;return t|0}c[b>>2]=f;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;if((c[e+4>>2]|0)>=(c[d+4>>2]|0)){t=s+3|0;i=g;return t|0}c[a>>2]=e;c[b>>2]=d;t=s+4|0;i=g;return t|0}function MRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;switch(b-a>>2|0){case 5:{LRb(a,a+4|0,a+8|0,a+12|0,b+-4|0,d)|0;f=1;i=e;return f|0}case 4:{d=a+4|0;g=a+8|0;h=b+-4|0;j=c[d>>2]|0;k=c[a>>2]|0;l=c[j+4>>2]|0;m=c[k+4>>2]|0;n=c[g>>2]|0;o=c[n+4>>2]|0;p=(o|0)<(l|0);do if((l|0)<(m|0)){if(p){c[a>>2]=n;c[g>>2]=k;q=k;break}c[a>>2]=j;c[d>>2]=k;if((o|0)<(m|0)){c[d>>2]=n;c[g>>2]=k;q=k}else q=n}else if(p){c[d>>2]=n;c[g>>2]=j;if((o|0)<(m|0)){c[a>>2]=n;c[d>>2]=k;q=j}else q=j}else q=n;while(0);n=c[h>>2]|0;if((c[n+4>>2]|0)>=(c[q+4>>2]|0)){f=1;i=e;return f|0}c[g>>2]=n;c[h>>2]=q;q=c[g>>2]|0;h=c[d>>2]|0;n=c[q+4>>2]|0;if((n|0)>=(c[h+4>>2]|0)){f=1;i=e;return f|0}c[d>>2]=q;c[g>>2]=h;h=c[a>>2]|0;if((n|0)>=(c[h+4>>2]|0)){f=1;i=e;return f|0}c[a>>2]=q;c[d>>2]=h;f=1;i=e;return f|0}case 2:{h=b+-4|0;d=c[h>>2]|0;q=c[a>>2]|0;if((c[d+4>>2]|0)>=(c[q+4>>2]|0)){f=1;i=e;return f|0}c[a>>2]=d;c[h>>2]=q;f=1;i=e;return f|0}case 3:{q=a+4|0;h=b+-4|0;d=c[q>>2]|0;n=c[a>>2]|0;g=c[d+4>>2]|0;j=c[n+4>>2]|0;k=c[h>>2]|0;m=(c[k+4>>2]|0)<(g|0);if((g|0)>=(j|0)){if(!m){f=1;i=e;return f|0}c[q>>2]=k;c[h>>2]=d;g=c[q>>2]|0;o=c[a>>2]|0;if((c[g+4>>2]|0)>=(c[o+4>>2]|0)){f=1;i=e;return f|0}c[a>>2]=g;c[q>>2]=o;f=1;i=e;return f|0}if(m){c[a>>2]=k;c[h>>2]=n;f=1;i=e;return f|0}c[a>>2]=d;c[q>>2]=n;d=c[h>>2]|0;if((c[d+4>>2]|0)>=(j|0)){f=1;i=e;return f|0}c[q>>2]=d;c[h>>2]=n;f=1;i=e;return f|0}case 1:case 0:{f=1;i=e;return f|0}default:{n=a+8|0;h=a+4|0;d=c[h>>2]|0;q=c[a>>2]|0;j=c[d+4>>2]|0;k=c[q+4>>2]|0;m=c[n>>2]|0;o=c[m+4>>2]|0;g=(o|0)<(j|0);do if((j|0)<(k|0)){if(g){c[a>>2]=m;c[n>>2]=q;r=q;break}c[a>>2]=d;c[h>>2]=q;if((o|0)<(k|0)){c[h>>2]=m;c[n>>2]=q;r=q}else r=m}else if(g){c[h>>2]=m;c[n>>2]=d;if((o|0)<(k|0)){c[a>>2]=m;c[h>>2]=q;r=d}else r=d}else r=m;while(0);m=a+12|0;if((m|0)==(b|0)){f=1;i=e;return f|0}else{s=r;t=0;u=m;v=n}while(1){n=c[u>>2]|0;m=c[n+4>>2]|0;if((m|0)<(c[s+4>>2]|0)){r=s;d=u;q=v;while(1){c[d>>2]=r;if((q|0)==(a|0)){w=a;break}h=q+-4|0;r=c[h>>2]|0;if((m|0)>=(c[r+4>>2]|0)){w=q;break}else{k=q;q=h;d=k}}c[w>>2]=n;d=t+1|0;if((d|0)==8){x=u;break}else y=d}else y=t;d=u+4|0;if((d|0)==(b|0)){f=1;z=41;break}q=u;s=c[u>>2]|0;t=y;u=d;v=q}if((z|0)==41){i=e;return f|0}f=(x+4|0)==(b|0);i=e;return f|0}}return 0}function NRb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+28|0;k=b+32|0;c[k>>2]=32;l=b+44|0;c[l>>2]=16;m=b+40|0;c[m>>2]=6;n=b+48|0;a[n>>0]=0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];o=cOb(256,16,g,0,3653512,80)|0;p=c[j>>2]|0;if(p){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(p,g)}c[j>>2]=o;p=o+(c[k>>2]<<3)|0;if((o|0)!=(p|0)){q=b+20|0;r=o;do{if(r){o=q;s=c[o+4>>2]|0;t=r;c[t>>2]=c[o>>2];c[t+4>>2]=s}r=r+8|0}while((r|0)!=(p|0))}p=b+36|0;c[p>>2]=0;c[b+4>>2]=0;r=d+4|0;u=ea(((c[d+36>>2]|0)-(c[r>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=e>>>0?(v=ea(q>>>0),w=ea(v*ea(.5)),!(u>=w)):0){x=v;y=w;z=q;break}q=q<<1}q=c[k>>2]|0;if(z>>>0>q>>>0){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];e=cOb(z<<3,16,g,0,3653512,80)|0;s=c[j>>2]|0;if(s){t=c[k>>2]|0;o=s+(t<<3)|0;if(!t)A=s;else{t=e;B=s;while(1){if(t){s=B;C=c[s+4>>2]|0;D=t;c[D>>2]=c[s>>2];c[D+4>>2]=C}B=B+8|0;if((B|0)==(o|0))break;else t=t+8|0}A=c[j>>2]|0}c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(A,g)}g=c[k>>2]|0;A=e+(z<<3)|0;if((g|0)!=(z|0)){h=b+20|0;t=e+(g<<3)|0;do{if(t){g=h;o=c[g+4>>2]|0;B=t;c[B>>2]=c[g>>2];c[B+4>>2]=o}t=t+8|0}while((t|0)!=(A|0))}c[j>>2]=e;c[k>>2]=z;c[l>>2]=~~y>>>0;c[m>>2]=~~ea(x*ea(.200000003))>>>0;a[n>>0]=0;E=z}else E=q;q=d+28|0;z=c[q>>2]|0;n=d+32|0;m=c[n>>2]|0;l=z+(m<<3)|0;a:do if(m){e=c[d+20>>2]|0;A=c[d+12>>2]|0;if((c[r>>2]|0)!=0&(a[d+8>>0]|0)!=0){t=z;do{h=c[t>>2]|0;if(!((e|0)==(h|0)|(A|0)==(h|0))){F=t;break a}t=t+8|0}while((t|0)!=(l|0));i=f;return}else{t=z;do{if((e|0)!=(c[t>>2]|0)){F=t;break a}t=t+8|0}while((t|0)!=(l|0));i=f;return}}else F=z;while(0);if((F|0)==(l|0)){i=f;return}z=b+20|0;b=d+20|0;m=d+8|0;t=d+12|0;d=E;E=F;while(1){F=d+-1|0;e=c[E>>2]|0;A=e+2127912214+(e<<12)|0;e=A^-949894596^A>>>19;A=e+374761393+(e<<5)|0;e=A+-744332180^A<<9;A=e+-42973499+(e<<3)|0;e=(A^-1252372727^A>>>16)&F;A=c[j>>2]|0;h=c[z>>2]|0;if((h|0)==(c[A+(e<<3)>>2]|0))G=e;else{o=e;e=0;while(1){e=e+1|0;B=e+o&F;if((h|0)==(c[A+(B<<3)>>2]|0)){G=B;break}else o=B}}o=A+(G<<3)|0;if(o){h=E;F=c[h+4>>2]|0;e=o;c[e>>2]=c[h>>2];c[e+4>>2]=F}c[p>>2]=(c[p>>2]|0)+1;F=E+8|0;b:do if((F|0)!=(l|0)){e=c[b>>2]|0;h=c[t>>2]|0;if((c[r>>2]|0)!=0&(a[m>>0]|0)!=0){o=E;B=F;while(1){g=c[o+8>>2]|0;if(!((e|0)==(g|0)|(h|0)==(g|0))){H=B;break b}g=o+16|0;if((g|0)==(l|0)){H=l;break}else{C=B;B=g;o=C}}}else{o=E;B=F;while(1){if((e|0)!=(c[o+8>>2]|0)){H=B;break b}h=o+16|0;if((h|0)==(l|0)){H=l;break}else{C=B;B=h;o=C}}}}else H=l;while(0);if((H|0)==((c[q>>2]|0)+(c[n>>2]<<3)|0))break;d=c[k>>2]|0;E=H}i=f;return}function ORb(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e;j=d+36|0;k=d+4|0;l=(c[j>>2]|0)-(c[k>>2]|0)|0;m=d+40|0;if(l>>>0>=(c[m>>2]|0)>>>0){n=d+48|0;a[n>>0]=0;i=e;return}o=d+32|0;p=c[o>>2]|0;if(p>>>0<=32){n=d+48|0;a[n>>0]=0;i=e;return}q=ea(l>>>0);l=p;while(1){p=l>>>1;if(l>>>0<66){r=p;break}if(q<ea(ea(p>>>0)*ea(.200000003)))l=p;else{r=p;break}}l=h+4|0;c[l>>2]=0;p=h+8|0;s=d+8|0;a[p>>0]=a[s>>0]|0;t=h+9|0;u=d+9|0;a[t>>0]=a[u>>0]|0;v=h+12|0;w=d+12|0;x=w;y=c[x+4>>2]|0;z=v;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=h+20|0;z=d+20|0;x=z;A=c[x+4>>2]|0;B=y;c[B>>2]=c[x>>2];c[B+4>>2]=A;A=h+28|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;a[A+20>>0]=0;NRb(h,d,r);r=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=r;r=a[s>>0]|0;l=b[p>>1]|0;a[s>>0]=l;a[p>>0]=r;r=a[u>>0]|0;a[u>>0]=(l&65535)>>>8;a[t>>0]=r;r=w;t=c[r>>2]|0;l=c[r+4>>2]|0;r=v;u=c[r+4>>2]|0;p=w;c[p>>2]=c[r>>2];c[p+4>>2]=u;u=v;c[u>>2]=t;c[u+4>>2]=l;l=z;u=c[l>>2]|0;t=c[l+4>>2]|0;l=y;v=c[l+4>>2]|0;p=z;c[p>>2]=c[l>>2];c[p+4>>2]=v;v=y;c[v>>2]=u;c[v+4>>2]=t;t=d+28|0;v=c[t>>2]|0;c[t>>2]=c[A>>2];c[A>>2]=v;A=h+32|0;t=c[o>>2]|0;u=c[A>>2]|0;c[o>>2]=u;c[A>>2]=t;A=h+36|0;o=c[j>>2]|0;c[j>>2]=c[A>>2];c[A>>2]=o;q=ea(u>>>0);c[d+44>>2]=~~ea(q*ea(.5))>>>0;c[m>>2]=~~ea(q*ea(.200000003))>>>0;a[d+48>>0]=0;q=ea(t>>>0);c[h+44>>2]=~~ea(q*ea(.5))>>>0;c[h+40>>2]=~~ea(q*ea(.200000003))>>>0;a[h+48>>0]=0;if(!v){n=d+48|0;a[n>>0]=0;i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(v,f);n=d+48|0;a[n>>0]=0;i=e;return}function PRb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;h=c[b>>2]|0;j=c[a>>2]|0;k=c[d>>2]|0;l=(k|0)<(h|0);do if((h|0)<(j|0)){if(l){c[a>>2]=k;c[d>>2]=j;m=1;n=j;break}c[a>>2]=h;c[b>>2]=j;o=c[d>>2]|0;if((o|0)<(j|0)){c[b>>2]=o;c[d>>2]=j;m=2;n=j}else{m=1;n=o}}else if(l){c[b>>2]=k;c[d>>2]=h;o=c[b>>2]|0;p=c[a>>2]|0;if((o|0)<(p|0)){c[a>>2]=o;c[b>>2]=p;m=2;n=c[d>>2]|0}else{m=1;n=h}}else{m=0;n=k}while(0);k=c[e>>2]|0;if((k|0)<(n|0)){c[d>>2]=k;c[e>>2]=n;n=m+1|0;k=c[d>>2]|0;h=c[b>>2]|0;if((k|0)<(h|0)){c[b>>2]=k;c[d>>2]=h;h=c[b>>2]|0;k=c[a>>2]|0;if((h|0)<(k|0)){c[a>>2]=h;c[b>>2]=k;q=m+3|0}else q=m+2|0}else q=n}else q=m;m=c[f>>2]|0;n=c[e>>2]|0;if((m|0)>=(n|0)){r=q;i=g;return r|0}c[e>>2]=m;c[f>>2]=n;n=c[e>>2]|0;f=c[d>>2]|0;if((n|0)>=(f|0)){r=q+1|0;i=g;return r|0}c[d>>2]=n;c[e>>2]=f;f=c[d>>2]|0;e=c[b>>2]|0;if((f|0)>=(e|0)){r=q+2|0;i=g;return r|0}c[b>>2]=f;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;if((e|0)>=(d|0)){r=q+3|0;i=g;return r|0}c[a>>2]=e;c[b>>2]=d;r=q+4|0;i=g;return r|0}function QRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;switch(b-a>>2|0){case 5:{PRb(a,a+4|0,a+8|0,a+12|0,b+-4|0,d)|0;f=1;i=e;return f|0}case 3:{d=a+4|0;g=b+-4|0;h=c[d>>2]|0;j=c[a>>2]|0;k=c[g>>2]|0;l=(k|0)<(h|0);if((h|0)>=(j|0)){if(!l){f=1;i=e;return f|0}c[d>>2]=k;c[g>>2]=h;m=c[d>>2]|0;n=c[a>>2]|0;if((m|0)>=(n|0)){f=1;i=e;return f|0}c[a>>2]=m;c[d>>2]=n;f=1;i=e;return f|0}if(l){c[a>>2]=k;c[g>>2]=j;f=1;i=e;return f|0}c[a>>2]=h;c[d>>2]=j;h=c[g>>2]|0;if((h|0)>=(j|0)){f=1;i=e;return f|0}c[d>>2]=h;c[g>>2]=j;f=1;i=e;return f|0}case 4:{j=a+4|0;g=a+8|0;h=b+-4|0;d=c[j>>2]|0;k=c[a>>2]|0;l=c[g>>2]|0;n=(l|0)<(d|0);do if((d|0)<(k|0)){if(n){c[a>>2]=l;c[g>>2]=k;o=k;break}c[a>>2]=d;c[j>>2]=k;if((l|0)<(k|0)){c[j>>2]=l;c[g>>2]=k;o=k}else o=l}else if(n){c[j>>2]=l;c[g>>2]=d;if((l|0)<(k|0)){c[a>>2]=l;c[j>>2]=k;o=d}else o=d}else o=l;while(0);l=c[h>>2]|0;if((l|0)>=(o|0)){f=1;i=e;return f|0}c[g>>2]=l;c[h>>2]=o;o=c[g>>2]|0;h=c[j>>2]|0;if((o|0)>=(h|0)){f=1;i=e;return f|0}c[j>>2]=o;c[g>>2]=h;h=c[a>>2]|0;if((o|0)>=(h|0)){f=1;i=e;return f|0}c[a>>2]=o;c[j>>2]=h;f=1;i=e;return f|0}case 2:{h=b+-4|0;j=c[h>>2]|0;o=c[a>>2]|0;if((j|0)>=(o|0)){f=1;i=e;return f|0}c[a>>2]=j;c[h>>2]=o;f=1;i=e;return f|0}case 1:case 0:{f=1;i=e;return f|0}default:{o=a+8|0;h=a+4|0;j=c[h>>2]|0;g=c[a>>2]|0;l=c[o>>2]|0;d=(l|0)<(j|0);do if((j|0)<(g|0)){if(d){c[a>>2]=l;c[o>>2]=g;p=g;break}c[a>>2]=j;c[h>>2]=g;if((l|0)<(g|0)){c[h>>2]=l;c[o>>2]=g;p=g}else p=l}else if(d){c[h>>2]=l;c[o>>2]=j;if((l|0)<(g|0)){c[a>>2]=l;c[h>>2]=g;p=j}else p=j}else p=l;while(0);l=a+12|0;if((l|0)==(b|0)){f=1;i=e;return f|0}else{q=p;r=0;s=l;t=o}while(1){o=c[s>>2]|0;if((o|0)<(q|0)){l=q;p=s;j=t;while(1){c[p>>2]=l;if((j|0)==(a|0)){u=a;break}g=j+-4|0;l=c[g>>2]|0;if((o|0)>=(l|0)){u=j;break}else{h=j;j=g;p=h}}c[u>>2]=o;p=r+1|0;if((p|0)==8){v=s;break}else w=p}else w=r;p=s+4|0;if((p|0)==(b|0)){f=1;x=41;break}j=s;q=c[s>>2]|0;r=w;s=p;t=j}if((x|0)==41){i=e;return f|0}f=(v+4|0)==(b|0);i=e;return f|0}}return 0}function RRb(){var a=0,b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im;a=i;i=i+240|0;b=a+228|0;d=a+32|0;e=a+24|0;f=a+8|0;h=a;j=rpe()|0;if(!j){i=a;return}k=ECc()|0;if(!(mo[c[(c[k>>2]|0)+32>>2]&4095](k)|0)){i=a;return}t1b(d,ync()|0);m1b();k=fKc()|0;l=ea(g[k+100>>2]);m=ea(g[k+104>>2]);spe(e);n=ea(l-ea(g[e>>2]));l=ea(~~n|0);n=ea(~~ea(m+ea(g[e+4>>2]))|0);e=mo[c[(c[j>>2]|0)+116>>2]&4095](j)|0;m=ea(e|0);o=ea(0-(mo[c[(c[j>>2]|0)+120>>2]&4095](j)|0)|0);g[f>>2]=l;g[f+8>>2]=m;g[f+4>>2]=n;g[f+12>>2]=o;c[h>>2]=-2139062144;c[b+0>>2]=c[h+0>>2];yYb(f,j,b,0);u1b(d);i=a;return}function SRb(){var a=0;a=i;QQb(18,81,0,0,0);i=a;return}function TRb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(0)|0))vQb();rri(b,551416,15);wQb(18,0,b,24,2594,0,0);xri(b);i=a;return}function URb(a){a=a|0;return 18}function VRb(a){a=a|0;return}function WRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(24,e,1,16,3653512,55)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];lQb(g,e,b);c[g>>2]=551440;i=d;return g|0}function XRb(a){a=a|0;c[a>>2]=551440;return}function YRb(a){a=a|0;var b=0;b=i;c[a>>2]=551440;ACi(a);i=b;return}function ZRb(){return c[137884]|0}function _Rb(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[e>>2]=c[153072];c[b+0>>2]=c[e+0>>2];e=bOb(44,b,0,16,3653512,16)|0;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];_rd(e,0,551544,12,4096,b,16);c[137884]=e;i=a;return}function $Rb(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[137884]|0;f=c[153072]|0;if(e)$rd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[137884]=0;i=a;return}function aSb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=bsd(a)|0;if(!e){c[g>>2]=d;c[g+8>>2]=b;c[g+4>>2]=0;i=f;return g|0}else{c[g+8>>2]=b;c[g>>2]=d;c[g+4>>2]=e;i=f;return g|0}return 0}function bSb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){i=d;return}e=b;do{b=e;e=c[e+4>>2]|0;dsd(a,b)}while((e|0)!=0);i=d;return}function cSb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;a:do if(!a)f=0;else{g=a;while(1){if((c[g+8>>2]|0)==(b|0)?(c[g>>2]|0)==(d|0):0){f=1;break a}g=c[g+4>>2]|0;if(!g){f=0;break}}}while(0);i=e;return f|0}function dSb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if(!b){g=0;i=f;return g|0}else{h=b;j=0}while(1){if((c[h+8>>2]|0)==(d|0)?(c[h>>2]|0)==(e|0):0){k=h;l=j;break}m=c[h+4>>2]|0;if(!m){g=b;n=8;break}else{o=h;h=m;j=o}}if((n|0)==8){i=f;return g|0}n=c[k+4>>2]|0;dsd(a,k);if(l)c[l+4>>2]=n;g=(k|0)==(b|0)?n:b;i=f;return g|0}function eSb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if(!a){i=e;return}else f=a;do{a=f;f=c[f+4>>2]|0;co[c[a+8>>2]&2047](c[a>>2]|0,b,d)}while((f|0)!=0);i=e;return}function fSb(a){a=a|0;var b=0,d=0;b=i;d=0;do{if((c[(vVb()|0)+(d<<2)>>2]|0)==(a|0))uVb(d,0);d=d+1|0}while((d|0)!=21);i=b;return}function gSb(b){b=b|0;var d=0,e=0,f=0;d=i;e=GQb(b)|0;if(!(a[e>>0]&1)){f=e+1|0;i=d;return f|0}else{f=c[e+8>>2]|0;i=d;return f|0}return 0}function hSb(a){a=a|0;var b=0,c=0;b=i;c=tVb(a)|0;i=b;return c|0}function iSb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];lQb(a,f,d);c[a>>2]=551568;i=e;return}function jSb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];lQb(a,f,d);c[a>>2]=551680;i=e;return}function kSb(){var a=0;a=i;QQb(3,82,0,0,0);i=a;return}function lSb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(9)|0))mSb();rri(b,551784,16);wQb(3,9,b,24,2595,1,0);xri(b);i=a;return}function mSb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(0)|0))vQb();rri(b,551832,11);wQb(9,0,b,24,2596,1,0);xri(b);i=a;return}function nSb(a){a=a|0;return 3}function oSb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(9)|0))mSb();rri(b,551808,17);wQb(6,9,b,24,2597,1,0);xri(b);i=a;return}function pSb(a){a=a|0;return 6}function qSb(){var a=0;a=i;QQb(9,83,0,0,0);i=a;return}function rSb(a){a=a|0;return 9}function sSb(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,551784,a,0);bdd(b);i=c;return}function tSb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,551784,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}sdd(b);i=d;return}function uSb(a,b){a=a|0;b=b|0;return}function vSb(a,b){a=a|0;b=b|0;return}function wSb(a,b){a=a|0;b=b|0;return}function xSb(a,b){a=a|0;b=b|0;return}function ySb(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,551808,a,0);bdd(b);i=c;return}function zSb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,551808,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}sdd(b);i=d;return}function ASb(a,b){a=a|0;b=b|0;return}function BSb(a,b){a=a|0;b=b|0;return}function CSb(a,b){a=a|0;b=b|0;return}function DSb(a,b){a=a|0;b=b|0;return}function ESb(a,b){a=a|0;b=b|0;return}function FSb(a,b){a=a|0;b=b|0;return}function GSb(a,b){a=a|0;b=b|0;return}function HSb(a,b){a=a|0;b=b|0;return}function ISb(a,b){a=a|0;b=b|0;return}function JSb(a,b){a=a|0;b=b|0;return}function KSb(a,b){a=a|0;b=b|0;return}function LSb(a,b){a=a|0;b=b|0;return}function MSb(a,b){a=a|0;b=b|0;return}function NSb(a,b){a=a|0;b=b|0;return}function OSb(a,b){a=a|0;b=b|0;return}function PSb(a,b){a=a|0;b=b|0;return}function QSb(a,b){a=a|0;b=b|0;return 0}function RSb(a,b){a=a|0;b=b|0;return 0}function SSb(a,b){a=a|0;b=b|0;return 0}function TSb(a){a=a|0;c[a>>2]=551856;return}function USb(a){a=a|0;var b=0;b=i;c[a>>2]=551856;ACi(a);i=b;return}function VSb(b){b=b|0;var d=0,e=0,f=0;d=i;e=GQb(b)|0;if(!(a[e>>0]&1)){f=e+1|0;i=d;return f|0}else{f=c[e+8>>2]|0;i=d;return f|0}return 0}function WSb(a){a=a|0;return}function XSb(a){a=a|0;return}function YSb(a){a=a|0;return 1}function ZSb(a){a=a|0;c[a>>2]=551856;return}function _Sb(a){a=a|0;var b=0;b=i;c[a>>2]=551856;ACi(a);i=b;return}function $Sb(a){a=a|0;c[a>>2]=551856;return}function aTb(a){a=a|0;var b=0;b=i;c[a>>2]=551856;ACi(a);i=b;return}function bTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+16|0;ddd(b,4);if(!(c[b>>2]&16384)){add(b,552912,c[142306]|0,a+24|0,65601);c[g>>2]=0;c[g+4>>2]=0;$cd(b,2646336,2646336,f,0);add(b,3142592,c[142274]|0,g,0);h=c[142270]|0;add(b,c[142266]|0,h,g,0);j=b+12|0;k=b+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,c[142282]|0,552928,g+4|0,0);g=e+8|0;l=g;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,h,e,1);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,g,1);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);bdd(b);cdd(b);bdd(b);m=k;n=j}else{m=b+20|0;n=b+12|0}add(b,551960,c[142304]|0,a+40|0,0);c[(c[c[n>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2487248,c[142294]|0,a+56|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,c[142260]|0,f,0);c[(c[c[n>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,2487608,c[142296]|0,a+44|0,0);c[(c[c[n>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=2;bdd(b);add(b,551968,c[142258]|0,a+46|0,0);c[(c[c[n>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=1;bdd(b);i=d;return}function cTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;rdd(d,4);if((c[d>>2]&16384|0)==0?(h=b+24|0,j=qdd(d,552912,c[142306]|0,g,1)|0,(j|0)!=0):0){if((j|0)<=0){j=c[g>>2]|0;if(j)_n[j&4095](h,d)|0}else yUb(d,h,0);sdd(d)}h=b+40|0;j=qdd(d,551960,c[142304]|0,f,0)|0;if(j){if((j|0)>0){j=d+12|0;g=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=g+k|0;c[j>>2]=l;if((k|0)>=0?(m=g+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[j>>2]=m}else Bid(j,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}sdd(d)}h=b+56|0;j=qdd(d,2487248,c[142294]|0,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else zUb(h,d);sdd(d)}AUb(d,b+44|0,2487608,0);h=b+46|0;j=qdd(d,551968,c[142258]|0,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;g=l+k|0;c[m>>2]=g;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[g>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}if(!(xdd(d,3)|0)){i=e;return}if(!(c[b+8>>2]&1048576)){i=e;return}a[h>>0]=1;i=e;return}function dTb(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if(!(c[e>>2]&16384))BUb(e,d+24|0,0);g=d+40|0;h=e+12|0;j=c[h>>2]|0;k=j+4|0;l=e+20|0;if(k>>>0>(c[l>>2]|0)>>>0)Bid(h,g,4);else{c[g>>2]=c[j>>2];c[h>>2]=k}CUb(d+56|0,e);e=d+44|0;k=c[h>>2]|0;j=k+2|0;g=c[l>>2]|0;if(j>>>0>g>>>0){Bid(h,e,2);m=c[h>>2]|0;n=c[l>>2]|0}else{b[e>>1]=b[k>>1]|0;c[h>>2]=j;m=j;n=g}g=d+46|0;if((m+1|0)>>>0>n>>>0){Bid(h,g,1);i=f;return}else{a[g>>0]=a[m>>0]|0;c[h>>2]=(c[h>>2]|0)+1;i=f;return}}function eTb(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;if(!(c[e>>2]&16384))DUb(e,d+24|0,0);g=d+40|0;h=e+12|0;j=c[h>>2]|0;k=j+4|0;l=e+20|0;if(k>>>0>(c[l>>2]|0)>>>0){Bid(h,g,4);m=c[g>>2]|0}else{n=c[j>>2]|0;c[g>>2]=n;c[h>>2]=k;m=n}c[g>>2]=XEi(m|0)|0;EUb(d+56|0,e);e=d+44|0;m=c[h>>2]|0;g=m+2|0;n=c[l>>2]|0;if(g>>>0>n>>>0){Bid(h,e,2);o=b[e>>1]|0;p=c[h>>2]|0;q=c[l>>2]|0}else{l=b[m>>1]|0;b[e>>1]=l;c[h>>2]=g;o=l;p=g;q=n}n=o&65535;b[e>>1]=n<<8|n>>>8;n=d+46|0;if((p+1|0)>>>0>q>>>0){Bid(h,n,1);i=f;return}else{a[n>>0]=a[p>>0]|0;c[h>>2]=(c[h>>2]|0)+1;i=f;return}}function fTb(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;if(!(c[e>>2]&16384)){h=d+32|0;j=c[h>>2]|0;c[g>>2]=j;k=e+12|0;l=c[k>>2]|0;m=l+4|0;n=e+20|0;if(m>>>0<(c[n>>2]|0)>>>0){c[l>>2]=j;c[k>>2]=m}else Gid(k,g,4);g=c[d+24>>2]|0;m=c[h>>2]|0;h=g+(m<<3)|0;if(!m){o=k;p=n;q=k}else{m=g;do{g=c[k>>2]|0;j=g+4|0;if(j>>>0<(c[n>>2]|0)>>>0){c[g>>2]=c[m>>2];c[k>>2]=j}else Gid(k,m,4);FUb(m+4|0,e);m=m+8|0}while((m|0)!=(h|0));o=k;p=n;q=k}}else{k=e+12|0;o=k;p=e+20|0;q=k}k=d+40|0;n=c[o>>2]|0;h=n+4|0;if(h>>>0<(c[p>>2]|0)>>>0){c[n>>2]=c[k>>2];c[o>>2]=h}else Gid(q,k,4);GUb(d+56|0,e);e=d+44|0;k=c[o>>2]|0;h=k+2|0;n=c[p>>2]|0;if(h>>>0<n>>>0){b[k>>1]=b[e>>1]|0;c[o>>2]=h;r=h;s=n}else{Gid(q,e,2);r=c[o>>2]|0;s=c[p>>2]|0}p=d+46|0;if((r+1|0)>>>0<s>>>0){a[r>>0]=a[p>>0]|0;c[o>>2]=(c[o>>2]|0)+1;i=f;return}else{Gid(q,p,1);i=f;return}}function gTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(c[d>>2]&16384){i=e;return}idd(d,65601);f=c[b+24>>2]|0;g=c[b+32>>2]|0;b=f+(g<<3)|0;if(g){g=d+12|0;h=d+28|0;j=d+32|0;k=f;do{f=k+4|0;l=c[f>>2]|0;if(!l)m=0;else m=c[l+4>>2]|0;l=c[g>>2]|0;n=xo[c[c[l>>2]>>2]&2047](l,m,c[h>>2]|0)|0;if(a[j>>0]|0)c[f>>2]=iQb(n,0)|0;k=k+8|0}while((k|0)!=(b|0))}jdd(d);i=e;return}function hTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(c[b>>2]&16384){i=d;return}add(b,551984,552888,a+24|0,65601);a=e+8|0;f=a;c[f>>2]=0;c[f+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,e,1);e=b+12|0;f=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,a,1);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);i=d;return}function iTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(c[b>>2]&16384){i=d;return}f=a+24|0;a=qdd(b,551984,552888,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else HUb(f,b);sdd(b);i=d;return}function jTb(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[b>>2]&16384){i=d;return}IUb(a+24|0,b);i=d;return}function kTb(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[b>>2]&16384){i=d;return}JUb(a+24|0,b);i=d;return}function lTb(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[b>>2]&16384){i=d;return}KUb(a+24|0,b);i=d;return}function mTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(c[d>>2]&16384){i=e;return}idd(d,65601);f=b+24|0;b=c[f>>2]|0;if(!b)g=0;else g=c[b+4>>2]|0;b=c[d+12>>2]|0;h=xo[c[c[b>>2]>>2]&2047](b,g,c[d+28>>2]|0)|0;if(a[d+32>>0]|0)c[f>>2]=iQb(h,0)|0;jdd(d);i=e;return}function nTb(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;k=c[e>>2]|0;c[j>>2]=k;c[h+0>>2]=c[j+0>>2];lQb(d,h,f);c[d>>2]=552016;c[d+24>>2]=0;c[d+28>>2]=k;c[d+32>>2]=0;c[d+36>>2]=0;k=d+56|0;c[k>>2]=0;qbc(k);c[d+60>>2]=0;c[d+64>>2]=0;c[d+68>>2]=d;c[d+52>>2]=0;a[d+48>>0]=0;a[d+49>>0]=0;b[d+44>>1]=0;a[d+46>>0]=0;a[d+47>>0]=-1;i=g;return}function oTb(a){a=a|0;c[a+40>>2]=0;b[a+44>>1]=0;return}function pTb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;a[b+48>>0]=1;e=c[b+24>>2]|0;f=c[b+32>>2]|0;b=e+(f<<3)|0;if(!f){i=d;return}else g=e;do{e=c[g+4>>2]|0;ko[c[(c[e>>2]|0)+100>>2]&4095](e);g=g+8|0}while((g|0)!=(b|0));i=d;return}function qTb(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=d+52|0;g=c[f>>2]|0;c[f>>2]=0;if((a[d+48>>0]|0)==0?(c[f>>2]=0,h=d+24|0,j=d+32|0,k=c[j>>2]|0,(k|0)!=0):0){l=c[h>>2]|0;m=0;n=k;k=l;o=l;while(1){l=c[o+4>>2]|0;if(!l){p=k;q=n;r=m}else{s=mo[c[(c[l>>2]|0)+92>>2]&4095](l)|0;l=c[f>>2]|s;c[f>>2]=l;p=c[h>>2]|0;q=c[j>>2]|0;r=l}o=o+8|0;if((o|0)==(p+(q<<3)|0)){t=r;u=q;v=p;break}else{m=r;n=q;k=p}}if(!((g|0)==(t|0)|(u|0)==0)){t=u;u=v;g=v;while(1){v=c[g+4>>2]|0;if(!v){w=u;x=t}else{In[c[(c[v>>2]|0)+96>>2]&4095](v,c[f>>2]|0);w=c[h>>2]|0;x=c[j>>2]|0}g=g+8|0;if((g|0)==(w+(x<<3)|0))break;else{t=x;u=w}}}}w=d+60|0;u=c[w>>2]|0;if(u){x=d+64|0;c[u+4>>2]=c[x>>2];c[c[x>>2]>>2]=u;c[w>>2]=0;c[x>>2]=0}do if(vTb(d)|0){x=c[138220]|0;if(!(b[d+44>>1]|0)){u=x+8|0;if((w|0)==(u|0))break;t=c[w>>2]|0;g=d+64|0;if(t){c[t+4>>2]=c[g>>2];c[c[g>>2]>>2]=t;c[w>>2]=0;c[g>>2]=0}t=c[u>>2]|0;c[w>>2]=t;c[g>>2]=u;c[t+4>>2]=w;c[c[g>>2]>>2]=w;break}else{if((w|0)==(x|0))break;g=c[w>>2]|0;t=d+64|0;if(g){c[g+4>>2]=c[t>>2];c[c[t>>2]>>2]=g;c[w>>2]=0;c[t>>2]=0}g=c[x>>2]|0;c[w>>2]=g;c[t>>2]=x;c[g+4>>2]=w;c[c[t>>2]>>2]=w;break}}while(0);if(!0){i=e;return}fa(d|0);i=e;return}function rTb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=b+52|0;f=c[e>>2]|0;c[e>>2]=0;if(a[b+48>>0]|0){i=d;return}c[e>>2]=0;g=b+24|0;h=b+32|0;b=c[h>>2]|0;if(!b){j=0;k=0}else{l=c[g>>2]|0;m=0;n=b;b=l;o=l;while(1){l=c[o+4>>2]|0;if(!l){p=b;q=n;r=m}else{s=mo[c[(c[l>>2]|0)+92>>2]&4095](l)|0;l=c[e>>2]|s;c[e>>2]=l;p=c[g>>2]|0;q=c[h>>2]|0;r=l}o=o+8|0;if((o|0)==(p+(q<<3)|0)){j=r;k=q;break}else{m=r;n=q;b=p}}}if((f|0)==(j|0)|(k|0)==0){i=d;return}j=c[g>>2]|0;f=k;k=j;p=j;while(1){j=c[p+4>>2]|0;if(!j){t=k;u=f}else{In[c[(c[j>>2]|0)+96>>2]&4095](j,c[e>>2]|0);t=c[g>>2]|0;u=c[h>>2]|0}p=p+8|0;if((p|0)==(t+(u<<3)|0))break;else{f=u;k=t}}i=d;return}function sTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a+32>>2]|0;if(!e){f=0;i=d;return f|0}g=c[a+24>>2]|0;a=c[137788]|0;h=c[137786]|0;j=g+(e<<3)|0;e=0;k=g;while(1){g=(da(a,c[k>>2]|0)|0)+b|0;l=g>>5;m=((1<<g-(l<<5)&c[h+(l<<2)>>2]|0)!=0&1)+e|0;k=k+8|0;if((k|0)==(j|0)){f=m;break}else e=m}i=d;return f|0}function tTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=SPc(b)|0;b=c[e>>2]|0;f=c[e+4>>2]|0;if((b|0)==(f|0)){g=0;i=d;return g|0}e=c[a+24>>2]|0;h=c[a+32>>2]|0;if(!h){g=0;i=d;return g|0}a=c[137788]|0;j=c[137786]|0;k=e;a:while(1){l=da(a,c[k>>2]|0)|0;m=b;do{n=l+(c[m>>2]|0)|0;o=n>>5;m=m+4|0;if(1<<n-(o<<5)&c[j+(o<<2)>>2]){p=k;break a}}while((m|0)!=(f|0));k=k+8|0;if((k|0)==(e+(h<<3)|0)){g=0;q=9;break}}if((q|0)==9){i=d;return g|0}g=c[p+4>>2]|0;i=d;return g|0}function uTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=VQb(a)|0;c[e+0>>2]=c[f+0>>2];tbc(a+56|0,b,e);if(!0){i=d;return}fa(a|0);i=d;return}function vTb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+47|0;f=a[e>>0]|0;a:do if(f<<24>>24==-1){if(!(a[b+46>>0]|0))g=0;else g=((c[b+8>>2]|0)>>>20&1^1)&255;a[e>>0]=g;h=c[b+24>>2]|0;j=c[b+32>>2]|0;k=h+(j<<3)|0;if(j){j=h;while(1){l=c[j>>2]|0;if((l|0)==4|(l|0)==224){m=j;break}j=j+8|0;if((j|0)==(k|0)){n=g;break a}}if(c[m+4>>2]|0){k=h;while(1){j=c[k>>2]|0;if((j|0)==4|(j|0)==224){o=k;break}k=k+8|0}k=c[(c[o+4>>2]|0)+156>>2]|0;if(k){if(!(g<<24>>24))p=0;else p=(vTb(c[k+24>>2]|0)|0)&1;a[e>>0]=p;n=p}else n=g}else n=g}else n=g}else n=f;while(0);i=d;return n<<24>>24!=0|0}function wTb(){return c[138220]|0}function xTb(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;h=d+49|0;if(a[h>>0]|0){Krd(552112,0,3653512,184,1,c[d+4>>2]|0,0,0);i=g;return}a[h>>0]=1;j=d+47|0;k=a[j>>0]|0;if(k<<24>>24==-1){l=1;m=vTb(d)|0}else{a[j>>0]=-1;j=vTb(d)|0;l=k<<24>>24!=0^j;m=j}j=d+24|0;k=c[j>>2]|0;n=d+32|0;o=c[n>>2]|0;p=k+(o<<3)|0;a:do if(o){q=k;while(1){r=c[q>>2]|0;if((r|0)==4|(r|0)==224){s=q;break}q=q+8|0;if((q|0)==(p|0))break a}q=c[s+4>>2]|0;if((q|0)!=0?(r=q+148|0,(c[r>>2]|0)>0):0){t=q+140|0;q=0;do{xTb(c[(c[(c[t>>2]|0)+(q<<2)>>2]|0)+24>>2]|0,e,f);q=q+1|0}while((q|0)<(c[r>>2]|0))}}while(0);do if(l){if(c[n>>2]|0)if(m){s=0;do{p=c[(c[j>>2]|0)+(s<<3)+4>>2]|0;c[p+24>>2]=d;hed(f,p,0,0,-1);s=s+1|0}while(s>>>0<(c[n>>2]|0)>>>0)}else{s=0;do{p=c[(c[j>>2]|0)+(s<<3)+4>>2]|0;In[c[(c[p>>2]|0)+104>>2]&4095](p,e);s=s+1|0}while(s>>>0<(c[n>>2]|0)>>>0)}if(!m){s=d+60|0;p=c[s>>2]|0;if(!p)break;k=d+64|0;c[p+4>>2]=c[k>>2];c[c[k>>2]>>2]=p;c[s>>2]=0;c[k>>2]=0;break}k=d+60|0;s=c[k>>2]|0;if(s){p=d+64|0;c[s+4>>2]=c[p>>2];c[c[p>>2]>>2]=s;c[k>>2]=0;c[p>>2]=0}if(vTb(d)|0){p=c[138220]|0;if(!(b[d+44>>1]|0)){s=p+8|0;if((k|0)==(s|0))break;o=c[k>>2]|0;r=d+64|0;if(o){c[o+4>>2]=c[r>>2];c[c[r>>2]>>2]=o;c[k>>2]=0;c[r>>2]=0}o=c[s>>2]|0;c[k>>2]=o;c[r>>2]=s;c[o+4>>2]=k;c[c[r>>2]>>2]=k;break}else{if((k|0)==(p|0))break;r=c[k>>2]|0;o=d+64|0;if(r){c[r+4>>2]=c[o>>2];c[c[o>>2]>>2]=r;c[k>>2]=0;c[o>>2]=0}r=c[p>>2]|0;c[k>>2]=r;c[o>>2]=p;c[r+4>>2]=k;c[c[o>>2]>>2]=k;break}}}while(0);a[h>>0]=0;i=g;return}function yTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+160|0;e=d+156|0;f=d+152|0;g=d+8|0;h=d;c[h>>2]=c[153134];c[e+0>>2]=c[h+0>>2];eed(g,e);xTb(a,b,g);ped(g,8,0);b=g+144|0;do{a=b;b=b+-16|0;if((c[a+-4>>2]|0)>-1){h=c[b>>2]|0;c[f>>2]=c[a+-12>>2];c[e+0>>2]=c[f+0>>2];eOb(h,e);c[b>>2]=0}}while((b|0)!=(g|0));i=d;return}function zTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e+8|0;g=e;c[g>>2]=(c[d+8>>2]|0)>>>21;c[g+4>>2]=d;LUb(b+24|0,g);In[c[(c[d>>2]|0)+44>>2]&4095](d,(c[b+8>>2]|0)>>>14&63);c[d+24>>2]=b;g=vTb(b)|0;h=c[(c[d>>2]|0)+12>>2]|0;if(g)In[h&4095](d,8);else In[h&4095](d,0);c[f+8>>2]=0;c[f+4>>2]=d;c[f>>2]=2;d=c[138720]|0;h=b+32|0;g=c[h>>2]|0;if(!g)j=0;else{k=b+24|0;l=g;g=0;while(1){m=c[k>>2]|0;n=c[m+(g<<3)>>2]|0;o=c[138e3]|0;p=(da(c[o+28>>2]|0,d)|0)+n|0;if(!(1<<(p&31)&c[(c[o+4>>2]|0)+(p>>>5<<2)>>2]))q=l;else{MVb((c[o+16>>2]|0)+(n<<5)|0,c[m+(g<<3)+4>>2]|0,d,f);q=c[h>>2]|0}g=g+1|0;if(g>>>0>=q>>>0){j=q;break}else l=q}}q=b+52|0;l=c[q>>2]|0;c[q>>2]=0;if(a[b+48>>0]|0){i=e;return}c[q>>2]=0;g=b+24|0;if(!j){i=e;return}b=c[g>>2]|0;f=0;d=j;j=b;k=b;while(1){b=c[k+4>>2]|0;if(!b){r=j;s=d;t=f}else{m=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;b=c[q>>2]|m;c[q>>2]=b;r=c[g>>2]|0;s=c[h>>2]|0;t=b}k=k+8|0;if((k|0)==(r+(s<<3)|0)){u=t;v=s;w=r;break}else{f=t;d=s;j=r}}if((l|0)==(u|0)|(v|0)==0){i=e;return}else{x=v;y=w;z=w}while(1){w=c[z+4>>2]|0;if(!w){A=y;B=x}else{In[c[(c[w>>2]|0)+96>>2]&4095](w,c[q>>2]|0);A=c[g>>2]|0;B=c[h>>2]|0}z=z+8|0;if((z|0)==(A+(B<<3)|0))break;else{x=B;y=A}}i=e;return}function ATb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[a+24>>2]|0;f=c[a+32>>2]|0;a=e+(f<<3)|0;if(!f){g=0;i=d;return g|0}else h=e;while(1){if((c[h>>2]|0)==(b|0)){j=h;break}h=h+8|0;if((h|0)==(a|0)){g=0;k=5;break}}if((k|0)==5){i=d;return g|0}g=c[j+4>>2]|0;i=d;return g|0}function BTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+24>>2]|0;e=c[a+32>>2]|0;a=d+(e<<3)|0;a:do if(!e)f=0;else{g=d;while(1){h=c[g>>2]|0;if((h|0)==4|(h|0)==224){j=g;break}g=g+8|0;if((g|0)==(a|0)){f=0;break a}}f=c[j+4>>2]|0}while(0);i=b;return f|0}function CTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a+24>>2]|0;f=c[a+32>>2]|0;a=e+(f<<3)|0;if(!f){g=0;i=d;return g|0}f=c[137788]|0;h=c[137786]|0;j=e;while(1){e=(da(f,c[j>>2]|0)|0)+b|0;k=e>>5;if(1<<e-(k<<5)&c[h+(k<<2)>>2]){l=j;break}j=j+8|0;if((j|0)==(a|0)){g=0;m=6;break}}if((m|0)==6){i=d;return g|0}g=c[l+4>>2]|0;i=d;return g|0}function DTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e;g=b+24|0;h=c[g>>2]|0;j=c[h+(d<<3)+4>>2]|0;k=d+1|0;l=b+32|0;aFi(h+(d<<3)|0,h+(k<<3)|0,(c[l>>2]|0)-k<<3|0)|0;k=(c[l>>2]|0)+-1|0;c[l>>2]=k;c[j+24>>2]=0;c[f+8>>2]=0;c[f+4>>2]=j;c[f>>2]=2;j=c[138732]|0;if(!k)m=0;else{h=k;k=0;while(1){d=c[g>>2]|0;n=c[d+(k<<3)>>2]|0;o=c[138e3]|0;p=(da(c[o+28>>2]|0,j)|0)+n|0;if(!(1<<(p&31)&c[(c[o+4>>2]|0)+(p>>>5<<2)>>2]))q=h;else{MVb((c[o+16>>2]|0)+(n<<5)|0,c[d+(k<<3)+4>>2]|0,j,f);q=c[l>>2]|0}k=k+1|0;if(k>>>0>=q>>>0){m=q;break}else h=q}}q=b+52|0;h=c[q>>2]|0;c[q>>2]=0;if(a[b+48>>0]|0){i=e;return}c[q>>2]=0;if(!m){i=e;return}b=c[g>>2]|0;k=0;f=m;m=b;j=b;while(1){b=c[j+4>>2]|0;if(!b){r=m;s=f;t=k}else{d=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;b=c[q>>2]|d;c[q>>2]=b;r=c[g>>2]|0;s=c[l>>2]|0;t=b}j=j+8|0;if((j|0)==(r+(s<<3)|0)){u=t;v=s;w=r;break}else{k=t;f=s;m=r}}if((h|0)==(u|0)|(v|0)==0){i=e;return}else{x=v;y=w;z=w}while(1){w=c[z+4>>2]|0;if(!w){A=y;B=x}else{In[c[(c[w>>2]|0)+96>>2]&4095](w,c[q>>2]|0);A=c[g>>2]|0;B=c[l>>2]|0}z=z+8|0;if((z|0)==(A+(B<<3)|0))break;else{x=B;y=A}}i=e;return}function ETb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+32>>2]|0;a:do if((e|0)>0){f=c[a+24>>2]|0;g=0;while(1){if((c[f+(g<<3)+4>>2]|0)==(b|0)){h=g;break a}g=g+1|0;if((g|0)>=(e|0)){h=-1;break}}}else h=-1;while(0);i=d;return h|0}function FTb(b){b=b|0;var c=0;c=i;if(vTb(b)|0){i=c;return}a[b+46>>0]=1;yTb(b,0);i=c;return}function GTb(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=b+46|0;if(vTb(b)|0){a[e>>0]=0;yTb(b,c);i=d;return}if(!(a[e>>0]|0)){i=d;return}a[e>>0]=0;i=d;return}function HTb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;e=vTb(b)|0;do if(c){if(!e){a[b+46>>0]=1;yTb(b,0)}}else{f=b+46|0;if(e){a[f>>0]=0;yTb(b,0);break}if(a[f>>0]|0)a[f>>0]=0}while(0);i=d;return}function ITb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=(c[b+8>>2]|0)>>>21;c[e+4>>2]=b;LUb(a+24|0,e);c[b+24>>2]=a;i=d;return}function JTb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+16|0;g=f;h=f+4|0;j=b+32|0;if(c[j>>2]|0){k=b+24|0;l=d^1;d=b+8|0;m=0;n=0;o=0;p=0;q=0;a:while(1){r=c[(c[k>>2]|0)+(n<<3)+4>>2]|0;do if((r|0)!=0?(s=(c[r+8>>2]|0)>>>21,(s|0)==4|(s|0)==224):0){t=m+1|0;if(p){if(!e?(c[d>>2]&1048576|0)!=0:0){u=0;v=25;break a}w=(c[p+8>>2]|0)>>>21;if(q|(s|0)==(w|0)){MUb(r,p,0);DTb(b,n);kQb(r);x=t;y=n+-1|0;z=o;A=p;B=q;break}if((w|0)==224&l){MUb(r,p,1);DTb(b,n);kQb(r);x=t;y=n+-1|0;z=o;A=p;B=1;break}else{MUb(p,r,1);DTb(b,o);w=n+-1|0;kQb(p);x=t;y=w;z=w;A=r;B=1;break}}else{x=t;y=n;z=n;A=r;B=q}}else{x=m;y=n;z=o;A=p;B=q}while(0);n=y+1|0;if(n>>>0>=(c[j>>2]|0)>>>0){C=x;D=z;E=A;break}else{m=x;o=z;p=A;q=B}}if((v|0)==25){i=f;return u|0}if(!E){Lsd(h,552168,g);if(!b){F=0;G=C;v=18}else{H=C;v=17}}else{I=C;J=D}}else{Lsd(h,552168,g);H=0;v=17}if((v|0)==17){F=c[b+4>>2]|0;G=H;v=18}if((v|0)==18){if(!(a[h>>0]&1))K=h+1|0;else K=c[h+8>>2]|0;Krd(K,0,3653512,748,1,F,0,0);xri(h);ZPc(b,4,0,0)|0;I=G;J=(c[j>>2]|0)+-1|0}if(J){j=c[b+24>>2]|0;b=j+(J<<3)|0;G=j+(J<<3)+4|0;J=c[G>>2]|0;h=c[b>>2]|0;c[b>>2]=c[j>>2];b=j+4|0;c[G>>2]=c[b>>2];c[j>>2]=h;c[b>>2]=J}u=(I|0)==1;i=f;return u|0}function KTb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+112|0;e=d;f=d+72|0;g=d+60|0;h=d+24|0;j=d+48|0;k=d+12|0;l=d+36|0;m=d+84|0;n=d+96|0;o=b+24|0;p=b+32|0;q=c[p>>2]|0;a:do if(q){r=b+8|0;s=b+56|0;t=f+1|0;u=f+8|0;v=b+4|0;w=q;x=0;while(1){y=c[o>>2]|0;z=c[y+(x<<3)+4>>2]|0;if(!z)A=0;else A=c[z+4>>2]|0;z=x;x=x+1|0;b:do if(x>>>0<w>>>0){B=w;C=y;D=x;while(1){E=D+1|0;F=B;G=C;while(1){H=c[G+(D<<3)+4>>2]|0;if(!H)I=0;else I=c[H+4>>2]|0;if((A|0)!=(I|0)){J=F;K=G;break}H=EQb((c[r>>2]|0)>>>21)|0;if(!(a[H>>0]&1))L=H+1|0;else L=c[H+8>>2]|0;H=c[s>>2]|0;M=EQb(c[(c[o>>2]|0)+(z<<3)>>2]|0)|0;if(!(a[M>>0]&1))N=M+1|0;else N=c[M+8>>2]|0;c[e>>2]=L;c[e+4>>2]=H;c[e+8>>2]=N;Lsd(f,552240,e);Krd((a[f>>0]&1)==0?t:c[u>>2]|0,0,3653512,781,1,c[v>>2]|0,0,0);xri(f);H=c[o>>2]|0;aFi(H+(D<<3)|0,H+(E<<3)|0,(c[p>>2]|0)-E<<3|0)|0;H=(c[p>>2]|0)+-1|0;c[p>>2]=H;if(D>>>0>=H>>>0){O=H;break b}F=H;G=c[o>>2]|0}if(E>>>0<J>>>0){B=J;C=K;D=E}else{O=J;break}}}else O=w;while(0);if(x>>>0>=O>>>0){P=O;break}else w=O}if(P){w=(b|0)==0;x=g+1|0;v=g+8|0;u=b+4|0;t=0;c:while(1){s=t;t=t+1|0;while(1){r=c[(c[o>>2]|0)+(s<<3)+4>>2]|0;if(!r)Q=0;else Q=c[r+4>>2]|0;if(PQb(Q)|0)break;r=c[(c[o>>2]|0)+(s<<3)>>2]|0;if((r|0)==17)jQb(Q);else{z=EQb(r)|0;if(!(a[z>>0]&1))R=z+1|0;else R=c[z+8>>2]|0;c[e>>2]=R;Lsd(g,552328,e);if(w)S=0;else S=c[u>>2]|0;Krd((a[g>>0]&1)==0?x:c[v>>2]|0,0,3653512,804,1,S,0,0);xri(g)}z=c[o>>2]|0;aFi(z+(s<<3)|0,z+(t<<3)|0,(c[p>>2]|0)-t<<3|0)|0;z=(c[p>>2]|0)+-1|0;c[p>>2]=z;if(s>>>0>=z>>>0){T=z;break c}}s=c[p>>2]|0;if(t>>>0>=s>>>0){T=s;break}}if(T){t=c[o>>2]|0;v=0;do{x=t+(v<<3)|0;u=(c[(c[t+(v<<3)+4>>2]|0)+8>>2]|0)>>>21;if((c[x>>2]|0)!=(u|0))c[x>>2]=u;v=v+1|0}while(v>>>0<T>>>0);if(T){v=b+4|0;t=m+1|0;u=m+8|0;x=(b|0)==0;w=h+1|0;s=h+8|0;z=k+1|0;r=k+8|0;y=T;D=0;while(1){C=D+1|0;B=y;d:while(1){G=c[o>>2]|0;F=c[G+(D<<3)+4>>2]|0;do if(F){H=F+24|0;M=c[H>>2]|0;if((M|0)==(b|0)){U=B;break d}if(!M){c[H>>2]=b;_ri(j,552400,GQb(F)|0);yO(h,j,552416);if(x)V=0;else V=c[v>>2]|0;Krd((a[h>>0]&1)==0?w:c[s>>2]|0,0,3653512,845,1,V,0,0);xri(h);xri(j);W=c[p>>2]|0;break}else{_ri(l,552464,GQb(F)|0);yO(k,l,552496);if(x)X=0;else X=c[v>>2]|0;Krd((a[k>>0]&1)==0?z:c[r>>2]|0,0,3653512,850,1,X,0,0);xri(k);xri(l);In[c[(c[F>>2]|0)+44>>2]&4095](F,61);Y=56;break}}else{_ri(n,552464,EQb(c[G+(D<<3)>>2]|0)|0);yO(m,n,552496);Krd((a[m>>0]&1)==0?t:c[u>>2]|0,0,3653512,856,1,c[v>>2]|0,0,0);xri(m);xri(n);Y=56}while(0);if((Y|0)==56){Y=0;G=c[o>>2]|0;aFi(G+(D<<3)|0,G+(C<<3)|0,(c[p>>2]|0)-C<<3|0)|0;G=(c[p>>2]|0)+-1|0;c[p>>2]=G;W=G}if(D>>>0<W>>>0)B=W;else break a}if(C>>>0<U>>>0){y=U;D=C}else break}}}}}while(0);if(JTb(b,0,0)|0){i=d;return}U=(b|0)!=0;if(!(c[b+8>>2]&1048576)){if(U)Z=c[b+4>>2]|0;else Z=0;Krd(552608,0,3653512,870,1,Z,0,0);i=d;return}else{if(U)_=c[b+4>>2]|0;else _=0;Krd(552512,0,3653512,868,1,_,0,0);i=d;return}}function LTb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[b+8>>2]|0;b=a+32|0;g=c[b>>2]|0;if(!g){i=e;return}h=a+24|0;a=g;g=0;while(1){j=c[h>>2]|0;k=c[j+(g<<3)>>2]|0;l=c[138e3]|0;m=(da(c[l+28>>2]|0,f)|0)+k|0;if(!(1<<(m&31)&c[(c[l+4>>2]|0)+(m>>>5<<2)>>2]))n=a;else{MVb((c[l+16>>2]|0)+(k<<5)|0,c[j+(g<<3)+4>>2]|0,f,d);n=c[b>>2]|0}g=g+1|0;if(g>>>0>=n>>>0)break;else a=n}i=e;return}function MTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+8|0;c[e>>2]=c[e>>2]&-1032193|b<<14&1032192;e=a+32|0;if(!(c[e>>2]|0)){i=d;return}f=a+24|0;a=0;do{g=c[(c[f>>2]|0)+(a<<3)+4>>2]|0;In[c[(c[g>>2]|0)+44>>2]&4095](g,b);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=d;return}function NTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+24>>2]|0;f=c[a+32>>2]|0;a=e+(f<<3)|0;if(!f){i=d;return}else g=e;do{EQc(c[g+4>>2]|0,b);g=g+8|0}while((g|0)!=(a|0));i=d;return}function OTb(a,b){a=a|0;b=b|0;return}function PTb(a){a=a|0;var b=0;b=i;if(0)fa(a|0);i=b;return}function QTb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[138170]|0;h=NUb()|0;OUb(g,((h|0)>(a|0)?h:a)+1|0);NVb((c[c[138170]>>2]|0)+(a<<5)|0,c[b+8>>2]|0,d,e);i=f;return}function RTb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[138170]|0;g=NUb()|0;OUb(f,((g|0)>(a|0)?g:a)+1|0);OVb((c[c[138170]>>2]|0)+(a<<5)|0,b,d);i=e;return}function STb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+16|0;b=a;d=c[138170]|0;c[b>>2]=0;e=b+4|0;c[e>>2]=0;c[b+8>>2]=0;AQb(0,b,0);f=c[e>>2]|0;g=c[b>>2]|0;if((f|0)==(g|0))h=1;else{j=f-g>>2;f=0;k=0;while(1){l=c[g+(k<<2)>>2]|0;m=(l|0)<(f|0)?f:l;k=k+1|0;if(k>>>0>=j>>>0){n=m;break}else f=m}h=n+1|0}OUb(d,h);h=d+4|0;if((c[h>>2]|0)!=(c[d>>2]|0)){n=0;do{a:do if(xQb(n)|0){f=HQb(n)|0;while(1){if(!f)break a;j=c[d>>2]|0;PVb(j+(n<<5)|0,j+(f<<5)|0);f=HQb(f)|0}}while(0);n=n+1|0}while(n>>>0<(c[h>>2]|0)-(c[d>>2]|0)>>5>>>0)}d=c[b>>2]|0;if(d){b=c[e>>2]|0;if((b|0)!=(d|0))c[e>>2]=b+(~((b+-4-d|0)>>>2)<<2);ACi(d)}RVb(c[138e3]|0,c[138170]|0);d=c[138170]|0;b=c[d>>2]|0;e=d+4|0;d=c[e>>2]|0;if((d|0)==(b|0)){i=a;return}else o=d;do{d=o+-32|0;c[e>>2]=d;h=c[o+-20>>2]|0;if(h){n=o+-16|0;f=c[n>>2]|0;if((f|0)!=(h|0))c[n>>2]=f+(~((f+-4-h|0)>>>2)<<2);ACi(h)}h=c[d>>2]|0;if(h){d=o+-28|0;f=c[d>>2]|0;if((f|0)!=(h|0))c[d>>2]=f+(~((f+-4-h|0)>>>2)<<2);ACi(h)}o=c[e>>2]|0}while((o|0)!=(b|0));i=a;return}function TTb(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153068];c[b+0>>2]=c[d+0>>2];d=bOb(60,b,0,16,3653512,1163)|0;c[d>>2]=c[153066];f=d+4|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=d+52|0;c[g>>2]=0;c[d+56>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[d+48>>2]=g;c[138e3]=d;c[e>>2]=c[153068];c[b+0>>2]=c[e+0>>2];e=bOb(12,b,0,16,3653512,1164)|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[138170]=e;QVb(c[138e3]|0);i=a;return}function UTb(){return c[138e3]|0}function VTb(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153106];c[b+0>>2]=c[d+0>>2];d=bOb(16,b,0,16,3653512,1368)|0;c[d>>2]=d;c[d+4>>2]=d;b=d+8|0;c[b>>2]=b;c[d+12>>2]=b;c[138220]=d;i=a;return}function WTb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[138220]|0;g=c[153106]|0;if(f){c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0}c[d>>2]=g;c[b+0>>2]=c[d+0>>2];eOb(f,b);c[138220]=0;f=c[138e3]|0;g=c[153068]|0;if(f){PUb(f+48|0,c[f+52>>2]|0);h=c[f+36>>2]|0;if(h){j=f+40|0;k=c[j>>2]|0;if((k|0)!=(h|0))c[j>>2]=k+(~(((k+-20-h|0)>>>0)/20|0)*20|0);ACi(h)}QUb(f+16|0);h=c[f+4>>2]|0;c[d>>2]=c[f>>2];c[b+0>>2]=c[d+0>>2];eOb(h,b)}c[e>>2]=g;c[b+0>>2]=c[e+0>>2];eOb(f,b);c[138e3]=0;f=c[138170]|0;e=c[153068]|0;if(!f){c[d>>2]=e;c[b+0>>2]=c[d+0>>2];eOb(f,b);c[138170]=0;i=a;return}QUb(f);c[d>>2]=e;c[b+0>>2]=c[d+0>>2];eOb(f,b);c[138170]=0;i=a;return}function XTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[b+8>>2]|0;b=a+24|0;f=a+32|0;a=c[f>>2]|0;if(!a){g=0;i=d;return g|0}h=c[b>>2]|0;j=a;a=h;k=h;while(1){h=c[k>>2]|0;l=c[138e3]|0;m=(da(c[l+28>>2]|0,e)|0)+h|0;if(!(1<<(m&31)&c[(c[l+4>>2]|0)+(m>>>5<<2)>>2])){n=a;o=j}else{if(SVb(l,c[k+4>>2]|0,h,e)|0){g=1;p=7;break}n=c[b>>2]|0;o=c[f>>2]|0}k=k+8|0;if((k|0)==(n+(o<<3)|0)){g=0;p=7;break}else{j=o;a=n}}if((p|0)==7){i=d;return g|0}return 0}function YTb(b){b=b|0;var c=0;c=i;if((a[b+47>>0]|0)==-1){i=c;return}yTb(b,0);i=c;return}function ZTb(d,e){d=d|0;e=e|0;var f=0;f=i;c[e+40>>2]=c[d+40>>2];b[e+44>>1]=b[d+44>>1]|0;a[e+46>>0]=a[d+46>>0]|0;a[e+47>>0]=-1;rbc(e+56|0,d+56|0);i=f;return}function _Tb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=(c[a+8>>2]|0)>>>21;g=c[138e3]|0;h=c[b+8>>2]|0;b=(da(c[g+28>>2]|0,h)|0)+f|0;if(!(1<<(b&31)&c[(c[g+4>>2]|0)+(b>>>5<<2)>>2])){i=e;return}MVb((c[g+16>>2]|0)+(f<<5)|0,a,h,d);i=e;return}function $Tb(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+24>>2]|0;if(e){f=c[e+56>>2]|0;i=d;return f|0}e=GQb(b)|0;if(!(a[e>>0]&1)){f=e+1|0;i=d;return f|0}else{f=c[e+8>>2]|0;i=d;return f|0}return 0}function aUb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+24>>2]|0;if(!e){i=d;return}In[c[(c[e>>2]|0)+36>>2]&4095](e,b);i=d;return}function bUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];lQb(a,f,d);c[a>>2]=552696;c[a+24>>2]=0;i=e;return}function cUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[a+24>>2]|0;if(!f){i=e;return}a=c[b+8>>2]|0;b=f+32|0;g=c[b>>2]|0;if(!g){i=e;return}h=f+24|0;f=g;g=0;while(1){j=c[h>>2]|0;k=c[j+(g<<3)>>2]|0;l=c[138e3]|0;m=(da(c[l+28>>2]|0,a)|0)+k|0;if(!(1<<(m&31)&c[(c[l+4>>2]|0)+(m>>>5<<2)>>2]))n=f;else{MVb((c[l+16>>2]|0)+(k<<5)|0,c[j+(g<<3)+4>>2]|0,a,d);n=c[b>>2]|0}g=g+1|0;if(g>>>0>=n>>>0)break;else f=n}i=e;return}function dUb(a,b){a=a|0;b=b|0;return}function eUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+24>>2]|0;if(!e)f=0;else f=c[e+4>>2]|0;DQc(f,b);i=d;return}function fUb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=d+4|0;g=c[b+24>>2]|0;if(!g){i=d;return}h=c[g+32>>2]|0;a:do if((h|0)>0){j=c[g+24>>2]|0;k=0;while(1){if((c[j+(k<<3)+4>>2]|0)==(b|0))break;k=k+1|0;if((k|0)>=(h|0))break a}i=d;return}while(0);h=GQb(b)|0;if(!(a[h>>0]&1))l=h+1|0;else l=c[h+8>>2]|0;c[e>>2]=l;Lsd(f,552808,e);if(!(a[f>>0]&1))m=f+1|0;else m=c[f+8>>2]|0;Krd(m,0,3653512,1346,1,c[g+4>>2]|0,0,0);xri(f);zTb(g,b);i=d;return}function gUb(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2460104,a,0);bTb(a,b);bdd(b);i=c;return}function hUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2460104,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else cTb(a,b);sdd(b);i=d;return}function iUb(a,b){a=a|0;b=b|0;var c=0;c=i;dTb(a,b);i=c;return}function jUb(a,b){a=a|0;b=b|0;var c=0;c=i;eTb(a,b);i=c;return}function kUb(a,b){a=a|0;b=b|0;var c=0;c=i;fTb(a,b);i=c;return}function lUb(a,b){a=a|0;b=b|0;var c=0;c=i;gTb(a,b);i=c;return}function mUb(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2459184,a,0);hTb(a,b);bdd(b);i=c;return}function nUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=qdd(b,792072,2459184,f,1)|0;if(!g){i=d;return}if((g|0)>0){if((c[b>>2]&16384|0)==0?(g=a+24|0,h=qdd(b,551984,552888,e,1)|0,(h|0)!=0):0){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else HUb(g,b);sdd(b)}}else{g=c[f>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b);i=d;return}function oUb(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[b>>2]&16384){i=d;return}IUb(a+24|0,b);i=d;return}function pUb(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[b>>2]&16384){i=d;return}JUb(a+24|0,b);i=d;return}function qUb(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[b>>2]&16384){i=d;return}KUb(a+24|0,b);i=d;return}function rUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(c[d>>2]&16384){i=e;return}idd(d,65601);f=b+24|0;b=c[f>>2]|0;if(!b)g=0;else g=c[b+4>>2]|0;b=c[d+12>>2]|0;h=xo[c[c[b>>2]>>2]&2047](b,g,c[d+28>>2]|0)|0;if(a[d+32>>0]|0)c[f>>2]=iQb(h,0)|0;jdd(d);i=e;return}function sUb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(18)|0))TRb();rri(b,2460104,10);wQb(1,18,b,72,2598,0,0);xri(b);i=a;return}function tUb(a){a=a|0;return 1}function uUb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(18)|0))TRb();rri(b,2459184,9);wQb(2,18,b,28,2599,0,0);xri(b);i=a;return}function vUb(a){a=a|0;return 2}function wUb(){var a=0;a=i;QQb(2,84,0,0,0);i=a;return}function xUb(){var a=0;a=i;QQb(1,85,86,0,87);i=a;return}function yUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];aVb(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<3)|0;do if(c[f>>2]|0){j=c[142274]|0;g=qdd(a,3142592,j,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((g|0)==2){g=c[l>>2]|0;o=c[g+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(k|0)){q=0;r=g;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(h,r);t=h;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;bVb(s,a);u=s+8|0;if((u|0)==(k|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(k|0)){n=l;do{l=qdd(a,3142592,j,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else bVb(n,a);sdd(a)}n=n+8|0}while((n|0)!=(k|0))}}while(0);udd(a);i=d;return}function zUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+4|0;j=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cVb(d,h,1);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;c[j>>2]=c[153118];c[f+0>>2]=c[j+0>>2];tbc(b,k,f);if(!(a[h>>0]&1)){i=e;return}k=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function AUb(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=qdd(a,f,c[142296]|0,h,0)|0;if(!j){i=g;return}if((j|0)>0){j=a+12|0;f=c[a+16>>2]|0;k=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;l=f+k|0;c[j>>2]=l;if((k|0)>=0?(m=f+(k+2)|0,m>>>0<=(c[a+20>>2]|0)>>>0):0){b[d>>1]=b[l>>1]|0;c[j>>2]=m}else Bid(j,d,2);if(c[a>>2]&512){j=e[d>>1]|0;b[d>>1]=j<<8|j>>>8}}else{j=c[h>>2]|0;if(j)_n[j&4095](d,a)|0}sdd(a);i=g;return}function BUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];aVb(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<3)|0;if(!k){i=d;return}else u=s;do{s=c[l>>2]|0;k=s+4|0;if(k>>>0>(c[p>>2]|0)>>>0)Bid(l,u,4);else{c[u>>2]=c[s>>2];c[l>>2]=k}dVb(u+4|0,a);u=u+8|0}while((u|0)!=(t|0));i=d;return}else{if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<3;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>3;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}}function CUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+4|0;j=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eVb(d,h,1);Ndd(d);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;c[j>>2]=c[153118];c[f+0>>2]=c[j+0>>2];tbc(b,k,f);if(!(a[h>>0]&1)){i=e;return}k=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function DUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];aVb(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<3)|0;if(!k){i=d;return}else u=t;do{t=c[l>>2]|0;k=t+4|0;if(k>>>0>(c[p>>2]|0)>>>0){Bid(l,u,4);v=c[u>>2]|0}else{s=c[t>>2]|0;c[u>>2]=s;c[l>>2]=k;v=s}c[u>>2]=XEi(v|0)|0;fVb(u+4|0,a);u=u+8|0}while((u|0)!=(j|0));i=d;return}else{if(r){Bid(l,h,4);w=c[h>>2]|0;x=c[l>>2]|0;y=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;w=p;x=o;y=q}q=XEi(w|0)|0;c[h>>2]=q;w=x+4|0;if(w>>>0>y>>>0){Bid(l,g,4);z=c[g>>2]|0;A=c[h>>2]|0}else{h=c[x>>2]|0;c[g>>2]=h;c[l>>2]=w;z=h;A=q}q=XEi(z|0)|0;c[g>>2]=q;g=A<<3;A=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>3;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=A;c[m>>2]=0;i=d;return}}function EUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+4|0;j=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;gVb(d,h,1);Mdd(d);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;c[j>>2]=c[153118];c[f+0>>2]=c[j+0>>2];tbc(b,k,f);if(!(a[h>>0]&1)){i=e;return}k=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function FUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=c[a>>2]|0;a=(g|0)==0;if(!(c[b>>2]&1)){if(a)h=0;else h=c[g+4>>2]|0;c[e>>2]=h;j=f;c[j>>2]=0;c[j+4>>2]=0;j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0<n>>>0){c[k>>2]=h;c[j>>2]=l;o=l;p=n}else{Gid(j,e,4);o=c[j>>2]|0;p=c[m>>2]|0}m=o+8|0;if(m>>>0<p>>>0){p=f;n=c[p+4>>2]|0;l=o;c[l>>2]=c[p>>2];c[l+4>>2]=n;c[j>>2]=m;i=d;return}else{Gid(j,f,8);i=d;return}}else{if(a)q=0;else q=c[g+4>>2]|0;fQb(q,e);q=b+12|0;g=c[q>>2]|0;a=g+4|0;j=b+20|0;b=c[j>>2]|0;if(a>>>0<b>>>0){c[g>>2]=c[e>>2];c[q>>2]=a;r=a;s=b}else{Gid(q,e,4);r=c[q>>2]|0;s=c[j>>2]|0}j=r+8|0;if(j>>>0<s>>>0){s=f;e=c[s+4>>2]|0;b=r;c[b>>2]=c[s>>2];c[b+4>>2]=e;c[q>>2]=j;i=d;return}else{Gid(q,f,8);i=d;return}}}function GUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=c[b>>2]|0;b=SEi(j|0)|0;if(b>>>0>10){AOb(h,10,b+-10|0,0,0,0,b,j);k=a[h>>0]|0}else{aFi(h+1|0,j|0,b|0)|0;a[h+b+1>>0]=0;j=b<<1&255;a[h>>0]=j;k=j}if(!(k&1))l=(k&255)>>>1;else l=c[h+4>>2]|0;c[f>>2]=l;k=d+12|0;j=c[k>>2]|0;b=j+4|0;m=d+20|0;if(b>>>0<(c[m>>2]|0)>>>0){c[j>>2]=l;c[k>>2]=b}else Gid(k,f,4);b=a[h>>0]|0;if(!(b&1)){n=h+1|0;o=h+((b&255)>>>1)+1|0}else{b=c[h+8>>2]|0;n=b;o=b+(c[h+4>>2]|0)|0}if((n|0)!=(o|0)){b=n;do{n=c[k>>2]|0;if((n+1|0)>>>0<(c[m>>2]|0)>>>0){a[n>>0]=a[b>>0]|0;c[k>>2]=(c[k>>2]|0)+1}else Gid(k,b,1);b=b+1|0}while((b|0)!=(o|0))}Tdd(d);if(!(a[h>>0]&1)){i=e;return}d=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(d,f);i=e;return}function HUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d;g=d+16|0;h=f+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[f>>2]=0;j=c[b>>2]|0;if(!(j&1)){k=qdd(b,792256,c[142270]|0,e,0)|0;if(k){if((k|0)>0){k=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[n>>2];c[k>>2]=o}else Bid(k,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{k=c[e>>2]|0;if(k)_n[k&4095](f,b)|0}sdd(b)}k=qdd(b,792272,c[142290]|0,e,0)|0;if(k){if((k|0)>0){k=b+12|0;o=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=o+n|0;c[k>>2]=m;if((n|0)>=0?(l=o+(n+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){n=m;m=c[n+4>>2]|0;o=h;c[o>>2]=c[n>>2];c[o+4>>2]=m;c[k>>2]=l}else Bid(k,h,8);if(c[b>>2]&512){k=XEi(c[h>>2]|0)|0;l=h+4|0;c[h>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=k}}else{k=c[e>>2]|0;if(k)_n[k&4095](h,b)|0}sdd(b)}c[a>>2]=iQb(c[f>>2]|0,0)|0;i=d;return}else{k=(j&8388608|0)!=0;j=qdd(b,792256,c[142270]|0,e,0)|0;if(j){if((j|0)>0){j=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;o=l+m|0;c[j>>2]=o;if((m|0)>=0?(n=l+(m+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[o>>2];c[j>>2]=n}else Bid(j,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](f,b)|0}sdd(b)}j=qdd(b,792272,c[142290]|0,e,0)|0;if(j){if((j|0)>0){j=b+12|0;n=c[b+16>>2]|0;o=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=n+o|0;c[j>>2]=m;if((o|0)>=0?(l=n+(o+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){o=m;m=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=m;c[j>>2]=l}else Bid(j,h,8);if(c[b>>2]&512){j=XEi(c[h>>2]|0)|0;l=h+4|0;c[h>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=j}}else{j=c[e>>2]|0;if(j)_n[j&4095](h,b)|0}sdd(b)}gQb(f,g);c[a>>2]=iQb(c[g>>2]|0,k)|0;i=d;return}}function IUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d;f=d+16|0;g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[b>>2]|0;if(!(h&1)){j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(j,e,4);o=c[j>>2]|0;p=c[m>>2]|0}else{c[e>>2]=c[k>>2];c[j>>2]=l;o=l;p=n}n=o+8|0;if(n>>>0>p>>>0)Bid(j,g,8);else{p=o;o=c[p+4>>2]|0;l=g;c[l>>2]=c[p>>2];c[l+4>>2]=o;c[j>>2]=n}c[a>>2]=iQb(c[e>>2]|0,0)|0;i=d;return}else{n=b+12|0;j=c[n>>2]|0;o=j+4|0;l=b+20|0;b=c[l>>2]|0;if(o>>>0>b>>>0){Bid(n,e,4);q=c[n>>2]|0;r=c[l>>2]|0}else{c[e>>2]=c[j>>2];c[n>>2]=o;q=o;r=b}b=q+8|0;if(b>>>0>r>>>0)Bid(n,g,8);else{r=q;q=c[r+4>>2]|0;o=g;c[o>>2]=c[r>>2];c[o+4>>2]=q;c[n>>2]=b}gQb(e,f);c[a>>2]=iQb(c[f>>2]|0,(h&8388608|0)!=0)|0;i=d;return}}function JUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+32|0;e=d;f=d+16|0;g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[b>>2]|0;if(!(h&1)){j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(j,e,4);o=c[e>>2]|0;p=c[j>>2]|0;q=c[m>>2]|0}else{m=c[k>>2]|0;c[e>>2]=m;c[j>>2]=l;o=m;p=l;q=n}n=XEi(o|0)|0;c[e>>2]=n;o=p+8|0;if(o>>>0>q>>>0){Bid(j,g,8);q=g+4|0;r=g;s=q;t=c[g>>2]|0;u=c[q>>2]|0;v=c[e>>2]|0}else{q=p;p=c[q>>2]|0;l=c[q+4>>2]|0;q=g;c[q>>2]=p;c[q+4>>2]=l;c[j>>2]=o;r=g;s=g+4|0;t=p;u=l;v=n}n=XEi(t|0)|0;c[r>>2]=XEi(u|0)|0;c[s>>2]=n;c[a>>2]=iQb(v,0)|0;i=d;return}else{v=b+12|0;n=c[v>>2]|0;s=n+4|0;u=b+20|0;b=c[u>>2]|0;if(s>>>0>b>>>0){Bid(v,e,4);w=c[e>>2]|0;x=c[v>>2]|0;y=c[u>>2]|0}else{u=c[n>>2]|0;c[e>>2]=u;c[v>>2]=s;w=u;x=s;y=b}c[e>>2]=XEi(w|0)|0;w=x+8|0;if(w>>>0>y>>>0){Bid(v,g,8);y=g+4|0;z=g;A=y;B=c[g>>2]|0;C=c[y>>2]|0}else{y=x;x=c[y>>2]|0;b=c[y+4>>2]|0;y=g;c[y>>2]=x;c[y+4>>2]=b;c[v>>2]=w;z=g;A=g+4|0;B=x;C=b}b=XEi(B|0)|0;c[z>>2]=XEi(C|0)|0;c[A>>2]=b;gQb(e,f);c[a>>2]=iQb(c[f>>2]|0,(h&8388608|0)!=0)|0;i=d;return}}function KUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=c[a>>2]|0;a=(g|0)==0;if(!(c[b>>2]&1)){if(a)h=0;else h=c[g+4>>2]|0;c[e>>2]=h;j=f;c[j>>2]=0;c[j+4>>2]=0;j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0<n>>>0){c[k>>2]=h;c[j>>2]=l;o=l;p=n}else{Gid(j,e,4);o=c[j>>2]|0;p=c[m>>2]|0}m=o+8|0;if(m>>>0<p>>>0){p=f;n=c[p+4>>2]|0;l=o;c[l>>2]=c[p>>2];c[l+4>>2]=n;c[j>>2]=m;i=d;return}else{Gid(j,f,8);i=d;return}}else{if(a)q=0;else q=c[g+4>>2]|0;fQb(q,e);q=b+12|0;g=c[q>>2]|0;a=g+4|0;j=b+20|0;b=c[j>>2]|0;if(a>>>0<b>>>0){c[g>>2]=c[e>>2];c[q>>2]=a;r=a;s=b}else{Gid(q,e,4);r=c[q>>2]|0;s=c[j>>2]|0}j=r+8|0;if(j>>>0<s>>>0){s=f;e=c[s+4>>2]|0;b=r;c[b>>2]=c[s>>2];c[b+4>>2]=e;c[q>>2]=j;i=d;return}else{Gid(q,f,8);i=d;return}}}function LUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<3)|0;c[q>>2]=p;r=b+4|0;s=c[r>>2]|0;t=o+(n<<3)+4|0;c[t>>2]=s;i=d;return}h=k<<1;u=(h|0)==0?1:h;do if(l>>>0<u>>>0)if((k|0)>-1){c[j>>2]=u;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,u<<3,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(u<<3,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<3|0)|0;c[j>>2]=u;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<3)|0;c[q>>2]=p;r=b+4|0;s=c[r>>2]|0;t=o+(n<<3)+4|0;c[t>>2]=s;i=d;return}function MUb(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+16|0;m=h;n=ea(g[b+44>>2]);o=ea(g[b+48>>2]);p=ea(g[b+52>>2]);q=b+28|0;c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];q=b+56|0;c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];a[e+137>>0]=a[b+137>>0]|0;q=b+156|0;r=c[q>>2]|0;a:do if((r|0)!=0?(c[q>>2]=0,s=c[r+148>>2]|0,(s|0)!=0):0){t=c[r+140>>2]|0;u=0;while(1){v=t+(u<<2)|0;u=u+1|0;if((c[v>>2]|0)==(b|0)){w=v;break}if(u>>>0>=s>>>0)break a}s=e+156|0;if(!(c[s>>2]|0)){c[w>>2]=e;c[s>>2]=r;break}else{mGc(r,b);break}}while(0);r=b+140|0;w=b+148|0;if(c[w>>2]|0){q=e+140|0;s=e+148|0;u=e+152|0;t=e+140|0;v=e+144|0;x=0;do{y=c[(c[r>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=jGc(e,y)|0,A=c[q>>2]|0,B=c[s>>2]|0,(z|0)==(A+(B<<2)|0)):0){c[y+156>>2]=e;z=B+1|0;c[s>>2]=z;B=c[u>>2]|0;C=B&2147483647;if(z>>>0>C>>>0){D=B<<1;E=(D|0)==0?1:D;do if(C>>>0<E>>>0)if((B|0)>-1){c[u>>2]=E;c[k>>2]=c[v>>2];c[j+0>>2]=c[k+0>>2];D=hOb(A,E<<2,4,j,0,3653512,370)|0;c[t>>2]=D;F=D;break}else{c[k>>2]=c[v>>2];c[j+0>>2]=c[k+0>>2];D=cOb(E<<2,4,j,0,3653512,352)|0;YEi(D|0,c[t>>2]|0,c[s>>2]<<2|0)|0;c[u>>2]=E;c[t>>2]=D;F=D;break}else F=A;while(0);G=c[s>>2]|0;H=F}else{G=z;H=A}c[H+(G+-1<<2)>>2]=y}x=x+1|0}while(x>>>0<(c[w>>2]|0)>>>0)}x=b+152|0;if((c[x>>2]|0)>-1){G=c[r>>2]|0;c[k>>2]=c[b+144>>2];c[j+0>>2]=c[k+0>>2];eOb(G,j);c[r>>2]=0}c[w>>2]=0;c[x>>2]=0;if(!f){i=h;return}g[e+44>>2]=n;g[e+48>>2]=o;g[e+52>>2]=p;f=e+135|0;x=(d[f>>0]|0|1)&255;a[f>>0]=x;do if((c[e+8>>2]&-2097152|0)==469762048){p=ea(n);w=e+192|0;I=ea(g[w>>2]);J=ea(n-I);if(J<ea(0.0))K=ea(-J);else K=J;if(I<ea(0.0))L=ea(-I);else L=I;if(n<ea(0.0))M=ea(-n);else M=n;I=ea((L<M?M:L)*ea(9.99999997e-07));r=I<ea(.000079999998);if(K<(r?ea(.000079999998):I)){I=ea(g[e+196>>2]);J=ea(o-I);if(J<ea(0.0))N=ea(-J);else N=J;if(I<ea(0.0))O=ea(-I);else O=I;if(o<ea(0.0))P=ea(-o);else P=o;I=ea((O<P?P:O)*ea(9.99999997e-07));r=I<ea(.000079999998);if(N<(r?ea(.000079999998):I)){Q=x;break}}I=ea(o);r=w;g[r>>2]=p;g[r+4>>2]=I;hzc(e);Q=a[f>>0]|0}else Q=x;while(0);x=e+28|0;c[x+0>>2]=c[l+0>>2];c[x+4>>2]=c[l+4>>2];c[x+8>>2]=c[l+8>>2];c[x+12>>2]=c[l+12>>2];l=e+56|0;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];a[f>>0]=Q&255|10;gGc(e);i=h;return}function NUb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;i=i+16|0;b=a;d=c[138236]|0;if(d){e=d;i=a;return e|0}c[b>>2]=0;d=b+4|0;c[d>>2]=0;c[b+8>>2]=0;AQb(2,b,0);f=c[d>>2]|0;g=c[b>>2]|0;if((f|0)==(g|0)){h=f;j=c[138236]|0}else{b=f-g>>2;k=c[138236]|0;l=0;while(1){m=c[g+(l<<2)>>2]|0;n=(k|0)<(m|0)?m:k;c[138236]=n;l=l+1|0;if(l>>>0>=b>>>0){h=g;j=n;break}else k=n}}if(!h){e=j;i=a;return e|0}if((f|0)!=(h|0))c[d>>2]=f+(~((f+-4-h|0)>>>2)<<2);ACi(h);e=j;i=a;return e|0}function OUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+4|0;f=c[e>>2]|0;g=c[a>>2]|0;h=f-g>>5;if(h>>>0<b>>>0){hVb(a,b-h|0);i=d;return}if(h>>>0<=b>>>0){i=d;return}h=g+(b<<5)|0;if((f|0)==(h|0)){i=d;return}else j=f;do{f=j+-32|0;c[e>>2]=f;b=c[j+-20>>2]|0;if(b){g=j+-16|0;a=c[g>>2]|0;if((a|0)!=(b|0))c[g>>2]=a+(~((a+-4-b|0)>>>2)<<2);ACi(b)}b=c[f>>2]|0;if(b){f=j+-28|0;a=c[f>>2]|0;if((a|0)!=(b|0))c[f>>2]=a+(~((a+-4-b|0)>>>2)<<2);ACi(b)}j=c[e>>2]|0}while((j|0)!=(h|0));i=d;return}function PUb(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}PUb(a,c[b>>2]|0);PUb(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function QUb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(!f){i=b;return}g=a+4|0;h=c[g>>2]|0;if((h|0)==(f|0))j=f;else{k=h;do{h=k+-32|0;c[g>>2]=h;l=c[k+-20>>2]|0;if(l){m=k+-16|0;n=c[m>>2]|0;if((n|0)!=(l|0))c[m>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(l)}l=c[h>>2]|0;if(l){h=k+-28|0;n=c[h>>2]|0;if((n|0)!=(l|0))c[h>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(l)}k=c[g>>2]|0}while((k|0)!=(f|0));j=c[a>>2]|0}c[e>>2]=1;c[d+0>>2]=c[e+0>>2];eOb(j,d);i=b;return}function RUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(72,e,1,16,3653512,90)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];nTb(f,e,b);i=d;return f|0}function SUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(28,e,1,16,3653512,333)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];lQb(g,e,b);c[g>>2]=552696;c[g+24>>2]=0;i=d;return g|0}function TUb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=552016;ubc(a+56|0);if((c[a+36>>2]|0)<=-1){c[a>>2]=551440;i=b;return}f=a+24|0;g=c[f>>2]|0;c[e>>2]=c[a+28>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;c[a>>2]=551440;i=b;return}function UUb(a){a=a|0;var b=0;b=i;TUb(a);ACi(a);i=b;return}function VUb(a){a=a|0;return c[a+56>>2]|0}function WUb(a){a=a|0;c[a>>2]=551440;return}function XUb(a){a=a|0;var b=0;b=i;c[a>>2]=551440;ACi(a);i=b;return}function YUb(a){a=a|0;return 0}function ZUb(a,b){a=a|0;b=b|0;return}function _Ub(a){a=a|0;return}function $Ub(a,b){a=a|0;b=b|0;return}function aVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<3,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<3,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<3|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<3)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<3)|0;do{if(f){c[f+4>>2]=0;c[f>>2]=0}f=f+8|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function bVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,c[142270]|0,e,0)|0;if(f){if((f|0)>0){f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[j>>2];c[f>>2]=k}else Bid(f,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}sdd(b)}f=a+4|0;a=qdd(b,c[142282]|0,552928,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else iVb(f,b);sdd(b);i=d;return}function cVb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;k=a[d>>0]|0;if(!(k&1))l=(k&255)>>>1;else l=c[d+4>>2]|0;c[g>>2]=l;if(!(tdd(b,2646336,2646336,g)|0)){i=e;return}l=c[g>>2]|0;c[h>>2]=c[b+8>>2];c[f+0>>2]=c[h+0>>2];jVb(d,l,f);f=a[d>>0]|0;if(!(f&1)){m=d+1|0;n=(f&255)>>>1}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0}f=m+n|0;a:do if(c[g>>2]|0){n=qdd(b,3142592,c[142260]|0,0,0)|0;m=b+80|0;l=c[($hd(c[m>>2]|0)|0)+12>>2]|0;h=b+84|0;c[c[h>>2]>>2]=0;if((n|0)!=2){sdd(b);if(!(a[d>>0]&1))o=d+1|0;else o=c[d+8>>2]|0;if((o|0)==(f|0))break;else p=o;while(1){kVb(b,p,3142592,0);p=p+1|0;if((p|0)==(f|0))break a}}n=c[m>>2]|0;k=c[n+12>>2]|0;if(!(a[d>>0]&1))q=d+1|0;else q=c[d+8>>2]|0;b:do if((q|0)!=(f|0)){r=b+12|0;s=b+16|0;t=b+28|0;u=b+32|0;v=b+20|0;w=0;x=n;y=q;while(1){z=(da(w,l)|0)+k|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(j,x);z=j;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[h>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(A+(B+1)|0)>>>0<=(c[v>>2]|0)>>>0:0){a[y>>0]=a[z>>0]|0;c[r>>2]=(c[r>>2]|0)+1}else Bid(r,y,1);z=y+1|0;if((z|0)==(f|0))break b;w=c[c[h>>2]>>2]|0;x=c[m>>2]|0;y=z}}while(0);sdd(b)}while(0);udd(b);i=e;return}function dVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d;f=d+16|0;g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[b>>2]|0;if(!(h&1)){j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(j,e,4);o=c[j>>2]|0;p=c[m>>2]|0}else{c[e>>2]=c[k>>2];c[j>>2]=l;o=l;p=n}n=o+8|0;if(n>>>0>p>>>0)Bid(j,g,8);else{p=o;o=c[p+4>>2]|0;l=g;c[l>>2]=c[p>>2];c[l+4>>2]=o;c[j>>2]=n}c[a>>2]=iQb(c[e>>2]|0,0)|0;i=d;return}else{n=b+12|0;j=c[n>>2]|0;o=j+4|0;l=b+20|0;b=c[l>>2]|0;if(o>>>0>b>>>0){Bid(n,e,4);q=c[n>>2]|0;r=c[l>>2]|0}else{c[e>>2]=c[j>>2];c[n>>2]=o;q=o;r=b}b=q+8|0;if(b>>>0>r>>>0)Bid(n,g,8);else{r=q;q=c[r+4>>2]|0;o=g;c[o>>2]=c[r>>2];c[o+4>>2]=q;c[n>>2]=b}gQb(e,f);c[a>>2]=iQb(c[f>>2]|0,(h&8388608|0)!=0)|0;i=d;return}}function eVb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+12|0;m=b+48|0;n=c[l>>2]|0;o=n+4|0;p=b+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[l>>2]|0;t=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;s=o;t=q}q=s+4|0;if(q>>>0>t>>>0){Bid(l,g,4);u=c[g>>2]|0}else{t=c[s>>2]|0;c[g>>2]=t;c[l>>2]=q;u=t}zid(l,u,c[h>>2]|0)|0;c[m>>2]=0;i=e;return}if(r){Bid(l,j,4);v=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;v=r}c[k>>2]=c[b+8>>2];c[f+0>>2]=c[k+0>>2];jVb(d,v,f);f=c[j>>2]|0;if(!f){i=e;return}if(!(a[d>>0]&1))w=d+1|0;else w=c[d+8>>2]|0;Ldd(b,w,f);i=e;return}function fVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+32|0;e=d;f=d+16|0;g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[b>>2]|0;if(!(h&1)){j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(j,e,4);o=c[e>>2]|0;p=c[j>>2]|0;q=c[m>>2]|0}else{m=c[k>>2]|0;c[e>>2]=m;c[j>>2]=l;o=m;p=l;q=n}n=XEi(o|0)|0;c[e>>2]=n;o=p+8|0;if(o>>>0>q>>>0){Bid(j,g,8);q=g+4|0;r=g;s=q;t=c[g>>2]|0;u=c[q>>2]|0;v=c[e>>2]|0}else{q=p;p=c[q>>2]|0;l=c[q+4>>2]|0;q=g;c[q>>2]=p;c[q+4>>2]=l;c[j>>2]=o;r=g;s=g+4|0;t=p;u=l;v=n}n=XEi(t|0)|0;c[r>>2]=XEi(u|0)|0;c[s>>2]=n;c[a>>2]=iQb(v,0)|0;i=d;return}else{v=b+12|0;n=c[v>>2]|0;s=n+4|0;u=b+20|0;b=c[u>>2]|0;if(s>>>0>b>>>0){Bid(v,e,4);w=c[e>>2]|0;x=c[v>>2]|0;y=c[u>>2]|0}else{u=c[n>>2]|0;c[e>>2]=u;c[v>>2]=s;w=u;x=s;y=b}c[e>>2]=XEi(w|0)|0;w=x+8|0;if(w>>>0>y>>>0){Bid(v,g,8);y=g+4|0;z=g;A=y;B=c[g>>2]|0;C=c[y>>2]|0}else{y=x;x=c[y>>2]|0;b=c[y+4>>2]|0;y=g;c[y>>2]=x;c[y+4>>2]=b;c[v>>2]=w;z=g;A=g+4|0;B=x;C=b}b=XEi(B|0)|0;c[z>>2]=XEi(C|0)|0;c[A>>2]=b;gQb(e,f);c[a>>2]=iQb(c[f>>2]|0,(h&8388608|0)!=0)|0;i=d;return}}function gVb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+12|0;m=b+48|0;n=c[l>>2]|0;o=n+4|0;p=b+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[h>>2]|0;t=c[l>>2]|0;u=c[p>>2]|0}else{v=c[n>>2]|0;c[h>>2]=v;c[l>>2]=o;s=v;t=o;u=q}q=XEi(s|0)|0;c[h>>2]=q;s=t+4|0;if(s>>>0>u>>>0){Bid(l,g,4);w=c[g>>2]|0;x=c[h>>2]|0}else{h=c[t>>2]|0;c[g>>2]=h;c[l>>2]=s;w=h;x=q}q=XEi(w|0)|0;c[g>>2]=q;zid(l,q,x)|0;c[m>>2]=0;i=e;return}if(r){Bid(l,j,4);y=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;y=r}r=XEi(y|0)|0;c[j>>2]=r;c[k>>2]=c[b+8>>2];c[f+0>>2]=c[k+0>>2];jVb(d,r,f);f=a[d>>0]|0;if(!(f&1)){z=d+1|0;A=d+((f&255)>>>1)+1|0}else{f=c[d+8>>2]|0;z=f;A=f+(c[d+4>>2]|0)|0}if((z|0)==(A|0)){i=e;return}else B=z;do{z=c[l>>2]|0;if((z+1|0)>>>0>(c[p>>2]|0)>>>0)Bid(l,B,1);else{a[B>>0]=a[z>>0]|0;c[l>>2]=(c[l>>2]|0)+1}B=B+1|0}while((B|0)!=(A|0));i=e;return}function hVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>5>>>0>=b>>>0){n=b;o=l;do{if(!o)p=0;else{LVb(o);p=c[k>>2]|0}o=p+32|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=d;return}n=c[a>>2]|0;o=(m-n>>5)+b|0;if((o|0)<0)vxi(a);m=n;n=j-m|0;if(n>>5>>>0<1073741823){j=n>>4;q=j>>>0<o>>>0?o:j}else q=2147483647;j=(c[k>>2]|0)-m>>5;m=g+12|0;c[m>>2]=0;c[g+16>>2]=a+8;if(!q)r=0;else{c[f>>2]=1;c[e+0>>2]=c[f+0>>2];r=cOb(q<<5,8,e,0,3653512,80)|0}c[g>>2]=r;e=r+(j<<5)|0;j=g+8|0;c[j>>2]=e;f=g+4|0;c[f>>2]=e;o=r+(q<<5)|0;c[m>>2]=o;q=b;b=e;while(1){if(!b)s=0;else{LVb(b);s=b}r=s+32|0;c[j>>2]=r;q=q+-1|0;if(!q){t=r;break}else b=r}b=c[a>>2]|0;q=c[k>>2]|0;if((q|0)==(b|0)){u=e;v=b;w=t;x=b;y=o}else{o=q;q=e;while(1){e=o;o=o+-32|0;lVb(q+-32|0,o);_P(q+-20|0,e+-20|0);t=e+-8|0;e=c[t+4>>2]|0;s=q+-8|0;c[s>>2]=c[t>>2];c[s+4>>2]=e;e=(c[f>>2]|0)+-32|0;c[f>>2]=e;if((o|0)==(b|0)){z=e;break}else q=e}u=z;v=c[a>>2]|0;w=c[j>>2]|0;x=c[k>>2]|0;y=c[m>>2]|0}c[a>>2]=u;c[f>>2]=v;c[k>>2]=w;c[j>>2]=x;x=c[h>>2]|0;c[h>>2]=y;c[m>>2]=x;c[g>>2]=v;mVb(g);i=d;return}function iVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d;g=d+16|0;h=f+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[f>>2]=0;j=c[b>>2]|0;if(!(j&1)){k=qdd(b,792256,c[142270]|0,e,0)|0;if(k){if((k|0)>0){k=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[n>>2];c[k>>2]=o}else Bid(k,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{k=c[e>>2]|0;if(k)_n[k&4095](f,b)|0}sdd(b)}k=qdd(b,792272,c[142290]|0,e,0)|0;if(k){if((k|0)>0){k=b+12|0;o=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=o+n|0;c[k>>2]=m;if((n|0)>=0?(l=o+(n+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){n=m;m=c[n+4>>2]|0;o=h;c[o>>2]=c[n>>2];c[o+4>>2]=m;c[k>>2]=l}else Bid(k,h,8);if(c[b>>2]&512){k=XEi(c[h>>2]|0)|0;l=h+4|0;c[h>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=k}}else{k=c[e>>2]|0;if(k)_n[k&4095](h,b)|0}sdd(b)}c[a>>2]=iQb(c[f>>2]|0,0)|0;i=d;return}else{k=(j&8388608|0)!=0;j=qdd(b,792256,c[142270]|0,e,0)|0;if(j){if((j|0)>0){j=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;o=l+m|0;c[j>>2]=o;if((m|0)>=0?(n=l+(m+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[o>>2];c[j>>2]=n}else Bid(j,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](f,b)|0}sdd(b)}j=qdd(b,792272,c[142290]|0,e,0)|0;if(j){if((j|0)>0){j=b+12|0;n=c[b+16>>2]|0;o=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=n+o|0;c[j>>2]=m;if((o|0)>=0?(l=n+(o+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){o=m;m=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=m;c[j>>2]=l}else Bid(j,h,8);if(c[b>>2]&512){j=XEi(c[h>>2]|0)|0;l=h+4|0;c[h>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=j}}else{j=c[e>>2]|0;if(j)_n[j&4095](h,b)|0}sdd(b)}gQb(f,g);c[a>>2]=iQb(c[g>>2]|0,k)|0;i=d;return}}function jVb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=a[b>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[b+4>>2]|0;if(h>>>0>=d>>>0)if(g){a[b+d+1>>0]=0;a[b>>0]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d>>0]=0;c[b+4>>2]=d;i=e;return}j=d-h|0;if((h|0)==(d|0)){i=e;return}if(g){k=f;l=10}else{f=c[b>>2]|0;k=f&255;l=(f&-2)+-1|0}if(!(k&1))m=(k&255)>>>1;else m=c[b+4>>2]|0;if((l-m|0)>>>0<j>>>0){nVb(b,l,j-l+m|0,m,m,0,0);n=a[b>>0]|0}else n=k;if(!(n&1))o=b+1|0;else o=c[b+8>>2]|0;PEi(o+m|0,1,j|0)|0;n=m+j|0;if(!(a[b>>0]&1))a[b>>0]=n<<1;else c[b+4>>2]=n;a[o+n>>0]=0;i=e;return}function kVb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=qdd(b,e,c[142260]|0,g,0)|0;if(!h){i=f;return}do if((h|0)<=0){e=c[g>>2]|0;if(e)_n[e&4095](d,b)|0}else{e=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[e>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[b+20>>2]|0)>>>0:0){a[d>>0]=a[l>>0]|0;c[e>>2]=(c[e>>2]|0)+1;break}Bid(e,d,1)}while(0);sdd(b);i=f;return}function lVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=(c[g>>2]|0)-(c[b>>2]|0)|0;j=h>>2;if(!j){i=d;return}if(j>>>0>1073741823)vxi(a);k=xCi(h)|0;c[e>>2]=k;c[a>>2]=k;c[f>>2]=k+(j<<2);j=c[b>>2]|0;b=c[g>>2]|0;if((j|0)==(b|0)){i=d;return}else{l=j;m=k}do{c[m>>2]=c[l>>2];m=(c[e>>2]|0)+4|0;c[e>>2]=m;l=l+4|0}while((l|0)!=(b|0));i=d;return}function mVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+4>>2]|0;g=a+8|0;h=c[g>>2]|0;if((h|0)!=(f|0)){j=h;do{h=j+-32|0;c[g>>2]=h;k=c[j+-20>>2]|0;if(k){l=j+-16|0;m=c[l>>2]|0;if((m|0)!=(k|0))c[l>>2]=m+(~((m+-4-k|0)>>>2)<<2);ACi(k)}k=c[h>>2]|0;if(k){h=j+-28|0;m=c[h>>2]|0;if((m|0)!=(k|0))c[h>>2]=m+(~((m+-4-k|0)>>>2)<<2);ACi(k)}j=c[g>>2]|0}while((j|0)!=(f|0))}f=c[a>>2]|0;if(!f){i=b;return}c[e>>2]=1;c[d+0>>2]=c[e+0>>2];eOb(f,d);i=b;return}function nVb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+16|0;l=k+4|0;m=k;if((2147483631-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))n=b+1|0;else n=c[b+8>>2]|0;if(d>>>0<1073741799){o=e+d|0;e=d<<1;p=o>>>0<e>>>0?e:o;if(p>>>0<11)q=11;else q=p+16&-16}else q=2147483631;c[m>>2]=89;c[l+0>>2]=c[m+0>>2];p=cOb(q,16,l,0,3653512,80)|0;if(g)YEi(p|0,n|0,g|0)|0;o=f-h|0;if((o|0)!=(g|0))YEi(p+(j+g)|0,n+(h+g)|0,o-g|0)|0;if((d|0)==10){r=b+8|0;c[r>>2]=p;s=q|1;c[b>>2]=s;i=k;return}c[m>>2]=89;c[l+0>>2]=c[m+0>>2];eOb(n,l);r=b+8|0;c[r>>2]=p;s=q|1;c[b>>2]=s;i=k;return}function oVb(){return 1!=0|0}function pVb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+84|0;e=d+0|0;f=e+84|0;do{c[e>>2]=-1;e=e+4|0}while((e|0)<(f|0));c[d>>2]=FQb(607136)|0;c[a+88>>2]=FQb(597456)|0;c[a+92>>2]=FQb(557592)|0;c[a+96>>2]=FQb(674016)|0;c[a+100>>2]=FQb(622976)|0;c[a+104>>2]=FQb(587552)|0;c[a+108>>2]=FQb(560968)|0;c[a+112>>2]=FQb(600552)|0;c[a+116>>2]=FQb(577952)|0;c[a+120>>2]=FQb(668248)|0;c[a+124>>2]=FQb(601760)|0;c[a+128>>2]=FQb(2353536)|0;c[a+132>>2]=FQb(611656)|0;c[a+136>>2]=FQb(552952)|0;c[a+140>>2]=FQb(552968)|0;c[a+148>>2]=FQb(552992)|0;c[a+152>>2]=FQb(564464)|0;c[a+156>>2]=FQb(561280)|0;c[a+160>>2]=FQb(589696)|0;c[a+164>>2]=FQb(553008)|0;c[a+144>>2]=FQb(609176)|0;i=b;return}function qVb(a){a=a|0;return (c[553024+(a<<2)>>2]|0)!=0|0}function rVb(a){a=a|0;return c[553024+(a<<2)>>2]|0}function sVb(){var a=0;a=i;pVb(553024);i=a;return}function tVb(a){a=a|0;return c[553024+(a<<2)>>2]|0}function uVb(a,b){a=a|0;b=b|0;c[553024+(a<<2)>>2]=b;return}function vVb(){return 553024}function wVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=vVb()|0;h=a+8|0;j=a+12|0;k=a+4|0;if(b)l=0;else{b=0;do{m=c[g+(b<<2)>>2]|0;if((m|0)!=0?(n=(da(c[137788]|0,(c[m+8>>2]|0)>>>21)|0)+3|0,o=n>>5,(1<<n-(o<<5)&c[(c[137786]|0)+(o<<2)>>2]|0)!=0):0){o=c[m+4>>2]|0;m=(c[h>>2]|0)+1|0;c[h>>2]=m;n=c[j>>2]|0;p=n&2147483647;if(m>>>0>p>>>0){q=n<<1;r=(q|0)==0?1:q;do if(p>>>0<r>>>0)if((n|0)>-1){c[j>>2]=r;q=c[a>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(q,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];q=cOb(r<<2,4,e,0,3653512,352)|0;YEi(q|0,c[a>>2]|0,c[h>>2]<<2|0)|0;c[j>>2]=r;c[a>>2]=q;break}while(0);s=c[h>>2]|0}else s=m;c[(c[a>>2]|0)+(s+-1<<2)>>2]=o}b=b+1|0}while((b|0)!=21);i=d;return}do{b=c[g+(l<<2)>>2]|0;if(((b|0)!=0?(s=(da(c[137788]|0,(c[b+8>>2]|0)>>>21)|0)+3|0,r=s>>5,(1<<s-(r<<5)&c[(c[137786]|0)+(r<<2)>>2]|0)!=0):0)?mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0:0){r=c[b+4>>2]|0;b=(c[h>>2]|0)+1|0;c[h>>2]=b;s=c[j>>2]|0;n=s&2147483647;if(b>>>0>n>>>0){p=s<<1;q=(p|0)==0?1:p;do if(n>>>0<q>>>0)if((s|0)>-1){c[j>>2]=q;p=c[a>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(p,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];p=cOb(q<<2,4,e,0,3653512,352)|0;YEi(p|0,c[a>>2]|0,c[h>>2]<<2|0)|0;c[j>>2]=q;c[a>>2]=p;break}while(0);t=c[h>>2]|0}else t=b;c[(c[a>>2]|0)+(t+-1<<2)>>2]=r}l=l+1|0}while((l|0)!=21);i=d;return}function xVb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+32|0;b=a+24|0;d=a+16|0;e=a;c[e>>2]=0;f=e+8|0;c[f>>2]=0;g=e+12|0;c[g>>2]=0;h=e+4|0;c[h>>2]=60;wVb(e,0);j=c[e>>2]|0;k=c[f>>2]|0;if(k){f=j;do{c[d>>2]=c[f>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(b,l,d);m=c[b>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0))p=c[o+4>>2]|0;else p=0}else p=0;lQc(p,0);f=f+4|0}while((f|0)!=(j+(k<<2)|0))}if((c[g>>2]|0)<=-1){i=a;return}c[d>>2]=c[h>>2];c[b+0>>2]=c[d+0>>2];eOb(j,b);c[e>>2]=0;i=a;return}function yVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+8|0;h=g+4|0;c[h>>2]=0;j=g+8|0;c[j>>2]=0;c[g+12>>2]=0;CVb(b,g);g=vVb()|0;b=0;while(1){k=c[553192+(b<<2)>>2]|0;l=c[g+(k<<2)+84>>2]|0;m=c[h>>2]|0;n=c[j>>2]|0;o=n-m>>3;if(!o)p=m;else{q=m;m=o;while(1){o=(m|0)/2|0;if((c[q+(o<<3)>>2]|0)<(l|0)){r=q+(o+1<<3)|0;s=m+-1-o|0}else{r=q;s=o}if(!s){p=r;break}else{q=r;m=s}}}a:do if((p|0)!=(n|0)?(c[p>>2]|0)<=(l|0):0){m=c[p+4>>2]|0;do if(m){c[f>>2]=m;q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(e,q,f);o=c[e>>2]|0;t=c[q+28>>2]|0;if((o|0)==-1){u=t+(c[q+32>>2]<<3)|0;break}else{u=t+(o<<3)|0;break}}else u=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((u|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[u+4>>2]|0,(q|0)!=0):0)v=q;else w=18}else w=18;if((w|0)==18){w=0;q=hQb(m)|0;if(!q)break;else v=q}q=da(c[137788]|0,(c[v+8>>2]|0)>>>21)|0;o=q>>5;if(1<<q-(o<<5)&c[(c[137786]|0)+(o<<2)>>2]){x=v;break a}}while(0);x=0}else x=0;while(0);uVb(k,x);n=c[g+(k<<2)>>2]|0;if(!n){y=k;z=b;w=23;break}m=(da(c[137788]|0,(c[n+8>>2]|0)>>>21)|0)+l|0;n=m>>5;if(!(1<<m-(n<<5)&c[(c[137786]|0)+(n<<2)>>2])){y=k;z=b;w=23;break}b=b+1|0;if(b>>>0>=6){w=24;break}}if((w|0)==23){c[e>>2]=y;c[e+4>>2]=z;Lsd(a,553216,e)}else if((w|0)==24){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0}a=c[h>>2]|0;if(!a){i=d;return}h=c[j>>2]|0;if((h|0)!=(a|0))c[j>>2]=h+(~((h+-8-a|0)>>>3)<<3);ACi(a);i=d;return}function zVb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+64|0;f=e;g=e+52|0;h=e+48|0;j=e+32|0;k=e+20|0;l=e+8|0;m=j+4|0;c[m>>2]=0;n=j+8|0;c[n>>2]=0;c[j+12>>2]=0;rri(k,d,SEi(d|0)|0);CVb(k,j);xri(k);k=0;do{j=c[(vVb()|0)+(k<<2)+84>>2]|0;a:do if((j|0)==-1)o=0;else{d=c[m>>2]|0;p=c[n>>2]|0;q=p-d>>3;if(!q)r=d;else{s=d;d=q;while(1){q=(d|0)/2|0;if((c[s+(q<<3)>>2]|0)<(j|0)){t=s+(q+1<<3)|0;u=d+-1-q|0}else{t=s;u=q}if(!u){r=t;break}else{s=t;d=u}}}do if(((r|0)!=(p|0)?(c[r>>2]|0)<=(j|0):0)?(d=c[r+4>>2]|0,(d|0)!=0):0){c[h>>2]=d;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(f,s,h);q=c[f>>2]|0;v=c[s+28>>2]|0;if((q|0)==-1){w=v+(c[s+32>>2]<<3)|0;break}else{w=v+(q<<3)|0;break}}else w=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((w|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[w+4>>2]|0,(s|0)!=0):0)x=s;else y=18}else y=18;if((y|0)==18){y=0;s=hQb(d)|0;if(!s)break;else x=s}s=da(c[137788]|0,(c[x+8>>2]|0)>>>21)|0;q=s>>5;v=(1<<s-(q<<5)&c[(c[137786]|0)+(q<<2)>>2]|0)!=0;if(v){o=v?x:0;break a}}while(0);c[g>>2]=c[153106];c[f+0>>2]=c[g+0>>2];p=yQb(j,0,f,0)|0;ko[c[(c[p>>2]|0)+24>>2]&4095](p);In[c[(c[p>>2]|0)+12>>2]&4095](p,0);v=EQb(j)|0;if(!(a[v>>0]&1))z=v+1|0;else z=c[v+8>>2]|0;In[c[(c[p>>2]|0)+36>>2]&4095](p,z);c[f>>2]=j;Ird(553272,f);o=p}while(0);uVb(k,o);k=k+1|0}while((k|0)<16);AVb(l);k=a[l>>0]|0;o=(k&1)==0;if(o)A=(k&255)>>>1;else A=c[l+4>>2]|0;if(!A){jfd(kfd()|0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0}else{if(o)B=l+1|0;else B=c[l+8>>2]|0;c[f>>2]=B;Lsd(b,553320,f)}xri(l);l=c[m>>2]|0;if(!l){i=e;return}m=c[n>>2]|0;if((m|0)!=(l|0))c[n>>2]=m+(~((m+-8-l|0)>>>3)<<3);ACi(l);i=e;return}function AVb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;j=vVb()|0;c[e>>2]=0;k=e+4|0;c[k>>2]=0;c[e+8>>2]=0;CQb(9,e,0)|0;l=f+4|0;m=f+8|0;n=h+1|0;o=h+8|0;p=h+4|0;q=g+1|0;r=g+8|0;s=g+4|0;t=0;do{u=j+(t<<2)+84|0;v=c[u>>2]|0;if((v|0)!=-1){c[f>>2]=0;c[l>>2]=0;c[m>>2]=0;w=c[e>>2]|0;if((c[k>>2]|0)==(w|0)){x=0;y=0}else{z=w;w=v;v=0;while(1){A=z+(v<<2)|0;B=c[A>>2]|0;C=(da(c[137788]|0,(c[B+8>>2]|0)>>>21)|0)+w|0;D=C>>5;do if(1<<C-(D<<5)&c[(c[137786]|0)+(D<<2)>>2]){E=c[l>>2]|0;if((E|0)==(c[m>>2]|0)){DVb(f,A);break}if(!E)F=0;else{c[E>>2]=B;F=c[l>>2]|0}c[l>>2]=F+4}while(0);B=v+1|0;A=c[e>>2]|0;if(B>>>0>=(c[k>>2]|0)-A>>2>>>0)break;z=A;w=c[u>>2]|0;v=B}x=c[f>>2]|0;y=c[l>>2]|0}v=y-x>>2;if(!v){uVb(t,0);if((t|0)<16){_ri(g,553352,EQb(c[u>>2]|0)|0);w=a[g>>0]|0;if(!(w&1)){G=q;H=(w&255)>>>1}else{G=c[r>>2]|0;H=c[s>>2]|0}Gri(b,G,H)|0;xri(g)}}else if((v|0)!=1){uVb(t,0);if((t|0)<16){_ri(h,553368,EQb(c[u>>2]|0)|0);v=a[h>>0]|0;if(!(v&1)){I=n;J=(v&255)>>>1}else{I=c[o>>2]|0;J=c[p>>2]|0}Gri(b,I,J)|0;xri(h)}}else uVb(t,c[x>>2]|0);v=c[f>>2]|0;if(v){w=c[l>>2]|0;if((w|0)!=(v|0))c[l>>2]=w+(~((w+-4-v|0)>>>2)<<2);ACi(v)}}else uVb(t,0);t=t+1|0}while((t|0)<21);t=c[e>>2]|0;if(!t){i=d;return}e=c[k>>2]|0;if((e|0)!=(t|0))c[k>>2]=e+(~((e+-4-t|0)>>>2)<<2);ACi(t);i=d;return}function BVb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+24|0;h=d+12|0;j=d;led(b,0,3);med(b,0);b=g+4|0;c[b>>2]=0;k=g+8|0;c[k>>2]=0;l=g+4|0;c[g>>2]=l;c[h>>2]=0;m=h+4|0;c[m>>2]=0;c[h+8>>2]=0;CQb(9,h,0)|0;n=c[h>>2]|0;if((c[m>>2]|0)!=(n|0)){o=n;n=0;while(1){p=(c[(c[o+(n<<2)>>2]|0)+8>>2]|0)>>>21;q=c[b>>2]|0;do if(q){r=q;while(1){s=c[r+16>>2]|0;if((p|0)<(s|0)){t=c[r>>2]|0;if(!t){u=r;v=r;w=6;break}else{r=t;continue}}if((s|0)>=(p|0)){x=r;w=10;break}s=r+4|0;t=c[s>>2]|0;if(!t){y=s;z=r;w=9;break}else r=t}if((w|0)==6){w=0;c[e>>2]=v;A=u;B=v;break}else if((w|0)==9){w=0;c[e>>2]=z;A=y;B=z;break}else if((w|0)==10){w=0;c[e>>2]=x;A=e;B=x;break}}else{c[e>>2]=l;A=l;B=l}while(0);q=c[A>>2]|0;if(!q){r=xCi(32)|0;c[r+16>>2]=p;t=r+24|0;c[t>>2]=0;c[r+28>>2]=0;c[r+20>>2]=t;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=B;c[A>>2]=r;t=c[c[g>>2]>>2]|0;if(!t)C=r;else{c[g>>2]=t;C=c[A>>2]|0}GN(c[b>>2]|0,C);c[k>>2]=(c[k>>2]|0)+1;D=c[h>>2]|0;E=r}else{D=o;E=q}q=D+(n<<2)|0;r=E+24|0;t=c[r>>2]|0;do if(t){s=c[q>>2]|0;F=t;while(1){G=c[F+16>>2]|0;if(s>>>0<G>>>0){H=c[F>>2]|0;if(!H){I=F;J=F;w=20;break}else{F=H;continue}}if(G>>>0>=s>>>0){K=F;w=24;break}G=F+4|0;H=c[G>>2]|0;if(!H){L=G;M=F;w=23;break}else F=H}if((w|0)==20){w=0;c[e>>2]=J;N=I;O=J;break}else if((w|0)==23){w=0;c[e>>2]=M;N=L;O=M;break}else if((w|0)==24){w=0;c[e>>2]=K;N=e;O=K;break}}else{F=E+24|0;c[e>>2]=F;N=F;O=F}while(0);if(!(c[N>>2]|0)){t=xCi(20)|0;c[t+16>>2]=c[q>>2];c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=O;c[N>>2]=t;p=E+20|0;F=c[c[p>>2]>>2]|0;if(!F)P=t;else{c[p>>2]=F;P=c[N>>2]|0}GN(c[r>>2]|0,P);F=E+28|0;c[F>>2]=(c[F>>2]|0)+1;Q=c[h>>2]|0}else Q=D;n=n+1|0;if(n>>>0>=(c[m>>2]|0)-Q>>2>>>0)break;else o=Q}}Q=vVb()|0;o=j+1|0;n=j+8|0;D=0;do{E=Q+(D<<2)+84|0;P=c[E>>2]|0;do if((P|0)==-1)uVb(D,0);else{N=c[b>>2]|0;do if(N){O=N;while(1){K=c[O+16>>2]|0;if((P|0)<(K|0)){M=c[O>>2]|0;if(!M){R=O;S=O;w=37;break}else{O=M;continue}}if((K|0)>=(P|0)){T=O;w=41;break}K=O+4|0;M=c[K>>2]|0;if(!M){U=K;V=O;w=40;break}else O=M}if((w|0)==37){w=0;c[e>>2]=S;W=R;X=S;break}else if((w|0)==40){w=0;c[e>>2]=V;W=U;X=V;break}else if((w|0)==41){w=0;c[e>>2]=T;W=e;X=T;break}}else{c[e>>2]=l;W=l;X=l}while(0);N=c[W>>2]|0;if(!N){O=xCi(32)|0;c[O+16>>2]=c[E>>2];M=O+24|0;c[M>>2]=0;c[O+28>>2]=0;c[O+20>>2]=M;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=X;c[W>>2]=O;M=c[c[g>>2]>>2]|0;if(!M)Y=O;else{c[g>>2]=M;Y=c[W>>2]|0}GN(c[b>>2]|0,Y);c[k>>2]=(c[k>>2]|0)+1;Z=O}else Z=N;N=Z+20|0;O=c[Z+28>>2]|0;if((O|0)==1){uVb(D,c[(c[N>>2]|0)+16>>2]|0);break}M=c[E>>2]|0;if(O){_ri(j,553392,EQb(M)|0);Krd((a[j>>0]&1)==0?o:c[n>>2]|0,0,3653512,276,1,0,0,0);xri(j);uVb(D,c[(c[N>>2]|0)+16>>2]|0);break}c[f>>2]=c[153106];c[e+0>>2]=c[f+0>>2];N=yQb(M,0,e,0)|0;ko[c[(c[N>>2]|0)+24>>2]&4095](N);In[c[(c[N>>2]|0)+12>>2]&4095](N,0);O=EQb(M)|0;if(!(a[O>>0]&1))_=O+1|0;else _=c[O+8>>2]|0;In[c[(c[N>>2]|0)+36>>2]&4095](N,_);uVb(D,N)}while(0);D=D+1|0}while((D|0)<21);D=c[h>>2]|0;if(!D){$=c[b>>2]|0;EVb(g,$);i=d;return}h=c[m>>2]|0;if((h|0)!=(D|0))c[m>>2]=h+(~((h+-4-D|0)>>>2)<<2);ACi(D);$=c[b>>2]|0;EVb(g,$);i=d;return}function CVb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+64|0;f=e+8|0;g=e;h=e+48|0;j=e+32|0;k=e+16|0;hfd(kfd()|0);l=c[153134]|0;c[j>>2]=0;m=j+4|0;c[m>>2]=l;n=j+8|0;c[n>>2]=0;o=j+12|0;c[o>>2]=0;c[k>>2]=0;p=k+4|0;c[p>>2]=l;c[k+8>>2]=0;l=k+12|0;c[l>>2]=0;Ned(kfd()|0,b,j,k);if(!(c[n>>2]|0))q=d+8|0;else{r=g+4|0;s=d+8|0;t=d+12|0;u=d+4|0;v=0;do{w=(c[j>>2]|0)+(v<<3)|0;x=c[w>>2]|0;y=c[w+4>>2]|0;w=c[(c[k>>2]|0)+(v<<2)>>2]|0;z=(da(c[137788]|0,w)|0)+6|0;A=z>>5;do if(1<<z-(A<<5)&c[(c[137786]|0)+(A<<2)>>2]){B=Ked(kfd()|0,b,x,y)|0;c[g>>2]=w;c[r>>2]=B;B=c[s>>2]|0;if((B|0)==(c[t>>2]|0)){FVb(u,g);break}if(!B)C=0;else{D=g;E=c[D+4>>2]|0;F=B;c[F>>2]=c[D>>2];c[F+4>>2]=E;C=c[s>>2]|0}c[s>>2]=C+8}while(0);v=v+1|0}while(v>>>0<(c[n>>2]|0)>>>0);q=s}s=c[d+4>>2]|0;n=c[q>>2]|0;a[f>>0]=a[d>>0]|0;GVb(s,n,f);ifd(kfd()|0);if((c[l>>2]|0)>-1){l=c[k>>2]|0;c[h>>2]=c[p>>2];c[f+0>>2]=c[h+0>>2];eOb(l,f);c[k>>2]=0}if((c[o>>2]|0)<=-1){i=e;return}o=c[j>>2]|0;c[h>>2]=c[m>>2];c[f+0>>2]=c[h+0>>2];eOb(o,f);c[j>>2]=0;i=e;return}function DVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function EVb(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{EVb(a,c[b>>2]|0);EVb(a,c[b+4>>2]|0);HVb(b+20|0,c[b+24>>2]|0);ACi(b);i=d;return}}function FVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>3)+1|0;if(g>>>0>536870911)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>3>>>0<268435455){l=k>>2;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>3;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=536870911;r=l>>3;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<3)|0;o=r;p=s}s=n+(o<<3)|0;if(s){r=b;b=c[r+4>>2]|0;q=s;c[q>>2]=c[r>>2];c[q+4>>2]=b}YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<3);c[h>>2]=n+(m<<3);if(!f){i=d;return}ACi(f);i=d;return}function GVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-8|0;h=a+-4|0;j=f;b:while(1){k=j;l=b-k|0;m=l>>3;switch(m|0){case 2:{n=j;o=a;p=h;q=4;break a;break}case 4:{r=j;s=g;q=14;break a;break}case 3:{t=j;u=a;v=h;q=6;break a;break}case 5:{w=j;x=a;y=h;q=15;break a;break}case 1:case 0:{q=70;break a;break}default:{}}if((l|0)<56){z=j;A=a;q=21;break a}B=(m|0)/2|0;C=j+(B<<3)|0;do if((l|0)>7992){D=(m|0)/4|0;E=j+(D<<3)|0;F=D+B|0;G=j+(F<<3)|0;H=IVb(j,E,C,G,d)|0;I=c[g>>2]|0;J=c[G>>2]|0;if((I|0)>=(J|0)){K=C;L=H;break}c[G>>2]=I;c[g>>2]=J;J=j+(F<<3)+4|0;F=c[J>>2]|0;c[J>>2]=c[h>>2];c[h>>2]=F;F=H+1|0;I=c[G>>2]|0;M=c[C>>2]|0;if((I|0)<(M|0)){c[C>>2]=I;c[G>>2]=M;M=j+(B<<3)+4|0;G=c[M>>2]|0;c[M>>2]=c[J>>2];c[J>>2]=G;G=H+2|0;J=c[C>>2]|0;I=c[E>>2]|0;if((J|0)<(I|0)){c[E>>2]=J;c[C>>2]=I;I=j+(D<<3)+4|0;D=c[I>>2]|0;c[I>>2]=c[M>>2];c[M>>2]=D;D=c[E>>2]|0;M=c[j>>2]|0;if((D|0)<(M|0)){c[j>>2]=D;c[E>>2]=M;M=j+4|0;E=c[M>>2]|0;c[M>>2]=c[I>>2];c[I>>2]=E;K=C;L=H+4|0}else{K=C;L=H+3|0}}else{K=C;L=G}}else{K=C;L=F}}else{F=c[C>>2]|0;G=c[j>>2]|0;H=c[g>>2]|0;E=(H|0)<(F|0);if((F|0)>=(G|0)){if(!E){K=C;L=0;break}c[C>>2]=H;c[g>>2]=F;I=j+(B<<3)+4|0;M=c[I>>2]|0;c[I>>2]=c[h>>2];c[h>>2]=M;M=c[C>>2]|0;D=c[j>>2]|0;if((M|0)>=(D|0)){K=C;L=1;break}c[j>>2]=M;c[C>>2]=D;D=j+4|0;M=c[D>>2]|0;c[D>>2]=c[I>>2];c[I>>2]=M;K=C;L=2;break}if(E){c[j>>2]=H;c[g>>2]=G;H=j+4|0;E=c[H>>2]|0;c[H>>2]=c[h>>2];c[h>>2]=E;K=C;L=1;break}c[j>>2]=F;c[C>>2]=G;F=j+4|0;E=j+(B<<3)+4|0;H=c[F>>2]|0;c[F>>2]=c[E>>2];c[E>>2]=H;H=c[g>>2]|0;if((H|0)<(G|0)){c[C>>2]=H;c[g>>2]=G;G=c[E>>2]|0;c[E>>2]=c[h>>2];c[h>>2]=G;K=C;L=2}else{K=C;L=1}}while(0);B=c[j>>2]|0;m=c[K>>2]|0;do if((B|0)<(m|0)){N=g;O=L}else{l=a;G=g;while(1){E=l+-16|0;if((j|0)==(E|0))break;H=c[E>>2]|0;if((H|0)<(m|0)){P=E;Q=l;R=E;S=H;q=52;break}else{H=G;G=E;l=H}}if((q|0)==52){q=0;c[j>>2]=S;c[P>>2]=B;l=j+4|0;G=Q+-12|0;H=c[l>>2]|0;c[l>>2]=c[G>>2];c[G>>2]=H;N=R;O=L+1|0;break}H=j+8|0;G=c[g>>2]|0;if((B|0)<(G|0))T=H;else{if((H|0)==(g|0)){q=70;break a}else{U=j;V=H}while(1){H=c[V>>2]|0;l=U+16|0;if((B|0)<(H|0)){W=V;X=H;Y=V;break}if((l|0)==(g|0)){q=70;break a}else{H=V;V=l;U=H}}c[W>>2]=G;c[g>>2]=X;H=Y+4|0;l=c[H>>2]|0;c[H>>2]=c[h>>2];c[h>>2]=l;T=Y+8|0}if((T|0)==(g|0)){q=70;break a}else{Z=T;_=g}while(1){l=c[j>>2]|0;H=Z;while(1){E=c[H>>2]|0;F=H+8|0;if((l|0)<(E|0)){$=F;aa=H;ba=E;ca=H;break}else H=F}H=_;while(1){F=H+-8|0;E=c[F>>2]|0;if((l|0)<(E|0))H=F;else{da=F;ea=F;fa=E;ga=H;break}}if(ca>>>0>=da>>>0){j=ca;continue b}c[aa>>2]=fa;c[ea>>2]=ba;H=ca+4|0;l=ga+-4|0;E=c[H>>2]|0;c[H>>2]=c[l>>2];c[l>>2]=E;Z=$;_=da}}while(0);B=j+8|0;c:do if(B>>>0<N>>>0){m=B;G=N;E=C;l=O;while(1){H=c[E>>2]|0;F=m;while(1){M=c[F>>2]|0;I=F+8|0;if((M|0)<(H|0))F=I;else{ha=F;ia=M;ja=I;ka=F;break}}F=G;while(1){I=F+-8|0;M=c[I>>2]|0;if((M|0)<(H|0)){la=I;ma=I;na=M;oa=F;break}else F=I}if(ka>>>0>la>>>0){pa=ka;qa=E;ra=l;break c}c[ha>>2]=na;c[ma>>2]=ia;F=ka+4|0;H=oa+-4|0;I=c[F>>2]|0;c[F>>2]=c[H>>2];c[H>>2]=I;m=ja;G=la;E=(E|0)==(ka|0)?la:E;l=l+1|0}}else{pa=B;qa=C;ra=O}while(0);if((pa|0)!=(qa|0)?(C=c[qa>>2]|0,B=c[pa>>2]|0,(C|0)<(B|0)):0){c[pa>>2]=C;c[qa>>2]=B;B=pa+4|0;C=qa+4|0;l=c[B>>2]|0;c[B>>2]=c[C>>2];c[C>>2]=l;sa=ra+1|0}else sa=ra;if(!sa){ta=KVb(j,pa,d)|0;l=pa+8|0;if(KVb(l,a,d)|0){q=65;break}if(ta){j=l;continue}}l=pa;if((l-k|0)>=(b-l|0)){ua=j;va=pa;q=69;break}GVb(j,pa,d);j=pa+8|0}if((q|0)==65){q=0;if(ta){q=70;break}else{f=j;a=pa;continue}}else if((q|0)==69){q=0;GVb(va+8|0,a,d);f=ua;a=va;continue}}if((q|0)==4){va=o+-8|0;o=c[va>>2]|0;a=c[n>>2]|0;if((o|0)>=(a|0)){i=e;return}c[n>>2]=o;c[va>>2]=a;a=n+4|0;n=c[a>>2]|0;c[a>>2]=c[p>>2];c[p>>2]=n;i=e;return}else if((q|0)==6){n=t+8|0;p=c[n>>2]|0;a=c[t>>2]|0;va=u+-8|0;u=c[va>>2]|0;o=(u|0)<(p|0);if((p|0)>=(a|0)){if(!o){i=e;return}c[n>>2]=u;c[va>>2]=p;ua=t+12|0;f=c[ua>>2]|0;c[ua>>2]=c[v>>2];c[v>>2]=f;f=c[n>>2]|0;pa=c[t>>2]|0;if((f|0)>=(pa|0)){i=e;return}c[t>>2]=f;c[n>>2]=pa;pa=t+4|0;f=c[pa>>2]|0;c[pa>>2]=c[ua>>2];c[ua>>2]=f;i=e;return}if(o){c[t>>2]=u;c[va>>2]=a;u=t+4|0;o=c[u>>2]|0;c[u>>2]=c[v>>2];c[v>>2]=o;i=e;return}c[t>>2]=p;c[n>>2]=a;p=t+4|0;o=t+12|0;t=c[p>>2]|0;c[p>>2]=c[o>>2];c[o>>2]=t;t=c[va>>2]|0;if((t|0)>=(a|0)){i=e;return}c[n>>2]=t;c[va>>2]=a;a=c[o>>2]|0;c[o>>2]=c[v>>2];c[v>>2]=a;i=e;return}else if((q|0)==14){IVb(r,r+8|0,r+16|0,s,d)|0;i=e;return}else if((q|0)==15){s=w+8|0;r=w+16|0;a=w+24|0;IVb(w,s,r,a,d)|0;v=x+-8|0;x=c[v>>2]|0;o=c[a>>2]|0;if((x|0)>=(o|0)){i=e;return}c[a>>2]=x;c[v>>2]=o;o=w+28|0;v=c[o>>2]|0;c[o>>2]=c[y>>2];c[y>>2]=v;v=c[a>>2]|0;y=c[r>>2]|0;if((v|0)>=(y|0)){i=e;return}c[r>>2]=v;c[a>>2]=y;y=w+20|0;a=c[y>>2]|0;x=c[o>>2]|0;c[y>>2]=x;c[o>>2]=a;a=c[s>>2]|0;if((v|0)>=(a|0)){i=e;return}c[s>>2]=v;c[r>>2]=a;a=w+12|0;r=c[a>>2]|0;c[a>>2]=x;c[y>>2]=r;r=c[w>>2]|0;if((v|0)>=(r|0)){i=e;return}c[w>>2]=v;c[s>>2]=r;r=w+4|0;w=c[r>>2]|0;c[r>>2]=x;c[a>>2]=w;i=e;return}else if((q|0)==21){JVb(z,A,d);i=e;return}else if((q|0)==70){i=e;return}}function HVb(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{HVb(a,c[b>>2]|0);HVb(a,c[b+4>>2]|0);ACi(b);i=d;return}}function IVb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=c[b>>2]|0;h=c[a>>2]|0;j=c[d>>2]|0;k=(j|0)<(g|0);do if((g|0)<(h|0)){if(k){c[a>>2]=j;c[d>>2]=h;l=a+4|0;m=d+4|0;n=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=n;o=1;break}c[a>>2]=g;c[b>>2]=h;n=a+4|0;m=b+4|0;l=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=l;l=c[d>>2]|0;n=c[b>>2]|0;if((l|0)<(n|0)){c[b>>2]=l;c[d>>2]=n;n=d+4|0;l=c[m>>2]|0;c[m>>2]=c[n>>2];c[n>>2]=l;o=2}else o=1}else if(k){c[b>>2]=j;c[d>>2]=g;l=b+4|0;n=d+4|0;m=c[l>>2]|0;c[l>>2]=c[n>>2];c[n>>2]=m;m=c[b>>2]|0;n=c[a>>2]|0;if((m|0)<(n|0)){c[a>>2]=m;c[b>>2]=n;n=a+4|0;m=c[n>>2]|0;c[n>>2]=c[l>>2];c[l>>2]=m;o=2}else o=1}else o=0;while(0);g=c[e>>2]|0;j=c[d>>2]|0;if((g|0)>=(j|0)){p=o;i=f;return p|0}c[d>>2]=g;c[e>>2]=j;j=d+4|0;g=e+4|0;e=c[j>>2]|0;c[j>>2]=c[g>>2];c[g>>2]=e;e=c[d>>2]|0;g=c[b>>2]|0;if((e|0)>=(g|0)){p=o+1|0;i=f;return p|0}c[b>>2]=e;c[d>>2]=g;g=b+4|0;d=c[g>>2]|0;c[g>>2]=c[j>>2];c[j>>2]=d;d=c[b>>2]|0;j=c[a>>2]|0;if((d|0)>=(j|0)){p=o+2|0;i=f;return p|0}c[a>>2]=d;c[b>>2]=j;j=a+4|0;a=c[j>>2]|0;c[j>>2]=c[g>>2];c[g>>2]=a;p=o+3|0;i=f;return p|0}function JVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+16|0;f=a+8|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[e>>2]|0;k=(j|0)<(g|0);do if((g|0)<(h|0)){if(k){c[a>>2]=j;c[e>>2]=h;l=a+4|0;m=a+20|0;n=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=n;o=h;break}c[a>>2]=g;c[f>>2]=h;n=a+4|0;m=a+12|0;l=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=l;if((j|0)<(h|0)){c[f>>2]=j;c[e>>2]=h;n=a+20|0;c[m>>2]=c[n>>2];c[n>>2]=l;o=h}else o=j}else if(k){c[f>>2]=j;c[e>>2]=g;l=a+12|0;n=a+20|0;m=c[l>>2]|0;p=c[n>>2]|0;c[l>>2]=p;c[n>>2]=m;if((j|0)<(h|0)){c[a>>2]=j;c[f>>2]=h;m=a+4|0;n=c[m>>2]|0;c[m>>2]=p;c[l>>2]=n;o=g}else o=g}else o=j;while(0);j=a+24|0;if((j|0)==(b|0)){i=d;return}else{q=o;r=j;s=e}while(1){if((c[r>>2]|0)<(q|0)){e=r;j=c[e>>2]|0;o=c[e+4>>2]|0;e=q;g=r;h=s;while(1){c[g>>2]=e;f=h+4|0;c[g+4>>2]=c[f>>2];if((h|0)==(a|0)){t=h;u=f;break}k=h+-8|0;e=c[k>>2]|0;if((j|0)>=(e|0)){t=h;u=f;break}else{f=h;h=k;g=f}}c[t>>2]=j;c[u>>2]=o}g=r+8|0;if((g|0)==(b|0))break;h=r;q=c[r>>2]|0;r=g;s=h}i=d;return}function KVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;switch(b-a>>3|0){case 4:{IVb(a,a+8|0,a+16|0,b+-8|0,d)|0;f=1;i=e;return f|0}case 3:{g=a+8|0;h=c[g>>2]|0;j=c[a>>2]|0;k=b+-8|0;l=c[k>>2]|0;m=(l|0)<(h|0);if((h|0)>=(j|0)){if(!m){f=1;i=e;return f|0}c[g>>2]=l;c[k>>2]=h;n=a+12|0;o=b+-4|0;p=c[n>>2]|0;c[n>>2]=c[o>>2];c[o>>2]=p;p=c[g>>2]|0;o=c[a>>2]|0;if((p|0)>=(o|0)){f=1;i=e;return f|0}c[a>>2]=p;c[g>>2]=o;o=a+4|0;p=c[o>>2]|0;c[o>>2]=c[n>>2];c[n>>2]=p;f=1;i=e;return f|0}if(m){c[a>>2]=l;c[k>>2]=j;l=a+4|0;m=b+-4|0;p=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=p;f=1;i=e;return f|0}c[a>>2]=h;c[g>>2]=j;h=a+4|0;p=a+12|0;m=c[h>>2]|0;c[h>>2]=c[p>>2];c[p>>2]=m;m=c[k>>2]|0;if((m|0)>=(j|0)){f=1;i=e;return f|0}c[g>>2]=m;c[k>>2]=j;j=b+-4|0;k=c[p>>2]|0;c[p>>2]=c[j>>2];c[j>>2]=k;f=1;i=e;return f|0}case 2:{k=b+-8|0;j=c[k>>2]|0;p=c[a>>2]|0;if((j|0)>=(p|0)){f=1;i=e;return f|0}c[a>>2]=j;c[k>>2]=p;p=a+4|0;k=b+-4|0;j=c[p>>2]|0;c[p>>2]=c[k>>2];c[k>>2]=j;f=1;i=e;return f|0}case 5:{j=a+8|0;k=a+16|0;p=a+24|0;IVb(a,j,k,p,d)|0;d=b+-8|0;m=c[d>>2]|0;g=c[p>>2]|0;if((m|0)>=(g|0)){f=1;i=e;return f|0}c[p>>2]=m;c[d>>2]=g;g=a+28|0;d=b+-4|0;m=c[g>>2]|0;c[g>>2]=c[d>>2];c[d>>2]=m;m=c[p>>2]|0;d=c[k>>2]|0;if((m|0)>=(d|0)){f=1;i=e;return f|0}c[k>>2]=m;c[p>>2]=d;d=a+20|0;p=c[d>>2]|0;h=c[g>>2]|0;c[d>>2]=h;c[g>>2]=p;p=c[j>>2]|0;if((m|0)>=(p|0)){f=1;i=e;return f|0}c[j>>2]=m;c[k>>2]=p;p=a+12|0;k=c[p>>2]|0;c[p>>2]=h;c[d>>2]=k;k=c[a>>2]|0;if((m|0)>=(k|0)){f=1;i=e;return f|0}c[a>>2]=m;c[j>>2]=k;k=a+4|0;j=c[k>>2]|0;c[k>>2]=h;c[p>>2]=j;f=1;i=e;return f|0}case 1:case 0:{f=1;i=e;return f|0}default:{j=a+16|0;p=a+8|0;h=c[p>>2]|0;k=c[a>>2]|0;m=c[j>>2]|0;d=(m|0)<(h|0);do if((h|0)<(k|0)){if(d){c[a>>2]=m;c[j>>2]=k;g=a+4|0;l=a+20|0;n=c[g>>2]|0;c[g>>2]=c[l>>2];c[l>>2]=n;q=k;break}c[a>>2]=h;c[p>>2]=k;n=a+4|0;l=a+12|0;g=c[n>>2]|0;c[n>>2]=c[l>>2];c[l>>2]=g;if((m|0)<(k|0)){c[p>>2]=m;c[j>>2]=k;n=a+20|0;c[l>>2]=c[n>>2];c[n>>2]=g;q=k}else q=m}else if(d){c[p>>2]=m;c[j>>2]=h;g=a+12|0;n=a+20|0;l=c[g>>2]|0;o=c[n>>2]|0;c[g>>2]=o;c[n>>2]=l;if((m|0)<(k|0)){c[a>>2]=m;c[p>>2]=k;l=a+4|0;n=c[l>>2]|0;c[l>>2]=o;c[g>>2]=n;q=h}else q=h}else q=m;while(0);m=a+24|0;if((m|0)==(b|0)){f=1;i=e;return f|0}else{r=q;s=0;t=m;u=j}while(1){if((c[t>>2]|0)<(r|0)){j=t;m=c[j>>2]|0;q=c[j+4>>2]|0;j=r;h=t;k=u;while(1){c[h>>2]=j;p=k+4|0;c[h+4>>2]=c[p>>2];if((k|0)==(a|0)){v=k;w=p;break}d=k+-8|0;j=c[d>>2]|0;if((m|0)>=(j|0)){v=k;w=p;break}else{p=k;k=d;h=p}}c[v>>2]=m;c[w>>2]=q;h=s+1|0;if((h|0)==8){x=t;break}else y=h}else y=s;h=t+8|0;if((h|0)==(b|0)){f=1;z=35;break}k=t;r=c[t>>2]|0;s=y;t=h;u=k}if((z|0)==35){i=e;return f|0}f=(x+8|0)==(b|0);i=e;return f|0}}return 0}function LVb(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;return}function MVb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[a+24>>2]|0;h=c[a>>2]|0;if(((c[a+4>>2]|0)-h>>2|0)>(d|0)){a=c[h+(d<<2)>>2]|0;j=(a|0)==0?g:a}else j=g;co[j&2047](b,d,e);i=f;return}function NVb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f+4|0;h=f;j=a+4|0;k=c[j>>2]|0;l=c[a>>2]|0;m=k-l>>2;do if((m|0)<=(b|0)){n=b+1|0;c[g>>2]=0;if(n>>>0<=m>>>0){if(n>>>0<m>>>0?(o=l+(n<<2)|0,(k|0)!=(o|0)):0)c[j>>2]=k+(~((k+-4-o|0)>>>2)<<2)}else WVb(a,n-m|0,g);o=a+12|0;c[h>>2]=0;p=a+16|0;q=c[p>>2]|0;r=c[o>>2]|0;s=q-r>>2;if(n>>>0>s>>>0){XVb(o,n-s|0,h);break}if(n>>>0<s>>>0?(s=r+(n<<2)|0,(q|0)!=(s|0)):0)c[p>>2]=q+(~((q+-4-s|0)>>>2)<<2)}while(0);c[(c[a>>2]|0)+(b<<2)>>2]=d;c[(c[a+12>>2]|0)+(b<<2)>>2]=e;i=f;return}function OVb(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+28>>2]=d;return}function PVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=(c[g>>2]|0)-(c[a>>2]|0)>>2;j=b+4|0;k=(c[j>>2]|0)-(c[b>>2]|0)>>2;l=h>>>0<k>>>0;m=l?k:h;c[e>>2]=0;if(l)WVb(a,m-h|0,e);e=a+12|0;c[f>>2]=0;h=a+16|0;l=c[h>>2]|0;k=c[e>>2]|0;n=l-k>>2;if(m>>>0<=n>>>0){if(m>>>0<n>>>0?(o=k+(m<<2)|0,(l|0)!=(o|0)):0)c[h>>2]=l+(~((l+-4-o|0)>>>2)<<2)}else XVb(e,m-n|0,f);f=c[g>>2]|0;n=c[a>>2]|0;if((f|0)!=(n|0)){m=b+12|0;o=n;n=f;f=0;while(1){l=o+(f<<2)|0;if((c[l>>2]|0)==0?(h=c[b>>2]|0,f>>>0<(c[j>>2]|0)-h>>2>>>0):0){c[l>>2]=c[h+(f<<2)>>2];c[(c[e>>2]|0)+(f<<2)>>2]=c[(c[m>>2]|0)+(f<<2)>>2];p=c[g>>2]|0;q=c[a>>2]|0}else{p=n;q=o}f=f+1|0;if(f>>>0>=p-q>>2>>>0)break;else{o=q;n=p}}}p=a+24|0;if(c[p>>2]|0){i=d;return}c[p>>2]=c[b+24>>2];i=d;return}function QVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+48|0;d=b+24|0;e=b+12|0;f=b;g=gWb()|0;hWb(d,0);h=a+36|0;j=c[h>>2]|0;k=a+40|0;l=c[k>>2]|0;if((l|0)!=(j|0))c[k>>2]=l+(~(((l+-20-j|0)>>>0)/20|0)*20|0);j=a+48|0;PUb(j,c[a+52>>2]|0);c[a+56>>2]=0;l=a+52|0;c[j>>2]=l;c[l>>2]=0;l=c[d+8>>2]|0;a=c[k>>2]|0;m=c[h>>2]|0;n=(a-m|0)/20|0;if(l>>>0<=n>>>0){if(l>>>0<n>>>0?(o=m+(l*20|0)|0,(a|0)!=(o|0)):0)c[k>>2]=a+(~(((a+-20-o|0)>>>0)/20|0)*20|0)}else YVb(h,l-n|0);n=c[d>>2]|0;l=d+4|0;if((n|0)!=(l|0)){o=n;n=0;while(1){c[(ZVb(j,o+16|0)|0)>>2]=n;a=(c[h>>2]|0)+(n*20|0)|0;k=o+28|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[(c[h>>2]|0)+(n*20|0)+8>>2]=n;n=n+1|0;k=c[o+4>>2]|0;if(!k){a=o;while(1){m=c[a+8>>2]|0;if((c[m>>2]|0)==(a|0)){p=m;break}else a=m}}else{a=k;while(1){m=c[a>>2]|0;if(!m){p=a;break}else a=m}}if((p|0)==(l|0))break;else o=p}}p=c[g+4>>2]|0;if((p|0)==(g|0)){q=d+4|0;r=c[q>>2]|0;$Vb(d,r);i=b;return}else s=p;do{p=c[s+8>>2]|0;o=c[p>>2]|0;rri(e,o,SEi(o|0)|0);o=_Vb(j,e)|0;xri(e);if(o){o=c[p>>2]|0;rri(f,o,SEi(o|0)|0);c[p+8>>2]=c[(ZVb(j,f)|0)>>2];xri(f)}s=c[s+4>>2]|0}while((s|0)!=(g|0));q=d+4|0;r=c[q>>2]|0;$Vb(d,r);i=b;return}function RVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+4112|0;e=d;f=d+16|0;g=a+16|0;if((g|0)==(b|0)){h=b;j=b+4|0}else{k=b+4|0;aWb(g,c[b>>2]|0,c[k>>2]|0);h=b;j=k}k=c[a+56>>2]|0;b=a+32|0;c[b>>2]=k;l=(c[j>>2]|0)-(c[h>>2]|0)>>5;h=a+28|0;c[h>>2]=l;mRb(a,da(l,k)|0,0);k=c[h>>2]|0;if((k|0)<=0){i=d;return}l=a+36|0;j=a+4|0;a=c[b>>2]|0;m=k;k=0;while(1){if((a|0)>0){n=0;do{o=c[g>>2]|0;p=c[l>>2]|0;q=c[p+(n*20|0)+8>>2]|0;r=c[o+(k<<5)>>2]|0;s=(c[o+(k<<5)+4>>2]|0)-r>>2;if((q|0)<(s|0)?(c[r+(q<<2)>>2]|0)!=0:0)t=11;else if((c[o+(k<<5)+24>>2]|0)!=0?(c[p+(n*20|0)+16>>2]&1|0)!=0:0)t=11;else t=15;do if((t|0)==11){t=0;if((s|0)>(n|0)?(q=c[(c[o+(k<<5)+12>>2]|0)+(n<<2)>>2]|0,r=c[p+(n*20|0)+12>>2]|0,!((q|0)==0|(r|0)==(q|0))):0){c[e>>2]=c[p+(n*20|0)>>2];c[e+4>>2]=k;c[e+8>>2]=q;c[e+12>>2]=r;rEi(f,4096,553432,e)|0;Krd(f,0,3653512,150,1,0,0,0);t=15;break}r=(da(c[h>>2]|0,n)|0)+k|0;q=(c[j>>2]|0)+(r>>>5<<2)|0;c[q>>2]=c[q>>2]|1<<(r&31)}while(0);if((t|0)==15){t=0;p=(da(c[h>>2]|0,n)|0)+k|0;o=(c[j>>2]|0)+(p>>>5<<2)|0;c[o>>2]=c[o>>2]&~(1<<(p&31))}n=n+1|0;p=c[b>>2]|0}while((n|0)<(p|0));u=p;v=c[h>>2]|0;w=u}else{v=m;w=a}k=k+1|0;if((k|0)>=(v|0))break;else{a=w;m=v}}i=d;return}function SVb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=c[a+16>>2]|0;j=c[a+36>>2]|0;a=c[j+(e*20|0)+8>>2]|0;k=c[h+(d<<5)>>2]|0;if((a|0)<((c[h+(d<<5)+4>>2]|0)-k>>2|0)?(c[k+(a<<2)>>2]|0)!=0:0){l=1;i=f;return l|0}if(!(c[h+(d<<5)+24>>2]|0)){l=0;i=f;return l|0}if(!(c[j+(e*20|0)+16>>2]&1)){l=0;i=f;return l|0}c[g+8>>2]=0;c[g+4>>2]=0;c[g>>2]=0;l=xo[c[h+(d<<5)+28>>2]&2047](b,a,g)|0;i=f;return l|0}function TVb(a,b){a=a|0;b=b|0;return c[(c[a+36>>2]|0)+(b*20|0)>>2]|0}function UVb(a,b){a=a|0;b=b|0;return c[(c[a+36>>2]|0)+(b*20|0)+12>>2]|0}function VVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[b+36>>2]|0)+(d*20|0)|0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];return}function WVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(g-k>>2>>>0>=b>>>0){l=b;m=j;do{if(!m)n=0;else{c[m>>2]=c[d>>2];n=c[h>>2]|0}m=n+4|0;c[h>>2]=m;l=l+-1|0}while((l|0)!=0);i=e;return}l=c[a>>2]|0;m=(k-l>>2)+b|0;if(m>>>0>1073741823)vxi(a);k=l;l=g-k|0;if(l>>2>>>0<536870911){g=l>>1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k>>2;if(!l){o=0;p=0;q=g}else{r=l;s=g;t=10}}else{r=1073741823;s=(c[h>>2]|0)-k>>2;t=10}if((t|0)==10){o=r;p=xCi(r<<2)|0;q=s}s=b;b=p+(q<<2)|0;while(1){if(!b)u=0;else{c[b>>2]=c[d>>2];u=b}r=u+4|0;s=s+-1|0;if(!s){v=r;break}else b=r}b=c[a>>2]|0;s=(c[h>>2]|0)-b|0;u=p+(q-(s>>2)<<2)|0;YEi(u|0,b|0,s|0)|0;c[a>>2]=u;c[h>>2]=v;c[f>>2]=p+(o<<2);if(!b){i=e;return}ACi(b);i=e;return}function XVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(g-k>>2>>>0>=b>>>0){l=b;m=j;while(1){if(m)c[m>>2]=c[d>>2];l=l+-1|0;if(!l)break;else m=m+4|0}c[h>>2]=j+(b<<2);i=e;return}j=c[a>>2]|0;m=(k-j>>2)+b|0;if(m>>>0>1073741823)vxi(a);k=j;l=g-k|0;if(l>>2>>>0<536870911){g=l>>1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k|0;m=g>>2;if(!l){n=0;o=0;p=m;q=g}else{r=l;s=m;t=g;u=11}}else{g=(c[h>>2]|0)-k|0;r=1073741823;s=g>>2;t=g;u=11}if((u|0)==11){n=r;o=xCi(r<<2)|0;p=s;q=t}t=b;s=o+(p<<2)|0;while(1){if(s)c[s>>2]=c[d>>2];t=t+-1|0;if(!t)break;else s=s+4|0}YEi(o|0,j|0,q|0)|0;q=c[a>>2]|0;c[a>>2]=o;c[h>>2]=o+(p+b<<2);c[f>>2]=o+(n<<2);if(!q){i=e;return}ACi(q);i=e;return}function YVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(((f-j|0)/20|0)>>>0>=b>>>0){k=b;l=h;while(1){if(l){c[l+8>>2]=-1;c[l+4>>2]=0;c[l>>2]=0;c[l+16>>2]=1}k=k+-1|0;if(!k)break;else l=l+20|0}c[g>>2]=h+(b*20|0);i=d;return}h=c[a>>2]|0;l=((j-h|0)/20|0)+b|0;if(l>>>0>214748364)vxi(a);j=h;k=(f-j|0)/20|0;if(k>>>0<107374182){f=k<<1;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j|0;l=(f|0)/20|0;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=(c[g>>2]|0)-j|0;q=214748364;r=(f|0)/20|0;s=f;t=11}if((t|0)==11){m=q;n=xCi(q*20|0)|0;o=r;p=s}s=b;r=n+(o*20|0)|0;while(1){if(r){c[r+8>>2]=-1;c[r+4>>2]=0;c[r>>2]=0;c[r+16>>2]=1}s=s+-1|0;if(!s)break;else r=r+20|0}r=n+((((p|0)/-20|0)+o|0)*20|0)|0;YEi(r|0,h|0,p|0)|0;p=c[a>>2]|0;c[a>>2]=r;c[g>>2]=n+((o+b|0)*20|0);c[e>>2]=n+(m*20|0);if(!p){i=d;return}ACi(p);i=d;return}function ZVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=cWb(a,e,b)|0;g=c[f>>2]|0;if(g){h=g;j=h+28|0;i=d;return j|0}g=xCi(32)|0;sri(g+16|0,b);c[g+28>>2]=0;b=c[e>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=b;c[f>>2]=g;b=c[c[a>>2]>>2]|0;if(!b)k=g;else{c[a>>2]=b;k=c[f>>2]|0}GN(c[a+4>>2]|0,k);k=a+8|0;c[k>>2]=(c[k>>2]|0)+1;h=g;j=h+28|0;i=d;return j|0}function _Vb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[b+4>>2]|0;if(!f){g=0;i=e;return g|0}b=a[d>>0]|0;h=(b&1)==0;j=(b&255)>>>1;b=d+1|0;k=c[d+8>>2]|0;l=c[d+4>>2]|0;d=f;while(1){f=d+16|0;m=h?j:l;n=a[f>>0]|0;o=(n&1)==0;if(o)p=(n&255)>>>1;else p=c[d+20>>2]|0;if(o)q=f+1|0;else q=c[d+24>>2]|0;r=FEi(h?b:k,q,p>>>0<m>>>0?p:m)|0;if(!r)if(m>>>0<p>>>0)s=12;else s=13;else if((r|0)<0)s=12;else s=13;if((s|0)==12){s=0;t=d}else if((s|0)==13){s=0;if(o)u=(n&255)>>>1;else u=c[d+20>>2]|0;n=h?j:l;if(o)v=f+1|0;else v=c[d+24>>2]|0;f=FEi(v,h?b:k,n>>>0<u>>>0?n:u)|0;if(!f){if(u>>>0>=n>>>0){g=1;s=24;break}}else if((f|0)>=0){g=1;s=24;break}t=d+4|0}d=c[t>>2]|0;if(!d){g=0;s=24;break}}if((s|0)==24){i=e;return g|0}return 0}function $Vb(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}$Vb(a,c[b>>2]|0);$Vb(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function aWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b;j=d-h|0;k=j>>5;l=a+8|0;m=c[a>>2]|0;n=m;if(k>>>0>(c[l>>2]|0)-n>>5>>>0){fWb(a);if((j|0)<0)vxi(a);j=(c[l>>2]|0)-(c[a>>2]|0)|0;if(j>>5>>>0<1073741823){o=j>>4;j=o>>>0<k>>>0?k:o;if((j|0)<0)vxi(a);else p=j}else p=2147483647;c[g>>2]=1;c[f+0>>2]=c[g+0>>2];g=cOb(p<<5,8,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(p<<5);if((b|0)==(d|0)){i=e;return}else{q=b;r=g}do{if(!r)s=0;else{lVb(r,q);_P(r+12|0,q+12|0);g=q+24|0;p=c[g+4>>2]|0;l=r+24|0;c[l>>2]=c[g>>2];c[l+4>>2]=p;s=c[f>>2]|0}r=s+32|0;c[f>>2]=r;q=q+32|0}while((q|0)!=(d|0));i=e;return}q=a+4|0;a=(c[q>>2]|0)-n>>5;if(k>>>0>a>>>0){t=1;u=b+(a<<5)|0}else{t=0;u=d}if((u|0)==(b|0))v=m;else{a=u+-32-h|0;h=b;b=m;while(1){if((b|0)!=(h|0)){dWb(b,c[h>>2]|0,c[h+4>>2]|0);eWb(b+12|0,c[h+12>>2]|0,c[h+16>>2]|0)}k=h+24|0;n=c[k+4>>2]|0;r=b+24|0;c[r>>2]=c[k>>2];c[r+4>>2]=n;h=h+32|0;if((h|0)==(u|0))break;else b=b+32|0}v=m+((a>>>5)+1<<5)|0}if(t){if((u|0)==(d|0)){i=e;return}t=u;u=c[q>>2]|0;do{if(!u)w=0;else{lVb(u,t);_P(u+12|0,t+12|0);a=t+24|0;m=c[a+4>>2]|0;b=u+24|0;c[b>>2]=c[a>>2];c[b+4>>2]=m;w=c[q>>2]|0}u=w+32|0;c[q>>2]=u;t=t+32|0}while((t|0)!=(d|0));i=e;return}d=c[q>>2]|0;if((d|0)==(v|0)){i=e;return}else x=d;do{d=x+-32|0;c[q>>2]=d;t=c[x+-20>>2]|0;if(t){u=x+-16|0;w=c[u>>2]|0;if((w|0)!=(t|0))c[u>>2]=w+(~((w+-4-t|0)>>>2)<<2);ACi(t)}t=c[d>>2]|0;if(t){d=x+-28|0;w=c[d>>2]|0;if((w|0)!=(t|0))c[d>>2]=w+(~((w+-4-t|0)>>>2)<<2);ACi(t)}x=c[q>>2]|0}while((x|0)!=(v|0));i=e;return}function bWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[d+4>>2]|0;h=d+4|0;do if(g){d=a[e>>0]|0;j=(d&1)==0;k=(d&255)>>>1;d=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;n=j?k:m;o=j?d:l;p=h;q=g;a:while(1){r=q;while(1){s=r+16|0;t=a[s>>0]|0;if(!(t&1)){u=(t&255)>>>1;v=s+1|0}else{u=c[r+20>>2]|0;v=c[r+24>>2]|0}s=FEi(v,o,n>>>0<u>>>0?n:u)|0;if(!s){if(u>>>0>=n>>>0){w=r;break}}else if((s|0)>=0){w=r;break}r=c[r+4>>2]|0;if(!r){x=p;break a}}q=c[w>>2]|0;if(!q){x=w;break}else p=w}if((x|0)!=(h|0)){p=x+16|0;q=j?k:m;n=a[p>>0]|0;o=(n&1)==0;if(o)y=(n&255)>>>1;else y=c[x+20>>2]|0;if(o)z=p+1|0;else z=c[x+24>>2]|0;p=FEi(j?d:l,z,y>>>0<q>>>0?y:q)|0;if(!p){if(q>>>0<y>>>0)break}else if((p|0)<0)break;c[b>>2]=x;i=f;return}}while(0);c[b>>2]=h;i=f;return}function cWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;a:do if(!(h&1)){e=g;while(1){n=e+16|0;o=a[n>>0]|0;p=(o&1)==0;if(p){q=(o&255)>>>1;r=n+1|0}else{q=c[e+20>>2]|0;r=c[e+24>>2]|0}s=FEi(k,r,q>>>0<b>>>0?q:b)|0;if(!s){if(b>>>0<q>>>0)t=16}else if((s|0)<0)t=16;if((t|0)==16){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){w=(o&255)>>>1;x=n+1|0}else{w=c[e+20>>2]|0;x=c[e+24>>2]|0}n=FEi(x,k,b>>>0<w>>>0?b:w)|0;if(!n){if(w>>>0>=b>>>0){y=e;t=33;break a}}else if((n|0)>=0){y=e;t=33;break a}n=e+4|0;o=c[n>>2]|0;if(!o){z=n;A=e;t=32;break}else e=o}}else{e=g;while(1){o=e+16|0;n=a[o>>0]|0;p=(n&1)==0;if(p){B=(n&255)>>>1;C=o+1|0}else{B=c[e+20>>2]|0;C=c[e+24>>2]|0}s=FEi(l,C,B>>>0<m>>>0?B:m)|0;if(!s){if(m>>>0<B>>>0)t=23}else if((s|0)<0)t=23;if((t|0)==23){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){D=(n&255)>>>1;E=o+1|0}else{D=c[e+20>>2]|0;E=c[e+24>>2]|0}o=FEi(E,l,m>>>0<D>>>0?m:D)|0;if(!o){if(D>>>0>=m>>>0){y=e;t=33;break a}}else if((o|0)>=0){y=e;t=33;break a}o=e+4|0;n=c[o>>2]|0;if(!n){z=o;A=e;t=32;break}else e=n}}while(0);if((t|0)==24){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==32){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==33){c[d>>2]=y;j=d;i=f;return j|0}return 0}function dWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=b;g=d-f>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=j-l>>2>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=n>>2;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;f=k+(p>>2<<2)|0;p=c[m>>2]|0;if((p|0)==(f|0)){i=e;return}c[m>>2]=p+(~((p+-4-f|0)>>>2)<<2);i=e;return}f=b+(o<<2)|0;aFi(k|0,b|0,n|0)|0;if((f|0)==(d|0)){i=e;return}n=f;f=c[m>>2]|0;do{if(!f)q=0;else{c[f>>2]=c[n>>2];q=c[m>>2]|0}f=q+4|0;c[m>>2]=f;n=n+4|0}while((n|0)!=(d|0));i=e;return}if(!k)r=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;r=0}if(g>>>0>1073741823)vxi(a);j=r-0|0;if(j>>2>>>0<536870911){r=j>>1;j=r>>>0<g>>>0?g:r;if(j>>>0>1073741823)vxi(a);else s=j}else s=1073741823;j=xCi(s<<2)|0;r=a+4|0;c[r>>2]=j;c[a>>2]=j;c[h>>2]=j+(s<<2);if((b|0)==(d|0)){i=e;return}else{t=b;u=j}do{c[u>>2]=c[t>>2];u=(c[r>>2]|0)+4|0;c[r>>2]=u;t=t+4|0}while((t|0)!=(d|0));i=e;return}function eWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b;g=d-f>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=j-l>>2>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=n>>2;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;q=k+(p>>2<<2)|0;p=c[m>>2]|0;if((p|0)==(q|0)){i=e;return}c[m>>2]=p+(~((p+-4-q|0)>>>2)<<2);i=e;return}q=b+(o<<2)|0;aFi(k|0,b|0,n|0)|0;if((q|0)==(d|0)){i=e;return}n=c[m>>2]|0;o=(d+-4-q|0)>>>2;p=q;q=n;while(1){if(q)c[q>>2]=c[p>>2];p=p+4|0;if((p|0)==(d|0))break;else q=q+4|0}c[m>>2]=n+(o+1<<2);i=e;return}if(!k)r=j;else{j=a+4|0;o=c[j>>2]|0;if((o|0)!=(k|0))c[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;r=0}if(g>>>0>1073741823)vxi(a);j=r-0|0;if(j>>2>>>0<536870911){r=j>>1;j=r>>>0<g>>>0?g:r;if(j>>>0>1073741823)vxi(a);else s=j}else s=1073741823;j=xCi(s<<2)|0;r=a+4|0;c[r>>2]=j;c[a>>2]=j;c[h>>2]=j+(s<<2);if((b|0)==(d|0)){i=e;return}s=(d+-4-f|0)>>>2;f=b;b=j;while(1){c[b>>2]=c[f>>2];f=f+4|0;if((f|0)==(d|0))break;else b=b+4|0}c[r>>2]=j+(s+1<<2);i=e;return}function fWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(!f){i=b;return}g=a+4|0;h=c[g>>2]|0;if((h|0)==(f|0))j=f;else{k=h;do{h=k+-32|0;c[g>>2]=h;l=c[k+-20>>2]|0;if(l){m=k+-16|0;n=c[m>>2]|0;if((n|0)!=(l|0))c[m>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(l)}l=c[h>>2]|0;if(l){h=k+-28|0;n=c[h>>2]|0;if((n|0)!=(l|0))c[h>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(l)}k=c[g>>2]|0}while((k|0)!=(f|0));j=c[a>>2]|0}c[e>>2]=1;c[d+0>>2]=c[e+0>>2];eOb(j,d);c[a+8>>2]=0;c[g>>2]=0;c[a>>2]=0;i=b;return}function gWb(){return c[138392]|0}function hWb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+192|0;f=e;g=e+128|0;h=e+112|0;j=e+32|0;k=e+80|0;l=e+20|0;m=e+64|0;n=e+160|0;o=e+172|0;p=b+4|0;c[p>>2]=0;c[b+8>>2]=0;q=b+4|0;c[b>>2]=q;r=c[138392]|0;s=c[r+4>>2]|0;if((s|0)==(r|0)){i=e;return}t=k+12|0;u=j+12|0;v=g+12|0;w=o+1|0;x=o+8|0;y=n+1|0;z=n+8|0;A=m+1|0;B=m+8|0;C=h+1|0;D=h+8|0;E=h+4|0;F=s;do{s=c[F+8>>2]|0;G=s+16|0;do if(!((c[G>>2]&2|0)!=0^d)){H=c[s>>2]|0;rri(h,H,SEi(H|0)|0);jWb(f,b,h,c[p>>2]|0,q);H=c[f>>2]|0;do if((H|0)!=(q|0)){I=H+16|0;J=a[h>>0]|0;K=(J&1)==0;if(K)L=(J&255)>>>1;else L=c[E>>2]|0;J=a[I>>0]|0;M=(J&1)==0;if(M)N=(J&255)>>>1;else N=c[H+20>>2]|0;if(M)O=I+1|0;else O=c[H+24>>2]|0;I=FEi(K?C:c[D>>2]|0,O,N>>>0<L>>>0?N:L)|0;if(!I)if(L>>>0<N>>>0){P=17;break}else{Q=H;break}else if((I|0)<0){P=17;break}else{Q=H;break}}else P=17;while(0);if((P|0)==17){P=0;Q=q}xri(h);if((Q|0)==(q|0)){H=c[s>>2]|0;rri(l,H,SEi(H|0)|0);c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];c[f+16>>2]=c[s+16>>2];sri(k,l);c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];c[t+16>>2]=c[f+16>>2];sri(j,k);c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];c[u+12>>2]=c[t+12>>2];c[u+16>>2]=c[t+16>>2];sri(g,j);c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];kWb(f,b,g);xri(g);xri(j);xri(k);xri(l);break}if((c[s+12>>2]|0)!=(c[Q+40>>2]|0)){rri(m,553576,50);Eri(m,c[s>>2]|0)|0;Eri(m,553632)|0;Krd((a[m>>0]&1)==0?A:c[B>>2]|0,0,3653512,56,1,0,0,0);xri(m)}if((c[s+4>>2]|0)!=(c[Q+32>>2]|0)){rri(n,553576,50);Eri(n,c[s>>2]|0)|0;Eri(n,553632)|0;Krd((a[n>>0]&1)==0?y:c[z>>2]|0,0,3653512,64,1,0,0,0);xri(n)}if((c[G>>2]|0)!=(c[Q+44>>2]|0)){rri(o,553728,46);Eri(o,c[s>>2]|0)|0;Krd((a[o>>0]&1)==0?w:c[x>>2]|0,0,3653512,71,1,0,0,0);xri(o)}}while(0);F=c[F+4>>2]|0}while((F|0)!=(r|0));i=e;return}function iWb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;a=i;i=i+16|0;b=a+4|0;d=a;c[138444]=553800;c[138447]=56;c[138445]=0;c[138446]=-1;c[138448]=1;e=c[138392]|0;if(!e){f=xCi(12)|0;c[f>>2]=f;c[f+4>>2]=f;c[f+8>>2]=0;c[138392]=f;g=f}else g=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=553776;c[e+4>>2]=g;f=c[g>>2]|0;c[e>>2]=f;c[f+4>>2]=e;c[g>>2]=e;e=g+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138454]=553840;c[138457]=56;c[138455]=0;c[138456]=-1;c[138458]=1;e=c[138392]|0;if(!e){g=xCi(12)|0;c[g>>2]=g;c[g+4>>2]=g;c[g+8>>2]=0;c[138392]=g;h=g}else h=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=553816;c[e+4>>2]=h;g=c[h>>2]|0;c[e>>2]=g;c[g+4>>2]=e;c[h>>2]=e;e=h+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138464]=553880;c[138467]=56;c[138465]=0;c[138466]=-1;c[138468]=1;e=c[138392]|0;if(!e){h=xCi(12)|0;c[h>>2]=h;c[h+4>>2]=h;c[h+8>>2]=0;c[138392]=h;j=h}else j=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=553856;c[e+4>>2]=j;h=c[j>>2]|0;c[e>>2]=h;c[h+4>>2]=e;c[j>>2]=e;e=j+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138474]=553920;c[138477]=100004;c[138475]=0;c[138476]=-1;c[138478]=1;e=c[138392]|0;if(!e){j=xCi(12)|0;c[j>>2]=j;c[j+4>>2]=j;c[j+8>>2]=0;c[138392]=j;k=j}else k=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=553896;c[e+4>>2]=k;j=c[k>>2]|0;c[e>>2]=j;c[j+4>>2]=e;c[k>>2]=e;e=k+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138486]=553968;c[138489]=100004;c[138487]=0;c[138488]=-1;c[138490]=1;e=c[138392]|0;if(!e){k=xCi(12)|0;c[k>>2]=k;c[k+4>>2]=k;c[k+8>>2]=0;c[138392]=k;l=k}else l=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=553944;c[e+4>>2]=l;k=c[l>>2]|0;c[e>>2]=k;c[k+4>>2]=e;c[l>>2]=e;e=l+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138496]=554008;c[138499]=100004;c[138497]=0;c[138498]=-1;c[138500]=1;e=c[138392]|0;if(!e){l=xCi(12)|0;c[l>>2]=l;c[l+4>>2]=l;c[l+8>>2]=0;c[138392]=l;m=l}else m=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=553984;c[e+4>>2]=m;l=c[m>>2]|0;c[e>>2]=l;c[l+4>>2]=e;c[m>>2]=e;e=m+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138506]=554048;c[138509]=100007;c[138507]=0;c[138508]=-1;c[138510]=1;e=c[138392]|0;if(!e){m=xCi(12)|0;c[m>>2]=m;c[m+4>>2]=m;c[m+8>>2]=0;c[138392]=m;n=m}else n=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554024;c[e+4>>2]=n;m=c[n>>2]|0;c[e>>2]=m;c[m+4>>2]=e;c[n>>2]=e;e=n+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138518]=554096;c[138521]=100007;c[138519]=0;c[138520]=-1;c[138522]=1;e=c[138392]|0;if(!e){n=xCi(12)|0;c[n>>2]=n;c[n+4>>2]=n;c[n+8>>2]=0;c[138392]=n;o=n}else o=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554072;c[e+4>>2]=o;n=c[o>>2]|0;c[e>>2]=n;c[n+4>>2]=e;c[o>>2]=e;e=o+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138530]=554144;c[138533]=100007;c[138531]=0;c[138532]=-1;c[138534]=1;e=c[138392]|0;if(!e){o=xCi(12)|0;c[o>>2]=o;c[o+4>>2]=o;c[o+8>>2]=0;c[138392]=o;p=o}else p=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554120;c[e+4>>2]=p;o=c[p>>2]|0;c[e>>2]=o;c[o+4>>2]=e;c[p>>2]=e;e=p+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138542]=554192;c[138545]=53;c[138543]=0;c[138544]=-1;c[138546]=1;e=c[138392]|0;if(!e){p=xCi(12)|0;c[p>>2]=p;c[p+4>>2]=p;c[p+8>>2]=0;c[138392]=p;q=p}else q=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554168;c[e+4>>2]=q;p=c[q>>2]|0;c[e>>2]=p;c[p+4>>2]=e;c[q>>2]=e;e=q+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138554]=554240;c[138557]=53;c[138555]=0;c[138556]=-1;c[138558]=1;e=c[138392]|0;if(!e){q=xCi(12)|0;c[q>>2]=q;c[q+4>>2]=q;c[q+8>>2]=0;c[138392]=q;r=q}else r=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554216;c[e+4>>2]=r;q=c[r>>2]|0;c[e>>2]=q;c[q+4>>2]=e;c[r>>2]=e;e=r+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138564]=554280;c[138567]=53;c[138565]=0;c[138566]=-1;c[138568]=1;e=c[138392]|0;if(!e){r=xCi(12)|0;c[r>>2]=r;c[r+4>>2]=r;c[r+8>>2]=0;c[138392]=r;s=r}else s=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554256;c[e+4>>2]=s;r=c[s>>2]|0;c[e>>2]=r;c[r+4>>2]=e;c[s>>2]=e;e=s+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138574]=554320;c[138577]=100002;c[138575]=0;c[138576]=-1;c[138578]=1;e=c[138392]|0;if(!e){s=xCi(12)|0;c[s>>2]=s;c[s+4>>2]=s;c[s+8>>2]=0;c[138392]=s;t=s}else t=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554296;c[e+4>>2]=t;s=c[t>>2]|0;c[e>>2]=s;c[s+4>>2]=e;c[t>>2]=e;e=t+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138584]=554360;c[138587]=1e5;c[138585]=0;c[138586]=-1;c[138588]=0;e=c[138392]|0;if(!e){t=xCi(12)|0;c[t>>2]=t;c[t+4>>2]=t;c[t+8>>2]=0;c[138392]=t;u=t}else u=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554336;c[e+4>>2]=u;t=c[u>>2]|0;c[e>>2]=t;c[t+4>>2]=e;c[u>>2]=e;e=u+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138596]=554408;c[138599]=0;c[138597]=0;c[138598]=-1;c[138600]=1;e=c[138392]|0;if(!e){u=xCi(12)|0;c[u>>2]=u;c[u+4>>2]=u;c[u+8>>2]=0;c[138392]=u;v=u}else v=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554384;c[e+4>>2]=v;u=c[v>>2]|0;c[e>>2]=u;c[u+4>>2]=e;c[v>>2]=e;e=v+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138610]=554464;c[138613]=0;c[138611]=0;c[138612]=-1;c[138614]=1;e=c[138392]|0;if(!e){v=xCi(12)|0;c[v>>2]=v;c[v+4>>2]=v;c[v+8>>2]=0;c[138392]=v;w=v}else w=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554440;c[e+4>>2]=w;v=c[w>>2]|0;c[e>>2]=v;c[v+4>>2]=e;c[w>>2]=e;e=w+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138624]=554520;c[138627]=0;c[138625]=0;c[138626]=-1;c[138628]=1;e=c[138392]|0;if(!e){w=xCi(12)|0;c[w>>2]=w;c[w+4>>2]=w;c[w+8>>2]=0;c[138392]=w;x=w}else x=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554496;c[e+4>>2]=x;w=c[x>>2]|0;c[e>>2]=w;c[w+4>>2]=e;c[x>>2]=e;e=x+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138638]=554576;c[138641]=1;c[138639]=0;c[138640]=-1;c[138642]=1;e=c[138392]|0;if(!e){x=xCi(12)|0;c[x>>2]=x;c[x+4>>2]=x;c[x+8>>2]=0;c[138392]=x;y=x}else y=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554552;c[e+4>>2]=y;x=c[y>>2]|0;c[e>>2]=x;c[x+4>>2]=e;c[y>>2]=e;e=y+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138650]=554624;c[138653]=0;c[138651]=0;c[138652]=-1;c[138654]=0;e=c[138392]|0;if(!e){y=xCi(12)|0;c[y>>2]=y;c[y+4>>2]=y;c[y+8>>2]=0;c[138392]=y;z=y}else z=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554600;c[e+4>>2]=z;y=c[z>>2]|0;c[e>>2]=y;c[y+4>>2]=e;c[z>>2]=e;e=z+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138662]=554672;c[138665]=43;c[138663]=0;c[138664]=-1;c[138666]=0;e=c[138392]|0;if(!e){z=xCi(12)|0;c[z>>2]=z;c[z+4>>2]=z;c[z+8>>2]=0;c[138392]=z;A=z}else A=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554648;c[e+4>>2]=A;z=c[A>>2]|0;c[e>>2]=z;c[z+4>>2]=e;c[A>>2]=e;e=A+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138674]=554720;c[138677]=0;c[138675]=0;c[138676]=-1;c[138678]=0;e=c[138392]|0;if(!e){A=xCi(12)|0;c[A>>2]=A;c[A+4>>2]=A;c[A+8>>2]=0;c[138392]=A;B=A}else B=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554696;c[e+4>>2]=B;A=c[B>>2]|0;c[e>>2]=A;c[A+4>>2]=e;c[B>>2]=e;e=B+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138686]=554768;c[138689]=0;c[138687]=0;c[138688]=-1;c[138690]=0;e=c[138392]|0;if(!e){B=xCi(12)|0;c[B>>2]=B;c[B+4>>2]=B;c[B+8>>2]=0;c[138392]=B;C=B}else C=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554744;c[e+4>>2]=C;B=c[C>>2]|0;c[e>>2]=B;c[B+4>>2]=e;c[C>>2]=e;e=C+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138696]=554808;c[138699]=0;c[138697]=0;c[138698]=-1;c[138700]=0;e=c[138392]|0;if(!e){C=xCi(12)|0;c[C>>2]=C;c[C+4>>2]=C;c[C+8>>2]=0;c[138392]=C;D=C}else D=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554784;c[e+4>>2]=D;C=c[D>>2]|0;c[e>>2]=C;c[C+4>>2]=e;c[D>>2]=e;e=D+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138706]=554848;c[138709]=0;c[138707]=0;c[138708]=-1;c[138710]=2;e=c[138392]|0;if(!e){D=xCi(12)|0;c[D>>2]=D;c[D+4>>2]=D;c[D+8>>2]=0;c[138392]=D;E=D}else E=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554824;c[e+4>>2]=E;D=c[E>>2]|0;c[e>>2]=D;c[D+4>>2]=e;c[E>>2]=e;e=E+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138718]=554896;c[138721]=2;c[138719]=0;c[138720]=-1;c[138722]=0;e=c[138392]|0;if(!e){E=xCi(12)|0;c[E>>2]=E;c[E+4>>2]=E;c[E+8>>2]=0;c[138392]=E;F=E}else F=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554872;c[e+4>>2]=F;E=c[F>>2]|0;c[e>>2]=E;c[E+4>>2]=e;c[F>>2]=e;e=F+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138730]=554944;c[138733]=2;c[138731]=0;c[138732]=-1;c[138734]=0;e=c[138392]|0;if(!e){F=xCi(12)|0;c[F>>2]=F;c[F+4>>2]=F;c[F+8>>2]=0;c[138392]=F;G=F}else G=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554920;c[e+4>>2]=G;F=c[G>>2]|0;c[e>>2]=F;c[F+4>>2]=e;c[G>>2]=e;e=G+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138742]=554992;c[138745]=0;c[138743]=0;c[138744]=-1;c[138746]=1;e=c[138392]|0;if(!e){G=xCi(12)|0;c[G>>2]=G;c[G+4>>2]=G;c[G+8>>2]=0;c[138392]=G;H=G}else H=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=554968;c[e+4>>2]=H;G=c[H>>2]|0;c[e>>2]=G;c[G+4>>2]=e;c[H>>2]=e;e=H+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138752]=555032;c[138755]=0;c[138753]=0;c[138754]=-1;c[138756]=1;e=c[138392]|0;if(!e){H=xCi(12)|0;c[H>>2]=H;c[H+4>>2]=H;c[H+8>>2]=0;c[138392]=H;I=H}else I=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555008;c[e+4>>2]=I;H=c[I>>2]|0;c[e>>2]=H;c[H+4>>2]=e;c[I>>2]=e;e=I+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138764]=555080;c[138767]=0;c[138765]=0;c[138766]=-1;c[138768]=5;e=c[138392]|0;if(!e){I=xCi(12)|0;c[I>>2]=I;c[I+4>>2]=I;c[I+8>>2]=0;c[138392]=I;J=I}else J=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555056;c[e+4>>2]=J;I=c[J>>2]|0;c[e>>2]=I;c[I+4>>2]=e;c[J>>2]=e;e=J+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138776]=555128;c[138779]=0;c[138777]=0;c[138778]=-1;c[138780]=5;e=c[138392]|0;if(!e){J=xCi(12)|0;c[J>>2]=J;c[J+4>>2]=J;c[J+8>>2]=0;c[138392]=J;K=J}else K=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555104;c[e+4>>2]=K;J=c[K>>2]|0;c[e>>2]=J;c[J+4>>2]=e;c[K>>2]=e;e=K+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138786]=555168;c[138789]=0;c[138787]=0;c[138788]=-1;c[138790]=5;e=c[138392]|0;if(!e){K=xCi(12)|0;c[K>>2]=K;c[K+4>>2]=K;c[K+8>>2]=0;c[138392]=K;L=K}else L=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555144;c[e+4>>2]=L;K=c[L>>2]|0;c[e>>2]=K;c[K+4>>2]=e;c[L>>2]=e;e=L+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138796]=1254888;c[138799]=0;c[138797]=0;c[138798]=-1;c[138800]=5;e=c[138392]|0;if(!e){L=xCi(12)|0;c[L>>2]=L;c[L+4>>2]=L;c[L+8>>2]=0;c[138392]=L;M=L}else M=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555184;c[e+4>>2]=M;L=c[M>>2]|0;c[e>>2]=L;c[L+4>>2]=e;c[M>>2]=e;e=M+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138802]=555232;c[138805]=100003;c[138803]=0;c[138804]=-1;c[138806]=1;e=c[138392]|0;if(!e){M=xCi(12)|0;c[M>>2]=M;c[M+4>>2]=M;c[M+8>>2]=0;c[138392]=M;N=M}else N=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555208;c[e+4>>2]=N;M=c[N>>2]|0;c[e>>2]=M;c[M+4>>2]=e;c[N>>2]=e;e=N+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138814]=555280;c[138817]=0;c[138815]=0;c[138816]=-1;c[138818]=5;e=c[138392]|0;if(!e){N=xCi(12)|0;c[N>>2]=N;c[N+4>>2]=N;c[N+8>>2]=0;c[138392]=N;O=N}else O=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555256;c[e+4>>2]=O;N=c[O>>2]|0;c[e>>2]=N;c[N+4>>2]=e;c[O>>2]=e;e=O+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138824]=555320;c[138827]=100006;c[138825]=0;c[138826]=-1;c[138828]=0;e=c[138392]|0;if(!e){O=xCi(12)|0;c[O>>2]=O;c[O+4>>2]=O;c[O+8>>2]=0;c[138392]=O;P=O}else P=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555296;c[e+4>>2]=P;O=c[P>>2]|0;c[e>>2]=O;c[O+4>>2]=e;c[P>>2]=e;e=P+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138836]=555368;c[138839]=1e5;c[138837]=0;c[138838]=-1;c[138840]=5;e=c[138392]|0;if(!e){P=xCi(12)|0;c[P>>2]=P;c[P+4>>2]=P;c[P+8>>2]=0;c[138392]=P;Q=P}else Q=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555344;c[e+4>>2]=Q;P=c[Q>>2]|0;c[e>>2]=P;c[P+4>>2]=e;c[Q>>2]=e;e=Q+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138846]=555408;c[138849]=0;c[138847]=0;c[138848]=-1;c[138850]=0;e=c[138392]|0;if(!e){Q=xCi(12)|0;c[Q>>2]=Q;c[Q+4>>2]=Q;c[Q+8>>2]=0;c[138392]=Q;R=Q}else R=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555384;c[e+4>>2]=R;Q=c[R>>2]|0;c[e>>2]=Q;c[Q+4>>2]=e;c[R>>2]=e;e=R+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138858]=555456;c[138861]=1e5;c[138859]=555480;c[138860]=-1;c[138862]=1;e=c[138392]|0;if(!e){R=xCi(12)|0;c[R>>2]=R;c[R+4>>2]=R;c[R+8>>2]=0;c[138392]=R;S=R}else S=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555432;c[e+4>>2]=S;R=c[S>>2]|0;c[e>>2]=R;c[R+4>>2]=e;c[S>>2]=e;e=S+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138874]=555520;c[138877]=1e5;c[138875]=555480;c[138876]=-1;c[138878]=1;e=c[138392]|0;if(!e){S=xCi(12)|0;c[S>>2]=S;c[S+4>>2]=S;c[S+8>>2]=0;c[138392]=S;T=S}else T=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555496;c[e+4>>2]=T;S=c[T>>2]|0;c[e>>2]=S;c[S+4>>2]=e;c[T>>2]=e;e=T+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138886]=555568;c[138889]=0;c[138887]=0;c[138888]=-1;c[138890]=1;e=c[138392]|0;if(!e){T=xCi(12)|0;c[T>>2]=T;c[T+4>>2]=T;c[T+8>>2]=0;c[138392]=T;U=T}else U=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555544;c[e+4>>2]=U;T=c[U>>2]|0;c[e>>2]=T;c[T+4>>2]=e;c[U>>2]=e;e=U+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138898]=555616;c[138901]=1e5;c[138899]=555480;c[138900]=-1;c[138902]=1;e=c[138392]|0;if(!e){U=xCi(12)|0;c[U>>2]=U;c[U+4>>2]=U;c[U+8>>2]=0;c[138392]=U;V=U}else V=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555592;c[e+4>>2]=V;U=c[V>>2]|0;c[e>>2]=U;c[U+4>>2]=e;c[V>>2]=e;e=V+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138910]=555664;c[138913]=1e5;c[138911]=555696;c[138912]=-1;c[138914]=1;e=c[138392]|0;if(!e){V=xCi(12)|0;c[V>>2]=V;c[V+4>>2]=V;c[V+8>>2]=0;c[138392]=V;W=V}else W=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555640;c[e+4>>2]=W;V=c[W>>2]|0;c[e>>2]=V;c[V+4>>2]=e;c[W>>2]=e;e=W+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138930]=555744;c[138933]=1e5;c[138931]=555768;c[138932]=-1;c[138934]=1;e=c[138392]|0;if(!e){W=xCi(12)|0;c[W>>2]=W;c[W+4>>2]=W;c[W+8>>2]=0;c[138392]=W;X=W}else X=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555720;c[e+4>>2]=X;W=c[X>>2]|0;c[e>>2]=W;c[W+4>>2]=e;c[X>>2]=e;e=X+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138948]=555816;c[138951]=1e5;c[138949]=555768;c[138950]=-1;c[138952]=1;e=c[138392]|0;if(!e){X=xCi(12)|0;c[X>>2]=X;c[X+4>>2]=X;c[X+8>>2]=0;c[138392]=X;Y=X}else Y=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555792;c[e+4>>2]=Y;X=c[Y>>2]|0;c[e>>2]=X;c[X+4>>2]=e;c[Y>>2]=e;e=Y+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138962]=555872;c[138965]=1e5;c[138963]=555696;c[138964]=-1;c[138966]=1;e=c[138392]|0;if(!e){Y=xCi(12)|0;c[Y>>2]=Y;c[Y+4>>2]=Y;c[Y+8>>2]=0;c[138392]=Y;Z=Y}else Z=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555848;c[e+4>>2]=Z;Y=c[Z>>2]|0;c[e>>2]=Y;c[Y+4>>2]=e;c[Z>>2]=e;e=Z+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138976]=555928;c[138979]=1e5;c[138977]=555952;c[138978]=-1;c[138980]=1;e=c[138392]|0;if(!e){Z=xCi(12)|0;c[Z>>2]=Z;c[Z+4>>2]=Z;c[Z+8>>2]=0;c[138392]=Z;_=Z}else _=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555904;c[e+4>>2]=_;Z=c[_>>2]|0;c[e>>2]=Z;c[Z+4>>2]=e;c[_>>2]=e;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[138994]=556e3;c[138997]=1e5;c[138995]=0;c[138996]=-1;c[138998]=1;e=c[138392]|0;if(!e){_=xCi(12)|0;c[_>>2]=_;c[_+4>>2]=_;c[_+8>>2]=0;c[138392]=_;$=_}else $=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=555976;c[e+4>>2]=$;_=c[$>>2]|0;c[e>>2]=_;c[_+4>>2]=e;c[$>>2]=e;e=$+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139006]=556048;c[139009]=100001;c[139007]=0;c[139008]=-1;c[139010]=1;e=c[138392]|0;if(!e){$=xCi(12)|0;c[$>>2]=$;c[$+4>>2]=$;c[$+8>>2]=0;c[138392]=$;aa=$}else aa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556024;c[e+4>>2]=aa;$=c[aa>>2]|0;c[e>>2]=$;c[$+4>>2]=e;c[aa>>2]=e;e=aa+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139018]=556096;c[139021]=100001;c[139019]=0;c[139020]=-1;c[139022]=1;e=c[138392]|0;if(!e){aa=xCi(12)|0;c[aa>>2]=aa;c[aa+4>>2]=aa;c[aa+8>>2]=0;c[138392]=aa;ba=aa}else ba=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556072;c[e+4>>2]=ba;aa=c[ba>>2]|0;c[e>>2]=aa;c[aa+4>>2]=e;c[ba>>2]=e;e=ba+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139030]=556144;c[139033]=0;c[139031]=0;c[139032]=-1;c[139034]=1;e=c[138392]|0;if(!e){ba=xCi(12)|0;c[ba>>2]=ba;c[ba+4>>2]=ba;c[ba+8>>2]=0;c[138392]=ba;ca=ba}else ca=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556120;c[e+4>>2]=ca;ba=c[ca>>2]|0;c[e>>2]=ba;c[ba+4>>2]=e;c[ca>>2]=e;e=ca+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139042]=556192;c[139045]=1e5;c[139043]=556216;c[139044]=-1;c[139046]=1;e=c[138392]|0;if(!e){ca=xCi(12)|0;c[ca>>2]=ca;c[ca+4>>2]=ca;c[ca+8>>2]=0;c[138392]=ca;da=ca}else da=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556168;c[e+4>>2]=da;ca=c[da>>2]|0;c[e>>2]=ca;c[ca+4>>2]=e;c[da>>2]=e;e=da+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139060]=556264;c[139063]=0;c[139061]=0;c[139062]=-1;c[139064]=0;e=c[138392]|0;if(!e){da=xCi(12)|0;c[da>>2]=da;c[da+4>>2]=da;c[da+8>>2]=0;c[138392]=da;ea=da}else ea=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556240;c[e+4>>2]=ea;da=c[ea>>2]|0;c[e>>2]=da;c[da+4>>2]=e;c[ea>>2]=e;e=ea+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139074]=556320;c[139077]=0;c[139075]=0;c[139076]=-1;c[139078]=0;e=c[138392]|0;if(!e){ea=xCi(12)|0;c[ea>>2]=ea;c[ea+4>>2]=ea;c[ea+8>>2]=0;c[138392]=ea;fa=ea}else fa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556296;c[e+4>>2]=fa;ea=c[fa>>2]|0;c[e>>2]=ea;c[ea+4>>2]=e;c[fa>>2]=e;e=fa+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139086]=556368;c[139089]=100005;c[139087]=0;c[139088]=-1;c[139090]=4;e=c[138392]|0;if(!e){fa=xCi(12)|0;c[fa>>2]=fa;c[fa+4>>2]=fa;c[fa+8>>2]=0;c[138392]=fa;ga=fa}else ga=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556344;c[e+4>>2]=ga;fa=c[ga>>2]|0;c[e>>2]=fa;c[fa+4>>2]=e;c[ga>>2]=e;e=ga+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139098]=556416;c[139101]=0;c[139099]=0;c[139100]=-1;c[139102]=0;e=c[138392]|0;if(!e){ga=xCi(12)|0;c[ga>>2]=ga;c[ga+4>>2]=ga;c[ga+8>>2]=0;c[138392]=ga;ha=ga}else ha=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556392;c[e+4>>2]=ha;ga=c[ha>>2]|0;c[e>>2]=ga;c[ga+4>>2]=e;c[ha>>2]=e;e=ha+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139110]=556464;c[139113]=0;c[139111]=0;c[139112]=-1;c[139114]=1;e=c[138392]|0;if(!e){ha=xCi(12)|0;c[ha>>2]=ha;c[ha+4>>2]=ha;c[ha+8>>2]=0;c[138392]=ha;ia=ha}else ia=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556440;c[e+4>>2]=ia;ha=c[ia>>2]|0;c[e>>2]=ha;c[ha+4>>2]=e;c[ia>>2]=e;e=ia+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139122]=556512;c[139125]=0;c[139123]=0;c[139124]=-1;c[139126]=0;e=c[138392]|0;if(!e){ia=xCi(12)|0;c[ia>>2]=ia;c[ia+4>>2]=ia;c[ia+8>>2]=0;c[138392]=ia;ja=ia}else ja=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556488;c[e+4>>2]=ja;ia=c[ja>>2]|0;c[e>>2]=ia;c[ia+4>>2]=e;c[ja>>2]=e;e=ja+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139134]=556560;c[139137]=100008;c[139135]=0;c[139136]=-1;c[139138]=0;e=c[138392]|0;if(!e){ja=xCi(12)|0;c[ja>>2]=ja;c[ja+4>>2]=ja;c[ja+8>>2]=0;c[138392]=ja;ka=ja}else ka=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556536;c[e+4>>2]=ka;ja=c[ka>>2]|0;c[e>>2]=ja;c[ja+4>>2]=e;c[ka>>2]=e;e=ka+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139146]=556608;c[139149]=100009;c[139147]=0;c[139148]=-1;c[139150]=0;e=c[138392]|0;if(!e){ka=xCi(12)|0;c[ka>>2]=ka;c[ka+4>>2]=ka;c[ka+8>>2]=0;c[138392]=ka;la=ka}else la=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556584;c[e+4>>2]=la;ka=c[la>>2]|0;c[e>>2]=ka;c[ka+4>>2]=e;c[la>>2]=e;e=la+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139158]=556656;c[139161]=100009;c[139159]=0;c[139160]=-1;c[139162]=0;e=c[138392]|0;if(!e){la=xCi(12)|0;c[la>>2]=la;c[la+4>>2]=la;c[la+8>>2]=0;c[138392]=la;ma=la}else ma=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556632;c[e+4>>2]=ma;la=c[ma>>2]|0;c[e>>2]=la;c[la+4>>2]=e;c[ma>>2]=e;e=ma+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139170]=556704;c[139173]=100009;c[139171]=0;c[139172]=-1;c[139174]=0;e=c[138392]|0;if(!e){ma=xCi(12)|0;c[ma>>2]=ma;c[ma+4>>2]=ma;c[ma+8>>2]=0;c[138392]=ma;na=ma}else na=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556680;c[e+4>>2]=na;ma=c[na>>2]|0;c[e>>2]=ma;c[ma+4>>2]=e;c[na>>2]=e;e=na+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139186]=556768;c[139189]=100009;c[139187]=0;c[139188]=-1;c[139190]=0;e=c[138392]|0;if(!e){na=xCi(12)|0;c[na>>2]=na;c[na+4>>2]=na;c[na+8>>2]=0;c[138392]=na;oa=na}else oa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556744;c[e+4>>2]=oa;na=c[oa>>2]|0;c[e>>2]=na;c[na+4>>2]=e;c[oa>>2]=e;e=oa+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139202]=556832;c[139205]=0;c[139203]=0;c[139204]=-1;c[139206]=1;e=c[138392]|0;if(!e){oa=xCi(12)|0;c[oa>>2]=oa;c[oa+4>>2]=oa;c[oa+8>>2]=0;c[138392]=oa;pa=oa}else pa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556808;c[e+4>>2]=pa;oa=c[pa>>2]|0;c[e>>2]=oa;c[oa+4>>2]=e;c[pa>>2]=e;e=pa+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139216]=556888;c[139219]=1e5;c[139217]=0;c[139218]=-1;c[139220]=1;e=c[138392]|0;if(!e){pa=xCi(12)|0;c[pa>>2]=pa;c[pa+4>>2]=pa;c[pa+8>>2]=0;c[138392]=pa;qa=pa}else qa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556864;c[e+4>>2]=qa;pa=c[qa>>2]|0;c[e>>2]=pa;c[pa+4>>2]=e;c[qa>>2]=e;e=qa+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139226]=556928;c[139229]=0;c[139227]=0;c[139228]=-1;c[139230]=1;e=c[138392]|0;if(!e){qa=xCi(12)|0;c[qa>>2]=qa;c[qa+4>>2]=qa;c[qa+8>>2]=0;c[138392]=qa;ra=qa}else ra=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];e=cOb(12,16,b,0,3653512,80)|0;c[e+8>>2]=556904;c[e+4>>2]=ra;qa=c[ra>>2]|0;c[e>>2]=qa;c[qa+4>>2]=e;c[ra>>2]=e;e=ra+8|0;c[e>>2]=(c[e>>2]|0)+1;c[139238]=556976;c[139241]=0;c[139239]=0;c[139240]=-1;c[139242]=0;e=c[138392]|0;if(e){sa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];ta=cOb(12,16,b,0,3653512,80)|0;ua=ta+8|0;c[ua>>2]=556952;va=ta+4|0;c[va>>2]=sa;wa=c[sa>>2]|0;c[ta>>2]=wa;xa=wa+4|0;c[xa>>2]=ta;c[sa>>2]=ta;ya=sa+8|0;za=c[ya>>2]|0;Aa=za+1|0;c[ya>>2]=Aa;i=a;return}e=xCi(12)|0;c[e>>2]=e;c[e+4>>2]=e;c[e+8>>2]=0;c[138392]=e;sa=e;c[d>>2]=1;c[b+0>>2]=c[d+0>>2];ta=cOb(12,16,b,0,3653512,80)|0;ua=ta+8|0;c[ua>>2]=556952;va=ta+4|0;c[va>>2]=sa;wa=c[sa>>2]|0;c[ta>>2]=wa;xa=wa+4|0;c[xa>>2]=ta;c[sa>>2]=ta;ya=sa+8|0;za=c[ya>>2]|0;Aa=za+1|0;c[ya>>2]=Aa;i=a;return}function jWb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=a[e>>0]|0;k=(j&1)==0;l=(j&255)>>>1;j=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(k){f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=o+1|0}else{q=c[f+20>>2]|0;r=c[f+24>>2]|0}o=FEi(r,j,l>>>0<q>>>0?l:q)|0;if(!o){if(q>>>0>=l>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}else{f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){u=(p&255)>>>1;v=o+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}o=FEi(v,m,n>>>0<u>>>0?n:u)|0;if(!o){if(u>>>0>=n>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}while(0);g=c[s>>2]|0;if(!g){h=s;t=19;break}else e=s}if((t|0)==19){c[b>>2]=h;i=d;return}}function kWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=lWb(d,g,e)|0;j=c[h>>2]|0;if(j){k=0;l=j;c[b>>2]=l;m=b+4|0;a[m>>0]=k;i=f;return}j=xCi(48)|0;sri(j+16|0,e);n=j+28|0;o=e+12|0;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];o=c[g>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=o;c[h>>2]=j;o=c[c[d>>2]>>2]|0;if(!o)p=j;else{c[d>>2]=o;p=c[h>>2]|0}GN(c[d+4>>2]|0,p);p=d+8|0;c[p>>2]=(c[p>>2]|0)+1;k=1;l=j;c[b>>2]=l;m=b+4|0;a[m>>0]=k;i=f;return}function lWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&1)==0;k=(h&255)>>>1;h=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;e=g;while(1){g=e+16|0;n=b?k:m;o=a[g>>0]|0;p=(o&1)==0;if(p)q=(o&255)>>>1;else q=c[e+20>>2]|0;if(p)r=g+1|0;else r=c[e+24>>2]|0;s=FEi(b?h:l,r,q>>>0<n>>>0?q:n)|0;if(!s){if(n>>>0<q>>>0)t=12}else if((s|0)<0)t=12;if((t|0)==12){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=13;break}else{e=s;continue}}if(p)w=(o&255)>>>1;else w=c[e+20>>2]|0;o=b?k:m;if(p)x=g+1|0;else x=c[e+24>>2]|0;g=FEi(x,b?h:l,o>>>0<w>>>0?o:w)|0;if(!g){if(w>>>0>=o>>>0){y=e;t=25;break}}else if((g|0)>=0){y=e;t=25;break}g=e+4|0;o=c[g>>2]|0;if(!o){z=g;A=e;t=24;break}else e=o}if((t|0)==13){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==24){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==25){c[d>>2]=y;j=d;i=f;return j|0}return 0}function mWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];lQb(a,f,d);c[a>>2]=557016;d=a+24|0;c[d>>2]=0;qbc(d);i=e;return}function nWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+24|0;if(!(HEi(c[g>>2]|0,b)|0)){i=d;return}c[f>>2]=VQb(a)|0;c[e+0>>2]=c[f+0>>2];tbc(g,b,e);i=d;return}function oWb(){var a=0;a=i;QQb(130,88,0,0,0);i=a;return}function pWb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(18)|0))TRb();rri(b,557112,11);wQb(130,18,b,28,2600,1,0);xri(b);i=a;return}function qWb(a){a=a|0;return 130}function rWb(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;add(b,792072,557112,a,0);add(b,2487248,c[142294]|0,a+24|0,1);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);bdd(b);i=d;return}function sWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=qdd(b,792072,557112,f,1)|0;if(!g){i=d;return}if((g|0)>0){g=a+24|0;h=qdd(b,2487248,c[142294]|0,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else zUb(g,b);sdd(b)}}else{g=c[f>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b);i=d;return}function tWb(a,b){a=a|0;b=b|0;var c=0;c=i;CUb(a+24|0,b);i=c;return}function uWb(a,b){a=a|0;b=b|0;var c=0;c=i;EUb(a+24|0,b);i=c;return}function vWb(a,b){a=a|0;b=b|0;var c=0;c=i;GUb(a+24|0,b);i=c;return}function wWb(a,b){a=a|0;b=b|0;return}function xWb(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;add(b,2487248,c[142294]|0,a+24|0,1);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);i=d;return}function yWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=a+24|0;a=qdd(b,2487248,c[142294]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else zUb(f,b);sdd(b);i=d;return}function zWb(a,b){a=a|0;b=b|0;var c=0;c=i;CUb(a+24|0,b);i=c;return}function AWb(a,b){a=a|0;b=b|0;var c=0;c=i;EUb(a+24|0,b);i=c;return}function BWb(a,b){a=a|0;b=b|0;var c=0;c=i;GUb(a+24|0,b);i=c;return}function CWb(a,b){a=a|0;b=b|0;return}function DWb(a,b){a=a|0;b=b|0;return 0}function EWb(a){a=a|0;var b=0;b=i;c[a>>2]=557016;ubc(a+24|0);c[a>>2]=551440;i=b;return}function FWb(a){a=a|0;var b=0;b=i;EWb(a);ACi(a);i=b;return}function GWb(a){a=a|0;return c[a+24>>2]|0}function HWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];jSb(a,f,d);c[a>>2]=557152;PEi(a+40|0,0,400)|0;c[h>>2]=c[153108];c[f+0>>2]=c[h+0>>2];c[a+32>>2]=bOb(4,f,1,16,3653512,27)|0;c[j>>2]=c[153108];c[f+0>>2]=c[j+0>>2];j=bOb(12,f,0,16,3653512,29)|0;h=j+4|0;c[h>>2]=0;c[j+8>>2]=0;c[j>>2]=h;c[a+24>>2]=j;c[k>>2]=c[153108];c[f+0>>2]=c[k+0>>2];k=bOb(12,f,0,16,3653512,30)|0;j=k+4|0;c[j>>2]=0;c[k+8>>2]=0;c[k>>2]=j;c[a+28>>2]=k;c[l>>2]=c[153108];c[f+0>>2]=c[l+0>>2];l=bOb(12,f,0,16,3653512,31)|0;f=l+4|0;c[f>>2]=0;c[l+8>>2]=0;c[l>>2]=f;c[a+36>>2]=l;i=e;return}function IWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b;g=a+24|0;h=c[g>>2]|0;j=c[153108]|0;if(h)_Wb(h,c[h+4>>2]|0);c[e>>2]=j;c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;g=a+28|0;h=c[g>>2]|0;j=c[153108]|0;if(h)$Wb(h,c[h+4>>2]|0);c[e>>2]=j;c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;g=a+36|0;h=c[g>>2]|0;j=c[153108]|0;if(h)_Wb(h,c[h+4>>2]|0);c[e>>2]=j;c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;g=0;do{c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;yri(a+(g*12|0)+40|0,f)|0;xri(f);g=g+1|0}while((g|0)<32);g=a+32|0;a=c[g>>2]|0;c[e>>2]=c[153108];c[d+0>>2]=c[e+0>>2];eOb(a,d);c[g>>2]=0;i=b;return}function JWb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+44|0;f=d+40|0;g=d+20|0;h=d+8|0;j=d+4|0;k=d;l=b+424|0;m=c[b+428>>2]|0;n=c[l>>2]|0;o=(m-n|0)/20|0;a:do if((m|0)!=(n|0)){p=0;while(1){if(!(c[n+(p*20|0)+12>>2]|0))break;p=p+1|0;if((p|0)==(o|0))break a}i=d;return}while(0);c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;a[g+16>>0]=0;a[h>>0]=14;o=h+1|0;a[o+0>>0]=a[3071232]|0;a[o+1>>0]=a[3071233]|0;a[o+2>>0]=a[3071234]|0;a[o+3>>0]=a[3071235]|0;a[o+4>>0]=a[3071236]|0;a[o+5>>0]=a[3071237]|0;a[o+6>>0]=a[3071238]|0;a[h+8>>0]=0;h=g+1|0;a[h+0>>0]=a[o+0>>0]|0;a[h+1>>0]=a[o+1>>0]|0;a[h+2>>0]=a[o+2>>0]|0;a[h+3>>0]=a[o+3>>0]|0;a[h+4>>0]=a[o+4>>0]|0;a[h+5>>0]=a[o+5>>0]|0;a[h+6>>0]=a[o+6>>0]|0;a[g+8>>0]=0;a[g>>0]=14;o=c[l>>2]|0;c[g+12>>2]=0;c[j>>2]=o;c[e+0>>2]=c[j+0>>2];aXb(k,l,e,g);c[b+436>>2]=0;if(!(a[g>>0]&1)){i=d;return}b=c[g+8>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function KWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+160|0;g=f+16|0;h=f+48|0;j=f+120|0;k=f;l=f+108|0;m=f+136|0;n=f+148|0;o=f+80|0;p=f+64|0;q=f+24|0;r=f+36|0;s=f+96|0;t=c[b+24>>2]|0;sri(l,e);sri(k,l);u=k+12|0;c[u>>2]=d;sri(j,k);v=j+12|0;c[v>>2]=c[u>>2];sri(h,j);c[h+12>>2]=c[v>>2];bXb(g,t,h);t=a[g+4>>0]|0;xri(h);if(!(t<<24>>24)){t=a[e>>0]|0;if(!(t&1))w=(t&255)>>>1;else w=c[e+4>>2]|0;xri(j);xri(k);xri(l);if(w){_ri(n,557256,e);yO(m,n,557288);if(!b)x=0;else x=c[b+4>>2]|0;if(!(a[m>>0]&1))y=m+1|0;else y=c[m+8>>2]|0;Krd(y,0,3653512,78,4,x,0,0);xri(m);xri(n)}}else{xri(j);xri(k);xri(l)}l=c[b+28>>2]|0;sri(q,e);c[p>>2]=d;d=p+4|0;sri(d,q);c[o>>2]=c[p>>2];p=o+4|0;sri(p,d);c[h>>2]=c[o>>2];k=h+4|0;sri(k,p);c[h>>2]=c[o>>2];cXb(g,l,h);h=a[g+4>>0]|0;xri(k);xri(p);xri(d);xri(q);if(h<<24>>24){i=f;return}_ri(s,557312,e);yO(r,s,557288);if(!b)z=0;else z=c[b+4>>2]|0;if(!(a[r>>0]&1))A=r+1|0;else A=c[r+8>>2]|0;Krd(A,0,3653512,81,4,z,0,0);xri(r);xri(s);i=f;return}function LWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+128|0;g=f+104|0;h=f+64|0;j=f+16|0;k=f+32|0;l=f+112|0;m=f;n=f+48|0;o=f+92|0;p=f+80|0;q=c[b+36>>2]|0;sri(l,e);sri(k,l);r=k+12|0;c[r>>2]=d;sri(j,k);s=j+12|0;c[s>>2]=c[r>>2];sri(h,j);c[h+12>>2]=c[s>>2];bXb(g,q,h);q=a[g+4>>0]|0;xri(h);if(!(q<<24>>24)){q=a[e>>0]|0;if(!(q&1))t=(q&255)>>>1;else t=c[e+4>>2]|0;xri(j);xri(k);xri(l);if(t){_ri(n,557352,e);yO(m,n,557288);if(!b)u=0;else u=c[b+4>>2]|0;if(!(a[m>>0]&1))v=m+1|0;else v=c[m+8>>2]|0;Krd(v,0,3653512,88,4,u,0,0);xri(m);xri(n)}}else{xri(j);xri(k);xri(l)}l=b+(d*12|0)+40|0;k=a[l>>0]|0;if(!(k&1))w=(k&255)>>>1;else w=c[b+(d*12|0)+44>>2]|0;if(!w){yri(l,e)|0;i=f;return}_ri(p,557384,e);yO(o,p,557288);if(!b)x=0;else x=c[b+4>>2]|0;if(!(a[o>>0]&1))y=o+1|0;else y=c[o+8>>2]|0;Krd(y,0,3653512,93,4,x,0,0);xri(o);xri(p);i=f;return}function MWb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+192|0;e=d+96|0;f=d+80|0;g=d+124|0;h=d+164|0;j=d+36|0;k=d+112|0;l=d+128|0;m=d+152|0;n=d+168|0;o=d+180|0;p=d+24|0;q=d+12|0;r=d;s=d+100|0;t=d+56|0;u=d+68|0;v=d+140|0;w=d+84|0;x=c[b+24>>2]|0;_Wb(x,c[x+4>>2]|0);c[x+8>>2]=0;y=x+4|0;c[x>>2]=y;c[y>>2]=0;y=c[b+28>>2]|0;$Wb(y,c[y+4>>2]|0);c[y+8>>2]=0;x=y+4|0;c[y>>2]=x;c[x>>2]=0;x=c[b+36>>2]|0;_Wb(x,c[x+4>>2]|0);c[x+8>>2]=0;y=x+4|0;c[x>>2]=y;c[y>>2]=0;y=0;do{x=b+(y*12|0)+40|0;if(!(a[x>>0]&1)){a[x+1>>0]=0;a[x>>0]=0}else{a[c[b+(y*12|0)+48>>2]>>0]=0;c[b+(y*12|0)+44>>2]=0}y=y+1|0}while((y|0)!=32);y=b+424|0;x=c[y>>2]|0;z=b+428|0;A=c[z>>2]|0;if((A|0)!=(x|0)){B=A;while(1){A=B+-20|0;c[z>>2]=A;if(!(a[A>>0]&1))C=A;else{A=c[B+-12>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(A,e);C=c[z>>2]|0}if((C|0)==(x|0))break;else B=C}};c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;C=j+12|0;c[C>>2]=1;a[j+16>>0]=0;do if((x|0)!=(c[b+432>>2]|0)){if(!x){c[z>>2]=20;break}a[x>>0]=0;a[x+1>>0]=0;B=x+12|0;c[B+0>>2]=c[C+0>>2];a[B+4>>0]=a[C+4>>0]|0;B=a[j>>0]|0;c[z>>2]=(c[z>>2]|0)+20;if(B&1){B=c[j+8>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(B,e)}}else dXb(y,j);while(0);j=c[y>>2]|0;a[k>>0]=14;y=k+1|0;a[y+0>>0]=a[3071232]|0;a[y+1>>0]=a[3071233]|0;a[y+2>>0]=a[3071234]|0;a[y+3>>0]=a[3071235]|0;a[y+4>>0]=a[3071236]|0;a[y+5>>0]=a[3071237]|0;a[y+6>>0]=a[3071238]|0;g=k+8|0;a[g>>0]=0;a:do if((j|0)!=(k|0)){z=a[j>>0]|0;do if(!(z&1))if(!(z&1))D=23;else D=22;else{C=c[j>>2]|0;x=C&-2;B=x+-1|0;h=(C&1|0)==0;if(B>>>0>=7)if(h){D=23;break}else{D=22;break}if(h)E=C>>>1&127;else E=c[j+4>>2]|0;eXb(j,B,8-x|0,E,0,E,7,y);break a}while(0);if((D|0)==22)F=c[j+8>>2]|0;else if((D|0)==23)F=j+1|0;aFi(F|0,y|0,7)|0;a[F+7>>0]=0;if(!(a[j>>0]&1)){a[j>>0]=14;break}else{c[j+4>>2]=7;break}}while(0);if(a[k>>0]&1){k=c[g>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e)}c[j+12>>2]=0;c[b+436>>2]=0;rri(l,557424,8);KWb(b,0,l);xri(l);rri(m,557440,7);KWb(b,1,m);xri(m);rri(n,557448,6);KWb(b,2,n);xri(n);rri(o,557456,10);KWb(b,3,o);xri(o);rri(p,557472,10);KWb(b,5,p);xri(p);rri(q,557488,14);KWb(b,7,q);xri(q);rri(r,557504,6);KWb(b,6,r);xri(r);rri(s,3071232,7);LWb(b,0,s);xri(s);rri(t,557512,13);LWb(b,1,t);xri(t);rri(u,557528,14);LWb(b,2,u);xri(u);rri(v,557544,5);LWb(b,4,v);xri(v);rri(w,557552,2);LWb(b,5,w);xri(w);i=d;return}function NWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=a+36|0;fXb(e,c[f>>2]|0,b);b=c[e>>2]|0;if((b|0)==((c[f>>2]|0)+4|0)){g=-1;i=d;return g|0}g=c[b+28>>2]|0;i=d;return g|0}function OWb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(b>>>0>31){Krd(557560,0,3653512,281,1,0,0,0);d=557128;i=c;return d|0}else{d=a+(b*12|0)+40|0;i=c;return d|0}return 0}function PWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;a:do if((b|0)!=0?(e=c[a+428>>2]|0,f=c[a+424>>2]|0,(e|0)!=(f|0)):0){g=0;while(1){if((c[f+(g*20|0)+12>>2]|0)==(b|0)){h=g;break}g=g+1|0;if(g>>>0>=((e-f|0)/20|0)>>>0){j=0;break a}}j=h-(c[a+436>>2]|0)|0}else j=0;while(0);i=d;return j|0}function QWb(){var a=0;a=i;QQb(78,89,0,0,0);i=a;return}function RWb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,557592,10);wQb(78,6,b,440,2601,0,0);xri(b);i=a;return}function SWb(a){a=a|0;return 78}function TWb(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,557592,a,0);hXb(a,b);bdd(b);i=c;return}function UWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,557592,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else iXb(a,b);sdd(b);i=d;return}function VWb(a,b){a=a|0;b=b|0;var c=0;c=i;jXb(a,b);i=c;return}function WWb(a,b){a=a|0;b=b|0;var c=0;c=i;kXb(a,b);i=c;return}function XWb(a,b){a=a|0;b=b|0;var c=0;c=i;lXb(a,b);i=c;return}function YWb(a,b){a=a|0;b=b|0;var c=0;c=i;mXb(a,b);i=c;return}function ZWb(){var a=0,b=0;a=i;b=rVb(2)|0;i=a;return b|0}function _Wb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}_Wb(a,c[b>>2]|0);_Wb(a,c[b+4>>2]|0);xri(b+16|0);c[f>>2]=1;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function $Wb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}$Wb(a,c[b>>2]|0);$Wb(a,c[b+4>>2]|0);xri(b+20|0);c[f>>2]=1;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function aXb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g;l=c[d>>2]|0;m=l;n=((c[e>>2]|0)-m|0)/20|0;e=l+(n*20|0)|0;o=d+4|0;p=c[o>>2]|0;q=c[d+8>>2]|0;if(p>>>0>=q>>>0){r=((p-m|0)/20|0)+1|0;if(r>>>0>214748364)vxi(d);m=l;s=(q-m|0)/20|0;if(s>>>0<107374182){q=s<<1;t=q>>>0<r>>>0?r:q}else t=214748364;q=e-m|0;m=(q|0)/20|0;r=k+12|0;c[r>>2]=0;c[k+16>>2]=d+8;if(!t)u=0;else u=xCi(t*20|0)|0;c[k>>2]=u;s=u+(m*20|0)|0;v=k+8|0;c[v>>2]=s;w=k+4|0;c[w>>2]=s;c[r>>2]=u+(t*20|0);do if((m|0)==(t|0)){x=(q|0)/20|0;if((q|0)>0){y=u+((m+((x+1|0)/-2|0)|0)*20|0)|0;c[v>>2]=y;c[w>>2]=y;z=y;break}y=x<<1;x=(y|0)==0?1:y;y=xCi(x*20|0)|0;A=y+((x>>>2)*20|0)|0;c[k>>2]=y;c[w>>2]=A;c[v>>2]=A;c[r>>2]=y+(x*20|0);if(!u)z=A;else{ACi(u);z=A}}else z=s;while(0);if(!z)B=0;else{s=a[f>>0]|0;if(!(s&1)){C=(s&255)>>>1;D=f+1|0}else{C=c[f+4>>2]|0;D=c[f+8>>2]|0}if(C>>>0>2147483631)ori(z);if(C>>>0<11){a[z>>0]=C<<1;E=z+1|0}else{s=C+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];u=cOb(s,16,h,0,3653512,80)|0;c[z+8>>2]=u;c[z>>2]=s|1;c[z+4>>2]=C;E=u}YEi(E|0,D|0,C|0)|0;a[E+C>>0]=0;C=z+12|0;z=f+12|0;c[C+0>>2]=c[z+0>>2];a[C+4>>0]=a[z+4>>0]|0;B=c[v>>2]|0}c[v>>2]=B+20;B=sXb(d,k,e)|0;z=c[w>>2]|0;w=c[v>>2]|0;if((w|0)!=(z|0)){C=w;do{w=C;C=C+-20|0;c[v>>2]=C;if(a[C>>0]&1){E=c[w+-12>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(E,h)}}while((C|0)!=(z|0))}z=c[k>>2]|0;if(!z){F=B;c[b>>2]=F;i=g;return}ACi(z);F=B;c[b>>2]=F;i=g;return}if((e|0)==(p|0)){if(!e)G=0;else{B=a[f>>0]|0;if(!(B&1)){H=(B&255)>>>1;I=f+1|0}else{H=c[f+4>>2]|0;I=c[f+8>>2]|0}if(H>>>0>2147483631)ori(e);if(H>>>0<11){a[e>>0]=H<<1;J=e+1|0}else{B=H+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];j=cOb(B,16,h,0,3653512,80)|0;c[l+(n*20|0)+8>>2]=j;c[e>>2]=B|1;c[l+(n*20|0)+4>>2]=H;J=j}YEi(J|0,I|0,H|0)|0;a[J+H>>0]=0;H=l+(n*20|0)+12|0;J=f+12|0;c[H+0>>2]=c[J+0>>2];a[H+4>>0]=a[J+4>>0]|0;G=c[o>>2]|0}c[o>>2]=G+20;F=e;c[b>>2]=F;i=g;return}rXb(d,e,p,l+((n+1|0)*20|0)|0);if(e>>>0>f>>>0)K=f;else K=(c[o>>2]|0)>>>0>f>>>0?f+20|0:f;do if((e|0)!=(K|0)){f=a[K>>0]|0;if(!(f&1)){L=(f&255)>>>1;M=K+1|0}else{L=c[K+4>>2]|0;M=c[K+8>>2]|0}f=a[e>>0]|0;if(!(f&1)){N=10;O=f}else{f=c[e>>2]|0;N=(f&-2)+-1|0;O=f&255}f=(O&1)==0;if(L>>>0>N>>>0){if(f)P=(O&255)>>>1;else P=c[l+(n*20|0)+4>>2]|0;eXb(e,N,L-N|0,P,0,P,L,M);break}if(f)Q=e+1|0;else Q=c[l+(n*20|0)+8>>2]|0;aFi(Q|0,M|0,L|0)|0;a[Q+L>>0]=0;if(!(a[e>>0]&1)){a[e>>0]=L<<1;break}else{c[l+(n*20|0)+4>>2]=L;break}}while(0);L=l+(n*20|0)+12|0;n=K+12|0;c[L+0>>2]=c[n+0>>2];a[L+4>>0]=a[n+4>>0]|0;F=e;c[b>>2]=F;i=g;return}function bXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=tXb(d,j,e)|0;l=c[k>>2]|0;if(l){m=0;n=l;c[b>>2]=n;o=b+4|0;a[o>>0]=m;i=f;return}c[h>>2]=1;c[g+0>>2]=c[h+0>>2];h=cOb(32,16,g,0,3653512,80)|0;sri(h+16|0,e);c[h+28>>2]=c[e+12>>2];e=c[j>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=e;c[k>>2]=h;e=c[c[d>>2]>>2]|0;if(!e)p=h;else{c[d>>2]=e;p=c[k>>2]|0}GN(c[d+4>>2]|0,p);p=d+8|0;c[p>>2]=(c[p>>2]|0)+1;m=1;n=h;c[b>>2]=n;o=b+4|0;a[o>>0]=m;i=f;return}function cXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d+4|0;l=c[k>>2]|0;do if(l){m=c[e>>2]|0;n=l;while(1){o=c[n+16>>2]|0;if(m>>>0<o>>>0){p=c[n>>2]|0;if(!p){q=n;r=n;s=5;break}else{n=p;continue}}if(o>>>0>=m>>>0){t=n;s=9;break}o=n+4|0;p=c[o>>2]|0;if(!p){u=o;v=n;s=8;break}else n=p}if((s|0)==5){c[j>>2]=r;w=q;x=r;break}else if((s|0)==8){c[j>>2]=v;w=u;x=v;break}else if((s|0)==9){c[j>>2]=t;w=j;x=t;break}}else{n=d+4|0;c[j>>2]=n;w=n;x=n}while(0);j=c[w>>2]|0;if(j){y=0;z=j;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}c[h>>2]=1;c[g+0>>2]=c[h+0>>2];h=cOb(32,16,g,0,3653512,80)|0;g=h+16|0;c[g>>2]=c[e>>2];sri(h+20|0,e+4|0);c[g>>2]=c[e>>2];c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=x;c[w>>2]=h;x=c[c[d>>2]>>2]|0;if(!x)B=h;else{c[d>>2]=x;B=c[w>>2]|0}GN(c[k>>2]|0,B);B=d+8|0;c[B>>2]=(c[B>>2]|0)+1;y=1;z=h;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}function dXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=b+4|0;k=c[b>>2]|0;l=(((c[j>>2]|0)-k|0)/20|0)+1|0;if(l>>>0>214748364)vxi(b);m=k;k=((c[b+8>>2]|0)-m|0)/20|0;if(k>>>0<107374182){n=k<<1;o=n>>>0<l>>>0?l:n}else o=214748364;n=((c[j>>2]|0)-m|0)/20|0;m=h+12|0;c[m>>2]=0;c[h+16>>2]=b+8;if(!o)p=0;else p=xCi(o*20|0)|0;c[h>>2]=p;j=p+(n*20|0)|0;l=h+8|0;c[l>>2]=j;k=h+4|0;c[k>>2]=j;c[m>>2]=p+(o*20|0);if(!j)q=0;else{o=a[d>>0]|0;if(!(o&1)){r=(o&255)>>>1;s=d+1|0}else{r=c[d+4>>2]|0;s=c[d+8>>2]|0}if(r>>>0>2147483631)ori(j);if(r>>>0<11){a[j>>0]=r<<1;t=j+1|0}else{o=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];m=cOb(o,16,f,0,3653512,80)|0;c[p+(n*20|0)+8>>2]=m;c[j>>2]=o|1;c[p+(n*20|0)+4>>2]=r;t=m}YEi(t|0,s|0,r|0)|0;a[t+r>>0]=0;r=p+(n*20|0)+12|0;n=d+12|0;c[r+0>>2]=c[n+0>>2];a[r+4>>0]=a[n+4>>0]|0;q=c[l>>2]|0}c[l>>2]=q+20;uXb(b,h);b=c[k>>2]|0;k=c[l>>2]|0;if((k|0)!=(b|0)){q=k;do{k=q;q=q+-20|0;c[l>>2]=q;if(a[q>>0]&1){n=c[k+-12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(n,f)}}while((q|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function eXb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+16|0;m=l+4|0;n=l;if((2147483630-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))o=b+1|0;else o=c[b+8>>2]|0;if(d>>>0<1073741799){p=e+d|0;e=d<<1;q=p>>>0<e>>>0?e:p;if(q>>>0<11)r=11;else r=q+16&-16}else r=2147483631;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];q=cOb(r,16,m,0,3653512,80)|0;if(g)YEi(q|0,o|0,g|0)|0;if(j)YEi(q+g|0,k|0,j|0)|0;k=f-h|0;if((k|0)!=(g|0))YEi(q+(j+g)|0,o+(h+g)|0,k-g|0)|0;if((d|0)==10){s=b+8|0;c[s>>2]=q;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=q+u|0;a[w>>0]=0;i=l;return}c[n>>2]=58;c[m+0>>2]=c[n+0>>2];eOb(o,m);s=b+8|0;c[s>>2]=q;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=q+u|0;a[w>>0]=0;i=l;return}function fXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[d+4>>2]|0;h=d+4|0;do if(g){d=a[e>>0]|0;j=(d&1)==0;k=(d&255)>>>1;d=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;n=j?k:m;o=j?d:l;p=h;q=g;a:while(1){r=q;while(1){s=r+16|0;t=a[s>>0]|0;if(!(t&1)){u=(t&255)>>>1;v=s+1|0}else{u=c[r+20>>2]|0;v=c[r+24>>2]|0}s=FEi(v,o,n>>>0<u>>>0?n:u)|0;if(!s){if(u>>>0>=n>>>0){w=r;break}}else if((s|0)>=0){w=r;break}r=c[r+4>>2]|0;if(!r){x=p;break a}}q=c[w>>2]|0;if(!q){x=w;break}else p=w}if((x|0)!=(h|0)){p=x+16|0;q=j?k:m;n=a[p>>0]|0;o=(n&1)==0;if(o)y=(n&255)>>>1;else y=c[x+20>>2]|0;if(o)z=p+1|0;else z=c[x+24>>2]|0;p=FEi(j?d:l,z,y>>>0<q>>>0?y:q)|0;if(!p){if(q>>>0<y>>>0)break}else if((p|0)<0)break;c[b>>2]=x;i=f;return}}while(0);c[b>>2]=h;i=f;return}function gXb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(440,e,1,16,3653512,77)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];HWb(f,e,b);i=d;return f|0}
function hXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+64|0;f=e+24|0;g=e+40|0;h=e+44|0;j=e+48|0;k=e+12|0;l=e;m=e+28|0;ddd(d,2);c[k>>2]=0;n=k+4|0;c[n>>2]=0;c[k+8>>2]=0;vXb(d,k,557608,2048);c[l>>2]=0;o=l+4|0;c[o>>2]=0;p=l+8|0;c[p>>2]=0;q=m+1|0;r=m+8|0;s=m+4|0;t=0;while(1){u=b+(t*12|0)+40|0;v=a[u>>0]|0;if(!(v&1)){w=(v&255)>>>1;x=u+1|0}else{w=c[b+(t*12|0)+44>>2]|0;x=c[b+(t*12|0)+48>>2]|0}if(w>>>0>2147483631){y=6;break}if(w>>>0<11){a[m>>0]=w<<1;z=q}else{u=w+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];v=cOb(u,16,f,0,3653512,80)|0;c[r>>2]=v;c[m>>2]=u|1;c[s>>2]=w;z=v}YEi(z|0,x|0,w|0)|0;a[z+w>>0]=0;A=c[o>>2]|0;if((A|0)==(c[p>>2]|0))wXb(l,m);else{if(!A)B=0;else{v=a[m>>0]|0;if(!(v&1)){C=(v&255)>>>1;D=q}else{C=c[s>>2]|0;D=c[r>>2]|0}if(C>>>0>2147483631){y=16;break}if(C>>>0<11){a[A>>0]=C<<1;E=A+1|0}else{v=C+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];u=cOb(v,16,f,0,3653512,80)|0;c[A+8>>2]=u;c[A>>2]=v|1;c[A+4>>2]=C;E=u}YEi(E|0,D|0,C|0)|0;a[E+C>>0]=0;B=c[o>>2]|0}c[o>>2]=B+12}if(a[m>>0]&1){u=c[r>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(u,f)}t=t+1|0;if((t|0)>=32){y=26;break}}if((y|0)==6)ori(m);else if((y|0)==16)ori(A);else if((y|0)==26){vXb(d,l,557656,2048);y=c[l>>2]|0;if(y){A=c[o>>2]|0;if((A|0)==(y|0))F=y;else{m=A;while(1){A=m+-12|0;c[o>>2]=A;if(!(a[A>>0]&1))G=A;else{A=c[m+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(A,f);G=c[o>>2]|0}if((G|0)==(y|0))break;else m=G}F=c[l>>2]|0}ACi(F)}xXb(d,b+424|0,557664,0);b=c[k>>2]|0;if(!b){i=e;return}d=c[n>>2]|0;if((d|0)==(b|0))H=b;else{F=d;while(1){d=F+-12|0;c[n>>2]=d;if(!(a[d>>0]&1))I=d;else{d=c[F+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(d,f);I=c[n>>2]|0}if((I|0)==(b|0))break;else F=I}H=c[k>>2]|0}ACi(H);i=e;return}}function iXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=i;i=i+544|0;f=e;g=e+40|0;h=e+16|0;j=e+20|0;k=e+36|0;l=e+24|0;m=e+4|0;n=e+104|0;o=e+488|0;p=e+500|0;q=e+512|0;r=e+524|0;rdd(d,2);c[l>>2]=0;s=l+4|0;c[s>>2]=0;c[l+8>>2]=0;MWb(b);t=c[142306]|0;u=qdd(d,557608,t,f,1)|0;if(u){if((u|0)<=0){u=c[f>>2]|0;if(u)_n[u&4095](l,d)|0}else yXb(d,l,0);sdd(d)}u=d+136|0;if((a[u>>0]|0)!=0?(v=c[s>>2]|0,w=c[l>>2]|0,(v|0)!=(w|0)):0){x=w;w=v;v=0;y=2e4;while(1){z=a[x+(v*12|0)>>0]|0;A=(z&1)==0;if(A)B=(z&255)>>>1;else B=c[x+(v*12|0)+4>>2]|0;if(!B){C=w;D=x;E=y}else{if(A){F=x+(v*12|0)+1|0;G=(z&255)>>>1}else{F=c[x+(v*12|0)+8>>2]|0;G=c[x+(v*12|0)+4>>2]|0}rri(m,F,G);KWb(b,y,m);xri(m);C=c[s>>2]|0;D=c[l>>2]|0;E=y+1|0}v=v+1|0;if(v>>>0>=((C-D|0)/12|0)>>>0)break;else{x=D;w=C;y=E}}}do if(!(wdd(d,1)|0)){c[p>>2]=0;E=p+4|0;c[E>>2]=0;y=p+8|0;c[y>>2]=0;C=q+1|0;w=q+8|0;D=q+4|0;x=0;while(1){v=b+(x*12|0)+40|0;m=a[v>>0]|0;if(!(m&1)){H=(m&255)>>>1;I=v+1|0}else{H=c[b+(x*12|0)+44>>2]|0;I=c[b+(x*12|0)+48>>2]|0}if(H>>>0>2147483631){J=60;break}if(H>>>0<11){a[q>>0]=H<<1;K=C}else{v=H+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];m=cOb(v,16,f,0,3653512,80)|0;c[w>>2]=m;c[q>>2]=v|1;c[D>>2]=H;K=m}YEi(K|0,I|0,H|0)|0;a[K+H>>0]=0;L=c[E>>2]|0;if((L|0)==(c[y>>2]|0))wXb(p,q);else{if(!L)M=0;else{m=a[q>>0]|0;if(!(m&1)){N=(m&255)>>>1;O=C}else{N=c[D>>2]|0;O=c[w>>2]|0}if(N>>>0>2147483631){J=70;break}if(N>>>0<11){a[L>>0]=N<<1;P=L+1|0}else{m=N+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];v=cOb(m,16,f,0,3653512,80)|0;c[L+8>>2]=v;c[L>>2]=m|1;c[L+4>>2]=N;P=v}YEi(P|0,O|0,N|0)|0;a[P+N>>0]=0;M=c[E>>2]|0}c[E>>2]=M+12}if(a[q>>0]&1){v=c[w>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(v,f)}x=x+1|0;if((x|0)>=32){J=80;break}}if((J|0)==60)ori(q);else if((J|0)==70)ori(L);else if((J|0)==80){x=qdd(d,557656,t,f,1)|0;if(x){if((x|0)<=0){x=c[f>>2]|0;if(x)_n[x&4095](p,d)|0}else yXb(d,p,0);sdd(d)}if(a[u>>0]|0){x=8;do{w=c[p>>2]|0;D=w+(x*12|0)|0;C=a[D>>0]|0;if(!(C&1)){Q=D+1|0;R=(C&255)>>>1}else{Q=c[w+(x*12|0)+8>>2]|0;R=c[w+(x*12|0)+4>>2]|0}rri(r,Q,R);LWb(b,x,r);xri(r);x=x+1|0}while((x|0)<32)}x=c[p>>2]|0;if(!x)break;w=c[E>>2]|0;if((w|0)==(x|0))S=x;else{C=w;while(1){w=C+-12|0;c[E>>2]=w;if(!(a[w>>0]&1))T=w;else{w=c[C+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(w,f);T=c[E>>2]|0}if((T|0)==(x|0))break;else C=T}S=c[p>>2]|0}ACi(S);break}}else{C=n+384|0;PEi(n|0,0,384)|0;x=c[142294]|0;E=0;do{w=(E|0)>7;if(w){c[f>>2]=E;rEi(g,64,557616,f)|0}else{c[f>>2]=E;rEi(g,64,557632,f)|0}D=n+(E*12|0)|0;y=b+(E*12|0)+40|0;v=a[y>>0]|0;if(!(v&1)){U=(v&255)>>>1;V=y+1|0}else{U=c[b+(E*12|0)+44>>2]|0;V=c[b+(E*12|0)+48>>2]|0}y=a[D>>0]|0;if(!(y&1)){W=10;X=y}else{y=c[D>>2]|0;W=(y&-2)+-1|0;X=y&255}y=(X&1)==0;do if(U>>>0<=W>>>0){if(y)Y=D+1|0;else Y=c[n+(E*12|0)+8>>2]|0;aFi(Y|0,V|0,U|0)|0;a[Y+U>>0]=0;if(!(a[D>>0]&1)){a[D>>0]=U<<1;break}else{c[n+(E*12|0)+4>>2]=U;break}}else{if(y)Z=(X&255)>>>1;else Z=c[n+(E*12|0)+4>>2]|0;eXb(D,W,U-W|0,Z,0,Z,U,V)}while(0);y=qdd(d,g,x,f,0)|0;if(y){if((y|0)<=0){y=c[f>>2]|0;if(y)_n[y&4095](D,d)|0}else zXb(d,D,1);sdd(d)}if((a[u>>0]|0)!=0&w){y=a[D>>0]|0;if(!(y&1)){_=D+1|0;$=(y&255)>>>1}else{_=c[n+(E*12|0)+8>>2]|0;$=c[n+(E*12|0)+4>>2]|0}rri(o,_,$);LWb(b,E,o);xri(o)}E=E+1|0}while((E|0)<32);E=C;do{x=E;E=E+-12|0;if(a[E>>0]&1){y=c[x+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(y,f)}}while((E|0)!=(n|0))}while(0);n=b+424|0;j=qdd(d,557664,t,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](n,d)|0}else AXb(d,n,0);sdd(d)}JWb(b);d=b+436|0;c[d>>2]=0;n=c[b+428>>2]|0;j=c[b+424>>2]|0;b=(n-j|0)/20|0;a:do if((n|0)!=(j|0)){t=0;while(1){if(!(c[j+(t*20|0)+12>>2]|0)){aa=t;break}t=t+1|0;if((t|0)==(b|0))break a}c[d>>2]=aa}while(0);aa=c[l>>2]|0;if(!aa){i=e;return}d=c[s>>2]|0;if((d|0)==(aa|0))ba=aa;else{b=d;while(1){d=b+-12|0;c[s>>2]=d;if(!(a[d>>0]&1))ca=d;else{d=c[b+-4>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(d,f);ca=c[s>>2]|0}if((ca|0)==(aa|0))break;else b=ca}ba=c[l>>2]|0}ACi(ba);i=e;return}function jXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+12|0;j=e+16|0;k=e+64|0;l=e;m=e+20|0;n=e+48|0;o=e+36|0;c[k>>2]=0;p=k+4|0;c[p>>2]=0;c[k+8>>2]=0;MWb(b);BXb(d,k,0);q=c[p>>2]|0;r=c[k>>2]|0;if((q|0)!=(r|0)){s=r;r=q;q=0;t=2e4;while(1){u=a[s+(q*12|0)>>0]|0;v=(u&1)==0;if(v)w=(u&255)>>>1;else w=c[s+(q*12|0)+4>>2]|0;if(!w){x=r;y=s;z=t}else{if(v){A=s+(q*12|0)+1|0;B=(u&255)>>>1}else{A=c[s+(q*12|0)+8>>2]|0;B=c[s+(q*12|0)+4>>2]|0}rri(l,A,B);KWb(b,t,l);xri(l);x=c[p>>2]|0;y=c[k>>2]|0;z=t+1|0}q=q+1|0;if(q>>>0>=((x-y|0)/12|0)>>>0)break;else{s=y;r=x;t=z}}}c[m>>2]=0;z=m+4|0;c[z>>2]=0;t=m+8|0;c[t>>2]=0;x=n+1|0;r=n+8|0;y=n+4|0;s=0;while(1){q=b+(s*12|0)+40|0;l=a[q>>0]|0;if(!(l&1)){C=(l&255)>>>1;D=q+1|0}else{C=c[b+(s*12|0)+44>>2]|0;D=c[b+(s*12|0)+48>>2]|0}if(C>>>0>2147483631){E=16;break}if(C>>>0<11){a[n>>0]=C<<1;F=x}else{q=C+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];l=cOb(q,16,f,0,3653512,80)|0;c[r>>2]=l;c[n>>2]=q|1;c[y>>2]=C;F=l}YEi(F|0,D|0,C|0)|0;a[F+C>>0]=0;G=c[z>>2]|0;if((G|0)==(c[t>>2]|0))wXb(m,n);else{if(!G)H=0;else{l=a[n>>0]|0;if(!(l&1)){I=(l&255)>>>1;J=x}else{I=c[y>>2]|0;J=c[r>>2]|0}if(I>>>0>2147483631){E=26;break}if(I>>>0<11){a[G>>0]=I<<1;K=G+1|0}else{l=I+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];q=cOb(l,16,f,0,3653512,80)|0;c[G+8>>2]=q;c[G>>2]=l|1;c[G+4>>2]=I;K=q}YEi(K|0,J|0,I|0)|0;a[K+I>>0]=0;H=c[z>>2]|0}c[z>>2]=H+12}if(a[n>>0]&1){q=c[r>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(q,f)}s=s+1|0;if((s|0)>=32){E=36;break}}if((E|0)==16)ori(n);else if((E|0)==26)ori(G);else if((E|0)==36){BXb(d,m,0);E=8;do{G=c[m>>2]|0;n=G+(E*12|0)|0;s=a[n>>0]|0;if(!(s&1)){L=n+1|0;M=(s&255)>>>1}else{L=c[G+(E*12|0)+8>>2]|0;M=c[G+(E*12|0)+4>>2]|0}rri(o,L,M);LWb(b,E,o);xri(o);E=E+1|0}while((E|0)<32);E=c[m>>2]|0;if(E){o=c[z>>2]|0;if((o|0)==(E|0))N=E;else{M=o;while(1){o=M+-12|0;c[z>>2]=o;if(!(a[o>>0]&1))O=o;else{o=c[M+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(o,f);O=c[z>>2]|0}if((O|0)==(E|0))break;else M=O}N=c[m>>2]|0}ACi(N)}CXb(d,b+424|0,0);JWb(b);d=b+436|0;c[d>>2]=0;N=c[b+428>>2]|0;m=c[b+424>>2]|0;b=(N-m|0)/20|0;a:do if((N|0)!=(m|0)){O=0;while(1){if(!(c[m+(O*20|0)+12>>2]|0)){P=O;break}O=O+1|0;if((O|0)==(b|0))break a}c[d>>2]=P}while(0);P=c[k>>2]|0;if(!P){i=e;return}d=c[p>>2]|0;if((d|0)==(P|0))Q=P;else{b=d;while(1){d=b+-12|0;c[p>>2]=d;if(!(a[d>>0]&1))R=d;else{d=c[b+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(d,f);R=c[p>>2]|0}if((R|0)==(P|0))break;else b=R}Q=c[k>>2]|0}ACi(Q);i=e;return}}function kXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+12|0;j=e+16|0;k=e+64|0;l=e;m=e+20|0;n=e+48|0;o=e+36|0;c[k>>2]=0;p=k+4|0;c[p>>2]=0;c[k+8>>2]=0;MWb(b);DXb(d,k,0);q=c[p>>2]|0;r=c[k>>2]|0;if((q|0)!=(r|0)){s=r;r=q;q=0;t=2e4;while(1){u=a[s+(q*12|0)>>0]|0;v=(u&1)==0;if(v)w=(u&255)>>>1;else w=c[s+(q*12|0)+4>>2]|0;if(!w){x=r;y=s;z=t}else{if(v){A=s+(q*12|0)+1|0;B=(u&255)>>>1}else{A=c[s+(q*12|0)+8>>2]|0;B=c[s+(q*12|0)+4>>2]|0}rri(l,A,B);KWb(b,t,l);xri(l);x=c[p>>2]|0;y=c[k>>2]|0;z=t+1|0}q=q+1|0;if(q>>>0>=((x-y|0)/12|0)>>>0)break;else{s=y;r=x;t=z}}}c[m>>2]=0;z=m+4|0;c[z>>2]=0;t=m+8|0;c[t>>2]=0;x=n+1|0;r=n+8|0;y=n+4|0;s=0;while(1){q=b+(s*12|0)+40|0;l=a[q>>0]|0;if(!(l&1)){C=(l&255)>>>1;D=q+1|0}else{C=c[b+(s*12|0)+44>>2]|0;D=c[b+(s*12|0)+48>>2]|0}if(C>>>0>2147483631){E=16;break}if(C>>>0<11){a[n>>0]=C<<1;F=x}else{q=C+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];l=cOb(q,16,f,0,3653512,80)|0;c[r>>2]=l;c[n>>2]=q|1;c[y>>2]=C;F=l}YEi(F|0,D|0,C|0)|0;a[F+C>>0]=0;G=c[z>>2]|0;if((G|0)==(c[t>>2]|0))wXb(m,n);else{if(!G)H=0;else{l=a[n>>0]|0;if(!(l&1)){I=(l&255)>>>1;J=x}else{I=c[y>>2]|0;J=c[r>>2]|0}if(I>>>0>2147483631){E=26;break}if(I>>>0<11){a[G>>0]=I<<1;K=G+1|0}else{l=I+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];q=cOb(l,16,f,0,3653512,80)|0;c[G+8>>2]=q;c[G>>2]=l|1;c[G+4>>2]=I;K=q}YEi(K|0,J|0,I|0)|0;a[K+I>>0]=0;H=c[z>>2]|0}c[z>>2]=H+12}if(a[n>>0]&1){q=c[r>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(q,f)}s=s+1|0;if((s|0)>=32){E=36;break}}if((E|0)==16)ori(n);else if((E|0)==26)ori(G);else if((E|0)==36){DXb(d,m,0);E=8;do{G=c[m>>2]|0;n=G+(E*12|0)|0;s=a[n>>0]|0;if(!(s&1)){L=n+1|0;M=(s&255)>>>1}else{L=c[G+(E*12|0)+8>>2]|0;M=c[G+(E*12|0)+4>>2]|0}rri(o,L,M);LWb(b,E,o);xri(o);E=E+1|0}while((E|0)<32);E=c[m>>2]|0;if(E){o=c[z>>2]|0;if((o|0)==(E|0))N=E;else{M=o;while(1){o=M+-12|0;c[z>>2]=o;if(!(a[o>>0]&1))O=o;else{o=c[M+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(o,f);O=c[z>>2]|0}if((O|0)==(E|0))break;else M=O}N=c[m>>2]|0}ACi(N)}EXb(d,b+424|0,0);JWb(b);d=b+436|0;c[d>>2]=0;N=c[b+428>>2]|0;m=c[b+424>>2]|0;b=(N-m|0)/20|0;a:do if((N|0)!=(m|0)){O=0;while(1){if(!(c[m+(O*20|0)+12>>2]|0)){P=O;break}O=O+1|0;if((O|0)==(b|0))break a}c[d>>2]=P}while(0);P=c[k>>2]|0;if(!P){i=e;return}d=c[p>>2]|0;if((d|0)==(P|0))Q=P;else{b=d;while(1){d=b+-12|0;c[p>>2]=d;if(!(a[d>>0]&1))R=d;else{d=c[b+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(d,f);R=c[p>>2]|0}if((R|0)==(P|0))break;else b=R}Q=c[k>>2]|0}ACi(Q);i=e;return}}function lXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+12|0;j=e+16|0;k=e+64|0;l=e;m=e+20|0;n=e+48|0;o=e+36|0;c[l>>2]=0;p=l+4|0;c[p>>2]=0;q=l+8|0;c[q>>2]=0;r=c[b+28>>2]|0;s=c[r+4>>2]|0;t=r+4|0;r=(s|0)==0;do if(!r){u=t;v=s;a:while(1){w=v;while(1){if((c[w+16>>2]|0)>>>0>=2e4){x=w;break}w=c[w+4>>2]|0;if(!w){y=u;break a}}v=c[x>>2]|0;if(!v){y=x;break}else u=x}b:do if(r)z=t;else{u=t;v=s;while(1){w=v;while(1){if((c[w+16>>2]|0)>>>0>3e4){A=w;break}w=c[w+4>>2]|0;if(!w){z=u;break b}}v=c[A>>2]|0;if(!v){z=A;break}else u=A}}while(0);if((y|0)!=(z|0)){u=m+1|0;v=m+8|0;w=m+4|0;B=y;while(1){C=B+20|0;D=a[C>>0]|0;if(!(D&1)){E=(D&255)>>>1;F=C+1|0}else{E=c[B+24>>2]|0;F=c[B+28>>2]|0}if(E>>>0>2147483631){G=17;break}if(E>>>0<11){a[m>>0]=E<<1;H=u}else{C=E+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];D=cOb(C,16,f,0,3653512,80)|0;c[v>>2]=D;c[m>>2]=C|1;c[w>>2]=E;H=D}YEi(H|0,F|0,E|0)|0;a[H+E>>0]=0;I=c[p>>2]|0;if((I|0)==(c[q>>2]|0))wXb(l,m);else{if(!I)J=0;else{D=a[m>>0]|0;if(!(D&1)){K=(D&255)>>>1;L=u}else{K=c[w>>2]|0;L=c[v>>2]|0}if(K>>>0>2147483631){G=27;break}if(K>>>0<11){a[I>>0]=K<<1;M=I+1|0}else{D=K+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];C=cOb(D,16,f,0,3653512,80)|0;c[I+8>>2]=C;c[I>>2]=D|1;c[I+4>>2]=K;M=C}YEi(M|0,L|0,K|0)|0;a[M+K>>0]=0;J=c[p>>2]|0}c[p>>2]=J+12}if(a[m>>0]&1){C=c[v>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(C,f)}C=c[B+4>>2]|0;if(!C){D=B;while(1){N=c[D+8>>2]|0;if((c[N>>2]|0)==(D|0)){O=N;break}else D=N}}else{D=C;while(1){N=c[D>>2]|0;if(!N){O=D;break}else D=N}}if((O|0)==(z|0)){G=41;break}else B=O}if((G|0)==17)ori(m);else if((G|0)==27)ori(I);else if((G|0)==41){P=c[l>>2]|0;Q=c[p>>2]|0;break}}else{P=0;Q=0}}else{P=0;Q=0}while(0);I=(Q-P|0)/12|0;c[f>>2]=I;m=d+12|0;O=c[m>>2]|0;z=O+4|0;j=d+20|0;if(z>>>0<(c[j>>2]|0)>>>0){c[O>>2]=I;c[m>>2]=z;R=P;S=Q}else{Gid(m,f,4);R=c[l>>2]|0;S=c[p>>2]|0}if((R|0)!=(S|0)){Q=R;do{FXb(d,Q,3142592,0);Q=Q+12|0}while((Q|0)!=(S|0))}c[n>>2]=0;S=n+4|0;c[S>>2]=0;Q=n+8|0;c[Q>>2]=0;R=o+1|0;P=o+8|0;z=o+4|0;I=0;while(1){O=b+(I*12|0)+40|0;J=a[O>>0]|0;if(!(J&1)){T=(J&255)>>>1;U=O+1|0}else{T=c[b+(I*12|0)+44>>2]|0;U=c[b+(I*12|0)+48>>2]|0}if(T>>>0>2147483631){G=52;break}if(T>>>0<11){a[o>>0]=T<<1;V=R}else{O=T+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];J=cOb(O,16,f,0,3653512,80)|0;c[P>>2]=J;c[o>>2]=O|1;c[z>>2]=T;V=J}YEi(V|0,U|0,T|0)|0;a[V+T>>0]=0;W=c[S>>2]|0;if((W|0)==(c[Q>>2]|0))wXb(n,o);else{if(!W)X=0;else{J=a[o>>0]|0;if(!(J&1)){Y=(J&255)>>>1;Z=R}else{Y=c[z>>2]|0;Z=c[P>>2]|0}if(Y>>>0>2147483631){G=62;break}if(Y>>>0<11){a[W>>0]=Y<<1;_=W+1|0}else{J=Y+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];O=cOb(J,16,f,0,3653512,80)|0;c[W+8>>2]=O;c[W>>2]=J|1;c[W+4>>2]=Y;_=O}YEi(_|0,Z|0,Y|0)|0;a[_+Y>>0]=0;X=c[S>>2]|0}c[S>>2]=X+12}if(a[o>>0]&1){O=c[P>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(O,f)}I=I+1|0;if((I|0)>=32){G=72;break}}if((G|0)==52)ori(o);else if((G|0)==62)ori(W);else if((G|0)==72){G=c[S>>2]|0;W=c[n>>2]|0;o=(G-W|0)/12|0;c[f>>2]=o;I=c[m>>2]|0;h=I+4|0;if(h>>>0<(c[j>>2]|0)>>>0){c[I>>2]=o;c[m>>2]=h;$=W;aa=G}else{Gid(m,f,4);$=c[n>>2]|0;aa=c[S>>2]|0}if(($|0)==(aa|0))ba=$;else{m=$;do{FXb(d,m,3142592,0);m=m+12|0}while((m|0)!=(aa|0));ba=c[n>>2]|0}if(ba){aa=c[S>>2]|0;if((aa|0)==(ba|0))ca=ba;else{m=aa;while(1){aa=m+-12|0;c[S>>2]=aa;if(!(a[aa>>0]&1))da=aa;else{aa=c[m+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(aa,f);da=c[S>>2]|0}if((da|0)==(ba|0))break;else m=da}ca=c[n>>2]|0}ACi(ca)}GXb(d,b+424|0,0);b=c[l>>2]|0;if(!b){i=e;return}d=c[p>>2]|0;if((d|0)==(b|0))ea=b;else{ca=d;while(1){d=ca+-12|0;c[p>>2]=d;if(!(a[d>>0]&1))fa=d;else{d=c[ca+-4>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(d,f);fa=c[p>>2]|0}if((fa|0)==(b|0))break;else ca=fa}ea=c[l>>2]|0}ACi(ea);i=e;return}}function mXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+12|0;j=d;c[h>>2]=0;k=h+4|0;c[k>>2]=0;l=h+8|0;c[l>>2]=0;m=j+1|0;n=j+8|0;o=j+4|0;p=0;while(1){q=b+(p*12|0)+40|0;r=a[q>>0]|0;if(!(r&1)){s=(r&255)>>>1;t=q+1|0}else{s=c[b+(p*12|0)+44>>2]|0;t=c[b+(p*12|0)+48>>2]|0}if(s>>>0>2147483631){u=6;break}if(s>>>0<11){a[j>>0]=s<<1;v=m}else{q=s+16&-16;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];r=cOb(q,16,e,0,3653512,80)|0;c[n>>2]=r;c[j>>2]=q|1;c[o>>2]=s;v=r}YEi(v|0,t|0,s|0)|0;a[v+s>>0]=0;w=c[k>>2]|0;if((w|0)==(c[l>>2]|0))wXb(h,j);else{if(!w)x=0;else{r=a[j>>0]|0;if(!(r&1)){y=(r&255)>>>1;z=m}else{y=c[o>>2]|0;z=c[n>>2]|0}if(y>>>0>2147483631){u=16;break}if(y>>>0<11){a[w>>0]=y<<1;A=w+1|0}else{r=y+16&-16;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];q=cOb(r,16,e,0,3653512,80)|0;c[w+8>>2]=q;c[w>>2]=r|1;c[w+4>>2]=y;A=q}YEi(A|0,z|0,y|0)|0;a[A+y>>0]=0;x=c[k>>2]|0}c[k>>2]=x+12}if(a[j>>0]&1){q=c[n>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(q,e)}p=p+1|0;if((p|0)>=32){u=26;break}}if((u|0)==6)ori(j);else if((u|0)==16)ori(w);else if((u|0)==26){u=c[h>>2]|0;if(!u){i=d;return}w=c[k>>2]|0;if((w|0)==(u|0))B=u;else{j=w;while(1){w=j+-12|0;c[k>>2]=w;if(!(a[w>>0]&1))C=w;else{w=c[j+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(w,e);C=c[k>>2]|0}if((C|0)==(u|0))break;else j=C}B=c[h>>2]|0}ACi(B);i=d;return}}function nXb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=557152;IWb(b);g=b+424|0;h=c[g>>2]|0;if(h){j=b+428|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-20|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-12>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[g>>2]|0}ACi(l)}l=b+40|0;g=b+424|0;do{g=g+-12|0;xri(g)}while((g|0)!=(l|0));ZSb(b);i=d;return}function oXb(a){a=a|0;var b=0;b=i;nXb(a);ACi(a);i=b;return}function pXb(a){a=a|0;return 1}function qXb(a){a=a|0;return}function rXb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+16|0;h=g+4|0;j=g;k=b+4|0;b=c[k>>2]|0;l=d+(((b-f|0)/20|0)*20|0)|0;a:do if(l>>>0<e>>>0){m=b;n=l;while(1){if(!m)o=0;else{p=a[n>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=n+1|0}else{q=c[n+4>>2]|0;r=c[n+8>>2]|0}if(q>>>0>2147483631)break;if(q>>>0<11){a[m>>0]=q<<1;s=m+1|0}else{p=q+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];t=cOb(p,16,h,0,3653512,80)|0;c[m+8>>2]=t;c[m>>2]=p|1;c[m+4>>2]=q;s=t}YEi(s|0,r|0,q|0)|0;a[s+q>>0]=0;t=m+12|0;p=n+12|0;c[t+0>>2]=c[p+0>>2];a[t+4>>0]=a[p+4>>0]|0;o=c[k>>2]|0}n=n+20|0;p=o+20|0;c[k>>2]=p;if(n>>>0>=e>>>0)break a;else m=p}ori(m)}while(0);if((b|0)==(f|0)){i=g;return}else{u=l;v=b}do{b=v;v=v+-20|0;l=u;u=u+-20|0;do if((b|0)!=(l|0)){f=a[u>>0]|0;if(!(f&1)){w=(f&255)>>>1;x=u+1|0}else{w=c[l+-16>>2]|0;x=c[l+-12>>2]|0}f=a[v>>0]|0;if(!(f&1)){y=10;z=f}else{f=c[v>>2]|0;y=(f&-2)+-1|0;z=f&255}f=(z&1)==0;if(w>>>0>y>>>0){if(f)A=(z&255)>>>1;else A=c[b+-16>>2]|0;eXb(v,y,w-y|0,A,0,A,w,x);break}if(f)B=v+1|0;else B=c[b+-12>>2]|0;aFi(B|0,x|0,w|0)|0;a[B+w>>0]=0;if(!(a[v>>0]&1)){a[v>>0]=w<<1;break}else{c[b+-16>>2]=w;break}}while(0);m=b+-8|0;f=l+-8|0;c[m+0>>2]=c[f+0>>2];a[m+4>>0]=a[f+4>>0]|0}while((u|0)!=(d|0));i=g;return}function sXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+16|0;g=f+4|0;h=f;j=d+4|0;k=c[j>>2]|0;l=c[b>>2]|0;a:do if((l|0)==(e|0))m=k;else{n=e;o=k;while(1){p=o+-20|0;q=n;n=n+-20|0;r=a[n>>0]|0;if(!(r&1)){s=(r&255)>>>1;t=n+1|0}else{s=c[q+-16>>2]|0;t=c[q+-12>>2]|0}if(s>>>0>2147483631)break;if(s>>>0<11){a[p>>0]=s<<1;u=p+1|0}else{r=s+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];v=cOb(r,16,g,0,3653512,80)|0;c[o+-12>>2]=v;c[p>>2]=r|1;c[o+-16>>2]=s;u=v}YEi(u|0,t|0,s|0)|0;a[u+s>>0]=0;v=o+-8|0;r=q+-8|0;c[v+0>>2]=c[r+0>>2];a[v+4>>0]=a[r+4>>0]|0;r=(c[j>>2]|0)+-20|0;c[j>>2]=r;if((n|0)==(l|0)){m=r;break a}else o=r}ori(p)}while(0);p=b+4|0;l=c[p>>2]|0;s=d+8|0;if((l|0)==(e|0)){w=m;x=c[b>>2]|0;c[b>>2]=w;c[j>>2]=x;y=c[p>>2]|0;z=c[s>>2]|0;c[p>>2]=z;c[s>>2]=y;A=b+8|0;B=d+12|0;C=c[A>>2]|0;D=c[B>>2]|0;c[A>>2]=D;c[B>>2]=C;E=c[j>>2]|0;c[d>>2]=E;i=f;return k|0}m=e;e=c[s>>2]|0;while(1){if(!e)F=0;else{u=a[m>>0]|0;if(!(u&1)){G=(u&255)>>>1;H=m+1|0}else{G=c[m+4>>2]|0;H=c[m+8>>2]|0}if(G>>>0>2147483631){I=19;break}if(G>>>0<11){a[e>>0]=G<<1;J=e+1|0}else{u=G+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];t=cOb(u,16,g,0,3653512,80)|0;c[e+8>>2]=t;c[e>>2]=u|1;c[e+4>>2]=G;J=t}YEi(J|0,H|0,G|0)|0;a[J+G>>0]=0;t=e+12|0;u=m+12|0;c[t+0>>2]=c[u+0>>2];a[t+4>>0]=a[u+4>>0]|0;F=c[s>>2]|0}m=m+20|0;u=F+20|0;c[s>>2]=u;if((m|0)==(l|0))break;else e=u}if((I|0)==19)ori(e);w=c[j>>2]|0;x=c[b>>2]|0;c[b>>2]=w;c[j>>2]=x;y=c[p>>2]|0;z=c[s>>2]|0;c[p>>2]=z;c[s>>2]=y;A=b+8|0;B=d+12|0;C=c[A>>2]|0;D=c[B>>2]|0;c[A>>2]=D;c[B>>2]=C;E=c[j>>2]|0;c[d>>2]=E;i=f;return k|0}function tXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;a:do if(!(h&1)){e=g;while(1){n=e+16|0;o=a[n>>0]|0;p=(o&1)==0;if(p){q=(o&255)>>>1;r=n+1|0}else{q=c[e+20>>2]|0;r=c[e+24>>2]|0}s=FEi(k,r,q>>>0<b>>>0?q:b)|0;if(!s){if(b>>>0<q>>>0)t=16}else if((s|0)<0)t=16;if((t|0)==16){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){w=(o&255)>>>1;x=n+1|0}else{w=c[e+20>>2]|0;x=c[e+24>>2]|0}n=FEi(x,k,b>>>0<w>>>0?b:w)|0;if(!n){if(w>>>0>=b>>>0){y=e;t=33;break a}}else if((n|0)>=0){y=e;t=33;break a}n=e+4|0;o=c[n>>2]|0;if(!o){z=n;A=e;t=32;break}else e=o}}else{e=g;while(1){o=e+16|0;n=a[o>>0]|0;p=(n&1)==0;if(p){B=(n&255)>>>1;C=o+1|0}else{B=c[e+20>>2]|0;C=c[e+24>>2]|0}s=FEi(l,C,B>>>0<m>>>0?B:m)|0;if(!s){if(m>>>0<B>>>0)t=23}else if((s|0)<0)t=23;if((t|0)==23){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){D=(n&255)>>>1;E=o+1|0}else{D=c[e+20>>2]|0;E=c[e+24>>2]|0}o=FEi(E,l,m>>>0<D>>>0?m:D)|0;if(!o){if(D>>>0>=m>>>0){y=e;t=33;break a}}else if((o|0)>=0){y=e;t=33;break a}o=e+4|0;n=c[o>>2]|0;if(!n){z=o;A=e;t=32;break}else e=n}}while(0);if((t|0)==24){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==32){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==33){c[d>>2]=y;j=d;i=f;return j|0}return 0}function uXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=n+-20|0;p=m;m=m+-20|0;q=a[m>>0]|0;if(!(q&1)){r=(q&255)>>>1;s=m+1|0}else{r=c[p+-16>>2]|0;s=c[p+-12>>2]|0}if(r>>>0>2147483631){t=8;break}if(r>>>0<11){a[o>>0]=r<<1;u=o+1|0}else{q=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];v=cOb(q,16,f,0,3653512,80)|0;c[n+-12>>2]=v;c[o>>2]=q|1;c[n+-16>>2]=r;u=v}YEi(u|0,s|0,r|0)|0;a[u+r>>0]=0;v=n+-8|0;q=p+-8|0;c[v+0>>2]=c[q+0>>2];a[v+4>>0]=a[q+4>>0]|0;q=(c[l>>2]|0)+-20|0;c[l>>2]=q;if((m|0)==(h|0)){w=q;t=13;break}else n=q}if((t|0)==8)ori(o);else if((t|0)==13){x=w;y=c[b>>2]|0;break}}else{x=c[l>>2]|0;y=h}while(0);c[b>>2]=x;c[l>>2]=y;y=d+8|0;x=c[j>>2]|0;c[j>>2]=c[y>>2];c[y>>2]=x;x=b+8|0;b=d+12|0;y=c[x>>2]|0;c[x>>2]=c[b>>2];c[b>>2]=y;c[d>>2]=c[l>>2];i=e;return}function vXb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g;add(b,e,c[142306]|0,d,f);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;$cd(b,2646336,2646336,g+12|0,0);add(b,3142592,c[142294]|0,k,0);$cd(b,2646336,2646336,h,1);add(b,3142592,c[142260]|0,j,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);cdd(b);if(!(a[k>>0]&1)){bdd(b);i=g;return}f=c[k+8>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(f,h);bdd(b);i=g;return}function wXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=b+4|0;k=c[b>>2]|0;l=(((c[j>>2]|0)-k|0)/12|0)+1|0;if(l>>>0>357913941)vxi(b);m=k;k=((c[b+8>>2]|0)-m|0)/12|0;if(k>>>0<178956970){n=k<<1;o=n>>>0<l>>>0?l:n}else o=357913941;n=((c[j>>2]|0)-m|0)/12|0;m=h+12|0;c[m>>2]=0;c[h+16>>2]=b+8;if(!o)p=0;else p=xCi(o*12|0)|0;c[h>>2]=p;j=p+(n*12|0)|0;l=h+8|0;c[l>>2]=j;k=h+4|0;c[k>>2]=j;c[m>>2]=p+(o*12|0);if(!j)q=0;else{o=a[d>>0]|0;if(!(o&1)){r=(o&255)>>>1;s=d+1|0}else{r=c[d+4>>2]|0;s=c[d+8>>2]|0}if(r>>>0>2147483631)ori(j);if(r>>>0<11){a[j>>0]=r<<1;t=j+1|0}else{d=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];o=cOb(d,16,f,0,3653512,80)|0;c[p+(n*12|0)+8>>2]=o;c[j>>2]=d|1;c[p+(n*12|0)+4>>2]=r;t=o}YEi(t|0,s|0,r|0)|0;a[t+r>>0]=0;q=c[l>>2]|0}c[l>>2]=q+12;HXb(b,h);b=c[k>>2]|0;k=c[l>>2]|0;if((k|0)!=(b|0)){q=k;do{k=q;q=q+-12|0;c[l>>2]=q;if(a[q>>0]&1){r=c[k+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(r,f)}}while((q|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function xXb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g;add(b,e,c[142306]|0,d,f);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=1;a[k+16>>0]=0;IXb(b,k,0);if(!(a[k>>0]&1)){bdd(b);i=g;return}f=c[k+8>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(f,h);bdd(b);i=g;return}function yXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/12|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}JXb(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142294]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;zXb(a,s,1);u=s+12|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,0)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else zXb(a,n,1);sdd(a)}n=n+12|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function zXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;k=a[d>>0]|0;if(!(k&1))l=(k&255)>>>1;else l=c[d+4>>2]|0;c[g>>2]=l;if(!(tdd(b,2646336,2646336,g)|0)){i=e;return}l=c[g>>2]|0;c[h>>2]=c[b+8>>2];c[f+0>>2]=c[h+0>>2];KXb(d,l,f);f=a[d>>0]|0;if(!(f&1)){m=d+1|0;n=(f&255)>>>1}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0}f=m+n|0;a:do if(c[g>>2]|0){n=qdd(b,3142592,c[142260]|0,0,0)|0;m=b+80|0;l=c[($hd(c[m>>2]|0)|0)+12>>2]|0;h=b+84|0;c[c[h>>2]>>2]=0;if((n|0)!=2){sdd(b);if(!(a[d>>0]&1))o=d+1|0;else o=c[d+8>>2]|0;if((o|0)==(f|0))break;else p=o;while(1){kVb(b,p,3142592,0);p=p+1|0;if((p|0)==(f|0))break a}}n=c[m>>2]|0;k=c[n+12>>2]|0;if(!(a[d>>0]&1))q=d+1|0;else q=c[d+8>>2]|0;b:do if((q|0)!=(f|0)){r=b+12|0;s=b+16|0;t=b+28|0;u=b+32|0;v=b+20|0;w=0;x=n;y=q;while(1){z=(da(w,l)|0)+k|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(j,x);z=j;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[h>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(A+(B+1)|0)>>>0<=(c[v>>2]|0)>>>0:0){a[y>>0]=a[z>>0]|0;c[r>>2]=(c[r>>2]|0)+1}else Bid(r,y,1);z=y+1|0;if((z|0)==(f|0))break b;w=c[c[h>>2]>>2]|0;x=c[m>>2]|0;y=z}}while(0);sdd(b)}while(0);udd(b);i=e;return}function AXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/20|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}LXb(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,557696,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;MXb(r,a);t=r+20|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,557696,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else MXb(m,a);sdd(a)}m=m+20|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function BXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}JXb(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{NXb(a,r,1);Ndd(a);r=r+12|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*12|0)|0;c[j>>2]=0;i=d;return}function CXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[h>>2]|0;q=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;p=l;q=n}n=p+4|0;if(n>>>0>q>>>0){Bid(h,e,4);r=c[e>>2]|0}else{q=c[p>>2]|0;c[e>>2]=q;c[h>>2]=n;r=q}zid(h,r,(c[f>>2]|0)*20|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);s=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;s=o}LXb(b,s);s=c[b+4>>2]|0;o=c[b>>2]|0;if((o|0)==(s|0)){i=d;return}else t=o;do{NXb(a,t,1);Ndd(a);o=t+12|0;b=c[h>>2]|0;l=b+4|0;if(l>>>0>(c[m>>2]|0)>>>0)Bid(h,o,4);else{c[o>>2]=c[b>>2];c[h>>2]=l}Ndd(a);t=t+20|0}while((t|0)!=(s|0));i=d;return}function DXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;JXb(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{OXb(a,r,1);Mdd(a);r=r+12|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*12|0)|0;c[j>>2]=0;i=d;return}function EXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{s=c[k>>2]|0;c[f>>2]=s;c[h>>2]=l;p=s;q=l;r=n}n=XEi(p|0)|0;c[f>>2]=n;p=q+4|0;if(p>>>0>r>>>0){Bid(h,e,4);t=c[e>>2]|0;u=c[f>>2]|0}else{f=c[q>>2]|0;c[e>>2]=f;c[h>>2]=p;t=f;u=n}n=XEi(t|0)|0;c[e>>2]=n;zid(h,n,u*20|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);v=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;v=o}o=XEi(v|0)|0;c[g>>2]=o;LXb(b,o);o=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(o|0)){i=d;return}else w=g;do{OXb(a,w,1);Mdd(a);g=w+12|0;b=c[h>>2]|0;v=b+4|0;if(v>>>0>(c[m>>2]|0)>>>0){Bid(h,g,4);x=c[g>>2]|0}else{l=c[b>>2]|0;c[g>>2]=l;c[h>>2]=v;x=l}c[g>>2]=XEi(x|0)|0;Mdd(a);w=w+20|0}while((w|0)!=(o|0));i=d;return}function FXb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f;g=a[d>>0]|0;if(!(g&1))h=(g&255)>>>1;else h=c[d+4>>2]|0;c[e>>2]=h;g=b+12|0;j=c[g>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=h;c[g>>2]=k}else Gid(g,e,4);e=a[d>>0]|0;if(!(e&1)){m=d+1|0;n=d+((e&255)>>>1)+1|0}else{e=c[d+8>>2]|0;m=e;n=e+(c[d+4>>2]|0)|0}if((m|0)==(n|0)){Tdd(b);i=f;return}else o=m;do{m=c[g>>2]|0;if((m+1|0)>>>0<(c[l>>2]|0)>>>0){a[m>>0]=a[o>>0]|0;c[g>>2]=(c[g>>2]|0)+1}else Gid(g,o,1);o=o+1|0}while((o|0)!=(n|0));Tdd(b);i=f;return}function GXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=b+4|0;g=c[f>>2]|0;h=c[b>>2]|0;j=(g-h|0)/20|0;c[e>>2]=j;k=a+12|0;l=c[k>>2]|0;m=l+4|0;n=a+20|0;if(m>>>0<(c[n>>2]|0)>>>0){c[l>>2]=j;c[k>>2]=m;o=h;p=g}else{Gid(k,e,4);o=c[b>>2]|0;p=c[f>>2]|0}if((o|0)==(p|0)){i=d;return}else q=o;do{FXb(a,q,3147344,0);o=q+12|0;f=c[k>>2]|0;b=f+4|0;if(b>>>0<(c[n>>2]|0)>>>0){c[f>>2]=c[o>>2];c[k>>2]=b}else Gid(k,o,4);Tdd(a);q=q+20|0}while((q|0)!=(p|0));i=d;return}function HXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=n+-12|0;p=m;m=m+-12|0;q=a[m>>0]|0;if(!(q&1)){r=(q&255)>>>1;s=m+1|0}else{r=c[p+-8>>2]|0;s=c[p+-4>>2]|0}if(r>>>0>2147483631){t=8;break}if(r>>>0<11){a[o>>0]=r<<1;u=o+1|0}else{p=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];q=cOb(p,16,f,0,3653512,80)|0;c[n+-4>>2]=q;c[o>>2]=p|1;c[n+-8>>2]=r;u=q}YEi(u|0,s|0,r|0)|0;a[u+r>>0]=0;q=(c[l>>2]|0)+-12|0;c[l>>2]=q;if((m|0)==(h|0)){v=q;t=13;break}else n=q}if((t|0)==8)ori(o);else if((t|0)==13){w=v;x=c[b>>2]|0;break}}else{w=c[l>>2]|0;x=h}while(0);c[b>>2]=w;c[l>>2]=x;x=d+8|0;w=c[j>>2]|0;c[j>>2]=c[x>>2];c[x>>2]=w;w=b+8|0;b=d+12|0;x=c[w>>2]|0;c[w>>2]=c[b>>2];c[b>>2]=x;c[d>>2]=c[l>>2];i=e;return}function IXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;$cd(a,2646336,2646336,e,d);add(a,3142592,557696,b,0);add(a,3147344,c[142294]|0,b,0);$cd(a,2646336,2646336,e+4|0,1);add(a,3142592,c[142260]|0,e+8|0,0);d=a+12|0;f=a+20|0;c[(c[c[d>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(a);cdd(a);fdd(a);bdd(a);add(a,557680,c[142304]|0,b+12|0,0);c[(c[c[d>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(a);fdd(a);bdd(a);cdd(a);i=e;return}function JXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e+52|0;g=e+16|0;h=e+36|0;j=e+4|0;k=e+40|0;l=e;m=e+12|0;n=e+24|0;o=e+20|0;p=e+8|0;q=e+56|0;r=b+4|0;s=c[b>>2]|0;t=s;u=((c[r>>2]|0)-t|0)/12|0;if(u>>>0>=d>>>0){if(u>>>0<=d>>>0){i=e;return}c[o>>2]=s;c[p>>2]=s+(d*12|0);c[g+0>>2]=c[o+0>>2];c[f+0>>2]=c[p+0>>2];SXb(n,g,f,q,0);q=c[n>>2]|0;p=c[b>>2]|0;c[n>>2]=p;c[b>>2]=q;q=n+4|0;o=c[q>>2]|0;s=c[r>>2]|0;c[q>>2]=s;c[r>>2]=o;o=n+8|0;v=b+8|0;w=c[o>>2]|0;c[o>>2]=c[v>>2];c[v>>2]=w;if(!p){i=e;return}if((s|0)==(p|0))x=p;else{w=s;while(1){s=w+-12|0;c[q>>2]=s;if(!(a[s>>0]&1))y=s;else{s=c[w+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(s,f);y=c[q>>2]|0}if((y|0)==(p|0))break;else w=y}x=c[n>>2]|0}ACi(x);i=e;return}x=b+8|0;if((((c[x>>2]|0)-t|0)/12|0|0)==(d|0)){RXb(b,d-u|0);i=e;return}c[k>>2]=0;u=k+4|0;c[u>>2]=0;t=k+8|0;c[t>>2]=0;PXb(k,d);c[l>>2]=c[b>>2];c[m>>2]=c[r>>2];c[g+0>>2]=c[l+0>>2];c[f+0>>2]=c[m+0>>2];QXb(k,g,f);m=c[u>>2]|0;l=c[k>>2]|0;n=(m-l|0)/12|0;if(n>>>0>=d>>>0)if(n>>>0>d>>>0?(y=l+(d*12|0)|0,(m|0)!=(y|0)):0){l=m;while(1){w=l+-12|0;c[u>>2]=w;if(!(a[w>>0]&1))z=w;else{w=c[l+-4>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(w,f);z=c[u>>2]|0}if((z|0)==(y|0)){A=y;break}else l=z}}else A=m;else{RXb(k,d-n|0);A=c[u>>2]|0}n=c[k>>2]|0;d=c[b>>2]|0;c[k>>2]=d;c[b>>2]=n;n=c[r>>2]|0;c[u>>2]=n;c[r>>2]=A;A=c[t>>2]|0;c[t>>2]=c[x>>2];c[x>>2]=A;if(!d){i=e;return}if((n|0)==(d|0))B=d;else{A=n;while(1){n=A+-12|0;c[u>>2]=n;if(!(a[n>>0]&1))C=n;else{n=c[A+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(n,f);C=c[u>>2]|0}if((C|0)==(d|0))break;else A=C}B=c[k>>2]|0}ACi(B);i=e;return}function KXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=a[b>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[b+4>>2]|0;if(h>>>0>=d>>>0)if(g){a[b+d+1>>0]=0;a[b>>0]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d>>0]=0;c[b+4>>2]=d;i=e;return}j=d-h|0;if((h|0)==(d|0)){i=e;return}if(g){k=f;l=10}else{f=c[b>>2]|0;k=f&255;l=(f&-2)+-1|0}if(!(k&1))m=(k&255)>>>1;else m=c[b+4>>2]|0;if((l-m|0)>>>0<j>>>0){TXb(b,l,j-l+m|0,m,m,0,0);n=a[b>>0]|0}else n=k;if(!(n&1))o=b+1|0;else o=c[b+8>>2]|0;PEi(o+m|0,1,j|0)|0;n=m+j|0;if(!(a[b>>0]&1))a[b>>0]=n<<1;else c[b+4>>2]=n;a[o+n>>0]=0;i=e;return}function LXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e+52|0;g=e+16|0;h=e+36|0;j=e+4|0;k=e+40|0;l=e;m=e+12|0;n=e+24|0;o=e+20|0;p=e+8|0;q=e+56|0;r=b+4|0;s=c[b>>2]|0;t=s;u=((c[r>>2]|0)-t|0)/20|0;if(u>>>0>=d>>>0){if(u>>>0<=d>>>0){i=e;return}c[o>>2]=s;c[p>>2]=s+(d*20|0);c[g+0>>2]=c[o+0>>2];c[f+0>>2]=c[p+0>>2];XXb(n,g,f,q,0);q=c[n>>2]|0;p=c[b>>2]|0;c[n>>2]=p;c[b>>2]=q;q=n+4|0;o=c[q>>2]|0;s=c[r>>2]|0;c[q>>2]=s;c[r>>2]=o;o=n+8|0;v=b+8|0;w=c[o>>2]|0;c[o>>2]=c[v>>2];c[v>>2]=w;if(!p){i=e;return}if((s|0)==(p|0))x=p;else{w=s;while(1){s=w+-20|0;c[q>>2]=s;if(!(a[s>>0]&1))y=s;else{s=c[w+-12>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(s,f);y=c[q>>2]|0}if((y|0)==(p|0))break;else w=y}x=c[n>>2]|0}ACi(x);i=e;return}x=b+8|0;if((((c[x>>2]|0)-t|0)/20|0|0)==(d|0)){WXb(b,d-u|0);i=e;return}c[k>>2]=0;u=k+4|0;c[u>>2]=0;t=k+8|0;c[t>>2]=0;UXb(k,d);c[l>>2]=c[b>>2];c[m>>2]=c[r>>2];c[g+0>>2]=c[l+0>>2];c[f+0>>2]=c[m+0>>2];VXb(k,g,f);m=c[u>>2]|0;l=c[k>>2]|0;n=(m-l|0)/20|0;if(n>>>0>=d>>>0)if(n>>>0>d>>>0?(y=l+(d*20|0)|0,(m|0)!=(y|0)):0){l=m;while(1){w=l+-20|0;c[u>>2]=w;if(!(a[w>>0]&1))z=w;else{w=c[l+-12>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(w,f);z=c[u>>2]|0}if((z|0)==(y|0)){A=y;break}else l=z}}else A=m;else{WXb(k,d-n|0);A=c[u>>2]|0}n=c[k>>2]|0;d=c[b>>2]|0;c[k>>2]=d;c[b>>2]=n;n=c[r>>2]|0;c[u>>2]=n;c[r>>2]=A;A=c[t>>2]|0;c[t>>2]=c[x>>2];c[x>>2]=A;if(!d){i=e;return}if((n|0)==(d|0))B=d;else{A=n;while(1){n=A+-20|0;c[u>>2]=n;if(!(a[n>>0]&1))C=n;else{n=c[A+-12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(n,f);C=c[u>>2]|0}if((C|0)==(d|0))break;else A=C}B=c[k>>2]|0}ACi(B);i=e;return}function MXb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=qdd(b,3147344,c[142294]|0,e,0)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else zXb(b,a,1);sdd(b)}f=a+12|0;a=qdd(b,557680,c[142304]|0,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[a>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[j>>2];c[a>>2]=k}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function NXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+12|0;m=b+48|0;n=c[l>>2]|0;o=n+4|0;p=b+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[l>>2]|0;t=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;s=o;t=q}q=s+4|0;if(q>>>0>t>>>0){Bid(l,g,4);u=c[g>>2]|0}else{t=c[s>>2]|0;c[g>>2]=t;c[l>>2]=q;u=t}zid(l,u,c[h>>2]|0)|0;c[m>>2]=0;i=e;return}if(r){Bid(l,j,4);v=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;v=r}c[k>>2]=c[b+8>>2];c[f+0>>2]=c[k+0>>2];KXb(d,v,f);f=c[j>>2]|0;if(!f){i=e;return}if(!(a[d>>0]&1))w=d+1|0;else w=c[d+8>>2]|0;Ldd(b,w,f);i=e;return}function OXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+12|0;m=b+48|0;n=c[l>>2]|0;o=n+4|0;p=b+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[h>>2]|0;t=c[l>>2]|0;u=c[p>>2]|0}else{v=c[n>>2]|0;c[h>>2]=v;c[l>>2]=o;s=v;t=o;u=q}q=XEi(s|0)|0;c[h>>2]=q;s=t+4|0;if(s>>>0>u>>>0){Bid(l,g,4);w=c[g>>2]|0;x=c[h>>2]|0}else{h=c[t>>2]|0;c[g>>2]=h;c[l>>2]=s;w=h;x=q}q=XEi(w|0)|0;c[g>>2]=q;zid(l,q,x)|0;c[m>>2]=0;i=e;return}if(r){Bid(l,j,4);y=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;y=r}r=XEi(y|0)|0;c[j>>2]=r;c[k>>2]=c[b+8>>2];c[f+0>>2]=c[k+0>>2];KXb(d,r,f);f=a[d>>0]|0;if(!(f&1)){z=d+1|0;A=d+((f&255)>>>1)+1|0}else{f=c[d+8>>2]|0;z=f;A=f+(c[d+4>>2]|0)|0}if((z|0)==(A|0)){i=e;return}else B=z;do{z=c[l>>2]|0;if((z+1|0)>>>0>(c[p>>2]|0)>>>0)Bid(l,B,1);else{a[B>>0]=a[z>>0]|0;c[l>>2]=(c[l>>2]|0)+1}B=B+1|0}while((B|0)!=(A|0));i=e;return}function PXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=c[b>>2]|0;if((((c[b+8>>2]|0)-j|0)/12|0)>>>0>=d>>>0){i=e;return}k=((c[b+4>>2]|0)-j|0)/12|0;j=h+12|0;c[j>>2]=0;c[h+16>>2]=b+8;if(!d)l=0;else l=xCi(d*12|0)|0;c[h>>2]=l;m=l+(k*12|0)|0;k=h+8|0;c[k>>2]=m;n=h+4|0;c[n>>2]=m;c[j>>2]=l+(d*12|0);HXb(b,h);b=c[n>>2]|0;n=c[k>>2]|0;if((n|0)!=(b|0)){d=n;do{n=d;d=d+-12|0;c[k>>2]=d;if(a[d>>0]&1){l=c[n+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f)}}while((d|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function QXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d>>2]|0;d=c[e>>2]|0;l=k;m=(d-l|0)/12|0;n=b+8|0;o=c[n>>2]|0;p=c[b>>2]|0;q=p;if(m>>>0>((o-q|0)/12|0)>>>0){if(!p)r=o;else{o=b+4|0;s=c[o>>2]|0;if((s|0)==(p|0))t=p;else{u=s;while(1){s=u+-12|0;c[o>>2]=s;if(!(a[s>>0]&1))v=s;else{s=c[u+-4>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(s,g);v=c[o>>2]|0}if((v|0)==(p|0))break;else u=v}t=c[b>>2]|0}ACi(t);c[n>>2]=0;c[o>>2]=0;c[b>>2]=0;r=0}if(m>>>0>357913941)vxi(b);o=(r-0|0)/12|0;if(o>>>0<178956970){r=o<<1;o=r>>>0<m>>>0?m:r;if(o>>>0>357913941)vxi(b);else w=o}else w=357913941;o=xCi(w*12|0)|0;r=b+4|0;c[r>>2]=o;c[b>>2]=o;c[n>>2]=o+(w*12|0);if((k|0)==(d|0)){i=f;return}w=k;n=o;while(1){o=a[w>>0]|0;if(!(o&1)){x=(o&255)>>>1;y=w+1|0}else{x=c[w+4>>2]|0;y=c[w+8>>2]|0}if(x>>>0>2147483631){z=63;break}if(x>>>0<11){a[n>>0]=x<<1;A=n+1|0}else{o=x+16&-16;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];t=cOb(o,16,g,0,3653512,80)|0;c[n+8>>2]=t;c[n>>2]=o|1;c[n+4>>2]=x;A=t}YEi(A|0,y|0,x|0)|0;a[A+x>>0]=0;t=(c[r>>2]|0)+12|0;c[r>>2]=t;w=w+12|0;if((w|0)==(d|0)){z=68;break}else n=t}if((z|0)==63)ori(n);else if((z|0)==68){i=f;return}}n=b+4|0;b=((c[n>>2]|0)-q|0)/12|0;if(m>>>0>b>>>0){B=k+(b*12|0)|0;C=1}else{B=d;C=0}if((k|0)==(B|0))D=p;else{d=((B+-12-l|0)>>>0)/12|0;l=p;b=k;while(1){do if((l|0)!=(b|0)){k=a[b>>0]|0;if(!(k&1)){E=(k&255)>>>1;F=b+1|0}else{E=c[b+4>>2]|0;F=c[b+8>>2]|0}k=a[l>>0]|0;if(!(k&1)){G=10;H=k}else{k=c[l>>2]|0;G=(k&-2)+-1|0;H=k&255}k=(H&1)==0;if(E>>>0>G>>>0){if(k)I=(H&255)>>>1;else I=c[l+4>>2]|0;eXb(l,G,E-G|0,I,0,I,E,F);break}if(k)J=l+1|0;else J=c[l+8>>2]|0;aFi(J|0,F|0,E|0)|0;a[J+E>>0]=0;if(!(a[l>>0]&1)){a[l>>0]=E<<1;break}else{c[l+4>>2]=E;break}}while(0);b=b+12|0;if((b|0)==(B|0))break;else l=l+12|0}D=p+((d+1|0)*12|0)|0}if(!C){C=c[n>>2]|0;if((C|0)==(D|0)){i=f;return}d=C;while(1){C=d+-12|0;c[n>>2]=C;if(!(a[C>>0]&1))K=C;else{C=c[d+-4>>2]|0;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];eOb(C,g);K=c[n>>2]|0}if((K|0)==(D|0))break;else d=K}i=f;return}K=c[e>>2]|0;if((B|0)==(K|0)){i=f;return}e=c[n>>2]|0;d=B;while(1){if(!e)L=0;else{B=a[d>>0]|0;if(!(B&1)){M=d+1|0;N=(B&255)>>>1}else{M=c[d+8>>2]|0;N=c[d+4>>2]|0}if(N>>>0>2147483631){z=33;break}if(N>>>0<11){a[e>>0]=N<<1;O=e+1|0}else{B=N+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];D=cOb(B,16,g,0,3653512,80)|0;c[e+8>>2]=D;c[e>>2]=B|1;c[e+4>>2]=N;O=D}YEi(O|0,M|0,N|0)|0;a[O+N>>0]=0;L=c[n>>2]|0}D=L+12|0;c[n>>2]=D;d=d+12|0;if((d|0)==(K|0)){z=68;break}else e=D}if((z|0)==33)ori(e);else if((z|0)==68){i=f;return}}function RXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=c[b+8>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/12|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;p=c[k>>2]|0}o=p+12|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=((m-n|0)/12|0)+d|0;if(o>>>0>357913941)vxi(b);m=n;n=(j-m|0)/12|0;if(n>>>0<178956970){j=n<<1;q=j>>>0<o>>>0?o:j}else q=357913941;j=((c[k>>2]|0)-m|0)/12|0;m=h+12|0;c[m>>2]=0;c[h+16>>2]=b+8;if(!q)r=0;else r=xCi(q*12|0)|0;c[h>>2]=r;k=r+(j*12|0)|0;j=h+8|0;c[j>>2]=k;o=h+4|0;c[o>>2]=k;c[m>>2]=r+(q*12|0);q=d;d=k;while(1){if(!d)s=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;s=d}k=s+12|0;q=q+-1|0;if(!q){t=k;break}else d=k}c[j>>2]=t;HXb(b,h);b=c[o>>2]|0;o=c[j>>2]|0;if((o|0)!=(b|0)){t=o;do{o=t;t=t+-12|0;c[j>>2]=t;if(a[t>>0]&1){d=c[o+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(d,f)}}while((t|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function SXb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;m=(e|0)/12|0;if((d|0)==(l|0)){i=g;return}if(m>>>0>357913941)vxi(b);n=xCi(e)|0;c[j>>2]=n;c[b>>2]=n;c[k>>2]=n+(m*12|0);m=l;l=n;while(1){n=a[m>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=m+1|0}else{o=c[m+4>>2]|0;p=c[m+8>>2]|0}if(o>>>0>2147483631){q=9;break}if(o>>>0<11){a[l>>0]=o<<1;r=l+1|0}else{n=o+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];k=cOb(n,16,f,0,3653512,80)|0;c[l+8>>2]=k;c[l>>2]=n|1;c[l+4>>2]=o;r=k}YEi(r|0,p|0,o|0)|0;a[r+o>>0]=0;k=(c[j>>2]|0)+12|0;c[j>>2]=k;m=m+12|0;if((m|0)==(d|0)){q=14;break}else l=k}if((q|0)==9)ori(l);else if((q|0)==14){i=g;return}}function TXb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+16|0;l=k+4|0;m=k;if((2147483631-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))n=b+1|0;else n=c[b+8>>2]|0;if(d>>>0<1073741799){o=e+d|0;e=d<<1;p=o>>>0<e>>>0?e:o;if(p>>>0<11)q=11;else q=p+16&-16}else q=2147483631;c[m>>2]=58;c[l+0>>2]=c[m+0>>2];p=cOb(q,16,l,0,3653512,80)|0;if(g)YEi(p|0,n|0,g|0)|0;o=f-h|0;if((o|0)!=(g|0))YEi(p+(j+g)|0,n+(h+g)|0,o-g|0)|0;if((d|0)==10){r=b+8|0;c[r>>2]=p;s=q|1;c[b>>2]=s;i=k;return}c[m>>2]=58;c[l+0>>2]=c[m+0>>2];eOb(n,l);r=b+8|0;c[r>>2]=p;s=q|1;c[b>>2]=s;i=k;return}function UXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=c[b>>2]|0;if((((c[b+8>>2]|0)-j|0)/20|0)>>>0>=d>>>0){i=e;return}k=((c[b+4>>2]|0)-j|0)/20|0;j=h+12|0;c[j>>2]=0;c[h+16>>2]=b+8;if(!d)l=0;else l=xCi(d*20|0)|0;c[h>>2]=l;m=l+(k*20|0)|0;k=h+8|0;c[k>>2]=m;n=h+4|0;c[n>>2]=m;c[j>>2]=l+(d*20|0);uXb(b,h);b=c[n>>2]|0;n=c[k>>2]|0;if((n|0)!=(b|0)){d=n;do{n=d;d=d+-20|0;c[k>>2]=d;if(a[d>>0]&1){l=c[n+-12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f)}}while((d|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function VXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d>>2]|0;d=c[e>>2]|0;l=k;m=(d-l|0)/20|0;n=b+8|0;o=c[n>>2]|0;p=c[b>>2]|0;q=p;if(m>>>0>((o-q|0)/20|0)>>>0){if(!p)r=o;else{o=b+4|0;s=c[o>>2]|0;if((s|0)==(p|0))t=p;else{u=s;while(1){s=u+-20|0;c[o>>2]=s;if(!(a[s>>0]&1))v=s;else{s=c[u+-12>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(s,g);v=c[o>>2]|0}if((v|0)==(p|0))break;else u=v}t=c[b>>2]|0}ACi(t);c[n>>2]=0;c[o>>2]=0;c[b>>2]=0;r=0}if(m>>>0>214748364)vxi(b);o=(r-0|0)/20|0;if(o>>>0<107374182){r=o<<1;o=r>>>0<m>>>0?m:r;if(o>>>0>214748364)vxi(b);else w=o}else w=214748364;o=xCi(w*20|0)|0;r=b+4|0;c[r>>2]=o;c[b>>2]=o;c[n>>2]=o+(w*20|0);if((k|0)==(d|0)){i=f;return}w=k;n=o;while(1){o=a[w>>0]|0;if(!(o&1)){x=(o&255)>>>1;y=w+1|0}else{x=c[w+4>>2]|0;y=c[w+8>>2]|0}if(x>>>0>2147483631){z=63;break}if(x>>>0<11){a[n>>0]=x<<1;A=n+1|0}else{o=x+16&-16;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];t=cOb(o,16,g,0,3653512,80)|0;c[n+8>>2]=t;c[n>>2]=o|1;c[n+4>>2]=x;A=t}YEi(A|0,y|0,x|0)|0;a[A+x>>0]=0;t=n+12|0;o=w+12|0;c[t+0>>2]=c[o+0>>2];a[t+4>>0]=a[o+4>>0]|0;o=(c[r>>2]|0)+20|0;c[r>>2]=o;w=w+20|0;if((w|0)==(d|0)){z=68;break}else n=o}if((z|0)==63)ori(n);else if((z|0)==68){i=f;return}}n=b+4|0;b=((c[n>>2]|0)-q|0)/20|0;if(m>>>0>b>>>0){B=k+(b*20|0)|0;C=1}else{B=d;C=0}if((k|0)==(B|0))D=p;else{d=((B+-20-l|0)>>>0)/20|0;l=p;b=k;while(1){do if((l|0)!=(b|0)){k=a[b>>0]|0;if(!(k&1)){E=(k&255)>>>1;F=b+1|0}else{E=c[b+4>>2]|0;F=c[b+8>>2]|0}k=a[l>>0]|0;if(!(k&1)){G=10;H=k}else{k=c[l>>2]|0;G=(k&-2)+-1|0;H=k&255}k=(H&1)==0;if(E>>>0>G>>>0){if(k)I=(H&255)>>>1;else I=c[l+4>>2]|0;eXb(l,G,E-G|0,I,0,I,E,F);break}if(k)J=l+1|0;else J=c[l+8>>2]|0;aFi(J|0,F|0,E|0)|0;a[J+E>>0]=0;if(!(a[l>>0]&1)){a[l>>0]=E<<1;break}else{c[l+4>>2]=E;break}}while(0);k=l+12|0;m=b+12|0;c[k+0>>2]=c[m+0>>2];a[k+4>>0]=a[m+4>>0]|0;b=b+20|0;if((b|0)==(B|0))break;else l=l+20|0}D=p+((d+1|0)*20|0)|0}if(!C){C=c[n>>2]|0;if((C|0)==(D|0)){i=f;return}d=C;while(1){C=d+-20|0;c[n>>2]=C;if(!(a[C>>0]&1))K=C;else{C=c[d+-12>>2]|0;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];eOb(C,g);K=c[n>>2]|0}if((K|0)==(D|0))break;else d=K}i=f;return}K=c[e>>2]|0;if((B|0)==(K|0)){i=f;return}e=c[n>>2]|0;d=B;while(1){if(!e)L=0;else{B=a[d>>0]|0;if(!(B&1)){M=d+1|0;N=(B&255)>>>1}else{M=c[d+8>>2]|0;N=c[d+4>>2]|0}if(N>>>0>2147483631){z=33;break}if(N>>>0<11){a[e>>0]=N<<1;O=e+1|0}else{B=N+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];D=cOb(B,16,g,0,3653512,80)|0;c[e+8>>2]=D;c[e>>2]=B|1;c[e+4>>2]=N;O=D}YEi(O|0,M|0,N|0)|0;a[O+N>>0]=0;D=e+12|0;B=d+12|0;c[D+0>>2]=c[B+0>>2];a[D+4>>0]=a[B+4>>0]|0;L=c[n>>2]|0}B=L+20|0;c[n>>2]=B;d=d+20|0;if((d|0)==(K|0)){z=68;break}else e=B}if((z|0)==33)ori(e);else if((z|0)==68){i=f;return}}function WXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=c[b+8>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/20|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=1;a[o+16>>0]=0;p=c[k>>2]|0}o=p+20|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=((m-n|0)/20|0)+d|0;if(o>>>0>214748364)vxi(b);m=n;n=(j-m|0)/20|0;if(n>>>0<107374182){j=n<<1;q=j>>>0<o>>>0?o:j}else q=214748364;j=((c[k>>2]|0)-m|0)/20|0;m=h+12|0;c[m>>2]=0;c[h+16>>2]=b+8;if(!q)r=0;else r=xCi(q*20|0)|0;c[h>>2]=r;k=r+(j*20|0)|0;j=h+8|0;c[j>>2]=k;o=h+4|0;c[o>>2]=k;c[m>>2]=r+(q*20|0);q=d;d=k;while(1){if(!d)s=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=1;a[d+16>>0]=0;s=d}k=s+20|0;q=q+-1|0;if(!q){t=k;break}else d=k}c[j>>2]=t;uXb(b,h);b=c[o>>2]|0;o=c[j>>2]|0;if((o|0)!=(b|0)){t=o;do{o=t;t=t+-20|0;c[j>>2]=t;if(a[t>>0]&1){d=c[o+-12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(d,f)}}while((t|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function XXb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;m=(e|0)/20|0;if((d|0)==(l|0)){i=g;return}if(m>>>0>214748364)vxi(b);n=xCi(e)|0;c[j>>2]=n;c[b>>2]=n;c[k>>2]=n+(m*20|0);m=l;l=n;while(1){n=a[m>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=m+1|0}else{o=c[m+4>>2]|0;p=c[m+8>>2]|0}if(o>>>0>2147483631){q=9;break}if(o>>>0<11){a[l>>0]=o<<1;r=l+1|0}else{n=o+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];k=cOb(n,16,f,0,3653512,80)|0;c[l+8>>2]=k;c[l>>2]=n|1;c[l+4>>2]=o;r=k}YEi(r|0,p|0,o|0)|0;a[r+o>>0]=0;k=l+12|0;n=m+12|0;c[k+0>>2]=c[n+0>>2];a[k+4>>0]=a[n+4>>0]|0;n=(c[j>>2]|0)+20|0;c[j>>2]=n;m=m+20|0;if((m|0)==(d|0)){q=14;break}else l=n}if((q|0)==9)ori(l);else if((q|0)==14){i=g;return}}function YXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=0;e=i;i=i+16|0;f=e;co[c[(c[a>>2]|0)+136>>2]&2047](f,a,d);h=ea(g[b>>2]);j=ea(g[b+4>>2]);k=ea(g[f>>2]);if(!(k<=h)){l=0;i=e;return l|0}if(!(ea(k+ea(g[f+8>>2]))>h)){l=0;i=e;return l|0}h=ea(g[f+4>>2]);if(!(h<=j)){l=0;i=e;return l|0}l=ea(h+ea(g[f+12>>2]))>j;i=e;return l|0}function ZXb(a){a=a|0;return}function _Xb(a){a=a|0;return}function $Xb(a){a=a|0;return}function aYb(){var a=0,b=0,d=0;a=i;b=xCi(24)|0;d=b+4|0;c[d>>2]=0;c[b+8>>2]=0;c[b>>2]=d;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[139430]=b;i=a;return}function bYb(){var a=0,b=0,d=0,e=0,f=0;a=i;b=c[139430]|0;if(!b){i=a;return}d=c[b+12>>2]|0;if(d){e=b+16|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-8-d|0)>>>3)<<3);ACi(d)}hYb(b,c[b+4>>2]|0);ACi(b);i=a;return}function cYb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d;l=c[139430]|0;m=l+12|0;n=c[m>>2]|0;o=l+16|0;if((n|0)!=(c[o>>2]|0)){p=n;while(1){n=p+4|0;if(!(a[p>>0]|0))jYb(l,n)|0;else iYb(e,l,n);n=p+8|0;if((n|0)==(c[o>>2]|0)){q=p;r=n;break}else p=n}p=c[m>>2]|0;if((r|0)!=(p|0))c[o>>2]=q+(0-((q-p|0)>>>3)<<3)}p=c[139430]|0;if(!(c[p+8>>2]|0)){i=d;return}c[h>>2]=c[p>>2];c[j>>2]=p+4;c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];kYb(g,f,e);j=c[g>>2]|0;h=g+4|0;p=c[h>>2]|0;c[e>>2]=2602;mYb(j,p,e);p=ATb(c[b+24>>2]|0,20)|0;b=c[p+412>>2]|0;u$b(k,p,1);p=c[g>>2]|0;j=c[h>>2]|0;if((p|0)==(j|0))s=p;else{q=p;do{p=c[q>>2]|0;if(1<<c[(c[p+24>>2]|0)+40>>2]&b)In[c[(c[p>>2]|0)+132>>2]&4095](p,k);q=q+4|0}while((q|0)!=(j|0));s=c[g>>2]|0}if(!s){i=d;return}g=c[h>>2]|0;if((g|0)!=(s|0))c[h>>2]=g+(~((g+-4-s|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function dYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=Im,C=0;d=i;i=i+64|0;e=d+56|0;f=d+48|0;h=d+36|0;j=d+24|0;k=d+16|0;l=d;m=ATb(c[a+24>>2]|0,20)|0;n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(g[m+456>>2]);g[j>>2]=n;g[j+4>>2]=o;g[j+8>>2]=p;s0b(h,m,j);p=ea(g[h>>2]);o=ea(g[h+4>>2]);g[k>>2]=p;h=k+4|0;g[h>>2]=o;if(!(o<ea(1.0)&((!(p<ea(1.0))|!(p>=ea(0.0))|!(o>=ea(0.0)))^1))){q=0;i=d;return q|0}u$b(l,m,1);j=n8b()|0;n=ea(g[j+64>>2]);r=ea(g[j+68>>2]);g[k>>2]=ea(n*p);g[h>>2]=ea(r*o);h=c[m+412>>2]&-5;m=c[139430]|0;j=c[m>>2]|0;b=m+4|0;if((j|0)==(b|0)){q=0;i=d;return q|0}m=j;j=0;o=ea(-x);while(1){a=m+16|0;s=c[a>>2]|0;do if(s){c[f>>2]=s;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(e,t,f);u=c[e>>2]|0;v=c[t+28>>2]|0;if((u|0)==-1){w=v+(c[t+32>>2]<<3)|0;break}else{w=v+(u<<3)|0;break}}else w=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((w|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[w+4>>2]|0,(t|0)!=0):0)y=t;else z=13}else z=13;if((z|0)==13){z=0;t=hQb(c[a>>2]|0)|0;if(!t){A=j;B=o;break}else y=t}t=y+24|0;if(((h&1<<c[(c[t>>2]|0)+40>>2]|0)!=0?YXb(y,k,l)|0:0)?(r=ea(g[(BTb(c[t>>2]|0)|0)+52>>2]),r>o):0){A=y;B=r}else{A=j;B=o}}else{A=j;B=o}while(0);a=c[m+4>>2]|0;if(!a){s=m;while(1){t=c[s+8>>2]|0;if((c[t>>2]|0)==(s|0)){C=t;break}else s=t}}else{s=a;while(1){t=c[s>>2]|0;if(!t){C=s;break}else s=t}}if((C|0)==(b|0)){q=A;break}else{m=C;j=A;o=B}}i=d;return q|0}function eYb(){var a=0;a=i;QQb(92,90,91,0,92);i=a;return}function fYb(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,2363376,8);wQb(92,8,b,32,2603,0,0);xri(b);i=a;return}function gYb(a){a=a|0;return 92}function hYb(b,d){b=b|0;d=d|0;var e=0;e=i;if(!d){i=e;return}hYb(b,c[d>>2]|0);hYb(b,c[d+4>>2]|0);if(!(a[557880]|0)){sYb(557872,20);b=557880;c[b>>2]=1;c[b+4>>2]=0}dsd(c[139468]|0,d);i=e;return}function iYb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=c[e>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((k|0)<(m|0)){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((m|0)>=(k|0)){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=d+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=0;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}if(!(a[557880]|0)){sYb(557872,20);g=557880;c[g>>2]=1;c[g+4>>2]=0}g=csd(c[139468]|0,20)|0;c[g+16>>2]=c[e>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=v;c[u>>2]=g;v=c[c[d>>2]>>2]|0;if(!v)z=g;else{c[d>>2]=v;z=c[u>>2]|0}GN(c[h>>2]|0,z);z=d+8|0;c[z>>2]=(c[z>>2]|0)+1;w=1;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function jYb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[b+4>>2]|0;g=b+4|0;if(!f){h=0;i=e;return h|0}j=c[d>>2]|0;d=g;k=f;a:while(1){l=k;while(1){if((c[l+16>>2]|0)>=(j|0)){m=l;break}l=c[l+4>>2]|0;if(!l){n=d;break a}}k=c[m>>2]|0;if(!k){n=m;break}else d=m}if((n|0)==(g|0)){h=0;i=e;return h|0}if((j|0)<(c[n+16>>2]|0)){h=0;i=e;return h|0}j=c[n+4>>2]|0;if(!j){g=n;while(1){m=c[g+8>>2]|0;if((c[m>>2]|0)==(g|0)){o=m;break}else g=m}}else{g=j;while(1){j=c[g>>2]|0;if(!j){o=g;break}else g=j}}if((c[b>>2]|0)==(n|0))c[b>>2]=o;o=b+8|0;c[o>>2]=(c[o>>2]|0)+-1;tYb(f,n);if(!(a[557880]|0)){sYb(557872,20);f=557880;c[f>>2]=1;c[f+4>>2]=0}dsd(c[139468]|0,n);h=1;i=e;return h|0}function kYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[a>>2]=0;k=a+4|0;c[k>>2]=0;l=a+8|0;c[l>>2]=0;m=c[b>>2]|0;b=c[d>>2]|0;if((m|0)==(b|0)){i=e;return}else{n=m;o=0}while(1){d=o+1|0;p=c[n+4>>2]|0;if(!p){q=n;while(1){r=c[q+8>>2]|0;if((c[r>>2]|0)==(q|0)){s=r;break}else q=r}}else{q=p;while(1){r=c[q>>2]|0;if(!r){s=q;break}else q=r}}if((s|0)==(b|0)){t=d;break}else{n=s;o=d}}if(!t){i=e;return}if((t|0)<0)vxi(a);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];o=cOb(t<<2,16,f,0,3653512,80)|0;c[k>>2]=o;c[a>>2]=o;c[l>>2]=o+(t<<2);c[h>>2]=m;c[j>>2]=b;c[g+0>>2]=c[h+0>>2];c[f+0>>2]=c[j+0>>2];uYb(a,g,f);i=e;return}function lYb(a,b){a=a|0;b=b|0;var d=0,e=Im;d=i;e=ea(g[(BTb(c[a+24>>2]|0)|0)+52>>2]);a=e<ea(g[(BTb(c[b+24>>2]|0)|0)+52>>2]);i=d;return a|0}function mYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-4|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>2;switch(l|0){case 3:{m=h;n=g;o=6;break a;break}case 5:{p=h;q=g;o=15;break a;break}case 2:{r=h;s=g;o=4;break a;break}case 4:{t=h;u=g;o=14;break a;break}case 1:case 0:{o=69;break a;break}default:{}}if((k|0)<124){v=h;w=a;o=21;break a}x=(l|0)/2|0;y=h+(x<<2)|0;do if((k|0)>3996){z=(l|0)/4|0;A=h+(z<<2)|0;B=h+(z+x<<2)|0;z=vYb(h,A,y,B,d)|0;if(_n[c[d>>2]&4095](c[g>>2]|0,c[B>>2]|0)|0){C=c[B>>2]|0;c[B>>2]=c[g>>2];c[g>>2]=C;C=z+1|0;if(_n[c[d>>2]&4095](c[B>>2]|0,c[y>>2]|0)|0){D=c[y>>2]|0;c[y>>2]=c[B>>2];c[B>>2]=D;D=z+2|0;if(_n[c[d>>2]&4095](c[y>>2]|0,c[A>>2]|0)|0){B=c[A>>2]|0;c[A>>2]=c[y>>2];c[y>>2]=B;if(_n[c[d>>2]&4095](c[A>>2]|0,c[h>>2]|0)|0){B=c[h>>2]|0;c[h>>2]=c[A>>2];c[A>>2]=B;E=z+4|0}else E=z+3|0}else E=D}else E=C}else E=z}else{z=_n[c[d>>2]&4095](c[y>>2]|0,c[h>>2]|0)|0;C=_n[c[d>>2]&4095](c[g>>2]|0,c[y>>2]|0)|0;if(!z){if(!C){E=0;break}z=c[y>>2]|0;c[y>>2]=c[g>>2];c[g>>2]=z;if(!(_n[c[d>>2]&4095](c[y>>2]|0,c[h>>2]|0)|0)){E=1;break}z=c[h>>2]|0;c[h>>2]=c[y>>2];c[y>>2]=z;E=2;break}z=c[h>>2]|0;if(C){c[h>>2]=c[g>>2];c[g>>2]=z;E=1;break}c[h>>2]=c[y>>2];c[y>>2]=z;if(_n[c[d>>2]&4095](c[g>>2]|0,z)|0){z=c[y>>2]|0;c[y>>2]=c[g>>2];c[g>>2]=z;E=2}else E=1}while(0);do if(_n[c[d>>2]&4095](c[h>>2]|0,c[y>>2]|0)|0){F=g;G=E}else{x=a;l=g;while(1){k=x+-8|0;if((h|0)==(k|0))break;if(_n[c[d>>2]&4095](c[k>>2]|0,c[y>>2]|0)|0){H=k;o=51;break}else{z=l;l=k;x=z}}if((o|0)==51){o=0;x=c[h>>2]|0;c[h>>2]=c[H>>2];c[H>>2]=x;F=H;G=E+1|0;break}x=h+4|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[g>>2]|0)|0)I=x;else{if((x|0)==(g|0)){o=69;break a}else{J=h;K=x}while(1){x=J+8|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[K>>2]|0)|0){L=K;break}if((x|0)==(g|0)){o=69;break a}else{l=K;K=x;J=l}}l=c[L>>2]|0;c[L>>2]=c[g>>2];c[g>>2]=l;I=L+4|0}if((I|0)==(g|0)){o=69;break a}else{M=I;N=g}while(1){l=M;while(1){x=l+4|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[l>>2]|0)|0){O=x;P=l;break}else l=x}l=N;while(1){x=l+-4|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[x>>2]|0)|0)l=x;else{Q=x;break}}if(P>>>0>=Q>>>0){h=P;continue b}l=c[P>>2]|0;c[P>>2]=c[Q>>2];c[Q>>2]=l;M=O;N=Q}}while(0);l=h+4|0;c:do if(l>>>0<F>>>0){x=l;z=F;k=y;C=G;while(1){D=x;while(1){B=D+4|0;if(_n[c[d>>2]&4095](c[D>>2]|0,c[k>>2]|0)|0)D=B;else{R=B;S=D;break}}D=z;while(1){B=D+-4|0;if(_n[c[d>>2]&4095](c[B>>2]|0,c[k>>2]|0)|0){T=B;break}else D=B}if(S>>>0>T>>>0){U=S;V=k;W=C;break c}D=c[S>>2]|0;c[S>>2]=c[T>>2];c[T>>2]=D;x=R;z=T;k=(k|0)==(S|0)?T:k;C=C+1|0}}else{U=l;V=y;W=G}while(0);if((U|0)!=(V|0)?_n[c[d>>2]&4095](c[V>>2]|0,c[U>>2]|0)|0:0){y=c[U>>2]|0;c[U>>2]=c[V>>2];c[V>>2]=y;X=W+1|0}else X=W;if(!X){Y=xYb(h,U,d)|0;y=U+4|0;if(xYb(y,a,d)|0){o=64;break}if(Y){h=y;continue}}y=U;if((y-j|0)>=(b-y|0)){Z=h;_=U;o=68;break}mYb(h,U,d);h=U+4|0}if((o|0)==64){o=0;if(Y){o=69;break}else{f=h;a=U;continue}}else if((o|0)==68){o=0;mYb(_+4|0,a,d);f=Z;a=_;continue}}if((o|0)==4){if(!(_n[c[d>>2]&4095](c[s>>2]|0,c[r>>2]|0)|0)){i=e;return}_=c[r>>2]|0;c[r>>2]=c[s>>2];c[s>>2]=_;i=e;return}else if((o|0)==6){_=m+4|0;s=_n[c[d>>2]&4095](c[_>>2]|0,c[m>>2]|0)|0;r=_n[c[d>>2]&4095](c[n>>2]|0,c[_>>2]|0)|0;if(!s){if(!r){i=e;return}s=c[_>>2]|0;c[_>>2]=c[n>>2];c[n>>2]=s;if(!(_n[c[d>>2]&4095](c[_>>2]|0,c[m>>2]|0)|0)){i=e;return}s=c[m>>2]|0;c[m>>2]=c[_>>2];c[_>>2]=s;i=e;return}s=c[m>>2]|0;if(r){c[m>>2]=c[n>>2];c[n>>2]=s;i=e;return}c[m>>2]=c[_>>2];c[_>>2]=s;if(!(_n[c[d>>2]&4095](c[n>>2]|0,s)|0)){i=e;return}s=c[_>>2]|0;c[_>>2]=c[n>>2];c[n>>2]=s;i=e;return}else if((o|0)==14){vYb(t,t+4|0,t+8|0,u,d)|0;i=e;return}else if((o|0)==15){u=p+4|0;t=p+8|0;s=p+12|0;vYb(p,u,t,s,d)|0;if(!(_n[c[d>>2]&4095](c[q>>2]|0,c[s>>2]|0)|0)){i=e;return}n=c[s>>2]|0;c[s>>2]=c[q>>2];c[q>>2]=n;if(!(_n[c[d>>2]&4095](c[s>>2]|0,c[t>>2]|0)|0)){i=e;return}n=c[t>>2]|0;q=c[s>>2]|0;c[t>>2]=q;c[s>>2]=n;if(!(_n[c[d>>2]&4095](q,c[u>>2]|0)|0)){i=e;return}q=c[u>>2]|0;n=c[t>>2]|0;c[u>>2]=n;c[t>>2]=q;if(!(_n[c[d>>2]&4095](n,c[p>>2]|0)|0)){i=e;return}n=c[p>>2]|0;c[p>>2]=c[u>>2];c[u>>2]=n;i=e;return}else if((o|0)==21){wYb(v,w,d);i=e;return}else if((o|0)==69){i=e;return}}function nYb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(32,f,1,16,3653512,13)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];bUb(h,f,d);a[h+28>>0]=1;a[h+29>>0]=0;c[h>>2]=557736;i=e;return h|0}function oYb(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);i=b;return}function pYb(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);ACi(a);i=b;return}function qYb(a){a=a|0;return}function rYb(a){a=a|0;return}function sYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=c[153126];c[e+0>>2]=c[f+0>>2];f=bOb(44,e,0,16,3653512,142)|0;c[g>>2]=c[153126];c[e+0>>2]=c[g+0>>2];_rd(f,1,719624,b,32768,e,16);c[a>>2]=f;Zrd(f);i=d;return}function tYb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;f=c[d>>2]|0;if(f){g=c[d+4>>2]|0;if(!g){h=d;j=f}else{f=g;while(1){g=c[f>>2]|0;if(!g){h=f;j=0;break}else f=g}}}else{h=d;j=0}f=h+4|0;g=c[((j|0)==0?f:h)>>2]|0;j=(g|0)==0;k=h+8|0;if(!j)c[g+8>>2]=c[k>>2];l=c[k>>2]|0;m=c[l>>2]|0;if((m|0)==(h|0)){c[l>>2]=g;if((h|0)==(b|0)){n=g;o=0}else{n=b;o=c[l+4>>2]|0}}else{c[l+4>>2]=g;n=b;o=m}m=h+12|0;b=(a[m>>0]|0)==0;if((h|0)==(d|0))p=n;else{l=d+8|0;q=c[l>>2]|0;c[k>>2]=q;if((c[c[l>>2]>>2]|0)==(d|0))c[q>>2]=h;else c[q+4>>2]=h;q=c[d>>2]|0;c[h>>2]=q;c[q+8>>2]=h;q=c[d+4>>2]|0;c[f>>2]=q;if(q)c[q+8>>2]=h;a[m>>0]=a[d+12>>0]|0;p=(n|0)==(d|0)?h:n}if(b|(p|0)==0){i=e;return}if(j){r=p;s=o}else{a[g+12>>0]=1;i=e;return}while(1){g=s+8|0;o=c[g>>2]|0;p=s+12|0;j=(a[p>>0]|0)!=0;if((c[o>>2]|0)==(s|0)){if(j){t=r;u=s}else{a[p>>0]=1;a[o+12>>0]=0;b=s+4|0;n=c[b>>2]|0;c[o>>2]=n;if(n)c[n+8>>2]=o;n=o+8|0;c[g>>2]=c[n>>2];g=c[n>>2]|0;if((c[g>>2]|0)==(o|0))c[g>>2]=s;else c[g+4>>2]=s;c[b>>2]=o;c[n>>2]=s;t=(r|0)==(o|0)?s:r;u=c[o>>2]|0}v=c[u>>2]|0;w=(v|0)==0;if(!w?(a[v+12>>0]|0)==0:0){x=v;y=u;z=66;break}n=c[u+4>>2]|0;if((n|0)!=0?(a[n+12>>0]|0)==0:0){z=65;break}a[u+12>>0]=0;n=c[u+8>>2]|0;b=n+12|0;if((a[b>>0]|0)==0|(n|0)==(t|0)){A=b;z=62;break}b=c[n+8>>2]|0;B=t;C=(c[b>>2]|0)==(n|0)?b+4|0:b}else{if(j){D=r;E=s}else{a[p>>0]=1;a[o+12>>0]=0;p=o+4|0;j=c[p>>2]|0;b=c[j>>2]|0;c[p>>2]=b;if(b)c[b+8>>2]=o;b=o+8|0;c[j+8>>2]=c[b>>2];p=c[b>>2]|0;if((c[p>>2]|0)==(o|0))c[p>>2]=j;else c[p+4>>2]=j;c[j>>2]=o;c[b>>2]=j;j=c[s>>2]|0;D=(r|0)==(j|0)?s:r;E=c[j+4>>2]|0}j=c[E>>2]|0;if((j|0)!=0?(a[j+12>>0]|0)==0:0){F=E;G=j;H=E;z=36;break}b=c[E+4>>2]|0;if((b|0)!=0?(a[b+12>>0]|0)==0:0){I=j;J=E;K=b;L=E;z=37;break}a[E+12>>0]=0;b=c[E+8>>2]|0;if((b|0)==(D|0)){M=D;z=34;break}if(!(a[b+12>>0]|0)){M=b;z=34;break}j=c[b+8>>2]|0;B=D;C=(c[j>>2]|0)==(b|0)?j+4|0:j}r=B;s=c[C>>2]|0}if((z|0)==34){a[M+12>>0]=1;i=e;return}else if((z|0)==36){M=c[H+4>>2]|0;if(!M){N=F;O=G;P=H;z=38}else{I=G;J=F;K=M;L=H;z=37}}else if((z|0)==62){a[A>>0]=1;i=e;return}else if((z|0)==65)if(w){Q=u;z=67}else{x=v;y=u;z=66}if((z|0)==37)if(!(a[K+12>>0]|0)){R=K;S=L;z=44}else{N=J;O=I;P=L;z=38}else if((z|0)==66)if(!(a[x+12>>0]|0)){T=x;U=y;z=73}else{Q=y;z=67}if((z|0)==38){a[O+12>>0]=1;a[P+12>>0]=0;y=O+4|0;x=c[y>>2]|0;c[N>>2]=x;if(x)c[x+8>>2]=P;x=P+8|0;c[O+8>>2]=c[x>>2];N=c[x>>2]|0;if((c[N>>2]|0)==(P|0))c[N>>2]=O;else c[N+4>>2]=O;c[y>>2]=P;c[x>>2]=O;R=P;S=O;z=44}else if((z|0)==67){O=Q+4|0;P=c[O>>2]|0;a[P+12>>0]=1;a[Q+12>>0]=0;x=c[P>>2]|0;c[O>>2]=x;if(x)c[x+8>>2]=Q;x=Q+8|0;c[P+8>>2]=c[x>>2];O=c[x>>2]|0;if((c[O>>2]|0)==(Q|0))c[O>>2]=P;else c[O+4>>2]=P;c[P>>2]=Q;c[x>>2]=P;T=Q;U=P;z=73}if((z|0)==44){P=c[S+8>>2]|0;Q=P+12|0;a[S+12>>0]=a[Q>>0]|0;a[Q>>0]=1;a[R+12>>0]=1;R=P+4|0;Q=c[R>>2]|0;S=c[Q>>2]|0;c[R>>2]=S;if(S)c[S+8>>2]=P;S=P+8|0;c[Q+8>>2]=c[S>>2];R=c[S>>2]|0;if((c[R>>2]|0)==(P|0))c[R>>2]=Q;else c[R+4>>2]=Q;c[Q>>2]=P;c[S>>2]=Q;i=e;return}else if((z|0)==73){z=c[U+8>>2]|0;Q=z+12|0;a[U+12>>0]=a[Q>>0]|0;a[Q>>0]=1;a[T+12>>0]=1;T=c[z>>2]|0;Q=T+4|0;U=c[Q>>2]|0;c[z>>2]=U;if(U)c[U+8>>2]=z;U=z+8|0;c[T+8>>2]=c[U>>2];S=c[U>>2]|0;if((c[S>>2]|0)==(z|0))c[S>>2]=T;else c[S+4>>2]=T;c[Q>>2]=z;c[U>>2]=T;i=e;return}}function uYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[b>>2]|0;j=c[d>>2]|0;if((h|0)==(j|0)){i=e;return}d=a+4|0;a=c[d>>2]|0;k=h;while(1){if(!a){l=0;m=k}else{h=k+16|0;n=c[h>>2]|0;if(!n)o=0;else{c[g>>2]=n;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(f,n,g);p=c[f>>2]|0;q=c[n+28>>2]|0;if((p|0)==-1){r=q+(c[n+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((r|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[r+4>>2]|0,(n|0)!=0):0)s=n;else t=13}else t=13;if((t|0)==13){t=0;s=hQb(c[h>>2]|0)|0}o=s}c[a>>2]=o;l=c[d>>2]|0;m=c[b>>2]|0}a=l+4|0;c[d>>2]=a;n=c[m+4>>2]|0;if(!n){p=m;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){u=q;break}else p=q}}else{p=n;while(1){h=c[p>>2]|0;if(!h){u=p;break}else p=h}}c[b>>2]=u;if((u|0)==(j|0))break;else k=u}i=e;return}function vYb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=_n[c[f>>2]&4095](c[b>>2]|0,c[a>>2]|0)|0;j=_n[c[f>>2]&4095](c[d>>2]|0,c[b>>2]|0)|0;do if(h){k=c[a>>2]|0;if(j){c[a>>2]=c[d>>2];c[d>>2]=k;l=1;break}c[a>>2]=c[b>>2];c[b>>2]=k;if(_n[c[f>>2]&4095](c[d>>2]|0,k)|0){k=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=k;l=2}else l=1}else if(j){k=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=k;if(_n[c[f>>2]&4095](c[b>>2]|0,c[a>>2]|0)|0){k=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=k;l=2}else l=1}else l=0;while(0);if(!(_n[c[f>>2]&4095](c[e>>2]|0,c[d>>2]|0)|0)){m=l;i=g;return m|0}j=c[d>>2]|0;c[d>>2]=c[e>>2];c[e>>2]=j;if(!(_n[c[f>>2]&4095](c[d>>2]|0,c[b>>2]|0)|0)){m=l+1|0;i=g;return m|0}j=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=j;if(!(_n[c[f>>2]&4095](c[b>>2]|0,c[a>>2]|0)|0)){m=l+2|0;i=g;return m|0}f=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=f;m=l+3|0;i=g;return m|0}function wYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=a+8|0;g=a+4|0;h=_n[c[d>>2]&4095](c[g>>2]|0,c[a>>2]|0)|0;j=_n[c[d>>2]&4095](c[f>>2]|0,c[g>>2]|0)|0;do if(h){k=c[a>>2]|0;if(j){c[a>>2]=c[f>>2];c[f>>2]=k;break}c[a>>2]=c[g>>2];c[g>>2]=k;if(_n[c[d>>2]&4095](c[f>>2]|0,k)|0){k=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=k}}else if(j?(k=c[g>>2]|0,l=c[f>>2]|0,c[g>>2]=l,c[f>>2]=k,_n[c[d>>2]&4095](l,c[a>>2]|0)|0):0){l=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=l}while(0);g=a+12|0;if((g|0)==(b|0)){i=e;return}else{m=g;n=f}while(1){if(_n[c[d>>2]&4095](c[m>>2]|0,c[n>>2]|0)|0){f=c[m>>2]|0;g=m;j=n;while(1){c[g>>2]=c[j>>2];if((j|0)==(a|0)){o=a;break}h=j+-4|0;if(_n[c[d>>2]&4095](f,c[h>>2]|0)|0){l=j;j=h;g=l}else{o=j;break}}c[o>>2]=f}j=m+4|0;if((j|0)==(b|0))break;else{g=m;m=j;n=g}}i=e;return}function xYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;switch(b-a>>2|0){case 4:{vYb(a,a+4|0,a+8|0,b+-4|0,d)|0;f=1;i=e;return f|0}case 3:{g=a+4|0;h=b+-4|0;j=_n[c[d>>2]&4095](c[g>>2]|0,c[a>>2]|0)|0;k=_n[c[d>>2]&4095](c[h>>2]|0,c[g>>2]|0)|0;if(!j){if(!k){f=1;i=e;return f|0}j=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=j;if(!(_n[c[d>>2]&4095](c[g>>2]|0,c[a>>2]|0)|0)){f=1;i=e;return f|0}j=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=j;f=1;i=e;return f|0}j=c[a>>2]|0;if(k){c[a>>2]=c[h>>2];c[h>>2]=j;f=1;i=e;return f|0}c[a>>2]=c[g>>2];c[g>>2]=j;if(!(_n[c[d>>2]&4095](c[h>>2]|0,j)|0)){f=1;i=e;return f|0}j=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=j;f=1;i=e;return f|0}case 2:{j=b+-4|0;if(!(_n[c[d>>2]&4095](c[j>>2]|0,c[a>>2]|0)|0)){f=1;i=e;return f|0}h=c[a>>2]|0;c[a>>2]=c[j>>2];c[j>>2]=h;f=1;i=e;return f|0}case 5:{h=a+4|0;j=a+8|0;g=a+12|0;k=b+-4|0;vYb(a,h,j,g,d)|0;if(!(_n[c[d>>2]&4095](c[k>>2]|0,c[g>>2]|0)|0)){f=1;i=e;return f|0}l=c[g>>2]|0;c[g>>2]=c[k>>2];c[k>>2]=l;if(!(_n[c[d>>2]&4095](c[g>>2]|0,c[j>>2]|0)|0)){f=1;i=e;return f|0}l=c[j>>2]|0;k=c[g>>2]|0;c[j>>2]=k;c[g>>2]=l;if(!(_n[c[d>>2]&4095](k,c[h>>2]|0)|0)){f=1;i=e;return f|0}k=c[h>>2]|0;l=c[j>>2]|0;c[h>>2]=l;c[j>>2]=k;if(!(_n[c[d>>2]&4095](l,c[a>>2]|0)|0)){f=1;i=e;return f|0}l=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=l;f=1;i=e;return f|0}case 1:case 0:{f=1;i=e;return f|0}default:{l=a+8|0;h=a+4|0;k=_n[c[d>>2]&4095](c[h>>2]|0,c[a>>2]|0)|0;j=_n[c[d>>2]&4095](c[l>>2]|0,c[h>>2]|0)|0;do if(k){g=c[a>>2]|0;if(j){c[a>>2]=c[l>>2];c[l>>2]=g;break}c[a>>2]=c[h>>2];c[h>>2]=g;if(_n[c[d>>2]&4095](c[l>>2]|0,g)|0){g=c[h>>2]|0;c[h>>2]=c[l>>2];c[l>>2]=g}}else if(j?(g=c[h>>2]|0,m=c[l>>2]|0,c[h>>2]=m,c[l>>2]=g,_n[c[d>>2]&4095](m,c[a>>2]|0)|0):0){m=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=m}while(0);h=a+12|0;if((h|0)==(b|0)){f=1;i=e;return f|0}else{n=0;o=h;p=l}while(1){if(_n[c[d>>2]&4095](c[o>>2]|0,c[p>>2]|0)|0){l=c[o>>2]|0;h=o;j=p;while(1){c[h>>2]=c[j>>2];if((j|0)==(a|0)){q=a;break}k=j+-4|0;if(_n[c[d>>2]&4095](l,c[k>>2]|0)|0){m=j;j=k;h=m}else{q=j;break}}c[q>>2]=l;j=n+1|0;if((j|0)==8){r=o;break}else s=j}else s=n;j=o+4|0;if((j|0)==(b|0)){f=1;t=34;break}else{h=o;n=s;o=j;p=h}}if((t|0)==34){i=e;return f|0}f=(r+4|0)==(b|0);i=e;return f|0}}return 0}function yYb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;h=f+24|0;j=f+8|0;k=f;l=c[d>>2]|0;g[j>>2]=ea(0.0);g[j+8>>2]=ea(1.0);g[j+4>>2]=ea(0.0);g[j+12>>2]=ea(1.0);c[k>>2]=l;c[h+0>>2]=c[k+0>>2];AYb(a,b,j,0,0,0,0,h,e);i=f;return}function zYb(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=i;i=i+32|0;m=l+24|0;n=l+8|0;o=l;g[n>>2]=ea(0.0);g[n+8>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+12>>2]=ea(1.0);c[o>>2]=c[j>>2];c[m+0>>2]=c[o+0>>2];AYb(a,b,n,d,e,f,h,m,k);i=l;return}function AYb(d,e,f,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=0,U=0;o=i;i=i+16|0;p=o+4|0;q=o;DYb();if(!e){Krd(557928,0,3653512,499,1,0,0,0);i=o;return}r=ync()|0;if(!(a[621175]|0)){s=c[m>>2]|0;t=s;u=s>>>16;v=m;w=s>>>8&255;x=s&255}else{s=c[m>>2]|0;t=s;u=s;v=m;w=a[m+1>>0]|0;x=a[m+2>>0]|0}m=u<<16&16711680|t&-16777216|(w&255)<<8|x&255;c[v>>2]=m;y=ea(ea(1.0)/ea(mo[c[(c[e>>2]|0)+104>>2]&4095](e)|0));z=ea(ea(1.0)/ea(mo[c[(c[e>>2]|0)+108>>2]&4095](e)|0));A=ea(g[d>>2]);B=ea(A+ea(.5));if(!(B>=ea(0.0)))C=ea(B+ea(-.99999994));else C=B;B=ea(~~C|0);C=ea(ea(A+ea(g[d+8>>2]))+ea(.5));if(!(C>=ea(0.0)))D=ea(C+ea(-.99999994));else D=C;C=ea(~~D|0);D=ea(g[d+4>>2]);A=ea(ea(D+ea(g[d+12>>2]))+ea(.5));if(!(A>=ea(0.0)))E=ea(A+ea(-.99999994));else E=A;A=ea(~~E|0);E=ea(D+ea(.5));if(!(E>=ea(0.0)))F=ea(E+ea(-.99999994));else F=E;E=ea(~~F|0);F=ea(g[f>>2]);D=ea(F+ea(g[f+8>>2]));G=ea(g[f+4>>2]);H=ea(G+ea(g[f+12>>2]));f=Mnc(ync()|0)|0;do if(!(j|h|k|l))if(gn[c[(c[f>>2]|0)+8>>2]&127](f,24,4,6,0,p,q)|0){d=c[p>>2]|0;g[d>>2]=B;g[d+4>>2]=A;g[d+8>>2]=ea(0.0);c[d+12>>2]=m;g[d+16>>2]=F;g[d+20>>2]=G;g[d+24>>2]=C;g[d+28>>2]=A;g[d+32>>2]=ea(0.0);c[d+36>>2]=m;g[d+40>>2]=D;g[d+44>>2]=G;g[d+48>>2]=B;g[d+52>>2]=E;g[d+56>>2]=ea(0.0);c[d+60>>2]=m;g[d+64>>2]=F;g[d+68>>2]=H;g[d+72>>2]=C;g[d+76>>2]=E;g[d+80>>2]=ea(0.0);c[d+84>>2]=m;g[d+88>>2]=D;g[d+92>>2]=H;d=c[q>>2]|0;b[d+0>>1]=b[278980]|0;b[d+2>>1]=b[278981]|0;b[d+4>>1]=b[278982]|0;b[d+6>>1]=b[278983]|0;b[d+8>>1]=b[278984]|0;b[d+10>>1]=b[278985]|0;co[c[(c[f>>2]|0)+12>>2]&2047](f,4,6);break}else{i=o;return}else{I=ea(h|0);J=ea(I+B);K=ea(j|0);L=ea(C-K);M=ea(l|0);N=ea(A-M);O=ea(k|0);P=ea(O+E);Q=ea(ea(I*y)+F);I=ea(D-ea(K*y));K=ea(ea(M*z)+G);M=ea(H-ea(O*z));if(gn[c[(c[f>>2]|0)+8>>2]&127](f,24,16,54,0,p,q)|0){d=c[p>>2]|0;g[d>>2]=B;g[d+4>>2]=A;g[d+8>>2]=ea(0.0);c[d+12>>2]=m;g[d+16>>2]=F;g[d+20>>2]=G;g[d+24>>2]=J;g[d+28>>2]=A;g[d+32>>2]=ea(0.0);c[d+36>>2]=m;g[d+40>>2]=Q;g[d+44>>2]=G;g[d+48>>2]=L;g[d+52>>2]=A;g[d+56>>2]=ea(0.0);c[d+60>>2]=m;g[d+64>>2]=I;g[d+68>>2]=G;g[d+72>>2]=C;g[d+76>>2]=A;g[d+80>>2]=ea(0.0);c[d+84>>2]=m;g[d+88>>2]=D;g[d+92>>2]=G;g[d+96>>2]=B;g[d+100>>2]=N;g[d+104>>2]=ea(0.0);c[d+108>>2]=m;g[d+112>>2]=F;g[d+116>>2]=K;g[d+120>>2]=J;g[d+124>>2]=N;g[d+128>>2]=ea(0.0);c[d+132>>2]=m;g[d+136>>2]=Q;g[d+140>>2]=K;g[d+144>>2]=L;g[d+148>>2]=N;g[d+152>>2]=ea(0.0);c[d+156>>2]=m;g[d+160>>2]=I;g[d+164>>2]=K;g[d+168>>2]=C;g[d+172>>2]=N;g[d+176>>2]=ea(0.0);c[d+180>>2]=m;g[d+184>>2]=D;g[d+188>>2]=K;g[d+192>>2]=B;g[d+196>>2]=P;g[d+200>>2]=ea(0.0);c[d+204>>2]=m;g[d+208>>2]=F;g[d+212>>2]=M;g[d+216>>2]=J;g[d+220>>2]=P;g[d+224>>2]=ea(0.0);c[d+228>>2]=m;g[d+232>>2]=Q;g[d+236>>2]=M;g[d+240>>2]=L;g[d+244>>2]=P;g[d+248>>2]=ea(0.0);c[d+252>>2]=m;g[d+256>>2]=I;g[d+260>>2]=M;g[d+264>>2]=C;g[d+268>>2]=P;g[d+272>>2]=ea(0.0);c[d+276>>2]=m;g[d+280>>2]=D;g[d+284>>2]=M;g[d+288>>2]=B;g[d+292>>2]=E;g[d+296>>2]=ea(0.0);c[d+300>>2]=m;g[d+304>>2]=F;g[d+308>>2]=H;g[d+312>>2]=J;g[d+316>>2]=E;g[d+320>>2]=ea(0.0);c[d+324>>2]=m;g[d+328>>2]=Q;g[d+332>>2]=H;g[d+336>>2]=L;g[d+340>>2]=E;g[d+344>>2]=ea(0.0);c[d+348>>2]=m;g[d+352>>2]=I;g[d+356>>2]=H;d=c[p>>2]|0;g[d+360>>2]=C;g[d+364>>2]=E;g[d+368>>2]=ea(0.0);c[d+372>>2]=m;g[d+376>>2]=D;g[d+380>>2]=H;d=(c[q>>2]|0)+0|0;v=557976;x=d+108|0;do{b[d>>1]=b[v>>1]|0;d=d+2|0;v=v+2|0}while((d|0)<(x|0));co[c[(c[f>>2]|0)+12>>2]&2047](f,16,54);break}else{i=o;return}}while(0);if(!n){f=c[139480]|0;q=f+32|0;m=c[q>>2]|0;if(!m){Qjd(f);R=c[q>>2]|0}else R=m;a[f+36>>0]=1;BYb(R,e);S=c[139480]|0}else{R=n+32|0;f=c[R>>2]|0;if(!f){Qjd(n);T=c[R>>2]|0}else T=f;a[n+36>>0]=1;BYb(T,e);S=n}n=kkd(S)|0;e=Mnc(r)|0;if((n|0)<=0){i=o;return}r=0;do{T=ync()|0;ko[c[(c[T>>2]|0)+352>>2]&4095](T);T=dkd(S,r,c[158074]|0,0,0)|0;if(T){f=c[(c[e>>2]|0)+16>>2]|0;R=c[T+4>>2]|0;m=c[139476]|0;if(!m){q=uic()|0;p=tic(q,c[139474]|0)|0;c[139476]=p;U=p}else U=m;m=qic(U,R,0)|0;co[f&2047](e,T,m)}r=r+1|0}while((r|0)!=(n|0));i=o;return}function BYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=Im;d=i;i=i+16|0;e=d+4|0;f=d;qud(a,557888,b)|0;h=mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0;j=mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0;k=c[a+48>>2]|0;l=a+48|0;if(!k){i=d;return}a=c[139472]|0;m=l;n=k;a:while(1){k=n;while(1){if((c[k+16>>2]|0)>=(a|0)){o=k;break}k=c[k+4>>2]|0;if(!k){p=m;break a}}n=c[o>>2]|0;if(!n){p=o;break}else m=o}if((p|0)==(l|0)){i=d;return}if((a|0)<(c[p+16>>2]|0)){i=d;return}a=p+24|0;if(!(c[a>>2]|0)){i=d;return}q=ea(g[b+64>>2]);r=ea(g[b+68>>2]);if(!(h+-1&h))s=(j+-1&j|0)==0;else s=0;if((!((mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0)!=2|s)?!(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0):0)?(c[b+52>>2]|0)!=6:0){s=RDc()|0;l=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;o=l?s:0;s=(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0)>>o;l=(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0)>>o;if((s|0)>0)t=ea(ea(h>>o|0)/ea(s|0));else t=ea(1.0);if((l|0)>0)u=ea(ea(j>>o|0)/ea(l|0));else u=ea(1.0);v=ea(q*t);t=ea(r*u);l=c[p+20>>2]|0;c[f>>2]=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;c[e+0>>2]=c[f+0>>2];lxd(l,e,v,t);e=c[a>>2]|0;g[e>>2]=v;g[e+4>>2]=t;g[e+8>>2]=ea(0.0);g[e+12>>2]=ea(0.0);i=d;return}e=c[a>>2]|0;g[e>>2]=q;g[e+4>>2]=r;g[e+8>>2]=ea(0.0);g[e+12>>2]=ea(0.0);i=d;return}function CYb(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);c[139472]=c[b>>2];c[139474]=13;c[139476]=0;i=a;return}function DYb(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;if(c[139480]|0){i=a;return}rri(b,609864,26);d=nUc(mUc()|0,48,b)|0;xri(b);b=bkd(d,61,0)|0;c[139480]=b;c[139478]=hkd(b)|0;i=a;return}function EYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[($hd(b+16|0)|0)+20>>2]|2097152;f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+20>>2]=e;e=c[142268]|0;add(b,2417856,e,a,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3145576,e,a+4|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3145560,e,a+8|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3145320,e,a+12|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function FYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;ddd(b,2);e=c[142268]|0;add(b,3143216,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2684928,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2497752,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function GYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function HYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,2417856,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,3145576,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,3145560,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;a=qdd(b,3145320,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function IYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function JYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=b;l=h}h=a+4|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[e>>2]=b;m=b;n=k}k=a+8|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+12|0;a=o+4|0;if(a>>>0>p>>>0){Bid(e,n,4);i=d;return}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=a;i=d;return}}function KYb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;d=a+12|0;f=c[d>>2]|0;h=f+4|0;j=a+20|0;a=c[j>>2]|0;if(h>>>0>a>>>0){Bid(d,b,4);k=c[d>>2]|0;l=c[j>>2]|0}else{g[b>>2]=ea(g[f>>2]);c[d>>2]=h;k=h;l=a}a=b+4|0;h=k+4|0;if(h>>>0>l>>>0){Bid(d,a,4);m=c[d>>2]|0;n=c[j>>2]|0}else{g[a>>2]=ea(g[k>>2]);c[d>>2]=h;m=h;n=l}l=b+8|0;h=m+4|0;if(h>>>0>n>>>0){Bid(d,l,4);o=c[d>>2]|0;p=c[j>>2]|0}else{g[l>>2]=ea(g[m>>2]);c[d>>2]=h;o=h;p=n}n=b+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(d,n,4);i=e;return}else{g[n>>2]=ea(g[o>>2]);c[d>>2]=b;i=e;return}}function LYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function MYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;a=w+4|0;if(a>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=XEi(z|0)|0;c[y>>2]=A;i=d;return}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=a;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=XEi(z|0)|0;c[y>>2]=A;i=d;return}}function NYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;a=w+4|0;if(a>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=XEi(z|0)|0;c[y>>2]=A;i=d;return}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=a;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=XEi(z|0)|0;c[y>>2]=A;i=d;return}}function OYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function PYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}j=a+12|0;a=o+4|0;if(a>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function QYb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;d=a+12|0;f=c[d>>2]|0;h=f+4|0;j=a+20|0;a=c[j>>2]|0;if(h>>>0<a>>>0){g[f>>2]=ea(g[b>>2]);c[d>>2]=h;k=h;l=a}else{Gid(d,b,4);k=c[d>>2]|0;l=c[j>>2]|0}a=b+4|0;h=k+4|0;if(h>>>0<l>>>0){g[k>>2]=ea(g[a>>2]);c[d>>2]=h;m=h;n=l}else{Gid(d,a,4);m=c[d>>2]|0;n=c[j>>2]|0}a=b+8|0;l=m+4|0;if(l>>>0<n>>>0){g[m>>2]=ea(g[a>>2]);c[d>>2]=l;o=l;p=n}else{Gid(d,a,4);o=c[d>>2]|0;p=c[j>>2]|0}j=b+12|0;b=o+4|0;if(b>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[d>>2]=b;i=e;return}else{Gid(d,j,4);i=e;return}}function RYb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[153134]|0;c[b>>2]=0;c[b+4>>2]=h;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=h;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=c[155410];c[b+36>>2]=0;c[b+40>>2]=0;h=c[153134]|0;j=b+44|0;c[j>>2]=0;k=b+48|0;c[k>>2]=h;h=b+52|0;l=b+56|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[b+72>>2]=d;VYb(b,ync()|0);d=c[l>>2]|0;if((d&2147483520)>>>0>=128){m=b+68|0;a[m>>0]=1;i=e;return}if((d|0)>-1){c[l>>2]=128;d=c[j>>2]|0;c[g>>2]=c[k>>2];c[f+0>>2]=c[g+0>>2];c[j>>2]=hOb(d,9728,4,f,0,3653512,370)|0;m=b+68|0;a[m>>0]=1;i=e;return}else{c[g>>2]=c[k>>2];c[f+0>>2]=c[g+0>>2];g=cOb(9728,4,f,0,3653512,352)|0;YEi(g|0,c[j>>2]|0,(c[h>>2]|0)*76|0)|0;c[l>>2]=128;c[j>>2]=g;m=b+68|0;a[m>>0]=1;i=e;return}}function SYb(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+16|0;k=j+4|0;l=j;if(c[b+8>>2]|0)WYb(b);m=c[h+4>>2]|0;if(mo[c[(c[e>>2]|0)+12>>2]&4095](e)|0)n=(m&1|0)!=0;else n=0;m=d[e+40>>0]|0;o=b+60|0;p=c[o>>2]|0;if(!((p|0)==(h|0)?!((c[b+64>>2]|0)!=(m|0)|n^1):0)){q=b+52|0;r=c[q>>2]|0;if(r){s=c[b+44>>2]|0;if((r|0)==1){t8b(s,c[s+72>>2]|0);t=c[s+64>>2]|0;co[c[(c[t>>2]|0)+8>>2]&2047](t,c[s+68>>2]|0,c[o>>2]|0)}else{c[k>>2]=s;c[k+4>>2]=r;if(!(a[b+68>>0]|0)){u=0;v=p}else{p=a[(NOc()|0)+95>>0]|0;u=p;v=c[o>>2]|0}a[k+8>>0]=u;u=c[s+64>>2]|0;co[c[(c[u>>2]|0)+16>>2]&2047](u,k,v)}c[q>>2]=0}c[o>>2]=h;c[b+64>>2]=m}if(!n){t8b(f,c[f+112>>2]|0);co[c[(c[e>>2]|0)+8>>2]&2047](e,g,h);i=j;return}h=b+44|0;n=b+52|0;m=(c[n>>2]|0)+1|0;c[n>>2]=m;o=b+56|0;q=c[o>>2]|0;v=q&2147483647;if(m>>>0>v>>>0){u=q<<1;s=(u|0)==0?1:u;do if(v>>>0<s>>>0)if((q|0)>-1){c[o>>2]=s;u=c[h>>2]|0;c[l>>2]=c[b+48>>2];c[k+0>>2]=c[l+0>>2];c[h>>2]=hOb(u,s*76|0,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[b+48>>2];c[k+0>>2]=c[l+0>>2];u=cOb(s*76|0,4,k,0,3653512,352)|0;YEi(u|0,c[h>>2]|0,(c[n>>2]|0)*76|0)|0;c[o>>2]=s;c[h>>2]=u;break}while(0);w=c[n>>2]|0}else w=m;m=w+-1|0;w=c[h>>2]|0;c[w+(m*76|0)+64>>2]=e;c[w+(m*76|0)+68>>2]=g;g=w+(m*76|0)+0|0;e=f+0|0;h=g+64|0;do{c[g>>2]=c[e>>2];g=g+4|0;e=e+4|0}while((g|0)<(h|0));c[w+(m*76|0)+72>>2]=c[f+112>>2];i=j;return}function TYb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=b+52|0;g=c[f>>2]|0;if(!g){i=d;return}h=c[b+44>>2]|0;if((g|0)==1){t8b(h,c[h+72>>2]|0);j=c[h+64>>2]|0;co[c[(c[j>>2]|0)+8>>2]&2047](j,c[h+68>>2]|0,c[b+60>>2]|0)}else{c[e>>2]=h;c[e+4>>2]=g;if(!(a[b+68>>0]|0))k=0;else k=a[(NOc()|0)+95>>0]|0;a[e+8>>0]=k;k=c[h+64>>2]|0;co[c[(c[k>>2]|0)+16>>2]&2047](k,e,c[b+60>>2]|0)}c[f>>2]=0;i=d;return}function UYb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;if(c[a+8>>2]|0)WYb(a);t8b(d,c[d+112>>2]|0);co[c[(c[b>>2]|0)+8>>2]&2047](b,e,f);i=g;return}function VYb(a,b){a=a|0;b=b|0;c[a+40>>2]=b;c[a+36>>2]=b+4;return}function WYb(a){a=a|0;var b=0,d=0;b=i;d=c[a+40>>2]|0;In[c[(c[d>>2]|0)+220>>2]&4095](d,a);c[a+8>>2]=0;c[a+24>>2]=0;c[a+32>>2]=c[155410];i=b;return}function XYb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=0,n=Im,o=Im,p=Im,q=Im;j=i;i=i+16|0;k=j;l=ea(g[b+124>>2]);m=ync()|0;tMc(e,m+3044|0);qud(h+20|0,558088,d)|0;if((c[b+212>>2]|0)==2){n=ea(g[b+104>>2]);o=ea(g[b+108>>2]);p=ea(g[b+112>>2]);q=ea(ea(1.0)/ea(g[b+184>>2]));g[m+644>>2]=n;g[m+648>>2]=o;g[m+652>>2]=p;g[m+656>>2]=q}q=ea(g[a+168>>2]);w9b(c[c[a>>2]>>2]|0,l,q,ea(g[a+172>>2]),k);a=m+676|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];if(f){g[k+12>>2]=ea(0.0);g[k+8>>2]=ea(0.0)}f=m+756|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];q=ea(ea(.5)/ea(mo[c[(c[d>>2]|0)+116>>2]&4095](d)|0));l=ea(ea(.5)/ea(mo[c[(c[d>>2]|0)+120>>2]&4095](d)|0));p=ea(-q);o=ea(-l);g[m+692>>2]=p;g[m+696>>2]=o;g[m+700>>2]=ea(0.0);g[m+704>>2]=ea(0.0);g[m+708>>2]=q;g[m+712>>2]=o;g[m+716>>2]=ea(0.0);g[m+720>>2]=ea(0.0);g[m+724>>2]=p;g[m+728>>2]=l;g[m+732>>2]=ea(0.0);g[m+736>>2]=ea(0.0);g[m+740>>2]=q;g[m+744>>2]=l;g[m+748>>2]=ea(0.0);g[m+752>>2]=ea(0.0);i=j;return}function YYb(d,f,h,j,k,l,m,n){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=Im,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;o=i;i=i+1552|0;p=o+296|0;q=o+312|0;r=o+1184|0;s=o+124|0;t=o+1544|0;u=o+1244|0;v=o+1320|0;w=o+1048|0;x=o+1036|0;y=o+168|0;z=o;A=o+1200|0;B=n8b()|0;C=c[B+88>>2]|0;D=B+92|0;B=c[158074]|0;K9b(B);E=ync()|0;In[c[(c[E>>2]|0)+196>>2]&4095](p,E);F=mo[c[(c[E>>2]|0)+192>>2]&4095](E)|0;G=L9b()|0;YEi(q|0,j|0,612)|0;j=(f|0)!=0;if(j)H=1;else H=(c[d+160>>2]|0)!=0;I=Fwc(Vwc()|0)|0;J=(a[621167]|0)==0?0:h;x9b(c[c[d>>2]>>2]|0,r,d+168|0,d+172|0);h=E+916|0;c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[h+12>>2]=c[r+12>>2];do if(j)if(!J){r=d+56|0;h=d+128|0;g[h>>2]=ea(ea(g[h>>2])+ea(-.00999999977));h=d+132|0;g[h>>2]=ea(ea(g[h>>2])+ea(-.00999999977));h=d+136|0;g[h>>2]=ea(ea(g[h>>2])+ea(-.00999999977));h=d+140|0;g[h>>2]=ea(ea(g[h>>2])+ea(.00999999977));h=d+144|0;g[h>>2]=ea(ea(g[h>>2])+ea(.00999999977));h=d+148|0;g[h>>2]=ea(ea(g[h>>2])+ea(.00999999977));c[r>>2]=f;mBc(1);ZYb(d,r,q,G,I,m,B);r=(c[d+60>>2]|0)==0?0:f;mBc(0);K=r;break}else{c[d+60>>2]=J;K=f;break}else K=0;while(0);f=d+152|0;I=c[f>>2]|0;j=d+160|0;r=c[j>>2]|0;h=I+(r*96|0)|0;if(r){r=I;do{I=r+72|0;g[I>>2]=ea(ea(g[I>>2])+ea(-.00999999977));I=r+76|0;g[I>>2]=ea(ea(g[I>>2])+ea(-.00999999977));I=r+80|0;g[I>>2]=ea(ea(g[I>>2])+ea(-.00999999977));I=r+84|0;g[I>>2]=ea(ea(g[I>>2])+ea(.00999999977));I=r+88|0;g[I>>2]=ea(ea(g[I>>2])+ea(.00999999977));I=r+92|0;g[I>>2]=ea(ea(g[I>>2])+ea(.00999999977));ZYb(d,r,q,G,0,m,B);r=r+96|0}while((r|0)!=(h|0))}if(H){y$b(c[c[d>>2]>>2]|0,B,2);K9b(B)}h=X8b()|0;r=Vwc()|0;y8b(r);q=c[d+48>>2]|0;I=c[d>>2]|0;L=c[I+108>>2]|0;In[c[(c[E>>2]|0)+104>>2]&4095](E,I+12|0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=-1;c[s+12>>2]=-1;c[s+16>>2]=-1;g[s+20>>2]=ea(-1.0);I=s+24|0;b[I+2>>1]=255;b[I>>1]=255;c[s+28>>2]=12;c[s+32>>2]=-1;c[s+36>>2]=0;c[s+40>>2]=-1;In[c[(c[E>>2]|0)+72>>2]&4095](E,l);if(m)J$b(c[c[d>>2]>>2]|0,0);else ko[c[(c[E>>2]|0)+404>>2]&4095](E);D8b(h);Bcc((c[c[d>>2]>>2]|0)+636|0,n?10:16,B);RYb(u,t);N_b(v,u,t);Q_b(w,u,t);S_b(x,u,t);C7b(y,l7b()|0);k7b(z);if(!q)M=C;else{t=d+40|0;h=d+4|0;m=d+8|0;l=d+24|0;I=A+4|0;N=A+8|0;O=A+12|0;P=A+16|0;Q=A+20|0;R=A+24|0;S=A+28|0;T=A+32|0;U=A+36|0;V=A+40|0;W=v+108|0;X=v+216|0;Y=d+56|0;Z=A+24|0;_=(K|0)!=0;$=d+60|0;aa=d+64|0;ba=w+128|0;ca=C;C=0;da=L;L=0;while(1){fa=c[t>>2]|0;ga=c[fa+(L<<3)>>2]|0;ha=c[c[h>>2]>>2]|0;ia=(c[l>>2]|0)+(c[(c[m>>2]|0)+(ga<<2)>>2]|0)|0;ja=b[ha+(ga*44|0)+4>>1]|0;a:do if((ja|0)>(da|0)){TYb(u);if(!(a[(c[d>>2]|0)+105>>0]|0))if((ca|0)==(D|0)){ka=D;la=ja}else{ma=ca;while(1){if((c[ma+16>>2]|0)>(ja|0)){ka=ma;la=ja;break a}na=c[ma+20>>2]|0;co[c[c[na>>2]>>2]&2047](na,c[(c[d>>2]|0)+4>>2]|0,B);na=c[ma+4>>2]|0;if(!na){oa=ma;while(1){pa=c[oa+8>>2]|0;if((c[pa>>2]|0)==(oa|0)){qa=pa;break}else oa=pa}}else{oa=na;while(1){pa=c[oa>>2]|0;if(!pa){qa=oa;break}else oa=pa}}if((qa|0)==(D|0)){ka=qa;la=ja;break}else ma=qa}}else{ka=ca;la=ja}}else{ka=ca;la=da}while(0);ja=c[ha+(ga*44|0)+28>>2]|0;ma=b[ha+(ga*44|0)+6>>1]|0;oa=ha+(ga*44|0)|0;c[A>>2]=c[oa>>2];c[I>>2]=c[ha+(ga*44|0)+32>>2];na=ja+116|0;pa=c[(c[na>>2]|0)+168>>2]|0;if(!pa)ra=0;else ra=c[pa+32>>2]|0;c[N>>2]=ra;pa=ha+(ga*44|0)+8|0;c[O>>2]=(b[pa>>1]<<1&65535)<<16>>16>>1<<16>>16;c[P>>2]=(e[pa>>1]|0)>>>15&65535;g[Q>>2]=ea(g[ja+120>>2]);c[R>>2]=c[ha+(ga*44|0)+12>>2];pa=fa+(L<<3)+4|0;sa=c[pa>>2]|0;c[S>>2]=sa>>>8&255;c[T>>2]=sa&255;c[U>>2]=ia;if(H?(a[(c[na>>2]|0)+42>>0]|0)!=0:0)ta=Tac(c[(c[d>>2]|0)+8>>2]|0,ja+64|0)|0;else ta=0;c[V>>2]=ta&1;sa=ha+(ga*44|0)+16|0;if(!(c[sa>>2]|0))ua=(c[pa>>2]&33554432|0)!=0|k;else ua=0;do if((c[S>>2]|0)!=5?bZb(A,s)|0:0){if(!ua?!(emd(c[I>>2]|0,ea(g[Q>>2]))|0):0){va=0;break}TYb(u);va=0}else wa=34;while(0);if((wa|0)==34){wa=0;TYb(u);xa=s+0|0;ya=A+0|0;za=xa+44|0;do{c[xa>>2]=c[ya>>2];xa=xa+4|0;ya=ya+4|0}while((xa|0)<(za|0));K_b(E,B,ea(g[Q>>2]));va=1}T_b(x,c[na>>2]|0,c[sa>>2]|0);b:do if((c[S>>2]|0)==4){ga=c[U>>2]|0;ha=0;while(1){if((c[W+(ha<<2)>>2]|0)!=(c[ga+(ha<<2)>>2]|0))break;ha=ha+1|0;if((ha|0)>=27)break b}xa=W+0|0;ya=ga+0|0;za=xa+108|0;do{c[xa>>2]=c[ya>>2];xa=xa+4|0;ya=ya+4|0}while((xa|0)<(za|0));O_b(c[X>>2]|0,ga)}else{ha=0;while(1){if((c[W+(ha<<2)>>2]|0)!=(c[v+(ha<<2)>>2]|0))break;ha=ha+1|0;if((ha|0)>=27)break b}xa=W+0|0;ya=v+0|0;za=xa+108|0;do{c[xa>>2]=c[ya>>2];xa=xa+4|0;ya=ya+4|0}while((xa|0)<(za|0));O_b(c[X>>2]|0,v)}while(0);b8b(c[na>>2]|0,ja+64|0,y,z);if(FEi(w,z,124)|0){xa=w+0|0;ya=z+0|0;za=xa+124|0;do{c[xa>>2]=c[ya>>2];xa=xa+4|0;ya=ya+4|0}while((xa|0)<(za|0));R_b(c[ba>>2]|0,z)}sa=c[S>>2]|0;if((sa|0)==5){ha=c[U>>2]|0;ga=c[ha+112>>2]|0;ia=ha+128|0;if((ga|0)>0){ha=ga+-1|0;fa=ma&65535;pa=0;while(1){Aa=c[ia+(pa<<2)>>2]|0;Ba=c[Aa>>2]|0;if((pa|0)==(ha|0))Ca=ea(g[(c[U>>2]|0)+120>>2]);else Ca=ea(1.0);E5b(Ba,Ca);Da=Ba+212|0;if((c[Da>>2]|0)!=1)Z4b(Aa+48|0,(c[d>>2]|0)+76|0,0,E);c:do if(c[V>>2]|0){if(!(c[Ba+116>>2]|0))break;if((c[Y>>2]|0)!=(Aa|0)){Ea=c[f>>2]|0;Fa=c[j>>2]|0;Ga=Ea+(Fa*96|0)|0;if(!Fa)break;else Ha=Ea;while(1){if((c[Ha>>2]|0)==(Aa|0)){Ia=Ha;break}Ha=Ha+96|0;if((Ha|0)==(Ga|0))break c}if(!Ia)break;else Ja=Ia}else Ja=Y;Ga=c[Ja+4>>2]|0;if(!Ga)break;Ea=c[Aa>>2]|0;XYb(d,Ea,Ga,Ja+8|0,0,B);Ga=c[Ea+212>>2]|0;M9b(B,Ga,c[Ea+116>>2]|0,(Ga|0)==1,G)}while(0);Aa=ekd(c[A>>2]|0,c[T>>2]|0,c[I>>2]|0,B,c[O>>2]|0)|0;if(Aa)UYb(u,c[na>>2]|0,ja,fa,Aa);do if(c[V>>2]|0){if(!(c[Ba+116>>2]|0))break;K9b(B)}while(0);if((c[Da>>2]|0)!=1)_4b(F,p,E);pa=pa+1|0;if((pa|0)>=(ga|0)){Ka=Aa;break}}}else Ka=C}else{if(va){d:do switch(sa|0){case 4:{In[c[(c[E>>2]|0)+100>>2]&4095](E,601008);D5b(c[U>>2]|0);x8b(r,Z);ga=c[V>>2]|0;do if((ga|0)!=0&_){if((c[(c[U>>2]|0)+108>>2]|0)!=(K|0))break;pa=c[K>>2]|0;XYb(d,pa,c[$>>2]|0,aa,0,B);M9b(B,c[pa+212>>2]|0,c[pa+116>>2]|0,1,G);break d}while(0);if(!ga)break d;Aa=c[(c[U>>2]|0)+108>>2]|0;if(!Aa)break d;Da=c[Aa>>2]|0;pa=Da+116|0;if(!(c[pa>>2]|0))break d;fa=c[f>>2]|0;ha=c[j>>2]|0;ia=fa+(ha*96|0)|0;if(!ha)break d;else La=fa;while(1){if((c[La>>2]|0)==(Aa|0)?(fa=c[La+4>>2]|0,(fa|0)!=0):0){Ma=fa;Na=La;break}La=La+96|0;if((La|0)==(ia|0))break d}XYb(d,Da,Ma,Na+8|0,0,B);ia=c[Da+212>>2]|0;M9b(B,ia,c[pa>>2]|0,(ia|0)==1,G);break}case 0:{In[c[(c[E>>2]|0)+248>>2]&4095](E,0);x8b(r,Z);break}case 3:case 2:case 1:{In[c[(c[E>>2]|0)+100>>2]&4095](E,601008);x8b(r,Z);ia=c[U>>2]|0;C5b(c[ia+116>>2]|0,ia+128|0);break}default:{}}while(0);Oa=ekd(c[oa>>2]|0,c[T>>2]|0,c[I>>2]|0,B,c[O>>2]|0)|0}else Oa=C;if(Oa)SYb(u,c[na>>2]|0,ja,ma&65535,Oa);if((c[S>>2]|0)==4){K9b(B);Ka=Oa}else Ka=Oa}L=L+1|0;if(L>>>0>=q>>>0){M=ka;break}else{ca=ka;C=Ka;da=la}}}TYb(u);K9b(B);_4b(F,p,E);p=d+60|0;F=c[p>>2]|0;if(!((F|0)==0|(F|0)==(J|0))){J=Gzc()|0;Jzc(J,c[p>>2]|0)}p=c[f>>2]|0;f=c[j>>2]|0;j=p+(f*96|0)|0;if(f){f=p;do{p=f+4|0;if(c[p>>2]|0){J=Gzc()|0;Jzc(J,c[p>>2]|0)}f=f+96|0}while((f|0)!=(j|0))}j=c[d>>2]|0;if((a[j+105>>0]|0)!=0|(M|0)==(D|0)){Pa=ync()|0;Qa=c[Pa>>2]|0;Ra=Qa+72|0;Sa=c[Ra>>2]|0;In[Sa&4095](Pa,0);Ta=c[E>>2]|0;Ua=Ta+104|0;Va=c[Ua>>2]|0;Wa=c[d>>2]|0;Xa=Wa+12|0;In[Va&4095](E,Xa);Ya=c[d>>2]|0;Za=c[Ya>>2]|0;_a=n?11:17;$a=Za+636|0;Bcc($a,_a,B);aZb(u);i=o;return}f=c[j+108>>2]|0;p=M;while(1){if((c[p+16>>2]|0)>=(f|0)){ab=p;break}M=c[p+4>>2]|0;if(!M){J=p;while(1){F=c[J+8>>2]|0;if((c[F>>2]|0)==(J|0)){bb=F;break}else J=F}}else{J=M;while(1){ma=c[J>>2]|0;if(!ma){bb=J;break}else J=ma}}if((bb|0)==(D|0)){ab=bb;break}else p=bb}if((ab|0)==(D|0)){Pa=ync()|0;Qa=c[Pa>>2]|0;Ra=Qa+72|0;Sa=c[Ra>>2]|0;In[Sa&4095](Pa,0);Ta=c[E>>2]|0;Ua=Ta+104|0;Va=c[Ua>>2]|0;Wa=c[d>>2]|0;Xa=Wa+12|0;In[Va&4095](E,Xa);Ya=c[d>>2]|0;Za=c[Ya>>2]|0;_a=n?11:17;$a=Za+636|0;Bcc($a,_a,B);aZb(u);i=o;return}else{cb=ab;db=j}while(1){if((c[cb+16>>2]|0)>=(c[db+112>>2]|0)){wa=115;break}j=c[cb+20>>2]|0;co[c[c[j>>2]>>2]&2047](j,c[db+4>>2]|0,B);j=c[cb+4>>2]|0;if(!j){ab=cb;while(1){bb=c[ab+8>>2]|0;if((c[bb>>2]|0)==(ab|0)){eb=bb;break}else ab=bb}}else{ab=j;while(1){bb=c[ab>>2]|0;if(!bb){eb=ab;break}else ab=bb}}if((eb|0)==(D|0)){wa=115;break}cb=eb;db=c[d>>2]|0}if((wa|0)==115){Pa=ync()|0;Qa=c[Pa>>2]|0;Ra=Qa+72|0;Sa=c[Ra>>2]|0;In[Sa&4095](Pa,0);Ta=c[E>>2]|0;Ua=Ta+104|0;Va=c[Ua>>2]|0;Wa=c[d>>2]|0;Xa=Wa+12|0;In[Va&4095](E,Xa);Ya=c[d>>2]|0;Za=c[Ya>>2]|0;_a=n?11:17;$a=Za+636|0;Bcc($a,_a,B);aZb(u);i=o;return}}function ZYb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;h=i;i=i+256|0;k=h;l=c[c[d>>2]>>2]|0;m=l+212|0;n=l+116|0;M9b(j,c[m>>2]|0,c[n>>2]|0,0,f);o=ync()|0;In[c[(c[o>>2]|0)+104>>2]&4095](o,(c[b>>2]|0)+12|0);o=d+4|0;c[o>>2]=N9b(e,c[d>>2]|0,d+72|0,j,k)|0;tMc(k,d+8|0);if(!((a[621167]|0)==0|(c[o>>2]|0)==0)?(c[m>>2]|0)==1:0){M9b(j,1,c[n>>2]|0,0,f);f=c[o>>2]|0;y$b(c[c[b>>2]>>2]|0,j,0);XYb(b,l,f,k,g,j);P9b(k,e,j);I4b(l,ea(1.0));c[o>>2]=O9b(c[c[b>>2]>>2]|0,f,c[n>>2]|0,j)|0;i=h;return}K9b(j);i=h;return}function _Yb(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;n=i;i=i+304|0;o=n;p=n+296|0;q=n+120|0;r=n+4|0;s=pyc()|0;t=c[s+40>>2]|0;u=c[s+24>>2]|0;v=ea(wyc());if(f?Y$b(c[d>>2]|0)|0:0){w=0;x=(a[(NOc()|0)+103>>0]|0)!=0}else{w=1;x=0}if((c[155255]|0)>2)y=(a[621171]|0)!=0;else y=0;s=c[153134]|0;c[q+8>>2]=0;z=q+12|0;c[z>>2]=s;A=q+16|0;c[A>>2]=0;B=q+20|0;c[B>>2]=0;c[q+24>>2]=0;C=q+28|0;c[C>>2]=s;D=q+32|0;c[D>>2]=0;E=q+36|0;c[E>>2]=0;F=q+40|0;c[F>>2]=0;G=q+44|0;c[G>>2]=s;H=q+48|0;I=q+128|0;J=q+140|0;K=q+144|0;L=q+148|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;c[I+16>>2]=0;c[H+0>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;c[I+0>>2]=c[150280];c[I+4>>2]=c[150281];c[I+8>>2]=c[150282];M=ea(-ea(g[150280]));N=ea(-ea(g[150281]));O=ea(-ea(g[150282]));g[J>>2]=M;g[K>>2]=N;g[L>>2]=O;c[q+152>>2]=0;c[q+156>>2]=s;c[q+160>>2]=0;c[q+164>>2]=0;c[q>>2]=d;c[q+4>>2]=e;P=q+8|0;Q=e+8|0;R=c[Q>>2]|0;if(!R){S=0;T=0}else{c[B>>2]=R;c[p>>2]=s;c[o+0>>2]=c[p+0>>2];c[P>>2]=hOb(0,R<<2,4,o,0,3653512,370)|0;S=c[E>>2]|0;T=(c[Q>>2]|0)*140|0}R=q+24|0;do if((S&2147483647)>>>0<T>>>0)if((S|0)>-1){c[E>>2]=T;s=c[R>>2]|0;c[p>>2]=c[C>>2];c[o+0>>2]=c[p+0>>2];c[R>>2]=hOb(s,T,1,o,0,3653512,370)|0;break}else{c[p>>2]=c[C>>2];c[o+0>>2]=c[p+0>>2];s=cOb(T,1,o,0,3653512,352)|0;YEi(s|0,c[R>>2]|0,c[D>>2]|0)|0;c[E>>2]=T;c[R>>2]=s;break}while(0);T=u8b()|0;E=c[d+4>>2]|0;C=X8b()|0;S=r+0|0;s=S+116|0;do{c[S>>2]=0;S=S+4|0}while((S|0)<(s|0));U=(Hwc(Vwc()|0)|0)==1&1;a[r>>0]=a[r>>0]&-3|U<<1&255;c[r+4>>2]=c[u+(t*96|0)+12>>2];S=r+8|0;t=C+296|0;s=S+108|0;do{c[S>>2]=c[t>>2];S=S+4|0;t=t+4|0}while((S|0)<(s|0));t=c[e>>2]|0;S=t+((c[Q>>2]|0)*44|0)|0;Q=E+184|0;if(!(c[Q>>2]|0))V=t;else{Gnd(Q);V=c[e>>2]|0}if((V|0)==(S|0))W=0;else{e=E+92|0;Q=E+216|0;t=y^1;s=q+52|0;C=q+40|0;u=d+8|0;U=d+12|0;X=q+152|0;Y=q+132|0;Z=q+136|0;_=E+208|0;$=E+192|0;E=V;V=0;aa=0;while(1){ba=c[E+28>>2]|0;ca=ba-(c[e>>2]|0)>>7;da=c[ba+116>>2]|0;fa=(b[E+12>>1]&-2)<<16>>16!=254|a[r>>0]&-2;a[r>>0]=fa;ga=c[(c[E+32>>2]|0)+52>>2]|0;ha=(c[A>>2]|0)+1|0;c[A>>2]=ha;ia=c[B>>2]|0;ja=ia&2147483647;if(ha>>>0>ja>>>0){ka=ia<<1;la=(ka|0)==0?1:ka;do if(ja>>>0<la>>>0)if((ia|0)>-1){c[B>>2]=la;ka=c[P>>2]|0;c[p>>2]=c[z>>2];c[o+0>>2]=c[p+0>>2];c[P>>2]=hOb(ka,la<<2,4,o,0,3653512,370)|0;break}else{c[p>>2]=c[z>>2];c[o+0>>2]=c[p+0>>2];ka=cOb(la<<2,4,o,0,3653512,352)|0;YEi(ka|0,c[P>>2]|0,c[A>>2]<<2|0)|0;c[B>>2]=la;c[P>>2]=ka;break}while(0);ma=c[A>>2]|0;na=a[r>>0]|0}else{ma=ha;na=fa}la=ma+-1|0;ia=c[P>>2]|0;ja=na&-5;a[r>>0]=ja;ka=E+8|0;oa=b[ka>>1]|0;do if((oa&32767)==32767){pa=c[ga+20>>2]|0;if((pa|0)==-1){qa=c[ga+((na&1)<<2)+12>>2]|0;a[r>>0]=na|4;if((qa|0)==-1){ra=V;break}sa=b[ka>>1]|0;ta=qa}else{sa=oa;ta=pa}pa=sa&-32768|ta&32767;b[ka>>1]=pa;ua=pa;va=a[r>>0]|0;wa=27}else{ua=oa;va=ja;wa=27}while(0);if((wa|0)==27){wa=0;ja=c[(c[ga>>2]|0)+((ua<<1&65535)<<16>>16>>1<<16>>16<<2)>>2]|0;oa=va&-9;a[r>>0]=oa;if(!(va&4))a[r>>0]=(a[ja+40>>0]<<3&255|oa)^8;oa=c[D>>2]|0;c[ia+(la<<2)>>2]=oa;if(!(c[Q>>2]|0)){xa=0;ya=0}else{ka=c[_>>2]|0;fa=c[ka+(ca<<2)>>2]|0;xa=(c[$>>2]|0)+(fa<<3)|0;ya=(c[ka+(ca+1<<2)>>2]|0)-fa|0}J5b(R,xa,ya,k,ba,r);fa=c[R>>2]|0;ka=fa+(oa+112)|0;ha=(c[ka>>2]|0)!=0;if(!(w|(a[da+42>>0]|0)==0)?(pa=ba+64|0,Tac(c[u>>2]|0,pa)|0):0){qa=c[fa+(oa+108)>>2]|0;do if((qa|0)!=0?(c[(c[qa>>2]|0)+116>>2]|0)!=0:0){za=(V|0)==0?qa:V;if((za|0)==(qa|0)){O=ea(g[pa>>2]);Aa=ba+76|0;N=ea(O+ea(g[Aa>>2]));Ba=ba+68|0;O=ea(g[Ba>>2]);Ca=ba+80|0;M=ea(O+ea(g[Ca>>2]));Da=ba+72|0;O=ea(g[Da>>2]);Ea=ba+84|0;Fa=ea(O+ea(g[Ea>>2]));O=ea(g[I>>2]);Ga=N<O?N:O;O=ea(g[Y>>2]);Ha=M<O?M:O;O=ea(g[Z>>2]);Ia=Fa<O?Fa:O;g[I>>2]=Ga;g[Y>>2]=Ha;g[Z>>2]=Ia;O=ea(g[J>>2]);Ja=O<N?N:O;O=ea(g[K>>2]);N=O<M?M:O;O=ea(g[L>>2]);M=O<Fa?Fa:O;g[J>>2]=Ja;g[K>>2]=N;g[L>>2]=M;O=ea(g[pa>>2]);Fa=ea(O-ea(g[Aa>>2]));O=ea(g[Ba>>2]);Ka=ea(O-ea(g[Ca>>2]));O=ea(g[Da>>2]);La=ea(O-ea(g[Ea>>2]));g[I>>2]=Fa<Ga?Fa:Ga;g[Y>>2]=Ka<Ha?Ka:Ha;g[Z>>2]=La<Ia?La:Ia;g[J>>2]=Ja<Fa?Fa:Ja;g[K>>2]=N<Ka?Ka:N;g[L>>2]=M<La?La:M;Ma=qa;break}else{dZb(pa,qa,U,v,X);Ma=za;break}}else Ma=V;while(0);if((x?(a[ja+41>>0]|0)!=0:0)?(qa=c[ka>>2]|0,ba=fa+(oa+128)|0,(qa|0)>0):0){da=0;do{ca=c[ba+(da<<2)>>2]|0;do if(c[(c[ca>>2]|0)+116>>2]|0){if((a[ca+8>>0]|0)==0|(ca|0)==(Ma|0))break;dZb(pa,ca,U,v,X)}while(0);da=da+1|0}while((da|0)!=(qa|0));Na=Ma}else Na=Ma}else Na=V;qa=c[ja+16>>2]|0;da=(qa|0)>0;if(da){pa=c[ja>>2]|0;ba=a[r>>0]|0;oa=ha^1;if(ba&4)if(!(ba&1)){ba=0;fa=0;while(1){ka=c[pa+(ba<<2)>>2]|0;ca=c[ka+660>>2]|0;la=c[ka+584>>2]|0;if((ca&T|0)!=(ca|0)|la>>>0>3|(la&-2|0)==2)Oa=0;else Oa=((la|0)!=2|t)&((la|0)!=3|y)&1;la=Oa+fa|0;ba=ba+1|0;if(!((ba|0)<(qa|0)&(la|0)<2)){Pa=la;break}else fa=la}}else{fa=0;ba=0;while(1){la=c[pa+(fa<<2)>>2]|0;ca=c[la+660>>2]|0;ka=c[la+584>>2]|0;if((ca&T|0)!=(ca|0)|ka>>>0>3|(ka|0)==1)Qa=0;else Qa=((ka|0)!=2|t)&((ka|0)!=3|y)&1;ka=Qa+ba|0;fa=fa+1|0;if(!((fa|0)<(qa|0)&(ka|0)<2)){Pa=ka;break}else ba=ka}}else{ba=0;fa=0;while(1){ka=c[pa+(ba<<2)>>2]|0;ca=c[ka+660>>2]|0;la=c[ka+584>>2]|0;do if((ca&T|0)==(ca|0)){if(!((la|0)==0|(la|0)==4|(la|0)==5)){Ra=0;break}Ra=(la|0)==5&oa&1^1}else Ra=0;while(0);la=Ra+fa|0;ba=ba+1|0;if(!((ba|0)<(qa|0)&(la|0)<2)){Pa=la;break}else fa=la}}fa=(Pa|0)>1?33554432:0;if(da){ba=ha^1;oa=16777216;pa=0;while(1){la=c[(c[ja>>2]|0)+(pa<<2)>>2]|0;ca=c[la+660>>2]|0;ka=c[la+584>>2]|0;la=a[r>>0]|0;ia=(la&1)!=0;do if((ca&T|0)==(ca|0)){if(!(la&4)){if(!((ka|0)==0|(ka|0)==4|(ka|0)==5)){Sa=oa;break}if((ka|0)==5&ba){Sa=oa;break}}else{if(ka>>>0>3){Sa=oa;break}if(!((ka|0)!=1|ia^1)){Sa=oa;break}if(!((ka&-2|0)!=2|ia)){Sa=oa;break}if(!(((ka|0)!=2|t)&((ka|0)!=3|y))){Sa=oa;break}}ga=oa|fa|pa&255|ka<<8;za=(c[H>>2]|0)+1|0;c[H>>2]=za;Ea=c[s>>2]|0;Da=Ea&2147483647;if(za>>>0>Da>>>0){Ca=Ea<<1;Ba=(Ca|0)==0?1:Ca;do if(Da>>>0<Ba>>>0)if((Ea|0)>-1){c[s>>2]=Ba;Ca=c[C>>2]|0;c[p>>2]=c[G>>2];c[o+0>>2]=c[p+0>>2];c[C>>2]=hOb(Ca,Ba<<3,4,o,0,3653512,370)|0;break}else{c[p>>2]=c[G>>2];c[o+0>>2]=c[p+0>>2];Ca=cOb(Ba<<3,4,o,0,3653512,352)|0;YEi(Ca|0,c[C>>2]|0,c[H>>2]<<3|0)|0;c[s>>2]=Ba;c[C>>2]=Ca;break}while(0);Ta=c[H>>2]|0}else Ta=za;Ba=(c[C>>2]|0)+(Ta+-1<<3)|0;c[Ba>>2]=aa;c[Ba+4>>2]=ga;Sa=0}else Sa=oa;while(0);pa=pa+1|0;if((pa|0)>=(qa|0)){ra=Na;break}else oa=Sa}}else ra=Na}else ra=Na}E=E+44|0;if((E|0)==(S|0)){W=ra;break}else{V=ra;aa=aa+1|0}}}aa=c[F>>2]|0;F=aa+(c[H>>2]<<3)|0;if(f){c[o>>2]=q;eZb(aa,F,o)}else{c[o>>2]=q;fZb(aa,F,o)}o=c[(c[d>>2]|0)+348>>2]|0;F=c[d+8>>2]|0;if(!l){Ua=0;YYb(q,W,j,F,h,Ua,m,f);cZb(q);i=n;return}if(!o){Ua=1;YYb(q,W,j,F,h,Ua,m,f);cZb(q);i=n;return}Ua=(a[o+130>>0]|0)!=0;YYb(q,W,j,F,h,Ua,m,f);cZb(q);i=n;return}function $Yb(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,565136);c[139522]=c[b>>2];i=a;return}function aZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+56>>2]|0)>-1){f=a+44|0;g=c[f>>2]|0;c[e>>2]=c[a+48>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function bZb(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=0,k=Im,l=Im,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im;d=i;if((a|0)==(b|0)){e=1;i=d;return e|0}if((c[a>>2]|0)!=(c[b>>2]|0)){e=0;i=d;return e|0}if((c[a+4>>2]|0)!=(c[b+4>>2]|0)){e=0;i=d;return e|0}if((c[a+12>>2]|0)!=(c[b+12>>2]|0)){e=0;i=d;return e|0}if((c[a+8>>2]|0)!=(c[b+8>>2]|0)){e=0;i=d;return e|0}if((c[a+16>>2]|0)!=(c[b+16>>2]|0)){e=0;i=d;return e|0}f=ea(g[a+20>>2]);h=ea(g[b+20>>2]);j=(f>ea(0.0)&1)-(f<ea(0.0)&1)|0;if((j|0)!=((h>ea(0.0)&1)-(h<ea(0.0)&1)|0)){e=0;i=d;return e|0}if((j|0)<0){k=ea(f-h);if(k<ea(0.0))l=ea(-k);else l=k;if(!(l<=ea(9.99999997e-07))){e=0;i=d;return e|0}}else{l=ea(f*ea(16.0));if(!(l>=ea(0.0)))m=ea(l+ea(-.99999994));else m=l;l=ea(h*ea(16.0));if(!(l>=ea(0.0)))n=ea(l+ea(-.99999994));else n=l;if((~~m|0)!=(~~n|0)){e=0;i=d;return e|0}}if((c[a+24>>2]|0)!=(c[b+24>>2]|0)){e=0;i=d;return e|0}j=c[a+36>>2]|0;o=c[b+36>>2]|0;if(!((j|0)!=0&(o|0)!=0)){e=0;i=d;return e|0}if((c[j+108>>2]|0)!=(c[o+108>>2]|0)){e=0;i=d;return e|0}p=c[j+116>>2]|0;if((p|0)!=(c[o+116>>2]|0)){e=0;i=d;return e|0}q=c[j+112>>2]|0;if((q|0)!=(c[o+112>>2]|0)){e=0;i=d;return e|0}r=q+p|0;p=j+128|0;q=o+128|0;a:do if((r|0)>0){s=0;while(1){if((c[p+(s<<2)>>2]|0)!=(c[q+(s<<2)>>2]|0)){e=0;break}s=s+1|0;if((s|0)>=(r|0))break a}i=d;return e|0}while(0);n=ea(g[j+120>>2]);m=ea(n-ea(g[o+120>>2]));if(m<ea(0.0))t=ea(-m);else t=m;if(!(t<=ea(9.99999997e-07))){e=0;i=d;return e|0}t=ea(g[j+124>>2]);m=ea(t-ea(g[o+124>>2]));if(m<ea(0.0))u=ea(-m);else u=m;if(!(u<=ea(9.99999997e-07))){e=0;i=d;return e|0}if((c[a+28>>2]|0)!=(c[b+28>>2]|0)){e=0;i=d;return e|0}if((c[a+32>>2]|0)!=(c[b+32>>2]|0)){e=0;i=d;return e|0}e=(c[a+40>>2]|0)==(c[b+40>>2]|0);i=d;return e|0}function cZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+164>>2]|0)>-1){f=a+152|0;g=c[f>>2]|0;c[e>>2]=c[a+156>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+52>>2]|0)>-1){f=a+40|0;g=c[f>>2]|0;c[e>>2]=c[a+44>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+36>>2]|0)>-1){f=a+24|0;g=c[f>>2]|0;c[e>>2]=c[a+28>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+20>>2]|0)<=-1){i=b;return}f=a+8|0;g=c[f>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function dZb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=0,w=Im,x=0,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=0,J=0,K=Im,L=Im,M=0,N=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h;m=c[f>>2]|0;n=f+8|0;o=c[n>>2]|0;p=m+(o*96|0)|0;a:do if(o){q=m;while(1){if((c[q>>2]|0)==(b|0)){r=q;break}q=q+96|0;if((q|0)==(p|0))break a}s=ea(g[a>>2]);q=a+12|0;t=ea(s+ea(g[q>>2]));u=a+4|0;s=ea(g[u>>2]);v=a+16|0;w=ea(s+ea(g[v>>2]));x=a+8|0;s=ea(g[x>>2]);y=a+20|0;z=ea(s+ea(g[y>>2]));A=r+72|0;s=ea(g[A>>2]);B=t<s?t:s;C=r+76|0;s=ea(g[C>>2]);D=w<s?w:s;E=r+80|0;s=ea(g[E>>2]);F=z<s?z:s;g[A>>2]=B;g[C>>2]=D;g[E>>2]=F;G=r+84|0;s=ea(g[G>>2]);H=s<t?t:s;I=r+88|0;s=ea(g[I>>2]);t=s<w?w:s;J=r+92|0;s=ea(g[J>>2]);w=s<z?z:s;g[G>>2]=H;g[I>>2]=t;g[J>>2]=w;s=ea(g[a>>2]);z=ea(s-ea(g[q>>2]));s=ea(g[u>>2]);K=ea(s-ea(g[v>>2]));s=ea(g[x>>2]);L=ea(s-ea(g[y>>2]));g[A>>2]=z<B?z:B;g[C>>2]=K<D?K:D;g[E>>2]=L<F?L:F;g[G>>2]=H<z?z:H;g[I>>2]=t<K?K:t;g[J>>2]=w<L?L:w;i=h;return}while(0);r=c[b>>2]|0;do if((c[r+212>>2]|0)!=1){rGc(l,BTb(c[r+24>>2]|0)|0);w=ea(g[l>>2]);L=ea(g[l+4>>2]);t=ea(g[l+8>>2]);K=ea(w*ea(g[d+8>>2]));w=ea(K+ea(L*ea(g[d+24>>2])));L=ea(w+ea(t*ea(g[d+40>>2])));t=ea(-ea(ea(g[d+56>>2])+L));if(ea(t-ea(g[r+184>>2]))>e){i=h;return}else{M=c[n>>2]|0;break}}else M=o;while(0);o=M+1|0;c[n>>2]=o;M=f+12|0;r=c[M>>2]|0;d=r&2147483647;if(o>>>0>d>>>0){l=r<<1;p=(l|0)==0?1:l;do if(d>>>0<p>>>0)if((r|0)>-1){c[M>>2]=p;l=c[f>>2]|0;c[k>>2]=c[f+4>>2];c[j+0>>2]=c[k+0>>2];c[f>>2]=hOb(l,p*96|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[f+4>>2];c[j+0>>2]=c[k+0>>2];l=cOb(p*96|0,4,j,0,3653512,352)|0;YEi(l|0,c[f>>2]|0,(c[n>>2]|0)*96|0)|0;c[M>>2]=p;c[f>>2]=l;break}while(0);N=c[n>>2]|0}else N=o;o=N+-1|0;N=c[f>>2]|0;c[N+(o*96|0)>>2]=b;e=ea(g[a>>2]);b=a+12|0;t=ea(e-ea(g[b>>2]));f=a+4|0;e=ea(g[f>>2]);n=a+16|0;L=ea(e-ea(g[n>>2]));p=a+8|0;e=ea(g[p>>2]);M=a+20|0;w=ea(e-ea(g[M>>2]));g[N+(o*96|0)+72>>2]=t;g[N+(o*96|0)+76>>2]=L;g[N+(o*96|0)+80>>2]=w;w=ea(g[a>>2]);L=ea(w+ea(g[b>>2]));w=ea(g[f>>2]);t=ea(w+ea(g[n>>2]));w=ea(g[p>>2]);e=ea(w+ea(g[M>>2]));g[N+(o*96|0)+84>>2]=L;g[N+(o*96|0)+88>>2]=t;g[N+(o*96|0)+92>>2]=e;c[N+(o*96|0)+4>>2]=0;i=h;return}function eZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=i;i=i+16|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-8|0;j=g;b:while(1){k=j;l=b-k|0;m=l>>3;switch(m|0){case 5:{n=j;o=h;p=11;break a;break}case 2:{q=j;r=h;s=h;p=4;break a;break}case 4:{t=j;u=h;v=h;p=7;break a;break}case 1:case 0:{p=56;break a;break}case 3:{w=j;x=h;p=6;break a;break}default:{}}if((l|0)<248){y=j;z=a;p=13;break a}A=(m|0)/2|0;B=j+(A<<3)|0;if((l|0)>7992){l=(m|0)/4|0;C=iZb(j,j+(l<<3)|0,B,j+(l+A<<3)|0,h,d)|0}else C=hZb(j,B,h,d)|0;do if(gZb(d,j,B)|0){D=h;E=C}else{A=a;l=h;while(1){m=A+-16|0;if((j|0)==(m|0))break;if(gZb(d,m,B)|0){F=m;p=38;break}else{G=l;l=m;A=G}}if((p|0)==38){p=0;A=j;l=c[A>>2]|0;G=c[A+4>>2]|0;A=F;m=c[A+4>>2]|0;H=j;c[H>>2]=c[A>>2];c[H+4>>2]=m;m=F;c[m>>2]=l;c[m+4>>2]=G;D=F;E=C+1|0;break}G=j+8|0;if(gZb(d,j,h)|0)I=G;else{if((G|0)==(h|0)){p=56;break a}else{J=j;K=G}while(1){G=J+16|0;if(gZb(d,j,K)|0){L=K;break}if((G|0)==(h|0)){p=56;break a}else{m=K;K=G;J=m}}m=L;G=c[m>>2]|0;l=c[m+4>>2]|0;m=h;H=c[m+4>>2]|0;A=L;c[A>>2]=c[m>>2];c[A+4>>2]=H;H=h;c[H>>2]=G;c[H+4>>2]=l;I=L+8|0}if((I|0)==(h|0)){p=56;break a}else{M=I;N=h}while(1){l=M;while(1){H=l+8|0;if(gZb(d,j,l)|0){O=H;P=l;break}else l=H}l=N;while(1){H=l+-8|0;if(gZb(d,j,H)|0)l=H;else{Q=H;break}}if(P>>>0>=Q>>>0){j=P;continue b}l=P;H=c[l>>2]|0;G=c[l+4>>2]|0;l=Q;A=c[l+4>>2]|0;m=P;c[m>>2]=c[l>>2];c[m+4>>2]=A;A=Q;c[A>>2]=H;c[A+4>>2]=G;M=O;N=Q}}while(0);G=j+8|0;c:do if(G>>>0<D>>>0){A=G;H=D;m=B;l=E;while(1){R=A;while(1){S=R+8|0;if(gZb(d,R,m)|0)R=S;else{T=S;U=R;break}}R=H;while(1){S=R+-8|0;if(gZb(d,S,m)|0){V=S;break}else R=S}if(U>>>0>V>>>0){W=U;X=m;Y=l;break c}R=U;S=c[R>>2]|0;Z=c[R+4>>2]|0;R=V;_=c[R+4>>2]|0;$=U;c[$>>2]=c[R>>2];c[$+4>>2]=_;_=V;c[_>>2]=S;c[_+4>>2]=Z;A=T;H=V;m=(m|0)==(U|0)?V:m;l=l+1|0}}else{W=G;X=B;Y=E}while(0);if((W|0)!=(X|0)?gZb(d,X,W)|0:0){B=W;G=c[B>>2]|0;l=c[B+4>>2]|0;B=X;m=c[B+4>>2]|0;H=W;c[H>>2]=c[B>>2];c[H+4>>2]=m;m=X;c[m>>2]=G;c[m+4>>2]=l;aa=Y+1|0}else aa=Y;if(!aa){ba=jZb(j,W,d)|0;l=W+8|0;if(jZb(l,a,d)|0){p=51;break}if(ba){j=l;continue}}l=W;if((l-k|0)>=(b-l|0)){ca=j;da=W;p=55;break}eZb(j,W,d);j=W+8|0}if((p|0)==51){p=0;if(ba){p=56;break}else{g=j;a=W;continue}}else if((p|0)==55){p=0;eZb(da+8|0,a,d);g=ca;a=da;continue}}if((p|0)==4){if(!(gZb(d,s,q)|0)){i=e;return}s=q;da=c[s>>2]|0;a=c[s+4>>2]|0;s=r;ca=c[s+4>>2]|0;g=q;c[g>>2]=c[s>>2];c[g+4>>2]=ca;ca=r;c[ca>>2]=da;c[ca+4>>2]=a;i=e;return}else if((p|0)==6){hZb(w,w+8|0,x,d)|0;i=e;return}else if((p|0)==7){x=t+8|0;w=t+16|0;hZb(t,x,w,d)|0;if(!(gZb(d,v,w)|0)){i=e;return}v=w;a=c[v>>2]|0;ca=c[v+4>>2]|0;v=u;da=c[v+4>>2]|0;r=w;c[r>>2]=c[v>>2];c[r+4>>2]=da;da=u;c[da>>2]=a;c[da+4>>2]=ca;if(!(gZb(d,w,x)|0)){i=e;return}ca=x;da=c[ca>>2]|0;a=c[ca+4>>2]|0;ca=w;u=c[ca>>2]|0;r=c[ca+4>>2]|0;ca=x;c[ca>>2]=u;c[ca+4>>2]=r;ca=w;c[ca>>2]=da;c[ca+4>>2]=a;if(!(gZb(d,x,t)|0)){i=e;return}a=t;ca=c[a>>2]|0;da=c[a+4>>2]|0;a=t;c[a>>2]=u;c[a+4>>2]=r;r=x;c[r>>2]=ca;c[r+4>>2]=da;i=e;return}else if((p|0)==11){iZb(n,n+8|0,n+16|0,n+24|0,o,d)|0;i=e;return}else if((p|0)==13){o=y+16|0;hZb(y,y+8|0,o,d)|0;n=y+24|0;if((n|0)==(z|0)){i=e;return}else{ea=n;fa=o}while(1){if(gZb(d,ea,fa)|0){o=ea;n=c[o+4>>2]|0;da=f;c[da>>2]=c[o>>2];c[da+4>>2]=n;n=ea;da=fa;while(1){o=da;r=c[o+4>>2]|0;ca=n;c[ca>>2]=c[o>>2];c[ca+4>>2]=r;if((da|0)==(y|0)){ga=da;break}r=da+-8|0;if(gZb(d,f,r)|0){ca=da;da=r;n=ca}else{ga=da;break}}da=f;n=c[da+4>>2]|0;j=ga;c[j>>2]=c[da>>2];c[j+4>>2]=n}n=ea+8|0;if((n|0)==(z|0))break;else{j=ea;ea=n;fa=j}}i=e;return}else if((p|0)==56){i=e;return}}function fZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=i;i=i+16|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-8|0;j=g;b:while(1){k=j;l=b-k|0;m=l>>3;switch(m|0){case 5:{n=j;o=h;p=11;break a;break}case 4:{q=j;r=h;s=h;p=7;break a;break}case 3:{t=j;u=h;p=6;break a;break}case 2:{v=j;w=h;x=h;p=4;break a;break}case 1:case 0:{p=56;break a;break}default:{}}if((l|0)<248){y=j;z=a;p=13;break a}A=(m|0)/2|0;B=j+(A<<3)|0;if((l|0)>7992){l=(m|0)/4|0;C=mZb(j,j+(l<<3)|0,B,j+(l+A<<3)|0,h,d)|0}else C=lZb(j,B,h,d)|0;do if(kZb(d,j,B)|0){D=h;E=C}else{A=a;l=h;while(1){m=A+-16|0;if((j|0)==(m|0))break;if(kZb(d,m,B)|0){F=m;p=38;break}else{G=l;l=m;A=G}}if((p|0)==38){p=0;A=j;l=c[A>>2]|0;G=c[A+4>>2]|0;A=F;m=c[A+4>>2]|0;H=j;c[H>>2]=c[A>>2];c[H+4>>2]=m;m=F;c[m>>2]=l;c[m+4>>2]=G;D=F;E=C+1|0;break}G=j+8|0;if(kZb(d,j,h)|0)I=G;else{if((G|0)==(h|0)){p=56;break a}else{J=j;K=G}while(1){G=J+16|0;if(kZb(d,j,K)|0){L=K;break}if((G|0)==(h|0)){p=56;break a}else{m=K;K=G;J=m}}m=L;G=c[m>>2]|0;l=c[m+4>>2]|0;m=h;H=c[m+4>>2]|0;A=L;c[A>>2]=c[m>>2];c[A+4>>2]=H;H=h;c[H>>2]=G;c[H+4>>2]=l;I=L+8|0}if((I|0)==(h|0)){p=56;break a}else{M=I;N=h}while(1){l=M;while(1){H=l+8|0;if(kZb(d,j,l)|0){O=H;P=l;break}else l=H}l=N;while(1){H=l+-8|0;if(kZb(d,j,H)|0)l=H;else{Q=H;break}}if(P>>>0>=Q>>>0){j=P;continue b}l=P;H=c[l>>2]|0;G=c[l+4>>2]|0;l=Q;A=c[l+4>>2]|0;m=P;c[m>>2]=c[l>>2];c[m+4>>2]=A;A=Q;c[A>>2]=H;c[A+4>>2]=G;M=O;N=Q}}while(0);G=j+8|0;c:do if(G>>>0<D>>>0){A=G;H=D;m=B;l=E;while(1){R=A;while(1){S=R+8|0;if(kZb(d,R,m)|0)R=S;else{T=S;U=R;break}}R=H;while(1){S=R+-8|0;if(kZb(d,S,m)|0){V=S;break}else R=S}if(U>>>0>V>>>0){W=U;X=m;Y=l;break c}R=U;S=c[R>>2]|0;Z=c[R+4>>2]|0;R=V;_=c[R+4>>2]|0;$=U;c[$>>2]=c[R>>2];c[$+4>>2]=_;_=V;c[_>>2]=S;c[_+4>>2]=Z;A=T;H=V;m=(m|0)==(U|0)?V:m;l=l+1|0}}else{W=G;X=B;Y=E}while(0);if((W|0)!=(X|0)?kZb(d,X,W)|0:0){B=W;G=c[B>>2]|0;l=c[B+4>>2]|0;B=X;m=c[B+4>>2]|0;H=W;c[H>>2]=c[B>>2];c[H+4>>2]=m;m=X;c[m>>2]=G;c[m+4>>2]=l;aa=Y+1|0}else aa=Y;if(!aa){ba=nZb(j,W,d)|0;l=W+8|0;if(nZb(l,a,d)|0){p=51;break}if(ba){j=l;continue}}l=W;if((l-k|0)>=(b-l|0)){ca=j;da=W;p=55;break}fZb(j,W,d);j=W+8|0}if((p|0)==51){p=0;if(ba){p=56;break}else{g=j;a=W;continue}}else if((p|0)==55){p=0;fZb(da+8|0,a,d);g=ca;a=da;continue}}if((p|0)==4){if(!(kZb(d,x,v)|0)){i=e;return}x=v;da=c[x>>2]|0;a=c[x+4>>2]|0;x=w;ca=c[x+4>>2]|0;g=v;c[g>>2]=c[x>>2];c[g+4>>2]=ca;ca=w;c[ca>>2]=da;c[ca+4>>2]=a;i=e;return}else if((p|0)==6){lZb(t,t+8|0,u,d)|0;i=e;return}else if((p|0)==7){u=q+8|0;t=q+16|0;lZb(q,u,t,d)|0;if(!(kZb(d,s,t)|0)){i=e;return}s=t;a=c[s>>2]|0;ca=c[s+4>>2]|0;s=r;da=c[s+4>>2]|0;w=t;c[w>>2]=c[s>>2];c[w+4>>2]=da;da=r;c[da>>2]=a;c[da+4>>2]=ca;if(!(kZb(d,t,u)|0)){i=e;return}ca=u;da=c[ca>>2]|0;a=c[ca+4>>2]|0;ca=t;r=c[ca>>2]|0;w=c[ca+4>>2]|0;ca=u;c[ca>>2]=r;c[ca+4>>2]=w;ca=t;c[ca>>2]=da;c[ca+4>>2]=a;if(!(kZb(d,u,q)|0)){i=e;return}a=q;ca=c[a>>2]|0;da=c[a+4>>2]|0;a=q;c[a>>2]=r;c[a+4>>2]=w;w=u;c[w>>2]=ca;c[w+4>>2]=da;i=e;return}else if((p|0)==11){mZb(n,n+8|0,n+16|0,n+24|0,o,d)|0;i=e;return}else if((p|0)==13){o=y+16|0;lZb(y,y+8|0,o,d)|0;n=y+24|0;if((n|0)==(z|0)){i=e;return}else{ea=n;fa=o}while(1){if(kZb(d,ea,fa)|0){o=ea;n=c[o+4>>2]|0;da=f;c[da>>2]=c[o>>2];c[da+4>>2]=n;n=ea;da=fa;while(1){o=da;w=c[o+4>>2]|0;ca=n;c[ca>>2]=c[o>>2];c[ca+4>>2]=w;if((da|0)==(y|0)){ga=da;break}w=da+-8|0;if(kZb(d,f,w)|0){ca=da;da=w;n=ca}else{ga=da;break}}da=f;n=c[da+4>>2]|0;j=ga;c[j>>2]=c[da>>2];c[j+4>>2]=n}n=ea+8|0;if((n|0)==(z|0))break;else{j=ea;ea=n;fa=j}}i=e;return}else if((p|0)==56){i=e;return}}function gZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im;f=i;h=c[d>>2]|0;j=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[e>>2]|0;k=c[j+(h*44|0)+40>>2]|0;l=c[j+(a*44|0)+40>>2]|0;if((k|0)!=(l|0)){m=k>>>0<l>>>0;i=f;return m|0}l=b[j+(h*44|0)+4>>1]|0;k=b[j+(a*44|0)+4>>1]|0;if(l<<16>>16!=k<<16>>16){m=l<<16>>16<k<<16>>16;i=f;return m|0}k=c[d+4>>2]|0;d=c[e+4>>2]|0;e=k&16777216;l=d&16777216;if((e|0)!=(l|0)){m=e>>>0>l>>>0;i=f;return m|0}l=c[j+(h*44|0)+12>>2]|0;e=c[j+(a*44|0)+12>>2]|0;if((l|0)!=(e|0)){m=l>>>0<e>>>0;i=f;return m|0}e=c[j+(h*44|0)+16>>2]|0;l=c[j+(a*44|0)+16>>2]|0;if((e|0)!=(l|0)){m=(e|0)>(l|0);i=f;return m|0}l=c[j+(h*44|0)+32>>2]|0;e=c[j+(a*44|0)+32>>2]|0;if((l|0)!=(e|0)){m=(c[l+4>>2]|0)<(c[e+4>>2]|0);i=f;return m|0}e=c[j+(h*44|0)>>2]|0;l=c[j+(a*44|0)>>2]|0;if((e|0)!=(l|0)){m=(c[e+4>>2]|0)<(c[l+4>>2]|0);i=f;return m|0}l=k&255;k=d&255;if((l|0)!=(k|0)){m=l>>>0<k>>>0;i=f;return m|0}n=ea(g[j+(h*44|0)+20>>2]);o=ea(g[j+(a*44|0)+20>>2]);if(n!=o){m=n>o;i=f;return m|0}k=b[j+(h*44|0)+36>>1]|0;l=b[j+(a*44|0)+36>>1]|0;if(k<<16>>16==l<<16>>16){m=(h|0)<(a|0);i=f;return m|0}else{m=(k&65535)>(l&65535);i=f;return m|0}return 0}function hZb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=gZb(e,b,a)|0;h=gZb(e,d,b)|0;if(!g){if(!h){j=0;i=f;return j|0}g=b;k=c[g>>2]|0;l=c[g+4>>2]|0;g=d;m=c[g+4>>2]|0;n=b;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=d;c[m>>2]=k;c[m+4>>2]=l;if(!(gZb(e,b,a)|0)){j=1;i=f;return j|0}l=a;m=c[l>>2]|0;k=c[l+4>>2]|0;l=b;n=c[l+4>>2]|0;g=a;c[g>>2]=c[l>>2];c[g+4>>2]=n;n=b;c[n>>2]=m;c[n+4>>2]=k;j=2;i=f;return j|0}k=a;n=c[k>>2]|0;m=c[k+4>>2]|0;if(h){h=d;k=c[h+4>>2]|0;g=a;c[g>>2]=c[h>>2];c[g+4>>2]=k;k=d;c[k>>2]=n;c[k+4>>2]=m;j=1;i=f;return j|0}k=b;g=c[k+4>>2]|0;h=a;c[h>>2]=c[k>>2];c[h+4>>2]=g;g=b;c[g>>2]=n;c[g+4>>2]=m;if(!(gZb(e,d,b)|0)){j=1;i=f;return j|0}e=d;g=c[e+4>>2]|0;h=b;c[h>>2]=c[e>>2];c[h+4>>2]=g;g=d;c[g>>2]=n;c[g+4>>2]=m;j=2;i=f;return j|0}function iZb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=hZb(a,b,d,g)|0;if(gZb(g,e,d)|0){k=d;l=c[k>>2]|0;m=c[k+4>>2]|0;k=e;n=c[k+4>>2]|0;o=d;c[o>>2]=c[k>>2];c[o+4>>2]=n;n=e;c[n>>2]=l;c[n+4>>2]=m;m=j+1|0;if(gZb(g,d,b)|0){n=b;l=c[n>>2]|0;o=c[n+4>>2]|0;n=d;k=c[n+4>>2]|0;p=b;c[p>>2]=c[n>>2];c[p+4>>2]=k;k=d;c[k>>2]=l;c[k+4>>2]=o;if(gZb(g,b,a)|0){o=a;k=c[o>>2]|0;l=c[o+4>>2]|0;o=b;p=c[o+4>>2]|0;n=a;c[n>>2]=c[o>>2];c[n+4>>2]=p;p=b;c[p>>2]=k;c[p+4>>2]=l;q=j+3|0}else q=j+2|0}else q=m}else q=j;if(!(gZb(g,f,e)|0)){r=q;i=h;return r|0}j=e;m=c[j>>2]|0;l=c[j+4>>2]|0;j=f;p=c[j+4>>2]|0;k=e;c[k>>2]=c[j>>2];c[k+4>>2]=p;p=f;c[p>>2]=m;c[p+4>>2]=l;if(!(gZb(g,e,d)|0)){r=q+1|0;i=h;return r|0}l=d;p=c[l>>2]|0;m=c[l+4>>2]|0;l=e;f=c[l+4>>2]|0;k=d;c[k>>2]=c[l>>2];c[k+4>>2]=f;f=e;c[f>>2]=p;c[f+4>>2]=m;if(!(gZb(g,d,b)|0)){r=q+2|0;i=h;return r|0}m=b;f=c[m>>2]|0;p=c[m+4>>2]|0;m=d;e=c[m+4>>2]|0;k=b;c[k>>2]=c[m>>2];c[k+4>>2]=e;e=d;c[e>>2]=f;c[e+4>>2]=p;if(!(gZb(g,b,a)|0)){r=q+3|0;i=h;return r|0}g=a;p=c[g>>2]|0;e=c[g+4>>2]|0;g=b;f=c[g+4>>2]|0;d=a;c[d>>2]=c[g>>2];c[d+4>>2]=f;f=b;c[f>>2]=p;c[f+4>>2]=e;r=q+4|0;i=h;return r|0}function jZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;switch(b-a>>3|0){case 3:{hZb(a,a+8|0,b+-8|0,d)|0;g=1;i=e;return g|0}case 1:case 0:{g=1;i=e;return g|0}case 4:{h=a+8|0;j=a+16|0;k=b+-8|0;hZb(a,h,j,d)|0;if(!(gZb(d,k,j)|0)){g=1;i=e;return g|0}l=j;m=c[l>>2]|0;n=c[l+4>>2]|0;l=k;o=c[l+4>>2]|0;p=j;c[p>>2]=c[l>>2];c[p+4>>2]=o;o=k;c[o>>2]=m;c[o+4>>2]=n;if(!(gZb(d,j,h)|0)){g=1;i=e;return g|0}n=h;o=c[n>>2]|0;m=c[n+4>>2]|0;n=j;k=c[n>>2]|0;p=c[n+4>>2]|0;n=h;c[n>>2]=k;c[n+4>>2]=p;n=j;c[n>>2]=o;c[n+4>>2]=m;if(!(gZb(d,h,a)|0)){g=1;i=e;return g|0}m=a;n=c[m>>2]|0;o=c[m+4>>2]|0;m=a;c[m>>2]=k;c[m+4>>2]=p;p=h;c[p>>2]=n;c[p+4>>2]=o;g=1;i=e;return g|0}case 2:{o=b+-8|0;if(!(gZb(d,o,a)|0)){g=1;i=e;return g|0}p=a;n=c[p>>2]|0;h=c[p+4>>2]|0;p=o;m=c[p+4>>2]|0;k=a;c[k>>2]=c[p>>2];c[k+4>>2]=m;m=o;c[m>>2]=n;c[m+4>>2]=h;g=1;i=e;return g|0}case 5:{iZb(a,a+8|0,a+16|0,a+24|0,b+-8|0,d)|0;g=1;i=e;return g|0}default:{h=a+16|0;hZb(a,a+8|0,h,d)|0;m=a+24|0;if((m|0)==(b|0)){g=1;i=e;return g|0}else{q=0;r=m;s=h}while(1){if(gZb(d,r,s)|0){h=r;m=c[h+4>>2]|0;n=f;c[n>>2]=c[h>>2];c[n+4>>2]=m;m=r;n=s;while(1){h=n;o=c[h+4>>2]|0;k=m;c[k>>2]=c[h>>2];c[k+4>>2]=o;if((n|0)==(a|0)){t=n;break}o=n+-8|0;if(gZb(d,f,o)|0){k=n;n=o;m=k}else{t=n;break}}n=f;m=c[n+4>>2]|0;k=t;c[k>>2]=c[n>>2];c[k+4>>2]=m;m=q+1|0;if((m|0)==8){u=r;break}else v=m}else v=q;m=r+8|0;if((m|0)==(b|0)){g=1;w=18;break}else{k=r;q=v;r=m;s=k}}if((w|0)==18){i=e;return g|0}g=(u+8|0)==(b|0);i=e;return g|0}}return 0}function kZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im;f=i;h=c[d>>2]|0;j=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[e>>2]|0;k=c[j+(h*44|0)+40>>2]|0;l=c[j+(a*44|0)+40>>2]|0;if((k|0)!=(l|0)){m=k>>>0<l>>>0;i=f;return m|0}l=b[j+(h*44|0)+4>>1]|0;k=b[j+(a*44|0)+4>>1]|0;if(l<<16>>16!=k<<16>>16){m=l<<16>>16<k<<16>>16;i=f;return m|0}n=ea(g[j+(h*44|0)+20>>2]);o=ea(g[j+(a*44|0)+20>>2]);if(n!=o){m=n<o;i=f;return m|0}k=b[j+(h*44|0)+36>>1]|0;l=b[j+(a*44|0)+36>>1]|0;if(k<<16>>16!=l<<16>>16){m=(k&65535)<(l&65535);i=f;return m|0}l=b[j+(h*44|0)+10>>1]|0;k=b[j+(a*44|0)+10>>1]|0;if(l<<16>>16!=k<<16>>16){m=(l&65535)<(k&65535);i=f;return m|0}k=c[d+4>>2]|0;d=c[e+4>>2]|0;e=k&16777216;l=d&16777216;if((e|0)!=(l|0)){m=e>>>0>l>>>0;i=f;return m|0}l=c[j+(h*44|0)+12>>2]|0;e=c[j+(a*44|0)+12>>2]|0;if((l|0)!=(e|0)){m=l>>>0<e>>>0;i=f;return m|0}e=c[j+(h*44|0)+16>>2]|0;l=c[j+(a*44|0)+16>>2]|0;if((e|0)!=(l|0)){m=(e|0)>(l|0);i=f;return m|0}l=c[j+(h*44|0)+32>>2]|0;e=c[j+(a*44|0)+32>>2]|0;if((l|0)!=(e|0)){m=(c[l+4>>2]|0)<(c[e+4>>2]|0);i=f;return m|0}e=c[j+(h*44|0)>>2]|0;l=c[j+(a*44|0)>>2]|0;if((e|0)!=(l|0)){m=(c[e+4>>2]|0)<(c[l+4>>2]|0);i=f;return m|0}l=k&255;k=d&255;if((l|0)==(k|0)){m=(h|0)<(a|0);i=f;return m|0}else{m=l>>>0<k>>>0;i=f;return m|0}return 0}function lZb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=kZb(e,b,a)|0;h=kZb(e,d,b)|0;if(!g){if(!h){j=0;i=f;return j|0}g=b;k=c[g>>2]|0;l=c[g+4>>2]|0;g=d;m=c[g+4>>2]|0;n=b;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=d;c[m>>2]=k;c[m+4>>2]=l;if(!(kZb(e,b,a)|0)){j=1;i=f;return j|0}l=a;m=c[l>>2]|0;k=c[l+4>>2]|0;l=b;n=c[l+4>>2]|0;g=a;c[g>>2]=c[l>>2];c[g+4>>2]=n;n=b;c[n>>2]=m;c[n+4>>2]=k;j=2;i=f;return j|0}k=a;n=c[k>>2]|0;m=c[k+4>>2]|0;if(h){h=d;k=c[h+4>>2]|0;g=a;c[g>>2]=c[h>>2];c[g+4>>2]=k;k=d;c[k>>2]=n;c[k+4>>2]=m;j=1;i=f;return j|0}k=b;g=c[k+4>>2]|0;h=a;c[h>>2]=c[k>>2];c[h+4>>2]=g;g=b;c[g>>2]=n;c[g+4>>2]=m;if(!(kZb(e,d,b)|0)){j=1;i=f;return j|0}e=d;g=c[e+4>>2]|0;h=b;c[h>>2]=c[e>>2];c[h+4>>2]=g;g=d;c[g>>2]=n;c[g+4>>2]=m;j=2;i=f;return j|0}function mZb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=lZb(a,b,d,g)|0;if(kZb(g,e,d)|0){k=d;l=c[k>>2]|0;m=c[k+4>>2]|0;k=e;n=c[k+4>>2]|0;o=d;c[o>>2]=c[k>>2];c[o+4>>2]=n;n=e;c[n>>2]=l;c[n+4>>2]=m;m=j+1|0;if(kZb(g,d,b)|0){n=b;l=c[n>>2]|0;o=c[n+4>>2]|0;n=d;k=c[n+4>>2]|0;p=b;c[p>>2]=c[n>>2];c[p+4>>2]=k;k=d;c[k>>2]=l;c[k+4>>2]=o;if(kZb(g,b,a)|0){o=a;k=c[o>>2]|0;l=c[o+4>>2]|0;o=b;p=c[o+4>>2]|0;n=a;c[n>>2]=c[o>>2];c[n+4>>2]=p;p=b;c[p>>2]=k;c[p+4>>2]=l;q=j+3|0}else q=j+2|0}else q=m}else q=j;if(!(kZb(g,f,e)|0)){r=q;i=h;return r|0}j=e;m=c[j>>2]|0;l=c[j+4>>2]|0;j=f;p=c[j+4>>2]|0;k=e;c[k>>2]=c[j>>2];c[k+4>>2]=p;p=f;c[p>>2]=m;c[p+4>>2]=l;if(!(kZb(g,e,d)|0)){r=q+1|0;i=h;return r|0}l=d;p=c[l>>2]|0;m=c[l+4>>2]|0;l=e;f=c[l+4>>2]|0;k=d;c[k>>2]=c[l>>2];c[k+4>>2]=f;f=e;c[f>>2]=p;c[f+4>>2]=m;if(!(kZb(g,d,b)|0)){r=q+2|0;i=h;return r|0}m=b;f=c[m>>2]|0;p=c[m+4>>2]|0;m=d;e=c[m+4>>2]|0;k=b;c[k>>2]=c[m>>2];c[k+4>>2]=e;e=d;c[e>>2]=f;c[e+4>>2]=p;if(!(kZb(g,b,a)|0)){r=q+3|0;i=h;return r|0}g=a;p=c[g>>2]|0;e=c[g+4>>2]|0;g=b;f=c[g+4>>2]|0;d=a;c[d>>2]=c[g>>2];c[d+4>>2]=f;f=b;c[f>>2]=p;c[f+4>>2]=e;r=q+4|0;i=h;return r|0}function nZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;switch(b-a>>3|0){case 4:{g=a+8|0;h=a+16|0;j=b+-8|0;lZb(a,g,h,d)|0;if(!(kZb(d,j,h)|0)){k=1;i=e;return k|0}l=h;m=c[l>>2]|0;n=c[l+4>>2]|0;l=j;o=c[l+4>>2]|0;p=h;c[p>>2]=c[l>>2];c[p+4>>2]=o;o=j;c[o>>2]=m;c[o+4>>2]=n;if(!(kZb(d,h,g)|0)){k=1;i=e;return k|0}n=g;o=c[n>>2]|0;m=c[n+4>>2]|0;n=h;j=c[n>>2]|0;p=c[n+4>>2]|0;n=g;c[n>>2]=j;c[n+4>>2]=p;n=h;c[n>>2]=o;c[n+4>>2]=m;if(!(kZb(d,g,a)|0)){k=1;i=e;return k|0}m=a;n=c[m>>2]|0;o=c[m+4>>2]|0;m=a;c[m>>2]=j;c[m+4>>2]=p;p=g;c[p>>2]=n;c[p+4>>2]=o;k=1;i=e;return k|0}case 2:{o=b+-8|0;if(!(kZb(d,o,a)|0)){k=1;i=e;return k|0}p=a;n=c[p>>2]|0;g=c[p+4>>2]|0;p=o;m=c[p+4>>2]|0;j=a;c[j>>2]=c[p>>2];c[j+4>>2]=m;m=o;c[m>>2]=n;c[m+4>>2]=g;k=1;i=e;return k|0}case 3:{lZb(a,a+8|0,b+-8|0,d)|0;k=1;i=e;return k|0}case 1:case 0:{k=1;i=e;return k|0}case 5:{mZb(a,a+8|0,a+16|0,a+24|0,b+-8|0,d)|0;k=1;i=e;return k|0}default:{g=a+16|0;lZb(a,a+8|0,g,d)|0;m=a+24|0;if((m|0)==(b|0)){k=1;i=e;return k|0}else{q=0;r=m;s=g}while(1){if(kZb(d,r,s)|0){g=r;m=c[g+4>>2]|0;n=f;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=r;n=s;while(1){g=n;o=c[g+4>>2]|0;j=m;c[j>>2]=c[g>>2];c[j+4>>2]=o;if((n|0)==(a|0)){t=n;break}o=n+-8|0;if(kZb(d,f,o)|0){j=n;n=o;m=j}else{t=n;break}}n=f;m=c[n+4>>2]|0;j=t;c[j>>2]=c[n>>2];c[j+4>>2]=m;m=q+1|0;if((m|0)==8){u=r;break}else v=m}else v=q;m=r+8|0;if((m|0)==(b|0)){k=1;w=18;break}else{j=r;q=v;r=m;s=j}}if((w|0)==18){i=e;return k|0}k=(u+8|0)==(b|0);i=e;return k|0}}return 0}function oZb(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=0,ja=0,ka=0,la=Im,ma=Im,na=0,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=Im,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;k=i;i=i+128|0;l=k+124|0;m=k+48|0;n=k+36|0;o=k;p=ync()|0;q=X8b()|0;r=c[158074]|0;s=n8b()|0;t=c[s+88>>2]|0;u=s+92|0;s=Vwc()|0;v=c[d+48>>2]|0;w=c[d>>2]|0;x=c[w+108>>2]|0;In[c[(c[p>>2]|0)+104>>2]&4095](p,w+12|0);In[c[(c[p>>2]|0)+72>>2]&4095](p,f);if(h)J$b(c[c[d>>2]>>2]|0,0);D8b(q);Bcc((c[c[d>>2]>>2]|0)+636|0,j?10:16,r);RYb(m,l);S_b(n,m,l);if(!v)y=t;else{l=d+40|0;q=d+4|0;h=d+8|0;f=d+24|0;w=o+4|0;z=o+8|0;A=o+12|0;B=o+16|0;C=o+20|0;D=o+24|0;E=o+28|0;F=o+32|0;G=o+24|0;H=0;I=0;J=-1;K=-1;L=-1;M=ea(-1.0);N=255;O=255;P=0;Q=t;t=0;R=x;x=0;while(1){S=c[l>>2]|0;T=c[S+(x<<3)>>2]|0;U=c[c[q>>2]>>2]|0;V=(c[f>>2]|0)+(c[(c[h>>2]|0)+(T<<2)>>2]|0)|0;W=b[U+(T*44|0)+4>>1]|0;a:do if((W|0)>(R|0)){TYb(m);if(!(a[(c[d>>2]|0)+105>>0]|0))if((Q|0)==(u|0)){X=u;Y=W}else{Z=Q;while(1){if((c[Z+16>>2]|0)>(W|0)){X=Z;Y=W;break a}_=c[Z+20>>2]|0;co[c[c[_>>2]>>2]&2047](_,c[(c[d>>2]|0)+4>>2]|0,r);_=c[Z+4>>2]|0;if(!_){$=Z;while(1){aa=c[$+8>>2]|0;if((c[aa>>2]|0)==($|0)){ba=aa;break}else $=aa}}else{$=_;while(1){aa=c[$>>2]|0;if(!aa){ba=$;break}else $=aa}}if((ba|0)==(u|0)){X=ba;Y=W;break}else Z=ba}}else{X=Q;Y=W}}else{X=Q;Y=R}while(0);W=c[U+(T*44|0)+28>>2]|0;Z=b[U+(T*44|0)+6>>1]|0;$=c[U+(T*44|0)>>2]|0;c[o>>2]=$;_=c[U+(T*44|0)+32>>2]|0;c[w>>2]=_;aa=W+116|0;ca=c[(c[aa>>2]|0)+168>>2]|0;if(!ca)da=0;else da=c[ca+32>>2]|0;c[z>>2]=da;ca=U+(T*44|0)+8|0;fa=(b[ca>>1]<<1&65535)<<16>>16>>1<<16>>16;c[A>>2]=fa;ga=(e[ca>>1]|0)>>>15&65535;c[B>>2]=ga;ha=ea(g[W+120>>2]);g[C>>2]=ha;ca=c[U+(T*44|0)+12>>2]|0;c[D>>2]=ca;ia=c[S+(x<<3)+4>>2]|0;c[E>>2]=ia&255;c[F>>2]=V;ja=U+(T*44|0)+16|0;if(!(c[ja>>2]|0))ka=(ia&131072|0)!=0;else ka=0;b:do if(($|0)==(H|0)&(_|0)==(I|0)&(fa|0)==(J|0)&(da|0)==(K|0)&(ga|0)==(L|0)?(ia=(ha>ea(0.0)&1)-(ha<ea(0.0)&1)|0,(ia|0)==((M>ea(0.0)&1)-(M<ea(0.0)&1)|0)):0){if((ia|0)<0){la=ea(ha-M);if(la<ea(0.0))ma=ea(-la);else ma=la;if(!(ma<=ea(9.99999997e-07))){na=35;break}}else{la=ea(ha*ea(16.0));if(!(la>=ea(0.0)))oa=ea(la+ea(-.99999994));else oa=la;la=ea(M*ea(16.0));if(!(la>=ea(0.0)))pa=ea(la+ea(-.99999994));else pa=la;if((~~oa|0)!=(~~pa|0)){na=35;break}}if(((ca|0)==((N&65535)<<16|O&65535|0)?(V|0)!=0&(P|0)!=0:0)?(ia=c[V>>2]|0,(ia|0)==(c[P>>2]|0)):0){if((ia|0)>0){qa=0;do{qa=qa+1|0;if((c[V+(qa<<2)>>2]|0)!=(c[P+(qa<<2)>>2]|0)){na=35;break b}}while((qa|0)<(ia|0))}if(emd(I,ha)|0|ka){TYb(m);ra=N;sa=O;ta=P;ua=M;va=L;wa=J;xa=K;ya=I;za=H;Aa=0}else{ra=N;sa=O;ta=P;ua=M;va=L;wa=J;xa=K;ya=I;za=H;Aa=0}}else na=35}else na=35;while(0);if((na|0)==35){na=0;TYb(m);V=c[o>>2]|0;ca=c[w>>2]|0;ga=c[z>>2]|0;fa=c[A>>2]|0;_=c[B>>2]|0;ha=ea(g[C>>2]);$=c[D>>2]|0;T=c[F>>2]|0;K_b(p,r,ha);ra=$>>>16&65535;sa=$&65535;ta=T;ua=ha;va=_;wa=fa;xa=ga;ya=ca;za=V;Aa=1}In[c[(c[p>>2]|0)+100>>2]&4095](p,601008);T_b(n,c[aa>>2]|0,c[ja>>2]|0);U_b(n,c[aa>>2]|0,p,c[ja>>2]|0);if(Aa){x8b(s,G);V=c[F>>2]|0;C5b(c[V>>2]|0,V+4|0);Ba=ekd(c[o>>2]|0,c[E>>2]|0,c[w>>2]|0,r,c[A>>2]|0)|0}else Ba=t;if(Ba)SYb(m,c[aa>>2]|0,W,Z&65535,Ba);x=x+1|0;if(x>>>0>=v>>>0){y=X;break}else{H=za;I=ya;J=wa;K=xa;L=va;M=ua;N=ra;O=sa;P=ta;Q=X;t=Ba;R=Y}}}TYb(m);In[c[(c[p>>2]|0)+72>>2]&4095](p,0);In[c[(c[p>>2]|0)+104>>2]&4095](p,(c[d>>2]|0)+12|0);p=c[d>>2]|0;if((a[p+105>>0]|0)!=0|(y|0)==(u|0)){Ca=p;Da=c[Ca>>2]|0;Ea=j?11:17;Fa=Da+636|0;Bcc(Fa,Ea,r);aZb(m);i=k;return}Y=c[p+108>>2]|0;R=y;while(1){if((c[R+16>>2]|0)>=(Y|0)){Ga=R;break}y=c[R+4>>2]|0;if(!y){Ba=R;while(1){t=c[Ba+8>>2]|0;if((c[t>>2]|0)==(Ba|0)){Ha=t;break}else Ba=t}}else{Ba=y;while(1){Z=c[Ba>>2]|0;if(!Z){Ha=Ba;break}else Ba=Z}}if((Ha|0)==(u|0)){Ga=Ha;break}else R=Ha}if((Ga|0)==(u|0)){Ca=p;Da=c[Ca>>2]|0;Ea=j?11:17;Fa=Da+636|0;Bcc(Fa,Ea,r);aZb(m);i=k;return}else{Ia=Ga;Ja=p}while(1){if((c[Ia+16>>2]|0)>=(c[Ja+112>>2]|0)){Ca=Ja;na=60;break}p=c[Ia+20>>2]|0;co[c[c[p>>2]>>2]&2047](p,c[Ja+4>>2]|0,r);p=c[Ia+4>>2]|0;if(!p){Ga=Ia;while(1){Ha=c[Ga+8>>2]|0;if((c[Ha>>2]|0)==(Ga|0)){Ka=Ha;break}else Ga=Ha}}else{Ga=p;while(1){Ha=c[Ga>>2]|0;if(!Ha){Ka=Ga;break}else Ga=Ha}}if((Ka|0)==(u|0))break;Ia=Ka;Ja=c[d>>2]|0}if((na|0)==60){Da=c[Ca>>2]|0;Ea=j?11:17;Fa=Da+636|0;Bcc(Fa,Ea,r);aZb(m);i=k;return}Ca=c[d>>2]|0;Da=c[Ca>>2]|0;Ea=j?11:17;Fa=Da+636|0;Bcc(Fa,Ea,r);aZb(m);i=k;return}function pZb(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;l=i;i=i+80|0;m=l;n=l+64|0;o=l+8|0;p=c[153134]|0;c[o+8>>2]=0;q=o+12|0;c[q>>2]=p;r=o+16|0;c[r>>2]=0;s=o+20|0;c[s>>2]=0;c[o+24>>2]=0;t=o+28|0;c[t>>2]=p;u=o+32|0;c[u>>2]=0;v=o+36|0;c[v>>2]=0;c[o+40>>2]=0;w=o+44|0;c[w>>2]=p;x=o+48|0;c[x>>2]=0;y=o+52|0;c[y>>2]=0;c[o>>2]=d;c[o+4>>2]=f;z=o+8|0;A=f+8|0;B=c[A>>2]|0;if(!B){C=0;D=0}else{c[s>>2]=B;c[n>>2]=p;c[m+0>>2]=c[n+0>>2];c[z>>2]=hOb(0,B<<2,4,m,0,3653512,370)|0;C=c[y>>2]|0;D=c[A>>2]|0}B=o+40|0;do if((C&2147483647)>>>0<D>>>0)if((C|0)>-1){c[y>>2]=D;p=c[B>>2]|0;c[n>>2]=c[w>>2];c[m+0>>2]=c[n+0>>2];c[B>>2]=hOb(p,D<<3,4,m,0,3653512,370)|0;break}else{c[n>>2]=c[w>>2];c[m+0>>2]=c[n+0>>2];p=cOb(D<<3,4,m,0,3653512,352)|0;YEi(p|0,c[B>>2]|0,c[x>>2]<<3|0)|0;c[y>>2]=D;c[B>>2]=p;break}while(0);D=o+24|0;C=c[A>>2]<<4;p=c[v>>2]|0;do if((p&2147483647)>>>0<C>>>0)if((p|0)>-1){c[v>>2]=C;E=c[D>>2]|0;c[n>>2]=c[t>>2];c[m+0>>2]=c[n+0>>2];c[D>>2]=hOb(E,C,1,m,0,3653512,370)|0;break}else{c[n>>2]=c[t>>2];c[m+0>>2]=c[n+0>>2];E=cOb(C,1,m,0,3653512,352)|0;YEi(E|0,c[D>>2]|0,c[u>>2]|0)|0;c[v>>2]=C;c[D>>2]=E;break}while(0);C=c[d+4>>2]|0;v=u8b()|0;t=Vwc()|0;if((c[155255]|0)>2)F=(a[621171]|0)!=0;else F=0;p=c[f>>2]|0;E=p+((c[A>>2]|0)*44|0)|0;A=C+184|0;if(!(c[A>>2]|0))G=p;else{Gnd(A);G=c[f>>2]|0}if((G|0)==(E|0))H=B;else{f=C+92|0;A=t+28|0;p=t+24|0;I=C+216|0;J=F^1;K=C+208|0;L=C+192|0;C=t+40|0;t=G;G=0;while(1){M=c[t+28>>2]|0;N=(c[r>>2]|0)+1|0;c[r>>2]=N;O=c[s>>2]|0;P=O&2147483647;if(N>>>0>P>>>0){Q=O<<1;R=(Q|0)==0?1:Q;do if(P>>>0<R>>>0)if((O|0)>-1){c[s>>2]=R;Q=c[z>>2]|0;c[n>>2]=c[q>>2];c[m+0>>2]=c[n+0>>2];c[z>>2]=hOb(Q,R<<2,4,m,0,3653512,370)|0;break}else{c[n>>2]=c[q>>2];c[m+0>>2]=c[n+0>>2];Q=cOb(R<<2,4,m,0,3653512,352)|0;YEi(Q|0,c[z>>2]|0,c[r>>2]<<2|0)|0;c[s>>2]=R;c[z>>2]=Q;break}while(0);S=c[r>>2]|0}else S=N;R=S+-1|0;O=c[z>>2]|0;P=M-(c[f>>2]|0)>>7;Q=e[(c[M+116>>2]|0)+36>>1]|0;if((c[A>>2]|0)>(Q|0))T=(c[p>>2]|0)+(Q<<3)|0;else T=C;Q=(c[T>>2]|0)!=0;U=c[(c[t+32>>2]|0)+52>>2]|0;V=t+8|0;W=b[V>>1]|0;if((W&32767)==32767){X=c[U+((Q&1)<<2)+12>>2]|0;if((X|0)!=-1){b[V>>1]=X&32767|W&-32768;Y=29}}else Y=29;if((Y|0)==29){Y=0;c[O+(R<<2)>>2]=c[u>>2];if(!(c[I>>2]|0)){Z=0;_=0}else{R=c[K>>2]|0;O=c[R+(P<<2)>>2]|0;Z=(c[L>>2]|0)+(O<<3)|0;_=(c[R+(P+1<<2)>>2]|0)-O|0}I5b(z5b()|0,D,Z,_,h,M);O=c[(c[U>>2]|0)+((b[V>>1]<<1&65535)<<16>>16>>1<<16>>16<<2)>>2]|0;V=c[O+16>>2]|0;U=(V|0)>0;if(U){P=c[O>>2]|0;if(Q){R=0;W=0;while(1){X=c[P+(R<<2)>>2]|0;$=c[X+660>>2]|0;aa=c[X+584>>2]|0;if(($&v|0)!=($|0)|aa>>>0>3|(aa|0)==1)ba=0;else ba=((aa|0)!=2|J)&((aa|0)!=3|F);aa=(ba&1)+W|0;R=R+1|0;if(!((R|0)<(V|0)&(aa|0)<2)){ca=aa;break}else W=aa}}else{W=0;R=0;while(1){M=c[P+(W<<2)>>2]|0;N=c[M+660>>2]|0;aa=c[M+584>>2]|0;if((N&v|0)!=(N|0)|aa>>>0>3|(aa&-2|0)==2)da=0;else da=((aa|0)!=2|J)&((aa|0)!=3|F);aa=(da&1)+R|0;W=W+1|0;if(!((W|0)<(V|0)&(aa|0)<2)){ca=aa;break}else R=aa}}R=(ca|0)>1?131072:0;if(U){W=Q^1;P=65536;aa=0;while(1){N=c[(c[O>>2]|0)+(aa<<2)>>2]|0;M=c[N+660>>2]|0;$=c[N+584>>2]|0;do if($>>>0<4&(M&v|0)==(M|0)&(($|0)!=1|W)?($&-2|0)!=2|Q:0){if(!((($|0)!=2|J)&(($|0)!=3|F))){ea=P;break}N=(c[x>>2]|0)+1|0;c[x>>2]=N;X=c[y>>2]|0;fa=X&2147483647;if(N>>>0>fa>>>0){ga=X<<1;ha=(ga|0)==0?1:ga;do if(fa>>>0<ha>>>0)if((X|0)>-1){c[y>>2]=ha;ga=c[B>>2]|0;c[n>>2]=c[w>>2];c[m+0>>2]=c[n+0>>2];c[B>>2]=hOb(ga,ha<<3,4,m,0,3653512,370)|0;break}else{c[n>>2]=c[w>>2];c[m+0>>2]=c[n+0>>2];ga=cOb(ha<<3,4,m,0,3653512,352)|0;YEi(ga|0,c[B>>2]|0,c[x>>2]<<3|0)|0;c[y>>2]=ha;c[B>>2]=ga;break}while(0);ia=c[x>>2]|0}else ia=N;ha=ia+-1|0;X=c[B>>2]|0;c[X+(ha<<3)>>2]=G;c[X+(ha<<3)+4>>2]=P|R|aa&255;ea=0}else ea=P;while(0);aa=aa+1|0;if((aa|0)>=(V|0))break;else P=ea}}}}t=t+44|0;if((t|0)==(E|0)){H=B;break}else G=G+1|0}}G=c[H>>2]|0;H=G+(c[x>>2]<<3)|0;if(g){c[m>>2]=o;rZb(G,H,m)}else{c[m>>2]=o;sZb(G,H,m)}m=c[(c[d>>2]|0)+348>>2]|0;if(!j){ja=0;oZb(o,ja,k,g);qZb(o);i=l;return}if(!m){ja=1;oZb(o,ja,k,g);qZb(o);i=l;return}ja=(a[m+130>>0]|0)!=0;oZb(o,ja,k,g);qZb(o);i=l;return}function qZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+52>>2]|0)>-1){f=a+40|0;g=c[f>>2]|0;c[e>>2]=c[a+44>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+36>>2]|0)>-1){f=a+24|0;g=c[f>>2]|0;c[e>>2]=c[a+28>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+20>>2]|0)<=-1){i=b;return}f=a+8|0;g=c[f>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function rZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=i;i=i+16|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-8|0;j=g;b:while(1){k=j;l=b-k|0;m=l>>3;switch(m|0){case 5:{n=j;o=h;p=11;break a;break}case 3:{q=j;r=h;p=6;break a;break}case 2:{s=j;t=h;u=h;p=4;break a;break}case 4:{v=j;w=h;x=h;p=7;break a;break}case 1:case 0:{p=56;break a;break}default:{}}if((l|0)<248){y=j;z=a;p=13;break a}A=(m|0)/2|0;B=j+(A<<3)|0;if((l|0)>7992){l=(m|0)/4|0;C=vZb(j,j+(l<<3)|0,B,j+(l+A<<3)|0,h,d)|0}else C=uZb(j,B,h,d)|0;do if(tZb(d,j,B)|0){D=h;E=C}else{A=a;l=h;while(1){m=A+-16|0;if((j|0)==(m|0))break;if(tZb(d,m,B)|0){F=m;p=38;break}else{G=l;l=m;A=G}}if((p|0)==38){p=0;A=j;l=c[A>>2]|0;G=c[A+4>>2]|0;A=F;m=c[A+4>>2]|0;H=j;c[H>>2]=c[A>>2];c[H+4>>2]=m;m=F;c[m>>2]=l;c[m+4>>2]=G;D=F;E=C+1|0;break}G=j+8|0;if(tZb(d,j,h)|0)I=G;else{if((G|0)==(h|0)){p=56;break a}else{J=j;K=G}while(1){G=J+16|0;if(tZb(d,j,K)|0){L=K;break}if((G|0)==(h|0)){p=56;break a}else{m=K;K=G;J=m}}m=L;G=c[m>>2]|0;l=c[m+4>>2]|0;m=h;H=c[m+4>>2]|0;A=L;c[A>>2]=c[m>>2];c[A+4>>2]=H;H=h;c[H>>2]=G;c[H+4>>2]=l;I=L+8|0}if((I|0)==(h|0)){p=56;break a}else{M=I;N=h}while(1){l=M;while(1){H=l+8|0;if(tZb(d,j,l)|0){O=H;P=l;break}else l=H}l=N;while(1){H=l+-8|0;if(tZb(d,j,H)|0)l=H;else{Q=H;break}}if(P>>>0>=Q>>>0){j=P;continue b}l=P;H=c[l>>2]|0;G=c[l+4>>2]|0;l=Q;A=c[l+4>>2]|0;m=P;c[m>>2]=c[l>>2];c[m+4>>2]=A;A=Q;c[A>>2]=H;c[A+4>>2]=G;M=O;N=Q}}while(0);G=j+8|0;c:do if(G>>>0<D>>>0){A=G;H=D;m=B;l=E;while(1){R=A;while(1){S=R+8|0;if(tZb(d,R,m)|0)R=S;else{T=S;U=R;break}}R=H;while(1){S=R+-8|0;if(tZb(d,S,m)|0){V=S;break}else R=S}if(U>>>0>V>>>0){W=U;X=m;Y=l;break c}R=U;S=c[R>>2]|0;Z=c[R+4>>2]|0;R=V;_=c[R+4>>2]|0;$=U;c[$>>2]=c[R>>2];c[$+4>>2]=_;_=V;c[_>>2]=S;c[_+4>>2]=Z;A=T;H=V;m=(m|0)==(U|0)?V:m;l=l+1|0}}else{W=G;X=B;Y=E}while(0);if((W|0)!=(X|0)?tZb(d,X,W)|0:0){B=W;G=c[B>>2]|0;l=c[B+4>>2]|0;B=X;m=c[B+4>>2]|0;H=W;c[H>>2]=c[B>>2];c[H+4>>2]=m;m=X;c[m>>2]=G;c[m+4>>2]=l;aa=Y+1|0}else aa=Y;if(!aa){ba=wZb(j,W,d)|0;l=W+8|0;if(wZb(l,a,d)|0){p=51;break}if(ba){j=l;continue}}l=W;if((l-k|0)>=(b-l|0)){ca=j;da=W;p=55;break}rZb(j,W,d);j=W+8|0}if((p|0)==51){p=0;if(ba){p=56;break}else{g=j;a=W;continue}}else if((p|0)==55){p=0;rZb(da+8|0,a,d);g=ca;a=da;continue}}if((p|0)==4){if(!(tZb(d,u,s)|0)){i=e;return}u=s;da=c[u>>2]|0;a=c[u+4>>2]|0;u=t;ca=c[u+4>>2]|0;g=s;c[g>>2]=c[u>>2];c[g+4>>2]=ca;ca=t;c[ca>>2]=da;c[ca+4>>2]=a;i=e;return}else if((p|0)==6){uZb(q,q+8|0,r,d)|0;i=e;return}else if((p|0)==7){r=v+8|0;q=v+16|0;uZb(v,r,q,d)|0;if(!(tZb(d,x,q)|0)){i=e;return}x=q;a=c[x>>2]|0;ca=c[x+4>>2]|0;x=w;da=c[x+4>>2]|0;t=q;c[t>>2]=c[x>>2];c[t+4>>2]=da;da=w;c[da>>2]=a;c[da+4>>2]=ca;if(!(tZb(d,q,r)|0)){i=e;return}ca=r;da=c[ca>>2]|0;a=c[ca+4>>2]|0;ca=q;w=c[ca>>2]|0;t=c[ca+4>>2]|0;ca=r;c[ca>>2]=w;c[ca+4>>2]=t;ca=q;c[ca>>2]=da;c[ca+4>>2]=a;if(!(tZb(d,r,v)|0)){i=e;return}a=v;ca=c[a>>2]|0;da=c[a+4>>2]|0;a=v;c[a>>2]=w;c[a+4>>2]=t;t=r;c[t>>2]=ca;c[t+4>>2]=da;i=e;return}else if((p|0)==11){vZb(n,n+8|0,n+16|0,n+24|0,o,d)|0;i=e;return}else if((p|0)==13){o=y+16|0;uZb(y,y+8|0,o,d)|0;n=y+24|0;if((n|0)==(z|0)){i=e;return}else{ea=n;fa=o}while(1){if(tZb(d,ea,fa)|0){o=ea;n=c[o+4>>2]|0;da=f;c[da>>2]=c[o>>2];c[da+4>>2]=n;n=ea;da=fa;while(1){o=da;t=c[o+4>>2]|0;ca=n;c[ca>>2]=c[o>>2];c[ca+4>>2]=t;if((da|0)==(y|0)){ga=da;break}t=da+-8|0;if(tZb(d,f,t)|0){ca=da;da=t;n=ca}else{ga=da;break}}da=f;n=c[da+4>>2]|0;j=ga;c[j>>2]=c[da>>2];c[j+4>>2]=n}n=ea+8|0;if((n|0)==(z|0))break;else{j=ea;ea=n;fa=j}}i=e;return}else if((p|0)==56){i=e;return}}function sZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=i;i=i+16|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-8|0;j=g;b:while(1){k=j;l=b-k|0;m=l>>3;switch(m|0){case 2:{n=j;o=h;p=h;q=4;break a;break}case 3:{r=j;s=h;q=6;break a;break}case 4:{t=j;u=h;v=h;q=7;break a;break}case 5:{w=j;x=h;q=11;break a;break}case 1:case 0:{q=56;break a;break}default:{}}if((l|0)<248){y=j;z=a;q=13;break a}A=(m|0)/2|0;B=j+(A<<3)|0;if((l|0)>7992){l=(m|0)/4|0;C=zZb(j,j+(l<<3)|0,B,j+(l+A<<3)|0,h,d)|0}else C=yZb(j,B,h,d)|0;do if(xZb(d,j,B)|0){D=h;E=C}else{A=a;l=h;while(1){m=A+-16|0;if((j|0)==(m|0))break;if(xZb(d,m,B)|0){F=m;q=38;break}else{G=l;l=m;A=G}}if((q|0)==38){q=0;A=j;l=c[A>>2]|0;G=c[A+4>>2]|0;A=F;m=c[A+4>>2]|0;H=j;c[H>>2]=c[A>>2];c[H+4>>2]=m;m=F;c[m>>2]=l;c[m+4>>2]=G;D=F;E=C+1|0;break}G=j+8|0;if(xZb(d,j,h)|0)I=G;else{if((G|0)==(h|0)){q=56;break a}else{J=j;K=G}while(1){G=J+16|0;if(xZb(d,j,K)|0){L=K;break}if((G|0)==(h|0)){q=56;break a}else{m=K;K=G;J=m}}m=L;G=c[m>>2]|0;l=c[m+4>>2]|0;m=h;H=c[m+4>>2]|0;A=L;c[A>>2]=c[m>>2];c[A+4>>2]=H;H=h;c[H>>2]=G;c[H+4>>2]=l;I=L+8|0}if((I|0)==(h|0)){q=56;break a}else{M=I;N=h}while(1){l=M;while(1){H=l+8|0;if(xZb(d,j,l)|0){O=H;P=l;break}else l=H}l=N;while(1){H=l+-8|0;if(xZb(d,j,H)|0)l=H;else{Q=H;break}}if(P>>>0>=Q>>>0){j=P;continue b}l=P;H=c[l>>2]|0;G=c[l+4>>2]|0;l=Q;A=c[l+4>>2]|0;m=P;c[m>>2]=c[l>>2];c[m+4>>2]=A;A=Q;c[A>>2]=H;c[A+4>>2]=G;M=O;N=Q}}while(0);G=j+8|0;c:do if(G>>>0<D>>>0){A=G;H=D;m=B;l=E;while(1){R=A;while(1){S=R+8|0;if(xZb(d,R,m)|0)R=S;else{T=S;U=R;break}}R=H;while(1){S=R+-8|0;if(xZb(d,S,m)|0){V=S;break}else R=S}if(U>>>0>V>>>0){W=U;X=m;Y=l;break c}R=U;S=c[R>>2]|0;Z=c[R+4>>2]|0;R=V;_=c[R+4>>2]|0;$=U;c[$>>2]=c[R>>2];c[$+4>>2]=_;_=V;c[_>>2]=S;c[_+4>>2]=Z;A=T;H=V;m=(m|0)==(U|0)?V:m;l=l+1|0}}else{W=G;X=B;Y=E}while(0);if((W|0)!=(X|0)?xZb(d,X,W)|0:0){B=W;G=c[B>>2]|0;l=c[B+4>>2]|0;B=X;m=c[B+4>>2]|0;H=W;c[H>>2]=c[B>>2];c[H+4>>2]=m;m=X;c[m>>2]=G;c[m+4>>2]=l;aa=Y+1|0}else aa=Y;if(!aa){ba=AZb(j,W,d)|0;l=W+8|0;if(AZb(l,a,d)|0){q=51;break}if(ba){j=l;continue}}l=W;if((l-k|0)>=(b-l|0)){ca=j;da=W;q=55;break}sZb(j,W,d);j=W+8|0}if((q|0)==51){q=0;if(ba){q=56;break}else{g=j;a=W;continue}}else if((q|0)==55){q=0;sZb(da+8|0,a,d);g=ca;a=da;continue}}if((q|0)==4){if(!(xZb(d,p,n)|0)){i=e;return}p=n;da=c[p>>2]|0;a=c[p+4>>2]|0;p=o;ca=c[p+4>>2]|0;g=n;c[g>>2]=c[p>>2];c[g+4>>2]=ca;ca=o;c[ca>>2]=da;c[ca+4>>2]=a;i=e;return}else if((q|0)==6){yZb(r,r+8|0,s,d)|0;i=e;return}else if((q|0)==7){s=t+8|0;r=t+16|0;yZb(t,s,r,d)|0;if(!(xZb(d,v,r)|0)){i=e;return}v=r;a=c[v>>2]|0;ca=c[v+4>>2]|0;v=u;da=c[v+4>>2]|0;o=r;c[o>>2]=c[v>>2];c[o+4>>2]=da;da=u;c[da>>2]=a;c[da+4>>2]=ca;if(!(xZb(d,r,s)|0)){i=e;return}ca=s;da=c[ca>>2]|0;a=c[ca+4>>2]|0;ca=r;u=c[ca>>2]|0;o=c[ca+4>>2]|0;ca=s;c[ca>>2]=u;c[ca+4>>2]=o;ca=r;c[ca>>2]=da;c[ca+4>>2]=a;if(!(xZb(d,s,t)|0)){i=e;return}a=t;ca=c[a>>2]|0;da=c[a+4>>2]|0;a=t;c[a>>2]=u;c[a+4>>2]=o;o=s;c[o>>2]=ca;c[o+4>>2]=da;i=e;return}else if((q|0)==11){zZb(w,w+8|0,w+16|0,w+24|0,x,d)|0;i=e;return}else if((q|0)==13){x=y+16|0;yZb(y,y+8|0,x,d)|0;w=y+24|0;if((w|0)==(z|0)){i=e;return}else{ea=w;fa=x}while(1){if(xZb(d,ea,fa)|0){x=ea;w=c[x+4>>2]|0;da=f;c[da>>2]=c[x>>2];c[da+4>>2]=w;w=ea;da=fa;while(1){x=da;o=c[x+4>>2]|0;ca=w;c[ca>>2]=c[x>>2];c[ca+4>>2]=o;if((da|0)==(y|0)){ga=da;break}o=da+-8|0;if(xZb(d,f,o)|0){ca=da;da=o;w=ca}else{ga=da;break}}da=f;w=c[da+4>>2]|0;j=ga;c[j>>2]=c[da>>2];c[j+4>>2]=w}w=ea+8|0;if((w|0)==(z|0))break;else{j=ea;ea=w;fa=j}}i=e;return}else if((q|0)==56){i=e;return}}function tZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im;f=i;h=c[d>>2]|0;j=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[e>>2]|0;k=c[j+(h*44|0)+40>>2]|0;l=c[j+(a*44|0)+40>>2]|0;if((k|0)!=(l|0)){m=k>>>0<l>>>0;i=f;return m|0}l=b[j+(h*44|0)+4>>1]|0;k=b[j+(a*44|0)+4>>1]|0;if(l<<16>>16!=k<<16>>16){m=l<<16>>16<k<<16>>16;i=f;return m|0}k=c[d+4>>2]|0;d=c[e+4>>2]|0;e=k&65536;l=d&65536;if((e|0)!=(l|0)){m=e>>>0>l>>>0;i=f;return m|0}l=b[j+(h*44|0)+12>>1]|0;e=b[j+(a*44|0)+12>>1]|0;if(l<<16>>16!=e<<16>>16){m=(l&65535)<(e&65535);i=f;return m|0}e=c[j+(h*44|0)+16>>2]|0;l=c[j+(a*44|0)+16>>2]|0;if((e|0)!=(l|0)){m=(e|0)<(l|0);i=f;return m|0}l=c[j+(h*44|0)>>2]|0;e=c[j+(a*44|0)>>2]|0;if((l|0)!=(e|0)){m=(c[l+4>>2]|0)<(c[e+4>>2]|0);i=f;return m|0}e=k&255;k=d&255;if((e|0)!=(k|0)){m=e>>>0<k>>>0;i=f;return m|0}n=ea(g[j+(h*44|0)+20>>2]);o=ea(g[j+(a*44|0)+20>>2]);if(n!=o){m=n>o;i=f;return m|0}k=b[j+(h*44|0)+36>>1]|0;e=b[j+(a*44|0)+36>>1]|0;if(k<<16>>16==e<<16>>16){m=(h|0)<(a|0);i=f;return m|0}else{m=(k&65535)>(e&65535);i=f;return m|0}return 0}function uZb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=tZb(e,b,a)|0;h=tZb(e,d,b)|0;if(!g){if(!h){j=0;i=f;return j|0}g=b;k=c[g>>2]|0;l=c[g+4>>2]|0;g=d;m=c[g+4>>2]|0;n=b;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=d;c[m>>2]=k;c[m+4>>2]=l;if(!(tZb(e,b,a)|0)){j=1;i=f;return j|0}l=a;m=c[l>>2]|0;k=c[l+4>>2]|0;l=b;n=c[l+4>>2]|0;g=a;c[g>>2]=c[l>>2];c[g+4>>2]=n;n=b;c[n>>2]=m;c[n+4>>2]=k;j=2;i=f;return j|0}k=a;n=c[k>>2]|0;m=c[k+4>>2]|0;if(h){h=d;k=c[h+4>>2]|0;g=a;c[g>>2]=c[h>>2];c[g+4>>2]=k;k=d;c[k>>2]=n;c[k+4>>2]=m;j=1;i=f;return j|0}k=b;g=c[k+4>>2]|0;h=a;c[h>>2]=c[k>>2];c[h+4>>2]=g;g=b;c[g>>2]=n;c[g+4>>2]=m;if(!(tZb(e,d,b)|0)){j=1;i=f;return j|0}e=d;g=c[e+4>>2]|0;h=b;c[h>>2]=c[e>>2];c[h+4>>2]=g;g=d;c[g>>2]=n;c[g+4>>2]=m;j=2;i=f;return j|0}function vZb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=uZb(a,b,d,g)|0;if(tZb(g,e,d)|0){k=d;l=c[k>>2]|0;m=c[k+4>>2]|0;k=e;n=c[k+4>>2]|0;o=d;c[o>>2]=c[k>>2];c[o+4>>2]=n;n=e;c[n>>2]=l;c[n+4>>2]=m;m=j+1|0;if(tZb(g,d,b)|0){n=b;l=c[n>>2]|0;o=c[n+4>>2]|0;n=d;k=c[n+4>>2]|0;p=b;c[p>>2]=c[n>>2];c[p+4>>2]=k;k=d;c[k>>2]=l;c[k+4>>2]=o;if(tZb(g,b,a)|0){o=a;k=c[o>>2]|0;l=c[o+4>>2]|0;o=b;p=c[o+4>>2]|0;n=a;c[n>>2]=c[o>>2];c[n+4>>2]=p;p=b;c[p>>2]=k;c[p+4>>2]=l;q=j+3|0}else q=j+2|0}else q=m}else q=j;if(!(tZb(g,f,e)|0)){r=q;i=h;return r|0}j=e;m=c[j>>2]|0;l=c[j+4>>2]|0;j=f;p=c[j+4>>2]|0;k=e;c[k>>2]=c[j>>2];c[k+4>>2]=p;p=f;c[p>>2]=m;c[p+4>>2]=l;if(!(tZb(g,e,d)|0)){r=q+1|0;i=h;return r|0}l=d;p=c[l>>2]|0;m=c[l+4>>2]|0;l=e;f=c[l+4>>2]|0;k=d;c[k>>2]=c[l>>2];c[k+4>>2]=f;f=e;c[f>>2]=p;c[f+4>>2]=m;if(!(tZb(g,d,b)|0)){r=q+2|0;i=h;return r|0}m=b;f=c[m>>2]|0;p=c[m+4>>2]|0;m=d;e=c[m+4>>2]|0;k=b;c[k>>2]=c[m>>2];c[k+4>>2]=e;e=d;c[e>>2]=f;c[e+4>>2]=p;if(!(tZb(g,b,a)|0)){r=q+3|0;i=h;return r|0}g=a;p=c[g>>2]|0;e=c[g+4>>2]|0;g=b;f=c[g+4>>2]|0;d=a;c[d>>2]=c[g>>2];c[d+4>>2]=f;f=b;c[f>>2]=p;c[f+4>>2]=e;r=q+4|0;i=h;return r|0}function wZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;switch(b-a>>3|0){case 4:{g=a+8|0;h=a+16|0;j=b+-8|0;uZb(a,g,h,d)|0;if(!(tZb(d,j,h)|0)){k=1;i=e;return k|0}l=h;m=c[l>>2]|0;n=c[l+4>>2]|0;l=j;o=c[l+4>>2]|0;p=h;c[p>>2]=c[l>>2];c[p+4>>2]=o;o=j;c[o>>2]=m;c[o+4>>2]=n;if(!(tZb(d,h,g)|0)){k=1;i=e;return k|0}n=g;o=c[n>>2]|0;m=c[n+4>>2]|0;n=h;j=c[n>>2]|0;p=c[n+4>>2]|0;n=g;c[n>>2]=j;c[n+4>>2]=p;n=h;c[n>>2]=o;c[n+4>>2]=m;if(!(tZb(d,g,a)|0)){k=1;i=e;return k|0}m=a;n=c[m>>2]|0;o=c[m+4>>2]|0;m=a;c[m>>2]=j;c[m+4>>2]=p;p=g;c[p>>2]=n;c[p+4>>2]=o;k=1;i=e;return k|0}case 3:{uZb(a,a+8|0,b+-8|0,d)|0;k=1;i=e;return k|0}case 2:{o=b+-8|0;if(!(tZb(d,o,a)|0)){k=1;i=e;return k|0}p=a;n=c[p>>2]|0;g=c[p+4>>2]|0;p=o;m=c[p+4>>2]|0;j=a;c[j>>2]=c[p>>2];c[j+4>>2]=m;m=o;c[m>>2]=n;c[m+4>>2]=g;k=1;i=e;return k|0}case 5:{vZb(a,a+8|0,a+16|0,a+24|0,b+-8|0,d)|0;k=1;i=e;return k|0}case 1:case 0:{k=1;i=e;return k|0}default:{g=a+16|0;uZb(a,a+8|0,g,d)|0;m=a+24|0;if((m|0)==(b|0)){k=1;i=e;return k|0}else{q=0;r=m;s=g}while(1){if(tZb(d,r,s)|0){g=r;m=c[g+4>>2]|0;n=f;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=r;n=s;while(1){g=n;o=c[g+4>>2]|0;j=m;c[j>>2]=c[g>>2];c[j+4>>2]=o;if((n|0)==(a|0)){t=n;break}o=n+-8|0;if(tZb(d,f,o)|0){j=n;n=o;m=j}else{t=n;break}}n=f;m=c[n+4>>2]|0;j=t;c[j>>2]=c[n>>2];c[j+4>>2]=m;m=q+1|0;if((m|0)==8){u=r;break}else v=m}else v=q;m=r+8|0;if((m|0)==(b|0)){k=1;w=18;break}else{j=r;q=v;r=m;s=j}}if((w|0)==18){i=e;return k|0}k=(u+8|0)==(b|0);i=e;return k|0}}return 0}function xZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im;f=i;h=c[d>>2]|0;j=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[e>>2]|0;k=c[j+(h*44|0)+40>>2]|0;l=c[j+(a*44|0)+40>>2]|0;if((k|0)!=(l|0)){m=k>>>0<l>>>0;i=f;return m|0}l=b[j+(h*44|0)+4>>1]|0;k=b[j+(a*44|0)+4>>1]|0;if(l<<16>>16!=k<<16>>16){m=l<<16>>16<k<<16>>16;i=f;return m|0}n=ea(g[j+(h*44|0)+20>>2]);o=ea(g[j+(a*44|0)+20>>2]);if(n!=o){m=n<o;i=f;return m|0}k=b[j+(h*44|0)+36>>1]|0;l=b[j+(a*44|0)+36>>1]|0;if(k<<16>>16!=l<<16>>16){m=(k&65535)<(l&65535);i=f;return m|0}l=b[j+(h*44|0)+10>>1]|0;k=b[j+(a*44|0)+10>>1]|0;if(l<<16>>16!=k<<16>>16){m=(l&65535)<(k&65535);i=f;return m|0}k=c[d+4>>2]|0;d=c[e+4>>2]|0;e=k&65536;l=d&65536;if((e|0)!=(l|0)){m=e>>>0>l>>>0;i=f;return m|0}l=b[j+(h*44|0)+12>>1]|0;e=b[j+(a*44|0)+12>>1]|0;if(l<<16>>16!=e<<16>>16){m=(l&65535)<(e&65535);i=f;return m|0}e=c[j+(h*44|0)+16>>2]|0;l=c[j+(a*44|0)+16>>2]|0;if((e|0)!=(l|0)){m=(e|0)<(l|0);i=f;return m|0}l=c[j+(h*44|0)>>2]|0;e=c[j+(a*44|0)>>2]|0;if((l|0)!=(e|0)){m=(c[l+4>>2]|0)<(c[e+4>>2]|0);i=f;return m|0}e=k&255;k=d&255;if((e|0)==(k|0)){m=(h|0)<(a|0);i=f;return m|0}else{m=e>>>0<k>>>0;i=f;return m|0}return 0}function yZb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=xZb(e,b,a)|0;h=xZb(e,d,b)|0;if(!g){if(!h){j=0;i=f;return j|0}g=b;k=c[g>>2]|0;l=c[g+4>>2]|0;g=d;m=c[g+4>>2]|0;n=b;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=d;c[m>>2]=k;c[m+4>>2]=l;if(!(xZb(e,b,a)|0)){j=1;i=f;return j|0}l=a;m=c[l>>2]|0;k=c[l+4>>2]|0;l=b;n=c[l+4>>2]|0;g=a;c[g>>2]=c[l>>2];c[g+4>>2]=n;n=b;c[n>>2]=m;c[n+4>>2]=k;j=2;i=f;return j|0}k=a;n=c[k>>2]|0;m=c[k+4>>2]|0;if(h){h=d;k=c[h+4>>2]|0;g=a;c[g>>2]=c[h>>2];c[g+4>>2]=k;k=d;c[k>>2]=n;c[k+4>>2]=m;j=1;i=f;return j|0}k=b;g=c[k+4>>2]|0;h=a;c[h>>2]=c[k>>2];c[h+4>>2]=g;g=b;c[g>>2]=n;c[g+4>>2]=m;if(!(xZb(e,d,b)|0)){j=1;i=f;return j|0}e=d;g=c[e+4>>2]|0;h=b;c[h>>2]=c[e>>2];c[h+4>>2]=g;g=d;c[g>>2]=n;c[g+4>>2]=m;j=2;i=f;return j|0}function zZb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=yZb(a,b,d,g)|0;if(xZb(g,e,d)|0){k=d;l=c[k>>2]|0;m=c[k+4>>2]|0;k=e;n=c[k+4>>2]|0;o=d;c[o>>2]=c[k>>2];c[o+4>>2]=n;n=e;c[n>>2]=l;c[n+4>>2]=m;m=j+1|0;if(xZb(g,d,b)|0){n=b;l=c[n>>2]|0;o=c[n+4>>2]|0;n=d;k=c[n+4>>2]|0;p=b;c[p>>2]=c[n>>2];c[p+4>>2]=k;k=d;c[k>>2]=l;c[k+4>>2]=o;if(xZb(g,b,a)|0){o=a;k=c[o>>2]|0;l=c[o+4>>2]|0;o=b;p=c[o+4>>2]|0;n=a;c[n>>2]=c[o>>2];c[n+4>>2]=p;p=b;c[p>>2]=k;c[p+4>>2]=l;q=j+3|0}else q=j+2|0}else q=m}else q=j;if(!(xZb(g,f,e)|0)){r=q;i=h;return r|0}j=e;m=c[j>>2]|0;l=c[j+4>>2]|0;j=f;p=c[j+4>>2]|0;k=e;c[k>>2]=c[j>>2];c[k+4>>2]=p;p=f;c[p>>2]=m;c[p+4>>2]=l;if(!(xZb(g,e,d)|0)){r=q+1|0;i=h;return r|0}l=d;p=c[l>>2]|0;m=c[l+4>>2]|0;l=e;f=c[l+4>>2]|0;k=d;c[k>>2]=c[l>>2];c[k+4>>2]=f;f=e;c[f>>2]=p;c[f+4>>2]=m;if(!(xZb(g,d,b)|0)){r=q+2|0;i=h;return r|0}m=b;f=c[m>>2]|0;p=c[m+4>>2]|0;m=d;e=c[m+4>>2]|0;k=b;c[k>>2]=c[m>>2];c[k+4>>2]=e;e=d;c[e>>2]=f;c[e+4>>2]=p;if(!(xZb(g,b,a)|0)){r=q+3|0;i=h;return r|0}g=a;p=c[g>>2]|0;e=c[g+4>>2]|0;g=b;f=c[g+4>>2]|0;d=a;c[d>>2]=c[g>>2];c[d+4>>2]=f;f=b;c[f>>2]=p;c[f+4>>2]=e;r=q+4|0;i=h;return r|0}function AZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;switch(b-a>>3|0){case 4:{g=a+8|0;h=a+16|0;j=b+-8|0;yZb(a,g,h,d)|0;if(!(xZb(d,j,h)|0)){k=1;i=e;return k|0}l=h;m=c[l>>2]|0;n=c[l+4>>2]|0;l=j;o=c[l+4>>2]|0;p=h;c[p>>2]=c[l>>2];c[p+4>>2]=o;o=j;c[o>>2]=m;c[o+4>>2]=n;if(!(xZb(d,h,g)|0)){k=1;i=e;return k|0}n=g;o=c[n>>2]|0;m=c[n+4>>2]|0;n=h;j=c[n>>2]|0;p=c[n+4>>2]|0;n=g;c[n>>2]=j;c[n+4>>2]=p;n=h;c[n>>2]=o;c[n+4>>2]=m;if(!(xZb(d,g,a)|0)){k=1;i=e;return k|0}m=a;n=c[m>>2]|0;o=c[m+4>>2]|0;m=a;c[m>>2]=j;c[m+4>>2]=p;p=g;c[p>>2]=n;c[p+4>>2]=o;k=1;i=e;return k|0}case 1:case 0:{k=1;i=e;return k|0}case 3:{yZb(a,a+8|0,b+-8|0,d)|0;k=1;i=e;return k|0}case 2:{o=b+-8|0;if(!(xZb(d,o,a)|0)){k=1;i=e;return k|0}p=a;n=c[p>>2]|0;g=c[p+4>>2]|0;p=o;m=c[p+4>>2]|0;j=a;c[j>>2]=c[p>>2];c[j+4>>2]=m;m=o;c[m>>2]=n;c[m+4>>2]=g;k=1;i=e;return k|0}case 5:{zZb(a,a+8|0,a+16|0,a+24|0,b+-8|0,d)|0;k=1;i=e;return k|0}default:{g=a+16|0;yZb(a,a+8|0,g,d)|0;m=a+24|0;if((m|0)==(b|0)){k=1;i=e;return k|0}else{q=0;r=m;s=g}while(1){if(xZb(d,r,s)|0){g=r;m=c[g+4>>2]|0;n=f;c[n>>2]=c[g>>2];c[n+4>>2]=m;m=r;n=s;while(1){g=n;o=c[g+4>>2]|0;j=m;c[j>>2]=c[g>>2];c[j+4>>2]=o;if((n|0)==(a|0)){t=n;break}o=n+-8|0;if(xZb(d,f,o)|0){j=n;n=o;m=j}else{t=n;break}}n=f;m=c[n+4>>2]|0;j=t;c[j>>2]=c[n>>2];c[j+4>>2]=m;m=q+1|0;if((m|0)==8){u=r;break}else v=m}else v=q;m=r+8|0;if((m|0)==(b|0)){k=1;w=18;break}else{j=r;q=v;r=m;s=j}}if((w|0)==18){i=e;return k|0}k=(u+8|0)==(b|0);i=e;return k|0}}return 0}function BZb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;if((c[b+5980>>2]|0)!=11){i=j;return}o=Hzc(Gzc()|0,-1,-1,e,1,4,1,1)|0;if(o)In[c[(c[o>>2]|0)+36>>2]&4095](o,558120);LDc(o,0);uBc(o)|0;o_b(d,6,o);d=c[(c[b>>2]|0)+412>>2]|0;c[m>>2]=c[o+140>>2];c[n>>2]=c[o+148>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];co[d&2047](b,l,k);c[f>>2]=o;c[g>>2]=c[o+44>>2];a[h>>0]=1;i=j;return}function CZb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a+176>>2]|0;if((e|0)==-1){f=0;i=d;return f|0}a=0;g=~e;e=0;while(1){if((g&1|0)!=0?(h=c[b+(a<<2)+4>>2]|0,(h|0)!=-1):0)j=1<<h|e;else j=e;g=g>>>1;if(!g){f=j;break}else{a=a+1|0;e=j}}i=d;return f|0}function DZb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=z5b()|0;d=c[b+4>>2]|0;if((d|0)==(b|0)){e=0;i=a;return e|0}else{f=d;g=-1}while(1){d=c[f+144>>2]|0;h=((d|0)==0?-1:d)&g;f=c[f+4>>2]|0;if((f|0)==(b|0)){j=h;break}else g=h}e=~j;i=a;return e|0}function EZb(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0;j=i;i=i+448|0;k=j+96|0;l=j+60|0;m=j+352|0;n=j+304|0;o=j+240|0;p=j+340|0;q=j+416|0;r=j+428|0;s=j+24|0;t=j+12|0;u=j+228|0;v=j+36|0;w=j;x=j+48|0;y=ync()|0;z=c[b>>2]|0;A=ea(g[z+184>>2]);B=ea(ea(F$b(c[a>>2]|0))*ea(1.00100005));C=c[z+212>>2]|0;if((C|0)!=2|f){if((C|0)!=0|f){v1b(k,ync()|0);f=c[a>>2]|0;D=ea(g[b+48>>2]);E=ea(D+ea(g[b+56>>2]));F=ea(g[b+52>>2]);G=ea(F+ea(g[b+60>>2]));g[r>>2]=D;g[r+4>>2]=F;g[r+8>>2]=B;u0b(q,f,r);g[t>>2]=D;g[t+4>>2]=G;g[t+8>>2]=B;u0b(s,f,t);g[v>>2]=E;g[v+4>>2]=G;g[v+8>>2]=B;u0b(u,f,v);g[x>>2]=E;g[x+4>>2]=F;g[x+8>>2]=B;u0b(w,f,x);B=ea(G$b(f));l1b(ea(0.0),B,1,ync()|0);co[c[(c[y>>2]|0)+576>>2]&2047](y,2,h);B=ea(g[q>>2]);H=ea(g[q+4>>2]);I=ea(g[q+8>>2]);qn[c[(c[y>>2]|0)+560>>2]&7](y,B,H,I);qn[c[(c[y>>2]|0)+556>>2]&7](y,D,F,ea(0.0));I=ea(g[s>>2]);H=ea(g[s+4>>2]);B=ea(g[s+8>>2]);qn[c[(c[y>>2]|0)+560>>2]&7](y,I,H,B);qn[c[(c[y>>2]|0)+556>>2]&7](y,D,G,ea(0.0));D=ea(g[u>>2]);B=ea(g[u+4>>2]);H=ea(g[u+8>>2]);qn[c[(c[y>>2]|0)+560>>2]&7](y,D,B,H);qn[c[(c[y>>2]|0)+556>>2]&7](y,E,G,ea(0.0));G=ea(g[w>>2]);H=ea(g[w+4>>2]);B=ea(g[w+8>>2]);qn[c[(c[y>>2]|0)+560>>2]&7](y,G,H,B);qn[c[(c[y>>2]|0)+556>>2]&7](y,E,F,ea(0.0));ko[c[(c[y>>2]|0)+580>>2]&4095](y);w1b(k);i=j;return}y=m+0|0;w=e+0|0;e=y+64|0;do{c[y>>2]=c[w>>2];y=y+4|0;w=w+4|0}while((y|0)<(e|0));hnc(n);inc(n,0,0);inc(n,1,2);F=ea(A/ea(g[z+196>>2]));g[p>>2]=F;g[p+4>>2]=F;g[p+8>>2]=A;jMc(m,p)|0;c[l>>2]=c[139528];p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(k,p,l);z=c[k>>2]|0;w=c[p+28>>2]|0;if((z|0)==-1){J=w+(c[p+32>>2]<<3)|0;break}else{J=w+(z<<3)|0;break}}else J=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((J|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[J+4>>2]|0,(p|0)!=0):0)K=p;else L=31}else L=31;if((L|0)==31)K=hQb(c[139528]|0)|0;_uc(n,K,m,-1);i=j;return}hnc(l);inc(l,0,0);inc(l,1,2);kMc(o,d)|0;g[o>>2]=A;g[o+20>>2]=A;g[o+40>>2]=A;do if(ea(g[b+60>>2])>ea(.25)){c[n>>2]=c[139526];d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(k,d,n);K=c[k>>2]|0;L=c[d+28>>2]|0;if((K|0)==-1){M=L+(c[d+32>>2]<<3)|0;break}else{M=L+(K<<3)|0;break}}else M=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((M|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[M+4>>2]|0,(d|0)!=0):0){N=d;break}}N=hQb(c[139526]|0)|0}else{c[m>>2]=c[139524];d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(k,d,m);K=c[k>>2]|0;L=c[d+28>>2]|0;if((K|0)==-1){O=L+(c[d+32>>2]<<3)|0;break}else{O=L+(K<<3)|0;break}}else O=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((O|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[O+4>>2]|0,(d|0)!=0):0){N=d;break}}N=hQb(c[139524]|0)|0}while(0);_uc(l,N,o,-1);i=j;return}function FZb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;i=i+64|0;b=a+24|0;d=a+44|0;e=a+48|0;f=a+52|0;g=a+12|0;h=a;j=a+32|0;k=c[139524]|0;do if(k){c[f>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(b,l,f);m=c[b>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(c[o+4>>2]|0)!=0:0)break}if(!(hQb(c[139524]|0)|0))p=11}else p=11;while(0);if((p|0)==11){rri(g,610064,15);o=nUc(mUc()|0,43,g)|0;if(!o)q=0;else q=c[o+4>>2]|0;c[139524]=q;xri(g)}g=c[139526]|0;do if(g){c[e>>2]=g;q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(b,q,e);o=c[b>>2]|0;f=c[q+28>>2]|0;if((o|0)==-1){r=f+(c[q+32>>2]<<3)|0;break}else{r=f+(o<<3)|0;break}}else r=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((r|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(c[r+4>>2]|0)!=0:0)break}if(!(hQb(c[139526]|0)|0))p=24}else p=24;while(0);if((p|0)==24){rri(h,610048,13);p=nUc(mUc()|0,43,h)|0;if(!p)s=0;else s=c[p+4>>2]|0;c[139526]=s;xri(h)}h=c[139528]|0;if(h){c[d>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(b,h,d);s=c[b>>2]|0;p=c[h+28>>2]|0;if((s|0)==-1){t=p+(c[h+32>>2]<<3)|0;break}else{t=p+(s<<3)|0;break}}else t=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((t|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(c[t+4>>2]|0)!=0:0){i=a;return}}if(hQb(c[139528]|0)|0){i=a;return}}rri(j,610080,11);t=nUc(mUc()|0,43,j)|0;if(!t)u=0;else u=c[t+4>>2]|0;c[139528]=u;xri(j);i=a;return}function GZb(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+16|0;j=h;k=ync()|0;l=Hzc(Gzc()|0,-1,-1,2,1,0,1,1)|0;if(l)In[c[(c[l>>2]|0)+36>>2]&4095](l,558136);LDc(l,0);uBc(l)|0;oBc(l,0,-1,0);o_b(c[a+116>>2]|0,7,l);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;Uvc(7,j,ea(1.0),0,f);In[c[(c[k>>2]|0)+104>>2]&4095](k,a+12|0);a=c[b+8>>2]|0;if(!a){i=h;return l|0}j=0;do{m=c[(c[d>>2]|0)+(j<<2)>>2]|0;n=c[b>>2]|0;o=n+(m*44|0)+32|0;p=c[o>>2]|0;q=c[(c[p+52>>2]|0)+24>>2]|0;if((q|0)!=-1?(r=c[n+(m*44|0)+28>>2]|0,K_b(k,f,ea(g[r+120>>2])),s=c[(c[c[(c[o>>2]|0)+52>>2]>>2]|0)+(q<<2)>>2]|0,o=c[s+16>>2]|0,(o|0)>0):0){t=n+(m*44|0)|0;u=r+112|0;v=r+116|0;w=n+(m*44|0)+6|0;m=0;do{if((c[(c[(c[s>>2]|0)+(m<<2)>>2]|0)+584>>2]|0)==6?(n=ekd(c[t>>2]|0,m,p,f,q)|0,(n|0)!=0):0){t8b(r,c[u>>2]|0);x=c[v>>2]|0;co[c[(c[x>>2]|0)+8>>2]&2047](x,e[w>>1]|0,n)}m=m+1|0}while((m|0)!=(o|0))}j=j+1|0}while((j|0)!=(a|0));i=h;return l|0}function HZb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d+4|0;h=d;j=a+172|0;k=c[j>>2]|0;do if(k){c[f>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,f);m=c[e>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[o+4>>2]|0,(l|0)!=0):0)p=l;else q=10}else q=10;if((q|0)==10){l=hQb(c[j>>2]|0)|0;if(!l)break;else p=l}c[g>>2]=c[139540];c[e+0>>2]=c[g+0>>2];rkd(b,e,p);i=d;return}while(0);if(c[a+212>>2]|0){i=d;return}a=c[139542]|0;if(!a){p=C8b(X8b()|0)|0;c[139542]=p;r=p}else r=a;c[h>>2]=c[139540];c[e+0>>2]=c[h+0>>2];rkd(b,e,r);i=d;return}function IZb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+48|0;h=j+36|0;b=j+32|0;l=j+16|0;m=j+8|0;n=j;if(!e){i=j;return}o=c[e+8>>2]|0;if(!o){i=j;return}c[l>>2]=0;p=l+8|0;c[p>>2]=0;q=l+12|0;c[q>>2]=0;r=l+4|0;c[r>>2]=60;if(!k){k=o>>>2;if(!k)s=0;else{c[q>>2]=k;c[b>>2]=60;c[h+0>>2]=c[b+0>>2];t=hOb(0,k*44|0,4,h,0,3653512,370)|0;c[l>>2]=t;s=t}t=s;s=0;while(1){k=c[e>>2]|0;u=k+(s*44|0)|0;if((a[(c[(c[k+(s*44|0)+28>>2]|0)+116>>2]|0)+42>>0]|0)!=0?(c[(c[(c[k+(s*44|0)+32>>2]|0)+52>>2]|0)+20>>2]|0)!=-1:0){k=(c[p>>2]|0)+1|0;c[p>>2]=k;v=c[q>>2]|0;w=v&2147483647;if(k>>>0>w>>>0){x=v<<1;y=(x|0)==0?1:x;do if(w>>>0<y>>>0)if((v|0)>-1){c[q>>2]=y;c[b>>2]=c[r>>2];c[h+0>>2]=c[b+0>>2];x=hOb(t,y*44|0,4,h,0,3653512,370)|0;c[l>>2]=x;z=x;break}else{c[b>>2]=c[r>>2];c[h+0>>2]=c[b+0>>2];x=cOb(y*44|0,4,h,0,3653512,352)|0;YEi(x|0,c[l>>2]|0,(c[p>>2]|0)*44|0)|0;c[q>>2]=y;c[l>>2]=x;z=x;break}else z=t;while(0);A=c[p>>2]|0;B=z}else{A=k;B=t}y=B+((A+-1|0)*44|0)+0|0;v=u+0|0;w=y+44|0;do{c[y>>2]=c[v>>2];y=y+4|0;v=v+4|0}while((y|0)<(w|0));C=B}else C=t;s=s+1|0;if(s>>>0>=o>>>0)break;else t=C}if(c[p>>2]|0){D=l;E=18}}else{D=e;E=18}if((E|0)==18){c[m>>2]=c[g>>2];c[h+0>>2]=c[m+0>>2];qBc(1,f,h,d,0,-1,0)|0;d=ync()|0;if(a[621195]|0)on[c[(c[d>>2]|0)+640>>2]&31](d,ea(1.0),ea(0.0));c[n>>2]=0;c[n+4>>2]=-1;u_b(D,n,1,c[158074]|0);on[c[(c[d>>2]|0)+640>>2]&31](d,ea(0.0),ea(0.0))}if((c[q>>2]|0)<=-1){i=j;return}q=c[l>>2]|0;c[b>>2]=c[r>>2];c[h+0>>2]=c[b+0>>2];eOb(q,h);c[l>>2]=0;i=j;return}function JZb(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+16|0;h=d;if(!(c[139544]|0)){j=Xmd()|0;rri(f,558184,35);k=Nmd(j,f)|0;xri(f);if(!k)l=c[139544]|0;else{f=bkd(k,61,0)|0;c[139544]=f;l=f}if(!l){m=0;i=d;return m|0}}l=Hzc(Gzc()|0,-1,-1,0,0,0,1,1)|0;if(l){LDc(l,0);In[c[(c[l>>2]|0)+36>>2]&4095](l,558224)}oBc(l,0,-1,0);g[h>>2]=ea(.5);g[h+4>>2]=ea(.5);g[h+8>>2]=ea(1.0);g[h+12>>2]=ea(1.0);Uvc(1,h,ea(1.0),0,c[158074]|0);F3b(0,l,c[139544]|0,0,0,-1);o_b(c[b+116>>2]|0,4,l);if(!(a[558256]|0)){c[e>>2]=-1;itd(e,558880);c[139562]=c[e>>2];a[558256]=1}qud((c[158074]|0)+20|0,558248,l)|0;m=l;i=d;return m|0}function KZb(){var a=0,b=0;a=i;i=i+16|0;b=a;c[139524]=0;c[139526]=0;c[139528]=0;c[b>>2]=-1;itd(b,562072);c[139540]=c[b>>2];i=a;return}function LZb(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0;o=i;i=i+976|0;p=o+16|0;q=o+40|0;r=o+20|0;s=o+764|0;t=o+780|0;u=o;v=o+24|0;w=o+776|0;c[n>>2]=0;x=pyc()|0;y=c[(c[x+24>>2]|0)+((c[x+40>>2]|0)*96|0)+16>>2]|0;x=Hwc(Vwc()|0)|0;YEi(q|0,c[(c[b>>2]|0)+8>>2]|0,612)|0;z=c[158074]|0;g[m>>2]=ea(ea(g[m>>2])+ea(-.00999999977));A=m+4|0;g[A>>2]=ea(ea(g[A>>2])+ea(-.00999999977));A=m+8|0;g[A>>2]=ea(ea(g[A>>2])+ea(-.00999999977));A=m+12|0;g[A>>2]=ea(ea(g[A>>2])+ea(.00999999977));A=m+16|0;g[A>>2]=ea(ea(g[A>>2])+ea(.00999999977));A=m+20|0;g[A>>2]=ea(ea(g[A>>2])+ea(.00999999977));i2b((x2b()|0)+32|0,558320,2);if(!(c[139580]|0)){i=o;return}FZb();if(!(a[558336]|0)){c[p>>2]=-1;itd(p,558848);c[139582]=c[p>>2];a[558336]=1}if(!(a[558352]|0)){c[p>>2]=-1;itd(p,558624);c[139586]=c[p>>2];a[558352]=1}A=mo[c[(c[h>>2]|0)+116>>2]&4095](h)|0;B=mo[c[(c[h>>2]|0)+120>>2]&4095](h)|0;C=z+20|0;if(a[621165]|0){c[r>>2]=c[f>>2];D=ea(g[e+72>>2]);E=ea(g[e+76>>2]);F=ea(g[e+64>>2]);G=ea(g[e+68>>2]);c[p+0>>2]=c[r+0>>2];tud(C,558328,p,A,B,D,E,F,G)}qud(C,558344,h)|0;h=ync()|0;C=ync()|0;B=mo[c[(c[C>>2]|0)+92>>2]&4095](C)|0;In[c[(c[C>>2]|0)+88>>2]&4095](C,0);In[c[(c[h>>2]|0)+140>>2]&4095](h,0);C=c[(c[h>>2]|0)+40>>2]|0;a[s>>0]=0;a[s+1>>0]=-1;a[s+2>>0]=-1;a[s+4>>0]=8;a[s+5>>0]=0;a[s+6>>0]=0;a[s+7>>0]=0;a[s+8>>0]=8;a[s+9>>0]=0;a[s+10>>0]=0;a[s+11>>0]=0;A=_n[C&4095](h,s)|0;t1b(t,ync()|0);In[c[(c[h>>2]|0)+100>>2]&4095](h,601008);Bcc((c[c[b>>2]>>2]|0)+636|0,6,z);s=c[d>>2]|0;C=(a[d+16>>0]|0)==0?0:s;r=c[d+8>>2]|0;d=s+(r*108|0)|0;if(r){r=s;do{if(!((a[r+9>>0]|0)==0|(r|0)==(C|0)))QZb(c[b>>2]|0,q,y,x,j,e,A,m,t,k,l,r,0,z)|0;r=r+108|0}while((r|0)!=(d|0))}if((C|0)!=0?(d=QZb(c[b>>2]|0,q,y,x,j,e,A,m,t,k,l,C,1,z)|0,(d|0)!=0):0){o_b(c[(c[b>>2]|0)+116>>2]|0,5,d);c[n>>2]=d}K9b(z);d=k;n=c[d>>2]|0;C=c[d+4>>2]|0;G=ea(g[k+8>>2]);F=ea(g[k+12>>2]);k=(Hwc(Vwc()|0)|0)==1;E=k?F:ea(1.0);F=k?G:ea(1.0);k=h+676|0;c[k>>2]=n;c[k+4>>2]=C;g[h+684>>2]=F;g[h+688>>2]=E;co[c[(c[h>>2]|0)+64>>2]&2047](h,A,0);A=c[j>>2]|0;if(!A){C=Hzc(Gzc()|0,16,16,0,0,0,1,1)|0;c[j>>2]=C;if(!C)H=0;else{In[c[(c[C>>2]|0)+36>>2]&4095](C,558360);H=c[j>>2]|0}oBc(H,0,-1,0);g[u>>2]=ea(1.0);g[u+4>>2]=ea(1.0);g[u+8>>2]=ea(1.0);g[u+12>>2]=ea(1.0);c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;Uvc(1,(a[(c[c[b>>2]>>2]|0)+620>>0]|0)!=0?v:u,ea(1.0),0,z);u=c[(c[h>>2]|0)+408>>2]|0;c[w>>2]=c[e+148>>2];c[p+0>>2]=c[w+0>>2];In[u&4095](h,p);p=c[j>>2]|0;if(p){I=p;J=20}}else{I=A;J=20}if((J|0)==20)o_b(c[(c[b>>2]|0)+116>>2]|0,9,I);Bcc((c[c[b>>2]>>2]|0)+636|0,7,z);u1b(t);t=ync()|0;In[c[(c[t>>2]|0)+88>>2]&4095](t,B);i=o;return}function MZb(d,f,h,j,k){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=0,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=0,xa=0,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=Im,Wa=0,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=Im,db=Im,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;l=i;i=i+512|0;m=l;n=l+144|0;o=l+4|0;p=l+16|0;q=l+480|0;r=l+488|0;s=l+20|0;t=l+504|0;u=l+148|0;v=l+348|0;w=l+224|0;x=ea(g[(c[(c[d>>2]|0)+8>>2]|0)+580>>2]);y=c[158074]|0;z=ync()|0;In[c[(c[z>>2]|0)+140>>2]&4095](z,0);a[o+1>>0]=-1;a[o+4>>0]=8;a[o+6>>0]=0;a[o+7>>0]=0;a[o+8>>0]=8;a[o+10>>0]=0;a[o+11>>0]=0;a[o+2>>0]=-17;a[o>>0]=1;a[o+9>>0]=2;a[o+5>>0]=2;A=_n[c[(c[z>>2]|0)+40>>2]&4095](z,o)|0;o=Hzc(Gzc()|0,-1,-1,0,0,0,1,1)|0;if(o)In[c[(c[o>>2]|0)+36>>2]&4095](o,558384);LDc(o,0);uBc(o)|0;c[p>>2]=c[o+140>>2];B=(c[(c[c[d>>2]>>2]|0)+376>>2]|0)==4;c[q>>2]=c[f+148>>2];c[m+0>>2]=c[q+0>>2];qBc(1,p,m,o,0,-1,B?4:12)|0;o_b(c[(c[d>>2]|0)+116>>2]|0,8,o);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;Uvc(B?1:7,r,ea(1.0),0,y);In[c[(c[z>>2]|0)+104>>2]&4095](z,(c[d>>2]|0)+12|0);Bcc((c[c[d>>2]>>2]|0)+636|0,4,y);C7b(s,l7b()|0);r=Vwc()|0;if(Dwc(r)|0)if((Hwc(r)|0)==1)C=(c[r+84>>2]|0)!=2;else C=1;else C=0;B=(Ewc(r)|0)&C;r=d+4|0;p=c[(c[r>>2]|0)+8>>2]|0;q=p>>>4;f=j+12|0;D=c[f>>2]|0;do if((D&2147483647)>>>0<q>>>0)if((D|0)>-1){c[f>>2]=q;E=c[j>>2]|0;c[n>>2]=c[j+4>>2];c[m+0>>2]=c[n+0>>2];c[j>>2]=hOb(E,q*44|0,4,m,0,3653512,370)|0;break}else{c[n>>2]=c[j+4>>2];c[m+0>>2]=c[n+0>>2];E=cOb(q*44|0,4,m,0,3653512,352)|0;YEi(E|0,c[j>>2]|0,(c[j+8>>2]|0)*44|0)|0;c[f>>2]=q;c[j>>2]=E;break}while(0);RYb(u,t);a[u+68>>0]=0;Q_b(v,u,t);if(!p){TYb(u);F=c[d>>2]|0;G=c[F>>2]|0;H=G+636|0;Bcc(H,5,y);aZb(u);i=l;return o|0}t=d+8|0;q=k+4|0;D=k+8|0;E=k+12|0;I=k+16|0;J=k+20|0;K=j+8|0;L=j+4|0;M=z+5968|0;N=v+128|0;O=0;P=0;Q=-1;R=-1;S=-1;T=ea(-1.0);U=16711935;V=0;W=0;X=-1;Y=0;while(1){Z=c[(c[t>>2]|0)+(W<<2)>>2]|0;_=c[c[r>>2]>>2]|0;$=_+(Z*44|0)|0;aa=c[_+(Z*44|0)+32>>2]|0;ba=c[_+(Z*44|0)+28>>2]|0;ca=ea(g[_+(Z*44|0)+24>>2]);if(ca>x){da=c[d>>2]|0;fa=ea(g[da+20>>2]);if(fa<ea(0.0))ga=ea(-fa);else ga=fa;fa=ea(ga*ea(g[ba+76>>2]));ha=ea(g[da+36>>2]);if(ha<ea(0.0))ia=ea(-ha);else ia=ha;ha=ea(fa+ea(ia*ea(g[ba+80>>2])));fa=ea(g[da+52>>2]);if(fa<ea(0.0))ja=ea(-fa);else ja=fa;if(ea(ca-ea(ha+ea(ja*ea(g[ba+84>>2]))))>x)ka=0;else ka=1}else ka=1;da=c[$>>2]|0;la=ba+116|0;ma=c[la>>2]|0;na=c[ma+168>>2]|0;if(!na)oa=0;else oa=c[na+32>>2]|0;na=b[_+(Z*44|0)+8>>1]|0;pa=(na<<1&65535)<<16>>16>>1;qa=pa<<16>>16;ra=(na&65535)>>>15&65535;ha=ea(g[ba+120>>2]);na=c[_+(Z*44|0)+12>>2]|0;if(pa<<16>>16==-1){pa=c[(c[aa+52>>2]|0)+24>>2]|0;if((pa|0)==-1){if(ka?(a[ma+42>>0]|0)!=0:0){ma=ba+64|0;ca=ea(g[ma>>2]);sa=ba+76|0;fa=ea(ca+ea(g[sa>>2]));ta=ba+68|0;ca=ea(g[ta>>2]);ua=ba+80|0;va=ea(ca+ea(g[ua>>2]));wa=ba+72|0;ca=ea(g[wa>>2]);xa=ba+84|0;ya=ea(ca+ea(g[xa>>2]));ca=ea(g[k>>2]);za=fa<ca?fa:ca;ca=ea(g[q>>2]);Aa=va<ca?va:ca;ca=ea(g[D>>2]);Ba=ya<ca?ya:ca;g[k>>2]=za;g[q>>2]=Aa;g[D>>2]=Ba;ca=ea(g[E>>2]);Ca=ca<fa?fa:ca;ca=ea(g[I>>2]);fa=ca<va?va:ca;ca=ea(g[J>>2]);va=ca<ya?ya:ca;g[E>>2]=Ca;g[I>>2]=fa;g[J>>2]=va;ca=ea(g[ma>>2]);ya=ea(ca-ea(g[sa>>2]));ca=ea(g[ta>>2]);Da=ea(ca-ea(g[ua>>2]));ca=ea(g[wa>>2]);Ea=ea(ca-ea(g[xa>>2]));g[k>>2]=ya<za?ya:za;g[q>>2]=Da<Aa?Da:Aa;g[D>>2]=Ea<Ba?Ea:Ba;g[E>>2]=Ca<ya?ya:Ca;g[I>>2]=fa<Da?Da:fa;g[J>>2]=va<Ea?Ea:va}xa=(c[K>>2]|0)+1|0;c[K>>2]=xa;wa=c[f>>2]|0;ua=wa&2147483647;if(xa>>>0>ua>>>0){ta=wa<<1;sa=(ta|0)==0?1:ta;do if(ua>>>0<sa>>>0)if((wa|0)>-1){c[f>>2]=sa;ta=c[j>>2]|0;c[n>>2]=c[L>>2];c[m+0>>2]=c[n+0>>2];c[j>>2]=hOb(ta,sa*44|0,4,m,0,3653512,370)|0;break}else{c[n>>2]=c[L>>2];c[m+0>>2]=c[n+0>>2];ta=cOb(sa*44|0,4,m,0,3653512,352)|0;YEi(ta|0,c[j>>2]|0,(c[K>>2]|0)*44|0)|0;c[f>>2]=sa;c[j>>2]=ta;break}while(0);Fa=c[K>>2]|0}else Fa=xa;Ga=(c[j>>2]|0)+((Fa+-1|0)*44|0)+0|0;Ha=$+0|0;Ia=Ga+44|0;do{c[Ga>>2]=c[Ha>>2];Ga=Ga+4|0;Ha=Ha+4|0}while((Ga|0)<(Ia|0));Ja=U;Ka=T;La=S;Ma=Q;Na=R;Oa=P;Pa=O;Qa=V;Ra=X;Sa=Y}else{Ta=pa;Ua=35}}else{Ta=qa;Ua=35}if((Ua|0)==35){Ua=0;do if((O|0)==(da|0)&(P|0)==(aa|0)&(Q|0)==(Ta|0)&(R|0)==(oa|0)&(S|0)==(ra|0)?(xa=(T>ea(0.0)&1)-(T<ea(0.0)&1)|0,(xa|0)==((ha>ea(0.0)&1)-(ha<ea(0.0)&1)|0)):0){if((xa|0)<0){va=ea(T-ha);if(va<ea(0.0))Va=ea(-va);else Va=va;if(!(Va<=ea(9.99999997e-07))|(U|0)!=(na|0)){Ua=46;break}else{Wa=U;Xa=T;Ya=S;Za=Q;_a=R;$a=P;ab=O;bb=0;break}}va=ea(T*ea(16.0));if(!(va>=ea(0.0)))cb=ea(va+ea(-.99999994));else cb=va;va=ea(ha*ea(16.0));if(!(va>=ea(0.0)))db=ea(va+ea(-.99999994));else db=va;if(!((~~cb|0)!=(~~db|0)|(U|0)!=(na|0))){Wa=U;Xa=T;Ya=S;Za=Q;_a=R;$a=P;ab=O;bb=0}else Ua=46}else Ua=46;while(0);if((Ua|0)==46){Ua=0;TYb(u);K_b(z,y,ha);Wa=na;Xa=ha;Ya=ra;Za=Ta;_a=oa;$a=aa;ab=da;bb=1}k7b(w);qa=ba+64|0;b8b(c[la>>2]|0,qa,s,w);if(FEi(v,w,124)|0){Ga=v+0|0;Ha=w+0|0;Ia=Ga+124|0;do{c[Ga>>2]=c[Ha>>2];Ga=Ga+4|0;Ha=Ha+4|0}while((Ga|0)<(Ia|0));R_b(c[N>>2]|0,w)}da=c[la>>2]|0;ra=(c[da+36>>2]&65534|0)==254;na=_7b(da,B,C)|0;da=c[(c[c[aa+52>>2]>>2]|0)+(Ta<<2)>>2]|0;pa=c[da+16>>2]|0;if((pa|0)>0){xa=na?128:192;na=ba+76|0;sa=ba+68|0;wa=ba+80|0;ua=ba+72|0;ta=ba+84|0;ma=_+(Z*44|0)+6|0;if(ra){ra=V;eb=0;fb=X;gb=Y;hb=bb;while(1){if((c[(c[(c[da>>2]|0)+(eb<<2)>>2]|0)+584>>2]|0)==6){ib=ka?xa:xa|32;jb=c[la>>2]|0;kb=c[h+((mo[c[(c[jb>>2]|0)+28>>2]&4095](jb)|0)<<2)+4>>2]|0;if((kb|0)==-1)lb=ib;else lb=1<<kb|ib;if((eb|0)==(fb|0)&(lb|0)==(gb|0))if(hb)Ua=57;else{mb=ra;nb=gb;ob=0}else{TYb(u);Ua=57}if((Ua|0)==57){Ua=0;ib=ekd(c[$>>2]|0,eb,aa,y,Ta)|0;co[c[(c[z>>2]|0)+64>>2]&2047](z,A,c[M>>2]|lb);mb=ib;nb=lb;ob=1}ha=ea(g[qa>>2]);va=ea(ha+ea(g[na>>2]));ha=ea(g[sa>>2]);Ea=ea(ha+ea(g[wa>>2]));ha=ea(g[ua>>2]);fa=ea(ha+ea(g[ta>>2]));ha=ea(g[k>>2]);Da=va<ha?va:ha;ha=ea(g[q>>2]);Ca=Ea<ha?Ea:ha;ha=ea(g[D>>2]);ya=fa<ha?fa:ha;g[k>>2]=Da;g[q>>2]=Ca;g[D>>2]=ya;ha=ea(g[E>>2]);Ba=ha<va?va:ha;ha=ea(g[I>>2]);va=ha<Ea?Ea:ha;ha=ea(g[J>>2]);Ea=ha<fa?fa:ha;g[E>>2]=Ba;g[I>>2]=va;g[J>>2]=Ea;ha=ea(g[qa>>2]);fa=ea(ha-ea(g[na>>2]));ha=ea(g[sa>>2]);Aa=ea(ha-ea(g[wa>>2]));ha=ea(g[ua>>2]);za=ea(ha-ea(g[ta>>2]));g[k>>2]=fa<Da?fa:Da;g[q>>2]=Aa<Ca?Aa:Ca;g[D>>2]=za<ya?za:ya;g[E>>2]=Ba<fa?fa:Ba;g[I>>2]=va<Aa?Aa:va;g[J>>2]=Ea<za?za:Ea;if(!mb){pb=0;qb=eb;rb=nb;sb=ob}else{SYb(u,c[la>>2]|0,ba,e[ma>>1]|0,mb);pb=mb;qb=eb;rb=nb;sb=ob}}else{pb=ra;qb=fb;rb=gb;sb=hb}eb=eb+1|0;if((eb|0)>=(pa|0)){Ja=Wa;Ka=Xa;La=Ya;Ma=Za;Na=_a;Oa=$a;Pa=ab;Qa=pb;Ra=qb;Sa=rb;break}else{ra=pb;fb=qb;gb=rb;hb=sb}}}else{hb=V;gb=0;fb=X;ra=Y;eb=bb;while(1){if((c[(c[(c[da>>2]|0)+(gb<<2)>>2]|0)+584>>2]|0)==6){xa=ka?128:160;Z=c[la>>2]|0;_=c[h+((mo[c[(c[Z>>2]|0)+28>>2]&4095](Z)|0)<<2)+4>>2]|0;if((_|0)==-1)tb=xa;else tb=1<<_|xa;if((gb|0)==(fb|0)&(tb|0)==(ra|0))if(eb)Ua=67;else{ub=hb;vb=ra;wb=0}else{TYb(u);Ua=67}if((Ua|0)==67){Ua=0;xa=ekd(c[$>>2]|0,gb,aa,y,Ta)|0;co[c[(c[z>>2]|0)+64>>2]&2047](z,A,c[M>>2]|tb);ub=xa;vb=tb;wb=1}Ea=ea(g[qa>>2]);za=ea(Ea+ea(g[na>>2]));Ea=ea(g[sa>>2]);va=ea(Ea+ea(g[wa>>2]));Ea=ea(g[ua>>2]);Aa=ea(Ea+ea(g[ta>>2]));Ea=ea(g[k>>2]);Ba=za<Ea?za:Ea;Ea=ea(g[q>>2]);fa=va<Ea?va:Ea;Ea=ea(g[D>>2]);ya=Aa<Ea?Aa:Ea;g[k>>2]=Ba;g[q>>2]=fa;g[D>>2]=ya;Ea=ea(g[E>>2]);Ca=Ea<za?za:Ea;Ea=ea(g[I>>2]);za=Ea<va?va:Ea;Ea=ea(g[J>>2]);va=Ea<Aa?Aa:Ea;g[E>>2]=Ca;g[I>>2]=za;g[J>>2]=va;Ea=ea(g[qa>>2]);Aa=ea(Ea-ea(g[na>>2]));Ea=ea(g[sa>>2]);Da=ea(Ea-ea(g[wa>>2]));Ea=ea(g[ua>>2]);ha=ea(Ea-ea(g[ta>>2]));g[k>>2]=Aa<Ba?Aa:Ba;g[q>>2]=Da<fa?Da:fa;g[D>>2]=ha<ya?ha:ya;g[E>>2]=Ca<Aa?Aa:Ca;g[I>>2]=za<Da?Da:za;g[J>>2]=va<ha?ha:va;if(!ub){xb=0;yb=gb;zb=vb;Ab=wb}else{SYb(u,c[la>>2]|0,ba,e[ma>>1]|0,ub);xb=ub;yb=gb;zb=vb;Ab=wb}}else{xb=hb;yb=fb;zb=ra;Ab=eb}gb=gb+1|0;if((gb|0)>=(pa|0)){Ja=Wa;Ka=Xa;La=Ya;Ma=Za;Na=_a;Oa=$a;Pa=ab;Qa=xb;Ra=yb;Sa=zb;break}else{hb=xb;fb=yb;ra=zb;eb=Ab}}}}else{Ja=Wa;Ka=Xa;La=Ya;Ma=Za;Na=_a;Oa=$a;Pa=ab;Qa=V;Ra=X;Sa=Y}}W=W+1|0;if(W>>>0>=p>>>0)break;else{O=Pa;P=Oa;Q=Ma;R=Na;S=La;T=Ka;U=Ja;V=Qa;X=Ra;Y=Sa}}TYb(u);F=c[d>>2]|0;G=c[F>>2]|0;H=G+636|0;Bcc(H,5,y);aZb(u);i=l;return o|0}function NZb(d,f,h,j,k){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=0,ba=Im,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=Im,oa=0,pa=0,qa=Im,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=Im,ya=Im,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0;l=i;i=i+432|0;m=l+420|0;n=l+344|0;o=l+120|0;p=l+108|0;q=l;r=c[158074]|0;s=ync()|0;In[c[(c[s>>2]|0)+140>>2]&4095](s,0);oBc(f,0,-1,0);t=c[(c[s>>2]|0)+72>>2]|0;if(!(j|k^1))if(!f)u=1;else u=(a[f+130>>0]|0)!=0;else u=0;In[t&4095](s,u);J$b(c[c[d>>2]>>2]|0,1);if(!h){if(j)v=qvc()|0;else v=pvc()|0;j=qud(r+20|0,558296,v)|0;ixd(j,ea(1.0),ea(1.0));jxd(j,ea(0.0),ea(0.0))}else NBc(h,558296)|0;Bcc((c[c[d>>2]>>2]|0)+636|0,8,r);h=Vwc()|0;y8b(h);j=Dwc(Vwc()|0)|0;v=(X8b()|0)+296|0;RYb(n,m);N_b(o,n,m);S_b(p,n,m);a[n+68>>0]=0;m=d+4|0;u=c[m>>2]|0;t=c[u+8>>2]|0;if(!t){TYb(n);w=c[d>>2]|0;x=c[w>>2]|0;y=x+636|0;Bcc(y,9,r);z=ync()|0;A=c[z>>2]|0;B=A+72|0;C=c[B>>2]|0;In[C&4095](z,0);aZb(n);i=l;return}f=d+8|0;k=o+108|0;D=o+216|0;o=16711935;E=u;u=0;F=0;G=-1;H=-1;I=-1;J=ea(-1.0);K=0;L=0;M=-1;while(1){N=c[(c[f>>2]|0)+(L<<2)>>2]|0;O=c[E>>2]|0;P=c[O+(N*44|0)+28>>2]|0;Q=O+(N*44|0)+32|0;R=c[Q>>2]|0;S=O+(N*44|0)|0;T=c[S>>2]|0;U=P+116|0;V=c[U>>2]|0;W=c[V+168>>2]|0;if(!W)X=0;else X=c[W+32>>2]|0;W=b[O+(N*44|0)+8>>1]|0;Y=(W<<1&65535)<<16>>16>>1;Z=Y<<16>>16;_=(W&65535)>>>15&65535;$=ea(g[P+120>>2]);W=c[O+(N*44|0)+12>>2]|0;if(Y<<16>>16==-1){Y=c[(c[R+52>>2]|0)+24>>2]|0;if((Y|0)==-1){aa=o;ba=J;ca=I;da=G;fa=H;ga=F;ha=u;ia=K;ja=M}else{ka=Y;la=16}}else{ka=Z;la=16}if((la|0)==16){la=0;do if((T|0)==(u|0)&(R|0)==(F|0)&(ka|0)==(G|0)&(X|0)==(H|0)&(_|0)==(I|0)?(Z=($>ea(0.0)&1)-($<ea(0.0)&1)|0,(Z|0)==((J>ea(0.0)&1)-(J<ea(0.0)&1)|0)):0){if((Z|0)<0){ma=ea($-J);if(ma<ea(0.0))na=ea(-ma);else na=ma;if(!(na<=ea(9.99999997e-07))|(W|0)!=(o|0)){la=27;break}else{oa=V;pa=o;qa=J;ra=I;sa=G;ta=H;ua=F;va=u;wa=0;break}}ma=ea($*ea(16.0));if(!(ma>=ea(0.0)))xa=ea(ma+ea(-.99999994));else xa=ma;ma=ea(J*ea(16.0));if(!(ma>=ea(0.0)))ya=ea(ma+ea(-.99999994));else ya=ma;if(!((~~xa|0)!=(~~ya|0)|(W|0)!=(o|0))){oa=V;pa=o;qa=J;ra=I;sa=G;ta=H;ua=F;va=u;wa=0}else la=27}else la=27;while(0);if((la|0)==27){la=0;TYb(n);K_b(s,r,$);oa=c[U>>2]|0;pa=W;qa=$;ra=_;sa=ka;ta=X;ua=R;va=T;wa=1}T_b(p,oa,c[O+(N*44|0)+16>>2]|0);a8b(P,v,j,q);V=0;do{if((c[k+(V<<2)>>2]|0)!=(c[q+(V<<2)>>2]|0)){la=31;break}V=V+1|0}while((V|0)<27);if((la|0)==31){la=0;V=k+0|0;T=q+0|0;_=V+108|0;do{c[V>>2]=c[T>>2];V=V+4|0;T=T+4|0}while((V|0)<(_|0));O_b(c[D>>2]|0,q)}T=c[(c[c[(c[Q>>2]|0)+52>>2]>>2]|0)+(ka<<2)>>2]|0;V=c[T+16>>2]|0;if((V|0)>0){_=O+(N*44|0)+12|0;W=O+(N*44|0)+6|0;Z=K;Y=0;za=M;Aa=wa;while(1){if((c[(c[(c[T>>2]|0)+(Y<<2)>>2]|0)+584>>2]|0)==7){if((Y|0)==(za|0))if(Aa)la=38;else{Ba=Z;Ca=0}else{TYb(n);la=38}if((la|0)==38){la=0;x8b(h,_);Ba=ekd(c[S>>2]|0,Y,R,r,ka)|0;Ca=1}if(!Ba){Da=0;Ea=Y;Fa=Ca}else{SYb(n,c[U>>2]|0,P,e[W>>1]|0,Ba);Da=Ba;Ea=Y;Fa=Ca}}else{Da=Z;Ea=za;Fa=Aa}Y=Y+1|0;if((Y|0)>=(V|0)){aa=pa;ba=qa;ca=ra;da=sa;fa=ta;ga=ua;ha=va;ia=Da;ja=Ea;break}else{Z=Da;za=Ea;Aa=Fa}}}else{aa=pa;ba=qa;ca=ra;da=sa;fa=ta;ga=ua;ha=va;ia=K;ja=M}}Aa=L+1|0;if(Aa>>>0>=t>>>0)break;o=aa;E=c[m>>2]|0;u=ha;F=ga;G=da;H=fa;I=ca;J=ba;K=ia;L=Aa;M=ja}TYb(n);w=c[d>>2]|0;x=c[w>>2]|0;y=x+636|0;Bcc(y,9,r);z=ync()|0;A=c[z>>2]|0;B=A+72|0;C=c[B>>2]|0;In[C&4095](z,0);aZb(n);i=l;return}function OZb(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;n=i;i=i+288|0;o=n;p=n+192|0;q=n+8|0;r=n+168|0;s=n+224|0;t=n+184|0;u=n+188|0;v=n+32|0;w=n+200|0;x=n+240|0;y=n+244|0;z=n+248|0;A=n+252|0;B=n+256|0;C=n+264|0;D=n+280|0;E=n+284|0;c[f>>2]=0;c[h>>2]=0;a[m>>0]=0;F=c[158074]|0;G=q+8|0;c[G>>2]=0;H=q+16|0;I=q+20|0;c[I>>2]=0;J=q+12|0;c[J>>2]=60;c[q>>2]=b;c[q+4>>2]=d;K=q+8|0;c[H>>2]=0;L=c[d>>2]|0;M=d+8|0;N=c[M>>2]|0;O=L+(N*44|0)|0;if(!N){P=L;Q=0}else{N=1;R=0;S=0;T=L;L=0;while(1){c[H>>2]=N;V=R&2147483647;if(N>>>0>V>>>0){W=R<<1;X=(W|0)==0?1:W;do if(V>>>0<X>>>0)if((R|0)>-1){c[I>>2]=X;c[p>>2]=c[J>>2];c[o+0>>2]=c[p+0>>2];W=hOb(S,X<<2,4,o,0,3653512,370)|0;c[K>>2]=W;Y=W;break}else{c[p>>2]=c[J>>2];c[o+0>>2]=c[p+0>>2];W=cOb(X<<2,4,o,0,3653512,352)|0;YEi(W|0,c[K>>2]|0,c[H>>2]<<2|0)|0;c[I>>2]=X;c[K>>2]=W;Y=W;break}else Y=S;while(0);Z=c[H>>2]|0;_=Y}else{Z=N;_=S}c[_+(Z+-1<<2)>>2]=L;X=T+44|0;if((X|0)==(O|0))break;N=(c[H>>2]|0)+1|0;R=c[I>>2]|0;S=_;T=X;L=L+1|0}P=c[d>>2]|0;Q=c[M>>2]|0}RZb(P,P+(Q*44|0)|0,o);Q=ync()|0;x9b(c[b>>2]|0,s,t,u);$=ea(g[t>>2]);w9b(c[b>>2]|0,ea(1.0),$,ea(g[u>>2]),r);u=Q+676|0;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];u=Q+916|0;c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];c[u+12>>2]=c[s+12>>2];s=X8b()|0;u=(KLc()|0)==1;$=ea(g[s+40>>2]);do if(u){do if(!($<=ea(.0404499993)))if($<ea(1.0)){aa=ea(+U(+ea(ea($+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{aa=ea(+U(+$,2.20000005));break}else aa=ea($/ea(12.9200001));while(0);ba=ea(g[s+44>>2]);do if(!(ba<=ea(.0404499993)))if(ba<ea(1.0)){ca=ea(+U(+ea(ea(ba+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{ca=ea(+U(+ba,2.20000005));break}else ca=ea(ba/ea(12.9200001));while(0);ba=ea(g[s+48>>2]);if(ba<=ea(.0404499993)){da=aa;fa=ca;ga=ea(ba/ea(12.9200001));break}if(ba<ea(1.0)){da=aa;fa=ca;ga=ea(+U(+ea(ea(ba+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{da=aa;fa=ca;ga=ea(+U(+ba,2.20000005));break}}else{ba=ea(g[s+44>>2]);da=$;fa=ba;ga=ea(g[s+48>>2])}while(0);$=ea(g[s+52>>2]);g[Q+660>>2]=da;g[Q+664>>2]=fa;g[Q+668>>2]=ga;g[Q+672>>2]=$;Q=ync()|0;s=c[(c[b>>2]|0)+348>>2]|0;uBc(s)|0;u=DZb()|0;c[v>>2]=u;t=v+4|0;P=t+128|0;do{c[t>>2]=-1;t=t+4|0}while((t|0)<(P|0));t=v+132|0;c[t>>2]=0;P=0;M=3;L=0;T=1;while(1){if(!(T&u)){ha=P;ia=M}else{if((P|0)<4){c[v+(L<<2)+4>>2]=M;ja=c[t>>2]|0}else ja=P;_=ja+1|0;c[t>>2]=_;ha=_;ia=M+-1|0}L=L+1|0;if((L|0)==32)break;else{P=ha;M=ia;T=T<<1}}a[658128]=0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+0>>2]=c[150280];c[w+4>>2]=c[150281];c[w+8>>2]=c[150282];$=ea(-ea(g[150280]));ga=ea(-ea(g[150281]));fa=ea(-ea(g[150282]));g[w+12>>2]=$;g[w+16>>2]=ga;g[w+20>>2]=fa;T=MZb(q,s,v,e,w)|0;c[f>>2]=T;ia=c[T+140>>2]|0;M=c[s+148>>2]|0;c[x>>2]=c[s+136>>2];ha=c[s+120>>2]|0;P=(c[Q+5980>>2]|0)==8;if(P){L=GZb(b,d,K,F)|0;c[x>>2]=c[L+44>>2];c[f>>2]=L;F=c[L+140>>2]|0;K=c[L+148>>2]|0;a[m>>0]=1;ka=F;la=K}else{ka=ia;la=M}if(a[621165]|0){if((((a[k+16>>0]|0)!=0?(M=c[k>>2]|0,(M|0)!=0):0)?(ia=c[M>>2]|0,(ia|0)!=0):0)?(c[ia+212>>2]|0)==1:0)ma=(c[ia+116>>2]|0)==0;else ma=1;ia=c[(c[b>>2]|0)+604>>2]&1;if(!(ma&(ia|0)==0)){c[y>>2]=ka;c[z>>2]=la;la=c[s+100>>2]|0;ka=c[s+104>>2]|0;c[p+0>>2]=c[y+0>>2];c[o+0>>2]=c[z+0>>2];IZb(b,s,e,p,o,la,ka,(ia|0)!=0)}}if(!P)BZb(Q,c[b+116>>2]|0,ha,f,x,m);c[A>>2]=0;c[B>>2]=c[x>>2];c[o+0>>2]=c[B+0>>2];LZb(q,k,s,o,T,A,r,v,w,j);a[658128]=1;j=c[b>>2]|0;if(!(a[j+623>>0]|0))na=j;else{c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;Co[c[(c[Q>>2]|0)+24>>2]&3](Q,4,C,ea(1.0),0);na=c[b>>2]|0}C=c[A>>2]|0;NZb(q,s,C,(a[na+620>>0]|0)!=0,l);if(C){l=c[(c[Q>>2]|0)+448>>2]|0;c[D>>2]=c[C+140>>2];c[o+0>>2]=c[D+0>>2];Dn[l&511](Q,o,0,-4);l=c[(c[Q>>2]|0)+448>>2]|0;c[E>>2]=c[C+148>>2];c[o+0>>2]=c[E+0>>2];Dn[l&511](Q,o,0,-4)}if(c[(c[b>>2]|0)+604>>2]&2){c[h>>2]=JZb(b,e)|0;oBc(s,0,-1,0)}In[c[(c[Q>>2]|0)+104>>2]&4095](Q,b+12|0);In[c[(c[Q>>2]|0)+140>>2]&4095](Q,0);if((c[I>>2]|0)<=-1){i=n;return}I=c[G>>2]|0;c[p>>2]=c[J>>2];c[o+0>>2]=c[p+0>>2];eOb(I,o);c[G>>2]=0;i=n;return}function PZb(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,558432);c[139566]=c[b>>2];c[b>>2]=-1;itd(b,558456);c[139568]=c[b>>2];c[b>>2]=-1;itd(b,558480);c[139570]=c[b>>2];c[b>>2]=-1;itd(b,562072);c[139572]=c[b>>2];c[b>>2]=-1;itd(b,558512);c[139574]=c[b>>2];c[b>>2]=-1;itd(b,558536);c[139576]=c[b>>2];c[b>>2]=-1;itd(b,565136);c[139578]=c[b>>2];i=a;return}function QZb(b,d,e,f,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;s=i;i=i+1568|0;t=s+1488|0;u=s+304|0;v=s+292|0;w=s+736|0;x=s+40|0;y=s+264|0;z=s+720|0;A=s+36|0;B=s+56|0;C=s+72|0;D=s+136|0;E=s+200|0;F=s+684|0;G=s+708|0;H=s+764|0;I=s+740|0;J=s+368|0;K=s+384|0;L=s+400|0;M=s+416|0;N=s+424|0;O=s+44|0;P=s+48|0;Q=s+680|0;R=s+16|0;S=s+280|0;T=s;V=s+1554|0;W=s+696|0;X=s+752|0;Y=s+24|0;Z=s+1552|0;_=c[p>>2]|0;$=_+212|0;if((c[$>>2]|0)!=3)if(!(a[_+217>>0]|0))aa=0;else aa=(c[_+208>>2]|0)==1?1:2;else aa=2;QGc(u,BTb(c[_+24>>2]|0)|0);ba=ea(g[u+48>>2]);ca=ea(g[u+52>>2]);da=ea(g[u+56>>2]);g[v>>2]=ba;fa=v+4|0;g[fa>>2]=ca;ga=v+8|0;g[ga>>2]=da;ha=_+116|0;ia=c[ha>>2]|0;do if(ia){if((c[$>>2]|0)==1){if((ia|0)<=1)break}else if(!((a[(NOc()|0)+103>>0]|0)!=0&(ia|0)>1))break;L9b()|0}while(0);ia=ync()|0;c[w>>2]=0;ja=c[j+148>>2]|0;c[x>>2]=c[j+140>>2];ka=(a[(c[b>>2]|0)+620>>0]|0)!=0;g[y>>2]=ea(1.0);g[y+4>>2]=ea(1.0);g[y+8>>2]=ea(1.0);g[y+12>>2]=ea(1.0);c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;la=c[h>>2]|0;if(!la){ma=Gzc()|0;if(ka){na=ync()|0;oa=mo[c[(c[na>>2]|0)+672>>2]&4095](na)|0}else oa=0;na=Hzc(ma,-1,-1,0,oa,0,1,1)|0;c[h>>2]=na;if(!na)pa=0;else{In[c[(c[na>>2]|0)+36>>2]&4095](na,558408);pa=c[h>>2]|0}uBc(pa)|0;LDc(c[h>>2]|0,0);pa=c[h>>2]|0;c[w>>2]=c[pa+140>>2];c[A>>2]=ja;c[t+0>>2]=c[A+0>>2];qBc(1,w,t,pa,0,-1,4)|0;Uvc(1,ka?z:y,ea(1.0),0,r);qa=c[h>>2]|0}else qa=la;c[w>>2]=c[qa+140>>2];J4b(_);da=ea(g[u+32>>2]);ca=ea(g[u+36>>2]);ba=ea(g[u+40>>2]);qa=(KLc()|0)==1;ra=ea(g[_+136>>2]);do if(qa){do if(!(ra<=ea(.0404499993)))if(ra<ea(1.0)){sa=ea(+U(+ea(ea(ra+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{sa=ea(+U(+ra,2.20000005));break}else sa=ea(ra/ea(12.9200001));while(0);ta=ea(g[_+140>>2]);do if(!(ta<=ea(.0404499993)))if(ta<ea(1.0)){ua=ea(+U(+ea(ea(ta+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{ua=ea(+U(+ta,2.20000005));break}else ua=ea(ta/ea(12.9200001));while(0);ta=ea(g[_+144>>2]);if(ta<=ea(.0404499993)){va=sa;wa=ua;xa=ea(ta/ea(12.9200001));break}if(ta<ea(1.0)){va=sa;wa=ua;xa=ea(+U(+ea(ea(ta+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{va=sa;wa=ua;xa=ea(+U(+ta,2.20000005));break}}else{ta=ea(g[_+140>>2]);va=ra;wa=ta;xa=ea(g[_+144>>2])}while(0);ra=ea(g[_+148>>2]);ua=ea(g[_+180>>2]);sa=ea(ea(wa*ua)*ea(2.0));wa=ea(ea(xa*ua)*ea(2.0));xa=ea(ea(ra*ua)*ea(2.0));g[B>>2]=ea(ea(va*ua)*ea(2.0));g[B+4>>2]=sa;g[B+8>>2]=wa;g[B+12>>2]=xa;qa=c[$>>2]|0;if(!qa){ya=t+0|0;za=_+40|0;Aa=ya+64|0;do{c[ya>>2]=c[za>>2];ya=ya+4|0;za=za+4|0}while((ya|0)<(Aa|0));g[F>>2]=ea(-.5);g[F+4>>2]=ea(-.5);g[F+8>>2]=ea(1.0);iMc(C,F)|0;g[G>>2]=ea(.5);g[G+4>>2]=ea(.5);g[G+8>>2]=ea(0.0);kMc(D,G)|0;xa=ea(g[_+196>>2]);nMc(E,xa,ea(0.0),ea(g[_+184>>2]))|0;dMc(D,E,H);dMc(H,C,D);dMc(D,t,ia+3556|0)}else if((qa|0)==2){ya=ia+3556|0;za=_+40|0;Aa=ya+64|0;do{c[ya>>2]=c[za>>2];ya=ya+4|0;za=za+4|0}while((ya|0)<(Aa|0))}else if((qa|0)==1){xa=ea(ea(1.0)/ea(g[_+192>>2]));g[I>>2]=xa;g[I+4>>2]=xa;g[I+8>>2]=ea(0.0);iMc(C,I)|0;g[J>>2]=ea(.5);g[J+4>>2]=ea(.5);g[J+8>>2]=ea(0.0);kMc(D,J)|0;dMc(D,C,E);dMc(E,_+40|0,ia+3556|0)}HZb(_,c[139580]|0);E=p+20|0;if((a[E>>0]|0)!=0?(a[p+21>>0]|0)!=0:0)Ba=1;else Ba=(c[$>>2]|0)==1;C=r+20|0;nud(C,558304,Ba?ea(1.0):ea(0.0));xa=ea(g[v>>2]);wa=ea(g[fa>>2]);sa=ea(g[ga>>2]);ua=ea(g[_+184>>2]);va=ea(ea(1.0)/ea(ua*ua));g[K>>2]=xa;g[K+4>>2]=wa;g[K+8>>2]=sa;g[K+12>>2]=va;oud(C,558264,K);g[L>>2]=da;g[L+4>>2]=ca;g[L+8>>2]=ba;g[L+12>>2]=ea(0.0);oud(C,558272,L);oud(C,558280,B);B=c[139580]|0;c[t>>2]=-1;itd(t,564232);c[M>>2]=c[t>>2];C=rvc()|0;c[t+0>>2]=c[M+0>>2];rkd(B,t,C);YEi(H|0,d|0,612)|0;do if(c[p+4>>2]|0){ba=ea(g[l>>2]);ca=ea(g[150280]);if((ba==ca?(ba=ea(g[l+4>>2]),ba==ea(g[150281])):0)?(ba=ea(g[l+8>>2]),ba==ea(g[150282])):0){Ca=56;break}ba=ea(-ca);ca=ea(-ea(g[150282]));if(ea(g[l+12>>2])==ba?(ba=ea(-ea(g[150281])),ea(g[l+16>>2])==ba):0)Da=ea(g[l+20>>2])!=ca;else Da=1;if(Da&(e|0)!=0){d=c[ha>>2]|0;C=(e|0)==1&(d|0)!=0?1:d;M9b(r,c[$>>2]|0,C,0,1);In[c[(c[ia>>2]|0)+104>>2]&4095](ia,b+12|0);co[c[(c[ia>>2]|0)+64>>2]&2047](ia,k,0);ko[c[(c[ia>>2]|0)+404>>2]&4095](ia);d=N9b(H,p,l,r,N)|0;do if(d){g[ia+756>>2]=ea(ea(1.0)-ea(g[_+124>>2]));g[ia+760>>2]=ea(0.0);g[ia+764>>2]=ea(0.0);g[ia+768>>2]=ea(0.0);B=c[$>>2]|0;if(!B){ya=ia+3044|0;za=N+0|0;Aa=ya+64|0;do{c[ya>>2]=c[za>>2];ya=ya+4|0;za=za+4|0}while((ya|0)<(Aa|0));Ea=d}else if((B|0)==1){ya=ia+3044|0;za=N+0|0;Aa=ya+64|0;do{c[ya>>2]=c[za>>2];ya=ya+4|0;za=za+4|0}while((ya|0)<(Aa|0));P9b(N,H,r);Ea=O9b(c[b>>2]|0,d,C,r)|0}else Ea=d;ca=ea(ea(.5)/ea(mo[c[(c[Ea>>2]|0)+116>>2]&4095](Ea)|0));ba=ea(ea(.5)/ea(mo[c[(c[Ea>>2]|0)+120>>2]&4095](Ea)|0));da=ea(-ca);va=ea(-ba);g[ia+692>>2]=da;g[ia+696>>2]=va;g[ia+700>>2]=ea(0.0);g[ia+704>>2]=ea(0.0);g[ia+708>>2]=ca;g[ia+712>>2]=va;g[ia+716>>2]=ea(0.0);g[ia+720>>2]=ea(0.0);g[ia+724>>2]=da;g[ia+728>>2]=ba;g[ia+732>>2]=ea(0.0);g[ia+736>>2]=ea(0.0);g[ia+740>>2]=ca;g[ia+744>>2]=ba;g[ia+748>>2]=ea(0.0);g[ia+752>>2]=ea(0.0);B=c[139580]|0;c[O>>2]=c[139578];c[t+0>>2]=c[O+0>>2];rkd(B,t,Ea);B=c[h>>2]|0;if(!B){c[Q>>2]=ja;c[t+0>>2]=c[Q+0>>2];qBc(1,x,t,j,0,-1,0)|0;Fa=Ea;break}else{c[P>>2]=ja;c[t+0>>2]=c[P+0>>2];qBc(1,w,t,B,0,-1,0)|0;Fa=Ea;break}}else{K9b(r);Fa=0}while(0);In[c[(c[ia>>2]|0)+108>>2]&4095](ia,m+132|0);In[c[(c[ia>>2]|0)+104>>2]&4095](ia,m+68|0);s1b(ync()|0);In[c[(c[ia>>2]|0)+140>>2]&4095](ia,0);Ga=Fa}else Ca=56}else Ca=56;while(0);if((Ca|0)==56){K9b(r);Ga=0}Fa=R;c[Fa>>2]=64;c[Fa+4>>2]=0;Fa=(aa|0)==0;if(!Fa)if((aa|0)==1&(f|0)!=1){c[R>>2]=64;Ha=1}else Ha=2;else{c[R>>2]=0;Ha=1}f=p+21|0;do if((a[E>>0]|0)==0?(a[f>>0]|0)==0&Fa:0){m=c[$>>2]|0;if(m){Ea=CZb(_,o)|0;if((m|0)==2)Ia=Ea;else{Ja=Ea;Ka=0;break}}else Ia=CZb(_,o)|0;Ea=dkd(ckd()|0,0,r,0,1)|0;a[S+4>>0]=1;a[S+5>>0]=0;a[S+6>>0]=1;m=S+7|0;a[m+0>>0]=0;a[m+1>>0]=0;a[m+2>>0]=0;a[m+3>>0]=0;a[m+4>>0]=0;c[S>>2]=0;m=c[ia>>2]|0;t=c[m+52>>2]|0;w=_n[c[m+32>>2]&4095](ia,S)|0;go[t&63](ia,w,ea(0.0));w=T;c[w>>2]=0;c[w+4>>2]=0;c[T+4>>2]=0;g[T+8>>2]=ea(0.0);c[T>>2]=0;w=c[ia>>2]|0;t=c[w+56>>2]|0;m=_n[c[w+44>>2]&4095](ia,T)|0;In[t&4095](ia,m);a[V>>0]=0;a[V+1>>0]=4;m=c[ia>>2]|0;t=c[m+60>>2]|0;w=_n[c[m+36>>2]&4095](ia,V)|0;In[t&4095](ia,w);a[W+6>>0]=0;a[W+10>>0]=0;a[W>>0]=1;a[W+1>>0]=-1;a[W+2>>0]=16;a[W+11>>0]=5;a[W+7>>0]=5;a[W+9>>0]=0;a[W+5>>0]=0;w=(Ia|0)!=0?6:8;a[W+8>>0]=w;a[W+4>>0]=w;w=c[ia>>2]|0;t=c[w+64>>2]|0;m=_n[c[w+40>>2]&4095](ia,W)|0;co[t&2047](ia,m,Ia|192);EZb(b,p,v,u,Ba,Ea);c[S>>2]=15;Ea=c[ia>>2]|0;m=c[Ea+52>>2]|0;t=_n[c[Ea+32>>2]&4095](ia,S)|0;go[m&63](ia,t,ea(0.0));Ja=Ia;Ka=1}else Ca=65;while(0);if((Ca|0)==65){Ja=CZb(_,o)|0;Ka=0}o=n+8|0;Ca=n+12|0;Ia=n+4|0;S=_+124|0;_=ia+676|0;W=ia+684|0;V=ia+688|0;T=ia+756|0;t=ia+760|0;m=ia+764|0;Ea=ia+768|0;w=X+1|0;P=X+2|0;ja=X+4|0;j=X+5|0;x=X+6|0;Q=X+7|0;h=X+8|0;O=X+9|0;H=X+10|0;N=X+11|0;za=(aa|0)==1;aa=za?-64:-128;ya=(aa&255|32)&255;Aa=Y+4|0;l=Y+8|0;k=Z+1|0;e=0;do{ha=n;Da=c[ha+4>>2]|0;ba=ea(g[o>>2]);ca=ea(g[Ca>>2]);da=ea(g[Ia>>2]);va=ea(ea(1.0)-ea(g[S>>2]));d=(e|0)==0|Fa;sa=d?ea(0.0):ca;wa=d?ea(0.0):ba;xa=d?ca:ea(0.0);ca=d?ba:ea(0.0);d=_;c[d>>2]=c[ha>>2];c[d+4>>2]=Da;g[W>>2]=wa;g[V>>2]=sa;g[T>>2]=va;g[t>>2]=da;g[m>>2]=ca;g[Ea>>2]=xa;Da=c[139580]|0;d=Da+32|0;ha=c[d>>2]|0;if(!ha){Qjd(Da);La=c[d>>2]|0}else La=ha;ha=c[La+48>>2]|0;d=La+48|0;if(ha){Da=c[139572]|0;C=d;B=ha;a:while(1){ha=B;while(1){if((c[ha+16>>2]|0)>=(Da|0)){Ma=ha;break}ha=c[ha+4>>2]|0;if(!ha){Na=C;break a}}B=c[Ma>>2]|0;if(!B){Na=Ma;break}else C=Ma}if(((Na|0)!=(d|0)?(Da|0)>=(c[Na+16>>2]|0):0)?(C=c[Na+20>>2]|0,(C|0)!=0):0)mxd(C,ea(-8.0))}C=c[139580]|0;if(!(a[(c[b>>2]|0)+620>>0]|0))Oa=dkd(C,0,r,0,1)|0;else Oa=dkd(C,1,r,0,1)|0;a[w>>0]=-1;a[P>>0]=-1;a[j>>0]=0;a[x>>0]=0;a[Q>>0]=0;a[O>>0]=0;a[H>>0]=0;a[N>>0]=0;a[X>>0]=1;a[h>>0]=3;a[ja>>0]=3;C=((e|0)!=0&za?ya:aa)&255|Ja;a[w>>0]=C;B=(c[R+(e<<2)>>2]|0)+128|0;if(Ka){a[P>>0]=16;a[N>>0]=1;a[Q>>0]=1;a[O>>0]=1;a[j>>0]=1;a[H>>0]=1;a[x>>0]=1;a[w>>0]=C|16;Pa=B|16}else Pa=B;B=_n[c[(c[ia>>2]|0)+40>>2]&4095](ia,X)|0;co[c[(c[ia>>2]|0)+64>>2]&2047](ia,B,Pa);B=Y;c[B>>2]=0;c[B+4>>2]=0;c[Y>>2]=2;c[Aa>>2]=0;g[l>>2]=ea(0.0);a[k>>0]=2;a[Z>>0]=0;if((a[E>>0]|0)!=0&(a[f>>0]|0)==0?(B=c[$>>2]|0,(B|0)==2|(B|0)==0):0){c[Y>>2]=1;Qa=5}else Qa=4;a[k>>0]=Qa;B=c[ia>>2]|0;C=c[B+56>>2]|0;ha=_n[c[B+44>>2]&4095](ia,Y)|0;In[C&4095](ia,ha);ha=c[ia>>2]|0;C=c[ha+60>>2]|0;B=_n[c[ha+36>>2]&4095](ia,Z)|0;In[C&4095](ia,B);EZb(b,p,v,u,Ba,Oa);e=e+1|0}while((e|0)<(Ha|0));if((Ga|0)==0|q){Ra=q?Ga:0;i=s;return Ra|0}Jzc(Gzc()|0,Ga);Ra=q?Ga:0;i=s;return Ra|0}function RZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;f=i;i=i+48|0;h=f;j=a;a=d;a:while(1){d=a;k=a+-44|0;l=a+-88|0;m=a+-4|0;n=a+-40|0;o=a+-32|0;p=a+-28|0;q=a+-24|0;r=a+-8|0;s=j;b:while(1){t=s;u=d-t|0;switch((u|0)/44|0|0){case 5:{v=s;w=k;x=21;break a;break}case 3:{y=s;z=k;x=19;break a;break}case 4:{A=s;B=k;x=20;break a;break}case 2:{C=s;D=m;E=n;F=o;G=p;H=k;I=q;J=r;K=k;x=4;break a;break}case 1:case 0:{x=183;break a;break}default:{}}if((u|0)<1364){L=s;M=a;x=23;break a}N=(u|0)/88|0;O=s+(N*44|0)|0;if((u|0)>43956){P=(u|0)/176|0;Q=UZb(s,s+(P*44|0)|0,O,s+((P+N|0)*44|0)|0,k,e)|0}else Q=SZb(s,O,k,e)|0;P=s+40|0;u=c[P>>2]|0;R=c[s+(N*44|0)+40>>2]|0;do if((u|0)==(R|0)){S=b[s+4>>1]|0;T=b[s+(N*44|0)+4>>1]|0;if(S<<16>>16!=T<<16>>16)if(S<<16>>16<T<<16>>16){U=k;V=Q;break}else{x=41;break}T=c[s+12>>2]|0;S=c[s+(N*44|0)+12>>2]|0;if((T|0)!=(S|0))if(T>>>0<S>>>0){U=k;V=Q;break}else{x=41;break}S=c[s+16>>2]|0;T=c[s+(N*44|0)+16>>2]|0;if((S|0)!=(T|0))if((S|0)>(T|0)){U=k;V=Q;break}else{x=41;break}T=c[s>>2]|0;S=c[O>>2]|0;if((T|0)!=(S|0))if((c[T+4>>2]|0)<(c[S+4>>2]|0)){U=k;V=Q;break}else{x=41;break}W=ea(g[s+20>>2]);X=ea(g[s+(N*44|0)+20>>2]);if(W==X?(S=b[s+36>>1]|0,T=b[s+(N*44|0)+36>>1]|0,S<<16>>16!=T<<16>>16):0)if((S&65535)>(T&65535)){U=k;V=Q;break}else{x=41;break}if(W>X){U=k;V=Q}else x=41}else if(u>>>0<R>>>0){U=k;V=Q}else x=41;while(0);c:do if((x|0)==41){x=0;d:do if((s|0)!=(l|0)){T=s+(N*44|0)+4|0;S=s+(N*44|0)+12|0;Y=s+(N*44|0)+16|0;Z=s+(N*44|0)+20|0;_=s+(N*44|0)+36|0;$=a;aa=l;ba=k;e:while(1){ca=c[$+-48>>2]|0;do if((ca|0)==(R|0)){da=b[$+-84>>1]|0;fa=b[T>>1]|0;if(da<<16>>16!=fa<<16>>16)if(da<<16>>16<fa<<16>>16){ga=aa;break e}else break;fa=c[$+-76>>2]|0;da=c[S>>2]|0;if((fa|0)!=(da|0))if(fa>>>0<da>>>0){ga=aa;break e}else break;da=c[$+-72>>2]|0;fa=c[Y>>2]|0;if((da|0)!=(fa|0))if((da|0)>(fa|0)){ga=aa;break e}else break;fa=c[$+-88>>2]|0;da=c[O>>2]|0;if((fa|0)!=(da|0))if((c[fa+4>>2]|0)<(c[da+4>>2]|0)){ga=aa;break e}else break;X=ea(g[$+-68>>2]);W=ea(g[Z>>2]);if(X==W?(da=b[$+-52>>1]|0,fa=b[_>>1]|0,da<<16>>16!=fa<<16>>16):0)if((da&65535)>(fa&65535)){ga=aa;break e}else break;if(X>W){ga=aa;break e}}else if(ca>>>0<R>>>0){ga=aa;break e}while(0);ca=ba+-88|0;if((s|0)==(ca|0))break d;else{fa=aa;da=ba;aa=ca;ba=fa;$=da}}ha=h+0|0;ia=s+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=s+0|0;ia=ga+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=ga+0|0;ia=h+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));U=ga;V=Q+1|0;break c}while(0);$=s+44|0;ba=c[m>>2]|0;do if((u|0)==(ba|0)){aa=b[s+4>>1]|0;_=b[n>>1]|0;if(aa<<16>>16!=_<<16>>16)if(aa<<16>>16<_<<16>>16){ka=$;break}else{x=57;break}_=c[s+12>>2]|0;aa=c[o>>2]|0;if((_|0)!=(aa|0))if(_>>>0<aa>>>0){ka=$;break}else{x=57;break}aa=c[s+16>>2]|0;_=c[p>>2]|0;if((aa|0)!=(_|0))if((aa|0)>(_|0)){ka=$;break}else{x=57;break}_=c[s>>2]|0;aa=c[k>>2]|0;if((_|0)!=(aa|0))if((c[_+4>>2]|0)<(c[aa+4>>2]|0)){ka=$;break}else{x=57;break}W=ea(g[s+20>>2]);X=ea(g[q>>2]);if(W==X?(aa=b[s+36>>1]|0,_=b[r>>1]|0,aa<<16>>16!=_<<16>>16):0)if((aa&65535)>(_&65535)){ka=$;break}else{x=57;break}if(W>X)ka=$;else x=57}else if(u>>>0<ba>>>0)ka=$;else x=57;while(0);if((x|0)==57){x=0;if(($|0)==(k|0)){x=183;break a}ba=s+4|0;_=s+12|0;aa=s+16|0;Z=s+20|0;Y=s+36|0;S=s;T=$;f:while(1){da=c[T+40>>2]|0;do if((u|0)==(da|0)){fa=b[ba>>1]|0;ca=b[T+4>>1]|0;if(fa<<16>>16!=ca<<16>>16)if(fa<<16>>16<ca<<16>>16){la=T;break f}else break;ca=c[_>>2]|0;fa=c[T+12>>2]|0;if((ca|0)!=(fa|0))if(ca>>>0<fa>>>0){la=T;break f}else break;fa=c[aa>>2]|0;ca=c[T+16>>2]|0;if((fa|0)!=(ca|0))if((fa|0)>(ca|0)){la=T;break f}else break;ca=c[s>>2]|0;fa=c[T>>2]|0;if((ca|0)!=(fa|0))if((c[ca+4>>2]|0)<(c[fa+4>>2]|0)){la=T;break f}else break;X=ea(g[Z>>2]);W=ea(g[T+20>>2]);if(X==W?(fa=b[Y>>1]|0,ca=b[T+36>>1]|0,fa<<16>>16!=ca<<16>>16):0)if((fa&65535)>(ca&65535)){la=T;break f}else break;if(X>W){la=T;break f}}else if(u>>>0<da>>>0){la=T;break f}while(0);da=S+88|0;if((da|0)==(k|0)){x=183;break a}else{ca=T;T=da;S=ca}}ha=h+0|0;ia=la+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=la+0|0;ia=k+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=k+0|0;ia=h+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ka=la+44|0}if((ka|0)==(k|0)){x=183;break a}S=s+4|0;T=s+12|0;Y=s+16|0;Z=s+20|0;aa=s+36|0;_=ka;ba=k;while(1){$=c[P>>2]|0;ca=_;g:while(1){da=c[ca+40>>2]|0;do if(($|0)==(da|0)){fa=b[S>>1]|0;ma=b[ca+4>>1]|0;if(fa<<16>>16!=ma<<16>>16)if(fa<<16>>16<ma<<16>>16){na=ca;break g}else break;ma=c[T>>2]|0;fa=c[ca+12>>2]|0;if((ma|0)!=(fa|0))if(ma>>>0<fa>>>0){na=ca;break g}else break;fa=c[Y>>2]|0;ma=c[ca+16>>2]|0;if((fa|0)!=(ma|0))if((fa|0)>(ma|0)){na=ca;break g}else break;ma=c[s>>2]|0;fa=c[ca>>2]|0;if((ma|0)!=(fa|0))if((c[ma+4>>2]|0)<(c[fa+4>>2]|0)){na=ca;break g}else break;W=ea(g[Z>>2]);X=ea(g[ca+20>>2]);if(W==X?(fa=b[aa>>1]|0,ma=b[ca+36>>1]|0,fa<<16>>16!=ma<<16>>16):0)if((fa&65535)>(ma&65535)){na=ca;break g}else break;if(W>X){na=ca;break g}}else if($>>>0<da>>>0){na=ca;break g}while(0);ca=ca+44|0}ca=ba;while(1){da=ca+-44|0;ma=c[ca+-4>>2]|0;if(($|0)!=(ma|0))if($>>>0<ma>>>0){ca=da;continue}else{oa=da;break}ma=b[S>>1]|0;fa=b[ca+-40>>1]|0;if(ma<<16>>16!=fa<<16>>16)if(ma<<16>>16<fa<<16>>16){ca=da;continue}else{oa=da;break}fa=c[T>>2]|0;ma=c[ca+-32>>2]|0;if((fa|0)!=(ma|0))if(fa>>>0<ma>>>0){ca=da;continue}else{oa=da;break}ma=c[Y>>2]|0;fa=c[ca+-28>>2]|0;if((ma|0)!=(fa|0))if((ma|0)>(fa|0)){ca=da;continue}else{oa=da;break}fa=c[s>>2]|0;ma=c[da>>2]|0;if((fa|0)!=(ma|0))if((c[fa+4>>2]|0)<(c[ma+4>>2]|0)){ca=da;continue}else{oa=da;break}X=ea(g[Z>>2]);W=ea(g[ca+-24>>2]);if(X==W?(ma=b[aa>>1]|0,fa=b[ca+-8>>1]|0,ma<<16>>16!=fa<<16>>16):0)if((ma&65535)>(fa&65535)){ca=da;continue}else{oa=da;break}if(X>W)ca=da;else{oa=da;break}}if(na>>>0>=oa>>>0){s=na;continue b}ha=h+0|0;ia=na+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=na+0|0;ia=oa+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=oa+0|0;ia=h+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));_=na+44|0;ba=oa}}while(0);P=s+44|0;h:do if(P>>>0<U>>>0){u=P;R=U;N=O;ba=V;while(1){_=c[N+40>>2]|0;aa=N+4|0;Z=N+12|0;Y=N+16|0;T=N+20|0;S=N+36|0;ca=u;i:while(1){$=c[ca+40>>2]|0;do if(($|0)==(_|0)){da=b[ca+4>>1]|0;fa=b[aa>>1]|0;if(da<<16>>16!=fa<<16>>16)if(da<<16>>16<fa<<16>>16)break;else{pa=ca;break i}fa=c[ca+12>>2]|0;da=c[Z>>2]|0;if((fa|0)!=(da|0))if(fa>>>0<da>>>0)break;else{pa=ca;break i}da=c[ca+16>>2]|0;fa=c[Y>>2]|0;if((da|0)!=(fa|0))if((da|0)>(fa|0))break;else{pa=ca;break i}fa=c[ca>>2]|0;da=c[N>>2]|0;if((fa|0)!=(da|0))if((c[fa+4>>2]|0)<(c[da+4>>2]|0))break;else{pa=ca;break i}W=ea(g[ca+20>>2]);X=ea(g[T>>2]);if(W==X?(da=b[ca+36>>1]|0,fa=b[S>>1]|0,da<<16>>16!=fa<<16>>16):0)if((da&65535)>(fa&65535))break;else{pa=ca;break i}if(!(W>X)){pa=ca;break i}}else if($>>>0>=_>>>0){pa=ca;break i}while(0);ca=ca+44|0}ca=R;while(1){$=ca+-44|0;fa=c[ca+-4>>2]|0;if((fa|0)!=(_|0))if(fa>>>0<_>>>0){qa=$;break}else{ca=$;continue}fa=b[ca+-40>>1]|0;da=b[aa>>1]|0;if(fa<<16>>16!=da<<16>>16)if(fa<<16>>16<da<<16>>16){qa=$;break}else{ca=$;continue}da=c[ca+-32>>2]|0;fa=c[Z>>2]|0;if((da|0)!=(fa|0))if(da>>>0<fa>>>0){qa=$;break}else{ca=$;continue}fa=c[ca+-28>>2]|0;da=c[Y>>2]|0;if((fa|0)!=(da|0))if((fa|0)>(da|0)){qa=$;break}else{ca=$;continue}da=c[$>>2]|0;fa=c[N>>2]|0;if((da|0)!=(fa|0))if((c[da+4>>2]|0)<(c[fa+4>>2]|0)){qa=$;break}else{ca=$;continue}X=ea(g[ca+-24>>2]);W=ea(g[T>>2]);if(X==W?(fa=b[ca+-8>>1]|0,da=b[S>>1]|0,fa<<16>>16!=da<<16>>16):0)if((fa&65535)>(da&65535)){qa=$;break}else{ca=$;continue}if(X>W){qa=$;break}else ca=$}if(pa>>>0>qa>>>0){ra=pa;sa=N;ta=ba;break h}ha=h+0|0;ia=pa+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=pa+0|0;ia=qa+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=qa+0|0;ia=h+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));u=pa+44|0;R=qa;N=(N|0)==(pa|0)?qa:N;ba=ba+1|0}}else{ra=P;sa=O;ta=V}while(0);j:do if((ra|0)==(sa|0))ua=ta;else{O=c[sa+40>>2]|0;P=c[ra+40>>2]|0;do if((O|0)==(P|0)){ba=b[sa+4>>1]|0;N=b[ra+4>>1]|0;if(ba<<16>>16!=N<<16>>16)if(ba<<16>>16<N<<16>>16)break;else{ua=ta;break j}N=c[sa+12>>2]|0;ba=c[ra+12>>2]|0;if((N|0)!=(ba|0))if(N>>>0<ba>>>0)break;else{ua=ta;break j}ba=c[sa+16>>2]|0;N=c[ra+16>>2]|0;if((ba|0)!=(N|0))if((ba|0)>(N|0))break;else{ua=ta;break j}N=c[sa>>2]|0;ba=c[ra>>2]|0;if((N|0)!=(ba|0))if((c[N+4>>2]|0)<(c[ba+4>>2]|0))break;else{ua=ta;break j}W=ea(g[sa+20>>2]);X=ea(g[ra+20>>2]);if(W==X?(ba=b[sa+36>>1]|0,N=b[ra+36>>1]|0,ba<<16>>16!=N<<16>>16):0)if((ba&65535)>(N&65535))break;else{ua=ta;break j}if(!(W>X)){ua=ta;break j}}else if(O>>>0>=P>>>0){ua=ta;break j}while(0);ha=h+0|0;ia=ra+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=ra+0|0;ia=sa+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=sa+0|0;ia=h+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ua=ta+1|0}while(0);if(!ua){va=WZb(s,ra,e)|0;P=ra+44|0;if(WZb(P,a,e)|0){x=178;break}if(va){s=P;continue}}P=ra;if((P-t|0)>=(d-P|0)){wa=s;xa=ra;x=182;break}RZb(s,ra,e);s=ra+44|0}if((x|0)==178){x=0;if(va){x=183;break}else{j=s;a=ra;continue}}else if((x|0)==182){x=0;RZb(xa+44|0,a,e);j=wa;a=xa;continue}}if((x|0)==4){xa=c[D>>2]|0;D=c[C+40>>2]|0;do if((xa|0)==(D|0)){a=b[E>>1]|0;wa=b[C+4>>1]|0;if(a<<16>>16!=wa<<16>>16){if(a<<16>>16<wa<<16>>16)break;i=f;return}wa=c[F>>2]|0;a=c[C+12>>2]|0;if((wa|0)!=(a|0)){if(wa>>>0<a>>>0)break;i=f;return}a=c[G>>2]|0;wa=c[C+16>>2]|0;if((a|0)!=(wa|0)){if((a|0)>(wa|0))break;i=f;return}wa=c[H>>2]|0;a=c[C>>2]|0;if((wa|0)!=(a|0)){if((c[wa+4>>2]|0)<(c[a+4>>2]|0))break;i=f;return}X=ea(g[I>>2]);W=ea(g[C+20>>2]);if(X==W?(a=b[J>>1]|0,wa=b[C+36>>1]|0,a<<16>>16!=wa<<16>>16):0){if((a&65535)>(wa&65535))break;i=f;return}if(!(X>W)){i=f;return}}else if(xa>>>0>=D>>>0){i=f;return}while(0);ha=h+0|0;ia=C+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=C+0|0;ia=K+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ha=K+0|0;ia=h+0|0;ja=ha+44|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));i=f;return}else if((x|0)==19){SZb(y,y+44|0,z,e)|0;i=f;return}else if((x|0)==20){TZb(A,A+44|0,A+88|0,B,e)|0;i=f;return}else if((x|0)==21){UZb(v,v+44|0,v+88|0,v+132|0,w,e)|0;i=f;return}else if((x|0)==23){VZb(L,M,e);i=f;return}else if((x|0)==183){i=f;return}}function SZb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+48|0;h=f;j=d+40|0;k=c[j>>2]|0;l=a+40|0;m=c[l>>2]|0;do if((k|0)==(m|0)){n=b[d+4>>1]|0;o=b[a+4>>1]|0;if(n<<16>>16!=o<<16>>16){p=n<<16>>16<o<<16>>16;break}o=c[d+12>>2]|0;n=c[a+12>>2]|0;if((o|0)!=(n|0)){p=o>>>0<n>>>0;break}n=c[d+16>>2]|0;o=c[a+16>>2]|0;if((n|0)!=(o|0)){p=(n|0)>(o|0);break}o=c[d>>2]|0;n=c[a>>2]|0;if((o|0)!=(n|0)){p=(c[o+4>>2]|0)<(c[n+4>>2]|0);break}q=ea(g[d+20>>2]);r=ea(g[a+20>>2]);if(q==r?(n=b[d+36>>1]|0,o=b[a+36>>1]|0,n<<16>>16!=o<<16>>16):0){p=(n&65535)>(o&65535);break}p=q>r}else p=k>>>0<m>>>0;while(0);m=e+40|0;o=c[m>>2]|0;do if((o|0)==(k|0)){n=b[e+4>>1]|0;s=b[d+4>>1]|0;if(n<<16>>16!=s<<16>>16){t=n<<16>>16<s<<16>>16;break}s=c[e+12>>2]|0;n=c[d+12>>2]|0;if((s|0)!=(n|0)){t=s>>>0<n>>>0;break}n=c[e+16>>2]|0;s=c[d+16>>2]|0;if((n|0)!=(s|0)){t=(n|0)>(s|0);break}s=c[e>>2]|0;n=c[d>>2]|0;if((s|0)!=(n|0)){t=(c[s+4>>2]|0)<(c[n+4>>2]|0);break}r=ea(g[e+20>>2]);q=ea(g[d+20>>2]);if(r==q?(n=b[e+36>>1]|0,s=b[d+36>>1]|0,n<<16>>16!=s<<16>>16):0){t=(n&65535)>(s&65535);break}t=r>q}else t=o>>>0<k>>>0;while(0);if(!p){if(!t){u=0;i=f;return u|0}v=h+0|0;w=d+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=d+0|0;w=e+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=e+0|0;w=h+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));p=c[j>>2]|0;k=c[l>>2]|0;do if((p|0)==(k|0)){l=b[d+4>>1]|0;o=b[a+4>>1]|0;if(l<<16>>16!=o<<16>>16){if(l<<16>>16<o<<16>>16)break;else u=1;i=f;return u|0}o=c[d+12>>2]|0;l=c[a+12>>2]|0;if((o|0)!=(l|0)){if(o>>>0<l>>>0)break;else u=1;i=f;return u|0}l=c[d+16>>2]|0;o=c[a+16>>2]|0;if((l|0)!=(o|0)){if((l|0)>(o|0))break;else u=1;i=f;return u|0}o=c[d>>2]|0;l=c[a>>2]|0;if((o|0)!=(l|0)){if((c[o+4>>2]|0)<(c[l+4>>2]|0))break;else u=1;i=f;return u|0}q=ea(g[d+20>>2]);r=ea(g[a+20>>2]);if(q==r?(l=b[d+36>>1]|0,o=b[a+36>>1]|0,l<<16>>16!=o<<16>>16):0){if((l&65535)>(o&65535))break;else u=1;i=f;return u|0}if(!(q>r)){u=1;i=f;return u|0}}else if(p>>>0>=k>>>0){u=1;i=f;return u|0}while(0);v=h+0|0;w=a+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=a+0|0;w=d+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=d+0|0;w=h+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));u=2;i=f;return u|0}if(t){v=h+0|0;w=a+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=a+0|0;w=e+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=e+0|0;w=h+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));u=1;i=f;return u|0}v=h+0|0;w=a+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=a+0|0;w=d+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=d+0|0;w=h+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));a=c[m>>2]|0;m=c[j>>2]|0;do if((a|0)==(m|0)){j=b[e+4>>1]|0;t=b[d+4>>1]|0;if(j<<16>>16!=t<<16>>16){if(j<<16>>16<t<<16>>16)break;else u=1;i=f;return u|0}t=c[e+12>>2]|0;j=c[d+12>>2]|0;if((t|0)!=(j|0)){if(t>>>0<j>>>0)break;else u=1;i=f;return u|0}j=c[e+16>>2]|0;t=c[d+16>>2]|0;if((j|0)!=(t|0)){if((j|0)>(t|0))break;else u=1;i=f;return u|0}t=c[e>>2]|0;j=c[d>>2]|0;if((t|0)!=(j|0)){if((c[t+4>>2]|0)<(c[j+4>>2]|0))break;else u=1;i=f;return u|0}r=ea(g[e+20>>2]);q=ea(g[d+20>>2]);if(r==q?(j=b[e+36>>1]|0,t=b[d+36>>1]|0,j<<16>>16!=t<<16>>16):0){if((j&65535)>(t&65535))break;else u=1;i=f;return u|0}if(!(r>q)){u=1;i=f;return u|0}}else if(a>>>0>=m>>>0){u=1;i=f;return u|0}while(0);v=h+0|0;w=d+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=d+0|0;w=e+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));v=e+0|0;w=h+0|0;x=v+44|0;do{c[v>>2]=c[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));u=2;i=f;return u|0}function TZb(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=0,v=0;j=i;i=i+48|0;k=j;l=SZb(a,d,e,h)|0;h=c[f+40>>2]|0;m=e+40|0;n=c[m>>2]|0;do if((h|0)==(n|0)){o=b[f+4>>1]|0;p=b[e+4>>1]|0;if(o<<16>>16!=p<<16>>16){if(o<<16>>16<p<<16>>16)break;else q=l;i=j;return q|0}p=c[f+12>>2]|0;o=c[e+12>>2]|0;if((p|0)!=(o|0)){if(p>>>0<o>>>0)break;else q=l;i=j;return q|0}o=c[f+16>>2]|0;p=c[e+16>>2]|0;if((o|0)!=(p|0)){if((o|0)>(p|0))break;else q=l;i=j;return q|0}p=c[f>>2]|0;o=c[e>>2]|0;if((p|0)!=(o|0)){if((c[p+4>>2]|0)<(c[o+4>>2]|0))break;else q=l;i=j;return q|0}r=ea(g[f+20>>2]);s=ea(g[e+20>>2]);if(r==s?(o=b[f+36>>1]|0,p=b[e+36>>1]|0,o<<16>>16!=p<<16>>16):0){if((o&65535)>(p&65535))break;else q=l;i=j;return q|0}if(!(r>s)){q=l;i=j;return q|0}}else if(h>>>0>=n>>>0){q=l;i=j;return q|0}while(0);n=k+0|0;h=e+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));n=e+0|0;h=f+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));n=f+0|0;h=k+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));f=l+1|0;o=c[m>>2]|0;m=d+40|0;t=c[m>>2]|0;do if((o|0)==(t|0)){u=b[e+4>>1]|0;v=b[d+4>>1]|0;if(u<<16>>16!=v<<16>>16){if(u<<16>>16<v<<16>>16)break;else q=f;i=j;return q|0}v=c[e+12>>2]|0;u=c[d+12>>2]|0;if((v|0)!=(u|0)){if(v>>>0<u>>>0)break;else q=f;i=j;return q|0}u=c[e+16>>2]|0;v=c[d+16>>2]|0;if((u|0)!=(v|0)){if((u|0)>(v|0))break;else q=f;i=j;return q|0}v=c[e>>2]|0;u=c[d>>2]|0;if((v|0)!=(u|0)){if((c[v+4>>2]|0)<(c[u+4>>2]|0))break;else q=f;i=j;return q|0}s=ea(g[e+20>>2]);r=ea(g[d+20>>2]);if(s==r?(u=b[e+36>>1]|0,v=b[d+36>>1]|0,u<<16>>16!=v<<16>>16):0){if((u&65535)>(v&65535))break;else q=f;i=j;return q|0}if(!(s>r)){q=f;i=j;return q|0}}else if(o>>>0>=t>>>0){q=f;i=j;return q|0}while(0);n=k+0|0;h=d+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));n=d+0|0;h=e+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));n=e+0|0;h=k+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));e=l+2|0;f=c[m>>2]|0;m=c[a+40>>2]|0;do if((f|0)==(m|0)){t=b[d+4>>1]|0;o=b[a+4>>1]|0;if(t<<16>>16!=o<<16>>16){if(t<<16>>16<o<<16>>16)break;else q=e;i=j;return q|0}o=c[d+12>>2]|0;t=c[a+12>>2]|0;if((o|0)!=(t|0)){if(o>>>0<t>>>0)break;else q=e;i=j;return q|0}t=c[d+16>>2]|0;o=c[a+16>>2]|0;if((t|0)!=(o|0)){if((t|0)>(o|0))break;else q=e;i=j;return q|0}o=c[d>>2]|0;t=c[a>>2]|0;if((o|0)!=(t|0)){if((c[o+4>>2]|0)<(c[t+4>>2]|0))break;else q=e;i=j;return q|0}r=ea(g[d+20>>2]);s=ea(g[a+20>>2]);if(r==s?(t=b[d+36>>1]|0,o=b[a+36>>1]|0,t<<16>>16!=o<<16>>16):0){if((t&65535)>(o&65535))break;else q=e;i=j;return q|0}if(!(r>s)){q=e;i=j;return q|0}}else if(f>>>0>=m>>>0){q=e;i=j;return q|0}while(0);n=k+0|0;h=a+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));n=a+0|0;h=d+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));n=d+0|0;h=k+0|0;p=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(p|0));q=l+3|0;i=j;return q|0}function UZb(a,d,e,f,h,j){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=0,w=0;k=i;i=i+48|0;l=k;m=TZb(a,d,e,f,j)|0;j=c[h+40>>2]|0;n=f+40|0;o=c[n>>2]|0;do if((j|0)==(o|0)){p=b[h+4>>1]|0;q=b[f+4>>1]|0;if(p<<16>>16!=q<<16>>16){if(p<<16>>16<q<<16>>16)break;else r=m;i=k;return r|0}q=c[h+12>>2]|0;p=c[f+12>>2]|0;if((q|0)!=(p|0)){if(q>>>0<p>>>0)break;else r=m;i=k;return r|0}p=c[h+16>>2]|0;q=c[f+16>>2]|0;if((p|0)!=(q|0)){if((p|0)>(q|0))break;else r=m;i=k;return r|0}q=c[h>>2]|0;p=c[f>>2]|0;if((q|0)!=(p|0)){if((c[q+4>>2]|0)<(c[p+4>>2]|0))break;else r=m;i=k;return r|0}s=ea(g[h+20>>2]);t=ea(g[f+20>>2]);if(s==t?(p=b[h+36>>1]|0,q=b[f+36>>1]|0,p<<16>>16!=q<<16>>16):0){if((p&65535)>(q&65535))break;else r=m;i=k;return r|0}if(!(s>t)){r=m;i=k;return r|0}}else if(j>>>0>=o>>>0){r=m;i=k;return r|0}while(0);o=l+0|0;j=f+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=f+0|0;j=h+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=h+0|0;j=l+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));h=m+1|0;p=c[n>>2]|0;n=e+40|0;u=c[n>>2]|0;do if((p|0)==(u|0)){v=b[f+4>>1]|0;w=b[e+4>>1]|0;if(v<<16>>16!=w<<16>>16){if(v<<16>>16<w<<16>>16)break;else r=h;i=k;return r|0}w=c[f+12>>2]|0;v=c[e+12>>2]|0;if((w|0)!=(v|0)){if(w>>>0<v>>>0)break;else r=h;i=k;return r|0}v=c[f+16>>2]|0;w=c[e+16>>2]|0;if((v|0)!=(w|0)){if((v|0)>(w|0))break;else r=h;i=k;return r|0}w=c[f>>2]|0;v=c[e>>2]|0;if((w|0)!=(v|0)){if((c[w+4>>2]|0)<(c[v+4>>2]|0))break;else r=h;i=k;return r|0}t=ea(g[f+20>>2]);s=ea(g[e+20>>2]);if(t==s?(v=b[f+36>>1]|0,w=b[e+36>>1]|0,v<<16>>16!=w<<16>>16):0){if((v&65535)>(w&65535))break;else r=h;i=k;return r|0}if(!(t>s)){r=h;i=k;return r|0}}else if(p>>>0>=u>>>0){r=h;i=k;return r|0}while(0);o=l+0|0;j=e+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=e+0|0;j=f+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=f+0|0;j=l+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));f=m+2|0;h=c[n>>2]|0;n=d+40|0;u=c[n>>2]|0;do if((h|0)==(u|0)){p=b[e+4>>1]|0;w=b[d+4>>1]|0;if(p<<16>>16!=w<<16>>16){if(p<<16>>16<w<<16>>16)break;else r=f;i=k;return r|0}w=c[e+12>>2]|0;p=c[d+12>>2]|0;if((w|0)!=(p|0)){if(w>>>0<p>>>0)break;else r=f;i=k;return r|0}p=c[e+16>>2]|0;w=c[d+16>>2]|0;if((p|0)!=(w|0)){if((p|0)>(w|0))break;else r=f;i=k;return r|0}w=c[e>>2]|0;p=c[d>>2]|0;if((w|0)!=(p|0)){if((c[w+4>>2]|0)<(c[p+4>>2]|0))break;else r=f;i=k;return r|0}s=ea(g[e+20>>2]);t=ea(g[d+20>>2]);if(s==t?(p=b[e+36>>1]|0,w=b[d+36>>1]|0,p<<16>>16!=w<<16>>16):0){if((p&65535)>(w&65535))break;else r=f;i=k;return r|0}if(!(s>t)){r=f;i=k;return r|0}}else if(h>>>0>=u>>>0){r=f;i=k;return r|0}while(0);o=l+0|0;j=d+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=d+0|0;j=e+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=e+0|0;j=l+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));e=m+3|0;f=c[n>>2]|0;n=c[a+40>>2]|0;do if((f|0)==(n|0)){u=b[d+4>>1]|0;h=b[a+4>>1]|0;if(u<<16>>16!=h<<16>>16){if(u<<16>>16<h<<16>>16)break;else r=e;i=k;return r|0}h=c[d+12>>2]|0;u=c[a+12>>2]|0;if((h|0)!=(u|0)){if(h>>>0<u>>>0)break;else r=e;i=k;return r|0}u=c[d+16>>2]|0;h=c[a+16>>2]|0;if((u|0)!=(h|0)){if((u|0)>(h|0))break;else r=e;i=k;return r|0}h=c[d>>2]|0;u=c[a>>2]|0;if((h|0)!=(u|0)){if((c[h+4>>2]|0)<(c[u+4>>2]|0))break;else r=e;i=k;return r|0}t=ea(g[d+20>>2]);s=ea(g[a+20>>2]);if(t==s?(u=b[d+36>>1]|0,h=b[a+36>>1]|0,u<<16>>16!=h<<16>>16):0){if((u&65535)>(h&65535))break;else r=e;i=k;return r|0}if(!(t>s)){r=e;i=k;return r|0}}else if(f>>>0>=n>>>0){r=e;i=k;return r|0}while(0);o=l+0|0;j=a+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=a+0|0;j=d+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));o=d+0|0;j=l+0|0;q=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(q|0));r=m+4|0;i=k;return r|0}function VZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+32|0;h=f+16|0;j=f;k=f+22|0;l=a+88|0;SZb(a,a+44|0,l,e)|0;e=a+132|0;if((e|0)==(d|0)){i=f;return}m=e;e=l;while(1){l=m+40|0;n=c[l>>2]|0;o=c[e+40>>2]|0;do if((n|0)==(o|0)){p=b[m+4>>1]|0;q=b[e+4>>1]|0;if(p<<16>>16!=q<<16>>16)if(p<<16>>16<q<<16>>16){r=p;s=18;break}else break;q=c[m+12>>2]|0;t=c[e+12>>2]|0;if((q|0)!=(t|0))if(q>>>0<t>>>0){r=p;s=18;break}else break;t=c[m+16>>2]|0;q=c[e+16>>2]|0;if((t|0)!=(q|0))if((t|0)>(q|0)){r=p;s=18;break}else break;q=c[m>>2]|0;t=c[e>>2]|0;if((q|0)!=(t|0))if((c[q+4>>2]|0)<(c[t+4>>2]|0)){r=p;s=18;break}else break;u=ea(g[m+20>>2]);v=ea(g[e+20>>2]);if(u==v?(t=b[m+36>>1]|0,q=b[e+36>>1]|0,t<<16>>16!=q<<16>>16):0)if((t&65535)>(q&65535)){r=p;s=18;break}else break;if(u>v){r=p;s=18}}else if(n>>>0<o>>>0){r=b[m+4>>1]|0;s=18}while(0);if((s|0)==18){s=0;o=c[m>>2]|0;n=m+6|0;b[h+0>>1]=b[n+0>>1]|0;b[h+2>>1]=b[n+2>>1]|0;b[h+4>>1]=b[n+4>>1]|0;n=c[m+12>>2]|0;p=c[m+16>>2]|0;v=ea(g[m+20>>2]);q=m+24|0;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];q=c[m+36>>2]|0;t=q&65535;b[k>>1]=q>>>16;q=c[l>>2]|0;w=o+4|0;x=m+0|0;y=e+0|0;z=x+44|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));a:do if((e|0)==(a|0)){A=e;B=a}else{l=e;while(1){C=l+-44|0;D=c[l+-4>>2]|0;do if((q|0)==(D|0)){E=b[l+-40>>1]|0;if(r<<16>>16!=E<<16>>16)if(r<<16>>16<E<<16>>16)break;else{A=l;B=l;break a}E=c[l+-32>>2]|0;if((n|0)!=(E|0))if(n>>>0<E>>>0)break;else{A=l;B=l;break a}E=c[l+-28>>2]|0;if((p|0)!=(E|0))if((p|0)>(E|0))break;else{A=l;B=l;break a}E=c[C>>2]|0;if((o|0)!=(E|0))if((c[w>>2]|0)<(c[E+4>>2]|0))break;else{A=l;B=l;break a}u=ea(g[l+-24>>2]);if(v==u?(E=b[l+-8>>1]|0,t<<16>>16!=E<<16>>16):0)if((t&65535)>(E&65535))break;else{A=l;B=l;break a}if(!(v>u)){A=l;B=l;break a}}else if(q>>>0>=D>>>0){A=l;B=l;break a}while(0);x=l+0|0;y=C+0|0;z=x+44|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));if((C|0)==(a|0)){A=C;B=a;break}else l=C}}while(0);c[B>>2]=o;b[B+4>>1]=r;y=B+6|0;b[y+0>>1]=b[h+0>>1]|0;b[y+2>>1]=b[h+2>>1]|0;b[y+4>>1]=b[h+4>>1]|0;c[B+12>>2]=n;c[B+16>>2]=p;g[B+20>>2]=v;y=B+24|0;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];b[B+36>>1]=t;b[A+38>>1]=b[k>>1]|0;c[B+40>>2]=q}y=m+44|0;if((y|0)==(d|0))break;else{x=m;m=y;e=x}}i=f;return}function WZb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+64|0;h=f+16|0;j=f;k=f+60|0;switch((d-a|0)/44|0|0){case 3:{SZb(a,a+44|0,d+-44|0,e)|0;l=1;i=f;return l|0}case 2:{m=d+-44|0;n=c[d+-4>>2]|0;o=c[a+40>>2]|0;do if((n|0)==(o|0)){p=b[d+-40>>1]|0;q=b[a+4>>1]|0;if(p<<16>>16!=q<<16>>16){if(p<<16>>16<q<<16>>16)break;else l=1;i=f;return l|0}q=c[d+-32>>2]|0;p=c[a+12>>2]|0;if((q|0)!=(p|0)){if(q>>>0<p>>>0)break;else l=1;i=f;return l|0}p=c[d+-28>>2]|0;q=c[a+16>>2]|0;if((p|0)!=(q|0)){if((p|0)>(q|0))break;else l=1;i=f;return l|0}q=c[m>>2]|0;p=c[a>>2]|0;if((q|0)!=(p|0)){if((c[q+4>>2]|0)<(c[p+4>>2]|0))break;else l=1;i=f;return l|0}r=ea(g[d+-24>>2]);s=ea(g[a+20>>2]);if(r==s?(p=b[d+-8>>1]|0,q=b[a+36>>1]|0,p<<16>>16!=q<<16>>16):0){if((p&65535)>(q&65535))break;else l=1;i=f;return l|0}if(!(r>s)){l=1;i=f;return l|0}}else if(n>>>0>=o>>>0){l=1;i=f;return l|0}while(0);t=h+0|0;u=a+0|0;v=t+44|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));t=a+0|0;u=m+0|0;v=t+44|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));t=m+0|0;u=h+0|0;v=t+44|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));l=1;i=f;return l|0}case 1:case 0:{l=1;i=f;return l|0}case 5:{UZb(a,a+44|0,a+88|0,a+132|0,d+-44|0,e)|0;l=1;i=f;return l|0}case 4:{TZb(a,a+44|0,a+88|0,d+-44|0,e)|0;l=1;i=f;return l|0}default:{m=a+88|0;SZb(a,a+44|0,m,e)|0;e=a+132|0;if((e|0)==(d|0)){l=1;i=f;return l|0}o=0;n=e;e=m;while(1){m=n+40|0;q=c[m>>2]|0;p=c[e+40>>2]|0;do if((q|0)==(p|0)){w=b[n+4>>1]|0;x=b[e+4>>1]|0;if(w<<16>>16!=x<<16>>16)if(w<<16>>16<x<<16>>16){y=w;z=37;break}else{A=o;break}x=c[n+12>>2]|0;B=c[e+12>>2]|0;if((x|0)!=(B|0))if(x>>>0<B>>>0){y=w;z=37;break}else{A=o;break}B=c[n+16>>2]|0;x=c[e+16>>2]|0;if((B|0)!=(x|0))if((B|0)>(x|0)){y=w;z=37;break}else{A=o;break}x=c[n>>2]|0;B=c[e>>2]|0;if((x|0)!=(B|0))if((c[x+4>>2]|0)<(c[B+4>>2]|0)){y=w;z=37;break}else{A=o;break}s=ea(g[n+20>>2]);r=ea(g[e+20>>2]);if(s==r?(B=b[n+36>>1]|0,x=b[e+36>>1]|0,B<<16>>16!=x<<16>>16):0)if((B&65535)>(x&65535)){y=w;z=37;break}else{A=o;break}if(s>r){y=w;z=37}else A=o}else if(q>>>0<p>>>0){y=b[n+4>>1]|0;z=37}else A=o;while(0);if((z|0)==37){z=0;p=c[n>>2]|0;q=n+6|0;b[h+0>>1]=b[q+0>>1]|0;b[h+2>>1]=b[q+2>>1]|0;b[h+4>>1]=b[q+4>>1]|0;q=c[n+12>>2]|0;w=c[n+16>>2]|0;r=ea(g[n+20>>2]);x=n+24|0;c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];x=c[n+36>>2]|0;B=x&65535;b[k>>1]=x>>>16;x=c[m>>2]|0;C=p+4|0;t=n+0|0;u=e+0|0;v=t+44|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));a:do if((e|0)==(a|0)){D=e;E=a}else{m=e;while(1){F=m+-44|0;G=c[m+-4>>2]|0;do if((x|0)==(G|0)){H=b[m+-40>>1]|0;if(y<<16>>16!=H<<16>>16)if(y<<16>>16<H<<16>>16)break;else{D=m;E=m;break a}H=c[m+-32>>2]|0;if((q|0)!=(H|0))if(q>>>0<H>>>0)break;else{D=m;E=m;break a}H=c[m+-28>>2]|0;if((w|0)!=(H|0))if((w|0)>(H|0))break;else{D=m;E=m;break a}H=c[F>>2]|0;if((p|0)!=(H|0))if((c[C>>2]|0)<(c[H+4>>2]|0))break;else{D=m;E=m;break a}s=ea(g[m+-24>>2]);if(r==s?(H=b[m+-8>>1]|0,B<<16>>16!=H<<16>>16):0)if((B&65535)>(H&65535))break;else{D=m;E=m;break a}if(!(r>s)){D=m;E=m;break a}}else if(x>>>0>=G>>>0){D=m;E=m;break a}while(0);t=m+0|0;u=F+0|0;v=t+44|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));if((F|0)==(a|0)){D=F;E=a;break}else m=F}}while(0);c[E>>2]=p;b[E+4>>1]=y;C=E+6|0;b[C+0>>1]=b[h+0>>1]|0;b[C+2>>1]=b[h+2>>1]|0;b[C+4>>1]=b[h+4>>1]|0;c[E+12>>2]=q;c[E+16>>2]=w;g[E+20>>2]=r;C=E+24|0;c[C+0>>2]=c[j+0>>2];c[C+4>>2]=c[j+4>>2];c[C+8>>2]=c[j+8>>2];b[E+36>>1]=B;b[D+38>>1]=b[k>>1]|0;c[E+40>>2]=x;C=o+1|0;if((C|0)==8){I=n;break}else A=C}C=n+44|0;if((C|0)==(d|0)){l=1;z=56;break}else{m=n;o=A;n=C;e=m}}if((z|0)==56){i=f;return l|0}l=(I+44|0)==(d|0);i=f;return l|0}}return 0}function XZb(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;o=i;i=i+976|0;p=o+24|0;q=o+232|0;r=o+956|0;s=o+960|0;t=o+12|0;u=o;v=o+220|0;c[n>>2]=0;w=pyc()|0;x=c[(c[w+24>>2]|0)+((c[w+40>>2]|0)*96|0)+16>>2]|0;w=Hwc(Vwc()|0)|0;YEi(q|0,c[(c[b>>2]|0)+8>>2]|0,612)|0;y=c[158074]|0;g[m>>2]=ea(ea(g[m>>2])+ea(-.00999999977));z=m+4|0;g[z>>2]=ea(ea(g[z>>2])+ea(-.00999999977));z=m+8|0;g[z>>2]=ea(ea(g[z>>2])+ea(-.00999999977));z=m+12|0;g[z>>2]=ea(ea(g[z>>2])+ea(.00999999977));z=m+16|0;g[z>>2]=ea(ea(g[z>>2])+ea(.00999999977));z=m+20|0;g[z>>2]=ea(ea(g[z>>2])+ea(.00999999977));FZb();if(!(a[558600]|0)){c[p>>2]=-1;itd(p,558848);c[139648]=c[p>>2];a[558600]=1}if(!(a[558616]|0)){c[p>>2]=-1;itd(p,558624);c[139652]=c[p>>2];a[558616]=1}z=mo[c[(c[e>>2]|0)+116>>2]&4095](e)|0;A=mo[c[(c[e>>2]|0)+120>>2]&4095](e)|0;if(a[621165]|0){c[r>>2]=c[f>>2];B=ea(g[e+72>>2]);C=ea(g[e+76>>2]);D=ea(g[e+64>>2]);E=ea(g[e+68>>2]);c[p+0>>2]=c[r+0>>2];tud(y+20|0,558592,p,z,A,B,C,D,E)}if((j|0)>0){A=u+1|0;z=t+1|0;r=y+20|0;f=t+8|0;F=u+4|0;G=u+8|0;H=0;do{c[s>>2]=-1;rri(u,558648,21);c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;I=a[u>>0]|0;if(!(I&1)){J=(I&255)>>>1;K=A}else{J=c[F>>2]|0;K=c[G>>2]|0}Pri(t,K,J,J+1|0);Fri(t,H+48&255);itd(s,(a[t>>0]&1)==0?z:c[f>>2]|0);xri(t);xri(u);qud(r,s,c[h+(H<<2)>>2]|0)|0;H=H+1|0}while((H|0)<(j|0))}j=c[h+8>>2]|0;if(j)qud(y+20|0,558608,j)|0;j=ync()|0;H=ync()|0;s=mo[c[(c[H>>2]|0)+92>>2]&4095](H)|0;In[c[(c[H>>2]|0)+88>>2]&4095](H,0);In[c[(c[j>>2]|0)+140>>2]&4095](j,0);H=c[(c[j>>2]|0)+40>>2]|0;a[v>>0]=0;a[v+1>>0]=-1;a[v+2>>0]=-1;a[v+4>>0]=8;a[v+5>>0]=0;a[v+6>>0]=0;a[v+7>>0]=0;a[v+8>>0]=8;a[v+9>>0]=0;a[v+10>>0]=0;a[v+11>>0]=0;r=_n[H&4095](j,v)|0;t1b(p,ync()|0);In[c[(c[j>>2]|0)+100>>2]&4095](j,601008);Bcc((c[c[b>>2]>>2]|0)+636|0,6,y);v=c[d>>2]|0;H=(a[d+16>>0]|0)==0?0:v;u=c[d+8>>2]|0;d=v+(u*108|0)|0;if(u){u=h+12|0;t=v;do{if(!((a[t+9>>0]|0)==0|(t|0)==(H|0)))a_b(c[b>>2]|0,q,x,w,c[u>>2]|0,e,r,m,p,k,l,t,0,y)|0;t=t+108|0}while((t|0)!=(d|0))}if(!H){K9b(y);L=c[j>>2]|0;M=L+64|0;N=c[M>>2]|0;co[N&2047](j,r,0);O=c[b>>2]|0;P=c[O>>2]|0;Q=P+636|0;Bcc(Q,7,y);u1b(p);R=ync()|0;S=c[R>>2]|0;T=S+88|0;U=c[T>>2]|0;In[U&4095](R,s);i=o;return}d=a_b(c[b>>2]|0,q,x,w,c[h+12>>2]|0,e,r,m,p,k,l,H,1,y)|0;if(!d){K9b(y);L=c[j>>2]|0;M=L+64|0;N=c[M>>2]|0;co[N&2047](j,r,0);O=c[b>>2]|0;P=c[O>>2]|0;Q=P+636|0;Bcc(Q,7,y);u1b(p);R=ync()|0;S=c[R>>2]|0;T=S+88|0;U=c[T>>2]|0;In[U&4095](R,s);i=o;return}o_b(c[(c[b>>2]|0)+116>>2]|0,5,d);c[n>>2]=d;K9b(y);L=c[j>>2]|0;M=L+64|0;N=c[M>>2]|0;co[N&2047](j,r,0);O=c[b>>2]|0;P=c[O>>2]|0;Q=P+636|0;Bcc(Q,7,y);u1b(p);R=ync()|0;S=c[R>>2]|0;T=S+88|0;U=c[T>>2]|0;In[U&4095](R,s);i=o;return}function YZb(d,f,h,j,k,l,m,n){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=0,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=Im,Ha=0,Ia=Im,Ja=Im,Ka=0,La=Im,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=Im,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=Im,ob=0,pb=0,qb=0,rb=0,sb=0,tb=Im,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0;o=i;i=i+912|0;p=o+348|0;q=o+760|0;r=o+576|0;s=o+560|0;t=o+712|0;u=o+744|0;v=o+764|0;w=o+880|0;x=o+896|0;y=o+224|0;z=o+900|0;A=o+352|0;B=o;C=o+428|0;D=o+728|0;E=o+768|0;F=o+588|0;G=ea(g[(c[(c[d>>2]|0)+8>>2]|0)+580>>2]);H=c[158074]|0;I=ync()|0;In[c[(c[I>>2]|0)+140>>2]&4095](I,0);a[r+1>>0]=-1;a[r+4>>0]=8;a[r+6>>0]=0;a[r+7>>0]=0;a[r+8>>0]=8;a[r+10>>0]=0;a[r+11>>0]=0;a[r+2>>0]=-17;a[r>>0]=1;a[r+9>>0]=2;a[r+5>>0]=2;J=_n[c[(c[I>>2]|0)+40>>2]&4095](I,r)|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;if(a[621126]|0){c[s+8>>2]=8;c[s+12>>2]=8}r=Gzc()|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;K=f+140|0;L=0;M=0;while(1){if((L|0)==3&m){c[t+12>>2]=c[K>>2];c[l+12>>2]=f;N=M}else{O=Hzc(r,-1,-1,0,c[s+(L<<2)>>2]|0,0,c[558672+(L<<2)>>2]|0,1)|0;if(O)In[c[(c[O>>2]|0)+36>>2]&4095](O,558688);LDc(O,0);uBc(O)|0;P=c[O+140>>2]|0;c[u+(M<<2)>>2]=P;c[t+(L<<2)>>2]=P;c[l+(L<<2)>>2]=O;o_b(c[(c[d>>2]|0)+116>>2]|0,L+11|0,O);N=M+1|0}L=L+1|0;if((L|0)==4){Q=N;break}else M=N}N=c[f+148>>2]|0;if(m){oBc(f,0,-1,1);J$b(c[c[d>>2]>>2]|0,1)}f=(c[(c[c[d>>2]>>2]|0)+376>>2]|0)==4;M=(f?4:12)|m&1;c[v>>2]=N;L=c[l>>2]|0;c[p+0>>2]=c[v+0>>2];qBc(Q,u,p,L,0,-1,M)|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;Uvc(f?1:7,w,ea(1.0),0,H);if(m){c[x>>2]=N;N=c[l>>2]|0;c[p+0>>2]=c[x+0>>2];qBc(4,t,p,N,0,-1,M)|0}In[c[(c[I>>2]|0)+72>>2]&4095](I,n);In[c[(c[I>>2]|0)+104>>2]&4095](I,(c[d>>2]|0)+12|0);Bcc((c[c[d>>2]>>2]|0)+636|0,4,H);n=Vwc()|0;M=Dwc(n)|0;if(M)if((Hwc(n)|0)==1)R=(c[n+84>>2]|0)!=2;else R=1;else R=0;N=(Ewc(n)|0)&R;t=(X8b()|0)+296|0;C7b(y,l7b()|0);y8b(n);RYb(A,z);N_b(B,A,z);Q_b(C,A,z);S_b(D,A,z);z=d+4|0;x=c[(c[z>>2]|0)+8>>2]|0;l=x>>>4;m=j+12|0;w=c[m>>2]|0;do if((w&2147483647)>>>0<l>>>0)if((w|0)>-1){c[m>>2]=l;f=c[j>>2]|0;c[q>>2]=c[j+4>>2];c[p+0>>2]=c[q+0>>2];c[j>>2]=hOb(f,l*44|0,4,p,0,3653512,370)|0;break}else{c[q>>2]=c[j+4>>2];c[p+0>>2]=c[q+0>>2];f=cOb(l*44|0,4,p,0,3653512,352)|0;YEi(f|0,c[j>>2]|0,(c[j+8>>2]|0)*44|0)|0;c[m>>2]=l;c[j>>2]=f;break}while(0);if(!x){TYb(A);S=c[d>>2]|0;T=c[S>>2]|0;U=T+636|0;Bcc(U,5,H);V=c[I>>2]|0;W=V+72|0;X=c[W>>2]|0;In[X&4095](I,0);aZb(A);i=o;return 4}l=d+8|0;w=k+4|0;f=k+8|0;L=k+12|0;u=k+16|0;Q=k+20|0;v=j+8|0;s=j+4|0;r=B+108|0;K=I+5968|0;O=C+128|0;P=B+216|0;B=0;Y=0;Z=-1;_=-1;$=-1;aa=ea(-1.0);ba=16711935;ca=0;da=0;fa=-1;ga=0;while(1){ha=c[(c[l>>2]|0)+(da<<2)>>2]|0;ia=c[c[z>>2]>>2]|0;ja=ia+(ha*44|0)|0;ka=ia+(ha*44|0)+32|0;la=c[ka>>2]|0;ma=ia+(ha*44|0)+8|0;na=(b[ma>>1]<<1&65535)<<16>>16>>1;if(na<<16>>16==-1)oa=c[(c[la+52>>2]|0)+28>>2]|0;else oa=na<<16>>16;na=ia+(ha*44|0)+28|0;pa=c[na>>2]|0;qa=ea(g[ia+(ha*44|0)+24>>2]);if(qa>G){ra=c[d>>2]|0;sa=ea(g[ra+20>>2]);if(sa<ea(0.0))ta=ea(-sa);else ta=sa;sa=ea(ta*ea(g[pa+76>>2]));ua=ea(g[ra+36>>2]);if(ua<ea(0.0))va=ea(-ua);else va=ua;ua=ea(sa+ea(va*ea(g[pa+80>>2])));sa=ea(g[ra+52>>2]);if(sa<ea(0.0))wa=ea(-sa);else wa=sa;if(ea(qa-ea(ua+ea(wa*ea(g[pa+84>>2]))))>G)xa=0;else xa=1}else xa=1;if((oa|0)!=-1){ra=pa+116|0;ya=c[ra>>2]|0;za=ia+(ha*44|0)+12|0;Aa=(b[za>>1]&-2)<<16>>16==254;Ba=_7b(ya,N,R)|0;Ca=c[na>>2]|0;na=c[ja>>2]|0;Da=c[ka>>2]|0;ka=c[(c[Ca+116>>2]|0)+168>>2]|0;if(!ka)Ea=0;else Ea=c[ka+32>>2]|0;ka=b[ma>>1]|0;ma=(ka<<1&65535)<<16>>16>>1<<16>>16;Fa=(ka&65535)>>>15&65535;ua=ea(g[Ca+120>>2]);Ca=c[ia+(ha*44|0)+12>>2]|0;do if((B|0)==(na|0)&(Y|0)==(Da|0)&(Z|0)==(ma|0)&(_|0)==(Ea|0)&($|0)==(Fa|0)?(ka=(aa>ea(0.0)&1)-(aa<ea(0.0)&1)|0,(ka|0)==((ua>ea(0.0)&1)-(ua<ea(0.0)&1)|0)):0){if((ka|0)<0){qa=ea(aa-ua);if(qa<ea(0.0))Ga=ea(-qa);else Ga=qa;if(!(Ga<=ea(9.99999997e-07))|(ba|0)!=(Ca|0)){Ha=58;break}}else{qa=ea(aa*ea(16.0));if(!(qa>=ea(0.0)))Ia=ea(qa+ea(-.99999994));else Ia=qa;qa=ea(ua*ea(16.0));if(!(qa>=ea(0.0)))Ja=ea(qa+ea(-.99999994));else Ja=qa;if((~~Ia|0)!=(~~Ja|0)|(ba|0)!=(Ca|0)){Ha=58;break}}if(emd(la,ua)|0){TYb(A);Ka=ba;La=aa;Ma=$;Na=Z;Oa=_;Pa=Y;Qa=B;Ra=0}else{Ka=ba;La=aa;Ma=$;Na=Z;Oa=_;Pa=Y;Qa=B;Ra=0}}else Ha=58;while(0);if((Ha|0)==58){Ha=0;TYb(A);K_b(I,H,ua);Ka=Ca;La=ua;Ma=Fa;Na=ma;Oa=Ea;Pa=Da;Qa=na;Ra=1}T_b(D,c[ra>>2]|0,c[ia+(ha*44|0)+16>>2]|0);a8b(pa,t,M,E);ka=0;do{if((c[r+(ka<<2)>>2]|0)!=(c[E+(ka<<2)>>2]|0)){Ha=64;break}ka=ka+1|0}while((ka|0)<27);if((Ha|0)==64){Ha=0;Sa=r+0|0;Ta=E+0|0;Ua=Sa+108|0;do{c[Sa>>2]=c[Ta>>2];Sa=Sa+4|0;Ta=Ta+4|0}while((Sa|0)<(Ua|0));O_b(c[P>>2]|0,E)}k7b(F);ka=pa+64|0;b8b(c[ra>>2]|0,ka,y,F);if(FEi(C,F,124)|0){Sa=C+0|0;Ta=F+0|0;Ua=Sa+124|0;do{c[Sa>>2]=c[Ta>>2];Sa=Sa+4|0;Ta=Ta+4|0}while((Sa|0)<(Ua|0));R_b(c[O>>2]|0,F)}ra=c[(c[c[la+52>>2]>>2]|0)+(oa<<2)>>2]|0;na=c[ra+16>>2]|0;if((na|0)>0){Da=Ba?128:192;ma=pa+76|0;Fa=pa+68|0;Ca=pa+80|0;Va=pa+72|0;Wa=pa+84|0;Xa=ia+(ha*44|0)+6|0;if(Aa){Ya=ca;Za=0;_a=fa;$a=ga;ab=Ra;while(1){do if((c[(c[(c[ra>>2]|0)+(Za<<2)>>2]|0)+584>>2]|0)==10){bb=xa?Da:Da|32;cb=c[h+((mo[c[(c[ya>>2]|0)+28>>2]&4095](ya)|0)<<2)+4>>2]|0;if((cb|0)==-1)db=bb;else db=1<<cb|bb;if((Za|0)==(_a|0)&(db|0)==($a|0))if(ab)Ha=75;else{eb=Ya;fb=$a;gb=0}else{TYb(A);Ha=75}if((Ha|0)==75){Ha=0;x8b(n,za);bb=ekd(c[ja>>2]|0,Za,la,H,oa)|0;co[c[(c[I>>2]|0)+64>>2]&2047](I,J,c[K>>2]|db);eb=bb;fb=db;gb=1}ua=ea(g[ka>>2]);qa=ea(ua+ea(g[ma>>2]));ua=ea(g[Fa>>2]);sa=ea(ua+ea(g[Ca>>2]));ua=ea(g[Va>>2]);hb=ea(ua+ea(g[Wa>>2]));ua=ea(g[k>>2]);ib=qa<ua?qa:ua;ua=ea(g[w>>2]);jb=sa<ua?sa:ua;ua=ea(g[f>>2]);kb=hb<ua?hb:ua;g[k>>2]=ib;g[w>>2]=jb;g[f>>2]=kb;ua=ea(g[L>>2]);lb=ua<qa?qa:ua;ua=ea(g[u>>2]);qa=ua<sa?sa:ua;ua=ea(g[Q>>2]);sa=ua<hb?hb:ua;g[L>>2]=lb;g[u>>2]=qa;g[Q>>2]=sa;ua=ea(g[ka>>2]);hb=ea(ua-ea(g[ma>>2]));ua=ea(g[Fa>>2]);mb=ea(ua-ea(g[Ca>>2]));ua=ea(g[Va>>2]);nb=ea(ua-ea(g[Wa>>2]));g[k>>2]=hb<ib?hb:ib;g[w>>2]=mb<jb?mb:jb;g[f>>2]=nb<kb?nb:kb;g[L>>2]=lb<hb?hb:lb;g[u>>2]=qa<mb?mb:qa;g[Q>>2]=sa<nb?nb:sa;if(!eb){ob=0;pb=Za;qb=fb;rb=gb;break}SYb(A,ya,pa,e[Xa>>1]|0,eb);ob=eb;pb=Za;qb=fb;rb=gb}else{ob=Ya;pb=_a;qb=$a;rb=ab}while(0);Za=Za+1|0;if((Za|0)>=(na|0)){sb=Ka;tb=La;ub=Ma;vb=Na;wb=Oa;xb=Pa;yb=Qa;zb=ob;Ab=pb;Bb=qb;break}else{Ya=ob;_a=pb;$a=qb;ab=rb}}}else{ab=ca;$a=0;_a=fa;Ya=ga;Za=Ra;while(1){do if((c[(c[(c[ra>>2]|0)+($a<<2)>>2]|0)+584>>2]|0)==10){Da=xa?128:160;Aa=c[h+((mo[c[(c[ya>>2]|0)+28>>2]&4095](ya)|0)<<2)+4>>2]|0;if((Aa|0)==-1)Cb=Da;else Cb=1<<Aa|Da;if(($a|0)==(_a|0)&(Cb|0)==(Ya|0))if(Za)Ha=85;else{Db=ab;Eb=Ya;Fb=0}else{TYb(A);Ha=85}if((Ha|0)==85){Ha=0;x8b(n,za);Da=ekd(c[ja>>2]|0,$a,la,H,oa)|0;co[c[(c[I>>2]|0)+64>>2]&2047](I,J,c[K>>2]|Cb);Db=Da;Eb=Cb;Fb=1}sa=ea(g[ka>>2]);nb=ea(sa+ea(g[ma>>2]));sa=ea(g[Fa>>2]);qa=ea(sa+ea(g[Ca>>2]));sa=ea(g[Va>>2]);mb=ea(sa+ea(g[Wa>>2]));sa=ea(g[k>>2]);lb=nb<sa?nb:sa;sa=ea(g[w>>2]);hb=qa<sa?qa:sa;sa=ea(g[f>>2]);kb=mb<sa?mb:sa;g[k>>2]=lb;g[w>>2]=hb;g[f>>2]=kb;sa=ea(g[L>>2]);jb=sa<nb?nb:sa;sa=ea(g[u>>2]);nb=sa<qa?qa:sa;sa=ea(g[Q>>2]);qa=sa<mb?mb:sa;g[L>>2]=jb;g[u>>2]=nb;g[Q>>2]=qa;sa=ea(g[ka>>2]);mb=ea(sa-ea(g[ma>>2]));sa=ea(g[Fa>>2]);ib=ea(sa-ea(g[Ca>>2]));sa=ea(g[Va>>2]);ua=ea(sa-ea(g[Wa>>2]));g[k>>2]=mb<lb?mb:lb;g[w>>2]=ib<hb?ib:hb;g[f>>2]=ua<kb?ua:kb;g[L>>2]=jb<mb?mb:jb;g[u>>2]=nb<ib?ib:nb;g[Q>>2]=qa<ua?ua:qa;if(!Db){Gb=0;Hb=$a;Ib=Eb;Jb=Fb;break}SYb(A,ya,pa,e[Xa>>1]|0,Db);Gb=Db;Hb=$a;Ib=Eb;Jb=Fb}else{Gb=ab;Hb=_a;Ib=Ya;Jb=Za}while(0);$a=$a+1|0;if(($a|0)>=(na|0)){sb=Ka;tb=La;ub=Ma;vb=Na;wb=Oa;xb=Pa;yb=Qa;zb=Gb;Ab=Hb;Bb=Ib;break}else{ab=Gb;_a=Hb;Ya=Ib;Za=Jb}}}}else{sb=Ka;tb=La;ub=Ma;vb=Na;wb=Oa;xb=Pa;yb=Qa;zb=ca;Ab=fa;Bb=ga}}else{if(xa?(a[(c[pa+116>>2]|0)+42>>0]|0)!=0:0){Za=pa+64|0;qa=ea(g[Za>>2]);Ya=pa+76|0;ua=ea(qa+ea(g[Ya>>2]));_a=pa+68|0;qa=ea(g[_a>>2]);ab=pa+80|0;nb=ea(qa+ea(g[ab>>2]));na=pa+72|0;qa=ea(g[na>>2]);$a=pa+84|0;ib=ea(qa+ea(g[$a>>2]));qa=ea(g[k>>2]);jb=ua<qa?ua:qa;qa=ea(g[w>>2]);mb=nb<qa?nb:qa;qa=ea(g[f>>2]);kb=ib<qa?ib:qa;g[k>>2]=jb;g[w>>2]=mb;g[f>>2]=kb;qa=ea(g[L>>2]);hb=qa<ua?ua:qa;qa=ea(g[u>>2]);ua=qa<nb?nb:qa;qa=ea(g[Q>>2]);nb=qa<ib?ib:qa;g[L>>2]=hb;g[u>>2]=ua;g[Q>>2]=nb;qa=ea(g[Za>>2]);ib=ea(qa-ea(g[Ya>>2]));qa=ea(g[_a>>2]);lb=ea(qa-ea(g[ab>>2]));qa=ea(g[na>>2]);sa=ea(qa-ea(g[$a>>2]));g[k>>2]=ib<jb?ib:jb;g[w>>2]=lb<mb?lb:mb;g[f>>2]=sa<kb?sa:kb;g[L>>2]=hb<ib?ib:hb;g[u>>2]=ua<lb?lb:ua;g[Q>>2]=nb<sa?sa:nb}$a=(c[v>>2]|0)+1|0;c[v>>2]=$a;na=c[m>>2]|0;ab=na&2147483647;if($a>>>0>ab>>>0){_a=na<<1;Ya=(_a|0)==0?1:_a;do if(ab>>>0<Ya>>>0)if((na|0)>-1){c[m>>2]=Ya;_a=c[j>>2]|0;c[q>>2]=c[s>>2];c[p+0>>2]=c[q+0>>2];c[j>>2]=hOb(_a,Ya*44|0,4,p,0,3653512,370)|0;break}else{c[q>>2]=c[s>>2];c[p+0>>2]=c[q+0>>2];_a=cOb(Ya*44|0,4,p,0,3653512,352)|0;YEi(_a|0,c[j>>2]|0,(c[v>>2]|0)*44|0)|0;c[m>>2]=Ya;c[j>>2]=_a;break}while(0);Kb=c[v>>2]|0}else Kb=$a;Sa=(c[j>>2]|0)+((Kb+-1|0)*44|0)+0|0;Ta=ja+0|0;Ua=Sa+44|0;do{c[Sa>>2]=c[Ta>>2];Sa=Sa+4|0;Ta=Ta+4|0}while((Sa|0)<(Ua|0));sb=ba;tb=aa;ub=$;vb=Z;wb=_;xb=Y;yb=B;zb=ca;Ab=fa;Bb=ga}da=da+1|0;if(da>>>0>=x>>>0)break;else{B=yb;Y=xb;Z=vb;_=wb;$=ub;aa=tb;ba=sb;ca=zb;fa=Ab;ga=Bb}}TYb(A);S=c[d>>2]|0;T=c[S>>2]|0;U=T+636|0;Bcc(U,5,H);V=c[I>>2]|0;W=V+72|0;X=c[W>>2]|0;In[X&4095](I,0);aZb(A);i=o;return 4}function ZZb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;h=ync()|0;In[c[(c[h>>2]|0)+140>>2]&4095](h,0);j=c[158074]|0;oBc(d,0,-1,0);k=ync()|0;l=mo[c[(c[k>>2]|0)+92>>2]&4095](k)|0;In[c[(c[k>>2]|0)+88>>2]&4095](k,0);k=j+20|0;nud(k,558552,ea(128.0));m=c[(c[h>>2]|0)+72>>2]|0;if(f)if(!d)n=1;else n=(a[d+130>>0]|0)!=0;else n=0;In[m&4095](h,n);J$b(c[c[b>>2]>>2]|0,1);if(!e){n=qud(k,558504,pvc()|0)|0;ixd(n,ea(1.0),ea(1.0));jxd(n,ea(0.0),ea(0.0))}else NBc(e,558504)|0;Bcc((c[c[b>>2]>>2]|0)+636|0,8,j);F3b(0,d,c[139678]|0,1,0,-1);Bcc((c[c[b>>2]>>2]|0)+636|0,9,j);j=ync()|0;In[c[(c[j>>2]|0)+72>>2]&4095](j,0);j=ync()|0;In[c[(c[j>>2]|0)+88>>2]&4095](j,l);i=g;return}function _Zb(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=0,ma=0;n=i;i=i+288|0;o=n+16|0;p=n+48|0;q=n+24|0;r=n;s=n+224|0;t=n+52|0;u=n+56|0;v=n+88|0;w=n+64|0;x=n+240|0;y=n+256|0;z=n+260|0;A=n+264|0;B=n+268|0;C=n+272|0;c[f>>2]=0;c[h>>2]=0;a[m>>0]=0;i2b((x2b()|0)+24|0,558712,2);if(!(c[139678]|0)){i=n;return}D=q+8|0;c[D>>2]=0;E=q+16|0;F=q+20|0;c[F>>2]=0;c[q+12>>2]=60;c[q>>2]=b;c[q+4>>2]=d;G=c[158074]|0;c[E>>2]=0;H=c[d>>2]|0;I=d+8|0;J=c[I>>2]|0;K=H+(J*44|0)|0;if(!J){L=0;M=0;N=H;O=0}else{J=q+8|0;P=0;Q=0;R=0;S=H;H=0;while(1){T=P+1|0;V=Q&2147483647;do if(T>>>0>V>>>0?(W=Q<<1,X=(W|0)==0?1:W,V>>>0<X>>>0):0)if((Q|0)>-1){c[F>>2]=X;c[p>>2]=60;c[o+0>>2]=c[p+0>>2];W=hOb(R,X<<2,4,o,0,3653512,370)|0;c[J>>2]=W;Y=X;Z=W;break}else{c[p>>2]=60;c[o+0>>2]=c[p+0>>2];W=cOb(X<<2,4,o,0,3653512,352)|0;YEi(W|0,R|0,T<<2|0)|0;c[F>>2]=X;c[J>>2]=W;Y=X;Z=W;break}else{Y=Q;Z=R}while(0);c[Z+(P<<2)>>2]=H;S=S+44|0;if((S|0)==(K|0)){_=T;$=Z;aa=Y;break}else{P=T;Q=Y;R=Z;H=H+1|0}}c[E>>2]=_;L=aa;M=$;N=c[d>>2]|0;O=c[I>>2]|0}b_b(N,N+(O*44|0)|0,o);O=ync()|0;x9b(c[b>>2]|0,s,t,u);ba=ea(g[t>>2]);w9b(c[b>>2]|0,ea(1.0),ba,ea(g[u>>2]),r);u=O+916|0;c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];c[u+12>>2]=c[s+12>>2];s=X8b()|0;u=(KLc()|0)==1;ba=ea(g[s+40>>2]);do if(u){do if(!(ba<=ea(.0404499993)))if(ba<ea(1.0)){ca=ea(+U(+ea(ea(ba+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{ca=ea(+U(+ba,2.20000005));break}else ca=ea(ba/ea(12.9200001));while(0);da=ea(g[s+44>>2]);do if(!(da<=ea(.0404499993)))if(da<ea(1.0)){fa=ea(+U(+ea(ea(da+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{fa=ea(+U(+da,2.20000005));break}else fa=ea(da/ea(12.9200001));while(0);da=ea(g[s+48>>2]);if(da<=ea(.0404499993)){ga=ca;ha=fa;ia=ea(da/ea(12.9200001));break}if(da<ea(1.0)){ga=ca;ha=fa;ia=ea(+U(+ea(ea(da+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{ga=ca;ha=fa;ia=ea(+U(+da,2.20000005));break}}else{da=ea(g[s+44>>2]);ga=ba;ha=da;ia=ea(g[s+48>>2])}while(0);ba=ea(g[s+52>>2]);g[O+660>>2]=ga;g[O+664>>2]=ha;g[O+668>>2]=ia;g[O+672>>2]=ba;s=ync()|0;u=c[(c[b>>2]|0)+348>>2]|0;uBc(u)|0;T=DZb()|0;c[v>>2]=T;t=v+4|0;N=t+128|0;do{c[t>>2]=-1;t=t+4|0}while((t|0)<(N|0));t=v+132|0;c[t>>2]=0;N=0;I=3;d=0;$=1;while(1){if(!($&T)){ja=N;ka=I}else{if((N|0)<4){c[v+(d<<2)+4>>2]=I;la=c[t>>2]|0}else la=N;aa=la+1|0;c[t>>2]=aa;ja=aa;ka=I+-1|0}d=d+1|0;if((d|0)==32)break;else{N=ja;I=ka;$=$<<1}}a[658128]=0;$=(a[(c[b>>2]|0)+620>>0]|0)!=0;ka=r;I=c[ka>>2]|0;ja=c[ka+4>>2]|0;ba=ea(g[r+8>>2]);ia=ea(g[r+12>>2]);ka=(Hwc(Vwc()|0)|0)==1;ha=ka?ia:ea(1.0);ia=ka?ba:ea(1.0);ka=O+676|0;N=ka;c[N>>2]=I;c[N+4>>2]=ja;g[O+684>>2]=ia;g[O+688>>2]=ha;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+0>>2]=c[150280];c[w+4>>2]=c[150281];c[w+8>>2]=c[150282];ha=ea(-ea(g[150280]));ia=ea(-ea(g[150281]));ba=ea(-ea(g[150282]));g[w+12>>2]=ha;g[w+16>>2]=ia;g[w+20>>2]=ba;YZb(q,u,v,e,w,x,$,l)|0;O=c[x>>2]|0;c[f>>2]=O;c[y>>2]=c[u+136>>2];ja=c[u+120>>2]|0;if(a[621165]|0){if((((a[k+16>>0]|0)!=0?(N=c[k>>2]|0,(N|0)!=0):0)?(I=c[N>>2]|0,(I|0)!=0):0)?(c[I+212>>2]|0)==1:0)ma=(c[I+116>>2]|0)==0;else ma=1;I=c[(c[b>>2]|0)+604>>2]&1;if(!(ma&(I|0)==0)){c[z>>2]=c[O+140>>2];c[A>>2]=c[u+148>>2];O=c[u+100>>2]|0;ma=c[u+104>>2]|0;c[p+0>>2]=c[z+0>>2];c[o+0>>2]=c[A+0>>2];IZb(b,u,e,p,o,O,ma,(I|0)!=0)}}BZb(s,c[b+116>>2]|0,ja,f,y,m);c[ka+0>>2]=c[r+0>>2];c[ka+4>>2]=c[r+4>>2];c[ka+8>>2]=c[r+8>>2];c[ka+12>>2]=c[r+12>>2];c[B>>2]=c[y>>2];c[o+0>>2]=c[B+0>>2];XZb(q,k,u,o,x,4,r,v,w,j);a[658128]=1;if(a[(c[b>>2]|0)+623>>0]|0){c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;Co[c[(c[s>>2]|0)+24>>2]&3](s,4,C,ea(1.0),0)}if($){Bcc((c[b>>2]|0)+636|0,8,G);Bcc((c[b>>2]|0)+636|0,9,G)}else ZZb(q,u,c[x+12>>2]|0,l);if(c[(c[b>>2]|0)+604>>2]&2)c[h>>2]=JZb(b,e)|0;oBc(u,0,-1,0);In[c[(c[s>>2]|0)+104>>2]&4095](s,b+12|0);In[c[(c[s>>2]|0)+140>>2]&4095](s,0);if((L|0)<=-1){i=n;return}c[p>>2]=60;c[o+0>>2]=c[p+0>>2];eOb(M,o);c[D>>2]=0;i=n;return}function $Zb(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,558432);c[139606]=c[b>>2];c[b>>2]=-1;itd(b,558456);c[139612]=c[b>>2];c[b>>2]=-1;itd(b,558480);c[139618]=c[b>>2];c[b>>2]=-1;itd(b,562072);c[139624]=c[b>>2];c[b>>2]=-1;itd(b,558512);c[139626]=c[b>>2];c[b>>2]=-1;itd(b,558536);c[139632]=c[b>>2];c[b>>2]=-1;itd(b,558560);c[139638]=c[b>>2];c[b>>2]=-1;itd(b,565136);c[139646]=c[b>>2];i=a;return}function a_b(b,d,e,f,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;s=i;i=i+1536|0;t=s+1456|0;u=s+1328|0;v=s+880|0;w=s+1408|0;x=s+1248|0;y=s+40|0;z=s+896|0;A=s+120|0;B=s+132|0;C=s+144|0;D=s+868|0;E=s+1392|0;F=s+1424|0;G=s+1440|0;H=s+972|0;I=s+976|0;J=s+1232|0;K=s+1236|0;L=s+1240|0;M=s+16|0;N=s+108|0;O=s;P=s+1522|0;Q=s+1312|0;R=s+1324|0;S=s+104|0;T=s+960|0;V=s+24|0;W=s+1520|0;X=c[p>>2]|0;Y=X+212|0;if((c[Y>>2]|0)!=3)if(!(a[X+217>>0]|0))Z=0;else Z=(c[X+208>>2]|0)==1?1:2;else Z=2;QGc(u,BTb(c[X+24>>2]|0)|0);_=ea(g[u+48>>2]);$=ea(g[u+52>>2]);aa=ea(g[u+56>>2]);g[v>>2]=_;ba=v+4|0;g[ba>>2]=$;ca=v+8|0;g[ca>>2]=aa;da=X+116|0;fa=c[da>>2]|0;do if(fa){if((c[Y>>2]|0)==1){if((fa|0)<=1)break}else if(!((a[(NOc()|0)+103>>0]|0)!=0&(fa|0)>1))break;L9b()|0}while(0);fa=ync()|0;J4b(X);aa=ea(g[u+32>>2]);$=ea(g[u+36>>2]);_=ea(g[u+40>>2]);ga=(KLc()|0)==1;ha=ea(g[X+136>>2]);do if(ga){do if(!(ha<=ea(.0404499993)))if(ha<ea(1.0)){ia=ea(+U(+ea(ea(ha+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{ia=ea(+U(+ha,2.20000005));break}else ia=ea(ha/ea(12.9200001));while(0);ja=ea(g[X+140>>2]);do if(!(ja<=ea(.0404499993)))if(ja<ea(1.0)){ka=ea(+U(+ea(ea(ja+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{ka=ea(+U(+ja,2.20000005));break}else ka=ea(ja/ea(12.9200001));while(0);ja=ea(g[X+144>>2]);if(ja<=ea(.0404499993)){la=ia;ma=ka;na=ea(ja/ea(12.9200001));break}if(ja<ea(1.0)){la=ia;ma=ka;na=ea(+U(+ea(ea(ja+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{la=ia;ma=ka;na=ea(+U(+ja,2.20000005));break}}else{ja=ea(g[X+140>>2]);la=ha;ma=ja;na=ea(g[X+144>>2])}while(0);ha=ea(g[X+148>>2]);ka=ea(g[X+180>>2]);ia=ea(ea(ma*ka)*ea(2.0));ma=ea(ea(na*ka)*ea(2.0));na=ea(ea(ha*ka)*ea(2.0));g[w>>2]=ea(ea(la*ka)*ea(2.0));g[w+4>>2]=ia;g[w+8>>2]=ma;g[w+12>>2]=na;ga=c[Y>>2]|0;if((ga|0)==2){oa=fa+3556|0;pa=X+40|0;qa=oa+64|0;do{c[oa>>2]=c[pa>>2];oa=oa+4|0;pa=pa+4|0}while((oa|0)<(qa|0))}else if(!ga){oa=t+0|0;pa=X+40|0;qa=oa+64|0;do{c[oa>>2]=c[pa>>2];oa=oa+4|0;pa=pa+4|0}while((oa|0)<(qa|0));g[A>>2]=ea(-.5);g[A+4>>2]=ea(-.5);g[A+8>>2]=ea(1.0);iMc(x,A)|0;g[B>>2]=ea(.5);g[B+4>>2]=ea(.5);g[B+8>>2]=ea(0.0);kMc(y,B)|0;na=ea(g[X+196>>2]);nMc(z,na,ea(0.0),ea(g[X+184>>2]))|0;dMc(y,z,C);dMc(C,x,y);dMc(y,t,fa+3556|0)}else if((ga|0)==1){na=ea(ea(1.0)/ea(g[X+192>>2]));g[D>>2]=na;g[D+4>>2]=na;g[D+8>>2]=ea(0.0);iMc(x,D)|0;g[E>>2]=ea(.5);g[E+4>>2]=ea(.5);g[E+8>>2]=ea(0.0);kMc(y,E)|0;dMc(y,x,z);dMc(z,X+40|0,fa+3556|0)}HZb(X,c[139678]|0);z=p+20|0;if((a[z>>0]|0)!=0?(a[p+21>>0]|0)!=0:0)ra=1;else ra=(c[Y>>2]|0)==1;x=r+20|0;nud(x,558528,ra?ea(1.0):ea(0.0));na=ea(g[v>>2]);ma=ea(g[ba>>2]);ia=ea(g[ca>>2]);ka=ea(g[X+184>>2]);la=ea(ea(1.0)/ea(ka*ka));g[F>>2]=na;g[F+4>>2]=ma;g[F+8>>2]=ia;g[F+12>>2]=la;oud(x,558424,F);g[G>>2]=aa;g[G+4>>2]=$;g[G+8>>2]=_;g[G+12>>2]=ea(0.0);oud(x,558448,G);oud(x,558472,w);w=c[139678]|0;c[t>>2]=-1;itd(t,564232);c[H>>2]=c[t>>2];x=rvc()|0;c[t+0>>2]=c[H+0>>2];rkd(w,t,x);YEi(C|0,d|0,612)|0;do if(c[p+4>>2]|0){_=ea(g[l>>2]);$=ea(g[150280]);if((_==$?(_=ea(g[l+4>>2]),_==ea(g[150281])):0)?(_=ea(g[l+8>>2]),_==ea(g[150282])):0){sa=48;break}_=ea(-$);$=ea(-ea(g[150282]));if(ea(g[l+12>>2])==_?(_=ea(-ea(g[150281])),ea(g[l+16>>2])==_):0)ta=ea(g[l+20>>2])!=$;else ta=1;if(ta&(e|0)!=0){d=c[da>>2]|0;x=(e|0)==1&(d|0)!=0?1:d;M9b(r,c[Y>>2]|0,x,0,1);In[c[(c[fa>>2]|0)+104>>2]&4095](fa,b+12|0);co[c[(c[fa>>2]|0)+64>>2]&2047](fa,k,0);ko[c[(c[fa>>2]|0)+404>>2]&4095](fa);d=N9b(C,p,l,r,I)|0;if(!d){K9b(r);ua=0}else{g[fa+756>>2]=ea(ea(1.0)-ea(g[X+124>>2]));g[fa+760>>2]=ea(0.0);g[fa+764>>2]=ea(0.0);g[fa+768>>2]=ea(0.0);w=c[Y>>2]|0;if(!w){oa=fa+3044|0;pa=I+0|0;qa=oa+64|0;do{c[oa>>2]=c[pa>>2];oa=oa+4|0;pa=pa+4|0}while((oa|0)<(qa|0));va=d}else if((w|0)==1){oa=fa+3044|0;pa=I+0|0;qa=oa+64|0;do{c[oa>>2]=c[pa>>2];oa=oa+4|0;pa=pa+4|0}while((oa|0)<(qa|0));P9b(I,C,r);va=O9b(c[b>>2]|0,d,x,r)|0}else va=d;$=ea(ea(.5)/ea(mo[c[(c[va>>2]|0)+116>>2]&4095](va)|0));_=ea(ea(.5)/ea(mo[c[(c[va>>2]|0)+120>>2]&4095](va)|0));aa=ea(-$);la=ea(-_);g[fa+692>>2]=aa;g[fa+696>>2]=la;g[fa+700>>2]=ea(0.0);g[fa+704>>2]=ea(0.0);g[fa+708>>2]=$;g[fa+712>>2]=la;g[fa+716>>2]=ea(0.0);g[fa+720>>2]=ea(0.0);g[fa+724>>2]=aa;g[fa+728>>2]=_;g[fa+732>>2]=ea(0.0);g[fa+736>>2]=ea(0.0);g[fa+740>>2]=$;g[fa+744>>2]=_;g[fa+748>>2]=ea(0.0);g[fa+752>>2]=ea(0.0);w=c[139678]|0;c[J>>2]=c[139646];c[t+0>>2]=c[J+0>>2];rkd(w,t,va);ua=va}In[c[(c[fa>>2]|0)+108>>2]&4095](fa,m+132|0);In[c[(c[fa>>2]|0)+104>>2]&4095](fa,m+68|0);s1b(ync()|0);In[c[(c[fa>>2]|0)+140>>2]&4095](fa,0);wa=ua}else sa=48}else sa=48;while(0);if((sa|0)==48){K9b(r);wa=0}if((tBc()|0)!=(h|0)){c[K>>2]=c[h+140>>2];c[L>>2]=c[j+148>>2];c[t+0>>2]=c[L+0>>2];qBc(1,K,t,h,0,-1,0)|0}h=M;c[h>>2]=64;c[h+4>>2]=0;h=(Z|0)==0;if(!h)if((Z|0)==1&(f|0)!=1){c[M>>2]=64;xa=1}else xa=2;else{c[M>>2]=0;xa=1}f=p+21|0;do if((a[z>>0]|0)==0?(a[f>>0]|0)==0&h:0){K=c[Y>>2]|0;if(K){L=CZb(X,o)|0;if((K|0)==2)ya=L;else{za=L;Aa=0;break}}else ya=CZb(X,o)|0;L=dkd(ckd()|0,0,r,0,1)|0;a[N+4>>0]=1;a[N+5>>0]=0;a[N+6>>0]=1;K=N+7|0;a[K+0>>0]=0;a[K+1>>0]=0;a[K+2>>0]=0;a[K+3>>0]=0;a[K+4>>0]=0;c[N>>2]=0;K=c[fa>>2]|0;j=c[K+52>>2]|0;ua=_n[c[K+32>>2]&4095](fa,N)|0;go[j&63](fa,ua,ea(0.0));ua=O;c[ua>>2]=0;c[ua+4>>2]=0;c[O+4>>2]=0;g[O+8>>2]=ea(0.0);c[O>>2]=0;ua=c[fa>>2]|0;j=c[ua+56>>2]|0;K=_n[c[ua+44>>2]&4095](fa,O)|0;In[j&4095](fa,K);a[P>>0]=0;a[P+1>>0]=4;K=c[fa>>2]|0;j=c[K+60>>2]|0;ua=_n[c[K+36>>2]&4095](fa,P)|0;In[j&4095](fa,ua);a[Q+6>>0]=0;a[Q+10>>0]=0;a[Q>>0]=1;a[Q+1>>0]=-1;a[Q+2>>0]=16;a[Q+11>>0]=5;a[Q+7>>0]=5;a[Q+9>>0]=0;a[Q+5>>0]=0;ua=(ya|0)!=0?6:8;a[Q+8>>0]=ua;a[Q+4>>0]=ua;ua=c[fa>>2]|0;j=c[ua+64>>2]|0;K=_n[c[ua+40>>2]&4095](fa,Q)|0;co[j&2047](fa,K,ya|192);EZb(b,p,v,u,ra,L);c[N>>2]=15;L=c[fa>>2]|0;K=c[L+52>>2]|0;j=_n[c[L+32>>2]&4095](fa,N)|0;go[K&63](fa,j,ea(0.0));za=ya;Aa=1}else sa=59;while(0);if((sa|0)==59){za=CZb(X,o)|0;Aa=0}o=(a[(c[b>>2]|0)+620>>0]|0)!=0;sa=n+8|0;ya=n+12|0;N=n+4|0;Q=X+124|0;X=fa+676|0;P=fa+684|0;O=fa+688|0;j=fa+756|0;K=fa+760|0;L=fa+764|0;ua=fa+768|0;_=o?ea(1.0):ea(2.0);$=ea(o&1);o=T+1|0;m=T+2|0;va=T+4|0;J=T+5|0;C=T+6|0;I=T+7|0;pa=T+8|0;oa=T+9|0;qa=T+10|0;l=T+11|0;k=(Z|0)==1;Z=k?-64:-128;e=(Z&255|32)&255;da=V+4|0;ta=V+8|0;w=W+1|0;H=0;do{G=n;F=c[G+4>>2]|0;aa=ea(g[sa>>2]);la=ea(g[ya>>2]);ia=ea(g[N>>2]);ma=ea(ea(1.0)-ea(g[Q>>2]));ca=(H|0)==0|h;na=ca?ea(0.0):la;ka=ca?ea(0.0):aa;ha=ca?la:ea(0.0);la=ca?aa:ea(0.0);ca=X;c[ca>>2]=c[G>>2];c[ca+4>>2]=F;g[P>>2]=ka;g[O>>2]=na;g[j>>2]=ma;g[K>>2]=ia;g[L>>2]=la;g[ua>>2]=ha;F=c[139678]|0;ca=F+32|0;G=c[ca>>2]|0;if(!G){Qjd(F);Ba=c[ca>>2]|0}else Ba=G;G=c[Ba+48>>2]|0;ca=Ba+48|0;if(G){F=c[139624]|0;ba=ca;y=G;a:while(1){G=y;while(1){if((c[G+16>>2]|0)>=(F|0)){Ca=G;break}G=c[G+4>>2]|0;if(!G){Da=ba;break a}}y=c[Ca>>2]|0;if(!y){Da=Ca;break}else ba=Ca}if(((Da|0)!=(ca|0)?(F|0)>=(c[Da+16>>2]|0):0)?(ba=c[Da+20>>2]|0,(ba|0)!=0):0)mxd(ba,ea(-8.0))}ba=c[139678]|0;c[t>>2]=-1;itd(t,558720);c[R>>2]=c[t>>2];c[t+0>>2]=c[R+0>>2];nkd(ba,t,_);ba=c[139678]|0;c[t>>2]=-1;itd(t,558736);c[S>>2]=c[t>>2];c[t+0>>2]=c[S+0>>2];nkd(ba,t,$);ba=dkd(c[139678]|0,0,r,0,1)|0;a[o>>0]=-1;a[m>>0]=-1;a[J>>0]=0;a[C>>0]=0;a[I>>0]=0;a[oa>>0]=0;a[qa>>0]=0;a[l>>0]=0;a[T>>0]=1;a[pa>>0]=3;a[va>>0]=3;y=((H|0)!=0&k?e:Z)&255|za;a[o>>0]=y;d=(c[M+(H<<2)>>2]|0)+128|0;if(Aa){a[m>>0]=16;a[l>>0]=1;a[I>>0]=1;a[oa>>0]=1;a[J>>0]=1;a[qa>>0]=1;a[C>>0]=1;a[o>>0]=y|16;Ea=d|16}else Ea=d;d=_n[c[(c[fa>>2]|0)+40>>2]&4095](fa,T)|0;co[c[(c[fa>>2]|0)+64>>2]&2047](fa,d,Ea);d=V;c[d>>2]=0;c[d+4>>2]=0;c[V>>2]=2;c[da>>2]=0;g[ta>>2]=ea(0.0);a[w>>0]=2;a[W>>0]=0;if((a[z>>0]|0)!=0&(a[f>>0]|0)==0?(d=c[Y>>2]|0,(d|0)==2|(d|0)==0):0){c[V>>2]=1;Fa=5}else Fa=4;a[w>>0]=Fa;d=c[fa>>2]|0;y=c[d+56>>2]|0;x=_n[c[d+44>>2]&4095](fa,V)|0;In[y&4095](fa,x);x=c[fa>>2]|0;y=c[x+60>>2]|0;d=_n[c[x+36>>2]&4095](fa,W)|0;In[y&4095](fa,d);EZb(b,p,v,u,ra,ba);H=H+1|0}while((H|0)<(xa|0));if((wa|0)==0|q){Ga=q?wa:0;i=s;return Ga|0}Jzc(Gzc()|0,wa);Ga=q?wa:0;i=s;return Ga|0}function b_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;f=i;i=i+48|0;h=f;j=a;a=d;a:while(1){d=a;k=a+-44|0;l=a+-88|0;m=a+-4|0;n=a+-40|0;o=a+-32|0;p=a+-28|0;q=a+-24|0;r=j;b:while(1){s=r;t=d-s|0;switch((t|0)/44|0|0){case 5:{u=r;v=k;w=18;break a;break}case 2:{x=r;y=m;z=n;A=o;B=p;C=k;D=q;E=k;w=4;break a;break}case 3:{F=r;G=k;w=16;break a;break}case 1:case 0:{w=153;break a;break}case 4:{H=r;I=k;w=17;break a;break}default:{}}if((t|0)<1364){J=r;K=a;w=20;break a}L=(t|0)/88|0;M=r+(L*44|0)|0;if((t|0)>43956){N=(t|0)/176|0;O=e_b(r,r+(N*44|0)|0,M,r+((N+L|0)*44|0)|0,k,e)|0}else O=c_b(r,M,k,e)|0;N=r+40|0;t=c[N>>2]|0;P=c[r+(L*44|0)+40>>2]|0;do if((t|0)==(P|0)){Q=b[r+4>>1]|0;R=b[r+(L*44|0)+4>>1]|0;if(Q<<16>>16!=R<<16>>16)if(Q<<16>>16<R<<16>>16){S=k;T=O;break}else{w=35;break}R=c[r+12>>2]|0;Q=c[r+(L*44|0)+12>>2]|0;if((R|0)!=(Q|0))if(R>>>0<Q>>>0){S=k;T=O;break}else{w=35;break}Q=c[r+16>>2]|0;R=c[r+(L*44|0)+16>>2]|0;if((Q|0)!=(R|0))if((Q|0)>(R|0)){S=k;T=O;break}else{w=35;break}R=c[r>>2]|0;Q=c[M>>2]|0;if((R|0)==(Q|0)){U=ea(g[r+20>>2]);if(U>ea(g[r+(L*44|0)+20>>2])){S=k;T=O;break}else{w=35;break}}else if((c[R+4>>2]|0)<(c[Q+4>>2]|0)){S=k;T=O;break}else{w=35;break}}else if(t>>>0<P>>>0){S=k;T=O}else w=35;while(0);c:do if((w|0)==35){w=0;d:do if((r|0)!=(l|0)){Q=r+(L*44|0)+4|0;R=r+(L*44|0)+12|0;V=r+(L*44|0)+16|0;W=r+(L*44|0)+20|0;X=a;Y=l;Z=k;e:while(1){_=c[X+-48>>2]|0;do if((_|0)==(P|0)){$=b[X+-84>>1]|0;aa=b[Q>>1]|0;if($<<16>>16!=aa<<16>>16)if($<<16>>16<aa<<16>>16){ba=Y;break e}else break;aa=c[X+-76>>2]|0;$=c[R>>2]|0;if((aa|0)!=($|0))if(aa>>>0<$>>>0){ba=Y;break e}else break;$=c[X+-72>>2]|0;aa=c[V>>2]|0;if(($|0)!=(aa|0))if(($|0)>(aa|0)){ba=Y;break e}else break;aa=c[X+-88>>2]|0;$=c[M>>2]|0;if((aa|0)==($|0)){U=ea(g[X+-68>>2]);if(U>ea(g[W>>2])){ba=Y;break e}else break}else if((c[aa+4>>2]|0)<(c[$+4>>2]|0)){ba=Y;break e}else break}else if(_>>>0<P>>>0){ba=Y;break e}while(0);_=Z+-88|0;if((r|0)==(_|0))break d;else{$=Y;aa=Z;Y=_;Z=$;X=aa}}ca=h+0|0;da=r+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=r+0|0;da=ba+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=ba+0|0;da=h+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));S=ba;T=O+1|0;break c}while(0);X=r+44|0;Z=c[m>>2]|0;do if((t|0)==(Z|0)){Y=b[r+4>>1]|0;W=b[n>>1]|0;if(Y<<16>>16!=W<<16>>16)if(Y<<16>>16<W<<16>>16){ga=X;break}else{w=48;break}W=c[r+12>>2]|0;Y=c[o>>2]|0;if((W|0)!=(Y|0))if(W>>>0<Y>>>0){ga=X;break}else{w=48;break}Y=c[r+16>>2]|0;W=c[p>>2]|0;if((Y|0)!=(W|0))if((Y|0)>(W|0)){ga=X;break}else{w=48;break}W=c[r>>2]|0;Y=c[k>>2]|0;if((W|0)==(Y|0)){U=ea(g[r+20>>2]);if(U>ea(g[q>>2])){ga=X;break}else{w=48;break}}else if((c[W+4>>2]|0)<(c[Y+4>>2]|0)){ga=X;break}else{w=48;break}}else if(t>>>0<Z>>>0)ga=X;else w=48;while(0);if((w|0)==48){w=0;if((X|0)==(k|0)){w=153;break a}Z=r+4|0;Y=r+12|0;W=r+16|0;V=r+20|0;R=r;Q=X;f:while(1){aa=c[Q+40>>2]|0;do if((t|0)==(aa|0)){$=b[Z>>1]|0;_=b[Q+4>>1]|0;if($<<16>>16!=_<<16>>16)if($<<16>>16<_<<16>>16){ha=Q;break f}else break;_=c[Y>>2]|0;$=c[Q+12>>2]|0;if((_|0)!=($|0))if(_>>>0<$>>>0){ha=Q;break f}else break;$=c[W>>2]|0;_=c[Q+16>>2]|0;if(($|0)!=(_|0))if(($|0)>(_|0)){ha=Q;break f}else break;_=c[r>>2]|0;$=c[Q>>2]|0;if((_|0)==($|0)){U=ea(g[V>>2]);if(U>ea(g[Q+20>>2])){ha=Q;break f}else break}else if((c[_+4>>2]|0)<(c[$+4>>2]|0)){ha=Q;break f}else break}else if(t>>>0<aa>>>0){ha=Q;break f}while(0);aa=R+88|0;if((aa|0)==(k|0)){w=153;break a}else{$=Q;Q=aa;R=$}}ca=h+0|0;da=ha+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=ha+0|0;da=k+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=k+0|0;da=h+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ga=ha+44|0}if((ga|0)==(k|0)){w=153;break a}R=r+20|0;Q=r+4|0;V=r+12|0;W=r+16|0;Y=ga;Z=k;while(1){X=c[N>>2]|0;$=Y;g:while(1){aa=c[$+40>>2]|0;do if((X|0)==(aa|0)){_=b[Q>>1]|0;ia=b[$+4>>1]|0;if(_<<16>>16!=ia<<16>>16)if(_<<16>>16<ia<<16>>16){ja=$;break g}else break;ia=c[V>>2]|0;_=c[$+12>>2]|0;if((ia|0)!=(_|0))if(ia>>>0<_>>>0){ja=$;break g}else break;_=c[W>>2]|0;ia=c[$+16>>2]|0;if((_|0)!=(ia|0))if((_|0)>(ia|0)){ja=$;break g}else break;ia=c[r>>2]|0;_=c[$>>2]|0;if((ia|0)==(_|0)){U=ea(g[R>>2]);if(U>ea(g[$+20>>2])){ja=$;break g}else break}else if((c[ia+4>>2]|0)<(c[_+4>>2]|0)){ja=$;break g}else break}else if(X>>>0<aa>>>0){ja=$;break g}while(0);$=$+44|0}$=Z;while(1){aa=$+-44|0;_=c[$+-4>>2]|0;if((X|0)!=(_|0))if(X>>>0<_>>>0){$=aa;continue}else{ka=aa;break}_=b[Q>>1]|0;ia=b[$+-40>>1]|0;if(_<<16>>16!=ia<<16>>16)if(_<<16>>16<ia<<16>>16){$=aa;continue}else{ka=aa;break}ia=c[V>>2]|0;_=c[$+-32>>2]|0;if((ia|0)!=(_|0))if(ia>>>0<_>>>0){$=aa;continue}else{ka=aa;break}_=c[W>>2]|0;ia=c[$+-28>>2]|0;if((_|0)!=(ia|0))if((_|0)>(ia|0)){$=aa;continue}else{ka=aa;break}ia=c[r>>2]|0;_=c[aa>>2]|0;if((ia|0)==(_|0)){U=ea(g[R>>2]);if(U>ea(g[$+-24>>2])){$=aa;continue}else{ka=aa;break}}else if((c[ia+4>>2]|0)<(c[_+4>>2]|0)){$=aa;continue}else{ka=aa;break}}if(ja>>>0>=ka>>>0){r=ja;continue b}ca=h+0|0;da=ja+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=ja+0|0;da=ka+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=ka+0|0;da=h+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));Y=ja+44|0;Z=ka}}while(0);N=r+44|0;h:do if(N>>>0<S>>>0){t=N;P=S;L=M;Z=T;while(1){Y=c[L+40>>2]|0;R=L+4|0;W=L+12|0;V=L+16|0;Q=L+20|0;$=t;i:while(1){X=c[$+40>>2]|0;do if((X|0)==(Y|0)){aa=b[$+4>>1]|0;_=b[R>>1]|0;if(aa<<16>>16!=_<<16>>16)if(aa<<16>>16<_<<16>>16)break;else{la=$;break i}_=c[$+12>>2]|0;aa=c[W>>2]|0;if((_|0)!=(aa|0))if(_>>>0<aa>>>0)break;else{la=$;break i}aa=c[$+16>>2]|0;_=c[V>>2]|0;if((aa|0)!=(_|0))if((aa|0)>(_|0))break;else{la=$;break i}_=c[$>>2]|0;aa=c[L>>2]|0;if((_|0)==(aa|0)){U=ea(g[$+20>>2]);if(U>ea(g[Q>>2]))break;else{la=$;break i}}else if((c[_+4>>2]|0)<(c[aa+4>>2]|0))break;else{la=$;break i}}else if(X>>>0>=Y>>>0){la=$;break i}while(0);$=$+44|0}$=P;while(1){X=$+-44|0;aa=c[$+-4>>2]|0;if((aa|0)!=(Y|0))if(aa>>>0<Y>>>0){ma=X;break}else{$=X;continue}aa=b[$+-40>>1]|0;_=b[R>>1]|0;if(aa<<16>>16!=_<<16>>16)if(aa<<16>>16<_<<16>>16){ma=X;break}else{$=X;continue}_=c[$+-32>>2]|0;aa=c[W>>2]|0;if((_|0)!=(aa|0))if(_>>>0<aa>>>0){ma=X;break}else{$=X;continue}aa=c[$+-28>>2]|0;_=c[V>>2]|0;if((aa|0)!=(_|0))if((aa|0)>(_|0)){ma=X;break}else{$=X;continue}_=c[X>>2]|0;aa=c[L>>2]|0;if((_|0)==(aa|0)){U=ea(g[$+-24>>2]);if(U>ea(g[Q>>2])){ma=X;break}else{$=X;continue}}else if((c[_+4>>2]|0)<(c[aa+4>>2]|0)){ma=X;break}else{$=X;continue}}if(la>>>0>ma>>>0){na=la;oa=L;pa=Z;break h}ca=h+0|0;da=la+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=la+0|0;da=ma+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=ma+0|0;da=h+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));t=la+44|0;P=ma;L=(L|0)==(la|0)?ma:L;Z=Z+1|0}}else{na=N;oa=M;pa=T}while(0);j:do if((na|0)==(oa|0))qa=pa;else{M=c[oa+40>>2]|0;N=c[na+40>>2]|0;do if((M|0)==(N|0)){Z=b[oa+4>>1]|0;L=b[na+4>>1]|0;if(Z<<16>>16!=L<<16>>16)if(Z<<16>>16<L<<16>>16)break;else{qa=pa;break j}L=c[oa+12>>2]|0;Z=c[na+12>>2]|0;if((L|0)!=(Z|0))if(L>>>0<Z>>>0)break;else{qa=pa;break j}Z=c[oa+16>>2]|0;L=c[na+16>>2]|0;if((Z|0)!=(L|0))if((Z|0)>(L|0))break;else{qa=pa;break j}L=c[oa>>2]|0;Z=c[na>>2]|0;if((L|0)==(Z|0)){U=ea(g[oa+20>>2]);if(U>ea(g[na+20>>2]))break;else{qa=pa;break j}}else if((c[L+4>>2]|0)<(c[Z+4>>2]|0))break;else{qa=pa;break j}}else if(M>>>0>=N>>>0){qa=pa;break j}while(0);ca=h+0|0;da=na+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=na+0|0;da=oa+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=oa+0|0;da=h+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));qa=pa+1|0}while(0);if(!qa){ra=g_b(r,na,e)|0;N=na+44|0;if(g_b(N,a,e)|0){w=148;break}if(ra){r=N;continue}}N=na;if((N-s|0)>=(d-N|0)){sa=r;ta=na;w=152;break}b_b(r,na,e);r=na+44|0}if((w|0)==148){w=0;if(ra){w=153;break}else{j=r;a=na;continue}}else if((w|0)==152){w=0;b_b(ta+44|0,a,e);j=sa;a=ta;continue}}if((w|0)==4){ta=c[y>>2]|0;y=c[x+40>>2]|0;do if((ta|0)==(y|0)){a=b[z>>1]|0;sa=b[x+4>>1]|0;if(a<<16>>16!=sa<<16>>16){if(a<<16>>16<sa<<16>>16)break;i=f;return}sa=c[A>>2]|0;a=c[x+12>>2]|0;if((sa|0)!=(a|0)){if(sa>>>0<a>>>0)break;i=f;return}a=c[B>>2]|0;sa=c[x+16>>2]|0;if((a|0)!=(sa|0)){if((a|0)>(sa|0))break;i=f;return}sa=c[C>>2]|0;a=c[x>>2]|0;if((sa|0)==(a|0)){U=ea(g[D>>2]);if(U>ea(g[x+20>>2]))break;i=f;return}else{if((c[sa+4>>2]|0)<(c[a+4>>2]|0))break;i=f;return}}else if(ta>>>0>=y>>>0){i=f;return}while(0);ca=h+0|0;da=x+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=x+0|0;da=E+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));ca=E+0|0;da=h+0|0;fa=ca+44|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));i=f;return}else if((w|0)==16){c_b(F,F+44|0,G,e)|0;i=f;return}else if((w|0)==17){d_b(H,H+44|0,H+88|0,I,e)|0;i=f;return}else if((w|0)==18){e_b(u,u+44|0,u+88|0,u+132|0,v,e)|0;i=f;return}else if((w|0)==20){f_b(J,K,e);i=f;return}else if((w|0)==153){i=f;return}}function c_b(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+48|0;h=f;j=d+40|0;k=c[j>>2]|0;l=a+40|0;m=c[l>>2]|0;do if((k|0)==(m|0)){n=b[d+4>>1]|0;o=b[a+4>>1]|0;if(n<<16>>16!=o<<16>>16){p=n<<16>>16<o<<16>>16;break}o=c[d+12>>2]|0;n=c[a+12>>2]|0;if((o|0)!=(n|0)){p=o>>>0<n>>>0;break}n=c[d+16>>2]|0;o=c[a+16>>2]|0;if((n|0)!=(o|0)){p=(n|0)>(o|0);break}o=c[d>>2]|0;n=c[a>>2]|0;if((o|0)==(n|0)){q=ea(g[d+20>>2]);p=q>ea(g[a+20>>2]);break}else{p=(c[o+4>>2]|0)<(c[n+4>>2]|0);break}}else p=k>>>0<m>>>0;while(0);m=e+40|0;n=c[m>>2]|0;do if((n|0)==(k|0)){o=b[e+4>>1]|0;r=b[d+4>>1]|0;if(o<<16>>16!=r<<16>>16){s=o<<16>>16<r<<16>>16;break}r=c[e+12>>2]|0;o=c[d+12>>2]|0;if((r|0)!=(o|0)){s=r>>>0<o>>>0;break}o=c[e+16>>2]|0;r=c[d+16>>2]|0;if((o|0)!=(r|0)){s=(o|0)>(r|0);break}r=c[e>>2]|0;o=c[d>>2]|0;if((r|0)==(o|0)){q=ea(g[e+20>>2]);s=q>ea(g[d+20>>2]);break}else{s=(c[r+4>>2]|0)<(c[o+4>>2]|0);break}}else s=n>>>0<k>>>0;while(0);if(!p){if(!s){t=0;i=f;return t|0}u=h+0|0;v=d+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=d+0|0;v=e+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=e+0|0;v=h+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));p=c[j>>2]|0;k=c[l>>2]|0;do if((p|0)==(k|0)){l=b[d+4>>1]|0;n=b[a+4>>1]|0;if(l<<16>>16!=n<<16>>16){if(l<<16>>16<n<<16>>16)break;else t=1;i=f;return t|0}n=c[d+12>>2]|0;l=c[a+12>>2]|0;if((n|0)!=(l|0)){if(n>>>0<l>>>0)break;else t=1;i=f;return t|0}l=c[d+16>>2]|0;n=c[a+16>>2]|0;if((l|0)!=(n|0)){if((l|0)>(n|0))break;else t=1;i=f;return t|0}n=c[d>>2]|0;l=c[a>>2]|0;if((n|0)==(l|0)){q=ea(g[d+20>>2]);if(q>ea(g[a+20>>2]))break;else t=1;i=f;return t|0}else{if((c[n+4>>2]|0)<(c[l+4>>2]|0))break;else t=1;i=f;return t|0}}else if(p>>>0>=k>>>0){t=1;i=f;return t|0}while(0);u=h+0|0;v=a+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=a+0|0;v=d+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=d+0|0;v=h+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=2;i=f;return t|0}if(s){u=h+0|0;v=a+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=a+0|0;v=e+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=e+0|0;v=h+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=1;i=f;return t|0}u=h+0|0;v=a+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=a+0|0;v=d+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=d+0|0;v=h+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));a=c[m>>2]|0;m=c[j>>2]|0;do if((a|0)==(m|0)){j=b[e+4>>1]|0;s=b[d+4>>1]|0;if(j<<16>>16!=s<<16>>16){if(j<<16>>16<s<<16>>16)break;else t=1;i=f;return t|0}s=c[e+12>>2]|0;j=c[d+12>>2]|0;if((s|0)!=(j|0)){if(s>>>0<j>>>0)break;else t=1;i=f;return t|0}j=c[e+16>>2]|0;s=c[d+16>>2]|0;if((j|0)!=(s|0)){if((j|0)>(s|0))break;else t=1;i=f;return t|0}s=c[e>>2]|0;j=c[d>>2]|0;if((s|0)==(j|0)){q=ea(g[e+20>>2]);if(q>ea(g[d+20>>2]))break;else t=1;i=f;return t|0}else{if((c[s+4>>2]|0)<(c[j+4>>2]|0))break;else t=1;i=f;return t|0}}else if(a>>>0>=m>>>0){t=1;i=f;return t|0}while(0);u=h+0|0;v=d+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=d+0|0;v=e+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));u=e+0|0;v=h+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=2;i=f;return t|0}function d_b(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0;j=i;i=i+48|0;k=j;l=c_b(a,d,e,h)|0;h=c[f+40>>2]|0;m=e+40|0;n=c[m>>2]|0;do if((h|0)==(n|0)){o=b[f+4>>1]|0;p=b[e+4>>1]|0;if(o<<16>>16!=p<<16>>16){if(o<<16>>16<p<<16>>16)break;else q=l;i=j;return q|0}p=c[f+12>>2]|0;o=c[e+12>>2]|0;if((p|0)!=(o|0)){if(p>>>0<o>>>0)break;else q=l;i=j;return q|0}o=c[f+16>>2]|0;p=c[e+16>>2]|0;if((o|0)!=(p|0)){if((o|0)>(p|0))break;else q=l;i=j;return q|0}p=c[f>>2]|0;o=c[e>>2]|0;if((p|0)==(o|0)){r=ea(g[f+20>>2]);if(r>ea(g[e+20>>2]))break;else q=l;i=j;return q|0}else{if((c[p+4>>2]|0)<(c[o+4>>2]|0))break;else q=l;i=j;return q|0}}else if(h>>>0>=n>>>0){q=l;i=j;return q|0}while(0);n=k+0|0;h=e+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));n=e+0|0;h=f+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));n=f+0|0;h=k+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));f=l+1|0;p=c[m>>2]|0;m=d+40|0;s=c[m>>2]|0;do if((p|0)==(s|0)){t=b[e+4>>1]|0;u=b[d+4>>1]|0;if(t<<16>>16!=u<<16>>16){if(t<<16>>16<u<<16>>16)break;else q=f;i=j;return q|0}u=c[e+12>>2]|0;t=c[d+12>>2]|0;if((u|0)!=(t|0)){if(u>>>0<t>>>0)break;else q=f;i=j;return q|0}t=c[e+16>>2]|0;u=c[d+16>>2]|0;if((t|0)!=(u|0)){if((t|0)>(u|0))break;else q=f;i=j;return q|0}u=c[e>>2]|0;t=c[d>>2]|0;if((u|0)==(t|0)){r=ea(g[e+20>>2]);if(r>ea(g[d+20>>2]))break;else q=f;i=j;return q|0}else{if((c[u+4>>2]|0)<(c[t+4>>2]|0))break;else q=f;i=j;return q|0}}else if(p>>>0>=s>>>0){q=f;i=j;return q|0}while(0);n=k+0|0;h=d+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));n=d+0|0;h=e+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));n=e+0|0;h=k+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));e=l+2|0;f=c[m>>2]|0;m=c[a+40>>2]|0;do if((f|0)==(m|0)){s=b[d+4>>1]|0;p=b[a+4>>1]|0;if(s<<16>>16!=p<<16>>16){if(s<<16>>16<p<<16>>16)break;else q=e;i=j;return q|0}p=c[d+12>>2]|0;s=c[a+12>>2]|0;if((p|0)!=(s|0)){if(p>>>0<s>>>0)break;else q=e;i=j;return q|0}s=c[d+16>>2]|0;p=c[a+16>>2]|0;if((s|0)!=(p|0)){if((s|0)>(p|0))break;else q=e;i=j;return q|0}p=c[d>>2]|0;s=c[a>>2]|0;if((p|0)==(s|0)){r=ea(g[d+20>>2]);if(r>ea(g[a+20>>2]))break;else q=e;i=j;return q|0}else{if((c[p+4>>2]|0)<(c[s+4>>2]|0))break;else q=e;i=j;return q|0}}else if(f>>>0>=m>>>0){q=e;i=j;return q|0}while(0);n=k+0|0;h=a+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));n=a+0|0;h=d+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));n=d+0|0;h=k+0|0;o=n+44|0;do{c[n>>2]=c[h>>2];n=n+4|0;h=h+4|0}while((n|0)<(o|0));q=l+3|0;i=j;return q|0}function e_b(a,d,e,f,h,j){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0;k=i;i=i+48|0;l=k;m=d_b(a,d,e,f,j)|0;j=c[h+40>>2]|0;n=f+40|0;o=c[n>>2]|0;do if((j|0)==(o|0)){p=b[h+4>>1]|0;q=b[f+4>>1]|0;if(p<<16>>16!=q<<16>>16){if(p<<16>>16<q<<16>>16)break;else r=m;i=k;return r|0}q=c[h+12>>2]|0;p=c[f+12>>2]|0;if((q|0)!=(p|0)){if(q>>>0<p>>>0)break;else r=m;i=k;return r|0}p=c[h+16>>2]|0;q=c[f+16>>2]|0;if((p|0)!=(q|0)){if((p|0)>(q|0))break;else r=m;i=k;return r|0}q=c[h>>2]|0;p=c[f>>2]|0;if((q|0)==(p|0)){s=ea(g[h+20>>2]);if(s>ea(g[f+20>>2]))break;else r=m;i=k;return r|0}else{if((c[q+4>>2]|0)<(c[p+4>>2]|0))break;else r=m;i=k;return r|0}}else if(j>>>0>=o>>>0){r=m;i=k;return r|0}while(0);o=l+0|0;j=f+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=f+0|0;j=h+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=h+0|0;j=l+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));h=m+1|0;q=c[n>>2]|0;n=e+40|0;t=c[n>>2]|0;do if((q|0)==(t|0)){u=b[f+4>>1]|0;v=b[e+4>>1]|0;if(u<<16>>16!=v<<16>>16){if(u<<16>>16<v<<16>>16)break;else r=h;i=k;return r|0}v=c[f+12>>2]|0;u=c[e+12>>2]|0;if((v|0)!=(u|0)){if(v>>>0<u>>>0)break;else r=h;i=k;return r|0}u=c[f+16>>2]|0;v=c[e+16>>2]|0;if((u|0)!=(v|0)){if((u|0)>(v|0))break;else r=h;i=k;return r|0}v=c[f>>2]|0;u=c[e>>2]|0;if((v|0)==(u|0)){s=ea(g[f+20>>2]);if(s>ea(g[e+20>>2]))break;else r=h;i=k;return r|0}else{if((c[v+4>>2]|0)<(c[u+4>>2]|0))break;else r=h;i=k;return r|0}}else if(q>>>0>=t>>>0){r=h;i=k;return r|0}while(0);o=l+0|0;j=e+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=e+0|0;j=f+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=f+0|0;j=l+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));f=m+2|0;h=c[n>>2]|0;n=d+40|0;t=c[n>>2]|0;do if((h|0)==(t|0)){q=b[e+4>>1]|0;u=b[d+4>>1]|0;if(q<<16>>16!=u<<16>>16){if(q<<16>>16<u<<16>>16)break;else r=f;i=k;return r|0}u=c[e+12>>2]|0;q=c[d+12>>2]|0;if((u|0)!=(q|0)){if(u>>>0<q>>>0)break;else r=f;i=k;return r|0}q=c[e+16>>2]|0;u=c[d+16>>2]|0;if((q|0)!=(u|0)){if((q|0)>(u|0))break;else r=f;i=k;return r|0}u=c[e>>2]|0;q=c[d>>2]|0;if((u|0)==(q|0)){s=ea(g[e+20>>2]);if(s>ea(g[d+20>>2]))break;else r=f;i=k;return r|0}else{if((c[u+4>>2]|0)<(c[q+4>>2]|0))break;else r=f;i=k;return r|0}}else if(h>>>0>=t>>>0){r=f;i=k;return r|0}while(0);o=l+0|0;j=d+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=d+0|0;j=e+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=e+0|0;j=l+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));e=m+3|0;f=c[n>>2]|0;n=c[a+40>>2]|0;do if((f|0)==(n|0)){t=b[d+4>>1]|0;h=b[a+4>>1]|0;if(t<<16>>16!=h<<16>>16){if(t<<16>>16<h<<16>>16)break;else r=e;i=k;return r|0}h=c[d+12>>2]|0;t=c[a+12>>2]|0;if((h|0)!=(t|0)){if(h>>>0<t>>>0)break;else r=e;i=k;return r|0}t=c[d+16>>2]|0;h=c[a+16>>2]|0;if((t|0)!=(h|0)){if((t|0)>(h|0))break;else r=e;i=k;return r|0}h=c[d>>2]|0;t=c[a>>2]|0;if((h|0)==(t|0)){s=ea(g[d+20>>2]);if(s>ea(g[a+20>>2]))break;else r=e;i=k;return r|0}else{if((c[h+4>>2]|0)<(c[t+4>>2]|0))break;else r=e;i=k;return r|0}}else if(f>>>0>=n>>>0){r=e;i=k;return r|0}while(0);o=l+0|0;j=a+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=a+0|0;j=d+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));o=d+0|0;j=l+0|0;p=o+44|0;do{c[o>>2]=c[j>>2];o=o+4|0;j=j+4|0}while((o|0)<(p|0));r=m+4|0;i=k;return r|0}function f_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+32|0;h=f+16|0;j=f;k=a+88|0;c_b(a,a+44|0,k,e)|0;e=a+132|0;if((e|0)==(d|0)){i=f;return}l=e;e=k;while(1){k=l+40|0;m=c[k>>2]|0;n=c[e+40>>2]|0;do if((m|0)==(n|0)){o=b[l+4>>1]|0;p=b[e+4>>1]|0;if(o<<16>>16!=p<<16>>16)if(o<<16>>16<p<<16>>16){q=o;r=15;break}else break;p=c[l+12>>2]|0;s=c[e+12>>2]|0;if((p|0)!=(s|0))if(p>>>0<s>>>0){q=o;r=15;break}else break;s=c[l+16>>2]|0;p=c[e+16>>2]|0;if((s|0)!=(p|0))if((s|0)>(p|0)){q=o;r=15;break}else break;p=c[l>>2]|0;s=c[e>>2]|0;if((p|0)==(s|0)){t=ea(g[l+20>>2]);if(t>ea(g[e+20>>2])){q=o;r=15;break}else break}else if((c[p+4>>2]|0)<(c[s+4>>2]|0)){q=o;r=15;break}else break}else if(m>>>0<n>>>0){q=b[l+4>>1]|0;r=15}while(0);if((r|0)==15){r=0;n=c[l>>2]|0;m=l+6|0;b[h+0>>1]=b[m+0>>1]|0;b[h+2>>1]=b[m+2>>1]|0;b[h+4>>1]=b[m+4>>1]|0;m=c[l+12>>2]|0;o=c[l+16>>2]|0;t=ea(g[l+20>>2]);s=l+24|0;c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];s=c[k>>2]|0;p=n+4|0;u=l+0|0;v=e+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));a:do if((e|0)==(a|0))x=a;else{k=e;while(1){y=k;k=k+-44|0;z=c[y+-4>>2]|0;do if((s|0)==(z|0)){A=b[y+-40>>1]|0;if(q<<16>>16!=A<<16>>16)if(q<<16>>16<A<<16>>16)break;else{x=y;break a}A=c[y+-32>>2]|0;if((m|0)!=(A|0))if(m>>>0<A>>>0)break;else{x=y;break a}A=c[y+-28>>2]|0;if((o|0)!=(A|0))if((o|0)>(A|0))break;else{x=y;break a}A=c[k>>2]|0;if((n|0)==(A|0))if(t>ea(g[y+-24>>2]))break;else{x=y;break a}else if((c[p>>2]|0)<(c[A+4>>2]|0))break;else{x=y;break a}}else if(s>>>0>=z>>>0){x=y;break a}while(0);u=y+0|0;v=k+0|0;w=u+44|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));if((k|0)==(a|0)){x=a;break}}}while(0);c[x>>2]=n;b[x+4>>1]=q;v=x+6|0;b[v+0>>1]=b[h+0>>1]|0;b[v+2>>1]=b[h+2>>1]|0;b[v+4>>1]=b[h+4>>1]|0;c[x+12>>2]=m;c[x+16>>2]=o;g[x+20>>2]=t;v=x+24|0;c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];c[x+40>>2]=s}v=l+44|0;if((v|0)==(d|0))break;else{u=l;l=v;e=u}}i=f;return}function g_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+64|0;h=f+16|0;j=f;switch((d-a|0)/44|0|0){case 2:{k=d+-44|0;l=c[d+-4>>2]|0;m=c[a+40>>2]|0;do if((l|0)==(m|0)){n=b[d+-40>>1]|0;o=b[a+4>>1]|0;if(n<<16>>16!=o<<16>>16){if(n<<16>>16<o<<16>>16)break;else p=1;i=f;return p|0}o=c[d+-32>>2]|0;n=c[a+12>>2]|0;if((o|0)!=(n|0)){if(o>>>0<n>>>0)break;else p=1;i=f;return p|0}n=c[d+-28>>2]|0;o=c[a+16>>2]|0;if((n|0)!=(o|0)){if((n|0)>(o|0))break;else p=1;i=f;return p|0}o=c[k>>2]|0;n=c[a>>2]|0;if((o|0)==(n|0)){q=ea(g[d+-24>>2]);if(q>ea(g[a+20>>2]))break;else p=1;i=f;return p|0}else{if((c[o+4>>2]|0)<(c[n+4>>2]|0))break;else p=1;i=f;return p|0}}else if(l>>>0>=m>>>0){p=1;i=f;return p|0}while(0);r=h+0|0;s=a+0|0;t=r+44|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=a+0|0;s=k+0|0;t=r+44|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=k+0|0;s=h+0|0;t=r+44|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));p=1;i=f;return p|0}case 3:{c_b(a,a+44|0,d+-44|0,e)|0;p=1;i=f;return p|0}case 5:{e_b(a,a+44|0,a+88|0,a+132|0,d+-44|0,e)|0;p=1;i=f;return p|0}case 4:{d_b(a,a+44|0,a+88|0,d+-44|0,e)|0;p=1;i=f;return p|0}case 1:case 0:{p=1;i=f;return p|0}default:{k=a+88|0;c_b(a,a+44|0,k,e)|0;e=a+132|0;if((e|0)==(d|0)){p=1;i=f;return p|0}m=0;l=e;e=k;while(1){k=l+40|0;n=c[k>>2]|0;o=c[e+40>>2]|0;do if((n|0)==(o|0)){u=b[l+4>>1]|0;v=b[e+4>>1]|0;if(u<<16>>16!=v<<16>>16)if(u<<16>>16<v<<16>>16){w=u;x=31;break}else{y=m;break}v=c[l+12>>2]|0;z=c[e+12>>2]|0;if((v|0)!=(z|0))if(v>>>0<z>>>0){w=u;x=31;break}else{y=m;break}z=c[l+16>>2]|0;v=c[e+16>>2]|0;if((z|0)!=(v|0))if((z|0)>(v|0)){w=u;x=31;break}else{y=m;break}v=c[l>>2]|0;z=c[e>>2]|0;if((v|0)==(z|0)){q=ea(g[l+20>>2]);if(q>ea(g[e+20>>2])){w=u;x=31;break}else{y=m;break}}else if((c[v+4>>2]|0)<(c[z+4>>2]|0)){w=u;x=31;break}else{y=m;break}}else if(n>>>0<o>>>0){w=b[l+4>>1]|0;x=31}else y=m;while(0);if((x|0)==31){x=0;o=c[l>>2]|0;n=l+6|0;b[h+0>>1]=b[n+0>>1]|0;b[h+2>>1]=b[n+2>>1]|0;b[h+4>>1]=b[n+4>>1]|0;n=c[l+12>>2]|0;u=c[l+16>>2]|0;q=ea(g[l+20>>2]);z=l+24|0;c[j+0>>2]=c[z+0>>2];c[j+4>>2]=c[z+4>>2];c[j+8>>2]=c[z+8>>2];c[j+12>>2]=c[z+12>>2];z=c[k>>2]|0;v=o+4|0;r=l+0|0;s=e+0|0;t=r+44|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));a:do if((e|0)==(a|0))A=a;else{k=e;while(1){B=k;k=k+-44|0;C=c[B+-4>>2]|0;do if((z|0)==(C|0)){D=b[B+-40>>1]|0;if(w<<16>>16!=D<<16>>16)if(w<<16>>16<D<<16>>16)break;else{A=B;break a}D=c[B+-32>>2]|0;if((n|0)!=(D|0))if(n>>>0<D>>>0)break;else{A=B;break a}D=c[B+-28>>2]|0;if((u|0)!=(D|0))if((u|0)>(D|0))break;else{A=B;break a}D=c[k>>2]|0;if((o|0)==(D|0))if(q>ea(g[B+-24>>2]))break;else{A=B;break a}else if((c[v>>2]|0)<(c[D+4>>2]|0))break;else{A=B;break a}}else if(z>>>0>=C>>>0){A=B;break a}while(0);r=B+0|0;s=k+0|0;t=r+44|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if((k|0)==(a|0)){A=a;break}}}while(0);c[A>>2]=o;b[A+4>>1]=w;v=A+6|0;b[v+0>>1]=b[h+0>>1]|0;b[v+2>>1]=b[h+2>>1]|0;b[v+4>>1]=b[h+4>>1]|0;c[A+12>>2]=n;c[A+16>>2]=u;g[A+20>>2]=q;v=A+24|0;c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];c[A+40>>2]=z;v=m+1|0;if((v|0)==8){E=l;break}else y=v}v=l+44|0;if((v|0)==(d|0)){p=1;x=47;break}else{k=l;m=y;l=v;e=k}}if((x|0)==47){i=f;return p|0}p=(E+44|0)==(d|0);i=f;return p|0}}return 0}function h_b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=xCi(860)|0;e=d+76|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;e=d+316|0;g[d+484>>2]=ea(0.0);c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[d+488>>2]=ea(0.0);g[d+492>>2]=ea(0.0);g[d+500>>2]=ea(0.0);g[d+504>>2]=ea(0.0);g[d+508>>2]=ea(0.0);g[d+516>>2]=ea(0.0);g[d+520>>2]=ea(0.0);g[d+524>>2]=ea(0.0);g[d+532>>2]=ea(0.0);g[d+536>>2]=ea(0.0);g[d+540>>2]=ea(0.0);g[d+548>>2]=ea(0.0);g[d+552>>2]=ea(0.0);g[d+556>>2]=ea(0.0);g[d+564>>2]=ea(0.0);g[d+568>>2]=ea(0.0);g[d+572>>2]=ea(0.0);g[d+580>>2]=ea(0.0);g[d+584>>2]=ea(0.0);g[d+588>>2]=ea(0.0);g[d+596>>2]=ea(0.0);g[d+600>>2]=ea(0.0);g[d+604>>2]=ea(0.0);g[d+612>>2]=ea(0.0);g[d+616>>2]=ea(0.0);g[d+620>>2]=ea(0.0);g[d+628>>2]=ea(0.0);g[d+632>>2]=ea(0.0);g[d+636>>2]=ea(0.0);g[d+644>>2]=ea(0.0);g[d+648>>2]=ea(0.0);g[d+652>>2]=ea(0.0);g[d+660>>2]=ea(0.0);g[d+664>>2]=ea(0.0);g[d+668>>2]=ea(0.0);g[d+676>>2]=ea(0.0);g[d+680>>2]=ea(0.0);g[d+684>>2]=ea(0.0);c[d+724>>2]=0;c[d+728>>2]=-1;c[d+732>>2]=0;c[d+740>>2]=0;c[d+744>>2]=0;c[d+736>>2]=60;c[d+748>>2]=0;c[d+756>>2]=0;c[d+760>>2]=0;c[d+752>>2]=60;e=d+764|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[d>>2]=a;c[d+116>>2]=d;e=d+800|0;f=e+60|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));i=b;return d|0}function i_b(a){a=a|0;var b=0;b=i;if(a){k_b(a);ACi(a)}i=b;return}function j_b(a){a=a|0;return a+764|0}function k_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+776>>2]|0;if(f){g=a+780|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~(((h+-12-f|0)>>>0)/12|0)*12|0);ACi(f)}f=c[a+764>>2]|0;if(f){h=a+768|0;g=c[h>>2]|0;if((g|0)!=(f|0))c[h>>2]=g+(~(((g+-12-f|0)>>>0)/12|0)*12|0);ACi(f)}f=a+732|0;g=a+764|0;do{a=g;g=g+-16|0;if((c[a+-4>>2]|0)>-1){h=c[g>>2]|0;c[e>>2]=c[a+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}}while((g|0)!=(f|0));i=b;return}function l_b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+32|0;g=f+16|0;h=f;j=c[b>>2]|0;k=j+636|0;Bcc(k,e?12:18,c[158074]|0);l=z$b(j)|0;m=b+764|0;n=b+768|0;if(!((c[m>>2]|0)==(c[n>>2]|0)?(c[b+776>>2]|0)==(c[b+780>>2]|0):0))o=3;if((o|0)==3?x$b(c[b>>2]|0,l)|0:0){if(e)p=x3b(m)|0;else p=y3b(m,l,1)|0;if(p){o=ync()|0;ko[c[(c[o>>2]|0)+404>>2]&4095](o);u$b(g,c[b>>2]|0,0);n1b(h,g);g=mo[c[(c[p>>2]|0)+116>>2]&4095](p)|0;o=c[h+8>>2]|0;q=mo[c[(c[p>>2]|0)+120>>2]&4095](p)|0;r=c[h+12>>2]|0;zBc(p,c[h>>2]|0,c[h+4>>2]|0,(g|0)<(o|0)?g:o,(q|0)<(r|0)?q:r);ABc(p,0)}}if((c[m>>2]|0)==(c[n>>2]|0)?(c[b+776>>2]|0)==(c[b+780>>2]|0):0)s=0;else s=x$b(j,l)|0;C3b(m,d,l,e,s,(a[j+620>>0]|0)!=0);if(s|e^1){t=e?13:19;u=c[158074]|0;Bcc(k,t,u);i=f;return}c[j+348>>2]=y3b(m,l,0)|0;t=e?13:19;u=c[158074]|0;Bcc(k,t,u);i=f;return}function m_b(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;j=i;i=i+96|0;k=j;l=j+40|0;m=j+12|0;n=j+16|0;o=j+80|0;p=j+84|0;q=j+88|0;r=j+72|0;s=j+56|0;t=j+76|0;u=j+24|0;v=d+8|0;c[v>>2]=c[f+1024>>2];w=d+4|0;c[w>>2]=f;x=ync()|0;y=mo[c[(c[x>>2]|0)+92>>2]&4095](x)|0;x=(a[(NOc()|0)+94>>0]|0)==0;z=c[d>>2]|0;A=f+1068|0;B=c[A>>2]|0;C=c[f+1072>>2]|0;D=(B|0)!=0;E=d+12|0;F=(D$b(z)|0)+0|0;G=E+64|0;do{c[E>>2]=c[F>>2];E=E+4|0;F=F+4|0}while((E|0)<(G|0));F=d+92|0;rGc(k,BTb(c[z+24>>2]|0)|0);c[F+0>>2]=c[k+0>>2];c[F+4>>2]=c[k+4>>2];c[F+8>>2]=c[k+8>>2];B$b(l,z);F=d+76|0;c[F+0>>2]=c[l+0>>2];c[F+4>>2]=c[l+4>>2];c[F+8>>2]=c[l+8>>2];c[F+12>>2]=c[l+12>>2];F=c[z+600>>2]|0;if((F|0)==2)a[d+104>>0]=1;else if((F|0)==1)a[d+104>>0]=0;else a[d+104>>0]=a[z+616>>0]|0;a[d+105>>0]=h&1;a[d+106>>0]=D&1;c[d+740>>2]=0;c[d+756>>2]=0;E=d+800|0;G=E+60|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(G|0));E=c[f+92>>2]|0;G=c[f+100>>2]|0;h=E+(G<<7)|0;if(G){G=d+104|0;F=d+20|0;H=d+36|0;I=d+52|0;J=d+68|0;K=d+92|0;L=d+96|0;M=d+100|0;N=B+52|0;O=E;do{E=c[O+116>>2]|0;if((a[E+41>>0]|0)!=3){P=ea(g[O+64>>2]);Q=ea(g[O+68>>2]);R=ea(g[O+72>>2]);S=ea(P*ea(g[F>>2]));T=ea(S+ea(Q*ea(g[H>>2])));S=ea(T+ea(R*ea(g[I>>2])));T=ea(ea(g[J>>2])+S);if(!(a[G>>0]|0)){S=ea(P-ea(g[K>>2]));P=ea(Q-ea(g[L>>2]));Q=ea(R-ea(g[M>>2]));U=ea(-ea(ea(ea(S*S)+ea(P*P))+ea(Q*Q)))}else U=T;Q=ea(U-ea(Kn[c[(c[E>>2]|0)+32>>2]&255](E)));P=ea(-T);V=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;if(x)W=0;else W=mo[c[(c[E>>2]|0)+48>>2]&4095](E)|0;X=c[E+36>>2]|0;if((V|0)>0){Y=O+112|0;Z=E+172|0;_=0;do{co[c[(c[E>>2]|0)+40>>2]&2047](n,E,_);$=c[n>>2]|0;do if($){c[m>>2]=$;aa=c[137784]|0;if(aa){do if((c[aa+36>>2]|0)!=(c[aa+4>>2]|0)){fRb(k,aa,m);ba=c[k>>2]|0;ca=c[aa+28>>2]|0;if((ba|0)==-1){da=ca+(c[aa+32>>2]<<3)|0;break}else{da=ca+(ba<<3)|0;break}}else da=(c[aa+28>>2]|0)+(c[aa+32>>2]<<3)|0;while(0);aa=c[137784]|0;if((da|0)!=((c[aa+28>>2]|0)+(c[aa+32>>2]<<3)|0)?(aa=c[da+4>>2]|0,(aa|0)!=0):0){fa=aa;break}}aa=hQb(c[n>>2]|0)|0;if(aa)fa=aa;else ga=25}else ga=25;while(0);if((ga|0)==25){ga=0;fa=ckd()|0}$=hkd(fa)|0;if(D){aa=w8b($,B,C)|0;if((aa|0)>=0){ha=aa;ga=28}}else{ha=-1;ga=28}if((ga|0)==28){ga=0;aa=_n[c[(c[E>>2]|0)+44>>2]&4095](E,_)|0;ba=c[fa+64>>2]|0;do if((ba|0)<0)if(D){ia=qtd(c[N>>2]|0,ha)|0;break}else{ia=c[(c[$+52>>2]|0)+36>>2]|0;break}else ia=ba;while(0);ba=(ia|0)>2500&1;ca=d+(ba<<4)+732|0;ja=d+(ba<<4)+740|0;ka=(c[ja>>2]|0)+1|0;c[ja>>2]=ka;la=d+(ba<<4)+744|0;ma=c[la>>2]|0;na=ma&2147483647;if(ka>>>0>na>>>0){oa=ma<<1;pa=(oa|0)==0?1:oa;do if(na>>>0<pa>>>0)if((ma|0)>-1){c[la>>2]=pa;oa=c[ca>>2]|0;c[l>>2]=c[d+(ba<<4)+736>>2];c[k+0>>2]=c[l+0>>2];c[ca>>2]=hOb(oa,pa*44|0,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[d+(ba<<4)+736>>2];c[k+0>>2]=c[l+0>>2];oa=cOb(pa*44|0,4,k,0,3653512,352)|0;YEi(oa|0,c[ca>>2]|0,(c[ja>>2]|0)*44|0)|0;c[la>>2]=pa;c[ca>>2]=oa;break}while(0);qa=c[ja>>2]|0}else qa=ka;pa=qa+-1|0;la=c[ca>>2]|0;c[la+(pa*44|0)>>2]=fa;b[la+(pa*44|0)+4>>1]=ia;b[la+(pa*44|0)+6>>1]=aa;ba=la+(pa*44|0)+8|0;ma=ha&32767;b[ba>>1]=b[ba>>1]&-32768|ma;b[la+(pa*44|0)+10>>1]=_;c[la+(pa*44|0)+12>>2]=X;c[la+(pa*44|0)+16>>2]=W;g[la+(pa*44|0)+20>>2]=Q;g[la+(pa*44|0)+24>>2]=P;c[la+(pa*44|0)+28>>2]=O;c[la+(pa*44|0)+32>>2]=D?B:$;b[ba>>1]=((c[Y>>2]|0)>>>2&1)<<15&65535|ma;b[la+(pa*44|0)+36>>1]=mo[c[(c[E>>2]|0)+56>>2]&4095](E)|0;c[la+(pa*44|0)+40>>2]=c[Z>>2]}_=_+1|0}while((_|0)<(V|0))}}O=O+128|0}while((O|0)!=(h|0))}h=(KLc()|0)==1;c[o>>2]=0;c[p>>2]=0;a[q>>0]=0;O=d+108|0;c[O>>2]=0;B=d+112|0;c[B>>2]=2501;do if((e|0)==3){c[t>>2]=0;c[u>>2]=0;D=u+8|0;c[D>>2]=0;W=u+12|0;c[W>>2]=0;ha=u+4|0;c[ha>>2]=60;ia=f+124|0;_Zb(d,d+732|0,u,o,p,t,ia,h,q);fa=(a[q>>0]|0)!=0;qa=c[o>>2]|0;N=c[p>>2]|0;if(c[D>>2]|0){_Yb(d,u,1,1,c[t>>2]|0,ia,h,0);q_b(c[d>>2]|0,qa,N,u,A,fa,1,1,c[158074]|0)}if((c[W>>2]|0)>-1){W=c[u>>2]|0;c[l>>2]=c[ha>>2];c[k+0>>2]=c[l+0>>2];eOb(W,k);c[u>>2]=0}}else if((e|0)==2){c[r>>2]=0;c[s>>2]=0;W=s+8|0;c[W>>2]=0;ha=s+12|0;c[ha>>2]=0;fa=s+4|0;c[fa>>2]=60;N=f+124|0;OZb(d,d+732|0,s,o,p,r,N,h,q);qa=(a[q>>0]|0)!=0;ia=c[o>>2]|0;D=c[p>>2]|0;if(c[W>>2]|0){_Yb(d,s,1,1,c[r>>2]|0,N,h,0);q_b(c[d>>2]|0,ia,D,s,A,qa,1,1,c[158074]|0)}if((c[ha>>2]|0)>-1){ha=c[s>>2]|0;c[l>>2]=c[fa>>2];c[k+0>>2]=c[l+0>>2];eOb(ha,k);c[s>>2]=0}}else{ha=d+732|0;fa=f+124|0;if((e|0)==1){_Yb(d,ha,1,0,0,fa,h,1);break}else{pZb(d,ha,1,fa,h,1);break}}while(0);s=ync()|0;In[c[(c[s>>2]|0)+72>>2]&4095](s,h);I$b(z);s=ync()|0;In[c[(c[s>>2]|0)+72>>2]&4095](s,0);s=z+292|0;r=c[s>>2]|0;if(!r)ra=0;else{c[l>>2]=r;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(k,r,l);u=c[k>>2]|0;t=c[r+28>>2]|0;if((u|0)==-1){sa=t+(c[r+32>>2]<<3)|0;break}else{sa=t+(u<<3)|0;break}}else sa=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((sa|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[sa+4>>2]|0,(r|0)!=0):0)ta=r;else ga=62}else ga=62;if((ga|0)==62)ta=hQb(c[s>>2]|0)|0;ra=ta}l_b(d,ra,1);c[O>>2]=2501;c[B>>2]=5e3;B=d+748|0;O=f+124|0;if(!e){pZb(d,B,0,O,h,0);ua=c[o>>2]|0;va=c[p>>2]|0;wa=a[q>>0]|0;xa=wa<<24>>24!=0;ya=c[158074]|0;q_b(z,ua,va,B,A,xa,0,0,ya);c[v>>2]=0;c[w>>2]=0;za=ync()|0;Aa=c[za>>2]|0;Ba=Aa+88|0;Ca=c[Ba>>2]|0;In[Ca&4095](za,y);i=j;return}else{_Yb(d,B,0,0,0,O,h,0);ua=c[o>>2]|0;va=c[p>>2]|0;wa=a[q>>0]|0;xa=wa<<24>>24!=0;ya=c[158074]|0;q_b(z,ua,va,B,A,xa,0,0,ya);c[v>>2]=0;c[w>>2]=0;za=ync()|0;Aa=c[za>>2]|0;Ba=Aa+88|0;Ca=c[Ba>>2]|0;In[Ca&4095](za,y);i=j;return}}function n_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Gzc()|0;e=0;do{f=a+(e<<2)+800|0;g=c[f>>2]|0;if(g){Jzc(d,g);c[f>>2]=0}e=e+1|0}while((e|0)!=15);Etd();i=b;return}function o_b(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)+800>>2]=d;return}function p_b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((b|0)==1){e=tBc()|0;i=d;return e|0}else{e=c[a+(b<<2)+800>>2]|0;i=d;return e|0}return 0}function q_b(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;m=i;i=i+32|0;n=m+28|0;o=m+24|0;p=m+20|0;q=m+16|0;r=m+12|0;s=m;if(!d){i=m;return}if(!(c[f+8>>2]|0)){i=m;return}t=c[(c[b+348>>2]|0)+148>>2]|0;u=k?2:18;if(!((a[621165]|0)==0|j)?(c[b+604>>2]&1|0)!=0:0){if(h)oBc(d,0,-1,0);else{c[o>>2]=c[d+140>>2];c[p>>2]=t;c[n+0>>2]=c[p+0>>2];qBc(1,o,n,d,0,-1,0)|0}u_b(f,g,0,l);y$b(b,l,u)}if(!e){i=m;return}if(!(c[b+604>>2]&2)){i=m;return}g=d0b()|0;if(!g){i=m;return}c[q>>2]=c[e+140>>2];c[r>>2]=t;c[n+0>>2]=c[r+0>>2];qBc(1,q,n,e,0,-1,0)|0;rri(s,559632,10);v_b(f,g,s,l);xri(s);y$b(b,l,u);i=m;return}function r_b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=h+4|0;c[j>>2]=-1;c[h>>2]=d;d=a[e>>0]|0;if(!(d&1))k=(d&255)>>>1;else k=c[e+4>>2]|0;if(!k)l=-1;else l=vvd(e)|0;c[j>>2]=l;s_b(b,h,f);i=g;return}function s_b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+112|0;f=e+64|0;h=e+88|0;j=e+72|0;k=e+92|0;l=e+100|0;m=e;n=e+76|0;o=e+96|0;p=c[b+4>>2]|0;q=c[b>>2]|0;b=n8b()|0;c[l>>2]=c[b>>2];r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(f,r,l);s=c[f>>2]|0;t=c[r+28>>2]|0;if((s|0)==-1){u=t+(c[r+32>>2]<<3)|0;break}else{u=t+(s<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[u+4>>2]|0,(r|0)!=0):0)v=r;else w=9}else w=9;if((w|0)==9)v=hQb(c[b>>2]|0)|0;b=m+0|0;r=(D$b(v)|0)+0|0;v=b+64|0;do{c[b>>2]=c[r>>2];b=b+4|0;r=r+4|0}while((b|0)<(v|0));c[n>>2]=0;r=n+4|0;c[r>>2]=0;b=n+8|0;c[b>>2]=0;v=a+8|0;u=c[v>>2]|0;l=u>>>2;if(!l)x=u;else{c[h>>2]=89;c[f+0>>2]=c[h+0>>2];u=cOb(l<<5,16,f,0,3653512,80)|0;s=c[n>>2]|0;t=(c[r>>2]|0)-s|0;y=u+(0-(t>>5)<<5)|0;YEi(y|0,s|0,t|0)|0;t=c[n>>2]|0;c[n>>2]=y;c[r>>2]=u;c[b>>2]=u+(l<<5);if(t){c[j>>2]=89;c[f+0>>2]=c[j+0>>2];eOb(t,f)}x=c[v>>2]|0}if(x){x=m+8|0;t=m+24|0;j=m+40|0;l=m+56|0;u=c[a>>2]|0;do{z=ea(g[u+64>>2]);A=ea(g[u+68>>2]);B=ea(g[u+72>>2]);C=ea(z*ea(g[x>>2]));z=ea(C+ea(A*ea(g[t>>2])));A=ea(z+ea(B*ea(g[j>>2])));B=ea(ea(g[l>>2])+A);b=c[u+116>>2]|0;y=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;if((y|0)>0){s=b+172|0;D=0;do{co[c[(c[b>>2]|0)+40>>2]&2047](o,b,D);E=c[o>>2]|0;if(!E)F=0;else{c[h>>2]=E;E=c[137784]|0;if(E){do if((c[E+36>>2]|0)!=(c[E+4>>2]|0)){fRb(f,E,h);G=c[f>>2]|0;H=c[E+28>>2]|0;if((G|0)==-1){I=H+(c[E+32>>2]<<3)|0;break}else{I=H+(G<<3)|0;break}}else I=(c[E+28>>2]|0)+(c[E+32>>2]<<3)|0;while(0);E=c[137784]|0;if((I|0)!=((c[E+28>>2]|0)+(c[E+32>>2]<<3)|0)?(E=c[I+4>>2]|0,(E|0)!=0):0)J=E;else w=27}else w=27;if((w|0)==27){w=0;J=hQb(c[o>>2]|0)|0}F=J}E=mo[c[(c[b>>2]|0)+48>>2]&4095](b)|0;G=c[s>>2]|0;w_b(n,F,q,p,u,B,D,E,G,mo[c[(c[b>>2]|0)+56>>2]&4095](b)|0);D=D+1|0}while((D|0)<(y|0))}u=u+128|0}while((u|0)!=((c[a>>2]|0)+(c[v>>2]<<7)|0))}x_b(m,n,d);d=c[n>>2]|0;if(!d){i=e;return}n=c[r>>2]|0;if((n|0)!=(d|0))c[r>>2]=n+(~((n+-32-d|0)>>>5)<<5);c[k>>2]=89;c[f+0>>2]=c[k+0>>2];eOb(d,f);i=e;return}function t_b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=i;i=i+112|0;j=h+64|0;k=h+88|0;l=h+72|0;m=h+92|0;n=h+100|0;o=h;p=h+76|0;q=h+96|0;r=n8b()|0;c[n>>2]=c[r>>2];s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(j,s,n);t=c[j>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[v+4>>2]|0,(s|0)!=0):0)w=s;else x=9}else x=9;if((x|0)==9)w=hQb(c[r>>2]|0)|0;r=o+0|0;s=(D$b(w)|0)+0|0;w=r+64|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(w|0));c[p>>2]=0;s=p+4|0;c[s>>2]=0;r=p+8|0;c[r>>2]=0;w=b+8|0;v=c[w>>2]|0;n=v>>>1;if(!n)y=v;else{c[k>>2]=89;c[j+0>>2]=c[k+0>>2];v=cOb(n<<5,16,j,0,3653512,80)|0;t=c[p>>2]|0;u=(c[s>>2]|0)-t|0;z=v+(0-(u>>5)<<5)|0;YEi(z|0,t|0,u|0)|0;u=c[p>>2]|0;c[p>>2]=z;c[s>>2]=v;c[r>>2]=v+(n<<5);if(u){c[l>>2]=89;c[j+0>>2]=c[l+0>>2];eOb(u,j)}y=c[w>>2]|0}if(y){u=c[b>>2]|0;l=o+8|0;n=o+24|0;v=o+40|0;r=o+56|0;z=y;y=u;t=u;while(1){u=c[t+116>>2]|0;if((a[u+41>>0]|0)==3){A=y;B=z}else{C=ea(g[t+64>>2]);D=ea(g[t+68>>2]);E=ea(g[t+72>>2]);F=ea(C*ea(g[l>>2]));C=ea(F+ea(D*ea(g[n>>2])));D=ea(C+ea(E*ea(g[v>>2])));E=ea(ea(g[r>>2])+D);G=mo[c[(c[u>>2]|0)+36>>2]&4095](u)|0;if((G|0)>0){H=u+172|0;I=0;do{co[c[(c[u>>2]|0)+40>>2]&2047](q,u,I);J=c[q>>2]|0;if(!J)K=0;else{c[k>>2]=J;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(j,J,k);L=c[j>>2]|0;M=c[J+28>>2]|0;if((L|0)==-1){N=M+(c[J+32>>2]<<3)|0;break}else{N=M+(L<<3)|0;break}}else N=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((N|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[N+4>>2]|0,(J|0)!=0):0)O=J;else x=28}else x=28;if((x|0)==28){x=0;O=hQb(c[q>>2]|0)|0}K=O}J=mo[c[(c[u>>2]|0)+48>>2]&4095](u)|0;y_b(p,K,d,t,E,I,J,c[H>>2]|0);I=I+1|0}while((I|0)<(G|0))}A=c[b>>2]|0;B=c[w>>2]|0}t=t+128|0;if((t|0)==(A+(B<<7)|0))break;else{z=B;y=A}}}z_b(o,p,e,f);f=c[p>>2]|0;if(!f){i=h;return}p=c[s>>2]|0;if((p|0)!=(f|0))c[s>>2]=p+(~((p+-32-f|0)>>>5)<<5);c[m>>2]=89;c[j+0>>2]=c[m+0>>2];eOb(f,j);i=h;return}function u_b(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im;h=i;i=i+112|0;j=h+64|0;k=h+88|0;l=h+72|0;m=h+92|0;n=h+100|0;o=h;p=h+76|0;q=h+96|0;r=n8b()|0;c[n>>2]=c[r>>2];s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(j,s,n);t=c[j>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[v+4>>2]|0,(s|0)!=0):0)w=s;else x=9}else x=9;if((x|0)==9)w=hQb(c[r>>2]|0)|0;r=o+0|0;s=(D$b(w)|0)+0|0;w=r+64|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(w|0));c[p>>2]=0;s=p+4|0;c[s>>2]=0;r=p+8|0;c[r>>2]=0;w=a+8|0;v=c[w>>2]|0;n=v>>>1;if(!n)y=v;else{c[k>>2]=89;c[j+0>>2]=c[k+0>>2];v=cOb(n<<5,16,j,0,3653512,80)|0;t=c[p>>2]|0;u=(c[s>>2]|0)-t|0;z=v+(0-(u>>5)<<5)|0;YEi(z|0,t|0,u|0)|0;u=c[p>>2]|0;c[p>>2]=z;c[s>>2]=v;c[r>>2]=v+(n<<5);if(u){c[l>>2]=89;c[j+0>>2]=c[l+0>>2];eOb(u,j)}y=c[w>>2]|0}if(y){y=c[a>>2]|0;do{u=y+28|0;l=c[(c[u>>2]|0)+116>>2]|0;n=y+10|0;co[c[(c[l>>2]|0)+40>>2]&2047](q,l,e[n>>1]|0);v=c[q>>2]|0;if(!v)A=0;else{c[k>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(j,v,k);r=c[j>>2]|0;z=c[v+28>>2]|0;if((r|0)==-1){B=z+(c[v+32>>2]<<3)|0;break}else{B=z+(r<<3)|0;break}}else B=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((B|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[B+4>>2]|0,(v|0)!=0):0)C=v;else x=25}else x=25;if((x|0)==25){x=0;C=hQb(c[q>>2]|0)|0}A=C}D=ea(g[y+20>>2]);y_b(p,A,b,c[u>>2]|0,D,e[n>>1]|0,c[y+16>>2]|0,c[l+172>>2]|0);y=y+44|0}while((y|0)!=((c[a>>2]|0)+((c[w>>2]|0)*44|0)|0))}z_b(o,p,d,f);f=c[p>>2]|0;if(!f){i=h;return}p=c[s>>2]|0;if((p|0)!=(f|0))c[s>>2]=p+(~((p+-32-f|0)>>>5)<<5);c[m>>2]=89;c[j+0>>2]=c[m+0>>2];eOb(f,j);i=h;return}function v_b(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im;k=i;i=i+112|0;l=k+64|0;m=k+88|0;n=k+72|0;o=k+92|0;p=k+100|0;q=k;r=k+76|0;s=k+96|0;t=a[h>>0]|0;if(!(t&1))u=(t&255)>>>1;else u=c[h+4>>2]|0;if(!u)v=-1;else v=vvd(h)|0;h=n8b()|0;c[o>>2]=c[h>>2];u=c[137784]|0;if(u){do if((c[u+36>>2]|0)!=(c[u+4>>2]|0)){fRb(l,u,o);t=c[l>>2]|0;w=c[u+28>>2]|0;if((t|0)==-1){x=w+(c[u+32>>2]<<3)|0;break}else{x=w+(t<<3)|0;break}}else x=(c[u+28>>2]|0)+(c[u+32>>2]<<3)|0;while(0);u=c[137784]|0;if((x|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[x+4>>2]|0,(u|0)!=0):0)y=u;else z=14}else z=14;if((z|0)==14)y=hQb(c[h>>2]|0)|0;h=q+0|0;u=(D$b(y)|0)+0|0;y=h+64|0;do{c[h>>2]=c[u>>2];h=h+4|0;u=u+4|0}while((h|0)<(y|0));c[r>>2]=0;u=r+4|0;c[u>>2]=0;h=r+8|0;c[h>>2]=0;y=d+8|0;x=c[y>>2]|0;o=x>>>2;if(!o)A=x;else{c[m>>2]=89;c[l+0>>2]=c[m+0>>2];x=cOb(o<<5,16,l,0,3653512,80)|0;t=c[r>>2]|0;w=(c[u>>2]|0)-t|0;B=x+(0-(w>>5)<<5)|0;YEi(B|0,t|0,w|0)|0;w=c[r>>2]|0;c[r>>2]=B;c[u>>2]=x;c[h>>2]=x+(o<<5);if(w){c[n>>2]=89;c[l+0>>2]=c[n+0>>2];eOb(w,l)}A=c[y>>2]|0}if(A){A=c[d>>2]|0;do{w=A+28|0;n=c[(c[w>>2]|0)+116>>2]|0;o=A+10|0;co[c[(c[n>>2]|0)+40>>2]&2047](s,n,e[o>>1]|0);x=c[s>>2]|0;if(!x)C=0;else{c[m>>2]=x;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(l,x,m);h=c[l>>2]|0;B=c[x+28>>2]|0;if((h|0)==-1){D=B+(c[x+32>>2]<<3)|0;break}else{D=B+(h<<3)|0;break}}else D=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((D|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[D+4>>2]|0,(x|0)!=0):0)E=x;else z=30}else z=30;if((z|0)==30){z=0;E=hQb(c[s>>2]|0)|0}C=E}x=c[w>>2]|0;F=ea(g[A+20>>2]);h=b[o>>1]|0;B=c[A+16>>2]|0;t=c[n+172>>2]|0;w_b(r,C,f,v,x,F,h&65535,B,t,mo[c[(c[n>>2]|0)+56>>2]&4095](n)|0);A=A+44|0}while((A|0)!=((c[d>>2]|0)+((c[y>>2]|0)*44|0)|0))}x_b(q,r,j);j=c[r>>2]|0;if(!j){i=k;return}r=c[u>>2]|0;if((r|0)!=(j|0))c[u>>2]=r+(~((r+-32-j|0)>>>5)<<5);c[p>>2]=89;c[l+0>>2]=c[p+0>>2];eOb(j,l);i=k;return}function w_b(a,d,e,f,h,j,l,m,n,o){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;i=i+32|0;q=p;if(!d)r=ckd()|0;else r=d;d=w8b(hkd(r)|0,e,f)|0;if((d|0)<0){i=p;return};c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;c[q+24>>2]=-2147450880;f=a+4|0;s=c[f>>2]|0;if((s|0)==(c[a+8>>2]|0)){A_b(a,q);t=c[f>>2]|0}else{if(!s)u=0;else{c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];c[s+12>>2]=c[q+12>>2];c[s+16>>2]=c[q+16>>2];c[s+20>>2]=c[q+20>>2];c[s+24>>2]=c[q+24>>2];c[s+28>>2]=c[q+28>>2];u=c[f>>2]|0}q=u+32|0;c[f>>2]=q;t=q}c[t+-20>>2]=h;c[t+-32>>2]=m<<19&133693440|(g[k>>2]=j,c[k>>2]|0)>>>22<<9|d<<27|c[r+4>>2]<<3&496;c[t+-24>>2]=r;c[t+-12>>2]=l;c[t+-16>>2]=e;c[t+-28>>2]=d;b[t+-4>>1]=o;c[t+-8>>2]=n;i=p;return}function x_b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=b+4|0;B_b(c[b>>2]|0,c[f>>2]|0,e);h=ync()|0;j=(c[f>>2]|0)-(c[b>>2]|0)>>5;In[c[(c[h>>2]|0)+104>>2]&4095](h,a);if(!j){i=e;return}else k=0;do{a=c[b>>2]|0;f=c[a+(k<<5)+12>>2]|0;l=c[f+116>>2]|0;m=a+(k<<5)+16|0;n=c[m>>2]|0;K_b(h,d,ea(g[f+120>>2]));o=a+(k<<5)+4|0;p=c[o>>2]|0;q=c[(c[(c[c[(c[m>>2]|0)+52>>2]>>2]|0)+(p<<2)>>2]|0)+16>>2]|0;a:do if((q|0)>0){m=a+(k<<5)+8|0;r=f+112|0;s=a+(k<<5)+20|0;t=p;u=0;while(1){v=ekd(c[m>>2]|0,u,n,d,t)|0;if(v){t8b(f,c[r>>2]|0);w=c[l>>2]|0;x=c[w+8>>2]|0;y=_n[c[w+44>>2]&4095](l,c[s>>2]|0)|0;co[x&2047](l,y,v)}v=u+1|0;if((v|0)==(q|0))break a;t=c[o>>2]|0;u=v}}while(0);k=k+1|0}while((k|0)!=(j|0));i=e;return}function y_b(a,b,d,e,f,h,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=i;i=i+48|0;n=m;if(!b){i=m;return}if((Rjd(b)|0)>2500){i=m;return}o=hkd(b)|0;p=w8b(o,c[d>>2]|0,c[d+4>>2]|0)|0;if((p|0)<0){i=m;return}q=c[d>>2]|0;d=(q|0)==0?o:q;if(!(Gld(d,p,m+32|0)|0)){i=m;return};c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+24>>2]=0;c[n+28>>2]=0;c[n+24>>2]=-2147450880;q=a+4|0;o=c[q>>2]|0;if((o|0)==(c[a+8>>2]|0)){A_b(a,n);r=c[q>>2]|0}else{if(!o)s=0;else{c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];c[o+12>>2]=c[n+12>>2];c[o+16>>2]=c[n+16>>2];c[o+20>>2]=c[n+20>>2];c[o+24>>2]=c[n+24>>2];c[o+28>>2]=c[n+28>>2];s=c[q>>2]|0}n=s+32|0;c[q>>2]=n;r=n}c[r+-20>>2]=e;c[r+-32>>2]=j<<19&133693440|(g[k>>2]=f,c[k>>2]|0)>>>22<<9|p<<27|c[b+4>>2]<<3&496;c[r+-24>>2]=b;c[r+-12>>2]=h;c[r+-16>>2]=d;c[r+-28>>2]=p;c[r+-8>>2]=l;i=m;return}function z_b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=0,J=Im,K=Im,L=0,M=0,N=0,O=0,P=Im,Q=0;f=i;i=i+80|0;h=f;j=b+4|0;C_b(c[b>>2]|0,c[j>>2]|0,h);RYb(h,f+76|0);k=ync()|0;In[c[(c[k>>2]|0)+104>>2]&4095](k,a);a=k+772|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;M9b(e,1,1,0,1);a=c[b>>2]|0;l=(c[j>>2]|0)-a>>5;if(!l){TYb(h);aZb(h);i=f;return}else{m=a;n=0;o=0;p=-1;q=-1;r=ea(0.0);s=0;t=0;u=0}while(1){a=c[m+(u<<5)+12>>2]|0;j=c[a+116>>2]|0;v=a+120|0;w=ea(g[v>>2]);x=m+(u<<5)+8|0;y=c[x>>2]|0;z=m+(u<<5)+16|0;A=c[z>>2]|0;B=m+(u<<5)+4|0;C=c[B>>2]|0;D=c[j+168>>2]|0;if(!D)E=0;else E=c[D+32>>2]|0;if(d)F=(mo[c[(c[j>>2]|0)+48>>2]&4095](j)|0)==0;else F=0;do if((y|0)==(n|0)&(A|0)==(o|0)&(C|0)==(p|0)&(q|0)==0?(D=(w>ea(0.0)&1)-(w<ea(0.0)&1)|0,(D|0)==((r>ea(0.0)&1)-(r<ea(0.0)&1)|0)):0){if((D|0)<0){G=ea(w-r);if(G<ea(0.0))H=ea(-G);else H=G;if(!(H<=ea(9.99999997e-07))|(E|0)!=(s|0)){I=17;break}}else{G=ea(w*ea(16.0));if(!(G>=ea(0.0)))J=ea(G+ea(-.99999994));else J=G;G=ea(r*ea(16.0));if(!(G>=ea(0.0)))K=ea(G+ea(-.99999994));else K=G;if((~~J|0)!=(~~K|0)|(E|0)!=(s|0)){I=17;break}}if(F){TYb(h);L=s;M=p;N=o;O=n;P=r;Q=t}else{L=s;M=p;N=o;O=n;P=r;Q=t}}else I=17;while(0);if((I|0)==17){I=0;TYb(h);K_b(k,e,ea(g[v>>2]));L=E;M=C;N=A;O=y;P=w;Q=fkd(c[x>>2]|0,c[z>>2]|0,e,c[B>>2]|0)|0}if(Q)SYb(h,j,a,_n[c[(c[j>>2]|0)+44>>2]&4095](j,c[m+(u<<5)+20>>2]|0)|0,Q);D=u+1|0;if(D>>>0>=l>>>0)break;m=c[b>>2]|0;n=O;o=N;p=M;q=0;r=P;s=L;t=Q;u=D}TYb(h);aZb(h);i=f;return}function A_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>5)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>5>>>0<1073741823){m=h>>4;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>5;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>5;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<5,16,e,0,3653512,80)|0;p=r}r=o+(p<<5)|0;if(r){c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];c[r+16>>2]=c[b+16>>2];c[r+20>>2]=c[b+20>>2];c[r+24>>2]=c[b+24>>2];c[r+28>>2]=c[b+28>>2]}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>5)<<5)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<5);c[k>>2]=o+(n<<5);if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function B_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;f=i;i=i+32|0;g=f;h=a;a=d;a:while(1){d=a;j=a+-32|0;k=a+-64|0;l=a+-8|0;m=a+-4|0;n=h;b:while(1){o=n;p=d-o|0;q=p>>5;switch(q|0){case 4:{r=n;s=j;t=12;break a;break}case 5:{u=n;v=j;t=13;break a;break}case 2:{w=n;x=l;y=j;z=m;A=j;t=4;break a;break}case 3:{B=n;C=j;t=11;break a;break}case 1:case 0:{t=103;break a;break}default:{}}if((p|0)<992){D=n;E=a;t=15;break a}F=(q|0)/2|0;G=n+(F<<5)|0;if((p|0)>31968){p=(q|0)/4|0;H=F_b(n,n+(p<<5)|0,G,n+(p+F<<5)|0,j,e)|0}else H=D_b(n,G,j,e)|0;p=n+24|0;q=c[p>>2]|0;I=c[n+(F<<5)+24>>2]|0;do if((q|0)==(I|0)){J=c[n>>2]|0;K=c[G>>2]|0;if((J|0)==(K|0)?(L=b[n+28>>1]|0,M=b[n+(F<<5)+28>>1]|0,L<<16>>16!=M<<16>>16):0)if((L&65535)>(M&65535)){N=j;O=H;break}else{t=25;break}if(J>>>0<K>>>0){N=j;O=H}else t=25}else if(q>>>0<I>>>0){N=j;O=H}else t=25;while(0);c:do if((t|0)==25){t=0;d:do if((n|0)!=(k|0)){K=n+(F<<5)+28|0;J=a;M=k;L=j;e:while(1){P=c[J+-40>>2]|0;do if((P|0)==(I|0)){Q=c[J+-64>>2]|0;R=c[G>>2]|0;if((Q|0)==(R|0)?(S=b[J+-36>>1]|0,T=b[K>>1]|0,S<<16>>16!=T<<16>>16):0)if((S&65535)>(T&65535)){U=M;break e}else break;if(Q>>>0<R>>>0){U=M;break e}}else if(P>>>0<I>>>0){U=M;break e}while(0);P=L+-64|0;if((n|0)==(P|0))break d;else{R=M;Q=L;M=P;L=R;J=Q}}c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[g+16>>2]=c[n+16>>2];c[g+20>>2]=c[n+20>>2];c[g+24>>2]=c[n+24>>2];c[g+28>>2]=c[n+28>>2];c[n+0>>2]=c[U+0>>2];c[n+4>>2]=c[U+4>>2];c[n+8>>2]=c[U+8>>2];c[n+12>>2]=c[U+12>>2];c[n+16>>2]=c[U+16>>2];c[n+20>>2]=c[U+20>>2];c[n+24>>2]=c[U+24>>2];b[n+28>>1]=b[U+28>>1]|0;c[U+0>>2]=c[g+0>>2];c[U+4>>2]=c[g+4>>2];c[U+8>>2]=c[g+8>>2];c[U+12>>2]=c[g+12>>2];c[U+16>>2]=c[g+16>>2];c[U+20>>2]=c[g+20>>2];c[U+24>>2]=c[g+24>>2];b[U+28>>1]=b[g+28>>1]|0;N=U;O=H+1|0;break c}while(0);J=n+32|0;L=c[l>>2]|0;do if((q|0)==(L|0)){M=c[n>>2]|0;K=c[j>>2]|0;if((M|0)==(K|0)?(Q=b[n+28>>1]|0,R=b[m>>1]|0,Q<<16>>16!=R<<16>>16):0)if((Q&65535)>(R&65535)){V=J;break}else{t=33;break}if(M>>>0<K>>>0)V=J;else t=33}else if(q>>>0<L>>>0)V=J;else t=33;while(0);if((t|0)==33){t=0;if((J|0)==(j|0)){t=103;break a}L=n+28|0;K=n;M=J;f:while(1){R=c[M+24>>2]|0;do if((q|0)==(R|0)){Q=c[n>>2]|0;P=c[M>>2]|0;if((Q|0)==(P|0)?(T=b[L>>1]|0,S=b[M+28>>1]|0,T<<16>>16!=S<<16>>16):0)if((T&65535)>(S&65535)){W=M;break f}else break;if(Q>>>0<P>>>0){W=M;break f}}else if(q>>>0<R>>>0){W=M;break f}while(0);R=K+64|0;if((R|0)==(j|0)){t=103;break a}else{P=M;M=R;K=P}}c[g+0>>2]=c[W+0>>2];c[g+4>>2]=c[W+4>>2];c[g+8>>2]=c[W+8>>2];c[g+12>>2]=c[W+12>>2];c[g+16>>2]=c[W+16>>2];c[g+20>>2]=c[W+20>>2];c[g+24>>2]=c[W+24>>2];c[g+28>>2]=c[W+28>>2];c[W+0>>2]=c[j+0>>2];c[W+4>>2]=c[j+4>>2];c[W+8>>2]=c[j+8>>2];c[W+12>>2]=c[j+12>>2];c[W+16>>2]=c[j+16>>2];c[W+20>>2]=c[j+20>>2];c[W+24>>2]=c[j+24>>2];b[W+28>>1]=b[j+28>>1]|0;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];c[j+24>>2]=c[g+24>>2];b[j+28>>1]=b[g+28>>1]|0;V=W+32|0}if((V|0)==(j|0)){t=103;break a}K=n+28|0;M=V;L=j;while(1){J=c[p>>2]|0;P=M;g:while(1){R=c[P+24>>2]|0;do if((J|0)==(R|0)){Q=c[n>>2]|0;S=c[P>>2]|0;if((Q|0)==(S|0)?(T=b[K>>1]|0,X=b[P+28>>1]|0,T<<16>>16!=X<<16>>16):0)if((T&65535)>(X&65535)){Y=P;break g}else break;if(Q>>>0<S>>>0){Y=P;break g}}else if(J>>>0<R>>>0){Y=P;break g}while(0);P=P+32|0}P=L;while(1){R=P+-32|0;S=c[P+-8>>2]|0;if((J|0)!=(S|0))if(J>>>0<S>>>0){P=R;continue}else{Z=R;break}S=c[n>>2]|0;Q=c[R>>2]|0;if((S|0)==(Q|0)?(X=b[K>>1]|0,T=b[P+-4>>1]|0,X<<16>>16!=T<<16>>16):0)if((X&65535)>(T&65535)){P=R;continue}else{Z=R;break}if(S>>>0<Q>>>0)P=R;else{Z=R;break}}if(Y>>>0>=Z>>>0){n=Y;continue b};c[g+0>>2]=c[Y+0>>2];c[g+4>>2]=c[Y+4>>2];c[g+8>>2]=c[Y+8>>2];c[g+12>>2]=c[Y+12>>2];c[g+16>>2]=c[Y+16>>2];c[g+20>>2]=c[Y+20>>2];c[g+24>>2]=c[Y+24>>2];c[g+28>>2]=c[Y+28>>2];c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];c[Y+16>>2]=c[Z+16>>2];c[Y+20>>2]=c[Z+20>>2];c[Y+24>>2]=c[Z+24>>2];b[Y+28>>1]=b[Z+28>>1]|0;c[Z+0>>2]=c[g+0>>2];c[Z+4>>2]=c[g+4>>2];c[Z+8>>2]=c[g+8>>2];c[Z+12>>2]=c[g+12>>2];c[Z+16>>2]=c[g+16>>2];c[Z+20>>2]=c[g+20>>2];c[Z+24>>2]=c[g+24>>2];b[Z+28>>1]=b[g+28>>1]|0;M=Y+32|0;L=Z}}while(0);p=n+32|0;h:do if(p>>>0<N>>>0){q=p;I=N;F=G;L=O;while(1){M=c[F+24>>2]|0;K=F+28|0;P=q;i:while(1){J=c[P+24>>2]|0;do if((J|0)==(M|0)){R=c[P>>2]|0;Q=c[F>>2]|0;if((R|0)==(Q|0)?(S=b[P+28>>1]|0,T=b[K>>1]|0,S<<16>>16!=T<<16>>16):0)if((S&65535)>(T&65535))break;else{_=P;break i}if(R>>>0>=Q>>>0){_=P;break i}}else if(J>>>0>=M>>>0){_=P;break i}while(0);P=P+32|0}P=I;while(1){J=P+-32|0;Q=c[P+-8>>2]|0;if((Q|0)!=(M|0))if(Q>>>0<M>>>0){$=J;break}else{P=J;continue}Q=c[J>>2]|0;R=c[F>>2]|0;if((Q|0)==(R|0)?(T=b[P+-4>>1]|0,S=b[K>>1]|0,T<<16>>16!=S<<16>>16):0)if((T&65535)>(S&65535)){$=J;break}else{P=J;continue}if(Q>>>0<R>>>0){$=J;break}else P=J}if(_>>>0>$>>>0){aa=_;ba=F;ca=L;break h};c[g+0>>2]=c[_+0>>2];c[g+4>>2]=c[_+4>>2];c[g+8>>2]=c[_+8>>2];c[g+12>>2]=c[_+12>>2];c[g+16>>2]=c[_+16>>2];c[g+20>>2]=c[_+20>>2];c[g+24>>2]=c[_+24>>2];c[g+28>>2]=c[_+28>>2];c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];c[_+16>>2]=c[$+16>>2];c[_+20>>2]=c[$+20>>2];c[_+24>>2]=c[$+24>>2];b[_+28>>1]=b[$+28>>1]|0;c[$+0>>2]=c[g+0>>2];c[$+4>>2]=c[g+4>>2];c[$+8>>2]=c[g+8>>2];c[$+12>>2]=c[g+12>>2];c[$+16>>2]=c[g+16>>2];c[$+20>>2]=c[g+20>>2];c[$+24>>2]=c[g+24>>2];b[$+28>>1]=b[g+28>>1]|0;q=_+32|0;I=$;F=(F|0)==(_|0)?$:F;L=L+1|0}}else{aa=p;ba=G;ca=O}while(0);j:do if((aa|0)==(ba|0))da=ca;else{G=c[ba+24>>2]|0;p=c[aa+24>>2]|0;do if((G|0)==(p|0)){L=c[ba>>2]|0;F=c[aa>>2]|0;if((L|0)==(F|0)?(I=b[ba+28>>1]|0,q=b[aa+28>>1]|0,I<<16>>16!=q<<16>>16):0)if((I&65535)>(q&65535))break;else{da=ca;break j}if(L>>>0>=F>>>0){da=ca;break j}}else if(G>>>0>=p>>>0){da=ca;break j}while(0);c[g+0>>2]=c[aa+0>>2];c[g+4>>2]=c[aa+4>>2];c[g+8>>2]=c[aa+8>>2];c[g+12>>2]=c[aa+12>>2];c[g+16>>2]=c[aa+16>>2];c[g+20>>2]=c[aa+20>>2];c[g+24>>2]=c[aa+24>>2];c[g+28>>2]=c[aa+28>>2];c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];c[aa+12>>2]=c[ba+12>>2];c[aa+16>>2]=c[ba+16>>2];c[aa+20>>2]=c[ba+20>>2];c[aa+24>>2]=c[ba+24>>2];b[aa+28>>1]=b[ba+28>>1]|0;c[ba+0>>2]=c[g+0>>2];c[ba+4>>2]=c[g+4>>2];c[ba+8>>2]=c[g+8>>2];c[ba+12>>2]=c[g+12>>2];c[ba+16>>2]=c[g+16>>2];c[ba+20>>2]=c[g+20>>2];c[ba+24>>2]=c[g+24>>2];b[ba+28>>1]=b[g+28>>1]|0;da=ca+1|0}while(0);if(!da){ea=H_b(n,aa,e)|0;p=aa+32|0;if(H_b(p,a,e)|0){t=98;break}if(ea){n=p;continue}}p=aa;if((p-o|0)>=(d-p|0)){fa=n;ga=aa;t=102;break}B_b(n,aa,e);n=aa+32|0}if((t|0)==98){t=0;if(ea){t=103;break}else{h=n;a=aa;continue}}else if((t|0)==102){t=0;B_b(ga+32|0,a,e);h=fa;a=ga;continue}}if((t|0)==4){ga=c[x>>2]|0;x=c[w+24>>2]|0;do if((ga|0)==(x|0)){a=c[y>>2]|0;fa=c[w>>2]|0;if((a|0)==(fa|0)?(h=b[z>>1]|0,aa=b[w+28>>1]|0,h<<16>>16!=aa<<16>>16):0){if((h&65535)>(aa&65535))break;i=f;return}if(a>>>0>=fa>>>0){i=f;return}}else if(ga>>>0>=x>>>0){i=f;return}while(0);c[g+0>>2]=c[w+0>>2];c[g+4>>2]=c[w+4>>2];c[g+8>>2]=c[w+8>>2];c[g+12>>2]=c[w+12>>2];c[g+16>>2]=c[w+16>>2];c[g+20>>2]=c[w+20>>2];c[g+24>>2]=c[w+24>>2];c[g+28>>2]=c[w+28>>2];c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];c[w+12>>2]=c[A+12>>2];c[w+16>>2]=c[A+16>>2];c[w+20>>2]=c[A+20>>2];c[w+24>>2]=c[A+24>>2];b[w+28>>1]=b[A+28>>1]|0;c[A+0>>2]=c[g+0>>2];c[A+4>>2]=c[g+4>>2];c[A+8>>2]=c[g+8>>2];c[A+12>>2]=c[g+12>>2];c[A+16>>2]=c[g+16>>2];c[A+20>>2]=c[g+20>>2];c[A+24>>2]=c[g+24>>2];b[A+28>>1]=b[g+28>>1]|0;i=f;return}else if((t|0)==11){D_b(B,B+32|0,C,e)|0;i=f;return}else if((t|0)==12){E_b(r,r+32|0,r+64|0,s,e)|0;i=f;return}else if((t|0)==13){F_b(u,u+32|0,u+64|0,u+96|0,v,e)|0;i=f;return}else if((t|0)==15){G_b(D,E,e);i=f;return}else if((t|0)==103){i=f;return}}function C_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;f=i;i=i+64|0;g=f+32|0;h=f;j=a;a=d;a:while(1){d=a;k=a+-32|0;l=j;b:while(1){m=l;n=d-m|0;o=n>>5;switch(o|0){case 4:{p=l;q=k;r=14;break a;break}case 3:{s=l;t=k;u=k;r=6;break a;break}case 5:{v=l;w=k;x=k;r=15;break a;break}case 2:{y=l;z=k;A=k;r=4;break a;break}case 1:case 0:{r=84;break a;break}default:{}}if((n|0)<992){B=l;C=a;r=21;break a}D=(o|0)/2|0;E=l+(D<<5)|0;do if((n|0)>31968){F=(o|0)/4|0;G=l+(F<<5)|0;H=l+(F+D<<5)|0;F=I_b(l,G,E,H,e)|0;if((c[k>>2]|0)>>>0>=(c[H>>2]|0)>>>0){I=E;J=F;break};c[g+0>>2]=c[H+0>>2];c[g+4>>2]=c[H+4>>2];c[g+8>>2]=c[H+8>>2];c[g+12>>2]=c[H+12>>2];c[g+16>>2]=c[H+16>>2];c[g+20>>2]=c[H+20>>2];c[g+24>>2]=c[H+24>>2];c[g+28>>2]=c[H+28>>2];c[H+0>>2]=c[k+0>>2];c[H+4>>2]=c[k+4>>2];c[H+8>>2]=c[k+8>>2];c[H+12>>2]=c[k+12>>2];c[H+16>>2]=c[k+16>>2];c[H+20>>2]=c[k+20>>2];c[H+24>>2]=c[k+24>>2];b[H+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;K=F+1|0;if((c[H>>2]|0)>>>0<(c[E>>2]|0)>>>0){c[g+0>>2]=c[E+0>>2];c[g+4>>2]=c[E+4>>2];c[g+8>>2]=c[E+8>>2];c[g+12>>2]=c[E+12>>2];c[g+16>>2]=c[E+16>>2];c[g+20>>2]=c[E+20>>2];c[g+24>>2]=c[E+24>>2];c[g+28>>2]=c[E+28>>2];c[E+0>>2]=c[H+0>>2];c[E+4>>2]=c[H+4>>2];c[E+8>>2]=c[H+8>>2];c[E+12>>2]=c[H+12>>2];c[E+16>>2]=c[H+16>>2];c[E+20>>2]=c[H+20>>2];c[E+24>>2]=c[H+24>>2];b[E+28>>1]=b[H+28>>1]|0;c[H+0>>2]=c[g+0>>2];c[H+4>>2]=c[g+4>>2];c[H+8>>2]=c[g+8>>2];c[H+12>>2]=c[g+12>>2];c[H+16>>2]=c[g+16>>2];c[H+20>>2]=c[g+20>>2];c[H+24>>2]=c[g+24>>2];b[H+28>>1]=b[g+28>>1]|0;H=F+2|0;if((c[E>>2]|0)>>>0<(c[G>>2]|0)>>>0){c[g+0>>2]=c[G+0>>2];c[g+4>>2]=c[G+4>>2];c[g+8>>2]=c[G+8>>2];c[g+12>>2]=c[G+12>>2];c[g+16>>2]=c[G+16>>2];c[g+20>>2]=c[G+20>>2];c[g+24>>2]=c[G+24>>2];c[g+28>>2]=c[G+28>>2];c[G+0>>2]=c[E+0>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];c[G+12>>2]=c[E+12>>2];c[G+16>>2]=c[E+16>>2];c[G+20>>2]=c[E+20>>2];c[G+24>>2]=c[E+24>>2];b[G+28>>1]=b[E+28>>1]|0;c[E+0>>2]=c[g+0>>2];c[E+4>>2]=c[g+4>>2];c[E+8>>2]=c[g+8>>2];c[E+12>>2]=c[g+12>>2];c[E+16>>2]=c[g+16>>2];c[E+20>>2]=c[g+20>>2];c[E+24>>2]=c[g+24>>2];b[E+28>>1]=b[g+28>>1]|0;if((c[G>>2]|0)>>>0<(c[l>>2]|0)>>>0){c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];c[g+24>>2]=c[l+24>>2];c[g+28>>2]=c[l+28>>2];c[l+0>>2]=c[G+0>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];c[l+12>>2]=c[G+12>>2];c[l+16>>2]=c[G+16>>2];c[l+20>>2]=c[G+20>>2];c[l+24>>2]=c[G+24>>2];b[l+28>>1]=b[G+28>>1]|0;c[G+0>>2]=c[g+0>>2];c[G+4>>2]=c[g+4>>2];c[G+8>>2]=c[g+8>>2];c[G+12>>2]=c[g+12>>2];c[G+16>>2]=c[g+16>>2];c[G+20>>2]=c[g+20>>2];c[G+24>>2]=c[g+24>>2];b[G+28>>1]=b[g+28>>1]|0;I=E;J=F+4|0}else{I=E;J=F+3|0}}else{I=E;J=H}}else{I=E;J=K}}else{K=c[E>>2]|0;H=(c[k>>2]|0)>>>0<K>>>0;if(K>>>0>=(c[l>>2]|0)>>>0){if(!H){I=E;J=0;break};c[g+0>>2]=c[E+0>>2];c[g+4>>2]=c[E+4>>2];c[g+8>>2]=c[E+8>>2];c[g+12>>2]=c[E+12>>2];c[g+16>>2]=c[E+16>>2];c[g+20>>2]=c[E+20>>2];c[g+24>>2]=c[E+24>>2];c[g+28>>2]=c[E+28>>2];c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[E+12>>2]=c[k+12>>2];c[E+16>>2]=c[k+16>>2];c[E+20>>2]=c[k+20>>2];c[E+24>>2]=c[k+24>>2];b[E+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;if((c[E>>2]|0)>>>0>=(c[l>>2]|0)>>>0){I=E;J=1;break};c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];c[g+24>>2]=c[l+24>>2];c[g+28>>2]=c[l+28>>2];c[l+0>>2]=c[E+0>>2];c[l+4>>2]=c[E+4>>2];c[l+8>>2]=c[E+8>>2];c[l+12>>2]=c[E+12>>2];c[l+16>>2]=c[E+16>>2];c[l+20>>2]=c[E+20>>2];c[l+24>>2]=c[E+24>>2];b[l+28>>1]=b[E+28>>1]|0;c[E+0>>2]=c[g+0>>2];c[E+4>>2]=c[g+4>>2];c[E+8>>2]=c[g+8>>2];c[E+12>>2]=c[g+12>>2];c[E+16>>2]=c[g+16>>2];c[E+20>>2]=c[g+20>>2];c[E+24>>2]=c[g+24>>2];b[E+28>>1]=b[g+28>>1]|0;I=E;J=2;break}if(H){c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];c[g+24>>2]=c[l+24>>2];c[g+28>>2]=c[l+28>>2];c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[l+16>>2]=c[k+16>>2];c[l+20>>2]=c[k+20>>2];c[l+24>>2]=c[k+24>>2];b[l+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;I=E;J=1;break};c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];c[g+24>>2]=c[l+24>>2];c[g+28>>2]=c[l+28>>2];c[l+0>>2]=c[E+0>>2];c[l+4>>2]=c[E+4>>2];c[l+8>>2]=c[E+8>>2];c[l+12>>2]=c[E+12>>2];c[l+16>>2]=c[E+16>>2];c[l+20>>2]=c[E+20>>2];c[l+24>>2]=c[E+24>>2];b[l+28>>1]=b[E+28>>1]|0;c[E+0>>2]=c[g+0>>2];c[E+4>>2]=c[g+4>>2];c[E+8>>2]=c[g+8>>2];c[E+12>>2]=c[g+12>>2];c[E+16>>2]=c[g+16>>2];c[E+20>>2]=c[g+20>>2];c[E+24>>2]=c[g+24>>2];b[E+28>>1]=b[g+28>>1]|0;if((c[k>>2]|0)>>>0<(c[E>>2]|0)>>>0){c[g+0>>2]=c[E+0>>2];c[g+4>>2]=c[E+4>>2];c[g+8>>2]=c[E+8>>2];c[g+12>>2]=c[E+12>>2];c[g+16>>2]=c[E+16>>2];c[g+20>>2]=c[E+20>>2];c[g+24>>2]=c[E+24>>2];c[g+28>>2]=c[E+28>>2];c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[E+12>>2]=c[k+12>>2];c[E+16>>2]=c[k+16>>2];c[E+20>>2]=c[k+20>>2];c[E+24>>2]=c[k+24>>2];b[E+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;I=E;J=2}else{I=E;J=1}}while(0);D=c[l>>2]|0;o=c[I>>2]|0;do if(D>>>0<o>>>0){L=k;M=J}else{n=a;H=k;while(1){K=n+-64|0;if((l|0)==(K|0))break;if((c[K>>2]|0)>>>0<o>>>0){N=K;r=66;break}else{F=H;H=K;n=F}}if((r|0)==66){r=0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];c[g+24>>2]=c[l+24>>2];c[g+28>>2]=c[l+28>>2];c[l+0>>2]=c[N+0>>2];c[l+4>>2]=c[N+4>>2];c[l+8>>2]=c[N+8>>2];c[l+12>>2]=c[N+12>>2];c[l+16>>2]=c[N+16>>2];c[l+20>>2]=c[N+20>>2];c[l+24>>2]=c[N+24>>2];b[l+28>>1]=b[N+28>>1]|0;c[N+0>>2]=c[g+0>>2];c[N+4>>2]=c[g+4>>2];c[N+8>>2]=c[g+8>>2];c[N+12>>2]=c[g+12>>2];c[N+16>>2]=c[g+16>>2];c[N+20>>2]=c[g+20>>2];c[N+24>>2]=c[g+24>>2];b[N+28>>1]=b[g+28>>1]|0;L=N;M=J+1|0;break}n=l+32|0;if(D>>>0<(c[k>>2]|0)>>>0)O=n;else{if((n|0)==(k|0)){r=84;break a}else{P=l;Q=n}while(1){n=P+64|0;if(D>>>0<(c[Q>>2]|0)>>>0){R=Q;break}if((n|0)==(k|0)){r=84;break a}else{H=Q;Q=n;P=H}}c[g+0>>2]=c[R+0>>2];c[g+4>>2]=c[R+4>>2];c[g+8>>2]=c[R+8>>2];c[g+12>>2]=c[R+12>>2];c[g+16>>2]=c[R+16>>2];c[g+20>>2]=c[R+20>>2];c[g+24>>2]=c[R+24>>2];c[g+28>>2]=c[R+28>>2];c[R+0>>2]=c[k+0>>2];c[R+4>>2]=c[k+4>>2];c[R+8>>2]=c[k+8>>2];c[R+12>>2]=c[k+12>>2];c[R+16>>2]=c[k+16>>2];c[R+20>>2]=c[k+20>>2];c[R+24>>2]=c[k+24>>2];b[R+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;O=R+32|0}if((O|0)==(k|0)){r=84;break a}else{S=O;T=k}while(1){H=c[l>>2]|0;n=S;while(1){F=n+32|0;if(H>>>0<(c[n>>2]|0)>>>0){U=F;V=n;break}else n=F}n=T;while(1){F=n+-32|0;if(H>>>0<(c[F>>2]|0)>>>0)n=F;else{W=F;break}}if(V>>>0>=W>>>0){l=V;continue b};c[g+0>>2]=c[V+0>>2];c[g+4>>2]=c[V+4>>2];c[g+8>>2]=c[V+8>>2];c[g+12>>2]=c[V+12>>2];c[g+16>>2]=c[V+16>>2];c[g+20>>2]=c[V+20>>2];c[g+24>>2]=c[V+24>>2];c[g+28>>2]=c[V+28>>2];c[V+0>>2]=c[W+0>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];c[V+12>>2]=c[W+12>>2];c[V+16>>2]=c[W+16>>2];c[V+20>>2]=c[W+20>>2];c[V+24>>2]=c[W+24>>2];b[V+28>>1]=b[W+28>>1]|0;c[W+0>>2]=c[g+0>>2];c[W+4>>2]=c[g+4>>2];c[W+8>>2]=c[g+8>>2];c[W+12>>2]=c[g+12>>2];c[W+16>>2]=c[g+16>>2];c[W+20>>2]=c[g+20>>2];c[W+24>>2]=c[g+24>>2];b[W+28>>1]=b[g+28>>1]|0;S=U;T=W}}while(0);D=l+32|0;c:do if(D>>>0<L>>>0){o=D;n=L;H=E;F=M;while(1){K=c[H>>2]|0;G=o;while(1){X=G+32|0;if((c[G>>2]|0)>>>0<K>>>0)G=X;else{Y=X;Z=G;break}}G=n;while(1){X=G+-32|0;if((c[X>>2]|0)>>>0<K>>>0){_=X;break}else G=X}if(Z>>>0>_>>>0){$=Z;aa=H;ba=F;break c};c[g+0>>2]=c[Z+0>>2];c[g+4>>2]=c[Z+4>>2];c[g+8>>2]=c[Z+8>>2];c[g+12>>2]=c[Z+12>>2];c[g+16>>2]=c[Z+16>>2];c[g+20>>2]=c[Z+20>>2];c[g+24>>2]=c[Z+24>>2];c[g+28>>2]=c[Z+28>>2];c[Z+0>>2]=c[_+0>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];c[Z+12>>2]=c[_+12>>2];c[Z+16>>2]=c[_+16>>2];c[Z+20>>2]=c[_+20>>2];c[Z+24>>2]=c[_+24>>2];b[Z+28>>1]=b[_+28>>1]|0;c[_+0>>2]=c[g+0>>2];c[_+4>>2]=c[g+4>>2];c[_+8>>2]=c[g+8>>2];c[_+12>>2]=c[g+12>>2];c[_+16>>2]=c[g+16>>2];c[_+20>>2]=c[g+20>>2];c[_+24>>2]=c[g+24>>2];b[_+28>>1]=b[g+28>>1]|0;o=Y;n=_;H=(H|0)==(Z|0)?_:H;F=F+1|0}}else{$=D;aa=E;ba=M}while(0);if(($|0)!=(aa|0)?(c[aa>>2]|0)>>>0<(c[$>>2]|0)>>>0:0){c[g+0>>2]=c[$+0>>2];c[g+4>>2]=c[$+4>>2];c[g+8>>2]=c[$+8>>2];c[g+12>>2]=c[$+12>>2];c[g+16>>2]=c[$+16>>2];c[g+20>>2]=c[$+20>>2];c[g+24>>2]=c[$+24>>2];c[g+28>>2]=c[$+28>>2];c[$+0>>2]=c[aa+0>>2];c[$+4>>2]=c[aa+4>>2];c[$+8>>2]=c[aa+8>>2];c[$+12>>2]=c[aa+12>>2];c[$+16>>2]=c[aa+16>>2];c[$+20>>2]=c[aa+20>>2];c[$+24>>2]=c[aa+24>>2];b[$+28>>1]=b[aa+28>>1]|0;c[aa+0>>2]=c[g+0>>2];c[aa+4>>2]=c[g+4>>2];c[aa+8>>2]=c[g+8>>2];c[aa+12>>2]=c[g+12>>2];c[aa+16>>2]=c[g+16>>2];c[aa+20>>2]=c[g+20>>2];c[aa+24>>2]=c[g+24>>2];b[aa+28>>1]=b[g+28>>1]|0;ca=ba+1|0}else ca=ba;if(!ca){da=J_b(l,$,e)|0;E=$+32|0;if(J_b(E,a,e)|0){r=79;break}if(da){l=E;continue}}E=$;if((E-m|0)>=(d-E|0)){ea=l;fa=$;r=83;break}C_b(l,$,e);l=$+32|0}if((r|0)==79){r=0;if(da){r=84;break}else{j=l;a=$;continue}}else if((r|0)==83){r=0;C_b(fa+32|0,a,e);j=ea;a=fa;continue}}if((r|0)==4){if((c[z>>2]|0)>>>0>=(c[y>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[y+0>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];c[g+12>>2]=c[y+12>>2];c[g+16>>2]=c[y+16>>2];c[g+20>>2]=c[y+20>>2];c[g+24>>2]=c[y+24>>2];c[g+28>>2]=c[y+28>>2];c[y+0>>2]=c[A+0>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];c[y+12>>2]=c[A+12>>2];c[y+16>>2]=c[A+16>>2];c[y+20>>2]=c[A+20>>2];c[y+24>>2]=c[A+24>>2];b[y+28>>1]=b[A+28>>1]|0;c[A+0>>2]=c[g+0>>2];c[A+4>>2]=c[g+4>>2];c[A+8>>2]=c[g+8>>2];c[A+12>>2]=c[g+12>>2];c[A+16>>2]=c[g+16>>2];c[A+20>>2]=c[g+20>>2];c[A+24>>2]=c[g+24>>2];b[A+28>>1]=b[g+28>>1]|0;i=f;return}else if((r|0)==6){A=s+32|0;y=c[A>>2]|0;z=(c[t>>2]|0)>>>0<y>>>0;if(y>>>0>=(c[s>>2]|0)>>>0){if(!z){i=f;return};c[g+0>>2]=c[A+0>>2];c[g+4>>2]=c[A+4>>2];c[g+8>>2]=c[A+8>>2];c[g+12>>2]=c[A+12>>2];c[g+16>>2]=c[A+16>>2];c[g+20>>2]=c[A+20>>2];c[g+24>>2]=c[A+24>>2];c[g+28>>2]=c[A+28>>2];c[A+0>>2]=c[u+0>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];c[A+12>>2]=c[u+12>>2];c[A+16>>2]=c[u+16>>2];c[A+20>>2]=c[u+20>>2];c[A+24>>2]=c[u+24>>2];b[A+28>>1]=b[u+28>>1]|0;c[u+0>>2]=c[g+0>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];c[u+12>>2]=c[g+12>>2];c[u+16>>2]=c[g+16>>2];c[u+20>>2]=c[g+20>>2];c[u+24>>2]=c[g+24>>2];b[u+28>>1]=b[g+28>>1]|0;if((c[A>>2]|0)>>>0>=(c[s>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];c[g+16>>2]=c[s+16>>2];c[g+20>>2]=c[s+20>>2];c[g+24>>2]=c[s+24>>2];c[g+28>>2]=c[s+28>>2];c[s+0>>2]=c[A+0>>2];c[s+4>>2]=c[A+4>>2];c[s+8>>2]=c[A+8>>2];c[s+12>>2]=c[A+12>>2];c[s+16>>2]=c[A+16>>2];c[s+20>>2]=c[A+20>>2];c[s+24>>2]=c[A+24>>2];b[s+28>>1]=b[A+28>>1]|0;c[A+0>>2]=c[g+0>>2];c[A+4>>2]=c[g+4>>2];c[A+8>>2]=c[g+8>>2];c[A+12>>2]=c[g+12>>2];c[A+16>>2]=c[g+16>>2];c[A+20>>2]=c[g+20>>2];c[A+24>>2]=c[g+24>>2];b[A+28>>1]=b[g+28>>1]|0;i=f;return}if(z){c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];c[g+16>>2]=c[s+16>>2];c[g+20>>2]=c[s+20>>2];c[g+24>>2]=c[s+24>>2];c[g+28>>2]=c[s+28>>2];c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];c[s+24>>2]=c[u+24>>2];b[s+28>>1]=b[u+28>>1]|0;c[u+0>>2]=c[g+0>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];c[u+12>>2]=c[g+12>>2];c[u+16>>2]=c[g+16>>2];c[u+20>>2]=c[g+20>>2];c[u+24>>2]=c[g+24>>2];b[u+28>>1]=b[g+28>>1]|0;i=f;return};c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];c[g+16>>2]=c[s+16>>2];c[g+20>>2]=c[s+20>>2];c[g+24>>2]=c[s+24>>2];c[g+28>>2]=c[s+28>>2];c[s+0>>2]=c[A+0>>2];c[s+4>>2]=c[A+4>>2];c[s+8>>2]=c[A+8>>2];c[s+12>>2]=c[A+12>>2];c[s+16>>2]=c[A+16>>2];c[s+20>>2]=c[A+20>>2];c[s+24>>2]=c[A+24>>2];b[s+28>>1]=b[A+28>>1]|0;c[A+0>>2]=c[g+0>>2];c[A+4>>2]=c[g+4>>2];c[A+8>>2]=c[g+8>>2];c[A+12>>2]=c[g+12>>2];c[A+16>>2]=c[g+16>>2];c[A+20>>2]=c[g+20>>2];c[A+24>>2]=c[g+24>>2];b[A+28>>1]=b[g+28>>1]|0;if((c[t>>2]|0)>>>0>=(c[A>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[A+0>>2];c[g+4>>2]=c[A+4>>2];c[g+8>>2]=c[A+8>>2];c[g+12>>2]=c[A+12>>2];c[g+16>>2]=c[A+16>>2];c[g+20>>2]=c[A+20>>2];c[g+24>>2]=c[A+24>>2];c[g+28>>2]=c[A+28>>2];c[A+0>>2]=c[u+0>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];c[A+12>>2]=c[u+12>>2];c[A+16>>2]=c[u+16>>2];c[A+20>>2]=c[u+20>>2];c[A+24>>2]=c[u+24>>2];b[A+28>>1]=b[u+28>>1]|0;c[u+0>>2]=c[g+0>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];c[u+12>>2]=c[g+12>>2];c[u+16>>2]=c[g+16>>2];c[u+20>>2]=c[g+20>>2];c[u+24>>2]=c[g+24>>2];b[u+28>>1]=b[g+28>>1]|0;i=f;return}else if((r|0)==14){I_b(p,p+32|0,p+64|0,q,e)|0;i=f;return}else if((r|0)==15){q=v+32|0;p=v+64|0;u=v+96|0;I_b(v,q,p,u,e)|0;if((c[w>>2]|0)>>>0>=(c[u>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[u+0>>2];c[g+4>>2]=c[u+4>>2];c[g+8>>2]=c[u+8>>2];c[g+12>>2]=c[u+12>>2];c[g+16>>2]=c[u+16>>2];c[g+20>>2]=c[u+20>>2];c[g+24>>2]=c[u+24>>2];c[g+28>>2]=c[u+28>>2];c[u+0>>2]=c[x+0>>2];c[u+4>>2]=c[x+4>>2];c[u+8>>2]=c[x+8>>2];c[u+12>>2]=c[x+12>>2];c[u+16>>2]=c[x+16>>2];c[u+20>>2]=c[x+20>>2];c[u+24>>2]=c[x+24>>2];b[u+28>>1]=b[x+28>>1]|0;c[x+0>>2]=c[g+0>>2];c[x+4>>2]=c[g+4>>2];c[x+8>>2]=c[g+8>>2];c[x+12>>2]=c[g+12>>2];c[x+16>>2]=c[g+16>>2];c[x+20>>2]=c[g+20>>2];c[x+24>>2]=c[g+24>>2];b[x+28>>1]=b[g+28>>1]|0;if((c[u>>2]|0)>>>0>=(c[p>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[p+0>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];c[g+16>>2]=c[p+16>>2];c[g+20>>2]=c[p+20>>2];c[g+24>>2]=c[p+24>>2];c[g+28>>2]=c[p+28>>2];c[p+0>>2]=c[u+0>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];c[p+16>>2]=c[u+16>>2];c[p+20>>2]=c[u+20>>2];c[p+24>>2]=c[u+24>>2];b[p+28>>1]=b[u+28>>1]|0;c[u+0>>2]=c[g+0>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];c[u+12>>2]=c[g+12>>2];c[u+16>>2]=c[g+16>>2];c[u+20>>2]=c[g+20>>2];c[u+24>>2]=c[g+24>>2];b[u+28>>1]=b[g+28>>1]|0;if((c[p>>2]|0)>>>0>=(c[q>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];c[g+16>>2]=c[q+16>>2];c[g+20>>2]=c[q+20>>2];c[g+24>>2]=c[q+24>>2];c[g+28>>2]=c[q+28>>2];c[q+0>>2]=c[p+0>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[q+12>>2]=c[p+12>>2];c[q+16>>2]=c[p+16>>2];c[q+20>>2]=c[p+20>>2];c[q+24>>2]=c[p+24>>2];b[q+28>>1]=b[p+28>>1]|0;c[p+0>>2]=c[g+0>>2];c[p+4>>2]=c[g+4>>2];c[p+8>>2]=c[g+8>>2];c[p+12>>2]=c[g+12>>2];c[p+16>>2]=c[g+16>>2];c[p+20>>2]=c[g+20>>2];c[p+24>>2]=c[g+24>>2];b[p+28>>1]=b[g+28>>1]|0;if((c[q>>2]|0)>>>0>=(c[v>>2]|0)>>>0){i=f;return};c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];c[g+16>>2]=c[v+16>>2];c[g+20>>2]=c[v+20>>2];c[g+24>>2]=c[v+24>>2];c[g+28>>2]=c[v+28>>2];c[v+0>>2]=c[q+0>>2];c[v+4>>2]=c[q+4>>2];c[v+8>>2]=c[q+8>>2];c[v+12>>2]=c[q+12>>2];c[v+16>>2]=c[q+16>>2];c[v+20>>2]=c[q+20>>2];c[v+24>>2]=c[q+24>>2];b[v+28>>1]=b[q+28>>1]|0;c[q+0>>2]=c[g+0>>2];c[q+4>>2]=c[g+4>>2];c[q+8>>2]=c[g+8>>2];c[q+12>>2]=c[g+12>>2];c[q+16>>2]=c[g+16>>2];c[q+20>>2]=c[g+20>>2];c[q+24>>2]=c[g+24>>2];b[q+28>>1]=b[g+28>>1]|0;i=f;return}else if((r|0)==21){q=B+64|0;v=B+32|0;p=c[v>>2]|0;u=c[B>>2]|0;x=c[q>>2]|0;w=x>>>0<p>>>0;do if(p>>>0<u>>>0){if(w){c[g+0>>2]=c[B+0>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];c[g+16>>2]=c[B+16>>2];c[g+20>>2]=c[B+20>>2];c[g+24>>2]=c[B+24>>2];c[g+28>>2]=c[B+28>>2];c[B+0>>2]=c[q+0>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2];c[B+12>>2]=c[q+12>>2];c[B+16>>2]=c[q+16>>2];c[B+20>>2]=c[q+20>>2];c[B+24>>2]=c[q+24>>2];b[B+28>>1]=b[q+28>>1]|0;c[q+0>>2]=c[g+0>>2];c[q+4>>2]=c[g+4>>2];c[q+8>>2]=c[g+8>>2];c[q+12>>2]=c[g+12>>2];c[q+16>>2]=c[g+16>>2];c[q+20>>2]=c[g+20>>2];c[q+24>>2]=c[g+24>>2];b[q+28>>1]=b[g+28>>1]|0;break};c[g+0>>2]=c[B+0>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];c[g+16>>2]=c[B+16>>2];c[g+20>>2]=c[B+20>>2];c[g+24>>2]=c[B+24>>2];c[g+28>>2]=c[B+28>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];c[B+16>>2]=c[v+16>>2];c[B+20>>2]=c[v+20>>2];c[B+24>>2]=c[v+24>>2];b[B+28>>1]=b[v+28>>1]|0;c[v+0>>2]=c[g+0>>2];c[v+4>>2]=c[g+4>>2];c[v+8>>2]=c[g+8>>2];c[v+12>>2]=c[g+12>>2];c[v+16>>2]=c[g+16>>2];c[v+20>>2]=c[g+20>>2];c[v+24>>2]=c[g+24>>2];b[v+28>>1]=b[g+28>>1]|0;if(x>>>0<(c[v>>2]|0)>>>0){c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];c[g+16>>2]=c[v+16>>2];c[g+20>>2]=c[v+20>>2];c[g+24>>2]=c[v+24>>2];c[g+28>>2]=c[v+28>>2];c[v+0>>2]=c[q+0>>2];c[v+4>>2]=c[q+4>>2];c[v+8>>2]=c[q+8>>2];c[v+12>>2]=c[q+12>>2];c[v+16>>2]=c[q+16>>2];c[v+20>>2]=c[q+20>>2];c[v+24>>2]=c[q+24>>2];b[v+28>>1]=b[q+28>>1]|0;c[q+0>>2]=c[g+0>>2];c[q+4>>2]=c[g+4>>2];c[q+8>>2]=c[g+8>>2];c[q+12>>2]=c[g+12>>2];c[q+16>>2]=c[g+16>>2];c[q+20>>2]=c[g+20>>2];c[q+24>>2]=c[g+24>>2];b[q+28>>1]=b[g+28>>1]|0}}else if(w?(c[g+0>>2]=c[v+0>>2],c[g+4>>2]=c[v+4>>2],c[g+8>>2]=c[v+8>>2],c[g+12>>2]=c[v+12>>2],c[g+16>>2]=c[v+16>>2],c[g+20>>2]=c[v+20>>2],c[g+24>>2]=c[v+24>>2],c[g+28>>2]=c[v+28>>2],c[v+0>>2]=c[q+0>>2],c[v+4>>2]=c[q+4>>2],c[v+8>>2]=c[q+8>>2],c[v+12>>2]=c[q+12>>2],c[v+16>>2]=c[q+16>>2],c[v+20>>2]=c[q+20>>2],c[v+24>>2]=c[q+24>>2],b[v+28>>1]=b[q+28>>1]|0,c[q+0>>2]=c[g+0>>2],c[q+4>>2]=c[g+4>>2],c[q+8>>2]=c[g+8>>2],c[q+12>>2]=c[g+12>>2],c[q+16>>2]=c[g+16>>2],c[q+20>>2]=c[g+20>>2],c[q+24>>2]=c[g+24>>2],b[q+28>>1]=b[g+28>>1]|0,(c[v>>2]|0)>>>0<u>>>0):0){c[g+0>>2]=c[B+0>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];c[g+16>>2]=c[B+16>>2];c[g+20>>2]=c[B+20>>2];c[g+24>>2]=c[B+24>>2];c[g+28>>2]=c[B+28>>2];c[B+0>>2]=c[v+0>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];c[B+16>>2]=c[v+16>>2];c[B+20>>2]=c[v+20>>2];c[B+24>>2]=c[v+24>>2];b[B+28>>1]=b[v+28>>1]|0;c[v+0>>2]=c[g+0>>2];c[v+4>>2]=c[g+4>>2];c[v+8>>2]=c[g+8>>2];c[v+12>>2]=c[g+12>>2];c[v+16>>2]=c[g+16>>2];c[v+20>>2]=c[g+20>>2];c[v+24>>2]=c[g+24>>2];b[v+28>>1]=b[g+28>>1]|0}while(0);g=B+96|0;if((g|0)==(C|0)){i=f;return}else{ga=g;ha=q}while(1){q=c[ga>>2]|0;if(q>>>0<(c[ha>>2]|0)>>>0){g=ga+4|0;c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[h+12>>2]=c[g+12>>2];c[h+16>>2]=c[g+16>>2];c[h+20>>2]=c[g+20>>2];c[h+24>>2]=c[g+24>>2];g=ga;v=ha;while(1){c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];c[g+16>>2]=c[v+16>>2];c[g+20>>2]=c[v+20>>2];c[g+24>>2]=c[v+24>>2];b[g+28>>1]=b[v+28>>1]|0;if((v|0)==(B|0)){ia=B;break}u=v+-32|0;if(q>>>0<(c[u>>2]|0)>>>0){w=v;v=u;g=w}else{ia=v;break}}c[ia>>2]=q;v=ia+4|0;c[v+0>>2]=c[h+0>>2];c[v+4>>2]=c[h+4>>2];c[v+8>>2]=c[h+8>>2];c[v+12>>2]=c[h+12>>2];c[v+16>>2]=c[h+16>>2];c[v+20>>2]=c[h+20>>2];b[v+24>>1]=b[h+24>>1]|0}v=ga+32|0;if((v|0)==(C|0))break;else{g=ga;ga=v;ha=g}}i=f;return}else if((r|0)==84){i=f;return}}function D_b(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f;h=d+24|0;j=c[h>>2]|0;k=a+24|0;l=c[k>>2]|0;do if((j|0)==(l|0)){m=c[d>>2]|0;n=c[a>>2]|0;if((m|0)==(n|0)?(o=b[d+28>>1]|0,p=b[a+28>>1]|0,o<<16>>16!=p<<16>>16):0){q=(o&65535)>(p&65535);break}q=m>>>0<n>>>0}else q=j>>>0<l>>>0;while(0);l=e+24|0;n=c[l>>2]|0;do if((n|0)==(j|0)){m=c[e>>2]|0;p=c[d>>2]|0;if((m|0)==(p|0)?(o=b[e+28>>1]|0,r=b[d+28>>1]|0,o<<16>>16!=r<<16>>16):0){s=(o&65535)>(r&65535);break}s=m>>>0<p>>>0}else s=n>>>0<j>>>0;while(0);if(!q){if(!s){t=0;i=f;return t|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];c[g+20>>2]=c[d+20>>2];c[g+24>>2]=c[d+24>>2];c[g+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];c[e+24>>2]=c[g+24>>2];b[e+28>>1]=b[g+28>>1]|0;q=c[h>>2]|0;j=c[k>>2]|0;do if((q|0)==(j|0)){k=c[d>>2]|0;n=c[a>>2]|0;if((k|0)==(n|0)?(p=b[d+28>>1]|0,m=b[a+28>>1]|0,p<<16>>16!=m<<16>>16):0){if((p&65535)>(m&65535))break;else t=1;i=f;return t|0}if(k>>>0>=n>>>0){t=1;i=f;return t|0}}else if(q>>>0>=j>>>0){t=1;i=f;return t|0}while(0);c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];c[d+16>>2]=c[g+16>>2];c[d+20>>2]=c[g+20>>2];c[d+24>>2]=c[g+24>>2];b[d+28>>1]=b[g+28>>1]|0;t=2;i=f;return t|0}if(s){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];c[a+20>>2]=c[e+20>>2];c[a+24>>2]=c[e+24>>2];b[a+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];c[e+24>>2]=c[g+24>>2];b[e+28>>1]=b[g+28>>1]|0;t=1;i=f;return t|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];c[d+16>>2]=c[g+16>>2];c[d+20>>2]=c[g+20>>2];c[d+24>>2]=c[g+24>>2];b[d+28>>1]=b[g+28>>1]|0;a=c[l>>2]|0;l=c[h>>2]|0;do if((a|0)==(l|0)){h=c[e>>2]|0;s=c[d>>2]|0;if((h|0)==(s|0)?(j=b[e+28>>1]|0,q=b[d+28>>1]|0,j<<16>>16!=q<<16>>16):0){if((j&65535)>(q&65535))break;else t=1;i=f;return t|0}if(h>>>0>=s>>>0){t=1;i=f;return t|0}}else if(a>>>0>=l>>>0){t=1;i=f;return t|0}while(0);c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];c[g+20>>2]=c[d+20>>2];c[g+24>>2]=c[d+24>>2];c[g+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];c[e+24>>2]=c[g+24>>2];b[e+28>>1]=b[g+28>>1]|0;t=2;i=f;return t|0}function E_b(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h;k=D_b(a,d,e,g)|0;g=c[f+24>>2]|0;l=e+24|0;m=c[l>>2]|0;do if((g|0)==(m|0)){n=c[f>>2]|0;o=c[e>>2]|0;if((n|0)==(o|0)?(p=b[f+28>>1]|0,q=b[e+28>>1]|0,p<<16>>16!=q<<16>>16):0){if((p&65535)>(q&65535))break;else r=k;i=h;return r|0}if(n>>>0>=o>>>0){r=k;i=h;return r|0}}else if(g>>>0>=m>>>0){r=k;i=h;return r|0}while(0);c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[j+20>>2]=c[e+20>>2];c[j+24>>2]=c[e+24>>2];c[j+28>>2]=c[e+28>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];b[e+28>>1]=b[f+28>>1]|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];b[f+28>>1]=b[j+28>>1]|0;f=k+1|0;m=c[l>>2]|0;l=d+24|0;g=c[l>>2]|0;do if((m|0)==(g|0)){o=c[e>>2]|0;n=c[d>>2]|0;if((o|0)==(n|0)?(q=b[e+28>>1]|0,p=b[d+28>>1]|0,q<<16>>16!=p<<16>>16):0){if((q&65535)>(p&65535))break;else r=f;i=h;return r|0}if(o>>>0>=n>>>0){r=f;i=h;return r|0}}else if(m>>>0>=g>>>0){r=f;i=h;return r|0}while(0);c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];c[j+24>>2]=c[d+24>>2];c[j+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];c[e+20>>2]=c[j+20>>2];c[e+24>>2]=c[j+24>>2];b[e+28>>1]=b[j+28>>1]|0;e=k+2|0;f=c[l>>2]|0;l=c[a+24>>2]|0;do if((f|0)==(l|0)){g=c[d>>2]|0;m=c[a>>2]|0;if((g|0)==(m|0)?(n=b[d+28>>1]|0,o=b[a+28>>1]|0,n<<16>>16!=o<<16>>16):0){if((n&65535)>(o&65535))break;else r=e;i=h;return r|0}if(g>>>0>=m>>>0){r=e;i=h;return r|0}}else if(f>>>0>=l>>>0){r=e;i=h;return r|0}while(0);c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[j+20>>2]=c[a+20>>2];c[j+24>>2]=c[a+24>>2];c[j+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[d+16>>2]=c[j+16>>2];c[d+20>>2]=c[j+20>>2];c[d+24>>2]=c[j+24>>2];b[d+28>>1]=b[j+28>>1]|0;r=k+3|0;i=h;return r|0}function F_b(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+32|0;k=j;l=E_b(a,d,e,f,h)|0;h=c[g+24>>2]|0;m=f+24|0;n=c[m>>2]|0;do if((h|0)==(n|0)){o=c[g>>2]|0;p=c[f>>2]|0;if((o|0)==(p|0)?(q=b[g+28>>1]|0,r=b[f+28>>1]|0,q<<16>>16!=r<<16>>16):0){if((q&65535)>(r&65535))break;else s=l;i=j;return s|0}if(o>>>0>=p>>>0){s=l;i=j;return s|0}}else if(h>>>0>=n>>>0){s=l;i=j;return s|0}while(0);c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[k+16>>2]=c[f+16>>2];c[k+20>>2]=c[f+20>>2];c[k+24>>2]=c[f+24>>2];c[k+28>>2]=c[f+28>>2];c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];c[f+24>>2]=c[g+24>>2];b[f+28>>1]=b[g+28>>1]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];c[g+24>>2]=c[k+24>>2];b[g+28>>1]=b[k+28>>1]|0;g=l+1|0;n=c[m>>2]|0;m=e+24|0;h=c[m>>2]|0;do if((n|0)==(h|0)){p=c[f>>2]|0;o=c[e>>2]|0;if((p|0)==(o|0)?(r=b[f+28>>1]|0,q=b[e+28>>1]|0,r<<16>>16!=q<<16>>16):0){if((r&65535)>(q&65535))break;else s=g;i=j;return s|0}if(p>>>0>=o>>>0){s=g;i=j;return s|0}}else if(n>>>0>=h>>>0){s=g;i=j;return s|0}while(0);c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[k+16>>2]=c[e+16>>2];c[k+20>>2]=c[e+20>>2];c[k+24>>2]=c[e+24>>2];c[k+28>>2]=c[e+28>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];b[e+28>>1]=b[f+28>>1]|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2];c[f+20>>2]=c[k+20>>2];c[f+24>>2]=c[k+24>>2];b[f+28>>1]=b[k+28>>1]|0;f=l+2|0;g=c[m>>2]|0;m=d+24|0;h=c[m>>2]|0;do if((g|0)==(h|0)){n=c[e>>2]|0;o=c[d>>2]|0;if((n|0)==(o|0)?(p=b[e+28>>1]|0,q=b[d+28>>1]|0,p<<16>>16!=q<<16>>16):0){if((p&65535)>(q&65535))break;else s=f;i=j;return s|0}if(n>>>0>=o>>>0){s=f;i=j;return s|0}}else if(g>>>0>=h>>>0){s=f;i=j;return s|0}while(0);c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[k+16>>2]=c[d+16>>2];c[k+20>>2]=c[d+20>>2];c[k+24>>2]=c[d+24>>2];c[k+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[e+16>>2]=c[k+16>>2];c[e+20>>2]=c[k+20>>2];c[e+24>>2]=c[k+24>>2];b[e+28>>1]=b[k+28>>1]|0;e=l+3|0;f=c[m>>2]|0;m=c[a+24>>2]|0;do if((f|0)==(m|0)){h=c[d>>2]|0;g=c[a>>2]|0;if((h|0)==(g|0)?(o=b[d+28>>1]|0,n=b[a+28>>1]|0,o<<16>>16!=n<<16>>16):0){if((o&65535)>(n&65535))break;else s=e;i=j;return s|0}if(h>>>0>=g>>>0){s=e;i=j;return s|0}}else if(f>>>0>=m>>>0){s=e;i=j;return s|0}while(0);c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];c[k+16>>2]=c[a+16>>2];c[k+20>>2]=c[a+20>>2];c[k+24>>2]=c[a+24>>2];c[k+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];c[d+16>>2]=c[k+16>>2];c[d+20>>2]=c[k+20>>2];c[d+24>>2]=c[k+24>>2];b[d+28>>1]=b[k+28>>1]|0;s=l+4|0;i=j;return s|0}function G_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+32|0;g=f;h=a+64|0;D_b(a,a+32|0,h,e)|0;e=a+96|0;if((e|0)==(d|0)){i=f;return}j=e;e=h;while(1){h=j+24|0;k=c[h>>2]|0;l=c[e+24>>2]|0;do if((k|0)==(l|0)){m=c[j>>2]|0;n=c[e>>2]|0;if((m|0)==(n|0)?(o=b[j+28>>1]|0,p=b[e+28>>1]|0,o<<16>>16!=p<<16>>16):0)if((o&65535)>(p&65535)){q=m;r=10;break}else break;if(m>>>0<n>>>0){q=m;r=10}}else if(k>>>0<l>>>0){q=c[j>>2]|0;r=10}while(0);if((r|0)==10){r=0;l=j+4|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];l=c[h>>2]|0;k=b[j+28>>1]|0;c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[j+20>>2]=c[e+20>>2];c[j+24>>2]=c[e+24>>2];b[j+28>>1]=b[e+28>>1]|0;a:do if((e|0)==(a|0))s=a;else{m=e;while(1){n=m;m=m+-32|0;p=c[n+-8>>2]|0;do if((l|0)==(p|0)){o=c[m>>2]|0;if((q|0)==(o|0)?(t=b[n+-4>>1]|0,k<<16>>16!=t<<16>>16):0)if((k&65535)>(t&65535))break;else{s=n;break a}if(q>>>0>=o>>>0){s=n;break a}}else if(l>>>0>=p>>>0){s=n;break a}while(0);c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[n+16>>2]=c[m+16>>2];c[n+20>>2]=c[m+20>>2];c[n+24>>2]=c[m+24>>2];b[n+28>>1]=b[m+28>>1]|0;if((m|0)==(a|0)){s=a;break}}}while(0);c[s>>2]=q;h=s+4|0;c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[h+12>>2]=c[g+12>>2];c[h+16>>2]=c[g+16>>2];c[s+24>>2]=l;b[s+28>>1]=k}h=j+32|0;if((h|0)==(d|0))break;else{m=j;j=h;e=m}}i=f;return}function H_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+64|0;g=f+24|0;h=f;switch(d-a>>5|0){case 4:{E_b(a,a+32|0,a+64|0,d+-32|0,e)|0;j=1;i=f;return j|0}case 3:{D_b(a,a+32|0,d+-32|0,e)|0;j=1;i=f;return j|0}case 5:{F_b(a,a+32|0,a+64|0,a+96|0,d+-32|0,e)|0;j=1;i=f;return j|0}case 2:{k=d+-32|0;l=c[d+-8>>2]|0;m=c[a+24>>2]|0;do if((l|0)==(m|0)){n=c[k>>2]|0;o=c[a>>2]|0;if((n|0)==(o|0)?(p=b[d+-4>>1]|0,q=b[a+28>>1]|0,p<<16>>16!=q<<16>>16):0){if((p&65535)>(q&65535))break;else j=1;i=f;return j|0}if(n>>>0>=o>>>0){j=1;i=f;return j|0}}else if(l>>>0>=m>>>0){j=1;i=f;return j|0}while(0);c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];b[a+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;j=1;i=f;return j|0}case 1:case 0:{j=1;i=f;return j|0}default:{g=a+64|0;D_b(a,a+32|0,g,e)|0;e=a+96|0;if((e|0)==(d|0)){j=1;i=f;return j|0}k=0;m=e;e=g;while(1){g=m+24|0;l=c[g>>2]|0;o=c[e+24>>2]|0;do if((l|0)==(o|0)){n=c[m>>2]|0;q=c[e>>2]|0;if((n|0)==(q|0)?(p=b[m+28>>1]|0,r=b[e+28>>1]|0,p<<16>>16!=r<<16>>16):0)if((p&65535)>(r&65535)){s=n;t=21;break}else{u=k;break}if(n>>>0<q>>>0){s=n;t=21}else u=k}else if(l>>>0<o>>>0){s=c[m>>2]|0;t=21}else u=k;while(0);if((t|0)==21){t=0;o=m+4|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];c[h+16>>2]=c[o+16>>2];o=c[g>>2]|0;l=b[m+28>>1]|0;c[m+0>>2]=c[e+0>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];c[m+16>>2]=c[e+16>>2];c[m+20>>2]=c[e+20>>2];c[m+24>>2]=c[e+24>>2];b[m+28>>1]=b[e+28>>1]|0;a:do if((e|0)==(a|0))v=a;else{n=e;while(1){q=n;n=n+-32|0;r=c[q+-8>>2]|0;do if((o|0)==(r|0)){p=c[n>>2]|0;if((s|0)==(p|0)?(w=b[q+-4>>1]|0,l<<16>>16!=w<<16>>16):0)if((l&65535)>(w&65535))break;else{v=q;break a}if(s>>>0>=p>>>0){v=q;break a}}else if(o>>>0>=r>>>0){v=q;break a}while(0);c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[q+16>>2]=c[n+16>>2];c[q+20>>2]=c[n+20>>2];c[q+24>>2]=c[n+24>>2];b[q+28>>1]=b[n+28>>1]|0;if((n|0)==(a|0)){v=a;break}}}while(0);c[v>>2]=s;g=v+4|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[g+16>>2]=c[h+16>>2];c[v+24>>2]=o;b[v+28>>1]=l;g=k+1|0;if((g|0)==8){x=m;break}else u=g}g=m+32|0;if((g|0)==(d|0)){j=1;t=32;break}else{n=m;k=u;m=g;e=n}}if((t|0)==32){i=f;return j|0}j=(x+32|0)==(d|0);i=f;return j|0}}return 0}function I_b(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g;j=c[d>>2]|0;k=(c[e>>2]|0)>>>0<j>>>0;do if(j>>>0<(c[a>>2]|0)>>>0){if(k){c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];c[a+20>>2]=c[e+20>>2];c[a+24>>2]=c[e+24>>2];b[a+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];b[e+28>>1]=b[h+28>>1]|0;l=1;break};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];b[d+28>>1]=b[h+28>>1]|0;if((c[e>>2]|0)>>>0<(c[d>>2]|0)>>>0){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];b[e+28>>1]=b[h+28>>1]|0;l=2}else l=1}else if(k){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];b[e+28>>1]=b[h+28>>1]|0;if((c[d>>2]|0)>>>0<(c[a>>2]|0)>>>0){c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];b[d+28>>1]=b[h+28>>1]|0;l=2}else l=1}else l=0;while(0);if((c[f>>2]|0)>>>0>=(c[e>>2]|0)>>>0){m=l;i=g;return m|0};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[h+16>>2]=c[e+16>>2];c[h+20>>2]=c[e+20>>2];c[h+24>>2]=c[e+24>>2];c[h+28>>2]=c[e+28>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];b[e+28>>1]=b[f+28>>1]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];c[f+24>>2]=c[h+24>>2];b[f+28>>1]=b[h+28>>1]|0;if((c[e>>2]|0)>>>0>=(c[d>>2]|0)>>>0){m=l+1|0;i=g;return m|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];b[d+28>>1]=b[e+28>>1]|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];b[e+28>>1]=b[h+28>>1]|0;if((c[d>>2]|0)>>>0>=(c[a>>2]|0)>>>0){m=l+2|0;i=g;return m|0};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];b[a+28>>1]=b[d+28>>1]|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];b[d+28>>1]=b[h+28>>1]|0;m=l+3|0;i=g;return m|0}function J_b(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+64|0;g=f+32|0;h=f;switch(d-a>>5|0){case 3:{j=a+32|0;k=d+-32|0;l=c[j>>2]|0;m=(c[k>>2]|0)>>>0<l>>>0;if(l>>>0>=(c[a>>2]|0)>>>0){if(!m){n=1;i=f;return n|0};c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];b[j+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;if((c[j>>2]|0)>>>0>=(c[a>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[a+16>>2]=c[j+16>>2];c[a+20>>2]=c[j+20>>2];c[a+24>>2]=c[j+24>>2];b[a+28>>1]=b[j+28>>1]|0;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];c[j+24>>2]=c[g+24>>2];b[j+28>>1]=b[g+28>>1]|0;n=1;i=f;return n|0}if(m){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];b[a+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;n=1;i=f;return n|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[a+16>>2]=c[j+16>>2];c[a+20>>2]=c[j+20>>2];c[a+24>>2]=c[j+24>>2];b[a+28>>1]=b[j+28>>1]|0;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];c[j+24>>2]=c[g+24>>2];b[j+28>>1]=b[g+28>>1]|0;if((c[k>>2]|0)>>>0>=(c[j>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];b[j+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;n=1;i=f;return n|0}case 1:case 0:{n=1;i=f;return n|0}case 2:{k=d+-32|0;if((c[k>>2]|0)>>>0>=(c[a>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];b[a+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;n=1;i=f;return n|0}case 4:{I_b(a,a+32|0,a+64|0,d+-32|0,e)|0;n=1;i=f;return n|0}case 5:{k=a+32|0;j=a+64|0;m=a+96|0;l=d+-32|0;I_b(a,k,j,m,e)|0;if((c[l>>2]|0)>>>0>=(c[m>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[g+16>>2]=c[m+16>>2];c[g+20>>2]=c[m+20>>2];c[g+24>>2]=c[m+24>>2];c[g+28>>2]=c[m+28>>2];c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[m+16>>2]=c[l+16>>2];c[m+20>>2]=c[l+20>>2];c[m+24>>2]=c[l+24>>2];b[m+28>>1]=b[l+28>>1]|0;c[l+0>>2]=c[g+0>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];c[l+16>>2]=c[g+16>>2];c[l+20>>2]=c[g+20>>2];c[l+24>>2]=c[g+24>>2];b[l+28>>1]=b[g+28>>1]|0;if((c[m>>2]|0)>>>0>=(c[j>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[j+16>>2]=c[m+16>>2];c[j+20>>2]=c[m+20>>2];c[j+24>>2]=c[m+24>>2];b[j+28>>1]=b[m+28>>1]|0;c[m+0>>2]=c[g+0>>2];c[m+4>>2]=c[g+4>>2];c[m+8>>2]=c[g+8>>2];c[m+12>>2]=c[g+12>>2];c[m+16>>2]=c[g+16>>2];c[m+20>>2]=c[g+20>>2];c[m+24>>2]=c[g+24>>2];b[m+28>>1]=b[g+28>>1]|0;if((c[j>>2]|0)>>>0>=(c[k>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];c[g+24>>2]=c[k+24>>2];c[g+28>>2]=c[k+28>>2];c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[k+16>>2]=c[j+16>>2];c[k+20>>2]=c[j+20>>2];c[k+24>>2]=c[j+24>>2];b[k+28>>1]=b[j+28>>1]|0;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];c[j+24>>2]=c[g+24>>2];b[j+28>>1]=b[g+28>>1]|0;if((c[k>>2]|0)>>>0>=(c[a>>2]|0)>>>0){n=1;i=f;return n|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];b[a+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;n=1;i=f;return n|0}default:{k=a+64|0;j=a+32|0;m=c[j>>2]|0;l=c[a>>2]|0;e=c[k>>2]|0;o=e>>>0<m>>>0;do if(m>>>0<l>>>0){if(o){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];b[a+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0;break};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[a+16>>2]=c[j+16>>2];c[a+20>>2]=c[j+20>>2];c[a+24>>2]=c[j+24>>2];b[a+28>>1]=b[j+28>>1]|0;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];c[j+24>>2]=c[g+24>>2];b[j+28>>1]=b[g+28>>1]|0;if(e>>>0<(c[j>>2]|0)>>>0){c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];b[j+28>>1]=b[k+28>>1]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];b[k+28>>1]=b[g+28>>1]|0}}else if(o?(c[g+0>>2]=c[j+0>>2],c[g+4>>2]=c[j+4>>2],c[g+8>>2]=c[j+8>>2],c[g+12>>2]=c[j+12>>2],c[g+16>>2]=c[j+16>>2],c[g+20>>2]=c[j+20>>2],c[g+24>>2]=c[j+24>>2],c[g+28>>2]=c[j+28>>2],c[j+0>>2]=c[k+0>>2],c[j+4>>2]=c[k+4>>2],c[j+8>>2]=c[k+8>>2],c[j+12>>2]=c[k+12>>2],c[j+16>>2]=c[k+16>>2],c[j+20>>2]=c[k+20>>2],c[j+24>>2]=c[k+24>>2],b[j+28>>1]=b[k+28>>1]|0,c[k+0>>2]=c[g+0>>2],c[k+4>>2]=c[g+4>>2],c[k+8>>2]=c[g+8>>2],c[k+12>>2]=c[g+12>>2],c[k+16>>2]=c[g+16>>2],c[k+20>>2]=c[g+20>>2],c[k+24>>2]=c[g+24>>2],b[k+28>>1]=b[g+28>>1]|0,(c[j>>2]|0)>>>0<l>>>0):0){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[a+16>>2]=c[j+16>>2];c[a+20>>2]=c[j+20>>2];c[a+24>>2]=c[j+24>>2];b[a+28>>1]=b[j+28>>1]|0;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];c[j+24>>2]=c[g+24>>2];b[j+28>>1]=b[g+28>>1]|0}while(0);g=a+96|0;if((g|0)==(d|0)){n=1;i=f;return n|0}j=0;l=g;g=k;while(1){k=c[l>>2]|0;if(k>>>0<(c[g>>2]|0)>>>0){o=l+4|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];c[h+16>>2]=c[o+16>>2];c[h+20>>2]=c[o+20>>2];c[h+24>>2]=c[o+24>>2];o=l;e=g;while(1){c[o+0>>2]=c[e+0>>2];c[o+4>>2]=c[e+4>>2];c[o+8>>2]=c[e+8>>2];c[o+12>>2]=c[e+12>>2];c[o+16>>2]=c[e+16>>2];c[o+20>>2]=c[e+20>>2];c[o+24>>2]=c[e+24>>2];b[o+28>>1]=b[e+28>>1]|0;if((e|0)==(a|0)){p=a;break}m=e+-32|0;if(k>>>0<(c[m>>2]|0)>>>0){q=e;e=m;o=q}else{p=e;break}}c[p>>2]=k;e=p+4|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];b[e+24>>1]=b[h+24>>1]|0;e=j+1|0;if((e|0)==8){r=l;break}else s=e}else s=j;e=l+32|0;if((e|0)==(d|0)){n=1;t=35;break}else{o=l;j=s;l=e;g=o}}if((t|0)==35){i=f;return n|0}n=(r+32|0)==(d|0);i=f;return n|0}}return 0}function K_b(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=Im,g=0,h=0,j=0;e=i;f=ea(S(ea(d)));Fn[c[(c[a>>2]|0)+132>>2]&255](a,f);if(d==ea(0.0)){a=c[139688]|0;g=b+(a>>>5<<2)+4|0;c[g>>2]=c[g>>2]&~(1<<(a&31));a=c[139690]|0;g=b+(a>>>5<<2)+4|0;c[g>>2]=c[g>>2]&~(1<<(a&31));i=e;return}a=d>ea(0.0);g=c[139688]|0;h=1<<(g&31);if(a){a=b+(g>>>5<<2)+4|0;c[a>>2]=c[a>>2]&~h;a=c[139690]|0;j=b+(a>>>5<<2)+4|0;c[j>>2]=1<<(a&31)|c[j>>2];i=e;return}else{j=b+(g>>>5<<2)+4|0;c[j>>2]=c[j>>2]|h;h=c[139690]|0;j=b+(h>>>5<<2)+4|0;c[j>>2]=c[j>>2]&~(1<<(h&31));i=e;return}}function L_b(){var a=0;a=i;c[139688]=xmd(622640)|0;c[139690]=xmd(622664)|0;i=a;return}function M_b(){return}function N_b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+216>>2]=b;c[a+220>>2]=d;MMc(a);MMc(a+108|0);if(c[b+52>>2]|0)TYb(b);P_b(b,a);i=e;return}function O_b(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[a+52>>2]|0)TYb(a);P_b(a,b);i=d;return}function P_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=0,n=0;d=i;i=i+128|0;e=d+112|0;f=d;g[f>>2]=ea(g[b+12>>2]);g[f+4>>2]=ea(g[b+4>>2]);g[f+8>>2]=ea(g[b+8>>2]);h=ea(g[b>>2]);j=ea(g[b+24>>2]);g[f+12>>2]=ea(h-j);g[f+16>>2]=ea(g[b+48>>2]);g[f+20>>2]=ea(g[b+40>>2]);g[f+24>>2]=ea(g[b+44>>2]);h=ea(g[b+36>>2]);k=ea(g[b+60>>2]);g[f+28>>2]=ea(h-k);g[f+32>>2]=ea(g[b+84>>2]);g[f+36>>2]=ea(g[b+76>>2]);g[f+40>>2]=ea(g[b+80>>2]);h=ea(g[b+72>>2]);l=ea(g[b+96>>2]);g[f+44>>2]=ea(h-l);g[f+48>>2]=ea(g[b+16>>2]);g[f+52>>2]=ea(g[b+20>>2]);g[f+56>>2]=ea(j*ea(3.0));g[f+60>>2]=ea(g[b+28>>2]);g[f+64>>2]=ea(g[b+52>>2]);g[f+68>>2]=ea(g[b+56>>2]);g[f+72>>2]=ea(k*ea(3.0));g[f+76>>2]=ea(g[b+64>>2]);g[f+80>>2]=ea(g[b+88>>2]);g[f+84>>2]=ea(g[b+92>>2]);g[f+88>>2]=ea(l*ea(3.0));g[f+92>>2]=ea(g[b+100>>2]);g[f+96>>2]=ea(g[b+32>>2]);g[f+100>>2]=ea(g[b+68>>2]);g[f+104>>2]=ea(g[b+104>>2]);g[f+108>>2]=ea(1.0);b=a+36|0;m=(c[b>>2]|0)+976|0;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];c[e>>2]=1073741885;old(a,e,f);m=f+16|0;n=(c[b>>2]|0)+992|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[e>>2]=1073741886;old(a,e,m);m=f+32|0;n=(c[b>>2]|0)+1008|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[e>>2]=1073741887;old(a,e,m);m=f+48|0;n=(c[b>>2]|0)+1024|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[e>>2]=1073741888;old(a,e,m);m=f+64|0;n=(c[b>>2]|0)+1040|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[e>>2]=1073741889;old(a,e,m);m=f+80|0;n=(c[b>>2]|0)+1056|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[e>>2]=1073741890;old(a,e,m);m=f+96|0;f=(c[b>>2]|0)+1072|0;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[e>>2]=1073741891;old(a,e,m);i=d;return}function Q_b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;k7b(a);c[a+124>>2]=d;c[a+128>>2]=b;R_b(b,a);i=e;return}function R_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=i;i=i+80|0;e=d+16|0;f=d+40|0;h=d+20|0;j=d+44|0;k=d+64|0;l=d;m=d+24|0;n=d+48|0;if(c[a+52>>2]|0)TYb(a);o=c[b+24>>2]|0;p=a+36|0;q=(c[p>>2]|0)+4960|0;c[f>>2]=o;c[e+0>>2]=c[f+0>>2];kxd(q,e,4,0,0);c[h>>2]=-1073741805;c[j>>2]=o;c[e+0>>2]=c[j+0>>2];mld(a,h,4,e);r=ea(g[b>>2]);s=ea(g[b+12>>2]);t=ea(r-s);u=ea(g[b+4>>2]);v=ea(g[b+16>>2]);w=ea(u-v);x=ea(g[b+8>>2]);y=ea(g[b+20>>2]);z=ea(x-y);A=ea(g[b+120>>2]);g[k>>2]=t;g[k+4>>2]=w;g[k+8>>2]=z;g[k+12>>2]=A;A=ea(u+v);v=ea(x+y);g[l>>2]=ea(r+s);g[l+4>>2]=A;g[l+8>>2]=v;g[l+12>>2]=ea(1.0);o=b+28|0;q=(c[p>>2]|0)+2320|0;c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];c[q+12>>2]=c[o+12>>2];c[e>>2]=1073741969;old(a,e,o);o=(c[p>>2]|0)+2352|0;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[e>>2]=1073741971;old(a,e,k);k=(c[p>>2]|0)+2336|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[e>>2]=1073741970;old(a,e,l);l=b+44|0;k=(c[p>>2]|0)+2368|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[e>>2]=1073741972;old(a,e,l);l=c[b+84>>2]|0;k=(c[p>>2]|0)+5024|0;c[f>>2]=l;c[e+0>>2]=c[f+0>>2];kxd(k,e,4,0,0);c[h>>2]=-1073741804;c[j>>2]=l;c[e+0>>2]=c[j+0>>2];mld(a,h,4,e);v=ea(g[b+60>>2]);A=ea(g[b+72>>2]);s=ea(v-A);r=ea(g[b+64>>2]);y=ea(g[b+76>>2]);x=ea(r-y);u=ea(g[b+68>>2]);z=ea(g[b+80>>2]);w=ea(u-z);g[m>>2]=s;g[m+4>>2]=x;g[m+8>>2]=w;g[m+12>>2]=ea(1.0);w=ea(r+y);y=ea(u+z);g[n>>2]=ea(v+A);g[n+4>>2]=w;g[n+8>>2]=y;g[n+12>>2]=ea(1.0);h=b+88|0;j=(c[p>>2]|0)+2384|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];c[e>>2]=1073741973;old(a,e,h);h=(c[p>>2]|0)+2416|0;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[e>>2]=1073741975;old(a,e,m);m=(c[p>>2]|0)+2400|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[e>>2]=1073741974;old(a,e,n);n=b+104|0;b=(c[p>>2]|0)+2432|0;c[b+0>>2]=c[n+0>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];c[b+12>>2]=c[n+12>>2];c[e>>2]=1073741976;old(a,e,n);i=d;return}function S_b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;h=f+32|0;j=f;c[b+4>>2]=d;c[b+8>>2]=e;g[j>>2]=ea(1.0);g[j+4>>2]=ea(1.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);e=j+16|0;g[e>>2]=ea(1.0);g[j+20>>2]=ea(1.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);if(c[d+52>>2]|0)TYb(d);k=d+36|0;l=(c[k>>2]|0)+944|0;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[h>>2]=1073741883;old(d,h,j);j=(c[k>>2]|0)+960|0;c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[h>>2]=1073741884;old(d,h,e);a[b>>0]=1;i=f;return}function T_b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;h=f+32|0;j=f;k=c[d+36>>2]|0;if((k&65534|0)==254)l=(k&-131072|0)!=16646144;else l=1;if(l&(e|0)==0){e=c[b+4>>2]|0;if(c[e+52>>2]|0)TYb(e);l=d+4|0;k=e+36|0;m=(c[k>>2]|0)+944|0;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[h>>2]=1073741883;old(e,h,l);l=d+20|0;d=(c[k>>2]|0)+960|0;c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];c[h>>2]=1073741884;old(e,h,l);a[b>>0]=0;i=f;return}if(a[b>>0]|0){i=f;return}g[j>>2]=ea(1.0);g[j+4>>2]=ea(1.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);l=j+16|0;g[l>>2]=ea(1.0);g[j+20>>2]=ea(1.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);e=c[b+4>>2]|0;if(c[e+52>>2]|0)TYb(e);d=e+36|0;k=(c[d>>2]|0)+944|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[h>>2]=1073741883;old(e,h,j);j=(c[d>>2]|0)+960|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[h>>2]=1073741884;old(e,h,l);a[b>>0]=1;i=f;return}function U_b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0;a=i;i=i+16|0;f=a;h=c[b+36>>2]|0;if((h&65534|0)==254)j=(h&-131072|0)!=16646144;else j=1;h=c[(c[d>>2]|0)+136>>2]|0;if(j&(e|0)==0){In[h&4095](d,b+4|0);i=a;return}else{g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(0.0);In[h&4095](d,f);i=a;return}}function V_b(d,e){d=d|0;e=e|0;var f=0,h=0;f=i;c[d>>2]=558776;a[d+40>>0]=e;a[d+41>>0]=1;a[d+42>>0]=1;a[d+43>>0]=0;c[d+44>>2]=0;a[d+48>>0]=1;a[d+49>>0]=1;e=d+116|0;h=e+48|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(h|0));c[d+168>>2]=0;c[d+172>>2]=-2147450880;c[d+176>>2]=0;c[d+180>>2]=-1;c[d+184>>2]=0;e=d+36|0;b[e+2>>1]=255;b[e>>1]=255;g[d+4>>2]=ea(1.0);g[d+8>>2]=ea(1.0);g[d+12>>2]=ea(0.0);g[d+16>>2]=ea(0.0);g[d+20>>2]=ea(1.0);g[d+24>>2]=ea(1.0);g[d+28>>2]=ea(0.0);g[d+32>>2]=ea(0.0);i=f;return}function W_b(a){a=a|0;return}function X_b(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Y_b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+48|0;g=b+49|0;if(!((a[f>>0]|0)==0?(a[g>>0]|0)==0:0)){ko[c[(c[b>>2]|0)+60>>2]&4095](b);a[f>>0]=0;a[g>>0]=0}g=b+116|0;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];c[d+16>>2]=c[g+16>>2];c[d+20>>2]=c[g+20>>2];i=e;return}function Z_b(a,c){a=a|0;c=c|0;var d=0;d=b[a+36+(c<<1)>>1]|0;return (d<<16>>16==255?-1:d&65535)|0}function __b(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=g+4|0;k=d+36+(f<<1)|0;if((e|0)==-1){b[k>>1]=255;i=g;return}if(e>>>0<=255){b[k>>1]=e;i=g;return}b[k>>1]=255;c[h>>2]=255;Lsd(j,721176,h);if(!(a[j>>0]&1))l=j+1|0;else l=c[j+8>>2]|0;Krd(l,0,3653512,60,1,0,0,0);xri(j);i=g;return}function $_b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+(d<<4)+4|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];return}function a$b(a){a=a|0;return 0}function b$b(a,b,c){a=a|0;b=b|0;c=c|0;return}function c$b(b){b=b|0;a[b+43>>0]=1;return}function d$b(b){b=b|0;a[b+43>>0]=0;return}function e$b(a){a=a|0;return ea(0.0)}function f$b(a,b){a=a|0;b=b|0;return b|0}function g$b(a){a=a|0;return 0}function h$b(a){a=a|0;return 0}function i$b(a){a=a|0;return 0}function j$b(){var a=0;a=i;QTb(20,554336,1807,0);Ydd(2449160,558936,558960);c[139744]=xmd(622600)|0;c[139746]=xmd(622624)|0;c[139754]=xmd(558992)|0;i=a;return}function k$b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];bUb(b,h,e);a[b+28>>0]=1;a[b+29>>0]=0;c[b>>2]=559032;e=b+32|0;j=b+160|0;d=b+296|0;l=b+96|0;m=b+224|0;n=b+332|0;c[n>>2]=0;c[b+340>>2]=0;c[b+344>>2]=0;o=b+352|0;p=b+396|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;p=b+424|0;q=b+436|0;c[b+604>>2]=0;r=b+608|0;s=b+292|0;t=s+36|0;do{c[s>>2]=0;s=s+4|0}while((s|0)<(t|0));c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;a[r>>0]=1;a[r+1>>0]=1;a[r+2>>0]=1;a[r+3>>0]=1;a[b+623>>0]=0;xcc(b+636|0);c[b+288>>2]=h_b(b)|0;c[b+412>>2]=-1;c[b+416>>2]=-1;s=b+468|0;t=s+128|0;do{c[s>>2]=0;s=s+4|0}while((s|0)<(t|0));a[b+618>>0]=0;c[b+600>>2]=0;r=b+612|0;o=b+619|0;a[r>>0]=1;a[r+1>>0]=1;a[r+2>>0]=1;a[r+3>>0]=1;a[o>>0]=0;a[o+1>>0]=0;a[o+2>>0]=0;a[o+3>>0]=0;g[b+596>>2]=ea(1.0);c[p+0>>2]=c[150284];c[p+4>>2]=c[150285];c[p+8>>2]=c[150286];c[q+0>>2]=c[150284];c[q+4>>2]=c[150285];c[q+8>>2]=c[150286];s=m+0|0;m=601008|0;t=s+64|0;do{c[s>>2]=c[m>>2];s=s+4|0;m=m+4|0}while((s|0)<(t|0));aFi(l|0,601008,64)|0;s=j+0|0;m=l+0|0;t=s+64|0;do{c[s>>2]=c[m>>2];s=s+4|0;m=m+4|0}while((s|0)<(t|0));s=e+0|0;m=l+0|0;t=s+64|0;do{c[s>>2]=c[m>>2];s=s+4|0;m=m+4|0}while((s|0)<(t|0));c[b+348>>2]=0;a[b+617>>0]=1;c[b+336>>2]=0;c[b+328>>2]=1;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;d=znc()|0;c[b+296>>2]=mo[c[(c[d>>2]|0)+428>>2]&4095](d)|0;d=znc()|0;c[n>>2]=mo[c[(c[d>>2]|0)+432>>2]&4095](d)|0;c[k>>2]=VQb(b)|0;c[h+0>>2]=c[k+0>>2];k=bOb(32,h,0,16,3653512,144)|0;c[k>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+4>>2]=60;c[k+16>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;c[k+20>>2]=60;c[b+372>>2]=k;g[b+624>>2]=ea(.0219999999);g[b+628>>2]=ea(10.0);c[b+632>>2]=0;i=f;return}function l$b(b){b=b|0;g[b+396>>2]=ea(0.0);g[b+400>>2]=ea(0.0);g[b+404>>2]=ea(1.0);g[b+408>>2]=ea(1.0);g[b+380>>2]=ea(.192156866);g[b+384>>2]=ea(.301960796);g[b+388>>2]=ea(.474509805);g[b+392>>2]=ea(.0196078438);g[b+420>>2]=ea(0.0);g[b+456>>2]=ea(.300000012);g[b+460>>2]=ea(1.0e3);c[b+464>>2]=-1;g[b+596>>2]=ea(1.0);a[b+616>>0]=0;a[b+619>>0]=0;c[b+600>>2]=0;g[b+448>>2]=ea(5.0);g[b+452>>2]=ea(60.0);c[b+376>>2]=1;a[b+610>>0]=1;a[b+609>>0]=1;a[b+608>>0]=1;c[b+352>>2]=0;return}function m$b(b){b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im;d=i;fUb(b);e=b+464|0;f=c[e>>2]|0;if((f|0)<-1)h=-1;else h=(f|0)>3?3:f;c[e>>2]=h;h=b+456|0;j=ea(g[h>>2]);if((a[b+616>>0]|0)==0&j<ea(.00999999977)){g[h>>2]=ea(.00999999977);k=ea(.00999999977)}else k=j;h=b+460|0;j=ea(k+ea(.00999999977));if(!(ea(g[h>>2])<j)){i=d;return}g[h>>2]=j;i=d;return}function n$b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+372|0;h=c[g>>2]|0;j=VQb(a)|0;if(h){if((c[h+28>>2]|0)>-1){k=h+16|0;l=c[k>>2]|0;c[e>>2]=c[h+20>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[k>>2]=0}if((c[h+12>>2]|0)>-1){k=c[h>>2]|0;c[e>>2]=c[h+4>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[h>>2]=0}}c[f>>2]=j;c[d+0>>2]=c[f+0>>2];eOb(h,d);c[g>>2]=0;i_b(c[a+288>>2]|0);i=b;return}function o$b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+636|0;zcc(g);h=a+292|0;j=c[h>>2]|0;do if(j){c[f>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,f);l=c[d>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if(!((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(c[n+4>>2]|0)!=0:0))o=10}else o=10;if((o|0)==10?(hQb(c[h>>2]|0)|0)==0:0)break;c[e>>2]=c[h>>2];k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,e);l=c[d>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){p=m+(c[k+32>>2]<<3)|0;break}else{p=m+(l<<3)|0;break}}else p=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((p|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[p+4>>2]|0,(k|0)!=0):0)q=k;else o=19}else o=19;if((o|0)==19)q=hQb(c[h>>2]|0)|0;wBc(q)}while(0);Ccc(g);n_b(c[a+288>>2]|0);g=a+340|0;if(c[g>>2]|0){q=Gzc()|0;Jzc(q,c[g>>2]|0);c[g>>2]=0}g=a+344|0;if(!(c[g>>2]|0)){i=b;return}a=Gzc()|0;Jzc(a,c[g>>2]|0);c[g>>2]=0;i=b;return}function p$b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;d=i;i=i+16|0;e=d;okc(b,c);if((c&1|0)==0?(a[b+29>>0]|0)!=0:0){k8b(n8b()|0,b);j8b(n8b()|0,b)}c=b+610|0;a[c>>0]=1;f=b+609|0;a[f>>0]=1;a[b+608>>0]=1;h=b+615|0;if(a[h>>0]|0){T0b(e,b,1);j=ea(g[b+396>>2]);k=ea(g[b+400>>2]);l=ea(g[b+404>>2]);m=ea(g[b+408>>2]);n=ea(g[e+8>>2]);o=ea(g[e+12>>2]);p=ea(j*n);j=ea(l*n);l=ea(k*o);k=ea(m*o);m=ea(g[e>>2]);q=ea(g[e+4>>2]);r=ea(p+m);p=ea(l+q);l=ea(j+r);j=ea(k+p);k=ea(n+m);n=ea(o+q);o=ea((l>k?k:l)-(r<m?m:r));r=ea((j>n?n:j)-(p<q?q:p));e=r<ea(0.0);p=e?ea(0.0):r;if(p!=ea(0.0)){e=o<ea(0.0);s=ea((e?ea(0.0):o)/p)}else s=ea(1.0);g[b+596>>2]=s;a[f>>0]=1;a[c>>0]=1;a[h>>0]=1}if(!(a[b+619>>0]|0)){i=d;return}r$b(b);i=d;return}function q$b(b){b=b|0;var c=0,d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=i;i=i+16|0;d=c;e=b+615|0;if(!(a[e>>0]|0)){i=c;return}T0b(d,b,1);f=ea(g[b+396>>2]);h=ea(g[b+400>>2]);j=ea(g[b+404>>2]);k=ea(g[b+408>>2]);l=ea(g[d+8>>2]);m=ea(g[d+12>>2]);n=ea(f*l);f=ea(j*l);j=ea(h*m);h=ea(k*m);k=ea(g[d>>2]);o=ea(g[d+4>>2]);p=ea(n+k);n=ea(j+o);j=ea(f+p);f=ea(h+n);h=ea(l+k);l=ea(m+o);m=ea((j>h?h:j)-(p<k?k:p));p=ea((f>l?l:f)-(n<o?o:n));d=p<ea(0.0);n=d?ea(0.0):p;if(n!=ea(0.0)){d=m<ea(0.0);q=ea((d?ea(0.0):m)/n)}else q=ea(1.0);g[b+596>>2]=q;a[b+609>>0]=1;a[b+610>>0]=1;a[e>>0]=1;i=c;return}function r$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=pyc()|0;if((c[(c[e+24>>2]|0)+((c[e+40>>2]|0)*96|0)+64>>2]|0)>0?(V$b(b)|0)==1:0){if(!b)f=0;else f=c[b+4>>2]|0;Krd(559784,0,3653512,2593,512,f,0,0)}f=ync()|0;if(!((a[621118+(mo[c[(c[f>>2]|0)+672>>2]&4095](f)|0)>>0]|0)!=0?(a[(NOc()|0)+92>>0]|0)!=0:0)){if(!b)g=0;else g=c[b+4>>2]|0;Krd(559976,0,3653512,2595,512,g,0,0)}g=(V$b(b)|0)==3;if(!(g&(a[621040]|0)==0)){i=d;return}if(!b)h=0;else h=c[b+4>>2]|0;Krd(560088,0,3653512,2598,512,h,0,0);i=d;return}function s$b(b){b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;d=i;i=i+32|0;e=d+16|0;f=d;j8b(n8b()|0,b);h=b+615|0;if(a[h>>0]|0){T0b(e,b,1);j=ea(g[b+396>>2]);k=ea(g[b+400>>2]);l=ea(g[b+404>>2]);m=ea(g[b+408>>2]);n=ea(g[e+8>>2]);o=ea(g[e+12>>2]);p=ea(j*n);j=ea(l*n);l=ea(k*o);k=ea(m*o);m=ea(g[e>>2]);q=ea(g[e+4>>2]);r=ea(p+m);p=ea(l+q);l=ea(j+r);j=ea(k+p);k=ea(n+m);n=ea(o+q);o=ea((l>k?k:l)-(r<m?m:r));r=ea((j>n?n:j)-(p<q?q:p));e=r<ea(0.0);p=e?ea(0.0):r;if(p!=ea(0.0)){e=o<ea(0.0);s=ea((e?ea(0.0):o)/p)}else s=ea(1.0);g[b+596>>2]=s;a[b+609>>0]=1;a[b+610>>0]=1;a[h>>0]=1}h=b+436|0;rGc(f,BTb(c[b+24>>2]|0)|0);c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];g[b+424>>2]=ea(0.0);g[b+428>>2]=ea(0.0);g[b+432>>2]=ea(0.0);i=d;return}function t$b(a){a=a|0;var b=0;b=i;k8b(n8b()|0,a);i=b;return}function u$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;e=i;i=i+16|0;f=e;T0b(f,b,d);d=b+396|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];h=ea(g[f+8>>2]);j=ea(g[f+12>>2]);k=ea(h*ea(g[a>>2]));d=a+8|0;l=ea(h*ea(g[d>>2]));g[d>>2]=l;b=a+4|0;m=ea(j*ea(g[b>>2]));n=a+12|0;o=ea(j*ea(g[n>>2]));g[n>>2]=o;p=ea(g[f>>2]);q=ea(g[f+4>>2]);r=ea(p+k);g[a>>2]=r;k=ea(q+m);g[b>>2]=k;m=ea(r+l);l=ea(k+o);o=ea(p+h);h=ea(q+j);if(r<p){g[a>>2]=p;s=p}else s=r;if(k<q){g[b>>2]=q;t=q}else t=k;k=ea((m>o?o:m)-s);b=k<ea(0.0);g[d>>2]=b?ea(0.0):k;k=ea((l>h?h:l)-t);b=k<ea(0.0);g[n>>2]=b?ea(0.0):k;i=e;return}function v$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;d=i;i=i+32|0;e=d+16|0;f=d;T0b(e,b,1);h=b+396|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];j=ea(g[e+8>>2]);k=ea(g[e+12>>2]);l=ea(j*ea(g[f>>2]));h=f+8|0;m=ea(j*ea(g[h>>2]));g[h>>2]=m;b=f+4|0;n=ea(k*ea(g[b>>2]));o=f+12|0;p=ea(k*ea(g[o>>2]));g[o>>2]=p;q=ea(g[e>>2]);r=ea(g[e+4>>2]);s=ea(l+q);g[f>>2]=s;l=ea(n+r);g[b>>2]=l;n=ea(m+s);m=ea(p+l);p=ea(j+q);j=ea(k+r);if(s<q){g[f>>2]=q;t=q}else t=s;if(l<r){g[b>>2]=r;u=r}else u=l;l=ea((n>p?p:n)-t);b=l<ea(0.0);g[h>>2]=b?ea(0.0):l;l=ea((m>j?j:m)-u);b=l<ea(0.0);g[o>>2]=b?ea(0.0):l;n1b(a,f);i=d;return}function w$b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;e=i;i=i+16|0;f=e;h=b+396|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];d=b+615|0;if(!(a[d>>0]|0)){i=e;return}T0b(f,b,1);j=ea(g[b+396>>2]);k=ea(g[b+400>>2]);l=ea(g[b+404>>2]);m=ea(g[b+408>>2]);n=ea(g[f+8>>2]);o=ea(g[f+12>>2]);p=ea(j*n);j=ea(l*n);l=ea(k*o);k=ea(m*o);m=ea(g[f>>2]);q=ea(g[f+4>>2]);r=ea(p+m);p=ea(l+q);l=ea(j+r);j=ea(k+p);k=ea(n+m);n=ea(o+q);o=ea((l>k?k:l)-(r<m?m:r));r=ea((j>n?n:j)-(p<q?q:p));f=r<ea(0.0);p=f?ea(0.0):r;if(p!=ea(0.0)){f=o<ea(0.0);s=ea((f?ea(0.0):o)/p)}else s=ea(1.0);g[b+596>>2]=s;a[b+609>>0]=1;a[b+610>>0]=1;a[d>>0]=1;i=e;return}function x$b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e;if(d){h=0;i=e;return h|0}d=b+292|0;j=c[d>>2]|0;if(j){c[g>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(f,j,g);k=c[f>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(c[m+4>>2]|0)!=0:0){h=0;i=e;return h|0}}if(hQb(c[d>>2]|0)|0){h=0;i=e;return h|0}}d=c[b+296>>2]|0;if(!d){h=0;i=e;return h|0}if(!(a[d+23>>0]|0)){h=0;i=e;return h|0}d=pyc()|0;if(((a[621046]|0)!=0?(c[(c[d+24>>2]|0)+((c[d+40>>2]|0)*96|0)+64>>2]|0)>1:0)&(a[621048]|0)==0){h=1;i=e;return h|0}else{i=e;return ((c[b+376>>2]|0)+-1|0)>>>0>1|0}return 0}function y$b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0;f=i;i=i+192|0;h=f+160|0;j=f+56|0;k=f;l=f+152|0;m=f+156|0;n=f+176|0;o=f+40|0;p=f+136|0;q=f+120|0;r=f+24|0;s=f+8|0;t=ync()|0;u=V$b(b)|0;if(!(a[(NOc()|0)+92>>0]|0))v=1;else{w=ync()|0;v=(a[621118+(mo[c[(c[w>>2]|0)+672>>2]&4095](w)|0)>>0]|0)==0}w=pyc()|0;x=(u|0)==3;y=((u|0)==2?1:(c[(c[w+24>>2]|0)+((c[w+40>>2]|0)*96|0)+64>>2]|0)==0)|x;if(x)z=(a[621040]|0)!=0;else z=1;if(!((a[b+619>>0]|0)==0|v)){v=y&z;z=b+620|0;a[z>>0]=v&1;y=d+4|0;x=c[139746]|0;if(v){v=d+(x>>>5<<2)+4|0;c[v>>2]=c[v>>2]|1<<(x&31);A=z;B=y}else{C=y;D=z;E=x;F=9}}else{x=b+620|0;a[x>>0]=0;C=d+4|0;D=x;E=c[139746]|0;F=9}if((F|0)==9){x=d+(E>>>5<<2)+4|0;c[x>>2]=c[x>>2]&~(1<<(E&31));A=D;B=C}C=(KLc()|0)==1;D=c[139754]|0;E=1<<(D&31);if(C){C=B+(D>>>5<<2)|0;c[C>>2]=c[C>>2]&~E}else{C=B+(D>>>5<<2)|0;c[C>>2]=c[C>>2]|E}do if(((V$b(b)|0)&-2|0)==2)G=1;else{if(!((a[621046]|0)!=0?(E=pyc()|0,(a[621048]|0)==0?(c[(c[E+24>>2]|0)+((c[E+40>>2]|0)*96|0)+64>>2]|0)>1:0):0))F=16;if((F|0)==16?(E=j_b(c[b+288>>2]|0)|0,(c[E>>2]|0)!=(c[E+4>>2]|0)):0){G=1;break}G=0}while(0);E=A$b(b)|0;if(e&4){C=j_b(c[b+288>>2]|0)|0;B3b(C,G,(a[A>>0]|0)!=0,E)}E=b+348|0;c[E>>2]=0;do if(!(x$b(b,G)|0)){A=j_b(c[b+288>>2]|0)|0;if(!(e&16)){C=x3b(A)|0;c[E>>2]=C;if(C){C=b+292|0;D=c[C>>2]|0;do if(D){c[n>>2]=D;B=c[137784]|0;if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(h,B,n);x=c[h>>2]|0;z=c[B+28>>2]|0;if((x|0)==-1){H=z+(c[B+32>>2]<<3)|0;break}else{H=z+(x<<3)|0;break}}else H=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);B=c[137784]|0;if(!((H|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(c[H+4>>2]|0)!=0:0))F=33}else F=33;if((F|0)==33?(hQb(c[C>>2]|0)|0)==0:0)break;if(((c[b+376>>2]|0)+-3|0)>>>0<2){B=c[C>>2]|0;if(!B)I=0;else{c[m>>2]=B;B=c[137784]|0;do if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(h,B,m);x=c[h>>2]|0;z=c[B+28>>2]|0;if((x|0)==-1){J=z+(c[B+32>>2]<<3)|0;break}else{J=z+(x<<3)|0;break}}else J=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);x=c[137784]|0;if((J|0)==((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)){F=44;break}x=c[J+4>>2]|0;if(x)K=x;else F=44}else F=44;while(0);if((F|0)==44)K=hQb(c[C>>2]|0)|0;I=K}D3b(I,c[E>>2]|0)}}while(0);L=c[E>>2]|0;F=48}}else{C=z3b(A)|0;c[E>>2]=C;L=C;F=48}if((F|0)==48?(L|0)!=0:0)break;C=b+292|0;D=c[C>>2]|0;if(!D)M=0;else{c[l>>2]=D;D=c[137784]|0;if(D){do if((c[D+36>>2]|0)!=(c[D+4>>2]|0)){fRb(h,D,l);B=c[h>>2]|0;x=c[D+28>>2]|0;if((B|0)==-1){N=x+(c[D+32>>2]<<3)|0;break}else{N=x+(B<<3)|0;break}}else N=(c[D+28>>2]|0)+(c[D+32>>2]<<3)|0;while(0);D=c[137784]|0;if((N|0)!=((c[D+28>>2]|0)+(c[D+32>>2]<<3)|0)?(D=c[N+4>>2]|0,(D|0)!=0):0)O=D;else F=58}else F=58;if((F|0)==58)O=hQb(c[C>>2]|0)|0;M=O}c[E>>2]=M}while(0);T0b(h,b,0);M=b+396|0;c[p+0>>2]=c[M+0>>2];c[p+4>>2]=c[M+4>>2];c[p+8>>2]=c[M+8>>2];c[p+12>>2]=c[M+12>>2];P=ea(g[h+8>>2]);Q=ea(g[h+12>>2]);R=ea(P*ea(g[p>>2]));M=p+8|0;S=ea(P*ea(g[M>>2]));g[M>>2]=S;O=p+4|0;T=ea(Q*ea(g[O>>2]));N=p+12|0;U=ea(Q*ea(g[N>>2]));g[N>>2]=U;V=ea(g[h>>2]);W=ea(g[h+4>>2]);X=ea(R+V);g[p>>2]=X;R=ea(T+W);g[O>>2]=R;T=ea(S+X);S=ea(U+R);U=ea(P+V);P=ea(Q+W);if(X<V){g[p>>2]=V;Y=V}else Y=X;if(R<W){g[O>>2]=W;Z=W}else Z=R;R=ea((T>U?U:T)-Y);O=R<ea(0.0);g[M>>2]=O?ea(0.0):R;R=ea((S>P?P:S)-Z);O=R<ea(0.0);g[N>>2]=O?ea(0.0):R;n1b(o,p);p=(n8b()|0)+72|0;c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];c[p+12>>2]=c[o+12>>2];if(e&2){e=pBc(c[E>>2]|0)|0;c[E>>2]=e;if(!e){c[j>>2]=0;p=c[b+332>>2]|0;O=c[b+328>>2]|0;N=c[b+336>>2]|0;c[E>>2]=N;_=b+296|0;$=O;aa=N;ba=p}else{c[j>>2]=c[e+140>>2];_=j;$=1;aa=e;ba=c[e+148>>2]|0}c[k>>2]=ba;c[h+0>>2]=c[k+0>>2];qBc($,_,h,aa,0,-1,1)|0;aa=c[_>>2]|0;if(aa){_=(a[aa+23>>0]|0)==0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;if(_){ca=q;F=73}else{c[q+0>>2]=c[o+0>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];c[q+12>>2]=c[o+12>>2]}}else{c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;ca=q;F=73}if((F|0)==73){B$b(s,b);n1b(r,s);c[ca+0>>2]=c[r+0>>2];c[ca+4>>2]=c[r+4>>2];c[ca+8>>2]=c[r+8>>2];c[ca+12>>2]=c[r+12>>2]}i1b(t,q);In[c[(c[t>>2]|0)+176>>2]&4095](t,q)}q=c[(c[t>>2]|0)+108>>2]|0;r=b+609|0;if((a[r>>0]|0)!=0?(a[b+613>>0]|0)!=0:0){ca=b+96|0;R=ea(g[b+596>>2]);Z=ea(g[b+456>>2]);S=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(ca,ea(g[b+452>>2]),R,Z,S)|0;else{P=ea(g[b+448>>2]);Y=ea(-P);oMc(ca,ea(R*Y),ea(R*P),Y,P,Z,S)|0}a[r>>0]=0}In[q&4095](t,b+96|0);q=c[(c[t>>2]|0)+104>>2]|0;r=b+608|0;if(!(a[r>>0]|0)){da=b+32|0;In[q&4095](t,da);E$b(b,d);i=f;return}if(!(a[b+612>>0]|0)){da=b+32|0;In[q&4095](t,da);E$b(b,d);i=f;return}ca=b+32|0;g[h>>2]=ea(1.0);g[h+4>>2]=ea(1.0);g[h+8>>2]=ea(-1.0);iMc(ca,h)|0;PGc(j,BTb(c[b+24>>2]|0)|0);cMc(ca,j)|0;a[r>>0]=0;da=b+32|0;In[q&4095](t,da);E$b(b,d);i=f;return}function z$b(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;if(((V$b(b)|0)&-2|0)==2){e=1;i=d;return e|0}if(!((a[621046]|0)!=0?(f=pyc()|0,(a[621048]|0)==0?(c[(c[f+24>>2]|0)+((c[f+40>>2]|0)*96|0)+64>>2]|0)>1:0):0))g=4;if((g|0)==4?(g=j_b(c[b+288>>2]|0)|0,(c[g>>2]|0)!=(c[g+4>>2]|0)):0){e=1;i=d;return e|0}e=0;i=d;return e|0}function A$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=b+292|0;j=c[h>>2]|0;if(!j){k=1;i=d;return k|0}c[g>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(e,j,g);l=c[e>>2]|0;m=c[j+28>>2]|0;if((l|0)==-1){n=m+(c[j+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((n|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[n+4>>2]|0,(j|0)!=0):0)o=j;else p=10}else p=10;if((p|0)==10)o=hQb(c[h>>2]|0)|0;if((o|0)==0|(a[621046]|0)==0){k=1;i=d;return k|0}if(((V$b(b)|0)&-2|0)==2){k=1;i=d;return k|0}c[f>>2]=c[h>>2];b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,f);o=c[e>>2]|0;j=c[b+28>>2]|0;if((o|0)==-1){q=j+(c[b+32>>2]<<3)|0;break}else{q=j+(o<<3)|0;break}}else q=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((q|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[q+4>>2]|0,(b|0)!=0):0)r=b;else p=21}else p=21;if((p|0)==21)r=hQb(c[h>>2]|0)|0;k=c[r+108>>2]|0;i=d;return k|0}function B$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;i=i+32|0;e=d+8|0;f=d;h=b+348|0;j=c[h>>2]|0;if(j){k=b+292|0;l=c[k>>2]|0;if(!l)m=0;else{c[f>>2]=l;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,f);n=c[e>>2]|0;o=c[l+28>>2]|0;if((n|0)==-1){p=o+(c[l+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((p|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[p+4>>2]|0,(l|0)!=0):0)q=l;else r=11}else r=11;if((r|0)==11)q=hQb(c[k>>2]|0)|0;m=q}if((j|0)!=(m|0)){m=c[h>>2]|0;s=ea(c[m+100>>2]|0);t=ea(c[m+104>>2]|0);g[a>>2]=ea(0.0);g[a+8>>2]=s;g[a+4>>2]=ea(0.0);g[a+12>>2]=t;i=d;return}}T0b(e,b,0);m=b+396|0;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];t=ea(g[e+8>>2]);s=ea(g[e+12>>2]);u=ea(t*ea(g[a>>2]));m=a+8|0;v=ea(t*ea(g[m>>2]));g[m>>2]=v;b=a+4|0;w=ea(s*ea(g[b>>2]));h=a+12|0;x=ea(s*ea(g[h>>2]));g[h>>2]=x;y=ea(g[e>>2]);z=ea(g[e+4>>2]);A=ea(u+y);g[a>>2]=A;u=ea(w+z);g[b>>2]=u;w=ea(v+A);v=ea(x+u);x=ea(t+y);t=ea(s+z);if(A<y){g[a>>2]=y;B=y}else B=A;if(u<z){g[b>>2]=z;C=z}else C=u;u=ea((w>x?x:w)-B);b=u<ea(0.0);g[m>>2]=b?ea(0.0):u;u=ea((v>t?t:v)-C);b=u<ea(0.0);g[h>>2]=b?ea(0.0):u;i=d;return}function C$b(b){b=b|0;var c=0,d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im;c=i;d=b+609|0;if(!(a[d>>0]|0)){e=b+96|0;i=c;return e|0}if(!(a[b+613>>0]|0)){e=b+96|0;i=c;return e|0}f=b+96|0;h=ea(g[b+596>>2]);j=ea(g[b+456>>2]);k=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(f,ea(g[b+452>>2]),h,j,k)|0;else{l=ea(g[b+448>>2]);m=ea(-l);oMc(f,ea(h*m),ea(l*h),m,l,j,k)|0}a[d>>0]=0;e=b+96|0;i=c;return e|0}function D$b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;i=i+80|0;e=d+64|0;f=d;h=b+608|0;if(!(a[h>>0]|0)){j=b+32|0;i=d;return j|0}if(!(a[b+612>>0]|0)){j=b+32|0;i=d;return j|0}k=b+32|0;g[e>>2]=ea(1.0);g[e+4>>2]=ea(1.0);g[e+8>>2]=ea(-1.0);iMc(k,e)|0;PGc(f,BTb(c[b+24>>2]|0)|0);cMc(k,f)|0;a[h>>0]=0;j=b+32|0;i=d;return j|0}function E$b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0.0,H=Im;e=i;i=i+368|0;f=e+64|0;h=e+152|0;j=e+128|0;k=e+216|0;l=e+344|0;m=e;n=e+140|0;o=e+280|0;uvd(ea(-1.0));p=ync()|0;q=b+24|0;rGc(j,BTb(c[q>>2]|0)|0);r=ea(g[j>>2]);s=ea(g[j+4>>2]);t=ea(g[j+8>>2]);g[p+564>>2]=r;g[p+568>>2]=s;g[p+572>>2]=t;g[p+576>>2]=ea(0.0);g[l>>2]=ea(1.0);g[l+4>>2]=ea(1.0);g[l+8>>2]=ea(-1.0);iMc(k,l)|0;l=b+608|0;if((a[l>>0]|0)!=0?(a[b+612>>0]|0)!=0:0){j=b+32|0;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(-1.0);iMc(j,f)|0;PGc(h,BTb(c[q>>2]|0)|0);cMc(j,h)|0;a[l>>0]=0}cMc(k,b+32|0)|0;l=p+2916|0;j=k+0|0;q=l+64|0;do{c[l>>2]=c[j>>2];l=l+4|0;j=j+4|0}while((l|0)<(q|0));rMc(k,h)|0;l=p+2980|0;j=h+0|0;q=l+64|0;do{c[l>>2]=c[j>>2];l=l+4|0;j=j+4|0}while((l|0)<(q|0));g[k+56>>2]=ea(0.0);g[k+52>>2]=ea(0.0);g[k+48>>2]=ea(0.0);g[n>>2]=ea(1.0);g[n+4>>2]=ea(-1.0);g[n+8>>2]=ea(1.0);iMc(m,n)|0;dMc(k,m,o);pud(d+20|0,558912,o);s1b(ync()|0);o=b+613|0;d=(a[o>>0]|0)==0;do if(d){m=0;a:while(1){k=0;do{if((m|0)!=(k|0)?ea(g[b+((k<<2)+m<<2)+96>>2])!=ea(0.0):0){u=11;break a}k=k+1|0}while((k|0)<3);m=m+1|0;if((m|0)>=3){u=12;break}}if((u|0)==11)v=ea(g[b+456>>2]);else if((u|0)==12){t=ea(g[b+108>>2]);s=ea(g[b+124>>2]);r=ea(g[b+140>>2]);w=ea(g[b+156>>2]);x=ea(g[b+104>>2]);y=ea(g[b+120>>2]);z=ea(g[b+136>>2]);A=ea(t+x);x=ea(s+y);y=ea(r+z);v=ea(ea(-ea(w+ea(g[b+152>>2])))/ea(T(ea(ea(ea(A*A)+ea(x*x))+ea(y*y)))))}if(d){m=0;b:while(1){k=0;do{if((m|0)!=(k|0)?ea(g[b+((k<<2)+m<<2)+96>>2])!=ea(0.0):0){u=20;break b}k=k+1|0}while((k|0)<3);m=m+1|0;if((m|0)>=3){u=21;break}}if((u|0)==20){B=ea(g[b+460>>2]);C=v;break}else if((u|0)==21){y=ea(g[b+108>>2]);x=ea(g[b+124>>2]);A=ea(g[b+140>>2]);w=ea(g[b+156>>2]);z=ea(g[b+104>>2]);r=ea(g[b+120>>2]);s=ea(g[b+136>>2]);t=ea(y-z);z=ea(x-r);r=ea(A-s);B=ea(ea(w-ea(g[b+152>>2]))/ea(T(ea(ea(ea(t*t)+ea(z*z))+ea(r*r)))));C=v;break}}else{D=v;u=14}}else{D=ea(g[b+456>>2]);u=14}while(0);if((u|0)==14){B=ea(g[b+460>>2]);C=D}if(C==ea(0.0))E=ea(1.0);else E=ea(ea(1.0)/C);if(B==ea(0.0))F=ea(1.0);else F=ea(ea(1.0)/B);g[p+580>>2]=(a[p+5972>>0]|0)!=0?ea(-1.0):ea(1.0);g[p+584>>2]=C;g[p+588>>2]=B;g[p+592>>2]=F;T0b(f,b,1);C=ea(g[b+396>>2]);D=ea(g[b+400>>2]);v=ea(g[b+404>>2]);r=ea(g[b+408>>2]);z=ea(g[f+8>>2]);t=ea(g[f+12>>2]);w=ea(C*z);C=ea(v*z);v=ea(D*t);D=ea(r*t);r=ea(g[f>>2]);s=ea(g[f+4>>2]);A=ea(w+r);w=ea(v+s);v=ea(C+A);C=ea(D+w);D=ea(z+r);z=ea(t+s);t=ea((v>D?D:v)-(A<r?r:A));u=t<ea(0.0);A=u?ea(0.0):t;t=ea((C>z?z:C)-(w<s?s:w));u=t<ea(0.0);w=u?ea(0.0):t;t=ea(ea(ea(1.0)/A)+ea(1.0));s=ea(ea(ea(1.0)/w)+ea(1.0));g[p+596>>2]=A;g[p+600>>2]=w;g[p+604>>2]=t;g[p+608>>2]=s;s=ea(B*E);G=1.0-+s;E=ea(G*+F);B=ea(s*F);g[p+612>>2]=ea(G);g[p+616>>2]=s;g[p+620>>2]=E;g[p+624>>2]=B;u=b+609|0;if((a[u>>0]|0)!=0?(a[o>>0]|0)!=0:0){o=b+96|0;B=ea(g[b+596>>2]);E=ea(g[b+456>>2]);s=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(o,ea(g[b+452>>2]),B,E,s)|0;else{F=ea(g[b+448>>2]);t=ea(-F);oMc(o,ea(B*t),ea(B*F),t,F,E,s)|0}a[u>>0]=0}u=b+96|0;if((!(ea(g[b+108>>2])!=ea(0.0))?!(ea(g[b+124>>2])!=ea(0.0)):0)?!(ea(g[b+140>>2])!=ea(0.0)):0){o=ea(g[b+156>>2])!=ea(1.0);H=o?ea(0.0):ea(1.0)}else H=ea(0.0);s=ea(g[b+448>>2]);g[p+628>>2]=ea(s*ea(g[b+596>>2]));g[p+632>>2]=s;g[p+636>>2]=ea(0.0);g[p+640>>2]=H;l=p+3620|0;j=u+0|0;q=l+64|0;do{c[l>>2]=c[j>>2];l=l+4|0;j=j+4|0}while((l|0)<(q|0));qMc(u,f)|0;l=p+3684|0;j=f+0|0;q=l+64|0;do{c[l>>2]=c[j>>2];l=l+4|0;j=j+4|0}while((l|0)<(q|0));i=e;return}function F$b(b){b=b|0;var c=0,d=0,e=Im,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=i;if(!(a[b+613>>0]|0))d=0;else{e=ea(g[b+456>>2]);i=c;return ea(e)}a:while(1){f=0;do{if((d|0)!=(f|0)?ea(g[b+((f<<2)+d<<2)+96>>2])!=ea(0.0):0){h=8;break a}f=f+1|0}while((f|0)<3);d=d+1|0;if((d|0)>=3){h=9;break}}if((h|0)==8){e=ea(g[b+456>>2]);i=c;return ea(e)}else if((h|0)==9){j=ea(g[b+108>>2]);k=ea(g[b+124>>2]);l=ea(g[b+140>>2]);m=ea(g[b+156>>2]);n=ea(g[b+104>>2]);o=ea(g[b+120>>2]);p=ea(g[b+136>>2]);q=ea(j+n);n=ea(k+o);o=ea(l+p);e=ea(ea(-ea(m+ea(g[b+152>>2])))/ea(T(ea(ea(ea(q*q)+ea(n*n))+ea(o*o)))));i=c;return ea(e)}return ea(0.0)}function G$b(b){b=b|0;var c=0,d=0,e=Im,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=i;if(!(a[b+613>>0]|0))d=0;else{e=ea(g[b+460>>2]);i=c;return ea(e)}a:while(1){f=0;do{if((d|0)!=(f|0)?ea(g[b+((f<<2)+d<<2)+96>>2])!=ea(0.0):0){h=8;break a}f=f+1|0}while((f|0)<3);d=d+1|0;if((d|0)>=3){h=9;break}}if((h|0)==8){e=ea(g[b+460>>2]);i=c;return ea(e)}else if((h|0)==9){j=ea(g[b+108>>2]);k=ea(g[b+124>>2]);l=ea(g[b+140>>2]);m=ea(g[b+156>>2]);n=ea(g[b+104>>2]);o=ea(g[b+120>>2]);p=ea(g[b+136>>2]);q=ea(j-n);n=ea(k-o);o=ea(l-p);e=ea(ea(m-ea(g[b+152>>2]))/ea(T(ea(ea(ea(q*q)+ea(n*n))+ea(o*o)))));i=c;return ea(e)}return ea(0.0)}function H$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d;g=CTb(c[b+24>>2]|0,45)|0;if(((g|0)!=0?(a[g+28>>0]|0)!=0:0)?(bac(g)|0)!=0:0){h=bac(g)|0;i=d;return h|0}g=(X8b()|0)+464|0;b=c[g>>2]|0;if(!b){h=0;i=d;return h|0}c[f>>2]=b;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,f);j=c[e>>2]|0;k=c[b+28>>2]|0;if((j|0)==-1){l=k+(c[b+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((l|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[l+4>>2]|0,(b|0)!=0):0)m=b;else n=14}else n=14;if((n|0)==14)m=hQb(c[g>>2]|0)|0;h=m;i=d;return h|0}function I$b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[a+376>>2]|0)!=1){i=b;return}d=H$b(a)|0;if(!d){i=b;return}e=c[158074]|0;f=a+636|0;Bcc(f,14,e);aac(d,a);Bcc(f,15,e);i=b;return}function J$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im;d=i;i=i+48|0;e=d+32|0;f=d+16|0;h=d;j=c[a+376>>2]|0;if((j|0)==3)k=6;else if((j|0)==4)k=0;else k=7;j=b?k&1:k;if(!j){i=d;return}B$b(f,a);k=a+380|0;if((KLc()|0)==1){l=ea(g[k>>2]);do if(!(l<=ea(.0404499993)))if(l<ea(1.0)){m=ea(+U(+ea(ea(l+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{m=ea(+U(+l,2.20000005));break}else m=ea(l/ea(12.9200001));while(0);l=ea(g[a+384>>2]);do if(!(l<=ea(.0404499993)))if(l<ea(1.0)){n=ea(+U(+ea(ea(l+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{n=ea(+U(+l,2.20000005));break}else n=ea(l/ea(12.9200001));while(0);l=ea(g[a+388>>2]);do if(!(l<=ea(.0404499993)))if(l<ea(1.0)){o=ea(+U(+ea(ea(l+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{o=ea(+U(+l,2.20000005));break}else o=ea(l/ea(12.9200001));while(0);l=ea(g[a+392>>2]);g[h>>2]=m;g[h+4>>2]=n;g[h+8>>2]=o;g[h+12>>2]=l}else{c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2]};c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];U0b(j,e,h);i=d;return}function K$b(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;k=i;i=i+144|0;l=k+128|0;m=k+64|0;n=k;r1b(e,d);e=a[b+612>>0]|0;if(!(e<<24>>24!=0|j)){g[h>>2]=ea(ea(g[d+92>>2])-f);i=k;return}j=b+608|0;if(!((a[j>>0]|0)==0|e<<24>>24==0)){e=b+32|0;g[l>>2]=ea(1.0);g[l+4>>2]=ea(1.0);g[l+8>>2]=ea(-1.0);iMc(e,l)|0;PGc(m,BTb(c[b+24>>2]|0)|0);cMc(e,m)|0;a[j>>0]=0}qMc(b+32|0,n)|0;o=ea(g[n+48>>2]);p=ea(g[n+52>>2]);q=ea(g[n+56>>2]);r=ea(g[n+32>>2]);s=ea(g[n+36>>2]);t=ea(g[n+40>>2]);u=ea(T(ea(ea(ea(r*r)+ea(s*s))+ea(t*t))));if(u>ea(g[150276])){v=ea(r/u);w=ea(s/u);x=ea(t/u)}else{u=ea(g[150284]);t=ea(g[150285]);v=u;w=t;x=ea(g[150286])}t=ea(-v);u=ea(-w);s=ea(-x);g[d+64>>2]=t;g[d+68>>2]=u;g[d+72>>2]=s;r=ea(-ea(ea(q*s)+ea(ea(p*u)+ea(o*t))));g[d+76>>2]=ea(r-ea(g[b+456>>2]));g[d+80>>2]=v;g[d+84>>2]=w;g[d+88>>2]=x;r=ea(-ea(ea(q*x)+ea(ea(p*w)+ea(o*v))));b=d+92|0;g[b>>2]=r;g[h>>2]=r;g[b>>2]=ea(ea(g[b>>2])+f);i=k;return}function L$b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+80|0;f=e+64|0;h=e;j=d+608|0;if((a[j>>0]|0)!=0?(a[d+612>>0]|0)!=0:0){k=d+32|0;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(-1.0);iMc(k,f)|0;PGc(h,BTb(c[d+24>>2]|0)|0);cMc(k,h)|0;a[j>>0]=0}qMc(d+32|0,b)|0;i=e;return}function M$b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im;e=i;i=i+192|0;f=e+88|0;h=e+80|0;j=e+16|0;k=e;g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);g[f+32>>2]=ea(0.0);g[f+36>>2]=ea(0.0);g[f+40>>2]=ea(0.0);g[f+48>>2]=ea(0.0);g[f+52>>2]=ea(0.0);g[f+56>>2]=ea(0.0);g[f+64>>2]=ea(0.0);g[f+68>>2]=ea(0.0);g[f+72>>2]=ea(0.0);g[f+80>>2]=ea(0.0);g[f+84>>2]=ea(0.0);g[f+88>>2]=ea(0.0);l=N$b(b)|0;m=j+0|0;n=l+0|0;o=m+64|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));aFi(d+532|0,l|0,64)|0;l=d+596|0;rGc(k,BTb(c[b+24>>2]|0)|0);c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];k=b+460|0;K$b(b,f,j,ea(g[k>>2]),h,0);P$b(b,d,f,6);if(a[b+618>>0]|0){aFi(d+196|0,b+468|0,128)|0;c[d+324>>2]=2;i=e;return}p=ea(g[h>>2]);h=0;do{q=ea(g[b+(h<<2)+468>>2]);if(q!=ea(0.0))r=q;else r=ea(g[k>>2]);g[d+(h<<2)+196>>2]=ea(p+r);h=h+1|0}while((h|0)!=32);c[d+324>>2]=1;i=e;return}function N$b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=0;d=i;i=i+80|0;e=d+64|0;f=d;h=b+610|0;if(!(a[h>>0]|0)){j=b+160|0;i=d;return j|0}k=b+609|0;if((a[k>>0]|0)!=0?(a[b+613>>0]|0)!=0:0){l=b+96|0;m=ea(g[b+596>>2]);n=ea(g[b+456>>2]);o=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(l,ea(g[b+452>>2]),m,n,o)|0;else{p=ea(g[b+448>>2]);q=ea(-p);oMc(l,ea(m*q),ea(m*p),q,p,n,o)|0}a[k>>0]=0}k=b+96|0;l=b+608|0;if((a[l>>0]|0)!=0?(a[b+612>>0]|0)!=0:0){r=b+32|0;g[e>>2]=ea(1.0);g[e+4>>2]=ea(1.0);g[e+8>>2]=ea(-1.0);iMc(r,e)|0;PGc(f,BTb(c[b+24>>2]|0)|0);cMc(r,f)|0;a[l>>0]=0}l=b+160|0;dMc(k,b+32|0,l);a[h>>0]=0;j=l;i=d;return j|0}function O$b(a,b){a=a|0;b=b|0;var d=0;d=i;rGc(a,BTb(c[b+24>>2]|0)|0);i=d;return}function P$b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im;h=i;i=i+48|0;j=h+24|0;k=h+12|0;l=h;a[d>>0]=a[b+616>>0]|0;m=d+4|0;n=b+24|0;rGc(k,BTb(c[n>>2]|0)|0);c[m+0>>2]=c[k+0>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];g[d+16>>2]=ea(g[b+452>>2]);g[d+20>>2]=ea(g[b+448>>2]);T0b(j,b,0);o=ea(g[b+400>>2]);p=ea(g[b+408>>2]);q=ea(g[j+12>>2]);r=ea(o*q);o=ea(p*q);p=ea(g[j+4>>2]);s=ea(r+p);r=ea(o+s);o=ea(q+p);q=ea((r>o?o:r)-(s<p?p:s));j=q<ea(0.0);c[d+24>>2]=j?0:~~q;J1b(d,e,f);c[d+188>>2]=f;c[d+324>>2]=0;c[d+192>>2]=c[b+412>>2];aFi(d+532|0,N$b(b)|0,64)|0;b=d+596|0;rGc(l,BTb(c[n>>2]|0)|0);c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];i=h;return}function Q$b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+48|0;h=f+28|0;j=f+24|0;k=f;l=f+20|0;m=f+8|0;n=b+622|0;if(a[n>>0]|0){Krd(559168,0,3653512,1041,1,c[b+4>>2]|0,0,0);i=f;return}o=ea(g[b+404>>2]);if(o<=ea(9.99999974e-06)){i=f;return}p=ea(g[b+408>>2]);if(p<=ea(9.99999974e-06)){i=f;return}q=ea(g[b+396>>2]);if(!(!(q>=ea(1.0))&!(ea(o+q)<=ea(0.0)))){i=f;return}q=ea(g[b+400>>2]);if(!(!(q>=ea(1.0))&!(ea(p+q)<=ea(0.0)))){i=f;return}q=ea(g[b+460>>2]);p=ea(g[b+456>>2]);if(q<=p){i=f;return}if(!(a[b+616>>0]|0)){if(p<=ea(0.0)){i=f;return}p=ea(g[b+452>>2]);if(p<ea(0.0))r=ea(-p);else r=p;if(r<ea(9.99999997e-07)){i=f;return}}else{r=ea(g[b+448>>2]);if(r<ea(0.0))s=ea(-r);else s=r;if(s<ea(9.99999997e-07)){i=f;return}}c[h+8>>2]=0;c[h+4>>2]=0;c[h>>2]=0;cUb(b,555104,h);if(Btc()|0){t=(Xbd()|0)+640|0;u=c[t+4>>2]|0;v=k;c[v>>2]=c[t>>2];c[v+4>>2]=u;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];tbd(h,b)}k=c[b+24>>2]|0;if(!(((k|0)!=0?vTb(k)|0:0)?(a[b+28>>0]|0)!=0:0))w=21;if((w|0)==21?(c[d+12>>2]&1|0)==0:0){i=f;return}a[n>>0]=1;k=c[b+412>>2]|0;u=BLc()|0;if((k|0)!=0&(u|0)!=0)In[c[(c[u>>2]|0)+20>>2]&4095](u,k);Bac(Lac()|0);S$b(d,V$b(b)|0,e);k=d+4|0;do if(!(c[k>>2]|0)){u=b+356|0;v=c[u>>2]|0;if(v){c[j>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(h,v,j);t=c[h>>2]|0;x=c[v+28>>2]|0;if((t|0)==-1){y=x+(c[v+32>>2]<<3)|0;break}else{y=x+(t<<3)|0;break}}else y=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((y|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[y+4>>2]|0,(v|0)!=0):0)z=v;else w=35}else w=35;if((w|0)==35){v=hQb(c[u>>2]|0)|0;if(!v)break;else z=v}v=b+360|0;c[e+1068>>2]=z;t=a[v>>0]|0;if(!(t&1))A=(t&255)>>>1;else A=c[b+364>>2]|0;if(!A)B=-1;else B=vvd(v)|0;c[e+1072>>2]=B}}else{v=k;t=c[v+4>>2]|0;x=e+1068|0;c[x>>2]=c[v>>2];c[x+4>>2]=t}while(0);k=e+240|0;if(a[e+913>>0]|0){c[l>>2]=c[153134];c[h+0>>2]=c[l+0>>2];l=bOb(612,h,0,16,3653512,1093)|0;h=l+196|0;g[l+364>>2]=ea(0.0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;g[l+368>>2]=ea(0.0);g[l+372>>2]=ea(0.0);g[l+380>>2]=ea(0.0);g[l+384>>2]=ea(0.0);g[l+388>>2]=ea(0.0);g[l+396>>2]=ea(0.0);g[l+400>>2]=ea(0.0);g[l+404>>2]=ea(0.0);g[l+412>>2]=ea(0.0);g[l+416>>2]=ea(0.0);g[l+420>>2]=ea(0.0);g[l+428>>2]=ea(0.0);g[l+432>>2]=ea(0.0);g[l+436>>2]=ea(0.0);g[l+444>>2]=ea(0.0);g[l+448>>2]=ea(0.0);g[l+452>>2]=ea(0.0);g[l+460>>2]=ea(0.0);g[l+464>>2]=ea(0.0);g[l+468>>2]=ea(0.0);g[l+476>>2]=ea(0.0);g[l+480>>2]=ea(0.0);g[l+484>>2]=ea(0.0);g[l+492>>2]=ea(0.0);g[l+496>>2]=ea(0.0);g[l+500>>2]=ea(0.0);g[l+508>>2]=ea(0.0);g[l+512>>2]=ea(0.0);g[l+516>>2]=ea(0.0);g[l+524>>2]=ea(0.0);g[l+528>>2]=ea(0.0);g[l+532>>2]=ea(0.0);g[l+540>>2]=ea(0.0);g[l+544>>2]=ea(0.0);g[l+548>>2]=ea(0.0);g[l+556>>2]=ea(0.0);g[l+560>>2]=ea(0.0);g[l+564>>2]=ea(0.0);c[l+604>>2]=0;c[l+608>>2]=-1;h=c[d>>2]|0;rGc(m,BTb(c[h+24>>2]|0)|0);u9b(h,m,e+1068|0,k,l);if((c[e+928>>2]|0)!=0&(c[e+80>>2]|0)!=0)c[l+596>>2]=e+16;c[e+1024>>2]=l}y1b(k,e);a[e+1076>>0]=1;a[n>>0]=0;i=f;return}function R$b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e;c[f+4>>2]=0;c[f+8>>2]=-1;c[f>>2]=b;g=f+12|0;c[g>>2]=4;c[f+16>>2]=0;c[f+20>>2]=0;if(a[b+617>>0]|0)c[g>>2]=6;Q$b(b,f,d);i=e;return}function S$b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=b+12|0;if(!(c[g>>2]&2))h=0;else h=c[(Lac()|0)+116>>2]|0;c[e+848>>2]=Hac(Lac()|0)|0;c[e+852>>2]=Fac(Lac()|0)|0;c[e+856>>2]=Dac(Lac()|0)|0;c[e+860>>2]=Iac(Lac()|0)|0;c[e+864>>2]=Gac(Lac()|0)|0;c[e+868>>2]=Eac(Lac()|0)|0;j=Lac()|0;c[e+872>>2]=b4b(j)|0;c[e+876>>2]=c4b(j)|0;c[e+880>>2]=c[j+24>>2];j=c[(c[b>>2]|0)+372>>2]|0;c[e+884>>2]=b4b(j)|0;c[e+888>>2]=c4b(j)|0;c[e+892>>2]=c[j+24>>2];j=BLc()|0;if(j)co[c[(c[j>>2]|0)+68>>2]&2047](j,e+992|0,e+1008|0);c[e+896>>2]=c[e+1008>>2];c[e+900>>2]=c[e+992>>2];c[e+904>>2]=c[e+1016>>2];I1b(e,h,e+848|0);M$b(c[b>>2]|0,e+240|0);c[e+924>>2]=e+16;c[e+936>>2]=c[b+16>>2];c[e+940>>2]=c[b+20>>2];c[e+928>>2]=h;c[e+932>>2]=c[(Lac()|0)+112>>2];a[e+913>>0]=(c[g>>2]|0)>>>2&1;if((d|0)!=1){k=0;l=e+912|0;a[l>>0]=k;m=e+916|0;c[m>>2]=d;n=(h|0)!=0;o=e+76|0;p=n&1;a[o>>0]=p;U$b(e,0);i=f;return}k=(Fwc(Vwc()|0)|0)&1^1;l=e+912|0;a[l>>0]=k;m=e+916|0;c[m>>2]=d;n=(h|0)!=0;o=e+76|0;p=n&1;a[o>>0]=p;U$b(e,0);i=f;return}function T$b(a){a=a|0;return 0}function U$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+64|0;e=d+52|0;f=d+48|0;g=d+32|0;h=d+16|0;j=d+12|0;k=d;l=_tc()|0;m=a+952|0;n=c[153134]|0;c[g>>2]=0;c[g+4>>2]=n;c[g+8>>2]=0;c[g+12>>2]=0;o=a+956|0;p=c[o>>2]|0;q=c[m>>2]|0;r=p-q>>4;if(l>>>0<=r>>>0){if(l>>>0<r>>>0?(s=q+(l<<4)|0,(p|0)!=(s|0)):0){q=p;while(1){p=q+-16|0;c[o>>2]=p;if((c[q+-4>>2]|0)>-1){t=c[p>>2]|0;c[f>>2]=c[q+-12>>2];c[e+0>>2]=c[f+0>>2];eOb(t,e);c[p>>2]=0;u=c[o>>2]|0}else u=p;if((u|0)==(s|0))break;else q=u}}}else V0b(m,l-r|0,g);r=c[g>>2]|0;c[f>>2]=n;c[e+0>>2]=c[f+0>>2];eOb(r,e);c[g>>2]=0;g=a+964|0;r=c[153134]|0;c[h>>2]=0;c[h+4>>2]=r;c[h+8>>2]=0;c[h+12>>2]=0;n=a+968|0;u=c[n>>2]|0;q=c[g>>2]|0;s=u-q>>4;if(l>>>0<=s>>>0){if(l>>>0<s>>>0?(o=q+(l<<4)|0,(u|0)!=(o|0)):0){q=u;while(1){u=q+-16|0;c[n>>2]=u;if((c[q+-4>>2]|0)>-1){p=c[u>>2]|0;c[f>>2]=c[q+-12>>2];c[e+0>>2]=c[f+0>>2];eOb(p,e);c[u>>2]=0;v=c[n>>2]|0}else v=u;if((v|0)==(o|0))break;else q=v}}}else W0b(g,l-s|0,h);s=c[h>>2]|0;c[f>>2]=r;c[e+0>>2]=c[f+0>>2];eOb(s,e);c[h>>2]=0;h=l<<2;s=h+15|0;r=(l|0)!=0;if(s>>>0<2e3)if(r){v=i;i=i+((1*s|0)+15&-16)|0;w=0;x=v}else{w=0;x=0}else if(r){c[j>>2]=c[153134];c[e+0>>2]=c[j+0>>2];j=cOb(s,16,e,0,3653512,983)|0;w=j;x=j}else{w=0;x=0}j=x+15&-16;x=j;PEi(j|0,0,h|0)|0;c[x>>2]=$tc()|0;if(!b?(b=BLc()|0,(b|0)!=0):0)co[c[(c[b>>2]|0)+72>>2]&2047](b,x,l);b=a+976|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;h=a+988|0;j=c[h>>2]|0;do if((j&2147483647)>>>0<l>>>0)if((j|0)>-1){c[h>>2]=l;s=c[b>>2]|0;c[f>>2]=c[a+980>>2];c[e+0>>2]=c[f+0>>2];c[b>>2]=hOb(s,l*12|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+980>>2];c[e+0>>2]=c[f+0>>2];s=cOb(l*12|0,4,e,0,3653512,352)|0;YEi(s|0,c[b>>2]|0,(c[a+984>>2]|0)*12|0)|0;c[h>>2]=l;c[b>>2]=s;break}while(0);h=a+984|0;j=c[h>>2]|0;if(j>>>0<l>>>0?(s=c[b>>2]|0,r=s+(l*12|0)|0,(j|0)!=(l|0)):0){v=s+(j*12|0)|0;do{if(v){c[v+0>>2]=c[k+0>>2];c[v+4>>2]=c[k+4>>2];c[v+8>>2]=c[k+8>>2]}v=v+12|0}while((v|0)!=(r|0))}c[h>>2]=l;if((l|0)>0){h=a+240|0;r=0;do{v=c[x+(r<<2)>>2]|0;if(v){k=c[v>>2]|0;j=(v|0)==($tc()|0);s=j?0:k;k=c[m>>2]|0;j=k+(s<<4)|0;q=c[g>>2]|0;o=q+(s<<4)|0;n=c[v+12>>2]|0;u=k+(s<<4)+8|0;c[u>>2]=n;p=k+(s<<4)+12|0;t=c[p>>2]|0;do if((t&2147483647)>>>0<n>>>0)if((t|0)>-1){c[p>>2]=n;y=c[j>>2]|0;c[f>>2]=c[k+(s<<4)+4>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(y,n,1,e,0,3653512,370)|0;break}else{c[f>>2]=c[k+(s<<4)+4>>2];c[e+0>>2]=c[f+0>>2];y=cOb(n,1,e,0,3653512,352)|0;YEi(y|0,c[j>>2]|0,c[u>>2]|0)|0;c[p>>2]=n;c[j>>2]=y;break}while(0);p=q+(s<<4)+8|0;c[p>>2]=n;u=q+(s<<4)+12|0;k=c[u>>2]|0;do if((k&2147483647)>>>0<n>>>0)if((k|0)>-1){c[u>>2]=n;t=c[o>>2]|0;c[f>>2]=c[q+(s<<4)+4>>2];c[e+0>>2]=c[f+0>>2];y=hOb(t,n<<2,4,e,0,3653512,370)|0;c[o>>2]=y;z=y;break}else{c[f>>2]=c[q+(s<<4)+4>>2];c[e+0>>2]=c[f+0>>2];y=cOb(n<<2,4,e,0,3653512,352)|0;YEi(y|0,c[o>>2]|0,c[p>>2]<<2|0)|0;c[u>>2]=n;c[o>>2]=y;z=y;break}else z=c[o>>2]|0;while(0);guc(v,h,c[j>>2]|0,z);u=c[b>>2]|0;c[u+(s*12|0)>>2]=c[j>>2];c[u+(s*12|0)+4>>2]=c[o>>2];c[u+(s*12|0)+8>>2]=n}r=r+1|0}while((r|0)<(l|0));A=b}else A=b;c[a+908>>2]=c[A>>2];if(!w){i=d;return}c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];eOb(w,e);i=d;return}function V$b(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im;e=i;f=c[d+464>>2]|0;if((f|0)==-1)h=wSc(rSc()|0)|0;else h=f;if((h&-2|0)!=2){j=h;i=e;return j|0}f=b[310590]|0;if(!((f&255)<<24>>24!=0&(h|0)==2|(h|0)==3&(f&65535)>255)){j=1;i=e;return j|0}f=d+616|0;if(a[f>>0]|0){j=1;i=e;return j|0}if(!(rBc()|0)){j=1;i=e;return j|0}k=d+609|0;if((a[k>>0]|0)!=0?(a[d+613>>0]|0)!=0:0){l=d+96|0;m=ea(g[d+596>>2]);n=ea(g[d+456>>2]);o=ea(g[d+460>>2]);if(!(a[f>>0]|0))mMc(l,ea(g[d+452>>2]),m,n,o)|0;else{p=ea(g[d+448>>2]);q=ea(-p);oMc(l,ea(m*q),ea(m*p),q,p,n,o)|0}a[k>>0]=0}if(ea(g[d+104>>2])!=ea(0.0)){j=1;i=e;return j|0}k=ea(g[d+120>>2])!=ea(0.0);j=k?1:h;i=e;return j|0}function W$b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+292|0;a=c[f>>2]|0;if(a){c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);g=c[d>>2]|0;h=c[a+28>>2]|0;if((g|0)==-1){j=h+(c[a+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((j|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[j+4>>2]|0)!=0:0){k=0;i=b;return k|0}}if(hQb(c[f>>2]|0)|0){k=0;i=b;return k|0}}f=ECc()|0;k=mo[c[(c[f>>2]|0)+96>>2]&4095](f)|0;i=b;return k|0}function X$b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=0;h=i;i=i+32|0;j=h+8|0;k=h;l=ea(g[b+404>>2]);if(l<=ea(9.99999974e-06)){i=h;return}m=ea(g[b+408>>2]);if(m<=ea(9.99999974e-06)){i=h;return}n=ea(g[b+396>>2]);if(!(!(n>=ea(1.0))&!(ea(l+n)<=ea(0.0)))){i=h;return}n=ea(g[b+400>>2]);if(!(!(n>=ea(1.0))&!(ea(m+n)<=ea(0.0)))){i=h;return}n=ea(g[b+460>>2]);m=ea(g[b+456>>2]);if(n<=m){i=h;return}if(!(a[b+616>>0]|0)){if(m<=ea(0.0)){i=h;return}m=ea(g[b+452>>2]);if(m<ea(0.0))o=ea(-m);else o=m;if(o<ea(9.99999997e-07)){i=h;return}}else{o=ea(g[b+448>>2]);if(o<ea(0.0))p=ea(-o);else p=o;if(p<ea(9.99999997e-07)){i=h;return}}q=c[b+288>>2]|0;if(!e)m_b(q,c[d+916>>2]|0,d,0);else co[e&2047](b,q,d);if((f&32|0)==0?(c[j+8>>2]=0,c[j+4>>2]=0,c[j>>2]=0,cUb(b,555144,j),(Btc()|0)!=0):0){f=(Xbd()|0)+656|0;d=c[f+4>>2]|0;q=k;c[q>>2]=c[f>>2];c[q+4>>2]=d;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];tbd(j,b)}b=ync()|0;In[c[(c[b>>2]|0)+140>>2]&4095](b,0);Wld();i=h;return}function Y$b(b){b=b|0;var c=0,d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im;c=i;if(!(Q9b(1)|0)){d=0;i=c;return d|0}e=b+609|0;if((a[e>>0]|0)!=0?(a[b+613>>0]|0)!=0:0){f=b+96|0;h=ea(g[b+596>>2]);j=ea(g[b+456>>2]);k=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(f,ea(g[b+452>>2]),h,j,k)|0;else{l=ea(g[b+448>>2]);m=ea(-l);oMc(f,ea(h*m),ea(h*l),m,l,j,k)|0}a[e>>0]=0}if(ea(g[b+104>>2])!=ea(0.0)){d=0;i=c;return d|0}d=ea(g[b+120>>2])==ea(0.0);i=c;return d|0}function Z$b(a){a=a|0;var b=0,c=Im,d=Im;b=i;c=ea(wyc());d=ea(g[a+460>>2]);i=b;return ea(d<c?d:c)}function _$b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+32|0;d=b+24|0;e=b+16|0;f=b;g=ync()|0;h=a+16|0;In[c[(c[g>>2]|0)+180>>2]&4095](f,g);c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];f=tBc()|0;if(!f)j=0;else j=c[f+4>>2]|0;c[a+36>>2]=j;j=n8b()|0;f=c[j>>2]|0;do if(!f)k=0;else{c[e>>2]=f;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,e);l=c[d>>2]|0;m=c[h+28>>2]|0;if((l|0)==-1){n=m+(c[h+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((n|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[n+4>>2]|0,(h|0)!=0):0)o=h;else p=12}else p=12;if((p|0)==12){h=hQb(c[j>>2]|0)|0;if(!h){k=0;break}else o=h}k=c[o+4>>2]|0}while(0);c[a+32>>2]=k;k=a+104|0;o=(mo[c[(c[g>>2]|0)+120>>2]&4095](g)|0)+0|0;j=k+64|0;do{c[k>>2]=c[o>>2];k=k+4|0;o=o+4|0}while((k|0)<(j|0));k=a+40|0;o=(mo[c[(c[g>>2]|0)+116>>2]&4095](g)|0)+0|0;j=k+64|0;do{c[k>>2]=c[o>>2];k=k+4|0;o=o+4|0}while((k|0)<(j|0));k=a+168|0;o=(mo[c[(c[g>>2]|0)+124>>2]&4095](g)|0)+0|0;j=k+64|0;do{c[k>>2]=c[o>>2];k=k+4|0;o=o+4|0}while((k|0)<(j|0));i=b;return}function $$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=ync()|0;j=a+32|0;k=c[j>>2]|0;do if(!k){l=n8b()|0;m=13}else{c[g>>2]=k;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(e,n,g);o=c[e>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[q+4>>2]|0,(n|0)!=0):0){r=n8b()|0;s=n}else m=12}else m=12;if((m|0)==12){n=hQb(c[j>>2]|0)|0;o=n8b()|0;if(!n){l=o;m=13;break}else{r=o;s=n}}c[r>>2]=c[s+4>>2];y$b(s,b,0)}while(0);if((m|0)==13)c[l>>2]=0;l=a+36|0;b=c[l>>2]|0;if(!b)t=0;else{c[f>>2]=b;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,f);s=c[e>>2]|0;r=c[b+28>>2]|0;if((s|0)==-1){u=r+(c[b+32>>2]<<3)|0;break}else{u=r+(s<<3)|0;break}}else u=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((u|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[u+4>>2]|0,(b|0)!=0):0)v=b;else m=24}else m=24;if((m|0)==24)v=hQb(c[l>>2]|0)|0;t=v}oBc(t,0,-1,0);In[c[(c[h>>2]|0)+176>>2]&4095](h,a+16|0);In[c[(c[h>>2]|0)+108>>2]&4095](h,a+168|0);In[c[(c[h>>2]|0)+104>>2]&4095](h,a+104|0);In[c[(c[h>>2]|0)+100>>2]&4095](h,a+40|0);s1b(ync()|0);i=d;return}function a0b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0;h=i;i=i+1344|0;j=h+1312|0;k=h+1080|0;l=h;m=c[158074]|0;m8b();if(c[141984]|0)ble();if(c[141986]|0)cle();if(c[141976]|0)Zke();c[k>>2]=0;c[k+4>>2]=0;n=k+16|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;n=(d&8|0)==0;if(n)_$b(k);o=n8b()|0;if(!b)p=0;else p=c[b+4>>2]|0;c[o>>2]=p;p=b+615|0;if(a[p>>0]|0){T0b(j,b,1);q=ea(g[b+396>>2]);r=ea(g[b+400>>2]);s=ea(g[b+404>>2]);t=ea(g[b+408>>2]);u=ea(g[j+8>>2]);v=ea(g[j+12>>2]);w=ea(q*u);q=ea(s*u);s=ea(r*v);r=ea(t*v);t=ea(g[j>>2]);x=ea(g[j+4>>2]);y=ea(w+t);w=ea(s+x);s=ea(q+y);q=ea(r+w);r=ea(u+t);u=ea(v+x);v=ea((s>r?r:s)-(y<t?t:y));y=ea((q>u?u:q)-(w<x?x:w));o=y<ea(0.0);w=o?ea(0.0):y;if(w!=ea(0.0)){o=v<ea(0.0);z=ea((o?ea(0.0):v)/w)}else z=ea(1.0);g[b+596>>2]=z;a[b+609>>0]=1;a[b+610>>0]=1;a[p>>0]=1}C1b(l);p=j+4|0;c[p>>2]=0;o=j+8|0;c[o>>2]=-1;c[j>>2]=b;A=j+12|0;c[A>>2]=5;c[j+16>>2]=0;c[j+20>>2]=0;if(a[b+617>>0]|0)c[A>>2]=7;A=(e|0)==0;if(!A){c[p>>2]=e;e=a[f>>0]|0;if(!(e&1))B=(e&255)>>>1;else B=c[f+4>>2]|0;if(!B)C=-1;else C=vvd(f)|0;c[o>>2]=C}Q$b(b,j,l);j=ync()|0;if(!(a[j+5832>>0]|0)){ko[c[(c[j>>2]|0)+500>>2]&4095](j);if(mo[c[(c[j>>2]|0)+516>>2]&4095](j)|0){D=1;E=26}}else{D=0;E=26}if((E|0)==26){b0b(b,l,m,(A?1:33)|d);if(n)$$b(k,m);if(!(D<<24>>24)){E1b(l);i=h;return}}D=ync()|0;ko[c[(c[D>>2]|0)+504>>2]&4095](D);E1b(l);i=h;return}function b0b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+8|0;n=h;o=ea(g[b+404>>2]);if(o<=ea(9.99999974e-06)){i=h;return}p=ea(g[b+408>>2]);if(p<=ea(9.99999974e-06)){i=h;return}q=ea(g[b+396>>2]);if(!(!(q>=ea(1.0))&!(ea(o+q)<=ea(0.0)))){i=h;return}q=ea(g[b+400>>2]);if(!(!(q>=ea(1.0))&!(ea(p+q)<=ea(0.0)))){i=h;return}q=ea(g[b+460>>2]);p=ea(g[b+456>>2]);if(q<=p){i=h;return}if(!(a[b+616>>0]|0)){if(p<=ea(0.0)){i=h;return}p=ea(g[b+452>>2]);if(p<ea(0.0))r=ea(-p);else r=p;if(r<ea(9.99999997e-07)){i=h;return}}else{r=ea(g[b+448>>2]);if(r<ea(0.0))s=ea(-r);else s=r;if(s<ea(9.99999997e-07)){i=h;return}}if(!(a[d+1076>>0]|0)){i=h;return}t=b+621|0;if(a[t>>0]|0){if(!b)u=0;else u=c[b+4>>2]|0;Krd(559648,0,3653512,1761,512,u,0,0);i=h;return}if(!(a[(ync()|0)+5832>>0]|0)){u=ync()|0;ko[c[(c[u>>2]|0)+500>>2]&4095](u)}a[t>>0]=1;u=b+24|0;rGc(m,BTb(c[u>>2]|0)|0);v=b+436|0;s=ea(g[m>>2]);r=ea(s-ea(g[v>>2]));s=ea(g[m+4>>2]);p=ea(s-ea(g[b+440>>2]));s=ea(g[m+8>>2]);q=ea(s-ea(g[b+444>>2]));s=ea(g[(jLc()|0)+116>>2]);o=ea(p*s);p=ea(q*s);g[b+424>>2]=ea(r*s);g[b+428>>2]=o;g[b+432>>2]=p;c[v+0>>2]=c[m+0>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];m=n8b()|0;if(!b)w=0;else w=c[b+4>>2]|0;c[m>>2]=w;w=kbc()|0;m=0;do{v=c[w+(m<<2)+960>>2]|0;if(v)ko[v&4095](b);m=m+1|0}while((m|0)!=16);m=(f&32|0)!=0;if(!m?(c[j+8>>2]=0,c[j+4>>2]=0,c[j>>2]=0,cUb(b,555184,j),(Btc()|0)!=0):0){w=(Xbd()|0)+648|0;v=c[w+4>>2]|0;x=n;c[x>>2]=c[w>>2];c[x+4>>2]=v;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];tbd(j,b)}h0b(b,d);y$b(b,e,f|4);X$b(b,d,0,f);n=(f&1|0)!=0;if(!n?(a[b+28>>0]|0)==0:0)y=b+292|0;else{if(!(c[d+1068>>2]|0)){v=CTb(c[u>>2]|0,124)|0;if((v|0)!=0?(a[v+28>>0]|0)!=0:0)S1b(L1b()|0);i8b(n8b()|0)}v=c[b+288>>2]|0;x=b+292|0;w=c[x>>2]|0;if(!w)z=0;else{c[l>>2]=w;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(j,w,l);A=c[j>>2]|0;B=c[w+28>>2]|0;if((A|0)==-1){C=B+(c[w+32>>2]<<3)|0;break}else{C=B+(A<<3)|0;break}}else C=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((C|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[C+4>>2]|0,(w|0)!=0):0)D=w;else E=47}else E=47;if((E|0)==47)D=hQb(c[x>>2]|0)|0;z=D}l_b(v,z,0);y=x}x=c[y>>2]|0;if(!x)F=0;else{c[k>>2]=x;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(j,x,k);z=c[j>>2]|0;v=c[x+28>>2]|0;if((z|0)==-1){G=v+(c[x+32>>2]<<3)|0;break}else{G=v+(z<<3)|0;break}}else G=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((G|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[G+4>>2]|0,(x|0)!=0):0)H=x;else E=59}else E=59;if((E|0)==59)H=hQb(c[y>>2]|0)|0;F=H}c[b+348>>2]=F;a[t>>0]=0;if(!(!n?(a[b+28>>0]|0)==0:0)){if((!m?(m=CTb(c[u>>2]|0,92)|0,(m|0)!=0):0)?(a[m+28>>0]|0)!=0:0)cYb(m);Bcc(b+636|0,20,e)}D1b(d);if(!(f&64))a4b(c[b+372>>2]|0,0);Ccc(b+636|0);n_b(c[b+288>>2]|0);f=b+340|0;if(c[f>>2]|0){d=Gzc()|0;Jzc(d,c[f>>2]|0);c[f>>2]=0}f=b+344|0;if(!(c[f>>2]|0)){i=h;return}b=Gzc()|0;Jzc(b,c[f>>2]|0);c[f>>2]=0;i=h;return}function c0b(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;k=i;i=i+1504|0;l=k+16|0;m=k+1184|0;n=k+40|0;o=k+1416|0;p=k+1492|0;q=k;r=k+104|0;s=k+1480|0;t=ync()|0;u=mo[c[(c[t>>2]|0)+668>>2]&4095](t)|0;if(e){t=da(c[137788]|0,(c[e+8>>2]|0)>>>21)|0;v=t+89|0;w=v>>5;x=c[137786]|0;y=(1<<v-(w<<5)&c[x+(w<<2)>>2]|0)==0?0:e;w=t+84|0;t=w>>5;if(!(1<<w-(t<<5)&c[x+(t<<2)>>2])){z=y;A=3}else{B=y;C=e}}else{z=0;A=3}if((A|0)==3){B=z;C=0}z=c[158074]|0;y=(B|0)!=0;do if(y){if(!(a[B+127>>0]|0)){Krd(559224,0,3653512,1381,1,0,0,0);D=0;i=k;return D|0}t=c[B+48>>2]|0;if((t|0)!=0?(x=c[t+32>>2]|0,!((x|0)==3|(x|0)==5)):0){if(!d)E=0;else E=c[d+4>>2]|0;Krd(559288,0,3653512,1387,1,E,0,0);D=0;i=k;return D|0}else F=u}else{if(!C){if(!d)G=0;else G=c[d+4>>2]|0;Krd(559392,0,3653512,1403,1,G,0,0);D=0;i=k;return D|0}if((mo[c[(c[C>>2]|0)+92>>2]&4095](C)|0)==4){F=c[C+116>>2]|0;break}if(!d)H=0;else H=c[d+4>>2]|0;Krd(559352,0,3653512,1395,1,H,0,0);D=0;i=k;return D|0}while(0);H=b[310579]|0;if((H&255)<<24>>24==0|(H&65535)<256){D=0;i=k;return D|0}m8b();H=mo[c[(c[e>>2]|0)+104>>2]&4095](e)|0;e=Hzc(Gzc()|0,H,H,2,F,0,0,1)|0;if(!e){if(!d)I=0;else I=c[d+4>>2]|0;Krd(559456,0,3653512,1420,1,I,0,0);D=0;i=k;return D|0}c[m>>2]=0;c[m+4>>2]=0;I=m+16|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[I+12>>2]=0;c[I+16>>2]=0;c[I+20>>2]=0;_$b(m);I=n8b()|0;if(!d)J=0;else J=c[d+4>>2]|0;c[I>>2]=J;J=d+292|0;I=c[J>>2]|0;c[J>>2]=c[e+4>>2];F=d+464|0;G=c[F>>2]|0;u=d+452|0;K=ea(g[u>>2]);E=d+596|0;L=ea(g[E>>2]);x=d+615|0;t=a[x>>0]|0;g[u>>2]=ea(90.0);g[E>>2]=ea(1.0);a[x>>0]=0;w=d+609|0;a[w>>0]=1;v=d+610|0;a[v>>0]=1;if((V$b(d)|0)>1)c[F>>2]=1;M=ync()|0;if(!(a[M+5832>>0]|0)){ko[c[(c[M>>2]|0)+500>>2]&4095](M);if(mo[c[(c[M>>2]|0)+516>>2]&4095](M)|0){N=1;A=32}else O=0}else{N=0;A=32}if((A|0)==32){A=ync()|0;rGc(q,BTb(c[d+24>>2]|0)|0);P=ea(-ea(g[q>>2]));Q=ea(-ea(g[q+4>>2]));R=ea(-ea(g[q+8>>2]));g[p>>2]=P;g[p+4>>2]=Q;g[p+8>>2]=R;kMc(o,p)|0;In[c[(c[A>>2]|0)+80>>2]&4095](A,1);p=d+32|0;q=d+612|0;M=r+944|0;S=r+948|0;T=l+4|0;U=l+8|0;V=l+12|0;W=l+16|0;X=l+20|0;Y=d+617|0;Z=A+5972|0;_=0;do{if(1<<_&f){oBc(e,0,-1,0);$=_*3|0;gMc(n,565288+($*12|0)|0,565288+(($+1|0)*12|0)|0,565288+(($+2|0)*12|0)|0)|0;cMc(n,o)|0;$=p+0|0;aa=n+0|0;ba=$+64|0;do{c[$>>2]=c[aa>>2];$=$+4|0;aa=aa+4|0}while(($|0)<(ba|0));a[q>>0]=0;a[v>>0]=1;C1b(r);c[M>>2]=h;c[S>>2]=j;rri(s,3653512,0);c[T>>2]=0;c[U>>2]=-1;c[l>>2]=d;c[V>>2]=5;c[W>>2]=0;c[X>>2]=0;if(a[Y>>0]|0)c[V>>2]=7;Q$b(d,l,r);xri(s);b0b(d,r,z,3);if(y)gFc(B,_,0,0,H,H,0,0,(a[Z>>0]|0)!=0,0);else{oBc(C,0,_,0);ko[c[(c[A>>2]|0)+404>>2]&4095](A);F3b(e,C,E3b()|0,-1,0,_)}E1b(r)}_=_+1|0}while((_|0)<6);a[q>>0]=1;a[d+608>>0]=1;c[F>>2]=G;g[u>>2]=K;g[E>>2]=L;a[x>>0]=t;a[w>>0]=1;a[v>>0]=1;c[J>>2]=I;$$b(m,z);In[c[(c[A>>2]|0)+80>>2]&4095](A,0);Jzc(Gzc()|0,e);if(y){MDc(B,1);ko[c[(c[B>>2]|0)+152>>2]&4095](B)}if(!(N<<24>>24)){D=1;i=k;return D|0}else O=1}N=ync()|0;ko[c[(c[N>>2]|0)+504>>2]&4095](N);D=O;i=k;return D|0}function d0b(){var a=0,b=0,c=0,d=0;a=i;i=i+16|0;b=a;c=Xmd()|0;rri(b,559536,32);d=Nmd(c,b)|0;xri(b);if(!d){i=a;return 0}else{b=Nld(d)|0;i=a;return (b?d:0)|0}return 0}function e0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;h=a+340|0;if(c[h>>2]|0){j=Gzc()|0;Jzc(j,c[h>>2]|0);c[h>>2]=0}j=Hzc(Gzc()|0,-1,-1,2,1,0,1,1)|0;c[h>>2]=j;if(!j){i=e;return}In[c[(c[j>>2]|0)+36>>2]&4095](j,559576);LDc(c[h>>2]|0,0);j=ync()|0;oBc(c[h>>2]|0,0,-1,0);k=c[(c[j>>2]|0)+24>>2]|0;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(1.0);g[f+12>>2]=ea(1.0);Co[k&3](j,7,f,ea(1.0),0);y$b(a,d,0);f=a+636|0;Bcc(f,0,d);t_b(b+92|0,b+1068|0,0,d);Bcc(f,1,d);In[c[(c[j>>2]|0)+140>>2]&4095](j,0);qud(d+20|0,558840,c[h>>2]|0)|0;i=e;return}function f0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;h=e;j=d0b()|0;if(!j){i=e;return}k=a+344|0;if(c[k>>2]|0){l=Gzc()|0;Jzc(l,c[k>>2]|0);c[k>>2]=0}l=Hzc(Gzc()|0,-1,-1,1,0,0,1,1)|0;c[k>>2]=l;if(!l){i=e;return}In[c[(c[l>>2]|0)+36>>2]&4095](l,559600);LDc(c[k>>2]|0,0);l=ync()|0;oBc(c[k>>2]|0,0,-1,0);g[f>>2]=ea(.5);g[f+4>>2]=ea(.5);g[f+8>>2]=ea(1.0);g[f+12>>2]=ea(1.0);Uvc(7,f,ea(1.0),0,d);y$b(a,d,0);f=a+636|0;Bcc(f,2,d);rri(h,559632,10);r_b(b+92|0,j,h,d);xri(h);Bcc(f,3,d);In[c[(c[l>>2]|0)+140>>2]&4095](l,0);qud(d+20|0,558872,c[k>>2]|0)|0;i=e;return}function g0b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((b|0)==2){e=c[a+348>>2]|0;i=d;return e|0}else{e=p_b(c[a+288>>2]|0,b)|0;i=d;return e|0}return 0}function h0b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=Im,A=Im;e=i;f=c[158074]|0;h=c[139744]|0;j=f+(h>>>5<<2)+4|0;c[j>>2]=c[j>>2]&~(1<<(h&31));h=b+616|0;if(!(a[h>>0]|0)){j=pyc()|0;k=(a[(c[j+24>>2]|0)+((c[j+40>>2]|0)*96|0)+72>>0]|0)==0}else k=1;j=c[b+604>>2]|0;l=((V$b(b)|0)&-2|0)==2;m=l^1;if(!(k|m)){n=c[139744]|0;o=f+(n>>>5<<2)+4|0;c[o>>2]=1<<(n&31)|c[o>>2]}if(!(a[621165]|0))p=l&1|j;else p=j;j=c[d+1068>>2]|0;if(!j)q=0;else q=(a[(c[j+52>>2]|0)+52>>0]|0)==0;if(!(l|(a[621167]|0)==0|q)){q=(a[d+164>>0]|0)==0;if(Q9b(1)|0){j=b+609|0;if((a[j>>0]|0)!=0?(a[b+613>>0]|0)!=0:0){o=b+96|0;r=ea(g[b+596>>2]);s=ea(g[b+456>>2]);t=ea(g[b+460>>2]);if(!(a[h>>0]|0))mMc(o,ea(g[b+452>>2]),r,s,t)|0;else{u=ea(g[b+448>>2]);v=ea(-u);oMc(o,ea(r*v),ea(r*u),v,u,s,t)|0}a[j>>0]=0}if(!(ea(g[b+104>>2])!=ea(0.0)))w=ea(g[b+120>>2])==ea(0.0);else w=0}else w=0;if(!q)x=w&1|p;else x=p}else x=p;p=(x&1|0)==0|m|(a[621165]|0)==0?x:x&-2;if(!(p&2))y=p;else y=l?p&-3:p;if(!y){i=e;return}p=(rBc()|0)^1;if((a[621119]|0)==0|p){i=e;return}p=(y&1|0)==0;if(!(k|p)){k=c[139744]|0;l=f+(k>>>5<<2)+4|0;c[l>>2]=1<<(k&31)|c[l>>2]}t=ea(g[b+404>>2]);if(t<=ea(9.99999974e-06)){i=e;return}s=ea(g[b+408>>2]);if(s<=ea(9.99999974e-06)){i=e;return}u=ea(g[b+396>>2]);if(!(!(u>=ea(1.0))&!(ea(t+u)<=ea(0.0)))){i=e;return}u=ea(g[b+400>>2]);if(!(!(u>=ea(1.0))&!(ea(s+u)<=ea(0.0)))){i=e;return}u=ea(g[b+460>>2]);s=ea(g[b+456>>2]);if(u<=s){i=e;return}if(!(a[h>>0]|0)){if(s<=ea(0.0)){i=e;return}s=ea(g[b+452>>2]);if(s<ea(0.0))z=ea(-s);else z=s;if(z<ea(9.99999997e-07)){i=e;return}}else{z=ea(g[b+448>>2]);if(z<ea(0.0))A=ea(-z);else A=z;if(A<ea(9.99999997e-07)){i=e;return}}if(!p)e0b(b,d,f);if(y&2)f0b(b,d,f);f=c[(ync()|0)+5980>>2]|0;if(!((f|0)==8|(f|0)==11)){i=e;return}if(!(y&3)){i=e;return}oBc(c[b+348>>2]|0,0,-1,0);i=e;return}function i0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=n8b()|0;if(!a)f=0;else f=c[a+4>>2]|0;c[e>>2]=f;y$b(a,b,3);i=d;return}function j0b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im;e=i;i=i+96|0;f=e+80|0;h=e+16|0;j=e;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;k=d+24|0;rGc(j,BTb(c[k>>2]|0)|0);c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];j=d+608|0;if((a[j>>0]|0)!=0?(a[d+612>>0]|0)!=0:0){l=d+32|0;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(-1.0);iMc(l,f)|0;PGc(h,BTb(c[k>>2]|0)|0);cMc(l,h)|0;a[j>>0]=0}m=ea(g[d+32>>2]);n=ea(g[d+36>>2]);o=ea(g[d+40>>2]);g[b+12>>2]=m;g[b+16>>2]=n;g[b+20>>2]=o;g[b+24>>2]=ea(g[d+624>>2]);g[b+28>>2]=ea(g[d+628>>2]);g[b+32>>2]=ea(g[d+456>>2]);g[b+36>>2]=ea(g[d+460>>2]);g[b+40>>2]=ea(g[d+452>>2]);g[b+44>>2]=ea(g[d+596>>2]);i=e;return}function k0b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+2624|0;f=e+256|0;h=e+2440|0;j=e+2504|0;k=e+2552|0;l=e+128|0;m=e;n=e+280|0;o=ync()|0;j0b(j,b);p=b+608|0;if((a[p>>0]|0)!=0?(a[b+612>>0]|0)!=0:0){q=b+32|0;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(-1.0);iMc(q,f)|0;PGc(h,BTb(c[b+24>>2]|0)|0);cMc(q,h)|0;a[p>>0]=0}p=b+32|0;q=k+0|0;r=p+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));t=b+609|0;u=b+613|0;if((a[t>>0]|0)!=0?(a[u>>0]|0)!=0:0){v=b+96|0;w=ea(g[b+596>>2]);x=ea(g[b+456>>2]);y=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(v,ea(g[b+452>>2]),w,x,y)|0;else{z=ea(g[b+448>>2]);A=ea(-z);oMc(v,ea(w*A),ea(w*z),A,z,x,y)|0}a[t>>0]=0}t=b+96|0;q=h+0|0;r=t+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));v=a[u>>0]|0;B=b+612|0;C=a[B>>0]|0;D=n+2160|0;E=n;do{C1b(E);E=E+1080|0}while((E|0)!=(D|0));y=ea(g[j+24>>2]);x=ea(y*ea(.5));z=ea(g[j+32>>2]);A=ea(x*z);x=ea(A/ea(g[j+28>>2]));A=ea(z*ea(+X(+ea(ea(ea(ea(ea(g[j+40>>2])*ea(.5))/ea(360.0))*ea(2.0))*ea(3.14159274)))));z=ea(ea(-x)/ea(A*ea(g[j+44>>2])));j=b+610|0;E=f+4|0;F=f+8|0;G=f+12|0;H=f+16|0;I=f+20|0;J=b+617|0;K=b+614|0;L=b+224|0;M=0;do{N=l+(M<<6)|0;q=N+0|0;r=k+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));O=m+(M<<6)|0;q=O+0|0;r=h+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));A=ea(ea(ea(M|0)*ea(2.0))+ea(-1.0));x=ea(ea(A*ea(.5))*y);P=l+(M<<6)+48|0;g[P>>2]=ea(ea(g[P>>2])+x);x=ea(A*z);P=m+(M<<6)+32|0;g[P>>2]=ea(ea(g[P>>2])+x);q=p+0|0;r=N+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));a[B>>0]=0;q=t+0|0;r=O+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));a[u>>0]=0;a[j>>0]=1;x=ea(g[m+(M<<6)+8>>2]);if(!(x!=ea(0.0)?1:ea(g[m+(M<<6)+24>>2])!=ea(0.0))){a[K>>0]=0;q=L+0|0;r=O+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0))}c[E>>2]=0;c[F>>2]=-1;c[f>>2]=b;c[G>>2]=4;c[H>>2]=0;c[I>>2]=0;if(a[J>>0]|0)c[G>>2]=6;Q$b(b,f,n+(M*1080|0)|0);M=M+1|0}while((M|0)<2);if(!(a[b+28>>0]|0))Q=D;else{M=0;do{f=(M|0)==0?64:0;In[c[(c[o>>2]|0)+772>>2]&4095](o,M);q=p+0|0;r=l+(M<<6)+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));a[B>>0]=0;G=m+(M<<6)|0;q=t+0|0;r=G+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));a[u>>0]=0;a[j>>0]=1;z=ea(g[m+(M<<6)+8>>2]);if(!(z!=ea(0.0)?1:ea(g[m+(M<<6)+24>>2])!=ea(0.0))){a[K>>0]=0;q=L+0|0;r=G+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0))}b0b(b,n+(M*1080|0)|0,c[158074]|0,f|d);M=M+1|0}while((M|0)<2);In[c[(c[o>>2]|0)+772>>2]&4095](o,0);a[u>>0]=v;a[B>>0]=C;q=t+0|0;r=h+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));q=p+0|0;r=k+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));Q=D}do{Q=Q+-1080|0;E1b(Q)}while((Q|0)!=(n|0));i=e;return}function l0b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im;e=i;f=b+96|0;h=d+0|0;j=f+64|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(j|0));a[b+613>>0]=0;a[b+610>>0]=1;k=ea(g[d+8>>2]);if(k!=ea(0.0)?1:ea(g[d+24>>2])!=ea(0.0)){i=e;return}a[b+614>>0]=0;f=b+224|0;h=d+0|0;j=f+64|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(j|0));i=e;return}function m0b(a,b){a=a|0;b=b|0;var d=0;d=i;v3b(j_b(c[a+288>>2]|0)|0,b);i=d;return}function n0b(a,b){a=a|0;b=b|0;var d=0;d=i;w3b(j_b(c[a+288>>2]|0)|0,b);i=d;return}function o0b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im;f=i;i=i+288|0;h=f+212|0;j=f+96|0;k=f;l=f+184|0;m=f+200|0;n=f+224|0;o=f+32|0;p=f+172|0;q=f+160|0;r=f+16|0;s=f+4|0;v$b(l,d);g[m>>2]=ea(0.0);t=m+4|0;g[t>>2]=ea(0.0);u=m+8|0;g[u>>2]=ea(0.0);qMc(N$b(d)|0,n)|0;v=d+608|0;if((a[v>>0]|0)!=0?(a[d+612>>0]|0)!=0:0){w=d+32|0;g[h>>2]=ea(1.0);g[h+4>>2]=ea(1.0);g[h+8>>2]=ea(-1.0);iMc(w,h)|0;PGc(j,BTb(c[d+24>>2]|0)|0);cMc(w,j)|0;a[v>>0]=0}qMc(d+32|0,o)|0;x=ea(g[e>>2]);v=e+4|0;y=ea(g[v>>2]);w=d+456|0;z=ea(g[w>>2]);g[p>>2]=x;g[p+4>>2]=y;g[p+8>>2]=z;A=d+292|0;B=c[A>>2]|0;if(!B)C=0;else{c[k>>2]=B;B=c[137784]|0;if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(h,B,k);D=c[h>>2]|0;E=c[B+28>>2]|0;if((D|0)==-1){F=E+(c[B+32>>2]<<3)|0;break}else{F=E+(D<<3)|0;break}}else F=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);B=c[137784]|0;if((F|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(B=c[F+4>>2]|0,(B|0)!=0):0)G=B;else H=13}else H=13;if((H|0)==13)G=hQb(c[A>>2]|0)|0;C=(G|0)!=0}if(!(p1b(p,o,n,l,m,C)|0)){rGc(q,BTb(c[d+24>>2]|0)|0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+0>>2]=c[q+0>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(0.0);g[b+20>>2]=ea(1.0);i=f;return}z=ea(g[m>>2]);y=ea(g[t>>2]);x=ea(g[u>>2]);do if(!(a[d+616>>0]|0)){I=ea(g[e>>2]);J=ea(g[v>>2]);K=ea(ea(g[w>>2])+ea(1.0e3));g[r>>2]=I;g[r+4>>2]=J;g[r+8>>2]=K;q=c[A>>2]|0;if(!q)L=0;else{c[j>>2]=q;q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(h,q,j);C=c[h>>2]|0;p=c[q+28>>2]|0;if((C|0)==-1){M=p+(c[q+32>>2]<<3)|0;break}else{M=p+(C<<3)|0;break}}else M=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((M|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[M+4>>2]|0,(q|0)!=0):0)N=q;else H=28}else H=28;if((H|0)==28)N=hQb(c[A>>2]|0)|0;L=(N|0)!=0}if(p1b(r,o,n,l,m,L)|0){K=ea(ea(g[m>>2])-z);J=ea(ea(g[t>>2])-y);I=ea(ea(g[u>>2])-x);O=ea(T(ea(ea(ea(K*K)+ea(J*J))+ea(I*I))));P=ea(K/O);Q=ea(J/O);R=ea(I/O);break}rGc(s,BTb(c[d+24>>2]|0)|0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+0>>2]=c[s+0>>2];c[b+4>>2]=c[s+4>>2];c[b+8>>2]=c[s+8>>2];g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(0.0);g[b+20>>2]=ea(1.0);i=f;return}else{O=ea(g[o+32>>2]);I=ea(g[o+36>>2]);J=ea(g[o+40>>2]);K=ea(T(ea(ea(ea(O*O)+ea(I*I))+ea(J*J))));P=ea(ea(-O)/K);Q=ea(ea(-I)/K);R=ea(ea(-J)/K)}while(0);g[b>>2]=z;g[b+4>>2]=y;g[b+8>>2]=x;g[b+12>>2]=P;g[b+16>>2]=Q;g[b+20>>2]=R;i=f;return}function p0b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+160|0;j=h+144|0;k=h+80|0;l=h+64|0;m=h;v$b(l,d);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);n=d+608|0;if((a[n>>0]|0)!=0?(a[d+612>>0]|0)!=0:0){o=d+32|0;g[j>>2]=ea(1.0);g[j+4>>2]=ea(1.0);g[j+8>>2]=ea(-1.0);iMc(o,j)|0;PGc(k,BTb(c[d+24>>2]|0)|0);cMc(o,k)|0;a[n>>0]=0}qMc(d+32|0,m)|0;n=N$b(d)|0;o=d+292|0;d=c[o>>2]|0;if(!d)p=0;else{c[k>>2]=d;d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(j,d,k);q=c[j>>2]|0;r=c[d+28>>2]|0;if((q|0)==-1){s=r+(c[d+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((s|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[s+4>>2]|0,(d|0)!=0):0)t=d;else u=13}else u=13;if((u|0)==13)t=hQb(c[o>>2]|0)|0;p=(t|0)!=0}t=o1b(e,m,n,l,b,p)|0;if(!f){i=h;return}a[f>>0]=t&1;i=h;return}function q0b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+224|0;h=f+208|0;j=f+144|0;k=f+128|0;l=f+64|0;m=f;v$b(k,d);g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(0.0);qMc(N$b(d)|0,l)|0;n=d+608|0;if((a[n>>0]|0)!=0?(a[d+612>>0]|0)!=0:0){o=d+32|0;g[h>>2]=ea(1.0);g[h+4>>2]=ea(1.0);g[h+8>>2]=ea(-1.0);iMc(o,h)|0;PGc(j,BTb(c[d+24>>2]|0)|0);cMc(o,j)|0;a[n>>0]=0}qMc(d+32|0,m)|0;n=d+292|0;d=c[n>>2]|0;if(!d){p=0;p1b(e,m,l,k,b,p)|0;i=f;return}c[j>>2]=d;d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(h,d,j);o=c[h>>2]|0;q=c[d+28>>2]|0;if((o|0)==-1){r=q+(c[d+32>>2]<<3)|0;break}else{r=q+(o<<3)|0;break}}else r=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((r|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[r+4>>2]|0,(d|0)!=0):0)s=d;else t=13}else t=13;if((t|0)==13)s=hQb(c[n>>2]|0)|0;p=(s|0)!=0;p1b(e,m,l,k,b,p)|0;i=f;return}function r0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+48|0;e=d+16|0;f=d;p0b(f,b,c,d+32|0);T0b(e,b,1);h=ea(g[b+396>>2]);j=ea(g[b+400>>2]);k=ea(g[b+404>>2]);l=ea(g[b+408>>2]);m=ea(g[e+8>>2]);n=ea(g[e+12>>2]);o=ea(h*m);h=ea(k*m);k=ea(j*n);j=ea(l*n);l=ea(g[e>>2]);p=ea(g[e+4>>2]);q=ea(o+l);o=ea(k+p);k=ea(h+q);h=ea(j+o);j=ea(m+l);m=ea(n+p);n=q<l?l:q;q=o<p?p:o;o=ea((k>j?j:k)-n);e=o<ea(0.0);k=e?ea(0.0):o;o=ea((h>m?m:h)-q);e=o<ea(0.0);h=e?ea(0.0):o;o=ea(ea(ea(g[f>>2])-n)/k);k=ea(ea(ea(g[f+4>>2])-q)/h);h=ea(g[f+8>>2]);g[a>>2]=o;g[a+4>>2]=k;g[a+8>>2]=h;i=d;return}function s0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;d=i;i=i+16|0;e=d;T0b(e,b,1);f=ea(g[b+396>>2]);h=ea(g[b+400>>2]);j=ea(g[b+404>>2]);k=ea(g[b+408>>2]);l=ea(g[e+8>>2]);m=ea(g[e+12>>2]);n=ea(f*l);f=ea(j*l);j=ea(h*m);h=ea(k*m);k=ea(g[e>>2]);o=ea(g[e+4>>2]);p=ea(n+k);n=ea(j+o);j=ea(f+p);f=ea(h+n);h=ea(l+k);l=ea(m+o);m=p<k?k:p;p=n<o?o:n;n=ea((j>h?h:j)-m);e=n<ea(0.0);j=e?ea(0.0):n;n=ea((f>l?l:f)-p);e=n<ea(0.0);f=e?ea(0.0):n;n=ea(ea(ea(g[c>>2])-m)/j);j=ea(ea(ea(g[c+4>>2])-p)/f);f=ea(g[c+8>>2]);g[a>>2]=n;g[a+4>>2]=j;g[a+8>>2]=f;i=d;return}function t0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+32|0;e=d+16|0;f=d;T0b(e,b,1);h=ea(g[b+396>>2]);j=ea(g[b+400>>2]);k=ea(g[b+404>>2]);l=ea(g[b+408>>2]);m=ea(g[e+8>>2]);n=ea(g[e+12>>2]);o=ea(h*m);h=ea(k*m);k=ea(j*n);j=ea(l*n);l=ea(g[e>>2]);p=ea(g[e+4>>2]);q=ea(o+l);o=ea(k+p);k=ea(h+q);h=ea(j+o);j=ea(m+l);m=ea(n+p);n=q<l?l:q;q=o<p?p:o;o=ea((k>j?j:k)-n);e=o<ea(0.0);k=e?ea(0.0):o;o=ea((h>m?m:h)-q);e=o<ea(0.0);h=e?ea(0.0):o;o=ea(n+ea(ea(g[c>>2])*k));k=ea(q+ea(ea(g[c+4>>2])*h));h=ea(g[c+8>>2]);g[f>>2]=o;g[f+4>>2]=k;g[f+8>>2]=h;q0b(a,b,f);i=d;return}function u0b(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;e=i;i=i+64|0;f=e;h=c+609|0;if((a[h>>0]|0)!=0?(a[c+613>>0]|0)!=0:0){j=c+96|0;k=ea(g[c+596>>2]);l=ea(g[c+456>>2]);m=ea(g[c+460>>2]);if(!(a[c+616>>0]|0))mMc(j,ea(g[c+452>>2]),k,l,m)|0;else{n=ea(g[c+448>>2]);o=ea(-n);oMc(j,ea(k*o),ea(k*n),o,n,l,m)|0}a[h>>0]=0}qMc(c+96|0,f)|0;m=ea(g[d>>2]);l=ea(m-ea(ea(1.0)-m));m=ea(g[d+4>>2]);n=ea(m-ea(ea(1.0)-m));m=ea(g[d+8>>2]);o=ea(m-ea(g[c+456>>2]));k=ea(o/ea(g[c+460>>2]));o=ea(k-ea(ea(1.0)-k));g[b>>2]=ea(0.0);c=b+4|0;g[c>>2]=ea(0.0);d=b+8|0;g[d>>2]=ea(0.0);k=ea(l*ea(g[f>>2]));p=ea(k+ea(n*ea(g[f+16>>2])));k=ea(p+ea(o*ea(g[f+32>>2])));p=ea(ea(g[f+48>>2])+k);k=ea(l*ea(g[f+4>>2]));q=ea(k+ea(n*ea(g[f+20>>2])));k=ea(q+ea(o*ea(g[f+36>>2])));q=ea(ea(g[f+52>>2])+k);k=ea(l*ea(g[f+12>>2]));l=ea(k+ea(n*ea(g[f+28>>2])));n=ea(l+ea(o*ea(g[f+44>>2])));o=ea(ea(g[f+60>>2])+n);if(o<ea(0.0))r=ea(-o);else r=o;if(!(r>ea(1.00000001e-07))){s=ea(0.0);t=ea(0.0);g[b>>2]=t;g[c>>2]=s;g[d>>2]=m;i=e;return}r=ea(ea(1.0)/o);s=ea(q*r);t=ea(p*r);g[b>>2]=t;g[c>>2]=s;g[d>>2]=m;i=e;return}function v0b(b,c){b=b|0;c=ea(c);g[b+596>>2]=c;a[b+609>>0]=1;a[b+610>>0]=1;a[b+615>>0]=0;return}function w0b(b,c,d){b=b|0;c=ea(c);d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;e=i;f=b+614|0;do if(a[f>>0]|0){h=b+611|0;if(a[h>>0]|0){j=b+224|0;k=ea(g[b+596>>2]);l=ea(g[b+456>>2]);m=ea(g[b+460>>2]);if(!(a[b+616>>0]|0))mMc(j,ea(g[b+452>>2]),k,l,m)|0;else{n=ea(g[b+448>>2]);o=ea(-n);oMc(j,ea(k*o),ea(n*k),o,n,l,m)|0}a[h>>0]=0;if(!(a[f>>0]|0))break}m=ea(g[b+596>>2]);l=ea(g[b+460>>2]);if(!(a[b+616>>0]|0)){mMc(d,ea(g[b+452>>2]),m,c,l)|0;i=e;return}else{n=ea(g[b+448>>2]);o=ea(-n);oMc(d,ea(m*o),ea(n*m),o,n,c,l)|0;i=e;return}}while(0);l=ea(g[b+224>>2]);n=ea(g[b+244>>2]);o=ea(g[b+256>>2]);m=ea(g[b+260>>2]);k=ea(g[b+456>>2]);p=ea(k*ea(2.0));q=ea(p/l);l=ea(o+ea(1.0));o=ea(p/n);n=ea(m+ea(1.0));m=ea(c/k);k=ea(ea(ea(l*ea(.5))*q)*m);p=ea(ea(ea(n*ea(.5))*o)*m);r=ea(m*ea(+q*(+l*.5+-1.0)));l=ea(m*ea(+o*(+n*.5+-1.0)));lMc(d,r,k,p,l,c,ea(g[b+460>>2]))|0;i=e;return}function x0b(b,c,d,e){b=b|0;c=ea(c);d=ea(d);e=e|0;var f=0,h=Im,j=Im,k=Im;f=i;h=ea(g[b+596>>2]);if(!(a[b+616>>0]|0)){mMc(e,ea(g[b+452>>2]),h,c,d)|0;i=f;return}else{j=ea(g[b+448>>2]);k=ea(-j);oMc(e,ea(h*k),ea(j*h),k,j,c,d)|0;i=f;return}}function y0b(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0;k=i;i=i+32|0;l=k+8|0;m=k+4|0;n=k;o=(d|0)==0;if(o)p=0;else p=c[d+4>>2]|0;q=b+292|0;if((c[q>>2]|0)==(p|0)){if((c[b+328>>2]|0)==(e|0)?(FEi(f,b+296|0,e<<2)|0)==0:0)r=(c[h>>2]|0)==(c[b+332>>2]|0);else r=0;if(r|o^1){i=k;return}}r=n8b()|0;p=c[r>>2]|0;if(!p)s=0;else{c[m>>2]=p;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(l,p,m);t=c[l>>2]|0;u=c[p+28>>2]|0;if((t|0)==-1){v=u+(c[p+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[v+4>>2]|0,(p|0)!=0):0)w=p;else x=17}else x=17;if((x|0)==17)w=hQb(c[r>>2]|0)|0;s=w}w=c[q>>2]|0;do if(w){c[n>>2]=w;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(l,r,n);p=c[l>>2]|0;v=c[r+28>>2]|0;if((p|0)==-1){y=v+(c[r+32>>2]<<3)|0;break}else{y=v+(p<<3)|0;break}}else y=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((y|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(c[y+4>>2]|0)!=0:0){z=0;break}}if(hQb(c[q>>2]|0)|0)z=0;else x=29}else x=29;while(0);if((x|0)==29)z=(c[b+336>>2]|0)==0;if(o)A=0;else A=c[d+4>>2]|0;c[q>>2]=A;YEi(b+296|0,f|0,e<<2|0)|0;if((e|0)<8)PEi(b+(e<<2)+296|0,0,8-e<<2|0)|0;c[b+328>>2]=e;c[b+332>>2]=c[h>>2];c[b+336>>2]=j;h=b+615|0;if(a[h>>0]|0){T0b(l,b,1);B=ea(g[b+396>>2]);C=ea(g[b+400>>2]);D=ea(g[b+404>>2]);E=ea(g[b+408>>2]);F=ea(g[l+8>>2]);G=ea(g[l+12>>2]);H=ea(B*F);B=ea(D*F);D=ea(C*G);C=ea(E*G);E=ea(g[l>>2]);I=ea(g[l+4>>2]);J=ea(H+E);H=ea(D+I);D=ea(B+J);B=ea(C+H);C=ea(F+E);F=ea(G+I);G=ea((D>C?C:D)-(J<E?E:J));J=ea((B>F?F:B)-(H<I?I:H));l=J<ea(0.0);H=l?ea(0.0):J;if(H!=ea(0.0)){l=G<ea(0.0);K=ea((l?ea(0.0):G)/H)}else K=ea(1.0);g[b+596>>2]=K;a[b+609>>0]=1;a[b+610>>0]=1;a[h>>0]=1}if(!(a[b+29>>0]|0)){i=k;return}k8b(n8b()|0,b);j8b(n8b()|0,b);if((s|0)!=(b|0)|z){i=k;return}if(!((d|0)!=0|(j|0)!=0)){i=k;return}j=n8b()|0;if(!b)L=0;else L=c[b+4>>2]|0;c[j>>2]=L;i=k;return}function z0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;if(!b){h=ync()|0;c[f>>2]=mo[c[(c[h>>2]|0)+428>>2]&4095](h)|0;h=ync()|0;j=mo[c[(c[h>>2]|0)+432>>2]&4095](h)|0}else{c[f>>2]=c[b+140>>2];j=c[b+148>>2]|0}c[g>>2]=j;c[e+0>>2]=c[g+0>>2];y0b(a,b,1,f,e,0);i=d;return}function A0b(b,c){b=b|0;c=ea(c);g[b+456>>2]=c;a[b+609>>0]=1;a[b+610>>0]=1;return}function B0b(b,c){b=b|0;c=ea(c);g[b+460>>2]=c;a[b+609>>0]=1;a[b+610>>0]=1;return}function C0b(b,c){b=b|0;c=ea(c);g[b+448>>2]=c;a[b+609>>0]=1;a[b+610>>0]=1;return}function D0b(b,c){b=b|0;c=c|0;a[b+616>>0]=c&1;a[b+609>>0]=1;a[b+610>>0]=1;return}function E0b(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(g[b+12>>2]);g[a+380>>2]=c;g[a+384>>2]=d;g[a+388>>2]=e;g[a+392>>2]=f;return}function F0b(a,b){a=a|0;b=b|0;c[a+376>>2]=b;return}function G0b(a,b){a=a|0;b=b|0;c[a+412>>2]=b;return}function H0b(b){b=b|0;return (a[b+621>>0]|0)!=0|0}function I0b(){var a=0;a=i;QQb(20,93,94,0,95);i=a;return}function J0b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,2449160,6);wQb(20,8,b,972,2604,0,1);xri(b);i=a;return}function K0b(a){a=a|0;return 20}function L0b(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2449160,a,0);Z0b(a,b);bdd(b);i=c;return}function M0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2449160,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else _0b(a,b);sdd(b);i=d;return}function N0b(a,b){a=a|0;b=b|0;var c=0;c=i;$0b(a,b);i=c;return}function O0b(a,b){a=a|0;b=b|0;var c=0;c=i;a1b(a,b);i=c;return}function P0b(a,b){a=a|0;b=b|0;var c=0;c=i;b1b(a,b);i=c;return}function Q0b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mkc(b,d);f=b+292|0;b=c[d+12>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[f>>2]|0,c[d+28>>2]|0)|0;if(!(a[d+32>>0]|0)){i=e;return}c[f>>2]=g;i=e;return}function R0b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,558848);c[139710]=c[b>>2];c[b>>2]=-1;itd(b,558880);c[139718]=c[b>>2];c[b>>2]=-1;itd(b,558920);c[139728]=c[b>>2];i=a;return}function S0b(b,c,d){b=b|0;c=c|0;d=d|0;a[b+608>>0]=1;a[b+610>>0]=1;return}function T0b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im;f=i;i=i+16|0;h=f+8|0;j=f;k=d+292|0;l=c[k>>2]|0;do if(l){c[j>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(h,m,j);n=c[h>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[p+4>>2]|0,(m|0)!=0):0)q=m;else r=10}else r=10;if((r|0)==10){m=hQb(c[k>>2]|0)|0;if(!m)break;else q=m}s=ea(c[q+100>>2]|0);t=ea(c[q+104>>2]|0);g[b>>2]=ea(0.0);g[b+8>>2]=s;g[b+4>>2]=ea(0.0);g[b+12>>2]=t;i=f;return}while(0);q=c[d+296>>2]|0;if((q|0)!=0?(a[q+23>>0]|0)==0:0){t=ea((c[q+4>>2]|0)>>>0);s=ea((c[q+8>>2]|0)>>>0);g[b>>2]=ea(0.0);g[b+8>>2]=t;g[b+4>>2]=ea(0.0);g[b+12>>2]=s;i=f;return}q=n8b()|0;s=ea(g[q+56>>2]);t=ea(g[q+60>>2]);d=q+64|0;q=c[d>>2]|0;k=c[d+4>>2]|0;u=e?ea(0.0):t;g[b>>2]=e?ea(0.0):s;g[b+4>>2]=u;e=b+8|0;c[e>>2]=q;c[e+4>>2]=k;i=f;return}function U0b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0;f=i;i=i+16|0;g=f;h=ync()|0;n1b(g,d);i1b(h,g);In[c[(c[h>>2]|0)+184>>2]&4095](h,g);j=+Ki();Uvc(b,e,ea(1.0),0,c[158074]|0);e=ync()|0;k=+Ki();if(!(a[e+5568>>0]|0)){l=c[h>>2]|0;m=l+188|0;n=c[m>>2]|0;ko[n&4095](h);i=f;return}o=k*1.0e6;b=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;k=j*1.0e6;g=ZEi(~~o>>>0|0,b|0,~~k>>>0|0,(+S(k)>=1.0?(k>0.0?(ha(+R(k/4294967296.0),4294967295.0)|0)>>>0:~~+ca((k-+(~~k>>>0))/4294967296.0)>>>0):0)|0)|0;b=e+5440|0;e=b;d=_Ei(g|0,H|0,c[e>>2]|0,c[e+4>>2]|0)|0;e=b;c[e>>2]=d;c[e+4>>2]=H;l=c[h>>2]|0;m=l+188|0;n=c[m>>2]|0;ko[n&4095](h);i=f;return}function V0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>4>>>0>=b>>>0){n=d+4|0;o=d+8|0;p=b;q=l;do{if(!q)r=0;else{l=c[n>>2]|0;c[q+4>>2]=l;s=q+8|0;c[s>>2]=0;t=q+12|0;c[t>>2]=0;c[q>>2]=0;u=c[d>>2]|0;v=c[o>>2]|0;c[s>>2]=v;if(!v){w=0;x=0}else{c[t>>2]=v;c[g>>2]=l;c[f+0>>2]=c[g+0>>2];l=hOb(0,v,1,f,0,3653512,370)|0;c[q>>2]=l;w=l;x=c[s>>2]|0}YEi(w|0,u|0,x|0)|0;r=c[k>>2]|0}q=r+16|0;c[k>>2]=q;p=p+-1|0}while((p|0)!=0);i=e;return}p=c[a>>2]|0;q=(m-p>>4)+b|0;if((q|0)<0)vxi(a);m=p;p=j-m|0;if(p>>4>>>0<1073741823){j=p>>3;p=j>>>0<q>>>0?q:j;j=(c[k>>2]|0)-m>>4;if(!p){y=0;z=0;A=j}else{B=p;C=j;D=13}}else{B=2147483647;C=(c[k>>2]|0)-m>>4;D=13}if((D|0)==13){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];y=B;z=cOb(B<<4,16,f,0,3653512,80)|0;A=C}C=z+(A<<4)|0;A=z+(y<<4)|0;y=d+4|0;z=d+8|0;B=b;b=C;while(1){if(!b)E=0;else{D=c[y>>2]|0;c[b+4>>2]=D;m=b+8|0;c[m>>2]=0;j=b+12|0;c[j>>2]=0;c[b>>2]=0;p=c[d>>2]|0;q=c[z>>2]|0;c[m>>2]=q;if(!q){F=0;G=0}else{c[j>>2]=q;c[g>>2]=D;c[f+0>>2]=c[g+0>>2];D=hOb(0,q,1,f,0,3653512,370)|0;c[b>>2]=D;F=D;G=c[m>>2]|0}YEi(F|0,p|0,G|0)|0;E=b}p=E+16|0;B=B+-1|0;if(!B){H=p;break}else b=p}b=c[a>>2]|0;B=c[k>>2]|0;if((B|0)!=(b|0)){E=B;B=C;while(1){G=E;E=E+-16|0;F=c[G+-12>>2]|0;c[B+-12>>2]=F;z=B+-8|0;c[z>>2]=0;d=B+-4|0;c[d>>2]=0;y=B+-16|0;c[y>>2]=0;p=c[E>>2]|0;m=c[G+-8>>2]|0;c[z>>2]=m;if(!m){I=0;J=0}else{c[d>>2]=m;c[g>>2]=F;c[f+0>>2]=c[g+0>>2];F=hOb(0,m,1,f,0,3653512,370)|0;c[y>>2]=F;I=F;J=c[z>>2]|0}YEi(I|0,p|0,J|0)|0;p=B+-16|0;if((E|0)==(b|0)){K=p;break}else B=p}B=c[a>>2]|0;E=c[k>>2]|0;c[a>>2]=K;c[k>>2]=H;c[h>>2]=A;if((E|0)==(B|0))L=B;else{K=E;do{E=K;K=K+-16|0;if((c[E+-4>>2]|0)>-1){J=c[K>>2]|0;c[g>>2]=c[E+-12>>2];c[f+0>>2]=c[g+0>>2];eOb(J,f);c[K>>2]=0}}while((K|0)!=(B|0));L=B}}else{c[a>>2]=C;c[k>>2]=H;c[h>>2]=A;L=b}if(!L){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(L,f);i=e;return}function W0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>4>>>0>=b>>>0){n=d+4|0;o=d+8|0;p=b;q=l;do{if(!q)r=0;else{l=c[n>>2]|0;c[q+4>>2]=l;s=q+8|0;c[s>>2]=0;t=q+12|0;c[t>>2]=0;c[q>>2]=0;u=c[d>>2]|0;v=c[o>>2]<<2;w=v>>2;c[s>>2]=w;if(!w){x=0;y=0}else{c[t>>2]=w;c[g>>2]=l;c[f+0>>2]=c[g+0>>2];l=hOb(0,v,4,f,0,3653512,370)|0;c[q>>2]=l;x=l;y=c[s>>2]<<2}YEi(x|0,u|0,y|0)|0;r=c[k>>2]|0}q=r+16|0;c[k>>2]=q;p=p+-1|0}while((p|0)!=0);i=e;return}p=c[a>>2]|0;q=(m-p>>4)+b|0;if((q|0)<0)vxi(a);m=p;p=j-m|0;if(p>>4>>>0<1073741823){j=p>>3;p=j>>>0<q>>>0?q:j;j=(c[k>>2]|0)-m>>4;if(!p){z=0;A=0;B=j}else{C=p;D=j;E=13}}else{C=2147483647;D=(c[k>>2]|0)-m>>4;E=13}if((E|0)==13){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];z=C;A=cOb(C<<4,16,f,0,3653512,80)|0;B=D}D=A+(B<<4)|0;B=A+(z<<4)|0;z=d+4|0;A=d+8|0;C=b;b=D;while(1){if(!b)F=0;else{E=c[z>>2]|0;c[b+4>>2]=E;m=b+8|0;c[m>>2]=0;j=b+12|0;c[j>>2]=0;c[b>>2]=0;p=c[d>>2]|0;q=c[A>>2]<<2;r=q>>2;c[m>>2]=r;if(!r){G=0;H=0}else{c[j>>2]=r;c[g>>2]=E;c[f+0>>2]=c[g+0>>2];E=hOb(0,q,4,f,0,3653512,370)|0;c[b>>2]=E;G=E;H=c[m>>2]<<2}YEi(G|0,p|0,H|0)|0;F=b}p=F+16|0;C=C+-1|0;if(!C){I=p;break}else b=p}b=c[a>>2]|0;C=c[k>>2]|0;if((C|0)!=(b|0)){F=C;C=D;while(1){H=F;F=F+-16|0;G=c[H+-12>>2]|0;c[C+-12>>2]=G;A=C+-8|0;c[A>>2]=0;d=C+-4|0;c[d>>2]=0;z=C+-16|0;c[z>>2]=0;p=c[F>>2]|0;m=c[H+-8>>2]<<2;H=m>>2;c[A>>2]=H;if(!H){J=0;K=0}else{c[d>>2]=H;c[g>>2]=G;c[f+0>>2]=c[g+0>>2];G=hOb(0,m,4,f,0,3653512,370)|0;c[z>>2]=G;J=G;K=c[A>>2]<<2}YEi(J|0,p|0,K|0)|0;p=C+-16|0;if((F|0)==(b|0)){L=p;break}else C=p}C=c[a>>2]|0;F=c[k>>2]|0;c[a>>2]=L;c[k>>2]=I;c[h>>2]=B;if((F|0)==(C|0))M=C;else{L=F;do{F=L;L=L+-16|0;if((c[F+-4>>2]|0)>-1){K=c[L>>2]|0;c[g>>2]=c[F+-12>>2];c[f+0>>2]=c[g+0>>2];eOb(K,f);c[L>>2]=0}}while((L|0)!=(C|0));M=C}}else{c[a>>2]=D;c[k>>2]=I;c[h>>2]=B;M=b}if(!M){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(M,f);i=e;return}function X0b(){return}function Y0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(972,e,1,16,3653512,91)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];k$b(f,e,b);i=d;return f|0}function Z0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;Hkc(a,b);ddd(b,2);f=c[142304]|0;add(b,560264,f,a+376|0,2048);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+380|0;add(b,560280,c[142262]|0,j,2048);EYb(j,b);bdd(b);j=a+396|0;add(b,560304,c[142280]|0,j,0);FYb(j,b);bdd(b);j=c[142268]|0;add(b,560336,j,a+456|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,560352,j,a+460|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,560368,j,a+452|0,2048);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142258]|0;add(b,558960,k,a+616|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,560384,j,a+448|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,595952,j,a+420|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+412|0;add(b,562504,614712,j,0);ddd(b,2);add(b,614648,f,j,4194305);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);j=c[142270]|0;add(b,607664,j,a+464|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);f=a+292|0;add(b,560408,560520,f,0);l=e+8|0;m=l;c[m>>2]=0;c[m+4>>2]=0;c[e>>2]=0;add(b,792256,j,f,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,l,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,560424,c[142304]|0,a+352|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,560440,k,a+619|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,560448,c[142258]|0,a+617|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);k=c[142268]|0;add(b,560472,k,a+628|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,560496,k,a+624|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function _0b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;Ikc(b,d);rdd(d,2);k=b+376|0;l=c[142304]|0;m=qdd(d,560264,l,f,0)|0;if(m){if((m|0)>0){m=d+12|0;n=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+o|0;c[m>>2]=p;if((o|0)>=0?(q=n+(o+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){c[k>>2]=c[p>>2];c[m>>2]=q}else Bid(m,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](k,d)|0}sdd(d)}k=b+380|0;m=qdd(d,560280,c[142262]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](k,d)|0}else HYb(k,d);sdd(d)}k=b+396|0;m=qdd(d,560304,c[142280]|0,h,1)|0;if(m){if((m|0)>0){rdd(d,2);m=c[142268]|0;q=qdd(d,3143216,m,f,0)|0;if(q){if((q|0)>0){q=d+12|0;p=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+o|0;c[q>>2]=n;if((o|0)>=0?(r=p+(o+4)|0,r>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[n>>2]);c[q>>2]=r}else Bid(q,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[f>>2]|0;if(q)_n[q&4095](k,d)|0}sdd(d)}q=b+400|0;r=qdd(d,3143224,m,f,0)|0;if(r){if((r|0)>0){r=d+12|0;n=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+o|0;c[r>>2]=p;if((o|0)>=0?(s=n+(o+4)|0,s>>>0<=(c[d+20>>2]|0)>>>0):0){g[q>>2]=ea(g[p>>2]);c[r>>2]=s}else Bid(r,q,4);if(c[d>>2]&512)c[q>>2]=XEi(c[q>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](q,d)|0}sdd(d)}q=b+404|0;r=qdd(d,2684928,m,f,0)|0;if(r){if((r|0)>0){r=d+12|0;s=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=s+p|0;c[r>>2]=o;if((p|0)>=0?(n=s+(p+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){g[q>>2]=ea(g[o>>2]);c[r>>2]=n}else Bid(r,q,4);if(c[d>>2]&512)c[q>>2]=XEi(c[q>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](q,d)|0}sdd(d)}q=b+408|0;r=qdd(d,2497752,m,f,0)|0;if(r){if((r|0)>0){r=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[r>>2]=o;if((n|0)>=0?(p=m+(n+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){g[q>>2]=ea(g[o>>2]);c[r>>2]=p}else Bid(r,q,4);if(c[d>>2]&512)c[q>>2]=XEi(c[q>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](q,d)|0}sdd(d)}}else{q=c[h>>2]|0;if(q)_n[q&4095](k,d)|0}sdd(d)}k=b+456|0;q=c[142268]|0;r=qdd(d,560336,q,h,0)|0;if(r){if((r|0)>0){r=d+12|0;f=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=f+p|0;c[r>>2]=o;if((p|0)>=0?(n=f+(p+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[o>>2]);c[r>>2]=n}else Bid(r,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{r=c[h>>2]|0;if(r)_n[r&4095](k,d)|0}sdd(d)}k=b+460|0;r=qdd(d,560352,q,h,0)|0;if(r){if((r|0)>0){r=d+12|0;n=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+o|0;c[r>>2]=p;if((o|0)>=0?(f=n+(o+4)|0,f>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[p>>2]);c[r>>2]=f}else Bid(r,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{r=c[h>>2]|0;if(r)_n[r&4095](k,d)|0}sdd(d)}k=b+452|0;r=qdd(d,560368,q,h,0)|0;if(r){if((r|0)>0){r=d+12|0;f=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=f+p|0;c[r>>2]=o;if((p|0)>=0?(n=f+(p+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[o>>2]);c[r>>2]=n}else Bid(r,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{r=c[h>>2]|0;if(r)_n[r&4095](k,d)|0}sdd(d)}k=b+616|0;r=c[142258]|0;n=qdd(d,558960,r,h,0)|0;if(n){do if((n|0)<=0){o=c[h>>2]|0;if(o)_n[o&4095](k,d)|0}else{o=d+12|0;p=c[d+16>>2]|0;f=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+f|0;c[o>>2]=m;if((f|0)>=0?(p+(f+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[k>>0]=a[m>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break}Bid(o,k,1)}while(0);sdd(d)}k=b+448|0;n=qdd(d,560384,q,h,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;f=o+m|0;c[n>>2]=f;if((m|0)>=0?(p=o+(m+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[f>>2]);c[n>>2]=p}else Bid(n,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{n=c[h>>2]|0;if(n)_n[n&4095](k,d)|0}sdd(d)}k=b+420|0;n=qdd(d,595952,q,h,0)|0;if(n){if((n|0)>0){n=d+12|0;p=c[d+16>>2]|0;f=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+f|0;c[n>>2]=m;if((f|0)>=0?(o=p+(f+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[m>>2]);c[n>>2]=o}else Bid(n,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{n=c[h>>2]|0;if(n)_n[n&4095](k,d)|0}sdd(d)}k=b+412|0;n=qdd(d,562504,614712,j,1)|0;if(n){if((n|0)>0){rdd(d,2);n=qdd(d,614648,l,h,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;f=o+m|0;c[n>>2]=f;if((m|0)>=0?(p=o+(m+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[k>>2]=c[f>>2];c[n>>2]=p}else Bid(n,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{n=c[h>>2]|0;if(n)_n[n&4095](k,d)|0}sdd(d)}if(wdd(d,1)|0?(n=c[k>>2]|0,(n&32|0)!=0):0)c[k>>2]=n|-65536}else{n=c[j>>2]|0;if(n)_n[n&4095](k,d)|0}sdd(d)}k=b+464|0;n=qdd(d,607664,c[142270]|0,h,0)|0;if(n){if((n|0)>0){n=d+12|0;j=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;f=j+p|0;c[n>>2]=f;if((p|0)>=0?(m=j+(p+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[k>>2]=c[f>>2];c[n>>2]=m}else Bid(n,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{n=c[h>>2]|0;if(n)_n[n&4095](k,d)|0}sdd(d)}k=b+292|0;n=qdd(d,560408,560520,h,1)|0;if(n){if((n|0)<=0){n=c[h>>2]|0;if(n)_n[n&4095](k,d)|0}else e1b(k,d);sdd(d)}k=b+352|0;n=qdd(d,560424,l,h,0)|0;if(n){if((n|0)>0){n=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;f=l+m|0;c[n>>2]=f;if((m|0)>=0?(p=l+(m+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[k>>2]=c[f>>2];c[n>>2]=p}else Bid(n,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{n=c[h>>2]|0;if(n)_n[n&4095](k,d)|0}sdd(d)}k=b+619|0;n=qdd(d,560440,r,h,0)|0;if(n){do if((n|0)<=0){p=c[h>>2]|0;if(p)_n[p&4095](k,d)|0}else{p=d+12|0;f=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=f+m|0;c[p>>2]=l;if((m|0)>=0?(f+(m+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[k>>0]=a[l>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,k,1)}while(0);sdd(d)}k=b+617|0;n=qdd(d,560448,r,h,0)|0;if(n){a:do if((n|0)<=0){r=c[h>>2]|0;if(r)_n[r&4095](k,d)|0}else{r=d+12|0;p=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+l|0;c[r>>2]=m;do if((l|0)>=0){if((p+(l+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[k>>0]=a[m>>0]|0;c[r>>2]=(c[r>>2]|0)+1;break a}while(0);Bid(r,k,1)}while(0);sdd(d)}k=b+628|0;n=qdd(d,560472,q,h,0)|0;if(n){do if((n|0)<=0){m=c[h>>2]|0;if(m)_n[m&4095](k,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;f=l+p|0;c[m>>2]=f;do if((p|0)<0)t=201;else{j=l+(p+4)|0;if(j>>>0>(c[d+20>>2]|0)>>>0){t=201;break}g[k>>2]=ea(g[f>>2]);c[m>>2]=j}while(0);if((t|0)==201)Bid(m,k,4);if(!(c[d>>2]&512))break;c[k>>2]=XEi(c[k>>2]|0)|0}while(0);sdd(d)}k=b+624|0;b=qdd(d,560496,q,h,0)|0;if(!b){i=e;return}do if((b|0)<=0){q=c[h>>2]|0;if(q)_n[q&4095](k,d)|0}else{q=d+12|0;n=c[d+16>>2]|0;f=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+f|0;c[q>>2]=p;do if((f|0)<0)t=212;else{l=n+(f+4)|0;if(l>>>0>(c[d+20>>2]|0)>>>0){t=212;break}g[k>>2]=ea(g[p>>2]);c[q>>2]=l}while(0);if((t|0)==212)Bid(q,k,4);if(!(c[d>>2]&512))break;c[k>>2]=XEi(c[k>>2]|0)|0}while(0);sdd(d);i=e;return}function $0b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;Jkc(b,d);f=b+376|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;if(k>>>0>(c[l>>2]|0)>>>0)Bid(h,f,4);else{c[f>>2]=c[j>>2];c[h>>2]=k}JYb(b+380|0,d);KYb(d,b+396|0,560304,0);k=b+456|0;j=c[h>>2]|0;f=j+4|0;m=c[l>>2]|0;if(f>>>0>m>>>0){Bid(h,k,4);n=c[h>>2]|0;o=c[l>>2]|0}else{g[k>>2]=ea(g[j>>2]);c[h>>2]=f;n=f;o=m}m=b+460|0;f=n+4|0;if(f>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[h>>2]=f;p=f;q=o}o=b+452|0;f=p+4|0;if(f>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[h>>2]=f;r=f;s=q}q=b+616|0;if((r+1|0)>>>0>s>>>0)Bid(h,q,1);else{a[q>>0]=a[r>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);r=b+448|0;q=c[h>>2]|0;s=q+4|0;f=c[l>>2]|0;if(s>>>0>f>>>0){Bid(h,r,4);t=c[h>>2]|0;u=c[l>>2]|0}else{g[r>>2]=ea(g[q>>2]);c[h>>2]=s;t=s;u=f}f=b+420|0;s=t+4|0;if(s>>>0>u>>>0){Bid(h,f,4);v=c[h>>2]|0;w=c[l>>2]|0}else{g[f>>2]=ea(g[t>>2]);c[h>>2]=s;v=s;w=u}u=b+412|0;s=v+4|0;if(s>>>0>w>>>0){Bid(h,u,4);x=c[h>>2]|0;y=c[l>>2]|0}else{c[u>>2]=c[v>>2];c[h>>2]=s;x=s;y=w}w=b+464|0;s=x+4|0;if(s>>>0>y>>>0)Bid(h,w,4);else{c[w>>2]=c[x>>2];c[h>>2]=s}f1b(b+292|0,d);s=b+352|0;x=c[h>>2]|0;w=x+4|0;y=c[l>>2]|0;if(w>>>0>y>>>0){Bid(h,s,4);z=c[h>>2]|0;A=c[l>>2]|0}else{c[s>>2]=c[x>>2];c[h>>2]=w;z=w;A=y}y=b+619|0;if((z+1|0)>>>0>A>>>0){Bid(h,y,1);B=c[h>>2]|0}else{a[y>>0]=a[z>>0]|0;z=(c[h>>2]|0)+1|0;c[h>>2]=z;B=z}z=b+617|0;if((B+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,z,1);else{a[z>>0]=a[B>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);d=b+628|0;B=c[h>>2]|0;z=B+4|0;y=c[l>>2]|0;if(z>>>0>y>>>0){Bid(h,d,4);C=c[h>>2]|0;D=c[l>>2]|0}else{g[d>>2]=ea(g[B>>2]);c[h>>2]=z;C=z;D=y}y=b+624|0;b=C+4|0;if(b>>>0>D>>>0){Bid(h,y,4);i=e;return}else{g[y>>2]=ea(g[C>>2]);c[h>>2]=b;i=e;return}}function a1b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;Kkc(b,d);f=b+376|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;if(l>>>0>(c[m>>2]|0)>>>0){Bid(h,f,4);n=c[f>>2]|0}else{o=c[j>>2]|0;c[f>>2]=o;c[h>>2]=l;n=o}c[f>>2]=XEi(n|0)|0;MYb(b+380|0,d);NYb(b+396|0,d);n=b+456|0;f=c[h>>2]|0;o=f+4|0;l=c[m>>2]|0;if(o>>>0>l>>>0){Bid(h,n,4);p=n;q=c[n>>2]|0;r=c[h>>2]|0;s=c[m>>2]|0}else{t=ea(g[f>>2]);g[n>>2]=t;c[h>>2]=o;p=n;q=(g[k>>2]=t,c[k>>2]|0);r=o;s=l}c[p>>2]=XEi(q|0)|0;q=b+460|0;p=r+4|0;if(p>>>0>s>>>0){Bid(h,q,4);u=q;v=c[q>>2]|0;w=c[h>>2]|0;x=c[m>>2]|0}else{t=ea(g[r>>2]);g[q>>2]=t;c[h>>2]=p;u=q;v=(g[k>>2]=t,c[k>>2]|0);w=p;x=s}c[u>>2]=XEi(v|0)|0;v=b+452|0;u=w+4|0;if(u>>>0>x>>>0){Bid(h,v,4);y=v;z=c[v>>2]|0;A=c[h>>2]|0;B=c[m>>2]|0}else{t=ea(g[w>>2]);g[v>>2]=t;c[h>>2]=u;y=v;z=(g[k>>2]=t,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=b+616|0;if((A+1|0)>>>0>B>>>0)Bid(h,z,1);else{a[z>>0]=a[A>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);A=b+448|0;z=c[h>>2]|0;B=z+4|0;y=c[m>>2]|0;if(B>>>0>y>>>0){Bid(h,A,4);C=A;D=c[A>>2]|0;E=c[h>>2]|0;F=c[m>>2]|0}else{t=ea(g[z>>2]);g[A>>2]=t;c[h>>2]=B;C=A;D=(g[k>>2]=t,c[k>>2]|0);E=B;F=y}c[C>>2]=XEi(D|0)|0;D=b+420|0;C=E+4|0;if(C>>>0>F>>>0){Bid(h,D,4);G=D;H=c[D>>2]|0;I=c[h>>2]|0;J=c[m>>2]|0}else{t=ea(g[E>>2]);g[D>>2]=t;c[h>>2]=C;G=D;H=(g[k>>2]=t,c[k>>2]|0);I=C;J=F}c[G>>2]=XEi(H|0)|0;H=b+412|0;G=I+4|0;if(G>>>0>J>>>0){Bid(h,H,4);K=c[H>>2]|0;L=c[h>>2]|0;M=c[m>>2]|0}else{F=c[I>>2]|0;c[H>>2]=F;c[h>>2]=G;K=F;L=G;M=J}c[H>>2]=XEi(K|0)|0;K=b+464|0;H=L+4|0;if(H>>>0>M>>>0){Bid(h,K,4);N=c[K>>2]|0}else{M=c[L>>2]|0;c[K>>2]=M;c[h>>2]=H;N=M}c[K>>2]=XEi(N|0)|0;g1b(b+292|0,d);N=b+352|0;K=c[h>>2]|0;M=K+4|0;H=c[m>>2]|0;if(M>>>0>H>>>0){Bid(h,N,4);O=c[N>>2]|0;P=c[h>>2]|0;Q=c[m>>2]|0}else{L=c[K>>2]|0;c[N>>2]=L;c[h>>2]=M;O=L;P=M;Q=H}c[N>>2]=XEi(O|0)|0;O=b+619|0;if((P+1|0)>>>0>Q>>>0){Bid(h,O,1);R=c[h>>2]|0}else{a[O>>0]=a[P>>0]|0;P=(c[h>>2]|0)+1|0;c[h>>2]=P;R=P}P=b+617|0;if((R+1|0)>>>0>(c[m>>2]|0)>>>0)Bid(h,P,1);else{a[P>>0]=a[R>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);d=b+628|0;R=c[h>>2]|0;P=R+4|0;O=c[m>>2]|0;if(P>>>0>O>>>0){Bid(h,d,4);S=d;T=c[d>>2]|0;U=c[h>>2]|0;V=c[m>>2]|0}else{t=ea(g[R>>2]);g[d>>2]=t;c[h>>2]=P;S=d;T=(g[k>>2]=t,c[k>>2]|0);U=P;V=O}c[S>>2]=XEi(T|0)|0;T=b+624|0;b=U+4|0;if(b>>>0>V>>>0){Bid(h,T,4);W=T;X=c[T>>2]|0;Y=XEi(X|0)|0;c[W>>2]=Y;i=e;return}else{t=ea(g[U>>2]);g[T>>2]=t;c[h>>2]=b;W=T;X=(g[k>>2]=t,c[k>>2]|0);Y=XEi(X|0)|0;c[W>>2]=Y;i=e;return}}function b1b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;Lkc(b,d);f=b+376|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=c[f>>2];c[h>>2]=k}else Gid(h,f,4);PYb(b+380|0,d);QYb(d,b+396|0,560304,0);f=b+456|0;k=c[h>>2]|0;j=k+4|0;m=c[l>>2]|0;if(j>>>0<m>>>0){g[k>>2]=ea(g[f>>2]);c[h>>2]=j;n=j;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=b+460|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[f>>2]);c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=b+452|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[f>>2]);c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=b+616|0;if((r+1|0)>>>0<s>>>0){a[r>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);f=b+448|0;r=c[h>>2]|0;s=r+4|0;q=c[l>>2]|0;if(s>>>0<q>>>0){g[r>>2]=ea(g[f>>2]);c[h>>2]=s;t=s;u=q}else{Gid(h,f,4);t=c[h>>2]|0;u=c[l>>2]|0}f=b+420|0;q=t+4|0;if(q>>>0<u>>>0){g[t>>2]=ea(g[f>>2]);c[h>>2]=q;v=q;w=u}else{Gid(h,f,4);v=c[h>>2]|0;w=c[l>>2]|0}f=b+412|0;u=v+4|0;if(u>>>0<w>>>0){c[v>>2]=c[f>>2];c[h>>2]=u;x=u;y=w}else{Gid(h,f,4);x=c[h>>2]|0;y=c[l>>2]|0}f=b+464|0;w=x+4|0;if(w>>>0<y>>>0){c[x>>2]=c[f>>2];c[h>>2]=w}else Gid(h,f,4);h1b(b+292|0,d);f=b+352|0;w=c[h>>2]|0;x=w+4|0;y=c[l>>2]|0;if(x>>>0<y>>>0){c[w>>2]=c[f>>2];c[h>>2]=x;z=x;A=y}else{Gid(h,f,4);z=c[h>>2]|0;A=c[l>>2]|0}f=b+619|0;if((z+1|0)>>>0<A>>>0){a[z>>0]=a[f>>0]|0;z=(c[h>>2]|0)+1|0;c[h>>2]=z;B=z}else{Gid(h,f,1);B=c[h>>2]|0}f=b+617|0;if((B+1|0)>>>0<(c[l>>2]|0)>>>0){a[B>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);d=b+628|0;f=c[h>>2]|0;B=f+4|0;z=c[l>>2]|0;if(B>>>0<z>>>0){g[f>>2]=ea(g[d>>2]);c[h>>2]=B;C=B;D=z}else{Gid(h,d,4);C=c[h>>2]|0;D=c[l>>2]|0}l=b+624|0;b=C+4|0;if(b>>>0<D>>>0){g[C>>2]=ea(g[l>>2]);c[h>>2]=b;i=e;return}else{Gid(h,l,4);i=e;return}}function c1b(a){a=a|0;var b=0;b=i;c[a>>2]=559032;n$b(a);ycc(a+636|0);xri(a+360|0);c[a>>2]=577608;WUb(a);i=b;return}function d1b(a){a=a|0;var b=0;b=i;c1b(a);ACi(a);i=b;return}function e1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function f1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function g1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function h1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function i1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((a[b+5984>>0]|0)!=0?(a[b+5972>>0]|0)==0:0){i=e;return}if(c[b+5836>>2]|0){i=e;return}b=ECc()|0;f=mo[c[(c[b>>2]|0)+84>>2]&4095](b)|0;b=d+4|0;g=f-(c[b>>2]|0)|0;f=d+12|0;d=g-(c[f>>2]|0)|0;h=(d|0)<(g|0);j=h?d:g;k=(j|0)<0?0:j;c[b>>2]=k;b=(h?g:d)-k|0;c[f>>2]=(b|0)<0?0:b;i=e;return}function j1b(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im;c=i;d=ea(g[a>>2]);e=ea(d+ea(g[a+8>>2]));f=ea(g[a+4>>2]);oMc(b,d,e,f,ea(f+ea(g[a+12>>2])),ea(-1.0),ea(100.0))|0;i=c;return}function k1b(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im;e=i;f=ync()|0;if(!(a[f+5985>>0]|0)){h=ea(0.0);j=ea(0.0)}else{h=ea(.5);j=(c[f+5836>>2]|0)==0?ea(-.5):ea(.5)}if(b)k=ea(-j);else k=j;j=ea(h*ea(g[d>>2]));b=d+48|0;g[b>>2]=ea(ea(g[b>>2])-j);j=ea(k*ea(g[d+20>>2]));b=d+52|0;g[b>>2]=ea(ea(g[b>>2])-j);i=e;return}function l1b(b,d,e,f){b=ea(b);d=ea(d);e=e|0;f=f|0;var g=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im;g=i;i=i+80|0;h=g+64|0;j=g;if(!((a[f+5985>>0]|0)==0|e)){In[c[(c[f>>2]|0)+180>>2]&4095](h,f);e=c[h+8>>2]|0;if(!e)k=ea(0.0);else k=ea(ea(.5)/ea(e|0));e=c[h+12>>2]|0;if(!e)l=ea(0.0);else l=ea(ea(.5)/ea(e|0));if(!(c[f+5836>>2]|0)){m=k;n=ea(-l)}else{m=k;n=l}}else{m=ea(0.0);n=ea(0.0)}oMc(j,m,ea(m+ea(1.0)),n,ea(n+ea(1.0)),b,d)|0;In[c[(c[f>>2]|0)+108>>2]&4095](f,j);In[c[(c[f>>2]|0)+104>>2]&4095](f,601008);i=g;return}function m1b(){var b=0,d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im;b=i;i=i+80|0;d=b+16|0;e=b;f=ync()|0;h=n8b()|0;j=ea(g[h+56>>2]);k=ea(g[h+60>>2]);l=ea(g[h+64>>2]);m=ea(g[h+68>>2]);c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;n=ea(j+ea(.5));if(!(n>=ea(0.0)))o=ea(n+ea(-.99999994));else o=n;h=~~o;c[e>>2]=h;o=ea(k+ea(.5));if(!(o>=ea(0.0)))p=ea(o+ea(-.99999994));else p=o;q=~~p;r=e+4|0;c[r>>2]=q;p=ea(j+l);c[e+8>>2]=(~~ea(p+ea(.5))>>>0)-h;l=ea(k+m);h=(~~ea(l+ea(.5))>>>0)-q|0;s=e+12|0;c[s>>2]=h;if(!((a[f+5984>>0]|0)!=0?(a[f+5972>>0]|0)==0:0))t=7;if((t|0)==7?(c[f+5836>>2]|0)==0:0){t=ECc()|0;u=(mo[c[(c[t>>2]|0)+84>>2]&4095](t)|0)-q|0;q=u-h|0;h=(q|0)<(u|0);t=h?q:u;v=(t|0)<0?0:t;c[r>>2]=v;r=(h?u:q)-v|0;c[s>>2]=(r|0)<0?0:r}In[c[(c[f>>2]|0)+176>>2]&4095](f,e);oMc(d,j,p,k,l,ea(-1.0),ea(100.0))|0;e=ync()|0;if(!(a[e+5985>>0]|0)){w=ea(0.0);x=ea(0.0)}else{w=ea(.5);x=(c[e+5836>>2]|0)==0?ea(-.5):ea(.5)}l=ea(w*ea(g[d>>2]));e=d+48|0;g[e>>2]=ea(ea(g[e>>2])-l);l=ea(x*ea(g[d+20>>2]));e=d+52|0;g[e>>2]=ea(ea(g[e>>2])-l);In[c[(c[f>>2]|0)+108>>2]&4095](f,d);In[c[(c[f>>2]|0)+104>>2]&4095](f,601008);i=b;return}function n1b(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=0,i=Im,j=0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;d=ea(g[b>>2]);e=ea(d+ea(.5));if(!(e>=ea(0.0)))f=ea(e+ea(-.99999994));else f=e;h=~~f;c[a>>2]=h;f=ea(g[b+4>>2]);e=ea(f+ea(.5));if(!(e>=ea(0.0)))i=ea(e+ea(-.99999994));else i=e;j=~~i;c[a+4>>2]=j;c[a+8>>2]=(~~ea(ea(d+ea(g[b+8>>2]))+ea(.5))>>>0)-h;c[a+12>>2]=(~~ea(ea(f+ea(g[b+12>>2]))+ea(.5))>>>0)-j;return}function o1b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=Im,u=0,v=0;h=i;j=ea(g[d>>2]);k=ea(g[a>>2]);l=ea(j*k);j=ea(g[d+16>>2]);m=ea(g[a+4>>2]);n=ea(l+ea(j*m));j=ea(g[d+32>>2]);l=ea(g[a+8>>2]);o=ea(n+ea(j*l));j=ea(ea(g[d+48>>2])+o);o=ea(k*ea(g[d+4>>2]));n=ea(o+ea(m*ea(g[d+20>>2])));o=ea(n+ea(l*ea(g[d+36>>2])));n=ea(ea(g[d+52>>2])+o);o=ea(k*ea(g[d+12>>2]));p=ea(o+ea(m*ea(g[d+28>>2])));o=ea(p+ea(l*ea(g[d+44>>2])));p=ea(ea(g[d+60>>2])+o);if(p<ea(0.0))q=ea(-p);else q=p;if(q>ea(1.00000001e-07)){q=ea(ea(1.0)/p);p=ea(j*q);j=ea(n*q);q=ea(g[b+48>>2]);n=ea(g[b+52>>2]);o=ea(k-q);q=ea(m-n);n=ea(l-ea(g[b+56>>2]));l=ea(g[b+32>>2]);m=ea(g[b+36>>2]);k=ea(ea(ea(-ea(q*m))-ea(o*l))-ea(n*ea(g[b+40>>2])));n=ea(c[e>>2]|0);l=ea(p+ea(1.0));g[f>>2]=ea(n+ea(ea(l*ea(c[e+8>>2]|0))*ea(.5)));l=ea(c[e+4>>2]|0);n=ea(j+ea(1.0));r=1;s=k;t=ea(l+ea(ea(n*ea(c[e+12>>2]|0))*ea(.5)));u=f+4|0;g[u>>2]=t;v=f+8|0;g[v>>2]=s;i=h;return r|0}else{g[f>>2]=ea(0.0);r=0;s=ea(0.0);t=ea(0.0);u=f+4|0;g[u>>2]=t;v=f+8|0;g[v>>2]=s;i=h;return r|0}return 0}function p1b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0;h=i;j=ea(g[a>>2]);k=ea(ea(j-ea(c[e>>2]|0))*ea(2.0));j=ea(ea(k/ea(c[e+8>>2]|0))+ea(-1.0));k=ea(g[a+4>>2]);l=ea(ea(k-ea(c[e+4>>2]|0))*ea(2.0));k=ea(ea(l/ea(c[e+12>>2]|0))+ea(-1.0));l=ea(j*ea(g[d>>2]));m=ea(l+ea(k*ea(g[d+16>>2])));l=ea(m+ea(ea(g[d+32>>2])*ea(.949999988)));m=ea(ea(g[d+48>>2])+l);l=ea(j*ea(g[d+4>>2]));n=ea(l+ea(k*ea(g[d+20>>2])));l=ea(n+ea(ea(g[d+36>>2])*ea(.949999988)));n=ea(ea(g[d+52>>2])+l);l=ea(j*ea(g[d+8>>2]));o=ea(l+ea(k*ea(g[d+24>>2])));l=ea(o+ea(ea(g[d+40>>2])*ea(.949999988)));o=ea(ea(g[d+56>>2])+l);l=ea(g[d+12>>2]);p=ea(j*l);j=ea(g[d+28>>2]);q=ea(p+ea(k*j));k=ea(g[d+44>>2]);p=ea(q+ea(k*ea(.949999988)));q=ea(g[d+60>>2]);r=ea(q+p);if(r<ea(0.0))s=ea(-r);else s=r;if(s>ea(1.00000001e-07)){s=ea(ea(1.0)/r);r=ea(m*s);m=ea(n*s);n=ea(o*s);s=ea(g[b+48>>2]);o=ea(g[b+52>>2]);p=ea(g[b+56>>2]);t=ea(r-s);u=ea(m-o);v=ea(n-p);w=ea(g[b+32>>2]);x=ea(g[b+36>>2]);y=ea(-w);w=ea(-x);x=ea(-ea(g[b+40>>2]));z=ea(ea(ea(t*y)+ea(u*w))+ea(v*x));if(z<ea(0.0))A=ea(-z);else A=z;if(A>=ea(9.99999997e-07)){if(!(l!=ea(0.0)|j!=ea(0.0)|k!=ea(0.0))){b=q!=ea(1.0);q=ea(g[a+8>>2]);if(b)B=q;else{k=ea(z-q);q=ea(m-ea(k*w));w=ea(n-ea(k*x));g[f>>2]=ea(r-ea(k*y));g[f+4>>2]=q;g[f+8>>2]=w;C=1;i=h;return C|0}}else B=ea(g[a+8>>2]);w=ea(B/z);z=ea(o+ea(u*w));u=ea(p+ea(v*w));g[f>>2]=ea(s+ea(t*w));g[f+4>>2]=z;g[f+8>>2]=u;C=1;i=h;return C|0}}g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);C=0;i=h;return C|0}function q1b(b){b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d;f=ea(g[b>>2]);h=ea(g[b+4>>2]);j=ea(g[b+8>>2]);k=ea(g[b+12>>2]);b=ync()|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;l=ea(f+ea(.5));if(!(l>=ea(0.0)))m=ea(l+ea(-.99999994));else m=l;n=~~m;c[e>>2]=n;m=ea(h+ea(.5));if(!(m>=ea(0.0)))o=ea(m+ea(-.99999994));else o=m;p=~~o;q=e+4|0;c[q>>2]=p;c[e+8>>2]=(~~ea(ea(f+j)+ea(.5))>>>0)-n;n=(~~ea(ea(h+k)+ea(.5))>>>0)-p|0;r=e+12|0;c[r>>2]=n;if((a[b+5984>>0]|0)!=0?(a[b+5972>>0]|0)==0:0){s=c[b>>2]|0;t=s+176|0;u=c[t>>2]|0;In[u&4095](b,e);i=d;return}if(c[b+5836>>2]|0){s=c[b>>2]|0;t=s+176|0;u=c[t>>2]|0;In[u&4095](b,e);i=d;return}v=ECc()|0;w=(mo[c[(c[v>>2]|0)+84>>2]&4095](v)|0)-p|0;p=w-n|0;n=(p|0)<(w|0);v=n?p:w;x=(v|0)<0?0:v;c[q>>2]=x;q=(n?w:p)-x|0;c[r>>2]=(q|0)<0?0:q;s=c[b>>2]|0;t=s+176|0;u=c[t>>2]|0;In[u&4095](b,e);i=d;return}function r1b(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;c=ea(g[a+12>>2]);d=ea(g[a+28>>2]);e=ea(g[a+44>>2]);f=ea(g[a+60>>2]);h=ea(g[a>>2]);i=ea(g[a+16>>2]);j=ea(g[a+32>>2]);k=ea(g[a+48>>2]);l=ea(c+h);m=ea(d+i);n=ea(e+j);o=ea(f+k);p=ea(ea(1.0)/ea(T(ea(ea(ea(l*l)+ea(m*m))+ea(n*n)))));g[b>>2]=ea(l*p);g[b+4>>2]=ea(m*p);g[b+8>>2]=ea(n*p);g[b+12>>2]=ea(p*o);o=ea(c-h);h=ea(d-i);i=ea(e-j);j=ea(f-k);k=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(h*h))+ea(i*i)))));g[b+16>>2]=ea(o*k);g[b+20>>2]=ea(h*k);g[b+24>>2]=ea(i*k);g[b+28>>2]=ea(k*j);j=ea(g[a+4>>2]);k=ea(g[a+20>>2]);i=ea(g[a+36>>2]);h=ea(g[a+52>>2]);o=ea(c+j);p=ea(d+k);n=ea(e+i);m=ea(f+h);l=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(p*p))+ea(n*n)))));g[b+32>>2]=ea(o*l);g[b+36>>2]=ea(p*l);g[b+40>>2]=ea(n*l);g[b+44>>2]=ea(l*m);m=ea(c-j);j=ea(d-k);k=ea(e-i);i=ea(f-h);h=ea(ea(1.0)/ea(T(ea(ea(ea(m*m)+ea(j*j))+ea(k*k)))));g[b+48>>2]=ea(m*h);g[b+52>>2]=ea(j*h);g[b+56>>2]=ea(k*h);g[b+60>>2]=ea(h*i);i=ea(g[a+8>>2]);h=ea(g[a+24>>2]);k=ea(g[a+40>>2]);j=ea(g[a+56>>2]);m=ea(c+i);l=ea(d+h);n=ea(e+k);p=ea(f+j);o=ea(ea(1.0)/ea(T(ea(ea(ea(m*m)+ea(l*l))+ea(n*n)))));g[b+64>>2]=ea(m*o);g[b+68>>2]=ea(l*o);g[b+72>>2]=ea(n*o);g[b+76>>2]=ea(o*p);p=ea(c-i);i=ea(d-h);h=ea(e-k);k=ea(f-j);j=ea(ea(1.0)/ea(T(ea(ea(ea(p*p)+ea(i*i))+ea(h*h)))));g[b+80>>2]=ea(p*j);g[b+84>>2]=ea(i*j);g[b+88>>2]=ea(h*j);g[b+92>>2]=ea(j*k);return}function s1b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+160|0;d=b+96|0;e=b;f=mo[c[(c[a>>2]|0)+120>>2]&4095](a)|0;dMc(mo[c[(c[a>>2]|0)+128>>2]&4095](a)|0,f,d);g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);g[e+16>>2]=ea(0.0);g[e+20>>2]=ea(0.0);g[e+24>>2]=ea(0.0);g[e+32>>2]=ea(0.0);g[e+36>>2]=ea(0.0);g[e+40>>2]=ea(0.0);g[e+48>>2]=ea(0.0);g[e+52>>2]=ea(0.0);g[e+56>>2]=ea(0.0);g[e+64>>2]=ea(0.0);g[e+68>>2]=ea(0.0);g[e+72>>2]=ea(0.0);g[e+80>>2]=ea(0.0);g[e+84>>2]=ea(0.0);g[e+88>>2]=ea(0.0);r1b(d,e);d=a+1380|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];d=e+16|0;f=a+1396|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=e+32|0;f=a+1412|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=e+48|0;f=a+1428|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=e+64|0;f=a+1444|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=e+80|0;e=a+1460|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];i=b;return}function t1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;c[a>>2]=b;e=a+4|0;f=a+132|0;g=a+68|0;a=(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0)+0|0;h=g+64|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(h|0));g=e+0|0;a=(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0)+0|0;h=g+64|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(h|0));g=f+0|0;a=(mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0)+0|0;h=g+64|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(h|0));i=d;return}function u1b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+160|0;d=b+96|0;e=b;f=c[a>>2]|0;In[c[(c[f>>2]|0)+108>>2]&4095](f,a+132|0);f=c[a>>2]|0;In[c[(c[f>>2]|0)+104>>2]&4095](f,a+68|0);f=c[a>>2]|0;In[c[(c[f>>2]|0)+100>>2]&4095](f,a+4|0);f=c[a>>2]|0;a=mo[c[(c[f>>2]|0)+120>>2]&4095](f)|0;dMc(mo[c[(c[f>>2]|0)+128>>2]&4095](f)|0,a,d);g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);g[e+16>>2]=ea(0.0);g[e+20>>2]=ea(0.0);g[e+24>>2]=ea(0.0);g[e+32>>2]=ea(0.0);g[e+36>>2]=ea(0.0);g[e+40>>2]=ea(0.0);g[e+48>>2]=ea(0.0);g[e+52>>2]=ea(0.0);g[e+56>>2]=ea(0.0);g[e+64>>2]=ea(0.0);g[e+68>>2]=ea(0.0);g[e+72>>2]=ea(0.0);g[e+80>>2]=ea(0.0);g[e+84>>2]=ea(0.0);g[e+88>>2]=ea(0.0);r1b(d,e);d=f+1380|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];d=e+16|0;a=f+1396|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+32|0;a=f+1412|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+48|0;a=f+1428|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+64|0;a=f+1444|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+80|0;e=f+1460|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];i=b;return}function v1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=b;e=a+68|0;f=a+4|0;a=(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0)+0|0;g=f+64|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(g|0));f=e+0|0;a=(mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0)+0|0;g=f+64|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(g|0));i=d;return}function w1b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+160|0;d=b+96|0;e=b;f=c[a>>2]|0;In[c[(c[f>>2]|0)+108>>2]&4095](f,a+68|0);f=c[a>>2]|0;In[c[(c[f>>2]|0)+104>>2]&4095](f,a+4|0);f=c[a>>2]|0;a=mo[c[(c[f>>2]|0)+120>>2]&4095](f)|0;dMc(mo[c[(c[f>>2]|0)+128>>2]&4095](f)|0,a,d);g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);g[e+16>>2]=ea(0.0);g[e+20>>2]=ea(0.0);g[e+24>>2]=ea(0.0);g[e+32>>2]=ea(0.0);g[e+36>>2]=ea(0.0);g[e+40>>2]=ea(0.0);g[e+48>>2]=ea(0.0);g[e+52>>2]=ea(0.0);g[e+56>>2]=ea(0.0);g[e+64>>2]=ea(0.0);g[e+68>>2]=ea(0.0);g[e+72>>2]=ea(0.0);g[e+80>>2]=ea(0.0);g[e+84>>2]=ea(0.0);g[e+88>>2]=ea(0.0);r1b(d,e);d=f+1380|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];d=e+16|0;a=f+1396|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+32|0;a=f+1412|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+48|0;a=f+1428|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+64|0;a=f+1444|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];d=e+80|0;e=f+1460|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];i=b;return}function x1b(b){b=b|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;f=d+4|0;h=d;j=b+976|0;k=b+92|0;l=b+100|0;m=b+104|0;n=b+96|0;o=b+116|0;p=b+120|0;q=b+108|0;r=b+112|0;s=0;do{t=c[b+(s*12|0)+852>>2]|0;u=c[j>>2]|0;v=b+(s*12|0)+20|0;w=c[v>>2]|0;x=w+(c[l>>2]|0)|0;y=c[m>>2]|0;if((y&2147483647)>>>0<x>>>0){if((y|0)>-1){c[m>>2]=x;y=c[k>>2]|0;c[h>>2]=c[n>>2];c[f+0>>2]=c[h+0>>2];z=hOb(y,x<<7,4,f,0,3653512,370)|0}else{c[h>>2]=c[n>>2];c[f+0>>2]=c[h+0>>2];y=cOb(x<<7,4,f,0,3653512,352)|0;YEi(y|0,c[k>>2]|0,c[l>>2]<<7|0)|0;c[m>>2]=x;z=y}c[k>>2]=z;A=c[v>>2]|0}else A=w;if((A|0)>0){w=b+(s*12|0)+16|0;y=0;do{x=c[(c[w>>2]|0)+(y<<2)>>2]|0;B=t+(x*24|0)|0;if(a[t+(x*24|0)+20>>0]|0){C=c[B>>2]|0;D=(c[o>>2]|0)+1|0;c[o>>2]=D;E=c[p>>2]|0;F=E&2147483647;if(D>>>0>F>>>0){G=E<<1;H=(G|0)==0?1:G;do if(F>>>0<H>>>0)if((E|0)>-1){c[p>>2]=H;G=c[q>>2]|0;c[h>>2]=c[r>>2];c[f+0>>2]=c[h+0>>2];c[q>>2]=hOb(G,H<<2,4,f,0,3653512,370)|0;break}else{c[h>>2]=c[r>>2];c[f+0>>2]=c[h+0>>2];G=cOb(H<<2,4,f,0,3653512,352)|0;YEi(G|0,c[q>>2]|0,c[o>>2]<<2|0)|0;c[p>>2]=H;c[q>>2]=G;break}while(0);I=c[o>>2]|0}else I=D;c[(c[q>>2]|0)+(I+-1<<2)>>2]=C}H=z1b(k)|0;c[H+116>>2]=c[B>>2];E=e[t+(x*24|0)+12>>1]|0;g[H+120>>2]=ea(huc(e[t+(x*24|0)+14>>1]|0,c[t+(x*24|0)+16>>2]|0,c[u+(E*12|0)>>2]|0,c[u+(E*12|0)+4>>2]|0));y=y+1|0}while((y|0)<(c[v>>2]|0))}s=s+1|0}while((s|0)!=5);i=d;return}function y1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=d+8|0;jac(d,g,b,d+16|0);h=d+84|0;Ind(h,3498,d,g,0);j=b+673|0;if(a[j>>0]|0)A1b(b,d);if(c[g>>2]|0)Gnd(g);g=kbc()|0;k=d+16|0;l=d+848|0;m=0;do{n=c[g+(m<<2)+1024>>2]|0;if(n)In[n&4095](k,l);m=m+1|0}while((m|0)!=16);if(c[h>>2]|0)Gnd(h);Kac(Lac()|0,1);h=d+116|0;if(c[h>>2]|0){m=d+108|0;l=f+8|0;k=f+4|0;g=0;do{n=c[(c[m>>2]|0)+(g<<2)>>2]|0;if(!n)o=0;else o=n+-28|0;c[l>>2]=0;c[k>>2]=0;c[f>>2]=0;cUb(o,555056,f);g=g+1|0}while(g>>>0<(c[h>>2]|0)>>>0)}Kac(Lac()|0,0);h=d+100|0;if(c[h>>2]|0){g=d+92|0;f=0;do{o=c[g>>2]|0;k=o+(f<<7)|0;l=c[o+(f<<7)+116>>2]|0;o=l+48|0;m=l+49|0;if(!((a[o>>0]|0)==0?(a[m>>0]|0)==0:0)){ko[c[(c[l>>2]|0)+60>>2]&4095](l);a[o>>0]=0;a[m>>0]=0}m=k+0|0;k=l+52|0;l=m+116|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(l|0));f=f+1|0}while(f>>>0<(c[h>>2]|0)>>>0)}if(!(a[j>>0]|0)){i=e;return}Sac(d+184|0,c[b+676>>2]|0,d+92|0,d+124|0,d+192|0,d+208|0);i=e;return}function z1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;do if(g>>>0>k>>>0?(l=j<<1,m=(l|0)==0?1:l,k>>>0<m>>>0):0)if((j|0)>-1){c[h>>2]=m;l=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(l,m<<7,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];l=cOb(m<<7,4,d,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[f>>2]<<7|0)|0;c[h>>2]=m;c[a>>2]=l;break}while(0);i=b;return (c[a>>2]|0)+((c[f>>2]|0)+-1<<7)|0}function A1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+112|0;f=e+84|0;g=e+60|0;h=e+16|0;j=e+32|0;k=e+88|0;l=e;m=e+48|0;n=e+72|0;o=e+64|0;p=z5b()|0;q=c[p+4>>2]|0;if((q|0)!=(p|0)){r=q;q=0;while(1){s=q+1|0;r=c[r+4>>2]|0;if((r|0)==(p|0)){t=s;break}else q=s}q=d+124|0;if(t){p=d+168|0;r=d+180|0;s=c[r>>2]|0;do if((s&2147483647)>>>0<t>>>0)if((s|0)>-1){c[r>>2]=t;u=c[p>>2]|0;c[g>>2]=c[d+172>>2];c[f+0>>2]=c[g+0>>2];c[p>>2]=hOb(u,t<<4,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+172>>2];c[f+0>>2]=c[g+0>>2];u=cOb(t<<4,4,f,0,3653512,352)|0;YEi(u|0,c[p>>2]|0,c[d+176>>2]<<4|0)|0;c[r>>2]=t;c[p>>2]=u;break}while(0);r=c[153134]|0;c[h>>2]=0;s=h+4|0;c[s>>2]=r;u=h+8|0;c[u>>2]=0;v=h+12|0;c[v>>2]=0;c[j>>2]=0;w=j+4|0;c[w>>2]=r;x=j+8|0;c[x>>2]=0;y=j+12|0;c[y>>2]=0;c[k>>2]=0;z=k+4|0;c[z>>2]=r;A=k+8|0;c[A>>2]=0;B=k+12|0;c[B>>2]=0;c[l>>2]=0;C=l+4|0;c[C>>2]=r;D=l+8|0;c[D>>2]=0;E=l+12|0;c[E>>2]=0;if(!t)F=0;else{c[v>>2]=t;c[g>>2]=r;c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(0,t<<2,4,f,0,3653512,370)|0;F=c[y>>2]|0}do if((F&2147483647)>>>0<t>>>0)if((F|0)>-1){c[y>>2]=t;r=c[j>>2]|0;c[g>>2]=c[w>>2];c[f+0>>2]=c[g+0>>2];c[j>>2]=hOb(r,t<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[w>>2];c[f+0>>2]=c[g+0>>2];r=cOb(t<<2,4,f,0,3653512,352)|0;YEi(r|0,c[j>>2]|0,c[x>>2]<<2|0)|0;c[y>>2]=t;c[j>>2]=r;break}while(0);F=c[B>>2]|0;do if((F&2147483647)>>>0<t>>>0)if((F|0)>-1){c[B>>2]=t;r=c[k>>2]|0;c[g>>2]=c[z>>2];c[f+0>>2]=c[g+0>>2];c[k>>2]=hOb(r,t<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[z>>2];c[f+0>>2]=c[g+0>>2];r=cOb(t<<2,4,f,0,3653512,352)|0;YEi(r|0,c[k>>2]|0,c[A>>2]<<2|0)|0;c[B>>2]=t;c[k>>2]=r;break}while(0);A=c[E>>2]|0;do if((A&2147483647)>>>0<t>>>0)if((A|0)>-1){c[E>>2]=t;F=c[l>>2]|0;c[g>>2]=c[C>>2];c[f+0>>2]=c[g+0>>2];c[l>>2]=hOb(F,t<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[C>>2];c[f+0>>2]=c[g+0>>2];F=cOb(t<<2,4,f,0,3653512,352)|0;YEi(F|0,c[l>>2]|0,c[D>>2]<<2|0)|0;c[E>>2]=t;c[l>>2]=F;break}while(0);t=d+1024|0;r5b(j,h,p,l,c[t>>2]|0);D=(c[u>>2]|0)+(c[x>>2]|0)|0;A=d+136|0;F=c[A>>2]|0;do if((F&2147483647)>>>0<D>>>0)if((F|0)>-1){c[A>>2]=D;r=c[q>>2]|0;c[g>>2]=c[d+128>>2];c[f+0>>2]=c[g+0>>2];c[q>>2]=hOb(r,D*108|0,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+128>>2];c[f+0>>2]=c[g+0>>2];r=cOb(D*108|0,4,f,0,3653512,352)|0;YEi(r|0,c[q>>2]|0,(c[d+132>>2]|0)*108|0)|0;c[A>>2]=D;c[q>>2]=r;break}while(0);o5b(c[j>>2]|0,c[x>>2]|0,q);D=d+224|0;A=(c[u>>2]|0)+(c[x>>2]|0)|0;x=d+236|0;u=c[x>>2]|0;do if((u&2147483647)>>>0<A>>>0)if((u|0)>-1){c[x>>2]=A;F=c[D>>2]|0;c[g>>2]=c[d+228>>2];c[f+0>>2]=c[g+0>>2];c[D>>2]=hOb(F,A*796|0,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+228>>2];c[f+0>>2]=c[g+0>>2];F=cOb(A*796|0,4,f,0,3653512,352)|0;YEi(F|0,c[D>>2]|0,(c[d+232>>2]|0)*796|0)|0;c[x>>2]=A;c[D>>2]=F;break}while(0);A=d+144|0;x=c[A>>2]|0;if(x){u=0;do{F=c[q>>2]|0;if(((a[F+(u*108|0)+9>>0]|0)!=0?(a[F+(u*108|0)+8>>0]|0)!=0:0)?(c[(c[F+(u*108|0)>>2]|0)+116>>2]|0)!=0:0){r=B1b(D)|0;c[r>>2]=u;c[F+(u*108|0)+4>>2]=r}else c[F+(u*108|0)+4>>2]=0;u=u+1|0}while((u|0)!=(x|0))}c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;x=d+176|0;F1b(m,c[x>>2]|0);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;F1b(n,c[x>>2]|0);c[o>>2]=0;c[o+4>>2]=0;n5b(o,d,b,p,l,m,n,k);x=d+232|0;D9b(c[x>>2]|0,b,d);if(c[o>>2]|0)Gnd(o);s5b(c[t>>2]|0,c[h>>2]|0,c[p>>2]|0,m,c[k>>2]|0,n,q);G1b(m);G1b(n);n=pyc()|0;if(((c[(c[n+24>>2]|0)+((c[n+40>>2]|0)*96|0)+16>>2]|0)!=0?(c[b+676>>2]|0)!=0:0)?(n=c[x>>2]|0,m=c[A>>2]|0,A=(c[d+148>>2]|0)+m+(c[d+152>>2]|0)|0,m>>>0<A>>>0):0){q=d+124|0;p=m;do{m=c[q>>2]|0;do if((a[m+(p*108|0)+9>>0]|0)!=0?(a[m+(p*108|0)+8>>0]|0)!=0:0){if(!(c[(c[m+(p*108|0)>>2]|0)+116>>2]|0)){G=49;break}t=B1b(D)|0;c[t>>2]=p;c[m+(p*108|0)+4>>2]=t}else G=49;while(0);if((G|0)==49){G=0;c[m+(p*108|0)+4>>2]=0}p=p+1|0}while((p|0)!=(A|0));A=c[x>>2]|0;if((A|0)!=(n|0))y9b(n,A,(a[b+672>>0]|0)!=0,d)}if((c[E>>2]|0)>-1){E=c[l>>2]|0;c[g>>2]=c[C>>2];c[f+0>>2]=c[g+0>>2];eOb(E,f);c[l>>2]=0}if((c[B>>2]|0)>-1){B=c[k>>2]|0;c[g>>2]=c[z>>2];c[f+0>>2]=c[g+0>>2];eOb(B,f);c[k>>2]=0}if((c[y>>2]|0)>-1){y=c[j>>2]|0;c[g>>2]=c[w>>2];c[f+0>>2]=c[g+0>>2];eOb(y,f);c[j>>2]=0}if((c[v>>2]|0)<=-1){i=e;return}v=c[h>>2]|0;c[g>>2]=c[s>>2];c[f+0>>2]=c[g+0>>2];eOb(v,f);c[h>>2]=0;i=e;return}}a[d+140>>0]=0;a[d+164>>0]=0;i=e;return}function B1b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;h=b+8|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;k=b+12|0;l=c[k>>2]|0;m=l&2147483647;do if(j>>>0>m>>>0?(n=l<<1,o=(n|0)==0?1:n,m>>>0<o>>>0):0)if((l|0)>-1){c[k>>2]=o;n=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];c[b>>2]=hOb(n,o*796|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];n=cOb(o*796|0,4,e,0,3653512,352)|0;YEi(n|0,c[b>>2]|0,(c[h>>2]|0)*796|0)|0;c[k>>2]=o;c[b>>2]=n;break}while(0);k=(c[h>>2]|0)+-1|0;h=c[b>>2]|0;b=h+(k*796|0)|0;e=h+(k*796|0)+4|0;c[h+(k*796|0)+68>>2]=0;c[h+(k*796|0)+72>>2]=0;c[h+(k*796|0)+76>>2]=0;g[h+(k*796|0)+84>>2]=ea(0.0);g[h+(k*796|0)+88>>2]=ea(0.0);g[h+(k*796|0)+92>>2]=ea(0.0);g[h+(k*796|0)+108>>2]=ea(0.0);g[h+(k*796|0)+112>>2]=ea(0.0);g[h+(k*796|0)+116>>2]=ea(0.0);g[h+(k*796|0)+124>>2]=ea(0.0);g[h+(k*796|0)+128>>2]=ea(0.0);g[h+(k*796|0)+132>>2]=ea(0.0);g[h+(k*796|0)+140>>2]=ea(0.0);g[h+(k*796|0)+144>>2]=ea(0.0);g[h+(k*796|0)+148>>2]=ea(0.0);g[h+(k*796|0)+156>>2]=ea(0.0);g[h+(k*796|0)+160>>2]=ea(0.0);g[h+(k*796|0)+164>>2]=ea(0.0);g[h+(k*796|0)+172>>2]=ea(0.0);g[h+(k*796|0)+176>>2]=ea(0.0);g[h+(k*796|0)+180>>2]=ea(0.0);g[h+(k*796|0)+188>>2]=ea(0.0);g[h+(k*796|0)+192>>2]=ea(0.0);g[h+(k*796|0)+196>>2]=ea(0.0);g[h+(k*796|0)+204>>2]=ea(0.0);g[h+(k*796|0)+208>>2]=ea(0.0);g[h+(k*796|0)+212>>2]=ea(0.0);g[h+(k*796|0)+220>>2]=ea(0.0);g[h+(k*796|0)+224>>2]=ea(0.0);g[h+(k*796|0)+228>>2]=ea(0.0);g[h+(k*796|0)+236>>2]=ea(0.0);g[h+(k*796|0)+240>>2]=ea(0.0);g[h+(k*796|0)+244>>2]=ea(0.0);g[h+(k*796|0)+252>>2]=ea(0.0);g[h+(k*796|0)+256>>2]=ea(0.0);g[h+(k*796|0)+260>>2]=ea(0.0);g[h+(k*796|0)+408>>2]=ea(0.0);g[h+(k*796|0)+412>>2]=ea(0.0);g[h+(k*796|0)+416>>2]=ea(0.0);f=h+(k*796|0)+676|0;c[h+(k*796|0)+784>>2]=0;c[h+(k*796|0)+788>>2]=0;c[h+(k*796|0)+792>>2]=0;k=e+0|0;h=k+60|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));a[e+60>>0]=0;k=f+0|0;h=k+72|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(h|0));i=d;return b|0}function C1b(b){b=b|0;var d=0,e=0,f=0,h=0;d=i;c[b+80>>2]=0;c[b+84>>2]=0;c[b+88>>2]=0;e=b+0|0;f=e+76|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));a[b+76>>0]=0;h=c[153136]|0;c[b+92>>2]=0;c[b+96>>2]=h;c[b+100>>2]=0;c[b+104>>2]=0;h=c[153136]|0;c[b+108>>2]=0;c[b+112>>2]=h;c[b+116>>2]=0;c[b+120>>2]=0;h=c[153134]|0;c[b+124>>2]=0;c[b+128>>2]=h;c[b+132>>2]=0;c[b+136>>2]=0;a[b+140>>0]=0;h=b+144|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;a[h+20>>0]=0;h=c[153134]|0;c[b+168>>2]=0;c[b+172>>2]=h;h=b+176|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;h=c[153136]|0;c[b+192>>2]=0;c[b+196>>2]=h;c[b+200>>2]=0;c[b+204>>2]=0;h=c[153136]|0;c[b+208>>2]=0;c[b+212>>2]=h;c[b+216>>2]=0;c[b+220>>2]=0;h=c[153134]|0;c[b+224>>2]=0;c[b+228>>2]=h;c[b+232>>2]=0;c[b+236>>2]=0;g[b+244>>2]=ea(0.0);g[b+248>>2]=ea(0.0);g[b+252>>2]=ea(0.0);g[b+268>>2]=ea(0.0);g[b+272>>2]=ea(0.0);g[b+276>>2]=ea(0.0);g[b+284>>2]=ea(0.0);g[b+288>>2]=ea(0.0);g[b+292>>2]=ea(0.0);g[b+300>>2]=ea(0.0);g[b+304>>2]=ea(0.0);g[b+308>>2]=ea(0.0);g[b+316>>2]=ea(0.0);g[b+320>>2]=ea(0.0);g[b+324>>2]=ea(0.0);g[b+332>>2]=ea(0.0);g[b+336>>2]=ea(0.0);g[b+340>>2]=ea(0.0);g[b+348>>2]=ea(0.0);g[b+352>>2]=ea(0.0);g[b+356>>2]=ea(0.0);g[b+364>>2]=ea(0.0);g[b+368>>2]=ea(0.0);g[b+372>>2]=ea(0.0);g[b+380>>2]=ea(0.0);g[b+384>>2]=ea(0.0);g[b+388>>2]=ea(0.0);g[b+396>>2]=ea(0.0);g[b+400>>2]=ea(0.0);g[b+404>>2]=ea(0.0);g[b+412>>2]=ea(0.0);g[b+416>>2]=ea(0.0);g[b+420>>2]=ea(0.0);g[b+568>>2]=ea(0.0);g[b+572>>2]=ea(0.0);g[b+576>>2]=ea(0.0);h=b+944|0;e=b+836|0;f=e+72|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;h=c[153134]|0;c[b+976>>2]=0;c[b+980>>2]=h;c[b+984>>2]=0;c[b+988>>2]=0;h=c[153134]|0;c[b+992>>2]=0;c[b+996>>2]=h;c[b+1e3>>2]=0;c[b+1004>>2]=0;h=c[153134]|0;c[b+1008>>2]=0;c[b+1012>>2]=h;h=b+1016|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;h=c[153136]|0;c[b+1036>>2]=0;c[b+1040>>2]=h;c[b+1044>>2]=0;c[b+1048>>2]=0;h=c[153136]|0;c[b+1052>>2]=0;c[b+1056>>2]=h;c[b+1060>>2]=0;c[b+1064>>2]=0;c[b+1068>>2]=0;c[b+1072>>2]=-1;a[b+1076>>0]=0;i=d;return}function D1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;if(c[a>>2]|0)Gnd(a);d=a+184|0;if(c[d>>2]|0)Gnd(d);d=a+1028|0;if(c[d>>2]|0)Gnd(d);d=a+232|0;e=c[d>>2]|0;if(!e){i=b;return}f=a+224|0;a=e;e=0;while(1){g=(c[f>>2]|0)+(e*796|0)+72|0;if(!(c[g>>2]|0))h=a;else{Gnd(g);h=c[d>>2]|0}e=e+1|0;if(e>>>0>=h>>>0)break;else a=h}i=b;return}function E1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;if(c[a>>2]|0)Gnd(a);j=a+184|0;if(c[j>>2]|0)Gnd(j);j=a+1028|0;if(c[j>>2]|0)Gnd(j);j=a+232|0;k=c[j>>2]|0;if(!k)l=0;else{m=a+224|0;n=k;k=0;while(1){o=(c[m>>2]|0)+(k*796|0)+72|0;if(!(c[o>>2]|0))p=n;else{Gnd(o);p=c[j>>2]|0}k=k+1|0;if(k>>>0>=p>>>0){l=p;break}else n=p}}p=a+80|0;if(!(c[p>>2]|0))q=l;else{l=GLc()|0;n=c[(c[l>>2]|0)+36>>2]|0;k=c[p>>2]|0;c[h>>2]=c[153134];c[d+0>>2]=c[h+0>>2];Dn[n&511](l,k,0,d);q=c[j>>2]|0}k=a+224|0;if(q){q=0;do{l=c[k>>2]|0;n=l+(q*796|0)+4|0;h=c[n>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[n>>2]=0;n=l+(q*796|0)+16|0;h=c[n>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[n>>2]=0;n=l+(q*796|0)+28|0;h=c[n>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[n>>2]=0;n=l+(q*796|0)+40|0;h=c[n>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[n>>2]=0;n=l+(q*796|0)+52|0;l=c[n>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[n>>2]=0;if(c[(c[k>>2]|0)+(q*796|0)+792>>2]|0){n=GLc()|0;In[c[(c[n>>2]|0)+24>>2]&4095](n,c[(c[k>>2]|0)+(q*796|0)+792>>2]|0)}q=q+1|0}while(q>>>0<(c[j>>2]|0)>>>0)}j=a+16|0;q=c[j>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0;j=a+28|0;q=c[j>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0;j=a+40|0;q=c[j>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0;j=a+52|0;q=c[j>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0;j=a+64|0;q=c[j>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0;j=a+1024|0;q=c[j>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0;if((c[a+1064>>2]|0)>-1){j=a+1052|0;q=c[j>>2]|0;c[e>>2]=c[a+1056>>2];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0}if((c[a+1048>>2]|0)>-1){j=a+1036|0;q=c[j>>2]|0;c[e>>2]=c[a+1040>>2];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0}if((c[a+1020>>2]|0)>-1){j=a+1008|0;q=c[j>>2]|0;c[e>>2]=c[a+1012>>2];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0}if((c[a+1004>>2]|0)>-1){j=a+992|0;q=c[j>>2]|0;c[e>>2]=c[a+996>>2];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0}if((c[a+988>>2]|0)>-1){j=a+976|0;q=c[j>>2]|0;c[e>>2]=c[a+980>>2];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[j>>2]=0}j=a+964|0;q=c[j>>2]|0;if(q){n=a+968|0;l=c[n>>2]|0;if((l|0)==(q|0))r=q;else{h=l;while(1){l=h+-16|0;c[n>>2]=l;if((c[h+-4>>2]|0)>-1){p=c[l>>2]|0;c[e>>2]=c[h+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(p,d);c[l>>2]=0;s=c[n>>2]|0}else s=l;if((s|0)==(q|0))break;else h=s}r=c[j>>2]|0}c[g>>2]=89;c[d+0>>2]=c[g+0>>2];eOb(r,d)}r=a+952|0;g=c[r>>2]|0;if(g){j=a+956|0;s=c[j>>2]|0;if((s|0)==(g|0))t=g;else{h=s;while(1){s=h+-16|0;c[j>>2]=s;if((c[h+-4>>2]|0)>-1){q=c[s>>2]|0;c[e>>2]=c[h+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(q,d);c[s>>2]=0;u=c[j>>2]|0}else u=s;if((u|0)==(g|0))break;else h=u}t=c[r>>2]|0}c[f>>2]=89;c[d+0>>2]=c[f+0>>2];eOb(t,d)}if((c[a+236>>2]|0)>-1){t=c[k>>2]|0;c[e>>2]=c[a+228>>2];c[d+0>>2]=c[e+0>>2];eOb(t,d);c[k>>2]=0}if((c[a+220>>2]|0)>-1){k=a+208|0;t=c[k>>2]|0;c[e>>2]=c[a+212>>2];c[d+0>>2]=c[e+0>>2];eOb(t,d);c[k>>2]=0}if((c[a+204>>2]|0)>-1){k=a+192|0;t=c[k>>2]|0;c[e>>2]=c[a+196>>2];c[d+0>>2]=c[e+0>>2];eOb(t,d);c[k>>2]=0}k=a+124|0;if((c[a+180>>2]|0)>-1){t=a+168|0;f=c[t>>2]|0;c[e>>2]=c[a+172>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[t>>2]=0}if((c[a+136>>2]|0)>-1){t=c[k>>2]|0;c[e>>2]=c[a+128>>2];c[d+0>>2]=c[e+0>>2];eOb(t,d);c[k>>2]=0}if((c[a+120>>2]|0)>-1){k=a+108|0;t=c[k>>2]|0;c[e>>2]=c[a+112>>2];c[d+0>>2]=c[e+0>>2];eOb(t,d);c[k>>2]=0}if((c[a+104>>2]|0)<=-1){i=b;return}k=a+92|0;t=c[k>>2]|0;c[e>>2]=c[a+96>>2];c[d+0>>2]=c[e+0>>2];eOb(t,d);c[k>>2]=0;i=b;return}function F1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];c[a>>2]=cOb(b<<2,16,e,0,3653512,62)|0;c[a+4>>2]=0;c[a+8>>2]=b;i=d;return}function G1b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function H1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a+8>>2]|0;c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];c[b>>2]=cOb(g<<2,16,e,0,3653512,62)|0;c[b+4>>2]=0;c[b+8>>2]=g;g=c[a+20>>2]|0;c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];c[b+12>>2]=cOb(g<<2,16,e,0,3653512,62)|0;c[b+16>>2]=0;c[b+20>>2]=g;g=c[a+32>>2]|0;c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];c[b+24>>2]=cOb(g<<2,16,e,0,3653512,62)|0;c[b+28>>2]=0;c[b+32>>2]=g;g=c[a+44>>2]|0;c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];c[b+36>>2]=cOb(g<<2,16,e,0,3653512,62)|0;c[b+40>>2]=0;c[b+44>>2]=g;g=c[a+56>>2]|0;c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];c[b+48>>2]=cOb(g<<2,16,e,0,3653512,62)|0;c[b+52>>2]=0;c[b+56>>2]=g;i=d;return}function I1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+16|0;H1b(d,h);if(!b)j=0;else{d=GLc()|0;k=c[(c[d>>2]|0)+32>>2]|0;l=c[h>>2]|0;c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];j=kn[k&511](d,b,l,f)|0}c[a+80>>2]=j;j=a+144|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;i=e;return}function J1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[a+188>>2]=d;if((d|0)>0){f=0;do{g=a+(f<<4)+28|0;h=b+(f<<4)|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];f=f+1|0}while((f|0)!=(d|0))}rmc(b,d,a+340|0)|0;i=e;return}function K1b(b,d,e,f,h){b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=0;j=i;i=i+32|0;l=j+24|0;m=j+20|0;n=j+8|0;o=j;p=j+16|0;q=b+52|0;a:do if(ea(g[q>>2])==ea(-1.0)){r=b+40|0;s=c[r>>2]|0;do if(s){c[m>>2]=s;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(l,t,m);u=c[l>>2]|0;v=c[t+28>>2]|0;if((u|0)==-1){w=v+(c[t+32>>2]<<3)|0;break}else{w=v+(u<<3)|0;break}}else w=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((w|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[w+4>>2]|0,(t|0)!=0):0)x=t;else y=11}else y=11;if((y|0)==11){t=hQb(c[r>>2]|0)|0;if(!t)break;else x=t}g[q>>2]=ea(ea(g[x+72>>2])*ea(.5));g[b+56>>2]=ea(ea(g[x+76>>2])*ea(.5));break a}while(0);g[q>>2]=ea(0.0);g[b+56>>2]=ea(0.0)}while(0);z=ea(g[d>>2]);x=d+4|0;A=ea(g[x>>2]);B=ea(ea(z*z)+ea(A*A));if(B>ea(g[150276])){C=ea(z);D=ea(T(ea(B)));B=ea(A);y=n;g[y>>2]=C;g[y+4>>2]=B;g[n>>2]=ea(z/D);g[n+4>>2]=ea(A/D);E=n}else{g[o>>2]=ea(1.0);g[o+4>>2]=ea(0.0);E=o}o=E;E=c[o>>2]|0;D=ea(g[o+4>>2]);if(!(a[b+48>>0]|0))F=e;else{o=X8b()|0;F=ea(ea(ea(1.0)-ea(B8b(o,ea(g[d+8>>2]))))*e)}o=b+32|0;n=b+28|0;y=(c[o>>2]|0)-(c[n>>2]|0)|0;w=Mnc(ync()|0)|0;l=y>>3;if(!(gn[c[(c[w>>2]|0)+8>>2]&127](w,24,l,0,2,p,0)|0)){i=j;return}y=c[o>>2]|0;o=c[n>>2]|0;if((o|0)!=(y|0)){n=b+44|0;m=b+56|0;b=d+8|0;r=f+4|0;s=f+8|0;t=f+12|0;e=(c[k>>2]=E,ea(g[k>>2]));A=ea(F*ea(.00999999977));E=o;do{o=c[n>>2]|0;u=c[E>>2]|0;do if((o|0)==1)if(!u){z=ea(ea(1.0)-ea(g[q>>2]));G=ea(0.0);H=ea(ea(.5)-ea(g[m>>2]));I=z;J=ea(0.0);break}else if((u|0)==1){z=ea(ea(.5)-ea(g[q>>2]));G=ea(.5);H=ea(ea(.75)-ea(g[m>>2]));I=z;J=ea(0.0);break}else if((u|0)==2){z=ea(ea(.5)-ea(g[q>>2]));G=ea(.75);H=ea(ea(1.0)-ea(g[m>>2]));I=z;J=ea(0.0);break}else{v=u+-3|0;K=v&1;L=v>>1;z=ea(ea(ea(K|0)*ea(.25))+ea(.5));B=ea(ea(ea(ea(L|0)*ea(.25))*ea(.5))+ea(.5));C=ea(g[q>>2]);M=ea(z+C);z=ea(g[m>>2]);G=ea(B+z);H=ea(ea(ea(ea(ea(L+1|0)*ea(.25))*ea(.5))+ea(.5))-z);I=ea(ea(ea(ea(K+1|0)*ea(.25))+ea(.5))-C);J=M;break}else if(!o)if(!u){M=ea(g[q>>2]);C=ea(M+ea(0.0));z=ea(g[m>>2]);G=ea(z+ea(0.0));H=ea(ea(.5)-z);I=ea(ea(1.0)-M);J=C;break}else{K=u+-1|0;L=K&1;v=K>>1;C=ea(ea(L|0)*ea(.5));M=ea(ea(ea(ea(v|0)*ea(.5))*ea(.5))+ea(.5));z=ea(g[q>>2]);B=ea(C+z);C=ea(g[m>>2]);G=ea(M+C);H=ea(ea(ea(ea(ea(v+1|0)*ea(.5))*ea(.5))+ea(.5))-C);I=ea(ea(ea(L+1|0)*ea(.5))-z);J=B;break}else{L=o+-1|0;v=(u|0)%(L|0)|0;K=(u|0)/(L|0)|0;B=ea(ea(1.0)/ea(L|0));z=ea(ea(v|0)*B);C=ea(ea(K|0)*B);M=ea(g[q>>2]);N=ea(z+M);z=ea(g[m>>2]);G=ea(C+z);H=ea(ea(B*ea(K+1|0))-z);I=ea(ea(ea(v+1|0)*B)-M);J=N}while(0);N=ea(ea(1.0)-G);M=ea(ea(1.0)-H);B=ea(g[E+8>>2]);z=ea(g[b>>2]);C=ea(B*z);B=ea(C*((a[E+30>>0]|0)==0?ea(.00999999977):A));if(!(a[E+29>>0]|0)){O=B;P=B}else{C=ea(B*ea(1.39999998));O=ea(e*C);P=ea(D*C)}C=ea(g[E+4>>2]);B=ea(C*ea(0.0));Q=ea(z*C);R=ea(ea(1.0)-C);C=ea(R*ea(g[d>>2]));S=ea(B+C);C=ea(B+ea(R*ea(g[x>>2])));B=ea(Q+ea(z*R));R=ea(g[E+12>>2]);if(!(a[E+28>>0]|0)){z=ea(F*R);Q=ea(F*ea(g[E+16>>2]));U=ea(F*ea(g[E+20>>2]));V=ea(F*ea(g[E+24>>2]));u=z<ea(0.0);W=u?ea(0.0):z;u=W>ea(1.0);o=~~ea(ea(W*ea(255.0))+ea(.5))>>>0&255;v=Q<ea(0.0);W=v?ea(0.0):Q;v=W>ea(1.0);K=~~ea(ea(W*ea(255.0))+ea(.5))>>>0;L=U<ea(0.0);W=L?ea(0.0):U;L=W>ea(1.0);X=~~ea(ea(W*ea(255.0))+ea(.5))>>>0&255;Y=V<ea(0.0);W=Y?ea(0.0):V;Y=W>ea(1.0);Z=~~ea(ea(W*ea(255.0))+ea(.5))>>>0;_=L?-1:X;$=u?-1:o;aa=Y?255:Z;ba=v?255:K}else{W=ea(g[E+16>>2]);V=ea(g[E+20>>2]);U=ea(g[E+24>>2]);Q=ea(R*ea(g[f>>2]));R=ea(W*ea(g[r>>2]));W=ea(V*ea(g[s>>2]));V=ea(U*ea(g[t>>2]));if(!(a[E+31>>0]|0)){ca=Q;da=R;fa=W;ga=V}else{ca=ea(F*Q);da=ea(F*R);fa=ea(F*W);ga=ea(F*V)}K=ca<ea(0.0);V=K?ea(0.0):ca;K=V>ea(1.0);v=~~ea(ea(V*ea(255.0))+ea(.5))>>>0&255;Z=da<ea(0.0);V=Z?ea(0.0):da;Z=V>ea(1.0);Y=~~ea(ea(V*ea(255.0))+ea(.5))>>>0;o=fa<ea(0.0);V=o?ea(0.0):fa;o=V>ea(1.0);u=~~ea(ea(V*ea(255.0))+ea(.5))>>>0&255;X=ga<ea(0.0);V=X?ea(0.0):ga;X=V>ea(1.0);L=~~ea(ea(V*ea(255.0))+ea(.5))>>>0;_=o?-1:u;$=K?-1:v;aa=X?255:L;ba=Z?255:Y}Y=(a[621175]|0)==0;Z=c[p>>2]|0;V=ea(C-P);g[Z>>2]=ea(S-O);g[Z+4>>2]=V;g[Z+8>>2]=B;L=ba<<8&65280|aa<<24|(Y?$:_)&255|((Y?_:$)&255)<<16;c[Z+12>>2]=L;g[Z+16>>2]=I;g[Z+20>>2]=N;V=ea(C-O);g[Z+24>>2]=ea(P+S);g[Z+28>>2]=V;g[Z+32>>2]=B;c[Z+36>>2]=L;g[Z+40>>2]=J;g[Z+44>>2]=N;N=ea(P+C);g[Z+48>>2]=ea(O+S);g[Z+52>>2]=N;g[Z+56>>2]=B;c[Z+60>>2]=L;g[Z+64>>2]=J;g[Z+68>>2]=M;N=ea(O+C);g[Z+72>>2]=ea(S-P);g[Z+76>>2]=N;g[Z+80>>2]=B;c[Z+84>>2]=L;g[Z+88>>2]=I;g[Z+92>>2]=M;c[p>>2]=Z+96;E=E+32|0}while((E|0)!=(y|0))}co[c[(c[w>>2]|0)+12>>2]&2047](w,l,0);l=c[(c[w>>2]|0)+16>>2]|0;y=c[h+4>>2]|0;E=c[140144]|0;if(!E){p=uic()|0;$=tic(p,c[140142]|0)|0;c[140144]=$;ha=$}else ha=E;E=qic(ha,y,0)|0;co[l&2047](w,h,E);i=j;return}function L1b(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a;if((c[140148]|0)==0?(d=Xmd()|0,rri(b,560600,21),e=Nmd(d,b)|0,xri(b),(e|0)!=0):0)c[140148]=bkd(e,61,0)|0;e=c[140146]|0;if(e){f=e;i=a;return f|0}e=xCi(24)|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e>>2]=e+4;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[140146]=e;f=e;i=a;return f|0}function M1b(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+64|0;f=e+4|0;h=e;j=d+12|0;k=d+16|0;l=c[k>>2]|0;m=c[j>>2]|0;a:do if((m|0)!=(l|0)){n=m;o=0;while(1){p=n+49|0;if(!(a[p>>0]|0)){q=p;r=o;break}n=n+52|0;if((n|0)==(l|0))break a;else o=o+1|0}a[q>>0]=1;o=c[d>>2]|0;n=d+4|0;if((o|0)==(n|0)){s=r;i=e;return s|0}else t=o;while(1){g[(c[t+20>>2]|0)+(r<<2)>>2]=ea(0.0);o=c[t+4>>2]|0;if(!o){p=t;while(1){u=c[p+8>>2]|0;if((c[u>>2]|0)==(p|0)){v=u;break}else p=u}}else{p=o;while(1){u=c[p>>2]|0;if(!u){v=p;break}else p=u}}if((v|0)==(n|0)){s=r;break}else t=v}i=e;return s|0}while(0);v=(l-m|0)/52|0;m=f+16|0;t=f+32|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[t>>2]=-1;c[f+36>>2]=-1;g[f+40>>2]=ea(0.0);g[f+44>>2]=ea(3.0);a[f+48>>0]=0;a[f+49>>0]=1;if((l|0)==(c[d+20>>2]|0))Z1b(j,f);else{if(!l)w=0;else{c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[l+16>>2]=c[f+16>>2];c[l+20>>2]=c[f+20>>2];c[l+24>>2]=c[f+24>>2];c[l+28>>2]=0;f=l+32|0;c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];b[f+16>>1]=b[t+16>>1]|0;w=c[k>>2]|0}c[k>>2]=w+52}w=c[d>>2]|0;k=d+4|0;if((w|0)==(k|0)){s=v;i=e;return s|0}else x=w;while(1){g[h>>2]=ea(0.0);w=x+24|0;d=c[w>>2]|0;if((d|0)==(c[x+28>>2]|0))_1b(x+20|0,h);else{if(d)g[d>>2]=ea(0.0);c[w>>2]=d+4}d=c[x+4>>2]|0;if(!d){w=x;while(1){t=c[w+8>>2]|0;if((c[t>>2]|0)==(w|0)){y=t;break}else w=t}}else{w=d;while(1){t=c[w>>2]|0;if(!t){y=w;break}else w=t}}if((y|0)==(k|0)){s=v;break}else x=y}i=e;return s|0}function N1b(b,d,e,f,h,i,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;i=ea(i);j=j|0;k=ea(k);l=l|0;m=m|0;var n=0,o=0,p=Im,q=Im,r=Im;n=c[b+12>>2]|0;b=n+(d*52|0)+16|0;c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];if(!e)o=0;else o=c[e+4>>2]|0;c[n+(d*52|0)+28>>2]=o;a[n+(d*52|0)+48>>0]=h&1;g[n+(d*52|0)+40>>2]=i;i=ea(g[j>>2]);p=ea(g[j+4>>2]);q=ea(g[j+8>>2]);r=ea(g[j+12>>2]);g[n+(d*52|0)>>2]=i;g[n+(d*52|0)+4>>2]=p;g[n+(d*52|0)+8>>2]=q;g[n+(d*52|0)+12>>2]=r;g[n+(d*52|0)+44>>2]=k;c[n+(d*52|0)+32>>2]=l;c[n+(d*52|0)+36>>2]=m;return}function O1b(b,d){b=b|0;d=d|0;a[(c[b+12>>2]|0)+(d*52|0)+49>>0]=0;return}function P1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+32|0;e=d+16|0;f=d+4|0;h=d;j=a+4|0;k=c[j>>2]|0;do if(k){l=k;while(1){m=c[l+16>>2]|0;if(m>>>0>b>>>0){n=c[l>>2]|0;if(!n){o=l;p=l;q=4;break}else{l=n;continue}}if(m>>>0>=b>>>0){r=l;q=8;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=7;break}else l=n}if((q|0)==4){c[e>>2]=p;u=o;v=p;break}else if((q|0)==7){c[e>>2]=t;u=s;v=t;break}else if((q|0)==8){c[e>>2]=r;u=e;v=r;break}}else{l=a+4|0;c[e>>2]=l;u=l;v=l}while(0);r=c[u>>2]|0;if(!r){t=xCi(32)|0;c[t+16>>2]=b;c[t+20>>2]=0;c[t+24>>2]=0;c[t+28>>2]=0;c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=v;c[u>>2]=t;v=c[c[a>>2]>>2]|0;if(!v)w=t;else{c[a>>2]=v;w=c[u>>2]|0}GN(c[j>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;x=t}else x=r;r=x+20|0;c[f>>2]=0;x=f+4|0;c[x>>2]=0;c[f+8>>2]=0;if((r|0)!=(f|0)?($1b(r,0,0),r=c[f>>2]|0,(r|0)!=0):0){f=c[x>>2]|0;if((f|0)!=(r|0))c[x>>2]=f+(~((f+-4-r|0)>>>2)<<2);ACi(r)}r=c[j>>2]|0;do if(r){f=r;while(1){x=c[f+16>>2]|0;if(x>>>0>b>>>0){t=c[f>>2]|0;if(!t){y=f;z=f;q=22;break}else{f=t;continue}}if(x>>>0>=b>>>0){A=f;q=26;break}x=f+4|0;t=c[x>>2]|0;if(!t){B=x;C=f;q=25;break}else f=t}if((q|0)==22){c[e>>2]=z;D=y;E=z;break}else if((q|0)==25){c[e>>2]=C;D=B;E=C;break}else if((q|0)==26){c[e>>2]=A;D=e;E=A;break}}else{f=a+4|0;c[e>>2]=f;D=f;E=f}while(0);e=c[D>>2]|0;if(!e){A=xCi(32)|0;c[A+16>>2]=b;c[A+20>>2]=0;c[A+24>>2]=0;c[A+28>>2]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=E;c[D>>2]=A;E=c[c[a>>2]>>2]|0;if(!E)F=A;else{c[a>>2]=E;F=c[D>>2]|0}GN(c[j>>2]|0,F);F=a+8|0;c[F>>2]=(c[F>>2]|0)+1;G=A}else G=e;e=G+20|0;A=((c[a+16>>2]|0)-(c[a+12>>2]|0)|0)/52|0;g[h>>2]=ea(0.0);a=G+24|0;G=c[a>>2]|0;F=c[e>>2]|0;j=G-F>>2;if(A>>>0>j>>>0){a2b(e,A-j|0,h);i=d;return}if(A>>>0>=j>>>0){i=d;return}j=F+(A<<2)|0;if((G|0)==(j|0)){i=d;return}c[a>>2]=G+(~((G+-4-j|0)>>>2)<<2);i=d;return}function Q1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=c[a+4>>2]|0;f=a+4|0;if(e){g=f;h=e;a:while(1){j=h;while(1){if((c[j+16>>2]|0)>>>0>=b>>>0){k=j;break}j=c[j+4>>2]|0;if(!j){l=g;break a}}h=c[k>>2]|0;if(!h){l=k;break}else g=k}if((l|0)!=(f|0)?(c[l+16>>2]|0)>>>0<=b>>>0:0)m=l;else n=8}else n=8;if((n|0)==8)m=f;f=c[m+4>>2]|0;if(!f){n=m;while(1){l=c[n+8>>2]|0;if((c[l>>2]|0)==(n|0)){o=l;break}else n=l}}else{n=f;while(1){f=c[n>>2]|0;if(!f){o=n;break}else n=f}}if((c[a>>2]|0)==(m|0))c[a>>2]=o;o=a+8|0;c[o>>2]=(c[o>>2]|0)+-1;tYb(e,m);e=c[m+20>>2]|0;if(!e){ACi(m);i=d;return}o=m+24|0;a=c[o>>2]|0;if((a|0)!=(e|0))c[o>>2]=a+(~((a+-4-e|0)>>>2)<<2);ACi(e);ACi(m);i=d;return}function R1b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im;d=i;i=i+176|0;e=d+16|0;f=d+48|0;h=d+144|0;j=d;k=d+132|0;l=d+148|0;m=d+160|0;n=d+64|0;o=d+52|0;p=d+24|0;q=d+36|0;r=d+88|0;s=n8b()|0;c[h>>2]=c[s>>2];t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(e,t,h);u=c[e>>2]|0;v=c[t+28>>2]|0;if((u|0)==-1){w=v+(c[t+32>>2]<<3)|0;break}else{w=v+(u<<3)|0;break}}else w=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((w|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[w+4>>2]|0,(t|0)!=0):0)x=t;else y=9}else y=9;if((y|0)==9)x=hQb(c[s>>2]|0)|0;s=c[b+4>>2]|0;t=b+4|0;if(!s){i=d;return}else{z=t;A=s}a:while(1){s=A;while(1){if((c[s+16>>2]|0)>>>0>=x>>>0){B=s;break}s=c[s+4>>2]|0;if(!s){C=z;break a}}A=c[B>>2]|0;if(!A){C=B;break}else z=B}if((C|0)==(t|0)){i=d;return}if(x>>>0<(c[C+16>>2]|0)>>>0){i=d;return}t=c[C+20>>2]|0;D=ea(g[x+460>>2]);B=c[b+12>>2]|0;z=b+16|0;if((B|0)==(c[z>>2]|0)){i=d;return}b=j+4|0;A=j+8|0;s=p+4|0;w=p+8|0;h=q+4|0;u=q+8|0;v=n+12|0;E=n+16|0;F=n+20|0;G=r+32|0;H=r+36|0;I=m+4|0;J=m+8|0;K=l+4|0;L=l+8|0;M=k+4|0;N=B;B=(c[C+24>>2]|0)==(t|0)?0:t;while(1){do if(a[N+49>>0]|0){t=~c[N+36>>2];O=ea(g[N+44>>2]);if(oVb()|0)P=ea(g[(jLc()|0)+104>>2]);else P=ea(1.0);Q=ea(O*P);O=ea(Q*ea(.5));C=N+48|0;if(!(a[C>>0]|0)){r0b(j,x,N+16|0);R=ea(g[j>>2]);S=ea(g[b>>2]);if((ea(g[A>>2])<D?R>ea(0.0)&R<ea(1.0):0)?S>ea(0.0)&S<ea(1.0):0)y=37;else U=ea(0.0)}else{V=n8b()|0;c[f>>2]=c[V>>2];W=c[137784]|0;if(W){do if((c[W+36>>2]|0)!=(c[W+4>>2]|0)){fRb(e,W,f);X=c[e>>2]|0;Y=c[W+28>>2]|0;if((X|0)==-1){Z=Y+(c[W+32>>2]<<3)|0;break}else{Z=Y+(X<<3)|0;break}}else Z=(c[W+28>>2]|0)+(c[W+32>>2]<<3)|0;while(0);W=c[137784]|0;if((Z|0)!=((c[W+28>>2]|0)+(c[W+32>>2]<<3)|0)?(W=c[Z+4>>2]|0,(W|0)!=0):0)_=W;else y=34}else y=34;if((y|0)==34){y=0;_=hQb(c[V>>2]|0)|0}O$b(m,_);S=ea(g[m>>2]);R=ea(S+ea(g[N+16>>2]));S=ea(g[I>>2]);$=ea(S+ea(g[N+20>>2]));S=ea(g[J>>2]);aa=ea(S+ea(g[N+24>>2]));g[l>>2]=R;g[K>>2]=$;g[L>>2]=aa;r0b(k,x,l);aa=ea(g[k>>2]);$=ea(g[M>>2]);if(aa>ea(0.0)&aa<ea(1.0)?$>ea(0.0)&$<ea(1.0):0)y=37;else U=ea(0.0)}if((y|0)==37){y=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;O$b(o,x);c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];if(!(a[C>>0]|0)){O$b(p,x);$=ea(g[p>>2]);W=N+16|0;aa=ea($-ea(g[W>>2]));$=ea(g[s>>2]);X=N+20|0;R=ea($-ea(g[X>>2]));$=ea(g[w>>2]);Y=N+24|0;S=ea($-ea(g[Y>>2]));$=ea(T(ea(ea(ea(aa*aa)+ea(R*R))+ea(S*S))));O$b(q,x);S=ea(g[W>>2]);R=ea(S-ea(g[q>>2]));S=ea(g[X>>2]);aa=ea(S-ea(g[h>>2]));S=ea(g[Y>>2]);ba=ea(ea(S-ea(g[u>>2]))/$);ca=ea(aa/$);da=ea(R/$);fa=$}else{$=ea(-ea(g[N+16>>2]));R=ea(-ea(g[N+20>>2]));ba=ea(-ea(g[N+24>>2]));ca=R;da=$;fa=ea(1.0e4)}g[v>>2]=da;g[E>>2]=ca;g[F>>2]=ba;Y=zLc()|0;g[G>>2]=ea(0.0);g[H>>2]=ea(0.0);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;if(!Y)U=ea(1.0);else{X=ln[c[(c[Y>>2]|0)+12>>2]&1](Y,n,fa,t,r)|0;U=X?ea(0.0):ea(1.0)}}$=ea(g[B>>2]);if(U>$){R=ea(Q+$);g[B>>2]=R;if(!(R>ea(1.0)))break;g[B>>2]=ea(1.0);break}if(U<$?(R=ea($-O),g[B>>2]=R,R<ea(0.0)):0)g[B>>2]=ea(0.0)}while(0);N=N+52|0;if((N|0)==(c[z>>2]|0))break;else B=B+4|0}i=d;return}function S1b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,T=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0;d=i;i=i+176|0;e=d+160|0;f=d+80|0;h=d+4|0;j=d+8|0;k=d+168|0;l=d;m=d+16|0;n=d+96|0;o=d+84|0;p=c[140148]|0;if(!p){i=d;return}q=hkd(p)|0;if(!q){i=d;return}p=Hld(q)|0;r=n8b()|0;s=c[r>>2]|0;if(!s){i=d;return}c[l>>2]=s;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,l);t=c[e>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if(!((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(c[v+4>>2]|0)!=0:0))w=12}else w=12;if((w|0)==12?(hQb(c[r>>2]|0)|0)==0:0){i=d;return}r=n8b()|0;c[k>>2]=c[r>>2];v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(e,v,k);s=c[e>>2]|0;l=c[v+28>>2]|0;if((s|0)==-1){x=l+(c[v+32>>2]<<3)|0;break}else{x=l+(s<<3)|0;break}}else x=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((x|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[x+4>>2]|0,(v|0)!=0):0)y=v;else w=21}else w=21;if((w|0)==21)y=hQb(c[r>>2]|0)|0;z=ea(ea(g[y+456>>2])*ea(2.0));R1b(b);r=ync()|0;v=m+0|0;x=(mo[c[(c[r>>2]|0)+120>>2]&4095](r)|0)+0|0;k=v+64|0;do{c[v>>2]=c[x>>2];v=v+4|0;x=x+4|0}while((v|0)<(k|0));v=n+0|0;x=(mo[c[(c[r>>2]|0)+116>>2]&4095](r)|0)+0|0;k=v+64|0;do{c[v>>2]=c[x>>2];v=v+4|0;x=x+4|0}while((v|0)<(k|0));In[c[(c[r>>2]|0)+104>>2]&4095](r,601008);x=c[b+4>>2]|0;v=b+4|0;if(x){k=v;s=x;a:while(1){x=s;while(1){if((c[x+16>>2]|0)>>>0>=y>>>0){A=x;break}x=c[x+4>>2]|0;if(!x){B=k;break a}}s=c[A>>2]|0;if(!s){B=A;break}else k=A}if((B|0)!=(v|0)?y>>>0>=(c[B+16>>2]|0)>>>0:0)C=B;else w=29}else w=29;if((w|0)==29)C=v;v=c[C+20>>2]|0;B=(c[C+24>>2]|0)==(v|0)?0:v;v=n8b()|0;c[j>>2]=c[v>>2];C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(e,C,j);y=c[e>>2]|0;A=c[C+28>>2]|0;if((y|0)==-1){D=A+(c[C+32>>2]<<3)|0;break}else{D=A+(y<<3)|0;break}}else D=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((D|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[D+4>>2]|0,(C|0)!=0):0)E=C;else w=38}else w=38;if((w|0)==38)E=hQb(c[v>>2]|0)|0;v=D$b(E)|0;F=ea(g[v>>2]);G=ea(g[v+4>>2]);H=ea(g[v+8>>2]);I=ea(g[v+16>>2]);J=ea(g[v+20>>2]);K=ea(g[v+24>>2]);L=ea(g[v+32>>2]);M=ea(g[v+36>>2]);N=ea(g[v+40>>2]);O=ea(g[v+48>>2]);P=ea(g[v+52>>2]);Q=ea(g[v+56>>2]);v=c[158074]|0;E=c[b+12>>2]|0;C=b+16|0;if((E|0)!=(c[C>>2]|0)){b=o+4|0;D=o+8|0;j=v+20|0;y=E;E=B;B=0;A=0;while(1){do if(((a[y+49>>0]|0)!=0?!(ea(g[E>>2])<=ea(0.0)):0)?(k=y+28|0,s=c[k>>2]|0,(s|0)!=0):0){c[f>>2]=s;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,f);x=c[e>>2]|0;l=c[s+28>>2]|0;if((x|0)==-1){R=l+(c[s+32>>2]<<3)|0;break}else{R=l+(x<<3)|0;break}}else R=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((R|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[R+4>>2]|0,(s|0)!=0):0)S=s;else w=52}else w=52;if((w|0)==52){w=0;s=hQb(c[k>>2]|0)|0;if(!s){T=B;U=A;break}else S=s}g[o>>2]=ea(0.0);g[b>>2]=ea(0.0);g[D>>2]=ea(0.0);V=ea(g[y+16>>2]);W=ea(g[y+20>>2]);X=ea(g[y+24>>2]);if(!(a[y+48>>0]|0)){Y=ea(Q+ea(ea(ea(H*V)+ea(K*W))+ea(N*X)));Z=ea(P+ea(ea(ea(G*V)+ea(J*W))+ea(M*X)));_=ea(O+ea(ea(ea(F*V)+ea(I*W))+ea(L*X)))}else{$=ea(-ea(z*V));V=ea(-ea(z*W));W=ea(-ea(z*X));Y=ea(ea(ea(H*$)+ea(K*V))+ea(N*W));Z=ea(ea(ea(G*$)+ea(J*V))+ea(M*W));_=ea(ea(ea(F*$)+ea(I*V))+ea(L*W))}g[o>>2]=_;g[b>>2]=Z;g[D>>2]=Y;s=S+40|0;x=c[s>>2]|0;if(x){c[h>>2]=x;x=c[137784]|0;do if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(e,x,h);l=c[e>>2]|0;t=c[x+28>>2]|0;if((l|0)==-1){aa=t+(c[x+32>>2]<<3)|0;break}else{aa=t+(l<<3)|0;break}}else aa=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);l=c[137784]|0;if((aa|0)==((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)){w=65;break}l=c[aa+4>>2]|0;if(l)ba=l;else w=65}else w=65;while(0);if((w|0)==65){w=0;x=hQb(c[s>>2]|0)|0;if(!x){T=B;U=A;break}else ba=x}if((A|0)==(ba|0)){ca=B;da=A}else{qud(j,560544,ba)|0;ca=ekd(c[140148]|0,0,q,v,p)|0;da=ba}W=ea(g[E>>2]);K1b(S,o,ea(W*ea(g[y+40>>2])),y,ca);T=ca;U=da}else{T=B;U=A}}else{T=B;U=A}while(0);y=y+52|0;if((y|0)==(c[C>>2]|0))break;else{E=E+4|0;B=T;A=U}}}In[c[(c[r>>2]|0)+104>>2]&4095](r,m);In[c[(c[r>>2]|0)+100>>2]&4095](r,n);i=d;return}function T1b(){var a=0;a=i;QQb(124,96,0,0,0);i=a;return}function U1b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,560624,10);wQb(124,8,b,32,2605,0,0);xri(b);i=a;return}function V1b(a){a=a|0;return 124}function W1b(a){a=a|0;var b=0,d=0;b=i;d=ATb(c[a+24>>2]|0,20)|0;P1b(L1b()|0,d);i=b;return}function X1b(a){a=a|0;var b=0,d=0;b=i;d=ATb(c[a+24>>2]|0,20)|0;Q1b(L1b()|0,d);i=b;return}function Y1b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,560552);c[140136]=c[b>>2];c[140142]=13;c[140144]=0;i=a;return}function Z1b(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=a+4|0;g=c[a>>2]|0;h=(((c[f>>2]|0)-g|0)/52|0)+1|0;if(h>>>0>82595524)vxi(a);j=a+8|0;k=g;l=((c[j>>2]|0)-k|0)/52|0;if(l>>>0<41297762){m=l<<1;l=m>>>0<h>>>0?h:m;m=c[f>>2]|0;h=(m-k|0)/52|0;if(!l){n=0;o=0;p=h;q=m}else{r=l;s=h;t=m;u=6}}else{m=c[f>>2]|0;r=82595524;s=(m-k|0)/52|0;t=m;u=6}if((u|0)==6){n=r;o=xCi(r*52|0)|0;p=s;q=t}t=o+(p*52|0)|0;s=o+(n*52|0)|0;if(t){c[t+0>>2]=c[d+0>>2];c[t+4>>2]=c[d+4>>2];c[t+8>>2]=c[d+8>>2];c[t+12>>2]=c[d+12>>2];c[t+16>>2]=c[d+16>>2];c[t+20>>2]=c[d+20>>2];c[t+24>>2]=c[d+24>>2];c[o+(p*52|0)+28>>2]=c[d+28>>2];n=o+(p*52|0)+32|0;r=d+32|0;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];b[n+16>>1]=b[r+16>>1]|0}r=o+((p+1|0)*52|0)|0;if((q|0)==(g|0)){v=t;w=g}else{n=p+-1-(((q+-52-k|0)>>>0)/52|0)|0;k=q;q=t;do{t=q;q=q+-52|0;p=k;k=k+-52|0;c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];c[q+16>>2]=c[k+16>>2];c[q+20>>2]=c[k+20>>2];c[q+24>>2]=c[k+24>>2];c[t+-24>>2]=c[p+-24>>2];d=t+-20|0;t=p+-20|0;c[d+0>>2]=c[t+0>>2];c[d+4>>2]=c[t+4>>2];c[d+8>>2]=c[t+8>>2];c[d+12>>2]=c[t+12>>2];b[d+16>>1]=b[t+16>>1]|0}while((k|0)!=(g|0));v=o+(n*52|0)|0;w=c[a>>2]|0}c[a>>2]=v;c[f>>2]=r;c[j>>2]=s;if(!w){i=e;return}ACi(w);i=e;return}function _1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[a>>2]|0;h=((c[e>>2]|0)-f>>2)+1|0;if(h>>>0>1073741823)vxi(a);j=a+8|0;k=f;l=(c[j>>2]|0)-k|0;if(l>>2>>>0<536870911){m=l>>1;l=m>>>0<h>>>0?h:m;m=(c[e>>2]|0)-k|0;h=m>>2;if(!l){n=0;o=0;p=h;q=m}else{r=l;s=h;t=m;u=6}}else{m=(c[e>>2]|0)-k|0;r=1073741823;s=m>>2;t=m;u=6}if((u|0)==6){n=r;o=xCi(r<<2)|0;p=s;q=t}t=o+(p<<2)|0;if(t)g[t>>2]=ea(g[b>>2]);YEi(o|0,f|0,q|0)|0;c[a>>2]=o;c[e>>2]=o+(p+1<<2);c[j>>2]=o+(n<<2);if(!f){i=d;return}ACi(f);i=d;return}function $1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b;h=d-f>>2;j=a+8|0;k=c[j>>2]|0;l=c[a>>2]|0;m=l;if(h>>>0<=k-m>>2>>>0){n=a+4|0;o=(c[n>>2]|0)-m|0;p=o>>2;if(h>>>0<=p>>>0){q=d-f|0;aFi(l|0,b|0,q|0)|0;r=l+(q>>2<<2)|0;q=c[n>>2]|0;if((q|0)==(r|0)){i=e;return}c[n>>2]=q+(~((q+-4-r|0)>>>2)<<2);i=e;return}r=b+(p<<2)|0;aFi(l|0,b|0,o|0)|0;if((r|0)==(d|0)){i=e;return}o=c[n>>2]|0;p=(d+-4-r|0)>>>2;q=r;r=o;while(1){if(r)g[r>>2]=ea(g[q>>2]);q=q+4|0;if((q|0)==(d|0))break;else r=r+4|0}c[n>>2]=o+(p+1<<2);i=e;return}if(!l)s=k;else{k=a+4|0;p=c[k>>2]|0;if((p|0)!=(l|0))c[k>>2]=p+(~((p+-4-m|0)>>>2)<<2);ACi(l);c[j>>2]=0;c[k>>2]=0;c[a>>2]=0;s=0}if(h>>>0>1073741823)vxi(a);k=s-0|0;if(k>>2>>>0<536870911){s=k>>1;k=s>>>0<h>>>0?h:s;if(k>>>0>1073741823)vxi(a);else t=k}else t=1073741823;k=xCi(t<<2)|0;s=a+4|0;c[s>>2]=k;c[a>>2]=k;c[j>>2]=k+(t<<2);if((b|0)==(d|0)){i=e;return}t=(d+-4-f|0)>>>2;f=b;b=k;while(1){g[b>>2]=ea(g[f>>2]);f=f+4|0;if((f|0)==(d|0))break;else b=b+4|0}c[s>>2]=k+(t+1<<2);i=e;return}function a2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8|0;h=c[f>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)g[n>>2]=ea(g[d>>2]);m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=e;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if(n>>>0>1073741823)vxi(a);l=k;m=h-l|0;if(m>>2>>>0<536870911){h=m>>1;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l|0;n=h>>2;if(!m){o=0;p=0;q=n;r=h}else{s=m;t=n;u=h;v=11}}else{h=(c[j>>2]|0)-l|0;s=1073741823;t=h>>2;u=h;v=11}if((v|0)==11){o=s;p=xCi(s<<2)|0;q=t;r=u}u=b;t=p+(q<<2)|0;while(1){if(t)g[t>>2]=ea(g[d>>2]);u=u+-1|0;if(!u)break;else t=t+4|0}YEi(p|0,k|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=p;c[j>>2]=p+(q+b<<2);c[f>>2]=p+(o<<2);if(!r){i=e;return}ACi(r);i=e;return}function b2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(32,f,1,16,3653512,160)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];bUb(h,f,d);a[h+28>>0]=1;a[h+29>>0]=0;c[h>>2]=560648;i=e;return h|0}function c2b(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);i=b;return}function d2b(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);ACi(a);i=b;return}function e2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function f2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function g2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function h2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function i2b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+32|0;g=f;h=f+28|0;j=f+24|0;k=f+20|0;l=f+8|0;m=c[b>>2]|0;if(!m){i=f;return}c[k>>2]=m;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(g,m,k);n=c[g>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[p+4>>2]|0,(m|0)!=0):0)q=m;else r=10}else r=10;if((r|0)==10){m=hQb(c[b>>2]|0)|0;if(!m){i=f;return}else q=m}m=c[q+52>>2]|0;p=c[m>>2]|0;if((p|0)!=(c[m+4>>2]|0)?(c[(c[p+(c[m+32>>2]<<2)>>2]|0)+16>>2]|0)>=(e|0):0){m=c[d>>2]|0;if(!m){c[d>>2]=bkd(q,61,0)|0;i=f;return}if((hkd(m)|0)==(q|0)){i=f;return}akd(c[d>>2]|0,q);i=f;return}c[g>>2]=e;Lsd(l,560784,g);e=c[b>>2]|0;do if(!e)s=0;else{c[h>>2]=e;q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(g,q,h);d=c[g>>2]|0;m=c[q+28>>2]|0;if((d|0)==-1){t=m+(c[q+32>>2]<<3)|0;break}else{t=m+(d<<3)|0;break}}else t=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if(!((t|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(c[t+4>>2]|0)!=0:0))r=22}else r=22;if((r|0)==22?(hQb(c[b>>2]|0)|0)==0:0){s=0;break}c[j>>2]=c[b>>2];q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(g,q,j);d=c[g>>2]|0;m=c[q+28>>2]|0;if((d|0)==-1){u=m+(c[q+32>>2]<<3)|0;break}else{u=m+(d<<3)|0;break}}else u=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((u|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[u+4>>2]|0,(q|0)!=0):0)v=q;else r=31}else r=31;if((r|0)==31)v=hQb(c[b>>2]|0)|0;s=c[v+4>>2]|0}while(0);if(!(a[l>>0]&1))w=l+1|0;else w=c[l+8>>2]|0;Krd(w,0,3653512,50,1,s,0,0);xri(l);i=f;return}function j2b(){var a=0;a=i;p8b();i=a;return}function k2b(){var a=0;a=i;q8b();i=a;return}function l2b(a,b){a=a|0;b=b|0;return}function m2b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+52|0;g=c[f>>2]|0;h=(c[a+56>>2]|0)-g>>2;if(!h){i=b;return}a=g;g=0;while(1){j=a+(g<<2)|0;k=c[j>>2]|0;do if(k){c[e>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(d,l,e);m=c[d>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[o+4>>2]|0,(l|0)!=0):0)p=l;else q=12}else q=12;if((q|0)==12){q=0;l=hQb(c[j>>2]|0)|0;if(!l)break;else p=l}Ajd(p)}while(0);j=g+1|0;if((j|0)==(h|0))break;a=c[f>>2]|0;g=j}i=b;return}function n2b(a){a=a|0;c[a+28>>2]=1;c[a+36>>2]=1;return}function o2b(){var a=0;a=i;QQb(30,97,98,0,99);i=a;return}function p2b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,560968,16);wQb(30,6,b,64,2606,0,0);xri(b);i=a;return}function q2b(a){a=a|0;return 30}function r2b(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,560968,a,0);A2b(a,b);bdd(b);i=c;return}function s2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,560968,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else B2b(a,b);sdd(b);i=d;return}function t2b(a,b){a=a|0;b=b|0;var c=0;c=i;C2b(a,b);i=c;return}function u2b(a,b){a=a|0;b=b|0;var c=0;c=i;D2b(a,b);i=c;return}function v2b(a,b){a=a|0;b=b|0;var c=0;c=i;E2b(a,b);i=c;return}function w2b(a,b){a=a|0;b=b|0;var c=0;c=i;F2b(a,b);i=c;return}function x2b(){var a=0,b=0;a=i;b=rVb(6)|0;i=a;return b|0}function y2b(){var a=0,b=0;a=i;b=tVb(6)|0;i=a;return b|0}function z2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(64,e,1,16,3653512,50)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];jSb(g,e,b);c[g>>2]=560864;c[g+24>>2]=0;c[g+28>>2]=1;c[g+32>>2]=0;c[g+36>>2]=1;b=g+40|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return g|0}function A2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;KSb(a,b);ddd(b,2);h=a+24|0;add(b,560992,561120,h,0);j=c[142270]|0;add(b,561080,j,a+28|0,0);k=b+12|0;l=b+20|0;c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,621432,623064,h,0);m=e+8|0;n=m;c[n>>2]=0;c[n+4>>2]=0;c[e>>2]=0;add(b,792256,j,h,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);h=c[142290]|0;add(b,792272,h,m,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);bdd(b);m=a+32|0;add(b,561008,561120,m,0);add(b,561080,j,a+36|0,0);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,621432,623064,m,0);n=e+8|0;o=n;c[o>>2]=0;c[o+4>>2]=0;c[e>>2]=0;add(b,792256,j,m,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,h,n,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);bdd(b);n=c[142306]|0;add(b,561032,n,a+40|0,0);c[g>>2]=0;$cd(b,2646336,2646336,f,0);add(b,3142592,623064,g,0);m=e+8|0;o=m;c[o>>2]=0;c[o+4>>2]=0;c[e>>2]=0;add(b,792256,j,g,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,h,m,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);add(b,561056,n,a+52|0,0);c[g>>2]=0;$cd(b,2646336,2646336,f,0);add(b,3142592,561088,g,0);f=e+8|0;a=f;c[a>>2]=0;c[a+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,g,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,f,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);i=d;return}function B2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;LSb(a,b);rdd(b,2);f=a+24|0;g=qdd(b,560992,561120,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else I2b(f,b);sdd(b)}f=a+32|0;g=qdd(b,561008,561120,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else I2b(f,b);sdd(b)}f=a+40|0;g=c[142306]|0;h=qdd(b,561032,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else J2b(b,f,0);sdd(b)}f=a+52|0;a=qdd(b,561056,g,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else K2b(b,f,0);sdd(b);i=d;return}function C2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;MSb(a,b);e=a+28|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;if(h>>>0>(c[j>>2]|0)>>>0)Bid(f,e,4);else{c[e>>2]=c[g>>2];c[f>>2]=h}L2b(a+24|0,b);h=a+36|0;g=c[f>>2]|0;e=g+4|0;if(e>>>0>(c[j>>2]|0)>>>0)Bid(f,h,4);else{c[h>>2]=c[g>>2];c[f>>2]=e}L2b(a+32|0,b);M2b(b,a+40|0,0);N2b(b,a+52|0,0);i=d;return}function D2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;NSb(a,b);e=a+28|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;if(h>>>0>(c[j>>2]|0)>>>0){Bid(f,e,4);k=c[e>>2]|0}else{l=c[g>>2]|0;c[e>>2]=l;c[f>>2]=h;k=l}c[e>>2]=XEi(k|0)|0;O2b(a+24|0,b);k=a+36|0;e=c[f>>2]|0;l=e+4|0;if(l>>>0>(c[j>>2]|0)>>>0){Bid(f,k,4);m=c[k>>2]|0}else{j=c[e>>2]|0;c[k>>2]=j;c[f>>2]=l;m=j}c[k>>2]=XEi(m|0)|0;O2b(a+32|0,b);P2b(b,a+40|0,0);Q2b(b,a+52|0,0);i=d;return}function E2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;OSb(a,b);f=a+28|0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;if(j>>>0<(c[k>>2]|0)>>>0){c[h>>2]=c[f>>2];c[g>>2]=j}else Gid(g,f,4);R2b(a+24|0,b);f=a+36|0;j=c[g>>2]|0;h=j+4|0;if(h>>>0<(c[k>>2]|0)>>>0){c[j>>2]=c[f>>2];c[g>>2]=h}else Gid(g,f,4);R2b(a+32|0,b);f=a+44|0;h=c[f>>2]|0;j=a+40|0;l=c[j>>2]|0;m=h-l>>2;c[e>>2]=m;n=c[g>>2]|0;o=n+4|0;if(o>>>0<(c[k>>2]|0)>>>0){c[n>>2]=m;c[g>>2]=o;p=l;q=h}else{Gid(g,e,4);p=c[j>>2]|0;q=c[f>>2]|0}if((p|0)!=(q|0)){f=p;do{R2b(f,b);f=f+4|0}while((f|0)!=(q|0))}q=a+56|0;f=c[q>>2]|0;p=a+52|0;a=c[p>>2]|0;j=f-a>>2;c[e>>2]=j;h=c[g>>2]|0;l=h+4|0;if(l>>>0<(c[k>>2]|0)>>>0){c[h>>2]=j;c[g>>2]=l;r=a;s=f}else{Gid(g,e,4);r=c[p>>2]|0;s=c[q>>2]|0}if((r|0)==(s|0)){i=d;return}else t=r;do{S2b(t,b);t=t+4|0}while((t|0)!=(s|0));i=d;return}function F2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;PSb(b,d);f=b+24|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=b+32|0;f=c[g>>2]|0;d=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=d;d=c[b+40>>2]|0;k=c[b+44>>2]|0;if((d|0)!=(k|0)){f=d;do{d=c[g>>2]|0;l=xo[c[c[d>>2]>>2]&2047](d,c[f>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[f>>2]=l;f=f+4|0}while((f|0)!=(k|0))}k=c[b+52>>2]|0;f=c[b+56>>2]|0;if((k|0)==(f|0)){i=e;return}else m=k;do{k=c[g>>2]|0;b=xo[c[c[k>>2]>>2]&2047](k,c[m>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[m>>2]=b;m=m+4|0}while((m|0)!=(f|0));i=e;return}function G2b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=560864;g=c[a+52>>2]|0;if(g){h=a+56|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~((j+-4-g|0)>>>2)<<2);c[f>>2]=44;c[d+0>>2]=c[f+0>>2];eOb(g,d)}g=c[a+40>>2]|0;if(!g){ZSb(a);i=b;return}f=a+44|0;j=c[f>>2]|0;if((j|0)!=(g|0))c[f>>2]=j+(~((j+-4-g|0)>>>2)<<2);c[e>>2]=44;c[d+0>>2]=c[e+0>>2];eOb(g,d);ZSb(a);i=b;return}function H2b(a){a=a|0;var b=0;b=i;G2b(a);ACi(a);i=b;return}function I2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=a+4|0;g=qdd(b,561080,c[142270]|0,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}sdd(b)}f=qdd(b,621432,623064,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else T2b(a,b);sdd(b);i=d;return}function J2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}U2b(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,623064,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;T2b(r,a);t=r+4|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,623064,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else T2b(m,a);sdd(a)}m=m+4|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function K2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}V2b(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,561088,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;W2b(r,a);t=r+4|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,561088,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else W2b(m,a);sdd(a)}m=m+4|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function L2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function M2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}U2b(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{L2b(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function N2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}V2b(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{X2b(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function O2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function P2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;U2b(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{O2b(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function Q2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;V2b(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{Y2b(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function R2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function S2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function T2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function U2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=(c[p>>2]|0)-r>>2;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b<<2);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];a3b(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;l=a+8|0;t=c[m>>2]|0;c[m>>2]=c[l>>2];c[l>>2]=t;if(!n){i=d;return}if((q|0)!=(n|0))c[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);c[g>>2]=44;c[e+0>>2]=c[g+0>>2];eOb(n,e);i=d;return}n=a+8|0;if(((c[n>>2]|0)-r>>2|0)==(b|0)){$2b(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;Z2b(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];_2b(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=k-j>>2;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(q=j+(b<<2)|0,(k|0)!=(q|0)):0){o=k+(~((k+-4-q|0)>>>2)<<2)|0;c[s>>2]=o;u=j;v=o}else{u=j;v=k}else{$2b(h,b-g|0);u=c[h>>2]|0;v=c[s>>2]|0}g=c[a>>2]|0;c[h>>2]=g;c[a>>2]=u;u=c[p>>2]|0;c[s>>2]=u;c[p>>2]=v;v=c[r>>2]|0;c[r>>2]=c[n>>2];c[n>>2]=v;if(!g){i=d;return}if((u|0)!=(g|0))c[s>>2]=u+(~((u+-4-g|0)>>>2)<<2);c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function V2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=(c[p>>2]|0)-r>>2;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b<<2);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];e3b(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;l=a+8|0;t=c[m>>2]|0;c[m>>2]=c[l>>2];c[l>>2]=t;if(!n){i=d;return}if((q|0)!=(n|0))c[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);c[g>>2]=44;c[e+0>>2]=c[g+0>>2];eOb(n,e);i=d;return}n=a+8|0;if(((c[n>>2]|0)-r>>2|0)==(b|0)){d3b(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;b3b(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];c3b(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=k-j>>2;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(q=j+(b<<2)|0,(k|0)!=(q|0)):0){o=k+(~((k+-4-q|0)>>>2)<<2)|0;c[s>>2]=o;u=j;v=o}else{u=j;v=k}else{d3b(h,b-g|0);u=c[h>>2]|0;v=c[s>>2]|0}g=c[a>>2]|0;c[h>>2]=g;c[a>>2]=u;u=c[p>>2]|0;c[s>>2]=u;c[p>>2]=v;v=c[r>>2]|0;c[r>>2]=c[n>>2];c[n>>2]=v;if(!g){i=d;return}if((u|0)!=(g|0))c[s>>2]=u+(~((u+-4-g|0)>>>2)<<2);c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function W2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function X2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function Y2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function Z2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((c[g>>2]|0)-j>>2>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;m=l-j>>2;if(!b){n=h;o=0;p=l}else{c[f>>2]=44;c[e+0>>2]=c[f+0>>2];l=cOb(b<<2,16,e,0,3653512,80)|0;n=c[a>>2]|0;o=l;p=c[k>>2]|0}l=o+(m<<2)|0;h=o+(b<<2)|0;if((p|0)==(n|0)){q=l;r=p}else{b=p+-4-n|0;j=p;p=l;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(n|0))break;else p=p+-4|0}q=o+(m+~(b>>>2)<<2)|0;r=n}c[a>>2]=q;c[k>>2]=l;c[g>>2]=h;if(!r){i=d;return}c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function _2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>m-o>>2>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~((q+-4-o|0)>>>2)<<2);c[g>>2]=44;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if((j|0)<0)vxi(a);j=p-0|0;if(j>>2>>>0<1073741823){p=j>>1;j=p>>>0<k>>>0?k:p;if((j|0)<0)vxi(a);else r=j}else r=2147483647;c[g>>2]=44;c[f+0>>2]=c[g+0>>2];g=cOb(r<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(r<<2);if((h|0)==(b|0)){i=e;return}r=(b+-4-d|0)>>>2;l=g;j=h;while(1){if(l)c[l>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else l=l+4|0}c[f>>2]=g+(r+1<<2);i=e;return}r=a+4|0;a=c[r>>2]|0;g=a-o>>2;if(k>>>0>g>>>0){s=h+(g<<2)|0;t=1}else{s=b;t=0}if((h|0)==(s|0))u=n;else{g=(s+-4-d|0)>>>2;d=n;k=h;while(1){c[d>>2]=c[k>>2];k=k+4|0;if((k|0)==(s|0))break;else d=d+4|0}u=n+(g+1<<2)|0}if(!t){if((a|0)==(u|0)){i=e;return}c[r>>2]=a+(~((a+-4-u|0)>>>2)<<2);i=e;return}if((s|0)==(b|0)){i=e;return}u=(b+-4-s|0)>>>2;t=a;g=s;while(1){if(t)c[t>>2]=c[g>>2];g=g+4|0;if((g|0)==(b|0))break;else t=t+4|0}c[r>>2]=a+(u+1<<2);i=e;return}function $2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)c[n>>2]=0;m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>2>>>0<1073741823){h=k>>1;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=(c[j>>2]|0)-l>>2;t=11}if((t|0)==11){c[f>>2]=44;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r<<2,16,e,0,3653512,80)|0;q=s}s=p+(q<<2)|0;r=b;t=s;while(1){if(t)c[t>>2]=0;r=r+-1|0;if(!r)break;else t=t+4|0}t=p+(o<<2)|0;o=p+(q+b<<2)|0;b=c[a>>2]|0;r=c[j>>2]|0;if((r|0)==(b|0)){u=s;v=b}else{l=r+-4-b|0;h=r;r=s;while(1){h=h+-4|0;c[r+-4>>2]=c[h>>2];if((h|0)==(b|0))break;else r=r+-4|0}u=p+(q+~(l>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[j>>2]=o;c[g>>2]=t;if(!v){i=d;return}c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(v,e);i=d;return}function a3b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=44;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function b3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((c[g>>2]|0)-j>>2>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;m=l-j>>2;if(!b){n=h;o=0;p=l}else{c[f>>2]=44;c[e+0>>2]=c[f+0>>2];l=cOb(b<<2,16,e,0,3653512,80)|0;n=c[a>>2]|0;o=l;p=c[k>>2]|0}l=o+(m<<2)|0;h=o+(b<<2)|0;if((p|0)==(n|0)){q=l;r=p}else{b=p+-4-n|0;j=p;p=l;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(n|0))break;else p=p+-4|0}q=o+(m+~(b>>>2)<<2)|0;r=n}c[a>>2]=q;c[k>>2]=l;c[g>>2]=h;if(!r){i=d;return}c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function c3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>m-o>>2>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~((q+-4-o|0)>>>2)<<2);c[g>>2]=44;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if((j|0)<0)vxi(a);j=p-0|0;if(j>>2>>>0<1073741823){p=j>>1;j=p>>>0<k>>>0?k:p;if((j|0)<0)vxi(a);else r=j}else r=2147483647;c[g>>2]=44;c[f+0>>2]=c[g+0>>2];g=cOb(r<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(r<<2);if((h|0)==(b|0)){i=e;return}r=(b+-4-d|0)>>>2;l=g;j=h;while(1){if(l)c[l>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else l=l+4|0}c[f>>2]=g+(r+1<<2);i=e;return}r=a+4|0;a=c[r>>2]|0;g=a-o>>2;if(k>>>0>g>>>0){s=h+(g<<2)|0;t=1}else{s=b;t=0}if((h|0)==(s|0))u=n;else{g=(s+-4-d|0)>>>2;d=n;k=h;while(1){c[d>>2]=c[k>>2];k=k+4|0;if((k|0)==(s|0))break;else d=d+4|0}u=n+(g+1<<2)|0}if(!t){if((a|0)==(u|0)){i=e;return}c[r>>2]=a+(~((a+-4-u|0)>>>2)<<2);i=e;return}if((s|0)==(b|0)){i=e;return}u=(b+-4-s|0)>>>2;t=a;g=s;while(1){if(t)c[t>>2]=c[g>>2];g=g+4|0;if((g|0)==(b|0))break;else t=t+4|0}c[r>>2]=a+(u+1<<2);i=e;return}function d3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)c[n>>2]=0;m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>2>>>0<1073741823){h=k>>1;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=(c[j>>2]|0)-l>>2;t=11}if((t|0)==11){c[f>>2]=44;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r<<2,16,e,0,3653512,80)|0;q=s}s=p+(q<<2)|0;r=b;t=s;while(1){if(t)c[t>>2]=0;r=r+-1|0;if(!r)break;else t=t+4|0}t=p+(o<<2)|0;o=p+(q+b<<2)|0;b=c[a>>2]|0;r=c[j>>2]|0;if((r|0)==(b|0)){u=s;v=b}else{l=r+-4-b|0;h=r;r=s;while(1){h=h+-4|0;c[r+-4>>2]=c[h>>2];if((h|0)==(b|0))break;else r=r+-4|0}u=p+(q+~(l>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[j>>2]=o;c[g>>2]=t;if(!v){i=d;return}c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(v,e);i=d;return}function e3b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=44;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function f3b(){var a=0,b=0;a=i;b=rVb(18)|0;i=a;return b|0}function g3b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;k=c[a+28>>2]|0;l=c[a+32>>2]|0;if((k|0)==(l|0)){i=j;return}else m=k;while(1){if((c[m+20>>2]|0)==(b|0)){n=m;break}m=m+28|0;if((m|0)==(l|0)){o=5;break}}if((o|0)==5){i=j;return};c[n+0>>2]=c[d+0>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[e>>2];g[n+16>>2]=f;c[n+24>>2]=h;i=j;return}function h3b(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;h=d+28|0;j=d+32|0;k=c[j>>2]|0;if((c[h>>2]|0)==(k|0))l=1;else l=(c[k+-8>>2]|0)+1|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;b[f+12>>1]=0;a[f+14>>0]=0;a[f+15>>0]=-1;g[f+16>>2]=ea(1.0);c[f+20>>2]=l;c[f+24>>2]=1;if((k|0)==(c[d+36>>2]|0)){r3b(h,f);i=e;return l|0}if(!k)m=0;else{c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[k+16>>2]=c[f+16>>2];c[k+20>>2]=c[f+20>>2];c[k+24>>2]=c[f+24>>2];m=c[j>>2]|0}c[j>>2]=m+28;i=e;return l|0}function i3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=c[a+28>>2]|0;f=a+32|0;a=c[f>>2]|0;if((e|0)==(a|0)){i=d;return}else g=e;while(1){if((c[g+20>>2]|0)==(b|0)){h=g;break}g=g+28|0;if((g|0)==(a|0)){j=10;break}}if((j|0)==10){i=d;return}j=(h-e|0)/28|0;h=e+(j*28|0)|0;g=j+1|0;j=e+(g*28|0)|0;if((j|0)==(a|0)){k=h;l=a}else{b=a+-28|0;m=j;n=h;while(1){c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];h=n+16|0;o=m+16|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];m=m+28|0;if((m|0)==(a|0))break;else n=n+28|0}k=e+(((((b-j|0)>>>0)/28|0)+g|0)*28|0)|0;l=c[f>>2]|0}if((l|0)==(k|0)){i=d;return}c[f>>2]=l+(~(((l+-28-k|0)>>>0)/28|0)*28|0);i=d;return}function j3b(a,b){a=a|0;b=b|0;b=i;g8b(n8b()|0,a+24|0,3e3);i=b;return}function k3b(a){a=a|0;var b=0,c=0;b=i;c=o8b()|0;if(c)h8b(c,a+24|0);fSb(a);i=b;return}function l3b(){var a=0;a=i;QQb(127,100,0,0,0);i=a;return}function m3b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(3)|0))lSb();rri(b,561280,11);wQb(127,3,b,40,2607,0,0);xri(b);i=a;return}function n3b(a){a=a|0;return 127}function o3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,T=Im,U=Im,V=0,W=0,X=Im,Y=0,Z=0,_=0;f=i;i=i+144|0;h=f+72|0;j=f+68|0;k=f+64|0;l=f;m=b+28|0;n=b+32|0;if((c[m>>2]|0)==(c[n>>2]|0)){i=f;return}if(c[d+1068>>2]|0){i=f;return}q3b();d=c[140324]|0;if(!d){i=f;return}b=hkd(d)|0;d=Hld(b)|0;o=ync()|0;p=(c[n>>2]|0)-(c[m>>2]|0)|0;n=(p|0)/28|0;q=(n|0)>3120?3120:n;r=Mnc(o)|0;if(!(gn[c[(c[r>>2]|0)+8>>2]&127](r,24,q*21|0,0,1,k,0)|0)){i=f;return}s=n8b()|0;c[j>>2]=c[s>>2];t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(h,t,j);u=c[h>>2]|0;v=c[t+28>>2]|0;if((u|0)==-1){w=v+(c[t+32>>2]<<3)|0;break}else{w=v+(u<<3)|0;break}}else w=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((w|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[w+4>>2]|0,(t|0)!=0):0)x=t;else y=13}else y=13;if((y|0)==13)x=hQb(c[s>>2]|0)|0;s=c[x+412>>2]|0;y=D$b(x)|0;z=ea(g[y>>2]);A=ea(g[y+4>>2]);B=ea(g[y+8>>2]);C=ea(g[y+16>>2]);D=ea(g[y+20>>2]);E=ea(g[y+24>>2]);F=ea(g[y+32>>2]);G=ea(g[y+36>>2]);H=ea(g[y+40>>2]);I=ea(g[y+48>>2]);J=ea(g[y+52>>2]);K=ea(g[y+56>>2]);if((q|0)>0){q=c[m>>2]|0;m=(p|0)<87360?n:3120;if(!(a[621175]|0)){n=0;p=0;while(1){L=ea(g[q+(p*28|0)>>2]);M=ea(z*L);N=ea(g[q+(p*28|0)+4>>2]);O=ea(M+ea(C*N));M=ea(g[q+(p*28|0)+8>>2]);P=ea(I+ea(O+ea(F*M)));O=ea(J+ea(ea(ea(A*L)+ea(D*N))+ea(G*M)));Q=ea(K+ea(ea(ea(B*L)+ea(E*N))+ea(H*M)));M=ea(g[q+(p*28|0)+16>>2]);if(!(Q>ea(-M))?(c[q+(p*28|0)+24>>2]&s|0)!=0:0){if(!(Q<=ea(M*ea(-2.0)))){N=ea(ea(ea(ea(Q*ea(-255.0))/M)+ea(-255.0))+ea(.5));if(!(N>=ea(0.0)))R=ea(N+ea(-.99999994));else R=N;y=~~R+1|0;x=c[q+(p*28|0)+12>>2]|0;S=(da(x&16711935,y)|0)>>>8&16711935|(da(x>>>8&16711935,y)|0)&-16711936}else S=c[q+(p*28|0)+12>>2]|0;N=ea(ea(M*ea(.333000004))+Q);y=c[k>>2]|0;g[y>>2]=P;g[y+4>>2]=O;g[y+8>>2]=N;c[y+12>>2]=S;g[y+16>>2]=ea(.5);g[y+20>>2]=ea(.5);g[y+24>>2]=P;g[y+28>>2]=O;g[y+32>>2]=N;c[y+36>>2]=S;g[y+40>>2]=ea(.5);g[y+44>>2]=ea(.5);L=ea(P-M);g[y+48>>2]=L;g[y+52>>2]=O;g[y+56>>2]=Q;c[y+60>>2]=S;g[y+64>>2]=ea(0.0);g[y+68>>2]=ea(.5);g[y+72>>2]=P;g[y+76>>2]=O;g[y+80>>2]=N;c[y+84>>2]=S;g[y+88>>2]=ea(.5);g[y+92>>2]=ea(.5);T=ea(O-M);g[y+96>>2]=L;g[y+100>>2]=T;g[y+104>>2]=Q;c[y+108>>2]=S;g[y+112>>2]=ea(0.0);g[y+116>>2]=ea(0.0);g[y+120>>2]=P;g[y+124>>2]=O;g[y+128>>2]=N;c[y+132>>2]=S;g[y+136>>2]=ea(.5);g[y+140>>2]=ea(.5);g[y+144>>2]=P;g[y+148>>2]=T;g[y+152>>2]=Q;c[y+156>>2]=S;g[y+160>>2]=ea(.5);g[y+164>>2]=ea(0.0);g[y+168>>2]=P;g[y+172>>2]=O;g[y+176>>2]=N;c[y+180>>2]=S;g[y+184>>2]=ea(.5);g[y+188>>2]=ea(.5);U=ea(M+P);g[y+192>>2]=U;g[y+196>>2]=T;g[y+200>>2]=Q;c[y+204>>2]=S;g[y+208>>2]=ea(1.0);g[y+212>>2]=ea(0.0);g[y+216>>2]=P;g[y+220>>2]=O;g[y+224>>2]=N;c[y+228>>2]=S;g[y+232>>2]=ea(.5);g[y+236>>2]=ea(.5);g[y+240>>2]=U;g[y+244>>2]=O;g[y+248>>2]=Q;c[y+252>>2]=S;g[y+256>>2]=ea(1.0);g[y+260>>2]=ea(.5);g[y+264>>2]=P;g[y+268>>2]=O;g[y+272>>2]=N;c[y+276>>2]=S;g[y+280>>2]=ea(.5);g[y+284>>2]=ea(.5);T=ea(M+O);g[y+288>>2]=U;g[y+292>>2]=T;g[y+296>>2]=Q;c[y+300>>2]=S;g[y+304>>2]=ea(1.0);g[y+308>>2]=ea(1.0);g[y+312>>2]=P;g[y+316>>2]=O;g[y+320>>2]=N;c[y+324>>2]=S;g[y+328>>2]=ea(.5);g[y+332>>2]=ea(.5);g[y+336>>2]=P;g[y+340>>2]=T;g[y+344>>2]=Q;c[y+348>>2]=S;g[y+352>>2]=ea(.5);g[y+356>>2]=ea(1.0);g[y+360>>2]=P;g[y+364>>2]=O;g[y+368>>2]=N;c[y+372>>2]=S;g[y+376>>2]=ea(.5);g[y+380>>2]=ea(.5);g[y+384>>2]=L;g[y+388>>2]=T;g[y+392>>2]=Q;c[y+396>>2]=S;g[y+400>>2]=ea(0.0);g[y+404>>2]=ea(1.0);g[y+408>>2]=P;g[y+412>>2]=O;g[y+416>>2]=N;c[y+420>>2]=S;g[y+424>>2]=ea(.5);g[y+428>>2]=ea(.5);g[y+432>>2]=L;g[y+436>>2]=O;g[y+440>>2]=Q;c[y+444>>2]=S;g[y+448>>2]=ea(0.0);g[y+452>>2]=ea(.5);g[y+456>>2]=P;g[y+460>>2]=O;g[y+464>>2]=N;c[y+468>>2]=S;g[y+472>>2]=ea(.5);g[y+476>>2]=ea(.5);g[y+480>>2]=P;g[y+484>>2]=O;g[y+488>>2]=N;c[y+492>>2]=S;g[y+496>>2]=ea(.5);g[y+500>>2]=ea(.5);c[k>>2]=y+504;V=n+1|0}else V=n;p=p+1|0;if((p|0)==(m|0)){W=V;break}else n=V}}else{V=0;n=0;while(1){R=ea(g[q+(n*28|0)>>2]);N=ea(z*R);O=ea(g[q+(n*28|0)+4>>2]);P=ea(N+ea(C*O));N=ea(g[q+(n*28|0)+8>>2]);Q=ea(I+ea(P+ea(F*N)));P=ea(J+ea(ea(ea(A*R)+ea(D*O))+ea(G*N)));L=ea(K+ea(ea(ea(B*R)+ea(E*O))+ea(H*N)));N=ea(g[q+(n*28|0)+16>>2]);if(!(L>ea(-N))?(c[q+(n*28|0)+24>>2]&s|0)!=0:0){if(!(L<=ea(N*ea(-2.0)))){O=ea(ea(ea(ea(L*ea(-255.0))/N)+ea(-255.0))+ea(.5));if(!(O>=ea(0.0)))X=ea(O+ea(-.99999994));else X=O;p=~~X+1|0;S=c[q+(n*28|0)+12>>2]|0;Y=(da(S&16711935,p)|0)>>>8&16711935|(da(S>>>8&16711935,p)|0)&-16711936}else Y=c[q+(n*28|0)+12>>2]|0;O=ea(ea(N*ea(.333000004))+L);p=c[k>>2]|0;g[p>>2]=Q;g[p+4>>2]=P;g[p+8>>2]=O;S=Y<<16&16711680|Y&-16777216|Y&65280|Y>>>16&255;c[p+12>>2]=S;g[p+16>>2]=ea(.5);g[p+20>>2]=ea(.5);g[p+24>>2]=Q;g[p+28>>2]=P;g[p+32>>2]=O;c[p+36>>2]=S;g[p+40>>2]=ea(.5);g[p+44>>2]=ea(.5);R=ea(Q-N);g[p+48>>2]=R;g[p+52>>2]=P;g[p+56>>2]=L;c[p+60>>2]=S;g[p+64>>2]=ea(0.0);g[p+68>>2]=ea(.5);g[p+72>>2]=Q;g[p+76>>2]=P;g[p+80>>2]=O;c[p+84>>2]=S;g[p+88>>2]=ea(.5);g[p+92>>2]=ea(.5);T=ea(P-N);g[p+96>>2]=R;g[p+100>>2]=T;g[p+104>>2]=L;c[p+108>>2]=S;g[p+112>>2]=ea(0.0);g[p+116>>2]=ea(0.0);g[p+120>>2]=Q;g[p+124>>2]=P;g[p+128>>2]=O;c[p+132>>2]=S;g[p+136>>2]=ea(.5);g[p+140>>2]=ea(.5);g[p+144>>2]=Q;g[p+148>>2]=T;g[p+152>>2]=L;c[p+156>>2]=S;g[p+160>>2]=ea(.5);g[p+164>>2]=ea(0.0);g[p+168>>2]=Q;g[p+172>>2]=P;g[p+176>>2]=O;c[p+180>>2]=S;g[p+184>>2]=ea(.5);g[p+188>>2]=ea(.5);U=ea(N+Q);g[p+192>>2]=U;g[p+196>>2]=T;g[p+200>>2]=L;c[p+204>>2]=S;g[p+208>>2]=ea(1.0);g[p+212>>2]=ea(0.0);g[p+216>>2]=Q;g[p+220>>2]=P;g[p+224>>2]=O;c[p+228>>2]=S;g[p+232>>2]=ea(.5);g[p+236>>2]=ea(.5);g[p+240>>2]=U;g[p+244>>2]=P;g[p+248>>2]=L;c[p+252>>2]=S;g[p+256>>2]=ea(1.0);g[p+260>>2]=ea(.5);g[p+264>>2]=Q;g[p+268>>2]=P;g[p+272>>2]=O;c[p+276>>2]=S;g[p+280>>2]=ea(.5);g[p+284>>2]=ea(.5);T=ea(N+P);g[p+288>>2]=U;g[p+292>>2]=T;g[p+296>>2]=L;c[p+300>>2]=S;g[p+304>>2]=ea(1.0);g[p+308>>2]=ea(1.0);g[p+312>>2]=Q;g[p+316>>2]=P;g[p+320>>2]=O;c[p+324>>2]=S;g[p+328>>2]=ea(.5);g[p+332>>2]=ea(.5);g[p+336>>2]=Q;g[p+340>>2]=T;g[p+344>>2]=L;c[p+348>>2]=S;g[p+352>>2]=ea(.5);g[p+356>>2]=ea(1.0);g[p+360>>2]=Q;g[p+364>>2]=P;g[p+368>>2]=O;c[p+372>>2]=S;g[p+376>>2]=ea(.5);g[p+380>>2]=ea(.5);g[p+384>>2]=R;g[p+388>>2]=T;g[p+392>>2]=L;c[p+396>>2]=S;g[p+400>>2]=ea(0.0);g[p+404>>2]=ea(1.0);g[p+408>>2]=Q;g[p+412>>2]=P;g[p+416>>2]=O;c[p+420>>2]=S;g[p+424>>2]=ea(.5);g[p+428>>2]=ea(.5);g[p+432>>2]=R;g[p+436>>2]=P;g[p+440>>2]=L;c[p+444>>2]=S;g[p+448>>2]=ea(0.0);g[p+452>>2]=ea(.5);g[p+456>>2]=Q;g[p+460>>2]=P;g[p+464>>2]=O;c[p+468>>2]=S;g[p+472>>2]=ea(.5);g[p+476>>2]=ea(.5);g[p+480>>2]=Q;g[p+484>>2]=P;g[p+488>>2]=O;c[p+492>>2]=S;g[p+496>>2]=ea(.5);g[p+500>>2]=ea(.5);c[k>>2]=p+504;Z=V+1|0}else Z=V;n=n+1|0;if((n|0)==(m|0)){W=Z;break}else V=Z}}}else W=0;co[c[(c[r>>2]|0)+12>>2]&2047](r,W*21|0,0);W=h+0|0;Z=(mo[c[(c[o>>2]|0)+120>>2]&4095](o)|0)+0|0;V=W+64|0;do{c[W>>2]=c[Z>>2];W=W+4|0;Z=Z+4|0}while((W|0)<(V|0));W=l+0|0;Z=(mo[c[(c[o>>2]|0)+116>>2]&4095](o)|0)+0|0;V=W+64|0;do{c[W>>2]=c[Z>>2];W=W+4|0;Z=Z+4|0}while((W|0)<(V|0));In[c[(c[o>>2]|0)+104>>2]&4095](o,601008);Z=ekd(c[140324]|0,0,b,e,d)|0;d=c[(c[r>>2]|0)+16>>2]|0;e=c[Z+4>>2]|0;b=c[140286]|0;if(!b){W=tic(uic()|0,13)|0;c[140286]=W;_=W}else _=b;b=qic(_,e,0)|0;co[d&2047](r,Z,b);In[c[(c[o>>2]|0)+104>>2]&4095](o,h);In[c[(c[o>>2]|0)+100>>2]&4095](o,l);i=f;return}function p3b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;o3b(a+-24|0,b,c);i=d;return}function q3b(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;if(c[140324]|0){i=a;return}d=Xmd()|0;rri(b,561304,20);e=Nmd(d,b)|0;xri(b);if(!e){i=a;return}c[140324]=bkd(e,61,0)|0;i=a;return}function r3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/28|0)+1|0;if(g>>>0>153391689)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/28|0;if(k>>>0<76695844){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/28|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=153391689;r=(l|0)/28|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*28|0)|0;o=r;p=s}s=n+(o*28|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];c[s+16>>2]=c[b+16>>2];c[s+20>>2]=c[b+20>>2];c[s+24>>2]=c[b+24>>2]}b=n+((((p|0)/-28|0)+o|0)*28|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*28|0);c[h>>2]=n+(m*28|0);if(!f){i=d;return}ACi(f);i=d;return}function s3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(40,e,1,16,3653512,32)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];iSb(g,e,b);c[g>>2]=561160;c[g+24>>2]=561276;c[g+28>>2]=0;c[g+32>>2]=0;c[g+36>>2]=0;i=d;return g|0}function t3b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=561160;c[a+24>>2]=561276;d=c[a+28>>2]|0;if(!d){TSb(a);i=b;return}e=a+32|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~(((f+-28-d|0)>>>0)/28|0)*28|0);ACi(d);TSb(a);i=b;return}function u3b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=561160;c[a+24>>2]=561276;d=c[a+28>>2]|0;if(!d){TSb(a);ACi(a);i=b;return}e=a+32|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~(((f+-28-d|0)>>>0)/28|0)*28|0);ACi(d);TSb(a);ACi(a);i=b;return}function v3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=(a[d+9>>0]|0)!=0?b:b+12|0;b=c[d>>2]|0;m=c[b+24>>2]|0;a:do if((m|0)!=0?(n=c[m+32>>2]|0,(n|0)>0):0){o=c[m+24>>2]|0;p=0;while(1){if((c[o+(p<<3)+4>>2]|0)==(b|0)){q=p;break a}p=p+1|0;if((p|0)>=(n|0)){q=-1;break}}}else q=-1;while(0);b=c[l>>2]|0;m=((c[l+4>>2]|0)-b|0)/12|0;while(1){n=m+-1|0;if((n|0)<=-1){r=15;break}p=c[b+(n*12|0)>>2]|0;o=c[p+24>>2]|0;b:do if((o|0)!=0?(s=c[o+32>>2]|0,(s|0)>0):0){t=c[o+24>>2]|0;u=0;while(1){if((c[t+(u<<3)+4>>2]|0)==(p|0)){v=u;break b}u=u+1|0;if((u|0)>=(s|0)){v=-1;break}}}else v=-1;while(0);if((q|0)<(v|0))m=n;else{w=m;r=14;break}}if((r|0)==14){c[g>>2]=b+(w*12|0);c[f+0>>2]=c[g+0>>2];H3b(h,l,f,d);i=e;return}else if((r|0)==15){c[j>>2]=b;c[f+0>>2]=c[j+0>>2];H3b(k,l,f,d);i=e;return}}function w3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[a>>2]|0;f=a+4|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=b+4|0;j=g;g=e;while(1){if((c[g>>2]|0)==(c[b>>2]|0)?(c[g+4>>2]|0)==(c[h>>2]|0):0){e=c[a>>2]|0;k=(g-e|0)/12|0;l=e+(k*12|0)|0;m=e+((k+1|0)*12|0)|0;n=j-m|0;aFi(l|0,m|0,n|0)|0;m=e+((((n|0)/12|0)+k|0)*12|0)|0;k=c[f>>2]|0;if((k|0)==(m|0)){o=l;p=m}else{n=k+(~(((k+-12-m|0)>>>0)/12|0)*12|0)|0;c[f>>2]=n;o=l;p=n}}else{o=g+12|0;p=j}if((o|0)==(p|0))break;else{j=p;g=o}}}o=a+12|0;g=c[o>>2]|0;p=a+16|0;a=c[p>>2]|0;if((g|0)==(a|0)){i=d;return}j=b+4|0;f=g;g=a;while(1){if((c[f>>2]|0)==(c[b>>2]|0)?(c[f+4>>2]|0)==(c[j>>2]|0):0){a=c[o>>2]|0;h=(f-a|0)/12|0;n=a+(h*12|0)|0;l=a+((h+1|0)*12|0)|0;m=g-l|0;aFi(n|0,l|0,m|0)|0;l=a+((((m|0)/12|0)+h|0)*12|0)|0;h=c[p>>2]|0;if((h|0)==(l|0)){q=n;r=l}else{m=h+(~(((h+-12-l|0)>>>0)/12|0)*12|0)|0;c[p>>2]=m;q=n;r=m}}else{q=f+12|0;r=g}if((q|0)==(r|0))break;else{f=q;g=r}}i=d;return}function x3b(a){a=a|0;return c[a+24>>2]|0}function y3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;do if((c[a>>2]|0)!=(c[a+4>>2]|0)){if(!((c[a+12>>2]|0)!=(c[a+16>>2]|0)|b)){f=a+24|0;break}if(d^1|b){f=a+28|0;break}else{f=a+24|0;break}}else f=a+24|0;while(0);i=e;return c[f>>2]|0}function z3b(a){a=a|0;return c[a+32>>2]|0}function A3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if(!b){f=0;i=e;return f|0}g=Gzc()|0;h=ync()|0;j=mo[c[(c[h>>2]|0)+668>>2]&4095](h)|0;h=Hzc(g,-1,-1,0,j,0,d?2:1,1)|0;if(h){ABc(h,1);In[c[(c[h>>2]|0)+36>>2]&4095](h,561336)}d=a+24|0;if((c[d>>2]|0)==(b|0)){Jzc(Gzc()|0,b);c[d>>2]=h;f=h;i=e;return f|0}d=a+28|0;a=(c[d>>2]|0)==(b|0);Jzc(Gzc()|0,b);if(!a){f=h;i=e;return f|0}c[d>>2]=h;f=h;i=e;return f|0}function B3b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=b+4|0;if((c[b>>2]|0)==(c[h>>2]|0)?!((c[b+12>>2]|0)!=(c[b+16>>2]|0)|d):0){i=g;return}d=(rBc()|0)^1;if((c[155287]|0)==0|d){if(a[561360]|0){i=g;return}Krd(561368,0,3653512,184,1,0,0,0);a[561360]=1;i=g;return}d=(KLc()|0)==1;j=Gzc()|0;k=ync()|0;l=c[k>>2]|0;if(e)m=mo[c[l+672>>2]&4095](k)|0;else m=mo[c[l+668>>2]&4095](k)|0;if(d)n=e?1:2;else n=1;k=Hzc(j,-1,-1,2,m,0,n,f)|0;if(k){ABc(k,1);In[c[(c[k>>2]|0)+36>>2]&4095](k,561336)}c[b+24>>2]=k;k=c[h>>2]|0;h=c[b>>2]|0;n=(k-h|0)/12|0;if((k|0)==(h|0))o=e;else{k=e;e=0;while(1){m=(a[h+(e*12|0)+8>>0]|0)==0&k;e=e+1|0;if(e>>>0>=n>>>0){o=m;break}else k=m}}k=Gzc()|0;n=ync()|0;e=c[n>>2]|0;if(o)p=mo[c[e+672>>2]&4095](n)|0;else p=mo[c[e+668>>2]&4095](n)|0;if(d)q=o?1:2;else q=1;o=Hzc(k,-1,-1,0,p,0,q,f)|0;if(o){ABc(o,1);In[c[(c[o>>2]|0)+36>>2]&4095](o,561336)}c[b+28>>2]=o;i=g;return}function C3b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=i;i=i+32|0;k=j+20|0;l=j+16|0;m=j+12|0;n=j+8|0;o=j+4|0;p=j;q=(rBc()|0)^1;if((c[155287]|0)==0|q){i=j;return}q=(KLc()|0)==1;r=Gzc()|0;s=b+32|0;c[s>>2]=c[(ync()|0)+5836>>2];if(f){t=c[b+24>>2]|0;if(((c[b+12>>2]|0)==(c[b+16>>2]|0)|g)^1|e){u=c[b+28>>2]|0;v=t}else{u=d;v=t}}else{do if((c[b>>2]|0)!=(c[b+4>>2]|0)){if(!((c[b+12>>2]|0)!=(c[b+16>>2]|0)|e)){w=b+24|0;break}if(g^1|e){w=b+28|0;break}else{w=b+24|0;break}}else w=b+24|0;while(0);u=d;v=c[w>>2]|0}w=a[561456]|0;d=c[140366]|0;g=c[140368]|0;a[561456]=0;c[140366]=v;c[140368]=u;t=ync()|0;x=f?b:b+12|0;y=x+4|0;z=c[y>>2]|0;A=c[x>>2]|0;B=(z-A|0)/12|0;if((z|0)==(A|0)){C=v;D=0}else{E=B+-1|0;F=h^1;G=b+24|0;H=b+28|0;I=v;v=0;J=h;h=0;while(1){if((h|0)!=(E|0)){if((a[(c[x>>2]|0)+(h*12|0)+8>>0]|0)==0|J^1){K=v;L=J}else{K=A3b(b,v,q)|0;L=0}if(!K){M=Gzc()|0;N=ync()|0;O=c[N>>2]|0;if(L)P=mo[c[O+672>>2]&4095](N)|0;else P=mo[c[O+668>>2]&4095](N)|0;if(q)Q=L?1:2;else Q=1;N=Hzc(M,-1,-1,0,P,0,Q,1)|0;if(!N){R=0;S=L;T=0}else{ABc(N,1);In[c[(c[N>>2]|0)+36>>2]&4095](N,561336);R=N;S=L;T=N}}else{R=K;S=L;T=K}}else{R=v;S=J;T=u}a[561456]=1;c[l>>2]=0;c[m>>2]=0;I3b(T,l,m);if(!(a[(c[l>>2]|0)+23>>0]|0))In[c[(c[t>>2]|0)+400>>2]&4095](t,l);N=c[m>>2]|0;if((N|0)!=(c[(c[140366]|0)+148>>2]|0)?(a[N+23>>0]|0)==0:0)In[c[(c[t>>2]|0)+400>>2]&4095](t,m);else{M=c[(c[t>>2]|0)+408>>2]|0;c[n>>2]=N;c[k+0>>2]=c[n+0>>2];In[M&4095](t,k)}M=c[x>>2]|0;co[c[M+(h*12|0)+4>>2]&2047](c[M+(h*12|0)>>2]|0,I,T);a[561456]=0;if(!((a[(c[x>>2]|0)+(h*12|0)+8>>0]|0)==0|F)?(I|0)!=0&(S^1):0){Jzc(Gzc()|0,I);if((I|0)==(c[G>>2]|0))c[G>>2]=0;if((I|0)==(c[H>>2]|0)){c[H>>2]=0;U=0}else U=0}else if(!I)U=0;else{ABc(I,1);U=I}h=h+1|0;if(h>>>0>=B>>>0){C=R;D=U;break}else{I=R;v=U;J=S}}}if(!(f|e^1)?(c[x>>2]|0)==(c[y>>2]|0):0){D3b(C,u);V=1}else V=0;y=c[140366]|0;if((y|0)!=0&(c[140368]|0)!=0?(x=c[y+148>>2]|0,(x|0)!=0):0){y=mo[c[(c[t>>2]|0)+420>>2]&4095](t)|0;if(!y){W=1;X=0;Y=0}else{W=c[y+12>>2]|0;X=c[y+4>>2]|0;Y=c[y+8>>2]|0}if((((x|0)!=(y|0)?(c[x+12>>2]|0)==(W|0):0)?(c[x+4>>2]|0)==(X|0):0)?(c[x+8>>2]|0)==(Y|0):0){c[o>>2]=_n[c[(c[t>>2]|0)+416>>2]&4095](t,0)|0;c[p>>2]=x;x=c[140368]|0;c[k+0>>2]=c[p+0>>2];qBc(1,o,k,x,0,-1,0)|0}}if((z|0)!=(A|0)|V)c[s>>2]=u;if(((D|0)!=0?(D|0)!=(c[b+24>>2]|0):0)?(D|0)!=(c[b+28>>2]|0):0)Jzc(r,D);if(((C|0)!=0?(C|0)!=(c[b+24>>2]|0):0)?(C|0)!=(c[b+28>>2]|0):0)Jzc(r,C);if(!f){f=b+24|0;C=c[f>>2]|0;if(C){Jzc(r,C);c[f>>2]=0}f=b+28|0;b=c[f>>2]|0;if(b){Jzc(r,b);if((c[f>>2]|0)==(c[s>>2]|0))c[s>>2]=0;c[f>>2]=0}}f=ync()|0;In[c[(c[f>>2]|0)+72>>2]&4095](f,0);a[561456]=w;c[140366]=d;c[140368]=g;i=j;return}function D3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+64|0;e=d+56|0;f=d+48|0;h=d+32|0;j=d+16|0;k=d;if(!((a|0)==0&(b|0)!=0)){l=E3b()|0;if(!l){i=d;return}F3b(a,b,l,-1,1,-1);i=d;return}m=ea(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0);n=ea(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0);g[h>>2]=ea(0.0);g[h+8>>2]=m;g[h+4>>2]=ea(0.0);g[h+12>>2]=n;l=n8b()|0;a=c[l>>2]|0;do if(a){c[f>>2]=a;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(e,o,f);p=c[e>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[r+4>>2]|0,(o|0)!=0):0)s=o;else t=11}else t=11;if((t|0)==11){o=hQb(c[l>>2]|0)|0;if(!o)break;else s=o}B$b(j,s);c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2]}while(0);n1b(k,h);zBc(b,c[k>>2]|0,c[k+4>>2]|0,c[k+8>>2]|0,c[k+12>>2]|0);i=d;return}function E3b(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+4|0;f=c[140370]|0;if(f){g=f;i=b;return g|0}f=Xmd()|0;rri(d,561488,15);h=Nmd(f,d)|0;xri(d);if(h){d=bkd(h,61,0)|0;c[140370]=d;g=d;i=b;return g|0}Lsd(e,561504,b);if(!(a[e>>0]&1))j=e+1|0;else j=c[e+8>>2]|0;Krd(j,0,3653512,465,1,0,0,0);xri(e);g=0;i=b;return g|0}function F3b(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=0,A=0,B=Im,C=Im,D=0;k=i;i=i+240|0;l=k;m=k+16|0;n=k+228|0;o=k+224|0;p=k+232|0;q=k+12|0;r=k+212|0;s=k+236|0;t=ync()|0;u=tBc()|0;if(!u)v=0;else v=(c[u+108>>2]|0)>1;if(v|h){c[m>>2]=0;c[n>>2]=0;I3b(d,m,n);c[o>>2]=c[n>>2];c[l+0>>2]=c[o+0>>2];qBc(1,m,l,d,0,j,v?2:0)|0;nBc(d)}if(b){c[p>>2]=c[140332];c[l+0>>2]=c[p+0>>2];if(pkd(e,l)|0){c[q>>2]=c[140332];c[l+0>>2]=c[q+0>>2];rkd(e,l,b);w=1}else w=0;q=ea(g[b+76>>2])<ea(0.0);if((c[b+52>>2]|0)==6){x=ea(mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0);y=ea(x/ea(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0));x=ea(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0);z=q;A=w;B=y;C=ea(x/ea(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0))}else{z=q;A=w;B=ea(1.0);C=ea(1.0)}}else{z=0;A=0;B=ea(1.0);C=ea(1.0)}t1b(m,ync()|0);l1b(ea(-1.0),ea(100.0),0,ync()|0);w=kkd(e)|0;do if((f|0)==-1){if((w|0)>0){q=0;do{Vvc(t,dkd(e,q,c[158074]|0,0,1)|0,z,B,C);q=q+1|0}while((q|0)<(w|0))}}else{if((f|0)>-1&(w|0)>(f|0)){Vvc(t,dkd(e,f,c[158074]|0,0,1)|0,z,B,C);break}q=mo[c[(c[e>>2]|0)+32>>2]&4095](e)|0;c[l>>2]=f;c[l+4>>2]=q;c[l+8>>2]=w;Lsd(r,561560,l);if(!(a[r>>0]&1))D=r+1|0;else D=c[r+8>>2]|0;Krd(D,0,3653512,594,1,0,0,0);xri(r)}while(0);if(!A){u1b(m);i=k;return}c[s>>2]=c[140332];c[l+0>>2]=c[s+0>>2];rkd(e,l,0);u1b(m);i=k;return}function G3b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);c[140332]=c[b>>2];i=a;return}function H3b(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;h=c[d>>2]|0;j=h;k=((c[e>>2]|0)-j|0)/12|0;e=h+(k*12|0)|0;l=d+4|0;m=c[l>>2]|0;n=d+8|0;o=c[n>>2]|0;if(m>>>0<o>>>0){if((e|0)==(m|0)){if(!e)p=0;else{c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];p=c[l>>2]|0}c[l>>2]=p+12;q=e;c[a>>2]=q;i=g;return}p=m-(h+((k+1|0)*12|0))|0;r=h+((((p|0)/12|0)+k|0)*12|0)|0;if(r>>>0<m>>>0){k=m;s=r;do{if(!k)t=0;else{c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];t=c[l>>2]|0}s=s+12|0;k=t+12|0;c[l>>2]=k}while(s>>>0<m>>>0)}aFi(m+(((p|0)/-12|0)*12|0)|0,e|0,p|0)|0;if(e>>>0>f>>>0)u=f;else u=(c[l>>2]|0)>>>0>f>>>0?f+12|0:f;c[e+0>>2]=c[u+0>>2];c[e+4>>2]=c[u+4>>2];b[e+8>>1]=b[u+8>>1]|0;q=e;c[a>>2]=q;i=g;return}u=((m-j|0)/12|0)+1|0;if(u>>>0>357913941)vxi(d);j=h;h=(o-j|0)/12|0;if(h>>>0<178956970){o=h<<1;h=o>>>0<u>>>0?u:o;o=e;u=(o-j|0)/12|0;if(!h){v=0;w=0;x=u;y=o}else{z=h;A=u;B=o;C=18}}else{o=e;z=357913941;A=(o-j|0)/12|0;B=o;C=18}if((C|0)==18){v=z;w=xCi(z*12|0)|0;x=A;y=B}B=w+(x*12|0)|0;A=w+(v*12|0)|0;do if((x|0)==(v|0)){z=(x*12|0)/12|0;if((x|0)>0){D=w+((((z+1|0)/-2|0)+x|0)*12|0)|0;E=A;break}C=z<<1;z=(C|0)==0?1:C;C=xCi(z*12|0)|0;o=C+((z>>>2)*12|0)|0;j=C+(z*12|0)|0;if(!w){D=o;E=j}else{ACi(w);D=o;E=j}}else{D=B;E=A}while(0);if(!D)F=0;else{c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];F=D}f=c[d>>2]|0;A=y-f|0;B=D+(((A|0)/-12|0)*12|0)|0;YEi(B|0,f|0,A|0)|0;A=(c[l>>2]|0)-y|0;YEi(F+12|0,e|0,A|0)|0;e=c[d>>2]|0;c[d>>2]=B;c[l>>2]=F+((((A|0)/12|0)+1|0)*12|0);c[n>>2]=E;if(!e){q=D;c[a>>2]=q;i=g;return}ACi(e);q=D;c[a>>2]=q;i=g;return}function I3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=(b|0)!=0;if(g)uBc(b)|0;h=c[140366]|0;if(((a[561456]|0)!=0&g&(h|0)!=0&(c[140368]|0)==(b|0)?(c[b+100>>2]|0)==(c[h+100>>2]|0):0)?(c[b+104>>2]|0)==(c[h+104>>2]|0):0){uBc(h)|0;c[d>>2]=c[b+140>>2];c[e>>2]=c[(c[140366]|0)+148>>2];i=f;return}if(g){c[d>>2]=c[b+140>>2];c[e>>2]=c[b+148>>2];i=f;return}else{b=ync()|0;c[d>>2]=mo[c[(c[b>>2]|0)+428>>2]&4095](b)|0;b=ync()|0;c[e>>2]=mo[c[(c[b>>2]|0)+432>>2]&4095](b)|0;i=f;return}}function J3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==1){e=c[a+4>>2]|0;if((e|0)==(a|0)){i=d;return}else f=e;do{e=c[f+8>>2]|0;ko[c[(c[e>>2]|0)+76>>2]&4095](e);f=c[f+4>>2]|0}while((f|0)!=(a|0));i=d;return}else if(!b){b=c[a+4>>2]|0;if((b|0)==(a|0)){i=d;return}else g=b;do{b=c[g+8>>2]|0;ko[c[(c[b>>2]|0)+72>>2]&4095](b);g=c[g+4>>2]|0}while((g|0)!=(a|0));i=d;return}else{i=d;return}}function K3b(a){a=a|0;var b=0,d=0;b=i;V_b(a,10);c[a>>2]=561640;c[a+188>>2]=0;c[a+192>>2]=0;c[a+196>>2]=a;c[a+200>>2]=0;d=c[153110]|0;c[a+204>>2]=0;c[a+208>>2]=d;c[a+212>>2]=0;c[a+216>>2]=0;c[a+220>>2]=0;c[a+224>>2]=d;c[a+228>>2]=0;c[a+232>>2]=0;c[a+236>>2]=c[155410];i=b;return}function L3b(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0;l=i;c[b+200>>2]=c[f>>2];c[b+240>>2]=h>>>0>31?0:h;a[b+41>>0]=j;a[b+42>>0]=k&1;k=b+52|0;j=d+0|0;h=k+64|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(h|0));c[b+164>>2]=pMc(d,ea(g[150276]))|0;j=b+140|0;c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[j+20>>2]=c[e+20>>2];Wlc(e,d,b+116|0);ko[c[(c[b>>2]|0)+20>>2]&4095](b);a[b+48>>0]=0;a[b+49>>0]=0;i=l;return}function M3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=561640;a[b+43>>0]=0;g=b+204|0;if((c[b+232>>2]|0)>-1){h=b+220|0;j=c[h>>2]|0;c[f>>2]=c[b+224>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[h>>2]=0}if((c[b+216>>2]|0)<=-1){i=d;return}h=c[g>>2]|0;c[f>>2]=c[b+208>>2];c[e+0>>2]=c[f+0>>2];eOb(h,e);c[g>>2]=0;i=d;return}function N3b(a){a=a|0;var b=0;b=i;M3b(a);ACi(a);i=b;return}function O3b(a){a=a|0;return}function P3b(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];d=bOb(44,b,0,16,3653512,70)|0;c[e>>2]=c[153126];c[b+0>>2]=c[e+0>>2];_rd(d,1,561736,252,65536,b,16);c[140432]=d;i=a;return}function Q3b(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[140432]|0;f=c[153126]|0;if(e)$rd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[140432]=0;i=a;return}function R3b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=561776;d=a+188|0;e=c[d>>2]|0;if(!e){M3b(a);i=b;return}f=a+192|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0;M3b(a);i=b;return}function S3b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=561776;d=a+188|0;e=c[d>>2]|0;if(e){f=a+192|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}M3b(a);dsd(c[140432]|0,a);i=b;return}function T3b(a){a=a|0;c[a+244>>2]=0;return}function U3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=c[a+248>>2]|0;f=a+244|0;g=c[f>>2]|0;if(!g){i=b;return}h=a+168|0;if(!(c[h>>2]|0))j=g;else{g=ync()|0;In[c[(c[g>>2]|0)+220>>2]&4095](g,c[h>>2]|0);j=c[f>>2]|0}Xuc(d,j,e,0,0);i=b;return}function V3b(a,b,c){a=a|0;b=b|0;c=c|0;a=i;Lmc(b,c);i=a;return}function W3b(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=i;c[b+244>>2]=e;do if(!e)o=m;else{p=b+188|0;q=e+220|0;if((p|0)!=(q|0)){r=c[p>>2]|0;s=b+192|0;if(r){c[r+4>>2]=c[s>>2];c[c[s>>2]>>2]=r;c[p>>2]=0;c[s>>2]=0}r=c[q>>2]|0;c[p>>2]=r;c[s>>2]=q;c[r+4>>2]=p;c[c[s>>2]>>2]=p}if((m|0)>=0?(iec(e)|0)>(m|0):0){o=m;break}o=0}while(0);c[b+248>>2]=o;c[b+200>>2]=c[h>>2];c[b+240>>2]=j>>>0>31?0:j;a[b+41>>0]=k;a[b+42>>0]=l&1;l=b+52|0;k=d+0|0;j=l+64|0;do{c[l>>2]=c[k>>2];l=l+4|0;k=k+4|0}while((l|0)<(j|0));c[b+164>>2]=pMc(d,ea(g[150276]))|0;k=b+140|0;c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[k+16>>2]=c[f+16>>2];c[k+20>>2]=c[f+20>>2];Wlc(f,d,b+116|0);ko[c[(c[b>>2]|0)+20>>2]&4095](b);a[b+48>>0]=0;a[b+49>>0]=0;i=n;return}function X3b(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];d=bOb(44,b,0,16,3653512,145)|0;c[e>>2]=c[153126];c[b+0>>2]=c[e+0>>2];_rd(d,1,561872,256,65536,b,16);c[140466]=d;i=a;return}function Y3b(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[140466]|0;f=c[153126]|0;if(e)$rd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[140466]=0;i=a;return}function Z3b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=561776;d=a+188|0;e=c[d>>2]|0;if(e){f=a+192|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}M3b(a);dsd(c[140466]|0,a);i=b;return}function _3b(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];d=bOb(44,b,0,16,3653512,178)|0;c[e>>2]=c[153126];c[b+0>>2]=c[e+0>>2];_rd(d,1,562032,264,65536,b,16);c[140506]=d;i=a;return}function $3b(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[140506]|0;f=c[153126]|0;if(e)$rd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[140506]=0;i=a;return}function a4b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;if(h>>>0>b>>>0){j=b;do{k=c[(c[a>>2]|0)+(j*24|0)>>2]|0;if(k)ko[c[(c[k>>2]|0)+4>>2]&4095](k);j=j+1|0}while((j|0)!=(h|0))}c[g>>2]=b;h=a+12|0;j=c[h>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[h>>2]=b;k=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(k,b*24|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];k=cOb(b*24|0,4,e,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,(c[g>>2]|0)*24|0)|0;c[h>>2]=b;c[a>>2]=k;break}while(0);h=a+16|0;g=a+24|0;c[g>>2]=b;j=a+28|0;k=c[j>>2]|0;if((k&2147483647)>>>0>=b>>>0){i=d;return}if((k|0)>-1){c[j>>2]=b;k=c[h>>2]|0;c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];c[h>>2]=hOb(k,b*24|0,4,e,0,3653512,370)|0;i=d;return}else{c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];f=cOb(b*24|0,4,e,0,3653512,352)|0;YEi(f|0,c[h>>2]|0,(c[g>>2]|0)*24|0)|0;c[j>>2]=b;c[h>>2]=f;i=d;return}}function b4b(a){a=a|0;return c[a+16>>2]|0}function c4b(a){a=a|0;return c[a>>2]|0}function d4b(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f;c[j+0>>2]=0;c[j+4>>2]=0;b[j+8>>1]=0;a[j+10>>0]=0;k=d+8|0;l=(c[k>>2]|0)+1|0;c[k>>2]=l;m=d+12|0;n=c[m>>2]|0;o=n&2147483647;if(l>>>0>o>>>0){p=n<<1;q=(p|0)==0?1:p;do if(o>>>0<q>>>0)if((n|0)>-1){c[m>>2]=q;p=c[d>>2]|0;c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];c[d>>2]=hOb(p,q*24|0,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];p=cOb(q*24|0,4,g,0,3653512,352)|0;YEi(p|0,c[d>>2]|0,(c[k>>2]|0)*24|0)|0;c[m>>2]=q;c[d>>2]=p;break}while(0);r=c[k>>2]|0}else r=l;l=r+-1|0;r=c[d>>2]|0;c[r+(l*24|0)>>2]=0;c[r+(l*24|0)+4>>2]=0;c[r+(l*24|0)+8>>2]=-1;q=r+(l*24|0)+12|0;c[q+0>>2]=c[j+0>>2];c[q+4>>2]=c[j+4>>2];b[q+8>>1]=b[j+8>>1]|0;a[q+10>>0]=a[j+10>>0]|0;j=(c[k>>2]|0)+-1|0;k=c[d>>2]|0;c[k+(j*24|0)>>2]=e;c[k+(j*24|0)+4>>2]=mo[c[(c[e>>2]|0)+28>>2]&4095](e)|0;j=d+16|0;k=d+24|0;q=(c[k>>2]|0)+1|0;c[k>>2]=q;l=d+28|0;r=c[l>>2]|0;m=r&2147483647;if(q>>>0<=m>>>0){s=q;t=s+-1|0;u=c[j>>2]|0;v=u+(t*24|0)|0;Y_b(e,v);i=f;return}q=r<<1;n=(q|0)==0?1:q;do if(m>>>0<n>>>0)if((r|0)>-1){c[l>>2]=n;q=c[j>>2]|0;c[h>>2]=c[d+20>>2];c[g+0>>2]=c[h+0>>2];c[j>>2]=hOb(q,n*24|0,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+20>>2];c[g+0>>2]=c[h+0>>2];q=cOb(n*24|0,4,g,0,3653512,352)|0;YEi(q|0,c[j>>2]|0,(c[k>>2]|0)*24|0)|0;c[l>>2]=n;c[j>>2]=q;break}while(0);s=c[k>>2]|0;t=s+-1|0;u=c[j>>2]|0;v=u+(t*24|0)|0;Y_b(e,v);i=f;return}function e4b(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;i=i+32|0;l=k+8|0;m=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;if(!b){c[l+0>>2]=c[150284];c[l+4>>2]=c[150285];c[l+8>>2]=c[150286];n=l+12|0;c[n+0>>2]=c[150284];c[n+4>>2]=c[150285];c[n+8>>2]=c[150286]}else{n=b+168|0;c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];c[l+16>>2]=c[n+16>>2];c[l+20>>2]=c[n+20>>2]}c[m>>2]=c[d>>2];d=f4b(a,b,l,m,e,f,g,h,j)|0;i=k;return d|0}function f4b(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;i=i+16|0;m=l;n=csd(c[140432]|0,252)|0;V_b(n,10);c[n+188>>2]=0;c[n+192>>2]=0;c[n+196>>2]=n;c[n+200>>2]=0;o=c[153110]|0;c[n+204>>2]=0;c[n+208>>2]=o;c[n+212>>2]=0;c[n+216>>2]=0;c[n+220>>2]=0;c[n+224>>2]=o;c[n+228>>2]=0;c[n+232>>2]=0;c[n+236>>2]=c[155410];c[n>>2]=561776;c[n+244>>2]=0;c[n+248>>2]=0;c[m>>2]=c[e>>2];W3b(n,a,b,d,m,f,g,h,j);if(!k){p=Lac()|0;d4b(p,n);i=l;return n|0}else{p=c[k+372>>2]|0;d4b(p,n);i=l;return n|0}return 0}function g4b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b)e=Lac()|0;else e=c[b+372>>2]|0;d4b(e,a);i=d;return}function h4b(a,d,e,f,g,h,j,k,l,m){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;n=i;i=i+16|0;o=n;p=csd(c[140466]|0,256)|0;V_b(p,10);c[p+188>>2]=0;c[p+192>>2]=0;c[p+196>>2]=p;c[p+200>>2]=0;q=c[153110]|0;c[p+204>>2]=0;c[p+208>>2]=q;c[p+212>>2]=0;c[p+216>>2]=0;c[p+220>>2]=0;c[p+224>>2]=q;c[p+228>>2]=0;c[p+232>>2]=0;c[p+236>>2]=c[155410];c[p+244>>2]=0;c[p+248>>2]=0;c[p>>2]=561936;q=c[g>>2]|0;b[p+252>>1]=e;c[o>>2]=q;W3b(p,a,d,f,o,h,j,k,l);if(!m){r=Lac()|0;d4b(r,p);i=n;return p|0}else{r=c[m+372>>2]|0;d4b(r,p);i=n;return p|0}return 0}function i4b(a){a=a|0;return c[a+240>>2]|0}function j4b(a){a=a|0;return 1}function k4b(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=c[b+200>>2];return}function l4b(a){a=a|0;return}function m4b(a){a=a|0;return 1<<c[a+240>>2]|0}function n4b(a){a=a|0;return 0}function o4b(a){a=a|0;return}function p4b(a){a=a|0;return (c[a+244>>2]|0)!=0|0}function q4b(a,b){a=a|0;b=b|0;return c[a+248>>2]|0}function r4b(a){a=a|0;return c[a+244>>2]|0}function s4b(a){a=a|0;return b[a+252>>1]|0}function t4b(a){a=a|0;var b=Im;b=ea(g[562088+(a<<2)>>2]);return ea(b)}function u4b(a){a=ea(a);var b=Im;b=ea(ea(25.0)/ea(a*a));return ea(b)}function v4b(a){a=ea(a);var b=0,c=Im,d=Im;b=i;c=ea(ea(1.0)/ea(ea(a*ea(25.0))+ea(1.0)));if(a>=ea(.640000045))if(a>ea(1.0))d=ea(0.0);else d=ea(c*ea(ea(1.0)-ea(ea(a+ea(-.640000045))/ea(.359999955))));else d=c;i=b;return ea(d)}function w4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0;f=i;i=i+16|0;h=f+4|0;j=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];bUb(b,h,e);a[b+28>>0]=1;a[b+29>>0]=0;c[b+32>>2]=0;c[b+36>>2]=0;c[b>>2]=562112;e=b+104|0;g[e>>2]=ea(0.0);g[b+108>>2]=ea(0.0);g[b+112>>2]=ea(0.0);Y9b(b+116|0);c[b+168>>2]=0;c[b+172>>2]=0;a[b+217>>0]=0;c[b+224>>2]=0;g[b+244>>2]=ea(g[150284]);g[b+248>>2]=ea(g[150285]);g[b+252>>2]=ea(g[150286]);g[b+256>>2]=ea(1.0);g[b+260>>2]=ea(g[150300]);g[b+264>>2]=ea(g[150301]);g[b+268>>2]=ea(g[150302]);g[b+272>>2]=ea(1.0);g[b+276>>2]=ea(0.0);g[b+280>>2]=ea(0.0);g[b+284>>2]=ea(0.0);g[b+288>>2]=ea(1.0);g[b+292>>2]=ea(0.0);g[b+296>>2]=ea(0.0);g[b+300>>2]=ea(0.0);c[b+304>>2]=1;a[b+308>>0]=0;c[b+232>>2]=1;c[b+236>>2]=0;c[b+240>>2]=-1;h=b+40|0;b=601008|0;j=h+64|0;do{c[h>>2]=c[b>>2];h=h+4|0;b=b+4|0}while((h|0)<(j|0));c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];i=f;return}function x4b(){var a=0;a=i;QTb(108,554336,1808,0);Ydd(562368,562248,562272);i=a;return}function y4b(){return}function z4b(a,b){a=a|0;b=ea(b);var c=Im,d=Im;c=ea(g[a+184>>2]);d=ea(ea(1.0)/ea(ea(ea(ea(25.0)/ea(c*c))*b)+ea(1.0)));return ea(d)}function A4b(a){a=a|0;var b=0,c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im;b=i;c=(KLc()|0)==1;d=ea(g[a+136>>2]);do if(c){do if(!(d<=ea(.0404499993)))if(d<ea(1.0)){e=ea(+U(+ea(ea(d+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{e=ea(+U(+d,2.20000005));break}else e=ea(d/ea(12.9200001));while(0);f=ea(g[a+140>>2]);do if(!(f<=ea(.0404499993)))if(f<ea(1.0)){h=ea(+U(+ea(ea(f+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{h=ea(+U(+f,2.20000005));break}else h=ea(f/ea(12.9200001));while(0);f=ea(g[a+144>>2]);if(f<=ea(.0404499993)){j=e;k=h;l=ea(f/ea(12.9200001));break}if(f<ea(1.0)){j=e;k=h;l=ea(+U(+ea(ea(f+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{j=e;k=h;l=ea(+U(+f,2.20000005));break}}else{f=ea(g[a+140>>2]);j=d;k=f;l=ea(g[a+144>>2])}while(0);d=ea(g[a+148>>2]);h=ea(g[a+180>>2]);e=ea(k*h);k=ea(l*h);l=ea(d*h);g[a+152>>2]=ea(j*h);g[a+156>>2]=e;g[a+160>>2]=k;g[a+164>>2]=l;l=ea(ea(ea(ea(ea(g[a+188>>2])*ea(.5))/ea(360.0))*ea(2.0))*ea(3.14159274));k=ea(+V(+l));g[a+196>>2]=ea(k/ea(+W(+l)));g[a+200>>2]=ea(ea(1.0)/k);H4b(a);E4b(a);F4b(a);i=b;return}function B4b(b){b=b|0;var d=0;d=i;Y9b(b+116|0);g[b+136>>2]=ea(1.0);g[b+140>>2]=ea(1.0);g[b+144>>2]=ea(1.0);g[b+148>>2]=ea(1.0);g[b+180>>2]=ea(1.0);g[b+184>>2]=ea(10.0);g[b+188>>2]=ea(30.0);g[b+192>>2]=ea(10.0);c[b+208>>2]=4;g[b+196>>2]=ea(3.73205066);g[b+200>>2]=ea(1.03527617);c[b+204>>2]=0;a[b+216>>0]=0;c[b+212>>2]=2;c[b+176>>2]=-1;g[b+220>>2]=ea(1.0);i=d;return}function C4b(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im;b=i;i=i+16|0;d=b+8|0;e=b;f=a+172|0;h=c[f>>2]|0;do if(h){c[e>>2]=h;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=11}else o=11;if((o|0)==11)n=hQb(c[f>>2]|0)|0;j=a+212|0;k=c[j>>2]|0;l=(n|0)!=0;if((k|0)==2&l?(c[n+8>>2]&-2097152|0)!=186646528:0){c[f>>2]=0;p=j;break}if((k|0)!=2&l?(c[n+8>>2]&-2097152|0)==186646528:0){c[f>>2]=0;p=j;break}if((k|0)==0&l?(l=mo[c[(c[n>>2]|0)+108>>2]&4095](n)|0,(l|0)!=(mo[c[(c[n>>2]|0)+104>>2]&4095](n)|0)):0){if(!a)q=0;else q=c[a+4>>2]|0;Krd(562296,0,3653512,165,1,q,0,0);c[f>>2]=0;p=j}else p=j}else p=a+212|0;while(0);f=c[p>>2]|0;if((f|0)<0)r=0;else r=(f|0)>3?3:f;c[p>>2]=r;r=a+208|0;p=c[r>>2]|0;if(!((p&7|0)!=0?(f=p-(p>>>1&1431655765)|0,p=(f>>>2&858993459)+(f&858993459)|0,((da((p>>>4)+p&252645135,16843009)|0)&-16777216|0)==16777216):0))c[r>>2]=4;r=a+184|0;s=ea(g[r>>2]);p=s<ea(0.0);g[r>>2]=p?ea(0.0):s;p=a+188|0;s=ea(g[p>>2]);r=s>ea(179.0);t=r?ea(179.0):s;r=t<ea(1.0);g[p>>2]=r?ea(1.0):t;r=a+192|0;t=ea(g[r>>2]);p=t<ea(0.0);g[r>>2]=p?ea(0.0):t;p=a+128|0;t=ea(g[p>>2]);if(t<ea(0.0))u=ea(0.0);else{r=t>ea(10.0);u=r?ea(10.0):t}g[p>>2]=u;p=a+132|0;u=ea(g[p>>2]);if(u<ea(0.0)){v=ea(0.0);g[p>>2]=v;i=b;return}a=u>ea(3.0);v=a?ea(3.0):u;g[p>>2]=v;i=b;return}function D4b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+80|0;d=b+16|0;e=b;f=BTb(c[a+24>>2]|0)|0;PGc(d,f);g=a+40|0;h=d+0|0;d=g+64|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(d|0));h=a+104|0;rGc(e,f);c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];F5b(z5b()|0,a);E4b(a);F4b(a);i=b;return}function E4b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;d=i;i=i+32|0;e=d+28|0;f=d+16|0;h=d+4|0;j=d;if((((a[b+216>>0]|0)!=0?(k=b+24|0,l=c[k>>2]|0,(l|0)!=0):0)?vTb(l)|0:0)?(a[b+28>>0]|0)!=0:0){m=ea(g[(X8b()|0)+404>>2]);l=b+236|0;if((c[l>>2]|0)==0?(n=h3b(f3b()|0)|0,c[l>>2]=n,(n|0)==0):0){i=d;return}n=f3b()|0;o=c[l>>2]|0;rGc(h,BTb(c[k>>2]|0)|0);p=ea(m*ea(g[b+180>>2]));q=ea(g[b+148>>2]);r=ea(p*q);p=ea(ea(g[b+136>>2])*r);s=ea(r*ea(g[b+140>>2]));t=ea(r*ea(g[b+144>>2]));u=ea(r*q);l=p<ea(0.0);q=l?ea(0.0):p;l=q>ea(1.0);v=~~ea(ea(q*ea(255.0))+ea(.5))>>>0&255;a[j>>0]=l?-1:v;v=s<ea(0.0);q=v?ea(0.0):s;v=q>ea(1.0);l=~~ea(ea(q*ea(255.0))+ea(.5))>>>0&255;a[j+1>>0]=v?-1:l;l=t<ea(0.0);q=l?ea(0.0):t;l=q>ea(1.0);v=~~ea(ea(q*ea(255.0))+ea(.5))>>>0&255;a[j+2>>0]=l?-1:v;v=u<ea(0.0);q=v?ea(0.0):u;v=q>ea(1.0);l=~~ea(ea(q*ea(255.0))+ea(.5))>>>0&255;a[j+3>>0]=v?-1:l;q=ea(m*ea(g[b+184>>2]));l=1<<c[(c[k>>2]|0)+40>>2];c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[e+0>>2]=c[j+0>>2];g3b(n,o,f,e,q,l);i=d;return}l=b+236|0;if(!(c[l>>2]|0)){i=d;return}b=f3b()|0;i3b(b,c[l>>2]|0);c[l>>2]=0;i=d;return}function F4b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im;d=i;i=i+64|0;e=d+56|0;f=d+48|0;h=d+36|0;j=d+24|0;k=d+12|0;l=d;m=b+168|0;n=c[m>>2]|0;do if(n){c[f>>2]=n;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(e,o,f);p=c[e>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[r+4>>2]|0,(o|0)!=0):0)s=o;else t=10}else t=10;if((t|0)==10){o=hQb(c[m>>2]|0)|0;if(!o)break;else s=o}o=b+24|0;p=c[o>>2]|0;if(((p|0)!=0?vTb(p)|0:0)?(a[b+28>>0]|0)!=0:0){g[h>>2]=ea(0.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(0.0);p=(c[b+212>>2]|0)==1;q=BTb(c[o>>2]|0)|0;if(p){g[l>>2]=ea(0.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(1.0);TGc(k,q,l);c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];u=1}else{rGc(j,q);c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];u=0}q=b+240|0;if((c[q>>2]|0)==-1)c[q>>2]=M1b(L1b()|0)|0;p=L1b()|0;v=c[q>>2]|0;w=ea(g[(X8b()|0)+408>>2]);x=ea(g[(X8b()|0)+412>>2]);N1b(p,v,s,h,u,w,b+152|0,x,1<<c[(c[o>>2]|0)+40>>2],6);i=d;return}}while(0);u=b+240|0;if((c[u>>2]|0)==-1){i=d;return}b=L1b()|0;O1b(b,c[u>>2]|0);c[u>>2]=-1;i=d;return}function G4b(a){a=a|0;var b=0,d=0,e=0;b=i;if(c[a+32>>2]|0)G5b(z5b()|0,a);d=a+236|0;if(c[d>>2]|0){e=f3b()|0;i3b(e,c[d>>2]|0);c[d>>2]=0}d=a+240|0;if((c[d>>2]|0)==-1){i=b;return}a=L1b()|0;O1b(a,c[d>>2]|0);c[d>>2]=-1;i=b;return}function H4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b+172|0;h=c[g>>2]|0;if(!h)j=0;else{c[f>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,f);k=c[e>>2]|0;l=c[h+28>>2]|0;if((k|0)==-1){m=l+(c[h+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((m|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[m+4>>2]|0,(h|0)!=0):0)n=h;else o=10}else o=10;if((o|0)==10)n=hQb(c[g>>2]|0)|0;j=n}n=c[b+212>>2]|0;if((n|0)==1){g=b+224|0;if(!j){c[g>>2]=0;c[b+228>>2]=3;c[b+232>>2]=1;i=d;return}else{c[g>>2]=c[j+4>>2];c[b+228>>2]=2;c[b+232>>2]=2;i=d;return}}else if(!n){do if(!j){g=c[b+24>>2]|0;if(!g){p=0;q=b+224|0;break}if(vTb(g)|0?(a[b+28>>0]|0)!=0:0){g=C8b(X8b()|0)|0;h=b+224|0;if(!g){p=0;q=h;break}else{r=h;s=g;o=21;break}}p=0;q=b+224|0}else{r=b+224|0;s=j;o=21}while(0);if((o|0)==21){p=c[s+4>>2]|0;q=r}c[q>>2]=p;c[b+228>>2]=0;c[b+232>>2]=0;i=d;return}else if((n|0)==2){n=b+224|0;if(j){c[n>>2]=c[j+4>>2];c[b+228>>2]=1;c[b+232>>2]=4;i=d;return}j=rvc()|0;if(!j)t=0;else t=c[j+4>>2]|0;c[n>>2]=t;c[b+228>>2]=1;c[b+232>>2]=3;i=d;return}else{i=d;return}}function I4b(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+8|0;f=d;h=ync()|0;j=ea(ea(g[a+152>>2])*b);k=ea(ea(g[a+156>>2])*b);l=ea(ea(g[a+160>>2])*b);m=ea(ea(g[a+164>>2])*b);g[h+548>>2]=j;g[h+552>>2]=k;g[h+556>>2]=l;g[h+560>>2]=m;h=a+224|0;a=c[h>>2]|0;if(!a){i=d;return}c[f>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(e,a,f);n=c[e>>2]|0;o=c[a+28>>2]|0;if((n|0)==-1){p=o+(c[a+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((p|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[p+4>>2]|0,(a|0)!=0):0)q=a;else r=10}else r=10;if((r|0)==10){r=hQb(c[h>>2]|0)|0;if(!r){i=d;return}else q=r}qud((c[158074]|0)+20|0,562064,q)|0;i=d;return}function J4b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(c[158074]|0)+4|0;e=c[d>>2]&-32;f=cFi(1,0,c[a+232>>2]|0)|0;c[d>>2]=f|e;i=b;return}function K4b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im;e=i;i=i+256|0;f=e+24|0;h=e+104|0;j=e+168|0;k=e+232|0;l=e+12|0;m=e;n=e+88|0;o=c[a+228>>2]|0;if((o|0)==1){p=ea(ea(1.0)/ea(g[a+184>>2]));g[l>>2]=p;g[l+4>>2]=p;g[l+8>>2]=p;iMc(f,l)|0;dMc(f,b,d);i=e;return}else if((o|0)==2){p=ea(ea(1.0)/ea(g[a+192>>2]));g[m>>2]=p;g[m+4>>2]=p;g[m+8>>2]=ea(0.0);iMc(f,m)|0;g[n>>2]=ea(.5);g[n+4>>2]=ea(.5);g[n+8>>2]=ea(0.0);kMc(h,n)|0;dMc(h,f,j);dMc(j,b,d);i=e;return}else if(!o){ZLc(j)|0;g[j+44>>2]=ea(ea(2.0)/ea(g[a+196>>2]));g[j+60>>2]=ea(0.0);p=ea(ea(1.0)/ea(g[a+184>>2]));g[k>>2]=p;g[k+4>>2]=p;g[k+8>>2]=p;iMc(f,k)|0;dMc(j,f,h);dMc(h,b,d);i=e;return}else{i=e;return}}function L4b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im;d=i;i=i+80|0;e=d+60|0;f=d+48|0;h=d+36|0;j=d+24|0;k=d+12|0;l=d;m=a+212|0;c[b+60>>2]=c[m>>2];n=BTb(c[a+24>>2]|0)|0;o=c[m>>2]|0;if(!o){rGc(j,n);p=ea(g[j>>2]);q=ea(g[j+4>>2]);r=ea(g[j+8>>2]);g[b>>2]=p;g[b+4>>2]=q;g[b+8>>2]=r;g[b+12>>2]=ea(1.0);g[l>>2]=ea(0.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(1.0);TGc(k,n,l);r=ea(g[k>>2]);q=ea(g[k+4>>2]);p=ea(g[k+8>>2]);g[b+16>>2]=r;g[b+20>>2]=q;g[b+24>>2]=p;g[b+28>>2]=ea(0.0);g[b+56>>2]=ea(g[a+188>>2]);p=ea(g[a+184>>2]);g[b+52>>2]=ea(ea(25.0)/ea(p*p))}else if((o|0)==2){rGc(e,n);p=ea(g[e>>2]);q=ea(g[e+4>>2]);r=ea(g[e+8>>2]);g[b>>2]=p;g[b+4>>2]=q;g[b+8>>2]=r;g[b+12>>2]=ea(1.0);g[b+56>>2]=ea(-1.0);r=ea(g[a+184>>2]);g[b+52>>2]=ea(ea(25.0)/ea(r*r));g[b+16>>2]=ea(1.0);g[b+20>>2]=ea(0.0);g[b+24>>2]=ea(0.0);g[b+28>>2]=ea(0.0)}else if((o|0)==1){g[h>>2]=ea(0.0);g[h+4>>2]=ea(0.0);g[h+8>>2]=ea(1.0);TGc(f,n,h);r=ea(g[f>>2]);q=ea(g[f+4>>2]);p=ea(g[f+8>>2]);g[b>>2]=r;g[b+4>>2]=q;g[b+8>>2]=p;g[b+12>>2]=ea(0.0);g[b+52>>2]=ea(0.0);g[b+56>>2]=ea(-1.0);g[b+16>>2]=ea(1.0);g[b+20>>2]=ea(0.0);g[b+24>>2]=ea(0.0);g[b+28>>2]=ea(0.0)}else if((o|0)!=3)Krd(562624,0,3653512,329,1,c[a+4>>2]|0,0,0);p=ea(g[a+152>>2]);q=ea(g[a+156>>2]);r=ea(g[a+160>>2]);s=ea(g[a+164>>2]);g[b+32>>2]=p;g[b+36>>2]=q;g[b+40>>2]=r;g[b+44>>2]=s;g[b+48>>2]=ea(g[a+184>>2]);i=d;return}function M4b(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=Im,l=Im,m=Im;f=i;h=b+308|0;j=b+244|0;if(!(a[h>>0]|0)){L4b(b,j);a[h>>0]=1}h=ync()|0;k=ea(g[b+152>>2]);l=ea(g[b+156>>2]);m=ea(l*e);l=ea(ea(g[b+160>>2])*e);g[b+276>>2]=ea(k*e);g[b+280>>2]=m;g[b+284>>2]=l;g[b+288>>2]=ea(1.0);co[c[(c[h>>2]|0)+252>>2]&2047](h,d,j);i=f;return}function N4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+80|0;f=e+16|0;g=e;okc(b,d);if((((d&1|0)==0?(a[b+28>>0]|0)!=0:0)?(d=b+24|0,h=c[d>>2]|0,(h|0)!=0):0)?vTb(h)|0:0){h=BTb(c[d>>2]|0)|0;PGc(f,h);d=b+40|0;j=f+0|0;f=d+64|0;do{c[d>>2]=c[j>>2];d=d+4|0;j=j+4|0}while((d|0)<(f|0));j=b+104|0;rGc(g,h);c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2]}a[b+308>>0]=0;A4b(b);i=e;return}function O4b(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+120>>2]|0;if((d|0)!=-1){e=d;i=b;return e|0}d=pyc()|0;e=c[(c[d+24>>2]|0)+((c[d+40>>2]|0)*96|0)+20>>2]|0;i=b;return e|0}function P4b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+212>>2]|0;if(!d)if(!(ea(g[a+184>>2])<ea(.00100000005))?!(ea(g[a+188>>2])<ea(.00100000005)):0)if((d|0)==2)e=5;else f=1;else f=0;else if((d|0)==2)e=5;else f=1;if((e|0)==5)f=!(ea(g[a+184>>2])<ea(9.99999993e-09));i=b;return f|0}function Q4b(){var a=0;a=i;QQb(108,101,102,0,103);i=a;return}function R4b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,562368,5);wQb(108,8,b,312,2608,0,1);xri(b);i=a;return}function S4b(a){a=a|0;return 108}function T4b(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,562368,a,0);c5b(a,b);bdd(b);i=c;return}function U4b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,562368,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else d5b(a,b);sdd(b);i=d;return}function V4b(a,b){a=a|0;b=b|0;var c=0;c=i;e5b(a,b);i=c;return}function W4b(a,b){a=a|0;b=b|0;var c=0;c=i;f5b(a,b);i=c;return}function X4b(a,b){a=a|0;b=b|0;var c=0;c=i;g5b(a,b);i=c;return}function Y4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;Mkc(b,d);f=b+172|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=b+168|0;b=c[g>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[k>>2]|0,c[j>>2]|0)|0;if(!(a[h>>0]|0)){i=e;return}c[k>>2]=g;i=e;return}function Z4b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=0,o=Im;f=i;i=i+32|0;h=f+16|0;j=f;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];k=ea(g[b+8>>2]);l=ea(g[b+12>>2]);m=ea(k*ea(g[h>>2]));g[h>>2]=m;a=h+8|0;g[a>>2]=ea(k*ea(g[a>>2]));a=h+4|0;k=ea(l*ea(g[a>>2]));g[a>>2]=k;n=h+12|0;g[n>>2]=ea(l*ea(g[n>>2]));if(!d){l=ea(g[b>>2]);o=ea(g[b+4>>2]);g[h>>2]=ea(l+m);g[a>>2]=ea(o+k)}n1b(j,h);i1b(e,j);In[c[(c[e>>2]|0)+184>>2]&4095](e,j);i=f;return}function _4b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(a){In[c[(c[d>>2]|0)+184>>2]&4095](d,b);i=e;return}else{ko[c[(c[d>>2]|0)+188>>2]&4095](d);i=e;return}}function $4b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,562072);c[140516]=c[b>>2];i=a;return}function a5b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+80|0;d=e+16|0;f=e;if(!(a[b+29>>0]|0)){g=b+308|0;a[g>>0]=0;i=e;return}h=BTb(c[b+24>>2]|0)|0;PGc(d,h);j=b+40|0;k=d+0|0;d=j+64|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(d|0));k=b+104|0;rGc(f,h);c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];A4b(b);g=b+308|0;a[g>>0]=0;i=e;return}function b5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(312,e,1,16,3653512,28)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];w4b(f,e,b);i=d;return f|0}function c5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;Hkc(a,b);ddd(b,5);f=c[142270]|0;add(b,2346296,f,a+212|0,2048);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+136|0;add(b,2463048,c[142262]|0,j,2048);EYb(j,b);bdd(b);j=c[142268]|0;add(b,562376,j,a+180|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574800,j,a+184|0,2048);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562392,j,a+188|0,2048);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562408,j,a+192|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+116|0;add(b,562424,562608,j,0);j5b(j,b);bdd(b);j=a+172|0;add(b,562440,723608,j,0);k=e+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,f,j,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=c[142290]|0;add(b,792272,j,k,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);k=c[142258]|0;add(b,562456,k,a+216|0,2048);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,562472,k,a+217|0,8388609);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);k=a+168|0;add(b,562496,562592,k,0);f=e+8|0;l=f;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;e=c[142270]|0;add(b,792256,e,k,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,j,f,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,792080,e,a+204|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);f=a+176|0;add(b,562504,614712,f,0);ddd(b,2);add(b,614648,c[142304]|0,f,4194305);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);add(b,562520,e,a+208|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562272,c[142268]|0,a+220|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function d5b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;Ikc(b,d);rdd(d,5);l=b+212|0;m=c[142270]|0;n=qdd(d,2346296,m,f,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=o+p|0;c[n>>2]=q;if((p|0)>=0?(r=o+(p+4)|0,r>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[q>>2];c[n>>2]=r}else Bid(n,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](l,d)|0}sdd(d)}l=b+136|0;n=qdd(d,2463048,c[142262]|0,f,1)|0;if(n){if((n|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](l,d)|0}else HYb(l,d);sdd(d)}l=b+180|0;n=c[142268]|0;r=qdd(d,562376,n,f,0)|0;if(r){if((r|0)>0){r=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=q+p|0;c[r>>2]=o;if((p|0)>=0?(s=q+(p+4)|0,s>>>0<=(c[d+20>>2]|0)>>>0):0){g[l>>2]=ea(g[o>>2]);c[r>>2]=s}else Bid(r,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](l,d)|0}sdd(d)}l=b+184|0;r=qdd(d,574800,n,f,0)|0;if(r){if((r|0)>0){r=d+12|0;s=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=s+o|0;c[r>>2]=p;if((o|0)>=0?(q=s+(o+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){g[l>>2]=ea(g[p>>2]);c[r>>2]=q}else Bid(r,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](l,d)|0}sdd(d)}l=b+188|0;r=qdd(d,562392,n,f,0)|0;if(r){if((r|0)>0){r=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=q+p|0;c[r>>2]=o;if((p|0)>=0?(s=q+(p+4)|0,s>>>0<=(c[d+20>>2]|0)>>>0):0){g[l>>2]=ea(g[o>>2]);c[r>>2]=s}else Bid(r,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](l,d)|0}sdd(d)}if(!(xdd(d,2)|0)){r=b+192|0;s=qdd(d,562408,n,k,0)|0;if(s){if((s|0)>0){s=d+12|0;o=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=o+p|0;c[s>>2]=q;if((p|0)>=0?(t=o+(p+4)|0,t>>>0<=(c[d+20>>2]|0)>>>0):0){g[r>>2]=ea(g[q>>2]);c[s>>2]=t}else Bid(s,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{s=c[k>>2]|0;if(s)_n[s&4095](r,d)|0}sdd(d)}}else g[b+192>>2]=ea(ea(g[l>>2])*ea(2.0));l=b+116|0;r=qdd(d,562424,562608,h,1)|0;if(r){if((r|0)>0){r=qdd(d,2346296,m,f,0)|0;if(r){if((r|0)>0){r=d+12|0;s=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;t=s+k|0;c[r>>2]=t;if((k|0)>=0?(q=s+(k+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[t>>2];c[r>>2]=q}else Bid(r,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](l,d)|0}sdd(d)}r=b+120|0;q=qdd(d,562536,m,f,0)|0;if(q){if((q|0)>0){q=d+12|0;t=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=t+k|0;c[q>>2]=s;if((k|0)>=0?(p=t+(k+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[r>>2]=c[s>>2];c[q>>2]=p}else Bid(q,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{q=c[f>>2]|0;if(q)_n[q&4095](r,d)|0}sdd(d)}r=b+124|0;q=qdd(d,562552,n,f,0)|0;if(q){if((q|0)>0){q=d+12|0;p=c[d+16>>2]|0;s=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=p+s|0;c[q>>2]=k;if((s|0)>=0?(t=p+(s+4)|0,t>>>0<=(c[d+20>>2]|0)>>>0):0){g[r>>2]=ea(g[k>>2]);c[q>>2]=t}else Bid(q,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{q=c[f>>2]|0;if(q)_n[q&4095](r,d)|0}sdd(d)}r=b+128|0;q=qdd(d,562568,n,f,0)|0;if(q){if((q|0)>0){q=d+12|0;t=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=t+k|0;c[q>>2]=s;if((k|0)>=0?(p=t+(k+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){g[r>>2]=ea(g[s>>2]);c[q>>2]=p}else Bid(q,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{q=c[f>>2]|0;if(q)_n[q&4095](r,d)|0}sdd(d)}r=b+132|0;q=qdd(d,562576,n,f,0)|0;if(q){if((q|0)>0){q=d+12|0;p=c[d+16>>2]|0;s=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=p+s|0;c[q>>2]=k;if((s|0)>=0?(t=p+(s+4)|0,t>>>0<=(c[d+20>>2]|0)>>>0):0){g[r>>2]=ea(g[k>>2]);c[q>>2]=t}else Bid(q,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{q=c[f>>2]|0;if(q)_n[q&4095](r,d)|0}sdd(d)}}else{r=c[h>>2]|0;if(r)_n[r&4095](l,d)|0}sdd(d)}l=b+172|0;r=qdd(d,562440,723608,h,1)|0;if(r){if((r|0)<=0){r=c[h>>2]|0;if(r)_n[r&4095](l,d)|0}else GYb(l,d);sdd(d)}l=b+216|0;r=c[142258]|0;q=qdd(d,562456,r,h,0)|0;if(q){do if((q|0)<=0){f=c[h>>2]|0;if(f)_n[f&4095](l,d)|0}else{f=d+12|0;t=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=t+k|0;c[f>>2]=s;if((k|0)>=0?(t+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[s>>0]|0;c[f>>2]=(c[f>>2]|0)+1;break}Bid(f,l,1)}while(0);sdd(d)}l=b+217|0;q=qdd(d,562472,r,h,0)|0;if(q){do if((q|0)<=0){r=c[h>>2]|0;if(r)_n[r&4095](l,d)|0}else{r=d+12|0;f=c[d+16>>2]|0;s=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=f+s|0;c[r>>2]=k;if((s|0)>=0?(f+(s+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[k>>0]|0;c[r>>2]=(c[r>>2]|0)+1;break}Bid(r,l,1)}while(0);sdd(d)}l=b+168|0;q=qdd(d,562496,562592,h,1)|0;if(q){if((q|0)<=0){q=c[h>>2]|0;if(q)_n[q&4095](l,d)|0}else e2b(l,d);sdd(d)}l=b+204|0;q=qdd(d,792080,m,h,0)|0;if(q){if((q|0)>0){q=d+12|0;r=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=r+k|0;c[q>>2]=s;if((k|0)>=0?(f=r+(k+4)|0,f>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[s>>2];c[q>>2]=f}else Bid(q,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](l,d)|0}sdd(d)}l=b+176|0;q=qdd(d,562504,614712,j,1)|0;if(q){if((q|0)>0){rdd(d,2);q=qdd(d,614648,c[142304]|0,h,0)|0;if(q){do if((q|0)>0){f=d+12|0;s=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=s+k|0;c[f>>2]=r;do if((k|0)<0)u=172;else{t=s+(k+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){u=172;break}c[l>>2]=c[r>>2];c[f>>2]=t}while(0);if((u|0)==172)Bid(f,l,4);if(!(c[d>>2]&512))break;c[l>>2]=XEi(c[l>>2]|0)|0}else{r=c[h>>2]|0;if(!r)break;_n[r&4095](l,d)|0}while(0);sdd(d)}if(wdd(d,1)|0?(u=c[l>>2]|0,(u&32|0)!=0):0)c[l>>2]=u|-65536}else{u=c[j>>2]|0;if(u)_n[u&4095](l,d)|0}sdd(d)}l=b+208|0;u=qdd(d,562520,m,h,0)|0;if(u){if((u|0)>0){u=d+12|0;m=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+j|0;c[u>>2]=q;if((j|0)>=0?(r=m+(j+4)|0,r>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[q>>2];c[u>>2]=r}else Bid(u,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{u=c[h>>2]|0;if(u)_n[u&4095](l,d)|0}sdd(d)}l=b+220|0;b=qdd(d,562272,n,h,0)|0;if(!b){i=e;return}if((b|0)>0){b=d+12|0;n=c[d+16>>2]|0;u=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=n+u|0;c[b>>2]=r;if((u|0)>=0?(q=n+(u+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){g[l>>2]=ea(g[r>>2]);c[b>>2]=q}else Bid(b,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{b=c[h>>2]|0;if(b)_n[b&4095](l,d)|0}sdd(d);i=e;return}function e5b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;Jkc(b,d);f=b+212|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;if(k>>>0>(c[l>>2]|0)>>>0)Bid(h,f,4);else{c[f>>2]=c[j>>2];c[h>>2]=k}JYb(b+136|0,d);k=b+180|0;j=c[h>>2]|0;f=j+4|0;m=c[l>>2]|0;if(f>>>0>m>>>0){Bid(h,k,4);n=c[h>>2]|0;o=c[l>>2]|0}else{g[k>>2]=ea(g[j>>2]);c[h>>2]=f;n=f;o=m}m=b+184|0;f=n+4|0;if(f>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[h>>2]=f;p=f;q=o}o=b+188|0;f=p+4|0;if(f>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[h>>2]=f;r=f;s=q}q=b+192|0;f=r+4|0;if(f>>>0>s>>>0)Bid(h,q,4);else{g[q>>2]=ea(g[r>>2]);c[h>>2]=f}k5b(b+116|0,d);IYb(b+172|0,d);f=b+216|0;r=c[h>>2]|0;if((r+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,f,1);t=c[h>>2]|0}else{a[f>>0]=a[r>>0]|0;r=(c[h>>2]|0)+1|0;c[h>>2]=r;t=r}r=b+217|0;if((t+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,r,1);else{a[r>>0]=a[t>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);f2b(b+168|0,d);d=b+204|0;t=c[h>>2]|0;r=t+4|0;f=c[l>>2]|0;if(r>>>0>f>>>0){Bid(h,d,4);u=c[h>>2]|0;v=c[l>>2]|0}else{c[d>>2]=c[t>>2];c[h>>2]=r;u=r;v=f}f=b+176|0;r=u+4|0;if(r>>>0>v>>>0){Bid(h,f,4);w=c[h>>2]|0;x=c[l>>2]|0}else{c[f>>2]=c[u>>2];c[h>>2]=r;w=r;x=v}v=b+208|0;r=w+4|0;if(r>>>0>x>>>0){Bid(h,v,4);y=c[h>>2]|0;z=c[l>>2]|0}else{c[v>>2]=c[w>>2];c[h>>2]=r;y=r;z=x}x=b+220|0;b=y+4|0;if(b>>>0>z>>>0){Bid(h,x,4);i=e;return}else{g[x>>2]=ea(g[y>>2]);c[h>>2]=b;i=e;return}}function f5b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;Kkc(b,d);f=b+212|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;if(l>>>0>(c[m>>2]|0)>>>0){Bid(h,f,4);n=c[f>>2]|0}else{o=c[j>>2]|0;c[f>>2]=o;c[h>>2]=l;n=o}c[f>>2]=XEi(n|0)|0;MYb(b+136|0,d);n=b+180|0;f=c[h>>2]|0;o=f+4|0;l=c[m>>2]|0;if(o>>>0>l>>>0){Bid(h,n,4);p=n;q=c[n>>2]|0;r=c[h>>2]|0;s=c[m>>2]|0}else{t=ea(g[f>>2]);g[n>>2]=t;c[h>>2]=o;p=n;q=(g[k>>2]=t,c[k>>2]|0);r=o;s=l}c[p>>2]=XEi(q|0)|0;q=b+184|0;p=r+4|0;if(p>>>0>s>>>0){Bid(h,q,4);u=q;v=c[q>>2]|0;w=c[h>>2]|0;x=c[m>>2]|0}else{t=ea(g[r>>2]);g[q>>2]=t;c[h>>2]=p;u=q;v=(g[k>>2]=t,c[k>>2]|0);w=p;x=s}c[u>>2]=XEi(v|0)|0;v=b+188|0;u=w+4|0;if(u>>>0>x>>>0){Bid(h,v,4);y=v;z=c[v>>2]|0;A=c[h>>2]|0;B=c[m>>2]|0}else{t=ea(g[w>>2]);g[v>>2]=t;c[h>>2]=u;y=v;z=(g[k>>2]=t,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=b+192|0;y=A+4|0;if(y>>>0>B>>>0){Bid(h,z,4);C=z;D=c[z>>2]|0}else{t=ea(g[A>>2]);g[z>>2]=t;c[h>>2]=y;C=z;D=(g[k>>2]=t,c[k>>2]|0)}c[C>>2]=XEi(D|0)|0;l5b(b+116|0,d);LYb(b+172|0,d);D=b+216|0;C=c[h>>2]|0;if((C+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(h,D,1);E=c[h>>2]|0}else{a[D>>0]=a[C>>0]|0;C=(c[h>>2]|0)+1|0;c[h>>2]=C;E=C}C=b+217|0;if((E+1|0)>>>0>(c[m>>2]|0)>>>0)Bid(h,C,1);else{a[C>>0]=a[E>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);g2b(b+168|0,d);d=b+204|0;E=c[h>>2]|0;C=E+4|0;D=c[m>>2]|0;if(C>>>0>D>>>0){Bid(h,d,4);F=c[d>>2]|0;G=c[h>>2]|0;H=c[m>>2]|0}else{z=c[E>>2]|0;c[d>>2]=z;c[h>>2]=C;F=z;G=C;H=D}c[d>>2]=XEi(F|0)|0;F=b+176|0;d=G+4|0;if(d>>>0>H>>>0){Bid(h,F,4);I=c[F>>2]|0;J=c[h>>2]|0;K=c[m>>2]|0}else{D=c[G>>2]|0;c[F>>2]=D;c[h>>2]=d;I=D;J=d;K=H}c[F>>2]=XEi(I|0)|0;I=b+208|0;F=J+4|0;if(F>>>0>K>>>0){Bid(h,I,4);L=c[I>>2]|0;M=c[h>>2]|0;N=c[m>>2]|0}else{m=c[J>>2]|0;c[I>>2]=m;c[h>>2]=F;L=m;M=F;N=K}c[I>>2]=XEi(L|0)|0;L=b+220|0;b=M+4|0;if(b>>>0>N>>>0){Bid(h,L,4);O=L;P=c[L>>2]|0;Q=XEi(P|0)|0;c[O>>2]=Q;i=e;return}else{t=ea(g[M>>2]);g[L>>2]=t;c[h>>2]=b;O=L;P=(g[k>>2]=t,c[k>>2]|0);Q=XEi(P|0)|0;c[O>>2]=Q;i=e;return}}function g5b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;Lkc(b,d);f=b+212|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=c[f>>2];c[h>>2]=k}else Gid(h,f,4);PYb(b+136|0,d);f=b+180|0;k=c[h>>2]|0;j=k+4|0;m=c[l>>2]|0;if(j>>>0<m>>>0){g[k>>2]=ea(g[f>>2]);c[h>>2]=j;n=j;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=b+184|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[f>>2]);c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=b+188|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[f>>2]);c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=b+192|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[f>>2]);c[h>>2]=q}else Gid(h,f,4);m5b(b+116|0,d);OYb(b+172|0,d);f=b+216|0;q=c[h>>2]|0;if((q+1|0)>>>0<(c[l>>2]|0)>>>0){a[q>>0]=a[f>>0]|0;q=(c[h>>2]|0)+1|0;c[h>>2]=q;t=q}else{Gid(h,f,1);t=c[h>>2]|0}f=b+217|0;if((t+1|0)>>>0<(c[l>>2]|0)>>>0){a[t>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);h2b(b+168|0,d);d=b+204|0;f=c[h>>2]|0;t=f+4|0;q=c[l>>2]|0;if(t>>>0<q>>>0){c[f>>2]=c[d>>2];c[h>>2]=t;u=t;v=q}else{Gid(h,d,4);u=c[h>>2]|0;v=c[l>>2]|0}d=b+176|0;q=u+4|0;if(q>>>0<v>>>0){c[u>>2]=c[d>>2];c[h>>2]=q;w=q;x=v}else{Gid(h,d,4);w=c[h>>2]|0;x=c[l>>2]|0}d=b+208|0;v=w+4|0;if(v>>>0<x>>>0){c[w>>2]=c[d>>2];c[h>>2]=v;y=v;z=x}else{Gid(h,d,4);y=c[h>>2]|0;z=c[l>>2]|0}l=b+220|0;b=y+4|0;if(b>>>0<z>>>0){g[y>>2]=ea(g[l>>2]);c[h>>2]=b;i=e;return}else{Gid(h,l,4);i=e;return}}function h5b(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);i=b;return}function i5b(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);ACi(a);i=b;return}function j5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142270]|0;add(b,2346296,e,a,2048);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562536,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142268]|0;add(b,562552,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562568,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562576,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function k5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{c[a>>2]=c[f>>2];c[e>>2]=h;k=b;l=h}h=a+4|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{c[h>>2]=c[l>>2];c[e>>2]=b;m=b;n=k}k=a+8|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[j>>2]|0}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=b;q=b;r=p}p=a+16|0;a=q+4|0;if(a>>>0>r>>>0){Bid(e,p,4);i=d;return}else{g[p>>2]=ea(g[q>>2]);c[e>>2]=a;i=d;return}}function l5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=c[e>>2]|0;m=c[j>>2]|0;n=c[a>>2]|0}else{o=c[f>>2]|0;c[a>>2]=o;c[e>>2]=h;l=h;m=b;n=o}c[a>>2]=XEi(n|0)|0;n=a+4|0;o=l+4|0;if(o>>>0>m>>>0){Bid(e,n,4);p=c[n>>2]|0;q=c[e>>2]|0;r=c[j>>2]|0}else{b=c[l>>2]|0;c[n>>2]=b;c[e>>2]=o;p=b;q=o;r=m}c[n>>2]=XEi(p|0)|0;p=a+8|0;n=q+4|0;if(n>>>0>r>>>0){Bid(e,p,4);s=p;t=c[p>>2]|0;u=c[e>>2]|0;v=c[j>>2]|0}else{w=ea(g[q>>2]);g[p>>2]=w;c[e>>2]=n;s=p;t=(g[k>>2]=w,c[k>>2]|0);u=n;v=r}c[s>>2]=XEi(t|0)|0;t=a+12|0;s=u+4|0;if(s>>>0>v>>>0){Bid(e,t,4);x=t;y=c[t>>2]|0;z=c[e>>2]|0;A=c[j>>2]|0}else{w=ea(g[u>>2]);g[t>>2]=w;c[e>>2]=s;x=t;y=(g[k>>2]=w,c[k>>2]|0);z=s;A=v}c[x>>2]=XEi(y|0)|0;y=a+16|0;a=z+4|0;if(a>>>0>A>>>0){Bid(e,y,4);B=y;C=c[y>>2]|0;D=XEi(C|0)|0;c[B>>2]=D;i=d;return}else{w=ea(g[z>>2]);g[y>>2]=w;c[e>>2]=a;B=y;C=(g[k>>2]=w,c[k>>2]|0);D=XEi(C|0)|0;c[B>>2]=D;i=d;return}}function m5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){c[f>>2]=c[a>>2];c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){c[l>>2]=c[h>>2];c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+12|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}j=a+16|0;a=q+4|0;if(a>>>0<r>>>0){g[q>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function n5b(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;i=i+16|0;l=k+4|0;m=k;n=e+8|0;if(!(c[n>>2]|0)){i=k;return}c[m>>2]=c[153136];c[l+0>>2]=c[m+0>>2];m=bOb(284,l,0,16,3653512,153)|0;c[m>>2]=d;c[m+4>>2]=c[e>>2];c[m+8>>2]=c[f>>2];c[m+12>>2]=g;c[m+16>>2]=h;c[m+20>>2]=c[j>>2];j=znd(m+24|0,c[n>>2]|0,16)|0;c[m+280>>2]=j;Knd(a,2658,m,j,b,3499,0);i=k;return}function o5b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+64|0;h=f+56|0;j=f+48|0;k=f+24|0;l=f;m=e+40|0;a[m>>0]=0;n=(d|0)==0;if(!n){o=ea(-1.0);p=0;q=-1;while(1){r=c[b+(p<<2)>>2]|0;s=ea(ea(g[r+136>>2])*ea(.300000012));t=ea(s+ea(ea(g[r+140>>2])*ea(.589999974)));s=ea(t+ea(ea(g[r+144>>2])*ea(.109999999)));t=ea(ea(g[r+180>>2])*s);if(!(c[r+116>>2]|0))u=t;else u=ea(t*ea(16.0));v=u>o?(c[r+204>>2]|0)!=2:0;r=v?p:q;p=p+1|0;if((p|0)==(d|0)){w=r;break}else{o=v?u:o;q=r}}if((w|0)!=-1){q=c[b+(w<<2)>>2]|0;p=w5b(e)|0;c[p>>2]=q;a[p+8>>0]=1;r=p+24|0;v=k+12|0;c[k+0>>2]=c[150284];c[k+4>>2]=c[150285];c[k+8>>2]=c[150286];c[v+0>>2]=c[150280];c[v+4>>2]=c[150281];c[v+8>>2]=c[150282];c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];c[r+12>>2]=c[k+12>>2];c[r+16>>2]=c[k+16>>2];c[r+20>>2]=c[k+20>>2];r=q+212|0;if((c[r>>2]|0)!=3)if(!(a[q+217>>0]|0))x=0;else x=(c[q+208>>2]|0)==1?1:2;else x=2;c[p+12>>2]=x;a[p+9>>0]=1;g[p+48>>2]=ea(0.0);g[p+52>>2]=ea(0.0);g[p+56>>2]=ea(1.0);g[p+60>>2]=ea(1.0);c[p+16>>2]=c[q+176>>2];x=q+172|0;v=c[x>>2]|0;if(!v)y=0;else{c[j>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(h,v,j);z=c[h>>2]|0;A=c[v+28>>2]|0;if((z|0)==-1){B=A+(c[v+32>>2]<<3)|0;break}else{B=A+(z<<3)|0;break}}else B=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((B|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[B+4>>2]|0,(v|0)!=0):0)C=v;else D=18}else D=18;if((D|0)==18)C=hQb(c[x>>2]|0)|0;y=(C|0)!=0&1}a[p+64>>0]=y;c[p+68>>2]=c[q+204>>2];c[p+72>>2]=c[r>>2];a[p+100>>0]=0;g[p+104>>2]=ea(1.0);o=ea(ea(g[q+136>>2])*ea(.300000012));u=ea(o+ea(ea(g[q+140>>2])*ea(.589999974)));o=ea(u+ea(ea(g[q+144>>2])*ea(.109999999)));g[p+96>>2]=ea(ea(g[q+180>>2])*o);a[e+16>>0]=1;E=w}else D=21}else D=21;if((D|0)==21){a[e+16>>0]=0;E=-1}if(n){F=e+8|0;G=c[F>>2]|0;H=e+20|0;c[H>>2]=G;i=f;return}n=l+12|0;w=0;do{q=c[b+(w<<2)>>2]|0;if(c[q+116>>2]|0)a[m>>0]=1;if((w|0)!=(E|0)){p=w5b(e)|0;c[p>>2]=q;a[p+8>>0]=1;r=p+24|0;c[l+0>>2]=c[150284];c[l+4>>2]=c[150285];c[l+8>>2]=c[150286];c[n+0>>2]=c[150280];c[n+4>>2]=c[150281];c[n+8>>2]=c[150282];c[r+0>>2]=c[l+0>>2];c[r+4>>2]=c[l+4>>2];c[r+8>>2]=c[l+8>>2];c[r+12>>2]=c[l+12>>2];c[r+16>>2]=c[l+16>>2];c[r+20>>2]=c[l+20>>2];r=q+212|0;if((c[r>>2]|0)!=3)if(!(a[q+217>>0]|0))I=0;else I=(c[q+208>>2]|0)==1?1:2;else I=2;c[p+12>>2]=I;a[p+9>>0]=1;g[p+48>>2]=ea(0.0);g[p+52>>2]=ea(0.0);g[p+56>>2]=ea(1.0);g[p+60>>2]=ea(1.0);c[p+16>>2]=c[q+176>>2];y=q+172|0;C=c[y>>2]|0;if(!C)J=0;else{c[k>>2]=C;C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(h,C,k);x=c[h>>2]|0;v=c[C+28>>2]|0;if((x|0)==-1){K=v+(c[C+32>>2]<<3)|0;break}else{K=v+(x<<3)|0;break}}else K=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((K|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[K+4>>2]|0,(C|0)!=0):0)L=C;else D=39}else D=39;if((D|0)==39){D=0;L=hQb(c[y>>2]|0)|0}J=(L|0)!=0&1}a[p+64>>0]=J;c[p+68>>2]=c[q+204>>2];c[p+72>>2]=c[r>>2];a[p+100>>0]=0;g[p+104>>2]=ea(1.0);o=ea(ea(g[q+136>>2])*ea(.300000012));u=ea(o+ea(ea(g[q+140>>2])*ea(.589999974)));o=ea(u+ea(ea(g[q+144>>2])*ea(.109999999)));g[p+96>>2]=ea(ea(g[q+180>>2])*o)}w=w+1|0}while((w|0)!=(d|0));F=e+8|0;G=c[F>>2]|0;H=e+20|0;c[H>>2]=G;i=f;return}function p5b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0;h=i;i=i+432|0;j=h+424|0;k=h+136|0;l=h+40|0;m=h+24|0;n=h;o=ea(g[e+48>>2]);p=ea(g[e+52>>2]);q=ea(g[e+56>>2]);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(0.0);g[k+36>>2]=ea(0.0);g[k+40>>2]=ea(0.0);g[k+44>>2]=ea(0.0);g[k+48>>2]=ea(0.0);g[k+52>>2]=ea(0.0);g[k+56>>2]=ea(0.0);g[k+60>>2]=ea(0.0);g[k+64>>2]=ea(0.0);g[k+68>>2]=ea(0.0);g[k+72>>2]=ea(0.0);g[k+76>>2]=ea(0.0);g[k+80>>2]=ea(0.0);g[k+84>>2]=ea(0.0);g[k+88>>2]=ea(0.0);g[k+92>>2]=ea(0.0);g[k+96>>2]=ea(0.0);g[k+100>>2]=ea(0.0);g[k+104>>2]=ea(0.0);g[k+108>>2]=ea(0.0);g[k+112>>2]=ea(0.0);g[k+116>>2]=ea(0.0);g[k+120>>2]=ea(0.0);g[k+124>>2]=ea(0.0);g[k+128>>2]=ea(0.0);g[k+132>>2]=ea(0.0);g[k+136>>2]=ea(0.0);g[k+140>>2]=ea(0.0);g[k+144>>2]=ea(0.0);g[k+148>>2]=ea(0.0);g[k+152>>2]=ea(0.0);g[k+156>>2]=ea(0.0);g[k+160>>2]=ea(0.0);g[k+164>>2]=ea(0.0);g[k+168>>2]=ea(0.0);g[k+172>>2]=ea(0.0);g[k+176>>2]=ea(0.0);g[k+180>>2]=ea(0.0);g[k+184>>2]=ea(0.0);g[k+188>>2]=ea(0.0);g[k+192>>2]=ea(0.0);g[k+196>>2]=ea(0.0);g[k+200>>2]=ea(0.0);g[k+204>>2]=ea(0.0);g[k+208>>2]=ea(0.0);g[k+212>>2]=ea(0.0);g[k+216>>2]=ea(0.0);g[k+220>>2]=ea(0.0);g[k+224>>2]=ea(0.0);g[k+228>>2]=ea(0.0);g[k+232>>2]=ea(0.0);g[k+236>>2]=ea(0.0);g[k+240>>2]=ea(0.0);g[k+244>>2]=ea(0.0);g[k+248>>2]=ea(0.0);g[k+252>>2]=ea(0.0);g[k+256>>2]=ea(0.0);g[k+260>>2]=ea(0.0);g[k+264>>2]=ea(0.0);g[k+268>>2]=ea(0.0);g[k+272>>2]=ea(0.0);g[k+276>>2]=ea(0.0);g[k+280>>2]=ea(0.0);g[k+284>>2]=ea(0.0);r=c[d+212>>2]|0;if(!r){s=d+184|0;t=l+0|0;u=t+60|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));v=ea(g[s>>2]);fmc(v,ea(g[d+196>>2]),e,l);a[j>>0]=4;e=j+1|0;s=l+48|0;a[e>>0]=3;a[e+1>>0]=3;a[e+2>>0]=3;a[e+3>>0]=3;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];e=k+12|0;t=l+36|0;c[e+0>>2]=c[t+0>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];e=k+24|0;u=l+24|0;c[e+0>>2]=c[u+0>>2];c[e+4>>2]=c[u+4>>2];c[e+8>>2]=c[u+8>>2];e=k+36|0;w=l+12|0;c[e+0>>2]=c[w+0>>2];c[e+4>>2]=c[w+4>>2];c[e+8>>2]=c[w+8>>2];e=k+48|0;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];e=k+60|0;c[e+0>>2]=c[w+0>>2];c[e+4>>2]=c[w+4>>2];c[e+8>>2]=c[w+8>>2];e=k+72|0;c[e+0>>2]=c[u+0>>2];c[e+4>>2]=c[u+4>>2];c[e+8>>2]=c[u+8>>2];e=k+84|0;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];e=k+96|0;c[e+0>>2]=c[u+0>>2];c[e+4>>2]=c[u+4>>2];c[e+8>>2]=c[u+8>>2];u=k+108|0;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];u=k+120|0;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];u=k+132|0;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];t=k+144|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];t=k+156|0;c[t+0>>2]=c[l+0>>2];c[t+4>>2]=c[l+4>>2];c[t+8>>2]=c[l+8>>2];t=k+168|0;c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];s=k+180|0;c[s+0>>2]=c[w+0>>2];c[s+4>>2]=c[w+4>>2];c[s+8>>2]=c[w+8>>2];x=j;y=5}else if((r|0)==2){v=ea(g[d+184>>2]);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=ea(o-v);A=ea(p-v);B=ea(q-v);g[l>>2]=z;g[l+4>>2]=A;g[l+8>>2]=B;d=l+12|0;C=ea(o+v);g[d>>2]=C;g[l+16>>2]=A;g[l+20>>2]=B;r=l+24|0;o=ea(p+v);g[r>>2]=C;g[l+28>>2]=o;g[l+32>>2]=B;w=l+36|0;g[w>>2]=z;g[l+40>>2]=o;g[l+44>>2]=B;s=l+48|0;B=ea(q+v);g[s>>2]=z;g[l+52>>2]=A;g[l+56>>2]=B;t=l+60|0;g[t>>2]=C;g[l+64>>2]=A;g[l+68>>2]=B;u=l+72|0;g[u>>2]=C;g[l+76>>2]=o;g[l+80>>2]=B;e=l+84|0;g[e>>2]=z;g[l+88>>2]=o;g[l+92>>2]=B;a[j+0>>0]=4;a[j+1>>0]=4;a[j+2>>0]=4;a[j+3>>0]=4;a[j+4>>0]=4;a[j+5>>0]=4;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];D=k+12|0;c[D+0>>2]=c[d+0>>2];c[D+4>>2]=c[d+4>>2];c[D+8>>2]=c[d+8>>2];D=k+24|0;c[D+0>>2]=c[r+0>>2];c[D+4>>2]=c[r+4>>2];c[D+8>>2]=c[r+8>>2];D=k+36|0;c[D+0>>2]=c[w+0>>2];c[D+4>>2]=c[w+4>>2];c[D+8>>2]=c[w+8>>2];D=k+48|0;c[D+0>>2]=c[e+0>>2];c[D+4>>2]=c[e+4>>2];c[D+8>>2]=c[e+8>>2];D=k+60|0;c[D+0>>2]=c[u+0>>2];c[D+4>>2]=c[u+4>>2];c[D+8>>2]=c[u+8>>2];D=k+72|0;c[D+0>>2]=c[t+0>>2];c[D+4>>2]=c[t+4>>2];c[D+8>>2]=c[t+8>>2];D=k+84|0;c[D+0>>2]=c[s+0>>2];c[D+4>>2]=c[s+4>>2];c[D+8>>2]=c[s+8>>2];D=k+96|0;c[D+0>>2]=c[l+0>>2];c[D+4>>2]=c[l+4>>2];c[D+8>>2]=c[l+8>>2];D=k+108|0;c[D+0>>2]=c[w+0>>2];c[D+4>>2]=c[w+4>>2];c[D+8>>2]=c[w+8>>2];D=k+120|0;c[D+0>>2]=c[e+0>>2];c[D+4>>2]=c[e+4>>2];c[D+8>>2]=c[e+8>>2];D=k+132|0;c[D+0>>2]=c[s+0>>2];c[D+4>>2]=c[s+4>>2];c[D+8>>2]=c[s+8>>2];D=k+144|0;c[D+0>>2]=c[d+0>>2];c[D+4>>2]=c[d+4>>2];c[D+8>>2]=c[d+8>>2];D=k+156|0;c[D+0>>2]=c[t+0>>2];c[D+4>>2]=c[t+4>>2];c[D+8>>2]=c[t+8>>2];D=k+168|0;c[D+0>>2]=c[u+0>>2];c[D+4>>2]=c[u+4>>2];c[D+8>>2]=c[u+8>>2];D=k+180|0;c[D+0>>2]=c[r+0>>2];c[D+4>>2]=c[r+4>>2];c[D+8>>2]=c[r+8>>2];D=k+192|0;c[D+0>>2]=c[s+0>>2];c[D+4>>2]=c[s+4>>2];c[D+8>>2]=c[s+8>>2];s=k+204|0;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];t=k+216|0;c[t+0>>2]=c[d+0>>2];c[t+4>>2]=c[d+4>>2];c[t+8>>2]=c[d+8>>2];d=k+228|0;c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];l=k+240|0;c[l+0>>2]=c[u+0>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];u=k+252|0;c[u+0>>2]=c[e+0>>2];c[u+4>>2]=c[e+4>>2];c[u+8>>2]=c[e+8>>2];e=k+264|0;c[e+0>>2]=c[w+0>>2];c[e+4>>2]=c[w+4>>2];c[e+8>>2]=c[w+8>>2];w=k+276|0;c[w+0>>2]=c[r+0>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];x=j;y=6}else{x=j;y=0}g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);j=b+208|0;B=ea(g[b+584>>2]);o=ea(g[j>>2]);z=ea(B*o);C=ea(g[b+212>>2]);A=ea(B*C);v=ea(g[b+216>>2]);q=ea(B*v);B=ea(z+ea(g[b+196>>2]));z=ea(A+ea(g[b+200>>2]));A=ea(q+ea(g[b+204>>2]));c[m+0>>2]=c[j+0>>2];c[m+4>>2]=c[j+4>>2];c[m+8>>2]=c[j+8>>2];q=ea(ea(ea(B*o)+ea(z*C))+ea(A*v));v=ea(-q);j=q>ea(-0.0);g[m+12>>2]=ea(v-ea((j?q:v)*ea(.0000999999974)));j=n+12|0;r=n+16|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+0>>2]=c[150280];c[n+4>>2]=c[150281];c[n+8>>2]=c[150282];v=ea(-ea(g[150280]));q=ea(-ea(g[150281]));A=ea(-ea(g[150282]));g[j>>2]=v;g[r>>2]=q;g[n+20>>2]=A;bmc(k,x,y,m,b+132|0,n);A=ea(g[n>>2]);q=ea(ea(A+ea(1.0))*ea(.5));v=ea(g[n+4>>2]);C=ea(ea(v+ea(1.0))*ea(.5));z=ea(g[j>>2]);o=ea(ea(z-A)*ea(.5));B=ea(g[r>>2]);p=ea(ea(B-v)*ea(.5));g[f>>2]=q;g[f+8>>2]=o;g[f+4>>2]=C;g[f+12>>2]=p;if(z>A){E=1;i=h;return E|0}E=B>v;i=h;return E|0}function q5b(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,da=0,fa=0,ga=0;l=i;i=i+384|0;m=l+280|0;n=l+72|0;o=l;p=l+216|0;q=l+360|0;r=l+8|0;s=l+136|0;t=l+296|0;u=l+200|0;v=c[j+4>>2]|0;w=o;c[w>>2]=0;c[w+4>>2]=0;w=f+4|0;x=q+8|0;y=q+12|0;if((c[w>>2]|0)>0){z=0;A=0;B=v;while(1){C=c[(c[f>>2]|0)+(A<<2)>>2]|0;D=e+(C<<2)|0;E=c[D>>2]|0;do if(!(c[E+212>>2]|0)){QGc(p,BTb(c[E+24>>2]|0)|0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;if(!(p5b(b,c[D>>2]|0,p,q)|0)){g[h+(B<<2)>>2]=ea(1.0);c[(c[j>>2]|0)+(B<<2)>>2]=C;F=z;G=B+1|0;break}H=!(ea(g[x>>2])<=ea(9.99999974e-06));if(H&!(ea(g[y>>2])<=ea(9.99999974e-06))){H=c[D>>2]|0;I=r+0|0;J=p+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));L=d+(C<<4)|0;M=w5b(k)|0;I=n+0|0;J=r+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];c[m+12>>2]=c[q+12>>2];x5b(a,b,H,n,L,m,1,ea(1.0),C,M);N=z+1|0;c[o>>2]=N;F=N;G=B}else{F=z;G=B}}else{F=z;G=B}while(0);A=A+1|0;C=c[w>>2]|0;if((A|0)>=(C|0)){O=F;P=C;Q=G;break}else{z=F;B=G}}if((P|0)>0){P=o+4|0;G=0;B=0;F=Q;while(1){z=c[(c[f>>2]|0)+(B<<2)>>2]|0;A=e+(z<<2)|0;C=c[A>>2]|0;do if((c[C+212>>2]|0)==2){QGc(p,BTb(c[C+24>>2]|0)|0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;if(!(p5b(b,c[A>>2]|0,p,q)|0)){g[h+(F<<2)>>2]=ea(1.0);c[(c[j>>2]|0)+(F<<2)>>2]=z;R=G;S=F+1|0;break}D=!(ea(g[x>>2])<=ea(9.99999974e-06));if(D&!(ea(g[y>>2])<=ea(9.99999974e-06))){D=c[A>>2]|0;I=r+0|0;J=p+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));M=d+(z<<4)|0;L=w5b(k)|0;I=n+0|0;J=r+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];c[m+12>>2]=c[q+12>>2];x5b(a,b,D,n,M,m,1,ea(1.0),z,L);H=G+1|0;c[P>>2]=H;R=H;S=F}else{R=G;S=F}}else{R=G;S=F}while(0);B=B+1|0;if((B|0)>=(c[w>>2]|0)){T=P;U=O;V=R;W=S;break}else{G=R;F=S}}}else{X=O;Y=Q;Z=10}}else{X=0;Y=v;Z=10}if((Z|0)==10){T=o+4|0;U=X;V=0;W=Y}c[k+24>>2]=U;c[k+28>>2]=V;c[T>>2]=0;c[o>>2]=0;if((W|0)<=0){_=0;$=0;aa=k+32|0;c[aa>>2]=_;ba=k+36|0;c[ba>>2]=$;i=l;return}V=0;U=0;while(1){Y=c[(c[j>>2]|0)+(U<<2)>>2]|0;X=c[e+(Y<<2)>>2]|0;if(!(c[X+212>>2]|0)){QGc(s,BTb(c[X+24>>2]|0)|0);I=t+0|0;J=s+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));Z=d+(Y<<4)|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;ca=ea(g[h+(U<<2)>>2]);v=w5b(k)|0;I=n+0|0;J=t+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));c[m+0>>2]=c[u+0>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];x5b(a,b,X,n,Z,m,0,ca,Y,v);Q=V+1|0;c[o>>2]=Q;da=Q}else da=V;U=U+1|0;if((U|0)==(W|0)){fa=da;break}else V=da}da=0;V=0;while(1){U=c[(c[j>>2]|0)+(V<<2)>>2]|0;o=c[e+(U<<2)>>2]|0;if((c[o+212>>2]|0)==2){QGc(s,BTb(c[o+24>>2]|0)|0);I=t+0|0;J=s+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));v=d+(U<<4)|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;ca=ea(g[h+(V<<2)>>2]);Y=w5b(k)|0;I=n+0|0;J=t+0|0;K=I+64|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));c[m+0>>2]=c[u+0>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];x5b(a,b,o,n,v,m,0,ca,U,Y);Z=da+1|0;c[T>>2]=Z;ga=Z}else ga=da;V=V+1|0;if((V|0)==(W|0)){_=fa;$=ga;break}else da=ga}aa=k+32|0;c[aa>>2]=_;ba=k+36|0;c[ba>>2]=$;i=l;return}function r5b(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;o=z5b()|0;p=c[o+4>>2]|0;if((p|0)==(o|0)){i=j;return}q=e+8|0;r=e+12|0;s=e+4|0;t=f+8|0;u=f+12|0;v=f+4|0;w=p;do{p=w+-32|0;x=c[w+180>>2]|0;y=c[(c[h>>2]|0)+412>>2]|0;do if((x|0)!=3){if((a[p+217>>0]|0)!=0?(c[w+176>>2]|0)!=1:0)break;if(((c[w+144>>2]&y|0)!=0?!(ea(g[w+148>>2])<ea(.00100000005)):0)?P4b(p)|0:0){if((x|0)==1){c[m>>2]=p;y5b(b,m);break}if(x&-3){Krd(562624,0,3653512,562,1,c[w+-28>>2]|0,0,0);break}z=ea(g[w+152>>2]);if(!x)A=ea(z*ea(g[w+168>>2]));else A=z;z=ea(g[w+72>>2]);B=ea(g[w+76>>2]);C=ea(g[w+80>>2]);D=(c[q>>2]|0)+1|0;c[q>>2]=D;E=c[r>>2]|0;F=E&2147483647;if(D>>>0>F>>>0){G=E<<1;H=(G|0)==0?1:G;do if(F>>>0<H>>>0)if((E|0)>-1){c[r>>2]=H;G=c[e>>2]|0;c[l>>2]=c[s>>2];c[k+0>>2]=c[l+0>>2];c[e>>2]=hOb(G,H<<4,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[s>>2];c[k+0>>2]=c[l+0>>2];G=cOb(H<<4,4,k,0,3653512,352)|0;YEi(G|0,c[e>>2]|0,c[q>>2]<<4|0)|0;c[r>>2]=H;c[e>>2]=G;break}while(0);I=c[q>>2]|0}else I=D;H=I+-1|0;E=c[e>>2]|0;g[E+(H<<4)>>2]=z;g[E+(H<<4)+4>>2]=B;g[E+(H<<4)+8>>2]=C;g[E+(H<<4)+12>>2]=A;c[n>>2]=p;y5b(d,n);H=(c[w+84>>2]|0)==0;E=(c[t>>2]|0)+1|0;c[t>>2]=E;F=c[u>>2]|0;G=F&2147483647;J=E>>>0>G>>>0;if(H){if(J){H=F<<1;K=(H|0)==0?1:H;do if(G>>>0<K>>>0)if((F|0)>-1){c[u>>2]=K;H=c[f>>2]|0;c[l>>2]=c[v>>2];c[k+0>>2]=c[l+0>>2];c[f>>2]=hOb(H,K<<2,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[v>>2];c[k+0>>2]=c[l+0>>2];H=cOb(K<<2,4,k,0,3653512,352)|0;YEi(H|0,c[f>>2]|0,c[t>>2]<<2|0)|0;c[u>>2]=K;c[f>>2]=H;break}while(0);L=c[t>>2]|0}else L=E;c[(c[f>>2]|0)+(L+-1<<2)>>2]=0;break}else{if(J){K=F<<1;D=(K|0)==0?1:K;do if(G>>>0<D>>>0)if((F|0)>-1){c[u>>2]=D;K=c[f>>2]|0;c[l>>2]=c[v>>2];c[k+0>>2]=c[l+0>>2];c[f>>2]=hOb(K,D<<2,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[v>>2];c[k+0>>2]=c[l+0>>2];K=cOb(D<<2,4,k,0,3653512,352)|0;YEi(K|0,c[f>>2]|0,c[t>>2]<<2|0)|0;c[u>>2]=D;c[f>>2]=K;break}while(0);M=c[t>>2]|0}else M=E;c[(c[f>>2]|0)+(M+-1<<2)>>2]=1;break}}}while(0);w=c[w+4>>2]|0}while((w|0)!=(o|0));i=j;return}function s5b(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=Im,q=Im;l=i;i=i+32|0;m=l;n=b+208|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=ea(g[n>>2]);p=ea(o*ea(g[b+196>>2]));o=ea(g[b+212>>2]);q=ea(p+ea(o*ea(g[b+200>>2])));o=ea(g[b+216>>2]);g[m+12>>2]=ea(-ea(q+ea(o*ea(g[b+204>>2]))));n=c[b>>2]|0;g[m+16>>2]=ea(g[n+460>>2]);o=ea(g[b+580>>2]);a[m+20>>0]=o>ea(g[n+456>>2])&1;c[m+24>>2]=c[n+412>>2];q5b(m,b,e,d,f,h,j,k);i=l;return}function t5b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;e=d+4|0;f=d;h=z5b()|0;j=c[153134]|0;c[f>>2]=j;c[e+0>>2]=c[f+0>>2];k=hOb(0,32,4,e,0,3653512,370)|0;l=c[h+4>>2]|0;if((l|0)!=(h|0)){m=0;n=8;o=k;p=l;while(1){l=p+-32|0;q=c[p+180>>2]|0;do if(b)if((q|0)!=3){if((a[l+217>>0]|0)!=0?(c[p+176>>2]|0)!=1:0){r=n;s=m;t=o;break}if(((c[p+144>>2]|0)!=0?!(ea(g[p+148>>2])<ea(.00100000005)):0)?(P4b(l)|0)&(q|0)==1:0)u=11;else{r=n;s=m;t=o}}else{r=n;s=m;t=o}else if((q|0)==1)u=11;else{r=n;s=m;t=o}while(0);if((u|0)==11){u=0;q=m+1|0;v=n&2147483647;do if(q>>>0>v>>>0?(w=n<<1,x=(w|0)==0?1:w,v>>>0<x>>>0):0)if((n|0)>-1){c[f>>2]=j;c[e+0>>2]=c[f+0>>2];y=hOb(o,x<<2,4,e,0,3653512,370)|0;z=x;break}else{c[f>>2]=j;c[e+0>>2]=c[f+0>>2];w=cOb(x<<2,4,e,0,3653512,352)|0;YEi(w|0,o|0,q<<2|0)|0;y=w;z=x;break}else{y=o;z=n}while(0);c[y+(m<<2)>>2]=l;r=z;s=q;t=y}p=c[p+4>>2]|0;if((p|0)==(h|0)){A=r;B=s;C=t;break}else{m=s;n=r;o=t}}if(B){D=ea(-1.0);t=0;o=-1;while(1){r=c[C+(t<<2)>>2]|0;E=ea(ea(g[r+136>>2])*ea(.300000012));F=ea(E+ea(ea(g[r+140>>2])*ea(.589999974)));E=ea(F+ea(ea(g[r+144>>2])*ea(.109999999)));F=ea(ea(g[r+180>>2])*E);if(!(c[r+116>>2]|0))G=F;else G=ea(F*ea(16.0));n=G>D?(c[r+204>>2]|0)!=2:0;r=n?t:o;t=t+1|0;if((t|0)==(B|0)){H=r;break}else{D=n?G:D;o=r}}if((H|0)!=-1)I=c[C+(H<<2)>>2]|0;else I=0}else I=0;if((A|0)>-1){J=I;K=C}else{L=I;i=d;return L|0}}else{J=0;K=k}c[f>>2]=j;c[e+0>>2]=c[f+0>>2];eOb(K,e);L=J;i=d;return L|0}function u5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+(b*12|0)+24|0;f=a+(b<<2)+216|0;h=c[a+20>>2]|0;j=c[e>>2]|0;k=a+(b*12|0)+28|0;b=(c[k>>2]|0)+j|0;if(j>>>0<b>>>0){l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=a+4|0;o=c[n>>2]|0;p=j;q=j;r=j;while(1){s=c[a>>2]|0;t=ea(tmc(o+(p<<4)|0,s+28|0,c[s+188>>2]|0));o=c[n>>2]|0;u=ea(g[o+(p<<4)+12>>2]);if(!(t<u))if(t<ea(u+u)){c[(c[l>>2]|0)+(q<<2)>>2]=p;g[h+(q<<2)>>2]=ea(ea(1.0)-ea(ea(t-u)/u));v=q+1|0;w=r}else{v=q;w=r}else{c[(c[m>>2]|0)+(r<<2)>>2]=p;v=q;w=r+1|0}p=p+1|0;if((p|0)==(b|0)){x=v;y=w;break}else{q=v;r=w}}z=c[e>>2]|0;A=x;B=y}else{z=j;A=j;B=j}c[k>>2]=B-z;c[f>>2]=A-z;z=GLc()|0;if(!z){i=d;return}co[c[(c[z>>2]|0)+48>>2]&2047](z,a,e);i=d;return}function v5b(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+12>>2]|0;h=c[a+16>>2]|0;j=c[a+20>>2]|0;k=a+280|0;if(!(c[k>>2]|0)){l=0;m=0;n=f+4|0;c[n>>2]=m;o=h+4|0;c[o>>2]=l;p=c[153136]|0;c[e>>2]=p;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}q=0;r=0;s=0;while(1){t=a+(q*12|0)+24|0;u=c[t>>2]|0;v=c[a+(q*12|0)+28>>2]|0;w=v+u|0;if(u>>>0<w>>>0){x=c[f>>2]|0;y=u;z=s;while(1){c[x+(z<<2)>>2]=c[x+(y<<2)>>2];y=y+1|0;if((y|0)==(w|0))break;else z=z+1|0}A=c[t>>2]|0;B=s+v|0}else{A=u;B=s}z=c[a+(q<<2)+216>>2]|0;w=z+A|0;if(A>>>0<w>>>0){y=c[h>>2]|0;x=A;C=r;while(1){c[y+(C<<2)>>2]=c[y+(x<<2)>>2];g[j+(C<<2)>>2]=ea(g[j+(x<<2)>>2]);x=x+1|0;if((x|0)==(w|0))break;else C=C+1|0}D=r+z|0}else D=r;q=q+1|0;if(q>>>0>=(c[k>>2]|0)>>>0){l=D;m=B;break}else{r=D;s=B}}n=f+4|0;c[n>>2]=m;o=h+4|0;c[o>>2]=l;p=c[153136]|0;c[e>>2]=p;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function w5b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;do if(g>>>0>k>>>0?(l=j<<1,m=(l|0)==0?1:l,k>>>0<m>>>0):0)if((j|0)>-1){c[h>>2]=m;l=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(l,m*108|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];l=cOb(m*108|0,4,d,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[f>>2]|0)*108|0)|0;c[h>>2]=m;c[a>>2]=l;break}while(0);i=b;return (c[a>>2]|0)+(((c[f>>2]|0)+-1|0)*108|0)|0}function x5b(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=ea(l);m=m|0;n=n|0;var o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=0;o=i;i=i+64|0;p=o+4|0;q=o;r=ea(g[h+12>>2]);s=ea(g[h>>2]);t=ea(g[h+4>>2]);u=ea(g[h+8>>2]);h=c[d>>2]|0;v=ea(ea(g[h+456>>2])*ea(1.00100005));w=ea(ea(g[h+460>>2])*ea(.999000012));c[n>>2]=e;y=ea(s*ea(g[b>>2]));h=b+4|0;z=ea(y+ea(t*ea(g[h>>2])));A=b+8|0;y=ea(z+ea(u*ea(g[A>>2])));B=b+12|0;z=ea(ea(g[B>>2])+y);C=n+9|0;D=k&1;a[C>>0]=D;k=n+48|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];g[n+104>>2]=l;c[n+76>>2]=m;m=e+184|0;l=ea(g[m>>2]);y=ea(g[e+104>>2]);E=ea(g[e+108>>2]);F=ea(g[e+112>>2]);g[n+80>>2]=y;g[n+84>>2]=E;g[n+88>>2]=F;g[n+92>>2]=l;l=ea(ea(g[e+136>>2])*ea(.300000012));F=ea(l+ea(ea(g[e+140>>2])*ea(.589999974)));l=ea(F+ea(ea(g[e+144>>2])*ea(.109999999)));g[n+96>>2]=ea(ea(g[e+180>>2])*l);a[n+100>>0]=D^1;D=e+212|0;j=c[D>>2]|0;if((j|0)!=3)if(!(a[e+217>>0]|0))G=0;else G=(c[e+208>>2]|0)==1?1:2;else G=2;c[n+12>>2]=G;c[n+16>>2]=c[e+176>>2];k=e+172|0;H=c[k>>2]|0;if(!H){I=0;J=j}else{c[q>>2]=H;H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(p,H,q);j=c[p>>2]|0;K=c[H+28>>2]|0;if((j|0)==-1){L=K+(c[H+32>>2]<<3)|0;break}else{L=K+(j<<3)|0;break}}else L=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if((L|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(H=c[L+4>>2]|0,(H|0)!=0):0)M=H;else N=13}else N=13;if((N|0)==13)M=hQb(c[k>>2]|0)|0;I=(M|0)!=0&1;J=c[D>>2]|0}a[n+64>>0]=I;c[n+68>>2]=c[e+204>>2];c[n+72>>2]=J;if(!J){J=p+16|0;I=p+20|0;D=p+24|0;M=p+28|0;k=p+32|0;N=p+36|0;H=p+40|0;L=p+44|0;q=p+48|0;j=p+52|0;K=p+56|0;O=p+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));l=ea(g[m>>2]);fmc(l,ea(g[e+196>>2]),f,p);l=ea(g[b>>2]);F=ea(g[h>>2]);E=ea(g[A>>2]);y=ea(g[B>>2]);Q=ea(g[p>>2]);R=ea(l*Q);S=ea(g[p+4>>2]);T=ea(R+ea(F*S));R=ea(g[p+8>>2]);U=ea(y+ea(T+ea(E*R)));B=U<ea(x);T=B?U:ea(x);B=U>ea(-x);V=B?U:ea(-x);U=ea(g[p+12>>2]);W=ea(l*U);X=ea(g[J>>2]);Y=ea(W+ea(F*X));W=ea(g[I>>2]);Z=ea(y+ea(Y+ea(E*W)));Y=Z<T?Z:T;T=V<Z?Z:V;V=ea(g[D>>2]);Z=ea(l*V);_=ea(g[M>>2]);$=ea(Z+ea(F*_));Z=ea(g[k>>2]);aa=ea(y+ea($+ea(E*Z)));$=aa<Y?aa:Y;Y=T<aa?aa:T;T=ea(g[N>>2]);aa=ea(l*T);ba=ea(g[H>>2]);ca=ea(aa+ea(F*ba));aa=ea(g[L>>2]);da=ea(y+ea(ca+ea(E*aa)));ca=da<$?da:$;$=Y<da?da:Y;Y=ea(g[q>>2]);da=ea(l*Y);l=ea(g[j>>2]);fa=ea(da+ea(F*l));F=ea(g[K>>2]);da=ea(y+ea(fa+ea(E*F)));E=da<ca?da:ca;a[n+20>>0]=E<=v&1;a[n+21>>0]=($<da?da:$)>=w&1;$=ea(z-r);da=E<$?$:E;if(da>ea(g[b+16>>2])){a[C>>0]=0;K=n+48|0;c[K+0>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;c[K+12>>2]=0}E=U<Q?U:Q;$=X<S?X:S;ca=W<R?W:R;fa=Q<U?U:Q;Q=S<X?X:S;S=R<W?W:R;R=V<E?V:E;E=_<$?_:$;$=Z<ca?Z:ca;ca=fa<V?V:fa;fa=Q<_?_:Q;Q=S<Z?Z:S;S=T<R?T:R;R=ba<E?ba:E;E=aa<$?aa:$;$=ca<T?T:ca;ca=fa<ba?ba:fa;fa=Q<aa?aa:Q;Q=Y<S?Y:S;S=l<R?l:R;R=F<E?F:E;E=$<Y?Y:$;$=ca<l?l:ca;ca=fa<F?F:fa;fa=ea(ea($+S)*ea(.5));F=ea(ea(ca+R)*ea(.5));l=ea(ea(E-Q)*ea(.5));Y=ea(ea($-S)*ea(.5));S=ea(ea(ca-R)*ea(.5));g[n+24>>2]=ea(ea(E+Q)*ea(.5));g[n+28>>2]=fa;g[n+32>>2]=F;g[n+36>>2]=l;g[n+40>>2]=Y;g[n+44>>2]=S;ga=da}else{da=ea(z-r);g[n+24>>2]=s;g[n+28>>2]=t;g[n+32>>2]=u;g[n+36>>2]=r;g[n+40>>2]=r;g[n+44>>2]=r;S=ea(r*ea(1.26999998));a[n+20>>0]=ea(z-S)<=v&1;a[n+21>>0]=ea(S+z)>=w&1;ga=da}do if(ga<ea(g[d+580>>2])){K=a[b+20>>0]|0;j=n+8|0;a[j>>0]=K;if(K<<24>>24){if(!(a[d+576>>0]|0)){i=o;return}da=ea(r+ea(g[d+568>>2]));w=ea(s-ea(g[d+556>>2]));z=ea(t-ea(g[d+560>>2]));S=ea(u-ea(g[d+564>>2]));if(ea(ea(ea(w*w)+ea(z*z))+ea(S*S))>ea(da*da)){a[j>>0]=0;ha=1;break}if(Tac(d,n+24|0)|0){ha=(a[j>>0]|0)==0;break}else{a[j>>0]=0;ha=1;break}}else ha=1}else{a[n+8>>0]=0;ha=1}while(0);if(!((G|0)==1&ha)){i=o;return}a[C>>0]=0;C=n+48|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;i=o;return}function y5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;b=a+8|0;h=(c[b>>2]|0)+1|0;c[b>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[b>>2]<<2|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[b>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}function z5b(){return c[140662]|0}function A5b(){var a=0,b=0;a=i;b=xCi(8)|0;c[b>>2]=b;c[b+4>>2]=b;c[140662]=b;c[140664]=xmd(622584)|0;i=a;return}function B5b(){var a=0,b=0;a=i;b=c[140662]|0;if(b)ACi(b);c[140662]=0;i=a;return}function C5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;e=ync()|0;f=c[155251]|0;h=(f|0)<(a|0)?f:a;if((h|0)>0){j=~f;f=~a;a=~((j|0)>(f|0)?j:f);f=0;do{j=c[b+(f<<2)>>2]|0;M4b(c[j>>2]|0,f,ea(g[j+104>>2]));f=f+1|0}while((f|0)!=(a|0))}In[c[(c[e>>2]|0)+248>>2]&4095](e,h);i=d;return}function D5b(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0;b=i;i=i+224|0;d=b+16|0;e=b+64|0;f=b+32|0;h=b+80|0;j=b+160|0;k=b;l=b+48|0;m=b+96|0;n=ync()|0;o=n+4|0;p=a+128|0;q=c[a+112>>2]|0;r=a+116|0;s=c[r>>2]|0;if((s|0)>0){t=a+120|0;u=a+124|0;v=s;w=0;while(1){x=c[c[p+(w+q<<2)>>2]>>2]|0;y=ea(g[x+104>>2]);z=ea(g[x+108>>2]);A=ea(g[x+112>>2]);B=ea(ea(g[x+180>>2])*ea(2.0));if((w|0)==0?(C=ea(g[t>>2]),C!=ea(1.0)):0)D=ea(B*ea(ea(1.0)-C));else if((w|0)==(v+-1|0))D=ea(B*ea(g[u>>2]));else D=B;E=(KLc()|0)==1;B=ea(g[x+136>>2]);do if(E){do if(!(B<=ea(.0404499993)))if(B<ea(1.0)){F=ea(+U(+ea(ea(B+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{F=ea(+U(+B,2.20000005));break}else F=ea(B/ea(12.9200001));while(0);C=ea(g[x+140>>2]);do if(!(C<=ea(.0404499993)))if(C<ea(1.0)){G=ea(+U(+ea(ea(C+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{G=ea(+U(+C,2.20000005));break}else G=ea(C/ea(12.9200001));while(0);C=ea(g[x+144>>2]);if(C<=ea(.0404499993)){H=F;I=G;J=ea(C/ea(12.9200001));break}if(C<ea(1.0)){H=F;I=G;J=ea(+U(+ea(ea(C+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{H=F;I=G;J=ea(+U(+C,2.20000005));break}}else{C=ea(g[x+140>>2]);H=B;I=C;J=ea(g[x+144>>2])}while(0);B=ea(D*H);C=ea(D*I);K=ea(D*J);L=ea(D*ea(g[x+148>>2]));M=ea(u4b(ea(g[x+184>>2])));g[d+(w<<2)>>2]=y;g[e+(w<<2)>>2]=z;g[f+(w<<2)>>2]=A;g[h+(w<<2)>>2]=M;g[j+(w<<4)>>2]=B;g[j+(w<<4)+4>>2]=C;g[j+(w<<4)+8>>2]=K;g[j+(w<<4)+12>>2]=L;w=w+1|0;E=c[r>>2]|0;if((w|0)>=(E|0)){N=E;break}else v=E}if((N|0)<4){O=N;P=4}else P=30}else{O=s;P=4}if((P|0)==4){s=O<<2;N=16-s|0;PEi(d+s|0,0,N|0)|0;PEi(e+s|0,0,N|0)|0;PEi(f+s|0,0,N|0)|0;N=O;do{g[h+(N<<2)>>2]=ea(1.0);s=j+(N<<4)|0;N=N+1|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0}while((N|0)!=4);if(!O){O=c[140664]|0;N=(c[158074]|0)+(O>>>5<<2)+4|0;c[N>>2]=c[N>>2]&~(1<<(O&31))}else P=30}if((P|0)==30){P=n+1172|0;c[P+0>>2]=c[d+0>>2];c[P+4>>2]=c[d+4>>2];c[P+8>>2]=c[d+8>>2];c[P+12>>2]=c[d+12>>2];d=n+1188|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];e=n+1204|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=n+1220|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[o+0>>2]=c[j+0>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];c[o+12>>2]=c[j+12>>2];o=j+16|0;h=n+20|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];o=j+32|0;h=n+36|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];o=j+48|0;j=n+52|0;c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];o=c[140664]|0;j=(c[158074]|0)+(o>>>5<<2)+4|0;c[j>>2]=1<<(o&31)|c[j>>2]}j=c[a+108>>2]|0;if(!j){a=n+548|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=b;return}else{a=c[j>>2]|0;j=BTb(c[a+24>>2]|0)|0;g[l>>2]=ea(0.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(-1.0);TGc(k,j,l);D=ea(g[k>>2]);J=ea(g[k+4>>2]);I=ea(g[k+8>>2]);g[n+532>>2]=D;g[n+536>>2]=J;g[n+540>>2]=I;g[n+544>>2]=ea(0.0);k=m+0|0;l=a+40|0;j=k+64|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(j|0));K4b(a,m,n+3556|0);J4b(a);I4b(a,ea(1.0));i=b;return}}function E5b(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+96|0;e=d+76|0;f=d+64|0;h=d;j=ync()|0;if((c[a+212>>2]|0)==1){k=BTb(c[a+24>>2]|0)|0;g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(-1.0);TGc(e,k,f);l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=l;o=m;p=ea(g[e+8>>2]);q=ea(0.0)}else{m=ea(g[a+104>>2]);l=ea(g[a+108>>2]);n=m;o=l;p=ea(g[a+112>>2]);q=ea(1.0)}g[j+532>>2]=n;g[j+536>>2]=o;g[j+540>>2]=p;g[j+544>>2]=q;e=h+0|0;f=a+40|0;k=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(k|0));K4b(a,h,j+3556|0);J4b(a);I4b(a,b);i=d;return}function F5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+32|0;if((e|0)==(a|0)){i=d;return}f=c[e>>2]|0;g=b+36|0;if(f){c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[e>>2]=0;c[g>>2]=0}f=c[a>>2]|0;c[e>>2]=f;c[g>>2]=a;c[f+4>>2]=e;c[c[g>>2]>>2]=e;i=d;return}function G5b(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;d=(b|0)==0?0:b+32|0;b=c[d>>2]|0;if(!b){i=a;return}e=d+4|0;c[b+4>>2]=c[e>>2];c[c[e>>2]>>2]=b;c[d>>2]=0;c[e>>2]=0;i=a;return}function H5b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=1<<e;e=c[b+4>>2]|0;if((e|0)==(b|0)){i=f;return}else l=e;do{e=l+-32|0;c[g>>2]=e;do if((c[l+180>>2]|0)==(d|0)?(c[l+144>>2]&k|0)!=0:0){m=c[h>>2]|0;if((m|0)==(c[j>>2]|0)){K5b(a,g);break}if(!m)n=0;else{c[m>>2]=e;n=c[h>>2]|0}c[h>>2]=n+4}while(0);l=c[l+4>>2]|0}while((l|0)!=(b|0));i=f;return}function I5b(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+16|0;a=g+4|0;h=g;j=c[155251]|0;k=(j|0)>8?8:j;l=(k|0)<(e|0)?k:e;k=b+8|0;m=c[k>>2]|0;n=m+4|0;o=n+(l<<2)|0;c[k>>2]=o;p=b+12|0;q=c[p>>2]|0;do if((q&2147483647)>>>0<o>>>0)if((q|0)>-1){c[p>>2]=o;r=c[b>>2]|0;c[h>>2]=c[b+4>>2];c[a+0>>2]=c[h+0>>2];s=hOb(r,o,1,a,0,3653512,370)|0;c[b>>2]=s;t=s;break}else{c[h>>2]=c[b+4>>2];c[a+0>>2]=c[h+0>>2];s=cOb(o,1,a,0,3653512,352)|0;YEi(s|0,c[b>>2]|0,c[k>>2]|0)|0;c[p>>2]=o;c[b>>2]=s;t=s;break}else t=c[b>>2]|0;while(0);b=t+n|0;c[t+m>>2]=l;if((l|0)<=0){i=g;return}l=~j;j=~e;e=(l|0)>(j|0)?l:j;j=(e|0)>-9?~e:8;e=0;do{c[b+(e<<2)>>2]=(c[f>>2]|0)+((c[d+(e<<3)>>2]|0)*108|0);e=e+1|0}while((e|0)!=(j|0));i=g;return}function J5b(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=Im;k=i;i=i+128|0;l=k+12|0;m=k+8|0;n=k+4|0;o=k;p=h+116|0;q=c[p>>2]|0;r=1<<(mo[c[(c[q>>2]|0)+28>>2]&4095](q)|0);q=Vwc()|0;s=c[p>>2]|0;t=Ewc(q)|0;u=_7b(s,t,Dwc(q)|0)|0;q=a[j>>0]|0;if(u)v=(q&2)==0;else v=0;if((q&4)==0?(a[h+124>>0]|0)!=0:0){q=(e<<3)+15|0;t=(e|0)!=0;if(q>>>0<2e3)if(t){s=i;i=i+((1*q|0)+15&-16)|0;w=0;x=s;y=11}else y=10;else if(t){c[o>>2]=c[153134];c[l+0>>2]=c[o+0>>2];o=cOb(q,16,l,0,3653512,399)|0;w=o;x=o;y=11}else y=10;if((y|0)==10){z=n;A=0;B=0}else if((y|0)==11){o=x+15&-16;if(!e)C=0;else{x=0;q=0;while(1){t=d+(q<<3)|0;if(!(a[(c[f>>2]|0)+((c[t>>2]|0)*108|0)+100>>0]|0)){s=t;t=c[s+4>>2]|0;D=o+(x<<3)|0;c[D>>2]=c[s>>2];c[D+4>>2]=t;E=x+1|0}else E=x;q=q+1|0;if((q|0)==(e|0)){C=E;break}else x=E}}if(!w){z=n;A=o;B=C}else{c[n>>2]=c[153134];c[l+0>>2]=c[n+0>>2];eOb(w,l);z=n;A=o;B=C}}F=B;G=A}else{F=e;G=d}d=b+8|0;e=c[d>>2]|0;A=e+128|0;c[d>>2]=A;B=b+12|0;C=c[B>>2]|0;do if((C&2147483647)>>>0<A>>>0)if((C|0)>-1){c[B>>2]=A;o=c[b>>2]|0;c[m>>2]=c[b+4>>2];c[l+0>>2]=c[m+0>>2];n=hOb(o,A,1,l,0,3653512,370)|0;c[b>>2]=n;H=n;break}else{c[m>>2]=c[b+4>>2];c[l+0>>2]=c[m+0>>2];n=cOb(A,1,l,0,3653512,352)|0;YEi(n|0,c[b>>2]|0,c[d>>2]|0)|0;c[B>>2]=A;c[b>>2]=n;H=n;break}else H=c[b>>2]|0;while(0);C=H+e|0;n=e+112|0;c[H+n>>2]=0;o=e+116|0;c[H+o>>2]=0;z=H+(e+108)|0;c[z>>2]=0;w=e+120|0;g[H+w>>2]=ea(1.0);g[H+(e+124)>>2]=ea(1.0);if(a[j>>0]&4){H=c[155251]|0;E=(H|0)>8?8:H;x=(E|0)<(F|0)?E:F;MMc(C);E=(x<<2)+A|0;c[d>>2]=E;q=c[B>>2]|0;do if((q&2147483647)>>>0<E>>>0)if((q|0)>-1){c[B>>2]=E;t=c[b>>2]|0;c[m>>2]=c[b+4>>2];c[l+0>>2]=c[m+0>>2];D=hOb(t,E,1,l,0,3653512,370)|0;c[b>>2]=D;I=D;break}else{c[m>>2]=c[b+4>>2];c[l+0>>2]=c[m+0>>2];D=cOb(E,1,l,0,3653512,352)|0;YEi(D|0,c[b>>2]|0,c[d>>2]|0)|0;c[B>>2]=E;c[b>>2]=D;I=D;break}else I=c[b>>2]|0;while(0);E=I+A|0;c[I+o>>2]=x;if((x|0)<=0){i=k;return}x=~F;I=~H;H=(x|0)>(I|0)?x:I;I=(H|0)>-9?~H:8;H=0;do{c[E+(H<<2)>>2]=(c[f>>2]|0)+((c[G+(H<<3)>>2]|0)*108|0);H=H+1|0}while((H|0)!=(I|0));i=k;return}do if((((a[f+16>>0]|0)!=0?(I=c[f>>2]|0,(I|0)!=0):0)?(c[I+16>>2]&r|0)!=0:0)?(a[I+64>>0]|0)==0:0){if(v?(c[I+12>>2]|0)==1:0)break;c[z>>2]=I}while(0);if(u)MMc(C);else{z=C+0|0;v=j+8|0;r=z+108|0;do{c[z>>2]=c[v>>2];z=z+4|0;v=v+4|0}while((z|0)<(r|0))}if(!F){J=-1;K=C}else{v=j+4|0;z=b+4|0;r=0;I=-1;H=C;while(1){C=c[G+(r<<3)>>2]|0;E=c[f>>2]|0;x=E+(C*108|0)|0;q=c[E+(C*108|0)+68>>2]|0;D=a[j>>0]|0;t=(D&1)==0;if(t)L=0;else L=(c[E+(C*108|0)+12>>2]|0)==0;s=H+108|0;M=(c[s>>2]|0)==0;do if((C|0)!=0|M|L){if((M?((q|0)!=2?(c[E+(C*108|0)+72>>2]|0)==1:0):0)?!((a[E+(C*108|0)+64>>0]|0)!=0|L):0){c[s>>2]=x;N=I;O=H;break}if((q|0)==1){if(!(D&8))y=55}else if((q|0)!=2?((D&8)==0?(c[H+112>>2]|0)<(c[v>>2]|0):0):0)y=55;if((y|0)==55){y=0;P=c[d>>2]|0;Q=P+4|0;c[d>>2]=Q;R=c[B>>2]|0;do if((R&2147483647)>>>0<Q>>>0)if((R|0)>-1){c[B>>2]=Q;S=c[b>>2]|0;c[m>>2]=c[z>>2];c[l+0>>2]=c[m+0>>2];T=hOb(S,Q,1,l,0,3653512,370)|0;c[b>>2]=T;U=T;break}else{c[m>>2]=c[z>>2];c[l+0>>2]=c[m+0>>2];T=cOb(Q,1,l,0,3653512,352)|0;YEi(T|0,c[b>>2]|0,c[d>>2]|0)|0;c[B>>2]=Q;c[b>>2]=T;U=T;break}else U=c[b>>2]|0;while(0);c[U+P>>2]=x;Q=c[b>>2]|0;R=Q+n|0;T=(c[R>>2]|0)+1|0;c[R>>2]=T;N=((q|0)!=1?(T|0)==(c[v>>2]|0):0)?r:I;O=Q+e|0;break}if(t){if((c[E+(C*108|0)+72>>2]|0)!=1?(c[H+116>>2]|0)<4:0){Q=c[d>>2]|0;T=Q+4|0;c[d>>2]=T;R=c[B>>2]|0;do if((R&2147483647)>>>0<T>>>0)if((R|0)>-1){c[B>>2]=T;S=c[b>>2]|0;c[m>>2]=c[z>>2];c[l+0>>2]=c[m+0>>2];V=hOb(S,T,1,l,0,3653512,370)|0;c[b>>2]=V;W=V;break}else{c[m>>2]=c[z>>2];c[l+0>>2]=c[m+0>>2];V=cOb(T,1,l,0,3653512,352)|0;YEi(V|0,c[b>>2]|0,c[d>>2]|0)|0;c[B>>2]=T;c[b>>2]=V;W=V;break}else W=c[b>>2]|0;while(0);c[W+Q>>2]=x;T=c[b>>2]|0;R=T+o|0;c[R>>2]=(c[R>>2]|0)+1;N=I;O=T+e|0;break}L5b(h,c[x>>2]|0,H,ea(1.0));N=I;O=H}else{N=I;O=H}}else{N=I;O=H}while(0);r=r+1|0;if((r|0)==(F|0)){J=N;K=O;break}else{I=N;H=O}}}O=(a[j>>0]&1)==0;j=c[b>>2]|0;H=j+e|0;N=(c[j+o>>2]|0)+(c[j+n>>2]|0)|0;I=N+-1|0;r=j+w|0;g[r>>2]=ea(1.0);w=F+-1|0;do if((J|0)>0&(w|0)>(J|0)?(X=ea(g[G+(J+-1<<3)+4>>2]),Y=ea(g[G+(J<<3)+4>>2]),Z=ea(g[G+(J+1<<3)+4>>2]),_=ea(X-Z),!(_>=ea(t4b(1)))):0){X=ea(ea(Y-Z)/ea(_+ea(.00100000005)));if(X<ea(0.0))$=ea(0.0);else{F=X>ea(1.0);$=F?ea(1.0):X}g[r>>2]=$;if(O){F=c[(c[f>>2]|0)+((c[G+(J<<3)>>2]|0)*108|0)>>2]|0;if((c[F+212>>2]|0)==1){L5b(h,F,H,ea(ea(1.0)-$));aa=I;ba=H;break}F=(c[d>>2]|0)+4|0;c[d>>2]=F;j=c[B>>2]|0;do if((j&2147483647)>>>0<F>>>0)if((j|0)>-1){c[B>>2]=F;W=c[b>>2]|0;c[m>>2]=c[b+4>>2];c[l+0>>2]=c[m+0>>2];z=hOb(W,F,1,l,0,3653512,370)|0;c[b>>2]=z;ca=z;break}else{c[m>>2]=c[b+4>>2];c[l+0>>2]=c[m+0>>2];z=cOb(F,1,l,0,3653512,352)|0;YEi(z|0,c[b>>2]|0,c[d>>2]|0)|0;c[B>>2]=F;c[b>>2]=z;ca=z;break}else ca=c[b>>2]|0;while(0);F=ca+e|0;j=ca+A|0;z=ca+n|0;W=c[z>>2]|0;v=ca+o|0;U=c[v>>2]|0;y=U+W|0;if((y|0)>(W+-1|0)){W=y;do{y=W;W=W+-1|0;c[j+(y<<2)>>2]=c[j+(W<<2)>>2]}while((y|0)>(c[z>>2]|0));da=c[v>>2]|0}else da=U;c[v>>2]=da+1;if((da|0)>3){c[v>>2]=4;aa=N+-2|0;ba=F}else{aa=I;ba=F}}else{aa=I;ba=H}}else{aa=I;ba=H}while(0);if(((c[ba+116>>2]|0)>0?(H=ba+124|0,g[H>>2]=ea(1.0),(aa|0)>0&(w|0)>(aa|0)):0)?($=ea(g[G+(aa+-1<<3)+4>>2]),X=ea(g[G+(aa<<3)+4>>2]),_=ea(g[G+(aa+1<<3)+4>>2]),Z=ea($-_),!(Z>=ea(t4b(1)))):0){$=ea(ea(X-_)/ea(Z+ea(.00100000005)));if($<ea(0.0))fa=ea(0.0);else{aa=$>ea(1.0);fa=aa?ea(1.0):$}g[H>>2]=fa}if(!u){i=k;return}if(!($7b(c[p>>2]|0,h+64|0,l)|0)){i=k;return}LMc(K,l)|0;i=k;return}function K5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>2)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>2>>>0<1073741823){m=h>>1;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>2;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>2;s=6}if((s|0)==6){c[f>>2]=44;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<2,16,e,0,3653512,80)|0;p=r}r=o+(p<<2)|0;if(r)c[r>>2]=c[b>>2];b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>2)<<2)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<2);c[k>>2]=o+(n<<2);if(!r){i=d;return}c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function L5b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=Im,R=Im,S=Im,V=Im,W=Im,X=Im;f=i;i=i+64|0;h=f+40|0;j=f+28|0;k=f+16|0;l=f;g[h>>2]=ea(0.0);m=h+4|0;g[m>>2]=ea(0.0);n=h+8|0;g[n>>2]=ea(0.0);o=b+212|0;p=c[o>>2]|0;if((p|0)==1){q=BTb(c[b+24>>2]|0)|0;g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(-1.0);TGc(j,q,k);c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];r=c[o>>2]|0}else{s=ea(g[b+104>>2]);t=ea(s-ea(g[a+64>>2]));s=ea(g[b+108>>2]);u=ea(s-ea(g[a+68>>2]));s=ea(g[b+112>>2]);v=ea(s-ea(g[a+72>>2]));s=ea(T(ea(ea(ea(t*t)+ea(u*u))+ea(v*v))));if(s>ea(g[150276])){w=ea(t/s);x=ea(u/s);y=ea(v/s)}else{s=ea(g[150284]);v=ea(g[150285]);w=s;x=v;y=ea(g[150286])}g[h>>2]=w;g[m>>2]=x;g[n>>2]=y;r=p}y=ea(g[b+180>>2]);if((r|0)==1){r=(KLc()|0)==1;x=ea(g[b+136>>2]);do if(r){do if(!(x<=ea(.0404499993)))if(x<ea(1.0)){z=ea(+U(+ea(ea(x+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{z=ea(+U(+x,2.20000005));break}else z=ea(x/ea(12.9200001));while(0);w=ea(g[b+140>>2]);do if(!(w<=ea(.0404499993)))if(w<ea(1.0)){A=ea(+U(+ea(ea(w+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{A=ea(+U(+w,2.20000005));break}else A=ea(w/ea(12.9200001));while(0);w=ea(g[b+144>>2]);if(w<=ea(.0404499993)){B=z;C=A;D=ea(w/ea(12.9200001));break}if(w<ea(1.0)){B=z;C=A;D=ea(+U(+ea(ea(w+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{B=z;C=A;D=ea(+U(+w,2.20000005));break}}else{w=ea(g[b+140>>2]);B=x;C=w;D=ea(g[b+144>>2])}while(0);E=ea(y*B);F=ea(y*C);G=ea(y*D);H=ea(y*ea(g[b+148>>2]));I=ea(e*ea(2.0));J=ea(I*E);K=ea(I*F);L=ea(I*G);M=ea(I*H);g[l>>2]=J;N=l+4|0;g[N>>2]=K;O=l+8|0;g[O>>2]=L;P=l+12|0;g[P>>2]=M;RMc(d,h,l);i=f;return}D=ea(g[a+100>>2]);C=ea(g[a+104>>2]);B=ea(g[a+108>>2]);x=ea(ea(ea(D*D)+ea(C*C))+ea(B*B));B=ea(g[b+184>>2]);C=ea(B*B);if(x>C)Q=ea(y*ea(C/x));else Q=y;y=ea(g[a+64>>2]);C=ea(g[a+68>>2]);B=ea(g[a+72>>2]);D=ea(y-ea(g[b+104>>2]));y=ea(C-ea(g[b+108>>2]));C=ea(B-ea(g[b+112>>2]));B=ea(ea(ea(D*D)+ea(y*y))+ea(C*C));C=ea(Q*ea(z4b(b,B<x?x:B)));a=(KLc()|0)==1;B=ea(g[b+136>>2]);do if(a){do if(!(B<=ea(.0404499993)))if(B<ea(1.0)){R=ea(+U(+ea(ea(B+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{R=ea(+U(+B,2.20000005));break}else R=ea(B/ea(12.9200001));while(0);x=ea(g[b+140>>2]);do if(!(x<=ea(.0404499993)))if(x<ea(1.0)){S=ea(+U(+ea(ea(x+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{S=ea(+U(+x,2.20000005));break}else S=ea(x/ea(12.9200001));while(0);x=ea(g[b+144>>2]);if(x<=ea(.0404499993)){V=R;W=S;X=ea(x/ea(12.9200001));break}if(x<ea(1.0)){V=R;W=S;X=ea(+U(+ea(ea(x+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{V=R;W=S;X=ea(+U(+x,2.20000005));break}}else{x=ea(g[b+140>>2]);V=B;W=x;X=ea(g[b+144>>2])}while(0);E=ea(C*V);F=ea(C*W);G=ea(C*X);H=ea(C*ea(g[b+148>>2]));I=ea(e*ea(2.0));J=ea(I*E);K=ea(I*F);L=ea(I*G);M=ea(I*H);g[l>>2]=J;N=l+4|0;g[N>>2]=K;O=l+8|0;g[O>>2]=L;P=l+12|0;g[P>>2]=M;RMc(d,h,l);i=f;return}function M5b(a,b){a=a|0;b=b|0;return}function N5b(){var a=0;a=i;QQb(258,104,105,0,106);i=a;return}function O5b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,562768,11);wQb(258,130,b,144,2609,0,0);xri(b);i=a;return}function P5b(a){a=a|0;return 258}function Q5b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+112|0;e=d;add(b,792072,562768,a,0);xWb(a,b);b6b(b,a+28|0,574776,0);add(b,562784,c[142306]|0,a+124|0,0);$cd(b,2646336,2646336,d+108|0,0);add(b,3142592,2441672,e,0);c6b(e,b);bdd(b);cdd(b);bdd(b);bdd(b);i=d;return}function R5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,562768,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else d6b(a,b);sdd(b);i=d;return}function S5b(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);e6b(b,a+28|0,0);f6b(b,a+44|0,0);g6b(b,a+60|0,0);f6b(b,a+76|0,0);h6b(b,a+92|0,0);i6b(b,a+124|0,0);i=c;return}function T5b(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);j6b(b,a+28|0,0);k6b(b,a+44|0,0);l6b(b,a+60|0,0);k6b(b,a+76|0,0);m6b(b,a+92|0,0);n6b(b,a+124|0,0);i=c;return}function U5b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;BWb(a,b);o6b(a+28|0,b);f=a+132|0;g=c[f>>2]|0;c[e>>2]=g;h=b+12|0;j=c[h>>2]|0;k=j+4|0;if(k>>>0<(c[b+20>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);e=c[a+124>>2]|0;a=c[f>>2]|0;f=e+(a*108|0)|0;if(!a){i=d;return}else l=e;do{p6b(l,b);l=l+108|0}while((l|0)!=(f|0));i=d;return}function V5b(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function W5b(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=a+140|0;h=c[g>>2]|0;if(!h)j=0;else j=(c[h+8>>2]|0)>>>0>b>>>0;if((c[a+132>>2]|0)>>>0>b>>>0){h=e+0|0;k=(c[a+124>>2]|0)+(b*108|0)+0|0;a=h+108|0;do{c[h>>2]=c[k>>2];h=h+4|0;k=k+4|0}while((h|0)<(a|0))}else MMc(e);if(!j){i=f;return 1}OMc(e,(c[c[g>>2]>>2]|0)+(b*48|0)|0,d);i=f;return 1}function X5b(a,b,d,e,f,h,j){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0;k=i;i=i+112|0;l=k+4|0;m=k;MMc(j);n=a+28|0;o=c[a+36>>2]|0;if((o|0)!=0?(c[a+84>>2]|0)!=0:0){Y5b(n,b,e,f,h,m);m=c[e>>2]|0;if(!((m|0)>-1&(m|0)<(o|0))){i=k;return}o=c[a+28>>2]|0;h=(c[o+(m*80|0)+12>>2]>>31)+4|0;if((h|0)<=0){i=k;return}b=a+140|0;n=a+132|0;p=a+124|0;a=0;do{q=c[o+(m*80|0)+(a<<2)>>2]|0;r=ea(g[f+(a<<2)>>2]);s=c[b>>2]|0;if(!s)t=0;else t=(c[s+8>>2]|0)>>>0>q>>>0;if((c[n>>2]|0)>>>0>q>>>0){s=l+0|0;u=(c[p>>2]|0)+(q*108|0)+0|0;v=s+108|0;do{c[s>>2]=c[u>>2];s=s+4|0;u=u+4|0}while((s|0)<(v|0))}else MMc(l);if(t)OMc(l,(c[c[b>>2]>>2]|0)+(q*48|0)|0,d);NMc(j,l,r);a=a+1|0}while((a|0)!=(h|0));i=k;return}c[e>>2]=-1;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;i=k;return}function Y5b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0;j=i;i=i+16|0;k=j;l=c[a+8>>2]|0;m=c[d>>2]|0;if(!((m|0)>-1&(m|0)<(l|0)))c[d>>2]=0;c[h>>2]=0;m=a+16|0;n=e+12|0;if((l|0)<=0){i=j;return}o=a+56|0;p=a+48|0;q=k+4|0;r=k+8|0;s=k+12|0;t=b+4|0;u=b+8|0;v=e+4|0;w=e+8|0;x=0;y=-1;z=-1;while(1){A=c[d>>2]|0;B=c[a>>2]|0;C=B+(A*80|0)|0;D=c[C>>2]|0;E=c[o>>2]|0;if(E>>>0>D>>>0)c[k>>2]=(c[p>>2]|0)+(D*12|0);D=c[B+(A*80|0)+4>>2]|0;if(E>>>0>D>>>0)c[q>>2]=(c[p>>2]|0)+(D*12|0);D=c[B+(A*80|0)+8>>2]|0;if(E>>>0>D>>>0)c[r>>2]=(c[p>>2]|0)+(D*12|0);D=c[B+(A*80|0)+12>>2]|0;if(E>>>0>D>>>0){E=(c[p>>2]|0)+(D*12|0)|0;c[s>>2]=E;F=E}else F=x;if((D|0)>-1){G=ea(g[b>>2]);H=ea(G-ea(g[F>>2]));G=ea(g[t>>2]);I=ea(G-ea(g[F+4>>2]));G=ea(g[u>>2]);J=ea(G-ea(g[F+8>>2]));G=ea(H*ea(g[B+(A*80|0)+32>>2]));K=ea(G+ea(I*ea(g[B+(A*80|0)+44>>2])));G=ea(K+ea(J*ea(g[B+(A*80|0)+56>>2])));K=ea(H*ea(g[B+(A*80|0)+36>>2]));L=ea(K+ea(I*ea(g[B+(A*80|0)+48>>2])));K=ea(L+ea(J*ea(g[B+(A*80|0)+60>>2])));L=ea(H*ea(g[B+(A*80|0)+40>>2]));H=ea(L+ea(I*ea(g[B+(A*80|0)+52>>2])));I=ea(H+ea(J*ea(g[B+(A*80|0)+64>>2])));g[e>>2]=G;g[v>>2]=K;g[w>>2]=I;g[n>>2]=ea(ea(ea(ea(1.0)-G)-K)-I);M=G}else{q6b(k,m,b,C,e,f);M=ea(g[e>>2])}C=!(M>=ea(0.0));D=C|!(ea(g[v>>2])>=ea(0.0));C=D|!(ea(g[w>>2])>=ea(0.0));if(!(C|!(ea(g[n>>2])>=ea(0.0)))){N=26;break}C=c[d>>2]|0;if((C|0)==(z|0)){N=26;break}G=ea(g[v>>2]);I=ea(g[w>>2]);do if(!(M<G&M<I&M<ea(g[n>>2]))){K=ea(g[n>>2]);if(G<I&G<K){c[d>>2]=c[B+(A*80|0)+20>>2];break}if(I<K){c[d>>2]=c[B+(A*80|0)+24>>2];break}else{c[d>>2]=c[B+(A*80|0)+28>>2];break}}else c[d>>2]=c[B+(A*80|0)+16>>2];while(0);A=(c[h>>2]|0)+1|0;c[h>>2]=A;if((A|0)<(l|0)){A=y;x=F;y=C;z=A}else{N=26;break}}if((N|0)==26){i=j;return}}function Z5b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[b+96>>2]|0;g=c[b+100>>2]|0;if((g|0)==(f|0))h=f;else{j=d;k=c[j>>2]|0;l=c[j+4>>2]|0;j=d+8|0;m=c[j>>2]|0;n=c[j+4>>2]|0;j=f;o=(g-f|0)/24|0;while(1){f=(o|0)/2|0;p=j+(f*24|0)|0;q=c[p>>2]|0;r=c[p+4>>2]|0;if((q|0)==(k|0)&(r|0)==(l|0)){p=j+(f*24|0)+8|0;s=c[p+4>>2]|0;if(s>>>0<n>>>0|((s|0)==(n|0)?(c[p>>2]|0)>>>0<m>>>0:0))t=6;else{u=j;v=f}}else if(r>>>0<l>>>0|(r|0)==(l|0)&q>>>0<k>>>0)t=6;else{u=j;v=f}if((t|0)==6){t=0;u=j+((f+1|0)*24|0)|0;v=o+-1-f|0}if(!v){h=u;break}else{j=u;o=v}}}do if((h|0)!=(g|0)){v=d;o=c[v>>2]|0;u=c[v+4>>2]|0;v=h;j=c[v>>2]|0;t=c[v+4>>2]|0;if((o|0)==(j|0)&(u|0)==(t|0)){v=d+8|0;k=c[v+4>>2]|0;l=h+8|0;m=c[l+4>>2]|0;if(k>>>0<m>>>0|((k|0)==(m|0)?(c[v>>2]|0)>>>0<(c[l>>2]|0)>>>0:0)|(h|0)==(g|0))break}else if(u>>>0<t>>>0|(u|0)==(t|0)&o>>>0<j>>>0|(h|0)==(g|0))break;j=c[h+16>>2]|0;o=c[b+60>>2]|0;c[a>>2]=c[o+(j*24|0)+16>>2];w=c[o+(j*24|0)+20>>2]|0;x=a+4|0;c[x>>2]=w;i=e;return}while(0);c[a>>2]=-1;w=0;x=a+4|0;c[x>>2]=w;i=e;return}function _5b(){return}function $5b(){return}function a6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(144,e,1,16,3653512,32)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];mWb(g,e,b);c[g>>2]=562672;c[g+28>>2]=0;c[g+36>>2]=0;c[g+40>>2]=0;c[g+32>>2]=60;c[g+44>>2]=0;c[g+52>>2]=0;c[g+56>>2]=0;c[g+48>>2]=60;b=c[153132]|0;c[g+60>>2]=0;c[g+64>>2]=b;c[g+68>>2]=0;c[g+72>>2]=0;b=c[153132]|0;c[g+76>>2]=0;c[g+80>>2]=b;c[g+84>>2]=0;c[g+88>>2]=0;c[g+96>>2]=0;c[g+100>>2]=0;c[g+104>>2]=0;b=g+112|0;c[g+132>>2]=0;c[g+136>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[g+128>>2]=60;c[g+140>>2]=0;i=d;return g|0}function b6b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+96|0;g=f+80|0;h=f;add(a,d,563552,b,e);add(a,563024,563584,b,0);e=c[142306]|0;add(a,563384,e,b,0);$cd(a,2646336,2646336,g,0);add(a,3142592,563632,h,0);t6b(h,a);bdd(a);cdd(a);bdd(a);u6b(a,b+16|0,563400,0);bdd(a);add(a,563048,e,b+32|0,0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;$cd(a,2646336,2646336,g,0);add(a,3142592,563568,h,0);add(a,563376,616312,h,0);v6b(h,a);bdd(a);e=c[142270]|0;add(a,632240,e,h+16|0,0);d=a+12|0;j=a+20|0;c[(c[c[d>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,2462848,e,h+20|0,0);c[(c[c[d>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);cdd(a);bdd(a);u6b(a,b+48|0,563064,0);add(a,563080,c[142272]|0,b+64|0,0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;$cd(a,2646336,2646336,g,0);add(a,3142592,c[142274]|0,h,0);add(a,c[142266]|0,616312,h,0);v6b(h,a);bdd(a);add(a,c[142282]|0,e,h+16|0,0);c[(c[c[d>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);cdd(a);bdd(a);bdd(a);i=f;return}function c6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142268]|0;add(b,562808,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562816,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562824,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562832,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562840,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562848,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562856,e,a+24|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562864,e,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562872,e,a+32|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562880,e,a+36|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142268]|0;add(b,562888,e,a+40|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562896,e,a+44|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562904,e,a+48|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562912,e,a+52|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562920,e,a+56|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562928,e,a+60|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562936,e,a+64|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562944,e,a+68|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562952,e,a+72|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562960,e,a+76|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142268]|0;add(b,562968,e,a+80|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562976,e,a+84|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562984,e,a+88|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,562992,e,a+92|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563e3,e,a+96|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563008,e,a+100|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563016,e,a+104|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function d6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;yWb(a,b);f=a+28|0;g=qdd(b,574776,563552,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else w6b(f,b);sdd(b)}f=a+124|0;a=qdd(b,562784,c[142306]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else x6b(b,f,0);sdd(b);i=d;return}function e6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];y6b(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k*80|0)|0;if(!k){i=d;return}else u=s;do{z6b(u,a);u=u+80|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=(c[h>>2]|0)*80|0;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(w|0)/80|0;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function f6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];A6b(b,s,e);s=c[j>>2]|0;if(!s){i=d;return}Ldd(a,c[b>>2]|0,s*12|0);i=d;return}if(r){Bid(l,h,4);u=c[l>>2]|0;v=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;u=o;v=q}q=u+4|0;if(q>>>0>v>>>0){Bid(l,g,4);w=c[g>>2]|0}else{v=c[u>>2]|0;c[g>>2]=v;c[l>>2]=q;w=v}v=(c[h>>2]|0)*12|0;h=zid(l,w,v)|0;w=b+12|0;if((c[w>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(v|0)/12|0;c[b+8>>2]=e;c[w>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function g6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[l>>2]|0;t=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;s=o;t=q}q=s+4|0;if(q>>>0>t>>>0){Bid(l,g,4);u=c[g>>2]|0}else{t=c[s>>2]|0;c[g>>2]=t;c[l>>2]=q;u=t}t=(c[h>>2]|0)*24|0;h=zid(l,u,t)|0;u=b+12|0;if((c[u>>2]|0)>-1){q=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(q,e);c[b>>2]=0}q=(t|0)/24|0;c[b+8>>2]=q;c[u>>2]=q|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}if(r){Bid(l,j,4);v=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;v=r}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];B6b(b,v,e);e=c[b>>2]|0;v=c[b+8>>2]|0;b=e+(v*24|0)|0;if(!v){i=d;return}else w=e;do{C6b(w,a);e=w+16|0;v=c[l>>2]|0;k=v+4|0;r=c[p>>2]|0;if(k>>>0>r>>>0){Bid(l,e,4);x=c[l>>2]|0;y=c[p>>2]|0}else{c[e>>2]=c[v>>2];c[l>>2]=k;x=k;y=r}r=w+20|0;k=x+4|0;if(k>>>0>y>>>0)Bid(l,r,4);else{c[r>>2]=c[x>>2];c[l>>2]=k}w=w+24|0}while((w|0)!=(b|0));i=d;return}function h6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[h>>2]|0;q=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;p=l;q=n}n=p+4|0;if(n>>>0>q>>>0){Bid(h,e,4);r=c[e>>2]|0}else{q=c[p>>2]|0;c[e>>2]=q;c[h>>2]=n;r=q}zid(h,r,(c[f>>2]|0)*24|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);s=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;s=o}o=b+4|0;l=b+8|0;g=c[l>>2]|0;k=c[o>>2]|0;j=(g-k|0)/24|0;if(s>>>0<=j>>>0)if(s>>>0<j>>>0?(f=k+(s*24|0)|0,(g|0)!=(f|0)):0){r=g+(~(((g+-24-f|0)>>>0)/24|0)*24|0)|0;c[l>>2]=r;t=k;u=r}else{t=k;u=g}else{D6b(o,s-j|0);t=c[b+4>>2]|0;u=c[l>>2]|0}if((t|0)==(u|0)){i=d;return}else v=t;do{C6b(v,a);t=v+16|0;l=c[h>>2]|0;b=l+4|0;if(b>>>0>(c[m>>2]|0)>>>0)Bid(h,t,4);else{c[t>>2]=c[l>>2];c[h>>2]=b}v=v+24|0}while((v|0)!=(u|0));i=d;return}function i6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];E6b(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k*108|0)|0;if(!k){i=d;return}else u=s;do{F6b(u,a);u=u+108|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=(c[h>>2]|0)*108|0;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(w|0)/108|0;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function j6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];y6b(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k*80|0)|0;if(!k){i=d;return}else u=t;do{G6b(u,a);u=u+80|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z*80|0;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(g|0)/80|0;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function k6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=0,M=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+12|0;j=d+8|0;l=d+4|0;m=d;n=a+12|0;o=a+48|0;p=c[n>>2]|0;q=p+4|0;r=a+20|0;s=c[r>>2]|0;t=q>>>0>s>>>0;if(c[o>>2]|0){if(t){Bid(n,j,4);u=c[j>>2]|0;v=c[n>>2]|0;w=c[r>>2]|0}else{x=c[p>>2]|0;c[j>>2]=x;c[n>>2]=q;u=x;v=q;w=s}s=XEi(u|0)|0;c[j>>2]=s;u=v+4|0;if(u>>>0>w>>>0){Bid(n,h,4);y=c[h>>2]|0;z=c[j>>2]|0}else{j=c[v>>2]|0;c[h>>2]=j;c[n>>2]=u;y=j;z=s}s=XEi(y|0)|0;c[h>>2]=s;h=z*12|0;z=zid(n,s,h)|0;s=b+12|0;if((c[s>>2]|0)>-1){y=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(y,e);c[b>>2]=0}y=(h|0)/12|0;c[b+8>>2]=y;c[s>>2]=y|-2147483648;c[b>>2]=z;c[o>>2]=0;i=d;return}if(t){Bid(n,l,4);A=c[l>>2]|0}else{t=c[p>>2]|0;c[l>>2]=t;c[n>>2]=q;A=t}t=XEi(A|0)|0;c[l>>2]=t;c[m>>2]=c[a+8>>2];c[e+0>>2]=c[m+0>>2];A6b(b,t,e);e=c[b>>2]|0;t=c[b+8>>2]|0;b=e+(t*12|0)|0;if(!t){i=d;return}else B=e;do{e=c[n>>2]|0;t=e+4|0;m=c[r>>2]|0;if(t>>>0>m>>>0){Bid(n,B,4);C=B;D=c[B>>2]|0;E=c[n>>2]|0;F=c[r>>2]|0}else{G=ea(g[e>>2]);g[B>>2]=G;c[n>>2]=t;C=B;D=(g[k>>2]=G,c[k>>2]|0);E=t;F=m}c[C>>2]=XEi(D|0)|0;m=B+4|0;t=E+4|0;if(t>>>0>F>>>0){Bid(n,m,4);H=m;I=c[m>>2]|0;J=c[n>>2]|0;K=c[r>>2]|0}else{G=ea(g[E>>2]);g[m>>2]=G;c[n>>2]=t;H=m;I=(g[k>>2]=G,c[k>>2]|0);J=t;K=F}c[H>>2]=XEi(I|0)|0;t=B+8|0;m=J+4|0;if(m>>>0>K>>>0){Bid(n,t,4);L=t;M=c[t>>2]|0}else{G=ea(g[J>>2]);g[t>>2]=G;c[n>>2]=m;L=t;M=(g[k>>2]=G,c[k>>2]|0)}c[L>>2]=XEi(M|0)|0;B=B+12|0}while((B|0)!=(b|0));i=d;return}function l6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[h>>2]|0;t=c[l>>2]|0;u=c[p>>2]|0}else{v=c[n>>2]|0;c[h>>2]=v;c[l>>2]=o;s=v;t=o;u=q}q=XEi(s|0)|0;c[h>>2]=q;s=t+4|0;if(s>>>0>u>>>0){Bid(l,g,4);w=c[g>>2]|0;x=c[h>>2]|0}else{h=c[t>>2]|0;c[g>>2]=h;c[l>>2]=s;w=h;x=q}q=XEi(w|0)|0;c[g>>2]=q;g=x*24|0;x=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){w=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(w,e);c[b>>2]=0}w=(g|0)/24|0;c[b+8>>2]=w;c[q>>2]=w|-2147483648;c[b>>2]=x;c[m>>2]=0;i=d;return}if(r){Bid(l,j,4);y=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;y=r}r=XEi(y|0)|0;c[j>>2]=r;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];B6b(b,r,e);e=c[b>>2]|0;r=c[b+8>>2]|0;b=e+(r*24|0)|0;if(!r){i=d;return}else z=e;do{H6b(z,a);e=z+16|0;r=c[l>>2]|0;k=r+4|0;j=c[p>>2]|0;if(k>>>0>j>>>0){Bid(l,e,4);A=c[e>>2]|0;B=c[l>>2]|0;C=c[p>>2]|0}else{y=c[r>>2]|0;c[e>>2]=y;c[l>>2]=k;A=y;B=k;C=j}c[e>>2]=XEi(A|0)|0;e=z+20|0;j=B+4|0;if(j>>>0>C>>>0){Bid(l,e,4);D=c[e>>2]|0}else{k=c[B>>2]|0;c[e>>2]=k;c[l>>2]=j;D=k}c[e>>2]=XEi(D|0)|0;z=z+24|0}while((z|0)!=(b|0));i=d;return}function m6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{s=c[k>>2]|0;c[f>>2]=s;c[h>>2]=l;p=s;q=l;r=n}n=XEi(p|0)|0;c[f>>2]=n;p=q+4|0;if(p>>>0>r>>>0){Bid(h,e,4);t=c[e>>2]|0;u=c[f>>2]|0}else{f=c[q>>2]|0;c[e>>2]=f;c[h>>2]=p;t=f;u=n}n=XEi(t|0)|0;c[e>>2]=n;zid(h,n,u*24|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);v=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;v=o}o=XEi(v|0)|0;c[g>>2]=o;g=b+4|0;v=b+8|0;l=c[v>>2]|0;k=c[g>>2]|0;j=(l-k|0)/24|0;if(o>>>0<=j>>>0)if(o>>>0<j>>>0?(u=k+(o*24|0)|0,(l|0)!=(u|0)):0){n=l+(~(((l+-24-u|0)>>>0)/24|0)*24|0)|0;c[v>>2]=n;w=k;x=n}else{w=k;x=l}else{D6b(g,o-j|0);w=c[b+4>>2]|0;x=c[v>>2]|0}if((w|0)==(x|0)){i=d;return}else y=w;do{H6b(y,a);w=y+16|0;v=c[h>>2]|0;b=v+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,w,4);z=c[w>>2]|0}else{j=c[v>>2]|0;c[w>>2]=j;c[h>>2]=b;z=j}c[w>>2]=XEi(z|0)|0;y=y+24|0}while((y|0)!=(x|0));i=d;return}function n6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];E6b(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k*108|0)|0;if(!k){i=d;return}else u=t;do{I6b(u,a);u=u+108|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z*108|0;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(g|0)/108|0;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function o6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=a+8|0;g=c[f>>2]|0;c[e>>2]=g;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);k=c[a>>2]|0;g=c[f>>2]|0;f=k+(g*80|0)|0;if(g){g=k;do{J6b(g,b);g=g+80|0}while((g|0)!=(f|0))}K6b(b,a+16|0,563400,0);L6b(b,a+32|0,0);K6b(b,a+48|0,563064,0);f=a+72|0;g=c[f>>2]|0;k=a+68|0;a=c[k>>2]|0;j=(g-a|0)/24|0;c[e>>2]=j;m=c[h>>2]|0;n=m+4|0;if(n>>>0<(c[l>>2]|0)>>>0){c[m>>2]=j;c[h>>2]=n;o=a;p=g}else{Gid(h,e,4);o=c[k>>2]|0;p=c[f>>2]|0}if((o|0)==(p|0)){i=d;return}else q=o;do{M6b(q,b);o=q+16|0;f=c[h>>2]|0;k=f+4|0;if(k>>>0<(c[l>>2]|0)>>>0){c[f>>2]=c[o>>2];c[h>>2]=k}else Gid(h,o,4);q=q+24|0}while((q|0)!=(p|0));i=d;return}function p6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+12|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}h=a+16|0;p=q+4|0;if(p>>>0<r>>>0){g[q>>2]=ea(g[h>>2]);c[e>>2]=p;s=p;t=r}else{Gid(e,h,4);s=c[e>>2]|0;t=c[j>>2]|0}h=a+20|0;r=s+4|0;if(r>>>0<t>>>0){g[s>>2]=ea(g[h>>2]);c[e>>2]=r;u=r;v=t}else{Gid(e,h,4);u=c[e>>2]|0;v=c[j>>2]|0}h=a+24|0;t=u+4|0;if(t>>>0<v>>>0){g[u>>2]=ea(g[h>>2]);c[e>>2]=t;w=t;x=v}else{Gid(e,h,4);w=c[e>>2]|0;x=c[j>>2]|0}h=a+28|0;v=w+4|0;if(v>>>0<x>>>0){g[w>>2]=ea(g[h>>2]);c[e>>2]=v;y=v;z=x}else{Gid(e,h,4);y=c[e>>2]|0;z=c[j>>2]|0}h=a+32|0;x=y+4|0;if(x>>>0<z>>>0){g[y>>2]=ea(g[h>>2]);c[e>>2]=x;A=x;B=z}else{Gid(e,h,4);A=c[e>>2]|0;B=c[j>>2]|0}h=a+36|0;z=A+4|0;if(z>>>0<B>>>0){g[A>>2]=ea(g[h>>2]);c[e>>2]=z;C=z;D=B}else{Gid(e,h,4);C=c[e>>2]|0;D=c[j>>2]|0}h=a+40|0;B=C+4|0;if(B>>>0<D>>>0){g[C>>2]=ea(g[h>>2]);c[e>>2]=B;E=B;F=D}else{Gid(e,h,4);E=c[e>>2]|0;F=c[j>>2]|0}h=a+44|0;D=E+4|0;if(D>>>0<F>>>0){g[E>>2]=ea(g[h>>2]);c[e>>2]=D;G=D;H=F}else{Gid(e,h,4);G=c[e>>2]|0;H=c[j>>2]|0}h=a+48|0;F=G+4|0;if(F>>>0<H>>>0){g[G>>2]=ea(g[h>>2]);c[e>>2]=F;I=F;J=H}else{Gid(e,h,4);I=c[e>>2]|0;J=c[j>>2]|0}h=a+52|0;H=I+4|0;if(H>>>0<J>>>0){g[I>>2]=ea(g[h>>2]);c[e>>2]=H;K=H;L=J}else{Gid(e,h,4);K=c[e>>2]|0;L=c[j>>2]|0}h=a+56|0;J=K+4|0;if(J>>>0<L>>>0){g[K>>2]=ea(g[h>>2]);c[e>>2]=J;M=J;N=L}else{Gid(e,h,4);M=c[e>>2]|0;N=c[j>>2]|0}h=a+60|0;L=M+4|0;if(L>>>0<N>>>0){g[M>>2]=ea(g[h>>2]);c[e>>2]=L;O=N;P=L}else{Gid(e,h,4);O=c[j>>2]|0;P=c[e>>2]|0}h=a+64|0;L=P+4|0;if(L>>>0<O>>>0){g[P>>2]=ea(g[h>>2]);c[e>>2]=L;Q=L;R=O}else{Gid(e,h,4);Q=c[e>>2]|0;R=c[j>>2]|0}h=a+68|0;O=Q+4|0;if(O>>>0<R>>>0){g[Q>>2]=ea(g[h>>2]);c[e>>2]=O;S=O;T=R}else{Gid(e,h,4);S=c[e>>2]|0;T=c[j>>2]|0}h=a+72|0;R=S+4|0;if(R>>>0<T>>>0){g[S>>2]=ea(g[h>>2]);c[e>>2]=R;U=R;V=T}else{Gid(e,h,4);U=c[e>>2]|0;V=c[j>>2]|0}h=a+76|0;T=U+4|0;if(T>>>0<V>>>0){g[U>>2]=ea(g[h>>2]);c[e>>2]=T;W=T;X=V}else{Gid(e,h,4);W=c[e>>2]|0;X=c[j>>2]|0}h=a+80|0;V=W+4|0;if(V>>>0<X>>>0){g[W>>2]=ea(g[h>>2]);c[e>>2]=V;Y=V;Z=X}else{Gid(e,h,4);Y=c[e>>2]|0;Z=c[j>>2]|0}h=a+84|0;X=Y+4|0;if(X>>>0<Z>>>0){g[Y>>2]=ea(g[h>>2]);c[e>>2]=X;_=X;$=Z}else{Gid(e,h,4);_=c[e>>2]|0;$=c[j>>2]|0}h=a+88|0;Z=_+4|0;if(Z>>>0<$>>>0){g[_>>2]=ea(g[h>>2]);c[e>>2]=Z;aa=Z;ba=$}else{Gid(e,h,4);aa=c[e>>2]|0;ba=c[j>>2]|0}h=a+92|0;$=aa+4|0;if($>>>0<ba>>>0){g[aa>>2]=ea(g[h>>2]);c[e>>2]=$;ca=$;da=ba}else{Gid(e,h,4);ca=c[e>>2]|0;da=c[j>>2]|0}h=a+96|0;ba=ca+4|0;if(ba>>>0<da>>>0){g[ca>>2]=ea(g[h>>2]);c[e>>2]=ba;fa=ba;ga=da}else{Gid(e,h,4);fa=c[e>>2]|0;ga=c[j>>2]|0}h=a+100|0;da=fa+4|0;if(da>>>0<ga>>>0){g[fa>>2]=ea(g[h>>2]);c[e>>2]=da;ha=da;ia=ga}else{Gid(e,h,4);ha=c[e>>2]|0;ia=c[j>>2]|0}j=a+104|0;a=ha+4|0;if(a>>>0<ia>>>0){g[ha>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function q6b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=0,A=Im,B=0,C=Im,D=Im,E=Im,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=Im,Q=Im,R=Im;j=i;i=i+48|0;k=j+12|0;l=j;m=c[a>>2]|0;n=c[a+4>>2]|0;o=ea(g[n>>2]);p=ea(g[m>>2]);q=ea(o-p);r=n+4|0;o=ea(g[r>>2]);s=m+4|0;t=ea(g[s>>2]);u=ea(o-t);v=n+8|0;o=ea(g[v>>2]);w=m+8|0;x=ea(g[w>>2]);y=ea(o-x);z=c[a+8>>2]|0;o=ea(ea(g[z>>2])-p);a=z+4|0;A=ea(ea(g[a>>2])-t);B=z+8|0;C=ea(ea(g[B>>2])-x);D=ea(ea(y*A)-ea(u*C));E=ea(ea(q*C)-ea(y*o));y=ea(ea(u*o)-ea(q*A));A=ea(ea(g[d>>2])-p);F=d+4|0;p=ea(ea(g[F>>2])-t);G=d+8|0;t=ea(ea(ea(A*D)+ea(p*E))+ea(y*ea(ea(g[G>>2])-x)));g[h>>2]=t;if(t<ea(0.0)){g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(-1.0);i=j;return}t=ea(g[e+32>>2]);x=ea(g[d>>2]);y=ea(t*x);t=ea(g[e+44>>2]);E=ea(g[F>>2]);p=ea(y+ea(t*E));t=ea(g[e+56>>2]);y=ea(g[G>>2]);D=ea(p+ea(t*y));t=ea(ea(g[e+68>>2])+D);D=ea(x*ea(g[e+36>>2]));p=ea(D+ea(E*ea(g[e+48>>2])));D=ea(p+ea(y*ea(g[e+60>>2])));p=ea(ea(g[e+72>>2])+D);D=ea(x*ea(g[e+40>>2]));x=ea(D+ea(E*ea(g[e+52>>2])));E=ea(x+ea(y*ea(g[e+64>>2])));y=ea(ea(g[e+76>>2])+E);do if((c[e+12>>2]|0)==-1){H=+p;I=+t*.3333333333333333;J=I*I;K=I*J-I*H*.5+ +y*.5;L=H*.3333333333333333-J;J=L*(L*L);H=J+K*K;if(!(H>=0.0)){M=+T(+-J);J=+U(+M,.3333333333333333);N=(J-L/J)*+V(+(+Y(+(-K/M))*.3333333333333333))-I;break}M=+T(+H)-K;if(M>0.0)O=+U(+M,.3333333333333333);else O=-+U(+-M,.3333333333333333);N=O+(-I-L/O)}else{if(t<ea(0.0))P=ea(-t);else P=t;if(P<ea(9.99999974e-06)){if(p<ea(0.0))Q=ea(-p);else Q=p;if(Q>ea(9.99999974e-06))R=ea(ea(-y)/p);else R=ea(0.0)}else{E=ea(ea(p*p)-ea(ea(t*ea(4.0))*y));if(E<ea(0.0))R=ea(0.0);else R=ea(ea(ea(.5)/t)*ea(ea(T(ea(E)))-p))}N=+R}while(0);R=ea(N);g[h>>2]=R;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(0.0);h=c[e>>2]|0;G=c[b>>2]|0;p=ea(R*ea(g[G+(h*12|0)>>2]));t=ea(R*ea(g[G+(h*12|0)+4>>2]));y=ea(R*ea(g[G+(h*12|0)+8>>2]));Q=ea(p+ea(g[m>>2]));p=ea(t+ea(g[s>>2]));t=ea(y+ea(g[w>>2]));g[k>>2]=Q;g[k+4>>2]=p;g[k+8>>2]=t;w=c[e+4>>2]|0;t=ea(R*ea(g[G+(w*12|0)>>2]));p=ea(R*ea(g[G+(w*12|0)+4>>2]));Q=ea(R*ea(g[G+(w*12|0)+8>>2]));y=ea(t+ea(g[n>>2]));t=ea(p+ea(g[r>>2]));p=ea(Q+ea(g[v>>2]));g[k+12>>2]=y;g[k+16>>2]=t;g[k+20>>2]=p;v=c[e+8>>2]|0;p=ea(R*ea(g[G+(v*12|0)>>2]));t=ea(R*ea(g[G+(v*12|0)+4>>2]));y=ea(R*ea(g[G+(v*12|0)+8>>2]));R=ea(p+ea(g[z>>2]));p=ea(t+ea(g[a>>2]));t=ea(y+ea(g[B>>2]));g[k+24>>2]=R;g[k+28>>2]=p;g[k+32>>2]=t;eyc(l,k,d);t=ea(g[l>>2]);p=ea(g[l+4>>2]);R=ea(g[l+8>>2]);g[f>>2]=t;g[f+4>>2]=p;g[f+8>>2]=R;g[f+12>>2]=ea(0.0);i=j;return}function r6b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=562672;if((c[a+136>>2]|0)>-1){f=a+124|0;g=c[f>>2]|0;c[e>>2]=c[a+128>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=c[a+112>>2]|0;if(!f){h=a+28|0;N6b(h);EWb(a);i=b;return}d=a+116|0;g=c[d>>2]|0;if((g|0)!=(f|0))c[d>>2]=g+(~(((g+-40-f|0)>>>0)/40|0)*40|0);ACi(f);h=a+28|0;N6b(h);EWb(a);i=b;return}function s6b(a){a=a|0;var b=0;b=i;r6b(a);ACi(a);i=b;return}function t6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142270]|0;add(b,563416,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563432,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563448,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563464,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563480,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563496,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563512,e,a+24|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,563528,e,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);g=a+32|0;add(b,563544,563616,g,0);O6b(g,b);bdd(b);i=d;return}function u6b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;i=i+16|0;h=f;add(a,d,c[142306]|0,b,e);g[h>>2]=ea(0.0);e=h+4|0;g[e>>2]=ea(0.0);b=h+8|0;g[b>>2]=ea(0.0);$cd(a,2646336,2646336,f+12|0,0);add(a,3142592,c[142310]|0,h,0);d=c[($hd(a+16|0)|0)+20>>2]|2097152;j=a+12|0;k=a+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=d;d=c[142268]|0;add(a,3143216,d,h,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,3143224,d,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,2416480,d,b,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);cdd(a);bdd(a);i=f;return}function v6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142302]|0;add(b,563120,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563136,e,a+1|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563152,e,a+2|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563168,e,a+3|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563184,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563200,e,a+5|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563216,e,a+6|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563232,e,a+7|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563248,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563264,e,a+9|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563280,e,a+10|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);e=c[142302]|0;add(b,563296,e,a+11|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563312,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563328,e,a+13|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563344,e,a+14|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,563360,e,a+15|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);i=d;return}function w6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=qdd(b,563024,563584,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else P6b(a,b);sdd(b)}f=a+32|0;g=c[142306]|0;h=qdd(b,563048,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else Q6b(b,f,0);sdd(b)}f=a+48|0;h=qdd(b,563064,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else R6b(b,f,0);sdd(b)}f=a+64|0;a=qdd(b,563080,c[142272]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else S6b(b,f,0);sdd(b);i=d;return}function x6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];E6b(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*108|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,2441672,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;T6b(r,a);t=r+108|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,2441672,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else T6b(m,a);sdd(a)}m=m+108|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function y6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+96|0;f=e+84|0;g=e+80|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=h+0|0;k=d+80|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(k|0));l=a+12|0;m=c[l>>2]|0;do if((m&2147483647)>>>0<b>>>0)if((m|0)>-1){c[l>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=hOb(j,b*80|0,4,f,0,3653512,370)|0;c[a>>2]=n;o=n;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=cOb(b*80|0,4,f,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,(c[a+8>>2]|0)*80|0)|0;c[l>>2]=b;c[a>>2]=n;o=n;break}else o=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}l=o+(b*80|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=o+(a*80|0)|0;do{if(f){d=f+0|0;a=h+0|0;k=d+80|0;do{c[d>>2]=c[a>>2];d=d+4|0;a=a+4|0}while((d|0)<(k|0))}f=f+80|0}while((f|0)!=(l|0));c[j>>2]=b;i=e;return}function z6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;j=c[h>>2]|0;if(g>>>0>j>>>0){Bid(e,a,4);k=c[h>>2]|0;l=c[e>>2]|0}else{c[a>>2]=c[f>>2];c[e>>2]=g;k=j;l=g}g=a+4|0;j=l+4|0;if(j>>>0>k>>>0){Bid(e,g,4);m=c[e>>2]|0;n=c[h>>2]|0}else{c[g>>2]=c[l>>2];c[e>>2]=j;m=j;n=k}k=a+8|0;j=m+4|0;if(j>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[h>>2]|0}else{c[k>>2]=c[m>>2];c[e>>2]=j;o=j;p=n}n=a+12|0;j=o+4|0;if(j>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[h>>2]|0}else{c[n>>2]=c[o>>2];c[e>>2]=j;q=j;r=p}p=a+16|0;j=q+4|0;if(j>>>0>r>>>0){Bid(e,p,4);s=c[e>>2]|0;t=c[h>>2]|0}else{c[p>>2]=c[q>>2];c[e>>2]=j;s=j;t=r}r=a+20|0;j=s+4|0;if(j>>>0>t>>>0){Bid(e,r,4);u=c[e>>2]|0;v=c[h>>2]|0}else{c[r>>2]=c[s>>2];c[e>>2]=j;u=j;v=t}t=a+24|0;j=u+4|0;if(j>>>0>v>>>0){Bid(e,t,4);w=c[e>>2]|0;x=c[h>>2]|0}else{c[t>>2]=c[u>>2];c[e>>2]=j;w=j;x=v}v=a+28|0;j=w+4|0;if(j>>>0>x>>>0){Bid(e,v,4);y=a+32|0;U6b(y,b);i=d;return}else{c[v>>2]=c[w>>2];c[e>>2]=j;y=a+32|0;U6b(y,b);i=d;return}}function A6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[h>>2]=c[a+4>>2];c[f+0>>2]=c[h+0>>2];l=hOb(j,b*12|0,4,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[h>>2]=c[a+4>>2];c[f+0>>2]=c[h+0>>2];l=cOb(b*12|0,4,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[a+8>>2]|0)*12|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b*12|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a*12|0)|0;do{if(f){g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0)}f=f+12|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function B6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b*24|0,8,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b*24|0,8,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[a+8>>2]|0)*24|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b*24|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a*24|0)|0;do{if(f){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2]}f=f+24|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function C6b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=d+12|0;g=c[f>>2]|0;h=d+20|0;if((g+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,b,1);j=c[f>>2]|0}else{a[b>>0]=a[g>>0]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;j=g}g=b+1|0;if((j+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,g,1);k=c[f>>2]|0}else{a[g>>0]=a[j>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}j=b+2|0;if((k+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,j,1);l=c[f>>2]|0}else{a[j>>0]=a[k>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}k=b+3|0;if((l+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,k,1);m=c[f>>2]|0}else{a[k>>0]=a[l>>0]|0;l=(c[f>>2]|0)+1|0;c[f>>2]=l;m=l}l=b+4|0;if((m+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,l,1);n=c[f>>2]|0}else{a[l>>0]=a[m>>0]|0;m=(c[f>>2]|0)+1|0;c[f>>2]=m;n=m}m=b+5|0;if((n+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,m,1);o=c[f>>2]|0}else{a[m>>0]=a[n>>0]|0;n=(c[f>>2]|0)+1|0;c[f>>2]=n;o=n}n=b+6|0;if((o+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,n,1);p=c[f>>2]|0}else{a[n>>0]=a[o>>0]|0;o=(c[f>>2]|0)+1|0;c[f>>2]=o;p=o}o=b+7|0;if((p+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,o,1);q=c[f>>2]|0}else{a[o>>0]=a[p>>0]|0;p=(c[f>>2]|0)+1|0;c[f>>2]=p;q=p}p=b+8|0;if((q+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,p,1);r=c[f>>2]|0}else{a[p>>0]=a[q>>0]|0;q=(c[f>>2]|0)+1|0;c[f>>2]=q;r=q}q=b+9|0;if((r+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,q,1);s=c[f>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[f>>2]|0)+1|0;c[f>>2]=r;s=r}r=b+10|0;if((s+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,r,1);t=c[f>>2]|0}else{a[r>>0]=a[s>>0]|0;s=(c[f>>2]|0)+1|0;c[f>>2]=s;t=s}s=b+11|0;if((t+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,s,1);u=c[f>>2]|0}else{a[s>>0]=a[t>>0]|0;t=(c[f>>2]|0)+1|0;c[f>>2]=t;u=t}t=b+12|0;if((u+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,t,1);v=c[f>>2]|0}else{a[t>>0]=a[u>>0]|0;u=(c[f>>2]|0)+1|0;c[f>>2]=u;v=u}u=b+13|0;if((v+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,u,1);w=c[f>>2]|0}else{a[u>>0]=a[v>>0]|0;v=(c[f>>2]|0)+1|0;c[f>>2]=v;w=v}v=b+14|0;if((w+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,v,1);x=c[f>>2]|0}else{a[v>>0]=a[w>>0]|0;w=(c[f>>2]|0)+1|0;c[f>>2]=w;x=w}w=b+15|0;if((x+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,w,1);i=e;return}else{a[w>>0]=a[x>>0]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}}function D6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/24|0)>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;o=c[j>>2]|0}n=o+24|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=((l-m|0)/24|0)+b|0;if((n|0)<0)vxi(a);l=m;m=(h-l|0)/24|0;if(m>>>0<1073741823){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/24|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=((c[j>>2]|0)-l|0)/24|0;u=10}if((u|0)==10){c[f>>2]=71;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s*24|0,16,e,0,3653512,80)|0;r=t}t=b;b=q+(r*24|0)|0;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;v=b}s=v+24|0;t=t+-1|0;if(!t){w=s;break}else b=s}b=c[a>>2]|0;t=(c[j>>2]|0)-b|0;v=q+((((t|0)/-24|0)+r|0)*24|0)|0;YEi(v|0,b|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=v;c[j>>2]=w;c[g>>2]=q+(p*24|0);if(!t){i=d;return}c[f>>2]=71;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function E6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+128|0;f=e+112|0;g=e+108|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=h+0|0;k=d+108|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(k|0));l=a+12|0;m=c[l>>2]|0;do if((m&2147483647)>>>0<b>>>0)if((m|0)>-1){c[l>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=hOb(j,b*108|0,4,f,0,3653512,370)|0;c[a>>2]=n;o=n;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=cOb(b*108|0,4,f,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,(c[a+8>>2]|0)*108|0)|0;c[l>>2]=b;c[a>>2]=n;o=n;break}else o=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}l=o+(b*108|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=o+(a*108|0)|0;do{if(f){d=f+0|0;a=h+0|0;k=d+108|0;do{c[d>>2]=c[a>>2];d=d+4|0;a=a+4|0}while((d|0)<(k|0))}f=f+108|0}while((f|0)!=(l|0));c[j>>2]=b;i=e;return}function F6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=b;l=h}h=a+4|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[e>>2]=b;m=b;n=k}k=a+8|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[j>>2]|0}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=b;q=b;r=p}p=a+16|0;b=q+4|0;if(b>>>0>r>>>0){Bid(e,p,4);s=c[e>>2]|0;t=c[j>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[e>>2]=b;s=b;t=r}r=a+20|0;b=s+4|0;if(b>>>0>t>>>0){Bid(e,r,4);u=c[e>>2]|0;v=c[j>>2]|0}else{g[r>>2]=ea(g[s>>2]);c[e>>2]=b;u=b;v=t}t=a+24|0;b=u+4|0;if(b>>>0>v>>>0){Bid(e,t,4);w=c[e>>2]|0;x=c[j>>2]|0}else{g[t>>2]=ea(g[u>>2]);c[e>>2]=b;w=b;x=v}v=a+28|0;b=w+4|0;if(b>>>0>x>>>0){Bid(e,v,4);y=c[e>>2]|0;z=c[j>>2]|0}else{g[v>>2]=ea(g[w>>2]);c[e>>2]=b;y=b;z=x}x=a+32|0;b=y+4|0;if(b>>>0>z>>>0){Bid(e,x,4);A=c[e>>2]|0;B=c[j>>2]|0}else{g[x>>2]=ea(g[y>>2]);c[e>>2]=b;A=b;B=z}z=a+36|0;b=A+4|0;if(b>>>0>B>>>0){Bid(e,z,4);C=c[e>>2]|0;D=c[j>>2]|0}else{g[z>>2]=ea(g[A>>2]);c[e>>2]=b;C=b;D=B}B=a+40|0;b=C+4|0;if(b>>>0>D>>>0){Bid(e,B,4);E=c[e>>2]|0;F=c[j>>2]|0}else{g[B>>2]=ea(g[C>>2]);c[e>>2]=b;E=b;F=D}D=a+44|0;b=E+4|0;if(b>>>0>F>>>0){Bid(e,D,4);G=c[e>>2]|0;H=c[j>>2]|0}else{g[D>>2]=ea(g[E>>2]);c[e>>2]=b;G=b;H=F}F=a+48|0;b=G+4|0;if(b>>>0>H>>>0){Bid(e,F,4);I=c[e>>2]|0;J=c[j>>2]|0}else{g[F>>2]=ea(g[G>>2]);c[e>>2]=b;I=b;J=H}H=a+52|0;b=I+4|0;if(b>>>0>J>>>0){Bid(e,H,4);K=c[e>>2]|0;L=c[j>>2]|0}else{g[H>>2]=ea(g[I>>2]);c[e>>2]=b;K=b;L=J}J=a+56|0;b=K+4|0;if(b>>>0>L>>>0){Bid(e,J,4);M=c[e>>2]|0;N=c[j>>2]|0}else{g[J>>2]=ea(g[K>>2]);c[e>>2]=b;M=b;N=L}L=a+60|0;b=M+4|0;if(b>>>0>N>>>0){Bid(e,L,4);O=c[j>>2]|0;P=c[e>>2]|0}else{g[L>>2]=ea(g[M>>2]);c[e>>2]=b;O=N;P=b}b=a+64|0;N=P+4|0;if(N>>>0>O>>>0){Bid(e,b,4);Q=c[e>>2]|0;R=c[j>>2]|0}else{g[b>>2]=ea(g[P>>2]);c[e>>2]=N;Q=N;R=O}O=a+68|0;N=Q+4|0;if(N>>>0>R>>>0){Bid(e,O,4);S=c[e>>2]|0;T=c[j>>2]|0}else{g[O>>2]=ea(g[Q>>2]);c[e>>2]=N;S=N;T=R}R=a+72|0;N=S+4|0;if(N>>>0>T>>>0){Bid(e,R,4);U=c[e>>2]|0;V=c[j>>2]|0}else{g[R>>2]=ea(g[S>>2]);c[e>>2]=N;U=N;V=T}T=a+76|0;N=U+4|0;if(N>>>0>V>>>0){Bid(e,T,4);W=c[e>>2]|0;X=c[j>>2]|0}else{g[T>>2]=ea(g[U>>2]);c[e>>2]=N;W=N;X=V}V=a+80|0;N=W+4|0;if(N>>>0>X>>>0){Bid(e,V,4);Y=c[e>>2]|0;Z=c[j>>2]|0}else{g[V>>2]=ea(g[W>>2]);c[e>>2]=N;Y=N;Z=X}X=a+84|0;N=Y+4|0;if(N>>>0>Z>>>0){Bid(e,X,4);_=c[e>>2]|0;$=c[j>>2]|0}else{g[X>>2]=ea(g[Y>>2]);c[e>>2]=N;_=N;$=Z}Z=a+88|0;N=_+4|0;if(N>>>0>$>>>0){Bid(e,Z,4);aa=c[e>>2]|0;ba=c[j>>2]|0}else{g[Z>>2]=ea(g[_>>2]);c[e>>2]=N;aa=N;ba=$}$=a+92|0;N=aa+4|0;if(N>>>0>ba>>>0){Bid(e,$,4);ca=c[e>>2]|0;da=c[j>>2]|0}else{g[$>>2]=ea(g[aa>>2]);c[e>>2]=N;ca=N;da=ba}ba=a+96|0;N=ca+4|0;if(N>>>0>da>>>0){Bid(e,ba,4);fa=c[e>>2]|0;ga=c[j>>2]|0}else{g[ba>>2]=ea(g[ca>>2]);c[e>>2]=N;fa=N;ga=da}da=a+100|0;N=fa+4|0;if(N>>>0>ga>>>0){Bid(e,da,4);ha=c[e>>2]|0;ia=c[j>>2]|0}else{g[da>>2]=ea(g[fa>>2]);c[e>>2]=N;ha=N;ia=ga}ga=a+104|0;a=ha+4|0;if(a>>>0>ia>>>0){Bid(e,ga,4);i=d;return}else{g[ga>>2]=ea(g[ha>>2]);c[e>>2]=a;i=d;return}}function G6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;j=c[h>>2]|0;if(g>>>0>j>>>0){Bid(e,a,4);k=c[e>>2]|0;l=c[h>>2]|0;m=c[a>>2]|0}else{n=c[f>>2]|0;c[a>>2]=n;c[e>>2]=g;k=g;l=j;m=n}c[a>>2]=XEi(m|0)|0;m=a+4|0;n=k+4|0;if(n>>>0>l>>>0){Bid(e,m,4);o=c[m>>2]|0;p=c[e>>2]|0;q=c[h>>2]|0}else{j=c[k>>2]|0;c[m>>2]=j;c[e>>2]=n;o=j;p=n;q=l}c[m>>2]=XEi(o|0)|0;o=a+8|0;m=p+4|0;if(m>>>0>q>>>0){Bid(e,o,4);r=c[o>>2]|0;s=c[e>>2]|0;t=c[h>>2]|0}else{l=c[p>>2]|0;c[o>>2]=l;c[e>>2]=m;r=l;s=m;t=q}c[o>>2]=XEi(r|0)|0;r=a+12|0;o=s+4|0;if(o>>>0>t>>>0){Bid(e,r,4);u=c[r>>2]|0;v=c[e>>2]|0;w=c[h>>2]|0}else{q=c[s>>2]|0;c[r>>2]=q;c[e>>2]=o;u=q;v=o;w=t}c[r>>2]=XEi(u|0)|0;u=a+16|0;r=v+4|0;if(r>>>0>w>>>0){Bid(e,u,4);x=c[u>>2]|0;y=c[e>>2]|0;z=c[h>>2]|0}else{t=c[v>>2]|0;c[u>>2]=t;c[e>>2]=r;x=t;y=r;z=w}c[u>>2]=XEi(x|0)|0;x=a+20|0;u=y+4|0;if(u>>>0>z>>>0){Bid(e,x,4);A=c[x>>2]|0;B=c[e>>2]|0;C=c[h>>2]|0}else{w=c[y>>2]|0;c[x>>2]=w;c[e>>2]=u;A=w;B=u;C=z}c[x>>2]=XEi(A|0)|0;A=a+24|0;x=B+4|0;if(x>>>0>C>>>0){Bid(e,A,4);D=c[A>>2]|0;E=c[e>>2]|0;F=c[h>>2]|0}else{h=c[B>>2]|0;c[A>>2]=h;c[e>>2]=x;D=h;E=x;F=C}c[A>>2]=XEi(D|0)|0;D=a+28|0;A=E+4|0;if(A>>>0>F>>>0){Bid(e,D,4);G=c[D>>2]|0;H=XEi(G|0)|0;c[D>>2]=H;I=a+32|0;V6b(I,b);i=d;return}else{F=c[E>>2]|0;c[D>>2]=F;c[e>>2]=A;G=F;H=XEi(G|0)|0;c[D>>2]=H;I=a+32|0;V6b(I,b);i=d;return}}function H6b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=d+12|0;g=c[f>>2]|0;h=d+20|0;if((g+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,b,1);j=c[f>>2]|0}else{a[b>>0]=a[g>>0]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;j=g}g=b+1|0;if((j+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,g,1);k=c[f>>2]|0}else{a[g>>0]=a[j>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}j=b+2|0;if((k+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,j,1);l=c[f>>2]|0}else{a[j>>0]=a[k>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}k=b+3|0;if((l+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,k,1);m=c[f>>2]|0}else{a[k>>0]=a[l>>0]|0;l=(c[f>>2]|0)+1|0;c[f>>2]=l;m=l}l=b+4|0;if((m+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,l,1);n=c[f>>2]|0}else{a[l>>0]=a[m>>0]|0;m=(c[f>>2]|0)+1|0;c[f>>2]=m;n=m}m=b+5|0;if((n+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,m,1);o=c[f>>2]|0}else{a[m>>0]=a[n>>0]|0;n=(c[f>>2]|0)+1|0;c[f>>2]=n;o=n}n=b+6|0;if((o+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,n,1);p=c[f>>2]|0}else{a[n>>0]=a[o>>0]|0;o=(c[f>>2]|0)+1|0;c[f>>2]=o;p=o}o=b+7|0;if((p+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,o,1);q=c[f>>2]|0}else{a[o>>0]=a[p>>0]|0;p=(c[f>>2]|0)+1|0;c[f>>2]=p;q=p}p=b+8|0;if((q+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,p,1);r=c[f>>2]|0}else{a[p>>0]=a[q>>0]|0;q=(c[f>>2]|0)+1|0;c[f>>2]=q;r=q}q=b+9|0;if((r+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,q,1);s=c[f>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[f>>2]|0)+1|0;c[f>>2]=r;s=r}r=b+10|0;if((s+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,r,1);t=c[f>>2]|0}else{a[r>>0]=a[s>>0]|0;s=(c[f>>2]|0)+1|0;c[f>>2]=s;t=s}s=b+11|0;if((t+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,s,1);u=c[f>>2]|0}else{a[s>>0]=a[t>>0]|0;t=(c[f>>2]|0)+1|0;c[f>>2]=t;u=t}t=b+12|0;if((u+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,t,1);v=c[f>>2]|0}else{a[t>>0]=a[u>>0]|0;u=(c[f>>2]|0)+1|0;c[f>>2]=u;v=u}u=b+13|0;if((v+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,u,1);w=c[f>>2]|0}else{a[u>>0]=a[v>>0]|0;v=(c[f>>2]|0)+1|0;c[f>>2]=v;w=v}v=b+14|0;if((w+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,v,1);x=c[f>>2]|0}else{a[v>>0]=a[w>>0]|0;w=(c[f>>2]|0)+1|0;c[f>>2]=w;x=w}w=b+15|0;if((x+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,w,1);i=e;return}else{a[w>>0]=a[x>>0]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}}function I6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;u=w+4|0;if(u>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=c[e>>2]|0;B=c[j>>2]|0}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=u;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=a+16|0;y=A+4|0;if(y>>>0>B>>>0){Bid(e,z,4);C=z;D=c[z>>2]|0;E=c[e>>2]|0;F=c[j>>2]|0}else{p=ea(g[A>>2]);g[z>>2]=p;c[e>>2]=y;C=z;D=(g[k>>2]=p,c[k>>2]|0);E=y;F=B}c[C>>2]=XEi(D|0)|0;D=a+20|0;C=E+4|0;if(C>>>0>F>>>0){Bid(e,D,4);G=D;H=c[D>>2]|0;I=c[e>>2]|0;J=c[j>>2]|0}else{p=ea(g[E>>2]);g[D>>2]=p;c[e>>2]=C;G=D;H=(g[k>>2]=p,c[k>>2]|0);I=C;J=F}c[G>>2]=XEi(H|0)|0;H=a+24|0;G=I+4|0;if(G>>>0>J>>>0){Bid(e,H,4);K=H;L=c[H>>2]|0;M=c[e>>2]|0;N=c[j>>2]|0}else{p=ea(g[I>>2]);g[H>>2]=p;c[e>>2]=G;K=H;L=(g[k>>2]=p,c[k>>2]|0);M=G;N=J}c[K>>2]=XEi(L|0)|0;L=a+28|0;K=M+4|0;if(K>>>0>N>>>0){Bid(e,L,4);O=L;P=c[L>>2]|0;Q=c[e>>2]|0;R=c[j>>2]|0}else{p=ea(g[M>>2]);g[L>>2]=p;c[e>>2]=K;O=L;P=(g[k>>2]=p,c[k>>2]|0);Q=K;R=N}c[O>>2]=XEi(P|0)|0;P=a+32|0;O=Q+4|0;if(O>>>0>R>>>0){Bid(e,P,4);S=P;T=c[P>>2]|0;U=c[e>>2]|0;V=c[j>>2]|0}else{p=ea(g[Q>>2]);g[P>>2]=p;c[e>>2]=O;S=P;T=(g[k>>2]=p,c[k>>2]|0);U=O;V=R}c[S>>2]=XEi(T|0)|0;T=a+36|0;S=U+4|0;if(S>>>0>V>>>0){Bid(e,T,4);W=T;X=c[T>>2]|0;Y=c[e>>2]|0;Z=c[j>>2]|0}else{p=ea(g[U>>2]);g[T>>2]=p;c[e>>2]=S;W=T;X=(g[k>>2]=p,c[k>>2]|0);Y=S;Z=V}c[W>>2]=XEi(X|0)|0;X=a+40|0;W=Y+4|0;if(W>>>0>Z>>>0){Bid(e,X,4);_=X;$=c[e>>2]|0;aa=c[j>>2]|0;ba=c[X>>2]|0}else{p=ea(g[Y>>2]);g[X>>2]=p;c[e>>2]=W;_=X;$=W;aa=Z;ba=(g[k>>2]=p,c[k>>2]|0)}c[_>>2]=XEi(ba|0)|0;ba=a+44|0;_=$+4|0;if(_>>>0>aa>>>0){Bid(e,ba,4);ca=ba;da=c[ba>>2]|0;fa=c[e>>2]|0;ga=c[j>>2]|0}else{p=ea(g[$>>2]);g[ba>>2]=p;c[e>>2]=_;ca=ba;da=(g[k>>2]=p,c[k>>2]|0);fa=_;ga=aa}c[ca>>2]=XEi(da|0)|0;da=a+48|0;ca=fa+4|0;if(ca>>>0>ga>>>0){Bid(e,da,4);ha=da;ia=c[da>>2]|0;ja=c[e>>2]|0;ka=c[j>>2]|0}else{p=ea(g[fa>>2]);g[da>>2]=p;c[e>>2]=ca;ha=da;ia=(g[k>>2]=p,c[k>>2]|0);ja=ca;ka=ga}c[ha>>2]=XEi(ia|0)|0;ia=a+52|0;ha=ja+4|0;if(ha>>>0>ka>>>0){Bid(e,ia,4);la=ia;ma=c[ia>>2]|0;na=c[e>>2]|0;oa=c[j>>2]|0}else{p=ea(g[ja>>2]);g[ia>>2]=p;c[e>>2]=ha;la=ia;ma=(g[k>>2]=p,c[k>>2]|0);na=ha;oa=ka}c[la>>2]=XEi(ma|0)|0;ma=a+56|0;la=na+4|0;if(la>>>0>oa>>>0){Bid(e,ma,4);pa=ma;qa=c[ma>>2]|0;ra=c[e>>2]|0;sa=c[j>>2]|0}else{p=ea(g[na>>2]);g[ma>>2]=p;c[e>>2]=la;pa=ma;qa=(g[k>>2]=p,c[k>>2]|0);ra=la;sa=oa}c[pa>>2]=XEi(qa|0)|0;qa=a+60|0;pa=ra+4|0;if(pa>>>0>sa>>>0){Bid(e,qa,4);ta=qa;ua=c[qa>>2]|0;va=c[e>>2]|0;wa=c[j>>2]|0}else{p=ea(g[ra>>2]);g[qa>>2]=p;c[e>>2]=pa;ta=qa;ua=(g[k>>2]=p,c[k>>2]|0);va=pa;wa=sa}c[ta>>2]=XEi(ua|0)|0;ua=a+64|0;ta=va+4|0;if(ta>>>0>wa>>>0){Bid(e,ua,4);xa=ua;ya=c[ua>>2]|0;za=c[e>>2]|0;Aa=c[j>>2]|0}else{p=ea(g[va>>2]);g[ua>>2]=p;c[e>>2]=ta;xa=ua;ya=(g[k>>2]=p,c[k>>2]|0);za=ta;Aa=wa}c[xa>>2]=XEi(ya|0)|0;ya=a+68|0;xa=za+4|0;if(xa>>>0>Aa>>>0){Bid(e,ya,4);Ba=ya;Ca=c[ya>>2]|0;Da=c[e>>2]|0;Ea=c[j>>2]|0}else{p=ea(g[za>>2]);g[ya>>2]=p;c[e>>2]=xa;Ba=ya;Ca=(g[k>>2]=p,c[k>>2]|0);Da=xa;Ea=Aa}c[Ba>>2]=XEi(Ca|0)|0;Ca=a+72|0;Ba=Da+4|0;if(Ba>>>0>Ea>>>0){Bid(e,Ca,4);Fa=Ca;Ga=c[Ca>>2]|0;Ha=c[e>>2]|0;Ia=c[j>>2]|0}else{p=ea(g[Da>>2]);g[Ca>>2]=p;c[e>>2]=Ba;Fa=Ca;Ga=(g[k>>2]=p,c[k>>2]|0);Ha=Ba;Ia=Ea}c[Fa>>2]=XEi(Ga|0)|0;Ga=a+76|0;Fa=Ha+4|0;if(Fa>>>0>Ia>>>0){Bid(e,Ga,4);Ja=Ga;Ka=c[Ga>>2]|0;La=c[e>>2]|0;Ma=c[j>>2]|0}else{p=ea(g[Ha>>2]);g[Ga>>2]=p;c[e>>2]=Fa;Ja=Ga;Ka=(g[k>>2]=p,c[k>>2]|0);La=Fa;Ma=Ia}c[Ja>>2]=XEi(Ka|0)|0;Ka=a+80|0;Ja=La+4|0;if(Ja>>>0>Ma>>>0){Bid(e,Ka,4);Na=Ka;Oa=c[Ka>>2]|0;Pa=c[e>>2]|0;Qa=c[j>>2]|0}else{p=ea(g[La>>2]);g[Ka>>2]=p;c[e>>2]=Ja;Na=Ka;Oa=(g[k>>2]=p,c[k>>2]|0);Pa=Ja;Qa=Ma}c[Na>>2]=XEi(Oa|0)|0;Oa=a+84|0;Na=Pa+4|0;if(Na>>>0>Qa>>>0){Bid(e,Oa,4);Ra=Oa;Sa=c[Oa>>2]|0;Ta=c[e>>2]|0;Ua=c[j>>2]|0}else{p=ea(g[Pa>>2]);g[Oa>>2]=p;c[e>>2]=Na;Ra=Oa;Sa=(g[k>>2]=p,c[k>>2]|0);Ta=Na;Ua=Qa}c[Ra>>2]=XEi(Sa|0)|0;Sa=a+88|0;Ra=Ta+4|0;if(Ra>>>0>Ua>>>0){Bid(e,Sa,4);Va=Sa;Wa=c[Sa>>2]|0;Xa=c[e>>2]|0;Ya=c[j>>2]|0}else{p=ea(g[Ta>>2]);g[Sa>>2]=p;c[e>>2]=Ra;Va=Sa;Wa=(g[k>>2]=p,c[k>>2]|0);Xa=Ra;Ya=Ua}c[Va>>2]=XEi(Wa|0)|0;Wa=a+92|0;Va=Xa+4|0;if(Va>>>0>Ya>>>0){Bid(e,Wa,4);Za=Wa;_a=c[Wa>>2]|0;$a=c[e>>2]|0;ab=c[j>>2]|0}else{p=ea(g[Xa>>2]);g[Wa>>2]=p;c[e>>2]=Va;Za=Wa;_a=(g[k>>2]=p,c[k>>2]|0);$a=Va;ab=Ya}c[Za>>2]=XEi(_a|0)|0;_a=a+96|0;Za=$a+4|0;if(Za>>>0>ab>>>0){Bid(e,_a,4);bb=_a;cb=c[_a>>2]|0;db=c[e>>2]|0;eb=c[j>>2]|0}else{p=ea(g[$a>>2]);g[_a>>2]=p;c[e>>2]=Za;bb=_a;cb=(g[k>>2]=p,c[k>>2]|0);db=Za;eb=ab}c[bb>>2]=XEi(cb|0)|0;cb=a+100|0;bb=db+4|0;if(bb>>>0>eb>>>0){Bid(e,cb,4);fb=cb;gb=c[cb>>2]|0;hb=c[e>>2]|0;ib=c[j>>2]|0}else{p=ea(g[db>>2]);g[cb>>2]=p;c[e>>2]=bb;fb=cb;gb=(g[k>>2]=p,c[k>>2]|0);hb=bb;ib=eb}c[fb>>2]=XEi(gb|0)|0;gb=a+104|0;a=hb+4|0;if(a>>>0>ib>>>0){Bid(e,gb,4);jb=gb;kb=c[gb>>2]|0;lb=XEi(kb|0)|0;c[jb>>2]=lb;i=d;return}else{p=ea(g[hb>>2]);g[gb>>2]=p;c[e>>2]=a;jb=gb;kb=(g[k>>2]=p,c[k>>2]|0);lb=XEi(kb|0)|0;c[jb>>2]=lb;i=d;return}}function J6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;j=c[h>>2]|0;if(g>>>0<j>>>0){c[f>>2]=c[a>>2];c[e>>2]=g;k=j;l=g}else{Gid(e,a,4);k=c[h>>2]|0;l=c[e>>2]|0}g=a+4|0;j=l+4|0;if(j>>>0<k>>>0){c[l>>2]=c[g>>2];c[e>>2]=j;m=j;n=k}else{Gid(e,g,4);m=c[e>>2]|0;n=c[h>>2]|0}g=a+8|0;k=m+4|0;if(k>>>0<n>>>0){c[m>>2]=c[g>>2];c[e>>2]=k;o=k;p=n}else{Gid(e,g,4);o=c[e>>2]|0;p=c[h>>2]|0}g=a+12|0;n=o+4|0;if(n>>>0<p>>>0){c[o>>2]=c[g>>2];c[e>>2]=n;q=n;r=p}else{Gid(e,g,4);q=c[e>>2]|0;r=c[h>>2]|0}g=a+16|0;p=q+4|0;if(p>>>0<r>>>0){c[q>>2]=c[g>>2];c[e>>2]=p;s=p;t=r}else{Gid(e,g,4);s=c[e>>2]|0;t=c[h>>2]|0}g=a+20|0;r=s+4|0;if(r>>>0<t>>>0){c[s>>2]=c[g>>2];c[e>>2]=r;u=r;v=t}else{Gid(e,g,4);u=c[e>>2]|0;v=c[h>>2]|0}g=a+24|0;t=u+4|0;if(t>>>0<v>>>0){c[u>>2]=c[g>>2];c[e>>2]=t;w=t;x=v}else{Gid(e,g,4);w=c[e>>2]|0;x=c[h>>2]|0}h=a+28|0;g=w+4|0;if(g>>>0<x>>>0){c[w>>2]=c[h>>2];c[e>>2]=g;y=a+32|0;W6b(y,b);i=d;return}else{Gid(e,h,4);y=a+32|0;W6b(y,b);i=d;return}}function K6b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;d=e;f=b+8|0;h=c[f>>2]|0;c[d>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k+4|0;m=a+20|0;if(l>>>0<(c[m>>2]|0)>>>0){c[k>>2]=h;c[j>>2]=l}else Gid(j,d,4);d=c[b>>2]|0;b=c[f>>2]|0;f=d+(b*12|0)|0;if(!b){i=e;return}else n=d;do{d=c[j>>2]|0;b=d+4|0;l=c[m>>2]|0;if(b>>>0<l>>>0){g[d>>2]=ea(g[n>>2]);c[j>>2]=b;o=b;p=l}else{Gid(j,n,4);o=c[j>>2]|0;p=c[m>>2]|0}l=n+4|0;b=o+4|0;if(b>>>0<p>>>0){g[o>>2]=ea(g[l>>2]);c[j>>2]=b;q=b;r=p}else{Gid(j,l,4);q=c[j>>2]|0;r=c[m>>2]|0}l=n+8|0;b=q+4|0;if(b>>>0<r>>>0){g[q>>2]=ea(g[l>>2]);c[j>>2]=b}else Gid(j,l,4);n=n+12|0}while((n|0)!=(f|0));i=e;return}function L6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+8|0;g=c[f>>2]|0;c[e>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j+4|0;l=a+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);e=c[b>>2]|0;b=c[f>>2]|0;f=e+(b*24|0)|0;if(!b){i=d;return}else m=e;do{M6b(m,a);e=m+16|0;b=c[h>>2]|0;k=b+4|0;g=c[l>>2]|0;if(k>>>0<g>>>0){c[b>>2]=c[e>>2];c[h>>2]=k;n=k;o=g}else{Gid(h,e,4);n=c[h>>2]|0;o=c[l>>2]|0}e=m+20|0;g=n+4|0;if(g>>>0<o>>>0){c[n>>2]=c[e>>2];c[h>>2]=g}else Gid(h,e,4);m=m+24|0}while((m|0)!=(f|0));i=d;return}function M6b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=d+12|0;g=c[f>>2]|0;h=d+20|0;if((g+1|0)>>>0<(c[h>>2]|0)>>>0){a[g>>0]=a[b>>0]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;j=g}else{Gid(f,b,1);j=c[f>>2]|0}g=b+1|0;if((j+1|0)>>>0<(c[h>>2]|0)>>>0){a[j>>0]=a[g>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}else{Gid(f,g,1);k=c[f>>2]|0}g=b+2|0;if((k+1|0)>>>0<(c[h>>2]|0)>>>0){a[k>>0]=a[g>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}else{Gid(f,g,1);l=c[f>>2]|0}g=b+3|0;if((l+1|0)>>>0<(c[h>>2]|0)>>>0){a[l>>0]=a[g>>0]|0;l=(c[f>>2]|0)+1|0;c[f>>2]=l;m=l}else{Gid(f,g,1);m=c[f>>2]|0}g=b+4|0;if((m+1|0)>>>0<(c[h>>2]|0)>>>0){a[m>>0]=a[g>>0]|0;m=(c[f>>2]|0)+1|0;c[f>>2]=m;n=m}else{Gid(f,g,1);n=c[f>>2]|0}g=b+5|0;if((n+1|0)>>>0<(c[h>>2]|0)>>>0){a[n>>0]=a[g>>0]|0;n=(c[f>>2]|0)+1|0;c[f>>2]=n;o=n}else{Gid(f,g,1);o=c[f>>2]|0}g=b+6|0;if((o+1|0)>>>0<(c[h>>2]|0)>>>0){a[o>>0]=a[g>>0]|0;o=(c[f>>2]|0)+1|0;c[f>>2]=o;p=o}else{Gid(f,g,1);p=c[f>>2]|0}g=b+7|0;if((p+1|0)>>>0<(c[h>>2]|0)>>>0){a[p>>0]=a[g>>0]|0;p=(c[f>>2]|0)+1|0;c[f>>2]=p;q=p}else{Gid(f,g,1);q=c[f>>2]|0}g=b+8|0;if((q+1|0)>>>0<(c[h>>2]|0)>>>0){a[q>>0]=a[g>>0]|0;q=(c[f>>2]|0)+1|0;c[f>>2]=q;r=q}else{Gid(f,g,1);r=c[f>>2]|0}g=b+9|0;if((r+1|0)>>>0<(c[h>>2]|0)>>>0){a[r>>0]=a[g>>0]|0;r=(c[f>>2]|0)+1|0;c[f>>2]=r;s=r}else{Gid(f,g,1);s=c[f>>2]|0}g=b+10|0;if((s+1|0)>>>0<(c[h>>2]|0)>>>0){a[s>>0]=a[g>>0]|0;s=(c[f>>2]|0)+1|0;c[f>>2]=s;t=s}else{Gid(f,g,1);t=c[f>>2]|0}g=b+11|0;if((t+1|0)>>>0<(c[h>>2]|0)>>>0){a[t>>0]=a[g>>0]|0;t=(c[f>>2]|0)+1|0;c[f>>2]=t;u=t}else{Gid(f,g,1);u=c[f>>2]|0}g=b+12|0;if((u+1|0)>>>0<(c[h>>2]|0)>>>0){a[u>>0]=a[g>>0]|0;u=(c[f>>2]|0)+1|0;c[f>>2]=u;v=u}else{Gid(f,g,1);v=c[f>>2]|0}g=b+13|0;if((v+1|0)>>>0<(c[h>>2]|0)>>>0){a[v>>0]=a[g>>0]|0;v=(c[f>>2]|0)+1|0;c[f>>2]=v;w=v}else{Gid(f,g,1);w=c[f>>2]|0}g=b+14|0;if((w+1|0)>>>0<(c[h>>2]|0)>>>0){a[w>>0]=a[g>>0]|0;w=(c[f>>2]|0)+1|0;c[f>>2]=w;x=w}else{Gid(f,g,1);x=c[f>>2]|0}g=b+15|0;if((x+1|0)>>>0<(c[h>>2]|0)>>>0){a[x>>0]=a[g>>0]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}else{Gid(f,g,1);i=e;return}}function N6b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a+68>>2]|0;if(g){h=a+72|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~(((j+-24-g|0)>>>0)/24|0)*24|0);c[f>>2]=71;c[d+0>>2]=c[f+0>>2];eOb(g,d)}if((c[a+60>>2]|0)>-1){g=a+48|0;f=c[g>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[g>>2]=0}if((c[a+44>>2]|0)<=-1){X6b(a);i=b;return}g=a+32|0;f=c[g>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[g>>2]=0;X6b(a);i=b;return}function O6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142268]|0;add(b,574944,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574952,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574960,e,a+24|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574968,e,a+36|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574976,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574984,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574992,e,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575e3,e,a+40|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575008,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575016,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142268]|0;add(b,575024,e,a+32|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575032,e,a+44|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function P6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[142306]|0;g=qdd(b,563384,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else Y6b(b,a,0);sdd(b)}g=a+16|0;a=qdd(b,563400,f,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}else R6b(b,g,0);sdd(b);i=d;return}function Q6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];B6b(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*24|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,563568,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Z6b(r,a);t=r+24|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,563568,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else Z6b(m,a);sdd(a)}m=m+24|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function R6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];A6b(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*12|0)|0;do if(c[f>>2]|0){j=c[142310]|0;g=qdd(a,3142592,j,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((g|0)==2){g=c[l>>2]|0;o=c[g+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(k|0)){q=0;r=g;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(h,r);t=h;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;_6b(s,a);u=s+12|0;if((u|0)==(k|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(k|0)){n=l;do{l=qdd(a,3142592,j,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else _6b(n,a);sdd(a)}n=n+12|0}while((n|0)!=(k|0))}}while(0);udd(a);i=d;return}function S6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+8|0;j=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[j>>2]|0)|0)/24|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;l=b+4|0;b=c[h>>2]|0;m=c[l>>2]|0;n=(b-m|0)/24|0;if(k>>>0<=n>>>0)if(k>>>0<n>>>0?(o=m+(k*24|0)|0,(b|0)!=(o|0)):0){m=b+(~(((b+-24-o|0)>>>0)/24|0)*24|0)|0;c[h>>2]=m;p=k;q=m}else{p=k;q=b}else{D6b(l,k-n|0);p=c[f>>2]|0;q=c[h>>2]|0}do if(p){h=c[142274]|0;f=qdd(a,3142592,h,0,1)|0;n=a+80|0;k=c[($hd(c[n>>2]|0)|0)+12>>2]|0;l=a+84|0;c[c[l>>2]>>2]=0;if((f|0)==2){f=c[n>>2]|0;b=c[f+12>>2]|0;m=c[j>>2]|0;a:do if((m|0)!=(q|0)){o=0;r=f;s=m;while(1){t=(da(o,k)|0)+b|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[l>>2]|0;c[u>>2]=(c[u>>2]|0)+1;$6b(s,a);u=s+24|0;if((u|0)==(q|0))break a;o=c[c[l>>2]>>2]|0;r=c[n>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);n=c[j>>2]|0;if((n|0)!=(q|0)){l=n;do{n=qdd(a,3142592,h,e,1)|0;if(n){if((n|0)<=0){n=c[e>>2]|0;if(n)_n[n&4095](l,a)|0}else $6b(l,a);sdd(a)}l=l+24|0}while((l|0)!=(q|0))}}while(0);udd(a);i=d;return}function T6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,562808,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,562816,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,562824,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;m=qdd(b,562832,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+16|0;m=qdd(b,562840,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+20|0;m=qdd(b,562848,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+24|0;m=qdd(b,562856,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+28|0;m=qdd(b,562864,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+32|0;m=qdd(b,562872,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+36|0;m=qdd(b,562880,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+40|0;m=qdd(b,562888,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+44|0;m=qdd(b,562896,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+48|0;m=qdd(b,562904,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+52|0;m=qdd(b,562912,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+56|0;m=qdd(b,562920,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;do if((j|0)<0)o=160;else{l=n+(j+4)|0;if(l>>>0>(c[b+20>>2]|0)>>>0){o=160;break}g[h>>2]=ea(g[k>>2]);c[m>>2]=l}while(0);if((o|0)==160)Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+60|0;m=qdd(b,562928,f,e,0)|0;if(m){do if((m|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](h,b)|0}else{k=b+12|0;j=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+n|0;c[k>>2]=l;do if((n|0)<0)o=171;else{p=j+(n+4)|0;if(p>>>0>(c[b+20>>2]|0)>>>0){o=171;break}g[h>>2]=ea(g[l>>2]);c[k>>2]=p}while(0);if((o|0)==171)Bid(k,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}while(0);sdd(b)}h=a+64|0;m=qdd(b,562936,f,e,0)|0;if(m){do if((m|0)>0){l=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;p=n+j|0;c[l>>2]=p;do if((j|0)<0)o=182;else{q=n+(j+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=182;break}g[h>>2]=ea(g[p>>2]);c[l>>2]=q}while(0);if((o|0)==182)Bid(l,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[e>>2]|0;if(!p)break;_n[p&4095](h,b)|0}while(0);sdd(b)}h=a+68|0;m=qdd(b,562944,f,e,0)|0;if(m){do if((m|0)>0){p=b+12|0;j=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=j+n|0;c[p>>2]=k;do if((n|0)<0)o=193;else{q=j+(n+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=193;break}g[h>>2]=ea(g[k>>2]);c[p>>2]=q}while(0);if((o|0)==193)Bid(p,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[e>>2]|0;if(!k)break;_n[k&4095](h,b)|0}while(0);sdd(b)}h=a+72|0;m=qdd(b,562952,f,e,0)|0;if(m){do if((m|0)>0){k=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=n+j|0;c[k>>2]=l;do if((j|0)<0)o=204;else{q=n+(j+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=204;break}g[h>>2]=ea(g[l>>2]);c[k>>2]=q}while(0);if((o|0)==204)Bid(k,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[e>>2]|0;if(!l)break;_n[l&4095](h,b)|0}while(0);sdd(b)}h=a+76|0;m=qdd(b,562960,f,e,0)|0;if(m){do if((m|0)>0){l=b+12|0;j=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;p=j+n|0;c[l>>2]=p;do if((n|0)<0)o=215;else{q=j+(n+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=215;break}g[h>>2]=ea(g[p>>2]);c[l>>2]=q}while(0);if((o|0)==215)Bid(l,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[e>>2]|0;if(!p)break;_n[p&4095](h,b)|0}while(0);sdd(b)}h=a+80|0;m=qdd(b,562968,f,e,0)|0;if(m){do if((m|0)>0){p=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[p>>2]=k;do if((j|0)<0)o=226;else{q=n+(j+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=226;break}g[h>>2]=ea(g[k>>2]);c[p>>2]=q}while(0);if((o|0)==226)Bid(p,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[e>>2]|0;if(!k)break;_n[k&4095](h,b)|0}while(0);sdd(b)}h=a+84|0;m=qdd(b,562976,f,e,0)|0;if(m){do if((m|0)>0){k=b+12|0;j=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+n|0;c[k>>2]=l;do if((n|0)<0)o=237;else{q=j+(n+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=237;break}g[h>>2]=ea(g[l>>2]);c[k>>2]=q}while(0);if((o|0)==237)Bid(k,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[e>>2]|0;if(!l)break;_n[l&4095](h,b)|0}while(0);sdd(b)}h=a+88|0;m=qdd(b,562984,f,e,0)|0;if(m){do if((m|0)>0){l=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;p=n+j|0;c[l>>2]=p;do if((j|0)<0)o=248;else{q=n+(j+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=248;break}g[h>>2]=ea(g[p>>2]);c[l>>2]=q}while(0);if((o|0)==248)Bid(l,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[e>>2]|0;if(!p)break;_n[p&4095](h,b)|0}while(0);sdd(b)}h=a+92|0;m=qdd(b,562992,f,e,0)|0;if(m){do if((m|0)>0){p=b+12|0;j=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=j+n|0;c[p>>2]=k;do if((n|0)<0)o=259;else{q=j+(n+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=259;break}g[h>>2]=ea(g[k>>2]);c[p>>2]=q}while(0);if((o|0)==259)Bid(p,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[e>>2]|0;if(!k)break;_n[k&4095](h,b)|0}while(0);sdd(b)}h=a+96|0;m=qdd(b,563e3,f,e,0)|0;if(m){do if((m|0)>0){k=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=n+j|0;c[k>>2]=l;do if((j|0)<0)o=270;else{q=n+(j+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=270;break}g[h>>2]=ea(g[l>>2]);c[k>>2]=q}while(0);if((o|0)==270)Bid(k,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[e>>2]|0;if(!l)break;_n[l&4095](h,b)|0}while(0);sdd(b)}h=a+100|0;m=qdd(b,563008,f,e,0)|0;if(m){do if((m|0)>0){l=b+12|0;j=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;p=j+n|0;c[l>>2]=p;do if((n|0)<0)o=281;else{q=j+(n+4)|0;if(q>>>0>(c[b+20>>2]|0)>>>0){o=281;break}g[h>>2]=ea(g[p>>2]);c[l>>2]=q}while(0);if((o|0)==281)Bid(l,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[e>>2]|0;if(!p)break;_n[p&4095](h,b)|0}while(0);sdd(b)}h=a+104|0;a=qdd(b,563016,f,e,0)|0;if(!a){i=d;return}do if((a|0)>0){f=b+12|0;m=c[b+16>>2]|0;p=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;n=m+p|0;c[f>>2]=n;do if((p|0)<0)o=292;else{j=m+(p+4)|0;if(j>>>0>(c[b+20>>2]|0)>>>0){o=292;break}g[h>>2]=ea(g[n>>2]);c[f>>2]=j}while(0);if((o|0)==292)Bid(f,h,4);if(!(c[b>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[e>>2]|0;if(!n)break;_n[n&4095](h,b)|0}while(0);sdd(b);i=d;return}function U6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=b;l=h}h=a+12|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[e>>2]=b;m=b;n=k}k=a+24|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+36|0;b=o+4|0;if(b>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[j>>2]|0}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=b;q=b;r=p}p=a+4|0;b=q+4|0;if(b>>>0>r>>>0){Bid(e,p,4);s=c[e>>2]|0;t=c[j>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[e>>2]=b;s=b;t=r}r=a+16|0;b=s+4|0;if(b>>>0>t>>>0){Bid(e,r,4);u=c[e>>2]|0;v=c[j>>2]|0}else{g[r>>2]=ea(g[s>>2]);c[e>>2]=b;u=b;v=t}t=a+28|0;b=u+4|0;if(b>>>0>v>>>0){Bid(e,t,4);w=c[e>>2]|0;x=c[j>>2]|0}else{g[t>>2]=ea(g[u>>2]);c[e>>2]=b;w=b;x=v}v=a+40|0;b=w+4|0;if(b>>>0>x>>>0){Bid(e,v,4);y=c[e>>2]|0;z=c[j>>2]|0}else{g[v>>2]=ea(g[w>>2]);c[e>>2]=b;y=b;z=x}x=a+8|0;b=y+4|0;if(b>>>0>z>>>0){Bid(e,x,4);A=c[e>>2]|0;B=c[j>>2]|0}else{g[x>>2]=ea(g[y>>2]);c[e>>2]=b;A=b;B=z}z=a+20|0;b=A+4|0;if(b>>>0>B>>>0){Bid(e,z,4);C=c[e>>2]|0;D=c[j>>2]|0}else{g[z>>2]=ea(g[A>>2]);c[e>>2]=b;C=b;D=B}B=a+32|0;b=C+4|0;if(b>>>0>D>>>0){Bid(e,B,4);E=c[e>>2]|0;F=c[j>>2]|0}else{g[B>>2]=ea(g[C>>2]);c[e>>2]=b;E=b;F=D}D=a+44|0;a=E+4|0;if(a>>>0>F>>>0){Bid(e,D,4);i=d;return}else{g[D>>2]=ea(g[E>>2]);c[e>>2]=a;i=d;return}}function V6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+12|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+24|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+36|0;u=w+4|0;if(u>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=c[e>>2]|0;B=c[j>>2]|0}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=u;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=a+4|0;y=A+4|0;if(y>>>0>B>>>0){Bid(e,z,4);C=z;D=c[z>>2]|0;E=c[e>>2]|0;F=c[j>>2]|0}else{p=ea(g[A>>2]);g[z>>2]=p;c[e>>2]=y;C=z;D=(g[k>>2]=p,c[k>>2]|0);E=y;F=B}c[C>>2]=XEi(D|0)|0;D=a+16|0;C=E+4|0;if(C>>>0>F>>>0){Bid(e,D,4);G=D;H=c[D>>2]|0;I=c[e>>2]|0;J=c[j>>2]|0}else{p=ea(g[E>>2]);g[D>>2]=p;c[e>>2]=C;G=D;H=(g[k>>2]=p,c[k>>2]|0);I=C;J=F}c[G>>2]=XEi(H|0)|0;H=a+28|0;G=I+4|0;if(G>>>0>J>>>0){Bid(e,H,4);K=H;L=c[H>>2]|0;M=c[e>>2]|0;N=c[j>>2]|0}else{p=ea(g[I>>2]);g[H>>2]=p;c[e>>2]=G;K=H;L=(g[k>>2]=p,c[k>>2]|0);M=G;N=J}c[K>>2]=XEi(L|0)|0;L=a+40|0;K=M+4|0;if(K>>>0>N>>>0){Bid(e,L,4);O=L;P=c[L>>2]|0;Q=c[e>>2]|0;R=c[j>>2]|0}else{p=ea(g[M>>2]);g[L>>2]=p;c[e>>2]=K;O=L;P=(g[k>>2]=p,c[k>>2]|0);Q=K;R=N}c[O>>2]=XEi(P|0)|0;P=a+8|0;O=Q+4|0;if(O>>>0>R>>>0){Bid(e,P,4);S=P;T=c[P>>2]|0;U=c[e>>2]|0;V=c[j>>2]|0}else{p=ea(g[Q>>2]);g[P>>2]=p;c[e>>2]=O;S=P;T=(g[k>>2]=p,c[k>>2]|0);U=O;V=R}c[S>>2]=XEi(T|0)|0;T=a+20|0;S=U+4|0;if(S>>>0>V>>>0){Bid(e,T,4);W=T;X=c[T>>2]|0;Y=c[e>>2]|0;Z=c[j>>2]|0}else{p=ea(g[U>>2]);g[T>>2]=p;c[e>>2]=S;W=T;X=(g[k>>2]=p,c[k>>2]|0);Y=S;Z=V}c[W>>2]=XEi(X|0)|0;X=a+32|0;W=Y+4|0;if(W>>>0>Z>>>0){Bid(e,X,4);_=X;$=c[e>>2]|0;aa=c[j>>2]|0;ba=c[X>>2]|0}else{p=ea(g[Y>>2]);g[X>>2]=p;c[e>>2]=W;_=X;$=W;aa=Z;ba=(g[k>>2]=p,c[k>>2]|0)}c[_>>2]=XEi(ba|0)|0;ba=a+44|0;a=$+4|0;if(a>>>0>aa>>>0){Bid(e,ba,4);ca=ba;da=c[ba>>2]|0;fa=XEi(da|0)|0;c[ca>>2]=fa;i=d;return}else{p=ea(g[$>>2]);g[ba>>2]=p;c[e>>2]=a;ca=ba;da=(g[k>>2]=p,c[k>>2]|0);fa=XEi(da|0)|0;c[ca>>2]=fa;i=d;return}}function W6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+12|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+24|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+36|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}h=a+4|0;p=q+4|0;if(p>>>0<r>>>0){g[q>>2]=ea(g[h>>2]);c[e>>2]=p;s=p;t=r}else{Gid(e,h,4);s=c[e>>2]|0;t=c[j>>2]|0}h=a+16|0;r=s+4|0;if(r>>>0<t>>>0){g[s>>2]=ea(g[h>>2]);c[e>>2]=r;u=r;v=t}else{Gid(e,h,4);u=c[e>>2]|0;v=c[j>>2]|0}h=a+28|0;t=u+4|0;if(t>>>0<v>>>0){g[u>>2]=ea(g[h>>2]);c[e>>2]=t;w=t;x=v}else{Gid(e,h,4);w=c[e>>2]|0;x=c[j>>2]|0}h=a+40|0;v=w+4|0;if(v>>>0<x>>>0){g[w>>2]=ea(g[h>>2]);c[e>>2]=v;y=v;z=x}else{Gid(e,h,4);y=c[e>>2]|0;z=c[j>>2]|0}h=a+8|0;x=y+4|0;if(x>>>0<z>>>0){g[y>>2]=ea(g[h>>2]);c[e>>2]=x;A=x;B=z}else{Gid(e,h,4);A=c[e>>2]|0;B=c[j>>2]|0}h=a+20|0;z=A+4|0;if(z>>>0<B>>>0){g[A>>2]=ea(g[h>>2]);c[e>>2]=z;C=z;D=B}else{Gid(e,h,4);C=c[e>>2]|0;D=c[j>>2]|0}h=a+32|0;B=C+4|0;if(B>>>0<D>>>0){g[C>>2]=ea(g[h>>2]);c[e>>2]=B;E=B;F=D}else{Gid(e,h,4);E=c[e>>2]|0;F=c[j>>2]|0}j=a+44|0;a=E+4|0;if(a>>>0<F>>>0){g[E>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function X6b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function Y6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];y6b(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*80|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,563632,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;a7b(r,a);t=r+80|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,563632,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else a7b(m,a);sdd(a)}m=m+80|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function Z6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=qdd(b,563376,616312,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else b7b(a,b);sdd(b)}f=a+16|0;g=c[142270]|0;h=qdd(b,632240,g,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[l>>2];c[h>>2]=m}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}f=a+20|0;a=qdd(b,2462848,g,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=g+h|0;c[a>>2]=m;if((h|0)>=0?(l=g+(h+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[a>>2]=l}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function _6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,3143216,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,3143224,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;a=qdd(b,2416480,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;n=f+m|0;c[a>>2]=n;if((m|0)>=0?(j=f+(m+4)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[n>>2]);c[a>>2]=j}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function $6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,616312,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else b7b(a,b);sdd(b)}f=a+16|0;a=qdd(b,c[142282]|0,c[142270]|0,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[a>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[j>>2];c[a>>2]=k}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function a7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[142270]|0;g=qdd(b,563416,f,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[g>>2]=l}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+4|0;l=qdd(b,563432,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;k=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(m=k+(j+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[h>>2];c[l>>2]=m}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+8|0;l=qdd(b,563448,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;m=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=m+h|0;c[l>>2]=j;if((h|0)>=0?(k=m+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[l>>2]=k}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+12|0;l=qdd(b,563464,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;k=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(m=k+(j+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[h>>2];c[l>>2]=m}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+16|0;l=qdd(b,563480,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;m=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=m+h|0;c[l>>2]=j;if((h|0)>=0?(k=m+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[l>>2]=k}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+20|0;l=qdd(b,563496,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;k=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(m=k+(j+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[h>>2];c[l>>2]=m}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+24|0;l=qdd(b,563512,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;m=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=m+h|0;c[l>>2]=j;if((h|0)>=0?(k=m+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[l>>2]=k}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+28|0;l=qdd(b,563528,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;f=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=f+k|0;c[l>>2]=j;if((k|0)>=0?(h=f+(k+4)|0,h>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[l>>2]=h}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+32|0;a=qdd(b,563544,563616,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}else c7b(g,b);sdd(b);i=d;return}function b7b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[142302]|0;h=qdd(d,563120,g,f,0)|0;if(h){do if((h|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](b,d)|0}else{j=d+12|0;k=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(k+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[b>>0]=a[m>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,b,1)}while(0);sdd(d)}h=b+1|0;j=qdd(d,563136,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+2|0;j=qdd(d,563152,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+3|0;j=qdd(d,563168,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+4|0;j=qdd(d,563184,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+5|0;j=qdd(d,563200,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+6|0;j=qdd(d,563216,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+7|0;j=qdd(d,563232,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+8|0;j=qdd(d,563248,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+9|0;j=qdd(d,563264,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+10|0;j=qdd(d,563280,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+11|0;j=qdd(d,563296,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+12|0;j=qdd(d,563312,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+13|0;j=qdd(d,563328,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+14|0;j=qdd(d,563344,g,f,0)|0;if(j){a:do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;do if((k|0)>=0){if((n+(k+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break a}while(0);Bid(m,h,1)}while(0);sdd(d)}h=b+15|0;b=qdd(d,563360,g,f,0)|0;if(!b){i=e;return}b:do if((b|0)<=0){g=c[f>>2]|0;if(g)_n[g&4095](h,d)|0}else{g=d+12|0;j=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=j+l|0;c[g>>2]=k;do if((l|0)>=0){if((j+(l+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[k>>0]|0;c[g>>2]=(c[g>>2]|0)+1;break b}while(0);Bid(g,h,1)}while(0);sdd(d);i=e;return}function c7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,574944,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+12|0;m=qdd(b,574952,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+24|0;m=qdd(b,574960,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+36|0;m=qdd(b,574968,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+4|0;m=qdd(b,574976,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+16|0;m=qdd(b,574984,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+28|0;m=qdd(b,574992,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+40|0;m=qdd(b,575e3,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,575008,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+20|0;m=qdd(b,575016,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+32|0;m=qdd(b,575024,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+44|0;a=qdd(b,575032,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function d7b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0;j=i;k=c[a+40>>2]|0;l=c[d>>2]|0;if(!((l|0)>-1&(l|0)<(k|0)))c[d>>2]=0;l=e+12|0;c[h>>2]=0;if((k|0)<=0){i=j;return}m=a+32|0;n=b+4|0;o=b+8|0;p=e+4|0;q=e+8|0;r=a+48|0;s=-1;t=-1;while(1){u=c[d>>2]|0;v=c[m>>2]|0;w=c[v+(u*80|0)+12>>2]|0;if((w|0)>-1){x=c[a>>2]|0;y=ea(g[b>>2]);z=ea(y-ea(g[x+(w*12|0)>>2]));y=ea(g[n>>2]);A=ea(y-ea(g[x+(w*12|0)+4>>2]));y=ea(g[o>>2]);B=ea(y-ea(g[x+(w*12|0)+8>>2]));y=ea(z*ea(g[v+(u*80|0)+32>>2]));C=ea(y+ea(A*ea(g[v+(u*80|0)+44>>2])));y=ea(C+ea(B*ea(g[v+(u*80|0)+56>>2])));C=ea(z*ea(g[v+(u*80|0)+36>>2]));D=ea(C+ea(A*ea(g[v+(u*80|0)+48>>2])));C=ea(D+ea(B*ea(g[v+(u*80|0)+60>>2])));D=ea(z*ea(g[v+(u*80|0)+40>>2]));z=ea(D+ea(A*ea(g[v+(u*80|0)+52>>2])));A=ea(z+ea(B*ea(g[v+(u*80|0)+64>>2])));g[e>>2]=y;g[p>>2]=C;g[q>>2]=A;g[l>>2]=ea(ea(ea(ea(1.0)-y)-C)-A);E=y}else{f7b(a,r,b,v+(u*80|0)|0,e,f);E=ea(g[e>>2])}w=!(E>=ea(0.0));x=w|!(ea(g[p>>2])>=ea(0.0));w=x|!(ea(g[q>>2])>=ea(0.0));if(!(w|!(ea(g[l>>2])>=ea(0.0)))){F=18;break}w=c[d>>2]|0;if((w|0)==(t|0)){F=18;break}y=ea(g[p>>2]);A=ea(g[q>>2]);do if(!(E<y&E<A&E<ea(g[l>>2]))){C=ea(g[l>>2]);if(y<A&y<C){c[d>>2]=c[v+(u*80|0)+20>>2];break}if(A<C){c[d>>2]=c[v+(u*80|0)+24>>2];break}else{c[d>>2]=c[v+(u*80|0)+28>>2];break}}else c[d>>2]=c[v+(u*80|0)+16>>2];while(0);u=(c[h>>2]|0)+1|0;c[h>>2]=u;if((u|0)<(k|0)){u=s;s=w;t=u}else{F=18;break}}if((F|0)==18){i=j;return}}function e7b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;MMc(h);k=c[a+68>>2]|0;if(!k){c[d>>2]=-1;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=j;return}d7b(a+28|0,b,d,e,f,j);f=c[d>>2]|0;if(!((f|0)>-1&(f|0)<(k|0))){i=j;return}k=c[a+60>>2]|0;d=(c[k+(f*80|0)+12>>2]>>31)+4|0;if((d|0)<=0){i=j;return}b=a+44|0;a=0;do{NMc(h,(c[b>>2]|0)+((c[k+(f*80|0)+(a<<2)>>2]|0)*108|0)|0,ea(g[e+(a<<2)>>2]));a=a+1|0}while((a|0)!=(d|0));i=j;return}function f7b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=Im,s=Im,t=0,u=0,v=Im,w=Im,x=0,y=0,z=Im,A=Im,B=0,C=0,D=0,E=Im,F=0,G=Im,H=Im,I=Im,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=Im,W=Im,X=Im;j=i;i=i+48|0;k=j+12|0;l=j;m=c[e>>2]|0;n=c[a>>2]|0;a=c[e+4>>2]|0;o=n+(a*12|0)|0;p=ea(g[o>>2]);q=n+(m*12|0)|0;r=ea(g[q>>2]);s=ea(p-r);t=n+(a*12|0)+4|0;p=ea(g[t>>2]);u=n+(m*12|0)+4|0;v=ea(g[u>>2]);w=ea(p-v);x=n+(a*12|0)+8|0;p=ea(g[x>>2]);y=n+(m*12|0)+8|0;z=ea(g[y>>2]);A=ea(p-z);B=c[e+8>>2]|0;C=n+(B*12|0)|0;p=ea(ea(g[C>>2])-r);D=n+(B*12|0)+4|0;E=ea(ea(g[D>>2])-v);F=n+(B*12|0)+8|0;G=ea(ea(g[F>>2])-z);H=ea(ea(A*E)-ea(w*G));I=ea(ea(s*G)-ea(A*p));A=ea(ea(w*p)-ea(s*E));E=ea(ea(g[d>>2])-r);n=d+4|0;r=ea(ea(g[n>>2])-v);J=d+8|0;v=ea(ea(ea(E*H)+ea(r*I))+ea(A*ea(ea(g[J>>2])-z)));g[h>>2]=v;if(v<ea(0.0)){g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(-1.0);i=j;return}v=ea(g[e+32>>2]);z=ea(g[d>>2]);A=ea(v*z);v=ea(g[e+44>>2]);I=ea(g[n>>2]);r=ea(A+ea(v*I));v=ea(g[e+56>>2]);A=ea(g[J>>2]);H=ea(r+ea(v*A));v=ea(ea(g[e+68>>2])+H);H=ea(z*ea(g[e+36>>2]));r=ea(H+ea(I*ea(g[e+48>>2])));H=ea(r+ea(A*ea(g[e+60>>2])));r=ea(ea(g[e+72>>2])+H);H=ea(z*ea(g[e+40>>2]));z=ea(H+ea(I*ea(g[e+52>>2])));I=ea(z+ea(A*ea(g[e+64>>2])));A=ea(ea(g[e+76>>2])+I);do if((c[e+12>>2]|0)==-1){K=+r;L=+v*.3333333333333333;M=L*L;N=L*M-L*K*.5+ +A*.5;O=K*.3333333333333333-M;M=O*(O*O);K=M+N*N;if(!(K>=0.0)){P=+T(+-M);M=+U(+P,.3333333333333333);Q=(M-O/M)*+V(+(+Y(+(-N/P))*.3333333333333333))-L;break}P=+T(+K)-N;if(P>0.0)R=+U(+P,.3333333333333333);else R=-+U(+-P,.3333333333333333);Q=R+(-L-O/R)}else{if(v<ea(0.0))S=ea(-v);else S=v;if(S<ea(9.99999974e-06)){if(r<ea(0.0))W=ea(-r);else W=r;if(W>ea(9.99999974e-06))X=ea(ea(-A)/r);else X=ea(0.0)}else{I=ea(ea(r*r)-ea(ea(v*ea(4.0))*A));if(I<ea(0.0))X=ea(0.0);else X=ea(ea(ea(.5)/v)*ea(ea(T(ea(I)))-r))}Q=+X}while(0);X=ea(Q);g[h>>2]=X;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(0.0);g[k+32>>2]=ea(0.0);h=c[b>>2]|0;r=ea(X*ea(g[h+(m*12|0)>>2]));v=ea(X*ea(g[h+(m*12|0)+4>>2]));A=ea(X*ea(g[h+(m*12|0)+8>>2]));W=ea(r+ea(g[q>>2]));r=ea(v+ea(g[u>>2]));v=ea(A+ea(g[y>>2]));g[k>>2]=W;g[k+4>>2]=r;g[k+8>>2]=v;v=ea(X*ea(g[h+(a*12|0)>>2]));r=ea(X*ea(g[h+(a*12|0)+4>>2]));W=ea(X*ea(g[h+(a*12|0)+8>>2]));A=ea(v+ea(g[o>>2]));v=ea(r+ea(g[t>>2]));r=ea(W+ea(g[x>>2]));g[k+12>>2]=A;g[k+16>>2]=v;g[k+20>>2]=r;r=ea(X*ea(g[h+(B*12|0)>>2]));v=ea(X*ea(g[h+(B*12|0)+4>>2]));A=ea(X*ea(g[h+(B*12|0)+8>>2]));X=ea(r+ea(g[C>>2]));r=ea(v+ea(g[D>>2]));v=ea(A+ea(g[F>>2]));g[k+24>>2]=X;g[k+28>>2]=r;g[k+32>>2]=v;eyc(l,k,d);v=ea(g[l>>2]);r=ea(g[l+4>>2]);X=ea(g[l+8>>2]);g[f>>2]=v;g[f+4>>2]=r;g[f+8>>2]=X;g[f+12>>2]=ea(0.0);i=j;return}function g7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}
function h7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function i7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function j7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function k7b(a){a=a|0;var b=0,d=0;b=i;d=a+0|0;a=d+124|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function l7b(){return c[140926]|0}function m7b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=e+4|0;h=c[d+36>>2]|0;if((h|0)==1)if(!(a[d+156>>0]|0)){j=uvc()|0;if(!j)k=0;else k=c[j+4>>2]|0;c[b>>2]=k;i=e;return}else{k=c[d+144>>2]|0;if(!k)l=0;else l=c[k+4>>2]|0;c[b>>2]=l;i=e;return}else if(!h){c[b>>2]=c[d+112>>2];i=e;return}else if((h|0)==2){c[b>>2]=c[d+116>>2];i=e;return}else{c[f>>2]=h;Lsd(g,563648,f);if(!(a[g>>0]&1))m=g+1|0;else m=c[g+8>>2]|0;Krd(m,0,3653512,348,1,0,0,0);xri(g);c[b>>2]=0;i=e;return}}function n7b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+48|0;f=e+20|0;g=e+28|0;h=e;j=e+24|0;k=e+36|0;l=e+16|0;m=e+40|0;n=e+32|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;o=ync()|0;c[j>>2]=mo[c[(c[o>>2]|0)+780>>2]&4095](o)|0;o=h+8|0;psd(j,4,h,o);c[k>>2]=c[d+32>>2];psd(k,4,h,o);c[l>>2]=c[d+40>>2];psd(l,4,h,o);if((KLc()|0)==1)p=a[d+124>>0]^1;else p=0;a[m>>0]=p;psd(m,1,h,o);m=b+40|0;p=b+48|0;l=c[p>>2]|0;a:do if(l){k=c[m>>2]|0;j=h;q=c[j>>2]|0;r=c[j+4>>2]|0;j=o;s=c[j>>2]|0;t=c[j+4>>2]|0;j=0;while(1){u=k+(j<<2)|0;v=c[u>>2]|0;w=v;if((((c[w>>2]|0)==(q|0)?(c[w+4>>2]|0)==(r|0):0)?(w=v+8|0,(c[w>>2]|0)==(s|0)?(c[w+4>>2]|0)==(t|0):0):0)?(w=v+16|0,(a[w>>0]|0)!=0):0){x=u;y=w;break}j=j+1|0;if(j>>>0>=l>>>0)break a}a[y>>0]=0;z=c[x>>2]|0;i=e;return z|0}while(0);c[n>>2]=c[153110];c[f+0>>2]=c[n+0>>2];n=bOb(32,f,0,16,3653512,492)|0;R7b(n);x=h;h=c[x+4>>2]|0;y=n;c[y>>2]=c[x>>2];c[y+4>>2]=h;h=o;o=c[h+4>>2]|0;y=n+8|0;c[y>>2]=c[h>>2];c[y+4>>2]=o;a[n+16>>0]=0;o=ync()|0;c[n+20>>2]=mo[c[(c[o>>2]|0)+780>>2]&4095](o)|0;c[n+24>>2]=t7b(d)|0;c[n+28>>2]=t7b(d)|0;d=(c[p>>2]|0)+1|0;c[p>>2]=d;o=b+52|0;y=c[o>>2]|0;h=y&2147483647;if(d>>>0>h>>>0){x=y<<1;l=(x|0)==0?1:x;do if(h>>>0<l>>>0)if((y|0)>-1){c[o>>2]=l;x=c[m>>2]|0;c[g>>2]=c[b+44>>2];c[f+0>>2]=c[g+0>>2];c[m>>2]=hOb(x,l<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[b+44>>2];c[f+0>>2]=c[g+0>>2];x=cOb(l<<2,4,f,0,3653512,352)|0;YEi(x|0,c[m>>2]|0,c[p>>2]<<2|0)|0;c[o>>2]=l;c[m>>2]=x;break}while(0);A=c[p>>2]|0}else A=d;c[(c[m>>2]|0)+(A+-1<<2)>>2]=n;z=n;i=e;return z|0}function o7b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+152|0;m=c[l>>2]|0;do if(m){c[h>>2]=m;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(f,n,h);o=c[f>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if(!((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(c[q+4>>2]|0)!=0:0))r=10}else r=10;if((r|0)==10?(hQb(c[l>>2]|0)|0)==0:0)break;n=c[l>>2]|0;if(!n)s=0;else{c[g>>2]=n;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(f,n,g);o=c[f>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){t=p+(c[n+32>>2]<<3)|0;break}else{t=p+(o<<3)|0;break}}else t=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((t|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[t+4>>2]|0,(n|0)!=0):0)u=n;else r=20}else r=20;if((r|0)==20)u=hQb(c[l>>2]|0)|0;s=u}D3b(s,c[d+24>>2]|0);c[l>>2]=0;i=e;return}while(0);l=b+144|0;s=c[l>>2]|0;if(!s){u=(c[b+32>>2]|0)==0?4:2;r=b+124|0;t=(a[r>>0]|0)==0;g=ync()|0;q=c[g>>2]|0;if(t)v=mo[c[q+668>>2]&4095](g)|0;else v=mo[c[q+672>>2]&4095](g)|0;if((KLc()|0)==1)w=(a[r>>0]|0)==0;else w=0;c[j>>2]=c[153106];c[f+0>>2]=c[j+0>>2];j=bOb(172,f,1,16,3653512,199)|0;c[k>>2]=c[153106];c[f+0>>2]=c[k+0>>2];BBc(j,f,0);f=pQb(j)|0;c[l>>2]=f;ko[c[(c[f>>2]|0)+24>>2]&4095](f);f=c[l>>2]|0;In[c[(c[f>>2]|0)+44>>2]&4095](f,61);f=c[l>>2]|0;j=c[(c[f>>2]|0)+36>>2]|0;k=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;In[j&4095](f,k);k=b+40|0;JBc(c[l>>2]|0,c[k>>2]|0);KBc(c[l>>2]|0,c[k>>2]|0);MBc(c[l>>2]|0,v);LBc(c[l>>2]|0,0);DBc(c[l>>2]|0,u);HBc(c[l>>2]|0,w);FBc(c[l>>2]|0,1);GBc(c[l>>2]|0,0);w=c[l>>2]|0;In[c[(c[w>>2]|0)+12>>2]&4095](w,4);x=c[l>>2]|0}else x=s;s=d+24|0;d=c[s>>2]|0;c[s>>2]=x;c[l>>2]=d;a[b+156>>0]=1;a[b+128>>0]=0;c[b+132>>2]=c[(jLc()|0)+124>>2];i=e;return}function p7b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[a+20>>2]|0;if(!j){i=f;return}k=c[a+12>>2]|0;l=k+(j<<2)|0;j=k;while(1){if((c[j>>2]|0)==(d|0))break;j=j+4|0;if((j|0)==(l|0)){m=27;break}}if((m|0)==27){i=f;return}if((b|0)!=5){l=a+80|0;j=c[l>>2]|0;k=a+76|0;n=c[k>>2]|0;o=j-n>>2;if(!o)p=0;else p=(o*341|0)+-1|0;o=a+88|0;q=c[o>>2]|0;r=a+92|0;s=c[r>>2]|0;if((p-q|0)==(s|0)){G7b(a+72|0);t=c[r>>2]|0;u=c[o>>2]|0;v=c[l>>2]|0;w=c[k>>2]|0}else{t=s;u=q;v=j;w=n}n=t+u|0;if((v|0)!=(w|0)?(v=c[w+(((n>>>0)/341|0)<<2)>>2]|0,w=(n>>>0)%341|0,n=v+(w*12|0)|0,(n|0)!=0):0){c[n>>2]=d;c[v+(w*12|0)+4>>2]=e;c[v+(w*12|0)+8>>2]=b;x=c[r>>2]|0}else x=t;c[r>>2]=x+1;i=f;return}x=a+56|0;r=a+64|0;t=c[r>>2]|0;do if(t){b=c[x>>2]|0;w=0;while(1){if((c[b+(w*12|0)+8>>2]|0)==5?(c[b+(w*12|0)>>2]|0)==(d|0):0){m=27;break}w=w+1|0;if(w>>>0>=t>>>0){m=11;break}}if((m|0)==11){y=t+1|0;break}else if((m|0)==27){i=f;return}}else y=1;while(0);c[r>>2]=y;m=a+68|0;t=c[m>>2]|0;w=t&2147483647;if(y>>>0>w>>>0){b=t<<1;v=(b|0)==0?1:b;do if(w>>>0<v>>>0)if((t|0)>-1){c[m>>2]=v;b=c[x>>2]|0;c[h>>2]=c[a+60>>2];c[g+0>>2]=c[h+0>>2];c[x>>2]=hOb(b,v*12|0,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[a+60>>2];c[g+0>>2]=c[h+0>>2];b=cOb(v*12|0,4,g,0,3653512,352)|0;YEi(b|0,c[x>>2]|0,(c[r>>2]|0)*12|0)|0;c[m>>2]=v;c[x>>2]=b;break}while(0);z=c[r>>2]|0}else z=y;y=z+-1|0;z=c[x>>2]|0;c[z+(y*12|0)>>2]=d;c[z+(y*12|0)+4>>2]=e;c[z+(y*12|0)+8>>2]=5;i=f;return}function q7b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=Im,P=Im,Q=Im,R=0,S=0;f=i;i=i+128|0;h=f+24|0;j=f+104|0;k=f+108|0;l=f+112|0;m=f+12|0;n=f;o=f+88|0;if((e|0)==-1){i=f;return}m7b(k,d);p=c[k>>2]|0;do if(!p){q=0;r=1;s=0}else{c[j>>2]=p;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(h,k,j);t=c[h>>2]|0;u=c[k+28>>2]|0;if((t|0)==-1){v=u+(c[k+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((v|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[v+4>>2]|0,(k|0)!=0):0)w=k;else x=11}else x=11;if((x|0)==11){k=hQb(p)|0;if(!k){q=0;r=1;s=0;break}else w=k}q=w;r=0;s=c[w+44>>2]|0}while(0);c[d+136>>2]=e;w=c[d+32>>2]|0;if((w|0)==1){p=d+24|0;QGc(h,BTb(c[p>>2]|0)|0);qGc(n,BTb(c[p>>2]|0)|0);y=ea(g[n>>2]);p=y<ea(.00999999977);z=p?ea(.00999999977):y;y=ea(g[n+4>>2]);n=y<ea(.00999999977);A=n?ea(.00999999977):y;y=ea(g[h+48>>2]);B=ea(g[h+52>>2]);C=ea(g[h+56>>2]);D=ea(g[h>>2]);E=ea(g[h+4>>2]);F=ea(g[h+8>>2]);G=ea(g[h+16>>2]);H=ea(g[h+20>>2]);I=ea(g[h+24>>2]);J=ea(g[h+32>>2]);K=ea(g[h+36>>2]);L=ea(g[h+40>>2]);n=b+128|0;p=c[n>>2]|0;g[p+(e*24|0)>>2]=y;g[p+(e*24|0)+4>>2]=B;g[p+(e*24|0)+8>>2]=C;p=c[n>>2]|0;g[p+(e*24|0)+12>>2]=J;g[p+(e*24|0)+16>>2]=K;g[p+(e*24|0)+20>>2]=L;p=b+144|0;n=c[p>>2]|0;if(!s)M=vvc()|0;else M=s;c[n+(e*44|0)+24>>2]=M;M=(c[p>>2]|0)+(e*44|0)+28|0;L=ea(g[d+120>>2]);if(r)qwc(o,0,0,ea(1.0));else{n=c[q+52>>2]|0;if((KLc()|0)==1)N=c[q+56>>2]|0;else N=0;qwc(o,n,N,L)};c[M+0>>2]=c[o+0>>2];c[M+4>>2]=c[o+4>>2];c[M+8>>2]=c[o+8>>2];c[M+12>>2]=c[o+12>>2];o=c[p>>2]|0;L=ea(E/z);E=ea(F/z);g[o+(e*44|0)>>2]=ea(D/z);g[o+(e*44|0)+4>>2]=L;g[o+(e*44|0)+8>>2]=E;o=c[p>>2]|0;E=ea(H/A);H=ea(I/A);g[o+(e*44|0)+12>>2]=ea(G/A);g[o+(e*44|0)+16>>2]=E;g[o+(e*44|0)+20>>2]=H;i=f;return}else if(!w){w=c[b+96>>2]|0;o=d+24|0;rGc(h,BTb(c[o>>2]|0)|0);H=ea(g[h>>2]);E=ea(H+ea(g[d+64>>2]));H=ea(g[h+4>>2]);A=ea(H+ea(g[d+68>>2]));H=ea(g[h+8>>2]);G=ea(H+ea(g[d+72>>2]));H=ea(g[d+52>>2]);I=ea(g[d+56>>2]);L=ea(H*ea(.5));H=ea(I*ea(.5));I=ea(ea(g[d+60>>2])*ea(.5));if(L<ea(0.0))O=ea(-L);else O=L;if(H<ea(0.0))P=ea(-H);else P=H;if(I<ea(0.0))Q=ea(-I);else Q=I;g[w+(e*24|0)>>2]=E;g[w+(e*24|0)+4>>2]=A;g[w+(e*24|0)+8>>2]=G;g[w+(e*24|0)+12>>2]=O;g[w+(e*24|0)+16>>2]=P;g[w+(e*24|0)+20>>2]=Q;w=c[b+112>>2]|0;if(!s)R=wvc()|0;else R=s;c[w+(e*40|0)>>2]=R;R=w+(e*40|0)+4|0;Q=ea(g[d+120>>2]);if(r)qwc(l,0,0,ea(1.0));else{r=c[q+52>>2]|0;if((KLc()|0)==1)S=c[q+56>>2]|0;else S=0;qwc(l,r,S,Q)};c[R+0>>2]=c[l+0>>2];c[R+4>>2]=c[l+4>>2];c[R+8>>2]=c[l+8>>2];c[R+12>>2]=c[l+12>>2];rGc(m,BTb(c[o>>2]|0)|0);Q=(a[d+126>>0]|0)!=0?ea(1.0):ea(0.0);P=ea(g[m>>2]);O=ea(g[m+4>>2]);G=ea(g[m+8>>2]);g[w+(e*40|0)+20>>2]=P;g[w+(e*40|0)+24>>2]=O;g[w+(e*40|0)+28>>2]=G;g[w+(e*40|0)+32>>2]=Q;c[w+(e*40|0)+36>>2]=c[d+48>>2];i=f;return}else{i=f;return}}function r7b(b){b=b|0;var d=0,e=0,f=0;d=i;c[b>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+16>>2]=60;c[b+32>>2]=-1;a[b+36>>0]=0;c[b+40>>2]=0;c[b+48>>2]=0;c[b+52>>2]=0;c[b+44>>2]=60;c[b+56>>2]=0;c[b+64>>2]=0;c[b+68>>2]=0;c[b+60>>2]=60;e=b+72|0;c[b+104>>2]=0;c[b+108>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[b+100>>2]=60;c[b+112>>2]=0;c[b+120>>2]=0;c[b+124>>2]=0;c[b+116>>2]=60;c[b+128>>2]=0;c[b+136>>2]=0;c[b+140>>2]=0;c[b+132>>2]=60;c[b+144>>2]=0;c[b+152>>2]=0;c[b+156>>2]=0;c[b+148>>2]=60;e=b+160|0;f=e+124|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[b+4>>2]=ea(1.0);c[b+28>>2]=KLc()|0;i=d;return}function s7b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+12|0;g=a+24|0;if((c[g>>2]|0)>-1){h=c[f>>2]|0;c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}c[a+20>>2]=0;c[g>>2]=0;h=a+40|0;j=c[h>>2]|0;k=a+48|0;if(!(c[k>>2]|0))l=j;else{m=j;do{j=c[m>>2]|0;c[e>>2]=c[153110];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[m>>2]=0;m=m+4|0;j=c[h>>2]|0}while((m|0)!=(j+(c[k>>2]<<2)|0));l=j}m=a+52|0;if((c[m>>2]|0)>-1){c[e>>2]=c[a+44>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[h>>2]=0}c[k>>2]=0;c[m>>2]=0;I7b(a+96|0);H7b(a+72|0);if((c[a+68>>2]|0)>-1){k=a+56|0;l=c[k>>2]|0;c[e>>2]=c[a+60>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[k>>2]=0}if((c[m>>2]|0)>-1){m=c[h>>2]|0;c[e>>2]=c[a+44>>2];c[d+0>>2]=c[e+0>>2];eOb(m,d);c[h>>2]=0}if((c[g>>2]|0)<=-1){i=b;return}g=c[f>>2]|0;c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function t7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=b+124|0;j=(a[h>>0]|0)==0;k=ync()|0;l=c[k>>2]|0;if(j)m=mo[c[l+668>>2]&4095](k)|0;else m=mo[c[l+672>>2]&4095](k)|0;k=(c[b+32>>2]|0)==0?4:2;if((KLc()|0)==1)n=(a[h>>0]|0)==0;else n=0;c[f>>2]=c[153106];c[e+0>>2]=c[f+0>>2];f=bOb(172,e,1,16,3653512,457)|0;c[g>>2]=c[153106];c[e+0>>2]=c[g+0>>2];BBc(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+44>>2]&4095](e,61);f=c[(c[e>>2]|0)+36>>2]|0;g=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;In[f&4095](e,g);g=b+40|0;JBc(e,c[g>>2]|0);KBc(e,c[g>>2]|0);MBc(e,m);LBc(e,0);DBc(e,k);HBc(e,n);FBc(e,1);GBc(e,0);In[c[(c[e>>2]|0)+12>>2]&4095](e,4);i=d;return e|0}function u7b(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0;e=i;c[a>>2]=c[b>>2];g[a+4>>2]=d;v7b(a);i=e;return}function v7b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=i;i=i+144|0;d=b+128|0;e=b+124|0;f=b;g=a+20|0;h=c[g>>2]|0;j=a+96|0;k=a+108|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<h>>>0)if((l|0)>-1){c[k>>2]=h;m=c[j>>2]|0;c[e>>2]=c[a+100>>2];c[d+0>>2]=c[e+0>>2];c[j>>2]=hOb(m,h*24|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+100>>2];c[d+0>>2]=c[e+0>>2];m=cOb(h*24|0,4,d,0,3653512,352)|0;YEi(m|0,c[j>>2]|0,(c[a+104>>2]|0)*24|0)|0;c[k>>2]=h;c[j>>2]=m;break}while(0);l=a+104|0;c[l>>2]=0;m=a+112|0;n=a+124|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<h>>>0)if((o|0)>-1){c[n>>2]=h;p=c[m>>2]|0;c[e>>2]=c[a+116>>2];c[d+0>>2]=c[e+0>>2];c[m>>2]=hOb(p,h*40|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+116>>2];c[d+0>>2]=c[e+0>>2];p=cOb(h*40|0,4,d,0,3653512,352)|0;YEi(p|0,c[m>>2]|0,(c[a+120>>2]|0)*40|0)|0;c[n>>2]=h;c[m>>2]=p;break}while(0);o=a+120|0;c[o>>2]=0;p=a+128|0;q=a+140|0;r=c[q>>2]|0;do if((r&2147483647)>>>0<h>>>0)if((r|0)>-1){c[q>>2]=h;s=c[p>>2]|0;c[e>>2]=c[a+132>>2];c[d+0>>2]=c[e+0>>2];c[p>>2]=hOb(s,h*24|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+132>>2];c[d+0>>2]=c[e+0>>2];s=cOb(h*24|0,4,d,0,3653512,352)|0;YEi(s|0,c[p>>2]|0,(c[a+136>>2]|0)*24|0)|0;c[q>>2]=h;c[p>>2]=s;break}while(0);r=a+136|0;c[r>>2]=0;s=a+144|0;t=a+156|0;u=c[t>>2]|0;do if((u&2147483647)>>>0<h>>>0)if((u|0)>-1){c[t>>2]=h;v=c[s>>2]|0;c[e>>2]=c[a+148>>2];c[d+0>>2]=c[e+0>>2];c[s>>2]=hOb(v,h*44|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+148>>2];c[d+0>>2]=c[e+0>>2];v=cOb(h*44|0,4,d,0,3653512,352)|0;YEi(v|0,c[s>>2]|0,(c[a+152>>2]|0)*44|0)|0;c[t>>2]=h;c[s>>2]=v;break}while(0);h=a+152|0;c[h>>2]=0;x7b(f,a);u=a+160|0;v=f+0|0;f=u+124|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(f|0));v=a+12|0;if(!(c[g>>2]|0)){i=b;return}u=a+100|0;f=a+116|0;w=a+132|0;x=a+148|0;y=c[v>>2]|0;do{z=c[(c[y>>2]|0)+32>>2]|0;do if(!z){A=c[l>>2]|0;B=A+1|0;c[l>>2]=B;C=c[k>>2]|0;D=C&2147483647;do if(B>>>0>D>>>0?(E=C<<1,F=(E|0)==0?1:E,D>>>0<F>>>0):0)if((C|0)>-1){c[k>>2]=F;E=c[j>>2]|0;c[e>>2]=c[u>>2];c[d+0>>2]=c[e+0>>2];c[j>>2]=hOb(E,F*24|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[u>>2];c[d+0>>2]=c[e+0>>2];E=cOb(F*24|0,4,d,0,3653512,352)|0;YEi(E|0,c[j>>2]|0,(c[l>>2]|0)*24|0)|0;c[k>>2]=F;c[j>>2]=E;break}while(0);C=(c[o>>2]|0)+1|0;c[o>>2]=C;D=c[n>>2]|0;B=D&2147483647;if(C>>>0>B>>>0?(C=D<<1,E=(C|0)==0?1:C,B>>>0<E>>>0):0)if((D|0)>-1){c[n>>2]=E;D=c[m>>2]|0;c[e>>2]=c[f>>2];c[d+0>>2]=c[e+0>>2];c[m>>2]=hOb(D,E*40|0,4,d,0,3653512,370)|0;G=A;break}else{c[e>>2]=c[f>>2];c[d+0>>2]=c[e+0>>2];D=cOb(E*40|0,4,d,0,3653512,352)|0;YEi(D|0,c[m>>2]|0,(c[o>>2]|0)*40|0)|0;c[n>>2]=E;c[m>>2]=D;G=A;break}else G=A}else if((z|0)==1){D=c[r>>2]|0;E=D+1|0;c[r>>2]=E;B=c[q>>2]|0;C=B&2147483647;do if(E>>>0>C>>>0?(F=B<<1,H=(F|0)==0?1:F,C>>>0<H>>>0):0)if((B|0)>-1){c[q>>2]=H;F=c[p>>2]|0;c[e>>2]=c[w>>2];c[d+0>>2]=c[e+0>>2];c[p>>2]=hOb(F,H*24|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[w>>2];c[d+0>>2]=c[e+0>>2];F=cOb(H*24|0,4,d,0,3653512,352)|0;YEi(F|0,c[p>>2]|0,(c[r>>2]|0)*24|0)|0;c[q>>2]=H;c[p>>2]=F;break}while(0);B=(c[h>>2]|0)+1|0;c[h>>2]=B;C=c[t>>2]|0;E=C&2147483647;if(B>>>0>E>>>0?(B=C<<1,A=(B|0)==0?1:B,E>>>0<A>>>0):0)if((C|0)>-1){c[t>>2]=A;C=c[s>>2]|0;c[e>>2]=c[x>>2];c[d+0>>2]=c[e+0>>2];c[s>>2]=hOb(C,A*44|0,4,d,0,3653512,370)|0;G=D;break}else{c[e>>2]=c[x>>2];c[d+0>>2]=c[e+0>>2];C=cOb(A*44|0,4,d,0,3653512,352)|0;YEi(C|0,c[s>>2]|0,(c[h>>2]|0)*44|0)|0;c[t>>2]=A;c[s>>2]=C;G=D;break}else G=D}else G=0;while(0);q7b(a,c[y>>2]|0,G);y=y+4|0}while((y|0)!=((c[v>>2]|0)+(c[g>>2]<<2)|0));i=b;return}function w7b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=n7b(b,d)|0;g=c[(X8b()|0)+480>>2]|0;h=pyc()|0;if((g|0)>=1){j=c[(c[h+24>>2]|0)+((c[h+40>>2]|0)*96|0)+92>>2]|0;if((g|0)>(j|0))if(!j){k=f+16|0;a[k>>0]=1;l=d+140|0;a[l>>0]=0;i=e;return}else m=j;else m=g}else m=1;g=d+136|0;j=m;do{j=j+-1|0;S7b(f,d,63);V7b(f,0,63,0,-1,1);o7b(d,f);q7b(b,d,c[g>>2]|0)}while((j|0)!=0);k=f+16|0;a[k>>0]=1;l=d+140|0;a[l>>0]=0;i=e;return}function x7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0;d=i;i=i+64|0;e=d+56|0;f=d+48|0;h=d+44|0;j=d+40|0;k=d+16|0;l=d;m=a+0|0;n=m+124|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));m=k+12|0;n=b+4|0;o=0;do{p=a+(o*60|0)|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+0>>2]=c[150284];c[k+4>>2]=c[150285];c[k+8>>2]=c[150286];c[m+0>>2]=c[150280];c[m+4>>2]=c[150281];c[m+8>>2]=c[150282];c[p+0>>2]=c[k+0>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];c[p+16>>2]=c[k+16>>2];c[p+20>>2]=c[k+20>>2];p=c[b>>2]|0;do if(!p)q=23;else{c[j>>2]=p;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(e,r,j);s=c[e>>2]|0;t=c[r+28>>2]|0;if((s|0)==-1){u=t+(c[r+32>>2]<<3)|0;break}else{u=t+(s<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(c[u+4>>2]|0)!=0:0)v=r;else q=11}else q=11;if((q|0)==11){q=0;if(!(hQb(c[b>>2]|0)|0)){q=23;break}v=c[137784]|0}c[h>>2]=c[b>>2];if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(e,v,h);r=c[e>>2]|0;s=c[v+28>>2]|0;if((r|0)==-1){w=s+(c[v+32>>2]<<3)|0;break}else{w=s+(r<<3)|0;break}}else w=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);r=c[137784]|0;if((w|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[w+4>>2]|0,(r|0)!=0):0)x=r;else q=21}else q=21;if((q|0)==21){q=0;x=hQb(c[b>>2]|0)|0}y=c[x+44>>2]|0}while(0);if((q|0)==23){q=0;y=wvc()|0}c[a+(o*60|0)+24>>2]=y;p=a+(o*60|0)+28|0;r=c[b>>2]|0;do if(!r)q=34;else{c[f>>2]=r;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,f);t=c[e>>2]|0;z=c[s+28>>2]|0;if((t|0)==-1){A=z+(c[s+32>>2]<<3)|0;break}else{A=z+(t<<3)|0;break}}else A=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((A|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[A+4>>2]|0,(s|0)!=0):0)B=s;else q=33}else q=33;if((q|0)==33){q=0;s=hQb(c[b>>2]|0)|0;if(!s){q=34;break}else B=s}C=ea(g[n>>2]);s=c[B+52>>2]|0;if((KLc()|0)==1)D=c[B+56>>2]|0;else D=0;qwc(l,s,D,C)}while(0);if((q|0)==34){q=0;qwc(l,0,0,ea(1.0))};c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];c[p+12>>2]=c[l+12>>2];r=a+(o*60|0)+44|0;o=o+1|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0}while((o|0)!=2);i=d;return}function y7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=KLc()|0;h=b+28|0;if((g|0)==(c[h>>2]|0))j=0;else{c[h>>2]=KLc()|0;j=1}h=b+32|0;g=c[h>>2]|0;k=pyc()|0;if(!(a[(c[k+24>>2]|0)+((c[k+40>>2]|0)*96|0)+74>>0]|0))l=0;else l=(a[(NOc()|0)+94>>0]|0)!=0;k=l&1;if((g|0)!=-1){if((g|0)!=(k|0)){g=pyc()|0;if(!(a[(c[g+24>>2]|0)+((c[g+40>>2]|0)*96|0)+74>>0]|0))m=0;else m=(a[(NOc()|0)+94>>0]|0)!=0;c[h>>2]=m&1}}else c[h>>2]=k;k=b+12|0;h=c[k>>2]|0;m=b+20|0;g=c[m>>2]|0;a:do if(g){if(j){n=g;o=h;p=h}else{l=h;while(1){l=l+4|0;if((l|0)==(h+(g<<2)|0))break a}}while(1){l=c[p>>2]|0;a[l+140>>0]=1;b:do if((c[l+36>>2]|0)==1?(q=c[140926]|0,r=c[q+20>>2]|0,(r|0)!=0):0){s=c[q+12>>2]|0;t=s+(r<<2)|0;r=s;while(1){if((c[r>>2]|0)==(l|0))break;r=r+4|0;if((r|0)==(t|0)){u=o;v=n;break b}}p7b(q,5,l,63);u=c[k>>2]|0;v=c[m>>2]|0}else{u=o;v=n}while(0);p=p+4|0;if((p|0)==(u+(v<<2)|0))break;else{n=v;o=u}}}while(0);u=b+56|0;o=b+64|0;if(c[o>>2]|0){v=0;do{z7b((c[u>>2]|0)+(v*12|0)|0)|0;v=v+1|0}while(v>>>0<(c[o>>2]|0)>>>0)}v=b+68|0;if((c[v>>2]|0)>-1){n=c[u>>2]|0;c[f>>2]=c[b+60>>2];c[e+0>>2]=c[f+0>>2];eOb(n,e);c[u>>2]=0}c[o>>2]=0;c[v>>2]=0;v=b+92|0;if(!(c[v>>2]|0)){i=d;return}o=b+76|0;u=b+88|0;b=c[u>>2]|0;z7b((c[(c[o>>2]|0)+(((b>>>0)/341|0)<<2)>>2]|0)+(((b>>>0)%341|0)*12|0)|0)|0;c[v>>2]=(c[v>>2]|0)+-1;v=(c[u>>2]|0)+1|0;c[u>>2]=v;if(v>>>0<=681){i=d;return}ACi(c[c[o>>2]>>2]|0);c[o>>2]=(c[o>>2]|0)+4;c[u>>2]=(c[u>>2]|0)+-341;i=d;return}function z7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;switch(c[b+8>>2]|0){case 4:{e=c[140926]|0;f=c[b>>2]|0;g=f+148|0;h=c[g>>2]|0;if(!h){j=n7b(e,f)|0;c[g>>2]=j;k=j}else k=h;o7b(f,k);q7b(e,f,c[f+136>>2]|0);a[f+140>>0]=0;a[(c[g>>2]|0)+16>>0]=1;c[g>>2]=0;i=d;return 1}case 2:{g=c[b>>2]|0;f=c[b+4>>2]|0;e=g+148|0;k=c[e>>2]|0;if(!k){h=n7b(c[140926]|0,g)|0;c[e>>2]=h;l=h}else l=k;V7b(l,1,63,f,f,0);i=d;return 1}case 5:{w7b(c[140926]|0,c[b>>2]|0);i=d;return 1}case 1:{f=c[b>>2]|0;l=c[b+4>>2]|0;k=f+148|0;h=c[k>>2]|0;if(!h){e=n7b(c[140926]|0,f)|0;c[k>>2]=e;m=e}else m=h;V7b(m,1,l,1,1,0);i=d;return 1}case 3:{l=c[b>>2]|0;m=c[b+4>>2]|0;h=l+148|0;e=c[h>>2]|0;if(!e){k=n7b(c[140926]|0,l)|0;c[h>>2]=k;n=k}else n=e;V7b(n,1,63,m,-1,1);i=d;return 1}case 0:{m=c[b>>2]|0;n=c[b+4>>2]|0;b=m+148|0;e=c[b>>2]|0;if(!e){k=n7b(c[140926]|0,m)|0;c[b>>2]=k;o=k}else o=e;S7b(o,m,n);i=d;return 1}default:{i=d;return 1}}return 0}function A7b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+4|0;f=a+8|0;a=c[f>>2]|0;if(a){g=a;i=b;return g|0}rri(e,563672,24);c[d>>2]=0;a=eQc(e,1,61,2449160,d)|0;xri(e);e=ATb(a,20)|0;c[f>>2]=e;In[c[(c[e>>2]|0)+120>>2]&4095](e,0);g=c[f>>2]|0;i=b;return g|0}function B7b(a){a=a|0;var b=0;b=i;v7b(a);y7b(a);i=b;return}function C7b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+0|0;a=b+160|0;b=e+124|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));i=d;return}function D7b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=Im,W=Im,X=Im,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im;h=i;i=i+144|0;j=h;k=h+104|0;l=h+108|0;m=h+120|0;n=h+56|0;o=h+32|0;p=h+80|0;q=a+96|0;c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];b=c[153134]|0;r=a+104|0;s=c[r>>2]|0;if(!s){t=0;u=0}else{c[k>>2]=b;c[j+0>>2]=c[k+0>>2];t=s;u=hOb(0,s*12|0,4,j,0,3653512,370)|0}do if(!d)v=4;else{s=ATb(c[d+24>>2]|0,215)|0;if(((s|0)!=0?(c[s+32>>2]|0)==0:0)?(w=s+136|0,(c[w>>2]|0)!=-1):0){x=c[w>>2]|0;w=c[s+48>>2]|0;do if(!(t&2147483647)){s=t<<1;y=(s|0)==0?1:s;if((t|0)>-1){c[k>>2]=b;c[j+0>>2]=c[k+0>>2];z=y;A=hOb(u,y*12|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=b;c[j+0>>2]=c[k+0>>2];s=cOb(y*12|0,4,j,0,3653512,352)|0;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];z=y;A=s;break}}else{z=t;A=u}while(0);c[A>>2]=x;g[A+4>>2]=ea(1.0);c[A+8>>2]=w;B=3;C=A;D=1;E=z;v=24;break}rGc(l,d);c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];v=4}while(0);if((v|0)==4){if(!(c[r>>2]|0)){F=t;G=0;H=u}else{l=a+112|0;d=0;z=t;t=u;u=0;while(1){I=ea(J7b(m,(c[q>>2]|0)+(u*24|0)|0));if(I>ea(0.0)){A=c[(c[l>>2]|0)+(u*40|0)+36>>2]|0;s=d+1|0;y=z&2147483647;do if(s>>>0>y>>>0?(J=z<<1,K=(J|0)==0?1:J,y>>>0<K>>>0):0)if((z|0)>-1){c[k>>2]=b;c[j+0>>2]=c[k+0>>2];L=K;M=hOb(t,K*12|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=b;c[j+0>>2]=c[k+0>>2];J=cOb(K*12|0,4,j,0,3653512,352)|0;YEi(J|0,t|0,s*12|0)|0;L=K;M=J;break}else{L=z;M=t}while(0);c[M+(d*12|0)>>2]=u;g[M+(d*12|0)+4>>2]=I;c[M+(d*12|0)+8>>2]=A;N=L;O=s;P=M}else{N=z;O=d;P=t}u=u+1|0;if(u>>>0>=(c[r>>2]|0)>>>0){F=N;G=O;H=P;break}else{d=O;z=N;t=P}}}c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[j+16>>2]=c[m+16>>2];c[j+20>>2]=c[m+20>>2];c[j+24>>2]=q;K7b(H,H+(G*12|0)|0,j);if(!G){Q=f+0|0;R=a+160|0;S=Q+60|0;do{c[Q>>2]=c[R>>2];Q=Q+4|0;R=R+4|0}while((Q|0)<(S|0));Q=f+60|0;R=a+220|0;S=Q+60|0;do{c[Q>>2]=c[R>>2];Q=Q+4|0;R=R+4|0}while((Q|0)<(S|0));g[f+120>>2]=ea(1.0);T=F;U=H}else{B=e;C=H;D=G;E=F;v=24}}if((v|0)==24){v=a+112|0;F=c[C>>2]|0;G=c[v>>2]|0;H=f+44|0;e=G+(F*40|0)+20|0;c[H+0>>2]=c[e+0>>2];c[H+4>>2]=c[e+4>>2];c[H+8>>2]=c[e+8>>2];c[H+12>>2]=c[e+12>>2];e=(c[q>>2]|0)+(F*24|0)|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];c[f+24>>2]=c[G+(F*40|0)>>2];e=f+28|0;H=G+(F*40|0)+4|0;c[e+0>>2]=c[H+0>>2];c[e+4>>2]=c[H+4>>2];c[e+8>>2]=c[H+8>>2];c[e+12>>2]=c[H+12>>2];H=f+60|0;e=D>>>0>1;if(e){D=c[C+12>>2]|0;F=c[v>>2]|0;v=f+104|0;G=F+(D*40|0)+20|0;c[v+0>>2]=c[G+0>>2];c[v+4>>2]=c[G+4>>2];c[v+8>>2]=c[G+8>>2];c[v+12>>2]=c[G+12>>2];G=(c[q>>2]|0)+(D*24|0)|0;c[H+0>>2]=c[G+0>>2];c[H+4>>2]=c[G+4>>2];c[H+8>>2]=c[G+8>>2];c[H+12>>2]=c[G+12>>2];c[H+16>>2]=c[G+16>>2];c[H+20>>2]=c[G+20>>2];c[f+84>>2]=c[F+(D*40|0)>>2];G=f+88|0;v=F+(D*40|0)+4|0;c[G+0>>2]=c[v+0>>2];c[G+4>>2]=c[v+4>>2];c[G+8>>2]=c[v+8>>2];c[G+12>>2]=c[v+12>>2]}else{Q=H+0|0;R=a+220|0;S=Q+60|0;do{c[Q>>2]=c[R>>2];Q=Q+4|0;R=R+4|0}while((Q|0)<(S|0))}do if((B|0)!=3){V=ea(g[C+4>>2]);R=c[C+8>>2]|0;Q=c[q>>2]|0;S=Q+((c[C>>2]|0)*24|0)|0;if(e){W=ea(g[C+16>>2]);X=W;Y=c[C+20>>2]|0;Z=Q+((c[C+12>>2]|0)*24|0)|0}else{X=ea(0.0);Y=-1;Z=578048}W=ea(g[m+12>>2]);_=ea(W*ea(2.0));$=ea(g[m+16>>2]);aa=ea($*ea(2.0));ba=ea(g[m+20>>2]);ca=ea(ea(_*aa)*ea(ba*ea(2.0)));aa=ea(g[150276]);_=aa<ca?ca:aa;if(!(X>ea(0.0))){if((B|0)!=2){da=ea(1.0);fa=W;ga=$;ha=ba;break}aa=ea(V/_);if(aa<ea(0.0)){da=ea(0.0);fa=W;ga=$;ha=ba;break}Q=aa>ea(1.0);da=Q?ea(1.0):aa;fa=W;ga=$;ha=ba;break}if((R|0)>(Y|0)){da=ea(V/_);fa=W;ga=$;ha=ba;break}if((Y|0)>(R|0)){da=ea(ea(1.0)-ea(X/_));fa=W;ga=$;ha=ba;break}if(Ylc(S,Z)|0){da=ea(V/_);fa=W;ga=$;ha=ba;break}if(Ylc(Z,S)|0){da=ea(ea(1.0)-ea(X/_));fa=W;ga=$;ha=ba;break}else{da=ea(V/ea(V+X));fa=W;ga=$;ha=ba;break}}else{ba=ea(g[m+12>>2]);$=ea(g[m+16>>2]);da=ea(1.0);fa=ba;ga=$;ha=ea(g[m+20>>2])}while(0);g[f+120>>2]=da;Z=o+4|0;Y=o+8|0;B=o+12|0;e=o+16|0;q=o+20|0;S=p+4|0;R=p+8|0;Q=p+12|0;a=p+16|0;H=p+20|0;da=ea(g[m>>2]);X=ea(da-fa);$=ea(g[m+4>>2]);ba=ea($-ga);W=ea(g[m+8>>2]);V=ea(W-ha);_=ea(da+fa);fa=ea($+ga);ga=ea(W+ha);m=n+12|0;v=n+16|0;G=n+4|0;D=n+20|0;F=n+8|0;P=0;do{if(ea(g[f+(P*60|0)+56>>2])>ea(0.0)){t=f+(P*60|0)|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;ha=ea(g[t>>2]);N=f+(P*60|0)+12|0;W=ea(g[N>>2]);$=ea(ha-W);z=f+(P*60|0)+4|0;da=ea(g[z>>2]);O=f+(P*60|0)+16|0;aa=ea(g[O>>2]);ca=ea(da-aa);d=f+(P*60|0)+8|0;ia=ea(g[d>>2]);r=f+(P*60|0)+20|0;ja=ea(g[r>>2]);ka=ea(ia-ja);g[o>>2]=$;g[Z>>2]=ca;g[Y>>2]=ka;ka=ea(da+aa);aa=ea(ia+ja);g[B>>2]=ea(ha+W);g[e>>2]=ka;g[q>>2]=aa;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;g[p>>2]=X;g[S>>2]=ba;g[R>>2]=V;g[Q>>2]=_;g[a>>2]=fa;g[H>>2]=ga;Vlc(n,o,p);aa=ea(g[m>>2]);ka=ea(g[n>>2]);W=ea(aa+ka);ha=ea(g[v>>2]);ja=ea(g[G>>2]);ia=ea(ha+ja);da=ea(g[D>>2]);ca=ea(g[F>>2]);$=ea(ia*ea(.5));ia=ea(ea(da+ca)*ea(.5));g[t>>2]=ea(W*ea(.5));g[z>>2]=$;g[d>>2]=ia;ia=ea(ea(ha-ja)*ea(.5));ja=ea(ea(da-ca)*ea(.5));g[N>>2]=ea(ea(aa-ka)*ea(.5));g[O>>2]=ia;g[r>>2]=ja}P=P+1|0}while((P|0)<2);T=E;U=C}if((T|0)<=-1){i=h;return}c[k>>2]=b;c[j+0>>2]=c[k+0>>2];eOb(U,j);i=h;return}function E7b(){var a=0,b=0;a=i;b=xCi(284)|0;r7b(b);c[140926]=b;i=a;return}function F7b(){var a=0,b=0;a=i;b=c[140926]|0;if(b){s7b(b);ACi(b)}c[140926]=0;i=a;return}function G7b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;i=i+16|0;d=b;e=a+16|0;f=c[e>>2]|0;if(f>>>0>340){c[e>>2]=f+-341;f=a+4|0;e=c[f>>2]|0;g=c[e>>2]|0;h=e+4|0;c[f>>2]=h;j=a+8|0;k=c[j>>2]|0;l=a+12|0;do if((k|0)==(c[l>>2]|0)){m=c[a>>2]|0;if(h>>>0>m>>>0){n=h;o=((n-m>>2)+1|0)/-2|0;p=k-n|0;aFi(e+(o+1<<2)|0,h|0,p|0)|0;n=e+((p>>2)+1+o<<2)|0;c[j>>2]=n;c[f>>2]=(c[f>>2]|0)+(o<<2);q=n;r=13;break}n=k-m>>1;o=(n|0)==0?1:n;n=xCi(o<<2)|0;p=n+(o>>>2<<2)|0;s=n+(o<<2)|0;if((h|0)==(k|0)){t=p;u=m}else{m=p;o=h;v=e;while(1){if(!m)w=0;else{c[m>>2]=c[o>>2];w=m}x=w+4|0;y=v+8|0;if((y|0)==(k|0)){z=x;break}else{A=o;m=x;o=y;v=A}}t=z;u=c[a>>2]|0}c[a>>2]=n;c[f>>2]=p;c[j>>2]=t;c[l>>2]=s;if(!u){B=t;r=12}else{ACi(u);B=c[j>>2]|0;r=12}}else{B=k;r=12}while(0);if((r|0)==12)if(!B)C=0;else{q=B;r=13}if((r|0)==13){c[q>>2]=g;C=c[j>>2]|0}c[j>>2]=C+4;i=b;return}C=a+8|0;j=c[C>>2]|0;g=a+4|0;q=j-(c[g>>2]|0)|0;B=q>>2;k=a+12|0;u=c[k>>2]|0;t=u-(c[a>>2]|0)|0;if(B>>>0<t>>2>>>0){l=xCi(4092)|0;if((u|0)!=(j|0)){if(!j)D=0;else{c[j>>2]=l;D=c[C>>2]|0}c[C>>2]=D+4;i=b;return}c[d>>2]=l;L7b(a,d);d=c[g>>2]|0;l=c[d>>2]|0;D=d+4|0;c[g>>2]=D;j=c[C>>2]|0;do if((j|0)==(c[k>>2]|0)){u=c[a>>2]|0;if(D>>>0>u>>>0){f=D;z=((f-u>>2)+1|0)/-2|0;w=j-f|0;aFi(d+(z+1<<2)|0,D|0,w|0)|0;f=d+((w>>2)+1+z<<2)|0;c[C>>2]=f;c[g>>2]=(c[g>>2]|0)+(z<<2);E=f;r=31;break}f=j-u>>1;z=(f|0)==0?1:f;f=xCi(z<<2)|0;w=f+(z>>>2<<2)|0;e=f+(z<<2)|0;if((D|0)==(j|0)){F=w;G=u}else{u=w;z=D;h=d;while(1){if(!u)H=0;else{c[u>>2]=c[z>>2];H=u}v=H+4|0;o=h+8|0;if((o|0)==(j|0)){I=v;break}else{m=z;u=v;z=o;h=m}}F=I;G=c[a>>2]|0}c[a>>2]=f;c[g>>2]=w;c[C>>2]=F;c[k>>2]=e;if(!G){J=F;r=30}else{ACi(G);J=c[C>>2]|0;r=30}}else{J=j;r=30}while(0);if((r|0)==30)if(!J)K=0;else{E=J;r=31}if((r|0)==31){c[E>>2]=l;K=c[C>>2]|0}c[C>>2]=K+4;i=b;return}K=t>>1;t=(K|0)==0?1:K;K=xCi(t<<2)|0;l=K+(t<<2)|0;E=xCi(4092)|0;r=K+(B<<2)|0;do if((B|0)==(t|0))if((q|0)>0){L=K+(((B+1|0)/-2|0)+B<<2)|0;M=l;N=K;break}else{J=q>>1;j=(J|0)==0?1:J;J=xCi(j<<2)|0;ACi(K);L=J+(j>>>2<<2)|0;M=J+(j<<2)|0;N=J;break}else{L=r;M=l;N=K}while(0);if(!L)O=0;else{c[L>>2]=E;O=L}E=O+4|0;O=c[C>>2]|0;if((O|0)==(c[g>>2]|0)){P=M;Q=E;R=L;S=N}else{K=L;L=N;N=E;E=M;M=O;while(1){M=M+-4|0;do if((K|0)==(L|0)){O=E;if(N>>>0<E>>>0){l=N;r=((O-l>>2)+1|0)/2|0;q=l-L|0;l=N+(r-(q>>2)<<2)|0;aFi(l|0,L|0,q|0)|0;T=l;U=E;V=N+(r<<2)|0;W=L;break}r=O-L>>1;O=(r|0)==0?1:r;r=xCi(O<<2)|0;l=r+((O+3|0)>>>2<<2)|0;q=r+(O<<2)|0;if((L|0)==(N|0))X=l;else{O=l;B=L;while(1){if(!O)Y=0;else{c[O>>2]=c[B>>2];Y=O}t=Y+4|0;B=B+4|0;if((B|0)==(N|0)){X=t;break}else O=t}}if(!L){T=l;U=q;V=X;W=r}else{ACi(L);T=l;U=q;V=X;W=r}}else{T=K;U=E;V=N;W=L}while(0);e=T+-4|0;c[e>>2]=c[M>>2];if((M|0)==(c[g>>2]|0)){P=U;Q=V;R=e;S=W;break}else{K=e;L=W;N=V;E=U}}}U=c[a>>2]|0;c[a>>2]=S;c[g>>2]=R;c[C>>2]=Q;c[k>>2]=P;if(!U){i=b;return}ACi(U);i=b;return}function H7b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+16|0;g=c[f>>2]|0;h=e+(((g>>>0)/341|0)<<2)|0;j=a+8|0;k=c[j>>2]|0;if((k|0)==(e|0)){l=0;m=a+20|0;n=0}else{o=a+20|0;p=(c[o>>2]|0)+g|0;l=(c[e+(((p>>>0)/341|0)<<2)>>2]|0)+(((p>>>0)%341|0)*12|0)|0;m=o;n=(c[h>>2]|0)+(((g>>>0)%341|0)*12|0)|0}g=n;n=h;a:while(1){h=g;do{if((h|0)==(l|0))break a;h=h+12|0}while((h-(c[n>>2]|0)|0)!=4092);h=n+4|0;g=c[h>>2]|0;n=h}c[m>>2]=0;m=k-e>>2;if(m>>>0>2){k=e;do{ACi(c[k>>2]|0);k=(c[d>>2]|0)+4|0;c[d>>2]=k;e=(c[j>>2]|0)-k>>2}while(e>>>0>2);q=e}else q=m;if((q|0)==1)c[f>>2]=170;else if((q|0)==2)c[f>>2]=341;f=c[d>>2]|0;q=c[j>>2]|0;if((f|0)!=(q|0)){m=f;do{ACi(c[m>>2]|0);m=m+4|0}while((m|0)!=(q|0));q=c[d>>2]|0;d=c[j>>2]|0;if((d|0)!=(q|0))c[j>>2]=d+(~((d+-4-q|0)>>>2)<<2)}q=c[a>>2]|0;if(!q){i=b;return}ACi(q);i=b;return}function I7b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+60>>2]|0)>-1){f=a+48|0;g=c[f>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+44>>2]|0)>-1){f=a+32|0;g=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function J7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;d=i;i=i+80|0;e=d+48|0;f=d+24|0;h=d;j=e+12|0;k=e+16|0;l=e+20|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+0>>2]=c[150280];c[e+4>>2]=c[150281];c[e+8>>2]=c[150282];m=ea(-ea(g[150280]));n=ea(-ea(g[150281]));o=ea(-ea(g[150282]));g[j>>2]=m;g[k>>2]=n;g[l>>2]=o;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;o=ea(g[a>>2]);n=ea(g[a+12>>2]);m=ea(o-n);p=ea(g[a+4>>2]);q=ea(g[a+16>>2]);r=ea(p-q);s=ea(g[a+8>>2]);t=ea(g[a+20>>2]);u=ea(s-t);g[f>>2]=m;g[f+4>>2]=r;g[f+8>>2]=u;u=ea(p+q);q=ea(s+t);g[f+12>>2]=ea(o+n);g[f+16>>2]=u;g[f+20>>2]=q;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;q=ea(g[b>>2]);u=ea(g[b+12>>2]);n=ea(q-u);o=ea(g[b+4>>2]);t=ea(g[b+16>>2]);s=ea(o-t);p=ea(g[b+8>>2]);r=ea(g[b+20>>2]);m=ea(p-r);g[h>>2]=n;g[h+4>>2]=s;g[h+8>>2]=m;m=ea(o+t);t=ea(p+r);g[h+12>>2]=ea(q+u);g[h+16>>2]=m;g[h+20>>2]=t;if(!(kmc(f,h,e)|0)){v=ea(-1.0);i=d;return ea(v)}t=ea(g[j>>2]);m=ea(t-ea(g[e>>2]));t=ea(g[k>>2]);u=ea(t-ea(g[e+4>>2]));t=ea(g[l>>2]);q=ea(ea(m*u)*ea(t-ea(g[e+8>>2])));t=ea(g[150276]);v=t<q?q:t;i=d;return ea(v)}function K7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;e=i;i=i+16|0;f=e;h=ea(g[150276]);j=d+24|0;k=d+4|0;l=d+8|0;m=a;a=b;a:while(1){b=a;n=a+-12|0;o=a+-24|0;p=a+-4|0;q=a+-8|0;r=m;b:while(1){s=r;t=b-s|0;switch((t|0)/12|0|0){case 3:{u=r;v=n;w=10;break a;break}case 5:{x=r;y=n;w=12;break a;break}case 4:{z=r;A=n;w=11;break a;break}case 2:{B=r;C=p;D=q;E=n;F=n;w=4;break a;break}case 1:case 0:{w=93;break a;break}default:{}}if((t|0)<372){G=r;H=a;w=14;break a}I=(t|0)/24|0;J=r+(I*12|0)|0;if((t|0)>11988){K=(t|0)/48|0;L=O7b(r,r+(K*12|0)|0,J,r+((K+I|0)*12|0)|0,n,d)|0}else L=M7b(r,J,n,d)|0;K=r+8|0;t=c[K>>2]|0;M=c[r+(I*12|0)+8>>2]|0;do if((t|0)==(M|0)){N=ea(g[r+4>>2]);O=ea(g[r+(I*12|0)+4>>2]);P=ea(N-O);if(ea(P*P)>h)if(N>O){Q=n;R=L;break}else{w=23;break}else{S=c[r>>2]|0;T=c[c[j>>2]>>2]|0;O=ea(g[T+(S*24|0)>>2]);N=ea(g[T+(S*24|0)+4>>2]);P=ea(g[T+(S*24|0)+8>>2]);S=c[J>>2]|0;U=ea(g[T+(S*24|0)>>2]);V=ea(g[T+(S*24|0)+4>>2]);W=ea(g[T+(S*24|0)+8>>2]);X=ea(g[d>>2]);Y=ea(O-X);O=ea(g[k>>2]);Z=ea(N-O);N=ea(g[l>>2]);_=ea(P-N);P=ea(U-X);X=ea(V-O);O=ea(W-N);if(ea(ea(ea(Y*Y)+ea(Z*Z))+ea(_*_))<ea(ea(ea(P*P)+ea(X*X))+ea(O*O))){Q=n;R=L;break}else{w=23;break}}}else if((t|0)>(M|0)){Q=n;R=L}else w=23;while(0);c:do if((w|0)==23){w=0;d:do if((r|0)!=(o|0)){S=r+(I*12|0)+4|0;T=c[j>>2]|0;O=ea(g[d>>2]);X=ea(g[k>>2]);P=ea(g[l>>2]);$=a;aa=o;ba=n;e:while(1){ca=c[$+-16>>2]|0;do if((ca|0)==(M|0)){_=ea(g[$+-20>>2]);Z=ea(g[S>>2]);Y=ea(_-Z);if(ea(Y*Y)>h)if(_>Z){da=aa;break e}else break;else{fa=c[$+-24>>2]|0;ga=c[T>>2]|0;Z=ea(g[ga+(fa*24|0)>>2]);_=ea(g[ga+(fa*24|0)+4>>2]);Y=ea(g[ga+(fa*24|0)+8>>2]);fa=c[J>>2]|0;N=ea(g[ga+(fa*24|0)>>2]);W=ea(g[ga+(fa*24|0)+4>>2]);V=ea(Z-O);Z=ea(_-X);_=ea(Y-P);Y=ea(N-O);N=ea(W-X);W=ea(ea(g[ga+(fa*24|0)+8>>2])-P);if(ea(ea(ea(V*V)+ea(Z*Z))+ea(_*_))<ea(ea(ea(Y*Y)+ea(N*N))+ea(W*W))){da=aa;break e}else break}}else if((ca|0)>(M|0)){da=aa;break e}while(0);ca=ba+-24|0;if((r|0)==(ca|0))break d;else{fa=aa;ga=ba;aa=ca;ba=fa;$=ga}}c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[r+0>>2]=c[da+0>>2];c[r+4>>2]=c[da+4>>2];c[r+8>>2]=c[da+8>>2];c[da+0>>2]=c[f+0>>2];c[da+4>>2]=c[f+4>>2];c[da+8>>2]=c[f+8>>2];Q=da;R=L+1|0;break c}while(0);$=r+12|0;ba=c[p>>2]|0;do if((t|0)==(ba|0)){P=ea(g[r+4>>2]);X=ea(g[q>>2]);O=ea(P-X);if(ea(O*O)>h)if(P>X){ha=$;break}else{w=30;break}else{aa=c[r>>2]|0;T=c[c[j>>2]>>2]|0;X=ea(g[T+(aa*24|0)>>2]);P=ea(g[T+(aa*24|0)+4>>2]);O=ea(g[T+(aa*24|0)+8>>2]);aa=c[n>>2]|0;W=ea(g[T+(aa*24|0)>>2]);N=ea(g[T+(aa*24|0)+4>>2]);Y=ea(g[T+(aa*24|0)+8>>2]);_=ea(g[d>>2]);Z=ea(X-_);X=ea(g[k>>2]);V=ea(P-X);P=ea(g[l>>2]);U=ea(O-P);O=ea(W-_);_=ea(N-X);X=ea(Y-P);if(ea(ea(ea(Z*Z)+ea(V*V))+ea(U*U))<ea(ea(ea(O*O)+ea(_*_))+ea(X*X))){ha=$;break}else{w=30;break}}}else if((t|0)>(ba|0))ha=$;else w=30;while(0);if((w|0)==30){w=0;if(($|0)==(n|0)){w=93;break a}ba=r+4|0;aa=c[j>>2]|0;X=ea(g[d>>2]);_=ea(g[k>>2]);O=ea(g[l>>2]);T=r;S=$;f:while(1){ga=c[S+8>>2]|0;do if((t|0)==(ga|0)){U=ea(g[ba>>2]);V=ea(g[S+4>>2]);Z=ea(U-V);if(ea(Z*Z)>h)if(U>V){ia=S;break f}else break;else{fa=c[r>>2]|0;ca=c[aa>>2]|0;V=ea(g[ca+(fa*24|0)>>2]);U=ea(g[ca+(fa*24|0)+4>>2]);Z=ea(g[ca+(fa*24|0)+8>>2]);fa=c[S>>2]|0;P=ea(g[ca+(fa*24|0)>>2]);Y=ea(g[ca+(fa*24|0)+4>>2]);N=ea(V-X);V=ea(U-_);U=ea(Z-O);Z=ea(P-X);P=ea(Y-_);Y=ea(ea(g[ca+(fa*24|0)+8>>2])-O);if(ea(ea(ea(N*N)+ea(V*V))+ea(U*U))<ea(ea(ea(Z*Z)+ea(P*P))+ea(Y*Y))){ia=S;break f}else break}}else if((t|0)>(ga|0)){ia=S;break f}while(0);ga=T+24|0;if((ga|0)==(n|0)){w=93;break a}else{fa=S;S=ga;T=fa}}c[f+0>>2]=c[ia+0>>2];c[f+4>>2]=c[ia+4>>2];c[f+8>>2]=c[ia+8>>2];c[ia+0>>2]=c[n+0>>2];c[ia+4>>2]=c[n+4>>2];c[ia+8>>2]=c[n+8>>2];c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];ha=ia+12|0}if((ha|0)==(n|0)){w=93;break a}T=r+4|0;S=ha;aa=n;while(1){ba=c[K>>2]|0;$=c[j>>2]|0;O=ea(g[d>>2]);_=ea(g[k>>2]);X=ea(g[l>>2]);fa=S;g:while(1){ga=c[fa+8>>2]|0;do if((ba|0)==(ga|0)){Y=ea(g[T>>2]);P=ea(g[fa+4>>2]);Z=ea(Y-P);if(ea(Z*Z)>h)if(Y>P){ja=fa;break g}else break;else{ca=c[r>>2]|0;ka=c[$>>2]|0;P=ea(g[ka+(ca*24|0)>>2]);Y=ea(g[ka+(ca*24|0)+4>>2]);Z=ea(g[ka+(ca*24|0)+8>>2]);ca=c[fa>>2]|0;U=ea(g[ka+(ca*24|0)>>2]);V=ea(g[ka+(ca*24|0)+4>>2]);N=ea(P-O);P=ea(Y-_);Y=ea(Z-X);Z=ea(U-O);U=ea(V-_);V=ea(ea(g[ka+(ca*24|0)+8>>2])-X);if(ea(ea(ea(N*N)+ea(P*P))+ea(Y*Y))<ea(ea(ea(Z*Z)+ea(U*U))+ea(V*V))){ja=fa;break g}else break}}else if((ba|0)>(ga|0)){ja=fa;break g}while(0);fa=fa+12|0}fa=aa;while(1){ga=fa+-12|0;ca=c[fa+-4>>2]|0;if((ba|0)!=(ca|0))if((ba|0)>(ca|0)){fa=ga;continue}else{la=ga;break}V=ea(g[T>>2]);U=ea(g[fa+-8>>2]);Z=ea(V-U);if(ea(Z*Z)>h)if(V>U){fa=ga;continue}else{la=ga;break}else{ca=c[r>>2]|0;ka=c[$>>2]|0;U=ea(g[ka+(ca*24|0)>>2]);V=ea(g[ka+(ca*24|0)+4>>2]);Z=ea(g[ka+(ca*24|0)+8>>2]);ca=c[ga>>2]|0;Y=ea(g[ka+(ca*24|0)>>2]);P=ea(g[ka+(ca*24|0)+4>>2]);N=ea(U-O);U=ea(V-_);V=ea(Z-X);Z=ea(Y-O);Y=ea(P-_);P=ea(ea(g[ka+(ca*24|0)+8>>2])-X);if(ea(ea(ea(N*N)+ea(U*U))+ea(V*V))<ea(ea(ea(Z*Z)+ea(Y*Y))+ea(P*P))){fa=ga;continue}else{la=ga;break}}}if(ja>>>0>=la>>>0){r=ja;continue b};c[f+0>>2]=c[ja+0>>2];c[f+4>>2]=c[ja+4>>2];c[f+8>>2]=c[ja+8>>2];c[ja+0>>2]=c[la+0>>2];c[ja+4>>2]=c[la+4>>2];c[ja+8>>2]=c[la+8>>2];c[la+0>>2]=c[f+0>>2];c[la+4>>2]=c[f+4>>2];c[la+8>>2]=c[f+8>>2];S=ja+12|0;aa=la}}while(0);K=r+12|0;h:do if(K>>>0<Q>>>0){t=K;M=Q;I=J;aa=R;while(1){S=c[I+8>>2]|0;T=I+4|0;fa=c[j>>2]|0;X=ea(g[d>>2]);_=ea(g[k>>2]);O=ea(g[l>>2]);$=t;i:while(1){ba=c[$+8>>2]|0;do if((ba|0)==(S|0)){P=ea(g[$+4>>2]);Y=ea(g[T>>2]);Z=ea(P-Y);if(ea(Z*Z)>h)if(P>Y)break;else{ma=$;break i}else{ga=c[$>>2]|0;ca=c[fa>>2]|0;Y=ea(g[ca+(ga*24|0)>>2]);P=ea(g[ca+(ga*24|0)+4>>2]);Z=ea(g[ca+(ga*24|0)+8>>2]);ga=c[I>>2]|0;V=ea(g[ca+(ga*24|0)>>2]);U=ea(g[ca+(ga*24|0)+4>>2]);N=ea(Y-X);Y=ea(P-_);P=ea(Z-O);Z=ea(V-X);V=ea(U-_);U=ea(ea(g[ca+(ga*24|0)+8>>2])-O);if(ea(ea(ea(N*N)+ea(Y*Y))+ea(P*P))<ea(ea(ea(Z*Z)+ea(V*V))+ea(U*U)))break;else{ma=$;break i}}}else if((ba|0)<=(S|0)){ma=$;break i}while(0);$=$+12|0}$=M;while(1){ba=$+-12|0;ga=c[$+-4>>2]|0;if((ga|0)!=(S|0))if((ga|0)>(S|0)){na=ba;break}else{$=ba;continue}U=ea(g[$+-8>>2]);V=ea(g[T>>2]);Z=ea(U-V);if(ea(Z*Z)>h)if(U>V){na=ba;break}else{$=ba;continue}else{ga=c[ba>>2]|0;ca=c[fa>>2]|0;V=ea(g[ca+(ga*24|0)>>2]);U=ea(g[ca+(ga*24|0)+4>>2]);Z=ea(g[ca+(ga*24|0)+8>>2]);ga=c[I>>2]|0;P=ea(g[ca+(ga*24|0)>>2]);Y=ea(g[ca+(ga*24|0)+4>>2]);N=ea(V-X);V=ea(U-_);U=ea(Z-O);Z=ea(P-X);P=ea(Y-_);Y=ea(ea(g[ca+(ga*24|0)+8>>2])-O);if(ea(ea(ea(N*N)+ea(V*V))+ea(U*U))<ea(ea(ea(Z*Z)+ea(P*P))+ea(Y*Y))){na=ba;break}else{$=ba;continue}}}if(ma>>>0>na>>>0){oa=ma;pa=I;qa=aa;break h};c[f+0>>2]=c[ma+0>>2];c[f+4>>2]=c[ma+4>>2];c[f+8>>2]=c[ma+8>>2];c[ma+0>>2]=c[na+0>>2];c[ma+4>>2]=c[na+4>>2];c[ma+8>>2]=c[na+8>>2];c[na+0>>2]=c[f+0>>2];c[na+4>>2]=c[f+4>>2];c[na+8>>2]=c[f+8>>2];t=ma+12|0;M=na;I=(I|0)==(ma|0)?na:I;aa=aa+1|0}}else{oa=K;pa=J;qa=R}while(0);j:do if((oa|0)==(pa|0))ra=qa;else{J=c[pa+8>>2]|0;K=c[oa+8>>2]|0;do if((J|0)==(K|0)){O=ea(g[pa+4>>2]);_=ea(g[oa+4>>2]);X=ea(O-_);if(ea(X*X)>h)if(O>_)break;else{ra=qa;break j}else{aa=c[pa>>2]|0;I=c[c[j>>2]>>2]|0;_=ea(g[I+(aa*24|0)>>2]);O=ea(g[I+(aa*24|0)+4>>2]);X=ea(g[I+(aa*24|0)+8>>2]);aa=c[oa>>2]|0;Y=ea(g[I+(aa*24|0)>>2]);P=ea(g[I+(aa*24|0)+4>>2]);Z=ea(g[I+(aa*24|0)+8>>2]);U=ea(g[d>>2]);V=ea(_-U);_=ea(g[k>>2]);N=ea(O-_);O=ea(g[l>>2]);W=ea(X-O);X=ea(Y-U);U=ea(P-_);_=ea(Z-O);if(ea(ea(ea(V*V)+ea(N*N))+ea(W*W))<ea(ea(ea(X*X)+ea(U*U))+ea(_*_)))break;else{ra=qa;break j}}}else if((J|0)<=(K|0)){ra=qa;break j}while(0);c[f+0>>2]=c[oa+0>>2];c[f+4>>2]=c[oa+4>>2];c[f+8>>2]=c[oa+8>>2];c[oa+0>>2]=c[pa+0>>2];c[oa+4>>2]=c[pa+4>>2];c[oa+8>>2]=c[pa+8>>2];c[pa+0>>2]=c[f+0>>2];c[pa+4>>2]=c[f+4>>2];c[pa+8>>2]=c[f+8>>2];ra=qa+1|0}while(0);if(!ra){sa=Q7b(r,oa,d)|0;K=oa+12|0;if(Q7b(K,a,d)|0){w=88;break}if(sa){r=K;continue}}K=oa;if((K-s|0)>=(b-K|0)){ta=r;ua=oa;w=92;break}K7b(r,oa,d);r=oa+12|0}if((w|0)==88){w=0;if(sa){w=93;break}else{m=r;a=oa;continue}}else if((w|0)==92){w=0;K7b(ua+12|0,a,d);m=ta;a=ua;continue}}if((w|0)==4){ua=c[C>>2]|0;C=c[B+8>>2]|0;do if((ua|0)==(C|0)){_=ea(g[D>>2]);U=ea(g[B+4>>2]);X=ea(_-U);if(ea(X*X)>h){if(_>U)break;i=e;return}else{a=c[E>>2]|0;ta=c[c[j>>2]>>2]|0;U=ea(g[ta+(a*24|0)>>2]);_=ea(g[ta+(a*24|0)+4>>2]);X=ea(g[ta+(a*24|0)+8>>2]);a=c[B>>2]|0;W=ea(g[ta+(a*24|0)>>2]);N=ea(g[ta+(a*24|0)+4>>2]);V=ea(g[ta+(a*24|0)+8>>2]);O=ea(g[d>>2]);Z=ea(U-O);U=ea(g[k>>2]);P=ea(_-U);_=ea(g[l>>2]);Y=ea(X-_);X=ea(W-O);O=ea(N-U);U=ea(V-_);if(ea(ea(ea(Z*Z)+ea(P*P))+ea(Y*Y))<ea(ea(ea(X*X)+ea(O*O))+ea(U*U)))break;i=e;return}}else if((ua|0)<=(C|0)){i=e;return}while(0);c[f+0>>2]=c[B+0>>2];c[f+4>>2]=c[B+4>>2];c[f+8>>2]=c[B+8>>2];c[B+0>>2]=c[F+0>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];c[F+0>>2]=c[f+0>>2];c[F+4>>2]=c[f+4>>2];c[F+8>>2]=c[f+8>>2];i=e;return}else if((w|0)==10){M7b(u,u+12|0,v,d)|0;i=e;return}else if((w|0)==11){N7b(z,z+12|0,z+24|0,A,d)|0;i=e;return}else if((w|0)==12){O7b(x,x+12|0,x+24|0,x+36|0,y,d)|0;i=e;return}else if((w|0)==14){P7b(G,H,d);i=e;return}else if((w|0)==93){i=e;return}}function L7b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function M7b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0;f=i;i=i+16|0;h=f;j=b+8|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;do if((k|0)==(m|0)){n=ea(g[b+4>>2]);o=ea(g[a+4>>2]);p=ea(n-o);q=ea(p*p);if(q>ea(g[150276])){r=n>o;break}else{s=c[b>>2]|0;t=c[c[e+24>>2]>>2]|0;o=ea(g[t+(s*24|0)>>2]);n=ea(g[t+(s*24|0)+4>>2]);q=ea(g[t+(s*24|0)+8>>2]);s=c[a>>2]|0;p=ea(g[t+(s*24|0)>>2]);u=ea(g[t+(s*24|0)+4>>2]);v=ea(g[t+(s*24|0)+8>>2]);w=ea(g[e>>2]);x=ea(o-w);o=ea(g[e+4>>2]);y=ea(n-o);n=ea(g[e+8>>2]);z=ea(q-n);q=ea(p-w);w=ea(u-o);o=ea(v-n);r=ea(ea(ea(x*x)+ea(y*y))+ea(z*z))<ea(ea(ea(q*q)+ea(w*w))+ea(o*o));break}}else r=(k|0)>(m|0);while(0);m=d+8|0;s=c[m>>2]|0;do if((s|0)==(k|0)){o=ea(g[d+4>>2]);w=ea(g[b+4>>2]);q=ea(o-w);z=ea(q*q);if(z>ea(g[150276])){A=o>w;break}else{t=c[d>>2]|0;B=c[c[e+24>>2]>>2]|0;w=ea(g[B+(t*24|0)>>2]);o=ea(g[B+(t*24|0)+4>>2]);z=ea(g[B+(t*24|0)+8>>2]);t=c[b>>2]|0;q=ea(g[B+(t*24|0)>>2]);y=ea(g[B+(t*24|0)+4>>2]);x=ea(g[B+(t*24|0)+8>>2]);n=ea(g[e>>2]);v=ea(w-n);w=ea(g[e+4>>2]);u=ea(o-w);o=ea(g[e+8>>2]);p=ea(z-o);z=ea(q-n);n=ea(y-w);w=ea(x-o);A=ea(ea(ea(v*v)+ea(u*u))+ea(p*p))<ea(ea(ea(z*z)+ea(n*n))+ea(w*w));break}}else A=(s|0)>(k|0);while(0);if(!r){if(!A){C=0;i=f;return C|0};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];r=c[j>>2]|0;k=c[l>>2]|0;do if((r|0)==(k|0)){w=ea(g[b+4>>2]);n=ea(g[a+4>>2]);z=ea(w-n);p=ea(z*z);if(p>ea(g[150276])){if(w>n)break;else C=1;i=f;return C|0}else{l=c[b>>2]|0;s=c[c[e+24>>2]>>2]|0;n=ea(g[s+(l*24|0)>>2]);w=ea(g[s+(l*24|0)+4>>2]);p=ea(g[s+(l*24|0)+8>>2]);l=c[a>>2]|0;z=ea(g[s+(l*24|0)>>2]);u=ea(g[s+(l*24|0)+4>>2]);v=ea(g[s+(l*24|0)+8>>2]);o=ea(g[e>>2]);x=ea(n-o);n=ea(g[e+4>>2]);y=ea(w-n);w=ea(g[e+8>>2]);q=ea(p-w);p=ea(z-o);o=ea(u-n);n=ea(v-w);if(ea(ea(ea(x*x)+ea(y*y))+ea(q*q))<ea(ea(ea(p*p)+ea(o*o))+ea(n*n)))break;else C=1;i=f;return C|0}}else if((r|0)<=(k|0)){C=1;i=f;return C|0}while(0);c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];C=2;i=f;return C|0}if(A){c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];C=1;i=f;return C|0};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];a=c[m>>2]|0;m=c[j>>2]|0;do if((a|0)==(m|0)){n=ea(g[d+4>>2]);o=ea(g[b+4>>2]);p=ea(n-o);q=ea(p*p);if(q>ea(g[150276])){if(n>o)break;else C=1;i=f;return C|0}else{j=c[d>>2]|0;A=c[c[e+24>>2]>>2]|0;o=ea(g[A+(j*24|0)>>2]);n=ea(g[A+(j*24|0)+4>>2]);q=ea(g[A+(j*24|0)+8>>2]);j=c[b>>2]|0;p=ea(g[A+(j*24|0)>>2]);y=ea(g[A+(j*24|0)+4>>2]);x=ea(g[A+(j*24|0)+8>>2]);w=ea(g[e>>2]);v=ea(o-w);o=ea(g[e+4>>2]);u=ea(n-o);n=ea(g[e+8>>2]);z=ea(q-n);q=ea(p-w);w=ea(y-o);o=ea(x-n);if(ea(ea(ea(v*v)+ea(u*u))+ea(z*z))<ea(ea(ea(q*q)+ea(w*w))+ea(o*o)))break;else C=1;i=f;return C|0}}else if((a|0)<=(m|0)){C=1;i=f;return C|0}while(0);c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];C=2;i=f;return C|0}function N7b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;h=i;i=i+16|0;j=h;k=M7b(a,b,d,f)|0;l=c[e+8>>2]|0;m=d+8|0;n=c[m>>2]|0;do if((l|0)==(n|0)){o=ea(g[e+4>>2]);p=ea(g[d+4>>2]);q=ea(o-p);r=ea(q*q);if(r>ea(g[150276])){if(o>p)break;else s=k;i=h;return s|0}else{t=c[e>>2]|0;u=c[c[f+24>>2]>>2]|0;p=ea(g[u+(t*24|0)>>2]);o=ea(g[u+(t*24|0)+4>>2]);r=ea(g[u+(t*24|0)+8>>2]);t=c[d>>2]|0;q=ea(g[u+(t*24|0)>>2]);v=ea(g[u+(t*24|0)+4>>2]);w=ea(g[u+(t*24|0)+8>>2]);x=ea(g[f>>2]);y=ea(p-x);p=ea(g[f+4>>2]);z=ea(o-p);o=ea(g[f+8>>2]);A=ea(r-o);r=ea(q-x);x=ea(v-p);p=ea(w-o);if(ea(ea(ea(y*y)+ea(z*z))+ea(A*A))<ea(ea(ea(r*r)+ea(x*x))+ea(p*p)))break;else s=k;i=h;return s|0}}else if((l|0)<=(n|0)){s=k;i=h;return s|0}while(0);c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];e=k+1|0;n=c[m>>2]|0;m=b+8|0;l=c[m>>2]|0;do if((n|0)==(l|0)){p=ea(g[d+4>>2]);x=ea(g[b+4>>2]);r=ea(p-x);A=ea(r*r);if(A>ea(g[150276])){if(p>x)break;else s=e;i=h;return s|0}else{t=c[d>>2]|0;u=c[c[f+24>>2]>>2]|0;x=ea(g[u+(t*24|0)>>2]);p=ea(g[u+(t*24|0)+4>>2]);A=ea(g[u+(t*24|0)+8>>2]);t=c[b>>2]|0;r=ea(g[u+(t*24|0)>>2]);z=ea(g[u+(t*24|0)+4>>2]);y=ea(g[u+(t*24|0)+8>>2]);o=ea(g[f>>2]);w=ea(x-o);x=ea(g[f+4>>2]);v=ea(p-x);p=ea(g[f+8>>2]);q=ea(A-p);A=ea(r-o);o=ea(z-x);x=ea(y-p);if(ea(ea(ea(w*w)+ea(v*v))+ea(q*q))<ea(ea(ea(A*A)+ea(o*o))+ea(x*x)))break;else s=e;i=h;return s|0}}else if((n|0)<=(l|0)){s=e;i=h;return s|0}while(0);c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];d=k+2|0;e=c[m>>2]|0;m=c[a+8>>2]|0;do if((e|0)==(m|0)){x=ea(g[b+4>>2]);o=ea(g[a+4>>2]);A=ea(x-o);q=ea(A*A);if(q>ea(g[150276])){if(x>o)break;else s=d;i=h;return s|0}else{l=c[b>>2]|0;n=c[c[f+24>>2]>>2]|0;o=ea(g[n+(l*24|0)>>2]);x=ea(g[n+(l*24|0)+4>>2]);q=ea(g[n+(l*24|0)+8>>2]);l=c[a>>2]|0;A=ea(g[n+(l*24|0)>>2]);v=ea(g[n+(l*24|0)+4>>2]);w=ea(g[n+(l*24|0)+8>>2]);p=ea(g[f>>2]);y=ea(o-p);o=ea(g[f+4>>2]);z=ea(x-o);x=ea(g[f+8>>2]);r=ea(q-x);q=ea(A-p);p=ea(v-o);o=ea(w-x);if(ea(ea(ea(y*y)+ea(z*z))+ea(r*r))<ea(ea(ea(q*q)+ea(p*p))+ea(o*o)))break;else s=d;i=h;return s|0}}else if((e|0)<=(m|0)){s=d;i=h;return s|0}while(0);c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];s=k+3|0;i=h;return s|0}function O7b(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im;j=i;i=i+16|0;k=j;l=N7b(a,b,d,e,h)|0;m=c[f+8>>2]|0;n=e+8|0;o=c[n>>2]|0;do if((m|0)==(o|0)){p=ea(g[f+4>>2]);q=ea(g[e+4>>2]);r=ea(p-q);s=ea(r*r);if(s>ea(g[150276])){if(p>q)break;else t=l;i=j;return t|0}else{u=c[f>>2]|0;v=c[c[h+24>>2]>>2]|0;q=ea(g[v+(u*24|0)>>2]);p=ea(g[v+(u*24|0)+4>>2]);s=ea(g[v+(u*24|0)+8>>2]);u=c[e>>2]|0;r=ea(g[v+(u*24|0)>>2]);w=ea(g[v+(u*24|0)+4>>2]);x=ea(g[v+(u*24|0)+8>>2]);y=ea(g[h>>2]);z=ea(q-y);q=ea(g[h+4>>2]);A=ea(p-q);p=ea(g[h+8>>2]);B=ea(s-p);s=ea(r-y);y=ea(w-q);q=ea(x-p);if(ea(ea(ea(z*z)+ea(A*A))+ea(B*B))<ea(ea(ea(s*s)+ea(y*y))+ea(q*q)))break;else t=l;i=j;return t|0}}else if((m|0)<=(o|0)){t=l;i=j;return t|0}while(0);c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];f=l+1|0;o=c[n>>2]|0;n=d+8|0;m=c[n>>2]|0;do if((o|0)==(m|0)){q=ea(g[e+4>>2]);y=ea(g[d+4>>2]);s=ea(q-y);B=ea(s*s);if(B>ea(g[150276])){if(q>y)break;else t=f;i=j;return t|0}else{u=c[e>>2]|0;v=c[c[h+24>>2]>>2]|0;y=ea(g[v+(u*24|0)>>2]);q=ea(g[v+(u*24|0)+4>>2]);B=ea(g[v+(u*24|0)+8>>2]);u=c[d>>2]|0;s=ea(g[v+(u*24|0)>>2]);A=ea(g[v+(u*24|0)+4>>2]);z=ea(g[v+(u*24|0)+8>>2]);p=ea(g[h>>2]);x=ea(y-p);y=ea(g[h+4>>2]);w=ea(q-y);q=ea(g[h+8>>2]);r=ea(B-q);B=ea(s-p);p=ea(A-y);y=ea(z-q);if(ea(ea(ea(x*x)+ea(w*w))+ea(r*r))<ea(ea(ea(B*B)+ea(p*p))+ea(y*y)))break;else t=f;i=j;return t|0}}else if((o|0)<=(m|0)){t=f;i=j;return t|0}while(0);c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];e=l+2|0;f=c[n>>2]|0;n=b+8|0;m=c[n>>2]|0;do if((f|0)==(m|0)){y=ea(g[d+4>>2]);p=ea(g[b+4>>2]);B=ea(y-p);r=ea(B*B);if(r>ea(g[150276])){if(y>p)break;else t=e;i=j;return t|0}else{o=c[d>>2]|0;u=c[c[h+24>>2]>>2]|0;p=ea(g[u+(o*24|0)>>2]);y=ea(g[u+(o*24|0)+4>>2]);r=ea(g[u+(o*24|0)+8>>2]);o=c[b>>2]|0;B=ea(g[u+(o*24|0)>>2]);w=ea(g[u+(o*24|0)+4>>2]);x=ea(g[u+(o*24|0)+8>>2]);q=ea(g[h>>2]);z=ea(p-q);p=ea(g[h+4>>2]);A=ea(y-p);y=ea(g[h+8>>2]);s=ea(r-y);r=ea(B-q);q=ea(w-p);p=ea(x-y);if(ea(ea(ea(z*z)+ea(A*A))+ea(s*s))<ea(ea(ea(r*r)+ea(q*q))+ea(p*p)))break;else t=e;i=j;return t|0}}else if((f|0)<=(m|0)){t=e;i=j;return t|0}while(0);c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];d=l+3|0;e=c[n>>2]|0;n=c[a+8>>2]|0;do if((e|0)==(n|0)){p=ea(g[b+4>>2]);q=ea(g[a+4>>2]);r=ea(p-q);s=ea(r*r);if(s>ea(g[150276])){if(p>q)break;else t=d;i=j;return t|0}else{m=c[b>>2]|0;f=c[c[h+24>>2]>>2]|0;q=ea(g[f+(m*24|0)>>2]);p=ea(g[f+(m*24|0)+4>>2]);s=ea(g[f+(m*24|0)+8>>2]);m=c[a>>2]|0;r=ea(g[f+(m*24|0)>>2]);A=ea(g[f+(m*24|0)+4>>2]);z=ea(g[f+(m*24|0)+8>>2]);y=ea(g[h>>2]);x=ea(q-y);q=ea(g[h+4>>2]);w=ea(p-q);p=ea(g[h+8>>2]);B=ea(s-p);s=ea(r-y);y=ea(A-q);q=ea(z-p);if(ea(ea(ea(x*x)+ea(w*w))+ea(B*B))<ea(ea(ea(s*s)+ea(y*y))+ea(q*q)))break;else t=d;i=j;return t|0}}else if((e|0)<=(n|0)){t=d;i=j;return t|0}while(0);c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[b+0>>2]=c[k+0>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];t=l+4|0;i=j;return t|0}function P7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0;e=i;f=a+24|0;M7b(a,a+12|0,f,d)|0;h=a+36|0;if((h|0)==(b|0)){i=e;return}j=ea(g[150276]);k=d+24|0;l=d+4|0;m=d+8|0;n=h;h=f;while(1){f=c[n+8>>2]|0;o=c[h+8>>2]|0;do if((f|0)==(o|0)){p=ea(g[n+4>>2]);q=ea(g[h+4>>2]);r=ea(p-q);if(ea(r*r)>j)if(p>q){s=p;t=9;break}else break;else{u=c[n>>2]|0;v=c[c[k>>2]>>2]|0;q=ea(g[v+(u*24|0)>>2]);r=ea(g[v+(u*24|0)+4>>2]);w=ea(g[v+(u*24|0)+8>>2]);u=c[h>>2]|0;x=ea(g[v+(u*24|0)>>2]);y=ea(g[v+(u*24|0)+4>>2]);z=ea(g[v+(u*24|0)+8>>2]);A=ea(g[d>>2]);B=ea(q-A);q=ea(g[l>>2]);C=ea(r-q);r=ea(g[m>>2]);D=ea(w-r);w=ea(x-A);A=ea(y-q);q=ea(z-r);if(ea(ea(ea(B*B)+ea(C*C))+ea(D*D))<ea(ea(ea(w*w)+ea(A*A))+ea(q*q))){s=p;t=9;break}else break}}else if((f|0)>(o|0)){s=ea(g[n+4>>2]);t=9}while(0);if((t|0)==9){t=0;o=c[n>>2]|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];a:do if((h|0)==(a|0))E=a;else{u=h;while(1){v=u;u=u+-12|0;F=c[v+-4>>2]|0;do if((f|0)==(F|0)){p=ea(g[v+-8>>2]);q=ea(s-p);if(ea(q*q)>j)if(s>p)break;else{E=v;break a}else{G=c[c[k>>2]>>2]|0;p=ea(g[G+(o*24|0)>>2]);q=ea(g[G+(o*24|0)+4>>2]);A=ea(g[G+(o*24|0)+8>>2]);H=c[u>>2]|0;w=ea(g[G+(H*24|0)>>2]);D=ea(g[G+(H*24|0)+4>>2]);C=ea(g[G+(H*24|0)+8>>2]);B=ea(g[d>>2]);r=ea(p-B);p=ea(g[l>>2]);z=ea(q-p);q=ea(g[m>>2]);y=ea(A-q);A=ea(w-B);B=ea(D-p);p=ea(C-q);if(ea(ea(ea(r*r)+ea(z*z))+ea(y*y))<ea(ea(ea(A*A)+ea(B*B))+ea(p*p)))break;else{E=v;break a}}}else if((f|0)<=(F|0)){E=v;break a}while(0);c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];if((u|0)==(a|0)){E=a;break}}}while(0);c[E>>2]=o;g[E+4>>2]=s;c[E+8>>2]=f}u=n+12|0;if((u|0)==(b|0))break;else{F=n;n=u;h=F}}i=e;return}function Q7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=0,C=0,D=0,E=0,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0;e=i;i=i+16|0;f=e;switch((b-a|0)/12|0|0){case 1:case 0:{h=1;i=e;return h|0}case 2:{j=b+-12|0;k=c[b+-4>>2]|0;l=c[a+8>>2]|0;do if((k|0)==(l|0)){m=ea(g[b+-8>>2]);n=ea(g[a+4>>2]);o=ea(m-n);p=ea(o*o);if(p>ea(g[150276])){if(m>n)break;else h=1;i=e;return h|0}else{q=c[j>>2]|0;r=c[c[d+24>>2]>>2]|0;n=ea(g[r+(q*24|0)>>2]);m=ea(g[r+(q*24|0)+4>>2]);p=ea(g[r+(q*24|0)+8>>2]);q=c[a>>2]|0;o=ea(g[r+(q*24|0)>>2]);s=ea(g[r+(q*24|0)+4>>2]);t=ea(g[r+(q*24|0)+8>>2]);u=ea(g[d>>2]);v=ea(n-u);n=ea(g[d+4>>2]);w=ea(m-n);m=ea(g[d+8>>2]);x=ea(p-m);p=ea(o-u);u=ea(s-n);n=ea(t-m);if(ea(ea(ea(v*v)+ea(w*w))+ea(x*x))<ea(ea(ea(p*p)+ea(u*u))+ea(n*n)))break;else h=1;i=e;return h|0}}else if((k|0)<=(l|0)){h=1;i=e;return h|0}while(0);c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];h=1;i=e;return h|0}case 3:{M7b(a,a+12|0,b+-12|0,d)|0;h=1;i=e;return h|0}case 5:{O7b(a,a+12|0,a+24|0,a+36|0,b+-12|0,d)|0;h=1;i=e;return h|0}case 4:{N7b(a,a+12|0,a+24|0,b+-12|0,d)|0;h=1;i=e;return h|0}default:{f=a+24|0;M7b(a,a+12|0,f,d)|0;j=a+36|0;if((j|0)==(b|0)){h=1;i=e;return h|0}n=ea(g[150276]);l=d+24|0;k=d+4|0;q=d+8|0;r=0;y=j;j=f;while(1){f=c[y+8>>2]|0;z=c[j+8>>2]|0;do if((f|0)==(z|0)){u=ea(g[y+4>>2]);p=ea(g[j+4>>2]);x=ea(u-p);if(ea(x*x)>n)if(u>p){A=u;B=19;break}else{C=r;break}else{D=c[y>>2]|0;E=c[c[l>>2]>>2]|0;p=ea(g[E+(D*24|0)>>2]);x=ea(g[E+(D*24|0)+4>>2]);w=ea(g[E+(D*24|0)+8>>2]);D=c[j>>2]|0;v=ea(g[E+(D*24|0)>>2]);m=ea(g[E+(D*24|0)+4>>2]);t=ea(g[E+(D*24|0)+8>>2]);s=ea(g[d>>2]);o=ea(p-s);p=ea(g[k>>2]);F=ea(x-p);x=ea(g[q>>2]);G=ea(w-x);w=ea(v-s);s=ea(m-p);p=ea(t-x);if(ea(ea(ea(o*o)+ea(F*F))+ea(G*G))<ea(ea(ea(w*w)+ea(s*s))+ea(p*p))){A=u;B=19;break}else{C=r;break}}}else if((f|0)>(z|0)){A=ea(g[y+4>>2]);B=19}else C=r;while(0);if((B|0)==19){B=0;z=c[y>>2]|0;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];a:do if((j|0)==(a|0))H=a;else{D=j;while(1){E=D;D=D+-12|0;I=c[E+-4>>2]|0;do if((f|0)==(I|0)){u=ea(g[E+-8>>2]);p=ea(A-u);if(ea(p*p)>n)if(A>u)break;else{H=E;break a}else{J=c[c[l>>2]>>2]|0;u=ea(g[J+(z*24|0)>>2]);p=ea(g[J+(z*24|0)+4>>2]);s=ea(g[J+(z*24|0)+8>>2]);K=c[D>>2]|0;w=ea(g[J+(K*24|0)>>2]);G=ea(g[J+(K*24|0)+4>>2]);F=ea(g[J+(K*24|0)+8>>2]);o=ea(g[d>>2]);x=ea(u-o);u=ea(g[k>>2]);t=ea(p-u);p=ea(g[q>>2]);m=ea(s-p);s=ea(w-o);o=ea(G-u);u=ea(F-p);if(ea(ea(ea(x*x)+ea(t*t))+ea(m*m))<ea(ea(ea(s*s)+ea(o*o))+ea(u*u)))break;else{H=E;break a}}}else if((f|0)<=(I|0)){H=E;break a}while(0);c[E+0>>2]=c[D+0>>2];c[E+4>>2]=c[D+4>>2];c[E+8>>2]=c[D+8>>2];if((D|0)==(a|0)){H=a;break}}}while(0);c[H>>2]=z;g[H+4>>2]=A;c[H+8>>2]=f;D=r+1|0;if((D|0)==8){L=y;break}else C=D}D=y+12|0;if((D|0)==(b|0)){h=1;B=29;break}else{I=y;r=C;y=D;j=I}}if((B|0)==29){i=e;return h|0}h=(L+12|0)==(b|0);i=e;return h|0}}return 0}function R7b(b){b=b|0;var d=0;d=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=-1;c[b+24>>2]=0;c[b+28>>2]=0;Crd(b);i=d;return}function S7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if(!b){T7b(0,c[a+24>>2]|0,d);i=e;return}f=c[b+32>>2]|0;if(!f){T7b(b,c[a+24>>2]|0,d);i=e;return}else if((f|0)==1){U7b(b,c[a+24>>2]|0,0);i=e;return}else{i=e;return}}function T7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0;e=i;i=i+48|0;f=e+32|0;h=e+16|0;j=e;mBc(1);yBc(b,(d|0)==63,1);k=A7b(l7b()|0)|0;l=BTb(c[k+24>>2]|0)|0;g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);g[f+12>>2]=ea(1.0);wGc(l,f);D0b(k,0);c[141376]=(c[141376]|0)+1;if(!a){yGc(l,601136);F0b(k,1);v0b(k,ea(1.0));c0b(k,b,d,336,0)|0;m=c[141376]|0;n=m+-1|0;c[141376]=n;mBc(0);i=e;return}else{rGc(h,BTb(c[a+24>>2]|0)|0);yGc(l,h);h=pyc()|0;o=ea(g[(c[h+24>>2]|0)+((c[h+40>>2]|0)*96|0)+32>>2]);h=pyc()|0;vyc(h,ea(g[a+84>>2]));p=ea(g[a+96>>2]);q=ea(g[a+100>>2]);r=ea(g[a+104>>2]);h=p<ea(0.0);s=h?ea(0.0):p;h=s>ea(1.0);l=~~ea(ea(s*ea(255.0))+ea(.5))>>>0;f=q<ea(0.0);s=f?ea(0.0):q;f=s>ea(1.0);t=~~ea(ea(s*ea(255.0))+ea(.5))>>>0;u=r<ea(0.0);s=u?ea(0.0):r;u=s>ea(1.0);v=~~ea(ea(s*ea(255.0))+ea(.5))>>>0;A0b(k,ea(g[a+76>>2]));B0b(k,ea(g[a+80>>2]));F0b(k,c[a+92>>2]|0);s=ea(ea(l&255|0)/ea(255.0));r=h?ea(1.0):s;s=ea(ea(t&255|0)/ea(255.0));q=f?ea(1.0):s;s=ea(ea(v&255|0)/ea(255.0));p=u?ea(1.0):s;g[j>>2]=r;g[j+4>>2]=q;g[j+8>>2]=p;g[j+12>>2]=ea(1.0);E0b(k,j);G0b(k,c[a+88>>2]|0);v0b(k,ea(1.0));c0b(k,b,d,0,0)|0;vyc(pyc()|0,o);m=c[141376]|0;n=m+-1|0;c[141376]=n;mBc(0);i=e;return}}function U7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=Im;d=i;i=i+176|0;e=d+96|0;f=d+56|0;h=d+12|0;j=d+24|0;k=d+160|0;l=d;m=d+40|0;n=d+80|0;o=d+68|0;p=a+24|0;QGc(e,BTb(c[p>>2]|0)|0);qGc(f,BTb(c[p>>2]|0)|0);q=ea(g[f>>2]);p=q<ea(.00999999977);r=p?ea(.00999999977):q;q=ea(g[f+4>>2]);f=q<ea(.00999999977);s=f?ea(.00999999977):q;f=A7b(l7b()|0)|0;p=BTb(c[f+24>>2]|0)|0;q=ea(g[e+48>>2]);t=ea(g[e+52>>2]);u=ea(g[e+56>>2]);v=e+32|0;w=ea(g[v>>2]);x=e+36|0;y=ea(g[x>>2]);z=e+40|0;A=ea(g[z>>2]);B=a+76|0;C=ea(g[B>>2]);D=ea(t+ea(y*C));y=ea(u+ea(A*C));g[h>>2]=ea(q+ea(w*C));g[h+4>>2]=D;g[h+8>>2]=y;yGc(p,h);y=ea(g[v>>2]);D=ea(g[x>>2]);C=ea(-D);D=ea(-ea(g[z>>2]));g[k>>2]=ea(-y);g[k+4>>2]=C;g[k+8>>2]=D;D=ea(g[e+16>>2]);C=ea(g[e+20>>2]);y=ea(-C);C=ea(-ea(g[e+24>>2]));g[l>>2]=ea(-D);g[l+4>>2]=y;g[l+8>>2]=C;JMc(k,l,j)|0;wGc(p,j);j=pyc()|0;C=ea(g[(c[j+24>>2]|0)+((c[j+40>>2]|0)*96|0)+32>>2]);j=pyc()|0;vyc(j,ea(g[a+84>>2]));y=ea(g[a+96>>2]);D=ea(g[a+100>>2]);w=ea(g[a+104>>2]);j=y<ea(0.0);q=j?ea(0.0):y;j=q>ea(1.0);p=~~ea(ea(q*ea(255.0))+ea(.5))>>>0;l=D<ea(0.0);q=l?ea(0.0):D;l=q>ea(1.0);k=~~ea(ea(q*ea(255.0))+ea(.5))>>>0;e=w<ea(0.0);q=e?ea(0.0):w;e=q>ea(1.0);z=~~ea(ea(q*ea(255.0))+ea(.5))>>>0;A0b(f,ea(g[B>>2]));B0b(f,ea(g[a+80>>2]));F0b(f,c[a+92>>2]|0);q=ea(ea(p&255|0)/ea(255.0));w=j?ea(1.0):q;q=ea(ea(k&255|0)/ea(255.0));D=l?ea(1.0):q;q=ea(ea(z&255|0)/ea(255.0));y=e?ea(1.0):q;g[m>>2]=w;g[m+4>>2]=D;g[m+8>>2]=y;g[m+12>>2]=ea(1.0);E0b(f,m);G0b(f,c[a+88>>2]|0);g[n>>2]=ea(0.0);g[n+8>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+12>>2]=ea(1.0);w$b(f,n);D0b(f,1);C0b(f,s);v0b(f,ea(r/s));z0b(f,b);rri(o,3653512,0);a0b(f,2,0,o);xri(o);vyc(pyc()|0,C);i=d;return}function V7b(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=a+24|0;k=c[j>>2]|0;if(!(mo[c[(c[k>>2]|0)+124>>2]&4095](k)|0)){i=h;return}X7b(c[j>>2]|0,c[a+28>>2]|0,b,d,e,f,g)|0;i=h;return}function W7b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[d+4>>2]=0;return}function X7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=0,Q=Im,R=Im,S=Im,T=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=0,fa=0,ga=Im,ha=0.0,ia=Im,ja=0,ka=Im,la=0,ma=Im,na=Im,oa=0,pa=Im,qa=0,ra=0,sa=Im,ta=0,ua=Im,va=0,wa=Im;k=i;i=i+288|0;l=k+40|0;m=k+32|0;n=k+60|0;o=k+268|0;p=k+12|0;q=k+48|0;r=k+64|0;s=k+264|0;t=k+272|0;u=k+276|0;v=k+8|0;w=k+4|0;x=k;y=k+44|0;z=k+24|0;A=k+28|0;B=k+260|0;C=k+36|0;D=Xmd()|0;rri(p,563824,15);E=Nmd(D,p)|0;xri(p);p=Xmd()|0;rri(q,563840,15);D=Nmd(p,q)|0;xri(q);if((E|0)==0|(D|0)==0|(d|0)==0|(b|0)==0){F=-1;i=k;return F|0}q=bkd(D,61,0)|0;D=bkd(E,61,0)|0;LDc(b,0);LDc(d,0);t1b(r,ync()|0);E=ync()|0;p=ync()|0;if(!(a[p+5832>>0]|0)){ko[c[(c[p>>2]|0)+500>>2]&4095](p);mo[c[(c[p>>2]|0)+516>>2]&4095](p)|0;G=1}else G=0;p=b+100|0;H=c[p>>2]>>1;if((H|0)>0){I=g+-1|0;J=(d|0)==(b|0);K=1;L=0;M=H;N=ea(ea(1.0)/ea(H|0));O=ea(.999984741);while(1){if(K>>>0>h>>>0){P=L;Q=O}else{if(K>>>0<g>>>0)if((K|0)!=(I|0)|J|(K&1|0)==0|e)R=O;else{S=ea(I|0);H=0;T=O;while(1){if(!(1<<H&f))V=T;else{c[s>>2]=c[140934];c[l+0>>2]=c[s+0>>2];nkd(D,l,S);c[m>>2]=c[140928];c[l+0>>2]=c[m+0>>2];rkd(D,l,b);Z7b(E,D,d,I,H,T);V=ea(T+ea(-.0000152587891))}H=H+1|0;if((H|0)>=6){R=V;break}else T=V}}else{T=ea(ea(K|0)+ea(-1.0));if(!(K&1)){H=0;S=O;while(1){if(!(1<<H&f))W=S;else{c[t>>2]=c[140930];c[l+0>>2]=c[t+0>>2];nkd(q,l,N);c[u>>2]=c[140938];c[l+0>>2]=c[u+0>>2];nkd(q,l,ea(1.0));c[v>>2]=c[140942];c[l+0>>2]=c[v+0>>2];nkd(q,l,ea(3.0));c[w>>2]=c[140934];c[l+0>>2]=c[w+0>>2];nkd(q,l,T);c[n>>2]=c[140928];c[l+0>>2]=c[n+0>>2];rkd(q,l,d);Z7b(E,q,b,K,H,S);W=ea(S+ea(-.0000152587891))}H=H+1|0;if((H|0)>=6){R=W;break}else S=W}}else{H=0;S=O;while(1){if(!(1<<H&f))X=S;else{c[t>>2]=c[140930];c[l+0>>2]=c[t+0>>2];nkd(q,l,N);c[u>>2]=c[140938];c[l+0>>2]=c[u+0>>2];nkd(q,l,ea(1.0));c[v>>2]=c[140942];c[l+0>>2]=c[v+0>>2];nkd(q,l,ea(3.0));c[w>>2]=c[140934];c[l+0>>2]=c[w+0>>2];nkd(q,l,T);c[o>>2]=c[140928];c[l+0>>2]=c[o+0>>2];rkd(q,l,b);Z7b(E,q,d,K,H,S);X=ea(S+ea(-.0000152587891))}H=H+1|0;if((H|0)>=6){R=X;break}else S=X}}}P=(M|0)==1;Q=R}M=M>>1;N=ea(N*ea(2.0));if((M|0)<=0){Y=P;Z=Q;break}else{K=K+1|0;L=P;O=Q}}if(Y&j){j=c[p>>2]|0;if((j|0)>0){Y=0;P=j;Q=Z;while(1){if(Y>>>0>=g>>>0)if(!(Y&1)){O=ea(Y|0);L=0;N=Q;while(1){if(!(1<<L&f))_=N;else{c[y>>2]=c[140934];c[l+0>>2]=c[y+0>>2];nkd(D,l,O);c[m>>2]=c[140928];c[l+0>>2]=c[m+0>>2];rkd(D,l,b);Z7b(E,D,d,Y,L,N);_=ea(N+ea(-.0000152587891))}L=L+1|0;if((L|0)>=6){$=_;break}else N=_}}else $=Q;else{N=ea(Y|0);L=0;O=Q;while(1){if(!(1<<L&f))aa=O;else{c[x>>2]=c[140934];c[l+0>>2]=c[x+0>>2];nkd(D,l,N);c[m>>2]=c[140928];c[l+0>>2]=c[m+0>>2];rkd(D,l,b);Z7b(E,D,d,Y,L,O);aa=ea(O+ea(-.0000152587891))}L=L+1|0;if((L|0)>=6){$=aa;break}else O=aa}}P=P>>1;if((P|0)<=0){ba=Y;ca=$;break}else{Y=Y+1|0;Q=$}}da=c[p>>2]|0;fa=ba;ga=ca}else{da=j;fa=-1;ga=Z}ca=ea(ea(1.0)/ea(fa|0));LDc(d,2);fa=da>>1;if((fa|0)>0){da=1;$=ca;j=fa;Q=ga;while(1){ha=+ea(+U(+$,1.5));ga=ea(ha*(+(c[p>>2]|0)*2.0));if((j|0)>1){fa=7;while(1){aa=ea(1<<fa+1|0);if(aa>ga)fa=fa+-1|0;else{ia=aa;ja=fa;break}}ka=ea(ea(ga-ia)/ea(ea(1<<ja+2|0)-ia));la=ja}else{ka=ea(0.0);la=7}aa=ea(ea(la|0)+ka);fa=0;_=Q;while(1){if(!(1<<fa&f))ma=_;else{c[z>>2]=c[140934];c[l+0>>2]=c[z+0>>2];nkd(D,l,aa);c[m>>2]=c[140928];c[l+0>>2]=c[m+0>>2];rkd(D,l,d);Z7b(E,D,b,da,fa,_);ma=ea(_+ea(-.0000152587891))}fa=fa+1|0;if((fa|0)>=6){na=ma;break}else _=ma}_=ea(ca+$);fa=j>>1;if((fa|0)>0){da=da+1|0;$=_;j=fa;Q=na}else break}}oa=f>>>5&1}else{pa=Z;qa=48}}else{pa=ea(.999984741);qa=48}if((qa|0)==48)if((d|0)!=(b|0)?(qa=c[p>>2]>>1,(qa|0)>0):0){p=0;j=1;da=qa;Z=pa;while(1){if(!(j>>>0<g>>>0|j>>>0>h>>>0)){pa=ea(j|0);if((da|0)==1){qa=p;z=0;na=Z;while(1){if(!(1<<z&f)){ra=qa;sa=na}else{c[A>>2]=c[140934];c[l+0>>2]=c[A+0>>2];nkd(D,l,pa);c[m>>2]=c[140928];c[l+0>>2]=c[m+0>>2];rkd(D,l,d);Z7b(E,D,b,j,z,na);ra=f>>>5&1;sa=ea(na+ea(-.0000152587891))}z=z+1|0;if((z|0)>=6){ta=ra;ua=sa;break}else{qa=ra;na=sa}}}else{qa=p;z=0;na=Z;while(1){if(!(1<<z&f)){va=qa;wa=na}else{c[A>>2]=c[140934];c[l+0>>2]=c[A+0>>2];nkd(D,l,pa);c[m>>2]=c[140928];c[l+0>>2]=c[m+0>>2];rkd(D,l,d);Z7b(E,D,b,j,z,na);va=0;wa=ea(na+ea(-.0000152587891))}z=z+1|0;if((z|0)>=6){ta=va;ua=wa;break}else{qa=va;na=wa}}}}else{ta=p;ua=Z}da=da>>2;if((da|0)<=0){oa=ta;break}else{p=ta;j=j+2|0;Z=ua}}}else oa=0;c[B>>2]=c[140928];c[l+0>>2]=c[B+0>>2];rkd(q,l,0);c[C>>2]=c[140928];c[l+0>>2]=c[C+0>>2];rkd(D,l,0);oBc(0,0,0,0);if(oa)LDc(b,2);ko[c[(c[E>>2]|0)+528>>2]&4095](E);kQb(D);kQb(q);if(G<<24>>24){G=ync()|0;ko[c[(c[G>>2]|0)+504>>2]&4095](G)}u1b(r);F=oa;i=k;return F|0}function Y7b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);c[140928]=c[b>>2];c[b>>2]=-1;itd(b,563728);c[140930]=c[b>>2];c[b>>2]=-1;itd(b,563744);c[140934]=c[b>>2];c[b>>2]=-1;itd(b,563760);c[140938]=c[b>>2];c[b>>2]=-1;itd(b,563776);c[140942]=c[b>>2];c[b>>2]=-1;itd(b,563792);c[140946]=c[b>>2];c[b>>2]=-1;itd(b,563808);c[140950]=c[b>>2];c[b>>2]=-1;itd(b,2974392);c[140954]=c[b>>2];i=a;return}function Z7b(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);var k=0,l=0,m=0,n=Im,o=Im,p=Im;k=i;i=i+16|0;l=k;m=(a[b+5984>>0]|0)!=0?563856:563856;oBc(e,f,h,0);if((a[621177]|a[621168])<<24>>24){f=c[(c[b>>2]|0)+24>>2]|0;g[l>>2]=ea(1.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+12>>2]=ea(0.0);Co[f&3](b,1,l,ea(1.0),0)}l1b(ea(-1.0),ea(100.0),0,ync()|0);l=dkd(d,0,c[158074]|0,0,1)|0;co[c[(c[b>>2]|0)+576>>2]&2047](b,2,l);n=ea(g[m+(h*60|0)>>2]);o=ea(g[m+(h*60|0)+4>>2]);p=ea(g[m+(h*60|0)+8>>2]);qn[c[(c[b>>2]|0)+568>>2]&7](b,n,o,p);qn[c[(c[b>>2]|0)+556>>2]&7](b,ea(0.0),ea(0.0),j);p=ea(g[m+(h*60|0)+36>>2]);o=ea(g[m+(h*60|0)+40>>2]);n=ea(g[m+(h*60|0)+44>>2]);qn[c[(c[b>>2]|0)+568>>2]&7](b,p,o,n);qn[c[(c[b>>2]|0)+556>>2]&7](b,ea(0.0),ea(1.0),j);n=ea(g[m+(h*60|0)+24>>2]);o=ea(g[m+(h*60|0)+28>>2]);p=ea(g[m+(h*60|0)+32>>2]);qn[c[(c[b>>2]|0)+568>>2]&7](b,n,o,p);qn[c[(c[b>>2]|0)+556>>2]&7](b,ea(1.0),ea(1.0),j);p=ea(g[m+(h*60|0)+12>>2]);o=ea(g[m+(h*60|0)+16>>2]);n=ea(g[m+(h*60|0)+20>>2]);qn[c[(c[b>>2]|0)+568>>2]&7](b,p,o,n);qn[c[(c[b>>2]|0)+556>>2]&7](b,ea(1.0),ea(0.0),j);ko[c[(c[b>>2]|0)+580>>2]&4095](b);i=k;return}function _7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+176>>2]|0;if((f|0)!=1|b^1?(f|0)!=2|d^1:0){g=0;i=e;return g|0}d=c[a+36>>2]|0;if((d&65534|0)!=254){g=0;i=e;return g|0}g=(d&-131072|0)==16646144;i=e;return g|0}function $7b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;j=c[a+176>>2]|0;if((j|0)==1){k=a+184|0;l=c[k>>2]|0;do if(!l)m=13;else{c[g>>2]=l;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(f,n,g);o=c[f>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[q+4>>2]|0,(n|0)!=0):0)r=n;else m=11}else m=11;if((m|0)==11){n=hQb(c[k>>2]|0)|0;if(!n){m=13;break}else r=n}rGc(h,r)}while(0);if((m|0)==13){c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2]}Iwc(Vwc()|0,h,a+180|0,d);s=1;i=e;return s|0}else if((j|0)==2){j=Vwc()|0;s=Jwc(j,c[a+180>>2]|0,d)|0;i=e;return s|0}else{s=0;i=e;return s|0}return 0}function a8b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;if(d?$7b(c[a+116>>2]|0,a+64|0,e)|0:0){i=f;return}a=e+0|0;e=b+0|0;b=a+108|0;do{c[a>>2]=c[e>>2];a=a+4|0;e=e+4|0}while((a|0)<(b|0));i=f;return}function b8b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+44|0;if((c[j>>2]|0)<=0){k=e+0|0;l=d+0|0;d=k+124|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(d|0));i=f;return}l=l7b()|0;k=a+184|0;a=c[k>>2]|0;if(!a)m=0;else{c[h>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(g,a,h);d=c[g>>2]|0;n=c[a+28>>2]|0;if((d|0)==-1){o=n+(c[a+32>>2]<<3)|0;break}else{o=n+(d<<3)|0;break}}else o=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((o|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[o+4>>2]|0,(a|0)!=0):0)p=a;else q=11}else q=11;if((q|0)==11)p=hQb(c[k>>2]|0)|0;m=p}D7b(l,b,m,c[j>>2]|0,e);i=f;return}function c8b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+100|0;e=a+104|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{f=g+4|0;h=g;g=c[f>>2]|0;c[h>>2]=0;c[f>>2]=0}while((g|0)!=(d|0))}c[e>>2]=0;c[d>>2]=0;r8b(a+88|0,c[a+92>>2]|0);d=a+40|0;e=a+48|0;if((c[e>>2]|0)!=0?(g=c[a+44>>2]|0,f=(c[d>>2]|0)+4|0,h=c[g>>2]|0,c[h+4>>2]=c[f>>2],c[c[f>>2]>>2]=h,c[e>>2]=0,(g|0)!=(d|0)):0){e=g;do{g=e;e=c[e+4>>2]|0;ACi(g)}while((e|0)!=(d|0))}d=a+28|0;e=a+36|0;if((c[e>>2]|0)!=0?(g=c[a+32>>2]|0,h=(c[d>>2]|0)+4|0,f=c[g>>2]|0,c[f+4>>2]=c[h>>2],c[c[h>>2]>>2]=f,c[e>>2]=0,(g|0)!=(d|0)):0){e=g;do{g=e;e=c[e+4>>2]|0;ACi(g)}while((e|0)!=(d|0))}d=a+16|0;e=a+24|0;if((c[e>>2]|0)!=0?(g=c[a+20>>2]|0,f=(c[d>>2]|0)+4|0,h=c[g>>2]|0,c[h+4>>2]=c[f>>2],c[c[f>>2]>>2]=h,c[e>>2]=0,(g|0)!=(d|0)):0){e=g;do{g=e;e=c[e+4>>2]|0;ACi(g)}while((e|0)!=(d|0))}d=a+4|0;e=a+12|0;if(!(c[e>>2]|0)){i=b;return}g=c[a+8>>2]|0;a=(c[d>>2]|0)+4|0;h=c[g>>2]|0;c[h+4>>2]=c[a>>2];c[c[a>>2]>>2]=h;c[e>>2]=0;if((g|0)==(d|0)){i=b;return}else j=g;do{g=j;j=c[j+4>>2]|0;ACi(g)}while((j|0)!=(d|0));i=b;return}function d8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+1104|0;e=d+24|0;f=d+16|0;g=d;h=b+52|0;a[h>>0]=1;j=b+72|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];k=b+16|0;l=c[b+20>>2]|0;if((l|0)==(k|0)){m=l7b()|0;B7b(m);c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];a[h>>0]=0;e8b(b);i=d;return}n=l;do{l=n+8|0;o=c[l>>2]|0;do if(!o){p=0;q=0}else{c[f>>2]=o;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(e,r,f);s=c[e>>2]|0;t=c[r+28>>2]|0;if((s|0)==-1){u=t+(c[r+32>>2]<<3)|0;break}else{u=t+(s<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[u+4>>2]|0,(r|0)!=0):0)v=r;else w=12}else w=12;if((w|0)==12){w=0;r=hQb(c[l>>2]|0)|0;if(!r){p=0;q=0;break}else v=r}p=v;q=c[v+4>>2]|0}while(0);c[b>>2]=q;C1b(e);if(((p|0)!=0?(l=p+28|0,(a[l>>0]|0)!=0):0)?(R$b(p,e),(a[l>>0]|0)!=0):0)b0b(p,e,c[158074]|0,2);E1b(e);n=c[n+4>>2]|0}while((n|0)!=(k|0));m=l7b()|0;B7b(m);c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];a[h>>0]=0;e8b(b);i=d;return}function e8b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+40|0;h=a+44|0;j=c[h>>2]|0;if((j|0)!=(g|0)){k=j;do{j=k+8|0;l=c[j>>2]|0;if(!l)m=0;else{c[e>>2]=l;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(d,l,e);n=c[d>>2]|0;o=c[l+28>>2]|0;if((n|0)==-1){p=o+(c[l+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((p|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[p+4>>2]|0,(l|0)!=0):0)q=l;else r=12}else r=12;if((r|0)==12){r=0;q=hQb(c[j>>2]|0)|0}m=q}k=c[k+4>>2]|0;k8b(a,m)}while((k|0)!=(g|0))}k=a+48|0;if((c[k>>2]|0)!=0?(m=c[h>>2]|0,h=(c[g>>2]|0)+4|0,q=c[m>>2]|0,c[q+4>>2]=c[h>>2],c[c[h>>2]>>2]=q,c[k>>2]=0,(m|0)!=(g|0)):0){k=m;do{m=k;k=c[k+4>>2]|0;ACi(m)}while((k|0)!=(g|0))}g=a+28|0;k=a+32|0;m=c[k>>2]|0;if((m|0)!=(g|0)){q=m;do{m=q+8|0;h=c[m>>2]|0;if(!h)s=0;else{c[f>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,f);p=c[d>>2]|0;e=c[h+28>>2]|0;if((p|0)==-1){t=e+(c[h+32>>2]<<3)|0;break}else{t=e+(p<<3)|0;break}}else t=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((t|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[t+4>>2]|0,(h|0)!=0):0)u=h;else r=29}else r=29;if((r|0)==29){r=0;u=hQb(c[m>>2]|0)|0}s=u}q=c[q+4>>2]|0;j8b(a,s)}while((q|0)!=(g|0))}q=a+36|0;if(!(c[q>>2]|0)){i=b;return}a=c[k>>2]|0;k=(c[g>>2]|0)+4|0;s=c[a>>2]|0;c[s+4>>2]=c[k>>2];c[c[k>>2]>>2]=s;c[q>>2]=0;if((a|0)==(g|0)){i=b;return}else v=a;do{a=v;v=c[v+4>>2]|0;ACi(a)}while((v|0)!=(g|0));i=b;return}function f8b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+1088|0;e=d+8|0;f=d;g=b+52|0;a[g>>0]=1;h=Lac()|0;j=b+4|0;k=c[b+8>>2]|0;if((k|0)==(j|0)){a[g>>0]=0;e8b(b);i=d;return}l=k;do{k=l+8|0;m=c[k>>2]|0;if(!m)n=0;else{c[f>>2]=m;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(e,m,f);o=c[e>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){q=p+(c[m+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0)r=m;else s=12}else s=12;if((s|0)==12){s=0;r=hQb(c[k>>2]|0)|0}n=r}if(!(c[n+352>>2]|0)){Nac(h);do if(n){c[b>>2]=c[n+4>>2];m=n+28|0;if((a[m>>0]|0)!=0?W$b(n)|0:0){k0b(n,2);break}C1b(e);if((a[m>>0]|0)!=0?(R$b(n,e),(a[m>>0]|0)!=0):0){b0b(n,e,c[158074]|0,2);s=23}else s=23}else{c[b>>2]=0;C1b(e);s=23}while(0);if((s|0)==23){s=0;E1b(e)}Oac(h)}l=c[l+4>>2]|0}while((l|0)!=(j|0));a[g>>0]=0;e8b(b);i=d;return}function g8b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=b;b=a+92|0;g=c[b>>2]|0;if(!g){h=a+92|0;j=h;k=h}else{h=g;while(1)if((c[h+16>>2]|0)>(d|0)){g=c[h>>2]|0;if(!g){j=h;k=h;break}else{h=g;continue}}else{g=h+4|0;l=c[g>>2]|0;if(!l){j=g;k=h;break}else{h=l;continue}}}h=xCi(24)|0;l=h+16|0;c[l>>2]=d;c[l+4>>2]=f;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=k;c[j>>2]=h;k=a+88|0;f=c[c[k>>2]>>2]|0;if(!f)m=h;else{c[k>>2]=f;m=c[j>>2]|0}GN(c[b>>2]|0,m);m=a+96|0;c[m>>2]=(c[m>>2]|0)+1;i=e;return}function h8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+88|0;f=c[e>>2]|0;g=a+92|0;if((f|0)==(g|0)){i=d;return}h=a+96|0;j=a+92|0;a=f;while(1){f=c[a+4>>2]|0;k=(f|0)==0;if(k){l=a;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=f;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}if((c[a+20>>2]|0)==(b|0)){if(k){l=a;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){o=m;break}else l=m}}else{l=f;while(1){k=c[l>>2]|0;if(!k){o=l;break}else l=k}}if((c[e>>2]|0)==(a|0))c[e>>2]=o;c[h>>2]=(c[h>>2]|0)+-1;tYb(c[j>>2]|0,a);ACi(a)}if((n|0)==(g|0))break;else a=n}i=d;return}function i8b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b;e=a+100|0;f=a+104|0;g=c[f>>2]|0;if((g|0)==(e|0)){i=b;return}h=d+4|0;j=d+8|0;c[j>>2]=e;k=d+12|0;c[k>>2]=0;l=c[e>>2]|0;c[d>>2]=l;c[f>>2]=d;c[h>>2]=g;c[e>>2]=e;if((l|0)==(e|0))c[d>>2]=d;c[a+104>>2]=e;c[e>>2]=e;c[(c[d>>2]|0)+4>>2]=d;e=c[h>>2]|0;c[e>>2]=d;a=e;while(1){if((a|0)==(d|0)){m=10;break}c[k>>2]=a;e=c[a>>2]|0;if(e){l=a+4|0;c[e+4>>2]=c[l>>2];c[c[l>>2]>>2]=e;c[a>>2]=0;c[l>>2]=0}l=c[j>>2]|0;if((a|0)!=(l|0)){e=a+4|0;g=c[l>>2]|0;c[a>>2]=g;c[e>>2]=l;c[g+4>>2]=a;c[c[e>>2]>>2]=a}if(!a)break;w9c(c[a+8>>2]|0);a=c[h>>2]|0}if((m|0)==10)c[k>>2]=0;c[h>>2]=0;c[d>>2]=0;i=b;return}function j8b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0;e=i;i=i+32|0;f=e+24|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;n=(d|0)==0;if(n)o=0;else o=c[d+4>>2]|0;c[k>>2]=o;if(a[b+52>>0]|0){s8b(b+40|0,k);p=b+28|0;q=xCi(12)|0;c[q+8>>2]=o;c[q+4>>2]=p;o=c[p>>2]|0;c[q>>2]=o;c[o+4>>2]=q;c[p>>2]=q;q=b+36|0;c[q>>2]=(c[q>>2]|0)+1;i=e;return}if(n)r=0;else r=c[d+4>>2]|0;c[l>>2]=r;s8b(b+28|0,l);if(n)s=0;else s=c[d+4>>2]|0;c[m>>2]=s;s8b(b+40|0,m);m=b+4|0;s8b(m,k);s=b+16|0;s8b(s,k);k=d+292|0;b=c[k>>2]|0;if(!b)t=m;else{c[h>>2]=b;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(f,b,h);l=c[f>>2]|0;r=c[b+28>>2]|0;if((l|0)==-1){u=r+(c[b+32>>2]<<3)|0;break}else{u=r+(l<<3)|0;break}}else u=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((u|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[u+4>>2]|0,(b|0)!=0):0)v=b;else w=18}else w=18;if((w|0)==18)v=hQb(c[k>>2]|0)|0;t=(v|0)==0?m:s}s=c[t+4>>2]|0;a:do if((s|0)!=(t|0)){m=d+420|0;v=s;b:while(1){k=v+8|0;b=c[k>>2]|0;do if(b){c[j>>2]=b;u=c[137784]|0;if(u){do if((c[u+36>>2]|0)!=(c[u+4>>2]|0)){fRb(f,u,j);h=c[f>>2]|0;l=c[u+28>>2]|0;if((h|0)==-1){x=l+(c[u+32>>2]<<3)|0;break}else{x=l+(h<<3)|0;break}}else x=(c[u+28>>2]|0)+(c[u+32>>2]<<3)|0;while(0);u=c[137784]|0;if((x|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[x+4>>2]|0,(u|0)!=0):0)y=u;else w=31}else w=31;if((w|0)==31){w=0;u=hQb(c[k>>2]|0)|0;if(!u)break;else y=u}z=ea(g[y+420>>2]);if(z>ea(g[m>>2])){A=v;break b}}while(0);v=c[v+4>>2]|0;if((v|0)==(t|0))break a}if(n)B=0;else B=c[d+4>>2]|0;v=xCi(12)|0;c[v>>2]=0;c[v+8>>2]=B;m=c[A>>2]|0;c[m+4>>2]=v;c[v>>2]=m;c[A>>2]=v;c[v+4>>2]=A;v=t+8|0;c[v>>2]=(c[v>>2]|0)+1;i=e;return}while(0);if(n)C=0;else C=c[d+4>>2]|0;d=xCi(12)|0;c[d+8>>2]=C;c[d+4>>2]=t;C=c[t>>2]|0;c[d>>2]=C;c[C+4>>2]=d;c[t>>2]=d;d=t+8|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function k8b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=(d|0)==0;if(l){c[h>>2]=0;m=0;n=h}else{o=c[d+4>>2]|0;c[h>>2]=o;m=o;n=h}c[j>>2]=m;s8b(b+28|0,j);j=b+40|0;if(l)p=0;else p=c[d+4>>2]|0;c[k>>2]=p;s8b(j,k);if(!(a[b+52>>0]|0)){s8b(b+4|0,h);s8b(b+16|0,h)}else{h=xCi(12)|0;c[h+8>>2]=c[n>>2];c[h+4>>2]=j;n=c[j>>2]|0;c[h>>2]=n;c[n+4>>2]=h;c[j>>2]=h;h=b+48|0;c[h>>2]=(c[h>>2]|0)+1}h=c[b>>2]|0;if(!h)q=0;else{c[g>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(f,h,g);j=c[f>>2]|0;n=c[h+28>>2]|0;if((j|0)==-1){r=n+(c[h+32>>2]<<3)|0;break}else{r=n+(j<<3)|0;break}}else r=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((r|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[r+4>>2]|0,(h|0)!=0):0)s=h;else t=18}else t=18;if((t|0)==18)s=hQb(c[b>>2]|0)|0;q=s}if((q|0)!=(d|0)){i=e;return}if(!(c[b+12>>2]|0)){c[b>>2]=0;i=e;return}else{c[b>>2]=c[(c[b+8>>2]|0)+8>>2];i=e;return}}function l8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+56|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];b=a+4|0;g=c[a+8>>2]|0;if((g|0)==(b|0)){i=d;return}a=g;do{g=a+8|0;c[f>>2]=c[g>>2];h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,f);j=c[e>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[l+4>>2]|0,(h|0)!=0):0)m=h;else n=11}else n=11;if((n|0)==11){n=0;m=hQb(c[g>>2]|0)|0}q$b(m);a=c[a+4>>2]|0}while((a|0)!=(b|0));i=d;return}function m8b(){var a=0,b=0;a=i;if(ILc()|0){b=ILc()|0;ko[c[c[b>>2]>>2]&4095](b)}mAc();i=a;return}function n8b(){return c[141054]|0}function o8b(){return c[141054]|0}function p8b(){var b=0,d=0,e=0,f=0;b=i;d=xCi(108)|0;e=d+4|0;c[e>>2]=e;c[d+8>>2]=e;c[d+12>>2]=0;e=d+16|0;c[e>>2]=e;c[d+20>>2]=e;c[d+24>>2]=0;e=d+28|0;c[e>>2]=e;c[d+32>>2]=e;c[d+36>>2]=0;e=d+40|0;c[e>>2]=e;c[d+44>>2]=e;c[d+48>>2]=0;a[d+52>>0]=0;e=d+56|0;f=d+92|0;c[f>>2]=0;c[d+96>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[d+88>>2]=f;f=d+100|0;c[f>>2]=f;c[d+104>>2]=f;g[e>>2]=ea(0.0);g[d+60>>2]=ea(0.0);g[d+64>>2]=ea(128.0);g[d+68>>2]=ea(128.0);c[d+72>>2]=0;c[d+76>>2]=0;c[d+80>>2]=128;c[d+84>>2]=128;c[d>>2]=0;c[141054]=d;i=b;return}function q8b(){var a=0,b=0;a=i;b=c[141054]|0;if(b){c8b(b);ACi(b)}c[141054]=0;i=a;return}function r8b(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{r8b(a,c[b>>2]|0);r8b(a,c[b+4>>2]|0);ACi(b);i=d;return}}function s8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;c[e>>2]=e;f=e+4|0;c[f>>2]=e;g=e+8|0;c[g>>2]=0;h=c[a+4>>2]|0;if((h|0)==(a|0)){i=d;return}j=a+8|0;if((e|0)==(a|0)){k=c[b>>2]|0;l=h;while(1){m=c[l+4>>2]|0;if((c[l+8>>2]|0)==(k|0)){a:do if((m|0)==(a|0)){n=a;o=0}else{p=m;while(1){if((c[p+8>>2]|0)!=(k|0)){n=p;o=1;break a}p=c[p+4>>2]|0;if((p|0)==(a|0)){n=a;o=0;break}}}while(0);if((l|0)!=(n|0)){p=c[n>>2]|0;q=p+4|0;r=c[l>>2]|0;c[r+4>>2]=c[q>>2];c[c[q>>2]>>2]=r;r=c[e>>2]|0;c[r+4>>2]=l;c[l>>2]=r;c[e>>2]=p;c[q>>2]=e}if(o)s=c[n+4>>2]|0;else s=n}else s=m;if((s|0)==(a|0))break;else l=s}i=d;return}else{t=h;u=0;v=e;w=0}while(1){h=c[t+8>>2]|0;s=c[t+4>>2]|0;if((h|0)==(c[b>>2]|0)){b:do if((s|0)==(a|0)){x=a;y=0}else{l=s;while(1){if((c[l+8>>2]|0)!=(h|0)){x=l;y=1;break b}l=c[l+4>>2]|0;if((l|0)==(a|0)){x=a;y=0;break}}}while(0);if((t|0)==(x|0)){z=u;A=v;B=w}else{h=s;m=1;while(1){if((h|0)==(x|0)){C=m;break}h=c[h+4>>2]|0;m=m+1|0}c[j>>2]=(c[j>>2]|0)-C;m=u+C|0;c[g>>2]=m;h=c[x>>2]|0;l=h+4|0;n=c[t>>2]|0;c[n+4>>2]=c[l>>2];c[c[l>>2]>>2]=n;n=c[e>>2]|0;c[n+4>>2]=t;c[t>>2]=n;c[e>>2]=h;c[l>>2]=e;z=m;A=h;B=m}if(y){D=c[x+4>>2]|0;E=z;F=A;G=B}else{D=x;E=z;F=A;G=B}}else{D=s;E=u;F=v;G=w}if((D|0)==(a|0)){H=F;I=G;break}else{t=D;u=E;v=F;w=G}}if(!I){i=d;return}I=c[f>>2]|0;f=H+4|0;H=c[I>>2]|0;c[H+4>>2]=c[f>>2];c[c[f>>2]>>2]=H;c[g>>2]=0;if((I|0)==(e|0)){i=d;return}else J=I;do{I=J;J=c[J+4>>2]|0;ACi(I)}while((J|0)!=(e|0));i=d;return}function t8b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ync()|0;co[c[(c[e>>2]|0)+96>>2]&2047](e,a,b);i=d;return}function u8b(){var a=0,b=0;a=i;b=pyc()|0;i=a;return d[(c[b+24>>2]|0)+((c[b+40>>2]|0)*96|0)+73>>0]|0|0}function v8b(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;f=pyc()|0;g=d[(c[f+24>>2]|0)+((c[f+40>>2]|0)*96|0)+73>>0]|0;f=c[(hkd(b)|0)+52>>2]|0;b=c[(c[(c[c[(c[f>>2]|0)+(c[f+32>>2]<<2)>>2]>>2]|0)+(a<<2)>>2]|0)+660>>2]|0;i=e;return (b&g|0)==(b|0)|0}function w8b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if(b)if((d|0)>-1){f=otd(c[a+52>>2]|0,d,1)|0;if((f|0)<0){g=-1;i=e;return g|0}h=Old(b,d,f)|0;if((h|0)==-1){g=-1;i=e;return g|0}else j=h}else j=0;else j=Hld(a)|0;g=j;i=e;return g|0}function x8b(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=(b[d>>1]|0)!=255;a:do if(!((b[d+2>>1]|0)==255&(k^1))){do if((c[a+84>>2]|0)==2)if((Hwc(a)|0)==2)l=5;else l=7;else{m=c[a+92>>2]|0;if((m|0)==1){l=5;break}else if((m|0)!=2){l=7;break}m=c[158074]|0;n=m+4|0;o=c[n>>2]&-229377|131072;c[n>>2]=o;p=m;q=o;break a}while(0);if((l|0)==5){o=c[158074]|0;m=o+4|0;n=c[m>>2]&-229377|65536;c[m>>2]=n;p=o;q=n;break}else if((l|0)==7){n=c[158074]|0;o=n+4|0;m=c[o>>2]&-229377|32768;c[o>>2]=m;p=n;q=m;break}}else{m=c[158074]|0;n=m+4|0;o=c[n>>2]&-229377|32768;c[n>>2]=o;p=m;q=o}while(0);if(!k){k=q&-24577|8192;c[p+4>>2]=k;r=p;s=k;t=r+4|0;u=s&-786433;v=u|262144;c[t>>2]=v;i=f;return}k=e[d>>1]|0;if((c[a+28>>2]|0)>(k|0))w=(c[a+24>>2]|0)+(k<<3)|0;else w=a+40|0;c[p+4>>2]=q&-24577|16384;q=ync()|0;c[h>>2]=c[w>>2];c[g+0>>2]=c[h+0>>2];kxd(q+4388|0,g,2,0,0);c[j>>2]=c[w+4>>2];c[g+0>>2]=c[j+0>>2];kxd(q+4452|0,g,2,0,0);g=c[158074]|0;r=g;s=c[g+4>>2]|0;t=r+4|0;u=s&-786433;v=u|262144;c[t>>2]=v;i=f;return}function y8b(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;Kwc(d,a);a=ync()|0;e=a+2164|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];e=a+2180|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];e=a+2196|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];e=a+2212|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];i=b;return}function z8b(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;g[b+24>>2]=ea(.211999997);g[b+28>>2]=ea(.226999998);g[b+32>>2]=ea(.259000003);g[b+36>>2]=ea(1.0);g[b+40>>2]=ea(.114);g[b+44>>2]=ea(.125);g[b+48>>2]=ea(.133000001);g[b+52>>2]=ea(1.0);g[b+56>>2]=ea(.0469999984);g[b+60>>2]=ea(.0430000015);g[b+64>>2]=ea(.0350000001);g[b+68>>2]=ea(1.0);MMc(b+72|0);MMc(b+180|0);g[b+288>>2]=ea(1.0);g[b+404>>2]=ea(.5);g[b+408>>2]=ea(1.0);g[b+412>>2]=ea(3.0);a[b+416>>0]=0;c[b+420>>2]=3;g[b+424>>2]=ea(.5);g[b+428>>2]=ea(.5);g[b+432>>2]=ea(.5);g[b+436>>2]=ea(1.0);g[b+440>>2]=ea(0.0);g[b+444>>2]=ea(300.0);g[b+448>>2]=ea(.00999999977);rri(e,609776,8);c[b+452>>2]=oUc(mUc()|0,28,e)|0;xri(e);c[b+456>>2]=0;A8b(b);g[b+468>>2]=ea(1.0);c[b+472>>2]=0;c[b+476>>2]=128;c[b+480>>2]=1;c[b+292>>2]=0;c[b+484>>2]=0;i=d;return}function A8b(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im;b=i;i=i+96|0;d=b+32|0;e=b+56|0;f=b+64|0;h=b+80|0;j=b+16|0;k=b;l=b+40|0;m=a+292|0;n=c[m>>2]|0;do if(!n){o=a+464|0;p=c[o>>2]|0;if(p){c[e>>2]=p;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(d,p,e);q=c[d>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(c[s+4>>2]|0)!=0:0){t=14;break}}if(!(hQb(c[o>>2]|0)|0)){u=c[m>>2]|0;t=13}else t=14}}else{u=n;t=13}while(0);if((t|0)==13?(u|0)==4:0)t=14;if((t|0)==14){t=a+296|0;MMc(t);u=(KLc()|0)==1;NMc(t,u?a+72|0:a+180|0,ea(g[a+288>>2]));i=b;return}u=(KLc()|0)==1;v=ea(g[a+24>>2]);do if(u){do if(!(v<=ea(.0404499993)))if(v<ea(1.0)){w=ea(+U(+ea(ea(v+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{w=ea(+U(+v,2.20000005));break}else w=ea(v/ea(12.9200001));while(0);x=ea(g[a+28>>2]);do if(!(x<=ea(.0404499993)))if(x<ea(1.0)){y=ea(+U(+ea(ea(x+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{y=ea(+U(+x,2.20000005));break}else y=ea(x/ea(12.9200001));while(0);x=ea(g[a+32>>2]);if(x<=ea(.0404499993)){z=w;A=y;B=ea(x/ea(12.9200001));break}if(x<ea(1.0)){z=w;A=y;B=ea(+U(+ea(ea(x+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{z=w;A=y;B=ea(+U(+x,2.20000005));break}}else{x=ea(g[a+28>>2]);z=v;A=x;B=ea(g[a+32>>2])}while(0);v=ea(g[a+36>>2]);u=a+288|0;y=ea(g[u>>2]);w=ea(z*y);z=ea(A*y);A=ea(B*y);B=ea(v*y);o=(KLc()|0)==1;y=ea(g[a+40>>2]);do if(o){do if(!(y<=ea(.0404499993)))if(y<ea(1.0)){C=ea(+U(+ea(ea(y+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{C=ea(+U(+y,2.20000005));break}else C=ea(y/ea(12.9200001));while(0);v=ea(g[a+44>>2]);do if(!(v<=ea(.0404499993)))if(v<ea(1.0)){D=ea(+U(+ea(ea(v+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{D=ea(+U(+v,2.20000005));break}else D=ea(v/ea(12.9200001));while(0);v=ea(g[a+48>>2]);if(v<=ea(.0404499993)){E=C;F=D;G=ea(v/ea(12.9200001));break}if(v<ea(1.0)){E=C;F=D;G=ea(+U(+ea(ea(v+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{E=C;F=D;G=ea(+U(+v,2.20000005));break}}else{v=ea(g[a+44>>2]);E=y;F=v;G=ea(g[a+48>>2])}while(0);y=ea(g[a+52>>2]);D=ea(g[u>>2]);C=ea(F*D);F=ea(G*D);G=ea(y*D);g[f>>2]=ea(E*D);o=f+4|0;g[o>>2]=C;t=f+8|0;g[t>>2]=F;n=f+12|0;g[n>>2]=G;s=(KLc()|0)==1;G=ea(g[a+56>>2]);do if(s){do if(!(G<=ea(.0404499993)))if(G<ea(1.0)){H=ea(+U(+ea(ea(G+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{H=ea(+U(+G,2.20000005));break}else H=ea(G/ea(12.9200001));while(0);F=ea(g[a+60>>2]);do if(!(F<=ea(.0404499993)))if(F<ea(1.0)){I=ea(+U(+ea(ea(F+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{I=ea(+U(+F,2.20000005));break}else I=ea(F/ea(12.9200001));while(0);F=ea(g[a+64>>2]);if(F<=ea(.0404499993)){J=H;K=I;L=ea(F/ea(12.9200001));break}if(F<ea(1.0)){J=H;K=I;L=ea(+U(+ea(ea(F+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{J=H;K=I;L=ea(+U(+F,2.20000005));break}}else{F=ea(g[a+60>>2]);J=G;K=F;L=ea(g[a+64>>2])}while(0);G=ea(g[a+68>>2]);I=ea(g[u>>2]);H=ea(J*I);J=ea(K*I);K=ea(L*I);L=ea(G*I);u=c[m>>2]|0;if((u|0)==0|(u|0)==3){g[f>>2]=w;g[o>>2]=z;g[t>>2]=A;g[n>>2]=B;M=w;N=z;O=A;P=B}else{M=H;N=J;O=K;P=L}u=a+296|0;MMc(u);QMc(u,f);g[h>>2]=ea(0.0);g[h+4>>2]=ea(1.0);g[h+8>>2]=ea(0.0);L=ea(w-ea(g[f>>2]));w=ea(z-ea(g[o>>2]));z=ea(A-ea(g[t>>2]));A=ea(B-ea(g[n>>2]));g[j>>2]=L;g[j+4>>2]=w;g[j+8>>2]=z;g[j+12>>2]=A;RMc(u,h,j);g[k>>2]=ea(0.0);g[k+4>>2]=ea(-1.0);g[k+8>>2]=ea(0.0);A=ea(M-ea(g[f>>2]));M=ea(N-ea(g[o>>2]));N=ea(O-ea(g[t>>2]));O=ea(P-ea(g[n>>2]));g[l>>2]=A;g[l+4>>2]=M;g[l+8>>2]=N;g[l+12>>2]=O;RMc(u,k,l);i=b;return}function B8b(b,c){b=b|0;c=ea(c);var d=0,e=Im,f=Im;d=i;if(!(a[b+416>>0]|0)){e=ea(0.0);i=d;return ea(e)}f=ea(g[b+448>>2]);e=ea(ea(1.0)-ea(+aa(+ea(-ea(ea(ea(f*f)*c)*c)))));i=d;return ea(e)}function C8b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+452|0;a=c[f>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0)l=a;else m=10}else m=10;if((m|0)==10)l=hQb(c[f>>2]|0)|0;g=l;i=b;return g|0}function D8b(a){a=a|0;var b=0,d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;b=i;i=i+16|0;d=b;e=(KLc()|0)==1;f=ea(g[a+40>>2]);do if(e){do if(!(f<=ea(.0404499993)))if(f<ea(1.0)){h=ea(+U(+ea(ea(f+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{h=ea(+U(+f,2.20000005));break}else h=ea(f/ea(12.9200001));while(0);j=ea(g[a+44>>2]);do if(!(j<=ea(.0404499993)))if(j<ea(1.0)){k=ea(+U(+ea(ea(j+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{k=ea(+U(+j,2.20000005));break}else k=ea(j/ea(12.9200001));while(0);j=ea(g[a+48>>2]);if(j<=ea(.0404499993)){l=h;m=k;n=ea(j/ea(12.9200001));break}if(j<ea(1.0)){l=h;m=k;n=ea(+U(+ea(ea(j+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{l=h;m=k;n=ea(+U(+j,2.20000005));break}}else{j=ea(g[a+44>>2]);l=f;m=j;n=ea(g[a+48>>2])}while(0);f=ea(m*ea(.5));m=ea(n*ea(.5));n=ea(ea(g[a+52>>2])*ea(.5));g[d>>2]=ea(l*ea(.5));g[d+4>>2]=f;g[d+8>>2]=m;g[d+12>>2]=n;e=(KLc()|0)==1;n=ea(g[a+24>>2]);do if(e){do if(!(n<=ea(.0404499993)))if(n<ea(1.0)){o=ea(+U(+ea(ea(n+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{o=ea(+U(+n,2.20000005));break}else o=ea(n/ea(12.9200001));while(0);m=ea(g[a+28>>2]);do if(!(m<=ea(.0404499993)))if(m<ea(1.0)){p=ea(+U(+ea(ea(m+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{p=ea(+U(+m,2.20000005));break}else p=ea(m/ea(12.9200001));while(0);m=ea(g[a+32>>2]);if(m<=ea(.0404499993)){q=o;r=p;s=ea(m/ea(12.9200001));break}if(m<ea(1.0)){q=o;r=p;s=ea(+U(+ea(ea(m+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{q=o;r=p;s=ea(+U(+m,2.20000005));break}}else{m=ea(g[a+28>>2]);q=n;r=m;s=ea(g[a+32>>2])}while(0);n=ea(q*ea(.5));q=ea(r*ea(.5));r=ea(s*ea(.5));s=ea(ea(g[a+36>>2])*ea(.5));e=(KLc()|0)==1;p=ea(g[a+56>>2]);do if(e){do if(!(p<=ea(.0404499993)))if(p<ea(1.0)){t=ea(+U(+ea(ea(p+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{t=ea(+U(+p,2.20000005));break}else t=ea(p/ea(12.9200001));while(0);o=ea(g[a+60>>2]);do if(!(o<=ea(.0404499993)))if(o<ea(1.0)){u=ea(+U(+ea(ea(o+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{u=ea(+U(+o,2.20000005));break}else u=ea(o/ea(12.9200001));while(0);o=ea(g[a+64>>2]);if(o<=ea(.0404499993)){v=t;w=u;x=ea(o/ea(12.9200001));break}if(o<ea(1.0)){v=t;w=u;x=ea(+U(+ea(ea(o+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{v=t;w=u;x=ea(+U(+o,2.20000005));break}}else{o=ea(g[a+60>>2]);v=p;w=o;x=ea(g[a+64>>2])}while(0);p=ea(v*ea(.5));v=ea(w*ea(.5));w=ea(x*ea(.5));x=ea(ea(g[a+68>>2])*ea(.5));a=ync()|0;In[c[(c[a>>2]|0)+256>>2]&4095](a,d);g[a+1476>>2]=n;g[a+1480>>2]=q;g[a+1484>>2]=r;g[a+1488>>2]=s;g[a+1492>>2]=p;g[a+1496>>2]=v;g[a+1500>>2]=w;g[a+1504>>2]=x;i=b;return}function E8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;h=(c[158074]|0)+20|0;qud(h,564224,rvc()|0)|0;h=a+452|0;j=c[h>>2]|0;do if(j){c[f>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,f);l=c[e>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(c[n+4>>2]|0)!=0:0)break}if(!(hQb(c[h>>2]|0)|0))o=11}else o=11;while(0);if((o|0)==11){rri(g,609776,8);o=nUc(mUc()|0,28,g)|0;if(!o)p=0;else p=c[o+4>>2]|0;c[h>>2]=p;xri(g)}A8b(a);F8b(a);G8b(a);g=ync()|0;In[c[(c[g>>2]|0)+248>>2]&4095](g,0);if(b&1){I8b(a);i=d;return}H8b(0,0);I8b(a);i=d;return}function F8b(b){b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;d=i;e=ync()|0;if(!(a[b+416>>0]|0))f=0;else f=c[b+420>>2]|0;c[164530]=f;h=ea(g[b+448>>2]);j=ea(g[b+440>>2]);k=ea(g[b+444>>2]);if((f|0)==1){l=ea(k-j);if(l<ea(0.0))m=ea(-l);else m=l;if(m>ea(.0000999999974))n=ea(ea(1.0)/l);else n=ea(0.0);o=ea(h*ea(1.2011224));p=ea(h*ea(1.44269502));q=ea(-n);r=ea(k*n);s=h;t=k;u=j}else if(!f){o=ea(0.0);p=ea(0.0);q=ea(0.0);r=ea(0.0);s=ea(0.0);t=ea(2.0e4);u=ea(1.0e4)}else{o=ea(h*ea(1.2011224));p=ea(h*ea(1.44269502));q=ea(0.0);r=ea(0.0);s=h;t=k;u=j}g[e+1236>>2]=u;g[e+1240>>2]=u;g[e+1244>>2]=u;g[e+1248>>2]=u;g[e+1252>>2]=t;g[e+1256>>2]=t;g[e+1260>>2]=t;g[e+1264>>2]=t;g[e+1268>>2]=s;g[e+1272>>2]=s;g[e+1276>>2]=s;g[e+1280>>2]=s;g[e+1300>>2]=o;g[e+1304>>2]=p;g[e+1308>>2]=q;g[e+1312>>2]=r;f=(KLc()|0)==1;r=ea(g[b+424>>2]);do if(f){do if(!(r<=ea(.0404499993)))if(r<ea(1.0)){v=ea(+U(+ea(ea(r+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{v=ea(+U(+r,2.20000005));break}else v=ea(r/ea(12.9200001));while(0);q=ea(g[b+428>>2]);do if(!(q<=ea(.0404499993)))if(q<ea(1.0)){w=ea(+U(+ea(ea(q+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{w=ea(+U(+q,2.20000005));break}else w=ea(q/ea(12.9200001));while(0);q=ea(g[b+432>>2]);if(q<=ea(.0404499993)){x=v;y=w;z=ea(q/ea(12.9200001));break}if(q<ea(1.0)){x=v;y=w;z=ea(+U(+ea(ea(q+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{x=v;y=w;z=ea(+U(+q,2.20000005));break}}else{q=ea(g[b+428>>2]);x=r;y=q;z=ea(g[b+432>>2])}while(0);r=ea(g[b+436>>2]);g[e+1284>>2]=x;g[e+1288>>2]=y;g[e+1292>>2]=z;g[e+1296>>2]=r;e=(c[158074]|0)+4|0;b=c[e>>2]&-7340033;c[e>>2]=b;f=c[164530]|0;if((f|0)==3){c[e>>2]=b|4194304;i=d;return}else if((f|0)==1){c[e>>2]=b|1048576;i=d;return}else if((f|0)==2){c[e>>2]=b|2097152;i=d;return}else{i=d;return}}function G8b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+456|0;a=c[f>>2]|0;do if(!a)g=(c[158074]|0)+20|0;else{c[e>>2]=a;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,e);j=c[d>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[l+4>>2]|0,(h|0)!=0):0){m=(c[158074]|0)+20|0;n=h}else o=12}else o=12;if((o|0)==12){h=hQb(c[f>>2]|0)|0;j=(c[158074]|0)+20|0;if(!h){g=j;break}else{m=j;n=h}}p=m;q=n;qud(p,564248,q)|0;i=b;return}while(0);p=g;q=svc()|0;qud(p,564248,q)|0;i=b;return}function H8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;a=i;i=i+32|0;d=a+16|0;e=a+12|0;f=a;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;BQb(108,f,0)|0;h=c[f>>2]|0;if((h|0)==(c[g>>2]|0)){j=h;k=h}else{if(!b){l=h;while(1){m=c[l>>2]|0;if(!m)n=0;else{c[e>>2]=m;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(d,o,e);p=c[d>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[r+4>>2]|0,(o|0)!=0):0)s=o;else t=12}else t=12;if((t|0)==12){t=0;s=hQb(m)|0}n=s}H4b(n);E4b(n);F4b(n);o=l+4|0;if((o|0)==(c[g>>2]|0)){u=o;break}else l=o}}else{l=h;while(1){h=c[l>>2]|0;if(!h)v=0;else{c[e>>2]=h;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,e);s=c[d>>2]|0;r=c[n+28>>2]|0;if((s|0)==-1){w=r+(c[n+32>>2]<<3)|0;break}else{w=r+(s<<3)|0;break}}else w=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((w|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[w+4>>2]|0,(n|0)!=0):0)x=n;else t=24}else t=24;if((t|0)==24){t=0;x=hQb(h)|0}v=x}if((b|0)==2)F4b(v);else if((b|0)==1)E4b(v);n=l+4|0;if((n|0)==(c[g>>2]|0)){u=n;break}else l=n}}j=c[f>>2]|0;k=u}if(!j){i=a;return}if((k|0)!=(j|0))c[g>>2]=k+(~((k+-4-j|0)>>>2)<<2);ACi(j);i=a;return}function I8b(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b+4|0;h=b;if(!(c[a+472>>2]|0)){j=a+488|0;k=c[j>>2]|0;if(k){c[f>>2]=k;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,f);l=c[d>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[n+4>>2]|0,(k|0)!=0):0)o=k;else p=23}else p=23;if((p|0)==23)o=hQb(c[j>>2]|0)|0;if(o)q=c[o+4>>2]|0;else q=0}else q=0}else{o=a+484|0;j=c[o>>2]|0;if(j){c[e>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;n=c[j+28>>2]|0;if((k|0)==-1){r=n+(c[j+32>>2]<<3)|0;break}else{r=n+(k<<3)|0;break}}else r=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((r|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[r+4>>2]|0,(j|0)!=0):0)s=j;else p=11}else p=11;if((p|0)==11)s=hQb(c[o>>2]|0)|0;if(s)q=c[s+4>>2]|0;else q=0}else q=0}s=l7b()|0;c[h>>2]=q;u7b(s,h,ea(g[a+468>>2]));i=b;return}function J8b(a){a=a|0;var b=0,d=0,e=Im,f=0,h=Im,j=0;b=i;d=a+448|0;e=ea(g[d>>2]);f=e<ea(0.0);h=f?ea(0.0):e;f=h>ea(1.0);g[d>>2]=f?ea(1.0):h;f=a+404|0;h=ea(g[f>>2]);d=h<ea(0.0);e=d?ea(0.0):h;d=e>ea(1.0);g[f>>2]=d?ea(1.0):e;d=a+476|0;f=c[d>>2]|0;c[d>>2]=(f|0)>2?f:2;f=a+444|0;e=ea(g[f>>2]);h=ea(ea(g[a+440>>2])+ea(.00999999977));if(e<h)g[f>>2]=h;f=a+480|0;a=c[f>>2]|0;if((a|0)<1){j=1;c[f>>2]=j;i=b;return}j=(a|0)>5?5:a;c[f>>2]=j;i=b;return}function K8b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+492|0;a=c[g>>2]|0;do if(a){c[f>>2]=a;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,f);j=c[d>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if(!((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0))m=10}else m=10;if((m|0)==10?(hQb(c[g>>2]|0)|0)==0:0)break;h=c[g>>2]|0;if(!h){n=0;i=b;return n|0}c[e>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,e);j=c[d>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){o=k+(c[h+32>>2]<<3)|0;break}else{o=k+(j<<3)|0;break}}else o=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((o|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[o+4>>2]|0,(h|0)!=0):0)p=h;else m=20}else m=20;if((m|0)==20)p=hQb(c[g>>2]|0)|0;n=p;i=b;return n|0}while(0);n=t5b(0)|0;i=b;return n|0}function L8b(){var a=0;a=i;Ydd(564464,564384,564400);Ydd(564464,564416,564440);A5b();E7b();i=a;return}function M8b(){var a=0;a=i;ovc();i=a;return}function N8b(){var a=0;a=i;B5b();F7b();i=a;return}function O8b(){var a=0;a=i;QQb(104,107,108,109,110);i=a;return}function P8b(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(3)|0))lSb();rri(b,564464,14);wQb(104,3,b,496,2610,0,0);xri(b);i=a;return}function Q8b(a){a=a|0;return 104}function R8b(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,564464,a,0);_8b(a,b);bdd(b);i=c;return}function S8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,564464,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else $8b(a,b);sdd(b);i=d;return}function T8b(a,b){a=a|0;b=b|0;var c=0;c=i;a9b(a,b);i=c;return}function U8b(a,b){a=a|0;b=b|0;var c=0;c=i;b9b(a,b);i=c;return}function V8b(a,b){a=a|0;b=b|0;var c=0;c=i;c9b(a,b);i=c;return}function W8b(a,b){a=a|0;b=b|0;var c=0;c=i;d9b(a,b);i=c;return}function X8b(){var a=0,b=0;a=i;b=rVb(17)|0;i=a;return b|0}function Y8b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,564232);c[141056]=c[b>>2];c[b>>2]=-1;itd(b,564256);c[141062]=c[b>>2];i=a;return}function Z8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(496,e,1,16,3653512,36)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];iSb(g,e,b);c[g>>2]=564280;b=g+452|0;c[g+484>>2]=0;c[g+488>>2]=0;c[g+492>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return g|0}function _8b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;ESb(a,b);ddd(b,5);add(b,564480,c[142258]|0,a+416|0,2048);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);h=a+424|0;j=c[142262]|0;add(b,564488,j,h,2048);EYb(h,b);bdd(b);h=c[142270]|0;add(b,564504,h,a+420|0,2048);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142268]|0;add(b,564520,k,a+448|0,2048);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564536,k,a+440|0,2048);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564560,k,a+444|0,2048);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);l=a+24|0;add(b,564576,j,l,0);EYb(l,b);bdd(b);l=a+40|0;add(b,564600,j,l,0);EYb(l,b);bdd(b);l=a+56|0;add(b,564624,j,l,0);EYb(l,b);bdd(b);add(b,564440,k,a+288|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);k=a+72|0;add(b,564648,2441672,k,0);c6b(k,b);bdd(b);k=a+180|0;add(b,564664,2441672,k,0);c6b(k,b);bdd(b);add(b,564688,h,a+292|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);k=a+464|0;add(b,564704,723624,k,2048);l=e+8|0;j=l;c[j>>2]=0;c[j+4>>2]=0;c[e>>2]=0;add(b,792256,h,k,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142290]|0;add(b,792272,k,l,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);l=c[142268]|0;add(b,564728,l,a+404|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564744,l,a+408|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564760,l,a+412|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);l=a+456|0;add(b,564784,614680,l,0);h=e+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[e>>2]=0;j=c[142270]|0;add(b,792256,j,l,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,k,h,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);h=a+452|0;add(b,564800,614680,h,0);l=e+8|0;m=l;c[m>>2]=0;c[m+4>>2]=0;c[e>>2]=0;add(b,792256,j,h,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,k,l,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,564816,j,a+472|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564840,j,a+476|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564872,j,a+480|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,564896,c[142268]|0,a+468|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);l=a+484|0;add(b,564920,565e3,l,2048);k=e+8|0;h=k;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;add(b,792256,j,l,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);l=c[142290]|0;add(b,792272,l,k,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);k=a+488|0;add(b,564944,565e3,k,2048);j=e+8|0;h=j;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[142270]|0;add(b,792256,h,k,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,l,j,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);j=a+492|0;add(b,564976,564984,j,0);a=e+8|0;k=a;c[k>>2]=0;c[k+4>>2]=0;c[e>>2]=0;add(b,792256,h,j,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,l,a,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);i=d;return}function $8b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;FSb(b,d);rdd(d,5);h=b+416|0;j=qdd(d,564480,c[142258]|0,f,0)|0;if(j){do if((j|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else{k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(l+(m+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[k>>2]=(c[k>>2]|0)+1;break}Bid(k,h,1)}while(0);sdd(d)}h=b+424|0;j=c[142262]|0;k=qdd(d,564488,j,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else HYb(h,d);sdd(d)}h=b+420|0;k=c[142270]|0;n=qdd(d,564504,k,f,0)|0;if(n){if((n|0)>0){n=d+12|0;m=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+l|0;c[n>>2]=o;if((l|0)>=0?(p=m+(l+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[o>>2];c[n>>2]=p}else Bid(n,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}sdd(d)}h=b+448|0;n=c[142268]|0;p=qdd(d,564520,n,f,0)|0;if(p){if((p|0)>0){p=d+12|0;o=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+l|0;c[p>>2]=m;if((l|0)>=0?(q=o+(l+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[m>>2]);c[p>>2]=q}else Bid(p,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}sdd(d)}h=b+440|0;p=qdd(d,564536,n,f,0)|0;if(p){if((p|0)>0){p=d+12|0;q=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=q+m|0;c[p>>2]=l;if((m|0)>=0?(o=q+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[p>>2]=o}else Bid(p,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}sdd(d)}h=b+444|0;p=qdd(d,564560,n,f,0)|0;if(p){if((p|0)>0){p=d+12|0;o=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+l|0;c[p>>2]=m;if((l|0)>=0?(q=o+(l+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[m>>2]);c[p>>2]=q}else Bid(p,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}sdd(d)}h=b+24|0;p=qdd(d,564576,j,f,1)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}else HYb(h,d);sdd(d)}h=b+40|0;p=qdd(d,564600,j,f,1)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}else HYb(h,d);sdd(d)}h=b+56|0;p=qdd(d,564624,j,f,1)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}else HYb(h,d);sdd(d)}h=b+288|0;p=qdd(d,564440,n,f,0)|0;if(p){if((p|0)>0){p=d+12|0;j=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=j+q|0;c[p>>2]=m;if((q|0)>=0?(l=j+(q+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[m>>2]);c[p>>2]=l}else Bid(p,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}sdd(d)}h=b+72|0;p=qdd(d,564648,2441672,f,1)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}else T6b(h,d);sdd(d)}h=b+180|0;p=qdd(d,564664,2441672,f,1)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}else T6b(h,d);sdd(d)}h=b+292|0;p=qdd(d,564688,k,f,0)|0;if(p){if((p|0)>0){p=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=l+m|0;c[p>>2]=q;if((m|0)>=0?(j=l+(m+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[q>>2];c[p>>2]=j}else Bid(p,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}sdd(d)}h=b+464|0;p=qdd(d,564704,723624,f,1)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}else g7b(h,d);sdd(d)}h=b+404|0;p=qdd(d,564728,n,f,0)|0;if(p){if((p|0)>0){p=d+12|0;j=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=j+q|0;c[p>>2]=m;do if((q|0)<0)r=123;else{l=j+(q+4)|0;if(l>>>0>(c[d+20>>2]|0)>>>0){r=123;break}g[h>>2]=ea(g[m>>2]);c[p>>2]=l}while(0);if((r|0)==123)Bid(p,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](h,d)|0}sdd(d)}h=b+408|0;p=qdd(d,564744,n,f,0)|0;if(p){do if((p|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;q=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=q+j|0;c[m>>2]=l;do if((j|0)<0)r=134;else{o=q+(j+4)|0;if(o>>>0>(c[d+20>>2]|0)>>>0){r=134;break}g[h>>2]=ea(g[l>>2]);c[m>>2]=o}while(0);if((r|0)==134)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}while(0);sdd(d)}h=b+412|0;p=qdd(d,564760,n,f,0)|0;if(p){do if((p|0)>0){l=d+12|0;j=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=j+q|0;c[l>>2]=o;do if((q|0)<0)r=145;else{s=j+(q+4)|0;if(s>>>0>(c[d+20>>2]|0)>>>0){r=145;break}g[h>>2]=ea(g[o>>2]);c[l>>2]=s}while(0);if((r|0)==145)Bid(l,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{o=c[f>>2]|0;if(!o)break;_n[o&4095](h,d)|0}while(0);sdd(d)}h=b+456|0;p=qdd(d,564784,614680,f,1)|0;if(p){do if((p|0)>0)g9b(h,d);else{o=c[f>>2]|0;if(!o)break;_n[o&4095](h,d)|0}while(0);sdd(d)}h=b+452|0;p=qdd(d,564800,614680,f,1)|0;if(p){do if((p|0)>0)g9b(h,d);else{o=c[f>>2]|0;if(!o)break;_n[o&4095](h,d)|0}while(0);sdd(d)}h=b+472|0;p=qdd(d,564816,k,f,0)|0;if(p){do if((p|0)>0){o=d+12|0;q=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+j|0;c[o>>2]=m;do if((j|0)<0)r=168;else{s=q+(j+4)|0;if(s>>>0>(c[d+20>>2]|0)>>>0){r=168;break}c[h>>2]=c[m>>2];c[o>>2]=s}while(0);if((r|0)==168)Bid(o,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+476|0;p=qdd(d,564840,k,f,0)|0;if(p){do if((p|0)>0){m=d+12|0;j=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+q|0;c[m>>2]=l;do if((q|0)<0)r=179;else{s=j+(q+4)|0;if(s>>>0>(c[d+20>>2]|0)>>>0){r=179;break}c[h>>2]=c[l>>2];c[m>>2]=s}while(0);if((r|0)==179)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(!l)break;_n[l&4095](h,d)|0}while(0);sdd(d)}h=b+480|0;p=qdd(d,564872,k,f,0)|0;if(p){do if((p|0)>0){k=d+12|0;l=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=l+q|0;c[k>>2]=j;do if((q|0)<0)r=190;else{o=l+(q+4)|0;if(o>>>0>(c[d+20>>2]|0)>>>0){r=190;break}c[h>>2]=c[j>>2];c[k>>2]=o}while(0);if((r|0)==190)Bid(k,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[f>>2]|0;if(!j)break;_n[j&4095](h,d)|0}while(0);sdd(d)}h=b+468|0;p=qdd(d,564896,n,f,0)|0;if(p){do if((p|0)>0){n=d+12|0;j=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+q|0;c[n>>2]=l;do if((q|0)<0)r=201;else{m=j+(q+4)|0;if(m>>>0>(c[d+20>>2]|0)>>>0){r=201;break}g[h>>2]=ea(g[l>>2]);c[n>>2]=m}while(0);if((r|0)==201)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(!l)break;_n[l&4095](h,d)|0}while(0);sdd(d)}h=b+484|0;r=qdd(d,564920,565e3,f,1)|0;if(r){do if((r|0)>0)h9b(h,d);else{p=c[f>>2]|0;if(!p)break;_n[p&4095](h,d)|0}while(0);sdd(d)}h=b+488|0;r=qdd(d,564944,565e3,f,1)|0;if(r){do if((r|0)>0)h9b(h,d);else{p=c[f>>2]|0;if(!p)break;_n[p&4095](h,d)|0}while(0);sdd(d)}h=b+492|0;r=qdd(d,564976,564984,f,1)|0;if(!r){j9b(b,d);i=e;return}do if((r|0)>0)i9b(h,d);else{p=c[f>>2]|0;if(!p)break;_n[p&4095](h,d)|0}while(0);sdd(d);j9b(b,d);i=e;return}function a9b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;GSb(b,d);f=b+416|0;h=d+12|0;j=c[h>>2]|0;k=d+20|0;if((j+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,f,1);else{a[f>>0]=a[j>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);JYb(b+424|0,d);j=b+420|0;f=c[h>>2]|0;l=f+4|0;m=c[k>>2]|0;if(l>>>0>m>>>0){Bid(h,j,4);n=c[h>>2]|0;o=c[k>>2]|0}else{c[j>>2]=c[f>>2];c[h>>2]=l;n=l;o=m}m=b+448|0;l=n+4|0;if(l>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[k>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[h>>2]=l;p=l;q=o}o=b+440|0;l=p+4|0;if(l>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[k>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[h>>2]=l;r=l;s=q}q=b+444|0;l=r+4|0;if(l>>>0>s>>>0)Bid(h,q,4);else{g[q>>2]=ea(g[r>>2]);c[h>>2]=l}JYb(b+24|0,d);JYb(b+40|0,d);JYb(b+56|0,d);l=b+288|0;r=c[h>>2]|0;q=r+4|0;if(q>>>0>(c[k>>2]|0)>>>0)Bid(h,l,4);else{g[l>>2]=ea(g[r>>2]);c[h>>2]=q}F6b(b+72|0,d);F6b(b+180|0,d);q=b+292|0;r=c[h>>2]|0;l=r+4|0;if(l>>>0>(c[k>>2]|0)>>>0)Bid(h,q,4);else{c[q>>2]=c[r>>2];c[h>>2]=l}Ndd(d);h7b(b+464|0,d);l=b+404|0;r=c[h>>2]|0;q=r+4|0;s=c[k>>2]|0;if(q>>>0>s>>>0){Bid(h,l,4);t=c[h>>2]|0;u=c[k>>2]|0}else{g[l>>2]=ea(g[r>>2]);c[h>>2]=q;t=q;u=s}s=b+408|0;q=t+4|0;if(q>>>0>u>>>0){Bid(h,s,4);v=c[h>>2]|0;w=c[k>>2]|0}else{g[s>>2]=ea(g[t>>2]);c[h>>2]=q;v=q;w=u}u=b+412|0;q=v+4|0;if(q>>>0>w>>>0)Bid(h,u,4);else{g[u>>2]=ea(g[v>>2]);c[h>>2]=q}k9b(b+456|0,d);k9b(b+452|0,d);q=b+472|0;v=c[h>>2]|0;u=v+4|0;w=c[k>>2]|0;if(u>>>0>w>>>0){Bid(h,q,4);x=c[h>>2]|0;y=c[k>>2]|0}else{c[q>>2]=c[v>>2];c[h>>2]=u;x=u;y=w}w=b+476|0;u=x+4|0;if(u>>>0>y>>>0){Bid(h,w,4);z=c[h>>2]|0;A=c[k>>2]|0}else{c[w>>2]=c[x>>2];c[h>>2]=u;z=u;A=y}y=b+480|0;u=z+4|0;if(u>>>0>A>>>0){Bid(h,y,4);B=c[h>>2]|0;C=c[k>>2]|0}else{c[y>>2]=c[z>>2];c[h>>2]=u;B=u;C=A}A=b+468|0;u=B+4|0;if(u>>>0>C>>>0){Bid(h,A,4);D=b+484|0;l9b(D,d);E=b+488|0;l9b(E,d);F=b+492|0;m9b(F,d);i=e;return}else{g[A>>2]=ea(g[B>>2]);c[h>>2]=u;D=b+484|0;l9b(D,d);E=b+488|0;l9b(E,d);F=b+492|0;m9b(F,d);i=e;return}}function b9b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=i;HSb(b,d);f=b+416|0;h=d+12|0;j=c[h>>2]|0;l=d+20|0;if((j+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,f,1);else{a[f>>0]=a[j>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);MYb(b+424|0,d);j=b+420|0;f=c[h>>2]|0;m=f+4|0;n=c[l>>2]|0;if(m>>>0>n>>>0){Bid(h,j,4);o=c[j>>2]|0;p=c[h>>2]|0;q=c[l>>2]|0}else{r=c[f>>2]|0;c[j>>2]=r;c[h>>2]=m;o=r;p=m;q=n}c[j>>2]=XEi(o|0)|0;o=b+448|0;j=p+4|0;if(j>>>0>q>>>0){Bid(h,o,4);s=o;t=c[o>>2]|0;u=c[h>>2]|0;v=c[l>>2]|0}else{w=ea(g[p>>2]);g[o>>2]=w;c[h>>2]=j;s=o;t=(g[k>>2]=w,c[k>>2]|0);u=j;v=q}c[s>>2]=XEi(t|0)|0;t=b+440|0;s=u+4|0;if(s>>>0>v>>>0){Bid(h,t,4);x=t;y=c[t>>2]|0;z=c[h>>2]|0;A=c[l>>2]|0}else{w=ea(g[u>>2]);g[t>>2]=w;c[h>>2]=s;x=t;y=(g[k>>2]=w,c[k>>2]|0);z=s;A=v}c[x>>2]=XEi(y|0)|0;y=b+444|0;x=z+4|0;if(x>>>0>A>>>0){Bid(h,y,4);B=y;C=c[y>>2]|0}else{w=ea(g[z>>2]);g[y>>2]=w;c[h>>2]=x;B=y;C=(g[k>>2]=w,c[k>>2]|0)}c[B>>2]=XEi(C|0)|0;MYb(b+24|0,d);MYb(b+40|0,d);MYb(b+56|0,d);C=b+288|0;B=c[h>>2]|0;y=B+4|0;if(y>>>0>(c[l>>2]|0)>>>0){Bid(h,C,4);D=C;E=c[C>>2]|0}else{w=ea(g[B>>2]);g[C>>2]=w;c[h>>2]=y;D=C;E=(g[k>>2]=w,c[k>>2]|0)}c[D>>2]=XEi(E|0)|0;I6b(b+72|0,d);I6b(b+180|0,d);E=b+292|0;D=c[h>>2]|0;C=D+4|0;if(C>>>0>(c[l>>2]|0)>>>0){Bid(h,E,4);F=c[E>>2]|0}else{y=c[D>>2]|0;c[E>>2]=y;c[h>>2]=C;F=y}c[E>>2]=XEi(F|0)|0;Mdd(d);i7b(b+464|0,d);F=b+404|0;E=c[h>>2]|0;y=E+4|0;C=c[l>>2]|0;if(y>>>0>C>>>0){Bid(h,F,4);G=F;H=c[F>>2]|0;I=c[h>>2]|0;J=c[l>>2]|0}else{w=ea(g[E>>2]);g[F>>2]=w;c[h>>2]=y;G=F;H=(g[k>>2]=w,c[k>>2]|0);I=y;J=C}c[G>>2]=XEi(H|0)|0;H=b+408|0;G=I+4|0;if(G>>>0>J>>>0){Bid(h,H,4);K=H;L=c[H>>2]|0;M=c[h>>2]|0;N=c[l>>2]|0}else{w=ea(g[I>>2]);g[H>>2]=w;c[h>>2]=G;K=H;L=(g[k>>2]=w,c[k>>2]|0);M=G;N=J}c[K>>2]=XEi(L|0)|0;L=b+412|0;K=M+4|0;if(K>>>0>N>>>0){Bid(h,L,4);O=L;P=c[L>>2]|0}else{w=ea(g[M>>2]);g[L>>2]=w;c[h>>2]=K;O=L;P=(g[k>>2]=w,c[k>>2]|0)}c[O>>2]=XEi(P|0)|0;n9b(b+456|0,d);n9b(b+452|0,d);P=b+472|0;O=c[h>>2]|0;L=O+4|0;K=c[l>>2]|0;if(L>>>0>K>>>0){Bid(h,P,4);Q=c[P>>2]|0;R=c[h>>2]|0;S=c[l>>2]|0}else{M=c[O>>2]|0;c[P>>2]=M;c[h>>2]=L;Q=M;R=L;S=K}c[P>>2]=XEi(Q|0)|0;Q=b+476|0;P=R+4|0;if(P>>>0>S>>>0){Bid(h,Q,4);T=c[Q>>2]|0;U=c[h>>2]|0;V=c[l>>2]|0}else{K=c[R>>2]|0;c[Q>>2]=K;c[h>>2]=P;T=K;U=P;V=S}c[Q>>2]=XEi(T|0)|0;T=b+480|0;Q=U+4|0;if(Q>>>0>V>>>0){Bid(h,T,4);W=c[T>>2]|0;X=c[h>>2]|0;Y=c[l>>2]|0}else{l=c[U>>2]|0;c[T>>2]=l;c[h>>2]=Q;W=l;X=Q;Y=V}c[T>>2]=XEi(W|0)|0;W=b+468|0;T=X+4|0;if(T>>>0>Y>>>0){Bid(h,W,4);Z=W;_=c[W>>2]|0;$=XEi(_|0)|0;c[Z>>2]=$;aa=b+484|0;o9b(aa,d);ba=b+488|0;o9b(ba,d);ca=b+492|0;p9b(ca,d);i=e;return}else{w=ea(g[X>>2]);g[W>>2]=w;c[h>>2]=T;Z=W;_=(g[k>>2]=w,c[k>>2]|0);$=XEi(_|0)|0;c[Z>>2]=$;aa=b+484|0;o9b(aa,d);ba=b+488|0;o9b(ba,d);ca=b+492|0;p9b(ca,d);i=e;return}}function c9b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;ISb(b,d);f=b+416|0;h=d+12|0;j=c[h>>2]|0;k=d+20|0;if((j+1|0)>>>0<(c[k>>2]|0)>>>0){a[j>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);PYb(b+424|0,d);f=b+420|0;j=c[h>>2]|0;l=j+4|0;m=c[k>>2]|0;if(l>>>0<m>>>0){c[j>>2]=c[f>>2];c[h>>2]=l;n=l;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[k>>2]|0}f=b+448|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[f>>2]);c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[k>>2]|0}f=b+440|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[f>>2]);c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[k>>2]|0}f=b+444|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[f>>2]);c[h>>2]=q}else Gid(h,f,4);PYb(b+24|0,d);PYb(b+40|0,d);PYb(b+56|0,d);f=b+288|0;q=c[h>>2]|0;r=q+4|0;if(r>>>0<(c[k>>2]|0)>>>0){g[q>>2]=ea(g[f>>2]);c[h>>2]=r}else Gid(h,f,4);p6b(b+72|0,d);p6b(b+180|0,d);f=b+292|0;r=c[h>>2]|0;q=r+4|0;if(q>>>0<(c[k>>2]|0)>>>0){c[r>>2]=c[f>>2];c[h>>2]=q}else Gid(h,f,4);Tdd(d);j7b(b+464|0,d);f=b+404|0;q=c[h>>2]|0;r=q+4|0;s=c[k>>2]|0;if(r>>>0<s>>>0){g[q>>2]=ea(g[f>>2]);c[h>>2]=r;t=r;u=s}else{Gid(h,f,4);t=c[h>>2]|0;u=c[k>>2]|0}f=b+408|0;s=t+4|0;if(s>>>0<u>>>0){g[t>>2]=ea(g[f>>2]);c[h>>2]=s;v=s;w=u}else{Gid(h,f,4);v=c[h>>2]|0;w=c[k>>2]|0}f=b+412|0;u=v+4|0;if(u>>>0<w>>>0){g[v>>2]=ea(g[f>>2]);c[h>>2]=u}else Gid(h,f,4);q9b(b+456|0,d);q9b(b+452|0,d);f=b+472|0;u=c[h>>2]|0;v=u+4|0;w=c[k>>2]|0;if(v>>>0<w>>>0){c[u>>2]=c[f>>2];c[h>>2]=v;x=v;y=w}else{Gid(h,f,4);x=c[h>>2]|0;y=c[k>>2]|0}f=b+476|0;w=x+4|0;if(w>>>0<y>>>0){c[x>>2]=c[f>>2];c[h>>2]=w;z=w;A=y}else{Gid(h,f,4);z=c[h>>2]|0;A=c[k>>2]|0}f=b+480|0;y=z+4|0;if(y>>>0<A>>>0){c[z>>2]=c[f>>2];c[h>>2]=y;B=y;C=A}else{Gid(h,f,4);B=c[h>>2]|0;C=c[k>>2]|0}k=b+468|0;f=B+4|0;if(f>>>0<C>>>0){g[B>>2]=ea(g[k>>2]);c[h>>2]=f;D=b+484|0;r9b(D,d);E=b+488|0;r9b(E,d);F=b+492|0;s9b(F,d);i=e;return}else{Gid(h,k,4);D=b+484|0;r9b(D,d);E=b+488|0;r9b(E,d);F=b+492|0;s9b(F,d);i=e;return}}function d9b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;JSb(b,d);idd(d,2048);f=b+464|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;jdd(d);k=b+456|0;f=c[g>>2]|0;l=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=l;l=b+452|0;k=c[g>>2]|0;f=xo[c[c[k>>2]>>2]&2047](k,c[l>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[l>>2]=f;idd(d,2048);f=b+484|0;l=c[g>>2]|0;k=xo[c[c[l>>2]>>2]&2047](l,c[f>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[f>>2]=k;jdd(d);idd(d,2048);k=b+488|0;f=c[g>>2]|0;l=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=l;jdd(d);d=b+492|0;b=c[g>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[d>>2]|0,c[j>>2]|0)|0;if(!(a[h>>0]|0)){i=e;return}c[d>>2]=g;i=e;return}function e9b(a){a=a|0;var b=0;b=i;c[a>>2]=564280;TSb(a);i=b;return}function f9b(a){a=a|0;var b=0;b=i;c[a>>2]=564280;TSb(a);ACi(a);i=b;return}function g9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function h9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function i9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function j9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im;d=i;i=i+16|0;e=d;if(xdd(b,1)|0){f=a+24|0;h=qdd(b,564400,c[142262]|0,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else HYb(f,b);sdd(b)}j=ea(g[f>>2]);k=ea(g[a+28>>2]);l=ea(g[a+32>>2]);m=ea(g[a+36>>2]);g[a+40>>2]=j;g[a+44>>2]=k;g[a+48>>2]=l;g[a+52>>2]=m;g[a+56>>2]=j;g[a+60>>2]=k;g[a+64>>2]=l;g[a+68>>2]=m;c[a+292>>2]=3}if(xdd(b,2)|0){f=a+180|0;h=a+72|0;e=f+108|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(e|0))}if(!(xdd(b,4)|0)){i=d;return}if((c[a+292>>2]|0)!=3){i=d;return}m=ea(g[a+40>>2]);l=ea(g[a+44>>2]);k=ea(g[a+48>>2]);j=ea(g[a+52>>2]);g[a+24>>2]=m;g[a+28>>2]=l;g[a+32>>2]=k;g[a+36>>2]=j;i=d;return}function k9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function l9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function m9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function n9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function o9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function p9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function q9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function r9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function s9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function t9b(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0;o=i;i=i+16|0;p=o+6|0;q=o;r=m+160|0;c[r>>2]=0;s=l+4|0;t=l+8|0;a:do if((k|0)==1){u=0;v=0;while(1){w=ea(g[d+(v<<4)>>2]);x=ea(g[d+(v<<4)+4>>2]);y=ea(g[d+(v<<4)+8>>2]);z=ea(g[d+(v<<4)+12>>2]);A=ea(w*ea(g[l>>2]));B=ea(A+ea(x*ea(g[s>>2])));a[p+v>>0]=ea(B+ea(y*ea(g[t>>2])))<ea(0.0)&1;a[q+v>>0]=1;if((a[p+v>>0]|0)!=0?(a[n+v>>0]|0)==0:0){c[r>>2]=u+1;g[m+(u<<4)>>2]=w;g[m+(u<<4)+4>>2]=x;g[m+(u<<4)+8>>2]=y;g[m+(u<<4)+12>>2]=z;C=c[r>>2]|0;if((C|0)==10)break;else D=C}else D=u;v=v+1|0;if((v|0)>=6){E=0;break a}else u=D}i=o;return}else{u=0;v=0;while(1){z=ea(g[d+(v<<4)>>2]);y=ea(g[d+(v<<4)+4>>2]);x=ea(g[d+(v<<4)+8>>2]);w=ea(g[d+(v<<4)+12>>2]);B=ea(z*ea(g[l>>2]));A=ea(B+ea(y*ea(g[s>>2])));B=ea(w+ea(A+ea(x*ea(g[t>>2]))));C=p+v|0;a[C>>0]=0;F=q+v|0;a[F>>0]=1;if(B>ea(-.00999999977)){a[C>>0]=1;if(B<ea(.00999999977))a[F>>0]=0;if(B<ea(0.0))G=ea(w-B);else G=w;if(!(a[n+v>>0]|0)){c[r>>2]=u+1;g[m+(u<<4)>>2]=z;g[m+(u<<4)+4>>2]=y;g[m+(u<<4)+8>>2]=x;g[m+(u<<4)+12>>2]=G;F=c[r>>2]|0;if((F|0)==10)break;else H=F}else H=u}else H=u;v=v+1|0;if((v|0)>=6){E=0;break a}else u=H}i=o;return}while(0);while(1){H=c[565016+(E<<2)>>2]|0;E=E+1|0;if((((((a[n+H>>0]|0)==0?(t=c[565016+(((E|0)==4?0:E)<<2)>>2]|0,(a[p+H>>0]|0)!=(a[p+t>>0]|0)):0)?(a[q+H>>0]|0)!=0:0)?(a[q+t>>0]|0)!=0:0)?F9b(b,d,e,f,h,j,H,t,5,k,l,m+(c[r>>2]<<4)|0)|0:0)?(t=(c[r>>2]|0)+1|0,c[r>>2]=t,(t|0)==10):0){I=30;break}if((E|0)>=4){J=0;break}}if((I|0)==30){i=o;return}b:while(1){E=c[565032+(J<<2)>>2]|0;if(!(a[n+E>>0]|0)){t=a[p+E>>0]|0;H=q+E|0;s=0;do{D=c[565016+(s<<2)>>2]|0;s=s+1|0;u=c[565016+(((s|0)==4?0:s)<<2)>>2]|0;if((((t<<24>>24!=(a[p+D>>0]|0)?(a[H>>0]|0)!=0:0)?(a[q+D>>0]|0)!=0:0)?F9b(b,d,e,f,h,j,E,D,u,k,l,m+(c[r>>2]<<4)|0)|0:0)?(u=(c[r>>2]|0)+1|0,c[r>>2]=u,(u|0)==10):0){I=30;break b}}while((s|0)<4)}J=J+1|0;if((J|0)>=2){I=30;break}}if((I|0)==30){i=o;return}}function u9b(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0;j=i;i=i+192|0;k=j+88|0;l=j+72|0;m=j+8|0;n=j;u$b(l,b,1);o=ea(Z$b(b));L$b(m,b);p=ea(g[m+32>>2]);q=ea(g[m+36>>2]);r=ea(g[m+40>>2]);s=ea(T(ea(ea(ea(p*p)+ea(q*q))+ea(r*r))));if(s>ea(g[150276])){t=ea(p/s);u=ea(q/s);v=ea(r/s)}else{s=ea(g[150284]);r=ea(g[150285]);t=s;u=r;v=ea(g[150286])}r=ea(-t);t=ea(-u);u=ea(-v);c[h>>2]=b;m=h+196|0;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];g[h+208>>2]=r;g[h+212>>2]=t;g[h+216>>2]=u;g[h+580>>2]=o;m=h+584|0;g[m>>2]=ea(F$b(b));u=ea(G$b(b));w=h+588|0;g[w>>2]=u;g[h+592>>2]=ea(o/u);g[h+220>>2]=ea(g[l+8>>2]);g[h+224>>2]=ea(g[l+12>>2]);l=h+132|0;x=l+0|0;y=(N$b(b)|0)+0|0;z=x+64|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));c[h+596>>2]=0;A=h+4|0;qMc(l,A)|0;u=ea(g[w>>2]);t=ea(u/ea(g[m>>2]));x=k+0|0;z=x+96|0;do{c[x>>2]=0;x=x+4|0}while((x|0)<(z|0));$lc(A,k);u=ea(g[d>>2]);r=ea(g[d+4>>2]);v=ea(g[d+8>>2]);d=0;while(1){m=d+4|0;s=ea(g[k+(d*12|0)>>2]);q=ea(s-u);p=ea(g[k+(d*12|0)+4>>2]);B=ea(p-r);C=ea(g[k+(d*12|0)+8>>2]);D=ea(u+ea(t*q));q=ea(r+ea(t*B));B=ea(v+ea(t*ea(C-v)));E=ea(g[k+(m*12|0)>>2]);F=ea(D-E);D=ea(g[k+(m*12|0)+4>>2]);G=ea(q-D);q=ea(g[k+(m*12|0)+8>>2]);H=ea(B-q);B=ea(E-s);s=ea(D-p);p=ea(q-C);d=d+1|0;if(!(ea(ea(ea(F*F)+ea(G*G))+ea(H*H))<=ea(ea(ea(ea(B*B)+ea(s*s))+ea(p*p))*ea(.00999999977)))){I=7;break}if((d|0)>=4){I=8;break}}if((I|0)==7){v=ea(g[b+456>>2]);d=b+460|0;x0b(b,v,ea(g[d>>2]),k);m=h+68|0;dMc(k,D$b(b)|0,m);qMc(m,A)|0;J=d}else if((I|0)==8){x=h+68|0;y=l+0|0;z=x+64|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));J=b+460|0}y=h+460|0;x=h+360|0;K$b(b,y,h+68|0,o,x,1);z=h+364|0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[z+12>>2]=c[y+12>>2];y=h+380|0;z=h+476|0;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];z=h+396|0;y=h+492|0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[z+12>>2]=c[y+12>>2];y=h+412|0;z=h+508|0;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];z=h+428|0;y=h+524|0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[z+12>>2]=c[y+12>>2];y=h+444|0;z=h+540|0;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];o=ea(g[x>>2]);g[h+456>>2]=ea(o+ea(g[J>>2]));J=h+556|0;c[J+0>>2]=c[150284];c[J+4>>2]=c[150285];c[J+8>>2]=c[150286];g[n>>2]=ea(999999986.0e6);a[h+576>>0]=(G9b(b,J,n)|0)&1;o=ea(g[n>>2]);g[h+568>>2]=o;g[h+572>>2]=ea(o*o);aFi(h+228|0,b+468|0,128)|0;a[h+356>>0]=a[b+618>>0]|0;b=e;e=c[b+4>>2]|0;n=h+604|0;c[n>>2]=c[b>>2];c[n+4>>2]=e;c[h+600>>2]=f;i=j;return}function v9b(b){b=b|0;var c=0,d=Im,e=Im,f=Im;c=i;if(!(a[b+616>>0]|0)){d=ea(ea(1.0)-ea(ea(g[b+452>>2])/ea(180.0)));if(d<ea(0.0))e=ea(0.0);else{b=d>ea(1.0);f=ea(d*ea(.400000006));e=b?ea(.400000006):f}}else e=ea(.400000006);i=c;return ea(e)}function w9b(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=e|0;var f=Im,h=Im,i=Im,j=Im;g[e>>2]=ea(ea(1.0)-b);if(d>ea(0.0)){b=ea(d-ea(c*ea(.200000003)));f=ea(ea(1.0)/ea(d-b));h=ea(-ea(b*f));i=f;j=ea(ea(g[a+460>>2])/c)}else{h=ea(1.0);i=ea(0.0);j=ea(x)}g[e+4>>2]=j;g[e+8>>2]=i;g[e+12>>2]=h;return}function x9b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im;e=i;i=i+16|0;f=e;h=ea(Z$b(a));g[c>>2]=h;g[d>>2]=h;O$b(f,a);c=G9b(a,f,d)|0;h=ea(g[f>>2]);j=ea(g[f+4>>2]);k=ea(g[f+8>>2]);l=ea(c&1);g[b>>2]=h;g[b+4>>2]=j;g[b+8>>2]=k;g[b+12>>2]=l;i=e;return}function y9b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;f=d+4|0;g=d;if((a|0)>=(b|0)){i=d;return}h=e+224|0;j=e+124|0;k=e+1024|0;l=e+168|0;m=e+8|0;e=a;do{a=c[h>>2]|0;n=c[a+(e*796|0)>>2]|0;o=c[j>>2]|0;p=o+(n*108|0)|0;q=a+(e*796|0)+80|0;YEi(q|0,c[(c[k>>2]|0)+600>>2]|0,712)|0;z9b(p,c[k>>2]|0,q,(c[h>>2]|0)+(e*796|0)|0);r=(c[o+(n*108|0)+4>>2]|0)+72|0;s=o+(n*108|0)+76|0;n=0;do{o=a+(e*796|0)+(n*12|0)+696|0;if(c[o>>2]|0){c[g>>2]=c[153136];c[f+0>>2]=c[g+0>>2];t=bOb(232,f,0,16,3653512,493)|0;c[t>>2]=q;c[t+4>>2]=c[k>>2];c[t+28>>2]=n;c[t+8>>2]=c[p>>2];u=t+12|0;v=(c[l>>2]|0)+(c[s>>2]<<4)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[t+32>>2]=(c[h>>2]|0)+(e*796|0)+(n*12|0)+4;v=znd(t+36|0,c[o>>2]|0,4096)|0;c[t+228>>2]=v;Nnd(r,2659,t,v,m,3500,0)}n=n+1|0}while((n|0)!=5);e=e+1|0}while((e|0)!=(b|0));i=d;return}function z9b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0;h=i;i=i+224|0;j=h+212|0;k=h+200|0;l=h+188|0;m=h+24|0;n=h+12|0;o=h;H1b(e+608|0,f+4|0);f=c[b>>2]|0;b=c[f+212>>2]|0;p=BTb(c[f+24>>2]|0)|0;g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+16>>2]=ea(0.0);g[m+20>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m+32>>2]=ea(0.0);g[m+36>>2]=ea(0.0);g[m+40>>2]=ea(0.0);g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(0.0);g[m+56>>2]=ea(0.0);g[m+64>>2]=ea(0.0);g[m+68>>2]=ea(0.0);g[m+72>>2]=ea(0.0);g[m+80>>2]=ea(0.0);g[m+84>>2]=ea(0.0);g[m+88>>2]=ea(0.0);g[m+96>>2]=ea(0.0);g[m+100>>2]=ea(0.0);g[m+104>>2]=ea(0.0);g[m+112>>2]=ea(0.0);g[m+116>>2]=ea(0.0);g[m+120>>2]=ea(0.0);g[m+128>>2]=ea(0.0);g[m+132>>2]=ea(0.0);g[m+136>>2]=ea(0.0);g[m+144>>2]=ea(0.0);g[m+148>>2]=ea(0.0);g[m+152>>2]=ea(0.0);f=(a[(c[d>>2]|0)+616>>0]|0)!=0;q=ea(g[d+592>>2]);g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);r=(b|0)==1;if(r){TGc(k,p,601200);c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2]}else{rGc(l,p);c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2]}t9b(f,d+460|0,d+4|0,d+196|0,ea(1.0),q,b,j,m,565040);P$b(c[d>>2]|0,e,m,c[m+160>>2]|0);if(!r){i=h;return}g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(-1.0);TGc(n,p,o);o=e+328|0;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];i=h;return}function A9b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+12|0;g=e;h=b+(d*12|0)+28|0;j=c[b>>2]|0;if(!(a[(c[j+684>>2]|0)+60>>0]|0)){k=c[b+20>>2]|0;l=c[j+(k*12|0)+608>>2]|0;m=c[j+(k*12|0)+612>>2]|0;k=c[h>>2]|0;n=b+(d*12|0)+32|0;o=c[n>>2]|0;c[f>>2]=(c[c[b+24>>2]>>2]|0)+(k<<2);p=f+4|0;c[p>>2]=o;c[f+8>>2]=o;abc(f,j,l,k,o+k|0);ibc(j,m,l,f);l=c[p>>2]|0;c[n>>2]=l;q=l}else{l=GLc()|0;n=kn[c[(c[l>>2]|0)+52>>2]&511](l,b,h,d)|0;c[f>>2]=(c[c[b+24>>2]>>2]|0)+(c[h>>2]<<2);l=f+4|0;c[l>>2]=n;c[f+8>>2]=n;n=c[b+20>>2]|0;p=c[b>>2]|0;ibc(p,c[p+(n*12|0)+612>>2]|0,c[p+(n*12|0)+608>>2]|0,f);n=c[l>>2]|0;c[b+(d*12|0)+32>>2]=n;q=n}n=c[b+12>>2]|0;l=c[b+4>>2]|0;p=c[b+20>>2]|0;m=c[l+600>>2]|0;j=(a[m+672>>0]|0)!=0;c[f>>2]=l;c[f+8>>2]=c[b+16>>2];if((c[n+212>>2]|0)!=3?(a[n+217>>0]|0)!=0:0)r=(c[n+208>>2]|0)==1;else r=0;a[f+4>>0]=r&j&1;j=b+(d*12|0)+32|0;c[g>>2]=(c[c[b+24>>2]>>2]|0)+(c[h>>2]<<2);h=g+4|0;c[h>>2]=q;c[g+8>>2]=q;q=m+(p*12|0)+612|0;d=m+(p*12|0)+608|0;bbc(g,c[q>>2]|0,c[d>>2]|0,f);f=c[b>>2]|0;b=c[f+704>>2]|0;if(!b){s=c[h>>2]|0;c[j>>2]=s;i=e;return}Dn[b&511](c[q>>2]|0,c[d>>2]|0,g,c[f+708>>2]|0);s=c[h>>2]|0;c[j>>2]=s;i=e;return}function B9b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im;d=i;i=i+16|0;e=d+4|0;f=d;if(!(a[b+76>>0]|0)){i=d;return}h=c[(c[b+1024>>2]|0)+600>>2]|0;j=c[h+684>>2]|0;k=b+1036|0;l=b+1052|0;m=j+16|0;n=j+20|0;o=j+28|0;p=j+32|0;q=j+40|0;r=j+44|0;s=j+52|0;t=(c[o>>2]|0)+(c[m>>2]|0)+(c[q>>2]|0)+(c[s>>2]|0)|0;u=(c[p>>2]|0)+(c[n>>2]|0)+(c[r>>2]|0)+(c[j+56>>2]|0)|0;v=b+1044|0;c[v>>2]=t;w=b+1048|0;x=c[w>>2]|0;do if((x&2147483647)>>>0<t>>>0)if((x|0)>-1){c[w>>2]=t;y=c[k>>2]|0;c[f>>2]=c[b+1040>>2];c[e+0>>2]=c[f+0>>2];c[k>>2]=hOb(y,t<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+1040>>2];c[e+0>>2]=c[f+0>>2];y=cOb(t<<2,4,e,0,3653512,352)|0;YEi(y|0,c[k>>2]|0,c[v>>2]<<2|0)|0;c[w>>2]=t;c[k>>2]=y;break}while(0);t=u<<1;w=b+1060|0;c[w>>2]=t;v=b+1064|0;x=c[v>>2]|0;do if((x&2147483647)>>>0<t>>>0)if((x|0)>-1){c[v>>2]=t;y=c[l>>2]|0;c[f>>2]=c[b+1056>>2];c[e+0>>2]=c[f+0>>2];c[l>>2]=hOb(y,u*24|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+1056>>2];c[e+0>>2]=c[f+0>>2];y=cOb(u*24|0,4,e,0,3653512,352)|0;YEi(y|0,c[l>>2]|0,(c[w>>2]|0)*12|0)|0;c[v>>2]=t;c[l>>2]=y;break}while(0);t=c[k>>2]|0;k=c[j+12>>2]|0;if((c[m>>2]|0)>0){v=0;while(1){w=v+1|0;c[t+(v<<2)>>2]=c[k+(v<<2)>>2];if((w|0)<(c[m>>2]|0))v=w;else{z=w;break}}}else z=0;v=c[n>>2]|0;n=c[j+24>>2]|0;if((c[o>>2]|0)>0){m=0;k=z;while(1){w=k+1|0;c[t+(k<<2)>>2]=(c[n+(m<<2)>>2]|0)+v;m=m+1|0;if((m|0)>=(c[o>>2]|0)){A=w;break}else k=w}}else A=z;z=(c[p>>2]|0)+v|0;v=c[j+36>>2]|0;if((c[q>>2]|0)>0){p=0;k=A;while(1){o=k+1|0;c[t+(k<<2)>>2]=(c[v+(p<<2)>>2]|0)+z;p=p+1|0;if((p|0)>=(c[q>>2]|0)){B=o;break}else k=o}}else B=A;A=(c[r>>2]|0)+z|0;z=c[j+48>>2]|0;if((c[s>>2]|0)>0){j=0;r=B;while(1){c[t+(r<<2)>>2]=A+(c[z+(j<<2)>>2]|0);j=j+1|0;if((j|0)>=(c[s>>2]|0))break;else r=r+1|0}}r=0;s=1;while(1){j=c[h+(s*12|0)+608>>2]|0;z=h+(s*12|0)+616|0;if(!(c[z>>2]|0))C=r;else{A=0;t=r;while(1){B=t+1|0;k=c[l>>2]|0;q=j+(A*24|0)|0;D=ea(g[q>>2]);p=j+(A*24|0)+12|0;E=ea(D-ea(g[p>>2]));v=j+(A*24|0)+4|0;D=ea(g[v>>2]);o=j+(A*24|0)+16|0;F=ea(D-ea(g[o>>2]));m=j+(A*24|0)+8|0;D=ea(g[m>>2]);n=j+(A*24|0)+20|0;G=ea(D-ea(g[n>>2]));g[k+(t*12|0)>>2]=E;g[k+(t*12|0)+4>>2]=F;g[k+(t*12|0)+8>>2]=G;k=t+2|0;w=c[l>>2]|0;G=ea(g[q>>2]);F=ea(G+ea(g[p>>2]));G=ea(g[v>>2]);E=ea(G+ea(g[o>>2]));G=ea(g[m>>2]);D=ea(G+ea(g[n>>2]));g[w+(B*12|0)>>2]=F;g[w+(B*12|0)+4>>2]=E;g[w+(B*12|0)+8>>2]=D;A=A+1|0;if(A>>>0>=(c[z>>2]|0)>>>0){C=k;break}else t=k}}s=s+1|0;if((s|0)==5)break;else r=C}i=d;return}function C9b(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im;d=i;i=i+32|0;e=d+16|0;f=d+12|0;h=d;j=c[b>>2]|0;k=b+4|0;l=c[k>>2]|0;m=c[b+8>>2]|0;if(!(a[j+76>>0]|0)){n=c[153136]|0;c[f>>2]=n;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}o=c[153134]|0;p=j+1044|0;if(!(c[p>>2]|0)){q=0;r=0;s=0}else{t=j+1036|0;u=j+1052|0;j=0;v=0;w=0;x=0;while(1){y=c[(c[t>>2]|0)+(x<<2)>>2]<<1;z=(c[u>>2]|0)+(y*12|0)|0;A=j|1;B=v&2147483647;do if(A>>>0>B>>>0?(C=v<<1,D=(C|0)==0?1:C,B>>>0<D>>>0):0)if((v|0)>-1){c[f>>2]=o;c[e+0>>2]=c[f+0>>2];E=hOb(w,D*12|0,4,e,0,3653512,370)|0;F=D;break}else{c[f>>2]=o;c[e+0>>2]=c[f+0>>2];C=cOb(D*12|0,4,e,0,3653512,352)|0;YEi(C|0,w|0,A*12|0)|0;E=C;F=D;break}else{E=w;F=v}while(0);B=E+(j*12|0)|0;c[B+0>>2]=c[z+0>>2];c[B+4>>2]=c[z+4>>2];c[B+8>>2]=c[z+8>>2];B=(c[u>>2]|0)+((y|1)*12|0)|0;D=j+2|0;C=F&2147483647;do if(D>>>0>C>>>0?(G=F<<1,H=(G|0)==0?1:G,C>>>0<H>>>0):0)if((F|0)>-1){c[f>>2]=o;c[e+0>>2]=c[f+0>>2];I=hOb(E,H*12|0,4,e,0,3653512,370)|0;J=H;break}else{c[f>>2]=o;c[e+0>>2]=c[f+0>>2];G=cOb(H*12|0,4,e,0,3653512,352)|0;YEi(G|0,E|0,D*12|0)|0;I=G;J=H;break}else{I=E;J=F}while(0);C=I+(A*12|0)|0;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];x=x+1|0;if(x>>>0>=(c[p>>2]|0)>>>0){K=D;L=J;M=I;break}else{j=D;v=J;w=I}}q=L;r=K>>>1;s=M}N=ea(-ea(g[l+328>>2]));O=ea(-ea(g[l+332>>2]));P=ea(-ea(g[l+336>>2]));g[h>>2]=N;g[h+4>>2]=O;g[h+8>>2]=P;M=GLc()|0;gn[c[(c[M>>2]|0)+64>>2]&127](M,m,c[(c[l+684>>2]|0)+64>>2]|0,c[k>>2]|0,h,s,r)|0;if((q|0)<=-1){n=c[153136]|0;c[f>>2]=n;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}c[f>>2]=o;c[e+0>>2]=c[f+0>>2];eOb(s,e);n=c[153136]|0;c[f>>2]=n;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function D9b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;k=f;if(!b){i=f;return}if(!(c[d+676>>2]|0)){i=f;return}l=e+1028|0;m=e+76|0;if(a[m>>0]|0)Ind(l,3501,e,e+8|0,1);if((b|0)>0){n=e+224|0;o=e+124|0;p=e+1024|0;q=h+4|0;r=d+192|0;d=0;do{s=c[n>>2]|0;t=c[s+(d*796|0)>>2]|0;u=c[o>>2]|0;v=u+(t*108|0)|0;w=s+(d*796|0)+80|0;YEi(w|0,c[(c[p>>2]|0)+600>>2]|0,712)|0;z9b(v,c[p>>2]|0,w,(c[n>>2]|0)+(d*796|0)|0);if(kac(s+(d*796|0)+688|0)|0){c[h>>2]=0;c[q>>2]=0;if(!(a[m>>0]|0))x=0;else{y=GLc()|0;z=mo[c[(c[y>>2]|0)+20>>2]&4095](y)|0;c[(c[n>>2]|0)+(d*796|0)+792>>2]=z;c[j>>2]=c[153136];c[g+0>>2]=c[j+0>>2];y=bOb(12,g,0,16,3653512,718)|0;c[y>>2]=e;c[y+4>>2]=w;c[y+8>>2]=z;Ind(h,3502,y,l,1);x=z}z=(c[u+(t*108|0)+4>>2]|0)+72|0;t=0;do{u=s+(d*796|0)+(t*12|0)+696|0;if(c[u>>2]|0){c[k>>2]=c[153136];c[g+0>>2]=c[k+0>>2];y=bOb(224,g,0,16,3653512,736)|0;c[y>>2]=w;c[y+8>>2]=x;c[y+4>>2]=c[p>>2];A=c[v>>2]|0;c[y+12>>2]=A;c[y+16>>2]=c[r>>2]&c[A+176>>2];c[y+20>>2]=t;c[y+24>>2]=(c[n>>2]|0)+(d*796|0)+(t*12|0)+4;A=znd(y+28|0,c[u>>2]|0,4096)|0;c[y+220>>2]=A;Nnd(z,2660,y,A,h,3503,0)}t=t+1|0}while((t|0)!=5);Fnd(h)}d=d+1|0}while((d|0)!=(b|0))}Fnd(l);i=f;return}function E9b(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,U=Im,V=Im,W=0;k=i;i=i+880|0;l=k+216|0;m=k+168|0;n=k+104|0;o=k+96|0;p=k;q=pyc()|0;r=(c[q+24>>2]|0)+((c[q+40>>2]|0)*96|0)+24|0;q=(e|0)==1;if((c[r>>2]|0)==0&q){i=k;return}s=c[j>>2]|0;g[l>>2]=ea(0.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+16>>2]=ea(0.0);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(0.0);g[l+32>>2]=ea(0.0);g[l+36>>2]=ea(0.0);g[l+40>>2]=ea(0.0);g[l+48>>2]=ea(0.0);g[l+52>>2]=ea(0.0);g[l+56>>2]=ea(0.0);g[l+64>>2]=ea(0.0);g[l+68>>2]=ea(0.0);g[l+72>>2]=ea(0.0);g[l+80>>2]=ea(0.0);g[l+84>>2]=ea(0.0);g[l+88>>2]=ea(0.0);g[l+96>>2]=ea(0.0);g[l+100>>2]=ea(0.0);g[l+104>>2]=ea(0.0);g[l+112>>2]=ea(0.0);g[l+116>>2]=ea(0.0);g[l+120>>2]=ea(0.0);g[l+128>>2]=ea(0.0);g[l+132>>2]=ea(0.0);g[l+136>>2]=ea(0.0);g[l+144>>2]=ea(0.0);g[l+148>>2]=ea(0.0);g[l+152>>2]=ea(0.0);g[l+164>>2]=ea(0.0);g[l+168>>2]=ea(0.0);g[l+172>>2]=ea(0.0);g[l+180>>2]=ea(0.0);g[l+184>>2]=ea(0.0);g[l+188>>2]=ea(0.0);g[l+196>>2]=ea(0.0);g[l+200>>2]=ea(0.0);g[l+204>>2]=ea(0.0);g[l+212>>2]=ea(0.0);g[l+216>>2]=ea(0.0);g[l+220>>2]=ea(0.0);g[l+228>>2]=ea(0.0);g[l+232>>2]=ea(0.0);g[l+236>>2]=ea(0.0);g[l+244>>2]=ea(0.0);g[l+248>>2]=ea(0.0);g[l+252>>2]=ea(0.0);g[l+260>>2]=ea(0.0);g[l+264>>2]=ea(0.0);g[l+268>>2]=ea(0.0);g[l+276>>2]=ea(0.0);g[l+280>>2]=ea(0.0);g[l+284>>2]=ea(0.0);g[l+292>>2]=ea(0.0);g[l+296>>2]=ea(0.0);g[l+300>>2]=ea(0.0);g[l+308>>2]=ea(0.0);g[l+312>>2]=ea(0.0);g[l+316>>2]=ea(0.0);g[l+328>>2]=ea(0.0);g[l+332>>2]=ea(0.0);g[l+336>>2]=ea(0.0);g[l+344>>2]=ea(0.0);g[l+348>>2]=ea(0.0);g[l+352>>2]=ea(0.0);g[l+360>>2]=ea(0.0);g[l+364>>2]=ea(0.0);g[l+368>>2]=ea(0.0);g[l+376>>2]=ea(0.0);g[l+380>>2]=ea(0.0);g[l+384>>2]=ea(0.0);g[l+392>>2]=ea(0.0);g[l+396>>2]=ea(0.0);g[l+400>>2]=ea(0.0);g[l+408>>2]=ea(0.0);g[l+412>>2]=ea(0.0);g[l+416>>2]=ea(0.0);g[l+424>>2]=ea(0.0);g[l+428>>2]=ea(0.0);g[l+432>>2]=ea(0.0);g[l+440>>2]=ea(0.0);g[l+444>>2]=ea(0.0);g[l+448>>2]=ea(0.0);g[l+456>>2]=ea(0.0);g[l+460>>2]=ea(0.0);g[l+464>>2]=ea(0.0);g[l+472>>2]=ea(0.0);g[l+476>>2]=ea(0.0);g[l+480>>2]=ea(0.0);g[l+492>>2]=ea(0.0);g[l+496>>2]=ea(0.0);g[l+500>>2]=ea(0.0);g[l+508>>2]=ea(0.0);g[l+512>>2]=ea(0.0);g[l+516>>2]=ea(0.0);g[l+524>>2]=ea(0.0);g[l+528>>2]=ea(0.0);g[l+532>>2]=ea(0.0);g[l+540>>2]=ea(0.0);g[l+544>>2]=ea(0.0);g[l+548>>2]=ea(0.0);g[l+556>>2]=ea(0.0);g[l+560>>2]=ea(0.0);g[l+564>>2]=ea(0.0);g[l+572>>2]=ea(0.0);g[l+576>>2]=ea(0.0);g[l+580>>2]=ea(0.0);g[l+588>>2]=ea(0.0);g[l+592>>2]=ea(0.0);g[l+596>>2]=ea(0.0);g[l+604>>2]=ea(0.0);g[l+608>>2]=ea(0.0);g[l+612>>2]=ea(0.0);g[l+620>>2]=ea(0.0);g[l+624>>2]=ea(0.0);g[l+628>>2]=ea(0.0);g[l+636>>2]=ea(0.0);g[l+640>>2]=ea(0.0);g[l+644>>2]=ea(0.0);g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+12>>2]=ea(0.0);g[m+16>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m+28>>2]=ea(0.0);g[m+36>>2]=ea(0.0);g[m+40>>2]=ea(0.0);GMc(f,n);f=(e|0)>0;if(f){t=n+4|0;u=n+8|0;v=n+16|0;w=n+20|0;x=n+24|0;y=o+4|0;z=o+5|0;A=j+460|0;B=s+456|0;C=p+76|0;D=j+580|0;E=p+92|0;F=j+584|0;G=j+588|0;H=s+616|0;s=j+4|0;I=j+196|0;j=0;do{do if(a[d+(j*364|0)>>0]|0){if((c[r>>2]|0)==1){J=ea(g[n>>2]);K=ea(g[t>>2]);L=ea(g[u>>2]);M=ea(g[d+(j*364|0)+324>>2]);N=ea(J*M);J=ea(g[d+(j*364|0)+328>>2]);O=ea(N+ea(K*J));K=ea(g[d+(j*364|0)+332>>2]);g[m+(j*12|0)>>2]=ea(O+ea(L*K));L=ea(g[v>>2]);O=ea(g[w>>2]);g[m+(j*12|0)+4>>2]=ea(ea(ea(L*M)+ea(O*J))+ea(ea(g[x>>2])*K));g[m+(j*12|0)+8>>2]=ea(g[d+(j*364|0)+336>>2])}if(q){c[l+(j*164|0)+160>>2]=0;break}else{c[o>>2]=16843009;a[y>>0]=(j|0)==0&1;a[z>>0]=(j+1|0)==(e|0)&1;P=p+0|0;Q=A+0|0;R=P+96|0;do{c[P>>2]=c[Q>>2];P=P+4|0;Q=Q+4|0}while((P|0)<(R|0));K=ea(g[d+(j*364|0)+348>>2]);J=ea(K-ea(g[B>>2]));g[C>>2]=ea(ea(g[C>>2])+J);J=ea(g[d+(j*364|0)+352>>2]);O=ea(J-ea(g[D>>2]));g[E>>2]=ea(ea(g[E>>2])+O);O=ea(K/ea(g[F>>2]));K=ea(J/ea(g[G>>2]));t9b((a[H>>0]|0)!=0,p,s,I,O,K,1,h,l+(j*164|0)|0,o);break}}while(0);j=j+1|0}while((j|0)!=(e|0));if(f){j=0;o=0;while(1){h=j<<1|1;o=o+1|0;if((o|0)==(e|0)){S=h;break}else j=h}}else S=0}else S=0;j=c[b>>2]|0;o=(c[b+4>>2]|0)-j|0;h=(o|0)/24|0;if((o|0)<=0){i=k;return}o=n+4|0;I=n+8|0;s=n+16|0;p=n+20|0;H=n+24|0;G=(e|0)>1;F=j;j=0;while(1){E=c[F+(j*24|0)+4>>2]|0;D=F+(j*24|0)+16|0;c[D>>2]=S;if((c[r>>2]|0)==1?(K=ea(g[E+12>>2]),O=ea(K*K),K=ea(g[E+16>>2]),J=ea(O+ea(K*K)),K=ea(g[E+20>>2]),O=ea(T(ea(J+ea(K*K)))),K=ea(g[n>>2]),J=ea(g[o>>2]),M=ea(g[I>>2]),L=ea(g[E>>2]),N=ea(K*L),K=ea(g[E+4>>2]),U=ea(N+ea(J*K)),J=ea(g[E+8>>2]),N=ea(U+ea(M*J)),M=ea(g[s>>2]),U=ea(g[p>>2]),V=ea(ea(ea(L*M)+ea(K*U))+ea(J*ea(g[H>>2]))),f):0){C=S;B=0;A=1;while(1){if((a[d+(B*364|0)>>0]|0)!=0?(J=ea(N-ea(g[m+(B*12|0)>>2])),U=ea(V-ea(g[m+(B*12|0)+4>>2])),K=ea(ea(J*J)+ea(U*U)),U=ea(O+ea(g[m+(B*12|0)+8>>2])),K>ea(U*U)):0){z=C&~A;c[D>>2]=z;W=z}else W=C;B=B+1|0;if((B|0)==(e|0))break;else{C=W;A=A<<1}}}if(G){A=0;C=1;while(1){if(((a[d+(A*364|0)>>0]|0)!=0?(c[D>>2]&C|0)!=0:0)?!(qmc(E,l+(A*164|0)|0,c[l+(A*164|0)+160>>2]|0)|0):0)c[D>>2]=c[D>>2]&~C;A=A+1|0;if((A|0)==(e|0))break;else C=C<<1}}C=j+1|0;if((C|0)>=(h|0))break;F=c[b>>2]|0;j=C}i=k;return}function F9b(b,c,d,e,f,h,j,k,l,m,n,o){b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=0,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im;p=i;if(!(a[565120]|0)){g[141262]=ea(-1.0);g[141263]=ea(0.0);g[141264]=ea(0.0);g[141265]=ea(1.0);g[141266]=ea(0.0);g[141267]=ea(0.0);g[141268]=ea(0.0);g[141269]=ea(-1.0);g[141270]=ea(0.0);g[141271]=ea(0.0);g[141272]=ea(1.0);g[141273]=ea(0.0);g[141274]=ea(0.0);g[141275]=ea(0.0);g[141276]=ea(-1.0);g[141277]=ea(0.0);g[141278]=ea(0.0);g[141279]=ea(1.0);a[565120]=1}q=ea(g[c+(j<<4)>>2]);r=ea(q+ea(g[c+(k<<4)>>2]));q=ea(g[c+(j<<4)+4>>2]);s=ea(q+ea(g[c+(k<<4)+4>>2]));q=ea(g[c+(j<<4)+8>>2]);t=ea(q+ea(g[c+(k<<4)+8>>2]));q=ea(g[565048+(j*12|0)>>2]);u=ea(q+ea(g[565048+(k*12|0)>>2]));q=ea(g[565052+(j*12|0)>>2]);v=ea(q+ea(g[565052+(k*12|0)>>2]));q=ea(g[565056+(j*12|0)>>2]);w=ea(q+ea(g[565056+(k*12|0)>>2]));q=ea(g[565048+(l*12|0)>>2]);x=ea(g[565052+(l*12|0)>>2]);y=ea(g[565056+(l*12|0)>>2]);z=ea(u-q);A=ea(v-x);B=ea(w-y);C=ea(u+q);q=ea(v+x);x=ea(w+y);l=B<ea(0.0);y=l?f:h;l=x<ea(0.0);w=l?f:h;h=ea(g[d>>2]);f=ea(z*h);v=ea(g[d+16>>2]);u=ea(f+ea(A*v));f=ea(g[d+32>>2]);D=ea(u+ea(B*f));u=ea(g[d+48>>2]);E=ea(u+D);D=ea(g[d+4>>2]);F=ea(z*D);G=ea(g[d+20>>2]);H=ea(F+ea(A*G));F=ea(g[d+36>>2]);I=ea(H+ea(B*F));H=ea(g[d+52>>2]);J=ea(H+I);I=ea(g[d+8>>2]);K=ea(z*I);L=ea(g[d+24>>2]);M=ea(K+ea(A*L));K=ea(g[d+40>>2]);N=ea(M+ea(B*K));M=ea(g[d+56>>2]);O=ea(M+N);N=ea(g[d+12>>2]);P=ea(z*N);z=ea(g[d+28>>2]);Q=ea(P+ea(A*z));A=ea(g[d+44>>2]);P=ea(Q+ea(B*A));B=ea(g[d+60>>2]);Q=ea(B+P);d=Q<ea(0.0);if(b){if(d)R=ea(-Q);else R=Q;if(R>ea(1.00000001e-07)){R=ea(ea(1.0)/Q);S=ea(O*R);U=ea(J*R);V=ea(E*R)}else{S=ea(0.0);U=ea(0.0);V=ea(0.0)}R=ea(u+ea(ea(ea(C*h)+ea(q*v))+ea(x*f)));P=ea(H+ea(ea(ea(C*D)+ea(q*G))+ea(x*F)));W=ea(M+ea(ea(ea(C*I)+ea(q*L))+ea(x*K)));X=ea(B+ea(ea(ea(C*N)+ea(q*z))+ea(x*A)));if(X<ea(0.0))Y=ea(-X);else Y=X;if(Y>ea(1.00000001e-07)){Y=ea(ea(1.0)/X);Z=ea(R*Y);_=V;$=ea(P*Y);aa=U;ba=ea(W*Y);ca=S}else{Z=ea(0.0);_=V;$=ea(0.0);aa=U;ba=ea(0.0);ca=S}}else{if(d)da=ea(-Q);else da=Q;if(da>ea(1.00000001e-07)){da=ea(ea(1.0)/Q);fa=ea(O*da);ga=ea(J*da);ha=ea(E*da)}else{fa=ea(0.0);ga=ea(0.0);ha=ea(0.0)}da=ea(u+ea(ea(ea(C*h)+ea(q*v))+ea(x*f)));f=ea(H+ea(ea(ea(C*D)+ea(q*G))+ea(x*F)));F=ea(M+ea(ea(ea(C*I)+ea(q*L))+ea(x*K)));K=ea(B+ea(ea(ea(C*N)+ea(q*z))+ea(x*A)));if(K<ea(0.0))ia=ea(-K);else ia=K;if(ia>ea(1.00000001e-07)){ia=ea(ea(1.0)/K);ja=ea(F*ia);ka=ea(f*ia);la=ea(da*ia)}else{ja=ea(0.0);ka=ea(0.0);la=ea(0.0)}ia=ea(g[e>>2]);da=ea(ha-ia);ha=ea(g[e+4>>2]);f=ea(ga-ha);ga=ea(g[e+8>>2]);Z=ea(ia+ea(w*ea(la-ia)));_=ea(ia+ea(y*da));$=ea(ha+ea(w*ea(ka-ha)));aa=ea(ha+ea(y*f));ba=ea(ga+ea(w*ea(ja-ga)));ca=ea(ga+ea(y*ea(fa-ga)))}ga=ea(Z-_);Z=ea($-aa);$=ea(ba-ca);if((m|0)!=1){ba=ea(ea(g[n>>2])-_);fa=ea(ea(g[n+4>>2])-aa);y=ea(ea(g[n+8>>2])-ca);ja=ea(ea(Z*y)-ea($*fa));w=ea(ea($*ba)-ea(ga*y));y=ea(ea(ga*fa)-ea(Z*ba));m=o+4|0;e=o+8|0;ba=ea(T(ea(ea(y*y)+ea(ea(ja*ja)+ea(w*w)))));fa=ea(ja/ba);ja=ea(w/ba);w=ea(y/ba);g[o>>2]=fa;g[m>>2]=ja;g[e>>2]=w;ba=ea(ea(ea(_*fa)+ea(aa*ja))+ea(ca*w));d=o+12|0;g[d>>2]=ea(-ba);if(!(ea(ea(ea(r*fa)+ea(s*ja))+ea(t*w))<ea(0.0))){ma=1;i=p;return ma|0}g[o>>2]=ea(-fa);g[m>>2]=ea(-ja);g[e>>2]=ea(-w);g[d>>2]=ba;ma=1;i=p;return ma|0}ba=ea(T(ea(ea($*$)+ea(ea(Z*Z)+ea(ga*ga)))));if(ba>ea(g[150276])){na=ea(Z/ba);oa=ea($/ba);pa=ea(ga/ba)}else{ba=ea(g[150284]);ga=ea(g[150285]);na=ga;oa=ea(g[150286]);pa=ba}ba=ea(g[n+8>>2]);ga=ea(na*ba);$=ea(g[n+4>>2]);Z=ea(ga-ea(oa*$));ga=ea(g[n>>2]);w=ea(ea(oa*ga)-ea(pa*ba));ba=ea(ea(pa*$)-ea(na*ga));ga=ea(T(ea(ea(ba*ba)+ea(ea(Z*Z)+ea(w*w)))));if(ga<ea(.00100000005)){ma=0;i=p;return ma|0}na=ea(Z/ga);Z=ea(w/ga);w=ea(ba/ga);if(ea(ea(ea(r*na)+ea(s*Z))+ea(t*w))<ea(0.0)){qa=ea(-na);ra=ea(-Z);sa=ea(-w)}else{qa=na;ra=Z;sa=w}g[o>>2]=qa;g[o+4>>2]=ra;g[o+8>>2]=sa;g[o+12>>2]=ea(-ea(ea(ca*sa)+ea(ea(aa*ra)+ea(_*qa))));ma=1;i=p;return ma|0}function G9b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;f=i;i=i+80|0;h=f+64|0;j=f;k=pyc()|0;if(!(c[(c[k+24>>2]|0)+((c[k+40>>2]|0)*96|0)+24>>2]|0)){l=0;i=f;return l|0}O$b(h,b);c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];m=ea(Z$b(b));g[e>>2]=m;if(!(a[b+616>>0]|0)){n=ea(ea(1.0)-ea(ea(g[b+452>>2])/ea(180.0)));if(n<ea(0.0))o=ea(0.0);else{h=n>ea(1.0);p=ea(n*ea(.400000006));o=h?ea(.400000006):p}}else o=ea(.400000006);p=ea(-ea(o*m));L$b(j,b);m=ea(ea(g[j>>2])*ea(0.0));n=ea(m+ea(ea(g[j+16>>2])*ea(0.0)));m=ea(n+ea(ea(g[j+32>>2])*p));n=ea(ea(g[j+4>>2])*ea(0.0));q=ea(n+ea(ea(g[j+20>>2])*ea(0.0)));n=ea(q+ea(ea(g[j+36>>2])*p));q=ea(ea(g[j+8>>2])*ea(0.0));r=ea(q+ea(ea(g[j+24>>2])*ea(0.0)));q=ea(r+ea(ea(g[j+40>>2])*p));g[d>>2]=ea(m+ea(g[d>>2]));j=d+4|0;g[j>>2]=ea(n+ea(g[j>>2]));j=d+8|0;g[j>>2]=ea(q+ea(g[j>>2]));q=ea(ea(1.0)-o);g[e>>2]=ea(q*ea(g[e>>2]));l=1;i=f;return l|0}function H9b(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0,F=Im,G=Im,H=0;e=i;i=i+560|0;f=e+464|0;h=e+376|0;j=e+12|0;k=e+248|0;l=e+496|0;m=e;n=e+312|0;o=e+400|0;p=e+388|0;q=b+28|0;r=c[q>>2]|0;s=c[b>>2]|0;t=c[s+(r*12|0)+608>>2]|0;u=c[s+(r*12|0)+612>>2]|0;r=b+32|0;v=b+(d*12|0)+36|0;w=c[v>>2]|0;x=b+(d*12|0)+40|0;d=c[x>>2]|0;c[f>>2]=(c[c[r>>2]>>2]|0)+(w<<2);y=f+4|0;c[y>>2]=d;c[f+8>>2]=d;abc(f,s,t,w,d+w|0);ibc(s,u,t,f);t=c[y>>2]|0;c[x>>2]=t;y=c[b+4>>2]|0;u=c[q>>2]|0;q=c[y+600>>2]|0;s=q+(u*12|0)+608|0;w=a[q+672>>0]|0;d=c[b+8>>2]|0;z=c[(c[y>>2]|0)+412>>2]&c[d+176>>2];A=d+212|0;B=c[A>>2]|0;if(!B){g[j+140>>2]=ea(0.0);g[j+144>>2]=ea(0.0);g[j+148>>2]=ea(0.0);g[j+156>>2]=ea(0.0);g[j+160>>2]=ea(0.0);g[j+164>>2]=ea(0.0);g[j+172>>2]=ea(0.0);g[j+176>>2]=ea(0.0);g[j+180>>2]=ea(0.0);g[j+188>>2]=ea(0.0);g[j+192>>2]=ea(0.0);g[j+196>>2]=ea(0.0);g[j+204>>2]=ea(0.0);g[j+208>>2]=ea(0.0);g[j+212>>2]=ea(0.0);g[j+220>>2]=ea(0.0);g[j+224>>2]=ea(0.0);g[j+228>>2]=ea(0.0);g[m>>2]=ea(1.0);g[m+4>>2]=ea(1.0);g[m+8>>2]=ea(-1.0);iMc(k,m)|0;C=ea(g[d+196>>2]);nMc(l,C,ea(.0000999999974),ea(g[d+184>>2]))|0;m=j+76|0;dMc(l,k,m);k=j+12|0;PGc(n,BTb(c[d+24>>2]|0)|0);l=k+0|0;D=n+0|0;n=l+64|0;do{c[l>>2]=c[D>>2];l=l+4|0;D=D+4|0}while((l|0)<(n|0));dMc(m,k,o);r1b(o,j+140|0);c[j>>2]=y;c[j+8>>2]=z;o=w<<24>>24!=0;if((c[A>>2]|0)!=3?(a[d+217>>0]|0)!=0:0)E=(c[d+208>>2]|0)==1;else E=0;a[j+4>>0]=E&o&1;o=c[x>>2]|0;c[p>>2]=(c[c[r>>2]>>2]|0)+(c[v>>2]<<2);E=p+4|0;c[E>>2]=o;c[p+8>>2]=o;dbc(p,c[q+(u*12|0)+612>>2]|0,c[s>>2]|0,j);c[x>>2]=c[E>>2];i=e;return}else if((B|0)==2){C=ea(g[b+24>>2]);F=ea(g[b+20>>2]);G=ea(g[b+16>>2]);g[f+12>>2]=ea(g[b+12>>2]);g[f+16>>2]=G;g[f+20>>2]=F;g[f+24>>2]=C;c[f>>2]=y;c[f+8>>2]=z;z=w<<24>>24!=0;if((c[A>>2]|0)!=3?(a[d+217>>0]|0)!=0:0)H=(c[d+208>>2]|0)==1;else H=0;a[f+4>>0]=H&z&1;c[h>>2]=(c[c[r>>2]>>2]|0)+(c[v>>2]<<2);v=h+4|0;c[v>>2]=t;c[h+8>>2]=t;cbc(h,c[q+(u*12|0)+612>>2]|0,c[s>>2]|0,f);c[x>>2]=c[v>>2];i=e;return}else{i=e;return}}function I9b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+32>>2]|0;g=c[a+228>>2]|0;h=c[a+40>>2]|0;if((g|0)>1){j=c[f>>2]|0;k=1;l=h;while(1){m=c[a+(k*12|0)+36>>2]|0;n=c[a+(k*12|0)+40>>2]|0;o=n+m|0;if(m>>>0<o>>>0){p=m;m=l;while(1){c[j+(m<<2)>>2]=c[j+(p<<2)>>2];p=p+1|0;if((p|0)==(o|0))break;else m=m+1|0}q=n+l|0}else q=l;k=k+1|0;if((k|0)==(g|0)){r=q;break}else l=q}}else r=h;c[f+4>>2]=r;c[e>>2]=c[153136];c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function J9b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+24>>2]|0;g=c[a+220>>2]|0;h=c[a+32>>2]|0;if((g|0)>1){j=c[f>>2]|0;k=1;l=h;while(1){m=c[a+(k*12|0)+28>>2]|0;n=c[a+(k*12|0)+32>>2]|0;o=n+m|0;if(m>>>0<o>>>0){p=m;m=l;while(1){c[j+(m<<2)>>2]=c[j+(p<<2)>>2];p=p+1|0;if((p|0)==(o|0))break;else m=m+1|0}q=n+l|0}else q=l;k=k+1|0;if((k|0)==(g|0)){r=q;break}else l=q}}else r=h;c[f+4>>2]=r;c[e>>2]=c[153136];c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function K9b(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=c[b>>2]&-8161|32;return}function L9b(){var b=0,d=0,e=0;b=i;d=NOc()|0;if(!(a[d+101>>0]|0)){e=0;i=b;return e|0}if(!((a[d+102>>0]|0)!=0&(a[621188]|0)==0)){e=0;i=b;return e|0}d=pyc()|0;if((c[(c[d+24>>2]|0)+((c[d+40>>2]|0)*96|0)+16>>2]|0)<2){e=0;i=b;return e|0}e=ea(wyc())>ea(0.0);i=b;return e|0}function M9b(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;k=pyc()|0;l=d+4|0;d=c[l>>2]|0;m=(f|0)!=2|h^1?d&-2593:d&-2593|512;d=(e|0)==1&(f|0)!=0&(c[(c[k+24>>2]|0)+((c[k+40>>2]|0)*96|0)+24>>2]|0)==1?m|1024:m&-3105;c[l>>2]=d;if(g){g=d&-2529;c[l>>2]=g|128;m=b[310583]|0;if(!((m&255)<<24>>24!=0&(m&65535)<256)){i=j;return}c[l>>2]=g|2176;i=j;return}g=d&-2529;if((e|0)==2){c[l>>2]=g|256;i=j;return}c[l>>2]=g|64;if(!(a[621166]|0)){i=j;return}c[l>>2]=g|2112;i=j;return}function N9b(d,f,h,j,k){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=0,ca=0,fa=0,ga=0,ha=0,ia=Im,ja=0,ka=0,la=0,ma=0,na=0,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im,mb=Im,nb=0,ob=Im,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=Im,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=Im,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=Im,Uc=Im,Vc=Im,Wc=Im,Xc=Im,Yc=Im,Zc=Im,_c=Im,$c=Im,ad=Im,bd=Im,cd=Im,dd=Im,ed=0,fd=Im,gd=Im,hd=Im,id=Im,jd=Im,kd=Im,ld=0,md=Im,nd=Im,od=0.0,pd=0.0,qd=0.0,rd=0,sd=0,td=0,ud=0,vd=0,wd=Im,xd=0,yd=0,zd=0,Ad=Im;l=i;i=i+2576|0;m=l+2416|0;n=l+672|0;o=l+16|0;p=l+320|0;q=l+448|0;r=l+2344|0;s=l+160|0;t=l+224|0;u=l+240|0;v=l+252|0;w=l+264|0;y=l+276|0;z=l+288|0;A=l+300|0;B=l+736|0;C=l+2216|0;D=l+2328|0;E=l+2408|0;F=l+2512|0;G=l+512|0;I=l+576|0;J=l+580|0;K=l+584|0;L=l+592|0;M=l+616|0;N=l+628|0;O=l+640|0;P=l+128|0;Q=l;R=l+112|0;S=l+656|0;U=l+312|0;V=l+760|0;W=l+416|0;X=l+2312|0;Y=l+144|0;Z=l+432|0;_=c[f>>2]|0;$=ea(g[h>>2]);aa=ea(g[150280]);if(($==aa?($=ea(g[h+4>>2]),$==ea(g[150281])):0)?($=ea(g[h+8>>2]),$==ea(g[150282])):0){ba=0;i=l;return ba|0}$=ea(-aa);aa=ea(-ea(g[150282]));if((ea(g[h+12>>2])==$?($=ea(-ea(g[150281])),ea(g[h+16>>2])==$):0)?!(ea(g[h+20>>2])!=aa):0){ba=0;i=l;return ba|0}ca=_+212|0;do if((c[ca>>2]|0)==1){fa=(a[(c[d>>2]|0)+616>>0]|0)==0;c[d+720>>2]=3-(O4b(_)|0);if(fa){if(!(a[621167]|0))ga=1;else{fa=pyc()|0;ga=c[(c[fa+24>>2]|0)+((c[fa+40>>2]|0)*96|0)+28>>2]|0}c[d+612>>2]=ga;aa=ea(g[(c[d>>2]|0)+456>>2]);$=ea(g[d+580>>2]);g[d+616>>2]=aa;g[d+(ga<<2)+616>>2]=$;g[d+636>>2]=ea(0.0);g[d+(ga<<2)+636>>2]=ea(1.0);if((ga|0)==2){fa=pyc()|0;g[d+640>>2]=ea(g[(c[fa+24>>2]|0)+((c[fa+40>>2]|0)*96|0)+36>>2])}else if((ga|0)!=4){if((ga|0)<=1)break}else{fa=pyc()|0;ha=(c[fa+24>>2]|0)+((c[fa+40>>2]|0)*96|0)+40|0;g[d+640>>2]=ea(g[ha>>2]);g[d+644>>2]=ea(g[ha+4>>2]);g[d+648>>2]=ea(g[ha+8>>2])}ia=ea($-aa);ha=1;do{g[d+(ha<<2)+616>>2]=ea(aa+ea(ia*ea(g[d+(ha<<2)+636>>2])));ha=ha+1|0}while((ha|0)!=(ga|0))}else{ja=d;ka=18}}else{c[d+720>>2]=3-(O4b(_)|0);ja=d;ka=18}while(0);if((ka|0)==18){g[d+616>>2]=ea(g[(c[ja>>2]|0)+456>>2]);g[d+620>>2]=ea(g[d+580>>2]);g[d+636>>2]=ea(0.0);g[d+640>>2]=ea(1.0);c[d+612>>2]=1}ja=d+612|0;ga=c[ja>>2]|0;ha=ga+1|0;if((ha|0)<5){ia=ea(g[d+(ga<<2)+616>>2]);fa=ga;la=ha;while(1){ia=ea(ia*ea(1.00999999));g[d+(la<<2)+616>>2]=ia;g[d+(la<<2)+636>>2]=ea(ea(g[d+(fa<<2)+636>>2])*ea(1.00999999));ha=la+1|0;if((ha|0)==5)break;else{ma=la;la=ha;fa=ma}}na=c[ja>>2]|0}else na=ga;g[d+656>>2]=ea(0.0);g[d+660>>2]=ea(0.0);g[d+664>>2]=ea(0.0);g[d+668>>2]=ea(-x);g[d+672>>2]=ea(0.0);g[d+676>>2]=ea(0.0);g[d+680>>2]=ea(0.0);g[d+684>>2]=ea(-x);g[d+688>>2]=ea(0.0);g[d+692>>2]=ea(0.0);g[d+696>>2]=ea(0.0);g[d+700>>2]=ea(-x);g[d+704>>2]=ea(0.0);g[d+708>>2]=ea(0.0);g[d+712>>2]=ea(0.0);g[d+716>>2]=ea(-x);if((na|0)<4)PEi(k+(na<<6)|0,0,256-(na<<6)|0)|0;na=ync()|0;ia=ea(g[f+56>>2]);aa=ea(g[f+60>>2]);ga=c[(c[f>>2]|0)+212>>2]|0;$=ea(g[155249]);fa=$>=ea(480.0);if((ga|0)==1){la=fa?4096:2048;ma=c[155258]|0;ha=(la|0)<(ma|0)?la:ma;oa=ea(g[d+220>>2]);pa=ea(g[d+224>>2]);ma=~~ea(ea(~~(oa<pa?pa:oa)|0)*ea(3.79999995))+-1|0;la=ma>>>16|ma;ma=la>>>8|la;la=ma>>>4|ma;ma=la>>>2|la;la=(ma>>>1|ma)+1>>c[d+720>>2];if((la|0)<32)qa=32;else qa=(la|0)>(ha|0)?ha:la}else if(!ga){la=fa?2048:1024;ha=c[155258]|0;ma=(la|0)<(ha|0)?la:ha;oa=ea(ia*ea(g[d+220>>2]));pa=ea(aa*ea(g[d+224>>2]));ha=~~ea((oa<pa?pa:oa)*ea(2.0))+-1|0;la=ha>>>16|ha;ha=la>>>8|la;la=ha>>>4|ha;ha=la>>>2|la;la=(ha>>>1|ha)+1>>c[d+720>>2];if((la|0)<16)qa=16;else qa=(la|0)>(ma|0)?ma:la}else if((ga|0)==2){ga=fa?1024:512;fa=c[155257]|0;la=(ga|0)<(fa|0)?ga:fa;oa=ea(ia*ea(g[d+220>>2]));ia=ea(aa*ea(g[d+224>>2]));fa=~~(oa<ia?ia:oa)+-1|0;ga=fa>>>16|fa;fa=ga>>>8|ga;ga=fa>>>4|fa;fa=ga>>>2|ga;ga=(fa>>>1|fa)+1>>c[d+720>>2];if((ga|0)<16)qa=16;else qa=(ga|0)>(la|0)?la:ga}else qa=128;do if((c[ca>>2]|0)==2){if(!(a[621159]|0)){ba=0;i=l;return ba|0}if(a[621140]|0){if(!(a[621118]|0))ba=0;else{ra=1;sa=0;ta=qa;break}i=l;return ba|0}ga=b[310566]|0;if(!((ga&255)<<24>>24))if(!(a[621130]|0))if((ga&65535)<256){ba=0;i=l;return ba|0}else{ra=1;sa=15;ta=qa}else{ra=1;sa=12;ta=qa}else{ra=1;sa=14;ta=qa}}else{if((c[ja>>2]|0)==2)ua=(qa|0)/2|0;else ua=qa;ra=0;sa=(a[621166]|0)!=0?3:1;ta=ua}while(0);ua=~~ea($*ea(1024.0));ga=c[na+5472>>2]|0;la=na+5480|0;fa=_Ei(ga|0,((ga|0)<0)<<31>>31|0,c[la>>2]|0,c[la+4>>2]|0)|0;la=eFi(fa|0,H|0,1024,0)|0;fa=~~ea(ea(ua-la|0)*ea(.300000012));la=ra?4:2;ua=ta;ta=qa;while(1){if(((PBc(ta,ua,1,sa,1,la,0)|0)/1024|0|0)<(fa|0)){va=ua;wa=ta;break}qa=(ta|0)/2|0;ga=(ua|0)/2|0;if((ta|0)>9&(ua|0)>9){ua=ga;ta=qa}else{va=ga;wa=qa;break}}if((wa|0)<5|(va|0)<5){ba=0;i=l;return ba|0}ta=Hzc(Gzc()|0,wa,va,1,sa,ra&1,1,1)|0;if(ta)In[c[(c[ta>>2]|0)+36>>2]&4095](ta,2510152);ra=(sa|0)==3;if(!(a[621196]|0)){if(!(a[621167]|0))xa=ra&(c[_+116>>2]|0)>1;else xa=ra;ya=(a[621193]|0)==0&xa}else ya=ra;c[ta+28>>2]=ya&1;ko[c[(c[ta>>2]|0)+132>>2]&4095](ta);if(!(uBc(ta)|0)){Jzc(Gzc()|0,ta);ba=0;i=l;return ba|0}ya=L+12|0;ra=L+16|0;xa=L+20|0;c[L+0>>2]=0;c[L+4>>2]=0;c[L+8>>2]=0;c[L+12>>2]=0;c[L+16>>2]=0;c[L+0>>2]=c[150280];c[L+4>>2]=c[150281];c[L+8>>2]=c[150282];$=ea(-ea(g[150280]));oa=ea(-ea(g[150281]));ia=ea(-ea(g[150282]));g[ya>>2]=$;g[ra>>2]=oa;g[xa>>2]=ia;c[M>>2]=0;sa=M+4|0;c[sa>>2]=0;ua=M+8|0;c[ua>>2]=0;c[N>>2]=0;fa=N+4|0;c[fa>>2]=0;la=N+8|0;c[la>>2]=0;c[n>>2]=89;c[m+0>>2]=c[n+0>>2];qa=cOb(1536,16,m,0,3653512,80)|0;ga=c[M>>2]|0;ma=(c[sa>>2]|0)-ga|0;ha=qa+(((ma|0)/-24|0)*24|0)|0;YEi(ha|0,ga|0,ma|0)|0;ma=c[M>>2]|0;c[M>>2]=ha;c[sa>>2]=qa;c[ua>>2]=qa+1536;if(ma){c[K>>2]=89;c[m+0>>2]=c[K+0>>2];eOb(ma,m)}ma=c[N>>2]|0;if((c[la>>2]|0)-ma>>4>>>0<64?(K=(c[fa>>2]|0)-ma>>4,c[n>>2]=89,c[m+0>>2]=c[n+0>>2],ma=cOb(1024,16,m,0,3653512,80)|0,qa=c[N>>2]|0,ha=(c[fa>>2]|0)-qa|0,ga=ma+(K-(ha>>4)<<4)|0,YEi(ga|0,qa|0,ha|0)|0,ha=c[N>>2]|0,c[N>>2]=ga,c[fa>>2]=ma+(K<<4),c[la>>2]=ma+1024,(ha|0)!=0):0){c[J>>2]=89;c[m+0>>2]=c[J+0>>2];eOb(ha,m)}ha=f+4|0;f=c[ha>>2]|0;J=f+72|0;if(!(c[J>>2]|0))za=f;else{Gnd(J);za=c[ha>>2]|0}ha=kbc()|0;J=za+4|0;f=d+600|0;ma=(c[f>>2]|0)+608|0;K=0;do{ga=c[ha+(K<<2)+1024>>2]|0;if(ga)In[ga&4095](J,ma);K=K+1|0}while((K|0)!=16);K=(c[ca>>2]|0)==1;ma=c[f>>2]|0;J=d+364|0;ha=d+604|0;ga=d+608|0;qa=p+8|0;Aa=p+4|0;Ba=p+12|0;Ca=q+4|0;Da=q+16|0;Ea=q+8|0;Fa=q+12|0;Ga=q+20|0;Ha=L+4|0;Ia=L+8|0;Ja=0;do{Ka=za+(Ja*12|0)+8|0;if((c[Ka>>2]|0)>0){La=za+(Ja*12|0)+4|0;Ma=ma+(Ja*12|0)+608|0;Na=ma+(Ja*12|0)+612|0;Oa=0;do{Pa=c[(c[La>>2]|0)+(Oa<<2)>>2]|0;if(K)Qa=pmc((c[Ma>>2]|0)+(Pa*24|0)|0,J)|0;else Qa=0;Ra=c[Na>>2]|0;Sa=Ra+(Pa*24|0)|0;Ta=c[Ma>>2]|0;Ua=Ta+(Pa*24|0)|0;Va=c[Sa>>2]|0;Wa=(c[fa>>2]|0)-(c[N>>2]|0)>>4;Xa=mo[c[(c[Va>>2]|0)+36>>2]&4095](Va)|0;Ya=c[ha>>2]|0;Za=c[ga>>2]|0;if((Xa|0)>0){_a=(Ya|0)!=0;$a=0;do{co[c[(c[Va>>2]|0)+40>>2]&2047](n,Va,$a);ab=c[n>>2]|0;do if(ab){c[I>>2]=ab;bb=c[137784]|0;do if(bb){do if((c[bb+36>>2]|0)!=(c[bb+4>>2]|0)){fRb(m,bb,I);cb=c[m>>2]|0;db=c[bb+28>>2]|0;if((cb|0)==-1){eb=db+(c[bb+32>>2]<<3)|0;break}else{eb=db+(cb<<3)|0;break}}else eb=(c[bb+28>>2]|0)+(c[bb+32>>2]<<3)|0;while(0);cb=c[137784]|0;if((eb|0)==((c[cb+28>>2]|0)+(c[cb+32>>2]<<3)|0)){ka=81;break}cb=c[eb+4>>2]|0;if(cb)fb=cb;else ka=81}else ka=81;while(0);if((ka|0)==81){ka=0;bb=hQb(c[n>>2]|0)|0;if(!bb)break;else fb=bb}bb=hkd(fb)|0;cb=_a?Ya:bb;db=w8b(bb,Ya,Za)|0;if((db|0)<0)break;if(!(Gld(cb,db,o)|0))break;c[p>>2]=_n[c[(c[Va>>2]|0)+44>>2]&4095](Va,$a)|0;c[qa>>2]=cb;c[Aa>>2]=db;c[Ba>>2]=fb;db=c[fa>>2]|0;if((db|0)==(c[la>>2]|0)){S9b(N,p);break}if(!db)gb=0;else{c[db+0>>2]=c[p+0>>2];c[db+4>>2]=c[p+4>>2];c[db+8>>2]=c[p+8>>2];c[db+12>>2]=c[p+12>>2];gb=db}c[fa>>2]=gb+16}while(0);$a=$a+1|0}while(($a|0)!=(Xa|0))}Xa=(c[fa>>2]|0)-(c[N>>2]|0)>>4;do if((Xa|0)!=(Wa|0)){c[q>>2]=Sa;c[Ca>>2]=Ua;c[Da>>2]=1;c[Ea>>2]=Wa;c[Fa>>2]=Xa;$a=e[Ra+(Pa*24|0)+12>>1]|0;Va=c[(c[f>>2]|0)+668>>2]|0;g[Ga>>2]=ea(huc(e[Ra+(Pa*24|0)+14>>1]|0,c[Ra+(Pa*24|0)+16>>2]|0,c[Va+($a*12|0)>>2]|0,c[Va+($a*12|0)+4>>2]|0));$a=c[sa>>2]|0;if(($a|0)==(c[ua>>2]|0))T9b(M,q);else{if(!$a)hb=0;else{c[$a+0>>2]=c[q+0>>2];c[$a+4>>2]=c[q+4>>2];c[$a+8>>2]=c[q+8>>2];c[$a+12>>2]=c[q+12>>2];c[$a+16>>2]=c[q+16>>2];c[$a+20>>2]=c[q+20>>2];hb=$a}c[sa>>2]=hb+24}if(!Qa)break;ia=ea(g[Ua>>2]);$a=Ta+(Pa*24|0)+12|0;oa=ea(ia+ea(g[$a>>2]));Va=Ta+(Pa*24|0)+4|0;ia=ea(g[Va>>2]);Za=Ta+(Pa*24|0)+16|0;$=ea(ia+ea(g[Za>>2]));Ya=Ta+(Pa*24|0)+8|0;ia=ea(g[Ya>>2]);_a=Ta+(Pa*24|0)+20|0;aa=ea(ia+ea(g[_a>>2]));ia=ea(g[L>>2]);pa=oa<ia?oa:ia;ia=ea(g[Ha>>2]);ib=$<ia?$:ia;ia=ea(g[Ia>>2]);jb=aa<ia?aa:ia;g[L>>2]=pa;g[Ha>>2]=ib;g[Ia>>2]=jb;ia=ea(g[ya>>2]);kb=ia<oa?oa:ia;ia=ea(g[ra>>2]);oa=ia<$?$:ia;ia=ea(g[xa>>2]);$=ia<aa?aa:ia;g[ya>>2]=kb;g[ra>>2]=oa;g[xa>>2]=$;ia=ea(g[Ua>>2]);aa=ea(ia-ea(g[$a>>2]));ia=ea(g[Va>>2]);lb=ea(ia-ea(g[Za>>2]));ia=ea(g[Ya>>2]);mb=ea(ia-ea(g[_a>>2]));g[L>>2]=aa<pa?aa:pa;g[Ha>>2]=lb<ib?lb:ib;g[Ia>>2]=mb<jb?mb:jb;g[ya>>2]=kb<aa?aa:kb;g[ra>>2]=oa<lb?lb:oa;g[xa>>2]=$<mb?mb:$}while(0);Oa=Oa+1|0}while((Oa|0)<(c[Ka>>2]|0))}Ja=Ja+1|0}while((Ja|0)!=5);if((c[sa>>2]|0)==(c[M>>2]|0)){Jzc(Gzc()|0,ta);nb=0}else{Ja=ync()|0;Qa=mo[c[(c[Ja>>2]|0)+92>>2]&4095](Ja)|0;In[c[(c[Ja>>2]|0)+88>>2]&4095](Ja,0);$=ea(g[L>>2]);mb=ea(g[150280]);if(($==mb?($=ea(g[Ha>>2]),$==ea(g[150281])):0)?($=ea(g[Ia>>2]),$==ea(g[150282])):0)ka=107;else ka=105;if(((ka|0)==105?($=ea(-mb),ea(g[ya>>2])==$):0)?($=ea(-ea(g[150282])),mb=ea(-ea(g[150281])),Ja=ea(g[ra>>2])!=mb,!(Ja|ea(g[xa>>2])!=$)):0)ka=107;if((ka|0)==107){c[L+0>>2]=c[h+0>>2];c[L+4>>2]=c[h+4>>2];c[L+8>>2]=c[h+8>>2];c[L+12>>2]=c[h+12>>2];c[L+16>>2]=c[h+16>>2];c[L+20>>2]=c[h+20>>2]}Ja=_+24|0;hb=BTb(c[Ja>>2]|0)|0;rGc(O,hb);oGc(P,hb);$=ea(g[P>>2]);mb=ea($*ea(2.0));oa=ea(g[P+4>>2]);lb=ea(oa*ea(2.0));kb=ea(g[P+8>>2]);aa=ea(kb*ea(2.0));jb=ea($*mb);ib=ea(oa*lb);pa=ea(kb*aa);kb=ea($*lb);ia=ea($*aa);$=ea(oa*aa);oa=ea(g[P+12>>2]);ob=ea(mb*oa);mb=ea(lb*oa);lb=ea(oa*aa);ua=Q+4|0;Ga=Q+8|0;g[Q>>2]=ea(ea(ia+mb)+ea(ea(ea(kb-lb)*ea(0.0))+ea(ea(ea(1.0)-ea(ib+pa))*ea(0.0))));g[ua>>2]=ea(ea($-ob)+ea(ea(ea(kb+lb)*ea(0.0))+ea(ea(ea(1.0)-ea(jb+pa))*ea(0.0))));g[Ga>>2]=ea(ea(ea(1.0)-ea(jb+ib))+ea(ea(ea(ia-mb)*ea(0.0))+ea(ea($+ob)*ea(0.0))));f=(a[na+5973>>0]|0)!=0;In[c[(c[na>>2]|0)+80>>2]&4095](na,(c[ca>>2]|0)==2);Fa=c[ca>>2]|0;do if((Fa|0)==2){ob=ea(g[O>>2]);ca=O+4|0;$=ea(g[ca>>2]);Ea=O+8|0;mb=ea(g[Ea>>2]);Da=_+184|0;ia=ea(ea(1.0)/ea(g[Da>>2]));g[na+644>>2]=ob;g[na+648>>2]=$;g[na+652>>2]=mb;g[na+656>>2]=ia;ia=ea(g[O>>2]);mb=ea(g[ca>>2]);$=ea(g[Ea>>2]);g[na+532>>2]=ia;g[na+536>>2]=mb;g[na+540>>2]=$;g[na+544>>2]=ea(1.0);Ca=R+4|0;gb=R+8|0;la=R+12|0;fb=p+4|0;Ba=p+8|0;Aa=j+20|0;qa=q+4|0;eb=q+8|0;I=q+12|0;ga=0;do{oBc(ta,0,ga,12);g[R>>2]=ea(1.0);g[Ca>>2]=ea(1.0);g[gb>>2]=ea(1.0);g[la>>2]=ea(1.0);Uvc(7,R,ea(1.0),0,j);$=ea(g[Da>>2]);ha=ync()|0;J=ga*3|0;gMc(m,565288+(J*12|0)|0,565288+((J+1|0)*12|0)|0,565288+((J+2|0)*12|0)|0)|0;mb=ea(g[O>>2]);ia=ea(g[ca>>2]);ob=ea(-ia);ia=ea(-ea(g[Ea>>2]));g[p>>2]=ea(-mb);g[fb>>2]=ob;g[Ba>>2]=ia;kMc(o,p)|0;cMc(m,o)|0;ia=ea($*ea(.00999999977));J=ia>ea(.00999999977);ob=J?ea(.00999999977):ia;ia=ea($*ea(1.00999999));mMc(n,ea(90.0),ea(1.0),ob,ia)|0;In[c[(c[ha>>2]|0)+108>>2]&4095](ha,n);In[c[(c[ha>>2]|0)+104>>2]&4095](ha,m);s1b(ync()|0);dMc(n,m,r);g[q>>2]=ea(0.0);g[qa>>2]=ob;g[eb>>2]=ia;g[I>>2]=ea(0.0);oud(Aa,565160,q);g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);g[m+16>>2]=ea(0.0);g[m+20>>2]=ea(0.0);g[m+24>>2]=ea(0.0);g[m+32>>2]=ea(0.0);g[m+36>>2]=ea(0.0);g[m+40>>2]=ea(0.0);g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(0.0);g[m+56>>2]=ea(0.0);g[m+64>>2]=ea(0.0);g[m+68>>2]=ea(0.0);g[m+72>>2]=ea(0.0);g[m+80>>2]=ea(0.0);g[m+84>>2]=ea(0.0);g[m+88>>2]=ea(0.0);r1b(r,m);ha=c[M>>2]|0;J=(c[sa>>2]|0)-ha|0;K=(J|0)/24|0;a:do if((J|0)>0){ma=ha;za=0;while(1){c[ma+(za*24|0)+16>>2]=(omc(c[ma+(za*24|0)+4>>2]|0,m,15)|0)&1;Ka=za+1|0;if((Ka|0)>=(K|0))break a;ma=c[M>>2]|0;za=Ka}}while(0);U9b(0,M,N,d,j);ga=ga+1|0}while((ga|0)<6)}else if((Fa|0)==1){ia=ea(g[Q>>2]);ob=ea(g[ua>>2]);$=ea(g[Ga>>2]);g[na+532>>2]=ia;g[na+536>>2]=ob;g[na+540>>2]=$;g[na+544>>2]=ea(0.0);oBc(ta,0,-1,12);g[S>>2]=ea(1.0);g[S+4>>2]=ea(1.0);g[S+8>>2]=ea(1.0);g[S+12>>2]=ea(1.0);Uvc(7,S,ea(1.0),0,j);ga=c[ja>>2]|0;if((ga|0)==4){pb=2;qb=2}else if((ga|0)==2|(ga|0)==1){pb=ga;qb=1}else{pb=1;qb=1}c[U>>2]=0;ga=(wa|0)/(pb|0)|0;g[V+324>>2]=ea(0.0);g[V+328>>2]=ea(0.0);g[V+332>>2]=ea(0.0);g[V+340>>2]=ea(0.0);g[V+344>>2]=ea(0.0);g[V+688>>2]=ea(0.0);g[V+692>>2]=ea(0.0);g[V+696>>2]=ea(0.0);g[V+704>>2]=ea(0.0);g[V+708>>2]=ea(0.0);g[V+1052>>2]=ea(0.0);g[V+1056>>2]=ea(0.0);g[V+1060>>2]=ea(0.0);g[V+1068>>2]=ea(0.0);g[V+1072>>2]=ea(0.0);g[V+1416>>2]=ea(0.0);g[V+1420>>2]=ea(0.0);g[V+1424>>2]=ea(0.0);g[V+1432>>2]=ea(0.0);g[V+1436>>2]=ea(0.0);Aa=(va|0)/(qb|0)|0;I=(pb|0)>0;eb=d+588|0;qa=d+580|0;Ba=d+584|0;fb=m+16|0;Ea=m+32|0;ca=m+48|0;Da=m+4|0;la=m+20|0;gb=m+36|0;Ca=m+52|0;K=m+8|0;ha=m+24|0;J=m+40|0;za=m+56|0;ma=m+12|0;Ka=m+28|0;Oa=m+44|0;Ma=m+60|0;$=ea(g[150276]);Na=q+4|0;La=q+8|0;Ua=s+4|0;Pa=s+8|0;Ta=u+4|0;Ra=u+8|0;Xa=w+4|0;Wa=w+8|0;Sa=z+4|0;_a=z+8|0;Ya=y+4|0;Za=y+8|0;Va=A+4|0;$a=A+8|0;ob=ea(ga|0);ia=ea(Aa|0);ab=t+4|0;db=t+8|0;cb=v+4|0;bb=v+8|0;rb=G+20|0;sb=G+40|0;tb=G+48|0;ub=G+52|0;vb=G+56|0;wb=D+4|0;xb=D+8|0;yb=F+16|0;zb=F+32|0;Ab=F+48|0;Bb=F+4|0;Cb=F+20|0;Db=F+36|0;Eb=F+52|0;Fb=F+8|0;Gb=F+24|0;Hb=F+40|0;Ib=F+56|0;Jb=d+4|0;Kb=0;Lb=0;while(1){if(I){Mb=Kb;Nb=0;while(1){Ob=V+(Mb*364|0)+260|0;ZLc(Ob)|0;Pb=V+(Mb*364|0)+324|0;c[Pb+0>>2]=c[150284];c[Pb+4>>2]=c[150285];c[Pb+8>>2]=c[150286];Qb=V+(Mb*364|0)+336|0;g[Qb>>2]=ea(-1.0e9);Rb=Ob+0|0;Sb=601008;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0));Ub=c[d>>2]|0;mb=ea(g[eb>>2]);ib=ea(g[qa>>2]);Vb=pyc()|0;Wb=c[(c[Vb+24>>2]|0)+((c[Vb+40>>2]|0)*96|0)+24>>2]|0;Vb=(Wb|0)==1;if(Vb){jb=ea(g[Ba>>2]);x0b(Ub,jb,ea(g[eb>>2]),n);qMc(n,m)|0;jb=ea(g[m>>2]);pa=ea(jb+ea(g[fb>>2]));jb=ea(pa+ea(g[Ea>>2]));pa=ea(ea(g[ca>>2])+jb);jb=ea(g[Da>>2]);lb=ea(jb+ea(g[la>>2]));jb=ea(lb+ea(g[gb>>2]));lb=ea(ea(g[Ca>>2])+jb);jb=ea(g[K>>2]);kb=ea(jb+ea(g[ha>>2]));jb=ea(kb+ea(g[J>>2]));kb=ea(ea(g[za>>2])+jb);jb=ea(g[ma>>2]);aa=ea(jb+ea(g[Ka>>2]));jb=ea(aa+ea(g[Oa>>2]));aa=ea(ea(g[Ma>>2])+jb);if(aa<ea(0.0))Xb=ea(-aa);else Xb=aa;if(Xb>ea(1.00000001e-07)){jb=ea(ea(1.0)/aa);Yb=ea(kb*jb);Zb=ea(lb*jb);_b=ea(pa*jb)}else{Yb=ea(0.0);Zb=ea(0.0);_b=ea(0.0)}jb=ea(ea(T(ea(ea(ea(_b*_b)+ea(Zb*Zb))+ea(Yb*Yb))))/mb);pa=ea(v9b(Ub));lb=ea(ea(1.0)-pa);kb=ea(jb*jb);$b=ea(ea(pa+ea(T(ea(ea(pa*pa)+ea(ea(lb*ea(kb*lb))-ea(pa*ea(kb*pa)))))))/kb);ac=m}else{$b=ea(1.0);ac=Jb}kb=ea(g[Ba>>2]);pa=ea(mb-kb);mb=ea(ea(ea(ib*$b)-kb)/pa);do if(!(mb<=$)){Rb=o+0|0;Tb=Rb+96|0;do{c[Rb>>2]=0;Rb=Rb+4|0}while((Rb|0)<(Tb|0));$lc(ac,o);bc=d+(Mb<<2)+636|0;Rb=p+0|0;Tb=Rb+96|0;do{c[Rb>>2]=0;Rb=Rb+4|0}while((Rb|0)<(Tb|0));lb=ea(mb*ea(g[bc>>2]));cc=Mb+1|0;jb=ea(mb*ea(g[d+(cc<<2)+636>>2]));g[V+(Mb*364|0)+348>>2]=ea(kb+ea(pa*lb));dc=V+(Mb*364|0)+352|0;g[dc>>2]=ea(kb+ea(pa*jb));amc(o,lb,jb,p);c[q>>2]=0;c[Na>>2]=0;c[La>>2]=0;ec=(Wb|0)==0;do if(ec){g[s>>2]=ea(0.0);g[Ua>>2]=ea(0.0);g[Pa>>2]=ea(1.0);TGc(r,hb,s);cmc(p,r,h,q);if((c[q>>2]|0)!=(c[Na>>2]|0)){ka=130;break}ZLc(V+(Mb*364|0)+4|0)|0;oMc(V+(Mb*364|0)+132|0,ea(-1.0),ea(1.0),ea(-1.0),ea(1.0),ea(.100000001),ea(10.0))|0;fc=0}else ka=130;while(0);if((ka|0)==130){ka=0;jb=ea(g[ya>>2]);lb=ea(g[L>>2]);aa=ea(jb+lb);oa=ea(g[ra>>2]);gc=ea(g[Ha>>2]);hc=ea(oa+gc);ic=ea(g[xa>>2]);jc=ea(g[Ia>>2]);kc=ea(aa*ea(.5));aa=ea(hc*ea(.5));hc=ea(ea(ic+jc)*ea(.5));lc=ea(jb-lb);lb=ea(oa-gc);gc=ea(ic-jc);jc=ea(ea(T(ea(ea(ea(lc*lc)+ea(lb*lb))+ea(gc*gc))))*ea(.5));g[u>>2]=ea(1.0);g[Ta>>2]=ea(0.0);g[Ra>>2]=ea(0.0);TGc(t,hb,u);g[w>>2]=ea(0.0);g[Xa>>2]=ea(1.0);g[Wa>>2]=ea(0.0);TGc(v,hb,w);g[z>>2]=ea(0.0);g[Sa>>2]=ea(0.0);g[_a>>2]=ea(1.0);TGc(y,hb,z);gc=ea(jc*ea(g[y>>2]));lb=ea(jc*ea(g[Ya>>2]));lc=ea(aa-ea(lb*ea(1.20000005)));lb=ea(hc-ea(ea(jc*ea(g[Za>>2]))*ea(1.20000005)));g[A>>2]=ea(kc-ea(gc*ea(1.20000005)));g[Va>>2]=lc;g[$a>>2]=lb;bc=V+(Mb*364|0)+4|0;hMc(bc,A,t,v,y)|0;Vlc(B,L,h);Rb=C+0|0;Tb=Rb+96|0;do{c[Rb>>2]=0;Rb=Rb+4|0}while((Rb|0)<(Tb|0));Slc(B,C);mc=V+(Mb*364|0)+52|0;lb=ea(g[mc>>2]);nc=V+(Mb*364|0)+56|0;lc=ea(g[nc>>2]);oc=V+(Mb*364|0)+60|0;gc=ea(g[oc>>2]);pc=V+(Mb*364|0)+36|0;kc=ea(g[pc>>2]);qc=V+(Mb*364|0)+40|0;jc=ea(g[qc>>2]);rc=V+(Mb*364|0)+44|0;hc=ea(g[rc>>2]);aa=ea(x);ic=ea(-x);sc=0;while(1){oa=ea(ea(g[C+(sc*12|0)>>2])-lb);jb=ea(ea(g[C+(sc*12|0)+4>>2])-lc);tc=ea(ea(ea(kc*oa)+ea(jc*jb))+ea(hc*ea(ea(g[C+(sc*12|0)+8>>2])-gc)));jb=aa<tc?aa:tc;oa=tc<ic?ic:tc;sc=sc+1|0;if((sc|0)==8){uc=jb;vc=oa;break}else{aa=jb;ic=oa}}ic=ea(ea(uc+vc)*ea(.5));aa=ea(ea(vc-uc)*ea(.5));hc=ea(g[150280]);jc=ea(g[150281]);kc=ea(g[150282]);oa=ea(-hc);jb=ea(-jc);tc=ea(-kc);do if(!ec)if(Vb){g[D>>2]=ea(0.0);g[wb>>2]=ea(0.0);g[xb>>2]=ea(0.0);dmc(p,D,E);wc=ea(g[xb>>2]);if(wc<ea(0.0))xc=ea(-wc);else xc=wc;wc=ea(xc+ea(g[E>>2]));g[dc>>2]=ib<wc?ib:wc;L$b(F,Ub);wc=ea(g[F>>2]);yc=ea(g[D>>2]);zc=ea(wc*yc);wc=ea(g[yb>>2]);Ac=ea(g[wb>>2]);Bc=ea(zc+ea(wc*Ac));wc=ea(g[zb>>2]);zc=ea(g[xb>>2]);Cc=ea(Bc+ea(wc*zc));wc=ea(ea(g[Ab>>2])+Cc);Cc=ea(yc*ea(g[Bb>>2]));Bc=ea(Cc+ea(Ac*ea(g[Cb>>2])));Cc=ea(Bc+ea(zc*ea(g[Db>>2])));Bc=ea(ea(g[Eb>>2])+Cc);Cc=ea(yc*ea(g[Fb>>2]));yc=ea(Cc+ea(Ac*ea(g[Gb>>2])));Ac=ea(yc+ea(zc*ea(g[Hb>>2])));zc=ea(ea(g[Ib>>2])+Ac);g[D>>2]=wc;g[wb>>2]=Bc;g[xb>>2]=zc;Ac=ea(g[E>>2]);c[Pb+0>>2]=c[D+0>>2];c[Pb+4>>2]=c[D+4>>2];c[Pb+8>>2]=c[D+8>>2];g[Qb>>2]=Ac;yc=ea(g[mc>>2]);Cc=ea(wc-yc);wc=ea(g[nc>>2]);Dc=ea(Bc-wc);Bc=ea(g[oc>>2]);Ec=ea(zc-Bc);zc=ea(Cc*ea(g[bc>>2]));Fc=ea(zc+ea(Dc*ea(g[V+(Mb*364|0)+8>>2])));zc=ea(Fc+ea(Ec*ea(g[V+(Mb*364|0)+12>>2])));Fc=ea(Cc*ea(g[V+(Mb*364|0)+20>>2]));Cc=ea(Fc+ea(Dc*ea(g[V+(Mb*364|0)+24>>2])));Dc=ea(Cc+ea(Ec*ea(g[V+(Mb*364|0)+28>>2])));Ec=ea(Ac*ea(2.0));Gc=Ec;Hc=Ec;Ic=ea(Ac+(zc>oa?zc:oa));Jc=ea((zc<hc?zc:hc)-Ac);Kc=ea(Ac+(Dc>jb?Dc:jb));Lc=ea((Dc<jc?Dc:jc)-Ac);Mc=ea((ic>tc?ic:tc)+Ac);Nc=ea((ic<kc?ic:kc)-Ac);Oc=yc;Pc=wc;Qc=Bc;break}else{Bc=ea(g[bc>>2]);wc=ea(g[V+(Mb*364|0)+8>>2]);yc=ea(g[V+(Mb*364|0)+12>>2]);Ac=ea(g[V+(Mb*364|0)+20>>2]);Dc=ea(g[V+(Mb*364|0)+24>>2]);zc=ea(g[V+(Mb*364|0)+28>>2]);Ec=hc;Cc=jc;Fc=kc;Rc=oa;Sc=jb;Tc=tc;sc=0;while(1){Uc=ea(ea(g[p+(sc*12|0)>>2])-lb);Vc=ea(ea(g[p+(sc*12|0)+4>>2])-lc);Wc=ea(ea(g[p+(sc*12|0)+8>>2])-gc);Xc=ea(ea(ea(Bc*Uc)+ea(wc*Vc))+ea(yc*Wc));Yc=ea(ea(ea(Ac*Uc)+ea(Dc*Vc))+ea(zc*Wc));Wc=Xc<Ec?Xc:Ec;Vc=Yc<Cc?Yc:Cc;Uc=ic<Fc?ic:Fc;Zc=Rc<Xc?Xc:Rc;Xc=Sc<Yc?Yc:Sc;Yc=Tc<ic?ic:Tc;sc=sc+1|0;if((sc|0)==8){_c=Wc;$c=Vc;ad=Uc;bd=Zc;cd=Xc;dd=Yc;break}else{Ec=Wc;Cc=Vc;Fc=Uc;Rc=Zc;Sc=Xc;Tc=Yc}}Gc=ea(bd-_c);Hc=ea(cd-$c);Ic=bd;Jc=_c;Kc=cd;Lc=$c;Mc=dd;Nc=ad;Oc=lb;Pc=lc;Qc=gc;break}else{sc=c[Na>>2]|0;ed=c[q>>2]|0;if((sc|0)==(ed|0)){fd=tc;gd=jb;hd=oa;id=kc;jd=jc;kd=hc}else{Tc=ea(g[bc>>2]);Sc=ea(g[V+(Mb*364|0)+8>>2]);Rc=ea(g[V+(Mb*364|0)+12>>2]);Fc=ea(g[V+(Mb*364|0)+20>>2]);Cc=ea(g[V+(Mb*364|0)+24>>2]);Ec=ea(g[V+(Mb*364|0)+28>>2]);ld=(sc-ed|0)/12|0;zc=hc;Dc=jc;Ac=kc;yc=oa;wc=jb;Bc=tc;sc=0;while(1){Yc=ea(ea(g[ed+(sc*12|0)>>2])-lb);Xc=ea(ea(g[ed+(sc*12|0)+4>>2])-lc);Zc=ea(ea(g[ed+(sc*12|0)+8>>2])-gc);Uc=ea(ea(ea(Tc*Yc)+ea(Sc*Xc))+ea(Rc*Zc));Vc=ea(ea(ea(Fc*Yc)+ea(Cc*Xc))+ea(Ec*Zc));Zc=Uc<zc?Uc:zc;Xc=Vc<Dc?Vc:Dc;Yc=ic<Ac?ic:Ac;Wc=yc<Uc?Uc:yc;Uc=wc<Vc?Vc:wc;Vc=Bc<ic?ic:Bc;sc=sc+1|0;if(sc>>>0>=ld>>>0){fd=Vc;gd=Uc;hd=Wc;id=Yc;jd=Xc;kd=Zc;break}else{zc=Zc;Dc=Xc;Ac=Yc;yc=Wc;wc=Uc;Bc=Vc}}}Gc=ea(hd-kd);Hc=ea(gd-jd);Ic=hd;Jc=kd;Kc=gd;Lc=jd;Mc=fd;Nc=id;Oc=lb;Pc=lc;Qc=gc}while(0);if((c[ja>>2]|0)>1){md=ea(Gc+ea(ea(Gc/ob)*ea(10.0)));nd=ea(Hc+ea(ea(Hc/ia)*ea(10.0)))}else{md=Gc;nd=Hc}gc=ea(ea(Ic+Jc)*ea(.5));lc=ea(ea(Kc+Lc)*ea(.5));lb=ea(ea(Mc+Nc)*ea(.5));ic=ea(md*ea(.5));tc=ea(nd*ea(.5));jb=ea(md/ob);oa=ea(nd/ia);g[V+(Mb*364|0)+340>>2]=jb;g[V+(Mb*364|0)+344>>2]=oa;kc=ea(gc*ea(g[bc>>2]));jc=ea(kc+ea(lc*ea(g[V+(Mb*364|0)+20>>2])));kc=ea(Oc+ea(jc+ea(lb*ea(g[pc>>2]))));jc=ea(gc*ea(g[V+(Mb*364|0)+8>>2]));hc=ea(jc+ea(lc*ea(g[V+(Mb*364|0)+24>>2])));jc=ea(Pc+ea(hc+ea(lb*ea(g[qc>>2]))));hc=ea(gc*ea(g[V+(Mb*364|0)+12>>2]));gc=ea(hc+ea(lc*ea(g[V+(Mb*364|0)+28>>2])));lc=ea(Qc+ea(gc+ea(lb*ea(g[rc>>2]))));lb=ea(g[t>>2]);od=+kc;gc=ea(g[ab>>2]);pd=+jc;hc=ea(g[db>>2]);qd=+lc;Bc=ea(g[v>>2]);wc=ea(g[cb>>2]);yc=ea(g[bb>>2]);Ac=ea(+WDi(od*+lb+pd*+gc+qd*+hc,+jb));jb=ea(lb*Ac);lb=ea(gc*Ac);gc=ea(hc*Ac);Ac=ea(+WDi(od*+Bc+pd*+wc+qd*+yc,+oa));oa=ea(ea(kc-jb)-ea(Bc*Ac));Bc=ea(ea(jc-lb)-ea(wc*Ac));wc=ea(ea(lc-gc)-ea(yc*Ac));Ac=ea(aa*ea(g[y>>2]));yc=ea(aa*ea(g[Ya>>2]));gc=ea(yc*ea(1.10000002));yc=ea(ea(aa*ea(g[Za>>2]))*ea(1.10000002));lc=ea(oa-ea(Ac*ea(1.10000002)));g[A>>2]=lc;Ac=ea(Bc-gc);g[Va>>2]=Ac;gc=ea(wc-yc);g[$a>>2]=gc;g[mc>>2]=lc;g[nc>>2]=Ac;g[oc>>2]=gc;gc=ea(aa*ea(.100000001));g[V+(Mb*364|0)+356>>2]=gc;Ac=ea(aa*ea(2.20000005));g[V+(Mb*364|0)+360>>2]=Ac;dc=V+(Mb*364|0)+132|0;oMc(dc,ea(-ic),ic,ea(-tc),tc,gc,Ac)|0;ec=V+(Mb*364|0)+68|0;Rb=ec+0|0;Sb=bc+0|0;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0));bc=V+(Mb*364|0)+100|0;aa=ea(g[bc>>2]);oc=V+(Mb*364|0)+104|0;Ac=ea(g[oc>>2]);nc=V+(Mb*364|0)+108|0;gc=ea(-Ac);Ac=ea(-ea(g[nc>>2]));g[bc>>2]=ea(-aa);g[oc>>2]=gc;g[nc>>2]=Ac;qMc(ec,ec)|0;Rb=G+0|0;Sb=601008;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0));g[G>>2]=ea(.5);g[rb>>2]=ea(.5);g[sb>>2]=ea(.5);g[tb>>2]=ea(.5);g[ub>>2]=ea(.5);g[vb>>2]=ea(.5);nc=V+(Mb*364|0)+196|0;dMc(dc,ec,nc);dMc(G,nc,Ob);fc=1}nc=c[q>>2]|0;if(!nc){rd=fc;sd=cc;break}oc=c[Na>>2]|0;if((oc|0)!=(nc|0))c[Na>>2]=oc+(~(((oc+-12-nc|0)>>>0)/12|0)*12|0);ACi(nc);rd=fc;sd=cc}else{rd=0;sd=Mb+1|0}while(0);a[V+(Mb*364|0)>>0]=rd&1;Rb=k+(Mb<<6)+0|0;Sb=Ob+0|0;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0));ib=ea(g[Qb>>2]);pa=ea(ib*ib);ib=ea(g[Pb>>2]);kb=ea(g[V+(Mb*364|0)+328>>2]);mb=ea(g[V+(Mb*364|0)+332>>2]);g[d+(Mb<<4)+656>>2]=ib;g[d+(Mb<<4)+660>>2]=kb;g[d+(Mb<<4)+664>>2]=mb;g[d+(Mb<<4)+668>>2]=pa;Nb=Nb+1|0;if((Nb|0)>=(pb|0)){td=sd;break}else Mb=sd}}else td=Kb;Lb=Lb+1|0;if((Lb|0)>=(qb|0)){ud=td;break}else Kb=td}E9b(M,V,ud,P,Q,d);Kb=_+128|0;Lb=_+132|0;Na=_+116|0;vb=na+772|0;ub=na+776|0;tb=na+780|0;sb=na+784|0;rb=j+20|0;$a=W+4|0;Va=W+8|0;Za=W+12|0;ia=ea(pb|0);ob=ea(ea(1.0)/ia);$=ea(qb|0);pa=ea(ea(1.0)/$);Ya=r+20|0;bb=r+40|0;cb=r+48|0;db=r+52|0;ab=ga+-2|0;xb=Aa+-2|0;wb=X+8|0;Ib=X+4|0;Hb=X+12|0;Gb=Y+8|0;Fb=Y+4|0;Eb=Y+12|0;Db=3;Cb=0;Bb=0;while(1){if(I){mb=ea(ea(Bb|0)/$);Ab=da(Bb,Aa)|0;zb=Ab+1|0;yb=Db;_a=Cb;Sa=0;while(1){if(!(a[V+(_a*364|0)>>0]|0)){ZLc(k+(_a<<6)|0)|0;vd=yb}else{In[c[(c[na>>2]|0)+108>>2]&4095](na,V+(_a*364|0)+132|0);In[c[(c[na>>2]|0)+104>>2]&4095](na,V+(_a*364|0)+68|0);s1b(ync()|0);kb=ea(g[Kb>>2]);ib=ea(-ea(kb*ea(g[(mo[c[(c[na>>2]|0)+128>>2]&4095](na)|0)+40>>2])));kb=ea(g[Lb>>2]);do if((c[Na>>2]|0)!=2|(c[155247]|0)<30|(a[621167]|0)==0)wd=kb;else{Wa=NOc()|0;if(!(a[Wa+101>>0]|0)){wd=kb;break}if(!((a[Wa+102>>0]|0)!=0&(a[621188]|0)==0)){wd=kb;break}Wa=pyc()|0;if((c[(c[Wa+24>>2]|0)+((c[Wa+40>>2]|0)*96|0)+16>>2]|0)<2){wd=kb;break}if(!(ea(wyc())>ea(0.0))){wd=kb;break}wd=ea(kb*ea(2.5))}while(0);kb=ea(g[V+(_a*364|0)+340>>2]);Ac=ea(g[V+(_a*364|0)+344>>2]);gc=ea(wd*(kb<Ac?Ac:kb));g[vb>>2]=ib;g[ub>>2]=ea(1.0);g[tb>>2]=gc;g[sb>>2]=ea(0.0);gc=ea(g[V+(_a*364|0)+356>>2]);kb=ea(g[V+(_a*364|0)+360>>2]);g[W>>2]=ea(0.0);g[$a>>2]=gc;g[Va>>2]=kb;g[Za>>2]=ea(0.0);oud(rb,565160,W);Rb=r+0|0;Sb=601008;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0));g[r>>2]=ob;g[Ya>>2]=pa;g[bb>>2]=ea(1.0);g[cb>>2]=ea(ea(Sa|0)/ia);g[db>>2]=mb;dMc(r,V+(_a*364|0)+260|0,k+(_a<<6)|0);a[U+_a>>0]=1;Pb=c[(c[na>>2]|0)+176>>2]|0;Qb=da(Sa,ga)|0;if((c[ja>>2]|0)==1){c[X>>2]=Qb+1;c[wb>>2]=ab;c[Ib>>2]=zb;c[Hb>>2]=xb;In[Pb&4095](na,X)}else{c[Y>>2]=Qb;c[Gb>>2]=ga;c[Fb>>2]=Ab;c[Eb>>2]=Aa;In[Pb&4095](na,Y)}U9b(_a,M,N,d,j);vd=(_a|0)<(yb|0)?_a:yb}Pb=_a+1|0;Sa=Sa+1|0;if((Sa|0)>=(pb|0)){xd=vd;yd=Pb;break}else{yb=vd;_a=Pb}}}else{xd=Db;yd=Cb}Bb=Bb+1|0;if((Bb|0)>=(qb|0)){zd=xd;break}else{Db=xd;Cb=yd}}Cb=k+(zd<<6)|0;if(!(a[U>>0]|0)){Rb=k+0|0;Sb=Cb+0|0;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0))}if(!(a[U+1>>0]|0)){Rb=k+64|0;Sb=Cb+0|0;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0))}if(!(a[U+2>>0]|0)){Rb=k+128|0;Sb=Cb+0|0;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0))}if(a[U+3>>0]|0)break;Rb=k+192|0;Sb=Cb+0|0;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0))}else{ia=ea(g[O>>2]);pa=ea(g[O+4>>2]);ob=ea(g[O+8>>2]);g[na+532>>2]=ia;g[na+536>>2]=pa;g[na+540>>2]=ob;g[na+544>>2]=ea(1.0);oBc(ta,0,-1,12);g[Z>>2]=ea(1.0);g[Z+4>>2]=ea(1.0);g[Z+8>>2]=ea(1.0);g[Z+12>>2]=ea(1.0);Uvc(7,Z,ea(1.0),0,j);Cb=ync()|0;Db=BTb(c[Ja>>2]|0)|0;g[p>>2]=ea(1.0);g[p+4>>2]=ea(1.0);g[p+8>>2]=ea(-1.0);iMc(o,p)|0;PGc(q,Db);dMc(o,q,m);ob=ea(g[_+184>>2]);pa=ea(ob*ea(.0399999991));nMc(n,ea(g[_+196>>2]),pa,ob)|0;In[c[(c[Cb>>2]|0)+108>>2]&4095](Cb,n);In[c[(c[Cb>>2]|0)+104>>2]&4095](Cb,m);s1b(ync()|0);ia=ea(g[_+128>>2]);if(!(a[Cb+5984>>0]|0))Ad=ia;else Ad=ea(ia*ea(2.0));g[Cb+772>>2]=Ad;g[Cb+776>>2]=ea(0.0);g[Cb+780>>2]=ea(0.0);g[Cb+784>>2]=ea(0.0);Rb=r+0|0;Sb=601008;Tb=Rb+64|0;do{c[Rb>>2]=c[Sb>>2];Rb=Rb+4|0;Sb=Sb+4|0}while((Rb|0)<(Tb|0));g[r>>2]=ea(.5);g[r+20>>2]=ea(.5);g[r+40>>2]=ea(.5);g[r+48>>2]=ea(.5);g[r+52>>2]=ea(.5);g[r+56>>2]=ea(.5);dMc(r,n,s);dMc(s,m,k);g[t>>2]=ea(0.0);g[t+4>>2]=pa;g[t+8>>2]=ob;g[t+12>>2]=ea(0.0);oud(j+20|0,565160,t);U9b(0,M,N,d,j)}while(0);In[c[(c[na>>2]|0)+80>>2]&4095](na,f);f=ync()|0;In[c[(c[f>>2]|0)+88>>2]&4095](f,Qa);nb=ta}ta=c[N>>2]|0;if(ta){N=c[fa>>2]|0;if((N|0)!=(ta|0))c[fa>>2]=N+(~((N+-16-ta|0)>>>4)<<4);c[n>>2]=89;c[m+0>>2]=c[n+0>>2];eOb(ta,m)}ta=c[M>>2]|0;if(!ta){ba=nb;i=l;return ba|0}M=c[sa>>2]|0;if((M|0)!=(ta|0))c[sa>>2]=M+(~(((M+-24-ta|0)>>>0)/24|0)*24|0);c[q>>2]=89;c[m+0>>2]=c[q+0>>2];eOb(ta,m);ba=nb;i=l;return ba|0}function O9b(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;j=i;i=i+240|0;k=j+152|0;l=j+128|0;m=j+64|0;n=j+52|0;o=j+28|0;p=j+116|0;q=j+140|0;r=j+216|0;s=j+76|0;t=j+16|0;u=j+4|0;v=j+88|0;w=j;x=j+40|0;y=j+104|0;z=ync()|0;if(!(c[141298]|0)){A=Xmd()|0;rri(u,565200,37);B=Nmd(A,u)|0;xri(u);c[141298]=bkd(B,61,0)|0}B=pyc()|0;u=h+4|0;A=c[u>>2]&-4065;C=(f|0)!=0;D=C&(c[(c[B+24>>2]|0)+((c[B+40>>2]|0)*96|0)+24>>2]|0)==1?A|1024:A;c[u>>2]=D|64;if(a[621166]|0)c[u>>2]=D|2112;D=Gzc()|0;A=Hzc(D,-1,-1,0,0,0,1,1)|0;if(A)In[c[(c[A>>2]|0)+36>>2]&4095](A,565240);oBc(A,0,-1,0);g[v>>2]=ea(1.0);g[v+4>>2]=ea(0.0);g[v+8>>2]=ea(1.0);g[v+12>>2]=ea(0.0);Co[c[(c[z>>2]|0)+24>>2]&3](z,1,v,ea(1.0),0);l1b(ea(-1.0),ea(100.0),0,ync()|0);v=c[141298]|0;c[w>>2]=c[141282];c[k+0>>2]=c[w+0>>2];rkd(v,k,e);if(((((f|0)==2?(v=NOc()|0,(a[v+101>>0]|0)!=0):0)?(a[v+102>>0]|0)!=0&(a[621188]|0)==0:0)?(v=pyc()|0,(c[(c[v+24>>2]|0)+((c[v+40>>2]|0)*96|0)+16>>2]|0)>=2):0)?(v=ea(wyc())>ea(0.0),v&(c[155247]|0)>29):0){rri(x,565264,15);v=vvd(x)|0;xri(x);rri(y,565280,7);x=vvd(y)|0;xri(y);y=hkd(c[141298]|0)|0;if(!y)E=0;else E=Old(y,v,x)|0;F=(E|0)>0?E:0}else F=0;E=dkd(c[141298]|0,0,h,F,1)|0;G=ea(G$b(d));co[c[(c[z>>2]|0)+576>>2]&2047](z,2,E);g[l>>2]=ea(1.0);g[l+4>>2]=ea(1.0);g[l+8>>2]=ea(-1.0);iMc(k,l)|0;cMc(k,D$b(d)|0)|0;yo[c[(c[z>>2]|0)+572>>2]&3](z,0,ea(0.0),ea(0.0),ea(0.0));g[n>>2]=ea(0.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=G;t0b(m,d,n);H=ea(g[k>>2]);I=ea(g[m>>2]);J=ea(H*I);n=k+16|0;H=ea(g[n>>2]);K=ea(g[m+4>>2]);L=ea(J+ea(H*K));l=k+32|0;H=ea(g[l>>2]);J=ea(g[m+8>>2]);M=ea(L+ea(H*J));m=k+48|0;H=ea(ea(g[m>>2])+M);E=k+4|0;M=ea(I*ea(g[E>>2]));F=k+20|0;L=ea(M+ea(K*ea(g[F>>2])));h=k+36|0;M=ea(L+ea(J*ea(g[h>>2])));x=k+52|0;L=ea(ea(g[x>>2])+M);v=k+8|0;M=ea(I*ea(g[v>>2]));y=k+24|0;I=ea(M+ea(K*ea(g[y>>2])));w=k+40|0;K=ea(I+ea(J*ea(g[w>>2])));B=k+56|0;J=ea(ea(g[B>>2])+K);qn[c[(c[z>>2]|0)+560>>2]&7](z,H,L,J);qn[c[(c[z>>2]|0)+556>>2]&7](z,ea(0.0),ea(0.0),ea(.100000001));yo[c[(c[z>>2]|0)+572>>2]&3](z,0,ea(1.0),ea(0.0),ea(0.0));g[p>>2]=ea(1.0);g[p+4>>2]=ea(0.0);g[p+8>>2]=G;t0b(o,d,p);J=ea(g[k>>2]);L=ea(g[o>>2]);H=ea(J*L);J=ea(g[n>>2]);K=ea(g[o+4>>2]);I=ea(H+ea(J*K));J=ea(g[l>>2]);H=ea(g[o+8>>2]);M=ea(I+ea(J*H));J=ea(ea(g[m>>2])+M);M=ea(L*ea(g[E>>2]));I=ea(M+ea(K*ea(g[F>>2])));M=ea(I+ea(H*ea(g[h>>2])));I=ea(ea(g[x>>2])+M);M=ea(L*ea(g[v>>2]));L=ea(M+ea(K*ea(g[y>>2])));K=ea(L+ea(H*ea(g[w>>2])));H=ea(ea(g[B>>2])+K);qn[c[(c[z>>2]|0)+560>>2]&7](z,J,I,H);qn[c[(c[z>>2]|0)+556>>2]&7](z,ea(1.0),ea(0.0),ea(.100000001));yo[c[(c[z>>2]|0)+572>>2]&3](z,0,ea(1.0),ea(1.0),ea(0.0));g[r>>2]=ea(1.0);g[r+4>>2]=ea(1.0);g[r+8>>2]=G;t0b(q,d,r);H=ea(g[k>>2]);I=ea(g[q>>2]);J=ea(H*I);H=ea(g[n>>2]);K=ea(g[q+4>>2]);L=ea(J+ea(H*K));H=ea(g[l>>2]);J=ea(g[q+8>>2]);M=ea(L+ea(H*J));H=ea(ea(g[m>>2])+M);M=ea(I*ea(g[E>>2]));L=ea(M+ea(K*ea(g[F>>2])));M=ea(L+ea(J*ea(g[h>>2])));L=ea(ea(g[x>>2])+M);M=ea(I*ea(g[v>>2]));I=ea(M+ea(K*ea(g[y>>2])));K=ea(I+ea(J*ea(g[w>>2])));J=ea(ea(g[B>>2])+K);qn[c[(c[z>>2]|0)+560>>2]&7](z,H,L,J);qn[c[(c[z>>2]|0)+556>>2]&7](z,ea(1.0),ea(1.0),ea(.100000001));yo[c[(c[z>>2]|0)+572>>2]&3](z,0,ea(0.0),ea(1.0),ea(0.0));g[t>>2]=ea(0.0);g[t+4>>2]=ea(1.0);g[t+8>>2]=G;t0b(s,d,t);G=ea(g[k>>2]);J=ea(g[s>>2]);L=ea(G*J);G=ea(g[n>>2]);H=ea(g[s+4>>2]);K=ea(L+ea(G*H));G=ea(g[l>>2]);L=ea(g[s+8>>2]);I=ea(K+ea(G*L));G=ea(ea(g[m>>2])+I);I=ea(J*ea(g[E>>2]));K=ea(I+ea(H*ea(g[F>>2])));I=ea(K+ea(L*ea(g[h>>2])));K=ea(ea(g[x>>2])+I);I=ea(J*ea(g[v>>2]));J=ea(I+ea(H*ea(g[y>>2])));H=ea(J+ea(L*ea(g[w>>2])));L=ea(ea(g[B>>2])+H);qn[c[(c[z>>2]|0)+560>>2]&7](z,G,K,L);qn[c[(c[z>>2]|0)+556>>2]&7](z,ea(0.0),ea(1.0),ea(.100000001));ko[c[(c[z>>2]|0)+580>>2]&4095](z);Jzc(D,e);e=pyc()|0;D=c[u>>2]&-2593;z=(f|0)!=2?D:D|512;D=(C&(c[(c[e+24>>2]|0)+((c[e+40>>2]|0)*96|0)+24>>2]|0)==1?z|1024:z&-3553)&-2529;c[u>>2]=D|128;z=b[310583]|0;if(!((z&255)<<24>>24!=0&(z&65535)<256)){i=j;return A|0}c[u>>2]=D|2176;i=j;return A|0}function P9b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;e=i;f=ync()|0;h=a+64|0;j=f+3108|0;k=h+0|0;l=j+64|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));m=a+128|0;j=f+3172|0;k=m+0|0;l=j+64|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));n=a+192|0;j=f+3236|0;k=n+0|0;l=j+64|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));o=ea(g[b+616>>2]);k=b+620|0;p=ea(g[k>>2]);j=b+624|0;q=ea(g[j>>2]);l=b+628|0;r=ea(g[l>>2]);g[f+788>>2]=o;g[f+792>>2]=p;g[f+796>>2]=q;g[f+800>>2]=r;r=ea(g[k>>2]);q=ea(g[j>>2]);p=ea(g[l>>2]);o=ea(g[b+632>>2]);g[f+804>>2]=r;g[f+808>>2]=q;g[f+812>>2]=p;g[f+816>>2]=o;l=b+656|0;j=f+820|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];l=b+672|0;j=f+836|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];l=b+688|0;j=f+852|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];l=b+704|0;j=f+868|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];o=ea(g[b+668>>2]);p=ea(g[b+684>>2]);q=ea(g[b+700>>2]);r=ea(g[b+716>>2]);g[f+884>>2]=o;g[f+888>>2]=p;g[f+892>>2]=q;g[f+896>>2]=r;r=ea(g[a>>2]);q=ea(g[a+4>>2]);p=ea(g[a+8>>2]);o=ea(ea(T(ea(ea(ea(r*r)+ea(q*q))+ea(p*p))))+ea(9.99999997e-07));p=ea(g[h>>2]);q=ea(g[a+68>>2]);r=ea(g[a+72>>2]);s=ea(ea(T(ea(ea(ea(p*p)+ea(q*q))+ea(r*r))))+ea(9.99999997e-07));r=ea(g[m>>2]);q=ea(g[a+132>>2]);p=ea(g[a+136>>2]);t=ea(ea(T(ea(ea(ea(r*r)+ea(q*q))+ea(p*p))))+ea(9.99999997e-07));p=ea(g[n>>2]);q=ea(g[a+196>>2]);r=ea(g[a+200>>2]);u=ea(o/s);s=ea(o/t);t=ea(o/ea(ea(T(ea(ea(ea(p*p)+ea(q*q))+ea(r*r))))+ea(9.99999997e-07)));g[f+900>>2]=ea(1.0);g[f+904>>2]=u;g[f+908>>2]=s;g[f+912>>2]=t;f=d+4|0;d=c[f>>2]|0;c[f>>2]=(c[b+612>>2]|0)>1?d&-4097:d|4096;i=e;return}function Q9b(d){d=d|0;var e=0,f=Im,g=0,h=0,j=0;e=i;f=ea(wyc());if(!(a[(NOc()|0)+101>>0]|0)){g=0;i=e;return g|0}h=b[310579]|0;if(!((c[155287]|0)!=0&(((h&255)<<24>>24==0|(a[621162]|0)==0|(h&65535)<256)^1))){g=0;i=e;return g|0}h=pyc()|0;j=(c[(c[h+24>>2]|0)+((c[h+40>>2]|0)*96|0)+16>>2]|0)==0;if(j|d^1){g=j^1;i=e;return g|0}g=f>ea(0.0);i=e;return g|0}function R9b(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,565136);c[141282]=c[b>>2];c[b>>2]=-1;itd(b,565168);c[141290]=c[b>>2];i=a;return}function S9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>4)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>4>>>0<1073741823){m=h>>3;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>4;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>4;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<4,16,e,0,3653512,80)|0;p=r}r=o+(p<<4)|0;if(r){c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2]}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>4)<<4)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<4);c[k>>2]=o+(n<<4);if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function T9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=(((c[g>>2]|0)-h|0)/24|0)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=((c[k>>2]|0)-l|0)/24|0;if(h>>>0<1073741823){m=h<<1;h=m>>>0<j>>>0?j:m;m=((c[g>>2]|0)-l|0)/24|0;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=((c[g>>2]|0)-l|0)/24|0;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q*24|0,16,e,0,3653512,80)|0;p=r}r=o+(p*24|0)|0;if(r){c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];c[r+16>>2]=c[b+16>>2];c[r+20>>2]=c[b+20>>2]}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+((((r|0)/-24|0)+p|0)*24|0)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+((p+1|0)*24|0);c[k>>2]=o+(n*24|0);if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function U9b(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=Im,ja=0,ka=Im,la=Im,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im,sa=0;k=i;i=i+224|0;l=k;m=k+72|0;n=k+8|0;o=k+152|0;p=k+4|0;q=k+216|0;r=k+76|0;s=ync()|0;t=n+0|0;u=(mo[c[(c[s>>2]|0)+120>>2]&4095](s)|0)+0|0;v=t+64|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));t=o+0|0;u=(mo[c[(c[s>>2]|0)+116>>2]&4095](s)|0)+0|0;v=t+64|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(v|0));u=c[f+4>>2]|0;t=c[f>>2]|0;v=u-t|15;w=(u|0)!=(t|0);if(v>>>0<2e3)if(w){t=i;i=i+((1*v|0)+15&-16)|0;x=0;y=t}else{x=0;y=0}else if(w){c[p>>2]=c[153134];c[l+0>>2]=c[p+0>>2];p=cOb(v,16,l,0,3653512,423)|0;x=p;y=p}else{x=0;y=0}p=y+15&-16;y=1<<b;b=e+4|0;v=c[b>>2]|0;w=c[e>>2]|0;if((v|0)==(w|0))z=0;else{t=h+76|0;u=h+80|0;A=h+92|0;B=h+96|0;C=h+108|0;D=h+112|0;E=h+124|0;F=h+128|0;h=v;v=w;w=0;G=0;while(1){if((c[v+(G*24|0)+16>>2]&y|0)!=0?(H=c[c[v+(G*24|0)>>2]>>2]|0,I=c[v+(G*24|0)+8>>2]|0,J=v+(G*24|0)+12|0,I>>>0<(c[J>>2]|0)>>>0):0){K=v+(G*24|0)+4|0;L=(a[H+41>>0]|0)==2?-2147483648:0;M=w;N=I;while(1){O=ea(g[t>>2]);P=ea(g[u>>2]);Q=ea(g[A>>2]);R=ea(g[B>>2]);S=ea(g[C>>2]);T=ea(g[D>>2]);U=ea(g[E>>2]);V=ea(g[F>>2]);I=c[K>>2]|0;W=ea(g[I>>2]);X=ea(O*W);O=ea(g[I+4>>2]);Y=ea(X+ea(Q*O));Q=ea(g[I+8>>2]);X=ea(ea(U+ea(Y+ea(S*Q)))/ea(V+ea(ea(ea(P*W)+ea(R*O))+ea(T*Q))));I=X<ea(0.0);Q=I?ea(0.0):X;I=Q>ea(1.0);Z=M+1|0;_=mo[c[(c[H>>2]|0)+52>>2]&4095](H)|0;$=c[(c[f>>2]|0)+(N<<4)+12>>2]|0;if(!(c[$+32>>2]|0))Qjd($);aa=c[$+136>>2]&2147483647|L;$=~~ea(Q*ea(16383.0))>>>0&16383;ba=p+(M<<4)|0;c[ba>>2]=(I?16383:$)|_<<16;c[ba+4>>2]=aa;c[p+(M<<4)+8>>2]=G;c[p+(M<<4)+12>>2]=N;N=N+1|0;if(N>>>0>=(c[J>>2]|0)>>>0){ca=Z;break}else M=Z}da=c[b>>2]|0;fa=c[e>>2]|0;ga=ca}else{da=h;fa=v;ga=w}G=G+1|0;if(G>>>0>=((da-fa|0)/24|0)>>>0){z=ga;break}else{h=da;v=fa;w=ga}}}V9b(p,p+(z<<4)|0,l);if(a[s+5568>>0]|0){ga=s+5424|0;c[ga>>2]=(c[ga>>2]|0)+z}if(z){on[c[(c[s>>2]|0)+640>>2]&31](s,ea(1.0),ea(1.0));K_b(s,j,ea(0.0));RYb(r,q);q=s+772|0;Q=ea(g[q>>2]);ga=s+776|0;X=ea(g[ga>>2]);w=s+780|0;T=ea(g[w>>2]);fa=s+784|0;O=ea(g[fa>>2]);if((z|0)>0){v=1;da=0;h=0;G=0;ca=0;b=-1;R=ea(0.0);while(1){F=p+(G<<4)+8|0;E=c[c[(c[e>>2]|0)+((c[F>>2]|0)*24|0)>>2]>>2]|0;D=E+48|0;C=E+49|0;if(!((a[D>>0]|0)==0?(a[C>>0]|0)==0:0)){ko[c[(c[E>>2]|0)+60>>2]&4095](E);a[D>>0]=0;a[C>>0]=0}C=E+52|0;D=c[p+(G<<4)+12>>2]|0;B=c[f>>2]|0;A=c[p+(G<<4)+4>>2]|0;u=c[E+168>>2]|0;if(!u)ha=0;else ha=c[u+32>>2]|0;W=ea(g[(c[e>>2]|0)+((c[F>>2]|0)*24|0)+20>>2]);do if((v|0)==0&(da|0)==(A|0)&(ca|0)==(ha|0)?(F=(W>ea(0.0)&1)-(W<ea(0.0)&1)|0,(F|0)==((R>ea(0.0)&1)-(R<ea(0.0)&1)|0)):0){if((F|0)<0){P=ea(W-R);if(P<ea(0.0))ia=ea(-P);else ia=P;if(!(ia<=ea(9.99999997e-07))){ja=37;break}}else{P=ea(W*ea(16.0));if(!(P>=ea(0.0)))ka=ea(P+ea(-.99999994));else ka=P;P=ea(R*ea(16.0));if(!(P>=ea(0.0)))la=ea(P+ea(-.99999994));else la=P;if((~~ka|0)!=(~~la|0)){ja=37;break}}if(emd(c[B+(D<<4)+8>>2]|0,W)|0){TYb(r);ma=v;na=da;oa=h;pa=ca;qa=b;ra=R}else{ma=v;na=da;oa=h;pa=ca;qa=b;ra=R}}else ja=37;while(0);if((ja|0)==37){ja=0;TYb(r);K_b(s,j,W);F=((a[E+41>>0]|0)!=2)<<31>>31;if((F|0)==(b|0))sa=b;else{In[c[(c[s>>2]|0)+84>>2]&4095](s,F);sa=F}F=((d[E+40>>0]|0)+-5|0)>>>0<4;if(F){g[q>>2]=Q;g[ga>>2]=X;g[w>>2]=ea(0.0);g[fa>>2]=O}u=fkd(c[B+(D<<4)+12>>2]|0,c[B+(D<<4)+8>>2]|0,j,c[B+(D<<4)+4>>2]|0)|0;if(F){g[q>>2]=Q;g[ga>>2]=X;g[w>>2]=T;g[fa>>2]=O;ma=0;na=A;oa=u;pa=ha;qa=sa;ra=W}else{ma=0;na=A;oa=u;pa=ha;qa=sa;ra=W}}if(oa)SYb(r,E,C,c[B+(D<<4)>>2]|0,oa);G=G+1|0;if((G|0)>=(z|0))break;else{v=ma;da=na;h=oa;ca=pa;b=qa;R=ra}}}TYb(r);In[c[(c[s>>2]|0)+104>>2]&4095](s,n);In[c[(c[s>>2]|0)+100>>2]&4095](s,o);on[c[(c[s>>2]|0)+640>>2]&31](s,ea(0.0),ea(0.0));In[c[(c[s>>2]|0)+84>>2]&4095](s,-1);aZb(r)}if(!x){i=k;return}c[m>>2]=c[153134];c[l+0>>2]=c[m+0>>2];eOb(x,l);i=k;return}function V9b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;e=i;i=i+16|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-16|0;j=g;b:while(1){k=j;l=b-k|0;m=l>>4;switch(m|0){case 4:{n=j;o=h;p=14;break a;break}case 3:{q=j;r=h;s=h;p=6;break a;break}case 2:{t=j;u=h;v=h;p=4;break a;break}case 5:{w=j;x=h;y=h;p=15;break a;break}case 1:case 0:{p=84;break a;break}default:{}}if((l|0)<496){z=j;A=a;p=21;break a}B=(m|0)/2|0;C=j+(B<<4)|0;do if((l|0)>15984){D=(m|0)/4|0;E=j+(D<<4)|0;F=j+(D+B<<4)|0;D=W9b(j,E,C,F,d)|0;G=h;H=c[G+4>>2]|0;I=F;J=c[I+4>>2]|0;if(!(H>>>0<J>>>0|((H|0)==(J|0)?(c[G>>2]|0)>>>0<(c[I>>2]|0)>>>0:0))){K=C;L=D;break};c[f+0>>2]=c[F+0>>2];c[f+4>>2]=c[F+4>>2];c[f+8>>2]=c[F+8>>2];c[f+12>>2]=c[F+12>>2];c[F+0>>2]=c[h+0>>2];c[F+4>>2]=c[h+4>>2];c[F+8>>2]=c[h+8>>2];c[F+12>>2]=c[h+12>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];I=D+1|0;G=F;J=c[G+4>>2]|0;H=C;M=c[H+4>>2]|0;if(J>>>0<M>>>0|((J|0)==(M|0)?(c[G>>2]|0)>>>0<(c[H>>2]|0)>>>0:0)){c[f+0>>2]=c[C+0>>2];c[f+4>>2]=c[C+4>>2];c[f+8>>2]=c[C+8>>2];c[f+12>>2]=c[C+12>>2];c[C+0>>2]=c[F+0>>2];c[C+4>>2]=c[F+4>>2];c[C+8>>2]=c[F+8>>2];c[C+12>>2]=c[F+12>>2];c[F+0>>2]=c[f+0>>2];c[F+4>>2]=c[f+4>>2];c[F+8>>2]=c[f+8>>2];c[F+12>>2]=c[f+12>>2];F=D+2|0;H=C;G=c[H+4>>2]|0;M=E;J=c[M+4>>2]|0;if(G>>>0<J>>>0|((G|0)==(J|0)?(c[H>>2]|0)>>>0<(c[M>>2]|0)>>>0:0)){c[f+0>>2]=c[E+0>>2];c[f+4>>2]=c[E+4>>2];c[f+8>>2]=c[E+8>>2];c[f+12>>2]=c[E+12>>2];c[E+0>>2]=c[C+0>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];c[E+12>>2]=c[C+12>>2];c[C+0>>2]=c[f+0>>2];c[C+4>>2]=c[f+4>>2];c[C+8>>2]=c[f+8>>2];c[C+12>>2]=c[f+12>>2];M=E;H=c[M+4>>2]|0;J=j;G=c[J+4>>2]|0;if(H>>>0<G>>>0|((H|0)==(G|0)?(c[M>>2]|0)>>>0<(c[J>>2]|0)>>>0:0)){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[E+0>>2];c[j+4>>2]=c[E+4>>2];c[j+8>>2]=c[E+8>>2];c[j+12>>2]=c[E+12>>2];c[E+0>>2]=c[f+0>>2];c[E+4>>2]=c[f+4>>2];c[E+8>>2]=c[f+8>>2];c[E+12>>2]=c[f+12>>2];K=C;L=D+4|0}else{K=C;L=D+3|0}}else{K=C;L=F}}else{K=C;L=I}}else{I=C;F=c[I>>2]|0;D=c[I+4>>2]|0;I=j;E=c[I+4>>2]|0;J=h;M=c[J+4>>2]|0;G=M>>>0<D>>>0|((M|0)==(D|0)?(c[J>>2]|0)>>>0<F>>>0:0);if(!(D>>>0<E>>>0|((D|0)==(E|0)?F>>>0<(c[I>>2]|0)>>>0:0))){if(!G){K=C;L=0;break};c[f+0>>2]=c[C+0>>2];c[f+4>>2]=c[C+4>>2];c[f+8>>2]=c[C+8>>2];c[f+12>>2]=c[C+12>>2];c[C+0>>2]=c[h+0>>2];c[C+4>>2]=c[h+4>>2];c[C+8>>2]=c[h+8>>2];c[C+12>>2]=c[h+12>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];I=C;F=c[I+4>>2]|0;E=j;D=c[E+4>>2]|0;if(!(F>>>0<D>>>0|((F|0)==(D|0)?(c[I>>2]|0)>>>0<(c[E>>2]|0)>>>0:0))){K=C;L=1;break};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[C+0>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];c[C+0>>2]=c[f+0>>2];c[C+4>>2]=c[f+4>>2];c[C+8>>2]=c[f+8>>2];c[C+12>>2]=c[f+12>>2];K=C;L=2;break}if(G){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];K=C;L=1;break};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[C+0>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];c[C+0>>2]=c[f+0>>2];c[C+4>>2]=c[f+4>>2];c[C+8>>2]=c[f+8>>2];c[C+12>>2]=c[f+12>>2];G=h;E=c[G+4>>2]|0;I=C;D=c[I+4>>2]|0;if(E>>>0<D>>>0|((E|0)==(D|0)?(c[G>>2]|0)>>>0<(c[I>>2]|0)>>>0:0)){c[f+0>>2]=c[C+0>>2];c[f+4>>2]=c[C+4>>2];c[f+8>>2]=c[C+8>>2];c[f+12>>2]=c[C+12>>2];c[C+0>>2]=c[h+0>>2];c[C+4>>2]=c[h+4>>2];c[C+8>>2]=c[h+8>>2];c[C+12>>2]=c[h+12>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];K=C;L=2}else{K=C;L=1}}while(0);B=j;m=c[B>>2]|0;l=c[B+4>>2]|0;B=K;I=c[B>>2]|0;G=c[B+4>>2]|0;do if(l>>>0<G>>>0|(l|0)==(G|0)&m>>>0<I>>>0){N=h;O=L}else{B=a;D=h;while(1){E=B+-32|0;if((j|0)==(E|0))break;F=E;J=c[F+4>>2]|0;if(J>>>0<G>>>0|((J|0)==(G|0)?(c[F>>2]|0)>>>0<I>>>0:0)){P=E;p=66;break}else{F=D;D=E;B=F}}if((p|0)==66){p=0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[P+0>>2];c[j+4>>2]=c[P+4>>2];c[j+8>>2]=c[P+8>>2];c[j+12>>2]=c[P+12>>2];c[P+0>>2]=c[f+0>>2];c[P+4>>2]=c[f+4>>2];c[P+8>>2]=c[f+8>>2];c[P+12>>2]=c[f+12>>2];N=P;O=L+1|0;break}B=j+16|0;D=h;F=c[D+4>>2]|0;if(l>>>0<F>>>0|((l|0)==(F|0)?m>>>0<(c[D>>2]|0)>>>0:0))Q=B;else{if((B|0)==(h|0)){p=84;break a}else{R=j;S=B}while(1){B=S;D=c[B+4>>2]|0;F=R+32|0;if(l>>>0<D>>>0|((l|0)==(D|0)?m>>>0<(c[B>>2]|0)>>>0:0)){T=S;break}if((F|0)==(h|0)){p=84;break a}else{B=S;S=F;R=B}}c[f+0>>2]=c[T+0>>2];c[f+4>>2]=c[T+4>>2];c[f+8>>2]=c[T+8>>2];c[f+12>>2]=c[T+12>>2];c[T+0>>2]=c[h+0>>2];c[T+4>>2]=c[h+4>>2];c[T+8>>2]=c[h+8>>2];c[T+12>>2]=c[h+12>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];Q=T+16|0}if((Q|0)==(h|0)){p=84;break a}else{U=Q;V=h}while(1){B=j;F=c[B>>2]|0;D=c[B+4>>2]|0;B=U;while(1){E=B;J=c[E+4>>2]|0;M=B+16|0;if(D>>>0<J>>>0|((D|0)==(J|0)?F>>>0<(c[E>>2]|0)>>>0:0)){W=M;X=B;break}else B=M}B=V;while(1){M=B+-16|0;E=M;J=c[E+4>>2]|0;if(D>>>0<J>>>0|((D|0)==(J|0)?F>>>0<(c[E>>2]|0)>>>0:0))B=M;else{Y=M;break}}if(X>>>0>=Y>>>0){j=X;continue b};c[f+0>>2]=c[X+0>>2];c[f+4>>2]=c[X+4>>2];c[f+8>>2]=c[X+8>>2];c[f+12>>2]=c[X+12>>2];c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];c[X+12>>2]=c[Y+12>>2];c[Y+0>>2]=c[f+0>>2];c[Y+4>>2]=c[f+4>>2];c[Y+8>>2]=c[f+8>>2];c[Y+12>>2]=c[f+12>>2];U=W;V=Y}}while(0);m=j+16|0;c:do if(m>>>0<N>>>0){l=m;I=N;G=C;B=O;while(1){F=G;D=c[F>>2]|0;M=c[F+4>>2]|0;F=l;while(1){E=F;J=c[E+4>>2]|0;H=F+16|0;if(J>>>0<M>>>0|((J|0)==(M|0)?(c[E>>2]|0)>>>0<D>>>0:0))F=H;else{Z=H;_=F;break}}F=I;while(1){H=F+-16|0;E=H;J=c[E+4>>2]|0;if(J>>>0<M>>>0|((J|0)==(M|0)?(c[E>>2]|0)>>>0<D>>>0:0)){$=H;break}else F=H}if(_>>>0>$>>>0){aa=_;ba=G;ca=B;break c};c[f+0>>2]=c[_+0>>2];c[f+4>>2]=c[_+4>>2];c[f+8>>2]=c[_+8>>2];c[f+12>>2]=c[_+12>>2];c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];c[$+0>>2]=c[f+0>>2];c[$+4>>2]=c[f+4>>2];c[$+8>>2]=c[f+8>>2];c[$+12>>2]=c[f+12>>2];l=Z;I=$;G=(G|0)==(_|0)?$:G;B=B+1|0}}else{aa=m;ba=C;ca=O}while(0);if((aa|0)!=(ba|0)?(C=ba,m=c[C+4>>2]|0,B=aa,G=c[B+4>>2]|0,m>>>0<G>>>0|((m|0)==(G|0)?(c[C>>2]|0)>>>0<(c[B>>2]|0)>>>0:0)):0){c[f+0>>2]=c[aa+0>>2];c[f+4>>2]=c[aa+4>>2];c[f+8>>2]=c[aa+8>>2];c[f+12>>2]=c[aa+12>>2];c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];c[aa+12>>2]=c[ba+12>>2];c[ba+0>>2]=c[f+0>>2];c[ba+4>>2]=c[f+4>>2];c[ba+8>>2]=c[f+8>>2];c[ba+12>>2]=c[f+12>>2];da=ca+1|0}else da=ca;if(!da){ea=X9b(j,aa,d)|0;B=aa+16|0;if(X9b(B,a,d)|0){p=79;break}if(ea){j=B;continue}}B=aa;if((B-k|0)>=(b-B|0)){fa=j;ga=aa;p=83;break}V9b(j,aa,d);j=aa+16|0}if((p|0)==79){p=0;if(ea){p=84;break}else{g=j;a=aa;continue}}else if((p|0)==83){p=0;V9b(ga+16|0,a,d);g=fa;a=ga;continue}}if((p|0)==4){ga=u;u=c[ga+4>>2]|0;a=t;fa=c[a+4>>2]|0;if(!(u>>>0<fa>>>0|((u|0)==(fa|0)?(c[ga>>2]|0)>>>0<(c[a>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[t+12>>2]=c[v+12>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];i=e;return}else if((p|0)==6){v=q+16|0;t=v;a=c[t>>2]|0;ga=c[t+4>>2]|0;t=q;fa=c[t+4>>2]|0;u=r;g=c[u+4>>2]|0;aa=g>>>0<ga>>>0|((g|0)==(ga|0)?(c[u>>2]|0)>>>0<a>>>0:0);if(!(ga>>>0<fa>>>0|((ga|0)==(fa|0)?a>>>0<(c[t>>2]|0)>>>0:0))){if(!aa){i=e;return};c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[s+0>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];c[v+12>>2]=c[s+12>>2];c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];t=v;a=c[t+4>>2]|0;fa=q;ga=c[fa+4>>2]|0;if(!(a>>>0<ga>>>0|((a|0)==(ga|0)?(c[t>>2]|0)>>>0<(c[fa>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[q+12>>2]=c[v+12>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];i=e;return}if(aa){c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];c[q+0>>2]=c[s+0>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];c[q+12>>2]=c[s+12>>2];c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];i=e;return};c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];c[q+12>>2]=c[v+12>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];q=r;r=c[q+4>>2]|0;aa=v;fa=c[aa+4>>2]|0;if(!(r>>>0<fa>>>0|((r|0)==(fa|0)?(c[q>>2]|0)>>>0<(c[aa>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[s+0>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];c[v+12>>2]=c[s+12>>2];c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];i=e;return}else if((p|0)==14){W9b(n,n+16|0,n+32|0,o,d)|0;i=e;return}else if((p|0)==15){o=w+16|0;n=w+32|0;s=w+48|0;W9b(w,o,n,s,d)|0;d=x;x=c[d+4>>2]|0;v=s;aa=c[v+4>>2]|0;if(!(x>>>0<aa>>>0|((x|0)==(aa|0)?(c[d>>2]|0)>>>0<(c[v>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];c[s+0>>2]=c[y+0>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];c[s+12>>2]=c[y+12>>2];c[y+0>>2]=c[f+0>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];c[y+12>>2]=c[f+12>>2];y=s;v=c[y+4>>2]|0;d=n;aa=c[d+4>>2]|0;if(!(v>>>0<aa>>>0|((v|0)==(aa|0)?(c[y>>2]|0)>>>0<(c[d>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];s=n;d=c[s+4>>2]|0;y=o;aa=c[y+4>>2]|0;if(!(d>>>0<aa>>>0|((d|0)==(aa|0)?(c[s>>2]|0)>>>0<(c[y>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];c[o+12>>2]=c[n+12>>2];c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];n=o;y=c[n+4>>2]|0;s=w;aa=c[s+4>>2]|0;if(!(y>>>0<aa>>>0|((y|0)==(aa|0)?(c[n>>2]|0)>>>0<(c[s>>2]|0)>>>0:0))){i=e;return};c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];i=e;return}else if((p|0)==21){o=z+32|0;w=z+16|0;s=w;n=c[s>>2]|0;aa=c[s+4>>2]|0;s=z;y=c[s>>2]|0;d=c[s+4>>2]|0;s=o;v=c[s>>2]|0;x=c[s+4>>2]|0;s=x>>>0<aa>>>0|(x|0)==(aa|0)&v>>>0<n>>>0;do if(aa>>>0<d>>>0|(aa|0)==(d|0)&n>>>0<y>>>0){if(s){c[f+0>>2]=c[z+0>>2];c[f+4>>2]=c[z+4>>2];c[f+8>>2]=c[z+8>>2];c[f+12>>2]=c[z+12>>2];c[z+0>>2]=c[o+0>>2];c[z+4>>2]=c[o+4>>2];c[z+8>>2]=c[o+8>>2];c[z+12>>2]=c[o+12>>2];c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[z+0>>2];c[f+4>>2]=c[z+4>>2];c[f+8>>2]=c[z+8>>2];c[f+12>>2]=c[z+12>>2];c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];c[z+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];q=w;fa=c[q+4>>2]|0;if(x>>>0<fa>>>0|((x|0)==(fa|0)?v>>>0<(c[q>>2]|0)>>>0:0)){c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2]}}else if(s?(c[f+0>>2]=c[w+0>>2],c[f+4>>2]=c[w+4>>2],c[f+8>>2]=c[w+8>>2],c[f+12>>2]=c[w+12>>2],c[w+0>>2]=c[o+0>>2],c[w+4>>2]=c[o+4>>2],c[w+8>>2]=c[o+8>>2],c[w+12>>2]=c[o+12>>2],c[o+0>>2]=c[f+0>>2],c[o+4>>2]=c[f+4>>2],c[o+8>>2]=c[f+8>>2],c[o+12>>2]=c[f+12>>2],q=w,fa=c[q+4>>2]|0,fa>>>0<d>>>0|((fa|0)==(d|0)?(c[q>>2]|0)>>>0<y>>>0:0)):0){c[f+0>>2]=c[z+0>>2];c[f+4>>2]=c[z+4>>2];c[f+8>>2]=c[z+8>>2];c[f+12>>2]=c[z+12>>2];c[z+0>>2]=c[w+0>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];c[z+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2]}while(0);f=z+48|0;if((f|0)==(A|0)){i=e;return}else{ha=f;ia=o}while(1){o=ha;f=c[o>>2]|0;w=c[o+4>>2]|0;o=ia;y=c[o+4>>2]|0;if(w>>>0<y>>>0|((w|0)==(y|0)?f>>>0<(c[o>>2]|0)>>>0:0)){o=ha+8|0;y=c[o>>2]|0;d=c[o+4>>2]|0;o=ha;s=ia;while(1){c[o+0>>2]=c[s+0>>2];c[o+4>>2]=c[s+4>>2];c[o+8>>2]=c[s+8>>2];c[o+12>>2]=c[s+12>>2];if((s|0)==(z|0)){ja=z;break}v=s+-16|0;x=v;n=c[x+4>>2]|0;if(w>>>0<n>>>0|((w|0)==(n|0)?f>>>0<(c[x>>2]|0)>>>0:0)){x=s;s=v;o=x}else{ja=s;break}}s=ja;c[s>>2]=f;c[s+4>>2]=w;s=ja+8|0;c[s>>2]=y;c[s+4>>2]=d}s=ha+16|0;if((s|0)==(A|0))break;else{o=ha;ha=s;ia=o}}i=e;return}else if((p|0)==84){i=e;return}}function W9b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;h=b;j=c[h>>2]|0;k=c[h+4>>2]|0;h=a;l=c[h+4>>2]|0;m=d;n=c[m+4>>2]|0;o=n>>>0<k>>>0|((n|0)==(k|0)?(c[m>>2]|0)>>>0<j>>>0:0);do if(k>>>0<l>>>0|((k|0)==(l|0)?j>>>0<(c[h>>2]|0)>>>0:0)){if(o){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];p=1;break};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];m=d;n=c[m+4>>2]|0;q=b;r=c[q+4>>2]|0;if(n>>>0<r>>>0|((n|0)==(r|0)?(c[m>>2]|0)>>>0<(c[q>>2]|0)>>>0:0)){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];p=2}else p=1}else if(o){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];q=b;m=c[q+4>>2]|0;r=a;n=c[r+4>>2]|0;if(m>>>0<n>>>0|((m|0)==(n|0)?(c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0:0)){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];p=2}else p=1}else p=0;while(0);o=e;h=c[o+4>>2]|0;j=d;l=c[j+4>>2]|0;if(!(h>>>0<l>>>0|((h|0)==(l|0)?(c[o>>2]|0)>>>0<(c[j>>2]|0)>>>0:0))){s=p;i=f;return s|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];e=d;j=c[e+4>>2]|0;o=b;l=c[o+4>>2]|0;if(!(j>>>0<l>>>0|((j|0)==(l|0)?(c[e>>2]|0)>>>0<(c[o>>2]|0)>>>0:0))){s=p+1|0;i=f;return s|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];d=b;o=c[d+4>>2]|0;e=a;l=c[e+4>>2]|0;if(!(o>>>0<l>>>0|((o|0)==(l|0)?(c[d>>2]|0)>>>0<(c[e>>2]|0)>>>0:0))){s=p+2|0;i=f;return s|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];s=p+3|0;i=f;return s|0}function X9b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e+8|0;g=e;switch(b-a>>4|0){case 5:{h=a+16|0;j=a+32|0;k=a+48|0;l=b+-16|0;W9b(a,h,j,k,d)|0;m=l;n=c[m+4>>2]|0;o=k;p=c[o+4>>2]|0;if(!(n>>>0<p>>>0|((n|0)==(p|0)?(c[m>>2]|0)>>>0<(c[o>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];l=k;o=c[l+4>>2]|0;m=j;p=c[m+4>>2]|0;if(!(o>>>0<p>>>0|((o|0)==(p|0)?(c[l>>2]|0)>>>0<(c[m>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];k=j;m=c[k+4>>2]|0;l=h;p=c[l+4>>2]|0;if(!(m>>>0<p>>>0|((m|0)==(p|0)?(c[k>>2]|0)>>>0<(c[l>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];j=h;l=c[j+4>>2]|0;k=a;p=c[k+4>>2]|0;if(!(l>>>0<p>>>0|((l|0)==(p|0)?(c[j>>2]|0)>>>0<(c[k>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[h+0>>2];c[a+4>>2]=c[h+4>>2];c[a+8>>2]=c[h+8>>2];c[a+12>>2]=c[h+12>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];q=1;i=e;return q|0}case 4:{W9b(a,a+16|0,a+32|0,b+-16|0,d)|0;q=1;i=e;return q|0}case 2:{d=b+-16|0;h=d;k=c[h+4>>2]|0;j=a;p=c[j+4>>2]|0;if(!(k>>>0<p>>>0|((k|0)==(p|0)?(c[h>>2]|0)>>>0<(c[j>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];q=1;i=e;return q|0}case 3:{d=a+16|0;j=b+-16|0;h=d;p=c[h>>2]|0;k=c[h+4>>2]|0;h=a;l=c[h+4>>2]|0;m=j;o=c[m+4>>2]|0;n=o>>>0<k>>>0|((o|0)==(k|0)?(c[m>>2]|0)>>>0<p>>>0:0);if(!(k>>>0<l>>>0|((k|0)==(l|0)?p>>>0<(c[h>>2]|0)>>>0:0))){if(!n){q=1;i=e;return q|0};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];h=d;p=c[h+4>>2]|0;l=a;k=c[l+4>>2]|0;if(!(p>>>0<k>>>0|((p|0)==(k|0)?(c[h>>2]|0)>>>0<(c[l>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];q=1;i=e;return q|0}if(n){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];q=1;i=e;return q|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];n=j;l=c[n+4>>2]|0;h=d;k=c[h+4>>2]|0;if(!(l>>>0<k>>>0|((l|0)==(k|0)?(c[n>>2]|0)>>>0<(c[h>>2]|0)>>>0:0))){q=1;i=e;return q|0};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];q=1;i=e;return q|0}case 1:case 0:{q=1;i=e;return q|0}default:{j=a+32|0;d=a+16|0;h=d;n=c[h>>2]|0;k=c[h+4>>2]|0;h=a;l=c[h>>2]|0;p=c[h+4>>2]|0;h=j;m=c[h>>2]|0;o=c[h+4>>2]|0;h=o>>>0<k>>>0|(o|0)==(k|0)&m>>>0<n>>>0;do if(k>>>0<p>>>0|(k|0)==(p|0)&n>>>0<l>>>0){if(h){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];r=d;s=c[r+4>>2]|0;if(o>>>0<s>>>0|((o|0)==(s|0)?m>>>0<(c[r>>2]|0)>>>0:0)){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}}else if(h?(c[f+0>>2]=c[d+0>>2],c[f+4>>2]=c[d+4>>2],c[f+8>>2]=c[d+8>>2],c[f+12>>2]=c[d+12>>2],c[d+0>>2]=c[j+0>>2],c[d+4>>2]=c[j+4>>2],c[d+8>>2]=c[j+8>>2],c[d+12>>2]=c[j+12>>2],c[j+0>>2]=c[f+0>>2],c[j+4>>2]=c[f+4>>2],c[j+8>>2]=c[f+8>>2],c[j+12>>2]=c[f+12>>2],r=d,s=c[r+4>>2]|0,s>>>0<p>>>0|((s|0)==(p|0)?(c[r>>2]|0)>>>0<l>>>0:0)):0){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2]}while(0);f=a+48|0;if((f|0)==(b|0)){q=1;i=e;return q|0}else{t=0;u=f;v=j}while(1){j=u;f=c[j>>2]|0;d=c[j+4>>2]|0;j=v;l=c[j+4>>2]|0;if(d>>>0<l>>>0|((d|0)==(l|0)?f>>>0<(c[j>>2]|0)>>>0:0)){j=u+8|0;l=c[j+4>>2]|0;p=g;c[p>>2]=c[j>>2];c[p+4>>2]=l;l=u;p=v;while(1){c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[l+12>>2]=c[p+12>>2];if((p|0)==(a|0)){w=a;break}j=p+-16|0;h=j;m=c[h+4>>2]|0;if(d>>>0<m>>>0|((d|0)==(m|0)?f>>>0<(c[h>>2]|0)>>>0:0)){h=p;p=j;l=h}else{w=p;break}}p=w;c[p>>2]=f;c[p+4>>2]=d;p=g;l=c[p+4>>2]|0;h=w+8|0;c[h>>2]=c[p>>2];c[h+4>>2]=l;l=t+1|0;if((l|0)==8){x=u;break}else y=l}else y=t;l=u+16|0;if((l|0)==(b|0)){q=1;z=34;break}else{h=u;t=y;u=l;v=h}}if((z|0)==34){i=e;return q|0}q=(x+16|0)==(b|0);i=e;return q|0}}return 0}function Y9b(a){a=a|0;c[a>>2]=0;c[a+4>>2]=-1;g[a+8>>2]=ea(1.0);g[a+12>>2]=ea(.0500000007);g[a+16>>2]=ea(.400000006);return}function Z9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+8|0;f=d;g=ync()|0;h=dac()|0;j=hkd(a)|0;k=Hld(j)|0;if(c[(c[(c[c[(c[c[j+52>>2]>>2]|0)+(k<<2)>>2]>>2]|0)+(b<<2)>>2]|0)+640>>2]|0){i=d;return}l=ekd(a,b,j,c[158074]|0,k)|0;if(!l){i=d;return}c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+16>>2]=b*6;c[e>>2]=0;c[e+20>>2]=6;c[f>>2]=h;c[f+4>>2]=24;h=c[(c[g>>2]|0)+304>>2]|0;b=eac(c[l+4>>2]|0)|0;Nn[h&31](g,0,f,1,e,1,b,l);i=d;return}function _9b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+8|0;e=b;f=ync()|0;g=fac()|0;h=hkd(a)|0;j=Hld(h)|0;k=kkd(a)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=cac()|0;c[e>>2]=g;c[e+4>>2]=28;if((k|0)<=0){i=b;return}g=h+52|0;l=0;do{m=c[(c[c[(c[c[g>>2]>>2]|0)+(j<<2)>>2]>>2]|0)+(l<<2)>>2]|0;n=c[m+584>>2]|0;if(((n|0)==0|(n|0)==1|(n|0)==4?(c[m+640>>2]|0)==0:0)?(m=ekd(a,l,h,c[158074]|0,j)|0,(m|0)!=0):0){n=gac(c[m+4>>2]|0)|0;Nn[c[(c[f>>2]|0)+304>>2]&31](f,0,e,1,d,1,n,m)}l=l+1|0}while((l|0)!=(k|0));i=b;return}function $9b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0;a=i;i=i+192|0;d=a+72|0;e=a+68|0;f=a+56|0;h=a+44|0;j=a;k=K8b(X8b()|0)|0;g[f>>2]=ea(0.0);l=f+4|0;g[l>>2]=ea(0.0);m=f+8|0;g[m>>2]=ea(-1.0);if(!k){n=ea(0.0);o=ea(0.0);p=ea(0.0);q=ea(0.0);r=ea(0.0);s=ea(0.0);t=ea(-1.0)}else{if(!(c[141376]|0)){u=ea(g[k+152>>2]);v=ea(g[k+156>>2]);w=ea(g[k+160>>2]);x=ea(g[k+164>>2]);y=w;z=v;A=u}else{x=ea(0.0);y=ea(0.0);z=ea(0.0);A=ea(0.0)}TGc(h,BTb(c[k+24>>2]|0)|0,f);c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];u=ea(g[f>>2]);v=ea(g[l>>2]);n=A;o=z;p=y;q=x;r=u;s=v;t=ea(g[m>>2])}g[b+548>>2]=n;g[b+552>>2]=o;g[b+556>>2]=p;g[b+560>>2]=q;g[b+532>>2]=r;g[b+536>>2]=s;g[b+540>>2]=t;g[b+544>>2]=ea(0.0);In[c[(c[b>>2]|0)+248>>2]&4095](b,0);m=c[153134]|0;c[j>>2]=0;l=j+4|0;c[l>>2]=m;f=j+8|0;c[f>>2]=0;h=j+12|0;c[h>>2]=0;k=j+16|0;c[k>>2]=0;B=j+20|0;c[B>>2]=m;c[j+24>>2]=0;m=j+28|0;c[m>>2]=0;c[j+32>>2]=c[155410];VYb(j,b);MMc(d);P_b(j,d);if(c[f>>2]|0)WYb(j);if((c[m>>2]|0)>-1){m=c[k>>2]|0;c[e>>2]=c[B>>2];c[d+0>>2]=c[e+0>>2];eOb(m,d);c[k>>2]=0}if((c[h>>2]|0)<=-1){i=a;return}h=c[j>>2]|0;c[e>>2]=c[l>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[j>>2]=0;i=a;return}function aac(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=0,y=0,z=0;f=i;i=i+608|0;h=f+16|0;j=f+104|0;k=f+504|0;l=f;m=f+440|0;n=f+520|0;o=f+584|0;p=f+232|0;q=f+168|0;r=f+80|0;s=f+92|0;t=f+244|0;if(!b){i=f;return}u=ync()|0;t1b(t,ync()|0);do if(!(W$b(e)|0)){v=ea(ea(g[e+456>>2])*ea(.00999999977));w=ea(ea(g[e+460>>2])*ea(10.0));if(!(a[e+616>>0]|0)){w0b(e,v,m);g[m+40>>2]=ea(-.999998986);g[m+56>>2]=ea(v*ea(-1.99999905));g[m+44>>2]=ea(-1.0);x=n+0|0;y=601008;z=x+64|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));g[o>>2]=w;g[o+4>>2]=w;g[o+8>>2]=w;iMc(n,o)|0;O$b(p,e);g[n+48>>2]=ea(g[p>>2]);g[n+52>>2]=ea(g[p+4>>2]);g[n+56>>2]=ea(g[p+8>>2]);In[c[(c[u>>2]|0)+100>>2]&4095](u,n);In[c[(c[u>>2]|0)+108>>2]&4095](u,m);break}else{x=h+0|0;y=601008;z=x+64|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));g[h+40>>2]=ea(-.999998986);g[h+56>>2]=ea(v*ea(-1.99999905));g[h+44>>2]=ea(-1.0);x=j+0|0;y=601008;z=x+64|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));g[k>>2]=w;g[k+4>>2]=w;g[k+8>>2]=w;iMc(j,k)|0;O$b(l,e);g[j+48>>2]=ea(g[l>>2]);g[j+52>>2]=ea(g[l+4>>2]);g[j+56>>2]=ea(g[l+8>>2]);In[c[(c[u>>2]|0)+100>>2]&4095](u,j);In[c[(c[u>>2]|0)+108>>2]&4095](u,h);break}}else{v=ea(ea(ea(g[e+460>>2])*ea(.990000009))*ea(.577350259));x=q+0|0;y=601008;z=x+64|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));g[r>>2]=v;g[r+4>>2]=v;g[r+8>>2]=v;iMc(q,r)|0;O$b(s,e);g[q+48>>2]=ea(g[s>>2]);g[q+52>>2]=ea(g[s+4>>2]);g[q+56>>2]=ea(g[s+8>>2]);In[c[(c[u>>2]|0)+100>>2]&4095](u,q)}while(0);$9b(0,u);u=kkd(b)|0;if(!((d[(c[(hkd(b)|0)+52>>2]|0)+52>>0]^1)&(u|0)==6))_9b(b);else{u=0;do{Z9b(b,u);u=u+1|0}while((u|0)<6)}u1b(t);i=f;return}function bac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+32|0;a=c[f>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0)l=a;else m=10}else m=10;if((m|0)==10)l=hQb(c[f>>2]|0)|0;g=l;i=b;return g|0}function cac(){return c[141382]|0}function dac(){var a=0,b=0,d=0,e=0;a=i;b=c[141600]|0;do if(b){if(mo[c[(c[b>>2]|0)+8>>2]&4095](b)|0){d=ync()|0;In[c[(c[d>>2]|0)+296>>2]&4095](d,c[141600]|0);c[141600]=0;break}d=c[141600]|0;if(d){e=d;i=a;return e|0}}while(0);b=ync()|0;d=mo[c[(c[b>>2]|0)+280>>2]&4095](b)|0;c[141600]=d;Wn[c[(c[b>>2]|0)+284>>2]&127](b,d,0,0,864,565536,0);e=c[141600]|0;i=a;return e|0}function eac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[141380]|0;if(!d){e=uic()|0;f=tic(e,c[141378]|0)|0;c[141380]=f;g=f}else g=d;d=qic(g,a,0)|0;i=b;return d|0}function fac(){var a=0,b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=0,ma=Im,na=Im,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=0,va=0,wa=0,xa=0,ya=0,za=0;a=i;i=i+32|0;b=a+28|0;d=a+24|0;e=a+20|0;f=a+16|0;h=a;j=c[141602]|0;do if(j){if(mo[c[(c[j>>2]|0)+8>>2]&4095](j)|0){k=ync()|0;In[c[(c[k>>2]|0)+296>>2]&4095](k,c[141602]|0);c[141602]=0;break}k=c[141602]|0;if(k){l=k;i=a;return l|0}}while(0);j=ync()|0;c[141602]=mo[c[(c[j>>2]|0)+280>>2]&4095](j)|0;c[h>>2]=0;k=h+8|0;m=h+12|0;n=h+4|0;c[n>>2]=60;c[k>>2]=24;c[m>>2]=24;c[d>>2]=60;c[b+0>>2]=c[d+0>>2];o=hOb(0,672,4,b,0,3653512,370)|0;c[h>>2]=o;p=0;do{q=p*3|0;r=ea(g[566416+(q<<2)>>2]);s=ea(g[566416+(q+1<<2)>>2]);t=ea(g[566416+(q+2<<2)>>2]);u=ea(T(ea(ea(ea(r*r)+ea(s*s))+ea(t*t))));v=ea(r/u);r=ea(s/u);s=ea(t/u);g[o+(p*28|0)+16>>2]=v;g[o+(p*28|0)>>2]=v;g[o+(p*28|0)+20>>2]=r;g[o+(p*28|0)+4>>2]=r;g[o+(p*28|0)+24>>2]=s;g[o+(p*28|0)+8>>2]=s;c[o+(p*28|0)+12>>2]=-1;p=p+1|0}while((p|0)!=24);p=0;do{o=c[h>>2]|0;c[h>>2]=0;q=c[k>>2]|0;c[k>>2]=0;w=c[m>>2]|0;c[m>>2]=0;x=c[n>>2]|0;c[n>>2]=60;c[d>>2]=60;c[b+0>>2]=c[d+0>>2];eOb(0,b);c[h>>2]=0;c[k>>2]=0;c[m>>2]=0;if((q|0)!=0?(c[m>>2]=q<<2,c[d>>2]=c[n>>2],c[b+0>>2]=c[d+0>>2],c[h>>2]=hOb(0,q*112|0,4,b,0,3653512,370)|0,(q|0)>0):0){y=0;do{z=o+(y*28|0)|0;A=y+1|0;B=o+(A*28|0)|0;C=y+2|0;D=o+(C*28|0)|0;s=ea(g[z>>2]);r=ea(g[o+(y*28|0)+4>>2]);v=ea(g[o+(y*28|0)+8>>2]);u=ea(g[B>>2]);t=ea(g[o+(A*28|0)+4>>2]);E=ea(u*ea(.5));u=ea(t*ea(.5));t=ea(ea(g[o+(A*28|0)+8>>2])*ea(.5));F=ea(s*ea(.5));s=ea(r*ea(.5));r=ea(v*ea(.5));v=ea(F+E);G=ea(s+u);H=ea(r+t);I=ea(T(ea(ea(ea(v*v)+ea(G*G))+ea(H*H))));J=ea(v/I);v=ea(G/I);G=ea(H/I);I=ea(g[D>>2]);H=ea(g[o+(C*28|0)+4>>2]);K=ea(I*ea(.5));I=ea(H*ea(.5));H=ea(ea(g[o+(C*28|0)+8>>2])*ea(.5));L=ea(E+K);E=ea(u+I);u=ea(t+H);t=ea(T(ea(ea(ea(L*L)+ea(E*E))+ea(u*u))));M=ea(L/t);L=ea(E/t);E=ea(u/t);t=ea(F+K);K=ea(s+I);I=ea(r+H);H=ea(T(ea(ea(ea(t*t)+ea(K*K))+ea(I*I))));r=ea(t/H);t=ea(K/H);K=ea(I/H);iac(h,z);z=(c[k>>2]|0)+1|0;c[k>>2]=z;C=c[m>>2]|0;A=C&2147483647;if(z>>>0>A>>>0){N=C<<1;O=(N|0)==0?1:N;do if(A>>>0<O>>>0)if((C|0)>-1){c[m>>2]=O;N=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(N,O*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];N=cOb(O*28|0,4,b,0,3653512,352)|0;YEi(N|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=O;c[h>>2]=N;break}while(0);P=c[k>>2]|0}else P=z;O=P+-1|0;C=c[h>>2]|0;g[C+(O*28|0)>>2]=J;g[C+(O*28|0)+4>>2]=v;g[C+(O*28|0)+8>>2]=G;c[C+(O*28|0)+12>>2]=-1;A=C+(O*28|0)+16|0;g[A>>2]=J;g[A+4>>2]=v;g[A+8>>2]=G;A=(c[k>>2]|0)+1|0;c[k>>2]=A;O=c[m>>2]|0;C=O&2147483647;if(A>>>0>C>>>0){N=O<<1;Q=(N|0)==0?1:N;do if(C>>>0<Q>>>0)if((O|0)>-1){c[m>>2]=Q;N=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(N,Q*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];N=cOb(Q*28|0,4,b,0,3653512,352)|0;YEi(N|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=Q;c[h>>2]=N;break}while(0);R=c[k>>2]|0}else R=A;Q=R+-1|0;O=c[h>>2]|0;g[O+(Q*28|0)>>2]=r;g[O+(Q*28|0)+4>>2]=t;g[O+(Q*28|0)+8>>2]=K;c[O+(Q*28|0)+12>>2]=-1;C=O+(Q*28|0)+16|0;g[C>>2]=r;g[C+4>>2]=t;g[C+8>>2]=K;C=(c[k>>2]|0)+1|0;c[k>>2]=C;Q=c[m>>2]|0;O=Q&2147483647;if(C>>>0>O>>>0){z=Q<<1;N=(z|0)==0?1:z;do if(O>>>0<N>>>0)if((Q|0)>-1){c[m>>2]=N;z=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(z,N*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];z=cOb(N*28|0,4,b,0,3653512,352)|0;YEi(z|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=N;c[h>>2]=z;break}while(0);S=c[k>>2]|0}else S=C;N=S+-1|0;Q=c[h>>2]|0;g[Q+(N*28|0)>>2]=J;g[Q+(N*28|0)+4>>2]=v;g[Q+(N*28|0)+8>>2]=G;c[Q+(N*28|0)+12>>2]=-1;O=Q+(N*28|0)+16|0;g[O>>2]=J;g[O+4>>2]=v;g[O+8>>2]=G;iac(h,B);O=(c[k>>2]|0)+1|0;c[k>>2]=O;N=c[m>>2]|0;Q=N&2147483647;if(O>>>0>Q>>>0){A=N<<1;z=(A|0)==0?1:A;do if(Q>>>0<z>>>0)if((N|0)>-1){c[m>>2]=z;A=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(A,z*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];A=cOb(z*28|0,4,b,0,3653512,352)|0;YEi(A|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=z;c[h>>2]=A;break}while(0);V=c[k>>2]|0}else V=O;z=V+-1|0;N=c[h>>2]|0;g[N+(z*28|0)>>2]=M;g[N+(z*28|0)+4>>2]=L;g[N+(z*28|0)+8>>2]=E;c[N+(z*28|0)+12>>2]=-1;Q=N+(z*28|0)+16|0;g[Q>>2]=M;g[Q+4>>2]=L;g[Q+8>>2]=E;Q=(c[k>>2]|0)+1|0;c[k>>2]=Q;z=c[m>>2]|0;N=z&2147483647;if(Q>>>0>N>>>0){B=z<<1;C=(B|0)==0?1:B;do if(N>>>0<C>>>0)if((z|0)>-1){c[m>>2]=C;B=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(B,C*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];B=cOb(C*28|0,4,b,0,3653512,352)|0;YEi(B|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=C;c[h>>2]=B;break}while(0);W=c[k>>2]|0}else W=Q;C=W+-1|0;z=c[h>>2]|0;g[z+(C*28|0)>>2]=M;g[z+(C*28|0)+4>>2]=L;g[z+(C*28|0)+8>>2]=E;c[z+(C*28|0)+12>>2]=-1;N=z+(C*28|0)+16|0;g[N>>2]=M;g[N+4>>2]=L;g[N+8>>2]=E;N=(c[k>>2]|0)+1|0;c[k>>2]=N;C=c[m>>2]|0;z=C&2147483647;if(N>>>0>z>>>0){O=C<<1;B=(O|0)==0?1:O;do if(z>>>0<B>>>0)if((C|0)>-1){c[m>>2]=B;O=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(O,B*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];O=cOb(B*28|0,4,b,0,3653512,352)|0;YEi(O|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=B;c[h>>2]=O;break}while(0);X=c[k>>2]|0}else X=N;B=X+-1|0;C=c[h>>2]|0;g[C+(B*28|0)>>2]=r;g[C+(B*28|0)+4>>2]=t;g[C+(B*28|0)+8>>2]=K;c[C+(B*28|0)+12>>2]=-1;z=C+(B*28|0)+16|0;g[z>>2]=r;g[z+4>>2]=t;g[z+8>>2]=K;z=(c[k>>2]|0)+1|0;c[k>>2]=z;B=c[m>>2]|0;C=B&2147483647;if(z>>>0>C>>>0){Q=B<<1;O=(Q|0)==0?1:Q;do if(C>>>0<O>>>0)if((B|0)>-1){c[m>>2]=O;Q=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(Q,O*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];Q=cOb(O*28|0,4,b,0,3653512,352)|0;YEi(Q|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=O;c[h>>2]=Q;break}while(0);Y=c[k>>2]|0}else Y=z;O=Y+-1|0;B=c[h>>2]|0;g[B+(O*28|0)>>2]=J;g[B+(O*28|0)+4>>2]=v;g[B+(O*28|0)+8>>2]=G;c[B+(O*28|0)+12>>2]=-1;C=B+(O*28|0)+16|0;g[C>>2]=J;g[C+4>>2]=v;g[C+8>>2]=G;iac(h,D);C=(c[k>>2]|0)+1|0;c[k>>2]=C;O=c[m>>2]|0;B=O&2147483647;if(C>>>0>B>>>0){N=O<<1;Q=(N|0)==0?1:N;do if(B>>>0<Q>>>0)if((O|0)>-1){c[m>>2]=Q;N=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(N,Q*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];N=cOb(Q*28|0,4,b,0,3653512,352)|0;YEi(N|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=Q;c[h>>2]=N;break}while(0);Z=c[k>>2]|0}else Z=C;Q=Z+-1|0;O=c[h>>2]|0;g[O+(Q*28|0)>>2]=r;g[O+(Q*28|0)+4>>2]=t;g[O+(Q*28|0)+8>>2]=K;c[O+(Q*28|0)+12>>2]=-1;B=O+(Q*28|0)+16|0;g[B>>2]=r;g[B+4>>2]=t;g[B+8>>2]=K;B=(c[k>>2]|0)+1|0;c[k>>2]=B;Q=c[m>>2]|0;O=Q&2147483647;if(B>>>0>O>>>0){D=Q<<1;z=(D|0)==0?1:D;do if(O>>>0<z>>>0)if((Q|0)>-1){c[m>>2]=z;D=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(D,z*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];D=cOb(z*28|0,4,b,0,3653512,352)|0;YEi(D|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=z;c[h>>2]=D;break}while(0);_=c[k>>2]|0}else _=B;z=_+-1|0;Q=c[h>>2]|0;g[Q+(z*28|0)>>2]=M;g[Q+(z*28|0)+4>>2]=L;g[Q+(z*28|0)+8>>2]=E;c[Q+(z*28|0)+12>>2]=-1;O=Q+(z*28|0)+16|0;g[O>>2]=M;g[O+4>>2]=L;g[O+8>>2]=E;y=y+3|0}while((y|0)<(q|0))}if((w|0)>-1){c[e>>2]=x;c[b+0>>2]=c[e+0>>2];eOb(o,b)}p=p+1|0}while((p|0)<3);p=0;do{e=c[h>>2]|0;c[h>>2]=0;_=c[k>>2]|0;c[k>>2]=0;Z=c[m>>2]|0;c[m>>2]=0;Y=c[n>>2]|0;c[n>>2]=60;K=ea(+U(.5,+ea(ea(p|0)+ea(1.0))));c[d>>2]=60;c[b+0>>2]=c[d+0>>2];eOb(0,b);c[h>>2]=0;c[k>>2]=0;c[m>>2]=0;if((_|0)!=0?(c[m>>2]=_<<2,c[d>>2]=c[n>>2],c[b+0>>2]=c[d+0>>2],c[h>>2]=hOb(0,_*112|0,4,b,0,3653512,370)|0,(_|0)>0):0){X=0;do{W=e+(X*28|0)|0;t=ea(g[e+(X*28|0)+4>>2]);if(t<ea(0.0))$=ea(-t);else $=t;V=X+1|0;S=e+(V*28|0)|0;r=ea(g[e+(V*28|0)+4>>2]);if(r<ea(0.0))aa=ea(-r);else aa=r;V=X+2|0;R=e+(V*28|0)|0;G=ea(g[e+(V*28|0)+4>>2]);if(G<ea(0.0))ba=ea(-G);else ba=G;v=$<aa?aa:$;do if(!((v<ba?ba:v)>K)){J=ea(r-t);if(J<ea(0.0))ca=ea(-J);else ca=J;J=ea(r-G);if(J<ea(0.0))da=ea(-J);else da=J;J=ea(G-t);if(J<ea(0.0))fa=ea(-J);else fa=J;if(ca<da&ca<fa){ga=t;ha=G;ia=r;ja=R;ka=W;la=S}else{V=da<ca&da<fa;P=V?W:S;q=V?S:R;y=V?R:W;J=ea(g[P+4>>2]);H=ea(g[q+4>>2]);ga=H;ha=J;ia=ea(g[y+4>>2]);ja=P;ka=q;la=y}J=ea(g[ja>>2]);H=ea(g[ja+8>>2]);I=ea(g[ka>>2]);y=ka+4|0;q=ka+8|0;s=ea(J*ea(.5));J=ea(ha*ea(.5));F=ea(H*ea(.5));H=ea(s+ea(I*ea(.5)));I=ea(ea(ga*ea(.5))+J);u=ea(F+ea(ea(g[q>>2])*ea(.5)));ma=ea(T(ea(ea(ea(I*I)+ea(H*H))+ea(u*u))));na=ea(H/ma);H=ea(I/ma);I=ea(u/ma);ma=ea(g[la>>2]);P=la+4|0;V=la+8|0;u=ea(s+ea(ma*ea(.5)));ma=ea(ea(ia*ea(.5))+J);J=ea(F+ea(ea(g[V>>2])*ea(.5)));F=ea(T(ea(ea(ea(ma*ma)+ea(u*u))+ea(J*J))));s=ea(u/F);u=ea(ma/F);ma=ea(J/F);iac(h,ja);O=(c[k>>2]|0)+1|0;c[k>>2]=O;z=c[m>>2]|0;Q=z&2147483647;if(O>>>0>Q>>>0){C=z<<1;D=(C|0)==0?1:C;do if(Q>>>0<D>>>0)if((z|0)>-1){c[m>>2]=D;C=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(C,D*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];C=cOb(D*28|0,4,b,0,3653512,352)|0;YEi(C|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=D;c[h>>2]=C;break}while(0);oa=c[k>>2]|0}else oa=O;D=oa+-1|0;z=c[h>>2]|0;g[z+(D*28|0)>>2]=na;g[z+(D*28|0)+4>>2]=H;g[z+(D*28|0)+8>>2]=I;c[z+(D*28|0)+12>>2]=-1;Q=z+(D*28|0)+16|0;g[Q>>2]=na;g[Q+4>>2]=H;g[Q+8>>2]=I;Q=(c[k>>2]|0)+1|0;c[k>>2]=Q;D=c[m>>2]|0;z=D&2147483647;if(Q>>>0>z>>>0){C=D<<1;N=(C|0)==0?1:C;do if(z>>>0<N>>>0)if((D|0)>-1){c[m>>2]=N;C=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(C,N*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];C=cOb(N*28|0,4,b,0,3653512,352)|0;YEi(C|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=N;c[h>>2]=C;break}while(0);pa=c[k>>2]|0}else pa=Q;N=pa+-1|0;D=c[h>>2]|0;g[D+(N*28|0)>>2]=s;g[D+(N*28|0)+4>>2]=u;g[D+(N*28|0)+8>>2]=ma;c[D+(N*28|0)+12>>2]=-1;z=D+(N*28|0)+16|0;g[z>>2]=s;g[z+4>>2]=u;g[z+8>>2]=ma;F=ea(s-ea(g[ka>>2]));J=ea(u-ea(g[y>>2]));qa=ea(ma-ea(g[q>>2]));ra=ea(na-ea(g[la>>2]));sa=ea(H-ea(g[P>>2]));ta=ea(I-ea(g[V>>2]));z=ea(ea(ea(F*F)+ea(J*J))+ea(qa*qa))>ea(ea(ea(ra*ra)+ea(sa*sa))+ea(ta*ta));N=(c[k>>2]|0)+1|0;c[k>>2]=N;D=c[m>>2]|0;O=D&2147483647;C=N>>>0>O>>>0;if(z){if(C){z=D<<1;A=(z|0)==0?1:z;do if(O>>>0<A>>>0)if((D|0)>-1){c[m>>2]=A;z=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(z,A*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];z=cOb(A*28|0,4,b,0,3653512,352)|0;YEi(z|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=A;c[h>>2]=z;break}while(0);ua=c[k>>2]|0}else ua=N;A=ua+-1|0;V=c[h>>2]|0;g[V+(A*28|0)>>2]=na;g[V+(A*28|0)+4>>2]=H;g[V+(A*28|0)+8>>2]=I;c[V+(A*28|0)+12>>2]=-1;P=V+(A*28|0)+16|0;g[P>>2]=na;g[P+4>>2]=H;g[P+8>>2]=I;iac(h,ka);iac(h,la);P=(c[k>>2]|0)+1|0;c[k>>2]=P;A=c[m>>2]|0;V=A&2147483647;if(P>>>0>V>>>0){q=A<<1;y=(q|0)==0?1:q;do if(V>>>0<y>>>0)if((A|0)>-1){c[m>>2]=y;q=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(q,y*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];q=cOb(y*28|0,4,b,0,3653512,352)|0;YEi(q|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=y;c[h>>2]=q;break}while(0);va=c[k>>2]|0}else va=P;y=va+-1|0;A=c[h>>2]|0;g[A+(y*28|0)>>2]=s;g[A+(y*28|0)+4>>2]=u;g[A+(y*28|0)+8>>2]=ma;c[A+(y*28|0)+12>>2]=-1;V=A+(y*28|0)+16|0;g[V>>2]=s;g[V+4>>2]=u;g[V+8>>2]=ma;V=(c[k>>2]|0)+1|0;c[k>>2]=V;y=c[m>>2]|0;A=y&2147483647;if(V>>>0>A>>>0){q=y<<1;Q=(q|0)==0?1:q;do if(A>>>0<Q>>>0)if((y|0)>-1){c[m>>2]=Q;q=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(q,Q*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];q=cOb(Q*28|0,4,b,0,3653512,352)|0;YEi(q|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=Q;c[h>>2]=q;break}while(0);wa=c[k>>2]|0}else wa=V;Q=wa+-1|0;y=c[h>>2]|0;g[y+(Q*28|0)>>2]=na;g[y+(Q*28|0)+4>>2]=H;g[y+(Q*28|0)+8>>2]=I;c[y+(Q*28|0)+12>>2]=-1;A=y+(Q*28|0)+16|0;g[A>>2]=na;g[A+4>>2]=H;g[A+8>>2]=I;iac(h,la);break}else{if(C){A=D<<1;Q=(A|0)==0?1:A;do if(O>>>0<Q>>>0)if((D|0)>-1){c[m>>2]=Q;A=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(A,Q*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];A=cOb(Q*28|0,4,b,0,3653512,352)|0;YEi(A|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=Q;c[h>>2]=A;break}while(0);xa=c[k>>2]|0}else xa=N;Q=xa+-1|0;D=c[h>>2]|0;g[D+(Q*28|0)>>2]=s;g[D+(Q*28|0)+4>>2]=u;g[D+(Q*28|0)+8>>2]=ma;c[D+(Q*28|0)+12>>2]=-1;O=D+(Q*28|0)+16|0;g[O>>2]=s;g[O+4>>2]=u;g[O+8>>2]=ma;O=(c[k>>2]|0)+1|0;c[k>>2]=O;Q=c[m>>2]|0;D=Q&2147483647;if(O>>>0>D>>>0){C=Q<<1;V=(C|0)==0?1:C;do if(D>>>0<V>>>0)if((Q|0)>-1){c[m>>2]=V;C=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(C,V*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];C=cOb(V*28|0,4,b,0,3653512,352)|0;YEi(C|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=V;c[h>>2]=C;break}while(0);ya=c[k>>2]|0}else ya=O;V=ya+-1|0;Q=c[h>>2]|0;g[Q+(V*28|0)>>2]=na;g[Q+(V*28|0)+4>>2]=H;g[Q+(V*28|0)+8>>2]=I;c[Q+(V*28|0)+12>>2]=-1;D=Q+(V*28|0)+16|0;g[D>>2]=na;g[D+4>>2]=H;g[D+8>>2]=I;iac(h,ka);D=(c[k>>2]|0)+1|0;c[k>>2]=D;V=c[m>>2]|0;Q=V&2147483647;if(D>>>0>Q>>>0){N=V<<1;C=(N|0)==0?1:N;do if(Q>>>0<C>>>0)if((V|0)>-1){c[m>>2]=C;N=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];c[h>>2]=hOb(N,C*28|0,4,b,0,3653512,370)|0;break}else{c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];N=cOb(C*28|0,4,b,0,3653512,352)|0;YEi(N|0,c[h>>2]|0,(c[k>>2]|0)*28|0)|0;c[m>>2]=C;c[h>>2]=N;break}while(0);za=c[k>>2]|0}else za=D;C=za+-1|0;V=c[h>>2]|0;g[V+(C*28|0)>>2]=s;g[V+(C*28|0)+4>>2]=u;g[V+(C*28|0)+8>>2]=ma;c[V+(C*28|0)+12>>2]=-1;Q=V+(C*28|0)+16|0;g[Q>>2]=s;g[Q+4>>2]=u;g[Q+8>>2]=ma;iac(h,ka);iac(h,la);break}}else{iac(h,W);iac(h,S);iac(h,R)}while(0);X=X+3|0}while((X|0)<(_|0))}if((Z|0)>-1){c[f>>2]=Y;c[b+0>>2]=c[f+0>>2];eOb(e,b)}p=p+1|0}while((p|0)<2);Wn[c[(c[j>>2]|0)+284>>2]&127](j,c[141602]|0,0,0,(c[k>>2]|0)*28|0,c[h>>2]|0,0);c[141382]=c[k>>2];k=c[141602]|0;if((c[m>>2]|0)<=-1){l=k;i=a;return l|0}m=c[h>>2]|0;c[d>>2]=c[n>>2];c[b+0>>2]=c[d+0>>2];eOb(m,b);c[h>>2]=0;l=k;i=a;return l|0}function gac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+48|0;e=d+32|0;f=d;g=c[141676]|0;if(g){h=g;j=qic(h,b,0)|0;i=d;return j|0}g=e+0|0;k=575992|0;l=g+16|0;do{a[g>>0]=a[k>>0]|0;g=g+1|0;k=k+1|0}while((g|0)<(l|0));a[e+7>>0]=3;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;$ic(13,e,f)|0;e=sic(uic()|0,f)|0;c[141676]=e;h=e;j=qic(h,b,0)|0;i=d;return j|0}function hac(){c[141378]=13;c[141380]=0;g[141384]=ea(-1.0);g[141385]=ea(1.0);g[141386]=ea(1.0);c[141387]=-1;g[141388]=ea(0.0);g[141389]=ea(1.0);g[141390]=ea(1.0);g[141391]=ea(1.0);g[141392]=ea(1.0);c[141393]=-1;g[141394]=ea(1.0);g[141395]=ea(1.0);g[141396]=ea(1.0);g[141397]=ea(-1.0);g[141398]=ea(1.0);c[141399]=-1;g[141400]=ea(1.0);g[141401]=ea(0.0);g[141402]=ea(-1.0);g[141403]=ea(1.0);g[141404]=ea(1.0);c[141405]=-1;g[141406]=ea(0.0);g[141407]=ea(1.0);g[141408]=ea(1.0);g[141409]=ea(-1.0);g[141410]=ea(1.0);c[141411]=-1;g[141412]=ea(1.0);g[141413]=ea(0.0);g[141414]=ea(-1.0);g[141415]=ea(-1.0);g[141416]=ea(1.0);c[141417]=-1;g[141418]=ea(0.0);g[141419]=ea(0.0);g[141420]=ea(1.0);g[141421]=ea(1.0);g[141422]=ea(-1.0);c[141423]=-1;g[141424]=ea(0.0);g[141425]=ea(1.0);g[141426]=ea(-1.0);g[141427]=ea(1.0);g[141428]=ea(-1.0);c[141429]=-1;g[141430]=ea(1.0);g[141431]=ea(1.0);g[141432]=ea(-1.0);g[141433]=ea(-1.0);g[141434]=ea(-1.0);c[141435]=-1;g[141436]=ea(1.0);g[141437]=ea(0.0);g[141438]=ea(1.0);g[141439]=ea(1.0);g[141440]=ea(-1.0);c[141441]=-1;g[141442]=ea(0.0);g[141443]=ea(1.0);g[141444]=ea(-1.0);g[141445]=ea(-1.0);g[141446]=ea(-1.0);c[141447]=-1;g[141448]=ea(1.0);g[141449]=ea(0.0);g[141450]=ea(1.0);g[141451]=ea(-1.0);g[141452]=ea(-1.0);c[141453]=-1;g[141454]=ea(0.0);g[141455]=ea(0.0);g[141456]=ea(1.0);g[141457]=ea(1.0);g[141458]=ea(1.0);c[141459]=-1;g[141460]=ea(0.0);g[141461]=ea(1.0);g[141462]=ea(1.0);g[141463]=ea(1.0);g[141464]=ea(-1.0);c[141465]=-1;g[141466]=ea(1.0);g[141467]=ea(1.0);g[141468]=ea(1.0);g[141469]=ea(-1.0);g[141470]=ea(-1.0);c[141471]=-1;g[141472]=ea(1.0);g[141473]=ea(0.0);g[141474]=ea(1.0);g[141475]=ea(1.0);g[141476]=ea(1.0);c[141477]=-1;g[141478]=ea(0.0);g[141479]=ea(1.0);g[141480]=ea(1.0);g[141481]=ea(-1.0);g[141482]=ea(-1.0);c[141483]=-1;g[141484]=ea(1.0);g[141485]=ea(0.0);g[141486]=ea(1.0);g[141487]=ea(-1.0);g[141488]=ea(1.0);c[141489]=-1;g[141490]=ea(0.0);g[141491]=ea(0.0);g[141492]=ea(-1.0);g[141493]=ea(1.0);g[141494]=ea(-1.0);c[141495]=-1;g[141496]=ea(0.0);g[141497]=ea(1.0);g[141498]=ea(-1.0);g[141499]=ea(1.0);g[141500]=ea(1.0);c[141501]=-1;g[141502]=ea(1.0);g[141503]=ea(1.0);g[141504]=ea(-1.0);g[141505]=ea(-1.0);g[141506]=ea(1.0);c[141507]=-1;g[141508]=ea(1.0);g[141509]=ea(0.0);g[141510]=ea(-1.0);g[141511]=ea(1.0);g[141512]=ea(-1.0);c[141513]=-1;g[141514]=ea(0.0);g[141515]=ea(1.0);g[141516]=ea(-1.0);g[141517]=ea(-1.0);g[141518]=ea(1.0);c[141519]=-1;g[141520]=ea(1.0);g[141521]=ea(0.0);g[141522]=ea(-1.0);g[141523]=ea(-1.0);g[141524]=ea(-1.0);c[141525]=-1;g[141526]=ea(0.0);g[141527]=ea(0.0);g[141528]=ea(-1.0);g[141529]=ea(1.0);g[141530]=ea(-1.0);c[141531]=-1;g[141532]=ea(0.0);g[141533]=ea(1.0);g[141534]=ea(1.0);g[141535]=ea(1.0);g[141536]=ea(-1.0);c[141537]=-1;g[141538]=ea(1.0);g[141539]=ea(1.0);g[141540]=ea(1.0);g[141541]=ea(1.0);g[141542]=ea(1.0);c[141543]=-1;g[141544]=ea(1.0);g[141545]=ea(0.0);g[141546]=ea(-1.0);g[141547]=ea(1.0);g[141548]=ea(-1.0);c[141549]=-1;g[141550]=ea(0.0);g[141551]=ea(1.0);g[141552]=ea(1.0);g[141553]=ea(1.0);g[141554]=ea(1.0);c[141555]=-1;g[141556]=ea(1.0);g[141557]=ea(0.0);g[141558]=ea(-1.0);g[141559]=ea(1.0);g[141560]=ea(1.0);c[141561]=-1;g[141562]=ea(0.0);g[141563]=ea(0.0);g[141564]=ea(-1.0);g[141565]=ea(-1.0);g[141566]=ea(1.0);c[141567]=-1;g[141568]=ea(0.0);g[141569]=ea(1.0);g[141570]=ea(1.0);g[141571]=ea(-1.0);g[141572]=ea(1.0);c[141573]=-1;g[141574]=ea(1.0);g[141575]=ea(1.0);g[141576]=ea(1.0);g[141577]=ea(-1.0);g[141578]=ea(-1.0);c[141579]=-1;g[141580]=ea(1.0);g[141581]=ea(0.0);g[141582]=ea(-1.0);g[141583]=ea(-1.0);g[141584]=ea(1.0);c[141585]=-1;g[141586]=ea(0.0);g[141587]=ea(1.0);g[141588]=ea(1.0);g[141589]=ea(-1.0);g[141590]=ea(-1.0);c[141591]=-1;g[141592]=ea(1.0);g[141593]=ea(0.0);g[141594]=ea(-1.0);g[141595]=ea(-1.0);g[141596]=ea(-1.0);c[141597]=-1;g[141598]=ea(0.0);g[141599]=ea(0.0);return}function iac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0>l>>>0){m=k<<1;n=(m|0)==0?1:m;do if(l>>>0<n>>>0)if((k|0)>-1){c[j>>2]=n;m=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(m,n*28|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];m=cOb(n*28|0,4,e,0,3653512,352)|0;YEi(m|0,c[a>>2]|0,(c[g>>2]|0)*28|0)|0;c[j>>2]=n;c[a>>2]=m;break}while(0);o=c[g>>2]|0}else o=h;h=o+-1|0;o=c[a>>2]|0;a=o+(h*28|0)|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[o+(h*28|0)+12>>2]=c[b+12>>2];a=o+(h*28|0)+16|0;h=b+16|0;c[a+0>>2]=c[h+0>>2];c[a+4>>2]=c[h+4>>2];c[a+8>>2]=c[h+8>>2];i=d;return}function jac(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;l=f+60|0;if(a[l>>0]|0){c[j>>2]=c[153136];c[h+0>>2]=c[j+0>>2];m=bOb(44,h,0,16,3653512,194)|0;n=(Pnd()|0)>2;o=n?6:1;c[m+4>>2]=o;c[m>>2]=e;c[m+40>>2]=f;p=m+8|0;c[p>>2]=c[f+64>>2];if(n){n=e+688|0;q=1;do{r=GLc()|0;s=c[(c[r>>2]|0)+32>>2]|0;t=c[n>>2]|0;c[k>>2]=c[153136];c[h+0>>2]=c[k+0>>2];c[p+(q<<2)>>2]=kn[s&511](r,t,0,h)|0;q=q+1|0}while((q|0)<(o|0))}Jnd(b,2661,m,o,3504,0);if(a[l>>0]|0){o=GLc()|0;u=j;v=_n[c[(c[o>>2]|0)+28>>2]&4095](o,c[f+64>>2]|0)|0}else{u=j;v=0}}else{u=j;v=0}u=0;do{o=e+(u*12|0)+616|0;if(c[o>>2]|0){c[j>>2]=c[153136];c[h+0>>2]=c[j+0>>2];m=bOb(220,h,0,16,3653512,117)|0;c[m>>2]=e;c[m+8>>2]=e+(u*12|0)+608;c[m+20>>2]=f+(u*12|0);c[m+12>>2]=l;c[m+4>>2]=v;c[m+16>>2]=u;if(!u){q=m+24|0;p=c[o>>2]|0;if(!(a[l>>0]|0)){w=q;x=p;y=14}else{k=And(q,p,1)|0;c[m+216>>2]=k;z=k}}else{w=m+24|0;x=c[o>>2]|0;y=14}if((y|0)==14){y=0;o=znd(w,x,256)|0;c[m+216>>2]=o;z=o}Nnd(d,2662,m,z,b,3505,0)}u=u+1|0}while((u|0)!=5);i=g;return}function kac(a){a=a|0;return ((c[a+56>>2]|0)!=0&1)+(((c[a+44>>2]|0)!=0&1)+(((c[a+32>>2]|0)!=0&1)+(((c[a+20>>2]|0)!=0&1)+((c[a+8>>2]|0)!=0&1))))|0}function lac(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+(d<<2)+8>>2]|0;g=GLc()|0;h=c[b>>2]|0;a[b+d+32>>0]=(Km[c[(c[g>>2]|0)+60>>2]&127](g,f,h,c[h+700>>2]|0,d,c[b+4>>2]|0)|0)&1;i=e;return}function mac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b+40>>2]|0;j=b+4|0;k=c[j>>2]|0;l=h+60|0;if((k|0)>0){m=0;do{if(a[b+m+32>>0]|0)a[l>>0]=0;m=m+1|0}while((m|0)<(k|0))}if(!(a[l>>0]|0))n=k;else{k=GLc()|0;En[c[(c[k>>2]|0)+56>>2]&127](k,h,c[(c[b>>2]|0)+688>>2]|0,b+8|0,c[j>>2]|0);k=c[b>>2]|0;ibc(k,c[k+612>>2]|0,c[k+608>>2]|0,h);n=c[j>>2]|0}if((n|0)<=1){o=c[153136]|0;c[f>>2]=o;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}n=1;do{h=GLc()|0;k=c[(c[h>>2]|0)+36>>2]|0;l=c[b+(n<<2)+8>>2]|0;c[g>>2]=c[153136];c[e+0>>2]=c[g+0>>2];Dn[k&511](h,l,1,e);n=n+1|0}while((n|0)<(c[j>>2]|0));o=c[153136]|0;c[f>>2]=o;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function nac(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=b+12|0;if((c[b+16>>2]|0)==0?(a[c[g>>2]>>0]|0)!=0:0){i=e;return}h=c[b+(d*12|0)+24>>2]|0;j=b+(d*12|0)+28|0;d=c[j>>2]|0;c[f>>2]=(c[c[b+20>>2]>>2]|0)+(h<<2);k=f+4|0;c[k>>2]=d;c[f+8>>2]=d;l=b+8|0;m=c[l>>2]|0;n=m+4|0;gbc(c[b>>2]|0,c[n>>2]|0,h,d+h|0,f);if(!(a[c[g>>2]>>0]|0)){ebc(c[b>>2]|0,c[m>>2]|0,f);o=m}else{fbc(c[c[l>>2]>>2]|0,c[b+4>>2]|0,f);o=m}hbc(c[b>>2]|0,c[n>>2]|0,c[o>>2]|0,f);m=c[b>>2]|0;b=c[m+704>>2]|0;if(b)Dn[b&511](c[n>>2]|0,c[o>>2]|0,f,c[m+708>>2]|0);c[j>>2]=c[k>>2];i=e;return}function oac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;if((c[b+16>>2]|0)==0?(a[c[b+12>>2]>>0]|0)!=0:0){g=c[153136]|0;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}h=c[b+20>>2]|0;j=c[b+216>>2]|0;k=c[b+28>>2]|0;if((j|0)>1){l=c[h>>2]|0;m=1;n=k;while(1){o=c[b+(m*12|0)+24>>2]|0;p=c[b+(m*12|0)+28>>2]|0;q=p+o|0;if(o>>>0<q>>>0){r=o;o=n;while(1){c[l+(o<<2)>>2]=c[l+(r<<2)>>2];r=r+1|0;if((r|0)==(q|0))break;else o=o+1|0}s=p+n|0}else s=n;m=m+1|0;if((m|0)==(j|0)){t=s;break}else n=s}}else t=k;c[h+4>>2]=t;g=c[153136]|0;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function pac(){var a=0,b=0;a=i;b=rVb(16)|0;i=a;return b|0}function qac(){var a=0,b=0;a=i;b=tVb(16)|0;i=a;return b|0}function rac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;k=d+8|0;c[h>>2]=c[k>>2];if(!(tdd(b,2646336,2646336,h)|0)){i=e;return}l=c[h>>2]|0;m=c[d>>2]|0;if(!m)c[d+4>>2]=c[b+8>>2];c[k>>2]=l;n=d+12|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<l>>>0)if((o|0)>-1){c[n>>2]=l;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];p=hOb(m,l,1,f,0,3653512,370)|0;c[d>>2]=p;q=p;break}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];p=cOb(l,1,f,0,3653512,352)|0;YEi(p|0,c[d>>2]|0,c[k>>2]|0)|0;c[n>>2]=l;c[d>>2]=p;q=p;break}else q=m;while(0);m=q+(c[k>>2]|0)|0;a:do if(c[h>>2]|0){k=qdd(b,3142592,c[142302]|0,0,0)|0;q=b+80|0;l=c[($hd(c[q>>2]|0)|0)+12>>2]|0;n=b+84|0;c[c[n>>2]>>2]=0;if((k|0)!=2){sdd(b);k=c[d>>2]|0;if((k|0)==(m|0))break;else r=k;while(1){uac(b,r,3142592,0);r=r+1|0;if((r|0)==(m|0))break a}}k=c[q>>2]|0;f=c[k+12>>2]|0;g=c[d>>2]|0;b:do if((g|0)!=(m|0)){o=b+12|0;p=b+16|0;s=b+28|0;t=b+32|0;u=b+20|0;v=0;w=k;x=g;while(1){y=(da(v,l)|0)+f|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(j,w);y=j;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[p>>2]|0;A=(c[(c[q>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[o>>2]=y;if((A|0)>=0?(z+(A+1)|0)>>>0<=(c[u>>2]|0)>>>0:0){a[x>>0]=a[y>>0]|0;c[o>>2]=(c[o>>2]|0)+1}else Bid(o,x,1);y=x+1|0;if((y|0)==(m|0))break b;v=c[c[n>>2]>>2]|0;w=c[q>>2]|0;x=y}}while(0);sdd(b)}while(0);udd(b);i=e;return}function sac(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;k=a+12|0;l=a+48|0;m=c[k>>2]|0;n=m+4|0;o=a+20|0;p=c[o>>2]|0;q=n>>>0>p>>>0;if(c[l>>2]|0){if(q){Bid(k,h,4);r=c[k>>2]|0;s=c[o>>2]|0}else{c[h>>2]=c[m>>2];c[k>>2]=n;r=n;s=p}p=r+4|0;if(p>>>0>s>>>0){Bid(k,g,4);t=c[g>>2]|0}else{s=c[r>>2]|0;c[g>>2]=s;c[k>>2]=p;t=s}s=c[h>>2]|0;h=zid(k,t,s)|0;t=b+12|0;if((c[t>>2]|0)>-1){p=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(p,e);c[b>>2]=0}c[b+8>>2]=s;c[t>>2]=s|-2147483648;c[b>>2]=h;c[l>>2]=0;i=d;return}if(q){Bid(k,j,4);u=c[j>>2]|0}else{q=c[m>>2]|0;c[j>>2]=q;c[k>>2]=n;u=q}q=c[b>>2]|0;if(!q)c[b+4>>2]=c[a+8>>2];n=b+8|0;c[n>>2]=u;k=b+12|0;m=c[k>>2]|0;do if((m&2147483647)>>>0<u>>>0)if((m|0)>-1){c[k>>2]=u;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];l=hOb(q,u,1,e,0,3653512,370)|0;c[b>>2]=l;v=l;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];l=cOb(u,1,e,0,3653512,352)|0;YEi(l|0,c[b>>2]|0,c[n>>2]|0)|0;c[k>>2]=u;c[b>>2]=l;v=l;break}else v=q;while(0);q=c[j>>2]|0;if(!q){i=d;return}Ldd(a,v,q);i=d;return}function tac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+12|0;m=b+48|0;n=c[l>>2]|0;o=n+4|0;p=b+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,j,4);s=c[j>>2]|0;t=c[l>>2]|0;u=c[p>>2]|0}else{v=c[n>>2]|0;c[j>>2]=v;c[l>>2]=o;s=v;t=o;u=q}q=XEi(s|0)|0;c[j>>2]=q;s=t+4|0;if(s>>>0>u>>>0){Bid(l,h,4);w=c[h>>2]|0;x=c[j>>2]|0}else{j=c[t>>2]|0;c[h>>2]=j;c[l>>2]=s;w=j;x=q}q=XEi(w|0)|0;c[h>>2]=q;h=zid(l,q,x)|0;q=d+12|0;if((c[q>>2]|0)>-1){w=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];eOb(w,f);c[d>>2]=0}c[d+8>>2]=x;c[q>>2]=x|-2147483648;c[d>>2]=h;c[m>>2]=0;i=e;return}if(r){Bid(l,k,4);y=c[k>>2]|0}else{r=c[n>>2]|0;c[k>>2]=r;c[l>>2]=o;y=r}r=XEi(y|0)|0;c[k>>2]=r;k=c[d>>2]|0;if(!k)c[d+4>>2]=c[b+8>>2];b=d+8|0;c[b>>2]=r;y=d+12|0;o=c[y>>2]|0;if((o&2147483647)>>>0<r>>>0){if((o|0)>-1){c[y>>2]=r;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];z=hOb(k,r,1,f,0,3653512,370)|0}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];g=cOb(r,1,f,0,3653512,352)|0;YEi(g|0,c[d>>2]|0,c[b>>2]|0)|0;c[y>>2]=r;z=g}c[d>>2]=z;A=z;B=c[b>>2]|0}else{A=k;B=r}r=A+B|0;if(!B){i=e;return}else C=A;do{A=c[l>>2]|0;if((A+1|0)>>>0>(c[p>>2]|0)>>>0)Bid(l,C,1);else{a[C>>0]=a[A>>0]|0;c[l>>2]=(c[l>>2]|0)+1}C=C+1|0}while((C|0)!=(r|0));i=e;return}function uac(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=qdd(b,e,c[142302]|0,g,0)|0;if(!h){i=f;return}do if((h|0)<=0){e=c[g>>2]|0;if(e)_n[e&4095](d,b)|0}else{e=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[e>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[b+20>>2]|0)>>>0:0){a[d>>0]=a[l>>0]|0;c[e>>2]=(c[e>>2]|0)+1;break}Bid(e,d,1)}while(0);sdd(b);i=f;return}function vac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;c[b>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=60;c[b+16>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+20>>2]=60;c[b+32>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[b+36>>2]=60;c[b+48>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;c[b+52>>2]=60;c[b+64>>2]=0;c[b+72>>2]=0;c[b+76>>2]=0;c[b+68>>2]=60;c[b+80>>2]=0;c[b+88>>2]=0;c[b+92>>2]=0;c[b+84>>2]=60;c[b+96>>2]=0;c[b+104>>2]=0;c[b+108>>2]=0;c[b+100>>2]=60;e=kbc()|0;f=0;while(1){g=e+(f<<2)+1024|0;f=f+1|0;if(!(c[g>>2]|0)){h=g;break}if((f|0)>=16){j=5;break}}if((j|0)==5){k=b+112|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;a[k+12>>0]=0;i=d;return}c[h>>2]=2663;k=b+112|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;a[k+12>>0]=0;i=d;return}function wac(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[141684]|0;g=b+4|0;if((c[g>>2]|0)>0){h=f+80|0;j=0;do{k=(c[h>>2]|0)+(c[(c[b>>2]|0)+(j<<2)>>2]|0)|0;a[k>>0]=d[k>>0]|1;j=j+1|0}while((j|0)<(c[g>>2]|0))}g=f+116|0;if(!(c[g>>2]|0))l=0;else{j=GLc()|0;l=_n[c[(c[j>>2]|0)+12>>2]&4095](j,c[g>>2]|0)|0}g=b+16|0;if((c[g>>2]|0)>0){j=b+12|0;b=f+80|0;h=0;do{k=(c[b>>2]|0)+((c[(c[j>>2]|0)+(h<<2)>>2]|0)+l)|0;a[k>>0]=d[k>>0]|1;h=h+1|0}while((h|0)<(c[g>>2]|0))}g=f+120|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;l=c[f+56>>2]|0;if((l|0)<=0){m=h;n=m+-1|0;c[g>>2]=n;i=e;return}h=f+80|0;j=f+48|0;f=0;do{b=(c[h>>2]|0)+f|0;if((a[b>>0]|0)==1){k=c[(c[j>>2]|0)+(f*24|0)>>2]|0;ko[c[(c[k>>2]|0)+20>>2]&4095](k);a[b>>0]=d[b>>0]|4}f=f+1|0}while((f|0)!=(l|0));m=c[g>>2]|0;n=m+-1|0;c[g>>2]=n;i=e;return}function xac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+4|0;e=b;a4b(a,0);c[a+116>>2]=0;f=a+112|0;g=c[f>>2]|0;c[e>>2]=c[153114];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;f=a+48|0;g=c[f>>2]|0;h=a+56|0;j=c[h>>2]|0;k=g+(j*24|0)|0;a:do if(j){l=g;do{c[l+8>>2]=-1;l=l+24|0}while((l|0)!=(k|0));m=g;n=j;o=0;while(1){if(!(c[m+(o*24|0)>>2]|0)){zac(a,o)|0;p=c[h>>2]|0;q=o+-1|0}else{p=n;q=o}l=q+1|0;if(l>>>0>=p>>>0)break a;m=c[f>>2]|0;n=p;o=l}}while(0);Rac((kbc()|0)+1024|0,2663);if((c[a+108>>2]|0)>-1){o=a+96|0;p=c[o>>2]|0;c[e>>2]=c[a+100>>2];c[d+0>>2]=c[e+0>>2];eOb(p,d);c[o>>2]=0}if((c[a+92>>2]|0)>-1){o=a+80|0;p=c[o>>2]|0;c[e>>2]=c[a+84>>2];c[d+0>>2]=c[e+0>>2];eOb(p,d);c[o>>2]=0}if((c[a+76>>2]|0)>-1){o=a+64|0;p=c[o>>2]|0;c[e>>2]=c[a+68>>2];c[d+0>>2]=c[e+0>>2];eOb(p,d);c[o>>2]=0}if((c[a+60>>2]|0)>-1){o=c[f>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(o,d);c[f>>2]=0}if((c[a+44>>2]|0)>-1){f=a+32|0;o=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(o,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;o=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(o,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function yac(a){a=a|0;var b=0;b=i;a4b(a,0);i=b;return}function zac(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f+4|0;h=f;if((e|0)>=0?(j=d+56|0,(c[j>>2]|0)>(e|0)):0){k=d+48|0;l=c[k>>2]|0;m=l+(e*24|0)|0;n=c[m>>2]|0;if(c[d+120>>2]|0){o=d+32|0;p=d+40|0;q=(c[p>>2]|0)+1|0;c[p>>2]=q;r=d+44|0;s=c[r>>2]|0;t=s&2147483647;if(q>>>0>t>>>0){u=s<<1;v=(u|0)==0?1:u;do if(t>>>0<v>>>0)if((s|0)>-1){c[r>>2]=v;u=c[o>>2]|0;c[h>>2]=c[d+36>>2];c[g+0>>2]=c[h+0>>2];c[o>>2]=hOb(u,v<<2,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+36>>2];c[g+0>>2]=c[h+0>>2];u=cOb(v<<2,4,g,0,3653512,352)|0;YEi(u|0,c[o>>2]|0,c[p>>2]<<2|0)|0;c[r>>2]=v;c[o>>2]=u;break}while(0);w=c[p>>2]|0}else w=q;c[(c[o>>2]|0)+(w+-1<<2)>>2]=e;a[l+(e*24|0)+22>>0]=1;x=n;i=f;return x|0}w=d+116|0;if(!(c[w>>2]|0))y=0;else{o=GLc()|0;y=_n[c[(c[o>>2]|0)+12>>2]&4095](o,c[w>>2]|0)|0}if((y|0)>(e|0)){a[(c[d+80>>2]|0)+e>>0]=0;c[m>>2]=0;a[l+(e*24|0)+21>>0]=0;x=n;i=f;return x|0}l=c[j>>2]|0;m=l+-1|0;y=c[k>>2]|0;k=y+(m*24|0)|0;if((m|0)!=(e|0)?(c[k>>2]|0)!=0:0){w=d+64|0;o=(c[w>>2]|0)+(m*24|0)|0;q=d+80|0;p=(a[(c[q>>2]|0)+m>>0]|0)!=0;v=y+(e*24|0)|0;c[v+0>>2]=c[k+0>>2];c[v+4>>2]=c[k+4>>2];c[v+8>>2]=c[k+8>>2];c[v+12>>2]=c[k+12>>2];c[v+16>>2]=c[k+16>>2];b[v+20>>1]=b[k+20>>1]|0;a[v+22>>0]=a[k+22>>0]|0;v=(c[w>>2]|0)+(e*24|0)|0;c[v+0>>2]=c[o+0>>2];c[v+4>>2]=c[o+4>>2];c[v+8>>2]=c[o+8>>2];c[v+12>>2]=c[o+12>>2];c[v+16>>2]=c[o+16>>2];c[v+20>>2]=c[o+20>>2];a[(c[q>>2]|0)+e>>0]=p&1;if(a[y+(m*24|0)+21>>0]|0){m=d+96|0;y=d+104|0;p=(c[y>>2]|0)+1|0;c[y>>2]=p;q=d+108|0;o=c[q>>2]|0;v=o&2147483647;if(p>>>0>v>>>0){w=o<<1;r=(w|0)==0?1:w;do if(v>>>0<r>>>0)if((o|0)>-1){c[q>>2]=r;w=c[m>>2]|0;c[h>>2]=c[d+100>>2];c[g+0>>2]=c[h+0>>2];c[m>>2]=hOb(w,r<<2,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+100>>2];c[g+0>>2]=c[h+0>>2];w=cOb(r<<2,4,g,0,3653512,352)|0;YEi(w|0,c[m>>2]|0,c[y>>2]<<2|0)|0;c[q>>2]=r;c[m>>2]=w;break}while(0);z=c[y>>2]|0}else z=p;c[(c[m>>2]|0)+(z+-1<<2)>>2]=e}z=c[k>>2]|0;if(!z)A=0;else A=z+-28|0;nAc(A,e);B=c[j>>2]|0}else B=l;c[j>>2]=B+-1;B=d+72|0;c[B>>2]=(c[B>>2]|0)+-1;B=d+88|0;c[B>>2]=(c[B>>2]|0)+-1;x=n;i=f;return x|0}Krd(566712,0,3653512,252,1,0,0,0);x=0;i=f;return x|0}function Aac(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+64|0;f=e+32|0;g=e+24|0;h=e;j=d+104|0;k=c[j>>2]|0;if((k|0)>0){l=d+96|0;m=d+56|0;n=d+48|0;o=d+64|0;p=0;do{q=c[(c[l>>2]|0)+(p<<2)>>2]|0;if((q|0)<(c[m>>2]|0)?(r=c[n>>2]|0,s=r+(q*24|0)+21|0,(a[s>>0]|0)!=0):0){Y_b(c[r+(q*24|0)>>2]|0,(c[o>>2]|0)+(q*24|0)|0);a[s>>0]=0}p=p+1|0}while((p|0)!=(k|0));t=m;u=n}else{t=d+56|0;u=d+48|0}c[j>>2]=0;j=d+116|0;c[j>>2]=0;n=d+112|0;m=c[n>>2]|0;c[g>>2]=c[153114];c[f+0>>2]=c[g+0>>2];eOb(m,f);c[n>>2]=0;m=c[u>>2]|0;k=c[t>>2]|0;p=m+(k*24|0)|0;a:do if(k){o=m;do{c[o+8>>2]=-1;o=o+24|0}while((o|0)!=(p|0));v=k;w=m;x=0;while(1){if(!(c[w+(x*24|0)>>2]|0)){zac(d,x)|0;y=c[t>>2]|0;z=x+-1|0}else{y=v;z=x}o=z+1|0;if(o>>>0>=y>>>0)break a;v=y;w=c[u>>2]|0;x=o}}while(0);if(!(qac()|0)){i=e;return}x=c[(pac()|0)+24>>2]|0;c[j>>2]=x;if(!x){i=e;return}x=pac()|0;w=GLc()|0;y=_n[c[(c[w>>2]|0)+12>>2]&4095](w,c[j>>2]|0)|0;if((y|0)>0){w=x+36|0;v=x+28|0;x=0;do{z=GLc()|0;m=xo[c[(c[z>>2]|0)+16>>2]&2047](z,c[j>>2]|0,x)|0;if(m>>>0<(c[w>>2]|0)>>>0){c[g>>2]=c[(c[v>>2]|0)+(m<<2)>>2];m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(f,m,g);z=c[f>>2]|0;k=c[m+28>>2]|0;if((z|0)==-1){A=k+(c[m+32>>2]<<3)|0;break}else{A=k+(z<<3)|0;break}}else A=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if(((((A|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[A+4>>2]|0,(m|0)!=0):0)?(z=(da(c[137788]|0,(c[m+8>>2]|0)>>>21)|0)+25|0,k=z>>5,(1<<z-(k<<5)&c[(c[137786]|0)+(k<<2)>>2]|0)!=0):0)?(k=c[m+216>>2]|0,(k|0)>=0):0)?(k|0)<(c[t>>2]|0):0)B=k;else C=32}else C=32;if((C|0)==32){C=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;B=Cac(d,0,0,h)|0}c[(c[u>>2]|0)+(B*24|0)+8>>2]=x}x=x+1|0}while((x|0)!=(y|0))}y=c[t>>2]|0;if(y){x=d+64|0;B=d+80|0;d=c[u>>2]|0;h=y;y=0;while(1){C=c[d+(y*24|0)+8>>2]|0;if((C|0)==-1|(C|0)==(y|0)){D=h;E=d}else{A=d;g=C;while(1){C=A+(y*24|0)|0;v=A+(g*24|0)|0;c[f+0>>2]=c[C+0>>2];c[f+4>>2]=c[C+4>>2];c[f+8>>2]=c[C+8>>2];c[f+12>>2]=c[C+12>>2];c[f+16>>2]=c[C+16>>2];c[f+20>>2]=c[C+20>>2];c[C+0>>2]=c[v+0>>2];c[C+4>>2]=c[v+4>>2];c[C+8>>2]=c[v+8>>2];c[C+12>>2]=c[v+12>>2];c[C+16>>2]=c[v+16>>2];b[C+20>>1]=b[v+20>>1]|0;a[C+22>>0]=a[v+22>>0]|0;c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];c[v+16>>2]=c[f+16>>2];b[v+20>>1]=b[f+20>>1]|0;a[v+22>>0]=a[f+22>>0]|0;v=c[x>>2]|0;C=v+(y*24|0)|0;w=v+(g*24|0)|0;c[f+0>>2]=c[C+0>>2];c[f+4>>2]=c[C+4>>2];c[f+8>>2]=c[C+8>>2];c[f+12>>2]=c[C+12>>2];c[f+16>>2]=c[C+16>>2];c[f+20>>2]=c[C+20>>2];c[C+0>>2]=c[w+0>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];c[C+12>>2]=c[w+12>>2];c[C+16>>2]=c[w+16>>2];c[C+20>>2]=c[w+20>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];c[w+16>>2]=c[f+16>>2];c[w+20>>2]=c[f+20>>2];w=c[B>>2]|0;C=w+y|0;v=w+g|0;w=a[C>>0]|0;a[C>>0]=a[v>>0]|0;a[v>>0]=w;w=c[u>>2]|0;v=c[w+(y*24|0)>>2]|0;if((v|0)!=0?(C=v+-28|0,(C|0)!=0):0){nAc(C,y);F=c[u>>2]|0}else F=w;w=c[F+(g*24|0)>>2]|0;if((w|0)!=0?(C=w+-28|0,(C|0)!=0):0){nAc(C,g);G=c[u>>2]|0}else G=F;g=c[G+(y*24|0)+8>>2]|0;if((g|0)==-1|(g|0)==(y|0)){H=G;break}else A=G}D=c[t>>2]|0;E=H}y=y+1|0;if(y>>>0>=D>>>0)break;else{d=E;h=D}}}D=GLc()|0;c[n>>2]=mo[c[(c[D>>2]|0)+44>>2]&4095](D)|0;i=e;return}function Bac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=b+104|0;f=c[e>>2]|0;if((f|0)<=0){c[e>>2]=0;i=d;return}g=b+96|0;h=b+56|0;j=b+48|0;k=b+64|0;b=0;do{l=c[(c[g>>2]|0)+(b<<2)>>2]|0;if((l|0)<(c[h>>2]|0)?(m=c[j>>2]|0,n=m+(l*24|0)+21|0,(a[n>>0]|0)!=0):0){Y_b(c[m+(l*24|0)>>2]|0,(c[k>>2]|0)+(l*24|0)|0);a[n>>0]=0}b=b+1|0}while((b|0)!=(f|0));c[e>>2]=0;i=d;return}function Cac(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h;m=d+48|0;n=d+56|0;o=c[n>>2]|0;c[l+0>>2]=0;c[l+4>>2]=0;b[l+8>>1]=0;a[l+10>>0]=0;p=(e|0)==0?0:e+28|0;e=o+1|0;c[n>>2]=e;q=d+60|0;r=c[q>>2]|0;s=r&2147483647;if(e>>>0>s>>>0){t=r<<1;u=(t|0)==0?1:t;do if(s>>>0<u>>>0)if((r|0)>-1){c[q>>2]=u;t=c[m>>2]|0;c[k>>2]=c[d+52>>2];c[j+0>>2]=c[k+0>>2];c[m>>2]=hOb(t,u*24|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[d+52>>2];c[j+0>>2]=c[k+0>>2];t=cOb(u*24|0,4,j,0,3653512,352)|0;YEi(t|0,c[m>>2]|0,(c[n>>2]|0)*24|0)|0;c[q>>2]=u;c[m>>2]=t;break}while(0);v=c[n>>2]|0}else v=e;e=v+-1|0;v=c[m>>2]|0;c[v+(e*24|0)>>2]=p;c[v+(e*24|0)+4>>2]=f;c[v+(e*24|0)+8>>2]=-1;f=v+(e*24|0)+12|0;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];b[f+8>>1]=b[l+8>>1]|0;a[f+10>>0]=a[l+10>>0]|0;l=d+64|0;f=d+72|0;e=(c[f>>2]|0)+1|0;c[f>>2]=e;v=d+76|0;p=c[v>>2]|0;m=p&2147483647;if(e>>>0>m>>>0){n=p<<1;u=(n|0)==0?1:n;do if(m>>>0<u>>>0)if((p|0)>-1){c[v>>2]=u;n=c[l>>2]|0;c[k>>2]=c[d+68>>2];c[j+0>>2]=c[k+0>>2];c[l>>2]=hOb(n,u*24|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[d+68>>2];c[j+0>>2]=c[k+0>>2];n=cOb(u*24|0,4,j,0,3653512,352)|0;YEi(n|0,c[l>>2]|0,(c[f>>2]|0)*24|0)|0;c[v>>2]=u;c[l>>2]=n;break}while(0);w=c[f>>2]|0}else w=e;e=(c[l>>2]|0)+((w+-1|0)*24|0)|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];g=d+80|0;e=d+88|0;w=(c[e>>2]|0)+1|0;c[e>>2]=w;l=d+92|0;f=c[l>>2]|0;u=f&2147483647;if(w>>>0<=u>>>0){x=w;y=x+-1|0;z=c[g>>2]|0;A=z+y|0;a[A>>0]=0;i=h;return o|0}w=f<<1;v=(w|0)==0?1:w;do if(u>>>0<v>>>0)if((f|0)>-1){c[l>>2]=v;w=c[g>>2]|0;c[k>>2]=c[d+84>>2];c[j+0>>2]=c[k+0>>2];c[g>>2]=hOb(w,v,1,j,0,3653512,370)|0;break}else{c[k>>2]=c[d+84>>2];c[j+0>>2]=c[k+0>>2];w=cOb(v,1,j,0,3653512,352)|0;YEi(w|0,c[g>>2]|0,c[e>>2]|0)|0;c[l>>2]=v;c[g>>2]=w;break}while(0);x=c[e>>2]|0;y=x+-1|0;z=c[g>>2]|0;A=z+y|0;a[A>>0]=0;i=h;return o|0}function Dac(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+116|0;if(!(c[d>>2]|0)){e=0;i=b;return e|0}a=GLc()|0;e=_n[c[(c[a>>2]|0)+12>>2]&4095](a,c[d>>2]|0)|0;i=b;return e|0}function Eac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+56>>2]|0;e=a+116|0;if(!(c[e>>2]|0)){f=0;g=d-f|0;i=b;return g|0}a=GLc()|0;f=_n[c[(c[a>>2]|0)+12>>2]&4095](a,c[e>>2]|0)|0;g=d-f|0;i=b;return g|0}function Fac(a){a=a|0;return c[a+48>>2]|0}function Gac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+48>>2]|0;e=a+116|0;if(!(c[e>>2]|0)){f=0;g=d+(f*24|0)|0;i=b;return g|0}a=GLc()|0;f=_n[c[(c[a>>2]|0)+12>>2]&4095](a,c[e>>2]|0)|0;g=d+(f*24|0)|0;i=b;return g|0}function Hac(a){a=a|0;return c[a+64>>2]|0}function Iac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+64>>2]|0;e=a+116|0;if(!(c[e>>2]|0)){f=0;g=d+(f*24|0)|0;i=b;return g|0}a=GLc()|0;f=_n[c[(c[a>>2]|0)+12>>2]&4095](a,c[e>>2]|0)|0;g=d+(f*24|0)|0;i=b;return g|0}function Jac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;if(c[a+120>>2]|0){f=-1;i=d;return f|0};c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;Y_b(b+28|0,e);f=Cac(a,b,mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0,e)|0;i=d;return f|0}function Kac(a,b){a=a|0;b=b|0;var d=0;d=a+120|0;c[d>>2]=(c[d>>2]|0)+(b?1:-1);return}function Lac(){return c[141684]|0}function Mac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b+56>>2]|0;if((e|0)<=0){i=d;return}f=b+80|0;g=b+48|0;b=0;do{h=(c[f>>2]|0)+b|0;j=a[h>>0]|0;if(j<<24>>24==2){k=c[(c[g>>2]|0)+(b*24|0)>>2]|0;ko[c[(c[k>>2]|0)+24>>2]&4095](k);l=a[h>>0]|0}else l=j;a[h>>0]=(l&1)<<1;b=b+1|0}while((b|0)!=(e|0));i=d;return}function Nac(b){b=b|0;var c=0,d=0;c=i;d=b+124|0;if(!(a[d>>0]|0)){i=c;return}a[d>>0]=0;Aac(b);i=c;return}function Oac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;e=b+4|0;f=a+40|0;g=c[f>>2]|0;if(!g){i=b;return}h=a+32|0;j=c[h>>2]|0;Wqi(j,j+(g<<2)|0,d);g=(c[f>>2]|0)+-1|0;if((g|0)>-1){j=g;do{zac(a,c[(c[h>>2]|0)+(j<<2)>>2]|0)|0;j=j+-1|0}while((j|0)>-1)}j=a+44|0;if((c[j>>2]|0)>-1){g=c[h>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[h>>2]=0}c[f>>2]=0;c[j>>2]=0;i=b;return}function Pac(){var a=0,b=0;a=i;b=xCi(128)|0;vac(b);c[141684]=b;i=a;return}function Qac(){var a=0,b=0;a=i;b=c[141684]|0;if(b){xac(b);ACi(b)}c[141684]=0;i=a;return}function Rac(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a>>2]|0)==(b|0))c[a>>2]=0;e=a+4|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+8|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+12|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+16|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+20|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+24|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+28|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+32|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+36|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+40|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+44|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+48|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+52|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+56|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+60|0;if((c[e>>2]|0)!=(b|0)){i=d;return}c[e>>2]=0;i=d;return}function Sac(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+32|0;k=j+24|0;l=j+16|0;m=j+12|0;n=j+8|0;o=j+4|0;p=j;q=e+8|0;if(!(c[q>>2]|0)){i=j;return}r=f+8|0;if(!(c[r>>2]|0)){i=j;return}c[n>>2]=c[153136];c[k+0>>2]=c[n+0>>2];n=bOb(360,k,0,16,3653512,349)|0;c[n>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;s=n+4|0;c[s>>2]=0;c[n>>2]=c[153136];c[n+16>>2]=e;c[n+20>>2]=f;c[n+32>>2]=g;c[n+36>>2]=h;a[n+28>>0]=(Hwc(Vwc()|0)|0)==1&1;a[n+29>>0]=(Ewc(Vwc()|0)|0)&1;a[n+30>>0]=(Dwc(Vwc()|0)|0)&1;c[n+24>>2]=d;h=c[q>>2]|0;g=((da(c[r>>2]|0,h)|0)/500|0)+1|0;r=n+168|0;f=znd(r,h,(g|0)<1?1:g)|0;g=c[q>>2]<<2;c[o>>2]=c[153136];c[k+0>>2]=c[o+0>>2];o=cOb(g,16,k,0,3653512,375)|0;if((f|0)>0){g=n+40|0;h=n+104|0;t=0;do{c[p>>2]=c[153136];c[k+0>>2]=c[p+0>>2];u=bOb(16,k,0,16,3653512,378)|0;c[u>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;v=u+4|0;c[v>>2]=60;c[g+(t<<2)>>2]=u;w=c[153136]|0;c[v>>2]=w;v=c[r+(t*12|0)+4>>2]|0;x=v*5|0;if(x){c[u+12>>2]=x;x=c[u>>2]|0;c[l>>2]=w;c[k+0>>2]=c[l+0>>2];c[u>>2]=hOb(x,v*40|0,4,k,0,3653512,370)|0}c[h+(t<<2)>>2]=o+(c[r+(t*12|0)>>2]<<2);t=t+1|0}while((t|0)!=(f|0))}if((d|0)>1){t=(d|0)==2?3:4;mRb(n,c[q>>2]|0,0);if(c[q>>2]|0){d=0;do{r=c[(c[e>>2]|0)+(d<<7)+116>>2]|0;o=mo[c[(c[r>>2]|0)+36>>2]&4095](r)|0;a:do if((o|0)>0){h=0;while(1){co[c[(c[r>>2]|0)+40>>2]&2047](m,r,h);g=c[m>>2]|0;do if(g){c[l>>2]=g;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(k,p,l);v=c[k>>2]|0;x=c[p+28>>2]|0;if((v|0)==-1){y=x+(c[p+32>>2]<<3)|0;break}else{y=x+(v<<3)|0;break}}else y=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((y|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[y+4>>2]|0,(p|0)!=0):0){z=p;break}}p=hQb(c[m>>2]|0)|0;if(p)z=p;else A=25}else A=25;while(0);if((A|0)==25){A=0;z=ckd()|0}if((Rjd(z)|0)>2500)break;h=h+1|0;if((c[(c[(hkd(z)|0)+52>>2]|0)+(t<<2)+12>>2]|0)==-1)break;if((h|0)>=(o|0)){A=29;break a}}h=(c[s>>2]|0)+(d>>>5<<2)|0;c[h>>2]=c[h>>2]|1<<(d&31)}else A=29;while(0);if((A|0)==29){A=0;o=(c[s>>2]|0)+(d>>>5<<2)|0;c[o>>2]=c[o>>2]&~(1<<(d&31))}d=d+1|0}while(d>>>0<(c[q>>2]|0)>>>0)}}else mRb(n,c[q>>2]|0,1);Jnd(b,2664,n,f,3506,0);i=j;return}function Tac(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im;e=i;i=i+16|0;f=e;if(!(a[b+576>>0]|0)){h=qmc(d,b+540|0,1)|0;i=e;return h|0}j=b+556|0;k=ea(g[d>>2]);l=ea(k-ea(g[j>>2]));k=ea(g[d+4>>2]);m=ea(k-ea(g[b+560>>2]));k=ea(g[d+8>>2]);n=ea(k-ea(g[b+564>>2]));k=ea(ea(ea(l*l)+ea(m*m))+ea(n*n));if(k<ea(g[b+572>>2])){h=1;i=e;return h|0}k=ea(g[b+568>>2]);c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];g[f+12>>2]=k;h=mmc(d,f)|0;i=e;return h|0}function Uac(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+16|0;f=e;h=c[b+(d*12|0)+168>>2]|0;j=c[b+(d*12|0)+172>>2]|0;k=c[b+20>>2]|0;l=a[b+28>>0]|0;m=(a[b+29>>0]|0)!=0;n=(a[b+30>>0]|0)!=0;o=c[b+(d<<2)+40>>2]|0;p=c[b+(d<<2)+104>>2]|0;if((h|0)>=(j+h|0)){i=e;return}d=c[b+24>>2]|0;q=c[b+16>>2]|0;r=o+8|0;s=b+4|0;b=l<<24>>24!=0;t=k+20|0;u=k+24|0;v=k+28|0;w=k+32|0;x=k+36|0;y=l<<24>>24==0;l=0;z=h;while(1){c[p+(l<<2)>>2]=c[r>>2];l=l+1|0;h=c[q>>2]|0;A=h+(z<<7)|0;if(!(c[(c[s>>2]|0)+(z>>>5<<2)>>2]&1<<(z&31)))a[h+(z<<7)+124>>0]=0;else{B=c[h+(z<<7)+116>>2]|0;C=1<<(mo[c[(c[B>>2]|0)+28>>2]&4095](B)|0);D=(c[B+36>>2]&65534|0)!=254;E=D|(_7b(B,m,n)|0)&y&(d|0)!=0;B=c[r>>2]|0;D=h+(z<<7)+64|0;F=ea(g[h+(z<<7)+64>>2]);G=ea(g[h+(z<<7)+68>>2]);H=ea(g[h+(z<<7)+72>>2]);I=c[t>>2]|0;if(!I)J=0;else{K=0;do{L=c[k>>2]|0;if(!(E&(((c[L+(K*108|0)+12>>2]|0)!=1|b)^1)|(c[L+(K*108|0)+16>>2]&C|0)==0))Wac(k,F,G,H,K,o);K=K+1|0}while((K|0)!=(I|0));J=I}K=(c[u>>2]|0)+I|0;if(J>>>0<K>>>0){L=h+(z<<7)+88|0;M=J;do{if(!(Xac((c[k>>2]|0)+(M*108|0)|0,C,E,b,D,L,A)|0))Wac(k,F,G,H,M,o);M=M+1|0}while((M|0)!=(K|0));N=K}else N=J;M=(c[v>>2]|0)+K|0;if(N>>>0<M>>>0){L=h+(z<<7)+88|0;I=h+(z<<7)+112|0;if(E){O=N;do{P=c[k>>2]|0;if((!((c[P+(O*108|0)+16>>2]&C|0)==0|((c[P+(O*108|0)+12>>2]|0)!=1|b)^1)?(Q=P+(O*108|0)+80|0,mmc(D,Q)|0):0)?nmc(L,A,c[I>>2]|0,Q)|0:0)Wac(k,F,G,H,O,o);O=O+1|0}while((O|0)!=(M|0));R=M}else{O=N;do{K=c[k>>2]|0;if(((c[K+(O*108|0)+16>>2]&C|0)!=0?(Q=K+(O*108|0)+80|0,mmc(D,Q)|0):0)?nmc(L,A,c[I>>2]|0,Q)|0:0)Wac(k,F,G,H,O,o);O=O+1|0}while((O|0)!=(M|0));R=M}}else R=N;O=c[r>>2]|0;I=(c[w>>2]|0)+M|0;if(R>>>0<I>>>0){L=h+(z<<7)+88|0;Q=R;do{if(!(Xac((c[k>>2]|0)+(Q*108|0)|0,C,E,b,D,L,A)|0))Wac(k,F,G,H,Q,o);Q=Q+1|0}while((Q|0)!=(I|0));S=I}else S=R;Q=(c[x>>2]|0)+I|0;if(S>>>0<Q>>>0){L=h+(z<<7)+88|0;M=h+(z<<7)+112|0;if(E){K=S;do{P=c[k>>2]|0;if((!((c[P+(K*108|0)+16>>2]&C|0)==0|((c[P+(K*108|0)+12>>2]|0)!=1|b)^1)?(T=P+(K*108|0)+80|0,mmc(D,T)|0):0)?nmc(L,A,c[M>>2]|0,T)|0:0)Wac(k,F,G,H,K,o);K=K+1|0}while((K|0)!=(Q|0))}else{K=S;do{E=c[k>>2]|0;if(((c[E+(K*108|0)+16>>2]&C|0)!=0?(I=E+(K*108|0)+80|0,mmc(D,I)|0):0)?nmc(L,A,c[M>>2]|0,I)|0:0)Wac(k,F,G,H,K,o);K=K+1|0}while((K|0)!=(Q|0))}}Q=c[r>>2]|0;if((Q|0)!=(B|0)){K=c[o>>2]|0;Yac(K+(B<<3)|0,K+(Q<<3)|0,f)}a[h+(z<<7)+124>>0]=(Q|0)!=(O|0)&1}if((l|0)==(j|0))break;else z=z+1|0}i=e;return}function Vac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+176>>2]|0;g=c[a+16>>2]|0;h=c[a+32>>2]|0;j=c[a+36>>2]|0;k=(f|0)>0;if(k){l=0;m=0;while(1){n=(c[(c[a+(l<<2)+40>>2]|0)+8>>2]|0)+m|0;l=l+1|0;if((l|0)==(f|0)){o=n;break}else m=n}}else o=0;m=h+12|0;l=c[m>>2]|0;do if((l&2147483647)>>>0<o>>>0)if((l|0)>-1){c[m>>2]=o;n=c[h>>2]|0;c[e>>2]=c[h+4>>2];c[d+0>>2]=c[e+0>>2];c[h>>2]=hOb(n,o<<3,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[h+4>>2];c[d+0>>2]=c[e+0>>2];n=cOb(o<<3,4,d,0,3653512,352)|0;YEi(n|0,c[h>>2]|0,c[h+8>>2]<<3|0)|0;c[m>>2]=o;c[h>>2]=n;break}while(0);o=(c[g+8>>2]|0)+1|0;g=j+8|0;c[g>>2]=o;l=j+12|0;n=c[l>>2]|0;do if((n&2147483647)>>>0<o>>>0)if((n|0)>-1){c[l>>2]=o;p=c[j>>2]|0;c[e>>2]=c[j+4>>2];c[d+0>>2]=c[e+0>>2];c[j>>2]=hOb(p,o<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[j+4>>2];c[d+0>>2]=c[e+0>>2];p=cOb(o<<2,4,d,0,3653512,352)|0;YEi(p|0,c[j>>2]|0,c[g>>2]<<2|0)|0;c[l>>2]=o;c[j>>2]=p;break}while(0);o=h+8|0;if(k){k=h+4|0;l=0;g=0;while(1){n=c[a+(l<<2)+40>>2]|0;p=c[a+(l<<2)+104>>2]|0;q=c[a+(l*12|0)+172>>2]|0;r=c[o>>2]|0;if(!((r|0)==0|(q|0)==0)){s=0;do{t=p+(s<<2)|0;c[t>>2]=(c[t>>2]|0)+r;s=s+1|0}while((s|0)!=(q|0))}YEi((c[j>>2]|0)+(g<<2)|0,p|0,q<<2|0)|0;s=q+g|0;r=c[h>>2]|0;t=c[o>>2]|0;u=c[n>>2]|0;v=t<<3>>3;w=t-v|0;x=c[n+8>>2]<<3;y=x>>3;z=y+t|0;c[o>>2]=z;t=c[m>>2]|0;A=t&2147483647;do if(A>>>0<z>>>0?(B=t<<1,C=B>>>0>z>>>0?B:z,A>>>0<C>>>0):0)if((t|0)>-1){c[m>>2]=C;c[e>>2]=c[k>>2];c[d+0>>2]=c[e+0>>2];B=hOb(r,C<<3,4,d,0,3653512,370)|0;c[h>>2]=B;D=B;break}else{c[e>>2]=c[k>>2];c[d+0>>2]=c[e+0>>2];B=cOb(C<<3,4,d,0,3653512,352)|0;YEi(B|0,c[h>>2]|0,c[o>>2]<<3|0)|0;c[m>>2]=C;c[h>>2]=B;D=B;break}else D=r;while(0);r=D+(v<<3)|0;aFi(D+(y+v<<3)|0,r|0,w<<3|0)|0;YEi(r|0,u|0,x|0)|0;l=l+1|0;if((l|0)==(f|0)){E=s;break}else g=s}}else E=0;c[(c[j>>2]|0)+(E<<2)>>2]=c[o>>2];o=c[153136]|0;if(!a){c[e>>2]=o;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}Zac(a);c[e>>2]=o;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function Wac(a,b,d,e,f,h){a=a|0;b=ea(b);d=ea(d);e=ea(e);f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=0;j=i;i=i+16|0;k=j+4|0;l=j;m=c[a>>2]|0;a=c[m+(f*108|0)>>2]|0;n=ea(g[m+(f*108|0)+96>>2]);if((c[a+212>>2]|0)==1)if(!(c[a+116>>2]|0))o=n;else o=ea(n*ea(16.0));else{p=ea(b-ea(g[a+104>>2]));b=ea(d-ea(g[a+108>>2]));d=ea(e-ea(g[a+112>>2]));o=ea(n*ea(z4b(a,ea(ea(ea(p*p)+ea(b*b))+ea(d*d)))))}d=ea(o+ea(t4b(c[a+204>>2]|0)));a=h+8|0;m=(c[a>>2]|0)+1|0;c[a>>2]=m;q=h+12|0;r=c[q>>2]|0;s=r&2147483647;if(m>>>0<=s>>>0){t=m;u=t+-1|0;v=c[h>>2]|0;w=v+(u<<3)|0;x=ea(d);y=w;z=y;c[z>>2]=f;A=y+4|0;B=A;g[B>>2]=x;i=j;return}m=r<<1;C=(m|0)==0?1:m;do if(s>>>0<C>>>0)if((r|0)>-1){c[q>>2]=C;m=c[h>>2]|0;c[l>>2]=c[h+4>>2];c[k+0>>2]=c[l+0>>2];c[h>>2]=hOb(m,C<<3,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[h+4>>2];c[k+0>>2]=c[l+0>>2];m=cOb(C<<3,4,k,0,3653512,352)|0;YEi(m|0,c[h>>2]|0,c[a>>2]<<3|0)|0;c[q>>2]=C;c[h>>2]=m;break}while(0);t=c[a>>2]|0;u=t+-1|0;v=c[h>>2]|0;w=v+(u<<3)|0;x=ea(d);y=w;z=y;c[z>>2]=f;A=y+4|0;B=A;g[B>>2]=x;i=j;return}function Xac(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im;k=i;i=i+432|0;l=k+80|0;m=k+240|0;n=k+304|0;o=k+368|0;p=k+64|0;q=k;r=k+176|0;if(d&(((c[a+12>>2]|0)!=1|e)^1)|(c[a+16>>2]&b|0)==0){s=1;i=k;return s|0}if(!(jmc(f,a+24|0)|0)){s=1;i=k;return s|0}f=c[a>>2]|0;g[l>>2]=ea(0.0);g[l+4>>2]=ea(0.0);g[l+8>>2]=ea(0.0);g[l+16>>2]=ea(0.0);g[l+20>>2]=ea(0.0);g[l+24>>2]=ea(0.0);g[l+32>>2]=ea(0.0);g[l+36>>2]=ea(0.0);g[l+40>>2]=ea(0.0);g[l+48>>2]=ea(0.0);g[l+52>>2]=ea(0.0);g[l+56>>2]=ea(0.0);g[l+64>>2]=ea(0.0);g[l+68>>2]=ea(0.0);g[l+72>>2]=ea(0.0);g[l+80>>2]=ea(0.0);g[l+84>>2]=ea(0.0);g[l+88>>2]=ea(0.0);g[p>>2]=ea(1.0);g[p+4>>2]=ea(1.0);g[p+8>>2]=ea(-1.0);iMc(m,p)|0;t=ea(g[f+184>>2]);u=ea(t*ea(9.99999974e-06));p=u>ea(.0000999999974);v=p?u:ea(.0000999999974);nMc(o,ea(g[f+196>>2]),v,t)|0;dMc(m,f+40|0,q);dMc(q,j,n);dMc(o,n,r);r1b(r,l);s=(pmc(h,l)|0)^1;i=k;return s|0}function Yac(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=i;f=a;a=b;a:while(1){b=a;h=a+-8|0;j=a+-4|0;l=f;b:while(1){m=l;n=b-m|0;o=n>>3;switch(o|0){case 3:{p=l;q=j;r=h;s=6;break a;break}case 4:{t=l;u=h;s=14;break a;break}case 2:{v=l;w=j;x=h;s=4;break a;break}case 5:{y=l;z=j;A=h;s=15;break a;break}case 1:case 0:{s=84;break a;break}default:{}}if((n|0)<248){B=l;C=a;s=21;break a}D=(o|0)/2|0;E=l+(D<<3)|0;do if((n|0)>7992){F=(o|0)/4|0;G=l+(F<<3)|0;H=F+D|0;I=l+(H<<3)|0;J=_ac(l,G,E,I,d)|0;K=ea(g[j>>2]);L=l+(H<<3)+4|0;if(!(K>ea(g[L>>2]))){M=l+(D<<3)+4|0;N=J;break}H=I;O=c[H>>2]|0;P=c[H+4>>2]|0;H=h;Q=c[H+4>>2]|0;R=I;c[R>>2]=c[H>>2];c[R+4>>2]=Q;Q=h;c[Q>>2]=O;c[Q+4>>2]=P;P=J+1|0;K=ea(g[L>>2]);L=l+(D<<3)+4|0;if(K>ea(g[L>>2])){Q=E;O=c[Q>>2]|0;R=c[Q+4>>2]|0;Q=I;H=c[Q+4>>2]|0;S=E;c[S>>2]=c[Q>>2];c[S+4>>2]=H;H=I;c[H>>2]=O;c[H+4>>2]=R;R=J+2|0;K=ea(g[L>>2]);H=l+(F<<3)+4|0;if(K>ea(g[H>>2])){F=G;O=c[F>>2]|0;I=c[F+4>>2]|0;F=E;S=c[F+4>>2]|0;Q=G;c[Q>>2]=c[F>>2];c[Q+4>>2]=S;S=E;c[S>>2]=O;c[S+4>>2]=I;K=ea(g[H>>2]);if(K>ea(g[l+4>>2])){H=l;I=c[H>>2]|0;S=c[H+4>>2]|0;H=G;O=c[H+4>>2]|0;Q=l;c[Q>>2]=c[H>>2];c[Q+4>>2]=O;O=G;c[O>>2]=I;c[O+4>>2]=S;M=L;N=J+4|0}else{M=L;N=J+3|0}}else{M=L;N=R}}else{M=L;N=P}}else{P=l+(D<<3)+4|0;K=ea(g[P>>2]);L=l+4|0;R=K>ea(g[L>>2]);J=ea(g[j>>2])>K;if(!R){if(!J){M=P;N=0;break}R=E;S=c[R>>2]|0;O=c[R+4>>2]|0;R=h;I=c[R+4>>2]|0;G=E;c[G>>2]=c[R>>2];c[G+4>>2]=I;I=h;c[I>>2]=S;c[I+4>>2]=O;K=ea(g[P>>2]);if(!(K>ea(g[L>>2]))){M=P;N=1;break}L=l;O=c[L>>2]|0;I=c[L+4>>2]|0;L=E;S=c[L+4>>2]|0;G=l;c[G>>2]=c[L>>2];c[G+4>>2]=S;S=E;c[S>>2]=O;c[S+4>>2]=I;M=P;N=2;break}I=l;S=c[I>>2]|0;O=c[I+4>>2]|0;if(J){J=h;I=c[J+4>>2]|0;G=l;c[G>>2]=c[J>>2];c[G+4>>2]=I;I=h;c[I>>2]=S;c[I+4>>2]=O;M=P;N=1;break}I=E;G=c[I+4>>2]|0;J=l;c[J>>2]=c[I>>2];c[J+4>>2]=G;G=E;c[G>>2]=S;c[G+4>>2]=O;K=ea(g[j>>2]);if(K>(c[k>>2]=O,ea(g[k>>2]))){G=h;J=c[G+4>>2]|0;I=E;c[I>>2]=c[G>>2];c[I+4>>2]=J;J=h;c[J>>2]=S;c[J+4>>2]=O;M=P;N=2}else{M=P;N=1}}while(0);D=l+4|0;K=ea(g[D>>2]);T=ea(g[M>>2]);do if(K>T){U=h;V=N}else{o=a;n=h;while(1){P=o+-16|0;if((l|0)==(P|0))break;if(ea(g[o+-12>>2])>T){W=P;s=66;break}else{O=n;n=P;o=O}}if((s|0)==66){s=0;o=l;n=c[o>>2]|0;O=c[o+4>>2]|0;o=W;P=c[o+4>>2]|0;J=l;c[J>>2]=c[o>>2];c[J+4>>2]=P;P=W;c[P>>2]=n;c[P+4>>2]=O;U=W;V=N+1|0;break}O=l+8|0;if(K>ea(g[j>>2]))X=O;else{if((O|0)==(h|0)){s=84;break a}else{Y=l;Z=O}while(1){O=Y+16|0;if(K>ea(g[Z+4>>2])){_=Z;break}if((O|0)==(h|0)){s=84;break a}else{P=Z;Z=O;Y=P}}P=_;O=c[P>>2]|0;n=c[P+4>>2]|0;P=h;J=c[P+4>>2]|0;o=_;c[o>>2]=c[P>>2];c[o+4>>2]=J;J=h;c[J>>2]=O;c[J+4>>2]=n;X=_+8|0}if((X|0)==(h|0)){s=84;break a}else{$=X;aa=h}while(1){ba=ea(g[D>>2]);n=$;while(1){J=n+8|0;if(ba>ea(g[n+4>>2])){ca=J;da=n;break}else n=J}n=aa;while(1){J=n+-8|0;if(ba>ea(g[n+-4>>2]))n=J;else{fa=J;break}}if(da>>>0>=fa>>>0){l=da;continue b}n=da;J=c[n>>2]|0;O=c[n+4>>2]|0;n=fa;o=c[n+4>>2]|0;P=da;c[P>>2]=c[n>>2];c[P+4>>2]=o;o=fa;c[o>>2]=J;c[o+4>>2]=O;$=ca;aa=fa}}while(0);D=l+8|0;c:do if(D>>>0<U>>>0){O=D;o=U;J=E;P=V;while(1){K=ea(g[J+4>>2]);n=O;while(1){S=n+8|0;if(ea(g[n+4>>2])>K)n=S;else{ga=S;ha=n;break}}n=o;while(1){S=n+-8|0;if(ea(g[n+-4>>2])>K){ia=S;break}else n=S}if(ha>>>0>ia>>>0){ja=ha;ka=J;la=P;break c}n=ha;S=c[n>>2]|0;I=c[n+4>>2]|0;n=ia;G=c[n+4>>2]|0;L=ha;c[L>>2]=c[n>>2];c[L+4>>2]=G;G=ia;c[G>>2]=S;c[G+4>>2]=I;O=ga;o=ia;J=(J|0)==(ha|0)?ia:J;P=P+1|0}}else{ja=D;ka=E;la=V}while(0);if((ja|0)!=(ka|0)?(K=ea(g[ka+4>>2]),K>ea(g[ja+4>>2])):0){E=ja;D=c[E>>2]|0;P=c[E+4>>2]|0;E=ka;J=c[E+4>>2]|0;o=ja;c[o>>2]=c[E>>2];c[o+4>>2]=J;J=ka;c[J>>2]=D;c[J+4>>2]=P;ma=la+1|0}else ma=la;if(!ma){na=$ac(l,ja,d)|0;P=ja+8|0;if($ac(P,a,d)|0){s=79;break}if(na){l=P;continue}}P=ja;if((P-m|0)>=(b-P|0)){oa=l;pa=ja;s=83;break}Yac(l,ja,d);l=ja+8|0}if((s|0)==79){s=0;if(na){s=84;break}else{f=l;a=ja;continue}}else if((s|0)==83){s=0;Yac(pa+8|0,a,d);f=oa;a=pa;continue}}if((s|0)==4){K=ea(g[w>>2]);if(!(K>ea(g[v+4>>2]))){i=e;return}w=v;pa=c[w>>2]|0;a=c[w+4>>2]|0;w=x;oa=c[w+4>>2]|0;f=v;c[f>>2]=c[w>>2];c[f+4>>2]=oa;oa=x;c[oa>>2]=pa;c[oa+4>>2]=a;i=e;return}else if((s|0)==6){a=p+8|0;oa=p+12|0;K=ea(g[oa>>2]);pa=p+4|0;x=K>ea(g[pa>>2]);f=ea(g[q>>2])>K;if(!x){if(!f){i=e;return}x=a;w=c[x>>2]|0;v=c[x+4>>2]|0;x=r;ja=c[x+4>>2]|0;na=a;c[na>>2]=c[x>>2];c[na+4>>2]=ja;ja=r;c[ja>>2]=w;c[ja+4>>2]=v;K=ea(g[oa>>2]);if(!(K>ea(g[pa>>2]))){i=e;return}pa=p;oa=c[pa>>2]|0;v=c[pa+4>>2]|0;pa=a;ja=c[pa+4>>2]|0;w=p;c[w>>2]=c[pa>>2];c[w+4>>2]=ja;ja=a;c[ja>>2]=oa;c[ja+4>>2]=v;i=e;return}v=p;ja=c[v>>2]|0;oa=c[v+4>>2]|0;if(f){f=r;v=c[f+4>>2]|0;w=p;c[w>>2]=c[f>>2];c[w+4>>2]=v;v=r;c[v>>2]=ja;c[v+4>>2]=oa;i=e;return}v=a;w=c[v+4>>2]|0;f=p;c[f>>2]=c[v>>2];c[f+4>>2]=w;w=a;c[w>>2]=ja;c[w+4>>2]=oa;K=ea(g[q>>2]);if(!(K>(c[k>>2]=oa,ea(g[k>>2])))){i=e;return}q=r;w=c[q+4>>2]|0;f=a;c[f>>2]=c[q>>2];c[f+4>>2]=w;w=r;c[w>>2]=ja;c[w+4>>2]=oa;i=e;return}else if((s|0)==14){_ac(t,t+8|0,t+16|0,u,d)|0;i=e;return}else if((s|0)==15){u=y+8|0;t=y+16|0;oa=y+24|0;_ac(y,u,t,oa,d)|0;K=ea(g[z>>2]);z=y+28|0;if(!(K>ea(g[z>>2]))){i=e;return}d=oa;w=c[d>>2]|0;ja=c[d+4>>2]|0;d=A;r=c[d+4>>2]|0;f=oa;c[f>>2]=c[d>>2];c[f+4>>2]=r;r=A;c[r>>2]=w;c[r+4>>2]=ja;K=ea(g[z>>2]);if(!(K>ea(g[y+20>>2]))){i=e;return}z=t;ja=c[z>>2]|0;r=c[z+4>>2]|0;z=oa;w=c[z>>2]|0;A=c[z+4>>2]|0;z=t;c[z>>2]=w;c[z+4>>2]=A;z=oa;c[z>>2]=ja;c[z+4>>2]=r;K=(c[k>>2]=A,ea(g[k>>2]));if(!(K>ea(g[y+12>>2]))){i=e;return}r=u;z=c[r>>2]|0;ja=c[r+4>>2]|0;r=u;c[r>>2]=w;c[r+4>>2]=A;r=t;c[r>>2]=z;c[r+4>>2]=ja;if(!(K>ea(g[y+4>>2]))){i=e;return}ja=y;r=c[ja>>2]|0;z=c[ja+4>>2]|0;ja=y;c[ja>>2]=w;c[ja+4>>2]=A;A=u;c[A>>2]=r;c[A+4>>2]=z;i=e;return}else if((s|0)==21){z=B+16|0;A=B+8|0;K=ea(g[B+12>>2]);T=ea(g[B+4>>2]);ba=ea(g[B+20>>2]);r=ba>K;do if(K>T){u=B;ja=c[u>>2]|0;w=c[u+4>>2]|0;if(r){u=z;y=c[u+4>>2]|0;t=B;c[t>>2]=c[u>>2];c[t+4>>2]=y;y=z;c[y>>2]=ja;c[y+4>>2]=w;break}y=A;t=c[y+4>>2]|0;u=B;c[u>>2]=c[y>>2];c[u+4>>2]=t;t=A;c[t>>2]=ja;c[t+4>>2]=w;if(ba>(c[k>>2]=w,ea(g[k>>2]))){t=z;u=c[t+4>>2]|0;y=A;c[y>>2]=c[t>>2];c[y+4>>2]=u;u=z;c[u>>2]=ja;c[u+4>>2]=w}}else if(r?(w=A,u=c[w>>2]|0,ja=c[w+4>>2]|0,w=z,y=c[w>>2]|0,t=c[w+4>>2]|0,w=A,c[w>>2]=y,c[w+4>>2]=t,w=z,c[w>>2]=u,c[w+4>>2]=ja,(c[k>>2]=t,ea(g[k>>2]))>T):0){ja=B;w=c[ja>>2]|0;u=c[ja+4>>2]|0;ja=B;c[ja>>2]=y;c[ja+4>>2]=t;t=A;c[t>>2]=w;c[t+4>>2]=u}while(0);A=B+24|0;if((A|0)==(C|0)){i=e;return}else{qa=A;ra=z}while(1){T=ea(g[qa+4>>2]);if(T>ea(g[ra+4>>2])){z=qa;A=c[z>>2]|0;r=c[z+4>>2]|0;T=(c[k>>2]=r,ea(g[k>>2]));z=qa;u=ra;while(1){t=u;w=c[t+4>>2]|0;ja=z;c[ja>>2]=c[t>>2];c[ja+4>>2]=w;if((u|0)==(B|0)){sa=u;break}if(T>ea(g[u+-4>>2])){w=u;u=u+-8|0;z=w}else{sa=u;break}}u=sa;c[u>>2]=A;c[u+4>>2]=r}u=qa+8|0;if((u|0)==(C|0))break;else{z=qa;qa=u;ra=z}}i=e;return}else if((s|0)==84){i=e;return}}function Zac(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+104|0;h=c[g>>2]|0;c[e>>2]=c[153136];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;g=c[a+176>>2]|0;if((g|0)<=0){j=a+4|0;k=c[j>>2]|0;l=c[a>>2]|0;c[e>>2]=l;c[d+0>>2]=c[e+0>>2];eOb(k,d);i=b;return}h=0;do{m=a+(h<<2)+40|0;n=c[m>>2]|0;o=c[153136]|0;if((n|0)!=0?(c[n+12>>2]|0)>-1:0){p=c[n>>2]|0;c[e>>2]=c[n+4>>2];c[d+0>>2]=c[e+0>>2];eOb(p,d);c[n>>2]=0}c[f>>2]=o;c[d+0>>2]=c[f+0>>2];eOb(n,d);c[m>>2]=0;h=h+1|0}while((h|0)<(g|0));j=a+4|0;k=c[j>>2]|0;l=c[a>>2]|0;c[e>>2]=l;c[d+0>>2]=c[e+0>>2];eOb(k,d);i=b;return}function _ac(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=0;f=i;h=b+4|0;j=ea(g[h>>2]);l=a+4|0;m=j>ea(g[l>>2]);n=d+4|0;o=ea(g[n>>2]);p=o>j;do if(m){q=a;r=c[q>>2]|0;s=c[q+4>>2]|0;if(p){q=d;t=c[q+4>>2]|0;u=a;c[u>>2]=c[q>>2];c[u+4>>2]=t;t=d;c[t>>2]=r;c[t+4>>2]=s;v=1;w=(c[k>>2]=s,ea(g[k>>2]));break}t=b;u=c[t+4>>2]|0;q=a;c[q>>2]=c[t>>2];c[q+4>>2]=u;u=b;c[u>>2]=r;c[u+4>>2]=s;j=ea(g[n>>2]);x=(c[k>>2]=s,ea(g[k>>2]));if(j>x){u=d;q=c[u+4>>2]|0;t=b;c[t>>2]=c[u>>2];c[t+4>>2]=q;q=d;c[q>>2]=r;c[q+4>>2]=s;v=2;w=x}else{v=1;w=j}}else if(p){s=b;q=c[s>>2]|0;r=c[s+4>>2]|0;s=d;t=c[s+4>>2]|0;u=b;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=d;c[t>>2]=q;c[t+4>>2]=r;j=ea(g[h>>2]);t=j>ea(g[l>>2]);j=(c[k>>2]=r,ea(g[k>>2]));if(t){t=a;r=c[t>>2]|0;q=c[t+4>>2]|0;t=b;u=c[t+4>>2]|0;s=a;c[s>>2]=c[t>>2];c[s+4>>2]=u;u=b;c[u>>2]=r;c[u+4>>2]=q;v=2;w=ea(g[n>>2])}else{v=1;w=j}}else{v=0;w=o}while(0);if(!(ea(g[e+4>>2])>w)){y=v;i=f;return y|0}p=d;m=c[p>>2]|0;q=c[p+4>>2]|0;p=e;u=c[p+4>>2]|0;r=d;c[r>>2]=c[p>>2];c[r+4>>2]=u;u=e;c[u>>2]=m;c[u+4>>2]=q;w=ea(g[n>>2]);if(!(w>ea(g[h>>2]))){y=v+1|0;i=f;return y|0}n=b;q=c[n>>2]|0;u=c[n+4>>2]|0;n=d;m=c[n+4>>2]|0;e=b;c[e>>2]=c[n>>2];c[e+4>>2]=m;m=d;c[m>>2]=q;c[m+4>>2]=u;w=ea(g[h>>2]);if(!(w>ea(g[l>>2]))){y=v+2|0;i=f;return y|0}l=a;h=c[l>>2]|0;u=c[l+4>>2]|0;l=b;m=c[l+4>>2]|0;q=a;c[q>>2]=c[l>>2];c[q+4>>2]=m;m=b;c[m>>2]=h;c[m+4>>2]=u;y=v+3|0;i=f;return y|0}function $ac(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;switch(b-a>>3|0){case 4:{_ac(a,a+8|0,a+16|0,b+-8|0,d)|0;f=1;i=e;return f|0}case 5:{h=a+8|0;j=a+16|0;l=a+24|0;_ac(a,h,j,l,d)|0;d=a+28|0;if(!(ea(g[b+-4>>2])>ea(g[d>>2]))){f=1;i=e;return f|0}m=b+-8|0;n=l;o=c[n>>2]|0;p=c[n+4>>2]|0;n=m;q=c[n+4>>2]|0;r=l;c[r>>2]=c[n>>2];c[r+4>>2]=q;q=m;c[q>>2]=o;c[q+4>>2]=p;if(!(ea(g[d>>2])>ea(g[a+20>>2]))){f=1;i=e;return f|0}d=j;p=c[d>>2]|0;q=c[d+4>>2]|0;d=l;o=c[d>>2]|0;m=c[d+4>>2]|0;d=j;c[d>>2]=o;c[d+4>>2]=m;d=l;c[d>>2]=p;c[d+4>>2]=q;s=(c[k>>2]=m,ea(g[k>>2]));if(!(s>ea(g[a+12>>2]))){f=1;i=e;return f|0}q=h;d=c[q>>2]|0;p=c[q+4>>2]|0;q=h;c[q>>2]=o;c[q+4>>2]=m;q=j;c[q>>2]=d;c[q+4>>2]=p;if(!(s>ea(g[a+4>>2]))){f=1;i=e;return f|0}p=a;q=c[p>>2]|0;d=c[p+4>>2]|0;p=a;c[p>>2]=o;c[p+4>>2]=m;m=h;c[m>>2]=q;c[m+4>>2]=d;f=1;i=e;return f|0}case 2:{if(!(ea(g[b+-4>>2])>ea(g[a+4>>2]))){f=1;i=e;return f|0}d=b+-8|0;m=a;q=c[m>>2]|0;h=c[m+4>>2]|0;m=d;p=c[m+4>>2]|0;o=a;c[o>>2]=c[m>>2];c[o+4>>2]=p;p=d;c[p>>2]=q;c[p+4>>2]=h;f=1;i=e;return f|0}case 3:{h=a+8|0;p=b+-8|0;q=a+12|0;s=ea(g[q>>2]);d=a+4|0;o=s>ea(g[d>>2]);m=b+-4|0;j=ea(g[m>>2])>s;if(!o){if(!j){f=1;i=e;return f|0}o=h;l=c[o>>2]|0;r=c[o+4>>2]|0;o=p;n=c[o+4>>2]|0;t=h;c[t>>2]=c[o>>2];c[t+4>>2]=n;n=p;c[n>>2]=l;c[n+4>>2]=r;s=ea(g[q>>2]);if(!(s>ea(g[d>>2]))){f=1;i=e;return f|0}d=a;q=c[d>>2]|0;r=c[d+4>>2]|0;d=h;n=c[d+4>>2]|0;l=a;c[l>>2]=c[d>>2];c[l+4>>2]=n;n=h;c[n>>2]=q;c[n+4>>2]=r;f=1;i=e;return f|0}r=a;n=c[r>>2]|0;q=c[r+4>>2]|0;if(j){j=p;r=c[j+4>>2]|0;l=a;c[l>>2]=c[j>>2];c[l+4>>2]=r;r=p;c[r>>2]=n;c[r+4>>2]=q;f=1;i=e;return f|0}r=h;l=c[r+4>>2]|0;j=a;c[j>>2]=c[r>>2];c[j+4>>2]=l;l=h;c[l>>2]=n;c[l+4>>2]=q;if(!(ea(g[m>>2])>(c[k>>2]=q,ea(g[k>>2])))){f=1;i=e;return f|0}m=p;l=c[m+4>>2]|0;j=h;c[j>>2]=c[m>>2];c[j+4>>2]=l;l=p;c[l>>2]=n;c[l+4>>2]=q;f=1;i=e;return f|0}case 1:case 0:{f=1;i=e;return f|0}default:{q=a+16|0;l=a+8|0;s=ea(g[a+12>>2]);u=ea(g[a+4>>2]);v=ea(g[a+20>>2]);n=v>s;do if(s>u){p=a;j=c[p>>2]|0;m=c[p+4>>2]|0;if(n){p=q;h=c[p+4>>2]|0;r=a;c[r>>2]=c[p>>2];c[r+4>>2]=h;h=q;c[h>>2]=j;c[h+4>>2]=m;break}h=l;r=c[h+4>>2]|0;p=a;c[p>>2]=c[h>>2];c[p+4>>2]=r;r=l;c[r>>2]=j;c[r+4>>2]=m;if(v>(c[k>>2]=m,ea(g[k>>2]))){r=q;p=c[r+4>>2]|0;h=l;c[h>>2]=c[r>>2];c[h+4>>2]=p;p=q;c[p>>2]=j;c[p+4>>2]=m}}else if(n?(m=l,p=c[m>>2]|0,j=c[m+4>>2]|0,m=q,h=c[m>>2]|0,r=c[m+4>>2]|0,m=l,c[m>>2]=h,c[m+4>>2]=r,m=q,c[m>>2]=p,c[m+4>>2]=j,(c[k>>2]=r,ea(g[k>>2]))>u):0){j=a;m=c[j>>2]|0;p=c[j+4>>2]|0;j=a;c[j>>2]=h;c[j+4>>2]=r;r=l;c[r>>2]=m;c[r+4>>2]=p}while(0);l=a+24|0;if((l|0)==(b|0)){f=1;i=e;return f|0}else{w=0;x=l;y=q}while(1){u=ea(g[x+4>>2]);if(u>ea(g[y+4>>2])){q=x;l=c[q>>2]|0;n=c[q+4>>2]|0;u=(c[k>>2]=n,ea(g[k>>2]));q=x;p=y;while(1){r=p;m=c[r+4>>2]|0;j=q;c[j>>2]=c[r>>2];c[j+4>>2]=m;if((p|0)==(a|0)){z=p;break}if(u>ea(g[p+-4>>2])){m=p;p=p+-8|0;q=m}else{z=p;break}}p=z;c[p>>2]=l;c[p+4>>2]=n;p=w+1|0;if((p|0)==8){A=x;break}else B=p}else B=w;p=x+8|0;if((p|0)==(b|0)){f=1;C=34;break}else{q=x;w=B;x=p;y=q}}if((C|0)==34){i=e;return f|0}f=(A+8|0)==(b|0);i=e;return f|0}}return 0}function abc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g;if(e>>>0>=f>>>0){j=0;k=a+4|0;c[k>>2]=j;i=g;return}l=b+340|0;m=b+188|0;b=e;e=0;while(1){n=d+(b*24|0)|0;c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[h+16>>2]=c[n+16>>2];c[h+20>>2]=c[n+20>>2];if(smc(h,l,c[m>>2]|0)|0){c[(c[a>>2]|0)+(e<<2)>>2]=b;o=e+1|0}else o=e;b=b+1|0;if((b|0)==(f|0)){j=o;break}else e=o}k=a+4|0;c[k>>2]=j;i=g;return}function bbc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=0,E=0;h=i;i=i+16|0;j=h;k=b+4|0;if((c[k>>2]|0)<=0){l=0;c[k>>2]=l;i=h;return}m=f+4|0;n=f+8|0;o=j+12|0;p=0;q=0;while(1){r=c[b>>2]|0;s=c[r+(p<<2)>>2]|0;t=e+(s*24|0)|0;u=c[d+(s*24|0)>>2]|0;v=c[d+(s*24|0)+4>>2]|0;a:do if(a[u+41>>0]|0){if((a[m>>0]|0)!=0?(c[u+36>>2]&65535)<<16>>16!=255:0){w=q;break}if(c[n>>2]&1<<v){x=c[f>>2]|0;y=ea(g[x+(v<<2)+228>>2]);do if(y!=ea(0.0)){if(a[x+356>>0]|0){z=ea(g[t>>2]);A=ea(z-ea(g[x+196>>2]));z=ea(g[e+(s*24|0)+4>>2]);B=ea(z-ea(g[x+200>>2]));z=ea(g[e+(s*24|0)+8>>2]);C=ea(z-ea(g[x+204>>2]));if(ea(ea(ea(A*A)+ea(B*B))+ea(C*C))>ea(y*y)){w=q;break a}else{D=r;break}}E=x+540|0;c[j+0>>2]=c[E+0>>2];c[j+4>>2]=c[E+4>>2];c[j+8>>2]=c[E+8>>2];g[o>>2]=ea(y+ea(g[x+360>>2]));if(!(qmc(t,j,1)|0)){w=q;break a}D=c[b>>2]|0}else D=r;while(0);c[D+(q<<2)>>2]=c[D+(p<<2)>>2];w=q+1|0}else w=q}else w=q;while(0);p=p+1|0;if((p|0)>=(c[k>>2]|0)){l=w;break}else q=w}c[k>>2]=l;i=h;return}function cbc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=0,A=Im,B=Im,C=Im,D=Im;h=i;i=i+16|0;j=h;k=b+4|0;if((c[k>>2]|0)<=0){l=0;c[k>>2]=l;i=h;return}m=f+4|0;n=f+8|0;o=j+12|0;p=f+12|0;q=0;r=0;while(1){s=c[(c[b>>2]|0)+(q<<2)>>2]|0;t=e+(s*24|0)|0;u=c[d+(s*24|0)>>2]|0;v=c[d+(s*24|0)+4>>2]|0;a:do if(a[u+41>>0]|0){if((a[m>>0]|0)!=0?(c[u+36>>2]&65535)<<16>>16!=255:0){w=r;break}if(c[n>>2]&1<<v){x=c[f>>2]|0;y=ea(g[x+(v<<2)+228>>2]);do if(y!=ea(0.0))if(!(a[x+356>>0]|0)){z=x+540|0;c[j+0>>2]=c[z+0>>2];c[j+4>>2]=c[z+4>>2];c[j+8>>2]=c[z+8>>2];g[o>>2]=ea(y+ea(g[x+360>>2]));if(qmc(t,j,1)|0)break;else{w=r;break a}}else{A=ea(g[t>>2]);B=ea(A-ea(g[x+196>>2]));A=ea(g[e+(s*24|0)+4>>2]);C=ea(A-ea(g[x+200>>2]));A=ea(g[e+(s*24|0)+8>>2]);D=ea(A-ea(g[x+204>>2]));if(ea(ea(ea(B*B)+ea(C*C))+ea(D*D))>ea(y*y)){w=r;break a}else break}while(0);if(mmc(t,p)|0){x=c[b>>2]|0;c[x+(r<<2)>>2]=c[x+(q<<2)>>2];w=r+1|0}else w=r}else w=r}else w=r;while(0);q=q+1|0;if((q|0)>=(c[k>>2]|0)){l=w;break}else r=w}c[k>>2]=l;i=h;return}function dbc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=0,W=Im,X=Im,Y=Im,Z=Im;h=i;i=i+224|0;j=h+128|0;k=h+64|0;l=h;m=b+4|0;if((c[m>>2]|0)<=0){n=0;c[m>>2]=n;i=h;return}o=f+4|0;p=f+8|0;q=j+12|0;r=f+140|0;s=j+4|0;t=j+8|0;u=j+16|0;v=j+20|0;w=j+24|0;x=j+32|0;y=j+36|0;z=j+40|0;A=j+48|0;B=j+52|0;C=j+56|0;D=j+64|0;E=j+68|0;F=j+72|0;G=j+80|0;H=j+84|0;I=j+88|0;J=f+12|0;K=f+76|0;L=0;M=0;while(1){N=c[(c[b>>2]|0)+(L<<2)>>2]|0;O=e+(N*24|0)|0;P=d+(N*24|0)|0;Q=c[P>>2]|0;R=c[d+(N*24|0)+4>>2]|0;a:do if(a[Q+41>>0]|0){if((a[o>>0]|0)!=0?(c[Q+36>>2]&65535)<<16>>16!=255:0){S=M;break}if(c[p>>2]&1<<R){T=c[f>>2]|0;U=ea(g[T+(R<<2)+228>>2]);do if(U!=ea(0.0))if(!(a[T+356>>0]|0)){V=T+540|0;c[j+0>>2]=c[V+0>>2];c[j+4>>2]=c[V+4>>2];c[j+8>>2]=c[V+8>>2];g[q>>2]=ea(U+ea(g[T+360>>2]));if(qmc(O,j,1)|0)break;else{S=M;break a}}else{W=ea(g[O>>2]);X=ea(W-ea(g[T+196>>2]));W=ea(g[e+(N*24|0)+4>>2]);Y=ea(W-ea(g[T+200>>2]));W=ea(g[e+(N*24|0)+8>>2]);Z=ea(W-ea(g[T+204>>2]));if(ea(ea(ea(X*X)+ea(Y*Y))+ea(Z*Z))>ea(U*U)){S=M;break a}else break}while(0);if(pmc(O,r)|0?(T=c[P>>2]|0,g[j>>2]=ea(0.0),g[s>>2]=ea(0.0),g[t>>2]=ea(0.0),g[u>>2]=ea(0.0),g[v>>2]=ea(0.0),g[w>>2]=ea(0.0),g[x>>2]=ea(0.0),g[y>>2]=ea(0.0),g[z>>2]=ea(0.0),g[A>>2]=ea(0.0),g[B>>2]=ea(0.0),g[C>>2]=ea(0.0),g[D>>2]=ea(0.0),g[E>>2]=ea(0.0),g[F>>2]=ea(0.0),g[G>>2]=ea(0.0),g[H>>2]=ea(0.0),g[I>>2]=ea(0.0),dMc(J,T+52|0,k),dMc(K,k,l),r1b(l,j),pmc(T+140|0,j)|0):0){T=c[b>>2]|0;c[T+(M<<2)>>2]=c[T+(L<<2)>>2];S=M+1|0}else S=M}else S=M}else S=M;while(0);L=L+1|0;if((L|0)>=(c[m>>2]|0)){n=S;break}else M=S}c[m>>2]=n;i=h;return}function ebc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d+4|0;g=c[f>>2]|0;if((g|0)<=0){h=0;c[f>>2]=h;i=e;return}j=a+340|0;k=a+188|0;a=0;l=0;while(1){m=c[(c[d>>2]|0)+(a<<2)>>2]|0;if(smc(b+(m*24|0)|0,j,c[k>>2]|0)|0){c[(c[d>>2]|0)+(l<<2)>>2]=m;n=l+1|0}else n=l;a=a+1|0;if((a|0)==(g|0)){h=n;break}else l=n}c[f>>2]=h;i=e;return}function fbc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=GLc()|0;Dn[c[(c[f>>2]|0)+68>>2]&511](f,a,b,d);i=e;return}function gbc(b,f,g,h,j){b=b|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;if(g>>>0>=h>>>0){l=0;m=j+4|0;c[m>>2]=l;i=k;return}n=b+192|0;o=b+668|0;b=g;g=0;while(1){do if(((1<<c[f+(b*24|0)+4>>2]&c[n>>2]|0)!=0?(c[f+(b*24|0)>>2]|0)!=0:0)?(a[f+(b*24|0)+22>>0]|0)==0:0){p=c[f+(b*24|0)+16>>2]|0;if((p|0)!=0?(d[(c[(c[o>>2]|0)+((e[f+(b*24|0)+12>>1]|0)*12|0)>>2]|0)+(e[f+(b*24|0)+14>>1]|0)>>0]&p|0)==0:0){q=g;break}c[(c[j>>2]|0)+(g<<2)>>2]=b;q=g+1|0}else q=g;while(0);b=b+1|0;if((b|0)==(h|0)){l=q;break}else g=q}m=j+4|0;c[m>>2]=l;i=k;return}function hbc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=0;f=i;i=i+16|0;h=f;j=e+4|0;k=c[j>>2]|0;if((k|0)<=0){l=0;c[j>>2]=l;i=f;return}m=a+324|0;n=a+108|0;o=h+12|0;p=a+596|0;q=a+600|0;r=a+604|0;s=0;t=0;while(1){u=c[e>>2]|0;v=c[u+(s<<2)>>2]|0;w=d+(v*24|0)|0;x=c[b+(v*24|0)+4>>2]|0;y=c[m>>2]|0;if((y|0)==1){c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];g[o>>2]=ea(g[a+(x<<2)+196>>2]);if(qmc(w,h,1)|0)z=7;else A=t}else if((y|0)==2?(B=ea(g[a+(x<<2)+196>>2]),!(B==ea(0.0))):0){C=ea(g[w>>2]);D=ea(C-ea(g[p>>2]));C=ea(g[d+(v*24|0)+4>>2]);E=ea(C-ea(g[q>>2]));C=ea(g[d+(v*24|0)+8>>2]);F=ea(C-ea(g[r>>2]));if(ea(ea(ea(D*D)+ea(E*E))+ea(F*F))>ea(B*B))A=t;else z=7}else{G=u;z=8}if((z|0)==7){z=0;G=c[e>>2]|0;z=8}if((z|0)==8){z=0;c[G+(t<<2)>>2]=v;A=t+1|0}s=s+1|0;if((s|0)==(k|0)){l=A;break}else t=A}c[j>>2]=l;i=f;return}function ibc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=e+4|0;h=c[g>>2]|0;if((h|0)<=0){j=0;c[g>>2]=j;i=f;return}k=0;l=0;while(1){m=c[(c[e>>2]|0)+(k<<2)>>2]|0;if(jbc(b+(m*24|0)|0,d+(m*24|0)|0,a)|0){c[(c[e>>2]|0)+(l<<2)>>2]=m;n=l+1|0}else n=l;k=k+1|0;if((k|0)==(h|0)){j=n;break}else l=n}c[g>>2]=j;i=f;return}function jbc(b,f,h){b=b|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im;j=i;i=i+16|0;k=j;l=c[b+4>>2]|0;if(!(1<<l&c[h+192>>2])){m=0;i=j;return m|0}if(!(c[b>>2]|0)){m=0;i=j;return m|0}if(a[b+22>>0]|0){m=0;i=j;return m|0}n=c[b+16>>2]|0;if((n|0)!=0?(d[(c[(c[h+668>>2]|0)+((e[b+12>>1]|0)*12|0)>>2]|0)+(e[b+14>>1]|0)>>0]&n|0)==0:0){m=0;i=j;return m|0}n=c[h+324>>2]|0;if((n|0)==1){b=h+108|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];g[k+12>>2]=ea(g[h+(l<<2)+196>>2]);o=(qmc(f,k,1)|0)^1}else if((n|0)==2?(p=ea(g[h+(l<<2)+196>>2]),!(p==ea(0.0))):0){q=ea(g[f>>2]);r=ea(q-ea(g[h+596>>2]));q=ea(g[f+4>>2]);s=ea(q-ea(g[h+600>>2]));q=ea(g[f+8>>2]);t=ea(q-ea(g[h+604>>2]));o=ea(ea(ea(r*r)+ea(s*s))+ea(t*t))>ea(p*p)}else o=0;m=o^1;i=j;return m|0}function kbc(){return 566744}function lbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=60;c[b+16>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+20>>2]=60;c[b+32>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[b+36>>2]=60;c[b+48>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;c[b+52>>2]=60;c[b+64>>2]=0;c[b+72>>2]=0;c[b+76>>2]=0;c[b+68>>2]=60;c[b+80>>2]=0;c[b+88>>2]=0;c[b+92>>2]=0;c[b+84>>2]=60;c[b+96>>2]=0;c[b+104>>2]=0;c[b+108>>2]=0;c[b+100>>2]=60;c[b+112>>2]=0;c[b+120>>2]=0;c[b+124>>2]=0;c[b+116>>2]=60;c[b+128>>2]=0;c[b+136>>2]=0;c[b+140>>2]=0;c[b+132>>2]=60;c[b+144>>2]=0;c[b+152>>2]=0;c[b+156>>2]=0;c[b+148>>2]=60;c[b+160>>2]=0;c[b+168>>2]=0;c[b+172>>2]=0;c[b+164>>2]=60;c[b+176>>2]=0;c[b+184>>2]=0;c[b+188>>2]=0;c[b+180>>2]=60;c[b+192>>2]=0;c[b+200>>2]=0;c[b+204>>2]=0;c[b+196>>2]=60;c[b+208>>2]=0;c[b+216>>2]=0;c[b+220>>2]=0;c[b+212>>2]=60;c[b+224>>2]=0;c[b+232>>2]=0;c[b+236>>2]=0;c[b+228>>2]=60;c[b+240>>2]=0;c[b+248>>2]=0;c[b+252>>2]=0;c[b+244>>2]=60;c[b+256>>2]=0;c[b+264>>2]=0;c[b+268>>2]=0;c[b+260>>2]=60;c[b+272>>2]=0;c[b+280>>2]=0;c[b+284>>2]=0;c[b+276>>2]=60;c[b+288>>2]=0;c[b+296>>2]=0;c[b+300>>2]=0;c[b+292>>2]=60;c[b+4>>2]=c[153118];c[b+20>>2]=c[153118];c[b+36>>2]=c[153118];c[b+52>>2]=c[153118];c[b+68>>2]=c[153118];c[b+84>>2]=c[153118];c[b+100>>2]=c[153118];c[b+116>>2]=c[153118];c[b+132>>2]=c[153118];c[b+148>>2]=c[153118];c[b+164>>2]=c[153118];c[b+180>>2]=c[153118];c[b+196>>2]=c[153118];c[b+212>>2]=c[153118];c[b+228>>2]=c[153118];c[b+244>>2]=c[153118];c[b+260>>2]=c[153118];c[b+276>>2]=c[153118];c[b+292>>2]=c[153118];g=c[142254]|0;h=c[142256]|0;if(g>>>0<h>>>0){j=g;do{g=SEi(j|0)|0;k=a[j>>0]|0;if(!(k<<24>>24))l=0;else{m=j;n=k;k=0;while(1){o=(k<<4)+(n<<24>>24)|0;p=o&-268435456;q=(p>>>24|p)^o;m=m+1|0;n=a[m>>0]|0;if(!(n<<24>>24)){l=q;break}else k=q}}k=(l>>>0)%19|0;n=b+(k<<4)|0;m=b+(k<<4)+8|0;q=(c[m>>2]|0)+1|0;c[m>>2]=q;o=b+(k<<4)+12|0;p=c[o>>2]|0;r=p&2147483647;if(q>>>0>r>>>0){s=p<<1;t=(s|0)==0?1:s;do if(r>>>0<t>>>0)if((p|0)>-1){c[o>>2]=t;s=c[n>>2]|0;c[f>>2]=c[b+(k<<4)+4>>2];c[e+0>>2]=c[f+0>>2];c[n>>2]=hOb(s,t<<3,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+(k<<4)+4>>2];c[e+0>>2]=c[f+0>>2];s=cOb(t<<3,4,e,0,3653512,352)|0;YEi(s|0,c[n>>2]|0,c[m>>2]<<3|0)|0;c[o>>2]=t;c[n>>2]=s;break}while(0);u=c[m>>2]|0}else u=q;t=(c[n>>2]|0)+(u+-1<<3)|0;c[t>>2]=l;c[t+4>>2]=j;j=j+(g+1)|0}while(j>>>0<h>>>0)}h=0;do{j=b+(h<<4)+12|0;if((c[j>>2]|0)>-1){l=c[b+(h<<4)+8>>2]|0;c[j>>2]=l;j=b+(h<<4)|0;u=c[j>>2]|0;c[f>>2]=c[b+(h<<4)+4>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(u,l<<3,4,e,0,3653512,370)|0}h=h+1|0}while((h|0)<19);i=d;return}function mbc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(!d){f=0;i=e;return f|0}if((c[142254]|0)>>>0<=d>>>0&(c[142256]|0)>>>0>d>>>0){f=d;i=e;return f|0}g=a[d>>0]|0;if(!(g<<24>>24))h=0;else{j=d;k=g;g=0;while(1){l=(g<<4)+(k<<24>>24)|0;m=l&-268435456;n=(m>>>24|m)^l;j=j+1|0;k=a[j>>0]|0;if(!(k<<24>>24)){h=n;break}else g=n}}g=(h>>>0)%19|0;k=c[b+(g<<4)+8>>2]|0;if(!k){f=0;i=e;return f|0}j=c[b+(g<<4)>>2]|0;g=0;while(1){if((c[j+(g<<3)>>2]|0)==(h|0)?(b=c[j+(g<<3)+4>>2]|0,(HEi(b,d)|0)==0):0){f=b;o=10;break}g=g+1|0;if(g>>>0>=k>>>0){f=0;o=10;break}}if((o|0)==10){i=e;return f|0}return 0}function nbc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153118];c[b+0>>2]=c[d+0>>2];d=bOb(304,b,1,16,3653512,59)|0;lbc(d);c[142316]=d;i=a;return}function obc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[142316]|0;g=c[153118]|0;if(f){h=f+304|0;do{j=h;h=h+-16|0;if((c[j+-4>>2]|0)>-1){k=c[h>>2]|0;c[d>>2]=c[j+-12>>2];c[b+0>>2]=c[d+0>>2];eOb(k,b);c[h>>2]=0}}while((h|0)!=(f|0))}c[e>>2]=g;c[b+0>>2]=c[e+0>>2];eOb(f,b);c[142316]=0;i=a;return}function pbc(){return c[142316]|0}function qbc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(((f|0)!=0?(c[142254]|0)>>>0>f>>>0|(c[142256]|0)>>>0<=f>>>0:0)?(g=f+-4|0,c[g>>2]=(c[g>>2]|0)+-1,(c[g>>2]&65535|0)==0):0){c[e>>2]=c[g>>2]<<16;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[a>>2]=c[142314];i=b;return}function rbc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a>>2]|0;if(((g|0)!=0?(c[142254]|0)>>>0>g>>>0|(c[142256]|0)>>>0<=g>>>0:0)?(h=g+-4|0,c[h>>2]=(c[h>>2]|0)+-1,(c[h>>2]&65535|0)==0):0){c[f>>2]=c[h>>2]<<16;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[a>>2]=0;e=c[b>>2]|0;c[a>>2]=e;if(!e){i=d;return}if(!((c[142254]|0)>>>0>e>>>0|(c[142256]|0)>>>0<=e>>>0)){i=d;return}a=e+-4|0;c[a>>2]=(c[a>>2]|0)+1;i=d;return}function sbc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a>>2]|0;if(((g|0)!=0?(c[142254]|0)>>>0>g>>>0|(c[142256]|0)>>>0<=g>>>0:0)?(h=g+-4|0,c[h>>2]=(c[h>>2]|0)+-1,(c[h>>2]&65535|0)==0):0){c[f>>2]=c[h>>2]<<16;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[a>>2]=0;e=c[b>>2]|0;c[a>>2]=e;if(!e){i=d;return}if(!((c[142254]|0)>>>0>e>>>0|(c[142256]|0)>>>0<=e>>>0)){i=d;return}a=e+-4|0;c[a>>2]=(c[a>>2]|0)+1;i=d;return}function tbc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[b>>2]|0;if(((k|0)!=0?(c[142254]|0)>>>0>k>>>0|(c[142256]|0)>>>0<=k>>>0:0)?(l=k+-4|0,c[l>>2]=(c[l>>2]|0)+-1,(c[l>>2]&65535|0)==0):0){c[h>>2]=c[l>>2]<<16;c[g+0>>2]=c[h+0>>2];eOb(l,g)}c[b>>2]=0;l=mbc(pbc()|0,d)|0;c[b>>2]=l;if(l){i=f;return}l=SEi(d|0)|0;c[j>>2]=c[e>>2];c[g+0>>2]=c[j+0>>2];j=cOb(l+5|0,16,g,0,3653512,86)|0;g=j+4|0;c[j>>2]=1;h=c[e>>2]<<16;c[j>>2]=c[j>>2]&65535;c[j>>2]=c[j>>2]|h;YEi(g|0,d|0,l|0)|0;a[j+(l+4)>>0]=0;c[b>>2]=g;i=f;return}function ubc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(((f|0)!=0?(c[142254]|0)>>>0>f>>>0|(c[142256]|0)>>>0<=f>>>0:0)?(g=f+-4|0,c[g>>2]=(c[g>>2]|0)+-1,(c[g>>2]&65535|0)==0):0){c[e>>2]=c[g>>2]<<16;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[a>>2]=0;i=b;return}function vbc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(!f){i=b;return}c[e>>2]=c[153124];c[d+0>>2]=c[e+0>>2];eOb(f,d);i=b;return}function wbc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+256|0;if(a[e>>0]|0){i=d;return}ybc();Erd();f=0;do{g=c[b+(f<<2)+192>>2]|0;if(g)ko[g&4095](b);f=f+1|0}while((f|0)!=16);a[e>>0]=1;i=d;return}function xbc(){var a=0,b=0,d=0;a=i;b=c[142318]|0;if(b){d=b;i=a;return d|0}b=xCi(260)|0;PEi(b|0,0,257)|0;c[142318]=b;d=b;i=a;return d|0}function ybc(){var a=0;a=i;hle();nbh();i=a;return}function zbc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,32)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[142320]=d;i=a;return}function Abc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[142320]|0;f=c[153072]|0;if(e)Bbc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[142320]=0;i=a;return}function Bbc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}Bbc(a,c[b>>2]|0);Bbc(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function Cbc(a,b){a=ea(a);b=ea(b);var d=0,e=Im,f=Im,g=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;d=i;if(a<ea(0.0))e=ea(-a);else e=a;if(b<ea(0.0))f=ea(-b);else f=b;g=~~e;h=~~f;j=g&255;k=h&255;b=ea(e-ea(g|0));e=ea(f-ea(h|0));h=b>ea(1.0);f=h?ea(1.0):b;a=ea(ea(f*ea(f*f))*ea(ea(f*ea(ea(f*ea(6.0))+ea(-15.0)))+ea(10.0)));h=e>ea(1.0);f=h?ea(1.0):e;l=ea(ea(f*ea(f*f))*ea(ea(f*ea(ea(f*ea(6.0))+ea(-15.0)))+ea(10.0)));h=k+(c[569288+(j<<2)>>2]|0)|0;g=(c[569288+(j+1<<2)>>2]|0)+k|0;k=c[569288+(c[569288+(h<<2)>>2]<<2)>>2]|0;j=k&15;f=j>>>0<8?b:e;if(j>>>0<4)m=e;else m=(k&13|0)==12?b:ea(0.0);if(!(k&1))n=f;else n=ea(-f);if(!(k&2))o=m;else o=ea(-m);m=ea(n+o);k=c[569288+(c[569288+(g<<2)>>2]<<2)>>2]|0;o=ea(b+ea(-1.0));j=k&15;n=j>>>0<8?o:e;if(j>>>0<4)p=e;else p=(k&13|0)==12?o:ea(0.0);if(!(k&1))q=n;else q=ea(-n);if(!(k&2))r=p;else r=ea(-p);p=ea(m+ea(a*ea(ea(q+r)-m)));k=c[569288+(c[569288+(h+1<<2)>>2]<<2)>>2]|0;m=ea(e+ea(-1.0));h=k&15;e=h>>>0<8?b:m;if(h>>>0<4)s=m;else s=(k&13|0)==12?b:ea(0.0);if(!(k&1))t=e;else t=ea(-e);if(!(k&2))u=s;else u=ea(-s);s=ea(t+u);k=c[569288+(c[569288+(g+1<<2)>>2]<<2)>>2]|0;g=k&15;u=g>>>0<8?o:m;if(g>>>0<4)v=m;else v=(k&13|0)==12?o:ea(0.0);if(!(k&1))w=u;else w=ea(-u);if(!(k&2)){x=v;y=ea(w+x);z=ea(y-s);A=ea(a*z);B=ea(s+A);C=ea(B-p);D=ea(l*C);E=ea(p+D);i=d;return ea(E)}x=ea(-v);y=ea(w+x);z=ea(y-s);A=ea(a*z);B=ea(s+A);C=ea(B-p);D=ea(l*C);E=ea(p+D);i=d;return ea(E)}function Dbc(b){b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0;d=i;g[b>>2]=ea(5.0);g[b+4>>2]=ea(2.5);g[b+8>>2]=ea(0.0);g[b+12>>2]=ea(1.0);g[b+416>>2]=ea(50.0);g[b+420>>2]=ea(2.0);g[b+624>>2]=ea(.300000012);g[b+628>>2]=ea(.75);g[b+632>>2]=ea(.300000012);e=b+504|0;f=e+120|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[b+756>>2]=ea(.300000012);g[b+760>>2]=ea(.75);g[b+764>>2]=ea(.300000012);e=b+636|0;f=e+120|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[b+968>>2]=ea(20.0);g[b+972>>2]=ea(1.0);g[b+976>>2]=ea(1.0);g[b+980>>2]=ea(.300000012);g[b+984>>2]=ea(.00499999989);g[b+988>>2]=ea(1.0);PEi(b+768|0,0,200)|0;g[b+1192>>2]=ea(20.0);g[b+1196>>2]=ea(1.0);g[b+1200>>2]=ea(1.0);g[b+1204>>2]=ea(.300000012);g[b+1208>>2]=ea(.00499999989);g[b+1212>>2]=ea(1.0);PEi(b+992|0,0,200)|0;g[b+1256>>2]=ea(10.0);g[b+1260>>2]=ea(1.0);g[b+1264>>2]=ea(.00499999989);g[b+1268>>2]=ea(9.0);g[b+1272>>2]=ea(32.0);g[b+1276>>2]=ea(.400000006);g[b+1280>>2]=ea(.0500000007);g[b+1284>>2]=ea(.5);g[b+1288>>2]=ea(.5);g[b+1292>>2]=ea(-.5);g[b+1296>>2]=ea(.5);g[b+1300>>2]=ea(.5);g[b+1304>>2]=ea(0.0);g[b+1308>>2]=ea(.5);g[b+1312>>2]=ea(1.0);g[b+1316>>2]=ea(1.0);g[b+1320>>2]=ea(4.0);g[b+1324>>2]=ea(1.0);g[b+1328>>2]=ea(1.0);PEi(b+16|0,0,400)|0;j=b+1216|0;e=b+424|0;f=e+80|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=j+0|0;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[b+1344>>2]=ea(0.0);g[b+1376>>2]=ea(0.0);h[b+1392>>3]=-1.0;h[b+1400>>3]=0.0;a[b+1408>>0]=0;j=b+1448|0;e=b+1412|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));h[j>>3]=1.0;h[b+1456>>3]=0.0;g[b+1464>>2]=ea(0.0);j=b+1472|0;k=b+1520|0;l=b+1556|0;e=b+1348|0;f=e+28|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(f|0));m=b+1380|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;e=l+0|0;f=e+84|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[m>>2]=ea(1.0);g[b+1504>>2]=ea(1.0);g[b+1536>>2]=ea(1.0);g[b+1492>>2]=ea(1.0);g[b+1384>>2]=ea(0.0);g[b+1508>>2]=ea(0.0);m=b+1540|0;g[b+1496>>2]=ea(0.0);g[b+1388>>2]=ea(0.0);g[b+1512>>2]=ea(0.0);g[b+1500>>2]=ea(0.0);g[b+1340>>2]=ea(0.0);g[b+1336>>2]=ea(0.0);g[b+1332>>2]=ea(0.0);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;i=d;return}function Ebc(a){a=a|0;var b=0,c=Im,d=0;b=i;c=ea(g[a+1380>>2]);if(c!=ea(g[a+1492>>2])){d=1;i=b;return d|0}c=ea(g[a+1384>>2]);if(c!=ea(g[a+1496>>2])){d=1;i=b;return d|0}c=ea(g[a+1388>>2]);if(c!=ea(g[a+1500>>2])){d=1;i=b;return d|0}c=ea(g[a+1376>>2]);d=c!=ea(g[a+1464>>2]);i=b;return d|0}function Fbc(b,d,e){b=b|0;d=d|0;e=+e;var f=0,j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0.0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im;f=i;j=b+1392|0;k=+h[j>>3];if(k==-1.0)l=0.0;else l=e-k;m=b+1400|0;h[m>>3]=l;h[j>>3]=e;if(!d){g[b+1640>>2]=ea(1.0);d=b+1644|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;g[b+1664>>2]=ea(1.0);g[b+1668>>2]=ea(1.0);g[b+1736>>2]=ea(0.0);g[b+1720>>2]=ea(0.0);g[b+1724>>2]=ea(0.0);g[b+1728>>2]=ea(0.0);g[b+1752>>2]=ea(0.0);g[b+1756>>2]=ea(0.0);g[b+1740>>2]=ea(0.0);g[b+1744>>2]=ea(0.0);g[b+1768>>2]=ea(0.0);g[b+1772>>2]=ea(0.0);g[b+1816>>2]=ea(0.0);g[b+1820>>2]=ea(0.0);d=b+1784|0;j=b+1832|0;n=b+1776|0;o=b+1672|0;p=o+40|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;g[n>>2]=ea(1.0);g[b+1824>>2]=ea(1.0);g[b+1864>>2]=ea(0.0);g[b+1868>>2]=ea(0.0);g[b+1872>>2]=ea(0.0);g[b+1876>>2]=ea(1.0);i=f;return}if(a[b+1408>>0]|0)Gbc(b,e);l=+h[b+1528>>3];k=+h[b+1520>>3];if(l!=k){q=(e-k)/(l-k);n=q>0.0;r=ea(q);s=n?r:ea(0.0);t=(n?q:0.0)<1.0?s:ea(1.0)}else t=ea(1.0);s=ea(ea(t*ea(.5))+ea(ea(ea(t*t)*ea(ea(3.0)-ea(t*ea(2.0))))*ea(.5)));n=s<ea(.5);t=ea(g[b+1504>>2]);if(n){r=ea(s*ea(2.0));u=ea(ea(1.0)-r);v=ea(ea(u*ea(g[b+1536>>2]))+ea(r*t));g[b+1380>>2]=v;w=ea(g[b+1540>>2]);x=ea(ea(u*w)+ea(r*ea(g[b+1508>>2])));g[b+1384>>2]=x;w=ea(g[b+1544>>2]);y=ea(ea(u*w)+ea(r*ea(g[b+1512>>2])));z=v;A=x}else{x=ea(ea(s+ea(-.5))*ea(2.0));s=ea(ea(1.0)-x);v=ea(ea(s*t)+ea(x*ea(g[b+1492>>2])));g[b+1380>>2]=v;t=ea(g[b+1508>>2]);r=ea(ea(s*t)+ea(x*ea(g[b+1496>>2])));g[b+1384>>2]=r;t=ea(g[b+1512>>2]);y=ea(ea(s*t)+ea(x*ea(g[b+1500>>2])));z=v;A=r}n=b+1388|0;g[n>>2]=y;j=b+1380|0;d=b+1384|0;r=ea(T(ea(ea(ea(z*z)+ea(A*A))+ea(y*y))));if(r!=ea(0.0)){v=ea(z/r);g[j>>2]=v;z=ea(A/r);g[d>>2]=z;B=v;C=z;D=ea(y/r)}else{g[j>>2]=ea(0.0);g[d>>2]=ea(0.0);B=ea(0.0);C=ea(0.0);D=ea(0.0)}g[n>>2]=D;q=+h[b+1480>>3];k=+h[b+1472>>3];if(q!=k){l=(e-k)/(q-k);o=l>0.0;D=ea(l);r=o?D:ea(0.0);E=(o?l:0.0)<1.0?r:ea(1.0)}else E=ea(0.0);r=ea(g[b+1488>>2]);D=ea(ea(E*ea(0.0))+ea(ea(E*E)*ea(ea(3.0)-ea(E*ea(2.0)))));E=ea(ea(ea(g[b+1464>>2])*D)+ea(r*ea(ea(1.0)-D)));g[b+1376>>2]=E;D=ea(ea(g[b+1412>>2])+E);o=D<ea(1.0);E=o?D:ea(1.0);o=E>ea(0.0);D=o?E:ea(0.0);o=b+1556|0;g[o>>2]=D;E=ea(B*D);B=ea(g[b+1280>>2]);l=+ea(B*E);k=+h[m>>3];p=b+1548|0;g[p>>2]=ea(+ea(g[p>>2])+k*l);l=k*+ea(ea(C*D)*B);p=b+1552|0;g[p>>2]=ea(+ea(g[p>>2])+l);B=ea(D*ea(9.0));p=~~B;F=p+1|0;if((p|0)<=8)if((p|0)<0){G=ea(0.0);H=0;I=0}else{G=ea(B-ea(p|0));H=F;I=p}else{G=ea(0.0);H=9;I=9}B=ea(ea(1.0)-G);l=k;p=0;while(1){D=ea(g[b+(p*40|0)+(I<<2)+16>>2]);C=ea(l*+ea(ea(B*D)+ea(G*ea(g[b+(p*40|0)+(H<<2)+16>>2]))));g[b+(p<<2)+1560>>2]=C;F=b+(p<<2)+1600|0;g[F>>2]=ea(ea(g[F>>2])+C);F=p+1|0;if((F|0)==10)break;l=+h[m>>3];p=F}C=ea(g[j>>2]);g[b+1640>>2]=C;D=ea(g[d>>2]);g[b+1644>>2]=D;E=ea(g[n>>2]);g[b+1648>>2]=E;g[b+1652>>2]=ea(g[o>>2]);r=ea(g[b+(I<<2)+424>>2]);g[b+1660>>2]=ea(ea(B*r)+ea(G*ea(g[b+(H<<2)+424>>2])));g[b+1656>>2]=ea(g[b+1600>>2]);r=ea(g[b+416>>2]);if(r!=ea(0.0))J=ea(ea(1.0)/r);else J=ea(1.0);g[b+1664>>2]=J;g[b+1668>>2]=ea(g[b+420>>2]);J=ea(g[b+(I<<2)+464>>2]);g[b+1736>>2]=ea(ea(B*J)+ea(G*ea(g[b+(H<<2)+464>>2])));J=ea(g[b+(I<<2)+504>>2]);g[b+1676>>2]=ea(ea(B*J)+ea(G*ea(g[b+(H<<2)+504>>2])));g[b+1672>>2]=ea(g[b+1604>>2]);J=ea(g[b+(I<<2)+636>>2]);g[b+1684>>2]=ea(ea(B*J)+ea(G*ea(g[b+(H<<2)+636>>2])));g[b+1680>>2]=ea(g[b+1608>>2]);J=ea(D+ea(g[b+8>>2]));D=ea(T(ea(ea(E*E)+ea(ea(C*C)+ea(J*J)))));if(D!=ea(0.0)){K=ea(C/D);L=ea(J/D);M=ea(E/D)}else{K=ea(0.0);L=ea(0.0);M=ea(0.0)}D=ea(g[b+1332>>2]);E=ea(g[b+1344>>2]);J=ea(K*E);K=ea(g[b+12>>2]);C=ea(D+ea(J*K));J=ea(ea(g[b+1336>>2])+ea(ea(L*E)*K));L=ea(ea(ea(M*E)*K)+ea(g[b+1340>>2]));K=ea(T(ea(ea(ea(C*C)+ea(J*J))+ea(L*L))));if(K==ea(0.0)){N=ea(0.0);O=ea(0.0);P=ea(0.0);Q=ea(0.0)}else{N=K;O=ea(L/K);P=ea(J/K);Q=ea(C/K)}g[b+1720>>2]=Q;g[b+1724>>2]=P;g[b+1728>>2]=O;g[b+1732>>2]=N;N=ea(g[b+(I<<2)+544>>2]);O=ea(ea(B*N)+ea(G*ea(g[b+(H<<2)+544>>2])));o=b+1740|0;g[o>>2]=O;if(a[b+1351>>0]|0)g[o>>2]=ea(O*E);g[b+1752>>2]=ea(g[b+624>>2]);O=ea(g[b+(I<<2)+676>>2]);N=ea(ea(B*O)+ea(G*ea(g[b+(H<<2)+676>>2])));o=b+1744|0;g[o>>2]=N;if(a[b+1357>>0]|0)g[o>>2]=ea(N*E);g[b+1756>>2]=ea(g[b+756>>2]);g[b+1688>>2]=ea(g[b+628>>2]);g[b+1692>>2]=ea(g[b+632>>2]);g[b+1696>>2]=ea(g[b+760>>2]);g[b+1700>>2]=ea(g[b+764>>2]);E=ea(g[b+(I<<2)+584>>2]);g[b+1704>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+584>>2])));E=ea(g[b+(I<<2)+716>>2]);g[b+1708>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+716>>2])));g[b+1768>>2]=ea(g[b+1612>>2]);E=ea(g[b+(I<<2)+768>>2]);g[b+1772>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+768>>2])));g[b+1816>>2]=ea(g[b+1624>>2]);E=ea(g[b+(I<<2)+992>>2]);g[b+1820>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+992>>2])));g[b+1784>>2]=ea(g[b+1616>>2]);E=ea(g[b+(I<<2)+808>>2]);g[b+1788>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+808>>2])));E=ea(g[b+(I<<2)+848>>2]);g[b+1792>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+848>>2])));E=ea(g[b+(I<<2)+888>>2]);g[b+1796>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+888>>2])));g[b+1832>>2]=ea(g[b+1628>>2]);E=ea(g[b+(I<<2)+1032>>2]);g[b+1836>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+1032>>2])));E=ea(g[b+(I<<2)+1072>>2]);g[b+1840>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+1072>>2])));E=ea(g[b+(I<<2)+1112>>2]);g[b+1844>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+1112>>2])));E=ea(g[b+(I<<2)+928>>2]);g[b+1800>>2]=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+928>>2])));E=ea(g[b+(I<<2)+216>>2]);N=ea(ea(B*E)+ea(G*ea(g[b+(H<<2)+216>>2])));if(N<ea(1.1920929e-07))R=ea(0.0);else{E=ea(ea(1.0)/N);R=ea(ea(E*ea(g[b+968>>2]))*ea(10.0))}g[b+1804>>2]=R;g[b+1808>>2]=ea(g[b+1620>>2]);R=ea(g[b+(I<<2)+1152>>2]);g[b+1848>>2]=ea(ea(B*R)+ea(G*ea(g[b+(H<<2)+1152>>2])));R=ea(g[b+(I<<2)+336>>2]);E=ea(ea(B*R)+ea(G*ea(g[b+(H<<2)+336>>2])));if(E<ea(1.1920929e-07))S=ea(0.0);else{R=ea(ea(1.0)/E);S=ea(ea(R*ea(g[b+1192>>2]))*ea(10.0))}g[b+1852>>2]=S;g[b+1856>>2]=ea(g[b+1632>>2]);g[b+1776>>2]=ea(g[b+988>>2]);g[b+1824>>2]=ea(g[b+1212>>2]);g[b+1864>>2]=ea(g[b+1636>>2]);S=ea(g[b+(I<<2)+1216>>2]);g[b+1868>>2]=ea(ea(B*S)+ea(G*ea(g[b+(H<<2)+1216>>2])));g[b+1872>>2]=ea(g[b+1256>>2]);g[b+1876>>2]=ea(g[b+1260>>2]);i=f;return}function Gbc(b,d){b=b|0;d=+d;var e=0,f=0,j=0,k=0.0,l=Im,m=0,n=0,o=0,p=0,q=0,r=0.0,s=Im,t=0,u=0,v=0,w=0,x=Im,y=Im,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=Im,Y=0,Z=Im,_=0,$=Im;e=i;f=b+1432|0;if(!(+h[f>>3]<d)){if(+h[b+1456>>3]>d?+h[b+1424>>3]<d:0)j=4}else j=4;if((j|0)==4){j=b+1400|0;k=+h[j>>3];l=ea(k);if(!(a[571368]|0)){c[142834]=0;c[142836]=1;c[142838]=1812433254;c[142840]=1900727103;m=571368;c[m>>2]=1;c[m+4>>2]=0;n=1;o=1812433254;p=1900727103;q=0;r=+h[j>>3]}else{n=c[142836]|0;o=c[142838]|0;p=c[142840]|0;q=c[142834]|0;r=k}j=q<<11^q;c[142834]=n;c[142836]=o;c[142838]=p;q=p>>>19^p^j^j>>>8;c[142840]=q;s=ea(ea((q&8388607)>>>0)*ea(1.19209304e-07));k=+ea(ea(s*ea(0.0))+ea(l*ea(ea(1.0)-s)));if(k<r*+ea(g[b+1304>>2])*.009999999776482582){h[b+1440>>3]=d;j=b+1412|0;h[b+1448>>3]=+ea(g[j>>2]);s=ea(g[b+1308>>2]);l=ea(g[b+1312>>2]);if(!(a[571368]|0)){c[142834]=0;c[142836]=1;c[142838]=1812433254;c[142840]=1900727103;m=571368;c[m>>2]=1;c[m+4>>2]=0;t=1;u=1812433254;v=1900727103;w=0}else{t=o;u=p;v=q;w=n}n=w<<11^w;c[142834]=t;c[142836]=u;c[142838]=v;w=v>>>19^v^n^n>>>8;c[142840]=w;x=ea(ea((w&8388607)>>>0)*ea(1.19209304e-07));y=ea(ea(s*x)+ea(l*ea(ea(1.0)-x)));r=+y;n=b+1416|0;h[n>>3]=r;x=ea(g[b+1376>>2]);l=ea(ea(1.0)-x);if(y>l){k=+l;h[n>>3]=k;z=k}else z=r;l=ea(g[b>>2]);y=ea(+S(+(z-+x)));x=ea(ea(l*y)+ea(ea(l*ea(.5))*ea(ea(1.0)-y)));if(z>+ea(g[j>>2])){y=ea(g[b+1324>>2]);l=ea(x*ea(2.0));if(!(a[571368]|0)){c[142834]=0;c[142836]=1;c[142838]=1812433254;c[142840]=1900727103;j=571368;c[j>>2]=1;c[j+4>>2]=0;A=0;B=1;C=1812433254;D=1900727103}else{A=t;B=u;C=v;D=w}j=A<<11^A;c[142834]=B;c[142836]=C;c[142838]=D;A=D>>>19^D^j^j>>>8;c[142840]=A;s=ea(ea((A&8388607)>>>0)*ea(1.19209304e-07));z=+ea(y*ea(ea(x*s)+ea(l*ea(ea(1.0)-s))))+d;h[b+1424>>3]=z;E=B;F=C;G=D;H=A;I=z}else{s=ea(g[b+1328>>2]);l=ea(x*ea(2.0));if(!(a[571368]|0)){c[142834]=0;c[142836]=1;c[142838]=1812433254;c[142840]=1900727103;A=571368;c[A>>2]=1;c[A+4>>2]=0;J=0;K=1;L=1812433254;M=1900727103}else{J=t;K=u;L=v;M=w}w=J<<11^J;c[142834]=K;c[142836]=L;c[142838]=M;J=M>>>19^M^w^w>>>8;c[142840]=J;y=ea(ea((J&8388607)>>>0)*ea(1.19209304e-07));z=+ea(s*ea(ea(x*y)+ea(l*ea(ea(1.0)-y))))+d;h[b+1424>>3]=z;E=K;F=L;G=M;H=J;I=z}y=ea(g[b+1316>>2]);l=ea(g[b+1320>>2]);if(!(a[571368]|0)){c[142834]=0;c[142836]=1;c[142838]=1812433254;c[142840]=1900727103;J=571368;c[J>>2]=1;c[J+4>>2]=0;N=1;O=1812433254;P=1900727103;Q=0}else{N=F;O=G;P=H;Q=E}E=Q<<11^Q;c[142834]=N;c[142836]=O;c[142838]=P;Q=P>>>19^P^E^E>>>8;c[142840]=Q;s=ea(ea((Q&8388607)>>>0)*ea(1.19209304e-07));z=I+ +ea(ea(y*s)+ea(l*ea(ea(1.0)-s)));h[b+1456>>3]=z;s=ea(g[b+1328>>2]);l=ea(x*ea(2.0));y=ea(x*ea(3.0));if(!(a[571368]|0)){c[142834]=0;c[142836]=1;c[142838]=1812433254;c[142840]=1900727103;E=571368;c[E>>2]=1;c[E+4>>2]=0;R=0;T=1;U=1812433254;V=1900727103}else{R=N;T=O;U=P;V=Q}Q=R<<11^R;c[142834]=T;c[142836]=U;c[142838]=V;U=V>>>19^V^Q^Q>>>8;c[142840]=U;x=ea(ea((U&8388607)>>>0)*ea(1.19209304e-07));h[f>>3]=z+ +ea(s*ea(ea(l*x)+ea(y*ea(ea(1.0)-x))))}}z=+h[b+1424>>3];if(z>d){x=ea(+h[b+1448>>3]);y=ea(+h[b+1416>>3]);I=+h[b+1440>>3];l=ea((d-I)/(z-I));s=ea(ea(l*ea(0.0))+ea(ea(1.0)/ea(ea(+aa(+ea(-ea(ea(l*ea(6.0))+ea(ea(ea(1.0)-l)*ea(-6.0))))))+ea(1.0))));g[b+1412>>2]=ea(ea(y*s)+ea(x*ea(ea(1.0)-s)));W=b+1412|0;X=ea(g[W>>2]);Y=X<ea(1.0);Z=Y?X:ea(1.0);_=Z>ea(0.0);$=_?Z:ea(0.0);g[W>>2]=$;i=e;return}I=+h[b+1456>>3];if(!(I<d)){W=b+1412|0;X=ea(g[W>>2]);Y=X<ea(1.0);Z=Y?X:ea(1.0);_=Z>ea(0.0);$=_?Z:ea(0.0);g[W>>2]=$;i=e;return}z=+h[f>>3];if(!(z>0.0&z>I)){W=b+1412|0;X=ea(g[W>>2]);Y=X<ea(1.0);Z=Y?X:ea(1.0);_=Z>ea(0.0);$=_?Z:ea(0.0);g[W>>2]=$;i=e;return}s=ea((d-I)/(z-I));x=ea(ea(s*ea(.5))+ea(ea(ea(1.0)/ea(ea(+aa(+ea(-ea(ea(s*ea(6.0))+ea(ea(ea(1.0)-s)*ea(-6.0))))))+ea(1.0)))*ea(.5)));g[b+1412>>2]=ea(ea(x*ea(0.0))+ea(ea(+h[b+1416>>3])*ea(ea(1.0)-x)));W=b+1412|0;X=ea(g[W>>2]);Y=X<ea(1.0);Z=Y?X:ea(1.0);_=Z>ea(0.0);$=_?Z:ea(0.0);g[W>>2]=$;i=e;return}function Hbc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=0,f=0,j=Im,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0.0,u=Im;c=i;d=ea(g[b>>2]);e=a+1492|0;f=b+4|0;if(!(d!=ea(g[e>>2]))){j=ea(g[f>>2]);k=a+1496|0;if(!(!(j!=ea(g[k>>2]))?(j=ea(g[b+8>>2]),!(j!=ea(g[a+1500>>2]))):0)){l=k;m=5}}else{l=a+1496|0;m=5}if((m|0)==5){g[e>>2]=d;j=ea(g[f>>2]);g[l>>2]=j;l=b+8|0;n=ea(g[l>>2]);g[a+1500>>2]=n;o=ea(g[a+1380>>2]);p=ea(o*ea(g[b>>2]));q=ea(g[a+1384>>2]);r=ea(p+ea(q*ea(g[f>>2])));p=ea(g[a+1388>>2]);s=ea(ea(1.0)-ea(ea(ea(r+ea(p*ea(g[l>>2])))+ea(1.0))*ea(.5)));t=+h[a+1392>>3];h[a+1520>>3]=t;r=ea(g[a+4>>2]);h[a+1528>>3]=t+ +ea(ea(r*s)+ea(ea(r*ea(.5))*ea(ea(1.0)-s)));g[a+1536>>2]=o;g[a+1540>>2]=q;g[a+1544>>2]=p;s=ea(ea(o+d)*ea(.5));l=a+1504|0;g[l>>2]=s;d=ea(ea(q+j)*ea(.5));f=a+1508|0;g[f>>2]=d;j=ea(ea(p+n)*ea(.5));e=a+1512|0;g[e>>2]=j;n=ea(T(ea(ea(ea(s*s)+ea(d*d))+ea(j*j))));if(n!=ea(0.0)){g[l>>2]=ea(s/n);g[f>>2]=ea(d/n);u=ea(j/n)}else{g[l>>2]=ea(0.0);g[f>>2]=ea(0.0);u=ea(0.0)}g[e>>2]=u}u=ea(g[b+12>>2]);b=a+1464|0;if(!(u!=ea(g[b>>2]))){i=c;return}t=+h[a+1392>>3];h[a+1472>>3]=t;n=ea(g[a>>2]);j=ea(n*ea(.5));d=ea(g[a+1376>>2]);s=ea(S(ea(u-d)));h[a+1480>>3]=t+ +ea(ea(n*s)+ea(j*ea(ea(1.0)-s)));g[a+1488>>2]=d;g[b>>2]=u;i=c;return}function Ibc(a){a=a|0;return a+1640|0}function Jbc(a,b){a=a|0;b=b|0;var c=0;c=i;YEi(a|0,b|0,1376)|0;i=c;return}function Kbc(a,b){a=a|0;b=b|0;var c=Im,d=0;c=ea(g[a+1560>>2]);g[b>>2]=ea(c+ea(g[b>>2]));c=ea(g[a+1564>>2]);d=b+4|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1568>>2]);d=b+8|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1572>>2]);d=b+12|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1576>>2]);d=b+16|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1580>>2]);d=b+20|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1584>>2]);d=b+24|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1588>>2]);d=b+28|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1592>>2]);d=b+32|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[a+1596>>2]);a=b+36|0;g[a>>2]=ea(c+ea(g[a>>2]));return}function Lbc(a){a=a|0;var b=0,d=0;b=i;d=a+0|0;a=d+44|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function Mbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+1920|0;if(!(a[e>>0]|0)){f=b+1912|0;g=c[f>>2]|0;i=d;return g|0}else{h=b+1380|0;j=b+1912|0;c[j>>2]=zrd(Ard(Ard(Ard(Ard(yrd()|0,b+32|0,1332)|0,b+1364|0,12)|0,b+1376|0,4)|0,h,28)|0)|0;c[b+1916>>2]=zrd(Ard(Ard(Ard(Ard(Ard(Ard(Ard(yrd()|0,b+448|0,4)|0,b+452|0,4)|0,b+456|0,40)|0,b+496|0,40)|0,b+48|0,40)|0,h,1)|0,b+1381|0,1)|0)|0;a[e>>0]=0;f=j;g=c[f>>2]|0;i=d;return g|0}return 0}function Nbc(){return c[142976]|0}function Obc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+4|0;h=c[g>>2]|0;j=a+8|0;k=c[j>>2]|0;if((h|0)!=(k|0)){l=k;k=h;while(1){h=c[k+4>>2]|0;if(!h)m=l;else{dsd(c[142972]|0,h);m=c[j>>2]|0}k=k+8|0;if((k|0)==(m|0)){n=m;break}else l=m}m=c[g>>2]|0;if((n|0)!=(m|0))c[j>>2]=n+(~((n+-8-m|0)>>>3)<<3)}m=a+20|0;n=c[m>>2]|0;l=a+24|0;a=c[l>>2]|0;if((n|0)!=(a|0)){k=n;h=a;while(1){a=c[k+4>>2]|0;if(!a)o=h;else{dsd(c[142972]|0,a);o=c[l>>2]|0}k=k+8|0;if((k|0)==(o|0)){p=o;break}else h=o}o=c[m>>2]|0;if((p|0)==(o|0)){q=o;r=p}else{m=p+(~((p+-8-o|0)>>>3)<<3)|0;c[l>>2]=m;q=o;r=m}}else{q=n;r=n}if(q){if((r|0)!=(q|0))c[l>>2]=r+(~((r+-8-q|0)>>>3)<<3);c[e>>2]=54;c[d+0>>2]=c[e+0>>2];eOb(q,d)}q=c[g>>2]|0;if(!q){i=b;return}g=c[j>>2]|0;if((g|0)!=(q|0))c[j>>2]=g+(~((g+-8-q|0)>>>3)<<3);c[f>>2]=54;c[d+0>>2]=c[f+0>>2];eOb(q,d);i=b;return}function Pbc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im;f=i;i=i+48|0;h=f;j=Qbc(a,d,e)|0;if(!j){Lbc(h);e=b+0|0;d=h+0|0;h=e+44|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(h|0));i=f;return j|0}k=ea(g[b>>2]);l=ea(g[a+48>>2]);if(!(k!=l)){i=f;return j|0}g[b>>2]=l;Kbc(j+24|0,b+4|0);i=f;return j|0}function Qbc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im;f=i;i=i+96|0;h=f+64|0;j=f+32|0;k=f+12|0;l=f+16|0;m=f+80|0;n=f;o=f+24|0;p=f+48|0;q=f+40|0;r=b+44|0;s=ea(g[r>>2]);t=b+48|0;if(s!=ea(g[t>>2])){u=dcc(acc()|0)|0;v=c[u+4>>2]|0;if((v|0)==(u|0)){w=ea(0.0);x=ea(0.0);y=ea(0.0)}else{z=h+4|0;A=h+8|0;B=h+12|0;C=v;s=ea(0.0);D=ea(0.0);E=ea(0.0);while(1){v=c[C+8>>2]|0;if((c[v+32>>2]|0)==0?_bc(v,578048,h)|0:0){F=ea(g[h>>2]);G=ea(g[z>>2]);H=ea(g[A>>2]);I=ea(g[B>>2]);J=ea(E+ea(H*I));K=ea(D+ea(G*I));L=ea(s+ea(F*I))}else{J=E;K=D;L=s}C=c[C+4>>2]|0;if((C|0)==(u|0)){w=L;x=K;y=J;break}else{s=L;D=K;E=J}}}g[b+32>>2]=w;g[b+36>>2]=x;g[b+40>>2]=y;g[r>>2]=ea(g[t>>2])}t=b+32|0;c[n+0>>2]=c[t+0>>2];c[n+4>>2]=c[t+4>>2];c[n+8>>2]=c[t+8>>2];t=Mbc(e)|0;r=b+4|0;u=c[r>>2]|0;C=b+8|0;B=c[C>>2]|0;A=B-u>>3;if(!A)M=u;else{z=u;u=A;while(1){A=(u|0)/2|0;if((c[z+(A<<3)>>2]|0)>>>0<t>>>0){N=z+(A+1<<3)|0;O=u+-1-A|0}else{N=z;O=A}if(!O){M=N;break}else{z=N;u=O}}}if(((M|0)!=(B|0)?(c[M>>2]|0)>>>0<=t>>>0:0)?(t=c[M+4>>2]|0,(t|0)!=0):0){P=t;Q=27}else Q=16;do if((Q|0)==16){y=ea(g[n>>2]);if((!(y!=ea(g[150284]))?(y=ea(g[n+4>>2]),!(y!=ea(g[150285]))):0)?(y=ea(g[n+8>>2]),!(y!=ea(g[150286]))):0){R=0;break}t=Ubc(b,578048,0,e+32|0,n)|0;M=Mbc(e)|0;c[o>>2]=M;c[o+4>>2]=t;B=c[r>>2]|0;O=c[C>>2]|0;u=O-B>>3;if(!u)S=B;else{N=B;B=u;while(1){u=(B|0)/2|0;if((c[N+(u<<3)>>2]|0)>>>0<M>>>0){U=N+(u+1<<3)|0;V=B+-1-u|0}else{U=N;V=u}if(!V){S=U;break}else{N=U;B=V}}}if(!((S|0)!=(O|0)?M>>>0>=(c[S>>2]|0)>>>0:0)){c[k>>2]=S;c[h+0>>2]=c[k+0>>2];Xbc(j,b+4|0,h,o)}if(!t)R=0;else{P=t;Q=27}}while(0);do if((Q|0)==27){if(!(ea(g[P+1400>>2])>ea(0.0))?!(Ebc(P+24|0)|0):0){R=0;break}a[P+1904>>0]=1;R=P}while(0);P=dcc(acc()|0)|0;Q=c[P+4>>2]|0;if((Q|0)==(P|0)){W=ea(0.0);X=ea(0.0);Y=ea(0.0)}else{o=h+4|0;j=h+8|0;k=h+12|0;S=Q;y=ea(0.0);x=ea(0.0);w=ea(0.0);while(1){Q=c[S+8>>2]|0;if((c[Q+32>>2]|0)==1?_bc(Q,d,h)|0:0){J=ea(g[h>>2]);E=ea(g[o>>2]);K=ea(g[j>>2]);D=ea(g[k>>2]);Z=ea(w+ea(K*D));_=ea(x+ea(E*D));$=ea(y+ea(J*D))}else{Z=w;_=x;$=y}S=c[S+4>>2]|0;if((S|0)==(P|0)){W=$;X=_;Y=Z;break}else{y=$;x=_;w=Z}}}c[h>>2]=Mbc(e)|0;P=zrd(Ard(Ard(yrd()|0,d,24)|0,h,4)|0)|0;S=b+20|0;k=c[S>>2]|0;j=b+24|0;o=c[j>>2]|0;Q=o-k>>3;if(!Q)aa=k;else{V=k;k=Q;while(1){Q=(k|0)/2|0;if((c[V+(Q<<3)>>2]|0)>>>0<P>>>0){ba=V+(Q+1<<3)|0;ca=k+-1-Q|0}else{ba=V;ca=Q}if(!ca){aa=ba;break}else{V=ba;k=ca}}}if(((aa|0)!=(o|0)?(c[aa>>2]|0)>>>0<=P>>>0:0)?(o=c[aa+4>>2]|0,(o|0)!=0):0)da=o;else{o=W!=ea(g[150284]);aa=o|X!=ea(g[150285]);if(!(aa|Y!=ea(g[150286]))){fa=R;i=f;return fa|0}Z=ea(W+ea(g[n>>2]));W=ea(X+ea(g[n+4>>2]));X=ea(Y+ea(g[n+8>>2]));g[p>>2]=Z;g[p+4>>2]=W;g[p+8>>2]=X;aa=Ubc(b,d,R,e+32|0,p)|0;c[q>>2]=P;c[q+4>>2]=aa;p=c[S>>2]|0;S=c[j>>2]|0;j=S-p>>3;if(!j)ga=p;else{e=p;p=j;while(1){j=(p|0)/2|0;if((c[e+(j<<3)>>2]|0)>>>0<P>>>0){ha=e+(j+1<<3)|0;ia=p+-1-j|0}else{ha=e;ia=j}if(!ia){ga=ha;break}else{e=ha;p=ia}}}if(!((ga|0)!=(S|0)?P>>>0>=(c[ga>>2]|0)>>>0:0)){c[m>>2]=ga;c[h+0>>2]=c[m+0>>2];Xbc(l,b+20|0,h,q)}if(!aa){fa=R;i=f;return fa|0}else da=aa}if(!(Ebc(da+24|0)|0)?(X=ea(g[da+1516>>2]),W=ea(g[da+1520>>2]),Z=ea(g[da+1524>>2]),Y=ea(g[150276]),w=ea(g[n>>2]),_=ea(w-X),X=ea(g[n+4>>2]),x=ea(X-W),W=ea(g[n+8>>2]),$=ea(W-Z),ea(ea(ea(_*_)+ea(x*x))+ea($*$))<=ea(Y*Y)):0){Y=ea(ea(g[da+1400>>2])-ea(T(ea(ea(ea(w*w)+ea(X*X))+ea(W*W)))));if(Y<ea(0.0))ja=ea(-Y);else ja=Y;if(ja<=ea(9.99999997e-07)){fa=R;i=f;return fa|0}}a[da+1904>>0]=1;fa=da;i=f;return fa|0}function Rbc(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+288|0;c[a+8>>2]=0;c[a+24>>2]=0;c[a+32>>2]=c[155410];nld(a,571864,ea(0.0));if(b){old(a,571376,d+80|0);old(a,571400,d+208|0);old(a,571544,d+112|0);i=d;return}else{old(a,571376,d+128|0);old(a,571400,d+96|0);old(a,571424,d+176|0);old(a,571448,d+240|0);old(a,571480,d+48|0);old(a,571512,d+160|0);old(a,571544,d+192|0);old(a,571584,d+224|0);old(a,571616,d+256|0);old(a,571648,d+272|0);old(a,571680,d+32|0);old(a,571712,d+16|0);old(a,571744,d);old(a,571776,d+144|0);old(a,571808,d+64|0);i=d;return}}function Sbc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0;h=i;if(!b)Rbc(a,d);b=c[a+16>>2]|0;if(!e){PEi(b|0,0,(d?52:244)|0)|0;xld(a);i=h;return}j=b+4|0;g[b>>2]=ea(1.0);k=Ibc(e+24|0)|0;if(d){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];d=b+36|0;e=k+96|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];g[b+20>>2]=ea(0.0);xld(a);i=h;return}else{YEi(j|0,k|0,240)|0;g[b+20>>2]=ea(g[f+4>>2]);g[b+36>>2]=ea(g[f+8>>2]);g[b+44>>2]=ea(g[f+12>>2]);g[b+132>>2]=ea(g[f+16>>2]);g[b+148>>2]=ea(g[f+20>>2]);g[b+172>>2]=ea(g[f+24>>2]);g[b+180>>2]=ea(g[f+28>>2]);g[b+196>>2]=ea(g[f+32>>2]);g[b+220>>2]=ea(g[f+36>>2]);g[b+228>>2]=ea(g[f+40>>2]);xld(a);i=h;return}}function Tbc(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=b+44|0;k=ea(g[j>>2]);l=b+48|0;if(k!=ea(g[l>>2])){m=dcc(acc()|0)|0;n=c[m+4>>2]|0;if((n|0)==(m|0)){o=ea(0.0);p=ea(0.0);q=ea(0.0)}else{r=f+4|0;s=f+8|0;t=f+12|0;u=n;k=ea(0.0);v=ea(0.0);w=ea(0.0);while(1){n=c[u+8>>2]|0;if((c[n+32>>2]|0)==0?_bc(n,578048,f)|0:0){x=ea(g[f>>2]);y=ea(g[r>>2]);z=ea(g[s>>2]);A=ea(g[t>>2]);B=ea(w+ea(z*A));C=ea(v+ea(y*A));D=ea(k+ea(x*A))}else{B=w;C=v;D=k}u=c[u+4>>2]|0;if((u|0)==(m|0)){o=D;p=C;q=B;break}else{k=D;v=C;w=B}}}g[b+32>>2]=o;g[b+36>>2]=p;g[b+40>>2]=q;g[j>>2]=ea(g[l>>2]);E=o;F=p;G=q}else{q=ea(g[b+32>>2]);p=ea(g[b+36>>2]);E=q;F=p;G=ea(g[b+40>>2])}j=b+4|0;m=c[j>>2]|0;u=b+8|0;t=c[u>>2]|0;if((m|0)!=(t|0)){p=ea(ea(ea(E*E)+ea(F*F))+ea(G*G));s=f+4|0;r=f+8|0;n=f+12|0;H=+d;I=h+4|0;J=h+8|0;K=h+12|0;L=t;t=m;while(1){m=t+4|0;M=c[m>>2]|0;if(!(a[M+1904>>0]|0)){if(!M)N=L;else{dsd(c[142972]|0,M);N=c[u>>2]|0}O=c[j>>2]|0;P=t-O>>3;Q=O+(P<<3)|0;R=P+1|0;P=O+(R<<3)|0;if((P|0)==(N|0))S=Q;else{U=P;V=Q;while(1){c[V>>2]=c[U>>2];c[V+4>>2]=c[U+4>>2];U=U+8|0;if((U|0)==(N|0))break;else V=V+8|0}S=O+(((N+-8-P|0)>>>3)+R<<3)|0}if((N|0)==(S|0)){W=Q;X=N}else{V=N+(~((N+-8-S|0)>>>3)<<3)|0;c[u>>2]=V;W=Q;X=V}}else{V=M+24|0;q=ea(T(ea(p)));if(q<ea(0.0))Y=ea(-q);else Y=q;if(!(Y<=ea(9.99999997e-07))){o=ea(F/q);B=ea(G/q);g[f>>2]=ea(E/q);g[s>>2]=o;g[r>>2]=B;g[n>>2]=q;Hbc(V,f)}else{q=ea(g[M+1516>>2]);B=ea(g[M+1520>>2]);o=ea(g[M+1524>>2]);g[h>>2]=q;g[I>>2]=B;g[J>>2]=o;g[K>>2]=ea(0.0);Hbc(V,h)}Fbc((c[m>>2]|0)+24|0,1,H);a[(c[m>>2]|0)+1904>>0]=0;W=t+8|0;X=c[u>>2]|0}if((W|0)==(X|0))break;else{L=X;t=W}}}W=b+20|0;t=c[W>>2]|0;X=b+24|0;b=c[X>>2]|0;if((t|0)==(b|0)){g[l>>2]=d;i=e;return}L=f+4|0;u=f+8|0;K=f+12|0;H=+d;J=h+4|0;I=h+8|0;n=h+12|0;r=f+4|0;s=f+8|0;S=f+12|0;N=t;t=b;while(1){b=N+4|0;j=c[b>>2]|0;if(!(a[j+1904>>0]|0)){if(!j)Z=t;else{dsd(c[142972]|0,j);Z=c[X>>2]|0}V=c[W>>2]|0;U=N-V>>3;_=V+(U<<3)|0;$=U+1|0;U=V+($<<3)|0;if((U|0)==(Z|0))aa=_;else{ba=U;ca=_;while(1){c[ca>>2]=c[ba>>2];c[ca+4>>2]=c[ba+4>>2];ba=ba+8|0;if((ba|0)==(Z|0))break;else ca=ca+8|0}aa=V+(((Z+-8-U|0)>>>3)+$<<3)|0}if((Z|0)==(aa|0)){da=_;fa=Z}else{ca=Z+(~((Z+-8-aa|0)>>>3)<<3)|0;c[X>>2]=ca;da=_;fa=ca}}else{ca=dcc(acc()|0)|0;ba=c[ca+4>>2]|0;if((ba|0)==(ca|0)){ga=ea(0.0);ha=ea(0.0);ia=ea(0.0)}else{m=ba;Y=ea(0.0);p=ea(0.0);o=ea(0.0);while(1){ba=c[m+8>>2]|0;if((c[ba+32>>2]|0)==1?_bc(ba,j,f)|0:0){B=ea(g[f>>2]);q=ea(g[r>>2]);w=ea(g[s>>2]);C=ea(g[S>>2]);ja=ea(o+ea(w*C));ka=ea(p+ea(q*C));la=ea(Y+ea(B*C))}else{ja=o;ka=p;la=Y}m=c[m+4>>2]|0;if((m|0)==(ca|0)){ga=la;ha=ka;ia=ja;break}else{Y=la;p=ka;o=ja}}}ca=c[b>>2]|0;m=ca+24|0;o=ea(E+ga);p=ea(F+ha);Y=ea(G+ia);C=ea(T(ea(ea(Y*Y)+ea(ea(p*p)+ea(o*o)))));if(C<ea(0.0))ma=ea(-C);else ma=C;if(!(ma<=ea(9.99999997e-07))){B=ea(p/C);p=ea(Y/C);g[f>>2]=ea(o/C);g[L>>2]=B;g[u>>2]=p;g[K>>2]=C;Hbc(m,f)}else{C=ea(g[ca+1516>>2]);p=ea(g[ca+1520>>2]);B=ea(g[ca+1524>>2]);g[h>>2]=C;g[J>>2]=p;g[I>>2]=B;g[n>>2]=ea(0.0);Hbc(m,h)}Fbc((c[b>>2]|0)+24|0,1,H);a[(c[b>>2]|0)+1904>>0]=0;da=N+8|0;fa=c[X>>2]|0}if((da|0)==(fa|0))break;else{N=da;t=fa}}g[l>>2]=d;i=e;return}function Ubc(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0;j=i;i=i+32|0;k=j+16|0;l=j;m=csd(c[142972]|0,1912)|0;n=m+24|0;PEi(m|0,0,1912)|0;Dbc(n);c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];c[m+16>>2]=c[d+16>>2];c[m+20>>2]=c[d+20>>2];if(!e){Jbc(n,f);Fbc(n,1,+ea(g[b+48>>2]))}else YEi(n|0,e+24|0,1880)|0;o=ea(g[h>>2]);p=ea(o*o);q=ea(g[h+4>>2]);r=ea(p+ea(q*q));p=ea(g[h+8>>2]);s=ea(T(ea(r+ea(p*p))));if(s<ea(0.0))t=ea(-s);else t=s;if(!(t<=ea(9.99999997e-07))){t=ea(q/s);q=ea(p/s);g[k>>2]=ea(o/s);g[k+4>>2]=t;g[k+8>>2]=q;g[k+12>>2]=s;Hbc(n,k);u=m+1904|0;a[u>>0]=1;i=j;return m|0}else{s=ea(g[m+1516>>2]);q=ea(g[m+1520>>2]);t=ea(g[m+1524>>2]);g[l>>2]=s;g[l+4>>2]=q;g[l+8>>2]=t;g[l+12>>2]=ea(0.0);Hbc(n,l);u=m+1904|0;a[u>>0]=1;i=j;return m|0}return 0}function Vbc(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,571384);c[142844]=c[b>>2];c[b>>2]=-1;itd(b,571408);c[142850]=c[b>>2];c[b>>2]=-1;itd(b,571432);c[142856]=c[b>>2];c[b>>2]=-1;itd(b,571456);c[142862]=c[b>>2];c[b>>2]=-1;itd(b,571488);c[142870]=c[b>>2];c[b>>2]=-1;itd(b,571520);c[142878]=c[b>>2];c[b>>2]=-1;itd(b,571552);c[142886]=c[b>>2];c[b>>2]=-1;itd(b,571592);c[142896]=c[b>>2];c[b>>2]=-1;itd(b,571624);c[142904]=c[b>>2];c[b>>2]=-1;itd(b,571656);c[142912]=c[b>>2];c[b>>2]=-1;itd(b,571688);c[142920]=c[b>>2];c[b>>2]=-1;itd(b,571720);c[142928]=c[b>>2];c[b>>2]=-1;itd(b,571752);c[142936]=c[b>>2];c[b>>2]=-1;itd(b,571784);c[142944]=c[b>>2];c[b>>2]=-1;itd(b,571816);c[142952]=c[b>>2];c[b>>2]=-1;itd(b,571840);c[b>>2]=-1;itd(b,571872);c[142966]=c[b>>2];Drd(571896,111,112,0);i=a;return}function Wbc(){var a=0,b=0;a=i;b=c[142976]|0;Tbc(b,ea(+h[(jLc()|0)+88>>3]));i=a;return}function Xbc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[b>>2]|0;l=k;m=(c[d>>2]|0)-l>>3;d=k+(m<<3)|0;n=b+4|0;o=c[n>>2]|0;p=b+8|0;q=c[p>>2]|0;if(o>>>0<q>>>0){if((d|0)==(o|0)){if(!d)r=0;else{s=e;t=c[s+4>>2]|0;u=d;c[u>>2]=c[s>>2];c[u+4>>2]=t;r=c[n>>2]|0}c[n>>2]=r+8;v=d;c[a>>2]=v;i=f;return}r=o-(k+(m+1<<3))>>3;t=k+(r+m<<3)|0;if(t>>>0<o>>>0){u=o;s=t;while(1){if(!u)w=0;else{x=s;y=c[x+4>>2]|0;z=u;c[z>>2]=c[x>>2];c[z+4>>2]=y;w=c[n>>2]|0}s=s+8|0;y=w+8|0;c[n>>2]=y;if(s>>>0>=o>>>0){A=y;break}else u=y}}else A=o;if(r){r=t;t=o;do{u=t;t=t+-8|0;s=r;r=r+-8|0;c[t>>2]=c[r>>2];c[u+-4>>2]=c[s+-4>>2]}while((r|0)!=(d|0))}if(d>>>0>e>>>0)B=e;else B=A>>>0>e>>>0?e+8|0:e;c[d>>2]=c[B>>2];c[k+(m<<3)+4>>2]=c[B+4>>2];v=d;c[a>>2]=v;i=f;return}B=(o-l>>3)+1|0;if((B|0)<0)vxi(b);l=k;k=q-l|0;if(k>>3>>>0<1073741823){q=k>>2;k=q>>>0<B>>>0?B:q;q=d;B=q-l>>3;if(!k){C=0;D=q;E=0;F=B}else{G=k;H=B;I=q;J=20}}else{q=d;G=2147483647;H=q-l>>3;I=q;J=20}if((J|0)==20){c[h>>2]=54;c[g+0>>2]=c[h+0>>2];C=G;D=I;E=cOb(G<<3,16,g,0,3653512,80)|0;F=H}H=E+(F<<3)|0;G=E+(C<<3)|0;do if((F|0)==(C|0)){if((F|0)>0){K=E+(((F+1|0)/-2|0)+F<<3)|0;L=G;break}I=(F|0)==0?1:F<<1;c[h>>2]=54;c[g+0>>2]=c[h+0>>2];J=cOb(I<<3,16,g,0,3653512,80)|0;q=J+(I>>>2<<3)|0;l=J+(I<<3)|0;if(!E){K=q;L=l}else{c[h>>2]=54;c[g+0>>2]=c[h+0>>2];eOb(E,g);K=q;L=l}}else{K=H;L=G}while(0);if(!K)M=0;else{G=e;e=c[G+4>>2]|0;H=K;c[H>>2]=c[G>>2];c[H+4>>2]=e;M=K}e=c[b>>2]|0;H=D-e|0;G=K+(0-(H>>3)<<3)|0;YEi(G|0,e|0,H|0)|0;H=(c[n>>2]|0)-D|0;YEi(M+8|0,d|0,H|0)|0;d=c[b>>2]|0;c[b>>2]=G;c[n>>2]=M+((H>>3)+1<<3);c[p>>2]=L;if(!d){v=K;c[a>>2]=v;i=f;return}c[j>>2]=54;c[g+0>>2]=c[j+0>>2];eOb(d,g);v=K;c[a>>2]=v;i=f;return}function Ybc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+12|0;d=a+8|0;e=a+4|0;f=a;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];d=bOb(44,b,0,16,3653512,55)|0;c[e>>2]=c[153116];c[b+0>>2]=c[e+0>>2];_rd(d,1,571912,1912,38240,b,16);c[142972]=d;c[f>>2]=c[153116];c[b+0>>2]=c[f+0>>2];f=bOb(52,b,0,16,3653512,58)|0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;b=f+20|0;g[f+48>>2]=ea(0.0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[141990]=113;c[142976]=f;i=a;return}function Zbc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[142976]|0;f=c[153116]|0;if(e)Obc(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[142976]=0;e=c[142972]|0;f=c[153126]|0;if(e)$rd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[142972]=0;i=a;return}function _bc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=0,s=Im,t=0;e=i;i=i+32|0;f=e+12|0;h=e;j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(g[b+8>>2]);m=ea(g[b+16>>2]);n=ea(k+ea(ea(ea(k+m)-ea(k-m))*ea(.25)));o=BTb(c[a+24>>2]|0)|0;rGc(f,o);if(!(c[a+32>>2]|0)){TGc(h,o,601200);m=ea(g[h>>2]);k=ea(m*m);o=h+4|0;p=ea(g[o>>2]);q=ea(k+ea(p*p));r=h+8|0;k=ea(g[r>>2]);s=ea(T(ea(q+ea(k*k))));q=ea(m/s);m=ea(p/s);p=ea(k/s);g[h>>2]=q;g[o>>2]=m;g[r>>2]=p;s=ea(g[a+40>>2]);g[d>>2]=q;g[d+4>>2]=m;g[d+8>>2]=p;g[d+12>>2]=s;t=1;i=e;return t|0}s=ea(Qlc(f,b));p=ea(g[a+36>>2]);if(!(ea(ea(1.0)-ea(s/ea(p*p)))>ea(0.0))){t=0;i=e;return t|0}p=ea(j-ea(g[f>>2]));j=ea(n-ea(g[f+4>>2]));n=ea(l-ea(g[f+8>>2]));l=ea(T(ea(ea(ea(p*p)+ea(j*j))+ea(n*n))));s=ea(p/l);p=ea(j/l);j=ea(n/l);l=ea(g[a+40>>2]);g[d>>2]=s;g[d+4>>2]=p;g[d+8>>2]=j;g[d+12>>2]=l;t=1;i=e;return t|0}function $bc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=0,t=Im;f=i;i=i+32|0;h=f+12|0;j=f;k=ea(g[d>>2]);l=ea(g[d+4>>2]);m=ea(g[d+8>>2]);n=ea(g[d+16>>2]);o=ea(l+ea(ea(ea(l+n)-ea(l-n))*ea(.25)));n=ea(e*ea(3.14159274));e=ea(ea(m*ea(.100000001))+ea(ea(k*ea(.100000001))+ea(n*ea(g[b+52>>2]))));n=ea(ea(ea(ea(+V(+e))+ea(+V(+ea(e*ea(.375)))))+ea(+V(+ea(e*ea(.0500000007)))))*ea(.333000004));e=ea(ea(ea(g[b+48>>2])*n)+ea(1.0));p=BTb(c[b+24>>2]|0)|0;rGc(h,p);if(!(c[b+32>>2]|0)){TGc(j,p,601200);n=ea(g[j>>2]);l=ea(n*n);p=j+4|0;q=ea(g[p>>2]);r=ea(l+ea(q*q));s=j+8|0;l=ea(g[s>>2]);t=ea(T(ea(r+ea(l*l))));r=ea(n/t);n=ea(q/t);q=ea(l/t);g[j>>2]=r;g[p>>2]=n;g[s>>2]=q;t=ea(g[b+40>>2]);l=ea(e*ea(r*t));r=ea(e*ea(t*n));n=ea(e*ea(q*t));t=ea(e*ea(g[b+44>>2]));g[a>>2]=l;g[a+4>>2]=r;g[a+8>>2]=n;g[a+12>>2]=t;i=f;return}t=ea(Qlc(h,d));n=ea(g[b+36>>2]);r=ea(ea(1.0)-ea(t/ea(n*n)));if(r>ea(0.0)){n=ea(e*r);r=ea(k-ea(g[h>>2]));k=ea(o-ea(g[h+4>>2]));o=ea(m-ea(g[h+8>>2]));m=ea(T(ea(ea(ea(r*r)+ea(k*k))+ea(o*o))));e=ea(r/m);r=ea(k/m);k=ea(o/m);m=ea(g[b+40>>2]);o=ea(n*ea(e*m));e=ea(n*ea(r*m));r=ea(n*ea(k*m));m=ea(n*ea(g[b+44>>2]));g[a>>2]=o;g[a+4>>2]=e;g[a+8>>2]=r;g[a+12>>2]=m;i=f;return}else{c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=f;return}}function acc(){return c[142986]|0}function bcc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153098];c[b+0>>2]=c[d+0>>2];d=bOb(8,b,0,16,3653512,183)|0;c[d>>2]=d;c[d+4>>2]=d;c[142986]=d;i=a;return}function ccc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[142986]|0;f=c[153098]|0;if(e){g=e+4|0;h=c[g>>2]|0;if((h|0)!=(e|0)){j=h;do{h=j+4|0;k=j;j=c[h>>2]|0;c[k>>2]=0;c[h>>2]=0}while((j|0)!=(e|0))}c[g>>2]=0;c[e>>2]=0}c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[142986]=0;i=a;return}function dcc(a){a=a|0;return a|0}function ecc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im;e=i;i=i+16|0;f=e;j=jLc()|0;k=ea(+h[j+88>>3]+ +h[j+160>>3]);j=a+4|0;l=a+8|0;m=a+12|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;n=c[b+4>>2]|0;if((n|0)==(b|0)){i=e;return}o=f+4|0;p=f+8|0;q=f+12|0;r=n;s=ea(0.0);t=ea(0.0);u=ea(0.0);v=ea(0.0);do{$bc(f,c[r+8>>2]|0,d,k);s=ea(s+ea(g[f>>2]));t=ea(t+ea(g[o>>2]));u=ea(u+ea(g[p>>2]));v=ea(v+ea(g[q>>2]));g[a>>2]=s;g[j>>2]=t;g[l>>2]=u;g[m>>2]=v;r=c[r+4>>2]|0}while((r|0)!=(b|0));i=e;return}function fcc(b){b=b|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=0;return}function gcc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+12|0;if(c[d>>2]|0){e=tLc()|0;In[c[(c[e>>2]|0)+52>>2]&4095](e,c[d>>2]|0);c[d>>2]=0}d=a+8|0;if(!(c[d>>2]|0)){i=b;return}a=tLc()|0;In[c[(c[a>>2]|0)+56>>2]&4095](a,c[d>>2]|0);c[d>>2]=0;i=b;return}function hcc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+12|0;if(c[d>>2]|0){e=tLc()|0;In[c[(c[e>>2]|0)+52>>2]&4095](e,c[d>>2]|0);c[d>>2]=0}d=a+8|0;if(!(c[d>>2]|0)){i=b;return}a=tLc()|0;In[c[(c[a>>2]|0)+56>>2]&4095](a,c[d>>2]|0);c[d>>2]=0;i=b;return}function icc(b){b=b|0;var d=0;d=i;if((c[b+8>>2]|0)==0?(c[b+12>>2]|0)==0:0){i=d;return}a[b+16>>0]=1;i=d;return}function jcc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+64|0;e=d;f=c[b+40>>2]|0;g=tLc()|0;ZLc(e)|0;h=a+12|0;if(!((c[h>>2]|0)!=0|(f&4|0)==0))c[h>>2]=Bn[c[(c[g>>2]|0)+32>>2]&255](g,b,0,e,0)|0;h=a+8|0;if((c[h>>2]|0)!=0|(f&2|0)==0){i=d;return}c[h>>2]=Bn[c[(c[g>>2]|0)+32>>2]&255](g,b,1,e,0)|0;i=d;return}function kcc(a,b){a=a|0;b=b|0;return}function lcc(){var a=0;a=i;pbh();i=a;return}function mcc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+4>>2]|0;if(!d){e=mo[c[(c[a>>2]|0)+92>>2]&4095](a)|0;i=b;return e|0}else{e=swe(d)|0;i=b;return e|0}return 0}function ncc(a){a=a|0;var b=0;b=a+76|0;c[b>>2]=(c[b>>2]|0)+1;return}function occ(a){a=a|0;var b=0,d=0;b=i;d=a+76|0;c[d>>2]=(c[d>>2]|0)+-1;if((a|0)==0|(c[d>>2]|0)!=0){i=b;return}ko[c[(c[a>>2]|0)+88>>2]&4095](a);i=b;return}function pcc(a){a=a|0;var b=0,d=0,e=0;b=i;if(!a){i=b;return}d=c[a>>2]|0;e=d+76|0;c[e>>2]=(c[e>>2]|0)+-1;if(!((d|0)==0|(c[e>>2]|0)!=0))ko[c[(c[d>>2]|0)+88>>2]&4095](d);d=c[a+16>>2]|0;if(d)ko[d&4095](c[a+12>>2]|0);ACi(a);i=b;return}function qcc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[b>>2]|0;do if(f){g=c[f+4>>2]|0;if(!g){if(mo[c[(c[f>>2]|0)+92>>2]&4095](f)|0)break;i=d;return}else{if(swe(g)|0)break;i=d;return}}while(0);In[c[b+4>>2]&4095](a,c[b+12>>2]|0);f=elc()|0;if(!a)h=0;else h=c[a+4>>2]|0;c[e>>2]=h;flc(f,e,2665,2611,b);i=d;return}function rcc(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function scc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=xCi(20)|0;c[j>>2]=a;k=a+76|0;c[k>>2]=(c[k>>2]|0)+1;c[j+4>>2]=b;c[j+8>>2]=d;c[j+12>>2]=e;c[j+16>>2]=f;if(!d)l=0;else l=c[d+4>>2]|0;c[h>>2]=l;dlc(2665,h,ea(0.0),j,ea(-1.0),3507,10);i=g;return}function tcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;if(a[b+36>>0]&1){h=c[b+44>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(h,e)}if((c[b+32>>2]|0)<=-1){j=b+4|0;vbc(j);i=d;return}h=b+20|0;g=c[h>>2]|0;c[f>>2]=c[b+24>>2];c[e+0>>2]=c[f+0>>2];eOb(g,e);c[h>>2]=0;j=b+4|0;vbc(j);i=d;return}function ucc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+20|0;g=a+28|0;if(!(c[g>>2]|0)){i=b;return}h=Gzc()|0;j=c[g>>2]|0;if(j){k=0;do{Jzc(h,c[(c[f>>2]|0)+(k<<3)+4>>2]|0);k=k+1|0}while((k|0)!=(j|0))}j=a+32|0;if((c[j>>2]|0)>-1){k=c[f>>2]|0;c[e>>2]=c[a+24>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[f>>2]=0}c[g>>2]=0;c[j>>2]=0;i=b;return}function vcc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+48|0;j=h;k=h+36|0;l=h+24|0;m=h+12|0;n=d+-1|0;if(n>>>0>=14){o=c[e>>2]|0;if((o|0)==-1){p=1;i=h;return p|0}q=c[b+28>>2]|0;a:do if(q){r=c[b+20>>2]|0;s=0;while(1){if((c[r+(s<<3)>>2]|0)==(o|0)){t=s;break}s=s+1|0;if((s|0)==(q|0)){u=23;break a}}s=c[r+(t<<3)+4>>2]|0;c[g>>2]=s;if(s){p=1;i=h;return p|0}}else u=23;while(0);if((u|0)==23)c[g>>2]=0;t=ftd(e)|0;e=b+36|0;if(!(a[e>>0]&1))v=e+1|0;else v=c[b+44>>2]|0;c[j>>2]=t;c[j+4>>2]=v;c[j+8>>2]=f;Lsd(m,572040,j);Ord(m,512,0);xri(m);p=0;i=h;return p|0}m=n8b()|0;v=c[m>>2]|0;do if(!v)w=0;else{c[k>>2]=v;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(j,t,k);e=c[j>>2]|0;q=c[t+28>>2]|0;if((e|0)==-1){x=q+(c[t+32>>2]<<3)|0;break}else{x=q+(e<<3)|0;break}}else x=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((x|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[x+4>>2]|0,(t|0)!=0):0)y=t;else u=11}else u=11;if((u|0)==11){t=hQb(c[m>>2]|0)|0;if(!t){w=0;break}else y=t}w=g0b(y,d)|0}while(0);c[g>>2]=w;if((w|0)!=0|n>>>0<2){p=1;i=h;return p|0}n=b+36|0;if(!(a[n>>0]&1))z=n+1|0;else z=c[b+44>>2]|0;c[j>>2]=d;c[j+4>>2]=z;c[j+8>>2]=f;Lsd(l,571952,j);Ord(l,512,0);xri(l);p=0;i=h;return p|0}function wcc(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=Im,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;f=i;i=i+432|0;h=f;j=f+384|0;k=f+112|0;l=f+24|0;m=f+20|0;n=f+12|0;o=f+28|0;p=f+32|0;q=f+36|0;r=f+40|0;s=f+52|0;t=f+56|0;u=f+60|0;v=f+64|0;w=f+100|0;x=f+16|0;y=f+116|0;z=f+312|0;A=f+344|0;B=f+352|0;C=f+388|0;D=f+392|0;E=f+396|0;F=f+400|0;G=f+404|0;H=f+408|0;I=f+412|0;J=f+424|0;K=c[d+12>>2]|0;if(!K){i=f;return}L=ync()|0;t1b(y,ync()|0);M=tBc()|0;N=mo[c[(c[L>>2]|0)+424>>2]&4095](L)|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z+20>>2]=0;c[z+24>>2]=0;c[z+28>>2]=0;if((N|0)>0){O=0;do{c[z+(O<<2)>>2]=_n[c[(c[L>>2]|0)+416>>2]&4095](L,O)|0;O=O+1|0}while((O|0)<(N|0))}O=mo[c[(c[L>>2]|0)+420>>2]&4095](L)|0;P=c[L+5840>>2]|0;Q=a[658128]|0;a[658128]=1;R=d+4|0;S=d+36|0;T=S+1|0;U=d+44|0;V=v+28|0;W=v+16|0;X=v+20|0;Y=v+12|0;Z=v+4|0;_=e+20|0;$=d+28|0;aa=d+32|0;ba=d+20|0;ca=d+24|0;da=d+20|0;fa=0;ga=0;ha=12;a:while(1){ia=fa+3&-4;ja=c[R>>2]|0;ka=c[ja+ia>>2]|0;b:do switch(ka|0){case 2:{la=ia+7&-4;ma=la+12|0;na=ja+la|0;oa=c[na>>2]|0;if(!oa)pa=0;else{c[o>>2]=oa;oa=c[137784]|0;if(oa){do if((c[oa+36>>2]|0)!=(c[oa+4>>2]|0)){fRb(h,oa,o);qa=c[h>>2]|0;ra=c[oa+28>>2]|0;if((qa|0)==-1){sa=ra+(c[oa+32>>2]<<3)|0;break}else{sa=ra+(qa<<3)|0;break}}else sa=(c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0;while(0);oa=c[137784]|0;if((sa|0)!=((c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0)?(oa=c[sa+4>>2]|0,(oa|0)!=0):0)ta=oa;else ua=87}else ua=87;if((ua|0)==87){ua=0;ta=hQb(c[na>>2]|0)|0}pa=ta}c[A>>2]=pa;if(vcc(d,c[ja+(la+4)>>2]|0,ja+(la+8)|0,572120,A)|0){oBc(c[A>>2]|0,0,-1,0);va=ma;wa=1;xa=2}else{va=ma;wa=ga;xa=2}break}case 4:{oa=ia+7&-4;qa=oa+32|0;ra=ja+oa|0;ya=c[ra>>2]|0;if(!ya)za=0;else{c[l>>2]=ya;ya=c[137784]|0;if(ya){do if((c[ya+36>>2]|0)!=(c[ya+4>>2]|0)){fRb(h,ya,l);Aa=c[h>>2]|0;Ba=c[ya+28>>2]|0;if((Aa|0)==-1){Ca=Ba+(c[ya+32>>2]<<3)|0;break}else{Ca=Ba+(Aa<<3)|0;break}}else Ca=(c[ya+28>>2]|0)+(c[ya+32>>2]<<3)|0;while(0);ya=c[137784]|0;if((Ca|0)!=((c[ya+28>>2]|0)+(c[ya+32>>2]<<3)|0)?(ya=c[Ca+4>>2]|0,(ya|0)!=0):0)Da=ya;else ua=132}else ua=132;if((ua|0)==132){ua=0;Da=hQb(c[ra>>2]|0)|0}za=Da}c[F>>2]=0;ya=vcc(d,c[ja+(oa+4)>>2]|0,ja+(oa+8)|0,572200,F)|0;ma=c[F>>2]|0;la=(ma|0)==0?za:ma;ma=ja+(oa+12)|0;na=c[ma>>2]|0;if(!na)Ea=0;else{c[k>>2]=na;na=c[137784]|0;if(na){do if((c[na+36>>2]|0)!=(c[na+4>>2]|0)){fRb(h,na,k);Aa=c[h>>2]|0;Ba=c[na+28>>2]|0;if((Aa|0)==-1){Fa=Ba+(c[na+32>>2]<<3)|0;break}else{Fa=Ba+(Aa<<3)|0;break}}else Fa=(c[na+28>>2]|0)+(c[na+32>>2]<<3)|0;while(0);na=c[137784]|0;if((Fa|0)!=((c[na+28>>2]|0)+(c[na+32>>2]<<3)|0)?(na=c[Fa+4>>2]|0,(na|0)!=0):0)Ga=na;else ua=143}else ua=143;if((ua|0)==143){ua=0;Ga=hQb(c[ma>>2]|0)|0}Ea=Ga}c[G>>2]=Ea;if(ya&(vcc(d,c[ja+(oa+16)>>2]|0,ja+(oa+20)|0,572216,G)|0)){na=ja+(oa+24)|0;ra=c[na>>2]|0;do if(!ra)Ha=c[G>>2]|0;else{c[j>>2]=ra;Aa=c[137784]|0;if(Aa){do if((c[Aa+36>>2]|0)!=(c[Aa+4>>2]|0)){fRb(h,Aa,j);Ba=c[h>>2]|0;Ia=c[Aa+28>>2]|0;if((Ba|0)==-1){Ja=Ia+(c[Aa+32>>2]<<3)|0;break}else{Ja=Ia+(Ba<<3)|0;break}}else Ja=(c[Aa+28>>2]|0)+(c[Aa+32>>2]<<3)|0;while(0);Aa=c[137784]|0;if((Ja|0)!=((c[Aa+28>>2]|0)+(c[Aa+32>>2]<<3)|0)?(Aa=c[Ja+4>>2]|0,(Aa|0)!=0):0){Ka=c[G>>2]|0;La=Aa}else ua=157}else ua=157;if((ua|0)==157){ua=0;Aa=hQb(c[na>>2]|0)|0;Ba=c[G>>2]|0;if(!Aa){Ha=Ba;break}else{Ka=Ba;La=Aa}}F3b(la,Ka,La,b[ja+(oa+28)>>1]|0,1,-1);va=qa;wa=1;xa=4;break b}while(0);D3b(la,Ha);va=qa;wa=1;xa=4}else{va=qa;wa=ga;xa=4}break}case 7:{oa=ia+7&-4;na=oa+4|0;ra=c[$>>2]|0;if(ra){ya=c[da>>2]|0;ma=c[ja+oa>>2]|0;oa=0;while(1){if((c[ya+(oa<<3)>>2]|0)==(ma|0)){Ma=oa;break}oa=oa+1|0;if((oa|0)==(ra|0)){va=na;wa=ga;xa=7;break b}}if((Ma|0)!=-1){ra=Gzc()|0;Jzc(ra,c[(c[da>>2]|0)+(Ma<<3)+4>>2]|0);ra=c[da>>2]|0;oa=ra+((c[$>>2]|0)+-1<<3)|0;ma=c[oa+4>>2]|0;ya=ra+(Ma<<3)|0;c[ya>>2]=c[oa>>2];c[ya+4>>2]=ma;c[$>>2]=(c[$>>2]|0)+-1;va=na;wa=ga;xa=7}else{va=na;wa=ga;xa=7}}else{va=na;wa=ga;xa=7}break}case 3:{ma=ia+7&-4;ya=ja+ma|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[B+16>>2]=0;c[B+20>>2]=0;c[B+24>>2]=0;c[B+28>>2]=0;oa=ma+112|0;if((c[ya>>2]|0)>0){ra=0;qa=1;la=0;while(1){Aa=ya+(ra<<2)+4|0;Ba=c[Aa>>2]|0;if(!Ba)Na=0;else{c[n>>2]=Ba;Ba=c[137784]|0;if(Ba){do if((c[Ba+36>>2]|0)!=(c[Ba+4>>2]|0)){fRb(h,Ba,n);Ia=c[h>>2]|0;Oa=c[Ba+28>>2]|0;if((Ia|0)==-1){Pa=Oa+(c[Ba+32>>2]<<3)|0;break}else{Pa=Oa+(Ia<<3)|0;break}}else Pa=(c[Ba+28>>2]|0)+(c[Ba+32>>2]<<3)|0;while(0);Ba=c[137784]|0;if((Pa|0)!=((c[Ba+28>>2]|0)+(c[Ba+32>>2]<<3)|0)?(Ba=c[Pa+4>>2]|0,(Ba|0)!=0):0)Qa=Ba;else ua=101}else ua=101;if((ua|0)==101){ua=0;Qa=hQb(c[Aa>>2]|0)|0}Na=Qa}c[C>>2]=Na;Ba=qa&(vcc(d,c[ya+(ra<<2)+36>>2]|0,ya+(ra<<2)+68|0,572136,C)|0);Ia=pBc(c[C>>2]|0)|0;c[C>>2]=Ia;Oa=(ra|0)==0?Ia:la;if(!Ia){Ra=ync()|0;Sa=mo[c[(c[Ra>>2]|0)+428>>2]&4095](Ra)|0}else Sa=c[Ia+140>>2]|0;c[B+(ra<<2)>>2]=Sa;ra=ra+1|0;if((ra|0)>=(c[ya>>2]|0)){Ta=Ba;Ua=Oa;break}else{qa=Ba;la=Oa}}}else{Ta=1;Ua=0}la=ja+(ma+100)|0;qa=c[la>>2]|0;if(!qa)Va=0;else{c[m>>2]=qa;qa=c[137784]|0;if(qa){do if((c[qa+36>>2]|0)!=(c[qa+4>>2]|0)){fRb(h,qa,m);ra=c[h>>2]|0;na=c[qa+28>>2]|0;if((ra|0)==-1){Wa=na+(c[qa+32>>2]<<3)|0;break}else{Wa=na+(ra<<3)|0;break}}else Wa=(c[qa+28>>2]|0)+(c[qa+32>>2]<<3)|0;while(0);qa=c[137784]|0;if((Wa|0)!=((c[qa+28>>2]|0)+(c[qa+32>>2]<<3)|0)?(qa=c[Wa+4>>2]|0,(qa|0)!=0):0)Xa=qa;else ua=116}else ua=116;if((ua|0)==116){ua=0;Xa=hQb(c[la>>2]|0)|0}Va=Xa}c[D>>2]=Va;qa=Ta&(vcc(d,c[ja+(ma+104)>>2]|0,ja+(ma+108)|0,572168,D)|0);ra=pBc(c[D>>2]|0)|0;c[D>>2]=ra;if(!ra){na=ync()|0;Ya=mo[c[(c[na>>2]|0)+432>>2]&4095](na)|0}else Ya=c[ra+148>>2]|0;if(qa){qa=c[ya>>2]|0;c[E>>2]=Ya;c[h+0>>2]=c[E+0>>2];qBc(qa,B,h,Ua,0,-1,0)|0;va=oa;wa=1;xa=3}else{va=oa;wa=ga;xa=3}break}case 5:{qa=ia+7&-4;Za=ea(g[ja+(qa+20)>>2]);Co[c[(c[L>>2]|0)+24>>2]&3](L,c[ja+(qa+16)>>2]|0,ja+qa|0,Za,c[ja+(qa+24)>>2]|0);va=qa+28|0;wa=ga;xa=5;break}case 6:{qa=ia+7&-4;ra=qa+32|0;na=ja+qa|0;Oa=Gzc()|0;Ba=Hzc(Oa,c[ja+(qa+4)>>2]|0,c[ja+(qa+8)>>2]|0,c[ja+(qa+16)>>2]|0,c[ja+(qa+12)>>2]|0,0,c[ja+(qa+24)>>2]|0,c[ja+(qa+28)>>2]|0)|0;LDc(Ba,c[ja+(qa+20)>>2]|0);qud(_,na,Ba)|0;qa=c[na>>2]|0;na=(c[$>>2]|0)+1|0;c[$>>2]=na;Oa=c[aa>>2]|0;Ia=Oa&2147483647;if(na>>>0>Ia>>>0){Ra=Oa<<1;_a=(Ra|0)==0?1:Ra;do if(Ia>>>0<_a>>>0)if((Oa|0)>-1){c[aa>>2]=_a;Ra=c[ba>>2]|0;c[s>>2]=c[ca>>2];c[h+0>>2]=c[s+0>>2];c[ba>>2]=hOb(Ra,_a<<3,4,h,0,3653512,370)|0;break}else{c[s>>2]=c[ca>>2];c[h+0>>2]=c[s+0>>2];Ra=cOb(_a<<3,4,h,0,3653512,352)|0;YEi(Ra|0,c[ba>>2]|0,c[$>>2]<<3|0)|0;c[aa>>2]=_a;c[ba>>2]=Ra;break}while(0);$a=c[$>>2]|0}else $a=na;_a=(c[ba>>2]|0)+($a+-1<<3)|0;c[_a>>2]=qa;c[_a+4>>2]=Ba;va=ra;wa=ga;xa=6;break}case 8:{_a=ia+7&-4;nud(_,ja+_a|0,ea(g[ja+(_a+4)>>2]));va=_a+8|0;wa=ga;xa=8;break}case 9:{_a=ia+7&-4;oud(_,ja+_a|0,ja+(_a+4)|0);va=_a+20|0;wa=ga;xa=9;break}case 10:{_a=ia+7&-4;pud(_,ja+_a|0,ja+(_a+4)|0);va=_a+68|0;wa=ga;xa=10;break}case 11:{_a=ia+7&-4;Oa=_a+16|0;Ia=ja+_a|0;oa=ja+(_a+4)|0;ya=c[oa>>2]|0;if(!ya)ab=0;else{c[x>>2]=ya;ya=c[137784]|0;if(ya){do if((c[ya+36>>2]|0)!=(c[ya+4>>2]|0)){fRb(h,ya,x);ma=c[h>>2]|0;la=c[ya+28>>2]|0;if((ma|0)==-1){bb=la+(c[ya+32>>2]<<3)|0;break}else{bb=la+(ma<<3)|0;break}}else bb=(c[ya+28>>2]|0)+(c[ya+32>>2]<<3)|0;while(0);ya=c[137784]|0;if((bb|0)!=((c[ya+28>>2]|0)+(c[ya+32>>2]<<3)|0)?(ya=c[bb+4>>2]|0,(ya|0)!=0):0)cb=ya;else ua=187}else ua=187;if((ua|0)==187){ua=0;cb=hQb(c[oa>>2]|0)|0}ab=cb}c[H>>2]=ab;if(vcc(d,c[ja+(_a+8)>>2]|0,ja+(_a+12)|0,572240,H)|0){qud(_,Ia,c[H>>2]|0)|0;va=Oa;wa=ga;xa=11}else{va=Oa;wa=ga;xa=11}break}case 1:{ya=ia+7&-4;ra=ya+84|0;Ba=ja+ya|0;qa=ja+(ya+76)|0;na=c[qa>>2]|0;if((na|0)!=0?(ma=c[ja+(ya+80)>>2]|0,(ma|0)!=0):0){la=ya+87&-4;Ra=(na<<4)+la|0;db=(ma<<2)+Ra|0;eb=ja+la|0;fb=ja+Ra|0}else{db=ra;eb=0;fb=0}ra=ja+(ya+68)|0;Ra=c[ra>>2]|0;if(Ra){c[u>>2]=Ra;Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(h,Ra,u);la=c[h>>2]|0;ma=c[Ra+28>>2]|0;if((la|0)==-1){gb=ma+(c[Ra+32>>2]<<3)|0;break}else{gb=ma+(la<<3)|0;break}}else gb=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if((gb|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(Ra=c[gb+4>>2]|0,(Ra|0)!=0):0)hb=Ra;else ua=19}else ua=19;if((ua|0)==19){ua=0;Ra=hQb(c[ra>>2]|0)|0;if(!Ra){va=db;wa=ga;xa=1;break b}else hb=Ra}Ra=ja+(ya+64)|0;Oa=c[Ra>>2]|0;if(Oa){c[t>>2]=Oa;Oa=c[137784]|0;if(Oa){do if((c[Oa+36>>2]|0)!=(c[Oa+4>>2]|0)){fRb(h,Oa,t);Ia=c[h>>2]|0;_a=c[Oa+28>>2]|0;if((Ia|0)==-1){ib=_a+(c[Oa+32>>2]<<3)|0;break}else{ib=_a+(Ia<<3)|0;break}}else ib=(c[Oa+28>>2]|0)+(c[Oa+32>>2]<<3)|0;while(0);Oa=c[137784]|0;if((ib|0)!=((c[Oa+28>>2]|0)+(c[Oa+32>>2]<<3)|0)?(Oa=c[ib+4>>2]|0,(Oa|0)!=0):0)jb=Oa;else ua=29}else ua=29;if((ua|0)==29){ua=0;Oa=hQb(c[Ra>>2]|0)|0;if(!Oa){va=db;wa=ga;xa=1;break b}else jb=Oa}kld(v,eb,c[qa>>2]|0,fb,c[ja+(ya+80)>>2]|0);Oa=ync()|0;ra=kkd(hb)|0;t8b(Ba,1);Ia=b[ja+(ya+74)>>1]|0;_a=Ia<<16>>16;do if(Ia<<16>>16==-1){if((ra|0)>0){oa=ja+(ya+72)|0;la=0;do{ma=dkd(hb,la,e,0,1)|0;if(ma){In[c[(c[Oa>>2]|0)+220>>2]&4095](Oa,v);Xuc(ma,jb,b[oa>>1]|0,0,0)}la=la+1|0}while((la|0)<(ra|0))}}else{if(!(Ia<<16>>16>-1&(_a|0)<(ra|0))){c[h>>2]=_a;Lsd(w,572400,h);Ord(w,256,0);xri(w);break}la=dkd(hb,_a,e,0,1)|0;if(la){In[c[(c[Oa>>2]|0)+220>>2]&4095](Oa,v);Xuc(la,jb,b[ja+(ya+72)>>1]|0,0,0)}}while(0);if((c[V>>2]|0)>-1){ya=c[W>>2]|0;c[s>>2]=c[X>>2];c[h+0>>2]=c[s+0>>2];eOb(ya,h);c[W>>2]=0}if((c[Y>>2]|0)>-1){ya=c[v>>2]|0;c[s>>2]=c[Z>>2];c[h+0>>2]=c[s+0>>2];eOb(ya,h);c[v>>2]=0;va=db;wa=ga;xa=1}else{va=db;wa=ga;xa=1}}else{va=db;wa=ga;xa=1}}else{va=db;wa=ga;xa=1}break}case 0:{ya=ia+7&-4;Oa=ya+12|0;_a=ja+ya|0;ra=ja+(ya+4)|0;Ia=c[ra>>2]|0;if(Ia){c[q>>2]=Ia;Ia=c[137784]|0;if(Ia){do if((c[Ia+36>>2]|0)!=(c[Ia+4>>2]|0)){fRb(h,Ia,q);Ba=c[h>>2]|0;qa=c[Ia+28>>2]|0;if((Ba|0)==-1){kb=qa+(c[Ia+32>>2]<<3)|0;break}else{kb=qa+(Ba<<3)|0;break}}else kb=(c[Ia+28>>2]|0)+(c[Ia+32>>2]<<3)|0;while(0);Ia=c[137784]|0;if((kb|0)!=((c[Ia+28>>2]|0)+(c[Ia+32>>2]<<3)|0)?(Ia=c[kb+4>>2]|0,(Ia|0)!=0):0)lb=Ia;else ua=53}else ua=53;if((ua|0)==53){ua=0;Ia=hQb(c[ra>>2]|0)|0;if(!Ia){va=Oa;wa=ga;xa=0;break b}else lb=Ia}Ia=c[_a>>2]|0;if(Ia){c[p>>2]=Ia;Ia=c[137784]|0;if(Ia){do if((c[Ia+36>>2]|0)!=(c[Ia+4>>2]|0)){fRb(h,Ia,p);Ba=c[h>>2]|0;qa=c[Ia+28>>2]|0;if((Ba|0)==-1){mb=qa+(c[Ia+32>>2]<<3)|0;break}else{mb=qa+(Ba<<3)|0;break}}else mb=(c[Ia+28>>2]|0)+(c[Ia+32>>2]<<3)|0;while(0);Ia=c[137784]|0;if((mb|0)!=((c[Ia+28>>2]|0)+(c[Ia+32>>2]<<3)|0)?(Ia=c[mb+4>>2]|0,(Ia|0)!=0):0)nb=Ia;else ua=63}else ua=63;if((ua|0)==63){ua=0;Ia=hQb(c[_a>>2]|0)|0;if(!Ia){va=Oa;wa=ga;xa=0;break b}else nb=Ia}if(hkd(lb)|0){Ia=kkd(lb)|0;ra=nb+28|0;Ba=ra+48|0;qa=ra+49|0;if(!((a[Ba>>0]|0)==0?(a[qa>>0]|0)==0:0)){ko[c[(c[ra>>2]|0)+60>>2]&4095](ra);a[Ba>>0]=0;a[qa>>0]=0}t8b(ra+52|0,c[ra+164>>2]|0);qa=b[ja+(ya+10)>>1]|0;Ba=qa<<16>>16;if(qa<<16>>16!=-1){if(!(qa<<16>>16>-1&(Ba|0)<(Ia|0))){c[h>>2]=Ba;Lsd(r,572336,h);Ord(r,256,0);xri(r);va=Oa;wa=ga;xa=0;break b}qa=dkd(lb,Ba,e,0,1)|0;if(!qa){va=Oa;wa=ga;xa=0;break b}Ba=c[(c[ra>>2]|0)+8>>2]|0;Ra=_n[c[(c[nb>>2]|0)+136>>2]&4095](nb,b[ja+(ya+8)>>1]|0)|0;co[Ba&2047](ra,Ra,qa);va=Oa;wa=ga;xa=0;break b}if((Ia|0)>0){qa=ja+(ya+8)|0;Ra=0;do{Ba=dkd(lb,Ra,e,0,1)|0;if(Ba){la=c[(c[ra>>2]|0)+8>>2]|0;oa=_n[c[(c[nb>>2]|0)+136>>2]&4095](nb,b[qa>>1]|0)|0;co[la&2047](ra,oa,Ba)}Ra=Ra+1|0}while((Ra|0)!=(Ia|0));va=Oa;wa=ga;xa=0}else{va=Oa;wa=ga;xa=0}}else{va=Oa;wa=ga;xa=0}}else{va=Oa;wa=ga;xa=0}}else{va=Oa;wa=ga;xa=0}break}default:{ob=ka;pb=ga;qb=ha;ua=191;break a}}while(0);if(va>>>0<K>>>0){fa=va;ga=wa;ha=xa}else{rb=wa;break}}if((ua|0)==191){if(!(a[S>>0]&1))sb=T;else sb=c[U>>2]|0;c[h>>2]=ob;c[h+4>>2]=qb;c[h+8>>2]=sb;Lsd(I,572264,h);Ord(I,256,0);xri(I);rb=pb}if(rb){c[J>>2]=O;c[h+0>>2]=c[J+0>>2];qBc(N,z,h,M,0,P,0)|0}a[658128]=Q;u1b(y);i=f;return}function xcc(a){a=a|0;c[a>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+4>>2]=60;c[a+16>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;c[a+20>>2]=60;c[a+32>>2]=0;c[a+40>>2]=0;c[a+44>>2]=0;c[a+36>>2]=60;c[a+48>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;c[a+52>>2]=60;c[a+64>>2]=0;c[a+72>>2]=0;c[a+76>>2]=0;c[a+68>>2]=60;c[a+80>>2]=0;c[a+88>>2]=0;c[a+92>>2]=0;c[a+84>>2]=60;c[a+96>>2]=0;c[a+104>>2]=0;c[a+108>>2]=0;c[a+100>>2]=60;c[a+112>>2]=0;c[a+120>>2]=0;c[a+124>>2]=0;c[a+116>>2]=60;c[a+128>>2]=0;c[a+136>>2]=0;c[a+140>>2]=0;c[a+132>>2]=60;c[a+144>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+148>>2]=60;c[a+160>>2]=0;c[a+168>>2]=0;c[a+172>>2]=0;c[a+164>>2]=60;c[a+176>>2]=0;c[a+184>>2]=0;c[a+188>>2]=0;c[a+180>>2]=60;c[a+192>>2]=0;c[a+200>>2]=0;c[a+204>>2]=0;c[a+196>>2]=60;c[a+208>>2]=0;c[a+216>>2]=0;c[a+220>>2]=0;c[a+212>>2]=60;c[a+224>>2]=0;c[a+232>>2]=0;c[a+236>>2]=0;c[a+228>>2]=60;c[a+240>>2]=0;c[a+248>>2]=0;c[a+252>>2]=0;c[a+244>>2]=60;c[a+256>>2]=0;c[a+264>>2]=0;c[a+268>>2]=0;c[a+260>>2]=60;c[a+272>>2]=0;c[a+280>>2]=0;c[a+284>>2]=0;c[a+276>>2]=60;c[a+288>>2]=0;c[a+296>>2]=0;c[a+300>>2]=0;c[a+292>>2]=60;c[a+304>>2]=0;c[a+312>>2]=0;c[a+316>>2]=0;c[a+308>>2]=60;c[a+320>>2]=0;c[a+328>>2]=0;c[a+332>>2]=0;c[a+324>>2]=60;return}function ycc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+336|0;do{g=f;f=f+-16|0;if((c[g+-4>>2]|0)>-1){h=c[f>>2]|0;c[e>>2]=c[g+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}}while((f|0)!=(a|0));i=b;return}function zcc(a){a=a|0;var b=0;b=i;Acc(a,0);Acc(a,1);Acc(a,2);Acc(a,3);Acc(a,4);Acc(a,5);Acc(a,6);Acc(a,7);Acc(a,8);Acc(a,9);Acc(a,10);Acc(a,11);Acc(a,12);Acc(a,13);Acc(a,14);Acc(a,15);Acc(a,16);Acc(a,17);Acc(a,18);Acc(a,19);Acc(a,20);i=b;return}function Acc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+(b<<4)|0;h=c[g>>2]|0;j=a+(b<<4)+8|0;if(!(c[j>>2]|0))k=h;else{l=h;do{h=c[l>>2]|0;m=h+48|0;c[m>>2]=(c[m>>2]|0)+-1;if(!((h|0)==0|(c[m>>2]|0)!=0)){tcc(h);ACi(h)}l=l+4|0;h=c[g>>2]|0}while((l|0)!=(h+(c[j>>2]<<2)|0));k=h}l=a+(b<<4)+12|0;if((c[l>>2]|0)<=-1){c[j>>2]=0;c[l>>2]=0;i=d;return}c[f>>2]=c[a+(b<<4)+4>>2];c[e+0>>2]=c[f+0>>2];eOb(k,e);c[g>>2]=0;c[j>>2]=0;c[l>>2]=0;i=d;return}function Bcc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+(b<<4)+8>>2]|0;if(!f){i=e;return}g=c[a+(b<<4)>>2]|0;b=g+(f<<2)|0;f=g;do{wcc(c[f>>2]|0,d);f=f+4|0}while((f|0)!=(b|0));i=e;return}function Ccc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=0;do{e=c[a+(d<<4)>>2]|0;f=c[a+(d<<4)+8>>2]|0;g=e+(f<<2)|0;if(f){f=e;do{ucc(c[f>>2]|0);f=f+4|0}while((f|0)!=(g|0))}d=d+1|0}while((d|0)!=21);i=b;return}function Dcc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+296|0;a=c[f>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0)l=a;else m=10}else m=10;if((m|0)==10)l=hQb(c[f>>2]|0)|0;g=l;i=b;return g|0}function Ecc(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+80|0;g=f+72|0;h=f+68|0;j=f+64|0;k=f;l=c[a+312>>2]|0;if(((l|0)==0?(m=c[a+300>>2]|0,(m|0)!=0):0)?(c[(c[m+28>>2]|0)+128>>2]|0)>0:0){m=a+332|0;n=c[m>>2]|0;if(!n){Gcc(a);o=c[m>>2]|0}else o=n;if((o|0)==0|(c[150158]|0)==0){p=0;i=f;return p|0}c[h>>2]=c[153136];c[g+0>>2]=c[h+0>>2];h=bOb(24,g,0,16,3653512,332)|0;o=a+344|0;n=c[o>>2]|0;if(!n){Gcc(a);q=c[o>>2]|0}else q=n;c[h>>2]=q;c[h+4>>2]=c[a+324>>2];c[h+8>>2]=e[a+340>>1];c[h+12>>2]=d;c[h+16>>2]=0;c[h+20>>2]=b;if(!h){p=0;i=f;return p|0}aYd(h);p=1;i=f;return p|0}if((d+-1|0)>>>0>=l>>>0){p=0;i=f;return p|0}l=a+304|0;a=0;h=0;while(1){q=(c[l>>2]|0)+(h<<2)|0;n=c[q>>2]|0;do if(!n){r=b+(h<<6)|0;s=26}else{c[j>>2]=n;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(g,o,j);m=c[g>>2]|0;t=c[o+28>>2]|0;if((m|0)==-1){u=t+(c[o+32>>2]<<3)|0;break}else{u=t+(m<<3)|0;break}}else u=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((u|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[u+4>>2]|0,(o|0)!=0):0){v=b+(h<<6)|0;w=o}else s=24}else s=24;if((s|0)==24){s=0;o=hQb(c[q>>2]|0)|0;m=b+(h<<6)|0;if(!o){r=m;s=26;break}else{v=m;w=o}}SGc(k,w);o=v+0|0;m=k+0|0;t=o+64|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(t|0));x=1}while(0);if((s|0)==26){s=0;ZLc(r)|0;x=a}h=h+1|0;if((h|0)==(d|0)){p=x;break}else a=x}i=f;return p|0}function Fcc(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+4|0;j=g;k=a+332|0;l=c[k>>2]|0;if(!l){Gcc(a);m=c[k>>2]|0}else m=l;if((m|0)==0|(c[150158]|0)==0){n=0;i=g;return n|0}c[j>>2]=c[153136];c[h+0>>2]=c[j+0>>2];j=bOb(24,h,0,16,3653512,332)|0;h=a+344|0;m=c[h>>2]|0;if(!m){Gcc(a);o=c[h>>2]|0}else o=m;c[j>>2]=o;c[j+4>>2]=c[a+324>>2];c[j+8>>2]=e[a+340>>1];c[j+12>>2]=d;if(f)p=rec(c[a+300>>2]|0)|0;else p=0;c[j+16>>2]=p;c[j+20>>2]=b;n=j;i=g;return n|0}function Gcc(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+12|0;m=f;n=e+344|0;o=c[n>>2]|0;if(o){MQb(o,1809,e);o=e+284|0;if(c[o>>2]|0)Gnd(o);o=e+336|0;if((c[o>>2]|0)>-1){p=e+324|0;q=c[p>>2]|0;c[h>>2]=c[e+328>>2];c[g+0>>2]=c[h+0>>2];eOb(q,g);c[p>>2]=0}c[e+332>>2]=0;c[o>>2]=0;c[n>>2]=0}o=e+300|0;p=c[o>>2]|0;if(!p){i=f;return}q=p+124|0;if((c[q>>2]|0)!=(c[(c[p+28>>2]|0)+128>>2]|0)){Krd(573536,0,3653512,1527,1,c[p+4>>2]|0,0,0);i=f;return}r=e+24|0;s=nQc(c[r>>2]|0,95)|0;c[n>>2]=s;if(!s){i=f;return}if(!(pLc()|0)){i=f;return}s=e+284|0;if(c[s>>2]|0)Gnd(s);s=e+324|0;t=c[(c[n>>2]|0)+24>>2]|0;if((c[r>>2]|0)!=(t|0)){u=c[(c[o>>2]|0)+132>>2]|0;c[k>>2]=u;if(!u){u=BTb(t)|0;oHc(m,BTb(c[r>>2]|0)|0,u);u=a[m>>0]|0;if(!(u&1)){v=(u&255)>>>1;w=m+1|0}else{v=c[m+4>>2]|0;w=c[m+8>>2]|0}if(v>>>0>2147483631)ori(l);if(v>>>0<11){a[l>>0]=v<<1;x=l;y=l+1|0}else{u=v+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];r=cOb(u,16,g,0,3653512,80)|0;c[l+8>>2]=r;c[l>>2]=u|1;c[l+4>>2]=v;x=l;y=r}YEi(y|0,w|0,v|0)|0;a[y+v>>0]=0;xri(m);m=(a[x>>0]&1)==0;if(m)z=l+1|0;else z=c[l+8>>2]|0;x=-1;v=0;y=0;while(1){if(!(x&1))A=y;else A=1<<31-v|y;v=v+1|0;if((v|0)==32){B=A;break}else{x=x>>>1;y=A}}A=SEi(z|0)|0;y=z+A|0;if((A|0)>0){A=B;x=z;while(1){z=c[572464+(((d[x>>0]|0)^A&255)<<2)>>2]^A>>>8;x=x+1|0;if((x|0)==(y|0)){C=z;break}else A=z}}else C=B;B=~C;c[k>>2]=B;if(m)D=B;else{B=c[l+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(B,g);D=c[k>>2]|0}if(!D){i=f;return}}D=pLc()|0;if(!(Bn[c[c[D>>2]>>2]&255](D,c[n>>2]|0,k,1,e+340|0)|0)){i=f;return}}else b[e+340>>1]=0;k=c[q>>2]|0;D=e+332|0;c[D>>2]=k;B=e+336|0;h=c[B>>2]|0;do if((h&2147483647)>>>0<k>>>0)if((h|0)>-1){c[B>>2]=k;l=c[s>>2]|0;c[j>>2]=c[e+328>>2];c[g+0>>2]=c[j+0>>2];c[s>>2]=hOb(l,k<<1,2,g,0,3653512,370)|0;E=s;break}else{c[j>>2]=c[e+328>>2];c[g+0>>2]=c[j+0>>2];l=cOb(k<<1,2,g,0,3653512,352)|0;YEi(l|0,c[s>>2]|0,c[D>>2]<<1|0)|0;c[B>>2]=k;c[s>>2]=l;E=s;break}else E=s;while(0);s=pLc()|0;if(!(Bn[c[c[s>>2]>>2]&255](s,c[n>>2]|0,c[p+116>>2]|0,c[q>>2]|0,c[E>>2]|0)|0)){if((c[B>>2]|0)>-1){q=c[E>>2]|0;c[j>>2]=c[e+328>>2];c[g+0>>2]=c[j+0>>2];eOb(q,g);c[E>>2]=0}c[D>>2]=0;c[B>>2]=0}LQb(c[n>>2]|0,1809,e);i=f;return}function Hcc(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=i;i=i+192|0;j=h+128|0;k=h+172|0;l=h+176|0;m=h+180|0;n=h+64|0;o=h;p=h+136|0;a[b+424>>0]=0;q=b+300|0;r=c[q>>2]|0;if(!r){s=0;i=h;return s|0}if(!(iec(r)|0)){s=0;i=h;return s|0}r=c[q>>2]|0;if(!r)t=0;else t=c[(c[r+28>>2]|0)+128>>2]|0;u=b+348|0;v=c[b+360>>2]|0;w=c[u>>2]|0;x=b+352|0;y=v>>>0<w>>>0?v:w;while(1){w=y+-1|0;if((w|0)<=-1){z=0;break}if(ea(g[(c[x>>2]|0)+(w<<2)>>2])>ea(.0000999999974)){z=y;break}else y=w}do if((t|0)>0){if(!(xec(r,t)|0)){if(!b)A=0;else A=c[b+4>>2]|0;Krd(573496,0,3653512,357,1,A,0,0);s=0;i=h;return s|0}y=c[q>>2]|0;w=c[y+28>>2]|0;if(c[w+144>>2]|0){if((!((c[b+312>>2]|0)!=0|(y|0)==0)?(c[w+128>>2]|0)>0:0)?(w=b+332|0,(c[w>>2]|0)==0):0){Gcc(b);y=(c[w>>2]|0)!=0;w=y?t:0;if(y)B=w;else{C=w;D=18;break}}else B=t;w=(z|0)>0;if(!(w|(e&8|0)==0))if((c[b+428>>2]|0)==0?(c[b+432>>2]|0)!=0:0){y=(a[(rSc()|0)+202>>0]|0)==0;E=B;F=1;G=y?0:a[621172]|0;H=0}else{E=B;F=1;G=0;H=0}else{E=B;F=1;G=0;H=w}}else{C=0;D=18}}else{C=0;D=18}while(0);if((D|0)==18){E=C;F=0;G=0;H=(c[u>>2]|0)!=0}c[b+420>>2]=c[(c[(c[q>>2]|0)+28>>2]|0)+96>>2];u=eic(E,z)|0;c[u+12>>2]=E;C=u+60|0;c[C>>2]=z;z=c[q>>2]|0;B=u+44|0;c[B>>2]=c[(c[z+28>>2]|0)+100>>2];t=u+76|0;a[t>>0]=G;do if(F){G=c[b+392>>2]|0;if(!G){A=pyc()|0;I=c[(c[A+24>>2]|0)+((c[A+40>>2]|0)*96|0)+52>>2]|0;J=c[q>>2]|0}else{I=G;J=z}c[u+4>>2]=I;c[u+8>>2]=yec(J,I)|0;c[k>>2]=c[b+320>>2];G=c[137784]|0;if(G){do if((c[G+36>>2]|0)!=(c[G+4>>2]|0)){fRb(j,G,k);A=c[j>>2]|0;r=c[G+28>>2]|0;if((A|0)==-1){K=r+(c[G+32>>2]<<3)|0;break}else{K=r+(A<<3)|0;break}}else K=(c[G+28>>2]|0)+(c[G+32>>2]<<3)|0;while(0);G=c[137784]|0;if((K|0)!=((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)?(G=c[K+4>>2]|0,(G|0)!=0):0)L=G;else D=35}else D=35;if((D|0)==35)L=qAc(b)|0;PGc(o,L);G=n+0|0;A=o+0|0;r=G+64|0;do{c[G>>2]=c[A>>2];G=G+4|0;A=A+4|0}while((G|0)<(r|0));if((c[b+312>>2]|0)==0?(A=c[q>>2]|0,(A|0)!=0):0){G=c[u+52>>2]|0;if((c[(c[A+28>>2]|0)+128>>2]|0)>0){A=Fcc(b,G,E,1)|0;if(!A){dic(u);s=0;i=h;return s|0}r=pLc()|0;w=_n[c[(c[r>>2]|0)+8>>2]&4095](r,c[b+344>>2]|0)|0;r=b+284|0;y=c[150158]|0;if(!f)Ind(r,y,A,w,0);else End(f,r,y,A,w);Fnd(w);A=r;y=c[A+4>>2]|0;v=w;c[v>>2]=c[A>>2];c[v+4>>2]=y;y=r;r=c[y+4>>2]|0;v=u+68|0;c[v>>2]=c[y>>2];c[v+4>>2]=r;break}else M=G}else M=c[u+52>>2]|0;if(!(Ecc(b,M,E)|0)){dic(u);s=0;i=h;return s|0}G=c[(c[q>>2]|0)+28>>2]|0;if(!(c[G+128>>2]|0))N=0;else N=c[G+120>>2]|0;BMc(n,M,N,M,E)}else{G=u+52|0;if(!(c[b+428>>2]|0))c[G>>2]=0;else{r=c[G>>2]|0;c[l>>2]=c[b+320>>2];G=c[137784]|0;if(G){do if((c[G+36>>2]|0)!=(c[G+4>>2]|0)){fRb(j,G,l);v=c[j>>2]|0;y=c[G+28>>2]|0;if((v|0)==-1){O=y+(c[G+32>>2]<<3)|0;break}else{O=y+(v<<3)|0;break}}else O=(c[G+28>>2]|0)+(c[G+32>>2]<<3)|0;while(0);G=c[137784]|0;if((O|0)!=((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)?(G=c[O+4>>2]|0,(G|0)!=0):0)P=G;else D=61}else D=61;if((D|0)==61)P=qAc(b)|0;nGc(p,P);$Lc(r,p)|0}c[u+8>>2]=0}while(0);if(H){YEi(c[u+56>>2]|0,c[x>>2]|0,c[C>>2]<<2|0)|0;C=c[q>>2]|0;c[u+64>>2]=C+56;Q=C}else Q=c[q>>2]|0;q=c[Q+28>>2]|0;Q=a[q+50>>0]|0;c[u+16>>2]=(c[q+92>>2]|0)+(c[q+44>>2]|0);C=Q&255;c[u+24>>2]=C;Q=u+28|0;c[Q>>2]=C;do if(!(e&1)){x=ync()|0;H=b+400|0;p=c[H>>2]|0;if(!p){P=mo[c[(c[x>>2]|0)+280>>2]&4095](x)|0;c[H>>2]=P;R=P}else R=p;if(!(a[t>>0]|0)){p=(c[(ync()|0)+5980>>2]|0)==0;S=c[H>>2]|0;T=p?2:1}else{S=R;T=3}p=da(c[q+100>>2]|0,C)|0;if((c[S+12>>2]|0)==(T|0)){P=mo[c[(c[S>>2]|0)+8>>2]&4095](S)|0;D=c[H>>2]|0;if(!P?(c[D+20>>2]|0)==(p|0):0)break;else U=D}else U=S;Wn[c[(c[x>>2]|0)+284>>2]&127](x,U,T,0,p,0,0)}while(0);if(a[t>>0]|0){s=u;i=h;return s|0}a[u+40>>0]=(a[q+15>>0]|0)!=0&1;c[u+32>>2]=d[q+13>>0];a[u+41>>0]=(a[q+39>>0]|0)!=0&1;c[u+36>>2]=d[q+37>>0];if(!(e&2)){s=u;i=h;return s|0}e=b+404|0;q=da(c[B>>2]|0,c[Q>>2]|0)|0;Q=b+412|0;c[Q>>2]=q;B=b+416|0;t=c[B>>2]|0;do if((t&2147483647)>>>0<q>>>0)if((t|0)>-1){c[B>>2]=q;T=c[e>>2]|0;c[m>>2]=c[b+408>>2];c[j+0>>2]=c[m+0>>2];U=hOb(T,q,1,j,0,3653512,370)|0;c[e>>2]=U;V=U;break}else{c[m>>2]=c[b+408>>2];c[j+0>>2]=c[m+0>>2];U=cOb(q,1,j,0,3653512,352)|0;YEi(U|0,c[e>>2]|0,c[Q>>2]|0)|0;c[B>>2]=q;c[e>>2]=U;V=U;break}else V=c[e>>2]|0;while(0);c[u+20>>2]=V;s=u;i=h;return s|0}function Icc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;c[e>>2]=c[a+320>>2];f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(d,f,e);g=c[d>>2]|0;h=c[f+28>>2]|0;if((g|0)==-1){j=h+(c[f+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if((j|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(f=c[j+4>>2]|0,(f|0)!=0):0){k=f;i=b;return k|0}}k=qAc(a)|0;i=b;return k|0}function Jcc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+64|0;k=j+8|0;l=j+4|0;m=j;n=b+292|0;if(c[n>>2]|0){o=ync()|0;p=c[(c[o>>2]|0)+316>>2]|0;c[l>>2]=c[n>>2];c[k+0>>2]=c[l+0>>2];In[p&4095](o,k);c[n>>2]=0}if(!(a[d+76>>0]|0)){tsd(m,f+6024|0);c[n>>2]=c[m>>2];m=c[h>>2]|0;c[h>>2]=m+1;h=c[b+400>>2]|0;o=c[h+20>>2]|0;c[g+(m*20|0)>>2]=c[n>>2];c[g+(m*20|0)+4>>2]=d;c[g+(m*20|0)+8>>2]=h;c[g+(m*20|0)+12>>2]=0;c[g+(m*20|0)+16>>2]=o;i=j;return}o=d+68|0;if(c[o>>2]|0)Gnd(o);o=ync()|0;m=b+432|0;Dn[c[(c[o>>2]|0)+372>>2]&511](o,c[m>>2]|0,c[d+52>>2]|0,c[d+12>>2]|0);o=c[b+300>>2]|0;g=c[(c[o+28>>2]|0)+40>>2]|0;sec(k,o,g,0);o=d+44|0;Yn[c[(c[f>>2]|0)+376>>2]&15](f,k+8|0,c[d+80>>2]|0,c[m>>2]|0,c[b+400>>2]|0,c[o>>2]|0,c[d+4>>2]|0,g,e);e=c[o>>2]|0;if(a[f+5568>>0]|0){o=f+5348|0;c[o>>2]=(c[o>>2]|0)+1;o=f+5352|0;c[o>>2]=(c[o>>2]|0)+e;o=f+5360|0;c[o>>2]=(c[o>>2]|0)+e;o=f+5356|0;c[o>>2]=(c[o>>2]|0)+e;e=f+5344|0;c[e>>2]=(c[e>>2]|0)+1}dic(d);i=j;return}function Kcc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=i;i=i+80|0;f=e+56|0;g=e+40|0;h=e+4|0;j=e+8|0;k=e+64|0;l=e;m=e+16|0;n=e+48|0;o=e+44|0;p=(b|0)==0;q=p?2:8;r=c[143373]|0;if((r|0)==573488)s=0;else{t=r;r=0;while(1){u=r+1|0;t=c[t+4>>2]|0;if((t|0)==573488){s=u;break}else r=u}}r=c[153134]|0;t=s<<2;c[g>>2]=r;c[f+0>>2]=c[g+0>>2];u=cOb(t,4,f,0,3653512,352)|0;v=c[153134]|0;c[g>>2]=v;c[f+0>>2]=c[g+0>>2];w=cOb(t,4,f,0,3653512,352)|0;Bnd(m,0,-1);t=c[143373]|0;if((t|0)==573488){x=0;y=0}else{z=t;t=0;A=0;while(1){B=c[z+8>>2]|0;if(((c[B+428>>2]|0)==0|0)==(b|0)?(C=Hcc(B,q,m)|0,(C|0)!=0):0){D=C+76|0;if(!(a[D>>0]|0))E=t;else{c[C+80>>2]=Aec(c[B+300>>2]|0,c[C+4>>2]|0)|0;E=(a[D>>0]|0)==0?t:C}c[w+(A<<2)>>2]=C;c[u+(A<<2)>>2]=B;F=E;G=A+1|0}else{F=t;G=A}z=c[z+4>>2]|0;if((z|0)==573488){x=F;y=G;break}else{t=F;A=G}}}if(y){do if((s&2147483647)>>>0<y>>>0)if((s|0)>-1){c[h>>2]=r;c[f+0>>2]=c[h+0>>2];G=hOb(u,y<<2,4,f,0,3653512,370)|0;c[g>>2]=v;c[f+0>>2]=c[g+0>>2];H=hOb(w,y<<2,4,f,0,3653512,370)|0;I=G;J=y;break}else{G=y<<2;c[g>>2]=r;c[f+0>>2]=c[g+0>>2];A=cOb(G,4,f,0,3653512,352)|0;YEi(A|0,u|0,G|0)|0;G=y<<2;c[g>>2]=v;c[f+0>>2]=c[g+0>>2];F=cOb(G,4,f,0,3653512,352)|0;YEi(F|0,w|0,G|0)|0;H=F;I=A;J=y;break}else{H=w;I=u;J=s}while(0);if(p){p=c[153134]|0;c[g>>2]=p;c[f+0>>2]=c[g+0>>2];h=cOb(y<<3,4,f,0,3653512,352)|0;A=f+4|0;F=0;do{G=h+(F<<3)|0;Fnd(G);t=c[H+(F<<2)>>2]|0;c[f>>2]=0;c[A>>2]=0;End(m,G,3508,t,f);F=F+1|0}while(F>>>0<y>>>0);F=0;do{m=h+(F<<3)|0;if(c[m>>2]|0)Gnd(m);m=c[I+(F<<2)>>2]|0;A=c[H+(F<<2)>>2]|0;t=A+20|0;G=c[t>>2]|0;z=c[A+32>>2]|0;E=a[A+40>>0]|0;q=c[A+36>>2]|0;b=a[A+41>>0]|0;B=tLc()|0;Wn[c[(c[B>>2]|0)+40>>2]&127](B,c[m+428>>2]|0,c[t>>2]|0,E<<24>>24!=0?G+z|0:0,b<<24>>24!=0?G+q|0:0,c[A+28>>2]|0,0);F=F+1|0}while(F>>>0<y>>>0);if((y|0)>-1){c[g>>2]=p;c[f+0>>2]=c[g+0>>2];eOb(h,f)}}else{h=ync()|0;g=(y*20|0)+15|0;if(g>>>0<2e3){p=i;i=i+((1*g|0)+15&-16)|0;K=0;L=p}else{c[n>>2]=c[153134];c[f+0>>2]=c[n+0>>2];n=cOb(g,16,f,0,3653512,1142)|0;K=n;L=n}n=L+15&-16;c[o>>2]=0;L=0;do{g=c[H+(L<<2)>>2]|0;Jcc(c[I+(L<<2)>>2]|0,g,(g|0)==(x|0),h,n,o);L=L+1|0}while(L>>>0<y>>>0);Dn[c[(c[h>>2]|0)+312>>2]&511](h,3508,n,c[o>>2]|0);if(K){c[j>>2]=c[153134];c[f+0>>2]=c[j+0>>2];eOb(K,f)}}if(!d){M=H;N=I;O=J}else{K=y<<2;y=K>>2;j=d+8|0;c[j>>2]=y;o=d+12|0;n=c[o>>2]|0;do if((n&2147483647)>>>0<y>>>0)if((n|0)>-1){c[o>>2]=y;h=c[d>>2]|0;c[k>>2]=c[d+4>>2];c[f+0>>2]=c[k+0>>2];L=hOb(h,K,4,f,0,3653512,370)|0;c[d>>2]=L;P=L;break}else{c[k>>2]=c[d+4>>2];c[f+0>>2]=c[k+0>>2];L=cOb(K,4,f,0,3653512,352)|0;YEi(L|0,c[d>>2]|0,c[j>>2]<<2|0)|0;c[o>>2]=y;c[d>>2]=L;P=L;break}else P=c[d>>2]|0;while(0);YEi(P|0,I|0,c[j>>2]<<2|0)|0;M=H;N=I;O=J}}else{M=w;N=u;O=s}if((O|0)>-1){c[k>>2]=v;c[f+0>>2]=c[k+0>>2];eOb(M,f)}if((O|0)<=-1){i=e;return}c[l>>2]=r;c[f+0>>2]=c[l+0>>2];eOb(N,f);i=e;return}function Lcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+128|0;e=d+56|0;f=d+48|0;g=d+24|0;h=d;j=c[b+8>>2]|0;if((j|0)<=0){i=d;return}k=0;do{l=c[(c[b>>2]|0)+(k<<2)>>2]|0;m=l+412|0;if(c[m>>2]|0){n=ync()|0;o=l+400|0;p=kn[c[(c[n>>2]|0)+288>>2]&511](n,c[o>>2]|0,0,0)|0;if(p){YEi(p|0,c[l+404>>2]|0,c[m>>2]|0)|0;co[c[(c[n>>2]|0)+292>>2]&2047](n,c[o>>2]|0,c[m>>2]|0)}c[f>>2]=c[l+320>>2];m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(e,m,f);o=c[e>>2]|0;n=c[m+28>>2]|0;if((o|0)==-1){q=n+(c[m+32>>2]<<3)|0;break}else{q=n+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0){r=m;s=l}else t=15}else t=15;if((t|0)==15){t=0;r=qAc(l)|0;s=l}RGc(e,r);m=(c[l+428>>2]|0)+92|0;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[g+16>>2]=c[m+16>>2];c[g+20>>2]=c[m+20>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;Wlc(g,e,h);m=l+368|0;c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];c[m+16>>2]=c[h+16>>2];c[m+20>>2]=c[h+20>>2];a[l+397>>0]=0;lAc(s)}k=k+1|0}while((k|0)!=(j|0));i=d;return}function Mcc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+4|0;f=b;if((d|0)!=3){i=b;return}d=a+344|0;g=c[d>>2]|0;if(!g){i=b;return}MQb(g,1809,a);g=a+284|0;if(c[g>>2]|0)Gnd(g);g=a+336|0;if((c[g>>2]|0)>-1){h=a+324|0;j=c[h>>2]|0;c[f>>2]=c[a+328>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[h>>2]=0}c[a+332>>2]=0;c[g>>2]=0;c[d>>2]=0;i=b;return}function Ncc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=591920;c[a+28>>2]=592084;aAc(a);if((c[a+248>>2]|0)>-1){f=a+236|0;g=c[f>>2]|0;c[e>>2]=c[a+240>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+232>>2]|0)<=-1){WUb(a);i=b;return}f=a+220|0;g=c[f>>2]|0;c[e>>2]=c[a+224>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;WUb(a);i=b;return}function Occ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f+4|0;h=f;j=e-d|0;k=b+8|0;l=c[k>>2]|0;m=c[b>>2]|0;n=m;if(j>>>0<=(l-n|0)>>>0){o=b+4|0;p=(c[o>>2]|0)-n|0;if(j>>>0<=p>>>0){aFi(m|0,d|0,j|0)|0;n=m+j|0;if((c[o>>2]|0)==(n|0)){i=f;return}c[o>>2]=n;i=f;return}n=d+p|0;aFi(m|0,d|0,p|0)|0;if((n|0)==(e|0)){i=f;return}p=n;n=c[o>>2]|0;do{if(!n)q=0;else{a[n>>0]=a[p>>0]|0;q=c[o>>2]|0}n=q+1|0;c[o>>2]=n;p=p+1|0}while((p|0)!=(e|0));i=f;return}if(!m)r=l;else{l=b+4|0;if((c[l>>2]|0)!=(m|0))c[l>>2]=m;c[h>>2]=8;c[g+0>>2]=c[h+0>>2];eOb(m,g);c[k>>2]=0;c[l>>2]=0;c[b>>2]=0;r=0}if((j|0)<0)vxi(b);l=r-0|0;if(l>>>0<1073741823){r=l<<1;l=r>>>0<j>>>0?j:r;if((l|0)<0)vxi(b);else s=l}else s=2147483647;c[h>>2]=8;c[g+0>>2]=c[h+0>>2];h=cOb(s,16,g,0,3653512,80)|0;g=b+4|0;c[g>>2]=h;c[b>>2]=h;c[k>>2]=h+s;if((d|0)==(e|0)){i=f;return}else{t=d;u=h}do{if(!u)v=0;else{a[u>>0]=a[t>>0]|0;v=c[g>>2]|0}u=v+1|0;c[g>>2]=u;t=t+1|0}while((t|0)!=(e|0));i=f;return}function Pcc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b;j=d-h|0;k=(j|0)/56|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=((m-o|0)/56|0)>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=(q|0)/56|0;if(k>>>0<=r>>>0){s=d-h|0;aFi(n|0,b|0,s|0)|0;h=n+(((s|0)/56|0)*56|0)|0;s=c[p>>2]|0;if((s|0)==(h|0)){i=e;return}c[p>>2]=s+(~(((s+-56-h|0)>>>0)/56|0)*56|0);i=e;return}h=b+(r*56|0)|0;aFi(n|0,b|0,q|0)|0;if((h|0)==(d|0)){i=e;return}q=h;h=c[p>>2]|0;do{if(!h)t=0;else{u=h+0|0;v=q+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=c[p>>2]|0}h=t+56|0;c[p>>2]=h;q=q+56|0}while((q|0)!=(d|0));i=e;return}if(!n)x=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~(((q+-56-o|0)>>>0)/56|0)*56|0);c[g>>2]=10;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=(x-0|0)/56|0;if(j>>>0<1073741823){x=j<<1;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=10;c[f+0>>2]=c[g+0>>2];g=cOb(y*56|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y*56|0);if((b|0)==(d|0)){i=e;return}else{z=b;A=g}do{if(!A)B=0;else{u=A+0|0;v=z+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));B=c[f>>2]|0}A=B+56|0;c[f>>2]=A;z=z+56|0}while((z|0)!=(d|0));i=e;return}function Qcc(a){a=a|0;return}function Rcc(a){a=a|0;return c[a+228>>2]|0}function Scc(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=c[(c[b+220>>2]|0)+(d<<2)>>2];return}function Tcc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!(c[a+244>>2]|0)){e=b;i=d;return e|0}e=c[(c[a+236>>2]|0)+(b<<2)>>2]|0;i=d;return e|0}function Ucc(a){a=a|0;return c[a+-28+228>>2]|0}function Vcc(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=c[(c[b+-28+220>>2]|0)+(d<<2)>>2];return}function Wcc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+-28|0;if(!(c[e+244>>2]|0)){f=b;i=d;return f|0}f=c[(c[e+236>>2]|0)+(b<<2)>>2]|0;i=d;return f|0}function Xcc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function Ycc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;h=d+8|0;j=d;k=b+8|0;c[f>>2]=c[k>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}l=c[f>>2]|0;c[h>>2]=c[a+8>>2];c[e+0>>2]=c[h+0>>2];kdc(b,l,e);e=(c[b>>2]|0)+(c[k>>2]<<2)|0;a:do if(c[f>>2]|0){k=qdd(a,3142592,c[142268]|0,0,0)|0;l=a+80|0;h=c[($hd(c[l>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((k|0)!=2){sdd(a);k=c[b>>2]|0;if((k|0)==(e|0))break;else n=k;while(1){ldc(a,n,3142592,0);n=n+4|0;if((n|0)==(e|0))break a}}k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;b:do if((p|0)!=(e|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=k;x=p;while(1){y=(da(v,h)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(j,w);y=j;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[m>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+4)|0,B>>>0<=(c[u>>2]|0)>>>0):0){g[x>>2]=ea(g[y>>2]);c[q>>2]=B}else Bid(q,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0;B=x+4|0;if((B|0)==(e|0))break b;v=c[c[m>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a)}while(0);udd(a);i=d;return}function Zcc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function _cc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[142310]|0;g=qdd(b,2490904,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else{ldc(b,a,3143216,0);ldc(b,a+4|0,3143224,0);ldc(b,a+8|0,2416480,0)}sdd(b)}g=a+12|0;h=qdd(b,614664,f,e,1)|0;if(!h){i=d;return}if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else{ldc(b,g,3143216,0);ldc(b,a+16|0,3143224,0);ldc(b,a+20|0,2416480,0)}sdd(b);i=d;return}function $cc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function adc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];kdc(b,s,e);s=c[j>>2]|0;if(!s){i=d;return}Ldd(a,c[b>>2]|0,s<<2);i=d;return}if(r){Bid(l,h,4);u=c[l>>2]|0;v=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;u=o;v=q}q=u+4|0;if(q>>>0>v>>>0){Bid(l,g,4);w=c[g>>2]|0}else{v=c[u>>2]|0;c[g>>2]=v;c[l>>2]=q;w=v}v=c[h>>2]<<2;h=zid(l,w,v)|0;w=b+12|0;if((c[w>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=v>>2;c[b+8>>2]=e;c[w>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function bdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function cdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=b;l=h}h=a+4|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[e>>2]=b;m=b;n=k}k=a+8|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[j>>2]|0}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=b;q=b;r=p}p=a+16|0;b=q+4|0;if(b>>>0>r>>>0){Bid(e,p,4);s=c[e>>2]|0;t=c[j>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[e>>2]=b;s=b;t=r}r=a+20|0;a=s+4|0;if(a>>>0>t>>>0){Bid(e,r,4);i=d;return}else{g[r>>2]=ea(g[s>>2]);c[e>>2]=a;i=d;return}}function ddc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function edc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+12|0;j=d+8|0;l=d+4|0;m=d;n=a+12|0;o=a+48|0;p=c[n>>2]|0;q=p+4|0;r=a+20|0;s=c[r>>2]|0;t=q>>>0>s>>>0;if(!(c[o>>2]|0)){if(t){Bid(n,l,4);u=c[l>>2]|0}else{v=c[p>>2]|0;c[l>>2]=v;c[n>>2]=q;u=v}v=XEi(u|0)|0;c[l>>2]=v;c[m>>2]=c[a+8>>2];c[e+0>>2]=c[m+0>>2];kdc(b,v,e);v=c[b>>2]|0;m=c[b+8>>2]|0;a=v+(m<<2)|0;if(!m){i=d;return}else w=v;do{v=c[n>>2]|0;m=v+4|0;if(m>>>0>(c[r>>2]|0)>>>0){Bid(n,w,4);x=w;y=c[w>>2]|0}else{z=ea(g[v>>2]);g[w>>2]=z;c[n>>2]=m;x=w;y=(g[k>>2]=z,c[k>>2]|0)}c[x>>2]=XEi(y|0)|0;w=w+4|0}while((w|0)!=(a|0));i=d;return}else{if(t){Bid(n,j,4);A=c[j>>2]|0;B=c[n>>2]|0;C=c[r>>2]|0}else{r=c[p>>2]|0;c[j>>2]=r;c[n>>2]=q;A=r;B=q;C=s}s=XEi(A|0)|0;c[j>>2]=s;A=B+4|0;if(A>>>0>C>>>0){Bid(n,h,4);D=c[h>>2]|0;E=c[j>>2]|0}else{j=c[B>>2]|0;c[h>>2]=j;c[n>>2]=A;D=j;E=s}s=XEi(D|0)|0;c[h>>2]=s;h=E<<2;E=zid(n,s,h)|0;s=b+12|0;if((c[s>>2]|0)>-1){n=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(n,e);c[b>>2]=0}e=h>>2;c[b+8>>2]=e;c[s>>2]=e|-2147483648;c[b>>2]=E;c[o>>2]=0;i=d;return}}function fdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function gdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;u=w+4|0;if(u>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=c[e>>2]|0;B=c[j>>2]|0}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=u;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=a+16|0;y=A+4|0;if(y>>>0>B>>>0){Bid(e,z,4);C=z;D=c[z>>2]|0;E=c[e>>2]|0;F=c[j>>2]|0}else{p=ea(g[A>>2]);g[z>>2]=p;c[e>>2]=y;C=z;D=(g[k>>2]=p,c[k>>2]|0);E=y;F=B}c[C>>2]=XEi(D|0)|0;D=a+20|0;a=E+4|0;if(a>>>0>F>>>0){Bid(e,D,4);G=D;H=c[D>>2]|0;I=XEi(H|0)|0;c[G>>2]=I;i=d;return}else{p=ea(g[E>>2]);g[D>>2]=p;c[e>>2]=a;G=D;H=(g[k>>2]=p,c[k>>2]|0);I=XEi(H|0)|0;c[G>>2]=I;i=d;return}}function hdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function idc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function jdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+12|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}h=a+16|0;p=q+4|0;if(p>>>0<r>>>0){g[q>>2]=ea(g[h>>2]);c[e>>2]=p;s=p;t=r}else{Gid(e,h,4);s=c[e>>2]|0;t=c[j>>2]|0}j=a+20|0;a=s+4|0;if(a>>>0<t>>>0){g[s>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function kdc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[h>>2]=c[a+4>>2];c[f+0>>2]=c[h+0>>2];l=hOb(j,b<<2,4,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[h>>2]=c[a+4>>2];c[f+0>>2]=c[h+0>>2];l=cOb(b<<2,4,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[a+8>>2]<<2|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b<<2)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a<<2)|0;do{if(f)g[f>>2]=ea(0.0);f=f+4|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function ldc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;h=qdd(a,d,c[142268]|0,f,0)|0;if(!h){i=e;return}if((h|0)>0){h=a+12|0;d=c[a+16>>2]|0;j=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;k=d+j|0;c[h>>2]=k;if((j|0)>=0?(l=d+(j+4)|0,l>>>0<=(c[a+20>>2]|0)>>>0):0){g[b>>2]=ea(g[k>>2]);c[h>>2]=l}else Bid(h,b,4);if(c[a>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](b,a)|0}sdd(a);i=e;return}function mdc(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=0,w=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;m=i;i=i+16|0;n=m;o=e+(da(j,h)|0)|0;p=(o|0)==(e|0);a:do if(p){q=ea(-x);r=ea(x)}else{if((f|0)>0){s=e;t=ea(-x);u=ea(x)}else{v=e;while(1){v=v+h|0;if((v|0)==(o|0)){q=ea(-x);r=ea(x);break a}}}while(1){v=0;w=t;y=u;while(1){z=ea(g[s+(v<<2)>>2]);A=w<z?z:w;B=y>z?z:y;v=v+1|0;if((v|0)==(f|0)){C=A;D=B;break}else{w=A;y=B}}s=s+h|0;if((s|0)==(o|0)){q=C;r=D;break}else{t=C;u=D}}}while(0);D=ea(q-r);s=b+4|0;g[s>>2]=D;if(D>ea(0.0)&l)E=~~ea(ca(ea(bEi(D))))+k|0;else E=k;k=r==q?0:(E|0)>32?32:E;E=b+8|0;g[E>>2]=r;l=da(j,f)|0;c[b>>2]=l;j=b+12|0;a[j>>0]=k;v=b+16|0;F=((da(k,l)|0)+7|0)>>>3;a[n>>0]=0;l=b+20|0;b=c[l>>2]|0;G=c[v>>2]|0;H=b-G|0;if(F>>>0<=H>>>0){if(F>>>0<H>>>0?(I=G+F|0,(b|0)!=(I|0)):0)c[l>>2]=I}else sdc(v,F-H|0,n);if(!k){i=m;return}r=ea(g[s>>2]);if(r>ea(0.0))J=ea(ea(1.0)/r);else J=ea(0.0);if(p){i=m;return}if((f|0)>0){K=0;L=0;M=e}else{p=e;do p=p+h|0;while((p|0)!=(o|0));i=m;return}while(1){p=K;e=0;s=L;while(1){r=ea(g[M+(e<<2)>>2]);q=ea(J*ea(r-ea(g[E>>2])));k=q<ea(0.0);r=k?ea(0.0):q;k=r>ea(1.0);q=k?ea(1.0):r;k=a[j>>0]|0;n=~~ea(ea(ea((1<<(k&255))+-1|0)*q)+ea(.5))>>>0;if(!(k<<24>>24)){N=p;O=s}else{k=p;H=0;F=s;while(1){I=(c[v>>2]|0)+F|0;a[I>>0]=d[I>>0]|0|n>>>H<<k;I=d[j>>0]|0;l=I-H|0;b=8-k|0;G=(b|0)<(l|0)?b:l;l=G+k|0;H=G+H|0;G=(l|0)==8;b=(G&1)+F|0;P=G?0:l;if((H|0)>=(I|0)){N=P;O=b;break}else{k=P;F=b}}}e=e+1|0;if((e|0)==(f|0)){Q=N;R=O;break}else{p=N;s=O}}s=M+h|0;if((s|0)==(o|0))break;else{K=Q;L=R;M=s}}i=m;return}function ndc(b,e,f,h,j,k){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;l=i;m=a[b+12>>0]|0;n=m&255;o=da(n,j)|0;p=+ea(g[b+4>>2]);if(!(m<<24>>24))q=p;else q=p/+((1<<n)+-1|0);if((k|0)==-1)r=((c[b>>2]|0)>>>0)/(f>>>0)|0;else r=k;k=e+(da(r,h)|0)|0;if((k|0)==(e|0)){i=l;return}r=(f|0)>0;j=b+8|0;s=b+16|0;b=e;e=m;t=(o|0)%8|0;u=(o|0)/8|0;while(1){if(r){o=e;v=t;w=0;x=u;while(1){y=o&255;if(!(o<<24>>24)){z=y;A=0;B=v;C=x;D=0}else{E=c[s>>2]|0;F=y;y=v;G=0;H=x;I=0;while(1){J=(d[E+H>>0]|0)>>>y<<G|I;K=F-G|0;L=8-y|0;M=(L|0)<(K|0)?L:K;K=M+y|0;G=M+G|0;M=(K|0)==8;L=M?0:K;K=(M&1)+H|0;if((n|0)<=(G|0)){z=n;A=m;B=L;C=K;D=J;break}else{F=n;y=L;H=K;I=J}}}g[b+(w<<2)>>2]=ea(q*+(((1<<z)+-1&D)>>>0)+ +ea(g[j>>2]));w=w+1|0;if((w|0)==(f|0)){N=A;O=B;P=C;break}else{o=A;v=B;x=C}}}else{N=e;O=t;P=u}b=b+h|0;if((b|0)==(k|0))break;else{e=N;t=O;u=P}}i=l;return}function odc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=b+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+12>>0]=0;e=b+44|0;f=b+72|0;g=b+92|0;h=b+120|0;i=b+140|0;j=b+168|0;k=b+188|0;l=b+208|0;m=b+228|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;a[d+24>>0]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;a[e+24>>0]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;a[f+16>>0]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;a[g+24>>0]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;a[h+16>>0]=0;c[i+0>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;c[i+12>>2]=0;c[i+16>>2]=0;c[i+20>>2]=0;a[i+24>>0]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;a[j+16>>0]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;a[k+16>>0]=0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;a[l+16>>0]=0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;return}function pdc(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=i;i=i+32|0;j=h+4|0;k=h+16|0;l=h+8|0;m=h+20|0;n=h+28|0;o=h;p=h+12|0;q=h+24|0;r=e+28|0;s=c[r>>2]|0;t=c[s+100>>2]|0;u=d[s+8>>0]|0;mdc(b,(c[s+92>>2]|0)+((d[s+9>>0]|0)+(c[s+(u*12|0)+44>>2]|0))|0,3,d[s+(u*12|0)+50>>0]|0,t,c[f>>2]|0,0);u=c[r>>2]|0;s=c[u+108>>2]|0;tdc(b+220|0,s,((c[u+112>>2]|0)-s|0)/2|0);s=b+240|0;c[s>>2]=0;u=c[r>>2]|0;v=a[u+23>>0]|0;if(!(v<<24>>24)){w=0;x=0}else{y=v&255;v=y+-1|4;c[s>>2]=v;w=v;x=y}y=a[u+27>>0]|0;if(!(y<<24>>24)){z=w;A=x}else{v=y&255;y=w|((v<<4)+-16|64);c[s>>2]=y;z=y;A=v+x|0}x=a[u+31>>0]|0;if(!(x<<24>>24)){B=z;C=A}else{v=x&255;x=z|((v<<8)+-256|1024);c[s>>2]=x;B=x;C=v+A|0}A=a[u+35>>0]|0;if(!(A<<24>>24))D=C;else{u=A&255;c[s>>2]=B|((u<<12)+-4096|16384);D=u+C|0}C=da(D,t)|0;D=c[153134]|0;c[k>>2]=D;c[j+0>>2]=c[k+0>>2];u=cOb(C<<2,4,j,0,3653512,352)|0;B=0;s=0;while(1){A=a[(c[r>>2]|0)+(B+3<<2)+11>>0]|0;if(!(A<<24>>24))E=s;else{v=A&255;Ndc(e,B,u+(s<<2)|0,v);E=(da(v,t)|0)+s|0}B=B+1|0;if((B|0)>=4)break;else s=E}if(C)mdc(b+28|0,u,C,1,1,c[f+8>>2]|0,1);if(a[(c[r>>2]|0)+15>>0]|0){E=c[153134]|0;c[k>>2]=E;c[j+0>>2]=c[k+0>>2];s=cOb(t<<3,4,j,0,3653512,352)|0;B=c[153134]|0;c[k>>2]=B;c[j+0>>2]=c[k+0>>2];v=cOb(t<<2,4,j,0,3653512,352)|0;A=c[r>>2]|0;x=a[A+15>>0]|0;if(!((a[A+14>>0]|0)!=0|(x&255)<3)){z=c[A+92>>2]|0;if((z|0)==0|x<<24>>24==0){F=1;G=0}else{x=d[A+12>>0]|0;F=d[A+(x*12|0)+50>>0]|0;G=z+((d[A+13>>0]|0)+(c[A+(x*12|0)+44>>2]|0))|0}}else{F=0;G=0}if((t|0)>0){x=G;G=0;while(1){g[s+(G<<3)>>2]=ea(g[x>>2]);g[s+(G<<3)+4>>2]=ea(g[x+4>>2]);c[v+(G<<2)>>2]=ea(g[x+8>>2])>ea(0.0)&1;G=G+1|0;if((G|0)==(t|0))break;else x=x+F|0}}mdc(b+56|0,s,2,8,t,c[f+4>>2]|0,0);udc(b+84|0,v,t);if((t|0)>-1){c[k>>2]=B;c[j+0>>2]=c[k+0>>2];eOb(v,j);c[k>>2]=E;c[j+0>>2]=c[k+0>>2];eOb(s,j)}}if(a[(c[r>>2]|0)+39>>0]|0){s=c[153134]|0;k=t<<3;c[l>>2]=s;c[j+0>>2]=c[l+0>>2];E=cOb(k,4,j,0,3653512,352)|0;v=t<<1;B=c[153134]|0;c[l>>2]=B;c[j+0>>2]=c[l+0>>2];F=cOb(k,4,j,0,3653512,352)|0;k=c[r>>2]|0;x=a[k+39>>0]|0;if(!((a[k+38>>0]|0)!=0|(x&255)<4)){G=c[k+92>>2]|0;if((G|0)==0|x<<24>>24==0){H=1;I=0}else{x=d[k+36>>0]|0;H=d[k+(x*12|0)+50>>0]|0;I=G+((d[k+37>>0]|0)+(c[k+(x*12|0)+44>>2]|0))|0}}else{H=0;I=0}if((t|0)>0){x=I;I=0;while(1){g[E+(I<<3)>>2]=ea(g[x>>2]);g[E+(I<<3)+4>>2]=ea(g[x+4>>2]);k=I<<1;c[F+(k<<2)>>2]=ea(g[x+8>>2])>ea(0.0)&1;c[F+((k|1)<<2)>>2]=ea(g[x+12>>2])>ea(0.0)&1;I=I+1|0;if((I|0)==(t|0))break;else x=x+H|0}}mdc(b+104|0,E,2,8,t,c[f+4>>2]|0,0);udc(b+132|0,F,v);if((t|0)>-1){c[l>>2]=B;c[j+0>>2]=c[l+0>>2];eOb(F,j);c[m>>2]=s;c[j+0>>2]=c[m+0>>2];eOb(E,j)}}if((a[(c[r>>2]|0)+19>>0]|0)!=0?(E=c[153134]|0,c[n>>2]=E,c[j+0>>2]=c[n+0>>2],m=cOb(t<<4,4,j,0,3653512,352)|0,Mdc(e,m),mdc(b+152|0,m,4,16,t,c[f+12>>2]|0,0),(t|0)>-1):0){c[n>>2]=E;c[j+0>>2]=c[n+0>>2];eOb(m,j)}m=c[r>>2]|0;if((c[m+144>>2]|0)!=0?(r=c[m+136>>2]|0,(r|0)!=0):0){m=c[153134]|0;c[o>>2]=m;c[j+0>>2]=c[o+0>>2];n=cOb(t*12|0,4,j,0,3653512,352)|0;E=c[153134]|0;c[o>>2]=E;c[j+0>>2]=c[o+0>>2];f=cOb(t<<4,4,j,0,3653512,352)|0;if((t|0)>0){e=0;s=0;F=0;while(1){l=3;while(1){B=l+-1|0;if(!(ea(g[r+(s<<5)+(l<<2)>>2])==ea(0.0))){J=l;break}if((B|0)>0)l=B;else{J=B;break}}l=e;B=0;v=0;H=F;while(1){if(!((B|0)<=(J|0)&(v|0)<31)){K=l;L=B;M=v;N=H;break}x=n+(H<<2)|0;c[x>>2]=~~ea(ea(g[r+(s<<5)+(B<<2)>>2])*ea(31.0))>>>0;I=l+1|0;c[f+(l<<2)>>2]=c[r+(s<<5)+(B<<2)+16>>2];k=H+1|0;G=(c[x>>2]|0)+v|0;x=B+1|0;if((x|0)<3){l=I;B=x;v=G;H=k}else{K=I;L=x;M=G;N=k;break}}H=(M|0)<31;if((J|0)<3)if(H){v=n+(N+-1<<2)|0;c[v>>2]=31-M+(c[v>>2]|0);O=K}else O=K;else if(H){c[f+(K<<2)>>2]=c[r+(s<<5)+(L<<2)+16>>2];O=K+1|0}else O=K;s=s+1|0;if((s|0)==(t|0)){P=O;Q=N;break}else{e=O;F=N}}}else{P=0;Q=0}udc(b+180|0,n,Q);udc(b+200|0,f,P);if((t|0)>-1){c[o>>2]=E;c[j+0>>2]=c[o+0>>2];eOb(f,j);c[p>>2]=m;c[j+0>>2]=c[p+0>>2];eOb(n,j)}}if((C|0)<=-1){i=h;return}c[q>>2]=D;c[j+0>>2]=c[q+0>>2];eOb(u,j);i=h;return}function qdc(e,f){e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=Im,ab=Im,bb=Im,cb=Im,db=Im,eb=Im,fb=0.0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=Im,Ab=0.0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;h=i;i=i+48|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;o=h+24|0;p=c[e>>2]|0;q=(p|0)/3|0;do if((p|0)==(q*3|0)){r=e+56|0;s=c[r>>2]|0;if(s){if((s|0)!=(q<<1|0))break;if((c[e+84>>2]|0)!=(q|0))break}s=e+104|0;t=c[s>>2]|0;if(t){if((t|0)!=(q<<1|0))break;if((c[e+132>>2]|0)!=(t|0))break}t=e+152|0;u=c[t>>2]|0;if((u|0)==0|(u|0)==(q<<2|0)){u=e+220|0;v=c[u>>2]|0;w=f+28|0;x=c[w>>2]|0;y=x+108|0;z=v<<1;A=x+112|0;B=c[A>>2]|0;C=c[y>>2]|0;D=B-C|0;if(z>>>0<=D>>>0)if(z>>>0<D>>>0?(E=C+z|0,(B|0)!=(E|0)):0){c[A>>2]=E;F=x;G=v}else{F=x;G=v}else{vdc(y,z-D|0);F=c[w>>2]|0;G=c[u>>2]|0}u=c[F+108>>2]|0;D=a[e+224>>0]|0;z=cFi(1,0,D&255|0)|0;y=_Ei(z|0,H|0,65535,0)|0;if(G){z=e+228|0;v=D&255;x=D;E=0;A=0;B=0;while(1){C=u+(A<<1)|0;b[C>>1]=0;if(!(x<<24>>24)){I=0;J=0;K=E;L=B}else{M=c[z>>2]|0;N=0;O=E;P=0;Q=B;while(1){R=(d[M+Q>>0]|0)>>>O<<P|N&65535;b[C>>1]=R;S=v-P|0;U=8-O|0;V=(U|0)<(S|0)?U:S;S=V+O|0;P=V+P|0;V=(S|0)==8;U=V?0:S;S=(V&1)+Q|0;if((P|0)>=(v|0)){W=U;X=S;Y=R;break}else{N=R;O=U;Q=S}}I=D;J=Y&65535;K=W;L=X}b[C>>1]=J&y;A=A+1|0;if((A|0)==(G|0))break;else{x=I;E=K;B=L}}}B=c[e>>2]|0;E=(B|0)/3|0;x=o+0|0;A=575992;y=x+16|0;do{a[x>>0]=a[A>>0]|0;x=x+1|0;A=A+1|0}while((x|0)<(y|0));A=(B|0)!=0&1;x=(c[r>>2]|0)==0?A:A|2;A=c[e+240>>2]|0;if(A){if(!(A&4))Z=x;else{a[o+7>>0]=(A&3)+1;Z=x|8}y=A>>>4;if(!(y&4))_=Z;else{a[o+9>>0]=(y&3)+1;_=Z|16}y=A>>>8;if(!(y&4))$=_;else{a[o+11>>0]=(y&3)+1;$=_|32}y=A>>>12;if(!(y&4))aa=$;else{a[o+13>>0]=(y&3)+1;aa=$|64}}else{y=c[e+28>>2]|0;A=(y|0)==0?x:x|8;aa=(y|0)==(E<<2|0)?A|16:A}A=(c[s>>2]|0)==0?aa:aa|128;y=o+4|0;do if(!(c[t>>2]|0))ba=A;else{x=A|4;ca=ea(g[e+160>>2]);if(!(ca<ea(0.0))?!(ea(ca+ea(g[e+156>>2]))>ea(1.0)):0){ba=x;break}a[y>>0]=0;ba=x}while(0);Pdc(f,E,ba,ba,o);Jdc(f,0);A=c[w>>2]|0;x=c[A+92>>2]|0;D=d[A+8>>0]|0;v=(d[A+9>>0]|0)+(c[A+(D*12|0)+44>>2]|0)|0;z=d[A+(D*12|0)+50>>0]|0;D=a[e+12>>0]|0;u=D&255;fa=+ea(g[e+4>>2]);if(!(D<<24>>24))ga=fa;else ga=fa/+((1<<u)+-1|0);Q=da(((c[e>>2]|0)>>>0)/3|0,z)|0;O=x+(Q+v)|0;if(Q){Q=e+8|0;N=e+16|0;P=x+v|0;v=D;M=0;S=0;while(1){U=v&255;if(!(v<<24>>24)){ha=U;ia=0;ja=M;ka=S;la=0}else{R=c[N>>2]|0;V=U;U=M;ma=0;na=S;oa=0;while(1){pa=(d[R+na>>0]|0)>>>U<<ma|oa;qa=V-ma|0;ra=8-U|0;sa=(ra|0)<(qa|0)?ra:qa;qa=sa+U|0;ma=sa+ma|0;sa=(qa|0)==8;ra=sa?0:qa;qa=(sa&1)+na|0;if((u|0)<=(ma|0)){ha=u;ia=D;ja=ra;ka=qa;la=pa;break}else{V=u;U=ra;na=qa;oa=pa}}}g[P>>2]=ea(ga*+(((1<<ha)+-1&la)>>>0)+ +ea(g[Q>>2]));oa=ia&255;if(!(ia<<24>>24)){ta=oa;ua=0;va=ja;wa=ka;xa=0}else{na=c[N>>2]|0;U=oa;oa=ja;V=0;ma=ka;R=0;while(1){C=(d[na+ma>>0]|0)>>>oa<<V|R;pa=U-V|0;qa=8-oa|0;ra=(qa|0)<(pa|0)?qa:pa;pa=ra+oa|0;V=ra+V|0;ra=(pa|0)==8;qa=ra?0:pa;pa=(ra&1)+ma|0;if((u|0)<=(V|0)){ta=u;ua=D;va=qa;wa=pa;xa=C;break}else{U=u;oa=qa;ma=pa;R=C}}}g[P+4>>2]=ea(ga*+(((1<<ta)+-1&xa)>>>0)+ +ea(g[Q>>2]));R=ua&255;if(!(ua<<24>>24)){ya=R;za=0;Aa=va;Ba=wa;Ca=0}else{ma=c[N>>2]|0;oa=R;R=va;U=0;V=wa;na=0;while(1){C=(d[ma+V>>0]|0)>>>R<<U|na;pa=oa-U|0;qa=8-R|0;ra=(qa|0)<(pa|0)?qa:pa;pa=ra+R|0;U=ra+U|0;ra=(pa|0)==8;qa=ra?0:pa;pa=(ra&1)+V|0;if((u|0)<=(U|0)){ya=u;za=D;Aa=qa;Ba=pa;Ca=C;break}else{oa=u;R=qa;V=pa;na=C}}}g[P+8>>2]=ea(ga*+(((1<<ya)+-1&Ca)>>>0)+ +ea(g[Q>>2]));P=P+z|0;if((P|0)==(O|0))break;else{v=za;M=Aa;S=Ba}}}S=e+28|0;if(!(ba&8))Da=0;else{M=d[o+7>>0]|0;v=d[A+20>>0]|0;ndc(S,x+((d[A+21>>0]|0)+(c[A+(v*12|0)+44>>2]|0))|0,M,d[A+(v*12|0)+50>>0]|0,0,E);Da=da(M,E)|0}if(!(ba&16))Ea=Da;else{M=d[o+9>>0]|0;v=c[w>>2]|0;O=d[v+24>>0]|0;ndc(S,(c[v+92>>2]|0)+((d[v+25>>0]|0)+(c[v+(O*12|0)+44>>2]|0))|0,M,d[v+(O*12|0)+50>>0]|0,Da,E);Ea=(da(M,E)|0)+Da|0}if(!(ba&32))Fa=Ea;else{M=d[o+11>>0]|0;O=c[w>>2]|0;v=d[O+28>>0]|0;ndc(S,(c[O+92>>2]|0)+((d[O+29>>0]|0)+(c[O+(v*12|0)+44>>2]|0))|0,M,d[O+(v*12|0)+50>>0]|0,Ea,E);Fa=(da(M,E)|0)+Ea|0}if(ba&64){M=c[w>>2]|0;v=d[M+32>>0]|0;ndc(S,(c[M+92>>2]|0)+((d[M+33>>0]|0)+(c[M+(v*12|0)+44>>2]|0))|0,d[o+13>>0]|0,d[M+(v*12|0)+50>>0]|0,Fa,E)}do if(c[r>>2]|0){v=c[153134]|0;c[k>>2]=v;c[j+0>>2]=c[k+0>>2];M=cOb(E<<3,4,j,0,3653512,352)|0;S=e+84|0;O=c[S>>2]|0;P=c[153134]|0;c[k>>2]=P;c[j+0>>2]=c[k+0>>2];z=cOb(O<<2,4,j,0,3653512,352)|0;Q=a[e+68>>0]|0;u=Q&255;fa=+ea(g[e+60>>2]);if(!(Q<<24>>24))Ga=fa;else Ga=fa/+((1<<u)+-1|0);D=(c[r>>2]|0)>>>1;N=M+(D<<3)|0;if(D){D=e+64|0;na=e+72|0;V=M;R=Q;oa=0;U=0;while(1){ma=R&255;if(!(R<<24>>24)){Ha=ma;Ia=0;Ja=oa;Ka=U;La=0}else{C=c[na>>2]|0;pa=ma;ma=oa;qa=0;ra=U;sa=0;while(1){Ma=(d[C+ra>>0]|0)>>>ma<<qa|sa;Na=pa-qa|0;Oa=8-ma|0;Pa=(Oa|0)<(Na|0)?Oa:Na;Na=Pa+ma|0;qa=Pa+qa|0;Pa=(Na|0)==8;Oa=Pa?0:Na;Na=(Pa&1)+ra|0;if((u|0)<=(qa|0)){Ha=u;Ia=Q;Ja=Oa;Ka=Na;La=Ma;break}else{pa=u;ma=Oa;ra=Na;sa=Ma}}}g[V>>2]=ea(Ga*+(((1<<Ha)+-1&La)>>>0)+ +ea(g[D>>2]));sa=Ia&255;if(!(Ia<<24>>24)){Qa=sa;Ra=0;Sa=Ja;Ta=Ka;Ua=0}else{ra=c[na>>2]|0;ma=sa;sa=Ja;pa=0;qa=Ka;C=0;while(1){Ma=(d[ra+qa>>0]|0)>>>sa<<pa|C;Na=ma-pa|0;Oa=8-sa|0;Pa=(Oa|0)<(Na|0)?Oa:Na;Na=Pa+sa|0;pa=Pa+pa|0;Pa=(Na|0)==8;Oa=Pa?0:Na;Na=(Pa&1)+qa|0;if((u|0)<=(pa|0)){Qa=u;Ra=Q;Sa=Oa;Ta=Na;Ua=Ma;break}else{ma=u;sa=Oa;qa=Na;C=Ma}}}g[V+4>>2]=ea(Ga*+(((1<<Qa)+-1&Ua)>>>0)+ +ea(g[D>>2]));V=V+8|0;if((V|0)==(N|0))break;else{R=Ra;oa=Sa;U=Ta}}}U=a[e+88>>0]|0;oa=cFi(1,0,U&255|0)|0;R=_Ei(oa|0,H|0,-1,0)|0;if(c[S>>2]|0){oa=e+92|0;N=U&255;V=U;D=0;u=0;Q=0;while(1){na=z+(u<<2)|0;c[na>>2]=0;if(!(V<<24>>24)){Va=0;Wa=0;Xa=D;Ya=Q}else{C=c[oa>>2]|0;qa=0;sa=D;ma=0;pa=Q;while(1){ra=(d[C+pa>>0]|0)>>>sa<<ma|qa;c[na>>2]=ra;Ma=N-ma|0;Na=8-sa|0;Oa=(Na|0)<(Ma|0)?Na:Ma;Ma=Oa+sa|0;ma=Oa+ma|0;Oa=(Ma|0)==8;Na=Oa?0:Ma;Ma=(Oa&1)+pa|0;if((ma|0)>=(N|0)){Va=U;Wa=ra;Xa=Na;Ya=Ma;break}else{qa=ra;sa=Na;pa=Ma}}}c[na>>2]=Wa&R;u=u+1|0;if(u>>>0>=(c[S>>2]|0)>>>0)break;else{V=Va;D=Xa;Q=Ya}}}Q=c[w>>2]|0;D=a[Q+15>>0]|0;do if((a[Q+14>>0]|0)!=0|(D&255)<3){Za=0;_a=0}else{V=c[Q+92>>2]|0;if((V|0)==0|D<<24>>24==0){Za=0;_a=1;break}S=d[Q+12>>0]|0;Za=V+((d[Q+13>>0]|0)+(c[Q+(S*12|0)+44>>2]|0))|0;_a=d[Q+(S*12|0)+50>>0]|0}while(0);if((B|0)>2){Q=Za;D=0;while(1){ca=ea(g[M+(D<<3)>>2]);g[Q>>2]=ca;$a=ea(g[M+(D<<3)+4>>2]);S=Q+4|0;g[S>>2]=$a;ab=ea(ca*ca);bb=ea($a*$a);cb=ea(ea(ea(1.0)-ab)-bb);if(!(cb>=ea(0.0))){db=ea(T(ea(ea(ab+bb)+ea(0.0))));bb=ea($a/db);$a=ea(ea(0.0)/db);g[Q>>2]=ea(ca/db);g[S>>2]=bb;g[Q+8>>2]=$a;eb=$a}else{$a=ea(T(ea(cb)));g[Q+8>>2]=$a;eb=$a}if(!(c[z+(D<<2)>>2]|0))g[Q+8>>2]=ea(-eb);D=D+1|0;if((D|0)>=(E|0))break;else Q=Q+_a|0}}if((O|0)>-1){c[k>>2]=P;c[j+0>>2]=c[k+0>>2];eOb(z,j)}if((B|0)<=-3)break;c[l>>2]=v;c[j+0>>2]=c[l+0>>2];eOb(M,j)}while(0);do if(c[s>>2]|0){r=c[153134]|0;c[l>>2]=r;c[j+0>>2]=c[l+0>>2];A=cOb(E<<3,4,j,0,3653512,352)|0;x=e+132|0;Q=c[x>>2]|0;D=c[153134]|0;c[l>>2]=D;c[j+0>>2]=c[l+0>>2];S=cOb(Q<<2,4,j,0,3653512,352)|0;V=a[e+116>>0]|0;u=V&255;fa=+ea(g[e+108>>2]);if(!(V<<24>>24))fb=fa;else fb=fa/+((1<<u)+-1|0);R=(c[s>>2]|0)>>>1;U=A+(R<<3)|0;if(R){R=e+112|0;N=e+120|0;oa=A;pa=V;sa=0;qa=0;while(1){ma=pa&255;if(!(pa<<24>>24)){gb=ma;hb=0;ib=sa;jb=qa;kb=0}else{C=c[N>>2]|0;Ma=ma;ma=sa;Na=0;ra=qa;Oa=0;while(1){Pa=(d[C+ra>>0]|0)>>>ma<<Na|Oa;lb=Ma-Na|0;mb=8-ma|0;nb=(mb|0)<(lb|0)?mb:lb;lb=nb+ma|0;Na=nb+Na|0;nb=(lb|0)==8;mb=nb?0:lb;lb=(nb&1)+ra|0;if((u|0)<=(Na|0)){gb=u;hb=V;ib=mb;jb=lb;kb=Pa;break}else{Ma=u;ma=mb;ra=lb;Oa=Pa}}}g[oa>>2]=ea(fb*+(((1<<gb)+-1&kb)>>>0)+ +ea(g[R>>2]));Oa=hb&255;if(!(hb<<24>>24)){ob=Oa;pb=0;qb=ib;rb=jb;sb=0}else{ra=c[N>>2]|0;ma=Oa;Oa=ib;Ma=0;Na=jb;C=0;while(1){na=(d[ra+Na>>0]|0)>>>Oa<<Ma|C;Pa=ma-Ma|0;lb=8-Oa|0;mb=(lb|0)<(Pa|0)?lb:Pa;Pa=mb+Oa|0;Ma=mb+Ma|0;mb=(Pa|0)==8;lb=mb?0:Pa;Pa=(mb&1)+Na|0;if((u|0)<=(Ma|0)){ob=u;pb=V;qb=lb;rb=Pa;sb=na;break}else{ma=u;Oa=lb;Na=Pa;C=na}}}g[oa+4>>2]=ea(fb*+(((1<<ob)+-1&sb)>>>0)+ +ea(g[R>>2]));oa=oa+8|0;if((oa|0)==(U|0))break;else{pa=pb;sa=qb;qa=rb}}}qa=a[e+136>>0]|0;sa=cFi(1,0,qa&255|0)|0;pa=_Ei(sa|0,H|0,-1,0)|0;if(c[x>>2]|0){sa=e+140|0;U=qa&255;oa=qa;R=0;u=0;V=0;while(1){N=S+(u<<2)|0;c[N>>2]=0;if(!(oa<<24>>24)){tb=0;ub=0;vb=R;wb=V}else{M=c[sa>>2]|0;v=0;z=R;P=0;O=V;while(1){C=(d[M+O>>0]|0)>>>z<<P|v;c[N>>2]=C;Na=U-P|0;Oa=8-z|0;ma=(Oa|0)<(Na|0)?Oa:Na;Na=ma+z|0;P=ma+P|0;ma=(Na|0)==8;Oa=ma?0:Na;Na=(ma&1)+O|0;if((P|0)>=(U|0)){tb=qa;ub=C;vb=Oa;wb=Na;break}else{v=C;z=Oa;O=Na}}}c[N>>2]=ub&pa;u=u+1|0;if(u>>>0>=(c[x>>2]|0)>>>0)break;else{oa=tb;R=vb;V=wb}}}V=c[w>>2]|0;R=a[V+39>>0]|0;do if((a[V+38>>0]|0)!=0|(R&255)<4){xb=0;yb=0}else{oa=c[V+92>>2]|0;if((oa|0)==0|R<<24>>24==0){xb=0;yb=1;break}x=d[V+36>>0]|0;xb=oa+((d[V+37>>0]|0)+(c[V+(x*12|0)+44>>2]|0))|0;yb=d[V+(x*12|0)+50>>0]|0}while(0);if((B|0)>2){V=xb;R=0;while(1){$a=ea(g[A+(R<<3)>>2]);g[V>>2]=$a;cb=ea(g[A+(R<<3)+4>>2]);x=V+4|0;g[x>>2]=cb;bb=ea($a*$a);db=ea(cb*cb);ca=ea(ea(ea(1.0)-bb)-db);if(!(ca>=ea(0.0))){ab=ea(T(ea(ea(bb+db)+ea(0.0))));db=ea(cb/ab);cb=ea(ea(0.0)/ab);g[V>>2]=ea($a/ab);g[x>>2]=db;g[V+8>>2]=cb;zb=cb}else{cb=ea(T(ea(ca)));g[V+8>>2]=cb;zb=cb}x=R<<1;if(!(c[S+(x<<2)>>2]|0))g[V+8>>2]=ea(-zb);g[V+12>>2]=(c[S+((x|1)<<2)>>2]|0)!=0?ea(1.0):ea(-1.0);R=R+1|0;if((R|0)>=(E|0))break;else V=V+yb|0}}if((Q|0)>-1){c[l>>2]=D;c[j+0>>2]=c[l+0>>2];eOb(S,j)}if((B|0)<=-3)break;c[m>>2]=r;c[j+0>>2]=c[m+0>>2];eOb(A,j)}while(0);do if(c[t>>2]|0){s=c[153134]|0;c[m>>2]=s;c[j+0>>2]=c[m+0>>2];V=cOb(E<<4,4,j,0,3653512,352)|0;R=a[e+164>>0]|0;x=R&255;fa=+ea(g[e+156>>2]);if(!(R<<24>>24))Ab=fa;else Ab=fa/+((1<<x)+-1|0);oa=(c[t>>2]|0)>>>2;u=V+(oa<<4)|0;if(oa){oa=e+160|0;pa=e+168|0;qa=V;U=R;sa=0;O=0;while(1){z=U&255;if(!(U<<24>>24)){Bb=z;Cb=0;Db=sa;Eb=O;Fb=0}else{v=c[pa>>2]|0;P=z;z=sa;M=0;Na=O;Oa=0;while(1){C=(d[v+Na>>0]|0)>>>z<<M|Oa;ma=P-M|0;Ma=8-z|0;ra=(Ma|0)<(ma|0)?Ma:ma;ma=ra+z|0;M=ra+M|0;ra=(ma|0)==8;Ma=ra?0:ma;ma=(ra&1)+Na|0;if((x|0)<=(M|0)){Bb=x;Cb=R;Db=Ma;Eb=ma;Fb=C;break}else{P=x;z=Ma;Na=ma;Oa=C}}}g[qa>>2]=ea(Ab*+(((1<<Bb)+-1&Fb)>>>0)+ +ea(g[oa>>2]));Oa=Cb&255;if(!(Cb<<24>>24)){Gb=Oa;Hb=0;Ib=Db;Jb=Eb;Kb=0}else{Na=c[pa>>2]|0;z=Oa;Oa=Db;P=0;M=Eb;v=0;while(1){N=(d[Na+M>>0]|0)>>>Oa<<P|v;C=z-P|0;ma=8-Oa|0;Ma=(ma|0)<(C|0)?ma:C;C=Ma+Oa|0;P=Ma+P|0;Ma=(C|0)==8;ma=Ma?0:C;C=(Ma&1)+M|0;if((x|0)<=(P|0)){Gb=x;Hb=R;Ib=ma;Jb=C;Kb=N;break}else{z=x;Oa=ma;M=C;v=N}}}g[qa+4>>2]=ea(Ab*+(((1<<Gb)+-1&Kb)>>>0)+ +ea(g[oa>>2]));v=Hb&255;if(!(Hb<<24>>24)){Lb=v;Mb=0;Nb=Ib;Ob=Jb;Pb=0}else{M=c[pa>>2]|0;Oa=v;v=Ib;z=0;P=Jb;Na=0;while(1){N=(d[M+P>>0]|0)>>>v<<z|Na;C=Oa-z|0;ma=8-v|0;Ma=(ma|0)<(C|0)?ma:C;C=Ma+v|0;z=Ma+z|0;Ma=(C|0)==8;ma=Ma?0:C;C=(Ma&1)+P|0;if((x|0)<=(z|0)){Lb=x;Mb=R;Nb=ma;Ob=C;Pb=N;break}else{Oa=x;v=ma;P=C;Na=N}}}g[qa+8>>2]=ea(Ab*+(((1<<Lb)+-1&Pb)>>>0)+ +ea(g[oa>>2]));Na=Mb&255;if(!(Mb<<24>>24)){Qb=Na;Rb=0;Sb=Nb;Tb=Ob;Ub=0}else{P=c[pa>>2]|0;v=Na;Na=Nb;Oa=0;z=Ob;M=0;while(1){N=(d[P+z>>0]|0)>>>Na<<Oa|M;C=v-Oa|0;ma=8-Na|0;Ma=(ma|0)<(C|0)?ma:C;C=Ma+Na|0;Oa=Ma+Oa|0;Ma=(C|0)==8;ma=Ma?0:C;C=(Ma&1)+z|0;if((x|0)<=(Oa|0)){Qb=x;Rb=R;Sb=ma;Tb=C;Ub=N;break}else{v=x;Na=ma;z=C;M=N}}}g[qa+12>>2]=ea(Ab*+(((1<<Qb)+-1&Ub)>>>0)+ +ea(g[oa>>2]));qa=qa+16|0;if((qa|0)==(u|0))break;else{U=Rb;sa=Sb;O=Tb}}}O=V+(E<<4)|0;sa=c[w>>2]|0;U=a[sa+18>>0]|0;u=a[sa+19>>0]|0;do if((a[y>>0]|0)==2){do if(U<<24>>24!=2|(u&255)<4){Vb=0;Wb=0}else{qa=c[sa+92>>2]|0;if((qa|0)==0|u<<24>>24==0){Vb=0;Wb=1;break}oa=d[sa+16>>0]|0;Vb=qa+((d[sa+17>>0]|0)+(c[sa+(oa*12|0)+44>>2]|0))|0;Wb=d[sa+(oa*12|0)+50>>0]|0}while(0);if((V|0)!=(O|0)){oa=V;qa=Vb;while(1){cb=ea(g[oa>>2]);x=cb<ea(0.0);ca=x?ea(0.0):cb;x=ca>ea(1.0);R=~~ea(ea(ca*ea(255.0))+ea(.5))>>>0&255;a[qa>>0]=x?-1:R;ca=ea(g[oa+4>>2]);R=ca<ea(0.0);cb=R?ea(0.0):ca;R=cb>ea(1.0);x=~~ea(ea(cb*ea(255.0))+ea(.5))>>>0&255;a[qa+1>>0]=R?-1:x;cb=ea(g[oa+8>>2]);x=cb<ea(0.0);ca=x?ea(0.0):cb;x=ca>ea(1.0);R=~~ea(ea(ca*ea(255.0))+ea(.5))>>>0&255;a[qa+2>>0]=x?-1:R;ca=ea(g[oa+12>>2]);R=ca<ea(0.0);cb=R?ea(0.0):ca;R=cb>ea(1.0);x=~~ea(ea(cb*ea(255.0))+ea(.5))>>>0&255;a[qa+3>>0]=R?-1:x;oa=oa+16|0;if((oa|0)==(O|0))break;else qa=qa+Wb|0}}Idc(f,1)}else{do if(U<<24>>24!=0|(u&255)<4){Xb=0;Yb=0}else{qa=c[sa+92>>2]|0;if((qa|0)==0|u<<24>>24==0){Xb=0;Yb=1;break}oa=d[sa+16>>0]|0;Xb=qa+((d[sa+17>>0]|0)+(c[sa+(oa*12|0)+44>>2]|0))|0;Yb=d[sa+(oa*12|0)+50>>0]|0}while(0);if((V|0)==(O|0))break;else{Zb=V;_b=Xb}while(1){cb=ea(g[Zb>>2]);ca=ea(g[Zb+4>>2]);db=ea(g[Zb+8>>2]);ab=ea(g[Zb+12>>2]);g[_b>>2]=cb;g[_b+4>>2]=ca;g[_b+8>>2]=db;g[_b+12>>2]=ab;Zb=Zb+16|0;if((Zb|0)==(O|0))break;else _b=_b+Yb|0}}while(0);if((B|0)<=-3)break;c[m>>2]=s;c[j+0>>2]=c[m+0>>2];eOb(V,j)}while(0);B=e+180|0;y=c[B>>2]|0;if(!y){i=h;return}t=c[153134]|0;c[m>>2]=t;c[j+0>>2]=c[m+0>>2];O=cOb(y<<2,4,j,0,3653512,352)|0;sa=a[e+184>>0]|0;u=cFi(1,0,sa&255|0)|0;U=_Ei(u|0,H|0,-1,0)|0;if(c[B>>2]|0){u=e+188|0;oa=sa&255;qa=sa;x=0;R=0;pa=0;while(1){A=O+(R<<2)|0;c[A>>2]=0;if(!(qa<<24>>24)){$b=0;ac=0;bc=x;cc=pa}else{r=c[u>>2]|0;S=0;D=x;Q=0;M=pa;while(1){z=(d[r+M>>0]|0)>>>D<<Q|S;c[A>>2]=z;Na=oa-Q|0;v=8-D|0;Oa=(v|0)<(Na|0)?v:Na;Na=Oa+D|0;Q=Oa+Q|0;Oa=(Na|0)==8;v=Oa?0:Na;Na=(Oa&1)+M|0;if((Q|0)>=(oa|0)){$b=sa;ac=z;bc=v;cc=Na;break}else{S=z;D=v;M=Na}}}c[A>>2]=ac&U;R=R+1|0;if(R>>>0>=(c[B>>2]|0)>>>0)break;else{qa=$b;x=bc;pa=cc}}}pa=e+200|0;x=c[pa>>2]|0;qa=c[153134]|0;c[m>>2]=qa;c[j+0>>2]=c[m+0>>2];R=cOb(x<<2,4,j,0,3653512,352)|0;U=a[e+204>>0]|0;sa=cFi(1,0,U&255|0)|0;oa=_Ei(sa|0,H|0,-1,0)|0;if(c[pa>>2]|0){sa=e+208|0;u=U&255;M=U;D=0;S=0;Q=0;while(1){r=R+(S<<2)|0;c[r>>2]=0;if(!(M<<24>>24)){dc=0;ec=0;fc=D;gc=Q}else{V=c[sa>>2]|0;s=0;Na=D;v=0;z=Q;while(1){Oa=(d[V+z>>0]|0)>>>Na<<v|s;c[r>>2]=Oa;P=u-v|0;N=8-Na|0;C=(N|0)<(P|0)?N:P;P=C+Na|0;v=C+v|0;C=(P|0)==8;N=C?0:P;P=(C&1)+z|0;if((v|0)>=(u|0)){dc=U;ec=Oa;fc=N;gc=P;break}else{s=Oa;Na=N;z=P}}}c[r>>2]=ec&oa;S=S+1|0;if(S>>>0>=(c[pa>>2]|0)>>>0)break;else{M=dc;D=fc;Q=gc}}}Q=c[w>>2]|0;D=Q+136|0;M=Q+144|0;c[M>>2]=E;pa=Q+148|0;S=c[pa>>2]|0;do if((S&2147483647)>>>0<E>>>0)if((S|0)>-1){c[pa>>2]=E;oa=c[D>>2]|0;c[m>>2]=c[Q+140>>2];c[j+0>>2]=c[m+0>>2];c[D>>2]=hOb(oa,E<<5,16,j,0,3653512,370)|0;break}else{c[m>>2]=c[Q+140>>2];c[j+0>>2]=c[m+0>>2];oa=cOb(E<<5,16,j,0,3653512,352)|0;YEi(oa|0,c[D>>2]|0,c[M>>2]<<5|0)|0;c[pa>>2]=E;c[D>>2]=oa;break}while(0);if((c[B>>2]|0)>0){E=c[D>>2]|0;pa=0;M=0;Q=0;S=0;w=0;while(1){oa=O+(Q<<2)|0;g[E+(M<<5)+(S<<2)>>2]=ea(+((c[oa>>2]|0)>>>0)/31.0);U=pa+1|0;c[E+(M<<5)+(S<<2)+16>>2]=c[R+(pa<<2)>>2];u=S+1|0;sa=(c[oa>>2]|0)+w|0;do if((sa|0)>30){if((u|0)<4){oa=u;do{g[E+(M<<5)+(oa<<2)>>2]=ea(0.0);c[E+(M<<5)+(oa<<2)+16>>2]=0;oa=oa+1|0}while((oa|0)!=4)}hc=U;ic=M+1|0;jc=0;kc=0}else{if((u|0)!=3){hc=U;ic=M;jc=u;kc=sa;break}g[E+(M<<5)+12>>2]=ea(+(31-sa|0)/31.0);c[E+(M<<5)+28>>2]=c[R+(U<<2)>>2];hc=pa+2|0;ic=M+1|0;jc=0;kc=0}while(0);Q=Q+1|0;if((Q|0)>=(c[B>>2]|0))break;else{pa=hc;M=ic;S=jc;w=kc}}}if((x|0)>-1){c[m>>2]=qa;c[j+0>>2]=c[m+0>>2];eOb(R,j)}if((y|0)<=-1){i=h;return}c[n>>2]=t;c[j+0>>2]=c[n+0>>2];eOb(O,j);i=h;return}}while(0);Krd(573568,0,3653512,456,1,0,0,0);i=h;return}function rdc(a){a=a|0;return 573592+(a<<4)|0}function sdc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+8|0;h=c[g>>2]|0;j=b+4|0;k=c[j>>2]|0;l=k;if((h-l|0)>>>0>=d>>>0){m=d;n=k;do{if(!n)o=0;else{a[n>>0]=a[e>>0]|0;o=c[j>>2]|0}n=o+1|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=f;return}m=c[b>>2]|0;n=l-m+d|0;if((n|0)<0)vxi(b);l=m;m=h-l|0;if(m>>>0<1073741823){h=m<<1;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=(c[j>>2]|0)-l|0;u=10}if((u|0)==10){p=s;q=xCi(s)|0;r=t}t=d;d=q+r|0;while(1){if(!d)v=0;else{a[d>>0]=a[e>>0]|0;v=d}s=v+1|0;t=t+-1|0;if(!t){w=s;break}else d=s}d=c[b>>2]|0;t=(c[j>>2]|0)-d|0;v=q+(r-t)|0;YEi(v|0,d|0,t|0)|0;c[b>>2]=v;c[j>>2]=w;c[g>>2]=q+p;if(!d){i=f;return}ACi(d);i=f;return}function tdc(b,f,g){b=b|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+16|0;j=h;k=(g|0)>0;if(k){l=0;m=0;while(1){n=e[f+(l<<1)>>1]|0;o=m>>>0<n>>>0?n:m;l=l+1|0;if((l|0)==(g|0)){p=o;break}else m=o}c[b>>2]=g;if(!p)q=0;else{m=p>>>0>65535;l=m?p>>>16:p;p=m?16:0;if(!(l&65280)){r=l;s=p}else{r=l>>>8;s=p|8}if(!(r&240)){t=r;u=s}else{t=r>>>4;u=s+4|0}q=u+1+(d[595568+t>>0]|0)&255}}else{c[b>>2]=g;q=0}t=b+4|0;a[t>>0]=q;u=b+8|0;s=((da(q&255,g)|0)+7|0)/8|0;a[j>>0]=0;q=b+12|0;b=c[q>>2]|0;r=c[u>>2]|0;p=b-r|0;if(s>>>0<=p>>>0){if(s>>>0<p>>>0?(l=r+s|0,(b|0)!=(l|0)):0)c[q>>2]=l}else sdc(u,s-p|0,j);if(!k){i=h;return}k=a[t>>0]|0;j=0;p=0;s=0;while(1){if(!(k<<24>>24)){v=0;w=j;x=s}else{l=f+(p<<1)|0;q=j;b=0;r=s;while(1){m=(c[u>>2]|0)+r|0;a[m>>0]=d[m>>0]|0|(e[l>>1]|0)>>>b<<q;m=a[t>>0]|0;o=m&255;n=o-b|0;y=8-q|0;z=(y|0)<(n|0)?y:n;n=z+q|0;b=z+b|0;z=(n|0)==8;y=(z&1)+r|0;A=z?0:n;if((b|0)>=(o|0)){v=m;w=A;x=y;break}else{q=A;r=y}}}p=p+1|0;if((p|0)==(g|0))break;else{k=v;j=w;s=x}}i=h;return}function udc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+16|0;h=g;j=(f|0)>0;if(j){k=0;l=0;while(1){m=c[e+(k<<2)>>2]|0;n=l>>>0<m>>>0?m:l;k=k+1|0;if((k|0)==(f|0)){o=n;break}else l=n}c[b>>2]=f;if(!o)p=0;else{l=o>>>0>65535;k=l?o>>>16:o;o=l?16:0;if(!(k&65280)){q=k;r=o}else{q=k>>>8;r=o|8}if(!(q&240)){s=q;t=r}else{s=q>>>4;t=r+4|0}p=t+1+(d[595568+s>>0]|0)&255}}else{c[b>>2]=f;p=0}s=b+4|0;a[s>>0]=p;t=b+8|0;r=((da(p&255,f)|0)+7|0)/8|0;a[h>>0]=0;p=b+12|0;b=c[p>>2]|0;q=c[t>>2]|0;o=b-q|0;if(r>>>0<=o>>>0){if(r>>>0<o>>>0?(k=q+r|0,(b|0)!=(k|0)):0)c[p>>2]=k}else sdc(t,r-o|0,h);if(!j){i=g;return}j=a[s>>0]|0;h=0;o=0;r=0;while(1){if(!(j<<24>>24)){u=0;v=h;w=r}else{k=e+(o<<2)|0;p=h;b=0;q=r;while(1){l=(c[t>>2]|0)+q|0;a[l>>0]=d[l>>0]|0|(c[k>>2]|0)>>>b<<p;l=a[s>>0]|0;n=l&255;m=n-b|0;x=8-p|0;y=(x|0)<(m|0)?x:m;m=y+p|0;b=y+b|0;y=(m|0)==8;x=(y&1)+q|0;z=y?0:m;if((b|0)>=(n|0)){u=l;v=z;w=x;break}else{p=z;q=x}}}o=o+1|0;if((o|0)==(f|0))break;else{j=u;h=v;r=w}}i=g;return}function vdc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if((j-m|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{a[o>>0]=0;p=c[k>>2]|0}o=p+1|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=m-n+d|0;if((o|0)<0)vxi(b);m=n;n=j-m|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m|0;if(!n){q=0;r=0;s=j}else{t=n;u=j;v=10}}else{t=2147483647;u=(c[k>>2]|0)-m|0;v=10}if((v|0)==10){c[g>>2]=8;c[f+0>>2]=c[g+0>>2];q=t;r=cOb(t,16,f,0,3653512,80)|0;s=u}u=d;d=r+s|0;while(1){if(!d)w=0;else{a[d>>0]=0;w=d}t=w+1|0;u=u+-1|0;if(!u){x=t;break}else d=t}d=c[b>>2]|0;u=(c[k>>2]|0)-d|0;w=r+(s-u)|0;YEi(w|0,d|0,u|0)|0;u=c[b>>2]|0;c[b>>2]=w;c[k>>2]=x;c[h>>2]=r+q;if(!u){i=e;return}c[g>>2]=8;c[f+0>>2]=c[g+0>>2];eOb(u,f);i=e;return}function wdc(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;c[a>>2]=573664;j=a+4|0;c[j>>2]=d;k=a+8|0;c[k>>2]=e;e=a+12|0;l=e+0|0;m=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));b[e+40>>1]=0;l=c[153134]|0;c[a+56>>2]=0;c[a+60>>2]=l;c[a+64>>2]=0;c[a+68>>2]=0;l=mo[c[(c[d>>2]|0)+260>>2]&4095](d)|0;c[a+16>>2]=l;a=c[k>>2]|0;if((a|0)==4){if((c[l+20>>2]|0)!=(g|0)){n=g;o=6}}else if((a|0)==1){if((c[l+20>>2]|0)!=(g|0)){n=g;o=6}}else if((c[l+20>>2]|0)>>>0<g>>>0){m=g+-1|0;g=m>>>16|m;m=g>>>8|g;g=m>>>4|m;m=g>>>2|g;n=(m>>>1|m)+1|0;o=6}if((o|0)==6?(n|0)!=0:0){o=c[j>>2]|0;Wn[c[(c[o>>2]|0)+264>>2]&127](o,l,a,1,n,0,0)}n=mo[c[(c[d>>2]|0)+280>>2]&4095](d)|0;c[e>>2]=n;e=c[k>>2]|0;do if((e|0)==1)if((c[n+20>>2]|0)==(f|0)){i=h;return}else p=f;else if((e|0)==4)if((c[n+20>>2]|0)==(f|0)){i=h;return}else p=f;else if((c[n+20>>2]|0)>>>0<f>>>0){k=f+-1|0;d=k>>>16|k;k=d>>>8|d;d=k>>>4|k;k=d>>>2|d;p=(k>>>1|k)+1|0;break}else{i=h;return}while(0);if(!p){i=h;return}f=c[j>>2]|0;Wn[c[(c[f>>2]|0)+284>>2]&127](f,n,e,1,p,0,0);i=h;return}function xdc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=573664;f=a+4|0;g=c[f>>2]|0;In[c[(c[g>>2]|0)+276>>2]&4095](g,c[a+16>>2]|0);g=c[f>>2]|0;In[c[(c[g>>2]|0)+296>>2]&4095](g,c[a+12>>2]|0);if((c[a+68>>2]|0)<=-1){i=b;return}g=a+56|0;f=c[g>>2]|0;c[e>>2]=c[a+60>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[g>>2]=0;i=b;return}function ydc(a){a=a|0;var b=0;b=i;xdc(a);ACi(a);i=b;return}function zdc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;i=i+16|0;l=k+4|0;m=k;if(!e){n=0;i=k;return n|0}c[b+36>>2]=d;c[b+48>>2]=g;o=(f|0)!=0;a[b+52>>0]=o&1;p=da(e,d)|0;e=f<<1;if(o&(g|0)==2&(a[621141]|0)==0){g=b+56|0;o=b+64|0;c[o>>2]=f;q=b+68|0;r=c[q>>2]|0;do if((r&2147483647)>>>0<f>>>0)if((r|0)>-1){c[q>>2]=f;s=c[g>>2]|0;c[m>>2]=c[b+60>>2];c[l+0>>2]=c[m+0>>2];t=hOb(s,e,2,l,0,3653512,370)|0;c[g>>2]=t;u=t;break}else{c[m>>2]=c[b+60>>2];c[l+0>>2]=c[m+0>>2];t=cOb(e,2,l,0,3653512,352)|0;YEi(t|0,c[g>>2]|0,c[o>>2]<<1|0)|0;c[q>>2]=f;c[g>>2]=t;u=t;break}else u=c[g>>2]|0;while(0);c[j>>2]=u;v=0}else v=e;if(!(Adc(b,p,d,v)|0)){n=0;i=k;return n|0}d=b+4|0;e=c[d>>2]|0;u=b+12|0;g=kn[c[(c[e>>2]|0)+288>>2]&511](e,c[u>>2]|0,c[b+20>>2]|0,p)|0;c[h>>2]=g;if(!g){n=0;i=k;return n|0}if((v|0)!=0?(g=c[d>>2]|0,h=kn[c[(c[g>>2]|0)+268>>2]&511](g,c[b+16>>2]|0,c[b+28>>2]|0,v)|0,c[j>>2]=h,(h|0)==0):0){h=c[d>>2]|0;co[c[(c[h>>2]|0)+292>>2]&2047](h,c[u>>2]|0,0);n=0;i=k;return n|0}a[b+53>>0]=1;n=1;i=k;return n|0}function Adc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+12|0;h=c[g>>2]|0;j=a+8|0;k=c[j>>2]|0;if((k|0)==1){l=c[h+20>>2]|0;if((l|0)==(b|0)){m=a+16|0;n=c[m>>2]|0;o=m;p=13}else{q=b;r=l;p=8}}else if((k|0)==4){l=c[h+20>>2]|0;if((l|0)==(b|0)){m=a+16|0;s=c[m>>2]|0;t=m;p=12}else{q=b;r=l;p=8}}else{l=c[h+20>>2]|0;if(l>>>0<b>>>0){m=b+-1|0;u=m>>>16|m;m=u>>>8|u;u=m>>>4|m;m=u>>>2|u;q=(m>>>1|m)+1|0;r=l;p=8}else{v=l;p=10}}if((p|0)==8)if(!q){v=r;p=10}else{r=c[a+4>>2]|0;Wn[c[(c[r>>2]|0)+284>>2]&127](r,h,k,1,q,0,0);v=c[(c[g>>2]|0)+20>>2]|0;p=10}do if((p|0)==10){if(v>>>0<b>>>0){w=0;i=f;return w|0}q=c[j>>2]|0;k=a+16|0;h=c[k>>2]|0;if((q|0)==4){s=h;t=k;p=12;break}else if((q|0)==1){n=h;o=k;p=13;break}r=c[h+20>>2]|0;if(r>>>0<e>>>0){l=e+-1|0;m=l>>>16|l;l=m>>>8|m;m=l>>>4|l;l=m>>>2|m;x=(l>>>1|l)+1|0;y=h;z=q;A=k;B=r;p=16}else{C=r;D=h;p=18}}while(0);if((p|0)==12){v=c[s+20>>2]|0;if((v|0)!=(e|0)){x=e;y=s;z=4;A=t;B=v;p=16}}else if((p|0)==13?(v=c[n+20>>2]|0,(v|0)!=(e|0)):0){x=e;y=n;z=1;A=o;B=v;p=16}if((p|0)==16)if(!x){C=B;D=y;p=18}else{B=c[a+4>>2]|0;Wn[c[(c[B>>2]|0)+264>>2]&127](B,y,z,1,x,0,0);x=c[A>>2]|0;C=c[x+20>>2]|0;D=x;p=18}if((p|0)==18){if(C>>>0<e>>>0){w=0;i=f;return w|0}if((c[j>>2]|0)==2){j=a+20|0;C=c[j>>2]|0;if(!d)E=C;else{p=d+-1+C|0;C=p-((p>>>0)%(d>>>0)|0)|0;c[j>>2]=C;E=C}if((E+b|0)>>>0>=(c[(c[g>>2]|0)+20>>2]|0)>>>0)c[a+20>>2]=0;g=a+28|0;if(((c[g>>2]|0)+e|0)>>>0<(c[D+20>>2]|0)>>>0){w=1;i=f;return w|0}c[g>>2]=0;w=1;i=f;return w|0}}c[a+20>>2]=0;c[a+28>>2]=0;w=1;i=f;return w|0}function Bdc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+4|0;h=f;a[b+53>>0]=0;c[b+40>>2]=d;c[b+44>>2]=e;j=da(c[b+36>>2]|0,d)|0;d=e<<1;e=b+4|0;k=c[e>>2]|0;co[c[(c[k>>2]|0)+292>>2]&2047](k,c[b+12>>2]|0,j);k=b+20|0;l=c[k>>2]|0;c[b+24>>2]=l;c[k>>2]=l+j;if((a[621141]|0)==0?(c[b+48>>2]|0)==2:0){Cdc(b);j=b+68|0;if((c[j>>2]|0)>-1){l=b+56|0;k=c[l>>2]|0;c[h>>2]=c[b+60>>2];c[g+0>>2]=c[h+0>>2];eOb(k,g);c[l>>2]=0}c[b+64>>2]=0;c[j>>2]=0;i=f;return}else{if(!(a[b+52>>0]|0)){i=f;return}j=c[e>>2]|0;co[c[(c[j>>2]|0)+272>>2]&2047](j,c[b+16>>2]|0,d);j=b+28|0;e=c[j>>2]|0;c[b+32>>2]=e;c[j>>2]=e+d;i=f;return}}function Cdc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=d+52|0;g=d+44|0;h=d+40|0;j=c[((a[f>>0]|0)==0?h:g)>>2]|0;if(!j){i=e;return}k=j>>>2;l=k*6|0;m=k*12|0;if(Adc(d,0,0,m)|0?(k=d+4|0,n=c[k>>2]|0,o=d+16|0,p=d+28|0,q=kn[c[(c[n>>2]|0)+268>>2]&511](n,c[o>>2]|0,c[p>>2]|0,m)|0,(q|0)!=0):0){if((a[f>>0]|0)!=0?(n=c[d+56>>2]|0,(n|0)!=0):0){r=n;n=q;s=0;while(1){b[n>>1]=b[r>>1]|0;b[n+2>>1]=b[r+2>>1]|0;t=r+4|0;b[n+4>>1]=b[t>>1]|0;b[n+6>>1]=b[r>>1]|0;b[n+8>>1]=b[t>>1]|0;b[n+10>>1]=b[r+6>>1]|0;s=s+4|0;if(s>>>0>=j>>>0)break;else{r=r+8|0;n=n+12|0}}}else{u=q;v=0;w=8}if((w|0)==8)while(1){w=0;q=v&65535;b[u>>1]=q;b[u+2>>1]=v|1;n=(v|2)&65535;b[u+4>>1]=n;b[u+6>>1]=q;b[u+8>>1]=n;b[u+10>>1]=v|3;v=v+4|0;if(v>>>0>=j>>>0)break;else{u=u+12|0;w=8}}c[d+48>>2]=0;a[f>>0]=1;c[g>>2]=l;l=c[k>>2]|0;co[c[(c[l>>2]|0)+272>>2]&2047](l,c[o>>2]|0,m);o=c[p>>2]|0;c[d+32>>2]=o;c[p>>2]=o+m;i=e;return}c[g>>2]=0;c[h>>2]=0;i=e;return}function Ddc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f;j=(a[b+52>>0]|0)==0;if(!j?(c[b+44>>2]|0)==0:0){i=f;return}k=c[b+40>>2]|0;if(!k){i=f;return}c[g>>2]=c[b+12>>2];l=c[b+36>>2]|0;c[g+4>>2]=l;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h>>2]=c[b+48>>2];c[h+20>>2]=k;if(j){c[h+16>>2]=((c[b+24>>2]|0)>>>0)/(l>>>0)|0;m=c[b+4>>2]|0;n=0}else{c[h+8>>2]=c[b+44>>2];c[h+4>>2]=c[b+32>>2];c[h+12>>2]=((c[b+24>>2]|0)>>>0)/(l>>>0)|0;m=c[b+4>>2]|0;n=c[b+16>>2]|0}Nn[c[(c[m>>2]|0)+304>>2]&31](m,n,g,1,h,1,e,d);i=f;return}function Edc(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+4|0;j=c[a>>2]|0;if((c[h>>2]|0)==(j|0)){i=e;return}k=d+8|0;l=d+12|0;m=d+4|0;n=j;j=0;do{o=(c[n+(j*56|0)+4>>2]|0)>>>1;p=c[n+(j*56|0)>>2]|0;if((p|0)==2){q=c[n+(j*56|0)+8>>2]|0;if(q>>>0>=4){r=q>>>2;q=c[k>>2]|0;s=r*6|0;t=q+s|0;c[k>>2]=t;u=c[l>>2]|0;do if((u&2147483647)>>>0<t>>>0)if((u|0)>-1){c[l>>2]=t;v=c[d>>2]|0;c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(v,t<<1,2,f,0,3653512,370)|0;break}else{c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];v=cOb(t<<1,2,f,0,3653512,352)|0;YEi(v|0,c[d>>2]|0,c[k>>2]<<1|0)|0;c[l>>2]=t;c[d>>2]=v;break}while(0);if(r){t=c[d>>2]|0;u=q;v=0;w=o;while(1){x=t+(w<<1)|0;b[t+(u<<1)>>1]=b[x>>1]|0;b[t+(u+1<<1)>>1]=b[t+(w+1<<1)>>1]|0;y=t+(w+2<<1)|0;b[t+(u+2<<1)>>1]=b[y>>1]|0;b[t+(u+3<<1)>>1]=b[x>>1]|0;b[t+(u+4<<1)>>1]=b[y>>1]|0;b[t+(u+5<<1)>>1]=b[t+(w+3<<1)>>1]|0;v=v+1|0;if(v>>>0>=r>>>0)break;else{u=u+6|0;w=w+4|0}}}c[n+(j*56|0)+24>>2]=q<<1;c[n+(j*56|0)+28>>2]=s}}else if((p|0)==1?(w=n+(j*56|0)+8|0,u=c[w>>2]|0,u>>>0>=3):0){r=c[k>>2]|0;v=(u*3|0)+-6+r|0;c[k>>2]=v;u=c[l>>2]|0;do if((u&2147483647)>>>0<v>>>0)if((u|0)>-1){c[l>>2]=v;t=c[d>>2]|0;c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(t,v<<1,2,f,0,3653512,370)|0;break}else{c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];t=cOb(v<<1,2,f,0,3653512,352)|0;YEi(t|0,c[d>>2]|0,c[k>>2]<<1|0)|0;c[l>>2]=v;c[d>>2]=t;break}while(0);v=c[w>>2]|0;if((v|0)==2)z=r;else{u=c[d>>2]|0;p=v+-2|0;v=r;s=0;q=o;while(1){t=b[u+(q<<1)>>1]|0;y=q;q=q+1|0;x=b[u+(q<<1)>>1]|0;A=b[u+(y+2<<1)>>1]|0;if((t<<16>>16==x<<16>>16?1:t<<16>>16==A<<16>>16)|x<<16>>16==A<<16>>16)B=v;else{y=(s&1|0)!=0;b[u+(v<<1)>>1]=y?x:t;b[u+(v+1<<1)>>1]=y?t:x;b[u+(v+2<<1)>>1]=A;B=v+3|0}s=s+1|0;if(s>>>0>=p>>>0){z=B;break}else v=B}}c[k>>2]=z;v=c[l>>2]|0;do if((v&2147483647)>>>0<z>>>0)if((v|0)>-1){c[l>>2]=z;p=c[d>>2]|0;c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(p,z<<1,2,f,0,3653512,370)|0;break}else{c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];p=cOb(z<<1,2,f,0,3653512,352)|0;YEi(p|0,c[d>>2]|0,c[k>>2]<<1|0)|0;c[l>>2]=z;c[d>>2]=p;break}while(0);c[n+(j*56|0)+24>>2]=r<<1;c[n+(j*56|0)+28>>2]=z-r}j=j+1|0;n=c[a>>2]|0}while(j>>>0<(((c[h>>2]|0)-n|0)/56|0)>>>0);i=e;return}function Fdc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+96|0;g=f+64|0;h=f+60|0;j=f+56|0;k=f;l=c[d>>2]|0;c[h>>2]=l;c[g+0>>2]=c[h+0>>2];mWb(b,g,e);c[b>>2]=573720;e=b+36|0;h=b+44|0;d=b+48|0;m=b+52|0;c[b+64>>2]=0;c[b+68>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[b+60>>2]=60;c[b+72>>2]=0;c[b+80>>2]=0;c[b+84>>2]=0;c[b+76>>2]=60;n=b+88|0;c[b+108>>2]=0;c[b+112>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[b+104>>2]=60;c[b+116>>2]=0;c[b+120>>2]=l;n=b+124|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[b+140>>2]=l;n=b+144|0;o=b+168|0;p=b+180|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[o+0>>2]=c[150284];c[o+4>>2]=c[150285];c[o+8>>2]=c[150286];c[p+0>>2]=c[150284];c[p+4>>2]=c[150285];c[p+8>>2]=c[150286];fcc(b+192|0);p=b+212|0;c[p>>2]=p;c[b+216>>2]=p;p=b+220|0;c[p>>2]=p;c[b+224>>2]=p;p=b+272|0;o=b+228|0;n=o+44|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(n|0));a[p>>0]=1;a[b+273>>0]=1;a[b+274>>0]=0;a[b+275>>0]=0;a[b+276>>0]=0;c[j>>2]=c[153074];c[g+0>>2]=c[j+0>>2];j=bOb(184,g,0,16,3653512,82)|0;c[j>>2]=575440;c[j+4>>2]=1;c[j>>2]=575424;Tic(j+8|0);p=j+108|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[j+124>>2]=l;c[j+128>>2]=0;c[j+132>>2]=0;c[j+136>>2]=0;c[j+140>>2]=l;c[j+144>>2]=0;c[j+148>>2]=0;c[j+152>>2]=0;c[j+156>>2]=l;c[j+160>>2]=0;c[j+164>>2]=0;c[j+168>>2]=0;c[j+172>>2]=l;c[j+176>>2]=0;c[j+180>>2]=0;c[b+28>>2]=j;c[b+164>>2]=-1;j=k+32|0;l=g+12|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;c[g+0>>2]=c[150284];c[g+4>>2]=c[150285];c[g+8>>2]=c[150286];c[l+0>>2]=c[150284];c[l+4>>2]=c[150285];c[l+8>>2]=c[150286];c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];c[j+16>>2]=c[g+16>>2];c[j+20>>2]=c[g+20>>2];g=c[d>>2]|0;if((g|0)==(c[m>>2]|0)){Hec(h,k);q=b+32|0;a[q>>0]=0;r=b+33|0;a[r>>0]=1;s=b+34|0;a[s>>0]=0;t=b+35|0;a[t>>0]=0;c[e>>2]=0;i=f;return}if(!g)u=0;else{o=g+0|0;g=k+0|0;n=o+56|0;do{c[o>>2]=c[g>>2];o=o+4|0;g=g+4|0}while((o|0)<(n|0));u=c[d>>2]|0}c[d>>2]=u+56;q=b+32|0;a[q>>0]=0;r=b+33|0;a[r>>0]=1;s=b+34|0;a[s>>0]=0;t=b+35|0;a[t>>0]=0;c[e>>2]=0;i=f;return}function Gdc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d+8>>2]=0;c[d+4>>2]=a;c[d>>2]=43;f=a+216|0;g=c[f>>2]|0;h=a+212|0;if((g|0)==(h|0))j=g;else{k=g;do{g=k;k=c[k+4>>2]|0;_Tb(c[g+8>>2]|0,554648,d)}while((k|0)!=(h|0));j=c[f>>2]|0}h=a+212|0;if((j|0)!=(h|0)){k=j;do{j=k+4|0;g=k;k=c[j>>2]|0;c[g>>2]=0;c[j>>2]=0}while((k|0)!=(h|0))}c[f>>2]=h;c[h>>2]=h;h=a+220|0;J3b(h,0);f=a+224|0;k=c[f>>2]|0;if((k|0)!=(h|0)){j=k;do{k=j+4|0;g=j;j=c[k>>2]|0;c[g>>2]=0;c[k>>2]=0}while((j|0)!=(h|0))}c[f>>2]=h;c[h>>2]=h;hcc(a+192|0);Hdc(a);h=a+28|0;f=c[h>>2]|0;j=c[153074]|0;k=f+4|0;c[k>>2]=(c[k>>2]|0)+-1;if(!(c[k>>2]|0)){ko[c[c[f>>2]>>2]&4095](f);c[e>>2]=j;c[d+0>>2]=c[e+0>>2];eOb(f,d)}c[h>>2]=0;h=a+36|0;a=c[h>>2]|0;if(!a){i=b;return}vsd(573688,a);c[h>>2]=0;i=b;return}function Hdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;uec(b+232|0);c[b+268>>2]=0;e=b+152|0;if(c[e>>2]|0){f=ync()|0;In[c[(c[f>>2]|0)+296>>2]&4095](f,c[e>>2]|0);c[e>>2]=0}e=b+156|0;if(c[e>>2]|0){f=ync()|0;In[c[(c[f>>2]|0)+296>>2]&4095](f,c[e>>2]|0);c[e>>2]=0}e=b+160|0;if(!(c[e>>2]|0)){g=b+273|0;a[g>>0]=1;h=b+272|0;a[h>>0]=1;i=d;return}f=ync()|0;In[c[(c[f>>2]|0)+296>>2]&4095](f,c[e>>2]|0);c[e>>2]=0;g=b+273|0;a[g>>0]=1;h=b+272|0;a[h>>0]=1;i=d;return}function Idc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+28>>2]|0;if((a[g+18>>0]|0)!=2){a[b+276>>0]=0;i=f;return}h=a[621175]|0;j=h<<24>>24==0;k=b+276|0;if(h<<24>>24==(a[k>>0]|0)){i=f;return}do if(e){b=(d[g+19>>0]|0)<4;if(j){if(b)break;l=c[g+92>>2]|0;if(!l){m=1;n=0}else{o=d[g+16>>0]|0;m=d[g+(o*12|0)+50>>0]|0;n=l+((d[g+17>>0]|0)+(c[g+(o*12|0)+44>>2]|0))|0}o=c[g+92>>2]|0;if(!o)p=0;else{l=d[g+16>>0]|0;p=o+((da(d[g+(l*12|0)+50>>0]|0,c[g+100>>2]|0)|0)+(c[g+(l*12|0)+44>>2]|0)+(d[g+17>>0]|0))|0}l=c[g+92>>2]|0;if(!l){q=1;r=0}else{o=d[g+16>>0]|0;q=d[g+(o*12|0)+50>>0]|0;r=l+((d[g+17>>0]|0)+(c[g+(o*12|0)+44>>2]|0))|0}if((n|0)==(p|0))break;else{s=n;t=r}while(1){c[t>>2]=d[s+1>>0]<<8|d[s+2>>0]|d[s>>0]<<16|d[s+3>>0]<<24;s=s+m|0;if((s|0)==(p|0))break;else t=t+q|0}}else{if(b)break;o=c[g+92>>2]|0;if(!o){u=1;v=0}else{l=d[g+16>>0]|0;u=d[g+(l*12|0)+50>>0]|0;v=o+((d[g+17>>0]|0)+(c[g+(l*12|0)+44>>2]|0))|0}l=c[g+92>>2]|0;if(!l)w=0;else{o=d[g+16>>0]|0;w=l+((da(d[g+(o*12|0)+50>>0]|0,c[g+100>>2]|0)|0)+(c[g+(o*12|0)+44>>2]|0)+(d[g+17>>0]|0))|0}o=c[g+92>>2]|0;if(!o){x=0;y=1}else{l=d[g+16>>0]|0;x=o+((d[g+17>>0]|0)+(c[g+(l*12|0)+44>>2]|0))|0;y=d[g+(l*12|0)+50>>0]|0}if((v|0)==(w|0))break;else{z=v;A=x}while(1){c[A>>2]=d[z+1>>0]<<8|d[z+2>>0]|d[z>>0]<<16|d[z+3>>0]<<24;z=z+u|0;if((z|0)==(w|0))break;else A=A+y|0}}}while(0);a[k>>0]=h;i=f;return}function Jdc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b+276|0;if(!(a[g>>0]|0)){i=f;return}if(e?(e=c[b+28>>2]|0,b=a[e+19>>0]|0,!((a[e+18>>0]|0)!=2|(b&255)<4)):0){h=c[e+92>>2]|0;if((h|0)==0|b<<24>>24==0){j=1;k=0}else{l=d[e+16>>0]|0;j=d[e+(l*12|0)+50>>0]|0;k=h+((d[e+17>>0]|0)+(c[e+(l*12|0)+44>>2]|0))|0}l=c[e+92>>2]|0;if((l|0)==0|b<<24>>24==0)m=0;else{h=d[e+16>>0]|0;m=l+((da(d[e+(h*12|0)+50>>0]|0,c[e+100>>2]|0)|0)+(c[e+(h*12|0)+44>>2]|0)+(d[e+17>>0]|0))|0}h=c[e+92>>2]|0;if((h|0)==0|b<<24>>24==0){n=1;o=0}else{b=d[e+16>>0]|0;n=d[e+(b*12|0)+50>>0]|0;o=h+((d[e+17>>0]|0)+(c[e+(b*12|0)+44>>2]|0))|0}if((k|0)!=(m|0)){b=k;k=o;while(1){c[k>>2]=d[b+1>>0]<<8|d[b+2>>0]|d[b>>0]<<16|d[b+3>>0]<<24;b=b+j|0;if((b|0)==(m|0))break;else k=k+n|0}}}a[g>>0]=0;i=f;return}function Kdc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+112|0;f=e;g=e+100|0;Tic(f);h=b+28|0;b=c[(c[h>>2]|0)+100>>2]|0;a[g>>0]=0;a[g+1>>0]=3;Ric(f,d,b,0,g);g=c[h>>2]|0;Zic(c[g+100>>2]|0,c[f+88>>2]|0,g+8|0,f);i=e;return}function Ldc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+112|0;g=f;h=f+100|0;j=b+28|0;k=c[j>>2]|0;if((a[k+18>>0]|0)!=2){Tic(g);l=c[(c[j>>2]|0)+100>>2]|0;a[h>>0]=2;a[h+1>>0]=4;Ric(g,e,l,2,h);h=c[j>>2]|0;Zic(c[h+100>>2]|0,c[g+88>>2]|0,h+8|0,g);i=f;return}g=(d[k+19>>0]|0)<4;if(!(a[b+276>>0]|0)){if(g){i=f;return}b=c[k+92>>2]|0;if(!b){m=1;n=0}else{h=d[k+16>>0]|0;m=d[k+(h*12|0)+50>>0]|0;n=b+((d[k+17>>0]|0)+(c[k+(h*12|0)+44>>2]|0))|0}h=c[k+92>>2]|0;if(!h)o=0;else{b=d[k+16>>0]|0;o=h+((da(d[k+(b*12|0)+50>>0]|0,c[k+100>>2]|0)|0)+(c[k+(b*12|0)+44>>2]|0)+(d[k+17>>0]|0))|0}if((n|0)==(o|0)){i=f;return}else{p=e;q=n}while(1){c[p>>2]=c[q>>2];q=q+m|0;if((q|0)==(o|0))break;else p=p+4|0}i=f;return}else{if(g){i=f;return}g=c[k+92>>2]|0;if(!g){r=1;s=0}else{p=d[k+16>>0]|0;r=d[k+(p*12|0)+50>>0]|0;s=g+((d[k+17>>0]|0)+(c[k+(p*12|0)+44>>2]|0))|0}p=c[k+92>>2]|0;if(!p)t=0;else{g=d[k+16>>0]|0;t=p+((da(d[k+(g*12|0)+50>>0]|0,c[k+100>>2]|0)|0)+(c[k+(g*12|0)+44>>2]|0)+(d[k+17>>0]|0))|0}if((s|0)==(t|0)){i=f;return}else{u=e;v=s}while(1){c[u>>2]=d[v+1>>0]<<8|d[v+2>>0]|d[v>>0]<<16|d[v+3>>0]<<24;v=v+r|0;if((v|0)==(t|0))break;else u=u+4|0}i=f;return}}function Mdc(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0;f=i;i=i+112|0;h=f;j=f+100|0;k=b+28|0;l=c[k>>2]|0;if((a[l+18>>0]|0)!=2){Tic(h);m=c[(c[k>>2]|0)+100>>2]|0;a[j>>0]=0;a[j+1>>0]=4;Ric(h,e,m,2,j);j=c[k>>2]|0;Zic(c[j+100>>2]|0,c[h+88>>2]|0,j+8|0,h);i=f;return}h=(d[l+19>>0]|0)<4;if(!(a[b+276>>0]|0)){if(h){i=f;return}b=c[l+92>>2]|0;if(!b){n=1;o=0}else{j=d[l+16>>0]|0;n=d[l+(j*12|0)+50>>0]|0;o=b+((d[l+17>>0]|0)+(c[l+(j*12|0)+44>>2]|0))|0}j=c[l+92>>2]|0;if(!j)p=0;else{b=d[l+16>>0]|0;p=j+((da(d[l+(b*12|0)+50>>0]|0,c[l+100>>2]|0)|0)+(c[l+(b*12|0)+44>>2]|0)+(d[l+17>>0]|0))|0}if((o|0)==(p|0)){i=f;return}else{q=e;r=o}while(1){s=ea(ea(d[r>>0]|0)/ea(255.0));t=ea(ea(d[r+1>>0]|0)/ea(255.0));u=ea(ea(d[r+2>>0]|0)/ea(255.0));v=ea(ea(d[r+3>>0]|0)/ea(255.0));g[q>>2]=s;g[q+4>>2]=t;g[q+8>>2]=u;g[q+12>>2]=v;r=r+n|0;if((r|0)==(p|0))break;else q=q+16|0}i=f;return}else{if(h){i=f;return}h=c[l+92>>2]|0;if(!h){w=1;x=0}else{q=d[l+16>>0]|0;w=d[l+(q*12|0)+50>>0]|0;x=h+((d[l+17>>0]|0)+(c[l+(q*12|0)+44>>2]|0))|0}q=c[l+92>>2]|0;if(!q)y=0;else{h=d[l+16>>0]|0;y=q+((da(d[l+(h*12|0)+50>>0]|0,c[l+100>>2]|0)|0)+(c[l+(h*12|0)+44>>2]|0)+(d[l+17>>0]|0))|0}if((x|0)==(y|0)){i=f;return}else{z=e;A=x}while(1){v=ea(ea(d[A+1>>0]|0)/ea(255.0));u=ea(ea(d[A>>0]|0)/ea(255.0));t=ea(ea(d[A+3>>0]|0)/ea(255.0));g[z>>2]=ea(ea(d[A+2>>0]|0)/ea(255.0));g[z+4>>2]=v;g[z+8>>2]=u;g[z+12>>2]=t;A=A+w|0;if((A|0)==(y|0))break;else z=z+16|0}i=f;return}}function Ndc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+112|0;h=g;j=g+100|0;Tic(h);k=b+28|0;b=c[(c[k>>2]|0)+100>>2]|0;a[j>>0]=0;a[j+1>>0]=f;Ric(h,e,b,d+3|0,j);j=c[k>>2]|0;Zic(c[j+100>>2]|0,c[h+88>>2]|0,j+8|0,h);i=g;return}function Odc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+28>>2]|0;if((c[h+144>>2]|0)==0?(c[a+92>>2]|0)==(c[a+88>>2]|0):0){Sic(f,h+8|0);c[f>>2]=(c[f+4>>2]&255^255)&~c[f+8>>2]&~c[f+12>>2];c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];Qdc(a,b,d,0,575992,g);i=e;return};c[g+0>>2]=c[143994];c[g+4>>2]=c[143995];c[g+8>>2]=c[143996];c[g+12>>2]=c[143997];Qdc(a,b,d,0,575992,g);i=e;return}function Pdc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+16|0;j=g;k=c[a+28>>2]|0;if((c[k+144>>2]|0)==0?(c[a+92>>2]|0)==(c[a+88>>2]|0):0){Sic(h,k+8|0);c[h>>2]=(c[h+4>>2]&255^255)&~c[h+8>>2]&~c[h+12>>2];c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];Qdc(a,b,d,e,f,j);i=g;return};c[j+0>>2]=c[143994];c[j+4>>2]=c[143995];c[j+8>>2]=c[143996];c[j+12>>2]=c[143997];Qdc(a,b,d,e,f,j);i=g;return}function Qdc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+36|0;l=j+32|0;m=j;n=b+28|0;o=c[n>>2]|0;p=o+8|0;q=c[o+96>>2]|0;r=~q&e|f;f=q&~e;if(!(((r|0)!=0?1:(c[o+100>>2]|0)!=(d|0))|(f|0)!=0)){i=j;return}if((q&4&r|0)!=0?(a[g+4>>0]|0)!=2:0)Jdc(b,1);Vic(p,d,r,f,h,g);g=c[n>>2]|0;n=g+136|0;h=g+144|0;if(c[h>>2]|0){c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m+24>>2]=0;c[m+28>>2]=0;f=g+148|0;r=c[f>>2]|0;do if((r&2147483647)>>>0<d>>>0)if((r|0)>-1){c[f>>2]=d;p=c[n>>2]|0;c[l>>2]=c[g+140>>2];c[k+0>>2]=c[l+0>>2];c[n>>2]=hOb(p,d<<5,16,k,0,3653512,370)|0;break}else{c[l>>2]=c[g+140>>2];c[k+0>>2]=c[l+0>>2];p=cOb(d<<5,16,k,0,3653512,352)|0;YEi(p|0,c[n>>2]|0,c[h>>2]<<5|0)|0;c[f>>2]=d;c[n>>2]=p;break}while(0);f=c[h>>2]|0;if(f>>>0<d>>>0?(k=c[n>>2]|0,n=k+(d<<5)|0,(f|0)!=(d|0)):0){l=k+(f<<5)|0;do{if(l){c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];c[l+24>>2]=c[m+24>>2];c[l+28>>2]=c[m+28>>2]}l=l+32|0}while((l|0)!=(n|0))}c[h>>2]=d}a[b+272>>0]=1;i=j;return}function Rdc(b){b=b|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0;e=i;f=ea(g[150280]);h=ea(g[150281]);j=ea(g[150282]);k=ea(-f);l=ea(-h);m=ea(-j);n=c[b+28>>2]|0;o=a[n+11>>0]|0;p=(a[n+10>>0]|0)!=0|(o&255)<3;if(!p){q=c[n+92>>2]|0;if((q|0)==0|o<<24>>24==0){r=1;s=0}else{t=d[n+8>>0]|0;r=d[n+(t*12|0)+50>>0]|0;s=q+((d[n+9>>0]|0)+(c[n+(t*12|0)+44>>2]|0))|0}t=c[n+92>>2]|0;if((t|0)==0|o<<24>>24==0)u=0;else{q=d[n+8>>0]|0;u=t+((da(d[n+(q*12|0)+50>>0]|0,c[n+100>>2]|0)|0)+(c[n+(q*12|0)+44>>2]|0)+(d[n+9>>0]|0))|0}if((s|0)!=(u|0)){q=s;v=f;w=h;x=j;y=k;z=l;A=m;while(1){B=ea(g[q>>2]);C=B<v?B:v;D=ea(g[q+4>>2]);E=D<w?D:w;F=ea(g[q+8>>2]);G=F<x?F:x;H=y<B?B:y;B=z<D?D:z;D=A<F?F:A;q=q+r|0;if((q|0)==(u|0)){I=D;J=B;K=H;L=G;M=E;N=C;break}else{v=C;w=E;x=G;y=H;z=B;A=D}}}else{I=m;J=l;K=k;L=j;M=h;N=f}}else{I=m;J=l;K=k;L=j;M=h;N=f}u=c[b+64>>2]|0;if(!u){O=K;P=N;Q=J;R=M;S=I;T=L}else{if(!p){p=c[n+92>>2]|0;if((p|0)==0|o<<24>>24==0){U=1;V=0}else{o=d[n+8>>0]|0;U=d[n+(o*12|0)+50>>0]|0;V=p+((d[n+9>>0]|0)+(c[n+(o*12|0)+44>>2]|0))|0}}else{U=0;V=0}o=c[b+56>>2]|0;f=N;N=M;M=L;L=K;K=J;J=I;p=0;while(1){q=da(c[o+(p*40|0)+36>>2]|0,U)|0;I=ea(g[V+q>>2]);h=ea(I+ea(g[o+(p*40|0)>>2]));I=ea(g[V+(q+4)>>2]);j=ea(I+ea(g[o+(p*40|0)+4>>2]));I=ea(g[V+(q+8)>>2]);k=ea(I+ea(g[o+(p*40|0)+8>>2]));I=h<f?h:f;l=j<N?j:N;m=k<M?k:M;A=L<h?h:L;h=K<j?j:K;j=J<k?k:J;p=p+1|0;if(p>>>0>=u>>>0){O=A;P=I;Q=h;R=l;S=j;T=m;break}else{f=I;N=l;M=m;L=A;K=h;J=j}}}if(!(c[n+100>>2]|0)){J=ea(g[150284]);K=ea(g[150285]);L=ea(g[150286]);W=J;X=K;Y=L;Z=J;_=K;$=L}else{W=ea(ea(O+P)*ea(.5));X=ea(ea(Q+R)*ea(.5));Y=ea(ea(S+T)*ea(.5));Z=ea(ea(O-P)*ea(.5));_=ea(ea(Q-R)*ea(.5));$=ea(ea(S-T)*ea(.5))}g[b+168>>2]=W;g[b+172>>2]=X;g[b+176>>2]=Y;g[b+180>>2]=Z;g[b+184>>2]=_;g[b+188>>2]=$;n=b+48|0;u=b+44|0;if((c[n>>2]|0)==(c[u>>2]|0)){i=e;return}else aa=0;do{Sdc(b,aa);aa=aa+1|0}while(aa>>>0<(((c[n>>2]|0)-(c[u>>2]|0)|0)/56|0)>>>0);i=e;return}function Sdc(b,f){b=b|0;f=f|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=0;h=i;j=ea(g[150280]);k=ea(g[150281]);l=ea(g[150282]);m=ea(-j);n=ea(-k);o=ea(-l);p=c[b+44>>2]|0;q=c[b+28>>2]|0;b=c[p+(f*56|0)+4>>2]|0;r=c[q+112>>2]|0;s=c[q+108>>2]|0;if((r|0)!=(s|0)&(r-s|0)>>>0>b>>>0)t=s+b|0;else t=0;b=a[q+11>>0]|0;if(!((a[q+10>>0]|0)!=0|(b&255)<3)){s=c[q+92>>2]|0;if((s|0)==0|b<<24>>24==0){u=1;v=0}else{b=d[q+8>>0]|0;u=d[q+(b*12|0)+50>>0]|0;v=s+((d[q+9>>0]|0)+(c[q+(b*12|0)+44>>2]|0))|0}}else{u=0;v=0}b=c[p+(f*56|0)+8>>2]|0;if(b){w=j;j=k;k=l;l=m;m=n;n=o;q=0;while(1){s=da(e[t+(q<<1)>>1]|0,u)|0;o=ea(g[v+s>>2]);x=o<w?o:w;y=ea(g[v+(s+4)>>2]);z=y<j?y:j;A=ea(g[v+(s+8)>>2]);B=A<k?A:k;C=l<o?o:l;o=m<y?y:m;y=n<A?A:n;q=q+1|0;if(q>>>0>=b>>>0){D=x;E=z;F=B;G=C;H=o;I=y;break}else{w=x;j=z;k=B;l=C;m=o;n=y}}if(b){J=ea(ea(G-D)*ea(.5));K=ea(ea(H-E)*ea(.5));L=ea(ea(I-F)*ea(.5));M=ea(ea(G+D)*ea(.5));N=ea(ea(H+E)*ea(.5));O=ea(ea(I+F)*ea(.5));P=p+(f*56|0)+32|0;g[P>>2]=M;Q=p+(f*56|0)+36|0;g[Q>>2]=N;R=p+(f*56|0)+40|0;g[R>>2]=O;S=p+(f*56|0)+44|0;g[S>>2]=J;T=p+(f*56|0)+48|0;g[T>>2]=K;U=p+(f*56|0)+52|0;g[U>>2]=L;i=h;return}}F=ea(g[150284]);I=ea(g[150285]);E=ea(g[150286]);J=F;K=I;L=E;M=F;N=I;O=E;P=p+(f*56|0)+32|0;g[P>>2]=M;Q=p+(f*56|0)+36|0;g[Q>>2]=N;R=p+(f*56|0)+40|0;g[R>>2]=O;S=p+(f*56|0)+44|0;g[S>>2]=J;T=p+(f*56|0)+48|0;g[T>>2]=K;U=p+(f*56|0)+52|0;g[U>>2]=L;i=h;return}function Tdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+28>>2]|0;f=c[(c[a+44>>2]|0)+(b*56|0)+4>>2]|0;b=c[e+112>>2]|0;a=c[e+108>>2]|0;if(!((b|0)!=(a|0)&(b-a|0)>>>0>f>>>0)){g=0;i=d;return g|0}g=a+f|0;i=d;return g|0}function Udc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;Rdc(a);c[d+8>>2]=0;c[d+4>>2]=a;c[d>>2]=43;e=c[a+216>>2]|0;f=a+212|0;if((e|0)==(f|0)){g=a+220|0;J3b(g,1);i=b;return}else h=e;do{e=h;h=c[h+4>>2]|0;_Tb(c[e+8>>2]|0,554696,d)}while((h|0)!=(f|0));g=a+220|0;J3b(g,1);i=b;return}function Vdc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+176|0;f=e+72|0;g=e+56|0;h=e;j=b+44|0;k=c[j>>2]|0;l=b+48|0;m=c[l>>2]|0;if((m|0)==(k|0))n=k;else{o=m+(~(((m+-56-k|0)>>>0)/56|0)*56|0)|0;c[l>>2]=o;n=o}o=h+32|0;k=f+12|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286];c[k+0>>2]=c[150284];c[k+4>>2]=c[150285];c[k+8>>2]=c[150286];c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];c[o+16>>2]=c[f+16>>2];c[o+20>>2]=c[f+20>>2];if((n|0)==(c[b+52>>2]|0))Hec(j,h);else{if(!n)p=0;else{j=n+0|0;n=h+0|0;h=j+56|0;do{c[j>>2]=c[n>>2];j=j+4|0;n=n+4|0}while((j|0)<(h|0));p=c[l>>2]|0}c[l>>2]=p+56}mhc(b+56|0);p=b+28|0;l=c[p>>2]|0;n=c[l+108>>2]|0;j=l+112|0;if((c[j>>2]|0)!=(n|0))c[j>>2]=n;n=c[l+96>>2]|0;do if(c[l+100>>2]|0){if(!d){Tic(f);Yic(f,(c[p>>2]|0)+8|0);a[b+272>>0]=1;Uic(f);break}if((c[l+144>>2]|0)==0?(c[b+92>>2]|0)==(c[b+88>>2]|0):0){Sic(f,l+8|0);c[f>>2]=(c[f+4>>2]&255^255)&~c[f+8>>2]&~c[f+12>>2];c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2]}else{c[g+0>>2]=c[143994];c[g+4>>2]=c[143995];c[g+8>>2]=c[143996];c[g+12>>2]=c[143997]}Qdc(b,0,n,0,575992,g)}while(0);l=c[p>>2]|0;p=l+144|0;if(!(c[p>>2]|0)){q=b+276|0;a[q>>0]=0;Wdc(b);Xdc(b,n,1);i=e;return}d=l+148|0;if((c[d>>2]|0)>-1){j=l+136|0;h=c[j>>2]|0;c[g>>2]=c[l+140>>2];c[f+0>>2]=c[g+0>>2];eOb(h,f);c[j>>2]=0}c[p>>2]=0;c[d>>2]=0;q=b+276|0;a[q>>0]=0;Wdc(b);Xdc(b,n,1);i=e;return}function Wdc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+148|0;if((c[f>>2]|0)>-1){g=a+136|0;h=c[g>>2]|0;c[e>>2]=c[a+140>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}c[a+144>>2]=0;c[f>>2]=0;f=c[a+28>>2]|0;g=f+164|0;if((c[g>>2]|0)>-1){h=f+152|0;j=c[h>>2]|0;c[e>>2]=c[f+156>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[h>>2]=0}c[f+160>>2]=0;c[g>>2]=0;g=f+180|0;if((c[g>>2]|0)>-1){h=f+168|0;j=c[h>>2]|0;c[e>>2]=c[f+172>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[h>>2]=0}c[f+176>>2]=0;c[g>>2]=0;c[a+164>>2]=-1;g=a+152|0;if(c[g>>2]|0){f=ync()|0;In[c[(c[f>>2]|0)+296>>2]&4095](f,c[g>>2]|0);c[g>>2]=0}g=a+156|0;if(c[g>>2]|0){f=ync()|0;In[c[(c[f>>2]|0)+296>>2]&4095](f,c[g>>2]|0);c[g>>2]=0}g=a+160|0;if(!(c[g>>2]|0)){i=b;return}a=ync()|0;In[c[(c[a>>2]|0)+296>>2]&4095](a,c[g>>2]|0);c[g>>2]=0;i=b;return}function Xdc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+4|0;j=g;k=b+272|0;a[k>>0]=d[k>>0]|0|(e|0)!=0;k=b+273|0;a[k>>0]=d[k>>0]|0|f&1;if((e&1|0)!=0|f){icc(b+192|0);f=b+148|0;if((c[f>>2]|0)>-1){e=b+136|0;k=c[e>>2]|0;c[j>>2]=c[b+140>>2];c[h+0>>2]=c[j+0>>2];eOb(k,h);c[e>>2]=0}c[b+144>>2]=0;c[f>>2]=0}c[h+8>>2]=0;c[h+4>>2]=b;c[h>>2]=43;f=c[b+216>>2]|0;e=b+212|0;if((f|0)==(e|0)){i=g;return}else l=f;do{f=l;l=c[l+4>>2]|0;_Tb(c[f+8>>2]|0,554744,h)}while((l|0)!=(e|0));i=g;return}function Ydc(){var a=0;a=i;QQb(43,114,0,0,0);i=a;return}function Zdc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,617744,4);wQb(43,130,b,280,2612,0,0);xri(b);i=a;return}function _dc(a){a=a|0;return 43}function $dc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,617744,a,0);Kec(a,b);bdd(b);i=c;return}function aec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,617744,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Lec(a,b);sdd(b);i=d;return}function bec(a,b){a=a|0;b=b|0;var c=0;c=i;Mec(a,b);i=c;return}function cec(a,b){a=a|0;b=b|0;var c=0;c=i;Nec(a,b);i=c;return}function dec(a,b){a=a|0;b=b|0;var c=0;c=i;Oec(a,b);i=c;return}function eec(a,b){a=a|0;b=b|0;var c=0;c=i;Pec(a,b);i=c;return}function fec(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[a+44>>2]|0;g=c[f+(d*56|0)+8>>2]|0;if(!g){c[f+(d*56|0)+16>>2]=0;c[f+(d*56|0)+20>>2]=0;i=e;return}h=c[a+28>>2]|0;a=c[f+(d*56|0)+4>>2]|0;j=c[h+112>>2]|0;k=c[h+108>>2]|0;if((j|0)!=(k|0)&(j-k|0)>>>0>a>>>0)l=k+a|0;else l=0;a=f+(d*56|0)+16|0;k=l+(g<<1)|0;if((g|0)>0){g=-1;j=0;h=l;while(1){l=b[h>>1]|0;m=(l&65535)<(g&65535)?l:g;n=(j&65535)<(l&65535)?l:j;h=h+2|0;if(h>>>0>=k>>>0){o=m;p=n;break}else{g=m;j=n}}}else{o=-1;p=0}j=o&65535;c[a>>2]=j;c[f+(d*56|0)+20>>2]=(p&65535)+1-j;i=e;return}function gec(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[b+44>>2]|0;b=g+(d*56|0)|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];b=c[a>>2]|0;if(e){if((b|0)!=1){i=f;return}}else if((b|0)!=2){i=f;return}c[a>>2]=0;c[a+4>>2]=c[g+(d*56|0)+24>>2];c[a+8>>2]=c[g+(d*56|0)+28>>2];i=f;return}function hec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b>>2]|0;f=b+4|0;g=c[f>>2]|0;if((g|0)!=(e|0))c[f>>2]=g+(~((g+-4-e|0)>>>2)<<2);e=a+48|0;g=a+44|0;if((c[e>>2]|0)==(c[g>>2]|0)){i=d;return}f=a+44|0;h=a+28|0;j=a+4|0;a=0;do{k=kec(b,a,f,c[h>>2]|0)|0;if((k|0)==1)Krd(573816,0,3653512,1093,1,c[j>>2]|0,0,0);else if((k|0)==4)Krd(573880,0,3653512,1096,1,c[j>>2]|0,0,0);a=a+1|0}while(a>>>0<(((c[e>>2]|0)-(c[g>>2]|0)|0)/56|0)>>>0);i=d;return}function iec(a){a=a|0;return ((c[a+48>>2]|0)-(c[a+44>>2]|0)|0)/56|0|0}function jec(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=((b|0)/4|0)<<2;h=((g|0)/2|0)*3|0;j=d+4|0;k=c[j>>2]|0;l=c[d>>2]|0;m=k-l>>2;if(h>>>0<=m>>>0){if(h>>>0<m>>>0?(n=l+(h<<2)|0,(k|0)!=(n|0)):0)c[j>>2]=k+(~((k+-4-n|0)>>>2)<<2)}else Qec(d,h-m|0);if((b|0)<=3){i=f;return}b=c[d>>2]|0;d=0;m=0;while(1){h=e[a+(d<<1)>>1]|0;c[b+(m<<2)>>2]=h;c[b+((m|1)<<2)>>2]=e[a+((d|1)<<1)>>1];n=e[a+((d|2)<<1)>>1]|0;c[b+(m+2<<2)>>2]=n;c[b+(m+3<<2)>>2]=h;c[b+(m+4<<2)>>2]=n;c[b+(m+5<<2)>>2]=e[a+((d|3)<<1)>>1];d=d+4|0;if((d|0)>=(g|0))break;else m=m+6|0}i=f;return}function kec(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d>>2]|0;if((((c[d+4>>2]|0)-k|0)/56|0)>>>0<=b>>>0){l=1;i=f;return l|0}d=c[k+(b*56|0)>>2]|0;if((d|0)==2){m=c[k+(b*56|0)+4>>2]|0;n=c[e+112>>2]|0;o=c[e+108>>2]|0;if((n|0)!=(o|0)&(n-o|0)>>>0>m>>>0)p=o+m|0;else p=0;jec(p,c[k+(b*56|0)+8>>2]|0,a);l=8;i=f;return l|0}else if((d|0)==1){p=c[k+(b*56|0)+4>>2]|0;m=c[e+112>>2]|0;o=c[e+108>>2]|0;if((m|0)!=(o|0)&(m-o|0)>>>0>p>>>0)q=o+p|0;else q=0;OHc(q,c[k+(b*56|0)+8>>2]|0,a);l=8;i=f;return l|0}else if(!d){d=c[k+(b*56|0)+4>>2]|0;q=c[e+112>>2]|0;p=c[e+108>>2]|0;if(!((q|0)!=(p|0)&(q-p|0)>>>0>d>>>0)){l=8;i=f;return l|0}q=p+d|0;if(!q){l=8;i=f;return l|0}c[h>>2]=c[a+4>>2];d=q+(c[k+(b*56|0)+8>>2]<<1)|0;c[g+0>>2]=c[h+0>>2];Rec(j,a,g,q,d);l=8;i=f;return l|0}else{l=4;i=f;return l|0}return 0}function lec(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;l=i;i=i+32|0;m=l;n=l+24|0;o=l+12|0;p=(k&8|0)==0;if((f|0)==0&(g|0)!=0&p){if(!d)q=0;else q=c[d+4>>2]|0;Krd(573944,0,3653512,1135,1,q,0,0);r=0;i=l;return r|0}q=d+44|0;if((((c[d+48>>2]|0)-(c[q>>2]|0)|0)/56|0)>>>0<=h>>>0){Krd(573992,0,3653512,1141,1,c[d+4>>2]|0,0,0);r=0;i=l;return r|0}if(!((j|0)!=0|((g>>>0)%3|0|0)==0)){Krd(574056,0,3653512,1147,1,c[d+4>>2]|0,0,0);r=0;i=l;return r|0}a:do if(p){s=c[(c[d+28>>2]|0)+100>>2]|0;b:do if(!(k&1)){if(!g)break a;else t=0;while(1){if((c[f+(t<<2)>>2]|0)>>>0>=s>>>0)break b;t=t+1|0;if(t>>>0>=g>>>0)break a}}else{if(!g)break a;else u=0;while(1){if((e[f+(u<<1)>>1]|0)>>>0>=s>>>0)break b;u=u+1|0;if(u>>>0>=g>>>0)break a}}while(0);c[m>>2]=g;c[m+4>>2]=s;Sec(o,574152,m);if(!d)v=0;else v=c[d+4>>2]|0;if(!(a[o>>0]&1))w=o+1|0;else w=c[o+8>>2]|0;Krd(w,0,3653512,1161,1,v,0,0);if(!(a[o>>0]&1)){r=0;i=l;return r|0}x=c[o+8>>2]|0;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];eOb(x,m);r=0;i=l;return r|0}while(0);nec(d,h,g,f,j,k);j=c[q>>2]|0;if(!(k&16)){q=c[j+(h*56|0)+8>>2]|0;if(!q){c[j+(h*56|0)+16>>2]=0;c[j+(h*56|0)+20>>2]=0}else{f=c[d+28>>2]|0;g=c[j+(h*56|0)+4>>2]|0;o=c[f+112>>2]|0;v=c[f+108>>2]|0;if((o|0)!=(v|0)&(o-v|0)>>>0>g>>>0)y=v+g|0;else y=0;g=j+(h*56|0)+16|0;v=y+(q<<1)|0;if((q|0)>0){q=-1;o=0;f=y;while(1){y=b[f>>1]|0;w=(y&65535)<(q&65535)?y:q;u=(o&65535)<(y&65535)?y:o;f=f+2|0;if(f>>>0>=v>>>0){z=w;A=u;break}else{q=w;o=u}}}else{z=-1;A=0}o=z&65535;c[g>>2]=o;c[j+(h*56|0)+20>>2]=(A&65535)+1-o}if(!(k&32)){Sdc(d,h);c[m+8>>2]=0;c[m+4>>2]=d;c[m>>2]=43;h=c[d+216>>2]|0;o=d+212|0;if((h|0)!=(o|0)){A=h;do{h=A;A=c[A+4>>2]|0;_Tb(c[h+8>>2]|0,554696,m)}while((A|0)!=(o|0))}J3b(d+220|0,1)}}else{c[j+16>>2]=0;c[j+20>>2]=c[(c[d+28>>2]|0)+100>>2];o=j+32|0;j=d+168|0;c[o+0>>2]=c[j+0>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];c[o+12>>2]=c[j+12>>2];c[o+16>>2]=c[j+16>>2];c[o+20>>2]=c[j+20>>2]}j=d+192|0;if(k&4)icc(j);a[d+273>>0]=1;icc(j);j=d+148|0;if((c[j>>2]|0)>-1){k=d+136|0;o=c[k>>2]|0;c[n>>2]=c[d+140>>2];c[m+0>>2]=c[n+0>>2];eOb(o,m);c[k>>2]=0}c[d+144>>2]=0;c[j>>2]=0;c[m+8>>2]=0;c[m+4>>2]=d;c[m>>2]=43;j=c[d+216>>2]|0;k=d+212|0;if((j|0)==(k|0)){r=1;i=l;return r|0}else B=j;do{j=B;B=c[B+4>>2]|0;_Tb(c[j+8>>2]|0,554744,m)}while((B|0)!=(k|0));r=1;i=l;return r|0}function mec(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=lec(a,b,c,d,e,5)|0;i=f;return g|0}function nec(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=i;i=i+16|0;l=k+8|0;m=k+4|0;n=k+12|0;o=f<<1;p=d+44|0;q=c[p>>2]|0;r=c[q+(e*56|0)+8>>2]<<1;s=o-r|0;t=c[q+(e*56|0)+4>>2]|0;q=d+28|0;u=c[q>>2]|0;v=u+108|0;w=c[v>>2]|0;if((s|0)<=0){if((o|0)!=(r|0)?(o=w+(t-s)|0,x=u+112|0,u=(c[x>>2]|0)-o|0,aFi(w+t|0,o|0,u|0)|0,o=w+(u+t)|0,(c[x>>2]|0)!=(o|0)):0)c[x>>2]=o}else{c[m>>2]=w+(t+r);a[n>>0]=0;c[l+0>>2]=c[m+0>>2];Tec(k,v,l,s,n)}n=c[p>>2]|0;c[n+(e*56|0)+8>>2]=f;c[n+(e*56|0)>>2]=h;h=e+1|0;p=((c[d+48>>2]|0)-n|0)/56|0;a:do if(h>>>0<p>>>0){d=f;s=c[n+(e*56|0)+4>>2]|0;l=h;while(1){v=(d<<1)+s|0;c[n+(l*56|0)+4>>2]=v;m=l+1|0;if(m>>>0>=p>>>0)break a;d=c[n+(l*56|0)+8>>2]|0;s=v;l=m}}while(0);if(j&8){i=k;return}if(!(j&1)){j=c[q>>2]|0;p=c[n+(e*56|0)+4>>2]|0;h=c[j+112>>2]|0;l=c[j+108>>2]|0;if((h|0)!=(l|0)&(h-l|0)>>>0>p>>>0)y=l+p|0;else y=0;if((f|0)>0)z=0;else{i=k;return}do{b[y+(z<<1)>>1]=c[g+(z<<2)>>2];z=z+1|0}while((z|0)!=(f|0));i=k;return}else{z=c[q>>2]|0;q=c[n+(e*56|0)+4>>2]|0;e=c[z+112>>2]|0;n=c[z+108>>2]|0;if((e|0)!=(n|0)&(e-n|0)>>>0>q>>>0)A=n+q|0;else A=0;if((f|0)>0)B=0;else{i=k;return}do{b[A+(B<<1)>>1]=b[g+(B<<1)>>1]|0;B=B+1|0}while((B|0)!=(f|0));i=k;return}}function oec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=a+168|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[e+8>>2]=0;c[e+4>>2]=a;c[e>>2]=43;b=c[a+216>>2]|0;f=a+212|0;if((b|0)==(f|0)){g=a+220|0;J3b(g,1);i=d;return}else h=b;do{b=h;h=c[h+4>>2]|0;_Tb(c[b+8>>2]|0,554696,e)}while((h|0)!=(f|0));g=a+220|0;J3b(g,1);i=d;return}function pec(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+96|0;f=e+80|0;g=e+24|0;h=e;if(!b){j=c[a+28>>2]|0;k=c[j+108>>2]|0;l=j+112|0;if((c[l>>2]|0)!=(k|0))c[l>>2]=k;k=c[a+44>>2]|0;l=a+48|0;j=c[l>>2]|0;if((j|0)==(k|0)){i=e;return}c[l>>2]=j+(~(((j+-56-k|0)>>>0)/56|0)*56|0);i=e;return}k=a+44|0;j=a+48|0;l=c[j>>2]|0;m=c[k>>2]|0;n=(l-m|0)/56|0;if(n>>>0<=b>>>0){if(n>>>0>=b>>>0){i=e;return}o=g+32|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;c[g+28>>2]=0;p=c[a+28>>2]|0;c[g+4>>2]=(c[p+112>>2]|0)-(c[p+108>>2]|0);c[g+8>>2]=0;c[g>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;p=h+12|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+0>>2]=c[150284];c[h+4>>2]=c[150285];c[h+8>>2]=c[150286];c[p+0>>2]=c[150284];c[p+4>>2]=c[150285];c[p+8>>2]=c[150286];c[o+0>>2]=c[h+0>>2];c[o+4>>2]=c[h+4>>2];c[o+8>>2]=c[h+8>>2];c[o+12>>2]=c[h+12>>2];c[o+16>>2]=c[h+16>>2];c[o+20>>2]=c[h+20>>2];Vec(k,b-n|0,g);if(!d){i=e;return}Rdc(a);c[f+8>>2]=0;c[f+4>>2]=a;c[f>>2]=43;d=c[a+216>>2]|0;g=a+212|0;if((d|0)!=(g|0)){n=d;do{d=n;n=c[n+4>>2]|0;_Tb(c[d+8>>2]|0,554696,f)}while((n|0)!=(g|0))}J3b(a+220|0,1);i=e;return}g=c[a+28>>2]|0;a=g+108|0;n=c[m+(b*56|0)+4>>2]|0;f=g+112|0;g=c[f>>2]|0;d=c[a>>2]|0;h=g-d|0;if(n>>>0<=h>>>0)if(n>>>0<h>>>0?(o=d+n|0,(g|0)!=(o|0)):0){c[f>>2]=o;q=l;r=m}else{q=l;r=m}else{vdc(a,n-h|0);q=c[j>>2]|0;r=c[k>>2]|0}h=(q-r|0)/56|0;if(h>>>0<b>>>0){Uec(k,b-h|0);i=e;return}if(h>>>0<=b>>>0){i=e;return}h=r+(b*56|0)|0;if((q|0)==(h|0)){i=e;return}c[j>>2]=q+(~(((q+-56-h|0)>>>0)/56|0)*56|0);i=e;return}function qec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+28|0;a=(c[e>>2]|0)+8|0;c[b+0>>2]=c[a+0>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];c[b+20>>2]=c[a+20>>2];c[b+24>>2]=c[a+24>>2];c[b+28>>2]=c[a+28>>2];a=b+32|0;f=(c[e>>2]|0)+40|0;g=a+48|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(g|0));f=c[e>>2]|0;c[b+80>>2]=c[f+92>>2];c[b+84>>2]=c[f+104>>2];c[b+88>>2]=c[f+100>>2];i=d;return}function rec(a){a=a|0;var b=0;b=a+28|0;a=(c[b>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;return c[b>>2]|0}function sec(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g;j=0;do{k=c[d+(j<<3)+236>>2]|0;if(!k)break;j=j+1|0;if(mo[c[(c[k>>2]|0)+8>>2]&4095](k)|0){l=5;break}}while((j|0)<4);if((l|0)==5)a[d+272>>0]=1;l=d+232|0;j=c[l>>2]|0;if((j|0)!=0?mo[c[(c[j>>2]|0)+8>>2]&4095](j)|0:0)a[d+273>>0]=1;tec(d);j=d+268|0;k=c[j>>2]|0;if(!k){m=b+0|0;n=m+44|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));i=g;return}c[b>>2]=c[l>>2];l=b+4|0;c[l>>2]=0;m=0;n=0;while(1){o=d+(n<<3)+236|0;if(!(c[o>>2]|0)){p=m;break}q=o;o=c[q+4>>2]|0;r=b+(n<<3)+8|0;c[r>>2]=c[q>>2];c[r+4>>2]=o;o=(c[l>>2]|0)+1|0;c[l>>2]=o;n=n+1|0;if((n|0)>=4){p=o;break}else m=o}if(f){m=p;n=0;while(1){o=f+(n<<3)+236|0;if(!(c[o>>2]|0)){s=m;break}r=o;o=c[r+4>>2]|0;q=b+(n+p<<3)+8|0;c[q>>2]=c[r>>2];c[q+4>>2]=o;o=(c[l>>2]|0)+1|0;c[l>>2]=o;n=n+1|0;if((n|0)>=4){s=o;break}else m=o}if((p|0)!=(s|0)){t=s;u=c[f+268>>2]|0}else{t=p;u=0}}else{t=p;u=0}if((e&4&c[155248]|0)!=0?(a[k+19>>0]|0)==0:0){p=ync()|0;_nc(h,p,c[(c[d+28>>2]|0)+100>>2]|0);d=h;h=c[d+4>>2]|0;p=b+(t<<3)+8|0;c[p>>2]=c[d>>2];c[p+4>>2]=h;c[l>>2]=(c[l>>2]|0)+1;v=c[j>>2]|0}else v=k;c[b+40>>2]=qic(v,e,u)|0;i=g;return}function tec(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+144|0;f=e+52|0;g=e+48|0;h=e+16|0;j=e;k=b+272|0;if((a[k>>0]|0)==0?(a[b+273>>0]|0)==0:0){i=e;return}l=d[b+274>>0]|0;m=d[b+275>>0]|0;n=b+28|0;o=(c[n>>2]|0)+4|0;c[o>>2]=(c[o>>2]|0)+1;o=c[n>>2]|0;p=znc()|0;if(a[k>>0]|0){q=f+80|0;r=f+84|0;s=f+88|0;t=f+0|0;u=t+92|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));v=c[n>>2]|0;w=v+8|0;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];c[f+24>>2]=c[w+24>>2];c[f+28>>2]=c[w+28>>2];t=f+32|0;w=v+40|0;u=t+48|0;do{c[t>>2]=c[w>>2];t=t+4|0;w=w+4|0}while((t|0)<(u|0));w=c[v+92>>2]|0;c[q>>2]=w;c[r>>2]=c[v+104>>2];r=c[v+100>>2]|0;c[s>>2]=r;s=b+152|0;if(c[s>>2]|0){v=ync()|0;In[c[(c[v>>2]|0)+296>>2]&4095](v,c[s>>2]|0);c[s>>2]=0}s=b+156|0;if(c[s>>2]|0){v=ync()|0;In[c[(c[v>>2]|0)+296>>2]&4095](v,c[s>>2]|0);c[s>>2]=0}s=b+160|0;if(c[s>>2]|0){v=ync()|0;In[c[(c[v>>2]|0)+296>>2]&4095](v,c[s>>2]|0);c[s>>2]=0}s=0;do{v=b+(s<<3)+236|0;q=c[v>>2]|0;t=(q|0)==0;if(!((r|0)>0?(c[f+(s*12|0)+32>>2]|0)!=0:0)){if(!t){u=ync()|0;In[c[(c[u>>2]|0)+296>>2]&4095](u,c[v>>2]|0);c[v>>2]=0;c[b+(s<<3)+240>>2]=0}}else{if(t){t=mo[c[(c[p>>2]|0)+280>>2]&4095](p)|0;c[v>>2]=t;x=t}else x=q;q=d[f+(s*12|0)+42>>0]|0;t=da(q,r)|0;Wn[c[(c[p>>2]|0)+284>>2]&127](p,x,l,m,t,w+(c[f+(s*12|0)+36>>2]|0)|0,1);t=c[(c[p>>2]|0)+652>>2]|0;u=c[v>>2]|0;v=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;co[t&2047](p,u,v);c[b+(s<<3)+240>>2]=q}s=s+1|0}while((s|0)!=4);s=uic()|0;Hic(h,f);c[b+268>>2]=sic(s,h)|0}h=b+273|0;do if(a[h>>0]|0){s=c[n>>2]|0;w=c[s+112>>2]|0;x=c[s+108>>2]|0;s=b+232|0;r=c[s>>2]|0;q=(r|0)==0;if((w-x|0)>>>0<=1){if(q)break;v=ync()|0;In[c[(c[v>>2]|0)+276>>2]&4095](v,c[s>>2]|0);c[s>>2]=0;break}if(q){q=ync()|0;v=mo[c[(c[q>>2]|0)+260>>2]&4095](q)|0;c[s>>2]=v;q=c[n>>2]|0;y=c[q+108>>2]|0;z=c[q+112>>2]|0;A=v}else{y=x;z=w;A=r}r=c[153134]|0;c[j>>2]=0;w=j+4|0;c[w>>2]=r;x=j+8|0;c[x>>2]=0;v=j+12|0;c[v>>2]=0;q=(y|0)==(z|0)?0:y;u=(z-y|0)>>>1;t=c[b+48>>2]|0;B=c[b+44>>2]|0;C=(t|0)==(B|0);a:do if(C){D=A;E=1;F=u;G=q}else{H=(t-B|0)/56|0;I=0;while(1){if((c[B+(I*56|0)>>2]|0)==2)break;I=I+1|0;if(I>>>0>=H>>>0){J=27;break}}b:do if((J|0)==27){if(C){D=A;E=1;F=u;G=q;break a}H=(t-B|0)/56|0;I=0;while(1){if((c[B+(I*56|0)>>2]|0)==1)break b;I=I+1|0;if(I>>>0>=H>>>0){D=A;E=1;F=u;G=q;break a}}}while(0);c[x>>2]=u;if(!u){K=u<<1;L=0}else{c[v>>2]=u;H=u<<1;c[g>>2]=r;c[f+0>>2]=c[g+0>>2];I=hOb(0,H,2,f,0,3653512,370)|0;c[j>>2]=I;K=H;L=I}YEi(L|0,q|0,K|0)|0;Edc(b+44|0,j);D=c[s>>2]|0;E=0;F=c[x>>2]|0;G=c[j>>2]|0}while(0);Wn[c[(c[p>>2]|0)+264>>2]&127](p,D,l,m,F<<1,G,E);x=c[(c[p>>2]|0)+656>>2]|0;q=c[s>>2]|0;r=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;co[x&2047](p,q,r);if((c[v>>2]|0)>-1){r=c[j>>2]|0;c[g>>2]=c[w>>2];c[f+0>>2]=c[g+0>>2];eOb(r,f);c[j>>2]=0}}while(0);In[c[(c[p>>2]|0)+356>>2]&4095](p,o);a[k>>0]=0;a[h>>0]=0;h=b+152|0;if(c[h>>2]|0){k=ync()|0;In[c[(c[k>>2]|0)+296>>2]&4095](k,c[h>>2]|0);c[h>>2]=0}h=b+156|0;if(c[h>>2]|0){k=ync()|0;In[c[(c[k>>2]|0)+296>>2]&4095](k,c[h>>2]|0);c[h>>2]=0}h=b+160|0;if(!(c[h>>2]|0)){i=e;return}b=ync()|0;In[c[(c[b>>2]|0)+296>>2]&4095](b,c[h>>2]|0);c[h>>2]=0;i=e;return}function uec(a){a=a|0;var b=0,d=0,e=0;b=i;if(c[a>>2]|0){d=ync()|0;In[c[(c[d>>2]|0)+276>>2]&4095](d,c[a>>2]|0);c[a>>2]=0}d=a+4|0;if(c[d>>2]|0){e=ync()|0;In[c[(c[e>>2]|0)+296>>2]&4095](e,c[d>>2]|0);c[d>>2]=0;c[a+8>>2]=0}d=a+12|0;if(c[d>>2]|0){e=ync()|0;In[c[(c[e>>2]|0)+296>>2]&4095](e,c[d>>2]|0);c[d>>2]=0;c[a+16>>2]=0}d=a+20|0;if(c[d>>2]|0){e=ync()|0;In[c[(c[e>>2]|0)+296>>2]&4095](e,c[d>>2]|0);c[d>>2]=0;c[a+24>>2]=0}d=a+28|0;if(!(c[d>>2]|0)){i=b;return}e=ync()|0;In[c[(c[e>>2]|0)+296>>2]&4095](e,c[d>>2]|0);c[d>>2]=0;c[a+32>>2]=0;i=b;return}function vec(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0;h=i;i=i+112|0;j=h+92|0;k=h+88|0;l=h+72|0;m=h+96|0;n=h+36|0;o=h;p=e+28|0;q=c[p>>2]|0;r=c[q+100>>2]|0;s=c[q+96>>2]|0;t=b+28|0;u=(c[t>>2]|0)+8|0;v=q+8|0;Sic(l,v);Lic(m,v);Vic(u,r,s,~s,l,m);if(s&1){m=c[p>>2]|0;l=d[m+8>>0]|0;u=c[t>>2]|0;q=d[u+8>>0]|0;zMc(f,(c[m+92>>2]|0)+((d[m+9>>0]|0)+(c[m+(l*12|0)+44>>2]|0))|0,d[m+(l*12|0)+50>>0]|0,(c[u+92>>2]|0)+((d[u+9>>0]|0)+(c[u+(q*12|0)+44>>2]|0))|0,d[u+(q*12|0)+50>>0]|0,r)}TLc(n,f);f=o+0|0;q=n+0|0;u=f+36|0;do{c[f>>2]=c[q>>2];f=f+4|0;q=q+4|0}while((f|0)<(u|0));VLc(o);if(s&2){q=c[p>>2]|0;f=a[q+15>>0]|0;if(!((a[q+14>>0]|0)!=0|(f&255)<3)){u=c[q+92>>2]|0;if((u|0)==0|f<<24>>24==0){w=1;x=0}else{l=d[q+12>>0]|0;w=d[q+(l*12|0)+50>>0]|0;x=u+((d[q+13>>0]|0)+(c[q+(l*12|0)+44>>2]|0))|0}l=c[q+92>>2]|0;if((l|0)==0|f<<24>>24==0){y=x;z=0;A=w}else{f=d[q+12>>0]|0;y=x;z=l+((da(d[q+(f*12|0)+50>>0]|0,c[q+100>>2]|0)|0)+(c[q+(f*12|0)+44>>2]|0)+(d[q+13>>0]|0))|0;A=w}}else{y=0;z=0;A=0}w=c[t>>2]|0;q=a[w+15>>0]|0;if(!((a[w+14>>0]|0)!=0|(q&255)<3)){f=c[w+92>>2]|0;if((f|0)==0|q<<24>>24==0){B=1;C=0}else{q=d[w+12>>0]|0;B=d[w+(q*12|0)+50>>0]|0;C=f+((d[w+13>>0]|0)+(c[w+(q*12|0)+44>>2]|0))|0}}else{B=0;C=0}if((y|0)!=(z|0)){q=o+12|0;w=o+24|0;f=o+4|0;l=o+16|0;x=o+28|0;u=o+8|0;m=o+20|0;D=o+32|0;E=ea(g[150276]);F=y;y=C;while(1){G=ea(g[o>>2]);H=ea(g[F>>2]);I=ea(G*H);G=ea(g[q>>2]);J=ea(g[F+4>>2]);K=ea(I+ea(G*J));G=ea(g[w>>2]);I=ea(g[F+8>>2]);L=ea(K+ea(G*I));G=ea(H*ea(g[f>>2]));K=ea(G+ea(J*ea(g[l>>2])));G=ea(K+ea(I*ea(g[x>>2])));K=ea(H*ea(g[u>>2]));H=ea(K+ea(J*ea(g[m>>2])));J=ea(H+ea(I*ea(g[D>>2])));I=ea(T(ea(ea(ea(L*L)+ea(G*G))+ea(J*J))));if(I>E){M=ea(L/I);N=ea(G/I);O=ea(J/I)}else{I=ea(g[150284]);J=ea(g[150285]);M=I;N=J;O=ea(g[150286])}g[y>>2]=M;g[y+4>>2]=N;g[y+8>>2]=O;F=F+A|0;if((F|0)==(z|0))break;else y=y+B|0}}}if(s&128){B=c[p>>2]|0;y=a[B+39>>0]|0;if(!((a[B+38>>0]|0)!=0|(y&255)<4)){z=c[B+92>>2]|0;if((z|0)==0|y<<24>>24==0){P=1;Q=0}else{F=d[B+36>>0]|0;P=d[B+(F*12|0)+50>>0]|0;Q=z+((d[B+37>>0]|0)+(c[B+(F*12|0)+44>>2]|0))|0}F=c[B+92>>2]|0;if((F|0)==0|y<<24>>24==0){R=Q;S=0;U=P}else{y=d[B+36>>0]|0;R=Q;S=F+((da(d[B+(y*12|0)+50>>0]|0,c[B+100>>2]|0)|0)+(c[B+(y*12|0)+44>>2]|0)+(d[B+37>>0]|0))|0;U=P}}else{R=0;S=0;U=0}P=c[t>>2]|0;B=a[P+39>>0]|0;if(!((a[P+38>>0]|0)!=0|(B&255)<4)){y=c[P+92>>2]|0;if((y|0)==0|B<<24>>24==0){V=1;W=0}else{B=d[P+36>>0]|0;V=d[P+(B*12|0)+50>>0]|0;W=y+((d[P+37>>0]|0)+(c[P+(B*12|0)+44>>2]|0))|0}}else{V=0;W=0}if((R|0)!=(S|0)){B=n+12|0;P=n+24|0;y=n+4|0;F=n+16|0;Q=n+28|0;z=n+8|0;A=n+20|0;D=n+32|0;O=ea(g[150276]);m=R;R=W;while(1){N=ea(g[m>>2]);M=ea(g[m+4>>2]);E=ea(g[m+8>>2]);J=ea(N*ea(g[n>>2]));I=ea(J+ea(M*ea(g[B>>2])));J=ea(I+ea(E*ea(g[P>>2])));I=ea(N*ea(g[y>>2]));G=ea(I+ea(M*ea(g[F>>2])));I=ea(G+ea(E*ea(g[Q>>2])));G=ea(N*ea(g[z>>2]));N=ea(G+ea(M*ea(g[A>>2])));M=ea(N+ea(E*ea(g[D>>2])));E=ea(T(ea(ea(ea(J*J)+ea(I*I))+ea(M*M))));if(E>O){X=ea(J/E);Y=ea(I/E);Z=ea(M/E)}else{E=ea(g[150284]);M=ea(g[150285]);X=E;Y=M;Z=ea(g[150286])}M=ea(g[m+12>>2]);g[R>>2]=X;g[R+4>>2]=Y;g[R+8>>2]=Z;g[R+12>>2]=M;m=m+U|0;if((m|0)==(S|0))break;else R=R+V|0}}}V=c[t>>2]|0;R=c[p>>2]|0;if((V|0)!=(R|0))Occ(V+108|0,c[R+108>>2]|0,c[R+112>>2]|0);if((b|0)!=(e|0))Pcc(b+44|0,c[e+44>>2]|0,c[e+48>>2]|0);R=c[t>>2]|0;V=R+136|0;S=c[p>>2]|0;if((S|0)==(R|0)){_=R;$=s&124;aa=_+8|0;Zic(r,$,v,aa);ba=e+276|0;ca=a[ba>>0]|0;fa=b+276|0;a[fa>>0]=ca;ga=b+168|0;ha=e+168|0;c[ga+0>>2]=c[ha+0>>2];c[ga+4>>2]=c[ha+4>>2];c[ga+8>>2]=c[ha+8>>2];c[ga+12>>2]=c[ha+12>>2];c[ga+16>>2]=c[ha+16>>2];c[ga+20>>2]=c[ha+20>>2];ia=b+192|0;icc(ia);Xdc(b,s,1);Wdc(b);i=h;return}p=c[S+136>>2]|0;m=c[S+144>>2]<<5;S=m>>5;U=R+144|0;c[U>>2]=S;D=R+148|0;A=c[D>>2]|0;do if((A&2147483647)>>>0<S>>>0)if((A|0)>-1){c[D>>2]=S;z=c[V>>2]|0;c[k>>2]=c[R+140>>2];c[j+0>>2]=c[k+0>>2];Q=hOb(z,m,16,j,0,3653512,370)|0;c[V>>2]=Q;ja=Q;break}else{c[k>>2]=c[R+140>>2];c[j+0>>2]=c[k+0>>2];Q=cOb(m,16,j,0,3653512,352)|0;YEi(Q|0,c[V>>2]|0,c[U>>2]<<5|0)|0;c[D>>2]=S;c[V>>2]=Q;ja=Q;break}else ja=c[V>>2]|0;while(0);YEi(ja|0,p|0,c[U>>2]<<5|0)|0;_=c[t>>2]|0;$=s&124;aa=_+8|0;Zic(r,$,v,aa);ba=e+276|0;ca=a[ba>>0]|0;fa=b+276|0;a[fa>>0]=ca;ga=b+168|0;ha=e+168|0;c[ga+0>>2]=c[ha+0>>2];c[ga+4>>2]=c[ha+4>>2];c[ga+8>>2]=c[ha+8>>2];c[ga+12>>2]=c[ha+12>>2];c[ga+16>>2]=c[ha+16>>2];c[ga+20>>2]=c[ha+20>>2];ia=b+192|0;icc(ia);Xdc(b,s,1);Wdc(b);i=h;return}function wec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d+16|0;f=d+32|0;g=d;h=b+28|0;Lic(f,(c[h>>2]|0)+8|0);j=(a[621174]|0)==0;a:do if(!(a[621173]|0)){k=1;l=0;m=0;while(1){n=f+(l<<1)+1|0;if(a[n>>0]|0){o=f+(l<<1)|0;p=a[o>>0]|0;if(p<<24>>24!=1?!(p<<24>>24==3&j):0){q=p;r=m}else{a[o>>0]=0;q=0;r=m|k}if((l|0)==1){if(!(q<<24>>24))a[n>>0]=3;k=k<<1;l=l+1|0;m=r;continue}else s=r}else s=m;l=l+1|0;if((l|0)==8){t=s;break}else{k=k<<1;m=s}}}else{if(j){u=0;v=1;w=0}else{m=0;b:while(1){k=f+(m<<1)+1|0;do if((a[k>>0]|0)!=0&(m|0)==1)if(!(a[f+(m<<1)>>0]|0)){a[k>>0]=3;break}else{m=m+1|0;continue b}while(0);m=m+1|0;if((m|0)==8){t=0;break a}}}while(1){m=f+(u<<1)+1|0;if(a[m>>0]|0){k=f+(u<<1)|0;l=a[k>>0]|0;if(l<<24>>24==3){a[k>>0]=0;x=0;y=w|v}else{x=l;y=w}if((u|0)==1){if(!(x<<24>>24))a[m>>0]=3;u=u+1|0;v=v<<1;w=y;continue}else z=y}else z=w;u=u+1|0;if((u|0)==8){t=z;break}else{v=v<<1;w=z}}}while(0);z=c[h>>2]|0;h=z+8|0;w=c[z+100>>2]|0;if((c[z+144>>2]|0)==0?(c[b+92>>2]|0)==(c[b+88>>2]|0):0){Sic(e,z+8|0);c[e>>2]=(c[e+4>>2]&255^255)&~c[e+8>>2]&~c[e+12>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Vic(h,w,t,0,g,f);Idc(b,1);i=d;return};c[g+0>>2]=c[143994];c[g+4>>2]=c[143995];c[g+8>>2]=c[143996];c[g+12>>2]=c[143997];Vic(h,w,t,0,g,f);Idc(b,1);i=d;return}function xec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+164|0;f=c[e>>2]|0;a:do if((f|0)==-1){c[e>>2]=-2;g=c[a+28>>2]|0;h=c[g+144>>2]|0;if(!h)j=0;else{k=c[g+136>>2]|0;g=0;l=0;while(1){m=c[k+(l<<5)+16>>2]|0;if((m|0)<0){n=0;break a}o=c[k+(l<<5)+20>>2]|0;if((o|0)<0){n=0;break a}p=c[k+(l<<5)+24>>2]|0;if((p|0)<0){n=0;break a}q=c[k+(l<<5)+28>>2]|0;if((q|0)<0){n=0;break a}r=(g|0)<(m|0)?m:g;m=(r|0)<(o|0)?o:r;r=(m|0)<(p|0)?p:m;m=(r|0)<(q|0)?q:r;l=l+1|0;if(l>>>0>=h>>>0){j=m;break}else g=m}}c[e>>2]=j;n=(j|0)<(b|0)}else if((f|0)==-2)n=0;else n=(f|0)<(b|0);while(0);i=d;return n|0}function yec(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=zec((c[a+28>>2]|0)+120|0,b)|0;i=d;return e|0}function zec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0;d=i;i=i+16|0;e=d+4|0;f=d;h=c[a+24>>2]|0;if(!h){j=0;i=d;return j|0}k=c[a+16>>2]|0;if((b|0)==2){l=a+32|0;m=a+40|0;if(c[m>>2]|0){j=c[l>>2]|0;i=d;return j|0}c[m>>2]=h;n=a+44|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<h>>>0)if((o|0)>-1){c[n>>2]=h;p=c[l>>2]|0;c[f>>2]=c[a+36>>2];c[e+0>>2]=c[f+0>>2];q=hOb(p,h<<4,16,e,0,3653512,370)|0;c[l>>2]=q;r=q;break}else{c[f>>2]=c[a+36>>2];c[e+0>>2]=c[f+0>>2];q=cOb(h<<4,16,e,0,3653512,352)|0;YEi(q|0,c[l>>2]|0,c[m>>2]<<4|0)|0;c[n>>2]=h;c[l>>2]=q;r=q;break}else r=c[l>>2]|0;while(0);if((h|0)>0){l=0;do{c[r+(l<<4)+8>>2]=c[k+(l<<5)+16>>2];c[r+(l<<4)+12>>2]=c[k+(l<<5)+20>>2];s=ea(g[k+(l<<5)>>2]);n=k+(l<<5)+4|0;t=ea(ea(1.0)/ea(s+ea(g[n>>2])));g[r+(l<<4)>>2]=ea(s*t);g[r+(l<<4)+4>>2]=ea(t*ea(g[n>>2]));l=l+1|0}while((l|0)!=(h|0))}j=r;i=d;return j|0}else if((b|0)==1){r=a+48|0;l=a+56|0;if(c[l>>2]|0){j=c[r>>2]|0;i=d;return j|0}c[l>>2]=h;n=a+60|0;m=c[n>>2]|0;do if((m&2147483647)>>>0<h>>>0)if((m|0)>-1){c[n>>2]=h;o=c[r>>2]|0;c[f>>2]=c[a+52>>2];c[e+0>>2]=c[f+0>>2];q=hOb(o,h<<2,4,e,0,3653512,370)|0;c[r>>2]=q;u=q;break}else{c[f>>2]=c[a+52>>2];c[e+0>>2]=c[f+0>>2];q=cOb(h<<2,4,e,0,3653512,352)|0;YEi(q|0,c[r>>2]|0,c[l>>2]<<2|0)|0;c[n>>2]=h;c[r>>2]=q;u=q;break}else u=c[r>>2]|0;while(0);if((h|0)>0){r=0;do{c[u+(r<<2)>>2]=c[k+(r<<5)+16>>2];r=r+1|0}while((r|0)!=(h|0))}j=u;i=d;return j|0}else if((b|0)==4){j=k;i=d;return j|0}else{j=0;i=d;return j|0}return 0}function Aec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=a+28|0;g=zec((c[f>>2]|0)+120|0,b)|0;if(!g){h=0;i=d;return h|0}sec(e,a,c[(c[f>>2]|0)+96>>2]|0,0);if(!(c[e>>2]|0)){h=0;i=d;return h|0}if((b|0)==4)j=a+152|0;else j=(b|0)==2?a+156|0:a+160|0;a=c[j>>2]|0;if(a){h=a;i=d;return h|0}a=ync()|0;c[j>>2]=mo[c[(c[a>>2]|0)+280>>2]&4095](a)|0;if((b|0)==1)k=4;else if((b|0)==4)k=32;else if((b|0)==2)k=16;else k=1;b=ync()|0;a=da(c[(c[f>>2]|0)+100>>2]|0,k)|0;Wn[c[(c[b>>2]|0)+284>>2]&127](b,c[j>>2]|0,0,0,a,g,0);h=c[j>>2]|0;i=d;return h|0}function Bec(a){a=a|0;var b=0,c=0;b=i;c=WQb(a)|0;i=b;return c|0}function Cec(b,d){b=b|0;d=d|0;var e=0;d=i;e=b+33|0;if(!(a[e>>0]|0))a[e>>0]=0;Wdc(b);wec(b);tec(b);e=b+36|0;if(c[e>>2]|0){i=d;return}c[e>>2]=xsd(573688)|0;i=d;return}function Dec(a){a=a|0;var b=0;b=i;jcc(a+192|0,a);i=b;return}function Eec(b){b=b|0;a[b+274>>0]=1;return}function Fec(a){a=a|0;return 1}function Gec(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153120];c[b+0>>2]=c[d+0>>2];rsd(573688,b);i=a;return}function Hec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=(((c[g>>2]|0)-h|0)/56|0)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=((c[k>>2]|0)-l|0)/56|0;if(h>>>0<1073741823){m=h<<1;h=m>>>0<j>>>0?j:m;m=((c[g>>2]|0)-l|0)/56|0;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=((c[g>>2]|0)-l|0)/56|0;s=6}if((s|0)==6){c[f>>2]=10;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q*56|0,16,e,0,3653512,80)|0;p=r}r=o+(p*56|0)|0;q=o+(n*56|0)|0;if(r){n=r+0|0;r=b+0|0;b=n+56|0;do{c[n>>2]=c[r>>2];n=n+4|0;r=r+4|0}while((n|0)<(b|0))}r=c[a>>2]|0;n=(c[g>>2]|0)-r|0;b=o+((((n|0)/-56|0)+p|0)*56|0)|0;YEi(b|0,r|0,n|0)|0;n=c[a>>2]|0;c[a>>2]=b;c[g>>2]=o+((p+1|0)*56|0);c[k>>2]=q;if(!n){i=d;return}c[f>>2]=10;c[e+0>>2]=c[f+0>>2];eOb(n,e);i=d;return}function Iec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+56>>2]|0)>-1){f=a+44|0;g=c[f>>2]|0;c[e>>2]=c[a+48>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=a+32|0;g=c[f>>2]|0;if(g){h=a+36|0;while(1){j=c[h>>2]|0;if((j|0)==(g|0))break;k=j+-16|0;c[h>>2]=k;ubc(k)}ACi(c[f>>2]|0)}if((c[a+28>>2]|0)>-1){f=a+16|0;h=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function Jec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(280,e,1,16,3653512,84)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];Fdc(f,e,b);i=d;return f|0}function Kec(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+448|0;g=f+200|0;h=f+136|0;j=f+128|0;k=f+112|0;l=f+12|0;m=f;xWb(b,e);ddd(e,8);n=b+276|0;o=(a[n>>0]|0)==0;Jdc(b,1);p=c[142306]|0;add(e,574264,p,b+44|0,1);q=h+32|0;r=g+12|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;c[g+0>>2]=c[150284];c[g+4>>2]=c[150285];c[g+8>>2]=c[150286];c[r+0>>2]=c[150284];c[r+4>>2]=c[150285];c[r+8>>2]=c[150286];c[q+0>>2]=c[g+0>>2];c[q+4>>2]=c[g+4>>2];c[q+8>>2]=c[g+8>>2];c[q+12>>2]=c[g+12>>2];c[q+16>>2]=c[g+16>>2];c[q+20>>2]=c[g+20>>2];$cd(e,2646336,2646336,g,0);add(e,3142592,575408,h,0);afc(h,e);bdd(e);cdd(e);bdd(e);bfc(e,b+56|0,574280,1);q=b+28|0;add(e,574296,p,(c[q>>2]|0)+120|0,1);$cd(e,2646336,2646336,g,0);add(e,3142592,614736,h,0);cfc(h,e);bdd(e);cdd(e);bdd(e);add(e,574312,p,b+116|0,1);$cd(e,2646336,2646336,g,0);p=c[142304]|0;add(e,3142592,p,h,0);r=e+12|0;s=e+20|0;c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(e);cdd(e);bdd(e);add(e,574336,p,b+132|0,1);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(e);p=b+32|0;t=c[142302]|0;add(e,574360,t,p,1);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(e);u=c[142258]|0;add(e,594920,u,b+33|0,1);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(e);add(e,574384,u,b+34|0,1);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(e);add(e,574400,u,b+35|0,1);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(e);fdd(e);if((a[p>>0]|0)!=0?(c[e>>2]&16384|0)==0:0){c[k>>2]=0;c[k+8>>2]=0;p=k+12|0;c[p>>2]=0;u=k+4|0;c[u>>2]=60;Tic(l);c[m>>2]=0;v=m+4|0;c[v>>2]=0;c[m+8>>2]=0;w=c[142306]|0;add(e,574416,w,m,1);$cd(e,2646336,2646336,g,0);add(e,3142592,t,h,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(e);cdd(e);fdd(e);bdd(e);add(e,574432,w,k,1);$cd(e,2646336,2646336,g,0);add(e,3142592,575312,h,0);dfc(h,e);bdd(e);cdd(e);bdd(e);add(e,574504,612640,l,1);Jic(l,e);bdd(e);w=c[m>>2]|0;if(w){if((c[v>>2]|0)!=(w|0))c[v>>2]=w;c[j>>2]=8;c[g+0>>2]=c[j+0>>2];eOb(w,g)}Uic(l);if((c[p>>2]|0)>-1){p=c[k>>2]|0;c[h>>2]=c[u>>2];c[g+0>>2]=c[h+0>>2];eOb(p,g);c[k>>2]=0}}else{k=c[142306]|0;add(e,574416,k,(c[q>>2]|0)+108|0,1);$cd(e,2646336,2646336,g,0);add(e,3142592,t,h,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(e);cdd(e);fdd(e);bdd(e);add(e,574432,k,(c[q>>2]|0)+136|0,1);$cd(e,2646336,2646336,g,0);add(e,3142592,575312,h,0);dfc(h,e);bdd(e);cdd(e);bdd(e);h=(c[q>>2]|0)+8|0;add(e,574504,612640,h,1);Jic(h,e);bdd(e)}odc(g);fdd(e);add(e,574520,575280,g,1);ffc(g,e);bdd(e);efc(g);if(o){x=b+168|0;add(e,574544,614728,x,1);gfc(e,x,2490904,0);y=b+180|0;gfc(e,y,614664,0);bdd(e);z=b+40|0;A=c[142270]|0;add(e,574560,A,z,1);B=c[r>>2]|0;C=c[B>>2]|0;D=c[s>>2]|0;E=C+(D*24|0)+12|0;c[E>>2]=4;bdd(e);F=b+192|0;hfc(F,e,b);i=f;return}o=c[q>>2]|0;q=a[o+19>>0]|0;if(!((a[o+18>>0]|0)!=2|(q&255)<4)){g=c[o+92>>2]|0;if((g|0)==0|q<<24>>24==0){G=1;H=0}else{h=d[o+16>>0]|0;G=d[o+(h*12|0)+50>>0]|0;H=g+((d[o+17>>0]|0)+(c[o+(h*12|0)+44>>2]|0))|0}h=c[o+92>>2]|0;if((h|0)==0|q<<24>>24==0)I=0;else{g=d[o+16>>0]|0;I=h+((da(d[o+(g*12|0)+50>>0]|0,c[o+100>>2]|0)|0)+(c[o+(g*12|0)+44>>2]|0)+(d[o+17>>0]|0))|0}g=c[o+92>>2]|0;if((g|0)==0|q<<24>>24==0){J=1;K=0}else{q=d[o+16>>0]|0;J=d[o+(q*12|0)+50>>0]|0;K=g+((d[o+17>>0]|0)+(c[o+(q*12|0)+44>>2]|0))|0}if((H|0)!=(I|0)){q=H;H=K;while(1){c[H>>2]=d[q+1>>0]<<8|d[q+2>>0]|d[q>>0]<<16|d[q+3>>0]<<24;q=q+G|0;if((q|0)==(I|0))break;else H=H+J|0}}}a[n>>0]=1;x=b+168|0;add(e,574544,614728,x,1);gfc(e,x,2490904,0);y=b+180|0;gfc(e,y,614664,0);bdd(e);z=b+40|0;A=c[142270]|0;add(e,574560,A,z,1);B=c[r>>2]|0;C=c[B>>2]|0;D=c[s>>2]|0;E=C+(D*24|0)+12|0;c[E>>2]=4;bdd(e);F=b+192|0;hfc(F,e,b);i=f;return}function Lec(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;h=i;i=i+416|0;j=h+16|0;k=h+64|0;l=h+376|0;m=h;n=h+360|0;o=h+384|0;p=h+400|0;q=h+328|0;r=h+312|0;s=h+32|0;t=h+48|0;u=h+344|0;yWb(f,g);rdd(g,8);v=f+276|0;w=(a[v>>0]|0)==0;Jdc(f,1);x=f+44|0;y=c[142306]|0;z=qdd(g,574264,y,j,1)|0;if(z){if((z|0)<=0){z=c[j>>2]|0;if(z)_n[z&4095](x,g)|0}else ifc(g,x,0);sdd(g)}x=f+56|0;z=qdd(g,574280,575328,j,1)|0;if(z){if((z|0)<=0){z=c[j>>2]|0;if(z)_n[z&4095](x,g)|0}else jfc(x,g);sdd(g)}x=f+28|0;z=(c[x>>2]|0)+120|0;A=qdd(g,574296,y,j,1)|0;if(A){if((A|0)<=0){A=c[j>>2]|0;if(A)_n[A&4095](z,g)|0}else kfc(g,z,0);sdd(g)}z=f+116|0;A=qdd(g,574312,y,j,1)|0;if(A){if((A|0)<=0){A=c[j>>2]|0;if(A)_n[A&4095](z,g)|0}else lfc(g,z,0);sdd(g)}z=f+132|0;A=qdd(g,574336,c[142304]|0,j,0)|0;if(A){if((A|0)>0){A=g+12|0;B=c[g+16>>2]|0;C=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;D=B+C|0;c[A>>2]=D;if((C|0)>=0?(E=B+(C+4)|0,E>>>0<=(c[g+20>>2]|0)>>>0):0){c[z>>2]=c[D>>2];c[A>>2]=E}else Bid(A,z,4);if(c[g>>2]&512)c[z>>2]=XEi(c[z>>2]|0)|0}else{A=c[j>>2]|0;if(A)_n[A&4095](z,g)|0}sdd(g)}z=f+32|0;A=qdd(g,574360,c[142302]|0,j,0)|0;if(A){do if((A|0)<=0){E=c[j>>2]|0;if(E)_n[E&4095](z,g)|0}else{E=g+12|0;D=c[g+16>>2]|0;C=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;B=D+C|0;c[E>>2]=B;if((C|0)>=0?(D+(C+1)|0)>>>0<=(c[g+20>>2]|0)>>>0:0){a[z>>0]=a[B>>0]|0;c[E>>2]=(c[E>>2]|0)+1;break}Bid(E,z,1)}while(0);sdd(g)}A=f+33|0;E=c[142258]|0;B=qdd(g,594920,E,j,0)|0;if(B){do if((B|0)<=0){C=c[j>>2]|0;if(C)_n[C&4095](A,g)|0}else{C=g+12|0;D=c[g+16>>2]|0;F=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;G=D+F|0;c[C>>2]=G;if((F|0)>=0?(D+(F+1)|0)>>>0<=(c[g+20>>2]|0)>>>0:0){a[A>>0]=a[G>>0]|0;c[C>>2]=(c[C>>2]|0)+1;break}Bid(C,A,1)}while(0);sdd(g)}A=f+34|0;B=qdd(g,574384,E,j,0)|0;if(B){do if((B|0)<=0){C=c[j>>2]|0;if(C)_n[C&4095](A,g)|0}else{C=g+12|0;G=c[g+16>>2]|0;F=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;D=G+F|0;c[C>>2]=D;if((F|0)>=0?(G+(F+1)|0)>>>0<=(c[g+20>>2]|0)>>>0:0){a[A>>0]=a[D>>0]|0;c[C>>2]=(c[C>>2]|0)+1;break}Bid(C,A,1)}while(0);sdd(g)}A=f+35|0;B=qdd(g,574400,E,j,0)|0;if(B){do if((B|0)<=0){E=c[j>>2]|0;if(E)_n[E&4095](A,g)|0}else{E=g+12|0;C=c[g+16>>2]|0;D=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;F=C+D|0;c[E>>2]=F;if((D|0)>=0?(C+(D+1)|0)>>>0<=(c[g+20>>2]|0)>>>0:0){a[A>>0]=a[F>>0]|0;c[E>>2]=(c[E>>2]|0)+1;break}Bid(E,A,1)}while(0);sdd(g)}if((a[z>>0]|0)!=0?(c[g>>2]&16384|0)==0:0){c[t>>2]=0;c[t+8>>2]=0;z=t+12|0;c[z>>2]=0;A=t+4|0;c[A>>2]=60;Tic(k);c[u>>2]=0;B=u+4|0;c[B>>2]=0;c[u+8>>2]=0;E=qdd(g,574416,y,j,1)|0;if(E){if((E|0)<=0){E=c[j>>2]|0;if(E)_n[E&4095](u,g)|0}else mfc(g,u,0);sdd(g)}E=qdd(g,574432,y,j,1)|0;if(E){if((E|0)<=0){E=c[j>>2]|0;if(E)_n[E&4095](t,g)|0}else nfc(g,t,0);sdd(g)}E=qdd(g,574504,612640,j,1)|0;if(E){if((E|0)<=0){E=c[j>>2]|0;if(E)_n[E&4095](k,g)|0}else Mic(k,g);sdd(g)}E=c[u>>2]|0;if(E){if((c[B>>2]|0)!=(E|0))c[B>>2]=E;c[l>>2]=8;c[j+0>>2]=c[l+0>>2];eOb(E,j)}Uic(k);if((c[z>>2]|0)>-1){z=c[t>>2]|0;c[k>>2]=c[A>>2];c[j+0>>2]=c[k+0>>2];eOb(z,j);c[t>>2]=0;odc(k);H=k;I=1}else{J=1;K=213}}else K=74;do if((K|0)==74){t=(c[x>>2]|0)+108|0;z=qdd(g,574416,y,j,1)|0;if(z){if((z|0)<=0){z=c[j>>2]|0;if(z)_n[z&4095](t,g)|0}else mfc(g,t,0);sdd(g)}t=c[x>>2]|0;if((c[g>>2]&512|0)!=0?(z=c[t+108>>2]|0,A=((c[t+112>>2]|0)-z|0)>>>1,(A|0)!=0):0){E=0;l=z;while(1){z=e[l>>1]|0;b[l>>1]=z<<8|z>>>8;E=E+1|0;if((E|0)==(A|0))break;else l=l+2|0}}l=t+136|0;A=qdd(g,574432,y,j,1)|0;if(A){if((A|0)<=0){A=c[j>>2]|0;if(A)_n[A&4095](l,g)|0}else nfc(g,l,0);sdd(g)}if(!(xdd(g,5)|0)){l=(c[x>>2]|0)+8|0;A=qdd(g,574504,612640,j,1)|0;if(A){do if((A|0)>0)Mic(l,g);else{E=c[j>>2]|0;if(!E)break;_n[E&4095](l,g)|0}while(0);sdd(g)}if(!(c[g>>2]&512)){J=0;K=213;break}Wic((c[x>>2]|0)+8|0);odc(k);H=k;I=0;break}c[n>>2]=0;l=n+8|0;c[l>>2]=0;A=n+12|0;c[A>>2]=0;t=n+4|0;c[t>>2]=60;c[o>>2]=0;E=o+8|0;c[E>>2]=0;z=o+12|0;c[z>>2]=0;B=o+4|0;c[B>>2]=60;c[p>>2]=0;u=p+8|0;c[u>>2]=0;F=p+12|0;c[F>>2]=0;D=p+4|0;c[D>>2]=60;c[q>>2]=0;C=q+8|0;c[C>>2]=0;G=q+12|0;c[G>>2]=0;L=q+4|0;c[L>>2]=60;c[r>>2]=0;M=r+8|0;c[M>>2]=0;N=r+12|0;c[N>>2]=0;O=r+4|0;c[O>>2]=60;c[s>>2]=0;P=s+8|0;c[P>>2]=0;Q=s+12|0;c[Q>>2]=0;R=s+4|0;c[R>>2]=60;S=qdd(g,574440,y,j,1)|0;if(S){if((S|0)<=0){S=c[j>>2]|0;if(S)_n[S&4095](o,g)|0}else R6b(g,o,0);sdd(g)}S=qdd(g,574456,y,j,1)|0;if(S){do if((S|0)>0)ofc(g,q,0);else{T=c[j>>2]|0;if(!T)break;_n[T&4095](q,g)|0}while(0);sdd(g)}S=qdd(g,574464,y,j,1)|0;if(S){do if((S|0)>0)ofc(g,r,0);else{T=c[j>>2]|0;if(!T)break;_n[T&4095](r,g)|0}while(0);sdd(g)}S=qdd(g,574472,y,j,1)|0;if(S){do if((S|0)>0)pfc(g,n,0);else{T=c[j>>2]|0;if(!T)break;_n[T&4095](n,g)|0}while(0);sdd(g)}S=qdd(g,574488,y,j,1)|0;if(S){do if((S|0)>0)R6b(g,p,0);else{T=c[j>>2]|0;if(!T)break;_n[T&4095](p,g)|0}while(0);sdd(g)}S=qdd(g,621552,y,j,1)|0;if(S){do if((S|0)>0)qfc(g,s,0);else{T=c[j>>2]|0;if(!T)break;_n[T&4095](s,g)|0}while(0);sdd(g)}S=c[E>>2]|0;T=(S|0)!=0&1;U=(c[l>>2]|0)==0?T:T|128;T=(c[u>>2]|0)==0?U:U|2;U=(c[C>>2]|0)==0?T:T|8;T=(c[M>>2]|0)==0?U:U|16;U=(c[P>>2]|0)==0?T:T|4;T=c[x>>2]|0;if((c[T+100>>2]|0)==(S|0)?(c[T+96>>2]|0)==(U|0):0){V=S;W=T}else{do if(!(c[T+144>>2]|0)){if((c[f+92>>2]|0)!=(c[f+88>>2]|0)){K=131;break}Sic(j,T+8|0);c[j>>2]=(c[j+4>>2]&255^255)&~c[j+8>>2]&~c[j+12>>2];c[m+0>>2]=c[j+0>>2];c[m+4>>2]=c[j+4>>2];c[m+8>>2]=c[j+8>>2];c[m+12>>2]=c[j+12>>2]}else K=131;while(0);if((K|0)==131){c[m+0>>2]=c[143994];c[m+4>>2]=c[143995];c[m+8>>2]=c[143996];c[m+12>>2]=c[143997]}Qdc(f,S,U,0,575992,m);V=c[E>>2]|0;W=c[x>>2]|0}T=c[o>>2]|0;X=S>>>0<V>>>0?S:V;Y=a[W+11>>0]|0;do if((a[W+10>>0]|0)!=0|(Y&255)<3){Z=0;_=0}else{$=c[W+92>>2]|0;if(($|0)==0|Y<<24>>24==0){Z=1;_=0;break}aa=d[W+8>>0]|0;Z=d[W+(aa*12|0)+50>>0]|0;_=$+((d[W+9>>0]|0)+(c[W+(aa*12|0)+44>>2]|0))|0}while(0);Y=T+(X*12|0)|0;if(!X)ba=W;else{E=T;U=_;while(1){c[U+0>>2]=c[E+0>>2];c[U+4>>2]=c[E+4>>2];c[U+8>>2]=c[E+8>>2];E=E+12|0;if((E|0)==(Y|0))break;else U=U+Z|0}ba=c[x>>2]|0}U=c[p>>2]|0;Y=c[u>>2]|0;E=S>>>0<Y>>>0?S:Y;Y=a[ba+15>>0]|0;do if((a[ba+14>>0]|0)!=0|(Y&255)<3){ca=0;ea=0}else{T=c[ba+92>>2]|0;if((T|0)==0|Y<<24>>24==0){ca=1;ea=0;break}X=d[ba+12>>0]|0;ca=d[ba+(X*12|0)+50>>0]|0;ea=T+((d[ba+13>>0]|0)+(c[ba+(X*12|0)+44>>2]|0))|0}while(0);Y=U+(E*12|0)|0;if(!E)fa=ba;else{u=U;X=ea;while(1){c[X+0>>2]=c[u+0>>2];c[X+4>>2]=c[u+4>>2];c[X+8>>2]=c[u+8>>2];u=u+12|0;if((u|0)==(Y|0))break;else X=X+ca|0}fa=c[x>>2]|0}X=c[q>>2]|0;Y=c[C>>2]|0;u=S>>>0<Y>>>0?S:Y;Y=a[fa+23>>0]|0;do if((a[fa+22>>0]|0)!=0|(Y&255)<2){ga=0;ha=0}else{U=c[fa+92>>2]|0;if((U|0)==0|Y<<24>>24==0){ga=1;ha=0;break}E=d[fa+20>>0]|0;ga=d[fa+(E*12|0)+50>>0]|0;ha=U+((d[fa+21>>0]|0)+(c[fa+(E*12|0)+44>>2]|0))|0}while(0);Y=X+(u<<3)|0;if(!u)ia=fa;else{C=X;E=ha;while(1){U=C;T=c[U+4>>2]|0;aa=E;c[aa>>2]=c[U>>2];c[aa+4>>2]=T;C=C+8|0;if((C|0)==(Y|0))break;else E=E+ga|0}ia=c[x>>2]|0}E=c[r>>2]|0;Y=c[M>>2]|0;C=S>>>0<Y>>>0?S:Y;Y=a[ia+27>>0]|0;do if((a[ia+26>>0]|0)!=0|(Y&255)<2){ja=0;ka=0}else{X=c[ia+92>>2]|0;if((X|0)==0|Y<<24>>24==0){ja=1;ka=0;break}u=d[ia+24>>0]|0;ja=d[ia+(u*12|0)+50>>0]|0;ka=X+((d[ia+25>>0]|0)+(c[ia+(u*12|0)+44>>2]|0))|0}while(0);Y=E+(C<<3)|0;if(!C)la=ia;else{M=E;u=ka;while(1){X=M;T=c[X+4>>2]|0;aa=u;c[aa>>2]=c[X>>2];c[aa+4>>2]=T;M=M+8|0;if((M|0)==(Y|0))break;else u=u+ja|0}la=c[x>>2]|0}u=c[n>>2]|0;Y=c[l>>2]|0;M=S>>>0<Y>>>0?S:Y;Y=a[la+39>>0]|0;do if((a[la+38>>0]|0)!=0|(Y&255)<4){ma=0;na=0}else{E=c[la+92>>2]|0;if((E|0)==0|Y<<24>>24==0){ma=1;na=0;break}C=d[la+36>>0]|0;ma=d[la+(C*12|0)+50>>0]|0;na=E+((d[la+37>>0]|0)+(c[la+(C*12|0)+44>>2]|0))|0}while(0);Y=u+(M<<4)|0;if(!M)oa=la;else{l=u;C=na;while(1){c[C+0>>2]=c[l+0>>2];c[C+4>>2]=c[l+4>>2];c[C+8>>2]=c[l+8>>2];c[C+12>>2]=c[l+12>>2];l=l+16|0;if((l|0)==(Y|0))break;else C=C+ma|0}oa=c[x>>2]|0}C=c[s>>2]|0;Y=c[P>>2]|0;l=S>>>0<Y>>>0?S:Y;Y=a[oa+19>>0]|0;do if((a[oa+18>>0]|0)!=2|(Y&255)<4){pa=0;qa=0}else{u=c[oa+92>>2]|0;if((u|0)==0|Y<<24>>24==0){pa=1;qa=0;break}M=d[oa+16>>0]|0;pa=d[oa+(M*12|0)+50>>0]|0;qa=u+((d[oa+17>>0]|0)+(c[oa+(M*12|0)+44>>2]|0))|0}while(0);Y=C+(l<<2)|0;if(l){S=C;P=qa;while(1){c[P>>2]=c[S>>2];S=S+4|0;if((S|0)==(Y|0))break;else P=P+pa|0}}if((c[Q>>2]|0)>-1){c[k>>2]=c[R>>2];c[j+0>>2]=c[k+0>>2];eOb(C,j);c[s>>2]=0}if((c[N>>2]|0)>-1){P=c[r>>2]|0;c[k>>2]=c[O>>2];c[j+0>>2]=c[k+0>>2];eOb(P,j);c[r>>2]=0}if((c[G>>2]|0)>-1){P=c[q>>2]|0;c[k>>2]=c[L>>2];c[j+0>>2]=c[k+0>>2];eOb(P,j);c[q>>2]=0}if((c[F>>2]|0)>-1){P=c[p>>2]|0;c[k>>2]=c[D>>2];c[j+0>>2]=c[k+0>>2];eOb(P,j);c[p>>2]=0}if((c[z>>2]|0)>-1){P=c[o>>2]|0;c[k>>2]=c[B>>2];c[j+0>>2]=c[k+0>>2];eOb(P,j);c[o>>2]=0}if((c[A>>2]|0)<=-1){J=0;K=213;break}P=c[n>>2]|0;c[k>>2]=c[t>>2];c[j+0>>2]=c[k+0>>2];eOb(P,j);c[n>>2]=0;odc(k);H=k;I=0}while(0);if((K|0)==213){odc(k);H=k;I=J}J=qdd(g,574520,575280,j,1)|0;if(J){if((J|0)<=0){J=c[j>>2]|0;if(J)_n[J&4095](H,g)|0}else rfc(k,g);sdd(g)}if(I?(a[g+136>>0]|0)!=0:0)qdc(k,f);efc(k);if(!w){w=c[x>>2]|0;x=a[w+19>>0]|0;if(!((a[w+18>>0]|0)!=2|(x&255)<4)){k=c[w+92>>2]|0;if((k|0)==0|x<<24>>24==0){ra=1;sa=0}else{I=d[w+16>>0]|0;ra=d[w+(I*12|0)+50>>0]|0;sa=k+((d[w+17>>0]|0)+(c[w+(I*12|0)+44>>2]|0))|0}I=c[w+92>>2]|0;if((I|0)==0|x<<24>>24==0)ta=0;else{k=d[w+16>>0]|0;ta=I+((da(d[w+(k*12|0)+50>>0]|0,c[w+100>>2]|0)|0)+(c[w+(k*12|0)+44>>2]|0)+(d[w+17>>0]|0))|0}k=c[w+92>>2]|0;if((k|0)==0|x<<24>>24==0){ua=1;va=0}else{x=d[w+16>>0]|0;ua=d[w+(x*12|0)+50>>0]|0;va=k+((d[w+17>>0]|0)+(c[w+(x*12|0)+44>>2]|0))|0}if((sa|0)!=(ta|0)){x=sa;sa=va;while(1){c[sa>>2]=d[x+1>>0]<<8|d[x+2>>0]|d[x>>0]<<16|d[x+3>>0]<<24;x=x+ra|0;if((x|0)==(ta|0))break;else sa=sa+ua|0}}}a[v>>0]=1}v=f+168|0;ua=qdd(g,574544,614728,j,1)|0;if(ua){if((ua|0)<=0){ua=c[j>>2]|0;if(ua)_n[ua&4095](v,g)|0}else _cc(v,g);sdd(g)}v=f+40|0;ua=qdd(g,574560,c[142270]|0,j,0)|0;if(!ua){wa=f+192|0;sfc(wa,g,f);i=h;return}if((ua|0)>0){ua=g+12|0;sa=c[g+16>>2]|0;ta=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;x=sa+ta|0;c[ua>>2]=x;if((ta|0)>=0?(ra=sa+(ta+4)|0,ra>>>0<=(c[g+20>>2]|0)>>>0):0){c[v>>2]=c[x>>2];c[ua>>2]=ra}else Bid(ua,v,4);if(c[g>>2]&512)c[v>>2]=XEi(c[v>>2]|0)|0}else{ua=c[j>>2]|0;if(ua)_n[ua&4095](v,g)|0}sdd(g);wa=f+192|0;sfc(wa,g,f);i=h;return}function Mec(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+384|0;g=f+136|0;h=f+132|0;j=f+32|0;k=f+16|0;l=f;zWb(b,e);m=b+276|0;n=(a[m>>0]|0)==0;Jdc(b,1);tfc(e,b+44|0,0);ufc(e,b+56|0,0);vfc(e,b+72|0,0);wfc(e,b+88|0,0);adc(e,b+100|0,0);o=b+28|0;xfc(e,(c[o>>2]|0)+120|0,0);yfc(e,b+116|0,0);p=b+132|0;q=e+12|0;r=c[q>>2]|0;s=r+4|0;t=e+20|0;u=c[t>>2]|0;if(s>>>0>u>>>0){Bid(q,p,4);v=c[q>>2]|0;w=c[t>>2]|0}else{c[p>>2]=c[r>>2];c[q>>2]=s;v=s;w=u}u=b+32|0;if((v+1|0)>>>0>w>>>0){Bid(q,u,1);x=c[q>>2]|0}else{a[u>>0]=a[v>>0]|0;v=(c[q>>2]|0)+1|0;c[q>>2]=v;x=v}v=b+33|0;if((x+1|0)>>>0>(c[t>>2]|0)>>>0){Bid(q,v,1);y=c[q>>2]|0}else{a[v>>0]=a[x>>0]|0;x=(c[q>>2]|0)+1|0;c[q>>2]=x;y=x}x=b+34|0;if((y+1|0)>>>0>(c[t>>2]|0)>>>0){Bid(q,x,1);z=c[q>>2]|0}else{a[x>>0]=a[y>>0]|0;y=(c[q>>2]|0)+1|0;c[q>>2]=y;z=y}y=b+35|0;if((z+1|0)>>>0>(c[t>>2]|0)>>>0)Bid(q,y,1);else{a[y>>0]=a[z>>0]|0;c[q>>2]=(c[q>>2]|0)+1}Ndd(e);if((a[u>>0]|0)!=0?(c[e>>2]&16384|0)==0:0){c[k>>2]=0;c[k+8>>2]=0;u=k+12|0;c[u>>2]=0;z=k+4|0;c[z>>2]=60;Tic(j);c[l>>2]=0;y=l+4|0;c[y>>2]=0;c[l+8>>2]=0;zfc(e,l,0);Ndd(e);Afc(e,k,0);Nic(j,e);x=c[l>>2]|0;if(x){if((c[y>>2]|0)!=(x|0))c[y>>2]=x;c[h>>2]=8;c[g+0>>2]=c[h+0>>2];eOb(x,g)}Uic(j);if((c[u>>2]|0)>-1){u=c[k>>2]|0;c[j>>2]=c[z>>2];c[g+0>>2]=c[j+0>>2];eOb(u,g);c[k>>2]=0;A=1}else A=1}else{zfc(e,(c[o>>2]|0)+108|0,0);Ndd(e);Afc(e,(c[o>>2]|0)+136|0,0);Nic((c[o>>2]|0)+8|0,e);A=0}odc(g);Ndd(e);Bfc(g,e);if(A)qdc(g,b);efc(g);if(!n){n=c[o>>2]|0;o=a[n+19>>0]|0;if(!((a[n+18>>0]|0)!=2|(o&255)<4)){g=c[n+92>>2]|0;if((g|0)==0|o<<24>>24==0){B=1;C=0}else{A=d[n+16>>0]|0;B=d[n+(A*12|0)+50>>0]|0;C=g+((d[n+17>>0]|0)+(c[n+(A*12|0)+44>>2]|0))|0}A=c[n+92>>2]|0;if((A|0)==0|o<<24>>24==0)D=0;else{g=d[n+16>>0]|0;D=A+((da(d[n+(g*12|0)+50>>0]|0,c[n+100>>2]|0)|0)+(c[n+(g*12|0)+44>>2]|0)+(d[n+17>>0]|0))|0}g=c[n+92>>2]|0;if((g|0)==0|o<<24>>24==0){E=1;F=0}else{o=d[n+16>>0]|0;E=d[n+(o*12|0)+50>>0]|0;F=g+((d[n+17>>0]|0)+(c[n+(o*12|0)+44>>2]|0))|0}if((C|0)!=(D|0)){o=C;C=F;while(1){c[C>>2]=d[o+1>>0]<<8|d[o+2>>0]|d[o>>0]<<16|d[o+3>>0]<<24;o=o+B|0;if((o|0)==(D|0))break;else C=C+E|0}}}a[m>>0]=1}cdc(b+168|0,e);m=b+40|0;E=c[q>>2]|0;C=E+4|0;if(C>>>0>(c[t>>2]|0)>>>0){Bid(q,m,4);G=b+192|0;Cfc(G,e,b);i=f;return}else{c[m>>2]=c[E>>2];c[q>>2]=C;G=b+192|0;Cfc(G,e,b);i=f;return}}function Nec(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=i;i=i+384|0;j=h+136|0;k=h+132|0;l=h+32|0;m=h+16|0;n=h;AWb(f,g);o=f+276|0;p=(a[o>>0]|0)==0;Jdc(f,1);Dfc(g,f+44|0,0);Efc(g,f+56|0,0);Ffc(g,f+72|0,0);Gfc(g,f+88|0,0);edc(g,f+100|0,0);q=f+28|0;Hfc(g,(c[q>>2]|0)+120|0,0);Ifc(g,f+116|0,0);r=f+132|0;s=g+12|0;t=c[s>>2]|0;u=t+4|0;v=g+20|0;w=c[v>>2]|0;if(u>>>0>w>>>0){Bid(s,r,4);x=c[r>>2]|0;y=c[s>>2]|0;z=c[v>>2]|0}else{A=c[t>>2]|0;c[r>>2]=A;c[s>>2]=u;x=A;y=u;z=w}c[r>>2]=XEi(x|0)|0;x=f+32|0;if((y+1|0)>>>0>z>>>0){Bid(s,x,1);B=c[s>>2]|0}else{a[x>>0]=a[y>>0]|0;y=(c[s>>2]|0)+1|0;c[s>>2]=y;B=y}y=f+33|0;if((B+1|0)>>>0>(c[v>>2]|0)>>>0){Bid(s,y,1);C=c[s>>2]|0}else{a[y>>0]=a[B>>0]|0;B=(c[s>>2]|0)+1|0;c[s>>2]=B;C=B}B=f+34|0;if((C+1|0)>>>0>(c[v>>2]|0)>>>0){Bid(s,B,1);D=c[s>>2]|0}else{a[B>>0]=a[C>>0]|0;C=(c[s>>2]|0)+1|0;c[s>>2]=C;D=C}C=f+35|0;if((D+1|0)>>>0>(c[v>>2]|0)>>>0)Bid(s,C,1);else{a[C>>0]=a[D>>0]|0;c[s>>2]=(c[s>>2]|0)+1}Mdd(g);if((a[x>>0]|0)!=0?(c[g>>2]&16384|0)==0:0){c[m>>2]=0;c[m+8>>2]=0;x=m+12|0;c[x>>2]=0;D=m+4|0;c[D>>2]=60;Tic(l);c[n>>2]=0;C=n+4|0;c[C>>2]=0;c[n+8>>2]=0;Jfc(g,n,0);Mdd(g);Kfc(g,m,0);Oic(l,g);B=c[n>>2]|0;if(B){if((c[C>>2]|0)!=(B|0))c[C>>2]=B;c[k>>2]=8;c[j+0>>2]=c[k+0>>2];eOb(B,j)}Uic(l);if((c[x>>2]|0)>-1){x=c[m>>2]|0;c[l>>2]=c[D>>2];c[j+0>>2]=c[l+0>>2];eOb(x,j);c[m>>2]=0;E=1}else E=1}else{Jfc(g,(c[q>>2]|0)+108|0,0);Mdd(g);m=c[q>>2]|0;x=c[m+108>>2]|0;l=((c[m+112>>2]|0)-x|0)>>>1;if(l){D=0;B=x;while(1){x=e[B>>1]|0;b[B>>1]=x<<8|x>>>8;D=D+1|0;if((D|0)==(l|0))break;else B=B+2|0}}Kfc(g,m+136|0,0);Oic((c[q>>2]|0)+8|0,g);Wic((c[q>>2]|0)+8|0);E=0}odc(j);Mdd(g);Lfc(j,g);if(E)qdc(j,f);efc(j);if(!p){p=c[q>>2]|0;q=a[p+19>>0]|0;if(!((a[p+18>>0]|0)!=2|(q&255)<4)){j=c[p+92>>2]|0;if((j|0)==0|q<<24>>24==0){F=1;G=0}else{E=d[p+16>>0]|0;F=d[p+(E*12|0)+50>>0]|0;G=j+((d[p+17>>0]|0)+(c[p+(E*12|0)+44>>2]|0))|0}E=c[p+92>>2]|0;if((E|0)==0|q<<24>>24==0)H=0;else{j=d[p+16>>0]|0;H=E+((da(d[p+(j*12|0)+50>>0]|0,c[p+100>>2]|0)|0)+(c[p+(j*12|0)+44>>2]|0)+(d[p+17>>0]|0))|0}j=c[p+92>>2]|0;if((j|0)==0|q<<24>>24==0){I=1;J=0}else{q=d[p+16>>0]|0;I=d[p+(q*12|0)+50>>0]|0;J=j+((d[p+17>>0]|0)+(c[p+(q*12|0)+44>>2]|0))|0}if((G|0)!=(H|0)){q=G;G=J;while(1){c[G>>2]=d[q+1>>0]<<8|d[q+2>>0]|d[q>>0]<<16|d[q+3>>0]<<24;q=q+F|0;if((q|0)==(H|0))break;else G=G+I|0}}}a[o>>0]=1}gdc(f+168|0,g);o=f+40|0;I=c[s>>2]|0;G=I+4|0;if(G>>>0>(c[v>>2]|0)>>>0){Bid(s,o,4);K=c[o>>2]|0;L=XEi(K|0)|0;c[o>>2]=L;M=f+192|0;Mfc(M,g,f);i=h;return}else{v=c[I>>2]|0;c[o>>2]=v;c[s>>2]=G;K=v;L=XEi(K|0)|0;c[o>>2]=L;M=f+192|0;Mfc(M,g,f);i=h;return}}function Oec(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+352|0;g=f+100|0;h=f;BWb(b,e);j=b+276|0;k=(a[j>>0]|0)==0;Jdc(b,1);l=b+48|0;m=c[l>>2]|0;n=b+44|0;o=c[n>>2]|0;p=(m-o|0)/56|0;c[g>>2]=p;q=e+12|0;r=c[q>>2]|0;s=r+4|0;t=e+20|0;if(s>>>0<(c[t>>2]|0)>>>0){c[r>>2]=p;c[q>>2]=s;u=o;v=m}else{Gid(q,g,4);u=c[n>>2]|0;v=c[l>>2]|0}if((u|0)!=(v|0)){l=u;do{Nfc(l,e);l=l+56|0}while((l|0)!=(v|0))}Ofc(b+56|0,e);v=b+28|0;l=c[v>>2]|0;u=l+128|0;n=c[u>>2]|0;c[g>>2]=n;m=c[q>>2]|0;o=m+4|0;if(o>>>0<(c[t>>2]|0)>>>0){c[m>>2]=n;c[q>>2]=o}else Gid(q,g,4);o=c[l+120>>2]|0;l=c[u>>2]|0;u=o+(l<<6)|0;if(l){l=o;do{Pfc(l,e);l=l+64|0}while((l|0)!=(u|0))}u=b+124|0;l=c[u>>2]|0;c[g>>2]=l;o=c[q>>2]|0;n=o+4|0;if(n>>>0<(c[t>>2]|0)>>>0){c[o>>2]=l;c[q>>2]=n}else Gid(q,g,4);n=c[b+116>>2]|0;l=c[u>>2]|0;u=n+(l<<2)|0;if(l){l=n;do{n=c[q>>2]|0;o=n+4|0;if(o>>>0<(c[t>>2]|0)>>>0){c[n>>2]=c[l>>2];c[q>>2]=o}else Gid(q,l,4);l=l+4|0}while((l|0)!=(u|0))}u=b+132|0;l=c[q>>2]|0;o=l+4|0;n=c[t>>2]|0;if(o>>>0<n>>>0){c[l>>2]=c[u>>2];c[q>>2]=o;w=o;x=n}else{Gid(q,u,4);w=c[q>>2]|0;x=c[t>>2]|0}u=b+32|0;if((w+1|0)>>>0<x>>>0){a[w>>0]=a[u>>0]|0;w=(c[q>>2]|0)+1|0;c[q>>2]=w;y=w}else{Gid(q,u,1);y=c[q>>2]|0}w=b+33|0;if((y+1|0)>>>0<(c[t>>2]|0)>>>0){a[y>>0]=a[w>>0]|0;y=(c[q>>2]|0)+1|0;c[q>>2]=y;z=y}else{Gid(q,w,1);z=c[q>>2]|0}w=b+34|0;if((z+1|0)>>>0<(c[t>>2]|0)>>>0){a[z>>0]=a[w>>0]|0;z=(c[q>>2]|0)+1|0;c[q>>2]=z;A=z}else{Gid(q,w,1);A=c[q>>2]|0}w=b+35|0;if((A+1|0)>>>0<(c[t>>2]|0)>>>0){a[A>>0]=a[w>>0]|0;c[q>>2]=(c[q>>2]|0)+1}else Gid(q,w,1);Tdd(e);if((a[u>>0]|0)!=0?(c[e>>2]&16384|0)==0:0){Tic(h);c[g>>2]=0;w=c[q>>2]|0;A=w+4|0;if(A>>>0<(c[t>>2]|0)>>>0){c[w>>2]=0;c[q>>2]=A}else Gid(q,g,4);Tdd(e);c[g>>2]=0;A=c[q>>2]|0;w=A+4|0;if(w>>>0<(c[t>>2]|0)>>>0){c[A>>2]=0;c[q>>2]=w}else Gid(q,g,4);Pic(h,e);Uic(h);c[h>>2]=60;c[g+0>>2]=c[h+0>>2];eOb(0,g);B=1}else{h=c[v>>2]|0;w=h+112|0;A=c[w>>2]|0;z=h+108|0;h=c[z>>2]|0;y=A-h|0;c[g>>2]=y;x=c[q>>2]|0;n=x+4|0;if(n>>>0<(c[t>>2]|0)>>>0){c[x>>2]=y;c[q>>2]=n;C=h;D=A}else{Gid(q,g,4);C=c[z>>2]|0;D=c[w>>2]|0}if((C|0)!=(D|0)){w=C;do{C=c[q>>2]|0;if((C+1|0)>>>0<(c[t>>2]|0)>>>0){a[C>>0]=a[w>>0]|0;c[q>>2]=(c[q>>2]|0)+1}else Gid(q,w,1);w=w+1|0}while((w|0)!=(D|0))}Tdd(e);D=c[v>>2]|0;w=D+144|0;C=c[w>>2]|0;c[g>>2]=C;z=c[q>>2]|0;A=z+4|0;if(A>>>0<(c[t>>2]|0)>>>0){c[z>>2]=C;c[q>>2]=A}else Gid(q,g,4);A=c[D+136>>2]|0;D=c[w>>2]|0;w=A+(D<<5)|0;if(D){D=A;do{Qfc(D,e);D=D+32|0}while((D|0)!=(w|0))}Pic((c[v>>2]|0)+8|0,e);B=0}odc(g);Tdd(e);if(B)pdc(g,b,rdc(d[u>>0]|0)|0);Rfc(g,e);efc(g);if(!k){k=c[v>>2]|0;v=a[k+19>>0]|0;do if(!((a[k+18>>0]|0)!=2|(v&255)<4)){g=c[k+92>>2]|0;if((g|0)==0|v<<24>>24==0){E=1;F=0}else{u=d[k+16>>0]|0;E=d[k+(u*12|0)+50>>0]|0;F=g+((d[k+17>>0]|0)+(c[k+(u*12|0)+44>>2]|0))|0}u=c[k+92>>2]|0;if((u|0)==0|v<<24>>24==0)G=0;else{g=d[k+16>>0]|0;G=u+((da(d[k+(g*12|0)+50>>0]|0,c[k+100>>2]|0)|0)+(c[k+(g*12|0)+44>>2]|0)+(d[k+17>>0]|0))|0}g=c[k+92>>2]|0;if((g|0)==0|v<<24>>24==0){H=1;I=0}else{u=d[k+16>>0]|0;H=d[k+(u*12|0)+50>>0]|0;I=g+((d[k+17>>0]|0)+(c[k+(u*12|0)+44>>2]|0))|0}if((F|0)==(G|0))break;else{J=F;K=I}while(1){c[K>>2]=d[J+1>>0]<<8|d[J+2>>0]|d[J>>0]<<16|d[J+3>>0]<<24;J=J+E|0;if((J|0)==(G|0))break;else K=K+H|0}}while(0);a[j>>0]=1}jdc(b+168|0,e);j=b+40|0;H=c[q>>2]|0;K=H+4|0;if(K>>>0<(c[t>>2]|0)>>>0){c[H>>2]=c[j>>2];c[q>>2]=K;L=b+192|0;Sfc(L,e,b);i=f;return}else{Gid(q,j,4);L=b+192|0;Sfc(L,e,b);i=f;return}}function Pec(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+352|0;g=f+248|0;h=f+244|0;j=f;CWb(b,e);k=b+276|0;l=(a[k>>0]|0)==0;Jdc(b,1);m=b+28|0;if((a[b+32>>0]|0)!=0?(c[e>>2]&16384|0)==0:0){Tic(g);idd(e,1);Qic(g,e);jdd(e);Uic(g);c[h>>2]=60;c[g+0>>2]=c[h+0>>2];eOb(0,g);odc(j);n=j}else{b=(c[m>>2]|0)+8|0;idd(e,1);Qic(b,e);jdd(e);odc(j);n=j}idd(e,1);jdd(e);efc(j);if(l){o=c[153134]|0;c[h>>2]=o;c[g+0>>2]=c[h+0>>2];eOb(0,g);c[h>>2]=o;c[g+0>>2]=c[h+0>>2];eOb(0,g);i=f;return}l=c[m>>2]|0;m=a[l+19>>0]|0;if(!((a[l+18>>0]|0)!=2|(m&255)<4)){j=c[l+92>>2]|0;if((j|0)==0|m<<24>>24==0){p=1;q=0}else{e=d[l+16>>0]|0;p=d[l+(e*12|0)+50>>0]|0;q=j+((d[l+17>>0]|0)+(c[l+(e*12|0)+44>>2]|0))|0}e=c[l+92>>2]|0;if((e|0)==0|m<<24>>24==0)r=0;else{j=d[l+16>>0]|0;r=e+((da(d[l+(j*12|0)+50>>0]|0,c[l+100>>2]|0)|0)+(c[l+(j*12|0)+44>>2]|0)+(d[l+17>>0]|0))|0}j=c[l+92>>2]|0;if((j|0)==0|m<<24>>24==0){s=0;t=1}else{m=d[l+16>>0]|0;s=j+((d[l+17>>0]|0)+(c[l+(m*12|0)+44>>2]|0))|0;t=d[l+(m*12|0)+50>>0]|0}if((q|0)!=(r|0)){m=q;q=s;while(1){c[q>>2]=d[m+1>>0]<<8|d[m+2>>0]|d[m>>0]<<16|d[m+3>>0]<<24;m=m+p|0;if((m|0)==(r|0))break;else q=q+t|0}}}a[k>>0]=1;o=c[153134]|0;c[h>>2]=o;c[g+0>>2]=c[h+0>>2];eOb(0,g);c[h>>2]=o;c[g+0>>2]=c[h+0>>2];eOb(0,g);i=f;return}function Qec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)c[n>>2]=0;m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>2>>>0<1073741823){h=k>>1;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=(c[j>>2]|0)-l>>2;t=11}if((t|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r<<2,16,e,0,3653512,80)|0;q=s}s=b;r=p+(q<<2)|0;while(1){if(r)c[r>>2]=0;s=s+-1|0;if(!s)break;else r=r+4|0}r=c[a>>2]|0;s=(c[j>>2]|0)-r|0;t=p+(q-(s>>2)<<2)|0;YEi(t|0,r|0,s|0)|0;s=c[a>>2]|0;c[a>>2]=t;c[j>>2]=p+(q+b<<2);c[g>>2]=p+(o<<2);if(!s){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function Rec(a,b,d,f,g){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=i;i=i+16|0;j=h+4|0;k=h;l=c[b>>2]|0;m=l;n=(c[d>>2]|0)-m>>2;d=l+(n<<2)|0;o=f;p=g-o|0;q=p>>1;if((p|0)<=0){r=d;c[a>>2]=r;i=h;return}p=b+8|0;s=c[p>>2]|0;t=b+4|0;u=c[t>>2]|0;v=u;if((q|0)>(s-v>>2|0)){w=(v-m>>2)+q|0;if((w|0)<0)vxi(b);m=l;x=s-m|0;if(x>>2>>>0<1073741823){s=x>>1;x=s>>>0<w>>>0?w:s;s=d;w=s-m>>2;if(!x){y=0;z=s;A=0;B=w}else{C=x;D=w;E=s;F=24}}else{s=d;C=2147483647;D=s-m>>2;E=s;F=24}if((F|0)==24){c[k>>2]=89;c[j+0>>2]=c[k+0>>2];y=C;z=E;A=cOb(C<<2,16,j,0,3653512,80)|0;B=D}D=A+(B<<2)|0;C=A+(y<<2)|0;if((f|0)==(g|0)){G=D;H=B}else{y=(g+-2-o|0)>>>1;o=f;E=D;while(1){if(E)c[E>>2]=e[o>>1];o=o+2|0;if((o|0)==(g|0))break;else E=E+4|0}E=y+1+B|0;G=A+(E<<2)|0;H=E}E=c[b>>2]|0;y=z-E|0;o=A+(B-(y>>2)<<2)|0;YEi(o|0,E|0,y|0)|0;y=(c[t>>2]|0)-z|0;YEi(G|0,d|0,y|0)|0;G=c[b>>2]|0;c[b>>2]=o;c[t>>2]=A+((y>>2)+H<<2);c[p>>2]=C;if(!G){r=D;c[a>>2]=r;i=h;return}c[k>>2]=89;c[j+0>>2]=c[k+0>>2];eOb(G,j);r=D;c[a>>2]=r;i=h;return}D=d;j=v-D>>2;if((q|0)>(j|0)){v=f+(j<<1)|0;if((v|0)==(g|0)){I=u;J=g;K=j}else{G=(g+-2-v|0)>>>1;k=v;C=u;while(1){if(C)c[C>>2]=e[k>>1];k=k+2|0;if((k|0)==(g|0))break;else C=C+4|0}C=u+(G+1<<2)|0;c[t>>2]=C;I=C;J=v;K=j}}else{I=u;J=g;K=q}if((K|0)<=0){r=d;c[a>>2]=r;i=h;return}K=I-(l+(n+q<<2))|0;q=K>>2;g=l+(q+n<<2)|0;n=0-q|0;if(g>>>0<u>>>0){q=(u+(n<<2)+~D|0)>>>2;D=I;l=g;while(1){if(D)c[D>>2]=c[l>>2];l=l+4|0;if(l>>>0>=u>>>0)break;else D=D+4|0}c[t>>2]=I+(q+1<<2)}aFi(I+(n<<2)|0,d|0,K|0)|0;if((J|0)==(f|0)){r=d;c[a>>2]=r;i=h;return}else{L=f;M=d}while(1){c[M>>2]=e[L>>1];L=L+2|0;if((L|0)==(J|0)){r=d;break}else M=M+4|0}c[a>>2]=r;i=h;return}function Sec(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+10272|0;g=f+20|0;h=f+16|0;j=f+24|0;k=f;c[k>>2]=e;Ksd(j,10240,d,k);k=SEi(j|0)|0;if(k>>>0>2147483631)ori(b);if(k>>>0<11){a[b>>0]=k<<1;l=b+1|0;YEi(l|0,j|0,k|0)|0;m=l+k|0;a[m>>0]=0;i=f;return}else{d=k+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(d,16,g,0,3653512,80)|0;c[b+8>>2]=h;c[b>>2]=d|1;c[b+4>>2]=k;l=h;YEi(l|0,j|0,k|0)|0;m=l+k|0;a[m>>0]=0;i=f;return}}function Tec(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=i;i=i+16|0;j=h+4|0;k=h;l=c[d>>2]|0;m=l;n=(c[e>>2]|0)-m|0;e=l+n|0;if(!f){o=e;c[b>>2]=o;i=h;return}p=d+8|0;q=c[p>>2]|0;r=d+4|0;s=c[r>>2]|0;t=s;if((q-t|0)>>>0<f>>>0){u=t-m+f|0;if((u|0)<0)vxi(d);m=l;v=q-m|0;if(v>>>0<1073741823){q=v<<1;v=q>>>0<u>>>0?u:q;q=e;u=q-m|0;if(!v){w=0;x=0;y=u;z=q}else{A=v;B=u;C=q;D=22}}else{q=e;A=2147483647;B=q-m|0;C=q;D=22}if((D|0)==22){c[k>>2]=8;c[j+0>>2]=c[k+0>>2];w=A;x=cOb(A,16,j,0,3653512,80)|0;y=B;z=C}C=x+y|0;B=f;A=C;while(1){if(!A)E=0;else{a[A>>0]=a[g>>0]|0;E=A}D=E+1|0;B=B+-1|0;if(!B){F=E;G=D;break}else A=D}A=c[d>>2]|0;E=z-A|0;B=x+(y-E)|0;YEi(B|0,A|0,E|0)|0;E=(c[r>>2]|0)-z|0;YEi(G|0,e|0,E|0)|0;G=c[d>>2]|0;c[d>>2]=B;c[r>>2]=F+(E+1);c[p>>2]=x+w;if(!G){o=C;c[b>>2]=o;i=h;return}c[k>>2]=8;c[j+0>>2]=c[k+0>>2];eOb(G,j);o=C;c[b>>2]=o;i=h;return}C=t-e|0;if(C>>>0<f>>>0){t=f-C|0;j=s;while(1){if(!j)H=0;else{a[j>>0]=a[g>>0]|0;H=c[r>>2]|0}G=H+1|0;c[r>>2]=G;t=t+-1|0;if(!t){I=C;J=G;break}else j=G}}else{I=f;J=s}if(!I){o=e;c[b>>2]=o;i=h;return}j=J-(l+(n+f))|0;C=l+(j+n)|0;if(C>>>0<s>>>0){n=J;l=C;do{if(!n)K=0;else{a[n>>0]=a[l>>0]|0;K=c[r>>2]|0}l=l+1|0;n=K+1|0;c[r>>2]=n}while((l|0)!=(s|0))}aFi(J+(0-j)|0,e|0,j|0)|0;if(e>>>0<=g>>>0?(c[r>>2]|0)>>>0>g>>>0:0)L=g+f|0;else L=g;PEi(e|0,a[L>>0]|0,I|0)|0;o=e;c[b>>2]=o;i=h;return}function Uec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+8|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/56|0)>>>0>=b>>>0){m=e+12|0;n=b;o=k;do{if(!o)p=0;else{k=o+32|0;q=o+0|0;r=q+56|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];c[m+0>>2]=c[150284];c[m+4>>2]=c[150285];c[m+8>>2]=c[150286];c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[k+16>>2]=c[e+16>>2];c[k+20>>2]=c[e+20>>2];p=c[j>>2]|0}o=p+56|0;c[j>>2]=o;n=n+-1|0}while((n|0)!=0);i=d;return}n=c[a>>2]|0;o=((l-n|0)/56|0)+b|0;if((o|0)<0)vxi(a);l=n;n=(h-l|0)/56|0;if(n>>>0<1073741823){h=n<<1;n=h>>>0<o>>>0?o:h;h=((c[j>>2]|0)-l|0)/56|0;if(!n){s=0;t=0;u=h}else{v=n;w=h;x=11}}else{v=2147483647;w=((c[j>>2]|0)-l|0)/56|0;x=11}if((x|0)==11){c[f>>2]=10;c[e+0>>2]=c[f+0>>2];s=v;t=cOb(v*56|0,16,e,0,3653512,80)|0;u=w}w=e+12|0;v=b;b=t+(u*56|0)|0;while(1){if(!b)y=0;else{x=b+32|0;q=b+0|0;r=q+56|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];c[w+0>>2]=c[150284];c[w+4>>2]=c[150285];c[w+8>>2]=c[150286];c[x+0>>2]=c[e+0>>2];c[x+4>>2]=c[e+4>>2];c[x+8>>2]=c[e+8>>2];c[x+12>>2]=c[e+12>>2];c[x+16>>2]=c[e+16>>2];c[x+20>>2]=c[e+20>>2];y=b}k=y+56|0;v=v+-1|0;if(!v){z=k;break}else b=k}b=c[a>>2]|0;v=(c[j>>2]|0)-b|0;y=t+((((v|0)/-56|0)+u|0)*56|0)|0;YEi(y|0,b|0,v|0)|0;v=c[a>>2]|0;c[a>>2]=y;c[j>>2]=z;c[g>>2]=t+(s*56|0);if(!v){i=d;return}c[f>>2]=10;c[e+0>>2]=c[f+0>>2];eOb(v,e);i=d;return}function Vec(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/56|0)>>>0>=b>>>0){n=b;o=l;do{if(!o)p=0;else{q=o+0|0;r=d+0|0;s=q+56|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));p=c[k>>2]|0}o=p+56|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[a>>2]|0;o=((m-n|0)/56|0)+b|0;if((o|0)<0)vxi(a);m=n;n=(j-m|0)/56|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=((c[k>>2]|0)-m|0)/56|0;if(!n){t=0;u=0;v=j}else{w=n;x=j;y=11}}else{w=2147483647;x=((c[k>>2]|0)-m|0)/56|0;y=11}if((y|0)==11){c[g>>2]=10;c[f+0>>2]=c[g+0>>2];t=w;u=cOb(w*56|0,16,f,0,3653512,80)|0;v=x}x=b;b=u+(v*56|0)|0;while(1){if(!b)z=0;else{q=b+0|0;r=d+0|0;s=q+56|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));z=b}w=z+56|0;x=x+-1|0;if(!x){A=w;break}else b=w}b=c[a>>2]|0;x=(c[k>>2]|0)-b|0;z=u+((((x|0)/-56|0)+v|0)*56|0)|0;YEi(z|0,b|0,x|0)|0;x=c[a>>2]|0;c[a>>2]=z;c[k>>2]=A;c[h>>2]=u+(t*56|0);if(!x){i=e;return}c[g>>2]=10;c[f+0>>2]=c[g+0>>2];eOb(x,f);i=e;return}function Wec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=573720;f=a+192|0;hcc(f);uec(a+232|0);g=a+212|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;gcc(f);if((c[a+148>>2]|0)>-1){f=a+136|0;g=c[f>>2]|0;c[e>>2]=c[a+140>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+128>>2]|0)>-1){f=a+116|0;g=c[f>>2]|0;c[e>>2]=c[a+120>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}Iec(a+56|0);f=c[a+44>>2]|0;if(!f){EWb(a);i=b;return}g=a+48|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~(((h+-56-f|0)>>>0)/56|0)*56|0);c[e>>2]=10;c[d+0>>2]=c[e+0>>2];eOb(f,d);EWb(a);i=b;return}function Xec(a){a=a|0;var b=0;b=i;Wec(a);ACi(a);i=b;return}function Yec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=575424;Tfc(a+120|0);f=c[a+108>>2]|0;if(!f){g=a+8|0;Uic(g);i=b;return}h=a+112|0;if((c[h>>2]|0)!=(f|0))c[h>>2]=f;c[e>>2]=8;c[d+0>>2]=c[e+0>>2];eOb(f,d);g=a+8|0;Uic(g);i=b;return}function Zec(a){a=a|0;var b=0;b=i;Yec(a);ACi(a);i=b;return}function _ec(a){a=a|0;return}function $ec(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function afc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;ddd(b,2);e=c[142304]|0;add(b,575200,e,a+4|0,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575216,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575232,c[142270]|0,a,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575144,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2533664,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);g=a+32|0;add(b,575248,614728,g,0);gfc(b,g,2490904,0);gfc(b,a+44|0,614664,0);bdd(b);i=d;return}function bfc(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+40|0;j=g;add(a,e,575328,d,f);f=c[142306]|0;add(a,2533712,f,d,0);c[j+0>>2]=c[150284];c[j+4>>2]=c[150285];c[j+8>>2]=c[150286];e=j+12|0;c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];k=j+24|0;c[k+0>>2]=c[150284];c[k+4>>2]=c[150285];c[k+8>>2]=c[150286];l=j+36|0;c[l>>2]=0;$cd(a,2646336,2646336,h,0);add(a,3142592,575384,j,0);gfc(a,j,575192,0);gfc(a,e,2504600,0);gfc(a,k,2504728,0);add(a,2984400,c[142304]|0,l,0);l=a+12|0;k=a+20|0;c[(c[c[l>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);cdd(a);bdd(a);add(a,575072,f,d+16|0,0);c[j+0>>2]=0;c[j+4>>2]=0;b[j+8>>1]=0;$cd(a,2646336,2646336,h,0);add(a,3142592,575368,j,0);Ufc(j,a);bdd(a);cdd(a);bdd(a);Vfc(a,d+32|0,575080,0);add(a,575096,f,d+44|0,0);$cd(a,2646336,2646336,h,0);add(a,3142592,c[142268]|0,j,0);c[(c[c[l>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);cdd(a);bdd(a);bdd(a);i=g;return}function cfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142268]|0;add(b,574944,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574952,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574960,e,a+32|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574968,e,a+48|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574976,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574984,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574992,e,a+36|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575e3,e,a+52|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575008,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575016,e,a+24|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142268]|0;add(b,575024,e,a+40|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575032,e,a+56|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575040,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575048,e,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575056,e,a+44|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575064,e,a+60|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function dfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142268]|0;add(b,574816,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574832,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574848,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574864,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142270]|0;add(b,574880,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574896,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574912,e,a+24|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574928,e,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function efc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+228>>2]|0;if(d){e=a+232|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+208>>2]|0;if(d){e=a+212|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+188>>2]|0;if(d){e=a+192|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+168>>2]|0;if(d){e=a+172|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+140>>2]|0;if(d){e=a+144|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+120>>2]|0;if(d){e=a+124|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+92>>2]|0;if(d){e=a+96|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+72>>2]|0;if(d){e=a+76|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+44>>2]|0;if(d){e=a+48|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+16>>2]|0;if(!d){i=b;return}e=a+20|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d);i=b;return}function ffc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;add(b,574440,575296,a,0);Wfc(a,b);bdd(b);e=a+28|0;add(b,574456,575296,e,0);Wfc(e,b);bdd(b);e=a+56|0;add(b,574488,575296,e,0);Wfc(e,b);bdd(b);e=a+104|0;add(b,574472,575296,e,0);Wfc(e,b);bdd(b);Xfc(b,a+180|0,574648,0);Xfc(b,a+84|0,574664,0);Xfc(b,a+132|0,574680,0);e=a+152|0;add(b,574696,575296,e,0);Wfc(e,b);bdd(b);Xfc(b,a+200|0,574712,0);Xfc(b,a+220|0,574728,0);add(b,574744,c[142304]|0,a+240|0,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function gfc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;add(a,d,c[142310]|0,b,e);e=c[($hd(a+16|0)|0)+20>>2]|2097152;d=a+12|0;g=a+20|0;c[(c[c[d>>2]>>2]|0)+((c[g>>2]|0)*24|0)+20>>2]=e;e=c[142268]|0;add(a,3143216,e,b,0);c[(c[c[d>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,3143224,e,b+4|0,0);c[(c[c[d>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,2416480,e,b+8|0,0);c[(c[c[d>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);i=f;return}function hfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;a=d+36|0;e=d+32|0;f=d+16|0;g=d;h=c[153134]|0;c[f>>2]=0;j=f+4|0;c[j>>2]=h;c[f+8>>2]=0;k=f+12|0;c[k>>2]=0;c[g>>2]=0;l=g+4|0;c[l>>2]=h;c[g+8>>2]=0;h=g+12|0;c[h>>2]=0;m=c[142306]|0;add(b,574584,m,f,1);$cd(b,2646336,2646336,a,0);n=c[142302]|0;add(b,3142592,n,e,0);o=b+12|0;p=b+20|0;c[(c[c[o>>2]>>2]|0)+((c[p>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,574616,m,g,1);$cd(b,2646336,2646336,a,0);add(b,3142592,n,e,0);c[(c[c[o>>2]>>2]|0)+((c[p>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);if((c[h>>2]|0)>-1){h=c[g>>2]|0;c[e>>2]=c[l>>2];c[a+0>>2]=c[e+0>>2];eOb(h,a);c[g>>2]=0}if((c[k>>2]|0)<=-1){i=d;return}k=c[f>>2]|0;c[e>>2]=c[j>>2];c[a+0>>2]=c[e+0>>2];eOb(k,a);c[f>>2]=0;i=d;return}function ifc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/56|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}Yfc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,575408,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Zfc(r,a);t=r+56|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,575408,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else Zfc(m,a);sdd(a)}m=m+56|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function jfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[142306]|0;g=qdd(b,2533712,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else _fc(b,a,0);sdd(b)}g=a+16|0;h=qdd(b,575072,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else $fc(b,g,0);sdd(b)}g=a+32|0;h=qdd(b,575080,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else agc(b,g,0);sdd(b)}g=a+44|0;a=qdd(b,575096,f,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}else Ycc(b,g,0);sdd(b);i=d;return}function kfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];bgc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<6)|0;do if(c[f>>2]|0){j=qdd(a,3142592,614736,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;cgc(r,a);t=r+64|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,614736,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else cgc(m,a);sdd(a)}m=m+64|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function lfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];dgc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<2)|0;do if(c[f>>2]|0){j=c[142304]|0;g=qdd(a,3142592,j,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((g|0)==2){g=c[l>>2]|0;o=c[g+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(k|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=g;x=p;while(1){y=(da(v,m)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(h,w);y=h;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+4)|0,B>>>0<=(c[u>>2]|0)>>>0):0){c[x>>2]=c[y>>2];c[q>>2]=B}else Bid(q,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0;B=x+4|0;if((B|0)==(k|0))break a;v=c[c[n>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(k|0)){o=a+12|0;m=a+16|0;p=a+28|0;g=a+32|0;x=a+20|0;w=n;do{n=qdd(a,3142592,j,e,0)|0;if(n){if((n|0)>0){n=c[m>>2]|0;v=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[g>>2]|0,c[p>>2]|0)|0)|0;q=n+v|0;c[o>>2]=q;if((v|0)>=0?(u=n+(v+4)|0,u>>>0<=(c[x>>2]|0)>>>0):0){c[w>>2]=c[q>>2];c[o>>2]=u}else Bid(o,w,4);if(c[a>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{u=c[e>>2]|0;if(u)_n[u&4095](w,a)|0}sdd(a)}w=w+4|0}while((w|0)!=(k|0))}}while(0);udd(a);i=d;return}function mfc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e;j=d+4|0;c[g>>2]=(c[j>>2]|0)-(c[d>>2]|0);if(!(tdd(b,2646336,2646336,g)|0)){i=e;return}egc(d,c[g>>2]|0);k=c[j>>2]|0;do if(c[g>>2]|0){j=c[142302]|0;l=qdd(b,3142592,j,0,0)|0;m=b+80|0;n=c[($hd(c[m>>2]|0)|0)+12>>2]|0;o=b+84|0;c[c[o>>2]>>2]=0;if((l|0)==2){l=c[m>>2]|0;p=c[l+12>>2]|0;q=c[d>>2]|0;a:do if((q|0)!=(k|0)){r=b+12|0;s=b+16|0;t=b+28|0;u=b+32|0;v=b+20|0;w=0;x=l;y=q;while(1){z=(da(w,n)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[o>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(A+(B+1)|0)>>>0<=(c[v>>2]|0)>>>0:0){a[y>>0]=a[z>>0]|0;c[r>>2]=(c[r>>2]|0)+1}else Bid(r,y,1);z=y+1|0;if((z|0)==(k|0))break a;w=c[c[o>>2]>>2]|0;x=c[m>>2]|0;y=z}}while(0);sdd(b);break}sdd(b);o=c[d>>2]|0;if((o|0)!=(k|0)){p=b+12|0;n=b+16|0;q=b+28|0;l=b+32|0;y=b+20|0;x=o;do{o=qdd(b,3142592,j,f,0)|0;if(o){do if((o|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](x,b)|0}else{w=c[n>>2]|0;r=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[l>>2]|0,c[q>>2]|0)|0)|0;v=w+r|0;c[p>>2]=v;if((r|0)>=0?(w+(r+1)|0)>>>0<=(c[y>>2]|0)>>>0:0){a[x>>0]=a[v>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,x,1)}while(0);sdd(b)}x=x+1|0}while((x|0)!=(k|0))}}while(0);udd(b);i=e;return}function nfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];fgc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<5)|0;do if(c[f>>2]|0){j=qdd(a,3142592,575312,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;ggc(r,a);t=r+32|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,575312,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else ggc(m,a);sdd(a)}m=m+32|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function ofc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[g>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,g)|0)){i=d;return}k=c[g>>2]|0;l=c[b>>2]|0;if(!l)c[b+4>>2]=c[a+8>>2];m=b+12|0;n=c[m>>2]|0;do if((n&2147483647)>>>0<k>>>0)if((n|0)>-1){c[m>>2]=k;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];o=hOb(l,k<<3,4,e,0,3653512,370)|0;c[b>>2]=o;p=o;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];o=cOb(k<<3,4,e,0,3653512,352)|0;YEi(o|0,c[b>>2]|0,c[j>>2]<<3|0)|0;c[m>>2]=k;c[b>>2]=o;p=o;break}else p=l;while(0);l=c[j>>2]|0;if(l>>>0<k>>>0?(m=p+(k<<3)|0,(l|0)!=(k|0)):0){f=p+(l<<3)|0;do{if(f){l=f;c[l>>2]=0;c[l+4>>2]=0}f=f+8|0}while((f|0)!=(m|0));q=c[b>>2]|0}else q=p;c[j>>2]=k;j=q+(k<<3)|0;do if(c[g>>2]|0){k=c[142308]|0;q=qdd(a,3142592,k,0,1)|0;p=a+80|0;m=c[($hd(c[p>>2]|0)|0)+12>>2]|0;f=a+84|0;c[c[f>>2]>>2]=0;if((q|0)==2){q=c[p>>2]|0;l=c[q+12>>2]|0;n=c[b>>2]|0;a:do if((n|0)!=(j|0)){o=0;r=q;s=n;while(1){t=(da(o,m)|0)+l|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(h,r);t=h;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[f>>2]|0;c[u>>2]=(c[u>>2]|0)+1;hgc(s,a);u=s+8|0;if((u|0)==(j|0))break a;o=c[c[f>>2]>>2]|0;r=c[p>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);p=c[b>>2]|0;if((p|0)!=(j|0)){f=p;do{p=qdd(a,3142592,k,e,1)|0;if(p){if((p|0)<=0){p=c[e>>2]|0;if(p)_n[p&4095](f,a)|0}else hgc(f,a);sdd(a)}f=f+8|0}while((f|0)!=(j|0))}}while(0);udd(a);i=d;return}function pfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;h=d+8|0;j=d;k=b+8|0;c[h>>2]=c[k>>2];if(!(tdd(a,2646336,2646336,h)|0)){i=d;return}l=c[h>>2]|0;m=c[b>>2]|0;if(!m)c[b+4>>2]=c[a+8>>2];n=b+12|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<l>>>0)if((o|0)>-1){c[n>>2]=l;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];p=hOb(m,l<<4,4,e,0,3653512,370)|0;c[b>>2]=p;q=p;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];p=cOb(l<<4,4,e,0,3653512,352)|0;YEi(p|0,c[b>>2]|0,c[k>>2]<<4|0)|0;c[n>>2]=l;c[b>>2]=p;q=p;break}else q=m;while(0);m=c[k>>2]|0;if(m>>>0<l>>>0?(n=q+(l<<4)|0,(m|0)!=(l|0)):0){f=q+(m<<4)|0;do{if(f){c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2]}f=f+16|0}while((f|0)!=(n|0));r=c[b>>2]|0}else r=q;c[k>>2]=l;k=r+(l<<4)|0;do if(c[h>>2]|0){l=c[142312]|0;r=qdd(a,3142592,l,0,1)|0;q=a+80|0;n=c[($hd(c[q>>2]|0)|0)+12>>2]|0;f=a+84|0;c[c[f>>2]>>2]=0;if((r|0)==2){r=c[q>>2]|0;g=c[r+12>>2]|0;m=c[b>>2]|0;a:do if((m|0)!=(k|0)){o=0;p=r;s=m;while(1){t=(da(o,n)|0)+g|0;c[p+20>>2]=t;c[p+12>>2]=t;cid(j,p);t=j;u=c[t+4>>2]|0;v=p+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[f>>2]|0;c[u>>2]=(c[u>>2]|0)+1;igc(s,a);u=s+16|0;if((u|0)==(k|0))break a;o=c[c[f>>2]>>2]|0;p=c[q>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);q=c[b>>2]|0;if((q|0)!=(k|0)){f=q;do{q=qdd(a,3142592,l,e,1)|0;if(q){if((q|0)<=0){q=c[e>>2]|0;if(q)_n[q&4095](f,a)|0}else igc(f,a);sdd(a)}f=f+16|0}while((f|0)!=(k|0))}}while(0);udd(a);i=d;return}function qfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[g>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,g)|0)){i=d;return}k=c[g>>2]|0;l=c[b>>2]|0;if(!l)c[b+4>>2]=c[a+8>>2];m=b+12|0;n=c[m>>2]|0;do if((n&2147483647)>>>0<k>>>0)if((n|0)>-1){c[m>>2]=k;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];o=hOb(l,k<<2,4,e,0,3653512,370)|0;c[b>>2]=o;p=o;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];o=cOb(k<<2,4,e,0,3653512,352)|0;YEi(o|0,c[b>>2]|0,c[j>>2]<<2|0)|0;c[m>>2]=k;c[b>>2]=o;p=o;break}else p=l;while(0);c[j>>2]=k;j=p+(k<<2)|0;do if(c[g>>2]|0){k=c[142262]|0;p=qdd(a,3142592,k,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((p|0)==2){p=c[l>>2]|0;o=c[p+12>>2]|0;q=c[b>>2]|0;a:do if((q|0)!=(j|0)){r=c[142304]|0;s=a+12|0;t=a+16|0;u=a+28|0;v=a+32|0;w=a+20|0;x=0;y=p;z=q;while(1){A=(da(x,m)|0)+o|0;c[y+20>>2]=A;c[y+12>>2]=A;cid(h,y);A=h;B=c[A+4>>2]|0;C=y+24|0;c[C>>2]=c[A>>2];c[C+4>>2]=B;B=c[n>>2]|0;c[B>>2]=(c[B>>2]|0)+1;rdd(a,2);B=(c[a>>2]&512|0)==0;C=qdd(a,614656,r,e,0)|0;if(C){if((C|0)>0){C=c[t>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[v>>2]|0,c[u>>2]|0)|0)|0;D=C+A|0;c[s>>2]=D;if((A|0)>=0?(E=C+(A+4)|0,E>>>0<=(c[w>>2]|0)>>>0):0){c[z>>2]=c[D>>2];c[s>>2]=E}else Bid(s,z,4);if(c[a>>2]&512)c[z>>2]=XEi(c[z>>2]|0)|0}else{E=c[e>>2]|0;if(E)_n[E&4095](z,a)|0}sdd(a)}if(!B)c[z>>2]=XEi(c[z>>2]|0)|0;B=z+4|0;if((B|0)==(j|0))break a;x=c[c[n>>2]>>2]|0;y=c[l>>2]|0;z=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(j|0)){o=c[142304]|0;m=a+12|0;q=a+16|0;p=a+28|0;z=a+32|0;y=a+20|0;x=n;do{n=qdd(a,3142592,k,f,1)|0;if(n){if((n|0)>0){rdd(a,2);n=(c[a>>2]&512|0)==0;s=qdd(a,614656,o,e,0)|0;if(s){if((s|0)>0){s=c[q>>2]|0;w=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[z>>2]|0,c[p>>2]|0)|0)|0;u=s+w|0;c[m>>2]=u;if((w|0)>=0?(v=s+(w+4)|0,v>>>0<=(c[y>>2]|0)>>>0):0){c[x>>2]=c[u>>2];c[m>>2]=v}else Bid(m,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0}else{v=c[e>>2]|0;if(v)_n[v&4095](x,a)|0}sdd(a)}if(!n)c[x>>2]=XEi(c[x>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](x,a)|0}sdd(a)}x=x+4|0}while((x|0)!=(j|0))}}while(0);udd(a);i=d;return}function rfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=qdd(b,574440,575296,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else jgc(a,b);sdd(b)}f=a+28|0;g=qdd(b,574456,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else jgc(f,b);sdd(b)}f=a+56|0;g=qdd(b,574488,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else jgc(f,b);sdd(b)}f=a+104|0;g=qdd(b,574472,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else jgc(f,b);sdd(b)}f=a+180|0;g=qdd(b,574648,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else kgc(f,b);sdd(b)}f=a+84|0;g=qdd(b,574664,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else kgc(f,b);sdd(b)}f=a+132|0;g=qdd(b,574680,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else kgc(f,b);sdd(b)}f=a+152|0;g=qdd(b,574696,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else jgc(f,b);sdd(b)}f=a+200|0;g=qdd(b,574712,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else kgc(f,b);sdd(b)}f=a+220|0;g=qdd(b,574728,575296,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else kgc(f,b);sdd(b)}f=a+240|0;a=qdd(b,574744,c[142304]|0,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[a>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[j>>2];c[a>>2]=k}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function sfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;h=d;j=c[153134]|0;c[g>>2]=0;k=g+4|0;c[k>>2]=j;l=g+8|0;c[l>>2]=0;m=g+12|0;c[m>>2]=0;c[h>>2]=0;n=h+4|0;c[n>>2]=j;j=h+8|0;c[j>>2]=0;o=h+12|0;c[o>>2]=0;p=c[142306]|0;q=qdd(b,574584,p,e,1)|0;if(q){if((q|0)<=0){q=c[e>>2]|0;if(q)_n[q&4095](g,b)|0}else rac(b,g,0);sdd(b)}q=qdd(b,574616,p,e,1)|0;if(q){if((q|0)<=0){q=c[e>>2]|0;if(q)_n[q&4095](h,b)|0}else rac(b,h,0);sdd(b)}b=tLc()|0;q=c[l>>2]|0;if(q)c[a+8>>2]=kn[c[(c[b>>2]|0)+60>>2]&511](b,1,c[g>>2]|0,q)|0;q=c[j>>2]|0;if(q)c[a+12>>2]=kn[c[(c[b>>2]|0)+60>>2]&511](b,0,c[h>>2]|0,q)|0;if((c[o>>2]|0)>-1){o=c[h>>2]|0;c[f>>2]=c[n>>2];c[e+0>>2]=c[f+0>>2];eOb(o,e);c[h>>2]=0}if((c[m>>2]|0)<=-1){i=d;return}m=c[g>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];eOb(m,e);c[g>>2]=0;i=d;return}function tfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}Yfc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{lgc(r,a);r=r+56|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*56|0)|0;c[j>>2]=0;i=d;return}function ufc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];mgc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k*40|0)|0;if(!k){i=d;return}else u=s;do{ngc(u,a);u=u+40|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=(c[h>>2]|0)*40|0;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(w|0)/40|0;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function vfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];ogc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k*12|0)|0;if(!k){i=d;return}else u=s;do{pgc(u,a);u=u+12|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=(c[h>>2]|0)*12|0;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(w|0)/12|0;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function wfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[h>>2]|0;q=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;p=l;q=n}n=p+4|0;if(n>>>0>q>>>0){Bid(h,e,4);r=c[e>>2]|0}else{q=c[p>>2]|0;c[e>>2]=q;c[h>>2]=n;r=q}zid(h,r,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);s=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;s=o}qgc(b,s);s=c[b+4>>2]|0;o=c[b>>2]|0;if((o|0)==(s|0)){i=d;return}else t=o;do{CUb(t,a);o=t+4|0;b=c[h>>2]|0;l=b+4|0;g=c[m>>2]|0;if(l>>>0>g>>>0){Bid(h,o,4);u=c[h>>2]|0;v=c[m>>2]|0}else{c[o>>2]=c[b>>2];c[h>>2]=l;u=l;v=g}g=t+8|0;l=u+4|0;if(l>>>0>v>>>0){Bid(h,g,4);w=c[h>>2]|0;x=c[m>>2]|0}else{c[g>>2]=c[u>>2];c[h>>2]=l;w=l;x=v}l=t+12|0;g=w+4|0;if(g>>>0>x>>>0)Bid(h,l,4);else{c[l>>2]=c[w>>2];c[h>>2]=g}t=t+16|0}while((t|0)!=(s|0));i=d;return}function xfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];bgc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<6)|0;if(!k){i=d;return}else u=s;do{rgc(u,a);u=u+64|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<6;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>6;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function yfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];dgc(b,s,e);s=c[j>>2]|0;if(!s){i=d;return}Ldd(a,c[b>>2]|0,s<<2);i=d;return}if(r){Bid(l,h,4);u=c[l>>2]|0;v=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;u=o;v=q}q=u+4|0;if(q>>>0>v>>>0){Bid(l,g,4);w=c[g>>2]|0}else{v=c[u>>2]|0;c[g>>2]=v;c[l>>2]=q;w=v}v=c[h>>2]<<2;h=zid(l,w,v)|0;w=b+12|0;if((c[w>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=v>>2;c[b+8>>2]=e;c[w>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function zfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}egc(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]|0)|0;c[j>>2]=0;i=d;return}function Afc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];fgc(b,s,e);s=c[j>>2]|0;if(!s){i=d;return}Ldd(a,c[b>>2]|0,s<<5);i=d;return}if(r){Bid(l,h,4);u=c[l>>2]|0;v=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;u=o;v=q}q=u+4|0;if(q>>>0>v>>>0){Bid(l,g,4);w=c[g>>2]|0}else{v=c[u>>2]|0;c[g>>2]=v;c[l>>2]=q;w=v}v=c[h>>2]<<5;h=zid(l,w,v)|0;w=b+12|0;if((c[w>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=v>>5;c[b+8>>2]=e;c[w>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function Bfc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;sgc(b,d);sgc(b+28|0,d);sgc(b+56|0,d);sgc(b+104|0,d);f=b+180|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0)Bid(g,f,4);else{c[f>>2]=c[h>>2];c[g>>2]=j}tgc(d,b+188|0,0);Ndd(d);j=b+184|0;h=c[g>>2]|0;if((h+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,j,1);else{a[j>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);h=b+84|0;j=c[g>>2]|0;f=j+4|0;if(f>>>0>(c[k>>2]|0)>>>0)Bid(g,h,4);else{c[h>>2]=c[j>>2];c[g>>2]=f}tgc(d,b+92|0,0);Ndd(d);f=b+88|0;j=c[g>>2]|0;if((j+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,f,1);else{a[f>>0]=a[j>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);j=b+132|0;f=c[g>>2]|0;h=f+4|0;if(h>>>0>(c[k>>2]|0)>>>0)Bid(g,j,4);else{c[j>>2]=c[f>>2];c[g>>2]=h}tgc(d,b+140|0,0);Ndd(d);h=b+136|0;f=c[g>>2]|0;if((f+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,h,1);else{a[h>>0]=a[f>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);sgc(b+152|0,d);f=b+200|0;h=c[g>>2]|0;j=h+4|0;if(j>>>0>(c[k>>2]|0)>>>0)Bid(g,f,4);else{c[f>>2]=c[h>>2];c[g>>2]=j}tgc(d,b+208|0,0);Ndd(d);j=b+204|0;h=c[g>>2]|0;if((h+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,j,1);else{a[j>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);h=b+220|0;j=c[g>>2]|0;f=j+4|0;if(f>>>0>(c[k>>2]|0)>>>0)Bid(g,h,4);else{c[h>>2]=c[j>>2];c[g>>2]=f}tgc(d,b+228|0,0);Ndd(d);f=b+224|0;j=c[g>>2]|0;if((j+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,f,1);else{a[f>>0]=a[j>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);d=b+240|0;b=c[g>>2]|0;j=b+4|0;if(j>>>0>(c[k>>2]|0)>>>0){Bid(g,d,4);i=e;return}else{c[d>>2]=c[b>>2];c[g>>2]=j;i=e;return}}function Cfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;h=d;j=c[153134]|0;c[g>>2]=0;k=g+4|0;c[k>>2]=j;l=g+8|0;c[l>>2]=0;m=g+12|0;c[m>>2]=0;c[h>>2]=0;n=h+4|0;c[n>>2]=j;j=h+8|0;c[j>>2]=0;o=h+12|0;c[o>>2]=0;sac(b,g,0);Ndd(b);sac(b,h,0);Ndd(b);b=tLc()|0;p=c[l>>2]|0;if(p)c[a+8>>2]=kn[c[(c[b>>2]|0)+60>>2]&511](b,1,c[g>>2]|0,p)|0;p=c[j>>2]|0;if(p)c[a+12>>2]=kn[c[(c[b>>2]|0)+60>>2]&511](b,0,c[h>>2]|0,p)|0;if((c[o>>2]|0)>-1){o=c[h>>2]|0;c[f>>2]=c[n>>2];c[e+0>>2]=c[f+0>>2];eOb(o,e);c[h>>2]=0}if((c[m>>2]|0)<=-1){i=d;return}m=c[g>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];eOb(m,e);c[g>>2]=0;i=d;return}function Dfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;Yfc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{ugc(r,a);r=r+56|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*56|0)|0;c[j>>2]=0;i=d;return}function Efc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+12|0;j=d+8|0;l=d+4|0;m=d;n=a+12|0;o=a+48|0;p=c[n>>2]|0;q=p+4|0;r=a+20|0;s=c[r>>2]|0;t=q>>>0>s>>>0;if(c[o>>2]|0){if(t){Bid(n,j,4);u=c[j>>2]|0;v=c[n>>2]|0;w=c[r>>2]|0}else{x=c[p>>2]|0;c[j>>2]=x;c[n>>2]=q;u=x;v=q;w=s}s=XEi(u|0)|0;c[j>>2]=s;u=v+4|0;if(u>>>0>w>>>0){Bid(n,h,4);y=c[h>>2]|0;z=c[j>>2]|0}else{j=c[v>>2]|0;c[h>>2]=j;c[n>>2]=u;y=j;z=s}s=XEi(y|0)|0;c[h>>2]=s;h=z*40|0;z=zid(n,s,h)|0;s=b+12|0;if((c[s>>2]|0)>-1){y=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(y,e);c[b>>2]=0}y=(h|0)/40|0;c[b+8>>2]=y;c[s>>2]=y|-2147483648;c[b>>2]=z;c[o>>2]=0;i=d;return}if(t){Bid(n,l,4);A=c[l>>2]|0}else{t=c[p>>2]|0;c[l>>2]=t;c[n>>2]=q;A=t}t=XEi(A|0)|0;c[l>>2]=t;c[m>>2]=c[a+8>>2];c[e+0>>2]=c[m+0>>2];mgc(b,t,e);e=c[b>>2]|0;t=c[b+8>>2]|0;b=e+(t*40|0)|0;if(!t){i=d;return}else B=e;do{e=c[n>>2]|0;t=e+4|0;m=c[r>>2]|0;if(t>>>0>m>>>0){Bid(n,B,4);C=B;D=c[B>>2]|0;E=c[n>>2]|0;F=c[r>>2]|0}else{G=ea(g[e>>2]);g[B>>2]=G;c[n>>2]=t;C=B;D=(g[k>>2]=G,c[k>>2]|0);E=t;F=m}c[C>>2]=XEi(D|0)|0;m=B+4|0;t=E+4|0;if(t>>>0>F>>>0){Bid(n,m,4);H=m;I=c[m>>2]|0;J=c[n>>2]|0;K=c[r>>2]|0}else{G=ea(g[E>>2]);g[m>>2]=G;c[n>>2]=t;H=m;I=(g[k>>2]=G,c[k>>2]|0);J=t;K=F}c[H>>2]=XEi(I|0)|0;t=B+8|0;m=J+4|0;if(m>>>0>K>>>0){Bid(n,t,4);L=t;M=c[t>>2]|0;N=c[n>>2]|0;O=c[r>>2]|0}else{G=ea(g[J>>2]);g[t>>2]=G;c[n>>2]=m;L=t;M=(g[k>>2]=G,c[k>>2]|0);N=m;O=K}c[L>>2]=XEi(M|0)|0;m=B+12|0;t=N+4|0;if(t>>>0>O>>>0){Bid(n,m,4);P=m;Q=c[m>>2]|0;R=c[n>>2]|0;S=c[r>>2]|0}else{G=ea(g[N>>2]);g[m>>2]=G;c[n>>2]=t;P=m;Q=(g[k>>2]=G,c[k>>2]|0);R=t;S=O}c[P>>2]=XEi(Q|0)|0;t=B+16|0;m=R+4|0;if(m>>>0>S>>>0){Bid(n,t,4);T=t;U=c[t>>2]|0;V=c[n>>2]|0;W=c[r>>2]|0}else{G=ea(g[R>>2]);g[t>>2]=G;c[n>>2]=m;T=t;U=(g[k>>2]=G,c[k>>2]|0);V=m;W=S}c[T>>2]=XEi(U|0)|0;m=B+20|0;t=V+4|0;if(t>>>0>W>>>0){Bid(n,m,4);X=m;Y=c[r>>2]|0;Z=c[m>>2]|0;_=c[n>>2]|0}else{G=ea(g[V>>2]);g[m>>2]=G;c[n>>2]=t;X=m;Y=W;Z=(g[k>>2]=G,c[k>>2]|0);_=t}c[X>>2]=XEi(Z|0)|0;t=B+24|0;m=_+4|0;if(m>>>0>Y>>>0){Bid(n,t,4);$=t;aa=c[t>>2]|0;ba=c[n>>2]|0;ca=c[r>>2]|0}else{G=ea(g[_>>2]);g[t>>2]=G;c[n>>2]=m;$=t;aa=(g[k>>2]=G,c[k>>2]|0);ba=m;ca=Y}c[$>>2]=XEi(aa|0)|0;m=B+28|0;t=ba+4|0;if(t>>>0>ca>>>0){Bid(n,m,4);da=m;fa=c[m>>2]|0;ga=c[n>>2]|0;ha=c[r>>2]|0}else{G=ea(g[ba>>2]);g[m>>2]=G;c[n>>2]=t;da=m;fa=(g[k>>2]=G,c[k>>2]|0);ga=t;ha=ca}c[da>>2]=XEi(fa|0)|0;t=B+32|0;m=ga+4|0;if(m>>>0>ha>>>0){Bid(n,t,4);ia=t;ja=c[t>>2]|0;ka=c[n>>2]|0;la=c[r>>2]|0}else{G=ea(g[ga>>2]);g[t>>2]=G;c[n>>2]=m;ia=t;ja=(g[k>>2]=G,c[k>>2]|0);ka=m;la=ha}c[ia>>2]=XEi(ja|0)|0;m=B+36|0;t=ka+4|0;if(t>>>0>la>>>0){Bid(n,m,4);ma=c[m>>2]|0}else{e=c[ka>>2]|0;c[m>>2]=e;c[n>>2]=t;ma=e}c[m>>2]=XEi(ma|0)|0;B=B+40|0}while((B|0)!=(b|0));i=d;return}function Ffc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];ogc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k*12|0)|0;if(!k){i=d;return}else u=t;do{vgc(u,a);u=u+12|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z*12|0;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(g|0)/12|0;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function Gfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;qgc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{wgc(r,a);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function Hfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];bgc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<6)|0;if(!k){i=d;return}else u=t;do{xgc(u,a);u=u+64|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<6;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>6;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function Ifc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];dgc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;a=t+(k<<2)|0;if(!k){i=d;return}else u=t;do{t=c[l>>2]|0;k=t+4|0;if(k>>>0>(c[p>>2]|0)>>>0){Bid(l,u,4);v=c[u>>2]|0}else{j=c[t>>2]|0;c[u>>2]=j;c[l>>2]=k;v=j}c[u>>2]=XEi(v|0)|0;u=u+4|0}while((u|0)!=(a|0));i=d;return}else{if(r){Bid(l,h,4);w=c[h>>2]|0;x=c[l>>2]|0;y=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;w=p;x=o;y=q}q=XEi(w|0)|0;c[h>>2]=q;w=x+4|0;if(w>>>0>y>>>0){Bid(l,g,4);z=c[g>>2]|0;A=c[h>>2]|0}else{h=c[x>>2]|0;c[g>>2]=h;c[l>>2]=w;z=h;A=q}q=XEi(z|0)|0;c[g>>2]=q;g=A<<2;A=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>2;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=A;c[m>>2]=0;i=d;return}}function Jfc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+12|0;k=b+48|0;l=c[j>>2]|0;m=l+4|0;n=b+20|0;b=c[n>>2]|0;o=m>>>0>b>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=b}b=XEi(p|0)|0;c[g>>2]=b;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=b}b=XEi(t|0)|0;c[f>>2]=b;zid(j,b,u)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;egc(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;if((h+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(j,w,1);else{a[w>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}w=w+1|0}while((w|0)!=(o|0));i=e;return}function Kfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];fgc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<5)|0;if(!k){i=d;return}else u=t;do{ygc(u,a);u=u+32|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<5;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>5;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function Lfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;zgc(a,b);zgc(a+28|0,b);zgc(a+56|0,b);zgc(a+104|0,b);Agc(a+180|0,b);Agc(a+84|0,b);Agc(a+132|0,b);zgc(a+152|0,b);Agc(a+200|0,b);Agc(a+220|0,b);e=a+240|0;a=b+12|0;f=c[a>>2]|0;g=f+4|0;if(g>>>0>(c[b+20>>2]|0)>>>0){Bid(a,e,4);h=c[e>>2]|0;j=XEi(h|0)|0;c[e>>2]=j;i=d;return}else{b=c[f>>2]|0;c[e>>2]=b;c[a>>2]=g;h=b;j=XEi(h|0)|0;c[e>>2]=j;i=d;return}}function Mfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;h=d;j=c[153134]|0;c[g>>2]=0;k=g+4|0;c[k>>2]=j;l=g+8|0;c[l>>2]=0;m=g+12|0;c[m>>2]=0;c[h>>2]=0;n=h+4|0;c[n>>2]=j;j=h+8|0;c[j>>2]=0;o=h+12|0;c[o>>2]=0;tac(b,g,0);Mdd(b);tac(b,h,0);Mdd(b);b=tLc()|0;p=c[l>>2]|0;if(p)c[a+8>>2]=kn[c[(c[b>>2]|0)+60>>2]&511](b,1,c[g>>2]|0,p)|0;p=c[j>>2]|0;if(p)c[a+12>>2]=kn[c[(c[b>>2]|0)+60>>2]&511](b,0,c[h>>2]|0,p)|0;if((c[o>>2]|0)>-1){o=c[h>>2]|0;c[f>>2]=c[n>>2];c[e+0>>2]=c[f+0>>2];eOb(o,e);c[h>>2]=0}if((c[m>>2]|0)<=-1){i=d;return}m=c[g>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];eOb(m,e);c[g>>2]=0;i=d;return}function Nfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;k=c[j>>2]|0;if(h>>>0<k>>>0){c[g>>2]=c[e>>2];c[f>>2]=h;l=h;m=k}else{Gid(f,e,4);l=c[f>>2]|0;m=c[j>>2]|0}e=a+8|0;k=l+4|0;if(k>>>0<m>>>0){c[l>>2]=c[e>>2];c[f>>2]=k;n=k;o=m}else{Gid(f,e,4);n=c[f>>2]|0;o=c[j>>2]|0}e=n+4|0;if(e>>>0<o>>>0){c[n>>2]=c[a>>2];c[f>>2]=e;p=e;q=o}else{Gid(f,a,4);p=c[f>>2]|0;q=c[j>>2]|0}o=a+16|0;e=p+4|0;if(e>>>0<q>>>0){c[p>>2]=c[o>>2];c[f>>2]=e;r=e;s=q}else{Gid(f,o,4);r=c[f>>2]|0;s=c[j>>2]|0}j=a+20|0;o=r+4|0;if(o>>>0<s>>>0){c[r>>2]=c[j>>2];c[f>>2]=o;t=a+32|0;jdc(t,b);i=d;return}else{Gid(f,j,4);t=a+32|0;jdc(t,b);i=d;return}}function Ofc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=a+8|0;h=c[f>>2]|0;c[e>>2]=h;j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;if(l>>>0<(c[m>>2]|0)>>>0){c[k>>2]=h;c[j>>2]=l}else Gid(j,e,4);l=c[a>>2]|0;h=c[f>>2]|0;f=l+(h*40|0)|0;if(h){h=l;do{Bgc(h,b);h=h+40|0}while((h|0)!=(f|0))}f=a+24|0;h=c[f>>2]|0;c[e>>2]=h;l=c[j>>2]|0;k=l+4|0;if(k>>>0<(c[m>>2]|0)>>>0){c[l>>2]=h;c[j>>2]=k}else Gid(j,e,4);k=c[a+16>>2]|0;h=c[f>>2]|0;f=k+(h*12|0)|0;if(h){h=k;do{Cgc(h,b);h=h+12|0}while((h|0)!=(f|0))}Dgc(b,a+32|0,0);b=a+52|0;f=c[b>>2]|0;c[e>>2]=f;h=c[j>>2]|0;k=h+4|0;if(k>>>0<(c[m>>2]|0)>>>0){c[h>>2]=f;c[j>>2]=k}else Gid(j,e,4);e=c[a+44>>2]|0;a=c[b>>2]|0;b=e+(a<<2)|0;if(!a){i=d;return}else n=e;do{e=c[j>>2]|0;a=e+4|0;if(a>>>0<(c[m>>2]|0)>>>0){g[e>>2]=ea(g[n>>2]);c[j>>2]=a}else Gid(j,n,4);n=n+4|0}while((n|0)!=(b|0));i=d;return}function Pfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+16|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+32|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+48|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}h=a+4|0;p=q+4|0;if(p>>>0<r>>>0){g[q>>2]=ea(g[h>>2]);c[e>>2]=p;s=p;t=r}else{Gid(e,h,4);s=c[e>>2]|0;t=c[j>>2]|0}h=a+20|0;r=s+4|0;if(r>>>0<t>>>0){g[s>>2]=ea(g[h>>2]);c[e>>2]=r;u=r;v=t}else{Gid(e,h,4);u=c[e>>2]|0;v=c[j>>2]|0}h=a+36|0;t=u+4|0;if(t>>>0<v>>>0){g[u>>2]=ea(g[h>>2]);c[e>>2]=t;w=t;x=v}else{Gid(e,h,4);w=c[e>>2]|0;x=c[j>>2]|0}h=a+52|0;v=w+4|0;if(v>>>0<x>>>0){g[w>>2]=ea(g[h>>2]);c[e>>2]=v;y=v;z=x}else{Gid(e,h,4);y=c[e>>2]|0;z=c[j>>2]|0}h=a+8|0;x=y+4|0;if(x>>>0<z>>>0){g[y>>2]=ea(g[h>>2]);c[e>>2]=x;A=x;B=z}else{Gid(e,h,4);A=c[e>>2]|0;B=c[j>>2]|0}h=a+24|0;z=A+4|0;if(z>>>0<B>>>0){g[A>>2]=ea(g[h>>2]);c[e>>2]=z;C=z;D=B}else{Gid(e,h,4);C=c[e>>2]|0;D=c[j>>2]|0}h=a+40|0;B=C+4|0;if(B>>>0<D>>>0){g[C>>2]=ea(g[h>>2]);c[e>>2]=B;E=B;F=D}else{Gid(e,h,4);E=c[e>>2]|0;F=c[j>>2]|0}h=a+56|0;D=E+4|0;if(D>>>0<F>>>0){g[E>>2]=ea(g[h>>2]);c[e>>2]=D;G=D;H=F}else{Gid(e,h,4);G=c[e>>2]|0;H=c[j>>2]|0}h=a+12|0;F=G+4|0;if(F>>>0<H>>>0){g[G>>2]=ea(g[h>>2]);c[e>>2]=F;I=F;J=H}else{Gid(e,h,4);I=c[e>>2]|0;J=c[j>>2]|0}h=a+28|0;H=I+4|0;if(H>>>0<J>>>0){g[I>>2]=ea(g[h>>2]);c[e>>2]=H;K=H;L=J}else{Gid(e,h,4);K=c[e>>2]|0;L=c[j>>2]|0}h=a+44|0;J=K+4|0;if(J>>>0<L>>>0){g[K>>2]=ea(g[h>>2]);c[e>>2]=J;M=J;N=L}else{Gid(e,h,4);M=c[e>>2]|0;N=c[j>>2]|0}j=a+60|0;a=M+4|0;if(a>>>0<N>>>0){g[M>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function Qfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+12|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}h=a+16|0;p=q+4|0;if(p>>>0<r>>>0){c[q>>2]=c[h>>2];c[e>>2]=p;s=p;t=r}else{Gid(e,h,4);s=c[e>>2]|0;t=c[j>>2]|0}h=a+20|0;r=s+4|0;if(r>>>0<t>>>0){c[s>>2]=c[h>>2];c[e>>2]=r;u=r;v=t}else{Gid(e,h,4);u=c[e>>2]|0;v=c[j>>2]|0}h=a+24|0;t=u+4|0;if(t>>>0<v>>>0){c[u>>2]=c[h>>2];c[e>>2]=t;w=t;x=v}else{Gid(e,h,4);w=c[e>>2]|0;x=c[j>>2]|0}j=a+28|0;a=w+4|0;if(a>>>0<x>>>0){c[w>>2]=c[j>>2];c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function Rfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Egc(a,b);Egc(a+28|0,b);Egc(a+56|0,b);Egc(a+104|0,b);Fgc(a+180|0,b);Fgc(a+84|0,b);Fgc(a+132|0,b);Egc(a+152|0,b);Fgc(a+200|0,b);Fgc(a+220|0,b);e=a+240|0;a=b+12|0;f=c[a>>2]|0;g=f+4|0;if(g>>>0<(c[b+20>>2]|0)>>>0){c[f>>2]=c[e>>2];c[a>>2]=g;i=d;return}else{Gid(a,e,4);i=d;return}}function Sfc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;a=d+4|0;e=d;f=c[153134]|0;c[a>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;if(j>>>0<(c[k>>2]|0)>>>0){c[h>>2]=0;c[g>>2]=j}else Gid(g,a,4);Tdd(b);c[a>>2]=0;j=c[g>>2]|0;h=j+4|0;if(h>>>0<(c[k>>2]|0)>>>0){c[j>>2]=0;c[g>>2]=h}else Gid(g,a,4);Tdd(b);c[e>>2]=f;c[a+0>>2]=c[e+0>>2];eOb(0,a);c[e>>2]=f;c[a+0>>2]=c[e+0>>2];eOb(0,a);i=d;return}function Tfc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+60>>2]|0)>-1){f=a+48|0;g=c[f>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+44>>2]|0)>-1){f=a+32|0;g=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function Ufc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142304]|0;add(b,575144,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2533664,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142258]|0;add(b,575160,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,575176,e,a+9|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function Vfc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+32|0;g=f;add(a,d,c[142306]|0,b,e);c[g>>2]=0;qbc(g);$cd(a,2646336,2646336,f+16|0,0);add(a,3142592,575344,g,0);Ggc(g,a);bdd(a);cdd(a);ubc(g);bdd(a);i=f;return}function Wfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;add(b,574760,c[142304]|0,a,0);e=b+12|0;f=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);g=c[142268]|0;add(b,574800,g,a+4|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574808,g,a+8|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,574776,c[142306]|0,a+16|0,0);$cd(b,2646336,2646336,d,0);g=c[142302]|0;add(b,3142592,g,d+4|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,574784,g,a+12|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function Xfc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;add(a,d,575296,b,e);add(a,574760,c[142304]|0,b,0);e=a+12|0;d=a+20|0;c[(c[c[e>>2]>>2]|0)+((c[d>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,574776,c[142306]|0,b+8|0,0);$cd(a,2646336,2646336,f,0);g=c[142302]|0;add(a,3142592,g,f+4|0,0);c[(c[c[e>>2]>>2]|0)+((c[d>>2]|0)*24|0)+12>>2]=1;bdd(a);cdd(a);fdd(a);bdd(a);add(a,574784,g,b+4|0,0);c[(c[c[e>>2]>>2]|0)+((c[d>>2]|0)*24|0)+12>>2]=1;bdd(a);fdd(a);bdd(a);i=f;return}function Yfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=((c[q>>2]|0)-s|0)/56|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b*56|0);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];Igc(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~(((r+-56-o|0)>>>0)/56|0)*56|0);c[h>>2]=10;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if((((c[o>>2]|0)-s|0)/56|0|0)==(b|0)){Uec(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=10,c[e+0>>2]=c[f+0>>2],h=cOb(b*56|0,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(((p|0)/-56|0)*56|0)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b*56|0),(p|0)!=0):0){c[g>>2]=10;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];Hgc(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=(l-k|0)/56|0;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b*56|0)|0,(l|0)!=(g|0)):0){h=l+(~(((l+-56-g|0)>>>0)/56|0)*56|0)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{Uec(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~(((v+-56-p|0)>>>0)/56|0)*56|0);c[f>>2]=10;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function Zfc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;rdd(b,2);g=a+4|0;h=c[142304]|0;j=qdd(b,575200,h,e,0)|0;if(j){if((j|0)>0){j=b+12|0;k=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[m>>2];c[j>>2]=n}else Bid(j,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](g,b)|0}sdd(b)}g=a+8|0;j=qdd(b,575216,h,e,0)|0;if(j){if((j|0)>0){j=b+12|0;n=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=n+m|0;c[j>>2]=l;if((m|0)>=0?(k=n+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[l>>2];c[j>>2]=k}else Bid(j,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](g,b)|0}sdd(b)}g=qdd(b,575232,c[142270]|0,e,0)|0;if(g){if((g|0)>0){g=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[g>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[g>>2]=m}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+16|0;m=qdd(b,575144,h,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[m>>2]=n}else Bid(m,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](g,b)|0}sdd(b)}g=a+20|0;m=qdd(b,2533664,h,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[k>>2];c[m>>2]=l}else Bid(m,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](g,b)|0}sdd(b)}g=a+32|0;m=qdd(b,575248,614728,e,1)|0;if(m){if((m|0)<=0){m=c[e>>2]|0;if(m)_n[m&4095](g,b)|0}else _cc(g,b);sdd(b)}if(!(wdd(b,1)|0)){i=d;return}g=qdd(b,575264,h,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=h+m|0;c[g>>2]=l;if((m|0)>=0?(k=h+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[l>>2];c[g>>2]=k}else Bid(g,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}sdd(b)}c[a>>2]=(c[f>>2]|0)!=0&1;i=d;return}function _fc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];mgc(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*40|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,575384,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Jgc(r,a);t=r+40|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,575384,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else Jgc(m,a);sdd(a)}m=m+40|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function $fc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];ogc(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*12|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,575368,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Kgc(r,a);t=r+12|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,575368,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else Kgc(m,a);sdd(a)}m=m+12|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function agc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}qgc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,575344,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Lgc(r,a);t=r+16|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,575344,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else Lgc(m,a);sdd(a)}m=m+16|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function bgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+80|0;f=e+68|0;g=e+64|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b<<6,4,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b<<6,4,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[a+8>>2]<<6|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b<<6)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a<<6)|0;do{if(f){a=f+0|0;m=h+0|0;g=a+64|0;do{c[a>>2]=c[m>>2];a=a+4|0;m=m+4|0}while((a|0)<(g|0))}f=f+64|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function cgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,574944,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+16|0;m=qdd(b,574952,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+32|0;m=qdd(b,574960,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+48|0;m=qdd(b,574968,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+4|0;m=qdd(b,574976,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+20|0;m=qdd(b,574984,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+36|0;m=qdd(b,574992,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+52|0;m=qdd(b,575e3,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,575008,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+24|0;m=qdd(b,575016,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+40|0;m=qdd(b,575024,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+56|0;m=qdd(b,575032,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;m=qdd(b,575040,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+28|0;m=qdd(b,575048,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+44|0;m=qdd(b,575056,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;do if((j|0)<0)o=160;else{l=n+(j+4)|0;if(l>>>0>(c[b+20>>2]|0)>>>0){o=160;break}g[h>>2]=ea(g[k>>2]);c[m>>2]=l}while(0);if((o|0)==160)Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+60|0;a=qdd(b,575064,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=f+m|0;c[a>>2]=k;do if((m|0)<0)o=171;else{j=f+(m+4)|0;if(j>>>0>(c[b+20>>2]|0)>>>0){o=171;break}g[h>>2]=ea(g[k>>2]);c[a>>2]=j}while(0);if((o|0)==171)Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function dgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<2,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<2,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<2|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<2)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<2)|0;do{if(f)c[f>>2]=0;f=f+4|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function egc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+b;c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];Ngc(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=o;c[h>>2]=8;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s|0)==(b|0)){vdc(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=8,c[e+0>>2]=c[f+0>>2],h=cOb(b,16,e,0,3653512,80)|0,p=c[j>>2]|0,r=(c[t>>2]|0)-p|0,u=h+(0-r)|0,YEi(u|0,p|0,r|0)|0,r=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+b,(r|0)!=0):0){c[g>>2]=8;c[e+0>>2]=c[g+0>>2];eOb(r,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];Mgc(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;r=l-k|0;if(r>>>0>=b>>>0)if(r>>>0>b>>>0?(g=k+b|0,(l|0)!=(g|0)):0){c[t>>2]=g;v=k;w=g}else{v=k;w=l}else{vdc(j,b-r|0);v=c[j>>2]|0;w=c[t>>2]|0}r=c[a>>2]|0;c[j>>2]=r;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!r){i=d;return}if((v|0)!=(r|0))c[t>>2]=r;c[f>>2]=8;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function fgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b<<5,16,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b<<5,16,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[a+8>>2]<<5|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b<<5)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a<<5)|0;do{if(f){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];c[f+24>>2]=c[h+24>>2];c[f+28>>2]=c[h+28>>2]}f=f+32|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function ggc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,574816,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,574832,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,574848,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;m=qdd(b,574864,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;f=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=f+l|0;c[m>>2]=k;if((l|0)>=0?(j=f+(l+4)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=j}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+16|0;m=c[142270]|0;j=qdd(b,574880,m,e,0)|0;if(j){if((j|0)>0){j=b+12|0;k=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;f=k+l|0;c[j>>2]=f;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[h>>2]=c[f>>2];c[j>>2]=n}else Bid(j,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](h,b)|0}sdd(b)}h=a+20|0;j=qdd(b,574896,m,e,0)|0;if(j){if((j|0)>0){j=b+12|0;n=c[b+16>>2]|0;f=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=n+f|0;c[j>>2]=l;if((f|0)>=0?(k=n+(f+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[j>>2]=k}else Bid(j,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](h,b)|0}sdd(b)}h=a+24|0;j=qdd(b,574912,m,e,0)|0;if(j){if((j|0)>0){j=b+12|0;k=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;f=k+l|0;c[j>>2]=f;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[h>>2]=c[f>>2];c[j>>2]=n}else Bid(j,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](h,b)|0}sdd(b)}h=a+28|0;a=qdd(b,574928,m,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;m=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;n=m+j|0;c[a>>2]=n;if((j|0)>=0?(f=m+(j+4)|0,f>>>0<=(c[b+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[a>>2]=f}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function hgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,3143216,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;a=qdd(b,3143224,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function igc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,3143216,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,3143224,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,2416480,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;a=qdd(b,2419736,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function jgc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;h=qdd(d,574760,c[142304]|0,f,0)|0;if(h){if((h|0)>0){h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[b>>2]=c[l>>2];c[h>>2]=m}else Bid(h,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](b,d)|0}sdd(d)}h=b+4|0;m=c[142268]|0;l=qdd(d,574800,m,f,0)|0;if(l){if((l|0)>0){l=d+12|0;k=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=k+j|0;c[l>>2]=n;if((j|0)>=0?(o=k+(j+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[n>>2]);c[l>>2]=o}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}h=b+8|0;l=qdd(d,574808,m,f,0)|0;if(l){if((l|0)>0){l=d+12|0;m=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=m+o|0;c[l>>2]=n;if((o|0)>=0?(j=m+(o+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[n>>2]);c[l>>2]=j}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}h=b+16|0;l=qdd(d,574776,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else Ogc(d,h,0);sdd(d)}h=b+12|0;b=qdd(d,574784,c[142302]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;j=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=j+n|0;c[l>>2]=o;if((n|0)>=0?(j+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d);i=e;return}function kgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=qdd(d,574760,c[142304]|0,f,0)|0;if(g){if((g|0)>0){g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[b>>2]=c[k>>2];c[g>>2]=l}else Bid(g,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{g=c[f>>2]|0;if(g)_n[g&4095](b,d)|0}sdd(d)}g=b+8|0;l=qdd(d,574776,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](g,d)|0}else Ogc(d,g,0);sdd(d)}g=b+4|0;b=qdd(d,574784,c[142302]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](g,d)|0}else{l=d+12|0;k=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(k+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[h>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,g,1)}while(0);sdd(d);i=e;return}function lgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,e,4);l=c[f>>2]|0;m=c[j>>2]|0}else{c[e>>2]=c[g>>2];c[f>>2]=h;l=h;m=k}k=a+8|0;h=l+4|0;if(h>>>0>m>>>0){Bid(f,k,4);n=c[f>>2]|0;o=c[j>>2]|0}else{c[k>>2]=c[l>>2];c[f>>2]=h;n=h;o=m}m=n+4|0;if(m>>>0>o>>>0){Bid(f,a,4);p=c[f>>2]|0;q=c[j>>2]|0}else{c[a>>2]=c[n>>2];c[f>>2]=m;p=m;q=o}o=a+16|0;m=p+4|0;if(m>>>0>q>>>0){Bid(f,o,4);r=c[f>>2]|0;s=c[j>>2]|0}else{c[o>>2]=c[p>>2];c[f>>2]=m;r=m;s=q}q=a+20|0;m=r+4|0;if(m>>>0>s>>>0){Bid(f,q,4);t=a+32|0;cdc(t,b);i=d;return}else{c[q>>2]=c[r>>2];c[f>>2]=m;t=a+32|0;cdc(t,b);i=d;return}}function mgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];c[h+0>>2]=c[150284];c[h+4>>2]=c[150285];c[h+8>>2]=c[150286];d=h+12|0;c[d+0>>2]=c[150284];c[d+4>>2]=c[150285];c[d+8>>2]=c[150286];d=h+24|0;c[d+0>>2]=c[150284];c[d+4>>2]=c[150285];c[d+8>>2]=c[150286];d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b*40|0,4,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b*40|0,4,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[a+8>>2]|0)*40|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b*40|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a*40|0)|0;do{if(f){a=f+0|0;m=h+0|0;g=a+36|0;do{c[a>>2]=c[m>>2];a=a+4|0;m=m+4|0}while((a|0)<(g|0));c[f+36>>2]=0}f=f+40|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function ngc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=b;l=h}h=a+4|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[e>>2]=b;m=b;n=k}k=a+8|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[j>>2]|0}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=b;q=b;r=p}p=a+16|0;b=q+4|0;if(b>>>0>r>>>0){Bid(e,p,4);s=c[e>>2]|0;t=c[j>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[e>>2]=b;s=b;t=r}r=a+20|0;b=s+4|0;if(b>>>0>t>>>0){Bid(e,r,4);u=c[e>>2]|0;v=c[j>>2]|0}else{g[r>>2]=ea(g[s>>2]);c[e>>2]=b;u=b;v=t}t=a+24|0;b=u+4|0;if(b>>>0>v>>>0){Bid(e,t,4);w=c[e>>2]|0;x=c[j>>2]|0}else{g[t>>2]=ea(g[u>>2]);c[e>>2]=b;w=b;x=v}v=a+28|0;b=w+4|0;if(b>>>0>x>>>0){Bid(e,v,4);y=c[e>>2]|0;z=c[j>>2]|0}else{g[v>>2]=ea(g[w>>2]);c[e>>2]=b;y=b;z=x}x=a+32|0;b=y+4|0;if(b>>>0>z>>>0){Bid(e,x,4);A=c[e>>2]|0;B=c[j>>2]|0}else{g[x>>2]=ea(g[y>>2]);c[e>>2]=b;A=b;B=z}z=a+36|0;a=A+4|0;if(a>>>0>B>>>0){Bid(e,z,4);i=d;return}else{c[z>>2]=c[A>>2];c[e>>2]=a;i=d;return}}function ogc(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f;k=c[a>>2]|0;if(!k)c[a+4>>2]=c[e>>2];c[j+0>>2]=0;c[j+4>>2]=0;b[j+8>>1]=0;e=a+12|0;l=c[e>>2]|0;do if((l&2147483647)>>>0<d>>>0)if((l|0)>-1){c[e>>2]=d;c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];m=hOb(k,d*12|0,4,g,0,3653512,370)|0;c[a>>2]=m;n=m;break}else{c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];m=cOb(d*12|0,4,g,0,3653512,352)|0;YEi(m|0,c[a>>2]|0,(c[a+8>>2]|0)*12|0)|0;c[e>>2]=d;c[a>>2]=m;n=m;break}else n=k;while(0);k=a+8|0;a=c[k>>2]|0;if(a>>>0>=d>>>0){c[k>>2]=d;i=f;return}e=n+(d*12|0)|0;if((a|0)==(d|0)){c[k>>2]=d;i=f;return}g=n+(a*12|0)|0;do{if(g){c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2]}g=g+12|0}while((g|0)!=(e|0));c[k>>2]=d;i=f;return}function pgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,b,4);l=c[j>>2]|0;m=c[f>>2]|0}else{c[b>>2]=c[g>>2];c[f>>2]=h;l=k;m=h}h=b+4|0;k=m+4|0;if(k>>>0>l>>>0){Bid(f,h,4);n=c[f>>2]|0;o=c[j>>2]|0}else{c[h>>2]=c[m>>2];c[f>>2]=k;n=k;o=l}l=b+8|0;if((n+1|0)>>>0>o>>>0){Bid(f,l,1);p=c[f>>2]|0}else{a[l>>0]=a[n>>0]|0;n=(c[f>>2]|0)+1|0;c[f>>2]=n;p=n}n=b+9|0;if((p+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,n,1);Ndd(d);i=e;return}else{a[n>>0]=a[p>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function qgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+44|0;f=d+32|0;g=d+16|0;h=d+36|0;j=d+12|0;k=d;l=d+28|0;m=d+40|0;n=d+48|0;o=a+4|0;p=c[a>>2]|0;q=p;r=(c[o>>2]|0)-q>>4;if(r>>>0>=b>>>0){if(r>>>0<=b>>>0){i=d;return}c[l>>2]=p;c[m>>2]=p+(b<<4);c[f+0>>2]=c[l+0>>2];c[e+0>>2]=c[m+0>>2];Sgc(k,f,e,n,0);n=c[k>>2]|0;m=c[a>>2]|0;c[k>>2]=m;c[a>>2]=n;n=k+4|0;l=c[n>>2]|0;p=c[o>>2]|0;c[n>>2]=p;c[o>>2]=l;l=k+8|0;s=a+8|0;t=c[l>>2]|0;c[l>>2]=c[s>>2];c[s>>2]=t;if(!m){i=d;return}else u=p;while(1){if((u|0)==(m|0))break;p=u+-16|0;c[n>>2]=p;ubc(p);u=c[n>>2]|0}ACi(c[k>>2]|0);i=d;return}k=a+8|0;if(((c[k>>2]|0)-q>>4|0)==(b|0)){Rgc(a,b-r|0);i=d;return}c[g>>2]=0;r=g+4|0;c[r>>2]=0;q=g+8|0;c[q>>2]=0;Pgc(g,b);c[h>>2]=c[a>>2];c[j>>2]=c[o>>2];c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];Qgc(g,f,e);e=c[r>>2]|0;f=c[g>>2]|0;j=e-f>>4;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<4)|0,(e|0)!=(h|0)):0){f=e;do{n=f+-16|0;c[r>>2]=n;ubc(n);f=c[r>>2]|0}while((f|0)!=(h|0));v=h}else v=e;else{Rgc(g,b-j|0);v=c[r>>2]|0}j=c[g>>2]|0;b=c[a>>2]|0;c[g>>2]=b;c[a>>2]=j;j=c[o>>2]|0;c[r>>2]=j;c[o>>2]=v;v=c[q>>2]|0;c[q>>2]=c[k>>2];c[k>>2]=v;if(!b){i=d;return}else w=j;while(1){if((w|0)==(b|0))break;j=w+-16|0;c[r>>2]=j;ubc(j);w=c[r>>2]|0}ACi(c[g>>2]|0);i=d;return}function rgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=b;l=h}h=a+16|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[e>>2]=b;m=b;n=k}k=a+32|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+48|0;b=o+4|0;if(b>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[j>>2]|0}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=b;q=b;r=p}p=a+4|0;b=q+4|0;if(b>>>0>r>>>0){Bid(e,p,4);s=c[e>>2]|0;t=c[j>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[e>>2]=b;s=b;t=r}r=a+20|0;b=s+4|0;if(b>>>0>t>>>0){Bid(e,r,4);u=c[e>>2]|0;v=c[j>>2]|0}else{g[r>>2]=ea(g[s>>2]);c[e>>2]=b;u=b;v=t}t=a+36|0;b=u+4|0;if(b>>>0>v>>>0){Bid(e,t,4);w=c[e>>2]|0;x=c[j>>2]|0}else{g[t>>2]=ea(g[u>>2]);c[e>>2]=b;w=b;x=v}v=a+52|0;b=w+4|0;if(b>>>0>x>>>0){Bid(e,v,4);y=c[e>>2]|0;z=c[j>>2]|0}else{g[v>>2]=ea(g[w>>2]);c[e>>2]=b;y=b;z=x}x=a+8|0;b=y+4|0;if(b>>>0>z>>>0){Bid(e,x,4);A=c[e>>2]|0;B=c[j>>2]|0}else{g[x>>2]=ea(g[y>>2]);c[e>>2]=b;A=b;B=z}z=a+24|0;b=A+4|0;if(b>>>0>B>>>0){Bid(e,z,4);C=c[e>>2]|0;D=c[j>>2]|0}else{g[z>>2]=ea(g[A>>2]);c[e>>2]=b;C=b;D=B}B=a+40|0;b=C+4|0;if(b>>>0>D>>>0){Bid(e,B,4);E=c[e>>2]|0;F=c[j>>2]|0}else{g[B>>2]=ea(g[C>>2]);c[e>>2]=b;E=b;F=D}D=a+56|0;b=E+4|0;if(b>>>0>F>>>0){Bid(e,D,4);G=c[e>>2]|0;H=c[j>>2]|0}else{g[D>>2]=ea(g[E>>2]);c[e>>2]=b;G=b;H=F}F=a+12|0;b=G+4|0;if(b>>>0>H>>>0){Bid(e,F,4);I=c[e>>2]|0;J=c[j>>2]|0}else{g[F>>2]=ea(g[G>>2]);c[e>>2]=b;I=b;J=H}H=a+28|0;b=I+4|0;if(b>>>0>J>>>0){Bid(e,H,4);K=c[e>>2]|0;L=c[j>>2]|0}else{g[H>>2]=ea(g[I>>2]);c[e>>2]=b;K=b;L=J}J=a+44|0;b=K+4|0;if(b>>>0>L>>>0){Bid(e,J,4);M=c[e>>2]|0;N=c[j>>2]|0}else{g[J>>2]=ea(g[K>>2]);c[e>>2]=b;M=b;N=L}L=a+60|0;a=M+4|0;if(a>>>0>N>>>0){Bid(e,L,4);i=d;return}else{g[L>>2]=ea(g[M>>2]);c[e>>2]=a;i=d;return}}function sgc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(f,b,4);m=c[k>>2]|0;n=c[f>>2]|0}else{c[b>>2]=c[h>>2];c[f>>2]=j;m=l;n=j}j=b+4|0;l=n+4|0;if(l>>>0>m>>>0){Bid(f,j,4);o=c[f>>2]|0;p=c[k>>2]|0}else{g[j>>2]=ea(g[n>>2]);c[f>>2]=l;o=l;p=m}m=b+8|0;l=o+4|0;if(l>>>0>p>>>0)Bid(f,m,4);else{g[m>>2]=ea(g[o>>2]);c[f>>2]=l}tgc(d,b+16|0,0);Ndd(d);l=b+12|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(f,l,1);Ndd(d);i=e;return}else{a[l>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function tgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}Tgc(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]|0)|0;c[j>>2]=0;i=d;return}function ugc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=a+4|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,e,4);l=c[f>>2]|0;m=c[j>>2]|0;n=c[e>>2]|0}else{o=c[g>>2]|0;c[e>>2]=o;c[f>>2]=h;l=h;m=k;n=o}c[e>>2]=XEi(n|0)|0;n=a+8|0;e=l+4|0;if(e>>>0>m>>>0){Bid(f,n,4);p=c[n>>2]|0;q=c[f>>2]|0;r=c[j>>2]|0}else{o=c[l>>2]|0;c[n>>2]=o;c[f>>2]=e;p=o;q=e;r=m}c[n>>2]=XEi(p|0)|0;p=q+4|0;if(p>>>0>r>>>0){Bid(f,a,4);s=c[a>>2]|0;t=c[f>>2]|0;u=c[j>>2]|0}else{n=c[q>>2]|0;c[a>>2]=n;c[f>>2]=p;s=n;t=p;u=r}c[a>>2]=XEi(s|0)|0;s=a+16|0;r=t+4|0;if(r>>>0>u>>>0){Bid(f,s,4);v=c[s>>2]|0;w=c[f>>2]|0;x=c[j>>2]|0}else{j=c[t>>2]|0;c[s>>2]=j;c[f>>2]=r;v=j;w=r;x=u}c[s>>2]=XEi(v|0)|0;v=a+20|0;s=w+4|0;if(s>>>0>x>>>0){Bid(f,v,4);y=c[v>>2]|0;z=XEi(y|0)|0;c[v>>2]=z;A=a+32|0;gdc(A,b);i=d;return}else{x=c[w>>2]|0;c[v>>2]=x;c[f>>2]=s;y=x;z=XEi(y|0)|0;c[v>>2]=z;A=a+32|0;gdc(A,b);i=d;return}}function vgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,b,4);l=c[f>>2]|0;m=c[j>>2]|0;n=c[b>>2]|0}else{o=c[g>>2]|0;c[b>>2]=o;c[f>>2]=h;l=h;m=k;n=o}c[b>>2]=XEi(n|0)|0;n=b+4|0;o=l+4|0;if(o>>>0>m>>>0){Bid(f,n,4);p=c[n>>2]|0;q=c[f>>2]|0;r=c[j>>2]|0}else{k=c[l>>2]|0;c[n>>2]=k;c[f>>2]=o;p=k;q=o;r=m}c[n>>2]=XEi(p|0)|0;p=b+8|0;if((q+1|0)>>>0>r>>>0){Bid(f,p,1);s=c[f>>2]|0}else{a[p>>0]=a[q>>0]|0;q=(c[f>>2]|0)+1|0;c[f>>2]=q;s=q}q=b+9|0;if((s+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,q,1);Mdd(d);i=e;return}else{a[q>>0]=a[s>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function wgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;EUb(a,b);e=a+4|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(f,e,4);k=c[f>>2]|0;l=c[j>>2]|0;m=c[e>>2]|0}else{n=c[g>>2]|0;c[e>>2]=n;c[f>>2]=h;k=h;l=b;m=n}c[e>>2]=XEi(m|0)|0;m=a+8|0;e=k+4|0;if(e>>>0>l>>>0){Bid(f,m,4);o=c[m>>2]|0;p=c[f>>2]|0;q=c[j>>2]|0}else{j=c[k>>2]|0;c[m>>2]=j;c[f>>2]=e;o=j;p=e;q=l}c[m>>2]=XEi(o|0)|0;o=a+12|0;a=p+4|0;if(a>>>0>q>>>0){Bid(f,o,4);r=c[o>>2]|0;s=XEi(r|0)|0;c[o>>2]=s;i=d;return}else{q=c[p>>2]|0;c[o>>2]=q;c[f>>2]=a;r=q;s=XEi(r|0)|0;c[o>>2]=s;i=d;return}}function xgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+16|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+32|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+48|0;u=w+4|0;if(u>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=c[e>>2]|0;B=c[j>>2]|0}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=u;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=a+4|0;y=A+4|0;if(y>>>0>B>>>0){Bid(e,z,4);C=z;D=c[z>>2]|0;E=c[e>>2]|0;F=c[j>>2]|0}else{p=ea(g[A>>2]);g[z>>2]=p;c[e>>2]=y;C=z;D=(g[k>>2]=p,c[k>>2]|0);E=y;F=B}c[C>>2]=XEi(D|0)|0;D=a+20|0;C=E+4|0;if(C>>>0>F>>>0){Bid(e,D,4);G=D;H=c[D>>2]|0;I=c[e>>2]|0;J=c[j>>2]|0}else{p=ea(g[E>>2]);g[D>>2]=p;c[e>>2]=C;G=D;H=(g[k>>2]=p,c[k>>2]|0);I=C;J=F}c[G>>2]=XEi(H|0)|0;H=a+36|0;G=I+4|0;if(G>>>0>J>>>0){Bid(e,H,4);K=H;L=c[H>>2]|0;M=c[e>>2]|0;N=c[j>>2]|0}else{p=ea(g[I>>2]);g[H>>2]=p;c[e>>2]=G;K=H;L=(g[k>>2]=p,c[k>>2]|0);M=G;N=J}c[K>>2]=XEi(L|0)|0;L=a+52|0;K=M+4|0;if(K>>>0>N>>>0){Bid(e,L,4);O=L;P=c[L>>2]|0;Q=c[e>>2]|0;R=c[j>>2]|0}else{p=ea(g[M>>2]);g[L>>2]=p;c[e>>2]=K;O=L;P=(g[k>>2]=p,c[k>>2]|0);Q=K;R=N}c[O>>2]=XEi(P|0)|0;P=a+8|0;O=Q+4|0;if(O>>>0>R>>>0){Bid(e,P,4);S=P;T=c[P>>2]|0;U=c[e>>2]|0;V=c[j>>2]|0}else{p=ea(g[Q>>2]);g[P>>2]=p;c[e>>2]=O;S=P;T=(g[k>>2]=p,c[k>>2]|0);U=O;V=R}c[S>>2]=XEi(T|0)|0;T=a+24|0;S=U+4|0;if(S>>>0>V>>>0){Bid(e,T,4);W=T;X=c[T>>2]|0;Y=c[e>>2]|0;Z=c[j>>2]|0}else{p=ea(g[U>>2]);g[T>>2]=p;c[e>>2]=S;W=T;X=(g[k>>2]=p,c[k>>2]|0);Y=S;Z=V}c[W>>2]=XEi(X|0)|0;X=a+40|0;W=Y+4|0;if(W>>>0>Z>>>0){Bid(e,X,4);_=X;$=c[e>>2]|0;aa=c[j>>2]|0;ba=c[X>>2]|0}else{p=ea(g[Y>>2]);g[X>>2]=p;c[e>>2]=W;_=X;$=W;aa=Z;ba=(g[k>>2]=p,c[k>>2]|0)}c[_>>2]=XEi(ba|0)|0;ba=a+56|0;_=$+4|0;if(_>>>0>aa>>>0){Bid(e,ba,4);ca=ba;da=c[ba>>2]|0;fa=c[e>>2]|0;ga=c[j>>2]|0}else{p=ea(g[$>>2]);g[ba>>2]=p;c[e>>2]=_;ca=ba;da=(g[k>>2]=p,c[k>>2]|0);fa=_;ga=aa}c[ca>>2]=XEi(da|0)|0;da=a+12|0;ca=fa+4|0;if(ca>>>0>ga>>>0){Bid(e,da,4);ha=da;ia=c[da>>2]|0;ja=c[e>>2]|0;ka=c[j>>2]|0}else{p=ea(g[fa>>2]);g[da>>2]=p;c[e>>2]=ca;ha=da;ia=(g[k>>2]=p,c[k>>2]|0);ja=ca;ka=ga}c[ha>>2]=XEi(ia|0)|0;ia=a+28|0;ha=ja+4|0;if(ha>>>0>ka>>>0){Bid(e,ia,4);la=ia;ma=c[ia>>2]|0;na=c[e>>2]|0;oa=c[j>>2]|0}else{p=ea(g[ja>>2]);g[ia>>2]=p;c[e>>2]=ha;la=ia;ma=(g[k>>2]=p,c[k>>2]|0);na=ha;oa=ka}c[la>>2]=XEi(ma|0)|0;ma=a+44|0;la=na+4|0;if(la>>>0>oa>>>0){Bid(e,ma,4);pa=ma;qa=c[ma>>2]|0;ra=c[e>>2]|0;sa=c[j>>2]|0}else{p=ea(g[na>>2]);g[ma>>2]=p;c[e>>2]=la;pa=ma;qa=(g[k>>2]=p,c[k>>2]|0);ra=la;sa=oa}c[pa>>2]=XEi(qa|0)|0;qa=a+60|0;a=ra+4|0;if(a>>>0>sa>>>0){Bid(e,qa,4);ta=qa;ua=c[qa>>2]|0;va=XEi(ua|0)|0;c[ta>>2]=va;i=d;return}else{p=ea(g[ra>>2]);g[qa>>2]=p;c[e>>2]=a;ta=qa;ua=(g[k>>2]=p,c[k>>2]|0);va=XEi(ua|0)|0;c[ta>>2]=va;i=d;return}}function ygc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;u=w+4|0;if(u>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=c[e>>2]|0;B=c[j>>2]|0}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=u;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=u;B=x}c[y>>2]=XEi(z|0)|0;z=a+16|0;y=A+4|0;if(y>>>0>B>>>0){Bid(e,z,4);C=c[z>>2]|0;D=c[e>>2]|0;E=c[j>>2]|0}else{x=c[A>>2]|0;c[z>>2]=x;c[e>>2]=y;C=x;D=y;E=B}c[z>>2]=XEi(C|0)|0;C=a+20|0;z=D+4|0;if(z>>>0>E>>>0){Bid(e,C,4);F=c[C>>2]|0;G=c[e>>2]|0;H=c[j>>2]|0}else{B=c[D>>2]|0;c[C>>2]=B;c[e>>2]=z;F=B;G=z;H=E}c[C>>2]=XEi(F|0)|0;F=a+24|0;C=G+4|0;if(C>>>0>H>>>0){Bid(e,F,4);I=c[F>>2]|0;J=c[e>>2]|0;K=c[j>>2]|0}else{j=c[G>>2]|0;c[F>>2]=j;c[e>>2]=C;I=j;J=C;K=H}c[F>>2]=XEi(I|0)|0;I=a+28|0;a=J+4|0;if(a>>>0>K>>>0){Bid(e,I,4);L=c[I>>2]|0;M=XEi(L|0)|0;c[I>>2]=M;i=d;return}else{K=c[J>>2]|0;c[I>>2]=K;c[e>>2]=a;L=K;M=XEi(L|0)|0;c[I>>2]=M;i=d;return}}function zgc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;l=d+20|0;m=c[l>>2]|0;if(j>>>0>m>>>0){Bid(f,b,4);n=c[f>>2]|0;o=c[l>>2]|0;p=c[b>>2]|0}else{q=c[h>>2]|0;c[b>>2]=q;c[f>>2]=j;n=j;o=m;p=q}c[b>>2]=XEi(p|0)|0;p=b+4|0;q=n+4|0;if(q>>>0>o>>>0){Bid(f,p,4);r=p;s=c[p>>2]|0;t=c[f>>2]|0;u=c[l>>2]|0}else{v=ea(g[n>>2]);g[p>>2]=v;c[f>>2]=q;r=p;s=(g[k>>2]=v,c[k>>2]|0);t=q;u=o}c[r>>2]=XEi(s|0)|0;s=b+8|0;r=t+4|0;if(r>>>0>u>>>0){Bid(f,s,4);w=s;x=c[s>>2]|0}else{v=ea(g[t>>2]);g[s>>2]=v;c[f>>2]=r;w=s;x=(g[k>>2]=v,c[k>>2]|0)}c[w>>2]=XEi(x|0)|0;Ugc(d,b+16|0,0);Mdd(d);x=b+12|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(f,x,1);Mdd(d);i=e;return}else{a[x>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function Agc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;if(h>>>0>(c[j>>2]|0)>>>0){Bid(f,b,4);k=c[b>>2]|0}else{l=c[g>>2]|0;c[b>>2]=l;c[f>>2]=h;k=l}c[b>>2]=XEi(k|0)|0;Ugc(d,b+8|0,0);Mdd(d);k=b+4|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,k,1);Mdd(d);i=e;return}else{a[k>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function Bgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}h=a+12|0;n=o+4|0;if(n>>>0<p>>>0){g[o>>2]=ea(g[h>>2]);c[e>>2]=n;q=n;r=p}else{Gid(e,h,4);q=c[e>>2]|0;r=c[j>>2]|0}h=a+16|0;p=q+4|0;if(p>>>0<r>>>0){g[q>>2]=ea(g[h>>2]);c[e>>2]=p;s=p;t=r}else{Gid(e,h,4);s=c[e>>2]|0;t=c[j>>2]|0}h=a+20|0;r=s+4|0;if(r>>>0<t>>>0){g[s>>2]=ea(g[h>>2]);c[e>>2]=r;u=r;v=t}else{Gid(e,h,4);u=c[e>>2]|0;v=c[j>>2]|0}h=a+24|0;t=u+4|0;if(t>>>0<v>>>0){g[u>>2]=ea(g[h>>2]);c[e>>2]=t;w=t;x=v}else{Gid(e,h,4);w=c[e>>2]|0;x=c[j>>2]|0}h=a+28|0;v=w+4|0;if(v>>>0<x>>>0){g[w>>2]=ea(g[h>>2]);c[e>>2]=v;y=v;z=x}else{Gid(e,h,4);y=c[e>>2]|0;z=c[j>>2]|0}h=a+32|0;x=y+4|0;if(x>>>0<z>>>0){g[y>>2]=ea(g[h>>2]);c[e>>2]=x;A=x;B=z}else{Gid(e,h,4);A=c[e>>2]|0;B=c[j>>2]|0}j=a+36|0;a=A+4|0;if(a>>>0<B>>>0){c[A>>2]=c[j>>2];c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function Cgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0<k>>>0){c[g>>2]=c[b>>2];c[f>>2]=h;l=k;m=h}else{Gid(f,b,4);l=c[j>>2]|0;m=c[f>>2]|0}h=b+4|0;k=m+4|0;if(k>>>0<l>>>0){c[m>>2]=c[h>>2];c[f>>2]=k;n=k;o=l}else{Gid(f,h,4);n=c[f>>2]|0;o=c[j>>2]|0}h=b+8|0;if((n+1|0)>>>0<o>>>0){a[n>>0]=a[h>>0]|0;n=(c[f>>2]|0)+1|0;c[f>>2]=n;p=n}else{Gid(f,h,1);p=c[f>>2]|0}h=b+9|0;if((p+1|0)>>>0<(c[j>>2]|0)>>>0){a[p>>0]=a[h>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Tdd(d);i=e;return}else{Gid(f,h,1);Tdd(d);i=e;return}}function Dgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;f=b+4|0;g=c[f>>2]|0;h=c[b>>2]|0;j=g-h>>4;c[e>>2]=j;k=a+12|0;l=c[k>>2]|0;m=l+4|0;n=a+20|0;if(m>>>0<(c[n>>2]|0)>>>0){c[l>>2]=j;c[k>>2]=m;o=h;p=g}else{Gid(k,e,4);o=c[b>>2]|0;p=c[f>>2]|0}if((o|0)==(p|0)){i=d;return}else q=o;do{GUb(q,a);o=q+4|0;f=c[k>>2]|0;b=f+4|0;e=c[n>>2]|0;if(b>>>0<e>>>0){c[f>>2]=c[o>>2];c[k>>2]=b;r=b;s=e}else{Gid(k,o,4);r=c[k>>2]|0;s=c[n>>2]|0}o=q+8|0;e=r+4|0;if(e>>>0<s>>>0){c[r>>2]=c[o>>2];c[k>>2]=e;t=e;u=s}else{Gid(k,o,4);t=c[k>>2]|0;u=c[n>>2]|0}o=q+12|0;e=t+4|0;if(e>>>0<u>>>0){c[t>>2]=c[o>>2];c[k>>2]=e}else Gid(k,o,4);q=q+16|0}while((q|0)!=(p|0));i=d;return}function Egc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){c[j>>2]=c[b>>2];c[h>>2]=k;n=m;o=k}else{Gid(h,b,4);n=c[l>>2]|0;o=c[h>>2]|0}k=b+4|0;m=o+4|0;if(m>>>0<n>>>0){g[o>>2]=ea(g[k>>2]);c[h>>2]=m;p=m;q=n}else{Gid(h,k,4);p=c[h>>2]|0;q=c[l>>2]|0}k=b+8|0;n=p+4|0;if(n>>>0<q>>>0){g[p>>2]=ea(g[k>>2]);c[h>>2]=n;r=n;s=q}else{Gid(h,k,4);r=c[h>>2]|0;s=c[l>>2]|0}k=b+20|0;q=c[k>>2]|0;n=b+16|0;p=c[n>>2]|0;m=q-p|0;c[f>>2]=m;o=r+4|0;if(o>>>0<s>>>0){c[r>>2]=m;c[h>>2]=o;t=p;u=q}else{Gid(h,f,4);t=c[n>>2]|0;u=c[k>>2]|0}if((t|0)!=(u|0)){k=t;do{t=c[h>>2]|0;if((t+1|0)>>>0<(c[l>>2]|0)>>>0){a[t>>0]=a[k>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,k,1);k=k+1|0}while((k|0)!=(u|0))}Tdd(d);u=b+12|0;b=c[h>>2]|0;if((b+1|0)>>>0<(c[l>>2]|0)>>>0){a[b>>0]=a[u>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Tdd(d);i=e;return}else{Gid(h,u,1);Tdd(d);i=e;return}}function Fgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[b>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,b,4);m=c[g>>2]|0;n=c[k>>2]|0}l=b+12|0;j=c[l>>2]|0;h=b+8|0;o=c[h>>2]|0;p=j-o|0;c[f>>2]=p;q=m+4|0;if(q>>>0<n>>>0){c[m>>2]=p;c[g>>2]=q;r=o;s=j}else{Gid(g,f,4);r=c[h>>2]|0;s=c[l>>2]|0}if((r|0)!=(s|0)){l=r;do{r=c[g>>2]|0;if((r+1|0)>>>0<(c[k>>2]|0)>>>0){a[r>>0]=a[l>>0]|0;c[g>>2]=(c[g>>2]|0)+1}else Gid(g,l,1);l=l+1|0}while((l|0)!=(s|0))}Tdd(d);s=b+4|0;b=c[g>>2]|0;if((b+1|0)>>>0<(c[k>>2]|0)>>>0){a[b>>0]=a[s>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Tdd(d);i=e;return}else{Gid(g,s,1);Tdd(d);i=e;return}}function Ggc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;add(b,3147344,c[142294]|0,a,0);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);e=b+12|0;f=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,2535104,c[142304]|0,a+4|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);g=c[142270]|0;add(b,575112,g,a+8|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,575128,g,a+12|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function Hgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=(j|0)/56|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=((m-o|0)/56|0)>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=(q|0)/56|0;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(((s|0)/56|0)*56|0)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~(((s+-56-d|0)>>>0)/56|0)*56|0);i=e;return}d=h+(r*56|0)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{u=q+0|0;v=r+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=c[p>>2]|0}q=t+56|0;c[p>>2]=q;r=r+56|0}while((r|0)!=(b|0));i=e;return}if(!n)x=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~(((r+-56-o|0)>>>0)/56|0)*56|0);c[g>>2]=10;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=(x-0|0)/56|0;if(j>>>0<1073741823){x=j<<1;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=10;c[f+0>>2]=c[g+0>>2];g=cOb(y*56|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y*56|0);if((h|0)==(b|0)){i=e;return}else{z=g;A=h}do{if(!z)B=0;else{u=z+0|0;v=A+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));B=c[f>>2]|0}z=B+56|0;c[f>>2]=z;A=A+56|0}while((A|0)!=(b|0));i=e;return}function Igc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=10;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/56|0)*56|0);d=g;g=k;do{if(!d)l=0;else{k=d+0|0;j=g+0|0;a=k+56|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(a|0));l=c[h>>2]|0}d=l+56|0;c[h>>2]=d;g=g+56|0}while((g|0)!=(b|0));i=f;return}function Jgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[142310]|0;g=qdd(b,575192,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else _6b(a,b);sdd(b)}g=a+12|0;h=qdd(b,2504600,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else _6b(g,b);sdd(b)}g=a+24|0;h=qdd(b,2504728,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else _6b(g,b);sdd(b)}g=a+36|0;a=qdd(b,2984400,c[142304]|0,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;h=c[b+16>>2]|0;f=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=h+f|0;c[a>>2]=j;if((f|0)>=0?(k=h+(f+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[a>>2]=k}else Bid(a,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}sdd(b);i=d;return}function Kgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[142304]|0;h=qdd(d,575144,g,f,0)|0;if(h){if((h|0)>0){h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[b>>2]=c[l>>2];c[h>>2]=m}else Bid(h,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](b,d)|0}sdd(d)}h=b+4|0;m=qdd(d,2533664,g,f,0)|0;if(m){if((m|0)>0){m=d+12|0;g=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=g+l|0;c[m>>2]=k;if((l|0)>=0?(j=g+(l+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[m>>2]=j}else Bid(m,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}sdd(d)}h=b+8|0;m=c[142258]|0;j=qdd(d,575160,m,f,0)|0;if(j){do if((j|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else{k=d+12|0;l=c[d+16>>2]|0;g=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+g|0;c[k>>2]=n;if((g|0)>=0?(l+(g+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[k>>2]=(c[k>>2]|0)+1;break}Bid(k,h,1)}while(0);sdd(d)}h=b+9|0;b=qdd(d,575176,m,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=j+k|0;c[m>>2]=n;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d);i=e;return}function Lgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=qdd(b,3147344,c[142294]|0,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else zUb(a,b);sdd(b)}f=a+4|0;g=qdd(b,2535104,c[142304]|0,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}sdd(b)}f=a+8|0;g=c[142270]|0;l=qdd(b,575112,g,e,0)|0;if(l){if((l|0)>0){l=b+12|0;k=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(m=k+(j+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[h>>2];c[l>>2]=m}else Bid(l,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](f,b)|0}sdd(b)}f=a+12|0;a=qdd(b,575128,g,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;g=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=g+l|0;c[a>>2]=m;if((l|0)>=0?(h=g+(l+4)|0,h>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[a>>2]=h}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function Mgc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=b+8|0;m=c[l>>2]|0;n=c[b>>2]|0;o=n;if(k>>>0<=(m-o|0)>>>0){p=b+4|0;q=(c[p>>2]|0)-o|0;if(k>>>0<=q>>>0){o=d-e|0;aFi(n|0,j|0,o|0)|0;e=n+o|0;if((c[p>>2]|0)==(e|0)){i=f;return}c[p>>2]=e;i=f;return}e=j+q|0;aFi(n|0,j|0,q|0)|0;if((e|0)==(d|0)){i=f;return}q=c[p>>2]|0;o=e;do{if(!q)r=0;else{a[q>>0]=a[o>>0]|0;r=c[p>>2]|0}q=r+1|0;c[p>>2]=q;o=o+1|0}while((o|0)!=(d|0));i=f;return}if(!n)s=m;else{m=b+4|0;if((c[m>>2]|0)!=(n|0))c[m>>2]=n;c[h>>2]=8;c[g+0>>2]=c[h+0>>2];eOb(n,g);c[l>>2]=0;c[m>>2]=0;c[b>>2]=0;s=0}if((k|0)<0)vxi(b);m=s-0|0;if(m>>>0<1073741823){s=m<<1;m=s>>>0<k>>>0?k:s;if((m|0)<0)vxi(b);else t=m}else t=2147483647;c[h>>2]=8;c[g+0>>2]=c[h+0>>2];h=cOb(t,16,g,0,3653512,80)|0;g=b+4|0;c[g>>2]=h;c[b>>2]=h;c[l>>2]=h+t;if((j|0)==(d|0)){i=f;return}else{u=h;v=j}do{if(!u)w=0;else{a[u>>0]=a[v>>0]|0;w=c[g>>2]|0}u=w+1|0;c[g>>2]=u;v=v+1|0}while((v|0)!=(d|0));i=f;return}function Ngc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=8;c[f+0>>2]=c[h+0>>2];h=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=h;c[b>>2]=h;c[k>>2]=h+e;e=h;h=l;do{if(!e)m=0;else{a[e>>0]=a[h>>0]|0;m=c[j>>2]|0}e=m+1|0;c[j>>2]=e;h=h+1|0}while((h|0)!=(d|0));i=g;return}function Ogc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e;j=d+4|0;c[g>>2]=(c[j>>2]|0)-(c[d>>2]|0);if(!(tdd(b,2646336,2646336,g)|0)){i=e;return}Tgc(d,c[g>>2]|0);k=c[j>>2]|0;do if(c[g>>2]|0){j=c[142302]|0;l=qdd(b,3142592,j,0,0)|0;m=b+80|0;n=c[($hd(c[m>>2]|0)|0)+12>>2]|0;o=b+84|0;c[c[o>>2]>>2]=0;if((l|0)==2){l=c[m>>2]|0;p=c[l+12>>2]|0;q=c[d>>2]|0;a:do if((q|0)!=(k|0)){r=b+12|0;s=b+16|0;t=b+28|0;u=b+32|0;v=b+20|0;w=0;x=l;y=q;while(1){z=(da(w,n)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[o>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(A+(B+1)|0)>>>0<=(c[v>>2]|0)>>>0:0){a[y>>0]=a[z>>0]|0;c[r>>2]=(c[r>>2]|0)+1}else Bid(r,y,1);z=y+1|0;if((z|0)==(k|0))break a;w=c[c[o>>2]>>2]|0;x=c[m>>2]|0;y=z}}while(0);sdd(b);break}sdd(b);o=c[d>>2]|0;if((o|0)!=(k|0)){p=b+12|0;n=b+16|0;q=b+28|0;l=b+32|0;y=b+20|0;x=o;do{o=qdd(b,3142592,j,f,0)|0;if(o){do if((o|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](x,b)|0}else{w=c[n>>2]|0;r=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[l>>2]|0,c[q>>2]|0)|0)|0;v=w+r|0;c[p>>2]=v;if((r|0)>=0?(w+(r+1)|0)>>>0<=(c[y>>2]|0)>>>0:0){a[x>>0]=a[v>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,x,1)}while(0);sdd(b)}x=x+1|0}while((x|0)!=(k|0))}}while(0);udd(b);i=e;return}function Pgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((c[e>>2]|0)-g>>4>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b<<4)|0;l=k+(j-g>>4<<4)|0;g=k+(b<<4)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=j+-16|0;p=b;b=b+-16|0;c[k>>2]=0;sbc(k,b);q=j+-12|0;r=p+-12|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];if((b|0)==(f|0)){s=k;break}else j=k}m=s;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-16|0;ubc(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function Qgc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[b>>2]|0;b=c[d>>2]|0;d=f;g=b-d>>4;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>4>>>0){if(!k)m=j;else{j=a+4|0;while(1){n=c[j>>2]|0;if((n|0)==(k|0))break;o=n+-16|0;c[j>>2]=o;ubc(o)}ACi(c[a>>2]|0);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>268435455)vxi(a);j=m-0|0;if(j>>4>>>0<134217727){m=j>>3;j=m>>>0<g>>>0?g:m;if(j>>>0>268435455)vxi(a);else p=j}else p=268435455;j=xCi(p<<4)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(p<<4);if((f|0)==(b|0)){i=e;return}else{q=j;r=f}do{c[q>>2]=0;sbc(q,r);j=q+4|0;p=r+4|0;c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];q=(c[m>>2]|0)+16|0;c[m>>2]=q;r=r+16|0}while((r|0)!=(b|0));i=e;return}r=a+4|0;a=(c[r>>2]|0)-l>>4;if(g>>>0>a>>>0){s=f+(a<<4)|0;t=1}else{s=b;t=0}if((f|0)==(s|0))u=k;else{a=(s+-16-d|0)>>>4;d=k;g=f;while(1){rbc(d,g);f=d+4|0;l=g+4|0;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];g=g+16|0;if((g|0)==(s|0))break;else d=d+16|0}u=k+(a+1<<4)|0}if(!t){while(1){t=c[r>>2]|0;if((t|0)==(u|0))break;a=t+-16|0;c[r>>2]=a;ubc(a)}i=e;return}if((s|0)==(b|0)){i=e;return}u=c[r>>2]|0;a=s;do{if(!u)v=0;else{c[u>>2]=0;sbc(u,a);s=u+4|0;t=a+4|0;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];v=c[r>>2]|0}u=v+16|0;c[r>>2]=u;a=a+16|0}while((a|0)!=(b|0));i=e;return}function Rgc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>4>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;qbc(l);m=c[g>>2]|0}l=m+16|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>4)+b|0;if(l>>>0>268435455)vxi(a);j=k;k=f-j|0;if(k>>4>>>0<134217727){f=k>>3;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>4;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=268435455;r=(c[g>>2]|0)-j>>4;s=10}if((s|0)==10){n=q;o=xCi(q<<4)|0;p=r}r=o+(p<<4)|0;p=o+(n<<4)|0;n=b;b=r;while(1){if(!b)t=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;qbc(b);t=b}o=t+16|0;n=n+-1|0;if(!n){u=o;break}else b=o}b=c[a>>2]|0;n=c[g>>2]|0;if((n|0)==(b|0)){v=r;w=b;x=b}else{t=n;n=r;while(1){r=n+-16|0;o=t;t=t+-16|0;c[r>>2]=0;sbc(r,t);q=n+-12|0;s=o+-12|0;c[q+0>>2]=c[s+0>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];if((t|0)==(b|0)){y=r;break}else n=r}v=y;w=c[a>>2]|0;x=c[g>>2]|0}c[a>>2]=v;c[g>>2]=u;c[e>>2]=p;p=x;while(1){if((p|0)==(w|0))break;x=p+-16|0;ubc(x);p=x}if(!w){i=d;return}ACi(w);i=d;return}function Sgc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;g=a+8|0;c[g>>2]=0;h=c[b>>2]|0;b=c[d>>2]|0;d=b-h|0;j=d>>4;if(!j){i=f;return}if(j>>>0>268435455)vxi(a);k=xCi(d)|0;c[e>>2]=k;c[a>>2]=k;c[g>>2]=k+(j<<4);if((h|0)==(b|0)){i=f;return}else{l=k;m=h}do{c[l>>2]=0;sbc(l,m);h=l+4|0;k=m+4|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];l=(c[e>>2]|0)+16|0;c[e>>2]=l;m=m+16|0}while((m|0)!=(b|0));i=f;return}function Tgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e;m=b+4|0;n=c[m>>2]|0;o=c[b>>2]|0;p=o;q=n-p|0;if(q>>>0>=d>>>0){if(q>>>0<=d>>>0){i=e;return}r=o+d|0;c[l>>2]=0;s=l+4|0;c[s>>2]=0;t=l+8|0;c[t>>2]=0;if(!d){u=o;v=0;w=n;x=0;y=0}else{if((d|0)<0)vxi(l);z=xCi(d)|0;c[s>>2]=z;c[l>>2]=z;c[t>>2]=z+d;A=o;B=z;while(1){a[B>>0]=a[A>>0]|0;z=(c[s>>2]|0)+1|0;c[s>>2]=z;A=A+1|0;if((A|0)==(r|0)){C=z;break}else B=z}u=c[b>>2]|0;v=c[l>>2]|0;w=c[m>>2]|0;x=C;y=c[t>>2]|0}c[l>>2]=u;c[b>>2]=v;c[s>>2]=w;c[m>>2]=x;x=b+8|0;c[t>>2]=c[x>>2];c[x>>2]=y;if(!u){i=e;return}if((w|0)!=(u|0))c[s>>2]=u;ACi(u);i=e;return}u=b+8|0;if(((c[u>>2]|0)-p|0)==(d|0)){Wgc(b,d-q|0);i=e;return}c[h>>2]=0;q=h+4|0;c[q>>2]=0;p=h+8|0;c[p>>2]=0;if(d){s=xCi(d)|0;c[h>>2]=s;c[q>>2]=s;c[p>>2]=s+d}c[j>>2]=o;c[k>>2]=n;c[g+0>>2]=c[j+0>>2];c[f+0>>2]=c[k+0>>2];Vgc(h,g,f);f=c[q>>2]|0;g=c[h>>2]|0;k=f-g|0;if(k>>>0>=d>>>0)if(k>>>0>d>>>0?(j=g+d|0,(f|0)!=(j|0)):0){c[q>>2]=j;D=g;E=j}else{D=g;E=f}else{Wgc(h,d-k|0);D=c[h>>2]|0;E=c[q>>2]|0}k=c[b>>2]|0;c[h>>2]=k;c[b>>2]=D;D=c[m>>2]|0;c[q>>2]=D;c[m>>2]=E;E=c[p>>2]|0;c[p>>2]=c[u>>2];c[u>>2]=E;if(!k){i=e;return}if((D|0)!=(k|0))c[q>>2]=k;ACi(k);i=e;return}function Ugc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+12|0;k=b+48|0;l=c[j>>2]|0;m=l+4|0;n=b+20|0;b=c[n>>2]|0;o=m>>>0>b>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=b}b=XEi(p|0)|0;c[g>>2]=b;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=b}b=XEi(t|0)|0;c[f>>2]=b;zid(j,b,u)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;Tgc(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;if((h+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(j,w,1);else{a[w>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}w=w+1|0}while((w|0)!=(o|0));i=e;return}function Vgc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;g=c[d>>2]|0;d=c[e>>2]|0;e=g;h=d-e|0;j=b+8|0;k=c[j>>2]|0;l=c[b>>2]|0;m=l;if(h>>>0<=(k-m|0)>>>0){n=b+4|0;o=(c[n>>2]|0)-m|0;if(h>>>0<=o>>>0){m=d-e|0;aFi(l|0,g|0,m|0)|0;e=l+m|0;if((c[n>>2]|0)==(e|0)){i=f;return}c[n>>2]=e;i=f;return}e=g+o|0;aFi(l|0,g|0,o|0)|0;if((e|0)==(d|0)){i=f;return}o=c[n>>2]|0;m=e;do{if(!o)p=0;else{a[o>>0]=a[m>>0]|0;p=c[n>>2]|0}o=p+1|0;c[n>>2]=o;m=m+1|0}while((m|0)!=(d|0));i=f;return}if(!l)q=k;else{k=b+4|0;if((c[k>>2]|0)!=(l|0))c[k>>2]=l;ACi(l);c[j>>2]=0;c[k>>2]=0;c[b>>2]=0;q=0}if((h|0)<0)vxi(b);k=q-0|0;if(k>>>0<1073741823){q=k<<1;k=q>>>0<h>>>0?h:q;if((k|0)<0)vxi(b);else r=k}else r=2147483647;k=xCi(r)|0;q=b+4|0;c[q>>2]=k;c[b>>2]=k;c[j>>2]=k+r;if((g|0)==(d|0)){i=f;return}else{s=g;t=k}do{a[t>>0]=a[s>>0]|0;t=(c[q>>2]|0)+1|0;c[q>>2]=t;s=s+1|0}while((s|0)!=(d|0));i=f;return}function Wgc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=b+8|0;g=c[f>>2]|0;h=b+4|0;j=c[h>>2]|0;k=j;if((g-k|0)>>>0>=d>>>0){l=d;m=j;do{if(!m)n=0;else{a[m>>0]=0;n=c[h>>2]|0}m=n+1|0;c[h>>2]=m;l=l+-1|0}while((l|0)!=0);i=e;return}l=c[b>>2]|0;m=k-l+d|0;if((m|0)<0)vxi(b);k=l;l=g-k|0;if(l>>>0<1073741823){g=l<<1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k|0;if(!l){o=0;p=0;q=g}else{r=l;s=g;t=10}}else{r=2147483647;s=(c[h>>2]|0)-k|0;t=10}if((t|0)==10){o=r;p=xCi(r)|0;q=s}s=d;d=p+q|0;while(1){if(!d)u=0;else{a[d>>0]=0;u=d}r=u+1|0;s=s+-1|0;if(!s){v=r;break}else d=r}d=c[b>>2]|0;s=(c[h>>2]|0)-d|0;u=p+(q-s)|0;YEi(u|0,d|0,s|0)|0;c[b>>2]=u;c[h>>2]=v;c[f>>2]=p+o;if(!d){i=e;return}ACi(d);i=e;return}function Xgc(a,b){a=a|0;b=b|0;c[a>>2]=c[b+28>>2];return}function Ygc(){var a=0;a=i;QQb(33,115,116,0,117);i=a;return}function Zgc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(2)|0))uUb();rri(b,575568,10);wQb(33,2,b,32,2613,0,0);xri(b);i=a;return}function _gc(){var a=0;a=i;Ydd(575568,575584,575600);QTb(33,554872,1810,0);i=a;return}function $gc(a){a=a|0;return 33}function ahc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;add(b,792072,575568,a,0);hTb(a,b);f=a+28|0;add(b,575600,575912,f,2048);a=e+8|0;g=a;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,a,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);bdd(b);i=d;return}function bhc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=qdd(b,792072,575568,f,1)|0;if(!g){i=d;return}if((g|0)>0){iTb(a,b);g=a+28|0;h=qdd(b,575600,575912,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else Xcc(g,b);sdd(b)}}else{g=c[f>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b);i=d;return}function chc(a,b){a=a|0;b=b|0;var c=0;c=i;jTb(a,b);$cc(a+28|0,b);i=c;return}function dhc(a,b){a=a|0;b=b|0;var c=0;c=i;kTb(a,b);ddc(a+28|0,b);i=c;return}function ehc(a,b){a=a|0;b=b|0;var c=0;c=i;lTb(a,b);hdc(a+28|0,b);i=c;return}function fhc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;mTb(b,d);idd(d,2048);f=b+28|0;b=c[d+12>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[f>>2]|0,c[d+28>>2]|0)|0;if(!(a[d+32>>0]|0)){jdd(d);i=e;return}c[f>>2]=g;jdd(d);i=e;return}function ghc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+24|0;g=c[f>>2]|0;if(!g){i=b;return}h=ATb(g,23)|0;if((h|0)!=0?(Ohc(d,h),g=c[a+28>>2]|0,(c[d>>2]|0)!=(g|0)):0){c[e>>2]=g;Nhc(h,e)}e=CTb(c[f>>2]|0,87)|0;if(!e){i=b;return}f=e+228|0;e=c[a+28>>2]|0;if((c[f>>2]|0)==(e|0)){i=b;return}c[f>>2]=e;i=b;return}function hhc(){return}function ihc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(32,e,1,16,3653512,13)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];bUb(g,e,b);c[g>>2]=575456;c[g+28>>2]=0;i=d;return g|0}function jhc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;b=d+4|0;e=d;f=a+24|0;g=c[f>>2]|0;if(!g){i=d;return}h=ATb(g,23)|0;if((h|0)!=0?(Ohc(b,h),g=c[a+28>>2]|0,(c[b>>2]|0)!=(g|0)):0){c[e>>2]=g;Nhc(h,e)}e=CTb(c[f>>2]|0,87)|0;if(!e){i=d;return}f=e+228|0;e=c[a+28>>2]|0;if((c[f>>2]|0)==(e|0)){i=d;return}c[f>>2]=e;i=d;return}function khc(a){a=a|0;var b=0;b=i;c[a>>2]=575456;WUb(a);i=b;return}function lhc(a){a=a|0;var b=0;b=i;c[a>>2]=575456;WUb(a);ACi(a);i=b;return}function mhc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+12|0;if((c[f>>2]|0)>-1){g=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[a>>2]=0}c[a+8>>2]=0;c[f>>2]=0;f=a+28|0;if((c[f>>2]|0)>-1){g=a+16|0;h=c[g>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}c[a+24>>2]=0;c[f>>2]=0;f=c[a+32>>2]|0;g=a+36|0;while(1){h=c[g>>2]|0;if((h|0)==(f|0))break;j=h+-16|0;c[g>>2]=j;ubc(j)}g=a+56|0;if((c[g>>2]|0)<=-1){k=a+52|0;c[k>>2]=0;c[g>>2]=0;i=b;return}f=a+44|0;j=c[f>>2]|0;c[e>>2]=c[a+48>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[f>>2]=0;k=a+52|0;c[k>>2]=0;c[g>>2]=0;i=b;return}function nhc(b,d,e,f,h){b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,k=0,l=Im,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0;j=i;if(!(e>ea(.0000999999974))){i=j;return}k=e>ea(1.0);l=k?ea(1.0):e;k=c[d>>2]|0;d=c[b>>2]|0;m=k+(d*40|0)|0;if(a[f+40>>0]|0){if(((a[f+41>>0]|0)!=0?(a[b+8>>0]|0)!=0:0)?(a[b+9>>0]|0)!=0:0){phc(m,c[b+4>>2]|0,c[f+44>>2]|0,l,c[f+32>>2]|0,c[f+36>>2]|0,c[f+24>>2]|0,h);i=j;return}if(a[b+8>>0]|0){m=c[b+4>>2]|0;n=c[f+32>>2]|0;o=c[f+24>>2]|0;if(!m){i=j;return}else p=0;do{q=p+d|0;r=da(c[k+(q*40|0)+36>>2]|0,o)|0;s=h+r|0;e=ea(l*ea(g[k+(q*40|0)>>2]));t=ea(l*ea(g[k+(q*40|0)+4>>2]));u=ea(l*ea(g[k+(q*40|0)+8>>2]));g[s>>2]=ea(e+ea(g[s>>2]));s=h+(r+4)|0;g[s>>2]=ea(t+ea(g[s>>2]));s=h+(r+8)|0;g[s>>2]=ea(u+ea(g[s>>2]));s=r+n|0;r=h+s|0;u=ea(l*ea(g[k+(q*40|0)+12>>2]));t=ea(l*ea(g[k+(q*40|0)+16>>2]));e=ea(l*ea(g[k+(q*40|0)+20>>2]));g[r>>2]=ea(u+ea(g[r>>2]));r=h+(s+4)|0;g[r>>2]=ea(t+ea(g[r>>2]));r=h+(s+8)|0;g[r>>2]=ea(e+ea(g[r>>2]));p=p+1|0}while((p|0)!=(m|0));i=j;return}}m=c[b+4>>2]|0;b=c[f+24>>2]|0;if(!m){i=j;return}else v=0;do{f=v+d|0;p=da(c[k+(f*40|0)+36>>2]|0,b)|0;n=h+p|0;e=ea(l*ea(g[k+(f*40|0)>>2]));t=ea(l*ea(g[k+(f*40|0)+4>>2]));u=ea(l*ea(g[k+(f*40|0)+8>>2]));g[n>>2]=ea(e+ea(g[n>>2]));n=h+(p+4)|0;g[n>>2]=ea(t+ea(g[n>>2]));n=h+(p+8)|0;g[n>>2]=ea(u+ea(g[n>>2]));v=v+1|0}while((v|0)!=(m|0));i=j;return}function ohc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im;d=i;YEi(b|0,c[a+16>>2]|0,da(c[a+44>>2]|0,c[a+24>>2]|0)|0)|0;e=c[a+64>>2]|0;f=a+60|0;if((c[f>>2]|0)<=0){i=d;return}h=a+56|0;j=e+32|0;k=e+16|0;l=e+44|0;m=0;do{n=ea(g[(c[h>>2]|0)+(m<<2)>>2]);do if(n>ea(.0000999999974)){o=c[j>>2]|0;p=c[o+(m<<4)+8>>2]|0;q=c[k>>2]|0;r=q+(p*12|0)|0;s=c[l>>2]|0;t=ea(g[s+(p<<2)>>2]);if(!(n<t)?(u=c[o+(m<<4)+12>>2]|0,(u|0)!=1):0){o=u+-1|0;u=0;while(1){v=u+1|0;w=v+p|0;x=s+(w<<2)|0;if(u>>>0>=o>>>0){y=x;z=w;A=u;break}if(ea(g[x>>2])<n)u=v;else{y=x;z=w;A=u;break}}u=A+p|0;B=ea(g[s+(u<<2)>>2]);C=ea(ea(n-B)/ea(ea(g[y>>2])-B));nhc(q+(u*12|0)|0,e,ea(ea(1.0)-C),a,b);nhc(q+(z*12|0)|0,e,C,a,b);break}nhc(r,e,ea(n/t),a,b)}while(0);m=m+1|0}while((m|0)<(c[f>>2]|0));i=d;return}function phc(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0;d=i;if(!b){i=d;return}else l=0;do{m=da(c[a+(l*40|0)+36>>2]|0,j)|0;n=k+m|0;o=ea(ea(g[a+(l*40|0)>>2])*e);p=ea(ea(g[a+(l*40|0)+4>>2])*e);q=ea(ea(g[a+(l*40|0)+8>>2])*e);g[n>>2]=ea(o+ea(g[n>>2]));n=k+(m+4)|0;g[n>>2]=ea(p+ea(g[n>>2]));n=k+(m+8)|0;g[n>>2]=ea(q+ea(g[n>>2]));n=m+f|0;r=k+n|0;q=ea(ea(g[a+(l*40|0)+12>>2])*e);p=ea(ea(g[a+(l*40|0)+16>>2])*e);o=ea(ea(g[a+(l*40|0)+20>>2])*e);g[r>>2]=ea(q+ea(g[r>>2]));r=k+(n+4)|0;g[r>>2]=ea(p+ea(g[r>>2]));r=k+(n+8)|0;g[r>>2]=ea(o+ea(g[r>>2]));r=m+h|0;m=k+r|0;o=ea(ea(g[a+(l*40|0)+24>>2])*e);p=ea(ea(g[a+(l*40|0)+28>>2])*e);q=ea(ea(g[a+(l*40|0)+32>>2])*e);g[m>>2]=ea(o+ea(g[m>>2]));m=k+(r+4)|0;g[m>>2]=ea(p+ea(g[m>>2]));m=k+(r+8)|0;g[m>>2]=ea(q+ea(g[m>>2]));l=l+1|0}while((l|0)!=(b|0));i=d;return}function qhc(){var a=0;a=i;QQb(23,118,119,0,0);i=a;return}function rhc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(25)|0))Ozc();rri(b,575608,12);wQb(23,25,b,312,2614,0,1);xri(b);i=a;return}function shc(){var a=0;a=i;QTb(23,554696,1811,0);QTb(23,554648,1812,0);QTb(23,554744,1813,0);i=a;return}function thc(a){a=a|0;return 23}function uhc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;add(b,792072,575608,a,0);FAc(a,b);f=a+304|0;add(b,575880,575912,f,1);a=e+8|0;g=a;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,a,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);bdd(b);i=d;return}function vhc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=qdd(b,792072,575608,f,1)|0;if(!g){i=d;return}if((g|0)>0){GAc(a,b);g=a+304|0;h=qdd(b,575880,575912,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else Xcc(g,b);sdd(b)}}else{g=c[f>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b);i=d;return}function whc(a,b){a=a|0;b=b|0;var c=0;c=i;HAc(a,b);$cc(a+304|0,b);i=c;return}function xhc(a,b){a=a|0;b=b|0;var c=0;c=i;IAc(a,b);ddc(a+304|0,b);i=c;return}function yhc(a,b){a=a|0;b=b|0;var c=0;c=i;JAc(a,b);hdc(a+304|0,b);i=c;return}function zhc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;KAc(b,d);idd(d,1);f=b+304|0;b=c[d+12>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[f>>2]|0,c[d+28>>2]|0)|0;if(!(a[d+32>>0]|0)){jdd(d);i=e;return}c[f>>2]=g;jdd(d);i=e;return}function Ahc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+284|0;e=c[d>>2]|0;if(e){f=a+288|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}cAc(a);i=b;return}function Bhc(a,b){a=a|0;b=b|0;var c=0;c=i;CAc(a,b);Chc(a);i=c;return}function Chc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b+300|0;h=c[g>>2]|0;if(!h)j=0;else{c[f>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,f);k=c[e>>2]|0;l=c[h+28>>2]|0;if((k|0)==-1){m=l+(c[h+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((m|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[m+4>>2]|0,(h|0)!=0):0)n=h;else o=10}else o=10;if((o|0)==10)n=hQb(c[g>>2]|0)|0;j=n}n=b+296|0;g=c[n>>2]|0;if((j|0)==(g|0)){i=d;return}if(g)zAc(b);c[n>>2]=j;a[b+76>>0]=1;lAc(b);j=b+284|0;g=c[j>>2]|0;if(g){o=b+288|0;c[g+4>>2]=c[o>>2];c[c[o>>2]>>2]=g;c[j>>2]=0;c[o>>2]=0}o=c[n>>2]|0;if(!o){i=d;return}n=o+212|0;if((j|0)==(n|0)){i=d;return}o=b+288|0;b=c[n>>2]|0;c[j>>2]=b;c[o>>2]=n;c[b+4>>2]=j;c[c[o>>2]>>2]=j;i=d;return}function Dhc(a,b){a=a|0;b=b|0;var c=0;c=i;uAc(a,b);i=c;return}function Ehc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im;b=i;d=a+296|0;e=c[d>>2]|0;if(!e){f=a+168|0;c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286];f=a+180|0;c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286];i=b;return}if(!(c[a+244>>2]|0)){f=a+168|0;h=e+168|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];i=b;return}if((mo[c[(c[a>>2]|0)+128>>2]&4095](a)|0)==1){h=a+168|0;f=c[d>>2]|0;e=_n[c[(c[a>>2]|0)+136>>2]&4095](a,0)|0;j=(c[f+44>>2]|0)+(e*56|0)+32|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];i=b;return}k=ea(g[150280]);l=ea(g[150281]);m=ea(g[150282]);n=ea(-k);o=ea(-l);p=ea(-m);if((mo[c[(c[a>>2]|0)+128>>2]&4095](a)|0)>0){q=k;r=l;s=m;t=n;u=o;v=p;j=0;while(1){h=c[d>>2]|0;e=_n[c[(c[a>>2]|0)+136>>2]&4095](a,j)|0;f=c[h+44>>2]|0;w=ea(g[f+(e*56|0)+32>>2]);x=ea(g[f+(e*56|0)+44>>2]);y=ea(w+x);z=ea(g[f+(e*56|0)+36>>2]);A=ea(g[f+(e*56|0)+48>>2]);B=ea(z+A);C=ea(g[f+(e*56|0)+40>>2]);D=ea(g[f+(e*56|0)+52>>2]);E=ea(C+D);F=y<q?y:q;G=B<r?B:r;H=E<s?E:s;I=t<y?y:t;y=u<B?B:u;B=v<E?E:v;E=ea(w-x);x=ea(z-A);A=ea(C-D);D=E<F?E:F;F=x<G?x:G;G=A<H?A:H;H=I<E?E:I;I=y<x?x:y;y=B<A?A:B;j=j+1|0;if((j|0)>=(mo[c[(c[a>>2]|0)+128>>2]&4095](a)|0)){J=y;K=I;L=H;M=G;N=F;O=D;break}else{q=D;r=F;s=G;t=H;u=I;v=y}}}else{J=p;K=o;L=n;M=m;N=l;O=k}k=ea(ea(K+N)*ea(.5));l=ea(ea(J+M)*ea(.5));g[a+168>>2]=ea(ea(L+O)*ea(.5));g[a+172>>2]=k;g[a+176>>2]=l;l=ea(ea(K-N)*ea(.5));N=ea(ea(J-M)*ea(.5));g[a+180>>2]=ea(ea(L-O)*ea(.5));g[a+184>>2]=l;g[a+188>>2]=N;i=b;return}function Fhc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+296>>2]|0;if((d|0)!=0?(c[a+244>>2]|0)!=0:0)e=c[d+4>>2]|0;else e=0;i=b;return e|0}function Ghc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+296>>2]|0;if((d|0)!=0?(c[a+244>>2]|0)!=0:0)e=c[d+4>>2]|0;else e=0;i=b;return e|0}function Hhc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+-28|0;a=c[d+296>>2]|0;if((a|0)!=0?(c[d+244>>2]|0)!=0:0)e=c[a+4>>2]|0;else e=0;i=b;return e|0}function Ihc(a){a=a|0;var b=0,d=0;b=c[a+296>>2]|0;if(!b)d=0;else d=c[b+36>>2]|0;return d|0}function Jhc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+-28+296>>2]|0;if(!d){e=0;i=b;return e|0}e=c[d+36>>2]|0;i=b;return e|0}function Khc(a){a=a|0;return c[a+296>>2]|0}function Lhc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+296>>2]|0;if(!h){i=e;return}j=a+196|0;if(c[j>>2]|0){k=ync()|0;In[c[(c[k>>2]|0)+220>>2]&4095](k,c[j>>2]|0)}j=c[a+4>>2]|0;k=a+304|0;a=c[k>>2]|0;if(!a)l=0;else{c[g>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(f,a,g);m=c[f>>2]|0;n=c[a+28>>2]|0;if((m|0)==-1){o=n+(c[a+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((o|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[o+4>>2]|0,(a|0)!=0):0)p=a;else q=13}else q=13;if((q|0)==13)p=hQb(c[k>>2]|0)|0;l=p}Xuc(d,h,b,j,l);i=e;return}function Mhc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Lhc(a+-28|0,b,c);i=d;return}function Nhc(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+300>>2]=c[b>>2];Chc(a);i=d;return}function Ohc(a,b){a=a|0;b=b|0;c[a>>2]=c[b+300>>2];return}function Phc(a,b,c){a=a|0;b=b|0;c=c|0;a=i;Lmc(b,c);i=a;return}function Qhc(a,b,c){a=a|0;b=b|0;c=c|0;a=i;Lmc(b,c);i=a;return}function Rhc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+304|0;a=c[f>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0)l=a;else m=10}else m=10;if((m|0)==10)l=hQb(c[f>>2]|0)|0;g=l;i=b;return g|0}function Shc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(312,f,1,16,3653512,14)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];Zzc(h,1,f,d);c[h>>2]=575632;c[h+28>>2]=575816;c[h+284>>2]=0;c[h+288>>2]=0;c[h+292>>2]=h;d=h+296|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;a[d+12>>0]=0;i=e;return h|0}function Thc(b,c,d){b=b|0;c=c|0;d=d|0;d=i;a[b+76>>0]=1;lAc(b);i=d;return}function Uhc(a,b,d){a=a|0;b=b|0;d=d|0;c[a+296>>2]=0;return}function Vhc(b,c,d){b=b|0;c=c|0;d=d|0;d=i;a[b+76>>0]=1;lAc(b);i=d;return}function Whc(a){a=a|0;var b=0;b=i;c[a>>2]=575632;c[a+28>>2]=575816;Ncc(a);i=b;return}function Xhc(a){a=a|0;var b=0;b=i;c[a>>2]=575632;c[a+28>>2]=575816;Ncc(a);ACi(a);i=b;return}function Yhc(b){b=b|0;return (a[b+308>>0]|0)==0|0}function Zhc(a){a=a|0;var b=0,d=0;b=i;d=a+-28|0;c[d>>2]=575632;c[d+28>>2]=575816;Ncc(d);i=b;return}function _hc(a){a=a|0;var b=0,d=0;b=i;d=a+-28|0;c[d>>2]=575632;c[d+28>>2]=575816;Ncc(d);ACi(d);i=b;return}function $hc(b){b=b|0;return (a[b+-28+308>>0]|0)==0|0}function aic(b){b=b|0;var d=0,e=0;d=i;do if(!(a[b+40>>0]|0)){e=c[b+4>>2]|0;if((e|0)==1){lic(b);break}else if((e|0)==4){nic(b);break}else if((e|0)==2){mic(b);break}else break}else{e=c[b+4>>2]|0;if(!(a[b+41>>0]|0))if((e|0)==1){iic(b);break}else if((e|0)==2){jic(b);break}else if((e|0)==4){kic(b);break}else break;else if((e|0)==2){gic(b);break}else if((e|0)==4){hic(b);break}else if((e|0)==1){fic(b);break}else break}while(0);i=d;return}function bic(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+68|0;if(c[g>>2]|0)Gnd(g);g=a+20|0;h=c[g>>2]|0;if(!h){i=b;return}j=c[a+60>>2]|0;k=c[a+12>>2]|0;l=(k|0)!=0;if(!(k|j)){k=a+16|0;m=a+24|0;n=a+44|0;YEi(h|0,c[k>>2]|0,da(c[n>>2]|0,c[m>>2]|0)|0)|0;h=c[a+52>>2]|0;if(!h){i=b;return}yMc(h,c[k>>2]|0,c[m>>2]|0,c[g>>2]|0,c[a+28>>2]|0,c[n>>2]|0);i=b;return}do if(!j)if(l){o=0;p=12}else{i=b;return}else{n=da(c[a+44>>2]|0,c[a+24>>2]|0)|0;c[e>>2]=c[153134];c[d+0>>2]=c[e+0>>2];m=cOb(n,16,d,0,3653512,109)|0;ohc(a,m);if(l){c[a+16>>2]=m;o=m;p=12;break}else{YEi(c[g>>2]|0,m|0,n|0)|0;q=m;break}}while(0);if((p|0)==12){aic(a);q=o}if(!q){i=b;return}c[f>>2]=c[153134];c[d+0>>2]=c[f+0>>2];eOb(q,d);i=b;return}function cic(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a>>2]|0;if(g)c[a+20>>2]=g;bic(a);g=a+68|0;if(c[g>>2]|0)Gnd(g);g=c[a+84>>2]|0;if((g|0)!=0?(h=c[153074]|0,j=g+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[f>>2]=c[153136];c[d+0>>2]=c[f+0>>2];eOb(a,d);i=b;return}function dic(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;if(!a){i=b;return}g=a+68|0;if(c[g>>2]|0)Gnd(g);g=c[a+84>>2]|0;if((g|0)!=0?(h=c[153074]|0,j=g+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[f>>2]=c[153136];c[d+0>>2]=c[f+0>>2];eOb(a,d);i=b;return}function eic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=(b|a|0)==0?1:a;a=g<<6;c[f>>2]=c[153136];c[e+0>>2]=c[f+0>>2];f=cOb((b<<2)+128+a|0,64,e,0,3653512,158)|0;if(!f)h=0;else{e=f+0|0;j=e+128|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(j|0));h=f}e=f+128|0;if(!g)k=e;else{c[h+52>>2]=e;k=f+(a+128)|0}if(!b){i=d;return h|0}c[h+56>>2]=k;i=d;return h|0}function fic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;j=c[a+32>>2]|0;k=c[a+36>>2]|0;if((h|0)<=0){i=b;return}l=j+4|0;m=j+8|0;n=k+4|0;o=k+8|0;p=k+12|0;q=c[a+8>>2]|0;r=c[a+16>>2]|0;s=c[a+20>>2]|0;a=0;while(1){t=c[q>>2]|0;u=ea(g[d+(t<<6)>>2]);v=ea(g[r>>2]);w=ea(u*v);x=ea(g[d+(t<<6)+16>>2]);y=ea(g[r+4>>2]);z=ea(w+ea(x*y));w=ea(g[d+(t<<6)+32>>2]);A=ea(g[r+8>>2]);B=ea(z+ea(w*A));z=ea(ea(g[d+(t<<6)+48>>2])+B);B=ea(g[d+(t<<6)+4>>2]);C=ea(v*B);D=ea(g[d+(t<<6)+20>>2]);E=ea(C+ea(y*D));C=ea(g[d+(t<<6)+36>>2]);F=ea(E+ea(A*C));E=ea(ea(g[d+(t<<6)+52>>2])+F);F=ea(g[d+(t<<6)+8>>2]);G=ea(v*F);v=ea(g[d+(t<<6)+24>>2]);H=ea(G+ea(y*v));y=ea(g[d+(t<<6)+40>>2]);G=ea(H+ea(A*y));A=ea(ea(g[d+(t<<6)+56>>2])+G);G=ea(g[r+j>>2]);H=ea(u*G);I=ea(g[r+l>>2]);J=ea(H+ea(x*I));H=ea(g[r+m>>2]);K=ea(J+ea(w*H));J=ea(ea(ea(B*G)+ea(D*I))+ea(C*H));L=ea(ea(ea(F*G)+ea(v*I))+ea(y*H));H=ea(g[r+k>>2]);I=ea(u*H);u=ea(g[r+n>>2]);G=ea(I+ea(x*u));x=ea(g[r+o>>2]);I=ea(G+ea(w*x));w=ea(ea(ea(B*H)+ea(D*u))+ea(C*x));C=ea(ea(ea(F*H)+ea(v*u))+ea(y*x));g[s>>2]=z;g[s+4>>2]=E;g[s+8>>2]=A;g[s+j>>2]=K;g[s+l>>2]=J;g[s+m>>2]=L;g[s+k>>2]=I;g[s+n>>2]=w;g[s+o>>2]=C;g[s+p>>2]=ea(g[r+p>>2]);a=a+1|0;if((a|0)==(h|0))break;else{q=q+4|0;r=r+e|0;s=s+f|0}}i=b;return}function gic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;j=c[a+32>>2]|0;k=c[a+36>>2]|0;if((h|0)<=0){i=b;return}l=j+4|0;m=j+8|0;n=k+4|0;o=k+8|0;p=k+12|0;q=c[a+8>>2]|0;r=c[a+16>>2]|0;s=c[a+20>>2]|0;a=0;while(1){t=ea(g[q>>2]);u=ea(g[q+4>>2]);v=c[q+8>>2]|0;w=c[q+12>>2]|0;x=ea(t*ea(g[d+(v<<6)>>2]));y=ea(x+ea(u*ea(g[d+(w<<6)>>2])));x=ea(t*ea(g[d+(v<<6)+4>>2]));z=ea(x+ea(u*ea(g[d+(w<<6)+4>>2])));x=ea(t*ea(g[d+(v<<6)+8>>2]));A=ea(x+ea(u*ea(g[d+(w<<6)+8>>2])));x=ea(t*ea(g[d+(v<<6)+16>>2]));B=ea(x+ea(u*ea(g[d+(w<<6)+16>>2])));x=ea(t*ea(g[d+(v<<6)+20>>2]));C=ea(x+ea(u*ea(g[d+(w<<6)+20>>2])));x=ea(t*ea(g[d+(v<<6)+24>>2]));D=ea(x+ea(u*ea(g[d+(w<<6)+24>>2])));x=ea(t*ea(g[d+(v<<6)+32>>2]));E=ea(x+ea(u*ea(g[d+(w<<6)+32>>2])));x=ea(t*ea(g[d+(v<<6)+36>>2]));F=ea(x+ea(u*ea(g[d+(w<<6)+36>>2])));x=ea(t*ea(g[d+(v<<6)+40>>2]));G=ea(x+ea(u*ea(g[d+(w<<6)+40>>2])));x=ea(t*ea(g[d+(v<<6)+48>>2]));H=ea(x+ea(u*ea(g[d+(w<<6)+48>>2])));x=ea(t*ea(g[d+(v<<6)+52>>2]));I=ea(x+ea(u*ea(g[d+(w<<6)+52>>2])));x=ea(t*ea(g[d+(v<<6)+56>>2]));t=ea(x+ea(u*ea(g[d+(w<<6)+56>>2])));u=ea(g[r>>2]);x=ea(y*u);J=ea(g[r+4>>2]);K=ea(x+ea(B*J));x=ea(g[r+8>>2]);L=ea(H+ea(K+ea(E*x)));K=ea(I+ea(ea(ea(z*u)+ea(C*J))+ea(F*x)));I=ea(t+ea(ea(ea(A*u)+ea(D*J))+ea(G*x)));x=ea(g[r+j>>2]);J=ea(y*x);u=ea(g[r+l>>2]);t=ea(J+ea(B*u));J=ea(g[r+m>>2]);H=ea(t+ea(E*J));t=ea(ea(ea(z*x)+ea(C*u))+ea(F*J));M=ea(ea(ea(A*x)+ea(D*u))+ea(G*J));J=ea(g[r+k>>2]);u=ea(y*J);y=ea(g[r+n>>2]);x=ea(u+ea(B*y));B=ea(g[r+o>>2]);u=ea(x+ea(E*B));E=ea(ea(ea(z*J)+ea(C*y))+ea(F*B));F=ea(ea(ea(A*J)+ea(D*y))+ea(G*B));g[s>>2]=L;g[s+4>>2]=K;g[s+8>>2]=I;g[s+j>>2]=H;g[s+l>>2]=t;g[s+m>>2]=M;g[s+k>>2]=u;g[s+n>>2]=E;g[s+o>>2]=F;g[s+p>>2]=ea(g[r+p>>2]);a=a+1|0;if((a|0)==(h|0))break;else{q=q+16|0;r=r+e|0;s=s+f|0}}i=b;return}function hic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;j=c[a+32>>2]|0;k=c[a+36>>2]|0;if((h|0)<=0){i=b;return}l=j+4|0;m=j+8|0;n=k+4|0;o=k+8|0;p=k+12|0;q=c[a+8>>2]|0;r=c[a+16>>2]|0;s=c[a+20>>2]|0;a=0;while(1){t=ea(g[q>>2]);u=ea(g[q+4>>2]);v=ea(g[q+8>>2]);w=ea(g[q+12>>2]);x=c[q+16>>2]|0;y=c[q+20>>2]|0;z=c[q+24>>2]|0;A=c[q+28>>2]|0;B=ea(t*ea(g[d+(x<<6)>>2]));C=ea(B+ea(u*ea(g[d+(y<<6)>>2])));B=ea(C+ea(v*ea(g[d+(z<<6)>>2])));C=ea(B+ea(w*ea(g[d+(A<<6)>>2])));B=ea(t*ea(g[d+(x<<6)+4>>2]));D=ea(B+ea(u*ea(g[d+(y<<6)+4>>2])));B=ea(D+ea(v*ea(g[d+(z<<6)+4>>2])));D=ea(B+ea(w*ea(g[d+(A<<6)+4>>2])));B=ea(t*ea(g[d+(x<<6)+8>>2]));E=ea(B+ea(u*ea(g[d+(y<<6)+8>>2])));B=ea(E+ea(v*ea(g[d+(z<<6)+8>>2])));E=ea(B+ea(w*ea(g[d+(A<<6)+8>>2])));B=ea(t*ea(g[d+(x<<6)+16>>2]));F=ea(B+ea(u*ea(g[d+(y<<6)+16>>2])));B=ea(F+ea(v*ea(g[d+(z<<6)+16>>2])));F=ea(B+ea(w*ea(g[d+(A<<6)+16>>2])));B=ea(t*ea(g[d+(x<<6)+20>>2]));G=ea(B+ea(u*ea(g[d+(y<<6)+20>>2])));B=ea(G+ea(v*ea(g[d+(z<<6)+20>>2])));G=ea(B+ea(w*ea(g[d+(A<<6)+20>>2])));B=ea(t*ea(g[d+(x<<6)+24>>2]));H=ea(B+ea(u*ea(g[d+(y<<6)+24>>2])));B=ea(H+ea(v*ea(g[d+(z<<6)+24>>2])));H=ea(B+ea(w*ea(g[d+(A<<6)+24>>2])));B=ea(t*ea(g[d+(x<<6)+32>>2]));I=ea(B+ea(u*ea(g[d+(y<<6)+32>>2])));B=ea(I+ea(v*ea(g[d+(z<<6)+32>>2])));I=ea(B+ea(w*ea(g[d+(A<<6)+32>>2])));B=ea(t*ea(g[d+(x<<6)+36>>2]));J=ea(B+ea(u*ea(g[d+(y<<6)+36>>2])));B=ea(J+ea(v*ea(g[d+(z<<6)+36>>2])));J=ea(B+ea(w*ea(g[d+(A<<6)+36>>2])));B=ea(t*ea(g[d+(x<<6)+40>>2]));K=ea(B+ea(u*ea(g[d+(y<<6)+40>>2])));B=ea(K+ea(v*ea(g[d+(z<<6)+40>>2])));K=ea(B+ea(w*ea(g[d+(A<<6)+40>>2])));B=ea(t*ea(g[d+(x<<6)+48>>2]));L=ea(B+ea(u*ea(g[d+(y<<6)+48>>2])));B=ea(L+ea(v*ea(g[d+(z<<6)+48>>2])));L=ea(B+ea(w*ea(g[d+(A<<6)+48>>2])));B=ea(t*ea(g[d+(x<<6)+52>>2]));M=ea(B+ea(u*ea(g[d+(y<<6)+52>>2])));B=ea(M+ea(v*ea(g[d+(z<<6)+52>>2])));M=ea(B+ea(w*ea(g[d+(A<<6)+52>>2])));B=ea(t*ea(g[d+(x<<6)+56>>2]));t=ea(B+ea(u*ea(g[d+(y<<6)+56>>2])));u=ea(t+ea(v*ea(g[d+(z<<6)+56>>2])));v=ea(u+ea(w*ea(g[d+(A<<6)+56>>2])));w=ea(g[r>>2]);u=ea(C*w);t=ea(g[r+4>>2]);B=ea(u+ea(F*t));u=ea(g[r+8>>2]);N=ea(L+ea(B+ea(I*u)));B=ea(M+ea(ea(ea(D*w)+ea(G*t))+ea(J*u)));M=ea(v+ea(ea(ea(E*w)+ea(H*t))+ea(K*u)));u=ea(g[r+j>>2]);t=ea(C*u);w=ea(g[r+l>>2]);v=ea(t+ea(F*w));t=ea(g[r+m>>2]);L=ea(v+ea(I*t));v=ea(ea(ea(D*u)+ea(G*w))+ea(J*t));O=ea(ea(ea(E*u)+ea(H*w))+ea(K*t));t=ea(g[r+k>>2]);w=ea(C*t);C=ea(g[r+n>>2]);u=ea(w+ea(F*C));F=ea(g[r+o>>2]);w=ea(u+ea(I*F));I=ea(ea(ea(D*t)+ea(G*C))+ea(J*F));J=ea(ea(ea(E*t)+ea(H*C))+ea(K*F));g[s>>2]=N;g[s+4>>2]=B;g[s+8>>2]=M;g[s+j>>2]=L;g[s+l>>2]=v;g[s+m>>2]=O;g[s+k>>2]=w;g[s+n>>2]=I;g[s+o>>2]=J;g[s+p>>2]=ea(g[r+p>>2]);a=a+1|0;if((a|0)==(h|0))break;else{q=q+32|0;r=r+e|0;s=s+f|0}}i=b;return}function iic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;j=c[a+32>>2]|0;if((h|0)<=0){i=b;return}k=j+4|0;l=j+8|0;m=c[a+8>>2]|0;n=c[a+16>>2]|0;o=c[a+20>>2]|0;a=0;while(1){p=c[m>>2]|0;q=ea(g[d+(p<<6)>>2]);r=ea(g[n>>2]);s=ea(q*r);t=ea(g[d+(p<<6)+16>>2]);u=ea(g[n+4>>2]);v=ea(s+ea(t*u));s=ea(g[d+(p<<6)+32>>2]);w=ea(g[n+8>>2]);x=ea(v+ea(s*w));v=ea(ea(g[d+(p<<6)+48>>2])+x);x=ea(g[d+(p<<6)+4>>2]);y=ea(r*x);z=ea(g[d+(p<<6)+20>>2]);A=ea(y+ea(u*z));y=ea(g[d+(p<<6)+36>>2]);B=ea(A+ea(w*y));A=ea(ea(g[d+(p<<6)+52>>2])+B);B=ea(g[d+(p<<6)+8>>2]);C=ea(r*B);r=ea(g[d+(p<<6)+24>>2]);D=ea(C+ea(u*r));u=ea(g[d+(p<<6)+40>>2]);C=ea(D+ea(w*u));w=ea(ea(g[d+(p<<6)+56>>2])+C);C=ea(g[n+j>>2]);D=ea(q*C);q=ea(g[n+k>>2]);E=ea(D+ea(t*q));t=ea(g[n+l>>2]);D=ea(E+ea(s*t));s=ea(ea(ea(x*C)+ea(z*q))+ea(y*t));y=ea(ea(ea(B*C)+ea(r*q))+ea(u*t));g[o>>2]=v;g[o+4>>2]=A;g[o+8>>2]=w;g[o+j>>2]=D;g[o+k>>2]=s;g[o+l>>2]=y;a=a+1|0;if((a|0)==(h|0))break;else{m=m+4|0;n=n+e|0;o=o+f|0}}i=b;return}function jic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;j=c[a+32>>2]|0;if((h|0)<=0){i=b;return}k=j+4|0;l=j+8|0;m=c[a+8>>2]|0;n=c[a+16>>2]|0;o=c[a+20>>2]|0;a=0;while(1){p=ea(g[m>>2]);q=ea(g[m+4>>2]);r=c[m+8>>2]|0;s=c[m+12>>2]|0;t=ea(p*ea(g[d+(r<<6)>>2]));u=ea(t+ea(q*ea(g[d+(s<<6)>>2])));t=ea(p*ea(g[d+(r<<6)+4>>2]));v=ea(t+ea(q*ea(g[d+(s<<6)+4>>2])));t=ea(p*ea(g[d+(r<<6)+8>>2]));w=ea(t+ea(q*ea(g[d+(s<<6)+8>>2])));t=ea(p*ea(g[d+(r<<6)+16>>2]));x=ea(t+ea(q*ea(g[d+(s<<6)+16>>2])));t=ea(p*ea(g[d+(r<<6)+20>>2]));y=ea(t+ea(q*ea(g[d+(s<<6)+20>>2])));t=ea(p*ea(g[d+(r<<6)+24>>2]));z=ea(t+ea(q*ea(g[d+(s<<6)+24>>2])));t=ea(p*ea(g[d+(r<<6)+32>>2]));A=ea(t+ea(q*ea(g[d+(s<<6)+32>>2])));t=ea(p*ea(g[d+(r<<6)+36>>2]));B=ea(t+ea(q*ea(g[d+(s<<6)+36>>2])));t=ea(p*ea(g[d+(r<<6)+40>>2]));C=ea(t+ea(q*ea(g[d+(s<<6)+40>>2])));t=ea(p*ea(g[d+(r<<6)+48>>2]));D=ea(t+ea(q*ea(g[d+(s<<6)+48>>2])));t=ea(p*ea(g[d+(r<<6)+52>>2]));E=ea(t+ea(q*ea(g[d+(s<<6)+52>>2])));t=ea(p*ea(g[d+(r<<6)+56>>2]));p=ea(t+ea(q*ea(g[d+(s<<6)+56>>2])));q=ea(g[n>>2]);t=ea(u*q);F=ea(g[n+4>>2]);G=ea(t+ea(x*F));t=ea(g[n+8>>2]);H=ea(D+ea(G+ea(A*t)));G=ea(E+ea(ea(ea(v*q)+ea(y*F))+ea(B*t)));E=ea(p+ea(ea(ea(w*q)+ea(z*F))+ea(C*t)));t=ea(g[n+j>>2]);F=ea(u*t);u=ea(g[n+k>>2]);q=ea(F+ea(x*u));x=ea(g[n+l>>2]);F=ea(q+ea(A*x));A=ea(ea(ea(v*t)+ea(y*u))+ea(B*x));B=ea(ea(ea(w*t)+ea(z*u))+ea(C*x));g[o>>2]=H;g[o+4>>2]=G;g[o+8>>2]=E;g[o+j>>2]=F;g[o+k>>2]=A;g[o+l>>2]=B;a=a+1|0;if((a|0)==(h|0))break;else{m=m+16|0;n=n+e|0;o=o+f|0}}i=b;return}function kic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;j=c[a+32>>2]|0;if((h|0)<=0){i=b;return}k=j+4|0;l=j+8|0;m=c[a+8>>2]|0;n=c[a+16>>2]|0;o=c[a+20>>2]|0;a=0;while(1){p=ea(g[m>>2]);q=ea(g[m+4>>2]);r=ea(g[m+8>>2]);s=ea(g[m+12>>2]);t=c[m+16>>2]|0;u=c[m+20>>2]|0;v=c[m+24>>2]|0;w=c[m+28>>2]|0;x=ea(p*ea(g[d+(t<<6)>>2]));y=ea(x+ea(q*ea(g[d+(u<<6)>>2])));x=ea(y+ea(r*ea(g[d+(v<<6)>>2])));y=ea(x+ea(s*ea(g[d+(w<<6)>>2])));x=ea(p*ea(g[d+(t<<6)+4>>2]));z=ea(x+ea(q*ea(g[d+(u<<6)+4>>2])));x=ea(z+ea(r*ea(g[d+(v<<6)+4>>2])));z=ea(x+ea(s*ea(g[d+(w<<6)+4>>2])));x=ea(p*ea(g[d+(t<<6)+8>>2]));A=ea(x+ea(q*ea(g[d+(u<<6)+8>>2])));x=ea(A+ea(r*ea(g[d+(v<<6)+8>>2])));A=ea(x+ea(s*ea(g[d+(w<<6)+8>>2])));x=ea(p*ea(g[d+(t<<6)+16>>2]));B=ea(x+ea(q*ea(g[d+(u<<6)+16>>2])));x=ea(B+ea(r*ea(g[d+(v<<6)+16>>2])));B=ea(x+ea(s*ea(g[d+(w<<6)+16>>2])));x=ea(p*ea(g[d+(t<<6)+20>>2]));C=ea(x+ea(q*ea(g[d+(u<<6)+20>>2])));x=ea(C+ea(r*ea(g[d+(v<<6)+20>>2])));C=ea(x+ea(s*ea(g[d+(w<<6)+20>>2])));x=ea(p*ea(g[d+(t<<6)+24>>2]));D=ea(x+ea(q*ea(g[d+(u<<6)+24>>2])));x=ea(D+ea(r*ea(g[d+(v<<6)+24>>2])));D=ea(x+ea(s*ea(g[d+(w<<6)+24>>2])));x=ea(p*ea(g[d+(t<<6)+32>>2]));E=ea(x+ea(q*ea(g[d+(u<<6)+32>>2])));x=ea(E+ea(r*ea(g[d+(v<<6)+32>>2])));E=ea(x+ea(s*ea(g[d+(w<<6)+32>>2])));x=ea(p*ea(g[d+(t<<6)+36>>2]));F=ea(x+ea(q*ea(g[d+(u<<6)+36>>2])));x=ea(F+ea(r*ea(g[d+(v<<6)+36>>2])));F=ea(x+ea(s*ea(g[d+(w<<6)+36>>2])));x=ea(p*ea(g[d+(t<<6)+40>>2]));G=ea(x+ea(q*ea(g[d+(u<<6)+40>>2])));x=ea(G+ea(r*ea(g[d+(v<<6)+40>>2])));G=ea(x+ea(s*ea(g[d+(w<<6)+40>>2])));x=ea(p*ea(g[d+(t<<6)+48>>2]));H=ea(x+ea(q*ea(g[d+(u<<6)+48>>2])));x=ea(H+ea(r*ea(g[d+(v<<6)+48>>2])));H=ea(x+ea(s*ea(g[d+(w<<6)+48>>2])));x=ea(p*ea(g[d+(t<<6)+52>>2]));I=ea(x+ea(q*ea(g[d+(u<<6)+52>>2])));x=ea(I+ea(r*ea(g[d+(v<<6)+52>>2])));I=ea(x+ea(s*ea(g[d+(w<<6)+52>>2])));x=ea(p*ea(g[d+(t<<6)+56>>2]));p=ea(x+ea(q*ea(g[d+(u<<6)+56>>2])));q=ea(p+ea(r*ea(g[d+(v<<6)+56>>2])));r=ea(q+ea(s*ea(g[d+(w<<6)+56>>2])));s=ea(g[n>>2]);q=ea(y*s);p=ea(g[n+4>>2]);x=ea(q+ea(B*p));q=ea(g[n+8>>2]);J=ea(H+ea(x+ea(E*q)));x=ea(I+ea(ea(ea(z*s)+ea(C*p))+ea(F*q)));I=ea(r+ea(ea(ea(A*s)+ea(D*p))+ea(G*q)));q=ea(g[n+j>>2]);p=ea(y*q);y=ea(g[n+k>>2]);s=ea(p+ea(B*y));B=ea(g[n+l>>2]);p=ea(s+ea(E*B));E=ea(ea(ea(z*q)+ea(C*y))+ea(F*B));F=ea(ea(ea(A*q)+ea(D*y))+ea(G*B));g[o>>2]=J;g[o+4>>2]=x;g[o+8>>2]=I;g[o+j>>2]=p;g[o+k>>2]=E;g[o+l>>2]=F;a=a+1|0;if((a|0)==(h|0))break;else{m=m+32|0;n=n+e|0;o=o+f|0}}i=b;return}function lic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;if((h|0)<=0){i=b;return}j=c[a+8>>2]|0;k=c[a+16>>2]|0;l=c[a+20>>2]|0;a=0;while(1){m=c[j>>2]|0;n=ea(g[d+(m<<6)>>2]);o=ea(g[k>>2]);p=ea(n*o);n=ea(g[d+(m<<6)+16>>2]);q=ea(g[k+4>>2]);r=ea(p+ea(n*q));n=ea(g[d+(m<<6)+32>>2]);p=ea(g[k+8>>2]);s=ea(r+ea(n*p));n=ea(ea(g[d+(m<<6)+48>>2])+s);s=ea(o*ea(g[d+(m<<6)+4>>2]));r=ea(s+ea(q*ea(g[d+(m<<6)+20>>2])));s=ea(r+ea(p*ea(g[d+(m<<6)+36>>2])));r=ea(ea(g[d+(m<<6)+52>>2])+s);s=ea(o*ea(g[d+(m<<6)+8>>2]));o=ea(s+ea(q*ea(g[d+(m<<6)+24>>2])));q=ea(o+ea(p*ea(g[d+(m<<6)+40>>2])));p=ea(ea(g[d+(m<<6)+56>>2])+q);g[l>>2]=n;g[l+4>>2]=r;g[l+8>>2]=p;a=a+1|0;if((a|0)==(h|0))break;else{j=j+4|0;k=k+e|0;l=l+f|0}}i=b;return}function mic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;if((h|0)<=0){i=b;return}j=c[a+8>>2]|0;k=c[a+16>>2]|0;l=c[a+20>>2]|0;a=0;while(1){m=ea(g[j>>2]);n=ea(g[j+4>>2]);o=c[j+8>>2]|0;p=c[j+12>>2]|0;q=ea(m*ea(g[d+(o<<6)>>2]));r=ea(q+ea(n*ea(g[d+(p<<6)>>2])));q=ea(m*ea(g[d+(o<<6)+4>>2]));s=ea(q+ea(n*ea(g[d+(p<<6)+4>>2])));q=ea(m*ea(g[d+(o<<6)+8>>2]));t=ea(q+ea(n*ea(g[d+(p<<6)+8>>2])));q=ea(m*ea(g[d+(o<<6)+16>>2]));u=ea(q+ea(n*ea(g[d+(p<<6)+16>>2])));q=ea(m*ea(g[d+(o<<6)+20>>2]));v=ea(q+ea(n*ea(g[d+(p<<6)+20>>2])));q=ea(m*ea(g[d+(o<<6)+24>>2]));w=ea(q+ea(n*ea(g[d+(p<<6)+24>>2])));q=ea(m*ea(g[d+(o<<6)+32>>2]));x=ea(q+ea(n*ea(g[d+(p<<6)+32>>2])));q=ea(m*ea(g[d+(o<<6)+36>>2]));y=ea(q+ea(n*ea(g[d+(p<<6)+36>>2])));q=ea(m*ea(g[d+(o<<6)+40>>2]));z=ea(q+ea(n*ea(g[d+(p<<6)+40>>2])));q=ea(m*ea(g[d+(o<<6)+48>>2]));A=ea(q+ea(n*ea(g[d+(p<<6)+48>>2])));q=ea(m*ea(g[d+(o<<6)+52>>2]));B=ea(q+ea(n*ea(g[d+(p<<6)+52>>2])));q=ea(m*ea(g[d+(o<<6)+56>>2]));m=ea(q+ea(n*ea(g[d+(p<<6)+56>>2])));n=ea(g[k>>2]);q=ea(r*n);r=ea(g[k+4>>2]);C=ea(q+ea(u*r));u=ea(g[k+8>>2]);q=ea(B+ea(ea(ea(s*n)+ea(v*r))+ea(y*u)));y=ea(m+ea(ea(ea(t*n)+ea(w*r))+ea(z*u)));g[l>>2]=ea(A+ea(C+ea(x*u)));g[l+4>>2]=q;g[l+8>>2]=y;a=a+1|0;if((a|0)==(h|0))break;else{j=j+16|0;k=k+e|0;l=l+f|0}}i=b;return}function nic(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;b=i;d=c[a+52>>2]|0;e=c[a+24>>2]|0;f=c[a+28>>2]|0;h=c[a+44>>2]|0;if((h|0)<=0){i=b;return}j=c[a+8>>2]|0;k=c[a+16>>2]|0;l=c[a+20>>2]|0;a=0;while(1){m=ea(g[j>>2]);n=ea(g[j+4>>2]);o=ea(g[j+8>>2]);p=ea(g[j+12>>2]);q=c[j+16>>2]|0;r=c[j+20>>2]|0;s=c[j+24>>2]|0;t=c[j+28>>2]|0;u=ea(m*ea(g[d+(q<<6)>>2]));v=ea(u+ea(n*ea(g[d+(r<<6)>>2])));u=ea(v+ea(o*ea(g[d+(s<<6)>>2])));v=ea(u+ea(p*ea(g[d+(t<<6)>>2])));u=ea(m*ea(g[d+(q<<6)+4>>2]));w=ea(u+ea(n*ea(g[d+(r<<6)+4>>2])));u=ea(w+ea(o*ea(g[d+(s<<6)+4>>2])));w=ea(u+ea(p*ea(g[d+(t<<6)+4>>2])));u=ea(m*ea(g[d+(q<<6)+8>>2]));x=ea(u+ea(n*ea(g[d+(r<<6)+8>>2])));u=ea(x+ea(o*ea(g[d+(s<<6)+8>>2])));x=ea(u+ea(p*ea(g[d+(t<<6)+8>>2])));u=ea(m*ea(g[d+(q<<6)+16>>2]));y=ea(u+ea(n*ea(g[d+(r<<6)+16>>2])));u=ea(y+ea(o*ea(g[d+(s<<6)+16>>2])));y=ea(u+ea(p*ea(g[d+(t<<6)+16>>2])));u=ea(m*ea(g[d+(q<<6)+20>>2]));z=ea(u+ea(n*ea(g[d+(r<<6)+20>>2])));u=ea(z+ea(o*ea(g[d+(s<<6)+20>>2])));z=ea(u+ea(p*ea(g[d+(t<<6)+20>>2])));u=ea(m*ea(g[d+(q<<6)+24>>2]));A=ea(u+ea(n*ea(g[d+(r<<6)+24>>2])));u=ea(A+ea(o*ea(g[d+(s<<6)+24>>2])));A=ea(u+ea(p*ea(g[d+(t<<6)+24>>2])));u=ea(m*ea(g[d+(q<<6)+32>>2]));B=ea(u+ea(n*ea(g[d+(r<<6)+32>>2])));u=ea(B+ea(o*ea(g[d+(s<<6)+32>>2])));B=ea(u+ea(p*ea(g[d+(t<<6)+32>>2])));u=ea(m*ea(g[d+(q<<6)+36>>2]));C=ea(u+ea(n*ea(g[d+(r<<6)+36>>2])));u=ea(C+ea(o*ea(g[d+(s<<6)+36>>2])));C=ea(u+ea(p*ea(g[d+(t<<6)+36>>2])));u=ea(m*ea(g[d+(q<<6)+40>>2]));D=ea(u+ea(n*ea(g[d+(r<<6)+40>>2])));u=ea(D+ea(o*ea(g[d+(s<<6)+40>>2])));D=ea(u+ea(p*ea(g[d+(t<<6)+40>>2])));u=ea(m*ea(g[d+(q<<6)+48>>2]));E=ea(u+ea(n*ea(g[d+(r<<6)+48>>2])));u=ea(E+ea(o*ea(g[d+(s<<6)+48>>2])));E=ea(u+ea(p*ea(g[d+(t<<6)+48>>2])));u=ea(m*ea(g[d+(q<<6)+52>>2]));F=ea(u+ea(n*ea(g[d+(r<<6)+52>>2])));u=ea(F+ea(o*ea(g[d+(s<<6)+52>>2])));F=ea(u+ea(p*ea(g[d+(t<<6)+52>>2])));u=ea(m*ea(g[d+(q<<6)+56>>2]));m=ea(u+ea(n*ea(g[d+(r<<6)+56>>2])));n=ea(m+ea(o*ea(g[d+(s<<6)+56>>2])));o=ea(n+ea(p*ea(g[d+(t<<6)+56>>2])));p=ea(g[k>>2]);n=ea(v*p);v=ea(g[k+4>>2]);m=ea(n+ea(y*v));y=ea(g[k+8>>2]);n=ea(F+ea(ea(ea(w*p)+ea(z*v))+ea(C*y)));C=ea(o+ea(ea(ea(x*p)+ea(A*v))+ea(D*y)));g[l>>2]=ea(E+ea(m+ea(B*y)));g[l+4>>2]=n;g[l+8>>2]=C;a=a+1|0;if((a|0)==(h|0))break;else{j=j+32|0;k=k+e|0;l=l+f|0}}i=b;return}function oic(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;c[b>>2]=d;d=b+8|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];c[b+44>>2]=0;c[b+48>>2]=0;c[b+52>>2]=0;a[b+56>>0]=f&1;c[b+4>>2]=((a[e+7>>0]|0)!=0?2:0)|(a[e+3>>0]|0)!=0|((a[e+11>>0]|0)!=0?4:0)|((a[e+15>>0]|0)!=0?8:0)|((a[e+19>>0]|0)!=0?16:0)|((a[e+23>>0]|0)!=0?32:0)|((a[e+27>>0]|0)!=0?64:0)|((a[e+31>>0]|0)!=0?128:0);return}function pic(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+44>>2]|0;if(!d){i=b;return}e=a+48|0;a=c[e>>2]|0;if((a|0)!=(d|0))c[e>>2]=a+(~((a+-16-d|0)>>>4)<<4);ACi(d);i=b;return}function qic(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;k=c[a+4>>2]|0;l=(k|-131)&b;b=0;while(1){m=1<<b+3;if(m&k){n=l;break}o=l&~m;b=b+1|0;if((b|0)>=4){n=o;break}else l=o}if(!d){p=0;q=n}else{p=c[d>>2]|0;q=n}l=a+44|0;b=c[l>>2]|0;k=a+48|0;o=c[k>>2]|0;m=o-b>>4;if(!m)r=b;else{s=b;b=m;while(1){m=(b|0)/2|0;t=s+(m<<4)|0;u=c[t+4>>2]|0;if(u>>>0<p>>>0|((u|0)==(p|0)?(c[t>>2]|0)>>>0<q>>>0:0)){v=s+(m+1<<4)|0;w=b+-1-m|0}else{v=s;w=m}if(!w){r=v;break}else{s=v;b=w}}}if((r|0)!=(o|0)?(w=r,b=c[w+4>>2]|0,v=p>>>0<b>>>0|((p|0)==(b|0)?q>>>0<(c[w>>2]|0)>>>0:0)?o:r,(v|0)!=(o|0)):0){x=c[v+8>>2]|0;i=e;return x|0}v=ric(a,n,d)|0;d=j;c[d>>2]=q;c[d+4>>2]=p;c[j+8>>2]=v;d=c[l>>2]|0;l=c[k>>2]|0;k=l-d>>4;if(!k)y=d;else{n=d;d=k;while(1){k=(d|0)/2|0;o=n+(k<<4)|0;r=c[o+4>>2]|0;if(r>>>0<p>>>0|((r|0)==(p|0)?(c[o>>2]|0)>>>0<q>>>0:0)){z=n+(k+1<<4)|0;A=d+-1-k|0}else{z=n;A=k}if(!A){y=z;break}else{n=z;d=A}}}if((y|0)!=(l|0)?(l=y,A=c[l+4>>2]|0,!(p>>>0<A>>>0|((p|0)==(A|0)?q>>>0<(c[l>>2]|0)>>>0:0))):0){x=v;i=e;return x|0}c[h>>2]=y;c[f+0>>2]=c[h+0>>2];vic(g,a+44|0,f,j);x=v;i=e;return x|0}function ric(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+64|0;h=g+32|0;j=g;k=(f|0)!=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;l=c[b+4>>2]|0;if(!l)m=0;else{n=0;o=1;p=0;while(1){if(!(a[b+(p<<2)+11>>0]|0))q=n;else{r=a[b+(p<<2)+8>>0]|0;q=(n&255)<(r&255)?r:n}p=p+1|0;o=o<<1;if(!((p|0)<8&o>>>0<=l>>>0)){m=q;break}else n=q}}q=m&255;m=q+1|0;if(k){n=f+8|0;c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[h+16>>2]=c[n+16>>2];c[h+20>>2]=c[n+20>>2];c[h+24>>2]=c[n+24>>2];c[h+28>>2]=c[n+28>>2];if(a[h+3>>0]|0)a[h>>0]=(d[h>>0]|0)+m;if(a[h+7>>0]|0){n=h+4|0;a[n>>0]=(d[n>>0]|0)+m}if(a[h+11>>0]|0){n=h+8|0;a[n>>0]=(d[n>>0]|0)+m}if(a[h+15>>0]|0){n=h+12|0;a[n>>0]=(d[n>>0]|0)+m}if(a[h+19>>0]|0){n=h+16|0;a[n>>0]=(d[n>>0]|0)+m}if(a[h+23>>0]|0){n=h+20|0;a[n>>0]=(d[n>>0]|0)+m}if(a[h+27>>0]|0){n=h+24|0;a[n>>0]=(d[n>>0]|0)+m}if(a[h+31>>0]|0){n=h+28|0;a[n>>0]=(d[n>>0]|0)+m}n=c[f+4>>2]|0;if(!n)s=0;else{l=0;o=0;p=1;while(1){if(!(a[f+(l<<2)+11>>0]|0))t=o;else{r=a[f+(l<<2)+8>>0]|0;t=(o&255)<(r&255)?r:o}l=l+1|0;p=p<<1;if(!((l|0)<8&p>>>0<=n>>>0)){s=t;break}else o=t}}u=q+2+(s&255)|0}else u=m;m=u&255;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;a:do if(e){if(k){v=0;w=1;x=0}else{u=0;s=1;q=0;while(1){t=(s&120|0)!=0;o=c[b+(q<<2)+8>>2]|0;n=o>>>24;p=n&255;if(t&p<<24>>24!=0)y=n<<24|o&16777215;else y=u;do if(s&e){if(p<<24>>24){c[j+(q<<2)>>2]=n<<24|o&16777215;break}if(t)c[j+(q<<2)>>2]=y}while(0);q=q+1|0;s=s<<1;if(!((q|0)<8&s>>>0<=e>>>0))break a;else u=y}}while(1){u=(w&120|0)!=0;if(!(a[h+(x<<2)+3>>0]|0))z=c[b+(x<<2)+8>>2]|0;else z=c[h+(x<<2)>>2]|0;s=z>>>24;q=s&255;if(u&q<<24>>24!=0)A=s<<24|z&16777215;else A=v;do if(w&e){if(q<<24>>24){c[j+(x<<2)>>2]=s<<24|z&16777215;break}if(u)c[j+(x<<2)>>2]=A}while(0);x=x+1|0;w=w<<1;if(!((x|0)<8&w>>>0<=e>>>0))break;else v=A}}while(0);if((e&4&c[155248]|0)!=0?(e=j+11|0,(a[e>>0]|0)==0):0){a[j+8>>0]=m;a[j+9>>0]=0;a[j+10>>0]=2;a[e>>0]=4}if(!(a[b+56>>0]|0)){B=ync()|0;C=c[B>>2]|0;D=C+300|0;E=c[D>>2]|0;F=_n[E&4095](B,j)|0;i=g;return F|0}else{B=Bnc()|0;C=c[B>>2]|0;D=C+300|0;E=c[D>>2]|0;F=_n[E&4095](B,j)|0;i=g;return F|0}return 0}function sic(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+240|0;f=e+224|0;g=e+220|0;h=e+216|0;j=e+124|0;k=e+32|0;l=e;m=c[b+4>>2]|0;n=b+4|0;if(m){o=n;p=m;a:while(1){m=p;while(1){if(!(Iic(m+16|0,d)|0)){q=m;break}m=c[m+4>>2]|0;if(!m){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if((r|0)!=(n|0))if(Iic(d,r+16|0)|0)s=r;else{t=r;u=t+48|0;i=e;return u|0}else s=n}else s=n;n=b+12|0;r=(c[n>>2]|0)+1|0;c[n>>2]=r;c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];c[l+16>>2]=c[d+16>>2];c[l+20>>2]=c[d+20>>2];c[l+24>>2]=c[d+24>>2];c[l+28>>2]=c[d+28>>2];n=((a[d+7>>0]|0)!=0?2:0)|(a[d+3>>0]|0)!=0|((a[d+11>>0]|0)!=0?4:0)|((a[d+15>>0]|0)!=0?8:0)|((a[d+19>>0]|0)!=0?16:0)|((a[d+23>>0]|0)!=0?32:0)|((a[d+27>>0]|0)!=0?64:0)|((a[d+31>>0]|0)!=0?128:0);c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[k+16>>2]=c[d+16>>2];c[k+20>>2]=c[d+20>>2];c[k+24>>2]=c[d+24>>2];c[k+28>>2]=c[d+28>>2];c[k+32>>2]=r;c[k+36>>2]=n;n=k+40|0;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];c[n+16>>2]=c[l+16>>2];c[n+20>>2]=c[l+20>>2];c[n+24>>2]=c[l+24>>2];c[n+28>>2]=c[l+28>>2];l=k+76|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;a[l+12>>0]=0;c[h>>2]=s;s=j+32|0;l=k+32|0;n=s+40|0;do{c[s>>2]=c[l>>2];s=s+4|0;l=l+4|0}while((s|0)<(n|0));c[j+76>>2]=0;l=j+80|0;c[l>>2]=0;c[j+84>>2]=0;a[j+88>>0]=0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];c[f+0>>2]=c[h+0>>2];xic(g,b,f,j);f=c[g>>2]|0;g=c[j+76>>2]|0;if(!g){t=f;u=t+48|0;i=e;return u|0}j=c[l>>2]|0;if((j|0)!=(g|0))c[l>>2]=j+(~((j+-16-g|0)>>>4)<<4);ACi(g);t=f;u=t+48|0;i=e;return u|0}function tic(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;$ic(b,575992,e)|0;b=sic(a,e)|0;i=d;return b|0}function uic(){return c[143982]|0}function vic(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;g=c[b>>2]|0;h=g;j=(c[d>>2]|0)-h>>4;d=g+(j<<4)|0;k=b+4|0;l=c[k>>2]|0;m=b+8|0;n=c[m>>2]|0;if(l>>>0<n>>>0){if((d|0)==(l|0)){if(!d)o=0;else{c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];o=c[k>>2]|0}c[k>>2]=o+16;p=d;c[a>>2]=p;i=f;return}o=l-(g+(j+1<<4))>>4;q=g+(o+j<<4)|0;if(q>>>0<l>>>0){r=l;s=q;while(1){if(!r)t=0;else{c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];t=c[k>>2]|0}s=s+16|0;u=t+16|0;c[k>>2]=u;if(s>>>0>=l>>>0){v=u;break}else r=u}}else v=l;if(o){o=q;q=l;do{r=q;q=q+-16|0;s=o;o=o+-16|0;t=o;u=c[t+4>>2]|0;w=q;c[w>>2]=c[t>>2];c[w+4>>2]=u;c[r+-8>>2]=c[s+-8>>2]}while((o|0)!=(d|0))}if(d>>>0>e>>>0)x=e;else x=v>>>0>e>>>0?e+16|0:e;v=x;o=c[v+4>>2]|0;q=d;c[q>>2]=c[v>>2];c[q+4>>2]=o;c[g+(j<<4)+8>>2]=c[x+8>>2];p=d;c[a>>2]=p;i=f;return}x=(l-h>>4)+1|0;if(x>>>0>268435455)vxi(b);h=g;g=n-h|0;if(g>>4>>>0<134217727){n=g>>3;g=n>>>0<x>>>0?x:n;n=d;x=n-h>>4;if(!g){y=0;z=n;A=0;B=x}else{C=g;D=x;E=n;F=20}}else{n=d;C=268435455;D=n-h>>4;E=n;F=20}if((F|0)==20){y=C;z=E;A=xCi(C<<4)|0;B=D}D=A+(B<<4)|0;C=A+(y<<4)|0;do if((B|0)==(y|0)){if((B|0)>0){G=C;H=A+(((B+1|0)/-2|0)+B<<4)|0;break}E=(B|0)==0?1:B<<1;F=xCi(E<<4)|0;n=F+(E>>>2<<4)|0;h=F+(E<<4)|0;if(!A){G=h;H=n}else{ACi(A);G=h;H=n}}else{G=C;H=D}while(0);if(!H)I=0;else{c[H+0>>2]=c[e+0>>2];c[H+4>>2]=c[e+4>>2];c[H+8>>2]=c[e+8>>2];c[H+12>>2]=c[e+12>>2];I=H}e=c[b>>2]|0;D=z-e|0;C=H+(0-(D>>4)<<4)|0;YEi(C|0,e|0,D|0)|0;D=(c[k>>2]|0)-z|0;YEi(I+16|0,d|0,D|0)|0;d=c[b>>2]|0;c[b>>2]=C;c[k>>2]=I+((D>>4)+1<<4);c[m>>2]=G;if(!d){p=H;c[a>>2]=p;i=f;return}ACi(d);p=H;c[a>>2]=p;i=f;return}function wic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b){i=d;return}wic(a,c[b>>2]|0);wic(a,c[b+4>>2]|0);a=c[b+92>>2]|0;if(a){e=b+96|0;f=c[e>>2]|0;if((f|0)!=(a|0))c[e>>2]=f+(~((f+-16-a|0)>>>4)<<4);ACi(a)}ACi(b);i=d;return}function xic(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;c[k>>2]=c[e>>2];c[h+0>>2]=c[k+0>>2];k=Aic(d,h,j,f)|0;h=c[k>>2]|0;if(h){l=h;c[b>>2]=l;i=g;return}h=xCi(108)|0;e=h+16|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];m=h+48|0;n=f+32|0;o=m+40|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));a[h+88>>0]=a[f+72>>0]|0;Bic(h+92|0,f+76|0);a[h+104>>0]=a[f+88>>0]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];f=c[j>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=f;c[k>>2]=h;f=c[c[d>>2]>>2]|0;if(!f)p=h;else{c[d>>2]=f;p=c[k>>2]|0}GN(c[d+4>>2]|0,p);p=d+8|0;c[p>>2]=(c[p>>2]|0)+1;l=h;c[b>>2]=l;i=g;return}function yic(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=0;c[b+0>>2]=c[d+0>>2];d=bOb(16,b,0,16,3653512,190)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[d+12>>2]=0;c[143982]=d;i=a;return}function zic(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[143982]|0;if(e)wic(e,c[e+4>>2]|0);c[d>>2]=0;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[143982]=0;i=a;return}function Aic(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=h+16|0,!(Iic(e,b)|0)):0){if(!(Iic(b,e)|0)){c[d>>2]=h;j=d;i=f;return j|0}b=h+4|0;k=c[b>>2]|0;if(!k){l=h;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=k;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}do if((n|0)!=(g|0)){if(Iic(e,n+16|0)|0){o=c[b>>2]|0;break}l=c[a+4>>2]|0;if(!l){c[d>>2]=g;j=g;i=f;return j|0}else p=l;while(1){l=p+16|0;if(Iic(e,l)|0){m=c[p>>2]|0;if(!m){q=p;r=p;s=35;break}else{p=m;continue}}if(!(Iic(l,e)|0)){t=p;s=39;break}l=p+4|0;m=c[l>>2]|0;if(!m){u=l;v=p;s=38;break}else p=m}if((s|0)==35){c[d>>2]=r;j=q;i=f;return j|0}else if((s|0)==38){c[d>>2]=v;j=u;i=f;return j|0}else if((s|0)==39){c[d>>2]=t;j=d;i=f;return j|0}}else o=k;while(0);if(!o){c[d>>2]=h;j=b;i=f;return j|0}else{c[d>>2]=n;j=n;i=f;return j|0}}if((h|0)!=(c[a>>2]|0)){n=c[h>>2]|0;if(!n){b=h;while(1){o=c[b+8>>2]|0;if((c[o>>2]|0)==(b|0))b=o;else{w=o;break}}}else{b=n;while(1){n=c[b+4>>2]|0;if(!n){w=b;break}else b=n}}if(!(Iic(w+16|0,e)|0)){b=c[a+4>>2]|0;if(!b){c[d>>2]=g;j=g;i=f;return j|0}else x=b;while(1){b=x+16|0;if(Iic(e,b)|0){g=c[x>>2]|0;if(!g){y=x;z=x;s=15;break}else{x=g;continue}}if(!(Iic(b,e)|0)){A=x;s=19;break}b=x+4|0;g=c[b>>2]|0;if(!g){B=b;C=x;s=18;break}else x=g}if((s|0)==15){c[d>>2]=z;j=y;i=f;return j|0}else if((s|0)==18){c[d>>2]=C;j=B;i=f;return j|0}else if((s|0)==19){c[d>>2]=A;j=d;i=f;return j|0}}else D=w}else D=h;if(!(c[h>>2]|0)){c[d>>2]=h;j=h;i=f;return j|0}else{c[d>>2]=D;j=D+4|0;i=f;return j|0}return 0}function Bic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=(c[g>>2]|0)-(c[b>>2]|0)|0;j=h>>4;if(!j){i=d;return}if(j>>>0>268435455)vxi(a);k=xCi(h)|0;c[e>>2]=k;c[a>>2]=k;c[f>>2]=k+(j<<4);j=c[b>>2]|0;b=c[g>>2]|0;if((j|0)==(b|0)){i=d;return}else{l=j;m=k}do{c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];m=(c[e>>2]|0)+16|0;c[e>>2]=m;l=l+16|0}while((l|0)!=(b|0));i=d;return}function Cic(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);c[b>>2]=-1;itd(b,575936);i=a;return}function Dic(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Eic(a,b,d){a=a|0;b=b|0;d=d|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Fic(a,b,d,e,f,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=Im,W=Im,X=0,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;o=i;i=i+48|0;p=o;q=(m|0)/4|0;TLc(p,b);if(n&2)VLc(p);r=d+-1|0;if(!d){i=o;return}d=b+16|0;s=b+32|0;t=b+48|0;u=b+4|0;v=b+20|0;w=b+36|0;x=b+52|0;y=b+8|0;z=b+24|0;A=b+40|0;B=b+56|0;C=p+12|0;D=f+4|0;E=p+24|0;F=f+8|0;G=p+4|0;H=p+16|0;I=p+28|0;J=p+8|0;K=p+20|0;L=p+32|0;M=(n&1|0)==0;n=(h|0)>-1;N=h+4|0;O=h+8|0;P=h+12|0;Q=(m|0)>3;R=(m|0)>7?q<<2:4;if((f|0)>-1){m=a;S=e;T=k;U=r;while(1){V=ea(g[b>>2]);W=ea(V*ea(g[S>>2]));V=ea(g[d>>2]);X=S+4|0;Y=ea(g[X>>2]);Z=ea(W+ea(V*Y));V=ea(g[s>>2]);W=ea(g[S+8>>2]);_=ea(Z+ea(V*W));g[m>>2]=ea(ea(g[t>>2])+_);_=ea(g[u>>2]);V=ea(g[S>>2]);Z=ea(_*V);_=ea(Z+ea(Y*ea(g[v>>2])));Y=ea(_+ea(W*ea(g[w>>2])));g[m+4>>2]=ea(ea(g[x>>2])+Y);Y=ea(V*ea(g[y>>2]));V=ea(g[z>>2]);_=ea(Y+ea(V*ea(g[X>>2])));V=ea(_+ea(W*ea(g[A>>2])));g[m+8>>2]=ea(ea(g[B>>2])+V);X=S+f|0;V=ea(g[p>>2]);W=ea(V*ea(g[X>>2]));V=ea(g[C>>2]);$=S+D|0;_=ea(g[$>>2]);Y=ea(W+ea(V*_));V=ea(g[E>>2]);W=ea(g[S+F>>2]);g[m+12>>2]=ea(Y+ea(V*W));V=ea(g[G>>2]);Y=ea(g[X>>2]);Z=ea(V*Y);V=ea(Z+ea(_*ea(g[H>>2])));g[m+16>>2]=ea(V+ea(W*ea(g[I>>2])));V=ea(Y*ea(g[J>>2]));Y=ea(g[K>>2]);_=ea(V+ea(Y*ea(g[$>>2])));g[m+20>>2]=ea(_+ea(W*ea(g[L>>2])));$=m+24|0;if(M){aa=$;ba=24}else{c[$>>2]=-1;aa=m+28|0;ba=28}if(!T){ca=0;da=aa}else{if(Q){$=m+(ba+R)|0;X=T;fa=aa;ga=0;while(1){c[fa>>2]=c[X>>2];ga=ga+1|0;if((ga|0)>=(q|0))break;else{X=X+4|0;fa=fa+4|0}}ha=$}else ha=aa;ca=T+l|0;da=ha}if(n){fa=S+h|0;W=ea(g[b>>2]);_=ea(W*ea(g[fa>>2]));W=ea(g[d>>2]);X=S+N|0;Y=ea(g[X>>2]);V=ea(_+ea(W*Y));W=ea(g[s>>2]);_=ea(g[S+O>>2]);g[da>>2]=ea(V+ea(W*_));W=ea(g[u>>2]);V=ea(g[fa>>2]);Z=ea(W*V);W=ea(Z+ea(Y*ea(g[v>>2])));g[da+4>>2]=ea(W+ea(_*ea(g[w>>2])));W=ea(V*ea(g[y>>2]));V=ea(g[z>>2]);Y=ea(W+ea(V*ea(g[X>>2])));g[da+8>>2]=ea(Y+ea(_*ea(g[A>>2])));g[da+12>>2]=ea(g[S+P>>2]);ia=da+16|0}else ia=da;if(!U)break;else{m=ia;S=S+j|0;T=ca;U=U+-1|0}}i=o;return}else{U=a;a=e;e=k;k=r;while(1){_=ea(g[b>>2]);Y=ea(_*ea(g[a>>2]));_=ea(g[d>>2]);r=a+4|0;V=ea(g[r>>2]);W=ea(Y+ea(_*V));_=ea(g[s>>2]);Y=ea(g[a+8>>2]);Z=ea(W+ea(_*Y));g[U>>2]=ea(ea(g[t>>2])+Z);Z=ea(g[u>>2]);_=ea(g[a>>2]);W=ea(Z*_);Z=ea(W+ea(V*ea(g[v>>2])));V=ea(Z+ea(Y*ea(g[w>>2])));g[U+4>>2]=ea(ea(g[x>>2])+V);V=ea(_*ea(g[y>>2]));_=ea(g[z>>2]);Z=ea(V+ea(_*ea(g[r>>2])));_=ea(Z+ea(Y*ea(g[A>>2])));g[U+8>>2]=ea(ea(g[B>>2])+_);r=U+12|0;if(M){ja=r;ka=12}else{c[r>>2]=-1;ja=U+16|0;ka=16}if(!e){la=0;ma=ja}else{if(Q){r=U+(ka+R)|0;ca=e;T=ja;S=0;while(1){c[T>>2]=c[ca>>2];S=S+1|0;if((S|0)>=(q|0))break;else{ca=ca+4|0;T=T+4|0}}na=r}else na=ja;la=e+l|0;ma=na}if(n){T=a+h|0;_=ea(g[b>>2]);Y=ea(_*ea(g[T>>2]));_=ea(g[d>>2]);ca=a+N|0;Z=ea(g[ca>>2]);V=ea(Y+ea(_*Z));_=ea(g[s>>2]);Y=ea(g[a+O>>2]);g[ma>>2]=ea(V+ea(_*Y));_=ea(g[u>>2]);V=ea(g[T>>2]);W=ea(_*V);_=ea(W+ea(Z*ea(g[v>>2])));g[ma+4>>2]=ea(_+ea(Y*ea(g[w>>2])));_=ea(V*ea(g[y>>2]));V=ea(g[z>>2]);Z=ea(_+ea(V*ea(g[ca>>2])));g[ma+8>>2]=ea(Z+ea(Y*ea(g[A>>2])));g[ma+12>>2]=ea(g[a+P>>2]);oa=ma+16|0}else oa=ma;if(!k)break;else{U=oa;a=a+j|0;e=la;k=k+-1|0}}i=o;return}}function Gic(b,e,f,h,j,k,l,m,n){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0;o=i;i=i+64|0;p=o;tMc(e,p);q=ea(g[e>>2]);r=e+4|0;s=ea(g[r>>2]);t=e+8|0;u=ea(g[t>>2]);v=ea(T(ea(ea(ea(q*q)+ea(s*s))+ea(u*u))));if(v>ea(9.99999997e-07))w=ea(ea(1.0)/v);else w=ea(1.0);g[p>>2]=ea(w*ea(g[p>>2]));x=p+4|0;g[x>>2]=ea(w*ea(g[x>>2]));y=p+8|0;g[y>>2]=ea(w*ea(g[y>>2]));z=p+16|0;g[z>>2]=ea(w*ea(g[z>>2]));A=p+20|0;g[A>>2]=ea(w*ea(g[A>>2]));B=p+24|0;g[B>>2]=ea(w*ea(g[B>>2]));C=p+32|0;g[C>>2]=ea(w*ea(g[C>>2]));D=p+36|0;g[D>>2]=ea(w*ea(g[D>>2]));E=p+40|0;g[E>>2]=ea(w*ea(g[E>>2]));if(!f){i=o;return}F=e+16|0;G=e+32|0;H=e+48|0;I=e+20|0;J=e+36|0;K=e+52|0;L=e+24|0;M=e+40|0;N=e+56|0;O=h+4|0;P=n+4|0;Q=m+4|0;R=l+4|0;S=k+4|0;U=j+4|0;V=b;b=f;w=q;while(1){f=b+-1|0;W=c[h>>2]|0;q=ea(w*ea(g[W>>2]));v=ea(g[F>>2]);X=W+4|0;u=ea(g[X>>2]);s=ea(q+ea(v*u));v=ea(g[G>>2]);q=ea(g[W+8>>2]);Y=ea(s+ea(v*q));g[V>>2]=ea(ea(g[H>>2])+Y);Y=ea(g[r>>2]);v=ea(g[W>>2]);s=ea(Y*v);Y=ea(s+ea(u*ea(g[I>>2])));u=ea(Y+ea(q*ea(g[J>>2])));g[V+4>>2]=ea(ea(g[K>>2])+u);u=ea(v*ea(g[t>>2]));v=ea(g[L>>2]);Y=ea(u+ea(v*ea(g[X>>2])));v=ea(Y+ea(q*ea(g[M>>2])));g[V+8>>2]=ea(ea(g[N>>2])+v);X=V+12|0;c[h>>2]=W+(c[O>>2]|0);W=c[j>>2]|0;if(!W){Z=X;_=V}else{v=ea(g[p>>2]);q=ea(v*ea(g[W>>2]));v=ea(g[z>>2]);$=W+4|0;Y=ea(g[$>>2]);u=ea(q+ea(v*Y));v=ea(g[C>>2]);q=ea(g[W+8>>2]);g[X>>2]=ea(u+ea(v*q));v=ea(g[x>>2]);u=ea(g[W>>2]);s=ea(v*u);v=ea(s+ea(Y*ea(g[A>>2])));g[V+16>>2]=ea(v+ea(q*ea(g[D>>2])));v=ea(u*ea(g[y>>2]));u=ea(g[B>>2]);Y=ea(v+ea(u*ea(g[$>>2])));g[V+20>>2]=ea(Y+ea(q*ea(g[E>>2])));c[j>>2]=W+(c[U>>2]|0);Z=V+24|0;_=X}X=c[k>>2]|0;if(!X)aa=Z;else{W=d[X>>0]|d[X+1>>0]<<8|d[X+2>>0]<<16|d[X+3>>0]<<24;a[Z>>0]=W;a[Z+1>>0]=W>>8;a[Z+2>>0]=W>>16;a[Z+3>>0]=W>>24;c[k>>2]=(c[k>>2]|0)+(c[S>>2]|0);aa=_+16|0}W=c[l>>2]|0;if(!W)ba=aa;else{X=W;W=X;$=d[W>>0]|d[W+1>>0]<<8|d[W+2>>0]<<16|d[W+3>>0]<<24;W=X+4|0;X=d[W>>0]|d[W+1>>0]<<8|d[W+2>>0]<<16|d[W+3>>0]<<24;W=aa;ca=W;a[ca>>0]=$;a[ca+1>>0]=$>>8;a[ca+2>>0]=$>>16;a[ca+3>>0]=$>>24;$=W+4|0;a[$>>0]=X;a[$+1>>0]=X>>8;a[$+2>>0]=X>>16;a[$+3>>0]=X>>24;c[l>>2]=(c[l>>2]|0)+(c[R>>2]|0);ba=aa+8|0}X=c[m>>2]|0;if(!X)da=ba;else{$=X;X=$;W=d[X>>0]|d[X+1>>0]<<8|d[X+2>>0]<<16|d[X+3>>0]<<24;X=$+4|0;$=d[X>>0]|d[X+1>>0]<<8|d[X+2>>0]<<16|d[X+3>>0]<<24;X=ba;ca=X;a[ca>>0]=W;a[ca+1>>0]=W>>8;a[ca+2>>0]=W>>16;a[ca+3>>0]=W>>24;W=X+4|0;a[W>>0]=$;a[W+1>>0]=$>>8;a[W+2>>0]=$>>16;a[W+3>>0]=$>>24;c[m>>2]=(c[m>>2]|0)+(c[Q>>2]|0);da=ba+8|0}$=c[n>>2]|0;if(!$)fa=da;else{q=ea(g[p>>2]);Y=ea(q*ea(g[$>>2]));q=ea(g[z>>2]);W=$+4|0;u=ea(g[W>>2]);v=ea(Y+ea(q*u));q=ea(g[C>>2]);Y=ea(g[$+8>>2]);g[da>>2]=ea(v+ea(q*Y));q=ea(g[x>>2]);v=ea(g[$>>2]);s=ea(q*v);q=ea(s+ea(u*ea(g[A>>2])));g[da+4>>2]=ea(q+ea(Y*ea(g[D>>2])));q=ea(v*ea(g[y>>2]));v=ea(g[B>>2]);u=ea(q+ea(v*ea(g[W>>2])));g[da+8>>2]=ea(u+ea(Y*ea(g[E>>2])));g[da+12>>2]=ea(g[$+12>>2]);c[n>>2]=$+(c[P>>2]|0);fa=da+16|0}if(!f)break;V=fa;b=f;w=ea(g[e>>2])}i=o;return}function Hic(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+0|0;g=f+32|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(g|0));c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];i=e;return}function Iic(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(FEi(a,b,32)|0)<0;i=c;return d|0}function Jic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;h=c[142304]|0;add(b,576008,h,a+88|0,1);j=b+12|0;k=b+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,576032,h,a+92|0,1);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);c[g>>2]=0;c[g+8>>2]=0;k=g+12|0;c[k>>2]=0;j=g+4|0;c[j>>2]=60;add(b,671400,c[142306]|0,g,1);c[f>>2]=0;$cd(b,2646336,2646336,e,0);add(b,3142592,2923672,f,0);bjc(f,b);bdd(b);cdd(b);bdd(b);h=a+96|0;edd(b,h,595992,1);gdd(b,c[h>>2]|0,c[a+84>>2]|0,0);if((c[k>>2]|0)<=-1){i=d;return}k=c[g>>2]|0;c[f>>2]=c[j>>2];c[e+0>>2]=c[f+0>>2];eOb(k,e);c[g>>2]=0;i=d;return}function Kic(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+16|0;l=k;m=b+88|0;n=c[m>>2]&~g|f;c[b+92>>2]=e;c[m>>2]=0;g=b+80|0;c[g>>2]=0;o=0;p=0;while(1){q=b+(o*12|0)+32|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];r=c[h+(o<<2)>>2]&n;c[q>>2]=r;if(!r)s=p;else{c[m>>2]=c[m>>2]|r;r=c[q>>2]|0;if(!r)t=b+(o*12|0)+42|0;else{u=o&255;v=b+(o*12|0)+42|0;w=r;r=1;x=0;while(1){if(!(w&r))y=w;else{a[b+(x<<2)>>0]=u;z=a[v>>0]|0;a[b+(x<<2)+1>>0]=z;if(!(r&f)){A=a[b+(x<<2)+2>>0]|0;B=a[b+(x<<2)+3>>0]|0;C=z}else{z=a[j+(x<<1)>>0]|0;a[b+(x<<2)+2>>0]=z;D=a[j+(x<<1)+1>>0]|0;a[b+(x<<2)+3>>0]=D;A=z;B=D;C=a[v>>0]|0}a[v>>0]=(C&255)+(da(d[576080+(A&255)>>0]|0,B&255)|0);y=c[q>>2]|0}x=x+1|0;r=r<<1;if(!((x|0)<8&r>>>0<=y>>>0)){t=v;break}else w=y}}w=p+15&-16;c[b+(o*12|0)+36>>2]=w;v=d[t>>0]|0;r=(da(v,e)|0)+w|0;c[g>>2]=(c[g>>2]|0)+v;s=r}o=o+1|0;if((o|0)==4){E=s;break}else p=s}s=c[m>>2]|0;if(!(s&1))c[b>>2]=0;if(!(s&2))c[b+4>>2]=0;if(!(s&4))c[b+8>>2]=0;if(!(s&8))c[b+12>>2]=0;if(!(s&16))c[b+16>>2]=0;if(!(s&32))c[b+20>>2]=0;if(!(s&64))c[b+24>>2]=0;if(s&128){F=b+96|0;c[F>>2]=E;i=k;return}c[b+28>>2]=0;F=b+96|0;c[F>>2]=E;i=k;return}function Lic(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+2|0;g=b+4|0;h=b+6|0;j=b+8|0;k=b+10|0;l=b+12|0;m=b+14|0;n=c+2|0;o=b+0|0;p=o+14|0;do{a[o>>0]=0;o=o+1|0}while((o|0)<(p|0));o=(d[c+3>>0]|0)<<8&65535|(d[n>>0]|0);a[b>>0]=o;a[b+1>>0]=o>>8;o=(d[c+7>>0]|0)<<8&65535|(d[c+6>>0]|0);a[f>>0]=o;a[f+1>>0]=o>>8;o=(d[c+11>>0]|0)<<8&65535|(d[c+10>>0]|0);a[g>>0]=o;a[g+1>>0]=o>>8;o=(d[c+15>>0]|0)<<8&65535|(d[c+14>>0]|0);a[h>>0]=o;a[h+1>>0]=o>>8;o=(d[c+19>>0]|0)<<8&65535|(d[c+18>>0]|0);a[j>>0]=o;a[j+1>>0]=o>>8;o=(d[c+23>>0]|0)<<8&65535|(d[c+22>>0]|0);a[k>>0]=o;a[k+1>>0]=o>>8;o=(d[c+27>>0]|0)<<8&65535|(d[c+26>>0]|0);a[l>>0]=o;a[l+1>>0]=o>>8;o=(d[c+31>>0]|0)<<8&65535|(d[c+30>>0]|0);a[m>>0]=o;a[m+1>>0]=o>>8;i=e;return}function Mic(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;i=i+64|0;h=g+4|0;j=g+24|0;k=g+8|0;l=g+32|0;m=g+48|0;n=g+28|0;o=g;p=e+88|0;q=c[142304]|0;r=qdd(f,576008,q,h,0)|0;if(r){if((r|0)>0){r=f+12|0;s=c[f+16>>2]|0;t=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;u=s+t|0;c[r>>2]=u;if((t|0)>=0?(v=s+(t+4)|0,v>>>0<=(c[f+20>>2]|0)>>>0):0){c[p>>2]=c[u>>2];c[r>>2]=v}else Bid(r,p,4);if(c[f>>2]&512)c[p>>2]=XEi(c[p>>2]|0)|0}else{r=c[h>>2]|0;if(r)_n[r&4095](p,f)|0}sdd(f)}r=e+92|0;v=qdd(f,576032,q,h,0)|0;if(v){if((v|0)>0){v=f+12|0;q=c[f+16>>2]|0;u=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;t=q+u|0;c[v>>2]=t;if((u|0)>=0?(s=q+(u+4)|0,s>>>0<=(c[f+20>>2]|0)>>>0):0){c[r>>2]=c[t>>2];c[v>>2]=s}else Bid(v,r,4);if(c[f>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{v=c[h>>2]|0;if(v)_n[v&4095](r,f)|0}sdd(f)}c[k>>2]=0;v=k+8|0;c[v>>2]=0;s=k+12|0;c[s>>2]=0;t=k+4|0;c[t>>2]=60;u=qdd(f,671400,c[142306]|0,h,1)|0;if(u){if((u|0)<=0){u=c[h>>2]|0;if(u)_n[u&4095](k,f)|0}else cjc(f,k,0);sdd(f)}u=c[v>>2]|0;if((u|0)==8)aFi(e|0,c[k>>2]|0,32)|0;else if(!u){v=c[p>>2]|0;c[p>>2]=v<<2&128|v&31;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0}else if((u|0)==6){u=c[k>>2]|0;aFi(e|0,u|0,20)|0;v=e+20|0;c[v>>2]=0;c[v+4>>2]=0;c[e+28>>2]=c[u+20>>2];if((a[e+10>>0]|0)==2)a[e+11>>0]=4}else{Krd(576048,0,3653512,121,1,0,0,0);c[p>>2]=0};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;u=a[e+3>>0]|0;if(!(u<<24>>24))w=0;else{v=l+(d[e>>0]<<2)|0;c[v>>2]=c[v>>2]|1;w=1}v=a[e+7>>0]|0;if(!(v<<24>>24))x=w;else{q=l+(d[e+4>>0]<<2)|0;c[q>>2]=c[q>>2]|2;x=w|2}w=a[e+11>>0]|0;if(!(w<<24>>24))y=x;else{q=l+(d[e+8>>0]<<2)|0;c[q>>2]=c[q>>2]|4;y=x|4}x=a[e+15>>0]|0;if(!(x<<24>>24))z=y;else{q=l+(d[e+12>>0]<<2)|0;c[q>>2]=c[q>>2]|8;z=y|8}y=a[e+19>>0]|0;if(!(y<<24>>24))A=z;else{q=l+(d[e+16>>0]<<2)|0;c[q>>2]=c[q>>2]|16;A=z|16}z=a[e+23>>0]|0;if(!(z<<24>>24))B=A;else{q=l+(d[e+20>>0]<<2)|0;c[q>>2]=c[q>>2]|32;B=A|32}A=a[e+27>>0]|0;if(!(A<<24>>24))C=B;else{q=l+(d[e+24>>0]<<2)|0;c[q>>2]=c[q>>2]|64;C=B|64}B=a[e+31>>0]|0;if(!(B<<24>>24)){q=c[r>>2]|0;if(!C){D=c[p>>2]|0;Kic(e,q,D,~D,575960,575992)}else{E=q;F=C;G=38}}else{q=l+(d[e+28>>0]<<2)|0;c[q>>2]=c[q>>2]|128;E=c[r>>2]|0;F=C|128;G=38}if((G|0)==38){b[m+0>>1]=0;b[m+2>>1]=0;b[m+4>>1]=0;b[m+6>>1]=0;b[m+8>>1]=0;b[m+10>>1]=0;b[m>>1]=(u&255)<<8&65535|d[e+2>>0];b[m+2>>1]=(v&255)<<8&65535|d[e+6>>0];b[m+4>>1]=(w&255)<<8&65535|d[e+10>>0];b[m+6>>1]=(x&255)<<8&65535|d[e+14>>0];b[m+8>>1]=(y&255)<<8&65535|d[e+18>>0];b[m+10>>1]=(z&255)<<8&65535|d[e+22>>0];b[m+12>>1]=(A&255)<<8&65535|d[e+26>>0];b[m+14>>1]=(B&255)<<8&65535|d[e+30>>0];Kic(e,E,F,~F,l,m)}m=e+96|0;ydd(f,m,595992,1);l=e+84|0;e=c[l>>2]|0;if(!(a[f+136>>0]|0))H=e;else{if(e){c[n>>2]=c[153074];c[h+0>>2]=c[n+0>>2];eOb(e,h)}e=(c[m>>2]|0)+16|0;c[o>>2]=c[153074];c[h+0>>2]=c[o+0>>2];o=cOb(e,32,h,0,3653512,150)|0;c[l>>2]=o;H=o}zdd(f,c[m>>2]|0,H,0);if((c[s>>2]|0)<=-1){i=g;return}s=c[k>>2]|0;c[j>>2]=c[t>>2];c[h+0>>2]=c[j+0>>2];eOb(s,h);c[k>>2]=0;i=g;return}function Nic(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=i;i=i+64|0;h=g+4|0;j=g+24|0;k=g+8|0;l=g+32|0;m=g+48|0;n=g+28|0;o=g;p=e+88|0;q=f+12|0;r=c[q>>2]|0;s=r+4|0;t=f+20|0;u=c[t>>2]|0;if(s>>>0>u>>>0){Bid(q,p,4);v=c[q>>2]|0;w=c[t>>2]|0}else{c[p>>2]=c[r>>2];c[q>>2]=s;v=s;w=u}u=e+92|0;s=v+4|0;if(s>>>0>w>>>0)Bid(q,u,4);else{c[u>>2]=c[v>>2];c[q>>2]=s}c[k>>2]=0;s=k+8|0;c[s>>2]=0;q=k+12|0;c[q>>2]=0;v=k+4|0;c[v>>2]=60;djc(f,k,0);w=c[s>>2]|0;if((w|0)==6){s=c[k>>2]|0;aFi(e|0,s|0,20)|0;r=e+20|0;c[r>>2]=0;c[r+4>>2]=0;c[e+28>>2]=c[s+20>>2];if((a[e+10>>0]|0)==2)a[e+11>>0]=4}else if(!w){s=c[p>>2]|0;c[p>>2]=s<<2&128|s&31;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0}else if((w|0)==8)aFi(e|0,c[k>>2]|0,32)|0;else{Krd(576048,0,3653512,121,1,0,0,0);c[p>>2]=0};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;w=a[e+3>>0]|0;if(!(w<<24>>24))x=0;else{s=l+(d[e>>0]<<2)|0;c[s>>2]=c[s>>2]|1;x=1}s=a[e+7>>0]|0;if(!(s<<24>>24))y=x;else{r=l+(d[e+4>>0]<<2)|0;c[r>>2]=c[r>>2]|2;y=x|2}x=a[e+11>>0]|0;if(!(x<<24>>24))z=y;else{r=l+(d[e+8>>0]<<2)|0;c[r>>2]=c[r>>2]|4;z=y|4}y=a[e+15>>0]|0;if(!(y<<24>>24))A=z;else{r=l+(d[e+12>>0]<<2)|0;c[r>>2]=c[r>>2]|8;A=z|8}z=a[e+19>>0]|0;if(!(z<<24>>24))B=A;else{r=l+(d[e+16>>0]<<2)|0;c[r>>2]=c[r>>2]|16;B=A|16}A=a[e+23>>0]|0;if(!(A<<24>>24))C=B;else{r=l+(d[e+20>>0]<<2)|0;c[r>>2]=c[r>>2]|32;C=B|32}B=a[e+27>>0]|0;if(!(B<<24>>24))D=C;else{r=l+(d[e+24>>0]<<2)|0;c[r>>2]=c[r>>2]|64;D=C|64}C=a[e+31>>0]|0;if(!(C<<24>>24)){r=c[u>>2]|0;if(!D){t=c[p>>2]|0;Kic(e,r,t,~t,575960,575992)}else{E=r;F=D;G=16}}else{r=l+(d[e+28>>0]<<2)|0;c[r>>2]=c[r>>2]|128;E=c[u>>2]|0;F=D|128;G=16}if((G|0)==16){b[m+0>>1]=0;b[m+2>>1]=0;b[m+4>>1]=0;b[m+6>>1]=0;b[m+8>>1]=0;b[m+10>>1]=0;b[m>>1]=(w&255)<<8&65535|d[e+2>>0];b[m+2>>1]=(s&255)<<8&65535|d[e+6>>0];b[m+4>>1]=(x&255)<<8&65535|d[e+10>>0];b[m+6>>1]=(y&255)<<8&65535|d[e+14>>0];b[m+8>>1]=(z&255)<<8&65535|d[e+18>>0];b[m+10>>1]=(A&255)<<8&65535|d[e+22>>0];b[m+12>>1]=(B&255)<<8&65535|d[e+26>>0];b[m+14>>1]=(C&255)<<8&65535|d[e+30>>0];Kic(e,E,F,~F,l,m)}m=e+96|0;Rdd(f,m,595992,1);l=e+84|0;e=c[l>>2]|0;if(e){c[n>>2]=c[153074];c[h+0>>2]=c[n+0>>2];eOb(e,h)}e=(c[m>>2]|0)+16|0;c[o>>2]=c[153074];c[h+0>>2]=c[o+0>>2];o=cOb(e,32,h,0,3653512,150)|0;c[l>>2]=o;Pdd(f,c[m>>2]|0,o,0);if((c[q>>2]|0)<=-1){i=g;return}q=c[k>>2]|0;c[j>>2]=c[v>>2];c[h+0>>2]=c[j+0>>2];eOb(q,h);c[k>>2]=0;i=g;return}function Oic(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+64|0;h=g+4|0;j=g+24|0;k=g+8|0;l=g+32|0;m=g+48|0;n=g+28|0;o=g;p=e+88|0;q=f+12|0;r=c[q>>2]|0;s=r+4|0;t=f+20|0;u=c[t>>2]|0;if(s>>>0>u>>>0){Bid(q,p,4);v=c[p>>2]|0;w=c[q>>2]|0;x=c[t>>2]|0}else{t=c[r>>2]|0;c[p>>2]=t;c[q>>2]=s;v=t;w=s;x=u}c[p>>2]=XEi(v|0)|0;v=e+92|0;u=w+4|0;if(u>>>0>x>>>0){Bid(q,v,4);y=c[v>>2]|0}else{x=c[w>>2]|0;c[v>>2]=x;c[q>>2]=u;y=x}c[v>>2]=XEi(y|0)|0;c[k>>2]=0;y=k+8|0;c[y>>2]=0;x=k+12|0;c[x>>2]=0;u=k+4|0;c[u>>2]=60;ejc(f,k,0);q=c[y>>2]|0;if((q|0)==8)aFi(e|0,c[k>>2]|0,32)|0;else if(!q){y=c[p>>2]|0;c[p>>2]=y<<2&128|y&31;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0}else if((q|0)==6){q=c[k>>2]|0;aFi(e|0,q|0,20)|0;y=e+20|0;c[y>>2]=0;c[y+4>>2]=0;c[e+28>>2]=c[q+20>>2];if((a[e+10>>0]|0)==2)a[e+11>>0]=4}else{Krd(576048,0,3653512,121,1,0,0,0);c[p>>2]=0};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;q=a[e+3>>0]|0;if(!(q<<24>>24))z=0;else{y=l+(d[e>>0]<<2)|0;c[y>>2]=c[y>>2]|1;z=1}y=a[e+7>>0]|0;if(!(y<<24>>24))A=z;else{w=l+(d[e+4>>0]<<2)|0;c[w>>2]=c[w>>2]|2;A=z|2}z=a[e+11>>0]|0;if(!(z<<24>>24))B=A;else{w=l+(d[e+8>>0]<<2)|0;c[w>>2]=c[w>>2]|4;B=A|4}A=a[e+15>>0]|0;if(!(A<<24>>24))C=B;else{w=l+(d[e+12>>0]<<2)|0;c[w>>2]=c[w>>2]|8;C=B|8}B=a[e+19>>0]|0;if(!(B<<24>>24))D=C;else{w=l+(d[e+16>>0]<<2)|0;c[w>>2]=c[w>>2]|16;D=C|16}C=a[e+23>>0]|0;if(!(C<<24>>24))E=D;else{w=l+(d[e+20>>0]<<2)|0;c[w>>2]=c[w>>2]|32;E=D|32}D=a[e+27>>0]|0;if(!(D<<24>>24))F=E;else{w=l+(d[e+24>>0]<<2)|0;c[w>>2]=c[w>>2]|64;F=E|64}E=a[e+31>>0]|0;if(!(E<<24>>24)){w=c[v>>2]|0;if(!F){s=c[p>>2]|0;Kic(e,w,s,~s,575960,575992)}else{G=w;H=F;I=16}}else{w=l+(d[e+28>>0]<<2)|0;c[w>>2]=c[w>>2]|128;G=c[v>>2]|0;H=F|128;I=16}if((I|0)==16){b[m+0>>1]=0;b[m+2>>1]=0;b[m+4>>1]=0;b[m+6>>1]=0;b[m+8>>1]=0;b[m+10>>1]=0;b[m>>1]=(q&255)<<8&65535|d[e+2>>0];b[m+2>>1]=(y&255)<<8&65535|d[e+6>>0];b[m+4>>1]=(z&255)<<8&65535|d[e+10>>0];b[m+6>>1]=(A&255)<<8&65535|d[e+14>>0];b[m+8>>1]=(B&255)<<8&65535|d[e+18>>0];b[m+10>>1]=(C&255)<<8&65535|d[e+22>>0];b[m+12>>1]=(D&255)<<8&65535|d[e+26>>0];b[m+14>>1]=(E&255)<<8&65535|d[e+30>>0];Kic(e,G,H,~H,l,m)}m=e+96|0;Qdd(f,m,595992,1);l=e+84|0;e=c[l>>2]|0;if(e){c[n>>2]=c[153074];c[h+0>>2]=c[n+0>>2];eOb(e,h)}e=(c[m>>2]|0)+16|0;c[o>>2]=c[153074];c[h+0>>2]=c[o+0>>2];o=cOb(e,32,h,0,3653512,150)|0;c[l>>2]=o;Odd(f,c[m>>2]|0,o,0);if((c[x>>2]|0)<=-1){i=g;return}x=c[k>>2]|0;c[j>>2]=c[u>>2];c[h+0>>2]=c[j+0>>2];eOb(x,h);c[k>>2]=0;i=g;return}function Pic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+88|0;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){c[j>>2]=c[g>>2];c[h>>2]=k;n=k;o=m}else{Gid(h,g,4);n=c[h>>2]|0;o=c[l>>2]|0}g=a+92|0;m=n+4|0;if(m>>>0<o>>>0){c[n>>2]=c[g>>2];c[h>>2]=m}else Gid(h,g,4);c[f>>2]=60;c[e+0>>2]=c[f+0>>2];eOb(0,e);c[e>>2]=8;f=c[h>>2]|0;g=f+4|0;if(g>>>0<(c[l>>2]|0)>>>0){c[f>>2]=8;c[h>>2]=g}else Gid(h,e,4);e=a+32|0;h=a;do{fjc(h,b);h=h+4|0}while((h|0)!=(e|0));e=a+96|0;Udd(b,e,595992,1);Vdd(b,c[e>>2]|0,c[a+84>>2]|0,0);i=d;return}function Qic(a,b){a=a|0;b=b|0;var d=0;b=i;i=i+16|0;a=b+4|0;d=b;c[d>>2]=60;c[a+0>>2]=c[d+0>>2];eOb(0,a);i=b;return}function Ric(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;c[b+84>>2]=e;c[b+92>>2]=f;e=d[h>>0]|d[h+1>>0]<<8;i=da((e&65535)>>>8&65535,d[576080+(e&255)>>0]|0)|0;c[b+80>>2]=i;c[b+96>>2]=da(i,f)|0;f=1<<g&255;c[b+88>>2]=f;c[b+32>>2]=f;a[b+42>>0]=i;a[b+(g<<2)+2>>0]=e;a[b+(g<<2)+3>>0]=a[h+1>>0]|0;return}function Sic(a,b){a=a|0;b=b|0;c[a>>2]=c[b+32>>2];c[a+4>>2]=c[b+44>>2];c[a+8>>2]=c[b+56>>2];c[a+12>>2]=c[b+68>>2];return}function Tic(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+44|0;f=b+0|0;g=f+44|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(g|0));c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=b+56|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=b+68|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=b+80|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;i=d;return}function Uic(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+84|0;a=c[f>>2]|0;if(!a){c[f>>2]=0;i=b;return}c[e>>2]=c[153074];c[d+0>>2]=c[e+0>>2];eOb(a,d);c[f>>2]=0;i=b;return}function Vic(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+112|0;j=h+8|0;k=h+16|0;l=h+48|0;m=h+96|0;n=h+4|0;o=h;p=h+12|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];c[k+16>>2]=c[a+16>>2];c[k+20>>2]=c[a+20>>2];c[k+24>>2]=c[a+24>>2];c[k+28>>2]=c[a+28>>2];q=a+32|0;r=l+0|0;s=q+0|0;t=r+48|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));s=a+88|0;r=c[s>>2]|0;t=a+92|0;u=c[t>>2]|0;v=a+84|0;w=c[v>>2]|0;Kic(a,b,d,e,f,g);g=c[v>>2]|0;f=(g|0)!=0;if(!b){if(f){c[m>>2]=c[153074];c[j+0>>2]=c[m+0>>2];eOb(g,j)}c[v>>2]=0;i=h;return}a:do if(f){m=0;do{if((c[k+(m<<2)>>2]|0)!=(c[a+(m<<2)>>2]|0))break a;m=m+1|0}while((m|0)<8);m=0;do{if((c[l+(m<<2)>>2]|0)!=(c[q+(m<<2)>>2]|0))break a;m=m+1|0}while((m|0)<12);m=(c[a+96>>2]|0)+16|0;c[n>>2]=c[153074];c[j+0>>2]=c[n+0>>2];c[v>>2]=hOb(g,m,32,j,0,3653512,528)|0;i=h;return}while(0);g=(c[a+96>>2]|0)+16|0;c[o>>2]=c[153074];c[j+0>>2]=c[o+0>>2];o=cOb(g,32,j,0,3653512,532)|0;c[v>>2]=o;if(!w){i=h;return}v=c[t>>2]|0;gjc(v>>>0<u>>>0?v:u,c[s>>2]&r,l,k,w,q,a,o);c[p>>2]=c[153074];c[j+0>>2]=c[p+0>>2];eOb(w,j);i=h;return}function Wic(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;h=f+84|0;j=f+92|0;k=0;do{l=a[f+(k*12|0)+42>>0]|0;if(l<<24>>24!=0?(m=l&255,l=c[h>>2]|0,n=c[f+(k*12|0)+36>>2]|0,o=da(c[j>>2]|0,m)|0,p=l+(o+n)|0,q=c[f+(k*12|0)+32>>2]|0,(o|0)!=0):0){o=l+n|0;do{n=1;l=0;r=0;while(1){if(!(n&q))s=r;else{t=a[f+(l<<2)+3>>0]|0;u=t&255;v=a[f+(l<<2)+2>>0]|0;w=d[576080+(v&255)>>0]|0;do if((v&255)<2){x=o+r|0;if((w|0)==2){if(!(t<<24>>24))break;y=0;z=x;while(1){A=e[z>>1]|0;b[z>>1]=A<<8|A>>>8;y=y+1|0;if((y|0)==(u|0))break;else z=z+2|0}}else if((w|0)==4){if(!(t<<24>>24))break;z=0;y=x;while(1){c[y>>2]=XEi(c[y>>2]|0)|0;z=z+1|0;if((z|0)==(u|0))break;else y=y+4|0}}else break}while(0);s=(da(w,u)|0)+r|0}l=l+1|0;if((l|0)==8)break;else{n=n<<1;r=s}}o=o+m|0}while((o|0)!=(p|0))}k=k+1|0}while((k|0)!=4);i=g;return}function Xic(a){a=a|0;return d[576080+(a&255)>>0]|0|0}function Yic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=f;f=a+4|0;g=b+4|0;h=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=h;h=a+8|0;g=b+8|0;f=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=f;f=a+12|0;g=b+12|0;h=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=h;h=a+16|0;g=b+16|0;f=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=f;f=a+20|0;g=b+20|0;h=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=h;h=a+24|0;g=b+24|0;f=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=f;f=a+28|0;g=b+28|0;h=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=h;h=a+32|0;g=b+32|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];g=a+44|0;h=b+44|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];h=a+56|0;g=b+56|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];g=a+68|0;h=b+68|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];e=a+88|0;h=b+88|0;g=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=g;g=a+80|0;h=b+80|0;e=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=e;e=a+92|0;h=b+92|0;g=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=g;g=a+96|0;h=b+96|0;e=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=e;e=a+84|0;a=b+84|0;b=c[e>>2]|0;c[e>>2]=c[a>>2];c[a>>2]=b;i=d;return}function Zic(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;gjc(a,b,d+32|0,d,c[d+84>>2]|0,e+32|0,e,c[e+84>>2]|0);i=f;return}function _ic(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=(e|0)==0;h=0;j=0;while(1){if(!(1<<h&a))k=j;else{if(!g)c[e+(h<<2)>>2]=j;l=b+(h<<1)|0;m=d[l>>0]|d[l+1>>0]<<8;k=(da((m&65535)>>>8&65535,d[576080+(m&255)>>0]|0)|0)+j|0}h=h+1|0;if((h|0)==8){n=k;break}else j=k}i=f;return n|0}function $ic(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if(!b){g=0;i=f;return g|0}else{h=1;j=0;k=0}while(1){if(!(h&b))l=k;else{m=c+(j<<1)|0;a[e+(j<<2)>>0]=0;a[e+(j<<2)+1>>0]=k;a[e+(j<<2)+2>>0]=a[m>>0]|0;a[e+(j<<2)+3>>0]=a[c+(j<<1)+1>>0]|0;n=d[m>>0]|d[m+1>>0]<<8;l=(da((n&65535)>>>8&65535,d[576080+(n&255)>>0]|0)|0)+k|0}j=j+1|0;h=h<<1;if(!((j|0)<8&h>>>0<=b>>>0)){g=l;break}else k=l}i=f;return g|0}function ajc(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=e|b;if(!j){k=0;i=h;return k|0}else{l=1;m=0;n=0}while(1){if(!(l&j))o=n;else{e=(l&b|0)!=0?c:f;p=e+(m<<1)|0;a[g+(m<<2)>>0]=0;a[g+(m<<2)+1>>0]=n;a[g+(m<<2)+2>>0]=a[p>>0]|0;a[g+(m<<2)+3>>0]=a[e+(m<<1)+1>>0]|0;e=d[p>>0]|d[p+1>>0]<<8;o=(da((e&65535)>>>8&65535,d[576080+(e&255)>>0]|0)|0)+n|0}m=m+1|0;l=l<<1;if(!((m|0)<8&l>>>0<=j>>>0)){k=o;break}else n=o}i=h;return k|0}function bjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142302]|0;add(b,2908912,e,a,1);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,3144200,e,a+1|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,3144048,e,a+2|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,2684376,e,a+3|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);i=d;return}function cjc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];hjc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<2)|0;do if(c[f>>2]|0){j=qdd(a,3142592,2923672,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;ijc(r,a);t=r+4|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,2923672,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else ijc(m,a);sdd(a)}m=m+4|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function djc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];hjc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<2)|0;if(!k){i=d;return}else u=s;do{jjc(u,a);u=u+4|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<2;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>2;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function ejc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];hjc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<2)|0;if(!k){i=d;return}else u=t;do{kjc(u,a);u=u+4|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<2;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>2;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function fjc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d+12|0;g=c[f>>2]|0;h=d+20|0;if((g+1|0)>>>0<(c[h>>2]|0)>>>0){a[g>>0]=a[b>>0]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;j=g}else{Gid(f,b,1);j=c[f>>2]|0}g=b+1|0;if((j+1|0)>>>0<(c[h>>2]|0)>>>0){a[j>>0]=a[g>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}else{Gid(f,g,1);k=c[f>>2]|0}g=b+2|0;if((k+1|0)>>>0<(c[h>>2]|0)>>>0){a[k>>0]=a[g>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}else{Gid(f,g,1);l=c[f>>2]|0}g=b+3|0;if((l+1|0)>>>0<(c[h>>2]|0)>>>0){a[l>>0]=a[g>>0]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}else{Gid(f,g,1);i=e;return}}function gjc(b,f,h,j,l,m,n,o){b=b|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=Im,W=0,X=0,Y=Im,Z=0,_=Im;p=i;if(!f){i=p;return}else{q=1;r=0}do{a:do if(q&f){s=d[j+(r<<2)>>0]|0;t=(d[j+(r<<2)+1>>0]|0)+(c[h+(s*12|0)+4>>2]|0)|0;u=l+t|0;v=d[n+(r<<2)>>0]|0;w=(d[n+(r<<2)+1>>0]|0)+(c[m+(v*12|0)+4>>2]|0)|0;x=o+w|0;y=a[h+(s*12|0)+10>>0]|0;s=a[m+(v*12|0)+10>>0]|0;v=a[j+(r<<2)+2>>0]|0;z=a[n+(r<<2)+2>>0]|0;A=a[j+(r<<2)+3>>0]|0;if(v<<24>>24==z<<24>>24){B=a[576080+(v&255)>>0]|0;C=da(B&255,A&255)|0;D=da(B&255,d[n+(r<<2)+3>>0]|0)|0;B=D>>>0<C>>>0?D:C;if((D|0)!=(B|0)){C=D-B|0;E=y&255;F=da(E,b)|0;G=l+(F+t)|0;if(!F)break;F=s&255;H=x;I=u;while(1){YEi(H|0,I|0,B|0)|0;PEi(H+B|0,0,C|0)|0;I=I+E|0;if((I|0)==(G|0))break a;else H=H+F|0}}F=y&255;H=da(F,b)|0;G=l+(H+t)|0;if((D|0)==12){if(!H)break;I=s&255;E=u;C=x;while(1){c[C>>2]=c[E>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];E=E+F|0;if((E|0)==(G|0))break a;else C=C+I|0}}else if((D|0)==8){if(!H)break;I=s&255;C=u;E=x;while(1){c[E>>2]=c[C>>2];c[E+4>>2]=c[C+4>>2];C=C+F|0;if((C|0)==(G|0))break a;else E=E+I|0}}else if((D|0)==4){if(!H)break;I=s&255;E=x;C=u;while(1){c[E>>2]=c[C>>2];C=C+F|0;if((C|0)==(G|0))break a;else E=E+I|0}}else{if(!H)break;I=s&255;E=u;C=x;while(1){YEi(C|0,E|0,D|0)|0;E=E+F|0;if((E|0)==(G|0))break a;else C=C+I|0}}}I=a[n+(r<<2)+3>>0]|0;C=(I&255)<(A&255)?I:A;G=y&255;E=da(G,b)|0;F=l+(E+t)|0;D=z<<24>>24==0;if(v<<24>>24==1&D){if(!E)break;H=s&255;if(!(C<<24>>24)){B=((I+-1<<24>>24&255)<<2)+4|0;J=I<<24>>24==0;K=u;L=0;while(1){if(!J)PEi(o+((da(L,H)|0)+w)|0,0,B|0)|0;K=K+G|0;if((K|0)==(F|0))break a;else L=L+1|0}}L=~I;K=~A;B=(-2-((L&255)>(K&255)?L:K)<<24>>24&255)+1|0;K=B&255;L=(K&255)<(I&255);J=(B<<2&1020)+w|0;B=(((I+-1<<24>>24)-K<<24>>24&255)<<2)+4|0;K=~A;t=~I;y=~((K&255)>(t&255)?K:t);t=x;K=u;M=0;while(1){N=0;do{O=t+(N<<2)|0;P=e[K+(N<<1)>>1]|0;Q=P&32767;c[O>>2]=Q;do if(Q){R=Q<<13;c[O>>2]=R;S=R&260046848;if((S|0)==260046848){T=R|1879048192;c[O>>2]=T;U=T;break}else if(!S){V=ea((c[k>>2]=R+947912704,ea(g[k>>2]))+ea(-.0000610351563));g[O>>2]=V;U=(g[k>>2]=V,c[k>>2]|0);break}else{S=R+939524096|0;c[O>>2]=S;U=S;break}}else U=0;while(0);c[O>>2]=U|P<<16&-2147483648;N=N+1|0}while((N&255)<<24>>24!=y<<24>>24);if(L)PEi(o+(J+(da(M,H)|0))|0,0,B|0)|0;K=K+G|0;if((K|0)==(F|0))break a;else{t=t+H|0;M=M+1|0}}}if(v<<24>>24==2&D){if(!E)break;M=s&255;if(!(C<<24>>24)){H=((I+-1<<24>>24&255)<<2)+4|0;t=I<<24>>24==0;K=u;B=0;while(1){if(!t)PEi(o+((da(B,M)|0)+w)|0,0,H|0)|0;K=K+G|0;if((K|0)==(F|0))break a;else B=B+1|0}}B=~I;K=~A;H=(-2-((B&255)>(K&255)?B:K)<<24>>24&255)+1|0;K=H&255;B=(H<<2&1020)+w|0;H=(((I+-1<<24>>24)-K<<24>>24&255)<<2)+4|0;t=~A;J=~I;L=~((t&255)>(J&255)?t:J);if((K&255)<(I&255)){K=x;J=u;t=0;while(1){y=0;do{g[K+(y<<2)>>2]=ea(ea(d[J+y>>0]|0)/ea(255.0));y=y+1|0}while((y&255)<<24>>24!=L<<24>>24);PEi(o+(B+(da(t,M)|0))|0,0,H|0)|0;J=J+G|0;if((J|0)==(F|0))break a;else{K=K+M|0;t=t+1|0}}}else{t=x;K=u;while(1){J=0;do{g[t+(J<<2)>>2]=ea(ea(d[K+J>>0]|0)/ea(255.0));J=J+1|0}while((J&255)<<24>>24!=L<<24>>24);K=K+G|0;if((K|0)==(F|0))break a;else t=t+M|0}}}if(v<<24>>24==3&D){if(!E)break;M=C<<24>>24==0;t=s&255;K=~I;L=~A;J=I+-1<<24>>24;H=(-2-((K&255)>(L&255)?K:L)<<24>>24&255)+1&255;L=~A;K=~I;B=~((L&255)>(K&255)?L:K);K=x;L=u;y=0;while(1){N=da(y,t)|0;if(M)W=0;else{Q=0;do{g[K+(Q<<2)>>2]=ea(ea(a[L+Q>>0]|0)*ea(.00787401571));Q=Q+1|0}while((Q&255)<<24>>24!=B<<24>>24);W=H}if((W&255)<(I&255))PEi(o+(N+w+((W&255)<<2))|0,0,((J-W<<24>>24&255)<<2)+4|0)|0;L=L+G|0;if((L|0)==(F|0))break a;else{K=K+t|0;y=y+1|0}}}y=v<<24>>24==0;if(y&z<<24>>24==2){if(!E)break;t=C<<24>>24==0;K=s&255;L=~I;J=~A;H=I+-1<<24>>24;B=(-2-((L&255)>(J&255)?L:J)<<24>>24&255)+1&255;J=~A;L=~I;M=~((J&255)>(L&255)?J:L);L=x;J=u;D=0;while(1){Q=da(D,K)|0;if(t)X=0;else{S=0;do{V=ea(g[J+(S<<2)>>2]);R=V<ea(0.0);Y=R?ea(0.0):V;R=Y>ea(1.0);T=~~ea(ea(Y*ea(255.0))+ea(.5))>>>0&255;a[L+S>>0]=R?-1:T;S=S+1|0}while((S&255)<<24>>24!=M<<24>>24);X=B}if((X&255)<(I&255))PEi(o+(Q+w+(X&255))|0,0,(H-X<<24>>24&255)+1|0)|0;J=J+G|0;if((J|0)==(F|0))break a;else{L=L+K|0;D=D+1|0}}}if(!(y&z<<24>>24==3)){Krd(576088,0,3653512,347,1,0,0,0);break}if(E){D=C<<24>>24==0;K=s&255;L=~I;J=~A;H=I+-1<<24>>24;B=(-2-((L&255)>(J&255)?L:J)<<24>>24&255)+1&255;J=~A;L=~I;M=~((J&255)>(L&255)?J:L);L=x;J=u;t=0;while(1){v=da(t,K)|0;if(D)Z=0;else{S=0;do{Y=ea(g[J+(S<<2)>>2]);N=Y<ea(-1.0);V=N?ea(-1.0):Y;N=V>ea(1.0);Y=ea(ea(V*ea(127.0))+ea(.5));V=N?ea(127.5):Y;if(!(V>=ea(0.0)))_=ea(V+ea(-.99999994));else _=V;a[L+S>>0]=~~_;S=S+1|0}while((S&255)<<24>>24!=M<<24>>24);Z=B}if((Z&255)<(I&255))PEi(o+(v+w+(Z&255))|0,0,(H-Z<<24>>24&255)+1|0)|0;J=J+G|0;if((J|0)==(F|0))break;else{L=L+K|0;t=t+1|0}}}}while(0);r=r+1|0;q=q<<1}while((r|0)<8&q>>>0<=f>>>0);i=p;return}function hjc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<2,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<2,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<2|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<2)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<2)|0;do{if(f)c[f>>2]=0;f=f+4|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function ijc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[142302]|0;h=qdd(d,2908912,g,f,0)|0;if(h){do if((h|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](b,d)|0}else{j=d+12|0;k=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(k+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[b>>0]=a[m>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,b,1)}while(0);sdd(d)}h=b+1|0;j=qdd(d,3144200,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+k|0;c[m>>2]=n;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+2|0;j=qdd(d,3144048,g,f,0)|0;if(j){do if((j|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+k|0;c[m>>2]=l;if((k|0)>=0?(n+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+3|0;b=qdd(d,2684376,g,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){g=c[f>>2]|0;if(g)_n[g&4095](h,d)|0}else{g=d+12|0;j=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+m|0;c[g>>2]=l;if((m|0)>=0?(j+(m+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[g>>2]=(c[g>>2]|0)+1;break}Bid(g,h,1)}while(0);sdd(d);i=e;return}function jjc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d+12|0;g=c[f>>2]|0;h=d+20|0;if((g+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,b,1);j=c[f>>2]|0}else{a[b>>0]=a[g>>0]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;j=g}g=b+1|0;if((j+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,g,1);k=c[f>>2]|0}else{a[g>>0]=a[j>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}j=b+2|0;if((k+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,j,1);l=c[f>>2]|0}else{a[j>>0]=a[k>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}k=b+3|0;if((l+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,k,1);i=e;return}else{a[k>>0]=a[l>>0]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}}function kjc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d+12|0;g=c[f>>2]|0;h=d+20|0;if((g+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,b,1);j=c[f>>2]|0}else{a[b>>0]=a[g>>0]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;j=g}g=b+1|0;if((j+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,g,1);k=c[f>>2]|0}else{a[g>>0]=a[j>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}j=b+2|0;if((k+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,j,1);l=c[f>>2]|0}else{a[j>>0]=a[k>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}k=b+3|0;if((l+1|0)>>>0>(c[h>>2]|0)>>>0){Bid(f,k,1);i=e;return}else{a[k>>0]=a[l>>0]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}}function ljc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[($hd(b+16|0)|0)+20>>2]|2097152;f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+20>>2]=e;e=c[142268]|0;add(b,3143216,e,a,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2416480,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2419736,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function mjc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;d=a+12|0;f=c[d>>2]|0;h=f+4|0;j=a+20|0;a=c[j>>2]|0;if(h>>>0<a>>>0){g[f>>2]=ea(g[b>>2]);c[d>>2]=h;k=h;l=a}else{Gid(d,b,4);k=c[d>>2]|0;l=c[j>>2]|0}a=b+4|0;h=k+4|0;if(h>>>0<l>>>0){g[k>>2]=ea(g[a>>2]);c[d>>2]=h;m=h;n=l}else{Gid(d,a,4);m=c[d>>2]|0;n=c[j>>2]|0}a=b+8|0;l=m+4|0;if(l>>>0<n>>>0){g[m>>2]=ea(g[a>>2]);c[d>>2]=l;o=l;p=n}else{Gid(d,a,4);o=c[d>>2]|0;p=c[j>>2]|0}j=b+12|0;b=o+4|0;if(b>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[d>>2]=b;i=e;return}else{Gid(d,j,4);i=e;return}}function njc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+72>>2]|0)>-1){f=a+60|0;g=c[f>>2]|0;c[e>>2]=c[a+64>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+56>>2]|0)>-1){f=a+44|0;g=c[f>>2]|0;c[e>>2]=c[a+48>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+40>>2]|0)>-1){f=a+28|0;g=c[f>>2]|0;c[e>>2]=c[a+32>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+24>>2]|0)<=-1){i=b;return}f=a+12|0;g=c[f>>2]|0;c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function ojc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;a=w+4|0;if(a>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=XEi(z|0)|0;c[y>>2]=A;i=d;return}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=a;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=XEi(z|0)|0;c[y>>2]=A;i=d;return}}function pjc(){return c[144346]|0}function qjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;c[b+4>>2]=0;c[b+8>>2]=0;c[b>>2]=b+4;c[b+16>>2]=0;c[b+20>>2]=0;c[b+12>>2]=b+16;c[b+28>>2]=0;c[b+32>>2]=0;e=c[153134]|0;c[b+36>>2]=0;c[b+40>>2]=e;e=b+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;e=c[153116]|0;c[b+60>>2]=0;c[b+64>>2]=e;c[b+68>>2]=0;c[b+72>>2]=0;c[b+76>>2]=0;c[b+80>>2]=e;c[b+84>>2]=0;c[b+88>>2]=0;c[b+92>>2]=c[155410];e=kbc()|0;f=0;while(1){g=e+(f<<2)+960|0;f=f+1|0;if(!(c[g>>2]|0)){h=g;break}if((f|0)>=16){j=5;break}}if((j|0)==5){k=b+24|0;a[k>>0]=0;i=d;return}c[h>>2]=3509;k=b+24|0;a[k>>0]=0;i=d;return}function rjc(a){a=a|0;var b=0,d=0;b=i;d=(c[a+412>>2]|0)==-2147483648;if(!(d|(T$b(a)|0))){Ejc(c[144346]|0,0);Fjc(c[144346]|0)}d=c[144346]|0;c[d+68>>2]=0;c[d+84>>2]=0;c[d+92>>2]=c[155410];Ljc(d+60|0,a);xld((c[144346]|0)+60|0);i=b;return}function sjc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;Mjc((kbc()|0)+960|0,3509);f=a+60|0;if((c[a+88>>2]|0)>-1){g=a+76|0;h=c[g>>2]|0;c[e>>2]=c[a+80>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}if((c[a+72>>2]|0)>-1){g=c[f>>2]|0;c[e>>2]=c[a+64>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+48>>2]|0)>-1){f=a+36|0;g=c[f>>2]|0;c[e>>2]=c[a+40>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}Jjc(a+12|0,c[a+16>>2]|0);Kjc(a,c[a+4>>2]|0);i=b;return}function tjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+320|0;e=d+312|0;f=d+208|0;g=d+104|0;h=d;j=c[b>>2]|0;if(!j){i=d;return};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;b=c[153116]|0;k=h+16|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[h+32>>2]=b;c[h+36>>2]=0;c[h+40>>2]=0;c[h+44>>2]=0;c[h+48>>2]=b;c[h+52>>2]=0;c[h+56>>2]=0;c[h+60>>2]=0;c[h+64>>2]=b;c[h+68>>2]=0;c[h+72>>2]=0;c[h+76>>2]=0;c[h+80>>2]=b;b=h+84|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[g>>2]=j;j=g+4|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];b=g+20|0;k=h+16|0;Njc(b,k);c[g+100>>2]=0;h=c[g>>2]|0;c[f>>2]=h;g=f+4|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];j=f+20|0;Njc(j,b);c[f+100>>2]=0;c[f>>2]=h;Ojc(e,a,f);f=c[e>>2]|0;njc(j);njc(b);njc(k);k=f+20|0;c[k>>2]=(c[k>>2]|0)+1;ujc(a,f+16|0)|0;i=d;return}function ujc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+48|0;f=e;g=e+28|0;h=e+32|0;j=e+36|0;k=e+12|0;l=e+8|0;m=e+24|0;n=d+16|0;if(c[n>>2]|0){o=1;i=e;return o|0}c[g>>2]=c[d>>2];p=c[137784]|0;if(!p){o=0;i=e;return o|0}do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,g);q=c[f>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;q=p+28|0;r=p+32|0;t=(c[q>>2]|0)+(c[r>>2]<<3)|0;if((s|0)==(t|0)){o=0;i=e;return o|0}u=c[s+4>>2]|0;if(!u){o=0;i=e;return o|0}s=(da(c[137788]|0,(c[u+8>>2]|0)>>>21)|0)+226|0;v=s>>5;if(!(1<<s-(v<<5)&c[(c[137786]|0)+(v<<2)>>2])){o=0;i=e;return o|0}v=u+28|0;s=v+76|0;w=c[s>>2]|0;if(!w){o=0;i=e;return o|0}c[j>>2]=w;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,j);w=c[f>>2]|0;x=c[q>>2]|0;if((w|0)==-1){y=x+(c[r>>2]<<3)|0;break}else{y=x+(w<<3)|0;break}}else y=t;while(0);t=c[137784]|0;if(!((y|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(c[y+4>>2]|0)!=0:0))z=19}else z=19;if((z|0)==19?(hQb(c[s>>2]|0)|0)==0:0){o=0;i=e;return o|0}y=v+20|0;t=c[y>>2]|0;if(!t){o=0;i=e;return o|0}if(t>>>0>32){c[f>>2]=mo[c[(c[u>>2]|0)+32>>2]&4095](u)|0;c[f+4>>2]=32;Lsd(k,577416,f);if(!(a[k>>0]&1))A=k+1|0;else A=c[k+8>>2]|0;Krd(A,0,3653512,516,1,0,0,0);xri(k);o=0;i=e;return o|0}k=c[s>>2]|0;if(!k)B=0;else{c[h>>2]=k;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(f,k,h);A=c[f>>2]|0;u=c[k+28>>2]|0;if((A|0)==-1){C=u+(c[k+32>>2]<<3)|0;break}else{C=u+(A<<3)|0;break}}else C=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((C|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[C+4>>2]|0,(k|0)!=0):0)D=k;else z=35}else z=35;if((z|0)==35)D=hQb(c[s>>2]|0)|0;B=D}D=Pjc(B)|0;c[l>>2]=0;B=b+12|0;s=c[B>>2]|0;k=b+16|0;a:do if((s|0)!=(k|0)){b=s;while(1){C=c[b+16>>2]|0;if((c[C>>2]|0)==(D|0)){h=c[C+28>>2]|0;if(!h){E=0;F=0}else{A=c[C+20>>2]|0;u=0;r=0;q=0;while(1){j=c[A+(r<<2)>>2]|0;if(!j){G=u;H=q}else{G=u+1|0;H=(c[j+40>>2]|0)+q|0}r=r+1|0;if(r>>>0>=h>>>0){E=G;F=H;break}else{u=G;q=H}}}if(!(E>>>0>3|(F+t|0)>>>0>32)){I=C;break}}q=c[b+4>>2]|0;if(!q){u=b;while(1){h=c[u+8>>2]|0;if((c[h>>2]|0)==(u|0)){J=h;break}else u=h}}else{u=q;while(1){C=c[u>>2]|0;if(!C){J=u;break}else u=C}}if((J|0)==(k|0)){z=51;break a}else b=J}c[l>>2]=I;if(I)K=I;else z=51}else z=51;while(0);if((z|0)==51){c[m>>2]=c[153116];c[f+0>>2]=c[m+0>>2];m=bOb(36,f,0,16,3653512,553)|0;c[m+4>>2]=0;a[m+8>>0]=1;c[m+12>>2]=0;a[m+16>>0]=1;I=c[153116]|0;c[m+20>>2]=0;c[m+24>>2]=I;c[m+28>>2]=0;c[m+32>>2]=0;c[l>>2]=m;c[m>>2]=D;Qjc(f,B,l);K=m}a[K+8>>0]=1;a[K+16>>0]=1;m=K+28|0;B=c[m>>2]|0;b:do if(B){D=c[K+20>>2]|0;I=0;while(1){if(!(c[D+(I<<2)>>2]|0)){L=I;break}I=I+1|0;if(I>>>0>=B>>>0){M=B;N=B;z=58;break b}}if(L>>>0<B>>>0){c[(c[K+20>>2]|0)+(L<<2)>>2]=d;O=K;P=L}else{M=B;N=L;z=58}}else{M=0;N=0;z=58}while(0);if((z|0)==58){z=M+1|0;c[m>>2]=z;M=K+32|0;L=c[M>>2]|0;B=L&2147483647;if(z>>>0>B>>>0){I=L<<1;D=(I|0)==0?1:I;do if(B>>>0<D>>>0)if((L|0)>-1){c[M>>2]=D;I=K+20|0;J=c[I>>2]|0;c[g>>2]=c[K+24>>2];c[f+0>>2]=c[g+0>>2];c[I>>2]=hOb(J,D<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[K+24>>2];c[f+0>>2]=c[g+0>>2];J=cOb(D<<2,4,f,0,3653512,352)|0;I=K+20|0;YEi(J|0,c[I>>2]|0,c[m>>2]<<2|0)|0;c[M>>2]=D;c[I>>2]=J;break}while(0);Q=c[l>>2]|0;R=c[m>>2]|0}else{Q=K;R=z}c[(c[K+20>>2]|0)+(R+-1<<2)>>2]=d;O=Q;P=N}c[n>>2]=O;Rjc(d+20|0,v)|0;O=Ard(Ard(Ard(yrd()|0,v,4)|0,v+8|0,4)|0,v+4|0,4)|0;n=Ard(O,c[v+12>>2]|0,c[y>>2]<<4)|0;c[d+8>>2]=zrd(Ard(n,c[v+28>>2]|0,c[v+36>>2]|0)|0)|0;n=yrd()|0;y=Ard(n,c[v+44>>2]|0,c[v+52>>2]<<3)|0;c[d+12>>2]=zrd(Ard(y,c[v+60>>2]|0,c[v+68>>2]<<1)|0)|0;c[d+100>>2]=Gjc(0,v,P)|0;o=1;i=e;return o|0}function vjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;b=a+4|0;h=c[b>>2]|0;j=a+4|0;if(!h){i=d;return}else{k=j;l=h}a:while(1){h=l;while(1){if((c[h+16>>2]|0)>=(g|0)){m=h;break}h=c[h+4>>2]|0;if(!h){n=k;break a}}l=c[m>>2]|0;if(!l){n=m;break}else k=m}if((n|0)==(j|0)){i=d;return}if((g|0)<(c[n+16>>2]|0)){i=d;return}g=n+20|0;j=(c[g>>2]|0)+-1|0;c[g>>2]=j;if(j){i=d;return}wjc(a,n+16|0);j=c[n+4>>2]|0;if(!j){g=n;while(1){m=c[g+8>>2]|0;if((c[m>>2]|0)==(g|0)){o=m;break}else g=m}}else{g=j;while(1){j=c[g>>2]|0;if(!j){o=g;break}else g=j}}if((c[a>>2]|0)==(n|0))c[a>>2]=o;o=a+8|0;c[o>>2]=(c[o>>2]|0)+-1;tYb(c[b>>2]|0,n);njc(n+36|0);c[f>>2]=54;c[e+0>>2]=c[f+0>>2];eOb(n,e);i=d;return}function wjc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;k=d+16|0;l=c[k>>2]|0;c[j>>2]=l;if(!l){i=e;return}m=c[l+28>>2]|0;if(m){n=1;o=0;while(1){p=(c[l+20>>2]|0)+(o<<2)|0;q=c[p>>2]|0;if((q|0)==(d|0)){c[p>>2]=0;r=n}else r=(q|0)==0&n;o=o+1|0;if(o>>>0>=m>>>0)break;else n=r}if(!r){a[l+8>>0]=1;a[l+16>>0]=1}else s=8}else s=8;if((s|0)==8){kQb(c[l+4>>2]|0);kQb(c[l+12>>2]|0);Sjc(b+12|0,j)|0;b=c[153116]|0;if((c[l+32>>2]|0)>-1){s=l+20|0;r=c[s>>2]|0;c[g>>2]=c[l+24>>2];c[f+0>>2]=c[g+0>>2];eOb(r,f);c[s>>2]=0}c[h>>2]=b;c[f+0>>2]=c[h+0>>2];eOb(l,f);c[j>>2]=0}j=d+100|0;kQb(c[j>>2]|0);c[k>>2]=0;c[j>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=e;return}function xjc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[d>>2]|0;d=c[b+4>>2]|0;g=b+4|0;if(!d){h=0;i=e;return h|0}else{j=g;k=d}a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(f|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=j;break a}}k=c[l>>2]|0;if(!k){m=l;break}else j=l}if((m|0)==(g|0)){h=0;i=e;return h|0}if((f|0)<(c[m+16>>2]|0)){h=0;i=e;return h|0}f=m+32|0;m=c[f>>2]|0;if(!m){h=0;i=e;return h|0}if(!(a[m+8>>0]|0))n=m;else{yjc(0,m,m+4|0);n=c[f>>2]|0}a[n+8>>0]=0;h=c[n+4>>2]|0;i=e;return h|0}function yjc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;b=i;i=i+64|0;f=b+48|0;g=b+44|0;h=b+40|0;j=b+4|0;k=b;if(!(c[e>>2]|0)){c[h>>2]=c[153106];c[f+0>>2]=c[h+0>>2];h=Tjc(4,f)|0;c[e>>2]=h;In[c[(c[h>>2]|0)+44>>2]&4095](h,61);h=c[e>>2]|0;In[c[(c[h>>2]|0)+36>>2]&4095](h,577472)}h=d+20|0;l=d+28|0;d=c[l>>2]|0;m=c[h>>2]|0;n=0;o=0;while(1){p=c[m+(n<<2)>>2]|0;q=(p|0)==0?o:p+4|0;n=n+1|0;if(n>>>0>=d>>>0){r=q;break}else o=q}o=r+92|0;r=c[o>>2]|0;do if(!r)s=c[e>>2]|0;else{c[g>>2]=r;d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(f,d,g);n=c[f>>2]|0;m=c[d+28>>2]|0;if((n|0)==-1){t=m+(c[d+32>>2]<<3)|0;break}else{t=m+(n<<3)|0;break}}else t=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((t|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[t+4>>2]|0,(d|0)!=0):0){u=d;v=c[e>>2]|0}else w=16}else w=16;if((w|0)==16){d=hQb(c[o>>2]|0)|0;n=c[e>>2]|0;if(!d){s=n;break}else{u=d;v=n}}n=v+72|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;c[j>>2]=j+4;d=j+16|0;c[d>>2]=0;c[j+20>>2]=0;c[j+12>>2]=j+16;m=j+28|0;c[m>>2]=0;c[j+32>>2]=0;c[j+24>>2]=j+28;Ujc(n,j)|0;Vjc(j+24|0,c[m>>2]|0);Wjc(j+12|0,c[d>>2]|0);Xjc(j,c[j+4>>2]|0);xnd(n,u+72|0);d=v+100|0;m=c[d>>2]|0;do if(m){q=c[144340]|0;p=m;while(1){x=c[p+16>>2]|0;if((q|0)<(x|0)){y=c[p>>2]|0;if(!y){z=p;A=p;w=22;break}else{p=y;continue}}if((x|0)>=(q|0)){B=p;w=26;break}x=p+4|0;y=c[x>>2]|0;if(!y){C=x;D=p;w=25;break}else p=y}if((w|0)==22){c[f>>2]=A;E=z;F=A;break}else if((w|0)==25){c[f>>2]=D;E=C;F=D;break}else if((w|0)==26){c[f>>2]=B;E=f;F=B;break}}else{p=v+100|0;c[f>>2]=p;E=p;F=p}while(0);m=c[E>>2]|0;if(!m){p=xCi(36)|0;c[p+16>>2]=c[144340];c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=F;c[E>>2]=p;q=v+96|0;y=c[c[q>>2]>>2]|0;if(!y)G=p;else{c[q>>2]=y;G=c[E>>2]|0}GN(c[d>>2]|0,G);y=v+104|0;c[y>>2]=(c[y>>2]|0)+1;H=p}else H=m;m=H+20|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[k>>2]=0;m=c[l>>2]|0;if(m){p=m;m=0;while(1){y=c[(c[h>>2]|0)+(m<<2)>>2]|0;if(!y)I=p;else{Yjc(n,y+20|0,m,k);I=c[l>>2]|0}m=m+1|0;if(m>>>0>=I>>>0)break;else p=I}}p=c[e>>2]|0;akd(p,hkd(u)|0);Akd(c[e>>2]|0,u+108|0);p=pyc()|0;m=c[e>>2]|0;if(!(a[(c[p+24>>2]|0)+((c[p+40>>2]|0)*96|0)+75>>0]|0))zkd(m,577312);else ykd(m,577312);Pjd(c[e>>2]|0);i=b;return}while(0);akd(s,0);i=b;return}function zjc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[d>>2]|0;d=c[b+4>>2]|0;g=b+4|0;if(!d){h=0;i=e;return h|0}else{j=g;k=d}a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(f|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=j;break a}}k=c[l>>2]|0;if(!k){m=l;break}else j=l}if((m|0)==(g|0)){h=0;i=e;return h|0}if((f|0)<(c[m+16>>2]|0)){h=0;i=e;return h|0}f=m+32|0;m=c[f>>2]|0;if(!m){h=0;i=e;return h|0}if(!(a[m+16>>0]|0))n=m;else{yjc(0,m,m+12|0);n=c[f>>2]|0}a[n+16>>0]=0;h=c[n+12>>2]|0;i=e;return h|0}function Ajc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b>>2]|0;b=c[a+4>>2]|0;f=a+4|0;if(!b){g=0;i=d;return g|0}else{h=f;j=b}a:while(1){b=j;while(1){if((c[b+16>>2]|0)>=(e|0)){k=b;break}b=c[b+4>>2]|0;if(!b){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)==(f|0)){g=0;i=d;return g|0}if((e|0)<(c[l+16>>2]|0)){g=0;i=d;return g|0}g=c[l+116>>2]|0;i=d;return g|0}function Bjc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+12>>2]|0;j=a+16|0;if((h|0)==(j|0)){k=0;i=e;return k|0}else l=h;while(1){h=c[l+16>>2]|0;if((c[h+4>>2]|0)==(b|0)){m=h;n=9;break}if((c[h+12>>2]|0)==(b|0)){o=h;break}h=c[l+4>>2]|0;if(!h){p=l;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){r=q;break}else p=q}}else{p=h;while(1){q=c[p>>2]|0;if(!q){r=p;break}else p=q}}if((r|0)==(j|0)){k=0;n=13;break}else l=r}if((n|0)==13){i=e;return k|0}if((n|0)==9)if(!m){k=0;i=e;return k|0}else o=m;c[a+28>>2]=o;c[a+32>>2]=d;if((c[a+48>>2]|0)>-1){d=a+36|0;o=c[d>>2]|0;c[g>>2]=c[a+40>>2];c[f+0>>2]=c[g+0>>2];eOb(o,f);c[d>>2]=0}d=a+44|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;k=1;i=e;return k|0}function Cjc(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);h=ea(h);j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im;k=i;l=a+28|0;m=c[l>>2]|0;n=c[m+28>>2]|0;a:do if(!n)o=255;else{p=c[b>>2]|0;q=c[m+20>>2]|0;r=0;while(1){s=c[q+(r<<2)>>2]|0;if((s|0)!=0?(c[s>>2]|0)==(p|0):0){o=r;break a}r=r+1|0;if(r>>>0>=n>>>0){o=255;break}}}while(0);t=ea(g[d>>2]);n=a+36|0;g[(Zjc(n)|0)>>2]=t;t=ea(g[d+4>>2]);g[(Zjc(n)|0)>>2]=t;t=ea(g[d+8>>2]);g[(Zjc(n)|0)>>2]=t;c[(Zjc(n)|0)>>2]=o<<24;g[(Zjc(n)|0)>>2]=e;g[(Zjc(n)|0)>>2]=f;g[(Zjc(n)|0)>>2]=h;g[(Zjc(n)|0)>>2]=j;n=c[(c[(c[l>>2]|0)+20>>2]|0)+(o<<2)>>2]|0;o=a+52|0;c[o>>2]=(c[o>>2]|0)+(c[n+72>>2]|0);o=a+56|0;c[o>>2]=(c[o>>2]|0)+(c[n+88>>2]|0);i=k;return}function Djc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+64|0;e=d+24|0;f=d+16|0;g=d;h=ync()|0;j=b+28|0;k=c[j>>2]|0;l=c[k+28>>2]|0;if(l){m=0;do{n=c[(c[k+20>>2]|0)+(m<<2)>>2]|0;if((n|0)!=0?(c[n+4>>2]|0)>0:0)c[g+(m<<2)>>2]=n+20;m=m+1|0}while(m>>>0<l>>>0)}l=b+32|0;m=c[(c[l>>2]|0)+4>>2]|0;k=c[144350]|0;if(!k){n=c[144376]|0;if(!n){if(!(a[577528]|0)){o=577512;p=575992;q=o+16|0;do{a[o>>0]=a[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));a[577528]=1}a[577521]=4;c[144376]=577512;r=577512}else r=n;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;c[144352]=$ic(29,r,e)|0;r=sic(uic()|0,e)|0;c[144350]=r;s=r}else s=k;k=qic(s,m,0)|0;Nn[c[(c[h>>2]|0)+328>>2]&31](h,c[l>>2]|0,29,c[144352]|0,k,c[b+52>>2]|0,c[b+56>>2]|0,0);k=b+36|0;m=b+44|0;En[c[(c[h>>2]|0)+340>>2]&127](h,g,4,c[k>>2]|0,c[m>>2]|0);In[c[(c[h>>2]|0)+336>>2]&4095](h,0);c[j>>2]=0;c[l>>2]=0;if((c[b+48>>2]|0)<=-1){c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;i=d;return}l=c[k>>2]|0;c[f>>2]=c[b+40>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[k>>2]=0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;i=d;return}function Ejc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;g=a+4|0;if((f|0)==(g|0)){i=b;return}h=a+8|0;j=a+4|0;k=f;while(1){a:do if(!(c[k+20>>2]|0)){wjc(a,k+16|0);f=c[k+4>>2]|0;l=(f|0)==0;if(l){m=k;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){o=n;break}else m=n}}else{m=f;while(1){n=c[m>>2]|0;if(!n){o=m;break}else m=n}}if(l){m=k;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){p=n;break}else m=n}}else{m=f;while(1){l=c[m>>2]|0;if(!l){p=m;break}else m=l}}if((c[a>>2]|0)==(k|0))c[a>>2]=p;c[h>>2]=(c[h>>2]|0)+-1;tYb(c[j>>2]|0,k);njc(k+36|0);c[e>>2]=54;c[d+0>>2]=c[e+0>>2];eOb(k,d);q=o}else{m=c[k+4>>2]|0;if(m){f=m;while(1){m=c[f>>2]|0;if(!m){q=f;break a}else f=m}}f=k;while(1){m=c[f+8>>2]|0;if((c[m>>2]|0)==(f|0)){q=m;break}else f=m}}while(0);if((q|0)==(g|0))break;else k=q}i=b;return}function Fjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=pyc()|0;j=a[(c[h+24>>2]|0)+((c[h+40>>2]|0)*96|0)+75>>0]|0;h=c[b>>2]|0;k=b+4|0;if((h|0)==(k|0)){l=b+24|0;a[l>>0]=j;i=d;return}m=b+24|0;n=h;while(1){h=n+16|0;o=n+32|0;p=c[o>>2]|0;if(!p){ujc(b,h)|0;q=c[o>>2]|0;if(q){r=q;s=6}}else{r=p;s=6}a:do if((s|0)==6){s=0;c[g>>2]=c[h>>2];p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,g);q=c[e>>2]|0;o=c[p+28>>2]|0;if((q|0)==-1){t=o+(c[p+32>>2]<<3)|0;break}else{t=o+(q<<3)|0;break}}else t=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;q=p+28|0;o=p+32|0;u=(c[q>>2]|0)+(c[o>>2]<<3)|0;if(((t|0)!=(u|0)?(v=c[t+4>>2]|0,(v|0)!=0):0)?(w=(da(c[137788]|0,(c[v+8>>2]|0)>>>21)|0)+226|0,x=w>>5,(1<<w-(x<<5)&c[(c[137786]|0)+(x<<2)>>2]|0)!=0):0){x=v+28|0;v=x+76|0;w=c[v>>2]|0;if(!w)y=0;else{c[f>>2]=w;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,f);w=c[e>>2]|0;z=c[q>>2]|0;if((w|0)==-1){A=z+(c[o>>2]<<3)|0;break}else{A=z+(w<<3)|0;break}}else A=u;while(0);u=c[137784]|0;if((A|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[A+4>>2]|0,(u|0)!=0):0)B=u;else s=24}else s=24;if((s|0)==24){s=0;B=hQb(c[v>>2]|0)|0}y=B}u=Pjc(y)|0;if(!((u|0)==(c[r>>2]|0)?(a[m>>0]|0)==j<<24>>24:0)){o=c[r+28>>2]|0;b:do if(o){q=c[r+20>>2]|0;p=0;while(1){w=c[q+(p<<2)>>2]|0;p=p+1|0;if(!((w|0)==0|(w|0)==(h|0)))break;if(p>>>0>=o>>>0)break b}wjc(b,h);ujc(b,h)|0;break a}while(0);c[r>>2]=u;a[r+8>>0]=1;a[r+16>>0]=1}o=n+36|0;v=x+20|0;p=c[v>>2]|0;if((c[n+56>>2]|0)!=(p|0)){q=c[r+28>>2]|0;if(!q)C=0;else{w=c[r+20>>2]|0;z=0;D=0;while(1){E=c[w+(z<<2)>>2]|0;if((E|0)==0|(E|0)==(h|0))F=D;else F=(c[E+40>>2]|0)+D|0;z=z+1|0;if(z>>>0>=q>>>0){C=F;break}else D=F}}if((p+C|0)>32){wjc(b,h);ujc(b,h)|0;break}}D=Ard(Ard(Ard(yrd()|0,x,4)|0,x+8|0,4)|0,x+4|0,4)|0;q=Ard(D,c[x+12>>2]|0,c[v>>2]<<4)|0;D=zrd(Ard(q,c[x+28>>2]|0,c[x+36>>2]|0)|0)|0;q=n+24|0;z=(D|0)!=(c[q>>2]|0);if(z){a[r+8>>0]=1;a[r+16>>0]=1;c[q>>2]=D}D=yrd()|0;q=Ard(D,c[x+44>>2]|0,c[x+52>>2]<<3)|0;D=zrd(Ard(q,c[x+60>>2]|0,c[x+68>>2]<<1)|0)|0;q=n+28|0;w=(D|0)!=(c[q>>2]|0);if(w){u=n+116|0;kQb(c[u>>2]|0);E=c[r+20>>2]|0;G=c[r+28>>2]|0;H=E+(G<<2)|0;c:do if(!G)I=E;else{J=E;while(1){if((c[J>>2]|0)==(h|0)){I=J;break c}J=J+4|0;if((J|0)==(H|0)){I=H;break}}}while(0);c[u>>2]=Gjc(0,x,I-E>>2)|0;c[q>>2]=D}if(!(z|w))break;Rjc(o,x)|0;break}}wjc(b,h)}while(0);h=c[n+4>>2]|0;if(!h){H=n;while(1){G=c[H+8>>2]|0;if((c[G>>2]|0)==(H|0)){K=G;break}else H=G}}else{H=h;while(1){G=c[H>>2]|0;if(!G){K=H;break}else H=G}}if((K|0)==(k|0)){l=m;break}else n=K}a[l>>0]=j;i=d;return}function Gjc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=i;i=i+16|0;g=b+4|0;h=b;c[h>>2]=c[153116];c[g+0>>2]=c[h+0>>2];h=_jc(4,g)|0;In[c[(c[h>>2]|0)+44>>2]&4095](h,61);g=e+52|0;j=c[g>>2]|0;k=c[144376]|0;if(!k){if(!(a[577528]|0)){l=577512;m=575992;n=l+16|0;do{a[l>>0]=a[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));a[577528]=1}a[577521]=4;c[144376]=577512;o=577512}else o=k;Pdc(h,j,29,0,o);o=h+28|0;j=c[o>>2]|0;k=a[j+11>>0]|0;if(!((a[j+10>>0]|0)!=0|(k&255)<3)){m=c[j+92>>2]|0;if((m|0)==0|k<<24>>24==0){p=1;q=0}else{k=d[j+8>>0]|0;p=d[j+(k*12|0)+50>>0]|0;q=m+((d[j+9>>0]|0)+(c[j+(k*12|0)+44>>2]|0))|0}}else{p=0;q=0}k=a[j+23>>0]|0;if(!((a[j+22>>0]|0)!=0|(k&255)<2)){m=c[j+92>>2]|0;if((m|0)==0|k<<24>>24==0){r=1;s=0}else{k=d[j+20>>0]|0;r=d[j+(k*12|0)+50>>0]|0;s=m+((d[j+21>>0]|0)+(c[j+(k*12|0)+44>>2]|0))|0}}else{r=0;s=0}k=a[j+27>>0]|0;if(!((a[j+26>>0]|0)!=0|(k&255)<2)){m=c[j+92>>2]|0;if((m|0)==0|k<<24>>24==0){t=1;u=0}else{k=d[j+24>>0]|0;t=d[j+(k*12|0)+50>>0]|0;u=m+((d[j+25>>0]|0)+(c[j+(k*12|0)+44>>2]|0))|0}}else{t=0;u=0}k=a[j+19>>0]|0;if(!((a[j+18>>0]|0)!=2|(k&255)<4)){m=c[j+92>>2]|0;if((m|0)==0|k<<24>>24==0){v=1;w=0}else{k=d[j+16>>0]|0;v=d[j+(k*12|0)+50>>0]|0;w=m+((d[j+17>>0]|0)+(c[j+(k*12|0)+44>>2]|0))|0}}else{v=0;w=0}if(!(c[g>>2]|0)){pec(h,1,1);x=e+60|0;y=c[x>>2]|0;z=e+68|0;A=c[z>>2]|0;mec(h,y,A,0,0)|0;B=c[o>>2]|0;C=B+96|0;D=c[C>>2]|0;Xdc(h,D,1);i=b;return h|0}k=f<<24;f=e+44|0;j=q;q=w;w=s;s=u;u=0;while(1){c[j+0>>2]=c[150284];c[j+4>>2]=c[150285];c[j+8>>2]=c[150286];c[q>>2]=k;m=(c[f>>2]|0)+(u<<3)|0;l=c[m+4>>2]|0;n=w;c[n>>2]=c[m>>2];c[n+4>>2]=l;u=u+1|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;if(u>>>0>=(c[g>>2]|0)>>>0)break;else{j=j+p|0;q=q+v|0;w=w+r|0;s=s+t|0}}pec(h,1,1);x=e+60|0;y=c[x>>2]|0;z=e+68|0;A=c[z>>2]|0;mec(h,y,A,0,0)|0;B=c[o>>2]|0;C=B+96|0;D=c[C>>2]|0;Xdc(h,D,1);i=b;return h|0}function Hjc(a,b,e,f,h,j,k,l,m){a=a|0;b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;n=k>>>3;k=(n|0)==0;if(k){o=0;p=e;q=p-e|0;c[l>>2]=q;c[m>>2]=o;i=h;return n|0}r=0;s=0;t=j;u=b;b=e;while(1){v=c[f+((d[t+15>>0]|0)<<2)>>2]|0;w=c[v+68>>2]|0;x=c[v+52>>2]|0;y=w>>>1;z=b<<16|b;if(!y)A=u;else{B=y>>>0>1?y:1;C=0;D=u;E=c[v+60>>2]|0;while(1){c[D>>2]=(c[E>>2]|0)+z;C=C+1|0;if((C|0)>=(y|0))break;else{D=D+4|0;E=E+4|0}}A=u+(B<<2)|0}E=x+b|0;D=w+s|0;r=r+1|0;if(r>>>0>=n>>>0){F=E;G=D;break}else{s=D;t=t+32|0;u=A;b=E}}if(k){o=G;p=F;q=p-e|0;c[l>>2]=q;c[m>>2]=o;i=h;return n|0}k=0;b=j;j=a;while(1){a=c[b+12>>2]|0;A=a>>>24;u=c[f+(A<<2)>>2]|0;t=c[u+44>>2]|0;s=c[u+52>>2]|0;if(!s)H=j;else{u=b+4|0;r=b+8|0;E=a<<16&16711680|a&65280|A<<24|a>>>16&255|0;a=b+16|0;A=b+20|0;D=b+24|0;y=b+28|0;C=s*10|0;z=0;v=j;while(1){g[v>>2]=ea(g[b>>2]);g[v+4>>2]=ea(g[u>>2]);g[v+8>>2]=ea(g[r>>2]);c[v+12>>2]=E;g[v+16>>2]=ea(g[t+(z<<3)>>2]);g[v+20>>2]=ea(g[t+(z<<3)+4>>2]);g[v+24>>2]=ea(g[a>>2]);g[v+28>>2]=ea(g[A>>2]);g[v+32>>2]=ea(g[D>>2]);g[v+36>>2]=ea(g[y>>2]);z=z+1|0;if((z|0)==(s|0))break;else v=v+40|0}H=j+(C<<2)|0}k=k+1|0;if(k>>>0>=n>>>0){o=G;p=F;break}else{b=b+32|0;j=H}}q=p-e|0;c[l>>2]=q;c[m>>2]=o;i=h;return n|0}function Ijc(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);c[b>>2]=-1;itd(b,576136);c[b>>2]=-1;itd(b,719280);c[b>>2]=-1;itd(b,576152);c[b>>2]=-1;itd(b,576176);c[144042]=c[b>>2];c[b>>2]=-1;itd(b,576208);c[144050]=c[b>>2];c[b>>2]=-1;itd(b,576240);c[144058]=c[b>>2];c[b>>2]=-1;itd(b,576272);c[144064]=c[b>>2];c[b>>2]=-1;itd(b,576288);c[144065]=c[b>>2];c[b>>2]=-1;itd(b,576304);c[144066]=c[b>>2];c[b>>2]=-1;itd(b,576320);c[144067]=c[b>>2];c[b>>2]=-1;itd(b,576352);c[144084]=c[b>>2];c[b>>2]=-1;itd(b,576368);c[144085]=c[b>>2];c[b>>2]=-1;itd(b,576384);c[144086]=c[b>>2];c[b>>2]=-1;itd(b,576400);c[144087]=c[b>>2];c[b>>2]=-1;itd(b,576544);c[144104]=c[b>>2];c[b>>2]=-1;itd(b,576568);c[144105]=c[b>>2];c[b>>2]=-1;itd(b,576592);c[144106]=c[b>>2];c[b>>2]=-1;itd(b,576616);c[144107]=c[b>>2];c[b>>2]=-1;itd(b,576640);c[144108]=c[b>>2];c[b>>2]=-1;itd(b,576664);c[144109]=c[b>>2];c[b>>2]=-1;itd(b,576688);c[144110]=c[b>>2];c[b>>2]=-1;itd(b,576712);c[144111]=c[b>>2];c[b>>2]=-1;itd(b,576736);c[144112]=c[b>>2];c[b>>2]=-1;itd(b,576760);c[144113]=c[b>>2];c[b>>2]=-1;itd(b,576784);c[144114]=c[b>>2];c[b>>2]=-1;itd(b,576808);c[144115]=c[b>>2];c[b>>2]=-1;itd(b,576832);c[144116]=c[b>>2];c[b>>2]=-1;itd(b,576856);c[144117]=c[b>>2];c[b>>2]=-1;itd(b,576880);c[144118]=c[b>>2];c[b>>2]=-1;itd(b,576904);c[144119]=c[b>>2];c[b>>2]=-1;itd(b,576928);c[144120]=c[b>>2];c[b>>2]=-1;itd(b,576952);c[144121]=c[b>>2];c[b>>2]=-1;itd(b,576976);c[144122]=c[b>>2];c[b>>2]=-1;itd(b,577e3);c[144123]=c[b>>2];c[b>>2]=-1;itd(b,577024);c[144124]=c[b>>2];c[b>>2]=-1;itd(b,577048);c[144125]=c[b>>2];c[b>>2]=-1;itd(b,577072);c[144126]=c[b>>2];c[b>>2]=-1;itd(b,577096);c[144127]=c[b>>2];c[b>>2]=-1;itd(b,577120);c[144128]=c[b>>2];c[b>>2]=-1;itd(b,577144);c[144129]=c[b>>2];c[b>>2]=-1;itd(b,577168);c[144130]=c[b>>2];c[b>>2]=-1;itd(b,577192);c[144131]=c[b>>2];c[b>>2]=-1;itd(b,577216);c[144132]=c[b>>2];c[b>>2]=-1;itd(b,577240);c[144133]=c[b>>2];c[b>>2]=-1;itd(b,577264);c[144134]=c[b>>2];c[b>>2]=-1;itd(b,577288);c[144135]=c[b>>2];rri(577312,577328,25);c[b>>2]=-1;itd(b,577368);c[144340]=c[b>>2];Drd(577392,120,121,0);i=a;return}function Jjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Jjc(a,c[b>>2]|0);Jjc(a,c[b+4>>2]|0);c[f>>2]=54;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Kjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Kjc(a,c[b>>2]|0);Kjc(a,c[b+4>>2]|0);njc(b+36|0);c[f>>2]=54;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Ljc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;c=i;i=i+96|0;d=c+32|0;e=c+16|0;f=c;L$b(d,b);h=ea(g[d+32>>2]);j=ea(g[d+36>>2]);k=ea(g[d+40>>2]);l=ea(g[150298]);m=ea(j*l);n=ea(g[150297]);o=ea(m-ea(k*n));m=ea(g[150296]);p=ea(ea(k*m)-ea(h*l));k=ea(ea(h*n)-ea(j*m));j=ea(ea(k*k)+ea(ea(o*o)+ea(p*p)));if(j<ea(0.0))q=ea(-j);else q=j;if(!(q<=ea(9.99999997e-07))){q=ea(T(ea(j)));r=ea(k/q);s=ea(p/q);t=ea(o/q)}else{q=ea(g[d>>2]);o=ea(g[d+4>>2]);r=ea(g[d+8>>2]);s=o;t=q}q=ea(ea(r*n)-ea(s*l));o=ea(ea(t*l)-ea(r*m));l=ea(ea(s*m)-ea(t*n));n=ea(T(ea(ea(l*l)+ea(ea(q*q)+ea(o*o)))));m=ea(q/n);q=ea(o/n);o=ea(l/n);n=ea(+$(+ea(ea(r*ea(0.0))-t),+ea(r+ea(t*ea(0.0)))));if(n<ea(0.0))u=ea(n+ea(6.28318548));else u=n;g[e>>2]=t;g[e+4>>2]=s;g[e+8>>2]=r;g[e+12>>2]=ea(0.0);old(a,576168,e);g[f>>2]=m;g[f+4>>2]=q;g[f+8>>2]=o;g[f+12>>2]=ea(0.0);old(a,576200,f);nld(a,576232,u);i=c;return}function Mjc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a>>2]|0)==(b|0))c[a>>2]=0;e=a+4|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+8|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+12|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+16|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+20|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+24|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+28|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+32|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+36|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+40|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+44|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+48|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+52|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+56|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+60|0;if((c[e>>2]|0)!=(b|0)){i=d;return}c[e>>2]=0;i=d;return}function Njc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];g=c[b+16>>2]|0;c[a+16>>2]=g;h=a+20|0;c[h>>2]=0;j=a+24|0;c[j>>2]=0;k=a+12|0;c[k>>2]=0;l=c[b+12>>2]|0;m=c[b+20>>2]<<4;n=m>>4;c[h>>2]=n;if(!n){o=0;p=0}else{c[j>>2]=n;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];g=hOb(0,m,4,e,0,3653512,370)|0;c[k>>2]=g;o=g;p=c[h>>2]<<4}YEi(o|0,l|0,p|0)|0;p=c[b+32>>2]|0;c[a+32>>2]=p;l=a+36|0;c[l>>2]=0;o=a+40|0;c[o>>2]=0;h=a+28|0;c[h>>2]=0;g=c[b+28>>2]|0;k=c[b+36>>2]|0;c[l>>2]=k;if(!k){q=0;r=0}else{c[o>>2]=k;c[f>>2]=p;c[e+0>>2]=c[f+0>>2];p=hOb(0,k,1,e,0,3653512,370)|0;c[h>>2]=p;q=p;r=c[l>>2]|0}YEi(q|0,g|0,r|0)|0;r=c[b+48>>2]|0;c[a+48>>2]=r;g=a+52|0;c[g>>2]=0;q=a+56|0;c[q>>2]=0;l=a+44|0;c[l>>2]=0;p=c[b+44>>2]|0;h=c[b+52>>2]<<3;k=h>>3;c[g>>2]=k;if(!k){s=0;t=0}else{c[q>>2]=k;c[f>>2]=r;c[e+0>>2]=c[f+0>>2];r=hOb(0,h,4,e,0,3653512,370)|0;c[l>>2]=r;s=r;t=c[g>>2]<<3}YEi(s|0,p|0,t|0)|0;t=c[b+64>>2]|0;c[a+64>>2]=t;p=a+68|0;c[p>>2]=0;s=a+72|0;c[s>>2]=0;g=a+60|0;c[g>>2]=0;r=c[b+60>>2]|0;l=c[b+68>>2]<<1;h=l>>1;c[p>>2]=h;if(!h){u=0;v=0;YEi(u|0,r|0,v|0)|0;w=b+76|0;x=c[w>>2]|0;y=a+76|0;c[y>>2]=x;i=d;return}c[s>>2]=h;c[f>>2]=t;c[e+0>>2]=c[f+0>>2];f=hOb(0,l,2,e,0,3653512,370)|0;c[g>>2]=f;u=f;v=c[p>>2]<<1;YEi(u|0,r|0,v|0)|0;w=b+76|0;x=c[w>>2]|0;y=a+76|0;c[y>>2]=x;i=d;return}function Ojc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d+4|0;l=c[k>>2]|0;do if(l){m=c[e>>2]|0;n=l;while(1){o=c[n+16>>2]|0;if((m|0)<(o|0)){p=c[n>>2]|0;if(!p){q=n;r=n;s=5;break}else{n=p;continue}}if((o|0)>=(m|0)){t=n;s=9;break}o=n+4|0;p=c[o>>2]|0;if(!p){u=o;v=n;s=8;break}else n=p}if((s|0)==5){c[j>>2]=r;w=q;x=r;break}else if((s|0)==8){c[j>>2]=v;w=u;x=v;break}else if((s|0)==9){c[j>>2]=t;w=j;x=t;break}}else{n=d+4|0;c[j>>2]=n;w=n;x=n}while(0);j=c[w>>2]|0;if(j){y=0;z=j;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}c[h>>2]=54;c[g+0>>2]=c[h+0>>2];h=cOb(120,16,g,0,3653512,80)|0;g=h+16|0;c[g>>2]=c[e>>2];j=h+20|0;t=e+4|0;c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[j+12>>2]=c[t+12>>2];Njc(h+36|0,e+20|0);c[h+116>>2]=c[e+100>>2];c[g>>2]=c[e>>2];c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=x;c[w>>2]=h;x=c[c[d>>2]>>2]|0;if(!x)B=h;else{c[d>>2]=x;B=c[w>>2]|0}GN(c[k>>2]|0,B);B=d+8|0;c[B>>2]=(c[B>>2]|0)+1;y=1;z=h;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}function Pjc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+96|0;d=b+76|0;e=b+48|0;f=b+8|0;g=b+24|0;h=b+80|0;j=b;k=b+32|0;l=b+72|0;m=b+56|0;if(!a){n=0;i=b;return n|0}c[e>>2]=c[144340];c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[d+0>>2]=c[e+0>>2];lkd(a,d,f);c[g>>2]=c[144064];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+0>>2]=c[g+0>>2];lkd(a,d,h);c[g>>2]=c[144065];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+0>>2]=c[g+0>>2];lkd(a,d,h);c[g>>2]=c[144066];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+0>>2]=c[g+0>>2];lkd(a,d,h);c[g>>2]=c[144067];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+0>>2]=c[g+0>>2];lkd(a,d,h);c[j>>2]=c[144084];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[d+0>>2]=c[j+0>>2];lkd(a,d,k);c[j>>2]=c[144085];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[d+0>>2]=c[j+0>>2];lkd(a,d,k);c[j>>2]=c[144086];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[d+0>>2]=c[j+0>>2];lkd(a,d,k);c[j>>2]=c[144087];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[d+0>>2]=c[j+0>>2];lkd(a,d,k);k=0;do{c[l>>2]=c[576416+(k<<2)>>2];c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[d+0>>2]=c[l+0>>2];lkd(a,d,m);k=k+1|0}while((k|0)!=32);n=Vjd(a)|0;i=b;return n|0}function Qjc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d+4|0;l=c[k>>2]|0;do if(l){m=c[e>>2]|0;n=l;while(1){o=c[n+16>>2]|0;if(m>>>0<o>>>0){p=c[n>>2]|0;if(!p){q=n;r=n;s=5;break}else{n=p;continue}}if(o>>>0>=m>>>0){t=n;s=9;break}o=n+4|0;p=c[o>>2]|0;if(!p){u=o;v=n;s=8;break}else n=p}if((s|0)==5){c[j>>2]=r;w=q;x=r;break}else if((s|0)==8){c[j>>2]=v;w=u;x=v;break}else if((s|0)==9){c[j>>2]=t;w=j;x=t;break}}else{n=d+4|0;c[j>>2]=n;w=n;x=n}while(0);j=c[w>>2]|0;if(j){y=0;z=j;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}c[h>>2]=54;c[g+0>>2]=c[h+0>>2];h=cOb(20,16,g,0,3653512,80)|0;c[h+16>>2]=c[e>>2];c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=x;c[w>>2]=h;x=c[c[d>>2]>>2]|0;if(!x)B=h;else{c[d>>2]=x;B=c[w>>2]|0}GN(c[k>>2]|0,B);B=d+8|0;c[B>>2]=(c[B>>2]|0)+1;y=1;z=h;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}function Rjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];g=a+12|0;h=(b|0)==(a|0);if(h){j=b+76|0;k=c[j>>2]|0;l=a+76|0;c[l>>2]=k;i=d;return a|0}m=c[b+12>>2]|0;n=c[b+20>>2]<<4;o=n>>4;p=a+20|0;c[p>>2]=o;q=a+24|0;r=c[q>>2]|0;if((r&2147483647)>>>0<o>>>0){if((r|0)>-1){c[q>>2]=o;r=c[g>>2]|0;c[f>>2]=c[a+16>>2];c[e+0>>2]=c[f+0>>2];s=hOb(r,n,4,e,0,3653512,370)|0;c[g>>2]=s;t=s}else{c[f>>2]=c[a+16>>2];c[e+0>>2]=c[f+0>>2];s=cOb(n,4,e,0,3653512,352)|0;YEi(s|0,c[g>>2]|0,c[p>>2]<<4|0)|0;c[q>>2]=o;c[g>>2]=s;t=s}YEi(t|0,m|0,c[p>>2]<<4|0)|0;if(h){j=b+76|0;k=c[j>>2]|0;l=a+76|0;c[l>>2]=k;i=d;return a|0}}else YEi(c[g>>2]|0,m|0,c[p>>2]<<4|0)|0;p=a+28|0;m=c[b+28>>2]|0;g=c[b+36>>2]|0;t=a+36|0;c[t>>2]=g;s=a+40|0;o=c[s>>2]|0;do if((o&2147483647)>>>0<g>>>0)if((o|0)>-1){c[s>>2]=g;q=c[p>>2]|0;c[f>>2]=c[a+32>>2];c[e+0>>2]=c[f+0>>2];n=hOb(q,g,1,e,0,3653512,370)|0;c[p>>2]=n;u=n;break}else{c[f>>2]=c[a+32>>2];c[e+0>>2]=c[f+0>>2];n=cOb(g,1,e,0,3653512,352)|0;YEi(n|0,c[p>>2]|0,c[t>>2]|0)|0;c[s>>2]=g;c[p>>2]=n;u=n;break}else u=c[p>>2]|0;while(0);YEi(u|0,m|0,c[t>>2]|0)|0;t=a+44|0;if(h){j=b+76|0;k=c[j>>2]|0;l=a+76|0;c[l>>2]=k;i=d;return a|0}m=c[b+44>>2]|0;u=c[b+52>>2]<<3;p=u>>3;g=a+52|0;c[g>>2]=p;s=a+56|0;o=c[s>>2]|0;if((o&2147483647)>>>0<p>>>0){if((o|0)>-1){c[s>>2]=p;o=c[t>>2]|0;c[f>>2]=c[a+48>>2];c[e+0>>2]=c[f+0>>2];n=hOb(o,u,4,e,0,3653512,370)|0;c[t>>2]=n;v=n}else{c[f>>2]=c[a+48>>2];c[e+0>>2]=c[f+0>>2];n=cOb(u,4,e,0,3653512,352)|0;YEi(n|0,c[t>>2]|0,c[g>>2]<<3|0)|0;c[s>>2]=p;c[t>>2]=n;v=n}YEi(v|0,m|0,c[g>>2]<<3|0)|0;if(h){j=b+76|0;k=c[j>>2]|0;l=a+76|0;c[l>>2]=k;i=d;return a|0}}else YEi(c[t>>2]|0,m|0,c[g>>2]<<3|0)|0;g=a+60|0;m=c[b+60>>2]|0;t=c[b+68>>2]<<1;h=t>>1;v=a+68|0;c[v>>2]=h;n=a+72|0;p=c[n>>2]|0;do if((p&2147483647)>>>0<h>>>0)if((p|0)>-1){c[n>>2]=h;s=c[g>>2]|0;c[f>>2]=c[a+64>>2];c[e+0>>2]=c[f+0>>2];u=hOb(s,t,2,e,0,3653512,370)|0;c[g>>2]=u;w=u;break}else{c[f>>2]=c[a+64>>2];c[e+0>>2]=c[f+0>>2];u=cOb(t,2,e,0,3653512,352)|0;YEi(u|0,c[g>>2]|0,c[v>>2]<<1|0)|0;c[n>>2]=h;c[g>>2]=u;w=u;break}else w=c[g>>2]|0;while(0);YEi(w|0,m|0,c[v>>2]<<1|0)|0;j=b+76|0;k=c[j>>2]|0;l=a+76|0;c[l>>2]=k;i=d;return a|0}function Sjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a+4>>2]|0;h=a+4|0;if(!g){j=0;i=d;return j|0}k=c[b>>2]|0;b=h;l=g;a:while(1){m=l;while(1){if((c[m+16>>2]|0)>>>0>=k>>>0){n=m;break}m=c[m+4>>2]|0;if(!m){o=b;break a}}l=c[n>>2]|0;if(!l){o=n;break}else b=n}if((o|0)==(h|0)){j=0;i=d;return j|0}if(k>>>0<(c[o+16>>2]|0)>>>0){j=0;i=d;return j|0}k=c[o+4>>2]|0;if(!k){h=o;while(1){n=c[h+8>>2]|0;if((c[n>>2]|0)==(h|0)){p=n;break}else h=n}}else{h=k;while(1){k=c[h>>2]|0;if(!k){p=h;break}else h=k}}if((c[a>>2]|0)==(o|0))c[a>>2]=p;p=a+8|0;c[p>>2]=(c[p>>2]|0)+-1;tYb(g,o);c[f>>2]=54;c[e+0>>2]=c[f+0>>2];eOb(o,e);j=1;i=d;return j|0}function Tjc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(144,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];Zjd(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function Ujc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d;j=(a|0)==(b|0);if(j){i=d;return a|0}k=a+4|0;Xjc(a,c[k>>2]|0);l=a+8|0;c[l>>2]=0;m=a+4|0;c[a>>2]=m;c[m>>2]=0;n=c[b>>2]|0;o=b+4|0;if((n|0)!=(o|0)){p=h+4|0;q=h+20|0;r=n;while(1){n=c[r+16>>2]|0;s=r+20|0;c[p+0>>2]=c[s+0>>2];c[p+4>>2]=c[s+4>>2];c[p+8>>2]=c[s+8>>2];c[p+12>>2]=c[s+12>>2];s=c[r+36>>2]|0;c[q>>2]=s;c[h>>2]=n;c[g>>2]=m;c[e+0>>2]=c[g+0>>2];t=bkc(a,e,f,h)|0;if(!(c[t>>2]|0)){u=xCi(40)|0;v=u+20|0;c[v+0>>2]=c[p+0>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];c[v+12>>2]=c[p+12>>2];c[u+36>>2]=s;c[u+16>>2]=n;n=c[f>>2]|0;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=n;c[t>>2]=u;n=c[c[a>>2]>>2]|0;if(!n)w=u;else{c[a>>2]=n;w=c[t>>2]|0}GN(c[k>>2]|0,w);c[l>>2]=(c[l>>2]|0)+1}t=c[r+4>>2]|0;if(!t){n=r;while(1){u=c[n+8>>2]|0;if((c[u>>2]|0)==(n|0)){x=u;break}else n=u}}else{n=t;while(1){u=c[n>>2]|0;if(!u){x=n;break}else n=u}}if((x|0)==(o|0))break;else r=x}if(j){i=d;return a|0}}x=a+12|0;r=a+16|0;Wjc(x,c[r>>2]|0);o=a+20|0;c[o>>2]=0;l=a+16|0;c[x>>2]=l;c[l>>2]=0;w=c[b+12>>2]|0;k=b+16|0;if((w|0)!=(k|0)){p=w;while(1){w=p+16|0;m=c[w>>2]|0;q=c[w+4>>2]|0;w=h;c[w>>2]=m;c[w+4>>2]=q;c[g>>2]=l;c[e+0>>2]=c[g+0>>2];w=ckc(x,e,f,h)|0;if(!(c[w>>2]|0)){n=xCi(24)|0;t=n+16|0;c[t>>2]=m;c[t+4>>2]=q;q=c[f>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=q;c[w>>2]=n;q=c[c[x>>2]>>2]|0;if(!q)y=n;else{c[x>>2]=q;y=c[w>>2]|0}GN(c[r>>2]|0,y);c[o>>2]=(c[o>>2]|0)+1}w=c[p+4>>2]|0;if(!w){q=p;while(1){n=c[q+8>>2]|0;if((c[n>>2]|0)==(q|0)){z=n;break}else q=n}}else{q=w;while(1){n=c[q>>2]|0;if(!n){z=q;break}else q=n}}if((z|0)==(k|0))break;else p=z}}z=a+24|0;if(j){i=d;return a|0}j=a+28|0;Vjc(z,c[j>>2]|0);p=a+32|0;c[p>>2]=0;k=a+28|0;c[z>>2]=k;c[k>>2]=0;o=c[b+24>>2]|0;y=b+28|0;if((o|0)==(y|0)){i=d;return a|0}b=o;while(1){o=b+16|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];c[h+16>>2]=c[o+16>>2];c[g>>2]=k;c[e+0>>2]=c[g+0>>2];o=dkc(z,e,f,h)|0;if(!(c[o>>2]|0)){r=xCi(36)|0;x=r+16|0;c[x+0>>2]=c[h+0>>2];c[x+4>>2]=c[h+4>>2];c[x+8>>2]=c[h+8>>2];c[x+12>>2]=c[h+12>>2];c[x+16>>2]=c[h+16>>2];x=c[f>>2]|0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=x;c[o>>2]=r;x=c[c[z>>2]>>2]|0;if(!x)A=r;else{c[z>>2]=x;A=c[o>>2]|0}GN(c[j>>2]|0,A);c[p>>2]=(c[p>>2]|0)+1}o=c[b+4>>2]|0;if(!o){x=b;while(1){r=c[x+8>>2]|0;if((c[r>>2]|0)==(x|0)){B=r;break}else x=r}}else{x=o;while(1){r=c[x>>2]|0;if(!r){B=x;break}else x=r}}if((B|0)==(y|0))break;else b=B}i=d;return a|0}function Vjc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Vjc(a,c[b>>2]|0);Vjc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Wjc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Wjc(a,c[b>>2]|0);Wjc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Xjc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Xjc(a,c[b>>2]|0);Xjc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Yjc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=Im,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;h=i;i=i+16|0;j=h;k=d+20|0;l=ea((c[k>>2]|0)>>>0);m=ea(ea(1.0)/ea(ea(6.28318548)/l));n=ea(c[f>>2]|0);o=b+24|0;p=576256+(e<<2)|0;q=b+28|0;r=c[q>>2]|0;do if(r){s=c[p>>2]|0;t=r;while(1){u=c[t+16>>2]|0;if((s|0)<(u|0)){v=c[t>>2]|0;if(!v){w=t;x=t;y=5;break}else{t=v;continue}}if((u|0)>=(s|0)){z=t;y=9;break}u=t+4|0;v=c[u>>2]|0;if(!v){A=u;B=t;y=8;break}else t=v}if((y|0)==5){c[j>>2]=x;C=w;D=x;break}else if((y|0)==8){c[j>>2]=B;C=A;D=B;break}else if((y|0)==9){c[j>>2]=z;C=j;D=z;break}}else{t=b+28|0;c[j>>2]=t;C=t;D=t}while(0);z=c[C>>2]|0;if(!z){B=xCi(36)|0;c[B+16>>2]=c[p>>2];c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=D;c[C>>2]=B;D=c[c[o>>2]>>2]|0;if(!D)E=B;else{c[o>>2]=D;E=c[C>>2]|0}GN(c[q>>2]|0,E);E=b+32|0;c[E>>2]=(c[E>>2]|0)+1;F=c[q>>2]|0;G=B}else{F=r;G=z}g[G+20>>2]=l;g[G+24>>2]=m;g[G+28>>2]=n;g[G+32>>2]=ea(0.0);n=ea(g[d>>2]);m=ea(g[d+8>>2]);l=ea(g[d+4>>2]);G=576336+(e<<2)|0;do if(F){e=c[G>>2]|0;z=F;while(1){r=c[z+16>>2]|0;if((e|0)<(r|0)){B=c[z>>2]|0;if(!B){H=z;I=z;y=19;break}else{z=B;continue}}if((r|0)>=(e|0)){J=z;y=23;break}r=z+4|0;B=c[r>>2]|0;if(!B){K=r;L=z;y=22;break}else z=B}if((y|0)==19){c[j>>2]=I;M=H;N=I;break}else if((y|0)==22){c[j>>2]=L;M=K;N=L;break}else if((y|0)==23){c[j>>2]=J;M=j;N=J;break}}else{z=b+28|0;c[j>>2]=z;M=z;N=z}while(0);J=c[M>>2]|0;if(!J){L=xCi(36)|0;c[L+16>>2]=c[G>>2];c[L>>2]=0;c[L+4>>2]=0;c[L+8>>2]=N;c[M>>2]=L;N=c[c[o>>2]>>2]|0;if(!N)O=L;else{c[o>>2]=N;O=c[M>>2]|0}GN(c[q>>2]|0,O);O=b+32|0;c[O>>2]=(c[O>>2]|0)+1;P=L}else P=J;g[P+20>>2]=n;g[P+24>>2]=m;g[P+28>>2]=l;g[P+32>>2]=ea(0.0);if(!(c[k>>2]|0)){i=h;return}P=d+12|0;J=d+28|0;d=b+28|0;L=b+32|0;b=0;do{O=c[P>>2]|0;l=ea(g[O+(b<<4)>>2]);m=ea(g[O+(b<<4)+4>>2]);n=ea(g[O+(b<<4)+8>>2]);Q=ea(g[O+(b<<4)+12>>2]);if(!(a[(c[J>>2]|0)+b>>0]|0)){R=n;S=Q}else{R=ea(-n);S=ea(-Q)}O=c[f>>2]|0;c[f>>2]=O+1;M=576416+(O<<2)|0;O=c[q>>2]|0;do if(O){N=c[M>>2]|0;G=O;while(1){K=c[G+16>>2]|0;if((N|0)<(K|0)){I=c[G>>2]|0;if(!I){T=G;U=G;y=37;break}else{G=I;continue}}if((K|0)>=(N|0)){V=G;y=41;break}K=G+4|0;I=c[K>>2]|0;if(!I){W=K;X=G;y=40;break}else G=I}if((y|0)==37){y=0;c[j>>2]=U;Y=T;Z=U;break}else if((y|0)==40){y=0;c[j>>2]=X;Y=W;Z=X;break}else if((y|0)==41){y=0;c[j>>2]=V;Y=j;Z=V;break}}else{c[j>>2]=d;Y=d;Z=d}while(0);O=c[Y>>2]|0;if(!O){G=xCi(36)|0;c[G+16>>2]=c[M>>2];c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=Z;c[Y>>2]=G;N=c[c[o>>2]>>2]|0;if(!N)_=G;else{c[o>>2]=N;_=c[Y>>2]|0}GN(c[q>>2]|0,_);c[L>>2]=(c[L>>2]|0)+1;$=G}else $=O;g[$+20>>2]=l;g[$+24>>2]=m;g[$+28>>2]=R;g[$+32>>2]=S;b=b+1|0}while(b>>>0<(c[k>>2]|0)>>>0);i=h;return}function Zjc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;do if(g>>>0>k>>>0?(l=j<<1,m=(l|0)==0?1:l,k>>>0<m>>>0):0)if((j|0)>-1){c[h>>2]=m;l=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(l,m<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];l=cOb(m<<2,4,d,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[f>>2]<<2|0)|0;c[h>>2]=m;c[a>>2]=l;break}while(0);i=b;return (c[a>>2]|0)+((c[f>>2]|0)+-1<<2)|0}function _jc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(280,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];Fdc(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function $jc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153116];c[b+0>>2]=c[d+0>>2];d=bOb(96,b,0,16,3653512,150)|0;qjc(d);c[144346]=d;i=a;return}function akc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[144346]|0;f=c[153116]|0;if(e)sjc(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[144346]=0;i=a;return}function bkc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function ckc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function dkc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function ekc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a;fkc();d=c[144384]|0;e=c[d>>2]|0;if((e|0)==(d+4|0)){i=a;return}d=e;while(1){c[b>>2]=c[d+16>>2];e=xjc(pjc()|0,b)|0;f=Ajc(pjc()|0,b)|0;g=d+24|0;h=d+28|0;if(!((e|0)==(c[g>>2]|0)?(f|0)==(c[h>>2]|0):0))j=5;if((j|0)==5?(j=0,c[g>>2]=e,c[h>>2]=f,h=c[d+20>>2]|0,g=c[h+4>>2]|0,(g|0)!=(h|0)):0){k=g;do{g=c[k+8>>2]|0;c[g+292>>2]=e;c[g+296>>2]=f;k=c[k+4>>2]|0}while((k|0)!=(h|0))}h=c[d+4>>2]|0;if(!h){k=d;while(1){f=c[k+8>>2]|0;if((c[f>>2]|0)==(k|0)){l=f;break}else k=f}}else{k=h;while(1){f=c[k>>2]|0;if(!f){l=k;break}else k=f}}if((l|0)==((c[144384]|0)+4|0))break;else d=l}i=a;return}function fkc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[144384]|0;g=c[f>>2]|0;if((g|0)==(f+4|0)){i=a;return}h=f;f=g;while(1){g=f+20|0;j=c[g>>2]|0;k=j+4|0;a:do if((c[k>>2]|0)==(j|0)){l=c[153116]|0;if(j){c[k>>2]=0;c[j>>2]=0}c[d>>2]=l;c[b+0>>2]=c[d+0>>2];eOb(j,b);c[g>>2]=0;l=c[144384]|0;m=c[f+4>>2]|0;n=(m|0)==0;if(n){o=f;while(1){p=c[o+8>>2]|0;if((c[p>>2]|0)==(o|0)){q=p;break}else o=p}}else{o=m;while(1){p=c[o>>2]|0;if(!p){q=o;break}else o=p}}if(n){o=f;while(1){p=c[o+8>>2]|0;if((c[p>>2]|0)==(o|0)){r=p;break}else o=p}}else{o=m;while(1){n=c[o>>2]|0;if(!n){r=o;break}else o=n}}if((c[l>>2]|0)==(f|0))c[l>>2]=r;o=l+8|0;c[o>>2]=(c[o>>2]|0)+-1;tYb(c[l+4>>2]|0,f);c[e>>2]=54;c[b+0>>2]=c[e+0>>2];eOb(f,b);s=q;t=c[144384]|0}else{o=c[f+4>>2]|0;if(o){m=o;while(1){o=c[m>>2]|0;if(!o){s=m;t=h;break a}else m=o}}m=f;while(1){l=c[m+8>>2]|0;if((c[l>>2]|0)==(m|0)){s=l;t=h;break}else m=l}}while(0);if((s|0)==(t+4|0))break;else{h=t;f=s}}i=a;return}function gkc(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153116];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,53)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[144384]=d;d=kbc()|0;b=0;while(1){e=d+(b<<2)+960|0;b=b+1|0;if(!(c[e>>2]|0)){f=e;break}if((b|0)>=16){g=5;break}}if((g|0)==5){i=a;return}c[f>>2]=3510;i=a;return}function hkc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;fkc();Mjc((kbc()|0)+960|0,3510);e=c[144384]|0;f=c[153116]|0;if(e)ikc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[144384]=0;i=a;return}function ikc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}ikc(a,c[b>>2]|0);ikc(a,c[b+4>>2]|0);c[f>>2]=54;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function jkc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;h=qdd(a,d,c[142262]|0,g,1)|0;if(!h){i=e;return}if((h|0)>0){rdd(a,2);h=(c[a>>2]&512|0)==0;d=qdd(a,614656,c[142304]|0,f,0)|0;if(d){if((d|0)>0){d=a+12|0;j=c[a+16>>2]|0;k=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;l=j+k|0;c[d>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[a+20>>2]|0)>>>0):0){c[b>>2]=c[l>>2];c[d>>2]=m}else Bid(d,b,4);if(c[a>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{d=c[f>>2]|0;if(d)_n[d&4095](b,a)|0}sdd(a)}if(!h)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[g>>2]|0;if(h)_n[h&4095](b,a)|0}sdd(a);i=e;return}function kkc(b){b=b|0;g[b>>2]=ea(1.0);g[b+4>>2]=ea(1.0);g[b+8>>2]=ea(1.0);g[b+12>>2]=ea(1.0);c[b+16>>2]=0;a[b+20>>0]=1;a[b+21>>0]=1;return}function lkc(b){b=b|0;g[b>>2]=ea(1.0);g[b+4>>2]=ea(1.0);g[b+8>>2]=ea(1.0);g[b+12>>2]=ea(1.0);c[b+16>>2]=0;a[b+20>>0]=1;a[b+21>>0]=1;return}function mkc(a){a=a|0;return}function nkc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+28|0;if(!((a[f>>0]|0)!=0^d)){i=e;return}a[f>>0]=d&1;d=c[b+24>>2]|0;if((d|0)!=0?vTb(d)|0:0){d=(a[f>>0]|0)!=0;f=b+29|0;if(!(d^(a[f>>0]|0)!=0)){i=e;return}if(d){a[f>>0]=1;ko[c[(c[b>>2]|0)+124>>2]&4095](b);i=e;return}else g=f}else{f=b+29|0;if(!(a[f>>0]|0)){i=e;return}else g=f}a[g>>0]=0;ko[c[(c[b>>2]|0)+128>>2]&4095](b);i=e;return}function okc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;d=i;e=c[b+24>>2]|0;if((e|0)!=0?vTb(e)|0:0){e=(a[b+28>>0]|0)!=0;f=b+29|0;if(!(e^(a[f>>0]|0)!=0)){i=d;return}if(e){a[f>>0]=1;ko[c[(c[b>>2]|0)+124>>2]&4095](b);i=d;return}else g=f}else{f=b+29|0;if(!(a[f>>0]|0)){i=d;return}else g=f}a[g>>0]=0;ko[c[(c[b>>2]|0)+128>>2]&4095](b);i=d;return}function pkc(b,d){b=b|0;d=d|0;var e=0;d=i;e=b+29|0;if(!(a[e>>0]|0)){i=d;return}a[e>>0]=0;ko[c[(c[b>>2]|0)+128>>2]&4095](b);i=d;return}
function qkc(a,b){a=a|0;b=b|0;var d=0;d=i;add(b,792072,2444312,a,0);hTb(a,b);add(b,667608,c[142302]|0,a+28|0,257);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);bdd(b);i=d;return}function rkc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2444312,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Ikc(a,b);sdd(b);i=d;return}function skc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;jTb(b,d);f=b+28|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(b,f,1);Ndd(d);i=e;return}else{a[f>>0]=a[g>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Ndd(d);i=e;return}}function tkc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;kTb(b,d);f=b+28|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(b,f,1);Mdd(d);i=e;return}else{a[f>>0]=a[g>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Mdd(d);i=e;return}}function ukc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;lTb(b,d);f=b+28|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0<(c[d+20>>2]|0)>>>0){a[g>>0]=a[f>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Tdd(d);i=e;return}else{Gid(b,f,1);Tdd(d);i=e;return}}function vkc(a,b){a=a|0;b=b|0;var c=0;c=i;mTb(a,b);i=c;return}function wkc(a){a=a|0;var b=0;b=i;Nkc(a);ACi(a);i=b;return}function xkc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;g=a+8|0;h=c[g>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if((k|0)>(d|0)){l=c[j>>2]|0;if(!l){m=j;n=j;o=4;break}else{j=l;continue}}if((k|0)>=(d|0)){p=j;o=8;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=7;break}else j=l}if((o|0)==4){c[f>>2]=n;s=m;t=n;break}else if((o|0)==7){c[f>>2]=r;s=q;t=r;break}else if((o|0)==8){c[f>>2]=p;s=f;t=p;break}}else{j=a+8|0;c[f>>2]=j;s=j;t=j}while(0);f=c[s>>2]|0;if(!f){p=xCi(28)|0;c[p+16>>2]=d;c[p+20>>2]=0;c[p+24>>2]=0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=t;c[s>>2]=p;t=a+4|0;d=c[c[t>>2]>>2]|0;if(!d)u=p;else{c[t>>2]=d;u=c[s>>2]|0}GN(c[g>>2]|0,u);u=a+12|0;c[u>>2]=(c[u>>2]|0)+1;v=p}else v=f;f=v+20|0;if(!(c[f>>2]|0)){p=xCi(8)|0;c[p>>2]=p;c[p+4>>2]=p;c[f>>2]=p;p=xCi(8)|0;c[p>>2]=p;c[p+4>>2]=p;c[v+24>>2]=p;w=p}else w=c[v+24>>2]|0;if((b|0)==(w|0)){i=e;return}v=c[b>>2]|0;p=b+4|0;if(v){c[v+4>>2]=c[p>>2];c[c[p>>2]>>2]=v;c[b>>2]=0;c[p>>2]=0}v=c[w>>2]|0;c[b>>2]=v;c[p>>2]=w;c[v+4>>2]=b;c[c[p>>2]>>2]=b;i=e;return}function ykc(){return c[144392]|0}function zkc(){return c[144394]|0}function Akc(){return c[144396]|0}function Bkc(){return c[144398]|0}function Ckc(){var a=0,b=0,d=0;a=i;b=xCi(16)|0;d=b+8|0;c[d>>2]=0;c[b+12>>2]=0;c[b+4>>2]=d;c[b>>2]=577824;c[144392]=b;b=xCi(16)|0;d=b+8|0;c[d>>2]=0;c[b+12>>2]=0;c[b+4>>2]=d;c[b>>2]=577800;c[144394]=b;b=xCi(16)|0;d=b+8|0;c[d>>2]=0;c[b+12>>2]=0;c[b+4>>2]=d;c[b>>2]=577776;c[144396]=b;b=xCi(16)|0;d=b+8|0;c[d>>2]=0;c[b+12>>2]=0;c[b+4>>2]=d;c[b>>2]=577752;c[144398]=b;i=a;return}function Dkc(){var a=0,b=0;a=i;b=c[144392]|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);b=c[144394]|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);b=c[144396]|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);b=c[144398]|0;if(!b){i=a;return}ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=a;return}function Ekc(){var a=0;a=i;QQb(8,122,123,0,124);i=a;return}function Fkc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(2)|0))uUb();rri(b,2444312,9);wQb(8,2,b,32,2615,1,0);xri(b);i=a;return}function Gkc(a){a=a|0;return 8}function Hkc(a,b){a=a|0;b=b|0;var d=0;d=i;hTb(a,b);add(b,667608,c[142302]|0,a+28|0,257);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function Ikc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;iTb(b,d);g=b+28|0;b=qdd(d,667608,c[142302]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){h=c[f>>2]|0;if(h)_n[h&4095](g,d)|0}else{h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[l>>0]|0;c[h>>2]=(c[h>>2]|0)+1;break}Bid(h,g,1)}while(0);sdd(d);i=e;return}function Jkc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;jTb(b,d);f=b+28|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(b,f,1);Ndd(d);i=e;return}else{a[f>>0]=a[g>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Ndd(d);i=e;return}}function Kkc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;kTb(b,d);f=b+28|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(b,f,1);Mdd(d);i=e;return}else{a[f>>0]=a[g>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Mdd(d);i=e;return}}function Lkc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;lTb(b,d);f=b+28|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0<(c[d+20>>2]|0)>>>0){a[g>>0]=a[f>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Tdd(d);i=e;return}else{Gid(b,f,1);Tdd(d);i=e;return}}function Mkc(a,b){a=a|0;b=b|0;var c=0;c=i;mTb(a,b);i=c;return}function Nkc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;c[a>>2]=577552;d=a+4|0;e=c[d>>2]|0;f=a+8|0;if((e|0)!=(f|0)){g=e;while(1){e=c[g+20>>2]|0;if(e)ACi(e);e=c[g+24>>2]|0;if(e)ACi(e);e=c[g+4>>2]|0;if(!e){h=g;while(1){j=c[h+8>>2]|0;if((c[j>>2]|0)==(h|0)){k=j;break}else h=j}}else{h=e;while(1){j=c[h>>2]|0;if(!j){k=h;break}else h=j}}if((k|0)==(f|0))break;else g=k}}Pkc(d,c[a+8>>2]|0);c[a+12>>2]=0;c[d>>2]=f;c[f>>2]=0;Pkc(d,0);i=b;return}function Okc(a,b){a=a|0;b=b|0;return 0}function Pkc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Pkc(a,c[b>>2]|0);Pkc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Qkc(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);i=b;return}function Rkc(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);ACi(a);i=b;return}function Skc(a){a=a|0;var b=0;b=i;Nkc(a);ACi(a);i=b;return}function Tkc(a){a=a|0;var b=0;b=i;_kc(a);i=b;return}function Ukc(a){a=a|0;var b=0;b=i;Nkc(a);ACi(a);i=b;return}function Vkc(a){a=a|0;var b=0;b=i;$kc(a);i=b;return}function Wkc(a){a=a|0;var b=0;b=i;Nkc(a);ACi(a);i=b;return}function Xkc(a){a=a|0;var b=0;b=i;alc(a);i=b;return}function Ykc(a){a=a|0;var b=0;b=i;Nkc(a);ACi(a);i=b;return}function Zkc(a){a=a|0;var b=0;b=i;_kc(a);i=b;return}function _kc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b;e=a+4|0;f=c[e>>2]|0;g=a+8|0;if((f|0)==(g|0))h=f;else{a=f;while(1){f=c[a+20>>2]|0;j=c[a+24>>2]|0;k=j+4|0;l=c[k>>2]|0;if((l|0)!=(j|0)){m=c[f>>2]|0;c[m+4>>2]=l;c[f>>2]=c[j>>2];c[l>>2]=m;c[(c[f>>2]|0)+4>>2]=f;c[k>>2]=j;c[j>>2]=j}j=c[a+4>>2]|0;if(!j){k=a;while(1){f=c[k+8>>2]|0;if((c[f>>2]|0)==(k|0)){n=f;break}else k=f}}else{k=j;while(1){f=c[k>>2]|0;if(!f){n=k;break}else k=f}}if((n|0)==(g|0))break;else a=n}h=c[e>>2]|0}if((h|0)==(g|0)){i=b;return}e=d+4|0;n=d+8|0;a=d+12|0;k=h;while(1){h=c[k+20>>2]|0;c[d>>2]=d;c[e>>2]=d;c[n>>2]=h;c[a>>2]=0;j=c[h>>2]|0;c[h>>2]=d;c[d>>2]=j;j=h+4|0;f=c[j>>2]|0;c[j>>2]=c[e>>2];c[e>>2]=f;if((c[h>>2]|0)==(d|0))c[h>>2]=h;if((c[d>>2]|0)==(h|0))c[d>>2]=d;if((c[j>>2]|0)==(d|0)){c[j>>2]=h;o=c[e>>2]|0}else o=f;if((o|0)==(h|0))c[e>>2]=d;c[(c[h>>2]|0)+4>>2]=h;c[c[j>>2]>>2]=h;c[(c[d>>2]|0)+4>>2]=d;h=c[e>>2]|0;c[h>>2]=d;j=h;while(1){if((j|0)==(d|0)){p=27;break}c[a>>2]=j;h=c[j>>2]|0;if(h){f=j+4|0;c[h+4>>2]=c[f>>2];c[c[f>>2]>>2]=h;c[j>>2]=0;c[f>>2]=0}f=c[n>>2]|0;if((j|0)!=(f|0)){h=j+4|0;m=c[f>>2]|0;c[j>>2]=m;c[h>>2]=f;c[m+4>>2]=j;c[c[h>>2]>>2]=j}if(!j)break;h=c[j+8>>2]|0;ko[c[(c[h>>2]|0)+108>>2]&4095](h);j=c[e>>2]|0}if((p|0)==27){p=0;c[a>>2]=0}c[e>>2]=0;c[d>>2]=0;j=c[k+4>>2]|0;if(!j){h=k;while(1){m=c[h+8>>2]|0;if((c[m>>2]|0)==(h|0)){q=m;break}else h=m}}else{h=j;while(1){m=c[h>>2]|0;if(!m){q=h;break}else h=m}}if((q|0)==(g|0))break;else k=q}i=b;return}function $kc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b;e=a+4|0;f=c[e>>2]|0;g=a+8|0;if((f|0)==(g|0))h=f;else{a=f;while(1){f=c[a+20>>2]|0;j=c[a+24>>2]|0;k=j+4|0;l=c[k>>2]|0;if((l|0)!=(j|0)){m=c[f>>2]|0;c[m+4>>2]=l;c[f>>2]=c[j>>2];c[l>>2]=m;c[(c[f>>2]|0)+4>>2]=f;c[k>>2]=j;c[j>>2]=j}j=c[a+4>>2]|0;if(!j){k=a;while(1){f=c[k+8>>2]|0;if((c[f>>2]|0)==(k|0)){n=f;break}else k=f}}else{k=j;while(1){f=c[k>>2]|0;if(!f){n=k;break}else k=f}}if((n|0)==(g|0))break;else a=n}h=c[e>>2]|0}if((h|0)==(g|0)){i=b;return}e=d+4|0;n=d+8|0;a=d+12|0;k=h;while(1){h=c[k+20>>2]|0;c[d>>2]=d;c[e>>2]=d;c[n>>2]=h;c[a>>2]=0;j=c[h>>2]|0;c[h>>2]=d;c[d>>2]=j;j=h+4|0;f=c[j>>2]|0;c[j>>2]=c[e>>2];c[e>>2]=f;if((c[h>>2]|0)==(d|0))c[h>>2]=h;if((c[d>>2]|0)==(h|0))c[d>>2]=d;if((c[j>>2]|0)==(d|0)){c[j>>2]=h;o=c[e>>2]|0}else o=f;if((o|0)==(h|0))c[e>>2]=d;c[(c[h>>2]|0)+4>>2]=h;c[c[j>>2]>>2]=h;c[(c[d>>2]|0)+4>>2]=d;h=c[e>>2]|0;c[h>>2]=d;j=h;while(1){if((j|0)==(d|0)){p=27;break}c[a>>2]=j;h=c[j>>2]|0;if(h){f=j+4|0;c[h+4>>2]=c[f>>2];c[c[f>>2]>>2]=h;c[j>>2]=0;c[f>>2]=0}f=c[n>>2]|0;if((j|0)!=(f|0)){h=j+4|0;m=c[f>>2]|0;c[j>>2]=m;c[h>>2]=f;c[m+4>>2]=j;c[c[h>>2]>>2]=j}if(!j)break;h=c[j+8>>2]|0;ko[c[(c[h>>2]|0)+116>>2]&4095](h);j=c[e>>2]|0}if((p|0)==27){p=0;c[a>>2]=0}c[e>>2]=0;c[d>>2]=0;j=c[k+4>>2]|0;if(!j){h=k;while(1){m=c[h+8>>2]|0;if((c[m>>2]|0)==(h|0)){q=m;break}else h=m}}else{h=j;while(1){m=c[h>>2]|0;if(!m){q=h;break}else h=m}}if((q|0)==(g|0))break;else k=q}i=b;return}function alc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b;e=a+4|0;f=c[e>>2]|0;g=a+8|0;if((f|0)==(g|0))h=f;else{a=f;while(1){f=c[a+20>>2]|0;j=c[a+24>>2]|0;k=j+4|0;l=c[k>>2]|0;if((l|0)!=(j|0)){m=c[f>>2]|0;c[m+4>>2]=l;c[f>>2]=c[j>>2];c[l>>2]=m;c[(c[f>>2]|0)+4>>2]=f;c[k>>2]=j;c[j>>2]=j}j=c[a+4>>2]|0;if(!j){k=a;while(1){f=c[k+8>>2]|0;if((c[f>>2]|0)==(k|0)){n=f;break}else k=f}}else{k=j;while(1){f=c[k>>2]|0;if(!f){n=k;break}else k=f}}if((n|0)==(g|0))break;else a=n}h=c[e>>2]|0}if((h|0)==(g|0)){i=b;return}e=d+4|0;n=d+8|0;a=d+12|0;k=h;while(1){h=c[k+20>>2]|0;c[d>>2]=d;c[e>>2]=d;c[n>>2]=h;c[a>>2]=0;j=c[h>>2]|0;c[h>>2]=d;c[d>>2]=j;j=h+4|0;f=c[j>>2]|0;c[j>>2]=c[e>>2];c[e>>2]=f;if((c[h>>2]|0)==(d|0))c[h>>2]=h;if((c[d>>2]|0)==(h|0))c[d>>2]=d;if((c[j>>2]|0)==(d|0)){c[j>>2]=h;o=c[e>>2]|0}else o=f;if((o|0)==(h|0))c[e>>2]=d;c[(c[h>>2]|0)+4>>2]=h;c[c[j>>2]>>2]=h;c[(c[d>>2]|0)+4>>2]=d;h=c[e>>2]|0;c[h>>2]=d;j=h;while(1){if((j|0)==(d|0)){p=27;break}c[a>>2]=j;h=c[j>>2]|0;if(h){f=j+4|0;c[h+4>>2]=c[f>>2];c[c[f>>2]>>2]=h;c[j>>2]=0;c[f>>2]=0}f=c[n>>2]|0;if((j|0)!=(f|0)){h=j+4|0;m=c[f>>2]|0;c[j>>2]=m;c[h>>2]=f;c[m+4>>2]=j;c[c[h>>2]>>2]=j}if(!j)break;h=c[j+8>>2]|0;ko[c[(c[h>>2]|0)+112>>2]&4095](h);j=c[e>>2]|0}if((p|0)==27){p=0;c[a>>2]=0}c[e>>2]=0;c[d>>2]=0;j=c[k+4>>2]|0;if(!j){h=k;while(1){m=c[h+8>>2]|0;if((c[m>>2]|0)==(h|0)){q=m;break}else h=m}}else{h=j;while(1){m=c[h>>2]|0;if(!m){q=h;break}else h=m}}if((q|0)==(g|0))break;else k=q}i=b;return}function blc(a){a=a|0;var b=0;b=i;clc(a);fSb(a);i=b;return}function clc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+24|0;g=c[f>>2]|0;h=a+28|0;if((g|0)==(h|0)){j=a+28|0;k=c[j>>2]|0;llc(f,k);l=a+32|0;c[l>>2]=0;c[f>>2]=h;c[h>>2]=0;i=b;return}m=g;while(1){if((c[m+52>>2]&64|0)!=0?(c[e>>2]=c[m+48>>2],g=c[137784]|0,(g|0)!=0):0){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);n=c[d>>2]|0;o=c[g+28>>2]|0;if((n|0)==-1){p=o+(c[g+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((p|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[p+4>>2]|0,(g|0)!=0):0)In[c[m+40>>2]&4095](g,c[m+36>>2]|0)}g=c[m+44>>2]|0;if(g)ko[g&4095](c[m+36>>2]|0);g=c[m+4>>2]|0;if(!g){n=m;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){q=o;break}else n=o}}else{n=g;while(1){o=c[n>>2]|0;if(!o){q=n;break}else n=o}}if((q|0)==(h|0))break;else m=q}j=a+28|0;k=c[j>>2]|0;llc(f,k);l=a+32|0;c[l>>2]=0;c[f>>2]=h;c[h>>2]=0;i=b;return}function dlc(b,d,e,f,j,k,l){b=b|0;d=d|0;e=ea(e);f=f|0;j=ea(j);k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;m=i;i=i+16|0;n=m;if(!(l&1))o=1797693134862315708145274.0e284;else o=+h[(jLc()|0)+24>>3];if(!(l&2))p=o;else{q=+h[(jLc()|0)+56>>3];p=q<o?q:o}if(!(l&3))r=+h[(jLc()|0)+88>>3];else r=p;p=+e+r;if(!(l&8))s=-1;else s=(c[(jLc()|0)+124>>2]|0)+1|0;t=j!=ea(0.0)&1;u=c[d>>2]|0;d=c[(rVb(8)|0)+40>>2]|0;v=rVb(8)|0;w=v+24|0;x=v+28|0;y=c[x>>2]|0;if(!y){z=x;A=x}else{B=y;while(1)if(p<+h[B+16>>3]){y=c[B>>2]|0;if(!y){z=B;A=B;break}else{B=y;continue}}else{y=B+4|0;C=c[y>>2]|0;if(!C){z=y;A=B;break}else{B=C;continue}}}B=xCi(64)|0;h[B+16>>3]=p;c[B+24>>2]=s;g[B+28>>2]=j;a[B+32>>0]=t;t=B+33|0;a[t+0>>0]=a[n+0>>0]|0;a[t+1>>0]=a[n+1>>0]|0;a[t+2>>0]=a[n+2>>0]|0;c[B+36>>2]=f;c[B+40>>2]=b;c[B+44>>2]=k;c[B+48>>2]=u;u=B+52|0;c[u>>2]=l;c[u+4>>2]=d;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=A;c[z>>2]=B;A=c[c[w>>2]>>2]|0;if(!A){D=B;E=c[x>>2]|0;GN(E,D);F=v+32|0;G=c[F>>2]|0;H=G+1|0;c[F>>2]=H;i=m;return}c[w>>2]=A;D=c[z>>2]|0;E=c[x>>2]|0;GN(E,D);F=v+32|0;G=c[F>>2]|0;H=G+1|0;c[F>>2]=H;i=m;return}function elc(){var a=0,b=0;a=i;b=rVb(8)|0;i=a;return b|0}function flc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g+4|0;j=g;k=c[a+24>>2]|0;l=a+28|0;if((k|0)==(l|0)){i=g;return}if(!e){m=k;while(1){n=c[m+4>>2]|0;if(!n){o=m;while(1){p=c[o+8>>2]|0;if((c[p>>2]|0)==(o|0)){q=p;break}else o=p}}else{o=n;while(1){p=c[o>>2]|0;if(!p){q=o;break}else o=p}}o=m+16|0;if((c[m+48>>2]|0)==(c[b>>2]|0)?(c[m+40>>2]|0)==(d|0):0){c[j>>2]=m;c[h+0>>2]=c[j+0>>2];mlc(a,o,h)}if((q|0)==(l|0))break;else m=q}i=g;return}else r=k;while(1){k=c[r+4>>2]|0;if(!k){q=r;while(1){m=c[q+8>>2]|0;if((c[m>>2]|0)==(q|0)){s=m;break}else q=m}}else{q=k;while(1){m=c[q>>2]|0;if(!m){s=q;break}else q=m}}q=r+16|0;if(((c[r+48>>2]|0)==(c[b>>2]|0)?(c[r+40>>2]|0)==(d|0):0)?_n[e&4095](c[r+36>>2]|0,f)|0:0){c[j>>2]=r;c[h+0>>2]=c[j+0>>2];mlc(a,q,h)}if((s|0)==(l|0))break;else r=s}i=g;return}function glc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[a+24>>2]|0;k=a+28|0;if((j|0)==(k|0)){i=f;return}l=j;while(1){j=c[l+4>>2]|0;if(!j){m=l;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){o=n;break}else m=n}}else{m=j;while(1){n=c[m>>2]|0;if(!n){o=m;break}else m=n}}m=l+16|0;if((c[l+48>>2]|0)==(c[b>>2]|0)?(j=c[l+40>>2]|0,(j|0)==(d|0)|(j|0)==(e|0)):0){c[h>>2]=l;c[g+0>>2]=c[h+0>>2];mlc(a,m,g)}if((o|0)==(k|0))break;else l=o}i=f;return}function hlc(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+32|0;f=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;n=+h[(jLc()|0)+88>>3];o=c[(jLc()|0)+124>>2]|0;p=b+24|0;q=c[p>>2]|0;r=b+40|0;c[r>>2]=(c[r>>2]|0)+1;s=b+28|0;if((q|0)==(s|0)){i=e;return}t=b+36|0;u=b+28|0;v=b+32|0;w=q;while(1){q=w+16|0;if(!(+h[q>>3]<=n)){x=34;break}c[t>>2]=w;y=c[w+4>>2]|0;if(!y){z=w;while(1){A=c[z+8>>2]|0;if((c[A>>2]|0)==(z|0)){B=A;break}else z=A}}else{z=y;while(1){A=c[z>>2]|0;if(!A){B=z;break}else z=A}}c[t>>2]=B;z=w+52|0;do if(((c[z>>2]&d|0)!=0?(c[w+56>>2]|0)!=(c[r>>2]|0):0)?(y=w+24|0,(c[y>>2]|0)<=(o|0)):0){A=w+48|0;c[j>>2]=c[A>>2];C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(f,C,j);D=c[f>>2]|0;E=c[C+28>>2]|0;if((D|0)==-1){F=E+(c[C+32>>2]<<3)|0;break}else{F=E+(D<<3)|0;break}}else F=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((F|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[F+4>>2]|0,(C|0)!=0):0){D=c[w+36>>2]|0;E=c[w+40>>2]|0;if(!(a[w+32>>0]|0)){G=c[w+44>>2]|0;c[k>>2]=w;c[f+0>>2]=c[k+0>>2];nlc(b,q,f);In[E&4095](C,D);if(!G)break;ko[G&4095](D);break}H=+ea(g[w+28>>2]);h[q>>3]=+h[q>>3]+H;if(c[z>>2]&8)c[y>>2]=(c[(jLc()|0)+124>>2]|0)+1;G=c[u>>2]|0;if(!G){I=s;J=s}else{H=+h[q>>3];K=G;while(1)if(H<+h[K+16>>3]){G=c[K>>2]|0;if(!G){I=K;J=K;break}else{K=G;continue}}else{G=K+4|0;L=c[G>>2]|0;if(!L){I=G;J=K;break}else{K=L;continue}}}K=xCi(64)|0;y=K+16|0;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];c[y+24>>2]=c[q+24>>2];c[y+28>>2]=c[q+28>>2];c[K+48>>2]=c[A>>2];y=z;L=c[y+4>>2]|0;G=K+52|0;c[G>>2]=c[y>>2];c[G+4>>2]=L;c[K>>2]=0;c[K+4>>2]=0;c[K+8>>2]=J;c[I>>2]=K;L=c[c[p>>2]>>2]|0;if(!L)M=K;else{c[p>>2]=L;M=c[I>>2]|0}GN(c[u>>2]|0,M);c[v>>2]=(c[v>>2]|0)+1;c[l>>2]=w;c[f+0>>2]=c[l+0>>2];nlc(b,q,f);In[E&4095](C,D);break}}c[m>>2]=w;c[f+0>>2]=c[m+0>>2];mlc(b,q,f)}while(0);w=c[t>>2]|0;if((w|0)==(s|0)){x=34;break}}if((x|0)==34){i=e;return}}function ilc(){var a=0;a=i;QQb(98,125,0,0,0);i=a;return}function jlc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,577952,18);wQb(98,6,b,44,2616,0,0);xri(b);i=a;return}function klc(a){a=a|0;return 98}function llc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{llc(a,c[b>>2]|0);llc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function mlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[b+28>>2]|0;g=c[b+20>>2]|0;b=a+36|0;h=c[b>>2]|0;j=c[d>>2]|0;if((h|0)==(j|0)){d=c[h+4>>2]|0;k=(d|0)==0;if(k){l=h;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=d;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}c[b>>2]=n;if(k){k=h;while(1){n=c[k+8>>2]|0;if((c[n>>2]|0)==(k|0)){o=n;break}else k=n}}else{k=d;while(1){d=c[k>>2]|0;if(!d){o=k;break}else k=d}}k=a+24|0;if((c[k>>2]|0)==(h|0))c[k>>2]=o;o=a+32|0;c[o>>2]=(c[o>>2]|0)+-1;tYb(c[a+28>>2]|0,h);ACi(h)}else{h=c[j+4>>2]|0;if(!h){o=j;while(1){k=c[o+8>>2]|0;if((c[k>>2]|0)==(o|0)){p=k;break}else o=k}}else{o=h;while(1){h=c[o>>2]|0;if(!h){p=o;break}else o=h}}o=a+24|0;if((c[o>>2]|0)==(j|0))c[o>>2]=p;p=a+32|0;c[p>>2]=(c[p>>2]|0)+-1;tYb(c[a+28>>2]|0,j);ACi(j)}if(!f){i=e;return}ko[f&4095](g);i=e;return}function nlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;e=a+36|0;f=c[e>>2]|0;g=c[d>>2]|0;if((f|0)!=(g|0)){d=c[g+4>>2]|0;if(!d){h=g;while(1){j=c[h+8>>2]|0;if((c[j>>2]|0)==(h|0)){k=j;break}else h=j}}else{h=d;while(1){d=c[h>>2]|0;if(!d){k=h;break}else h=d}}h=a+24|0;if((c[h>>2]|0)==(g|0))c[h>>2]=k;k=a+32|0;c[k>>2]=(c[k>>2]|0)+-1;tYb(c[a+28>>2]|0,g);ACi(g);i=b;return}g=c[f+4>>2]|0;k=(g|0)==0;if(k){h=f;while(1){d=c[h+8>>2]|0;if((c[d>>2]|0)==(h|0)){l=d;break}else h=d}}else{h=g;while(1){d=c[h>>2]|0;if(!d){l=h;break}else h=d}}c[e>>2]=l;if(k){k=f;while(1){l=c[k+8>>2]|0;if((c[l>>2]|0)==(k|0)){m=l;break}else k=l}}else{k=g;while(1){g=c[k>>2]|0;if(!g){m=k;break}else k=g}}k=a+24|0;if((c[k>>2]|0)==(f|0))c[k>>2]=m;m=a+32|0;c[m>>2]=(c[m>>2]|0)+-1;tYb(c[a+28>>2]|0,f);ACi(f);i=b;return}function olc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(44,e,1,16,3653512,24)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];jSb(g,e,b);c[g>>2]=577848;b=g+28|0;c[b>>2]=0;c[g+32>>2]=0;c[g+24>>2]=b;c[g+40>>2]=0;c[g+36>>2]=b;i=d;return g|0}function plc(a){a=a|0;var b=0;b=i;c[a>>2]=577848;llc(a+24|0,c[a+28>>2]|0);ZSb(a);i=b;return}function qlc(a){a=a|0;var b=0;b=i;c[a>>2]=577848;llc(a+24|0,c[a+28>>2]|0);ZSb(a);ACi(a);i=b;return}function rlc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=(c[a+8>>2]|0)>>>21;c[f>>2]=c[153106];c[e+0>>2]=c[f+0>>2];f=yQb(h,0,e,2)|0;if((f|0)!=0?(e=(da(c[137788]|0,(c[f+8>>2]|0)>>>21)|0)+114|0,h=e>>5,(1<<e-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]|0)!=0):0)R9c(f,a);h=c[f+4>>2]|0;c[g>>2]=c[a+4>>2];c[g+4>>2]=h;h=b+8|0;a=c[h>>2]|0;if((a|0)==(c[b+12>>2]|0)){wlc(b+4|0,g);i=d;return}if(!a)j=0;else{b=g;g=c[b+4>>2]|0;f=a;c[f>>2]=c[b>>2];c[f+4>>2]=g;j=c[h>>2]|0}c[h>>2]=j+8;i=d;return}function slc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+8|0;k=e;c[h>>2]=c[153106];c[f+0>>2]=c[h+0>>2];h=yQb(1,0,f,2)|0;l=d+4|0;m=c[h+4>>2]|0;c[j>>2]=c[a+4>>2];c[j+4>>2]=m;m=d+8|0;n=c[m>>2]|0;o=d+12|0;if((n|0)==(c[o>>2]|0))wlc(l,j);else{if(!n)p=0;else{q=j;j=c[q+4>>2]|0;r=n;c[r>>2]=c[q>>2];c[r+4>>2]=j;p=c[m>>2]|0}c[m>>2]=p+8}ZTb(a,h);p=h+24|0;j=a+32|0;r=c[j>>2]|0;q=h+32|0;c[q>>2]=r;n=h+36|0;s=c[n>>2]|0;do if((s&2147483647)>>>0<r>>>0)if((s|0)>-1){c[n>>2]=r;t=c[p>>2]|0;c[g>>2]=c[h+28>>2];c[f+0>>2]=c[g+0>>2];c[p>>2]=hOb(t,r<<3,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[h+28>>2];c[f+0>>2]=c[g+0>>2];t=cOb(r<<3,4,f,0,3653512,352)|0;YEi(t|0,c[p>>2]|0,c[q>>2]<<3|0)|0;c[n>>2]=r;c[p>>2]=t;break}while(0);if(c[j>>2]|0){r=a+24|0;a=k+4|0;n=0;do{q=c[(c[r>>2]|0)+(n<<3)+4>>2]|0;s=(c[q+8>>2]|0)>>>21;c[g>>2]=c[153106];c[f+0>>2]=c[g+0>>2];t=yQb(s,0,f,2)|0;if((t|0)!=0?(s=(da(c[137788]|0,(c[t+8>>2]|0)>>>21)|0)+114|0,u=s>>5,(1<<s-(u<<5)&c[(c[137786]|0)+(u<<2)>>2]|0)!=0):0)R9c(t,q);u=c[p>>2]|0;c[u+(n<<3)>>2]=c[(c[r>>2]|0)+(n<<3)>>2];c[u+(n<<3)+4>>2]=t;c[t+24>>2]=h;u=c[t+4>>2]|0;c[k>>2]=c[q+4>>2];c[a>>2]=u;u=c[m>>2]|0;if((u|0)==(c[o>>2]|0))wlc(l,k);else{if(!u)v=0;else{q=k;t=c[q+4>>2]|0;s=u;c[s>>2]=c[q>>2];c[s+4>>2]=t;v=c[m>>2]|0}c[m>>2]=v+8}n=n+1|0}while(n>>>0<(c[j>>2]|0)>>>0)}if(!b){w=0;i=e;return w|0}j=BTb(h)|0;h=j+140|0;pHc(j,b);n=b+148|0;v=c[n>>2]|0;m=j+148|0;c[m>>2]=v;k=j+152|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<v>>>0)if((l|0)>-1){c[k>>2]=v;o=c[h>>2]|0;c[g>>2]=c[j+144>>2];c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(o,v<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[j+144>>2];c[f+0>>2]=c[g+0>>2];o=cOb(v<<2,4,f,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,c[m>>2]<<2|0)|0;c[k>>2]=v;c[h>>2]=o;break}while(0);if(!(c[n>>2]|0)){w=j;i=e;return w|0}v=b+140|0;b=0;do{k=c[(c[v>>2]|0)+(b<<2)>>2]|0;m=slc(c[k+24>>2]|0,k,d)|0;c[m+156>>2]=j;c[(c[h>>2]|0)+(b<<2)>>2]=m;b=b+1|0}while(b>>>0<(c[n>>2]|0)>>>0);w=j;i=e;return w|0}function tlc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;g=e+4|0;h=d+12|0;j=d+4|0;k=c[j>>2]|0;if((c[h>>2]|0)-k>>3>>>0<64?(l=d+8|0,m=(c[l>>2]|0)-k>>3,c[g>>2]=89,c[f+0>>2]=c[g+0>>2],k=cOb(512,16,f,0,3653512,80)|0,n=c[j>>2]|0,o=(c[l>>2]|0)-n|0,p=k+(m-(o>>3)<<3)|0,YEi(p|0,n|0,o|0)|0,o=c[j>>2]|0,c[j>>2]=p,c[l>>2]=k+(m<<3),c[h>>2]=k+512,(o|0)!=0):0){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f)}o=da(c[137788]|0,(c[b+8>>2]|0)>>>21)|0;g=o+1|0;k=g>>5;h=c[137786]|0;m=(1<<g-(k<<5)&c[h+(k<<2)>>2]|0)==0?0:b;k=o+2|0;o=k>>5;if(!(1<<k-(o<<5)&c[h+(o<<2)>>2]))q=m;else{o=c[b+24>>2]|0;q=(o|0)==0?m:o}if(!q){rlc(b,d);r=c[j>>2]|0;s=d+8|0;t=c[s>>2]|0;u=a[d>>0]|0;a[f>>0]=u;xlc(r,t,f);i=e;return}else{slc(q,BTb(q)|0,d)|0;r=c[j>>2]|0;s=d+8|0;t=c[s>>2]|0;u=a[d>>0]|0;a[f>>0]=u;xlc(r,t,f);i=e;return}}function ulc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+176|0;d=b+168|0;e=b+160|0;f=b+156|0;g=b+152|0;h=b+8|0;j=b;c[j>>2]=c[153134];c[d+0>>2]=c[j+0>>2];eed(h,d);j=a+8|0;k=a+4|0;fed(h,(c[j>>2]|0)-(c[k>>2]|0)>>3);a=c[k>>2]|0;if((a|0)!=(c[j>>2]|0)){k=a;do{a=k+4|0;l=c[a>>2]|0;c[f>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(d,m,f);n=c[d>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[p+4>>2]|0,(m|0)!=0):0)q=m;else r=11}else r=11;if((r|0)==11){r=0;q=hQb(l)|0}In[c[(c[q>>2]|0)+44>>2]&4095](q,0);m=c[a>>2]|0;c[e>>2]=m;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,e);o=c[d>>2]|0;s=c[n+28>>2]|0;if((o|0)==-1){t=s+(c[n+32>>2]<<3)|0;break}else{t=s+(o<<3)|0;break}}else t=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((t|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[t+4>>2]|0,(n|0)!=0):0)u=n;else r=20}else r=20;if((r|0)==20){r=0;u=hQb(m)|0}hed(h,u,0,0,-1);k=k+8|0}while((k|0)!=(c[j>>2]|0))}ped(h,4,0);j=h+144|0;do{k=j;j=j+-16|0;if((c[k+-4>>2]|0)>-1){u=c[j>>2]|0;c[g>>2]=c[k+-12>>2];c[d+0>>2]=c[g+0>>2];eOb(u,d);c[j>>2]=0}}while((j|0)!=(h|0));i=b;return}function vlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;h=d;j=g+4|0;c[j>>2]=0;k=g+8|0;c[k>>2]=0;c[g+12>>2]=0;l=ylc(b,g)|0;if(l){b=c[l>>2]|0;m=c[b+36>>2]|0;Nsd(h,mo[c[b+32>>2]&4095](l)|0,577976);if(!(a[h>>0]&1))n=h+1|0;else n=c[h+8>>2]|0;In[m&4095](l,n);xri(h)}ulc(g);g=c[j>>2]|0;if(!g){i=d;return l|0}j=c[k>>2]|0;if((j|0)!=(g|0))c[k>>2]=j+(~((j+-8-g|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return l|0}function wlc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>3)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>3>>>0<1073741823){m=h>>2;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>3;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>3;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<3,16,e,0,3653512,80)|0;p=r}r=o+(p<<3)|0;if(r){q=b;b=c[q+4>>2]|0;s=r;c[s>>2]=c[q>>2];c[s+4>>2]=b}b=c[a>>2]|0;s=(c[g>>2]|0)-b|0;q=o+(p-(s>>3)<<3)|0;YEi(q|0,b|0,s|0)|0;s=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<3);c[k>>2]=o+(n<<3);if(!s){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function xlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-8|0;h=a+-4|0;j=f;b:while(1){k=j;l=b-k|0;m=l>>3;switch(m|0){case 5:{n=j;o=a;p=h;q=15;break a;break}case 3:{r=j;s=a;t=h;q=6;break a;break}case 4:{u=j;v=g;q=14;break a;break}case 2:{w=j;x=a;y=h;q=4;break a;break}case 1:case 0:{q=70;break a;break}default:{}}if((l|0)<56){z=j;A=a;q=21;break a}B=(m|0)/2|0;C=j+(B<<3)|0;do if((l|0)>7992){D=(m|0)/4|0;E=j+(D<<3)|0;F=D+B|0;G=j+(F<<3)|0;H=Ilc(j,E,C,G,d)|0;I=c[g>>2]|0;J=c[G>>2]|0;if((I|0)>=(J|0)){K=C;L=H;break}c[G>>2]=I;c[g>>2]=J;J=j+(F<<3)+4|0;F=c[J>>2]|0;c[J>>2]=c[h>>2];c[h>>2]=F;F=H+1|0;I=c[G>>2]|0;M=c[C>>2]|0;if((I|0)<(M|0)){c[C>>2]=I;c[G>>2]=M;M=j+(B<<3)+4|0;G=c[M>>2]|0;c[M>>2]=c[J>>2];c[J>>2]=G;G=H+2|0;J=c[C>>2]|0;I=c[E>>2]|0;if((J|0)<(I|0)){c[E>>2]=J;c[C>>2]=I;I=j+(D<<3)+4|0;D=c[I>>2]|0;c[I>>2]=c[M>>2];c[M>>2]=D;D=c[E>>2]|0;M=c[j>>2]|0;if((D|0)<(M|0)){c[j>>2]=D;c[E>>2]=M;M=j+4|0;E=c[M>>2]|0;c[M>>2]=c[I>>2];c[I>>2]=E;K=C;L=H+4|0}else{K=C;L=H+3|0}}else{K=C;L=G}}else{K=C;L=F}}else{F=c[C>>2]|0;G=c[j>>2]|0;H=c[g>>2]|0;E=(H|0)<(F|0);if((F|0)>=(G|0)){if(!E){K=C;L=0;break}c[C>>2]=H;c[g>>2]=F;I=j+(B<<3)+4|0;M=c[I>>2]|0;c[I>>2]=c[h>>2];c[h>>2]=M;M=c[C>>2]|0;D=c[j>>2]|0;if((M|0)>=(D|0)){K=C;L=1;break}c[j>>2]=M;c[C>>2]=D;D=j+4|0;M=c[D>>2]|0;c[D>>2]=c[I>>2];c[I>>2]=M;K=C;L=2;break}if(E){c[j>>2]=H;c[g>>2]=G;H=j+4|0;E=c[H>>2]|0;c[H>>2]=c[h>>2];c[h>>2]=E;K=C;L=1;break}c[j>>2]=F;c[C>>2]=G;F=j+4|0;E=j+(B<<3)+4|0;H=c[F>>2]|0;c[F>>2]=c[E>>2];c[E>>2]=H;H=c[g>>2]|0;if((H|0)<(G|0)){c[C>>2]=H;c[g>>2]=G;G=c[E>>2]|0;c[E>>2]=c[h>>2];c[h>>2]=G;K=C;L=2}else{K=C;L=1}}while(0);B=c[j>>2]|0;m=c[K>>2]|0;do if((B|0)<(m|0)){N=g;O=L}else{l=a;G=g;while(1){E=l+-16|0;if((j|0)==(E|0))break;H=c[E>>2]|0;if((H|0)<(m|0)){P=E;Q=l;R=E;S=H;q=52;break}else{H=G;G=E;l=H}}if((q|0)==52){q=0;c[j>>2]=S;c[P>>2]=B;l=j+4|0;G=Q+-12|0;H=c[l>>2]|0;c[l>>2]=c[G>>2];c[G>>2]=H;N=R;O=L+1|0;break}H=j+8|0;G=c[g>>2]|0;if((B|0)<(G|0))T=H;else{if((H|0)==(g|0)){q=70;break a}else{U=j;V=H}while(1){H=c[V>>2]|0;l=U+16|0;if((B|0)<(H|0)){W=V;X=H;Y=V;break}if((l|0)==(g|0)){q=70;break a}else{H=V;V=l;U=H}}c[W>>2]=G;c[g>>2]=X;H=Y+4|0;l=c[H>>2]|0;c[H>>2]=c[h>>2];c[h>>2]=l;T=Y+8|0}if((T|0)==(g|0)){q=70;break a}else{Z=T;_=g}while(1){l=c[j>>2]|0;H=Z;while(1){E=c[H>>2]|0;F=H+8|0;if((l|0)<(E|0)){$=F;aa=H;ba=E;ca=H;break}else H=F}H=_;while(1){F=H+-8|0;E=c[F>>2]|0;if((l|0)<(E|0))H=F;else{da=F;ea=F;fa=E;ga=H;break}}if(ca>>>0>=da>>>0){j=ca;continue b}c[aa>>2]=fa;c[ea>>2]=ba;H=ca+4|0;l=ga+-4|0;E=c[H>>2]|0;c[H>>2]=c[l>>2];c[l>>2]=E;Z=$;_=da}}while(0);B=j+8|0;c:do if(B>>>0<N>>>0){m=B;G=N;E=C;l=O;while(1){H=c[E>>2]|0;F=m;while(1){M=c[F>>2]|0;I=F+8|0;if((M|0)<(H|0))F=I;else{ha=F;ia=M;ja=I;ka=F;break}}F=G;while(1){I=F+-8|0;M=c[I>>2]|0;if((M|0)<(H|0)){la=I;ma=I;na=M;oa=F;break}else F=I}if(ka>>>0>la>>>0){pa=ka;qa=E;ra=l;break c}c[ha>>2]=na;c[ma>>2]=ia;F=ka+4|0;H=oa+-4|0;I=c[F>>2]|0;c[F>>2]=c[H>>2];c[H>>2]=I;m=ja;G=la;E=(E|0)==(ka|0)?la:E;l=l+1|0}}else{pa=B;qa=C;ra=O}while(0);if((pa|0)!=(qa|0)?(C=c[qa>>2]|0,B=c[pa>>2]|0,(C|0)<(B|0)):0){c[pa>>2]=C;c[qa>>2]=B;B=pa+4|0;C=qa+4|0;l=c[B>>2]|0;c[B>>2]=c[C>>2];c[C>>2]=l;sa=ra+1|0}else sa=ra;if(!sa){ta=Klc(j,pa,d)|0;l=pa+8|0;if(Klc(l,a,d)|0){q=65;break}if(ta){j=l;continue}}l=pa;if((l-k|0)>=(b-l|0)){ua=j;va=pa;q=69;break}xlc(j,pa,d);j=pa+8|0}if((q|0)==65){q=0;if(ta){q=70;break}else{f=j;a=pa;continue}}else if((q|0)==69){q=0;xlc(va+8|0,a,d);f=ua;a=va;continue}}if((q|0)==4){va=x+-8|0;x=c[va>>2]|0;a=c[w>>2]|0;if((x|0)>=(a|0)){i=e;return}c[w>>2]=x;c[va>>2]=a;a=w+4|0;w=c[a>>2]|0;c[a>>2]=c[y>>2];c[y>>2]=w;i=e;return}else if((q|0)==6){w=r+8|0;y=c[w>>2]|0;a=c[r>>2]|0;va=s+-8|0;s=c[va>>2]|0;x=(s|0)<(y|0);if((y|0)>=(a|0)){if(!x){i=e;return}c[w>>2]=s;c[va>>2]=y;ua=r+12|0;f=c[ua>>2]|0;c[ua>>2]=c[t>>2];c[t>>2]=f;f=c[w>>2]|0;pa=c[r>>2]|0;if((f|0)>=(pa|0)){i=e;return}c[r>>2]=f;c[w>>2]=pa;pa=r+4|0;f=c[pa>>2]|0;c[pa>>2]=c[ua>>2];c[ua>>2]=f;i=e;return}if(x){c[r>>2]=s;c[va>>2]=a;s=r+4|0;x=c[s>>2]|0;c[s>>2]=c[t>>2];c[t>>2]=x;i=e;return}c[r>>2]=y;c[w>>2]=a;y=r+4|0;x=r+12|0;r=c[y>>2]|0;c[y>>2]=c[x>>2];c[x>>2]=r;r=c[va>>2]|0;if((r|0)>=(a|0)){i=e;return}c[w>>2]=r;c[va>>2]=a;a=c[x>>2]|0;c[x>>2]=c[t>>2];c[t>>2]=a;i=e;return}else if((q|0)==14){Ilc(u,u+8|0,u+16|0,v,d)|0;i=e;return}else if((q|0)==15){v=n+8|0;u=n+16|0;a=n+24|0;Ilc(n,v,u,a,d)|0;t=o+-8|0;o=c[t>>2]|0;x=c[a>>2]|0;if((o|0)>=(x|0)){i=e;return}c[a>>2]=o;c[t>>2]=x;x=n+28|0;t=c[x>>2]|0;c[x>>2]=c[p>>2];c[p>>2]=t;t=c[a>>2]|0;p=c[u>>2]|0;if((t|0)>=(p|0)){i=e;return}c[u>>2]=t;c[a>>2]=p;p=n+20|0;a=c[p>>2]|0;o=c[x>>2]|0;c[p>>2]=o;c[x>>2]=a;a=c[v>>2]|0;if((t|0)>=(a|0)){i=e;return}c[v>>2]=t;c[u>>2]=a;a=n+12|0;u=c[a>>2]|0;c[a>>2]=o;c[p>>2]=u;u=c[n>>2]|0;if((t|0)>=(u|0)){i=e;return}c[n>>2]=t;c[v>>2]=u;u=n+4|0;n=c[u>>2]|0;c[u>>2]=o;c[a>>2]=n;i=e;return}else if((q|0)==21){Jlc(z,A,d);i=e;return}else if((q|0)==70){i=e;return}}function ylc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+240|0;e=d+8|0;f=d+120|0;g=d+188|0;h=d;j=d+184|0;k=d+192|0;l=d+224|0;m=d+160|0;n=d+124|0;o=d+72|0;p=d+112|0;q=d+168|0;tlc(a,b);c[l>>2]=c[153134];c[e+0>>2]=c[l+0>>2];Llc(k,e);c[m>>2]=578040;c[m+4>>2]=b;hdd(n,16384,1);c[n+12>>2]=m;m=b+4|0;l=c[m>>2]|0;r=b+8|0;if((l|0)==(c[r>>2]|0)){s=l;t=l}else{b=o+4|0;u=o+12|0;v=o+16|0;w=o+20|0;x=o+24|0;y=o+28|0;z=o+32|0;A=o+36|0;B=p+4|0;C=k+24|0;D=k+4|0;E=e+4|0;F=e+12|0;G=e+8|0;H=k+16|0;I=l;while(1){l=c[I>>2]|0;c[g>>2]=l;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(e,J,g);K=c[e>>2]|0;L=c[J+28>>2]|0;if((K|0)==-1){M=L+(c[J+32>>2]<<3)|0;break}else{M=L+(K<<3)|0;break}}else M=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((M|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[M+4>>2]|0,(J|0)!=0):0)N=J;else O=11}else O=11;if((O|0)==11){O=0;N=hQb(l)|0}J=(c[N+8>>2]|0)>>>21;if(!((J|0)==1|(J|0)==4)){J=c[I+4>>2]|0;c[f>>2]=J;K=c[137784]|0;if(K){do if((c[K+36>>2]|0)!=(c[K+4>>2]|0)){fRb(e,K,f);L=c[e>>2]|0;P=c[K+28>>2]|0;if((L|0)==-1){Q=P+(c[K+32>>2]<<3)|0;break}else{Q=P+(L<<3)|0;break}}else Q=(c[K+28>>2]|0)+(c[K+32>>2]<<3)|0;while(0);K=c[137784]|0;if((Q|0)!=((c[K+28>>2]|0)+(c[K+32>>2]<<3)|0)?(K=c[Q+4>>2]|0,(K|0)!=0):0)R=K;else O=21}else O=21;if((O|0)==21){O=0;R=hQb(J)|0}c[o>>2]=0;c[b>>2]=0;c[u>>2]=0;c[v>>2]=0;c[w>>2]=0;c[x>>2]=-1;c[y>>2]=0;c[z>>2]=-2;c[A>>2]=0;c[p>>2]=-2;c[B>>2]=0;c[e+0>>2]=c[p+0>>2];c[e+4>>2]=c[p+4>>2];K=Sdd(o,16384,e)|0;Jid(K,k);In[c[(c[N>>2]|0)+64>>2]&4095](N,o);Iid(K)|0;_id(q,(c[C>>2]|0)==0?0:c[H>>2]|0,c[D>>2]|0,256);c[e>>2]=0;c[E>>2]=0;tid(F);c[G>>2]=VQb(R)|0;c[E>>2]=0;c[e>>2]=268451840;uid(F,q,0,Hid(K)|0);In[c[(c[R>>2]|0)+68>>2]&4095](R,e);wid(F)|0;In[c[(c[R>>2]|0)+72>>2]&4095](R,n);$id(q)}K=I+8|0;if((K|0)==(c[r>>2]|0)){S=K;break}else I=K}s=S;t=c[m>>2]|0}m=c[a+4>>2]|0;a=s-t>>3;if(!a)T=t;else{S=t;t=a;while(1){a=(t|0)/2|0;if((c[S+(a<<3)>>2]|0)<(m|0)){U=S+(a+1<<3)|0;V=t+-1-a|0}else{U=S;V=a}if(!V){T=U;break}else{S=U;t=V}}}if((T|0)==(s|0))W=s;else W=(m|0)<(c[T>>2]|0)?s:T;T=c[W+4>>2]|0;do if(!T)X=0;else{c[h>>2]=T;W=c[137784]|0;if(W){do if((c[W+36>>2]|0)!=(c[W+4>>2]|0)){fRb(e,W,h);s=c[e>>2]|0;m=c[W+28>>2]|0;if((s|0)==-1){Y=m+(c[W+32>>2]<<3)|0;break}else{Y=m+(s<<3)|0;break}}else Y=(c[W+28>>2]|0)+(c[W+32>>2]<<3)|0;while(0);W=c[137784]|0;if((Y|0)!=((c[W+28>>2]|0)+(c[W+32>>2]<<3)|0)?(W=c[Y+4>>2]|0,(W|0)!=0):0){X=W;break}}X=hQb(T)|0}while(0);T=c[n+16>>2]|0;if(!T){zlc(k);i=d;return X|0}Y=n+20|0;n=c[Y>>2]|0;if((n|0)!=(T|0))c[Y>>2]=n+(~((n+-4-T|0)>>>2)<<2);c[j>>2]=89;c[e+0>>2]=c[j+0>>2];eOb(T,e);zlc(k);i=d;return X|0}function zlc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=577992;g=a+16|0;h=c[g>>2]|0;j=a+24|0;if(!(c[j>>2]|0))k=h;else{l=a+12|0;m=h;do{h=c[m>>2]|0;c[f>>2]=c[l>>2];c[d+0>>2]=c[f+0>>2];eOb(h,d);m=m+4|0;h=c[g>>2]|0}while((m|0)!=(h+(c[j>>2]<<2)|0));k=h}if((c[a+28>>2]|0)<=-1){i=b;return}c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[g>>2]=0;i=b;return}function Alc(a){a=a|0;var b=0;b=i;zlc(a);ACi(a);i=b;return}function Blc(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+4>>2]=b;Mlc(a,(b>>>8)+1|0);i=d;return 1}function Clc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=b+1|0;h=c[a+24>>2]|0;Mlc(a,(g|0)<(h|0)?h:g);g=c[(c[a+16>>2]|0)+(b<<2)>>2]|0;c[d>>2]=g;c[e>>2]=g+256;g=a+8|0;c[g>>2]=(c[g>>2]|0)+1;i=f;return}function Dlc(a,b){a=a|0;b=b|0;b=a+8|0;c[b>>2]=(c[b>>2]|0)+-1;return}function Elc(a){a=a|0;return 256}function Flc(a,b){a=a|0;b=b|0;b=i;rri(a,2789160,12);i=b;return}function Glc(a){a=a|0;return c[a+4>>2]|0}function Hlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+4>>2]|0;a=c[e+4>>2]|0;f=c[e+8>>2]|0;e=f-a>>3;if(!e)g=a;else{h=a;a=e;while(1){e=(a|0)/2|0;if((c[h+(e<<3)>>2]|0)<(b|0)){j=h+(e+1<<3)|0;k=a+-1-e|0}else{j=h;k=e}if(!k){g=j;break}else{h=j;a=k}}}if((g|0)==(f|0)){l=b;i=d;return l|0}k=(c[g>>2]|0)>(b|0)?f:g;if((k|0)==(f|0)){l=b;i=d;return l|0}l=c[k+4>>2]|0;i=d;return l|0}function Ilc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=c[b>>2]|0;h=c[a>>2]|0;j=c[d>>2]|0;k=(j|0)<(g|0);do if((g|0)<(h|0)){if(k){c[a>>2]=j;c[d>>2]=h;l=a+4|0;m=d+4|0;n=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=n;o=1;break}c[a>>2]=g;c[b>>2]=h;n=a+4|0;m=b+4|0;l=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=l;l=c[d>>2]|0;n=c[b>>2]|0;if((l|0)<(n|0)){c[b>>2]=l;c[d>>2]=n;n=d+4|0;l=c[m>>2]|0;c[m>>2]=c[n>>2];c[n>>2]=l;o=2}else o=1}else if(k){c[b>>2]=j;c[d>>2]=g;l=b+4|0;n=d+4|0;m=c[l>>2]|0;c[l>>2]=c[n>>2];c[n>>2]=m;m=c[b>>2]|0;n=c[a>>2]|0;if((m|0)<(n|0)){c[a>>2]=m;c[b>>2]=n;n=a+4|0;m=c[n>>2]|0;c[n>>2]=c[l>>2];c[l>>2]=m;o=2}else o=1}else o=0;while(0);g=c[e>>2]|0;j=c[d>>2]|0;if((g|0)>=(j|0)){p=o;i=f;return p|0}c[d>>2]=g;c[e>>2]=j;j=d+4|0;g=e+4|0;e=c[j>>2]|0;c[j>>2]=c[g>>2];c[g>>2]=e;e=c[d>>2]|0;g=c[b>>2]|0;if((e|0)>=(g|0)){p=o+1|0;i=f;return p|0}c[b>>2]=e;c[d>>2]=g;g=b+4|0;d=c[g>>2]|0;c[g>>2]=c[j>>2];c[j>>2]=d;d=c[b>>2]|0;j=c[a>>2]|0;if((d|0)>=(j|0)){p=o+2|0;i=f;return p|0}c[a>>2]=d;c[b>>2]=j;j=a+4|0;a=c[j>>2]|0;c[j>>2]=c[g>>2];c[g>>2]=a;p=o+3|0;i=f;return p|0}function Jlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+16|0;f=a+8|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[e>>2]|0;k=(j|0)<(g|0);do if((g|0)<(h|0)){if(k){c[a>>2]=j;c[e>>2]=h;l=a+4|0;m=a+20|0;n=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=n;o=h;break}c[a>>2]=g;c[f>>2]=h;n=a+4|0;m=a+12|0;l=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=l;if((j|0)<(h|0)){c[f>>2]=j;c[e>>2]=h;n=a+20|0;c[m>>2]=c[n>>2];c[n>>2]=l;o=h}else o=j}else if(k){c[f>>2]=j;c[e>>2]=g;l=a+12|0;n=a+20|0;m=c[l>>2]|0;p=c[n>>2]|0;c[l>>2]=p;c[n>>2]=m;if((j|0)<(h|0)){c[a>>2]=j;c[f>>2]=h;m=a+4|0;n=c[m>>2]|0;c[m>>2]=p;c[l>>2]=n;o=g}else o=g}else o=j;while(0);j=a+24|0;if((j|0)==(b|0)){i=d;return}else{q=o;r=j;s=e}while(1){if((c[r>>2]|0)<(q|0)){e=r;j=c[e>>2]|0;o=c[e+4>>2]|0;e=q;g=r;h=s;while(1){c[g>>2]=e;f=h+4|0;c[g+4>>2]=c[f>>2];if((h|0)==(a|0)){t=h;u=f;break}k=h+-8|0;e=c[k>>2]|0;if((j|0)>=(e|0)){t=h;u=f;break}else{f=h;h=k;g=f}}c[t>>2]=j;c[u>>2]=o}g=r+8|0;if((g|0)==(b|0))break;h=r;q=c[r>>2]|0;r=g;s=h}i=d;return}function Klc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;switch(b-a>>3|0){case 5:{f=a+8|0;g=a+16|0;h=a+24|0;Ilc(a,f,g,h,d)|0;j=b+-8|0;k=c[j>>2]|0;l=c[h>>2]|0;if((k|0)>=(l|0)){m=1;i=e;return m|0}c[h>>2]=k;c[j>>2]=l;l=a+28|0;j=b+-4|0;k=c[l>>2]|0;c[l>>2]=c[j>>2];c[j>>2]=k;k=c[h>>2]|0;j=c[g>>2]|0;if((k|0)>=(j|0)){m=1;i=e;return m|0}c[g>>2]=k;c[h>>2]=j;j=a+20|0;h=c[j>>2]|0;n=c[l>>2]|0;c[j>>2]=n;c[l>>2]=h;h=c[f>>2]|0;if((k|0)>=(h|0)){m=1;i=e;return m|0}c[f>>2]=k;c[g>>2]=h;h=a+12|0;g=c[h>>2]|0;c[h>>2]=n;c[j>>2]=g;g=c[a>>2]|0;if((k|0)>=(g|0)){m=1;i=e;return m|0}c[a>>2]=k;c[f>>2]=g;g=a+4|0;f=c[g>>2]|0;c[g>>2]=n;c[h>>2]=f;m=1;i=e;return m|0}case 3:{f=a+8|0;h=c[f>>2]|0;n=c[a>>2]|0;g=b+-8|0;k=c[g>>2]|0;j=(k|0)<(h|0);if((h|0)>=(n|0)){if(!j){m=1;i=e;return m|0}c[f>>2]=k;c[g>>2]=h;l=a+12|0;o=b+-4|0;p=c[l>>2]|0;c[l>>2]=c[o>>2];c[o>>2]=p;p=c[f>>2]|0;o=c[a>>2]|0;if((p|0)>=(o|0)){m=1;i=e;return m|0}c[a>>2]=p;c[f>>2]=o;o=a+4|0;p=c[o>>2]|0;c[o>>2]=c[l>>2];c[l>>2]=p;m=1;i=e;return m|0}if(j){c[a>>2]=k;c[g>>2]=n;k=a+4|0;j=b+-4|0;p=c[k>>2]|0;c[k>>2]=c[j>>2];c[j>>2]=p;m=1;i=e;return m|0}c[a>>2]=h;c[f>>2]=n;h=a+4|0;p=a+12|0;j=c[h>>2]|0;c[h>>2]=c[p>>2];c[p>>2]=j;j=c[g>>2]|0;if((j|0)>=(n|0)){m=1;i=e;return m|0}c[f>>2]=j;c[g>>2]=n;n=b+-4|0;g=c[p>>2]|0;c[p>>2]=c[n>>2];c[n>>2]=g;m=1;i=e;return m|0}case 1:case 0:{m=1;i=e;return m|0}case 4:{Ilc(a,a+8|0,a+16|0,b+-8|0,d)|0;m=1;i=e;return m|0}case 2:{d=b+-8|0;g=c[d>>2]|0;n=c[a>>2]|0;if((g|0)>=(n|0)){m=1;i=e;return m|0}c[a>>2]=g;c[d>>2]=n;n=a+4|0;d=b+-4|0;g=c[n>>2]|0;c[n>>2]=c[d>>2];c[d>>2]=g;m=1;i=e;return m|0}default:{g=a+16|0;d=a+8|0;n=c[d>>2]|0;p=c[a>>2]|0;j=c[g>>2]|0;f=(j|0)<(n|0);do if((n|0)<(p|0)){if(f){c[a>>2]=j;c[g>>2]=p;h=a+4|0;k=a+20|0;l=c[h>>2]|0;c[h>>2]=c[k>>2];c[k>>2]=l;q=p;break}c[a>>2]=n;c[d>>2]=p;l=a+4|0;k=a+12|0;h=c[l>>2]|0;c[l>>2]=c[k>>2];c[k>>2]=h;if((j|0)<(p|0)){c[d>>2]=j;c[g>>2]=p;l=a+20|0;c[k>>2]=c[l>>2];c[l>>2]=h;q=p}else q=j}else if(f){c[d>>2]=j;c[g>>2]=n;h=a+12|0;l=a+20|0;k=c[h>>2]|0;o=c[l>>2]|0;c[h>>2]=o;c[l>>2]=k;if((j|0)<(p|0)){c[a>>2]=j;c[d>>2]=p;k=a+4|0;l=c[k>>2]|0;c[k>>2]=o;c[h>>2]=l;q=n}else q=n}else q=j;while(0);j=a+24|0;if((j|0)==(b|0)){m=1;i=e;return m|0}else{r=q;s=0;t=j;u=g}while(1){if((c[t>>2]|0)<(r|0)){g=t;j=c[g>>2]|0;q=c[g+4>>2]|0;g=r;n=t;p=u;while(1){c[n>>2]=g;d=p+4|0;c[n+4>>2]=c[d>>2];if((p|0)==(a|0)){v=p;w=d;break}f=p+-8|0;g=c[f>>2]|0;if((j|0)>=(g|0)){v=p;w=d;break}else{d=p;p=f;n=d}}c[v>>2]=j;c[w>>2]=q;n=s+1|0;if((n|0)==8){x=t;break}else y=n}else y=s;n=t+8|0;if((n|0)==(b|0)){m=1;z=35;break}p=t;r=c[t>>2]|0;s=y;t=n;u=p}if((z|0)==35){i=e;return m|0}m=(x+8|0)==(b|0);i=e;return m|0}}return 0}function Llc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=577992;g=c[b>>2]|0;c[a+12>>2]=g;b=a+16|0;c[b>>2]=0;c[a+20>>2]=g;c[a+24>>2]=0;c[a+28>>2]=256;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];c[b>>2]=hOb(0,1024,4,e,0,3653512,370)|0;c[a+4>>2]=0;c[a+8>>2]=0;i=d;return}function Mlc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;j=a+16|0;k=a+24|0;l=c[k>>2]|0;if(l>>>0>b>>>0){m=a+12|0;n=b;do{o=c[(c[j>>2]|0)+(n<<2)>>2]|0;c[g>>2]=c[m>>2];c[e+0>>2]=c[g+0>>2];eOb(o,e);n=n+1|0}while((n|0)!=(l|0))}n=a+28|0;g=c[n>>2]|0;m=g&2147483647;do if(m>>>0<b>>>0?(o=g<<1,m>>>0<o>>>0):0)if((g|0)>-1){c[n>>2]=o;p=c[j>>2]|0;c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(p,g<<3,4,e,0,3653512,370)|0;q=c[n>>2]|0;break}else{c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];p=cOb(g<<3,4,e,0,3653512,352)|0;YEi(p|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[n>>2]=o;c[j>>2]=p;q=o;break}else q=g;while(0);do if((q&2147483647)>>>0<b>>>0)if((q|0)>-1){c[n>>2]=b;g=c[j>>2]|0;c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(g,b<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];g=cOb(b<<2,4,e,0,3653512,352)|0;YEi(g|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[n>>2]=b;c[j>>2]=g;break}while(0);n=c[k>>2]|0;if(n>>>0<b>>>0?(f=c[j>>2]|0,q=f+(b<<2)|0,(n|0)!=(b|0)):0){g=f+(n<<2)|0;do{if(g)c[g>>2]=0;g=g+4|0}while((g|0)!=(q|0))}c[k>>2]=b;if(l>>>0>=b>>>0){i=d;return}k=a+12|0;a=l;do{c[h>>2]=c[k>>2];c[e+0>>2]=c[h+0>>2];l=cOb(256,16,e,0,3653512,67)|0;c[(c[j>>2]|0)+(a<<2)>>2]=l;a=a+1|0}while((a|0)!=(b|0));i=d;return}function Nlc(a,b){a=a|0;b=b|0;b=i;lQc(a,0);i=b;return}function Olc(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!a)f=0;else f=c[a+4>>2]|0;c[e>>2]=f;dlc(2666,e,b,0,ea(0.0),0,67);i=d;return}function Plc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;f=i;h=ea(g[a>>2]);j=ea(g[b>>2]);k=ea(h-j);h=ea(g[a+4>>2]);l=ea(g[b+4>>2]);m=ea(h-l);h=ea(g[a+8>>2]);n=ea(g[b+8>>2]);o=ea(h-n);p=b+12|0;h=ea(g[p>>2]);q=ea(-h);if(!(k<q))if(k>h){r=ea(k-h);s=h;t=ea(ea(r*r)+ea(0.0))}else{s=k;t=ea(0.0)}else{r=ea(k+h);s=q;t=ea(ea(r*r)+ea(0.0))}r=ea(g[p+4>>2]);q=ea(-r);if(!(m<q))if(m>r){h=ea(m-r);u=r;v=ea(t+ea(h*h))}else{u=m;v=t}else{h=ea(m+r);u=q;v=ea(t+ea(h*h))}h=ea(g[p+8>>2]);t=ea(-h);if(!(o<t))if(o>h){q=ea(o-h);w=h;x=ea(v+ea(q*q))}else{w=o;x=v}else{q=ea(o+h);w=t;x=ea(v+ea(q*q))}if(x==ea(0.0)){c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];y=ea(0.0);g[e>>2]=y;i=f;return}else{q=ea(u+l);l=ea(w+n);g[d>>2]=ea(s+j);g[d+4>>2]=q;g[d+8>>2]=l;y=x;g[e>>2]=y;i=f;return}}function Qlc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im;c=i;d=ea(g[a>>2]);e=ea(d-ea(g[b>>2]));d=ea(g[a+4>>2]);f=ea(d-ea(g[b+4>>2]));d=ea(g[a+8>>2]);h=ea(d-ea(g[b+8>>2]));a=b+12|0;d=ea(g[a>>2]);if(!(e<ea(-d)))if(e>d){j=ea(e-d);k=ea(ea(j*j)+ea(0.0))}else k=ea(0.0);else{j=ea(e+d);k=ea(ea(j*j)+ea(0.0))}j=ea(g[a+4>>2]);if(!(f<ea(-j)))if(f>j){d=ea(f-j);l=ea(k+ea(d*d))}else l=k;else{d=ea(f+j);l=ea(k+ea(d*d))}d=ea(g[a+8>>2]);if(h<ea(-d)){k=ea(h+d);m=ea(l+ea(k*k));i=c;return ea(m)}if(!(h>d)){m=l;i=c;return ea(m)}k=ea(h-d);m=ea(l+ea(k*k));i=c;return ea(m)}function Rlc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=0,f=Im,h=0,i=Im,j=Im,k=0,l=0;c=a+12|0;d=ea(g[c>>2]);e=a+16|0;f=ea(g[e>>2]);h=a+20|0;i=ea(g[h>>2]);j=ea(ea(g[a>>2])-d);k=a+4|0;d=ea(ea(g[k>>2])-f);l=a+8|0;f=ea(ea(g[l>>2])-i);g[b>>2]=j;g[b+4>>2]=d;g[b+8>>2]=f;f=ea(g[c>>2]);d=ea(g[e>>2]);j=ea(g[h>>2]);i=ea(f+ea(g[a>>2]));f=ea(ea(g[k>>2])-d);d=ea(ea(g[l>>2])-j);g[b+12>>2]=i;g[b+16>>2]=f;g[b+20>>2]=d;d=ea(g[c>>2]);f=ea(g[e>>2]);i=ea(g[h>>2]);j=ea(ea(g[a>>2])-d);d=ea(f+ea(g[k>>2]));f=ea(ea(g[l>>2])-i);g[b+24>>2]=j;g[b+28>>2]=d;g[b+32>>2]=f;f=ea(g[c>>2]);d=ea(g[e>>2]);j=ea(g[h>>2]);i=ea(f+ea(g[a>>2]));f=ea(d+ea(g[k>>2]));d=ea(ea(g[l>>2])-j);g[b+36>>2]=i;g[b+40>>2]=f;g[b+44>>2]=d;d=ea(g[c>>2]);f=ea(g[e>>2]);i=ea(g[h>>2]);j=ea(ea(g[a>>2])-d);d=ea(ea(g[k>>2])-f);f=ea(i+ea(g[l>>2]));g[b+48>>2]=j;g[b+52>>2]=d;g[b+56>>2]=f;f=ea(g[c>>2]);d=ea(g[e>>2]);j=ea(g[h>>2]);i=ea(f+ea(g[a>>2]));f=ea(ea(g[k>>2])-d);d=ea(j+ea(g[l>>2]));g[b+60>>2]=i;g[b+64>>2]=f;g[b+68>>2]=d;d=ea(g[c>>2]);f=ea(g[e>>2]);i=ea(g[h>>2]);j=ea(ea(g[a>>2])-d);d=ea(f+ea(g[k>>2]));f=ea(i+ea(g[l>>2]));g[b+72>>2]=j;g[b+76>>2]=d;g[b+80>>2]=f;f=ea(g[c>>2]);d=ea(g[e>>2]);j=ea(g[h>>2]);i=ea(f+ea(g[a>>2]));f=ea(d+ea(g[k>>2]));d=ea(j+ea(g[l>>2]));g[b+84>>2]=i;g[b+88>>2]=f;g[b+92>>2]=d;return}function Slc(a,b){a=a|0;b=b|0;var c=Im,d=0,e=Im,f=0,h=Im,i=0,j=0;c=ea(g[a>>2]);d=a+4|0;e=ea(g[d>>2]);f=a+8|0;h=ea(g[f>>2]);g[b>>2]=c;g[b+4>>2]=e;g[b+8>>2]=h;i=a+12|0;h=ea(g[i>>2]);e=ea(g[d>>2]);c=ea(g[f>>2]);g[b+12>>2]=h;g[b+16>>2]=e;g[b+20>>2]=c;c=ea(g[i>>2]);j=a+16|0;e=ea(g[j>>2]);h=ea(g[f>>2]);g[b+24>>2]=c;g[b+28>>2]=e;g[b+32>>2]=h;h=ea(g[a>>2]);e=ea(g[j>>2]);c=ea(g[f>>2]);g[b+36>>2]=h;g[b+40>>2]=e;g[b+44>>2]=c;c=ea(g[a>>2]);e=ea(g[d>>2]);f=a+20|0;h=ea(g[f>>2]);g[b+48>>2]=c;g[b+52>>2]=e;g[b+56>>2]=h;h=ea(g[i>>2]);e=ea(g[d>>2]);c=ea(g[f>>2]);g[b+60>>2]=h;g[b+64>>2]=e;g[b+68>>2]=c;c=ea(g[i>>2]);e=ea(g[j>>2]);h=ea(g[f>>2]);g[b+72>>2]=c;g[b+76>>2]=e;g[b+80>>2]=h;h=ea(g[a>>2]);e=ea(g[j>>2]);c=ea(g[f>>2]);g[b+84>>2]=h;g[b+88>>2]=e;g[b+92>>2]=c;return}function Tlc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=0,h=Im,j=0;c=i;d=ea(g[b>>2]);e=ea(g[a>>2]);f=a+12|0;h=ea(g[f>>2]);if(d<ea(e-h)|d>ea(e+h)){j=0;i=c;return j|0}h=ea(g[b+4>>2]);e=ea(g[a+4>>2]);d=ea(g[f+4>>2]);if(h<ea(e-d)|h>ea(e+d)){j=0;i=c;return j|0}d=ea(g[b+8>>2]);e=ea(g[a+8>>2]);h=ea(g[f+8>>2]);if(d<ea(e-h)){j=0;i=c;return j|0}j=!(d>ea(e+h));i=c;return j|0}function Ulc(a,b){a=a|0;b=b|0;var c=Im,d=0,e=Im,f=Im,h=0,i=Im,j=0,k=Im,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im;c=ea(g[a>>2]);d=a+12|0;e=ea(g[d>>2]);f=ea(c-e);h=a+4|0;i=ea(g[h>>2]);j=a+16|0;k=ea(g[j>>2]);l=ea(i-k);m=a+8|0;n=ea(g[m>>2]);o=a+20|0;p=ea(g[o>>2]);q=ea(n-p);r=ea(c+e);e=ea(i+k);k=ea(n+p);p=ea(g[b>>2]);n=p<f?p:f;f=ea(g[b+4>>2]);i=f<l?f:l;l=ea(g[b+8>>2]);c=l<q?l:q;q=r<p?p:r;r=e<f?f:e;e=k<l?l:k;k=ea(ea(r+i)*ea(.5));l=ea(ea(e+c)*ea(.5));g[a>>2]=ea(ea(q+n)*ea(.5));g[h>>2]=k;g[m>>2]=l;l=ea(ea(r-i)*ea(.5));i=ea(ea(e-c)*ea(.5));g[d>>2]=ea(ea(q-n)*ea(.5));g[j>>2]=l;g[o>>2]=i;return}function Vlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im;e=i;f=a+12|0;h=a+16|0;j=a+20|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+0>>2]=c[150280];c[a+4>>2]=c[150281];c[a+8>>2]=c[150282];k=ea(g[150280]);l=ea(-k);m=ea(g[150281]);n=ea(-m);o=ea(g[150282]);p=ea(-o);g[f>>2]=l;g[h>>2]=n;g[j>>2]=p;if(!((ea(g[b>>2])==k?ea(g[b+4>>2])==m:0)?ea(g[b+8>>2])==o:0))q=4;do if((q|0)==4){if((ea(g[b+12>>2])==l?ea(g[b+16>>2])==n:0)?!(ea(g[b+20>>2])!=p):0)break;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2]}while(0);r=ea(g[d>>2]);if((r==k?ea(g[d+4>>2])==m:0)?ea(g[d+8>>2])==o:0){i=e;return}o=ea(g[d+12>>2]);m=ea(g[d+16>>2]);if(o==l&m==n?!(ea(g[d+20>>2])!=p):0){i=e;return}p=ea(g[a>>2]);n=o<p?o:p;b=a+4|0;p=ea(g[b>>2]);l=m<p?m:p;q=a+8|0;p=ea(g[q>>2]);k=ea(g[d+20>>2]);s=k<p?k:p;p=ea(g[f>>2]);t=p<o?o:p;p=ea(g[h>>2]);o=p<m?m:p;p=ea(g[j>>2]);m=p<k?k:p;p=ea(g[d+4>>2]);k=ea(g[d+8>>2]);g[a>>2]=r<n?r:n;g[b>>2]=p<l?p:l;g[q>>2]=k<s?k:s;g[f>>2]=t<r?r:t;g[h>>2]=o<p?p:o;g[j>>2]=m<k?k:m;i=e;return}function Wlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;d=ea(g[a+12>>2]);e=ea(g[a+16>>2]);f=ea(g[a+20>>2]);h=ea(g[b>>2]);i=ea(d*h);if(i<ea(0.0))j=ea(-i);else j=i;i=ea(g[b+16>>2]);k=ea(e*i);if(k<ea(0.0))l=ea(-k);else l=k;k=ea(j+l);l=ea(g[b+32>>2]);j=ea(f*l);if(j<ea(0.0))m=ea(-j);else m=j;j=ea(k+m);m=ea(g[b+4>>2]);k=ea(d*m);if(k<ea(0.0))n=ea(-k);else n=k;k=ea(g[b+20>>2]);o=ea(e*k);if(o<ea(0.0))p=ea(-o);else p=o;o=ea(n+p);p=ea(g[b+36>>2]);n=ea(f*p);if(n<ea(0.0))q=ea(-n);else q=n;n=ea(o+q);q=ea(g[b+8>>2]);o=ea(d*q);if(o<ea(0.0))r=ea(-o);else r=o;o=ea(g[b+24>>2]);d=ea(e*o);if(d<ea(0.0))s=ea(-d);else s=d;d=ea(r+s);s=ea(g[b+40>>2]);r=ea(f*s);if(r<ea(0.0))t=ea(-r);else t=r;r=ea(d+t);t=ea(g[a>>2]);d=ea(h*t);h=ea(g[a+4>>2]);f=ea(d+ea(i*h));i=ea(g[a+8>>2]);d=ea(f+ea(l*i));l=ea(ea(g[b+48>>2])+d);d=ea(ea(ea(t*m)+ea(h*k))+ea(i*p));p=ea(ea(g[b+52>>2])+d);d=ea(ea(ea(t*q)+ea(h*o))+ea(i*s));s=ea(ea(g[b+56>>2])+d);g[c>>2]=l;g[c+4>>2]=p;g[c+8>>2]=s;g[c+12>>2]=j;g[c+16>>2]=n;g[c+20>>2]=r;return}function Xlc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im;e=i;i=i+96|0;f=e;h=ea(g[150280]);j=ea(g[150281]);k=ea(g[150282]);l=ea(-j);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;g[f+16>>2]=ea(0.0);g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);g[f+28>>2]=ea(0.0);g[f+32>>2]=ea(0.0);g[f+36>>2]=ea(0.0);g[f+40>>2]=ea(0.0);g[f+44>>2]=ea(0.0);g[f+48>>2]=ea(0.0);g[f+52>>2]=ea(0.0);g[f+56>>2]=ea(0.0);g[f+60>>2]=ea(0.0);g[f+64>>2]=ea(0.0);g[f+68>>2]=ea(0.0);g[f+72>>2]=ea(0.0);g[f+76>>2]=ea(0.0);g[f+80>>2]=ea(0.0);g[f+84>>2]=ea(0.0);g[f+88>>2]=ea(0.0);g[f+92>>2]=ea(0.0);m=ea(-h);n=ea(-k);Rlc(a,f);o=ea(g[b>>2]);p=ea(g[b+16>>2]);q=ea(g[b+32>>2]);r=ea(g[b+48>>2]);s=ea(g[b+4>>2]);t=ea(g[b+20>>2]);u=ea(g[b+36>>2]);v=ea(g[b+52>>2]);w=ea(g[b+8>>2]);x=ea(g[b+24>>2]);y=ea(g[b+40>>2]);z=ea(g[b+56>>2]);A=h;h=j;j=k;k=m;m=l;l=n;b=0;while(1){n=ea(g[f+(b*12|0)>>2]);B=ea(o*n);C=ea(g[f+(b*12|0)+4>>2]);D=ea(B+ea(p*C));B=ea(g[f+(b*12|0)+8>>2]);E=ea(r+ea(D+ea(q*B)));D=ea(v+ea(ea(ea(n*s)+ea(C*t))+ea(B*u)));F=ea(z+ea(ea(ea(n*w)+ea(C*x))+ea(B*y)));B=E<A?E:A;C=D<h?D:h;n=F<j?F:j;G=k<E?E:k;E=m<D?D:m;D=l<F?F:l;b=b+1|0;if((b|0)==8){H=B;I=C;J=n;K=G;L=E;M=D;break}else{A=B;h=C;j=n;k=G;m=E;l=D}}l=ea(ea(L+I)*ea(.5));m=ea(ea(M+J)*ea(.5));g[d>>2]=ea(ea(K+H)*ea(.5));g[d+4>>2]=l;g[d+8>>2]=m;m=ea(ea(L-I)*ea(.5));I=ea(ea(M-J)*ea(.5));g[d+12>>2]=ea(ea(K-H)*ea(.5));g[d+16>>2]=m;g[d+20>>2]=I;i=e;return}function Ylc(a,b){a=a|0;b=b|0;var c=Im,d=0,e=Im,f=Im,h=Im,i=0,j=Im,k=0,l=0;c=ea(g[a>>2]);d=a+12|0;e=ea(g[d>>2]);f=ea(c-e);h=ea(g[b>>2]);i=b+12|0;j=ea(g[i>>2]);k=f<ea(h-j)?1:ea(c+e)>ea(h+j);j=ea(g[a+4>>2]);h=ea(g[d+4>>2]);e=ea(j-h);c=ea(g[b+4>>2]);f=ea(g[i+4>>2]);l=k|e<ea(c-f)|ea(j+h)>ea(c+f);f=ea(g[a+8>>2]);c=ea(g[d+8>>2]);h=ea(f-c);j=ea(g[b+8>>2]);e=ea(g[i+8>>2]);i=(l|h<ea(j-e)|ea(f+c)>ea(j+e))^1;return i|0}function Zlc(){c[144512]=c[150284];c[144513]=c[150285];c[144514]=c[150286];c[144515]=c[150284];c[144516]=c[150285];c[144517]=c[150286];return}function _lc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=0;e=i;i=i+128|0;f=e+64|0;h=e;j=CTb(b,25)|0;do if(j){b=j+28|0;k=j+76|0;l=b+49|0;if(!((a[k>>0]|0)==0?(a[l>>0]|0)==0:0)){ko[c[(c[b>>2]|0)+60>>2]&4095](b);a[k>>0]=0;a[l>>0]=0}l=j+80|0;k=l+88|0;m=ea(g[l+100>>2]);if((!(m!=ea(g[150284]))?(m=ea(g[l+104>>2]),!(m!=ea(g[150285]))):0)?(m=ea(g[l+108>>2]),!(m!=ea(g[150286]))):0)break;RGc(f,BTb(c[j+24>>2]|0)|0);dMc(f,l,h);Wlc(k,h,d);n=1;i=e;return n|0}while(0);c[d+0>>2]=c[150284];c[d+4>>2]=c[150285];c[d+8>>2]=c[150286];h=d+12|0;c[h+0>>2]=c[150284];c[h+4>>2]=c[150285];c[h+8>>2]=c[150286];n=0;i=e;return n|0}function $lc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=0,f=Im,h=0,j=0,k=0,l=0,m=Im,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0,ga=0;c=i;d=ea(g[a>>2]);e=a+16|0;f=ea(ea(-ea(g[e>>2]))-d);h=a+32|0;d=ea(f-ea(g[h>>2]));j=a+48|0;f=ea(ea(g[j>>2])+d);k=a+4|0;d=ea(g[k>>2]);l=a+20|0;m=ea(ea(-ea(g[l>>2]))-d);n=a+36|0;d=ea(m-ea(g[n>>2]));o=a+52|0;m=ea(ea(g[o>>2])+d);p=a+8|0;d=ea(g[p>>2]);q=a+24|0;r=ea(ea(-ea(g[q>>2]))-d);s=a+40|0;d=ea(r-ea(g[s>>2]));t=a+56|0;r=ea(ea(g[t>>2])+d);u=a+12|0;d=ea(g[u>>2]);v=a+28|0;w=ea(ea(-ea(g[v>>2]))-d);x=a+44|0;d=ea(w-ea(g[x>>2]));y=a+60|0;w=ea(ea(g[y>>2])+d);if(w<ea(0.0))z=ea(-w);else z=w;if(z>ea(1.00000001e-07)){z=ea(ea(1.0)/w);A=ea(r*z);B=ea(m*z);C=ea(f*z)}else{A=ea(0.0);B=ea(0.0);C=ea(0.0)}g[b>>2]=C;g[b+4>>2]=B;g[b+8>>2]=A;A=ea(g[a>>2]);B=ea(A-ea(g[e>>2]));A=ea(B-ea(g[h>>2]));B=ea(ea(g[j>>2])+A);A=ea(g[k>>2]);C=ea(A-ea(g[l>>2]));A=ea(C-ea(g[n>>2]));C=ea(ea(g[o>>2])+A);A=ea(g[p>>2]);z=ea(A-ea(g[q>>2]));A=ea(z-ea(g[s>>2]));z=ea(ea(g[t>>2])+A);A=ea(g[u>>2]);f=ea(A-ea(g[v>>2]));A=ea(f-ea(g[x>>2]));f=ea(ea(g[y>>2])+A);if(f<ea(0.0))D=ea(-f);else D=f;if(D>ea(1.00000001e-07)){D=ea(ea(1.0)/f);E=ea(z*D);F=ea(C*D);G=ea(B*D)}else{E=ea(0.0);F=ea(0.0);G=ea(0.0)}g[b+12>>2]=G;g[b+16>>2]=F;g[b+20>>2]=E;E=ea(g[a>>2]);F=ea(E+ea(g[e>>2]));E=ea(F-ea(g[h>>2]));F=ea(ea(g[j>>2])+E);E=ea(g[k>>2]);G=ea(E+ea(g[l>>2]));E=ea(G-ea(g[n>>2]));G=ea(ea(g[o>>2])+E);E=ea(g[p>>2]);D=ea(E+ea(g[q>>2]));E=ea(D-ea(g[s>>2]));D=ea(ea(g[t>>2])+E);E=ea(g[u>>2]);B=ea(E+ea(g[v>>2]));E=ea(B-ea(g[x>>2]));B=ea(ea(g[y>>2])+E);if(B<ea(0.0))H=ea(-B);else H=B;if(H>ea(1.00000001e-07)){H=ea(ea(1.0)/B);I=ea(D*H);J=ea(G*H);K=ea(F*H)}else{I=ea(0.0);J=ea(0.0);K=ea(0.0)}g[b+24>>2]=K;g[b+28>>2]=J;g[b+32>>2]=I;I=ea(g[a>>2]);J=ea(ea(g[e>>2])-I);I=ea(J-ea(g[h>>2]));J=ea(ea(g[j>>2])+I);I=ea(g[k>>2]);K=ea(ea(g[l>>2])-I);I=ea(K-ea(g[n>>2]));K=ea(ea(g[o>>2])+I);I=ea(g[p>>2]);H=ea(ea(g[q>>2])-I);I=ea(H-ea(g[s>>2]));H=ea(ea(g[t>>2])+I);I=ea(g[u>>2]);F=ea(ea(g[v>>2])-I);I=ea(F-ea(g[x>>2]));F=ea(ea(g[y>>2])+I);if(F<ea(0.0))L=ea(-F);else L=F;if(L>ea(1.00000001e-07)){L=ea(ea(1.0)/F);M=ea(H*L);N=ea(K*L);O=ea(J*L)}else{M=ea(0.0);N=ea(0.0);O=ea(0.0)}g[b+36>>2]=O;g[b+40>>2]=N;g[b+44>>2]=M;M=ea(g[a>>2]);N=ea(ea(-ea(g[e>>2]))-M);M=ea(ea(g[h>>2])+N);N=ea(ea(g[j>>2])+M);M=ea(g[k>>2]);O=ea(ea(-ea(g[l>>2]))-M);M=ea(ea(g[n>>2])+O);O=ea(ea(g[o>>2])+M);M=ea(g[p>>2]);L=ea(ea(-ea(g[q>>2]))-M);M=ea(ea(g[s>>2])+L);L=ea(ea(g[t>>2])+M);M=ea(g[u>>2]);J=ea(ea(-ea(g[v>>2]))-M);M=ea(ea(g[x>>2])+J);J=ea(ea(g[y>>2])+M);if(J<ea(0.0))P=ea(-J);else P=J;if(P>ea(1.00000001e-07)){P=ea(ea(1.0)/J);Q=ea(L*P);R=ea(O*P);S=ea(N*P)}else{Q=ea(0.0);R=ea(0.0);S=ea(0.0)}g[b+48>>2]=S;g[b+52>>2]=R;g[b+56>>2]=Q;Q=ea(g[a>>2]);R=ea(Q-ea(g[e>>2]));Q=ea(R+ea(g[h>>2]));R=ea(ea(g[j>>2])+Q);Q=ea(g[k>>2]);S=ea(Q-ea(g[l>>2]));Q=ea(S+ea(g[n>>2]));S=ea(ea(g[o>>2])+Q);Q=ea(g[p>>2]);P=ea(Q-ea(g[q>>2]));Q=ea(P+ea(g[s>>2]));P=ea(ea(g[t>>2])+Q);Q=ea(g[u>>2]);N=ea(Q-ea(g[v>>2]));Q=ea(N+ea(g[x>>2]));N=ea(ea(g[y>>2])+Q);if(N<ea(0.0))T=ea(-N);else T=N;if(T>ea(1.00000001e-07)){T=ea(ea(1.0)/N);U=ea(P*T);V=ea(S*T);W=ea(R*T)}else{U=ea(0.0);V=ea(0.0);W=ea(0.0)}g[b+60>>2]=W;g[b+64>>2]=V;g[b+68>>2]=U;U=ea(g[a>>2]);V=ea(U+ea(g[e>>2]));U=ea(V+ea(g[h>>2]));V=ea(ea(g[j>>2])+U);U=ea(g[k>>2]);W=ea(U+ea(g[l>>2]));U=ea(W+ea(g[n>>2]));W=ea(ea(g[o>>2])+U);U=ea(g[p>>2]);T=ea(U+ea(g[q>>2]));U=ea(T+ea(g[s>>2]));T=ea(ea(g[t>>2])+U);U=ea(g[u>>2]);R=ea(U+ea(g[v>>2]));U=ea(R+ea(g[x>>2]));R=ea(ea(g[y>>2])+U);if(R<ea(0.0))X=ea(-R);else X=R;if(X>ea(1.00000001e-07)){X=ea(ea(1.0)/R);Y=ea(T*X);Z=ea(W*X);_=ea(V*X)}else{Y=ea(0.0);Z=ea(0.0);_=ea(0.0)}g[b+72>>2]=_;g[b+76>>2]=Z;g[b+80>>2]=Y;Y=ea(g[a>>2]);Z=ea(ea(g[e>>2])-Y);Y=ea(Z+ea(g[h>>2]));Z=ea(ea(g[j>>2])+Y);Y=ea(g[k>>2]);_=ea(ea(g[l>>2])-Y);Y=ea(_+ea(g[n>>2]));_=ea(ea(g[o>>2])+Y);Y=ea(g[p>>2]);X=ea(ea(g[q>>2])-Y);Y=ea(X+ea(g[s>>2]));X=ea(ea(g[t>>2])+Y);Y=ea(g[u>>2]);V=ea(ea(g[v>>2])-Y);Y=ea(V+ea(g[x>>2]));V=ea(ea(g[y>>2])+Y);if(V<ea(0.0))$=ea(-V);else $=V;if(!($>ea(1.00000001e-07))){aa=ea(0.0);ba=ea(0.0);ca=ea(0.0);da=b+84|0;g[da>>2]=ca;fa=b+88|0;g[fa>>2]=ba;ga=b+92|0;g[ga>>2]=aa;i=c;return}$=ea(ea(1.0)/V);aa=ea(X*$);ba=ea(_*$);ca=ea(Z*$);da=b+84|0;g[da>>2]=ca;fa=b+88|0;g[fa>>2]=ba;ga=b+92|0;g[ga>>2]=aa;i=c;return}function amc(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=d|0;var e=0,f=Im,h=0,i=Im,j=0,k=Im,l=Im,m=Im,n=0,o=Im,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=a+48|0;f=ea(ea(g[e>>2])*b);h=a+52|0;i=ea(ea(g[h>>2])*b);j=a+56|0;k=ea(ea(g[j>>2])*b);l=ea(ea(1.0)-b);m=ea(l*ea(g[a>>2]));n=a+4|0;o=ea(l*ea(g[n>>2]));p=a+8|0;q=ea(i+o);o=ea(k+ea(l*ea(g[p>>2])));g[d>>2]=ea(f+m);g[d+4>>2]=q;g[d+8>>2]=o;r=a+60|0;o=ea(ea(g[r>>2])*b);s=a+64|0;q=ea(ea(g[s>>2])*b);t=a+68|0;m=ea(ea(g[t>>2])*b);u=a+12|0;f=ea(l*ea(g[u>>2]));v=a+16|0;k=ea(l*ea(g[v>>2]));w=a+20|0;i=ea(q+k);k=ea(m+ea(l*ea(g[w>>2])));g[d+12>>2]=ea(o+f);g[d+16>>2]=i;g[d+20>>2]=k;x=a+72|0;k=ea(ea(g[x>>2])*b);y=a+76|0;i=ea(ea(g[y>>2])*b);z=a+80|0;f=ea(ea(g[z>>2])*b);A=a+24|0;o=ea(l*ea(g[A>>2]));B=a+28|0;m=ea(l*ea(g[B>>2]));C=a+32|0;q=ea(i+m);m=ea(f+ea(l*ea(g[C>>2])));g[d+24>>2]=ea(k+o);g[d+28>>2]=q;g[d+32>>2]=m;D=a+84|0;m=ea(ea(g[D>>2])*b);E=a+88|0;q=ea(ea(g[E>>2])*b);F=a+92|0;o=ea(ea(g[F>>2])*b);G=a+36|0;b=ea(l*ea(g[G>>2]));H=a+40|0;k=ea(l*ea(g[H>>2]));I=a+44|0;f=ea(q+k);k=ea(o+ea(l*ea(g[I>>2])));g[d+36>>2]=ea(m+b);g[d+40>>2]=f;g[d+44>>2]=k;k=ea(ea(g[e>>2])*c);f=ea(ea(g[h>>2])*c);b=ea(ea(g[j>>2])*c);m=ea(ea(1.0)-c);l=ea(m*ea(g[a>>2]));o=ea(m*ea(g[n>>2]));q=ea(f+o);o=ea(b+ea(m*ea(g[p>>2])));g[d+48>>2]=ea(k+l);g[d+52>>2]=q;g[d+56>>2]=o;o=ea(ea(g[r>>2])*c);q=ea(ea(g[s>>2])*c);l=ea(ea(g[t>>2])*c);k=ea(m*ea(g[u>>2]));b=ea(m*ea(g[v>>2]));f=ea(q+b);b=ea(l+ea(m*ea(g[w>>2])));g[d+60>>2]=ea(o+k);g[d+64>>2]=f;g[d+68>>2]=b;b=ea(ea(g[x>>2])*c);f=ea(ea(g[y>>2])*c);k=ea(ea(g[z>>2])*c);o=ea(m*ea(g[A>>2]));l=ea(m*ea(g[B>>2]));q=ea(f+l);l=ea(k+ea(m*ea(g[C>>2])));g[d+72>>2]=ea(b+o);g[d+76>>2]=q;g[d+80>>2]=l;l=ea(ea(g[D>>2])*c);q=ea(ea(g[E>>2])*c);o=ea(ea(g[F>>2])*c);c=ea(m*ea(g[G>>2]));b=ea(m*ea(g[H>>2]));k=ea(q+b);b=ea(o+ea(m*ea(g[I>>2])));g[d+84>>2]=ea(l+c);g[d+88>>2]=k;g[d+92>>2]=b;return}function bmc(b,c,e,f,h,j){b=b|0;c=c|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,T=0;k=i;i=i+3200|0;l=k+1536|0;m=k;n=k+3136|0;o=k+3072|0;p=l+1536|0;q=l;do{g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);q=q+12|0}while((q|0)!=(p|0));p=m+1536|0;q=m;do{g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);q=q+12|0}while((q|0)!=(p|0));a[o>>0]=0;p=e&255;q=e<<24>>24==0;if(!q){r=0;s=c;c=b;b=n;t=l;while(1){u=a[s>>0]|0;gmc(u,c,f,b,t,o,m)|0;t=t+((d[b>>0]|0)*12|0)|0;r=r+1<<24>>24;if(r<<24>>24==e<<24>>24)break;else{s=s+1|0;c=c+((u&255)*12|0)|0;b=b+1|0}}if(!q){q=h+16|0;b=h+32|0;c=h+48|0;s=h+4|0;e=h+20|0;r=h+36|0;t=h+52|0;m=h+8|0;o=h+24|0;f=h+40|0;u=h+56|0;v=h+12|0;w=h+28|0;x=h+44|0;y=h+60|0;z=j+4|0;A=j+8|0;B=j+12|0;C=j+16|0;D=j+20|0;E=0;F=n;n=l;while(1){l=a[F>>0]|0;F=F+1|0;G=l&255;if(l<<24>>24){l=0;do{H=ea(g[h>>2]);I=ea(g[n+(l*12|0)>>2]);J=ea(H*I);H=ea(g[q>>2]);K=ea(g[n+(l*12|0)+4>>2]);L=ea(J+ea(H*K));H=ea(g[b>>2]);J=ea(g[n+(l*12|0)+8>>2]);M=ea(L+ea(H*J));H=ea(ea(g[c>>2])+M);M=ea(I*ea(g[s>>2]));L=ea(M+ea(K*ea(g[e>>2])));M=ea(L+ea(J*ea(g[r>>2])));L=ea(ea(g[t>>2])+M);M=ea(I*ea(g[m>>2]));N=ea(M+ea(K*ea(g[o>>2])));M=ea(N+ea(J*ea(g[f>>2])));N=ea(ea(g[u>>2])+M);M=ea(I*ea(g[v>>2]));I=ea(M+ea(K*ea(g[w>>2])));K=ea(I+ea(J*ea(g[x>>2])));J=ea(ea(g[y>>2])+K);if(J<ea(0.0))O=ea(-J);else O=J;if(O>ea(1.00000001e-07)){K=ea(ea(1.0)/J);P=ea(N*K);Q=ea(L*K);R=ea(H*K)}else{P=ea(0.0);Q=ea(0.0);R=ea(0.0)}K=ea(g[j>>2]);H=ea(g[z>>2]);L=ea(g[A>>2]);g[j>>2]=R<K?R:K;g[z>>2]=Q<H?Q:H;g[A>>2]=P<L?P:L;L=ea(g[B>>2]);H=ea(g[C>>2]);K=ea(g[D>>2]);g[B>>2]=L<R?R:L;g[C>>2]=H<Q?Q:H;g[D>>2]=K<P?P:K;l=l+1|0}while((l|0)<(G|0))}E=E+1|0;if((E|0)>=(p|0)){S=j;break}else n=n+(G*12|0)|0}}else T=7}else T=7;if((T|0)==7)S=j;if(ea(g[S>>2])<ea(-1.0))g[S>>2]=ea(-1.0);S=j+4|0;if(ea(g[S>>2])<ea(-1.0))g[S>>2]=ea(-1.0);S=j+12|0;if(ea(g[S>>2])>ea(1.0))g[S>>2]=ea(1.0);S=j+16|0;if(!(ea(g[S>>2])>ea(1.0))){i=k;return}g[S>>2]=ea(1.0);i=k;return}function cmc(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=0,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0;j=i;i=i+9728|0;k=j+128|0;l=j+9344|0;m=j+32|0;n=j+24|0;o=j+16|0;p=j;q=k+9216|0;r=k;do{g[r>>2]=ea(0.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);r=r+12|0}while((r|0)!=(q|0));q=f+4|0;s=ea(-ea(g[q>>2]));g[m>>2]=ea(0.0);g[m+4>>2]=ea(1.0);g[m+8>>2]=ea(0.0);g[m+12>>2]=s;r=f+16|0;s=ea(g[r>>2]);g[m+16>>2]=ea(0.0);g[m+20>>2]=ea(-1.0);g[m+24>>2]=ea(0.0);g[m+28>>2]=s;s=ea(-ea(g[f>>2]));g[m+32>>2]=ea(1.0);g[m+36>>2]=ea(0.0);g[m+40>>2]=ea(0.0);g[m+44>>2]=s;t=f+12|0;s=ea(g[t>>2]);g[m+48>>2]=ea(-1.0);g[m+52>>2]=ea(0.0);g[m+56>>2]=ea(0.0);g[m+60>>2]=s;u=f+8|0;s=ea(-ea(g[u>>2]));g[m+64>>2]=ea(0.0);g[m+68>>2]=ea(0.0);g[m+72>>2]=ea(1.0);g[m+76>>2]=s;v=f+20|0;s=ea(g[v>>2]);g[m+80>>2]=ea(0.0);g[m+84>>2]=ea(0.0);g[m+88>>2]=ea(-1.0);g[m+92>>2]=s;c[n>>2]=k;c[n+4>>2]=k+3072;c[o>>2]=l;c[o+4>>2]=l+128;a[l+0>>0]=4;a[l+1>>0]=4;a[l+2>>0]=4;a[l+3>>0]=4;a[l+4>>0]=4;a[l+5>>0]=4;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];w=k+12|0;x=b+12|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];w=k+24|0;y=b+24|0;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];w=k+36|0;z=b+36|0;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];w=k+48|0;A=b+84|0;c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];w=k+60|0;B=b+72|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];w=k+72|0;C=b+60|0;c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];w=k+84|0;D=b+48|0;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];w=k+96|0;c[w+0>>2]=c[b+0>>2];c[w+4>>2]=c[b+4>>2];c[w+8>>2]=c[b+8>>2];w=k+108|0;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];w=k+120|0;c[w+0>>2]=c[A+0>>2];c[w+4>>2]=c[A+4>>2];c[w+8>>2]=c[A+8>>2];w=k+132|0;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];w=k+144|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];w=k+156|0;c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];w=k+168|0;c[w+0>>2]=c[B+0>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2];w=k+180|0;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];w=k+192|0;c[w+0>>2]=c[D+0>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];D=k+204|0;c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];C=k+216|0;c[C+0>>2]=c[x+0>>2];c[C+4>>2]=c[x+4>>2];c[C+8>>2]=c[x+8>>2];x=k+228|0;c[x+0>>2]=c[b+0>>2];c[x+4>>2]=c[b+4>>2];c[x+8>>2]=c[b+8>>2];b=k+240|0;c[b+0>>2]=c[B+0>>2];c[b+4>>2]=c[B+4>>2];c[b+8>>2]=c[B+8>>2];B=k+252|0;c[B+0>>2]=c[A+0>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];A=k+264|0;c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];z=k+276|0;c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];y=k+6144|0;k=l+256|0;l=6;z=0;A=0;while(1){B=c[n+(A<<2)>>2]|0;b=A;A=1-A|0;x=c[n+(A<<2)>>2]|0;C=c[o+(b<<2)>>2]|0;b=c[o+(A<<2)>>2]|0;a[k>>0]=0;a:do if(!l){E=0;F=0;G=b;H=x}else{D=m+(z<<4)|0;w=0;I=C;J=B;K=l;L=0;M=b;N=x;while(1){O=a[I>>0]|0;if(!(gmc(O,J,D,M,N,k,y)|0)){P=K+-1|0;if(!P){E=0;F=L;G=M;H=N;break a}else{Q=P;R=L;S=M;T=N}}else{P=d[M>>0]|0;Q=K;R=P+L|0;S=M+1|0;T=N+(P*12|0)|0}w=w+1|0;if(w>>>0>=l>>>0){E=Q;F=R;G=S;H=T;break}else{I=I+1|0;J=J+((O&255)*12|0)|0;K=Q;L=R;M=S;N=T}}}while(0);x=a[k>>0]|0;if(x<<24>>24!=0&(z|0)<5){a[G>>0]=x;YEi(H|0,y|0,(x&255)*12|0)|0;U=E+1|0}else U=E;z=z+1|0;if((z|0)==6){V=U;W=F;break}else l=U}if(!V){i=j;return}g[p>>2]=ea(0.0);U=p+4|0;g[U>>2]=ea(0.0);l=p+8|0;g[l>>2]=ea(0.0);s=ea(g[e>>2]);X=ea(-s);Y=ea(g[e+4>>2]);Z=ea(-Y);_=ea(g[e+8>>2]);$=ea(-_);e=W<<1;F=h+8|0;z=c[h>>2]|0;E=z;if((((c[F>>2]|0)-E|0)/12|0)>>>0<e>>>0){y=h+4|0;H=(c[y>>2]|0)-E|0;E=(H|0)/12|0;if(!e)aa=0;else aa=xCi(W*24|0)|0;W=aa+((((H|0)/-12|0)+E|0)*12|0)|0;YEi(W|0,z|0,H|0)|0;c[h>>2]=W;c[y>>2]=aa+(E*12|0);c[F>>2]=aa+(e*12|0);if(z)ACi(z)}z=h+4|0;e=_<ea(-1.00000001e-10);aa=_>ea(1.00000001e-10);E=Y<ea(-1.00000001e-10);y=Y>ea(1.00000001e-10);W=s<ea(-1.00000001e-10);H=s>ea(1.00000001e-10);G=0;k=c[o>>2]|0;o=c[n>>2]|0;while(1){n=a[k>>0]|0;k=k+1|0;if(n<<24>>24){T=0;do{S=o+(T*12|0)|0;R=c[z>>2]|0;if((R|0)==(c[F>>2]|0))hmc(h,S);else{if(!R)ba=0;else{c[R+0>>2]=c[S+0>>2];c[R+4>>2]=c[S+4>>2];c[R+8>>2]=c[S+8>>2];ba=c[z>>2]|0}c[z>>2]=ba+12}R=o+(T*12|0)+8|0;ca=ea(g[R>>2]);da=ea(ca-ea(g[u>>2]));do if(e){fa=ea(da/_);if(!(fa>ea(1000000019999999998489706.0e6))){Q=fa>ea(0.0);ga=Q?fa:ea(0.0);fa=ea(ea(g[v>>2])-ca);if(!aa)if(e){ha=ea(fa/$);if(!(ha<ga))if(ha<ea(1000000019999999998489706.0e6)){ia=ha;ja=ga;ka=42}else{ia=ea(1000000019999999998489706.0e6);ja=ga;ka=42}}else{la=fa;ma=ga;ka=41}else{na=fa;oa=ea(1000000019999999998489706.0e6);pa=ga;ka=34}}}else if(aa){ga=ea(da/_);if(ga<ea(0.0))break;Q=ga<ea(1000000019999999998489706.0e6);fa=ea(ea(g[v>>2])-ca);na=fa;oa=Q?ga:ea(1000000019999999998489706.0e6);pa=ea(0.0);ka=34;break}else{if(!(da>=ea(0.0)))break;la=ea(ea(g[v>>2])-ca);ma=ea(0.0);ka=41;break}while(0);if((ka|0)==34){ka=0;da=ea(na/$);if(!(da>oa))if(da>pa){ia=oa;ja=da;ka=42}else{ia=oa;ja=pa;ka=42}}else if((ka|0)==41?(ka=0,la>=ea(0.0)):0){ia=ea(1000000019999999998489706.0e6);ja=ma;ka=42}b:do if((ka|0)==42){ka=0;Q=o+(T*12|0)+4|0;da=ea(g[Q>>2]);ga=ea(da-ea(g[q>>2]));do if(E){fa=ea(ga/Y);if(fa>ia)break b;ha=fa>ja?fa:ja;fa=ea(ea(g[r>>2])-da);if(!y)if(E){qa=ea(fa/Z);if(qa<ha)break b;if(qa<ia){ra=qa;sa=ha}else{ra=ia;sa=ha}}else{ta=fa;ua=ha;ka=57}else{va=fa;wa=ia;xa=ha;ka=50}}else if(y){ha=ea(ga/Y);if(ha<ja)break b;fa=ea(ea(g[r>>2])-da);va=fa;wa=ha<ia?ha:ia;xa=ja;ka=50;break}else{if(!(ga>=ea(0.0)))break b;ta=ea(ea(g[r>>2])-da);ua=ja;ka=57;break}while(0);if((ka|0)==50){ka=0;ga=ea(va/Z);if(ga>wa)break;if(ga>xa){ra=wa;sa=ga}else{ra=wa;sa=xa}}else if((ka|0)==57){ka=0;if(!(ta>=ea(0.0)))break;else{ra=ia;sa=ua}}ga=ea(g[S>>2]);ha=ea(ga-ea(g[f>>2]));do if(W){fa=ea(ha/s);if(fa>ra)break b;qa=fa>sa?fa:sa;fa=ea(ea(g[t>>2])-ga);if(!H)if(W){ya=ea(fa/X);if(ya<qa)break b;if(ya<ra){za=qa;Aa=ya}else{za=qa;Aa=ra}}else{Ba=fa;Ca=qa;ka=73}else{Da=fa;Ea=ra;Fa=qa;ka=66}}else if(H){qa=ea(ha/s);if(qa<sa)break b;fa=ea(ea(g[t>>2])-ga);Da=fa;Ea=qa<ra?qa:ra;Fa=sa;ka=66;break}else{if(!(ha>=ea(0.0)))break b;Ba=ea(ea(g[t>>2])-ga);Ca=sa;ka=73;break}while(0);if((ka|0)==66){ka=0;ha=ea(Da/X);if(ha>Ea)break;if(ha>Fa){za=ha;Aa=Ea}else{za=Fa;Aa=Ea}}else if((ka|0)==73){ka=0;if(!(Ba>=ea(0.0)))break;else{za=Ca;Aa=ra}}if(!(za>=ea(0.0)))Ga=0;else{ha=ea(da+ea(za*Z));qa=ea(ca+ea(za*$));g[p>>2]=ea(ga+ea(za*X));g[U>>2]=ha;g[l>>2]=qa;Ga=1}if(!(Aa>=ea(0.0))){if(!Ga)break}else{qa=ea(Aa*X);ha=ea(Aa*Z);fa=ea(Aa*$);ya=ea(qa+ea(g[S>>2]));qa=ea(ha+ea(g[Q>>2]));ha=ea(fa+ea(g[R>>2]));g[p>>2]=ya;g[U>>2]=qa;g[l>>2]=ha}m=c[z>>2]|0;if((m|0)==(c[F>>2]|0)){hmc(h,p);break}if(!m)Ha=0;else{c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];Ha=c[z>>2]|0}c[z>>2]=Ha+12}while(0);T=T+1|0}while((T&255)<<24>>24!=n<<24>>24)}G=G+1|0;if((G|0)==(V|0))break;else o=o+((n&255)*12|0)|0}i=j;return}function dmc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0;e=i;i=i+48|0;f=e;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];h=f+12|0;j=a+36|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];j=f+24|0;h=a+60|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];h=f+36|0;j=a+84|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];j=1;while(1){h=j<<1;k=ea(g[f+(h*12|0)>>2]);l=ea(g[f+(h*12|0)+4>>2]);m=ea(g[f+(h*12|0)+8>>2]);a=h|1;n=ea(g[f+(a*12|0)>>2]);o=ea(g[f+(a*12|0)+4>>2]);p=ea(ea(k+n)*ea(.5));n=ea(ea(l+o)*ea(.5));o=ea(ea(m+ea(g[f+(a*12|0)+8>>2]))*ea(.5));q=ea(k-p);k=ea(l-n);l=ea(m-o);m=ea(ea(ea(q*q)+ea(k*k))+ea(l*l));a=1-j<<1;l=ea(g[f+(a*12|0)>>2]);k=ea(g[f+(a*12|0)+4>>2]);h=a|1;q=ea(l-p);l=ea(k-n);k=ea(ea(g[f+(a*12|0)+8>>2])-o);if(ea(ea(ea(q*q)+ea(l*l))+ea(k*k))<=m?(k=ea(g[f+(h*12|0)+8>>2]),l=ea(g[f+(h*12|0)+4>>2]),q=ea(ea(g[f+(h*12|0)>>2])-p),r=ea(l-n),l=ea(k-o),ea(ea(l*l)+ea(ea(r*r)+ea(q*q)))<=m):0){s=p;t=n;u=o;v=m;w=4;break}if((j|0)>0)j=j+-1|0;else{w=6;break}}if((w|0)==4){g[b>>2]=s;g[b+4>>2]=t;g[b+8>>2]=u;g[d>>2]=ea(T(ea(v)));i=e;return}else if((w|0)==6){emc(f,b,d);i=e;return}}function emc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im;d=i;i=i+64|0;e=d;g[e>>2]=ea(g[a>>2]);f=a+4|0;h=e+16|0;g[h>>2]=ea(g[f>>2]);j=a+8|0;k=e+32|0;g[k>>2]=ea(g[j>>2]);l=e+48|0;g[l>>2]=ea(1.0);m=a+12|0;n=e+4|0;g[n>>2]=ea(g[m>>2]);o=a+16|0;p=e+20|0;g[p>>2]=ea(g[o>>2]);q=a+20|0;r=e+36|0;g[r>>2]=ea(g[q>>2]);s=e+52|0;g[s>>2]=ea(1.0);t=a+24|0;u=e+8|0;g[u>>2]=ea(g[t>>2]);v=a+28|0;w=e+24|0;g[w>>2]=ea(g[v>>2]);x=a+32|0;y=e+40|0;g[y>>2]=ea(g[x>>2]);z=e+56|0;g[z>>2]=ea(1.0);A=a+36|0;B=e+12|0;g[B>>2]=ea(g[A>>2]);C=a+40|0;D=e+28|0;g[D>>2]=ea(g[C>>2]);E=a+44|0;F=e+44|0;g[F>>2]=ea(g[E>>2]);G=e+60|0;g[G>>2]=ea(1.0);H=+bMc(e);I=ea(g[a>>2]);J=ea(I*I);I=ea(g[f>>2]);K=ea(J+ea(I*I));J=ea(g[j>>2]);g[e>>2]=ea(K+ea(J*J));g[h>>2]=I;g[k>>2]=J;g[l>>2]=ea(1.0);J=ea(g[m>>2]);I=ea(J*J);J=ea(g[o>>2]);K=ea(I+ea(J*J));I=ea(g[q>>2]);g[n>>2]=ea(K+ea(I*I));g[p>>2]=J;g[r>>2]=I;g[s>>2]=ea(1.0);I=ea(g[t>>2]);J=ea(I*I);I=ea(g[v>>2]);K=ea(J+ea(I*I));J=ea(g[x>>2]);g[u>>2]=ea(K+ea(J*J));g[w>>2]=I;g[y>>2]=J;g[z>>2]=ea(1.0);J=ea(g[A>>2]);I=ea(J*J);J=ea(g[C>>2]);K=ea(I+ea(J*J));I=ea(g[E>>2]);g[B>>2]=ea(K+ea(I*I));g[D>>2]=J;g[F>>2]=I;g[G>>2]=ea(1.0);I=ea(H);H=+bMc(e);J=ea(g[a>>2]);g[e>>2]=J;K=ea(J*J);J=ea(g[f>>2]);L=ea(K+ea(J*J));J=ea(g[j>>2]);g[h>>2]=ea(L+ea(J*J));g[k>>2]=J;g[l>>2]=ea(1.0);J=ea(g[m>>2]);g[n>>2]=J;L=ea(J*J);J=ea(g[o>>2]);K=ea(L+ea(J*J));J=ea(g[q>>2]);g[p>>2]=ea(K+ea(J*J));g[r>>2]=J;g[s>>2]=ea(1.0);J=ea(g[t>>2]);g[u>>2]=J;K=ea(J*J);J=ea(g[v>>2]);L=ea(K+ea(J*J));J=ea(g[x>>2]);g[w>>2]=ea(L+ea(J*J));g[y>>2]=J;g[z>>2]=ea(1.0);J=ea(g[A>>2]);g[B>>2]=J;L=ea(J*J);J=ea(g[C>>2]);K=ea(L+ea(J*J));J=ea(g[E>>2]);g[D>>2]=ea(K+ea(J*J));g[F>>2]=J;g[G>>2]=ea(1.0);J=ea(H);H=+bMc(e);K=ea(g[a>>2]);g[e>>2]=K;L=ea(g[f>>2]);g[h>>2]=L;M=ea(ea(K*K)+ea(L*L));L=ea(g[j>>2]);g[k>>2]=ea(M+ea(L*L));g[l>>2]=ea(1.0);L=ea(g[m>>2]);g[n>>2]=L;M=ea(g[o>>2]);g[p>>2]=M;K=ea(ea(L*L)+ea(M*M));M=ea(g[q>>2]);g[r>>2]=ea(K+ea(M*M));g[s>>2]=ea(1.0);M=ea(g[t>>2]);g[u>>2]=M;K=ea(g[v>>2]);g[w>>2]=K;L=ea(ea(M*M)+ea(K*K));K=ea(g[x>>2]);g[y>>2]=ea(L+ea(K*K));g[z>>2]=ea(1.0);K=ea(g[A>>2]);g[B>>2]=K;L=ea(g[C>>2]);g[D>>2]=L;M=ea(ea(K*K)+ea(L*L));L=ea(g[E>>2]);g[F>>2]=ea(M+ea(L*L));g[G>>2]=ea(1.0);L=ea(H);H=+bMc(e);M=ea(g[a>>2]);K=ea(M*M);N=ea(g[f>>2]);O=ea(K+ea(N*N));K=ea(g[j>>2]);g[e>>2]=ea(O+ea(K*K));g[h>>2]=M;g[k>>2]=N;g[l>>2]=K;K=ea(g[m>>2]);N=ea(K*K);M=ea(g[o>>2]);O=ea(N+ea(M*M));N=ea(g[q>>2]);g[n>>2]=ea(O+ea(N*N));g[p>>2]=K;g[r>>2]=M;g[s>>2]=N;N=ea(g[t>>2]);M=ea(N*N);K=ea(g[v>>2]);O=ea(M+ea(K*K));M=ea(g[x>>2]);g[u>>2]=ea(O+ea(M*M));g[w>>2]=N;g[y>>2]=K;g[z>>2]=M;M=ea(g[A>>2]);K=ea(M*M);N=ea(g[C>>2]);O=ea(K+ea(N*N));K=ea(g[E>>2]);g[B>>2]=ea(O+ea(K*K));g[D>>2]=M;g[F>>2]=N;g[G>>2]=K;K=ea(H);H=+I;N=ea(+J*.5/H);J=ea(+L*.5/H);L=ea(+K*.5/H);g[c>>2]=ea(T(ea(ea(ea(ea(N*N)+ea(J*J))+ea(L*L))-ea(ea(+bMc(e))/I))));g[b>>2]=N;g[b+4>>2]=J;g[b+8>>2]=L;i=d;return}function fmc(a,b,c,d){a=ea(a);b=ea(b);c=c|0;d=d|0;var e=Im,f=0,h=0,i=Im,j=0,k=Im,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=Im,u=0;e=ea(a/b);f=c+48|0;b=ea(g[f>>2]);h=c+52|0;i=ea(g[h>>2]);j=c+56|0;k=ea(g[j>>2]);g[d>>2]=b;g[d+4>>2]=i;g[d+8>>2]=k;k=ea(-e);i=ea(ea(g[c>>2])*k);l=c+16|0;b=ea(i+ea(ea(g[l>>2])*k));m=c+32|0;i=ea(b+ea(ea(g[m>>2])*a));b=ea(ea(g[f>>2])+i);n=c+4|0;i=ea(ea(g[n>>2])*k);o=c+20|0;p=ea(i+ea(ea(g[o>>2])*k));q=c+36|0;i=ea(p+ea(ea(g[q>>2])*a));p=ea(ea(g[h>>2])+i);r=c+8|0;i=ea(ea(g[r>>2])*k);s=c+24|0;t=ea(i+ea(ea(g[s>>2])*k));u=c+40|0;i=ea(t+ea(ea(g[u>>2])*a));t=ea(ea(g[j>>2])+i);g[d+12>>2]=b;g[d+16>>2]=p;g[d+20>>2]=t;t=ea(e*ea(g[c>>2]));p=ea(t+ea(ea(g[l>>2])*k));t=ea(p+ea(ea(g[m>>2])*a));p=ea(ea(g[f>>2])+t);t=ea(e*ea(g[n>>2]));b=ea(t+ea(ea(g[o>>2])*k));t=ea(b+ea(ea(g[q>>2])*a));b=ea(ea(g[h>>2])+t);t=ea(e*ea(g[r>>2]));i=ea(t+ea(ea(g[s>>2])*k));t=ea(i+ea(ea(g[u>>2])*a));i=ea(ea(g[j>>2])+t);g[d+24>>2]=p;g[d+28>>2]=b;g[d+32>>2]=i;i=ea(e*ea(g[c>>2]));b=ea(i+ea(e*ea(g[l>>2])));i=ea(b+ea(ea(g[m>>2])*a));b=ea(ea(g[f>>2])+i);i=ea(e*ea(g[n>>2]));p=ea(i+ea(e*ea(g[o>>2])));i=ea(p+ea(ea(g[q>>2])*a));p=ea(ea(g[h>>2])+i);i=ea(e*ea(g[r>>2]));t=ea(i+ea(e*ea(g[s>>2])));i=ea(t+ea(ea(g[u>>2])*a));t=ea(ea(g[j>>2])+i);g[d+36>>2]=b;g[d+40>>2]=p;g[d+44>>2]=t;t=ea(ea(g[c>>2])*k);p=ea(t+ea(e*ea(g[l>>2])));t=ea(p+ea(ea(g[m>>2])*a));p=ea(ea(g[f>>2])+t);t=ea(ea(g[n>>2])*k);b=ea(t+ea(e*ea(g[o>>2])));t=ea(b+ea(ea(g[q>>2])*a));b=ea(ea(g[h>>2])+t);t=ea(ea(g[r>>2])*k);k=ea(t+ea(e*ea(g[s>>2])));e=ea(k+ea(ea(g[u>>2])*a));a=ea(ea(g[j>>2])+e);g[d+48>>2]=p;g[d+52>>2]=b;g[d+56>>2]=a;return}function gmc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+16|0;m=l;n=b&255;if((b&255)<3){a[f>>0]=0;o=0;i=l;return o|0}g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);b=i;i=i+((1*n|0)+15&-16)|0;p=ea(g[e>>2]);q=ea(g[e+4>>2]);r=ea(g[e+8>>2]);s=ea(g[e+12>>2]);t=0;do{u=ea(p*ea(g[d+(t*12|0)>>2]));v=ea(u+ea(q*ea(g[d+(t*12|0)+4>>2])));a[b+t>>0]=ea(s+ea(v+ea(r*ea(g[d+(t*12|0)+8>>2]))))<ea(0.0)&1;t=t+1|0}while((t|0)<(n|0));t=0;w=0;a:while(1){x=t;while(1){y=x;x=x+1|0;z=(x|0)<(n|0);A=z?x:0;B=(a[b+A>>0]|0)==0;if(!(a[b+y>>0]|0)){if(B){C=A;D=x;E=z;F=17;break}if(umc(d+(y*12|0)|0,d+(A*12|0)|0,e,m)|0){G=x;H=z;F=16;break}}else if(B){I=A;J=x;K=z;L=y;F=9;break}if(!z){M=w;break a}}if((F|0)==9){F=0;x=d+(I*12|0)|0;if(umc(d+(L*12|0)|0,x,e,m)|0){z=h+((w&255)*12|0)|0;c[z+0>>2]=c[m+0>>2];c[z+4>>2]=c[m+4>>2];c[z+8>>2]=c[m+8>>2];z=a[j>>0]|0;a[j>>0]=z+1<<24>>24;y=k+((z&255)*12|0)|0;c[y+0>>2]=c[m+0>>2];c[y+4>>2]=c[m+4>>2];c[y+8>>2]=c[m+8>>2];N=w+1<<24>>24}else N=w;y=h+((N&255)*12|0)|0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];O=K;P=J;Q=N}else if((F|0)==16){F=0;x=h+((w&255)*12|0)|0;c[x+0>>2]=c[m+0>>2];c[x+4>>2]=c[m+4>>2];c[x+8>>2]=c[m+8>>2];x=a[j>>0]|0;a[j>>0]=x+1<<24>>24;y=k+((x&255)*12|0)|0;c[y+0>>2]=c[m+0>>2];c[y+4>>2]=c[m+4>>2];c[y+8>>2]=c[m+8>>2];O=H;P=G;Q=w}else if((F|0)==17){F=0;y=h+((w&255)*12|0)|0;x=d+(C*12|0)|0;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];O=E;P=D;Q=w}x=Q+1<<24>>24;if(O){t=P;w=x}else{M=x;break}}a[f>>0]=M;o=M<<24>>24!=0;i=l;return o|0}function hmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=357913941;r=(l|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2]}b=n+((((p|0)/-12|0)+o|0)*12|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*12|0);c[h>>2]=n+(m*12|0);if(!f){i=d;return}ACi(f);i=d;return}function imc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=0,s=0,t=Im,u=Im,v=Im;e=i;i=i+32|0;f=e+12|0;h=e;j=ea(g[150278]);k=ea(-j);l=ea(g[b>>2]);m=ea(l-ea(g[a>>2]));l=ea(g[b+4>>2]);n=ea(l-ea(g[a+4>>2]));l=ea(g[b+8>>2]);o=ea(l-ea(g[a+8>>2]));g[f>>2]=m;g[f+4>>2]=n;g[f+8>>2]=o;p=b+12|0;c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];p=a+12|0;o=m;a=0;m=j;j=k;while(1){k=ea(ea(1.0)/ea(g[p+(a<<2)>>2]));n=ea(g[h+(a<<2)>>2]);l=ea(k*ea(o+n));q=ea(k*ea(o-n));if(l<q){n=l>j?l:j;k=q<m?q:m;if(n>k|k<ea(0.0)){r=0;s=8;break}else{t=k;u=n}}else{n=q>j?q:j;q=l<m?l:m;if(n>q|q<ea(0.0)){r=0;s=8;break}else{t=q;u=n}}b=a+1|0;if((b|0)>=3){v=u;s=7;break}o=ea(g[f+(b<<2)>>2]);a=b;m=t;j=u}if((s|0)==7){g[d>>2]=v;r=1;i=e;return r|0}else if((s|0)==8){i=e;return r|0}return 0}function jmc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=0,l=0,m=Im,n=Im;c=i;d=ea(g[b>>2]);e=ea(d-ea(g[a>>2]));d=ea(g[b+4>>2]);f=ea(d-ea(g[a+4>>2]));d=ea(g[b+8>>2]);h=ea(d-ea(g[a+8>>2]));if(e<ea(0.0))j=ea(-e);else j=e;k=a+12|0;e=ea(g[k>>2]);a=b+12|0;if(!(j<ea(e+ea(g[a>>2])))){l=0;i=c;return l|0}if(f<ea(0.0))m=ea(-f);else m=f;f=ea(g[k+4>>2]);if(!(m<ea(f+ea(g[a+4>>2])))){l=0;i=c;return l|0}if(h<ea(0.0))n=ea(-h);else n=h;h=ea(g[k+8>>2]);l=n<ea(h+ea(g[a+8>>2]));i=c;return l|0}function kmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=0,h=0,j=0,k=Im,l=Im,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=ea(g[a>>2]);f=b+12|0;if(e>ea(g[f>>2])){h=0;i=d;return h|0}j=a+12|0;k=ea(g[j>>2]);l=ea(g[b>>2]);if(k<l){h=0;i=d;return h|0}m=a+4|0;k=ea(g[m>>2]);n=b+16|0;if(k>ea(g[n>>2])){h=0;i=d;return h|0}o=a+16|0;k=ea(g[o>>2]);p=b+4|0;if(k<ea(g[p>>2])){h=0;i=d;return h|0}q=a+8|0;k=ea(g[q>>2]);r=b+20|0;if(k>ea(g[r>>2])){h=0;i=d;return h|0}s=a+20|0;k=ea(g[s>>2]);t=b+8|0;if(k<ea(g[t>>2])){h=0;i=d;return h|0}if(!c){h=1;i=d;return h|0}g[c>>2]=ea(g[(e<l?b:a)>>2]);l=ea(g[f>>2]);e=ea(g[j>>2]);g[c+12>>2]=l<e?l:e;e=ea(g[m>>2]);l=ea(g[p>>2]);g[c+4>>2]=e<l?l:e;e=ea(g[n>>2]);l=ea(g[o>>2]);g[c+16>>2]=e<l?e:l;l=ea(g[q>>2]);e=ea(g[t>>2]);g[c+8>>2]=l<e?e:l;l=ea(g[r>>2]);e=ea(g[s>>2]);g[c+20>>2]=l<e?l:e;h=1;i=d;return h|0}function lmc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=0,l=0,m=Im,n=Im;c=i;d=ea(g[b>>2]);e=ea(d-ea(g[a>>2]));d=ea(g[b+4>>2]);f=ea(d-ea(g[a+4>>2]));d=ea(g[b+8>>2]);h=ea(d-ea(g[a+8>>2]));if(e<ea(0.0))j=ea(-e);else j=e;k=a+12|0;e=ea(g[k>>2]);a=b+12|0;if(!(j<=ea(e+ea(g[a>>2])))){l=0;i=c;return l|0}if(f<ea(0.0))m=ea(-f);else m=f;f=ea(g[k+4>>2]);if(!(m<=ea(f+ea(g[a+4>>2])))){l=0;i=c;return l|0}if(h<ea(0.0))n=ea(-h);else n=h;h=ea(g[k+8>>2]);l=n<=ea(h+ea(g[a+8>>2]));i=c;return l|0}function mmc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im;c=i;d=ea(Qlc(b,a));e=ea(g[b+12>>2]);b=d<ea(e*e);i=c;return b|0}function nmc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=0,P=0,Q=0,R=Im,S=Im,U=Im,V=Im,W=0,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im;f=i;i=i+208|0;h=f+184|0;j=f+144|0;k=f+80|0;l=f+16|0;m=f;if(!(d&2)){n=ea(g[b>>2]);o=ea(g[b+4>>2]);p=ea(g[b+8>>2]);if(!d)q=ea(1.0);else q=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(o*o))+ea(p*p)))));r=ea(g[e>>2]);s=ea(r-ea(g[b+48>>2]));r=ea(g[e+4>>2]);t=ea(r-ea(g[b+52>>2]));r=ea(g[e+8>>2]);u=ea(r-ea(g[b+56>>2]));r=ea(ea(ea(s*n)+ea(t*o))+ea(u*p));p=ea(s*ea(g[b+16>>2]));o=ea(p+ea(t*ea(g[b+20>>2])));p=ea(o+ea(u*ea(g[b+24>>2])));o=ea(s*ea(g[b+32>>2]));s=ea(o+ea(t*ea(g[b+36>>2])));t=ea(q*ea(q*r));r=ea(q*ea(q*p));p=ea(q*ea(q*ea(s+ea(u*ea(g[b+40>>2])))));u=ea(q*ea(g[e+12>>2]));g[h>>2]=t;g[h+4>>2]=r;g[h+8>>2]=p;d=h+12|0;g[d>>2]=u;u=ea(Qlc(h,a));p=ea(g[d>>2]);v=u<ea(p*p);i=f;return v|0}p=ea(g[b>>2]);u=ea(g[a>>2]);r=ea(p*u);t=ea(g[b+16>>2]);q=ea(g[a+4>>2]);s=ea(r+ea(t*q));r=ea(g[b+32>>2]);o=ea(g[a+8>>2]);n=ea(s+ea(r*o));s=ea(ea(g[b+48>>2])+n);n=ea(g[b+4>>2]);w=ea(u*n);x=ea(g[b+20>>2]);y=ea(w+ea(q*x));w=ea(g[b+36>>2]);z=ea(y+ea(o*w));y=ea(ea(g[b+52>>2])+z);z=ea(g[b+8>>2]);A=ea(u*z);u=ea(g[b+24>>2]);B=ea(A+ea(q*u));q=ea(g[b+40>>2]);A=ea(B+ea(o*q));o=ea(ea(g[b+56>>2])+A);A=ea(ea(g[e>>2])-s);s=ea(ea(g[e+4>>2])-y);y=ea(ea(g[e+8>>2])-o);o=ea(ea(ea(A*A)+ea(s*s))+ea(y*y));d=e+12|0;B=ea(g[d>>2]);if(o<ea(B*B)){v=1;i=f;return v|0}c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;g[j+16>>2]=ea(0.0);g[j+20>>2]=ea(0.0);g[j+24>>2]=ea(0.0);g[j+28>>2]=ea(0.0);g[j+32>>2]=ea(0.0);g[j>>2]=p;e=j+4|0;g[e>>2]=n;h=j+8|0;g[h>>2]=z;B=ea(T(ea(ea(z*z)+ea(ea(p*p)+ea(n*n)))));if(B>ea(0.0)){o=ea(ea(1.0)/B);C=ea(o*p);g[j>>2]=C;D=ea(o*n);g[e>>2]=D;E=ea(o*z);g[h>>2]=E;F=C;G=D;H=E}else{F=p;G=n;H=z}I=j+12|0;g[I>>2]=t;J=j+16|0;g[J>>2]=x;K=j+20|0;g[K>>2]=u;z=ea(T(ea(ea(u*u)+ea(ea(t*t)+ea(x*x)))));if(z>ea(0.0)){n=ea(ea(1.0)/z);p=ea(n*t);g[I>>2]=p;E=ea(n*x);g[J>>2]=E;D=ea(n*u);g[K>>2]=D;L=p;M=E;N=D}else{L=t;M=x;N=u}O=j+24|0;g[O>>2]=r;P=j+28|0;g[P>>2]=w;Q=j+32|0;g[Q>>2]=q;u=ea(T(ea(ea(q*q)+ea(ea(r*r)+ea(w*w)))));if(u>ea(0.0)){x=ea(ea(1.0)/u);t=ea(x*r);g[O>>2]=t;D=ea(x*w);g[P>>2]=D;E=ea(x*q);g[Q>>2]=E;R=t;S=D;U=E}else{R=r;S=w;U=q}q=ea(ea(ea(F*L)+ea(G*M))+ea(H*N));if(q<ea(0.0))V=ea(-q);else V=q;W=V<ea(0.0);q=W?ea(0.0):V;V=ea(ea(ea(L*R)+ea(M*S))+ea(N*U));if(V<ea(0.0))X=ea(-V);else X=V;V=X<q?q:X;X=ea(ea(ea(F*R)+ea(G*S))+ea(H*U));if(X<ea(0.0))Y=ea(-X);else Y=X;W=(Y<V?V:Y)>ea(.0000999999974);if(W){fMc(k,j,j+12|0,j+24|0)|0;rMc(k,l)|0;sMc(l)|0;Y=ea(g[150276]);V=ea(g[150284]);X=ea(g[150285]);q=ea(g[150286]);w=ea(g[l>>2]);r=ea(g[l+4>>2]);E=ea(g[l+8>>2]);D=ea(T(ea(ea(ea(w*w)+ea(r*r))+ea(E*E))));if(D>Y){Z=ea(w/D);_=ea(r/D);$=ea(E/D)}else{Z=V;_=X;$=q}g[j>>2]=Z;g[e>>2]=_;g[h>>2]=$;D=ea(g[l+16>>2]);E=ea(g[l+20>>2]);r=ea(g[l+24>>2]);w=ea(T(ea(ea(ea(D*D)+ea(E*E))+ea(r*r))));if(w>Y){aa=ea(D/w);ba=ea(E/w);ca=ea(r/w)}else{aa=V;ba=X;ca=q}g[I>>2]=aa;g[J>>2]=ba;g[K>>2]=ca;w=ea(g[l+32>>2]);r=ea(g[l+36>>2]);E=ea(g[l+40>>2]);D=ea(T(ea(ea(ea(w*w)+ea(r*r))+ea(E*E))));if(D>Y){da=ea(w/D);fa=ea(r/D);ga=ea(E/D)}else{da=V;fa=X;ga=q}g[O>>2]=da;g[P>>2]=fa;g[Q>>2]=ga;ha=Z;ia=_;ja=$;ka=aa;la=ba;ma=ca;na=da;oa=fa;pa=ga}else{ha=F;ia=G;ja=H;ka=L;la=M;ma=N;na=R;oa=S;pa=U}g[m>>2]=ea(0.0);Q=m+4|0;g[Q>>2]=ea(0.0);P=m+8|0;g[P>>2]=ea(0.0);O=a+12|0;U=ea(g[O>>2]);if(W){S=ea(g[b>>2]);R=ea(g[b+4>>2]);N=ea(U*S);S=ea(U*R);R=ea(U*ea(g[b+8>>2]));M=ea(g[j>>2]);L=ea(N*M);N=ea(g[j+4>>2]);H=ea(L+ea(S*N));S=ea(g[j+8>>2]);L=ea(H+ea(R*S));R=ea(ea(ea(A*M)+ea(s*N))+ea(y*S));if(R<ea(0.0))qa=ea(-R);else qa=R;if(L<ea(0.0))ra=ea(-L);else ra=L;L=ea(qa-ra);a=L<ea(0.0);g[m>>2]=a?ea(0.0):L;L=ea(g[O+4>>2]);ra=ea(g[b+16>>2]);qa=ea(g[b+20>>2]);R=ea(L*ra);ra=ea(L*qa);qa=ea(L*ea(g[b+24>>2]));L=ea(g[j+12>>2]);S=ea(R*L);R=ea(g[j+16>>2]);N=ea(S+ea(ra*R));ra=ea(g[j+20>>2]);S=ea(N+ea(qa*ra));qa=ea(ea(ea(A*L)+ea(s*R))+ea(y*ra));if(qa<ea(0.0))sa=ea(-qa);else sa=qa;if(S<ea(0.0))ta=ea(-S);else ta=S;S=ea(sa-ta);a=S<ea(0.0);g[m+4>>2]=a?ea(0.0):S;S=ea(g[O+8>>2]);ta=ea(g[b+32>>2]);sa=ea(g[b+36>>2]);qa=ea(S*ta);ta=ea(S*sa);sa=ea(S*ea(g[b+40>>2]));S=ea(g[j+24>>2]);ra=ea(qa*S);qa=ea(g[j+28>>2]);R=ea(ra+ea(ta*qa));ta=ea(g[j+32>>2]);ra=ea(R+ea(sa*ta));sa=ea(ea(ea(A*S)+ea(s*qa))+ea(y*ta));if(sa<ea(0.0))ua=ea(-sa);else ua=sa;if(ra<ea(0.0))va=ea(-ra);else va=ra;ra=ea(ua-va);j=ra<ea(0.0);g[m+8>>2]=j?ea(0.0):ra;wa=ea(g[m>>2])}else{ra=ea(U*B);B=ea(ea(ea(A*ha)+ea(s*ia))+ea(y*ja));if(B<ea(0.0))xa=ea(-B);else xa=B;if(ra<ea(0.0))ya=ea(-ra);else ya=ra;ra=ea(xa-ya);j=ra<ea(0.0);ya=j?ea(0.0):ra;g[m>>2]=ya;ra=ea(ea(g[O+4>>2])*z);z=ea(ea(ea(A*ka)+ea(s*la))+ea(y*ma));if(z<ea(0.0))za=ea(-z);else za=z;if(ra<ea(0.0))Aa=ea(-ra);else Aa=ra;ra=ea(za-Aa);j=ra<ea(0.0);g[m+4>>2]=j?ea(0.0):ra;ra=ea(ea(g[O+8>>2])*u);u=ea(ea(ea(A*na)+ea(s*oa))+ea(y*pa));if(u<ea(0.0))Ba=ea(-u);else Ba=u;if(ra<ea(0.0))Ca=ea(-ra);else Ca=ra;ra=ea(Ba-Ca);O=ra<ea(0.0);g[m+8>>2]=O?ea(0.0):ra;wa=ya}if(W){ya=ea(g[Q>>2]);ra=wa<ya?ya:wa;ya=ea(g[P>>2]);v=(ra<ya?ya:ra)<ea(g[d>>2]);i=f;return v|0}else{ra=ea(wa*wa);wa=ea(g[Q>>2]);ya=ea(ra+ea(wa*wa));wa=ea(g[P>>2]);ra=ea(ya+ea(wa*wa));wa=ea(g[d>>2]);v=ra<ea(wa*wa);i=f;return v|0}return 0}function omc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;d=i;if(!c){e=1;i=d;return e|0}f=ea(g[a>>2]);h=ea(g[a+4>>2]);j=ea(g[a+8>>2]);k=ea(g[a+12>>2]);l=ea(g[a+16>>2]);m=ea(g[a+20>>2]);a=b;b=1;while(1){if(b&c){n=ea(g[a>>2]);o=ea(n*f);p=ea(g[a+4>>2]);q=ea(o+ea(p*h));o=ea(g[a+8>>2]);r=ea(q+ea(o*j));q=ea(ea(g[a+12>>2])+r);if(n<ea(0.0))s=ea(-n);else s=n;if(p<ea(0.0))t=ea(-p);else t=p;if(o<ea(0.0))u=ea(-o);else u=o;if(ea(q+ea(ea(ea(s*k)+ea(t*l))+ea(u*m)))<ea(0.0)){e=0;v=12;break}}b=b<<1;if(b>>>0>c>>>0){e=1;v=12;break}else a=a+16|0}if((v|0)==12){i=d;return e|0}return 0}function pmc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0;c=i;d=ea(g[a>>2]);e=ea(g[a+4>>2]);f=ea(g[a+8>>2]);h=ea(g[a+12>>2]);j=ea(g[a+16>>2]);k=ea(g[a+20>>2]);a=b;b=0;while(1){l=ea(g[a>>2]);m=ea(d*l);n=ea(g[a+4>>2]);o=ea(m+ea(e*n));m=ea(g[a+8>>2]);p=ea(o+ea(f*m));o=ea(ea(g[a+12>>2])+p);if(l<ea(0.0))q=ea(-l);else q=l;if(n<ea(0.0))r=ea(-n);else r=n;if(m<ea(0.0))s=ea(-m);else s=m;if(ea(o+ea(ea(ea(h*q)+ea(j*r))+ea(k*s)))<ea(0.0)){t=0;u=10;break}b=b+1|0;if((b|0)>=6){t=1;u=10;break}else a=a+16|0}if((u|0)==10){i=c;return t|0}return 0}function qmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;d=i;if((c|0)<=0){e=1;i=d;return e|0}f=ea(g[a>>2]);h=ea(g[a+4>>2]);j=ea(g[a+8>>2]);k=ea(g[a+12>>2]);l=ea(g[a+16>>2]);m=ea(g[a+20>>2]);a=b;b=0;while(1){n=ea(g[a>>2]);o=ea(n*f);p=ea(g[a+4>>2]);q=ea(o+ea(p*h));o=ea(g[a+8>>2]);r=ea(q+ea(o*j));q=ea(ea(g[a+12>>2])+r);if(n<ea(0.0))s=ea(-n);else s=n;if(p<ea(0.0))t=ea(-p);else t=p;if(o<ea(0.0))u=ea(-o);else u=o;if(ea(q+ea(ea(ea(s*k)+ea(t*l))+ea(u*m)))<ea(0.0)){e=0;v=11;break}b=b+1|0;if((b|0)>=(c|0)){e=1;v=11;break}else a=a+16|0}if((v|0)==11){i=d;return e|0}return 0}function rmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im;d=i;if((b|0)<=0){e=0;i=d;return e|0}f=b+-1|0;h=0;do{j=h|1;k=h|2;l=h|3;m=a+(h<<4)|0;n=a+(((f|0)<(j|0)?f:j)<<4)|0;j=a+(((f|0)<(k|0)?f:k)<<4)|0;k=a+(((f|0)<(l|0)?f:l)<<4)|0;o=ea(g[m>>2]);p=ea(g[n>>2]);q=ea(g[j>>2]);r=ea(g[k>>2]);g[c+(h<<4)>>2]=o;g[c+(h<<4)+4>>2]=p;g[c+(h<<4)+8>>2]=q;g[c+(h<<4)+12>>2]=r;l=h|1;r=ea(g[m+4>>2]);q=ea(g[n+4>>2]);p=ea(g[j+4>>2]);o=ea(g[k+4>>2]);g[c+(l<<4)>>2]=r;g[c+(l<<4)+4>>2]=q;g[c+(l<<4)+8>>2]=p;g[c+(l<<4)+12>>2]=o;l=h|2;o=ea(g[m+8>>2]);p=ea(g[n+8>>2]);q=ea(g[j+8>>2]);r=ea(g[k+8>>2]);g[c+(l<<4)>>2]=o;g[c+(l<<4)+4>>2]=p;g[c+(l<<4)+8>>2]=q;g[c+(l<<4)+12>>2]=r;l=h|3;r=ea(g[m+12>>2]);q=ea(g[n+12>>2]);p=ea(g[j+12>>2]);o=ea(g[k+12>>2]);g[c+(l<<4)>>2]=r;g[c+(l<<4)+4>>2]=q;g[c+(l<<4)+8>>2]=p;g[c+(l<<4)+12>>2]=o;h=h+4|0}while((h|0)<(b|0));e=b+3&-4;i=d;return e|0}function smc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0;d=i;e=ea(g[a>>2]);f=ea(g[a+4>>2]);h=ea(g[a+8>>2]);j=ea(g[a+12>>2]);k=ea(g[a+16>>2]);l=ea(g[a+20>>2]);if((c|0)>0)m=0;else{n=1;i=d;return n|0}while(1){o=ea(g[b+(m<<4)>>2]);p=ea(g[b+(m<<4)+4>>2]);q=ea(g[b+(m<<4)+8>>2]);r=ea(g[b+(m<<4)+12>>2]);a=m|1;s=ea(g[b+(a<<4)>>2]);t=ea(g[b+(a<<4)+4>>2]);u=ea(g[b+(a<<4)+8>>2]);v=ea(g[b+(a<<4)+12>>2]);a=m|2;w=ea(g[b+(a<<4)>>2]);x=ea(g[b+(a<<4)+4>>2]);y=ea(g[b+(a<<4)+8>>2]);z=ea(g[b+(a<<4)+12>>2]);a=m|3;A=ea(g[b+(a<<4)>>2]);B=ea(g[b+(a<<4)+4>>2]);C=ea(g[b+(a<<4)+8>>2]);m=m+4|0;if((ea(ea(ea(h*x)+ea(ea(f*t)+ea(ea(e*p)+B)))+ea(ea(ea(j*ea(S(ea(p))))+ea(k*ea(S(ea(t)))))+ea(l*ea(S(ea(x))))))<ea(0.0)?1:ea(ea(ea(h*w)+ea(ea(f*s)+ea(ea(e*o)+A)))+ea(ea(ea(j*ea(S(ea(o))))+ea(k*ea(S(ea(s)))))+ea(l*ea(S(ea(w))))))<ea(0.0))|ea(ea(ea(h*y)+ea(ea(f*u)+ea(ea(e*q)+C)))+ea(ea(ea(j*ea(S(ea(q))))+ea(k*ea(S(ea(u)))))+ea(l*ea(S(ea(y))))))<ea(0.0)|ea(ea(ea(h*z)+ea(ea(f*v)+ea(ea(e*r)+ea(g[b+(a<<4)+12>>2]))))+ea(ea(ea(j*ea(S(ea(r))))+ea(k*ea(S(ea(v)))))+ea(l*ea(S(ea(z))))))<ea(0.0)){n=0;D=4;break}if((m|0)>=(c|0)){n=1;D=4;break}}if((D|0)==4){i=d;return n|0}return 0}function tmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=Im;d=i;if((c|0)<=0){e=ea(0.0);i=d;return ea(e)}f=ea(g[a>>2]);h=ea(g[a+4>>2]);j=ea(g[a+8>>2]);a=b;b=0;k=ea(-x);while(1){l=ea(ea(g[a>>2])*f);m=ea(l+ea(ea(g[a+4>>2])*h));l=ea(m+ea(ea(g[a+8>>2])*j));m=ea(ea(g[a+12>>2])+l);n=m<ea(0.0)&m>k;l=n?m:k;b=b+1|0;if((b|0)==(c|0)){o=l;break}else{a=a+16|0;k=l}}if(!(o!=ea(-x))){e=ea(0.0);i=d;return ea(e)}e=ea(-o);i=d;return ea(e)}function umc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0;e=i;f=ea(g[b>>2]);h=ea(g[a>>2]);j=ea(f-h);f=ea(g[b+4>>2]);k=ea(g[a+4>>2]);l=ea(f-k);f=ea(g[b+8>>2]);m=ea(g[a+8>>2]);n=ea(f-m);f=ea(g[c>>2]);o=ea(j*f);p=ea(g[c+4>>2]);q=ea(o+ea(l*p));o=ea(g[c+8>>2]);r=ea(q+ea(n*o));if(r<ea(0.0))s=ea(-r);else s=r;if(s<=ea(9.99999997e-07)){t=0;i=e;return t|0}s=ea(-ea(ea(ea(h*f)+ea(k*p))+ea(m*o)));o=ea(ea(s-ea(g[c+12>>2]))/r);if(o<ea(0.0)|o>ea(1.0)){t=0;i=e;return t|0}r=ea(k+ea(l*o));l=ea(m+ea(n*o));g[d>>2]=ea(h+ea(j*o));g[d+4>>2]=r;g[d+8>>2]=l;t=1;i=e;return t|0}function vmc(b,d,e,f,h){b=b|0;d=ea(d);e=ea(e);f=ea(f);h=h|0;var j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=Im,J=Im,K=0,L=0;j=i;k=ea(f*ea(2.0));l=~~ea(d+f);m=l+3&-4;n=~~ea(e+f);o=n+3&-4;a:do if(h){p=b;b:while(1){q=c[p>>2]|0;do if(!q){r=p+24|0;if(a[r>>0]|0){s=0;t=27;break b}u=p+16|0;v=ea(g[u>>2]);if(ea(ea(v-f)+ea(.5))<d){s=0;t=27;break b}w=p+20|0;x=ea(g[w>>2]);if(ea(ea(x-f)+ea(.5))<e){s=0;t=27;break b}y=ea(v-d);v=ea(x-e);if(!(!(y<=k)|!(v<=k))){z=r;A=p;break a}if(y<ea(4.0)&v<ea(4.0)){B=r;C=p;t=23;break b}r=xCi(28)|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;a[r+24>>0]=0;c[p>>2]=r;r=xCi(28)|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;a[r+24>>0]=0;D=p+4|0;c[D>>2]=r;r=c[p>>2]|0;E=p+8|0;x=ea(g[E>>2]);F=p+12|0;G=ea(g[F>>2]);if(y>v){v=ea(ea(x+d)+f);y=ea(v-x);v=ea(ea(G+ea(g[w>>2]))-G);g[r+8>>2]=x;g[r+12>>2]=G;g[r+16>>2]=y;g[r+20>>2]=v;H=c[D>>2]|0;v=ea(g[E>>2]);y=ea(ea(m|0)+v);I=ea(g[F>>2]);J=ea(v+ea(g[u>>2]));v=ea(J-y);J=ea(ea(I+ea(g[w>>2]))-I);g[H+8>>2]=y;g[H+12>>2]=I;g[H+16>>2]=v;g[H+20>>2]=J;K=p;break}else{J=ea(ea(x+ea(g[u>>2]))-x);v=ea(ea(ea(G+e)+f)-G);g[r+8>>2]=x;g[r+12>>2]=G;g[r+16>>2]=J;g[r+20>>2]=v;r=c[D>>2]|0;v=ea(g[E>>2]);J=ea(g[F>>2]);G=ea(ea(o|0)+J);x=ea(v+ea(g[u>>2]));I=ea(x-v);x=ea(ea(J+ea(g[w>>2]))-G);g[r+8>>2]=v;g[r+12>>2]=G;g[r+16>>2]=I;g[r+20>>2]=x;K=p;break}}else{r=vmc(q,d,e,f,1)|0;if(r){s=r;t=27;break b}K=p+4|0}while(0);p=c[K>>2]|0}if((t|0)==23){a[B>>0]=1;s=C;i=j;return s|0}else if((t|0)==27){i=j;return s|0}}else{p=b;c:while(1){q=c[p>>2]|0;do if(!q){r=p+24|0;if(a[r>>0]|0){s=0;t=27;break c}w=p+16|0;x=ea(g[w>>2]);if(ea(ea(x-f)+ea(.5))<d){s=0;t=27;break c}u=p+20|0;I=ea(g[u>>2]);if(ea(ea(I-f)+ea(.5))<e){s=0;t=27;break c}G=ea(x-d);x=ea(I-e);if(!(!(G<=k)|!(x<=k))){z=r;A=p;break a}r=xCi(28)|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;a[r+24>>0]=0;c[p>>2]=r;r=xCi(28)|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;a[r+24>>0]=0;F=p+4|0;c[F>>2]=r;r=c[p>>2]|0;E=p+8|0;I=ea(g[E>>2]);D=p+12|0;v=ea(g[D>>2]);if(G>x){x=ea(ea(I+d)+f);G=ea(x-I);x=ea(ea(v+ea(g[u>>2]))-v);g[r+8>>2]=I;g[r+12>>2]=v;g[r+16>>2]=G;g[r+20>>2]=x;H=c[F>>2]|0;x=ea(g[E>>2]);G=ea(ea(l|0)+x);J=ea(g[D>>2]);y=ea(x+ea(g[w>>2]));x=ea(y-G);y=ea(ea(J+ea(g[u>>2]))-J);g[H+8>>2]=G;g[H+12>>2]=J;g[H+16>>2]=x;g[H+20>>2]=y;L=p;break}else{y=ea(ea(I+ea(g[w>>2]))-I);x=ea(ea(ea(v+e)+f)-v);g[r+8>>2]=I;g[r+12>>2]=v;g[r+16>>2]=y;g[r+20>>2]=x;r=c[F>>2]|0;x=ea(g[E>>2]);y=ea(g[D>>2]);v=ea(ea(n|0)+y);I=ea(x+ea(g[w>>2]));J=ea(I-x);I=ea(ea(y+ea(g[u>>2]))-v);g[r+8>>2]=x;g[r+12>>2]=v;g[r+16>>2]=J;g[r+20>>2]=I;L=p;break}}else{r=vmc(q,d,e,f,0)|0;if(r){s=r;t=27;break c}L=p+4|0}while(0);p=c[L>>2]|0}if((t|0)==27){i=j;return s|0}}while(0);a[z>>0]=1;s=A;i=j;return s|0}function wmc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+48>>2]|0;a:do if(f){g=c[f+32>>2]|0;switch(g|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{break a;break}default:{}}if((g+-48|0)>>>0>=12)h=4}else h=4;while(0);if((h|0)==4)ko[c[(c[b>>2]|0)+160>>2]&4095](b);if(d){a[b+127>>0]=0;a[b+129>>0]=0}In[c[(c[b>>2]|0)+12>>2]&4095](b,0);i=e;return}function xmc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;l=i;i=i+48|0;m=l+24|0;n=l+12|0;o=l;p=c[155256]|0;q=(p|0)>(d|0)?d:p;c[m>>2]=0;p=m+4|0;c[p>>2]=0;c[m+8>>2]=0;if(e)Bmc(m,e);c[n>>2]=0;d=n+4|0;c[d>>2]=0;r=n+8|0;c[r>>2]=0;s=(e|0)>0;if(s){t=0;do{u=f+(t<<2)|0;v=c[u>>2]|0;do if(!v){c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[(c[m>>2]|0)+(t<<2)>>2]=-1}else{w=c[n>>2]|0;x=c[d>>2]|0;a:do if((w|0)==(x|0)){y=w;z=9}else{A=w;do{if((c[A>>2]|0)==(v|0)){y=A;z=9;break a}A=A+4|0}while((A|0)!=(x|0))}while(0);if((z|0)==9?(z=0,(y|0)!=(x|0)):0){c[(c[m>>2]|0)+(t<<2)>>2]=y-w>>2;break}c[(c[m>>2]|0)+(t<<2)>>2]=x-w>>2;if((x|0)==(c[r>>2]|0)){Cmc(n,u);break}if(!x)B=0;else{c[x>>2]=v;B=c[d>>2]|0}c[d>>2]=B+4}while(0);t=t+1|0}while((t|0)<(e|0));t=c[n>>2]|0;B=c[d>>2]|0;if((t|0)!=(B|0)){c[o>>2]=0;r=o+4|0;c[r>>2]=0;c[o+8>>2]=0;y=B-t>>2;if(!y){C=B;D=t;E=0}else{Dmc(o,y);C=c[d>>2]|0;D=c[n>>2]|0;E=c[o>>2]|0}y=(ymc(b,q,C-D>>2,D,E,h,0)|0)^1;if(y|s^1)F=y&1;else{y=c[m>>2]|0;s=c[o>>2]|0;h=0;do{E=c[y+(h<<2)>>2]|0;if((E|0)!=-1){D=g+(h<<4)|0;C=s+(E<<4)|0;c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[D+12>>2]=c[C+12>>2]}h=h+1|0}while((h|0)!=(e|0));F=0}e=c[o>>2]|0;if(e){o=c[r>>2]|0;if((o|0)!=(e|0))c[r>>2]=o+(~((o+-16-e|0)>>>4)<<4);ACi(e)}e=(F|0)!=0;if(e|j^1)G=e^1;else z=31}else z=30}else z=30;if((z|0)==30)if(j)z=31;else G=1;if((z|0)==31){j=c[b+48>>2]|0;b:do if(j){e=c[j+32>>2]|0;switch(e|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{break b;break}default:{}}if((e+-48|0)>>>0>=12)z=34}else z=34;while(0);if((z|0)==34)ko[c[(c[b>>2]|0)+160>>2]&4095](b);if(k){a[b+127>>0]=0;a[b+129>>0]=0}In[c[(c[b>>2]|0)+12>>2]&4095](b,0);G=1}b=c[n>>2]|0;if(b){n=c[d>>2]|0;if((n|0)!=(b|0))c[d>>2]=n+(~((n+-4-b|0)>>>2)<<2);ACi(b)}b=c[m>>2]|0;if(!b){i=l;return G|0}m=c[p>>2]|0;if((m|0)!=(b|0))c[p>>2]=m+(~((m+-4-b|0)>>>2)<<2);ACi(b);i=l;return G|0}function ymc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=Im,oa=Im,pa=Im,qa=0,ra=0,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;l=i;i=i+144|0;m=l;n=l+64|0;o=l+68|0;p=l+80|0;q=l+32|0;r=l+4|0;s=l+44|0;t=l+92|0;u=l+112|0;v=l+132|0;w=(d|0)<8?8:d;c[o>>2]=0;d=o+4|0;c[d>>2]=0;c[o+8>>2]=0;x=(e|0)!=0;do if(x){Emc(o,e);y=(e|0)>0;if(y){z=1;A=0;B=1;C=0;D=0;while(1){E=c[o>>2]|0;F=f+(A<<2)|0;G=c[F>>2]|0;H=E+(A<<3)|0;c[H>>2]=mo[c[(c[G>>2]|0)+104>>2]&4095](G)|0;G=c[F>>2]|0;I=mo[c[(c[G>>2]|0)+108>>2]&4095](G)|0;G=E+(A<<3)+4|0;c[G>>2]=I;E=c[H>>2]|0;if((E|0)>(w|0)&(E|0)>4){J=E;while(1){E=(J|0)/2|0;if((E|0)>(w|0)&(J|0)>9)J=E;else{K=E;break}}c[H>>2]=K;L=0}else L=B;if((I|0)>(w|0)&(I|0)>4){J=I;while(1){E=(J|0)/2|0;if((E|0)>(w|0)&(J|0)>9)J=E;else{M=E;break}}c[G>>2]=M;N=0}else N=L;J=c[F>>2]|0;I=c[J+48>>2]|0;if(I){H=c[I+32>>2]|0;if((H|0)==2|(H|0)==13){O=H;P=z}else{Q=H;R=12}}else{Q=5;R=12}if((R|0)==12){R=0;O=Q;P=0}if((O|0)==10|(O|0)==12)S=(N|0)==1&(O|0)==12?2:N;else S=0;H=mo[c[(c[J>>2]|0)+124>>2]&4095](J)|0;J=D|H^1;I=H|C;A=A+1|0;if((A|0)>=(e|0)){U=H;V=I;W=P;X=S;Y=C;Z=J;break}else{z=P;B=S;C=I;D=J}}_=y;$=W;aa=V?(Z?0:X):X;ba=U|Y}else{_=0;$=1;aa=1;ba=0}c[p>>2]=0;D=p+4|0;c[D>>2]=0;c[p+8>>2]=0;if(x){Bmc(p,e);C=c[p>>2]|0;if(_)ca=C;else{fa=p;ga=0;ha=D;ia=C;ja=$;ka=aa;la=ba;break}}else if(_)ca=0;else{fa=p;ga=0;ha=D;ia=0;ja=$;ka=aa;la=ba;break}C=0;do{c[ca+(C<<2)>>2]=C;C=C+1|0}while((C|0)!=(e|0));fa=p;ga=1;ha=D;ia=ca;ja=$;ka=aa;la=ba}else{c[p>>2]=0;D=p+4|0;c[D>>2]=0;c[p+8>>2]=0;fa=p;ga=0;ha=D;ia=0;ja=1;ka=1;la=0}while(0);p=c[ha>>2]|0;c[m>>2]=o;Fmc(ia,p,m);if(ga){p=c[o>>2]|0;ia=0;ba=0;while(1){aa=(da(c[p+(ia<<3)+4>>2]|0,c[p+(ia<<3)>>2]|0)|0)+ba|0;ia=ia+1|0;if((ia|0)==(e|0)){ma=aa;break}else ba=aa}}else ma=0;ba=(~~ea(T(ea(ma|0)))>>>0)+-1|0;ia=ba>>>16|ba;ba=ia>>>8|ia;ia=ba>>>4|ba;ba=ia>>>2|ia;ia=(ba>>>1|ba)+1|0;ba=(w|0)<(ia|0)?w:ia;ia=((ma|0)/(ba|0)|0)+-1|0;ma=ia>>>16|ia;ia=ma>>>8|ma;ma=ia>>>4|ia;ia=ma>>>2|ma;ma=(ia>>>1|ia)+1|0;c[q>>2]=0;ia=q+4|0;c[ia>>2]=0;c[q+8>>2]=0;if(x)Gmc(q,e);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;a[r+24>>0]=0;x=r+8|0;p=r+12|0;aa=r+16|0;$=r+20|0;na=ea(j|0);ca=(w|0)<(ma|0)?w:ma;ma=ba;ba=ka;ka=0;a:while(1){zmc(r);oa=ea(ma|0);pa=ea(ca|0);g[x>>2]=ea(0.0);g[p>>2]=ea(0.0);g[aa>>2]=oa;g[$>>2]=pa;_=(ba|0)!=0;if(ga)qa=0;else{ra=0;sa=ca;ta=ma;ua=ba;R=49;break}while(1){Y=c[(c[fa>>2]|0)+(qa<<2)>>2]|0;U=c[o>>2]|0;X=vmc(r,ea(c[U+(Y<<3)>>2]|0),ea(c[U+(Y<<3)+4>>2]|0),na,_)|0;c[(c[q>>2]|0)+(Y<<2)>>2]=X;qa=qa+1|0;if(!X)break;if((qa|0)>=(e|0)){va=oa;wa=pa;xa=ca;ya=ma;za=ba;R=30;break a}}_=(ma|0)==(w|0);X=(ca|0)==(w|0);do if(!(_&X)){if(_){Aa=ca<<1;Ba=w;Ca=ba;Da=ka;break}if(X){Aa=w;Ba=ma<<1;Ca=ba;Da=ka;break}if((ma|0)<(ca|0)){Aa=ca;Ba=ma<<1;Ca=ba;Da=ka;break}else{Aa=ca<<1;Ba=ma;Ca=ba;Da=ka;break}}else{Y=c[o>>2]|0;U=0;do{Z=Y+(U<<3)|0;V=c[Z>>2]|0;if((V|0)>4?(W=Y+(U<<3)+4|0,S=c[W>>2]|0,(S|0)>4):0){c[Z>>2]=(V*3|0)/4|0;c[W>>2]=(S*3|0)/4|0}U=U+1|0}while((U|0)!=(e|0));Aa=w;Ba=w;Ca=0;Da=ka+1|0}while(0);if((Da|0)<100){ca=Aa;ma=Ba;ba=Ca;ka=Da}else{Ea=0;break}}if((R|0)==30)if(ga){Da=c[fa>>2]|0;ka=c[o>>2]|0;Ca=c[q>>2]|0;ba=0;do{Ba=c[Da+(ba<<2)>>2]|0;ma=c[Ca+(Ba<<2)>>2]|0;na=ea(g[ma+8>>2]);pa=ea(na/va);oa=ea(g[ma+12>>2]);Fa=ea(oa/wa);Ga=ea(ea(ea(ea(c[ka+(Ba<<3)>>2]|0)+na)/va)-pa);na=ea(ea(ea(ea(c[ka+(Ba<<3)+4>>2]|0)+oa)/wa)-Fa);g[h+(Ba<<4)>>2]=pa;g[h+(Ba<<4)+4>>2]=Fa;g[h+(Ba<<4)+8>>2]=Ga;g[h+(Ba<<4)+12>>2]=na;ba=ba+1|0}while((ba|0)!=(e|0));ra=ga;sa=xa;ta=ya;ua=za;R=49}else{ra=0;sa=xa;ta=ya;ua=za;R=49}b:do if((R|0)==49){if((ua|0)==2)Ha=12;else if((ua|0)==1)Ha=10;else Ha=ja?2:5;if(!(gn[c[(c[b>>2]|0)+148>>2]&127](b,ta,sa,Ha,la&1|k,1,0)|0)){Krd(578072,0,3653512,458,1,0,0,0);Ea=0;break}zEc(b);za=b+48|0;ya=c[za>>2]|0;xa=(ya|0)==0;if(ua){if(xa)Ia=0;else Ia=c[ya+8>>2]|0;ga=(Ha|0)==10?8:16;zEc(b);ba=c[za>>2]|0;if(!ba)Ja=0;else Ja=(c[ba+8>>2]|0)+(c[ba+36>>2]|0)|0;PEi(Ia|0,0,Ja-Ia|0)|0;if(!ra){Ea=1;break}ba=v+1|0;h=v+8|0;ka=(Ha|0)==12;Ca=0;while(1){Da=c[(c[fa>>2]|0)+(Ca<<2)>>2]|0;Ba=c[o>>2]|0;ma=c[Ba+(Da<<3)>>2]|0;Aa=c[Ba+(Da<<3)+4>>2]|0;Ba=c[f+(Da<<2)>>2]|0;ca=yEc(Ba)|0;w=yEc(b)|0;qa=(w|0)<(ca|0)?w:ca;ca=c[(c[q>>2]|0)+(Da<<2)>>2]|0;Da=Ba+48|0;w=c[Da>>2]|0;c:do if((w|0)!=0?($=c[w+8>>2]|0,($|0)!=0):0){aa=~~ea(g[ca+8>>2]);p=~~ea(g[ca+12>>2]);x=~~ea(g[ca+16>>2]);X=~~ea(g[ca+20>>2]);if((qa|0)>0){_=w;U=Ia;Y=sa;F=ta;G=aa;aa=p;p=X;X=x;x=1;S=$;$=Aa;W=ma;while(1){V=U+(da(((da((aa|0)/4|0,F)|0)/4|0)+((G|0)/4|0)|0,ga)|0)|0;if(!_)Ka=5;else Ka=c[_+32>>2]|0;if((Ka|0)!=(Ha|0)){if((Ka|0)==10&ka)awc(S,W,$,V,F,Y)}else $vc(Ha,S,W,$,V,F,Y,0);V=S+(dwc(W,$,Ka)|0)|0;Z=dwc(F,Y,Ha)|0;P=(G|0)/2|0;N=(aa|0)/2|0;O=(F|0)/2|0;Q=(Y|0)/2|0;L=(W|0)/2|0;M=($|0)/2|0;if((N|P)&3)break c;if(!((p|0)>7&(X|0)>7&(x|0)<(qa|0)))break c;_=c[Da>>2]|0;U=U+Z|0;Y=(Q|0)<4?4:Q;F=(O|0)<4?4:O;G=P;aa=N;p=(p|0)/2|0;X=(X|0)/2|0;x=x+1|0;S=V;$=(M|0)<4?4:M;W=(L|0)<4?4:L}}}else R=95;while(0);if((R|0)==95){R=0;c[m>>2]=mo[c[(c[Ba>>2]|0)+32>>2]&4095](Ba)|0;Lsd(v,578104,m);Krd((a[v>>0]&1)==0?ba:c[h>>2]|0,0,3653512,613,1,0,0,0);xri(v)}Ca=Ca+1|0;if((Ca|0)>=(e|0)){Ea=1;break b}}}if(xa)La=0;else La=c[ya+8>>2]|0;zEc(b);Ca=c[za>>2]|0;if(!Ca)Ma=0;else Ma=(c[Ca+8>>2]|0)+(c[Ca+36>>2]|0)|0;PEi(La|0,0,Ma-La|0)|0;Ca=yEc(b)|0;if(ra){h=u+4|0;ba=u+8|0;ka=0;ga=0;while(1){Da=c[(c[fa>>2]|0)+(ga<<2)>>2]|0;qa=c[o>>2]|0;ma=c[qa+(Da<<3)>>2]|0;Aa=c[qa+(Da<<3)+4>>2]|0;qa=c[(c[q>>2]|0)+(Da<<2)>>2]|0;wa=ea(g[qa+8>>2]);va=ea(g[qa+12>>2]);w=~~ea(g[qa+16>>2])-j|0;ca=(w|0)>1?w:1;w=~~ea(g[qa+20>>2])-j|0;qa=(w|0)>1?w:1;w=f+(Da<<2)|0;Da=yEc(c[w>>2]|0)|0;W=(Ca|0)<(Da|0)?Ca:Da;if(!W)Na=ka;else{Da=ma;$=Aa;S=ka;x=~~wa;X=~~va;p=(qa|0)<(Aa|0)?qa:Aa;Aa=(ca|0)<(ma|0)?ca:ma;ma=0;while(1){c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;DEc(b,s,0,ma)|0;lwc(t,s,x,X,Aa,p);c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;if(DEc(c[w>>2]|0,u,0,ma)|0){if((Aa|0)==(c[h>>2]|0))Oa=(p|0)==(c[ba>>2]|0)?0:2;else Oa=2;hwc(t,u,Oa);Pa=S}else{if(!S){ca=xCi(20)|0;mwc(ca,Da,$,4);Qa=ca}else{nwc(S,Da,$,4,0);Qa=S}ca=c[w>>2]|0;xo[c[(c[ca>>2]|0)+96>>2]&2047](ca,Qa,0)|0;if((Aa|0)==(c[Qa+4>>2]|0))Ra=(p|0)==(c[Qa+8>>2]|0)?0:2;else Ra=2;hwc(t,Qa,Ra);Pa=Qa}ca=(Da|0)/2|0;qa=($|0)/2|0;ma=ma+1|0;if((ma|0)==(W|0)){Na=Pa;break}else{Da=(ca|0)<1?1:ca;$=(qa|0)<1?1:qa;S=Pa;x=(x|0)/2|0;X=(X|0)/2|0;p=(p|0)/2|0;Aa=(Aa|0)/2|0}}}ga=ga+1|0;if((ga|0)>=(e|0)){Sa=Na;break}else ka=Na}if(Sa){ka=c[Sa+16>>2]|0;c[n>>2]=c[153068];c[m+0>>2]=c[n+0>>2];eOb(ka,m);ACi(Sa);Ea=1}else Ea=1}else Ea=1}while(0);Amc(r);r=c[q>>2]|0;if(r){q=c[ia>>2]|0;if((q|0)!=(r|0))c[ia>>2]=q+(~((q+-4-r|0)>>>2)<<2);ACi(r)}r=c[fa>>2]|0;if(r){fa=c[ha>>2]|0;if((fa|0)!=(r|0))c[ha>>2]=fa+(~((fa+-4-r|0)>>>2)<<2);ACi(r)}r=c[o>>2]|0;if(!r){i=l;return Ea|0}o=c[d>>2]|0;if((o|0)!=(r|0))c[d>>2]=o+(~((o+-8-r|0)>>>3)<<3);ACi(r);i=l;return Ea|0}function zmc(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b>>2]|0;if(e){Amc(e);ACi(e)}e=b+4|0;f=c[e>>2]|0;if(f){Amc(f);ACi(f)}c[b>>2]=0;c[e>>2]=0;a[b+24>>0]=0;i=d;return}function Amc(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(d){Amc(d);ACi(d)}d=c[a+4>>2]|0;if(!d){i=b;return}Amc(d);ACi(d);i=b;return}function Bmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;while(1){if(l)c[l>>2]=0;k=k+-1|0;if(!k)break;else l=l+4|0}c[g>>2]=h+(b<<2);i=d;return}h=c[a>>2]|0;l=(j-h>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=h;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j|0;l=f>>2;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=(c[g>>2]|0)-j|0;q=1073741823;r=f>>2;s=f;t=11}if((t|0)==11){m=q;n=xCi(q<<2)|0;o=r;p=s}s=b;r=n+(o<<2)|0;while(1){if(r)c[r>>2]=0;s=s+-1|0;if(!s)break;else r=r+4|0}YEi(n|0,h|0,p|0)|0;p=c[a>>2]|0;c[a>>2]=n;c[g>>2]=n+(o+b<<2);c[e>>2]=n+(m<<2);if(!p){i=d;return}ACi(p);i=d;return}function Cmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function Dmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>4>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;m=c[g>>2]|0}l=m+16|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>4)+b|0;if(l>>>0>268435455)vxi(a);j=k;k=f-j|0;if(k>>4>>>0<134217727){f=k>>3;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>4;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=268435455;r=(c[g>>2]|0)-j>>4;s=10}if((s|0)==10){n=q;o=xCi(q<<4)|0;p=r}r=b;b=o+(p<<4)|0;while(1){if(!b)t=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;t=b}q=t+16|0;r=r+-1|0;if(!r){u=q;break}else b=q}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;t=o+(p-(r>>4)<<4)|0;YEi(t|0,b|0,r|0)|0;c[a>>2]=t;c[g>>2]=u;c[e>>2]=o+(n<<4);if(!b){i=d;return}ACi(b);i=d;return}function Emc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>3>>>0>=b>>>0){k=b;l=h;while(1){if(l){c[l>>2]=0;c[l+4>>2]=0}k=k+-1|0;if(!k)break;else l=l+8|0}c[g>>2]=h+(b<<3);i=d;return}h=c[a>>2]|0;l=(j-h>>3)+b|0;if(l>>>0>536870911)vxi(a);j=h;k=f-j|0;if(k>>3>>>0<268435455){f=k>>2;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j|0;l=f>>3;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=(c[g>>2]|0)-j|0;q=536870911;r=f>>3;s=f;t=11}if((t|0)==11){m=q;n=xCi(q<<3)|0;o=r;p=s}s=b;r=n+(o<<3)|0;while(1){if(r){c[r>>2]=0;c[r+4>>2]=0}s=s+-1|0;if(!s)break;else r=r+8|0}YEi(n|0,h|0,p|0)|0;p=c[a>>2]|0;c[a>>2]=n;c[g>>2]=n+(o+b<<3);c[e>>2]=n+(m<<3);if(!p){i=d;return}ACi(p);i=d;return}function Fmc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-4|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>2;switch(l|0){case 5:{m=h;n=g;o=8;break a;break}case 3:{p=h;q=g;o=6;break a;break}case 2:{r=h;s=g;o=4;break a;break}case 4:{t=h;u=g;o=7;break a;break}case 1:case 0:{o=52;break a;break}default:{}}if((k|0)<124){v=h;w=a;o=10;break a}x=(l|0)/2|0;y=h+(x<<2)|0;if((k|0)>3996){k=(l|0)/4|0;z=Jmc(h,h+(k<<2)|0,y,h+(k+x<<2)|0,g,d)|0}else z=Hmc(h,y,g,d)|0;x=c[h>>2]|0;k=c[y>>2]|0;l=c[c[d>>2]>>2]|0;A=da(c[l+(x<<3)+4>>2]|0,c[l+(x<<3)>>2]|0)|0;B=da(c[l+(k<<3)+4>>2]|0,c[l+(k<<3)>>2]|0)|0;do if((A|0)>(B|0)){C=g;D=z}else{k=a;E=g;while(1){F=k+-8|0;if((h|0)==(F|0))break;G=c[F>>2]|0;if((da(c[l+(G<<3)+4>>2]|0,c[l+(G<<3)>>2]|0)|0)>(B|0)){H=G;I=F;o=34;break}else{G=E;E=F;k=G}}if((o|0)==34){o=0;c[h>>2]=H;c[I>>2]=x;C=I;D=z+1|0;break}k=h+4|0;E=c[g>>2]|0;if((A|0)>(da(c[l+(E<<3)+4>>2]|0,c[l+(E<<3)>>2]|0)|0))J=k;else{if((k|0)==(g|0)){o=52;break a}else{K=h;L=k}while(1){k=c[L>>2]|0;G=K+8|0;if((A|0)>(da(c[l+(k<<3)+4>>2]|0,c[l+(k<<3)>>2]|0)|0)){M=k;N=L;break}if((G|0)==(g|0)){o=52;break a}else{k=L;L=G;K=k}}c[N>>2]=E;c[g>>2]=M;J=N+4|0}if((J|0)==(g|0)){o=52;break a}else{O=J;P=g}while(1){k=c[h>>2]|0;G=c[c[d>>2]>>2]|0;F=da(c[G+(k<<3)+4>>2]|0,c[G+(k<<3)>>2]|0)|0;k=O;while(1){Q=c[k>>2]|0;R=k+4|0;if((F|0)>(da(c[G+(Q<<3)+4>>2]|0,c[G+(Q<<3)>>2]|0)|0)){S=Q;T=R;U=k;break}else k=R}k=P;while(1){R=k+-4|0;Q=c[R>>2]|0;if((F|0)>(da(c[G+(Q<<3)+4>>2]|0,c[G+(Q<<3)>>2]|0)|0))k=R;else{V=R;W=Q;break}}if(U>>>0>=V>>>0){h=U;continue b}c[U>>2]=W;c[V>>2]=S;O=T;P=V}}while(0);l=h+4|0;c:do if(l>>>0<C>>>0){A=l;x=C;B=y;E=D;while(1){k=c[B>>2]|0;G=c[c[d>>2]>>2]|0;F=da(c[G+(k<<3)+4>>2]|0,c[G+(k<<3)>>2]|0)|0;k=A;while(1){Q=c[k>>2]|0;R=k+4|0;if((da(c[G+(Q<<3)+4>>2]|0,c[G+(Q<<3)>>2]|0)|0)>(F|0))k=R;else{X=Q;Y=R;Z=k;break}}k=x;while(1){R=k+-4|0;Q=c[R>>2]|0;if((da(c[G+(Q<<3)+4>>2]|0,c[G+(Q<<3)>>2]|0)|0)>(F|0)){_=R;$=Q;break}else k=R}if(Z>>>0>_>>>0){aa=Z;ba=B;ca=E;break c}c[Z>>2]=$;c[_>>2]=X;A=Y;x=_;B=(B|0)==(Z|0)?_:B;E=E+1|0}}else{aa=l;ba=y;ca=D}while(0);if((aa|0)!=(ba|0)?(y=c[ba>>2]|0,l=c[aa>>2]|0,E=c[c[d>>2]>>2]|0,B=da(c[E+(y<<3)+4>>2]|0,c[E+(y<<3)>>2]|0)|0,(B|0)>(da(c[E+(l<<3)+4>>2]|0,c[E+(l<<3)>>2]|0)|0)):0){c[aa>>2]=y;c[ba>>2]=l;ea=ca+1|0}else ea=ca;if(!ea){fa=Kmc(h,aa,d)|0;l=aa+4|0;if(Kmc(l,a,d)|0){o=47;break}if(fa){h=l;continue}}l=aa;if((l-j|0)>=(b-l|0)){ga=h;ha=aa;o=51;break}Fmc(h,aa,d);h=aa+4|0}if((o|0)==47){o=0;if(fa){o=52;break}else{f=h;a=aa;continue}}else if((o|0)==51){o=0;Fmc(ha+4|0,a,d);f=ga;a=ha;continue}}if((o|0)==4){ha=c[s>>2]|0;a=c[r>>2]|0;ga=c[c[d>>2]>>2]|0;f=da(c[ga+(ha<<3)+4>>2]|0,c[ga+(ha<<3)>>2]|0)|0;if((f|0)<=(da(c[ga+(a<<3)+4>>2]|0,c[ga+(a<<3)>>2]|0)|0)){i=e;return}c[r>>2]=ha;c[s>>2]=a;i=e;return}else if((o|0)==6){Hmc(p,p+4|0,q,d)|0;i=e;return}else if((o|0)==7){Imc(t,t+4|0,t+8|0,u,d)|0;i=e;return}else if((o|0)==8){Jmc(m,m+4|0,m+8|0,m+12|0,n,d)|0;i=e;return}else if((o|0)==10){n=v+8|0;Hmc(v,v+4|0,n,d)|0;m=v+12|0;if((m|0)==(w|0)){i=e;return}else{ia=m;ja=n}while(1){n=c[ia>>2]|0;m=c[ja>>2]|0;u=c[c[d>>2]>>2]|0;t=da(c[u+(n<<3)+4>>2]|0,c[u+(n<<3)>>2]|0)|0;if((t|0)>(da(c[u+(m<<3)+4>>2]|0,c[u+(m<<3)>>2]|0)|0)){u=m;m=ia;t=ja;while(1){c[m>>2]=u;if((t|0)==(v|0)){ka=v;break}q=t+-4|0;u=c[q>>2]|0;p=c[c[d>>2]>>2]|0;a=da(c[p+(n<<3)+4>>2]|0,c[p+(n<<3)>>2]|0)|0;if((a|0)<=(da(c[p+(u<<3)+4>>2]|0,c[p+(u<<3)>>2]|0)|0)){ka=t;break}else{p=t;t=q;m=p}}c[ka>>2]=n}m=ia+4|0;if((m|0)==(w|0))break;else{t=ia;ia=m;ja=t}}i=e;return}else if((o|0)==52){i=e;return}}function Gmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l>>2]=0;m=c[g>>2]|0}l=m+4|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=k;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>2;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=1073741823;r=(c[g>>2]|0)-j>>2;s=10}if((s|0)==10){n=q;o=xCi(q<<2)|0;p=r}r=b;b=o+(p<<2)|0;while(1){if(!b)t=0;else{c[b>>2]=0;t=b}q=t+4|0;r=r+-1|0;if(!r){u=q;break}else b=q}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;t=o+(p-(r>>2)<<2)|0;YEi(t|0,b|0,r|0)|0;c[a>>2]=t;c[g>>2]=u;c[e>>2]=o+(n<<2);if(!b){i=d;return}ACi(b);i=d;return}function Hmc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=c[b>>2]|0;h=c[a>>2]|0;j=c[c[e>>2]>>2]|0;k=da(c[j+(g<<3)+4>>2]|0,c[j+(g<<3)>>2]|0)|0;l=(k|0)>(da(c[j+(h<<3)+4>>2]|0,c[j+(h<<3)>>2]|0)|0);m=c[d>>2]|0;n=(da(c[j+(m<<3)+4>>2]|0,c[j+(m<<3)>>2]|0)|0)>(k|0);if(!l){if(!n){o=0;i=f;return o|0}c[b>>2]=m;c[d>>2]=g;l=c[b>>2]|0;k=c[a>>2]|0;j=c[c[e>>2]>>2]|0;p=da(c[j+(l<<3)+4>>2]|0,c[j+(l<<3)>>2]|0)|0;if((p|0)<=(da(c[j+(k<<3)+4>>2]|0,c[j+(k<<3)>>2]|0)|0)){o=1;i=f;return o|0}c[a>>2]=l;c[b>>2]=k;o=2;i=f;return o|0}if(n){c[a>>2]=m;c[d>>2]=h;o=1;i=f;return o|0}c[a>>2]=g;c[b>>2]=h;g=c[d>>2]|0;a=c[c[e>>2]>>2]|0;e=da(c[a+(g<<3)+4>>2]|0,c[a+(g<<3)>>2]|0)|0;if((e|0)<=(da(c[a+(h<<3)+4>>2]|0,c[a+(h<<3)>>2]|0)|0)){o=1;i=f;return o|0}c[b>>2]=g;c[d>>2]=h;o=2;i=f;return o|0}function Imc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;h=Hmc(a,b,d,f)|0;j=c[e>>2]|0;k=c[d>>2]|0;l=c[c[f>>2]>>2]|0;m=da(c[l+(j<<3)+4>>2]|0,c[l+(j<<3)>>2]|0)|0;if((m|0)<=(da(c[l+(k<<3)+4>>2]|0,c[l+(k<<3)>>2]|0)|0)){n=h;i=g;return n|0}c[d>>2]=j;c[e>>2]=k;k=c[d>>2]|0;e=c[b>>2]|0;j=c[c[f>>2]>>2]|0;l=da(c[j+(k<<3)+4>>2]|0,c[j+(k<<3)>>2]|0)|0;if((l|0)<=(da(c[j+(e<<3)+4>>2]|0,c[j+(e<<3)>>2]|0)|0)){n=h+1|0;i=g;return n|0}c[b>>2]=k;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;k=c[c[f>>2]>>2]|0;f=da(c[k+(e<<3)+4>>2]|0,c[k+(e<<3)>>2]|0)|0;if((f|0)<=(da(c[k+(d<<3)+4>>2]|0,c[k+(d<<3)>>2]|0)|0)){n=h+2|0;i=g;return n|0}c[a>>2]=e;c[b>>2]=d;n=h+3|0;i=g;return n|0}function Jmc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;j=Imc(a,b,d,e,g)|0;k=c[f>>2]|0;l=c[e>>2]|0;m=c[c[g>>2]>>2]|0;n=da(c[m+(k<<3)+4>>2]|0,c[m+(k<<3)>>2]|0)|0;if((n|0)<=(da(c[m+(l<<3)+4>>2]|0,c[m+(l<<3)>>2]|0)|0)){o=j;i=h;return o|0}c[e>>2]=k;c[f>>2]=l;l=c[e>>2]|0;f=c[d>>2]|0;k=c[c[g>>2]>>2]|0;m=da(c[k+(l<<3)+4>>2]|0,c[k+(l<<3)>>2]|0)|0;if((m|0)<=(da(c[k+(f<<3)+4>>2]|0,c[k+(f<<3)>>2]|0)|0)){o=j+1|0;i=h;return o|0}c[d>>2]=l;c[e>>2]=f;f=c[d>>2]|0;e=c[b>>2]|0;l=c[c[g>>2]>>2]|0;k=da(c[l+(f<<3)+4>>2]|0,c[l+(f<<3)>>2]|0)|0;if((k|0)<=(da(c[l+(e<<3)+4>>2]|0,c[l+(e<<3)>>2]|0)|0)){o=j+2|0;i=h;return o|0}c[b>>2]=f;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;f=c[c[g>>2]>>2]|0;g=da(c[f+(e<<3)+4>>2]|0,c[f+(e<<3)>>2]|0)|0;if((g|0)<=(da(c[f+(d<<3)+4>>2]|0,c[f+(d<<3)>>2]|0)|0)){o=j+3|0;i=h;return o|0}c[a>>2]=e;c[b>>2]=d;o=j+4|0;i=h;return o|0}function Kmc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;switch(b-a>>2|0){case 2:{f=b+-4|0;g=c[f>>2]|0;h=c[a>>2]|0;j=c[c[d>>2]>>2]|0;if((da(c[j+(g<<3)+4>>2]|0,c[j+(g<<3)>>2]|0)|0)<=(da(c[j+(h<<3)+4>>2]|0,c[j+(h<<3)>>2]|0)|0)){k=1;i=e;return k|0}c[a>>2]=g;c[f>>2]=h;k=1;i=e;return k|0}case 4:{Imc(a,a+4|0,a+8|0,b+-4|0,d)|0;k=1;i=e;return k|0}case 5:{Jmc(a,a+4|0,a+8|0,a+12|0,b+-4|0,d)|0;k=1;i=e;return k|0}case 3:{Hmc(a,a+4|0,b+-4|0,d)|0;k=1;i=e;return k|0}case 1:case 0:{k=1;i=e;return k|0}default:{h=a+8|0;Hmc(a,a+4|0,h,d)|0;f=a+12|0;if((f|0)==(b|0)){k=1;i=e;return k|0}g=0;j=f;f=h;while(1){h=c[j>>2]|0;l=c[f>>2]|0;m=c[c[d>>2]>>2]|0;n=da(c[m+(h<<3)+4>>2]|0,c[m+(h<<3)>>2]|0)|0;if((n|0)>(da(c[m+(l<<3)+4>>2]|0,c[m+(l<<3)>>2]|0)|0)){m=l;l=j;n=f;while(1){c[l>>2]=m;if((n|0)==(a|0)){o=a;break}p=n+-4|0;m=c[p>>2]|0;q=c[c[d>>2]>>2]|0;r=da(c[q+(h<<3)+4>>2]|0,c[q+(h<<3)>>2]|0)|0;if((r|0)<=(da(c[q+(m<<3)+4>>2]|0,c[q+(m<<3)>>2]|0)|0)){o=n;break}else{q=n;n=p;l=q}}c[o>>2]=h;l=g+1|0;if((l|0)==8){s=j;break}else t=l}else t=g;l=j+4|0;if((l|0)==(b|0)){k=1;u=15;break}else{n=j;g=t;j=l;f=n}}if((u|0)==15){i=e;return k|0}k=(s+4|0)==(b|0);i=e;return k|0}}return 0}function Lmc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=i;i=i+368|0;f=e+44|0;g=e+224|0;h=e+180|0;j=e+136|0;k=e+300|0;l=e+344|0;m=e+256|0;n=e;o=ync()|0;p=c[(c[(c[b>>2]|0)+64>>2]|0)+168>>2]|0;q=(p|0)!=0;if(q)In[c[(c[o>>2]|0)+220>>2]&4095](o,p);r=d+4|0;s=c[r>>2]|0;t=s&124;u=4;while(1)if(u>>>0<=t>>>0&(u&t|0)==0)u=u<<1;else{v=u;break}if(v>>>0>t>>>0)w=s;else{u=s;x=v;while(1){v=x|u;x=x<<1;if(x>>>0>t>>>0){w=v;break}else u=v}}u=(a[b+8>>0]|0)==0;t=c[b>>2]|0;x=c[b+4>>2]|0;b=t+(x*76|0)|0;if(!x){i=e;return}x=w-(w>>>1&1431655765)|0;v=(x>>>2&858993459)+(x&858993459)|0;x=(da((v>>>4)+v&252645135,16843009)|0)>>>24;v=w&124;y=v>>>0>3;z=t;while(1){t=c[z+64>>2]|0;A=a[t+40>>0]|0;do if(A<<24>>24!=1)if((A&255)>9){B=0;C=mo[c[(c[t>>2]|0)+68>>2]&4095](t)|0;D=0;E=15;break}else{c[h>>2]=0;E=17;break}else{F=t+-28|0;G=Khc(F)|0;H=Rhc(F)|0;B=H;C=G;D=Ghc(F)|0;E=15}while(0);do if((E|0)==15){E=0;c[h>>2]=0;if(C){sec(j,C,s,0);t=h+0|0;A=j+0|0;F=t+44|0;do{c[t>>2]=c[A>>2];t=t+4|0;A=A+4|0}while((t|0)<(F|0));if(c[h>>2]|0){A=c[z+68>>2]|0;if(!(iec(C)|0))I=0;else I=(iec(C)|0)+-1|0;G=(I|0)<(A|0)?I:A;A=c[C+44>>2]|0;H=c[A+(G*56|0)>>2]|0;J=c[A+(G*56|0)+20>>2]|0;K=(H|0)==1;L=(c[A+(G*56|0)+8>>2]|0)+(K&1)|0;G=z+76|0;if(!D)if((!((c[h>>2]|0)==0|u)?(A=c[C+28>>2]|0,((J|0)<301?(c[A+108>>2]|0)!=(c[A+112>>2]|0):0)&(da(J,x)|0)<901):0)?((L|0)<32e3?(c[z+72>>2]&4|0)==0:0)&(H|0)!=4&(B|0)==0:0){M=c[A+96>>2]&w;Lic(l,A+8|0);a:do if((G|0)==(b|0)){N=L;O=J;P=b}else{A=z;Q=L;R=J;S=G;while(1){if(c[A+148>>2]&4){N=Q;O=R;P=S;break a}T=c[A+140>>2]|0;U=a[T+40>>0]|0;if(U<<24>>24==1){V=T+-28|0;W=Khc(V)|0;X=Rhc(V)|0;Y=W;Z=(Ghc(V)|0)!=0;_=(X|0)!=0}else{if((U&255)<=9){N=Q;O=R;P=S;break a}Y=mo[c[(c[T>>2]|0)+68>>2]&4095](T)|0;Z=0;_=0}if(Z|(Y|0)==0|_){N=Q;O=R;P=S;break a}T=c[A+144>>2]|0;if(!(iec(Y)|0))$=0;else $=(iec(Y)|0)+-1|0;U=($|0)<(T|0)?$:T;T=c[Y+44>>2]|0;if((c[T+(U*56|0)>>2]|0)!=(H|0)){N=Q;O=R;P=S;break a}X=c[T+(U*56|0)+20>>2]|0;V=Y+28|0;W=c[V>>2]|0;if(!(((X|0)<301?(c[W+108>>2]|0)!=(c[W+112>>2]|0):0)&(da(X,x)|0)<901)){N=Q;O=R;P=S;break a}W=X+R|0;X=(c[T+(U*56|0)+8>>2]|0)+Q|0;U=K?X+3|0:X;if(W>>>0>65535|U>>>0>32e3){N=Q;O=R;P=S;break a}sec(m,Y,s,0);if(!(c[m>>2]|0)){N=Q;O=R;P=S;break a}X=c[V>>2]|0;if(y){V=4;T=2;do{if(V&v){if((a[X+(T<<2)+10>>0]|0)!=(a[l+(T<<1)>>0]|0)){N=Q;O=R;P=S;break a}if((a[X+(T<<2)+11>>0]|0)!=(a[l+(T<<1)+1>>0]|0)){N=Q;O=R;P=S;break a}}T=T+1|0;V=V<<1}while((T|0)<8&V>>>0<=v>>>0)}V=(M|0)==(c[X+96>>2]&w|0);T=V?U:Q;aa=V?W:R;ba=A+152|0;if(!V){N=T;O=aa;P=S;break a}if((ba|0)==(b|0)){N=T;O=aa;P=b;break}else{V=S;Q=T;R=aa;S=ba;A=V}}}while(0);if((O|0)==0|(N|0)==0){ca=P;break}J=P-z|0;A=(J|0)/76|0;if(A>>>0<2){ea=P;E=88}else{S=ync()|0;R=c[r>>2]|0;Q=R&(M&4^4)&c[155248];V=z+(A*76|0)|0;if((J|0)<=0){ca=P;break}J=Q>>>2;A=R&2;R=0;ba=z;while(1){aa=c[ba+64>>2]|0;T=a[aa+40>>0]|0;do if(T<<24>>24==1){fa=aa+-28|0;ga=Khc(fa)|0;Rhc(fa)|0;ha=ga;E=79}else{if((T&255)<=9){ia=R;break}ha=mo[c[(c[aa>>2]|0)+68>>2]&4095](aa)|0;E=79}while(0);do if((E|0)==79){E=0;if(!ha){ia=R;break}aa=c[ba+68>>2]|0;if(!(iec(ha)|0))ja=0;else ja=(iec(ha)|0)+-1|0;T=(ja|0)<(aa|0)?ja:aa;aa=c[ha+44>>2]|0;t=f+0|0;F=t+92|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(F|0));qec(ha,f);W=Tdc(ha,T)|0;if(!R){c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;c[g+28>>2]=0;U=ajc(M,l,Q,575992,g)|0;X=sic(uic()|0,g)|0;ga=qic(X,c[r>>2]|0,0)|0;Nn[c[(c[S>>2]|0)+328>>2]&31](S,d,M,U,ga,O,N,H)}Nn[c[(c[S>>2]|0)+332>>2]&31](S,ba,f,c[aa+(T*56|0)+16>>2]|0,c[aa+(T*56|0)+20>>2]|0,W,c[aa+(T*56|0)+8>>2]|0,A&c[ba+72>>2]|J);ia=1}while(0);ba=ba+76|0;if(ba>>>0>=V>>>0)break;else R=ia}if(!ia){ca=P;break}In[c[(c[S>>2]|0)+336>>2]&4095](S,0);ca=P;break}}else ka=G;else{ync()|0;R=coc()|0;V=c[(c[C+28>>2]|0)+96>>2]|0;b:do if((G|0)!=(b|0))if(K){ba=z;J=L;A=G;while(1){M=c[ba+140>>2]|0;if(!M)la=0;else la=M+-28|0;if((D|0)!=(Ghc(la)|0)){ma=A;break b}M=Khc(la)|0;if(!M){ma=A;break b}Q=c[ba+144>>2]|0;if(!(iec(M)|0))na=0;else na=(iec(M)|0)+-1|0;t=(na|0)<(Q|0)?na:Q;Q=c[M+44>>2]|0;if((c[Q+(t*56|0)>>2]|0)!=1){ma=A;break b}sec(k,M,s,0);if((c[k>>2]|0)!=(c[h>>2]|0)){ma=A;break b}if((c[(c[M+28>>2]|0)+96>>2]^V)&s){ma=A;break b}J=(c[Q+(t*56|0)+8>>2]|0)+J+3|0;if(J>>>0>R>>>0){ma=A;break b}t=ba+152|0;if((t|0)==(b|0)){ma=b;break}else{Q=A;A=t;ba=Q}}}else{ba=z;A=L;J=G;while(1){Q=c[ba+140>>2]|0;if(!Q)oa=0;else oa=Q+-28|0;if((D|0)!=(Ghc(oa)|0)){ma=J;break b}Q=Khc(oa)|0;if(!Q){ma=J;break b}t=c[ba+144>>2]|0;if(!(iec(Q)|0))pa=0;else pa=(iec(Q)|0)+-1|0;M=(pa|0)<(t|0)?pa:t;t=c[Q+44>>2]|0;if((c[t+(M*56|0)>>2]|0)!=(H|0)){ma=J;break b}sec(k,Q,s,0);if((c[k>>2]|0)!=(c[h>>2]|0)){ma=J;break b}if((c[(c[Q+28>>2]|0)+96>>2]^V)&s){ma=J;break b}A=(c[t+(M*56|0)+8>>2]|0)+A|0;if(A>>>0>R>>>0){ma=J;break b}M=ba+152|0;if((M|0)==(b|0)){ma=b;break}else{t=J;J=M;ba=t}}}else ma=b;while(0);if(!(c[h>>2]|0)){ea=ma;E=88}else{Pmc(C,h,z,(ma-z|0)/76|0,d);ca=ma;break}}if((E|0)==88){E=0;if((z|0)==(ea|0)){ca=ea;break}else ka=ea}R=((ka+-76-z|0)>>>0)/76|0;V=z;do{H=c[V+64>>2]|0;G=a[H+40>>0]|0;if(G<<24>>24!=1){if((G&255)>9){qa=mo[c[(c[H>>2]|0)+68>>2]&4095](H)|0;ra=0;sa=0;E=94}}else{G=H+-28|0;H=Khc(G)|0;L=Rhc(G)|0;qa=H;ra=L;sa=c[G+4>>2]|0;E=94}if(((E|0)==94?(E=0,(qa|0)!=0):0)?(sec(n,qa,s,ra),(c[n>>2]|0)!=0):0){if(q)In[c[(c[o>>2]|0)+220>>2]&4095](o,p);t8b(V,c[V+72>>2]|0);Wuc(n,qa,d,c[V+68>>2]|0,sa)}V=V+76|0}while((V|0)!=(ka|0));ca=z+((R+1|0)*76|0)|0}else E=17}else E=17}while(0);if((E|0)==17){E=0;ca=z+76|0}if((ca|0)==(b|0))break;else z=ca}i=e;return}function Mmc(a,c,d,f,g,h,j){a=a|0;c=c|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;l=c+d|0;if((h|0)!=0&j){b[a>>1]=b[a+-2>>1]|0;d=h-g|0;b[a+2>>1]=d+(e[l>>1]|0);m=a+4|0;n=d}else{m=a;n=h-g|0}g=f>>>1;h=(g|0)==0;if((n|0)>-1){if(!h){d=g<<1;c=l;o=m;p=0;while(1){b[o>>1]=(e[c>>1]|0)+n;p=p+1|0;if((p|0)==(d|0))break;else{c=c+2|0;o=o+2|0}}}}else if(!h){h=g<<1;o=l;c=m;d=0;while(1){b[c>>1]=(e[o>>1]|0)+n;d=d+1|0;if((d|0)==(h|0))break;else{o=o+2|0;c=c+2|0}}}if((g<<1|0)!=(f|0)){g=f+-1|0;b[m+(g<<1)>>1]=n+(e[l+(g<<1)>>1]|0)}g=m+(f<<1)|0;if((f&1|0)==0|j^1){q=g;r=q;s=a;t=r-s|0;u=t>>1;i=k;return u|0}b[g>>1]=b[m+(f+-1<<1)>>1]|0;q=m+(f+1<<1)|0;r=q;s=a;t=r-s|0;u=t>>1;i=k;return u|0}function Nmc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=i;m=d[f+42>>0]|0;if(!(j&2))n=-1;else n=d[f+5>>0]|0;if(!(j&128))o=-1;else o=d[f+29>>0]|0;p=4;q=2;r=-1;s=0;t=0;while(1){if(!(p&j)){u=r;v=s;w=t}else{if(!s){x=d[f+(q<<2)>>0]|0;y=(d[f+(q<<2)+1>>0]|0)+(c[f+(x*12|0)+36>>2]|0)|0;z=d[f+(x*12|0)+42>>0]|0}else{y=r;z=t}x=a[f+(q<<2)+3>>0]|0;u=y;v=(da(x&255,Xic(a[f+(q<<2)+2>>0]|0)|0)|0)+s|0;w=z}q=q+1|0;if((q|0)==7){A=u;B=v;C=w;break}else{p=p<<1;r=u;s=v;t=w}}w=c[f+80>>2]|0;f=w+(da(m,g)|0)|0;if((B|0)<=0){D=0;Fic(b,e,h,f,n,o,m,D,C,B,k);i=l;return h|0}D=w+((da(C,g)|0)+A)|0;Fic(b,e,h,f,n,o,m,D,C,B,k);i=l;return h|0}function Omc(a,d,f,h,j,k,l,m,n,o){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;p=i;i=i+80|0;q=p+8|0;r=p+40|0;s=p+24|0;t=p+56|0;u=p+72|0;v=p;w=p+32|0;x=p+64|0;g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(-1.0);g[r>>2]=ea(1.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+12>>2]=ea(-1.0);c[s>>2]=j;c[s+4>>2]=20;c[t>>2]=(f&2|0)!=0?q:0;c[t+4>>2]=0;c[u>>2]=n;c[u+4>>2]=0;c[v>>2]=j+12;c[v+4>>2]=20;c[w>>2]=0;c[w+4>>2]=0;c[x>>2]=(f&128|0)!=0?r:0;c[x+4>>2]=0;Gic(a,h,k,s,t,u,v,w,x);if(!o){YEi(d|0,l|0,m<<1|0)|0;i=p;return}if(!m){i=p;return}else y=0;do{b[d+(y<<1)>>1]=(e[l+(y<<1)>>1]|0)+o;y=y+1|0}while((y|0)!=(m|0));i=p;return}function Pmc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g;m=ync()|0;co[c[(c[m>>2]|0)+96>>2]&2047](m,d,0);if(_n[c[(c[m>>2]|0)+232>>2]&4095](m,4)|0)n=1;else n=_n[c[(c[m>>2]|0)+232>>2]&4095](m,5)|0;o=(e*24|0)+15|0;p=(e|0)!=0;if(o>>>0<2e3)if(p){q=i;i=i+((1*o|0)+15&-16)|0;r=0;s=q;t=8}else{u=0;v=0;w=0;x=0}else if(p){c[k>>2]=c[153134];c[h+0>>2]=c[k+0>>2];k=cOb(o,16,h,0,3653512,99)|0;r=k;s=k;t=8}else{u=0;v=0;w=0;x=0}a:do if((t|0)==8){k=s+15&-16;if(!e){u=k;v=r;w=0;x=0}else{o=l+8|0;p=l+20|0;q=0;y=0;z=0;while(1){gec(l,a,c[d+(q*76|0)+68>>2]|0,n);A=k+(q*24|0)|0;c[A+0>>2]=c[l+0>>2];c[A+4>>2]=c[l+4>>2];c[A+8>>2]=c[l+8>>2];c[A+12>>2]=c[l+12>>2];c[A+16>>2]=c[l+16>>2];c[A+20>>2]=c[l+20>>2];A=c[o>>2]|0;switch(c[l>>2]|0){case 2:{B=(A|0)/4|0;break}case 5:{B=A;break}case 1:{B=A+-2|0;break}case 3:{B=(A|0)/2|0;break}case 0:{B=(A|0)/3|0;break}case 4:{B=A+-1|0;break}default:B=0}A=B+y|0;C=(c[p>>2]|0)+z|0;q=q+1|0;if(q>>>0>=e>>>0){u=k;v=r;w=A;x=C;break a}else{y=A;z=C}}}}while(0);Nn[c[(c[m>>2]|0)+304>>2]&31](m,c[b>>2]|0,b+8|0,c[b+4>>2]|0,u,e,c[b+40>>2]|0,f);Dn[c[(c[m>>2]|0)+324>>2]&511](m,w,x,e);if(!v){i=g;return}c[j>>2]=c[153134];c[h+0>>2]=c[j+0>>2];eOb(v,h);i=g;return}function Qmc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+5280|0;e=a+3744|0;do{f=e+8|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[e+60>>2]=-1;c[f>>2]=0;c[e+12>>2]=0;c[e>>2]=0;c[e+4>>2]=5;g[e+36>>2]=ea(1.0);g[e+32>>2]=ea(1.0);g[e+40>>2]=ea(0.0);g[e+44>>2]=ea(1.0);g[e+48>>2]=ea(1.0);g[e+52>>2]=ea(0.0);g[e+56>>2]=ea(0.0);e=e+64|0}while((e|0)!=(d|0));PEi(a|0,0,3744)|0;g[a+128>>2]=ea(1.0);g[a+144>>2]=ea(1.0);g[a+160>>2]=ea(1.0);g[a+176>>2]=ea(1.0);g[a+192>>2]=ea(1.0);g[a+208>>2]=ea(1.0);g[a+224>>2]=ea(1.0);g[a+240>>2]=ea(1.0);i=b;return}function Rmc(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=j;if(!(Xmc(d,k)|0)){l=0;i=j;return l|0}d=c[k>>2]|0;c[a+(d*12|0)>>2]=e;b[a+(d*12|0)+4>>1]=f;b[a+(d*12|0)+6>>1]=g;c[a+(d*12|0)+8>>2]=h;l=1;i=j;return l|0}function Smc(a){a=a|0;return c[584440+(a<<2)>>2]|0}function Tmc(a){a=a|0;return c[584056+(a<<2)>>2]|0}function Umc(a){a=a|0;return c[579480+(a<<2)>>2]|0}function Vmc(a){a=a|0;return c[578984+(a<<2)>>2]|0}function Wmc(){var a=0,b=0,d=0,e=0;a=i;if(c[144560]|0){i=a;return}b=xCi(48)|0;d=b+0|0;e=d+48|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));c[144560]=b;$mc(b,584440,7);b=c[144560]|0;anc(c[b>>2]|0,c[b+4>>2]|0);$mc((c[144560]|0)+12|0,579480,170);bnc((c[144560]|0)+12|0,578248,16);b=c[144560]|0;anc(c[b+12>>2]|0,c[b+16>>2]|0);$mc((c[144560]|0)+24|0,584056,16);bnc((c[144560]|0)+24|0,578376,5);b=c[144560]|0;anc(c[b+24>>2]|0,c[b+28>>2]|0);$mc((c[144560]|0)+36|0,578984,24);b=c[144560]|0;anc(c[b+36>>2]|0,c[b+40>>2]|0);i=a;return}function Xmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[144560]|0;f=c[e>>2]|0;g=c[e+4>>2]|0;a:do if((f|0)==(g|0))h=f;else{e=f;while(1){if(!(HEi(c[e>>2]|0,a)|0)){h=e;break a}e=e+8|0;if((e|0)==(g|0)){j=0;break}}i=d;return j|0}while(0);if((h|0)==(g|0)){j=0;i=d;return j|0}if(!b){j=1;i=d;return j|0}c[b>>2]=c[h+4>>2];j=1;i=d;return j|0}function Ymc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[144560]|0;f=c[e+12>>2]|0;g=c[e+16>>2]|0;a:do if((f|0)==(g|0))h=f;else{e=f;while(1){if(!(HEi(c[e>>2]|0,a)|0)){h=e;break a}e=e+8|0;if((e|0)==(g|0)){j=0;break}}i=d;return j|0}while(0);if((h|0)==(g|0)){j=0;i=d;return j|0}if(!b){j=1;i=d;return j|0}c[b>>2]=c[h+4>>2];j=1;i=d;return j|0}function Zmc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[144560]|0;f=c[e+24>>2]|0;g=c[e+28>>2]|0;a:do if((f|0)==(g|0))h=f;else{e=f;while(1){if(!(HEi(c[e>>2]|0,a)|0)){h=e;break a}e=e+8|0;if((e|0)==(g|0)){j=0;break}}i=d;return j|0}while(0);if((h|0)==(g|0)){j=0;i=d;return j|0}if(!b){j=1;i=d;return j|0}c[b>>2]=c[h+4>>2];j=1;i=d;return j|0}function _mc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[144560]|0;f=c[e+36>>2]|0;g=c[e+40>>2]|0;a:do if((f|0)==(g|0))h=f;else{e=f;while(1){if(!(HEi(c[e>>2]|0,a)|0)){h=e;break a}e=e+8|0;if((e|0)==(g|0)){j=0;break}}i=d;return j|0}while(0);if((h|0)==(g|0)){j=0;i=d;return j|0}if(!b){j=1;i=d;return j|0}c[b>>2]=c[h+4>>2];j=1;i=d;return j|0}function $mc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[a>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;k=j-f>>3;a:do if(k>>>0<d>>>0){l=d-k|0;m=a+8|0;n=c[m>>2]|0;if(n-j>>3>>>0>=l>>>0){o=l;p=h;while(1){if(!p)q=0;else{r=p;c[r>>2]=0;c[r+4>>2]=0;q=c[g>>2]|0}p=q+8|0;c[g>>2]=p;o=o+-1|0;if(!o)break a}}if(d>>>0>536870911)vxi(a);o=f;p=n-o|0;if(p>>3>>>0<268435455){r=p>>2;p=r>>>0<d>>>0?d:r;r=(c[g>>2]|0)-o>>3;if(!p){s=0;t=0;u=r}else{v=p;w=r;x=11}}else{v=536870911;w=(c[g>>2]|0)-o>>3;x=11}if((x|0)==11){s=v;t=xCi(v<<3)|0;u=w}o=l;r=t+(u<<3)|0;while(1){if(!r)y=0;else{p=r;c[p>>2]=0;c[p+4>>2]=0;y=r}p=y+8|0;o=o+-1|0;if(!o){z=p;break}else r=p}r=c[a>>2]|0;o=(c[g>>2]|0)-r|0;l=t+(u-(o>>3)<<3)|0;YEi(l|0,r|0,o|0)|0;c[a>>2]=l;c[g>>2]=z;c[m>>2]=t+(s<<3);if(r)ACi(r)}else if(k>>>0>d>>>0?(r=f+(d<<3)|0,(h|0)!=(r|0)):0)c[g>>2]=h+(~((h+-8-r|0)>>>3)<<3);while(0);if((d|0)<=0){i=e;return}h=c[a>>2]|0;a=0;do{c[h+(a<<3)>>2]=c[b+(a<<2)>>2];c[h+(a<<3)+4>>2]=a;a=a+1|0}while((a|0)!=(d|0));i=e;return}function anc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=i;e=a;a=b;a:while(1){b=a;f=a+-8|0;g=e;b:while(1){h=g;j=b-h|0;k=j>>3;switch(k|0){case 3:{l=g;m=f;n=6;break a;break}case 5:{o=g;p=f;n=8;break a;break}case 4:{q=g;r=f;n=7;break a;break}case 2:{s=g;t=f;u=f;n=4;break a;break}case 1:case 0:{n=53;break a;break}default:{}}if((j|0)<248){v=g;w=a;n=10;break a}x=(k|0)/2|0;y=g+(x<<3)|0;if((j|0)>7992){j=(k|0)/4|0;z=enc(g,g+(j<<3)|0,y,g+(j+x<<3)|0,f)|0}else z=cnc(g,y,f)|0;x=c[g>>2]|0;j=c[y>>2]|0;do if((HEi(x,j)|0)<0){A=f;B=z}else{k=a;C=f;while(1){D=k+-16|0;if((g|0)==(D|0))break;if((HEi(c[D>>2]|0,j)|0)<0){E=D;n=35;break}else{F=C;C=D;k=F}}if((n|0)==35){n=0;k=g;C=c[k>>2]|0;F=c[k+4>>2]|0;k=E;D=c[k+4>>2]|0;G=g;c[G>>2]=c[k>>2];c[G+4>>2]=D;D=E;c[D>>2]=C;c[D+4>>2]=F;A=E;B=z+1|0;break}F=g+8|0;if((HEi(x,c[f>>2]|0)|0)<0)H=F;else{if((F|0)==(f|0)){n=53;break a}else{I=g;J=F}while(1){F=I+16|0;if((HEi(x,c[J>>2]|0)|0)<0){K=J;break}if((F|0)==(f|0)){n=53;break a}else{D=J;J=F;I=D}}D=K;F=c[D>>2]|0;C=c[D+4>>2]|0;D=f;G=c[D+4>>2]|0;k=K;c[k>>2]=c[D>>2];c[k+4>>2]=G;G=f;c[G>>2]=F;c[G+4>>2]=C;H=K+8|0}if((H|0)==(f|0)){n=53;break a}else{L=H;M=f}while(1){C=c[g>>2]|0;G=L;while(1){F=G+8|0;if((HEi(C,c[G>>2]|0)|0)<0){N=F;O=G;break}else G=F}G=M;while(1){F=G+-8|0;if((HEi(C,c[F>>2]|0)|0)<0)G=F;else{P=F;break}}if(O>>>0>=P>>>0){g=O;continue b}G=O;C=c[G>>2]|0;F=c[G+4>>2]|0;G=P;k=c[G+4>>2]|0;D=O;c[D>>2]=c[G>>2];c[D+4>>2]=k;k=P;c[k>>2]=C;c[k+4>>2]=F;L=N;M=P}}while(0);x=g+8|0;c:do if(x>>>0<A>>>0){j=x;F=A;k=y;C=B;while(1){D=c[k>>2]|0;G=j;while(1){Q=G+8|0;if((HEi(c[G>>2]|0,D)|0)<0)G=Q;else{R=Q;S=G;break}}G=F;while(1){Q=G+-8|0;if((HEi(c[Q>>2]|0,D)|0)<0){T=Q;break}else G=Q}if(S>>>0>T>>>0){U=S;V=k;W=C;break c}G=S;D=c[G>>2]|0;Q=c[G+4>>2]|0;G=T;X=c[G+4>>2]|0;Y=S;c[Y>>2]=c[G>>2];c[Y+4>>2]=X;X=T;c[X>>2]=D;c[X+4>>2]=Q;j=R;F=T;k=(k|0)==(S|0)?T:k;C=C+1|0}}else{U=x;V=y;W=B}while(0);if((U|0)!=(V|0)?(HEi(c[V>>2]|0,c[U>>2]|0)|0)<0:0){y=U;x=c[y>>2]|0;C=c[y+4>>2]|0;y=V;k=c[y+4>>2]|0;F=U;c[F>>2]=c[y>>2];c[F+4>>2]=k;k=V;c[k>>2]=x;c[k+4>>2]=C;Z=W+1|0}else Z=W;if(!Z){_=fnc(g,U)|0;C=U+8|0;if(fnc(C,a)|0){n=48;break}if(_){g=C;continue}}C=U;if((C-h|0)>=(b-C|0)){$=g;aa=U;n=52;break}anc(g,U);g=U+8|0}if((n|0)==48){n=0;if(_){n=53;break}else{e=g;a=U;continue}}else if((n|0)==52){n=0;anc(aa+8|0,a);e=$;a=aa;continue}}if((n|0)==4){if((HEi(c[t>>2]|0,c[s>>2]|0)|0)>=0){i=d;return}t=s;aa=c[t>>2]|0;a=c[t+4>>2]|0;t=u;$=c[t+4>>2]|0;e=s;c[e>>2]=c[t>>2];c[e+4>>2]=$;$=u;c[$>>2]=aa;c[$+4>>2]=a;i=d;return}else if((n|0)==6){cnc(l,l+8|0,m)|0;i=d;return}else if((n|0)==7){dnc(q,q+8|0,q+16|0,r)|0;i=d;return}else if((n|0)==8){enc(o,o+8|0,o+16|0,o+24|0,p)|0;i=d;return}else if((n|0)==10){p=v+16|0;cnc(v,v+8|0,p)|0;o=v+24|0;if((o|0)==(w|0)){i=d;return}else{ba=o;ca=p}while(1){if((HEi(c[ba>>2]|0,c[ca>>2]|0)|0)<0){p=ba;o=c[p>>2]|0;r=c[p+4>>2]|0;p=o;q=ba;m=ca;while(1){l=m;a=c[l+4>>2]|0;$=q;c[$>>2]=c[l>>2];c[$+4>>2]=a;if((m|0)==(v|0)){da=m;break}a=m+-8|0;if((HEi(p,c[a>>2]|0)|0)<0){$=m;m=a;q=$}else{da=m;break}}m=da;c[m>>2]=o;c[m+4>>2]=r}m=ba+8|0;if((m|0)==(w|0))break;else{q=ba;ba=m;ca=q}}i=d;return}else if((n|0)==53){i=d;return}}function bnc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a>>2]|0;g=a+4|0;h=f;j=(c[g>>2]|0)-h|0;k=j>>3;l=k+d|0;m=a+8|0;if((c[m>>2]|0)-h>>3>>>0<l>>>0){if(!l)n=0;else n=xCi(l<<3)|0;YEi(n|0,f|0,j|0)|0;c[a>>2]=n;c[g>>2]=n+(k<<3);c[m>>2]=n+(l<<3);if(f)ACi(f)}if((d|0)<=0){i=e;return}f=0;while(1){l=b+(f<<3)|0;n=c[g>>2]|0;if((n|0)==(c[m>>2]|0)){k=c[a>>2]|0;j=(n-k>>3)+1|0;if(j>>>0>536870911){o=13;break}h=k;p=n-h|0;if(p>>3>>>0<268435455){q=p>>2;p=q>>>0<j>>>0?j:q;q=(c[g>>2]|0)-h|0;j=q>>3;if(!p){r=0;s=0;t=j;u=q}else{v=p;w=j;x=q;o=17}}else{q=(c[g>>2]|0)-h|0;v=536870911;w=q>>3;x=q;o=17}if((o|0)==17){o=0;r=v;s=xCi(v<<3)|0;t=w;u=x}q=s+(t<<3)|0;if(q){h=l;j=c[h+4>>2]|0;p=q;c[p>>2]=c[h>>2];c[p+4>>2]=j}YEi(s|0,k|0,u|0)|0;c[a>>2]=s;c[g>>2]=s+(t+1<<3);c[m>>2]=s+(r<<3);if(k)ACi(k)}else{if(!n)y=0;else{k=l;l=c[k+4>>2]|0;j=n;c[j>>2]=c[k>>2];c[j+4>>2]=l;y=c[g>>2]|0}c[g>>2]=y+8}f=f+1|0;if((f|0)==(d|0)){o=23;break}}if((o|0)==13)vxi(a);else if((o|0)==23){i=e;return}}function cnc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[b>>2]|0;g=(HEi(f,c[a>>2]|0)|0)<0;h=(HEi(c[d>>2]|0,f)|0)<0;if(!g){if(!h){j=0;i=e;return j|0}g=b;f=c[g>>2]|0;k=c[g+4>>2]|0;g=d;l=c[g+4>>2]|0;m=b;c[m>>2]=c[g>>2];c[m+4>>2]=l;l=d;c[l>>2]=f;c[l+4>>2]=k;if((HEi(c[b>>2]|0,c[a>>2]|0)|0)>=0){j=1;i=e;return j|0}k=a;l=c[k>>2]|0;f=c[k+4>>2]|0;k=b;m=c[k+4>>2]|0;g=a;c[g>>2]=c[k>>2];c[g+4>>2]=m;m=b;c[m>>2]=l;c[m+4>>2]=f;j=2;i=e;return j|0}f=a;m=c[f>>2]|0;l=c[f+4>>2]|0;if(h){h=d;f=c[h+4>>2]|0;g=a;c[g>>2]=c[h>>2];c[g+4>>2]=f;f=d;c[f>>2]=m;c[f+4>>2]=l;j=1;i=e;return j|0}f=b;g=c[f+4>>2]|0;h=a;c[h>>2]=c[f>>2];c[h+4>>2]=g;g=b;c[g>>2]=m;c[g+4>>2]=l;if((HEi(c[d>>2]|0,m)|0)>=0){j=1;i=e;return j|0}g=d;h=c[g+4>>2]|0;f=b;c[f>>2]=c[g>>2];c[f+4>>2]=h;h=d;c[h>>2]=m;c[h+4>>2]=l;j=2;i=e;return j|0}function dnc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=cnc(a,b,d)|0;if((HEi(c[e>>2]|0,c[d>>2]|0)|0)>=0){h=g;i=f;return h|0}j=d;k=c[j>>2]|0;l=c[j+4>>2]|0;j=e;m=c[j+4>>2]|0;n=d;c[n>>2]=c[j>>2];c[n+4>>2]=m;m=e;c[m>>2]=k;c[m+4>>2]=l;if((HEi(c[d>>2]|0,c[b>>2]|0)|0)>=0){h=g+1|0;i=f;return h|0}l=b;m=c[l>>2]|0;k=c[l+4>>2]|0;l=d;e=c[l+4>>2]|0;n=b;c[n>>2]=c[l>>2];c[n+4>>2]=e;e=d;c[e>>2]=m;c[e+4>>2]=k;if((HEi(c[b>>2]|0,c[a>>2]|0)|0)>=0){h=g+2|0;i=f;return h|0}k=a;e=c[k>>2]|0;m=c[k+4>>2]|0;k=b;d=c[k+4>>2]|0;n=a;c[n>>2]=c[k>>2];c[n+4>>2]=d;d=b;c[d>>2]=e;c[d+4>>2]=m;h=g+3|0;i=f;return h|0}function enc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=dnc(a,b,d,e)|0;if((HEi(c[f>>2]|0,c[e>>2]|0)|0)>=0){j=h;i=g;return j|0}k=e;l=c[k>>2]|0;m=c[k+4>>2]|0;k=f;n=c[k+4>>2]|0;o=e;c[o>>2]=c[k>>2];c[o+4>>2]=n;n=f;c[n>>2]=l;c[n+4>>2]=m;if((HEi(c[e>>2]|0,c[d>>2]|0)|0)>=0){j=h+1|0;i=g;return j|0}m=d;n=c[m>>2]|0;l=c[m+4>>2]|0;m=e;f=c[m+4>>2]|0;o=d;c[o>>2]=c[m>>2];c[o+4>>2]=f;f=e;c[f>>2]=n;c[f+4>>2]=l;if((HEi(c[d>>2]|0,c[b>>2]|0)|0)>=0){j=h+2|0;i=g;return j|0}l=b;f=c[l>>2]|0;n=c[l+4>>2]|0;l=d;e=c[l+4>>2]|0;o=b;c[o>>2]=c[l>>2];c[o+4>>2]=e;e=d;c[e>>2]=f;c[e+4>>2]=n;if((HEi(c[b>>2]|0,c[a>>2]|0)|0)>=0){j=h+3|0;i=g;return j|0}n=a;e=c[n>>2]|0;f=c[n+4>>2]|0;n=b;d=c[n+4>>2]|0;o=a;c[o>>2]=c[n>>2];c[o+4>>2]=d;d=b;c[d>>2]=e;c[d+4>>2]=f;j=h+4|0;i=g;return j|0}function fnc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;switch(b-a>>3|0){case 1:case 0:{e=1;i=d;return e|0}case 4:{dnc(a,a+8|0,a+16|0,b+-8|0)|0;e=1;i=d;return e|0}case 5:{enc(a,a+8|0,a+16|0,a+24|0,b+-8|0)|0;e=1;i=d;return e|0}case 3:{cnc(a,a+8|0,b+-8|0)|0;e=1;i=d;return e|0}case 2:{f=b+-8|0;if((HEi(c[f>>2]|0,c[a>>2]|0)|0)>=0){e=1;i=d;return e|0}g=a;h=c[g>>2]|0;j=c[g+4>>2]|0;g=f;k=c[g+4>>2]|0;l=a;c[l>>2]=c[g>>2];c[l+4>>2]=k;k=f;c[k>>2]=h;c[k+4>>2]=j;e=1;i=d;return e|0}default:{j=a+16|0;cnc(a,a+8|0,j)|0;k=a+24|0;if((k|0)==(b|0)){e=1;i=d;return e|0}else{m=0;n=k;o=j}while(1){if((HEi(c[n>>2]|0,c[o>>2]|0)|0)<0){j=n;k=c[j>>2]|0;h=c[j+4>>2]|0;j=k;f=n;l=o;while(1){g=l;p=c[g+4>>2]|0;q=f;c[q>>2]=c[g>>2];c[q+4>>2]=p;if((l|0)==(a|0)){r=l;break}p=l+-8|0;if((HEi(j,c[p>>2]|0)|0)<0){q=l;l=p;f=q}else{r=l;break}}l=r;c[l>>2]=k;c[l+4>>2]=h;l=m+1|0;if((l|0)==8){s=n;break}else t=l}else t=m;l=n+8|0;if((l|0)==(b|0)){e=1;u=15;break}else{f=n;m=t;n=l;o=f}}if((u|0)==15){i=d;return e|0}e=(s+8|0)==(b|0);i=d;return e|0}}return 0}function gnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;sri(e,b);b=a[e>>0]|0;if(!(b&1)){f=e+1|0;g=f;h=f;j=e+8|0}else{f=e+8|0;g=c[f>>2]|0;h=e+1|0;j=f}f=e+4|0;k=g;g=b;while(1){if(!(g&1)){l=h;m=(g&255)>>>1}else{l=c[j>>2]|0;m=c[f>>2]|0}if((k|0)==(l+m|0)){n=0;break}b=a[k>>0]|0;o=b<<24>>24;a[k>>0]=(b+-97<<24>>24&255)<26?o+224|0:o;k=k+1|0;g=a[e>>0]|0}while(1){if(!(Ori(e,c[584664+(n<<2)>>2]|0)|0)){p=n;q=12;break}n=n+1|0;if((n|0)>=8){p=-1;q=12;break}}if((q|0)==12){xri(e);i=d;return p|0}return 0}function hnc(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=0;c[b+4>>2]=0;e=b+8|0;b=e+28|0;do{a[e>>0]=255;e=e+1|0}while((e|0)<(b|0));i=d;return}function inc(b,d,e){b=b|0;d=d|0;e=e|0;if((e|0)!=-1){a[b+e+8>>0]=d;c[b>>2]=c[b>>2]|1<<e}e=b+4|0;c[e>>2]=c[e>>2]|1<<d;return}function jnc(b,d){b=b|0;d=d|0;c[b>>2]=c[b>>2]&~(1<<d);a[b+d+8>>0]=-1;return}function knc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0;e=i;c[b>>2]=d;hnc(b+4|0);hnc(b+40|0);d=b+116|0;f=b+76|0;h=f+104|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));g[d>>2]=ea(1.0);g[b+120>>2]=ea(1.0);g[b+124>>2]=ea(1.0);g[b+128>>2]=ea(1.0);f=b+180|0;h=f+88|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));g[b+204>>2]=ea(1.0);g[b+208>>2]=ea(1.0);g[b+212>>2]=ea(1.0);g[b+216>>2]=ea(1.0);c[b+268>>2]=0;c[b+272>>2]=0;a[b+276>>0]=a[621179]|0;lnc(b);i=e;return}function lnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+48|0;e=d+40|0;f=d+8|0;g=d;h=b+40|0;inc(h,0,0);inc(h,1,2);inc(h,2,1);inc(h,3,4);inc(h,4,5);inc(h,5,6);inc(h,6,7);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=3;a[f+5>>0]=12;a[f+6>>0]=0;a[f+7>>0]=3;a[f+9>>0]=24;a[f+10>>0]=0;a[f+11>>0]=4;a[f+13>>0]=40;a[f+14>>0]=0;a[f+15>>0]=3;a[f+17>>0]=52;a[f+18>>0]=0;a[f+19>>0]=3;a[f+21>>0]=64;a[f+22>>0]=0;a[f+23>>0]=3;a[f+25>>0]=76;a[f+26>>0]=0;a[f+27>>0]=3;c[g>>2]=c[153080];c[e+0>>2]=c[g+0>>2];g=bOb(60,e,0,16,3653512,170)|0;oic(g,1,f,1);c[b+76>>2]=g;i=d;return}function mnc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+76|0;g=c[f>>2]|0;h=c[153080]|0;if(g)pic(g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;f=c[a+80>>2]|0;if(f){d=c[a>>2]|0;In[c[(c[d>>2]|0)+296>>2]&4095](d,f)}f=c[a+84>>2]|0;if(!f){i=b;return}d=c[a>>2]|0;In[c[(c[d>>2]|0)+276>>2]&4095](d,f);i=b;return}function nnc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+80|0;h=f+48|0;j=f;k=b+88|0;if(c[k>>2]|0){i=f;return}l=b+276|0;do if(!(a[l>>0]|0)){m=b+80|0;n=c[m>>2]|0;if(n){if(!(mo[c[(c[n>>2]|0)+8>>2]&4095](n)|0))break;n=c[m>>2]|0;if(n){o=b;p=n}else{q=b;r=7}}else{q=b;r=7}if((r|0)==7){n=c[q>>2]|0;s=mo[c[(c[n>>2]|0)+280>>2]&4095](n)|0;c[m>>2]=s;o=q;p=s}s=c[o>>2]|0;Wn[c[(c[s>>2]|0)+284>>2]&127](s,p,1,1,67584,0,0)}while(0);p=b+4|0;o=((e|0)!=0?e:b+40|0)+0|0;e=p+36|0;do{c[p>>2]=c[o>>2];p=p+4|0;o=o+4|0}while((p|0)<(e|0));q=b+268|0;c[q>>2]=d;d=c[b>>2]|0;if(a[l>>0]|0){l=Mnc(d)|0;c[h>>2]=0;if(gn[c[(c[l>>2]|0)+8>>2]&127](l,88,768,0,c[q>>2]|0,h,0)|0)c[k>>2]=c[h>>2]}else c[k>>2]=kn[c[(c[d>>2]|0)+288>>2]&511](d,c[b+80>>2]|0,0,0)|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;p=j+0|0;e=p+48|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(e|0));d=b+92|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];g[b+116>>2]=ea(1.0);g[b+120>>2]=ea(1.0);g[b+124>>2]=ea(1.0);g[b+128>>2]=ea(1.0);p=b+132|0;o=j+0|0;e=p+48|0;do{c[p>>2]=c[o>>2];p=p+4|0;o=o+4|0}while((p|0)<(e|0));i=f;return}function onc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0;b=i;i=i+80|0;d=b+48|0;e=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;f=e+0|0;h=f+48|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));j=a+92|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];g[a+116>>2]=ea(1.0);g[a+120>>2]=ea(1.0);g[a+124>>2]=ea(1.0);g[a+128>>2]=ea(1.0);f=a+132|0;a=e+0|0;h=f+48|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(h|0));i=b;return}function pnc(a){a=a|0;var b=0;b=i;if(!(c[a+88>>2]|0)){i=b;return}qnc(a);i=b;return}function qnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+24|0;f=d;g=b+88|0;if(!(c[g>>2]|0)){i=d;return}h=b+272|0;j=c[h>>2]|0;k=b+268|0;switch(c[k>>2]|0){case 5:{l=j;break}case 3:{l=(j|0)/2|0;break}case 1:{l=j+-2|0;break}case 0:{l=(j|0)/3|0;break}case 4:{l=j+-1|0;break}case 2:{l=(j|0)/4|0;break}default:l=0}j=b+4|0;m=qic(c[b+76>>2]|0,c[b+8>>2]|0,0)|0;n=c[b>>2]|0;if(!(a[b+276>>0]|0)){o=b+80|0;co[c[(c[n>>2]|0)+292>>2]&2047](n,c[o>>2]|0,(c[h>>2]|0)*88|0);if((l|0)>0){p=c[k>>2]|0;if((p|0)==2&(a[621141]|0)==0){k=b+84|0;q=c[k>>2]|0;if(!q){wnc(b);r=c[k>>2]|0}else r=q;q=c[h>>2]|0;s=q;t=r;u=(q>>>2)*6|0;v=0}else{s=c[h>>2]|0;t=0;u=0;v=p}c[e>>2]=c[o>>2];c[e+4>>2]=88;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f>>2]=v;c[f+8>>2]=u;c[f+20>>2]=s;s=c[b>>2]|0;Nn[c[(c[s>>2]|0)+304>>2]&31](s,t,e,1,f,1,m,j)}}else{f=Mnc(n)|0;co[c[(c[f>>2]|0)+12>>2]&2047](f,c[h>>2]|0,0);if((l|0)>0)co[c[(c[f>>2]|0)+16>>2]&2047](f,j,m)}c[g>>2]=0;c[h>>2]=0;i=d;return}function rnc(b,d,e,f){b=b|0;d=ea(d);e=ea(e);f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h;k=b+88|0;l=c[k>>2]|0;if(!l){i=h;return}m=b+92|0;g[b+92>>2]=d;g[b+96>>2]=e;g[b+100>>2]=f;c[k>>2]=l+88;n=l+0|0;l=m+0|0;o=n+88|0;do{c[n>>2]=c[l>>2];n=n+4|0;l=l+4|0}while((n|0)<(o|0));p=b+272|0;q=(c[p>>2]|0)+1|0;c[p>>2]=q;if(q>>>0<=766){i=h;return}r=b+268|0;if((c[r>>2]|0)==1&(q|0)==767){n=b+180|0;l=m+0|0;o=n+88|0;do{c[n>>2]=c[l>>2];n=n+4|0;l=l+4|0}while((n|0)<(o|0))}if((q|0)!=768){i=h;return}qnc(b);q=c[b>>2]|0;do if(a[b+276>>0]|0){s=Mnc(q)|0;c[j>>2]=0;if(gn[c[(c[s>>2]|0)+8>>2]&127](s,88,768,0,c[r>>2]|0,j,0)|0){s=c[j>>2]|0;c[k>>2]=s;t=s;break}else{t=c[k>>2]|0;break}}else{s=kn[c[(c[q>>2]|0)+288>>2]&511](q,c[b+80>>2]|0,0,0)|0;c[k>>2]=s;t=s}while(0);if(!t){i=h;return}if((c[r>>2]|0)!=1){i=h;return}c[k>>2]=t+88;n=t+0|0;l=b+180|0;o=n+88|0;do{c[n>>2]=c[l>>2];n=n+4|0;l=l+4|0}while((n|0)<(o|0));b=c[k>>2]|0;c[k>>2]=b+88;n=b+0|0;l=m+0|0;o=n+88|0;do{c[n>>2]=c[l>>2];n=n+4|0;l=l+4|0}while((n|0)<(o|0));c[p>>2]=2;i=h;return}function snc(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);g[a+104>>2]=b;g[a+108>>2]=c;g[a+112>>2]=d;return}function tnc(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);g[a+116>>2]=b;g[a+120>>2]=c;g[a+124>>2]=d;g[a+128>>2]=e;return}function unc(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);g[a+132>>2]=b;g[a+136>>2]=c;g[a+140>>2]=d;g[a+144>>2]=b;g[a+148>>2]=c;g[a+152>>2]=d;g[a+156>>2]=b;g[a+160>>2]=c;g[a+164>>2]=d;g[a+168>>2]=b;g[a+172>>2]=c;g[a+176>>2]=d;return}function vnc(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);var f=0;f=i;if(b>>>0>=4){i=f;return}g[a+(b*12|0)+132>>2]=c;g[a+(b*12|0)+136>>2]=d;g[a+(b*12|0)+140>>2]=e;i=f;return}function wnc(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a>>2]|0;h=mo[c[(c[g>>2]|0)+260>>2]&4095](g)|0;g=a+84|0;c[g>>2]=h;if(!h){i=d;return}h=c[153134]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];j=cOb(2304,2,e,0,3653512,352)|0;k=0;l=0;while(1){b[j+(l<<1)>>1]=k|1;m=(k|2)&65535;b[j+((l|1)<<1)>>1]=m;n=k&65535;b[j+(l+2<<1)>>1]=n;b[j+(l+3<<1)>>1]=m;b[j+(l+4<<1)>>1]=k|3;b[j+(l+5<<1)>>1]=n;l=l+6|0;if(l>>>0>=1152)break;else k=k+4|0}k=c[a>>2]|0;Wn[c[(c[k>>2]|0)+264>>2]&127](k,c[g>>2]|0,0,1,2304,j,0);c[f>>2]=h;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function xnc(){return (c[146226]|0)!=0|0}function ync(){return c[146226]|0}function znc(){return c[146226]|0}function Anc(a){a=a|0;c[146226]=a;return}function Bnc(){return c[146226]|0}function Cnc(){return c[146226]|0}function Dnc(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=584920;Qmc(a+4|0);yqc(a+5320|0);yqc(a+5576|0);c[a+5876>>2]=-1;b[a+5880>>1]=0;b[a+5882>>1]=0;c[a+5884>>2]=0;c[a+5888>>2]=-1;b[a+5892>>1]=0;b[a+5894>>1]=0;c[a+5896>>2]=0;c[a+5900>>2]=-1;b[a+5904>>1]=0;b[a+5906>>1]=0;c[a+5908>>2]=0;c[a+5912>>2]=-1;b[a+5916>>1]=0;b[a+5918>>1]=0;c[a+5920>>2]=0;c[a+5924>>2]=-1;b[a+5928>>1]=0;b[a+5930>>1]=0;c[a+5932>>2]=0;c[a+5936>>2]=-1;b[a+5940>>1]=0;b[a+5942>>1]=0;c[a+5944>>2]=0;c[a+5948>>2]=-1;b[a+5952>>1]=0;b[a+5954>>1]=0;c[a+5956>>2]=0;c[a+5996>>2]=0;c[a+6e3>>2]=0;mrc(a+6008|0);c[f>>2]=c[153120];c[e+0>>2]=c[f+0>>2];rsd(a+6024|0,e);c[a+6060>>2]=0;c[a+6064>>2]=0;c[a+6056>>2]=a+6060;Enc(a);i=d;return}function Enc(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d+4|0;j=d;Aqc(b+5320|0);Aqc(b+5576|0);c[b+5836>>2]=0;g[b+5964>>2]=ea(0.0);g[b+5960>>2]=ea(0.0);c[b+5968>>2]=0;c[b+5840>>2]=-1;a[b+5832>>0]=0;a[b+5833>>0]=0;a[b+5834>>0]=0;a[b+5972>>0]=0;a[b+5973>>0]=0;c[b+5976>>2]=-1;c[b+5992>>2]=0;k=b+5876|0;c[b+5852>>2]=k;c[b+5856>>2]=k;c[b+5860>>2]=k;c[b+5864>>2]=k;c[b+5868>>2]=k;c[b+5872>>2]=k;c[b+6044>>2]=0;c[b+5844>>2]=0;c[b+5848>>2]=0;c[f>>2]=c[153080];c[e+0>>2]=c[f+0>>2];f=bOb(280,e,0,16,3653512,196)|0;knc(f,b);c[b+6004>>2]=f;c[h>>2]=c[153080];c[e+0>>2]=c[h+0>>2];h=bOb(8,e,0,16,3653512,197)|0;c[h>>2]=h;c[h+4>>2]=h;c[b+6048>>2]=h;c[j>>2]=c[153080];c[e+0>>2]=c[j+0>>2];j=bOb(8,e,0,16,3653512,198)|0;c[j>>2]=j;c[j+4>>2]=j;c[b+6052>>2]=j;qrc();i=d;return}function Fnc(a){a=a|0;var b=0;b=i;Ooc(a);ACi(a);i=b;return}function Gnc(b){b=b|0;var d=0;d=i;a[b+5973>>0]=0;c[b+5976>>2]=-1;c[b+5284>>2]=-1;g[b+5288>>2]=ea(-1.0);g[b+5292>>2]=ea(-1.0);g[b+5296>>2]=ea(-1.0);g[b+5300>>2]=ea(-1.0);g[b+5304>>2]=ea(-1.0);g[b+5308>>2]=ea(-1.0);g[b+5312>>2]=ea(-1.0);onc(c[b+6004>>2]|0);i=d;return}function Hnc(a){a=a|0;var b=0,d=0;b=i;d=a+6044|0;a=c[d>>2]|0;if(!a){c[d>>2]=0;i=b;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);c[d>>2]=0;i=b;return}function Inc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+6048>>2]|0;a=b+4|0;if((a|0)==(e|0)){i=d;return}f=c[a>>2]|0;g=b+8|0;if(f){c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[a>>2]=0;c[g>>2]=0}f=c[e>>2]|0;c[a>>2]=f;c[g>>2]=e;c[f+4>>2]=a;c[c[g>>2]>>2]=a;i=d;return}function Jnc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=((b|0)==0?0:b+4|0)+-4|0;b=d+4|0;e=c[b>>2]|0;if(!e){i=a;return}f=d+8|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[b>>2]=0;c[f>>2]=0;i=a;return}function Knc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+6052>>2]|0;a=b+4|0;if((a|0)==(e|0)){i=d;return}f=c[a>>2]|0;g=b+8|0;if(f){c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[a>>2]=0;c[g>>2]=0}f=c[e>>2]|0;c[a>>2]=f;c[g>>2]=e;c[f+4>>2]=a;c[c[g>>2]>>2]=a;i=d;return}function Lnc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=((b|0)==0?0:b+4|0)+-4|0;b=d+4|0;e=c[b>>2]|0;if(!e){i=a;return}f=d+8|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[b>>2]=0;c[f>>2]=0;i=a;return}function Mnc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+6044|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=mo[c[(c[a>>2]|0)+784>>2]&4095](a)|0;c[d>>2]=e;f=e;i=b;return f|0}function Nnc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+6052>>2]|0;e=c[d+4>>2]|0;if((e|0)!=(d|0)){f=e;do{e=f+-4|0;ko[c[(c[e>>2]|0)+12>>2]&4095](e);f=c[f+4>>2]|0}while((f|0)!=(d|0))}d=c[a+6048>>2]|0;a=c[d+4>>2]|0;if((a|0)==(d|0)){i=b;return}else g=a;do{a=g+-4|0;ko[c[(c[a>>2]|0)+12>>2]&4095](a);g=c[g+4>>2]|0}while((g|0)!=(d|0));i=b;return}function Onc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+6004|0;g=c[f>>2]|0;h=c[153080]|0;if(g)mnc(g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;f=a+5844|0;d=c[f>>2]|0;if(d){In[c[(c[a>>2]|0)+276>>2]&4095](a,d);c[f>>2]=0}f=a+5848|0;d=c[f>>2]|0;if(!d){i=b;return}In[c[(c[a>>2]|0)+296>>2]&4095](a,d);c[f>>2]=0;i=b;return}function Pnc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[(c[a>>2]|0)+100>>2]&4095](a,b);In[c[(c[a>>2]|0)+140>>2]&4095](a,(d&4|0)!=0);i=e;return}function Qnc(a,b){a=a|0;b=ea(b);var c=Im,d=0,e=Im;c=ea(R(ea(b*ea(16.0))));d=c>ea(15.0);e=ea(c*ea(.0625));c=d?ea(.9375):e;g[a+932>>2]=b;g[a+936>>2]=c;g[a+940>>2]=ea(0.0);g[a+944>>2]=ea(0.0);return}function Rnc(a,b){a=a|0;b=b|0;var d=0;d=a+948|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function Snc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Uqc(b,c)|0;i=a;return d|0}function Tnc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;Krd(585712,0,3653512,392,1,0,0,0);i=e;return}function Unc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;Krd(585712,0,3653512,397,1,0,0,0);i=h;return}function Vnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Krd(585712,0,3653512,402,1,0,0,0);i=d;return}function Wnc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;Krd(585712,0,3653512,407,1,0,0,0);i=h;return}function Xnc(a,b){a=a|0;b=b|0;a=i;if(!b){i=a;return}ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=a;return}function Ync(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;e=i;i=i+32|0;m=e;n=d<<1;o=Znc(a,n)|0;if(!o){i=e;return}p=kn[c[(c[a>>2]|0)+268>>2]&511](a,o,0,n)|0;if(!p){Krd(585752,0,3653512,431,1,0,0,0);i=e;return}else{YEi(p|0,b|0,n|0)|0;co[c[(c[a>>2]|0)+272>>2]&2047](a,o,n);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+8>>2]=d;c[m+16>>2]=h;c[m+20>>2]=j;Nn[c[(c[a>>2]|0)+304>>2]&31](a,o,f,g,m,1,k,l);i=e;return}}function Znc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;g=e+4|0;h=b+5844|0;j=c[h>>2]|0;if(!j){k=mo[c[(c[b>>2]|0)+260>>2]&4095](b)|0;c[h>>2]=k;if(!k){l=0;i=e;return l|0}else m=k}else m=j;j=d+-1|0;d=j>>>16|j;j=d>>>8|d;d=j>>>4|j;j=d>>>2|d;d=(j>>>1|j)+1|0;j=c[m+20>>2]|0;if(j>>>0<d>>>0){Wn[c[(c[b>>2]|0)+264>>2]&127](b,m,1,1,d,0,0);b=c[h>>2]|0;n=c[b+20>>2]|0;o=b}else{n=j;o=m}if(n>>>0>=d>>>0){l=o;i=e;return l|0}c[f>>2]=d;Lsd(g,585792,f);if(!(a[g>>0]&1))p=g+1|0;else p=c[g+8>>2]|0;Krd(p,0,3653512,479,1,0,0,0);xri(g);l=0;i=e;return l|0}function _nc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+5848|0;j=c[h>>2]|0;if(!j){k=mo[c[(c[b>>2]|0)+280>>2]&4095](b)|0;c[h>>2]=k;l=k}else l=j;if((c[l+20>>2]|0)>>>0>=d<<2>>>0){m=c[h>>2]|0;c[a>>2]=m;n=a+4|0;c[n>>2]=4;i=e;return}l=d+-1|0;d=l>>>16|l;l=d>>>8|d;d=l>>>4|l;l=d>>>2|d;d=(l>>>1|l)+1|0;l=c[153134]|0;j=d<<2;c[g>>2]=l;c[f+0>>2]=c[g+0>>2];k=cOb(j,4,f,0,3653512,352)|0;o=k+(d<<2)|0;if((k|0)!=(o|0)){p=k;do{if(p)c[p>>2]=-1;p=p+4|0}while((p|0)!=(o|0))}Wn[c[(c[b>>2]|0)+284>>2]&127](b,c[h>>2]|0,0,1,j,k,0);if((d|0)<=-1){m=c[h>>2]|0;c[a>>2]=m;n=a+4|0;c[n>>2]=4;i=e;return}c[g>>2]=l;c[f+0>>2]=c[g+0>>2];eOb(k,f);m=c[h>>2]|0;c[a>>2]=m;n=a+4|0;c[n>>2]=4;i=e;return}function $nc(a){a=a|0;var b=0;b=i;nrc(a+6008|0,a);wsd(a+6024|0);i=b;return}function aoc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+6024|0;j=c[b>>2]|0;c[f>>2]=j;c[e+0>>2]=c[f+0>>2];if(!(ysd(h,e)|0)){i=d;return}c[g>>2]=j;c[e+0>>2]=c[g+0>>2];usd(h,e);orc(a+6008|0,a,j&16777215);i=d;return}function boc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;prc(a+6008|0,a,b,c,d,0);i=e;return}function coc(){return 32e3}function doc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(!(a[b+5568>>0]|0)){i=g;return}h=b+5380|0;c[h>>2]=(c[h>>2]|0)+1;h=b+5384|0;c[h>>2]=(c[h>>2]|0)+f;f=b+5388|0;c[f>>2]=(c[f>>2]|0)+d;d=b+5392|0;c[d>>2]=(c[d>>2]|0)+e;i=g;return}function eoc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;m=+Ki()*1.0e6;n=+S(m)>=1.0?(m>0.0?(ha(+R(m/4294967296.0),4294967295.0)|0)>>>0:~~+ca((m-+(~~m>>>0))/4294967296.0)>>>0):0;o=585856|0;c[o>>2]=~~m>>>0;c[o+4>>2]=n;n=585864|0;o=d+0|0;d=n+36|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(d|0));c[146475]=e;c[146476]=h;e=(k|0)==2;if(e)p=(j>>>2)*6|0;else p=j;c[146477]=p;c[146478]=0;c[146479]=0;c[146480]=0;c[146481]=k;c[146482]=f;c[146485]=g;g=b+6044|0;j=c[g>>2]|0;if(j){q=j;r=f;s=p;t=c[q>>2]|0;u=t+8|0;v=c[u>>2]|0;w=e?0:k;x=gn[v&127](q,r,h,s,w,585932|0,585936|0)|0;y=x&1;a[585848]=y;i=l;return}p=mo[c[(c[b>>2]|0)+784>>2]&4095](b)|0;c[g>>2]=p;q=p;r=c[146482]|0;s=c[146477]|0;t=c[q>>2]|0;u=t+8|0;v=c[u>>2]|0;w=e?0:k;x=gn[v&127](q,r,h,s,w,585932|0,585936|0)|0;y=x&1;a[585848]=y;i=l;return}function foc(a,d,e,f,g,h,j,k){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a=i;i=i+16|0;l=a+8|0;m=a+4|0;n=a;o=c[146481]|0;if((o|0)==2){p=j>>>2;q=p*6|0;c[m>>2]=c[153134];c[l+0>>2]=c[m+0>>2];m=cOb(p*12|0,16,l,0,3653512,576)|0;if(p){r=h;s=0;while(1){t=s*6|0;b[m+(t<<1)>>1]=b[r>>1]|0;b[m+((t|1)<<1)>>1]=b[r+2>>1]|0;u=r+4|0;b[m+(t+2<<1)>>1]=b[u>>1]|0;b[m+(t+3<<1)>>1]=b[r>>1]|0;b[m+(t+4<<1)>>1]=b[u>>1]|0;b[m+(t+5<<1)>>1]=b[r+6>>1]|0;s=s+1|0;if(s>>>0>=p>>>0)break;else r=r+8|0}}r=Mmc(c[146484]|0,m,0,q,f,c[146478]|0,0)|0;c[n>>2]=c[153134];c[l+0>>2]=c[n+0>>2];eOb(m,l);v=r}else v=Mmc(c[146484]|0,h,0,j,f,c[146478]|0,(o|0)==1)|0;o=Nmc(c[146483]|0,d,e,f,g,c[146475]|0,k)|0;c[146484]=(c[146484]|0)+(v<<1);k=da(c[146482]|0,o)|0;c[146483]=(c[146483]|0)+k;c[146479]=(c[146479]|0)+v;c[146478]=(c[146478]|0)+o;c[146480]=(c[146480]|0)+1;i=a;return}function goc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0.0,m=0;e=i;f=b+6044|0;g=c[f>>2]|0;if(!g){h=mo[c[(c[b>>2]|0)+784>>2]&4095](b)|0;c[f>>2]=h;j=h}else j=g;co[c[(c[j>>2]|0)+12>>2]&2047](j,c[146478]|0,c[146479]|0);co[c[(c[b>>2]|0)+96>>2]&2047](b,601008,d);d=c[f>>2]|0;if(!d){j=mo[c[(c[b>>2]|0)+784>>2]&4095](b)|0;c[f>>2]=j;k=j}else k=d;co[c[(c[k>>2]|0)+16>>2]&2047](k,585864,c[146485]|0);l=+Ki()*1.0e6;k=+S(l)>=1.0?(l>0.0?(ha(+R(l/4294967296.0),4294967295.0)|0)>>>0:~~+ca((l-+(~~l>>>0))/4294967296.0)>>>0):0;d=585856;j=ZEi(~~l>>>0|0,k|0,c[d>>2]|0,c[d+4>>2]|0)|0;d=H;k=c[146479]|0;switch(c[146481]|0){case 4:{m=k+-1|0;break}case 1:{m=k+-2|0;break}case 0:{m=(k|0)/3|0;break}case 5:{m=k;break}case 2:{m=((k|0)/4|0)<<1;break}case 3:{m=(k|0)/2|0;break}default:m=0}if(!(a[b+5568>>0]|0)){a[585848]=0;i=e;return}k=c[146480]|0;f=c[146478]|0;g=b+5364|0;c[g>>2]=(c[g>>2]|0)+1;g=b+5368|0;c[g>>2]=(c[g>>2]|0)+k;k=b+5408|0;g=k;h=_Ei(j|0,d|0,c[g>>2]|0,c[g+4>>2]|0)|0;g=k;c[g>>2]=h;c[g+4>>2]=H;g=b+5372|0;c[g>>2]=(c[g>>2]|0)+m;m=b+5376|0;c[m>>2]=(c[m>>2]|0)+f;a[585848]=0;i=e;return}function hoc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;i=i+16|0;g=a+4|0;h=a;j=Hjc(c[146483]|0,c[146484]|0,c[146478]|0,b,d,e,f,g,h)|0;f=c[g>>2]|0;g=da(c[146482]|0,f)|0;c[146483]=(c[146483]|0)+g;c[146478]=(c[146478]|0)+f;f=c[h>>2]|0;c[146484]=(c[146484]|0)+(f<<1);c[146479]=(c[146479]|0)+f;c[146480]=(c[146480]|0)+j;i=a;return}function ioc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;a=i;i=i+16|0;j=a+4|0;k=a;l=c[146483]|0;m=c[146484]|0;n=c[146475]|0;c[k>>2]=c[h>>2];h=c[146478]|0;c[j+0>>2]=c[k+0>>2];Omc(l,m,n,b,d,e,f,g,j,h);c[146484]=(c[146484]|0)+(g<<1);h=da(c[146482]|0,e)|0;c[146483]=(c[146483]|0)+h;c[146479]=(c[146479]|0)+g;c[146478]=(c[146478]|0)+e;c[146480]=(c[146480]|0)+1;i=a;return}function joc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(!(a[b+5568>>0]|0)){i=g;return}h=b+5364|0;c[h>>2]=(c[h>>2]|0)+1;h=b+5368|0;c[h>>2]=(c[h>>2]|0)+f;f=b+5372|0;c[f>>2]=(c[f>>2]|0)+d;d=b+5376|0;c[d>>2]=(c[d>>2]|0)+e;i=g;return}function koc(a){a=a|0;var b=0;b=a+5396|0;c[b>>2]=(c[b>>2]|0)+1;return}function loc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[153074]|0;g=b+4|0;c[g>>2]=(c[g>>2]|0)+-1;if(c[g>>2]|0){i=a;return}ko[c[c[b>>2]>>2]&4095](b);c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(b,d);i=a;return}function moc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[153076]|0;g=b+4|0;c[g>>2]=(c[g>>2]|0)+-1;if(c[g>>2]|0){i=a;return}ko[c[c[b>>2]>>2]&4095](b);c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(b,d);i=a;return}function noc(a){a=a|0;c[146486]=(c[146486]|0)+1;return c[146486]|0}function ooc(a,b){a=a|0;b=b|0;return}function poc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+48|0;e=a+32|0;f=a+24|0;g=a+8|0;h=a;j=c[b>>2]|0;c[h>>2]=j;do if((c[146729]|0)!=(c[146721]|0)){Roc(e,586880,h);b=c[e>>2]|0;k=c[146727]|0;if((b|0)==-1){l=c[146728]|0;m=k;n=l;o=k+(l<<3)|0;break}else{m=k;n=c[146728]|0;o=k+(b<<3)|0;break}}else{b=c[146727]|0;k=c[146728]|0;m=b;n=k;o=b+(k<<3)|0}while(0);if((o|0)==(m+(n<<3)|0)){c[f>>2]=j;c[f+4>>2]=d;Soc(g,586880,f);i=a;return}else{c[o+4>>2]=d;i=a;return}}function qoc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+8|0;f=b;c[f>>2]=c[d>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(e,586880,f);d=c[e>>2]|0;g=c[146727]|0;h=c[146728]|0;if((d|0)==-1){j=g;k=h;l=g+(h<<3)|0;break}else{j=g;k=h;l=g+(d<<3)|0;break}}else{d=c[146727]|0;g=c[146728]|0;j=d;k=g;l=d+(g<<3)|0}while(0);if((l|0)==(j+(k<<3)|0)){i=b;return}k=586892|0;j=c[k+4>>2]|0;e=l;c[e>>2]=c[k>>2];c[e+4>>2]=j;c[146721]=(c[146721]|0)+1;a[586928]=1;i=b;return}function roc(a){a=a|0;c[146488]=(c[146488]|0)+1;return c[146488]|0}function soc(a,b){a=a|0;b=b|0;return}function toc(a){a=a|0;var b=0;b=i;Aqc(a+5320|0);i=b;return}function uoc(a){a=a|0;var b=0;b=i;Cqc(a+5320|0);i=b;return}function voc(a){a=a|0;var b=0;b=i;Dqc(a+5320|0);i=b;return}function woc(a){a=a|0;var b=0,c=0,d=0;b=i;c=a+5576|0;d=a+5320|0;Eqc(c,d);Fqc(c,d);i=b;return}function xoc(a){a=a|0;var b=0,c=0,d=0;b=i;c=a+5320|0;d=a+5576|0;Eqc(c,d);Fqc(c,d);i=b;return}function yoc(a){a=a|0;return}function zoc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Krd(585960,0,3653512,785,1,0,0,0);i=d;return}function Aoc(a){a=a|0;var b=0;b=i;if(a&4)EDc(1,1,0,1);if(a&2)Sld();if(!(a&1)){i=b;return}OBc();i=b;return}function Boc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=Im;a=i;if(c){i=a;return}if(d){d=b+4|0;g[d>>2]=ea(-ea(g[d>>2]));d=b+20|0;g[d>>2]=ea(-ea(g[d>>2]));d=b+36|0;g[d>>2]=ea(-ea(g[d>>2]));d=b+52|0;g[d>>2]=ea(-ea(g[d>>2]))}d=b+8|0;e=ea(ea(g[d>>2])*ea(.5));g[d>>2]=ea(e+ea(ea(g[b+12>>2])*ea(.5)));d=b+24|0;e=ea(ea(g[d>>2])*ea(.5));g[d>>2]=ea(e+ea(ea(g[b+28>>2])*ea(.5)));d=b+40|0;e=ea(ea(g[d>>2])*ea(.5));g[d>>2]=ea(e+ea(ea(g[b+44>>2])*ea(.5)));d=b+56|0;e=ea(ea(g[d>>2])*ea(.5));g[d>>2]=ea(e+ea(ea(g[b+60>>2])*ea(.5)));i=a;return}function Coc(b,c){b=b|0;c=c|0;var e=0,f=0;e=i;f=b+5972|0;if((d[f>>0]|0|0)==(c&1|0)){i=e;return}a[f>>0]=c&1;g[b+580>>2]=c?ea(-1.0):ea(1.0);c=b+2808|0;g[c>>2]=ea(-ea(g[c>>2]));c=b+2840|0;g[c>>2]=ea(-ea(g[c>>2]));i=e;return}function Doc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;e=i;f=b+8|0;h=b+16|0;j=a+(h<<4)+4|0;k=b+24|0;l=a+(k<<4)+4|0;m=d+32|0;n=a+(b<<4)+4|0;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];m=a+2724|0;o=ea(g[m>>2]);p=ea(g[d>>2]);q=ea(o*p);n=a+2740|0;o=ea(g[n>>2]);r=ea(g[d+4>>2]);s=ea(q+ea(o*r));b=a+2756|0;o=ea(g[b>>2]);q=ea(g[d+8>>2]);t=ea(s+ea(o*q));u=a+2728|0;o=ea(g[u>>2]);v=a+2744|0;s=ea(g[v>>2]);w=a+2760|0;x=ea(g[w>>2]);y=a+2732|0;z=ea(g[y>>2]);A=a+2748|0;B=ea(g[A>>2]);C=a+2764|0;D=ea(g[C>>2]);if((c[d+60>>2]|0)==1){E=ea(0.0);F=ea(-ea(ea(ea(p*z)+ea(r*B))+ea(q*D)));G=ea(-ea(ea(ea(p*o)+ea(r*s))+ea(q*x)));H=ea(-t)}else{I=ea(t+ea(g[a+2772>>2]));t=ea(ea(ea(p*o)+ea(r*s))+ea(q*x));x=ea(ea(g[a+2776>>2])+t);t=ea(ea(ea(p*z)+ea(r*B))+ea(q*D));E=ea(1.0);F=ea(ea(g[a+2780>>2])+t);G=x;H=I}g[a+(f<<4)+4>>2]=H;g[a+(f<<4)+8>>2]=G;g[a+(f<<4)+12>>2]=F;g[a+(f<<4)+16>>2]=E;E=ea(g[d+48>>2]);F=ea(E*E);E=ea(g[d+56>>2]);if(!(E>ea(0.0))){g[j>>2]=ea(0.0);g[a+(h<<4)+8>>2]=ea(0.0);g[a+(h<<4)+12>>2]=ea(1.0);g[a+(h<<4)+16>>2]=ea(0.0);G=ea(g[d+52>>2]);g[l>>2]=ea(-1.0);g[a+(k<<4)+8>>2]=ea(1.0);g[a+(k<<4)+12>>2]=G;g[a+(k<<4)+16>>2]=F;i=e;return}G=ea(g[m>>2]);H=ea(g[d+16>>2]);I=ea(G*H);G=ea(g[n>>2]);x=ea(g[d+20>>2]);t=ea(I+ea(G*x));G=ea(g[b>>2]);I=ea(g[d+24>>2]);D=ea(t+ea(G*I));G=ea(H*ea(g[u>>2]));t=ea(G+ea(x*ea(g[v>>2])));G=ea(t+ea(I*ea(g[w>>2])));t=ea(H*ea(g[y>>2]));H=ea(t+ea(x*ea(g[A>>2])));x=ea(-G);G=ea(-ea(H+ea(I*ea(g[C>>2]))));g[j>>2]=ea(-D);g[a+(h<<4)+8>>2]=x;g[a+(h<<4)+12>>2]=G;g[a+(h<<4)+16>>2]=ea(0.0);G=ea(ea(ea(E/ea(360.0))*ea(2.0))*ea(3.14159274));E=ea(+V(+ea(G*ea(.5))));x=ea(ea(+V(+ea(G*ea(.25))))-E);if(x!=ea(0.0))J=ea(ea(1.0)/x);else J=ea(1.0);x=ea(g[d+52>>2]);g[l>>2]=E;g[a+(k<<4)+8>>2]=J;g[a+(k<<4)+12>>2]=x;g[a+(k<<4)+16>>2]=F;i=e;return}function Eoc(a,b,d,e,f,g){a=a|0;b=ea(b);d=ea(d);e=ea(e);f=ea(f);g=g|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;h=i;if(!g){co[c[(c[a>>2]|0)+576>>2]&2047](a,2,0);qn[c[(c[a>>2]|0)+560>>2]&7](a,ea(0.0),ea(0.0),ea(0.0));j=ea(b+f);k=ea(d-f);l=ea(e-f);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,k,l);m=ea(b-f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,k,l);n=ea(d+f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,n,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,l);o=ea(e+f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,k,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,k,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,n,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,n,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,k,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,k,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,n,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,k,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,k,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,k,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,k,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,k,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,k,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,n,l);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,n,o);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,o);ko[c[(c[a>>2]|0)+580>>2]&4095](a);i=h;return}else if((g|0)==1){o=ea(f*ea(1.25840795));co[c[(c[a>>2]|0)+576>>2]&2047](a,0,0);qn[c[(c[a>>2]|0)+560>>2]&7](a,ea(0.0),ea(0.0),ea(0.0));f=ea(ea(o*ea(.606999993))+b);n=ea(ea(o*ea(0.0))+d);j=ea(o*ea(.795000016));m=ea(j+e);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);l=ea(o*ea(.187999994));k=ea(l+b);p=ea(ea(o*ea(.577000022))+d);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,p,m);q=ea(ea(o*ea(-.490999997))+b);r=ea(ea(o*ea(.356999993))+d);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,r,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,r,m);s=ea(ea(o*ea(-.356999993))+d);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,s,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,s,m);t=ea(ea(o*ea(-.577000022))+d);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,t,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);u=ea(ea(o*ea(.981999993))+b);v=ea(l+e);qn[c[(c[a>>2]|0)+556>>2]&7](a,u,n,v);l=ea(j+b);j=ea(o*ea(-.187999994));w=ea(j+e);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,p,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,p,w);x=ea(ea(o*ea(.30399999))+b);y=ea(ea(o*ea(.934000015))+d);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,y,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,y,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,p,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,p,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,y,v);z=ea(ea(o*ea(-.30399999))+b);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,y,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,p,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,y,w);A=ea(o*ea(-.795000016));B=ea(A+b);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,p,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,p,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,p,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,r,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,r,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,p,v);C=ea(ea(o*ea(-.981999993))+b);qn[c[(c[a>>2]|0)+556>>2]&7](a,C,n,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,r,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,C,n,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,t,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,r,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,t,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,s,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,s,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,t,v);D=ea(ea(o*ea(-.934000015))+d);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,D,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,s,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,D,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,D,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,q,s,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,D,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,t,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,t,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,D,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,t,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,t,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,t,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,u,n,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,k,t,m);qn[c[(c[a>>2]|0)+556>>2]&7](a,u,n,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,f,n,m);m=ea(ea(o*ea(.490999997))+b);f=ea(A+e);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);e=ea(j+b);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,p,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,y,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,y,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,y,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,y,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,p,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,p,f);j=ea(ea(o*ea(-.606999993))+b);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,C,n,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,p,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,C,n,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,p,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,p,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,p,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,y,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,t,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,D,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,D,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,t,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,B,t,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,C,n,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,t,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,s,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,t,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,t,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,t,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,D,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,t,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,x,D,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,z,D,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,s,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,p,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,s,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,p,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,u,n,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,s,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,u,n,v);qn[c[(c[a>>2]|0)+556>>2]&7](a,l,t,w);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,s,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,t,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,t,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,m,r,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,j,n,f);qn[c[(c[a>>2]|0)+556>>2]&7](a,e,p,f);ko[c[(c[a>>2]|0)+580>>2]&4095](a);i=h;return}else{Krd(586048,0,3653512,1029,32785,0,0,0);i=h;return}}function Foc(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=ea(e);var f=0;f=i;rnc(c[a+6004>>2]|0,b,d,e);i=f;return}function Goc(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=ea(e);var f=0;f=i;snc(c[a+6004>>2]|0,b,d,e);i=f;return}function Hoc(a,b,d,e,f){a=a|0;b=ea(b);d=ea(d);e=ea(e);f=ea(f);var g=0;g=i;tnc(c[a+6004>>2]|0,b,d,e,f);i=g;return}function Ioc(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=ea(e);var f=0;f=i;unc(c[a+6004>>2]|0,b,d,e);i=f;return}function Joc(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=ea(e);f=ea(f);var g=0;g=i;vnc(c[a+6004>>2]|0,b,d,e,f);i=g;return}function Koc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;nnc(c[a+6004>>2]|0,b,d);i=e;return}function Loc(a){a=a|0;var b=0;b=i;pnc(c[a+6004>>2]|0);i=b;return}function Moc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;d=a+8|0;e=a;c[e>>2]=c[b>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(d,586880,e);b=c[d>>2]|0;f=c[146727]|0;if((b|0)==-1){g=c[146728]|0;h=f;j=g;k=f+(g<<3)|0;break}else{h=f;j=c[146728]|0;k=f+(b<<3)|0;break}}else{b=c[146727]|0;f=c[146728]|0;h=b;j=f;k=b+(f<<3)|0}while(0);if((k|0)==(h+(j<<3)|0)){l=0;i=a;return l|0}l=c[k+4>>2]|0;i=a;return l|0}function Noc(a,b){a=a|0;b=b|0;return}function Ooc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=584920;nrc(a+6008|0,a);wsd(a+6024|0);f=a+6044|0;g=c[f>>2]|0;if(g)ko[c[(c[g>>2]|0)+4>>2]&4095](g);c[f>>2]=0;f=a+6048|0;g=c[f>>2]|0;h=c[153080]|0;if(g){c[g+4>>2]=0;c[g>>2]=0}c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;f=a+6052|0;g=c[f>>2]|0;h=c[153080]|0;if(g){c[g+4>>2]=0;c[g>>2]=0}c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;Qoc(a+6056|0,c[a+6060>>2]|0);if((c[a+6036>>2]|0)>-1){f=a+6024|0;g=c[f>>2]|0;c[e>>2]=c[a+6028>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+6020>>2]|0)>-1){f=a+6008|0;g=c[f>>2]|0;c[e>>2]=c[a+6012>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=a+3748|0;d=a+5284|0;do{d=d+-64|0;gxd(d)}while((d|0)!=(f|0));i=b;return}function Poc(){var a=0,b=0,d=0;a=i;b=584776|0;d=b+64|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=584840|0;d=b+64|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));hnc(585864|0);i=a;return}function Qoc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Qoc(a,c[b>>2]|0);Qoc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Roc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=(c[d+32>>2]|0)+-1|0;h=c[e>>2]|0;e=h+2127912214+(h<<12)|0;j=e^-949894596^e>>>19;e=j+374761393+(j<<5)|0;j=e+-744332180^e<<9;e=j+-42973499+(j<<3)|0;j=(e^-1252372727^e>>>16)&g;e=c[d+28>>2]|0;k=c[d+20>>2]|0;l=c[e+(j<<3)>>2]|0;a:do if((k|0)==(l|0)){m=j;n=5}else{o=d+4|0;p=d+12|0;b:do if(!(a[d+8>>0]|0)){q=l;r=j;s=0;while(1){if((h|0)==(q|0)){t=r;break b}s=s+1|0;u=s+r&g;q=c[e+(u<<3)>>2]|0;if((k|0)==(q|0)){m=u;n=5;break a}else r=u}}else{r=l;q=-1;s=j;u=0;while(1){if((c[o>>2]|0)!=0?(c[p>>2]|0)==(r|0):0)v=(q|0)==-1?s:q;else if((h|0)==(r|0)){t=s;break b}else v=q;u=u+1|0;w=u+s&g;r=c[e+(w<<3)>>2]|0;if((k|0)==(r|0)){x=v;y=w;break}else{q=v;s=w}}c[b>>2]=-1;s=b+4|0;if((x|0)==-1){z=y;A=s;break a}c[s>>2]=x;i=f;return}while(0);c[b>>2]=t;c[b+4>>2]=-1;i=f;return}while(0);if((n|0)==5){c[b>>2]=-1;z=m;A=b+4|0}c[A>>2]=z;i=f;return}function Soc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;sqc(d,1,0);Roc(g,d,e);h=c[g>>2]|0;if((h|0)!=-1){j=c[d+28>>2]|0;k=j+(c[d+32>>2]<<3)|0;c[b>>2]=d;c[b+4>>2]=j+(h<<3);c[b+8>>2]=k;a[b+12>>0]=0;i=f;return}k=c[g+4>>2]|0;if(((a[d+8>>0]|0)!=0?(g=d+4|0,h=c[g>>2]|0,(h|0)!=0):0)?(j=c[d+28>>2]|0,(c[d+12>>2]|0)==(c[j+(k<<3)>>2]|0)):0){c[g>>2]=h+-1;l=j}else{j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;l=c[d+28>>2]|0}j=l+(k<<3)|0;if(!j)m=l;else{l=e;e=c[l+4>>2]|0;h=j;c[h>>2]=c[l>>2];c[h+4>>2]=e;m=c[d+28>>2]|0}e=m+(c[d+32>>2]<<3)|0;c[b>>2]=d;c[b+4>>2]=m+(k<<3);c[b+8>>2]=e;a[b+12>>0]=1;i=f;return}function Toc(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+8>>2]&4095](a);i=b;return}function Uoc(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+8>>2]&4095](a);i=b;return}function Voc(a,b){a=a|0;b=b|0;c[a+5988>>2]=b;return}function Woc(a,b){a=a|0;b=b|0;c[a+5968>>2]=b;return}function Xoc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Yoc(a,b){a=a|0;b=b|0;return}function Zoc(a,b){a=a|0;b=b|0;return}function _oc(a,b){a=a|0;b=b|0;return}function $oc(a){a=a|0;return}function apc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function bpc(a,b,c){a=a|0;b=b|0;c=c|0;return}function cpc(a){a=a|0;return 0}function dpc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return}function epc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function fpc(a,b,c){a=a|0;b=b|0;c=c|0;return}function gpc(a,b){a=a|0;b=b|0;return}function hpc(a){a=a|0;return 0}function ipc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return}function jpc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function kpc(a,b,c){a=a|0;b=b|0;c=c|0;return}function lpc(a,b){a=a|0;b=b|0;return}function mpc(a,b){a=a|0;b=b|0;return 0}function npc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return}function opc(a){a=a|0;return 0}function ppc(a,b){a=a|0;b=b|0;return}function qpc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function rpc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return}function spc(a){a=a|0;return}function tpc(a,b){a=a|0;b=b|0;return}function upc(a,b,c){a=a|0;b=b|0;c=c|0;return}function vpc(a){a=a|0;return c[a+5996>>2]|0}function wpc(a){a=a|0;return c[a+6e3>>2]|0}function xpc(a,b){a=a|0;b=b|0;c[a+5996>>2]=b;return}function ypc(a,b){a=a|0;b=b|0;c[a+6e3>>2]=b;return}function zpc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;f=c[155258]|0;return (f|0)>=(d|0)&(f|0)>=(b|0)|0}function Apc(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;i=a;c[i>>2]=1;c[i+4>>2]=1;return}function Bpc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return}function Cpc(a,b){a=a|0;b=b|0;b=i;ko[c[(c[a>>2]|0)+508>>2]&4095](a);i=b;return}function Dpc(a){a=a|0;return 1}function Epc(a){a=a|0;return}function Fpc(a){a=a|0;return 0}function Gpc(a){a=a|0;return 0}function Hpc(a,b){a=a|0;b=b|0;return}function Ipc(a){a=a|0;return}function Jpc(a){a=a|0;return}function Kpc(a){a=a|0;return 0}function Lpc(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Mpc(a){a=a|0;return}function Npc(a,b){a=a|0;b=b|0;return}function Opc(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a+5960>>2]=b;g[a+5964>>2]=c;return}function Ppc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Qpc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Rpc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Spc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Tpc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Upc(a){a=a|0;return 0}function Vpc(a){a=a|0;return 2}function Wpc(a){a=a|0;return 0}function Xpc(a,b){a=a|0;b=b|0;return 0}function Ypc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Zpc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function _pc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function $pc(a,b,c){a=a|0;b=b|0;c=c|0;return}function aqc(a,b,c){a=a|0;b=b|0;c=c|0;return}function bqc(a){a=a|0;return}function cqc(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function dqc(a,b){a=a|0;b=b|0;return}function eqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function fqc(a,b,c){a=a|0;b=b|0;c=c|0;return}function gqc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function hqc(a,b){a=a|0;b=b|0;return}function iqc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return}function jqc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return}function kqc(a,b){a=a|0;b=b|0;return}function lqc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function mqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function nqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function oqc(a,b){a=a|0;b=b|0;return}function pqc(a){a=a|0;return 1}function qqc(a){a=a|0;return 0}function rqc(a,b){a=a|0;b=b|0;return}function sqc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+64|0;h=g+56|0;j=g+52|0;k=g;l=d+48|0;if(a[l>>0]|0)tqc(d);m=d+32|0;n=c[m>>2]|0;o=c[d+36>>2]|0;if(n>>>0>f>>>0?(o+e|0)>>>0<=(c[d+44>>2]|0)>>>0:0){i=g;return}p=d+36|0;q=o+e|0;r=ea(q>>>0);e=32;while(1){if(e>>>0>=f>>>0?!(r>=ea(ea(e>>>0)*ea(.5))):0){s=e;break}e=e<<1}if(s>>>0<=n>>>0){i=g;return}n=d+4|0;r=ea((q-(c[n>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=f>>>0?!(r>=ea(ea(q>>>0)*ea(.5))):0){t=q;break}q=q<<1}q=k+4|0;c[q>>2]=0;f=k+8|0;s=d+8|0;a[f>>0]=a[s>>0]|0;e=k+9|0;o=d+9|0;a[e>>0]=a[o>>0]|0;u=k+12|0;v=d+12|0;w=v;x=c[w+4>>2]|0;y=u;c[y>>2]=c[w>>2];c[y+4>>2]=x;x=k+20|0;y=d+20|0;w=y;z=c[w+4>>2]|0;A=x;c[A>>2]=c[w>>2];c[A+4>>2]=z;z=k+28|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;a[z+20>>0]=0;uqc(k,d,t);t=c[n>>2]|0;c[n>>2]=c[q>>2];c[q>>2]=t;t=a[s>>0]|0;q=b[f>>1]|0;a[s>>0]=q;a[f>>0]=t;t=a[o>>0]|0;a[o>>0]=(q&65535)>>>8;a[e>>0]=t;t=v;e=c[t>>2]|0;q=c[t+4>>2]|0;t=u;o=c[t+4>>2]|0;f=v;c[f>>2]=c[t>>2];c[f+4>>2]=o;o=u;c[o>>2]=e;c[o+4>>2]=q;q=y;o=c[q>>2]|0;e=c[q+4>>2]|0;q=x;u=c[q+4>>2]|0;f=y;c[f>>2]=c[q>>2];c[f+4>>2]=u;u=x;c[u>>2]=o;c[u+4>>2]=e;e=d+28|0;u=c[e>>2]|0;c[e>>2]=c[z>>2];c[z>>2]=u;z=k+32|0;e=c[m>>2]|0;o=c[z>>2]|0;c[m>>2]=o;c[z>>2]=e;z=k+36|0;m=c[p>>2]|0;c[p>>2]=c[z>>2];c[z>>2]=m;r=ea(o>>>0);c[d+44>>2]=~~ea(r*ea(.5))>>>0;c[d+40>>2]=~~ea(r*ea(.200000003))>>>0;a[l>>0]=0;r=ea(e>>>0);c[k+44>>2]=~~ea(r*ea(.5))>>>0;c[k+40>>2]=~~ea(r*ea(.200000003))>>>0;a[k+48>>0]=0;if(!u){i=g;return}c[j>>2]=57;c[h+0>>2]=c[j+0>>2];eOb(u,h);i=g;return}function tqc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e;j=d+36|0;k=d+4|0;l=(c[j>>2]|0)-(c[k>>2]|0)|0;m=d+40|0;if(l>>>0>=(c[m>>2]|0)>>>0){n=d+48|0;a[n>>0]=0;i=e;return}o=d+32|0;p=c[o>>2]|0;if(p>>>0<=32){n=d+48|0;a[n>>0]=0;i=e;return}q=ea(l>>>0);l=p;while(1){p=l>>>1;if(l>>>0<66){r=p;break}if(q<ea(ea(p>>>0)*ea(.200000003)))l=p;else{r=p;break}}l=h+4|0;c[l>>2]=0;p=h+8|0;s=d+8|0;a[p>>0]=a[s>>0]|0;t=h+9|0;u=d+9|0;a[t>>0]=a[u>>0]|0;v=h+12|0;w=d+12|0;x=w;y=c[x+4>>2]|0;z=v;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=h+20|0;z=d+20|0;x=z;A=c[x+4>>2]|0;B=y;c[B>>2]=c[x>>2];c[B+4>>2]=A;A=h+28|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;a[A+20>>0]=0;uqc(h,d,r);r=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=r;r=a[s>>0]|0;l=b[p>>1]|0;a[s>>0]=l;a[p>>0]=r;r=a[u>>0]|0;a[u>>0]=(l&65535)>>>8;a[t>>0]=r;r=w;t=c[r>>2]|0;l=c[r+4>>2]|0;r=v;u=c[r+4>>2]|0;p=w;c[p>>2]=c[r>>2];c[p+4>>2]=u;u=v;c[u>>2]=t;c[u+4>>2]=l;l=z;u=c[l>>2]|0;t=c[l+4>>2]|0;l=y;v=c[l+4>>2]|0;p=z;c[p>>2]=c[l>>2];c[p+4>>2]=v;v=y;c[v>>2]=u;c[v+4>>2]=t;t=d+28|0;v=c[t>>2]|0;c[t>>2]=c[A>>2];c[A>>2]=v;A=h+32|0;t=c[o>>2]|0;u=c[A>>2]|0;c[o>>2]=u;c[A>>2]=t;A=h+36|0;o=c[j>>2]|0;c[j>>2]=c[A>>2];c[A>>2]=o;q=ea(u>>>0);c[d+44>>2]=~~ea(q*ea(.5))>>>0;c[m>>2]=~~ea(q*ea(.200000003))>>>0;a[d+48>>0]=0;q=ea(t>>>0);c[h+44>>2]=~~ea(q*ea(.5))>>>0;c[h+40>>2]=~~ea(q*ea(.200000003))>>>0;a[h+48>>0]=0;if(!v){n=d+48|0;a[n>>0]=0;i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(v,f);n=d+48|0;a[n>>0]=0;i=e;return}function uqc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+28|0;k=b+32|0;c[k>>2]=32;l=b+44|0;c[l>>2]=16;m=b+40|0;c[m>>2]=6;n=b+48|0;a[n>>0]=0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];o=cOb(256,16,g,0,3653512,80)|0;p=c[j>>2]|0;if(p){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(p,g)}c[j>>2]=o;p=o+(c[k>>2]<<3)|0;if((o|0)!=(p|0)){q=b+20|0;r=o;do{if(r){o=q;s=c[o+4>>2]|0;t=r;c[t>>2]=c[o>>2];c[t+4>>2]=s}r=r+8|0}while((r|0)!=(p|0))}p=b+36|0;c[p>>2]=0;c[b+4>>2]=0;r=d+4|0;u=ea(((c[d+36>>2]|0)-(c[r>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=e>>>0?(v=ea(q>>>0),w=ea(v*ea(.5)),!(u>=w)):0){x=v;y=w;z=q;break}q=q<<1}q=c[k>>2]|0;if(z>>>0>q>>>0){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];e=cOb(z<<3,16,g,0,3653512,80)|0;s=c[j>>2]|0;t=c[k>>2]|0;o=t>>>0>z>>>0?z:t;A=s+(o<<3)|0;if(!o)B=t;else{t=e;o=s;while(1){if(t){s=o;C=c[s+4>>2]|0;D=t;c[D>>2]=c[s>>2];c[D+4>>2]=C}o=o+8|0;if((o|0)==(A|0))break;else t=t+8|0}B=c[k>>2]|0}t=e+(z<<3)|0;if((B|0)!=(z|0)){A=b+20|0;o=e+(B<<3)|0;do{if(o){B=A;C=c[B+4>>2]|0;D=o;c[D>>2]=c[B>>2];c[D+4>>2]=C}o=o+8|0}while((o|0)!=(t|0))}t=c[j>>2]|0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(t,g);c[j>>2]=e;c[k>>2]=z;c[l>>2]=~~y>>>0;c[m>>2]=~~ea(x*ea(.200000003))>>>0;a[n>>0]=0;E=z}else E=q;q=d+28|0;z=c[q>>2]|0;n=d+32|0;m=c[n>>2]|0;l=z+(m<<3)|0;a:do if(m){e=c[d+20>>2]|0;g=c[d+12>>2]|0;if((c[r>>2]|0)!=0&(a[d+8>>0]|0)!=0){t=z;do{h=c[t>>2]|0;if(!((e|0)==(h|0)|(g|0)==(h|0))){F=t;break a}t=t+8|0}while((t|0)!=(l|0));i=f;return}else{t=z;do{if((e|0)!=(c[t>>2]|0)){F=t;break a}t=t+8|0}while((t|0)!=(l|0));i=f;return}}else F=z;while(0);if((F|0)==(l|0)){i=f;return}z=b+20|0;b=d+20|0;m=d+8|0;t=d+12|0;d=E;E=F;while(1){F=d+-1|0;e=c[E>>2]|0;g=e+2127912214+(e<<12)|0;e=g^-949894596^g>>>19;g=e+374761393+(e<<5)|0;e=g+-744332180^g<<9;g=e+-42973499+(e<<3)|0;e=(g^-1252372727^g>>>16)&F;g=c[j>>2]|0;h=c[z>>2]|0;if((h|0)==(c[g+(e<<3)>>2]|0))G=e;else{o=e;e=0;while(1){e=e+1|0;A=e+o&F;if((h|0)==(c[g+(A<<3)>>2]|0)){G=A;break}else o=A}}o=g+(G<<3)|0;if(o){h=E;F=c[h+4>>2]|0;e=o;c[e>>2]=c[h>>2];c[e+4>>2]=F}c[p>>2]=(c[p>>2]|0)+1;F=E+8|0;b:do if((F|0)!=(l|0)){e=c[b>>2]|0;h=c[t>>2]|0;if((c[r>>2]|0)!=0&(a[m>>0]|0)!=0){o=E;A=F;while(1){C=c[o+8>>2]|0;if(!((e|0)==(C|0)|(h|0)==(C|0))){H=A;break b}C=o+16|0;if((C|0)==(l|0)){H=l;break}else{D=A;A=C;o=D}}}else{o=E;A=F;while(1){if((e|0)!=(c[o+8>>2]|0)){H=A;break b}h=o+16|0;if((h|0)==(l|0)){H=l;break}else{D=A;A=h;o=D}}}}else H=l;while(0);if((H|0)==((c[q>>2]|0)+(c[n>>2]<<3)|0))break;d=c[k>>2]|0;E=H}i=f;return}function vqc(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(d)eo[d&511]();d=c[a+4>>2]|0;if(d)eo[d&511]();d=c[a+8>>2]|0;if(d)eo[d&511]();d=c[a+12>>2]|0;if(d)eo[d&511]();d=c[a+16>>2]|0;if(d)eo[d&511]();d=c[a+20>>2]|0;if(d)eo[d&511]();d=c[a+24>>2]|0;if(d)eo[d&511]();d=c[a+28>>2]|0;if(d)eo[d&511]();d=c[a+32>>2]|0;if(d)eo[d&511]();d=c[a+36>>2]|0;if(d)eo[d&511]();d=c[a+40>>2]|0;if(d)eo[d&511]();d=c[a+44>>2]|0;if(d)eo[d&511]();d=c[a+48>>2]|0;if(d)eo[d&511]();d=c[a+52>>2]|0;if(d)eo[d&511]();d=c[a+56>>2]|0;if(d)eo[d&511]();d=c[a+60>>2]|0;if(!d){i=b;return}eo[d&511]();i=b;return}function wqc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+16|0;m=l+4|0;n=l;if((2147483630-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))o=b+1|0;else o=c[b+8>>2]|0;if(d>>>0<1073741799){p=e+d|0;e=d<<1;q=p>>>0<e>>>0?e:p;if(q>>>0<11)r=11;else r=q+16&-16}else r=2147483631;c[n>>2]=59;c[m+0>>2]=c[n+0>>2];q=cOb(r,16,m,0,3653512,80)|0;if(g)YEi(q|0,o|0,g|0)|0;if(j)YEi(q+g|0,k|0,j|0)|0;k=f-h|0;if((k|0)!=(g|0))YEi(q+(j+g)|0,o+(h+g)|0,k-g|0)|0;if((d|0)==10){s=b+8|0;c[s>>2]=q;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=q+u|0;a[w>>0]=0;i=l;return}c[n>>2]=59;c[m+0>>2]=c[n+0>>2];eOb(o,m);s=b+8|0;c[s>>2]=q;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=q+u|0;a[w>>0]=0;i=l;return}function xqc(){var a=0,b=0,c=0;a=i;qSc()|0;b=Ig()|0;if((b|0)==2)c=owe()|0;else if((b|0)==1)c=hwe()|0;else{Krd(586072,0,3653512,430,1,0,0,0);rl(-1)}Anc(c);Jjd(620920);i=a;return (c|0)!=0|0}function yqc(a){a=a|0;var b=0;c[a>>2]=586144;c[a+128>>2]=64;c[a+132>>2]=64;c[a+136>>2]=4;c[a+140>>2]=4;c[a+144>>2]=4;c[a+148>>2]=0;c[a+152>>2]=49152;b=a+160|0;c[b>>2]=0;c[b+4>>2]=0;return}function zqc(a){a=a|0;return}function Aqc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;e=a+112|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;e=a+168|0;a=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));e=d+0|0;a=e+104|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));i=b;return}function Bqc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;c[a+128>>2]=b;c[a+132>>2]=d;if((f|0)>-1)c[a+136>>2]=f;if((e|0)>-1)c[a+140>>2]=e;if((g|0)>-1)c[a+144>>2]=g;g=a+148|0;if((h|0)>-1){c[g>>2]=h;i=h}else i=c[g>>2]|0;g=da(d,b)|0;b=da((c[a+144>>2]|0)+(c[a+140>>2]|0)|0,(i|0)<1?1:i)|0;c[a+152>>2]=da(g,b+(c[a+136>>2]|0)|0)|0;return}function Cqc(b){b=b|0;var c=0;c=i;a[b+248>>0]=1;h[b+232>>3]=+Ype();i=c;return}function Dqc(b){b=b|0;var c=0,d=0.0,e=0;c=i;a[b+248>>0]=0;d=+Ype();e=b+240|0;g[e>>2]=ea(d-+h[b+232>>3]+ +ea(g[e>>2]));i=c;return}function Eqc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;e=a+24|0;f=b+24|0;h=e+80|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(h|0));j=a+4|0;k=b+4|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];g[a+244>>2]=ea(g[b+244>>2]);e=a+168|0;f=b+168|0;h=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(h|0));i=d;return}function Fqc(a,b){a=a|0;b=b|0;var d=0,e=0;d=a+104|0;e=b+104|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];g[a+240>>2]=ea(g[b+240>>2]);return}function Gqc(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0;l=i;i=i+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;c[p>>2]=c[b>>2];c[m+0>>2]=c[p+0>>2];p=xvd(j,k,m,d,o)|0;oxd(p,e);if(f){q=ea(g[p+44>>2]);r=ea(q*ea(g[p+32>>2]));q=ea(g[p+48>>2]);s=ea(q*ea(g[p+36>>2]));q=ea(g[p+52>>2]);t=ea(g[p+56>>2]);g[f>>2]=r;g[f+4>>2]=s;g[f+8>>2]=q;g[f+12>>2]=t}f=c[o>>2]|0;o=(f|0)==4;k=o^1;if(o|(f+-1|0)>>>0>1){i=l;return k|0}f=e-h|0;h=a+64|0;e=a+72|0;o=(c[e>>2]|0)+1|0;c[e>>2]=o;j=a+76|0;b=c[j>>2]|0;u=b&2147483647;if(o>>>0>u>>>0){v=b<<1;w=(v|0)==0?1:v;do if(u>>>0<w>>>0)if((b|0)>-1){c[j>>2]=w;v=c[h>>2]|0;c[n>>2]=c[a+68>>2];c[m+0>>2]=c[n+0>>2];c[h>>2]=hOb(v,w*12|0,4,m,0,3653512,370)|0;break}else{c[n>>2]=c[a+68>>2];c[m+0>>2]=c[n+0>>2];v=cOb(w*12|0,4,m,0,3653512,352)|0;YEi(v|0,c[h>>2]|0,(c[e>>2]|0)*12|0)|0;c[j>>2]=w;c[h>>2]=v;break}while(0);x=c[e>>2]|0}else x=o;o=x+-1|0;x=c[h>>2]|0;c[x+(o*12|0)>>2]=p;c[x+(o*12|0)+4>>2]=d;c[x+(o*12|0)+8>>2]=f;i=l;return k|0}function Hqc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(c>>>0>3)g=(HEi(b+(c+-3)|0,599648)|0)==0;else g=0;if(e)a[e>>0]=g&1;i=f;return (d|0)>1|g|0}function Iqc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;g=i;i=i+80|0;h=g+60|0;j=g+48|0;k=g+36|0;l=g+24|0;m=g+12|0;n=g;_ri(h,586152,d);rri(j,586160,6);d=(f|0)!=0;do if(d)if(!(a[f>>0]&1)){a[f+1>>0]=0;a[f>>0]=0;break}else{a[c[f+8>>2]>>0]=0;c[f+4>>2]=0;break}while(0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;o=e+1|0;p=h+1|0;q=e+8|0;r=h+4|0;s=h+8|0;t=e+4|0;u=j+1|0;v=j+8|0;w=j+4|0;x=k+1|0;y=l+1|0;z=l+8|0;A=l+4|0;B=m+1|0;C=m+8|0;D=m+4|0;E=k+8|0;F=k+4|0;G=0;a:while(1){H=a[e>>0]|0;I=(H&1)==0;J=(H&255)>>>1;H=a[h>>0]|0;K=(H&1)==0;L=(H&255)>>>1;H=c[q>>2]|0;M=c[r>>2]|0;N=c[s>>2]|0;O=c[t>>2]|0;if(I){P=G;while(1){Q=K?p:N;R=K?L:M;if(J>>>0<P>>>0|(J-P|0)>>>0<R>>>0){S=G;break a}if(!R)T=P;else{U=e+P+1|0;V=e+J+1|0;W=Q+R|0;if((V-U|0)<(R|0)){S=G;break a}X=1-R+J|0;R=e+X+1|0;if((X|0)==(P|0)){S=G;break a}X=a[Q>>0]|0;Y=U;b:while(1){if((a[Y>>0]|0)==X<<24>>24){U=Y;Z=Q;do{Z=Z+1|0;if((Z|0)==(W|0)){_=Y;break b}U=U+1|0}while((a[U>>0]|0)==(a[Z>>0]|0))}Y=Y+1|0;if((Y|0)==(R|0)){S=G;break a}}if((_|0)==(V|0)){S=G;break a}T=_-o|0}if((T|0)==-1){S=G;break a}R=(K?L:M)+T|0;Y=(a[e+R+1>>0]|0)+-9<<24>>24;if((Y&255)>=24){P=R;continue}if(!(8388639>>>(Y&255)&1))P=R;else{$=R;break}}}else{P=G;while(1){R=K?p:N;Y=K?L:M;if(O>>>0<P>>>0|(O-P|0)>>>0<Y>>>0){S=G;break a}if(!Y)aa=P;else{W=H+P|0;Q=H+O|0;X=R+Y|0;if((Q-W|0)<(Y|0)){S=G;break a}Z=1-Y+O|0;Y=H+Z|0;if((Z|0)==(P|0)){S=G;break a}Z=a[R>>0]|0;U=W;c:while(1){if((a[U>>0]|0)==Z<<24>>24){W=U;ba=R;do{ba=ba+1|0;if((ba|0)==(X|0)){ca=U;break c}W=W+1|0}while((a[W>>0]|0)==(a[ba>>0]|0))}U=U+1|0;if((U|0)==(Y|0)){S=G;break a}}if((ca|0)==(Q|0)){S=G;break a}aa=ca-H|0}if((aa|0)==-1){S=G;break a}Y=(K?L:M)+aa|0;U=(a[H+Y>>0]|0)+-9<<24>>24;if((U&255)>=24){P=Y;continue}if(!(8388639>>>(U&255)&1))P=Y;else{$=Y;break}}}P=a[j>>0]|0;M=(P&1)==0;L=(P&255)>>>1;P=c[v>>2]|0;K=c[w>>2]|0;N=$;Y=1;while(1){U=I?o:H;X=I?J:O;R=M?u:P;Z=M?L:K;d:do if(!(X>>>0<N>>>0|(X-N|0)>>>0<Z>>>0))if(Z){V=U+N|0;ba=U+X|0;W=R+Z|0;if((ba-V|0)>=(Z|0)?(da=1-Z+X|0,ea=U+da|0,(da|0)!=(N|0)):0){da=a[R>>0]|0;fa=V;e:while(1){if((a[fa>>0]|0)==da<<24>>24){V=fa;ga=R;do{ga=ga+1|0;if((ga|0)==(W|0)){ha=fa;break e}V=V+1|0}while((a[V>>0]|0)==(a[ga>>0]|0))}fa=fa+1|0;if((fa|0)==(ea|0)){ia=-1;break d}}if((ha|0)!=(ba|0))ia=ha-U|0;else ia=-1}else ia=-1}else ia=N;else ia=-1;while(0);U=I?o:H;R=I?J:O;f:do if((!(R>>>0<N>>>0|(R-N|0)>>>0<3)?(X=U+N|0,Z=U+R|0,(Z-X|0)>=3):0)?(Q=R+-2|0,ea=U+Q|0,(Q|0)!=(N|0)):0){Q=X;g:while(1){if((a[Q>>0]|0)==35){X=Q;fa=586168;do{fa=fa+1|0;if((fa|0)==586171){ja=Q;break g}X=X+1|0}while((a[X>>0]|0)==(a[fa>>0]|0))}Q=Q+1|0;if((Q|0)==(ea|0)){ka=-1;break f}}if((ja|0)!=(Z|0))ka=ja-U|0;else ka=-1}else ka=-1;while(0);if((ia|0)==-1){S=G;break a}U=(ka|0)!=-1&ka>>>0<ia>>>0;Y=(U?1:-1)+Y|0;R=(U?ka:ia)+1|0;if(!Y){la=R;break}else N=R}vri(k,e,$,la+~$|0,e);N=a[k>>0]|0;if(!(N&1)){ma=x;na=(N&255)>>>1}else{ma=c[E>>2]|0;na=c[F>>2]|0}Gri(b,ma,na)|0;xri(k);if(!d){G=la;continue}if(!G){N=a[h>>0]|0;if(!(N&1))oa=(N&255)>>>1;else oa=c[r>>2]|0;vri(l,e,0,$-oa|0,e);N=a[l>>0]|0;if(!(N&1)){pa=y;qa=(N&255)>>>1}else{pa=c[z>>2]|0;qa=c[A>>2]|0}Gri(f,pa,qa)|0;xri(l);G=la;continue}N=a[j>>0]|0;Y=(N&1)==0;if(Y)ra=(N&255)>>>1;else ra=c[w>>2]|0;O=a[h>>0]|0;if(!(O&1))sa=(O&255)>>>1;else sa=c[r>>2]|0;if(Y)ta=(N&255)>>>1;else ta=c[w>>2]|0;vri(m,e,ra+G|0,$-G-sa-ta|0,e);N=a[m>>0]|0;if(!(N&1)){ua=B;va=(N&255)>>>1}else{ua=c[C>>2]|0;va=c[D>>2]|0}Gri(f,ua,va)|0;xri(m);G=la}if(!d){xri(j);xri(h);i=g;return}d=a[b>>0]|0;if(!(d&1))wa=(d&255)>>>1;else wa=c[b+4>>2]|0;if(!wa)yri(f,e)|0;if(!S){xri(j);xri(h);i=g;return}wa=a[j>>0]|0;b=(wa&1)==0;if(b)xa=(wa&255)>>>1;else xa=c[w>>2]|0;d=a[e>>0]|0;if(!(d&1))ya=(d&255)>>>1;else ya=c[t>>2]|0;if((xa+S|0)>>>0>=ya>>>0){xri(j);xri(h);i=g;return}if(b)za=(wa&255)>>>1;else za=c[w>>2]|0;vri(n,e,za+S|0,-1,e);e=a[n>>0]|0;if(!(e&1)){Aa=n+1|0;Ba=(e&255)>>>1}else{Aa=c[n+8>>2]|0;Ba=c[n+4>>2]|0}Gri(f,Aa,Ba)|0;xri(n);xri(j);xri(h);i=g;return}function Jqc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+48|0;l=k+32|0;m=k+28|0;n=k+24|0;o=k+20|0;p=k;if((h|0)>-1)q=(c[b+60>>2]|0)+(h*28|0)+4|0;else q=b;c[l>>2]=-1;itd(l,g);g=c[l>>2]|0;c[o>>2]=g;c[p>>2]=g;c[p+4>>2]=d;c[p+8>>2]=1;c[p+12>>2]=e;a[p+16>>0]=1;a[p+17>>0]=f;a[p+18>>0]=0;brc(q,p);p=b+156|0;c[p>>2]=(c[p>>2]|0)+16;c[b+160>>2]=1;if(!j){i=k;return}b=c[o>>2]|0;if((b|0)!=-1&b>>>0>1073741823){i=k;return}p=c[j>>2]|0;q=c[j+4>>2]|0;f=q-p>>2;if(!f)r=p;else{e=p;p=f;while(1){f=(p|0)/2|0;if((c[e+(f<<2)>>2]|0)<(b|0)){s=e+(f+1<<2)|0;t=p+-1-f|0}else{s=e;t=f}if(!t){r=s;break}else{e=s;p=t}}}if((r|0)!=(q|0)?(b|0)>=(c[r>>2]|0):0){i=k;return}c[n>>2]=r;c[l+0>>2]=c[n+0>>2];drc(m,j,l,o);o=j+12|0;c[o>>2]=(c[o>>2]|0)+16;i=k;return}function Kqc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;l=i;i=i+48|0;m=l+32|0;n=l+28|0;o=l+24|0;p=l+20|0;q=l;r=(j|0)>-1;if(r){s=c[b+60>>2]|0;t=c[s+(j*28|0)+20>>2]<<16|c[s+(j*28|0)>>2]}else t=0;if(Rmc(b+72|0,f,d,g,h,t)|0){i=l;return}if(r)u=(c[b+60>>2]|0)+(j*28|0)+4|0;else u=b;c[m>>2]=-1;itd(m,f);f=c[m>>2]|0;c[p>>2]=f;c[q>>2]=f;c[q+4>>2]=d;c[q+8>>2]=1;c[q+12>>2]=e;a[q+16>>0]=g;a[q+17>>0]=h;a[q+18>>0]=1;brc(u,q);q=b+156|0;c[q>>2]=(c[q>>2]|0)+68;c[b+160>>2]=1;if(!k){i=l;return}b=c[p>>2]|0;if((b|0)!=-1&b>>>0>1073741823){i=l;return}q=c[k>>2]|0;u=c[k+4>>2]|0;h=u-q>>2;if(!h)v=q;else{g=q;q=h;while(1){h=(q|0)/2|0;if((c[g+(h<<2)>>2]|0)<(b|0)){w=g+(h+1<<2)|0;x=q+-1-h|0}else{w=g;x=h}if(!x){v=w;break}else{g=w;q=x}}}if((v|0)!=(u|0)?(b|0)>=(c[v>>2]|0):0){i=l;return}c[o>>2]=v;c[m+0>>2]=c[o+0>>2];drc(n,k,m,p);p=k+12|0;c[p>>2]=(c[p>>2]|0)+68;i=l;return}function Lqc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h;c[j>>2]=-1;itd(j,e);e=c[j>>2]|0;c[m>>2]=e;c[n>>2]=e;c[n+4>>2]=b;c[n+8>>2]=d;c[n+12>>2]=f;f=a+36|0;d=c[f>>2]|0;if((d|0)==(c[a+40>>2]|0))crc(a+32|0,n);else{if(!d)o=0;else{c[d+0>>2]=c[n+0>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];c[d+12>>2]=c[n+12>>2];o=c[f>>2]|0}c[f>>2]=o+16}o=a+156|0;c[o>>2]=(c[o>>2]|0)+12;c[a+160>>2]=1;if(!g){i=h;return}a=c[m>>2]|0;if((a|0)!=-1&a>>>0>1073741823){i=h;return}o=c[g>>2]|0;f=c[g+4>>2]|0;n=f-o>>2;if(!n)p=o;else{d=o;o=n;while(1){n=(o|0)/2|0;if((c[d+(n<<2)>>2]|0)<(a|0)){q=d+(n+1<<2)|0;r=o+-1-n|0}else{q=d;r=n}if(!r){p=q;break}else{d=q;o=r}}}if((p|0)!=(f|0)?(a|0)>=(c[p>>2]|0):0){i=h;return}c[l>>2]=p;c[j+0>>2]=c[l+0>>2];drc(k,g,j,m);m=g+12|0;c[m>>2]=(c[m>>2]|0)+12;i=h;return}function Mqc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=-1;itd(g,d);d=c[g>>2]|0;c[k>>2]=d;l=a+44|0;m=a+52|0;n=(c[m>>2]|0)+1|0;c[m>>2]=n;o=a+56|0;p=c[o>>2]|0;q=p&2147483647;if(n>>>0>q>>>0){r=p<<1;s=(r|0)==0?1:r;do if(q>>>0<s>>>0)if((p|0)>-1){c[o>>2]=s;r=c[l>>2]|0;c[h>>2]=c[a+48>>2];c[g+0>>2]=c[h+0>>2];c[l>>2]=hOb(r,s<<3,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[a+48>>2];c[g+0>>2]=c[h+0>>2];r=cOb(s<<3,4,g,0,3653512,352)|0;YEi(r|0,c[l>>2]|0,c[m>>2]<<3|0)|0;c[o>>2]=s;c[l>>2]=r;break}while(0);t=c[m>>2]|0}else t=n;n=(c[l>>2]|0)+(t+-1<<3)|0;c[n>>2]=d;c[n+4>>2]=b;b=a+156|0;c[b>>2]=(c[b>>2]|0)+4;if(!e){i=f;return}b=c[k>>2]|0;if((b|0)!=-1&b>>>0>1073741823){i=f;return}a=c[e>>2]|0;n=c[e+4>>2]|0;d=n-a>>2;if(!d)u=a;else{t=a;a=d;while(1){d=(a|0)/2|0;if((c[t+(d<<2)>>2]|0)<(b|0)){v=t+(d+1<<2)|0;w=a+-1-d|0}else{v=t;w=d}if(!w){u=v;break}else{t=v;a=w}}}if((u|0)!=(n|0)?(b|0)>=(c[u>>2]|0):0){i=f;return}c[j>>2]=u;c[g+0>>2]=c[j+0>>2];drc(h,e,g,k);k=e+12|0;c[k>>2]=(c[k>>2]|0)+4;i=f;return}function Nqc(a){a=a|0;var b=0;b=i;if((c[a+160>>2]|0)==1)Oqc(a);i=b;return a|0}function Oqc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;e=b+4|0;f=a+160|0;if((c[f>>2]|0)!=1){c[f>>2]=2;i=b;return}g=a+16|0;h=a+28|0;if((c[h>>2]|0)>-1){j=c[g>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[g>>2]=0}j=a+24|0;c[j>>2]=0;c[h>>2]=0;Sqc(a,a,-1);h=a+64|0;e=a+60|0;k=c[e>>2]|0;if((c[h>>2]|0)!=(k|0)){l=k;k=0;do{Sqc(a,l+(k*28|0)+4|0,k);k=k+1|0;l=c[e>>2]|0}while(k>>>0<(((c[h>>2]|0)-l|0)/28|0)>>>0)}l=c[g>>2]|0;erc(l,l+(c[j>>2]<<3)|0,d);c[f>>2]=2;i=b;return}function Pqc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a+32>>2]|0;g=c[a+36>>2]|0;if((f|0)==(g|0)){h=0;i=e;return h|0}a=c[b>>2]|0;b=f;while(1){if((c[b>>2]|0)==(a|0)?(c[b+12>>2]|0)==(d|0):0){h=b;j=6;break}b=b+16|0;if((b|0)==(g|0)){h=0;j=6;break}}if((j|0)==6){i=e;return h|0}return 0}function Qqc(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=c[d>>2]|0;d=c[a+16>>2]|0;j=c[a+24>>2]|0;k=d+(j<<3)|0;a:do if(!j)l=d;else{m=d;while(1){if((c[m>>2]|0)==(h|0)){l=m;break a}m=m+8|0;if((m|0)==(k|0)){n=0;break}}i=g;return n|0}while(0);if((l|0)==(k|0)){n=0;i=g;return n|0}k=b[l+4>>1]|0;if(k<<16>>16>-1)o=(c[a+60>>2]|0)+((k<<16>>16)*28|0)+4|0;else o=a;a=(c[o>>2]|0)+((e[l+6>>1]|0)*20|0)|0;if(!f){n=a;i=g;return n|0}c[f>>2]=k<<16>>16;n=a;i=g;return n|0}function Rqc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+32|0;l=k+20|0;m=k+16|0;n=k+12|0;o=k+8|0;p=k+4|0;q=k;if((c[b+160>>2]|0)==1)Oqc(b);r=frc(c[b>>2]|0,c[b+8>>2]|0,d,e,f,g,h)|0;f=b+64|0;s=b+60|0;t=c[s>>2]|0;if((c[f>>2]|0)==(t|0))u=r;else{v=r;r=t;t=0;while(1){w=frc(c[r+(t*28|0)+4>>2]|0,c[r+(t*28|0)+12>>2]|0,d,e,v,g,h)|0;t=t+1|0;r=c[s>>2]|0;if(t>>>0>=(((c[f>>2]|0)-r|0)/28|0)>>>0){u=w;break}else v=w}}v=c[b+36>>2]|0;r=c[b+32>>2]|0;f=r;if((r|0)==(v|0))x=u;else{if(!h){t=u;s=r;while(1){w=c[s>>2]|0;c[o>>2]=w;y=c[s+12>>2]|0;c[n>>2]=w;c[l+0>>2]=c[n+0>>2];oxd(xvd(d,e,l,y,m)|0,t);s=s+16|0;if((s|0)==(v|0))break;else t=t+12|0}}else{t=u;s=r;while(1){c[o>>2]=c[s>>2];if(!(Gqc(h,o,c[s+12>>2]|0,t,0,g,d,e)|0))a[j>>0]=1;s=s+16|0;if((s|0)==(v|0))break;else t=t+12|0}}x=u+((((v+-16-f|0)>>>4)*12|0)+12)|0}f=c[b+44>>2]|0;v=c[b+52>>2]|0;b=f+(v<<3)|0;if(!v){z=x;i=k;return z|0}u=g;g=h+56|0;t=h+60|0;s=h+48|0;j=h+52|0;if(!h){h=x;o=f;while(1){c[q>>2]=c[o>>2];c[l+0>>2]=c[q+0>>2];c[h>>2]=c[(Cvd(d,e,l,p)|0)>>2];o=o+8|0;if((o|0)==(b|0))break;else h=h+4|0}}else{h=x;o=f;while(1){c[q>>2]=c[o>>2];c[l+0>>2]=c[q+0>>2];f=Cvd(d,e,l,p)|0;r=c[p>>2]|0;if((r|0)==1|(r|0)==2|(r|0)==4){n=(r|0)==4?0:f;r=h-u|0;y=c[o>>2]|0;w=(c[g>>2]|0)+1|0;c[g>>2]=w;A=c[t>>2]|0;B=A&2147483647;if(w>>>0>B>>>0){C=A<<1;D=(C|0)==0?1:C;do if(B>>>0<D>>>0)if((A|0)>-1){c[t>>2]=D;C=c[s>>2]|0;c[m>>2]=c[j>>2];c[l+0>>2]=c[m+0>>2];c[s>>2]=hOb(C,D*12|0,4,l,0,3653512,370)|0;break}else{c[m>>2]=c[j>>2];c[l+0>>2]=c[m+0>>2];C=cOb(D*12|0,4,l,0,3653512,352)|0;YEi(C|0,c[s>>2]|0,(c[g>>2]|0)*12|0)|0;c[t>>2]=D;c[s>>2]=C;break}while(0);E=c[g>>2]|0}else E=w;D=E+-1|0;A=c[s>>2]|0;c[A+(D*12|0)>>2]=y;c[A+(D*12|0)+4>>2]=n;c[A+(D*12|0)+8>>2]=r}c[h>>2]=c[f>>2];o=o+8|0;if((o|0)==(b|0))break;else h=h+4|0}}z=x+((((v<<3)+-8|0)>>>1)+4)|0;i=k;return z|0}function Sqc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=e+4|0;h=c[b>>2]|0;j=b+8|0;grc(h,h+((c[j>>2]|0)*20|0)|0,f);h=c[j>>2]|0;if((h|0)<=0){i=e;return}j=a+24|0;k=a+28|0;l=a+16|0;m=a+20|0;a=d&65535;d=0;do{n=c[(c[b>>2]|0)+(d*20|0)>>2]|0;o=(c[j>>2]|0)+1|0;c[j>>2]=o;p=c[k>>2]|0;q=p&2147483647;if(o>>>0>q>>>0){r=p<<1;s=(r|0)==0?1:r;do if(q>>>0<s>>>0)if((p|0)>-1){c[k>>2]=s;r=c[l>>2]|0;c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];c[l>>2]=hOb(r,s<<3,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];r=cOb(s<<3,4,f,0,3653512,352)|0;YEi(r|0,c[l>>2]|0,c[j>>2]<<3|0)|0;c[k>>2]=s;c[l>>2]=r;break}while(0);t=c[j>>2]|0}else t=o;s=(c[l>>2]|0)+(t+-1<<3)|0;p=cFi(d|0,0,48)|0;q=s;c[q>>2]=p|n;c[q+4>>2]=H|a;d=d+1|0}while((d|0)!=(h|0));i=e;return}function Tqc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[(ync()|0)+5980>>2]|0;do if((d|0)!=4)if(IEi(a,586176,6)|0){if(!(IEi(a,586184,7)|0)){e=(d|0)!=11&1;break}if(!(IEi(a,586192,6)|0)){e=(d|0)!=8&1;break}if(((((((((((((((IEi(a,586200,6)|0)!=0?(IEi(a,586208,6)|0)!=0:0)?(IEi(a,586216,6)|0)!=0:0)?(IEi(a,586224,6)|0)!=0:0)?(IEi(a,586232,14)|0)!=0:0)?(IEi(a,586248,14)|0)!=0:0)?(IEi(a,586264,7)|0)!=0:0)?(IEi(a,586272,6)|0)!=0:0)?(IEi(a,586280,6)|0)!=0:0)?(IEi(a,586288,7)|0)!=0:0)?(IEi(a,586296,6)|0)!=0:0)?(IEi(a,586304,6)|0)!=0:0)?(IEi(a,586312,6)|0)!=0:0)?(IEi(a,586320,6)|0)!=0:0)?(IEi(a,586328,6)|0)!=0:0){if(!(IEi(a,586336,6)|0)){e=1;break}if(!(IEi(a,586344,6)|0)){e=1;break}if(!(IEi(a,586352,6)|0)){e=1;break}if(!(IEi(a,586360,10)|0)){e=1;break}if(!(IEi(a,586376,10)|0)){e=1;break}if(!(IEi(a,586392,11)|0)){e=1;break}if(!(IEi(a,586408,11)|0)){e=1;break}if(!(IEi(a,586424,10)|0)){e=1;break}if(!(IEi(a,586440,10)|0)){e=1;break}if(!(IEi(a,586456,6)|0)){e=1;break}if(!(IEi(a,586464,6)|0)){e=1;break}if(!(IEi(a,586472,6)|0)){e=1;break}if(!(IEi(a,586480,6)|0)){e=1;break}if(!(IEi(a,586488,6)|0)){e=1;break}if(!(IEi(a,586496,8)|0)){e=1;break}if(!(IEi(a,586512,8)|0)){e=1;break}if(!(IEi(a,586528,10)|0)){e=1;break}if(!(IEi(a,586544,14)|0)){e=1;break}if(!(IEi(a,586560,10)|0)){e=1;break}f=(IEi(a,586576,14)|0)==0&1;i=b;return f|0}else e=1}else e=1;else e=0;while(0);i=b;return e|0}function Uqc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;e=i;i=i+64|0;f=e;g=e+52|0;h=e+40|0;j=e+28|0;k=e+16|0;l=e+4|0;m=c[(Bnc()|0)+5980>>2]|0;n=a[b>>0]|0;o=(n&1)==0;if(o)p=b+1|0;else p=c[b+8>>2]|0;if(!(IEi(p,586176,6)|0)){q=0;i=e;return q|0}if(o)r=b+1|0;else r=c[b+8>>2]|0;if(!(IEi(r,586184,7)|0)){if((m|0)!=11){q=0;i=e;return q|0}r=xCi(32)|0;if(o)s=(n&255)>>>1;else s=c[b+4>>2]|0;vri(g,b,7,s+-7|0,b);zue(r,g,d);xri(g);q=r;i=e;return q|0}if(o)t=b+1|0;else t=c[b+8>>2]|0;if(!(IEi(t,586192,6)|0)){if((m|0)!=8){q=0;i=e;return q|0}m=xCi(32)|0;if(o)u=(n&255)>>>1;else u=c[b+4>>2]|0;vri(h,b,6,u+-6|0,b);zue(m,h,d);xri(h);q=m;i=e;return q|0}if(o)v=b+1|0;else v=c[b+8>>2]|0;if(!(IEi(v,586200,6)|0)){q=0;i=e;return q|0}if(o)w=b+1|0;else w=c[b+8>>2]|0;if(!(IEi(w,586208,6)|0)){q=0;i=e;return q|0}if(o)x=b+1|0;else x=c[b+8>>2]|0;if(!(IEi(x,586216,6)|0)){q=0;i=e;return q|0}if(o)y=b+1|0;else y=c[b+8>>2]|0;if(!(IEi(y,586224,6)|0)){q=0;i=e;return q|0}if(o)z=b+1|0;else z=c[b+8>>2]|0;if(!(IEi(z,586232,14)|0)){q=0;i=e;return q|0}if(o)A=b+1|0;else A=c[b+8>>2]|0;if(!(IEi(A,586248,14)|0)){q=0;i=e;return q|0}if(o)B=b+1|0;else B=c[b+8>>2]|0;if(!(IEi(B,586264,7)|0)){q=0;i=e;return q|0}if(o)C=b+1|0;else C=c[b+8>>2]|0;if(!(IEi(C,586272,6)|0)){q=0;i=e;return q|0}if(o)D=b+1|0;else D=c[b+8>>2]|0;if(!(IEi(D,586280,6)|0)){q=0;i=e;return q|0}if(o)E=b+1|0;else E=c[b+8>>2]|0;if(!(IEi(E,586288,7)|0)){q=0;i=e;return q|0}if(o)F=b+1|0;else F=c[b+8>>2]|0;if(!(IEi(F,586296,6)|0)){q=0;i=e;return q|0}if(o)G=b+1|0;else G=c[b+8>>2]|0;if(!(IEi(G,586304,6)|0)){q=0;i=e;return q|0}if(o)H=b+1|0;else H=c[b+8>>2]|0;if(!(IEi(H,586312,6)|0)){q=0;i=e;return q|0}if(o)I=b+1|0;else I=c[b+8>>2]|0;if(!(IEi(I,586320,6)|0)){q=0;i=e;return q|0}if(o)J=b+1|0;else J=c[b+8>>2]|0;if(!(IEi(J,586328,6)|0)){q=0;i=e;return q|0}if(o)K=b+1|0;else K=c[b+8>>2]|0;if(!(IEi(K,586336,6)|0)){q=0;i=e;return q|0}if(o)L=b+1|0;else L=c[b+8>>2]|0;if(!(IEi(L,586344,6)|0)){q=0;i=e;return q|0}if(o)M=b+1|0;else M=c[b+8>>2]|0;if(!(IEi(M,586352,6)|0)){q=0;i=e;return q|0}if(o)N=b+1|0;else N=c[b+8>>2]|0;if(!(IEi(N,586360,10)|0)){q=0;i=e;return q|0}if(o)O=b+1|0;else O=c[b+8>>2]|0;if(!(IEi(O,586376,10)|0)){q=0;i=e;return q|0}if(o)P=b+1|0;else P=c[b+8>>2]|0;if(!(IEi(P,586592,7)|0)){q=0;i=e;return q|0}if(o)Q=b+1|0;else Q=c[b+8>>2]|0;if(!(IEi(Q,586600,7)|0)){q=0;i=e;return q|0}if(o)R=b+1|0;else R=c[b+8>>2]|0;if(!(IEi(R,586392,11)|0)){q=0;i=e;return q|0}if(o)S=b+1|0;else S=c[b+8>>2]|0;if(!(IEi(S,586408,11)|0)){q=0;i=e;return q|0}if(o)T=b+1|0;else T=c[b+8>>2]|0;if(!(IEi(T,586424,10)|0)){q=0;i=e;return q|0}if(o)U=b+1|0;else U=c[b+8>>2]|0;if(!(IEi(U,586440,10)|0)){q=0;i=e;return q|0}if(o)V=b+1|0;else V=c[b+8>>2]|0;if(!(IEi(V,586456,6)|0)){q=0;i=e;return q|0}if(o)W=b+1|0;else W=c[b+8>>2]|0;if(!(IEi(W,586464,6)|0)){q=0;i=e;return q|0}if(o)X=b+1|0;else X=c[b+8>>2]|0;if(!(IEi(X,586472,6)|0)){q=0;i=e;return q|0}if(o)Y=b+1|0;else Y=c[b+8>>2]|0;if(!(IEi(Y,586480,6)|0)){q=0;i=e;return q|0}if(o)Z=b+1|0;else Z=c[b+8>>2]|0;if(!(IEi(Z,586488,6)|0)){q=0;i=e;return q|0}if(o)_=b+1|0;else _=c[b+8>>2]|0;if(!(IEi(_,586496,8)|0)){q=0;i=e;return q|0}if(o)$=b+1|0;else $=c[b+8>>2]|0;if(!(IEi($,586512,8)|0)){q=0;i=e;return q|0}if(!(Ori(b,586608)|0)){Ird(586616,f);q=0;i=e;return q|0}$=a[b>>0]|0;o=($&1)==0;if(o)aa=($&255)>>>1;else aa=c[b+4>>2]|0;if(!aa){Lsd(j,586672,f);if(!(a[j>>0]&1))ba=j+1|0;else ba=c[j+8>>2]|0;Krd(ba,0,3653512,642,512,0,0,0);xri(j);q=0;i=e;return q|0}if(o)ca=($&255)>>>1;else ca=c[b+4>>2]|0;do if(ca>>>0<10)if(o){da=($&255)>>>1;break}else{da=c[b+4>>2]|0;break}else da=10;while(0);vri(l,b,0,da,b);if(!(a[l>>0]&1))ea=l+1|0;else ea=c[l+8>>2]|0;c[f>>2]=ea;Lsd(k,586720,f);if(!(a[k>>0]&1))fa=k+1|0;else fa=c[k+8>>2]|0;Krd(fa,0,3653512,648,512,0,0,0);xri(k);xri(l);q=0;i=e;return q|0}function Vqc(b){b=b|0;c[b>>2]=586856;c[b+4>>2]=-1;c[b+12>>2]=0;a[b+8>>0]=0;a[b+9>>0]=0;return}function Wqc(a){a=a|0;return}function Xqc(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Yqc(b){b=b|0;return (a[b+8>>0]|0)==0|0}function Zqc(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;c[a+12>>2]=0;return}function _qc(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if(d){hrc(d);ACi(d)}d=c[a+4>>2]|0;if(!d){i=b;return}ACi(d);i=b;return}function $qc(a){a=a|0;var d=0,e=0,f=0;d=i;e=xCi(164)|0;c[e>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+4>>2]=60;c[e+16>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;c[e+20>>2]=60;f=e+32|0;c[e+52>>2]=0;c[e+56>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[e+48>>2]=60;c[e+60>>2]=0;c[e+64>>2]=0;c[e+68>>2]=0;c[e+72>>2]=-1;b[e+76>>1]=0;b[e+78>>1]=0;c[e+80>>2]=0;c[e+84>>2]=-1;b[e+88>>1]=0;b[e+90>>1]=0;c[e+92>>2]=0;c[e+96>>2]=-1;b[e+100>>1]=0;b[e+102>>1]=0;c[e+104>>2]=0;c[e+108>>2]=-1;b[e+112>>1]=0;b[e+114>>1]=0;c[e+116>>2]=0;c[e+120>>2]=-1;b[e+124>>1]=0;b[e+126>>1]=0;c[e+128>>2]=0;c[e+132>>2]=-1;b[e+136>>1]=0;b[e+138>>1]=0;c[e+140>>2]=0;c[e+144>>2]=-1;f=e+148|0;b[f+0>>1]=0;b[f+2>>1]=0;b[f+4>>1]=0;b[f+6>>1]=0;b[f+8>>1]=0;b[f+10>>1]=0;b[f+12>>1]=0;b[f+14>>1]=0;c[a>>2]=e;i=d;return e|0}function arc(a){a=a|0;var b=0,d=0;b=i;d=xCi(36)|0;hnc(d);c[a+4>>2]=d;i=b;return d|0}function brc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+4|0;h=f;j=d+8|0;k=(c[j>>2]|0)+1|0;c[j>>2]=k;l=d+12|0;m=c[l>>2]|0;n=m&2147483647;if(k>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[l>>2]=p;o=c[d>>2]|0;c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];c[d>>2]=hOb(o,p*20|0,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];o=cOb(p*20|0,4,g,0,3653512,352)|0;YEi(o|0,c[d>>2]|0,(c[j>>2]|0)*20|0)|0;c[l>>2]=p;c[d>>2]=o;break}while(0);q=c[j>>2]|0}else q=k;k=(c[d>>2]|0)+((q+-1|0)*20|0)|0;c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];b[k+16>>1]=b[e+16>>1]|0;a[k+18>>0]=a[e+18>>0]|0;i=f;return}function crc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>4)+1|0;if(g>>>0>268435455)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>4>>>0<134217727){l=k>>3;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>4;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=268435455;r=l>>4;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<4)|0;o=r;p=s}s=n+(o<<4)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2]}YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<4);c[h>>2]=n+(m<<4);if(!f){i=d;return}ACi(f);i=d;return}function drc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;g=c[b>>2]|0;h=g;j=(c[d>>2]|0)-h>>2;d=g+(j<<2)|0;k=b+4|0;l=c[k>>2]|0;m=b+8|0;n=c[m>>2]|0;if(l>>>0<n>>>0){if((d|0)==(l|0)){if(d)c[d>>2]=c[e>>2];c[k>>2]=g+(j+1<<2);o=d;c[a>>2]=o;i=f;return}p=l-(g+(j+1<<2))|0;q=p>>2;r=g+(q+j<<2)|0;if(r>>>0<l>>>0){j=0-q|0;s=(l+(j<<2)+~d|0)>>>2;t=l;u=r;while(1){if(t)c[t>>2]=c[u>>2];u=u+4|0;if(u>>>0>=l>>>0)break;else t=t+4|0}c[k>>2]=l+(s+1<<2);v=j}else v=0-q|0;aFi(l+(v<<2)|0,d|0,p|0)|0;if(d>>>0>e>>>0)w=e;else w=(c[k>>2]|0)>>>0>e>>>0?e+4|0:e;c[d>>2]=c[w>>2];o=d;c[a>>2]=o;i=f;return}w=(l-h>>2)+1|0;if(w>>>0>1073741823)vxi(b);h=g;g=n-h|0;if(g>>2>>>0<536870911){n=g>>1;g=n>>>0<w>>>0?w:n;n=d;w=n-h>>2;if(!g){x=0;y=0;z=w;A=n}else{B=g;C=w;D=n;E=21}}else{n=d;B=1073741823;C=n-h>>2;D=n;E=21}if((E|0)==21){x=B;y=xCi(B<<2)|0;z=C;A=D}D=y+(z<<2)|0;C=y+(x<<2)|0;do if((z|0)==(x|0)){if((z|0)>0){F=y+(((z+1|0)/-2|0)+z<<2)|0;G=C;break}B=(z|0)==0?1:z<<1;E=xCi(B<<2)|0;n=E+(B>>>2<<2)|0;h=E+(B<<2)|0;if(!y){F=n;G=h}else{ACi(y);F=n;G=h}}else{F=D;G=C}while(0);if(F)c[F>>2]=c[e>>2];e=c[b>>2]|0;C=A-e|0;D=F+(0-(C>>2)<<2)|0;YEi(D|0,e|0,C|0)|0;C=(c[k>>2]|0)-A|0;YEi(F+4|0,d|0,C|0)|0;c[b>>2]=D;c[k>>2]=F+((C>>2)+1<<2);c[m>>2]=G;if(!e){o=F;c[a>>2]=o;i=f;return}ACi(e);o=F;c[a>>2]=o;i=f;return}function erc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-8|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>3;switch(l|0){case 5:{m=h;n=g;o=g;p=15;break a;break}case 2:{q=h;r=g;s=g;p=4;break a;break}case 4:{t=h;u=g;p=14;break a;break}case 3:{v=h;w=g;x=g;p=6;break a;break}case 1:case 0:{p=85;break a;break}default:{}}if((k|0)<248){y=h;z=a;p=21;break a}A=(l|0)/2|0;B=h+(A<<3)|0;do if((k|0)>7992){C=(l|0)/4|0;D=h+(C<<3)|0;E=h+(C+A<<3)|0;C=irc(h,D,B,E,d)|0;if((c[g>>2]|0)>=(c[E>>2]|0)){F=B;G=C;break}H=E;I=c[H>>2]|0;J=c[H+4>>2]|0;H=g;K=c[H+4>>2]|0;L=E;c[L>>2]=c[H>>2];c[L+4>>2]=K;K=g;c[K>>2]=I;c[K+4>>2]=J;J=C+1|0;if((c[E>>2]|0)<(c[B>>2]|0)){K=B;I=c[K>>2]|0;L=c[K+4>>2]|0;K=E;H=c[K+4>>2]|0;M=B;c[M>>2]=c[K>>2];c[M+4>>2]=H;H=E;c[H>>2]=I;c[H+4>>2]=L;L=C+2|0;if((c[B>>2]|0)<(c[D>>2]|0)){H=D;I=c[H>>2]|0;E=c[H+4>>2]|0;H=B;M=c[H+4>>2]|0;K=D;c[K>>2]=c[H>>2];c[K+4>>2]=M;M=B;c[M>>2]=I;c[M+4>>2]=E;if((c[D>>2]|0)<(c[h>>2]|0)){E=h;M=c[E>>2]|0;I=c[E+4>>2]|0;E=D;K=c[E+4>>2]|0;H=h;c[H>>2]=c[E>>2];c[H+4>>2]=K;K=D;c[K>>2]=M;c[K+4>>2]=I;F=B;G=C+4|0}else{F=B;G=C+3|0}}else{F=B;G=L}}else{F=B;G=J}}else{J=c[B>>2]|0;L=(c[g>>2]|0)<(J|0);if((J|0)>=(c[h>>2]|0)){if(!L){F=B;G=0;break}J=B;C=c[J>>2]|0;I=c[J+4>>2]|0;J=g;K=c[J+4>>2]|0;M=B;c[M>>2]=c[J>>2];c[M+4>>2]=K;K=g;c[K>>2]=C;c[K+4>>2]=I;if((c[B>>2]|0)>=(c[h>>2]|0)){F=B;G=1;break}I=h;K=c[I>>2]|0;C=c[I+4>>2]|0;I=B;M=c[I+4>>2]|0;J=h;c[J>>2]=c[I>>2];c[J+4>>2]=M;M=B;c[M>>2]=K;c[M+4>>2]=C;F=B;G=2;break}C=h;M=c[C>>2]|0;K=c[C+4>>2]|0;if(L){L=g;C=c[L+4>>2]|0;J=h;c[J>>2]=c[L>>2];c[J+4>>2]=C;C=g;c[C>>2]=M;c[C+4>>2]=K;F=B;G=1;break}C=B;J=c[C+4>>2]|0;L=h;c[L>>2]=c[C>>2];c[L+4>>2]=J;J=B;c[J>>2]=M;c[J+4>>2]=K;if((c[g>>2]|0)<(M|0)){J=g;L=c[J+4>>2]|0;C=B;c[C>>2]=c[J>>2];c[C+4>>2]=L;L=g;c[L>>2]=M;c[L+4>>2]=K;F=B;G=2}else{F=B;G=1}}while(0);A=c[h>>2]|0;l=c[F>>2]|0;do if((A|0)<(l|0)){N=g;O=G}else{k=a;K=g;while(1){L=k+-16|0;if((h|0)==(L|0))break;if((c[L>>2]|0)<(l|0)){P=L;p=67;break}else{M=K;K=L;k=M}}if((p|0)==67){p=0;k=h;K=c[k>>2]|0;M=c[k+4>>2]|0;k=P;L=c[k+4>>2]|0;C=h;c[C>>2]=c[k>>2];c[C+4>>2]=L;L=P;c[L>>2]=K;c[L+4>>2]=M;N=P;O=G+1|0;break}M=h+8|0;if((A|0)<(c[g>>2]|0))Q=M;else{if((M|0)==(g|0)){p=85;break a}else{R=h;S=M}while(1){M=R+16|0;if((A|0)<(c[S>>2]|0)){T=S;break}if((M|0)==(g|0)){p=85;break a}else{L=S;S=M;R=L}}L=T;M=c[L>>2]|0;K=c[L+4>>2]|0;L=g;C=c[L+4>>2]|0;k=T;c[k>>2]=c[L>>2];c[k+4>>2]=C;C=g;c[C>>2]=M;c[C+4>>2]=K;Q=T+8|0}if((Q|0)==(g|0)){p=85;break a}else{U=Q;V=g}while(1){K=c[h>>2]|0;C=U;while(1){M=C+8|0;if((K|0)<(c[C>>2]|0)){W=M;X=C;break}else C=M}C=V;while(1){M=C+-8|0;if((K|0)<(c[M>>2]|0))C=M;else{Y=M;break}}if(X>>>0>=Y>>>0){h=X;continue b}C=X;K=c[C>>2]|0;M=c[C+4>>2]|0;C=Y;k=c[C+4>>2]|0;L=X;c[L>>2]=c[C>>2];c[L+4>>2]=k;k=Y;c[k>>2]=K;c[k+4>>2]=M;U=W;V=Y}}while(0);A=h+8|0;c:do if(A>>>0<N>>>0){l=A;M=N;k=B;K=O;while(1){L=c[k>>2]|0;C=l;while(1){J=C+8|0;if((c[C>>2]|0)<(L|0))C=J;else{Z=J;_=C;break}}C=M;while(1){J=C+-8|0;if((c[J>>2]|0)<(L|0)){$=J;break}else C=J}if(_>>>0>$>>>0){aa=_;ba=k;ca=K;break c}C=_;L=c[C>>2]|0;J=c[C+4>>2]|0;C=$;I=c[C+4>>2]|0;D=_;c[D>>2]=c[C>>2];c[D+4>>2]=I;I=$;c[I>>2]=L;c[I+4>>2]=J;l=Z;M=$;k=(k|0)==(_|0)?$:k;K=K+1|0}}else{aa=A;ba=B;ca=O}while(0);if((aa|0)!=(ba|0)?(c[ba>>2]|0)<(c[aa>>2]|0):0){B=aa;A=c[B>>2]|0;K=c[B+4>>2]|0;B=ba;k=c[B+4>>2]|0;M=aa;c[M>>2]=c[B>>2];c[M+4>>2]=k;k=ba;c[k>>2]=A;c[k+4>>2]=K;da=ca+1|0}else da=ca;if(!da){ea=jrc(h,aa,d)|0;K=aa+8|0;if(jrc(K,a,d)|0){p=80;break}if(ea){h=K;continue}}K=aa;if((K-j|0)>=(b-K|0)){fa=h;ga=aa;p=84;break}erc(h,aa,d);h=aa+8|0}if((p|0)==80){p=0;if(ea){p=85;break}else{f=h;a=aa;continue}}else if((p|0)==84){p=0;erc(ga+8|0,a,d);f=fa;a=ga;continue}}if((p|0)==4){if((c[r>>2]|0)>=(c[q>>2]|0)){i=e;return}r=q;ga=c[r>>2]|0;a=c[r+4>>2]|0;r=s;fa=c[r+4>>2]|0;f=q;c[f>>2]=c[r>>2];c[f+4>>2]=fa;fa=s;c[fa>>2]=ga;c[fa+4>>2]=a;i=e;return}else if((p|0)==6){a=v+8|0;fa=c[a>>2]|0;ga=(c[w>>2]|0)<(fa|0);if((fa|0)>=(c[v>>2]|0)){if(!ga){i=e;return}fa=a;s=c[fa>>2]|0;f=c[fa+4>>2]|0;fa=x;r=c[fa+4>>2]|0;q=a;c[q>>2]=c[fa>>2];c[q+4>>2]=r;r=x;c[r>>2]=s;c[r+4>>2]=f;if((c[a>>2]|0)>=(c[v>>2]|0)){i=e;return}f=v;r=c[f>>2]|0;s=c[f+4>>2]|0;f=a;q=c[f+4>>2]|0;fa=v;c[fa>>2]=c[f>>2];c[fa+4>>2]=q;q=a;c[q>>2]=r;c[q+4>>2]=s;i=e;return}s=v;q=c[s>>2]|0;r=c[s+4>>2]|0;if(ga){ga=x;s=c[ga+4>>2]|0;fa=v;c[fa>>2]=c[ga>>2];c[fa+4>>2]=s;s=x;c[s>>2]=q;c[s+4>>2]=r;i=e;return}s=a;fa=c[s+4>>2]|0;ga=v;c[ga>>2]=c[s>>2];c[ga+4>>2]=fa;fa=a;c[fa>>2]=q;c[fa+4>>2]=r;if((c[w>>2]|0)>=(q|0)){i=e;return}w=x;fa=c[w+4>>2]|0;ga=a;c[ga>>2]=c[w>>2];c[ga+4>>2]=fa;fa=x;c[fa>>2]=q;c[fa+4>>2]=r;i=e;return}else if((p|0)==14){irc(t,t+8|0,t+16|0,u,d)|0;i=e;return}else if((p|0)==15){u=m+8|0;t=m+16|0;r=m+24|0;irc(m,u,t,r,d)|0;if((c[n>>2]|0)>=(c[r>>2]|0)){i=e;return}n=r;d=c[n>>2]|0;fa=c[n+4>>2]|0;n=o;q=c[n+4>>2]|0;x=r;c[x>>2]=c[n>>2];c[x+4>>2]=q;q=o;c[q>>2]=d;c[q+4>>2]=fa;if((c[r>>2]|0)>=(c[t>>2]|0)){i=e;return}fa=t;q=c[fa>>2]|0;d=c[fa+4>>2]|0;fa=r;o=c[fa>>2]|0;x=c[fa+4>>2]|0;fa=t;c[fa>>2]=o;c[fa+4>>2]=x;fa=r;c[fa>>2]=q;c[fa+4>>2]=d;if((o|0)>=(c[u>>2]|0)){i=e;return}d=u;fa=c[d>>2]|0;q=c[d+4>>2]|0;d=u;c[d>>2]=o;c[d+4>>2]=x;d=t;c[d>>2]=fa;c[d+4>>2]=q;if((o|0)>=(c[m>>2]|0)){i=e;return}q=m;d=c[q>>2]|0;fa=c[q+4>>2]|0;q=m;c[q>>2]=o;c[q+4>>2]=x;x=u;c[x>>2]=d;c[x+4>>2]=fa;i=e;return}else if((p|0)==21){fa=y+16|0;x=y+8|0;d=c[x>>2]|0;u=c[y>>2]|0;q=c[fa>>2]|0;o=(q|0)<(d|0);do if((d|0)<(u|0)){m=y;t=c[m>>2]|0;r=c[m+4>>2]|0;if(o){m=fa;n=c[m+4>>2]|0;ga=y;c[ga>>2]=c[m>>2];c[ga+4>>2]=n;n=fa;c[n>>2]=t;c[n+4>>2]=r;ha=t;break}n=x;ga=c[n+4>>2]|0;m=y;c[m>>2]=c[n>>2];c[m+4>>2]=ga;ga=x;c[ga>>2]=t;c[ga+4>>2]=r;if((q|0)<(t|0)){ga=fa;m=c[ga+4>>2]|0;n=x;c[n>>2]=c[ga>>2];c[n+4>>2]=m;m=fa;c[m>>2]=t;c[m+4>>2]=r;ha=t}else ha=q}else if(o){t=x;r=c[t>>2]|0;m=c[t+4>>2]|0;t=fa;n=c[t>>2]|0;ga=c[t+4>>2]|0;t=x;c[t>>2]=n;c[t+4>>2]=ga;t=fa;c[t>>2]=r;c[t+4>>2]=m;if((n|0)<(u|0)){m=y;t=c[m>>2]|0;w=c[m+4>>2]|0;m=y;c[m>>2]=n;c[m+4>>2]=ga;ga=x;c[ga>>2]=t;c[ga+4>>2]=w;ha=r}else ha=r}else ha=q;while(0);q=y+24|0;if((q|0)==(z|0)){i=e;return}else{ia=ha;ja=q;ka=fa}while(1){if((c[ja>>2]|0)<(ia|0)){fa=ja;q=c[fa>>2]|0;ha=c[fa+4>>2]|0;fa=ja;x=ka;while(1){u=x;o=c[u+4>>2]|0;d=fa;c[d>>2]=c[u>>2];c[d+4>>2]=o;if((x|0)==(y|0)){la=x;break}o=x+-8|0;if((q|0)<(c[o>>2]|0)){d=x;x=o;fa=d}else{la=x;break}}x=la;c[x>>2]=q;c[x+4>>2]=ha}x=ja+8|0;if((x|0)==(z|0))break;fa=ja;ia=c[ja>>2]|0;ja=x;ka=fa}i=e;return}else if((p|0)==85){i=e;return}}function frc(b,d,e,f,h,j,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;m=i;i=i+32|0;n=m+20|0;o=m+16|0;p=m+12|0;q=m+8|0;r=m+4|0;s=m;t=b+(d*20|0)|0;if(!d){u=h;i=m;return u|0}d=(l|0)==0;v=j;j=l+8|0;w=l+12|0;x=l+4|0;y=l+24|0;z=l+28|0;A=l+16|0;B=l+20|0;C=l+40|0;D=l+44|0;E=l+32|0;F=l+36|0;G=h;h=b;while(1){b=c[h>>2]|0;do if((a[h+18>>0]|0)==0?(c[h+8>>2]|0)<2:0)if((a[h+17>>0]|0)==1){c[q>>2]=b;c[n+0>>2]=c[q+0>>2];H=zvd(e,f,n,p)|0;if(!d?(I=c[p>>2]|0,(I|0)==1|(I|0)==2|(I|0)==4):0){J=(I|0)==4?0:H;I=G-v|0;K=(c[j>>2]|0)+1|0;c[j>>2]=K;L=c[w>>2]|0;M=L&2147483647;if(K>>>0>M>>>0){N=L<<1;O=(N|0)==0?1:N;do if(M>>>0<O>>>0)if((L|0)>-1){c[w>>2]=O;N=c[l>>2]|0;c[o>>2]=c[x>>2];c[n+0>>2]=c[o+0>>2];c[l>>2]=hOb(N,O*12|0,4,n,0,3653512,370)|0;break}else{c[o>>2]=c[x>>2];c[n+0>>2]=c[o+0>>2];N=cOb(O*12|0,4,n,0,3653512,352)|0;YEi(N|0,c[l>>2]|0,(c[j>>2]|0)*12|0)|0;c[w>>2]=O;c[l>>2]=N;break}while(0);P=c[j>>2]|0}else P=K;O=P+-1|0;L=c[l>>2]|0;c[L+(O*12|0)>>2]=b;c[L+(O*12|0)+4>>2]=J;c[L+(O*12|0)+8>>2]=I}Q=ea(g[H>>2]);g[k>>2]=Q;a[G>>0]=a[k>>0];a[G+1>>0]=a[k+1>>0];a[G+2>>0]=a[k+2>>0];a[G+3>>0]=a[k+3>>0];O=G+4|0;g[k>>2]=ea(0.0);a[O>>0]=a[k>>0];a[O+1>>0]=a[k+1>>0];a[O+2>>0]=a[k+2>>0];a[O+3>>0]=a[k+3>>0];O=G+8|0;g[k>>2]=ea(0.0);a[O>>0]=a[k>>0];a[O+1>>0]=a[k+1>>0];a[O+2>>0]=a[k+2>>0];a[O+3>>0]=a[k+3>>0];O=G+12|0;g[k>>2]=ea(0.0);a[O>>0]=a[k>>0];a[O+1>>0]=a[k+1>>0];a[O+2>>0]=a[k+2>>0];a[O+3>>0]=a[k+3>>0];R=G+16|0;break}else{c[r>>2]=b;c[n+0>>2]=c[r+0>>2];O=Avd(e,f,n,p)|0;if(!d?(L=c[p>>2]|0,(L|0)==1|(L|0)==2|(L|0)==4):0){M=(L|0)==4?0:O;L=G-v|0;N=(c[y>>2]|0)+1|0;c[y>>2]=N;S=c[z>>2]|0;T=S&2147483647;if(N>>>0>T>>>0){U=S<<1;V=(U|0)==0?1:U;do if(T>>>0<V>>>0)if((S|0)>-1){c[z>>2]=V;U=c[A>>2]|0;c[o>>2]=c[B>>2];c[n+0>>2]=c[o+0>>2];c[A>>2]=hOb(U,V*12|0,4,n,0,3653512,370)|0;break}else{c[o>>2]=c[B>>2];c[n+0>>2]=c[o+0>>2];U=cOb(V*12|0,4,n,0,3653512,352)|0;YEi(U|0,c[A>>2]|0,(c[y>>2]|0)*12|0)|0;c[z>>2]=V;c[A>>2]=U;break}while(0);W=c[y>>2]|0}else W=N;V=W+-1|0;S=c[A>>2]|0;c[S+(V*12|0)>>2]=b;c[S+(V*12|0)+4>>2]=M;c[S+(V*12|0)+8>>2]=L}X=G+0|0;Y=O+0|0;Z=X+16|0;do{a[X>>0]=a[Y>>0]|0;X=X+1|0;Y=Y+1|0}while((X|0)<(Z|0));R=G+16|0;break}else{c[s>>2]=b;c[n+0>>2]=c[s+0>>2];O=Bvd(e,f,n,p)|0;c[G>>2]=16;L=G+4|0;if(!d?(M=c[p>>2]|0,(M|0)==1|(M|0)==2|(M|0)==4):0){N=(M|0)==4?0:O;M=L-v|0;V=(c[C>>2]|0)+1|0;c[C>>2]=V;S=c[D>>2]|0;T=S&2147483647;if(V>>>0>T>>>0){H=S<<1;I=(H|0)==0?1:H;do if(T>>>0<I>>>0)if((S|0)>-1){c[D>>2]=I;H=c[E>>2]|0;c[o>>2]=c[F>>2];c[n+0>>2]=c[o+0>>2];c[E>>2]=hOb(H,I*12|0,4,n,0,3653512,370)|0;break}else{c[o>>2]=c[F>>2];c[n+0>>2]=c[o+0>>2];H=cOb(I*12|0,4,n,0,3653512,352)|0;YEi(H|0,c[E>>2]|0,(c[C>>2]|0)*12|0)|0;c[D>>2]=I;c[E>>2]=H;break}while(0);_=c[C>>2]|0}else _=V;I=_+-1|0;S=c[E>>2]|0;c[S+(I*12|0)>>2]=b;c[S+(I*12|0)+4>>2]=N;c[S+(I*12|0)+8>>2]=M}X=L+0|0;Y=O+0|0;Z=X+64|0;do{a[X>>0]=a[Y>>0]|0;X=X+1|0;Y=Y+1|0}while((X|0)<(Z|0));R=G+68|0}while(0);h=h+20|0;if((h|0)==(t|0)){u=R;break}else G=R}i=m;return u|0}function grc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=i;i=i+48|0;h=g+16|0;j=g;k=d;d=e;a:while(1){e=d;l=d+-20|0;m=k;b:while(1){n=m;o=e-n|0;switch((o|0)/20|0|0){case 2:{p=m;q=l;r=l;s=4;break a;break}case 5:{t=m;u=l;v=l;s=15;break a;break}case 3:{w=m;x=l;y=l;s=6;break a;break}case 4:{z=m;A=l;s=14;break a;break}case 1:case 0:{s=84;break a;break}default:{}}if((o|0)<620){B=m;C=d;s=21;break a}D=(o|0)/40|0;E=m+(D*20|0)|0;do if((o|0)>19980){F=(o|0)/80|0;G=m+(F*20|0)|0;H=m+((F+D|0)*20|0)|0;F=krc(m,G,E,H,f)|0;if((c[l>>2]|0)>=(c[H>>2]|0)){I=E;J=F;break};c[h+0>>2]=c[H+0>>2];c[h+4>>2]=c[H+4>>2];c[h+8>>2]=c[H+8>>2];c[h+12>>2]=c[H+12>>2];c[h+16>>2]=c[H+16>>2];c[H+0>>2]=c[l+0>>2];c[H+4>>2]=c[l+4>>2];c[H+8>>2]=c[l+8>>2];c[H+12>>2]=c[l+12>>2];b[H+16>>1]=b[l+16>>1]|0;a[H+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;K=F+1|0;if((c[H>>2]|0)<(c[E>>2]|0)){c[h+0>>2]=c[E+0>>2];c[h+4>>2]=c[E+4>>2];c[h+8>>2]=c[E+8>>2];c[h+12>>2]=c[E+12>>2];c[h+16>>2]=c[E+16>>2];c[E+0>>2]=c[H+0>>2];c[E+4>>2]=c[H+4>>2];c[E+8>>2]=c[H+8>>2];c[E+12>>2]=c[H+12>>2];b[E+16>>1]=b[H+16>>1]|0;a[E+18>>0]=a[H+18>>0]|0;c[H+0>>2]=c[h+0>>2];c[H+4>>2]=c[h+4>>2];c[H+8>>2]=c[h+8>>2];c[H+12>>2]=c[h+12>>2];b[H+16>>1]=b[h+16>>1]|0;a[H+18>>0]=a[h+18>>0]|0;H=F+2|0;if((c[E>>2]|0)<(c[G>>2]|0)){c[h+0>>2]=c[G+0>>2];c[h+4>>2]=c[G+4>>2];c[h+8>>2]=c[G+8>>2];c[h+12>>2]=c[G+12>>2];c[h+16>>2]=c[G+16>>2];c[G+0>>2]=c[E+0>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];c[G+12>>2]=c[E+12>>2];b[G+16>>1]=b[E+16>>1]|0;a[G+18>>0]=a[E+18>>0]|0;c[E+0>>2]=c[h+0>>2];c[E+4>>2]=c[h+4>>2];c[E+8>>2]=c[h+8>>2];c[E+12>>2]=c[h+12>>2];b[E+16>>1]=b[h+16>>1]|0;a[E+18>>0]=a[h+18>>0]|0;if((c[G>>2]|0)<(c[m>>2]|0)){c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[h+16>>2]=c[m+16>>2];c[m+0>>2]=c[G+0>>2];c[m+4>>2]=c[G+4>>2];c[m+8>>2]=c[G+8>>2];c[m+12>>2]=c[G+12>>2];b[m+16>>1]=b[G+16>>1]|0;a[m+18>>0]=a[G+18>>0]|0;c[G+0>>2]=c[h+0>>2];c[G+4>>2]=c[h+4>>2];c[G+8>>2]=c[h+8>>2];c[G+12>>2]=c[h+12>>2];b[G+16>>1]=b[h+16>>1]|0;a[G+18>>0]=a[h+18>>0]|0;I=E;J=F+4|0}else{I=E;J=F+3|0}}else{I=E;J=H}}else{I=E;J=K}}else{K=c[E>>2]|0;H=(c[l>>2]|0)<(K|0);if((K|0)>=(c[m>>2]|0)){if(!H){I=E;J=0;break};c[h+0>>2]=c[E+0>>2];c[h+4>>2]=c[E+4>>2];c[h+8>>2]=c[E+8>>2];c[h+12>>2]=c[E+12>>2];c[h+16>>2]=c[E+16>>2];c[E+0>>2]=c[l+0>>2];c[E+4>>2]=c[l+4>>2];c[E+8>>2]=c[l+8>>2];c[E+12>>2]=c[l+12>>2];b[E+16>>1]=b[l+16>>1]|0;a[E+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;if((c[E>>2]|0)>=(c[m>>2]|0)){I=E;J=1;break};c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[h+16>>2]=c[m+16>>2];c[m+0>>2]=c[E+0>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];c[m+12>>2]=c[E+12>>2];b[m+16>>1]=b[E+16>>1]|0;a[m+18>>0]=a[E+18>>0]|0;c[E+0>>2]=c[h+0>>2];c[E+4>>2]=c[h+4>>2];c[E+8>>2]=c[h+8>>2];c[E+12>>2]=c[h+12>>2];b[E+16>>1]=b[h+16>>1]|0;a[E+18>>0]=a[h+18>>0]|0;I=E;J=2;break}if(H){c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[h+16>>2]=c[m+16>>2];c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];b[m+16>>1]=b[l+16>>1]|0;a[m+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;I=E;J=1;break};c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[h+16>>2]=c[m+16>>2];c[m+0>>2]=c[E+0>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];c[m+12>>2]=c[E+12>>2];b[m+16>>1]=b[E+16>>1]|0;a[m+18>>0]=a[E+18>>0]|0;c[E+0>>2]=c[h+0>>2];c[E+4>>2]=c[h+4>>2];c[E+8>>2]=c[h+8>>2];c[E+12>>2]=c[h+12>>2];b[E+16>>1]=b[h+16>>1]|0;a[E+18>>0]=a[h+18>>0]|0;if((c[l>>2]|0)<(c[E>>2]|0)){c[h+0>>2]=c[E+0>>2];c[h+4>>2]=c[E+4>>2];c[h+8>>2]=c[E+8>>2];c[h+12>>2]=c[E+12>>2];c[h+16>>2]=c[E+16>>2];c[E+0>>2]=c[l+0>>2];c[E+4>>2]=c[l+4>>2];c[E+8>>2]=c[l+8>>2];c[E+12>>2]=c[l+12>>2];b[E+16>>1]=b[l+16>>1]|0;a[E+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;I=E;J=2}else{I=E;J=1}}while(0);D=c[m>>2]|0;o=c[I>>2]|0;do if((D|0)<(o|0)){L=l;M=J}else{H=d;K=l;while(1){F=H+-40|0;if((m|0)==(F|0))break;if((c[F>>2]|0)<(o|0)){N=F;s=66;break}else{G=K;K=F;H=G}}if((s|0)==66){s=0;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[h+16>>2]=c[m+16>>2];c[m+0>>2]=c[N+0>>2];c[m+4>>2]=c[N+4>>2];c[m+8>>2]=c[N+8>>2];c[m+12>>2]=c[N+12>>2];b[m+16>>1]=b[N+16>>1]|0;a[m+18>>0]=a[N+18>>0]|0;c[N+0>>2]=c[h+0>>2];c[N+4>>2]=c[h+4>>2];c[N+8>>2]=c[h+8>>2];c[N+12>>2]=c[h+12>>2];b[N+16>>1]=b[h+16>>1]|0;a[N+18>>0]=a[h+18>>0]|0;L=N;M=J+1|0;break}H=m+20|0;if((D|0)<(c[l>>2]|0))O=H;else{if((H|0)==(l|0)){s=84;break a}else{P=m;Q=H}while(1){H=P+40|0;if((D|0)<(c[Q>>2]|0)){R=Q;break}if((H|0)==(l|0)){s=84;break a}else{K=Q;Q=H;P=K}}c[h+0>>2]=c[R+0>>2];c[h+4>>2]=c[R+4>>2];c[h+8>>2]=c[R+8>>2];c[h+12>>2]=c[R+12>>2];c[h+16>>2]=c[R+16>>2];c[R+0>>2]=c[l+0>>2];c[R+4>>2]=c[l+4>>2];c[R+8>>2]=c[l+8>>2];c[R+12>>2]=c[l+12>>2];b[R+16>>1]=b[l+16>>1]|0;a[R+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;O=R+20|0}if((O|0)==(l|0)){s=84;break a}else{S=O;T=l}while(1){K=c[m>>2]|0;H=S;while(1){G=H+20|0;if((K|0)<(c[H>>2]|0)){U=G;V=H;break}else H=G}H=T;while(1){G=H+-20|0;if((K|0)<(c[G>>2]|0))H=G;else{W=G;break}}if(V>>>0>=W>>>0){m=V;continue b};c[h+0>>2]=c[V+0>>2];c[h+4>>2]=c[V+4>>2];c[h+8>>2]=c[V+8>>2];c[h+12>>2]=c[V+12>>2];c[h+16>>2]=c[V+16>>2];c[V+0>>2]=c[W+0>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];c[V+12>>2]=c[W+12>>2];b[V+16>>1]=b[W+16>>1]|0;a[V+18>>0]=a[W+18>>0]|0;c[W+0>>2]=c[h+0>>2];c[W+4>>2]=c[h+4>>2];c[W+8>>2]=c[h+8>>2];c[W+12>>2]=c[h+12>>2];b[W+16>>1]=b[h+16>>1]|0;a[W+18>>0]=a[h+18>>0]|0;S=U;T=W}}while(0);D=m+20|0;c:do if(D>>>0<L>>>0){o=D;H=L;K=E;G=M;while(1){F=c[K>>2]|0;X=o;while(1){Y=X+20|0;if((c[X>>2]|0)<(F|0))X=Y;else{Z=Y;_=X;break}}X=H;while(1){Y=X+-20|0;if((c[Y>>2]|0)<(F|0)){$=Y;break}else X=Y}if(_>>>0>$>>>0){aa=_;ba=K;ca=G;break c};c[h+0>>2]=c[_+0>>2];c[h+4>>2]=c[_+4>>2];c[h+8>>2]=c[_+8>>2];c[h+12>>2]=c[_+12>>2];c[h+16>>2]=c[_+16>>2];c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];b[_+16>>1]=b[$+16>>1]|0;a[_+18>>0]=a[$+18>>0]|0;c[$+0>>2]=c[h+0>>2];c[$+4>>2]=c[h+4>>2];c[$+8>>2]=c[h+8>>2];c[$+12>>2]=c[h+12>>2];b[$+16>>1]=b[h+16>>1]|0;a[$+18>>0]=a[h+18>>0]|0;o=Z;H=$;K=(K|0)==(_|0)?$:K;G=G+1|0}}else{aa=D;ba=E;ca=M}while(0);if((aa|0)!=(ba|0)?(c[ba>>2]|0)<(c[aa>>2]|0):0){c[h+0>>2]=c[aa+0>>2];c[h+4>>2]=c[aa+4>>2];c[h+8>>2]=c[aa+8>>2];c[h+12>>2]=c[aa+12>>2];c[h+16>>2]=c[aa+16>>2];c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];c[aa+12>>2]=c[ba+12>>2];b[aa+16>>1]=b[ba+16>>1]|0;a[aa+18>>0]=a[ba+18>>0]|0;c[ba+0>>2]=c[h+0>>2];c[ba+4>>2]=c[h+4>>2];c[ba+8>>2]=c[h+8>>2];c[ba+12>>2]=c[h+12>>2];b[ba+16>>1]=b[h+16>>1]|0;a[ba+18>>0]=a[h+18>>0]|0;da=ca+1|0}else da=ca;if(!da){ea=lrc(m,aa,f)|0;E=aa+20|0;if(lrc(E,d,f)|0){s=79;break}if(ea){m=E;continue}}E=aa;if((E-n|0)>=(e-E|0)){fa=m;ga=aa;s=83;break}grc(m,aa,f);m=aa+20|0}if((s|0)==79){s=0;if(ea){s=84;break}else{k=m;d=aa;continue}}else if((s|0)==83){s=0;grc(ga+20|0,d,f);k=fa;d=ga;continue}}if((s|0)==4){if((c[q>>2]|0)>=(c[p>>2]|0)){i=g;return};c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];c[h+16>>2]=c[p+16>>2];c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];b[p+16>>1]=b[r+16>>1]|0;a[p+18>>0]=a[r+18>>0]|0;c[r+0>>2]=c[h+0>>2];c[r+4>>2]=c[h+4>>2];c[r+8>>2]=c[h+8>>2];c[r+12>>2]=c[h+12>>2];b[r+16>>1]=b[h+16>>1]|0;a[r+18>>0]=a[h+18>>0]|0;i=g;return}else if((s|0)==6){r=w+20|0;p=c[r>>2]|0;q=(c[x>>2]|0)<(p|0);if((p|0)>=(c[w>>2]|0)){if(!q){i=g;return};c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[h+12>>2]=c[r+12>>2];c[h+16>>2]=c[r+16>>2];c[r+0>>2]=c[y+0>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];c[r+12>>2]=c[y+12>>2];b[r+16>>1]=b[y+16>>1]|0;a[r+18>>0]=a[y+18>>0]|0;c[y+0>>2]=c[h+0>>2];c[y+4>>2]=c[h+4>>2];c[y+8>>2]=c[h+8>>2];c[y+12>>2]=c[h+12>>2];b[y+16>>1]=b[h+16>>1]|0;a[y+18>>0]=a[h+18>>0]|0;if((c[r>>2]|0)>=(c[w>>2]|0)){i=g;return};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[h+16>>2]=c[w+16>>2];c[w+0>>2]=c[r+0>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];c[w+12>>2]=c[r+12>>2];b[w+16>>1]=b[r+16>>1]|0;a[w+18>>0]=a[r+18>>0]|0;c[r+0>>2]=c[h+0>>2];c[r+4>>2]=c[h+4>>2];c[r+8>>2]=c[h+8>>2];c[r+12>>2]=c[h+12>>2];b[r+16>>1]=b[h+16>>1]|0;a[r+18>>0]=a[h+18>>0]|0;i=g;return}if(q){c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[h+16>>2]=c[w+16>>2];c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];b[w+16>>1]=b[y+16>>1]|0;a[w+18>>0]=a[y+18>>0]|0;c[y+0>>2]=c[h+0>>2];c[y+4>>2]=c[h+4>>2];c[y+8>>2]=c[h+8>>2];c[y+12>>2]=c[h+12>>2];b[y+16>>1]=b[h+16>>1]|0;a[y+18>>0]=a[h+18>>0]|0;i=g;return};c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[h+16>>2]=c[w+16>>2];c[w+0>>2]=c[r+0>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];c[w+12>>2]=c[r+12>>2];b[w+16>>1]=b[r+16>>1]|0;a[w+18>>0]=a[r+18>>0]|0;c[r+0>>2]=c[h+0>>2];c[r+4>>2]=c[h+4>>2];c[r+8>>2]=c[h+8>>2];c[r+12>>2]=c[h+12>>2];b[r+16>>1]=b[h+16>>1]|0;a[r+18>>0]=a[h+18>>0]|0;if((c[x>>2]|0)>=(c[r>>2]|0)){i=g;return};c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[h+12>>2]=c[r+12>>2];c[h+16>>2]=c[r+16>>2];c[r+0>>2]=c[y+0>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];c[r+12>>2]=c[y+12>>2];b[r+16>>1]=b[y+16>>1]|0;a[r+18>>0]=a[y+18>>0]|0;c[y+0>>2]=c[h+0>>2];c[y+4>>2]=c[h+4>>2];c[y+8>>2]=c[h+8>>2];c[y+12>>2]=c[h+12>>2];b[y+16>>1]=b[h+16>>1]|0;a[y+18>>0]=a[h+18>>0]|0;i=g;return}else if((s|0)==14){krc(z,z+20|0,z+40|0,A,f)|0;i=g;return}else if((s|0)==15){A=t+20|0;z=t+40|0;y=t+60|0;krc(t,A,z,y,f)|0;if((c[u>>2]|0)>=(c[y>>2]|0)){i=g;return};c[h+0>>2]=c[y+0>>2];c[h+4>>2]=c[y+4>>2];c[h+8>>2]=c[y+8>>2];c[h+12>>2]=c[y+12>>2];c[h+16>>2]=c[y+16>>2];c[y+0>>2]=c[v+0>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];c[y+12>>2]=c[v+12>>2];b[y+16>>1]=b[v+16>>1]|0;a[y+18>>0]=a[v+18>>0]|0;c[v+0>>2]=c[h+0>>2];c[v+4>>2]=c[h+4>>2];c[v+8>>2]=c[h+8>>2];c[v+12>>2]=c[h+12>>2];b[v+16>>1]=b[h+16>>1]|0;a[v+18>>0]=a[h+18>>0]|0;if((c[y>>2]|0)>=(c[z>>2]|0)){i=g;return};c[h+0>>2]=c[z+0>>2];c[h+4>>2]=c[z+4>>2];c[h+8>>2]=c[z+8>>2];c[h+12>>2]=c[z+12>>2];c[h+16>>2]=c[z+16>>2];c[z+0>>2]=c[y+0>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[z+12>>2]=c[y+12>>2];b[z+16>>1]=b[y+16>>1]|0;a[z+18>>0]=a[y+18>>0]|0;c[y+0>>2]=c[h+0>>2];c[y+4>>2]=c[h+4>>2];c[y+8>>2]=c[h+8>>2];c[y+12>>2]=c[h+12>>2];b[y+16>>1]=b[h+16>>1]|0;a[y+18>>0]=a[h+18>>0]|0;if((c[z>>2]|0)>=(c[A>>2]|0)){i=g;return};c[h+0>>2]=c[A+0>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[h+12>>2]=c[A+12>>2];c[h+16>>2]=c[A+16>>2];c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];c[A+12>>2]=c[z+12>>2];b[A+16>>1]=b[z+16>>1]|0;a[A+18>>0]=a[z+18>>0]|0;c[z+0>>2]=c[h+0>>2];c[z+4>>2]=c[h+4>>2];c[z+8>>2]=c[h+8>>2];c[z+12>>2]=c[h+12>>2];b[z+16>>1]=b[h+16>>1]|0;a[z+18>>0]=a[h+18>>0]|0;if((c[A>>2]|0)>=(c[t>>2]|0)){i=g;return};c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[h+12>>2]=c[t+12>>2];c[h+16>>2]=c[t+16>>2];c[t+0>>2]=c[A+0>>2];c[t+4>>2]=c[A+4>>2];c[t+8>>2]=c[A+8>>2];c[t+12>>2]=c[A+12>>2];b[t+16>>1]=b[A+16>>1]|0;a[t+18>>0]=a[A+18>>0]|0;c[A+0>>2]=c[h+0>>2];c[A+4>>2]=c[h+4>>2];c[A+8>>2]=c[h+8>>2];c[A+12>>2]=c[h+12>>2];b[A+16>>1]=b[h+16>>1]|0;a[A+18>>0]=a[h+18>>0]|0;i=g;return}else if((s|0)==21){A=B+40|0;t=B+20|0;z=c[t>>2]|0;y=c[B>>2]|0;v=c[A>>2]|0;u=(v|0)<(z|0);do if((z|0)<(y|0)){if(u){c[h+0>>2]=c[B+0>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2];c[h+12>>2]=c[B+12>>2];c[h+16>>2]=c[B+16>>2];c[B+0>>2]=c[A+0>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];c[B+12>>2]=c[A+12>>2];b[B+16>>1]=b[A+16>>1]|0;a[B+18>>0]=a[A+18>>0]|0;c[A+0>>2]=c[h+0>>2];c[A+4>>2]=c[h+4>>2];c[A+8>>2]=c[h+8>>2];c[A+12>>2]=c[h+12>>2];b[A+16>>1]=b[h+16>>1]|0;a[A+18>>0]=a[h+18>>0]|0;break};c[h+0>>2]=c[B+0>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2];c[h+12>>2]=c[B+12>>2];c[h+16>>2]=c[B+16>>2];c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];b[B+16>>1]=b[t+16>>1]|0;a[B+18>>0]=a[t+18>>0]|0;c[t+0>>2]=c[h+0>>2];c[t+4>>2]=c[h+4>>2];c[t+8>>2]=c[h+8>>2];c[t+12>>2]=c[h+12>>2];b[t+16>>1]=b[h+16>>1]|0;a[t+18>>0]=a[h+18>>0]|0;if((v|0)<(c[t>>2]|0)){c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[h+12>>2]=c[t+12>>2];c[h+16>>2]=c[t+16>>2];c[t+0>>2]=c[A+0>>2];c[t+4>>2]=c[A+4>>2];c[t+8>>2]=c[A+8>>2];c[t+12>>2]=c[A+12>>2];b[t+16>>1]=b[A+16>>1]|0;a[t+18>>0]=a[A+18>>0]|0;c[A+0>>2]=c[h+0>>2];c[A+4>>2]=c[h+4>>2];c[A+8>>2]=c[h+8>>2];c[A+12>>2]=c[h+12>>2];b[A+16>>1]=b[h+16>>1]|0;a[A+18>>0]=a[h+18>>0]|0}}else if(u?(c[h+0>>2]=c[t+0>>2],c[h+4>>2]=c[t+4>>2],c[h+8>>2]=c[t+8>>2],c[h+12>>2]=c[t+12>>2],c[h+16>>2]=c[t+16>>2],c[t+0>>2]=c[A+0>>2],c[t+4>>2]=c[A+4>>2],c[t+8>>2]=c[A+8>>2],c[t+12>>2]=c[A+12>>2],b[t+16>>1]=b[A+16>>1]|0,a[t+18>>0]=a[A+18>>0]|0,c[A+0>>2]=c[h+0>>2],c[A+4>>2]=c[h+4>>2],c[A+8>>2]=c[h+8>>2],c[A+12>>2]=c[h+12>>2],b[A+16>>1]=b[h+16>>1]|0,a[A+18>>0]=a[h+18>>0]|0,(c[t>>2]|0)<(y|0)):0){c[h+0>>2]=c[B+0>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2];c[h+12>>2]=c[B+12>>2];c[h+16>>2]=c[B+16>>2];c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];b[B+16>>1]=b[t+16>>1]|0;a[B+18>>0]=a[t+18>>0]|0;c[t+0>>2]=c[h+0>>2];c[t+4>>2]=c[h+4>>2];c[t+8>>2]=c[h+8>>2];c[t+12>>2]=c[h+12>>2];b[t+16>>1]=b[h+16>>1]|0;a[t+18>>0]=a[h+18>>0]|0}while(0);h=B+60|0;if((h|0)==(C|0)){i=g;return}else{ha=h;ia=A}while(1){A=c[ha>>2]|0;if((A|0)<(c[ia>>2]|0)){h=ha+4|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];h=ha;t=ia;while(1){c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[h+12>>2]=c[t+12>>2];b[h+16>>1]=b[t+16>>1]|0;a[h+18>>0]=a[t+18>>0]|0;if((t|0)==(B|0)){ja=B;break}y=t+-20|0;if((A|0)<(c[y>>2]|0)){u=t;t=y;h=u}else{ja=t;break}}c[ja>>2]=A;t=ja+4|0;c[t+0>>2]=c[j+0>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];b[t+12>>1]=b[j+12>>1]|0;a[t+14>>0]=a[j+14>>0]|0}t=ha+20|0;if((t|0)==(C|0))break;else{h=ha;ha=t;ia=h}}i=g;return}else if((s|0)==84){i=g;return}}function hrc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+60|0;g=c[f>>2]|0;if(g){h=a+64|0;j=c[h>>2]|0;if((j|0)==(g|0))k=g;else{l=j;while(1){j=l+-28|0;c[h>>2]=j;if((c[l+-12>>2]|0)>-1){m=l+-24|0;n=c[m>>2]|0;c[e>>2]=c[l+-20>>2];c[d+0>>2]=c[e+0>>2];eOb(n,d);c[m>>2]=0;o=c[h>>2]|0}else o=j;if((o|0)==(g|0))break;else l=o}k=c[f>>2]|0}ACi(k)}if((c[a+56>>2]|0)>-1){k=a+44|0;f=c[k>>2]|0;c[e>>2]=c[a+48>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[k>>2]=0}k=c[a+32>>2]|0;if(k){f=a+36|0;o=c[f>>2]|0;if((o|0)!=(k|0))c[f>>2]=o+(~((o+-16-k|0)>>>4)<<4);ACi(k)}if((c[a+28>>2]|0)>-1){k=a+16|0;o=c[k>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(o,d);c[k>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}k=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[a>>2]=0;i=b;return}function irc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[b>>2]|0;h=c[d>>2]|0;j=(h|0)<(g|0);do if((g|0)<(c[a>>2]|0)){k=a;l=c[k>>2]|0;m=c[k+4>>2]|0;if(j){k=d;n=c[k+4>>2]|0;o=a;c[o>>2]=c[k>>2];c[o+4>>2]=n;n=d;c[n>>2]=l;c[n+4>>2]=m;p=1;q=l;break}n=b;o=c[n+4>>2]|0;k=a;c[k>>2]=c[n>>2];c[k+4>>2]=o;o=b;c[o>>2]=l;c[o+4>>2]=m;o=c[d>>2]|0;if((o|0)<(l|0)){k=d;n=c[k+4>>2]|0;r=b;c[r>>2]=c[k>>2];c[r+4>>2]=n;n=d;c[n>>2]=l;c[n+4>>2]=m;p=2;q=l}else{p=1;q=o}}else if(j){o=b;l=c[o>>2]|0;m=c[o+4>>2]|0;o=d;n=c[o+4>>2]|0;r=b;c[r>>2]=c[o>>2];c[r+4>>2]=n;n=d;c[n>>2]=l;c[n+4>>2]=m;if((c[b>>2]|0)<(c[a>>2]|0)){m=a;n=c[m>>2]|0;r=c[m+4>>2]|0;m=b;o=c[m+4>>2]|0;k=a;c[k>>2]=c[m>>2];c[k+4>>2]=o;o=b;c[o>>2]=n;c[o+4>>2]=r;p=2;q=c[d>>2]|0}else{p=1;q=l}}else{p=0;q=h}while(0);if((c[e>>2]|0)>=(q|0)){s=p;i=f;return s|0}q=d;h=c[q>>2]|0;j=c[q+4>>2]|0;q=e;g=c[q+4>>2]|0;l=d;c[l>>2]=c[q>>2];c[l+4>>2]=g;g=e;c[g>>2]=h;c[g+4>>2]=j;if((c[d>>2]|0)>=(c[b>>2]|0)){s=p+1|0;i=f;return s|0}j=b;g=c[j>>2]|0;h=c[j+4>>2]|0;j=d;e=c[j+4>>2]|0;l=b;c[l>>2]=c[j>>2];c[l+4>>2]=e;e=d;c[e>>2]=g;c[e+4>>2]=h;if((c[b>>2]|0)>=(c[a>>2]|0)){s=p+2|0;i=f;return s|0}h=a;e=c[h>>2]|0;g=c[h+4>>2]|0;h=b;d=c[h+4>>2]|0;l=a;c[l>>2]=c[h>>2];c[l+4>>2]=d;d=b;c[d>>2]=e;c[d+4>>2]=g;s=p+3|0;i=f;return s|0}function jrc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;switch(b-a>>3|0){case 2:{f=b+-8|0;if((c[f>>2]|0)>=(c[a>>2]|0)){g=1;i=e;return g|0}h=a;j=c[h>>2]|0;k=c[h+4>>2]|0;h=f;l=c[h+4>>2]|0;m=a;c[m>>2]=c[h>>2];c[m+4>>2]=l;l=f;c[l>>2]=j;c[l+4>>2]=k;g=1;i=e;return g|0}case 4:{irc(a,a+8|0,a+16|0,b+-8|0,d)|0;g=1;i=e;return g|0}case 5:{k=a+8|0;l=a+16|0;j=a+24|0;f=b+-8|0;irc(a,k,l,j,d)|0;if((c[f>>2]|0)>=(c[j>>2]|0)){g=1;i=e;return g|0}d=j;m=c[d>>2]|0;h=c[d+4>>2]|0;d=f;n=c[d+4>>2]|0;o=j;c[o>>2]=c[d>>2];c[o+4>>2]=n;n=f;c[n>>2]=m;c[n+4>>2]=h;if((c[j>>2]|0)>=(c[l>>2]|0)){g=1;i=e;return g|0}h=l;n=c[h>>2]|0;m=c[h+4>>2]|0;h=j;f=c[h>>2]|0;o=c[h+4>>2]|0;h=l;c[h>>2]=f;c[h+4>>2]=o;h=j;c[h>>2]=n;c[h+4>>2]=m;if((f|0)>=(c[k>>2]|0)){g=1;i=e;return g|0}m=k;h=c[m>>2]|0;n=c[m+4>>2]|0;m=k;c[m>>2]=f;c[m+4>>2]=o;m=l;c[m>>2]=h;c[m+4>>2]=n;if((f|0)>=(c[a>>2]|0)){g=1;i=e;return g|0}n=a;m=c[n>>2]|0;h=c[n+4>>2]|0;n=a;c[n>>2]=f;c[n+4>>2]=o;o=k;c[o>>2]=m;c[o+4>>2]=h;g=1;i=e;return g|0}case 3:{h=a+8|0;o=b+-8|0;m=c[h>>2]|0;k=(c[o>>2]|0)<(m|0);if((m|0)>=(c[a>>2]|0)){if(!k){g=1;i=e;return g|0}m=h;n=c[m>>2]|0;f=c[m+4>>2]|0;m=o;l=c[m+4>>2]|0;j=h;c[j>>2]=c[m>>2];c[j+4>>2]=l;l=o;c[l>>2]=n;c[l+4>>2]=f;if((c[h>>2]|0)>=(c[a>>2]|0)){g=1;i=e;return g|0}f=a;l=c[f>>2]|0;n=c[f+4>>2]|0;f=h;j=c[f+4>>2]|0;m=a;c[m>>2]=c[f>>2];c[m+4>>2]=j;j=h;c[j>>2]=l;c[j+4>>2]=n;g=1;i=e;return g|0}n=a;j=c[n>>2]|0;l=c[n+4>>2]|0;if(k){k=o;n=c[k+4>>2]|0;m=a;c[m>>2]=c[k>>2];c[m+4>>2]=n;n=o;c[n>>2]=j;c[n+4>>2]=l;g=1;i=e;return g|0}n=h;m=c[n+4>>2]|0;k=a;c[k>>2]=c[n>>2];c[k+4>>2]=m;m=h;c[m>>2]=j;c[m+4>>2]=l;if((c[o>>2]|0)>=(j|0)){g=1;i=e;return g|0}m=o;k=c[m+4>>2]|0;n=h;c[n>>2]=c[m>>2];c[n+4>>2]=k;k=o;c[k>>2]=j;c[k+4>>2]=l;g=1;i=e;return g|0}case 1:case 0:{g=1;i=e;return g|0}default:{l=a+16|0;k=a+8|0;j=c[k>>2]|0;o=c[a>>2]|0;n=c[l>>2]|0;m=(n|0)<(j|0);do if((j|0)<(o|0)){h=a;f=c[h>>2]|0;d=c[h+4>>2]|0;if(m){h=l;p=c[h+4>>2]|0;q=a;c[q>>2]=c[h>>2];c[q+4>>2]=p;p=l;c[p>>2]=f;c[p+4>>2]=d;r=f;break}p=k;q=c[p+4>>2]|0;h=a;c[h>>2]=c[p>>2];c[h+4>>2]=q;q=k;c[q>>2]=f;c[q+4>>2]=d;if((n|0)<(f|0)){q=l;h=c[q+4>>2]|0;p=k;c[p>>2]=c[q>>2];c[p+4>>2]=h;h=l;c[h>>2]=f;c[h+4>>2]=d;r=f}else r=n}else if(m){f=k;d=c[f>>2]|0;h=c[f+4>>2]|0;f=l;p=c[f>>2]|0;q=c[f+4>>2]|0;f=k;c[f>>2]=p;c[f+4>>2]=q;f=l;c[f>>2]=d;c[f+4>>2]=h;if((p|0)<(o|0)){h=a;f=c[h>>2]|0;s=c[h+4>>2]|0;h=a;c[h>>2]=p;c[h+4>>2]=q;q=k;c[q>>2]=f;c[q+4>>2]=s;r=d}else r=d}else r=n;while(0);n=a+24|0;if((n|0)==(b|0)){g=1;i=e;return g|0}else{t=r;u=0;v=n;w=l}while(1){if((c[v>>2]|0)<(t|0)){l=v;n=c[l>>2]|0;r=c[l+4>>2]|0;l=v;k=w;while(1){o=k;m=c[o+4>>2]|0;j=l;c[j>>2]=c[o>>2];c[j+4>>2]=m;if((k|0)==(a|0)){x=k;break}m=k+-8|0;if((n|0)<(c[m>>2]|0)){j=k;k=m;l=j}else{x=k;break}}k=x;c[k>>2]=n;c[k+4>>2]=r;k=u+1|0;if((k|0)==8){y=v;break}else z=k}else z=u;k=v+8|0;if((k|0)==(b|0)){g=1;A=35;break}l=v;t=c[v>>2]|0;u=z;v=k;w=l}if((A|0)==35){i=e;return g|0}g=(y+8|0)==(b|0);i=e;return g|0}}return 0}function krc(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;h=i;i=i+32|0;j=h;k=c[e>>2]|0;l=(c[f>>2]|0)<(k|0);do if((k|0)<(c[d>>2]|0)){if(l){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];b[d+16>>1]=b[f+16>>1]|0;a[d+18>>0]=a[f+18>>0]|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];b[f+16>>1]=b[j+16>>1]|0;a[f+18>>0]=a[j+18>>0]|0;m=1;break};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];b[d+16>>1]=b[e+16>>1]|0;a[d+18>>0]=a[e+18>>0]|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];b[e+16>>1]=b[j+16>>1]|0;a[e+18>>0]=a[j+18>>0]|0;if((c[f>>2]|0)<(c[e>>2]|0)){c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];b[e+16>>1]=b[f+16>>1]|0;a[e+18>>0]=a[f+18>>0]|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];b[f+16>>1]=b[j+16>>1]|0;a[f+18>>0]=a[j+18>>0]|0;m=2}else m=1}else if(l){c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];b[e+16>>1]=b[f+16>>1]|0;a[e+18>>0]=a[f+18>>0]|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];b[f+16>>1]=b[j+16>>1]|0;a[f+18>>0]=a[j+18>>0]|0;if((c[e>>2]|0)<(c[d>>2]|0)){c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];b[d+16>>1]=b[e+16>>1]|0;a[d+18>>0]=a[e+18>>0]|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];b[e+16>>1]=b[j+16>>1]|0;a[e+18>>0]=a[j+18>>0]|0;m=2}else m=1}else m=0;while(0);if((c[g>>2]|0)>=(c[f>>2]|0)){n=m;i=h;return n|0};c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];b[f+16>>1]=b[g+16>>1]|0;a[f+18>>0]=a[g+18>>0]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];b[g+16>>1]=b[j+16>>1]|0;a[g+18>>0]=a[j+18>>0]|0;if((c[f>>2]|0)>=(c[e>>2]|0)){n=m+1|0;i=h;return n|0};c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];b[e+16>>1]=b[f+16>>1]|0;a[e+18>>0]=a[f+18>>0]|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];b[f+16>>1]=b[j+16>>1]|0;a[f+18>>0]=a[j+18>>0]|0;if((c[e>>2]|0)>=(c[d>>2]|0)){n=m+2|0;i=h;return n|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];b[d+16>>1]=b[e+16>>1]|0;a[d+18>>0]=a[e+18>>0]|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];b[e+16>>1]=b[j+16>>1]|0;a[e+18>>0]=a[j+18>>0]|0;n=m+3|0;i=h;return n|0}function lrc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g+16|0;j=g;switch((e-d|0)/20|0|0){case 3:{k=d+20|0;l=e+-20|0;m=c[k>>2]|0;n=(c[l>>2]|0)<(m|0);if((m|0)>=(c[d>>2]|0)){if(!n){o=1;i=g;return o|0};c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];b[k+16>>1]=b[l+16>>1]|0;a[k+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;if((c[k>>2]|0)>=(c[d>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];b[d+16>>1]=b[k+16>>1]|0;a[d+18>>0]=a[k+18>>0]|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];c[k+12>>2]=c[h+12>>2];b[k+16>>1]=b[h+16>>1]|0;a[k+18>>0]=a[h+18>>0]|0;o=1;i=g;return o|0}if(n){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];b[d+16>>1]=b[l+16>>1]|0;a[d+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;o=1;i=g;return o|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];b[d+16>>1]=b[k+16>>1]|0;a[d+18>>0]=a[k+18>>0]|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];c[k+12>>2]=c[h+12>>2];b[k+16>>1]=b[h+16>>1]|0;a[k+18>>0]=a[h+18>>0]|0;if((c[l>>2]|0)>=(c[k>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];b[k+16>>1]=b[l+16>>1]|0;a[k+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;o=1;i=g;return o|0}case 4:{krc(d,d+20|0,d+40|0,e+-20|0,f)|0;o=1;i=g;return o|0}case 2:{l=e+-20|0;if((c[l>>2]|0)>=(c[d>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];b[d+16>>1]=b[l+16>>1]|0;a[d+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;o=1;i=g;return o|0}case 1:case 0:{o=1;i=g;return o|0}case 5:{l=d+20|0;k=d+40|0;n=d+60|0;m=e+-20|0;krc(d,l,k,n,f)|0;if((c[m>>2]|0)>=(c[n>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[h+16>>2]=c[n+16>>2];c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];b[n+16>>1]=b[m+16>>1]|0;a[n+18>>0]=a[m+18>>0]|0;c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];b[m+16>>1]=b[h+16>>1]|0;a[m+18>>0]=a[h+18>>0]|0;if((c[n>>2]|0)>=(c[k>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];b[k+16>>1]=b[n+16>>1]|0;a[k+18>>0]=a[n+18>>0]|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[n+12>>2]=c[h+12>>2];b[n+16>>1]=b[h+16>>1]|0;a[n+18>>0]=a[h+18>>0]|0;if((c[k>>2]|0)>=(c[l>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[h+16>>2]=c[l+16>>2];c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];b[l+16>>1]=b[k+16>>1]|0;a[l+18>>0]=a[k+18>>0]|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];c[k+12>>2]=c[h+12>>2];b[k+16>>1]=b[h+16>>1]|0;a[k+18>>0]=a[h+18>>0]|0;if((c[l>>2]|0)>=(c[d>>2]|0)){o=1;i=g;return o|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];b[d+16>>1]=b[l+16>>1]|0;a[d+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;o=1;i=g;return o|0}default:{l=d+40|0;k=d+20|0;n=c[k>>2]|0;m=c[d>>2]|0;f=c[l>>2]|0;p=(f|0)<(n|0);do if((n|0)<(m|0)){if(p){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];b[d+16>>1]=b[l+16>>1]|0;a[d+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0;break};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];b[d+16>>1]=b[k+16>>1]|0;a[d+18>>0]=a[k+18>>0]|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];c[k+12>>2]=c[h+12>>2];b[k+16>>1]=b[h+16>>1]|0;a[k+18>>0]=a[h+18>>0]|0;if((f|0)<(c[k>>2]|0)){c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];b[k+16>>1]=b[l+16>>1]|0;a[k+18>>0]=a[l+18>>0]|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];b[l+16>>1]=b[h+16>>1]|0;a[l+18>>0]=a[h+18>>0]|0}}else if(p?(c[h+0>>2]=c[k+0>>2],c[h+4>>2]=c[k+4>>2],c[h+8>>2]=c[k+8>>2],c[h+12>>2]=c[k+12>>2],c[h+16>>2]=c[k+16>>2],c[k+0>>2]=c[l+0>>2],c[k+4>>2]=c[l+4>>2],c[k+8>>2]=c[l+8>>2],c[k+12>>2]=c[l+12>>2],b[k+16>>1]=b[l+16>>1]|0,a[k+18>>0]=a[l+18>>0]|0,c[l+0>>2]=c[h+0>>2],c[l+4>>2]=c[h+4>>2],c[l+8>>2]=c[h+8>>2],c[l+12>>2]=c[h+12>>2],b[l+16>>1]=b[h+16>>1]|0,a[l+18>>0]=a[h+18>>0]|0,(c[k>>2]|0)<(m|0)):0){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];b[d+16>>1]=b[k+16>>1]|0;a[d+18>>0]=a[k+18>>0]|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];c[k+12>>2]=c[h+12>>2];b[k+16>>1]=b[h+16>>1]|0;a[k+18>>0]=a[h+18>>0]|0}while(0);h=d+60|0;if((h|0)==(e|0)){o=1;i=g;return o|0}k=0;m=h;h=l;while(1){l=c[m>>2]|0;if((l|0)<(c[h>>2]|0)){p=m+4|0;c[j+0>>2]=c[p+0>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];p=m;f=h;while(1){c[p+0>>2]=c[f+0>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2];c[p+12>>2]=c[f+12>>2];b[p+16>>1]=b[f+16>>1]|0;a[p+18>>0]=a[f+18>>0]|0;if((f|0)==(d|0)){q=d;break}n=f+-20|0;if((l|0)<(c[n>>2]|0)){r=f;f=n;p=r}else{q=f;break}}c[q>>2]=l;f=q+4|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];b[f+12>>1]=b[j+12>>1]|0;a[f+14>>0]=a[j+14>>0]|0;f=k+1|0;if((f|0)==8){s=m;break}else t=f}else t=k;f=m+20|0;if((f|0)==(e|0)){o=1;u=35;break}else{p=m;k=t;m=f;h=p}}if((u|0)==35){i=g;return o|0}o=(s+20|0)==(e|0);i=g;return o|0}}return 0}function mrc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[153080]|0;c[a>>2]=0;c[a+4>>2]=f;c[a+8>>2]=0;c[a+12>>2]=64;c[e>>2]=f;c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(0,1024,4,d,0,3653512,370)|0;i=b;return}function nrc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;if(!f){i=d;return}g=f;f=0;while(1){h=c[a>>2]|0;j=h+(f<<4)|0;k=c[j>>2]|0;if(!k)l=g;else{m=h+(f<<4)+8|0;if(!(c[m>>2]|0))n=k;else{Gnd(m);n=c[j>>2]|0}co[c[(c[b>>2]|0)+292>>2]&2047](b,n,c[h+(f<<4)+4>>2]|0);c[j>>2]=0;l=c[e>>2]|0}f=f+1|0;if(f>>>0>=l>>>0)break;else g=l}i=d;return}function orc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a>>2]|0;a=f+(d<<4)|0;g=c[a>>2]|0;if(!g){i=e;return}h=f+(d<<4)+8|0;if(!(c[h>>2]|0))j=g;else{Gnd(h);j=c[a>>2]|0}co[c[(c[b>>2]|0)+292>>2]&2047](b,j,c[f+(d<<4)+4>>2]|0);c[a>>2]=0;i=e;return}function prc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h;m=a+12|0;n=c[m>>2]|0;do if((n&2147483520)>>>0<128)if((n|0)>-1){c[m>>2]=128;o=c[a>>2]|0;c[k>>2]=c[a+4>>2];c[j+0>>2]=c[k+0>>2];c[a>>2]=hOb(o,2048,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[a+4>>2];c[j+0>>2]=c[k+0>>2];o=cOb(2048,4,j,0,3653512,352)|0;YEi(o|0,c[a>>2]|0,c[a+8>>2]<<4|0)|0;c[m>>2]=128;c[a>>2]=o;break}while(0);if(!f){i=h;return}n=a+8|0;o=a+4|0;p=0;do{q=c[e+(p*20|0)>>2]&16777215;r=q+1|0;if(r>>>0>(c[n>>2]|0)>>>0){c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;s=c[m>>2]|0;t=s&2147483647;do if(t>>>0<r>>>0?(u=s<<1,v=u>>>0>r>>>0?u:r,t>>>0<v>>>0):0)if((s|0)>-1){c[m>>2]=v;u=c[a>>2]|0;c[k>>2]=c[o>>2];c[j+0>>2]=c[k+0>>2];c[a>>2]=hOb(u,v<<4,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[o>>2];c[j+0>>2]=c[k+0>>2];u=cOb(v<<4,4,j,0,3653512,352)|0;YEi(u|0,c[a>>2]|0,c[n>>2]<<4|0)|0;c[m>>2]=v;c[a>>2]=u;break}while(0);s=c[n>>2]|0;if(s>>>0<r>>>0?(t=c[a>>2]|0,u=t+(r<<4)|0,(s|0)!=(r|0)):0){v=t+(s<<4)|0;do{if(v){c[v+0>>2]=c[l+0>>2];c[v+4>>2]=c[l+4>>2];c[v+8>>2]=c[l+8>>2];c[v+12>>2]=c[l+12>>2]}v=v+16|0}while((v|0)!=(u|0))}c[n>>2]=r}u=c[a>>2]|0;v=c[e+(p*20|0)+8>>2]|0;if(g)w=c[v+36>>2]|0;else w=v;v=e+(p*20|0)+16|0;s=kn[c[(c[b>>2]|0)+288>>2]&511](b,w,c[e+(p*20|0)+12>>2]|0,c[v>>2]|0)|0;if(s){c[u+(q<<4)>>2]=w;c[u+(q<<4)+4>>2]=c[v>>2]}v=c[e+(p*20|0)+4>>2]|0;c[v>>2]=s;ko[d&4095](v);v=c[a>>2]|0;s=v+(q<<4)|0;u=c[s>>2]|0;if(u){t=v+(q<<4)+8|0;if(!(c[t>>2]|0))x=u;else{Gnd(t);x=c[s>>2]|0}co[c[(c[b>>2]|0)+292>>2]&2047](b,x,c[v+(q<<4)+4>>2]|0);c[s>>2]=0}p=p+1|0}while((p|0)!=(f|0));i=h;return}function qrc(){var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;if(a[586872]|0){i=b;return}a[586889]=1;f=586900;c[f>>2]=-1;c[f+4>>2]=0;f=c[146728]<<3;c[e>>2]=57;c[d+0>>2]=c[e+0>>2];e=cOb(f,16,d,0,3653512,80)|0;c[146727]=e;d=e+(c[146728]<<3)|0;if((e|0)!=(d|0)){f=e;do{if(f){e=586900;g=c[e+4>>2]|0;h=f;c[h>>2]=c[e>>2];c[h+4>>2]=g}f=f+8|0}while((f|0)!=(d|0))}src(586880);a[586888]=1;d=586892;c[d>>2]=-2;c[d+4>>2]=0;a[586872]=1;i=b;return}function rrc(){return}function src(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e;j=d+4|0;if(!(c[j>>2]|0)){i=e;return}k=h+4|0;c[k>>2]=0;l=h+8|0;m=d+8|0;a[l>>0]=a[m>>0]|0;n=h+9|0;o=d+9|0;a[n>>0]=a[o>>0]|0;p=h+12|0;q=d+12|0;r=q;s=c[r+4>>2]|0;t=p;c[t>>2]=c[r>>2];c[t+4>>2]=s;s=h+20|0;t=d+20|0;r=t;u=c[r+4>>2]|0;v=s;c[v>>2]=c[r>>2];c[v+4>>2]=u;u=h+28|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;a[u+20>>0]=0;uqc(h,d,0);v=c[j>>2]|0;c[j>>2]=c[k>>2];c[k>>2]=v;v=a[m>>0]|0;k=b[l>>1]|0;a[m>>0]=k;a[l>>0]=v;v=a[o>>0]|0;a[o>>0]=(k&65535)>>>8;a[n>>0]=v;v=q;n=c[v>>2]|0;k=c[v+4>>2]|0;v=p;o=c[v+4>>2]|0;l=q;c[l>>2]=c[v>>2];c[l+4>>2]=o;o=p;c[o>>2]=n;c[o+4>>2]=k;k=t;o=c[k>>2]|0;n=c[k+4>>2]|0;k=s;p=c[k+4>>2]|0;l=t;c[l>>2]=c[k>>2];c[l+4>>2]=p;p=s;c[p>>2]=o;c[p+4>>2]=n;n=d+28|0;p=c[n>>2]|0;c[n>>2]=c[u>>2];c[u>>2]=p;u=d+32|0;n=h+32|0;o=c[u>>2]|0;s=c[n>>2]|0;c[u>>2]=s;c[n>>2]=o;n=d+36|0;u=h+36|0;l=c[n>>2]|0;c[n>>2]=c[u>>2];c[u>>2]=l;w=ea(s>>>0);c[d+44>>2]=~~ea(w*ea(.5))>>>0;c[d+40>>2]=~~ea(w*ea(.200000003))>>>0;a[d+48>>0]=0;w=ea(o>>>0);c[h+44>>2]=~~ea(w*ea(.5))>>>0;c[h+40>>2]=~~ea(w*ea(.200000003))>>>0;a[h+48>>0]=0;if(!p){i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(p,f);i=e;return}function trc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;h=d+36|0;j=d;k=a+4|0;l=a+8|0;m=c[l>>2]|0;n=a+8|0;if(m){o=n;p=m;a:while(1){m=p;while(1){if(!(Iic(m+16|0,b)|0)){q=m;break}m=c[m+4>>2]|0;if(!m){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if((r|0)!=(n|0))if(Iic(b,r+16|0)|0)s=r;else{t=c[r+48>>2]|0;i=d;return t|0}else s=n}else s=n;n=_n[c[(c[a>>2]|0)+8>>2]&4095](a,b)|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2];c[j+20>>2]=c[b+20>>2];c[j+24>>2]=c[b+24>>2];c[j+28>>2]=c[b+28>>2];c[j+32>>2]=n;c[h>>2]=s;c[e+0>>2]=c[h+0>>2];h=vrc(k,e,g,j)|0;if(c[h>>2]|0){t=n;i=d;return t|0}c[f>>2]=8;c[e+0>>2]=c[f+0>>2];f=cOb(52,16,e,0,3653512,80)|0;e=f+16|0;s=j+0|0;j=e+36|0;do{c[e>>2]=c[s>>2];e=e+4|0;s=s+4|0}while((e|0)<(j|0));s=c[g>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=s;c[h>>2]=f;s=c[c[k>>2]>>2]|0;if(!s)u=f;else{c[k>>2]=s;u=c[h>>2]|0}GN(c[l>>2]|0,u);u=a+12|0;c[u>>2]=(c[u>>2]|0)+1;t=n;i=d;return t|0}function urc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+8|0;if((e|0)!=(f|0)){g=e;while(1){In[c[(c[a>>2]|0)+12>>2]&4095](a,c[g+48>>2]|0);e=c[g+4>>2]|0;if(!e){h=g;while(1){j=c[h+8>>2]|0;if((c[j>>2]|0)==(h|0)){k=j;break}else h=j}}else{h=e;while(1){j=c[h>>2]|0;if(!j){k=h;break}else h=j}}if((k|0)==(f|0))break;else g=k}}wrc(d,c[a+8>>2]|0);c[a+12>>2]=0;c[d>>2]=f;c[f>>2]=0;i=b;return}function vrc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=h+16|0,!(Iic(e,b)|0)):0){if(!(Iic(b,e)|0)){c[d>>2]=h;j=d;i=f;return j|0}b=h+4|0;k=c[b>>2]|0;if(!k){l=h;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=k;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}do if((n|0)!=(g|0)){if(Iic(e,n+16|0)|0){o=c[b>>2]|0;break}l=c[a+4>>2]|0;if(!l){c[d>>2]=g;j=g;i=f;return j|0}else p=l;while(1){l=p+16|0;if(Iic(e,l)|0){m=c[p>>2]|0;if(!m){q=p;r=p;s=35;break}else{p=m;continue}}if(!(Iic(l,e)|0)){t=p;s=39;break}l=p+4|0;m=c[l>>2]|0;if(!m){u=l;v=p;s=38;break}else p=m}if((s|0)==35){c[d>>2]=r;j=q;i=f;return j|0}else if((s|0)==38){c[d>>2]=v;j=u;i=f;return j|0}else if((s|0)==39){c[d>>2]=t;j=d;i=f;return j|0}}else o=k;while(0);if(!o){c[d>>2]=h;j=b;i=f;return j|0}else{c[d>>2]=n;j=n;i=f;return j|0}}if((h|0)!=(c[a>>2]|0)){n=c[h>>2]|0;if(!n){b=h;while(1){o=c[b+8>>2]|0;if((c[o>>2]|0)==(b|0))b=o;else{w=o;break}}}else{b=n;while(1){n=c[b+4>>2]|0;if(!n){w=b;break}else b=n}}if(!(Iic(w+16|0,e)|0)){b=c[a+4>>2]|0;if(!b){c[d>>2]=g;j=g;i=f;return j|0}else x=b;while(1){b=x+16|0;if(Iic(e,b)|0){g=c[x>>2]|0;if(!g){y=x;z=x;s=15;break}else{x=g;continue}}if(!(Iic(b,e)|0)){A=x;s=19;break}b=x+4|0;g=c[b>>2]|0;if(!g){B=b;C=x;s=18;break}else x=g}if((s|0)==15){c[d>>2]=z;j=y;i=f;return j|0}else if((s|0)==18){c[d>>2]=C;j=B;i=f;return j|0}else if((s|0)==19){c[d>>2]=A;j=d;i=f;return j|0}}else D=w}else D=h;if(!(c[h>>2]|0)){c[d>>2]=h;j=h;i=f;return j|0}else{c[d>>2]=D;j=D+4|0;i=f;return j|0}return 0}function wrc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}wrc(a,c[b>>2]|0);wrc(a,c[b+4>>2]|0);c[f>>2]=8;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function xrc(a,b){a=a|0;b=b|0;var c=0;c=i;Zq(a,b);i=c;return}function yrc(a){a=a|0;var b=0,c=0;b=i;if(!a)c=0;else c=$q(a)|0;i=b;return c|0}function zrc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=qtc(Atc()|0,a,b)|0;i=c;return d|0}function Arc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=fbd(d)|0;j=c[a>>2]|0;_r(j)|0;a=d+80|0;if(f){k=es(j,b,a,h,e)|0;i=g;return k|0}else{k=fs(j,b,a,e)|0;i=g;return k|0}return 0}function Brc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,19)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[146734]=d;i=a;return}function Crc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[146734]|0;f=c[153072]|0;if(e)Bbc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[146734]=0;i=a;return}function Drc(){var a=0,b=0;a=i;lcc();Vq(586944);hs(0);b=trd()|0;Xq(b,urd()|0,0);i=a;return}function Erc(a){a=a|0;var b=0;if(!a)b=0;else b=c[a+12>>2]|0;return b|0}function Frc(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function Grc(a){a=a|0;var b=0;if(!a)b=0;else b=c[a+8>>2]|0;return b|0}function Hrc(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Irc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b;while(1){b=EQb(e)|0;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;b=Asc(3516336,3516216,f)|0;if(b){g=b;break}e=HQb(e)|0;if(!e){h=0;j=8;break}}if((j|0)==8){i=d;return h|0}h=tsc(g)|0;i=d;return h|0}function Jrc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+5136|0;g=f;h=f+16|0;c[g>>2]=c[e>>2];uEi(h,5120,d,g)|0;Fr(Gr(Yq()|0,a,b,h)|0)}function Krc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=c[d>>2];Jrc(3496376,a,b,f)}function Lrc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+5136|0;e=d;f=d+16|0;c[e>>2]=b;uEi(f,5120,a,e)|0;Fr(Gr(ptc(Atc()|0,0)|0,3516216,2514384,f)|0)}function Mrc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;Krc(3101296,a,e)}function Nrc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;Krc(3026840,a,e)}function Orc(a){a=a|0;Fr(Gr(Yq()|0,3496376,3101296,3653512)|0)}function Prc(a){a=a|0;var b=0;b=i;i=i+16|0;if(!a)Mrc(3672696,b);else{i=b;return}}function Qrc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[(Gsc(a,b,4)|0)>>2]=d;i=e;return}function Rrc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Gsc(a,b,4)|0;i=c;return d|0}function Src(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(Gsc(a,b,4)|0)>>2]|0;i=d;return e|0}function Trc(a){a=a|0;var b=0,c=0,d=0;b=i;if(HEi(ksc(a)|0,2711992)|0){c=0;i=b;return c|0}d=etc(a)|0;c=(d|0)==(dtc()|0);i=b;return c|0}function Urc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=$sc(Osc(b)|0)|0;g=ksc(Msc(b)|0)|0;h=ctc(gsc(f)|0)|0;f=Ksc(b)|0;c[e>>2]=h;c[e+4>>2]=f;c[e+8>>2]=g;Lsd(a,586968,e);BDi(h);i=d;return}function Vrc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b;if(HEi(ksc(a)|0,2711992)|0){g=0;i=b;return g|0}h=etc(a)|0;if((h|0)!=(dtc()|0)){g=0;i=b;return g|0}c[f>>2]=0;h=f+4|0;c[h>>2]=0;c[f+8>>2]=0;Ssc(a,f);a=c[f>>2]|0;if((c[h>>2]|0)-a>>2>>>0<=1)wxi(f);f=c[a+4>>2]|0;if(!a){g=f;i=b;return g|0}j=c[h>>2]|0;if((j|0)!=(a|0))c[h>>2]=j+(~((j+-4-a|0)>>>2)<<2);c[e>>2]=89;c[d+0>>2]=c[e+0>>2];eOb(a,d);g=f;i=b;return g|0}function Wrc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+12|0;e=b;if(!a){i=b;return}c[d>>2]=0;gs(a,d);a=c[d>>2]|0;if(!a){i=b;return};c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Rcd(a,0,e);xri(e);i=b;return}function Xrc(a){a=a|0;return (a&15|0)==6|0}function Yrc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!d){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}h=is(d)|0;j=js(d)|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Bri(f,h<<2,0);c[g>>2]=0;if(!(a[f>>0]&1))k=f+1|0;else k=c[f+8>>2]|0;KVc(j,h,k,g)|0;Bri(f,c[g>>2]|0,0);sri(b,f);xri(f);i=e;return}function Zrc(a){a=a|0;var b=0,d=0;b=i;d=Zr(c[a>>2]|0)|0;i=b;return d|0}function _rc(a){a=a|0;var b=0,d=0;b=i;d=_r(c[a>>2]|0)|0;i=b;return d|0}function $rc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=$r(c[a>>2]|0,b)|0;i=d;return e|0}function asc(a){a=a|0;var b=0,d=0;b=i;d=Wr(c[a>>2]|0)|0;i=b;return d|0}function bsc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=as(c[a>>2]|0,b)|0;i=d;return e|0}function csc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=kr(a,b,c)|0;i=d;return e|0}function dsc(a){a=a|0;var b=0,c=0;b=i;c=sr(a)|0;i=b;return c|0}function esc(a){a=a|0;var b=0,c=0;b=i;c=rr(a)|0;i=b;return c|0}function fsc(a){a=a|0;var b=0,c=0,d=0;b=i;if((a|0)!=0?(c=yr(a)|0,(c|0)!=0):0)d=qs(c)|0;else d=0;i=b;return d|0}function gsc(a){a=a|0;var b=0,c=0;b=i;c=yr(a)|0;i=b;return c|0}function hsc(a){a=a|0;return a|0}function isc(a){a=a|0;var b=0,c=0;b=i;c=qr(a)|0;i=b;return c|0}function jsc(a){a=a|0;var b=0,c=0;b=i;c=Ar(a)|0;i=b;return c|0}function ksc(a){a=a|0;var b=0,c=0;b=i;c=or(a)|0;i=b;return c|0}function lsc(a){a=a|0;var b=0,c=0;b=i;c=pr(a)|0;i=b;return c|0}function msc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ir(a,b,1)|0;i=c;return d|0}function nsc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=0;c[f>>2]=0;g=nr(a,e)|0;if(!g){i=d;return}h=b+4|0;j=b+8|0;k=g;do{c[f>>2]=k;g=c[h>>2]|0;if((g|0)==(c[j>>2]|0))jtc(b,f);else{if(!g)l=0;else{m=f;n=c[m+4>>2]|0;o=g;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=c[h>>2]|0}c[h>>2]=l+8}k=nr(a,e)|0}while((k|0)!=0);i=d;return}function osc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;psc(a,b,c,d,0);i=e;return}function psc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g;c[h>>2]=0;j=nr(b,h)|0;a:do if(j){b:do if((e|0)==-1){k=j;while(1){do if(!(HEi(Wr(k)|0,d)|0)){if(!(Yr(k)|0)?Xr(k)|0:0)break;if(!(Xcd(f)|0)){l=k;m=15;break b}n=Zr(k)|0;if(Wcd(f,n,_r(k)|0)|0){o=k;m=17;break b}}while(0);k=nr(b,h)|0;if(!k)break a}}else{k=j;while(1){do if((HEi(Wr(k)|0,d)|0)==0?(_r(k)|0)==(e|0):0){if(!(Yr(k)|0)?Xr(k)|0:0)break;if(!(Xcd(f)|0)){l=k;m=15;break b}n=Zr(k)|0;if(Wcd(f,n,_r(k)|0)|0){o=k;m=17;break b}}while(0);k=nr(b,h)|0;if(!k)break a}}while(0);if((m|0)==15){c[a>>2]=l;i=g;return}else if((m|0)==17){c[a>>2]=o;i=g;return}}while(0);if(f&8){o=a;c[o>>2]=0;c[o+4>>2]=0;i=g;return}o=qr(b)|0;if(!o){b=a;c[b>>2]=0;c[b+4>>2]=0;i=g;return}else{psc(a,o,d,e,f);i=g;return}}function qsc(a){a=a|0;var b=0,d=0;b=i;d=Ur(c[a>>2]|0)|0;i=b;return d|0}function rsc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[a>>2]|0;_r(g)|0;a=fs(g,b,d+80|0,e)|0;i=f;return a|0}function ssc(a){a=a|0;var b=0,c=0;b=i;if(!a)c=0;else c=gr(a)|0;i=b;return c|0}function tsc(a){a=a|0;var b=0,c=0;b=i;c=ds(a)|0;i=b;return c|0}function usc(a,b){a=a|0;b=b|0;var c=0;c=i;gs(a,b);i=c;return}function vsc(a){a=a|0;var b=0,c=0;b=i;c=bs(a)|0;i=b;return c|0}function wsc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a>>2]=cs(b,c[d>>2]|0)|0;i=e;return}function xsc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+80|0;f=e;g=e+40|0;h=e+28|0;j=e+8|0;k=e+16|0;l=e+4|0;m=e+12|0;n=e+48|0;o=e+56|0;if((a[587040]|0)==0?(a[587040]=1,p=c[(Xbd()|0)+532>>2]|0,(p|0)!=0):0){rri(h,587048,21);q=a[h>>0]|0;if(!(q&1)){r=h+1|0;s=(q&255)>>>1}else{r=c[h+8>>2]|0;s=c[h+4>>2]|0}c[j>>2]=ms(r,s)|0;fs(p,0,j,g)|0;j=c[g>>2]|0;if(j){c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Rcd(j,0,k);xri(k)}xri(h)}if(!(c[(Xbd()|0)+380>>2]|0)){i=e;return}c[l>>2]=0;c[m>>2]=1;c[n>>2]=ls(b)|0;c[n+4>>2]=m;m=fs(c[(Xbd()|0)+380>>2]|0,0,n,l)|0;if(!(c[l>>2]|0)){Yrc(o,m);yri(d,o)|0;xri(o);i=e;return}else{Ird(587072,f);i=e;return}}function ysc(a){a=a|0;var b=0,c=0;b=i;c=ls(a)|0;i=b;return c|0}function zsc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+64|0;f=k;b=k+56|0;l=k+48|0;m=k+36|0;n=k+24|0;o=k+12|0;if(!((ps()|0)!=0&(j&262144|0)==0)){i=k;return}p=ntc(Atc()|0,3516336,3516216,2513848)|0;if(!p){i=k;return}psc(b,p,2513192,0,0);p=c[b>>2]|0;if(!p){i=k;return}c[l>>2]=0;b=fs(p,0,0,l)|0;if(c[l>>2]|0){Ird(587112,f);i=k;return}Yrc(m,b);yri(e,m)|0;xri(m);m=a[e>>0]|0;if(!(m&1))q=(m&255)>>>1;else q=c[e+4>>2]|0;if(!q){i=k;return}q=c[h>>2]|0;sri(n,g);if(!(j&16384)){if(!(a[e>>0]&1))r=e+1|0;else r=c[e+8>>2]|0;if(!(a[n>>0]&1))s=n+1|0;else s=c[n+8>>2]|0;c[f>>2]=r;c[f+4>>2]=s;c[f+8>>2]=q;Lsd(o,587168,f);yri(e,o)|0;xri(o)}if(!(a[e>>0]&1))t=e+1|0;else t=c[e+8>>2]|0;xsc(t,d);xri(n);i=k;return}function Asc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=ntc(Atc()|0,a,b,c)|0;i=d;return e|0}function Bsc(a){a=a|0;var b=0,c=0;b=i;c=Nr(a,1)|0;i=b;return c|0}function Csc(a){a=a|0;var b=0;b=i;Pr(a);i=b;return}function Dsc(a){a=a|0;var b=0,c=0;b=i;c=Or(a)|0;i=b;return c|0}function Esc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ms(a,b)|0;i=c;return d|0}function Fsc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+112|0;f=e+84|0;g=e+40|0;h=e;j=e+68|0;k=e+72|0;l=e+96|0;m=e+28|0;n=e+56|0;o=e+44|0;p=e+16|0;q=e+4|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;c[k>>2]=b;c[k+4>>2]=h;c[k+8>>2]=j;if((c[(Xbd()|0)+372>>2]|0)!=0?(fs(c[(Xbd()|0)+372>>2]|0,b,k,g)|0,k=c[g>>2]|0,(k|0)!=0):0){g=or(bs(k)|0)|0;rri(n,g,SEi(g|0)|0);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;g=a[n>>0]|0;if(!(g&1))r=(g&255)>>>1;else r=c[n+4>>2]|0;Pri(m,587184,78,r+78|0);if(!(a[n>>0]&1))s=n+1|0;else s=c[n+8>>2]|0;Gri(m,s,r)|0;yO(l,m,587264);if(!(a[l>>0]&1))t=l+1|0;else t=c[l+8>>2]|0;Krd(t,0,3653512,385,1,0,0,0);xri(l);xri(m);xri(n);xri(f);i=e;return}n=c[h>>2]|0;if(n){Yrc(o,n);yri(d,o)|0;xri(o)}o=c[j>>2]|0;if(o){Yrc(p,o);yri(f,p)|0;xri(p)};c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;if(!(a[f>>0]&1))u=f+1|0;else u=c[f+8>>2]|0;xsc(u,q);yri(d+12|0,q)|0;yri(d+24|0,f)|0;c[d+36>>2]=0;zri(d+40|0,587312)|0;c[d+52>>2]=-1;xri(q);xri(f);i=e;return}function Gsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=a+((da(c,b)|0)+16)|0;return d|0}function Hsc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_q(a,b)|0;i=c;return d|0}function Isc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;b=i;d=ar(a,c)|0;i=b;return d|0}function Jsc(a){a=a|0;var b=0,c=0;b=i;c=Cr(a)|0;i=b;return c|0}function Ksc(a){a=a|0;var b=0,c=0;b=i;c=Hr(a)|0;i=b;return c|0}function Lsc(a){a=a|0;var b=0,c=0;b=i;c=Ir(a)|0;i=b;return c|0}function Msc(a){a=a|0;var b=0,c=0;b=i;c=Jr(a)|0;i=b;return c|0}function Nsc(a){a=a|0;var b=0,c=0;b=i;c=Kr(a)|0;i=b;return c|0}function Osc(a){a=a|0;var b=0,c=0;b=i;c=Lr(a)|0;i=b;return c|0}function Psc(a){a=a|0;var b=0,c=0;b=i;c=rs(a)|0;i=b;return c|0}function Qsc(a){a=a|0;var b=0,c=0;b=i;c=ss(a)|0;i=b;return c|0}function Rsc(a){a=a|0;var b=0,c=0;b=i;c=tr(a)|0;i=b;return c|0}function Ssc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;g=lr(a,e)|0;c[f>>2]=g;if(!g){i=d;return}h=b+4|0;j=b+8|0;k=g;do{g=c[h>>2]|0;if((g|0)==(c[j>>2]|0))ktc(b,f);else{if(!g)l=0;else{c[g>>2]=k;l=c[h>>2]|0}c[h>>2]=l+4}k=lr(a,e)|0;c[f>>2]=k}while((k|0)!=0);i=d;return}function Tsc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=mr(a,b)|0;i=c;return d|0}function Usc(a){a=a|0;var b=0,c=0;b=i;c=fr(a)|0;i=b;return c|0}function Vsc(a){a=a|0;var b=0,c=0;b=i;c=ur(a)|0;i=b;return c|0}function Wsc(a){a=a|0;var b=0,c=0;b=i;c=vr(a)|0;i=b;return c|0}function Xsc(a){a=a|0;var b=0,c=0;b=i;c=hr(a)|0;i=b;return c|0}function Ysc(a){a=a|0;var b=0,c=0;b=i;c=$q(a)|0;i=b;return c|0}function Zsc(a){a=a|0;var b=0,c=0;b=i;c=wr(a)|0;i=b;return c|0}function _sc(a){a=a|0;var b=0,c=0;b=i;c=dr(a)|0;i=b;return c|0}function $sc(a){a=a|0;var b=0,c=0;b=i;c=xr(a)|0;i=b;return c|0}function atc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Mr(b,c)|0;i=a;return d|0}function btc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zr(a,b)|0;i=c;return d|0}function ctc(a){a=a|0;var b=0,c=0;b=i;c=ts(a)|0;i=b;return c|0}function dtc(){var a=0,b=0;a=i;b=Yq()|0;i=a;return b|0}function etc(a){a=a|0;var b=0,c=0;b=i;c=Br(a)|0;i=b;return c|0}function ftc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=Qr(a,b,c,d)|0;i=e;return f|0}function gtc(a){a=a|0;var b=0;b=i;Rr(a);i=b;return}function htc(a,b){a=a|0;b=b|0;var c=0;c=i;Sr(a,b);i=c;return}function itc(a){a=a|0;var b=0;b=i;Tr(a);i=b;return}function jtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>3)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>3>>>0<1073741823){m=h>>2;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>3;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>3;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<3,16,e,0,3653512,80)|0;p=r}r=o+(p<<3)|0;if(r){q=b;b=c[q+4>>2]|0;s=r;c[s>>2]=c[q>>2];c[s+4>>2]=b}b=c[a>>2]|0;s=(c[g>>2]|0)-b|0;q=o+(p-(s>>3)<<3)|0;YEi(q|0,b|0,s|0)|0;s=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<3);c[k>>2]=o+(n<<3);if(!s){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function ktc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>2)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>2>>>0<1073741823){m=h>>1;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>2;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>2;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<2,16,e,0,3653512,80)|0;p=r}r=o+(p<<2)|0;if(r)c[r>>2]=c[b>>2];b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>2)<<2)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<2);c[k>>2]=o+(n<<2);if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function ltc(a,b){a=a|0;b=b|0;b=i;mtc(a);Lbd(a+36|0);ko[c[(c[a>>2]|0)+100>>2]&4095](a);Jrd(23);i=b;return}function mtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+720|0;f=b+712|0;g=c[f>>2]|0;h=b+708|0;j=c[h>>2]|0;k=(g-j|0)/12|0;l=b+724|0;b=c[l>>2]|0;m=c[e>>2]|0;n=b-m>>2;if(k>>>0<=n>>>0)if(k>>>0<n>>>0?(o=m+(k<<2)|0,(b|0)!=(o|0)):0){c[l>>2]=b+(~((b+-4-o|0)>>>2)<<2);p=g;q=j}else{p=g;q=j}else{Ctc(e,k-n|0);p=c[f>>2]|0;q=c[h>>2]|0}if((p|0)==(q|0)){i=d;return}else{r=q;s=p;t=0}while(1){p=a[r+(t*12|0)>>0]|0;if(!(p&1))u=(p&255)>>>1;else u=c[r+(t*12|0)+4>>2]|0;if(!u){v=s;w=r}else{p=Dr()|0;q=c[h>>2]|0;n=q+(t*12|0)|0;if(!(a[n>>0]&1))x=n+1|0;else x=c[q+(t*12|0)+8>>2]|0;q=Er(p,x)|0;if(!q)y=0;else y=er(q)|0;c[(c[e>>2]|0)+(t<<2)>>2]=y;v=c[f>>2]|0;w=c[h>>2]|0}t=t+1|0;if(t>>>0>=((v-w|0)/12|0)>>>0)break;else{r=w;s=v}}i=d;return}function ntc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;f=kr(Yq()|0,d,e)|0;g=c[a+720>>2]|0;h=a+724|0;a=c[h>>2]|0;if((g|0)!=(a|0)&(f|0)==0){j=a;k=g}else{l=f;i=b;return l|0}while(1){f=c[k>>2]|0;if(!f){m=j;n=0}else{g=kr(f,d,e)|0;m=c[h>>2]|0;n=g}k=k+4|0;if(!((k|0)!=(m|0)&(n|0)==0)){l=n;break}else j=m}i=b;return l|0}function otc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+724>>2]|0;f=c[a+720>>2]|0;if((e|0)==(f|0)){g=-1;i=d;return g|0}a=e-f>>2;e=0;while(1){if((c[f+(e<<2)>>2]|0)==(b|0)){g=e;h=5;break}e=e+1|0;if(e>>>0>=a>>>0){g=-1;h=5;break}}if((h|0)==5){i=d;return g|0}return 0}function ptc(a,b){a=a|0;b=b|0;return c[(c[a+720>>2]|0)+(b<<2)>>2]|0}function qtc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;h=f+4|0;j=c[c[b+720>>2]>>2]|0;if(!j)k=0;else k=csc(j,3516216,d)|0;if((k|0)!=0|e){l=k;i=f;return l|0}c[g>>2]=d;Lsd(h,587472,g);if(!(a[h>>0]&1))m=h+1|0;else m=c[h+8>>2]|0;Krd(m,0,3653512,111,1,0,0,0);xri(h);l=0;i=f;return l|0}function rtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d;f=d+16|0;add(b,792072,587552,a,0);KSb(a,b);ddd(b,2);add(b,587568,c[142284]|0,a+24|0,0);$cd(b,2646336,2646336,d+20|0,0);c[f>>2]=0;add(b,3142592,615200,f,0);g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,g,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);vXb(b,a+708|0,609208,0);bdd(b);i=d;return}function stc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,587552,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Dtc(a,b);sdd(b);i=d;return}function ttc(a,b){a=a|0;b=b|0;var c=0;c=i;Etc(a,b);i=c;return}function utc(a,b){a=a|0;b=b|0;var c=0;c=i;NSb(a,b);Ftc(b,a+24|0,0);DXb(b,a+708|0,0);i=c;return}function vtc(a,b){a=a|0;b=b|0;var c=0;c=i;Gtc(a,b);i=c;return}function wtc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;PSb(b,d);f=c[b+24>>2]|0;g=b+28|0;if((f|0)==(g|0)){i=e;return}b=d+12|0;h=d+28|0;j=d+32|0;d=f;while(1){f=d+16|0;k=c[b>>2]|0;l=xo[c[c[k>>2]>>2]&2047](k,c[f>>2]|0,c[h>>2]|0)|0;if(a[j>>0]|0)c[f>>2]=l;l=c[d+4>>2]|0;if(!l){f=d;while(1){k=c[f+8>>2]|0;if((c[k>>2]|0)==(f|0)){m=k;break}else f=k}}else{f=l;while(1){k=c[f>>2]|0;if(!k){m=f;break}else f=k}}if((m|0)==(g|0))break;else d=m}i=e;return}function xtc(){var a=0;a=i;QQb(116,126,0,0,0);i=a;return}function ytc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,587552,11);wQb(116,6,b,732,2617,0,0);xri(b);i=a;return}function ztc(a){a=a|0;return 116}function Atc(){var a=0,b=0;a=i;b=rVb(5)|0;i=a;return b|0}function Btc(){var a=0,b=0;a=i;b=tVb(5)|0;i=a;return b|0}function Ctc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l>>2]=0;m=c[g>>2]|0}l=m+4|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=k;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>2;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=1073741823;r=(c[g>>2]|0)-j>>2;s=10}if((s|0)==10){n=q;o=xCi(q<<2)|0;p=r}r=b;b=o+(p<<2)|0;while(1){if(!b)t=0;else{c[b>>2]=0;t=b}q=t+4|0;r=r+-1|0;if(!r){u=q;break}else b=q}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;t=o+(p-(r>>2)<<2)|0;YEi(t|0,b|0,r|0)|0;c[a>>2]=t;c[g>>2]=u;c[e>>2]=o+(n<<2);if(!b){i=d;return}ACi(b);i=d;return}function Dtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;LSb(a,b);rdd(b,2);f=a+24|0;g=qdd(b,587568,c[142284]|0,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else Ltc(b,f,0);sdd(b)}f=a+708|0;a=qdd(b,609208,c[142306]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else yXb(b,f,0);sdd(b);i=d;return}function Etc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;MSb(a,b);h=a+24|0;j=b+12|0;k=c[j>>2]|0;l=k+4|0;if(l>>>0>(c[b+20>>2]|0)>>>0)Bid(j,f,4);else{c[f>>2]=c[k>>2];c[j>>2]=l}c[g>>2]=0;Mtc(h,c[a+28>>2]|0);c[a+32>>2]=0;l=a+28|0;c[h>>2]=l;c[l>>2]=0;if((c[f>>2]|0)<=0){m=a+708|0;BXb(b,m,0);i=d;return}l=0;do{Ntc(g,b);Otc(e,h,g);l=l+1|0}while((l|0)<(c[f>>2]|0));m=a+708|0;BXb(b,m,0);i=d;return}function Ftc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=c[h>>2]|0;k=j+4|0;if(k>>>0>(c[a+20>>2]|0)>>>0){Bid(h,f,4);l=c[f>>2]|0}else{m=c[j>>2]|0;c[f>>2]=m;c[h>>2]=k;l=m}c[f>>2]=XEi(l|0)|0;c[g>>2]=0;Mtc(b,c[b+4>>2]|0);c[b+8>>2]=0;l=b+4|0;c[b>>2]=l;c[l>>2]=0;if((c[f>>2]|0)<=0){i=d;return}l=0;do{Ptc(g,a);Otc(e,b,g);l=l+1|0}while((l|0)<(c[f>>2]|0));i=d;return}function Gtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;OSb(a,b);f=c[a+32>>2]|0;c[e>>2]=f;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;if(j>>>0<(c[k>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=j}else Gid(g,e,4);j=a+28|0;f=c[a+24>>2]|0;if((f|0)!=(j|0)){h=f;while(1){Qtc(h+16|0,b);f=c[h+4>>2]|0;if(!f){l=h;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=f;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}if((n|0)==(j|0))break;else h=n}}n=a+712|0;h=c[n>>2]|0;j=a+708|0;a=c[j>>2]|0;l=(h-a|0)/12|0;c[e>>2]=l;f=c[g>>2]|0;m=f+4|0;if(m>>>0<(c[k>>2]|0)>>>0){c[f>>2]=l;c[g>>2]=m;o=a;p=h}else{Gid(g,e,4);o=c[j>>2]|0;p=c[n>>2]|0}if((o|0)==(p|0)){i=d;return}else q=o;do{FXb(b,q,3142592,0);q=q+12|0}while((q|0)!=(p|0));i=d;return}function Htc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(732,e,1,16,3653512,16)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];Obd(g,e,b);c[g>>2]=587360;b=g+708|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return g|0}function Itc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=587360;Jrd(0);g=c[b+720>>2]|0;if(g){h=b+724|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~((j+-4-g|0)>>>2)<<2);ACi(g)}g=b+708|0;j=c[g>>2]|0;if(!j){Pbd(b);i=d;return}h=b+712|0;k=c[h>>2]|0;if((k|0)==(j|0))l=j;else{m=k;while(1){k=m+-12|0;c[h>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[h>>2]|0}if((n|0)==(j|0))break;else m=n}l=c[g>>2]|0}ACi(l);Pbd(b);i=d;return}function Jtc(a){a=a|0;var b=0;b=i;Itc(a);ACi(a);i=b;return}function Ktc(a,b){a=a|0;b=b|0;return 0}function Ltc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=b+8|0;c[f>>2]=c[h>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}c[g>>2]=0;Mtc(b,c[b+4>>2]|0);c[h>>2]=0;h=b+4|0;c[b>>2]=h;c[h>>2]=0;if((c[f>>2]|0)>0){h=0;do{j=qdd(a,3142592,615200,e,1)|0;if(j){if((j|0)<=0){j=c[e>>2]|0;if(j)_n[j&4095](g,a)|0}else Rtc(g,a);sdd(a)}Otc(e,b,g);h=h+1|0}while((h|0)<(c[f>>2]|0))}udd(a);i=d;return}function Mtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Mtc(a,c[b>>2]|0);Mtc(a,c[b+4>>2]|0);c[f>>2]=68;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Ntc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function Otc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d+4|0;l=c[k>>2]|0;do if(l){m=c[e>>2]|0;n=l;while(1){o=c[n+16>>2]|0;if((m|0)<(o|0)){p=c[n>>2]|0;if(!p){q=n;r=n;s=5;break}else{n=p;continue}}if((o|0)>=(m|0)){t=n;s=9;break}o=n+4|0;p=c[o>>2]|0;if(!p){u=o;v=n;s=8;break}else n=p}if((s|0)==5){c[j>>2]=r;w=q;x=r;break}else if((s|0)==8){c[j>>2]=v;w=u;x=v;break}else if((s|0)==9){c[j>>2]=t;w=j;x=t;break}}else{n=d+4|0;c[j>>2]=n;w=n;x=n}while(0);j=c[w>>2]|0;if(j){y=0;z=j;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}c[h>>2]=68;c[g+0>>2]=c[h+0>>2];h=cOb(20,16,g,0,3653512,80)|0;c[h+16>>2]=c[e>>2];c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=x;c[w>>2]=h;x=c[c[d>>2]>>2]|0;if(!x)B=h;else{c[d>>2]=x;B=c[w>>2]|0}GN(c[k>>2]|0,B);B=d+8|0;c[B>>2]=(c[B>>2]|0)+1;y=1;z=h;c[b>>2]=z;A=b+4|0;a[A>>0]=y;i=f;return}function Ptc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function Qtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function Rtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function Stc(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function Ttc(a){a=a|0;return (c[a>>2]|0)==0|0}function Utc(a,b){a=a|0;b=b|0;var d=0;d=i;Yrc(a,c[b>>2]|0);i=d;return}function Vtc(a,b){a=a|0;b=b|0;var d=0;d=i;Yrc(a,c[b>>2]|0);i=d;return}function Wtc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+72|0;f=c[e>>2]|0;if(!f){i=d;return}g=c[a+64>>2]|0;a=0;while(1){h=g+(a<<2)|0;a=a+1|0;if((c[h>>2]|0)==(b|0)){j=h;break}if(a>>>0>=f>>>0){k=6;break}}if((k|0)==6){i=d;return}k=f+-1|0;c[j>>2]=c[g+(k<<2)>>2];c[e>>2]=k;i=d;return}function Xtc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;if(!b)g=0;else g=c[b+4>>2]|0;b=c[a+48>>2]|0;h=c[a+44>>2]|0;if((b|0)==(h|0)){j=0;c[e>>2]=j;k=a+56|0;l=c[k>>2]|0;c[d>>2]=l;i=f;return}m=(b-h|0)/28|0;b=0;n=0;while(1){o=c[h+(b*28|0)+20>>2]|0;if(!o)p=n;else{q=c[h+(b*28|0)+12>>2]|0;r=1<<b;s=n;t=0;while(1){u=s|((c[q+(t<<2)>>2]|0)==(g|0)?r:0);t=t+1|0;if(t>>>0>=o>>>0){p=u;break}else s=u}}b=b+1|0;if(b>>>0>=m>>>0){j=p;break}else n=p}c[e>>2]=j;k=a+56|0;l=c[k>>2]|0;c[d>>2]=l;i=f;return}function Ytc(a,b){a=a|0;b=b|0;return (c[a+44>>2]|0)+(b*28|0)|0}function Ztc(a){a=a|0;var b=0,d=0,e=Im,f=Im,h=Im,j=Im;b=i;i=i+16|0;d=b;qGc(d,BTb(c[a+24>>2]|0)|0);e=ea(g[d>>2]);if(e<ea(0.0))f=ea(-e);else f=e;e=ea(g[d+4>>2]);if(e<ea(0.0))h=ea(-e);else h=e;e=f<h?h:f;f=ea(g[d+8>>2]);if(f<ea(0.0))j=ea(-f);else j=f;f=ea((e<j?j:e)*ea(g[a+40>>2]));i=b;return ea(f)}function _tc(){return c[146898]|0}function $tc(){return c[146902]|0}function auc(){return c[146902]|0}function buc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[146902]|0;g=c[153110]|0;if((f|0)!=0?(vsd(587584,c[f>>2]|0),(c[f+16>>2]|0)>-1):0){h=f+4|0;j=c[h>>2]|0;c[d>>2]=c[f+8>>2];c[b+0>>2]=c[d+0>>2];eOb(j,b);c[h>>2]=0}c[e>>2]=g;c[b+0>>2]=c[e+0>>2];eOb(f,b);c[146902]=0;ssd(587584);i=a;return}function cuc(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153110];c[b+0>>2]=c[d+0>>2];d=bOb(28,b,1,16,3653512,42)|0;b=c[153110]|0;e=d+4|0;c[e>>2]=0;c[d+8>>2]=b;c[d+12>>2]=0;c[d+16>>2]=0;c[d>>2]=xsd(587584)|0;g[d+20>>2]=ea(1.0);c[d+24>>2]=0;b=(nuc(e)|0)+0|0;e=b+92|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));c[146902]=d;i=a;return}function duc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+4|0;f=c[b>>2]|0;c[e>>2]=0;c[a+8>>2]=f;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=xsd(587584)|0;g[a+20>>2]=ea(1.0);c[a+24>>2]=0;a=(nuc(e)|0)+0|0;e=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}function euc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;vsd(587584,c[a>>2]|0);if((c[a+16>>2]|0)<=-1){i=b;return}f=a+4|0;g=c[f>>2]|0;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function fuc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=Im,v=0,w=0,x=Im;l=i;m=c[b+88>>2]|0;if(m){a[j>>0]=m;g[k>>2]=ea(0.0);i=l;return}n=ea(g[b>>2]);o=ea(n-ea(g[d>>2]));n=ea(g[b+4>>2]);p=ea(n-ea(g[d+4>>2]));n=ea(g[b+8>>2]);q=ea(n-ea(g[d+8>>2]));n=ea(ea(ea(ea(o*o)+ea(p*p))+ea(q*q))*h);a[j>>0]=0;g[k>>2]=ea(0.0);if(n>ea(g[b+12>>2])){i=l;return}d=c[b+16>>2]|0;if((d|0)>(e|0)){r=f;s=e}else{i=l;return}while(1){h=ea(g[b+(s<<2)+20>>2]);if(n<ea(h*h)){t=r;u=h;v=s;break}s=s+1|0;if((s|0)>=(d|0)){w=17;break}else r=r<<1}if((w|0)==17){i=l;return}h=ea(g[b+(v<<2)+52>>2]);if(h<ea(0.0)){a[j>>0]=t;if((v|0)>0)x=ea(g[b+(v+-1<<2)+20>>2]);else x=ea(Ztc(c[b+84>>2]|0));g[k>>2]=ea(ea(ea(T(ea(n)))-x)/ea(u-x));i=l;return}if(!(h>ea(0.0))){a[j>>0]=t;g[k>>2]=ea(0.0);i=l;return}x=ea(u-ea(T(ea(n))));if(x<h){a[j>>0]=t<<1|t;g[k>>2]=ea(x/h);i=l;return}else{a[j>>0]=t;g[k>>2]=ea(0.0);i=l;return}}function guc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=Im,A=Im;h=i;j=(a[d>>0]|0)==0;k=ea(g[d+20>>2]);if(j)l=ea(+X(+(+ea(ea(ea(ea(ea(g[d+16>>2])/ea(360.0))*ea(2.0))*ea(3.14159274))*ea(.5)))));else l=k;k=ea(l*ea(2.0));l=ea(k/ea(g[b+20>>2]));m=b+4|0;n=c[b+12>>2]|0;g[f>>2]=ea(0.0);o=b+24|0;b=c[o>>2]|0;p=1<<b;if(j){k=ea(l*l);if((n|0)<=1){i=h;return}j=d+4|0;d=b;q=1;while(1){fuc((c[m>>2]|0)+(q*92|0)|0,j,d,p,k,e+q|0,f+(q<<2)|0);r=q+1|0;if((r|0)==(n|0))break;d=c[o>>2]|0;q=r}i=h;return}if((n|0)<=1){i=h;return}q=b;b=1;while(1){d=c[m>>2]|0;j=e+b|0;r=f+(b<<2)|0;s=c[d+(b*92|0)+88>>2]|0;a:do if(!s){a[j>>0]=0;g[r>>2]=ea(0.0);t=c[d+(b*92|0)+16>>2]|0;if((t|0)>(q|0)){u=p;v=q;while(1){k=ea(g[d+(b*92|0)+(v<<2)+20>>2]);if(k>l){w=u;x=k;y=v;break}v=v+1|0;if((v|0)>=(t|0))break a;else u=u<<1}k=ea(g[d+(b*92|0)+(y<<2)+52>>2]);if(k<ea(0.0)){a[j>>0]=w;if((y|0)>0)z=ea(g[d+(b*92|0)+(y+-1<<2)+20>>2]);else z=ea(0.0);g[r>>2]=ea(ea(l-z)/ea(x-z));break}if(!(k>ea(0.0))){a[j>>0]=w;g[r>>2]=ea(0.0);break}A=ea(x-l);if(A<k){a[j>>0]=w<<1|w;g[r>>2]=ea(A/k);break}else{a[j>>0]=w;g[r>>2]=ea(0.0);break}}}else{a[j>>0]=s;g[r>>2]=ea(0.0)}while(0);r=b+1|0;if((r|0)==(n|0))break;q=c[o>>2]|0;b=r}i=h;return}function huc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im;h=i;i=i+16|0;j=h;if(!b){k=ea(0.0);i=h;return ea(k)}l=d[e+a>>0]|0;e=l>>>1;m=l-(e&85)|0;n=(m>>>2&858993459)+(m&858993459)|0;m=((da((n>>>4)+n&252645135,16843009)|0)&-16777216|0)==16777216;if((l&b|0)==(l|0)){if(!m){k=ea(0.0);i=h;return ea(k)}o=ea(g[f+(a<<2)>>2]);if(o!=ea(.5))if(o<ea(0.0))p=ea(0.0);else{n=o>ea(.999000012);p=n?ea(.999000012):o}else p=ea(.499000013);k=ea(-p);i=h;return ea(k)}n=e|l;e=n>>>2|n;n=(e>>>4|e)+1|0;c[j>>2]=n>>>2;c[j+4>>2]=n>>>1;p=ea(g[f+(a<<2)>>2]);if(!(c[j+(((l+255&l|0)==0&1)<<2)>>2]&b))q=ea(ea(1.0)-p);else q=p;if(q!=ea(.5))if(q<ea(0.0))r=ea(0.0);else{b=q>ea(.999000012);r=b?ea(.999000012):q}else r=ea(.499000013);if(!m){k=r;i=h;return ea(k)}k=ea(-r);i=h;return ea(k)}function iuc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,g=0,h=0,j=0;f=i;g=a+4|0;h=a+12|0;j=c[h>>2]|0;nuc(g)|0;juc(a,j,b,d,e);c[(c[g>>2]|0)+(((c[h>>2]|0)+-1|0)*92|0)+88>>2]=0;i=f;return j|0}function juc(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=Im,x=Im;j=i;k=c[b+4>>2]|0;b=k+(d*92|0)|0;c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[k+(d*92|0)+84>>2]=e;f=e+48|0;b=e+44|0;e=k+(d*92|0)+16|0;c[e>>2]=((c[f>>2]|0)-(c[b>>2]|0)|0)/28|0;l=k+(d*92|0)+12|0;g[l>>2]=ea(0.0);if(!(a[(NOc()|0)+94>>0]|0)){m=c[e>>2]|0;c[e>>2]=(m|0)>1?m:1;n=ea(h/ea(.0000999999974));g[k+(d*92|0)+20>>2]=n;g[k+(d*92|0)+52>>2]=ea(0.0);o=n;p=ea(o*o);g[l>>2]=p;i=j;return}m=c[f>>2]|0;f=c[b>>2]|0;if((m|0)==(f|0)){o=ea(0.0);p=ea(o*o);g[l>>2]=p;i=j;return}b=(m-f|0)/28|0;n=ea(0.0);m=0;while(1){q=ea(g[f+(m*28|0)>>2]);r=ea(h/q);s=r<n?n:r;g[k+(d*92|0)+(m<<2)+20>>2]=r;e=c[f+(m*28|0)+4>>2]|0;do if((e|0)!=2){t=k+(d*92|0)+(m<<2)+52|0;if((e|0)==1)g[t>>2]=ea(-1.0);else{u=t;v=13}}else{w=ea(g[f+(m*28|0)+8>>2]);if(!(w>ea(9.99999974e-06))){u=k+(d*92|0)+(m<<2)+52|0;v=13;break}if(!m)x=ea(1.0);else x=ea(g[f+((m+-1|0)*28|0)>>2]);g[k+(d*92|0)+(m<<2)+52>>2]=ea(r-ea(h/ea(q+ea(ea(x-q)*w))))}while(0);if((v|0)==13){v=0;g[u>>2]=ea(0.0)}m=m+1|0;if(m>>>0>=b>>>0){o=s;break}else n=s}p=ea(o*o);g[l>>2]=p;i=j;return}function kuc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=a+16|0;j=c[h>>2]|0;if((j&2147483647)>>>0>=b>>>0){i=d;return}if((j|0)>-1){c[h>>2]=b;j=c[g>>2]|0;c[f>>2]=c[a+8>>2];c[e+0>>2]=c[f+0>>2];c[g>>2]=hOb(j,b*92|0,4,e,0,3653512,370)|0;i=d;return}else{c[f>>2]=c[a+8>>2];c[e+0>>2]=c[f+0>>2];f=cOb(b*92|0,4,e,0,3653512,352)|0;YEi(f|0,c[g>>2]|0,(c[a+12>>2]|0)*92|0)|0;c[h>>2]=b;c[g>>2]=f;i=d;return}}function luc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+4|0;g=a+12|0;c[g>>2]=1;h=a+16|0;j=c[h>>2]|0;if(j&2147483647){i=b;return}if((j|0)>-1){c[h>>2]=1;j=c[f>>2]|0;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];c[f>>2]=hOb(j,92,4,d,0,3653512,370)|0;i=b;return}else{c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=cOb(92,4,d,0,3653512,352)|0;YEi(e|0,c[f>>2]|0,(c[g>>2]|0)*92|0)|0;c[h>>2]=1;c[f>>2]=e;i=b;return}}function muc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153110];c[b+0>>2]=c[d+0>>2];rsd(587584,b);Drd(587616,127,128,0);i=a;return}function nuc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;do if(g>>>0>k>>>0?(l=j<<1,m=(l|0)==0?1:l,k>>>0<m>>>0):0)if((j|0)>-1){c[h>>2]=m;l=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(l,m*92|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];l=cOb(m*92|0,4,d,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[f>>2]|0)*92|0)|0;c[h>>2]=m;c[a>>2]=l;break}while(0);i=b;return (c[a>>2]|0)+(((c[f>>2]|0)+-1|0)*92|0)|0}function ouc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];oEc(a,f,d);c[a>>2]=587632;d=a+136|0;c[d>>2]=0;c[a+140>>2]=0;c[a+144>>2]=0;Buc(d,6);i=e;return}function puc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;g=i;if((b+-1&b|0)==0?(d+-1&d|0)==0:0){if((b|0)==(d|0)){j=BEc(a,b,b,e,f,6,h)|0;i=g;return j|0}if(!a)k=0;else k=c[a+4>>2]|0;Krd(587840,0,3653512,32,1,k,0,0);j=0;i=g;return j|0}if(!a)l=0;else l=c[a+4>>2]|0;Krd(587800,0,3653512,27,1,l,0,0);j=0;i=g;return j|0}function quc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;k=mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0;l=b+48|0;if(((k|0)==(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0)?(k=c[l>>2]|0,(k|0)!=0):0)?(c[k+40>>2]|0)==6:0){m=k;n=b+48|0;o=6}else{Krd(587872,0,3653512,44,1,0,0,0);k=c[l>>2]|0;l=b+48|0;if(!k){p=0;q=0;r=0;s=l}else{m=k;n=l;o=6}}if((o|0)==6){l=c[m+8>>2]|0;p=l+(c[m+36>>2]|0)|0;q=l;r=m;s=n}n=p-q|0;q=n*6|0;p=r+4|0;c[p>>2]=(c[p>>2]|0)+1;if(!d?(a[b+125>>0]|0)!=0:0)t=1;else t=3;d=znc()|0;p=c[(c[d>>2]|0)+476>>2]|0;r=b+44|0;c[h>>2]=c[r>>2];m=c[s>>2]|0;if(!m)u=0;else u=c[m+8>>2]|0;m=mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0;l=c[s>>2]|0;if(!l)v=5;else v=c[l+32>>2]|0;l=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;if((KLc()|0)==1)w=c[b+56>>2]|0;else w=0;c[f+0>>2]=c[h+0>>2];yn[p&7](d,f,u,q,n,m,v,l,t,w);In[c[(c[d>>2]|0)+360>>2]&4095](d,c[s>>2]|0);d=c[r>>2]|0;w=b;t=c[148593]|0;do if(t){l=t;while(1){v=c[l+16>>2]|0;if(d>>>0<v>>>0){m=c[l>>2]|0;if(!m){x=l;y=l;o=19;break}else{l=m;continue}}if(v>>>0>=d>>>0){z=l;o=23;break}v=l+4|0;m=c[v>>2]|0;if(!m){A=v;B=l;o=22;break}else l=m}if((o|0)==19){c[f>>2]=y;C=x;D=y;break}else if((o|0)==22){c[f>>2]=B;C=A;D=B;break}else if((o|0)==23){c[f>>2]=z;C=f;D=z;break}}else{c[f>>2]=594372;C=594372;D=594372}while(0);if(!(c[C>>2]|0)){z=xCi(24)|0;o=z+16|0;c[o>>2]=d;c[o+4>>2]=w;c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=D;c[C>>2]=z;D=c[c[148592]>>2]|0;if(!D)E=z;else{c[148592]=D;E=c[C>>2]|0}GN(c[148593]|0,E);c[148594]=(c[148594]|0)+1}c[b+40>>2]=1;ko[c[(c[b>>2]|0)+132>>2]&4095](b);a[b+125>>0]=1;E=ync()|0;C=c[(c[E>>2]|0)+644>>2]|0;c[j>>2]=c[r>>2];r=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;c[f+0>>2]=c[j+0>>2];co[C&2047](E,f,r);if(a[b+127>>0]|0){i=e;return}b=c[s>>2]|0;r=c[153076]|0;E=b+4|0;c[E>>2]=(c[E>>2]|0)+-1;if(!(c[E>>2]|0)){ko[c[c[b>>2]>>2]&4095](b);c[g>>2]=r;c[f+0>>2]=c[g+0>>2];eOb(b,f)}c[s>>2]=0;i=e;return}function ruc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;if(!(mo[c[(c[a>>2]|0)+124>>2]&4095](a)|0)){i=b;return}d=a+48|0;e=c[d>>2]|0;a:do if(e){f=c[e+32>>2]|0;switch(f|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((f+-48|0)>>>0>=12){if((c[e+40>>2]|0)!=6)break a;zEc(a);f=c[d>>2]|0;g=c[f+24>>2]|0;gwc(c[f+8>>2]|0,g,g,1,c[f+32>>2]|0);f=c[d>>2]|0;gwc((c[f+8>>2]|0)+(c[f+36>>2]|0)|0,g,g,1,c[f+32>>2]|0);f=c[d>>2]|0;gwc((c[f+8>>2]|0)+(c[f+36>>2]<<1)|0,g,g,1,c[f+32>>2]|0);f=c[d>>2]|0;gwc((c[f+8>>2]|0)+((c[f+36>>2]|0)*3|0)|0,g,g,1,c[f+32>>2]|0);f=c[d>>2]|0;gwc((c[f+8>>2]|0)+(c[f+36>>2]<<2)|0,g,g,1,c[f+32>>2]|0);f=c[d>>2]|0;gwc((c[f+8>>2]|0)+((c[f+36>>2]|0)*5|0)|0,g,g,1,c[f+32>>2]|0);i=b;return}}if(!a)h=0;else h=c[a+4>>2]|0;Krd(595872,0,3653512,161,1,h,0,0);i=b;return}while(0);if(!a)j=0;else j=c[a+4>>2]|0;Krd(587928,0,3653512,166,1,j,0,0);i=b;return}function suc(){var a=0;a=i;QQb(89,129,0,0,0);i=a;return}function tuc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(28)|0))REc();rri(b,587960,7);wQb(89,28,b,148,2618,0,0);xri(b);i=a;return}function uuc(a){a=a|0;return 89}function vuc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+16|0;add(b,792072,587960,a,0);$Ec(a,b);add(b,587968,c[142306]|0,a+136|0,0);c[f>>2]=0;$cd(b,2646336,2646336,d+20|0,0);add(b,3142592,614680,f,0);a=e+8|0;g=a;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,a,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);fdd(b);bdd(b);i=d;return}function wuc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=qdd(b,792072,587960,f,1)|0;if(!g){i=d;return}if((g|0)>0){aFc(a,b);g=a+136|0;h=qdd(b,587968,c[142306]|0,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else Euc(b,g,0);sdd(b)}}else{g=c[f>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b);i=d;return}function xuc(a,b){a=a|0;b=b|0;var c=0;c=i;bFc(a,b);Fuc(b,a+136|0,0);Ndd(b);i=c;return}function yuc(a,b){a=a|0;b=b|0;var c=0;c=i;cFc(a,b);Guc(b,a+136|0,0);Mdd(b);i=c;return}function zuc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;dFc(a,b);f=a+140|0;g=c[f>>2]|0;h=a+136|0;a=c[h>>2]|0;j=g-a>>2;c[e>>2]=j;k=b+12|0;l=c[k>>2]|0;m=l+4|0;if(m>>>0<(c[b+20>>2]|0)>>>0){c[l>>2]=j;c[k>>2]=m;n=a;o=g}else{Gid(k,e,4);n=c[h>>2]|0;o=c[f>>2]|0}if((n|0)==(o|0)){Tdd(b);i=d;return}else p=n;do{q9b(p,b);p=p+4|0}while((p|0)!=(o|0));Tdd(b);i=d;return}function Auc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;eFc(b,d);f=c[b+136>>2]|0;g=c[b+140>>2]|0;if((f|0)==(g|0)){i=e;return}b=d+12|0;h=d+28|0;j=d+32|0;d=f;do{f=c[b>>2]|0;k=xo[c[c[f>>2]>>2]&2047](f,c[d>>2]|0,c[h>>2]|0)|0;if(a[j>>0]|0)c[d>>2]=k;d=d+4|0}while((d|0)!=(g|0));i=e;return}function Buc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;while(1){if(l)c[l>>2]=0;k=k+-1|0;if(!k)break;else l=l+4|0}c[g>>2]=h+(b<<2);i=d;return}h=c[a>>2]|0;l=(j-h>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=h;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=c[g>>2]|0;l=f-j>>2;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=c[g>>2]|0;q=1073741823;r=f-j>>2;s=f;t=11}if((t|0)==11){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;r=b;q=s;while(1){if(q)c[q>>2]=0;r=r+-1|0;if(!r)break;else q=q+4|0}q=n+(m<<2)|0;m=n+(o+b<<2)|0;if((p|0)==(h|0)){u=s;v=h}else{b=p+-4-j|0;j=p;p=s;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(h|0))break;else p=p+-4|0}u=n+(o+~(b>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[g>>2]=m;c[e>>2]=q;if(!v){i=d;return}ACi(v);i=d;return}function Cuc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=594392;if((c[a+92>>2]|0)<=-1){EWb(a);i=b;return}f=a+80|0;g=c[f>>2]|0;c[e>>2]=c[a+84>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;EWb(a);i=b;return}function Duc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(148,e,1,16,3653512,10)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];ouc(f,e,b);i=d;return f|0}function Euc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}Nuc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,614680,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;g9b(r,a);t=r+4|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,614680,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else g9b(m,a);sdd(a)}m=m+4|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function Fuc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}Nuc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{k9b(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function Guc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;Nuc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{n9b(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function Huc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=587632;d=c[a+136>>2]|0;if(d){e=a+140|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d)}c[a>>2]=594568;tEc(a);Cuc(a);i=b;return}function Iuc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=587632;d=c[a+136>>2]|0;if(d){e=a+140|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d)}c[a>>2]=594568;tEc(a);Cuc(a);ACi(a);i=b;return}function Juc(a){a=a|0;return 4}function Kuc(a){a=a|0;return c[a+112>>2]|0}function Luc(a){a=a|0;return c[a+116>>2]|0}function Muc(b){b=b|0;return (a[b+96>>0]|0)!=0|0}function Nuc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d;l=a+4|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;p=m-o>>2;if(p>>>0>=b>>>0){if(p>>>0<=b>>>0){i=d;return}q=n+(b<<2)|0;c[k>>2]=0;r=k+4|0;c[r>>2]=0;s=k+8|0;c[s>>2]=0;t=b<<2;u=t>>2;if(u){if(u>>>0>1073741823)vxi(k);v=xCi(t)|0;c[r>>2]=v;c[k>>2]=v;w=v+(u<<2)|0;c[s>>2]=w;if(!b){x=v;y=v;z=w}else{u=t+-4|0;t=n;A=v;while(1){c[A>>2]=c[t>>2];t=t+4|0;if((t|0)==(q|0))break;else A=A+4|0}A=v+((u>>>2)+1<<2)|0;c[r>>2]=A;x=v;y=A;z=w}}else{x=0;y=0;z=0}w=c[a>>2]|0;c[k>>2]=w;c[a>>2]=x;x=c[l>>2]|0;c[r>>2]=x;c[l>>2]=y;y=a+8|0;c[s>>2]=c[y>>2];c[y>>2]=z;if(!w){i=d;return}if((x|0)!=(w|0))c[r>>2]=x+(~((x+-4-w|0)>>>2)<<2);ACi(w);i=d;return}w=a+8|0;if(((c[w>>2]|0)-o>>2|0)==(b|0)){Buc(a,b-p|0);i=d;return}c[g>>2]=0;p=g+4|0;c[p>>2]=0;o=g+8|0;c[o>>2]=0;if(b){x=xCi(b<<2)|0;c[g>>2]=x;c[p>>2]=x;c[o>>2]=x+(b<<2)}c[h>>2]=n;c[j>>2]=m;c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];Ouc(g,f,e);e=c[p>>2]|0;f=c[g>>2]|0;j=e-f>>2;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<2)|0,(e|0)!=(h|0)):0){m=e+(~((e+-4-h|0)>>>2)<<2)|0;c[p>>2]=m;B=f;C=m}else{B=f;C=e}else{Buc(g,b-j|0);B=c[g>>2]|0;C=c[p>>2]|0}j=c[a>>2]|0;c[g>>2]=j;c[a>>2]=B;B=c[l>>2]|0;c[p>>2]=B;c[l>>2]=C;C=c[o>>2]|0;c[o>>2]=c[w>>2];c[w>>2]=C;if(!j){i=d;return}if((B|0)!=(j|0))c[p>>2]=B+(~((B+-4-j|0)>>>2)<<2);ACi(j);i=d;return}function Ouc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b>>2]|0;b=c[d>>2]|0;d=f;g=b-d>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>2>>>0){if(!k)m=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>1073741823)vxi(a);j=m-0|0;if(j>>2>>>0<536870911){m=j>>1;j=m>>>0<g>>>0?g:m;if(j>>>0>1073741823)vxi(a);else o=j}else o=1073741823;j=xCi(o<<2)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(o<<2);if((f|0)==(b|0)){i=e;return}o=(b+-4-d|0)>>>2;h=f;n=j;while(1){c[n>>2]=c[h>>2];h=h+4|0;if((h|0)==(b|0))break;else n=n+4|0}c[m>>2]=j+(o+1<<2);i=e;return}o=a+4|0;a=c[o>>2]|0;j=a-l>>2;if(g>>>0>j>>>0){p=f+(j<<2)|0;q=1}else{p=b;q=0}if((f|0)==(p|0))r=k;else{j=(p+-4-d|0)>>>2;d=k;g=f;while(1){c[d>>2]=c[g>>2];g=g+4|0;if((g|0)==(p|0))break;else d=d+4|0}r=k+(j+1<<2)|0}if(!q){if((a|0)==(r|0)){i=e;return}c[o>>2]=a+(~((a+-4-r|0)>>>2)<<2);i=e;return}if((p|0)==(b|0)){i=e;return}r=(b+-4-p|0)>>>2;q=a;j=p;while(1){if(q)c[q>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else q=q+4|0}c[o>>2]=a+(r+1<<2);i=e;return}function Puc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=0,n=Im,o=Im;b=i;i=i+224|0;d=b+220|0;e=b+24|0;f=b+8|0;h=b;j=Uuc(6)|0;if(!j){i=b;return}k=ea(+$Kc(jLc()|0));if(k>ea(9.0)&(a^1)){i=b;return}if(!(k<ea(2.5)))if(a){l=ea(1.0);m=8}else{n=ea(ea(1.0)-ea(ea(k+ea(-7.5))/ea(1.5)));m=7}else{n=ea(k+ea(-1.5));m=7}if((m|0)==7)if(n<ea(0.0))o=ea(0.0);else{l=n;m=8}if((m|0)==8){m=l>ea(1.0);o=m?ea(1.0):l}l=ea(ea(o*ea(o*ea(3.0)))+ea(o*ea(o*ea(o*ea(-2.0)))));m=n8b()|0;t1b(e,ync()|0);m1b();o=ea(ea(l*ea(128.0))+ea(ea(ea(1.0)-l)*ea(0.0)));g[f>>2]=ea(ea(g[m+64>>2])-o);g[f+8>>2]=ea(128.0);g[f+4>>2]=ea(62.0);g[f+12>>2]=ea(-58.0);c[h>>2]=-2139062144;c[d+0>>2]=c[h+0>>2];yYb(f,j,d,0);u1b(e);i=b;return}function Quc(){var a=0,b=0;a=i;b=+Ype()>=0.0+4.5;i=a;return b|0}function Ruc(){var b=0,c=0,d=0;b=i;c=NOc()|0;if(!(a[c+96>>0]|0))if(!(a[c+100>>0]|0))d=1;else d=(a[c+93>>0]|0)==0;else d=0;i=b;return d|0}function Suc(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=Im,u=0,v=0,w=Im,x=0,y=Im,z=Im,A=Im,B=0,C=0,D=Im;d=i;i=i+320|0;e=d+12|0;f=d+40|0;h=d+96|0;j=d;k=d+80|0;l=d+108|0;m=d+304|0;n=d+72|0;o=d+56|0;p=d+16|0;q=d+24|0;r=d+76|0;s=+Ype()-0.0;t=ea(s-(b?0.0:4.5));if(t>ea(.400000006)&(b^1)){i=d;return}rri(f,610424,15);u=nUc(mUc()|0,28,f)|0;xri(f);if(!u){i=d;return}rri(h,610440,16);f=nUc(mUc()|0,28,h)|0;xri(h);if(!f){i=d;return}rri(j,610464,19);h=nUc(mUc()|0,28,j)|0;xri(j);if(!h){i=d;return}j=n8b()|0;v=j+64|0;w=ea(ea(g[v>>2])*ea(.5));x=j+68|0;y=ea(ea(g[x>>2])*ea(.5));j=ync()|0;do if(b){ko[c[(c[j>>2]|0)+500>>2]&4095](j);if(mo[c[(c[j>>2]|0)+516>>2]&4095](j)|0){g[k>>2]=ea(.301960796);g[k+4>>2]=ea(.301960796);g[k+8>>2]=ea(.301960796);g[k+12>>2]=ea(0.0);Uvc(7,k,ea(1.0),0,c[158074]|0);break}mo[c[(c[j>>2]|0)+520>>2]&4095](j)|0;i=d;return}while(0);t1b(l,ync()|0);m1b();if(b){z=ea(ea(t+ea(-3.0))/ea(1.5));if(z<ea(0.0))A=ea(0.0);else{k=z>ea(1.0);A=k?ea(1.0):z}z=ea(ea(A*ea(A*ea(3.0)))+ea(A*ea(A*ea(A*ea(-2.0)))));A=ea(ea(z*ea(0.0))+ea(ea(1.0)-z));z=ea(y+ea(-75.0));g[m>>2]=ea(w+ea(-75.0));g[m+8>>2]=ea(150.0);g[m+4>>2]=z;g[m+12>>2]=ea(-66.0);a[n>>0]=-1;a[n+1>>0]=-1;a[n+2>>0]=-1;k=A<ea(0.0);z=k?ea(0.0):A;k=z>ea(1.0);B=~~ea(ea(z*ea(255.0))+ea(.5))>>>0&255;C=k?-1:B;a[n+3>>0]=C;c[e+0>>2]=c[n+0>>2];yYb(m,f,e,0);z=ea(y+ea(65.0));g[o>>2]=ea(w+ea(-77.0));g[o+8>>2]=ea(154.0);g[o+4>>2]=z;g[o+12>>2]=ea(-130.0);a[p>>0]=-1;a[p+1>>0]=-1;a[p+2>>0]=-1;a[p+3>>0]=C;c[e+0>>2]=c[p+0>>2];yYb(o,u,e,0)}else{z=ea(t/ea(.400000006));if(z<ea(0.0))D=ea(0.0);else{u=z>ea(1.0);D=u?ea(1.0):z}z=ea(ea(D*ea(D*ea(3.0)))+ea(D*ea(D*ea(D*ea(-2.0)))));D=ea(ea(z*ea(0.0))+ea(ea(ea(1.0)-z)*ea(.5)));z=ea(ea(g[v>>2])+ea(10.0));t=ea(ea(g[x>>2])+ea(10.0));g[q>>2]=ea(0.0);g[q+8>>2]=z;g[q+4>>2]=ea(0.0);g[q+12>>2]=t;a[r>>0]=-128;a[r+1>>0]=-128;a[r+2>>0]=-128;x=D<ea(0.0);t=x?ea(0.0):D;x=t>ea(1.0);v=~~ea(ea(t*ea(255.0))+ea(.5))>>>0&255;a[r+3>>0]=x?-1:v;c[e+0>>2]=c[r+0>>2];yYb(q,h,e,0)}if(b){ko[c[(c[j>>2]|0)+504>>2]&4095](j);In[c[(c[j>>2]|0)+512>>2]&4095](j,0)}u1b(l);i=d;return}function Tuc(){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=Im;b=i;c=EVc()|0;d=(a[(NOc()|0)+96>>0]|0)==0;e=(a[(NOc()|0)+98>>0]|0)==0;f=(a[(NOc()|0)+97>>0]|0)==0;g=(a[(NOc()|0)+100>>0]|0)==0;if(!(a[(NOc()|0)+93>>0]|0))h=FVc(c)|0;else h=0;c=(a[(NOc()|0)+104>>0]|0)==0;if(h)Puc(0);if(c)j=ea(3.0);else j=ea((Vuc(3,ea(3.0))|0)+6|0);do if(d){if(!e){Vuc(1,j)|0;break}if(!f){Vuc(2,j)|0;break}if(g)Vuc(0,j)|0}while(0);g=NOc()|0;if(a[g+96>>0]|0){i=b;return}if((a[g+100>>0]|0)!=0?(a[g+93>>0]|0)!=0:0){i=b;return}Suc(0);i=b;return}function Uuc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=587996+(a<<3)|0;f=c[e>>2]|0;if(f){g=f;i=b;return g|0}f=c[587992+(a<<3)>>2]|0;rri(d,f,SEi(f|0)|0);c[e>>2]=nUc(mUc()|0,28,d)|0;xri(d);g=c[e>>2]|0;i=b;return g|0}function Vuc(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im;d=i;i=i+224|0;e=d+220|0;f=d+24|0;h=d+8|0;j=d;k=Uuc(a)|0;if(!k){l=0;i=d;return l|0}a=n8b()|0;t1b(f,ync()|0);m1b();m=ea(mo[c[(c[k>>2]|0)+104>>2]&4095](k)|0);n=ea(0-(mo[c[(c[k>>2]|0)+108>>2]&4095](k)|0)|0);o=ea(ea(ea(g[a+64>>2])-m)+ea(-1.0));if(b<ea(0.0)){p=ea(b+ea(1.0));q=ea(p+ea(n+ea(g[a+68>>2])))}else q=b;b=ea(q-n);g[h>>2]=o;g[h+8>>2]=m;g[h+4>>2]=b;g[h+12>>2]=n;c[j>>2]=-2139062144;c[e+0>>2]=c[j+0>>2];yYb(h,k,e,0);e=mo[c[(c[k>>2]|0)+108>>2]&4095](k)|0;u1b(f);l=e;i=d;return l|0}function Wuc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=iec(b)|0;j=(h|0)==0?0:h+-1|0;h=ync()|0;if(_n[c[(c[h>>2]|0)+232>>2]&4095](h,4)|0)k=1;else k=_n[c[(c[h>>2]|0)+232>>2]&4095](h,5)|0;gec(g,b,j>>>0<e>>>0?j:e,k);Nn[c[(c[h>>2]|0)+304>>2]&31](h,c[a>>2]|0,a+8|0,c[a+4>>2]|0,g,1,c[a+40>>2]|0,d);i=f;return}function Xuc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;e=i;i=i+80|0;g=e+48|0;h=e;sec(h,b,c[a+4>>2]|0,f);if(!(c[h>>2]|0)){i=e;return}f=iec(b)|0;j=(f|0)==0?0:f+-1|0;f=ync()|0;if(_n[c[(c[f>>2]|0)+232>>2]&4095](f,4)|0)k=1;else k=_n[c[(c[f>>2]|0)+232>>2]&4095](f,5)|0;gec(g,b,j>>>0<d>>>0?j:d,k);Nn[c[(c[f>>2]|0)+304>>2]&31](f,c[h>>2]|0,h+8|0,c[h+4>>2]|0,g,1,c[h+40>>2]|0,a);i=e;return}function Yuc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;if(c[(ync()|0)+5980>>2]|0){Xuc(a,b,0,0,0);i=e;return}h=Mnc(ync()|0)|0;j=b+28|0;b=c[j>>2]|0;k=((c[b+112>>2]|0)-(c[b+108>>2]|0)|0)>>>1;l=c[b+100>>2]|0;b=_ic(d,575992,0)|0;if(!(gn[c[(c[h>>2]|0)+8>>2]&127](h,b,l,k,0,f,g)|0)){i=e;return}l=c[j>>2]|0;YEi(c[f>>2]|0,c[l+92>>2]|0,da(c[l+100>>2]|0,b)|0)|0;YEi(c[g>>2]|0,c[(c[j>>2]|0)+108>>2]|0,k<<1|0)|0;co[c[(c[h>>2]|0)+12>>2]&2047](h,c[(c[j>>2]|0)+100>>2]|0,k);k=c[(c[h>>2]|0)+16>>2]|0;j=qic(tic(uic()|0,d)|0,d,0)|0;co[k&2047](h,a,j);i=e;return}function Zuc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0;f=i;i=i+64|0;h=f;GMc(d,h);g[h+48>>2]=ea(g[c>>2]);g[h+52>>2]=ea(g[c+4>>2]);g[h+56>>2]=ea(g[c+8>>2]);$uc(a,b,h,e,0);i=f;return}function _uc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;$uc(a,b,c,d,1);i=e;return}function $uc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+144|0;h=g+72|0;j=g+64|0;k=g;l=n8b()|0;m=c[l>>2]|0;if(!m)n=0;else{c[j>>2]=m;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(h,m,j);o=c[h>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){q=p+(c[m+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0)r=m;else s=10}else s=10;if((s|0)==10)r=hQb(c[l>>2]|0)|0;n=r}r=ync()|0;l=h+0|0;s=(mo[c[(c[r>>2]|0)+120>>2]&4095](r)|0)+0|0;m=l+64|0;do{c[l>>2]=c[s>>2];l=l+4|0;s=s+4|0}while((l|0)<(m|0));l=k+0|0;s=(mo[c[(c[r>>2]|0)+116>>2]&4095](r)|0)+0|0;m=l+64|0;do{c[l>>2]=c[s>>2];l=l+4|0;s=s+4|0}while((l|0)<(m|0));if(n){s=c[(c[r>>2]|0)+104>>2]|0;l=D$b(n)|0;In[s&4095](r,l)}t8b(d,f);if((e|0)==-1){f=iec(b)|0;if((f|0)>0){d=0;do{Xuc(a,b,d,0,0);d=d+1|0}while((d|0)!=(f|0))}}else Xuc(a,b,e,0,0);In[c[(c[r>>2]|0)+104>>2]&4095](r,h);In[c[(c[r>>2]|0)+100>>2]&4095](r,k);i=g;return}function avc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=c[b+56>>2]|0;a:do if(f){g=c[b+48>>2]|0;h=c[b+16>>2]|0;j=c[b>>2]|0;k=0;while(1){l=c[g+(k*12|0)>>2]|0;m=c[h+(l*56|0)>>2]|0;k=k+1|0;if((c[j+(m*40|0)>>2]|0)==(d|0)){n=l;o=m;break}if(k>>>0>=f>>>0)break a}if((n|0)>=0?(c[b+24>>2]|0)>>>0>n>>>0:0)p=j+(o*40|0)|0;else p=0;k=p+24|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];i=e;return}while(0);p=c[b+68>>2]|0;o=c[b+72>>2]|0;n=o-p>>3;if(!n)q=p;else{f=p;p=n;while(1){n=(p|0)/2|0;if((c[f+(n<<3)>>2]|0)<(d|0)){r=f+(n+1<<3)|0;s=p+-1-n|0}else{r=f;s=n}if(!s){q=r;break}else{f=r;p=s}}}if(((q|0)!=(o|0)?(s=(c[q>>2]|0)>(d|0)?o:q,(s|0)!=(o|0)):0)?(o=c[s+4>>2]|0,s=c[b>>2]|0,(s+(o*40|0)|0)!=0):0){b=s+(o*40|0)+24|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=e;return};c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=e;return}function bvc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b;e=c[a+8>>2]|0;if(!e){f=a+64|0;dvc(f);i=b;return}g=d+4|0;h=a+72|0;j=a+76|0;k=a+68|0;l=0;do{c[d>>2]=c[(c[a>>2]|0)+(l*40|0)>>2];c[g>>2]=l;m=c[h>>2]|0;if((m|0)==(c[j>>2]|0))cvc(k,d);else{if(!m)n=0;else{o=d;p=c[o+4>>2]|0;q=m;c[q>>2]=c[o>>2];c[q+4>>2]=p;n=c[h>>2]|0}c[h>>2]=n+8}l=l+1|0}while((l|0)!=(e|0));f=a+64|0;dvc(f);i=b;return}function cvc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>3)+1|0;if(g>>>0>536870911)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>3>>>0<268435455){l=k>>2;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>3;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=536870911;r=l>>3;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<3)|0;o=r;p=s}s=n+(o<<3)|0;if(s){r=b;b=c[r+4>>2]|0;q=s;c[q>>2]=c[r>>2];c[q+4>>2]=b}YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<3);c[h>>2]=n+(m<<3);if(!f){i=d;return}ACi(f);i=d;return}function dvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;k=b+4|0;l=c[k>>2]|0;m=b+8|0;n=c[m>>2]|0;if((l|0)==(n|0)){i=d;return}a[j>>0]=a[b>>0]|0;b=n-l|0;o=b>>3;if((b|0)>0){b=o;while(1){p=yCi(b<<3,3667768)|0;if(p){q=p;r=b;break}if((b|0)>1)b=(b|0)/2|0;else{q=0;r=0;break}}s=q;t=r}else{s=0;t=0}c[g>>2]=l;c[h>>2]=n;c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];evc(f,e,j,o,s,t);if(s)ACi(s);s=c[k>>2]|0;k=c[m>>2]|0;a:do if((s|0)==(k|0))u=s;else{t=s;while(1){o=t+8|0;if((o|0)==(k|0)){v=23;break}j=c[t>>2]|0;if((j|0)<(c[o>>2]|0))t=o;else{w=t;x=o;y=j;break}}if((v|0)==23){i=d;return}if((w|0)==(k|0)){i=d;return}else{z=w;A=y;B=x;C=x;D=w}while(1){t=c[z+8>>2]|0;if((A|0)<(t|0)){c[B>>2]=t;c[B+4>>2]=c[C+4>>2];E=B+8|0}else E=B;t=z+16|0;j=D+8|0;if((t|0)==(k|0)){u=E;break a}o=C;A=c[j>>2]|0;B=E;C=t;D=j;z=o}}while(0);if((u|0)==(k|0)){i=d;return}z=u;u=z-s>>3;D=s+(u<<3)|0;C=s+(u+(k-z>>3)<<3)|0;if((C|0)==(k|0))F=D;else{z=k+-8|0;E=C;B=D;while(1){c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];E=E+8|0;if((E|0)==(k|0))break;else B=B+8|0}F=s+(u+1+((z-C|0)>>>3)<<3)|0}if((k|0)==(F|0)){i=d;return}c[m>>2]=k+(~((k+-8-F|0)>>>3)<<3);i=d;return}function evc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+64|0;j=h+24|0;k=h+20|0;l=h+44|0;m=h+36|0;n=h+32|0;o=h+40|0;p=h+48|0;q=h+52|0;r=h+8|0;s=h+4|0;t=h+28|0;u=h+12|0;v=h;w=h+16|0;if((e|0)==2){x=c[b>>2]|0;y=x+-8|0;c[b>>2]=y;z=c[a>>2]|0;A=c[y>>2]|0;B=c[z>>2]|0;if((A|0)>=(B|0)){i=h;return}c[z>>2]=A;c[y>>2]=B;B=z+4|0;z=x+-4|0;x=c[B>>2]|0;c[B>>2]=c[z>>2];c[z>>2]=x;i=h;return}else if((e|0)==1|(e|0)==0){i=h;return}else{if((e|0)<1){x=c[a>>2]|0;z=c[b>>2]|0;if((x|0)==(z|0)){i=h;return}B=x+8|0;if((B|0)==(z|0)){i=h;return}else{C=B;D=x}while(1){B=C;y=c[B>>2]|0;A=c[B+4>>2]|0;a:do if((C|0)==(x|0))E=x;else{B=C;while(1){F=B;B=B+-8|0;G=c[B>>2]|0;if((y|0)>=(G|0)){E=F;break a}c[F>>2]=G;c[F+4>>2]=c[F+-4>>2];if((B|0)==(x|0)){E=x;break}}}while(0);c[E>>2]=y;c[E+4>>2]=A;B=D+16|0;if((B|0)==(z|0))break;else{F=C;C=B;D=F}}i=h;return}D=(e|0)/2|0;C=c[a>>2]|0;a=C+(D<<3)|0;if((e|0)>(g|0)){c[q>>2]=C;c[r>>2]=a;c[k+0>>2]=c[q+0>>2];c[j+0>>2]=c[r+0>>2];evc(k,j,d,D,f,g);c[s>>2]=a;r=c[b>>2]|0;c[t>>2]=r;q=e-D|0;c[k+0>>2]=c[s+0>>2];c[j+0>>2]=c[t+0>>2];evc(k,j,d,q,f,g);c[u>>2]=C;c[v>>2]=a;c[w>>2]=r;c[l+0>>2]=c[u+0>>2];c[k+0>>2]=c[v+0>>2];c[j+0>>2]=c[w+0>>2];gvc(l,k,j,d,D,q,f,g);i=h;return}c[m>>2]=C;c[n>>2]=a;c[k+0>>2]=c[m+0>>2];c[j+0>>2]=c[n+0>>2];fvc(k,j,d,D,f);c[o>>2]=a;c[p>>2]=c[b>>2];b=f+(D<<3)|0;c[k+0>>2]=c[o+0>>2];c[j+0>>2]=c[p+0>>2];fvc(k,j,d,e-D|0,b);D=f+(e<<3)|0;b:do if((e+1|0)>>>0<3){H=b;I=C}else{d=b;j=f;k=C;while(1){if((d|0)==(D|0)){J=j;K=k;break}p=c[d>>2]|0;o=c[j>>2]|0;if((p|0)<(o|0)){c[k>>2]=p;L=d;M=d+8|0;N=j}else{c[k>>2]=o;L=j;M=d;N=j+8|0}c[k+4>>2]=c[L+4>>2];o=k+8|0;if((N|0)==(b|0)){H=M;I=o;break b}else{d=M;j=N;k=o}}if((J|0)==(b|0)){i=h;return}else{O=J;P=K}while(1){c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];O=O+8|0;if((O|0)==(b|0))break;else P=P+8|0}i=h;return}while(0);if((H|0)==(D|0)){i=h;return}else{Q=H;R=I}while(1){c[R>>2]=c[Q>>2];c[R+4>>2]=c[Q+4>>2];Q=Q+8|0;if((Q|0)==(D|0))break;else R=R+8|0}i=h;return}}function fvc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;if((e|0)==1){if(!f){i=g;return}o=c[a>>2]|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;i=g;return}else if((e|0)==2){p=(c[b>>2]|0)+-8|0;c[b>>2]=p;q=c[a>>2]|0;o=(f|0)==0;if((c[p>>2]|0)<(c[q>>2]|0)){if(!o){r=p;s=c[r+4>>2]|0;t=f;c[t>>2]=c[r>>2];c[t+4>>2]=s}s=q;t=c[s+4>>2]|0;r=f+8|0;c[r>>2]=c[s>>2];c[r+4>>2]=t;i=g;return}else{if(!o){o=q;q=c[o+4>>2]|0;t=f;c[t>>2]=c[o>>2];c[t+4>>2]=q}q=p;p=c[q+4>>2]|0;t=f+8|0;c[t>>2]=c[q>>2];c[t+4>>2]=p;i=g;return}}else if(!e){i=g;return}else{if((e|0)<9){p=c[a>>2]|0;t=c[b>>2]|0;if((p|0)==(t|0)){i=g;return}if(!f)u=0;else{q=p;o=c[q+4>>2]|0;r=f;c[r>>2]=c[q>>2];c[r+4>>2]=o;u=f}o=p+8|0;if((o|0)==(t|0)){i=g;return}else{v=o;w=p;x=u}while(1){u=x;x=x+8|0;if((c[w+8>>2]|0)<(c[u>>2]|0)){p=u;o=c[p+4>>2]|0;r=x;c[r>>2]=c[p>>2];c[r+4>>2]=o;a:do if((u|0)==(f|0))y=f;else{o=u;while(1){r=o;o=o+-8|0;p=c[o>>2]|0;if((c[v>>2]|0)>=(p|0)){y=r;break a}c[r>>2]=p;c[r+4>>2]=c[r+-4>>2];if((o|0)==(f|0)){y=f;break}}}while(0);c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2]}else{u=v;o=c[u+4>>2]|0;r=x;c[r>>2]=c[u>>2];c[r+4>>2]=o}o=w+16|0;if((o|0)==(t|0))break;else{r=v;v=o;w=r}}i=g;return}w=(e|0)/2|0;v=c[a>>2]|0;a=v+(w<<3)|0;c[k>>2]=v;c[l>>2]=a;c[j+0>>2]=c[k+0>>2];c[h+0>>2]=c[l+0>>2];evc(j,h,d,w,f,w);c[m>>2]=a;l=c[b>>2]|0;c[n>>2]=l;b=e-w|0;c[j+0>>2]=c[m+0>>2];c[h+0>>2]=c[n+0>>2];evc(j,h,d,b,f+(w<<3)|0,b);b:do if((e+1|0)>>>0<3){z=f;A=v}else{b=f;w=a;d=v;while(1){if((w|0)==(l|0)){B=b;C=d;break}h=(b|0)==0;if((c[w>>2]|0)<(c[d>>2]|0)){if(!h){j=w;n=c[j+4>>2]|0;m=b;c[m>>2]=c[j>>2];c[m+4>>2]=n}D=d;E=w+8|0}else{if(!h){h=d;n=c[h+4>>2]|0;m=b;c[m>>2]=c[h>>2];c[m+4>>2]=n}D=d+8|0;E=w}n=b+8|0;if((D|0)==(a|0)){z=n;A=E;break b}else{b=n;w=E;d=D}}if((C|0)==(a|0)){i=g;return}else{F=B;G=C}while(1){if(F){d=G;w=c[d+4>>2]|0;b=F;c[b>>2]=c[d>>2];c[b+4>>2]=w}G=G+8|0;if((G|0)==(a|0))break;else F=F+8|0}i=g;return}while(0);if((A|0)==(l|0)){i=g;return}else{H=z;I=A}while(1){if(H){A=I;z=c[A+4>>2]|0;F=H;c[F>>2]=c[A>>2];c[F+4>>2]=z}I=I+8|0;if((I|0)==(l|0))break;else H=H+8|0}i=g;return}}function gvc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;k=i;i=i+48|0;l=k+4|0;m=k+16|0;n=k+36|0;o=k;p=k+32|0;q=k+40|0;r=k+44|0;s=k+24|0;t=k+20|0;u=k+8|0;v=k+12|0;w=k+28|0;if((g|0)==0|(f|0)==0){i=k;return}x=g;g=f;f=c[b>>2]|0;a:while(1){y=c[f>>2]|0;z=g;A=c[a>>2]|0;while(1){B=c[A>>2]|0;if((y|0)<(B|0)){C=z;D=A;E=A;F=B;break}A=A+8|0;c[a>>2]=A;z=z+-1|0;if(!z){G=36;break a}}if(!((C|0)>(j|0)&(x|0)>(j|0))){H=x;I=C;J=D;K=f;G=7;break}if((C|0)<(x|0)){z=(x|0)/2|0;A=f+(z<<3)|0;B=D;L=f-B>>3;if(!L)M=D;else{N=c[A>>2]|0;O=D;P=L;while(1){L=(P|0)/2|0;if((N|0)<(c[O+(L<<3)>>2]|0)){Q=O;R=L}else{Q=O+(L+1<<3)|0;R=P+-1-L|0}if(!R){M=Q;break}else{O=Q;P=R}}}S=M;T=A;U=M-B>>3;V=z}else{if((C|0)==1){W=D;X=E;Y=F;Z=f;_=f;$=y;G=16;break}P=(C|0)/2|0;O=D+(P<<3)|0;N=f;L=(c[d>>2]|0)-N>>3;if(!L)aa=f;else{ba=c[O>>2]|0;ca=f;da=L;while(1){L=(da|0)/2|0;if((c[ca+(L<<3)>>2]|0)<(ba|0)){ea=ca+(L+1<<3)|0;fa=da+-1-L|0}else{ea=ca;fa=L}if(!fa){aa=ea;break}else{ca=ea;da=fa}}}S=O;T=aa;U=P;V=aa-N>>3}da=C-U|0;ca=x-V|0;b:do if((S|0)!=(f|0))if((f|0)!=(T|0)){ba=c[S>>2]|0;c[S>>2]=y;c[f>>2]=ba;ba=S+4|0;z=f+4|0;B=c[ba>>2]|0;c[ba>>2]=c[z>>2];c[z>>2]=B;B=S+8|0;z=f+8|0;if((z|0)==(T|0)){ga=B;ha=f}else{ba=B;B=f;A=z;z=S;L=f;while(1){ia=(ba|0)==(B|0)?A:B;ja=z+8|0;ka=L+8|0;la=c[ja>>2]|0;c[ja>>2]=c[ka>>2];c[ka>>2]=la;la=z+12|0;ka=L+12|0;ja=c[la>>2]|0;c[la>>2]=c[ka>>2];c[ka>>2]=ja;ja=z+16|0;ka=L+16|0;if((ka|0)==(T|0)){ga=ja;ha=ia;break}else{la=A;ma=ba;ba=ja;B=ia;A=ka;L=la;z=ma}}}if((ga|0)==(ha|0))na=ha;else{z=ha;L=ga;A=ha;while(1){B=L;ba=A;while(1){ma=c[B>>2]|0;c[B>>2]=c[ba>>2];c[ba>>2]=ma;ma=B+4|0;la=ba+4|0;ka=c[ma>>2]|0;c[ma>>2]=c[la>>2];c[la>>2]=ka;B=B+8|0;ka=ba+8|0;la=(B|0)==(z|0);if((ka|0)!=(T|0)){oa=B;pa=ka;qa=la;break}if(la){na=ga;break b}else ba=z}z=qa?pa:z;L=oa;A=pa}}}else na=S;else na=T;while(0);c[b>>2]=na;if((V+U|0)<(ca+da|0)){c[r>>2]=D;c[s>>2]=S;c[t>>2]=na;c[n+0>>2]=c[r+0>>2];c[m+0>>2]=c[s+0>>2];c[l+0>>2]=c[t+0>>2];gvc(n,m,l,e,U,V,h,j);c[a>>2]=na;ra=da;sa=ca;ta=T}else{c[u>>2]=na;c[v>>2]=T;c[w>>2]=c[d>>2];c[n+0>>2]=c[u+0>>2];c[m+0>>2]=c[v+0>>2];c[l+0>>2]=c[w+0>>2];gvc(n,m,l,e,da,ca,h,j);c[d>>2]=na;ra=U;sa=V;ta=S}c[b>>2]=ta;if((sa|0)==0|(ra|0)==0){G=36;break}else{x=sa;g=ra;f=ta}}if((G|0)==7){c[o>>2]=J;c[p>>2]=K;c[q>>2]=c[d>>2];c[n+0>>2]=c[o+0>>2];c[m+0>>2]=c[p+0>>2];c[l+0>>2]=c[q+0>>2];hvc(n,m,l,e,I,H,h);i=k;return}else if((G|0)==16){c[X>>2]=$;c[_>>2]=Y;Y=W+4|0;W=Z+4|0;Z=c[Y>>2]|0;c[Y>>2]=c[W>>2];c[W>>2]=Z;i=k;return}else if((G|0)==36){i=k;return}}function hvc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;if((f|0)>(g|0)){g=c[b>>2]|0;f=g;j=c[d>>2]|0;if((g|0)==(j|0)){k=g;l=h}else{m=((j+-8-f|0)>>>3)+1|0;n=g;o=h;while(1){if(o){p=n;q=c[p+4>>2]|0;r=o;c[r>>2]=c[p>>2];c[r+4>>2]=q}n=n+8|0;if((n|0)==(j|0))break;else o=o+8|0}k=j;l=h+(m<<3)|0}m=c[a>>2]|0;j=l;a:do if((g|0)==(m|0)){s=j;t=k}else{o=j;n=f;q=l;r=g;p=k;u=g;while(1){if((o|0)==(h|0)){v=p;w=u;break}x=c[q+-8>>2]|0;y=c[r+-8>>2]|0;z=p+-8|0;if((x|0)<(y|0)){c[z>>2]=y;y=r+-8|0;A=o;B=y;C=r;D=q;E=y}else{c[z>>2]=x;x=q+-8|0;A=x;B=n;C=q;D=x;E=r}c[p+-4>>2]=c[C+-4>>2];x=p+-8|0;u=B;if((u|0)==(m|0)){s=A;t=x;break a}else{o=A;n=B;q=D;r=E;p=x}}if((w|0)==(m|0)){i=e;return}else{F=w;G=v}while(1){c[G+-8>>2]=c[F+-8>>2];c[G+-4>>2]=c[F+-4>>2];F=F+-8|0;if((F|0)==(m|0))break;else G=G+-8|0}i=e;return}while(0);G=s;if((G|0)==(h|0)){i=e;return}else{H=G;I=t}while(1){c[I+-8>>2]=c[H+-8>>2];c[I+-4>>2]=c[H+-4>>2];H=H+-8|0;if((H|0)==(h|0))break;else I=I+-8|0}i=e;return}else{I=c[a>>2]|0;a=c[b>>2]|0;b:do if((I|0)!=(a|0)){b=((a+-8-I|0)>>>3)+1|0;H=I;t=h;while(1){if(t){G=H;s=c[G+4>>2]|0;m=t;c[m>>2]=c[G>>2];c[m+4>>2]=s}H=H+8|0;if((H|0)==(a|0))break;else t=t+8|0}t=h+(b<<3)|0;H=c[d>>2]|0;if((t|0)==(h|0)){J=a;K=I;L=H}else{s=a;m=h;G=I;while(1){if((s|0)==(H|0)){M=G;N=m;break}F=c[s>>2]|0;v=c[m>>2]|0;if((F|0)<(v|0)){c[G>>2]=F;O=s;P=s+8|0;Q=m}else{c[G>>2]=v;O=m;P=s;Q=m+8|0}c[G+4>>2]=c[O+4>>2];v=G+8|0;if((Q|0)==(t|0)){J=P;K=v;L=H;break b}else{s=P;m=Q;G=v}}if((N|0)==(t|0)){i=e;return}else{R=N;S=M}while(1){c[S>>2]=c[R>>2];c[S+4>>2]=c[R+4>>2];R=R+8|0;if((R|0)==(t|0))break;else S=S+8|0}i=e;return}}else{J=I;K=I;L=c[d>>2]|0}while(0);if((J|0)==(L|0)){i=e;return}else{T=J;U=K}while(1){c[U>>2]=c[T>>2];c[U+4>>2]=c[T+4>>2];T=T+8|0;if((T|0)==(L|0))break;else U=U+8|0}i=e;return}}function ivc(b,c,e,f,g,h){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+48|0;k=j;l=((e|0)/4|0)+((e&3|0)!=0&1)|0;e=((f|0)/4|0)+((f&3|0)!=0&1)|0;f=g<<2;if((e|0)<=0){i=j;return}m=(l|0)>0;n=~g;o=0;p=~h;while(1){q=(p|0)>-5?~p:4;if(m){r=da(o,l)|0;s=o<<2;t=(h-s|0)>0;u=0;v=n;while(1){w=(v|0)>-5?~v:4;x=u+r<<3;y=cFi(d[c+x>>0]|0|0,0,8)|0;z=cFi(d[c+(x|1)>>0]|0|y|0,H|0,8)|0;y=cFi(z|(d[c+(x|2)>>0]|0)|0,H|0,8)|0;z=cFi(y|(d[c+(x|3)>>0]|0)|0,H|0,8)|0;y=cFi(z|(d[c+(x|4)>>0]|0)|0,H|0,8)|0;z=cFi(y|(d[c+(x|5)>>0]|0)|0,H|0,8)|0;y=cFi(z|(d[c+(x|6)>>0]|0)|0,H|0,8)|0;lvc(y|(d[c+(x|7)>>0]|0),H,k,0,0);x=u<<2;if(t){y=(g-x|0)>0;z=0;do{if(y){A=z<<2;B=da(f,z+s|0)|0;C=0;do{D=(C+A|0)*3|0;E=(C+x<<2)+B|0;a[b+E>>0]=a[k+D>>0]|0;a[b+(E|1)>>0]=a[k+(D+1)>>0]|0;a[b+(E|2)>>0]=a[k+(D+2)>>0]|0;a[b+(E|3)>>0]=-1;C=C+1|0}while((C|0)!=(w|0))}z=z+1|0}while((z|0)!=(q|0))}u=u+1|0;if((u|0)==(l|0))break;else v=v+4|0}}o=o+1|0;if((o|0)==(e|0))break;else p=p+4|0}i=j;return}function jvc(b,c,e,f,g,h){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+64|0;k=j+16|0;l=j;m=((e|0)/4|0)+((e&3|0)!=0&1)|0;e=((f|0)/4|0)+((f&3|0)!=0&1)|0;f=g<<2;if((e|0)<=0){i=j;return}n=(m|0)>0;o=~g;p=0;q=~h;while(1){r=(q|0)>-5?~q:4;if(n){s=da(p,m)|0;t=p<<2;u=(h-t|0)>0;v=0;w=o;while(1){x=(w|0)>-5?~w:4;y=v+s<<3;z=cFi(d[c+y>>0]|0|0,0,8)|0;A=cFi(d[c+(y|1)>>0]|0|z|0,H|0,8)|0;z=cFi(A|(d[c+(y|2)>>0]|0)|0,H|0,8)|0;A=cFi(z|(d[c+(y|3)>>0]|0)|0,H|0,8)|0;z=cFi(A|(d[c+(y|4)>>0]|0)|0,H|0,8)|0;A=cFi(z|(d[c+(y|5)>>0]|0)|0,H|0,8)|0;z=cFi(A|(d[c+(y|6)>>0]|0)|0,H|0,8)|0;lvc(z|(d[c+(y|7)>>0]|0),H,k,l,1);y=v<<2;if(u){z=(g-y|0)>0;A=0;do{if(z){B=A<<2;C=da(f,A+t|0)|0;D=0;do{E=D+B|0;F=E*3|0;G=(D+y<<2)+C|0;a[b+G>>0]=a[k+F>>0]|0;a[b+(G|1)>>0]=a[k+(F+1)>>0]|0;a[b+(G|2)>>0]=a[k+(F+2)>>0]|0;a[b+(G|3)>>0]=a[l+E>>0]|0;D=D+1|0}while((D|0)!=(x|0))}A=A+1|0}while((A|0)!=(r|0))}v=v+1|0;if((v|0)==(m|0))break;else w=w+4|0}}p=p+1|0;if((p|0)==(e|0))break;else q=q+4|0}i=j;return}function kvc(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0;k=i;i=i+64|0;l=k+48|0;m=k;n=((f|0)/4|0)+((f&3|0)!=0&1)|0;f=((g|0)/4|0)+((g&3|0)!=0&1)|0;g=h<<2;if((f|0)<=0){i=k;return}o=(n|0)>0;p=~h;q=0;r=~j;while(1){s=(r|0)>-5?~r:4;if(o){t=da(q,n)|0;u=q<<2;v=(j-u|0)>0;w=0;x=p;while(1){y=(x|0)>-5?~x:4;z=w+t<<4;A=a[e+z>>0]|0;B=cFi(A&255|0,0,8)|0;C=a[e+(z|1)>>0]|0;D=cFi(C&255|B|0,H|0,8)|0;B=cFi(D|(d[e+(z|2)>>0]|0)|0,H|0,8)|0;D=cFi(B|(d[e+(z|3)>>0]|0)|0,H|0,8)|0;B=cFi(D|(d[e+(z|4)>>0]|0)|0,H|0,8)|0;D=cFi(B|(d[e+(z|5)>>0]|0)|0,H|0,8)|0;B=cFi(D|(d[e+(z|6)>>0]|0)|0,H|0,8)|0;D=H;E=B|(d[e+(z|7)>>0]|0);B=cFi(d[e+(z|8)>>0]|0|0,0,8)|0;F=cFi(d[e+(z|9)>>0]|0|B|0,H|0,8)|0;B=cFi(F|(d[e+(z|10)>>0]|0)|0,H|0,8)|0;F=cFi(B|(d[e+(z|11)>>0]|0)|0,H|0,8)|0;B=cFi(F|(d[e+(z|12)>>0]|0)|0,H|0,8)|0;F=cFi(B|(d[e+(z|13)>>0]|0)|0,H|0,8)|0;B=cFi(F|(d[e+(z|14)>>0]|0)|0,H|0,8)|0;lvc(B|(d[e+(z|15)>>0]|0),H,m,0,0);z=A&255;A=(C&255)>>>4&255;B=C&15;C=0;do{F=da(C,-3)|0;G=VEi(E|0,D|0,F+47|0)|0;I=VEi(E|0,D|0,F+46|0)|0;J=VEi(E|0,D|0,F+45|0)|0;F=(da(c[588048+(B<<5)+((I<<1&2|J&1|G<<2&4)<<2)>>2]|0,A)|0)+z|0;if((F|0)<0)K=0;else K=(F|0)>255?-1:F&255;a[l+((((C|0)%4|0)<<2)+((C|0)/4|0))>>0]=K;C=C+1|0}while((C|0)!=16);C=w<<2;if(v){z=(h-C|0)>0;A=0;do{if(z){B=A<<2;D=da(g,A+u|0)|0;E=0;do{F=E+B|0;G=F*3|0;J=(E+C<<2)+D|0;a[b+J>>0]=a[m+G>>0]|0;a[b+(J|1)>>0]=a[m+(G+1)>>0]|0;a[b+(J|2)>>0]=a[m+(G+2)>>0]|0;a[b+(J|3)>>0]=a[l+F>>0]|0;E=E+1|0}while((E|0)!=(y|0))}A=A+1|0}while((A|0)!=(s|0))}w=w+1|0;if((w|0)==(n|0))break;else x=x+4|0}}q=q+1|0;if((q|0)==(f|0))break;else r=r+4|0}i=k;return}function lvc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;j=i;i=i+32|0;k=j;l=j+20|0;m=j+22|0;n=j+24|0;o=j+12|0;p=j+8|0;q=j+16|0;r=VEi(b|0,e|0,59)|0;s=H;t=VEi(b|0,e|0,51)|0;u=H;v=t&31;w=VEi(b|0,e|0,43)|0;x=H;y=w&31;z=VEi(b|0,e|0,56)|0;A=H;B=z&7;C=((z&4|0)!=0?248:0)|B;D=VEi(b|0,e|0,48)|0;E=H;F=((D&4|0)!=0?248:0)|D&7;G=VEi(b|0,e|0,40)|0;I=H;J=((G&4|0)!=0?248:0)|G&7;K=0==0&(e&2|0)==0;do if(K&(h^1))L=0;else{if(((C<<24>>24)+r|0)>>>0<32){if(((F<<24>>24)+v|0)>>>0<32){M=((J<<24>>24)+y|0)>>>0<32?1:4;if(!(M&4)){L=M;break}M=VEi(b|0,e|0,49)|0;N=VEi(b|0,e|0,39)|0;O=VEi(b|0,e|0,55)|0;P=VEi(b|0,e|0,61)|0;Q=cFi(z|0,A|0,6)|0;R=Q&64;Q=(R|M&63)<<1|R>>>6;R=cFi(D|0,E|0,5)|0;M=cFi(w|0,x|0,3)|0;S=R&32|M&24;M=(S|N&7)<<2|S>>>4;S=VEi(b|0,e|0,33)|0;N=S&62;S=VEi(b|0,e|0,25)|0;R=S&127;S=VEi(b|0,e|0,19)|0;T=S&63;S=VEi(b|0,e|0,13)|0;U=S&63;S=VEi(b|0,e|0,6)|0;V=S&127;S=b&63;W=P&3|O&252;O=((N|e&1)<<2|N>>>4)-W|0;N=(U>>>4|U<<2)-W|0;U=W<<2|2;W=(R>>>6|R<<1)-Q|0;R=(V>>>6|V<<1)-Q|0;V=Q<<2|2;Q=(T>>>4|T<<2)-M|0;T=(S>>>4|S<<2)-M|0;S=M<<2|2;M=0;do{P=M<<2;X=U+(da(M,N)|0)|0;Y=V+(da(M,R)|0)|0;Z=S+(da(M,T)|0)|0;_=0;do{$=_+P|0;aa=$*3|0;ba=X+(da(_,O)|0)>>2;ca=Y+(da(_,W)|0)>>2;ea=Z+(da(_,Q)|0)>>2;if((ba|0)<0)fa=0;else fa=(ba|0)>255?-1:ba&255;a[f+aa>>0]=fa;if((ca|0)<0)ga=0;else ga=(ca|0)>255?-1:ca&255;a[f+(aa+1)>>0]=ga;if((ea|0)<0)ha=0;else ha=(ea|0)>255?-1:ea&255;a[f+(aa+2)>>0]=ha;if(h)a[g+$>>0]=-1;_=_+1|0}while((_|0)!=4);M=M+1|0}while((M|0)!=4);i=j;return}M=VEi(b|0,e|0,52)|0;Q=VEi(b|0,e|0,47)|0;W=VEi(b|0,e|0,39)|0;O=H;T=VEi(b|0,e|0,35)|0;S=T&15;T=cFi(r|0,s|0,4)|0;R=B<<1|M&1;M=R<<4|R;R=cFi(t|0,u|0,3)|0;V=R&8|Q&7;Q=V<<4|V;V=cFi(w|0,x|0,4)|0;R=cFi(W|0,O|0,4)|0;O=S<<4|S;S=T&240|r&15;T=V&240|w&15;V=R&240|W&15;W=VEi(b|0,e|0,31)|0;R=c[588688+((e&4|W&2|(Q|S<<16|M<<8)>>>0>=(V<<8|O|T<<16)>>>0)<<2)>>2]|0;W=R+S|0;if((W|0)<0)ia=0;else ia=(W|0)>255?-1:W&255;a[o>>0]=ia;W=R+M|0;if((W|0)<0)ja=0;else ja=(W|0)>255?-1:W&255;a[p>>0]=ja;W=R+Q|0;if((W|0)<0)ka=0;else ka=(W|0)>255?-1:W&255;a[q>>0]=ka;W=S-R|0;if((W|0)<0)la=0;else la=(W|0)>255?-1:W&255;a[o+1>>0]=la;W=M-R|0;if((W|0)<0)ma=0;else ma=(W|0)>255?-1:W&255;a[p+1>>0]=ma;W=Q-R|0;if((W|0)<0)na=0;else na=(W|0)>255?-1:W&255;a[q+1>>0]=na;W=R+T|0;if((W|0)<0)oa=0;else oa=(W|0)>255?-1:W&255;a[o+2>>0]=oa;W=R+V|0;if((W|0)<0)pa=0;else pa=(W|0)>255?-1:W&255;a[p+2>>0]=pa;W=R+O|0;if((W|0)<0)qa=0;else qa=(W|0)>255?-1:W&255;a[q+2>>0]=qa;W=T-R|0;if((W|0)<0)ra=0;else ra=(W|0)>255?-1:W&255;a[o+3>>0]=ra;W=V-R|0;if((W|0)<0)sa=0;else sa=(W|0)>255?-1:W&255;a[p+3>>0]=sa;W=O-R|0;if((W|0)<0)ta=0;else ta=(W|0)>255?-1:W&255;a[q+3>>0]=ta}else{W=VEi(b|0,e|0,52)|0;R=H;O=VEi(b|0,e|0,44)|0;V=H;T=VEi(b|0,e|0,36)|0;Q=T&15;T=VEi(b|0,e|0,33)|0;M=c[588688+((T&6|e&1)<<2)>>2]|0;T=cFi(r|0,s|0,2)|0;S=T&12|z&3;a[o>>0]=S<<4|S;S=cFi(W|0,R|0,4)|0;a[p>>0]=W&15|S;S=cFi(D|0,E|0,4)|0;a[q>>0]=D&15|S;S=cFi(O|0,V|0,4)|0;V=O&15|S;a[o+2>>0]=V;S=cFi(G|0,I|0,4)|0;O=G&15|S;a[p+2>>0]=O;S=Q<<4|Q;a[q+2>>0]=S;Q=V&255;V=Q+M|0;if((V|0)<0)ua=0;else ua=(V|0)>255?-1:V&255;a[o+1>>0]=ua;V=O&255;O=V+M|0;if((O|0)<0)va=0;else va=(O|0)>255?-1:O&255;a[p+1>>0]=va;O=S+M|0;if((O|0)<0)wa=0;else wa=(O|0)>255?-1:O&255;a[q+1>>0]=wa;O=Q-M|0;if((O|0)<0)xa=0;else xa=(O|0)>255?-1:O&255;a[o+3>>0]=xa;O=V-M|0;if((O|0)<0)ya=0;else ya=(O|0)>255?-1:O&255;a[p+3>>0]=ya;O=S-M|0;if((O|0)<0)za=0;else za=(O|0)>255?-1:O&255;a[q+3>>0]=za}if(K&h)Aa=0;else{O=0;do{M=(((O|0)%4|0)<<2)+((O|0)/4|0)|0;S=M*3|0;V=VEi(b|0,e|0,O+16|0)|0;Q=VEi(b|0,e|0,O|0)|0;W=V<<1&2|Q&1;a[f+S>>0]=a[o+W>>0]|0;a[f+(S+1)>>0]=a[p+W>>0]|0;a[f+(S+2)>>0]=a[q+W>>0]|0;if(h)a[g+M>>0]=-1;O=O+1|0}while((O|0)!=16);i=j;return}do{O=(((Aa|0)%4|0)<<2)+((Aa|0)/4|0)|0;M=O*3|0;W=VEi(b|0,e|0,Aa+16|0)|0;S=VEi(b|0,e|0,Aa|0)|0;Q=W<<1&2|S&1;if((Q|0)==2){a[f+M>>0]=0;a[f+(M+1)>>0]=0;a[f+(M+2)>>0]=0;a[g+O>>0]=0}else{a[f+M>>0]=a[o+Q>>0]|0;a[f+(M+1)>>0]=a[p+Q>>0]|0;a[f+(M+2)>>0]=a[q+Q>>0]|0;a[g+O>>0]=-1}Aa=Aa+1|0}while((Aa|0)!=16);i=j;return}while(0);Aa=VEi(b|0,e|0,37)|0;c[k>>2]=Aa&7;Aa=VEi(b|0,e|0,34)|0;c[k+4>>2]=Aa&7;if(!L){L=VEi(b|0,e|0,60)|0;Aa=H;q=cFi(L|0,Aa|0,4)|0;a[l>>0]=q|L;L=cFi(z|0,A|0,4)|0;A=VEi(b|0,e|0,52)|0;q=cFi(A|0,H|0,4)|0;Aa=cFi(D|0,E|0,4)|0;E=VEi(b|0,e|0,44)|0;p=cFi(E|0,H|0,4)|0;o=cFi(G|0,I|0,4)|0;Ba=G&15|o;Ca=D&15|Aa;Da=z&15|L;Ea=E&15|p;Fa=A&15|q}else{q=cFi(r|0,s|0,3)|0;s=H;s=VEi(b|0,e|0,61)|0;a[l>>0]=q|s;s=cFi(t|0,u|0,3)|0;u=cFi(w|0,x|0,3)|0;x=C+r&255;r=F+v&255;F=J+y&255;Ba=F>>>2|F<<3;Ca=r>>>2|r<<3;Da=x>>>2|x<<3;Ea=y>>>2|u;Fa=v>>>2|s}a[m>>0]=Fa;a[n>>0]=Ea;a[l+1>>0]=Da;a[m+1>>0]=Ca;a[n+1>>0]=Ba;Ba=0!=0|(e&1|0)!=0;if(K&h)Ga=0;else{K=0;do{Ca=(K|0)/4|0;Da=(K|0)%4|0;Ea=(Da<<2)+Ca|0;Fa=Ea*3|0;s=((Ba?Da:Ca)|0)>1&1;Ca=c[k+(s<<2)>>2]|0;Da=VEi(b|0,e|0,K+16|0)|0;v=VEi(b|0,e|0,K|0)|0;u=c[588560+(Ca<<4)+((Da<<1&2|v&1)<<2)>>2]|0;v=(d[l+s>>0]|0)+u|0;if((v|0)<0)Ha=0;else Ha=(v|0)>255?-1:v&255;a[f+Fa>>0]=Ha;v=(d[m+s>>0]|0)+u|0;if((v|0)<0)Ia=0;else Ia=(v|0)>255?-1:v&255;a[f+(Fa+1)>>0]=Ia;v=(d[n+s>>0]|0)+u|0;if((v|0)<0)Ja=0;else Ja=(v|0)>255?-1:v&255;a[f+(Fa+2)>>0]=Ja;if(h)a[g+Ea>>0]=-1;K=K+1|0}while((K|0)!=16);i=j;return}do{K=(Ga|0)/4|0;h=(Ga|0)%4|0;Ja=(h<<2)+K|0;Ia=Ja*3|0;Ha=((Ba?h:K)|0)>1&1;K=c[k+(Ha<<2)>>2]|0;h=VEi(b|0,e|0,Ga+16|0)|0;Ea=VEi(b|0,e|0,Ga|0)|0;Fa=Ea&1;Ea=h<<1&2|Fa;if((Ea|0)==2){a[f+Ia>>0]=0;a[f+(Ia+1)>>0]=0;a[f+(Ia+2)>>0]=0;a[g+Ja>>0]=0}else{if(!Fa)Ka=0;else Ka=c[588560+(K<<4)+(Ea<<2)>>2]|0;Ea=(d[l+Ha>>0]|0)+Ka|0;if((Ea|0)<0)La=0;else La=(Ea|0)>255?-1:Ea&255;a[f+Ia>>0]=La;Ea=(d[m+Ha>>0]|0)+Ka|0;if((Ea|0)<0)Ma=0;else Ma=(Ea|0)>255?-1:Ea&255;a[f+(Ia+1)>>0]=Ma;Ea=(d[n+Ha>>0]|0)+Ka|0;if((Ea|0)<0)Na=0;else Na=(Ea|0)>255?-1:Ea&255;a[f+(Ia+2)>>0]=Na;a[g+Ja>>0]=-1}Ga=Ga+1|0}while((Ga|0)!=16);i=j;return}function mvc(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;b=i;i=i+80|0;e=b+64|0;f=b+44|0;g=b+24|0;h=b+28|0;j=b+12|0;k=b+40|0;l=b+48|0;m=b+56|0;n=b+72|0;o=b+8|0;p=b+4|0;q=b+32|0;r=b;s=b+16|0;t=b+36|0;u=b+20|0;v=b+52|0;c[u>>2]=c[153106];c[e+0>>2]=c[u+0>>2];u=xvc(4,e)|0;if(!u)w=0;else w=c[u+4>>2]|0;c[147190]=w;c[t>>2]=w;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(e,w,t);u=c[e>>2]|0;x=c[w+28>>2]|0;if((u|0)==-1){y=x+(c[w+32>>2]<<3)|0;break}else{y=x+(u<<3)|0;break}}else y=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((y|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[y+4>>2]|0,(w|0)!=0):0)z=w;else A=11}else A=11;if((A|0)==11)z=hQb(c[147190]|0)|0;In[c[(c[z>>2]|0)+44>>2]&4095](z,61);c[s>>2]=c[147190];z=c[137784]|0;if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(e,z,s);w=c[e>>2]|0;y=c[z+28>>2]|0;if((w|0)==-1){B=y+(c[z+32>>2]<<3)|0;break}else{B=y+(w<<3)|0;break}}else B=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);z=c[137784]|0;if((B|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(z=c[B+4>>2]|0,(z|0)!=0):0)C=z;else A=20}else A=20;if((A|0)==20)C=hQb(c[147190]|0)|0;gn[c[(c[C>>2]|0)+148>>2]&127](C,4,64,1,0,1,0)|0;c[r>>2]=c[147190];C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(e,C,r);z=c[e>>2]|0;B=c[C+28>>2]|0;if((z|0)==-1){D=B+(c[C+32>>2]<<3)|0;break}else{D=B+(z<<3)|0;break}}else D=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((D|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(r=c[D+4>>2]|0,(r|0)!=0):0){E=C;F=r}else A=29}else A=29;if((A|0)==29){r=hQb(c[147190]|0)|0;E=c[137784]|0;F=r}c[F+32>>2]=0;c[q>>2]=c[147190];if(E){do if((c[E+36>>2]|0)!=(c[E+4>>2]|0)){fRb(e,E,q);F=c[e>>2]|0;r=c[E+28>>2]|0;if((F|0)==-1){G=r+(c[E+32>>2]<<3)|0;break}else{G=r+(F<<3)|0;break}}else G=(c[E+28>>2]|0)+(c[E+32>>2]<<3)|0;while(0);E=c[137784]|0;if((G|0)!=((c[E+28>>2]|0)+(c[E+32>>2]<<3)|0)?(q=c[G+4>>2]|0,(q|0)!=0):0){H=E;I=q}else A=38}else A=38;if((A|0)==38){q=hQb(c[147190]|0)|0;H=c[137784]|0;I=q}c[I+28>>2]=0;c[p>>2]=c[147190];if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(e,H,p);I=c[e>>2]|0;q=c[H+28>>2]|0;if((I|0)==-1){J=q+(c[H+32>>2]<<3)|0;break}else{J=q+(I<<3)|0;break}}else J=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if((J|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(H=c[J+4>>2]|0,(H|0)!=0):0)K=H;else A=47}else A=47;if((A|0)==47)K=hQb(c[147190]|0)|0;ko[c[(c[K>>2]|0)+132>>2]&4095](K);c[o>>2]=c[147190];K=c[137784]|0;if(K){do if((c[K+36>>2]|0)!=(c[K+4>>2]|0)){fRb(e,K,o);H=c[e>>2]|0;J=c[K+28>>2]|0;if((H|0)==-1){L=J+(c[K+32>>2]<<3)|0;break}else{L=J+(H<<3)|0;break}}else L=(c[K+28>>2]|0)+(c[K+32>>2]<<3)|0;while(0);K=c[137784]|0;if((L|0)!=((c[K+28>>2]|0)+(c[K+32>>2]<<3)|0)?(K=c[L+4>>2]|0,(K|0)!=0):0)M=K;else A=56}else A=56;if((A|0)==56)M=hQb(c[147190]|0)|0;zEc(M);K=c[M+48>>2]|0;if(!K)N=0;else N=c[K+8>>2]|0;K=0;do{M=K<<4;L=15-K<<4;o=0;do{H=((d[588880+o>>0]|0)<(K|0))<<31>>31;a[N+(o+M)>>0]=H;a[N+(o+L)>>0]=H&255^255;o=o+1|0}while((o|0)!=16);K=K+1|0}while((K|0)!=8);if(a[621142]|0){c[v>>2]=c[153106];c[e+0>>2]=c[v+0>>2];v=yvc(4,e)|0;if(!v)O=0;else O=c[v+4>>2]|0;c[147192]=O;c[n>>2]=O;O=c[137784]|0;if(O){do if((c[O+36>>2]|0)!=(c[O+4>>2]|0)){fRb(e,O,n);v=c[e>>2]|0;K=c[O+28>>2]|0;if((v|0)==-1){P=K+(c[O+32>>2]<<3)|0;break}else{P=K+(v<<3)|0;break}}else P=(c[O+28>>2]|0)+(c[O+32>>2]<<3)|0;while(0);O=c[137784]|0;if((P|0)!=((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)?(O=c[P+4>>2]|0,(O|0)!=0):0)Q=O;else A=74}else A=74;if((A|0)==74)Q=hQb(c[147192]|0)|0;In[c[(c[Q>>2]|0)+44>>2]&4095](Q,61);c[m>>2]=c[147192];Q=c[137784]|0;if(Q){do if((c[Q+36>>2]|0)!=(c[Q+4>>2]|0)){fRb(e,Q,m);O=c[e>>2]|0;P=c[Q+28>>2]|0;if((O|0)==-1){R=P+(c[Q+32>>2]<<3)|0;break}else{R=P+(O<<3)|0;break}}else R=(c[Q+28>>2]|0)+(c[Q+32>>2]<<3)|0;while(0);Q=c[137784]|0;if((R|0)!=((c[Q+28>>2]|0)+(c[Q+32>>2]<<3)|0)?(Q=c[R+4>>2]|0,(Q|0)!=0):0)S=Q;else A=83}else A=83;if((A|0)==83)S=hQb(c[147192]|0)|0;rFc(S,4,4,16,1,0)|0;c[l>>2]=c[147192];S=c[137784]|0;if(S){do if((c[S+36>>2]|0)!=(c[S+4>>2]|0)){fRb(e,S,l);Q=c[e>>2]|0;R=c[S+28>>2]|0;if((Q|0)==-1){T=R+(c[S+32>>2]<<3)|0;break}else{T=R+(Q<<3)|0;break}}else T=(c[S+28>>2]|0)+(c[S+32>>2]<<3)|0;while(0);S=c[137784]|0;if((T|0)!=((c[S+28>>2]|0)+(c[S+32>>2]<<3)|0)?(l=c[T+4>>2]|0,(l|0)!=0):0){U=S;V=l}else A=92}else A=92;if((A|0)==92){l=hQb(c[147192]|0)|0;U=c[137784]|0;V=l}c[V+32>>2]=0;c[k>>2]=c[147192];if(U){do if((c[U+36>>2]|0)!=(c[U+4>>2]|0)){fRb(e,U,k);V=c[e>>2]|0;l=c[U+28>>2]|0;if((V|0)==-1){W=l+(c[U+32>>2]<<3)|0;break}else{W=l+(V<<3)|0;break}}else W=(c[U+28>>2]|0)+(c[U+32>>2]<<3)|0;while(0);U=c[137784]|0;if((W|0)!=((c[U+28>>2]|0)+(c[U+32>>2]<<3)|0)?(k=c[W+4>>2]|0,(k|0)!=0):0){X=U;Y=k}else A=101}else A=101;if((A|0)==101){k=hQb(c[147192]|0)|0;X=c[137784]|0;Y=k}c[Y+28>>2]=0;c[j>>2]=c[147192];if(X){do if((c[X+36>>2]|0)!=(c[X+4>>2]|0)){fRb(e,X,j);Y=c[e>>2]|0;k=c[X+28>>2]|0;if((Y|0)==-1){Z=k+(c[X+32>>2]<<3)|0;break}else{Z=k+(Y<<3)|0;break}}else Z=(c[X+28>>2]|0)+(c[X+32>>2]<<3)|0;while(0);X=c[137784]|0;if((Z|0)!=((c[X+28>>2]|0)+(c[X+32>>2]<<3)|0)?(X=c[Z+4>>2]|0,(X|0)!=0):0)_=X;else A=110}else A=110;if((A|0)==110)_=hQb(c[147192]|0)|0;ko[c[(c[_>>2]|0)+132>>2]&4095](_);c[h>>2]=c[147192];_=c[137784]|0;if(_){do if((c[_+36>>2]|0)!=(c[_+4>>2]|0)){fRb(e,_,h);X=c[e>>2]|0;Z=c[_+28>>2]|0;if((X|0)==-1){$=Z+(c[_+32>>2]<<3)|0;break}else{$=Z+(X<<3)|0;break}}else $=(c[_+28>>2]|0)+(c[_+32>>2]<<3)|0;while(0);_=c[137784]|0;if(($|0)!=((c[_+28>>2]|0)+(c[_+32>>2]<<3)|0)?(_=c[$+4>>2]|0,(_|0)!=0):0)aa=_;else A=119}else A=119;if((A|0)==119)aa=hQb(c[147192]|0)|0;YEi(c[aa+116>>2]|0,N|0,256)|0;c[g>>2]=c[147192];N=c[137784]|0;do if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,g);aa=c[e>>2]|0;_=c[N+28>>2]|0;if((aa|0)==-1){ba=_+(c[N+32>>2]<<3)|0;break}else{ba=_+(aa<<3)|0;break}}else ba=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);aa=c[137784]|0;if((ba|0)==((c[aa+28>>2]|0)+(c[aa+32>>2]<<3)|0)){A=128;break}aa=c[ba+4>>2]|0;if(aa)ca=aa;else A=128}else A=128;while(0);if((A|0)==128)ca=hQb(c[147192]|0)|0;sFc(ca,0)}c[f>>2]=c[147190];ca=c[137784]|0;if(ca){do if((c[ca+36>>2]|0)!=(c[ca+4>>2]|0)){fRb(e,ca,f);A=c[e>>2]|0;ba=c[ca+28>>2]|0;if((A|0)==-1){da=ba+(c[ca+32>>2]<<3)|0;break}else{da=ba+(A<<3)|0;break}}else da=(c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0;while(0);ca=c[137784]|0;if((da|0)!=((c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0)?(ca=c[da+4>>2]|0,(ca|0)!=0):0){ea=ca;fa=c[ea>>2]|0;ga=fa+152|0;ha=c[ga>>2]|0;ko[ha&4095](ea);i=b;return}}ea=hQb(c[147190]|0)|0;fa=c[ea>>2]|0;ga=fa+152|0;ha=c[ga>>2]|0;ko[ha&4095](ea);i=b;return}function nvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;a=i;i=i+96|0;b=a+80|0;d=a+48|0;e=a+24|0;f=a+36|0;g=a+68|0;h=a+16|0;j=a+20|0;k=a+56|0;l=a+64|0;m=a+72|0;n=a+88|0;o=a+40|0;p=a+44|0;q=a+8|0;r=a;s=a+4|0;t=a+52|0;u=a+28|0;v=a+60|0;w=a+12|0;x=a+32|0;y=(ync()|0)+3748|0;z=c[147180]|0;if(!z)A=0;else{c[w>>2]=z;z=c[137784]|0;if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(b,z,w);B=c[b>>2]|0;C=c[z+28>>2]|0;if((B|0)==-1){D=C+(c[z+32>>2]<<3)|0;break}else{D=C+(B<<3)|0;break}}else D=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);z=c[137784]|0;if((D|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(z=c[D+4>>2]|0,(z|0)!=0):0)E=z;else F=10}else F=10;if((F|0)==10)E=hQb(c[147180]|0)|0;A=E}pxd(y,A,0,104,0,125);A=(ync()|0)+3812|0;y=c[147182]|0;if(!y)G=0;else{c[u>>2]=y;y=c[137784]|0;if(y){do if((c[y+36>>2]|0)!=(c[y+4>>2]|0)){fRb(b,y,u);E=c[b>>2]|0;z=c[y+28>>2]|0;if((E|0)==-1){H=z+(c[y+32>>2]<<3)|0;break}else{H=z+(E<<3)|0;break}}else H=(c[y+28>>2]|0)+(c[y+32>>2]<<3)|0;while(0);y=c[137784]|0;if((H|0)!=((c[y+28>>2]|0)+(c[y+32>>2]<<3)|0)?(y=c[H+4>>2]|0,(y|0)!=0):0)I=y;else F=21}else F=21;if((F|0)==21)I=hQb(c[147182]|0)|0;G=I}pxd(A,G,0,105,0,126);G=(ync()|0)+3876|0;A=c[147198]|0;if(!A)J=0;else{c[t>>2]=A;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(b,A,t);I=c[b>>2]|0;y=c[A+28>>2]|0;if((I|0)==-1){K=y+(c[A+32>>2]<<3)|0;break}else{K=y+(I<<3)|0;break}}else K=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if((K|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0)?(A=c[K+4>>2]|0,(A|0)!=0):0)L=A;else F=32}else F=32;if((F|0)==32)L=hQb(c[147198]|0)|0;J=L}pxd(G,J,0,106,0,127);J=(ync()|0)+3940|0;G=c[147200]|0;if(!G)M=0;else{c[r>>2]=G;G=c[137784]|0;if(G){do if((c[G+36>>2]|0)!=(c[G+4>>2]|0)){fRb(b,G,r);L=c[b>>2]|0;A=c[G+28>>2]|0;if((L|0)==-1){N=A+(c[G+32>>2]<<3)|0;break}else{N=A+(L<<3)|0;break}}else N=(c[G+28>>2]|0)+(c[G+32>>2]<<3)|0;while(0);G=c[137784]|0;if((N|0)!=((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)?(G=c[N+4>>2]|0,(G|0)!=0):0)O=G;else F=43}else F=43;if((F|0)==43)O=hQb(c[147200]|0)|0;M=O}pxd(J,M,0,107,0,128);M=(ync()|0)+4004|0;J=c[147200]|0;if(!J)P=0;else{c[q>>2]=J;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(b,J,q);O=c[b>>2]|0;G=c[J+28>>2]|0;if((O|0)==-1){Q=G+(c[J+32>>2]<<3)|0;break}else{Q=G+(O<<3)|0;break}}else Q=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((Q|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[Q+4>>2]|0,(J|0)!=0):0)R=J;else F=54}else F=54;if((F|0)==54)R=hQb(c[147200]|0)|0;P=R}pxd(M,P,0,108,0,129);P=(ync()|0)+4068|0;M=c[147202]|0;if(!M)S=0;else{c[o>>2]=M;M=c[137784]|0;if(M){do if((c[M+36>>2]|0)!=(c[M+4>>2]|0)){fRb(b,M,o);R=c[b>>2]|0;J=c[M+28>>2]|0;if((R|0)==-1){T=J+(c[M+32>>2]<<3)|0;break}else{T=J+(R<<3)|0;break}}else T=(c[M+28>>2]|0)+(c[M+32>>2]<<3)|0;while(0);M=c[137784]|0;if((T|0)!=((c[M+28>>2]|0)+(c[M+32>>2]<<3)|0)?(M=c[T+4>>2]|0,(M|0)!=0):0)U=M;else F=65}else F=65;if((F|0)==65)U=hQb(c[147202]|0)|0;S=U}pxd(P,S,0,109,0,130);S=(ync()|0)+4132|0;P=c[147202]|0;if(!P)V=0;else{c[n>>2]=P;P=c[137784]|0;if(P){do if((c[P+36>>2]|0)!=(c[P+4>>2]|0)){fRb(b,P,n);U=c[b>>2]|0;M=c[P+28>>2]|0;if((U|0)==-1){W=M+(c[P+32>>2]<<3)|0;break}else{W=M+(U<<3)|0;break}}else W=(c[P+28>>2]|0)+(c[P+32>>2]<<3)|0;while(0);P=c[137784]|0;if((W|0)!=((c[P+28>>2]|0)+(c[P+32>>2]<<3)|0)?(P=c[W+4>>2]|0,(P|0)!=0):0)X=P;else F=76}else F=76;if((F|0)==76)X=hQb(c[147202]|0)|0;V=X}pxd(S,V,0,110,0,131);V=(ync()|0)+4196|0;S=c[147196]|0;if(!S)Y=0;else{c[l>>2]=S;S=c[137784]|0;if(S){do if((c[S+36>>2]|0)!=(c[S+4>>2]|0)){fRb(b,S,l);X=c[b>>2]|0;P=c[S+28>>2]|0;if((X|0)==-1){Z=P+(c[S+32>>2]<<3)|0;break}else{Z=P+(X<<3)|0;break}}else Z=(c[S+28>>2]|0)+(c[S+32>>2]<<3)|0;while(0);S=c[137784]|0;if((Z|0)!=((c[S+28>>2]|0)+(c[S+32>>2]<<3)|0)?(S=c[Z+4>>2]|0,(S|0)!=0):0)_=S;else F=87}else F=87;if((F|0)==87)_=hQb(c[147196]|0)|0;Y=_}pxd(V,Y,0,111,0,132);Y=(ync()|0)+4260|0;V=c[147184]|0;if(!V)$=0;else{c[k>>2]=V;V=c[137784]|0;if(V){do if((c[V+36>>2]|0)!=(c[V+4>>2]|0)){fRb(b,V,k);_=c[b>>2]|0;S=c[V+28>>2]|0;if((_|0)==-1){aa=S+(c[V+32>>2]<<3)|0;break}else{aa=S+(_<<3)|0;break}}else aa=(c[V+28>>2]|0)+(c[V+32>>2]<<3)|0;while(0);V=c[137784]|0;if((aa|0)!=((c[V+28>>2]|0)+(c[V+32>>2]<<3)|0)?(V=c[aa+4>>2]|0,(V|0)!=0):0)ba=V;else F=98}else F=98;if((F|0)==98)ba=hQb(c[147184]|0)|0;$=ba}pxd(Y,$,0,112,0,133);$=(ync()|0)+4324|0;Y=c[147182]|0;if(!Y)ca=0;else{c[h>>2]=Y;Y=c[137784]|0;if(Y){do if((c[Y+36>>2]|0)!=(c[Y+4>>2]|0)){fRb(b,Y,h);ba=c[b>>2]|0;V=c[Y+28>>2]|0;if((ba|0)==-1){da=V+(c[Y+32>>2]<<3)|0;break}else{da=V+(ba<<3)|0;break}}else da=(c[Y+28>>2]|0)+(c[Y+32>>2]<<3)|0;while(0);Y=c[137784]|0;if((da|0)!=((c[Y+28>>2]|0)+(c[Y+32>>2]<<3)|0)?(Y=c[da+4>>2]|0,(Y|0)!=0):0)ea=Y;else F=109}else F=109;if((F|0)==109)ea=hQb(c[147182]|0)|0;ca=ea}pxd($,ca,0,113,0,134);ca=(ync()|0)+4388|0;$=c[147182]|0;if(!$)fa=0;else{c[g>>2]=$;$=c[137784]|0;if($){do if((c[$+36>>2]|0)!=(c[$+4>>2]|0)){fRb(b,$,g);ea=c[b>>2]|0;Y=c[$+28>>2]|0;if((ea|0)==-1){ga=Y+(c[$+32>>2]<<3)|0;break}else{ga=Y+(ea<<3)|0;break}}else ga=(c[$+28>>2]|0)+(c[$+32>>2]<<3)|0;while(0);$=c[137784]|0;if((ga|0)!=((c[$+28>>2]|0)+(c[$+32>>2]<<3)|0)?($=c[ga+4>>2]|0,($|0)!=0):0)ha=$;else F=120}else F=120;if((F|0)==120)ha=hQb(c[147182]|0)|0;fa=ha}pxd(ca,fa,0,114,0,135);fa=(ync()|0)+4452|0;ca=c[147182]|0;if(!ca)ia=0;else{c[e>>2]=ca;ca=c[137784]|0;if(ca){do if((c[ca+36>>2]|0)!=(c[ca+4>>2]|0)){fRb(b,ca,e);ha=c[b>>2]|0;$=c[ca+28>>2]|0;if((ha|0)==-1){ja=$+(c[ca+32>>2]<<3)|0;break}else{ja=$+(ha<<3)|0;break}}else ja=(c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0;while(0);ca=c[137784]|0;if((ja|0)!=((c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0)?(ca=c[ja+4>>2]|0,(ca|0)!=0):0)ka=ca;else F=131}else F=131;if((F|0)==131)ka=hQb(c[147182]|0)|0;ia=ka}pxd(fa,ia,0,115,0,136);ia=(ync()|0)+4516|0;fa=c[147182]|0;if(!fa)la=0;else{c[d>>2]=fa;fa=c[137784]|0;if(fa){do if((c[fa+36>>2]|0)!=(c[fa+4>>2]|0)){fRb(b,fa,d);ka=c[b>>2]|0;ca=c[fa+28>>2]|0;if((ka|0)==-1){ma=ca+(c[fa+32>>2]<<3)|0;break}else{ma=ca+(ka<<3)|0;break}}else ma=(c[fa+28>>2]|0)+(c[fa+32>>2]<<3)|0;while(0);fa=c[137784]|0;if((ma|0)!=((c[fa+28>>2]|0)+(c[fa+32>>2]<<3)|0)?(fa=c[ma+4>>2]|0,(fa|0)!=0):0)na=fa;else F=142}else F=142;if((F|0)==142)na=hQb(c[147182]|0)|0;la=na}pxd(ia,la,0,116,0,137);la=(ync()|0)+4580|0;ia=c[147182]|0;if(!ia)oa=0;else{c[f>>2]=ia;ia=c[137784]|0;if(ia){do if((c[ia+36>>2]|0)!=(c[ia+4>>2]|0)){fRb(b,ia,f);na=c[b>>2]|0;fa=c[ia+28>>2]|0;if((na|0)==-1){pa=fa+(c[ia+32>>2]<<3)|0;break}else{pa=fa+(na<<3)|0;break}}else pa=(c[ia+28>>2]|0)+(c[ia+32>>2]<<3)|0;while(0);ia=c[137784]|0;if((pa|0)!=((c[ia+28>>2]|0)+(c[ia+32>>2]<<3)|0)?(ia=c[pa+4>>2]|0,(ia|0)!=0):0)qa=ia;else F=153}else F=153;if((F|0)==153)qa=hQb(c[147182]|0)|0;oa=qa}pxd(la,oa,0,117,0,138);oa=(ync()|0)+4644|0;la=c[147182]|0;if(!la)ra=0;else{c[j>>2]=la;la=c[137784]|0;if(la){do if((c[la+36>>2]|0)!=(c[la+4>>2]|0)){fRb(b,la,j);qa=c[b>>2]|0;ia=c[la+28>>2]|0;if((qa|0)==-1){sa=ia+(c[la+32>>2]<<3)|0;break}else{sa=ia+(qa<<3)|0;break}}else sa=(c[la+28>>2]|0)+(c[la+32>>2]<<3)|0;while(0);la=c[137784]|0;if((sa|0)!=((c[la+28>>2]|0)+(c[la+32>>2]<<3)|0)?(la=c[sa+4>>2]|0,(la|0)!=0):0)ta=la;else F=164}else F=164;if((F|0)==164)ta=hQb(c[147182]|0)|0;ra=ta}pxd(oa,ra,0,117,0,138);ra=(ync()|0)+4708|0;oa=c[147192]|0;if(!oa)ua=0;else{c[m>>2]=oa;oa=c[137784]|0;do if(oa){do if((c[oa+36>>2]|0)!=(c[oa+4>>2]|0)){fRb(b,oa,m);ta=c[b>>2]|0;la=c[oa+28>>2]|0;if((ta|0)==-1){va=la+(c[oa+32>>2]<<3)|0;break}else{va=la+(ta<<3)|0;break}}else va=(c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0;while(0);ta=c[137784]|0;if((va|0)==((c[ta+28>>2]|0)+(c[ta+32>>2]<<3)|0)){F=175;break}ta=c[va+4>>2]|0;if(ta)wa=ta;else F=175}else F=175;while(0);if((F|0)==175)wa=hQb(c[147192]|0)|0;ua=wa}pxd(ra,ua,0,120,0,141);ua=(ync()|0)+4772|0;ra=c[147190]|0;if(!ra)xa=0;else{c[p>>2]=ra;ra=c[137784]|0;do if(ra){do if((c[ra+36>>2]|0)!=(c[ra+4>>2]|0)){fRb(b,ra,p);wa=c[b>>2]|0;va=c[ra+28>>2]|0;if((wa|0)==-1){ya=va+(c[ra+32>>2]<<3)|0;break}else{ya=va+(wa<<3)|0;break}}else ya=(c[ra+28>>2]|0)+(c[ra+32>>2]<<3)|0;while(0);wa=c[137784]|0;if((ya|0)==((c[wa+28>>2]|0)+(c[wa+32>>2]<<3)|0)){F=186;break}wa=c[ya+4>>2]|0;if(wa)za=wa;else F=186}else F=186;while(0);if((F|0)==186)za=hQb(c[147190]|0)|0;xa=za}pxd(ua,xa,0,121,0,142);xa=(ync()|0)+4836|0;ua=c[147194]|0;if(!ua)Aa=0;else{c[s>>2]=ua;ua=c[137784]|0;do if(ua){do if((c[ua+36>>2]|0)!=(c[ua+4>>2]|0)){fRb(b,ua,s);za=c[b>>2]|0;ya=c[ua+28>>2]|0;if((za|0)==-1){Ba=ya+(c[ua+32>>2]<<3)|0;break}else{Ba=ya+(za<<3)|0;break}}else Ba=(c[ua+28>>2]|0)+(c[ua+32>>2]<<3)|0;while(0);za=c[137784]|0;if((Ba|0)==((c[za+28>>2]|0)+(c[za+32>>2]<<3)|0)){F=197;break}za=c[Ba+4>>2]|0;if(za)Ca=za;else F=197}else F=197;while(0);if((F|0)==197)Ca=hQb(c[147194]|0)|0;Aa=Ca}pxd(xa,Aa,0,122,0,143);Aa=(ync()|0)+4900|0;xa=c[147204]|0;if(!xa)Da=0;else{c[v>>2]=xa;xa=c[137784]|0;do if(xa){do if((c[xa+36>>2]|0)!=(c[xa+4>>2]|0)){fRb(b,xa,v);Ca=c[b>>2]|0;Ba=c[xa+28>>2]|0;if((Ca|0)==-1){Ea=Ba+(c[xa+32>>2]<<3)|0;break}else{Ea=Ba+(Ca<<3)|0;break}}else Ea=(c[xa+28>>2]|0)+(c[xa+32>>2]<<3)|0;while(0);Ca=c[137784]|0;if((Ea|0)==((c[Ca+28>>2]|0)+(c[Ca+32>>2]<<3)|0)){F=208;break}Ca=c[Ea+4>>2]|0;if(Ca)Fa=Ca;else F=208}else F=208;while(0);if((F|0)==208)Fa=hQb(c[147204]|0)|0;Da=Fa}pxd(Aa,Da,0,123,0,144);Da=(ync()|0)+4964|0;Aa=c[147184]|0;if(!Aa){Ga=0;pxd(Da,Ga,0,124,0,145);i=a;return}c[x>>2]=Aa;Aa=c[137784]|0;do if(Aa){do if((c[Aa+36>>2]|0)!=(c[Aa+4>>2]|0)){fRb(b,Aa,x);Fa=c[b>>2]|0;Ea=c[Aa+28>>2]|0;if((Fa|0)==-1){Ha=Ea+(c[Aa+32>>2]<<3)|0;break}else{Ha=Ea+(Fa<<3)|0;break}}else Ha=(c[Aa+28>>2]|0)+(c[Aa+32>>2]<<3)|0;while(0);Fa=c[137784]|0;if((Ha|0)==((c[Fa+28>>2]|0)+(c[Fa+32>>2]<<3)|0)){F=219;break}Fa=c[Ha+4>>2]|0;if(Fa)Ia=Fa;else F=219}else F=219;while(0);if((F|0)==219)Ia=hQb(c[147184]|0)|0;Ga=Ia;pxd(Da,Ga,0,124,0,145);i=a;return}function ovc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;b=i;i=i+112|0;d=b+48|0;e=b+44|0;f=b+88|0;g=b+96|0;h=b+40|0;j=b+16|0;k=b+20|0;l=b+24|0;m=b+28|0;n=b+76|0;o=b+84|0;p=b+92|0;q=b+100|0;r=b+104|0;s=b+56|0;t=b+60|0;u=b+64|0;v=b+68|0;w=b+8|0;x=b+12|0;y=b+72|0;z=b+32|0;A=b+36|0;B=b+80|0;C=b;D=b+4|0;if(a[588896]|0){i=b;return}a[588896]=1;c[o>>2]=102;E=Avc(588904,4,4,4,o,0)|0;if(!E)F=0;else F=c[E+4>>2]|0;c[147196]=F;c[p>>2]=103;F=Avc(588920,4,4,4,p,0)|0;if(!F)G=0;else G=c[F+4>>2]|0;c[147180]=G;c[q>>2]=104;G=Avc(588936,4,4,4,q,0)|0;if(!G)H=0;else H=c[G+4>>2]|0;c[147182]=H;c[r>>2]=105;H=Avc(588952,16,16,4,r,0)|0;if(!H)I=0;else I=c[H+4>>2]|0;c[147194]=I;c[s>>2]=106;I=Avc(588976,4,4,4,s,1)|0;if(!I)J=0;else J=c[I+4>>2]|0;c[147198]=J;c[t>>2]=107;J=Avc(588992,4,4,4,t,0)|0;if(!J)K=0;else K=c[J+4>>2]|0;c[147200]=K;c[m>>2]=K;K=c[137784]|0;if(K){do if((c[K+36>>2]|0)!=(c[K+4>>2]|0)){fRb(d,K,m);J=c[d>>2]|0;t=c[K+28>>2]|0;if((J|0)==-1){L=t+(c[K+32>>2]<<3)|0;break}else{L=t+(J<<3)|0;break}}else L=(c[K+28>>2]|0)+(c[K+32>>2]<<3)|0;while(0);K=c[137784]|0;if((L|0)!=((c[K+28>>2]|0)+(c[K+32>>2]<<3)|0)?(K=c[L+4>>2]|0,(K|0)!=0):0)M=K;else N=22}else N=22;if((N|0)==22)M=hQb(c[147200]|0)|0;NDc(M,1);c[u>>2]=108;M=Avc(589008,256,2,4,u,0)|0;if(!M)O=0;else O=c[M+4>>2]|0;c[147202]=O;c[l>>2]=O;O=c[137784]|0;if(O){do if((c[O+36>>2]|0)!=(c[O+4>>2]|0)){fRb(d,O,l);M=c[d>>2]|0;u=c[O+28>>2]|0;if((M|0)==-1){P=u+(c[O+32>>2]<<3)|0;break}else{P=u+(M<<3)|0;break}}else P=(c[O+28>>2]|0)+(c[O+32>>2]<<3)|0;while(0);O=c[137784]|0;if((P|0)!=((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)?(l=c[P+4>>2]|0,(l|0)!=0):0){Q=O;R=l}else N=33}else N=33;if((N|0)==33){l=hQb(c[147202]|0)|0;Q=c[137784]|0;R=l}c[R+40>>2]=1;c[k>>2]=c[147202];if(Q){do if((c[Q+36>>2]|0)!=(c[Q+4>>2]|0)){fRb(d,Q,k);R=c[d>>2]|0;l=c[Q+28>>2]|0;if((R|0)==-1){S=l+(c[Q+32>>2]<<3)|0;break}else{S=l+(R<<3)|0;break}}else S=(c[Q+28>>2]|0)+(c[Q+32>>2]<<3)|0;while(0);Q=c[137784]|0;if((S|0)!=((c[Q+28>>2]|0)+(c[Q+32>>2]<<3)|0)?(Q=c[S+4>>2]|0,(Q|0)!=0):0)T=Q;else N=42}else N=42;if((N|0)==42)T=hQb(c[147202]|0)|0;ko[c[(c[T>>2]|0)+132>>2]&4095](T);c[v>>2]=109;T=Avc(589032,64,64,1,v,0)|0;if(!T)U=0;else U=c[T+4>>2]|0;c[147188]=U;c[j>>2]=U;U=c[137784]|0;if(U){do if((c[U+36>>2]|0)!=(c[U+4>>2]|0)){fRb(d,U,j);T=c[d>>2]|0;v=c[U+28>>2]|0;if((T|0)==-1){V=v+(c[U+32>>2]<<3)|0;break}else{V=v+(T<<3)|0;break}}else V=(c[U+28>>2]|0)+(c[U+32>>2]<<3)|0;while(0);U=c[137784]|0;if((V|0)!=((c[U+28>>2]|0)+(c[U+32>>2]<<3)|0)?(j=c[V+4>>2]|0,(j|0)!=0):0){W=U;X=j}else N=53}else N=53;if((N|0)==53){j=hQb(c[147188]|0)|0;W=c[137784]|0;X=j}c[X+40>>2]=1;c[h>>2]=c[147188];if(W){do if((c[W+36>>2]|0)!=(c[W+4>>2]|0)){fRb(d,W,h);X=c[d>>2]|0;j=c[W+28>>2]|0;if((X|0)==-1){Y=j+(c[W+32>>2]<<3)|0;break}else{Y=j+(X<<3)|0;break}}else Y=(c[W+28>>2]|0)+(c[W+32>>2]<<3)|0;while(0);W=c[137784]|0;if((Y|0)!=((c[W+28>>2]|0)+(c[W+32>>2]<<3)|0)?(W=c[Y+4>>2]|0,(W|0)!=0):0)Z=W;else N=62}else N=62;if((N|0)==62)Z=hQb(c[147188]|0)|0;ko[c[(c[Z>>2]|0)+132>>2]&4095](Z);if(!(a[621067]|0)){c[x>>2]=111;Z=Avc(589048,1024,1,1,x,0)|0;if(!Z)_=0;else _=c[Z+4>>2]|0}else{c[w>>2]=110;Z=Jvc(589048,1024,1,9,w,0)|0;if(!Z)_=0;else _=c[Z+4>>2]|0}c[147186]=_;c[g>>2]=_;_=c[137784]|0;if(_){do if((c[_+36>>2]|0)!=(c[_+4>>2]|0)){fRb(d,_,g);Z=c[d>>2]|0;w=c[_+28>>2]|0;if((Z|0)==-1){$=w+(c[_+32>>2]<<3)|0;break}else{$=w+(Z<<3)|0;break}}else $=(c[_+28>>2]|0)+(c[_+32>>2]<<3)|0;while(0);_=c[137784]|0;if(($|0)!=((c[_+28>>2]|0)+(c[_+32>>2]<<3)|0)?(g=c[$+4>>2]|0,(g|0)!=0):0){aa=_;ba=g}else N=76}else N=76;if((N|0)==76){g=hQb(c[147186]|0)|0;aa=c[137784]|0;ba=g}c[ba+40>>2]=1;c[f>>2]=c[147186];if(aa){do if((c[aa+36>>2]|0)!=(c[aa+4>>2]|0)){fRb(d,aa,f);ba=c[d>>2]|0;g=c[aa+28>>2]|0;if((ba|0)==-1){ca=g+(c[aa+32>>2]<<3)|0;break}else{ca=g+(ba<<3)|0;break}}else ca=(c[aa+28>>2]|0)+(c[aa+32>>2]<<3)|0;while(0);aa=c[137784]|0;if((ca|0)!=((c[aa+28>>2]|0)+(c[aa+32>>2]<<3)|0)?(aa=c[ca+4>>2]|0,(aa|0)!=0):0)da=aa;else N=85}else N=85;if((N|0)==85)da=hQb(c[147186]|0)|0;ko[c[(c[da>>2]|0)+132>>2]&4095](da);c[y>>2]=2667;c[e>>2]=c[153106];c[d+0>>2]=c[e+0>>2];da=Mvc(4,d)|0;In[c[(c[da>>2]|0)+44>>2]&4095](da,61);gn[c[(c[da>>2]|0)+148>>2]&127](da,1,1,4,0,6,0)|0;In[c[(c[da>>2]|0)+36>>2]&4095](da,589072);Nvc(da,y);ko[c[(c[da>>2]|0)+156>>2]&4095](da);c[da+40>>2]=1;ko[c[(c[da>>2]|0)+132>>2]&4095](da);if(!da)ea=0;else ea=c[da+4>>2]|0;c[147184]=ea;c[z>>2]=112;c[147208]=c[(Avc(589088,16,16,4,z,0)|0)+44>>2];if(a[621142]|0){c[A>>2]=62;c[147209]=c[(Qvc(589104,1,1,1,4,A)|0)+44>>2]}c[B>>2]=2668;c[e>>2]=c[153106];c[d+0>>2]=c[e+0>>2];A=Mvc(4,d)|0;In[c[(c[A>>2]|0)+44>>2]&4095](A,61);gn[c[(c[A>>2]|0)+148>>2]&127](A,1,1,4,0,6,0)|0;In[c[(c[A>>2]|0)+36>>2]&4095](A,589120);Nvc(A,B);ko[c[(c[A>>2]|0)+156>>2]&4095](A);c[A+40>>2]=1;ko[c[(c[A>>2]|0)+132>>2]&4095](A);c[147210]=c[A+44>>2];mvc();do if(!(a[621067]|0)){c[D>>2]=114;A=Avc(589144,256,64,1,D,0)|0;if(!A){fa=0;break}fa=c[A+4>>2]|0}else{c[C>>2]=113;A=Jvc(589144,256,64,9,C,0)|0;if(!A){fa=0;break}fa=c[A+4>>2]|0}while(0);c[147204]=fa;c[e>>2]=fa;fa=c[137784]|0;do if(fa){do if((c[fa+36>>2]|0)!=(c[fa+4>>2]|0)){fRb(d,fa,e);C=c[d>>2]|0;D=c[fa+28>>2]|0;if((C|0)==-1){ga=D+(c[fa+32>>2]<<3)|0;break}else{ga=D+(C<<3)|0;break}}else ga=(c[fa+28>>2]|0)+(c[fa+32>>2]<<3)|0;while(0);C=c[137784]|0;if((ga|0)==((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)){N=103;break}D=c[ga+4>>2]|0;if(D){ha=C;ia=D}else N=103}else N=103;while(0);if((N|0)==103){ga=hQb(c[147204]|0)|0;ha=c[137784]|0;ia=ga}c[ia+40>>2]=1;c[n>>2]=c[147204];do if(ha){do if((c[ha+36>>2]|0)!=(c[ha+4>>2]|0)){fRb(d,ha,n);ia=c[d>>2]|0;ga=c[ha+28>>2]|0;if((ia|0)==-1){ja=ga+(c[ha+32>>2]<<3)|0;break}else{ja=ga+(ia<<3)|0;break}}else ja=(c[ha+28>>2]|0)+(c[ha+32>>2]<<3)|0;while(0);ia=c[137784]|0;if((ja|0)==((c[ia+28>>2]|0)+(c[ia+32>>2]<<3)|0)){N=112;break}ia=c[ja+4>>2]|0;if(ia)ka=ia;else N=112}else N=112;while(0);if((N|0)==112)ka=hQb(c[147204]|0)|0;ko[c[(c[ka>>2]|0)+132>>2]&4095](ka);c[147211]=c[147208];nvc();i=b;return}function pvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;e=c[147180]|0;if(!e){f=0;i=a;return f|0}c[d>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);g=c[b>>2]|0;h=c[e+28>>2]|0;if((g|0)==-1){j=h+(c[e+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((j|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[j+4>>2]|0,(e|0)!=0):0)k=e;else l=10}else l=10;if((l|0)==10)k=hQb(c[147180]|0)|0;f=k;i=a;return f|0}function qvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;e=c[147182]|0;if(!e){f=0;i=a;return f|0}c[d>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);g=c[b>>2]|0;h=c[e+28>>2]|0;if((g|0)==-1){j=h+(c[e+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((j|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[j+4>>2]|0,(e|0)!=0):0)k=e;else l=10}else l=10;if((l|0)==10)k=hQb(c[147182]|0)|0;f=k;i=a;return f|0}function rvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;e=c[147186]|0;if(!e){f=0;i=a;return f|0}c[d>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);g=c[b>>2]|0;h=c[e+28>>2]|0;if((g|0)==-1){j=h+(c[e+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((j|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[j+4>>2]|0,(e|0)!=0):0)k=e;else l=10}else l=10;if((l|0)==10)k=hQb(c[147186]|0)|0;f=k;i=a;return f|0}function svc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;e=c[147188]|0;if(!e){f=0;i=a;return f|0}c[d>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);g=c[b>>2]|0;h=c[e+28>>2]|0;if((g|0)==-1){j=h+(c[e+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((j|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[j+4>>2]|0,(e|0)!=0):0)k=e;else l=10}else l=10;if((l|0)==10)k=hQb(c[147188]|0)|0;f=k;i=a;return f|0}function tvc(a){a=a|0;return c[588824+(a<<2)>>2]|0}function uvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;e=c[147184]|0;if(!e){f=0;i=a;return f|0}c[d>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);g=c[b>>2]|0;h=c[e+28>>2]|0;if((g|0)==-1){j=h+(c[e+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((j|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[j+4>>2]|0,(e|0)!=0):0)k=e;else l=10}else l=10;if((l|0)==10)k=hQb(c[147184]|0)|0;f=k;i=a;return f|0}function vvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;c[d>>2]=c[147182];e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);f=c[b>>2]|0;g=c[e+28>>2]|0;if((f|0)==-1){h=g+(c[e+32>>2]<<3)|0;break}else{h=g+(f<<3)|0;break}}else h=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((h|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[h+4>>2]|0,(e|0)!=0):0){j=e;k=j+44|0;l=c[k>>2]|0;i=a;return l|0}}j=hQb(c[147182]|0)|0;k=j+44|0;l=c[k>>2]|0;i=a;return l|0}function wvc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;c[d>>2]=c[147184];e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);f=c[b>>2]|0;g=c[e+28>>2]|0;if((f|0)==-1){h=g+(c[e+32>>2]<<3)|0;break}else{h=g+(f<<3)|0;break}}else h=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((h|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[h+4>>2]|0,(e|0)!=0):0){j=e;k=j+44|0;l=c[k>>2]|0;i=a;return l|0}}j=hQb(c[147184]|0)|0;k=j+44|0;l=c[k>>2]|0;i=a;return l|0}function xvc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(136,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];oEc(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function yvc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(128,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];mFc(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function zvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=127;a[c+1>>0]=127;a[c+2>>0]=-1;a[c+3>>0]=127;return}function Avc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+4|0;k=h;c[k>>2]=c[153106];c[j+0>>2]=c[k+0>>2];k=xvc(4,j)|0;In[c[(c[k>>2]|0)+44>>2]&4095](k,61);gn[c[(c[k>>2]|0)+148>>2]&127](k,b,d,e,g&1,1,0)|0;if(a)In[c[(c[k>>2]|0)+36>>2]&4095](k,a);c[k+32>>2]=0;a=mo[c[(c[k>>2]|0)+116>>2]&4095](k)|0;e=mo[c[(c[k>>2]|0)+120>>2]&4095](k)|0;zEc(k);d=c[k+48>>2]|0;if(!d){l=5;m=0}else{l=c[d+32>>2]|0;m=c[d+8>>2]|0}d=TFc(l)|0;if((e|0)>0&(a|0)>0){l=da(d,a)|0;b=m;m=0;while(1){j=b;n=0;while(1){rn[c[f>>2]&127](k,j,n,m,a,e);n=n+1|0;if((n|0)==(a|0))break;else j=j+d|0}m=m+1|0;if((m|0)==(e|0))break;else b=b+l|0}}l=c[k>>2]|0;if(g){ko[c[l+152>>2]&4095](k);i=h;return k|0}else{ko[c[l+156>>2]&4095](k);i=h;return k|0}return 0}function Bvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=-1;a[c+1>>0]=-1>>8;a[c+2>>0]=-1>>16;a[c+3>>0]=-1>>24;return}function Cvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=0;a[c+1>>0]=0;a[c+2>>0]=0;a[c+3>>0]=0;return}function Dvc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=Im,j=Im,k=Im;h=c[147212]|0;g=h<<11^h;c[147212]=c[147214];c[147214]=c[147216];h=c[147218]|0;c[147216]=h;f=g>>>8^g^h^h>>>19;c[147218]=f;i=ea(ea(ea((f&8388607)>>>0)*ea(1.19209304e-07))*ea(6.28318548));j=ea(ea(ea(+V(+i))*ea(.5))+ea(.5));f=j<ea(0.0);k=f?ea(0.0):j;f=k>ea(1.0);h=~~ea(ea(k*ea(255.0))+ea(.5))>>>0&255;g=f?-1:h;a[d>>0]=g;k=ea(+W(+i));i=ea(ea(k*ea(-.5))+ea(.5));h=i<ea(0.0);j=h?ea(0.0):i;h=j>ea(1.0);f=~~ea(ea(j*ea(255.0))+ea(.5))>>>0&255;a[d+1>>0]=h?-1:f;j=ea(ea(k*ea(.5))+ea(.5));f=j<ea(0.0);k=f?ea(0.0):j;f=k>ea(1.0);h=~~ea(ea(k*ea(255.0))+ea(.5))>>>0&255;a[d+2>>0]=f?-1:h;a[d+3>>0]=g;return}function Evc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=-1;a[c+1>>0]=0;a[c+2>>0]=0;a[c+3>>0]=0;return}function Fvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=127;a[c+1>>0]=127;a[c+2>>0]=127;a[c+3>>0]=127;return}function Gvc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=i;PEi(b|0,c&255|0,4)|0;i=f;return}function Hvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=0;b=i;h=f>>1;f=g>>1;j=ea(ea(d-h|0)/ea(h|0));k=ea(ea(e-f|0)/ea(f|0));l=ea(ea(j*j)+ea(k*k));f=l>ea(1.0);k=ea(ea(ea(ea(1.0)-l)*ea(255.0))+ea(.5));l=f?ea(.5):k;if(l>=ea(0.0)){m=l;n=~~m;o=n&255;a[c>>0]=o;i=b;return}m=ea(l+ea(-.99999994));n=~~m;o=n&255;a[c>>0]=o;i=b;return}function Ivc(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=Im,j=Im;g=i;h=ea(ea(ea(v4b(ea(ea(d|0)/ea(f|0))))*ea(65535.0))+ea(.5));if(!(h>=ea(0.0)))j=ea(h+ea(-.99999994));else j=h;b[c>>1]=~~j;i=g;return}function Jvc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+4|0;k=h;c[k>>2]=c[153106];c[j+0>>2]=c[k+0>>2];k=xvc(4,j)|0;In[c[(c[k>>2]|0)+44>>2]&4095](k,61);gn[c[(c[k>>2]|0)+148>>2]&127](k,b,d,e,g&1,1,0)|0;if(a)In[c[(c[k>>2]|0)+36>>2]&4095](k,a);c[k+32>>2]=0;a=mo[c[(c[k>>2]|0)+116>>2]&4095](k)|0;e=mo[c[(c[k>>2]|0)+120>>2]&4095](k)|0;zEc(k);d=c[k+48>>2]|0;if(!d){l=5;m=0}else{l=c[d+32>>2]|0;m=c[d+8>>2]|0}d=(TFc(l)|0)>>>1;if((e|0)>0&(a|0)>0){l=da(d,a)|0;b=m;m=0;while(1){j=b;n=0;while(1){rn[c[f>>2]&127](k,j,n,m,a,e);n=n+1|0;if((n|0)==(a|0))break;else j=j+(d<<1)|0}m=m+1|0;if((m|0)==(e|0))break;else b=b+(l<<1)|0}}l=c[k>>2]|0;if(g){ko[c[l+152>>2]&4095](k);i=h;return k|0}else{ko[c[l+156>>2]&4095](k);i=h;return k|0}return 0}function Kvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=Im,j=Im;g=i;h=ea(ea(ea(v4b(ea(ea(d|0)/ea(f|0))))*ea(255.0))+ea(.5));if(!(h>=ea(0.0)))j=ea(h+ea(-.99999994));else j=h;a[c>>0]=~~j;i=g;return}function Lvc(b,c){b=b|0;c=c|0;a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;return}function Mvc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(148,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];ouc(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function Nvc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0,F=Im,G=0;d=i;i=i+32|0;e=d+12|0;f=d;h=a+48|0;j=f+4|0;k=f+8|0;l=0;do{m=mo[c[(c[a>>2]|0)+116>>2]&4095](a)|0;n=mo[c[(c[a>>2]|0)+120>>2]&4095](a)|0;o=ea(g[589240+(l<<2)>>2]);p=ea(g[589264+(l<<2)>>2]);q=ea(g[589288+(l<<2)>>2]);r=c[h>>2]|0;if(!r)s=5;else s=c[r+32>>2]|0;r=TFc(s)|0;t=ea(ea(1.0)/ea(m|0));u=ea(ea(1.0)/ea(n|0));zEc(a);v=c[h>>2]|0;if(!v)w=0;else{x=da(c[v+36>>2]|0,l)|0;w=(c[v+8>>2]|0)+x|0}a:do if((n|0)>0){x=589168+(l<<2)|0;v=589192+(l<<2)|0;y=589216+(l<<2)|0;if((m|0)<=0){z=0;while(1){z=z+1|0;if((z|0)==(n|0))break a}}z=da(r,m)|0;A=w;B=0;while(1){C=ea(p*ea(ea(ea(u*ea(B|0))*ea(2.0))+ea(-1.0)));D=A;E=0;while(1){F=ea(o*ea(ea(ea(t*ea(E|0))*ea(2.0))+ea(-1.0)));g[f>>2]=ea(0.0);g[j>>2]=ea(0.0);g[k>>2]=ea(0.0);g[f+(c[x>>2]<<2)>>2]=F;g[f+(c[v>>2]<<2)>>2]=C;g[f+(c[y>>2]<<2)>>2]=q;G=c[b>>2]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];In[G&4095](D,e);E=E+1|0;if((E|0)==(m|0))break;else D=D+r|0}B=B+1|0;if((B|0)==(n|0))break;else A=A+z|0}}while(0);l=l+1|0}while((l|0)!=6);i=d;return}function Ovc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=-2139062144;a[c+1>>0]=-2139062144>>8;a[c+2>>0]=-2139062144>>16;a[c+3>>0]=-2139062144>>24;return}function Pvc(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a[b>>0]=-2139062144;a[b+1>>0]=-2139062144>>8;a[b+2>>0]=-2139062144>>16;a[b+3>>0]=-2139062144>>24;return}function Qvc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h+4|0;k=h;c[k>>2]=c[153106];c[j+0>>2]=c[k+0>>2];k=yvc(4,j)|0;In[c[(c[k>>2]|0)+44>>2]&4095](k,61);rFc(k,b,d,e,f,0)|0;if(a)In[c[(c[k>>2]|0)+36>>2]&4095](k,a);a=mo[c[(c[k>>2]|0)+116>>2]&4095](k)|0;f=mo[c[(c[k>>2]|0)+120>>2]&4095](k)|0;e=c[k+108>>2]|0;d=c[k+116>>2]|0;b=TFc(c[k+112>>2]|0)|0;if((e|0)<=0){sFc(k,0);i=h;return k|0}j=(f|0)>0;l=(a|0)>0;m=da(b,a)|0;n=d;d=0;while(1){if(j){o=n;p=0;while(1){if(l){q=o;r=0;while(1){Wn[c[g>>2]&127](q,r,p,d,a,f,e);r=r+1|0;if((r|0)==(a|0))break;else q=q+b|0}s=o+m|0}else s=o;p=p+1|0;if((p|0)==(f|0)){t=s;break}else o=s}}else t=n;d=d+1|0;if((d|0)==(e|0))break;else n=t}sFc(k,0);i=h;return k|0}function Rvc(b,c){b=b|0;c=c|0;a[b>>0]=-2139062144;a[b+1>>0]=-2139062144>>8;a[b+2>>0]=-2139062144>>16;a[b+3>>0]=-2139062144>>24;return}function Svc(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0;a=i;h=ea(+U(+ea(ea(d|0)/ea(ea(f|0)+ea(-1.0))),.25));j=ea(ea(e|0)/ea(ea(g|0)+ea(-.5)));k=ea(ea(10.0)/ea(bEi(ea(ea(ea(ea(1.0)-j)*ea(.967999994))+ea(.0299999993)))));l=ea(ea(k*k)*ea(.25));k=ea(ea(ea(ea(l+ea(2.0))/ea(6.28318548))*ea(+U(+h,+l)))/ea(445.721954));g=k<ea(0.0);l=g?ea(0.0):k;g=l>ea(1.0);k=g?ea(1.0):l;do if(!(k<=ea(0.0))){if(k<=ea(.00313080009)){m=ea(k*ea(12.9200001));break}if(!(k<=ea(1.0))){m=ea(+U(+k,.454545468));break}else{m=ea(ea(ea(+U(+k,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else m=ea(0.0);while(0);if(!(j<=ea(.0500000007))|(f+-1|0)>(d|0))n=m;else n=ea(m*ea(j/ea(.0500000007)));j=ea(ea(n*ea(65535.0))+ea(.5));if(j>=ea(0.0)){o=j;p=~~o;q=p&65535;b[c>>1]=q;i=a;return}o=ea(j+ea(-.99999994));p=~~o;q=p&65535;b[c>>1]=q;i=a;return}function Tvc(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0;b=i;h=ea(+U(+ea(ea(d|0)/ea(ea(f|0)+ea(-1.0))),.25));j=ea(ea(e|0)/ea(ea(g|0)+ea(-.5)));k=ea(ea(10.0)/ea(bEi(ea(ea(ea(ea(1.0)-j)*ea(.967999994))+ea(.0299999993)))));l=ea(ea(k*k)*ea(.25));k=ea(ea(ea(ea(l+ea(2.0))/ea(6.28318548))*ea(+U(+h,+l)))/ea(445.721954));g=k<ea(0.0);l=g?ea(0.0):k;g=l>ea(1.0);k=g?ea(1.0):l;do if(!(k<=ea(0.0))){if(k<=ea(.00313080009)){m=ea(k*ea(12.9200001));break}if(!(k<=ea(1.0))){m=ea(+U(+k,.454545468));break}else{m=ea(ea(ea(+U(+k,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else m=ea(0.0);while(0);if(!(j<=ea(.0500000007))|(f+-1|0)>(d|0))n=m;else n=ea(m*ea(j/ea(.0500000007)));j=ea(ea(n*ea(255.0))+ea(.5));if(j>=ea(0.0)){o=j;p=~~o;q=p&255;a[c>>0]=q;i=b;return}o=ea(j+ea(-.99999994));p=~~o;q=p&255;a[c>>0]=q;i=b;return}function Uvc(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;var g=0;f=i;g=ync()|0;Co[c[(c[g>>2]|0)+24>>2]&3](g,a,b,d,e);i=f;return}function Vvc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);var g=0,h=Im,j=Im;g=i;co[c[(c[a>>2]|0)+576>>2]&2047](a,2,b);h=d?f:ea(0.0);j=d?ea(0.0):f;Zm[c[(c[a>>2]|0)+564>>2]&15](a,ea(1.0),ea(1.0),ea(1.0),ea(1.0));qn[c[(c[a>>2]|0)+568>>2]&7](a,ea(0.0),h,ea(0.0));qn[c[(c[a>>2]|0)+556>>2]&7](a,ea(0.0),ea(0.0),ea(.100000001));qn[c[(c[a>>2]|0)+568>>2]&7](a,ea(0.0),j,ea(0.0));qn[c[(c[a>>2]|0)+556>>2]&7](a,ea(0.0),ea(1.0),ea(.100000001));qn[c[(c[a>>2]|0)+568>>2]&7](a,e,j,ea(0.0));qn[c[(c[a>>2]|0)+556>>2]&7](a,ea(1.0),ea(1.0),ea(.100000001));qn[c[(c[a>>2]|0)+568>>2]&7](a,e,h,ea(0.0));qn[c[(c[a>>2]|0)+556>>2]&7](a,ea(1.0),ea(0.0),ea(.100000001));ko[c[(c[a>>2]|0)+580>>2]&4095](a);i=g;return}function Wvc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im;h=i;i=i+16|0;j=h+8|0;k=h;l=ync()|0;if(a[l+5833>>0]|0){En[c[(c[l>>2]|0)+48>>2]&127](l,b,d,e,f);i=h;return}m=c[(c[l>>2]|0)+52>>2]|0;n=c[d+4>>2]|0;if((n|0)==-1)o=d;else{c[k>>2]=n;c[j+0>>2]=c[k+0>>2];o=zvd(e,f,j,h+4|0)|0}p=ea(g[o>>2]);go[m&63](l,b,p);i=h;return}function Xvc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0;l=i;i=i+144|0;m=l+16|0;n=l+20|0;o=l+44|0;p=l+128|0;q=l;r=l+24|0;s=l+112|0;t=ync()|0;if(a[t+5833>>0]|0){Nn[c[(c[t>>2]|0)+148>>2]&31](t,b,d,e,f,h,j,k);i=l;return}_vc(p,b,j,k);u=ea(g[p>>2]);v=ea(g[p+4>>2]);w=ea(g[p+8>>2]);x=ea(g[p+12>>2]);g[o>>2]=u;g[o+4>>2]=v;g[o+8>>2]=w;g[o+12>>2]=x;_vc(q,d,j,k);x=ea(g[q>>2]);w=ea(g[q+4>>2]);v=ea(g[q+8>>2]);u=ea(g[q+12>>2]);g[o+16>>2]=x;g[o+20>>2]=w;g[o+24>>2]=v;g[o+28>>2]=u;_vc(r,e,j,k);u=ea(g[r>>2]);v=ea(g[r+4>>2]);w=ea(g[r+8>>2]);x=ea(g[r+12>>2]);g[o+32>>2]=u;g[o+36>>2]=v;g[o+40>>2]=w;g[o+44>>2]=x;_vc(s,f,j,k);x=ea(g[s>>2]);w=ea(g[s+4>>2]);v=ea(g[s+8>>2]);u=ea(g[s+12>>2]);g[o+48>>2]=x;g[o+52>>2]=w;g[o+56>>2]=v;g[o+60>>2]=u;s=c[h+4>>2]|0;if((s|0)==-1)y=h;else{c[n>>2]=s;c[m+0>>2]=c[n+0>>2];y=zvd(j,k,m,l+40|0)|0}g[o+64>>2]=ea(g[y>>2]);In[c[(c[t>>2]|0)+152>>2]&4095](t,o);i=l;return}function Yvc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;h=f+16|0;j=f;k=ync()|0;if(!(a[k+5833>>0]|0)){l=c[(c[k>>2]|0)+160>>2]|0;_vc(j,b,d,e);g[h>>2]=ea(g[j>>2]);g[h+4>>2]=ea(g[j+4>>2]);g[h+8>>2]=ea(g[j+8>>2]);g[h+12>>2]=ea(g[j+12>>2]);In[l&4095](k,h);i=f;return}else{Dn[c[(c[k>>2]|0)+156>>2]&511](k,b,d,e);i=f;return}}function Zvc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0;l=i;i=i+64|0;m=l+56|0;n=l+52|0;o=l+48|0;p=l+16|0;q=l;r=ync()|0;if(a[r+5833>>0]|0){Nn[c[(c[r>>2]|0)+164>>2]&31](r,b,d,e,f,h,j,k);i=l;return}c[p>>2]=b;_vc(q,h,j,k);s=ea(g[q>>2]);t=ea(g[q+4>>2]);u=ea(g[q+8>>2]);v=ea(g[q+12>>2]);g[p+4>>2]=s;g[p+8>>2]=t;g[p+12>>2]=u;g[p+16>>2]=v;q=c[d+4>>2]|0;if((q|0)==-1)w=d;else{c[o>>2]=q;c[m+0>>2]=c[o+0>>2];w=zvd(j,k,m,n)|0}g[p+20>>2]=ea(g[w>>2]);w=c[e+4>>2]|0;if((w|0)==-1)x=e;else{c[o>>2]=w;c[m+0>>2]=c[o+0>>2];x=zvd(j,k,m,n)|0}g[p+24>>2]=ea(g[x>>2]);x=c[f+4>>2]|0;if((x|0)==-1)y=f;else{c[o>>2]=x;c[m+0>>2]=c[o+0>>2];y=zvd(j,k,m,n)|0}g[p+28>>2]=ea(g[y>>2]);In[c[(c[r>>2]|0)+168>>2]&4095](r,p);i=l;return}function _vc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;l=c[b+32>>2]|0;if((l|0)!=-1){c[k>>2]=l;c[h+0>>2]=c[k+0>>2];l=Avd(d,e,h,j)|0;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];i=f;return}l=c[b+4>>2]|0;if((l|0)==-1)m=b;else{c[k>>2]=l;c[h+0>>2]=c[k+0>>2];m=zvd(d,e,h,j)|0}n=ea(g[m>>2]);m=c[b+12>>2]|0;if((m|0)==-1)o=b+8|0;else{c[k>>2]=m;c[h+0>>2]=c[k+0>>2];o=zvd(d,e,h,j)|0}p=ea(g[o>>2]);o=c[b+20>>2]|0;if((o|0)==-1)q=b+16|0;else{c[k>>2]=o;c[h+0>>2]=c[k+0>>2];q=zvd(d,e,h,j)|0}r=ea(g[q>>2]);q=c[b+28>>2]|0;if((q|0)==-1)s=b+24|0;else{c[k>>2]=q;c[h+0>>2]=c[k+0>>2];s=zvd(d,e,h,j)|0}t=ea(g[s>>2]);g[a>>2]=n;g[a+4>>2]=p;g[a+8>>2]=r;g[a+12>>2]=t;i=f;return}function $vc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;switch(a|0){case 10:case 34:case 35:case 41:case 45:case 46:{k=8;break}default:k=(a|0)==42?8:16}a=(d+3|0)/4|0;l=(g+3|0)/4|0;g=da((c+3|0)/4|0,k)|0;c=da((f+3|0)/4|0,k)|0;if((d|0)>0){d=c-g|0;k=(a|0)>1?a:1;if(h){f=e;m=b;n=0;while(1){YEi(f|0,m|0,g|0)|0;PEi(f+g|0,0,d|0)|0;n=n+1|0;if((n|0)>=(a|0))break;else{f=f+c|0;m=m+g|0}}}else{m=e;f=b;b=0;while(1){YEi(m|0,f|0,g|0)|0;b=b+1|0;if((b|0)>=(a|0))break;else{m=m+c|0;f=f+g|0}}}o=e+(da(c,k)|0)|0}else o=e;if(!h){i=j;return}PEi(o|0,0,da(l-a|0,c)|0)|0;i=j;return}function awc(b,c,e,f,g,h){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=(c+3|0)/4|0;k=(e+3|0)/4|0;l=j<<3;m=((g+3|0)/4|0)<<4;if((e|0)<=0){i=h;return}if((c|0)>0){n=f;o=b;p=0}else{b=0;do b=b+1|0;while((b|0)<(k|0));i=h;return}while(1){b=0;do{f=b<<4;c=n+f|0;e=c;a[e>>0]=-1;a[e+1>>0]=-1>>8;a[e+2>>0]=-1>>16;a[e+3>>0]=-1>>24;e=c+4|0;a[e>>0]=-1;a[e+1>>0]=-1>>8;a[e+2>>0]=-1>>16;a[e+3>>0]=-1>>24;e=o+(b<<3)|0;c=e;g=d[c>>0]|d[c+1>>0]<<8|d[c+2>>0]<<16|d[c+3>>0]<<24;c=e+4|0;e=d[c>>0]|d[c+1>>0]<<8|d[c+2>>0]<<16|d[c+3>>0]<<24;c=n+(f|8)|0;f=c;a[f>>0]=g;a[f+1>>0]=g>>8;a[f+2>>0]=g>>16;a[f+3>>0]=g>>24;g=c+4|0;a[g>>0]=e;a[g+1>>0]=e>>8;a[g+2>>0]=e>>16;a[g+3>>0]=e>>24;b=b+1|0}while((b|0)<(j|0));p=p+1|0;if((p|0)>=(k|0))break;else{n=n+m|0;o=o+l|0}}i=h;return}function bwc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+8>>2]|0;k=b+16|0;l=c[k>>2]|0;m=TFc(c[b>>2]|0)|0;if((e|0)>0){n=da(m,d+-1|0)|0;o=(m|0)>0;p=da(m,d)|0;q=(h|0)>(d|0);r=b+12|0;s=l;t=0;while(1){if(o){u=0;do{a[g+u>>0]=a[s+(u+n)>>0]|0;u=u+1|0}while((u|0)!=(m|0))}if(q){u=s+p|0;v=d;while(1){if(o){w=0;do{a[u+w>>0]=a[g+w>>0]|0;w=w+1|0}while((w|0)!=(m|0))}v=v+1|0;if((v|0)==(h|0))break;else u=u+m|0}}u=c[r>>2]|0;v=s+u|0;t=t+1|0;if((t|0)==(e|0)){x=u;y=v;break}else s=v}}else{x=c[b+12>>2]|0;y=l}l=c[k>>2]|0;k=b+12|0;b=da(x,e+-1|0)|0;x=l+b|0;s=(m|0)>0;if(s)YEi(g|0,l+(b+(da(m,d+-1|0)|0))|0,m|0)|0;if((j|0)<=(e|0)){i=f;return}b=da(m,d)|0;if((h|0)>(d|0)){z=y;A=e}else{l=y;y=e;while(1){YEi(l|0,x|0,b|0)|0;y=y+1|0;if((y|0)==(j|0))break;else l=l+(c[k>>2]|0)|0}i=f;return}while(1){YEi(z|0,x|0,b|0)|0;if(s){l=z+b|0;y=d;while(1){e=0;do{a[l+e>>0]=a[g+e>>0]|0;e=e+1|0}while((e|0)!=(m|0));y=y+1|0;if((y|0)==(h|0))break;else l=l+m|0}}else{l=d;do l=l+1|0;while((l|0)!=(h|0))}A=A+1|0;if((A|0)==(j|0))break;else z=z+(c[k>>2]|0)|0}i=f;return}function cwc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;f=b>>>0>65535;g=f?b>>>16:b;b=f?16:0;if(!(g&65280)){h=g;j=b}else{h=g>>>8;j=b|8}if(!(h&240)){k=h;l=j}else{k=h>>>4;l=j+4|0}j=(a[595568+k>>0]|0)+l|0;l=c>>>0>65535;k=l?c>>>16:c;c=l?16:0;if(!(k&65280)){m=k;n=c}else{m=k>>>8;n=c|8}if(!(m&240)){o=m;p=n}else{o=m>>>4;p=n+4|0}n=(a[595568+o>>0]|0)+p|0;p=(j|0)<(n|0)?n:j;j=d>>>0>65535;n=j?d>>>16:d;d=j?16:0;if(!(n&65280)){q=n;r=d}else{q=n>>>8;r=d|8}if(!(q&240)){s=q;t=r;u=595568+s|0;v=a[u>>0]|0;w=v<<24>>24;x=w+t|0;y=(p|0)<(x|0);z=y?x:p;A=z+1|0;i=e;return A|0}s=q>>>4;t=r+4|0;u=595568+s|0;v=a[u>>0]|0;w=v<<24>>24;x=w+t|0;y=(p|0)<(x|0);z=y?x:p;A=z+1|0;i=e;return A|0}function dwc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;switch(c|0){case 11:case 12:case 36:{e=da(((a+3|0)/4|0)<<4,(b+3|0)/4|0)|0;i=d;return e|0}case 10:case 35:{e=da(((a+3|0)/4|0)<<3,(b+3|0)/4|0)|0;i=d;return e|0}default:{f=c&-2;if((f|0)==30){e=((da((a|0)<16?32:a<<1,(b|0)<8?8:b)|0)+7|0)/8|0;i=d;return e|0}else if((f|0)==32){e=((da((a|0)<8?32:a<<2,(b|0)<8?8:b)|0)+7|0)/8|0;i=d;return e|0}else do switch(c|0){case 21:{e=da(a<<1,b)|0;i=d;return e|0}case 49:case 55:{e=da(((a+4|0)/5|0)<<4,(b+4|0)/5|0)|0;i=d;return e|0}case 53:case 59:{e=da(((a+11|0)/12|0)<<4,(b+11|0)/12|0)|0;i=d;return e|0}case 50:case 56:{e=da(((a+5|0)/6|0)<<4,(b+5|0)/6|0)|0;i=d;return e|0}case 51:case 57:{e=da(((a+7|0)/8|0)<<4,(b+7|0)/8|0)|0;i=d;return e|0}case 34:case 41:case 42:case 45:case 46:{e=((da((a|0)<4?16:a<<2,(b|0)<4?4:b)|0)+7|0)/8|0;i=d;return e|0}case 48:case 54:{e=da(((a+3|0)/4|0)<<4,(b+3|0)/4|0)|0;i=d;return e|0}case 52:case 58:{e=da(((a+9|0)/10|0)<<4,(b+9|0)/10|0)|0;i=d;return e|0}case 43:case 44:case 47:{e=(da((a|0)<4?32:a<<3,(b|0)<4?4:b)|0|7|0)/8|0;i=d;return e|0}default:{e=da(VFc(a,c)|0,b)|0;i=d;return e|0}}while(0)}}return 0}function ewc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((b|0)!=0&(a|0)!=0&(d|0)>0){f=0;g=0}else{h=0;i=e;return h|0}while(1){j=a>>g;k=b>>g;l=(dwc((j|0)<1?1:j,(k|0)<1?1:k,c)|0)+f|0;g=g+1|0;if((g|0)==(d|0)){h=l;break}else f=l}i=e;return h|0}function fwc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b>>>0>65535;g=f?b>>>16:b;h=f?16:0;if(!(g&65280)){j=g;k=h}else{j=g>>>8;k=h|8}if(!(j&240)){l=j;m=k}else{l=j>>>4;m=k+4|0}k=(a[595568+l>>0]|0)+m|0;m=c>>>0>65535;l=m?c>>>16:c;j=m?16:0;if(!(l&65280)){n=l;o=j}else{n=l>>>8;o=j|8}if(!(n&240)){p=n;q=o}else{p=n>>>4;q=o+4|0}o=(a[595568+p>>0]|0)+q|0;q=(k|0)<(o|0)?o:k;k=(q|0)<0?1:q+1|0;if((c|0)!=0&(b|0)!=0&(k|0)>0){r=0;s=0}else{t=0;i=e;return t|0}while(1){q=b>>s;o=c>>s;p=(dwc((q|0)<1?1:q,(o|0)<1?1:o,d)|0)+r|0;s=s+1|0;if((s|0)==(k|0)){t=p;break}else r=p}i=e;return t|0}function gwc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;j=i;i=i+144|0;k=j+108|0;l=j+80|0;m=j+20|0;n=j+40|0;o=j+112|0;p=j;q=j+60|0;r=j+88|0;s=j+84|0;t=TFc(h)|0;u=(cwc(e,f,g)|0)+-1|0;if((u|0)<=0){v=0;w=c[153134]|0;c[s>>2]=w;c[k+0>>2]=c[s+0>>2];eOb(v,k);i=j;return}x=m+4|0;y=m+8|0;z=m+12|0;A=m+16|0;B=n+4|0;C=n+8|0;D=n+12|0;E=n+16|0;F=o+4|0;G=o+8|0;H=o+12|0;I=o+16|0;J=p+4|0;K=p+8|0;L=p+12|0;M=p+16|0;N=(h|0)<9;O=(h|0)>0;P=(h+-13|0)>>>0<9;Q=q+4|0;R=q+8|0;S=q+12|0;T=q+16|0;U=r+4|0;V=r+8|0;W=r+12|0;X=r+16|0;Y=f;f=g;g=e;e=0;Z=b;b=0;while(1){_=(g|0)/2|0;$=g;g=(_|0)<1?1:_;aa=(Y|0)/2|0;ba=Y;Y=(aa|0)<1?1:aa;ca=(f|0)/2|0;ea=f;f=(ca|0)<1?1:ca;ca=da($,ba)|0;fa=Z;Z=Z+(da(da(ea,t)|0,ca)|0)|0;if((ea|0)>1){if(!b){ea=(da(da(g,t)|0,Y)|0)+t|0;c[l>>2]=c[153134];c[k+0>>2]=c[l+0>>2];ga=cOb(ea,16,k,0,3653512,265)|0}else ga=b;if((f|0)>0){ea=da($,t)|0;ha=da(ca,t)|0;ca=ha<<1;ia=da(g,t)|0;ja=(ga|0)!=0;ka=da(ia,Y)|0;la=(ka|0)>0;ma=(g|0)>0&(Y|0)>0&O;na=($|0)>0&(ba|0)>0&O;oa=da(t,(_|0)>1?_:1)|0;_=da(oa,(aa|0)>1?aa:1)|0;aa=0;oa=Z;pa=fa;while(1){c[x>>2]=$;c[y>>2]=ba;c[m>>2]=h;c[z>>2]=ea;c[A>>2]=(pa|0)!=0&(na&(N|P))?pa:0;qa=pa+ha|0;c[B>>2]=$;c[C>>2]=ba;c[n>>2]=h;c[D>>2]=ea;c[E>>2]=(qa|0)!=0&(na&(N|P))?qa:0;pa=pa+ca|0;c[F>>2]=g;c[G>>2]=Y;c[o>>2]=h;c[H>>2]=ia;c[I>>2]=(oa|0)!=0&(ma&(N|P))?oa:0;hwc(o,m,2);c[J>>2]=g;c[K>>2]=Y;c[p>>2]=h;c[L>>2]=ia;c[M>>2]=ja&(ma&(N|P))?ga:0;hwc(p,n,2);if(la){qa=0;do{ra=oa+qa|0;a[ra>>0]=((d[ga+qa>>0]|0)+(d[ra>>0]|0)|0)>>>1;qa=qa+1|0}while((qa|0)!=(_|0))}aa=aa+1|0;if((aa|0)>=(f|0)){sa=ga;break}else oa=oa+ka|0}}else sa=ga}else{ka=da($,t)|0;c[Q>>2]=$;c[R>>2]=ba;c[q>>2]=h;c[S>>2]=ka;if((fa|0)!=0?($|0)>0&(ba|0)>0&O&(N|P):0)ta=fa;else ta=0;c[T>>2]=ta;ka=da(g,t)|0;c[U>>2]=g;c[V>>2]=Y;c[r>>2]=h;c[W>>2]=ka;if((Z|0)!=0?(g|0)>0&(Y|0)>0&O&(N|P):0)ua=Z;else ua=0;c[X>>2]=ua;hwc(r,q,2);sa=b}e=e+1|0;if((e|0)==(u|0)){v=sa;break}else b=sa}w=c[153134]|0;c[s>>2]=w;c[k+0>>2]=c[s+0>>2];eOb(v,k);i=j;return}function hwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+144|0;f=e+100|0;g=e+72|0;h=e+28|0;j=e;k=a+16|0;if(!(c[k>>2]|0)){i=e;return}l=b+16|0;if(!(c[l>>2]|0)){i=e;return}m=c[b+4>>2]|0;n=c[b+8>>2]|0;o=c[b+12>>2]|0;kwc(g,c[b>>2]|0);Zoe(f,m,n,o,g,c[l>>2]|0);l=c[a+4>>2]|0;g=c[a+8>>2]|0;o=c[a+12>>2]|0;kwc(j,c[a>>2]|0);Zoe(h,l,g,o,j,c[k>>2]|0);Gle(h,f,d);i=e;return}function iwc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;c[a+4>>2]=b;c[a+8>>2]=d;c[a>>2]=f;c[a+12>>2]=e;if(g){if((f|0)<9)j=1;else j=(f+-13|0)>>>0<9;if((b|0)>0&(d|0)>0&(f|0)>0&j){c[a+16>>2]=g;i=h;return}}c[a+16>>2]=0;i=h;return}function jwc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+80|0;d=b+28|0;e=b;f=a+16|0;if(!(c[f>>2]|0)){i=b;return}g=c[a+4>>2]|0;h=c[a+8>>2]|0;j=c[a+12>>2]|0;kwc(e,c[a>>2]|0);Zoe(d,g,h,j,e,c[f>>2]|0);Hle(d);i=b;return}function kwc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;do switch(d|0){case 3:{c[b>>2]=-1879048168;c[b+4>>2]=255;c[b+8>>2]=65280;c[b+12>>2]=16711680;c[b+16>>2]=0;a[b+26>>0]=7;a[b+22>>0]=8;a[b+25>>0]=15;a[b+21>>0]=8;a[b+24>>0]=23;a[b+20>>0]=8;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}case 2:{c[b>>2]=-1879048176;c[b+4>>2]=3840;c[b+8>>2]=240;c[b+12>>2]=15;c[b+16>>2]=61440;a[b+26>>0]=11;a[b+22>>0]=4;a[b+25>>0]=7;a[b+21>>0]=4;a[b+24>>0]=3;a[b+20>>0]=4;a[b+27>>0]=15;a[b+23>>0]=4;i=e;return}case 4:{c[b>>2]=-1879048160;c[b+4>>2]=255;c[b+8>>2]=65280;c[b+12>>2]=16711680;c[b+16>>2]=-16777216;a[b+26>>0]=7;a[b+22>>0]=8;a[b+25>>0]=15;a[b+21>>0]=8;a[b+24>>0]=23;a[b+20>>0]=8;a[b+27>>0]=31;a[b+23>>0]=8;i=e;return}case 8:{c[b>>2]=-1879048168;c[b+4>>2]=16711680;c[b+8>>2]=65280;c[b+12>>2]=255;c[b+16>>2]=0;a[b+26>>0]=23;a[b+22>>0]=8;a[b+25>>0]=15;a[b+21>>0]=8;a[b+24>>0]=7;a[b+20>>0]=8;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}case 17:{c[b>>2]=1342177344;c[b+4>>2]=1;c[b+8>>2]=2;c[b+12>>2]=4;c[b+16>>2]=8;a[b+26>>0]=0;a[b+22>>0]=1;a[b+25>>0]=1;a[b+21>>0]=1;a[b+24>>0]=2;a[b+20>>0]=1;a[b+27>>0]=3;a[b+23>>0]=1;i=e;return}case 15:{c[b>>2]=1342177296;c[b+4>>2]=1;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;a[b+26>>0]=0;a[b+22>>0]=1;a[b+25>>0]=-1;a[b+21>>0]=0;a[b+24>>0]=-1;a[b+20>>0]=0;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}case 19:{c[b>>2]=805306432;c[b+4>>2]=1;c[b+8>>2]=2;c[b+12>>2]=0;c[b+16>>2]=0;a[b+26>>0]=0;a[b+22>>0]=1;a[b+25>>0]=1;a[b+21>>0]=1;a[b+24>>0]=-1;a[b+20>>0]=0;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}case 7:{c[b>>2]=-1879048176;c[b+4>>2]=63488;c[b+8>>2]=2016;c[b+12>>2]=31;c[b+16>>2]=0;a[b+26>>0]=15;a[b+22>>0]=5;a[b+25>>0]=10;a[b+21>>0]=6;a[b+24>>0]=4;a[b+20>>0]=5;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}case 1:{c[b>>2]=-2013265912;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=255;f=b+20|0;c[f>>2]=0;g=b+24|0;c[g>>2]=0;a[g>>0]=-1;a[f>>0]=0;a[b+27>>0]=7;a[b+23>>0]=8;i=e;return}case 13:{c[b>>2]=-1879048176;c[b+4>>2]=61440;c[b+8>>2]=3840;c[b+12>>2]=240;c[b+16>>2]=15;a[b+26>>0]=15;a[b+22>>0]=4;a[b+25>>0]=11;a[b+21>>0]=4;a[b+24>>0]=7;a[b+20>>0]=4;a[b+27>>0]=3;a[b+23>>0]=4;i=e;return}case 6:{c[b>>2]=805306496;c[b+4>>2]=2;c[b+8>>2]=4;c[b+12>>2]=8;c[b+16>>2]=1;a[b+26>>0]=1;a[b+22>>0]=1;a[b+25>>0]=2;a[b+21>>0]=1;a[b+24>>0]=3;a[b+20>>0]=1;a[b+27>>0]=0;a[b+23>>0]=1;i=e;return}case 5:{c[b>>2]=-1879048160;c[b+4>>2]=65280;c[b+8>>2]=16711680;c[b+12>>2]=-16777216;c[b+16>>2]=255;a[b+26>>0]=15;a[b+22>>0]=8;a[b+25>>0]=23;a[b+21>>0]=8;a[b+24>>0]=31;a[b+20>>0]=8;a[b+27>>0]=7;a[b+23>>0]=8;i=e;return}case 14:{c[b>>2]=-1879048160;c[b+4>>2]=16711680;c[b+8>>2]=65280;c[b+12>>2]=255;c[b+16>>2]=-16777216;a[b+26>>0]=23;a[b+22>>0]=8;a[b+25>>0]=15;a[b+21>>0]=8;a[b+24>>0]=7;a[b+20>>0]=8;a[b+27>>0]=31;a[b+23>>0]=8;i=e;return}case 16:{c[b>>2]=1342177312;c[b+4>>2]=1;c[b+8>>2]=2;c[b+12>>2]=0;c[b+16>>2]=0;a[b+26>>0]=0;a[b+22>>0]=1;a[b+25>>0]=1;a[b+21>>0]=1;a[b+24>>0]=-1;a[b+20>>0]=0;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}case 20:{c[b>>2]=805306496;c[b+4>>2]=1;c[b+8>>2]=2;c[b+12>>2]=4;c[b+16>>2]=8;a[b+26>>0]=0;a[b+22>>0]=1;a[b+25>>0]=1;a[b+21>>0]=1;a[b+24>>0]=2;a[b+20>>0]=1;a[b+27>>0]=3;a[b+23>>0]=1;i=e;return}case 18:{c[b>>2]=805306400;c[b+4>>2]=1;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;a[b+26>>0]=0;a[b+22>>0]=1;a[b+25>>0]=-1;a[b+21>>0]=0;a[b+24>>0]=-1;a[b+20>>0]=0;a[b+27>>0]=-1;a[b+23>>0]=0;i=e;return}default:{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;i=e;return}}while(0)}function lwc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b+16|0;if(!(c[j>>2]|0)){k=c[b>>2]|0;c[a+4>>2]=0;c[a+8>>2]=0;c[a>>2]=k;c[a+12>>2]=0;c[a+16>>2]=0;i=h;return}k=b+4|0;if((d|0)<0)l=0;else{m=c[k>>2]|0;l=(m|0)<(d|0)?m:d}d=c[b+8>>2]|0;if((e|0)<0)n=0;else n=(d|0)<(e|0)?d:e;e=l+f|0;f=c[k>>2]|0;k=((e|0)<(f|0)?e:f)-l|0;f=n+g|0;g=((f|0)<(d|0)?f:d)-n|0;d=(k|0)>0;f=(g|0)>0;e=TFc(c[b>>2]|0)|0;m=c[b+12>>2]|0;o=c[b>>2]|0;b=(c[j>>2]|0)+((da(m,n)|0)+(da(e,l)|0))|0;c[a+4>>2]=d?k:0;c[a+8>>2]=f?g:0;c[a>>2]=o;c[a+12>>2]=m;if(b){if((o|0)<9)p=1;else p=(o+-13|0)>>>0<9;if(d&f&(o|0)>0&p){c[a+16>>2]=b;i=h;return}}c[a+16>>2]=0;i=h;return}function mwc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+4|0;h=f;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;j=a+8|0;c[j>>2]=d;k=a+4|0;c[k>>2]=b;c[a>>2]=e;l=TFc(e)|0;m=da(c[k>>2]|0,l)|0;c[a+12>>2]=m;if((e|0)<9)n=1;else n=(e+-13|0)>>>0<9;if(!((b|0)>0&(d|0)>0&(e|0)>0&n)){o=0;p=a+16|0;c[p>>2]=o;i=f;return}n=da(c[j>>2]|0,m)|0;m=(UFc(c[a>>2]|0)|0)+n|0;c[h>>2]=c[153068];c[g+0>>2]=c[h+0>>2];o=cOb(m,16,g,0,3653512,441)|0;p=a+16|0;c[p>>2]=o;i=f;return}function nwc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;l=a+12|0;m=a+8|0;n=da(c[m>>2]|0,c[l>>2]|0)|0;o=(TFc(c[a>>2]|0)|0)+n|0;n=a+4|0;c[n>>2]=b;c[m>>2]=d;c[a>>2]=e;d=TFc(e)|0;e=da(c[n>>2]|0,d)|0;c[l>>2]=e;b=(da(e,c[m>>2]|0)|0)+d|0;if(((o|0)>=(b|0)|f)&((o|0)==(b|0)|f^1)){i=g;return}f=a+16|0;b=c[f>>2]|0;c[j>>2]=c[153068];c[h+0>>2]=c[j+0>>2];eOb(b,h);c[f>>2]=0;b=c[a>>2]|0;if(!b){i=g;return}a=c[m>>2]|0;if((b|0)<9)p=1;else p=(b+-13|0)>>>0<9;if(!((c[n>>2]|0)>0&(a|0)>0&(b|0)>0&p)){i=g;return}p=da(a,c[l>>2]|0)|0;l=(UFc(b)|0)+p|0;c[k>>2]=c[153068];c[h+0>>2]=c[k+0>>2];c[f>>2]=cOb(l,16,h,0,3653512,482)|0;i=g;return}function owc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+4|0;m=h;n=da(TFc(f)|0,d)|0;o=(f|0)<9;if(o)p=1;else p=(f+-13|0)>>>0<9;q=(d|0)>0&(e|0)>0&(f|0)>0;if(q&p){p=da(n,e)|0;r=(UFc(c[a>>2]|0)|0)+p|0;c[k>>2]=c[153068];c[j+0>>2]=c[k+0>>2];s=cOb(r,16,j,0,3653512,503)|0}else s=0;c[l+4>>2]=d;c[l+8>>2]=e;c[l>>2]=f;c[l+12>>2]=n;if(s){if(o)t=1;else t=(f+-13|0)>>>0<9;if(q&t)c[l+16>>2]=s;else u=10}else u=10;if((u|0)==10)c[l+16>>2]=0;hwc(l,b,g);g=a+16|0;b=c[g>>2]|0;c[m>>2]=c[153068];c[j+0>>2]=c[m+0>>2];eOb(b,j);c[a+8>>2]=e;c[a+4>>2]=d;c[a>>2]=f;c[a+12>>2]=n;c[g>>2]=s;i=h;return}function pwc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;if(((c[a+4>>2]|0)==(b|0)?(c[a+8>>2]|0)==(d|0):0)?(c[a>>2]|0)==(e|0):0){i=g;return}owc(a,a,b,d,e,f);i=g;return}function qwc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0,f=Im,h=Im,j=Im,k=Im,l=Im;e=i;a:do switch(b|0){case 5:case 2:{if(c){f=ea(0.0);h=ea(2.20000005);j=ea(d*ea(97.005867));break a}do if(!(d<=ea(0.0))){if(d<=ea(.00313080009)){k=ea(d*ea(12.9200001));break}if(!(d<=ea(1.0))){k=ea(+U(+d,.454545468));break}else{k=ea(ea(ea(+U(+d,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else k=ea(0.0);while(0);f=ea(0.0);h=ea(1.0);j=ea(k*ea(8.0));break}case 0:{if(!c)if(!(d<=ea(0.0))){if(d<=ea(.00313080009)){f=ea(0.0);h=ea(.00999999977);j=ea(d*ea(12.9200001));break a}if(!(d<=ea(1.0))){f=ea(0.0);h=ea(.00999999977);j=ea(+U(+d,.454545468));break a}else{f=ea(0.0);h=ea(.00999999977);j=ea(ea(ea(+U(+d,.416660011))*ea(1.05499995))+ea(-.0549999997));break a}}else{f=ea(0.0);h=ea(.00999999977);j=ea(0.0)}else{f=ea(0.0);h=ea(.00999999977);j=d}break}case 4:{f=ea(-1.0);h=ea(.00999999977);j=ea(2.0);break}case 1:case 7:{do if(!(d<=ea(0.0))){if(d<=ea(.00313080009)){l=ea(d*ea(12.9200001));break}if(!(d<=ea(1.0))){l=ea(+U(+d,.454545468));break}else{l=ea(ea(ea(+U(+d,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else l=ea(0.0);while(0);f=ea(0.0);h=ea(.00999999977);j=ea(l*ea(2.0));break}default:{f=ea(0.0);h=ea(.00999999977);j=ea(1.0)}}while(0);g[a>>2]=j;g[a+4>>2]=h;g[a+8>>2]=f;g[a+12>>2]=ea(0.0);i=e;return}function rwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+48|0;e=d+8|0;f=i;i=i+168|0;c[f>>2]=0;g=d+32|0;h=d+36|0;j=d+40|0;k=d+4|0;l=d;m=d+12|0;s=0;n=Ka(249,589312,0,0,0)|0;o=s;s=0;if((o|0)!=0&(t|0)!=0){p=WEi(c[o>>2]|0,f)|0;if(!p)lk(o|0,t|0);H=t}else p=-1;if((p|0)!=1){c[k>>2]=n;if(!n){q=0;i=d;return q|0}s=0;p=Lb(3553,n|0)|0;o=s;s=0;if((o|0)!=0&(t|0)!=0){r=WEi(c[o>>2]|0,f)|0;if(!r)lk(o|0,t|0);H=t}else r=-1;if((r|0)!=1){c[l>>2]=p;if(!p){q=0;i=d;return q|0}s=0;p=Wb(1731,n|0,2599,156)|0;n=s;s=0;if((n|0)!=0&(t|0)!=0){u=WEi(c[n>>2]|0,f)|0;if(!u)lk(n|0,t|0);H=t}else u=-1;if((u|0)!=1){REi(p,1,f|0)|0;s=0;p=s;s=0;if((p|0)!=0&(t|0)!=0){v=WEi(c[p>>2]|0,f)|0;if(!v)lk(p|0,t|0);H=t}else v=-1;if((v|0)!=1)w=0;else w=H}else w=H}else w=H}else w=H;a:while(1){if(w){q=0;x=34;break}v=b+12|0;p=c[v>>2]|0;do if((p&2147479552)>>>0<4096)if((p|0)>-1){c[v>>2]=4096;u=c[b>>2]|0;c[h>>2]=c[b+4>>2];s=0;c[e+0>>2]=c[h+0>>2];n=Ha(110,u|0,4096,1,e|0,0,3653512,370)|0;u=s;s=0;if((u|0)!=0&(t|0)!=0){y=WEi(c[u>>2]|0,f)|0;if(!y)lk(u|0,t|0);H=t}else y=-1;if((y|0)==1){w=H;continue a}c[b>>2]=n;break}else{c[j>>2]=c[b+4>>2];s=0;c[e+0>>2]=c[j+0>>2];n=ja(109,4096,1,e|0,0,3653512,352)|0;u=s;s=0;if((u|0)!=0&(t|0)!=0){z=WEi(c[u>>2]|0,f)|0;if(!z)lk(u|0,t|0);H=t}else z=-1;if((z|0)==1){w=H;continue a}YEi(n|0,c[b>>2]|0,c[b+8>>2]|0)|0;c[v>>2]=4096;c[b>>2]=n;break}while(0);v=c[k>>2]|0;s=0;bb(337,v|0,b|0,1814,3511);p=s;s=0;if((p|0)!=0&(t|0)!=0){A=WEi(c[p>>2]|0,f)|0;if(!A)lk(p|0,t|0);H=t}else A=-1;if((A|0)==1){w=H;continue}s=0;gb(2669,v|0,1);p=s;s=0;if((p|0)!=0&(t|0)!=0){B=WEi(c[p>>2]|0,f)|0;if(!B)lk(p|0,t|0);H=t}else B=-1;if((B|0)==1){w=H;continue}s=0;p=Lb(3554,c[a>>2]|0)|0;n=s;s=0;if((n|0)!=0&(t|0)!=0){C=WEi(c[n>>2]|0,f)|0;if(!C)lk(n|0,t|0);H=t}else C=-1;if((C|0)==1){w=H;continue}n=p?4:3;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;u=a+4|0;if((c[a>>2]|0)==(n|0)){D=a+8|0;E=v;F=a}else{v=a+8|0;s=0;cb(98,m|0,c[u>>2]|0,c[v>>2]|0,n|0,1);n=s;s=0;if((n|0)!=0&(t|0)!=0){G=WEi(c[n>>2]|0,f)|0;if(!G)lk(n|0,t|0);H=t}else G=-1;if((G|0)==1){w=H;continue}s=0;Cb(1815,m|0,a|0,0);n=s;s=0;if((n|0)!=0&(t|0)!=0){I=WEi(c[n>>2]|0,f)|0;if(!I)lk(n|0,t|0);H=t}else I=-1;if((I|0)==1){w=H;continue}D=v;E=c[k>>2]|0;F=m}v=c[l>>2]|0;s=0;wb(8,E|0,v|0,c[u>>2]|0,c[D>>2]|0,8,(p?6:2)|0,0,0,0);p=s;s=0;if((p|0)!=0&(t|0)!=0){J=WEi(c[p>>2]|0,f)|0;if(!J)lk(p|0,t|0);H=t}else J=-1;if((J|0)==1){w=H;continue}s=0;gb(2670,E|0,v|0);p=s;s=0;if((p|0)!=0&(t|0)!=0){K=WEi(c[p>>2]|0,f)|0;if(!K)lk(p|0,t|0);H=t}else K=-1;if((K|0)==1){w=H;continue}p=F+8|0;u=c[p>>2]|0;if((u|0)>0){n=F+16|0;r=F+12|0;o=u;u=E;L=0;while(1){M=(c[n>>2]|0)+(da(c[r>>2]|0,o+~L|0)|0)|0;s=0;gb(2671,u|0,M|0);M=s;s=0;if((M|0)!=0&(t|0)!=0){N=WEi(c[M>>2]|0,f)|0;if(!N)lk(M|0,t|0);H=t}else N=-1;if((N|0)==1){w=H;continue a}L=L+1|0;o=c[p>>2]|0;u=c[k>>2]|0;if((o|0)<=(L|0))break}O=u;P=c[l>>2]|0}else{O=E;P=v}s=0;gb(2672,O|0,P|0);L=s;s=0;if((L|0)!=0&(t|0)!=0){Q=WEi(c[L>>2]|0,f)|0;if(!Q)lk(L|0,t|0);H=t}else Q=-1;if((Q|0)==1){w=H;continue}s=0;gb(2673,k|0,l|0);L=s;s=0;if((L|0)!=0&(t|0)!=0){R=WEi(c[L>>2]|0,f)|0;if(!R)lk(L|0,t|0);H=t}else R=-1;if((R|0)==1){w=H;continue}S=(c[b+8>>2]|0)!=0;L=c[m+16>>2]|0;c[g>>2]=c[153068];s=0;c[e+0>>2]=c[g+0>>2];gb(2674,L|0,e|0);L=s;s=0;if((L|0)!=0&(t|0)!=0){T=WEi(c[L>>2]|0,f)|0;if(!T)lk(L|0,t|0);H=t}else T=-1;if((T|0)==1)w=H;else break}if((x|0)==34){i=d;return q|0}q=S;i=d;return q|0}function swc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+8|0;c[h>>2]=0;j=g+12|0;c[j>>2]=0;k=g+4|0;c[k>>2]=60;if(rwc(a,g)|0)l=vqd(c[g>>2]|0,c[h>>2]|0,b)|0;else l=0;if((c[j>>2]|0)<=-1){i=d;return l|0}j=c[g>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[g>>2]=0;i=d;return l|0}function twc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wwc(xQ(a)|0,b,c);i=d;return}function uwc(a){a=a|0;return}function vwc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[a>>2]|0;k=b-j|0;b=a+8|0;l=c[b>>2]|0;m=l-k|0;n=e-d|0;e=l+n|0;c[b>>2]=e;l=a+12|0;o=c[l>>2]|0;p=o&2147483647;do if(p>>>0<e>>>0?(q=o<<1,r=q>>>0>e>>>0?q:e,p>>>0<r>>>0):0)if((o|0)>-1){c[l>>2]=r;c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];q=hOb(j,r,1,g,0,3653512,370)|0;c[a>>2]=q;s=q;break}else{c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];q=cOb(r,1,g,0,3653512,352)|0;YEi(q|0,c[a>>2]|0,c[b>>2]|0)|0;c[l>>2]=r;c[a>>2]=q;s=q;break}else s=j;while(0);j=s+k|0;aFi(s+(k+n)|0,j|0,m|0)|0;YEi(j|0,d|0,n|0)|0;i=f;return j|0}function wwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;l=a+8|0;m=(c[l>>2]|0)+d|0;do if(k>>>0<m>>>0?(n=(k>>>1)+k|0,o=m>>>0<n>>>0?n:m,k>>>0<o>>>0):0)if((j|0)>-1){c[h>>2]=o;n=c[a>>2]|0;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];c[a>>2]=hOb(n,o,1,f,0,3653512,370)|0;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=cOb(o,1,f,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,c[l>>2]|0)|0;c[h>>2]=o;c[a>>2]=n;break}while(0);vwc(a,(c[a>>2]|0)+(c[l>>2]|0)|0,b,b+d|0)|0;i=e;return}function xwc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];iSb(b,g,e);c[b>>2]=589416;c[b+76>>2]=0;c[b+80>>2]=0;e=b+72|0;g=b+24|0;h=g+48|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));c[e>>2]=60;c[b+84>>2]=2;c[b+88>>2]=1;c[b+92>>2]=1;a[b+96>>0]=0;kkc(b+100|0);c[b+124>>2]=0;c[b+132>>2]=0;c[b+136>>2]=0;c[b+128>>2]=60;c[b+140>>2]=0;c[b+148>>2]=0;c[b+152>>2]=0;c[b+144>>2]=60;c[b+156>>2]=0;c[b+164>>2]=0;c[b+168>>2]=0;c[b+160>>2]=60;c[b+172>>2]=0;c[b+180>>2]=0;c[b+184>>2]=0;c[b+176>>2]=60;c[b+192>>2]=0;c[b+196>>2]=0;c[b+200>>2]=0;c[b+204>>2]=25;i=f;return}function ywc(a){a=a|0;var b=0;b=i;c[a+92>>2]=1;c[a+204>>2]=25;lkc(a+100|0);i=b;return}function zwc(a){a=a|0;return a+124|0}function Awc(a,b){a=a|0;b=b|0;b=i;Bwc(a);i=b;return}function Bwc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+24|0;h=c[g>>2]|0;if(h)BCi(h);h=c[a+76>>2]|0;j=zCi(h>>>0>536870911?-1:h<<3)|0;k=(h|0)==0;if(k){c[g>>2]=j;c[a+28>>2]=h;i=b;return}l=j+(h<<3)|0;m=j;do{c[m+4>>2]=0;c[m>>2]=0;m=m+8|0}while((m|0)!=(l|0));c[g>>2]=j;c[a+28>>2]=h;if(k){i=b;return}k=a+68|0;a=0;do{j=(c[k>>2]|0)+(a<<3)|0;l=c[j>>2]|0;do if(!l)n=20;else{c[e>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(d,m,e);o=c[d>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){q=p+(c[m+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0)r=m;else n=18}else n=18;if((n|0)==18){n=0;m=hQb(c[j>>2]|0)|0;if(!m){n=20;break}else r=m}s=c[r+44>>2]|0}while(0);if((n|0)==20){n=0;s=vvc()|0}j=(c[k>>2]|0)+(a<<3)+4|0;l=c[j>>2]|0;do if(!l)n=32;else{c[f>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(d,m,f);o=c[d>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){t=p+(c[m+32>>2]<<3)|0;break}else{t=p+(o<<3)|0;break}}else t=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((t|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[t+4>>2]|0,(m|0)!=0):0)u=m;else n=30}else n=30;if((n|0)==30){n=0;m=hQb(c[j>>2]|0)|0;if(!m){n=32;break}else u=m}v=c[u+44>>2]|0}while(0);if((n|0)==32){n=0;v=vvc()|0}j=(c[g>>2]|0)+(a<<3)|0;c[j>>2]=s;c[j+4>>2]=v;a=a+1|0}while((a|0)!=(h|0));i=b;return}function Cwc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+60|0;a=c[f>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0)l=a;else m=10}else m=10;if((m|0)==10)l=hQb(c[f>>2]|0)|0;g=l;i=b;return g|0}function Dwc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;if((c[a+84>>2]|0)==2){j=a+64|0;k=c[j>>2]|0;if(!k){l=0;i=b;return l|0}c[h>>2]=k;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,h);m=c[d>>2]|0;n=c[k+28>>2]|0;if((m|0)==-1){o=n+(c[k+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if(!((o|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(c[o+4>>2]|0)!=0:0))p=11}else p=11;if((p|0)==11?(hQb(c[j>>2]|0)|0)==0:0){l=0;i=b;return l|0}c[g>>2]=c[j>>2];o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(d,o,g);k=c[d>>2]|0;h=c[o+28>>2]|0;if((k|0)==-1){q=h+(c[o+32>>2]<<3)|0;break}else{q=h+(k<<3)|0;break}}else q=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((q|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[q+4>>2]|0,(o|0)!=0):0)r=o;else p=20}else p=20;if((p|0)==20)r=hQb(c[j>>2]|0)|0;l=(c[r+68>>2]|0)>0;i=b;return l|0}else{r=a+60|0;a=c[r>>2]|0;if(!a){l=0;i=b;return l|0}c[f>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,f);j=c[d>>2]|0;o=c[a+28>>2]|0;if((j|0)==-1){s=o+(c[a+32>>2]<<3)|0;break}else{s=o+(j<<3)|0;break}}else s=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if(!((s|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[s+4>>2]|0)!=0:0))p=31}else p=31;if((p|0)==31?(hQb(c[r>>2]|0)|0)==0:0){l=0;i=b;return l|0}c[e>>2]=c[r>>2];s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(d,s,e);a=c[d>>2]|0;f=c[s+28>>2]|0;if((a|0)==-1){t=f+(c[s+32>>2]<<3)|0;break}else{t=f+(a<<3)|0;break}}else t=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((t|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[t+4>>2]|0,(s|0)!=0):0)u=s;else p=40}else p=40;if((p|0)==40)u=hQb(c[r>>2]|0)|0;l=(c[u+84>>2]|0)!=0;i=b;return l|0}return 0}function Ewc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;if((c[a+84>>2]|0)==2){g=Dwc(a)|0;i=b;return g|0}h=a+60|0;a=c[h>>2]|0;if(!a){g=0;i=b;return g|0}c[f>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,f);j=c[d>>2]|0;k=c[a+28>>2]|0;if((j|0)==-1){l=k+(c[a+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if(!((l|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0))m=12}else m=12;if((m|0)==12?(hQb(c[h>>2]|0)|0)==0:0){g=0;i=b;return g|0}c[e>>2]=c[h>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(d,l,e);a=c[d>>2]|0;f=c[l+28>>2]|0;if((a|0)==-1){n=f+(c[l+32>>2]<<3)|0;break}else{n=f+(a<<3)|0;break}}else n=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((n|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[n+4>>2]|0,(l|0)!=0):0)o=l;else m=21}else m=21;if((m|0)==21)o=hQb(c[h>>2]|0)|0;g=(c[o+36>>2]|0)>0;i=b;return g|0}function Fwc(b){b=b|0;var d=0,e=0;d=i;if((c[b+88>>2]|0)!=1){e=0;i=d;return e|0}e=(a[b+96>>0]|0)!=0;i=d;return e|0}function Gwc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;h=e+12|0;j=b+68|0;k=b+76|0;l=c[k>>2]|0;m=c[d+8>>2]|0;if((m+l|0)>>>0>254){n=254-l|0;o=(n|0)>0?n:0;c[f>>2]=m;c[f+4>>2]=254;c[f+8>>2]=o;Lsd(h,589520,f);if(!(a[h>>0]&1))p=h+1|0;else p=c[h+8>>2]|0;Krd(p,0,3653512,247,1,0,0,0);xri(h);q=o}else q=m;if((q|0)<1){i=e;return}m=q+l|0;c[k>>2]=m;o=b+80|0;h=c[o>>2]|0;do if((h&2147483647)>>>0<m>>>0)if((h|0)>-1){c[o>>2]=m;p=c[j>>2]|0;c[g>>2]=c[b+72>>2];c[f+0>>2]=c[g+0>>2];c[j>>2]=hOb(p,m<<3,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[b+72>>2];c[f+0>>2]=c[g+0>>2];p=cOb(m<<3,4,f,0,3653512,352)|0;YEi(p|0,c[j>>2]|0,c[k>>2]<<3|0)|0;c[o>>2]=m;c[j>>2]=p;break}while(0);m=c[d>>2]|0;d=m+(q<<3)|0;if(q){q=m;m=(c[j>>2]|0)+(l<<3)|0;while(1){c[m>>2]=c[q>>2];c[m+4>>2]=c[q+4>>2];q=q+8|0;if((q|0)==(d|0))break;else m=m+8|0}}Bwc(b);i=e;return}function Hwc(a){a=a|0;var b=0;if((c[a+84>>2]|0)==2)b=c[a+88>>2]|0;else b=0;return b|0}function Iwc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+48|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+8|0;m=f;if((c[a+84>>2]|0)==2){n=a+64|0;c[k>>2]=c[n>>2];o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(h,o,k);p=c[h>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[r+4>>2]|0,(o|0)!=0):0)s=o;else t=10}else t=10;if((t|0)==10)s=hQb(c[n>>2]|0)|0;e7b(s,b,d,l,m,e);i=f;return}else{m=a+60|0;c[j>>2]=c[m>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(h,l,j);s=c[h>>2]|0;n=c[l+28>>2]|0;if((s|0)==-1){u=n+(c[l+32>>2]<<3)|0;break}else{u=n+(s<<3)|0;break}}else u=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((u|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[u+4>>2]|0,(l|0)!=0):0)v=l;else t=20}else t=20;if((t|0)==20)v=hQb(c[m>>2]|0)|0;X5b(v,b,ea(g[a+104>>2]),d,h,k,e);i=f;return}}function Jwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0;e=i;i=i+16|0;f=e+8|0;h=e;j=a+60|0;c[h>>2]=c[j>>2];k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(f,k,h);l=c[f>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[n+4>>2]|0,(k|0)!=0):0){o=k;p=a+104|0;q=ea(g[p>>2]);r=W5b(o,b,q,d)|0;i=e;return r|0}}o=hQb(c[j>>2]|0)|0;p=a+104|0;q=ea(g[p>>2]);r=W5b(o,b,q,d)|0;i=e;return r|0}function Kwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d;if(!(c[b+76>>2]|0)){qwc(a,0,0,ea(1.0));i=d;return}g=c[b+68>>2]|0;b=c[g>>2]|0;do if(b){c[f>>2]=b;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,f);j=c[e>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[l+4>>2]|0,(h|0)!=0):0)m=h;else n=12}else n=12;if((n|0)==12){h=hQb(c[g>>2]|0)|0;if(!h)break;else m=h}h=c[m+52>>2]|0;if((KLc()|0)==1)o=c[m+56>>2]|0;else o=0;qwc(a,h,o,ea(1.0));i=d;return}while(0);qwc(a,0,0,ea(1.0));i=d;return}function Lwc(a){a=a|0;return}function Mwc(){var a=0;a=i;QQb(157,130,0,0,0);i=a;return}function Nwc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(3)|0))lSb();rri(b,589696,16);wQb(157,3,b,208,2619,0,0);xri(b);i=a;return}function Owc(a){a=a|0;return 157}function Pwc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,589696,a,0);Xwc(a,b);bdd(b);i=c;return}function Qwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,589696,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Ywc(a,b);sdd(b);i=d;return}function Rwc(a,b){a=a|0;b=b|0;var c=0;c=i;Zwc(a,b);i=c;return}function Swc(a,b){a=a|0;b=b|0;var c=0;c=i;_wc(a,b);i=c;return}function Twc(a,b){a=a|0;b=b|0;var c=0;c=i;$wc(a,b);i=c;return}function Uwc(a,b){a=a|0;b=b|0;var c=0;c=i;axc(a,b);i=c;return}function Vwc(){var a=0,b=0;a=i;b=rVb(19)|0;i=a;return b|0}function Wwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(208,e,1,16,3653512,57)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];xwc(f,e,b);i=d;return f|0}function Xwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d;f=d+16|0;ESb(a,b);ddd(b,4);g=a+64|0;add(b,589736,590728,g,0);h=e+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[e>>2]=0;j=c[142270]|0;add(b,792256,j,g,1);g=b+12|0;k=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);l=c[142290]|0;add(b,792272,l,h,1);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,589760,j,a+84|0,0);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);h=a+124|0;add(b,589784,590568,h,0);dxc(h,b);bdd(b);h=a+60|0;add(b,589720,590544,h,0);m=e+8|0;n=m;c[n>>2]=0;c[n+4>>2]=0;c[e>>2]=0;add(b,792256,j,h,1);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,l,m,1);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,589808,c[142306]|0,a+68|0,0);c[f>>2]=0;c[f+4>>2]=0;$cd(b,2646336,2646336,e,0);add(b,3142592,590528,f,0);exc(f,b);bdd(b);cdd(b);bdd(b);add(b,589840,j,a+88|0,0);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,589824,j,a+92|0,0);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,589864,c[142258]|0,a+96|0,0);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);j=a+100|0;add(b,589896,590512,j,0);fxc(j,b);bdd(b);add(b,589912,c[142270]|0,a+204|0,0);c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function Ywc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;FSb(b,d);rdd(d,4);l=b+64|0;if(xdd(d,1)|0){m=qdd(d,589720,590728,k,1)|0;if(m){if((m|0)<=0){m=c[k>>2]|0;if(m)_n[m&4095](l,d)|0}else gxc(l,d);sdd(d)}}else{m=qdd(d,589736,590728,j,1)|0;if(m){if((m|0)<=0){m=c[j>>2]|0;if(m)_n[m&4095](l,d)|0}else gxc(l,d);sdd(d)}}l=b+84|0;m=c[142270]|0;j=qdd(d,589760,m,f,0)|0;if(j){if((j|0)>0){j=d+12|0;k=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=k+n|0;c[j>>2]=o;if((n|0)>=0?(p=k+(n+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[o>>2];c[j>>2]=p}else Bid(j,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}sdd(d)}l=b+124|0;j=qdd(d,589784,590568,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}else hxc(l,d);sdd(d)}l=b+60|0;j=qdd(d,589720,590544,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}else ixc(l,d);sdd(d)}l=b+68|0;j=qdd(d,589808,c[142306]|0,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}else jxc(d,l,0);sdd(d)}l=b+88|0;if(xdd(d,2)|0){j=qdd(d,589824,m,h,0)|0;if(j){if((j|0)>0){j=d+12|0;p=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+o|0;c[j>>2]=n;if((o|0)>=0?(k=p+(o+4)|0,k>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[n>>2];c[j>>2]=k}else Bid(j,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{j=c[h>>2]|0;if(j)_n[j&4095](l,d)|0}sdd(d)}}else{j=qdd(d,589840,m,f,0)|0;if(j){if((j|0)>0){j=d+12|0;h=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=h+k|0;c[j>>2]=n;if((k|0)>=0?(o=h+(k+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[n>>2];c[j>>2]=o}else Bid(j,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}sdd(d)}l=b+92|0;j=qdd(d,589824,m,g,0)|0;if(j){if((j|0)>0){j=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=o+n|0;c[j>>2]=k;if((n|0)>=0?(h=o+(n+4)|0,h>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[k>>2];c[j>>2]=h}else Bid(j,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{j=c[g>>2]|0;if(j)_n[j&4095](l,d)|0}sdd(d)}}l=b+96|0;j=qdd(d,589864,c[142258]|0,f,0)|0;if(j){do if((j|0)<=0){g=c[f>>2]|0;if(g)_n[g&4095](l,d)|0}else{g=d+12|0;h=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=h+k|0;c[g>>2]=n;if((k|0)>=0?(h+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[n>>0]|0;c[g>>2]=(c[g>>2]|0)+1;break}Bid(g,l,1)}while(0);sdd(d)}l=b+100|0;j=qdd(d,589896,590512,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}else kxc(l,d);sdd(d)}l=b+204|0;j=qdd(d,589912,m,f,0)|0;if(j){if((j|0)>0){j=d+12|0;m=c[d+16>>2]|0;g=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=m+g|0;c[j>>2]=n;if((g|0)>=0?(k=m+(g+4)|0,k>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[n>>2];c[j>>2]=k}else Bid(j,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](l,d)|0}sdd(d)}if(!(xdd(d,3)|0)){i=e;return}c[b+92>>2]=1;i=e;return}function Zwc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;GSb(b,d);lxc(b+64|0,d);f=b+84|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0)Bid(g,f,4);else{c[f>>2]=c[h>>2];c[g>>2]=j}j=b+124|0;mxc(d,j,0);nxc(d,b+140|0,0);oxc(d,b+156|0,0);pxc(d,b+172|0,0);bvc(j);qxc(b+60|0,d);rxc(d,b+68|0,0);j=b+88|0;h=c[g>>2]|0;f=h+4|0;l=c[k>>2]|0;if(f>>>0>l>>>0){Bid(g,j,4);m=c[g>>2]|0;n=c[k>>2]|0}else{c[j>>2]=c[h>>2];c[g>>2]=f;m=f;n=l}l=b+92|0;f=m+4|0;if(f>>>0>n>>>0){Bid(g,l,4);o=c[g>>2]|0;p=c[k>>2]|0}else{c[l>>2]=c[m>>2];c[g>>2]=f;o=f;p=n}n=b+96|0;if((o+1|0)>>>0>p>>>0)Bid(g,n,1);else{a[n>>0]=a[o>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);sxc(b+100|0,d);d=b+204|0;b=c[g>>2]|0;o=b+4|0;if(o>>>0>(c[k>>2]|0)>>>0){Bid(g,d,4);i=e;return}else{c[d>>2]=c[b>>2];c[g>>2]=o;i=e;return}}function _wc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;HSb(b,d);txc(b+64|0,d);f=b+84|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0){Bid(g,f,4);l=c[f>>2]|0}else{m=c[h>>2]|0;c[f>>2]=m;c[g>>2]=j;l=m}c[f>>2]=XEi(l|0)|0;l=b+124|0;uxc(d,l,0);vxc(d,b+140|0,0);wxc(d,b+156|0,0);xxc(d,b+172|0,0);bvc(l);yxc(b+60|0,d);zxc(d,b+68|0,0);l=b+88|0;f=c[g>>2]|0;m=f+4|0;j=c[k>>2]|0;if(m>>>0>j>>>0){Bid(g,l,4);n=c[l>>2]|0;o=c[g>>2]|0;p=c[k>>2]|0}else{h=c[f>>2]|0;c[l>>2]=h;c[g>>2]=m;n=h;o=m;p=j}c[l>>2]=XEi(n|0)|0;n=b+92|0;l=o+4|0;if(l>>>0>p>>>0){Bid(g,n,4);q=c[n>>2]|0;r=c[g>>2]|0;s=c[k>>2]|0}else{j=c[o>>2]|0;c[n>>2]=j;c[g>>2]=l;q=j;r=l;s=p}c[n>>2]=XEi(q|0)|0;q=b+96|0;if((r+1|0)>>>0>s>>>0)Bid(g,q,1);else{a[q>>0]=a[r>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Mdd(d);Axc(b+100|0,d);d=b+204|0;b=c[g>>2]|0;r=b+4|0;if(r>>>0>(c[k>>2]|0)>>>0){Bid(g,d,4);t=c[d>>2]|0;u=XEi(t|0)|0;c[d>>2]=u;i=e;return}else{k=c[b>>2]|0;c[d>>2]=k;c[g>>2]=r;t=k;u=XEi(t|0)|0;c[d>>2]=u;i=e;return}}function $wc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;ISb(b,d);Bxc(b+64|0,d);g=b+84|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=c[g>>2];c[h>>2]=k}else Gid(h,g,4);Cxc(b+124|0,d);Dxc(b+60|0,d);g=b+76|0;k=c[g>>2]|0;c[f>>2]=k;j=c[h>>2]|0;m=j+4|0;if(m>>>0<(c[l>>2]|0)>>>0){c[j>>2]=k;c[h>>2]=m}else Gid(h,f,4);f=c[b+68>>2]|0;m=c[g>>2]|0;g=f+(m<<3)|0;if(m){m=f;do{q9b(m,d);q9b(m+4|0,d);m=m+8|0}while((m|0)!=(g|0))}g=b+88|0;m=c[h>>2]|0;f=m+4|0;k=c[l>>2]|0;if(f>>>0<k>>>0){c[m>>2]=c[g>>2];c[h>>2]=f;n=f;o=k}else{Gid(h,g,4);n=c[h>>2]|0;o=c[l>>2]|0}g=b+92|0;k=n+4|0;if(k>>>0<o>>>0){c[n>>2]=c[g>>2];c[h>>2]=k;p=k;q=o}else{Gid(h,g,4);p=c[h>>2]|0;q=c[l>>2]|0}g=b+96|0;if((p+1|0)>>>0<q>>>0){a[p>>0]=a[g>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,g,1);Tdd(d);Exc(b+100|0,d);d=b+204|0;b=c[h>>2]|0;g=b+4|0;if(g>>>0<(c[l>>2]|0)>>>0){c[b>>2]=c[d>>2];c[h>>2]=g;i=e;return}else{Gid(h,d,4);i=e;return}}function axc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;JSb(b,d);f=b+64|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=c[b+124>>2]|0;f=c[b+132>>2]|0;d=k+(f*40|0)|0;if(f){f=k;do{k=c[g>>2]|0;l=xo[c[c[k>>2]>>2]&2047](k,c[f>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[f>>2]=l;f=f+40|0}while((f|0)!=(d|0))}d=b+60|0;f=c[g>>2]|0;l=xo[c[c[f>>2]>>2]&2047](f,c[d>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[d>>2]=l;l=c[b+68>>2]|0;d=c[b+76>>2]|0;b=l+(d<<3)|0;if(!d){i=e;return}else m=l;do{l=c[g>>2]|0;d=xo[c[c[l>>2]>>2]&2047](l,c[m>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[m>>2]=d;d=m+4|0;l=c[g>>2]|0;f=xo[c[c[l>>2]>>2]&2047](l,c[d>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[d>>2]=f;m=m+8|0}while((m|0)!=(b|0));i=e;return}function bxc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=589416;f=c[a+24>>2]|0;if(f)BCi(f);f=c[a+32>>2]|0;if(f)BCi(f);Fxc(a+124|0);if((c[a+80>>2]|0)<=-1){TSb(a);i=b;return}f=a+68|0;g=c[f>>2]|0;c[e>>2]=c[a+72>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;TSb(a);i=b;return}function cxc(a){a=a|0;var b=0;b=i;bxc(a);ACi(a);i=b;return}function dxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+64|0;e=d+56|0;f=d;g=c[142306]|0;add(b,590168,g,a,0);c[f>>2]=0;h=f+24|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;$cd(b,2646336,2646336,e,0);add(b,3142592,590696,f,0);Gxc(f,b);bdd(b);cdd(b);bdd(b);add(b,590184,g,a+16|0,0);h=f+24|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;$cd(b,2646336,2646336,e,0);add(b,3142592,590664,f,0);Hxc(f,b);bdd(b);cdd(b);bdd(b);add(b,590200,g,a+32|0,0);h=f+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;$cd(b,2646336,2646336,e,0);add(b,3142592,590632,f,0);j=c[142270]|0;add(b,590280,j,f,0);k=b+12|0;l=b+20|0;c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590296,616312,h,0);v6b(h,b);bdd(b);add(b,590232,j,f+24|0,0);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);cdd(b);bdd(b);add(b,590216,g,a+48|0,0);$cd(b,2646336,2646336,e,0);add(b,3142592,590592,f,0);add(b,590232,j,f,0);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590248,j,f+4|0,0);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590264,j,f+8|0,0);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);cdd(b);bdd(b);i=d;return}function exc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;add(b,590128,614680,a,0);f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=c[142270]|0;add(b,792256,g,a,1);h=b+12|0;j=b+20|0;c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142290]|0;add(b,792272,k,f,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);f=a+4|0;add(b,590144,614680,f,0);a=e+8|0;l=a;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,g,f,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,k,a,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);i=d;return}function fxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;ddd(b,2);e=c[142268]|0;add(b,589936,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,589952,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,589976,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,589992,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590024,c[142304]|0,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142258]|0;add(b,590056,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,590080,e,a+21|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function gxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function hxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[142306]|0;g=qdd(b,590168,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else Ixc(b,a,0);sdd(b)}g=a+16|0;h=qdd(b,590184,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else Jxc(b,g,0);sdd(b)}g=a+32|0;h=qdd(b,590200,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else Kxc(b,g,0);sdd(b)}g=a+48|0;h=qdd(b,590216,f,e,1)|0;if(!h){bvc(a);i=d;return}if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else Lxc(b,g,0);sdd(b);bvc(a);i=d;return}function ixc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function jxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];Mxc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<3)|0;do if(c[f>>2]|0){j=qdd(a,3142592,590528,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Nxc(r,a);t=r+8|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,590528,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else Nxc(m,a);sdd(a)}m=m+8|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function kxc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;h=e+4|0;rdd(d,2);j=c[142268]|0;k=qdd(d,589936,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){g[b>>2]=ea(g[n>>2]);c[k>>2]=o}else Bid(k,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](b,d)|0}sdd(d)}k=b+4|0;o=qdd(d,589952,j,f,0)|0;if(o){if((o|0)>0){o=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+m|0;c[o>>2]=l;if((m|0)>=0?(p=n+(m+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[l>>2]);c[o>>2]=p}else Bid(o,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](k,d)|0}sdd(d)}k=b+8|0;o=qdd(d,589976,j,f,0)|0;if(o){if((o|0)>0){o=d+12|0;p=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+l|0;c[o>>2]=m;if((l|0)>=0?(n=p+(l+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[m>>2]);c[o>>2]=n}else Bid(o,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](k,d)|0}sdd(d)}k=b+12|0;o=qdd(d,589992,j,f,0)|0;if(o){if((o|0)>0){o=d+12|0;j=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=j+n|0;c[o>>2]=m;if((n|0)>=0?(l=j+(n+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){g[k>>2]=ea(g[m>>2]);c[o>>2]=l}else Bid(o,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](k,d)|0}sdd(d)}k=b+16|0;o=qdd(d,590024,c[142304]|0,f,0)|0;if(o){if((o|0)>0){o=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[o>>2]=n;if((m|0)>=0?(j=l+(m+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[k>>2]=c[n>>2];c[o>>2]=j}else Bid(o,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](k,d)|0}sdd(d)}o=b+20|0;j=c[142258]|0;n=qdd(d,590056,j,f,0)|0;if(n){do if((n|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](o,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=l+p|0;c[m>>2]=q;if((p|0)>=0?(l+(p+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[o>>0]=a[q>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,o,1)}while(0);sdd(d)}o=b+21|0;b=qdd(d,590080,j,f,0)|0;if(b){do if((b|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](o,d)|0}else{n=d+12|0;m=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=m+q|0;c[n>>2]=p;if((q|0)>=0?(m+(q+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[o>>0]=a[p>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break}Bid(n,o,1)}while(0);sdd(d)}if(!(xdd(d,1)|0)){i=e;return}a[h>>0]=1;o=qdd(d,590112,j,f,0)|0;if(!o)r=0;else{do if((o|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else{j=d+12|0;b=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=b+n|0;c[j>>2]=p;if((n|0)>=0?(b+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[p>>0]|0;c[j>>2]=b+(n+1);break}Bid(j,h,1)}while(0);sdd(d);r=a[h>>0]^1}c[k>>2]=r&255;i=e;return}function lxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function mxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Oxc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k*40|0)|0;if(!k){i=d;return}else u=s;do{Pxc(u,a);Qxc(a,u+4|0,590448,0);s=u+20|0;k=c[l>>2]|0;j=k+4|0;if(j>>>0>(c[p>>2]|0)>>>0)Bid(l,s,4);else{c[s>>2]=c[k>>2];c[l>>2]=j}C6b(u+24|0,a);u=u+40|0}while((u|0)!=(t|0));i=d;return}else{if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=(c[h>>2]|0)*40|0;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(w|0)/40|0;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}}function nxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Rxc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k*56|0)|0;if(!k){i=d;return}else u=s;do{Sxc(u,a);u=u+56|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=(c[h>>2]|0)*56|0;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(w|0)/56|0;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function oxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[l>>2]|0;t=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;s=o;t=q}q=s+4|0;if(q>>>0>t>>>0){Bid(l,g,4);u=c[g>>2]|0}else{t=c[s>>2]|0;c[g>>2]=t;c[l>>2]=q;u=t}t=c[h>>2]<<5;h=zid(l,u,t)|0;u=b+12|0;if((c[u>>2]|0)>-1){q=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(q,e);c[b>>2]=0}q=t>>5;c[b+8>>2]=q;c[u>>2]=q|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}if(r){Bid(l,j,4);v=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;v=r}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Txc(b,v,e);e=c[b>>2]|0;v=c[b+8>>2]|0;b=e+(v<<5)|0;if(!v){i=d;return}else w=e;do{e=c[l>>2]|0;v=e+4|0;if(v>>>0>(c[p>>2]|0)>>>0)Bid(l,w,4);else{c[w>>2]=c[e>>2];c[l>>2]=v}C6b(w+8|0,a);v=w+24|0;e=c[l>>2]|0;k=e+4|0;if(k>>>0>(c[p>>2]|0)>>>0)Bid(l,v,4);else{c[v>>2]=c[e>>2];c[l>>2]=k}w=w+32|0}while((w|0)!=(b|0));i=d;return}function pxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[l>>2]|0;t=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;s=o;t=q}q=s+4|0;if(q>>>0>t>>>0){Bid(l,g,4);u=c[g>>2]|0}else{t=c[s>>2]|0;c[g>>2]=t;c[l>>2]=q;u=t}t=(c[h>>2]|0)*12|0;h=zid(l,u,t)|0;u=b+12|0;if((c[u>>2]|0)>-1){q=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(q,e);c[b>>2]=0}q=(t|0)/12|0;c[b+8>>2]=q;c[u>>2]=q|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}if(r){Bid(l,j,4);v=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;v=r}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Uxc(b,v,e);e=c[b>>2]|0;v=c[b+8>>2]|0;b=e+(v*12|0)|0;if(!v){i=d;return}else w=e;do{e=c[l>>2]|0;v=e+4|0;k=c[p>>2]|0;if(v>>>0>k>>>0){Bid(l,w,4);x=c[l>>2]|0;y=c[p>>2]|0}else{c[w>>2]=c[e>>2];c[l>>2]=v;x=v;y=k}k=w+4|0;v=x+4|0;if(v>>>0>y>>>0){Bid(l,k,4);z=c[l>>2]|0;A=c[p>>2]|0}else{c[k>>2]=c[x>>2];c[l>>2]=v;z=v;A=y}v=w+8|0;k=z+4|0;if(k>>>0>A>>>0)Bid(l,v,4);else{c[v>>2]=c[z>>2];c[l>>2]=k}w=w+12|0}while((w|0)!=(b|0));i=d;return}function qxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function rxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Mxc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<3)|0;if(!k){i=d;return}else u=s;do{k9b(u,a);k9b(u+4|0,a);u=u+8|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<3;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>3;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function sxc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(f,b,4);m=c[k>>2]|0;n=c[f>>2]|0}else{g[b>>2]=ea(g[h>>2]);c[f>>2]=j;m=l;n=j}j=b+4|0;l=n+4|0;if(l>>>0>m>>>0){Bid(f,j,4);o=c[f>>2]|0;p=c[k>>2]|0}else{g[j>>2]=ea(g[n>>2]);c[f>>2]=l;o=l;p=m}m=b+8|0;l=o+4|0;if(l>>>0>p>>>0){Bid(f,m,4);q=c[f>>2]|0;r=c[k>>2]|0}else{g[m>>2]=ea(g[o>>2]);c[f>>2]=l;q=l;r=p}p=b+12|0;l=q+4|0;if(l>>>0>r>>>0){Bid(f,p,4);s=c[f>>2]|0;t=c[k>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[f>>2]=l;s=l;t=r}r=b+16|0;l=s+4|0;if(l>>>0>t>>>0){Bid(f,r,4);u=c[f>>2]|0;v=c[k>>2]|0}else{c[r>>2]=c[s>>2];c[f>>2]=l;u=l;v=t}t=b+20|0;if((u+1|0)>>>0>v>>>0){Bid(f,t,1);w=c[f>>2]|0}else{a[t>>0]=a[u>>0]|0;u=(c[f>>2]|0)+1|0;c[f>>2]=u;w=u}u=b+21|0;if((w+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(f,u,1);Ndd(d);i=e;return}else{a[u>>0]=a[w>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function txc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function uxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Oxc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k*40|0)|0;if(!k){i=d;return}else u=t;do{Vxc(u,a);ojc(u+4|0,a);t=u+20|0;k=c[l>>2]|0;s=k+4|0;if(s>>>0>(c[p>>2]|0)>>>0){Bid(l,t,4);v=c[t>>2]|0}else{w=c[k>>2]|0;c[t>>2]=w;c[l>>2]=s;v=w}c[t>>2]=XEi(v|0)|0;H6b(u+24|0,a);u=u+40|0}while((u|0)!=(j|0));i=d;return}else{if(r){Bid(l,h,4);x=c[h>>2]|0;y=c[l>>2]|0;z=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;x=p;y=o;z=q}q=XEi(x|0)|0;c[h>>2]=q;x=y+4|0;if(x>>>0>z>>>0){Bid(l,g,4);A=c[g>>2]|0;B=c[h>>2]|0}else{h=c[y>>2]|0;c[g>>2]=h;c[l>>2]=x;A=h;B=q}q=XEi(A|0)|0;c[g>>2]=q;g=B*40|0;B=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(g|0)/40|0;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=B;c[m>>2]=0;i=d;return}}function vxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Rxc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k*56|0)|0;if(!k){i=d;return}else u=t;do{Wxc(u,a);u=u+56|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z*56|0;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(g|0)/56|0;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function wxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(c[m>>2]|0){if(r){Bid(l,h,4);s=c[h>>2]|0;t=c[l>>2]|0;u=c[p>>2]|0}else{v=c[n>>2]|0;c[h>>2]=v;c[l>>2]=o;s=v;t=o;u=q}q=XEi(s|0)|0;c[h>>2]=q;s=t+4|0;if(s>>>0>u>>>0){Bid(l,g,4);w=c[g>>2]|0;x=c[h>>2]|0}else{h=c[t>>2]|0;c[g>>2]=h;c[l>>2]=s;w=h;x=q}q=XEi(w|0)|0;c[g>>2]=q;g=x<<5;x=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){w=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(w,e);c[b>>2]=0}w=g>>5;c[b+8>>2]=w;c[q>>2]=w|-2147483648;c[b>>2]=x;c[m>>2]=0;i=d;return}if(r){Bid(l,j,4);y=c[j>>2]|0}else{r=c[n>>2]|0;c[j>>2]=r;c[l>>2]=o;y=r}r=XEi(y|0)|0;c[j>>2]=r;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Txc(b,r,e);e=c[b>>2]|0;r=c[b+8>>2]|0;b=e+(r<<5)|0;if(!r){i=d;return}else z=e;do{e=c[l>>2]|0;r=e+4|0;if(r>>>0>(c[p>>2]|0)>>>0){Bid(l,z,4);A=c[z>>2]|0}else{k=c[e>>2]|0;c[z>>2]=k;c[l>>2]=r;A=k}c[z>>2]=XEi(A|0)|0;H6b(z+8|0,a);k=z+24|0;r=c[l>>2]|0;e=r+4|0;if(e>>>0>(c[p>>2]|0)>>>0){Bid(l,k,4);B=c[k>>2]|0}else{j=c[r>>2]|0;c[k>>2]=j;c[l>>2]=e;B=j}c[k>>2]=XEi(B|0)|0;z=z+32|0}while((z|0)!=(b|0));i=d;return}function xxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Uxc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k*12|0)|0;if(!k){i=d;return}else u=t;do{Xxc(u,a);u=u+12|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z*12|0;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=(g|0)/12|0;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function yxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function zxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];Mxc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<3)|0;if(!k){i=d;return}else u=t;do{n9b(u,a);n9b(u+4|0,a);u=u+8|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<3;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>3;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function Axc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;l=d+20|0;m=c[l>>2]|0;if(j>>>0>m>>>0){Bid(f,b,4);n=b;o=c[f>>2]|0;p=c[l>>2]|0;q=c[b>>2]|0}else{r=ea(g[h>>2]);g[b>>2]=r;c[f>>2]=j;n=b;o=j;p=m;q=(g[k>>2]=r,c[k>>2]|0)}c[n>>2]=XEi(q|0)|0;q=b+4|0;n=o+4|0;if(n>>>0>p>>>0){Bid(f,q,4);s=q;t=c[q>>2]|0;u=c[f>>2]|0;v=c[l>>2]|0}else{r=ea(g[o>>2]);g[q>>2]=r;c[f>>2]=n;s=q;t=(g[k>>2]=r,c[k>>2]|0);u=n;v=p}c[s>>2]=XEi(t|0)|0;t=b+8|0;s=u+4|0;if(s>>>0>v>>>0){Bid(f,t,4);w=t;x=c[t>>2]|0;y=c[f>>2]|0;z=c[l>>2]|0}else{r=ea(g[u>>2]);g[t>>2]=r;c[f>>2]=s;w=t;x=(g[k>>2]=r,c[k>>2]|0);y=s;z=v}c[w>>2]=XEi(x|0)|0;x=b+12|0;w=y+4|0;if(w>>>0>z>>>0){Bid(f,x,4);A=x;B=c[x>>2]|0;C=c[f>>2]|0;D=c[l>>2]|0}else{r=ea(g[y>>2]);g[x>>2]=r;c[f>>2]=w;A=x;B=(g[k>>2]=r,c[k>>2]|0);C=w;D=z}c[A>>2]=XEi(B|0)|0;B=b+16|0;A=C+4|0;if(A>>>0>D>>>0){Bid(f,B,4);E=c[B>>2]|0;F=c[f>>2]|0;G=c[l>>2]|0}else{z=c[C>>2]|0;c[B>>2]=z;c[f>>2]=A;E=z;F=A;G=D}c[B>>2]=XEi(E|0)|0;E=b+20|0;if((F+1|0)>>>0>G>>>0){Bid(f,E,1);H=c[f>>2]|0}else{a[E>>0]=a[F>>0]|0;F=(c[f>>2]|0)+1|0;c[f>>2]=F;H=F}F=b+21|0;if((H+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(f,F,1);Mdd(d);i=e;return}else{a[F>>0]=a[H>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function Bxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function Cxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=a+8|0;g=c[f>>2]|0;c[e>>2]=g;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);k=c[a>>2]|0;g=c[f>>2]|0;f=k+(g*40|0)|0;if(g){g=k;do{Yxc(g,b);mjc(b,g+4|0,590448,0);k=g+20|0;j=c[h>>2]|0;m=j+4|0;if(m>>>0<(c[l>>2]|0)>>>0){c[j>>2]=c[k>>2];c[h>>2]=m}else Gid(h,k,4);M6b(g+24|0,b);g=g+40|0}while((g|0)!=(f|0))}f=a+24|0;g=c[f>>2]|0;c[e>>2]=g;k=c[h>>2]|0;m=k+4|0;if(m>>>0<(c[l>>2]|0)>>>0){c[k>>2]=g;c[h>>2]=m}else Gid(h,e,4);m=c[a+16>>2]|0;g=c[f>>2]|0;f=m+(g*56|0)|0;if(g){g=m;do{Zxc(g,b);g=g+56|0}while((g|0)!=(f|0))}_xc(b,a+32|0,0);b=a+56|0;f=c[b>>2]|0;c[e>>2]=f;g=c[h>>2]|0;m=g+4|0;if(m>>>0<(c[l>>2]|0)>>>0){c[g>>2]=f;c[h>>2]=m}else Gid(h,e,4);e=c[a+48>>2]|0;a=c[b>>2]|0;b=e+(a*12|0)|0;if(!a){i=d;return}else n=e;do{e=c[h>>2]|0;a=e+4|0;m=c[l>>2]|0;if(a>>>0<m>>>0){c[e>>2]=c[n>>2];c[h>>2]=a;o=a;p=m}else{Gid(h,n,4);o=c[h>>2]|0;p=c[l>>2]|0}m=n+4|0;a=o+4|0;if(a>>>0<p>>>0){c[o>>2]=c[m>>2];c[h>>2]=a;q=a;r=p}else{Gid(h,m,4);q=c[h>>2]|0;r=c[l>>2]|0}m=n+8|0;a=q+4|0;if(a>>>0<r>>>0){c[q>>2]=c[m>>2];c[h>>2]=a}else Gid(h,m,4);n=n+12|0}while((n|0)!=(b|0));i=d;return}function Dxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function Exc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){g[h>>2]=ea(g[b>>2]);c[f>>2]=j;m=l;n=j}else{Gid(f,b,4);m=c[k>>2]|0;n=c[f>>2]|0}j=b+4|0;l=n+4|0;if(l>>>0<m>>>0){g[n>>2]=ea(g[j>>2]);c[f>>2]=l;o=l;p=m}else{Gid(f,j,4);o=c[f>>2]|0;p=c[k>>2]|0}j=b+8|0;m=o+4|0;if(m>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[f>>2]=m;q=m;r=p}else{Gid(f,j,4);q=c[f>>2]|0;r=c[k>>2]|0}j=b+12|0;p=q+4|0;if(p>>>0<r>>>0){g[q>>2]=ea(g[j>>2]);c[f>>2]=p;s=p;t=r}else{Gid(f,j,4);s=c[f>>2]|0;t=c[k>>2]|0}j=b+16|0;r=s+4|0;if(r>>>0<t>>>0){c[s>>2]=c[j>>2];c[f>>2]=r;u=r;v=t}else{Gid(f,j,4);u=c[f>>2]|0;v=c[k>>2]|0}j=b+20|0;if((u+1|0)>>>0<v>>>0){a[u>>0]=a[j>>0]|0;u=(c[f>>2]|0)+1|0;c[f>>2]=u;w=u}else{Gid(f,j,1);w=c[f>>2]|0}j=b+21|0;if((w+1|0)>>>0<(c[k>>2]|0)>>>0){a[w>>0]=a[j>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Tdd(d);i=e;return}else{Gid(f,j,1);Tdd(d);i=e;return}}function Fxc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+68>>2]|0;if(f){g=a+72|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~((h+-8-f|0)>>>3)<<3);ACi(f)}if((c[a+60>>2]|0)>-1){f=a+48|0;h=c[f>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}if((c[a+44>>2]|0)>-1){f=a+32|0;h=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;h=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function Gxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;add(b,590432,c[142276]|0,a,0);f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;e=c[142270]|0;add(b,792256,e,a,1);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,f,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);f=a+4|0;add(b,590448,c[142312]|0,f,0);ljc(f,b);bdd(b);add(b,590480,e,a+20|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);h=a+24|0;add(b,590496,616312,h,0);v6b(h,b);bdd(b);i=d;return}function Hxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142304]|0;add(b,590312,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590328,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142270]|0;add(b,590344,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590360,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,590376,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);g=a+24|0;add(b,590392,616312,g,0);v6b(g,b);bdd(b);g=a+40|0;add(b,590408,616312,g,0);v6b(g,b);bdd(b);i=d;return}function Ixc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];Oxc(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*40|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,590696,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;$xc(r,a);t=r+40|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,590696,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else $xc(m,a);sdd(a)}m=m+40|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function Jxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];Rxc(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*56|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,590664,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;ayc(r,a);t=r+56|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,590664,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else ayc(m,a);sdd(a)}m=m+56|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function Kxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];Txc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<5)|0;do if(c[f>>2]|0){j=qdd(a,3142592,590632,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;byc(r,a);t=r+32|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,590632,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else byc(m,a);sdd(a)}m=m+32|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function Lxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];Uxc(b,k,e);k=(c[b>>2]|0)+((c[j>>2]|0)*12|0)|0;do if(c[f>>2]|0){j=qdd(a,3142592,590592,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;cyc(r,a);t=r+12|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,590592,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else cyc(m,a);sdd(a)}m=m+12|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function Mxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<3,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<3,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<3|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<3)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<3)|0;do{if(f){c[f>>2]=0;c[f+4>>2]=0}f=f+8|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function Nxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,590128,614680,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else g9b(a,b);sdd(b)}f=a+4|0;a=qdd(b,590144,614680,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else g9b(f,b);sdd(b);i=d;return}function Oxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;k=h+0|0;l=k+36|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));m=c[d>>2]|0;do if((m&2147483647)>>>0<b>>>0)if((m|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=hOb(j,b*40|0,8,f,0,3653512,370)|0;c[a>>2]=n;o=n;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=cOb(b*40|0,8,f,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,(c[a+8>>2]|0)*40|0)|0;c[d>>2]=b;c[a>>2]=n;o=n;break}else o=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=o+(b*40|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=o+(a*40|0)|0;do{if(f){c[f>>2]=0;k=f+4|0;a=h+0|0;l=k+36|0;do{c[k>>2]=c[a>>2];k=k+4|0;a=a+4|0}while((k|0)<(l|0))}f=f+40|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function Pxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function Qxc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;d=a+12|0;f=c[d>>2]|0;h=f+4|0;j=a+20|0;a=c[j>>2]|0;if(h>>>0>a>>>0){Bid(d,b,4);k=c[d>>2]|0;l=c[j>>2]|0}else{g[b>>2]=ea(g[f>>2]);c[d>>2]=h;k=h;l=a}a=b+4|0;h=k+4|0;if(h>>>0>l>>>0){Bid(d,a,4);m=c[d>>2]|0;n=c[j>>2]|0}else{g[a>>2]=ea(g[k>>2]);c[d>>2]=h;m=h;n=l}l=b+8|0;h=m+4|0;if(h>>>0>n>>>0){Bid(d,l,4);o=c[d>>2]|0;p=c[j>>2]|0}else{g[l>>2]=ea(g[m>>2]);c[d>>2]=h;o=h;p=n}n=b+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(d,n,4);i=e;return}else{g[n>>2]=ea(g[o>>2]);c[d>>2]=b;i=e;return}}function Rxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+64|0;f=e+60|0;g=e+56|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;k=h+0|0;l=k+56|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));m=c[d>>2]|0;do if((m&2147483647)>>>0<b>>>0)if((m|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=hOb(j,b*56|0,8,f,0,3653512,370)|0;c[a>>2]=n;o=n;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];n=cOb(b*56|0,8,f,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,(c[a+8>>2]|0)*56|0)|0;c[d>>2]=b;c[a>>2]=n;o=n;break}else o=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=o+(b*56|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=o+(a*56|0)|0;do{if(f){k=f+0|0;a=h+0|0;l=k+56|0;do{c[k>>2]=c[a>>2];k=k+4|0;a=a+4|0}while((k|0)<(l|0))}f=f+56|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function Sxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;j=c[h>>2]|0;if(g>>>0>j>>>0){Bid(e,a,4);k=c[h>>2]|0;l=c[e>>2]|0}else{c[a>>2]=c[f>>2];c[e>>2]=g;k=j;l=g}g=a+4|0;j=l+4|0;if(j>>>0>k>>>0){Bid(e,g,4);m=c[e>>2]|0;n=c[h>>2]|0}else{c[g>>2]=c[l>>2];c[e>>2]=j;m=j;n=k}k=a+8|0;j=m+4|0;if(j>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[h>>2]|0}else{c[k>>2]=c[m>>2];c[e>>2]=j;o=j;p=n}n=a+12|0;j=o+4|0;if(j>>>0>p>>>0){Bid(e,n,4);q=c[e>>2]|0;r=c[h>>2]|0}else{c[n>>2]=c[o>>2];c[e>>2]=j;q=j;r=p}p=a+16|0;j=q+4|0;if(j>>>0>r>>>0){Bid(e,p,4);s=a+24|0;C6b(s,b);t=a+40|0;C6b(t,b);i=d;return}else{c[p>>2]=c[q>>2];c[e>>2]=j;s=a+24|0;C6b(s,b);t=a+40|0;C6b(t,b);i=d;return}}function Txc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b<<5,8,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b<<5,8,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[a+8>>2]<<5|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b<<5)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a<<5)|0;do{if(f){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];c[f+24>>2]=c[h+24>>2];c[f+28>>2]=c[h+28>>2]}f=f+32|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function Uxc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b*12|0,4,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b*12|0,4,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[a+8>>2]|0)*12|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b*12|0)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a*12|0)|0;do{if(f){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2]}f=f+12|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function Vxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function Wxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;j=c[h>>2]|0;if(g>>>0>j>>>0){Bid(e,a,4);k=c[e>>2]|0;l=c[h>>2]|0;m=c[a>>2]|0}else{n=c[f>>2]|0;c[a>>2]=n;c[e>>2]=g;k=g;l=j;m=n}c[a>>2]=XEi(m|0)|0;m=a+4|0;n=k+4|0;if(n>>>0>l>>>0){Bid(e,m,4);o=c[m>>2]|0;p=c[e>>2]|0;q=c[h>>2]|0}else{j=c[k>>2]|0;c[m>>2]=j;c[e>>2]=n;o=j;p=n;q=l}c[m>>2]=XEi(o|0)|0;o=a+8|0;m=p+4|0;if(m>>>0>q>>>0){Bid(e,o,4);r=c[o>>2]|0;s=c[e>>2]|0;t=c[h>>2]|0}else{l=c[p>>2]|0;c[o>>2]=l;c[e>>2]=m;r=l;s=m;t=q}c[o>>2]=XEi(r|0)|0;r=a+12|0;o=s+4|0;if(o>>>0>t>>>0){Bid(e,r,4);u=c[r>>2]|0;v=c[e>>2]|0;w=c[h>>2]|0}else{h=c[s>>2]|0;c[r>>2]=h;c[e>>2]=o;u=h;v=o;w=t}c[r>>2]=XEi(u|0)|0;u=a+16|0;r=v+4|0;if(r>>>0>w>>>0){Bid(e,u,4);x=c[u>>2]|0;y=XEi(x|0)|0;c[u>>2]=y;z=a+24|0;H6b(z,b);A=a+40|0;H6b(A,b);i=d;return}else{w=c[v>>2]|0;c[u>>2]=w;c[e>>2]=r;x=w;y=XEi(x|0)|0;c[u>>2]=y;z=a+24|0;H6b(z,b);A=a+40|0;H6b(A,b);i=d;return}}function Xxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;b=c[h>>2]|0;if(g>>>0>b>>>0){Bid(e,a,4);j=c[e>>2]|0;k=c[h>>2]|0;l=c[a>>2]|0}else{m=c[f>>2]|0;c[a>>2]=m;c[e>>2]=g;j=g;k=b;l=m}c[a>>2]=XEi(l|0)|0;l=a+4|0;m=j+4|0;if(m>>>0>k>>>0){Bid(e,l,4);n=c[l>>2]|0;o=c[e>>2]|0;p=c[h>>2]|0}else{h=c[j>>2]|0;c[l>>2]=h;c[e>>2]=m;n=h;o=m;p=k}c[l>>2]=XEi(n|0)|0;n=a+8|0;a=o+4|0;if(a>>>0>p>>>0){Bid(e,n,4);q=c[n>>2]|0;r=XEi(q|0)|0;c[n>>2]=r;i=d;return}else{p=c[o>>2]|0;c[n>>2]=p;c[e>>2]=a;q=p;r=XEi(q|0)|0;c[n>>2]=r;i=d;return}}function Yxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function Zxc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;j=c[h>>2]|0;if(g>>>0<j>>>0){c[f>>2]=c[a>>2];c[e>>2]=g;k=j;l=g}else{Gid(e,a,4);k=c[h>>2]|0;l=c[e>>2]|0}g=a+4|0;j=l+4|0;if(j>>>0<k>>>0){c[l>>2]=c[g>>2];c[e>>2]=j;m=j;n=k}else{Gid(e,g,4);m=c[e>>2]|0;n=c[h>>2]|0}g=a+8|0;k=m+4|0;if(k>>>0<n>>>0){c[m>>2]=c[g>>2];c[e>>2]=k;o=k;p=n}else{Gid(e,g,4);o=c[e>>2]|0;p=c[h>>2]|0}g=a+12|0;n=o+4|0;if(n>>>0<p>>>0){c[o>>2]=c[g>>2];c[e>>2]=n;q=n;r=p}else{Gid(e,g,4);q=c[e>>2]|0;r=c[h>>2]|0}h=a+16|0;g=q+4|0;if(g>>>0<r>>>0){c[q>>2]=c[h>>2];c[e>>2]=g;s=a+24|0;M6b(s,b);t=a+40|0;M6b(t,b);i=d;return}else{Gid(e,h,4);s=a+24|0;M6b(s,b);t=a+40|0;M6b(t,b);i=d;return}}function _xc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=b+8|0;g=c[f>>2]|0;c[e>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j+4|0;l=a+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);e=c[b>>2]|0;b=c[f>>2]|0;f=e+(b<<5)|0;if(!b){i=d;return}else m=e;do{e=c[h>>2]|0;b=e+4|0;if(b>>>0<(c[l>>2]|0)>>>0){c[e>>2]=c[m>>2];c[h>>2]=b}else Gid(h,m,4);M6b(m+8|0,a);b=m+24|0;e=c[h>>2]|0;k=e+4|0;if(k>>>0<(c[l>>2]|0)>>>0){c[e>>2]=c[b>>2];c[h>>2]=k}else Gid(h,b,4);m=m+32|0}while((m|0)!=(f|0));i=d;return}function $xc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=qdd(b,590432,c[142276]|0,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else dyc(a,b);sdd(b)}f=a+4|0;g=qdd(b,590448,c[142312]|0,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else igc(f,b);sdd(b)}f=a+20|0;g=qdd(b,590480,c[142270]|0,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}sdd(b)}f=a+24|0;a=qdd(b,590496,616312,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else b7b(f,b);sdd(b);i=d;return}function ayc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[142304]|0;g=qdd(b,590312,f,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[g>>2]=l}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+4|0;l=qdd(b,590328,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;f=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=f+k|0;c[l>>2]=j;if((k|0)>=0?(h=f+(k+4)|0,h>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[l>>2]=h}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+8|0;l=c[142270]|0;h=qdd(b,590344,l,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;f=j+k|0;c[h>>2]=f;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[f>>2];c[h>>2]=m}else Bid(h,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}g=a+12|0;h=qdd(b,590360,l,e,0)|0;if(h){if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;f=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+f|0;c[h>>2]=k;if((f|0)>=0?(j=m+(f+4)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[k>>2];c[h>>2]=j}else Bid(h,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}g=a+16|0;h=qdd(b,590376,l,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+j|0;c[h>>2]=k;if((j|0)>=0?(f=l+(j+4)|0,f>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[k>>2];c[h>>2]=f}else Bid(h,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}g=a+24|0;h=qdd(b,590392,616312,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else b7b(g,b);sdd(b)}g=a+40|0;a=qdd(b,590408,616312,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}else b7b(g,b);sdd(b);i=d;return}function byc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=c[142270]|0;g=qdd(b,590280,f,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[g>>2]=l}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+8|0;l=qdd(b,590296,616312,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}else b7b(g,b);sdd(b)}g=a+24|0;a=qdd(b,590232,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=f+l|0;c[a>>2]=k;if((l|0)>=0?(j=f+(l+4)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[k>>2];c[a>>2]=j}else Bid(a,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}sdd(b);i=d;return}function cyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[142270]|0;g=qdd(b,590232,f,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[g>>2]=l}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+4|0;l=qdd(b,590248,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;k=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(m=k+(j+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[h>>2];c[l>>2]=m}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+8|0;a=qdd(b,590264,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=f+l|0;c[a>>2]=m;if((l|0)>=0?(h=f+(l+4)|0,h>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[m>>2];c[a>>2]=h}else Bid(a,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}sdd(b);i=d;return}function dyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function eyc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;d=i;e=ea(g[b+12>>2]);f=ea(g[b>>2]);h=ea(e-f);j=ea(g[b+16>>2]);k=ea(g[b+4>>2]);l=ea(j-k);m=ea(g[b+20>>2]);n=ea(g[b+8>>2]);o=ea(m-n);p=ea(g[b+24>>2]);q=ea(p-f);f=ea(g[b+28>>2]);r=ea(f-k);k=ea(g[b+32>>2]);s=ea(k-n);n=ea(ea(l*s)-ea(o*r));t=ea(ea(o*q)-ea(h*s));o=ea(ea(h*r)-ea(l*q));if(n<ea(0.0))u=ea(-n);else u=n;if(t<ea(0.0))v=ea(-t);else v=t;if(o<ea(0.0))w=ea(-o);else w=o;do if(!(u>=v)|!(u>=w)){l=ea(g[c>>2]);if(!(v>=u)|!(v>=w)){h=ea(g[c+4>>2]);x=o;y=ea(ea(ea(l-e)*ea(j-f))-ea(ea(h-j)*ea(e-p)));z=ea(ea(ea(l-p)*r)-ea(ea(h-f)*q));break}else{h=ea(g[c+8>>2]);x=ea(-t);y=ea(ea(ea(l-e)*ea(m-k))-ea(ea(h-m)*ea(e-p)));z=ea(ea(ea(l-p)*s)-ea(ea(h-k)*q));break}}else{h=ea(g[c+4>>2]);l=ea(g[c+8>>2]);x=n;y=ea(ea(ea(h-j)*ea(m-k))-ea(ea(l-m)*ea(j-f)));z=ea(ea(ea(h-f)*s)-ea(ea(l-k)*r))}while(0);r=ea(ea(1.0)/x);x=ea(y*r);y=ea(z*r);r=ea(ea(ea(1.0)-x)-y);g[a>>2]=x;g[a+4>>2]=y;g[a+8>>2]=r;i=d;return}function fyc(){var a=0;a=i;QQb(47,131,132,0,133);i=a;return}function gyc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,2353536,15);wQb(47,6,b,44,2620,0,0);xri(b);i=a;return}function hyc(){return}function iyc(a){a=a|0;return 47}function jyc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2353536,a,0);zyc(a,b);bdd(b);i=c;return}function kyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2353536,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Ayc(a,b);sdd(b);i=d;return}function lyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;MSb(a,b);e=a+40|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;if(h>>>0>(c[j>>2]|0)>>>0)Bid(f,e,4);else{c[e>>2]=c[g>>2];c[f>>2]=h}Byc(b,a+24|0,0);b=a+36|0;a=c[f>>2]|0;h=a+4|0;if(h>>>0>(c[j>>2]|0)>>>0){Bid(f,b,4);i=d;return}else{c[b>>2]=c[a>>2];c[f>>2]=h;i=d;return}}function myc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;NSb(a,b);e=a+40|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;j=b+20|0;if(h>>>0>(c[j>>2]|0)>>>0){Bid(f,e,4);k=c[e>>2]|0}else{l=c[g>>2]|0;c[e>>2]=l;c[f>>2]=h;k=l}c[e>>2]=XEi(k|0)|0;Cyc(b,a+24|0,0);b=a+36|0;a=c[f>>2]|0;k=a+4|0;if(k>>>0>(c[j>>2]|0)>>>0){Bid(f,b,4);m=c[b>>2]|0;n=XEi(m|0)|0;c[b>>2]=n;i=d;return}else{j=c[a>>2]|0;c[b>>2]=j;c[f>>2]=k;m=j;n=XEi(m|0)|0;c[b>>2]=n;i=d;return}}function nyc(a,b){a=a|0;b=b|0;var c=0;c=i;Dyc(a,b);i=c;return}function oyc(a,b){a=a|0;b=b|0;var c=0;c=i;PSb(a,b);idd(b,2048);jdd(b);i=c;return}function pyc(){var a=0,b=0;a=i;b=rVb(11)|0;i=a;return b|0}function qyc(){var a=0,b=0;a=i;b=tVb(11)|0;i=a;return b|0}function ryc(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;i=i+592|0;e=d+580|0;f=d+576|0;h=d;j=h+576|0;a[h>>0]=14;k=h+1|0;a[k+0>>0]=a[590864]|0;a[k+1>>0]=a[590865]|0;a[k+2>>0]=a[590866]|0;a[k+3>>0]=a[590867]|0;a[k+4>>0]=a[590868]|0;a[k+5>>0]=a[590869]|0;a[k+6>>0]=a[590870]|0;a[h+8>>0]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=1;c[h+28>>2]=1;g[h+32>>2]=ea(15.0);g[h+36>>2]=ea(.333333343);g[h+40>>2]=ea(.0666666701);g[h+44>>2]=ea(.200000003);g[h+48>>2]=ea(.466666669);c[h+52>>2]=1;c[h+56>>2]=1;k=h+60|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[h+76>>2]=ea(.300000012);c[h+80>>2]=0;c[h+84>>2]=4;g[h+88>>2]=ea(512.0);c[h+92>>2]=1;k=h+96|0;a[k>>0]=14;l=k+1|0;a[l+0>>0]=a[590864]|0;a[l+1>>0]=a[590865]|0;a[l+2>>0]=a[590866]|0;a[l+3>>0]=a[590867]|0;a[l+4>>0]=a[590868]|0;a[l+5>>0]=a[590869]|0;a[l+6>>0]=a[590870]|0;a[h+104>>0]=0;c[h+108>>2]=0;c[h+112>>2]=0;c[h+116>>2]=0;c[h+120>>2]=1;c[h+124>>2]=1;g[h+128>>2]=ea(15.0);g[h+132>>2]=ea(.333333343);g[h+136>>2]=ea(.0666666701);g[h+140>>2]=ea(.200000003);g[h+144>>2]=ea(.466666669);c[h+148>>2]=1;c[h+152>>2]=1;l=h+156|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[h+172>>2]=ea(.300000012);c[h+176>>2]=0;c[h+180>>2]=4;g[h+184>>2]=ea(512.0);c[h+188>>2]=1;l=h+192|0;a[l>>0]=14;k=l+1|0;a[k+0>>0]=a[590864]|0;a[k+1>>0]=a[590865]|0;a[k+2>>0]=a[590866]|0;a[k+3>>0]=a[590867]|0;a[k+4>>0]=a[590868]|0;a[k+5>>0]=a[590869]|0;a[k+6>>0]=a[590870]|0;a[h+200>>0]=0;c[h+204>>2]=0;c[h+208>>2]=0;c[h+212>>2]=0;c[h+216>>2]=1;c[h+220>>2]=1;g[h+224>>2]=ea(15.0);g[h+228>>2]=ea(.333333343);g[h+232>>2]=ea(.0666666701);g[h+236>>2]=ea(.200000003);g[h+240>>2]=ea(.466666669);c[h+244>>2]=1;c[h+248>>2]=1;k=h+252|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[h+268>>2]=ea(.300000012);c[h+272>>2]=0;c[h+276>>2]=4;g[h+280>>2]=ea(512.0);c[h+284>>2]=1;k=h+288|0;a[k>>0]=14;l=k+1|0;a[l+0>>0]=a[590864]|0;a[l+1>>0]=a[590865]|0;a[l+2>>0]=a[590866]|0;a[l+3>>0]=a[590867]|0;a[l+4>>0]=a[590868]|0;a[l+5>>0]=a[590869]|0;a[l+6>>0]=a[590870]|0;a[h+296>>0]=0;c[h+300>>2]=0;c[h+304>>2]=0;c[h+308>>2]=0;c[h+312>>2]=1;c[h+316>>2]=1;g[h+320>>2]=ea(15.0);g[h+324>>2]=ea(.333333343);g[h+328>>2]=ea(.0666666701);g[h+332>>2]=ea(.200000003);g[h+336>>2]=ea(.466666669);c[h+340>>2]=1;c[h+344>>2]=1;l=h+348|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[h+364>>2]=ea(.300000012);c[h+368>>2]=0;c[h+372>>2]=4;g[h+376>>2]=ea(512.0);c[h+380>>2]=1;l=h+384|0;a[l>>0]=14;k=l+1|0;a[k+0>>0]=a[590864]|0;a[k+1>>0]=a[590865]|0;a[k+2>>0]=a[590866]|0;a[k+3>>0]=a[590867]|0;a[k+4>>0]=a[590868]|0;a[k+5>>0]=a[590869]|0;a[k+6>>0]=a[590870]|0;a[h+392>>0]=0;c[h+396>>2]=0;c[h+400>>2]=0;c[h+404>>2]=0;c[h+408>>2]=1;c[h+412>>2]=1;g[h+416>>2]=ea(15.0);g[h+420>>2]=ea(.333333343);g[h+424>>2]=ea(.0666666701);g[h+428>>2]=ea(.200000003);g[h+432>>2]=ea(.466666669);c[h+436>>2]=1;c[h+440>>2]=1;k=h+444|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[h+460>>2]=ea(.300000012);c[h+464>>2]=0;c[h+468>>2]=4;g[h+472>>2]=ea(512.0);c[h+476>>2]=1;k=h+480|0;a[k>>0]=14;l=k+1|0;a[l+0>>0]=a[590864]|0;a[l+1>>0]=a[590865]|0;a[l+2>>0]=a[590866]|0;a[l+3>>0]=a[590867]|0;a[l+4>>0]=a[590868]|0;a[l+5>>0]=a[590869]|0;a[l+6>>0]=a[590870]|0;a[h+488>>0]=0;c[h+492>>2]=0;c[h+496>>2]=0;c[h+500>>2]=0;c[h+504>>2]=1;c[h+508>>2]=1;g[h+512>>2]=ea(15.0);g[h+516>>2]=ea(.333333343);g[h+520>>2]=ea(.0666666701);g[h+524>>2]=ea(.200000003);g[h+528>>2]=ea(.466666669);c[h+532>>2]=1;c[h+536>>2]=1;l=h+540|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[h+556>>2]=ea(.300000012);c[h+560>>2]=0;c[h+564>>2]=4;g[h+568>>2]=ea(512.0);c[h+572>>2]=1;Eyc(h);Fyc(b+24|0,h,j);c[b+40>>2]=5;b=j;do{j=b;b=b+-96|0;if(a[b>>0]&1){l=c[j+-88>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(l,e)}}while((b|0)!=(h|0));i=d;return}function syc(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0;d=i;i=i+592|0;e=d+580|0;f=d+576|0;h=d;j=b+24|0;k=c[j>>2]|0;l=b+28|0;m=c[l>>2]|0;if((k|0)==(m|0)){n=h+576|0;a[h>>0]=14;o=h+1|0;a[o+0>>0]=a[590864]|0;a[o+1>>0]=a[590865]|0;a[o+2>>0]=a[590866]|0;a[o+3>>0]=a[590867]|0;a[o+4>>0]=a[590868]|0;a[o+5>>0]=a[590869]|0;a[o+6>>0]=a[590870]|0;a[h+8>>0]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=1;c[h+28>>2]=1;g[h+32>>2]=ea(15.0);g[h+36>>2]=ea(.333333343);g[h+40>>2]=ea(.0666666701);g[h+44>>2]=ea(.200000003);g[h+48>>2]=ea(.466666669);c[h+52>>2]=1;c[h+56>>2]=1;o=h+60|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[h+76>>2]=ea(.300000012);c[h+80>>2]=0;c[h+84>>2]=4;g[h+88>>2]=ea(512.0);c[h+92>>2]=1;o=h+96|0;a[o>>0]=14;p=o+1|0;a[p+0>>0]=a[590864]|0;a[p+1>>0]=a[590865]|0;a[p+2>>0]=a[590866]|0;a[p+3>>0]=a[590867]|0;a[p+4>>0]=a[590868]|0;a[p+5>>0]=a[590869]|0;a[p+6>>0]=a[590870]|0;a[h+104>>0]=0;c[h+108>>2]=0;c[h+112>>2]=0;c[h+116>>2]=0;c[h+120>>2]=1;c[h+124>>2]=1;g[h+128>>2]=ea(15.0);g[h+132>>2]=ea(.333333343);g[h+136>>2]=ea(.0666666701);g[h+140>>2]=ea(.200000003);g[h+144>>2]=ea(.466666669);c[h+148>>2]=1;c[h+152>>2]=1;p=h+156|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[h+172>>2]=ea(.300000012);c[h+176>>2]=0;c[h+180>>2]=4;g[h+184>>2]=ea(512.0);c[h+188>>2]=1;p=h+192|0;a[p>>0]=14;o=p+1|0;a[o+0>>0]=a[590864]|0;a[o+1>>0]=a[590865]|0;a[o+2>>0]=a[590866]|0;a[o+3>>0]=a[590867]|0;a[o+4>>0]=a[590868]|0;a[o+5>>0]=a[590869]|0;a[o+6>>0]=a[590870]|0;a[h+200>>0]=0;c[h+204>>2]=0;c[h+208>>2]=0;c[h+212>>2]=0;c[h+216>>2]=1;c[h+220>>2]=1;g[h+224>>2]=ea(15.0);g[h+228>>2]=ea(.333333343);g[h+232>>2]=ea(.0666666701);g[h+236>>2]=ea(.200000003);g[h+240>>2]=ea(.466666669);c[h+244>>2]=1;c[h+248>>2]=1;o=h+252|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[h+268>>2]=ea(.300000012);c[h+272>>2]=0;c[h+276>>2]=4;g[h+280>>2]=ea(512.0);c[h+284>>2]=1;o=h+288|0;a[o>>0]=14;p=o+1|0;a[p+0>>0]=a[590864]|0;a[p+1>>0]=a[590865]|0;a[p+2>>0]=a[590866]|0;a[p+3>>0]=a[590867]|0;a[p+4>>0]=a[590868]|0;a[p+5>>0]=a[590869]|0;a[p+6>>0]=a[590870]|0;a[h+296>>0]=0;c[h+300>>2]=0;c[h+304>>2]=0;c[h+308>>2]=0;c[h+312>>2]=1;c[h+316>>2]=1;g[h+320>>2]=ea(15.0);g[h+324>>2]=ea(.333333343);g[h+328>>2]=ea(.0666666701);g[h+332>>2]=ea(.200000003);g[h+336>>2]=ea(.466666669);c[h+340>>2]=1;c[h+344>>2]=1;p=h+348|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[h+364>>2]=ea(.300000012);c[h+368>>2]=0;c[h+372>>2]=4;g[h+376>>2]=ea(512.0);c[h+380>>2]=1;p=h+384|0;a[p>>0]=14;o=p+1|0;a[o+0>>0]=a[590864]|0;a[o+1>>0]=a[590865]|0;a[o+2>>0]=a[590866]|0;a[o+3>>0]=a[590867]|0;a[o+4>>0]=a[590868]|0;a[o+5>>0]=a[590869]|0;a[o+6>>0]=a[590870]|0;a[h+392>>0]=0;c[h+396>>2]=0;c[h+400>>2]=0;c[h+404>>2]=0;c[h+408>>2]=1;c[h+412>>2]=1;g[h+416>>2]=ea(15.0);g[h+420>>2]=ea(.333333343);g[h+424>>2]=ea(.0666666701);g[h+428>>2]=ea(.200000003);g[h+432>>2]=ea(.466666669);c[h+436>>2]=1;c[h+440>>2]=1;o=h+444|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[h+460>>2]=ea(.300000012);c[h+464>>2]=0;c[h+468>>2]=4;g[h+472>>2]=ea(512.0);c[h+476>>2]=1;o=h+480|0;a[o>>0]=14;p=o+1|0;a[p+0>>0]=a[590864]|0;a[p+1>>0]=a[590865]|0;a[p+2>>0]=a[590866]|0;a[p+3>>0]=a[590867]|0;a[p+4>>0]=a[590868]|0;a[p+5>>0]=a[590869]|0;a[p+6>>0]=a[590870]|0;a[h+488>>0]=0;c[h+492>>2]=0;c[h+496>>2]=0;c[h+500>>2]=0;c[h+504>>2]=1;c[h+508>>2]=1;g[h+512>>2]=ea(15.0);g[h+516>>2]=ea(.333333343);g[h+520>>2]=ea(.0666666701);g[h+524>>2]=ea(.200000003);g[h+528>>2]=ea(.466666669);c[h+532>>2]=1;c[h+536>>2]=1;p=h+540|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;g[h+556>>2]=ea(.300000012);c[h+560>>2]=0;c[h+564>>2]=4;g[h+568>>2]=ea(512.0);c[h+572>>2]=1;Eyc(h);p=h+288|0;o=c[l>>2]|0;if((o|0)==(c[b+32>>2]|0))Gyc(j,p);else{if(!o)q=0;else{r=a[p>>0]|0;if(!(r&1)){s=(r&255)>>>1;t=p+1|0}else{s=c[h+292>>2]|0;t=c[h+296>>2]|0}if(s>>>0>2147483631)ori(o);if(s>>>0<11){a[o>>0]=s<<1;u=o+1|0}else{p=s+16&-16;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];r=cOb(p,16,e,0,3653512,80)|0;c[o+8>>2]=r;c[o>>2]=p|1;c[o+4>>2]=s;u=r}YEi(u|0,t|0,s|0)|0;a[u+s>>0]=0;s=o+12|0;o=h+300|0;u=s+84|0;do{c[s>>2]=c[o>>2];s=s+4|0;o=o+4|0}while((s|0)<(u|0));q=c[l>>2]|0}c[l>>2]=q+96}q=n;do{n=q;q=q+-96|0;if(a[q>>0]&1){o=c[n+-88>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(o,e)}}while((q|0)!=(h|0));v=c[l>>2]|0;w=c[j>>2]|0}else{v=m;w=k}k=(v-w|0)/96|0;if((v|0)!=(w|0)){v=0;do{m=w+(v*96|0)+12|0;j=c[m>>2]|0;c[m>>2]=(j|0)<0?0:j;j=w+(v*96|0)+16|0;m=c[j>>2]|0;if((m|0)<0)x=0;else x=(m|0)>2?2:m;c[j>>2]=x;j=w+(v*96|0)+20|0;m=c[j>>2]|0;if((m|0)<0)y=0;else y=(m|0)>3?3:m;c[j>>2]=y;j=w+(v*96|0)+24|0;m=c[j>>2]|0;if((m|0)<0)z=0;else z=(m|0)>1?1:m;c[j>>2]=z;j=w+(v*96|0)+28|0;m=c[j>>2]|0;if((m|0)<1)A=1;else A=(m|0)>4?4:m;c[j>>2]=(A|0)==3?2:A;j=w+(v*96|0)+64|0;m=c[j>>2]|0;do if((m|0)>=2){if((m|0)<4){c[j>>2]=2;break}if((m|0)<8){c[j>>2]=4;break}else{c[j>>2]=8;break}}else c[j>>2]=0;while(0);j=w+(v*96|0)+32|0;B=ea(g[j>>2]);m=B<ea(0.0);g[j>>2]=m?ea(0.0):B;m=w+(v*96|0)+52|0;j=c[m>>2]|0;l=(j|0)<1?1:j;j=(l|0)>4?4:l;c[m>>2]=(j|0)==3?2:j;j=w+(v*96|0)+56|0;m=c[j>>2]|0;l=(m|0)<0?0:m;c[j>>2]=(l|0)>10?10:l;l=w+(v*96|0)+60|0;j=c[l>>2]|0;m=(j|0)<0?0:j;c[l>>2]=(m|0)>3?3:m;m=w+(v*96|0)+68|0;l=c[m>>2]|0;j=(l|0)<0?0:l;c[m>>2]=(j|0)>2?2:j;j=w+(v*96|0)+76|0;B=ea(g[j>>2]);m=B>ea(0.0);g[j>>2]=m?B:ea(0.0);m=w+(v*96|0)+80|0;j=c[m>>2]|0;if((j|0)<0)C=0;else C=(j|0)>7?7:j;c[m>>2]=C;m=w+(v*96|0)+92|0;j=c[m>>2]|0;if((j|0)<1)D=1;else D=(j|0)>5?5:j;c[m>>2]=D;v=v+1|0}while(v>>>0<k>>>0)}v=b+40|0;b=k+-1|0;k=c[v>>2]|0;if((k|0)<0){E=0;c[v>>2]=E;i=d;return}E=(k|0)>(b|0)?b:k;c[v>>2]=E;i=d;return}function tyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;rri(d,590872,20);e=a+40|0;f=ape(d,c[e>>2]|0)|0;g=(((c[a+28>>2]|0)-(c[a+24>>2]|0)|0)/96|0)+-1|0;if((f|0)<0)h=0;else h=(f|0)>(g|0)?g:f;c[e>>2]=h;xri(d);uyc(a,-1,0);i=b;return}function uyc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;h=c[a+40>>2]|0;j=a+24|0;k=c[j>>2]|0;FDc(c[k+(h*96|0)+60>>2]|0);DDc(c[k+(h*96|0)+56>>2]|0,1);if(auc()|0){l=$tc()|0;g[l+20>>2]=ea(g[k+(h*96|0)+76>>2])}l=c[k+(h*96|0)+80>>2]|0;if(oVb()|0){m=c[a+36>>2]|0;n=(m|0)<(l|0)?l:m}else n=l;if(auc()|0)c[($tc()|0)+24>>2]=n;if(!d){i=e;return}d=c[j>>2]|0;if((c[d+(b*96|0)+64>>2]|0)==(c[k+(h*96|0)+64>>2]|0)?(c[d+(b*96|0)+68>>2]|0)==(c[k+(h*96|0)+68>>2]|0):0){i=e;return}h=ECc()|0;k=c[h>>2]|0;b=c[k+8>>2]|0;d=c[h+4>>2]|0;if((d|0)==-1)o=mo[c[k+80>>2]&4095](h)|0;else o=d;d=c[h+8>>2]|0;if((d|0)==-1)p=mo[c[(c[h>>2]|0)+84>>2]&4095](h)|0;else p=d;d=c[h+12>>2]|0;if((d|0)==-1)q=mo[c[(c[h>>2]|0)+92>>2]&4095](h)|0;else q=(d|0)==1;d=c[h+16>>2]|0;if((d|0)==-1){In[c[(c[h>>2]|0)+28>>2]&4095](f,h);r=c[f+8>>2]|0}else r=d;En[b&127](h,o,p,q,r);i=e;return}function vyc(a,b){a=a|0;b=ea(b);var d=0,e=Im;d=b<ea(0.0);e=d?ea(0.0):b;g[(c[a+24>>2]|0)+((c[a+40>>2]|0)*96|0)+32>>2]=e;return}function wyc(){var a=0,b=0,d=Im;a=i;b=rVb(11)|0;d=ea(g[(c[b+24>>2]|0)+((c[b+40>>2]|0)*96|0)+32>>2]);i=a;return ea(d)}function xyc(){return}function yyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(44,e,1,16,3653512,19)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];jSb(g,e,b);c[g>>2]=590760;b=g+24|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return g|0}function zyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;KSb(a,b);ddd(b,5);e=c[142270]|0;add(b,590896,e,a+40|0,2048);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);h=a+24|0;add(b,590920,c[142306]|0,h,2048);Jyc(b,h,0);bdd(b);add(b,591096,e,a+36|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function Ayc(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+704|0;h=f+640|0;j=f+56|0;k=f+660|0;l=f+684|0;m=f+28|0;n=f+656|0;o=f+664|0;p=f+680|0;q=f+688|0;r=f+692|0;s=f+24|0;t=f+12|0;u=f;v=f+644|0;w=f+32|0;x=f+44|0;y=f+668|0;z=f+64|0;LSb(b,e);rdd(e,5);A=b+40|0;B=c[142270]|0;C=qdd(e,590896,B,h,0)|0;if(C){if((C|0)>0){C=e+12|0;D=c[e+16>>2]|0;E=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;F=D+E|0;c[C>>2]=F;if((E|0)>=0?(G=D+(E+4)|0,G>>>0<=(c[e+20>>2]|0)>>>0):0){c[A>>2]=c[F>>2];c[C>>2]=G}else Bid(C,A,4);if(c[e>>2]&512)c[A>>2]=XEi(c[A>>2]|0)|0}else{C=c[h>>2]|0;if(C)_n[C&4095](A,e)|0}sdd(e)}C=b+24|0;G=qdd(e,590920,c[142306]|0,h,1)|0;if(G){if((G|0)<=0){G=c[h>>2]|0;if(G)_n[G&4095](C,e)|0}else Kyc(e,C,0);sdd(e)}do if(xdd(e,4)|0){c[q>>2]=3;c[r>>2]=3;c[s>>2]=2;G=qdd(e,590944,B,h,0)|0;if(G){if((G|0)>0){G=e+12|0;F=c[e+16>>2]|0;E=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;D=F+E|0;c[G>>2]=D;if((E|0)>=0?(H=F+(E+4)|0,H>>>0<=(c[e+20>>2]|0)>>>0):0){c[q>>2]=c[D>>2];c[G>>2]=H}else Bid(G,q,4);if(c[e>>2]&512)c[q>>2]=XEi(c[q>>2]|0)|0}else{G=c[h>>2]|0;if(G)_n[G&4095](q,e)|0}sdd(e)}G=qdd(e,590976,B,h,0)|0;if(G){if((G|0)>0){G=e+12|0;H=c[e+16>>2]|0;D=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;E=H+D|0;c[G>>2]=E;if((D|0)>=0?(F=H+(D+4)|0,F>>>0<=(c[e+20>>2]|0)>>>0):0){c[r>>2]=c[E>>2];c[G>>2]=F}else Bid(G,r,4);if(c[e>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{G=c[h>>2]|0;if(G)_n[G&4095](r,e)|0}sdd(e)}G=qdd(e,591008,B,h,0)|0;if(G){if((G|0)>0){G=e+12|0;F=c[e+16>>2]|0;E=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;D=F+E|0;c[G>>2]=D;if((E|0)>=0?(H=F+(E+4)|0,H>>>0<=(c[e+20>>2]|0)>>>0):0){c[s>>2]=c[D>>2];c[G>>2]=H}else Bid(G,s,4);if(c[e>>2]&512)c[s>>2]=XEi(c[s>>2]|0)|0}else{G=c[h>>2]|0;if(G)_n[G&4095](s,e)|0}sdd(e)}G=qdd(e,591032,B,h,0)|0;if(G){if((G|0)>0){G=e+12|0;H=c[e+16>>2]|0;D=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;E=H+D|0;c[G>>2]=E;if((D|0)>=0?(F=H+(D+4)|0,F>>>0<=(c[e+20>>2]|0)>>>0):0){c[A>>2]=c[E>>2];c[G>>2]=F}else Bid(G,A,4);if(c[e>>2]&512)c[A>>2]=XEi(c[A>>2]|0)|0}else{G=c[h>>2]|0;if(G)_n[G&4095](A,e)|0}sdd(e)}c[A>>2]=c[q>>2];G=c[C>>2]|0;if(((c[b+28>>2]|0)-G|0)==576){a[t>>0]=14;F=t+1|0;a[F+0>>0]=a[590864]|0;a[F+1>>0]=a[590865]|0;a[F+2>>0]=a[590866]|0;a[F+3>>0]=a[590867]|0;a[F+4>>0]=a[590868]|0;a[F+5>>0]=a[590869]|0;a[F+6>>0]=a[590870]|0;E=t+8|0;a[E>>0]=0;a:do if((G|0)!=(t|0)){D=a[G>>0]|0;do if(!(D&1))if(!(D&1))I=70;else I=69;else{H=c[G>>2]|0;J=H&-2;K=J+-1|0;L=(H&1|0)==0;if(K>>>0>=7)if(L){I=70;break}else{I=69;break}if(L)M=H>>>1&127;else M=c[G+4>>2]|0;eXb(G,K,8-J|0,M,0,M,7,F);break a}while(0);if((I|0)==69)N=c[G+8>>2]|0;else if((I|0)==70)N=G+1|0;aFi(N|0,F|0,7)|0;a[N+7>>0]=0;if(!(a[G>>0]&1)){a[G>>0]=14;break}else{c[G+4>>2]=7;break}}while(0);if(a[t>>0]&1){G=c[E>>2]|0;c[p>>2]=58;c[h+0>>2]=c[p+0>>2];eOb(G,h)}G=c[C>>2]|0;F=G+96|0;a[u>>0]=8;D=u+1|0;a[D>>0]=70;a[D+1>>0]=97;a[D+2>>0]=115;a[D+3>>0]=116;a[u+5>>0]=0;b:do if((F|0)!=(u|0)){J=a[F>>0]|0;do if(!(J&1))if(!(J&1))I=86;else I=85;else{K=c[F>>2]|0;H=K&-2;L=H+-1|0;O=(K&1|0)==0;if(L>>>0>=4)if(O){I=86;break}else{I=85;break}if(O)P=K>>>1&127;else P=c[G+100>>2]|0;eXb(F,L,5-H|0,P,0,P,4,D);break b}while(0);if((I|0)==85)Q=c[G+104>>2]|0;else if((I|0)==86)Q=F+1|0;J=d[D>>0]|d[D+1>>0]<<8|d[D+2>>0]<<16|d[D+3>>0]<<24;a[Q>>0]=J;a[Q+1>>0]=J>>8;a[Q+2>>0]=J>>16;a[Q+3>>0]=J>>24;a[Q+4>>0]=0;if(!(a[F>>0]&1)){a[F>>0]=8;break}else{c[G+100>>2]=4;break}}while(0);if(a[u>>0]&1){G=c[u+8>>2]|0;c[o>>2]=58;c[h+0>>2]=c[o+0>>2];eOb(G,h)}G=c[C>>2]|0;F=G+192|0;a[v>>0]=12;D=v+1|0;a[D+0>>0]=a[2952392]|0;a[D+1>>0]=a[2952393]|0;a[D+2>>0]=a[2952394]|0;a[D+3>>0]=a[2952395]|0;a[D+4>>0]=a[2952396]|0;a[D+5>>0]=a[2952397]|0;a[v+7>>0]=0;c:do if((F|0)!=(v|0)){E=a[F>>0]|0;do if(!(E&1))if(!(E&1))I=102;else I=101;else{J=c[F>>2]|0;H=J&-2;L=H+-1|0;K=(J&1|0)==0;if(L>>>0>=6)if(K){I=102;break}else{I=101;break}if(K)R=J>>>1&127;else R=c[G+196>>2]|0;eXb(F,L,7-H|0,R,0,R,6,D);break c}while(0);if((I|0)==101)S=c[G+200>>2]|0;else if((I|0)==102)S=F+1|0;aFi(S|0,D|0,6)|0;a[S+6>>0]=0;if(!(a[F>>0]&1)){a[F>>0]=12;break}else{c[G+196>>2]=6;break}}while(0);if(a[v>>0]&1){G=c[v+8>>2]|0;c[n>>2]=58;c[h+0>>2]=c[n+0>>2];eOb(G,h)}G=c[C>>2]|0;F=G+288|0;a[w>>0]=8;D=w+1|0;a[D>>0]=71;a[D+1>>0]=111;a[D+2>>0]=111;a[D+3>>0]=100;a[w+5>>0]=0;d:do if((F|0)!=(w|0)){E=a[F>>0]|0;do if(!(E&1))if(!(E&1))I=118;else I=117;else{H=c[F>>2]|0;L=H&-2;J=L+-1|0;K=(H&1|0)==0;if(J>>>0>=4)if(K){I=118;break}else{I=117;break}if(K)T=H>>>1&127;else T=c[G+292>>2]|0;eXb(F,J,5-L|0,T,0,T,4,D);break d}while(0);if((I|0)==117)U=c[G+296>>2]|0;else if((I|0)==118)U=F+1|0;E=d[D>>0]|d[D+1>>0]<<8|d[D+2>>0]<<16|d[D+3>>0]<<24;a[U>>0]=E;a[U+1>>0]=E>>8;a[U+2>>0]=E>>16;a[U+3>>0]=E>>24;a[U+4>>0]=0;if(!(a[F>>0]&1)){a[F>>0]=8;break}else{c[G+292>>2]=4;break}}while(0);if(a[w>>0]&1){G=c[w+8>>2]|0;c[m>>2]=58;c[h+0>>2]=c[m+0>>2];eOb(G,h)}G=c[C>>2]|0;F=G+384|0;a[x>>0]=18;D=x+1|0;E=D+0|0;L=591064|0;J=E+9|0;do{a[E>>0]=a[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(J|0));a[x+10>>0]=0;e:do if((F|0)!=(x|0)){H=a[F>>0]|0;do if(!(H&1))if(!(H&1))I=134;else I=133;else{K=c[F>>2]|0;O=K&-2;V=O+-1|0;W=(K&1|0)==0;if(V>>>0>=9)if(W){I=134;break}else{I=133;break}if(W)X=K>>>1&127;else X=c[G+388>>2]|0;eXb(F,V,10-O|0,X,0,X,9,D);break e}while(0);if((I|0)==133)Y=c[G+392>>2]|0;else if((I|0)==134)Y=F+1|0;aFi(Y|0,D|0,9)|0;a[Y+9>>0]=0;if(!(a[F>>0]&1)){a[F>>0]=18;break}else{c[G+388>>2]=9;break}}while(0);if(a[x>>0]&1){G=c[x+8>>2]|0;c[l>>2]=58;c[h+0>>2]=c[l+0>>2];eOb(G,h)}G=c[C>>2]|0;F=G+480|0;a[y>>0]=18;D=y+1|0;E=D+0|0;L=591080|0;J=E+9|0;do{a[E>>0]=a[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(J|0));a[y+10>>0]=0;f:do if((F|0)!=(y|0)){L=a[F>>0]|0;do if(!(L&1))if(!(L&1))I=150;else I=149;else{E=c[F>>2]|0;J=E&-2;H=J+-1|0;O=(E&1|0)==0;if(H>>>0>=9)if(O){I=150;break}else{I=149;break}if(O)Z=E>>>1&127;else Z=c[G+484>>2]|0;eXb(F,H,10-J|0,Z,0,Z,9,D);break f}while(0);if((I|0)==149)_=c[G+488>>2]|0;else if((I|0)==150)_=F+1|0;aFi(_|0,D|0,9)|0;a[_+9>>0]=0;if(!(a[F>>0]&1)){a[F>>0]=18;break}else{c[G+484>>2]=9;break}}while(0);if(!(a[y>>0]&1))break;G=c[y+8>>2]|0;c[k>>2]=58;c[h+0>>2]=c[k+0>>2];eOb(G,h)}}while(0);if(xdd(e,3)|0){k=z+576|0;a[z>>0]=14;y=z+1|0;a[y+0>>0]=a[590864]|0;a[y+1>>0]=a[590865]|0;a[y+2>>0]=a[590866]|0;a[y+3>>0]=a[590867]|0;a[y+4>>0]=a[590868]|0;a[y+5>>0]=a[590869]|0;a[y+6>>0]=a[590870]|0;a[z+8>>0]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z+20>>2]=0;c[z+24>>2]=1;c[z+28>>2]=1;g[z+32>>2]=ea(15.0);g[z+36>>2]=ea(.333333343);g[z+40>>2]=ea(.0666666701);g[z+44>>2]=ea(.200000003);g[z+48>>2]=ea(.466666669);c[z+52>>2]=1;c[z+56>>2]=1;y=z+60|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[z+76>>2]=ea(.300000012);c[z+80>>2]=0;c[z+84>>2]=4;g[z+88>>2]=ea(512.0);c[z+92>>2]=1;y=z+96|0;a[y>>0]=14;_=y+1|0;a[_+0>>0]=a[590864]|0;a[_+1>>0]=a[590865]|0;a[_+2>>0]=a[590866]|0;a[_+3>>0]=a[590867]|0;a[_+4>>0]=a[590868]|0;a[_+5>>0]=a[590869]|0;a[_+6>>0]=a[590870]|0;a[z+104>>0]=0;c[z+108>>2]=0;c[z+112>>2]=0;c[z+116>>2]=0;c[z+120>>2]=1;c[z+124>>2]=1;g[z+128>>2]=ea(15.0);g[z+132>>2]=ea(.333333343);g[z+136>>2]=ea(.0666666701);g[z+140>>2]=ea(.200000003);g[z+144>>2]=ea(.466666669);c[z+148>>2]=1;c[z+152>>2]=1;_=z+156|0;c[_+0>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;c[_+12>>2]=0;g[z+172>>2]=ea(.300000012);c[z+176>>2]=0;c[z+180>>2]=4;g[z+184>>2]=ea(512.0);c[z+188>>2]=1;_=z+192|0;a[_>>0]=14;y=_+1|0;a[y+0>>0]=a[590864]|0;a[y+1>>0]=a[590865]|0;a[y+2>>0]=a[590866]|0;a[y+3>>0]=a[590867]|0;a[y+4>>0]=a[590868]|0;a[y+5>>0]=a[590869]|0;a[y+6>>0]=a[590870]|0;a[z+200>>0]=0;c[z+204>>2]=0;c[z+208>>2]=0;c[z+212>>2]=0;c[z+216>>2]=1;c[z+220>>2]=1;g[z+224>>2]=ea(15.0);g[z+228>>2]=ea(.333333343);g[z+232>>2]=ea(.0666666701);g[z+236>>2]=ea(.200000003);g[z+240>>2]=ea(.466666669);c[z+244>>2]=1;c[z+248>>2]=1;y=z+252|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[z+268>>2]=ea(.300000012);c[z+272>>2]=0;c[z+276>>2]=4;g[z+280>>2]=ea(512.0);c[z+284>>2]=1;y=z+288|0;a[y>>0]=14;_=y+1|0;a[_+0>>0]=a[590864]|0;a[_+1>>0]=a[590865]|0;a[_+2>>0]=a[590866]|0;a[_+3>>0]=a[590867]|0;a[_+4>>0]=a[590868]|0;a[_+5>>0]=a[590869]|0;a[_+6>>0]=a[590870]|0;a[z+296>>0]=0;c[z+300>>2]=0;c[z+304>>2]=0;c[z+308>>2]=0;c[z+312>>2]=1;c[z+316>>2]=1;g[z+320>>2]=ea(15.0);g[z+324>>2]=ea(.333333343);g[z+328>>2]=ea(.0666666701);g[z+332>>2]=ea(.200000003);g[z+336>>2]=ea(.466666669);c[z+340>>2]=1;c[z+344>>2]=1;_=z+348|0;c[_+0>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;c[_+12>>2]=0;g[z+364>>2]=ea(.300000012);c[z+368>>2]=0;c[z+372>>2]=4;g[z+376>>2]=ea(512.0);c[z+380>>2]=1;_=z+384|0;a[_>>0]=14;y=_+1|0;a[y+0>>0]=a[590864]|0;a[y+1>>0]=a[590865]|0;a[y+2>>0]=a[590866]|0;a[y+3>>0]=a[590867]|0;a[y+4>>0]=a[590868]|0;a[y+5>>0]=a[590869]|0;a[y+6>>0]=a[590870]|0;a[z+392>>0]=0;c[z+396>>2]=0;c[z+400>>2]=0;c[z+404>>2]=0;c[z+408>>2]=1;c[z+412>>2]=1;g[z+416>>2]=ea(15.0);g[z+420>>2]=ea(.333333343);g[z+424>>2]=ea(.0666666701);g[z+428>>2]=ea(.200000003);g[z+432>>2]=ea(.466666669);c[z+436>>2]=1;c[z+440>>2]=1;y=z+444|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[z+460>>2]=ea(.300000012);c[z+464>>2]=0;c[z+468>>2]=4;g[z+472>>2]=ea(512.0);c[z+476>>2]=1;y=z+480|0;a[y>>0]=14;_=y+1|0;a[_+0>>0]=a[590864]|0;a[_+1>>0]=a[590865]|0;a[_+2>>0]=a[590866]|0;a[_+3>>0]=a[590867]|0;a[_+4>>0]=a[590868]|0;a[_+5>>0]=a[590869]|0;a[_+6>>0]=a[590870]|0;a[z+488>>0]=0;c[z+492>>2]=0;c[z+496>>2]=0;c[z+500>>2]=0;c[z+504>>2]=1;c[z+508>>2]=1;g[z+512>>2]=ea(15.0);g[z+516>>2]=ea(.333333343);g[z+520>>2]=ea(.0666666701);g[z+524>>2]=ea(.200000003);g[z+528>>2]=ea(.466666669);c[z+532>>2]=1;c[z+536>>2]=1;_=z+540|0;c[_+0>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;c[_+12>>2]=0;g[z+556>>2]=ea(.300000012);c[z+560>>2]=0;c[z+564>>2]=4;g[z+568>>2]=ea(512.0);c[z+572>>2]=1;Eyc(z);_=qdd(e,590864,591560,h,1)|0;if(_){if((_|0)<=0){_=c[h>>2]|0;if(_)_n[_&4095](z,e)|0}else Lyc(z,e);sdd(e)}_=z+96|0;y=qdd(e,591048,591560,h,1)|0;if(y){if((y|0)<=0){y=c[h>>2]|0;if(y)_n[y&4095](_,e)|0}else Lyc(_,e);sdd(e)}_=z+192|0;y=qdd(e,2952392,591560,h,1)|0;if(y){if((y|0)<=0){y=c[h>>2]|0;if(y)_n[y&4095](_,e)|0}else Lyc(_,e);sdd(e)}_=z+288|0;y=qdd(e,591056,591560,h,1)|0;if(y){if((y|0)<=0){y=c[h>>2]|0;if(y)_n[y&4095](_,e)|0}else Lyc(_,e);sdd(e)}_=z+384|0;y=qdd(e,591064,591560,h,1)|0;if(y){if((y|0)<=0){y=c[h>>2]|0;if(y)_n[y&4095](_,e)|0}else Lyc(_,e);sdd(e)}_=z+480|0;y=qdd(e,591080,591560,h,1)|0;if(y){if((y|0)<=0){y=c[h>>2]|0;if(y)_n[y&4095](_,e)|0}else Lyc(_,e);sdd(e)}if(xdd(e,2)|0){c[z+24>>2]=0;c[z+120>>2]=0;c[z+216>>2]=0;c[z+312>>2]=0;c[z+408>>2]=0;c[z+504>>2]=0}Fyc(C,z,k);C=k;do{k=C;C=C+-96|0;if(a[C>>0]&1){_=c[k+-88>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(_,h)}}while((C|0)!=(z|0));$=c[142270]|0}else $=B;B=b+36|0;b=qdd(e,591096,$,h,0)|0;if(!b){i=f;return}if((b|0)>0){b=e+12|0;$=c[e+16>>2]|0;z=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;C=$+z|0;c[b>>2]=C;if((z|0)>=0?(j=$+(z+4)|0,j>>>0<=(c[e+20>>2]|0)>>>0):0){c[B>>2]=c[C>>2];c[b>>2]=j}else Bid(b,B,4);if(c[e>>2]&512)c[B>>2]=XEi(c[B>>2]|0)|0}else{b=c[h>>2]|0;if(b)_n[b&4095](B,e)|0}sdd(e);i=f;return}function Byc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}Myc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{Nyc(r,a);r=r+96|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*96|0)|0;c[j>>2]=0;i=d;return}function Cyc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;Myc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{Oyc(r,a);r=r+96|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*96|0)|0;c[j>>2]=0;i=d;return}function Dyc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;OSb(a,b);f=a+40|0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[f>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,f,4);m=c[g>>2]|0;n=c[k>>2]|0}f=a+28|0;l=c[f>>2]|0;j=a+24|0;h=c[j>>2]|0;o=(l-h|0)/96|0;c[e>>2]=o;p=m+4|0;if(p>>>0<n>>>0){c[m>>2]=o;c[g>>2]=p;q=h;r=l}else{Gid(g,e,4);q=c[j>>2]|0;r=c[f>>2]|0}if((q|0)!=(r|0)){f=q;do{Pyc(f,b);f=f+96|0}while((f|0)!=(r|0))}r=a+36|0;a=c[g>>2]|0;f=a+4|0;if(f>>>0<(c[k>>2]|0)>>>0){c[a>>2]=c[r>>2];c[g>>2]=f;i=d;return}else{Gid(g,r,4);i=d;return}}function Eyc(e){e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;f=i;i=i+192|0;h=f+176|0;j=f+168|0;k=f+136|0;l=f+132|0;m=f+164|0;n=f+172|0;o=f+180|0;p=f+24|0;q=f+12|0;r=f+140|0;s=f+120|0;t=f+152|0;u=f;a[p>>0]=14;v=p+1|0;a[v+0>>0]=a[590864]|0;a[v+1>>0]=a[590865]|0;a[v+2>>0]=a[590866]|0;a[v+3>>0]=a[590867]|0;a[v+4>>0]=a[590868]|0;a[v+5>>0]=a[590869]|0;a[v+6>>0]=a[590870]|0;w=p+8|0;a[w>>0]=0;x=p+12|0;c[x>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=1;c[p+28>>2]=1;g[p+32>>2]=ea(15.0);g[p+36>>2]=ea(.333333343);g[p+40>>2]=ea(.0666666701);g[p+44>>2]=ea(.200000003);g[p+48>>2]=ea(.466666669);c[p+52>>2]=1;c[p+56>>2]=1;y=p+60|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;g[p+76>>2]=ea(.300000012);c[p+80>>2]=0;c[p+84>>2]=4;g[p+88>>2]=ea(512.0);c[p+92>>2]=1;y=e+96|0;z=e+192|0;A=e+288|0;B=e+384|0;C=e+480|0;a:do if((C|0)!=(p|0)){D=a[C>>0]|0;do if(!(D&1))if(!(D&1))E=7;else E=6;else{F=c[C>>2]|0;G=F&-2;H=G+-1|0;I=(F&1|0)==0;if(H>>>0>=7)if(I){E=7;break}else{E=6;break}if(I)J=F>>>1&127;else J=c[e+484>>2]|0;eXb(C,H,8-G|0,J,0,J,7,v);break a}while(0);if((E|0)==6)K=c[e+488>>2]|0;else if((E|0)==7)K=C+1|0;aFi(K|0,v|0,7)|0;a[K+7>>0]=0;if(!(a[C>>0]&1)){a[C>>0]=14;break}else{c[e+484>>2]=7;break}}while(0);K=e+492|0;v=K+0|0;J=x+0|0;x=v+84|0;do{c[v>>2]=c[J>>2];v=v+4|0;J=J+4|0}while((v|0)<(x|0));D=a[C>>0]|0;if(!(D&1)){L=(D&255)>>>1;M=C+1|0}else{L=c[e+484>>2]|0;M=c[e+488>>2]|0}D=a[B>>0]|0;if(!(D&1)){N=10;O=D}else{D=c[B>>2]|0;N=(D&-2)+-1|0;O=D&255}D=(O&1)==0;do if(L>>>0<=N>>>0){if(D)P=B+1|0;else P=c[e+392>>2]|0;aFi(P|0,M|0,L|0)|0;a[P+L>>0]=0;G=a[B>>0]|0;if(!(G&1)){H=L<<1&255;a[B>>0]=H;Q=H;break}else{c[e+388>>2]=L;Q=G;break}}else{if(D)R=(O&255)>>>1;else R=c[e+388>>2]|0;eXb(B,N,L-N|0,R,0,R,L,M);Q=a[B>>0]|0}while(0);M=e+396|0;v=M+0|0;J=K+0|0;x=v+84|0;do{c[v>>2]=c[J>>2];v=v+4|0;J=J+4|0}while((v|0)<(x|0));if(!(Q&1)){S=(Q&255)>>>1;T=B+1|0}else{S=c[e+388>>2]|0;T=c[e+392>>2]|0}Q=a[A>>0]|0;if(!(Q&1)){U=10;V=Q}else{Q=c[A>>2]|0;U=(Q&-2)+-1|0;V=Q&255}Q=(V&1)==0;do if(S>>>0<=U>>>0){if(Q)W=A+1|0;else W=c[e+296>>2]|0;aFi(W|0,T|0,S|0)|0;a[W+S>>0]=0;L=a[A>>0]|0;if(!(L&1)){R=S<<1&255;a[A>>0]=R;X=R;break}else{c[e+292>>2]=S;X=L;break}}else{if(Q)Y=(V&255)>>>1;else Y=c[e+292>>2]|0;eXb(A,U,S-U|0,Y,0,Y,S,T);X=a[A>>0]|0}while(0);T=e+300|0;v=T+0|0;J=M+0|0;x=v+84|0;do{c[v>>2]=c[J>>2];v=v+4|0;J=J+4|0}while((v|0)<(x|0));if(!(X&1)){Z=(X&255)>>>1;_=A+1|0}else{Z=c[e+292>>2]|0;_=c[e+296>>2]|0}X=a[z>>0]|0;if(!(X&1)){$=10;aa=X}else{X=c[z>>2]|0;$=(X&-2)+-1|0;aa=X&255}X=(aa&1)==0;do if(Z>>>0<=$>>>0){if(X)ba=z+1|0;else ba=c[e+200>>2]|0;aFi(ba|0,_|0,Z|0)|0;a[ba+Z>>0]=0;S=a[z>>0]|0;if(!(S&1)){Y=Z<<1&255;a[z>>0]=Y;ca=Y;break}else{c[e+196>>2]=Z;ca=S;break}}else{if(X)da=(aa&255)>>>1;else da=c[e+196>>2]|0;eXb(z,$,Z-$|0,da,0,da,Z,_);ca=a[z>>0]|0}while(0);_=e+204|0;v=_+0|0;J=T+0|0;x=v+84|0;do{c[v>>2]=c[J>>2];v=v+4|0;J=J+4|0}while((v|0)<(x|0));if(!(ca&1)){fa=(ca&255)>>>1;ga=z+1|0}else{fa=c[e+196>>2]|0;ga=c[e+200>>2]|0}ca=a[y>>0]|0;if(!(ca&1)){ha=10;ia=ca}else{ca=c[y>>2]|0;ha=(ca&-2)+-1|0;ia=ca&255}ca=(ia&1)==0;do if(fa>>>0<=ha>>>0){if(ca)ja=y+1|0;else ja=c[e+104>>2]|0;aFi(ja|0,ga|0,fa|0)|0;a[ja+fa>>0]=0;Z=a[y>>0]|0;if(!(Z&1)){da=fa<<1&255;a[y>>0]=da;ka=da;break}else{c[e+100>>2]=fa;ka=Z;break}}else{if(ca)la=(ia&255)>>>1;else la=c[e+100>>2]|0;eXb(y,ha,fa-ha|0,la,0,la,fa,ga);ka=a[y>>0]|0}while(0);ga=e+108|0;v=ga+0|0;J=_+0|0;x=v+84|0;do{c[v>>2]=c[J>>2];v=v+4|0;J=J+4|0}while((v|0)<(x|0));if(!(ka&1)){ma=(ka&255)>>>1;na=y+1|0}else{ma=c[e+100>>2]|0;na=c[e+104>>2]|0}ka=a[e>>0]|0;if(!(ka&1)){oa=10;pa=ka}else{ka=c[e>>2]|0;oa=(ka&-2)+-1|0;pa=ka&255}ka=(pa&1)==0;do if(ma>>>0<=oa>>>0){if(ka)qa=e+1|0;else qa=c[e+8>>2]|0;aFi(qa|0,na|0,ma|0)|0;a[qa+ma>>0]=0;if(!(a[e>>0]&1)){a[e>>0]=ma<<1;break}else{c[e+4>>2]=ma;break}}else{if(ka)ra=(pa&255)>>>1;else ra=c[e+4>>2]|0;eXb(e,oa,ma-oa|0,ra,0,ra,ma,na)}while(0);v=e+12|0;J=ga+0|0;x=v+84|0;do{c[v>>2]=c[J>>2];v=v+4|0;J=J+4|0}while((v|0)<(x|0));a[q>>0]=8;ga=q+1|0;a[ga>>0]=70;a[ga+1>>0]=97;a[ga+2>>0]=115;a[ga+3>>0]=116;a[q+5>>0]=0;b:do if((y|0)!=(q|0)){na=a[y>>0]|0;do if(!(na&1))if(!(na&1))E=101;else E=100;else{ma=c[y>>2]|0;ra=ma&-2;oa=ra+-1|0;pa=(ma&1|0)==0;if(oa>>>0>=4)if(pa){E=101;break}else{E=100;break}if(pa)sa=ma>>>1&127;else sa=c[e+100>>2]|0;eXb(y,oa,5-ra|0,sa,0,sa,4,ga);break b}while(0);if((E|0)==100)ta=c[e+104>>2]|0;else if((E|0)==101)ta=y+1|0;na=d[ga>>0]|d[ga+1>>0]<<8|d[ga+2>>0]<<16|d[ga+3>>0]<<24;a[ta>>0]=na;a[ta+1>>0]=na>>8;a[ta+2>>0]=na>>16;a[ta+3>>0]=na>>24;a[ta+4>>0]=0;if(!(a[y>>0]&1)){a[y>>0]=8;break}else{c[e+100>>2]=4;break}}while(0);if(a[q>>0]&1){y=c[q+8>>2]|0;c[o>>2]=58;c[h+0>>2]=c[o+0>>2];eOb(y,h)}g[e+128>>2]=ea(20.0);c[e+148>>2]=2;y=e+152|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;b[y+16>>1]=0;g[e+172>>2]=ea(.400000006);c[e+180>>2]=16;a[r>>0]=12;y=r+1|0;a[y+0>>0]=a[2952392]|0;a[y+1>>0]=a[2952393]|0;a[y+2>>0]=a[2952394]|0;a[y+3>>0]=a[2952395]|0;a[y+4>>0]=a[2952396]|0;a[y+5>>0]=a[2952397]|0;a[r+7>>0]=0;c:do if((z|0)!=(r|0)){o=a[z>>0]|0;do if(!(o&1))if(!(o&1))E=117;else E=116;else{q=c[z>>2]|0;ta=q&-2;ga=ta+-1|0;sa=(q&1|0)==0;if(ga>>>0>=6)if(sa){E=117;break}else{E=116;break}if(sa)ua=q>>>1&127;else ua=c[e+196>>2]|0;eXb(z,ga,7-ta|0,ua,0,ua,6,y);break c}while(0);if((E|0)==116)va=c[e+200>>2]|0;else if((E|0)==117)va=z+1|0;aFi(va|0,y|0,6)|0;a[va+6>>0]=0;if(!(a[z>>0]&1)){a[z>>0]=12;break}else{c[e+196>>2]=6;break}}while(0);if(a[r>>0]&1){z=c[r+8>>2]|0;c[n>>2]=58;c[h+0>>2]=c[n+0>>2];eOb(z,h)}c[_>>2]=1;c[e+208>>2]=1;g[e+224>>2]=ea(20.0);c[e+244>>2]=2;c[e+248>>2]=0;c[e+252>>2]=1;_=e+256|0;c[_+0>>2]=0;c[_+4>>2]=0;b[_+8>>1]=0;g[e+268>>2]=ea(.699999988);c[e+276>>2]=64;a[s>>0]=8;_=s+1|0;a[_>>0]=71;a[_+1>>0]=111;a[_+2>>0]=111;a[_+3>>0]=100;a[s+5>>0]=0;d:do if((A|0)!=(s|0)){z=a[A>>0]|0;do if(!(z&1))if(!(z&1))E=133;else E=132;else{n=c[A>>2]|0;r=n&-2;va=r+-1|0;y=(n&1|0)==0;if(va>>>0>=4)if(y){E=133;break}else{E=132;break}if(y)wa=n>>>1&127;else wa=c[e+292>>2]|0;eXb(A,va,5-r|0,wa,0,wa,4,_);break d}while(0);if((E|0)==132)xa=c[e+296>>2]|0;else if((E|0)==133)xa=A+1|0;z=d[_>>0]|d[_+1>>0]<<8|d[_+2>>0]<<16|d[_+3>>0]<<24;a[xa>>0]=z;a[xa+1>>0]=z>>8;a[xa+2>>0]=z>>16;a[xa+3>>0]=z>>24;a[xa+4>>0]=0;if(!(a[A>>0]&1)){a[A>>0]=8;break}else{c[e+292>>2]=4;break}}while(0);if(a[s>>0]&1){A=c[s+8>>2]|0;c[m>>2]=58;c[h+0>>2]=c[m+0>>2];eOb(A,h)}c[T>>2]=2;c[e+304>>2]=2;c[e+308>>2]=1;c[e+316>>2]=2;g[e+320>>2]=ea(40.0);g[e+324>>2]=ea(.333333343);c[e+340>>2]=2;c[e+344>>2]=0;c[e+348>>2]=1;c[e+356>>2]=1;a[e+361>>0]=1;a[e+362>>0]=1;a[e+363>>0]=1;g[e+364>>2]=ea(1.0);c[e+372>>2]=256;a[t>>0]=18;T=t+1|0;v=T+0|0;J=591064|0;x=v+9|0;do{a[v>>0]=a[J>>0]|0;v=v+1|0;J=J+1|0}while((v|0)<(x|0));a[t+10>>0]=0;e:do if((B|0)!=(t|0)){A=a[B>>0]|0;do if(!(A&1))if(!(A&1))E=149;else E=148;else{m=c[B>>2]|0;s=m&-2;xa=s+-1|0;_=(m&1|0)==0;if(xa>>>0>=9)if(_){E=149;break}else{E=148;break}if(_)ya=m>>>1&127;else ya=c[e+388>>2]|0;eXb(B,xa,10-s|0,ya,0,ya,9,T);break e}while(0);if((E|0)==148)za=c[e+392>>2]|0;else if((E|0)==149)za=B+1|0;aFi(za|0,T|0,9)|0;a[za+9>>0]=0;if(!(a[B>>0]&1)){a[B>>0]=18;break}else{c[e+388>>2]=9;break}}while(0);if(a[t>>0]&1){B=c[t+8>>2]|0;c[l>>2]=58;c[h+0>>2]=c[l+0>>2];eOb(B,h)}c[M>>2]=3;c[e+400>>2]=2;c[e+404>>2]=2;c[e+412>>2]=2;g[e+416>>2]=ea(70.0);g[e+420>>2]=ea(.333333343);c[e+436>>2]=4;c[e+440>>2]=0;c[e+444>>2]=2;c[e+448>>2]=2;c[e+452>>2]=1;M=e+456|0;a[M>>0]=1;a[M+1>>0]=1;a[M+2>>0]=1;a[M+3>>0]=1;g[e+460>>2]=ea(1.5);c[e+468>>2]=1024;a[u>>0]=18;M=u+1|0;v=M+0|0;J=591080|0;x=v+9|0;do{a[v>>0]=a[J>>0]|0;v=v+1|0;J=J+1|0}while((v|0)<(x|0));a[u+10>>0]=0;f:do if((C|0)!=(u|0)){J=a[C>>0]|0;do if(!(J&1))if(!(J&1))E=165;else E=164;else{v=c[C>>2]|0;x=v&-2;B=x+-1|0;l=(v&1|0)==0;if(B>>>0>=9)if(l){E=165;break}else{E=164;break}if(l)Aa=v>>>1&127;else Aa=c[e+484>>2]|0;eXb(C,B,10-x|0,Aa,0,Aa,9,M);break f}while(0);if((E|0)==164)Ba=c[e+488>>2]|0;else if((E|0)==165)Ba=C+1|0;aFi(Ba|0,M|0,9)|0;a[Ba+9>>0]=0;if(!(a[C>>0]&1)){a[C>>0]=18;break}else{c[e+484>>2]=9;break}}while(0);if(a[u>>0]&1){C=c[u+8>>2]|0;c[k>>2]=58;c[h+0>>2]=c[k+0>>2];eOb(C,h)}c[K>>2]=4;c[e+496>>2]=2;c[e+500>>2]=2;c[e+508>>2]=4;g[e+512>>2]=ea(150.0);g[e+328>>2]=ea(.0666666701);g[e+332>>2]=ea(.200000003);g[e+336>>2]=ea(.466666669);c[e+532>>2]=4;c[e+536>>2]=0;c[e+540>>2]=2;c[e+544>>2]=2;c[e+548>>2]=1;K=e+552|0;a[K>>0]=1;a[K+1>>0]=1;a[K+2>>0]=1;a[K+3>>0]=1;c[e+504>>2]=0;g[e+556>>2]=ea(2.0);c[e+564>>2]=4096;if(!(a[p>>0]&1)){i=f;return}p=c[w>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(p,h);i=f;return}function Fyc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d;l=(e-k|0)/96|0;m=b+8|0;n=c[m>>2]|0;o=c[b>>2]|0;p=o;if(l>>>0>((n-p|0)/96|0)>>>0){if(!o)q=n;else{n=b+4|0;r=c[n>>2]|0;if((r|0)==(o|0))s=o;else{t=r;while(1){r=t+-96|0;c[n>>2]=r;if(!(a[r>>0]&1))u=r;else{r=c[t+-88>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(r,g);u=c[n>>2]|0}if((u|0)==(o|0))break;else t=u}s=c[b>>2]|0}ACi(s);c[m>>2]=0;c[n>>2]=0;c[b>>2]=0;q=0}if(l>>>0>44739242)vxi(b);n=(q-0|0)/96|0;if(n>>>0<22369621){q=n<<1;n=q>>>0<l>>>0?l:q;if(n>>>0>44739242)vxi(b);else v=n}else v=44739242;n=xCi(v*96|0)|0;q=b+4|0;c[q>>2]=n;c[b>>2]=n;c[m>>2]=n+(v*96|0);if((d|0)==(e|0)){i=f;return}v=d;m=n;while(1){n=a[v>>0]|0;if(!(n&1)){w=(n&255)>>>1;x=v+1|0}else{w=c[v+4>>2]|0;x=c[v+8>>2]|0}if(w>>>0>2147483631){y=63;break}if(w>>>0<11){a[m>>0]=w<<1;z=m+1|0}else{n=w+16&-16;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];s=cOb(n,16,g,0,3653512,80)|0;c[m+8>>2]=s;c[m>>2]=n|1;c[m+4>>2]=w;z=s}YEi(z|0,x|0,w|0)|0;a[z+w>>0]=0;A=m+12|0;B=v+12|0;C=A+84|0;do{c[A>>2]=c[B>>2];A=A+4|0;B=B+4|0}while((A|0)<(C|0));s=(c[q>>2]|0)+96|0;c[q>>2]=s;v=v+96|0;if((v|0)==(e|0)){y=68;break}else m=s}if((y|0)==63)ori(m);else if((y|0)==68){i=f;return}}m=b+4|0;b=((c[m>>2]|0)-p|0)/96|0;if(l>>>0>b>>>0){D=1;E=d+(b*96|0)|0}else{D=0;E=e}if((E|0)==(d|0))F=o;else{b=E+-96-k|0;k=d;d=o;while(1){do if((d|0)!=(k|0)){l=a[k>>0]|0;if(!(l&1)){G=(l&255)>>>1;H=k+1|0}else{G=c[k+4>>2]|0;H=c[k+8>>2]|0}l=a[d>>0]|0;if(!(l&1)){I=10;J=l}else{l=c[d>>2]|0;I=(l&-2)+-1|0;J=l&255}l=(J&1)==0;if(G>>>0>I>>>0){if(l)K=(J&255)>>>1;else K=c[d+4>>2]|0;eXb(d,I,G-I|0,K,0,K,G,H);break}if(l)L=d+1|0;else L=c[d+8>>2]|0;aFi(L|0,H|0,G|0)|0;a[L+G>>0]=0;if(!(a[d>>0]&1)){a[d>>0]=G<<1;break}else{c[d+4>>2]=G;break}}while(0);A=d+12|0;B=k+12|0;C=A+84|0;do{c[A>>2]=c[B>>2];A=A+4|0;B=B+4|0}while((A|0)<(C|0));k=k+96|0;if((k|0)==(E|0))break;else d=d+96|0}F=o+((((b>>>0)/96|0)+1|0)*96|0)|0}if(!D){D=c[m>>2]|0;if((D|0)==(F|0)){i=f;return}b=D;while(1){D=b+-96|0;c[m>>2]=D;if(!(a[D>>0]&1))M=D;else{D=c[b+-88>>2]|0;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];eOb(D,g);M=c[m>>2]|0}if((M|0)==(F|0))break;else b=M}i=f;return}if((E|0)==(e|0)){i=f;return}M=E;E=c[m>>2]|0;while(1){if(!E)N=0;else{b=a[M>>0]|0;if(!(b&1)){O=(b&255)>>>1;P=M+1|0}else{O=c[M+4>>2]|0;P=c[M+8>>2]|0}if(O>>>0>2147483631){y=33;break}if(O>>>0<11){a[E>>0]=O<<1;Q=E+1|0}else{b=O+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];F=cOb(b,16,g,0,3653512,80)|0;c[E+8>>2]=F;c[E>>2]=b|1;c[E+4>>2]=O;Q=F}YEi(Q|0,P|0,O|0)|0;a[Q+O>>0]=0;A=E+12|0;B=M+12|0;C=A+84|0;do{c[A>>2]=c[B>>2];A=A+4|0;B=B+4|0}while((A|0)<(C|0));N=c[m>>2]|0}F=N+96|0;c[m>>2]=F;M=M+96|0;if((M|0)==(e|0)){y=68;break}else E=F}if((y|0)==33)ori(E);else if((y|0)==68){i=f;return}}function Gyc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=b+4|0;k=c[b>>2]|0;l=(((c[j>>2]|0)-k|0)/96|0)+1|0;if(l>>>0>44739242)vxi(b);m=k;k=((c[b+8>>2]|0)-m|0)/96|0;if(k>>>0<22369621){n=k<<1;o=n>>>0<l>>>0?l:n}else o=44739242;n=((c[j>>2]|0)-m|0)/96|0;m=h+12|0;c[m>>2]=0;c[h+16>>2]=b+8;if(!o)p=0;else p=xCi(o*96|0)|0;c[h>>2]=p;j=p+(n*96|0)|0;l=h+8|0;c[l>>2]=j;k=h+4|0;c[k>>2]=j;c[m>>2]=p+(o*96|0);if(!j)q=0;else{o=a[d>>0]|0;if(!(o&1)){r=(o&255)>>>1;s=d+1|0}else{r=c[d+4>>2]|0;s=c[d+8>>2]|0}if(r>>>0>2147483631)ori(j);if(r>>>0<11){a[j>>0]=r<<1;t=j+1|0}else{o=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];m=cOb(o,16,f,0,3653512,80)|0;c[p+(n*96|0)+8>>2]=m;c[j>>2]=o|1;c[p+(n*96|0)+4>>2]=r;t=m}YEi(t|0,s|0,r|0)|0;a[t+r>>0]=0;r=p+(n*96|0)+12|0;n=d+12|0;d=r+84|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(d|0));q=c[l>>2]|0}c[l>>2]=q+96;Qyc(b,h);b=c[k>>2]|0;k=c[l>>2]|0;if((k|0)!=(b|0)){q=k;do{k=q;q=q+-96|0;c[l>>2]=q;if(a[q>>0]&1){n=c[k+-88>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(n,f)}}while((q|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function Hyc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=590760;g=b+24|0;h=c[g>>2]|0;if(!h){ZSb(b);i=d;return}j=b+28|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-96|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-88>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[g>>2]|0}ACi(l);ZSb(b);i=d;return}function Iyc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=590760;g=b+24|0;h=c[g>>2]|0;if(!h){ZSb(b);ACi(b);i=d;return}j=b+28|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-96|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-88>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[g>>2]|0}ACi(l);ZSb(b);ACi(b);i=d;return}function Jyc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;d=i;i=i+112|0;f=d+100|0;h=d+96|0;j=d;a[j>>0]=14;k=j+1|0;a[k+0>>0]=a[590864]|0;a[k+1>>0]=a[590865]|0;a[k+2>>0]=a[590866]|0;a[k+3>>0]=a[590867]|0;a[k+4>>0]=a[590868]|0;a[k+5>>0]=a[590869]|0;a[k+6>>0]=a[590870]|0;k=j+8|0;a[k>>0]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=1;c[j+28>>2]=1;g[j+32>>2]=ea(15.0);g[j+36>>2]=ea(.333333343);g[j+40>>2]=ea(.0666666701);g[j+44>>2]=ea(.200000003);g[j+48>>2]=ea(.466666669);c[j+52>>2]=1;c[j+56>>2]=1;l=j+60|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[j+76>>2]=ea(.300000012);c[j+80>>2]=0;c[j+84>>2]=4;g[j+88>>2]=ea(512.0);c[j+92>>2]=1;$cd(b,2646336,2646336,f,e);add(b,3142592,591560,j,0);Ryc(j,b);bdd(b);cdd(b);if(!(a[j>>0]&1)){i=d;return}j=c[k>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(j,f);i=d;return}function Kyc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/96|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}Myc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,591560,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;Lyc(r,a);t=r+96|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,591560,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else Lyc(m,a);sdd(a)}m=m+96|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function Lyc(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;h=f;j=f+4|0;rdd(e,2);k=qdd(e,3147344,c[142294]|0,h,0)|0;if(k){if((k|0)<=0){k=c[h>>2]|0;if(k)_n[k&4095](b,e)|0}else zXb(e,b,1);sdd(e)}k=b+12|0;l=c[142270]|0;m=qdd(e,591128,l,h,0)|0;if(m){if((m|0)>0){m=e+12|0;n=c[e+16>>2]|0;o=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;p=n+o|0;c[m>>2]=p;if((o|0)>=0?(q=n+(o+4)|0,q>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[p>>2];c[m>>2]=q}else Bid(m,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{m=c[h>>2]|0;if(m)_n[m&4095](k,e)|0}sdd(e)}k=b+16|0;m=qdd(e,591144,l,h,0)|0;if(m){if((m|0)>0){m=e+12|0;q=c[e+16>>2]|0;p=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=q+p|0;c[m>>2]=o;if((p|0)>=0?(n=q+(p+4)|0,n>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[o>>2];c[m>>2]=n}else Bid(m,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{m=c[h>>2]|0;if(m)_n[m&4095](k,e)|0}sdd(e)}k=b+20|0;m=qdd(e,591152,l,h,0)|0;if(m){if((m|0)>0){m=e+12|0;n=c[e+16>>2]|0;o=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;p=n+o|0;c[m>>2]=p;if((o|0)>=0?(q=n+(o+4)|0,q>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[p>>2];c[m>>2]=q}else Bid(m,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{m=c[h>>2]|0;if(m)_n[m&4095](k,e)|0}sdd(e)}k=b+24|0;m=qdd(e,591176,l,h,0)|0;if(m){if((m|0)>0){m=e+12|0;q=c[e+16>>2]|0;p=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=q+p|0;c[m>>2]=o;if((p|0)>=0?(n=q+(p+4)|0,n>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[o>>2];c[m>>2]=n}else Bid(m,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{m=c[h>>2]|0;if(m)_n[m&4095](k,e)|0}sdd(e)}k=b+28|0;m=qdd(e,591200,l,h,0)|0;if(m){if((m|0)>0){m=e+12|0;n=c[e+16>>2]|0;o=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;p=n+o|0;c[m>>2]=p;if((o|0)>=0?(q=n+(o+4)|0,q>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[p>>2];c[m>>2]=q}else Bid(m,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{m=c[h>>2]|0;if(m)_n[m&4095](k,e)|0}sdd(e)}k=b+32|0;m=c[142268]|0;q=qdd(e,591216,m,h,0)|0;if(q){if((q|0)>0){q=e+12|0;p=c[e+16>>2]|0;o=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;n=p+o|0;c[q>>2]=n;if((o|0)>=0?(r=p+(o+4)|0,r>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[n>>2]);c[q>>2]=r}else Bid(q,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}sdd(e)}k=b+36|0;q=qdd(e,591232,m,h,0)|0;if(q){if((q|0)>0){q=e+12|0;r=c[e+16>>2]|0;n=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=r+n|0;c[q>>2]=o;if((n|0)>=0?(p=r+(n+4)|0,p>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[o>>2]);c[q>>2]=p}else Bid(q,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}sdd(e)}k=b+40|0;q=qdd(e,591256,c[142310]|0,h,1)|0;if(q){if((q|0)<=0){q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}else _6b(k,e);sdd(e)}k=b+52|0;q=qdd(e,591280,l,h,0)|0;if(q){if((q|0)>0){q=e+12|0;p=c[e+16>>2]|0;o=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;n=p+o|0;c[q>>2]=n;if((o|0)>=0?(r=p+(o+4)|0,r>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[n>>2];c[q>>2]=r}else Bid(q,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}sdd(e)}k=b+56|0;q=qdd(e,591296,l,h,0)|0;if(q){if((q|0)>0){q=e+12|0;r=c[e+16>>2]|0;n=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=r+n|0;c[q>>2]=o;if((n|0)>=0?(p=r+(n+4)|0,p>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[o>>2];c[q>>2]=p}else Bid(q,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}sdd(e)}k=b+60|0;q=qdd(e,591312,l,h,0)|0;if(q){if((q|0)>0){q=e+12|0;p=c[e+16>>2]|0;o=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;n=p+o|0;c[q>>2]=n;if((o|0)>=0?(r=p+(o+4)|0,r>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[n>>2];c[q>>2]=r}else Bid(q,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}sdd(e)}k=b+64|0;q=qdd(e,591336,l,h,0)|0;if(q){if((q|0)>0){q=e+12|0;r=c[e+16>>2]|0;n=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=r+n|0;c[q>>2]=o;if((n|0)>=0?(p=r+(n+4)|0,p>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[o>>2];c[q>>2]=p}else Bid(q,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{q=c[h>>2]|0;if(q)_n[q&4095](k,e)|0}sdd(e)}k=b+72|0;q=c[142258]|0;p=qdd(e,591352,q,h,0)|0;if(p){do if((p|0)<=0){o=c[h>>2]|0;if(o)_n[o&4095](k,e)|0}else{o=e+12|0;n=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;s=n+r|0;c[o>>2]=s;if((r|0)>=0?(n+(r+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){a[k>>0]=a[s>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break}Bid(o,k,1)}while(0);sdd(e)}k=b+73|0;p=qdd(e,591368,q,h,0)|0;if(p){a:do if((p|0)<=0){o=c[h>>2]|0;if(o)_n[o&4095](k,e)|0}else{o=e+12|0;s=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;n=s+r|0;c[o>>2]=n;do if((r|0)>=0){if((s+(r+1)|0)>>>0>(c[e+20>>2]|0)>>>0)break;a[k>>0]=a[n>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break a}while(0);Bid(o,k,1)}while(0);sdd(e)}k=b+74|0;p=qdd(e,591384,q,h,0)|0;if(p){b:do if((p|0)<=0){n=c[h>>2]|0;if(n)_n[n&4095](k,e)|0}else{n=e+12|0;r=c[e+16>>2]|0;s=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;t=r+s|0;c[n>>2]=t;do if((s|0)>=0){if((r+(s+1)|0)>>>0>(c[e+20>>2]|0)>>>0)break;a[k>>0]=a[t>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break b}while(0);Bid(n,k,1)}while(0);sdd(e)}k=b+75|0;p=qdd(e,591416,q,h,0)|0;if(p){c:do if((p|0)>0){t=e+12|0;s=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=s+r|0;c[t>>2]=o;do if((r|0)>=0){if((s+(r+1)|0)>>>0>(c[e+20>>2]|0)>>>0)break;a[k>>0]=a[o>>0]|0;c[t>>2]=(c[t>>2]|0)+1;break c}while(0);Bid(t,k,1)}else{o=c[h>>2]|0;if(!o)break;_n[o&4095](k,e)|0}while(0);sdd(e)}k=b+68|0;p=qdd(e,591448,l,h,0)|0;if(p){do if((p|0)>0){o=e+12|0;r=c[e+16>>2]|0;s=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;n=r+s|0;c[o>>2]=n;do if((s|0)<0)u=175;else{v=r+(s+4)|0;if(v>>>0>(c[e+20>>2]|0)>>>0){u=175;break}c[k>>2]=c[n>>2];c[o>>2]=v}while(0);if((u|0)==175)Bid(o,k,4);if(!(c[e>>2]&512))break;c[k>>2]=XEi(c[k>>2]|0)|0}else{n=c[h>>2]|0;if(!n)break;_n[n&4095](k,e)|0}while(0);sdd(e)}p=b+76|0;n=qdd(e,591464,m,h,0)|0;if(n){do if((n|0)>0){m=e+12|0;s=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;t=s+r|0;c[m>>2]=t;do if((r|0)<0)u=186;else{v=s+(r+4)|0;if(v>>>0>(c[e+20>>2]|0)>>>0){u=186;break}g[p>>2]=ea(g[t>>2]);c[m>>2]=v}while(0);if((u|0)==186)Bid(m,p,4);if(!(c[e>>2]&512))break;c[p>>2]=XEi(c[p>>2]|0)|0}else{t=c[h>>2]|0;if(!t)break;_n[t&4095](p,e)|0}while(0);sdd(e)}p=b+80|0;n=qdd(e,591472,l,h,0)|0;if(n){do if((n|0)>0){t=e+12|0;r=c[e+16>>2]|0;s=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;o=r+s|0;c[t>>2]=o;do if((s|0)<0)u=197;else{v=r+(s+4)|0;if(v>>>0>(c[e+20>>2]|0)>>>0){u=197;break}c[p>>2]=c[o>>2];c[t>>2]=v}while(0);if((u|0)==197)Bid(t,p,4);if(!(c[e>>2]&512))break;c[p>>2]=XEi(c[p>>2]|0)|0}else{o=c[h>>2]|0;if(!o)break;_n[o&4095](p,e)|0}while(0);sdd(e)}p=b+92|0;n=qdd(e,591488,l,h,0)|0;if(n){do if((n|0)>0){o=e+12|0;s=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;m=s+r|0;c[o>>2]=m;do if((r|0)<0)u=208;else{v=s+(r+4)|0;if(v>>>0>(c[e+20>>2]|0)>>>0){u=208;break}c[p>>2]=c[m>>2];c[o>>2]=v}while(0);if((u|0)==208)Bid(o,p,4);if(!(c[e>>2]&512))break;c[p>>2]=XEi(c[p>>2]|0)|0}else{m=c[h>>2]|0;if(!m)break;_n[m&4095](p,e)|0}while(0);sdd(e)}p=b+84|0;b=qdd(e,591520,l,h,0)|0;if(b){do if((b|0)>0){l=e+12|0;n=c[e+16>>2]|0;m=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=n+m|0;c[l>>2]=r;do if((m|0)<0)u=219;else{s=n+(m+4)|0;if(s>>>0>(c[e+20>>2]|0)>>>0){u=219;break}c[p>>2]=c[r>>2];c[l>>2]=s}while(0);if((u|0)==219)Bid(l,p,4);if(!(c[e>>2]&512))break;c[p>>2]=XEi(c[p>>2]|0)|0}else{r=c[h>>2]|0;if(!r)break;_n[r&4095](p,e)|0}while(0);sdd(e)}if(!(xdd(e,1)|0)){i=f;return}p=qdd(e,591544,q,h,0)|0;if(p){d:do if((p|0)>0){q=e+12|0;u=c[e+16>>2]|0;b=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=u+b|0;c[q>>2]=r;do if((b|0)>=0){if((u+(b+1)|0)>>>0>(c[e+20>>2]|0)>>>0)break;a[j>>0]=a[r>>0]|0;c[q>>2]=u+(b+1);break d}while(0);Bid(q,j,1)}else{b=c[h>>2]|0;if(!b)break;_n[b&4095](j,e)|0}while(0);sdd(e)}c[k>>2]=d[j>>0];i=f;return}function Myc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e+52|0;g=e+16|0;h=e+36|0;j=e+4|0;k=e+40|0;l=e;m=e+12|0;n=e+24|0;o=e+20|0;p=e+8|0;q=e+56|0;r=b+4|0;s=c[b>>2]|0;t=s;u=((c[r>>2]|0)-t|0)/96|0;if(u>>>0>=d>>>0){if(u>>>0<=d>>>0){i=e;return}c[o>>2]=s;c[p>>2]=s+(d*96|0);c[g+0>>2]=c[o+0>>2];c[f+0>>2]=c[p+0>>2];Vyc(n,g,f,q,0);q=c[n>>2]|0;p=c[b>>2]|0;c[n>>2]=p;c[b>>2]=q;q=n+4|0;o=c[q>>2]|0;s=c[r>>2]|0;c[q>>2]=s;c[r>>2]=o;o=n+8|0;v=b+8|0;w=c[o>>2]|0;c[o>>2]=c[v>>2];c[v>>2]=w;if(!p){i=e;return}if((s|0)==(p|0))x=p;else{w=s;while(1){s=w+-96|0;c[q>>2]=s;if(!(a[s>>0]&1))y=s;else{s=c[w+-88>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(s,f);y=c[q>>2]|0}if((y|0)==(p|0))break;else w=y}x=c[n>>2]|0}ACi(x);i=e;return}x=b+8|0;if((((c[x>>2]|0)-t|0)/96|0|0)==(d|0)){Uyc(b,d-u|0);i=e;return}c[k>>2]=0;u=k+4|0;c[u>>2]=0;t=k+8|0;c[t>>2]=0;Syc(k,d);c[l>>2]=c[b>>2];c[m>>2]=c[r>>2];c[g+0>>2]=c[l+0>>2];c[f+0>>2]=c[m+0>>2];Tyc(k,g,f);m=c[u>>2]|0;l=c[k>>2]|0;n=(m-l|0)/96|0;if(n>>>0>=d>>>0)if(n>>>0>d>>>0?(y=l+(d*96|0)|0,(m|0)!=(y|0)):0){l=m;while(1){w=l+-96|0;c[u>>2]=w;if(!(a[w>>0]&1))z=w;else{w=c[l+-88>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(w,f);z=c[u>>2]|0}if((z|0)==(y|0)){A=y;break}else l=z}}else A=m;else{Uyc(k,d-n|0);A=c[u>>2]|0}n=c[k>>2]|0;d=c[b>>2]|0;c[k>>2]=d;c[b>>2]=n;n=c[r>>2]|0;c[u>>2]=n;c[r>>2]=A;A=c[t>>2]|0;c[t>>2]=c[x>>2];c[x>>2]=A;if(!d){i=e;return}if((n|0)==(d|0))B=d;else{A=n;while(1){n=A+-96|0;c[u>>2]=n;if(!(a[n>>0]&1))C=n;else{n=c[A+-88>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(n,f);C=c[u>>2]|0}if((C|0)==(d|0))break;else A=C}B=c[k>>2]|0}ACi(B);i=e;return}function Nyc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;NXb(d,b,1);Ndd(d);f=b+12|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0>m>>>0){Bid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}else{c[f>>2]=c[j>>2];c[h>>2]=k;n=k;o=m}m=b+16|0;k=n+4|0;if(k>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{c[m>>2]=c[n>>2];c[h>>2]=k;p=k;q=o}o=b+20|0;k=p+4|0;if(k>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{c[o>>2]=c[p>>2];c[h>>2]=k;r=k;s=q}q=b+24|0;k=r+4|0;if(k>>>0>s>>>0){Bid(h,q,4);t=c[h>>2]|0;u=c[l>>2]|0}else{c[q>>2]=c[r>>2];c[h>>2]=k;t=k;u=s}s=b+28|0;k=t+4|0;if(k>>>0>u>>>0){Bid(h,s,4);v=c[h>>2]|0;w=c[l>>2]|0}else{c[s>>2]=c[t>>2];c[h>>2]=k;v=k;w=u}u=b+32|0;k=v+4|0;if(k>>>0>w>>>0){Bid(h,u,4);x=c[h>>2]|0;y=c[l>>2]|0}else{g[u>>2]=ea(g[v>>2]);c[h>>2]=k;x=k;y=w}w=b+36|0;k=x+4|0;if(k>>>0>y>>>0){Bid(h,w,4);z=c[h>>2]|0;A=c[l>>2]|0}else{g[w>>2]=ea(g[x>>2]);c[h>>2]=k;z=k;A=y}y=b+40|0;k=z+4|0;if(k>>>0>A>>>0){Bid(h,y,4);B=c[h>>2]|0;C=c[l>>2]|0}else{g[y>>2]=ea(g[z>>2]);c[h>>2]=k;B=k;C=A}A=b+44|0;k=B+4|0;if(k>>>0>C>>>0){Bid(h,A,4);D=c[h>>2]|0;E=c[l>>2]|0}else{g[A>>2]=ea(g[B>>2]);c[h>>2]=k;D=k;E=C}C=b+48|0;k=D+4|0;if(k>>>0>E>>>0){Bid(h,C,4);F=c[h>>2]|0;G=c[l>>2]|0}else{g[C>>2]=ea(g[D>>2]);c[h>>2]=k;F=k;G=E}E=b+52|0;k=F+4|0;if(k>>>0>G>>>0){Bid(h,E,4);H=c[h>>2]|0;I=c[l>>2]|0}else{c[E>>2]=c[F>>2];c[h>>2]=k;H=k;I=G}G=b+56|0;k=H+4|0;if(k>>>0>I>>>0){Bid(h,G,4);J=c[h>>2]|0;K=c[l>>2]|0}else{c[G>>2]=c[H>>2];c[h>>2]=k;J=k;K=I}I=b+60|0;k=J+4|0;if(k>>>0>K>>>0){Bid(h,I,4);L=c[h>>2]|0;M=c[l>>2]|0}else{c[I>>2]=c[J>>2];c[h>>2]=k;L=k;M=K}K=b+64|0;k=L+4|0;if(k>>>0>M>>>0){Bid(h,K,4);N=c[h>>2]|0;O=c[l>>2]|0}else{c[K>>2]=c[L>>2];c[h>>2]=k;N=k;O=M}M=b+72|0;if((N+1|0)>>>0>O>>>0){Bid(h,M,1);P=c[h>>2]|0}else{a[M>>0]=a[N>>0]|0;N=(c[h>>2]|0)+1|0;c[h>>2]=N;P=N}N=b+73|0;if((P+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,N,1);Q=c[h>>2]|0}else{a[N>>0]=a[P>>0]|0;P=(c[h>>2]|0)+1|0;c[h>>2]=P;Q=P}P=b+74|0;if((Q+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,P,1);R=c[h>>2]|0}else{a[P>>0]=a[Q>>0]|0;Q=(c[h>>2]|0)+1|0;c[h>>2]=Q;R=Q}Q=b+75|0;if((R+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,Q,1);else{a[Q>>0]=a[R>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);R=b+68|0;Q=c[h>>2]|0;P=Q+4|0;N=c[l>>2]|0;if(P>>>0>N>>>0){Bid(h,R,4);S=c[h>>2]|0;T=c[l>>2]|0}else{c[R>>2]=c[Q>>2];c[h>>2]=P;S=P;T=N}N=b+76|0;P=S+4|0;if(P>>>0>T>>>0){Bid(h,N,4);U=c[h>>2]|0;V=c[l>>2]|0}else{g[N>>2]=ea(g[S>>2]);c[h>>2]=P;U=P;V=T}T=b+80|0;P=U+4|0;if(P>>>0>V>>>0){Bid(h,T,4);W=c[h>>2]|0;X=c[l>>2]|0}else{c[T>>2]=c[U>>2];c[h>>2]=P;W=P;X=V}V=b+92|0;P=W+4|0;if(P>>>0>X>>>0){Bid(h,V,4);Y=c[h>>2]|0;Z=c[l>>2]|0}else{c[V>>2]=c[W>>2];c[h>>2]=P;Y=P;Z=X}X=b+84|0;b=Y+4|0;if(b>>>0>Z>>>0){Bid(h,X,4);Ndd(d);i=e;return}else{c[X>>2]=c[Y>>2];c[h>>2]=b;Ndd(d);i=e;return}}function Oyc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;e=i;OXb(d,b,1);Mdd(d);f=b+12|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(h,f,4);o=c[h>>2]|0;p=c[m>>2]|0;q=c[f>>2]|0}else{r=c[j>>2]|0;c[f>>2]=r;c[h>>2]=l;o=l;p=n;q=r}c[f>>2]=XEi(q|0)|0;q=b+16|0;f=o+4|0;if(f>>>0>p>>>0){Bid(h,q,4);s=c[q>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{r=c[o>>2]|0;c[q>>2]=r;c[h>>2]=f;s=r;t=f;u=p}c[q>>2]=XEi(s|0)|0;s=b+20|0;q=t+4|0;if(q>>>0>u>>>0){Bid(h,s,4);v=c[s>>2]|0;w=c[h>>2]|0;x=c[m>>2]|0}else{p=c[t>>2]|0;c[s>>2]=p;c[h>>2]=q;v=p;w=q;x=u}c[s>>2]=XEi(v|0)|0;v=b+24|0;s=w+4|0;if(s>>>0>x>>>0){Bid(h,v,4);y=c[v>>2]|0;z=c[h>>2]|0;A=c[m>>2]|0}else{u=c[w>>2]|0;c[v>>2]=u;c[h>>2]=s;y=u;z=s;A=x}c[v>>2]=XEi(y|0)|0;y=b+28|0;v=z+4|0;if(v>>>0>A>>>0){Bid(h,y,4);B=c[y>>2]|0;C=c[h>>2]|0;D=c[m>>2]|0}else{x=c[z>>2]|0;c[y>>2]=x;c[h>>2]=v;B=x;C=v;D=A}c[y>>2]=XEi(B|0)|0;B=b+32|0;y=C+4|0;if(y>>>0>D>>>0){Bid(h,B,4);E=B;F=c[B>>2]|0;G=c[h>>2]|0;H=c[m>>2]|0}else{I=ea(g[C>>2]);g[B>>2]=I;c[h>>2]=y;E=B;F=(g[k>>2]=I,c[k>>2]|0);G=y;H=D}c[E>>2]=XEi(F|0)|0;F=b+36|0;E=G+4|0;if(E>>>0>H>>>0){Bid(h,F,4);J=F;K=c[F>>2]|0;L=c[h>>2]|0;M=c[m>>2]|0}else{I=ea(g[G>>2]);g[F>>2]=I;c[h>>2]=E;J=F;K=(g[k>>2]=I,c[k>>2]|0);L=E;M=H}c[J>>2]=XEi(K|0)|0;K=b+40|0;J=L+4|0;if(J>>>0>M>>>0){Bid(h,K,4);N=K;O=c[K>>2]|0;P=c[h>>2]|0;Q=c[m>>2]|0}else{I=ea(g[L>>2]);g[K>>2]=I;c[h>>2]=J;N=K;O=(g[k>>2]=I,c[k>>2]|0);P=J;Q=M}c[N>>2]=XEi(O|0)|0;O=b+44|0;N=P+4|0;if(N>>>0>Q>>>0){Bid(h,O,4);R=O;S=c[O>>2]|0;T=c[h>>2]|0;U=c[m>>2]|0}else{I=ea(g[P>>2]);g[O>>2]=I;c[h>>2]=N;R=O;S=(g[k>>2]=I,c[k>>2]|0);T=N;U=Q}c[R>>2]=XEi(S|0)|0;S=b+48|0;R=T+4|0;if(R>>>0>U>>>0){Bid(h,S,4);V=S;W=c[S>>2]|0;X=c[h>>2]|0;Y=c[m>>2]|0}else{I=ea(g[T>>2]);g[S>>2]=I;c[h>>2]=R;V=S;W=(g[k>>2]=I,c[k>>2]|0);X=R;Y=U}c[V>>2]=XEi(W|0)|0;W=b+52|0;V=X+4|0;if(V>>>0>Y>>>0){Bid(h,W,4);Z=c[W>>2]|0;_=c[h>>2]|0;$=c[m>>2]|0}else{U=c[X>>2]|0;c[W>>2]=U;c[h>>2]=V;Z=U;_=V;$=Y}c[W>>2]=XEi(Z|0)|0;Z=b+56|0;W=_+4|0;if(W>>>0>$>>>0){Bid(h,Z,4);aa=c[Z>>2]|0;ba=c[h>>2]|0;ca=c[m>>2]|0}else{Y=c[_>>2]|0;c[Z>>2]=Y;c[h>>2]=W;aa=Y;ba=W;ca=$}c[Z>>2]=XEi(aa|0)|0;aa=b+60|0;Z=ba+4|0;if(Z>>>0>ca>>>0){Bid(h,aa,4);da=c[aa>>2]|0;fa=c[h>>2]|0;ga=c[m>>2]|0}else{$=c[ba>>2]|0;c[aa>>2]=$;c[h>>2]=Z;da=$;fa=Z;ga=ca}c[aa>>2]=XEi(da|0)|0;da=b+64|0;aa=fa+4|0;if(aa>>>0>ga>>>0){Bid(h,da,4);ha=c[da>>2]|0;ia=c[h>>2]|0;ja=c[m>>2]|0}else{ca=c[fa>>2]|0;c[da>>2]=ca;c[h>>2]=aa;ha=ca;ia=aa;ja=ga}c[da>>2]=XEi(ha|0)|0;ha=b+72|0;if((ia+1|0)>>>0>ja>>>0){Bid(h,ha,1);ka=c[h>>2]|0}else{a[ha>>0]=a[ia>>0]|0;ia=(c[h>>2]|0)+1|0;c[h>>2]=ia;ka=ia}ia=b+73|0;if((ka+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(h,ia,1);la=c[h>>2]|0}else{a[ia>>0]=a[ka>>0]|0;ka=(c[h>>2]|0)+1|0;c[h>>2]=ka;la=ka}ka=b+74|0;if((la+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(h,ka,1);ma=c[h>>2]|0}else{a[ka>>0]=a[la>>0]|0;la=(c[h>>2]|0)+1|0;c[h>>2]=la;ma=la}la=b+75|0;if((ma+1|0)>>>0>(c[m>>2]|0)>>>0)Bid(h,la,1);else{a[la>>0]=a[ma>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);ma=b+68|0;la=c[h>>2]|0;ka=la+4|0;ia=c[m>>2]|0;if(ka>>>0>ia>>>0){Bid(h,ma,4);na=c[ma>>2]|0;oa=c[h>>2]|0;pa=c[m>>2]|0}else{ha=c[la>>2]|0;c[ma>>2]=ha;c[h>>2]=ka;na=ha;oa=ka;pa=ia}c[ma>>2]=XEi(na|0)|0;na=b+76|0;ma=oa+4|0;if(ma>>>0>pa>>>0){Bid(h,na,4);qa=na;ra=c[na>>2]|0;sa=c[h>>2]|0;ta=c[m>>2]|0}else{I=ea(g[oa>>2]);g[na>>2]=I;c[h>>2]=ma;qa=na;ra=(g[k>>2]=I,c[k>>2]|0);sa=ma;ta=pa}c[qa>>2]=XEi(ra|0)|0;ra=b+80|0;qa=sa+4|0;if(qa>>>0>ta>>>0){Bid(h,ra,4);ua=c[ra>>2]|0;va=c[h>>2]|0;wa=c[m>>2]|0}else{pa=c[sa>>2]|0;c[ra>>2]=pa;c[h>>2]=qa;ua=pa;va=qa;wa=ta}c[ra>>2]=XEi(ua|0)|0;ua=b+92|0;ra=va+4|0;if(ra>>>0>wa>>>0){Bid(h,ua,4);xa=c[ua>>2]|0;ya=c[h>>2]|0;za=c[m>>2]|0}else{m=c[va>>2]|0;c[ua>>2]=m;c[h>>2]=ra;xa=m;ya=ra;za=wa}c[ua>>2]=XEi(xa|0)|0;xa=b+84|0;b=ya+4|0;if(b>>>0>za>>>0){Bid(h,xa,4);Aa=c[xa>>2]|0;Ba=XEi(Aa|0)|0;c[xa>>2]=Ba;Mdd(d);i=e;return}else{za=c[ya>>2]|0;c[xa>>2]=za;c[h>>2]=b;Aa=za;Ba=XEi(Aa|0)|0;c[xa>>2]=Ba;Mdd(d);i=e;return}}function Pyc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;FXb(d,b,3147344,2048);f=b+12|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){c[j>>2]=c[f>>2];c[h>>2]=k;n=k;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=b+16|0;m=n+4|0;if(m>>>0<o>>>0){c[n>>2]=c[f>>2];c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=b+20|0;o=p+4|0;if(o>>>0<q>>>0){c[p>>2]=c[f>>2];c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=b+24|0;q=r+4|0;if(q>>>0<s>>>0){c[r>>2]=c[f>>2];c[h>>2]=q;t=q;u=s}else{Gid(h,f,4);t=c[h>>2]|0;u=c[l>>2]|0}f=b+28|0;s=t+4|0;if(s>>>0<u>>>0){c[t>>2]=c[f>>2];c[h>>2]=s;v=s;w=u}else{Gid(h,f,4);v=c[h>>2]|0;w=c[l>>2]|0}f=b+32|0;u=v+4|0;if(u>>>0<w>>>0){g[v>>2]=ea(g[f>>2]);c[h>>2]=u;x=u;y=w}else{Gid(h,f,4);x=c[h>>2]|0;y=c[l>>2]|0}f=b+36|0;w=x+4|0;if(w>>>0<y>>>0){g[x>>2]=ea(g[f>>2]);c[h>>2]=w;z=w;A=y}else{Gid(h,f,4);z=c[h>>2]|0;A=c[l>>2]|0}f=b+40|0;y=z+4|0;if(y>>>0<A>>>0){g[z>>2]=ea(g[f>>2]);c[h>>2]=y;B=y;C=A}else{Gid(h,f,4);B=c[h>>2]|0;C=c[l>>2]|0}f=b+44|0;A=B+4|0;if(A>>>0<C>>>0){g[B>>2]=ea(g[f>>2]);c[h>>2]=A;D=A;E=C}else{Gid(h,f,4);D=c[h>>2]|0;E=c[l>>2]|0}f=b+48|0;C=D+4|0;if(C>>>0<E>>>0){g[D>>2]=ea(g[f>>2]);c[h>>2]=C;F=C;G=E}else{Gid(h,f,4);F=c[h>>2]|0;G=c[l>>2]|0}f=b+52|0;E=F+4|0;if(E>>>0<G>>>0){c[F>>2]=c[f>>2];c[h>>2]=E;H=E;I=G}else{Gid(h,f,4);H=c[h>>2]|0;I=c[l>>2]|0}f=b+56|0;G=H+4|0;if(G>>>0<I>>>0){c[H>>2]=c[f>>2];c[h>>2]=G;J=G;K=I}else{Gid(h,f,4);J=c[h>>2]|0;K=c[l>>2]|0}f=b+60|0;I=J+4|0;if(I>>>0<K>>>0){c[J>>2]=c[f>>2];c[h>>2]=I;L=I;M=K}else{Gid(h,f,4);L=c[h>>2]|0;M=c[l>>2]|0}f=b+64|0;K=L+4|0;if(K>>>0<M>>>0){c[L>>2]=c[f>>2];c[h>>2]=K;N=K;O=M}else{Gid(h,f,4);N=c[h>>2]|0;O=c[l>>2]|0}f=b+72|0;if((N+1|0)>>>0<O>>>0){a[N>>0]=a[f>>0]|0;N=(c[h>>2]|0)+1|0;c[h>>2]=N;P=N}else{Gid(h,f,1);P=c[h>>2]|0}f=b+73|0;if((P+1|0)>>>0<(c[l>>2]|0)>>>0){a[P>>0]=a[f>>0]|0;P=(c[h>>2]|0)+1|0;c[h>>2]=P;Q=P}else{Gid(h,f,1);Q=c[h>>2]|0}f=b+74|0;if((Q+1|0)>>>0<(c[l>>2]|0)>>>0){a[Q>>0]=a[f>>0]|0;Q=(c[h>>2]|0)+1|0;c[h>>2]=Q;R=Q}else{Gid(h,f,1);R=c[h>>2]|0}f=b+75|0;if((R+1|0)>>>0<(c[l>>2]|0)>>>0){a[R>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);f=b+68|0;R=c[h>>2]|0;Q=R+4|0;P=c[l>>2]|0;if(Q>>>0<P>>>0){c[R>>2]=c[f>>2];c[h>>2]=Q;S=Q;T=P}else{Gid(h,f,4);S=c[h>>2]|0;T=c[l>>2]|0}f=b+76|0;P=S+4|0;if(P>>>0<T>>>0){g[S>>2]=ea(g[f>>2]);c[h>>2]=P;U=P;V=T}else{Gid(h,f,4);U=c[h>>2]|0;V=c[l>>2]|0}f=b+80|0;T=U+4|0;if(T>>>0<V>>>0){c[U>>2]=c[f>>2];c[h>>2]=T;W=T;X=V}else{Gid(h,f,4);W=c[h>>2]|0;X=c[l>>2]|0}f=b+92|0;V=W+4|0;if(V>>>0<X>>>0){c[W>>2]=c[f>>2];c[h>>2]=V;Y=V;Z=X}else{Gid(h,f,4);Y=c[h>>2]|0;Z=c[l>>2]|0}l=b+84|0;b=Y+4|0;if(b>>>0<Z>>>0){c[Y>>2]=c[l>>2];c[h>>2]=b;Tdd(d);i=e;return}else{Gid(h,l,4);Tdd(d);i=e;return}}function Qyc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=n+-96|0;p=m;m=m+-96|0;q=a[m>>0]|0;if(!(q&1)){r=(q&255)>>>1;s=m+1|0}else{r=c[p+-92>>2]|0;s=c[p+-88>>2]|0}if(r>>>0>2147483631){t=8;break}if(r>>>0<11){a[o>>0]=r<<1;u=o+1|0}else{q=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];v=cOb(q,16,f,0,3653512,80)|0;c[n+-88>>2]=v;c[o>>2]=q|1;c[n+-92>>2]=r;u=v}YEi(u|0,s|0,r|0)|0;a[u+r>>0]=0;v=n+-84+0|0;q=p+-84+0|0;p=v+84|0;do{c[v>>2]=c[q>>2];v=v+4|0;q=q+4|0}while((v|0)<(p|0));q=(c[l>>2]|0)+-96|0;c[l>>2]=q;if((m|0)==(h|0)){w=q;t=13;break}else n=q}if((t|0)==8)ori(o);else if((t|0)==13){x=w;y=c[b>>2]|0;break}}else{x=c[l>>2]|0;y=h}while(0);c[b>>2]=x;c[l>>2]=y;y=d+8|0;x=c[j>>2]|0;c[j>>2]=c[y>>2];c[y>>2]=x;x=b+8|0;b=d+12|0;y=c[x>>2]|0;c[x>>2]=c[b>>2];c[b>>2]=y;c[d>>2]=c[l>>2];i=e;return}function Ryc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;ddd(b,2);add(b,3147344,c[142294]|0,a,2048);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);e=b+12|0;f=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);g=c[142270]|0;add(b,591128,g,a+12|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591144,g,a+16|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591152,g,a+20|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591176,g,a+24|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591200,g,a+28|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);g=c[142268]|0;add(b,591216,g,a+32|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591232,g,a+36|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);h=a+40|0;add(b,591256,c[142310]|0,h,2048);j=c[($hd(b+16|0)|0)+20>>2]|2097152;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+20>>2]=j;add(b,3143216,g,h,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,g,a+44|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2416480,g,a+48|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);g=c[142270]|0;add(b,591280,g,a+52|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591296,g,a+56|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591312,g,a+60|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591336,g,a+64|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);h=c[142258]|0;add(b,591352,h,a+72|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,591368,h,a+73|0,2049);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,591384,h,a+74|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,591416,h,a+75|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,591448,g,a+68|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591464,c[142268]|0,a+76|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);g=c[142270]|0;add(b,591472,g,a+80|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591488,g,a+92|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,591520,g,a+84|0,2048);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);i=d;return}function Syc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=c[b>>2]|0;if((((c[b+8>>2]|0)-j|0)/96|0)>>>0>=d>>>0){i=e;return}k=((c[b+4>>2]|0)-j|0)/96|0;j=h+12|0;c[j>>2]=0;c[h+16>>2]=b+8;if(!d)l=0;else l=xCi(d*96|0)|0;c[h>>2]=l;m=l+(k*96|0)|0;k=h+8|0;c[k>>2]=m;n=h+4|0;c[n>>2]=m;c[j>>2]=l+(d*96|0);Qyc(b,h);b=c[n>>2]|0;n=c[k>>2]|0;if((n|0)!=(b|0)){d=n;do{n=d;d=d+-96|0;c[k>>2]=d;if(a[d>>0]&1){l=c[n+-88>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f)}}while((d|0)!=(b|0))}b=c[h>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function Tyc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d>>2]|0;d=c[e>>2]|0;l=k;m=(d-l|0)/96|0;n=b+8|0;o=c[n>>2]|0;p=c[b>>2]|0;q=p;if(m>>>0>((o-q|0)/96|0)>>>0){if(!p)r=o;else{o=b+4|0;s=c[o>>2]|0;if((s|0)==(p|0))t=p;else{u=s;while(1){s=u+-96|0;c[o>>2]=s;if(!(a[s>>0]&1))v=s;else{s=c[u+-88>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(s,g);v=c[o>>2]|0}if((v|0)==(p|0))break;else u=v}t=c[b>>2]|0}ACi(t);c[n>>2]=0;c[o>>2]=0;c[b>>2]=0;r=0}if(m>>>0>44739242)vxi(b);o=(r-0|0)/96|0;if(o>>>0<22369621){r=o<<1;o=r>>>0<m>>>0?m:r;if(o>>>0>44739242)vxi(b);else w=o}else w=44739242;o=xCi(w*96|0)|0;r=b+4|0;c[r>>2]=o;c[b>>2]=o;c[n>>2]=o+(w*96|0);if((k|0)==(d|0)){i=f;return}w=k;n=o;while(1){o=a[w>>0]|0;if(!(o&1)){x=(o&255)>>>1;y=w+1|0}else{x=c[w+4>>2]|0;y=c[w+8>>2]|0}if(x>>>0>2147483631){z=63;break}if(x>>>0<11){a[n>>0]=x<<1;A=n+1|0}else{o=x+16&-16;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];t=cOb(o,16,g,0,3653512,80)|0;c[n+8>>2]=t;c[n>>2]=o|1;c[n+4>>2]=x;A=t}YEi(A|0,y|0,x|0)|0;a[A+x>>0]=0;B=n+12|0;C=w+12|0;D=B+84|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0));t=(c[r>>2]|0)+96|0;c[r>>2]=t;w=w+96|0;if((w|0)==(d|0)){z=68;break}else n=t}if((z|0)==63)ori(n);else if((z|0)==68){i=f;return}}n=b+4|0;b=((c[n>>2]|0)-q|0)/96|0;if(m>>>0>b>>>0){E=k+(b*96|0)|0;F=1}else{E=d;F=0}if((k|0)==(E|0))G=p;else{d=((E+-96-l|0)>>>0)/96|0;l=p;b=k;while(1){do if((l|0)!=(b|0)){k=a[b>>0]|0;if(!(k&1)){H=(k&255)>>>1;I=b+1|0}else{H=c[b+4>>2]|0;I=c[b+8>>2]|0}k=a[l>>0]|0;if(!(k&1)){J=10;K=k}else{k=c[l>>2]|0;J=(k&-2)+-1|0;K=k&255}k=(K&1)==0;if(H>>>0>J>>>0){if(k)L=(K&255)>>>1;else L=c[l+4>>2]|0;eXb(l,J,H-J|0,L,0,L,H,I);break}if(k)M=l+1|0;else M=c[l+8>>2]|0;aFi(M|0,I|0,H|0)|0;a[M+H>>0]=0;if(!(a[l>>0]&1)){a[l>>0]=H<<1;break}else{c[l+4>>2]=H;break}}while(0);B=l+12|0;C=b+12|0;D=B+84|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0));b=b+96|0;if((b|0)==(E|0))break;else l=l+96|0}G=p+((d+1|0)*96|0)|0}if(!F){F=c[n>>2]|0;if((F|0)==(G|0)){i=f;return}d=F;while(1){F=d+-96|0;c[n>>2]=F;if(!(a[F>>0]&1))N=F;else{F=c[d+-88>>2]|0;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];eOb(F,g);N=c[n>>2]|0}if((N|0)==(G|0))break;else d=N}i=f;return}N=c[e>>2]|0;if((E|0)==(N|0)){i=f;return}e=c[n>>2]|0;d=E;while(1){if(!e)O=0;else{E=a[d>>0]|0;if(!(E&1)){P=d+1|0;Q=(E&255)>>>1}else{P=c[d+8>>2]|0;Q=c[d+4>>2]|0}if(Q>>>0>2147483631){z=33;break}if(Q>>>0<11){a[e>>0]=Q<<1;R=e+1|0}else{E=Q+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];G=cOb(E,16,g,0,3653512,80)|0;c[e+8>>2]=G;c[e>>2]=E|1;c[e+4>>2]=Q;R=G}YEi(R|0,P|0,Q|0)|0;a[R+Q>>0]=0;B=e+12|0;C=d+12|0;D=B+84|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0));O=c[n>>2]|0}G=O+96|0;c[n>>2]=G;d=d+96|0;if((d|0)==(N|0)){z=68;break}else e=G}if((z|0)==33)ori(e);else if((z|0)==68){i=f;return}}function Uyc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;h=e+20|0;j=e;k=c[b+8>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/96|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{a[p>>0]=14;m=p+1|0;a[m+0>>0]=a[590864]|0;a[m+1>>0]=a[590865]|0;a[m+2>>0]=a[590866]|0;a[m+3>>0]=a[590867]|0;a[m+4>>0]=a[590868]|0;a[m+5>>0]=a[590869]|0;a[m+6>>0]=a[590870]|0;a[p+8>>0]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=1;c[p+28>>2]=1;g[p+32>>2]=ea(15.0);g[p+36>>2]=ea(.333333343);g[p+40>>2]=ea(.0666666701);g[p+44>>2]=ea(.200000003);g[p+48>>2]=ea(.466666669);c[p+52>>2]=1;c[p+56>>2]=1;m=p+60|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[p+76>>2]=ea(.300000012);c[p+80>>2]=0;c[p+84>>2]=4;g[p+88>>2]=ea(512.0);c[p+92>>2]=1;q=c[l>>2]|0}p=q+96|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/96|0)+d|0;if(p>>>0>44739242)vxi(b);n=o;o=(k-n|0)/96|0;if(o>>>0<22369621){k=o<<1;r=k>>>0<p>>>0?p:k}else r=44739242;k=((c[l>>2]|0)-n|0)/96|0;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!r)s=0;else s=xCi(r*96|0)|0;c[j>>2]=s;l=s+(k*96|0)|0;k=j+8|0;c[k>>2]=l;p=j+4|0;c[p>>2]=l;c[n>>2]=s+(r*96|0);r=d;d=l;do{if(!d)t=0;else{a[d>>0]=14;l=d+1|0;a[l+0>>0]=a[590864]|0;a[l+1>>0]=a[590865]|0;a[l+2>>0]=a[590866]|0;a[l+3>>0]=a[590867]|0;a[l+4>>0]=a[590868]|0;a[l+5>>0]=a[590869]|0;a[l+6>>0]=a[590870]|0;a[d+8>>0]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=1;c[d+28>>2]=1;g[d+32>>2]=ea(15.0);g[d+36>>2]=ea(.333333343);g[d+40>>2]=ea(.0666666701);g[d+44>>2]=ea(.200000003);g[d+48>>2]=ea(.466666669);c[d+52>>2]=1;c[d+56>>2]=1;l=d+60|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g[d+76>>2]=ea(.300000012);c[d+80>>2]=0;c[d+84>>2]=4;g[d+88>>2]=ea(512.0);c[d+92>>2]=1;t=c[k>>2]|0}d=t+96|0;c[k>>2]=d;r=r+-1|0}while((r|0)!=0);Qyc(b,j);b=c[p>>2]|0;p=c[k>>2]|0;if((p|0)!=(b|0)){r=p;do{p=r;r=r+-96|0;c[k>>2]=r;if(a[r>>0]&1){d=c[p+-88>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((r|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}ACi(b);i=e;return}function Vyc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;m=(e|0)/96|0;if((d|0)==(l|0)){i=g;return}if(m>>>0>44739242)vxi(b);n=xCi(e)|0;c[j>>2]=n;c[b>>2]=n;c[k>>2]=n+(m*96|0);m=l;l=n;while(1){n=a[m>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=m+1|0}else{o=c[m+4>>2]|0;p=c[m+8>>2]|0}if(o>>>0>2147483631){q=9;break}if(o>>>0<11){a[l>>0]=o<<1;r=l+1|0}else{n=o+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];k=cOb(n,16,f,0,3653512,80)|0;c[l+8>>2]=k;c[l>>2]=n|1;c[l+4>>2]=o;r=k}YEi(r|0,p|0,o|0)|0;a[r+o>>0]=0;k=l+12|0;n=m+12|0;b=k+84|0;do{c[k>>2]=c[n>>2];k=k+4|0;n=n+4|0}while((k|0)<(b|0));n=(c[j>>2]|0)+96|0;c[j>>2]=n;m=m+96|0;if((m|0)==(d|0)){q=14;break}else l=n}if((q|0)==9)ori(l);else if((q|0)==14){i=g;return}}function Wyc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(4)|0))bHc();rri(b,2435040,13);wQb(224,4,b,220,2621,0,1);xri(b);i=a;return}function Xyc(){var a=0;a=i;Ydd(2435040,2462600,591696);QTb(224,554336,1816,1e5);i=a;return}function Yyc(){return}function Zyc(a){a=a|0;return 224}function _yc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;add(b,792072,2435040,a,0);dHc(a,b);e=a+176|0;f=c[142308]|0;add(b,591720,f,e,0);g=b+16|0;h=c[($hd(g)|0)+20>>2]|2097152;j=b+12|0;k=b+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=h;h=c[142268]|0;add(b,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+180|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);e=a+184|0;add(b,591736,f,e,0);l=c[($hd(g)|0)+20>>2]|2097152;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=l;add(b,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+188|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);e=a+192|0;add(b,591696,f,e,0);f=c[($hd(g)|0)+20>>2]|2097152;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=f;add(b,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+196|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);e=a+200|0;f=c[142308]|0;add(b,591752,f,e,0);l=c[($hd(g)|0)+20>>2]|2097152;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=l;add(b,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+204|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);h=a+208|0;add(b,695344,f,h,0);f=c[($hd(g)|0)+20>>2]|2097152;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=f;f=c[142268]|0;add(b,3143216,f,h,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,f,a+212|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);bdd(b);i=d;return}function $yc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2435040,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else uzc(a,b);sdd(b);i=d;return}function azc(a,b){a=a|0;b=b|0;var c=0;c=i;vzc(a,b);i=c;return}function bzc(a,b){a=a|0;b=b|0;var c=0;c=i;wzc(a,b);i=c;return}function czc(a,b){a=a|0;b=b|0;var c=0;c=i;xzc(a,b);i=c;return}function dzc(a,b){a=a|0;b=b|0;var c=0;c=i;kHc(a,b);i=c;return}function ezc(a){a=a|0;var b=0,d=Im,e=Im,f=Im,h=0,j=0,k=0;b=i;fGc(a);d=ea(ea(g[150274])*ea(.5));e=ea(ea(g[150275])*ea(.5));f=ea(d);d=ea(e);h=a+176|0;g[h>>2]=f;g[h+4>>2]=d;d=ea(ea(g[150274])*ea(.5));f=ea(ea(g[150275])*ea(.5));e=ea(d);d=ea(f);h=a+184|0;g[h>>2]=e;g[h+4>>2]=d;h=601088;j=c[h+4>>2]|0;k=a+192|0;c[k>>2]=c[h>>2];c[k+4>>2]=j;d=ea(ea(g[150274])*ea(100.0));e=ea(ea(g[150275])*ea(100.0));f=ea(d);d=ea(e);j=a+200|0;g[j>>2]=f;g[j+4>>2]=d;d=ea(ea(g[150274])*ea(.5));f=ea(ea(g[150275])*ea(.5));e=ea(d);d=ea(f);j=a+208|0;g[j>>2]=e;g[j+4>>2]=d;i=b;return}function fzc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im;b=i;i=i+80|0;d=b+24|0;e=b+40|0;f=b;h=b+48|0;j=b+16|0;k=b+8|0;l=b+32|0;m=c[a+24>>2]|0;if(!m){i=b;return}n=ATb(m,212)|0;if(!n){i=b;return}m=c[n+284>>2]|0;do if(m){c[e>>2]=m;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,e);o=c[d>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[q+4>>2]|0,(n|0)!=0):0)r=n;else s=12}else s=12;if((s|0)==12){n=hQb(m)|0;if(!n)break;else r=n}t=ea(g[r+36>>2]);u=ea(g[r+40>>2]);v=ea(t);w=ea(g[r+144>>2]);x=ea(u);n=f;g[n>>2]=v;g[n+4>>2]=x;x=ea(t/w);g[f>>2]=x;t=ea(u/w);g[f+4>>2]=t;yzc(a,f);if(!(x!=ea(0.0)&t!=ea(0.0))){i=b;return}g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];vDc(h,r,d);w=ea(g[h>>2]);u=ea(w-ea(g[h+12>>2]));w=ea(g[h+4>>2]);v=ea(ea(-ea(w-ea(g[h+16>>2])))/t);g[k>>2]=ea(ea(-u)/x);g[k+4>>2]=v;zzc(a,k);i=b;return}while(0);g[l>>2]=ea(1.0);g[l+4>>2]=ea(1.0);yzc(a,l);i=b;return}function gzc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+208|0;f=e;UGc(b,d);if((kzc(b)|0)&2){lzc(b,b);c[f+8>>2]=0;c[f+4>>2]=0;c[f>>2]=0;cUb(b,556808,f)}a[b+216>>0]=0;if(!(qVb(5)|0)){i=e;return}kbd(f,3516336,3516216,2435040,2434936);cbd(f+32|0,Ecd(b)|0);nbd(f)|0;i=e;return}function hzc(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;if(!((kzc(a)|0)&2)){i=b;return}lzc(a,a);c[d+8>>2]=0;c[d+4>>2]=0;c[d>>2]=0;cUb(a,556808,d);i=b;return}function izc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+224|0;e=d;f=d+200|0;if((b|0)==1){c[f+8>>2]=0;c[f+4>>2]=0;c[f>>2]=0;KGc(a,556440,f)}if(!(qVb(5)|0)){i=d;return}kbd(e,3516336,3516216,2435040,2434936);cbd(e+32|0,Ecd(a)|0);nbd(e)|0;i=d;return}function jzc(a){a=a|0;var b=0,c=0;b=i;c=a+160|0;if(((ea(g[c>>2])==ea(0.0)?ea(g[a+164>>2])==ea(0.0):0)?ea(g[a+168>>2])==ea(0.0):0)?ea(g[a+172>>2])==ea(0.0):0)kzc(a)|0;i=b;return c|0}function kzc(b){b=b|0;var e=0,f=0,h=0,j=0,k=Im,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0;e=i;i=i+32|0;f=e+16|0;h=e;mzc(h,b);j=b+44|0;k=ea(g[j>>2]);l=b+48|0;m=ea(g[l>>2]);n=b+52|0;o=ea(g[n>>2]);mzc(f,b);p=ea(g[n>>2]);q=ea(g[f>>2]);r=ea(g[f+8>>2]);s=ea(q+ea(r*ea(g[b+208>>2])));r=ea(g[f+4>>2]);q=ea(g[f+12>>2]);t=ea(r+ea(q*ea(g[b+212>>2])));if(k!=s|m!=t|o!=p){g[j>>2]=s;g[l>>2]=t;g[n>>2]=p;n=b+135|0;a[n>>0]=d[n>>0]|0|1;hGc(b,65);u=1}else u=0;p=ea(ea(g[h>>2])-s);g[h>>2]=p;n=h+4|0;s=ea(ea(g[n>>2])-t);g[n>>2]=s;n=b+160|0;if(((!(p!=ea(g[n>>2]))?!(s!=ea(g[b+164>>2])):0)?(s=ea(g[h+8>>2]),!(s!=ea(g[b+168>>2]))):0)?(s=ea(g[h+12>>2]),!(s!=ea(g[b+172>>2]))):0){v=u;i=e;return v|0}c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[n+12>>2]=c[h+12>>2];v=u|2;i=e;return v|0}function lzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[b+148>>2]|0;if((f|0)<=0){i=d;return}g=b+140|0;b=e+8|0;h=e+4|0;j=0;do{k=c[(c[g>>2]|0)+(j<<2)>>2]|0;if(((k|0)!=0?(l=(da(c[137788]|0,(c[k+8>>2]|0)>>>21)|0)+224|0,m=l>>5,(1<<l-(m<<5)&c[(c[137786]|0)+(m<<2)>>2]|0)!=0):0)?((kzc(k)|0)&2|0)!=0:0){lzc(a,k);c[b>>2]=0;c[h>>2]=0;c[e>>2]=0;cUb(k,556808,e)}j=j+1|0}while((j|0)!=(f|0));i=d;return}function mzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;d=i;e=c[b+156>>2]|0;if((e|0)!=0?(f=(da(c[137788]|0,(c[e+8>>2]|0)>>>21)|0)+224|0,h=f>>5,(1<<f-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]|0)!=0):0){h=e+160|0;j=ea(g[h>>2]);f=e+164|0;if(((j==ea(0.0)?ea(g[f>>2])==ea(0.0):0)?ea(g[e+168>>2])==ea(0.0):0)?ea(g[e+172>>2])==ea(0.0):0){kzc(e)|0;k=ea(g[h>>2])}else k=j;j=ea(g[f>>2]);l=ea(g[e+168>>2]);m=l;n=k;o=ea(g[e+172>>2]);p=j}else{m=ea(0.0);n=ea(0.0);o=ea(0.0);p=ea(0.0)}j=ea(n+ea(m*ea(g[b+176>>2])));k=ea(p+ea(o*ea(g[b+180>>2])));l=ea(n+ea(m*ea(g[b+184>>2])));m=ea(p+ea(o*ea(g[b+188>>2])));c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;o=ea(j+ea(g[b+192>>2]));p=ea(g[b+200>>2]);g[a>>2]=ea(o-ea(p*ea(g[b+208>>2])));o=ea(k+ea(g[b+196>>2]));n=ea(g[b+204>>2]);g[a+4>>2]=ea(o-ea(n*ea(g[b+212>>2])));g[a+8>>2]=ea(ea(l-j)+p);g[a+12>>2]=ea(ea(m-k)+n);i=d;return}function nzc(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=0,s=Im,t=Im,u=0,v=0,w=0,x=Im,y=Im;f=i;i=i+48|0;h=f+24|0;j=f+8|0;k=f;if(e&32){if(!((kzc(b)|0)&2)){i=f;return}lzc(b,b);c[h+8>>2]=0;c[h+4>>2]=0;c[h>>2]=0;cUb(b,556808,h);i=f;return}if((e&193|0)!=1){i=f;return}e=b+216|0;if(!(a[e>>0]|0)){l=b+48|0;m=b+208|0;n=b+212|0;o=b+44|0}else{mzc(h,b);p=ea(g[h>>2]);q=ea(g[h+8>>2]);r=b+208|0;s=ea(p+ea(q*ea(g[r>>2])));q=ea(g[h+4>>2]);p=ea(g[h+12>>2]);h=b+212|0;t=ea(q+ea(p*ea(g[h>>2])));u=b+44|0;g[u>>2]=s;v=b+48|0;g[v>>2]=t;w=b+135|0;a[w>>0]=d[w>>0]|1;a[e>>0]=0;l=v;m=r;n=h;o=u}mzc(j,b);t=ea(g[o>>2]);s=ea(g[l>>2]);p=ea(g[j>>2]);q=ea(g[j+8>>2]);x=ea(p+ea(q*ea(g[m>>2])));q=ea(g[j+4>>2]);p=ea(g[j+12>>2]);y=ea(q+ea(p*ea(g[n>>2])));p=ea(ea(t+ea(g[b+192>>2]))-x);x=ea(ea(s+ea(g[b+196>>2]))-y);g[k>>2]=p;g[k+4>>2]=x;Azc(b,k);i=f;return}function ozc(a,b){a=a|0;b=b|0;return}function pzc(a){a=a|0;return 0}function qzc(a,b){a=a|0;b=b|0;return}function rzc(){var a=0;a=i;QQb(224,134,135,0,136);i=a;return}function szc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(220,f,1,16,3653512,42)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];eGc(h,f,d);c[h>>2]=591584;d=h+160|0;f=h+176|0;g=h+184|0;j=h+192|0;b=h+200|0;k=h+208|0;l=d+0|0;m=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=f;c[l>>2]=1056964608;c[l+4>>2]=1056964608;l=g;c[l>>2]=1056964608;c[l+4>>2]=1056964608;l=j;c[l>>2]=0;c[l+4>>2]=0;l=b;c[l>>2]=1120403456;c[l+4>>2]=1120403456;l=k;c[l>>2]=1056964608;c[l+4>>2]=1056964608;a[h+216>>0]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;a[h+137>>0]=1;i=e;return h|0}function tzc(a,b,d){a=a|0;b=b|0;d=d|0;b=i;nzc(a,c[d+4>>2]|0);i=b;return}function uzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;fHc(a,b);f=a+176|0;g=c[142308]|0;h=qdd(b,591720,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else hgc(f,b);sdd(b)}f=a+184|0;h=qdd(b,591736,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else hgc(f,b);sdd(b)}f=a+192|0;h=qdd(b,591696,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else hgc(f,b);sdd(b)}f=a+200|0;h=qdd(b,591752,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else hgc(f,b);sdd(b)}f=a+208|0;a=qdd(b,695344,g,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else hgc(f,b);sdd(b);i=d;return}function vzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;hHc(a,b);e=a+176|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;k=b+20|0;b=c[k>>2]|0;if(j>>>0>b>>>0){Bid(f,e,4);l=c[f>>2]|0;m=c[k>>2]|0}else{g[e>>2]=ea(g[h>>2]);c[f>>2]=j;l=j;m=b}b=a+180|0;j=l+4|0;if(j>>>0>m>>>0){Bid(f,b,4);n=c[f>>2]|0;o=c[k>>2]|0}else{g[b>>2]=ea(g[l>>2]);c[f>>2]=j;n=j;o=m}m=a+184|0;j=n+4|0;if(j>>>0>o>>>0){Bid(f,m,4);p=c[f>>2]|0;q=c[k>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[f>>2]=j;p=j;q=o}o=a+188|0;j=p+4|0;if(j>>>0>q>>>0){Bid(f,o,4);r=c[f>>2]|0;s=c[k>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[f>>2]=j;r=j;s=q}q=a+192|0;j=r+4|0;if(j>>>0>s>>>0){Bid(f,q,4);t=c[f>>2]|0;u=c[k>>2]|0}else{g[q>>2]=ea(g[r>>2]);c[f>>2]=j;t=j;u=s}s=a+196|0;j=t+4|0;if(j>>>0>u>>>0){Bid(f,s,4);v=c[f>>2]|0;w=c[k>>2]|0}else{g[s>>2]=ea(g[t>>2]);c[f>>2]=j;v=j;w=u}u=a+200|0;j=v+4|0;if(j>>>0>w>>>0){Bid(f,u,4);x=c[f>>2]|0;y=c[k>>2]|0}else{g[u>>2]=ea(g[v>>2]);c[f>>2]=j;x=j;y=w}w=a+204|0;j=x+4|0;if(j>>>0>y>>>0){Bid(f,w,4);z=c[f>>2]|0;A=c[k>>2]|0}else{g[w>>2]=ea(g[x>>2]);c[f>>2]=j;z=j;A=y}y=a+208|0;j=z+4|0;if(j>>>0>A>>>0){Bid(f,y,4);B=c[f>>2]|0;C=c[k>>2]|0}else{g[y>>2]=ea(g[z>>2]);c[f>>2]=j;B=j;C=A}A=a+212|0;a=B+4|0;if(a>>>0>C>>>0){Bid(f,A,4);i=d;return}else{g[A>>2]=ea(g[B>>2]);c[f>>2]=a;i=d;return}}function wzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=i;iHc(a,b);e=a+176|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;l=b+20|0;b=c[l>>2]|0;if(j>>>0>b>>>0){Bid(f,e,4);m=e;n=c[f>>2]|0;o=c[l>>2]|0;p=c[e>>2]|0}else{q=ea(g[h>>2]);g[e>>2]=q;c[f>>2]=j;m=e;n=j;o=b;p=(g[k>>2]=q,c[k>>2]|0)}c[m>>2]=XEi(p|0)|0;p=a+180|0;m=n+4|0;if(m>>>0>o>>>0){Bid(f,p,4);r=p;s=c[p>>2]|0;t=c[f>>2]|0;u=c[l>>2]|0}else{q=ea(g[n>>2]);g[p>>2]=q;c[f>>2]=m;r=p;s=(g[k>>2]=q,c[k>>2]|0);t=m;u=o}c[r>>2]=XEi(s|0)|0;s=a+184|0;r=t+4|0;if(r>>>0>u>>>0){Bid(f,s,4);v=s;w=c[s>>2]|0;x=c[f>>2]|0;y=c[l>>2]|0}else{q=ea(g[t>>2]);g[s>>2]=q;c[f>>2]=r;v=s;w=(g[k>>2]=q,c[k>>2]|0);x=r;y=u}c[v>>2]=XEi(w|0)|0;w=a+188|0;v=x+4|0;if(v>>>0>y>>>0){Bid(f,w,4);z=w;A=c[w>>2]|0;B=c[f>>2]|0;C=c[l>>2]|0}else{q=ea(g[x>>2]);g[w>>2]=q;c[f>>2]=v;z=w;A=(g[k>>2]=q,c[k>>2]|0);B=v;C=y}c[z>>2]=XEi(A|0)|0;A=a+192|0;z=B+4|0;if(z>>>0>C>>>0){Bid(f,A,4);D=A;E=c[A>>2]|0;F=c[f>>2]|0;G=c[l>>2]|0}else{q=ea(g[B>>2]);g[A>>2]=q;c[f>>2]=z;D=A;E=(g[k>>2]=q,c[k>>2]|0);F=z;G=C}c[D>>2]=XEi(E|0)|0;E=a+196|0;D=F+4|0;if(D>>>0>G>>>0){Bid(f,E,4);H=E;I=c[E>>2]|0;J=c[f>>2]|0;K=c[l>>2]|0}else{q=ea(g[F>>2]);g[E>>2]=q;c[f>>2]=D;H=E;I=(g[k>>2]=q,c[k>>2]|0);J=D;K=G}c[H>>2]=XEi(I|0)|0;I=a+200|0;H=J+4|0;if(H>>>0>K>>>0){Bid(f,I,4);L=I;M=c[I>>2]|0;N=c[f>>2]|0;O=c[l>>2]|0}else{q=ea(g[J>>2]);g[I>>2]=q;c[f>>2]=H;L=I;M=(g[k>>2]=q,c[k>>2]|0);N=H;O=K}c[L>>2]=XEi(M|0)|0;M=a+204|0;L=N+4|0;if(L>>>0>O>>>0){Bid(f,M,4);P=M;Q=c[M>>2]|0;R=c[f>>2]|0;S=c[l>>2]|0}else{q=ea(g[N>>2]);g[M>>2]=q;c[f>>2]=L;P=M;Q=(g[k>>2]=q,c[k>>2]|0);R=L;S=O}c[P>>2]=XEi(Q|0)|0;Q=a+208|0;P=R+4|0;if(P>>>0>S>>>0){Bid(f,Q,4);T=Q;U=c[Q>>2]|0;V=c[f>>2]|0;W=c[l>>2]|0}else{q=ea(g[R>>2]);g[Q>>2]=q;c[f>>2]=P;T=Q;U=(g[k>>2]=q,c[k>>2]|0);V=P;W=S}c[T>>2]=XEi(U|0)|0;U=a+212|0;a=V+4|0;if(a>>>0>W>>>0){Bid(f,U,4);X=U;Y=c[U>>2]|0;Z=XEi(Y|0)|0;c[X>>2]=Z;i=d;return}else{q=ea(g[V>>2]);g[U>>2]=q;c[f>>2]=a;X=U;Y=(g[k>>2]=q,c[k>>2]|0);Z=XEi(Y|0)|0;c[X>>2]=Z;i=d;return}}function xzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;jHc(a,b);e=a+176|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;k=b+20|0;b=c[k>>2]|0;if(j>>>0<b>>>0){g[h>>2]=ea(g[e>>2]);c[f>>2]=j;l=j;m=b}else{Gid(f,e,4);l=c[f>>2]|0;m=c[k>>2]|0}e=a+180|0;b=l+4|0;if(b>>>0<m>>>0){g[l>>2]=ea(g[e>>2]);c[f>>2]=b;n=b;o=m}else{Gid(f,e,4);n=c[f>>2]|0;o=c[k>>2]|0}e=a+184|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[e>>2]);c[f>>2]=m;p=m;q=o}else{Gid(f,e,4);p=c[f>>2]|0;q=c[k>>2]|0}e=a+188|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[e>>2]);c[f>>2]=o;r=o;s=q}else{Gid(f,e,4);r=c[f>>2]|0;s=c[k>>2]|0}e=a+192|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[e>>2]);c[f>>2]=q;t=q;u=s}else{Gid(f,e,4);t=c[f>>2]|0;u=c[k>>2]|0}e=a+196|0;s=t+4|0;if(s>>>0<u>>>0){g[t>>2]=ea(g[e>>2]);c[f>>2]=s;v=s;w=u}else{Gid(f,e,4);v=c[f>>2]|0;w=c[k>>2]|0}e=a+200|0;u=v+4|0;if(u>>>0<w>>>0){g[v>>2]=ea(g[e>>2]);c[f>>2]=u;x=u;y=w}else{Gid(f,e,4);x=c[f>>2]|0;y=c[k>>2]|0}e=a+204|0;w=x+4|0;if(w>>>0<y>>>0){g[x>>2]=ea(g[e>>2]);c[f>>2]=w;z=w;A=y}else{Gid(f,e,4);z=c[f>>2]|0;A=c[k>>2]|0}e=a+208|0;y=z+4|0;if(y>>>0<A>>>0){g[z>>2]=ea(g[e>>2]);c[f>>2]=y;B=y;C=A}else{Gid(f,e,4);B=c[f>>2]|0;C=c[k>>2]|0}k=a+212|0;a=B+4|0;if(a>>>0<C>>>0){g[B>>2]=ea(g[k>>2]);c[f>>2]=a;i=d;return}else{Gid(f,k,4);i=d;return}}function yzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=0;d=i;i=i+16|0;e=d;f=a+200|0;h=ea(g[f>>2]);j=ea(g[b>>2]);k=ea(j-h);if(k<ea(0.0))l=ea(-k);else l=k;if(h<ea(0.0))m=ea(-h);else m=h;if(j<ea(0.0))n=ea(-j);else n=j;j=ea((m<n?n:m)*ea(9.99999997e-07));o=j<ea(.000079999998);if(l<(o?ea(.000079999998):j)){j=ea(g[a+204>>2]);l=ea(g[b+4>>2]);m=ea(l-j);if(m<ea(0.0))p=ea(-m);else p=m;if(j<ea(0.0))q=ea(-j);else q=j;if(l<ea(0.0))r=ea(-l);else r=l;l=ea((q<r?r:q)*ea(9.99999997e-07));o=l<ea(.000079999998);if(p<(o?ea(.000079999998):l)){i=d;return}}o=b;b=c[o+4>>2]|0;s=f;c[s>>2]=c[o>>2];c[s+4>>2]=b;if(!((kzc(a)|0)&2)){i=d;return}lzc(a,a);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(a,556808,e);i=d;return}function zzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=0;d=i;i=i+16|0;e=d;f=a+208|0;h=ea(g[f>>2]);j=ea(g[b>>2]);k=ea(j-h);if(k<ea(0.0))l=ea(-k);else l=k;if(h<ea(0.0))m=ea(-h);else m=h;if(j<ea(0.0))n=ea(-j);else n=j;j=ea((m<n?n:m)*ea(9.99999997e-07));o=j<ea(.000079999998);if(l<(o?ea(.000079999998):j)){j=ea(g[a+212>>2]);l=ea(g[b+4>>2]);m=ea(l-j);if(m<ea(0.0))p=ea(-m);else p=m;if(j<ea(0.0))q=ea(-j);else q=j;if(l<ea(0.0))r=ea(-l);else r=l;l=ea((q<r?r:q)*ea(9.99999997e-07));o=l<ea(.000079999998);if(p<(o?ea(.000079999998):l)){i=d;return}}o=b;b=c[o+4>>2]|0;s=f;c[s>>2]=c[o>>2];c[s+4>>2]=b;if(!((kzc(a)|0)&2)){i=d;return}lzc(a,a);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(a,556808,e);i=d;return}function Azc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=0;d=i;i=i+16|0;e=d;f=a+192|0;h=ea(g[f>>2]);j=ea(g[b>>2]);k=ea(j-h);if(k<ea(0.0))l=ea(-k);else l=k;if(h<ea(0.0))m=ea(-h);else m=h;if(j<ea(0.0))n=ea(-j);else n=j;j=ea((m<n?n:m)*ea(9.99999997e-07));o=j<ea(.000079999998);if(l<(o?ea(.000079999998):j)){j=ea(g[a+196>>2]);l=ea(g[b+4>>2]);m=ea(l-j);if(m<ea(0.0))p=ea(-m);else p=m;if(j<ea(0.0))q=ea(-j);else q=j;if(l<ea(0.0))r=ea(-l);else r=l;l=ea((q<r?r:q)*ea(9.99999997e-07));o=l<ea(.000079999998);if(p<(o?ea(.000079999998):l)){i=d;return}}o=b;b=c[o+4>>2]|0;s=f;c[s>>2]=c[o>>2];c[s+4>>2]=b;if(!((kzc(a)|0)&2)){i=d;return}lzc(a,a);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(a,556808,e);i=d;return}function Bzc(a){a=a|0;var b=0;b=i;c[a>>2]=591584;Ezc(a);i=b;return}function Czc(a){a=a|0;var b=0;b=i;c[a>>2]=591584;Ezc(a);ACi(a);i=b;return}function Dzc(b,c){b=b|0;c=c|0;a[b+137>>0]=1;return}function Ezc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=596384;if((c[a+152>>2]|0)<=-1){WUb(a);i=b;return}f=a+140|0;g=c[f>>2]|0;c[e>>2]=c[a+144>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;WUb(a);i=b;return}function Fzc(){var a=0,b=0,d=0;a=i;b=xCi(32)|0;c[b>>2]=b;c[b+4>>2]=b;c[b+8>>2]=0;d=b+16|0;c[d>>2]=0;c[b+20>>2]=0;c[b+12>>2]=d;c[b+24>>2]=0;c[b+28>>2]=0;c[147942]=b;i=a;return}function Gzc(){return c[147942]|0}function Hzc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;l=i;i=i+80|0;m=l;n=l+32|0;o=l+44|0;p=l+40|0;q=l+48|0;r=l+16|0;s=l+36|0;t=l+52|0;u=l+56|0;v=l+68|0;w=l+72|0;if((g|0)==7){x=ync()|0;y=mo[c[(c[x>>2]|0)+668>>2]&4095](x)|0}else y=g;if((y|0)==9){g=ync()|0;z=mo[c[(c[g>>2]|0)+672>>2]&4095](g)|0}else z=y;y=h&2;g=(y|0)==0;x=h>>>2;A=h&1;h=(A|0)!=0;B=(A<<1)+2|0;if((j|0)==2)C=7;else if((j|0)==0?(KLc()|0)==1:0)C=7;else D=0;if((C|0)==7){j=ync()|0;D=(z|0)!=(mo[c[(c[j>>2]|0)+672>>2]&4095](j)|0)}if((d|0)<1|(e|0)<1){if(h){E=0;i=l;return E|0}j=n8b()|0;A=c[j>>2]|0;if(!A){E=0;i=l;return E|0}c[q>>2]=A;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(m,A,q);F=c[m>>2]|0;G=c[A+28>>2]|0;if((F|0)==-1){H=G+(c[A+32>>2]<<3)|0;break}else{H=G+(F<<3)|0;break}}else H=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if((H|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0)?(A=c[H+4>>2]|0,(A|0)!=0):0)I=A;else C=19}else C=19;if((C|0)==19){A=hQb(c[j>>2]|0)|0;if(!A){E=0;i=l;return E|0}else I=A}v$b(r,I);I=c[r+8>>2]|0;if((d|0)<0)J=(I|0)/(0-d|0)|0;else J=I;I=c[r+12>>2]|0;if((e|0)<0){K=(I|0)/(0-e|0)|0;L=J}else{K=I;L=J}}else{K=e;L=d}if(h){if((L|0)!=(K|0)|(L+-1&L|0)!=0|(k+-1|0)>>>0>7){E=0;i=l;return E|0}}else if((k+-1|0)>>>0>7){E=0;i=l;return E|0}if(k+-1&k){E=0;i=l;return E|0}h=c[b+4>>2]|0;a:do if((h|0)!=(b|0)){d=(x&1|0)!=0;e=h;b:while(1){J=e+12|0;I=c[J>>2]|0;do if(I){c[p>>2]=I;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(m,r,p);A=c[m>>2]|0;j=c[r+28>>2]|0;if((A|0)==-1){M=j+(c[r+32>>2]<<3)|0;break}else{M=j+(A<<3)|0;break}}else M=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((M|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[M+4>>2]|0,(r|0)!=0):0)N=r;else C=39}else C=39;if((C|0)==39){C=0;r=hQb(c[J>>2]|0)|0;if(!r)break;else N=r}if(((((((c[N+120>>2]|0)==(f|0)?(c[N+116>>2]|0)==(z|0):0)?(mo[c[(c[N>>2]|0)+92>>2]&4095](N)|0)==(B|0):0)?!((a[N+130>>0]|0)!=0^D):0)?(c[N+108>>2]|0)==(k|0):0)?!((a[N+133>>0]|0)!=0^d):0)?((c[N+100>>2]|0)==(L|0)?(c[N+104>>2]|0)==(K|0):0):0){O=e;P=J;break b}}while(0);e=c[e+4>>2]|0;if((e|0)==(b|0))break a}if((O|0)!=(b|0)?(e=c[P>>2]|0,(e|0)!=0):0){c[n>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(m,e,n);d=c[m>>2]|0;J=c[e+28>>2]|0;if((d|0)==-1){Q=J+(c[e+32>>2]<<3)|0;break}else{Q=J+(d<<3)|0;break}}else Q=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if(!((Q|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(c[Q+4>>2]|0)!=0:0))C=58}else C=58;if((C|0)==58?(hQb(c[P>>2]|0)|0)==0:0)break;e=c[P>>2]|0;do if(!e){R=0;S=0}else{c[o>>2]=e;d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(m,d,o);J=c[m>>2]|0;I=c[d+28>>2]|0;if((J|0)==-1){T=I+(c[d+32>>2]<<3)|0;break}else{T=I+(J<<3)|0;break}}else T=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((T|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[T+4>>2]|0,(d|0)!=0):0)U=d;else C=74}else C=74;if((C|0)==74){d=hQb(c[P>>2]|0)|0;if(!d){R=0;S=0;break}else U=d}R=U;S=c[U+4>>2]|0}while(0);c[w>>2]=S;Lzc(m,b+12|0,w);e=O+4|0;d=c[O>>2]|0;c[d+4>>2]=c[e>>2];c[c[e>>2]>>2]=d;d=b+8|0;c[d>>2]=(c[d>>2]|0)+-1;if(!(a[591888]|0)){Kzc(591880,16);d=591888;c[d>>2]=1;c[d+4>>2]=0}dsd(c[147970]|0,O);bGc(R+28|0);c[R+40>>2]=1;c[R+32>>2]=0;ko[c[(c[R>>2]|0)+132>>2]&4095](R);a[R+132>>0]=y>>>1;if(g){E=R;i=l;return E|0}xBc(R);E=R;i=l;return E|0}}while(0);R=b+24|0;c[R>>2]=(c[R>>2]|0)+1;c[s>>2]=c[153106];c[m+0>>2]=c[s+0>>2];s=bOb(172,m,1,16,3653512,152)|0;c[t>>2]=c[153106];c[m+0>>2]=c[t+0>>2];BBc(s,m,0);t=pQb(s)|0;ko[c[(c[t>>2]|0)+24>>2]&4095](t);In[c[(c[t>>2]|0)+44>>2]&4095](t,61);s=c[(c[t>>2]|0)+36>>2]|0;c[m>>2]=c[R>>2];c[m+4>>2]=L;c[m+8>>2]=K;Lsd(u,591776,m);if(!(a[u>>0]&1))V=u+1|0;else V=c[u+8>>2]|0;In[s&4095](t,V);xri(u);JBc(t,L);KBc(t,K);MBc(t,z);LBc(t,f);DBc(t,B);HBc(t,D);EBc(t,k);a[t+133>>0]=x&1;In[c[(c[t>>2]|0)+12>>2]&4095](t,4);if(!t)W=0;else W=c[t+4>>2]|0;c[v>>2]=W;Lzc(m,b+12|0,v);E=t;i=l;return E|0}function Izc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e+8|0;g=e;h=b+28|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;k=c[b+4>>2]|0;if((k|0)==(b|0)){i=e;return}l=b+8|0;m=j;j=k;while(1){k=m-(c[j+8>>2]|0)|0;n=j+4|0;o=c[n>>2]|0;if((k|0)>(d|0)|(k|0)<0){k=j+12|0;p=c[k>>2]|0;if(!p)q=0;else{c[g>>2]=p;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,g);r=c[f>>2]|0;s=c[p+28>>2]|0;if((r|0)==-1){t=s+(c[p+32>>2]<<3)|0;break}else{t=s+(r<<3)|0;break}}else t=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((t|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[t+4>>2]|0,(p|0)!=0):0)u=p;else v=13}else v=13;if((v|0)==13){v=0;u=hQb(c[k>>2]|0)|0}q=u}kQb(q);p=c[j>>2]|0;c[p+4>>2]=c[n>>2];c[c[n>>2]>>2]=p;c[l>>2]=(c[l>>2]|0)+-1;if(!(a[591888]|0)){Kzc(591880,16);p=591888;c[p>>2]=1;c[p+4>>2]=0}dsd(c[147970]|0,j)}if((o|0)==(b|0))break;m=c[h>>2]|0;j=o}i=e;return}function Jzc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;if(!d){i=e;return}g=d+4|0;d=c[g>>2]|0;h=c[b+16>>2]|0;a:do if(h){j=h;while(1){k=c[j+16>>2]|0;if((d|0)<(k|0))l=j;else{if((k|0)>=(d|0))break;l=j+4|0}j=c[l>>2]|0;if(!j)break a}c[f>>2]=d;Mzc(b+12|0,f)|0;j=c[b+28>>2]|0;k=c[g>>2]|0;if(!(a[591888]|0)){Kzc(591880,16);m=591888;c[m>>2]=1;c[m+4>>2]=0}m=csd(c[147970]|0,16)|0;c[m+12>>2]=k;c[m+8>>2]=j;c[m+4>>2]=b;j=c[b>>2]|0;c[m>>2]=j;c[j+4>>2]=m;c[b>>2]=m;m=b+8|0;c[m>>2]=(c[m>>2]|0)+1;i=e;return}while(0);Krd(591800,0,3653512,251,1,d,0,0);i=e;return}function Kzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=c[153126];c[e+0>>2]=c[f+0>>2];f=bOb(44,e,0,16,3653512,142)|0;c[g>>2]=c[153126];c[e+0>>2]=c[g+0>>2];_rd(f,1,719624,b,32768,e,16);c[a>>2]=f;Zrd(f);i=d;return}function Lzc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=c[e>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((k|0)<(m|0)){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((m|0)>=(k|0)){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=d+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=0;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}if(!(a[557880]|0)){sYb(557872,20);g=557880;c[g>>2]=1;c[g+4>>2]=0}g=csd(c[139468]|0,20)|0;c[g+16>>2]=c[e>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=v;c[u>>2]=g;v=c[c[d>>2]>>2]|0;if(!v)z=g;else{c[d>>2]=v;z=c[u>>2]|0}GN(c[h>>2]|0,z);z=d+8|0;c[z>>2]=(c[z>>2]|0)+1;w=1;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function Mzc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[b+4>>2]|0;g=b+4|0;if(!f){h=0;i=e;return h|0}j=c[d>>2]|0;d=g;k=f;a:while(1){l=k;while(1){if((c[l+16>>2]|0)>=(j|0)){m=l;break}l=c[l+4>>2]|0;if(!l){n=d;break a}}k=c[m>>2]|0;if(!k){n=m;break}else d=m}if((n|0)==(g|0)){h=0;i=e;return h|0}if((j|0)<(c[n+16>>2]|0)){h=0;i=e;return h|0}j=c[n+4>>2]|0;if(!j){g=n;while(1){m=c[g+8>>2]|0;if((c[m>>2]|0)==(g|0)){o=m;break}else g=m}}else{g=j;while(1){j=c[g>>2]|0;if(!j){o=g;break}else g=j}}if((c[b>>2]|0)==(n|0))c[b>>2]=o;o=b+8|0;c[o>>2]=(c[o>>2]|0)+-1;tYb(f,n);if(!(a[557880]|0)){sYb(557872,20);f=557880;c[f>>2]=1;c[f+4>>2]=0}dsd(c[139468]|0,n);h=1;i=e;return h|0}function Nzc(){var a=0;a=i;QQb(25,137,138,139,140);i=a;return}function Ozc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(2)|0))uUb();rri(b,613088,8);wQb(25,2,b,284,2622,1,0);xri(b);i=a;return}function Pzc(){var a=0;a=i;QTb(25,554336,1817,1e5);QTb(25,554784,1818,0);YAc();i=a;return}function Qzc(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153106];c[b+0>>2]=c[d+0>>2];d=OAc(4,b)|0;c[e>>2]=c[153106];c[b+0>>2]=c[e+0>>2];e=PAc(4,b)|0;c[147976]=e;ITb(d,e);In[c[(c[d>>2]|0)+44>>2]&4095](d,61);i=a;return}function Rzc(){var a=0;a=i;c[147976]=0;ZAc();i=a;return}function Szc(a){a=a|0;return 25}function Tzc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,613088,a,0);FAc(a,b);bdd(b);i=c;return}function Uzc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,613088,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else GAc(a,b);sdd(b);i=d;return}function Vzc(a,b){a=a|0;b=b|0;var c=0;c=i;HAc(a,b);i=c;return}function Wzc(a,b){a=a|0;b=b|0;var c=0;c=i;IAc(a,b);i=c;return}function Xzc(a,b){a=a|0;b=b|0;var c=0;c=i;JAc(a,b);i=c;return}function Yzc(a,b){a=a|0;b=b|0;var c=0;c=i;KAc(a,b);i=c;return}function Zzc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h+4|0;k=h;c[k>>2]=c[f>>2];c[j+0>>2]=c[k+0>>2];bUb(d,j,g);V_b(d+28|0,e);c[d>>2]=591920;c[d+28>>2]=592084;c[d+216>>2]=-1;e=VQb(d)|0;c[d+220>>2]=0;c[d+224>>2]=e;c[d+228>>2]=0;c[d+232>>2]=0;e=VQb(d)|0;c[d+236>>2]=0;c[d+240>>2]=e;e=d+244|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[d+268>>2]=d;a[d+272>>0]=1;a[d+273>>0]=1;c[d+276>>2]=0;b[d+280>>1]=0;b[d+282>>1]=0;c[d+204>>2]=1;c[d+72>>2]=1;i=h;return}function _zc(a){a=a|0;var b=0;b=i;$zc(a,1);i=b;return}function $zc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+220|0;h=a+228|0;if((c[h>>2]|0)==(b|0)){i=d;return}j=a+232|0;k=c[j>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[j>>2]=b;l=c[g>>2]|0;c[f>>2]=c[a+224>>2];c[e+0>>2]=c[f+0>>2];c[g>>2]=hOb(l,b<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+224>>2];c[e+0>>2]=c[f+0>>2];l=cOb(b<<2,4,e,0,3653512,352)|0;YEi(l|0,c[g>>2]|0,c[h>>2]<<2|0)|0;c[j>>2]=b;c[g>>2]=l;break}while(0);j=c[h>>2]|0;if(j>>>0<b>>>0?(e=c[g>>2]|0,g=e+(b<<2)|0,(j|0)!=(b|0)):0){f=e+(j<<2)|0;do{if(f)c[f>>2]=0;f=f+4|0}while((f|0)!=(g|0))}c[h>>2]=b;vAc(a);lAc(a);i=d;return}function aAc(a){a=a|0;var b=0;b=i;bAc(a);i=b;return}function bAc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+196|0;h=c[g>>2]|0;j=VQb(a)|0;if(h){if((c[h+28>>2]|0)>-1){a=h+16|0;k=c[a>>2]|0;c[e>>2]=c[h+20>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[a>>2]=0}if((c[h+12>>2]|0)>-1){a=c[h>>2]|0;c[e>>2]=c[h+4>>2];c[d+0>>2]=c[e+0>>2];eOb(a,d);c[h>>2]=0}}c[f>>2]=j;c[d+0>>2]=c[f+0>>2];eOb(h,d);c[g>>2]=0;i=b;return}function cAc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+260|0;e=c[d>>2]|0;if(e){f=a+264|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}f=c[a+256>>2]|0;if(!f){i=b;return}Wtc(f,a);i=b;return}function dAc(b){b=b|0;return (a[b+71>>0]|0)!=0|0}function eAc(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[b+71>>0]=1;OQb(b,0);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(b,554968,e);i=d;return}function fAc(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=b+-28|0;a[f+71>>0]=1;OQb(f,0);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(f,554968,e);i=d;return}function gAc(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[b+71>>0]=0;c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(b,555008,e);OQb(b,1);i=d;return}function hAc(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=b+-28|0;a[f+71>>0]=0;c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(f,555008,e);OQb(f,1);i=d;return}function iAc(a){a=a|0;return c[(c[a+24>>2]|0)+40>>2]|0}function jAc(a){a=a|0;return c[(c[a+-28+24>>2]|0)+40>>2]|0}function kAc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;a[b+273>>0]=d&1;if(!((a[b+272>>0]|0)==0|d^1)?(d=c[b+24>>2]|0,(d|0)!=0):0){f=vTb(d)|0;if(!(f^(c[b+216>>2]|0)!=-1)){i=e;return}if(f){f=b+260|0;if(c[f>>2]|0){i=e;return}d=c[147975]|0;if((f|0)==(d|0)){i=e;return}g=b+264|0;h=c[d>>2]|0;c[f>>2]=h;c[g>>2]=d;c[h+4>>2]=f;c[c[g>>2]>>2]=f;i=e;return}}else j=3;if((j|0)==3?(c[b+216>>2]|0)==-1:0){i=e;return}ko[c[(c[b>>2]|0)+152>>2]&4095](b);j=b+260|0;f=c[j>>2]|0;if(f){g=b+264|0;c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[j>>2]=0;c[g>>2]=0}OQb(b,1);i=e;return}function lAc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;a[b+77>>0]=1;g=b+216|0;if((c[g>>2]|0)==-1){i=d;return}b=Lac()|0;h=c[g>>2]|0;g=(c[b+48>>2]|0)+(h*24|0)+21|0;if(a[g>>0]|0){i=d;return}j=b+96|0;k=b+104|0;l=(c[k>>2]|0)+1|0;c[k>>2]=l;m=b+108|0;n=c[m>>2]|0;o=n&2147483647;if(l>>>0>o>>>0){p=n<<1;q=(p|0)==0?1:p;do if(o>>>0<q>>>0)if((n|0)>-1){c[m>>2]=q;p=c[j>>2]|0;c[f>>2]=c[b+100>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(p,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+100>>2];c[e+0>>2]=c[f+0>>2];p=cOb(q<<2,4,e,0,3653512,352)|0;YEi(p|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[m>>2]=q;c[j>>2]=p;break}while(0);r=c[k>>2]|0}else r=l;c[(c[j>>2]|0)+(r+-1<<2)>>2]=h;a[g>>0]=1;i=d;return}function mAc(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;b=c[147975]|0;if((b|0)==591896){i=a;return}else d=b;do{b=d;d=c[d+4>>2]|0;e=c[b+8>>2]|0;b=e+260|0;f=c[b>>2]|0;if(f){g=e+264|0;c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[b>>2]=0;c[g>>2]=0}ko[c[(c[e>>2]|0)+144>>2]&4095](e)}while((d|0)!=591896);i=a;return}function nAc(a,b){a=a|0;b=b|0;c[a+216>>2]=b;return}function oAc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e;j=d+216|0;if((c[j>>2]|0)==-1){i=e;return}k=Lac()|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;Y_b(d+28|0,h);l=c[j>>2]|0;m=(c[k+64>>2]|0)+(l*24|0)|0;c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];c[m+16>>2]=c[h+16>>2];c[m+20>>2]=c[h+20>>2];h=k+48|0;k=c[h>>2]|0;a[k+(l*24|0)+21>>0]=0;l=c[j>>2]|0;a[k+(l*24|0)+20>>0]=(c[(c[d+24>>2]|0)+52>>2]|0)>>>4&1;k=mo[c[(c[d>>2]|0)+116>>2]&4095](d)|0;c[(c[h>>2]|0)+(l*24|0)+4>>2]=k;if((c[j>>2]|0)==-1){i=e;return}k=Lac()|0;c[f>>2]=0;c[g>>2]=0;l=c[d+256>>2]|0;if(!l){n=0;o=0}else{Xtc(l,d,f,g);n=c[f>>2]&65535;o=c[g>>2]|0}g=c[j>>2]|0;j=c[k+48>>2]|0;b[j+(g*24|0)+12>>1]=0;b[j+(g*24|0)+14>>1]=n;c[j+(g*24|0)+16>>2]=o;i=e;return}function pAc(b){b=b|0;var d=0,e=0;d=i;e=qAc(b)|0;if(a[b+76>>0]|0)c[b+192>>2]=NGc(e,b+80|0)|0;if(a[b+77>>0]|0)ko[c[(c[b>>2]|0)+124>>2]&4095](b);Wlc(b+168|0,b+80|0,b+144|0);i=d;return}function qAc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;if(!(c[a+244>>2]|0)){g=BTb(c[a+24>>2]|0)|0;i=b;return g|0}h=a+252|0;a=c[h>>2]|0;do if(a){c[e>>2]=a;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(c[m+4>>2]|0)!=0:0)n=j;else o=12}else o=12;if((o|0)==12){if(!(hQb(c[h>>2]|0)|0))break;n=c[137784]|0}c[f>>2]=c[h>>2];if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,f);j=c[d>>2]|0;k=c[n+28>>2]|0;if((j|0)==-1){p=k+(c[n+32>>2]<<3)|0;break}else{p=k+(j<<3)|0;break}}else p=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);j=c[137784]|0;if((p|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[p+4>>2]|0,(j|0)!=0):0)q=j;else o=22}else o=22;if((o|0)==22)q=hQb(c[h>>2]|0)|0;g=q;i=b;return g|0}while(0);g=c[147976]|0;i=b;return g|0}function rAc(b){b=b|0;var d=0,e=0;d=i;e=b+-28|0;b=qAc(e)|0;if(a[e+76>>0]|0)c[e+192>>2]=NGc(b,e+80|0)|0;if(a[e+77>>0]|0)ko[c[(c[e>>2]|0)+124>>2]&4095](e);Wlc(e+168|0,e+80|0,e+144|0);i=d;return}function sAc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;if(((a[b+272>>0]|0)!=0?(a[b+273>>0]|0)!=0:0)?(e=c[b+24>>2]|0,(e|0)!=0):0){f=vTb(e)|0;e=c[b>>2]|0;if(f){ko[c[e+148>>2]&4095](b);oAc(b);i=d;return}else g=e}else g=c[b>>2]|0;ko[c[g+152>>2]&4095](b);i=d;return}function tAc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+196|0;g=c[f>>2]|0;if(g){h=g;i=b;return h|0}g=VQb(a)|0;c[e>>2]=g;c[d+0>>2]=c[e+0>>2];e=bOb(36,d,0,16,3653512,308)|0;c[e>>2]=0;c[e+4>>2]=g;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=g;c[e+24>>2]=0;c[e+28>>2]=0;c[e+32>>2]=c[155410];c[f>>2]=e;h=e;i=b;return h|0}function uAc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;b=i;ko[c[(c[a>>2]|0)+152>>2]&4095](a);d=a+260|0;e=c[d>>2]|0;if(!e){i=b;return}f=a+264|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0;i=b;return}function vAc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+236|0;g=a+244|0;h=c[g>>2]|0;if(!h){i=b;return}j=c[a+228>>2]|0;if((h|0)==(j|0)){i=b;return}c[g>>2]=j;k=a+248|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<j>>>0)if((l|0)>-1){c[k>>2]=j;m=c[f>>2]|0;c[e>>2]=c[a+240>>2];c[d+0>>2]=c[e+0>>2];c[f>>2]=hOb(m,j<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+240>>2];c[d+0>>2]=c[e+0>>2];m=cOb(j<<2,4,d,0,3653512,352)|0;YEi(m|0,c[f>>2]|0,c[g>>2]<<2|0)|0;c[k>>2]=j;c[f>>2]=m;break}while(0);if(h>>>0<(c[g>>2]|0)>>>0){j=c[f>>2]|0;f=h;do{c[j+(f<<2)>>2]=f;f=f+1|0}while(f>>>0<(c[g>>2]|0)>>>0)}lAc(a);i=b;return}function wAc(a){a=a|0;var b=0,d=0;b=i;d=a+216|0;if((c[d>>2]|0)!=-1){i=b;return}c[d>>2]=Jac(Lac()|0,a)|0;i=b;return}function xAc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+216|0;if((c[e>>2]|0)==-1){i=d;return}f=(a[b+71>>0]|0)==0;g=Lac()|0;zac(g,c[e>>2]|0)|0;c[e>>2]=-1;if(f){i=d;return}ko[c[(c[b>>2]|0)+112>>2]&4095](b);i=d;return}function yAc(a){a=a|0;var b=0;b=i;fUb(a);vAc(a);i=b;return}function zAc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+248|0;if((c[f>>2]|0)>-1){g=a+236|0;h=c[g>>2]|0;c[e>>2]=c[a+240>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}c[a+244>>2]=0;c[f>>2]=0;lAc(a);i=b;return}function AAc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+236|0;j=a+244|0;if(!(c[j>>2]|0)){k=a+228|0;l=c[k>>2]|0;c[j>>2]=l;m=a+248|0;n=c[m>>2]|0;do if((n&2147483647)>>>0<l>>>0)if((n|0)>-1){c[m>>2]=l;o=c[h>>2]|0;c[g>>2]=c[a+240>>2];c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(o,l<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[a+240>>2];c[f+0>>2]=c[g+0>>2];o=cOb(l<<2,4,f,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,c[j>>2]<<2|0)|0;c[m>>2]=l;c[h>>2]=o;break}while(0);if(c[k>>2]|0){l=c[h>>2]|0;m=0;do{c[l+(m<<2)>>2]=m;m=m+1|0}while(m>>>0<(c[k>>2]|0)>>>0)}}if((b|0)<=-1){lAc(a);i=e;return}if((c[j>>2]|0)<=(b|0)){lAc(a);i=e;return}c[(c[h>>2]|0)+(b<<2)>>2]=d;lAc(a);i=e;return}function BAc(a,b,d){a=a|0;b=b|0;d=d|0;c[(c[a+220>>2]|0)+(d<<2)>>2]=c[b>>2];return}function CAc(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if(!(f&1))kAc(d,(a[d+273>>0]|0)!=0);if(f&13){f=ZWb()|0;b[d+282>>1]=PWb(f,c[d+276>>2]|0)|0}f=c[d+24>>2]|0;do if(!f){h=d+260|0;j=c[h>>2]|0;if(j){k=j;l=h;m=14}}else{h=vTb(f)|0;j=d+260|0;n=c[j>>2]|0;if((n|0)!=0^h){if(!h)if(!n)break;else{k=n;l=j;m=14;break}h=c[147975]|0;if((j|0)!=(h|0)){o=d+264|0;if(n){c[n+4>>2]=c[o>>2];c[c[o>>2]>>2]=n;c[j>>2]=0;c[o>>2]=0}n=c[h>>2]|0;c[j>>2]=n;c[o>>2]=h;c[n+4>>2]=j;c[c[o>>2]>>2]=j}}}while(0);if((m|0)==14){m=d+264|0;c[k+4>>2]=c[m>>2];c[c[m>>2]>>2]=k;c[l>>2]=0;c[m>>2]=0}c[d+200>>2]=e[d+282>>1]<<16^-2147483648|(b[d+280>>1]|0)+32768;i=g;return}function DAc(b,d){b=b|0;d=d|0;var e=0,f=0;d=i;e=b+216|0;if((c[e>>2]|0)==-1){i=d;return}f=c[(c[b+24>>2]|0)+52>>2]|0;b=Lac()|0;a[(c[b+48>>2]|0)+((c[e>>2]|0)*24|0)+20>>0]=f>>>4&1;i=d;return}function EAc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=g+4|0;k=d+64+(f<<1)|0;if((e|0)==-1){b[k>>1]=255;i=g;return}if(e>>>0<=255){b[k>>1]=e;i=g;return}b[k>>1]=255;c[h>>2]=255;Lsd(j,721176,h);if(!(a[j>>0]&1))l=j+1|0;else l=c[j+8>>2]|0;Krd(l,0,3653512,60,1,0,0,0);xri(j);i=g;return}function FAc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+16|0;k=f+24|0;hTb(b,e);l=c[142258]|0;add(e,667608,l,b+272|0,1);m=e+12|0;n=e+20|0;c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=1;bdd(e);fdd(e);add(e,720904,c[142302]|0,b+69|0,0);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=1;bdd(e);add(e,592152,l,b+70|0,0);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=1;bdd(e);fdd(e);l=b+64|0;o=c[142296]|0;add(e,720984,o,l,8388609);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=2;bdd(e);add(e,721e3,o,l+2|0,8388609);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=2;bdd(e);l=b+32|0;o=c[142312]|0;add(e,721024,o,l,8388609);ljc(l,e);bdd(e);l=b+48|0;add(e,721048,o,l,8388609);ljc(l,e);bdd(e);l=c[142306]|0;add(e,592176,l,b+220|0,0);c[j>>2]=0;$cd(e,2646336,2646336,h,0);add(e,3142592,723624,j,0);o=g+8|0;p=o;c[p>>2]=0;c[p+4>>2]=0;c[g>>2]=0;p=c[142270]|0;add(e,792256,p,j,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=4;bdd(e);j=c[142290]|0;add(e,792272,j,o,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=8;bdd(e);bdd(e);cdd(e);bdd(e);add(e,592192,l,b+236|0,1);$cd(e,2646336,2646336,g,0);add(e,3142592,c[142304]|0,h,0);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=4;bdd(e);cdd(e);bdd(e);h=b+252|0;add(e,592208,596808,h,1);l=g+8|0;o=l;c[o>>2]=0;c[o+4>>2]=0;c[g>>2]=0;add(e,792256,p,h,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,792272,j,l,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=8;bdd(e);bdd(e);l=b+204|0;a[k>>0]=(c[l>>2]|0)==1&1;add(e,592232,c[142258]|0,k,0);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=1;bdd(e);c[l>>2]=d[k>>0];fdd(e);add(e,592256,p,b+72|0,0);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=4;bdd(e);p=b+212|0;add(e,592280,596808,p,0);k=g+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[g>>2]=0;g=c[142270]|0;add(e,792256,g,p,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,792272,c[142290]|0,k,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=8;bdd(e);bdd(e);fdd(e);add(e,792216,g,b+276|0,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,792240,c[142286]|0,b+280|0,1);c[(c[c[m>>2]>>2]|0)+((c[n>>2]|0)*24|0)+12>>2]=2;bdd(e);fdd(e);i=f;return}function GAc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+4|0;iTb(b,d);h=b+272|0;j=c[142258]|0;k=qdd(d,667608,j,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[l>>2]=o;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+69|0;k=qdd(d,720904,c[142302]|0,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[l>>2]=m;if((n|0)>=0?(o+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[m>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+70|0;k=qdd(d,592152,j,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[l>>2]=o;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+64|0;AUb(d,h,720984,8388609);AUb(d,h+2|0,721e3,8388609);h=b+32|0;k=c[142312]|0;l=qdd(d,721024,k,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else igc(h,d);sdd(d)}h=b+48|0;l=qdd(d,721048,k,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else igc(h,d);sdd(d)}h=b+220|0;l=c[142306]|0;k=qdd(d,592176,l,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else QAc(d,h,0);sdd(d)}h=b+236|0;k=qdd(d,592192,l,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else lfc(d,h,0);sdd(d)}h=b+252|0;k=qdd(d,592208,596808,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else Zcc(h,d);sdd(d)}h=b+204|0;k=(c[h>>2]|0)==1&1;a[g>>0]=k;l=qdd(d,592232,j,f,0)|0;if(!l)p=k;else{do if((l|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](g,d)|0}else{k=d+12|0;j=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=j+o|0;c[k>>2]=n;if((o|0)>=0?(j+(o+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[n>>0]|0;c[k>>2]=j+(o+1);break}Bid(k,g,1)}while(0);sdd(d);p=a[g>>0]|0}c[h>>2]=p&255;p=b+72|0;h=c[142270]|0;g=qdd(d,592256,h,f,0)|0;if(g){if((g|0)>0){g=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=l+k|0;c[g>>2]=o;if((k|0)>=0?(j=l+(k+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[p>>2]=c[o>>2];c[g>>2]=j}else Bid(g,p,4);if(c[d>>2]&512)c[p>>2]=XEi(c[p>>2]|0)|0}else{g=c[f>>2]|0;if(g)_n[g&4095](p,d)|0}sdd(d)}p=b+212|0;g=qdd(d,592280,596808,f,1)|0;if(g){if((g|0)<=0){g=c[f>>2]|0;if(g)_n[g&4095](p,d)|0}else Zcc(p,d);sdd(d)}p=b+276|0;g=qdd(d,792216,h,f,0)|0;if(!g){q=b+280|0;RAc(d,q,792240,1);i=e;return}if((g|0)>0){g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=h+j|0;c[g>>2]=o;if((j|0)>=0?(k=h+(j+4)|0,k>>>0<=(c[d+20>>2]|0)>>>0):0){c[p>>2]=c[o>>2];c[g>>2]=k}else Bid(g,p,4);if(c[d>>2]&512)c[p>>2]=XEi(c[p>>2]|0)|0}else{g=c[f>>2]|0;if(g)_n[g&4095](p,d)|0}sdd(d);q=b+280|0;RAc(d,q,792240,1);i=e;return}function HAc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;jTb(d,e);h=d+272|0;j=e+12|0;k=c[j>>2]|0;l=e+20|0;if((k+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(j,h,1);else{a[h>>0]=a[k>>0]|0;c[j>>2]=(c[j>>2]|0)+1}Ndd(e);k=d+69|0;h=c[j>>2]|0;if((h+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(j,k,1);m=c[j>>2]|0}else{a[k>>0]=a[h>>0]|0;h=(c[j>>2]|0)+1|0;c[j>>2]=h;m=h}h=d+70|0;if((m+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(j,h,1);else{a[h>>0]=a[m>>0]|0;c[j>>2]=(c[j>>2]|0)+1}Ndd(e);m=d+64|0;h=c[j>>2]|0;k=h+2|0;n=c[l>>2]|0;if(k>>>0>n>>>0){Bid(j,m,2);o=c[j>>2]|0;p=c[l>>2]|0}else{b[m>>1]=b[h>>1]|0;c[j>>2]=k;o=k;p=n}n=m+2|0;m=o+2|0;if(m>>>0>p>>>0)Bid(j,n,2);else{b[n>>1]=b[o>>1]|0;c[j>>2]=m}Qxc(e,d+32|0,721024,8388609);Qxc(e,d+48|0,721048,8388609);SAc(e,d+220|0,0);yfc(e,d+236|0,0);bdc(d+252|0,e);m=d+204|0;a[g>>0]=(c[m>>2]|0)==1&1;o=c[j>>2]|0;n=o+1|0;if(n>>>0>(c[l>>2]|0)>>>0){Bid(j,g,1);q=a[g>>0]|0}else{p=a[o>>0]|0;a[g>>0]=p;c[j>>2]=n;q=p}c[m>>2]=q&255;Ndd(e);q=d+72|0;m=c[j>>2]|0;p=m+4|0;if(p>>>0>(c[l>>2]|0)>>>0)Bid(j,q,4);else{c[q>>2]=c[m>>2];c[j>>2]=p}bdc(d+212|0,e);Ndd(e);p=d+276|0;m=c[j>>2]|0;q=m+4|0;n=c[l>>2]|0;if(q>>>0>n>>>0){Bid(j,p,4);r=c[j>>2]|0;s=c[l>>2]|0}else{c[p>>2]=c[m>>2];c[j>>2]=q;r=q;s=n}n=d+280|0;d=r+2|0;if(d>>>0>s>>>0){Bid(j,n,2);Ndd(e);i=f;return}else{b[n>>1]=b[r>>1]|0;c[j>>2]=d;Ndd(e);i=f;return}}function IAc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+16|0;g=f;kTb(d,e);h=d+272|0;j=e+12|0;k=c[j>>2]|0;l=e+20|0;if((k+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(j,h,1);else{a[h>>0]=a[k>>0]|0;c[j>>2]=(c[j>>2]|0)+1}Mdd(e);k=d+69|0;h=c[j>>2]|0;if((h+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(j,k,1);m=c[j>>2]|0}else{a[k>>0]=a[h>>0]|0;h=(c[j>>2]|0)+1|0;c[j>>2]=h;m=h}h=d+70|0;if((m+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(j,h,1);else{a[h>>0]=a[m>>0]|0;c[j>>2]=(c[j>>2]|0)+1}Mdd(e);m=d+64|0;h=c[j>>2]|0;k=h+2|0;n=c[l>>2]|0;if(k>>>0>n>>>0){Bid(j,m,2);o=b[m>>1]|0;p=c[j>>2]|0;q=c[l>>2]|0}else{r=b[h>>1]|0;b[m>>1]=r;c[j>>2]=k;o=r;p=k;q=n}n=o&65535;b[m>>1]=n<<8|n>>>8;n=m+2|0;m=p+2|0;if(m>>>0>q>>>0){Bid(j,n,2);s=b[n>>1]|0}else{q=b[p>>1]|0;b[n>>1]=q;c[j>>2]=m;s=q}q=s&65535;b[n>>1]=q<<8|q>>>8;ojc(d+32|0,e);ojc(d+48|0,e);TAc(e,d+220|0,0);Ifc(e,d+236|0,0);fdc(d+252|0,e);q=d+204|0;a[g>>0]=(c[q>>2]|0)==1&1;n=c[j>>2]|0;s=n+1|0;if(s>>>0>(c[l>>2]|0)>>>0){Bid(j,g,1);t=a[g>>0]|0}else{m=a[n>>0]|0;a[g>>0]=m;c[j>>2]=s;t=m}c[q>>2]=t&255;Mdd(e);t=d+72|0;q=c[j>>2]|0;m=q+4|0;if(m>>>0>(c[l>>2]|0)>>>0){Bid(j,t,4);u=c[t>>2]|0}else{s=c[q>>2]|0;c[t>>2]=s;c[j>>2]=m;u=s}c[t>>2]=XEi(u|0)|0;fdc(d+212|0,e);Mdd(e);u=d+276|0;t=c[j>>2]|0;s=t+4|0;m=c[l>>2]|0;if(s>>>0>m>>>0){Bid(j,u,4);v=c[u>>2]|0;w=c[j>>2]|0;x=c[l>>2]|0}else{l=c[t>>2]|0;c[u>>2]=l;c[j>>2]=s;v=l;w=s;x=m}c[u>>2]=XEi(v|0)|0;v=d+280|0;d=w+2|0;if(d>>>0>x>>>0){Bid(j,v,2);y=b[v>>1]|0;z=y&65535;A=z<<8;B=z>>>8;C=A|B;D=C&65535;b[v>>1]=D;Mdd(e);i=f;return}else{x=b[w>>1]|0;b[v>>1]=x;c[j>>2]=d;y=x;z=y&65535;A=z<<8;B=z>>>8;C=A|B;D=C&65535;b[v>>1]=D;Mdd(e);i=f;return}}function JAc(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+16|0;h=g;j=g+4|0;lTb(e,f);k=e+272|0;l=f+12|0;m=c[l>>2]|0;n=f+20|0;if((m+1|0)>>>0<(c[n>>2]|0)>>>0){a[m>>0]=a[k>>0]|0;c[l>>2]=(c[l>>2]|0)+1}else Gid(l,k,1);Tdd(f);k=e+69|0;m=c[l>>2]|0;if((m+1|0)>>>0<(c[n>>2]|0)>>>0){a[m>>0]=a[k>>0]|0;m=(c[l>>2]|0)+1|0;c[l>>2]=m;o=m}else{Gid(l,k,1);o=c[l>>2]|0}k=e+70|0;if((o+1|0)>>>0<(c[n>>2]|0)>>>0){a[o>>0]=a[k>>0]|0;c[l>>2]=(c[l>>2]|0)+1}else Gid(l,k,1);Tdd(f);k=e+64|0;o=c[l>>2]|0;m=o+2|0;p=c[n>>2]|0;if(m>>>0<p>>>0){b[o>>1]=b[k>>1]|0;c[l>>2]=m;q=m;r=p}else{Gid(l,k,2);q=c[l>>2]|0;r=c[n>>2]|0}p=k+2|0;k=q+2|0;if(k>>>0<r>>>0){b[q>>1]=b[p>>1]|0;c[l>>2]=k}else Gid(l,p,2);mjc(f,e+32|0,721024,8388609);mjc(f,e+48|0,721048,8388609);p=e+228|0;k=c[p>>2]|0;c[h>>2]=k;q=c[l>>2]|0;r=q+4|0;if(r>>>0<(c[n>>2]|0)>>>0){c[q>>2]=k;c[l>>2]=r}else Gid(l,h,4);r=c[e+220>>2]|0;k=c[p>>2]|0;p=r+(k<<2)|0;if(k){k=r;do{j7b(k,f);k=k+4|0}while((k|0)!=(p|0))}p=e+244|0;k=c[p>>2]|0;c[h>>2]=k;r=c[l>>2]|0;q=r+4|0;if(q>>>0<(c[n>>2]|0)>>>0){c[r>>2]=k;c[l>>2]=q}else Gid(l,h,4);h=c[e+236>>2]|0;q=c[p>>2]|0;p=h+(q<<2)|0;if(q){q=h;do{h=c[l>>2]|0;k=h+4|0;if(k>>>0<(c[n>>2]|0)>>>0){c[h>>2]=c[q>>2];c[l>>2]=k}else Gid(l,q,4);q=q+4|0}while((q|0)!=(p|0))}idc(e+252|0,f);p=e+204|0;q=(c[p>>2]|0)==1&1;a[j>>0]=q;k=c[l>>2]|0;if((k+1|0)>>>0<(c[n>>2]|0)>>>0){a[k>>0]=q;c[l>>2]=(c[l>>2]|0)+1}else Gid(l,j,1);c[p>>2]=d[j>>0];Tdd(f);j=e+72|0;p=c[l>>2]|0;q=p+4|0;if(q>>>0<(c[n>>2]|0)>>>0){c[p>>2]=c[j>>2];c[l>>2]=q}else Gid(l,j,4);idc(e+212|0,f);Tdd(f);j=e+276|0;q=c[l>>2]|0;p=q+4|0;k=c[n>>2]|0;if(p>>>0<k>>>0){c[q>>2]=c[j>>2];c[l>>2]=p;s=k;t=p}else{Gid(l,j,4);s=c[n>>2]|0;t=c[l>>2]|0}n=e+280|0;e=t+2|0;if(e>>>0<s>>>0){b[t>>1]=b[n>>1]|0;c[l>>2]=e;Tdd(f);i=g;return}else{Gid(l,n,2);Tdd(f);i=g;return}}function KAc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;mTb(b,d);f=c[b+220>>2]|0;g=c[b+228>>2]|0;h=f+(g<<2)|0;j=d+12|0;k=d+28|0;l=d+32|0;if(g){g=f;do{f=c[j>>2]|0;m=xo[c[c[f>>2]>>2]&2047](f,c[g>>2]|0,c[k>>2]|0)|0;if(a[l>>0]|0)c[g>>2]=m;g=g+4|0}while((g|0)!=(h|0))}idd(d,1);h=b+252|0;g=c[j>>2]|0;m=xo[c[c[g>>2]>>2]&2047](g,c[h>>2]|0,c[k>>2]|0)|0;if(a[l>>0]|0)c[h>>2]=m;jdd(d);d=b+204|0;c[d>>2]=(c[d>>2]|0)==1&1;d=b+212|0;b=c[j>>2]|0;j=xo[c[c[b>>2]>>2]&2047](b,c[d>>2]|0,c[k>>2]|0)|0;if(!(a[l>>0]|0)){i=e;return}c[d>>2]=j;i=e;return}function LAc(a,b){a=a|0;b=b|0;return 0}function MAc(b,c,d){b=b|0;c=c|0;d=d|0;d=i;a[b+76>>0]=1;lAc(b);i=d;return}function NAc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;b=a+216|0;if((c[b>>2]|0)==-1){i=d;return}e=Lac()|0;f=c[b>>2]|0;b=mo[c[(c[a>>2]|0)+116>>2]&4095](a)|0;c[(c[e+48>>2]|0)+(f*24|0)+4>>2]=b;i=d;return}function OAc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(72,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];nTb(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function PAc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(160,e,1,16,3653512,1140)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];eGc(f,e,0);e=pQb(f)|0;ko[c[(c[e>>2]|0)+24>>2]&4095](e);In[c[(c[e>>2]|0)+12>>2]&4095](e,a);i=d;return e|0}function QAc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];XAc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<2)|0;do if(c[f>>2]|0){j=qdd(a,3142592,723624,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;g7b(r,a);t=r+4|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,723624,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else g7b(m,a);sdd(a)}m=m+4|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function RAc(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=qdd(a,f,c[142286]|0,h,0)|0;if(!j){i=g;return}if((j|0)>0){j=a+12|0;f=c[a+16>>2]|0;k=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;l=f+k|0;c[j>>2]=l;if((k|0)>=0?(m=f+(k+2)|0,m>>>0<=(c[a+20>>2]|0)>>>0):0){b[d>>1]=b[l>>1]|0;c[j>>2]=m}else Bid(j,d,2);if(c[a>>2]&512){j=e[d>>1]|0;b[d>>1]=j<<8|j>>>8}}else{j=c[h>>2]|0;if(j)_n[j&4095](d,a)|0}sdd(a);i=g;return}function SAc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];XAc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<2)|0;if(!k){i=d;return}else u=s;do{h7b(u,a);u=u+4|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<2;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>2;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function TAc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];XAc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<2)|0;if(!k){i=d;return}else u=t;do{i7b(u,a);u=u+4|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<2;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>2;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function UAc(a){a=a|0;var b=0;b=i;Ncc(a);ACi(a);i=b;return}function VAc(a){a=a|0;var b=0;b=i;Ncc(a+-28|0);i=b;return}function WAc(a){a=a|0;var b=0,c=0;b=i;c=a+-28|0;Ncc(c);ACi(c);i=b;return}function XAc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<2,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<2,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<2|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<2)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<2)|0;do{if(f)c[f>>2]=0;f=f+4|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function YAc(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;if(!(pLc()|0)){i=a;return}c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];d=bOb(4,b,0,16,3653512,389)|0;c[d>>2]=592400;c[148084]=d;d=pLc()|0;Dn[c[(c[d>>2]|0)+4>>2]&511](d,25,21,c[148084]|0);c[e>>2]=c[153084];c[b+0>>2]=c[e+0>>2];e=bOb(4,b,0,16,3653512,393)|0;c[e>>2]=592360;c[148086]=e;e=pLc()|0;Dn[c[(c[e>>2]|0)+4>>2]&511](e,25,22,c[148086]|0);i=a;return}function ZAc(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[148084]|0;c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[148084]=0;e=c[148086]|0;c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[148086]=0;i=a;return}function _Ac(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,592304);c[148074]=c[b>>2];i=a;return}function $Ac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;a=i;i=i+112|0;d=a+88|0;e=a+32|0;f=a;h=a+64|0;j=a+80|0;k=a+96|0;l=a+28|0;m=a+56|0;n=a+40|0;o=a+24|0;p=a+8|0;q=c[b+12>>2]|0;r=c[b>>2]|0;c[f>>2]=r&268435455;b=c[q+196>>2]|0;do if(b){s=r>>>30;if(!s){t=vld(b,f)|0;if(!t)break;u=ea(g[t+((r>>>28&3)<<2)>>2]);i=a;return ea(u)}else if((s|0)==2){t=uld(b,f)|0;if(!t)break;u=ea(g[t>>2]);i=a;return ea(u)}else if((s|0)==1){if(!(wld(b,f,h)|0))break;u=ea(g[h+((r>>>28&3)<<2)>>2]);i=a;return ea(u)}else break}while(0);if((mo[c[(c[q>>2]|0)+128>>2]&4095](q)|0)<=0){u=ea(0.0);i=a;return ea(u)}h=r>>>30;if((h|0)==2){b=0;a:while(1){co[c[(c[q>>2]|0)+132>>2]&2047](j,q,0);s=c[j>>2]|0;do if(s){c[e>>2]=s;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(d,t,e);v=c[d>>2]|0;w=c[t+28>>2]|0;if((v|0)==-1){x=w+(c[t+32>>2]<<3)|0;break}else{x=w+(v<<3)|0;break}}else x=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((x|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[x+4>>2]|0,(t|0)!=0):0)y=t;else z=19}else z=19;if((z|0)==19){z=0;t=hQb(c[j>>2]|0)|0;if(!t)break;else y=t}c[k>>2]=c[f>>2];c[d+0>>2]=c[k+0>>2];if(pkd(y,d)|0){A=y;break a}}while(0);b=b+1|0;if((b|0)>=(mo[c[(c[q>>2]|0)+128>>2]&4095](q)|0)){u=ea(0.0);z=39;break}}if((z|0)==39){i=a;return ea(u)}c[l>>2]=c[f>>2];c[d+0>>2]=c[l+0>>2];u=ea(okd(A,d));i=a;return ea(u)}else B=0;b:while(1){co[c[(c[q>>2]|0)+132>>2]&2047](j,q,0);A=c[j>>2]|0;do if(A){c[e>>2]=A;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(d,l,e);b=c[d>>2]|0;y=c[l+28>>2]|0;if((b|0)==-1){C=y+(c[l+32>>2]<<3)|0;break}else{C=y+(b<<3)|0;break}}else C=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((C|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[C+4>>2]|0,(l|0)!=0):0)D=l;else z=32}else z=32;if((z|0)==32){z=0;l=hQb(c[j>>2]|0)|0;if(!l)break;else D=l}c[k>>2]=c[f>>2];c[d+0>>2]=c[k+0>>2];if(pkd(D,d)|0)if((h|0)==1){E=D;z=36;break b}else if(!h){F=D;z=37;break b}}while(0);B=B+1|0;if((B|0)>=(mo[c[(c[q>>2]|0)+128>>2]&4095](q)|0)){u=ea(0.0);z=39;break}}if((z|0)==36){c[m>>2]=c[f>>2];c[d+0>>2]=c[m+0>>2];mkd(n,E,d);u=ea(g[n+((r>>>28&3)<<2)>>2]);i=a;return ea(u)}else if((z|0)==37){c[o>>2]=c[f>>2];c[d+0>>2]=c[o+0>>2];mkd(p,F,d);u=ea(g[p+((r>>>28&3)<<2)>>2]);i=a;return ea(u)}else if((z|0)==39){i=a;return ea(u)}return ea(0.0)}function aBc(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0,h=0,j=0;a=i;i=i+32|0;e=a+8|0;f=a;g=c[b+12>>2]|0;h=c[b>>2]|0;b=tAc(g)|0;c[f>>2]=h&268435455;j=h>>>30;if((j|0)==2)rld(b,f,d);else if(!j)sld(b,f,d,4,h>>>28&3);else if((j|0)==1)tld(b,f,d,4,h>>>28&3);xld(b);if(!((h&805306368|0)==536870912?(c[148074]|0)==(c[f>>2]|0):0)){i=a;return}if((c[g+64>>2]&-131072|0)==16646144){i=a;return}f=rLc()|0;if(!((wld(b,592296,e)|0)&(f|0)!=0)){i=a;return}xo[c[c[f>>2]>>2]&2047](f,g,e)|0;i=a;return}function bBc(a,b,c){a=a|0;b=b|0;c=c|0;return}function cBc(a,b){a=a|0;b=b|0;return 0}function dBc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+16|0;g=b;if(e){h=0;i=b;return h|0}if(!(a[d>>0]&1))j=d+1|0;else j=c[d+8>>2]|0;if(!(Esd(j,592320)|0)){h=0;i=b;return h|0}if(!(a[d>>0]&1))k=d+1|0;else k=c[d+8>>2]|0;d=SEi(592320)|0;j=k+d|0;e=a[j>>0]|0;a:do if(e<<24>>24){l=j;m=e;n=j;o=-1;while(1){if(m<<24>>24==46&(o|0)==-1)p=n-l|0;else p=o;q=n+1|0;m=a[q>>0]|0;if(!(m<<24>>24)){r=n;s=p;break}else{n=q;o=p}}if((s|0)!=-1){o=k+(s+d)|0;n=o-j|0;if(n>>>0>4294967279)ori(g);if(n>>>0<11){a[g>>0]=n<<1;t=g+1|0}else{m=n+16&-16;l=xCi(m)|0;c[g+8>>2]=l;c[g>>2]=m|1;c[g+4>>2]=n;t=l}if(!s)u=t;else{l=j;m=t;while(1){a[m>>0]=a[l>>0]|0;l=l+1|0;if((l|0)==(o|0))break;else m=m+1|0}u=t+n|0}a[u>>0]=0;if(!(a[g>>0]&1))v=g+1|0;else v=c[g+8>>2]|0;m=(gtd(v)|0)&268435455;xri(g);if((s+2|0)!=(SEi(j|0)|0)){h=0;i=b;return h|0}o=a[r>>0]|0;if((o|0)==97|(o|0)==98|(o|0)==103|(o|0)==114)w=m|1073741824;else w=m;switch(o|0){case 119:case 97:{x=w|805306368;break a;break}case 122:case 98:{x=w&-805306369|536870912;break a;break}case 120:case 114:{x=w&-805306369;break a;break}case 121:case 103:{x=w&-805306369|268435456;break a;break}default:{h=0;i=b;return h|0}}}else y=15}else y=15;while(0);if((y|0)==15)x=(gtd(j)|0)&268435455|-2147483648;c[f+4>>2]=x;h=1;i=b;return h|0}function eBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;i=i+16|0;a=b;f=c[d+4>>2]|0;c[a>>2]=-1;htd(a,f&268435455);c[e>>2]=c[a>>2]&268435455|f&-268435456;i=b;return 100002}function fBc(a,b){a=a|0;b=b|0;return ea(0.0)}function gBc(a,b,c){a=a|0;b=b|0;c=ea(c);return}function hBc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;i=i+16|0;e=a;f=c[b+12>>2]|0;g=c[b>>2]|0;if((g|0)>=(mo[c[(c[f>>2]|0)+128>>2]&4095](f)|0)){i=a;return}c[e>>2]=d;BAc(f,e,g);i=a;return}function iBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a;e=c[b+12>>2]|0;f=c[b>>2]|0;if((f|0)>=(mo[c[(c[e>>2]|0)+128>>2]&4095](e)|0)){g=0;i=a;return g|0}co[c[(c[e>>2]|0)+132>>2]&2047](d,e,f);g=c[d>>2]|0;i=a;return g|0}function jBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;f=lBc(b,592432)|0;if((f|0)==-1|d^1){g=0;i=a;return g|0}c[e+4>>2]=f;g=1;i=a;return g|0}function kBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[e>>2]=c[d+4>>2];return 21}function lBc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=a[b>>0]|0;g=(f&1)==0;if(g){h=(f&255)>>>1;j=b+1|0}else{h=c[b+4>>2]|0;j=c[b+8>>2]|0}if((h|0)!=0?(k=EEi(j,91,h)|0,(k|0)!=0):0)l=k-j|0;else l=-1;if(g){m=(f&255)>>>1;n=b+1|0}else{m=c[b+4>>2]|0;n=c[b+8>>2]|0}if(!m){o=-1;i=e;return o|0}f=EEi(n,93,m)|0;if(!f){o=-1;i=e;return o|0}if((l|0)==-1|(f-n|0)==-1){o=-1;i=e;return o|0}if(g)p=b+1|0;else p=c[b+8>>2]|0;if(!(Esd(p,d)|0)){o=-1;i=e;return o|0}if(!(a[b>>0]&1))q=b+1|0;else q=c[b+8>>2]|0;o=Hsd(q+l|0)|0;i=e;return o|0}function mBc(a){a=a|0;c[148116]=(c[148116]|0)+(a?1:-1);return}function nBc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=(KLc()|0)==1;f=ync()|0;g=c[(c[f>>2]|0)+72>>2]|0;if(!b){h=e;In[g&4095](f,h);i=d;return}h=(a[b+130>>0]|0)!=0&e;In[g&4095](f,h);i=d;return}function oBc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;if((!((a[621158]|0)==0|1==0)?(l=a[(NOc()|0)+92>>0]|0,!((c[148116]|0)==0&l<<24>>24==0|(b|0)==0)):0)?(uBc(b)|0,l=c[b+140>>2]|0,m=c[b+148>>2]|0,!((l|0)==0&(m|0)==0)):0){c[j>>2]=l;l=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;n=b;o=l?d:0;p=m;c[k>>2]=p;c[h+0>>2]=c[k+0>>2];qBc(1,j,h,n,o,e,f)|0;i=g;return}m=ync()|0;c[j>>2]=mo[c[(c[m>>2]|0)+428>>2]&4095](m)|0;m=ync()|0;n=0;o=0;p=mo[c[(c[m>>2]|0)+432>>2]&4095](m)|0;c[k>>2]=p;c[h+0>>2]=c[k+0>>2];qBc(1,j,h,n,o,e,f)|0;i=g;return}function pBc(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[621158]|0)==0|1==0){e=0;i=d;return e|0}f=a[(NOc()|0)+92>>0]|0;if((c[148116]|0)==0&f<<24>>24==0|(b|0)==0){e=0;i=d;return e|0}uBc(b)|0;if(c[b+140>>2]|0){e=b;i=d;return e|0}e=(c[b+148>>2]|0)!=0?b:0;i=d;return e|0}function qBc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+80|0;l=k;m=l+0|0;n=m+72|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));do if((a[621158]|0)==0|1==0){c[l+36>>2]=1;if(!(j&4)){o=1;p=14}else{q=1;p=13}}else{if(!(a[(NOc()|0)+92>>0]|0))r=(c[148116]|0)!=0;else r=1;m=r?b:1;c[l+36>>2]=m;if((m|0)>0){n=(j&4|0)==0;if(!r)if(n){o=m;p=14;break}else{q=m;p=13;break}else s=0;do{t=c[d+(s<<2)>>2]|0;if(!t){u=ync()|0;v=mo[c[(c[u>>2]|0)+428>>2]&4095](u)|0}else v=t;t=l+(s<<2)|0;c[t>>2]=v;if(n)w=a[v+20>>0]|0;else w=2;a[l+s+52>>0]=w;a[l+s+60>>0]=a[(c[t>>2]|0)+21>>0]|0;u=c[t>>2]|0;a[u+21>>0]=0;a[u+20>>0]=0;s=s+1|0}while((s|0)!=(m|0))}if(r?(m=c[e>>2]|0,(m|0)!=0):0)x=m;else p=19}while(0);if((p|0)==13){e=0;do{r=ync()|0;s=l+(e<<2)|0;c[s>>2]=mo[c[(c[r>>2]|0)+428>>2]&4095](r)|0;a[l+e+52>>0]=2;a[l+e+60>>0]=a[(c[s>>2]|0)+21>>0]|0;r=c[s>>2]|0;a[r+21>>0]=0;a[r+20>>0]=0;e=e+1|0}while((e|0)!=(q|0));p=19}else if((p|0)==14){q=0;do{e=ync()|0;r=mo[c[(c[e>>2]|0)+428>>2]&4095](e)|0;e=l+(q<<2)|0;c[e>>2]=r;a[l+q+52>>0]=a[r+20>>0]|0;a[l+q+60>>0]=a[(c[e>>2]|0)+21>>0]|0;r=c[e>>2]|0;a[r+21>>0]=0;a[r+20>>0]=0;q=q+1|0}while((q|0)!=(o|0));p=19}if((p|0)==19){p=ync()|0;x=mo[c[(c[p>>2]|0)+432>>2]&4095](p)|0}c[l+32>>2]=x;p=j&8;o=x+20|0;if(!p)y=a[o>>0]|0;else y=2;a[l+68>>0]=y;y=x+21|0;a[l+69>>0]=a[y>>0]|0;a[y>>0]=0;a[o>>0]=0;c[l+44>>2]=h;h=c[l>>2]|0;if(!(a[h+23>>0]|0))z=(cwc(c[h+4>>2]|0,c[h+8>>2]|0,1)|0)+-1|0;else z=0;if((g|0)<0){A=0;B=l+40|0;c[B>>2]=A;C=j>>>2;D=C&1;E=p>>>2;F=D|E;G=j<<2;H=G&8;I=F|H;J=l+48|0;c[J>>2]=I;sBc(f,l,j)|0;i=k;return 1}A=(z|0)<(g|0)?z:g;B=l+40|0;c[B>>2]=A;C=j>>>2;D=C&1;E=p>>>2;F=D|E;G=j<<2;H=G&8;I=F|H;J=l+48|0;c[J>>2]=I;sBc(f,l,j)|0;i=k;return 1}function rBc(){var b=0,d=0;b=i;if(!((a[621158]|0)==0|1==0))if(!(a[(NOc()|0)+92>>0]|0))d=(c[148116]|0)!=0;else d=1;else d=0;i=b;return d|0}function sBc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+64|0;g=f+48|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+16|0;m=f;n=a[(c[d>>2]|0)+23>>0]|0;o=ync()|0;p=_n[c[(c[o>>2]|0)+416>>2]&4095](o,0)|0;if(!((p|0)==(c[d>>2]|0)?(c[d+48>>2]&2|0)==0:0))q=3;if((((q|0)==3?(p=c[(ync()|0)+5836>>2]|0,(p|0)!=0):0)?(c[p+108>>2]|0)>1:0)?(r=p+144|0,(c[r>>2]|0)!=0):0){s=ync()|0;t=c[(c[s>>2]|0)+396>>2]|0;c[j>>2]=c[p+140>>2];c[k>>2]=c[r>>2];c[h+0>>2]=c[j+0>>2];c[g+0>>2]=c[k+0>>2];co[t&2047](s,h,g)}In[c[(c[o>>2]|0)+392>>2]&4095](o,d);c[(ync()|0)+5836>>2]=b;do if(!(e&1)){if(!(n<<24>>24)){s=c[d>>2]|0;t=c[d+40>>2]|0;k=(c[s+4>>2]|0)>>>t;j=(c[s+8>>2]|0)>>>t;t=c[(c[o>>2]|0)+176>>2]|0;c[m>>2]=0;c[m+8>>2]=k;c[m+4>>2]=0;c[m+12>>2]=j;In[t&4095](o,m);u=c[(c[o>>2]|0)+28>>2]|0;break}t=n8b()|0;j=c[t>>2]|0;do if(j){c[h>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(g,k,h);s=c[g>>2]|0;r=c[k+28>>2]|0;if((s|0)==-1){v=r+(c[k+32>>2]<<3)|0;break}else{v=r+(s<<3)|0;break}}else v=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((v|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[v+4>>2]|0,(k|0)!=0):0)w=k;else q=18}else q=18;if((q|0)==18){k=hQb(c[t>>2]|0)|0;if(!k){q=19;break}else w=k}k=H0b(w)|0;s=n8b()|0;if(k){k=s+72|0;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2]}else{x=s;q=21}}else q=19;while(0);if((q|0)==19){x=n8b()|0;q=21}if((q|0)==21)n1b(l,x+56|0);i1b(o,l);In[c[(c[o>>2]|0)+176>>2]&4095](o,l);q=25}else q=25;while(0);if((q|0)==25){q=c[(c[o>>2]|0)+28>>2]|0;if(!(n<<24>>24))u=q;else{In[q&4095](o,0);i=f;return 1}}if((b|0)!=0?(a[b+134>>0]|0)==0:0)y=0;else y=(a[o+5984>>0]|0)==0;In[u&4095](o,y);i=f;return 1}function tBc(){var a=0,b=0;a=i;b=c[(ync()|0)+5836>>2]|0;i=a;return b|0}function uBc(e){e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im;f=i;i=i+32|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;if((a[621158]|0)==0|1==0){o=0;i=f;return o|0}p=(a[(NOc()|0)+92>>0]|0)!=0;if(!(p|(c[148116]|0)!=0)){o=0;i=f;return o|0}p=e+140|0;if(c[p>>2]|0){o=1;i=f;return o|0}q=e+148|0;if(c[q>>2]|0){o=1;i=f;return o|0}r=ync()|0;s=e+100|0;t=c[s>>2]|0;if((t|0)<1)if(!e)u=0;else v=8;else{w=e+104|0;x=c[w>>2]|0;if((x|0)<1)v=8;else{y=e+124|0;do if((c[y>>2]|0)==4){if((t+-1&t|0)==0?(x+-1&x|0)==0&(t|0)==(x|0):0)break;if(!e)z=0;else z=c[e+4>>2]|0;Krd(592544,0,3653512,248,1,z,0,0);o=0;i=f;return o|0}while(0);z=e+116|0;A=e+120|0;a:do if(!(Bn[c[(c[r>>2]|0)+444>>2]&255](r,t,x,c[z>>2]|0,c[A>>2]|0)|0)){B=c[s>>2]|0;if((B+-1&B|0)==0?(C=c[w>>2]|0,(C+-1&C|0)==0):0){if((c[155258]|0)>=4){D=B;B=C;while(1){C=(D|0)/2|0;E=(C|0)<4?4:C;c[s>>2]=E;C=(B|0)/2|0;F=(C|0)<4?4:C;c[w>>2]=F;if(Bn[c[(c[r>>2]|0)+444>>2]&255](r,E,F,c[z>>2]|0,c[A>>2]|0)|0)break a;D=c[s>>2]|0;B=c[w>>2]|0}}if(!e)G=0;else G=c[e+4>>2]|0;Krd(592632,0,3653512,258,1,G,0,0);o=0;i=f;return o|0}if(!e)I=0;else I=c[e+4>>2]|0;Krd(592696,0,3653512,272,1,I,0,0);o=0;i=f;return o|0}while(0);I=c[z>>2]|0;if(!(a[621118+I>>0]|0)){if(!e)J=0;else J=c[e+4>>2]|0;Krd(592760,0,3653512,279,1,J,0,0);o=0;i=f;return o|0}J=c[s>>2]|0;if(!(J+-1&J)){J=c[w>>2]|0;K=(J+-1&J|0)!=0}else K=1;if((c[155287]|0)==0&K){if(!e)L=0;else L=c[e+4>>2]|0;Krd(592816,0,3653512,285,1,L,0,0);o=0;i=f;return o|0}L=c[y>>2]|0;do if((L|0)==4){if(!(a[621159]|0))if(!e)M=0;else v=42;else if(_Fc(I)|0)v=42;else{N=c[y>>2]|0;break}if((v|0)==42)M=c[e+4>>2]|0;Krd(592888,0,3653512,291,1,M,0,0);o=0;i=f;return o|0}else N=L;while(0);if((N|0)==3?(a[621142]|0)==0|(a[621160]|0)==0:0){if(!e)O=0;else O=c[e+4>>2]|0;Krd(592944,0,3653512,297,1,O,0,0);o=0;i=f;return o|0}O=(a[621057]|0)!=0&(a[e+128>>0]|0)!=0;if((N|0)==4)P=(a[621191]|0)==0&O;else P=O;O=c[s>>2]|0;if(!(O+-1&O)){L=c[w>>2]|0;Q=(L+-1&L|0)==0}else Q=0;L=c[e+108>>2]|0;if((L|0)<1)R=1;else R=(L|0)>8?8:L;L=e+130|0;M=b[310523]|0;I=(N|0)==2;K=I?((M&255)<<24>>24==0?1:R):1;R=(K|0)>1;J=Q&(((N|0)!=3|(a[621192]|0)==0)&P)&(R^1);P=c[z>>2]|0;Q=b[310582]|0;G=c[155291]|0;b:do if((P|0)!=1|(G&255)<<24>>24==0?(P|0)!=3|(G&16711680|0)==0:0){x=R&(M&65535)<256;t=c[e+44>>2]|0;B=x?0:t;D=x?t:0;do if(I){if(!((a[621190]|0)==0&((R|(c[A>>2]|0)==0|(Q&65535)<256)^1)))break;t=c[e+136>>2]|0;a[e+168>>0]=1;S=B;T=D;U=t;break b}while(0);a[e+168>>0]=0;S=B;T=D;U=0}else v=58;while(0);if((v|0)==58){Q=c[e+44>>2]|0;a[e+168>>0]=0;S=0;T=0;U=Q}Q=J?2:0;J=(a[e+129>>0]|0)==0?Q:Q|128;Q=(a[L>>0]|0)==0?J:J|4;J=(a[e+131>>0]|0)==0?Q:Q|16;Q=c[(c[r>>2]|0)+380>>2]|0;c[j>>2]=S;S=c[w>>2]|0;I=e+112|0;M=c[I>>2]|0;c[h+0>>2]=c[j+0>>2];c[p>>2]=cn[Q&15](r,h,O,S,K,M,N,P,J)|0;if(R&(a[621047]|0)==0){R=c[(c[r>>2]|0)+380>>2]|0;c[k>>2]=T;T=c[s>>2]|0;P=c[w>>2]|0;N=c[I>>2]|0;I=c[y>>2]|0;M=c[z>>2]|0;c[h+0>>2]=c[k+0>>2];c[e+144>>2]=cn[R&15](r,h,T,P,1,N,I,M,J)|0}J=(c[z>>2]|0)==3?8:0;z=(a[e+133>>0]|0)==0?J:J|32;J=c[A>>2]|0;if(!U)V=(J|0)==0?z|64:z;else V=z;z=c[(c[r>>2]|0)+384>>2]|0;c[l>>2]=U;U=c[s>>2]|0;A=c[w>>2]|0;M=c[y>>2]|0;c[h+0>>2]=c[l+0>>2];l=Oo[z&63](r,h,U,A,K,M,J,V)|0;c[q>>2]=l;V=e+140|0;do if(!(c[V>>2]|0))if(!e)W=0;else v=70;else{if(!l){v=70;break}J=mo[c[(c[e>>2]|0)+48>>2]&4095](e)|0;c[e+152>>2]=J;M=r+5480|0;K=M;A=_Ei(c[K>>2]|0,c[K+4>>2]|0,J|0,((J|0)<0)<<31>>31|0)|0;J=M;c[J>>2]=A;c[J+4>>2]=H;if(a[e+132>>0]|0){J=c[(c[r>>2]|0)+448>>2]|0;c[m>>2]=c[V>>2];c[h+0>>2]=c[m+0>>2];Dn[J&511](r,h,2,-4);J=c[(c[r>>2]|0)+448>>2]|0;c[n>>2]=c[q>>2];c[h+0>>2]=c[n+0>>2];Dn[J&511](r,h,2,-4)}J=c[(c[r>>2]|0)+648>>2]|0;A=c[V>>2]|0;M=mo[c[(c[e>>2]|0)+32>>2]&4095](e)|0;co[J&2047](r,A,M);M=c[(c[r>>2]|0)+648>>2]|0;A=c[q>>2]|0;J=mo[c[(c[e>>2]|0)+32>>2]&4095](e)|0;co[M&2047](r,A,J);NDc(e,d[L>>0]|0);ko[c[(c[e>>2]|0)+132>>2]&4095](e);g[e+64>>2]=ea(1.0);g[e+68>>2]=ea(1.0);KDc(e);J=c[s>>2]|0;if(!J){o=1;i=f;return o|0}A=c[w>>2]|0;if(!A){o=1;i=f;return o|0}X=ea(ea(1.0)/ea(A|0));g[e+72>>2]=ea(ea(1.0)/ea(J|0));g[e+76>>2]=X;o=1;i=f;return o|0}while(0);if((v|0)==70)W=c[e+4>>2]|0;Krd(593008,0,3653512,395,1,W,0,0);do if(!(c[p>>2]|0)){if(!(c[q>>2]|0))o=0;else break;i=f;return o|0}while(0);q=ync()|0;p=e+152|0;W=0-(c[p>>2]|0)|0;w=q+5480|0;s=w;L=_Ei(c[s>>2]|0,c[s+4>>2]|0,W|0,((W|0)<0)<<31>>31|0)|0;W=w;c[W>>2]=L;c[W+4>>2]=H;c[p>>2]=0;if(c[V>>2]|0)In[c[(c[q>>2]|0)+388>>2]&4095](q,V);V=e+144|0;if(c[V>>2]|0)In[c[(c[q>>2]|0)+388>>2]&4095](q,V);V=e+148|0;if(!(c[V>>2]|0)){o=0;i=f;return o|0}In[c[(c[q>>2]|0)+388>>2]&4095](q,V);o=0;i=f;return o|0}}if((v|0)==8)u=c[e+4>>2]|0;Krd(592472,0,3653512,242,1,u,0,0);o=0;i=f;return o|0}function vBc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;j=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;if(!(!(_Fc(c[b+116>>2]|0)|0)?(a[b+168>>0]|0)==0:0))c[b+32>>2]=0;k=b+28|0;c[f>>2]=c[b+44>>2];if((KLc()|0)==1)l=c[b+56>>2]|0;else l=0;c[e+0>>2]=c[f+0>>2];dGc(k,e,h,j,l,0);if(!(a[b+168>>0]|0)){HDc(b);i=d;return}c[g>>2]=c[b+136>>2];if((KLc()|0)==1)m=c[b+56>>2]|0;else m=0;c[e+0>>2]=c[g+0>>2];dGc(k,e,h,j,m,0);HDc(b);i=d;return}function wBc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;if((c[(ync()|0)+5836>>2]|0)==(a|0)){if(!a)d=0;else d=c[a+4>>2]|0;Krd(593040,0,3653512,464,1,d,0,0);c[(ync()|0)+5836>>2]=0}if((c[a+140>>2]|0)==0?(c[a+148>>2]|0)==0:0){i=b;return}d=ync()|0;e=a+152|0;f=0-(c[e>>2]|0)|0;g=d+5480|0;h=g;j=_Ei(c[h>>2]|0,c[h+4>>2]|0,f|0,((f|0)<0)<<31>>31|0)|0;f=g;c[f>>2]=j;c[f+4>>2]=H;c[e>>2]=0;e=a+140|0;if(c[e>>2]|0)In[c[(c[d>>2]|0)+388>>2]&4095](d,e);e=a+144|0;if(c[e>>2]|0)In[c[(c[d>>2]|0)+388>>2]&4095](d,e);e=a+148|0;if(!(c[e>>2]|0)){i=b;return}In[c[(c[d>>2]|0)+388>>2]&4095](d,e);i=b;return}function xBc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+140|0;h=a+148|0;if((c[g>>2]|0)==0?(c[h>>2]|0)==0:0){i=b;return}j=ync()|0;k=c[g>>2]|0;c[d>>2]=k;g=c[a+144>>2]|0;c[e>>2]=g;c[f>>2]=c[h>>2];if(!k)l=g;else{In[c[(c[j>>2]|0)+400>>2]&4095](j,d);l=c[e>>2]|0}if(l)In[c[(c[j>>2]|0)+400>>2]&4095](j,e);if(!(c[f>>2]|0)){i=b;return}In[c[(c[j>>2]|0)+400>>2]&4095](j,f);i=b;return}function yBc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=a+140|0;k=a+148|0;if((c[j>>2]|0)==0?(c[k>>2]|0)==0:0){i=e;return}l=ync()|0;m=c[j>>2]|0;c[f>>2]=m;j=c[a+144>>2]|0;c[g>>2]=j;c[h>>2]=c[k>>2];if(b){if(!m)n=j;else{In[c[(c[l>>2]|0)+400>>2]&4095](l,f);n=c[g>>2]|0}if(n)In[c[(c[l>>2]|0)+400>>2]&4095](l,g)}if((c[h>>2]|0)==0|d^1){i=e;return}In[c[(c[l>>2]|0)+400>>2]&4095](l,h);i=e;return}function zBc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h+12|0;k=h+8|0;l=h+4|0;m=h;if((c[b+140>>2]|0)==0?(c[b+148>>2]|0)==0:0)uBc(b)|0;n=(c[b+108>>2]|0)>1?b+144|0:b+140|0;if(!(c[n>>2]|0)){i=h;return}o=(d|0)<0;p=(o?d:0)+f|0;f=(e|0)<0;q=(f?e:0)+g|0;g=c[b+100>>2]|0;r=c[b+104>>2]|0;s=ync()|0;t=c[(c[s>>2]|0)+600>>2]|0;c[l>>2]=c[n>>2];c[m>>2]=c[b+148>>2];c[k+0>>2]=c[l+0>>2];c[j+0>>2]=c[m+0>>2];Wn[t&127](s,k,j,o?0:d,f?0:e,(p|0)>(g|0)?g:p,(q|0)>(r|0)?r:q);if(!(a[s+5568>>0]|0)){i=h;return}q=s+5324|0;c[q>>2]=(c[q>>2]|0)+1;i=h;return}function ABc(b,c){b=b|0;c=c|0;var d=0,e=0,f=Im;d=i;if(a[(ync()|0)+5984>>0]|0){i=d;return}e=b+76|0;f=ea(g[e>>2]);if(!(!(f<ea(0.0))|c^1)){g[e>>2]=ea(-f);i=d;return}if(!(f>ea(0.0))|c){i=d;return}g[e>>2]=ea(-f);i=d;return}function BBc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];yDc(b,g,e);c[b>>2]=593120;c[b+116>>2]=0;c[b+120>>2]=2;c[b+124>>2]=2;a[b+128>>0]=0;a[b+129>>0]=1;e=b+130|0;a[e>>0]=0;a[e+1>>0]=0;a[e+2>>0]=0;a[e+3>>0]=0;a[b+134>>0]=1;e=b+136|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[b+164>>2]=b;c[b+100>>2]=256;c[b+104>>2]=256;c[b+112>>2]=1;c[b+108>>2]=1;c[b+40>>2]=1;g=Cnc()|0;c[e>>2]=mo[c[(c[g>>2]|0)+452>>2]&4095](g)|0;a[b+168>>0]=0;i=f;return}function CBc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;wBc(a);d=a+156|0;e=c[d>>2]|0;if(e){f=a+160|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}f=c[148593]|0;if(!f){ADc(a);i=b;return}d=c[a+136>>2]|0;e=594372|0;g=f;a:while(1){h=g;while(1){if((c[h+16>>2]|0)>>>0>=d>>>0){j=h;break}h=c[h+4>>2]|0;if(!h){k=e;break a}}g=c[j>>2]|0;if(!g){k=j;break}else e=j}if((k|0)==(594372|0)){ADc(a);i=b;return}if(d>>>0<(c[k+16>>2]|0)>>>0){ADc(a);i=b;return}d=c[k+4>>2]|0;if(!d){j=k;while(1){e=c[j+8>>2]|0;if((c[e>>2]|0)==(j|0)){l=e;break}else j=e}}else{j=d;while(1){d=c[j>>2]|0;if(!d){l=j;break}else j=d}}if((c[148592]|0)==(k|0))c[148592]=l;c[148594]=(c[148594]|0)+-1;tYb(f,k);ACi(k);ADc(a);i=b;return}function DBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+124|0;if((c[e>>2]|0)==(b|0)){i=d;return}if(!(c[a+140>>2]|0))if(!(c[a+148>>2]|0)){c[e>>2]=b;i=d;return}else f=6;else if(!a)g=0;else f=6;if((f|0)==6)g=c[a+4>>2]|0;Krd(593264,0,3653512,602,1,g,0,0);i=d;return}function EBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+108|0;if((c[e>>2]|0)==(b|0)){i=d;return}if(b+-1&(b|-8)){if(!a)f=0;else f=c[a+4>>2]|0;Krd(593336,0,3653512,623,1,f,0,0);i=d;return}if((c[a+140>>2]|0)==0?(c[a+148>>2]|0)==0:0){c[e>>2]=b;i=d;return}Krd(593392,0,3653512,630,1,c[a+4>>2]|0,0,0);i=d;return}function FBc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[b+124>>2]|0;h=(a[621057]|0)!=0&e;if((g|0)==4)j=(a[621191]|0)==0&h;else j=h;h=((g|0)!=3|(a[621192]|0)==0)&j;j=b+128|0;if((h&1|0)==(d[j>>0]|0)){i=f;return}if(!(c[b+140>>2]|0))if(!(c[b+148>>2]|0)){a[j>>0]=h&1;i=f;return}else k=8;else if(!b)l=0;else k=8;if((k|0)==8)l=c[b+4>>2]|0;Krd(593472,0,3653512,644,1,l,0,0);i=f;return}function GBc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=b+129|0;if((e&1|0)==(d[g>>0]|0)){i=f;return}if((c[b+140>>2]|0)==0?(c[b+148>>2]|0)==0:0){if((a[b+128>>0]|0)!=0?!((c[b+120>>2]|0)==0|e):0){if(!b)h=0;else h=c[b+4>>2]|0;Krd(593536,0,3653512,657,512,h,0,0);j=1}else j=e;a[g>>0]=j&1;i=f;return}if(!b)k=0;else k=c[b+4>>2]|0;Krd(593616,0,3653512,663,1,k,0,0);i=f;return}function HBc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((c[b+140>>2]|0)==0?(c[b+148>>2]|0)==0:0){if(d?(KLc()|0)==1:0){d=c[b+116>>2]|0;f=ync()|0;g=(d|0)!=(mo[c[(c[f>>2]|0)+672>>2]&4095](f)|0)&1}else g=0;a[b+130>>0]=g;i=e;return}Krd(593680,0,3653512,673,1,c[b+4>>2]|0,0,0);i=e;return}function IBc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im;d=i;e=b+100|0;f=c[e>>2]|0;c[e>>2]=(f|0)>1?f:1;f=b+104|0;h=c[f>>2]|0;c[f>>2]=(h|0)>1?h:1;h=b+112|0;j=c[h>>2]|0;c[h>>2]=(j|0)>1?j:1;j=b+108|0;h=c[j>>2]|0;if((h|0)<1)k=1;else k=(h|0)>8?8:h;c[j>>2]=k;k=b+116|0;if(_Fc(c[k>>2]|0)|0)a[b+128>>0]=0;j=c[e>>2]|0;if((c[b+124>>2]|0)==4)c[f>>2]=j;if(!((j+-1&j|0)==0?(j=c[f>>2]|0,(j+-1&j|0)==0):0))l=9;if((l|0)==9?(l=b+40|0,(c[l>>2]|0)==0):0)c[l>>2]=1;if(_Fc(c[k>>2]|0)|0)c[b+40>>2]=1;k=b+156|0;if((k|0)!=592456){l=c[k>>2]|0;j=b+160|0;if(l){c[l+4>>2]=c[j>>2];c[c[j>>2]>>2]=l;c[k>>2]=0;c[j>>2]=0}l=c[148114]|0;c[k>>2]=l;c[j>>2]=592456;c[l+4>>2]=k;c[c[j>>2]>>2]=k}g[b+64>>2]=ea(1.0);g[b+68>>2]=ea(1.0);KDc(b);k=c[e>>2]|0;if(!k){i=d;return}e=c[f>>2]|0;if(!e){i=d;return}m=ea(ea(1.0)/ea(e|0));g[b+72>>2]=ea(ea(1.0)/ea(k|0));g[b+76>>2]=m;i=d;return}function JBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im;d=i;if((c[a+140>>2]|0)==0?(c[a+148>>2]|0)==0:0){e=a+100|0;c[e>>2]=b;g[a+64>>2]=ea(1.0);g[a+68>>2]=ea(1.0);KDc(a);b=c[e>>2]|0;if(!b){i=d;return}e=c[a+104>>2]|0;if(!e){i=d;return}f=ea(ea(1.0)/ea(e|0));g[a+72>>2]=ea(ea(1.0)/ea(b|0));g[a+76>>2]=f;i=d;return}Krd(593736,0,3653512,725,1,c[a+4>>2]|0,0,0);i=d;return}function KBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im;d=i;if((c[a+140>>2]|0)==0?(c[a+148>>2]|0)==0:0){e=a+104|0;c[e>>2]=b;g[a+64>>2]=ea(1.0);g[a+68>>2]=ea(1.0);KDc(a);b=c[a+100>>2]|0;if(!b){i=d;return}f=c[e>>2]|0;if(!f){i=d;return}h=ea(ea(1.0)/ea(f|0));g[a+72>>2]=ea(ea(1.0)/ea(b|0));g[a+76>>2]=h;i=d;return}Krd(593736,0,3653512,735,1,c[a+4>>2]|0,0,0);i=d;return}function LBc(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[a+140>>2]|0)==0?(c[a+148>>2]|0)==0:0)if(b>>>0>2){Krd(593784,0,3653512,744,1,0,0,0);i=d;return}else{c[a+120>>2]=b;i=d;return}Krd(593816,0,3653512,750,1,c[a+4>>2]|0,0,0);i=d;return}function MBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((c[a+140>>2]|0)==0?(c[a+148>>2]|0)==0:0){if((b|0)==7){e=ync()|0;f=mo[c[(c[e>>2]|0)+668>>2]&4095](e)|0}else f=b;if(f>>>0>21){Krd(593880,0,3653512,762,1,0,0,0);i=d;return}c[a+116>>2]=f;if(!(_Fc(f)|0)){i=d;return}c[a+32>>2]=0;i=d;return}Krd(593912,0,3653512,769,1,c[a+4>>2]|0,0,0);i=d;return}function NBc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=qud((c[158074]|0)+20|0,b,a)|0;ixd(e,ea(1.0),ea(1.0));jxd(e,ea(0.0),ea(0.0));i=d;return e|0}function OBc(){var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;if(!((a[621158]|0)==0|1==0))NOc()|0;g=ync()|0;c[e>>2]=mo[c[(c[g>>2]|0)+428>>2]&4095](g)|0;g=ync()|0;c[f>>2]=mo[c[(c[g>>2]|0)+432>>2]&4095](g)|0;c[d+0>>2]=c[f+0>>2];qBc(1,e,d,0,0,-1,0)|0;d=c[148115]|0;if((d|0)==592456){i=b;return}else h=d;do{wBc(c[h+8>>2]|0);h=c[h+4>>2]|0}while((h|0)!=592456);i=b;return}function PBc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;l=c[155291]|0;if((f|0)!=1|(l&255)<<24>>24==0?(f|0)!=3|(l&16711680|0)==0:0)m=c[593976+(f<<2)>>2]|0;else m=0;f=da(d,b)|0;b=da(m,f)|0;if((h|0)==4)n=b*6|0;else if((h|0)==3)n=da(b,e)|0;else n=b;if((a[621057]|0)==0|j^1)o=n;else o=((n|0)/3|0)+n|0;n=(da(c[594064+(g<<2)>>2]|0,f)|0)+o|0;i=k;return n|0}function QBc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=c[b+100>>2]|0;f=c[b+104>>2]|0;g=c[b+112>>2]|0;h=c[b+116>>2]|0;j=c[b+120>>2]|0;k=c[b+124>>2]|0;l=a[b+128>>0]|0;m=c[155291]|0;if((h|0)!=1|(m&255)<<24>>24==0?(h|0)!=3|(m&16711680|0)==0:0)n=c[593976+(h<<2)>>2]|0;else n=0;h=da(f,e)|0;e=da(n,h)|0;if((k|0)==4)o=e*6|0;else if((k|0)==3)o=da(e,g)|0;else o=e;if((a[621057]|0)==0|l<<24>>24==0){p=o;q=594064+(j<<2)|0;r=c[q>>2]|0;s=da(r,h)|0;t=s+p|0;u=b+108|0;v=c[u>>2]|0;w=da(t,v)|0;i=d;return w|0}p=((o|0)/3|0)+o|0;q=594064+(j<<2)|0;r=c[q>>2]|0;s=da(r,h)|0;t=s+p|0;u=b+108|0;v=c[u>>2]|0;w=da(t,v)|0;i=d;return w|0}function RBc(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+128>>0]|0)){e=1;i=d;return e|0}e=cwc(c[b+100>>2]|0,c[b+104>>2]|0,1)|0;i=d;return e|0}function SBc(){var a=0;a=i;QQb(84,141,0,0,0);i=a;return}function TBc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(27)|0))UDc();rri(b,2362368,13);wQb(84,27,b,172,2623,0,0);xri(b);i=a;return}function UBc(a){a=a|0;return 84}function VBc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2362368,a,0);aCc(a,b);bdd(b);i=c;return}function WBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2362368,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else bCc(a,b);sdd(b);i=d;return}function XBc(a,b){a=a|0;b=b|0;var c=0;c=i;cCc(a,b);i=c;return}function YBc(a,b){a=a|0;b=b|0;var c=0;c=i;dCc(a,b);i=c;return}function ZBc(a,b){a=a|0;b=b|0;var c=0;c=i;eCc(a,b);i=c;return}function _Bc(a,b){a=a|0;b=b|0;var c=0;c=i;fEc(a,b);i=c;return}function $Bc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(172,f,1,16,3653512,41)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];yDc(h,f,d);c[h>>2]=593120;c[h+116>>2]=0;c[h+120>>2]=2;c[h+124>>2]=2;a[h+128>>0]=0;a[h+129>>0]=1;d=h+130|0;a[d>>0]=0;a[d+1>>0]=0;a[d+2>>0]=0;a[d+3>>0]=0;a[h+134>>0]=1;d=h+136|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[h+164>>2]=h;c[h+100>>2]=256;c[h+104>>2]=256;c[h+112>>2]=1;c[h+108>>2]=1;c[h+40>>2]=1;f=Cnc()|0;c[d>>2]=mo[c[(c[f>>2]|0)+452>>2]&4095](f)|0;a[h+168>>0]=0;i=e;return h|0}function aCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;aEc(a,b);e=c[142270]|0;add(b,2356976,e,a+100|0,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2357176,e,a+104|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,594080,e,a+108|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,594096,e,a+120|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,594112,e,a+116|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142258]|0;add(b,595976,e,a+128|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,594128,e,a+129|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,594144,e,a+130|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);g=a+28|0;add(b,596008,596048,g,0);sCc(g,b);bdd(b);i=d;return}function bCc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;bEc(b,d);g=b+100|0;h=c[142270]|0;j=qdd(d,2356976,h,f,0)|0;if(j){if((j|0)>0){j=d+12|0;k=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){c[g>>2]=c[m>>2];c[j>>2]=n}else Bid(j,g,4);if(c[d>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](g,d)|0}sdd(d)}g=b+104|0;j=qdd(d,2357176,h,f,0)|0;if(j){if((j|0)>0){j=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+m|0;c[j>>2]=l;if((m|0)>=0?(k=n+(m+4)|0,k>>>0<=(c[d+20>>2]|0)>>>0):0){c[g>>2]=c[l>>2];c[j>>2]=k}else Bid(j,g,4);if(c[d>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](g,d)|0}sdd(d)}g=b+108|0;j=qdd(d,594080,h,f,0)|0;if(j){if((j|0)>0){j=d+12|0;k=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){c[g>>2]=c[m>>2];c[j>>2]=n}else Bid(j,g,4);if(c[d>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](g,d)|0}sdd(d)}g=b+120|0;j=qdd(d,594096,h,f,0)|0;if(j){if((j|0)>0){j=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+m|0;c[j>>2]=l;if((m|0)>=0?(k=n+(m+4)|0,k>>>0<=(c[d+20>>2]|0)>>>0):0){c[g>>2]=c[l>>2];c[j>>2]=k}else Bid(j,g,4);if(c[d>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](g,d)|0}sdd(d)}g=b+116|0;j=qdd(d,594112,h,f,0)|0;if(j){if((j|0)>0){j=d+12|0;h=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=h+k|0;c[j>>2]=l;if((k|0)>=0?(m=h+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[g>>2]=c[l>>2];c[j>>2]=m}else Bid(j,g,4);if(c[d>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](g,d)|0}sdd(d)}g=b+128|0;j=c[142258]|0;m=qdd(d,595976,j,f,0)|0;if(m){do if((m|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](g,d)|0}else{l=d+12|0;k=c[d+16>>2]|0;h=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=k+h|0;c[l>>2]=n;if((h|0)>=0?(k+(h+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[n>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,g,1)}while(0);sdd(d)}g=b+129|0;m=qdd(d,594128,j,f,0)|0;if(m){do if((m|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](g,d)|0}else{l=d+12|0;n=c[d+16>>2]|0;h=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=n+h|0;c[l>>2]=k;if((h|0)>=0?(n+(h+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[k>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,g,1)}while(0);sdd(d)}g=b+130|0;m=qdd(d,594144,j,f,0)|0;if(m){do if((m|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](g,d)|0}else{j=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;h=l+k|0;c[j>>2]=h;if((k|0)>=0?(l+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,g,1)}while(0);sdd(d)}g=b+28|0;b=qdd(d,596008,596048,f,1)|0;if(!b){i=e;return}if((b|0)<=0){b=c[f>>2]|0;if(b)_n[b&4095](g,d)|0}else tCc(g,d);sdd(d);i=e;return}function cCc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;cEc(b,d);f=b+100|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,f,4);m=c[g>>2]|0;n=c[k>>2]|0}else{c[f>>2]=c[h>>2];c[g>>2]=j;m=j;n=l}l=b+104|0;j=m+4|0;if(j>>>0>n>>>0){Bid(g,l,4);o=c[g>>2]|0;p=c[k>>2]|0}else{c[l>>2]=c[m>>2];c[g>>2]=j;o=j;p=n}n=b+108|0;j=o+4|0;if(j>>>0>p>>>0){Bid(g,n,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[n>>2]=c[o>>2];c[g>>2]=j;q=j;r=p}p=b+120|0;j=q+4|0;if(j>>>0>r>>>0){Bid(g,p,4);s=c[g>>2]|0;t=c[k>>2]|0}else{c[p>>2]=c[q>>2];c[g>>2]=j;s=j;t=r}r=b+116|0;j=s+4|0;if(j>>>0>t>>>0){Bid(g,r,4);u=c[g>>2]|0;v=c[k>>2]|0}else{c[r>>2]=c[s>>2];c[g>>2]=j;u=j;v=t}t=b+128|0;if((u+1|0)>>>0>v>>>0){Bid(g,t,1);w=c[g>>2]|0}else{a[t>>0]=a[u>>0]|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;w=u}u=b+129|0;if((w+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,u,1);x=c[g>>2]|0}else{a[u>>0]=a[w>>0]|0;w=(c[g>>2]|0)+1|0;c[g>>2]=w;x=w}w=b+130|0;if((x+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,w,1);Ndd(d);y=b+28|0;uCc(y,d);i=e;return}else{a[w>>0]=a[x>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Ndd(d);y=b+28|0;uCc(y,d);i=e;return}}function dCc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;dEc(b,d);f=b+100|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,f,4);m=c[g>>2]|0;n=c[k>>2]|0;o=c[f>>2]|0}else{p=c[h>>2]|0;c[f>>2]=p;c[g>>2]=j;m=j;n=l;o=p}c[f>>2]=XEi(o|0)|0;o=b+104|0;f=m+4|0;if(f>>>0>n>>>0){Bid(g,o,4);q=c[o>>2]|0;r=c[g>>2]|0;s=c[k>>2]|0}else{p=c[m>>2]|0;c[o>>2]=p;c[g>>2]=f;q=p;r=f;s=n}c[o>>2]=XEi(q|0)|0;q=b+108|0;o=r+4|0;if(o>>>0>s>>>0){Bid(g,q,4);t=c[q>>2]|0;u=c[g>>2]|0;v=c[k>>2]|0}else{n=c[r>>2]|0;c[q>>2]=n;c[g>>2]=o;t=n;u=o;v=s}c[q>>2]=XEi(t|0)|0;t=b+120|0;q=u+4|0;if(q>>>0>v>>>0){Bid(g,t,4);w=c[t>>2]|0;x=c[g>>2]|0;y=c[k>>2]|0}else{s=c[u>>2]|0;c[t>>2]=s;c[g>>2]=q;w=s;x=q;y=v}c[t>>2]=XEi(w|0)|0;w=b+116|0;t=x+4|0;if(t>>>0>y>>>0){Bid(g,w,4);z=c[w>>2]|0;A=c[g>>2]|0;B=c[k>>2]|0}else{v=c[x>>2]|0;c[w>>2]=v;c[g>>2]=t;z=v;A=t;B=y}c[w>>2]=XEi(z|0)|0;z=b+128|0;if((A+1|0)>>>0>B>>>0){Bid(g,z,1);C=c[g>>2]|0}else{a[z>>0]=a[A>>0]|0;A=(c[g>>2]|0)+1|0;c[g>>2]=A;C=A}A=b+129|0;if((C+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,A,1);D=c[g>>2]|0}else{a[A>>0]=a[C>>0]|0;C=(c[g>>2]|0)+1|0;c[g>>2]=C;D=C}C=b+130|0;if((D+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,C,1);Mdd(d);E=b+28|0;vCc(E,d);i=e;return}else{a[C>>0]=a[D>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Mdd(d);E=b+28|0;vCc(E,d);i=e;return}}function eCc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;eEc(b,d);f=b+100|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[f>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,f,4);m=c[g>>2]|0;n=c[k>>2]|0}f=b+104|0;l=m+4|0;if(l>>>0<n>>>0){c[m>>2]=c[f>>2];c[g>>2]=l;o=l;p=n}else{Gid(g,f,4);o=c[g>>2]|0;p=c[k>>2]|0}f=b+108|0;n=o+4|0;if(n>>>0<p>>>0){c[o>>2]=c[f>>2];c[g>>2]=n;q=n;r=p}else{Gid(g,f,4);q=c[g>>2]|0;r=c[k>>2]|0}f=b+120|0;p=q+4|0;if(p>>>0<r>>>0){c[q>>2]=c[f>>2];c[g>>2]=p;s=p;t=r}else{Gid(g,f,4);s=c[g>>2]|0;t=c[k>>2]|0}f=b+116|0;r=s+4|0;if(r>>>0<t>>>0){c[s>>2]=c[f>>2];c[g>>2]=r;u=r;v=t}else{Gid(g,f,4);u=c[g>>2]|0;v=c[k>>2]|0}f=b+128|0;if((u+1|0)>>>0<v>>>0){a[u>>0]=a[f>>0]|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;w=u}else{Gid(g,f,1);w=c[g>>2]|0}f=b+129|0;if((w+1|0)>>>0<(c[k>>2]|0)>>>0){a[w>>0]=a[f>>0]|0;w=(c[g>>2]|0)+1|0;c[g>>2]=w;x=w}else{Gid(g,f,1);x=c[g>>2]|0}f=b+130|0;if((x+1|0)>>>0<(c[k>>2]|0)>>>0){a[x>>0]=a[f>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Tdd(d);y=b+28|0;wCc(y,d);i=e;return}else{Gid(g,f,1);Tdd(d);y=b+28|0;wCc(y,d);i=e;return}}function fCc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=593120;f=znc()|0;g=c[(c[f>>2]|0)+456>>2]|0;c[e>>2]=c[a+136>>2];c[d+0>>2]=c[e+0>>2];In[g&4095](f,d);Cuc(a);i=b;return}function gCc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=593120;f=znc()|0;g=c[(c[f>>2]|0)+456>>2]|0;c[e>>2]=c[a+136>>2];c[d+0>>2]=c[e+0>>2];In[g&4095](f,d);Cuc(a);ACi(a);i=b;return}function hCc(a){a=a|0;return c[a+124>>2]|0}function iCc(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function jCc(a){a=a|0;return c[a+44>>2]|0}function kCc(a){a=a|0;return c[a+100>>2]|0}function lCc(a){a=a|0;return c[a+104>>2]|0}function mCc(a){a=a|0;return 0}function nCc(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+104>>2]&4095](a)|0;i=b;return d|0}function oCc(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+108>>2]&4095](a)|0;i=b;return d|0}function pCc(b){b=b|0;return (a[b+128>>0]|0)!=0|0}function qCc(a,b){a=a|0;b=b|0;return}function rCc(a){a=a|0;return}function sCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142270]|0;add(b,594152,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,594168,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,594176,c[142268]|0,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,594192,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function tCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142270]|0;h=qdd(b,594152,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,594168,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[h>>2]=c[j>>2];c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,594176,c[142268]|0,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;a=qdd(b,594192,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function uCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}else{c[a>>2]=c[f>>2];c[e>>2]=h;k=b;l=h}h=a+4|0;b=l+4|0;if(b>>>0>k>>>0){Bid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}else{c[h>>2]=c[l>>2];c[e>>2]=b;m=b;n=k}k=a+8|0;b=m+4|0;if(b>>>0>n>>>0){Bid(e,k,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[e>>2]=b;o=b;p=n}n=a+12|0;a=o+4|0;if(a>>>0>p>>>0){Bid(e,n,4);i=d;return}else{c[n>>2]=c[o>>2];c[e>>2]=a;i=d;return}}function vCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=c[e>>2]|0;m=c[j>>2]|0;n=c[a>>2]|0}else{o=c[f>>2]|0;c[a>>2]=o;c[e>>2]=h;l=h;m=b;n=o}c[a>>2]=XEi(n|0)|0;n=a+4|0;o=l+4|0;if(o>>>0>m>>>0){Bid(e,n,4);p=c[n>>2]|0;q=c[e>>2]|0;r=c[j>>2]|0}else{b=c[l>>2]|0;c[n>>2]=b;c[e>>2]=o;p=b;q=o;r=m}c[n>>2]=XEi(p|0)|0;p=a+8|0;n=q+4|0;if(n>>>0>r>>>0){Bid(e,p,4);s=p;t=c[p>>2]|0;u=c[e>>2]|0;v=c[j>>2]|0}else{w=ea(g[q>>2]);g[p>>2]=w;c[e>>2]=n;s=p;t=(g[k>>2]=w,c[k>>2]|0);u=n;v=r}c[s>>2]=XEi(t|0)|0;t=a+12|0;a=u+4|0;if(a>>>0>v>>>0){Bid(e,t,4);x=c[t>>2]|0;y=XEi(x|0)|0;c[t>>2]=y;i=d;return}else{v=c[u>>2]|0;c[t>>2]=v;c[e>>2]=a;x=v;y=XEi(x|0)|0;c[t>>2]=y;i=d;return}}function wCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){c[f>>2]=c[a>>2];c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){c[l>>2]=c[h>>2];c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}j=a+12|0;a=o+4|0;if(a>>>0<p>>>0){c[o>>2]=c[j>>2];c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function xCc(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+16|0;k=j;a[k+3>>0]=0;a[k+2>>0]=-1;a[k+1>>0]=-1;a[k>>0]=-1;l=c[k>>2]|0;if((e|0)<=0){i=j;return}m=d<<2;if((d|0)>0)n=0;else{o=0;do o=o+1|0;while((o|0)!=(e|0));i=j;return}do{o=da(n,f)|0;p=g+((da(m,n)|0)<<2)|0;q=0;while(1){r=p+8|0;ACc(r,k);s=h+(q+o<<2<<2)|0;BCc(s,r,f,k);r=s;s=0;while(1){t=b[p+(s<<1)>>1]|0;u=t&65535;c[r>>2]=(u&15|u<<4)<<24|c[r>>2]&l;u=r+4|0;v=(t&65535)>>>4&65535;c[u>>2]=(v&15|v<<4)<<24|c[u>>2]&l;u=r+8|0;v=(t&65535)>>>8&65535;c[u>>2]=(v&15|v<<4)<<24|c[u>>2]&l;u=r+12|0;v=(t&65535)>>>12&65535;c[u>>2]=c[u>>2]&l|(v<<4|v)<<24;s=s+1|0;if((s|0)==4)break;else r=r+(f<<2)|0}q=q+1|0;if((q|0)==(d|0))break;else p=p+16|0}n=n+1|0}while((n|0)!=(e|0));i=j;return}function yCc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;d=i;j=zCc(a,b,c,e,f,g,h)|0;i=d;return j|0}function zCc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+32|0;l=k+16|0;m=k;n=(d+3|0)/4|0;o=(e+3|0)/4|0;switch(b|0){case 10:{if((e|0)<=0){p=1;i=k;return p|0}b=n<<1;if((d|0)>0)q=0;else{p=1;i=k;return p|0}do{r=da(q,g)|0;s=f+((da(b,q)|0)<<2)|0;t=0;while(1){ACc(s,m);BCc(j+(t+r<<2<<2)|0,s,g,m);t=t+1|0;if((t|0)==(n|0))break;else s=s+8|0}q=q+1|0}while((q|0)!=(o|0));p=1;i=k;return p|0}case 46:{jvc(j,f,d,e,g,h);p=1;i=k;return p|0}case 45:{ivc(j,f,d,e,g,h);p=1;i=k;return p|0}case 47:{kvc(j,f,d,e,g,h);p=1;i=k;return p|0}case 12:{a[l+3>>0]=0;a[l+2>>0]=-1;a[l+1>>0]=-1;a[l>>0]=-1;h=c[l>>2]|0;if((e|0)<=0){p=1;i=k;return p|0}e=n<<2;if((d|0)>0)u=0;else{p=1;i=k;return p|0}do{d=da(u,g)|0;q=f+((da(e,u)|0)<<2)|0;m=0;while(1){b=q+8|0;ACc(b,l);s=j+(m+d<<2<<2)|0;BCc(s,b,g,l);CCc(s,q,g,h);m=m+1|0;if((m|0)==(n|0))break;else q=q+16|0}u=u+1|0}while((u|0)!=(o|0));p=1;i=k;return p|0}case 11:{xCc(n,o,g,f,j);p=1;i=k;return p|0}default:{p=0;i=k;return p|0}}return 0}function ACc(c,d){c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=b[c>>1]|0;g=b[c+2>>1]|0;c=(f&65535)>>>11&65535;h=c<<3|c>>>2;a[d>>0]=h;c=(f&65535)>>>5&63;j=c<<2|c>>>4;a[d+1>>0]=j;c=f&31;k=c<<3|c>>>2;a[d+2>>0]=k;a[d+3>>0]=-1;c=(g&65535)>>>11&65535;l=c<<3|c>>>2;a[d+4>>0]=l;c=(g&65535)>>>5&63;m=c<<2|c>>>4;a[d+5>>0]=m;c=g&31;n=c<<3|c>>>2;a[d+6>>0]=n;a[d+7>>0]=-1;if((f&65535)>(g&65535)){a[d+8>>0]=((l+(h<<1)|0)>>>0)/3|0;a[d+9>>0]=(((j<<1)+m|0)>>>0)/3|0;a[d+10>>0]=(((k<<1)+n|0)>>>0)/3|0;a[d+11>>0]=-1;a[d+12>>0]=(((l<<1)+h|0)>>>0)/3|0;a[d+13>>0]=(((m<<1)+j|0)>>>0)/3|0;o=-1;p=((((n<<1)+k|0)>>>0)/3|0)&255;q=d+14|0;a[q>>0]=p;r=d+15|0;a[r>>0]=o;i=e;return}else{a[d+8>>0]=(l+h|0)>>>1;a[d+9>>0]=(m+j|0)>>>1;a[d+10>>0]=(n+k|0)>>>1;a[d+11>>0]=-1;a[d+12>>0]=0;a[d+13>>0]=0;o=0;p=0;q=d+14|0;a[q>>0]=p;r=d+15|0;a[r>>0]=o;i=e;return}}function BCc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=b+4|0;c[a>>2]=c[f+(((d[g>>0]|0)&3)<<2)>>2];c[a+4>>2]=c[f+(((d[g>>0]|0)>>>2&3)<<2)>>2];c[a+8>>2]=c[f+(((d[g>>0]|0)>>>4&3)<<2)>>2];c[a+12>>2]=c[f+((d[g>>0]|0)>>>6<<2)>>2];g=b+5|0;c[a+(e<<2)>>2]=c[f+(((d[g>>0]|0)&3)<<2)>>2];c[a+(e+1<<2)>>2]=c[f+(((d[g>>0]|0)>>>2&3)<<2)>>2];c[a+(e+2<<2)>>2]=c[f+(((d[g>>0]|0)>>>4&3)<<2)>>2];c[a+(e+3<<2)>>2]=c[f+((d[g>>0]|0)>>>6<<2)>>2];g=e<<1;h=b+6|0;c[a+(g<<2)>>2]=c[f+(((d[h>>0]|0)&3)<<2)>>2];i=g|1;c[a+(i<<2)>>2]=c[f+(((d[h>>0]|0)>>>2&3)<<2)>>2];c[a+(i+1<<2)>>2]=c[f+(((d[h>>0]|0)>>>4&3)<<2)>>2];c[a+(i+2<<2)>>2]=c[f+((d[h>>0]|0)>>>6<<2)>>2];h=e*3|0;e=b+7|0;c[a+(h<<2)>>2]=c[f+(((d[e>>0]|0)&3)<<2)>>2];c[a+(h+1<<2)>>2]=c[f+(((d[e>>0]|0)>>>2&3)<<2)>>2];c[a+(h+2<<2)>>2]=c[f+(((d[e>>0]|0)>>>4&3)<<2)>>2];c[a+(h+3<<2)>>2]=c[f+((d[e>>0]|0)>>>6<<2)>>2];return}function CCc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+80|0;j=h;k=h+64|0;l=~g;m=a[e>>0]|0;b[k>>1]=m&255;n=a[e+1>>0]|0;b[k+2>>1]=n&255;o=m&255;p=n&255;if((m&255)>(n&255)){b[k+4>>1]=((p+3+(o*6|0)|0)>>>0)/7|0;m=n&255;b[k+6>>1]=(((o*5|0)+3+(m<<1)|0)>>>0)/7|0;b[k+8>>1]=(((o<<2|3)+(m*3|0)|0)>>>0)/7|0;b[k+10>>1]=(((o*3|0)+3+(m<<2)|0)>>>0)/7|0;b[k+12>>1]=(((o<<1)+3+(m*5|0)|0)>>>0)/7|0;q=(((o+3+(m*6|0)|0)>>>0)/7|0)&65535}else{b[k+4>>1]=((p+2+(o<<2)|0)>>>0)/5|0;p=n&255;b[k+6>>1]=(((o*3|0)+2+(p<<1)|0)>>>0)/5|0;b[k+8>>1]=(((o<<1)+2+(p*3|0)|0)>>>0)/5|0;b[k+10>>1]=((o+2+(p<<2)|0)>>>0)/5|0;b[k+12>>1]=0;q=255}b[k+14>>1]=q;q=c[e+2>>2]|0;p=c[e+5>>2]|0;a[j+3>>0]=b[k+((q&7)<<1)>>1];a[j+7>>0]=b[k+((q>>>3&7)<<1)>>1];a[j+11>>0]=b[k+((q>>>6&7)<<1)>>1];a[j+15>>0]=b[k+((q>>>9&7)<<1)>>1];a[j+19>>0]=b[k+((q>>>12&7)<<1)>>1];a[j+23>>0]=b[k+((q>>>15&7)<<1)>>1];a[j+27>>0]=b[k+((q>>>18&7)<<1)>>1];a[j+31>>0]=b[k+((q>>>21&7)<<1)>>1];a[j+35>>0]=b[k+((p&7)<<1)>>1];a[j+39>>0]=b[k+((p>>>3&7)<<1)>>1];a[j+43>>0]=b[k+((p>>>6&7)<<1)>>1];a[j+47>>0]=b[k+((p>>>9&7)<<1)>>1];a[j+51>>0]=b[k+((p>>>12&7)<<1)>>1];a[j+55>>0]=b[k+((p>>>15&7)<<1)>>1];a[j+59>>0]=b[k+((p>>>18&7)<<1)>>1];a[j+63>>0]=b[k+((p>>>21&7)<<1)>>1];p=c[d>>2]&g;c[d>>2]=p;c[d>>2]=c[j>>2]&l|p;p=d+4|0;k=c[p>>2]&g;c[p>>2]=k;c[p>>2]=c[j+4>>2]&l|k;k=d+8|0;p=c[k>>2]&g;c[k>>2]=p;c[k>>2]=c[j+8>>2]&l|p;p=d+12|0;k=c[p>>2]&g;c[p>>2]=k;c[p>>2]=c[j+12>>2]&l|k;k=d+(f<<2)|0;d=c[k>>2]&g;c[k>>2]=d;c[k>>2]=c[j+16>>2]&l|d;d=k+4|0;p=c[d>>2]&g;c[d>>2]=p;c[d>>2]=c[j+20>>2]&l|p;p=k+8|0;d=c[p>>2]&g;c[p>>2]=d;c[p>>2]=c[j+24>>2]&l|d;d=k+12|0;p=c[d>>2]&g;c[d>>2]=p;c[d>>2]=c[j+28>>2]&l|p;p=k+(f<<2)|0;k=c[p>>2]&g;c[p>>2]=k;c[p>>2]=c[j+32>>2]&l|k;k=p+4|0;d=c[k>>2]&g;c[k>>2]=d;c[k>>2]=c[j+36>>2]&l|d;d=p+8|0;k=c[d>>2]&g;c[d>>2]=k;c[d>>2]=c[j+40>>2]&l|k;k=p+12|0;d=c[k>>2]&g;c[k>>2]=d;c[k>>2]=c[j+44>>2]&l|d;d=p+(f<<2)|0;f=c[d>>2]&g;c[d>>2]=f;c[d>>2]=c[j+48>>2]&l|f;f=d+4|0;p=c[f>>2]&g;c[f>>2]=p;c[f>>2]=c[j+52>>2]&l|p;p=d+8|0;f=c[p>>2]&g;c[p>>2]=f;c[p>>2]=c[j+56>>2]&l|f;f=d+12|0;d=c[f>>2]&g;c[f>>2]=d;c[f>>2]=c[j+60>>2]&l|d;i=h;return}function DCc(){var a=0,b=0;a=i;b=xCi(64)|0;Jpe(b);c[148552]=b;i=a;return}function ECc(){return c[148552]|0}function FCc(){return c[148552]|0}function GCc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;c[b>>2]=594224;e=b+4|0;c[e+0>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;c[b+20>>2]=0;e=b+24|0;f=b+26|0;g=f+10|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(g|0));a[e>>0]=1;a[b+25>>0]=1;c[b+40>>2]=1;c[b+44>>2]=0;c[b+36>>2]=0;c[b+48>>2]=0;c[b+52>>2]=0;i=d;return}function HCc(a){a=a|0;return}function ICc(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function JCc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e&1;c[a+16>>2]=f;return}function KCc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;a[b+26>>0]=d&1;d=c[b>>2]|0;f=c[d+36>>2]|0;g=mo[c[d+32>>2]&4095](b)|0;In[f&4095](b,g);i=e;return}function LCc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=a+4|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=a+16|0;if((h&f&c[j>>2]&c[k>>2]|0)==-1){l=0;i=b;return l|0}m=c[a>>2]|0;n=c[m+16>>2]|0;if((f|0)==-1){o=mo[c[m+80>>2]&4095](a)|0;p=c[g>>2]|0;q=o}else{p=h;q=f}if((p|0)==-1)r=mo[c[(c[a>>2]|0)+84>>2]&4095](a)|0;else r=p;p=c[j>>2]|0;if((p|0)==-1)s=mo[c[(c[a>>2]|0)+92>>2]&4095](a)|0;else s=(p|0)==1;p=c[k>>2]|0;if((p|0)==-1){In[c[(c[a>>2]|0)+28>>2]&4095](d,a);t=c[d+8>>2]|0}else t=p;Bn[n&255](a,q,r,s,t)|0;c[e+0>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;l=1;i=b;return l|0}function MCc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;if(!((mo[c[(c[a>>2]|0)+92>>2]&4095](a)|0)^b)){i=d;return}In[c[(c[a>>2]|0)+28>>2]&4095](e,a);Bn[c[(c[a>>2]|0)+16>>2]&255](a,c[e>>2]|0,c[e+4>>2]|0,b,c[e+8>>2]|0)|0;i=d;return}function NCc(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[b>>2]|0)+28>>2]&4095](a,b);i=d;return}function OCc(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=mo[c[(c[b>>2]|0)+80>>2]&4095](b)|0;c[a+4>>2]=mo[c[(c[b>>2]|0)+84>>2]&4095](b)|0;c[a+8>>2]=0;i=d;return}function PCc(a,b,d){a=a|0;b=ea(b);d=ea(d);c[a+28>>2]=~~ea(b+ea(.5))>>>0;c[a+32>>2]=~~ea(d+ea(.5))>>>0;return}function QCc(b,d){b=b|0;d=d|0;var e=0;e=i;a[b+25>>0]=d&1;if(d){i=e;return}In[c[(c[b>>2]|0)+44>>2]&4095](b,0);i=e;return}function RCc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(d){d=a+36|0;c[d>>2]=c[d>>2]|b;i=e;return}else{d=a+36|0;c[d>>2]=c[d>>2]&~b;i=e;return}}function SCc(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);i=a;return}function TCc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function UCc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function VCc(a){a=a|0;return 1}function WCc(a,b){a=a|0;b=b|0;return}function XCc(a){a=a|0;return 0}function YCc(a,b){a=a|0;b=b|0;return}function ZCc(a){a=a|0;return 1}function _Cc(a,b){a=a|0;b=b|0;return}function $Cc(a){a=a|0;return -1}function aDc(a,b){a=a|0;b=b|0;return}function bDc(a){a=a|0;return 1}function cDc(a,b){a=a|0;b=b|0;return}function dDc(b){b=b|0;return (a[b+26>>0]|0)!=0|0}function eDc(a){a=a|0;return c[a+28>>2]|0}function fDc(a){a=a|0;return c[a+32>>2]|0}function gDc(a){a=a|0;return ea(0.0)}function hDc(b){b=b|0;return (a[b+27>>0]|0)!=0|0}function iDc(a){a=a|0;return 0}function jDc(a){a=a|0;return 0}function kDc(a,b){a=a|0;b=b|0;c[a+44>>2]=b;return}function lDc(a){a=a|0;return c[a+40>>2]|0}function mDc(a,b){a=a|0;b=b|0;c[a+40>>2]=b;return}function nDc(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;m=i;i=i+16|0;n=m+4|0;o=m;c[b>>2]=575440;c[b+4>>2]=1;c[b>>2]=594360;p=c[d>>2]|0;d=b+8|0;c[d>>2]=0;q=b+12|0;c[q>>2]=p;p=b+16|0;c[p>>2]=0;r=b+20|0;c[r>>2]=0;c[b+24>>2]=e;c[b+28>>2]=f;c[b+32>>2]=g;c[b+36>>2]=h;c[b+40>>2]=j;a[b+44>>0]=k&1;k=(lEc(g)|0)+(da(j,h)|0)|0;if(!l){c[p>>2]=k;l=c[r>>2]|0;if((l&2147483647)>>>0>=k>>>0){i=m;return}if((l|0)>-1){c[r>>2]=k;l=c[d>>2]|0;c[o>>2]=c[q>>2];c[n+0>>2]=c[o+0>>2];c[d>>2]=hOb(l,k,1,n,0,3653512,370)|0;i=m;return}else{c[o>>2]=c[q>>2];c[n+0>>2]=c[o+0>>2];l=cOb(k,1,n,0,3653512,352)|0;YEi(l|0,c[d>>2]|0,c[p>>2]|0)|0;c[r>>2]=k;c[d>>2]=l;i=m;return}}l=c[r>>2]|0;do if((l&2147483647)>>>0<k>>>0)if((l|0)>-1){c[r>>2]=k;h=c[d>>2]|0;c[o>>2]=c[q>>2];c[n+0>>2]=c[o+0>>2];c[d>>2]=hOb(h,k,1,n,0,3653512,370)|0;break}else{c[o>>2]=c[q>>2];c[n+0>>2]=c[o+0>>2];h=cOb(k,1,n,0,3653512,352)|0;YEi(h|0,c[d>>2]|0,c[p>>2]|0)|0;c[r>>2]=k;c[d>>2]=h;break}while(0);r=c[p>>2]|0;if(r>>>0<k>>>0?(n=c[d>>2]|0,d=n+k|0,(r|0)!=(k|0)):0){o=n+r|0;do{if(o)a[o>>0]=-51;o=o+1|0}while((o|0)!=(d|0))}c[p>>2]=k;i=m;return}function oDc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f;if(!(c[a+16>>2]|0)){h=0;i=f;return h|0}j=a+32|0;k=c[j>>2]|0;switch(k|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{h=0;i=f;return h|0}default:{}}if((k+-48|0)>>>0<12){h=0;i=f;return h|0}l=da(c[a+36>>2]|0,d)|0;d=c[a+8>>2]|0;m=a+24|0;n=a+28|0;a=d+((ewc(c[m>>2]|0,c[n>>2]|0,k,e)|0)+l)|0;l=c[m>>2]>>e;m=(l|0)<1?1:l;l=c[n>>2]>>e;e=VFc(m,c[j>>2]|0)|0;iwc(g,m,(l|0)<1?1:l,e,c[j>>2]|0,a);c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];c[b+16>>2]=c[g+16>>2];h=1;i=f;return h|0}function pDc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;if(!(c[b+16>>2]|0)){i=f;return}h=b+32|0;j=c[h>>2]|0;switch(j|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{i=f;return}default:{}}if((j+-48|0)>>>0<12){i=f;return}k=da(c[b+36>>2]|0,d)|0;d=c[b+8>>2]|0;l=b+24|0;m=b+28|0;b=d+((ewc(c[l>>2]|0,c[m>>2]|0,j,e)|0)+k)|0;k=c[l>>2]>>e;l=(k|0)<1?1:k;k=c[m>>2]>>e;e=VFc(l,c[h>>2]|0)|0;iwc(g,l,(k|0)<1?1:k,e,c[h>>2]|0,b);c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[a+16>>2]=c[g+16>>2];i=f;return}function qDc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h;if(!(c[a+24>>2]|0)){i=h;return}if(!(c[a+28>>2]|0)){i=h;return}k=da(c[b+36>>2]|0,d)|0;l=b+24|0;m=b+28|0;n=b+32|0;o=(ewc(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,e)|0)+k|0;k=(c[b+8>>2]|0)+o|0;o=c[l>>2]>>e;l=(o|0)<1?1:o;o=c[m>>2]>>e;m=(o|0)<1?1:o;a:do if(f){o=c[n>>2]|0;switch(o|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((o+-48|0)>>>0>=12)break a}rDc(a,k,l,m,d);i=h;return}while(0);pDc(j,b,d,e);sDc(a,j,g,d)|0;i=h;return}function rDc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;j=b+24|0;k=b+28|0;l=mEc(c[j>>2]|0,c[k>>2]|0,e,f)|0;if(!(a[b+44>>0]|0))m=0;else m=(cwc(c[j>>2]|0,c[k>>2]|0,1)|0)+-1|0;n=(m|0)<(l|0)?m:l;l=b+32|0;m=ewc(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,n)|0;o=c[j>>2]>>n;j=c[k>>2]>>n;n=(da(c[b+36>>2]|0,g)|0)+m|0;$vc(c[l>>2]|0,(c[b+8>>2]|0)+n|0,(o|0)<1?1:o,(j|0)<1?1:j,d,e,f,1);i=h;return}function sDc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+80|0;h=g+64|0;j=g+60|0;k=g+40|0;l=g+20|0;m=g;n=b+24|0;o=b+28|0;p=mEc(c[n>>2]|0,c[o>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;if(!(a[b+44>>0]|0))q=0;else q=(cwc(c[n>>2]|0,c[o>>2]|0,1)|0)+-1|0;r=(q|0)<(p|0)?q:p;p=b+32|0;q=ewc(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,r)|0;s=c[n>>2]>>r;n=(s|0)<1?1:s;s=c[o>>2]>>r;o=(s|0)<1?1:s;s=c[p>>2]|0;switch(s|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((s+-48|0)>>>0>=12){t=da(TFc(s)|0,n)|0;s=(da(c[b+36>>2]|0,f)|0)+q|0;iwc(m,n,o,t,c[p>>2]|0,(c[b+8>>2]|0)+s|0);if(e){hwc(d,m,2);u=1;i=g;return u|0}else{hwc(d,m,0);bwc(d,n,o);u=1;i=g;return u|0}}}m=((n+3|0)/4|0)<<2;s=((o+3|0)/4|0)<<2;mwc(k,m,s,4);t=(da(c[b+36>>2]|0,f)|0)+q|0;q=k+16|0;do if(yCc(c[p>>2]|0,n,o,r,(c[b+8>>2]|0)+t|0,m,s,c[q>>2]|0)|0){lwc(l,k,0,0,n,o);if(e){hwc(d,l,2);v=1;break}else{hwc(d,l,0);bwc(d,n,o);v=1;break}}else v=0;while(0);o=c[q>>2]|0;c[j>>2]=c[153068];c[h+0>>2]=c[j+0>>2];eOb(o,h);u=v;i=g;return u|0}function tDc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=594360;if((c[a+20>>2]|0)<=-1){i=b;return}f=a+8|0;g=c[f>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function uDc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=594360;if((c[a+20>>2]|0)<=-1){ACi(a);i=b;return}f=c[a+8>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);ACi(a);i=b;return}function vDc(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;e=ea(g[b+36>>2]);f=ea(g[b+144>>2]);h=ea(ea(e/f)*ea(.5));e=ea(ea(ea(g[b+40>>2])/f)*ea(.5));i=ea(ea(g[b+44>>2])/f);j=ea(ea(g[b+48>>2])/f);f=ea(g[150280]);k=ea(g[150281]);l=ea(g[150282]);m=ea(-f);n=ea(-k);o=ea(-l);p=ea(ea(-h)-i);q=ea(g[d>>2]);r=ea(p+q);p=ea(e-j);s=ea(g[d+4>>2]);t=ea(p+s);p=ea(ea(h-i)+q);q=ea(ea(ea(-e)-j)+s);s=r<f?r:f;f=t<k?t:k;d=l>ea(.100000001);k=d?ea(.100000001):l;j=r>m?r:m;m=t>n?t:n;d=l>ea(-.100000001);l=d?ea(.100000001):o;o=p<s?p:s;s=q<f?q:f;d=k>ea(-.100000001);f=d?ea(-.100000001):k;k=j<p?p:j;j=m<q?q:m;d=l<ea(-.100000001);m=d?ea(-.100000001):l;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;l=ea(ea(j+s)*ea(.5));q=ea(ea(m+f)*ea(.5));g[a>>2]=ea(ea(k+o)*ea(.5));g[a+4>>2]=l;g[a+8>>2]=q;q=ea(ea(j-s)*ea(.5));s=ea(ea(m-f)*ea(.5));g[a+12>>2]=ea(ea(k-o)*ea(.5));g[a+16>>2]=q;g[a+20>>2]=s;return}function wDc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;BQb(213,f,1)|0;h=c[g>>2]|0;j=c[f>>2]|0;if((h|0)==(j|0)){k=h;l=h}else{h=j;j=0;while(1){m=c[h+(j<<2)>>2]|0;c[e>>2]=m;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,e);o=c[d>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[q+4>>2]|0,(n|0)!=0):0)r=n;else s=11}else s=11;if((s|0)==11){s=0;r=hQb(m)|0}a[r+140>>0]=1;j=j+1|0;n=c[g>>2]|0;o=c[f>>2]|0;if(j>>>0>=n-o>>2>>>0){k=o;l=n;break}else h=o}}if(!k){i=b;return}if((l|0)!=(k|0))c[g>>2]=l+(~((l+-4-k|0)>>>2)<<2);ACi(k);i=b;return}function xDc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;h=e;j=qdd(a,d,c[142280]|0,h,1)|0;if(!j){i=e;return}if((j|0)>0){rdd(a,2);j=c[142268]|0;d=qdd(a,3143216,j,f,0)|0;if(d){if((d|0)>0){d=a+12|0;k=c[a+16>>2]|0;l=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;m=k+l|0;c[d>>2]=m;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[a+20>>2]|0)>>>0):0){g[b>>2]=ea(g[m>>2]);c[d>>2]=n}else Bid(d,b,4);if(c[a>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{d=c[f>>2]|0;if(d)_n[d&4095](b,a)|0}sdd(a)}d=b+4|0;n=qdd(a,3143224,j,f,0)|0;if(n){if((n|0)>0){n=a+12|0;m=c[a+16>>2]|0;l=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;k=m+l|0;c[n>>2]=k;if((l|0)>=0?(o=m+(l+4)|0,o>>>0<=(c[a+20>>2]|0)>>>0):0){g[d>>2]=ea(g[k>>2]);c[n>>2]=o}else Bid(n,d,4);if(c[a>>2]&512)c[d>>2]=XEi(c[d>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](d,a)|0}sdd(a)}d=b+8|0;n=qdd(a,2684928,j,f,0)|0;if(n){if((n|0)>0){n=a+12|0;o=c[a+16>>2]|0;k=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;l=o+k|0;c[n>>2]=l;if((k|0)>=0?(m=o+(k+4)|0,m>>>0<=(c[a+20>>2]|0)>>>0):0){g[d>>2]=ea(g[l>>2]);c[n>>2]=m}else Bid(n,d,4);if(c[a>>2]&512)c[d>>2]=XEi(c[d>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](d,a)|0}sdd(a)}d=b+12|0;n=qdd(a,2497752,j,f,0)|0;if(n){if((n|0)>0){n=a+12|0;j=c[a+16>>2]|0;m=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;l=j+m|0;c[n>>2]=l;if((m|0)>=0?(k=j+(m+4)|0,k>>>0<=(c[a+20>>2]|0)>>>0):0){g[d>>2]=ea(g[l>>2]);c[n>>2]=k}else Bid(n,d,4);if(c[a>>2]&512)c[d>>2]=XEi(c[d>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](d,a)|0}sdd(a)}}else{d=c[h>>2]|0;if(d)_n[d&4095](b,a)|0}sdd(a);i=e;return}function yDc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0;f=i;i=i+16|0;h=f+4|0;j=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];mWb(b,h,e);c[b>>2]=594392;bGc(b+28|0);e=b+44|0;c[e>>2]=0;c[b+48>>2]=0;g[b+64>>2]=ea(1.0);g[b+68>>2]=ea(1.0);g[b+72>>2]=ea(1.0);g[b+76>>2]=ea(1.0);c[b+80>>2]=0;c[b+88>>2]=0;c[b+92>>2]=0;c[b+84>>2]=60;a[b+96>>0]=0;h=Cnc()|0;c[e>>2]=mo[c[(c[h>>2]|0)+452>>2]&4095](h)|0;c[b+52>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;i=f;return}function zDc(a){a=a|0;return}function ADc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[148593]|0;h=a+44|0;if(g){j=c[h>>2]|0;k=594372|0;l=g;a:while(1){m=l;while(1){if((c[m+16>>2]|0)>>>0>=j>>>0){n=m;break}m=c[m+4>>2]|0;if(!m){o=k;break a}}l=c[n>>2]|0;if(!l){o=n;break}else k=n}if((o|0)!=(594372|0)?j>>>0>=(c[o+16>>2]|0)>>>0:0){j=c[o+4>>2]|0;if(!j){n=o;while(1){k=c[n+8>>2]|0;if((c[k>>2]|0)==(n|0)){p=k;break}else n=k}}else{n=j;while(1){j=c[n>>2]|0;if(!j){p=n;break}else n=j}}if((c[148592]|0)==(o|0))c[148592]=p;c[148594]=(c[148594]|0)+-1;tYb(g,o);ACi(o)}}o=Cnc()|0;g=c[(c[o>>2]|0)+456>>2]|0;c[f>>2]=c[h>>2];c[d+0>>2]=c[f+0>>2];In[g&4095](o,d);c[h>>2]=0;h=a+80|0;o=a+88|0;g=c[o>>2]|0;if(g){f=c[h>>2]|0;p=0;do{n=c[f+(p<<2)>>2]|0;c[n+16>>2]=0;c[n+20>>2]=0;p=p+1|0}while((p|0)!=(g|0))}g=a+92|0;if((c[g>>2]|0)<=-1){c[o>>2]=0;c[g>>2]=0;i=b;return}p=c[h>>2]|0;c[e>>2]=c[a+84>>2];c[d+0>>2]=c[e+0>>2];eOb(p,d);c[h>>2]=0;c[o>>2]=0;c[g>>2]=0;i=b;return}function BDc(a){a=a|0;var b=0;b=i;cGc(a+28|0);i=b;return}function CDc(a){a=a|0;c[a+52>>2]=0;c[a+56>>2]=0;return}function DDc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;if((c[148634]|0)==(a|0)){i=d;return}c[148634]=a;if(!b){i=d;return}c[g>>2]=0;b=g+4|0;c[b>>2]=0;c[g+8>>2]=0;BQb(27,g,0)|0;a=c[g>>2]|0;if((c[b>>2]|0)!=(a|0)){h=a;a=0;do{j=c[h+(a<<2)>>2]|0;c[f>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,f);l=c[e>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[n+4>>2]|0,(k|0)!=0):0)o=k;else p=13}else p=13;if((p|0)==13){p=0;o=hQb(j)|0}In[c[(c[o>>2]|0)+136>>2]&4095](o,0);ko[c[(c[o>>2]|0)+140>>2]&4095](o);a=a+1|0;h=c[g>>2]|0}while(a>>>0<(c[b>>2]|0)-h>>2>>>0)}wDc();h=c[g>>2]|0;if(!h){i=d;return}g=c[b>>2]|0;if((g|0)!=(h|0))c[b>>2]=g+(~((g+-4-h|0)>>>2)<<2);ACi(h);i=d;return}function EDc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+32|0;g=f+24|0;h=f+16|0;j=f+12|0;k=f;c[k>>2]=0;l=k+4|0;c[l>>2]=0;c[k+8>>2]=0;BQb(27,k,1)|0;m=c[k>>2]|0;if((c[l>>2]|0)!=(m|0)){n=m;m=0;do{o=c[n+(m<<2)>>2]|0;c[h>>2]=o;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(g,p,h);q=c[g>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[s+4>>2]|0,(p|0)!=0):0)t=p;else u=11}else u=11;if((u|0)==11){u=0;t=hQb(o)|0}if(a?(In[c[(c[t>>2]|0)+136>>2]&4095](t,d),!e):0){p=t+80|0;q=t+88|0;r=c[q>>2]|0;if(r){v=c[p>>2]|0;w=0;do{x=c[v+(w<<2)>>2]|0;c[x+16>>2]=0;c[x+20>>2]=0;w=w+1|0}while((w|0)!=(r|0))}r=t+92|0;if((c[r>>2]|0)>-1){w=c[p>>2]|0;c[j>>2]=c[t+84>>2];c[g+0>>2]=c[j+0>>2];eOb(w,g);c[p>>2]=0}c[q>>2]=0;c[r>>2]=0}if(b)ko[c[(c[t>>2]|0)+140>>2]&4095](t);m=m+1|0;n=c[k>>2]|0}while(m>>>0<(c[l>>2]|0)-n>>2>>>0)}wDc();n=c[k>>2]|0;if(!n){i=f;return}k=c[l>>2]|0;if((k|0)!=(n|0))c[l>>2]=k+(~((k+-4-n|0)>>>2)<<2);ACi(n);i=f;return}function FDc(a){a=a|0;var b=0;b=i;hEc(a,0);i=b;return}function GDc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=Im;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+44>>2];f=mo[c[(c[a>>2]|0)+92>>2]&4095](a)|0;h=mo[c[(c[a>>2]|0)+124>>2]&4095](a)|0;if((KLc()|0)==1)j=c[a+56>>2]|0;else j=0;c[d+0>>2]=c[e+0>>2];dGc(a+28|0,d,f,h,j,0);k=ea(g[a+36>>2]);j=a+88|0;if(!(c[j>>2]|0)){i=b;return}h=a+80|0;a=0;do{mxd(c[(c[h>>2]|0)+(a<<2)>>2]|0,k);a=a+1|0}while(a>>>0<(c[j>>2]|0)>>>0);i=b;return}function HDc(a){a=a|0;var b=0,d=Im,e=0,f=0;b=i;d=ea(g[a+36>>2]);e=a+88|0;if(!(c[e>>2]|0)){i=b;return}f=a+80|0;a=0;do{mxd(c[(c[f>>2]|0)+(a<<2)>>2]|0,d);a=a+1|0}while(a>>>0<(c[e>>2]|0)>>>0);i=b;return}function IDc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+80|0;h=a+88|0;j=c[h>>2]|0;c[b+16>>2]=a;c[b+20>>2]=j;k=j+1|0;c[h>>2]=k;j=a+92|0;l=c[j>>2]|0;m=l&2147483647;if(k>>>0<=m>>>0){n=k;o=n+-1|0;p=c[g>>2]|0;q=p+(o<<2)|0;c[q>>2]=b;i=d;return}k=l<<1;r=(k|0)==0?1:k;do if(m>>>0<r>>>0)if((l|0)>-1){c[j>>2]=r;k=c[g>>2]|0;c[f>>2]=c[a+84>>2];c[e+0>>2]=c[f+0>>2];c[g>>2]=hOb(k,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+84>>2];c[e+0>>2]=c[f+0>>2];k=cOb(r<<2,4,e,0,3653512,352)|0;YEi(k|0,c[g>>2]|0,c[h>>2]<<2|0)|0;c[j>>2]=r;c[g>>2]=k;break}while(0);n=c[h>>2]|0;o=n+-1|0;p=c[g>>2]|0;q=p+(o<<2)|0;c[q>>2]=b;i=d;return}function JDc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=a+88|0;f=(c[e>>2]|0)+-1|0;g=a+80|0;h=c[g>>2]|0;c[h+(d<<2)>>2]=c[h+(f<<2)>>2];h=c[(c[g>>2]|0)+(d<<2)>>2]|0;c[h+16>>2]=a;c[h+20>>2]=d;c[e>>2]=f;c[b+16>>2]=0;c[b+20>>2]=0;return}function KDc(a){a=a|0;var b=0,d=Im,e=Im,f=0,h=0;b=i;d=ea(g[a+64>>2]);e=ea(g[a+68>>2]);f=a+88|0;if(!(c[f>>2]|0)){i=b;return}h=a+80|0;a=0;do{nxd(c[(c[h>>2]|0)+(a<<2)>>2]|0,d,e);a=a+1|0}while(a>>>0<(c[f>>2]|0)>>>0);i=b;return}function LDc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+28|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;ko[c[(c[a>>2]|0)+132>>2]&4095](a);i=d;return}function MDc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+56|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;ko[c[(c[a>>2]|0)+132>>2]&4095](a);i=d;return}function NDc(a,b){a=a|0;b=b|0;c[a+56>>2]=b;return}function ODc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+40|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;ko[c[(c[a>>2]|0)+132>>2]&4095](a);i=d;return}function PDc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+32|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;ko[c[(c[a>>2]|0)+132>>2]&4095](a);i=d;return}function QDc(a,b){a=a|0;b=ea(b);var d=0,e=0;d=i;e=a+36|0;if(!(ea(g[e>>2])!=b)){i=d;return}g[e>>2]=b;ko[c[(c[a>>2]|0)+132>>2]&4095](a);i=d;return}function RDc(){return c[148634]|0}function SDc(a){a=a|0;return 1}function TDc(){var a=0;a=i;QQb(27,142,0,0,0);i=a;return}function UDc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,2359320,7);wQb(27,130,b,100,2624,1,0);xri(b);i=a;return}function VDc(a){a=a|0;return 27}function WDc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2359320,a,0);xWb(a,b);bdd(b);i=c;return}function XDc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2359320,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else yWb(a,b);sdd(b);i=d;return}function YDc(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);i=c;return}function ZDc(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);i=c;return}function _Dc(a,b){a=a|0;b=b|0;var c=0;c=i;BWb(a,b);i=c;return}function $Dc(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function aEc(a,b){a=a|0;b=b|0;var c=0;c=i;xWb(a,b);i=c;return}function bEc(a,b){a=a|0;b=b|0;var c=0;c=i;yWb(a,b);i=c;return}function cEc(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);i=c;return}function dEc(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);i=c;return}function eEc(a,b){a=a|0;b=b|0;var c=0;c=i;BWb(a,b);i=c;return}function fEc(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function gEc(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;n=i;i=i+32|0;o=n+20|0;p=n+16|0;q=n+12|0;r=n+8|0;s=n+4|0;t=n;c[p>>2]=b;u=g+-1|0;c[q>>2]=e;c[r>>2]=f;c[s>>2]=0;f=jEc((u|0)>(m|0)?m:u,h,g,p,q,r,s)|0;u=c[p>>2]|0;if(f){v=g;w=h;x=c[s>>2]|0;y=u;z=c[q>>2]|0;A=c[r>>2]|0;B=b+d-u|0}else{c[p>>2]=594552;c[q>>2]=1;c[r>>2]=1;c[s>>2]=0;v=1;w=5;x=0;y=594552;z=1;A=1;B=4}s=znc()|0;r=c[(c[s>>2]|0)+468>>2]|0;c[t>>2]=c[a>>2];c[o+0>>2]=c[t+0>>2];An[r&3](s,o,2,y,B,z,A,w,v-x|0,j,k,l);i=n;return}function hEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;if(!((c[148636]|0)!=(a|0)|b)){i=d;return}c[148636]=a;if((a|0)==2)$Fc(9,16);else if(!a)$Fc(1,1);else $Fc(1,16);c[e>>2]=0;a=e+4|0;c[a>>2]=0;c[e+8>>2]=0;CQb(27,e,0)|0;b=c[a>>2]|0;f=c[e>>2]|0;if((b|0)==(f|0)){g=b;h=b}else{b=f;f=0;while(1){j=c[b+(f<<2)>>2]|0;ko[c[(c[j>>2]|0)+132>>2]&4095](j);f=f+1|0;j=c[a>>2]|0;k=c[e>>2]|0;if(f>>>0>=j-k>>2>>>0){g=k;h=j;break}else b=k}}if(!g){i=d;return}if((h|0)!=(g|0))c[a>>2]=h+(~((h+-4-g|0)>>>2)<<2);ACi(g);i=d;return}function iEc(a,b){a=a|0;b=b|0;return 0}function jEc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;a:do if((a|0)>0){k=c[f>>2]|0;l=a;while(1){if((k>>l|0)>=8?(c[g>>2]>>l|0)>=8:0){m=l;break a}n=l+-1|0;if((n|0)>0)l=n;else{m=n;break}}}else m=a;while(0);a=d+-1|0;d=(a|0)<(m|0)?a:m;c[h>>2]=d;if((d|0)>0){m=c[g>>2]|0;l=0;do{k=dwc(c[f>>2]|0,m,b)|0;c[e>>2]=(c[e>>2]|0)+k;k=(c[f>>2]|0)/2|0;c[f>>2]=(k|0)<1?1:k;k=(c[g>>2]|0)/2|0;m=(k|0)<1?1:k;c[g>>2]=m;l=l+1|0;k=c[h>>2]|0}while((l|0)<(k|0));o=k}else o=d;d=c[f>>2]|0;b:do if((o|0)<(a|0)){l=d;while(1){m=c[155256]|0;k=c[g>>2]|0;if(!((l|0)>(m|0)|(k|0)>(m|0))){p=l;break b}m=dwc(l,k,b)|0;c[e>>2]=(c[e>>2]|0)+m;m=(c[f>>2]|0)/2|0;c[f>>2]=(m|0)<1?1:m;m=(c[g>>2]|0)/2|0;c[g>>2]=(m|0)<1?1:m;m=(c[h>>2]|0)+1|0;c[h>>2]=m;k=c[f>>2]|0;if((m|0)<(a|0))l=k;else{p=k;break}}}else p=d;while(0);d=c[155256]|0;if((p|0)>(d|0)){q=0;i=j;return q|0}q=(c[g>>2]|0)<=(d|0);i=j;return q|0}function kEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=594392;if((c[a+92>>2]|0)<=-1){EWb(a);ACi(a);i=b;return}f=a+80|0;g=c[f>>2]|0;c[e>>2]=c[a+84>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;EWb(a);ACi(a);i=b;return}function lEc(a){a=a|0;var b=0,c=0;b=i;switch(a|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{c=0;break}default:if((a+-48|0)>>>0<12)c=0;else c=TFc(a)|0}i=b;return c|0}function mEc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;g=b+-1|0;b=g>>>16|g;g=b>>>8|b;b=g>>>4|g;g=b>>>2|b;b=(g>>>1|g)+1|0;g=b>>>0>65535;h=g?b>>>16:b;b=g?16:0;if(!(h&65280)){j=h;k=b}else{j=h>>>8;k=b|8}if(!(j&240)){l=j;m=k}else{l=j>>>4;m=k+4|0}k=d+-1|0;d=k>>>16|k;k=d>>>8|d;d=k>>>4|k;k=d>>>2|d;d=(k>>>1|k)+1|0;k=d>>>0>65535;j=k?d>>>16:d;d=k?16:0;if(!(j&65280)){n=j;o=d}else{n=j>>>8;o=d|8}if(!(n&240)){p=n;q=o}else{p=n>>>4;q=o+4|0}o=(a[595568+l>>0]|0)+m-q-(a[595568+p>>0]|0)|0;p=c+-1|0;c=p>>>16|p;p=c>>>8|c;c=p>>>4|p;p=c>>>2|c;c=(p>>>1|p)+1|0;p=c>>>0>65535;q=p?c>>>16:c;c=p?16:0;if(!(q&65280)){r=q;s=c}else{r=q>>>8;s=c|8}if(!(r&240)){t=r;u=s}else{t=r>>>4;u=s+4|0}s=a[595568+t>>0]|0;t=e+-1|0;e=t>>>16|t;t=e>>>8|e;e=t>>>4|t;t=e>>>2|e;e=(t>>>1|t)+1|0;t=e>>>0>65535;r=t?e>>>16:e;e=t?16:0;if(!(r&65280)){v=r;w=e}else{v=r>>>8;w=e|8}if(!(v&240)){x=v;y=w;z=595568+x|0;A=a[z>>0]|0;B=A<<24>>24;C=s+u|0;D=C-y|0;E=D-B|0;F=(o|0)<(E|0);G=F?E:o;H=(G|0)>0;I=H?G:0;i=f;return I|0}x=v>>>4;y=w+4|0;z=595568+x|0;A=a[z>>0]|0;B=A<<24>>24;C=s+u|0;D=C-y|0;E=D-B|0;F=(o|0)<(E|0);G=F?E:o;H=(G|0)>0;I=H?G:0;i=f;return I|0}function nEc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[155286]|0;if((e|0)==1)f=2;else if(!e){g=0;i=d;return g|0}if(((f|0)==2?(a[621152]|0)!=0:0)?(f=c[b+48>>2]|0,(f|0)!=0):0){e=c[f+32>>2]|0;switch(e|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{g=0;i=d;return g|0}default:{}}if((e+-48|0)>>>0<12){g=0;i=d;return g|0}}e=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;b=c[155286]|0;g=e?(b|0)==2:(b|0)>0;i=d;return g|0}function oEc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];yDc(b,g,e);c[b>>2]=594568;e=b+132|0;c[e>>2]=0;g=b+100|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;a[b+124>>0]=1;a[b+127>>0]=1;a[b+129>>0]=0;a[b+128>>0]=1;a[b+125>>0]=0;a[b+126>>0]=0;b=Cnc()|0;c[e>>2]=mo[c[(c[b>>2]|0)+452>>2]&4095](b)|0;i=f;return}function pEc(a){a=a|0;var b=0;b=i;CDc(a);bGc(a+28|0);i=b;return}function qEc(a){a=a|0;return}function rEc(){return}function sEc(a,b){a=a|0;b=b|0;var d=0;d=i;if(b&32){i=d;return}if(!(c[a+48>>2]|0)){i=d;return}In[c[(c[a>>2]|0)+144>>2]&4095](a,0);i=d;return}function tEc(a){a=a|0;var b=0;b=i;uEc(a);i=b;return}function uEc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=b+48|0;j=c[h>>2]|0;if(j){k=c[153076]|0;l=j+4|0;c[l>>2]=(c[l>>2]|0)+-1;if(!(c[l>>2]|0)){ko[c[c[j>>2]>>2]&4095](j);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(j,e)}c[h>>2]=0}h=b+125|0;if(a[h>>0]|0){j=ync()|0;k=c[(c[j>>2]|0)+484>>2]|0;c[f>>2]=c[b+44>>2];c[e+0>>2]=c[f+0>>2];In[k&4095](j,e);a[h>>0]=0}h=b+126|0;if(!(a[h>>0]|0)){i=d;return}j=ync()|0;k=c[(c[j>>2]|0)+484>>2]|0;c[g>>2]=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;c[e+0>>2]=c[g+0>>2];In[k&4095](j,e);a[h>>0]=0;i=d;return}function vEc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;j=b+125|0;if(a[j>>0]|0){k=ync()|0;l=c[(c[k>>2]|0)+484>>2]|0;c[f>>2]=c[b+44>>2];c[e+0>>2]=c[f+0>>2];In[l&4095](k,e);a[j>>0]=0}j=b+126|0;if(a[j>>0]|0){k=ync()|0;l=c[(c[k>>2]|0)+484>>2]|0;c[g>>2]=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;c[e+0>>2]=c[g+0>>2];In[l&4095](k,e);a[j>>0]=0}j=c[148593]|0;k=b+132|0;if(j){l=c[k>>2]|0;g=594372;f=j;a:while(1){m=f;while(1){if((c[m+16>>2]|0)>>>0>=l>>>0){n=m;break}m=c[m+4>>2]|0;if(!m){o=g;break a}}f=c[n>>2]|0;if(!f){o=n;break}else g=n}if((o|0)!=594372?l>>>0>=(c[o+16>>2]|0)>>>0:0){l=c[o+4>>2]|0;if(!l){n=o;while(1){g=c[n+8>>2]|0;if((c[g>>2]|0)==(n|0)){p=g;break}else n=g}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((c[148592]|0)==(o|0))c[148592]=p;c[148594]=(c[148594]|0)+-1;tYb(j,o);ACi(o)}}o=Cnc()|0;j=c[(c[o>>2]|0)+456>>2]|0;c[h>>2]=c[k>>2];c[e+0>>2]=c[h+0>>2];In[j&4095](o,e);c[k>>2]=0;ADc(b);i=d;return}function wEc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+48>>2]|0;if(!f){Krd(594736,0,3653512,329,1,c[a+4>>2]|0,0,0);g=0;i=e;return g|0}else{g=sDc(f,b,1,d)|0;i=e;return g|0}return 0}function xEc(a){a=a|0;var b=0,d=0;b=i;if(!(mo[c[(c[a>>2]|0)+124>>2]&4095](a)|0)){d=1;i=b;return d|0}d=cwc(c[a+112>>2]|0,c[a+116>>2]|0,1)|0;i=b;return d|0}function yEc(a){a=a|0;var b=0,d=0;b=i;if(!(mo[c[(c[a>>2]|0)+124>>2]&4095](a)|0)){d=1;i=b;return d|0}d=cwc(c[a+104>>2]|0,c[a+108>>2]|0,1)|0;i=b;return d|0}function zEc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=b+48|0;b=c[h>>2]|0;if(!b){i=d;return}if((c[b+4>>2]|0)==1){i=d;return}c[g>>2]=c[153076];c[e+0>>2]=c[g+0>>2];g=bOb(48,e,0,16,3653512,361)|0;b=c[h>>2]|0;c[g>>2]=575440;c[g+4>>2]=1;c[g>>2]=594360;j=c[b+12>>2]|0;c[g+12>>2]=j;k=g+16|0;c[k>>2]=0;l=g+20|0;c[l>>2]=0;m=g+8|0;c[m>>2]=0;n=c[b+8>>2]|0;o=c[b+16>>2]|0;c[k>>2]=o;if(!o){p=0;q=0}else{c[l>>2]=o;c[f>>2]=j;c[e+0>>2]=c[f+0>>2];j=hOb(0,o,1,e,0,3653512,370)|0;c[m>>2]=j;p=j;q=c[k>>2]|0}YEi(p|0,n|0,q|0)|0;q=g+24|0;n=b+24|0;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[q+16>>2]=c[n+16>>2];a[q+20>>0]=a[n+20>>0]|0;n=c[h>>2]|0;q=c[153076]|0;b=n+4|0;c[b>>2]=(c[b>>2]|0)+-1;if(!(c[b>>2]|0)){ko[c[c[n>>2]>>2]&4095](n);c[f>>2]=q;c[e+0>>2]=c[f+0>>2];eOb(n,e)}c[h>>2]=g;i=d;return}function AEc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im;l=i;i=i+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;if(j&32){q=b+48|0;r=c[q>>2]|0;if(r){s=c[153076]|0;t=r+4|0;c[t>>2]=(c[t>>2]|0)+-1;if(!(c[t>>2]|0)){ko[c[c[r>>2]>>2]&4095](r);c[n>>2]=s;c[m+0>>2]=c[n+0>>2];eOb(r,m)}c[q>>2]=0}}else uEc(b);q=j&1;r=(q|0)!=0;n=(VQb(b)|0)==15;s=VQb(b)|0;c[o>>2]=c[153076];c[m+0>>2]=c[o+0>>2];o=bOb(48,m,0,16,3653512,392)|0;c[p>>2]=n?s:13;c[m+0>>2]=c[p+0>>2];nDc(o,m,d,e,f,h,k,r,(j&16|0)==0);c[b+48>>2]=o;c[b+100>>2]=2;c[b+120>>2]=j;c[b+104>>2]=d;c[b+108>>2]=e;a[b+96>>0]=q;q=XFc(f)|0;j=d+-1+q&0-q;switch(f|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{u=1;break}default:u=(f+-48|0)>>>0<12}q=c[155286]|0;if((a[621152]|0)==0|u&(q|0)<2^1)v=j;else{u=j+-1|0;j=u>>>16|u;u=j>>>8|j;j=u>>>4|u;u=j>>>2|j;v=(u>>>1|u)+1|0}if(r?(q|0)==2:(q|0)>0)w=v;else{q=v+-1|0;v=q>>>16|q;q=v>>>8|v;v=q>>>4|q;q=v>>>2|v;w=(q>>>1|q)+1|0}q=b+112|0;c[q>>2]=w;w=XFc(f)|0;v=e+-1+w&0-w;switch(f|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{x=1;break}default:x=(f+-48|0)>>>0<12}f=c[155286]|0;if((a[621152]|0)==0|x&(f|0)<2^1)y=v;else{x=v+-1|0;v=x>>>16|x;x=v>>>8|v;v=x>>>4|x;x=v>>>2|v;y=(x>>>1|x)+1|0}if(r?(f|0)==2:(f|0)>0)z=y;else{f=y+-1|0;y=f>>>16|f;f=y>>>8|y;y=f>>>4|f;f=y>>>2|y;z=(f>>>1|f)+1|0}c[b+116>>2]=z;A=ea(ea(1.0)/ea(z|0));g[b+72>>2]=ea(ea(1.0)/ea(c[q>>2]|0));g[b+76>>2]=A;q=mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0;if(!(q+-1&q)){q=mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0;z=(q+-1&q|0)==0;a[b+124>>0]=z&1;if(z){i=l;return}}else a[b+124>>0]=0;z=(mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0)^1;if(!((c[155286]|0)==1&z)){i=l;return}c[b+40>>2]=1;i=l;return}function BEc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+16|0;k=j+4|0;l=j;if(b>>>0>16384|(d|0)<0|(d|0)>16384){if(!a)m=0;else m=c[a+4>>2]|0;Krd(594768,0,3653512,410,1,m,0,0);n=0;i=j;return n|0}if(!(WFc(e)|0)){if(!a)o=0;else o=c[a+4>>2]|0;Krd(594808,0,3653512,416,1,o,0,0);n=0;i=j;return n|0}if(!(f&1))p=dwc(b,d,e)|0;else p=fwc(b,d,e)|0;o=da(p,g)|0;if((p|0)!=0?((o>>>0)/(p>>>0)|0|0)!=(g|0):0){n=0;i=j;return n|0}switch(e|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{q=0;break}default:if((e+-48|0)>>>0<12)q=0;else q=TFc(e)|0}if((o+q|0)>>>0<o>>>0){n=0;i=j;return n|0}if(h){o=ync()|0;q=c[(c[o>>2]|0)+460>>2]|0;c[l>>2]=c[a+44>>2];c[k+0>>2]=c[l+0>>2];co[q&2047](o,k,h)}AEc(a,b,d,e,p,f,g);n=1;i=j;return n|0}function CEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;if(!(mo[c[(c[a>>2]|0)+124>>2]&4095](a)|0)){i=b;return}d=c[a+48>>2]|0;e=d+32|0;f=c[e>>2]|0;switch(f|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((f+-48|0)>>>0>=12){g=d+40|0;if((c[g>>2]|0)<=0){i=b;return}h=d+36|0;j=d+8|0;k=d+24|0;l=d+28|0;d=f;f=0;while(1){m=da(c[h>>2]|0,f)|0;gwc((c[j>>2]|0)+m|0,c[k>>2]|0,c[l>>2]|0,1,d);m=f+1|0;if((m|0)>=(c[g>>2]|0))break;d=c[e>>2]|0;f=m}i=b;return}}if(!a)n=0;else n=c[a+4>>2]|0;Krd(595872,0,3653512,453,1,n,0,0);i=b;return}function DEc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=a+48|0;if(!(c[g>>2]|0)){h=0;i=f;return h|0}zEc(a);h=oDc(c[g>>2]|0,b,d,e)|0;i=f;return h|0}function EEc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;j=b+28|0;c[f>>2]=c[b+44>>2];k=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;if((KLc()|0)==1)l=c[b+56>>2]|0;else l=0;c[e+0>>2]=c[f+0>>2];dGc(j,e,h,k,l,0);if(!(a[b+126>>0]|0)){HDc(b);i=d;return}c[g>>2]=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;l=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;if((KLc()|0)==1)m=c[b+56>>2]|0;else m=0;c[e+0>>2]=c[g+0>>2];dGc(j,e,h,l,m,0);HDc(b);i=d;return}function FEc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0;e=i;i=i+48|0;f=e;h=e+16|0;j=e+28|0;k=e+4|0;l=e+32|0;m=e+36|0;n=e+12|0;o=e+24|0;p=e+20|0;q=e+8|0;r=b+48|0;s=c[r>>2]|0;if(!s){Krd(594840,0,3653512,526,1,c[b+4>>2]|0,0,0);i=e;return}if(!(c[s+24>>2]|0)){i=e;return}if(!(c[s+28>>2]|0)){i=e;return}c[k>>2]=0;c[l>>2]=0;GEc(b,k,l);s=c[b+52>>2]|0;t=(s|0)==6;if(t){u=c[k>>2]|0;v=c[u+24>>2]|0;c[b+112>>2]=v;w=c[u+28>>2]|0;c[b+116>>2]=w;x=ea(ea(1.0)/ea(w|0));g[b+72>>2]=ea(ea(1.0)/ea(v|0));g[b+76>>2]=x}v=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;w=RDc()|0;if(!d?(a[b+125>>0]|0)!=0:0)y=1;else y=3;u=b+120|0;z=(c[u>>2]|0)>>>1&4|y;y=b+127|0;A=(a[y>>0]|0)==0?z:z|16;z=b+44|0;c[m>>2]=c[z>>2];B=c[k>>2]|0;C=c[B+8>>2]|0;D=c[B+36>>2]|0;E=c[B+24>>2]|0;F=c[B+28>>2]|0;G=c[B+32>>2]|0;if((KLc()|0)==1)H=c[b+56>>2]|0;else H=0;c[f+0>>2]=c[m+0>>2];gEc(f,C,D,E,F,v,G,A,s,H,w);H=c[z>>2]|0;A=b;G=c[148593]|0;do if(G){F=G;while(1){E=c[F+16>>2]|0;if(H>>>0<E>>>0){D=c[F>>2]|0;if(!D){I=F;J=F;K=15;break}else{F=D;continue}}if(E>>>0>=H>>>0){L=F;K=19;break}E=F+4|0;D=c[E>>2]|0;if(!D){M=E;N=F;K=18;break}else F=D}if((K|0)==15){c[f>>2]=J;O=I;P=J;break}else if((K|0)==18){c[f>>2]=N;O=M;P=N;break}else if((K|0)==19){c[f>>2]=L;O=f;P=L;break}}else{c[f>>2]=594372;O=594372;P=594372}while(0);if(!(c[O>>2]|0)){L=xCi(24)|0;N=L+16|0;c[N>>2]=H;c[N+4>>2]=A;c[L>>2]=0;c[L+4>>2]=0;c[L+8>>2]=P;c[O>>2]=L;P=c[c[148592]>>2]|0;if(!P)Q=L;else{c[148592]=P;Q=c[O>>2]|0}GN(c[148593]|0,Q);c[148594]=(c[148594]|0)+1;R=c[k>>2]|0}else R=B;B=c[R+24>>2]|0;if(!(B+-1&B)){B=c[R+28>>2]|0;S=(B+-1&B|0)!=0}else S=1;B=b+28|0;c[n>>2]=c[z>>2];k=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;Q=(a[R+44>>0]|0)!=0;if((KLc()|0)==1)T=c[b+56>>2]|0;else T=0;c[f+0>>2]=c[n+0>>2];dGc(B,f,k,Q,T,S);a[b+125>>0]=1;S=ync()|0;In[c[(c[S>>2]|0)+360>>2]&4095](S,R);R=c[r>>2]|0;if((c[R+24>>2]|0)==(c[b+112>>2]|0))if((c[R+28>>2]|0)==(c[b+116>>2]|0)|t)K=55;else K=32;else if(t)K=55;else K=32;if((K|0)==32){t=b+126|0;if(!d?(a[t>>0]|0)!=0:0)U=1;else U=3;d=(c[u>>2]|0)>>>1&4|U;a[t>>0]=1;t=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;c[o>>2]=t;U=c[l>>2]|0;u=c[U+8>>2]|0;R=c[U+36>>2]|0;S=c[U+24>>2]|0;T=c[U+28>>2]|0;Q=c[U+32>>2]|0;if((KLc()|0)==1)V=c[b+56>>2]|0;else V=0;c[f+0>>2]=c[o+0>>2];gEc(f,u,R,S,T,v,Q,d,s,V,w);w=c[148593]|0;do if(w){V=w;while(1){s=c[V+16>>2]|0;if(t>>>0<s>>>0){d=c[V>>2]|0;if(!d){W=V;X=V;K=40;break}else{V=d;continue}}if(s>>>0>=t>>>0){Y=V;K=44;break}s=V+4|0;d=c[s>>2]|0;if(!d){Z=s;_=V;K=43;break}else V=d}if((K|0)==40){c[f>>2]=X;$=W;aa=X;break}else if((K|0)==43){c[f>>2]=_;$=Z;aa=_;break}else if((K|0)==44){c[f>>2]=Y;$=f;aa=Y;break}}else{c[f>>2]=594372;$=594372;aa=594372}while(0);if(!(c[$>>2]|0)){Y=xCi(24)|0;_=Y+16|0;c[_>>2]=t;c[_+4>>2]=A;c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=aa;c[$>>2]=Y;aa=c[c[148592]>>2]|0;if(!aa)ba=Y;else{c[148592]=aa;ba=c[$>>2]|0}GN(c[148593]|0,ba);c[148594]=(c[148594]|0)+1;ca=c[l>>2]|0}else ca=U;U=c[ca+24>>2]|0;if(!(U+-1&U)){U=c[ca+28>>2]|0;da=(U+-1&U|0)!=0}else da=1;c[p>>2]=t;t=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;U=(a[ca+44>>0]|0)!=0;if((KLc()|0)==1)fa=c[b+56>>2]|0;else fa=0;c[f+0>>2]=c[p+0>>2];dGc(B,f,t,U,fa,da);da=ync()|0;In[c[(c[da>>2]|0)+360>>2]&4095](da,ca)}else if((K|0)==55?(K=c[l>>2]|0,l=c[153076]|0,ca=K+4|0,c[ca>>2]=(c[ca>>2]|0)+-1,(c[ca>>2]|0)==0):0){ko[c[c[K>>2]>>2]&4095](K);c[h>>2]=l;c[f+0>>2]=c[h+0>>2];eOb(K,f)}K=ync()|0;h=c[(c[K>>2]|0)+644>>2]|0;c[q>>2]=c[z>>2];z=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;c[f+0>>2]=c[q+0>>2];co[h&2047](K,f,z);if(a[y>>0]|0){i=e;return}y=c[r>>2]|0;if(!y){i=e;return}z=c[153076]|0;K=y+4|0;c[K>>2]=(c[K>>2]|0)+-1;if(!(c[K>>2]|0)){ko[c[c[y>>2]>>2]&4095](y);c[j>>2]=z;c[f+0>>2]=c[j+0>>2];eOb(y,f)}c[r>>2]=0;i=e;return}function GEc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=0,q=0;f=i;h=b+100|0;if((c[h>>2]|0)==1)c[h>>2]=2;h=b+48|0;j=c[h>>2]|0;if(!j)k=5;else k=c[j+32>>2]|0;j=(XFc(k)|0)+-1|0;do if(((mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0)&j|0)==0?((mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0)&j|0)==0:0){if((a[b+124>>0]|0)==0?!(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0):0)break;l=c[h>>2]|0;c[e>>2]=l;c[d>>2]=l;l=(c[h>>2]|0)+4|0;c[l>>2]=(c[l>>2]|0)+1;l=(c[h>>2]|0)+4|0;c[l>>2]=(c[l>>2]|0)+1;m=ea(ea(1.0)/ea(mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0));n=ea(ea(1.0)/ea(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0));g[b+72>>2]=m;g[b+76>>2]=n;i=f;return}while(0);j=(c[b+52>>2]|0)==6;if(!j){switch(k|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{o=4;break}default:o=(k+-48|0)>>>0<12?4:k}c[d>>2]=OEc(b,o)|0}c[e>>2]=OEc(b,k)|0;k=c[h>>2]|0;if(!k)p=0;else p=c[k+40>>2]|0;k=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;a:do if((p|0)>0){if((k|0)>0)q=0;else{b=0;while(1){b=b+1|0;if((b|0)==(p|0))break a}}do{if(j){b=0;do{qDc(c[h>>2]|0,c[e>>2]|0,q,b,1,0);b=b+1|0}while((b|0)!=(k|0))}else{b=0;do{qDc(c[h>>2]|0,c[d>>2]|0,q,b,0,1);qDc(c[h>>2]|0,c[e>>2]|0,q,b,1,0);b=b+1|0}while((b|0)!=(k|0))}q=q+1|0}while((q|0)!=(p|0))}while(0);if(!j){i=f;return}c[d>>2]=c[e>>2];c[e>>2]=c[h>>2];e=(c[h>>2]|0)+4|0;c[e>>2]=(c[e>>2]|0)+1;i=f;return}function HEc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;if(!((a[b+129>>0]|0)==0|d)){i=e;return}d=b+125|0;if(a[d>>0]|0){j=ync()|0;k=c[(c[j>>2]|0)+484>>2]|0;c[g>>2]=c[b+44>>2];c[f+0>>2]=c[g+0>>2];In[k&4095](j,f);a[d>>0]=0}d=b+126|0;if(!(a[d>>0]|0)){i=e;return}j=ync()|0;k=c[(c[j>>2]|0)+484>>2]|0;c[h>>2]=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;c[f+0>>2]=c[h+0>>2];In[k&4095](j,f);a[d>>0]=0;i=e;return}function IEc(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(a[b+129>>0]|0){i=d;return}if((c[b+48>>2]|0)==0?(a[b+127>>0]|0)==0:0){f=b+28|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];Xed(kfd()|0,b)|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];ko[c[(c[b>>2]|0)+132>>2]&4095](b);i=d;return}In[c[(c[b>>2]|0)+144>>2]&4095](b,1);i=d;return}function JEc(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+160>>2]&4095](a);In[c[(c[a>>2]|0)+144>>2]&4095](a,0);i=b;return}function KEc(a){a=a|0;var b=0;b=i;In[c[(c[a>>2]|0)+144>>2]&4095](a,0);i=b;return}function LEc(b){b=b|0;return c[((a[b+126>>0]|0)==0?b+44|0:b+132|0)>>2]|0}function MEc(a){a=a|0;return c[a+104>>2]|0}function NEc(a){a=a|0;return c[a+108>>2]|0}function OEc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0;k=mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0;l=XFc(d)|0;m=k+-1+l&0-l;switch(d|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{n=1;break}default:n=(d+-48|0)>>>0<12}l=c[155286]|0;if((a[621152]|0)==0|n&(l|0)<2^1)o=m;else{n=m+-1|0;m=n>>>16|n;n=m>>>8|m;m=n>>>4|n;n=m>>>2|m;o=(n>>>1|n)+1|0}if(j?(l|0)==2:(l|0)>0)p=o;else{l=o+-1|0;o=l>>>16|l;l=o>>>8|o;o=l>>>4|l;l=o>>>2|o;p=(l>>>1|l)+1|0}l=mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0;o=XFc(d)|0;n=l+-1+o&0-o;switch(d|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{q=1;break}default:q=(d+-48|0)>>>0<12}o=c[155286]|0;if((a[621152]|0)==0|q&(o|0)<2^1)r=n;else{q=n+-1|0;n=q>>>16|q;q=n>>>8|n;n=q>>>4|q;q=n>>>2|n;r=(q>>>1|q)+1|0}if(j?(o|0)==2:(o|0)>0)s=r;else{o=r+-1|0;r=o>>>16|o;o=r>>>8|r;r=o>>>4|o;o=r>>>2|r;s=(o>>>1|o)+1|0}if(j)t=fwc(p,s,d)|0;else t=dwc(p,s,d)|0;c[g>>2]=c[153076];c[f+0>>2]=c[g+0>>2];g=bOb(48,f,0,16,3653512,947)|0;c[h>>2]=c[153076];o=c[b+48>>2]|0;if(!o){u=0;c[f+0>>2]=c[h+0>>2];nDc(g,f,p,s,d,t,u,j,1);i=e;return g|0}u=c[o+40>>2]|0;c[f+0>>2]=c[h+0>>2];nDc(g,f,p,s,d,t,u,j,1);i=e;return g|0}function PEc(a){a=a|0;return 136}function QEc(){var a=0;a=i;QQb(28,143,144,0,145);i=a;return}function REc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(27)|0))UDc();rri(b,2359424,9);wQb(28,27,b,136,2625,0,0);xri(b);i=a;return}function SEc(){return}function TEc(){return}function UEc(a){a=a|0;return 28}function VEc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2359424,a,0);$Ec(a,b);bdd(b);i=c;return}function WEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2359424,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else aFc(a,b);sdd(b);i=d;return}function XEc(a,b){a=a|0;b=b|0;var c=0;c=i;bFc(a,b);i=c;return}function YEc(a,b){a=a|0;b=b|0;var c=0;c=i;cFc(a,b);i=c;return}function ZEc(a,b){a=a|0;b=b|0;var c=0;c=i;dFc(a,b);i=c;return}function _Ec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;fEc(a,b);zEc(a);c[f>>2]=60;c[e+0>>2]=c[f+0>>2];eOb(0,e);i=d;return}function $Ec(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+48|0;f=e+4|0;g=e+16|0;h=e+20|0;j=e+24|0;k=e+28|0;l=e;m=e+12|0;n=e+32|0;o=e+8|0;aEc(b,d);zEc(b);c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;a[n>>0]=0;p=c[142270]|0;add(d,2356976,p,h,16);h=d+12|0;q=d+20|0;c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,2357176,p,j,16);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,594880,p,l,16);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,594904,p,k,1);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);k=c[142258]|0;add(d,595976,k,n,16);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=1;bdd(d);add(d,594920,k,b+127|0,0);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=1;bdd(d);add(d,594936,k,b+128|0,16);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=1;bdd(d);fdd(d);add(d,594952,p,m,16);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,594968,p,b+100|0,1);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);k=b+28|0;add(d,596008,596048,k,0);sCc(k,d);bdd(d);add(d,594992,p,b+52|0,0);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,595016,p,b+56|0,0);c[(c[c[h>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(d);c[o>>2]=da(c[l>>2]|0,c[m>>2]|0)|0;edd(d,o,596032,1);m=c[b+48>>2]|0;if(!m){r=0;s=c[o>>2]|0;gdd(d,s,r,0);c[g>>2]=60;c[f+0>>2]=c[g+0>>2];eOb(0,f);i=e;return}r=c[m+8>>2]|0;s=c[o>>2]|0;gdd(d,s,r,0);c[g>>2]=60;c[f+0>>2]=c[g+0>>2];eOb(0,f);i=e;return}function aFc(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=0;h=i;i=i+48|0;j=h;k=h+16|0;l=h+4|0;m=h+8|0;n=h+32|0;o=h+36|0;p=h+12|0;q=h+40|0;r=h+20|0;s=h+28|0;t=h+24|0;bEc(d,f);zEc(d);c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;a[q>>0]=0;u=c[142270]|0;v=qdd(f,2356976,u,j,0)|0;if(v){if((v|0)>0){v=f+12|0;w=c[f+16>>2]|0;x=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;y=w+x|0;c[v>>2]=y;if((x|0)>=0?(z=w+(x+4)|0,z>>>0<=(c[f+20>>2]|0)>>>0):0){c[l>>2]=c[y>>2];c[v>>2]=z}else Bid(v,l,4);if(c[f>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{v=c[j>>2]|0;if(v)_n[v&4095](l,f)|0}sdd(f)}v=qdd(f,2357176,u,j,0)|0;if(v){if((v|0)>0){v=f+12|0;z=c[f+16>>2]|0;y=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;x=z+y|0;c[v>>2]=x;if((y|0)>=0?(w=z+(y+4)|0,w>>>0<=(c[f+20>>2]|0)>>>0):0){c[m>>2]=c[x>>2];c[v>>2]=w}else Bid(v,m,4);if(c[f>>2]&512)c[m>>2]=XEi(c[m>>2]|0)|0}else{v=c[j>>2]|0;if(v)_n[v&4095](m,f)|0}sdd(f)}v=qdd(f,594880,u,j,0)|0;if(v){if((v|0)>0){v=f+12|0;w=c[f+16>>2]|0;x=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;y=w+x|0;c[v>>2]=y;if((x|0)>=0?(z=w+(x+4)|0,z>>>0<=(c[f+20>>2]|0)>>>0):0){c[o>>2]=c[y>>2];c[v>>2]=z}else Bid(v,o,4);if(c[f>>2]&512)c[o>>2]=XEi(c[o>>2]|0)|0}else{v=c[j>>2]|0;if(v)_n[v&4095](o,f)|0}sdd(f)}v=qdd(f,594904,u,j,0)|0;if(v){if((v|0)>0){v=f+12|0;z=c[f+16>>2]|0;y=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;x=z+y|0;c[v>>2]=x;if((y|0)>=0?(w=z+(y+4)|0,w>>>0<=(c[f+20>>2]|0)>>>0):0){c[n>>2]=c[x>>2];c[v>>2]=w}else Bid(v,n,4);if(c[f>>2]&512)c[n>>2]=XEi(c[n>>2]|0)|0}else{v=c[j>>2]|0;if(v)_n[v&4095](n,f)|0}sdd(f)}v=c[142258]|0;w=qdd(f,595976,v,j,0)|0;if(w){do if((w|0)<=0){x=c[j>>2]|0;if(x)_n[x&4095](q,f)|0}else{x=f+12|0;y=c[f+16>>2]|0;z=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;A=y+z|0;c[x>>2]=A;if((z|0)>=0?(y+(z+1)|0)>>>0<=(c[f+20>>2]|0)>>>0:0){a[q>>0]=a[A>>0]|0;c[x>>2]=y+(z+1);break}Bid(x,q,1)}while(0);sdd(f)}w=d+127|0;x=qdd(f,594920,v,j,0)|0;if(x){do if((x|0)<=0){z=c[j>>2]|0;if(z)_n[z&4095](w,f)|0}else{z=f+12|0;y=c[f+16>>2]|0;A=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;B=y+A|0;c[z>>2]=B;if((A|0)>=0?(y+(A+1)|0)>>>0<=(c[f+20>>2]|0)>>>0:0){a[w>>0]=a[B>>0]|0;c[z>>2]=(c[z>>2]|0)+1;break}Bid(z,w,1)}while(0);sdd(f)}w=d+128|0;x=qdd(f,594936,v,j,0)|0;if(x){do if((x|0)<=0){v=c[j>>2]|0;if(v)_n[v&4095](w,f)|0}else{v=f+12|0;z=c[f+16>>2]|0;B=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;A=z+B|0;c[v>>2]=A;if((B|0)>=0?(z+(B+1)|0)>>>0<=(c[f+20>>2]|0)>>>0:0){a[w>>0]=a[A>>0]|0;c[v>>2]=(c[v>>2]|0)+1;break}Bid(v,w,1)}while(0);sdd(f)}w=qdd(f,594952,u,j,0)|0;if(w){if((w|0)>0){w=f+12|0;x=c[f+16>>2]|0;v=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;A=x+v|0;c[w>>2]=A;if((v|0)>=0?(B=x+(v+4)|0,B>>>0<=(c[f+20>>2]|0)>>>0):0){c[p>>2]=c[A>>2];c[w>>2]=B}else Bid(w,p,4);if(c[f>>2]&512)c[p>>2]=XEi(c[p>>2]|0)|0}else{w=c[j>>2]|0;if(w)_n[w&4095](p,f)|0}sdd(f)}w=d+100|0;B=qdd(f,594968,u,j,0)|0;if(B){if((B|0)>0){B=f+12|0;A=c[f+16>>2]|0;v=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;x=A+v|0;c[B>>2]=x;if((v|0)>=0?(z=A+(v+4)|0,z>>>0<=(c[f+20>>2]|0)>>>0):0){c[w>>2]=c[x>>2];c[B>>2]=z}else Bid(B,w,4);if(c[f>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{B=c[j>>2]|0;if(B)_n[B&4095](w,f)|0}sdd(f)}w=d+28|0;B=qdd(f,596008,596048,j,1)|0;if(B){if((B|0)<=0){B=c[j>>2]|0;if(B)_n[B&4095](w,f)|0}else tCc(w,f);sdd(f)}w=d+52|0;B=qdd(f,594992,u,j,0)|0;if(B){if((B|0)>0){B=f+12|0;z=c[f+16>>2]|0;x=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;v=z+x|0;c[B>>2]=v;if((x|0)>=0?(A=z+(x+4)|0,A>>>0<=(c[f+20>>2]|0)>>>0):0){c[w>>2]=c[v>>2];c[B>>2]=A}else Bid(B,w,4);if(c[f>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{B=c[j>>2]|0;if(B)_n[B&4095](w,f)|0}sdd(f)}w=d+56|0;B=qdd(f,595016,u,j,0)|0;if(B){if((B|0)>0){B=f+12|0;u=c[f+16>>2]|0;A=(c[(c[f+80>>2]|0)+12>>2]|0)-(da(c[f+32>>2]|0,c[f+28>>2]|0)|0)|0;v=u+A|0;c[B>>2]=v;if((A|0)>=0?(x=u+(A+4)|0,x>>>0<=(c[f+20>>2]|0)>>>0):0){c[w>>2]=c[v>>2];c[B>>2]=x}else Bid(B,w,4);if(c[f>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{B=c[j>>2]|0;if(B)_n[B&4095](w,f)|0}sdd(f)}c[r>>2]=da(c[o>>2]|0,c[p>>2]|0)|0;ydd(f,r,596032,1);uEc(d);w=VQb(d)|0;B=VQb(d)|0;x=(w|0)==15?B:13;B=d+48|0;w=c[B>>2]|0;if(w){v=c[153076]|0;A=w+4|0;c[A>>2]=(c[A>>2]|0)+-1;if(!(c[A>>2]|0)){ko[c[c[w>>2]>>2]&4095](w);c[k>>2]=v;c[j+0>>2]=c[k+0>>2];eOb(w,j)}c[B>>2]=0}c[s>>2]=c[153076];c[j+0>>2]=c[s+0>>2];s=bOb(48,j,0,16,3653512,808)|0;c[t>>2]=x;x=c[l>>2]|0;w=c[m>>2]|0;v=c[n>>2]|0;A=c[o>>2]|0;o=c[p>>2]|0;p=(a[q>>0]|0)!=0;c[j+0>>2]=c[t+0>>2];nDc(s,j,x,w,v,A,o,p,1);c[B>>2]=s;s=c[l>>2]|0;c[d+104>>2]=s;c[d+108>>2]=c[m>>2];l=a[q>>0]|0;a[d+96>>0]=l;p=l<<24>>24!=0;l=c[n>>2]|0;o=XFc(l)|0;A=s+-1+o&0-o;switch(l|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{C=1;break}default:C=(l+-48|0)>>>0<12}l=c[155286]|0;if((a[621152]|0)==0|C&(l|0)<2^1)D=A;else{C=A+-1|0;A=C>>>16|C;C=A>>>8|A;A=C>>>4|C;C=A>>>2|A;D=(C>>>1|C)+1|0}if(p?(l|0)==2:(l|0)>0)E=D;else{l=D+-1|0;D=l>>>16|l;l=D>>>8|D;D=l>>>4|l;l=D>>>2|D;E=(l>>>1|l)+1|0}l=d+112|0;c[l>>2]=E;E=c[m>>2]|0;m=(a[q>>0]|0)!=0;q=c[n>>2]|0;D=XFc(q)|0;p=E+-1+D&0-D;switch(q|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{F=1;break}default:F=(q+-48|0)>>>0<12}q=c[155286]|0;if((a[621152]|0)==0|F&(q|0)<2^1)G=p;else{F=p+-1|0;p=F>>>16|F;F=p>>>8|p;p=F>>>4|F;F=p>>>2|p;G=(F>>>1|F)+1|0}if(m?(q|0)==2:(q|0)>0)H=G;else{q=G+-1|0;G=q>>>16|q;q=G>>>8|G;G=q>>>4|q;q=G>>>2|G;H=(q>>>1|q)+1|0}c[d+116>>2]=H;I=ea(ea(1.0)/ea(H|0));g[d+72>>2]=ea(ea(1.0)/ea(c[l>>2]|0));g[d+76>>2]=I;l=mo[c[(c[d>>2]|0)+104>>2]&4095](d)|0;if(!(l+-1&l)){l=mo[c[(c[d>>2]|0)+108>>2]&4095](d)|0;H=(l+-1&l|0)==0;a[d+124>>0]=H&1;if(!H)J=141}else{a[d+124>>0]=0;J=141}if((J|0)==141?(J=(mo[c[(c[d>>2]|0)+124>>2]&4095](d)|0)^1,(c[155286]|0)==1&J):0)c[d+40>>2]=1;d=c[B>>2]|0;if(!d)K=0;else K=c[d+8>>2]|0;zdd(f,c[r>>2]|0,K,0);if(!(c[f>>2]&512)){c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}f=c[n>>2]|0;n=c[r>>2]|0;if((f|0)==6){r=(n|0)/4|0;if((n|0)<=3){c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}d=0;B=K;while(1){c[B>>2]=XEi(c[B>>2]|0)|0;d=d+1|0;if((d|0)==(r|0))break;else B=B+4|0}c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}else if((f|0)==2|(f|0)==7|(f|0)==13){f=(n|0)/2|0;if((n|0)<=1){c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}n=0;B=K;while(1){K=e[B>>1]|0;b[B>>1]=K<<8|K>>>8;n=n+1|0;if((n|0)==(f|0))break;else B=B+2|0}c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}else{c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}}function bFc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=0,U=0,V=0;e=i;i=i+48|0;f=e;h=e+16|0;j=e+4|0;k=e+8|0;l=e+32|0;m=e+36|0;n=e+12|0;o=e+40|0;p=e+20|0;q=e+28|0;r=e+24|0;cEc(b,d);zEc(b);c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;a[o>>0]=0;s=d+12|0;t=c[s>>2]|0;u=t+4|0;v=d+20|0;w=c[v>>2]|0;if(u>>>0>w>>>0){Bid(s,j,4);x=c[s>>2]|0;y=c[v>>2]|0}else{c[j>>2]=c[t>>2];c[s>>2]=u;x=u;y=w}w=x+4|0;if(w>>>0>y>>>0){Bid(s,k,4);z=c[s>>2]|0;A=c[v>>2]|0}else{c[k>>2]=c[x>>2];c[s>>2]=w;z=w;A=y}y=z+4|0;if(y>>>0>A>>>0){Bid(s,m,4);B=c[s>>2]|0;C=c[v>>2]|0}else{c[m>>2]=c[z>>2];c[s>>2]=y;B=y;C=A}A=B+4|0;if(A>>>0>C>>>0){Bid(s,l,4);D=c[s>>2]|0;E=c[v>>2]|0}else{c[l>>2]=c[B>>2];c[s>>2]=A;D=A;E=C}C=D+1|0;if(C>>>0>E>>>0){Bid(s,o,1);F=c[s>>2]|0;G=c[v>>2]|0}else{a[o>>0]=a[D>>0]|0;c[s>>2]=C;F=C;G=E}E=b+127|0;if((F+1|0)>>>0>G>>>0){Bid(s,E,1);H=c[s>>2]|0}else{a[E>>0]=a[F>>0]|0;F=(c[s>>2]|0)+1|0;c[s>>2]=F;H=F}F=b+128|0;if((H+1|0)>>>0>(c[v>>2]|0)>>>0)Bid(s,F,1);else{a[F>>0]=a[H>>0]|0;c[s>>2]=(c[s>>2]|0)+1}Ndd(d);H=c[s>>2]|0;F=H+4|0;E=c[v>>2]|0;if(F>>>0>E>>>0){Bid(s,n,4);I=c[s>>2]|0;J=c[v>>2]|0}else{c[n>>2]=c[H>>2];c[s>>2]=F;I=F;J=E}E=b+100|0;F=I+4|0;if(F>>>0>J>>>0)Bid(s,E,4);else{c[E>>2]=c[I>>2];c[s>>2]=F}uCc(b+28|0,d);F=b+52|0;I=c[s>>2]|0;E=I+4|0;J=c[v>>2]|0;if(E>>>0>J>>>0){Bid(s,F,4);K=c[s>>2]|0;L=c[v>>2]|0}else{c[F>>2]=c[I>>2];c[s>>2]=E;K=E;L=J}J=b+56|0;E=K+4|0;if(E>>>0>L>>>0)Bid(s,J,4);else{c[J>>2]=c[K>>2];c[s>>2]=E}c[p>>2]=da(c[m>>2]|0,c[n>>2]|0)|0;Rdd(d,p,596032,1);uEc(b);E=VQb(b)|0;s=VQb(b)|0;K=(E|0)==15?s:13;s=b+48|0;E=c[s>>2]|0;if(E){J=c[153076]|0;L=E+4|0;c[L>>2]=(c[L>>2]|0)+-1;if(!(c[L>>2]|0)){ko[c[c[E>>2]>>2]&4095](E);c[h>>2]=J;c[f+0>>2]=c[h+0>>2];eOb(E,f)}c[s>>2]=0}c[q>>2]=c[153076];c[f+0>>2]=c[q+0>>2];q=bOb(48,f,0,16,3653512,808)|0;c[r>>2]=K;K=c[j>>2]|0;E=c[k>>2]|0;J=c[l>>2]|0;L=c[m>>2]|0;m=c[n>>2]|0;n=(a[o>>0]|0)!=0;c[f+0>>2]=c[r+0>>2];nDc(q,f,K,E,J,L,m,n,1);c[s>>2]=q;q=c[j>>2]|0;c[b+104>>2]=q;c[b+108>>2]=c[k>>2];j=a[o>>0]|0;a[b+96>>0]=j;n=j<<24>>24!=0;j=c[l>>2]|0;m=XFc(j)|0;L=q+-1+m&0-m;switch(j|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{M=1;break}default:M=(j+-48|0)>>>0<12}j=c[155286]|0;if((a[621152]|0)==0|M&(j|0)<2^1)N=L;else{M=L+-1|0;L=M>>>16|M;M=L>>>8|L;L=M>>>4|M;M=L>>>2|L;N=(M>>>1|M)+1|0}if(n?(j|0)==2:(j|0)>0)O=N;else{j=N+-1|0;N=j>>>16|j;j=N>>>8|N;N=j>>>4|j;j=N>>>2|N;O=(j>>>1|j)+1|0}j=b+112|0;c[j>>2]=O;O=c[k>>2]|0;k=(a[o>>0]|0)!=0;o=c[l>>2]|0;l=XFc(o)|0;N=O+-1+l&0-l;switch(o|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{P=1;break}default:P=(o+-48|0)>>>0<12}o=c[155286]|0;if((a[621152]|0)==0|P&(o|0)<2^1)Q=N;else{P=N+-1|0;N=P>>>16|P;P=N>>>8|N;N=P>>>4|P;P=N>>>2|N;Q=(P>>>1|P)+1|0}if(k?(o|0)==2:(o|0)>0)R=Q;else{o=Q+-1|0;Q=o>>>16|o;o=Q>>>8|Q;Q=o>>>4|o;o=Q>>>2|Q;R=(o>>>1|o)+1|0}c[b+116>>2]=R;S=ea(ea(1.0)/ea(R|0));g[b+72>>2]=ea(ea(1.0)/ea(c[j>>2]|0));g[b+76>>2]=S;j=mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0;if(!(j+-1&j)){j=mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0;R=(j+-1&j|0)==0;a[b+124>>0]=R&1;if(!R)T=53}else{a[b+124>>0]=0;T=53}if((T|0)==53?(T=(mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0)^1,(c[155286]|0)==1&T):0)c[b+40>>2]=1;b=c[s>>2]|0;if(!b){U=0;V=c[p>>2]|0;Pdd(d,V,U,0);c[h>>2]=60;c[f+0>>2]=c[h+0>>2];eOb(0,f);i=e;return}U=c[b+8>>2]|0;V=c[p>>2]|0;Pdd(d,V,U,0);c[h>>2]=60;c[f+0>>2]=c[h+0>>2];eOb(0,f);i=e;return}function cFc(d,f){d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,fa=0;h=i;i=i+48|0;j=h;k=h+16|0;l=h+4|0;m=h+8|0;n=h+32|0;o=h+36|0;p=h+12|0;q=h+40|0;r=h+20|0;s=h+28|0;t=h+24|0;dEc(d,f);zEc(d);c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;a[q>>0]=0;u=f+12|0;v=c[u>>2]|0;w=v+4|0;x=f+20|0;y=c[x>>2]|0;if(w>>>0>y>>>0){Bid(u,l,4);z=c[l>>2]|0;A=c[u>>2]|0;B=c[x>>2]|0}else{C=c[v>>2]|0;c[l>>2]=C;c[u>>2]=w;z=C;A=w;B=y}c[l>>2]=XEi(z|0)|0;z=A+4|0;if(z>>>0>B>>>0){Bid(u,m,4);D=c[m>>2]|0;E=c[u>>2]|0;F=c[x>>2]|0}else{y=c[A>>2]|0;c[m>>2]=y;c[u>>2]=z;D=y;E=z;F=B}c[m>>2]=XEi(D|0)|0;D=E+4|0;if(D>>>0>F>>>0){Bid(u,o,4);G=c[o>>2]|0;H=c[u>>2]|0;I=c[x>>2]|0}else{B=c[E>>2]|0;c[o>>2]=B;c[u>>2]=D;G=B;H=D;I=F}c[o>>2]=XEi(G|0)|0;G=H+4|0;if(G>>>0>I>>>0){Bid(u,n,4);J=c[n>>2]|0;K=c[u>>2]|0;L=c[x>>2]|0}else{F=c[H>>2]|0;c[n>>2]=F;c[u>>2]=G;J=F;K=G;L=I}c[n>>2]=XEi(J|0)|0;J=K+1|0;if(J>>>0>L>>>0){Bid(u,q,1);M=c[u>>2]|0;N=c[x>>2]|0}else{a[q>>0]=a[K>>0]|0;c[u>>2]=J;M=J;N=L}L=d+127|0;if((M+1|0)>>>0>N>>>0){Bid(u,L,1);O=c[u>>2]|0}else{a[L>>0]=a[M>>0]|0;M=(c[u>>2]|0)+1|0;c[u>>2]=M;O=M}M=d+128|0;if((O+1|0)>>>0>(c[x>>2]|0)>>>0)Bid(u,M,1);else{a[M>>0]=a[O>>0]|0;c[u>>2]=(c[u>>2]|0)+1}Mdd(f);O=c[u>>2]|0;M=O+4|0;L=c[x>>2]|0;if(M>>>0>L>>>0){Bid(u,p,4);P=c[p>>2]|0;Q=c[u>>2]|0;R=c[x>>2]|0}else{N=c[O>>2]|0;c[p>>2]=N;c[u>>2]=M;P=N;Q=M;R=L}c[p>>2]=XEi(P|0)|0;P=d+100|0;L=Q+4|0;if(L>>>0>R>>>0){Bid(u,P,4);S=c[P>>2]|0}else{R=c[Q>>2]|0;c[P>>2]=R;c[u>>2]=L;S=R}c[P>>2]=XEi(S|0)|0;vCc(d+28|0,f);S=d+52|0;P=c[u>>2]|0;R=P+4|0;L=c[x>>2]|0;if(R>>>0>L>>>0){Bid(u,S,4);T=c[S>>2]|0;U=c[u>>2]|0;V=c[x>>2]|0}else{x=c[P>>2]|0;c[S>>2]=x;c[u>>2]=R;T=x;U=R;V=L}c[S>>2]=XEi(T|0)|0;T=d+56|0;S=U+4|0;if(S>>>0>V>>>0){Bid(u,T,4);W=c[T>>2]|0}else{V=c[U>>2]|0;c[T>>2]=V;c[u>>2]=S;W=V}c[T>>2]=XEi(W|0)|0;c[r>>2]=da(c[o>>2]|0,c[p>>2]|0)|0;Qdd(f,r,596032,1);uEc(d);W=VQb(d)|0;T=VQb(d)|0;V=(W|0)==15?T:13;T=d+48|0;W=c[T>>2]|0;if(W){S=c[153076]|0;u=W+4|0;c[u>>2]=(c[u>>2]|0)+-1;if(!(c[u>>2]|0)){ko[c[c[W>>2]>>2]&4095](W);c[k>>2]=S;c[j+0>>2]=c[k+0>>2];eOb(W,j)}c[T>>2]=0}c[s>>2]=c[153076];c[j+0>>2]=c[s+0>>2];s=bOb(48,j,0,16,3653512,808)|0;c[t>>2]=V;V=c[l>>2]|0;W=c[m>>2]|0;S=c[n>>2]|0;u=c[o>>2]|0;o=c[p>>2]|0;p=(a[q>>0]|0)!=0;c[j+0>>2]=c[t+0>>2];nDc(s,j,V,W,S,u,o,p,1);c[T>>2]=s;s=c[l>>2]|0;c[d+104>>2]=s;c[d+108>>2]=c[m>>2];l=a[q>>0]|0;a[d+96>>0]=l;p=l<<24>>24!=0;l=c[n>>2]|0;o=XFc(l)|0;u=s+-1+o&0-o;switch(l|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{X=1;break}default:X=(l+-48|0)>>>0<12}l=c[155286]|0;if((a[621152]|0)==0|X&(l|0)<2^1)Y=u;else{X=u+-1|0;u=X>>>16|X;X=u>>>8|u;u=X>>>4|X;X=u>>>2|u;Y=(X>>>1|X)+1|0}if(p?(l|0)==2:(l|0)>0)Z=Y;else{l=Y+-1|0;Y=l>>>16|l;l=Y>>>8|Y;Y=l>>>4|l;l=Y>>>2|Y;Z=(l>>>1|l)+1|0}l=d+112|0;c[l>>2]=Z;Z=c[m>>2]|0;m=(a[q>>0]|0)!=0;q=c[n>>2]|0;Y=XFc(q)|0;p=Z+-1+Y&0-Y;switch(q|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{_=1;break}default:_=(q+-48|0)>>>0<12}q=c[155286]|0;if((a[621152]|0)==0|_&(q|0)<2^1)$=p;else{_=p+-1|0;p=_>>>16|_;_=p>>>8|p;p=_>>>4|_;_=p>>>2|p;$=(_>>>1|_)+1|0}if(m?(q|0)==2:(q|0)>0)aa=$;else{q=$+-1|0;$=q>>>16|q;q=$>>>8|$;$=q>>>4|q;q=$>>>2|$;aa=(q>>>1|q)+1|0}c[d+116>>2]=aa;ba=ea(ea(1.0)/ea(aa|0));g[d+72>>2]=ea(ea(1.0)/ea(c[l>>2]|0));g[d+76>>2]=ba;l=mo[c[(c[d>>2]|0)+104>>2]&4095](d)|0;if(!(l+-1&l)){l=mo[c[(c[d>>2]|0)+108>>2]&4095](d)|0;aa=(l+-1&l|0)==0;a[d+124>>0]=aa&1;if(!aa)ca=53}else{a[d+124>>0]=0;ca=53}if((ca|0)==53?(ca=(mo[c[(c[d>>2]|0)+124>>2]&4095](d)|0)^1,(c[155286]|0)==1&ca):0)c[d+40>>2]=1;d=c[T>>2]|0;if(!d)fa=0;else fa=c[d+8>>2]|0;Odd(f,c[r>>2]|0,fa,0);f=c[n>>2]|0;n=c[r>>2]|0;if((f|0)==2|(f|0)==7|(f|0)==13){r=(n|0)/2|0;if((n|0)<=1){c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}d=0;T=fa;while(1){ca=e[T>>1]|0;b[T>>1]=ca<<8|ca>>>8;d=d+1|0;if((d|0)==(r|0))break;else T=T+2|0}c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}else if((f|0)==6){f=(n|0)/4|0;if((n|0)<=3){c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}n=0;T=fa;while(1){c[T>>2]=XEi(c[T>>2]|0)|0;n=n+1|0;if((n|0)==(f|0))break;else T=T+4|0}c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}else{c[k>>2]=60;c[j+0>>2]=c[k+0>>2];eOb(0,j);i=h;return}}function dFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+48|0;f=e+4|0;g=e+16|0;h=e+20|0;j=e+24|0;k=e+28|0;l=e;m=e+12|0;n=e+32|0;o=e+8|0;eEc(b,d);zEc(b);c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;a[n>>0]=0;p=b+48|0;q=c[p>>2]|0;if(!q)r=0;else{s=c[q+24>>2]|0;c[h>>2]=s;c[j>>2]=c[q+28>>2];c[k>>2]=c[q+32>>2];c[l>>2]=c[q+36>>2];c[m>>2]=c[q+40>>2];a[n>>0]=a[q+44>>0]|0;r=s}s=d+12|0;q=c[s>>2]|0;t=q+4|0;u=d+20|0;v=c[u>>2]|0;if(t>>>0<v>>>0){c[q>>2]=r;c[s>>2]=t;w=t;x=v}else{Gid(s,h,4);w=c[s>>2]|0;x=c[u>>2]|0}h=w+4|0;if(h>>>0<x>>>0){c[w>>2]=c[j>>2];c[s>>2]=h;y=h;z=x}else{Gid(s,j,4);y=c[s>>2]|0;z=c[u>>2]|0}j=y+4|0;if(j>>>0<z>>>0){c[y>>2]=c[l>>2];c[s>>2]=j;A=j;B=z}else{Gid(s,l,4);A=c[s>>2]|0;B=c[u>>2]|0}z=A+4|0;if(z>>>0<B>>>0){c[A>>2]=c[k>>2];c[s>>2]=z;C=z;D=B}else{Gid(s,k,4);C=c[s>>2]|0;D=c[u>>2]|0}if((C+1|0)>>>0<D>>>0){a[C>>0]=a[n>>0]|0;C=(c[s>>2]|0)+1|0;c[s>>2]=C;E=C}else{Gid(s,n,1);E=c[s>>2]|0}n=b+127|0;if((E+1|0)>>>0<(c[u>>2]|0)>>>0){a[E>>0]=a[n>>0]|0;E=(c[s>>2]|0)+1|0;c[s>>2]=E;F=E}else{Gid(s,n,1);F=c[s>>2]|0}n=b+128|0;if((F+1|0)>>>0<(c[u>>2]|0)>>>0){a[F>>0]=a[n>>0]|0;c[s>>2]=(c[s>>2]|0)+1}else Gid(s,n,1);Tdd(d);n=c[s>>2]|0;F=n+4|0;E=c[u>>2]|0;if(F>>>0<E>>>0){c[n>>2]=c[m>>2];c[s>>2]=F;G=F;H=E}else{Gid(s,m,4);G=c[s>>2]|0;H=c[u>>2]|0}E=b+100|0;F=G+4|0;if(F>>>0<H>>>0){c[G>>2]=c[E>>2];c[s>>2]=F}else Gid(s,E,4);wCc(b+28|0,d);E=b+52|0;F=c[s>>2]|0;G=F+4|0;H=c[u>>2]|0;if(G>>>0<H>>>0){c[F>>2]=c[E>>2];c[s>>2]=G;I=G;J=H}else{Gid(s,E,4);I=c[s>>2]|0;J=c[u>>2]|0}u=b+56|0;b=I+4|0;if(b>>>0<J>>>0){c[I>>2]=c[u>>2];c[s>>2]=b}else Gid(s,u,4);c[o>>2]=da(c[l>>2]|0,c[m>>2]|0)|0;Udd(d,o,596032,1);m=c[p>>2]|0;if(!m){K=0;L=c[o>>2]|0;Vdd(d,L,K,0);c[g>>2]=60;c[f+0>>2]=c[g+0>>2];eOb(0,f);i=e;return}K=c[m+8>>2]|0;L=c[o>>2]|0;Vdd(d,L,K,0);c[g>>2]=60;c[f+0>>2]=c[g+0>>2];eOb(0,f);i=e;return}function eFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;fEc(a,b);zEc(a);c[f>>2]=60;c[e+0>>2]=c[f+0>>2];eOb(0,e);i=d;return}function fFc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+160|0;h=g;j=g+64|0;k=g+68|0;l=g+88|0;m=g+32|0;n=g+12|0;o=g+44|0;p=g+100|0;q=g+120|0;r=g+132|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;s=b+48|0;b=c[s>>2]|0;if(!b){t=0;i=g;return t|0}if(oDc(b,k,0,d)|0){b=c[k+4>>2]|0;u=c[k+8>>2]|0;if((da(u,b)|0)<=(f|0)){iwc(r,b,u,VFc(b,4)|0,4,e);hwc(r,k,0);t=1;i=g;return t|0}c[h>>2]=f;c[h+4>>2]=b;c[h+8>>2]=u;Lsd(q,595072,h);if(!(a[q>>0]&1))v=q+1|0;else v=c[q+8>>2]|0;Krd(v,0,3653512,1239,1,0,0,0);xri(q);t=0;i=g;return t|0}q=c[s>>2]|0;if(!q){t=0;i=g;return t|0}v=c[q+32>>2]|0;switch(v|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((v+-48|0)>>>0>=12){t=0;i=g;return t|0}}u=ewc(c[q+24>>2]|0,c[q+28>>2]|0,v,d)|0;v=(c[q+8>>2]|0)+u|0;u=YFc(c[(c[s>>2]|0)+32>>2]|0)|0;q=c[s>>2]|0;b=c[q+24>>2]>>d;k=(b|0)<(u|0)?u:b;b=c[q+28>>2]>>d;r=(b|0)<(u|0)?u:b;if(((k|0)%(u|0)|0|0)==0?((r|0)%(u|0)|0|0)==0:0){if((da(r,k)|0)<=(f|0)){yCc(c[q+32>>2]|0,k,r,d,v,k,r,e)|0;t=1;i=g;return t|0}c[h>>2]=f;c[h+4>>2]=k;c[h+8>>2]=r;Lsd(l,595072,h);if(!(a[l>>0]&1))w=l+1|0;else w=c[l+8>>2]|0;Krd(w,0,3653512,1204,1,0,0,0);xri(l);t=0;i=g;return t|0}l=u+-1|0;w=l+k|0;q=w-((w|0)%(u|0)|0)|0;w=l+r|0;l=w-((w|0)%(u|0)|0)|0;if((da(l,q)|0)<=(f|0)){mwc(n,q,l,4);u=n+16|0;yCc(c[(c[s>>2]|0)+32>>2]|0,k,r,d,v,q,l,c[u>>2]|0)|0;lwc(o,n,0,0,k,r);iwc(p,k,r,VFc(k,4)|0,4,e);hwc(p,o,0);o=c[u>>2]|0;c[j>>2]=c[153068];c[h+0>>2]=c[j+0>>2];eOb(o,h);t=1;i=g;return t|0}c[h>>2]=f;c[h+4>>2]=q;c[h+8>>2]=l;Lsd(m,595072,h);if(!(a[m>>0]&1))x=m+1|0;else x=c[m+8>>2]|0;Krd(x,0,3653512,1217,1,0,0,0);xri(m);t=0;i=g;return t|0}function gFc(b,d,e,f,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;o=i;i=i+64|0;p=o;q=o+48|0;r=o+28|0;s=o+8|0;if(((l|k|0)>=0?(mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0)>(k|0):0)?(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0)>(l|0):0){if((j|h|0)<0){if(!b)t=0;else t=c[b+4>>2]|0;Krd(595200,0,3653512,1331,1,t,0,0);i=o;return}if((a[(ync()|0)+5832>>0]|0)==0?(tBc()|0)==0:0){if(!b)u=0;else u=c[b+4>>2]|0;Krd(595248,0,3653512,1337,1,u,0,0)}u=b+48|0;t=c[u>>2]|0;if((d|0)>=0){if(!t)v=0;else v=c[t+40>>2]|0;if((v|0)>(d|0)){v=(c[(ync()|0)+5980>>2]|0)+-8|0;if(v>>>0<9)w=265>>>(v&511)&1;else w=0;v=c[u>>2]|0;if(!v){c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;if(!b)x=0;else y=38}else{z=c[v+32>>2]|0;if(!((z|0)==3|(z|0)==5)?(z|0)!=(w|0):0){if(!b)A=0;else A=c[b+4>>2]|0;Krd(595496,0,3653512,1356,1,A,0,0);i=o;return};c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;zEc(b);if(oDc(c[u>>2]|0,r,d,0)|0){if(!(tBc()|0)){u=n8b()|0;B=ea(g[u+56>>2]);C=~~ea(ea(e|0)+B);D=~~ea(ea(f|0)+ea(g[u+60>>2]))}else{C=e;D=f}f=(C|0)<0;e=(f?C:0)+h|0;h=(D|0)<0;u=(h?D:0)+j|0;if((e+k|0)>(mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0))E=(mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0)-k|0;else E=e;if((u+l|0)>(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0))F=(mo[c[(c[b>>2]|0)+108>>2]&4095](b)|0)-l|0;else F=u;u=ync()|0;Oo[c[(c[u>>2]|0)+596>>2]&63](u,r,f?0:C,h?0:D,E,F,k,l)|0;if(m){lwc(s,r,k,l,E,F);jwc(s)}if(!n){i=o;return}if(!(mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0)){i=o;return}ko[c[(c[b>>2]|0)+160>>2]&4095](b);i=o;return}else y=38}if((y|0)==38)x=c[b+4>>2]|0;Krd(595032,0,3653512,1363,1,x,0,0);i=o;return}}if(!t)G=-1;else G=(c[t+40>>2]|0)+-1|0;c[p>>2]=d;c[p+4>>2]=G;Lsd(q,595344,p);if(!b)H=0;else H=c[b+4>>2]|0;if(!(a[q>>0]&1))I=q+1|0;else I=c[q+8>>2]|0;Krd(I,0,3653512,1343,1,H,0,0);xri(q);i=o;return}if(!b)J=0;else J=c[b+4>>2]|0;Krd(595160,0,3653512,1326,1,J,0,0);i=o;return}function hFc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;if(!(a[b+127>>0]|0)){Krd(595416,0,3653512,1442,1,c[b+4>>2]|0,0,0);j=0;i=h;return j|0}switch(f|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((f+-48|0)>>>0>=12){j=gn[c[(c[b>>2]|0)+148>>2]&127](b,d,e,f,g,1,0)|0;i=h;return j|0}}Krd(595448,0,3653512,1448,1,c[b+4>>2]|0,0,0);j=0;i=h;return j|0}function iFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(136,f,1,16,3653512,77)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];yDc(h,f,d);c[h>>2]=594568;d=h+132|0;c[d>>2]=0;f=h+100|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;a[h+124>>0]=1;a[h+127>>0]=1;a[h+129>>0]=0;a[h+128>>0]=1;a[h+125>>0]=0;a[h+126>>0]=0;f=Cnc()|0;c[d>>2]=mo[c[(c[f>>2]|0)+452>>2]&4095](f)|0;i=e;return h|0}function jFc(a){a=a|0;var b=0;b=i;c[a>>2]=594568;uEc(a);Cuc(a);i=b;return}function kFc(a){a=a|0;var b=0;b=i;c[a>>2]=594568;uEc(a);Cuc(a);ACi(a);i=b;return}function lFc(a){a=a|0;return c[a+100>>2]|0}function mFc(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];yDc(a,g,e);c[a>>2]=595592;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=0;c[a+112>>2]=5;e=a+116|0;c[e+0>>2]=0;c[e+4>>2]=0;b[e+8>>1]=0;i=f;return}function nFc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+125|0;if(!(a[g>>0]|0)){ADc(b);i=d;return}h=ync()|0;j=c[(c[h>>2]|0)+484>>2]|0;c[f>>2]=c[b+44>>2];c[e+0>>2]=c[f+0>>2];In[j&4095](h,e);a[g>>0]=0;ADc(b);i=d;return}function oFc(a,b){a=a|0;b=b|0;var d=0;d=i;if((b&-5|0)==0?(c[a+116>>2]|0)==0:0){i=d;return}pFc(a,0);i=d;return}function pFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;if(!(a[621142]|0)){i=e;return}j=OOc()|0;if((j|0)!=0?(a[j+93>>0]|0)==0:0){i=e;return}if(d)k=2;else k=(a[b+125>>0]|0)==0?2:0;d=ync()|0;j=c[(c[d>>2]|0)+480>>2]|0;l=b+44|0;c[g>>2]=c[l>>2];m=c[b+116>>2]|0;n=c[b+120>>2]|0;o=c[b+100>>2]|0;p=c[b+104>>2]|0;q=c[b+108>>2]|0;r=c[b+112>>2]|0;s=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;c[f+0>>2]=c[g+0>>2];yn[j&7](d,f,m,n,o,p,q,r,s,k);k=c[l>>2]|0;s=b;r=c[148593]|0;do if(r){q=r;while(1){p=c[q+16>>2]|0;if(k>>>0<p>>>0){o=c[q>>2]|0;if(!o){t=q;u=q;v=9;break}else{q=o;continue}}if(p>>>0>=k>>>0){w=q;v=13;break}p=q+4|0;o=c[p>>2]|0;if(!o){x=p;y=q;v=12;break}else q=o}if((v|0)==9){c[f>>2]=u;z=t;A=u;break}else if((v|0)==12){c[f>>2]=y;z=x;A=y;break}else if((v|0)==13){c[f>>2]=w;z=f;A=w;break}}else{c[f>>2]=594372;z=594372;A=594372}while(0);if(!(c[z>>2]|0)){w=xCi(24)|0;v=w+16|0;c[v>>2]=k;c[v+4>>2]=s;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=A;c[z>>2]=w;A=c[c[148592]>>2]|0;if(!A)B=w;else{c[148592]=A;B=c[z>>2]|0}GN(c[148593]|0,B);c[148594]=(c[148594]|0)+1}ko[c[(c[b>>2]|0)+132>>2]&4095](b);B=ync()|0;z=c[(c[B>>2]|0)+644>>2]|0;c[h>>2]=c[l>>2];l=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;c[f+0>>2]=c[h+0>>2];co[z&2047](B,f,l);a[b+125>>0]=1;i=e;return}function qFc(a){a=a|0;var b=0;b=i;CDc(a);bGc(a+28|0);i=b;return}function rFc(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=0,C=0;k=i;i=i+16|0;l=k+8|0;m=k+4|0;n=k;if(((d+-1&d|0)==0?(e+-1&e|0)==0:0)?(f+-1&f|0)==0:0){if((h|0)<=9?WFc(h)|0:0){if(d>>>0>1024|(e|0)<0|(e|0)>1024|(f|0)<0|(f|0)>1024){if(!b)o=0;else o=c[b+4>>2]|0;Krd(595816,0,3653512,85,1,o,0,0);p=0;i=k;return p|0}o=b+100|0;c[o>>2]=d;q=b+104|0;c[q>>2]=e;c[b+108>>2]=f;r=b+112|0;c[r>>2]=h;a[b+124>>0]=j&1;j=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;s=TFc(h)|0;if((j|0)>0){h=0;t=0;while(1){u=d>>t;v=e>>t;w=f>>t;x=(da(da(da((u|0)<1?1:u,s)|0,(v|0)<1?1:v)|0,(w|0)<1?1:w)|0)+h|0;t=t+1|0;if((t|0)==(j|0)){y=x;break}else h=x}}else y=0;h=(TFc(c[r>>2]|0)|0)+y|0;c[m>>2]=c[153076];c[l+0>>2]=c[m+0>>2];r=cOb(h,32,l,0,3653512,118)|0;if(!r){p=0;i=k;return p|0}PEi(r|0,-51,h|0)|0;h=b+116|0;j=c[h>>2]|0;c[n>>2]=c[153076];c[l+0>>2]=c[n+0>>2];eOb(j,l);c[h>>2]=0;j=b+120|0;c[j>>2]=0;n=b+125|0;if(a[n>>0]|0){t=ync()|0;s=c[(c[t>>2]|0)+484>>2]|0;c[m>>2]=c[b+44>>2];c[l+0>>2]=c[m+0>>2];In[s&4095](t,l);a[n>>0]=0}c[h>>2]=r;c[j>>2]=y;z=ea(ea(1.0)/ea(c[o>>2]|0));A=ea(ea(1.0)/ea(c[q>>2]|0));g[b+72>>2]=z;g[b+76>>2]=A;p=1;i=k;return p|0}if(!b)B=0;else B=c[b+4>>2]|0;Krd(595776,0,3653512,78,1,B,0,0);p=0;i=k;return p|0}if(!b)C=0;else C=c[b+4>>2]|0;Krd(595736,0,3653512,73,1,C,0,0);p=0;i=k;return p|0}function sFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;a:do if((d?(a[b+124>>0]|0)!=0:0)?(f=c[b+116>>2]|0,(f|0)!=0):0){g=c[b+112>>2]|0;switch(g|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:break;default:if((g+-48|0)>>>0>=12){gwc(f,c[b+100>>2]|0,c[b+104>>2]|0,c[b+108>>2]|0,g);break a}}if(!b)h=0;else h=c[b+4>>2]|0;Krd(595872,0,3653512,184,1,h,0,0)}while(0);pFc(b,0);i=e;return}function tFc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=a+116|0;if(!(c[f>>2]|0)){g=0;i=d;return g|0}h=c[a+100>>2]|0;j=c[a+104>>2]|0;k=a+112|0;a=da(TFc(c[k>>2]|0)|0,h)|0;iwc(e,h,j,a,c[k>>2]|0,c[f>>2]|0);hwc(b,e,2);g=1;i=d;return g|0}function uFc(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+124>>0]|0)){e=1;i=d;return e|0}e=cwc(c[b+100>>2]|0,c[b+104>>2]|0,c[b+108>>2]|0)|0;i=d;return e|0}function vFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+125|0;if(!(a[g>>0]|0)){i=d;return}h=ync()|0;j=c[(c[h>>2]|0)+484>>2]|0;c[f>>2]=c[b+44>>2];c[e+0>>2]=c[f+0>>2];In[j&4095](h,e);a[g>>0]=0;i=d;return}function wFc(a){a=a|0;var b=0;b=i;pFc(a,1);i=b;return}function xFc(){var a=0;a=i;QQb(117,146,0,0,0);i=a;return}function yFc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(27)|0))UDc();rri(b,595936,9);wQb(117,27,b,128,2626,0,0);xri(b);i=a;return}function zFc(a){a=a|0;return 117}function AFc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,595936,a,0);HFc(a,b);bdd(b);i=c;return}function BFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,595936,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else IFc(a,b);sdd(b);i=d;return}function CFc(a,b){a=a|0;b=b|0;var c=0;c=i;JFc(a,b);i=c;return}function DFc(a,b){a=a|0;b=b|0;var c=0;c=i;KFc(a,b);i=c;return}function EFc(a,b){a=a|0;b=b|0;var c=0;c=i;LFc(a,b);i=c;return}function FFc(a,b){a=a|0;b=b|0;var c=0;c=i;fEc(a,b);i=c;return}function GFc(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(128,f,1,16,3653512,9)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];yDc(h,f,d);c[h>>2]=595592;c[h+100>>2]=0;c[h+104>>2]=0;c[h+108>>2]=0;c[h+112>>2]=5;d=h+116|0;c[d+0>>2]=0;c[d+4>>2]=0;b[d+8>>1]=0;i=e;return h|0}function HFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;aEc(a,b);f=c[142270]|0;add(b,2356976,f,a+100|0,16);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2357176,f,a+104|0,16);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,595952,f,a+108|0,16);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,595960,f,a+112|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,595976,c[142258]|0,a+124|0,16);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);f=a+120|0;add(b,595992,c[142304]|0,f,16);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);h=a+28|0;add(b,596008,596048,h,0);sCc(h,b);bdd(b);c[e>>2]=c[f>>2];edd(b,e,596032,1);gdd(b,c[e>>2]|0,c[a+116>>2]|0,0);i=d;return}function IFc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=0,E=Im,F=Im,G=0,H=0,I=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;bEc(b,d);l=b+100|0;m=c[142270]|0;n=qdd(d,2356976,m,f,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=o+p|0;c[n>>2]=q;if((p|0)>=0?(r=o+(p+4)|0,r>>>0<=(c[d+20>>2]|0)>>>0):0){c[l>>2]=c[q>>2];c[n>>2]=r}else Bid(n,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](l,d)|0}sdd(d)}n=b+104|0;r=qdd(d,2357176,m,f,0)|0;if(r){if((r|0)>0){r=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=q+p|0;c[r>>2]=o;if((p|0)>=0?(s=q+(p+4)|0,s>>>0<=(c[d+20>>2]|0)>>>0):0){c[n>>2]=c[o>>2];c[r>>2]=s}else Bid(r,n,4);if(c[d>>2]&512)c[n>>2]=XEi(c[n>>2]|0)|0}else{r=c[f>>2]|0;if(r)_n[r&4095](n,d)|0}sdd(d)}r=b+108|0;s=qdd(d,595952,m,f,0)|0;if(s){if((s|0)>0){s=d+12|0;o=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=o+p|0;c[s>>2]=q;if((p|0)>=0?(t=o+(p+4)|0,t>>>0<=(c[d+20>>2]|0)>>>0):0){c[r>>2]=c[q>>2];c[s>>2]=t}else Bid(s,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{s=c[f>>2]|0;if(s)_n[s&4095](r,d)|0}sdd(d)}r=b+112|0;s=qdd(d,595960,m,f,0)|0;if(s){if((s|0)>0){s=d+12|0;m=c[d+16>>2]|0;t=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+t|0;c[s>>2]=q;if((t|0)>=0?(p=m+(t+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[r>>2]=c[q>>2];c[s>>2]=p}else Bid(s,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{s=c[f>>2]|0;if(s)_n[s&4095](r,d)|0}sdd(d)}s=b+124|0;p=qdd(d,595976,c[142258]|0,f,0)|0;if(p){do if((p|0)<=0){q=c[f>>2]|0;if(q)_n[q&4095](s,d)|0}else{q=d+12|0;t=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=t+m|0;c[q>>2]=o;if((m|0)>=0?(t+(m+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[s>>0]=a[o>>0]|0;c[q>>2]=(c[q>>2]|0)+1;break}Bid(q,s,1)}while(0);sdd(d)}s=b+120|0;p=qdd(d,595992,c[142304]|0,f,0)|0;if(p){if((p|0)>0){p=d+12|0;q=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+o|0;c[p>>2]=m;if((o|0)>=0?(t=q+(o+4)|0,t>>>0<=(c[d+20>>2]|0)>>>0):0){c[s>>2]=c[m>>2];c[p>>2]=t}else Bid(p,s,4);if(c[d>>2]&512)c[s>>2]=XEi(c[s>>2]|0)|0}else{p=c[f>>2]|0;if(p)_n[p&4095](s,d)|0}sdd(d)}p=b+28|0;t=qdd(d,596008,596048,f,1)|0;if(t){if((t|0)<=0){t=c[f>>2]|0;if(t)_n[t&4095](p,d)|0}else tCc(p,d);sdd(d)}c[k>>2]=c[s>>2];ydd(d,k,596032,1);p=b+116|0;t=c[p>>2]|0;c[j>>2]=c[153076];c[f+0>>2]=c[j+0>>2];eOb(t,f);c[p>>2]=0;c[s>>2]=0;t=b+125|0;if(!(a[t>>0]|0)){u=c[k>>2]|0;c[s>>2]=u;v=c[r>>2]|0;w=TFc(v)|0;x=w+u|0;y=c[153076]|0;c[h>>2]=y;c[f+0>>2]=c[h+0>>2];z=cOb(x,32,f,0,3653512,118)|0;c[p>>2]=z;A=c[l>>2]|0;B=ea(A|0);C=ea(ea(1.0)/B);D=c[n>>2]|0;E=ea(D|0);F=ea(ea(1.0)/E);G=b+72|0;g[G>>2]=C;H=b+76|0;g[H>>2]=F;I=c[k>>2]|0;zdd(d,I,z,0);i=e;return}j=ync()|0;m=c[(c[j>>2]|0)+484>>2]|0;c[h>>2]=c[b+44>>2];c[f+0>>2]=c[h+0>>2];In[m&4095](j,f);a[t>>0]=0;u=c[k>>2]|0;c[s>>2]=u;v=c[r>>2]|0;w=TFc(v)|0;x=w+u|0;y=c[153076]|0;c[h>>2]=y;c[f+0>>2]=c[h+0>>2];z=cOb(x,32,f,0,3653512,118)|0;c[p>>2]=z;A=c[l>>2]|0;B=ea(A|0);C=ea(ea(1.0)/B);D=c[n>>2]|0;E=ea(D|0);F=ea(ea(1.0)/E);G=b+72|0;g[G>>2]=C;H=b+76|0;g[H>>2]=F;I=c[k>>2]|0;zdd(d,I,z,0);i=e;return}function JFc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;cEc(b,d);l=b+100|0;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;q=c[p>>2]|0;if(o>>>0>q>>>0){Bid(m,l,4);r=c[m>>2]|0;s=c[p>>2]|0}else{c[l>>2]=c[n>>2];c[m>>2]=o;r=o;s=q}q=b+104|0;o=r+4|0;if(o>>>0>s>>>0){Bid(m,q,4);t=c[m>>2]|0;u=c[p>>2]|0}else{c[q>>2]=c[r>>2];c[m>>2]=o;t=o;u=s}s=b+108|0;o=t+4|0;if(o>>>0>u>>>0){Bid(m,s,4);v=c[m>>2]|0;w=c[p>>2]|0}else{c[s>>2]=c[t>>2];c[m>>2]=o;v=o;w=u}u=b+112|0;o=v+4|0;if(o>>>0>w>>>0){Bid(m,u,4);x=c[m>>2]|0;y=c[p>>2]|0}else{c[u>>2]=c[v>>2];c[m>>2]=o;x=o;y=w}w=b+124|0;if((x+1|0)>>>0>y>>>0)Bid(m,w,1);else{a[w>>0]=a[x>>0]|0;c[m>>2]=(c[m>>2]|0)+1}Ndd(d);x=b+120|0;w=c[m>>2]|0;y=w+4|0;if(y>>>0>(c[p>>2]|0)>>>0)Bid(m,x,4);else{c[x>>2]=c[w>>2];c[m>>2]=y}uCc(b+28|0,d);c[k>>2]=c[x>>2];Rdd(d,k,596032,1);y=b+116|0;m=c[y>>2]|0;c[j>>2]=c[153076];c[f+0>>2]=c[j+0>>2];eOb(m,f);c[y>>2]=0;c[x>>2]=0;m=b+125|0;if(a[m>>0]|0){j=ync()|0;w=c[(c[j>>2]|0)+484>>2]|0;c[h>>2]=c[b+44>>2];c[f+0>>2]=c[h+0>>2];In[w&4095](j,f);a[m>>0]=0}m=c[k>>2]|0;c[x>>2]=m;x=(TFc(c[u>>2]|0)|0)+m|0;c[h>>2]=c[153076];c[f+0>>2]=c[h+0>>2];h=cOb(x,32,f,0,3653512,118)|0;c[y>>2]=h;z=ea(ea(1.0)/ea(c[l>>2]|0));A=ea(ea(1.0)/ea(c[q>>2]|0));g[b+72>>2]=z;g[b+76>>2]=A;Pdd(d,c[k>>2]|0,h,0);i=e;return}function KFc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;dEc(b,d);l=b+100|0;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;q=c[p>>2]|0;if(o>>>0>q>>>0){Bid(m,l,4);r=c[l>>2]|0;s=c[m>>2]|0;t=c[p>>2]|0}else{u=c[n>>2]|0;c[l>>2]=u;c[m>>2]=o;r=u;s=o;t=q}c[l>>2]=XEi(r|0)|0;r=b+104|0;q=s+4|0;if(q>>>0>t>>>0){Bid(m,r,4);v=c[r>>2]|0;w=c[m>>2]|0;x=c[p>>2]|0}else{o=c[s>>2]|0;c[r>>2]=o;c[m>>2]=q;v=o;w=q;x=t}c[r>>2]=XEi(v|0)|0;v=b+108|0;t=w+4|0;if(t>>>0>x>>>0){Bid(m,v,4);y=c[v>>2]|0;z=c[m>>2]|0;A=c[p>>2]|0}else{q=c[w>>2]|0;c[v>>2]=q;c[m>>2]=t;y=q;z=t;A=x}c[v>>2]=XEi(y|0)|0;y=b+112|0;v=z+4|0;if(v>>>0>A>>>0){Bid(m,y,4);B=c[y>>2]|0;C=c[m>>2]|0;D=c[p>>2]|0}else{x=c[z>>2]|0;c[y>>2]=x;c[m>>2]=v;B=x;C=v;D=A}c[y>>2]=XEi(B|0)|0;B=b+124|0;if((C+1|0)>>>0>D>>>0)Bid(m,B,1);else{a[B>>0]=a[C>>0]|0;c[m>>2]=(c[m>>2]|0)+1}Mdd(d);C=b+120|0;B=c[m>>2]|0;D=B+4|0;if(D>>>0>(c[p>>2]|0)>>>0){Bid(m,C,4);E=c[C>>2]|0}else{p=c[B>>2]|0;c[C>>2]=p;c[m>>2]=D;E=p}c[C>>2]=XEi(E|0)|0;vCc(b+28|0,d);c[k>>2]=c[C>>2];Qdd(d,k,596032,1);E=b+116|0;p=c[E>>2]|0;c[j>>2]=c[153076];c[f+0>>2]=c[j+0>>2];eOb(p,f);c[E>>2]=0;c[C>>2]=0;p=b+125|0;if(a[p>>0]|0){j=ync()|0;D=c[(c[j>>2]|0)+484>>2]|0;c[h>>2]=c[b+44>>2];c[f+0>>2]=c[h+0>>2];In[D&4095](j,f);a[p>>0]=0}p=c[k>>2]|0;c[C>>2]=p;C=(TFc(c[y>>2]|0)|0)+p|0;c[h>>2]=c[153076];c[f+0>>2]=c[h+0>>2];h=cOb(C,32,f,0,3653512,118)|0;c[E>>2]=h;F=ea(ea(1.0)/ea(c[l>>2]|0));G=ea(ea(1.0)/ea(c[r>>2]|0));g[b+72>>2]=F;g[b+76>>2]=G;Odd(d,c[k>>2]|0,h,0);i=e;return}function LFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;eEc(b,d);g=b+100|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){c[j>>2]=c[g>>2];c[h>>2]=k;n=k;o=m}else{Gid(h,g,4);n=c[h>>2]|0;o=c[l>>2]|0}g=b+104|0;m=n+4|0;if(m>>>0<o>>>0){c[n>>2]=c[g>>2];c[h>>2]=m;p=m;q=o}else{Gid(h,g,4);p=c[h>>2]|0;q=c[l>>2]|0}g=b+108|0;o=p+4|0;if(o>>>0<q>>>0){c[p>>2]=c[g>>2];c[h>>2]=o;r=o;s=q}else{Gid(h,g,4);r=c[h>>2]|0;s=c[l>>2]|0}g=b+112|0;q=r+4|0;if(q>>>0<s>>>0){c[r>>2]=c[g>>2];c[h>>2]=q;t=q;u=s}else{Gid(h,g,4);t=c[h>>2]|0;u=c[l>>2]|0}g=b+124|0;if((t+1|0)>>>0<u>>>0){a[t>>0]=a[g>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,g,1);Tdd(d);g=b+120|0;t=c[h>>2]|0;u=t+4|0;if(u>>>0<(c[l>>2]|0)>>>0){c[t>>2]=c[g>>2];c[h>>2]=u}else Gid(h,g,4);wCc(b+28|0,d);c[f>>2]=c[g>>2];Udd(d,f,596032,1);Vdd(d,c[f>>2]|0,c[b+116>>2]|0,0);i=e;return}function MFc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[b>>2]=595592;h=b+116|0;j=c[h>>2]|0;c[g>>2]=c[153076];c[e+0>>2]=c[g+0>>2];eOb(j,e);c[h>>2]=0;c[b+120>>2]=0;h=b+125|0;if(!(a[h>>0]|0)){Cuc(b);i=d;return}j=ync()|0;g=c[(c[j>>2]|0)+484>>2]|0;c[f>>2]=c[b+44>>2];c[e+0>>2]=c[f+0>>2];In[g&4095](j,e);a[h>>0]=0;Cuc(b);i=d;return}function NFc(a){a=a|0;var b=0;b=i;MFc(a);ACi(a);i=b;return}function OFc(a){a=a|0;return c[a+120>>2]|0}function PFc(a){a=a|0;return 3}function QFc(a){a=a|0;return c[a+100>>2]|0}function RFc(a){a=a|0;return c[a+104>>2]|0}function SFc(b){b=b|0;return (a[b+124>>0]|0)!=0|0}function TFc(a){a=a|0;var b=0;if((a|0)==14)b=4;else b=c[596072+(a<<2)>>2]|0;return b|0}function UFc(a){a=a|0;return 16}function VFc(a,b){a=a|0;b=b|0;var d=0;if((b|0)==14)d=4;else d=c[596072+(b<<2)>>2]|0;b=da(d,a)|0;return b|0}function WFc(a){a=a|0;var b=0;b=i;if((a+-1|0)>>>0<22|(a+-30|0)>>>0<4|(a|0)==34|(a+-35|0)>>>0<2|(a+-45|0)>>>0<3|(a+-48|0)>>>0<12){i=b;return 1}else{i=b;return (a+-41|0)>>>0<4|0}return 0}function XFc(a){a=a|0;var b=0;b=i;switch(a|0){case 10:case 11:case 12:case 34:case 35:case 36:case 45:case 46:case 47:{i=b;return 4}default:{i=b;return ((a+-41|0)>>>0<4?4:1)|0}}return 0}function YFc(a){a=a|0;var b=0,c=0,d=0;b=i;c=a&-2;a:do if((c|0)!=30)if((c|0)!=32){switch(a|0){case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{d=4;break a;break}default:{}}if((a+-48|0)>>>0<12)d=1;else d=(a+-10|0)>>>0<3?4:1}else d=8;else d=16;while(0);i=b;return d|0}function ZFc(a){a=a|0;var b=0;b=i;switch(a|0){case 1:case 2:case 4:case 5:case 6:case 9:case 11:case 12:case 13:case 14:case 17:case 20:case 31:case 33:case 36:case 46:case 47:{i=b;return 1}default:{i=b;return (a+-54|0)>>>0<6|0}}return 0}function _Fc(a){a=a|0;return (a&-3|0)==1|0}function $Fc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[149078]=a;c[149080]=b;if((a|0)<1){Krd(596328,0,3653512,14,1,0,0,0);e=c[149080]|0}else e=b;if((e|0)<=16){i=d;return}Krd(596352,0,3653512,15,1,0,0,0);i=d;return}function aGc(a,b){a=a|0;b=b|0;c[a>>2]=c[149078];c[b>>2]=c[149080];return}function bGc(a){a=a|0;c[a>>2]=1;c[a+4>>2]=1;g[a+8>>2]=ea(0.0);c[a+12>>2]=0;return}function cGc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)<0)e=0;else e=(d|0)>2?2:d;c[a>>2]=e;e=a+12|0;a=c[e>>2]|0;if((a|0)<0){f=0;c[e>>2]=f;i=b;return}f=(a|0)>1?1:a;c[e>>2]=f;i=b;return}function dGc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g+4|0;j=g;k=znc()|0;l=c[a+12>>2]|0;m=c[(c[k>>2]|0)+216>>2]|0;c[j>>2]=c[b>>2];b=c[a>>2]|0;n=c[a+4>>2]|0;if(!((n|0)==0|(b|0)==0)){a=c[149078]|0;if((n|0)<(a|0))o=a;else{a=c[149080]|0;o=(n|0)>(a|0)?a:n}}else o=1;c[h+0>>2]=c[j+0>>2];Nn[m&31](k,h,d,b,l,o,e,f);i=g;return}function eGc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;c[h>>2]=j;c[g+0>>2]=c[h+0>>2];bUb(b,g,e);c[b>>2]=596384;e=b+44|0;a[b+132>>0]=0;a[b+133>>0]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;a[b+134>>0]=1;a[b+135>>0]=11;c[b+140>>2]=0;c[b+144>>2]=j;c[b+148>>2]=0;c[b+152>>2]=0;c[b+156>>2]=0;a[b+136>>0]=0;a[b+137>>0]=0;i=f;return}function fGc(b){b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=0,o=0;d=i;g[b+28>>2]=ea(0.0);g[b+32>>2]=ea(0.0);g[b+36>>2]=ea(0.0);g[b+40>>2]=ea(1.0);e=b+44|0;c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];e=b+56|0;c[e+0>>2]=c[150288];c[e+4>>2]=c[150289];c[e+8>>2]=c[150290];f=ea(g[b+56>>2]);h=ea(g[b+60>>2]);j=ea(f-h);if(j<ea(0.0))k=ea(-j);else k=j;e=!(k<=ea(.0000999999974));k=ea(g[b+64>>2]);do if(!e){j=ea(h-k);if(j<ea(0.0))l=ea(-j);else l=j;if(l<=ea(.0000999999974)){j=ea(f+ea(-1.0));if(j<ea(0.0))m=ea(-j);else m=j;n=b+136|0;if(m<=ea(.0000999999974)){a[n>>0]=0;break}a[n>>0]=1;if(f<ea(0.0))a[n>>0]=6}else o=13}else o=13;while(0);if((o|0)==13)a[b+136>>0]=(ea(ea(f*h)*k)<ea(0.0)&1)<<2|2;a[b+133>>0]=0;a[b+134>>0]=1;if(!(c[b+24>>2]|0)){i=d;return}hGc(b,11);i=d;return}function gGc(b){b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=0,k=Im,l=Im;c=i;d=ea(g[b+56>>2]);e=ea(g[b+60>>2]);f=ea(d-e);if(f<ea(0.0))h=ea(-f);else h=f;j=!(h<=ea(.0000999999974));h=ea(g[b+64>>2]);if(!j){f=ea(e-h);if(f<ea(0.0))k=ea(-f);else k=f;if(k<=ea(.0000999999974)){k=ea(d+ea(-1.0));if(k<ea(0.0))l=ea(-k);else l=k;j=b+136|0;if(l<=ea(.0000999999974)){a[j>>0]=0;i=c;return}a[j>>0]=1;if(!(d<ea(0.0))){i=c;return}a[j>>0]=6;i=c;return}}a[b+136>>0]=(ea(ea(d*e)*h)<ea(0.0)&1)<<2|2;i=c;return}function hGc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+12|0;h=f;j=b+135|0;k=d[j>>0]|e;a[j>>0]=0;j=k>>>5;e=(a[b+137>>0]|0)==0;a[b+133>>0]=0;a[b+134>>0]=1;if(e&(j&1|0)==0){l=c[b+140>>2]|0;m=c[b+148>>2]|0;n=l+(m<<2)|0;if(!m){i=f;return}m=k|1;o=l;do{hGc(c[o>>2]|0,m);o=o+4|0}while((o|0)!=(n|0));i=f;return}n=c[b+24>>2]|0;if(!e){c[g+8>>2]=0;c[g+4>>2]=k;c[g>>2]=1e5;LTb(n,554336,g)}if((j|k>>>7)&1){YTb(n);c[h+8>>2]=0;c[h+4>>2]=0;c[h>>2]=0;LTb(n,554440,h)}h=c[b+140>>2]|0;n=c[b+148>>2]|0;b=h+(n<<2)|0;if(!n){i=f;return}n=k|1;k=h;do{hGc(c[k>>2]|0,n);k=k+4|0}while((k|0)!=(b|0));i=f;return}function iGc(a){a=a|0;return}function jGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+140>>2]|0;f=c[a+148>>2]|0;a=e+(f<<2)|0;a:do if(!f)g=a;else{h=e;while(1){if((c[h>>2]|0)==(b|0)){g=h;break a}h=h+4|0;if((h|0)==(a|0)){g=a;break}}}while(0);i=d;return g|0}function kGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[a+156>>2]|0;if(!f){i=d;return}if(b?(c[a+24>>2]|0)!=0:0)lGc(a);g=f+148|0;h=c[g>>2]|0;a:do if(h){j=h+-1|0;k=c[f+140>>2]|0;if((c[k+(j<<2)>>2]|0)==(a|0)){c[g>>2]=j;break}j=k+(h<<2)|0;l=k;while(1){if((c[l>>2]|0)==(a|0)){m=l;break}l=l+4|0;if((l|0)==(j|0))break a}if((m|0)!=(j|0)){l=m+4|0;aFi(m|0,l|0,j-l|0)|0;c[g>>2]=(c[g>>2]|0)+-1}}while(0);if(!b){i=d;return}if(!(c[a+24>>2]|0)){i=d;return}hGc(a,32);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;LTb(c[f+24>>2]|0,554496,e);i=d;return}function lGc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d+8>>2]=0;c[d+4>>2]=0;c[d>>2]=0;e=c[a+24>>2]|0;if(e)LTb(e,554384,d);d=c[a+140>>2]|0;e=c[a+148>>2]|0;a=d+(e<<2)|0;if(!e){i=b;return}else f=d;do{lGc(c[f>>2]|0);f=f+4|0}while((f|0)!=(a|0));i=b;return}function mGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[a+140>>2]|0;f=a+148|0;a=c[f>>2]|0;g=e+(a<<2)|0;if(!a){i=d;return}else h=e;while(1){if((c[h>>2]|0)==(b|0)){j=h;break}h=h+4|0;if((h|0)==(g|0)){k=6;break}}if((k|0)==6){i=d;return}if((j|0)==(g|0)){i=d;return}k=j+4|0;aFi(j|0,k|0,g-k|0)|0;c[f>>2]=(c[f>>2]|0)+-1;i=d;return}function nGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=i;i=i+96|0;e=d+56|0;f=d+40|0;h=d;j=ea(g[b+28>>2]);k=ea(g[b+32>>2]);l=ea(g[b+36>>2]);m=ea(g[b+40>>2]);n=c[b+156>>2]|0;if(!n){o=j;p=k;q=l;r=m}else{s=j;j=m;m=l;l=k;t=n;while(1){k=ea(g[t+40>>2]);u=ea(s*k);v=ea(g[t+28>>2]);w=ea(u+ea(j*v));u=ea(g[t+32>>2]);x=ea(w+ea(m*u));w=ea(g[t+36>>2]);y=ea(x-ea(l*w));x=ea(ea(ea(s*w)+ea(ea(l*k)+ea(j*u)))-ea(m*v));z=ea(ea(ea(l*v)+ea(ea(m*k)+ea(j*w)))-ea(s*u));A=ea(ea(ea(ea(j*k)-ea(s*v))-ea(l*u))-ea(m*w));t=c[t+156>>2]|0;if(!t){o=y;p=x;q=z;r=A;break}else{s=y;j=A;m=z;l=x}}}l=ea(-p);p=ea(-q);g[f>>2]=ea(-o);g[f+4>>2]=l;g[f+8>>2]=p;g[f+12>>2]=r;FMc(f,e);pGc(h,b);b=a+0|0;f=e+0|0;e=b+36|0;do{c[b>>2]=c[f>>2];b=b+4|0;f=f+4|0}while((b|0)<(e|0));WLc(a,h)|0;i=d;return}function oGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;d=i;e=b+28|0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];e=c[b+156>>2]|0;if(!e){i=d;return}b=a+12|0;f=a+8|0;h=a+4|0;j=ea(g[a>>2]);k=ea(g[b>>2]);l=ea(g[f>>2]);m=k;k=l;l=ea(g[h>>2]);n=j;o=e;while(1){j=ea(g[o+40>>2]);p=ea(j*n);q=ea(g[o+28>>2]);r=ea(p+ea(q*m));p=ea(g[o+32>>2]);s=ea(r+ea(p*k));r=ea(g[o+36>>2]);t=ea(s-ea(r*l));s=ea(ea(ea(n*r)+ea(ea(m*p)+ea(j*l)))-ea(q*k));u=ea(ea(ea(ea(j*k)+ea(m*r))+ea(q*l))-ea(n*p));v=ea(ea(ea(ea(j*m)-ea(n*q))-ea(p*l))-ea(k*r));o=c[o+156>>2]|0;if(!o){w=t;x=s;y=u;z=v;break}else{m=v;k=u;l=s;n=t}}g[a>>2]=w;g[b>>2]=z;g[f>>2]=y;g[h>>2]=x;i=d;return}function pGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+144|0;e=d+108|0;f=d+72|0;g=d+36|0;h=d;ULc(e,b+56|0)|0;FMc(b+28|0,f);j=c[b+156>>2]|0;if(!j){k=a+0|0;l=f+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));WLc(a,e)|0;i=d;return}else{pGc(g,j);k=h+0|0;l=g+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));WLc(h,f)|0;k=a+0|0;l=h+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));WLc(a,e)|0;i=d;return}}function qGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=Im,f=Im,h=Im;c=i;i=i+48|0;d=c;nGc(d,b);e=ea(g[d>>2]);f=ea(g[d+16>>2]);h=ea(g[d+32>>2]);g[a>>2]=e;g[a+4>>2]=f;g[a+8>>2]=h;i=c;return}function rGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;e=b+44|0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];e=c[b+156>>2]|0;if(!e){i=d;return}b=a+4|0;f=a+8|0;h=ea(g[a>>2]);j=ea(g[b>>2]);k=j;j=ea(g[f>>2]);l=h;m=e;while(1){h=ea(ea(g[m+56>>2])*l);n=ea(ea(g[m+60>>2])*k);o=ea(ea(g[m+64>>2])*j);p=ea(g[m+28>>2]);q=ea(p*ea(2.0));r=ea(g[m+32>>2]);s=ea(r*ea(2.0));t=ea(g[m+36>>2]);u=ea(t*ea(2.0));v=ea(p*q);w=ea(r*s);x=ea(t*u);t=ea(p*s);y=ea(p*u);p=ea(r*u);r=ea(g[m+40>>2]);z=ea(q*r);q=ea(s*r);s=ea(r*u);u=ea(ea(o*ea(y+q))+ea(ea(ea(t-s)*n)+ea(h*ea(ea(1.0)-ea(w+x)))));r=ea(ea(o*ea(p-z))+ea(ea(h*ea(t+s))+ea(n*ea(ea(1.0)-ea(v+x)))));x=ea(ea(o*ea(ea(1.0)-ea(v+w)))+ea(ea(h*ea(y-q))+ea(ea(p+z)*n)));n=ea(ea(g[m+44>>2])+u);u=ea(ea(g[m+48>>2])+r);r=ea(ea(g[m+52>>2])+x);m=c[m+156>>2]|0;if(!m){A=n;B=u;C=r;break}else{k=u;j=r;l=n}}g[a>>2]=A;g[b>>2]=B;g[f>>2]=C;i=d;return}function sGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;rHc(a,b,c);i=d;return}function tGc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;a[b+133>>0]=0;a[b+134>>0]=1;e=c[b+140>>2]|0;f=c[b+148>>2]|0;b=e+(f<<2)|0;if(!f){i=d;return}else g=e;do{tGc(c[g>>2]|0);g=g+4|0}while((g|0)!=(b|0));i=d;return}function uGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=i;i=i+32|0;d=c+16|0;e=c;f=ea(ea(g[b>>2])*ea(.0174532942));h=ea(ea(g[b+4>>2])*ea(.0174532942));j=ea(ea(g[b+8>>2])*ea(.0174532942));g[e>>2]=f;g[e+4>>2]=h;g[e+8>>2]=j;DMc(d,e);j=ea(g[d>>2]);h=ea(j*j);f=ea(g[d+4>>2]);k=ea(h+ea(f*f));h=ea(g[d+8>>2]);l=ea(k+ea(h*h));k=ea(g[d+12>>2]);m=ea(T(ea(l+ea(k*k))));if(m<ea(g[150276])){n=ea(1.0);o=ea(0.0);p=ea(0.0);q=ea(0.0)}else{n=ea(k/m);o=ea(h/m);p=ea(f/m);q=ea(j/m)}d=a+28|0;e=a+32|0;if(((!(ea(g[d>>2])!=q)?!(ea(g[e>>2])!=p):0)?!(ea(g[a+36>>2])!=o):0)?!(ea(g[a+40>>2])!=n):0){i=c;return}g[d>>2]=q;g[e>>2]=p;g[a+36>>2]=o;g[a+40>>2]=n;hGc(a,2);i=c;return}function vGc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0;c=i;d=ea(g[b>>2]);e=ea(d*d);f=ea(g[b+4>>2]);h=ea(e+ea(f*f));e=ea(g[b+8>>2]);j=ea(h+ea(e*e));h=ea(g[b+12>>2]);k=ea(T(ea(j+ea(h*h))));if(k<ea(g[150276])){l=ea(1.0);m=ea(0.0);n=ea(0.0);o=ea(0.0)}else{l=ea(h/k);m=ea(e/k);n=ea(f/k);o=ea(d/k)}b=a+28|0;p=a+32|0;if(((!(ea(g[b>>2])!=o)?!(ea(g[p>>2])!=n):0)?!(ea(g[a+36>>2])!=m):0)?!(ea(g[a+40>>2])!=l):0){i=c;return}g[b>>2]=o;g[p>>2]=n;g[a+36>>2]=m;g[a+40>>2]=l;hGc(a,2);i=c;return}function wGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=i;e=c[a+156>>2]|0;if(!e){f=a+28|0;h=ea(g[f>>2]);if(((!(h!=ea(g[b>>2]))?(h=ea(g[a+32>>2]),!(h!=ea(g[b+4>>2]))):0)?(h=ea(g[a+36>>2]),!(h!=ea(g[b+8>>2]))):0)?(h=ea(g[a+40>>2]),!(h!=ea(g[b+12>>2]))):0){i=d;return};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];hGc(a,2);i=d;return}h=ea(g[e+28>>2]);j=ea(g[e+32>>2]);k=ea(g[e+36>>2]);l=ea(g[e+40>>2]);f=c[e+156>>2]|0;if(!f){m=h;n=j;o=k;p=l}else{q=h;h=l;l=k;k=j;e=f;while(1){j=ea(g[e+40>>2]);r=ea(q*j);s=ea(g[e+28>>2]);t=ea(r+ea(h*s));r=ea(g[e+32>>2]);u=ea(t+ea(l*r));t=ea(g[e+36>>2]);v=ea(u-ea(k*t));u=ea(ea(ea(q*t)+ea(ea(k*j)+ea(h*r)))-ea(l*s));w=ea(ea(ea(k*s)+ea(ea(l*j)+ea(h*t)))-ea(q*r));x=ea(ea(ea(ea(h*j)-ea(q*s))-ea(k*r))-ea(l*t));e=c[e+156>>2]|0;if(!e){m=v;n=u;o=w;p=x;break}else{q=v;h=x;l=w;k=u}}}k=ea(-m);m=ea(-n);n=ea(-o);o=ea(g[b>>2]);l=ea(p*o);h=ea(g[b+12>>2]);q=ea(l+ea(h*k));l=ea(g[b+8>>2]);u=ea(q+ea(l*m));q=ea(g[b+4>>2]);w=ea(u-ea(q*n));u=ea(ea(ea(o*n)+ea(ea(h*m)+ea(p*q)))-ea(l*k));x=ea(ea(ea(ea(h*n)+ea(p*l))+ea(q*k))-ea(o*m));v=ea(ea(ea(ea(p*h)-ea(o*k))-ea(q*m))-ea(l*n));b=a+28|0;e=a+32|0;if(((!(ea(g[b>>2])!=w)?!(ea(g[e>>2])!=u):0)?!(ea(g[a+36>>2])!=x):0)?!(ea(g[a+40>>2])!=v):0){i=d;return}g[b>>2]=w;g[e>>2]=u;g[a+36>>2]=x;g[a+40>>2]=v;hGc(a,2);i=d;return}function xGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;e=c[a+156>>2]|0;if(!e){f=ea(g[b>>2]);h=ea(f*f);j=ea(g[b+4>>2]);k=ea(h+ea(j*j));h=ea(g[b+8>>2]);l=ea(k+ea(h*h));k=ea(g[b+12>>2]);m=ea(T(ea(l+ea(k*k))));if(m<ea(g[150276])){n=ea(1.0);o=ea(0.0);p=ea(0.0);q=ea(0.0)}else{n=ea(k/m);o=ea(h/m);p=ea(j/m);q=ea(f/m)}r=a+28|0;s=a+32|0;if(((!(ea(g[r>>2])!=q)?!(ea(g[s>>2])!=p):0)?!(ea(g[a+36>>2])!=o):0)?!(ea(g[a+40>>2])!=n):0){i=d;return}g[r>>2]=q;g[s>>2]=p;g[a+36>>2]=o;g[a+40>>2]=n;hGc(a,2);i=d;return}n=ea(g[e+28>>2]);o=ea(g[e+32>>2]);p=ea(g[e+36>>2]);q=ea(g[e+40>>2]);s=c[e+156>>2]|0;if(!s){t=n;u=o;v=p;w=q}else{m=n;n=q;q=p;p=o;e=s;while(1){o=ea(g[e+40>>2]);f=ea(m*o);j=ea(g[e+28>>2]);h=ea(f+ea(n*j));f=ea(g[e+32>>2]);k=ea(h+ea(q*f));h=ea(g[e+36>>2]);l=ea(k-ea(p*h));k=ea(ea(ea(m*h)+ea(ea(p*o)+ea(n*f)))-ea(q*j));x=ea(ea(ea(p*j)+ea(ea(q*o)+ea(n*h)))-ea(m*f));y=ea(ea(ea(ea(n*o)-ea(m*j))-ea(p*f))-ea(q*h));e=c[e+156>>2]|0;if(!e){t=l;u=k;v=x;w=y;break}else{m=l;n=y;q=x;p=k}}}p=ea(-t);t=ea(-u);u=ea(-v);v=ea(g[b>>2]);q=ea(w*v);n=ea(g[b+12>>2]);m=ea(q+ea(n*p));q=ea(g[b+8>>2]);k=ea(m+ea(q*t));m=ea(g[b+4>>2]);x=ea(k-ea(m*u));k=ea(ea(ea(v*u)+ea(ea(n*t)+ea(w*m)))-ea(q*p));y=ea(ea(ea(ea(n*u)+ea(w*q))+ea(m*p))-ea(v*t));l=ea(ea(ea(ea(w*n)-ea(v*p))-ea(m*t))-ea(q*u));u=ea(T(ea(ea(l*l)+ea(ea(y*y)+ea(ea(x*x)+ea(k*k))))));if(u<ea(g[150276])){z=ea(1.0);A=ea(0.0);B=ea(0.0);C=ea(0.0)}else{z=ea(l/u);A=ea(y/u);B=ea(k/u);C=ea(x/u)}b=a+28|0;e=a+32|0;if(((!(ea(g[b>>2])!=C)?!(ea(g[e>>2])!=B):0)?!(ea(g[a+36>>2])!=A):0)?!(ea(g[a+40>>2])!=z):0){i=d;return}g[b>>2]=C;g[e>>2]=B;g[a+36>>2]=A;g[a+40>>2]=z;hGc(a,2);i=d;return}function yGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im;d=i;i=i+32|0;e=d+12|0;f=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];b=c[a+156>>2]|0;if(b){zGc(f,b,e);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2]}f=a+44|0;h=ea(g[f>>2]);if((!(h!=ea(g[e>>2]))?(h=ea(g[a+48>>2]),!(h!=ea(g[e+4>>2]))):0)?(h=ea(g[a+52>>2]),!(h!=ea(g[e+8>>2]))):0){i=d;return};c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];hGc(a,1);i=d;return}function zGc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;f=i;i=i+16|0;h=f;g[b>>2]=ea(0.0);j=b+4|0;g[j>>2]=ea(0.0);k=b+8|0;g[k>>2]=ea(0.0);l=c[d+156>>2]|0;if(!l){m=ea(g[e>>2]);n=ea(g[e+4>>2]);o=m;p=n;q=ea(g[e+8>>2])}else{zGc(h,l,e);n=ea(g[h>>2]);m=ea(g[h+4>>2]);o=n;p=m;q=ea(g[h+8>>2])}m=ea(o-ea(g[d+44>>2]));o=ea(p-ea(g[d+48>>2]));p=ea(q-ea(g[d+52>>2]));q=ea(g[d+28>>2]);n=ea(-q);r=ea(g[d+32>>2]);s=ea(-r);t=ea(g[d+36>>2]);u=ea(g[d+40>>2]);v=ea(q*ea(-2.0));q=ea(r*ea(-2.0));r=ea(t*ea(-2.0));w=ea(v*n);x=ea(q*s);y=ea(t*r);t=ea(q*n);z=ea(r*n);n=ea(r*s);s=ea(v*u);v=ea(q*u);q=ea(u*r);r=ea(ea(p*ea(z+v))+ea(ea(o*ea(t-q))+ea(m*ea(ea(1.0)-ea(x-y)))));u=ea(ea(p*ea(n-s))+ea(ea(m*ea(t+q))+ea(o*ea(ea(1.0)-ea(w-y)))));y=ea(ea(p*ea(ea(1.0)-ea(w+x)))+ea(ea(m*ea(z-v))+ea(o*ea(n+s))));g[b>>2]=r;g[j>>2]=u;g[k>>2]=y;if(!(a[d+136>>0]|0)){i=f;return}s=ea(g[d+56>>2]);if(s<ea(0.0))A=ea(-s);else A=s;n=ea(g[150276]);if(A>n)B=ea(ea(1.0)/s);else B=ea(0.0);s=ea(g[d+60>>2]);if(s<ea(0.0))C=ea(-s);else C=s;if(C>n)D=ea(ea(1.0)/s);else D=ea(0.0);s=ea(g[d+64>>2]);if(s<ea(0.0))E=ea(-s);else E=s;if(E>n)F=ea(ea(1.0)/s);else F=ea(0.0);g[b>>2]=ea(B*r);g[j>>2]=ea(D*u);g[k>>2]=ea(F*y);i=f;return}function AGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;e=i;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];if(!b){i=e;return}d=a+4|0;f=a+8|0;h=ea(g[a>>2]);j=ea(g[d>>2]);k=j;j=ea(g[f>>2]);l=h;m=b;while(1){h=ea(ea(g[m+56>>2])*l);n=ea(ea(g[m+60>>2])*k);o=ea(ea(g[m+64>>2])*j);p=ea(g[m+28>>2]);q=ea(p*ea(2.0));r=ea(g[m+32>>2]);s=ea(r*ea(2.0));t=ea(g[m+36>>2]);u=ea(t*ea(2.0));v=ea(p*q);w=ea(r*s);x=ea(t*u);t=ea(p*s);y=ea(p*u);p=ea(r*u);r=ea(g[m+40>>2]);z=ea(q*r);q=ea(s*r);s=ea(r*u);u=ea(ea(o*ea(y+q))+ea(ea(ea(t-s)*n)+ea(h*ea(ea(1.0)-ea(w+x)))));r=ea(ea(o*ea(p-z))+ea(ea(h*ea(t+s))+ea(n*ea(ea(1.0)-ea(v+x)))));x=ea(ea(o*ea(ea(1.0)-ea(v+w)))+ea(ea(h*ea(y-q))+ea(ea(p+z)*n)));n=ea(ea(g[m+44>>2])+u);u=ea(ea(g[m+48>>2])+r);r=ea(ea(g[m+52>>2])+x);m=c[m+156>>2]|0;if(!m){A=n;B=u;C=r;break}else{k=u;j=r;l=n}}g[a>>2]=A;g[d>>2]=B;g[f>>2]=C;i=e;return}function BGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;sHc(a,b,c);i=d;return}function CGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a+156>>2]|0;g=a+44|0;if(!f){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];i=d;return}else{zGc(e,f,b);c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];i=d;return}}function DGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=i;e=c[a+156>>2]|0;if(!e){f=a+28|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];i=d;return}h=ea(g[e+28>>2]);j=ea(g[e+32>>2]);k=ea(g[e+36>>2]);l=ea(g[e+40>>2]);f=c[e+156>>2]|0;if(!f){m=h;n=j;o=k;p=l}else{q=h;h=l;l=k;k=j;e=f;while(1){j=ea(g[e+40>>2]);r=ea(q*j);s=ea(g[e+28>>2]);t=ea(r+ea(h*s));r=ea(g[e+32>>2]);u=ea(t+ea(l*r));t=ea(g[e+36>>2]);v=ea(u-ea(k*t));u=ea(ea(ea(q*t)+ea(ea(k*j)+ea(h*r)))-ea(l*s));w=ea(ea(ea(k*s)+ea(ea(l*j)+ea(h*t)))-ea(q*r));x=ea(ea(ea(ea(h*j)-ea(q*s))-ea(k*r))-ea(l*t));e=c[e+156>>2]|0;if(!e){m=v;n=u;o=w;p=x;break}else{q=v;h=x;l=w;k=u}}}k=ea(-m);m=ea(-n);n=ea(-o);o=ea(g[b>>2]);l=ea(p*o);h=ea(g[b+12>>2]);q=ea(l+ea(h*k));l=ea(g[b+8>>2]);u=ea(q+ea(l*m));q=ea(g[b+4>>2]);w=ea(ea(ea(o*n)+ea(ea(h*m)+ea(p*q)))-ea(l*k));x=ea(ea(ea(ea(h*n)+ea(p*l))+ea(q*k))-ea(o*m));v=ea(ea(ea(ea(p*h)-ea(o*k))-ea(q*m))-ea(l*n));g[a+28>>2]=ea(u-ea(q*n));g[a+32>>2]=w;g[a+36>>2]=x;g[a+40>>2]=v;i=d;return}function EGc(b,e){b=b|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im;f=i;h=b+44|0;j=ea(g[150276]);k=ea(g[e>>2]);l=ea(k-ea(g[h>>2]));k=ea(g[e+4>>2]);m=ea(k-ea(g[b+48>>2]));k=ea(g[e+8>>2]);n=ea(k-ea(g[b+52>>2]));if(ea(ea(ea(l*l)+ea(m*m))+ea(n*n))<=ea(j*j)){i=f;return};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];e=b+135|0;a[e>>0]=d[e>>0]|0|1;i=f;return}function FGc(b,e){b=b|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;h=b+28|0;j=ea(g[150276]);k=ea(g[h>>2]);l=ea(g[b+32>>2]);m=ea(g[b+36>>2]);n=ea(g[b+40>>2]);o=ea(g[e>>2]);p=ea(k-o);q=ea(g[e+4>>2]);r=ea(l-q);s=ea(g[e+8>>2]);t=ea(m-s);u=ea(g[e+12>>2]);v=ea(n-u);w=ea(j*j);if(ea(ea(ea(ea(p*p)+ea(r*r))+ea(t*t))+ea(v*v))<=w){i=f;return}v=ea(k+o);o=ea(l+q);q=ea(m+s);s=ea(n+u);if(ea(ea(ea(ea(v*v)+ea(o*o))+ea(q*q))+ea(s*s))<=w){i=f;return};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];e=b+135|0;a[e>>0]=d[e>>0]|0|2;i=f;return}function GGc(b,e){b=b|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=Im;f=i;h=b+56|0;j=ea(g[150276]);k=ea(g[e>>2]);l=ea(k-ea(g[h>>2]));k=ea(g[e+4>>2]);m=b+60|0;n=ea(k-ea(g[m>>2]));k=ea(g[e+8>>2]);o=b+64|0;p=ea(k-ea(g[o>>2]));if(ea(ea(ea(l*l)+ea(n*n))+ea(p*p))<=ea(j*j)){i=f;return};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];e=b+135|0;a[e>>0]=d[e>>0]|0|8;j=ea(g[b+56>>2]);p=ea(g[m>>2]);n=ea(j-p);if(n<ea(0.0))q=ea(-n);else q=n;m=!(q<=ea(.0000999999974));q=ea(g[o>>2]);if(!m){n=ea(p-q);if(n<ea(0.0))r=ea(-n);else r=n;if(r<=ea(.0000999999974)){r=ea(j+ea(-1.0));if(r<ea(0.0))s=ea(-r);else s=r;m=b+136|0;if(s<=ea(.0000999999974)){a[m>>0]=0;i=f;return}a[m>>0]=1;if(!(j<ea(0.0))){i=f;return}a[m>>0]=6;i=f;return}}a[b+136>>0]=(ea(ea(j*p)*q)<ea(0.0)&1)<<2|2;i=f;return}function HGc(a){a=a|0;var b=0,d=0;b=i;d=XTb(c[a+24>>2]|0,554336)|0;i=b;return (d?8:0)|0}function IGc(b,c){b=b|0;c=c|0;a[b+137>>0]=c&8;return}function JGc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a[b+135>>0]|0;if(e<<24>>24){hGc(b,e&255);i=d;return}e=c[b+140>>2]|0;f=c[b+148>>2]|0;b=e+(f<<2)|0;if(!f){i=d;return}else g=e;do{JGc(c[g>>2]|0);g=g+4|0}while((g|0)!=(b|0));i=d;return}function KGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+24>>2]|0;if(f)LTb(f,b,d);f=a+140|0;g=a+148|0;if(!(c[g>>2]|0)){i=e;return}a=c[f>>2]|0;do{KGc(c[a>>2]|0,b,d);a=a+4|0}while((a|0)!=((c[f>>2]|0)+(c[g>>2]<<2)|0));i=e;return}function LGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;e=i;f=ea(g[b+28>>2]);h=ea(g[b+32>>2]);j=ea(g[b+36>>2]);k=ea(g[b+40>>2]);l=c[b+156>>2]|0;if(!l){m=f;n=h;o=j;p=k}else{q=f;f=k;k=j;j=h;b=l;while(1){h=ea(g[b+40>>2]);r=ea(q*h);s=ea(g[b+28>>2]);t=ea(r+ea(f*s));r=ea(g[b+32>>2]);u=ea(t+ea(k*r));t=ea(g[b+36>>2]);v=ea(u-ea(j*t));u=ea(ea(ea(q*t)+ea(ea(j*h)+ea(f*r)))-ea(k*s));w=ea(ea(ea(j*s)+ea(ea(k*h)+ea(f*t)))-ea(q*r));x=ea(ea(ea(ea(f*h)-ea(q*s))-ea(j*r))-ea(k*t));b=c[b+156>>2]|0;if(!b){m=v;n=u;o=w;p=x;break}else{q=v;f=x;k=w;j=u}}}j=ea(-m);k=ea(-n);f=ea(m*ea(-2.0));m=ea(n*ea(-2.0));n=ea(o*ea(-2.0));q=ea(f*j);u=ea(m*k);w=ea(o*n);o=ea(m*j);x=ea(n*j);j=ea(n*k);k=ea(p*f);f=ea(p*m);m=ea(p*n);n=ea(ea(1.0)-ea(u-w));p=ea(g[d>>2]);v=ea(p*n);n=ea(o-m);t=ea(g[d+4>>2]);r=ea(ea(t*n)+v);v=ea(f+x);n=ea(g[d+8>>2]);g[a>>2]=ea(ea(v*n)+r);g[a+4>>2]=ea(ea(ea(j-k)*n)+ea(ea(p*ea(m+o))+ea(t*ea(ea(1.0)-ea(q-w)))));g[a+8>>2]=ea(ea(ea(p*ea(x-f))+ea(t*ea(j+k)))+ea(n*ea(ea(1.0)-ea(u+q))));i=e;return}function MGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im;e=i;f=ea(g[a+44>>2]);h=ea(g[a+48>>2]);j=ea(g[a+52>>2]);k=ea(g[a+28>>2]);l=ea(g[a+32>>2]);m=ea(g[a+36>>2]);n=ea(g[a+40>>2]);o=c[a+156>>2]|0;if(!o){p=j;q=h;r=f;s=n;t=m;u=l;v=k;g[b>>2]=r;w=b+4|0;g[w>>2]=q;x=b+8|0;g[x>>2]=p;g[d>>2]=v;y=d+4|0;g[y>>2]=u;z=d+8|0;g[z>>2]=t;A=d+12|0;g[A>>2]=s;i=e;return}else{B=f;C=h;D=j;E=k;F=n;G=m;H=l;I=o}while(1){l=ea(B*ea(g[I+56>>2]));m=ea(C*ea(g[I+60>>2]));n=ea(D*ea(g[I+64>>2]));k=ea(g[I+28>>2]);j=ea(k*ea(2.0));h=ea(g[I+32>>2]);f=ea(h*ea(2.0));J=ea(g[I+36>>2]);K=ea(J*ea(2.0));L=ea(k*j);M=ea(h*f);N=ea(J*K);O=ea(k*f);P=ea(k*K);Q=ea(h*K);R=ea(g[I+40>>2]);S=ea(j*R);j=ea(f*R);f=ea(R*K);K=ea(ea(n*ea(P+j))+ea(ea(m*ea(O-f))+ea(l*ea(ea(1.0)-ea(M+N)))));T=ea(ea(n*ea(Q-S))+ea(ea(l*ea(O+f))+ea(m*ea(ea(1.0)-ea(L+N)))));N=ea(ea(n*ea(ea(1.0)-ea(L+M)))+ea(ea(l*ea(P-j))+ea(m*ea(Q+S))));S=ea(ea(g[I+44>>2])+K);K=ea(ea(g[I+48>>2])+T);T=ea(ea(g[I+52>>2])+N);N=ea(ea(ea(G*h)+ea(ea(F*k)+ea(E*R)))-ea(H*J));Q=ea(ea(ea(E*J)+ea(ea(F*h)+ea(H*R)))-ea(G*k));m=ea(ea(ea(H*k)+ea(ea(F*J)+ea(G*R)))-ea(E*h));j=ea(ea(ea(ea(F*R)-ea(E*k))-ea(H*h))-ea(G*J));I=c[I+156>>2]|0;if(!I){p=T;q=K;r=S;s=j;t=m;u=Q;v=N;break}else{B=S;C=K;D=T;E=N;F=j;G=m;H=Q}}g[b>>2]=r;w=b+4|0;g[w>>2]=q;x=b+8|0;g[x>>2]=p;g[d>>2]=v;y=d+4|0;g[y>>2]=u;z=d+8|0;g[z>>2]=t;A=d+12|0;g[A>>2]=s;i=e;return}function NGc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+192|0;g=f+64|0;h=f;j=b+68|0;if(a[b+133>>0]|0){tMc(j,e);k=d[b+132>>0]|0;i=f;return k|0}c[g>>2]=b;l=c[b+156>>2]|0;m=1;while(1){if(!l){n=0;o=m;p=10;break}if(a[l+133>>0]|0){n=l;o=m;p=10;break}c[g+(m<<2)>>2]=l;m=m+1|0;q=c[l+156>>2]|0;if((m|0)==31){r=q;p=7;break}else l=q}if((p|0)==7){if(!r){s=0;t=0}else{s=OGc(r,h)|0;t=r}c[g+124>>2]=t;u=t;v=s;w=31;p=11}else if((p|0)==10?(c[g+(o<<2)>>2]=n,(o|0)>0):0){u=n;v=0;w=o;p=11}if((p|0)==11)while(1){p=0;w=w+-1|0;o=u;u=c[g+(w<<2)>>2]|0;if(!o){n=u+68|0;s=a[u+136>>0]|0;t=u+44|0;r=u+28|0;if(!(s<<24>>24))uMc(n,t,r);else vMc(n,t,r,u+56|0);x=s&255|v}else{s=a[u+136>>0]|0;r=u+44|0;t=u+28|0;if(!(s<<24>>24))uMc(h,r,t);else vMc(h,r,t,u+56|0);t=s&255|v|d[o+132>>0];dMc(o+68|0,h,u+68|0);x=t}if(x&4){t=x&-5;if(!u)y=t;else{o=t;t=u;while(1){s=d[t+136>>0]|0;r=(s|o)&-5|(s^o)&4;t=c[t+156>>2]|0;if(!t){y=r;break}else o=r}}}else y=x;a[u+132>>0]=(y&2|0)==0?y:y&254;a[u+133>>0]=1;if((w|0)<=0)break;else{v=x;p=11}}tMc(j,e);k=d[b+132>>0]|0;i=f;return k|0}function OGc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+128|0;g=f+64|0;h=f;j=b+133|0;if(a[j>>0]|0){tMc(b+68|0,e);k=d[b+132>>0]|0;i=f;return k|0}l=a[b+136>>0]|0;m=l&255;n=b+44|0;o=b+28|0;if(!(l<<24>>24))uMc(e,n,o);else vMc(e,n,o,b+56|0);o=c[b+156>>2]|0;a:do if(!o){p=m;q=e}else{n=m;l=o;while(1){if(a[l+133>>0]|0){r=n;s=l;break}t=a[l+136>>0]|0;u=l+44|0;v=l+28|0;if(!(t<<24>>24))uMc(h,u,v);else vMc(h,u,v,l+56|0);dMc(h,e,g);l=c[l+156>>2]|0;v=t&255|n;tMc(g,e);if(!l){p=v;q=e;break a}else n=v}n=d[s+132>>0]|0;dMc(s+68|0,e,g);tMc(g,e);p=n|r;q=e}while(0);tMc(q,b+68|0);if(p&4){q=p&-5;if(!b)w=q;else{e=q;q=b;while(1){r=d[q+136>>0]|0;g=(r|e)&-5|(r^e)&4;q=c[q+156>>2]|0;if(!q){w=g;break}else e=g}}}else w=p;a[b+132>>0]=(w&2|0)==0?w:w&254;a[j>>0]=1;k=p;i=f;return k|0}function PGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+32|0;d=c+16|0;e=c;g[d>>2]=ea(0.0);g[d+4>>2]=ea(0.0);g[d+8>>2]=ea(0.0);MGc(b,d,e);wMc(a,d,e);i=c;return}function QGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+32|0;d=c+16|0;e=c;g[e>>2]=ea(0.0);g[e+4>>2]=ea(0.0);g[e+8>>2]=ea(0.0);MGc(b,e,d);uMc(a,e,d);i=c;return}function RGc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;e=i;i=i+144|0;f=e+80|0;h=e+16|0;j=e;wMc(b,d+44|0,d+28|0);if(a[d+136>>0]|0){k=ea(g[d+56>>2]);if(k<ea(0.0))l=ea(-k);else l=k;m=ea(g[150276]);if(l>m)n=ea(ea(1.0)/k);else n=ea(0.0);k=ea(g[d+60>>2]);if(k<ea(0.0))o=ea(-k);else o=k;if(o>m)p=ea(ea(1.0)/k);else p=ea(0.0);k=ea(g[d+64>>2]);if(k<ea(0.0))q=ea(-k);else q=k;if(q>m)r=ea(ea(1.0)/k);else r=ea(0.0);g[j>>2]=n;g[j+4>>2]=p;g[j+8>>2]=r;iMc(h,j)|0;dMc(h,b,f);tMc(f,b)}j=c[d+156>>2]|0;if(!j){i=e;return}RGc(h,j);dMc(b,h,f);tMc(f,b);i=e;return}function SGc(a,b){a=a|0;b=b|0;var c=0;c=i;NGc(b,a)|0;i=c;return}function TGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;e=i;f=ea(g[b+28>>2]);h=ea(g[b+32>>2]);j=ea(g[b+36>>2]);k=ea(g[b+40>>2]);l=c[b+156>>2]|0;if(!l){m=f;n=h;o=j;p=k}else{q=f;f=k;k=j;j=h;b=l;while(1){h=ea(g[b+40>>2]);r=ea(q*h);s=ea(g[b+28>>2]);t=ea(r+ea(f*s));r=ea(g[b+32>>2]);u=ea(t+ea(k*r));t=ea(g[b+36>>2]);v=ea(u-ea(j*t));u=ea(ea(ea(q*t)+ea(ea(j*h)+ea(f*r)))-ea(k*s));w=ea(ea(ea(j*s)+ea(ea(k*h)+ea(f*t)))-ea(q*r));x=ea(ea(ea(ea(f*h)-ea(q*s))-ea(j*r))-ea(k*t));b=c[b+156>>2]|0;if(!b){m=v;n=u;o=w;p=x;break}else{q=v;f=x;k=w;j=u}}}j=ea(m*ea(2.0));k=ea(n*ea(2.0));f=ea(o*ea(2.0));q=ea(m*j);u=ea(n*k);w=ea(o*f);o=ea(m*k);x=ea(f*m);m=ea(n*f);n=ea(p*j);j=ea(p*k);k=ea(p*f);f=ea(ea(1.0)-ea(w+u));p=ea(g[d>>2]);v=ea(p*f);f=ea(o-k);t=ea(g[d+4>>2]);r=ea(ea(f*t)+v);v=ea(x+j);f=ea(g[d+8>>2]);g[a>>2]=ea(ea(v*f)+r);g[a+4>>2]=ea(ea(ea(m-n)*f)+ea(ea(p*ea(k+o))+ea(t*ea(ea(1.0)-ea(w+q)))));g[a+8>>2]=ea(ea(ea(p*ea(x-j))+ea(t*ea(m+n)))+ea(f*ea(ea(1.0)-ea(u+q))));i=e;return}function UGc(b,c){b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=0,n=0;d=i;if(c){i=d;return}tGc(b);e=ea(g[b+56>>2]);f=ea(g[b+60>>2]);h=ea(e-f);if(h<ea(0.0))j=ea(-h);else j=h;c=!(j<=ea(.0000999999974));j=ea(g[b+64>>2]);do if(!c){h=ea(f-j);if(h<ea(0.0))k=ea(-h);else k=h;if(k<=ea(.0000999999974)){h=ea(e+ea(-1.0));if(h<ea(0.0))l=ea(-h);else l=h;m=b+136|0;if(l<=ea(.0000999999974)){a[m>>0]=0;break}a[m>>0]=1;if(e<ea(0.0))a[m>>0]=6}else n=14}else n=14;while(0);if((n|0)==14)a[b+136>>0]=(ea(ea(e*f)*j)<ea(0.0)&1)<<2|2;hGc(b,75);i=d;return}function VGc(a){a=a|0;var b=0,d=0,e=0,f=0,h=Im,j=Im,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;b=i;i=i+16|0;d=b;fUb(a);e=a+28|0;f=c[e>>2]|0;h=(c[k>>2]=f,ea(g[k>>2]));if((f&2139095040|0)==2139095040){g[e>>2]=ea(0.0);j=ea(0.0)}else j=h;e=a+32|0;f=c[e>>2]|0;h=(c[k>>2]=f,ea(g[k>>2]));if((f&2139095040|0)==2139095040){g[e>>2]=ea(0.0);l=ea(0.0)}else l=h;f=a+36|0;m=c[f>>2]|0;h=(c[k>>2]=m,ea(g[k>>2]));if((m&2139095040|0)==2139095040){g[f>>2]=ea(0.0);n=ea(0.0)}else n=h;m=a+40|0;o=c[m>>2]|0;h=(c[k>>2]=o,ea(g[k>>2]));if((o&2139095040|0)==2139095040){g[m>>2]=ea(0.0);p=ea(0.0)}else p=h;o=a+44|0;if((c[o>>2]&2139095040|0)==2139095040)g[o>>2]=ea(0.0);o=a+48|0;if((c[o>>2]&2139095040|0)==2139095040)g[o>>2]=ea(0.0);o=a+52|0;if((c[o>>2]&2139095040|0)==2139095040)g[o>>2]=ea(0.0);o=a+56|0;if((c[o>>2]&2139095040|0)==2139095040)g[o>>2]=ea(0.0);o=a+60|0;if((c[o>>2]&2139095040|0)==2139095040)g[o>>2]=ea(0.0);o=a+64|0;if((c[o>>2]&2139095040|0)==2139095040)g[o>>2]=ea(0.0);h=ea(T(ea(ea(ea(ea(j*j)+ea(l*l))+ea(n*n))+ea(p*p))));if(h<ea(g[150276])){q=ea(1.0);r=ea(0.0);s=ea(0.0);t=ea(0.0)}else{q=ea(p/h);r=ea(n/h);s=ea(l/h);t=ea(j/h)}g[a+28>>2]=t;g[e>>2]=s;g[f>>2]=r;g[m>>2]=q;m=c[a+156>>2]|0;a:do if(m){f=c[m+140>>2]|0;e=c[m+148>>2]|0;o=f+(e<<2)|0;b:do if(e){u=f;while(1){if((c[u>>2]|0)==(a|0)){v=u;break}u=u+4|0;if((u|0)==(o|0))break b}if((v|0)!=(o|0))break a}while(0);c[d>>2]=a;qHc(m+140|0,d)}while(0);d=a+148|0;m=c[d>>2]|0;if((m|0)<=0){i=b;return}v=a+140|0;o=a+4|0;if(!a){f=m;e=0;do{u=c[v>>2]|0;w=u+(e<<2)|0;x=c[w>>2]|0;do if(x){y=e+1|0;if(!(c[x+156>>2]|0)){z=f;A=y;B=0}else{aFi(w|0,u+(y<<2)|0,f-y<<2|0)|0;c[d>>2]=(c[d>>2]|0)+-1;Krd(596552,0,3653512,1797,1,c[x+4>>2]|0,0,0);C=e+-1|0;break}c:while(1){y=A;while(1){if((y|0)>=(z|0))break c;D=c[v>>2]|0;E=D+(y<<2)|0;F=y+1|0;if((c[E>>2]|0)==(x|0)){G=D;H=E;I=F;J=y;break}else y=F}aFi(H|0,G+(I<<2)|0,z-I<<2|0)|0;y=(c[d>>2]|0)+-1|0;c[d>>2]=y;z=y;A=J;B=1}if(B){Krd(596608,0,3653512,1816,1,c[x+4>>2]|0,0,0);C=e}else C=e}else{Krd(596496,0,3653512,1773,1,0,0,0);y=c[v>>2]|0;F=e+1|0;aFi(y+(e<<2)|0,y+(F<<2)|0,(c[d>>2]|0)-F<<2|0)|0;c[d>>2]=(c[d>>2]|0)+-1;C=e+-1|0}while(0);e=C+1|0;f=c[d>>2]|0}while((e|0)<(f|0));i=b;return}else{f=m;m=0;do{e=c[v>>2]|0;C=e+(m<<2)|0;B=c[C>>2]|0;do if(B){J=m+1|0;if((c[B+156>>2]|0)==(a|0)){K=f;L=J;M=0}else{aFi(C|0,e+(J<<2)|0,f-J<<2|0)|0;c[d>>2]=(c[d>>2]|0)+-1;Krd(596552,0,3653512,1797,1,c[B+4>>2]|0,0,0);N=m+-1|0;break}d:while(1){J=L;while(1){if((J|0)>=(K|0))break d;A=c[v>>2]|0;z=A+(J<<2)|0;I=J+1|0;if((c[z>>2]|0)==(B|0)){O=A;P=z;Q=I;R=J;break}else J=I}aFi(P|0,O+(Q<<2)|0,K-Q<<2|0)|0;J=(c[d>>2]|0)+-1|0;c[d>>2]=J;K=J;L=R;M=1}if(M){Krd(596608,0,3653512,1816,1,c[B+4>>2]|0,0,0);N=m}else N=m}else{Krd(596496,0,3653512,1773,1,c[o>>2]|0,0,0);J=c[v>>2]|0;I=m+1|0;aFi(J+(m<<2)|0,J+(I<<2)|0,(c[d>>2]|0)-I<<2|0)|0;c[d>>2]=(c[d>>2]|0)+-1;N=m+-1|0}while(0);m=N+1|0;f=c[d>>2]|0}while((m|0)<(f|0));i=b;return}}function WGc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2462344,a,0);dHc(a,b);bdd(b);i=c;return}function XGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2462344,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else fHc(a,b);sdd(b);i=d;return}function YGc(a,b){a=a|0;b=b|0;var c=0;c=i;hHc(a,b);i=c;return}function ZGc(a,b){a=a|0;b=b|0;var c=0;c=i;iHc(a,b);i=c;return}function _Gc(a,b){a=a|0;b=b|0;var c=0;c=i;jHc(a,b);i=c;return}function $Gc(a,b){a=a|0;b=b|0;var c=0;c=i;mTb(a,b);lHc(a,b);i=c;return}function aHc(){var a=0;a=i;QQb(4,147,0,0,0);i=a;return}function bHc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(2)|0))uUb();rri(b,2462344,9);wQb(4,2,b,160,2627,0,0);xri(b);i=a;return}function cHc(a){a=a|0;return 4}function dHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;hTb(a,b);e=a+28|0;add(b,596720,c[142278]|0,e,2048);uHc(e,b);bdd(b);e=a+44|0;f=c[142310]|0;add(b,596736,f,e,2048);g=b+16|0;h=c[($hd(g)|0)+20>>2]|2097152;j=b+12|0;k=b+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=h;h=c[142268]|0;add(b,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+48|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2416480,h,a+52|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);e=a+56|0;add(b,596752,f,e,2048);f=c[($hd(g)|0)+20>>2]|2097152;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=f;add(b,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+60|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2416480,h,a+64|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);eHc(a,b);i=d;return}function eHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;if(c[b>>2]&16384){i=d;return}add(b,596768,c[142306]|0,a+140|0,65601);c[f>>2]=0;$cd(b,2646336,2646336,d+20|0,0);add(b,3142592,596808,f,0);f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=c[142270]|0;add(b,792256,g,e,1);h=b+12|0;j=b+20|0;c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142290]|0;add(b,792272,k,f,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);add(b,596784,596808,a+156|0,65537);a=e+8|0;f=a;c[f>>2]=0;c[f+4>>2]=0;c[e>>2]=0;add(b,792256,g,e,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,k,a,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);i=d;return}function fHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;iTb(a,b);f=a+28|0;g=qdd(b,596720,c[142278]|0,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else vHc(f,b);sdd(b)}f=a+44|0;g=c[142310]|0;h=qdd(b,596736,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else _6b(f,b);sdd(b)}f=a+56|0;h=qdd(b,596752,g,e,1)|0;if(!h){gHc(a,b);i=d;return}if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else _6b(f,b);sdd(b);gHc(a,b);i=d;return}function gHc(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=Im,p=0,q=0;e=i;i=i+16|0;f=e;h=ea(g[b+56>>2]);j=ea(g[b+60>>2]);k=ea(h-j);if(k<ea(0.0))l=ea(-k);else l=k;m=!(l<=ea(.0000999999974));l=ea(g[b+64>>2]);do if(!m){k=ea(j-l);if(k<ea(0.0))n=ea(-k);else n=k;if(n<=ea(.0000999999974)){k=ea(h+ea(-1.0));if(k<ea(0.0))o=ea(-k);else o=k;p=b+136|0;if(o<=ea(.0000999999974)){a[p>>0]=0;break}a[p>>0]=1;if(h<ea(0.0))a[p>>0]=6}else q=13}else q=13;while(0);if((q|0)==13)a[b+136>>0]=(ea(ea(h*j)*l)<ea(0.0)&1)<<2|2;if(c[d>>2]&16384){i=e;return}q=b+140|0;m=qdd(d,596768,c[142306]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](q,d)|0}else wHc(d,q,0);sdd(d)}q=b+156|0;b=qdd(d,596784,596808,f,1)|0;if(!b){i=e;return}if((b|0)<=0){b=c[f>>2]|0;if(b)_n[b&4095](q,d)|0}else xHc(q,d);sdd(d);i=e;return}function hHc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=0;e=i;jTb(b,d);yHc(d,b+28|0,596720,2048);f=b+44|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0>m>>>0){Bid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}else{g[f>>2]=ea(g[j>>2]);c[h>>2]=k;n=k;o=m}m=b+48|0;k=n+4|0;if(k>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[h>>2]=k;p=k;q=o}o=b+52|0;k=p+4|0;if(k>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[h>>2]=k;r=k;s=q}q=b+56|0;k=r+4|0;if(k>>>0>s>>>0){Bid(h,q,4);t=c[h>>2]|0;u=c[l>>2]|0}else{g[q>>2]=ea(g[r>>2]);c[h>>2]=k;t=k;u=s}s=b+60|0;k=t+4|0;if(k>>>0>u>>>0){Bid(h,s,4);v=c[h>>2]|0;w=c[l>>2]|0}else{g[s>>2]=ea(g[t>>2]);c[h>>2]=k;v=k;w=u}u=b+64|0;k=v+4|0;if(k>>>0>w>>>0)Bid(h,u,4);else{g[u>>2]=ea(g[v>>2]);c[h>>2]=k}x=ea(g[b+56>>2]);y=ea(g[s>>2]);z=ea(x-y);if(z<ea(0.0))A=ea(-z);else A=z;s=!(A<=ea(.0000999999974));A=ea(g[u>>2]);do if(!s){z=ea(y-A);if(z<ea(0.0))B=ea(-z);else B=z;if(B<=ea(.0000999999974)){z=ea(x+ea(-1.0));if(z<ea(0.0))C=ea(-z);else C=z;u=b+136|0;if(C<=ea(.0000999999974)){a[u>>0]=0;break}a[u>>0]=1;if(x<ea(0.0))a[u>>0]=6}else D=31}else D=31;while(0);if((D|0)==31)a[b+136>>0]=(ea(ea(x*y)*A)<ea(0.0)&1)<<2|2;if(c[d>>2]&16384){i=e;return}zHc(d,b+140|0,0);AHc(b+156|0,d);i=e;return}function iHc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0;e=i;kTb(b,d);BHc(b+28|0,d);f=b+44|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(h,f,4);o=f;p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{s=ea(g[j>>2]);g[f>>2]=s;c[h>>2]=l;o=f;p=(g[k>>2]=s,c[k>>2]|0);q=l;r=n}c[o>>2]=XEi(p|0)|0;p=b+48|0;o=q+4|0;if(o>>>0>r>>>0){Bid(h,p,4);t=p;u=c[p>>2]|0;v=c[h>>2]|0;w=c[m>>2]|0}else{s=ea(g[q>>2]);g[p>>2]=s;c[h>>2]=o;t=p;u=(g[k>>2]=s,c[k>>2]|0);v=o;w=r}c[t>>2]=XEi(u|0)|0;u=b+52|0;t=v+4|0;if(t>>>0>w>>>0){Bid(h,u,4);x=u;y=c[u>>2]|0;z=c[h>>2]|0;A=c[m>>2]|0}else{s=ea(g[v>>2]);g[u>>2]=s;c[h>>2]=t;x=u;y=(g[k>>2]=s,c[k>>2]|0);z=t;A=w}c[x>>2]=XEi(y|0)|0;y=b+56|0;x=z+4|0;if(x>>>0>A>>>0){Bid(h,y,4);B=y;C=c[y>>2]|0;D=c[h>>2]|0;E=c[m>>2]|0}else{s=ea(g[z>>2]);g[y>>2]=s;c[h>>2]=x;B=y;C=(g[k>>2]=s,c[k>>2]|0);D=x;E=A}c[B>>2]=XEi(C|0)|0;C=b+60|0;B=D+4|0;if(B>>>0>E>>>0){Bid(h,C,4);F=C;G=c[C>>2]|0;H=c[h>>2]|0;I=c[m>>2]|0}else{s=ea(g[D>>2]);g[C>>2]=s;c[h>>2]=B;F=C;G=(g[k>>2]=s,c[k>>2]|0);H=B;I=E}c[F>>2]=XEi(G|0)|0;G=b+64|0;F=H+4|0;if(F>>>0>I>>>0){Bid(h,G,4);J=G;K=c[G>>2]|0}else{s=ea(g[H>>2]);g[G>>2]=s;c[h>>2]=F;J=G;K=(g[k>>2]=s,c[k>>2]|0)}c[J>>2]=XEi(K|0)|0;s=ea(g[b+56>>2]);L=ea(g[C>>2]);M=ea(s-L);if(M<ea(0.0))N=ea(-M);else N=M;C=!(N<=ea(.0000999999974));N=ea(g[G>>2]);do if(!C){M=ea(L-N);if(M<ea(0.0))O=ea(-M);else O=M;if(O<=ea(.0000999999974)){M=ea(s+ea(-1.0));if(M<ea(0.0))P=ea(-M);else P=M;G=b+136|0;if(P<=ea(.0000999999974)){a[G>>0]=0;break}a[G>>0]=1;if(s<ea(0.0))a[G>>0]=6}else Q=31}else Q=31;while(0);if((Q|0)==31)a[b+136>>0]=(ea(ea(s*L)*N)<ea(0.0)&1)<<2|2;if(c[d>>2]&16384){i=e;return}CHc(d,b+140|0,0);DHc(b+156|0,d);i=e;return}function jHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;lTb(a,b);EHc(b,a+28|0,596720,2048);f=a+44|0;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){g[j>>2]=ea(g[f>>2]);c[h>>2]=k;n=k;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=a+48|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[f>>2]);c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=a+52|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[f>>2]);c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=a+56|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[f>>2]);c[h>>2]=q;t=q;u=s}else{Gid(h,f,4);t=c[h>>2]|0;u=c[l>>2]|0}f=a+60|0;s=t+4|0;if(s>>>0<u>>>0){g[t>>2]=ea(g[f>>2]);c[h>>2]=s;v=s;w=u}else{Gid(h,f,4);v=c[h>>2]|0;w=c[l>>2]|0}f=a+64|0;u=v+4|0;if(u>>>0<w>>>0){g[v>>2]=ea(g[f>>2]);c[h>>2]=u}else Gid(h,f,4);if(c[b>>2]&16384){i=d;return}f=a+148|0;u=c[f>>2]|0;c[e>>2]=u;v=c[h>>2]|0;w=v+4|0;if(w>>>0<(c[l>>2]|0)>>>0){c[v>>2]=u;c[h>>2]=w}else Gid(h,e,4);e=c[a+140>>2]|0;h=c[f>>2]|0;f=e+(h<<2)|0;if(h){h=e;do{FHc(h,b);h=h+4|0}while((h|0)!=(f|0))}FHc(a+156|0,b);i=d;return}function kHc(a,b){a=a|0;b=b|0;var c=0;c=i;mTb(a,b);lHc(a,b);i=c;return}function lHc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(c[d>>2]&16384){i=e;return}idd(d,65601);f=c[b+140>>2]|0;g=c[b+148>>2]|0;h=f+(g<<2)|0;if(g){g=d+12|0;j=d+28|0;k=d+32|0;l=f;do{f=c[l>>2]|0;if(!f)m=0;else m=c[f+4>>2]|0;f=c[g>>2]|0;n=xo[c[c[f>>2]>>2]&2047](f,m,c[j>>2]|0)|0;if(a[k>>0]|0)c[l>>2]=iQb(n,0)|0;l=l+4|0}while((l|0)!=(h|0))}jdd(d);idd(d,65537);h=b+156|0;b=c[h>>2]|0;if(!b)o=0;else o=c[b+4>>2]|0;b=c[d+12>>2]|0;l=xo[c[c[b>>2]>>2]&2047](b,o,c[d+28>>2]|0)|0;if(a[d+32>>0]|0)c[h>>2]=iQb(l,0)|0;jdd(d);i=e;return}function mHc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=(c[149200]|0)+1|0;c[149200]=g;a:do if(g>>>0<=2e3){h=a[d>>0]|0;if(h<<24>>24){j=h;k=d;while(1){if(j<<24>>24==0|j<<24>>24==47){l=k;break}m=k+1|0;j=a[m>>0]|0;k=m}k=l-d|0;if(h<<24>>24==47){n=nHc(d)|0;break}else if(h<<24>>24==46)o=7;do if((o|0)==7?(a[d+1>>0]|0)==46:0){j=c[b+156>>2]|0;m=a[d+2>>0]|0;if(!(m<<24>>24)){n=j;break a}else if(m<<24>>24!=47)break;if(!j){n=0;break a}n=mHc(j,d+3|0,0)|0;break a}while(0);h=b+140|0;j=b+148|0;if(!(c[j>>2]|0))n=0;else{m=(k|0)>0;p=d+k|0;q=d+(k+1)|0;r=c[h>>2]|0;while(1){s=c[r>>2]|0;if(e){t=c[s+24>>2]|0;if((t|0)!=0?vTb(t)|0:0)o=16}else o=16;if((o|0)==16?(o=0,t=mo[c[(c[s>>2]|0)+32>>2]&4095](s)|0,(SEi(t|0)|0)==(k|0)):0){b:do if(m){u=0;v=t;while(1){if((a[d+u>>0]|0)!=(a[v>>0]|0)){w=u;break b}x=u+1|0;if((x|0)<(k|0)){u=x;v=v+1|0}else{w=x;break}}}else w=0;while(0);if((w|0)==(k|0)){if(!(a[p>>0]|0)){n=s;break a}t=mHc(s,q,0)|0;if(t){n=t;break a}}}r=r+4|0;if((r|0)==((c[h>>2]|0)+(c[j>>2]<<2)|0)){n=0;break}}}}else n=b}else n=0;while(0);c[149200]=(c[149200]|0)+-1;i=f;return n|0}function nHc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=(a[b>>0]|0)==47;f=e?b+1|0:b;if(!(a[f>>0]|0)){g=0;i=d;return g|0}b=wTb()|0;h=c[b+4>>2]|0;a:do if((h|0)!=(b|0)){j=h;while(1){k=GHc(f,c[j+8>>2]|0,e)|0;if(k){g=k;break}j=c[j+4>>2]|0;if((j|0)==(b|0))break a}i=d;return g|0}while(0);b=wTb()|0;h=c[b+12>>2]|0;j=b+8|0;if((h|0)==(j|0)){g=0;i=d;return g|0}else l=h;while(1){h=GHc(f,c[l+8>>2]|0,e)|0;if(h){g=h;m=8;break}l=c[l+4>>2]|0;if((l|0)==(j|0)){g=0;m=8;break}}if((m|0)==8){i=d;return g|0}return 0}function oHc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+32|0;g=f+24|0;h=f+12|0;j=f;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;if((d|0)==(e|0)){i=f;return}k=b+1|0;l=j+1|0;m=j+8|0;n=j+4|0;o=b+8|0;p=b+4|0;q=0;r=d;while(1){if(!(q&1))s=(q&255)>>>1;else s=c[p>>2]|0;d=mo[c[(c[r>>2]|0)+32>>2]&4095](r)|0;if(!s)zri(b,d)|0;else{a[g>>0]=47;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;t=a[b>>0]|0;if(!(t&1))u=(t&255)>>>1;else u=c[p>>2]|0;Pri(j,g,1,u+1|0);if(!(a[b>>0]&1))v=k;else v=c[o>>2]|0;Gri(j,v,u)|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;t=SEi(d|0)|0;w=a[j>>0]|0;if(!(w&1))x=(w&255)>>>1;else x=c[n>>2]|0;Pri(h,d,t,x+t|0);Gri(h,(a[j>>0]&1)==0?l:c[m>>2]|0,x)|0;yri(b,h)|0;xri(h);xri(j)}t=c[r+156>>2]|0;if(!((t|0)!=(e|0)&(t|0)!=0))break;q=a[b>>0]|0;r=t}i=f;return}function pHc(b,d){b=b|0;d=d|0;var e=0,f=0;e=b+28|0;f=d+28|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=b+44|0;e=d+44|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];e=b+56|0;f=d+56|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];a[b+136>>0]=a[d+136>>0]|0;return}function qHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<2)|0;c[q>>2]=p;i=d;return}h=k<<1;r=(h|0)==0?1:h;do if(l>>>0<r>>>0)if((k|0)>-1){c[j>>2]=r;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(r<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<2|0)|0;c[j>>2]=r;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<2)|0;c[q>>2]=p;i=d;return}function rHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;e=i;i=i+16|0;f=e;h=c[a+156>>2]|0;j=a+44|0;if(!h){c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];k=ea(g[d>>2]);l=ea(k*k);m=ea(g[d+4>>2]);n=ea(l+ea(m*m));l=ea(g[d+8>>2]);o=ea(n+ea(l*l));n=ea(g[d+12>>2]);p=ea(T(ea(o+ea(n*n))));if(p<ea(g[150276])){q=ea(1.0);r=ea(0.0);s=ea(0.0);t=ea(0.0)}else{q=ea(n/p);r=ea(l/p);s=ea(m/p);t=ea(k/p)}g[a+28>>2]=t;g[a+32>>2]=s;g[a+36>>2]=r;g[a+40>>2]=q;i=e;return}zGc(f,h,b);c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];q=ea(g[h+28>>2]);r=ea(g[h+32>>2]);s=ea(g[h+36>>2]);t=ea(g[h+40>>2]);f=c[h+156>>2]|0;if(!f){u=q;v=r;w=s;x=t}else{p=q;q=t;t=s;s=r;h=f;while(1){r=ea(g[h+40>>2]);k=ea(p*r);m=ea(g[h+28>>2]);l=ea(k+ea(q*m));k=ea(g[h+32>>2]);n=ea(l+ea(t*k));l=ea(g[h+36>>2]);o=ea(n-ea(s*l));n=ea(ea(ea(p*l)+ea(ea(s*r)+ea(q*k)))-ea(t*m));y=ea(ea(ea(s*m)+ea(ea(t*r)+ea(q*l)))-ea(p*k));z=ea(ea(ea(ea(q*r)-ea(p*m))-ea(s*k))-ea(t*l));h=c[h+156>>2]|0;if(!h){u=o;v=n;w=y;x=z;break}else{p=o;q=z;t=y;s=n}}}s=ea(-u);u=ea(-v);v=ea(-w);w=ea(g[d>>2]);t=ea(x*w);q=ea(g[d+12>>2]);p=ea(t+ea(q*s));t=ea(g[d+8>>2]);n=ea(p+ea(t*u));p=ea(g[d+4>>2]);y=ea(n-ea(p*v));n=ea(ea(ea(w*v)+ea(ea(q*u)+ea(x*p)))-ea(t*s));z=ea(ea(ea(ea(q*v)+ea(x*t))+ea(p*s))-ea(w*u));o=ea(ea(ea(ea(x*q)-ea(w*s))-ea(p*u))-ea(t*v));v=ea(T(ea(ea(o*o)+ea(ea(z*z)+ea(ea(y*y)+ea(n*n))))));if(v<ea(g[150276])){A=ea(1.0);B=ea(0.0);C=ea(0.0);D=ea(0.0)}else{A=ea(o/v);B=ea(z/v);C=ea(n/v);D=ea(y/v)}g[a+28>>2]=D;g[a+32>>2]=C;g[a+36>>2]=B;g[a+40>>2]=A;i=e;return}function sHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im;e=i;i=i+16|0;f=e;h=c[a+156>>2]|0;j=a+44|0;if(!h){c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];k=ea(g[d>>2]);l=ea(k*k);m=ea(g[d+4>>2]);n=ea(l+ea(m*m));l=ea(g[d+8>>2]);o=ea(n+ea(l*l));n=ea(g[d+12>>2]);p=ea(T(ea(o+ea(n*n))));if(p<ea(g[150276])){q=ea(1.0);r=ea(0.0);s=ea(0.0);t=ea(0.0)}else{q=ea(n/p);r=ea(l/p);s=ea(m/p);t=ea(k/p)}g[a+28>>2]=t;g[a+32>>2]=s;g[a+36>>2]=r;g[a+40>>2]=q;hGc(a,3);i=e;return}zGc(f,h,b);c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];q=ea(g[h+28>>2]);r=ea(g[h+32>>2]);s=ea(g[h+36>>2]);t=ea(g[h+40>>2]);f=c[h+156>>2]|0;if(!f){u=q;v=r;w=s;x=t}else{p=q;q=t;t=s;s=r;h=f;while(1){r=ea(g[h+40>>2]);k=ea(p*r);m=ea(g[h+28>>2]);l=ea(k+ea(q*m));k=ea(g[h+32>>2]);n=ea(l+ea(t*k));l=ea(g[h+36>>2]);o=ea(n-ea(s*l));n=ea(ea(ea(p*l)+ea(ea(s*r)+ea(q*k)))-ea(t*m));y=ea(ea(ea(s*m)+ea(ea(t*r)+ea(q*l)))-ea(p*k));z=ea(ea(ea(ea(q*r)-ea(p*m))-ea(s*k))-ea(t*l));h=c[h+156>>2]|0;if(!h){u=o;v=n;w=y;x=z;break}else{p=o;q=z;t=y;s=n}}}s=ea(-u);u=ea(-v);v=ea(-w);w=ea(g[d>>2]);t=ea(x*w);q=ea(g[d+12>>2]);p=ea(t+ea(q*s));t=ea(g[d+8>>2]);n=ea(p+ea(t*u));p=ea(g[d+4>>2]);y=ea(n-ea(p*v));n=ea(ea(ea(w*v)+ea(ea(q*u)+ea(x*p)))-ea(t*s));z=ea(ea(ea(ea(q*v)+ea(x*t))+ea(p*s))-ea(w*u));o=ea(ea(ea(ea(x*q)-ea(w*s))-ea(p*u))-ea(t*v));v=ea(T(ea(ea(o*o)+ea(ea(z*z)+ea(ea(y*y)+ea(n*n))))));if(v<ea(g[150276])){A=ea(1.0);B=ea(0.0);C=ea(0.0);D=ea(0.0)}else{A=ea(o/v);B=ea(z/v);C=ea(n/v);D=ea(y/v)}g[a+28>>2]=D;g[a+32>>2]=C;g[a+36>>2]=B;g[a+40>>2]=A;hGc(a,3);i=e;return}function tHc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(160,f,1,16,3653512,78)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];bUb(h,f,d);c[h>>2]=596384;d=h+44|0;a[h+132>>0]=0;a[h+133>>0]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;a[h+134>>0]=1;a[h+135>>0]=11;c[h+140>>2]=0;c[h+144>>2]=j;c[h+148>>2]=0;c[h+152>>2]=0;c[h+156>>2]=0;a[h+136>>0]=0;a[h+137>>0]=0;i=e;return h|0}function uHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[($hd(b+16|0)|0)+20>>2]|2097152;f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+20>>2]=e;e=c[142268]|0;add(b,3143216,e,a,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2416480,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2419736,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}
function vHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,3143216,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,3143224,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,2416480,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;a=qdd(b,2419736,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function wHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];JHc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<2)|0;do if(c[f>>2]|0){j=qdd(a,3142592,596808,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;xHc(r,a);t=r+4|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,596808,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else xHc(m,a);sdd(a)}m=m+4|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function xHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d;g=d+16|0;h=f+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[f>>2]=0;j=c[b>>2]|0;if(!(j&1)){k=qdd(b,792256,c[142270]|0,e,0)|0;if(k){if((k|0)>0){k=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[n>>2];c[k>>2]=o}else Bid(k,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{k=c[e>>2]|0;if(k)_n[k&4095](f,b)|0}sdd(b)}k=qdd(b,792272,c[142290]|0,e,0)|0;if(k){if((k|0)>0){k=b+12|0;o=c[b+16>>2]|0;n=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=o+n|0;c[k>>2]=m;if((n|0)>=0?(l=o+(n+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){n=m;m=c[n+4>>2]|0;o=h;c[o>>2]=c[n>>2];c[o+4>>2]=m;c[k>>2]=l}else Bid(k,h,8);if(c[b>>2]&512){k=XEi(c[h>>2]|0)|0;l=h+4|0;c[h>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=k}}else{k=c[e>>2]|0;if(k)_n[k&4095](h,b)|0}sdd(b)}c[a>>2]=iQb(c[f>>2]|0,0)|0;i=d;return}else{k=(j&8388608|0)!=0;j=qdd(b,792256,c[142270]|0,e,0)|0;if(j){if((j|0)>0){j=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;o=l+m|0;c[j>>2]=o;if((m|0)>=0?(n=l+(m+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[o>>2];c[j>>2]=n}else Bid(j,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](f,b)|0}sdd(b)}j=qdd(b,792272,c[142290]|0,e,0)|0;if(j){if((j|0)>0){j=b+12|0;n=c[b+16>>2]|0;o=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=n+o|0;c[j>>2]=m;if((o|0)>=0?(l=n+(o+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){o=m;m=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=m;c[j>>2]=l}else Bid(j,h,8);if(c[b>>2]&512){j=XEi(c[h>>2]|0)|0;l=h+4|0;c[h>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=j}}else{j=c[e>>2]|0;if(j)_n[j&4095](h,b)|0}sdd(b)}gQb(f,g);c[a>>2]=iQb(c[g>>2]|0,k)|0;i=d;return}}function yHc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;d=a+12|0;f=c[d>>2]|0;h=f+4|0;j=a+20|0;a=c[j>>2]|0;if(h>>>0>a>>>0){Bid(d,b,4);k=c[d>>2]|0;l=c[j>>2]|0}else{g[b>>2]=ea(g[f>>2]);c[d>>2]=h;k=h;l=a}a=b+4|0;h=k+4|0;if(h>>>0>l>>>0){Bid(d,a,4);m=c[d>>2]|0;n=c[j>>2]|0}else{g[a>>2]=ea(g[k>>2]);c[d>>2]=h;m=h;n=l}l=b+8|0;h=m+4|0;if(h>>>0>n>>>0){Bid(d,l,4);o=c[d>>2]|0;p=c[j>>2]|0}else{g[l>>2]=ea(g[m>>2]);c[d>>2]=h;o=h;p=n}n=b+12|0;b=o+4|0;if(b>>>0>p>>>0){Bid(d,n,4);i=e;return}else{g[n>>2]=ea(g[o>>2]);c[d>>2]=b;i=e;return}}function zHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];JHc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<2)|0;if(!k){i=d;return}else u=s;do{AHc(u,a);u=u+4|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<2;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>2;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function AHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d;f=d+16|0;g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[b>>2]|0;if(!(h&1)){j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(j,e,4);o=c[j>>2]|0;p=c[m>>2]|0}else{c[e>>2]=c[k>>2];c[j>>2]=l;o=l;p=n}n=o+8|0;if(n>>>0>p>>>0)Bid(j,g,8);else{p=o;o=c[p+4>>2]|0;l=g;c[l>>2]=c[p>>2];c[l+4>>2]=o;c[j>>2]=n}c[a>>2]=iQb(c[e>>2]|0,0)|0;i=d;return}else{n=b+12|0;j=c[n>>2]|0;o=j+4|0;l=b+20|0;b=c[l>>2]|0;if(o>>>0>b>>>0){Bid(n,e,4);q=c[n>>2]|0;r=c[l>>2]|0}else{c[e>>2]=c[j>>2];c[n>>2]=o;q=o;r=b}b=q+8|0;if(b>>>0>r>>>0)Bid(n,g,8);else{r=q;q=c[r+4>>2]|0;o=g;c[o>>2]=c[r>>2];c[o+4>>2]=q;c[n>>2]=b}gQb(e,f);c[a>>2]=iQb(c[f>>2]|0,(h&8388608|0)!=0)|0;i=d;return}}function BHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;a=w+4|0;if(a>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=XEi(z|0)|0;c[y>>2]=A;i=d;return}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=a;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=XEi(z|0)|0;c[y>>2]=A;i=d;return}}function CHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];JHc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<2)|0;if(!k){i=d;return}else u=t;do{DHc(u,a);u=u+4|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<2;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>2;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function DHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+32|0;e=d;f=d+16|0;g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[b>>2]|0;if(!(h&1)){j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(j,e,4);o=c[e>>2]|0;p=c[j>>2]|0;q=c[m>>2]|0}else{m=c[k>>2]|0;c[e>>2]=m;c[j>>2]=l;o=m;p=l;q=n}n=XEi(o|0)|0;c[e>>2]=n;o=p+8|0;if(o>>>0>q>>>0){Bid(j,g,8);q=g+4|0;r=g;s=q;t=c[g>>2]|0;u=c[q>>2]|0;v=c[e>>2]|0}else{q=p;p=c[q>>2]|0;l=c[q+4>>2]|0;q=g;c[q>>2]=p;c[q+4>>2]=l;c[j>>2]=o;r=g;s=g+4|0;t=p;u=l;v=n}n=XEi(t|0)|0;c[r>>2]=XEi(u|0)|0;c[s>>2]=n;c[a>>2]=iQb(v,0)|0;i=d;return}else{v=b+12|0;n=c[v>>2]|0;s=n+4|0;u=b+20|0;b=c[u>>2]|0;if(s>>>0>b>>>0){Bid(v,e,4);w=c[e>>2]|0;x=c[v>>2]|0;y=c[u>>2]|0}else{u=c[n>>2]|0;c[e>>2]=u;c[v>>2]=s;w=u;x=s;y=b}c[e>>2]=XEi(w|0)|0;w=x+8|0;if(w>>>0>y>>>0){Bid(v,g,8);y=g+4|0;z=g;A=y;B=c[g>>2]|0;C=c[y>>2]|0}else{y=x;x=c[y>>2]|0;b=c[y+4>>2]|0;y=g;c[y>>2]=x;c[y+4>>2]=b;c[v>>2]=w;z=g;A=g+4|0;B=x;C=b}b=XEi(B|0)|0;c[z>>2]=XEi(C|0)|0;c[A>>2]=b;gQb(e,f);c[a>>2]=iQb(c[f>>2]|0,(h&8388608|0)!=0)|0;i=d;return}}function EHc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;d=a+12|0;f=c[d>>2]|0;h=f+4|0;j=a+20|0;a=c[j>>2]|0;if(h>>>0<a>>>0){g[f>>2]=ea(g[b>>2]);c[d>>2]=h;k=h;l=a}else{Gid(d,b,4);k=c[d>>2]|0;l=c[j>>2]|0}a=b+4|0;h=k+4|0;if(h>>>0<l>>>0){g[k>>2]=ea(g[a>>2]);c[d>>2]=h;m=h;n=l}else{Gid(d,a,4);m=c[d>>2]|0;n=c[j>>2]|0}a=b+8|0;l=m+4|0;if(l>>>0<n>>>0){g[m>>2]=ea(g[a>>2]);c[d>>2]=l;o=l;p=n}else{Gid(d,a,4);o=c[d>>2]|0;p=c[j>>2]|0}j=b+12|0;b=o+4|0;if(b>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[d>>2]=b;i=e;return}else{Gid(d,j,4);i=e;return}}function FHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=c[a>>2]|0;a=(g|0)==0;if(!(c[b>>2]&1)){if(a)h=0;else h=c[g+4>>2]|0;c[e>>2]=h;j=f;c[j>>2]=0;c[j+4>>2]=0;j=b+12|0;k=c[j>>2]|0;l=k+4|0;m=b+20|0;n=c[m>>2]|0;if(l>>>0<n>>>0){c[k>>2]=h;c[j>>2]=l;o=l;p=n}else{Gid(j,e,4);o=c[j>>2]|0;p=c[m>>2]|0}m=o+8|0;if(m>>>0<p>>>0){p=f;n=c[p+4>>2]|0;l=o;c[l>>2]=c[p>>2];c[l+4>>2]=n;c[j>>2]=m;i=d;return}else{Gid(j,f,8);i=d;return}}else{if(a)q=0;else q=c[g+4>>2]|0;fQb(q,e);q=b+12|0;g=c[q>>2]|0;a=g+4|0;j=b+20|0;b=c[j>>2]|0;if(a>>>0<b>>>0){c[g>>2]=c[e>>2];c[q>>2]=a;r=a;s=b}else{Gid(q,e,4);r=c[q>>2]|0;s=c[j>>2]|0}j=r+8|0;if(j>>>0<s>>>0){s=f;e=c[s+4>>2]|0;b=r;c[b>>2]=c[s>>2];c[b+4>>2]=e;c[q>>2]=j;i=d;return}else{Gid(q,f,8);i=d;return}}}function GHc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=mo[c[(c[d>>2]|0)+32>>2]&4095](d)|0;h=SEi(g|0)|0;if(IEi(g,b,h)|0){j=0;i=f;return j|0}g=b+h|0;if((a[g>>0]|0)==47)k=b+(h+1)|0;else k=g;g=BTb(d)|0;if(!g){j=0;i=f;return j|0}if(e?(c[g+156>>2]|0)!=0:0){j=0;i=f;return j|0}if(((a[k>>0]|0)==0?(e=c[g+24>>2]|0,(e|0)!=0):0)?vTb(e)|0:0){j=g;i=f;return j|0}j=mHc(g,k,1)|0;i=f;return j|0}function HHc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=SEi(d|0)|0;g=a[b>>0]|0;if(!(g&1)){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+-1|0;j=g&255}g=(j&1)==0;if(g)k=(j&255)>>>1;else k=c[b+4>>2]|0;if((h-k|0)>>>0<f>>>0){eXb(b,h,f-h+k|0,k,k,0,f,d);i=e;return b|0}if(!f){i=e;return b|0}if(g)l=b+1|0;else l=c[b+8>>2]|0;YEi(l+k|0,d|0,f|0)|0;d=k+f|0;if(!(a[b>>0]&1))a[b>>0]=d<<1;else c[b+4>>2]=d;a[l+d>>0]=0;i=e;return b|0}function IHc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=596384;if((c[a+152>>2]|0)<=-1){WUb(a);ACi(a);i=b;return}f=a+140|0;g=c[f>>2]|0;c[e>>2]=c[a+144>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;WUb(a);ACi(a);i=b;return}function JHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<2,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<2,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<2|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<2)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<2)|0;do{if(f)c[f>>2]=0;f=f+4|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function KHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+64|0;f=e+40|0;g=e+28|0;h=e;j=c[d>>2]|0;k=d+4|0;l=c[k>>2]|0;if((l|0)!=(j|0))c[k>>2]=l+(~((l+-4-j|0)>>>2)<<2);if(!b){m=0;i=e;return m|0}c[f+8>>2]=0;c[f+4>>2]=a;c[f>>2]=(b|0)/3|0;rxd(h);if((uxd(h,f)|0?vxd(h,g)|0:0)?(c[g>>2]|0)==1:0){f=c[c[g+4>>2]>>2]|0;b=c[g+8>>2]|0;PHc(d,f);QHc(d,b,b+(f<<2)|0);n=1}else n=0;sxd(h);m=n;i=e;return m|0}function LHc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c+-2|0;c=0;f=0;a:while(1){g=f;while(1){if((g|0)>=(e|0)){h=c;break a}j=b[a+(g<<1)>>1]|0;k=g+1|0;l=b[a+(k<<1)>>1]|0;if(j<<16>>16==l<<16>>16)g=k;else{m=j;n=k;o=l;p=g;break}}g=b[a+(p+2<<1)>>1]|0;c=((m<<16>>16==g<<16>>16?1:o<<16>>16==g<<16>>16)&1^1)+c|0;f=n}i=d;return h|0}function MHc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c+-2|0;c=0;g=0;a:while(1){h=c;while(1){if((h|0)>=(f|0))break a;j=b[a+(h<<1)>>1]|0;k=h+1|0;l=b[a+(k<<1)>>1]|0;m=b[a+(h+2<<1)>>1]|0;if((j<<16>>16==l<<16>>16?1:j<<16>>16==m<<16>>16)|l<<16>>16==m<<16>>16)h=k;else{n=j;o=k;p=l;q=m;r=h;break}}h=(r&1|0)==0;b[d+(g<<1)>>1]=h?n:p;b[d+(g+1<<1)>>1]=h?p:n;b[d+(g+2<<1)>>1]=q;c=o;g=g+3|0}i=e;return}function NHc(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=e+4|0;h=c[g>>2]|0;j=c[e>>2]|0;k=h-j|0;l=d+-2|0;d=0;m=0;a:while(1){n=m;while(1){if((n|0)>=(l|0)){o=d;break a}p=b[a+(n<<1)>>1]|0;q=n+1|0;r=b[a+(q<<1)>>1]|0;if(p<<16>>16==r<<16>>16)n=q;else{s=p;t=q;u=r;v=n;break}}n=b[a+(v+2<<1)>>1]|0;d=((s<<16>>16==n<<16>>16?1:u<<16>>16==n<<16>>16)&1^1)+d|0;m=t}t=k>>1;k=o*3|0;o=k+t|0;m=o>>>0<k>>>0;if(o>>>0<=t>>>0)if(m?(m=j+(o<<1)|0,(h|0)!=(m|0)):0){c[g>>2]=h+(~((h+-2-m|0)>>>1)<<1);w=j}else w=j;else{RHc(e,k);w=c[e>>2]|0}e=t+1|0;k=t+2|0;j=0;m=0;b:while(1){h=j;while(1){if((h|0)>=(l|0))break b;g=b[a+(h<<1)>>1]|0;o=h+1|0;d=b[a+(o<<1)>>1]|0;u=b[a+(h+2<<1)>>1]|0;if((g<<16>>16==d<<16>>16?1:g<<16>>16==u<<16>>16)|d<<16>>16==u<<16>>16)h=o;else{x=g;y=o;z=d;A=u;B=h;break}}h=(B&1|0)==0;b[w+(m+t<<1)>>1]=h?x:z;b[w+(e+m<<1)>>1]=h?z:x;b[w+(k+m<<1)>>1]=A;j=y;m=m+3|0}i=f;return}function OHc(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;g=e+4|0;h=c[g>>2]|0;j=c[e>>2]|0;k=h-j|0;l=d+-2|0;d=0;m=0;a:while(1){n=m;while(1){if((n|0)>=(l|0)){o=d;break a}p=b[a+(n<<1)>>1]|0;q=n+1|0;r=b[a+(q<<1)>>1]|0;if(p<<16>>16==r<<16>>16)n=q;else{s=p;t=q;u=r;v=n;break}}n=b[a+(v+2<<1)>>1]|0;d=((s<<16>>16==n<<16>>16?1:u<<16>>16==n<<16>>16)&1^1)+d|0;m=t}t=k>>2;k=o*3|0;o=k+t|0;m=o>>>0<k>>>0;if(o>>>0<=t>>>0)if(m?(m=j+(o<<2)|0,(h|0)!=(m|0)):0){c[g>>2]=h+(~((h+-4-m|0)>>>2)<<2);w=j}else w=j;else{Qec(e,k);w=c[e>>2]|0}if((l|0)<=0){i=f;return}e=t+1|0;k=t+2|0;j=b[a>>1]|0;m=0;h=0;b:while(1){g=j;o=m;while(1){d=o;o=o+1|0;u=g;g=b[a+(o<<1)>>1]|0;if(u<<16>>16!=g<<16>>16?(s=b[a+(d+2<<1)>>1]|0,!(u<<16>>16==s<<16>>16?1:g<<16>>16==s<<16>>16)):0){x=u;y=o;z=g;A=s;B=d;break}if((o|0)>=(l|0)){C=18;break b}}o=(B&1|0)==0;c[w+(h+t<<2)>>2]=(o?x:z)&65535;c[w+(e+h<<2)>>2]=(o?z:x)&65535;c[w+(k+h<<2)>>2]=A&65535;if((y|0)<(l|0)){j=z;m=y;h=h+3|0}else{C=18;break}}if((C|0)==18){i=f;return}}function PHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+8|0;j=d+4|0;k=d;l=a+8|0;if(((c[l>>2]|0)-(c[a>>2]|0)>>2|0)==(b|0)){i=d;return}c[h>>2]=0;m=h+4|0;c[m>>2]=0;n=h+8|0;c[n>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],o=cOb(b<<2,16,e,0,3653512,80)|0,p=c[h>>2]|0,q=(c[m>>2]|0)-p|0,r=o+(0-(q>>2)<<2)|0,YEi(r|0,p|0,q|0)|0,q=c[h>>2]|0,c[h>>2]=r,c[m>>2]=o,c[n>>2]=o+(b<<2),(q|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(q,e)}c[j>>2]=c[a>>2];q=a+4|0;c[k>>2]=c[q>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];SHc(h,f,e);k=c[h>>2]|0;j=c[a>>2]|0;c[h>>2]=j;c[a>>2]=k;k=c[m>>2]|0;a=c[q>>2]|0;c[m>>2]=a;c[q>>2]=k;k=c[n>>2]|0;c[n>>2]=c[l>>2];c[l>>2]=k;if(!j){i=d;return}if((a|0)!=(j|0))c[m>>2]=a+(~((a+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function QHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b;j=d-h|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>2>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>2;if(k>>>0<=r>>>0){s=d-h|0;aFi(n|0,b|0,s|0)|0;t=n+(s>>2<<2)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-4-t|0)>>>2)<<2);i=e;return}t=b+(r<<2)|0;aFi(n|0,b|0,q|0)|0;if((t|0)==(d|0)){i=e;return}q=c[p>>2]|0;r=(d+-4-t|0)>>>2;s=t;t=q;while(1){if(t)c[t>>2]=c[s>>2];s=s+4|0;if((s|0)==(d|0))break;else t=t+4|0}c[p>>2]=q+(r+1<<2);i=e;return}if(!n)u=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;u=0}if((j|0)<0)vxi(a);j=u-0|0;if(j>>2>>>0<1073741823){u=j>>1;j=u>>>0<k>>>0?k:u;if((j|0)<0)vxi(a);else v=j}else v=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(v<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(v<<2);if((b|0)==(d|0)){i=e;return}v=(d+-4-h|0)>>>2;h=b;b=g;while(1){if(b)c[b>>2]=c[h>>2];h=h+4|0;if((h|0)==(d|0))break;else b=b+4|0}c[f>>2]=g+(v+1<<2);i=e;return}function RHc(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>1>>>0>=d>>>0){n=d;o=l;while(1){if(o)b[o>>1]=0;n=n+-1|0;if(!n)break;else o=o+2|0}c[k>>2]=l+(d<<1);i=e;return}l=c[a>>2]|0;o=(m-l>>1)+d|0;if((o|0)<0)vxi(a);m=l;l=j-m|0;if(l>>1>>>0<1073741823){j=l>>>0<o>>>0?o:l;l=(c[k>>2]|0)-m>>1;if(!j){p=0;q=0;r=l}else{s=j;t=l;u=11}}else{s=2147483647;t=(c[k>>2]|0)-m>>1;u=11}if((u|0)==11){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];p=s;q=cOb(s<<1,16,f,0,3653512,80)|0;r=t}t=d;s=q+(r<<1)|0;while(1){if(s)b[s>>1]=0;t=t+-1|0;if(!t)break;else s=s+2|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+(r-(t>>1)<<1)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+(r+d<<1);c[h>>2]=q+(p<<1);if(!t){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(t,f);i=e;return}function SHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>2>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>2;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>2<<2)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-4-t|0)>>>2)<<2);i=e;return}t=h+(r<<2)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-4-t|0)>>>2;s=q;u=t;while(1){if(s)c[s>>2]=c[u>>2];u=u+4|0;if((u|0)==(b|0))break;else s=s+4|0}c[p>>2]=q+(r+1<<2);i=e;return}if(!n)v=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;v=0}if((j|0)<0)vxi(a);j=v-0|0;if(j>>2>>>0<1073741823){v=j>>1;j=v>>>0<k>>>0?k:v;if((j|0)<0)vxi(a);else w=j}else w=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(w<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(w<<2);if((h|0)==(b|0)){i=e;return}w=(b+-4-d|0)>>>2;d=g;l=h;while(1){if(d)c[d>>2]=c[l>>2];l=l+4|0;if((l|0)==(b|0))break;else d=d+4|0}c[f>>2]=g+(w+1<<2);i=e;return}function THc(a,b){a=a|0;b=b|0;return}function UHc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[b>>2]=621328;_jd(b);if(a[b+108>>0]&1){h=c[b+116>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(h,e)}Vjc(b+96|0,c[b+100>>2]|0);Wjc(b+84|0,c[b+88>>2]|0);Xjc(b+72|0,c[b+76>>2]|0);h=b+40|0;g=c[h>>2]|0;if(!g){EWb(b);i=d;return}j=b+44|0;k=c[j>>2]|0;if((k|0)==(g|0))l=g;else{m=k;while(1){k=m+-44|0;c[j>>2]=k;if((c[m+-32>>2]|0)>-1){n=c[k>>2]|0;c[f>>2]=c[m+-40>>2];c[e+0>>2]=c[f+0>>2];eOb(n,e);c[k>>2]=0;o=c[j>>2]|0}else o=k;if((o|0)==(g|0))break;else m=o}l=c[h>>2]|0}ACi(l);EWb(b);i=d;return}function VHc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d;l=(e-k|0)/12|0;m=b+8|0;n=c[m>>2]|0;o=c[b>>2]|0;p=o;if(l>>>0>((n-p|0)/12|0)>>>0){if(!o)q=n;else{n=b+4|0;r=c[n>>2]|0;if((r|0)==(o|0))s=o;else{t=r;while(1){r=t+-12|0;c[n>>2]=r;if(!(a[r>>0]&1))u=r;else{r=c[t+-4>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(r,g);u=c[n>>2]|0}if((u|0)==(o|0))break;else t=u}s=c[b>>2]|0}ACi(s);c[m>>2]=0;c[n>>2]=0;c[b>>2]=0;q=0}if(l>>>0>357913941)vxi(b);n=(q-0|0)/12|0;if(n>>>0<178956970){q=n<<1;n=q>>>0<l>>>0?l:q;if(n>>>0>357913941)vxi(b);else v=n}else v=357913941;n=xCi(v*12|0)|0;q=b+4|0;c[q>>2]=n;c[b>>2]=n;c[m>>2]=n+(v*12|0);if((d|0)==(e|0)){i=f;return}v=d;m=n;while(1){n=a[v>>0]|0;if(!(n&1)){w=(n&255)>>>1;x=v+1|0}else{w=c[v+4>>2]|0;x=c[v+8>>2]|0}if(w>>>0>2147483631){y=63;break}if(w>>>0<11){a[m>>0]=w<<1;z=m+1|0}else{n=w+16&-16;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];s=cOb(n,16,g,0,3653512,80)|0;c[m+8>>2]=s;c[m>>2]=n|1;c[m+4>>2]=w;z=s}YEi(z|0,x|0,w|0)|0;a[z+w>>0]=0;s=(c[q>>2]|0)+12|0;c[q>>2]=s;v=v+12|0;if((v|0)==(e|0)){y=68;break}else m=s}if((y|0)==63)ori(m);else if((y|0)==68){i=f;return}}m=b+4|0;b=((c[m>>2]|0)-p|0)/12|0;if(l>>>0>b>>>0){A=1;B=d+(b*12|0)|0}else{A=0;B=e}if((B|0)==(d|0))C=o;else{b=B+-12-k|0;k=d;d=o;while(1){do if((d|0)!=(k|0)){l=a[k>>0]|0;if(!(l&1)){D=(l&255)>>>1;E=k+1|0}else{D=c[k+4>>2]|0;E=c[k+8>>2]|0}l=a[d>>0]|0;if(!(l&1)){F=10;G=l}else{l=c[d>>2]|0;F=(l&-2)+-1|0;G=l&255}l=(G&1)==0;if(D>>>0>F>>>0){if(l)H=(G&255)>>>1;else H=c[d+4>>2]|0;eXb(d,F,D-F|0,H,0,H,D,E);break}if(l)I=d+1|0;else I=c[d+8>>2]|0;aFi(I|0,E|0,D|0)|0;a[I+D>>0]=0;if(!(a[d>>0]&1)){a[d>>0]=D<<1;break}else{c[d+4>>2]=D;break}}while(0);k=k+12|0;if((k|0)==(B|0))break;else d=d+12|0}C=o+((((b>>>0)/12|0)+1|0)*12|0)|0}if(!A){A=c[m>>2]|0;if((A|0)==(C|0)){i=f;return}b=A;while(1){A=b+-12|0;c[m>>2]=A;if(!(a[A>>0]&1))J=A;else{A=c[b+-4>>2]|0;c[j>>2]=58;c[g+0>>2]=c[j+0>>2];eOb(A,g);J=c[m>>2]|0}if((J|0)==(C|0))break;else b=J}i=f;return}if((B|0)==(e|0)){i=f;return}J=B;B=c[m>>2]|0;while(1){if(!B)K=0;else{b=a[J>>0]|0;if(!(b&1)){L=(b&255)>>>1;M=J+1|0}else{L=c[J+4>>2]|0;M=c[J+8>>2]|0}if(L>>>0>2147483631){y=33;break}if(L>>>0<11){a[B>>0]=L<<1;N=B+1|0}else{b=L+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];C=cOb(b,16,g,0,3653512,80)|0;c[B+8>>2]=C;c[B>>2]=b|1;c[B+4>>2]=L;N=C}YEi(N|0,M|0,L|0)|0;a[N+L>>0]=0;K=c[m>>2]|0}C=K+12|0;c[m>>2]=C;J=J+12|0;if((J|0)==(e|0)){y=68;break}else B=C}if((y|0)==33)ori(B);else if((y|0)==68){i=f;return}}function WHc(){var a=0,b=0;a=i;b=xCi(100)|0;YHc(b);c[149206]=b;IIc();i=a;return}function XHc(){return c[149206]|0}function YHc(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=b;c[b+4>>2]=b;g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(0.0);e=b+20|0;c[e>>2]=e;c[b+24>>2]=e;c[b+28>>2]=0;e=b+40|0;c[b+76>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;EIc(b+80|0);g[b+32>>2]=ea(0.0);a[b+9>>0]=0;a[b+8>>0]=0;i=d;return}function ZHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((b|0)==(a|0)){i=d;return}e=c[b>>2]|0;f=b+4|0;if(e){c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[b>>2]=0;c[f>>2]=0}e=c[a>>2]|0;c[b>>2]=e;c[f>>2]=a;c[e+4>>2]=b;c[c[f>>2]>>2]=b;i=d;return}function _Hc(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+48|0;e=d;a[(fKc()|0)+156>>0]=0;f=e+4|0;c[e+40>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;WQc(e,b+36|0);c[e>>2]=7;$Hc(b,e,0);TQc(e);i=d;return}function $Hc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;h=i;i=i+112|0;j=h+84|0;k=h+36|0;l=h+44|0;m=h+48|0;n=h+56|0;o=h;p=h+88|0;q=h+24|0;r=h+8|0;s=h+60|0;t=h+72|0;u=h+52|0;v=h+40|0;w=rIc()|0;AIc(w,f);x=w+280|0;y=c[x>>2]|0;z=e+80|0;FIc(z,w);A=Asd(zsd()|0)|0;B=e+4|0;C=(A|0)==0;if((c[B>>2]|0)==(e|0)&C){a[e+8>>0]=0;i=h;return}D=ECc()|0;if((mo[c[(c[D>>2]|0)+40>>2]&4095](D)|0)==1){D=y+4|0;c[D>>2]=-971227136;c[D+4>>2]=-971227136}D=c[y>>2]|0;if((D|0)==4?(E=b[y+36>>1]|0,E<<16>>16==25|E<<16>>16==9):0)F=(c[y+24>>2]<<1&2^2)+-1|0;else F=0;c[p>>2]=0;E=p+4|0;c[E>>2]=0;G=p+8|0;c[G>>2]=0;if(C){C=c[B>>2]|0;H=(C|0)==(e|0);if(!H){I=C;J=0;while(1){K=J+1|0;I=c[I+4>>2]|0;if((I|0)==(e|0)){L=K;break}else J=K}if(L){J=xCi(L*12|0)|0;c[p>>2]=J;c[E>>2]=J;c[G>>2]=J+(L*12|0)}}L=r+4|0;J=r+8|0;c[J>>2]=e;I=r+12|0;c[I>>2]=0;K=c[e>>2]|0;c[r>>2]=K;c[B>>2]=r;c[L>>2]=C;c[e>>2]=e;if((K|0)==(e|0))c[r>>2]=r;c[B>>2]=e;if(H)c[L>>2]=r;c[e+4>>2]=e;c[e>>2]=e;c[(c[r>>2]|0)+4>>2]=r;H=c[L>>2]|0;c[H>>2]=r;a:do if((H|0)==(r|0)){M=0;N=25}else{B=s+4|0;K=s+8|0;C=H;O=0;while(1){P=C;while(1){c[I>>2]=P;Q=c[P>>2]|0;if(Q){R=P+4|0;c[Q+4>>2]=c[R>>2];c[c[R>>2]>>2]=Q;c[P>>2]=0;c[R>>2]=0}R=c[J>>2]|0;if((P|0)!=(R|0)){Q=P+4|0;S=c[R>>2]|0;c[P>>2]=S;c[Q>>2]=R;c[S+4>>2]=P;c[c[Q>>2]>>2]=P}if(!P){T=O;break a}Q=c[P+8>>2]|0;if(!(o9c(Q)|0)){U=Q;break}c[s>>2]=Q;c[B>>2]=1732;c[K>>2]=3555;S=c[E>>2]|0;if((S|0)==(c[G>>2]|0))eIc(p,s);else{if(S){c[S>>2]=Q;c[S+4>>2]=1732;c[S+8>>2]=3555}c[E>>2]=S+12}P=c[L>>2]|0;if((P|0)==(r|0)){M=O;N=25;break a}}if(O)V=1;else V=xo[c[(c[U>>2]|0)+132>>2]&2047](U,0,0)|0;C=c[L>>2]|0;if((C|0)==(r|0)){M=V;N=25;break}else O=V}}while(0);if((N|0)==25){c[I>>2]=0;T=M}c[L>>2]=0;c[r>>2]=0;W=T}else{c[q>>2]=A;c[q+4>>2]=1732;c[q+8>>2]=3555;eIc(p,q);W=0}q=c[w+8>>2]|0;if(!q)X=0;else X=(c[q+24>>2]|0)!=0;q=e+20|0;A=e+28|0;b:do if(c[A>>2]|0){T=c[e+24>>2]|0;r=(c[q>>2]|0)+4|0;L=c[T>>2]|0;c[L+4>>2]=c[r>>2];c[c[r>>2]>>2]=L;c[A>>2]=0;L=T;while(1){if((L|0)==(q|0))break b;T=c[L+4>>2]|0;if(!(a[596840]|0)){bIc(596832,24);r=596840;c[r>>2]=1;c[r+4>>2]=0}dsd(c[149208]|0,L);L=T}}while(0);if((c[p>>2]|0)!=(c[E>>2]|0)){c[y>>2]=8;L=X^1;dJc(w,1,L);T=c[p>>2]|0;r=c[E>>2]|0;if((T|0)!=(r|0)){M=T;T=r;while(1){r=c[M>>2]|0;I=c[M+4>>2]|0;V=c[M+8>>2]|0;if(!r)Y=T;else{xo[I&2047](r,1,0)|0;U=c[(rIc()|0)+68>>2]|0;if(!(a[596840]|0)){bIc(596832,24);s=596840;c[s>>2]=1;c[s+4>>2]=0}s=csd(c[149208]|0,24)|0;c[s+12>>2]=r;c[s+16>>2]=I;c[s+20>>2]=V;c[s+8>>2]=U;c[s+4>>2]=q;U=c[q>>2]|0;c[s>>2]=U;c[U+4>>2]=s;c[q>>2]=s;c[A>>2]=(c[A>>2]|0)+1;Y=c[E>>2]|0}M=M+12|0;if((M|0)==(Y|0))break;else T=Y}}Y=w+96|0;nIc(Y,c[x>>2]|0);fJc(w,L);oIc(Y,c[x>>2]|0);c[l>>2]=c[e+24>>2];c[m>>2]=q;Y=c[A>>2]|0;c[k+0>>2]=c[l+0>>2];c[j+0>>2]=c[m+0>>2];fIc(n,k,j,Y,o);c[y>>2]=D}if(g){g=w+272|0;c[g>>2]=d[e+8>>0];o=c[e+24>>2]|0;c:do if((o|0)==(q|0)|W)Z=W;else{Y=X^1;if(X){j=o;k=0;while(1){if(k)_=0;else{dJc(w,1,Y);_=1}n=xo[c[j+16>>2]&2047](c[j+12>>2]|0,1,0)|0;if(_)fJc(w,Y);j=c[j+4>>2]|0;if((j|0)==(q|0)|n){Z=n;break c}else k=1}}else{$=o;aa=1;ba=0}while(1){if((aa|0)==(c[A>>2]|0))if(ba){ca=0;da=1}else N=66;else if((c[$+8>>2]|0)<1|ba){ca=0;da=ba}else N=66;if((N|0)==66){N=0;dJc(w,1,Y);ca=1;da=1}k=xo[c[$+16>>2]&2047](c[$+12>>2]|0,1,0)|0;if(ca)fJc(w,Y);$=c[$+4>>2]|0;if(($|0)==(q|0)|k){Z=k;break}else{aa=aa+1|0;ba=da}}}while(0);if((D|0)!=0|Z)ea=Z;else{c[(rIc()|0)>>2]=0;ea=0}if(D>>>0<2){c[g>>2]=((c[g>>2]|0)!=0|ea)&1;fa=ea}else fa=ea}else{ea=w+96|0;c[w+272>>2]=0;a[e+8>>0]=0;g=X^1;dJc(w,1,g);D=e+24|0;if((q|0)!=(c[D>>2]|0)){Z=q;da=1;ba=0;while(1){Z=c[Z>>2]|0;if(!ba)if((da|0)==(c[A>>2]|0)){ga=1;ha=1}else{aa=(c[(c[Z>>2]|0)+8>>2]|0)<1;ga=aa;ha=aa}else{ga=0;ha=1}xo[c[Z+16>>2]&2047](c[Z+12>>2]|0,1,0)|0;if(ga){nIc(ea,c[x>>2]|0);fJc(w,g);oIc(ea,c[x>>2]|0)}if((Z|0)==(c[D>>2]|0))break;else{da=da+1|0;ba=ha}}}if(X){nIc(ea,c[x>>2]|0);hJc(w);oIc(ea,c[x>>2]|0);fa=W}else fa=W}if(!((F|0)==0|fa)?(c[A>>2]|0)!=0:0){c[t>>2]=0;fa=t+4|0;c[fa>>2]=0;W=t+8|0;c[W>>2]=0;x=iJc(w)|0;do if(!x){ea=c[A>>2]|0;X=c[t>>2]|0;ha=X;if((c[W>>2]|0)-ha>>2>>>0<ea>>>0){ba=(c[fa>>2]|0)-ha|0;if(!ea)ia=0;else ia=xCi(ea<<2)|0;YEi(ia|0,X|0,ba|0)|0;c[t>>2]=ia;c[fa>>2]=ia+(ba>>2<<2);c[W>>2]=ia+(ea<<2);if(X)ACi(X)}X=c[e+24>>2]|0;if((X|0)!=(q|0)){ea=X;do{X=mo[c[ea+20>>2]&4095](c[ea+12>>2]|0)|0;c[v>>2]=X;ba=c[fa>>2]|0;if((ba|0)==(c[W>>2]|0))gIc(t,v);else{if(!ba)ja=0;else{c[ba>>2]=X;ja=c[fa>>2]|0}c[fa>>2]=ja+4}ea=c[ea+4>>2]|0}while((ea|0)!=(q|0))}}else{ea=x+4|0;c[u>>2]=ea;X=c[fa>>2]|0;if((X|0)==(c[W>>2]|0)){gIc(t,u);break}if(!X)ka=0;else{c[X>>2]=ea;ka=c[fa>>2]|0}c[fa>>2]=ka+4}while(0);CIc(w,t,(F|0)==1);F=c[t>>2]|0;if(F){t=c[fa>>2]|0;if((t|0)!=(F|0))c[fa>>2]=t+(~((t+-4-F|0)>>>2)<<2);ACi(F)}}GIc(z,w);HIc(z);a[e+8>>0]=(c[w+272>>2]|0)!=0&1;c[f>>2]=c[y>>2];y=c[p>>2]|0;if(!y){i=h;return}p=c[E>>2]|0;if((p|0)!=(y|0))c[E>>2]=p+(~(((p+-12-y|0)>>>0)/12|0)*12|0);ACi(y);i=h;return}function aIc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;i=i+64|0;d=b+48|0;e=b+44|0;f=b;h=EJc()|0;if(BJc(h)|0)WQc(a+36|0,CJc(h,(BJc(h)|0)+-1|0)|0);j=f+4|0;c[f+40>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;j=0;k=0;l=0;m=0;while(1){if((m|0)>=(BJc(h)|0)){n=k;o=j;p=l;break}WQc(f,CJc(h,m)|0);q=c[f>>2]|0;if((q|0)==4|(q|0)==1|(q|0)==0){r=ea(+$Kc(jLc()|0));g[(c[149206]|0)+32>>2]=r;s=7}else if((q|0)==2){t=k;u=j;v=l}else s=7;if((s|0)==7){s=0;$Hc(a,f,1);if((c[f>>2]|0)==12){q=j+1|0;w=k&2147483647;do if(q>>>0>w>>>0?(x=k<<1,y=(x|0)==0?1:x,w>>>0<y>>>0):0)if((k|0)>-1){c[e>>2]=60;c[d+0>>2]=c[e+0>>2];z=hOb(l,y<<2,4,d,0,3653512,370)|0;A=y;break}else{c[e>>2]=60;c[d+0>>2]=c[e+0>>2];x=cOb(y<<2,4,d,0,3653512,352)|0;YEi(x|0,l|0,q<<2|0)|0;z=x;A=y;break}else{z=l;A=k}while(0);c[z+(j<<2)>>2]=m;t=A;u=q;v=z}else{t=k;u=j;v=l}}j=u;k=t;l=v;m=m+1|0}a:do if(!o)B=p;else{m=o;while(1){v=m+-1|0;if((v|0)<=-1){B=p;break a}DJc(h,v);m=v}}while(0);if((n|0)<=-1){TQc(f);i=b;return}c[e>>2]=60;c[d+0>>2]=c[e+0>>2];eOb(B,d);TQc(f);i=b;return}function bIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=c[153126];c[e+0>>2]=c[f+0>>2];f=bOb(44,e,0,16,3653512,142)|0;c[g>>2]=c[153126];c[e+0>>2]=c[g+0>>2];_rd(f,1,719624,b,32768,e,16);c[a>>2]=f;Zrd(f);i=d;return}function cIc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[(c[a>>2]|0)+132>>2]&2047](a,b,d)|0;i=e;return f|0}function dIc(a){a=a|0;var b=0,c=0;b=i;c=g9c(a)|0;i=b;return c|0}function eIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=357913941;r=(l-j|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;r=n+(m*12|0)|0;if(s){c[s>>2]=c[b>>2];c[n+(o*12|0)+4>>2]=c[b+4>>2];c[n+(o*12|0)+8>>2]=c[b+8>>2]}b=n+((o+1|0)*12|0)|0;if((p|0)==(f|0)){u=s;v=f}else{m=o+-1-(((p+-12-j|0)>>>0)/12|0)|0;j=p;p=s;while(1){s=j;j=j+-12|0;c[p+-12>>2]=c[j>>2];c[p+-8>>2]=c[s+-8>>2];c[p+-4>>2]=c[s+-4>>2];if((j|0)==(f|0))break;else p=p+-12|0}u=n+(m*12|0)|0;v=c[a>>2]|0}c[a>>2]=u;c[e>>2]=b;c[h>>2]=r;if(!v){i=d;return}ACi(v);i=d;return}function fIc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+32|0;h=g+4|0;j=g+16|0;k=g+8|0;l=g+20|0;m=g+28|0;n=g;o=g+12|0;p=g+24|0;if((e|0)==1|(e|0)==0){c[a>>2]=c[b>>2];i=g;return}else if((e|0)==2){q=c[c[d>>2]>>2]|0;c[d>>2]=q;r=c[b>>2]|0;if((c[q+8>>2]|0)<(c[r+8>>2]|0)){s=q+4|0;t=c[q>>2]|0;c[t+4>>2]=c[s>>2];c[c[s>>2]>>2]=t;t=c[r>>2]|0;c[t+4>>2]=q;c[q>>2]=t;c[r>>2]=q;c[s>>2]=r;c[a>>2]=q;i=g;return}else{c[a>>2]=r;i=g;return}}else{r=e>>>1;q=c[b>>2]|0;if(!r)u=q;else{s=r;t=q;while(1){v=c[t+4>>2]|0;s=s+-1|0;if((s|0)<=0){u=v;break}else t=v}}c[l>>2]=q;c[m>>2]=u;c[j+0>>2]=c[l+0>>2];c[h+0>>2]=c[m+0>>2];fIc(k,j,h,r,f);m=c[k>>2]|0;c[b>>2]=m;c[o>>2]=u;u=c[d>>2]|0;c[p>>2]=u;c[j+0>>2]=c[o+0>>2];c[h+0>>2]=c[p+0>>2];fIc(n,j,h,e-r|0,f);f=c[n>>2]|0;n=c[m+8>>2]|0;if((c[f+8>>2]|0)<(n|0)){r=c[f+4>>2]|0;a:do if((r|0)==(u|0))w=u;else{e=r;while(1){if((c[e+8>>2]|0)>=(n|0)){w=e;break a}e=c[e+4>>2]|0;if((e|0)==(u|0)){w=u;break}}}while(0);n=c[w>>2]|0;r=n+4|0;e=c[f>>2]|0;c[e+4>>2]=c[r>>2];c[c[r>>2]>>2]=e;e=c[m+4>>2]|0;h=c[m>>2]|0;c[h+4>>2]=f;c[f>>2]=h;c[m>>2]=n;c[r>>2]=m;x=w;y=f;z=e}else{x=f;y=m;z=c[m+4>>2]|0}c[b>>2]=z;b:do if((z|0)!=(x|0)&(x|0)!=(u|0)){m=x;f=x;e=u;w=z;c:while(1){r=c[f+8>>2]|0;d:do if((f|0)==(e|0))if((r|0)<(c[w+8>>2]|0))A=w;else{B=w;break c}else{n=w;while(1){if((r|0)<(c[n+8>>2]|0)){A=n;break d}n=c[n+4>>2]|0;c[b>>2]=n;if((n|0)==(m|0))break b}}while(0);r=c[f+4>>2]|0;e:do if((r|0)==(e|0))C=e;else{n=c[A+8>>2]|0;h=r;while(1){if((c[h+8>>2]|0)>=(n|0)){C=h;break e}h=c[h+4>>2]|0;if((h|0)==(e|0)){C=e;break}}}while(0);r=c[C>>2]|0;h=r+4|0;n=c[f>>2]|0;c[n+4>>2]=c[h>>2];c[c[h>>2]>>2]=n;w=c[A+4>>2]|0;m=(m|0)==(f|0)?C:m;n=c[A>>2]|0;c[n+4>>2]=f;c[f>>2]=n;c[A>>2]=r;c[h>>2]=A;c[b>>2]=w;e=c[d>>2]|0;if(!((w|0)!=(m|0)&(C|0)!=(e|0)))break b;else f=C}c[b>>2]=c[B+4>>2]}while(0);c[a>>2]=y;i=g;return}}function gIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function hIc(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=a+140|0;a=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function iIc(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=i;i=i+128|0;k=j+120|0;l=j+64|0;m=j+8|0;n=j;o=a+4|0;p=c[o>>2]|0;if((c[a>>2]|0)==(p|0)){Krd(596848,0,3653512,32,1,0,0,0);i=j;return}q=ea(g[d>>2]);r=ea(g[p+-56>>2]);s=ea(q+r);t=ea(g[p+-24>>2]);u=ea(s+t);s=ea(t+ea(r+ea(q+ea(g[d+8>>2]))));q=ea(g[d+4>>2]);t=ea(g[p+-52>>2]);v=ea(q+t);w=ea(g[p+-20>>2]);x=ea(v+w);v=ea(w+ea(t+ea(q+ea(g[d+12>>2]))));if(u<r){q=ea(u-r);g[e>>2]=ea(q+ea(g[e>>2]));y=r}else y=u;if(x<t){u=ea(x-t);z=e+4|0;g[z>>2]=ea(u+ea(g[z>>2]));A=t}else A=x;x=ea(r+ea(g[p+-48>>2]));r=s>x?x:s;s=ea(t+ea(g[p+-44>>2]));t=v>s?s:v;v=ea((!(r<=y)?r:y)-y);r=ea((!(t<=A)?t:A)-A);do if(h){t=ea(g[e>>2]);s=ea(y+t);x=ea(s+ea(g[f>>2]));s=ea(g[e+4>>2]);u=ea(A+s);q=ea(u+ea(g[f+4>>2]));u=ea(x);x=ea(t+ea(g[p+-16>>2]));t=ea(s+ea(g[p+-12>>2]));s=ea(x);z=m+16|0;B=m+32|0;C=m+40|0;D=m+48|0;E=m+0|0;F=E+40|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(F|0));c[z+0>>2]=c[d+0>>2];c[z+4>>2]=c[d+4>>2];c[z+8>>2]=c[d+8>>2];c[z+12>>2]=c[d+12>>2];g[m>>2]=y;g[m+4>>2]=A;g[m+8>>2]=v;g[m+12>>2]=r;G=e;H=c[G+4>>2]|0;I=B;c[I>>2]=c[G>>2];c[I+4>>2]=H;x=ea(q);H=D;g[H>>2]=u;g[H+4>>2]=x;x=ea(t);H=C;g[H>>2]=s;g[H+4>>2]=x;if((p|0)==(c[a+8>>2]|0)){qIc(a,m);break}else{E=p+0|0;J=m+0|0;F=E+56|0;do{c[E>>2]=c[J>>2];E=E+4|0;J=J+4|0}while((E|0)<(F|0));c[o>>2]=(c[o>>2]|0)+56;break}}else{s=ea(g[p+-8>>2]);t=ea(s+ea(g[f>>2]));s=ea(g[p+-4>>2]);u=ea(s+ea(g[f+4>>2]));s=ea(t);t=ea(g[p+-16>>2]);q=ea(t+ea(g[e>>2]));t=ea(g[p+-12>>2]);x=ea(t+ea(g[e+4>>2]));t=ea(q);C=l+16|0;D=l+32|0;B=l+40|0;z=l+48|0;E=l+0|0;F=E+40|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(F|0));c[C+0>>2]=c[d+0>>2];c[C+4>>2]=c[d+4>>2];c[C+8>>2]=c[d+8>>2];c[C+12>>2]=c[d+12>>2];g[l>>2]=y;g[l+4>>2]=A;g[l+8>>2]=v;g[l+12>>2]=r;H=e;I=c[H+4>>2]|0;G=D;c[G>>2]=c[H>>2];c[G+4>>2]=I;q=ea(u);I=z;g[I>>2]=s;g[I+4>>2]=q;q=ea(x);I=B;g[I>>2]=t;g[I+4>>2]=q;if((p|0)==(c[a+8>>2]|0)){qIc(a,l);break}if(!p)K=0;else{E=p+0|0;J=l+0|0;F=E+56|0;do{c[E>>2]=c[J>>2];E=E+4|0;J=J+4|0}while((E|0)<(F|0));K=c[o>>2]|0}c[o>>2]=K+56}while(0);K=(c[o>>2]|0)+-56|0;g[n>>2]=ea(1.0);g[n+4>>2]=ea(1.0);c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];jIc(a,b,K,k);i=j;return}function jIc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=Im,C=0,D=0,E=Im,F=0,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,S=Im,T=Im;f=i;i=i+272|0;h=f+16|0;j=f+112|0;k=f+32|0;l=f+176|0;m=f+256|0;n=f;o=f+96|0;p=f+192|0;mIc(a,b);q=d+32|0;r=ea(-ea(g[q>>2]));s=d+36|0;t=ea(-ea(g[s>>2]));u=d+8|0;v=ea(g[u>>2]);w=d+12|0;x=ea(g[w>>2]);g[a+156>>2]=r;g[a+160>>2]=t;g[a+164>>2]=v;g[a+168>>2]=x;if((c[b>>2]|0)!=7){i=f;return}x=ea(g[d>>2]);v=ea(g[d+4>>2]);t=ea(g[u>>2]);r=ea(g[w>>2]);b=t<ea(0.0);y=r<ea(0.0);z=ea(x-ea(g[d+48>>2]));x=ea(v-ea(g[d+52>>2]));v=ea(z+ea(.5));if(!(v>=ea(0.0)))A=ea(v+ea(-.99999994));else A=v;v=ea(~~A|0);A=ea(x+ea(.5));if(!(A>=ea(0.0)))B=ea(A+ea(-.99999994));else B=A;A=ea(~~B|0);B=ea(~~ea(t+ea(.5))>>>0>>>0);t=b?ea(0.0):B;B=ea(~~ea(r+ea(.5))>>>0>>>0);r=y?ea(0.0):B;ZLc(k)|0;y=tBc()|0;if(!y){b=ECc()|0;d=mo[c[(c[b>>2]|0)+80>>2]&4095](b)|0;b=ECc()|0;C=mo[c[(c[b>>2]|0)+84>>2]&4095](b)|0;D=d}else{C=c[y+104>>2]|0;D=c[y+100>>2]|0}B=ea(C|0);x=ea(D|0);z=ea(t/x);t=ea(r/B);D=l+4|0;g[l+8>>2]=ea(1.0);r=ea(ea(g[e>>2])*z);g[l>>2]=r;z=ea(ea(g[e+4>>2])*t);g[D>>2]=z;e=a+12|0;t=ea(v*ea(g[e>>2]));C=a+28|0;E=ea(t+ea(A*ea(g[C>>2])));y=a+44|0;t=ea(E+ea(ea(g[y>>2])*ea(0.0)));d=a+60|0;E=ea(ea(g[d>>2])+t);b=a+16|0;t=ea(v*ea(g[b>>2]));F=a+32|0;G=ea(t+ea(A*ea(g[F>>2])));H=a+48|0;t=ea(G+ea(ea(g[H>>2])*ea(0.0)));I=a+64|0;G=ea(ea(g[I>>2])+t);J=a+24|0;t=ea(v*ea(g[J>>2]));K=a+40|0;v=ea(t+ea(A*ea(g[K>>2])));L=a+56|0;A=ea(v+ea(ea(g[L>>2])*ea(0.0)));M=a+72|0;v=ea(ea(g[M>>2])+A);if(v<ea(0.0))N=ea(-v);else N=v;if(N>ea(1.00000001e-07)){N=ea(ea(1.0)/v);O=ea(G*N);P=ea(E*N)}else{O=ea(0.0);P=ea(0.0)}N=ea(O*z);g[m>>2]=ea(P*r);g[m+4>>2]=N;g[m+8>>2]=ea(0.0);g[n>>2]=ea(0.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(1.0);vMc(k,m,n,l);g[o>>2]=ea(0.0);g[o+8>>2]=x;g[o+4>>2]=ea(0.0);g[o+12>>2]=B;q1b(o);B=ea(-ea(g[q>>2]));x=ea(-ea(g[s>>2]));N=ea(ea(g[e>>2])*B);r=ea(N+ea(ea(g[C>>2])*x));N=ea(r+ea(ea(g[y>>2])*ea(0.0)));r=ea(ea(g[d>>2])+N);N=ea(ea(g[b>>2])*B);P=ea(N+ea(ea(g[F>>2])*x));N=ea(P+ea(ea(g[H>>2])*ea(0.0)));P=ea(ea(g[I>>2])+N);N=ea(ea(g[J>>2])*B);B=ea(N+ea(ea(g[K>>2])*x));x=ea(B+ea(ea(g[L>>2])*ea(0.0)));B=ea(ea(g[M>>2])+x);if(B<ea(0.0))Q=ea(-B);else Q=B;if(Q>ea(1.00000001e-07)){Q=ea(ea(1.0)/B);S=ea(P*Q);T=ea(r*Q)}else{S=ea(0.0);T=ea(0.0)}Q=ea(T*ea(g[l>>2]));T=ea(S*ea(g[D>>2]));dMc(k,e,p);S=ea(Q+ea(R(ea(ea(g[u>>2])+ea(.5)))));r=ea(T+ea(R(ea(ea(g[w>>2])+ea(.5)))));P=ea(S-Q);S=ea(T-r);g[h>>2]=Q;g[h+8>>2]=P;g[h+4>>2]=r;g[h+12>>2]=S;j1b(h,j);cMc(j,p)|0;k1b(1,j);p=ync()|0;In[c[(c[p>>2]|0)+108>>2]&4095](p,j);In[c[(c[p>>2]|0)+104>>2]&4095](p,601008);VIc(a+156|0);i=f;return}function kIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;h=a+4|0;j=c[h>>2]|0;if(((j-(c[a>>2]|0)|0)/56|0)>>>0<2){Krd(596896,0,3653512,101,1,0,0,0);i=d;return}else{c[h>>2]=j+-56;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];jIc(a,b,j+-112|0,e);i=d;return}}function lIc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+80|0;f=e+72|0;h=e+64|0;j=e;k=a+12|0;l=k+0|0;m=d+0|0;n=l+64|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(n|0));if(!(qMc(d,j)|0)){Krd(596928,0,3653512,223,1,0,0,0);i=e;return}l=k+0|0;m=d+0|0;n=l+64|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(n|0));l=a+76|0;m=j+0|0;n=l+64|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(n|0));m=c[a+4>>2]|0;if((c[a>>2]|0)==(m|0)){i=e;return}g[h>>2]=ea(1.0);g[h+4>>2]=ea(1.0);c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];jIc(a,b,m+-56|0,f);i=e;return}function mIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,T=Im,U=Im,V=Im,W=Im;d=i;e=a+4|0;f=c[e>>2]|0;if((c[a>>2]|0)==(f|0)){i=d;return}h=a+140|0;j=ea(g[h>>2]);k=a+144|0;l=ea(g[k>>2]);m=a+76|0;n=ea(j*ea(g[m>>2]));o=a+92|0;p=ea(n+ea(l*ea(g[o>>2])));q=a+108|0;n=ea(p+ea(ea(g[q>>2])*ea(0.0)));r=a+124|0;p=ea(ea(g[r>>2])+n);s=a+80|0;n=ea(j*ea(g[s>>2]));t=a+96|0;u=ea(n+ea(l*ea(g[t>>2])));v=a+112|0;n=ea(u+ea(ea(g[v>>2])*ea(0.0)));w=a+128|0;u=ea(ea(g[w>>2])+n);x=a+88|0;n=ea(j*ea(g[x>>2]));y=a+104|0;j=ea(n+ea(l*ea(g[y>>2])));z=a+120|0;l=ea(j+ea(ea(g[z>>2])*ea(0.0)));A=a+136|0;j=ea(ea(g[A>>2])+l);if(j<ea(0.0))B=ea(-j);else B=j;if(B>ea(1.00000001e-07)){B=ea(ea(1.0)/j);C=ea(u*B);D=ea(p*B)}else{C=ea(0.0);D=ea(0.0)}B=ea(D-ea(g[f+-24>>2]));D=ea(C-ea(g[f+-20>>2]));C=ea(g[f+-56>>2]);p=ea(B-C);C=ea(D-ea(g[f+-52>>2]));D=ea(p);B=ea(C);f=b+4|0;g[f>>2]=D;g[f+4>>2]=B;B=ea(g[h>>2]);D=ea(g[k>>2]);u=ea(g[m>>2]);j=ea(B*u);l=ea(g[o>>2]);n=ea(j+ea(D*l));j=ea(ea(g[q>>2])*ea(0.0));E=ea(n+j);n=ea(g[r>>2]);F=ea(n+E);E=ea(g[s>>2]);G=ea(B*E);H=ea(g[t>>2]);I=ea(G+ea(D*H));G=ea(ea(g[v>>2])*ea(0.0));J=ea(I+G);I=ea(g[w>>2]);K=ea(I+J);J=ea(g[x>>2]);L=ea(B*J);B=ea(g[y>>2]);M=ea(L+ea(D*B));D=ea(ea(g[z>>2])*ea(0.0));L=ea(M+D);M=ea(g[A>>2]);N=ea(M+L);if(N<ea(0.0))O=ea(-N);else O=N;if(O>ea(1.00000001e-07)){O=ea(ea(1.0)/N);P=ea(K*O);Q=ea(F*O)}else{P=ea(0.0);Q=ea(0.0)}A=c[e>>2]|0;O=ea(g[A+-56>>2]);if((O<=Q?ea(O+ea(g[A+-48>>2]))>Q:0)?(Q=ea(g[A+-52>>2]),Q<=P):0)R=ea(Q+ea(g[A+-44>>2]))>P;else R=0;c[a+172>>2]=R<<31>>31;if((c[b>>2]|0)==6){i=d;return}R=b+12|0;if((c[a>>2]|0)==(A|0)){S=ea(0.0);T=ea(0.0)}else{P=ea(g[a+148>>2]);Q=ea(g[a+152>>2]);F=ea(n+ea(ea(ea(P*u)+ea(Q*l))+j));j=ea(I+ea(ea(ea(P*E)+ea(Q*H))+G));G=ea(M+ea(ea(ea(P*J)+ea(Q*B))+D));if(G<ea(0.0))U=ea(-G);else U=G;if(U>ea(1.00000001e-07)){U=ea(ea(1.0)/G);V=ea(j*U);W=ea(F*U)}else{V=ea(0.0);W=ea(0.0)}U=ea(W-ea(g[A+-24>>2]));W=ea(V-ea(g[A+-20>>2]));S=ea(U-O);T=ea(W-ea(g[A+-52>>2]))}W=ea(p-S);S=ea(C-T);T=ea(W);W=ea(S);A=R;g[A>>2]=T;g[A+4>>2]=W;i=d;return}function nIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+80|0;e=d+64|0;f=d+8|0;h=d;j=b+4|0;l=c[j>>2]|0;m=c[j+4>>2]|0;j=a+140|0;c[j>>2]=l;c[j+4>>2]=m;n=(c[k>>2]=l,ea(g[k>>2]));o=ea(n-ea(g[b+12>>2]));n=(c[k>>2]=m,ea(g[k>>2]));p=ea(n-ea(g[b+16>>2]));n=ea(o);o=ea(p);m=a+148|0;g[m>>2]=n;g[m+4>>2]=o;ZLc(a+12|0)|0;ZLc(a+76|0)|0;m=a+4|0;l=c[m>>2]|0;j=c[a>>2]|0;if((l|0)==(j|0))q=l;else{r=l+(~(((l+-56-j|0)>>>0)/56|0)*56|0)|0;c[m>>2]=r;q=r}r=f+32|0;j=f+40|0;l=f+0|0;s=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(s|0));g[f+16>>2]=ea(-1.0e4);g[f+20>>2]=ea(-1.0e4);g[f+24>>2]=ea(4.0e4);g[f+28>>2]=ea(4.0e4);g[f>>2]=ea(-1.0e4);g[f+4>>2]=ea(-1.0e4);g[f+8>>2]=ea(4.0e4);g[f+12>>2]=ea(4.0e4);t=r;c[t>>2]=1176256512;c[t+4>>2]=1176256512;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;if((q|0)==(c[a+8>>2]|0)){qIc(a,f);u=c[m>>2]|0;v=u+-56|0;w=h;x=w;c[x>>2]=1065353216;y=w+4|0;z=y;c[z>>2]=1065353216;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];jIc(a,b,v,e);i=d;return}if(!q)A=0;else{l=q+0|0;q=f+0|0;s=l+56|0;do{c[l>>2]=c[q>>2];l=l+4|0;q=q+4|0}while((l|0)<(s|0));A=c[m>>2]|0}q=A+56|0;c[m>>2]=q;u=q;v=u+-56|0;w=h;x=w;c[x>>2]=1065353216;y=w+4|0;z=y;c[z>>2]=1065353216;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];jIc(a,b,v,e);i=d;return}function oIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im;d=i;e=c[b>>2]|0;f=a+4|0;h=c[f>>2]|0;j=h-(c[a>>2]|0)|0;do if((j|0)!=56&(e|0)!=11&(e|0)!=12){if(((j|0)/56|0)>>>0>1){Krd(597048,0,3653512,410,1,0,0,0);k=c[f>>2]|0;break}Krd(597144,0,3653512,414,1,0,0,0);i=d;return}else k=h;while(0);c[f>>2]=k+-56;k=a+140|0;l=ea(g[k>>2]);m=ea(l-ea(g[a+148>>2]));l=ea(g[a+144>>2]);n=ea(l-ea(g[a+152>>2]));l=ea(m);m=ea(n);a=b+12|0;g[a>>2]=l;g[a+4>>2]=m;a=k;k=c[a+4>>2]|0;f=b+4|0;c[f>>2]=c[a>>2];c[f+4>>2]=k;i=d;return}function pIc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;f=c[a>>2]|0;if((e|0)==(f|0)){i=b;return}c[d>>2]=e+(~(((e+-56-f|0)>>>0)/56|0)*56|0);i=b;return}function qIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/56|0)+1|0;if(g>>>0>76695844)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/56|0;if(k>>>0<38347922){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/56|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=76695844;r=(l|0)/56|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*56|0)|0;o=r;p=s}s=n+(o*56|0)|0;r=n+(m*56|0)|0;if(s){m=s+0|0;s=b+0|0;b=m+56|0;do{c[m>>2]=c[s>>2];m=m+4|0;s=s+4|0}while((m|0)<(b|0))}s=n+((((p|0)/-56|0)+o|0)*56|0)|0;YEi(s|0,f|0,p|0)|0;c[a>>2]=s;c[e>>2]=n+((o+1|0)*56|0);c[h>>2]=r;if(!f){i=d;return}ACi(f);i=d;return}function rIc(){return c[149310]|0}function sIc(a){a=a|0;var b=0;b=i;rJc(a);i=b;return}function tIc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+36>>2]|0)<=-1){i=b;return}f=a+24|0;g=c[f>>2]|0;c[e>>2]=c[a+28>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function uIc(a){a=a|0;var b=0,d=0;b=i;d=c[a+68>>2]|0;if(d){xri(d);ACi(d)}d=c[a+72>>2]|0;if(d){wJc(d);ACi(d)}d=c[a+76>>2]|0;if(!d){i=b;return}wJc(d);ACi(d);i=b;return}function vIc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+68|0;e=c[d>>2]|0;if(e){xri(e);ACi(e)}c[d>>2]=0;d=a+72|0;e=c[d>>2]|0;if(e){wJc(e);ACi(e)}c[d>>2]=0;d=a+76|0;a=c[d>>2]|0;if(!a){c[d>>2]=0;i=b;return}wJc(a);ACi(a);c[d>>2]=0;i=b;return}function wIc(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=a+76|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;g[a+44>>2]=ea(1.0);g[a+48>>2]=ea(1.0);g[a+52>>2]=ea(1.0);g[a+56>>2]=ea(1.0);g[a+28>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+12>>2]=ea(1.0);g[a+16>>2]=ea(1.0);g[a+20>>2]=ea(1.0);g[a+24>>2]=ea(1.0);c[a+60>>2]=1;c[a+64>>2]=0;c[a+68>>2]=0;c[a+72>>2]=1;hIc(a+96|0);d=a+288|0;c[a+324>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[a+280>>2]=0;c[a+92>>2]=0;c[a+328>>2]=0;i=b;return}function xIc(a){a=a|0;return}function yIc(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+92>>2]=b;g[a+44>>2]=ea(1.0);g[a+48>>2]=ea(1.0);g[a+52>>2]=ea(1.0);g[a+56>>2]=ea(1.0);g[a+28>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+12>>2]=ea(1.0);g[a+16>>2]=ea(1.0);g[a+20>>2]=ea(1.0);g[a+24>>2]=ea(1.0);c[a+60>>2]=1;c[a+64>>2]=0;c[a+68>>2]=1;sJc(b);b=a+328|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function zIc(a){a=a|0;var b=0,d=0;b=i;vIc(a+12|0);c[a+92>>2]=0;d=a+328|0;c[d>>2]=(c[d>>2]|0)+-1;i=b;return}function AIc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;ubd(f);g=f+4|0;h=(Xbd()|0)+516|0;c[g+0>>2]=c[h+0>>2];a[g+4>>0]=a[h+4>>0]|0;xbd(f)|0;WQc(c[b+280>>2]|0,d);i=e;return}function BIc(a,b){a=a|0;b=b|0;c[a+280>>2]=b;return}function CIc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a>>2]=DIc(0,b,d)|0;i=e;return}function DIc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;f=c[d>>2]|0;g=c[d+4>>2]|0;d=(f|0)==(g|0);a:do if(d)h=0;else{j=f;while(1){k=c[j>>2]|0;j=j+4|0;if(a[k+20>>0]|0){h=k;break a}if((j|0)==(g|0)){h=0;break}}}while(0);j=(h|0)!=0;if(!e){b:do if(j){e=c[h+12>>2]|0;if((e|0)!=-1){l=e;i=b;return l|0}e=g-f>>2;if(d){m=e;n=e;o=0}else{k=0;while(1){if((c[f+(k<<2)>>2]|0)==(h|0)){m=e;n=k;o=k;break b}k=k+1|0;if(k>>>0>=e>>>0){m=e;n=e;o=0;break}}}}else{e=g-f>>2;m=e;n=e;o=0}while(0);d=n;while(1){d=((d|0)==0?m:d)+-1|0;n=c[(c[f+(d<<2)>>2]|0)+8>>2]|0;if((n|0)!=-1){l=n;p=24;break}if((d|0)==(o|0)){l=0;p=24;break}}if((p|0)==24){i=b;return l|0}}c:do if(j){o=c[h+16>>2]|0;if((o|0)!=-1){l=o;i=b;return l|0}o=g-f>>2;d=0;while(1){if(d>>>0>=o>>>0){q=o;r=-1;break c}m=d+1|0;if((c[f+(d<<2)>>2]|0)==(h|0)){s=m;break}else d=m}q=o;r=(s>>>0)%(o>>>0)|0}else{q=g-f>>2;r=0}while(0);g=r;while(1){s=c[(c[f+(g<<2)>>2]|0)+4>>2]|0;if((s|0)!=-1){l=s;p=24;break}g=((g+1|0)>>>0)%(q>>>0)|0;if((g|0)==(r|0)){l=0;p=24;break}}if((p|0)==24){i=b;return l|0}return 0}function EIc(a){a=a|0;c[a>>2]=0;c[a+16>>2]=-1;c[a+4>>2]=1;c[a+8>>2]=0;c[a+12>>2]=0;return}function FIc(a,b){a=a|0;b=b|0;var d=0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+12>>2];d=a+8|0;c[b+8>>2]=c[d>>2];c[b+72>>2]=c[a+4>>2];c[d>>2]=0;return}function GIc(a,b){a=a|0;b=b|0;var d=0;c[a>>2]=c[b>>2];d=b+4|0;c[a+12>>2]=c[d>>2];c[d>>2]=0;d=b+8|0;c[a+8>>2]=c[d>>2];c[a+4>>2]=c[b+72>>2];c[d>>2]=0;return}function HIc(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;if(!d){i=b;return}gJc(d);i=b;return}function IIc(){var b=0,d=0,e=0,f=0,g=0;b=i;d=xCi(332)|0;wIc(d);c[149310]=d;e=c[149312]|0;if(!e){f=xCi(12)|0;c[f>>2]=1;c[f+4>>2]=0;a[f+8>>0]=1;c[149312]=f;g=f}else g=e;c[d+276>>2]=g;g=xCi(44)|0;e=g+4|0;c[g+40>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d+280>>2]=g;UQc(g);i=b;return}function JIc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}JIc(a,c[b>>2]|0);JIc(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function KIc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;if(c[149318]|0){i=a;return}c[d>>2]=115;f=Avc(597280,16,16,1,d,0)|0;c[149318]=f;LDc(f,0);ODc(c[149318]|0,1);f=(c[158074]|0)+20|0;c[b>>2]=-1;itd(b,597296);c[e>>2]=c[b>>2];qud(f,e,c[149318]|0)|0;i=a;return}function LIc(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;d=c[149328]|0;if(d){e=d;i=a;return e|0}rri(b,609792,30);d=nUc(mUc()|0,48,b)|0;xri(b);c[149328]=bkd(d,61,0)|0;KIc();e=c[149328]|0;i=a;return e|0}function MIc(b){b=b|0;var d=0,e=0,f=0,h=0;d=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[b+28>>2]=ea(1.0);e=b+32|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+48>>2]=ea(1.0);e=b+52|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+68>>2]=ea(1.0);e=b+72|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+88>>2]=ea(1.0);e=b+92|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+108>>2]=ea(1.0);e=b+112|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+128>>2]=ea(1.0);e=b+132|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+148>>2]=ea(1.0);e=b+152|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+168>>2]=ea(1.0);e=b+245|0;f=b+172|0;h=f+72|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));a[e>>0]=1;a[b+244>>0]=0;e=b+288|0;f=b+248|0;h=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));a[e>>0]=1;a[b+289>>0]=0;i=d;return}function NIc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im;e=i;f=b+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[f>>2]=ea(1.0);h=b+32|0;j=b+48|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;g[j>>2]=ea(1.0);k=b+52|0;l=b+68|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[l>>2]=ea(1.0);m=b+72|0;n=b+88|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;g[n>>2]=ea(1.0);o=b+92|0;p=b+108|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;g[p>>2]=ea(1.0);q=b+112|0;r=b+128|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;g[r>>2]=ea(1.0);s=b+132|0;t=b+148|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;g[t>>2]=ea(1.0);u=b+152|0;v=b+168|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;g[v>>2]=ea(1.0);w=b+172|0;x=b+188|0;y=b+204|0;z=b+220|0;A=b+236|0;B=b+256|0;C=b+264|0;D=(b|0)==(d|0);E=w+0|0;F=E+68|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(F|0));c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;do if(!D){E=a[d>>0]|0;if(!(E&1)){G=(E&255)>>>1;H=d+1|0}else{G=c[d+4>>2]|0;H=c[d+8>>2]|0}if(G>>>0>10){eXb(b,10,G+-10|0,0,0,0,G,H);break}aFi(b+1|0,H|0,G|0)|0;a[b+G+1>>0]=0;if(!(a[b>>0]&1)){a[b>>0]=G<<1;break}else{c[b+4>>2]=G;break}}while(0);c[b+12>>2]=c[d+12>>2];I=ea(g[d+16>>2]);J=ea(g[d+20>>2]);K=ea(g[d+24>>2]);L=ea(g[d+28>>2]);g[b+16>>2]=I;g[b+20>>2]=J;g[b+24>>2]=K;g[f>>2]=L;c[h>>2]=c[d+32>>2];L=ea(g[d+36>>2]);K=ea(g[d+40>>2]);J=ea(g[d+44>>2]);I=ea(g[d+48>>2]);g[b+36>>2]=L;g[b+40>>2]=K;g[b+44>>2]=J;g[j>>2]=I;c[k>>2]=c[d+52>>2];I=ea(g[d+56>>2]);J=ea(g[d+60>>2]);K=ea(g[d+64>>2]);L=ea(g[d+68>>2]);g[b+56>>2]=I;g[b+60>>2]=J;g[b+64>>2]=K;g[l>>2]=L;c[m>>2]=c[d+72>>2];L=ea(g[d+76>>2]);K=ea(g[d+80>>2]);J=ea(g[d+84>>2]);I=ea(g[d+88>>2]);g[b+76>>2]=L;g[b+80>>2]=K;g[b+84>>2]=J;g[n>>2]=I;c[o>>2]=c[d+92>>2];I=ea(g[d+96>>2]);J=ea(g[d+100>>2]);K=ea(g[d+104>>2]);L=ea(g[d+108>>2]);g[b+96>>2]=I;g[b+100>>2]=J;g[b+104>>2]=K;g[p>>2]=L;c[q>>2]=c[d+112>>2];L=ea(g[d+116>>2]);K=ea(g[d+120>>2]);J=ea(g[d+124>>2]);I=ea(g[d+128>>2]);g[b+116>>2]=L;g[b+120>>2]=K;g[b+124>>2]=J;g[r>>2]=I;c[s>>2]=c[d+132>>2];I=ea(g[d+136>>2]);J=ea(g[d+140>>2]);K=ea(g[d+144>>2]);L=ea(g[d+148>>2]);g[b+136>>2]=I;g[b+140>>2]=J;g[b+144>>2]=K;g[t>>2]=L;c[u>>2]=c[d+152>>2];L=ea(g[d+156>>2]);K=ea(g[d+160>>2]);J=ea(g[d+164>>2]);I=ea(g[d+168>>2]);g[b+156>>2]=L;g[b+160>>2]=K;g[b+164>>2]=J;g[v>>2]=I;v=d+172|0;c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];v=d+188|0;c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];c[x+12>>2]=c[v+12>>2];v=d+204|0;c[y+0>>2]=c[v+0>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];c[y+12>>2]=c[v+12>>2];v=d+220|0;c[z+0>>2]=c[v+0>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];c[z+12>>2]=c[v+12>>2];c[A>>2]=c[d+236>>2];c[b+240>>2]=c[d+240>>2];a[b+245>>0]=a[d+245>>0]|0;a[b+244>>0]=a[d+244>>0]|0;c[b+248>>2]=c[d+248>>2];c[b+252>>2]=c[d+252>>2];A=d+256|0;v=c[A+4>>2]|0;z=B;c[z>>2]=c[A>>2];c[z+4>>2]=v;v=d+264|0;z=c[v+4>>2]|0;A=C;c[A>>2]=c[v>>2];c[A+4>>2]=z;g[b+272>>2]=ea(g[d+272>>2]);g[b+276>>2]=ea(g[d+276>>2]);c[b+280>>2]=c[d+280>>2];c[b+284>>2]=c[d+284>>2];a[b+288>>0]=a[d+288>>0]|0;a[b+289>>0]=a[d+289>>0]|0;i=e;return}function OIc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if(a){c[149314]=c[a+4>>2];i=b;return}rri(d,724424,9);a=nUc(mUc()|0,128,d)|0;if(!a)e=0;else e=c[a+4>>2]|0;c[149314]=e;xri(d);i=b;return}function PIc(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im;m=i;i=i+16|0;n=m;o=ea(g[e>>2]);p=ea(g[e+4>>2]);q=ea(g[b+272>>2]);if(q!=ea(0.0))r=q;else r=ea(g[e+8>>2]);q=ea(g[b+276>>2]);if(q!=ea(0.0))s=q;else s=ea(g[e+12>>2]);q=ea(R(ea(ea(o+r)+ea(.5))));r=ea(R(ea(ea(s+p)+ea(.5))));s=ea(R(ea(o+ea(.5))));g[n>>2]=s;o=ea(R(ea(p+ea(.5))));g[n+4>>2]=o;g[n+8>>2]=ea(q-s);g[n+12>>2]=ea(r-o);s=ea(g[d+256>>2]);if(r<s){i=m;return}if(o>ea(s+ea(g[d+264>>2]))){i=m;return}e=QIc(b,d,(a[(c[d+276>>2]|0)+8>>0]|0)!=0&h,j,k,l)|0;RIc(b,d,n,e);SIc(b,d,n,f,e);i=m;return}function QIc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;h=i;i=i+64|0;j=h+40|0;k=h+16|0;l=h;m=h+28|0;n=h+32|0;o=h+48|0;p=h+12|0;q=h+24|0;r=h+20|0;s=h+8|0;t=h+4|0;do if(f){if(d?(u=a+112|0,v=c[u>>2]|0,(v|0)!=0):0){c[p>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(j,v,p);w=c[j>>2]|0;x=c[v+28>>2]|0;if((w|0)==-1){y=x+(c[v+32>>2]<<3)|0;break}else{y=x+(w<<3)|0;break}}else y=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((y|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[y+4>>2]|0,(v|0)!=0):0)z=v;else A=59}else A=59;if((A|0)==59)z=hQb(c[u>>2]|0)|0;B=(z|0)!=0?u:0}else B=0;do if(g){v=a+152|0;w=c[v>>2]|0;if(w){c[o>>2]=w;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(j,w,o);x=c[j>>2]|0;C=c[w+28>>2]|0;if((x|0)==-1){D=C+(c[w+32>>2]<<3)|0;break}else{D=C+(x<<3)|0;break}}else D=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((D|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(c[D+4>>2]|0)!=0:0){E=v;break}}if(hQb(c[v>>2]|0)|0){E=v;break}}w=a+112|0;x=c[w>>2]|0;if(x){c[n>>2]=x;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(j,x,n);C=c[j>>2]|0;F=c[x+28>>2]|0;if((C|0)==-1){G=F+(c[x+32>>2]<<3)|0;break}else{G=F+(C<<3)|0;break}}else G=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((G|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[G+4>>2]|0,(x|0)!=0):0)H=x;else A=81}else A=81;if((A|0)==81)H=hQb(c[w>>2]|0)|0;E=(H|0)!=0?w:B}else E=B}else E=B;while(0);if(e&d?(u=a+132|0,x=c[u>>2]|0,(x|0)!=0):0){c[m>>2]=x;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(j,x,m);v=c[j>>2]|0;C=c[x+28>>2]|0;if((v|0)==-1){I=C+(c[x+32>>2]<<3)|0;break}else{I=C+(v<<3)|0;break}}else I=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((I|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[I+4>>2]|0,(x|0)!=0):0)J=x;else A=93}else A=93;if((A|0)==93)J=hQb(c[u>>2]|0)|0;K=(J|0)!=0?u:E}else K=E;x=b+60|0;v=(c[x>>2]|0)==0?a+12|0:K;if((v|0)!=0?(C=c[v>>2]|0,(C|0)!=0):0){c[l>>2]=C;C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(j,C,l);F=c[j>>2]|0;L=c[C+28>>2]|0;if((F|0)==-1){M=L+(c[C+32>>2]<<3)|0;break}else{M=L+(F<<3)|0;break}}else M=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((M|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[M+4>>2]|0,(C|0)!=0):0)N=C;else A=105}else A=105;if((A|0)==105)N=hQb(c[v>>2]|0)|0;if(!((N|0)==0|(c[x>>2]|0)==0)){O=v;A=108;break}}P=a+92|0;A=109}else{if(d?(C=a+32|0,u=c[C>>2]|0,(u|0)!=0):0){c[t>>2]=u;u=c[137784]|0;if(u){do if((c[u+36>>2]|0)!=(c[u+4>>2]|0)){fRb(j,u,t);F=c[j>>2]|0;L=c[u+28>>2]|0;if((F|0)==-1){Q=L+(c[u+32>>2]<<3)|0;break}else{Q=L+(F<<3)|0;break}}else Q=(c[u+28>>2]|0)+(c[u+32>>2]<<3)|0;while(0);u=c[137784]|0;if((Q|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[Q+4>>2]|0,(u|0)!=0):0)R=u;else A=12}else A=12;if((A|0)==12)R=hQb(c[C>>2]|0)|0;S=(R|0)!=0?C:0}else S=0;do if(g){u=a+72|0;v=c[u>>2]|0;if(v){c[s>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(j,v,s);x=c[j>>2]|0;F=c[v+28>>2]|0;if((x|0)==-1){T=F+(c[v+32>>2]<<3)|0;break}else{T=F+(x<<3)|0;break}}else T=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((T|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(c[T+4>>2]|0)!=0:0){U=u;break}}if(hQb(c[u>>2]|0)|0){U=u;break}}v=a+32|0;w=c[v>>2]|0;if(w){c[r>>2]=w;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(j,w,r);x=c[j>>2]|0;F=c[w+28>>2]|0;if((x|0)==-1){V=F+(c[w+32>>2]<<3)|0;break}else{V=F+(x<<3)|0;break}}else V=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((V|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[V+4>>2]|0,(w|0)!=0):0)W=w;else A=34}else A=34;if((A|0)==34)W=hQb(c[v>>2]|0)|0;U=(W|0)!=0?v:S}else U=S}else U=S;while(0);if(e&d?(C=a+52|0,w=c[C>>2]|0,(w|0)!=0):0){c[q>>2]=w;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(j,w,q);u=c[j>>2]|0;x=c[w+28>>2]|0;if((u|0)==-1){X=x+(c[w+32>>2]<<3)|0;break}else{X=x+(u<<3)|0;break}}else X=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((X|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[X+4>>2]|0,(w|0)!=0):0)Y=w;else A=46}else A=46;if((A|0)==46)Y=hQb(c[C>>2]|0)|0;Z=(Y|0)!=0?C:U}else Z=U;O=(c[b+60>>2]|0)==0?a+12|0:Z;A=108}while(0);if((A|0)==108?(O|0)!=0:0){P=O;A=109}if((A|0)==109?(A=c[P>>2]|0,(A|0)!=0):0){c[k>>2]=A;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(j,A,k);O=c[j>>2]|0;Z=c[A+28>>2]|0;if((O|0)==-1){_=Z+(c[A+32>>2]<<3)|0;break}else{_=Z+(O<<3)|0;break}}else _=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if((_|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0)?(c[_+4>>2]|0)!=0:0){$=P;i=h;return $|0}}if(hQb(c[P>>2]|0)|0){$=P;i=h;return $|0}}$=a+12|0;i=h;return $|0}function RIc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=0;h=i;i=i+96|0;j=h+32|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h;o=ea(g[d+252>>2]);p=ea(g[d+256>>2]);q=ea(g[d+260>>2]);r=ea(g[d+264>>2]);ZLc(j)|0;if(q>ea(0.0))s=ea(ea(.875)/q);else s=ea(x);g[j>>2]=s;if(r>ea(0.0))t=ea(ea(.875)/r);else t=ea(x);g[j+20>>2]=t;g[j+48>>2]=ea(ea(.0625)-ea(o*s));g[j+52>>2]=ea(ea(.0625)-ea(p*t));g[j+40>>2]=ea(0.0);g[j+60>>2]=ea(1.0);g[j+56>>2]=ea(1.0);u=(ync()|0)+3492|0;v=j+0|0;w=u+64|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));v=c[f>>2]|0;if(!v){i=h;return}c[l>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(j,v,l);u=c[j>>2]|0;w=c[v+28>>2]|0;if((u|0)==-1){y=w+(c[v+32>>2]<<3)|0;break}else{y=w+(u<<3)|0;break}}else y=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if(!((y|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(c[y+4>>2]|0)!=0:0))z=14}else z=14;if((z|0)==14?(hQb(c[f>>2]|0)|0)==0:0){i=h;return}t=ea(g[d+12>>2]);p=ea(t*ea(g[d+28>>2]));t=ea(g[d+16>>2]);s=ea(t*ea(g[d+32>>2]));t=ea(g[d+20>>2]);o=ea(t*ea(g[d+36>>2]));t=ea(g[d+24>>2]);r=ea(t*ea(g[d+40>>2]));if(!(c[d+60>>2]|0))A=ea(r*ea(.5));else A=r;r=ea(g[e>>2]);t=ea(r-ea(c[b+220>>2]|0));q=ea(g[e+4>>2]);B=ea(q-ea(c[b+228>>2]|0));C=ea(r+ea(g[e+8>>2]));r=ea(C+ea(c[b+224>>2]|0));C=ea(q+ea(g[e+12>>2]));q=ea(r-t);r=ea(ea(C+ea(c[b+232>>2]|0))-B);g[n>>2]=t;g[n+8>>2]=q;g[n+4>>2]=B;g[n+12>>2]=r;e=c[f>>2]|0;if(!e)D=0;else{c[k>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(j,e,k);d=c[j>>2]|0;y=c[e+28>>2]|0;if((d|0)==-1){E=y+(c[e+32>>2]<<3)|0;break}else{E=y+(d<<3)|0;break}}else E=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((E|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[E+4>>2]|0,(e|0)!=0):0)F=e;else z=26}else z=26;if((z|0)==26)F=hQb(c[f>>2]|0)|0;D=F}r=ea(c[b+172>>2]|0);B=ea(c[b+176>>2]|0);q=ea(c[b+180>>2]|0);F=~~ea(c[b+184>>2]|0);b=p<ea(0.0);t=b?ea(0.0):p;b=t>ea(1.0);f=~~ea(ea(t*ea(255.0))+ea(.5))>>>0&255;a[m>>0]=b?-1:f;f=s<ea(0.0);t=f?ea(0.0):s;f=t>ea(1.0);b=~~ea(ea(t*ea(255.0))+ea(.5))>>>0&255;a[m+1>>0]=f?-1:b;b=o<ea(0.0);t=b?ea(0.0):o;b=t>ea(1.0);f=~~ea(ea(t*ea(255.0))+ea(.5))>>>0&255;a[m+2>>0]=b?-1:f;f=A<ea(0.0);t=f?ea(0.0):A;f=t>ea(1.0);b=~~ea(ea(t*ea(255.0))+ea(.5))>>>0&255;a[m+3>>0]=f?-1:b;b=LIc()|0;c[j+0>>2]=c[m+0>>2];zYb(n,D,~~r,~~B,~~q,F,j,b);i=h;return}function SIc(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=Im,T=Im,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=Im,xa=Im,ya=Im,za=Im;j=i;i=i+208|0;l=j+128|0;m=j+40|0;n=j+96|0;o=j+88|0;p=j+72|0;q=j+56|0;r=j+192|0;s=j+120|0;t=j+24|0;u=j+8|0;v=j;w=j+16|0;y=j+104|0;z=ea(g[d+12>>2]);A=ea(z*ea(g[d+44>>2]));z=ea(g[d+16>>2]);B=ea(z*ea(g[d+48>>2]));z=ea(g[d+20>>2]);C=ea(z*ea(g[d+52>>2]));z=ea(g[d+24>>2]);D=ea(z*ea(g[d+56>>2]));z=ea(A*ea(g[h+4>>2]));E=ea(B*ea(g[h+8>>2]));F=ea(C*ea(g[h+12>>2]));G=ea(D*ea(g[h+16>>2]));if(!(c[d+60>>2]|0)){H=ea(D*ea(.5));I=ea(G*ea(.5))}else{H=D;I=G}h=b+252|0;if(((c[h>>2]|0)!=2?(c[f+4>>2]|0)!=0:0)?(J=z<ea(0.0),G=J?ea(0.0):z,J=G>ea(1.0),K=~~ea(ea(G*ea(255.0))+ea(.5))>>>0,L=E<ea(0.0),G=L?ea(0.0):E,L=G>ea(1.0),M=~~ea(ea(G*ea(255.0))+ea(.5))>>>0,N=F<ea(0.0),G=N?ea(0.0):F,N=G>ea(1.0),O=~~ea(ea(G*ea(255.0))+ea(.5))>>>0,P=I<ea(0.0),G=P?ea(0.0):I,P=G>ea(1.0),Q=~~ea(ea(G*ea(255.0))+ea(.5))>>>0,G=ea(g[e>>2]),D=ea(G+ea(c[b+204>>2]|0)),R=ea(g[e+4>>2]),S=ea(R+ea(c[b+212>>2]|0)),T=ea(G+ea(g[e+8>>2])),G=ea(T-ea(c[b+208>>2]|0)),T=ea(R+ea(g[e+12>>2])),R=ea(G-D),G=ea(ea(T-ea(c[b+216>>2]|0))-S),g[m>>2]=D,g[m+8>>2]=R,g[m+4>>2]=S,g[m+12>>2]=G,U=TIc(b)|0,V=c[b+240>>2]|0,W=(a[b+244>>0]|0)!=0,X=(a[b+245>>0]|0)!=0,c[n>>2]=(L?65280:M<<8&65280)|(J?255:K&255)|(N?16711680:O<<16&16711680)|(P?-16777216:Q<<24),Q=c[b+280>>2]|0,P=c[b+284>>2]|0,O=c[h>>2]|0,c[l+0>>2]=c[n+0>>2],N=uJc(m,f,U,V,W,X,l,Q,P,O)|0,(N|0)!=0):0){G=ea(g[N+16>>2]);S=ea(g[N+20>>2]);O=(g[k>>2]=G,c[k>>2]|0);Y=0;Z=O;_=(g[k>>2]=S,c[k>>2]|0);$=0;aa=N}else{Y=0;Z=0;_=0;$=0;aa=0}N=f+24|0;f=c[N>>2]|0;do if(f){c[o>>2]=f;O=c[137784]|0;if(O){do if((c[O+36>>2]|0)!=(c[O+4>>2]|0)){fRb(l,O,o);P=c[l>>2]|0;Q=c[O+28>>2]|0;if((P|0)==-1){ba=Q+(c[O+32>>2]<<3)|0;break}else{ba=Q+(P<<3)|0;break}}else ba=(c[O+28>>2]|0)+(c[O+32>>2]<<3)|0;while(0);O=c[137784]|0;if((ba|0)!=((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)?(O=c[ba+4>>2]|0,(O|0)!=0):0)ca=O;else da=16}else da=16;if((da|0)==16){O=hQb(c[N>>2]|0)|0;if(!O){fa=0;ga=0;ha=0;ia=0;ja=0;break}else ca=O}if((c[h>>2]|0)==3){fa=ca;ga=0;ha=0;ia=0;ja=0}else{S=ea(mo[c[(c[ca>>2]|0)+104>>2]&4095](ca)|0);G=ea(mo[c[(c[ca>>2]|0)+108>>2]&4095](ca)|0);O=(g[k>>2]=S,c[k>>2]|0);fa=ca;ga=0;ha=O;ia=(g[k>>2]=G,c[k>>2]|0);ja=0}}else{fa=0;ga=0;ha=0;ia=0;ja=0}while(0);ca=p+8|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;N=q+8|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;G=ea(g[e>>2]);S=ea(G+ea(c[b+204>>2]|0));R=ea(g[e+4>>2]);D=ea(R+ea(c[b+212>>2]|0));T=ea(G+ea(g[e+8>>2]));G=ea(T-ea(c[b+208>>2]|0));T=ea(R+ea(g[e+12>>2]));R=ea(G-S);G=ea(ea(T-ea(c[b+216>>2]|0))-D);g[t>>2]=S;g[t+8>>2]=R;g[t+4>>2]=D;g[t+12>>2]=G;e=u;c[e>>2]=ga|ha;c[e+4>>2]=ia|ja;ja=v;c[ja>>2]=Y|Z;c[ja+4>>2]=_|$;$=c[h>>2]|0;h=c[b+240>>2]|0;_=b+256|0;ja=_;Z=c[ja+4>>2]|0;Y=w;c[Y>>2]=c[ja>>2];c[Y+4>>2]=Z;c[n+0>>2]=c[u+0>>2];c[n+4>>2]=c[u+4>>2];c[m+0>>2]=c[v+0>>2];c[m+4>>2]=c[v+4>>2];c[l+0>>2]=c[w+0>>2];c[l+4>>2]=c[w+4>>2];XIc(t,n,m,p,q,r,s,$,h,l);T=ea(g[d+252>>2]);ka=ea(g[d+256>>2]);la=ea(g[d+260>>2]);ma=ea(g[d+264>>2]);if((c[b+248>>2]|0)!=0?(d=ea(g[r>>2])>R,d|ea(g[s>>2])>G):0){na=ea(g[_>>2]);oa=ea(S+ea(na+ea(g[b+264>>2])));na=ea(g[b+260>>2]);S=ea(D+ea(na+ea(g[b+268>>2])));na=ea(R+oa);R=ea(G+S);G=ea(T+la);D=ea(ka+ma);pa=oa<T?T:oa;oa=S<ka?ka:S;S=ea((na>G?G:na)-pa);_=S<ea(0.0);na=_?ea(0.0):S;S=ea((R>D?D:R)-oa);_=S<ea(0.0);R=_?ea(0.0):S;if(na==ea(0.0)|R==ea(0.0)){i=j;return}ZLc(l)|0;if(na>ea(0.0))qa=ea(ea(.875)/na);else qa=ea(x);g[l>>2]=qa;if(R>ea(0.0))ra=ea(ea(.875)/R);else ra=ea(x);g[l+20>>2]=ra;g[l+48>>2]=ea(ea(.0625)-ea(pa*qa));g[l+52>>2]=ea(ea(.0625)-ea(oa*ra));g[l+40>>2]=ea(0.0);g[l+60>>2]=ea(1.0);g[l+56>>2]=ea(1.0);sa=(ync()|0)+3492|0;ta=l+0|0;ua=sa+64|0;do{c[sa>>2]=c[ta>>2];sa=sa+4|0;ta=ta+4|0}while((sa|0)<(ua|0));va=1}else{ZLc(l)|0;if(la>ea(0.0))wa=ea(ea(.875)/la);else wa=ea(x);g[l>>2]=wa;if(ma>ea(0.0))xa=ea(ea(.875)/ma);else xa=ea(x);g[l+20>>2]=xa;g[l+48>>2]=ea(ea(.0625)-ea(T*wa));g[l+52>>2]=ea(ea(.0625)-ea(ka*xa));g[l+40>>2]=ea(0.0);g[l+60>>2]=ea(1.0);g[l+56>>2]=ea(1.0);sa=(ync()|0)+3492|0;ta=l+0|0;ua=sa+64|0;do{c[sa>>2]=c[ta>>2];sa=sa+4|0;ta=ta+4|0}while((sa|0)<(ua|0));va=0}if((aa|0)!=0?ea(g[N>>2])!=ea(0.0):0){g[y>>2]=z;g[y+4>>2]=E;g[y+8>>2]=F;g[y+12>>2]=I;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];WIc(b,q,aa,l)}if(ea(g[ca>>2])!=ea(0.0)){ca=A<ea(0.0);I=ca?ea(0.0):A;ca=I>ea(1.0);aa=~~ea(ea(I*ea(255.0))+ea(.5))>>>0&255;a[m>>0]=ca?-1:aa;aa=B<ea(0.0);I=aa?ea(0.0):B;aa=I>ea(1.0);ca=~~ea(ea(I*ea(255.0))+ea(.5))>>>0&255;a[m+1>>0]=aa?-1:ca;ca=C<ea(0.0);I=ca?ea(0.0):C;ca=I>ea(1.0);aa=~~ea(ea(I*ea(255.0))+ea(.5))>>>0&255;a[m+2>>0]=ca?-1:aa;aa=H<ea(0.0);I=aa?ea(0.0):H;aa=I>ea(1.0);ca=~~ea(ea(I*ea(255.0))+ea(.5))>>>0&255;a[m+3>>0]=aa?-1:ca;ca=LIc()|0;c[l+0>>2]=c[m+0>>2];zYb(p,fa,0,0,0,0,l,ca)}if(!va){i=j;return}ZLc(l)|0;if(la>ea(0.0))ya=ea(ea(.875)/la);else ya=ea(x);g[l>>2]=ya;if(ma>ea(0.0))za=ea(ea(.875)/ma);else za=ea(x);g[l+20>>2]=za;g[l+48>>2]=ea(ea(.0625)-ea(T*ya));g[l+52>>2]=ea(ea(.0625)-ea(ka*za));g[l+40>>2]=ea(0.0);g[l+60>>2]=ea(1.0);g[l+56>>2]=ea(1.0);sa=(ync()|0)+3492|0;ta=l+0|0;ua=sa+64|0;do{c[sa>>2]=c[ta>>2];sa=sa+4|0;ta=ta+4|0}while((sa|0)<(ua|0));i=j;return}function TIc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+236|0;a=c[g>>2]|0;if(a){c[f>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,f);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0){l=a;i=b;return l|0}}a=hQb(c[g>>2]|0)|0;if(a){l=a;i=b;return l|0}}a=c[149314]|0;if(a){c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);g=c[d>>2]|0;k=c[a+28>>2]|0;if((g|0)==-1){m=k+(c[a+32>>2]<<3)|0;break}else{m=k+(g<<3)|0;break}}else m=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((m|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[m+4>>2]|0,(a|0)!=0):0){l=a;i=b;return l|0}}a=hQb(c[149314]|0)|0;if(a){l=a;i=b;return l|0}}l=UIc()|0;i=b;return l|0}function UIc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+32|0;b=a+16|0;d=a+12|0;e=a;f=c[149316]|0;if(f){c[d>>2]=f;f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(b,f,d);g=c[b>>2]|0;h=c[f+28>>2]|0;if((g|0)==-1){j=h+(c[f+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if((j|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(f=c[j+4>>2]|0,(f|0)!=0):0){k=f;i=a;return k|0}}f=hQb(c[149316]|0)|0;if(f){k=f;i=a;return k|0}}rri(e,724424,9);f=nUc(mUc()|0,128,e)|0;if(!f){c[149316]=0;xri(e);Krd(597320,0,3653512,364,4,0,0,0);k=0;i=a;return k|0}else{c[149316]=c[f+4>>2];xri(e);k=f;i=a;return k|0}return 0}function VIc(a){a=a|0;var b=0,d=0,e=Im,f=Im,h=Im,j=0;b=i;i=i+64|0;d=b;ZLc(d)|0;e=ea(g[a+8>>2]);if(e>ea(0.0))f=ea(ea(.875)/e);else f=ea(x);g[d>>2]=f;e=ea(g[a+12>>2]);if(e>ea(0.0))h=ea(ea(.875)/e);else h=ea(x);g[d+20>>2]=h;g[d+48>>2]=ea(ea(.0625)-ea(ea(g[a>>2])*f));g[d+52>>2]=ea(ea(.0625)-ea(ea(g[a+4>>2])*h));g[d+40>>2]=ea(0.0);g[d+60>>2]=ea(1.0);g[d+56>>2]=ea(1.0);a=(ync()|0)+3492|0;j=d+0|0;d=a+64|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(d|0));i=b;return}function WIc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+224|0;j=h+72|0;k=h+148|0;l=h+152|0;m=h+160|0;n=h+8|0;o=h;p=h+136|0;q=c[149356]|0;if(!q){rri(j,609824,34);r=nUc(mUc()|0,48,j)|0;xri(j);c[149356]=bkd(r,61,0)|0;KIc();s=c[149356]|0}else s=q;g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(1.0);g[f+12>>2]=ea(1.0);if(!(a[597376]|0)){c[j>>2]=-1;itd(j,719656);c[149342]=c[j>>2];a[597376]=1}if(!(a[597392]|0)){c[j>>2]=-1;itd(j,791824);c[149346]=c[j>>2];a[597392]=1}q=s+32|0;r=c[q>>2]|0;if(!r){Qjd(s);t=c[q>>2]|0}else t=r;a[s+36>>0]=1;oud(t,597368,f);f=TIc(b)|0;if(f){$Ic(l,f);f=c[l>>2]|0;if(!f)u=0;else{c[k>>2]=f;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(j,l,k);b=c[j>>2]|0;r=c[l+28>>2]|0;if((b|0)==-1){v=r+(c[l+32>>2]<<3)|0;break}else{v=r+(b<<3)|0;break}}else v=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((v|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[v+4>>2]|0,(l|0)!=0):0)w=l;else x=19}else x=19;if((x|0)==19)w=hQb(f)|0;u=w}qud(t,597384,u)|0}u=ync()|0;t=j+0|0;w=(mo[c[(c[u>>2]|0)+120>>2]&4095](u)|0)+0|0;f=t+64|0;do{c[t>>2]=c[w>>2];t=t+4|0;w=w+4|0}while((t|0)<(f|0));t=m+0|0;w=(mo[c[(c[u>>2]|0)+116>>2]&4095](u)|0)+0|0;f=t+64|0;do{c[t>>2]=c[w>>2];t=t+4|0;w=w+4|0}while((t|0)<(f|0));aJc(o,e,d);y=ea(g[o>>2]);z=ea(g[o+4>>2]);g[p>>2]=y;g[p+4>>2]=z;g[p+8>>2]=ea(0.0);kMc(n,p)|0;In[c[(c[u>>2]|0)+104>>2]&4095](u,n);n=kkd(s)|0;p=c[158074]|0;if((n|0)<=0){A=c[u>>2]|0;B=A+104|0;C=c[B>>2]|0;In[C&4095](u,j);D=c[u>>2]|0;E=D+100|0;F=c[E>>2]|0;In[F&4095](u,m);i=h;return}o=0;do{d=dkd(s,o,p,0,1)|0;Yuc(d,c[e>>2]|0,13);o=o+1|0}while((o|0)!=(n|0));A=c[u>>2]|0;B=A+104|0;C=c[B>>2]|0;In[C&4095](u,j);D=c[u>>2]|0;E=D+100|0;F=c[E>>2]|0;In[F&4095](u,m);i=h;return}function XIc(a,b,c,d,e,f,h,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=0,C=Im,D=Im,E=Im;m=i;g[f>>2]=ea(0.0);g[h>>2]=ea(0.0);if((j|0)==3){g[f>>2]=ea(g[c>>2]);n=ea(g[c+4>>2]);g[h>>2]=n;o=n}else if(!j){n=ea(g[b>>2]);do if(n>ea(0.0)){if(!(ea(0.0)==ea(0.0)|ea(0.0)==ea(0.0))){g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);p=ea(0.0);q=ea(0.0);break}r=ea(g[a+8>>2]);s=ea(ea(r-ea(g[c>>2]))/n);r=ea(g[a+12>>2]);t=b+4|0;u=ea(g[t>>2]);v=ea(r/u);r=v<s?v:s;if(r<ea(0.0))w=ea(0.0);else{x=r>ea(1.0);w=x?ea(1.0):r}r=ea(R(ea(ea(w*n)+ea(.5))));g[b>>2]=r;s=ea(R(ea(ea(w*u)+ea(.5))));g[t>>2]=s;p=r;q=s}else{p=n;q=ea(g[b+4>>2])}while(0);g[f>>2]=ea(p+ea(g[c>>2]));p=ea(g[c+4>>2]);n=q<p?p:q;g[h>>2]=n;o=n}else if((j|0)==1){n=ea(g[b>>2]);do if(n>ea(0.0)){if(!(ea(0.0)==ea(0.0)|ea(0.0)==ea(0.0))){g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);y=ea(0.0);z=ea(0.0);break}q=ea(g[a+12>>2]);p=ea(q-ea(g[c+4>>2]));t=b+4|0;q=ea(g[t>>2]);w=ea(p/q);p=ea(ea(g[a+8>>2])/n);s=p<w?p:w;if(s<ea(0.0))A=ea(0.0);else{x=s>ea(1.0);A=x?ea(1.0):s}s=ea(R(ea(ea(A*n)+ea(.5))));g[b>>2]=s;w=ea(R(ea(ea(A*q)+ea(.5))));g[t>>2]=w;y=s;z=w}else{y=n;z=ea(g[b+4>>2])}while(0);n=ea(g[c>>2]);g[f>>2]=y<n?n:y;y=ea(z+ea(g[c+4>>2]));g[h>>2]=y;o=y}else if((j|0)==2){y=ea(g[b>>2]);do if(y>ea(0.0))if(ea(0.0)==ea(0.0)|ea(0.0)==ea(0.0)){z=ea(ea(g[a+8>>2])/y);n=ea(g[a+12>>2]);t=b+4|0;A=ea(g[t>>2]);w=ea(n/A);n=w<z?w:z;x=n>ea(1.0);z=x?ea(1.0):n;n=ea(R(ea(ea(y*z)+ea(.5))));g[b>>2]=n;g[t>>2]=ea(R(ea(ea(A*z)+ea(.5))));B=t;C=n;break}else{g[b>>2]=ea(0.0);t=b+4|0;g[t>>2]=ea(0.0);B=t;C=ea(0.0);break}else{B=b+4|0;C=y}while(0);g[f>>2]=C;C=ea(g[B>>2]);g[h>>2]=C;o=C}else o=ea(0.0);switch(k|0){case 8:{D=ea(1.0);E=ea(1.0);break}case 4:{D=ea(.5);E=ea(.5);break}case 1:{D=ea(.5);E=ea(0.0);break}case 2:{D=ea(1.0);E=ea(0.0);break}case 5:{D=ea(1.0);E=ea(.5);break}case 7:{D=ea(.5);E=ea(1.0);break}case 6:{D=ea(0.0);E=ea(1.0);break}case 3:{D=ea(0.0);E=ea(.5);break}default:{D=ea(0.0);E=ea(0.0)}}C=ea(g[a>>2]);y=ea(g[a+8>>2]);n=ea(g[f>>2]);z=ea(C+ea(D*ea(y-n)));y=ea(R(ea(ea(ea(g[l>>2])+z)+ea(.5))));z=ea(g[a+4>>2]);D=ea(z+ea(E*ea(ea(g[a+12>>2])-o)));E=ea(R(ea(ea(ea(g[l+4>>2])+D)+ea(.5))));if(!j){D=ea(g[b>>2]);l=D>ea(0.0);if(l){z=ea(g[b+4>>2]);C=ea(E+ea(ea(o-z)*ea(.5)));g[d>>2]=y;g[d+4>>2]=C;g[d+8>>2]=D;g[d+12>>2]=z}z=ea(g[c>>2]);if(!(z>ea(0.0))){i=m;return}if(l){C=ea(ea(y+D)+ea(1.0));D=ea(g[h>>2]);o=ea(g[c+4>>2]);A=ea(E+ea(ea(D-o)*ea(.5)));g[e>>2]=C;g[e+4>>2]=A;g[e+8>>2]=z;g[e+12>>2]=o;i=m;return}else{o=ea(g[h>>2]);A=ea(g[c+4>>2]);C=ea(E+ea(ea(o-A)*ea(.5)));g[e>>2]=y;g[e+4>>2]=C;g[e+8>>2]=z;g[e+12>>2]=A;i=m;return}}else if((j|0)==1){A=ea(g[b>>2]);if(A>ea(0.0)){z=ea(R(ea(ea(y+ea(ea(n-A)*ea(.5)))+ea(.5))));C=ea(g[b+4>>2]);g[d>>2]=z;g[d+4>>2]=E;g[d+8>>2]=A;g[d+12>>2]=C}C=ea(g[c>>2]);if(!(C>ea(0.0))){i=m;return}A=ea(R(ea(ea(y+ea(ea(ea(g[f>>2])-C)*ea(.5)))+ea(.5))));z=ea(E+ea(g[b+4>>2]));o=ea(g[c+4>>2]);g[e>>2]=A;g[e+4>>2]=z;g[e+8>>2]=C;g[e+12>>2]=o;i=m;return}else if((j|0)==2){o=ea(g[b>>2]);if(!(o>ea(0.0))){i=m;return}C=ea(R(ea(ea(y+ea(ea(n-o)*ea(.5)))+ea(.5))));n=ea(g[b+4>>2]);g[d>>2]=C;g[d+4>>2]=E;g[d+8>>2]=o;g[d+12>>2]=n;i=m;return}else if((j|0)==3){n=ea(g[c>>2]);if(!(n>ea(0.0))){i=m;return}o=ea(g[c+4>>2]);g[e>>2]=y;g[e+4>>2]=E;g[e+8>>2]=n;g[e+12>>2]=o;i=m;return}else{i=m;return}}function YIc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+12|0;h=d;do if(a[597416]|0){j=c[149350]|0;if(j){c[f>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(e,j,f);k=c[e>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(c[m+4>>2]|0)!=0:0)break}if(!(hQb(c[149350]|0)|0))n=13}else n=13}else{c[149350]=0;c[149351]=0;c[149352]=0;a[597416]=1;n=13}while(0);if((n|0)==13){m=mUc()|0;rri(h,610536,25);f=nUc(m,114,h)|0;xri(h);if(!f)o=0;else o=c[f+4>>2]|0;c[149350]=o}o=597400+(b<<2)|0;b=c[o>>2]|0;if(!b){p=0;i=d;return p|0}c[g>>2]=b;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,g);f=c[e>>2]|0;h=c[b+28>>2]|0;if((f|0)==-1){q=h+(c[b+32>>2]<<3)|0;break}else{q=h+(f<<3)|0;break}}else q=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((q|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[q+4>>2]|0,(b|0)!=0):0)r=b;else n=25}else n=25;if((n|0)==25)r=hQb(c[o>>2]|0)|0;p=r;i=d;return p|0}function ZIc(a){a=a|0;var b=0;a=i;b=YIc(0)|0;i=a;return b|0}function _Ic(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[c>>0]=(((d|0)==0|(e|0)==0|(f+-1|0)==(d|0)|(g+-1|0)==(e|0))^1)<<31>>31;return}function $Ic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;k=b+40|0;l=c[k>>2]|0;do if(l){c[h>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(e,m,h);n=c[e>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if(!((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(c[p+4>>2]|0)!=0:0))q=10}else q=10;if((q|0)==10?(hQb(c[k>>2]|0)|0)==0:0)break;c[a>>2]=c[k>>2];i=d;return}while(0);k=b+36|0;b=c[k>>2]|0;do if(b){c[g>>2]=b;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,g);h=c[e>>2]|0;l=c[p+28>>2]|0;if((h|0)==-1){r=l+(c[p+32>>2]<<3)|0;break}else{r=l+(h<<3)|0;break}}else r=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((r|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(c[r+4>>2]|0)!=0:0)s=p;else q=21}else q=21;if((q|0)==21){if(!(hQb(c[k>>2]|0)|0))break;s=c[137784]|0}c[f>>2]=c[k>>2];if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,f);p=c[e>>2]|0;h=c[s+28>>2]|0;if((p|0)==-1){t=h+(c[s+32>>2]<<3)|0;break}else{t=h+(p<<3)|0;break}}else t=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);p=c[137784]|0;if((t|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[t+4>>2]|0,(p|0)!=0):0)u=p;else q=31}else q=31;if((q|0)==31)u=hQb(c[k>>2]|0)|0;c[e>>2]=-1;itd(e,791824);c[j>>2]=c[e>>2];c[e+0>>2]=c[j+0>>2];p=skd(u,e)|0;if(!p)v=0;else v=c[p+4>>2]|0;c[a>>2]=v;i=d;return}while(0);c[a>>2]=0;i=d;return}function aJc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;f=i;g[b>>2]=ea(0.0);h=b+4|0;g[h>>2]=ea(0.0);do switch(c[d+24>>2]|0){case 6:{j=ea(g[e>>2]);k=(a[d+28>>0]|0)==0;if(k)l=j;else l=ea(R(ea(j+ea(.5))));g[b>>2]=l;j=ea(ea(ea(g[e+4>>2])+ea(g[e+12>>2]))-ea(g[d+20>>2]));if(k)m=j;else m=ea(R(ea(j+ea(.5))));g[h>>2]=m;i=f;return}case 0:{j=ea(g[e>>2]);if(!(a[d+28>>0]|0)){g[b>>2]=j;n=ea(g[e+4>>2])}else{g[b>>2]=ea(R(ea(j+ea(.5))));n=ea(R(ea(ea(g[e+4>>2])+ea(.5))))}g[h>>2]=n;i=f;return}case 4:{j=ea(ea(g[e>>2])+ea(ea(g[e+8>>2])*ea(.5)));k=(a[d+28>>0]|0)==0;if(k)o=j;else o=ea(R(ea(j+ea(.5))));g[b>>2]=o;j=ea(g[e+4>>2]);p=ea(ea(ea(j+ea(j+ea(g[e+12>>2])))-ea(g[d+20>>2]))*ea(.5));if(k)q=p;else q=ea(R(ea(p+ea(.5))));g[h>>2]=q;i=f;return}case 2:{p=ea(ea(g[e>>2])+ea(g[e+8>>2]));if(!(a[d+28>>0]|0)){g[b>>2]=p;r=ea(g[e+4>>2])}else{g[b>>2]=ea(R(ea(p+ea(.5))));r=ea(R(ea(ea(g[e+4>>2])+ea(.5))))}g[h>>2]=r;i=f;return}case 3:{p=ea(g[e>>2]);k=(a[d+28>>0]|0)==0;if(k)s=p;else s=ea(R(ea(p+ea(.5))));g[b>>2]=s;p=ea(g[e+4>>2]);j=ea(ea(ea(p+ea(p+ea(g[e+12>>2])))-ea(g[d+20>>2]))*ea(.5));if(k)t=j;else t=ea(R(ea(j+ea(.5))));g[h>>2]=t;i=f;return}case 5:{j=ea(ea(g[e>>2])+ea(g[e+8>>2]));k=(a[d+28>>0]|0)==0;if(k)u=j;else u=ea(R(ea(j+ea(.5))));g[b>>2]=u;j=ea(g[e+4>>2]);p=ea(ea(ea(j+ea(j+ea(g[e+12>>2])))-ea(g[d+20>>2]))*ea(.5));if(k)v=p;else v=ea(R(ea(p+ea(.5))));g[h>>2]=v;i=f;return}case 1:{p=ea(ea(g[e>>2])+ea(ea(g[e+8>>2])*ea(.5)));if(!(a[d+28>>0]|0)){g[b>>2]=p;w=ea(g[e+4>>2])}else{g[b>>2]=ea(R(ea(p+ea(.5))));w=ea(R(ea(ea(g[e+4>>2])+ea(.5))))}g[h>>2]=w;i=f;return}case 7:{p=ea(g[e>>2]);j=ea(ea(p+ea(p+ea(g[e+8>>2])))*ea(.5));k=(a[d+28>>0]|0)==0;if(k)x=j;else x=ea(R(ea(j+ea(.5))));g[b>>2]=x;j=ea(ea(ea(g[e+4>>2])+ea(g[e+12>>2]))-ea(g[d+20>>2]));if(k)y=j;else y=ea(R(ea(j+ea(.5))));g[h>>2]=y;i=f;return}case 8:{j=ea(ea(g[e>>2])+ea(g[e+8>>2]));k=(a[d+28>>0]|0)==0;if(k)z=j;else z=ea(R(ea(j+ea(.5))));g[b>>2]=z;j=ea(ea(ea(g[e+4>>2])+ea(g[e+12>>2]))-ea(g[d+20>>2]));if(k)A=j;else A=ea(R(ea(j+ea(.5))));g[h>>2]=A;i=f;return}default:{g[h>>2]=ea(0.0);g[b>>2]=ea(0.0);i=f;return}}while(0)}function bJc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+100|0;e=c[d>>2]|0;if(e){Csc(e);c[d>>2]=0}d=a+104|0;e=c[d>>2]|0;if(e){Csc(e);c[d>>2]=0}d=a+108|0;e=c[d>>2]|0;if(e){Csc(e);c[d>>2]=0}wJc(a+80|0);wJc(a+68|0);tIc(a+4|0);i=b;return}function cJc(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+432|0;h=f+216|0;j=f+208|0;k=f+8|0;l=f;m=f+428|0;n=f+416|0;o=e+280|0;p=c[o>>2]|0;q=ea(g[b+112>>2]);r=ea(g[b+116>>2]);s=ea(g[b+120>>2]);t=ea(g[b+124>>2]);g[e+12>>2]=q;g[e+16>>2]=r;g[e+20>>2]=s;g[e+24>>2]=t;t=ea(g[b+128>>2]);s=ea(g[b+132>>2]);r=ea(g[b+136>>2]);q=ea(g[b+140>>2]);g[e+28>>2]=t;g[e+32>>2]=s;g[e+36>>2]=r;g[e+40>>2]=q;q=ea(g[b+144>>2]);r=ea(g[b+148>>2]);s=ea(g[b+152>>2]);t=ea(g[b+156>>2]);g[e+44>>2]=q;g[e+48>>2]=r;g[e+52>>2]=s;g[e+56>>2]=t;c[e+60>>2]=d[b+224>>0];u=e+96|0;lIc(u,p,b+160|0);v=e+8|0;w=c[v>>2]|0;c[w+20>>2]=b;if(((((c[p>>2]|0)==7?(t=ea(g[p+4>>2]),s=ea(g[p+8>>2]),r=ea(g[b+48>>2]),r<=t):0)?ea(r+ea(g[b+56>>2]))>t:0)?(t=ea(g[b+52>>2]),t<=s):0)?ea(t+ea(g[b+60>>2]))>s:0)c[e+272>>2]=1;x=e+72|0;y=c[x>>2]|0;z=w+12|0;c[x>>2]=(c[z>>2]|0)==(c[b>>2]|0)&y;w=Dsc(c[b+108>>2]|0)|0;if((w|0)!=0?(c[p>>2]|0)==7:0){A=c[w+8>>2]|0;B=b+48|0;C=b+68|0;s=ea(g[p+4>>2]);t=ea(g[p+8>>2]);r=ea(g[B>>2]);if((r<=s?ea(r+ea(g[b+56>>2]))>s:0)?(s=ea(g[b+52>>2]),s<=t):0)D=ea(s+ea(g[b+60>>2]))>t;else D=0;PIc(A,e,B,C,D,0,(c[(c[v>>2]|0)+12>>2]|0)==(c[b>>2]|0),0)}D=c[o>>2]|0;o=601088;C=c[o+4>>2]|0;B=j;c[B>>2]=c[o>>2];c[B+4>>2]=C;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];iIc(u,D,b+48|0,h,601088,0);D=e+92|0;j=c[D>>2]|0;yIc(e,b+4|0);C=(Xbd()|0)+452|0;B=c[C+4>>2]|0;o=l;c[o>>2]=c[C>>2];c[o+4>>2]=B;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];jbd(k,h);l=k+32|0;cbd(l,Dsc(c[b+100>>2]|0)|0);$ad(l,c[b>>2]|0);cbd(l,Dsc(c[b+104>>2]|0)|0);$ad(l,d[b+98>>0]|0);abd(l,ea(g[b+56>>2]));abd(l,ea(g[b+60>>2]));cbd(l,w);c[x>>2]=(c[z>>2]|0)==(c[b>>2]|0)&1;c[m>>2]=0;a[k+25>>0]=0;qbd(k,m)|0;if(!(c[m>>2]|0)){zIc(e);c[D>>2]=j;kIc(u,p);E=c[v>>2]|0;F=E+20|0;c[F>>2]=0;c[x>>2]=y;i=f;return}kbd(h,3516336,3516216,2378232,2377968);cbd(h+32|0,c[m>>2]|0);if(pbd(h)|0){zIc(e);c[D>>2]=j;kIc(u,p);E=c[v>>2]|0;F=E+20|0;c[F>>2]=0;c[x>>2]=y;i=f;return}h=c[m>>2]|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Rcd(h,0,n);xri(n);zIc(e);c[D>>2]=j;kIc(u,p);E=c[v>>2]|0;F=E+20|0;c[F>>2]=0;c[x>>2]=y;i=f;return}function dJc(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;h=i;i=i+128|0;j=h+116|0;k=h;l=c[b+8>>2]|0;m=b+280|0;n=c[m>>2]|0;if(!l){i=h;return}o=k+0|0;p=b+108|0;q=o+64|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));p=b+12|0;r=ea(g[p>>2]);o=b+16|0;s=ea(g[o>>2]);q=b+20|0;t=ea(g[q>>2]);u=b+24|0;v=ea(g[u>>2]);w=k+64|0;g[w>>2]=r;x=k+68|0;g[x>>2]=s;y=k+72|0;g[y>>2]=t;z=k+76|0;g[z>>2]=v;A=b+44|0;v=ea(g[A>>2]);B=b+48|0;t=ea(g[B>>2]);C=b+52|0;s=ea(g[C>>2]);D=b+56|0;r=ea(g[D>>2]);E=k+80|0;g[E>>2]=v;F=k+84|0;g[F>>2]=t;G=k+88|0;g[G>>2]=s;H=k+92|0;g[H>>2]=r;I=b+28|0;r=ea(g[I>>2]);J=b+32|0;s=ea(g[J>>2]);K=b+36|0;t=ea(g[K>>2]);L=b+40|0;v=ea(g[L>>2]);M=k+96|0;g[M>>2]=r;N=k+100|0;g[N>>2]=s;O=k+104|0;g[O>>2]=t;P=k+108|0;g[P>>2]=v;Q=b+60|0;R=k+112|0;a[R>>0]=(c[Q>>2]|0)!=0&1;if(e)nIc(b+96|0,n);if((a[l+16>>0]|0)!=0?(S=c[l>>2]|0,T=l+4|0,U=c[T>>2]|0,c[j>>2]=2628,nJc(S,U,j),U=c[T>>2]|0,T=c[l>>2]|0,(U|0)!=(T|0)):0){S=U-T>>2;U=0;do{c[(c[T+(U<<2)>>2]|0)+64>>2]=U;U=U+1|0}while(U>>>0<S>>>0)}a:do switch(c[n>>2]|0){case 2:case 3:case 1:{if(!f?(S=c[l+24>>2]|0,(S|0)!=0):0){V=S;W=47;break a}if(!(c[(c[b+276>>2]|0)+4>>2]|0)){X=eJc(l,b)|0;W=46;break a}S=c[l+12>>2]|0;U=c[l>>2]|0;T=c[l+4>>2]|0;if((U|0)!=(T|0)){Y=U;do{U=c[Y>>2]|0;Y=Y+4|0;if((c[U>>2]|0)==(S|0)){X=U;W=46;break a}}while((Y|0)!=(T|0))}T=c[l+24>>2]|0;if((T|0)!=0?(c[T>>2]|0)==(S|0):0){V=T;W=47}break}case 6:{if(!f?(T=c[l+24>>2]|0,(T|0)!=0):0){V=T;W=47;break a}X=eJc(l,b)|0;W=46;break}case 15:case 10:case 9:{if(!f?(T=c[l+24>>2]|0,(T|0)!=0):0){V=T;W=47;break a}X=eJc(l,b)|0;W=46;break}case 8:{T=c[l>>2]|0;Y=c[l+4>>2]|0;if((T|0)!=(Y|0)){U=T;do{a[(c[U>>2]|0)+96>>0]=0;U=U+4|0}while((U|0)!=(Y|0))}if(!f?(Y=c[l+24>>2]|0,(Y|0)!=0):0)a[Y+96>>0]=0;break}case 0:{Y=l+12|0;c[Y>>2]=-1;if(!f?(U=c[l+24>>2]|0,(U|0)!=0):0)Z=U;else{U=eJc(l,b)|0;if(!U)break a;else Z=U}c[Z+64>>2]=-1;c[Y>>2]=c[Z>>2];Y=c[l>>2]|0;U=l+4|0;S=c[U>>2]|0;c[j>>2]=2628;nJc(Y,S,j);S=c[U>>2]|0;U=c[l>>2]|0;if((S|0)==(U|0)){V=Z;W=47}else{Y=S-U>>2;S=0;do{c[(c[U+(S<<2)>>2]|0)+64>>2]=S;S=S+1|0}while(S>>>0<Y>>>0);X=Z;W=46}break}case 7:{if(!f?(c[l+24>>2]|0)!=0:0)_=0;else _=(eJc(l,b)|0)==0&1;a[(c[b+276>>2]|0)+8>>0]=_;i=h;return}default:{if(!f?(Y=c[l+24>>2]|0,(Y|0)!=0):0){V=Y;W=47;break a}Y=c[l+12>>2]|0;S=c[l>>2]|0;U=c[l+4>>2]|0;if((S|0)!=(U|0)){T=S;do{S=c[T>>2]|0;T=T+4|0;if((c[S>>2]|0)==(Y|0)){X=S;W=46;break a}}while((T|0)!=(U|0))}U=c[l+24>>2]|0;if((U|0)!=0?(c[U>>2]|0)==(Y|0):0){V=U;W=47}}}while(0);if((W|0)==46?(X|0)!=0:0){V=X;W=47}b:do if((((W|0)==47?(c[V+100>>2]|0)!=0:0)?(cJc(V,b),!f):0)?(c[l+24>>2]|0)!=0:0){switch(c[n>>2]|0){case 1:case 3:case 2:break;case 0:case 6:{c[n>>2]=11;break b;break}default:break b}if(!(c[(c[b+276>>2]|0)+4>>2]|0))c[n>>2]=11}while(0);l=b+96|0;lIc(l,n,k);v=ea(g[w>>2]);t=ea(g[x>>2]);s=ea(g[y>>2]);r=ea(g[z>>2]);g[p>>2]=v;g[o>>2]=t;g[q>>2]=s;g[u>>2]=r;r=ea(g[E>>2]);s=ea(g[F>>2]);t=ea(g[G>>2]);v=ea(g[H>>2]);g[A>>2]=r;g[B>>2]=s;g[C>>2]=t;g[D>>2]=v;v=ea(g[M>>2]);t=ea(g[N>>2]);s=ea(g[O>>2]);r=ea(g[P>>2]);g[I>>2]=v;g[J>>2]=t;g[K>>2]=s;g[L>>2]=r;c[Q>>2]=d[R>>0];if(!e){i=h;return}oIc(l,c[m>>2]|0);i=h;return}function eJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d;VQc(e,c[b+280>>2]|0);f=c[a+24>>2]|0;if(((((f|0)!=0?(h=ea(g[e+4>>2]),j=ea(g[e+8>>2]),k=ea(g[f+48>>2]),k<=h):0)?ea(k+ea(g[f+56>>2]))>h:0)?(h=ea(g[f+52>>2]),h<=j):0)?ea(h+ea(g[f+60>>2]))>j:0){l=f;TQc(e);i=d;return l|0}f=c[a>>2]|0;m=a+4|0;if((f|0)==(c[m>>2]|0)){l=0;TQc(e);i=d;return l|0}a=b+96|0;b=e+4|0;n=e+8|0;o=f;while(1){lIc(a,e,(c[o>>2]|0)+160|0);f=c[o>>2]|0;j=ea(g[b>>2]);h=ea(g[n>>2]);k=ea(g[f+48>>2]);if(((k<=j?ea(k+ea(g[f+56>>2]))>j:0)?(j=ea(g[f+52>>2]),j<=h):0)?ea(j+ea(g[f+60>>2]))>h:0){l=f;p=13;break}o=o+4|0;if((o|0)==(c[m>>2]|0)){l=0;p=13;break}}if((p|0)==13){TQc(e);i=d;return l|0}return 0}function fJc(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;f=i;i=i+128|0;h=f+116|0;j=f;k=c[b+8>>2]|0;if(!k){i=f;return}l=j+0|0;m=b+108|0;n=l+64|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(n|0));m=b+12|0;o=ea(g[m>>2]);l=b+16|0;p=ea(g[l>>2]);n=b+20|0;q=ea(g[n>>2]);r=b+24|0;s=ea(g[r>>2]);t=j+64|0;g[t>>2]=o;u=j+68|0;g[u>>2]=p;v=j+72|0;g[v>>2]=q;w=j+76|0;g[w>>2]=s;x=b+44|0;s=ea(g[x>>2]);y=b+48|0;q=ea(g[y>>2]);z=b+52|0;p=ea(g[z>>2]);A=b+56|0;o=ea(g[A>>2]);B=j+80|0;g[B>>2]=s;C=j+84|0;g[C>>2]=q;D=j+88|0;g[D>>2]=p;E=j+92|0;g[E>>2]=o;F=b+28|0;o=ea(g[F>>2]);G=b+32|0;p=ea(g[G>>2]);H=b+36|0;q=ea(g[H>>2]);I=b+40|0;s=ea(g[I>>2]);J=j+96|0;g[J>>2]=o;K=j+100|0;g[K>>2]=p;L=j+104|0;g[L>>2]=q;M=j+108|0;g[M>>2]=s;N=b+60|0;O=j+112|0;a[O>>0]=(c[N>>2]|0)!=0&1;P=c[b+280>>2]|0;Q=c[P>>2]|0;do if((Q|0)==7){R=k+24|0;S=c[R>>2]|0;if(!S)T=eJc(k,b)|0;else T=S;S=c[k>>2]|0;U=(c[k+4>>2]|0)-S>>2;a:do if(U){V=b+276|0;W=U;X=S;while(1){Y=W+-1|0;Z=c[X+(Y<<2)>>2]|0;if((Z|0)==(T|0))_=(c[R>>2]|0)==0&1;else _=0;a[(c[V>>2]|0)+8>>0]=_;cJc(Z,b);if(!Y)break a;W=Y;X=c[k>>2]|0}}while(0);if(!e?(c[R>>2]|0)!=0:0){a[(c[b+276>>2]|0)+8>>0]=0;break}a[(c[b+276>>2]|0)+8>>0]=1}else if((Q|0)==8){S=k+4|0;U=c[S>>2]|0;X=c[k>>2]|0;W=U-X>>2;b:do if(!W)$=1;else{V=k+16|0;Y=k+12|0;Z=W;aa=U;ba=X;ca=1;while(1){da=Z;fa=aa;ga=ba;while(1){ha=da+-1|0;ia=c[ga+(ha<<2)>>2]|0;if(a[ia+96>>0]|0){ja=fa;ka=ga;la=ha;ma=ia;break}if(!ia){na=ga;oa=fa}else{bJc(ia);ACi(ia);na=c[k>>2]|0;oa=c[S>>2]|0}ia=ha<<2>>2;pa=na+(ia+1<<2)|0;qa=oa-pa|0;aFi(na+(ia<<2)|0,pa|0,qa|0)|0;pa=na+((qa>>2)+ia<<2)|0;ia=c[S>>2]|0;if((ia|0)==(pa|0))ra=pa;else{qa=ia+(~((ia+-4-pa|0)>>>2)<<2)|0;c[S>>2]=qa;ra=qa}a[V>>0]=1;if(!ha){$=ca;break b}da=ha;fa=ra;ga=c[k>>2]|0}ga=ca&(c[ma>>2]|0)!=(c[Y>>2]|0);if(!la){$=ga;break}else{Z=la;aa=ja;ba=ka;ca=ga}}}while(0);if((!e?(X=k+24|0,U=c[X>>2]|0,(U|0)!=0):0)?(a[U+96>>0]|0)==0:0){bJc(U);ACi(U);c[X>>2]=0}if($)c[k+12>>2]=-1;if((a[k+16>>0]|0)!=0?(X=c[k>>2]|0,U=c[S>>2]|0,c[h>>2]=2628,nJc(X,U,h),U=c[S>>2]|0,X=c[k>>2]|0,(U|0)!=(X|0)):0){W=U-X>>2;U=0;do{c[(c[X+(U<<2)>>2]|0)+64>>2]=U;U=U+1|0}while(U>>>0<W>>>0)}if(!e?(W=c[k+24>>2]|0,(W|0)!=0):0)cJc(W,b);W=c[k>>2]|0;if((W|0)!=(c[S>>2]|0)){U=W;do{cJc(c[U>>2]|0,b);U=U+4|0}while((U|0)!=(c[S>>2]|0))}}while(0);lIc(b+96|0,P,j);s=ea(g[t>>2]);q=ea(g[u>>2]);p=ea(g[v>>2]);o=ea(g[w>>2]);g[m>>2]=s;g[l>>2]=q;g[n>>2]=p;g[r>>2]=o;o=ea(g[B>>2]);p=ea(g[C>>2]);q=ea(g[D>>2]);s=ea(g[E>>2]);g[x>>2]=o;g[y>>2]=p;g[z>>2]=q;g[A>>2]=s;s=ea(g[J>>2]);q=ea(g[K>>2]);p=ea(g[L>>2]);o=ea(g[M>>2]);g[F>>2]=s;g[G>>2]=q;g[H>>2]=p;g[I>>2]=o;c[N>>2]=d[O>>0];if((c[P>>2]|0)==8){i=f;return}if(!e?(c[k+24>>2]|0)!=0:0){i=f;return}gJc(k);i=f;return}function gJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=a+4|0;if((d|0)!=(c[e>>2]|0)){f=d;do{d=c[f>>2]|0;g=d+100|0;h=c[g>>2]|0;if(h){Csc(h);c[g>>2]=0}g=d+104|0;h=c[g>>2]|0;if(h){Csc(h);c[g>>2]=0}g=d+108|0;d=c[g>>2]|0;if(d){Csc(d);c[g>>2]=0}f=f+4|0}while((f|0)!=(c[e>>2]|0))}e=c[a+24>>2]|0;if(!e){i=b;return}a=e+100|0;f=c[a>>2]|0;if(f){Csc(f);c[a>>2]=0}a=e+104|0;f=c[a>>2]|0;if(f){Csc(f);c[a>>2]=0}a=e+108|0;e=c[a>>2]|0;if(!e){i=b;return}Csc(e);c[a>>2]=0;i=b;return}function hJc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+8>>2]|0;if(!e){i=d;return}f=c[b+280>>2]|0;g=c[f>>2]|0;if((g|0)==7){a[(c[b+276>>2]|0)+8>>0]=1;h=c[e+24>>2]|0;if(h){cJc(h,b);j=c[f>>2]|0;k=5}}else{j=g;k=5}if((k|0)==5?(j|0)==8:0){i=d;return}gJc(e);i=d;return}function iJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+8>>2]|0;a:do if(!d)e=0;else{a=c[d+12>>2]|0;f=c[d>>2]|0;g=c[d+4>>2]|0;if((f|0)!=(g|0)){h=f;do{f=c[h>>2]|0;h=h+4|0;if((c[f>>2]|0)==(a|0)){e=f;break a}}while((h|0)!=(g|0))}g=c[d+24>>2]|0;if((g|0)!=0?(c[g>>2]|0)==(a|0):0){e=g;break}e=0}while(0);i=b;return e|0}function jJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=a+4|0;f=c[e>>2]|0;if((d|0)!=(f|0)){g=f;f=d;while(1){d=c[f>>2]|0;if(!d)h=g;else{bJc(d);ACi(d);h=c[e>>2]|0}f=f+4|0;if((f|0)==(h|0))break;else g=h}}h=a+24|0;g=c[h>>2]|0;if(g){bJc(g);ACi(g);c[h>>2]=0}h=c[a>>2]|0;if(!h){i=b;return}a=c[e>>2]|0;if((a|0)!=(h|0))c[e>>2]=a+(~((a+-4-h|0)>>>2)<<2);ACi(h);i=b;return}function kJc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im;f=i;h=c[b+8>>2]|0;b=c[h>>2]|0;j=c[h+4>>2]|0;a:do if((b|0)!=(j|0)){k=b;while(1){l=c[k>>2]|0;k=k+4|0;if((c[l>>2]|0)==(d|0)){m=l;break}if((k|0)==(j|0)){n=4;break a}}if(!m){i=f;return}else o=m}else n=4;while(0);if((n|0)==4){n=c[h+24>>2]|0;if(!n){i=f;return}if((c[n>>2]|0)==(d|0))o=n;else{i=f;return}}n=o+48|0;p=ea(g[n>>2]);if(((!(p!=ea(g[e>>2]))?(p=ea(g[o+52>>2]),!(p!=ea(g[e+4>>2]))):0)?(p=ea(g[o+56>>2]),!(p!=ea(g[e+8>>2]))):0)?(p=ea(g[o+60>>2]),!(p!=ea(g[e+12>>2]))):0){i=f;return};c[n+0>>2]=c[e+0>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];a[o+97>>0]=1;i=f;return}function lJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[b+8>>2]|0;b=c[f>>2]|0;g=c[f+4>>2]|0;a:do if((b|0)!=(g|0)){h=b;while(1){j=c[h>>2]|0;h=h+4|0;if((c[j>>2]|0)==(d|0)){k=j;break}if((h|0)==(g|0)){l=4;break a}}if(!k)l=8;else{m=k;l=7}}else l=4;while(0);if((l|0)==4){k=c[f+24>>2]|0;if((k|0)!=0?(c[k>>2]|0)==(d|0):0){m=k;l=7}else l=8}if((l|0)==7){k=m+48|0;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];i=e;return}else if((l|0)==8){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=e;return}}function mJc(a,b){a=a|0;b=b|0;return (c[a+64>>2]|0)<(c[b+64>>2]|0)|0}function nJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-4|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>2;switch(l|0){case 5:{m=h;n=g;o=15;break a;break}case 4:{p=h;q=g;o=14;break a;break}case 3:{r=h;s=g;o=6;break a;break}case 1:case 0:{o=69;break a;break}case 2:{t=h;u=g;o=4;break a;break}default:{}}if((k|0)<124){v=h;w=a;o=21;break a}x=(l|0)/2|0;y=h+(x<<2)|0;do if((k|0)>3996){z=(l|0)/4|0;A=h+(z<<2)|0;B=h+(z+x<<2)|0;z=oJc(h,A,y,B,d)|0;if(_n[c[d>>2]&4095](c[g>>2]|0,c[B>>2]|0)|0){C=c[B>>2]|0;c[B>>2]=c[g>>2];c[g>>2]=C;C=z+1|0;if(_n[c[d>>2]&4095](c[B>>2]|0,c[y>>2]|0)|0){D=c[y>>2]|0;c[y>>2]=c[B>>2];c[B>>2]=D;D=z+2|0;if(_n[c[d>>2]&4095](c[y>>2]|0,c[A>>2]|0)|0){B=c[A>>2]|0;c[A>>2]=c[y>>2];c[y>>2]=B;if(_n[c[d>>2]&4095](c[A>>2]|0,c[h>>2]|0)|0){B=c[h>>2]|0;c[h>>2]=c[A>>2];c[A>>2]=B;E=z+4|0}else E=z+3|0}else E=D}else E=C}else E=z}else{z=_n[c[d>>2]&4095](c[y>>2]|0,c[h>>2]|0)|0;C=_n[c[d>>2]&4095](c[g>>2]|0,c[y>>2]|0)|0;if(!z){if(!C){E=0;break}z=c[y>>2]|0;c[y>>2]=c[g>>2];c[g>>2]=z;if(!(_n[c[d>>2]&4095](c[y>>2]|0,c[h>>2]|0)|0)){E=1;break}z=c[h>>2]|0;c[h>>2]=c[y>>2];c[y>>2]=z;E=2;break}z=c[h>>2]|0;if(C){c[h>>2]=c[g>>2];c[g>>2]=z;E=1;break}c[h>>2]=c[y>>2];c[y>>2]=z;if(_n[c[d>>2]&4095](c[g>>2]|0,z)|0){z=c[y>>2]|0;c[y>>2]=c[g>>2];c[g>>2]=z;E=2}else E=1}while(0);do if(_n[c[d>>2]&4095](c[h>>2]|0,c[y>>2]|0)|0){F=g;G=E}else{x=a;l=g;while(1){k=x+-8|0;if((h|0)==(k|0))break;if(_n[c[d>>2]&4095](c[k>>2]|0,c[y>>2]|0)|0){H=k;o=51;break}else{z=l;l=k;x=z}}if((o|0)==51){o=0;x=c[h>>2]|0;c[h>>2]=c[H>>2];c[H>>2]=x;F=H;G=E+1|0;break}x=h+4|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[g>>2]|0)|0)I=x;else{if((x|0)==(g|0)){o=69;break a}else{J=h;K=x}while(1){x=J+8|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[K>>2]|0)|0){L=K;break}if((x|0)==(g|0)){o=69;break a}else{l=K;K=x;J=l}}l=c[L>>2]|0;c[L>>2]=c[g>>2];c[g>>2]=l;I=L+4|0}if((I|0)==(g|0)){o=69;break a}else{M=I;N=g}while(1){l=M;while(1){x=l+4|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[l>>2]|0)|0){O=x;P=l;break}else l=x}l=N;while(1){x=l+-4|0;if(_n[c[d>>2]&4095](c[h>>2]|0,c[x>>2]|0)|0)l=x;else{Q=x;break}}if(P>>>0>=Q>>>0){h=P;continue b}l=c[P>>2]|0;c[P>>2]=c[Q>>2];c[Q>>2]=l;M=O;N=Q}}while(0);l=h+4|0;c:do if(l>>>0<F>>>0){x=l;z=F;k=y;C=G;while(1){D=x;while(1){B=D+4|0;if(_n[c[d>>2]&4095](c[D>>2]|0,c[k>>2]|0)|0)D=B;else{R=B;S=D;break}}D=z;while(1){B=D+-4|0;if(_n[c[d>>2]&4095](c[B>>2]|0,c[k>>2]|0)|0){T=B;break}else D=B}if(S>>>0>T>>>0){U=S;V=k;W=C;break c}D=c[S>>2]|0;c[S>>2]=c[T>>2];c[T>>2]=D;x=R;z=T;k=(k|0)==(S|0)?T:k;C=C+1|0}}else{U=l;V=y;W=G}while(0);if((U|0)!=(V|0)?_n[c[d>>2]&4095](c[V>>2]|0,c[U>>2]|0)|0:0){y=c[U>>2]|0;c[U>>2]=c[V>>2];c[V>>2]=y;X=W+1|0}else X=W;if(!X){Y=qJc(h,U,d)|0;y=U+4|0;if(qJc(y,a,d)|0){o=64;break}if(Y){h=y;continue}}y=U;if((y-j|0)>=(b-y|0)){Z=h;_=U;o=68;break}nJc(h,U,d);h=U+4|0}if((o|0)==64){o=0;if(Y){o=69;break}else{f=h;a=U;continue}}else if((o|0)==68){o=0;nJc(_+4|0,a,d);f=Z;a=_;continue}}if((o|0)==4){if(!(_n[c[d>>2]&4095](c[u>>2]|0,c[t>>2]|0)|0)){i=e;return}_=c[t>>2]|0;c[t>>2]=c[u>>2];c[u>>2]=_;i=e;return}else if((o|0)==6){_=r+4|0;u=_n[c[d>>2]&4095](c[_>>2]|0,c[r>>2]|0)|0;t=_n[c[d>>2]&4095](c[s>>2]|0,c[_>>2]|0)|0;if(!u){if(!t){i=e;return}u=c[_>>2]|0;c[_>>2]=c[s>>2];c[s>>2]=u;if(!(_n[c[d>>2]&4095](c[_>>2]|0,c[r>>2]|0)|0)){i=e;return}u=c[r>>2]|0;c[r>>2]=c[_>>2];c[_>>2]=u;i=e;return}u=c[r>>2]|0;if(t){c[r>>2]=c[s>>2];c[s>>2]=u;i=e;return}c[r>>2]=c[_>>2];c[_>>2]=u;if(!(_n[c[d>>2]&4095](c[s>>2]|0,u)|0)){i=e;return}u=c[_>>2]|0;c[_>>2]=c[s>>2];c[s>>2]=u;i=e;return}else if((o|0)==14){oJc(p,p+4|0,p+8|0,q,d)|0;i=e;return}else if((o|0)==15){q=m+4|0;p=m+8|0;u=m+12|0;oJc(m,q,p,u,d)|0;if(!(_n[c[d>>2]&4095](c[n>>2]|0,c[u>>2]|0)|0)){i=e;return}s=c[u>>2]|0;c[u>>2]=c[n>>2];c[n>>2]=s;if(!(_n[c[d>>2]&4095](c[u>>2]|0,c[p>>2]|0)|0)){i=e;return}s=c[p>>2]|0;n=c[u>>2]|0;c[p>>2]=n;c[u>>2]=s;if(!(_n[c[d>>2]&4095](n,c[q>>2]|0)|0)){i=e;return}n=c[q>>2]|0;s=c[p>>2]|0;c[q>>2]=s;c[p>>2]=n;if(!(_n[c[d>>2]&4095](s,c[m>>2]|0)|0)){i=e;return}s=c[m>>2]|0;c[m>>2]=c[q>>2];c[q>>2]=s;i=e;return}else if((o|0)==21){pJc(v,w,d);i=e;return}else if((o|0)==69){i=e;return}}function oJc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=_n[c[f>>2]&4095](c[b>>2]|0,c[a>>2]|0)|0;j=_n[c[f>>2]&4095](c[d>>2]|0,c[b>>2]|0)|0;do if(h){k=c[a>>2]|0;if(j){c[a>>2]=c[d>>2];c[d>>2]=k;l=1;break}c[a>>2]=c[b>>2];c[b>>2]=k;if(_n[c[f>>2]&4095](c[d>>2]|0,k)|0){k=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=k;l=2}else l=1}else if(j){k=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=k;if(_n[c[f>>2]&4095](c[b>>2]|0,c[a>>2]|0)|0){k=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=k;l=2}else l=1}else l=0;while(0);if(!(_n[c[f>>2]&4095](c[e>>2]|0,c[d>>2]|0)|0)){m=l;i=g;return m|0}j=c[d>>2]|0;c[d>>2]=c[e>>2];c[e>>2]=j;if(!(_n[c[f>>2]&4095](c[d>>2]|0,c[b>>2]|0)|0)){m=l+1|0;i=g;return m|0}j=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=j;if(!(_n[c[f>>2]&4095](c[b>>2]|0,c[a>>2]|0)|0)){m=l+2|0;i=g;return m|0}f=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=f;m=l+3|0;i=g;return m|0}function pJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=a+8|0;g=a+4|0;h=_n[c[d>>2]&4095](c[g>>2]|0,c[a>>2]|0)|0;j=_n[c[d>>2]&4095](c[f>>2]|0,c[g>>2]|0)|0;do if(h){k=c[a>>2]|0;if(j){c[a>>2]=c[f>>2];c[f>>2]=k;break}c[a>>2]=c[g>>2];c[g>>2]=k;if(_n[c[d>>2]&4095](c[f>>2]|0,k)|0){k=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=k}}else if(j?(k=c[g>>2]|0,l=c[f>>2]|0,c[g>>2]=l,c[f>>2]=k,_n[c[d>>2]&4095](l,c[a>>2]|0)|0):0){l=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=l}while(0);g=a+12|0;if((g|0)==(b|0)){i=e;return}else{m=g;n=f}while(1){if(_n[c[d>>2]&4095](c[m>>2]|0,c[n>>2]|0)|0){f=c[m>>2]|0;g=m;j=n;while(1){c[g>>2]=c[j>>2];if((j|0)==(a|0)){o=a;break}h=j+-4|0;if(_n[c[d>>2]&4095](f,c[h>>2]|0)|0){l=j;j=h;g=l}else{o=j;break}}c[o>>2]=f}j=m+4|0;if((j|0)==(b|0))break;else{g=m;m=j;n=g}}i=e;return}function qJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;switch(b-a>>2|0){case 4:{oJc(a,a+4|0,a+8|0,b+-4|0,d)|0;f=1;i=e;return f|0}case 3:{g=a+4|0;h=b+-4|0;j=_n[c[d>>2]&4095](c[g>>2]|0,c[a>>2]|0)|0;k=_n[c[d>>2]&4095](c[h>>2]|0,c[g>>2]|0)|0;if(!j){if(!k){f=1;i=e;return f|0}j=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=j;if(!(_n[c[d>>2]&4095](c[g>>2]|0,c[a>>2]|0)|0)){f=1;i=e;return f|0}j=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=j;f=1;i=e;return f|0}j=c[a>>2]|0;if(k){c[a>>2]=c[h>>2];c[h>>2]=j;f=1;i=e;return f|0}c[a>>2]=c[g>>2];c[g>>2]=j;if(!(_n[c[d>>2]&4095](c[h>>2]|0,j)|0)){f=1;i=e;return f|0}j=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=j;f=1;i=e;return f|0}case 2:{j=b+-4|0;if(!(_n[c[d>>2]&4095](c[j>>2]|0,c[a>>2]|0)|0)){f=1;i=e;return f|0}h=c[a>>2]|0;c[a>>2]=c[j>>2];c[j>>2]=h;f=1;i=e;return f|0}case 5:{h=a+4|0;j=a+8|0;g=a+12|0;k=b+-4|0;oJc(a,h,j,g,d)|0;if(!(_n[c[d>>2]&4095](c[k>>2]|0,c[g>>2]|0)|0)){f=1;i=e;return f|0}l=c[g>>2]|0;c[g>>2]=c[k>>2];c[k>>2]=l;if(!(_n[c[d>>2]&4095](c[g>>2]|0,c[j>>2]|0)|0)){f=1;i=e;return f|0}l=c[j>>2]|0;k=c[g>>2]|0;c[j>>2]=k;c[g>>2]=l;if(!(_n[c[d>>2]&4095](k,c[h>>2]|0)|0)){f=1;i=e;return f|0}k=c[h>>2]|0;l=c[j>>2]|0;c[h>>2]=l;c[j>>2]=k;if(!(_n[c[d>>2]&4095](l,c[a>>2]|0)|0)){f=1;i=e;return f|0}l=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=l;f=1;i=e;return f|0}case 1:case 0:{f=1;i=e;return f|0}default:{l=a+8|0;h=a+4|0;k=_n[c[d>>2]&4095](c[h>>2]|0,c[a>>2]|0)|0;j=_n[c[d>>2]&4095](c[l>>2]|0,c[h>>2]|0)|0;do if(k){g=c[a>>2]|0;if(j){c[a>>2]=c[l>>2];c[l>>2]=g;break}c[a>>2]=c[h>>2];c[h>>2]=g;if(_n[c[d>>2]&4095](c[l>>2]|0,g)|0){g=c[h>>2]|0;c[h>>2]=c[l>>2];c[l>>2]=g}}else if(j?(g=c[h>>2]|0,m=c[l>>2]|0,c[h>>2]=m,c[l>>2]=g,_n[c[d>>2]&4095](m,c[a>>2]|0)|0):0){m=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=m}while(0);h=a+12|0;if((h|0)==(b|0)){f=1;i=e;return f|0}else{n=0;o=h;p=l}while(1){if(_n[c[d>>2]&4095](c[o>>2]|0,c[p>>2]|0)|0){l=c[o>>2]|0;h=o;j=p;while(1){c[h>>2]=c[j>>2];if((j|0)==(a|0)){q=a;break}k=j+-4|0;if(_n[c[d>>2]&4095](l,c[k>>2]|0)|0){m=j;j=k;h=m}else{q=j;break}}c[q>>2]=l;j=n+1|0;if((j|0)==8){r=o;break}else s=j}else s=n;j=o+4|0;if((j|0)==(b|0)){f=1;t=34;break}else{h=o;n=s;o=j;p=h}}if((t|0)==34){i=e;return f|0}f=(r+4|0)==(b|0);i=e;return f|0}}return 0}function rJc(a){a=a|0;c[a+24>>2]=0;c[a+32>>2]=0;c[a+36>>2]=0;c[a+28>>2]=60;c[a+40>>2]=0;return}function sJc(b){b=b|0;var d=0;c[b+40>>2]=0;d=b+4|0;c[d+0>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;a[b+20>>0]=0;c[b>>2]=1;return}function tJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b>>2]|0;a:do if(!(c[a+60>>2]|0))if((e|0)==7|(e|0)==8|(e|0)==12)f=e;else f=11;else if(!(c[a+268>>2]|0)){switch(e|0){case 0:case 1:case 9:case 10:case 16:{f=11;break a;break}default:{}}f=e}else f=e;while(0);i=d;return f|0}function uJc(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im;n=i;i=i+32|0;o=n+16|0;p=n+8|0;q=n+4|0;r=n;s=vLc()|0;if(!s){t=0;i=n;return t|0}if(!f){f=c[c[s>>2]>>2]|0;c[q>>2]=c[j>>2];c[o+0>>2]=c[q+0>>2];t=hn[f&1](s,b,d,e,3,ea(0.0),ea(16.0),ea(1.0),h,1,o,k,l)|0;i=n;return t|0}f=b+24|0;q=c[f>>2]|0;if(!q)u=0;else{c[p>>2]=q;q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(o,q,p);v=c[o>>2]|0;w=c[q+28>>2]|0;if((v|0)==-1){x=w+(c[q+32>>2]<<3)|0;break}else{x=w+(v<<3)|0;break}}else x=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((x|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[x+4>>2]|0,(q|0)!=0):0)y=q;else z=13}else z=13;if((z|0)==13)y=hQb(c[f>>2]|0)|0;u=y}y=a+8|0;A=ea(g[y>>2]);if((m|0)==2){t=0;i=n;return t|0}else if(!m)z=16;else B=A;do if((z|0)==16)if(!u)B=A;else{C=ea(mo[c[(c[u>>2]|0)+104>>2]&4095](u)|0);m=mo[c[(c[u>>2]|0)+108>>2]&4095](u)|0;if(!(ea(0.0)==ea(0.0))){B=ea(A-ea(0.0));break}D=ea(m|0);E=ea(ea(g[y>>2])/C);F=ea(ea(g[a+12>>2])/D);D=F<E?F:E;if(D<ea(0.0))G=ea(0.0);else{m=D>ea(1.0);G=m?ea(1.0):D}B=ea(A-ea(R(ea(ea(C*G)+ea(.5)))))}while(0);a=c[c[s>>2]>>2]|0;c[r>>2]=c[j>>2];c[o+0>>2]=c[r+0>>2];t=hn[a&1](s,b,d,e,3,B,ea(16.0),ea(1.0),h,1,o,k,l)|0;i=n;return t|0}function vJc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;h=SEi(d|0)|0;if(!h){c[b>>2]=0;c[b+4>>2]=0;j=0;k=b+8|0;a[k>>0]=j;i=e;return}else{c[g>>2]=c[153122];c[f+0>>2]=c[g+0>>2];g=cOb(h<<1,16,f,0,3653512,26)|0;c[b>>2]=g;IVc(d,h,g,b+4|0)|0;j=1;k=b+8|0;a[k>>0]=j;i=e;return}}function wJc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!(a[b+8>>0]|0)){i=d;return}g=c[b>>2]|0;c[f>>2]=c[153122];c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function xJc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[d+4>>2]|0;j=b+4|0;if(!h){c[j>>2]=0;c[b>>2]=0;k=0;l=b+8|0;a[l>>0]=k;i=e;return}else{c[j>>2]=h;c[g>>2]=c[153122];c[f+0>>2]=c[g+0>>2];g=cOb(h<<1,16,f,0,3653512,128)|0;c[b>>2]=g;YEi(g|0,c[d>>2]|0,c[j>>2]<<1|0)|0;k=1;l=b+8|0;a[l>>0]=k;i=e;return}}function yJc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=b+8|0;g=c[f>>2]|0;h=b+4|0;j=c[h>>2]|0;k=j;if((g-k|0)>>>0>=d>>>0){l=d;m=j;do{if(!m)n=0;else{a[m>>0]=0;n=c[h>>2]|0}m=n+1|0;c[h>>2]=m;l=l+-1|0}while((l|0)!=0);i=e;return}l=c[b>>2]|0;m=k-l+d|0;if((m|0)<0)vxi(b);k=l;l=g-k|0;if(l>>>0<1073741823){g=l<<1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k|0;if(!l){o=0;p=0;q=g}else{r=l;s=g;t=10}}else{r=2147483647;s=(c[h>>2]|0)-k|0;t=10}if((t|0)==10){o=r;p=xCi(r)|0;q=s}s=d;d=p+q|0;while(1){if(!d)u=0;else{a[d>>0]=0;u=d}r=u+1|0;s=s+-1|0;if(!s){v=r;break}else d=r}d=c[b>>2]|0;s=(c[h>>2]|0)-d|0;u=p+(q-s)|0;YEi(u|0,d|0,s|0)|0;c[b>>2]=u;c[h>>2]=v;c[f>>2]=p+o;if(!d){i=e;return}ACi(d);i=e;return}function zJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=c[b>>2]|0;if((e|0)==16|(e|0)==11){i=d;return}e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=f-h>>2;if(!j)k=0;else k=(j*93|0)+-1|0;j=a+16|0;l=c[j>>2]|0;m=a+20|0;n=c[m>>2]|0;if((k-l|0)==(n|0)){FJc(a);o=c[m>>2]|0;p=c[j>>2]|0;q=c[e>>2]|0;r=c[g>>2]|0}else{o=n;p=l;q=f;r=h}h=o+p|0;if((q|0)!=(r|0)?(q=(c[r+(((h>>>0)/93|0)<<2)>>2]|0)+(((h>>>0)%93|0)*44|0)|0,(q|0)!=0):0){VQc(q,b);s=c[m>>2]|0}else s=o;c[m>>2]=s+1;i=d;return}function AJc(a){a=a|0;var b=0;b=i;GJc(a);i=b;return}function BJc(a){a=a|0;return c[a+20>>2]|0}function CJc(a,b){a=a|0;b=b|0;var d=0;d=(c[a+16>>2]|0)+b|0;return (c[(c[a+4>>2]|0)+(((d>>>0)/93|0)<<2)>>2]|0)+(((d>>>0)%93|0)*44|0)|0}function DJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d;h=c[a+4>>2]|0;j=c[a+16>>2]|0;k=(j>>>0)/93|0;l=h+(k<<2)|0;if((c[a+8>>2]|0)==(h|0))m=0;else m=(c[l>>2]|0)+(((j>>>0)%93|0)*44|0)|0;do if(b){j=((m-(c[l>>2]|0)|0)/44|0)+b|0;if((j|0)>0){n=h+(((j|0)/93|0)+k<<2)|0;o=n;p=(c[n>>2]|0)+(((j|0)%93|0)*44|0)|0;break}else{n=92-j|0;j=h+(((n|0)/-93|0)+k<<2)|0;o=j;p=(c[j>>2]|0)+((92-((n|0)%93|0)|0)*44|0)|0;break}}else{o=l;p=m}while(0);c[f>>2]=o;c[f+4>>2]=p;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];HJc(g,a,e);i=d;return}function EJc(){return c[149358]|0}function FJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;i=i+16|0;d=b;e=a+16|0;f=c[e>>2]|0;if(f>>>0>92){c[e>>2]=f+-93;f=a+4|0;e=c[f>>2]|0;g=c[e>>2]|0;h=e+4|0;c[f>>2]=h;j=a+8|0;k=c[j>>2]|0;l=a+12|0;do if((k|0)==(c[l>>2]|0)){m=c[a>>2]|0;if(h>>>0>m>>>0){n=h;o=((n-m>>2)+1|0)/-2|0;p=k-n|0;aFi(e+(o+1<<2)|0,h|0,p|0)|0;n=e+((p>>2)+1+o<<2)|0;c[j>>2]=n;c[f>>2]=(c[f>>2]|0)+(o<<2);q=n;r=13;break}n=k-m>>1;o=(n|0)==0?1:n;n=xCi(o<<2)|0;p=n+(o>>>2<<2)|0;s=n+(o<<2)|0;if((h|0)==(k|0)){t=p;u=m}else{m=p;o=h;v=e;while(1){if(!m)w=0;else{c[m>>2]=c[o>>2];w=m}x=w+4|0;y=v+8|0;if((y|0)==(k|0)){z=x;break}else{A=o;m=x;o=y;v=A}}t=z;u=c[a>>2]|0}c[a>>2]=n;c[f>>2]=p;c[j>>2]=t;c[l>>2]=s;if(!u){B=t;r=12}else{ACi(u);B=c[j>>2]|0;r=12}}else{B=k;r=12}while(0);if((r|0)==12)if(!B)C=0;else{q=B;r=13}if((r|0)==13){c[q>>2]=g;C=c[j>>2]|0}c[j>>2]=C+4;i=b;return}C=a+8|0;j=c[C>>2]|0;g=a+4|0;q=j-(c[g>>2]|0)|0;B=q>>2;k=a+12|0;u=c[k>>2]|0;t=u-(c[a>>2]|0)|0;if(B>>>0<t>>2>>>0){l=xCi(4092)|0;if((u|0)!=(j|0)){if(!j)D=0;else{c[j>>2]=l;D=c[C>>2]|0}c[C>>2]=D+4;i=b;return}c[d>>2]=l;KJc(a,d);d=c[g>>2]|0;l=c[d>>2]|0;D=d+4|0;c[g>>2]=D;j=c[C>>2]|0;do if((j|0)==(c[k>>2]|0)){u=c[a>>2]|0;if(D>>>0>u>>>0){f=D;z=((f-u>>2)+1|0)/-2|0;w=j-f|0;aFi(d+(z+1<<2)|0,D|0,w|0)|0;f=d+((w>>2)+1+z<<2)|0;c[C>>2]=f;c[g>>2]=(c[g>>2]|0)+(z<<2);E=f;r=31;break}f=j-u>>1;z=(f|0)==0?1:f;f=xCi(z<<2)|0;w=f+(z>>>2<<2)|0;e=f+(z<<2)|0;if((D|0)==(j|0)){F=w;G=u}else{u=w;z=D;h=d;while(1){if(!u)H=0;else{c[u>>2]=c[z>>2];H=u}v=H+4|0;o=h+8|0;if((o|0)==(j|0)){I=v;break}else{m=z;u=v;z=o;h=m}}F=I;G=c[a>>2]|0}c[a>>2]=f;c[g>>2]=w;c[C>>2]=F;c[k>>2]=e;if(!G){J=F;r=30}else{ACi(G);J=c[C>>2]|0;r=30}}else{J=j;r=30}while(0);if((r|0)==30)if(!J)K=0;else{E=J;r=31}if((r|0)==31){c[E>>2]=l;K=c[C>>2]|0}c[C>>2]=K+4;i=b;return}K=t>>1;t=(K|0)==0?1:K;K=xCi(t<<2)|0;l=K+(t<<2)|0;E=xCi(4092)|0;r=K+(B<<2)|0;do if((B|0)==(t|0))if((q|0)>0){L=K+(((B+1|0)/-2|0)+B<<2)|0;M=l;N=K;break}else{J=q>>1;j=(J|0)==0?1:J;J=xCi(j<<2)|0;ACi(K);L=J+(j>>>2<<2)|0;M=J+(j<<2)|0;N=J;break}else{L=r;M=l;N=K}while(0);if(!L)O=0;else{c[L>>2]=E;O=L}E=O+4|0;O=c[C>>2]|0;if((O|0)==(c[g>>2]|0)){P=M;Q=E;R=L;S=N}else{K=L;L=N;N=E;E=M;M=O;while(1){M=M+-4|0;do if((K|0)==(L|0)){O=E;if(N>>>0<E>>>0){l=N;r=((O-l>>2)+1|0)/2|0;q=l-L|0;l=N+(r-(q>>2)<<2)|0;aFi(l|0,L|0,q|0)|0;T=l;U=E;V=N+(r<<2)|0;W=L;break}r=O-L>>1;O=(r|0)==0?1:r;r=xCi(O<<2)|0;l=r+((O+3|0)>>>2<<2)|0;q=r+(O<<2)|0;if((L|0)==(N|0))X=l;else{O=l;B=L;while(1){if(!O)Y=0;else{c[O>>2]=c[B>>2];Y=O}t=Y+4|0;B=B+4|0;if((B|0)==(N|0)){X=t;break}else O=t}}if(!L){T=l;U=q;V=X;W=r}else{ACi(L);T=l;U=q;V=X;W=r}}else{T=K;U=E;V=N;W=L}while(0);e=T+-4|0;c[e>>2]=c[M>>2];if((M|0)==(c[g>>2]|0)){P=U;Q=V;R=e;S=W;break}else{K=e;L=W;N=V;E=U}}}U=c[a>>2]|0;c[a>>2]=S;c[g>>2]=R;c[C>>2]=Q;c[k>>2]=P;if(!U){i=b;return}ACi(U);i=b;return}function GJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+16|0;g=c[f>>2]|0;h=e+(((g>>>0)/93|0)<<2)|0;j=a+8|0;if((c[j>>2]|0)==(e|0)){k=0;l=a+20|0;m=0}else{n=a+20|0;a=g+(c[n>>2]|0)|0;k=(c[e+(((a>>>0)/93|0)<<2)>>2]|0)+(((a>>>0)%93|0)*44|0)|0;l=n;m=(c[h>>2]|0)+(((g>>>0)%93|0)*44|0)|0}g=m;m=h;a:while(1){h=g;do{if((h|0)==(k|0))break a;TQc(h);h=h+44|0}while((h-(c[m>>2]|0)|0)!=4092);h=m+4|0;g=c[h>>2]|0;m=h}c[l>>2]=0;l=c[d>>2]|0;m=(c[j>>2]|0)-l>>2;if(m>>>0>2){g=l;do{ACi(c[g>>2]|0);g=(c[d>>2]|0)+4|0;c[d>>2]=g;l=(c[j>>2]|0)-g>>2}while(l>>>0>2);o=l}else o=m;if((o|0)==1){c[f>>2]=46;i=b;return}else if((o|0)==2){c[f>>2]=93;i=b;return}else{i=b;return}}function HJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+96|0;f=e+80|0;g=e+40|0;h=e+56|0;j=e;k=e+24|0;l=e+32|0;m=e+72|0;n=e+64|0;o=e+8|0;p=e+48|0;q=e+16|0;r=b+4|0;s=c[r>>2]|0;t=b+16|0;u=c[t>>2]|0;v=(u>>>0)/93|0;w=s+(v<<2)|0;x=b+8|0;y=(c[x>>2]|0)==(s|0);if(y)z=0;else z=(c[w>>2]|0)+(((u>>>0)%93|0)*44|0)|0;A=w;B=c[d+4>>2]|0;do if((B|0)!=(z|0)){C=c[d>>2]|0;D=z;E=((C-A>>2)*93|0)+((B-(c[C>>2]|0)|0)/44|0)+((D-(c[w>>2]|0)|0)/-44|0)|0;C=(E|0)==0;if(!C){F=((D-(c[w>>2]|0)|0)/44|0)+E|0;if((F|0)>0){G=s+(((F|0)/93|0)+v<<2)|0;H=E;I=G;J=0;K=A;L=D;M=(c[G>>2]|0)+(((F|0)%93|0)*44|0)|0;break}else{G=92-F|0;F=s+(((G|0)/-93|0)+v<<2)|0;H=E;I=F;J=C;K=A;L=D;M=(c[F>>2]|0)+((92-((G|0)%93|0)|0)*44|0)|0;break}}else{H=0;I=w;J=1;K=A;L=D;M=z}}else{H=0;I=w;J=1;K=A;L=z;M=z}while(0);A=I;w=b+20|0;b=c[w>>2]|0;if(H>>>0<(b+-1|0)>>>1>>>0){v=j;c[v>>2]=K;c[v+4>>2]=L;L=M;v=k;c[v>>2]=A;c[v+4>>2]=L;v=L-(c[I>>2]|0)|0;L=(v|0)/44|0;K=L+1|0;if((v|0)>-44){v=I+(((K|0)/93|0)<<2)|0;N=v;O=(c[v>>2]|0)+(((K|0)%93|0)*44|0)|0}else{K=91-L|0;L=I+(((K|0)/-93|0)<<2)|0;N=L;O=(c[L>>2]|0)+((92-((K|0)%93|0)|0)*44|0)|0}K=l;c[K>>2]=N;c[K+4>>2]=O;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];LJc(m,h,g,f);TQc(z);c[w>>2]=(c[w>>2]|0)+-1;z=(c[t>>2]|0)+1|0;c[t>>2]=z;if(z>>>0>185){ACi(c[c[r>>2]>>2]|0);c[r>>2]=(c[r>>2]|0)+4;m=(c[t>>2]|0)+-93|0;c[t>>2]=m;P=m}else P=z}else{z=M;M=z-(c[I>>2]|0)|0;m=(M|0)/44|0;l=m+1|0;if((M|0)>-44){M=I+(((l|0)/93|0)<<2)|0;Q=M;R=(c[M>>2]|0)+(((l|0)%93|0)*44|0)|0}else{l=91-m|0;m=I+(((l|0)/-93|0)<<2)|0;Q=m;R=(c[m>>2]|0)+((92-((l|0)%93|0)|0)*44|0)|0}l=o;c[l>>2]=Q;c[l+4>>2]=R;R=u+b|0;b=s+(((R>>>0)/93|0)<<2)|0;if(y)S=0;else S=(c[b>>2]|0)+(((R>>>0)%93|0)*44|0)|0;c[p>>2]=b;c[p+4>>2]=S;S=q;c[S>>2]=A;c[S+4>>2]=z;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[g+0>>2]=c[p+0>>2];c[g+4>>2]=c[p+4>>2];c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];MJc(n,h,g,f);TQc(c[n+4>>2]|0);n=(c[w>>2]|0)+-1|0;c[w>>2]=n;w=c[x>>2]|0;f=w-(c[r>>2]|0)>>2;if(!f)T=0;else T=(f*93|0)+-1|0;f=c[t>>2]|0;if((T-f-n|0)>>>0>185){ACi(c[w+-4>>2]|0);c[x>>2]=(c[x>>2]|0)+-4;P=c[t>>2]|0}else P=f}f=c[r>>2]|0;r=(P>>>0)/93|0;t=f+(r<<2)|0;if((c[x>>2]|0)==(f|0)){U=0;V=0}else{U=0;V=(c[t>>2]|0)+(((P>>>0)%93|0)*44|0)|0}P=a;c[P>>2]=U|t;c[P+4>>2]=V;if(J){i=e;return}J=a+4|0;P=((V-(c[t>>2]|0)|0)/44|0)+H|0;if((P|0)>0){H=f+(((P|0)/93|0)+r<<2)|0;c[a>>2]=H;c[J>>2]=(c[H>>2]|0)+(((P|0)%93|0)*44|0);i=e;return}else{H=92-P|0;P=f+(((H|0)/-93|0)+r<<2)|0;c[a>>2]=P;c[J>>2]=(c[P>>2]|0)+((92-((H|0)%93|0)|0)*44|0);i=e;return}}function IJc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153102];c[b+0>>2]=c[d+0>>2];d=bOb(24,b,1,16,3653512,52)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[149358]=d;i=a;return}function JJc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[149358]|0;f=c[153102]|0;if(e){GJc(e);g=e+4|0;h=c[g>>2]|0;j=e+8|0;k=c[j>>2]|0;if((h|0)!=(k|0)){l=h;do{ACi(c[l>>2]|0);l=l+4|0}while((l|0)!=(k|0));k=c[g>>2]|0;g=c[j>>2]|0;if((g|0)!=(k|0))c[j>>2]=g+(~((g+-4-k|0)>>>2)<<2)}k=c[e>>2]|0;if(k)ACi(k)}c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[149358]=0;i=a;return}function KJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function LJc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f;k=d+4|0;l=c[k>>2]|0;m=c[b+4>>2]|0;if((l|0)!=(m|0)?(n=c[d>>2]|0,o=c[b>>2]|0,b=((n-o>>2)*93|0)+((l-(c[n>>2]|0)|0)/44|0)+((m-(c[o>>2]|0)|0)/-44|0)|0,(b|0)>0):0){o=c[d>>2]|0;m=l;l=b;while(1){if((m|0)==(c[o>>2]|0)){b=o+-4|0;c[d>>2]=b;n=(c[b>>2]|0)+4092|0;c[k>>2]=n;p=n;q=b}else{p=m;q=o}b=p+-44|0;c[k>>2]=b;n=c[q>>2]|0;r=(p-n|0)/44|0;if((r|0)>(l|0)){s=l;t=p+((0-l|0)*44|0)|0}else{s=r;t=n}n=e;r=c[n+4>>2]|0;u=j;c[u>>2]=c[n>>2];c[u+4>>2]=r;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];NJc(h,t,p,g,0);r=h;u=c[r>>2]|0;n=c[r+4>>2]|0;r=e;c[r>>2]=u;c[r+4>>2]=n;l=l-s|0;r=s+-1|0;do if(r){v=((b-(c[q>>2]|0)|0)/44|0)-r|0;if((v|0)>0){w=q+(((v|0)/93|0)<<2)|0;c[d>>2]=w;x=(c[w>>2]|0)+(((v|0)%93|0)*44|0)|0;c[k>>2]=x;y=w;z=x;break}else{x=92-v|0;v=q+(((x|0)/-93|0)<<2)|0;c[d>>2]=v;w=(c[v>>2]|0)+((92-((x|0)%93|0)|0)*44|0)|0;c[k>>2]=w;y=v;z=w;break}}else{y=q;z=b}while(0);if((l|0)<=0){A=u;B=n;break}else{o=y;m=z}}C=a;D=C;c[D>>2]=A;E=C+4|0;F=E;c[F>>2]=B;i=f;return}z=e;A=c[z>>2]|0;B=c[z+4>>2]|0;C=a;D=C;c[D>>2]=A;E=C+4|0;F=E;c[F>>2]=B;i=f;return}function MJc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;g=c[d+4>>2]|0;h=b+4|0;j=c[h>>2]|0;if((g|0)!=(j|0)?(k=c[d>>2]|0,d=c[b>>2]|0,l=((k-d>>2)*93|0)+((g-(c[k>>2]|0)|0)/44|0)+((j-(c[d>>2]|0)|0)/-44|0)|0,(l|0)>0):0){d=c[b>>2]|0;k=j;j=l;while(1){l=(c[d>>2]|0)+4092|0;g=k;m=(l-g|0)/44|0;if((m|0)>(j|0)){n=j;o=k+(j*44|0)|0}else{n=m;o=l}l=e;m=c[l>>2]|0;p=c[l+4>>2]|0;if((k|0)==(o|0)){q=p;r=m}else{l=o;s=k;t=m;u=p;v=m;m=p;while(1){p=m;w=((c[v>>2]|0)+4092-p|0)/44|0;x=(l-s|0)/44|0;if((x|0)>(w|0)){y=s+(w*44|0)|0;z=w}else{y=o;z=x}if((s|0)!=(y|0)){x=s;w=m;while(1){WQc(w,x);x=x+44|0;if((x|0)==(y|0))break;else w=w+44|0}}do if(z){w=((p-(c[v>>2]|0)|0)/44|0)+z|0;if((w|0)>0){x=v+(((w|0)/93|0)<<2)|0;A=(c[x>>2]|0)+(((w|0)%93|0)*44|0)|0;B=x;C=A;D=x;E=A;break}else{A=92-w|0;w=v+(((A|0)/-93|0)<<2)|0;x=(c[w>>2]|0)+((92-((A|0)%93|0)|0)*44|0)|0;B=w;C=x;D=w;E=x;break}}else{B=t;C=u;D=v;E=m}while(0);if((y|0)==(o|0)){q=C;r=B;break}else{s=y;t=B;u=C;v=D;m=E}}}m=q;v=e;c[v>>2]=r;c[v+4>>2]=m;j=j-n|0;do if(n){v=((g-(c[d>>2]|0)|0)/44|0)+n|0;if((v|0)>0){u=d+(((v|0)/93|0)<<2)|0;c[b>>2]=u;t=(c[u>>2]|0)+(((v|0)%93|0)*44|0)|0;c[h>>2]=t;F=u;G=t;break}else{t=92-v|0;v=d+(((t|0)/-93|0)<<2)|0;c[b>>2]=v;u=(c[v>>2]|0)+((92-((t|0)%93|0)|0)*44|0)|0;c[h>>2]=u;F=v;G=u;break}}else{F=d;G=k}while(0);if((j|0)<=0){H=r;I=m;break}else{d=F;k=G}}J=a;K=J;c[K>>2]=H;L=J+4|0;M=L;c[M>>2]=I;i=f;return}G=e;H=c[G>>2]|0;I=c[G+4>>2]|0;J=a;K=J;c[K>>2]=H;L=J+4|0;M=L;c[M>>2]=I;i=f;return}function NJc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;if((d|0)==(b|0)){g=e;h=g;j=c[h>>2]|0;k=g+4|0;l=k;m=c[l>>2]|0;n=a;o=n;c[o>>2]=j;p=n+4|0;q=p;c[q>>2]=m;i=f;return}r=b;s=e+4|0;t=d;while(1){d=e;u=c[d>>2]|0;v=((c[d+4>>2]|0)-(c[u>>2]|0)|0)/44|0;d=v+-1|0;if((d|0)>0){w=c[u+(((d|0)/93|0)<<2)>>2]|0;x=w+(((d|0)%93|0)*44|0)|0;y=w}else{w=93-v|0;v=c[u+(((w|0)/-93|0)<<2)>>2]|0;x=v+((92-((w|0)%93|0)|0)*44|0)|0;y=v}v=x+44|0;w=(v-y|0)/44|0;d=(t-r|0)/44|0;if((d|0)>(w|0)){z=t+((0-w|0)*44|0)|0;A=w}else{z=b;A=d}if((t|0)!=(z|0)){d=t;w=v;do{w=w+-44|0;d=d+-44|0;WQc(w,d)}while((d|0)!=(z|0))}do if(A){d=(((c[s>>2]|0)-(c[u>>2]|0)|0)/44|0)-A|0;if((d|0)>0){w=u+(((d|0)/93|0)<<2)|0;c[e>>2]=w;c[s>>2]=(c[w>>2]|0)+(((d|0)%93|0)*44|0);break}else{w=92-d|0;d=u+(((w|0)/-93|0)<<2)|0;c[e>>2]=d;c[s>>2]=(c[d>>2]|0)+((92-((w|0)%93|0)|0)*44|0);break}}while(0);if((z|0)==(b|0))break;else t=z}g=e;h=g;j=c[h>>2]|0;k=g+4|0;l=k;m=c[l>>2]|0;n=a;o=n;c[o>>2]=j;p=n+4|0;q=p;c[q>>2]=m;i=f;return}function OJc(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;h=d+12|0;j=d;c[b>>2]=597448;k=b+16|0;l=b+28|0;m=b+80|0;n=b+4|0;o=n+60|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));g[m>>2]=ea(.00100000005);g[b+76>>2]=ea(0.0);g[b+84>>2]=ea(.100000001);a[b+89>>0]=0;a[b+88>>0]=0;g[b+64>>2]=ea(0.0);c[b+72>>2]=0;a[h>>0]=0;a[h+1>>0]=0;do if((k|0)!=(h|0)){a[k+1>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=0;break}else{c[b+20>>2]=0;break}}while(0);a[j>>0]=0;a[j+1>>0]=0;do if((l|0)!=(j|0)){k=a[l>>0]|0;if(!(k&1))p=k;else p=c[l>>2]&255;if(!(p&1))q=l+1|0;else q=c[b+36>>2]|0;a[q>>0]=0;if(!(a[l>>0]&1)){a[l>>0]=0;break}else{c[b+32>>2]=0;break}}while(0);if(!(a[j>>0]&1)){i=d;return}b=c[j+8>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function PJc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+48|0;f=e+32|0;h=e+28|0;j=e+24|0;k=e+12|0;l=e;c[b>>2]=597448;m=b+4|0;n=b+16|0;o=b+28|0;p=b+80|0;q=m+0|0;r=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));g[p>>2]=ea(.00100000005);g[b+76>>2]=ea(0.0);g[b+84>>2]=ea(.100000001);a[b+89>>0]=0;a[b+88>>0]=0;g[b+64>>2]=ea(0.0);c[b+72>>2]=0;p=a[d>>0]|0;if(!(p&1)){s=(p&255)>>>1;t=d+1|0}else{s=c[d+4>>2]|0;t=c[d+8>>2]|0}do if(s>>>0<=10){aFi(m+1|0,t|0,s|0)|0;a[m+s+1>>0]=0;if(!(a[m>>0]&1)){a[m>>0]=s<<1;break}else{c[b+8>>2]=s;break}}else eXb(m,10,s+-10|0,0,0,0,s,t);while(0);a[k>>0]=0;a[k+1>>0]=0;do if((n|0)!=(k|0)){t=a[n>>0]|0;if(!(t&1))u=t;else u=c[n>>2]&255;if(!(u&1))v=n+1|0;else v=c[b+24>>2]|0;a[v>>0]=0;if(!(a[n>>0]&1)){a[n>>0]=0;break}else{c[b+20>>2]=0;break}}while(0);if(a[k>>0]&1){n=c[k+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(n,f)}a[l>>0]=0;a[l+1>>0]=0;do if((o|0)!=(l|0)){n=a[o>>0]|0;if(!(n&1))w=n;else w=c[o>>2]&255;if(!(w&1))x=o+1|0;else x=c[b+36>>2]|0;a[x>>0]=0;if(!(a[o>>0]&1)){a[o>>0]=0;break}else{c[b+32>>2]=0;break}}while(0);if(!(a[l>>0]&1)){i=e;return}b=c[l+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(b,f);i=e;return}function QJc(b){b=b|0;var d=0,e=Im,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=0,o=Im,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0;d=i;e=ea(g[(jLc()|0)+104>>2]);f=b+89|0;if(a[f>>0]|0){h=b+64|0;g[h>>2]=ea(-ea(g[h>>2]))}h=c[b+60>>2]|0;do if((h|0)==2){j=fKc()|0;k=ea(nKc(j,c[b+56>>2]|0,c[b+72>>2]|0));j=b+64|0;g[b+68>>2]=k;l=ea(ea(g[b+84>>2])*k);g[j>>2]=l;if(l>ea(1.0)){g[j>>2]=ea(1.0);break}if(l<ea(-1.0)){g[j>>2]=ea(-1.0);break}k=ea(g[b+80>>2]);if(l<k&l>ea(-k)){g[j>>2]=ea(0.0);break}if(l>ea(0.0)){m=ea(ea(l-k)/ea(ea(1.0)-k));g[j>>2]=ea(m+ea(ea(ea(1.0)-m)*ea(0.0)));break}else{m=ea(ea(ea(-l)-k)/ea(ea(1.0)-k));g[j>>2]=ea(ea(ea(ea(1.0)-m)*ea(0.0))-m);break}}else if((h|0)==1){j=fKc()|0;n=c[b+72>>2]|0;if(!n){m=ea(g[j+84>>2]);g[b+64>>2]=m;o=m}else if((n|0)==1){m=ea(g[j+88>>2]);g[b+64>>2]=m;o=m}else if((n|0)==3){m=ea(g[j+92>>2]);g[b+64>>2]=m;o=m}else{m=ea(g[j+96>>2]);g[b+64>>2]=m;o=m}g[b+68>>2]=o;g[b+64>>2]=ea(ea(g[b+84>>2])*o)}else if(!h){j=fKc()|0;n=c[b+40>>2]|0;p=n>>>5;if(!((c[(c[j+40>>2]|0)+(p<<2)>>2]|c[(c[j+56>>2]|0)+(p<<2)>>2])&1<<(n&31))){n=fKc()|0;p=c[b+48>>2]|0;j=p>>>5;q=((c[(c[n+40>>2]|0)+(j<<2)>>2]|c[(c[n+56>>2]|0)+(j<<2)>>2])&1<<(p&31)|0)!=0}else q=1;p=fKc()|0;j=c[b+44>>2]|0;n=j>>>5;if(!((c[(c[p+40>>2]|0)+(n<<2)>>2]|c[(c[p+56>>2]|0)+(n<<2)>>2])&1<<(j&31))){j=fKc()|0;n=c[b+52>>2]|0;p=n>>>5;r=((c[(c[j+40>>2]|0)+(p<<2)>>2]|c[(c[j+56>>2]|0)+(p<<2)>>2])&1<<(n&31)|0)!=0}else r=1;n=b+68|0;g[n>>2]=ea(0.0);if(!(q&r)){if(q){p=b+64|0;m=ea(g[p>>2]);if(!((a[b+88>>0]|0)!=0&m<ea(0.0))){k=ea(m+ea(e*ea(g[b+84>>2])));g[b+64>>2]=k;j=b+64|0;if(k<ea(0.0)){m=ea(k+ea(e*ea(g[b+76>>2])));g[j>>2]=m;s=j;t=m}else{s=j;t=k}}else{g[p>>2]=ea(0.0);s=b+64|0;t=ea(0.0)}p=t<ea(1.0);g[s>>2]=p?t:ea(1.0);g[n>>2]=ea(1.0);break}if(r){p=b+64|0;k=ea(g[p>>2]);if(!((a[b+88>>0]|0)!=0&k>ea(0.0))){m=ea(k-ea(e*ea(g[b+84>>2])));g[b+64>>2]=m;j=b+64|0;if(m>ea(0.0)){k=ea(m-ea(e*ea(g[b+76>>2])));g[j>>2]=k;u=k;v=j}else{u=m;v=j}}else{g[p>>2]=ea(0.0);u=ea(0.0);v=b+64|0}p=u>ea(-1.0);g[v>>2]=p?u:ea(-1.0);g[n>>2]=ea(-1.0);break}m=ea(g[b+76>>2]);if(m!=ea(0.0)){n=b+64|0;k=ea(g[n>>2]);if(k>ea(0.0)){l=ea(k-ea(e*m));g[n>>2]=l;if(!(l<ea(0.0)))break;g[n>>2]=ea(0.0);break}if(k<ea(0.0)?(l=ea(ea(e*m)+k),g[n>>2]=l,l>ea(0.0)):0)g[n>>2]=ea(0.0)}}}while(0);if(!(a[f>>0]|0)){i=d;return}f=b+64|0;g[f>>2]=ea(-ea(g[f>>2]));f=b+68|0;g[f>>2]=ea(-ea(g[f>>2]));i=d;return}function RJc(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;c[b+40>>2]=d;c[b+44>>2]=e;c[b+48>>2]=f;c[b+52>>2]=h;c[b+60>>2]=0;g[b+84>>2]=ea(3.0);g[b+76>>2]=ea(3.0);a[b+88>>0]=1;return}function SJc(b,d,e){b=b|0;d=d|0;e=e|0;c[b+40>>2]=d;c[b+44>>2]=0;c[b+48>>2]=e;c[b+52>>2]=0;c[b+60>>2]=0;g[b+84>>2]=ea(1.0e3);g[b+76>>2]=ea(1.0e3);a[b+88>>0]=0;return}function TJc(a,b){a=a|0;b=b|0;c[a+60>>2]=1;c[a+72>>2]=b;g[a+80>>2]=ea(0.0);g[a+84>>2]=ea(.100000001);return}function UJc(b,d){b=b|0;d=d|0;c[b+60>>2]=2;c[b+72>>2]=d;g[b+84>>2]=ea(1.0);g[b+80>>2]=ea(.189999998);g[b+76>>2]=ea(0.0);a[b+88>>0]=0;a[b+89>>0]=0;return}function VJc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f+4|0;h=f;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;j=a[d>>0]|0;if(!(j&1)){k=SEi(e|0)|0;l=(j&255)>>>1;m=d+1|0}else{j=c[d+4>>2]|0;n=SEi(e|0)|0;k=n;l=j;m=c[d+8>>2]|0}d=k+l|0;if(d>>>0>2147483631)ori(b);if(d>>>0<11){a[b>>0]=l<<1;o=b+1|0}else{j=d+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(j,16,g,0,3653512,80)|0;c[b+8>>2]=h;c[b>>2]=j|1;c[b+4>>2]=l;o=h}YEi(o|0,m|0,l|0)|0;a[o+l>>0]=0;l=a[b>>0]|0;if(!(l&1)){p=l;q=10}else{l=c[b>>2]|0;p=l&255;q=(l&-2)+-1|0}l=(p&1)==0;if(l)r=(p&255)>>>1;else r=c[b+4>>2]|0;if((q-r|0)>>>0<k>>>0){eXb(b,q,k-q+r|0,r,r,0,k,e);i=f;return}if(!k){i=f;return}if(l)s=b+1|0;else s=c[b+8>>2]|0;YEi(s+r|0,e|0,k|0)|0;e=r+k|0;if(!(a[b>>0]&1))a[b>>0]=e<<1;else c[b+4>>2]=e;a[s+e>>0]=0;i=f;return}function WJc(){var a=0;a=i;QQb(13,148,149,0,150);i=a;return}function XJc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,597456,12);wQb(13,6,b,180,2629,0,0);xri(b);i=a;return}function YJc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153108];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,317)|0;f=d+4|0;c[f>>2]=0;c[d+8>>2]=0;c[d>>2]=f;c[149478]=d;c[e>>2]=c[153108];c[b+0>>2]=c[e+0>>2];e=bOb(12,b,0,16,3653512,318)|0;b=e+4|0;c[b>>2]=0;c[e+8>>2]=0;c[e>>2]=b;c[149480]=e;pKc();i=a;return}function ZJc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[149478]|0;f=c[153108]|0;if(e)wKc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[149478]=0;e=c[149480]|0;f=c[153108]|0;if(!e){c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[149480]=0;i=a;return}PUb(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[149480]=0;i=a;return}function _Jc(a){a=a|0;return 13}function $Jc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,597456,a,0);KSb(a,b);ddd(b,2);xKc(b,a+24|0,600232,2048);bdd(b);i=c;return}function aKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,597456,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else yKc(a,b);sdd(b);i=d;return}function bKc(a,b){a=a|0;b=b|0;var c=0;c=i;MSb(a,b);zKc(b,a+24|0,0);i=c;return}function cKc(a,b){a=a|0;b=b|0;var c=0;c=i;NSb(a,b);AKc(b,a+24|0,0);i=c;return}function dKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;OSb(a,b);f=a+28|0;g=c[f>>2]|0;h=a+24|0;a=c[h>>2]|0;j=(g-a|0)/92|0;c[e>>2]=j;k=b+12|0;l=c[k>>2]|0;m=l+4|0;if(m>>>0<(c[b+20>>2]|0)>>>0){c[l>>2]=j;c[k>>2]=m;n=a;o=g}else{Gid(k,e,4);n=c[h>>2]|0;o=c[f>>2]|0}if((n|0)==(o|0)){i=d;return}else p=n;do{BKc(p,b);p=p+92|0}while((p|0)!=(o|0));i=d;return}function eKc(a,b){a=a|0;b=b|0;var c=0;c=i;PSb(a,b);idd(b,2048);jdd(b);i=c;return}function fKc(){var a=0,b=0;a=i;b=rVb(1)|0;i=a;return b|0}function gKc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;h=f+20|0;j=f+16|0;k=f+4|0;l=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];jSb(b,h,e);c[b>>2]=597480;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=0;e=b+36|0;c[e>>2]=0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+40>>2]=0;h=b+52|0;c[h>>2]=0;c[b+60>>2]=0;c[b+64>>2]=0;c[b+56>>2]=0;j=b+68|0;c[j>>2]=0;c[b+76>>2]=0;c[b+80>>2]=0;c[b+72>>2]=0;g[b+100>>2]=ea(0.0);g[b+104>>2]=ea(0.0);d=b+112|0;m=b+116|0;n=b+120|0;o=d+0|0;p=o+44|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));hKc(b);mRb(e,570,0);mRb(h,570,0);mRb(j,570,0);j=b+84|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;a[b+108>>0]=1;a[b+176>>0]=0;a[b+156>>0]=0;a[b+164>>0]=0;a[b+177>>0]=1;j=k+4|0;h=k+8|0;e=0;do{c[k>>2]=0;c[j>>2]=0;c[h>>2]=0;o=0;p=0;q=1;while(1){g[l>>2]=ea(0.0);if((o|0)==(p|0))_1b(k,l);else{if(o)g[o>>2]=ea(0.0);c[j>>2]=o+4}if((q|0)>=20)break;o=c[j>>2]|0;p=c[h>>2]|0;q=q+1|0}q=c[m>>2]|0;if((q|0)==(c[n>>2]|0))DKc(d,k);else{if(!q)r=0;else{CKc(q,k);r=c[m>>2]|0}c[m>>2]=r+12}q=c[k>>2]|0;if(q){p=c[j>>2]|0;if((p|0)!=(q|0))c[j>>2]=p+(~((p+-4-q|0)>>>2)<<2);ACi(q)}e=e+1|0}while((e|0)<12);a[b+157>>0]=1;c[b+160>>2]=0;i=f;return}function hKc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;d=i;i=i+1792|0;e=d+928|0;f=d+836|0;g=d+812|0;h=d+1604|0;j=d+1756|0;k=d+1732|0;l=d+300|0;m=d+312|0;n=d+324|0;o=d+336|0;p=d+348|0;q=d+360|0;r=d+372|0;s=d+384|0;t=d+476|0;u=d+488|0;v=d+580|0;w=d+592|0;x=d+684|0;y=d+696|0;z=d+1592|0;A=d+1696|0;B=d+1720|0;C=d+1744|0;D=d+1768|0;E=d+1780|0;F=d+932|0;G=d+944|0;H=d+956|0;I=d+1048|0;J=d+1060|0;K=d+1152|0;L=d+1164|0;M=d+1256|0;N=d+1268|0;O=d+1360|0;P=d+1372|0;Q=d+1464|0;R=d+1476|0;S=d+1568|0;T=d+208|0;U=d+184|0;V=d;W=d+196|0;X=d+92|0;Y=d+1580|0;Z=d+788|0;_=d+800|0;$=d+1708|0;aa=d+824|0;ba=b+24|0;rri(g,597680,10);PJc(f,g);ca=b+28|0;da=c[ca>>2]|0;ea=b+32|0;if((da|0)==(c[ea>>2]|0))GKc(ba,f);else{if(!da)fa=0;else{FKc(da,f);fa=c[ca>>2]|0}c[ca>>2]=fa+92}EKc(f);xri(g);rri(j,597696,8);PJc(h,j);g=c[ca>>2]|0;if((g|0)==(c[ea>>2]|0))GKc(ba,h);else{if(!g)ga=0;else{FKc(g,h);ga=c[ca>>2]|0}c[ca>>2]=ga+92}EKc(h);xri(j);j=c[ba>>2]|0;rri(k,2531152,5);bWb(e,c[149480]|0,k);h=c[e>>2]|0;if((h|0)==((c[149480]|0)+4|0))ha=0;else ha=c[h+28>>2]|0;rri(l,2531144,4);bWb(e,c[149480]|0,l);h=c[e>>2]|0;if((h|0)==((c[149480]|0)+4|0))ia=0;else ia=c[h+28>>2]|0;rri(m,3145312,1);bWb(e,c[149480]|0,m);h=c[e>>2]|0;if((h|0)==((c[149480]|0)+4|0))ja=0;else ja=c[h+28>>2]|0;rri(n,3145320,1);bWb(e,c[149480]|0,n);h=c[e>>2]|0;if((h|0)==((c[149480]|0)+4|0))ka=0;else ka=c[h+28>>2]|0;RJc(j,ha,ia,ja,ka);xri(n);xri(m);xri(l);xri(k);k=(c[ba>>2]|0)+92|0;rri(o,597712,2);bWb(e,c[149480]|0,o);l=c[e>>2]|0;if((l|0)==((c[149480]|0)+4|0))la=0;else la=c[l+28>>2]|0;rri(p,597720,4);bWb(e,c[149480]|0,p);l=c[e>>2]|0;if((l|0)==((c[149480]|0)+4|0))ma=0;else ma=c[l+28>>2]|0;rri(q,2419736,1);bWb(e,c[149480]|0,q);l=c[e>>2]|0;if((l|0)==((c[149480]|0)+4|0))na=0;else na=c[l+28>>2]|0;rri(r,3143208,1);bWb(e,c[149480]|0,r);l=c[e>>2]|0;if((l|0)==((c[149480]|0)+4|0))oa=0;else oa=c[l+28>>2]|0;RJc(k,la,ma,na,oa);xri(r);xri(q);xri(p);xri(o);rri(t,597728,5);PJc(s,t);o=c[ca>>2]|0;if((o|0)==(c[ea>>2]|0))GKc(ba,s);else{if(!o)pa=0;else{FKc(o,s);pa=c[ca>>2]|0}c[ca>>2]=pa+92}EKc(s);xri(t);rri(v,597736,5);PJc(u,v);t=c[ca>>2]|0;if((t|0)==(c[ea>>2]|0))GKc(ba,u);else{if(!t)qa=0;else{FKc(t,u);qa=c[ca>>2]|0}c[ca>>2]=qa+92}EKc(u);xri(v);rri(x,597744,5);PJc(w,x);v=c[ca>>2]|0;if((v|0)==(c[ea>>2]|0))GKc(ba,w);else{if(!v)ra=0;else{FKc(v,w);ra=c[ca>>2]|0}c[ca>>2]=ra+92}EKc(w);xri(x);rri(z,2279864,4);PJc(y,z);x=c[ca>>2]|0;if((x|0)==(c[ea>>2]|0))GKc(ba,y);else{if(!x)sa=0;else{FKc(x,y);sa=c[ca>>2]|0}c[ca>>2]=sa+92}EKc(y);xri(z);z=(c[ba>>2]|0)+184|0;rri(A,597752,9);bWb(e,c[149480]|0,A);y=c[e>>2]|0;if((y|0)==((c[149480]|0)+4|0))ta=0;else ta=c[y+28>>2]|0;rri(B,597768,7);bWb(e,c[149480]|0,B);y=c[e>>2]|0;if((y|0)==((c[149480]|0)+4|0))ua=0;else ua=c[y+28>>2]|0;SJc(z,ta,ua);xri(B);xri(A);A=(c[ba>>2]|0)+276|0;rri(C,597776,8);bWb(e,c[149480]|0,C);B=c[e>>2]|0;if((B|0)==((c[149480]|0)+4|0))va=0;else va=c[B+28>>2]|0;rri(D,597792,7);bWb(e,c[149480]|0,D);B=c[e>>2]|0;if((B|0)==((c[149480]|0)+4|0))wa=0;else wa=c[B+28>>2]|0;SJc(A,va,wa);xri(D);xri(C);C=(c[ba>>2]|0)+368|0;rri(E,597800,8);bWb(e,c[149480]|0,E);D=c[e>>2]|0;if((D|0)==((c[149480]|0)+4|0))xa=0;else xa=c[D+28>>2]|0;rri(F,597816,7);bWb(e,c[149480]|0,F);D=c[e>>2]|0;if((D|0)==((c[149480]|0)+4|0))ya=0;else ya=c[D+28>>2]|0;SJc(C,xa,ya);xri(F);xri(E);E=(c[ba>>2]|0)+460|0;rri(G,597632,5);bWb(e,c[149480]|0,G);F=c[e>>2]|0;if((F|0)==((c[149480]|0)+4|0))za=0;else za=c[F+28>>2]|0;SJc(E,za,0);xri(G);rri(I,597824,7);PJc(H,I);G=c[ca>>2]|0;if((G|0)==(c[ea>>2]|0))GKc(ba,H);else{if(!G)Aa=0;else{FKc(G,H);Aa=c[ca>>2]|0}c[ca>>2]=Aa+92}EKc(H);xri(I);rri(K,597832,7);PJc(J,K);I=c[ca>>2]|0;if((I|0)==(c[ea>>2]|0))GKc(ba,J);else{if(!I)Ba=0;else{FKc(I,J);Ba=c[ca>>2]|0}c[ca>>2]=Ba+92}EKc(J);xri(K);rri(M,597840,17);PJc(L,M);K=c[ca>>2]|0;if((K|0)==(c[ea>>2]|0))GKc(ba,L);else{if(!K)Ca=0;else{FKc(K,L);Ca=c[ca>>2]|0}c[ca>>2]=Ca+92}EKc(L);xri(M);TJc((c[ba>>2]|0)+552|0,0);TJc((c[ba>>2]|0)+644|0,1);TJc((c[ba>>2]|0)+736|0,2);rri(O,597680,10);PJc(N,O);M=c[ca>>2]|0;if((M|0)==(c[ea>>2]|0))GKc(ba,N);else{if(!M)Da=0;else{FKc(M,N);Da=c[ca>>2]|0}c[ca>>2]=Da+92}EKc(N);xri(O);rri(Q,597696,8);PJc(P,Q);O=c[ca>>2]|0;if((O|0)==(c[ea>>2]|0))GKc(ba,P);else{if(!O)Ea=0;else{FKc(O,P);Ea=c[ca>>2]|0}c[ca>>2]=Ea+92}EKc(P);xri(Q);UJc((c[ba>>2]|0)+828|0,0);UJc((c[ba>>2]|0)+920|0,1);a[(c[ba>>2]|0)+1009>>0]=1;rri(S,597728,5);PJc(R,S);Q=c[ca>>2]|0;if((Q|0)==(c[ea>>2]|0))GKc(ba,R);else{if(!Q)Fa=0;else{FKc(Q,R);Fa=c[ca>>2]|0}c[ca>>2]=Fa+92}EKc(R);xri(S);rri(U,597736,5);PJc(T,U);S=c[ca>>2]|0;if((S|0)==(c[ea>>2]|0))GKc(ba,T);else{if(!S)Ga=0;else{FKc(S,T);Ga=c[ca>>2]|0}c[ca>>2]=Ga+92}EKc(T);xri(U);rri(W,597744,5);PJc(V,W);U=c[ca>>2]|0;if((U|0)==(c[ea>>2]|0))GKc(ba,V);else{if(!U)Ha=0;else{FKc(U,V);Ha=c[ca>>2]|0}c[ca>>2]=Ha+92}EKc(V);xri(W);rri(Y,2279864,4);PJc(X,Y);W=c[ca>>2]|0;if((W|0)==(c[ea>>2]|0))GKc(ba,X);else{if(!W)Ia=0;else{FKc(W,X);Ia=c[ca>>2]|0}c[ca>>2]=Ia+92}EKc(X);xri(Y);Y=(c[ba>>2]|0)+1012|0;rri(Z,597600,17);bWb(e,c[149480]|0,Z);X=c[e>>2]|0;if((X|0)==((c[149480]|0)+4|0))Ja=0;else Ja=c[X+28>>2]|0;SJc(Y,Ja,0);xri(Z);Z=(c[ba>>2]|0)+1104|0;rri(_,597656,17);bWb(e,c[149480]|0,_);Ja=c[e>>2]|0;if((Ja|0)==((c[149480]|0)+4|0))Ka=0;else Ka=c[Ja+28>>2]|0;SJc(Z,Ka,0);xri(_);_=(c[ba>>2]|0)+1196|0;rri($,597864,17);bWb(e,c[149480]|0,$);Ka=c[e>>2]|0;if((Ka|0)==((c[149480]|0)+4|0))La=0;else La=c[Ka+28>>2]|0;SJc(_,La,0);xri($);$=(c[ba>>2]|0)+1288|0;rri(aa,597888,17);bWb(e,c[149480]|0,aa);La=c[e>>2]|0;if((La|0)==((c[149480]|0)+4|0)){Ma=0;SJc($,Ma,0);xri(aa);jKc(ba);i=d;return}Ma=c[La+28>>2]|0;SJc($,Ma,0);xri(aa);jKc(ba);i=d;return}function iKc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b+24>>2]|0;f=b+28|0;g=c[f>>2]|0;if((g|0)!=(e|0)){h=g;do{g=h+-92|0;c[f>>2]=g;EKc(g);h=c[f>>2]|0}while((h|0)!=(e|0))}e=b+136|0;if(!(a[e>>0]&1)){a[e+1>>0]=0;a[e>>0]=0;hKc(b);i=d;return}else{a[c[b+144>>2]>>0]=0;c[b+140>>2]=0;hKc(b);i=d;return}}function jKc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=i;i=i+400|0;d=b+372|0;e=b+188|0;f=b+60|0;g=b+48|0;h=b+176|0;j=b+280|0;k=b+376|0;l=b+24|0;m=b+12|0;n=b+72|0;o=b+36|0;p=b+164|0;q=b;r=a+4|0;s=((c[r>>2]|0)-(c[a>>2]|0)|0)/92|0;rri(f,597584,6);PJc(e,f);t=c[r>>2]|0;u=a+8|0;if((t|0)==(c[u>>2]|0))GKc(a,e);else{if(!t)v=0;else{FKc(t,e);v=c[r>>2]|0}c[r>>2]=v+92}EKc(e);xri(f);f=s+1|0;e=(c[a>>2]|0)+(s*92|0)|0;rri(g,597592,6);bWb(d,c[149480]|0,g);v=c[d>>2]|0;if((v|0)==((c[149480]|0)+4|0))w=0;else w=c[v+28>>2]|0;rri(h,597600,17);bWb(d,c[149480]|0,h);v=c[d>>2]|0;if((v|0)==((c[149480]|0)+4|0))x=0;else x=c[v+28>>2]|0;SJc(e,w,x);xri(h);xri(g);rri(k,597584,6);PJc(j,k);g=c[r>>2]|0;if((g|0)==(c[u>>2]|0))GKc(a,j);else{if(!g)y=0;else{FKc(g,j);y=c[r>>2]|0}c[r>>2]=y+92}EKc(j);xri(k);k=s+2|0;s=(c[a>>2]|0)+(f*92|0)|0;rri(l,597624,5);bWb(d,c[149480]|0,l);f=c[d>>2]|0;if((f|0)==((c[149480]|0)+4|0))z=0;else z=c[f+28>>2]|0;rri(m,597632,5);bWb(d,c[149480]|0,m);f=c[d>>2]|0;if((f|0)==((c[149480]|0)+4|0))A=0;else A=c[f+28>>2]|0;SJc(s,z,A);xri(m);xri(l);rri(o,597640,6);PJc(n,o);l=c[r>>2]|0;if((l|0)==(c[u>>2]|0))GKc(a,n);else{if(!l)B=0;else{FKc(l,n);B=c[r>>2]|0}c[r>>2]=B+92}EKc(n);xri(o);o=(c[a>>2]|0)+(k*92|0)|0;rri(p,597648,6);bWb(d,c[149480]|0,p);k=c[d>>2]|0;if((k|0)==((c[149480]|0)+4|0))C=0;else C=c[k+28>>2]|0;rri(q,597656,17);bWb(d,c[149480]|0,q);k=c[d>>2]|0;if((k|0)==((c[149480]|0)+4|0)){D=0;SJc(o,C,D);xri(q);xri(p);i=b;return}D=c[k+28>>2]|0;SJc(o,C,D);xri(q);xri(p);i=b;return}function kKc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;bWb(d,c[149480]|0,a);a=c[d>>2]|0;if((a|0)==((c[149480]|0)+4|0)){e=0;i=b;return e|0}e=c[a+28>>2]|0;i=b;return e|0}function lKc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0;b=i;d=c[a+24>>2]|0;e=c[a+28>>2]|0;if((d|0)!=(e|0)){f=d;do{g[f+64>>2]=ea(0.0);g[f+68>>2]=ea(0.0);f=f+92|0}while((f|0)!=(e|0))}if(c[a+44>>2]|0)PEi(c[a+40>>2]|0,0,c[a+48>>2]<<2|0)|0;if(c[a+60>>2]|0)PEi(c[a+56>>2]|0,0,c[a+64>>2]<<2|0)|0;if(c[a+76>>2]|0)PEi(c[a+72>>2]|0,0,c[a+80>>2]<<2|0)|0;e=c[a+116>>2]|0;f=c[a+112>>2]|0;if((e|0)==(f|0)){h=a+84|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;i=b;return}d=(e-f|0)/12|0;e=0;do{j=c[f+(e*12|0)+4>>2]|0;k=c[f+(e*12|0)>>2]|0;if((j|0)!=(k|0)){l=j-k|0;PEi(k|0,0,(l>>2>>>0>1?l:4)|0)|0}e=e+1|0}while(e>>>0<d>>>0);h=a+84|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;i=b;return}function mKc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0;b=i;d=c[a+24>>2]|0;e=c[a+28>>2]|0;if((d|0)!=(e|0)){f=d;do{g[f+64>>2]=ea(0.0);g[f+68>>2]=ea(0.0);f=f+92|0}while((f|0)!=(e|0))}if(c[a+44>>2]|0)PEi(c[a+40>>2]|0,0,c[a+48>>2]<<2|0)|0;if(c[a+60>>2]|0)PEi(c[a+56>>2]|0,0,c[a+64>>2]<<2|0)|0;if(c[a+76>>2]|0)PEi(c[a+72>>2]|0,0,c[a+80>>2]<<2|0)|0;e=c[a+116>>2]|0;f=c[a+112>>2]|0;if((e|0)==(f|0)){h=a+84|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;i=b;return}d=(e-f|0)/12|0;e=0;do{j=c[f+(e*12|0)+4>>2]|0;k=c[f+(e*12|0)>>2]|0;if((j|0)!=(k|0)){l=j-k>>2;j=0;do{g[k+(j<<2)>>2]=ea(0.0);j=j+1|0}while(j>>>0<l>>>0)}e=e+1|0}while(e>>>0<d>>>0);h=a+84|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;i=b;return}function nKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;f=c[a+112>>2]|0;if((((c[a+116>>2]|0)-f|0)/12|0|0)<=(b|0)){h=ea(0.0);i=e;return ea(h)}a=c[f+(b*12|0)>>2]|0;if(((c[f+(b*12|0)+4>>2]|0)-a>>2|0)<=(d|0)){h=ea(0.0);i=e;return ea(h)}h=ea(g[a+(d<<2)>>2]);i=e;return ea(h)}function oKc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0;f=i;h=c[a+112>>2]|0;if((((c[a+116>>2]|0)-h|0)/12|0|0)<=(b|0)){i=f;return}a=c[h+(b*12|0)>>2]|0;if(((c[h+(b*12|0)+4>>2]|0)-a>>2|0)<=(d|0)){i=f;return}g[a+(d<<2)>>2]=e;i=f;return}function pKc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0,Vm=0,Wm=0,Xm=0,Ym=0,Zm=0,_m=0,$m=0,an=0,bn=0,cn=0,dn=0,en=0,fn=0,gn=0,hn=0,jn=0,kn=0,ln=0,mn=0,nn=0,on=0,pn=0,qn=0,rn=0,sn=0,tn=0,un=0,vn=0,wn=0,xn=0,yn=0,zn=0,An=0,Bn=0,Cn=0,Dn=0,En=0,Fn=0,Gn=0,Hn=0,In=0,Jn=0,Kn=0,Ln=0,Mn=0,Nn=0,On=0,Pn=0,Qn=0,Rn=0,Sn=0,Tn=0,Un=0,Vn=0,Wn=0,Xn=0,Yn=0,Zn=0,_n=0,$n=0,ao=0,bo=0,co=0,eo=0,fo=0,go=0,ho=0,io=0,jo=0,ko=0,lo=0,mo=0,no=0,oo=0,po=0,qo=0,ro=0,so=0,to=0,uo=0,vo=0,wo=0,xo=0,yo=0,zo=0,Ao=0,Bo=0,Co=0,Do=0,Eo=0,Fo=0,Go=0,Ho=0,Io=0,Jo=0,Ko=0,Lo=0,Mo=0,No=0,Oo=0,Po=0,Qo=0,Ro=0,So=0,To=0,Uo=0,Vo=0,Wo=0,Xo=0,Yo=0,Zo=0,_o=0,$o=0,ap=0,bp=0,cp=0,dp=0,ep=0,fp=0,gp=0,hp=0,ip=0,jp=0,kp=0,lp=0,mp=0,np=0,op=0,pp=0,qp=0,rp=0,sp=0,tp=0,up=0,vp=0,wp=0,xp=0,yp=0,zp=0,Ap=0,Bp=0,Cp=0,Dp=0,Ep=0,Fp=0,Gp=0,Hp=0,Ip=0,Jp=0,Kp=0,Lp=0,Mp=0,Np=0,Op=0,Pp=0,Qp=0,Rp=0,Sp=0,Tp=0,Up=0,Vp=0,Wp=0,Xp=0,Yp=0,Zp=0,_p=0,$p=0,aq=0,bq=0,cq=0,dq=0,eq=0,fq=0,gq=0,hq=0,iq=0,jq=0,kq=0,lq=0,mq=0,nq=0,oq=0,pq=0,qq=0,rq=0,sq=0,tq=0,uq=0,vq=0,wq=0,xq=0,yq=0,zq=0,Aq=0,Bq=0,Cq=0,Dq=0,Eq=0,Fq=0,Gq=0,Hq=0,Iq=0,Jq=0,Kq=0,Lq=0,Mq=0,Nq=0,Oq=0,Pq=0,Qq=0,Rq=0,Sq=0,Tq=0,Uq=0,Vq=0,Wq=0,Xq=0,Yq=0,Zq=0,_q=0,$q=0,ar=0,br=0,cr=0,dr=0,er=0,fr=0,gr=0,hr=0,ir=0,jr=0,kr=0,lr=0,mr=0,nr=0,or=0,pr=0,qr=0,rr=0,sr=0,tr=0,ur=0,vr=0,wr=0,xr=0,yr=0,zr=0,Ar=0,Br=0,Cr=0,Dr=0,Er=0,Fr=0,Gr=0,Hr=0,Ir=0,Jr=0,Kr=0,Lr=0,Mr=0,Nr=0,Or=0,Pr=0,Qr=0,Rr=0,Sr=0,Tr=0,Ur=0,Vr=0,Wr=0,Xr=0,Yr=0,Zr=0,_r=0,$r=0,as=0,bs=0,cs=0,ds=0,es=0,fs=0,gs=0,hs=0,is=0,js=0,ks=0,ls=0,ms=0,ns=0,os=0,ps=0,qs=0,rs=0,ss=0,ts=0,us=0,vs=0,ws=0,xs=0,ys=0,zs=0,As=0,Bs=0,Cs=0,Ds=0,Es=0,Fs=0,Gs=0,Hs=0,Is=0,Js=0,Ks=0,Ls=0,Ms=0,Ns=0,Os=0,Ps=0,Qs=0,Rs=0,Ss=0,Ts=0,Us=0,Vs=0,Ws=0,Xs=0,Ys=0,Zs=0,_s=0,$s=0,at=0,bt=0,ct=0,dt=0,et=0,ft=0,gt=0,ht=0,it=0,jt=0,kt=0,lt=0,mt=0,nt=0,ot=0,pt=0,qt=0,rt=0,st=0,tt=0,ut=0,vt=0,wt=0,xt=0,yt=0,zt=0,At=0,Bt=0,Ct=0,Dt=0,Et=0,Ft=0,Gt=0,Ht=0,It=0,Jt=0,Kt=0,Lt=0,Mt=0,Nt=0,Ot=0,Pt=0,Qt=0,Rt=0,St=0,Tt=0,Ut=0,Vt=0,Wt=0,Xt=0,Yt=0,Zt=0,_t=0,$t=0,au=0,bu=0,cu=0,du=0,eu=0,fu=0,gu=0,hu=0,iu=0,ju=0,ku=0,lu=0,mu=0,nu=0,ou=0,pu=0,qu=0,ru=0,su=0,tu=0,uu=0,vu=0,wu=0,xu=0,yu=0,zu=0,Au=0,Bu=0,Cu=0,Du=0,Eu=0,Fu=0,Gu=0,Hu=0,Iu=0,Ju=0,Ku=0,Lu=0,Mu=0,Nu=0,Ou=0,Pu=0,Qu=0,Ru=0,Su=0,Tu=0,Uu=0,Vu=0,Wu=0,Xu=0,Yu=0,Zu=0,_u=0,$u=0,av=0,bv=0,cv=0,dv=0,ev=0,fv=0,gv=0,hv=0,iv=0,jv=0,kv=0,lv=0,mv=0,nv=0,ov=0,pv=0,qv=0,rv=0,sv=0,tv=0,uv=0,vv=0,wv=0,xv=0,yv=0,zv=0,Av=0,Bv=0,Cv=0,Dv=0,Ev=0,Fv=0,Gv=0,Hv=0,Iv=0,Jv=0,Kv=0,Lv=0,Mv=0,Nv=0,Ov=0,Pv=0,Qv=0,Rv=0,Sv=0,Tv=0,Uv=0,Vv=0,Wv=0,Xv=0,Yv=0,Zv=0,_v=0,$v=0,aw=0,bw=0,cw=0,dw=0,ew=0,fw=0,gw=0,hw=0,iw=0,jw=0,kw=0,lw=0,mw=0,nw=0,ow=0,pw=0,qw=0,rw=0,sw=0,tw=0,uw=0,vw=0,ww=0,xw=0,yw=0,zw=0,Aw=0,Bw=0,Cw=0,Dw=0,Ew=0,Fw=0,Gw=0,Hw=0,Iw=0,Jw=0,Kw=0,Lw=0,Mw=0,Nw=0,Ow=0,Pw=0,Qw=0,Rw=0,Sw=0,Tw=0,Uw=0,Vw=0,Ww=0,Xw=0,Yw=0,Zw=0,_w=0,$w=0,ax=0,bx=0,cx=0,dx=0,ex=0,fx=0,gx=0,hx=0,ix=0,jx=0,kx=0,lx=0,mx=0,nx=0,ox=0,px=0,qx=0,rx=0,sx=0,tx=0,ux=0,vx=0,wx=0,xx=0,yx=0,zx=0,Ax=0,Bx=0,Cx=0,Dx=0,Ex=0,Fx=0,Gx=0,Hx=0,Ix=0,Jx=0,Kx=0,Lx=0,Mx=0,Nx=0,Ox=0,Px=0,Qx=0,Rx=0,Sx=0,Tx=0,Ux=0,Vx=0,Wx=0,Xx=0,Yx=0,Zx=0,_x=0,$x=0,ay=0,by=0,cy=0,dy=0,ey=0,fy=0,gy=0,hy=0,iy=0,jy=0,ky=0,ly=0,my=0,ny=0,oy=0,py=0,qy=0,ry=0,sy=0,ty=0,uy=0,vy=0,wy=0,xy=0,yy=0,zy=0,Ay=0,By=0,Cy=0,Dy=0,Ey=0,Fy=0,Gy=0,Hy=0,Iy=0,Jy=0,Ky=0,Ly=0,My=0,Ny=0,Oy=0,Py=0,Qy=0,Ry=0,Sy=0,Ty=0,Uy=0,Vy=0,Wy=0,Xy=0,Yy=0,Zy=0,_y=0,$y=0,az=0,bz=0,cz=0,dz=0,ez=0,fz=0,gz=0,hz=0,iz=0,jz=0,kz=0,lz=0,mz=0,nz=0,oz=0,pz=0,qz=0,rz=0,sz=0,tz=0,uz=0,vz=0,wz=0,xz=0,yz=0,zz=0,Az=0,Bz=0,Cz=0,Dz=0,Ez=0,Fz=0,Gz=0,Hz=0,Iz=0,Jz=0,Kz=0,Lz=0,Mz=0,Nz=0,Oz=0,Pz=0,Qz=0,Rz=0,Sz=0,Tz=0,Uz=0,Vz=0,Wz=0,Xz=0,Yz=0,Zz=0,_z=0,$z=0,aA=0,bA=0,cA=0,dA=0,eA=0,fA=0,gA=0,hA=0,iA=0,jA=0,kA=0,lA=0,mA=0,nA=0,oA=0,pA=0,qA=0,rA=0,sA=0,tA=0,uA=0,vA=0,wA=0,xA=0,yA=0,zA=0,AA=0,BA=0,CA=0,DA=0,EA=0,FA=0,GA=0,HA=0,IA=0,JA=0,KA=0,LA=0,MA=0,NA=0,OA=0,PA=0,QA=0,RA=0,SA=0,TA=0,UA=0,VA=0,WA=0,XA=0,YA=0,ZA=0,_A=0,$A=0,aB=0,bB=0,cB=0,dB=0,eB=0,fB=0,gB=0,hB=0,iB=0,jB=0,kB=0,lB=0,mB=0,nB=0,oB=0,pB=0,qB=0,rB=0,sB=0,tB=0,uB=0,vB=0,wB=0,xB=0,yB=0,zB=0,AB=0,BB=0,CB=0,DB=0,EB=0,FB=0,GB=0,HB=0,IB=0,JB=0,KB=0,LB=0,MB=0,NB=0,OB=0,PB=0,QB=0,RB=0,SB=0,TB=0,UB=0,VB=0,WB=0,XB=0,YB=0,ZB=0,_B=0,$B=0,aC=0,bC=0,cC=0,dC=0,eC=0,fC=0,gC=0,hC=0,iC=0,jC=0,kC=0,lC=0,mC=0,nC=0,oC=0,pC=0,qC=0,rC=0,sC=0,tC=0,uC=0,vC=0,wC=0,xC=0,yC=0,zC=0,AC=0,BC=0,CC=0,DC=0,EC=0,FC=0,GC=0,HC=0,IC=0,JC=0,KC=0,LC=0,MC=0,NC=0,OC=0,PC=0,QC=0,RC=0,SC=0,TC=0,UC=0,VC=0,WC=0,XC=0,YC=0,ZC=0,_C=0,$C=0,aD=0,bD=0,cD=0,dD=0,eD=0,fD=0,gD=0,hD=0,iD=0,jD=0,kD=0,lD=0,mD=0,nD=0,oD=0,pD=0,qD=0,rD=0,sD=0,tD=0,uD=0,vD=0,wD=0,xD=0,yD=0,zD=0,AD=0,BD=0,CD=0,DD=0,ED=0,FD=0,GD=0,HD=0,ID=0,JD=0,KD=0,LD=0,MD=0,ND=0,OD=0,PD=0,QD=0,RD=0,SD=0,TD=0,UD=0,VD=0,WD=0,XD=0,YD=0,ZD=0,_D=0,$D=0,aE=0,bE=0,cE=0,dE=0,eE=0,fE=0,gE=0,hE=0,iE=0,jE=0,kE=0,lE=0,mE=0,nE=0,oE=0,pE=0,qE=0,rE=0,sE=0,tE=0,uE=0,vE=0,wE=0,xE=0,yE=0,zE=0,AE=0,BE=0,CE=0,DE=0,EE=0,FE=0,GE=0,HE=0,IE=0,JE=0,KE=0,LE=0,ME=0,NE=0,OE=0,PE=0,QE=0,RE=0,SE=0,TE=0,UE=0,VE=0,WE=0,XE=0,YE=0,ZE=0,_E=0,$E=0,aF=0,bF=0,cF=0,dF=0,eF=0,fF=0,gF=0,hF=0,iF=0,jF=0,kF=0,lF=0,mF=0,nF=0,oF=0,pF=0,qF=0,rF=0,sF=0,tF=0,uF=0,vF=0,wF=0,xF=0,yF=0,zF=0,AF=0,BF=0,CF=0,DF=0,EF=0,FF=0,GF=0,HF=0,IF=0,JF=0,KF=0,LF=0,MF=0,NF=0,OF=0,PF=0,QF=0,RF=0,SF=0,TF=0,UF=0,VF=0,WF=0,XF=0,YF=0,ZF=0,_F=0,$F=0,aG=0,bG=0,cG=0,dG=0,eG=0,fG=0,gG=0,hG=0,iG=0,jG=0,kG=0,lG=0,mG=0,nG=0,oG=0,pG=0,qG=0,rG=0,sG=0,tG=0,uG=0,vG=0,wG=0,xG=0,yG=0,zG=0,AG=0,BG=0,CG=0,DG=0,EG=0,FG=0,GG=0,HG=0,IG=0,JG=0,KG=0,LG=0,MG=0,NG=0,OG=0,PG=0,QG=0,RG=0,SG=0,TG=0,UG=0,VG=0,WG=0,XG=0,YG=0,ZG=0,_G=0,$G=0,aH=0,bH=0,cH=0,dH=0,eH=0,fH=0,gH=0,hH=0,iH=0,jH=0,kH=0,lH=0,mH=0,nH=0,oH=0,pH=0,qH=0,rH=0,sH=0,tH=0,uH=0,vH=0,wH=0,xH=0,yH=0,zH=0,AH=0,BH=0,CH=0,DH=0,EH=0,FH=0,GH=0,HH=0,IH=0,JH=0,KH=0,LH=0,MH=0,NH=0,OH=0,PH=0,QH=0,RH=0,SH=0,TH=0,UH=0,VH=0,WH=0,XH=0,YH=0,ZH=0,_H=0,$H=0,aI=0,bI=0,cI=0,dI=0,eI=0,fI=0,gI=0,hI=0,iI=0,jI=0,kI=0,lI=0,mI=0,nI=0,oI=0,pI=0,qI=0,rI=0,sI=0,tI=0,uI=0,vI=0,wI=0,xI=0,yI=0,zI=0,AI=0,BI=0,CI=0,DI=0,EI=0,FI=0,GI=0,HI=0,II=0,JI=0,KI=0,LI=0,MI=0,NI=0,OI=0,PI=0,QI=0,RI=0,SI=0,TI=0,UI=0,VI=0,WI=0,XI=0,YI=0,ZI=0,_I=0,$I=0,aJ=0,bJ=0,cJ=0,dJ=0,eJ=0,fJ=0,gJ=0,hJ=0,iJ=0,jJ=0,kJ=0,lJ=0,mJ=0,nJ=0,oJ=0,pJ=0,qJ=0,rJ=0,sJ=0,tJ=0,uJ=0,vJ=0,wJ=0,xJ=0,yJ=0,zJ=0,AJ=0,BJ=0,CJ=0,DJ=0,EJ=0,FJ=0,GJ=0,HJ=0,IJ=0,JJ=0,KJ=0,LJ=0,MJ=0,NJ=0,OJ=0,PJ=0,QJ=0,RJ=0,SJ=0,TJ=0,UJ=0,VJ=0,WJ=0,XJ=0,YJ=0,ZJ=0,_J=0,$J=0,aK=0,bK=0,cK=0,dK=0,eK=0,fK=0,gK=0,hK=0,iK=0,jK=0,kK=0,lK=0,mK=0,nK=0,oK=0,pK=0,qK=0,rK=0,sK=0,tK=0,uK=0,vK=0,wK=0,xK=0,yK=0,zK=0,AK=0,BK=0,CK=0,DK=0,EK=0,FK=0,GK=0,HK=0,IK=0,JK=0,KK=0,LK=0,MK=0,NK=0,OK=0,PK=0,QK=0,RK=0,SK=0,TK=0,UK=0,VK=0,WK=0,XK=0,YK=0,ZK=0,_K=0,$K=0,aL=0,bL=0,cL=0,dL=0,eL=0,fL=0,gL=0,hL=0,iL=0,jL=0,kL=0,lL=0,mL=0,nL=0,oL=0,pL=0,qL=0,rL=0,sL=0,tL=0,uL=0,vL=0,wL=0,xL=0,yL=0,zL=0,AL=0,BL=0,CL=0,DL=0,EL=0,FL=0,GL=0,HL=0,IL=0,JL=0,KL=0,LL=0,ML=0,NL=0,OL=0,PL=0,QL=0,RL=0,SL=0,TL=0,UL=0,VL=0,WL=0,XL=0,YL=0,ZL=0,_L=0,$L=0,aM=0,bM=0,cM=0,dM=0,eM=0,fM=0,gM=0,hM=0,iM=0,jM=0,kM=0,lM=0,mM=0,nM=0,oM=0,pM=0,qM=0,rM=0,sM=0,tM=0,uM=0,vM=0,wM=0,xM=0,yM=0,zM=0,AM=0,BM=0,CM=0,DM=0,EM=0,FM=0,GM=0,HM=0,IM=0,JM=0,KM=0,LM=0,MM=0,NM=0,OM=0,PM=0,QM=0,RM=0,SM=0,TM=0,UM=0,VM=0,WM=0,XM=0,YM=0,ZM=0,_M=0,$M=0,aN=0,bN=0,cN=0,dN=0,eN=0,fN=0,gN=0,hN=0,iN=0,jN=0,kN=0,lN=0,mN=0,nN=0,oN=0,pN=0,qN=0,rN=0;b=i;i=i+112|0;d=b;e=b+8|0;if(a[597928]|0){i=b;return}a[597928]=1;f=c[149478]|0;g=f+4|0;h=c[g>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if((k|0)>8){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if((k|0)>=8){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[d>>2]=n;s=m;t=n;break}else if((o|0)==8){c[d>>2]=r;s=q;t=r;break}else if((o|0)==9){c[d>>2]=p;s=d;t=p;break}}else{j=f+4|0;c[d>>2]=j;s=j;t=j}while(0);p=c[s>>2]|0;if(!p){r=xCi(32)|0;c[r+16>>2]=8;q=r+20|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=t;c[s>>2]=r;t=c[c[f>>2]>>2]|0;if(!t)u=r;else{c[f>>2]=t;u=c[s>>2]|0}GN(c[g>>2]|0,u);u=f+8|0;c[u>>2]=(c[u>>2]|0)+1;v=r}else v=p;zri(v+20|0,597936)|0;v=c[149478]|0;p=v+4|0;r=c[p>>2]|0;do if(r){u=r;while(1){f=c[u+16>>2]|0;if((f|0)>9){g=c[u>>2]|0;if(!g){w=u;x=u;o=18;break}else{u=g;continue}}if((f|0)>=9){y=u;o=22;break}f=u+4|0;g=c[f>>2]|0;if(!g){z=f;A=u;o=21;break}else u=g}if((o|0)==18){c[d>>2]=x;B=w;C=x;break}else if((o|0)==21){c[d>>2]=A;B=z;C=A;break}else if((o|0)==22){c[d>>2]=y;B=d;C=y;break}}else{u=v+4|0;c[d>>2]=u;B=u;C=u}while(0);y=c[B>>2]|0;if(!y){A=xCi(32)|0;c[A+16>>2]=9;z=A+20|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=C;c[B>>2]=A;C=c[c[v>>2]>>2]|0;if(!C)D=A;else{c[v>>2]=C;D=c[B>>2]|0}GN(c[p>>2]|0,D);D=v+8|0;c[D>>2]=(c[D>>2]|0)+1;E=A}else E=y;zri(E+20|0,597952)|0;E=c[149478]|0;y=E+4|0;A=c[y>>2]|0;do if(A){D=A;while(1){v=c[D+16>>2]|0;if((v|0)>12){p=c[D>>2]|0;if(!p){F=D;G=D;o=31;break}else{D=p;continue}}if((v|0)>=12){H=D;o=35;break}v=D+4|0;p=c[v>>2]|0;if(!p){I=v;J=D;o=34;break}else D=p}if((o|0)==31){c[d>>2]=G;K=F;L=G;break}else if((o|0)==34){c[d>>2]=J;K=I;L=J;break}else if((o|0)==35){c[d>>2]=H;K=d;L=H;break}}else{D=E+4|0;c[d>>2]=D;K=D;L=D}while(0);H=c[K>>2]|0;if(!H){J=xCi(32)|0;c[J+16>>2]=12;I=J+20|0;c[I+0>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=L;c[K>>2]=J;L=c[c[E>>2]>>2]|0;if(!L)M=J;else{c[E>>2]=L;M=c[K>>2]|0}GN(c[y>>2]|0,M);M=E+8|0;c[M>>2]=(c[M>>2]|0)+1;N=J}else N=H;zri(N+20|0,597960)|0;N=c[149478]|0;H=N+4|0;J=c[H>>2]|0;do if(J){M=J;while(1){E=c[M+16>>2]|0;if((E|0)>13){y=c[M>>2]|0;if(!y){O=M;P=M;o=44;break}else{M=y;continue}}if((E|0)>=13){Q=M;o=48;break}E=M+4|0;y=c[E>>2]|0;if(!y){R=E;S=M;o=47;break}else M=y}if((o|0)==44){c[d>>2]=P;T=O;U=P;break}else if((o|0)==47){c[d>>2]=S;T=R;U=S;break}else if((o|0)==48){c[d>>2]=Q;T=d;U=Q;break}}else{M=N+4|0;c[d>>2]=M;T=M;U=M}while(0);Q=c[T>>2]|0;if(!Q){S=xCi(32)|0;c[S+16>>2]=13;R=S+20|0;c[R+0>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;c[S>>2]=0;c[S+4>>2]=0;c[S+8>>2]=U;c[T>>2]=S;U=c[c[N>>2]>>2]|0;if(!U)V=S;else{c[N>>2]=U;V=c[T>>2]|0}GN(c[H>>2]|0,V);V=N+8|0;c[V>>2]=(c[V>>2]|0)+1;W=S}else W=Q;zri(W+20|0,597592)|0;W=c[149478]|0;Q=W+4|0;S=c[Q>>2]|0;do if(S){V=S;while(1){N=c[V+16>>2]|0;if((N|0)>19){H=c[V>>2]|0;if(!H){X=V;Y=V;o=57;break}else{V=H;continue}}if((N|0)>=19){Z=V;o=61;break}N=V+4|0;H=c[N>>2]|0;if(!H){_=N;$=V;o=60;break}else V=H}if((o|0)==57){c[d>>2]=Y;aa=X;ba=Y;break}else if((o|0)==60){c[d>>2]=$;aa=_;ba=$;break}else if((o|0)==61){c[d>>2]=Z;aa=d;ba=Z;break}}else{V=W+4|0;c[d>>2]=V;aa=V;ba=V}while(0);Z=c[aa>>2]|0;if(!Z){$=xCi(32)|0;c[$+16>>2]=19;_=$+20|0;c[_+0>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;c[$>>2]=0;c[$+4>>2]=0;c[$+8>>2]=ba;c[aa>>2]=$;ba=c[c[W>>2]>>2]|0;if(!ba)ca=$;else{c[W>>2]=ba;ca=c[aa>>2]|0}GN(c[Q>>2]|0,ca);ca=W+8|0;c[ca>>2]=(c[ca>>2]|0)+1;da=$}else da=Z;zri(da+20|0,597968)|0;da=c[149478]|0;Z=da+4|0;$=c[Z>>2]|0;do if($){ca=$;while(1){W=c[ca+16>>2]|0;if((W|0)>27){Q=c[ca>>2]|0;if(!Q){ea=ca;fa=ca;o=70;break}else{ca=Q;continue}}if((W|0)>=27){ga=ca;o=74;break}W=ca+4|0;Q=c[W>>2]|0;if(!Q){ha=W;ia=ca;o=73;break}else ca=Q}if((o|0)==70){c[d>>2]=fa;ja=ea;ka=fa;break}else if((o|0)==73){c[d>>2]=ia;ja=ha;ka=ia;break}else if((o|0)==74){c[d>>2]=ga;ja=d;ka=ga;break}}else{ca=da+4|0;c[d>>2]=ca;ja=ca;ka=ca}while(0);ga=c[ja>>2]|0;if(!ga){ia=xCi(32)|0;c[ia+16>>2]=27;ha=ia+20|0;c[ha+0>>2]=0;c[ha+4>>2]=0;c[ha+8>>2]=0;c[ia>>2]=0;c[ia+4>>2]=0;c[ia+8>>2]=ka;c[ja>>2]=ia;ka=c[c[da>>2]>>2]|0;if(!ka)la=ia;else{c[da>>2]=ka;la=c[ja>>2]|0}GN(c[Z>>2]|0,la);la=da+8|0;c[la>>2]=(c[la>>2]|0)+1;ma=ia}else ma=ga;zri(ma+20|0,597648)|0;ma=c[149478]|0;ga=ma+4|0;ia=c[ga>>2]|0;do if(ia){la=ia;while(1){da=c[la+16>>2]|0;if((da|0)>32){Z=c[la>>2]|0;if(!Z){na=la;oa=la;o=83;break}else{la=Z;continue}}if((da|0)>=32){pa=la;o=87;break}da=la+4|0;Z=c[da>>2]|0;if(!Z){qa=da;ra=la;o=86;break}else la=Z}if((o|0)==83){c[d>>2]=oa;sa=na;ta=oa;break}else if((o|0)==86){c[d>>2]=ra;sa=qa;ta=ra;break}else if((o|0)==87){c[d>>2]=pa;sa=d;ta=pa;break}}else{la=ma+4|0;c[d>>2]=la;sa=la;ta=la}while(0);pa=c[sa>>2]|0;if(!pa){ra=xCi(32)|0;c[ra+16>>2]=32;qa=ra+20|0;c[qa+0>>2]=0;c[qa+4>>2]=0;c[qa+8>>2]=0;c[ra>>2]=0;c[ra+4>>2]=0;c[ra+8>>2]=ta;c[sa>>2]=ra;ta=c[c[ma>>2]>>2]|0;if(!ta)ua=ra;else{c[ma>>2]=ta;ua=c[sa>>2]|0}GN(c[ga>>2]|0,ua);ua=ma+8|0;c[ua>>2]=(c[ua>>2]|0)+1;va=ra}else va=pa;zri(va+20|0,597632)|0;va=c[149478]|0;pa=va+4|0;ra=c[pa>>2]|0;do if(ra){ua=ra;while(1){ma=c[ua+16>>2]|0;if((ma|0)>33){ga=c[ua>>2]|0;if(!ga){wa=ua;xa=ua;o=96;break}else{ua=ga;continue}}if((ma|0)>=33){ya=ua;o=100;break}ma=ua+4|0;ga=c[ma>>2]|0;if(!ga){za=ma;Aa=ua;o=99;break}else ua=ga}if((o|0)==96){c[d>>2]=xa;Ba=wa;Ca=xa;break}else if((o|0)==99){c[d>>2]=Aa;Ba=za;Ca=Aa;break}else if((o|0)==100){c[d>>2]=ya;Ba=d;Ca=ya;break}}else{ua=va+4|0;c[d>>2]=ua;Ba=ua;Ca=ua}while(0);ya=c[Ba>>2]|0;if(!ya){Aa=xCi(32)|0;c[Aa+16>>2]=33;za=Aa+20|0;c[za+0>>2]=0;c[za+4>>2]=0;c[za+8>>2]=0;c[Aa>>2]=0;c[Aa+4>>2]=0;c[Aa+8>>2]=Ca;c[Ba>>2]=Aa;Ca=c[c[va>>2]>>2]|0;if(!Ca)Da=Aa;else{c[va>>2]=Ca;Da=c[Ba>>2]|0}GN(c[pa>>2]|0,Da);Da=va+8|0;c[Da>>2]=(c[Da>>2]|0)+1;Ea=Aa}else Ea=ya;zri(Ea+20|0,597976)|0;Ea=c[149478]|0;ya=Ea+4|0;Aa=c[ya>>2]|0;do if(Aa){Da=Aa;while(1){va=c[Da+16>>2]|0;if((va|0)>34){pa=c[Da>>2]|0;if(!pa){Fa=Da;Ga=Da;o=109;break}else{Da=pa;continue}}if((va|0)>=34){Ha=Da;o=113;break}va=Da+4|0;pa=c[va>>2]|0;if(!pa){Ia=va;Ja=Da;o=112;break}else Da=pa}if((o|0)==109){c[d>>2]=Ga;Ka=Fa;La=Ga;break}else if((o|0)==112){c[d>>2]=Ja;Ka=Ia;La=Ja;break}else if((o|0)==113){c[d>>2]=Ha;Ka=d;La=Ha;break}}else{Da=Ea+4|0;c[d>>2]=Da;Ka=Da;La=Da}while(0);Ha=c[Ka>>2]|0;if(!Ha){Ja=xCi(32)|0;c[Ja+16>>2]=34;Ia=Ja+20|0;c[Ia+0>>2]=0;c[Ia+4>>2]=0;c[Ia+8>>2]=0;c[Ja>>2]=0;c[Ja+4>>2]=0;c[Ja+8>>2]=La;c[Ka>>2]=Ja;La=c[c[Ea>>2]>>2]|0;if(!La)Ma=Ja;else{c[Ea>>2]=La;Ma=c[Ka>>2]|0}GN(c[ya>>2]|0,Ma);Ma=Ea+8|0;c[Ma>>2]=(c[Ma>>2]|0)+1;Na=Ja}else Na=Ha;zri(Na+20|0,597984)|0;Na=c[149478]|0;Ha=Na+4|0;Ja=c[Ha>>2]|0;do if(Ja){Ma=Ja;while(1){Ea=c[Ma+16>>2]|0;if((Ea|0)>35){ya=c[Ma>>2]|0;if(!ya){Oa=Ma;Pa=Ma;o=122;break}else{Ma=ya;continue}}if((Ea|0)>=35){Qa=Ma;o=126;break}Ea=Ma+4|0;ya=c[Ea>>2]|0;if(!ya){Ra=Ea;Sa=Ma;o=125;break}else Ma=ya}if((o|0)==122){c[d>>2]=Pa;Ta=Oa;Ua=Pa;break}else if((o|0)==125){c[d>>2]=Sa;Ta=Ra;Ua=Sa;break}else if((o|0)==126){c[d>>2]=Qa;Ta=d;Ua=Qa;break}}else{Ma=Na+4|0;c[d>>2]=Ma;Ta=Ma;Ua=Ma}while(0);Qa=c[Ta>>2]|0;if(!Qa){Sa=xCi(32)|0;c[Sa+16>>2]=35;Ra=Sa+20|0;c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;c[Sa>>2]=0;c[Sa+4>>2]=0;c[Sa+8>>2]=Ua;c[Ta>>2]=Sa;Ua=c[c[Na>>2]>>2]|0;if(!Ua)Va=Sa;else{c[Na>>2]=Ua;Va=c[Ta>>2]|0}GN(c[Ha>>2]|0,Va);Va=Na+8|0;c[Va>>2]=(c[Va>>2]|0)+1;Wa=Sa}else Wa=Qa;zri(Wa+20|0,724176)|0;Wa=c[149478]|0;Qa=Wa+4|0;Sa=c[Qa>>2]|0;do if(Sa){Va=Sa;while(1){Na=c[Va+16>>2]|0;if((Na|0)>36){Ha=c[Va>>2]|0;if(!Ha){Xa=Va;Ya=Va;o=135;break}else{Va=Ha;continue}}if((Na|0)>=36){Za=Va;o=139;break}Na=Va+4|0;Ha=c[Na>>2]|0;if(!Ha){_a=Na;$a=Va;o=138;break}else Va=Ha}if((o|0)==135){c[d>>2]=Ya;ab=Xa;bb=Ya;break}else if((o|0)==138){c[d>>2]=$a;ab=_a;bb=$a;break}else if((o|0)==139){c[d>>2]=Za;ab=d;bb=Za;break}}else{Va=Wa+4|0;c[d>>2]=Va;ab=Va;bb=Va}while(0);Za=c[ab>>2]|0;if(!Za){$a=xCi(32)|0;c[$a+16>>2]=36;_a=$a+20|0;c[_a+0>>2]=0;c[_a+4>>2]=0;c[_a+8>>2]=0;c[$a>>2]=0;c[$a+4>>2]=0;c[$a+8>>2]=bb;c[ab>>2]=$a;bb=c[c[Wa>>2]>>2]|0;if(!bb)cb=$a;else{c[Wa>>2]=bb;cb=c[ab>>2]|0}GN(c[Qa>>2]|0,cb);cb=Wa+8|0;c[cb>>2]=(c[cb>>2]|0)+1;db=$a}else db=Za;zri(db+20|0,597992)|0;db=c[149478]|0;Za=db+4|0;$a=c[Za>>2]|0;do if($a){cb=$a;while(1){Wa=c[cb+16>>2]|0;if((Wa|0)>38){Qa=c[cb>>2]|0;if(!Qa){eb=cb;fb=cb;o=148;break}else{cb=Qa;continue}}if((Wa|0)>=38){gb=cb;o=152;break}Wa=cb+4|0;Qa=c[Wa>>2]|0;if(!Qa){hb=Wa;ib=cb;o=151;break}else cb=Qa}if((o|0)==148){c[d>>2]=fb;jb=eb;kb=fb;break}else if((o|0)==151){c[d>>2]=ib;jb=hb;kb=ib;break}else if((o|0)==152){c[d>>2]=gb;jb=d;kb=gb;break}}else{cb=db+4|0;c[d>>2]=cb;jb=cb;kb=cb}while(0);gb=c[jb>>2]|0;if(!gb){ib=xCi(32)|0;c[ib+16>>2]=38;hb=ib+20|0;c[hb+0>>2]=0;c[hb+4>>2]=0;c[hb+8>>2]=0;c[ib>>2]=0;c[ib+4>>2]=0;c[ib+8>>2]=kb;c[jb>>2]=ib;kb=c[c[db>>2]>>2]|0;if(!kb)lb=ib;else{c[db>>2]=kb;lb=c[jb>>2]|0}GN(c[Za>>2]|0,lb);lb=db+8|0;c[lb>>2]=(c[lb>>2]|0)+1;mb=ib}else mb=gb;zri(mb+20|0,598e3)|0;mb=c[149478]|0;gb=mb+4|0;ib=c[gb>>2]|0;do if(ib){lb=ib;while(1){db=c[lb+16>>2]|0;if((db|0)>39){Za=c[lb>>2]|0;if(!Za){nb=lb;ob=lb;o=161;break}else{lb=Za;continue}}if((db|0)>=39){pb=lb;o=165;break}db=lb+4|0;Za=c[db>>2]|0;if(!Za){qb=db;rb=lb;o=164;break}else lb=Za}if((o|0)==161){c[d>>2]=ob;sb=nb;tb=ob;break}else if((o|0)==164){c[d>>2]=rb;sb=qb;tb=rb;break}else if((o|0)==165){c[d>>2]=pb;sb=d;tb=pb;break}}else{lb=mb+4|0;c[d>>2]=lb;sb=lb;tb=lb}while(0);pb=c[sb>>2]|0;if(!pb){rb=xCi(32)|0;c[rb+16>>2]=39;qb=rb+20|0;c[qb+0>>2]=0;c[qb+4>>2]=0;c[qb+8>>2]=0;c[rb>>2]=0;c[rb+4>>2]=0;c[rb+8>>2]=tb;c[sb>>2]=rb;tb=c[c[mb>>2]>>2]|0;if(!tb)ub=rb;else{c[mb>>2]=tb;ub=c[sb>>2]|0}GN(c[gb>>2]|0,ub);ub=mb+8|0;c[ub>>2]=(c[ub>>2]|0)+1;vb=rb}else vb=pb;zri(vb+20|0,659600)|0;vb=c[149478]|0;pb=vb+4|0;rb=c[pb>>2]|0;do if(rb){ub=rb;while(1){mb=c[ub+16>>2]|0;if((mb|0)>40){gb=c[ub>>2]|0;if(!gb){wb=ub;xb=ub;o=174;break}else{ub=gb;continue}}if((mb|0)>=40){yb=ub;o=178;break}mb=ub+4|0;gb=c[mb>>2]|0;if(!gb){zb=mb;Ab=ub;o=177;break}else ub=gb}if((o|0)==174){c[d>>2]=xb;Bb=wb;Cb=xb;break}else if((o|0)==177){c[d>>2]=Ab;Bb=zb;Cb=Ab;break}else if((o|0)==178){c[d>>2]=yb;Bb=d;Cb=yb;break}}else{ub=vb+4|0;c[d>>2]=ub;Bb=ub;Cb=ub}while(0);yb=c[Bb>>2]|0;if(!yb){Ab=xCi(32)|0;c[Ab+16>>2]=40;zb=Ab+20|0;c[zb+0>>2]=0;c[zb+4>>2]=0;c[zb+8>>2]=0;c[Ab>>2]=0;c[Ab+4>>2]=0;c[Ab+8>>2]=Cb;c[Bb>>2]=Ab;Cb=c[c[vb>>2]>>2]|0;if(!Cb)Db=Ab;else{c[vb>>2]=Cb;Db=c[Bb>>2]|0}GN(c[pb>>2]|0,Db);Db=vb+8|0;c[Db>>2]=(c[Db>>2]|0)+1;Eb=Ab}else Eb=yb;zri(Eb+20|0,1081728)|0;Eb=c[149478]|0;yb=Eb+4|0;Ab=c[yb>>2]|0;do if(Ab){Db=Ab;while(1){vb=c[Db+16>>2]|0;if((vb|0)>41){pb=c[Db>>2]|0;if(!pb){Fb=Db;Gb=Db;o=187;break}else{Db=pb;continue}}if((vb|0)>=41){Hb=Db;o=191;break}vb=Db+4|0;pb=c[vb>>2]|0;if(!pb){Ib=vb;Jb=Db;o=190;break}else Db=pb}if((o|0)==187){c[d>>2]=Gb;Kb=Fb;Lb=Gb;break}else if((o|0)==190){c[d>>2]=Jb;Kb=Ib;Lb=Jb;break}else if((o|0)==191){c[d>>2]=Hb;Kb=d;Lb=Hb;break}}else{Db=Eb+4|0;c[d>>2]=Db;Kb=Db;Lb=Db}while(0);Hb=c[Kb>>2]|0;if(!Hb){Jb=xCi(32)|0;c[Jb+16>>2]=41;Ib=Jb+20|0;c[Ib+0>>2]=0;c[Ib+4>>2]=0;c[Ib+8>>2]=0;c[Jb>>2]=0;c[Jb+4>>2]=0;c[Jb+8>>2]=Lb;c[Kb>>2]=Jb;Lb=c[c[Eb>>2]>>2]|0;if(!Lb)Mb=Jb;else{c[Eb>>2]=Lb;Mb=c[Kb>>2]|0}GN(c[yb>>2]|0,Mb);Mb=Eb+8|0;c[Mb>>2]=(c[Mb>>2]|0)+1;Nb=Jb}else Nb=Hb;zri(Nb+20|0,1081744)|0;Nb=c[149478]|0;Hb=Nb+4|0;Jb=c[Hb>>2]|0;do if(Jb){Mb=Jb;while(1){Eb=c[Mb+16>>2]|0;if((Eb|0)>42){yb=c[Mb>>2]|0;if(!yb){Ob=Mb;Pb=Mb;o=200;break}else{Mb=yb;continue}}if((Eb|0)>=42){Qb=Mb;o=204;break}Eb=Mb+4|0;yb=c[Eb>>2]|0;if(!yb){Rb=Eb;Sb=Mb;o=203;break}else Mb=yb}if((o|0)==200){c[d>>2]=Pb;Tb=Ob;Ub=Pb;break}else if((o|0)==203){c[d>>2]=Sb;Tb=Rb;Ub=Sb;break}else if((o|0)==204){c[d>>2]=Qb;Tb=d;Ub=Qb;break}}else{Mb=Nb+4|0;c[d>>2]=Mb;Tb=Mb;Ub=Mb}while(0);Qb=c[Tb>>2]|0;if(!Qb){Sb=xCi(32)|0;c[Sb+16>>2]=42;Rb=Sb+20|0;c[Rb+0>>2]=0;c[Rb+4>>2]=0;c[Rb+8>>2]=0;c[Sb>>2]=0;c[Sb+4>>2]=0;c[Sb+8>>2]=Ub;c[Tb>>2]=Sb;Ub=c[c[Nb>>2]>>2]|0;if(!Ub)Vb=Sb;else{c[Nb>>2]=Ub;Vb=c[Tb>>2]|0}GN(c[Hb>>2]|0,Vb);Vb=Nb+8|0;c[Vb>>2]=(c[Vb>>2]|0)+1;Wb=Sb}else Wb=Qb;zri(Wb+20|0,598008)|0;Wb=c[149478]|0;Qb=Wb+4|0;Sb=c[Qb>>2]|0;do if(Sb){Vb=Sb;while(1){Nb=c[Vb+16>>2]|0;if((Nb|0)>43){Hb=c[Vb>>2]|0;if(!Hb){Xb=Vb;Yb=Vb;o=213;break}else{Vb=Hb;continue}}if((Nb|0)>=43){Zb=Vb;o=217;break}Nb=Vb+4|0;Hb=c[Nb>>2]|0;if(!Hb){_b=Nb;$b=Vb;o=216;break}else Vb=Hb}if((o|0)==213){c[d>>2]=Yb;ac=Xb;bc=Yb;break}else if((o|0)==216){c[d>>2]=$b;ac=_b;bc=$b;break}else if((o|0)==217){c[d>>2]=Zb;ac=d;bc=Zb;break}}else{Vb=Wb+4|0;c[d>>2]=Vb;ac=Vb;bc=Vb}while(0);Zb=c[ac>>2]|0;if(!Zb){$b=xCi(32)|0;c[$b+16>>2]=43;_b=$b+20|0;c[_b+0>>2]=0;c[_b+4>>2]=0;c[_b+8>>2]=0;c[$b>>2]=0;c[$b+4>>2]=0;c[$b+8>>2]=bc;c[ac>>2]=$b;bc=c[c[Wb>>2]>>2]|0;if(!bc)cc=$b;else{c[Wb>>2]=bc;cc=c[ac>>2]|0}GN(c[Qb>>2]|0,cc);cc=Wb+8|0;c[cc>>2]=(c[cc>>2]|0)+1;dc=$b}else dc=Zb;zri(dc+20|0,598016)|0;dc=c[149478]|0;Zb=dc+4|0;$b=c[Zb>>2]|0;do if($b){cc=$b;while(1){Wb=c[cc+16>>2]|0;if((Wb|0)>44){Qb=c[cc>>2]|0;if(!Qb){ec=cc;fc=cc;o=226;break}else{cc=Qb;continue}}if((Wb|0)>=44){gc=cc;o=230;break}Wb=cc+4|0;Qb=c[Wb>>2]|0;if(!Qb){hc=Wb;ic=cc;o=229;break}else cc=Qb}if((o|0)==226){c[d>>2]=fc;jc=ec;kc=fc;break}else if((o|0)==229){c[d>>2]=ic;jc=hc;kc=ic;break}else if((o|0)==230){c[d>>2]=gc;jc=d;kc=gc;break}}else{cc=dc+4|0;c[d>>2]=cc;jc=cc;kc=cc}while(0);gc=c[jc>>2]|0;if(!gc){ic=xCi(32)|0;c[ic+16>>2]=44;hc=ic+20|0;c[hc+0>>2]=0;c[hc+4>>2]=0;c[hc+8>>2]=0;c[ic>>2]=0;c[ic+4>>2]=0;c[ic+8>>2]=kc;c[jc>>2]=ic;kc=c[c[dc>>2]>>2]|0;if(!kc)lc=ic;else{c[dc>>2]=kc;lc=c[jc>>2]|0}GN(c[Zb>>2]|0,lc);lc=dc+8|0;c[lc>>2]=(c[lc>>2]|0)+1;mc=ic}else mc=gc;zri(mc+20|0,598024)|0;mc=c[149478]|0;gc=mc+4|0;ic=c[gc>>2]|0;do if(ic){lc=ic;while(1){dc=c[lc+16>>2]|0;if((dc|0)>45){Zb=c[lc>>2]|0;if(!Zb){nc=lc;oc=lc;o=239;break}else{lc=Zb;continue}}if((dc|0)>=45){pc=lc;o=243;break}dc=lc+4|0;Zb=c[dc>>2]|0;if(!Zb){qc=dc;rc=lc;o=242;break}else lc=Zb}if((o|0)==239){c[d>>2]=oc;sc=nc;tc=oc;break}else if((o|0)==242){c[d>>2]=rc;sc=qc;tc=rc;break}else if((o|0)==243){c[d>>2]=pc;sc=d;tc=pc;break}}else{lc=mc+4|0;c[d>>2]=lc;sc=lc;tc=lc}while(0);pc=c[sc>>2]|0;if(!pc){rc=xCi(32)|0;c[rc+16>>2]=45;qc=rc+20|0;c[qc+0>>2]=0;c[qc+4>>2]=0;c[qc+8>>2]=0;c[rc>>2]=0;c[rc+4>>2]=0;c[rc+8>>2]=tc;c[sc>>2]=rc;tc=c[c[mc>>2]>>2]|0;if(!tc)uc=rc;else{c[mc>>2]=tc;uc=c[sc>>2]|0}GN(c[gc>>2]|0,uc);uc=mc+8|0;c[uc>>2]=(c[uc>>2]|0)+1;vc=rc}else vc=pc;zri(vc+20|0,630368)|0;vc=c[149478]|0;pc=vc+4|0;rc=c[pc>>2]|0;do if(rc){uc=rc;while(1){mc=c[uc+16>>2]|0;if((mc|0)>46){gc=c[uc>>2]|0;if(!gc){wc=uc;xc=uc;o=252;break}else{uc=gc;continue}}if((mc|0)>=46){yc=uc;o=256;break}mc=uc+4|0;gc=c[mc>>2]|0;if(!gc){zc=mc;Ac=uc;o=255;break}else uc=gc}if((o|0)==252){c[d>>2]=xc;Bc=wc;Cc=xc;break}else if((o|0)==255){c[d>>2]=Ac;Bc=zc;Cc=Ac;break}else if((o|0)==256){c[d>>2]=yc;Bc=d;Cc=yc;break}}else{uc=vc+4|0;c[d>>2]=uc;Bc=uc;Cc=uc}while(0);yc=c[Bc>>2]|0;if(!yc){Ac=xCi(32)|0;c[Ac+16>>2]=46;zc=Ac+20|0;c[zc+0>>2]=0;c[zc+4>>2]=0;c[zc+8>>2]=0;c[Ac>>2]=0;c[Ac+4>>2]=0;c[Ac+8>>2]=Cc;c[Bc>>2]=Ac;Cc=c[c[vc>>2]>>2]|0;if(!Cc)Dc=Ac;else{c[vc>>2]=Cc;Dc=c[Bc>>2]|0}GN(c[pc>>2]|0,Dc);Dc=vc+8|0;c[Dc>>2]=(c[Dc>>2]|0)+1;Ec=Ac}else Ec=yc;zri(Ec+20|0,3672776)|0;Ec=c[149478]|0;yc=Ec+4|0;Ac=c[yc>>2]|0;do if(Ac){Dc=Ac;while(1){vc=c[Dc+16>>2]|0;if((vc|0)>47){pc=c[Dc>>2]|0;if(!pc){Fc=Dc;Gc=Dc;o=265;break}else{Dc=pc;continue}}if((vc|0)>=47){Hc=Dc;o=269;break}vc=Dc+4|0;pc=c[vc>>2]|0;if(!pc){Ic=vc;Jc=Dc;o=268;break}else Dc=pc}if((o|0)==265){c[d>>2]=Gc;Kc=Fc;Lc=Gc;break}else if((o|0)==268){c[d>>2]=Jc;Kc=Ic;Lc=Jc;break}else if((o|0)==269){c[d>>2]=Hc;Kc=d;Lc=Hc;break}}else{Dc=Ec+4|0;c[d>>2]=Dc;Kc=Dc;Lc=Dc}while(0);Hc=c[Kc>>2]|0;if(!Hc){Jc=xCi(32)|0;c[Jc+16>>2]=47;Ic=Jc+20|0;c[Ic+0>>2]=0;c[Ic+4>>2]=0;c[Ic+8>>2]=0;c[Jc>>2]=0;c[Jc+4>>2]=0;c[Jc+8>>2]=Lc;c[Kc>>2]=Jc;Lc=c[c[Ec>>2]>>2]|0;if(!Lc)Mc=Jc;else{c[Ec>>2]=Lc;Mc=c[Kc>>2]|0}GN(c[yc>>2]|0,Mc);Mc=Ec+8|0;c[Mc>>2]=(c[Mc>>2]|0)+1;Nc=Jc}else Nc=Hc;zri(Nc+20|0,63e4)|0;Nc=c[149478]|0;Hc=Nc+4|0;Jc=c[Hc>>2]|0;do if(Jc){Mc=Jc;while(1){Ec=c[Mc+16>>2]|0;if((Ec|0)>48){yc=c[Mc>>2]|0;if(!yc){Oc=Mc;Pc=Mc;o=278;break}else{Mc=yc;continue}}if((Ec|0)>=48){Qc=Mc;o=282;break}Ec=Mc+4|0;yc=c[Ec>>2]|0;if(!yc){Rc=Ec;Sc=Mc;o=281;break}else Mc=yc}if((o|0)==278){c[d>>2]=Pc;Tc=Oc;Uc=Pc;break}else if((o|0)==281){c[d>>2]=Sc;Tc=Rc;Uc=Sc;break}else if((o|0)==282){c[d>>2]=Qc;Tc=d;Uc=Qc;break}}else{Mc=Nc+4|0;c[d>>2]=Mc;Tc=Mc;Uc=Mc}while(0);Qc=c[Tc>>2]|0;if(!Qc){Sc=xCi(32)|0;c[Sc+16>>2]=48;Rc=Sc+20|0;c[Rc+0>>2]=0;c[Rc+4>>2]=0;c[Rc+8>>2]=0;c[Sc>>2]=0;c[Sc+4>>2]=0;c[Sc+8>>2]=Uc;c[Tc>>2]=Sc;Uc=c[c[Nc>>2]>>2]|0;if(!Uc)Vc=Sc;else{c[Nc>>2]=Uc;Vc=c[Tc>>2]|0}GN(c[Hc>>2]|0,Vc);Vc=Nc+8|0;c[Vc>>2]=(c[Vc>>2]|0)+1;Wc=Sc}else Wc=Qc;zri(Wc+20|0,598032)|0;Wc=c[149478]|0;Qc=Wc+4|0;Sc=c[Qc>>2]|0;do if(Sc){Vc=Sc;while(1){Nc=c[Vc+16>>2]|0;if((Nc|0)>49){Hc=c[Vc>>2]|0;if(!Hc){Xc=Vc;Yc=Vc;o=291;break}else{Vc=Hc;continue}}if((Nc|0)>=49){Zc=Vc;o=295;break}Nc=Vc+4|0;Hc=c[Nc>>2]|0;if(!Hc){_c=Nc;$c=Vc;o=294;break}else Vc=Hc}if((o|0)==291){c[d>>2]=Yc;ad=Xc;bd=Yc;break}else if((o|0)==294){c[d>>2]=$c;ad=_c;bd=$c;break}else if((o|0)==295){c[d>>2]=Zc;ad=d;bd=Zc;break}}else{Vc=Wc+4|0;c[d>>2]=Vc;ad=Vc;bd=Vc}while(0);Zc=c[ad>>2]|0;if(!Zc){$c=xCi(32)|0;c[$c+16>>2]=49;_c=$c+20|0;c[_c+0>>2]=0;c[_c+4>>2]=0;c[_c+8>>2]=0;c[$c>>2]=0;c[$c+4>>2]=0;c[$c+8>>2]=bd;c[ad>>2]=$c;bd=c[c[Wc>>2]>>2]|0;if(!bd)cd=$c;else{c[Wc>>2]=bd;cd=c[ad>>2]|0}GN(c[Qc>>2]|0,cd);cd=Wc+8|0;c[cd>>2]=(c[cd>>2]|0)+1;dd=$c}else dd=Zc;zri(dd+20|0,598040)|0;dd=c[149478]|0;Zc=dd+4|0;$c=c[Zc>>2]|0;do if($c){cd=$c;while(1){Wc=c[cd+16>>2]|0;if((Wc|0)>50){Qc=c[cd>>2]|0;if(!Qc){ed=cd;fd=cd;o=304;break}else{cd=Qc;continue}}if((Wc|0)>=50){gd=cd;o=308;break}Wc=cd+4|0;Qc=c[Wc>>2]|0;if(!Qc){hd=Wc;id=cd;o=307;break}else cd=Qc}if((o|0)==304){c[d>>2]=fd;jd=ed;kd=fd;break}else if((o|0)==307){c[d>>2]=id;jd=hd;kd=id;break}else if((o|0)==308){c[d>>2]=gd;jd=d;kd=gd;break}}else{cd=dd+4|0;c[d>>2]=cd;jd=cd;kd=cd}while(0);gd=c[jd>>2]|0;if(!gd){id=xCi(32)|0;c[id+16>>2]=50;hd=id+20|0;c[hd+0>>2]=0;c[hd+4>>2]=0;c[hd+8>>2]=0;c[id>>2]=0;c[id+4>>2]=0;c[id+8>>2]=kd;c[jd>>2]=id;kd=c[c[dd>>2]>>2]|0;if(!kd)ld=id;else{c[dd>>2]=kd;ld=c[jd>>2]|0}GN(c[Zc>>2]|0,ld);ld=dd+8|0;c[ld>>2]=(c[ld>>2]|0)+1;md=id}else md=gd;zri(md+20|0,619664)|0;md=c[149478]|0;gd=md+4|0;id=c[gd>>2]|0;do if(id){ld=id;while(1){dd=c[ld+16>>2]|0;if((dd|0)>51){Zc=c[ld>>2]|0;if(!Zc){nd=ld;od=ld;o=317;break}else{ld=Zc;continue}}if((dd|0)>=51){pd=ld;o=321;break}dd=ld+4|0;Zc=c[dd>>2]|0;if(!Zc){qd=dd;rd=ld;o=320;break}else ld=Zc}if((o|0)==317){c[d>>2]=od;sd=nd;td=od;break}else if((o|0)==320){c[d>>2]=rd;sd=qd;td=rd;break}else if((o|0)==321){c[d>>2]=pd;sd=d;td=pd;break}}else{ld=md+4|0;c[d>>2]=ld;sd=ld;td=ld}while(0);pd=c[sd>>2]|0;if(!pd){rd=xCi(32)|0;c[rd+16>>2]=51;qd=rd+20|0;c[qd+0>>2]=0;c[qd+4>>2]=0;c[qd+8>>2]=0;c[rd>>2]=0;c[rd+4>>2]=0;c[rd+8>>2]=td;c[sd>>2]=rd;td=c[c[md>>2]>>2]|0;if(!td)ud=rd;else{c[md>>2]=td;ud=c[sd>>2]|0}GN(c[gd>>2]|0,ud);ud=md+8|0;c[ud>>2]=(c[ud>>2]|0)+1;vd=rd}else vd=pd;zri(vd+20|0,598048)|0;vd=c[149478]|0;pd=vd+4|0;rd=c[pd>>2]|0;do if(rd){ud=rd;while(1){md=c[ud+16>>2]|0;if((md|0)>52){gd=c[ud>>2]|0;if(!gd){wd=ud;xd=ud;o=330;break}else{ud=gd;continue}}if((md|0)>=52){yd=ud;o=334;break}md=ud+4|0;gd=c[md>>2]|0;if(!gd){zd=md;Ad=ud;o=333;break}else ud=gd}if((o|0)==330){c[d>>2]=xd;Bd=wd;Cd=xd;break}else if((o|0)==333){c[d>>2]=Ad;Bd=zd;Cd=Ad;break}else if((o|0)==334){c[d>>2]=yd;Bd=d;Cd=yd;break}}else{ud=vd+4|0;c[d>>2]=ud;Bd=ud;Cd=ud}while(0);yd=c[Bd>>2]|0;if(!yd){Ad=xCi(32)|0;c[Ad+16>>2]=52;zd=Ad+20|0;c[zd+0>>2]=0;c[zd+4>>2]=0;c[zd+8>>2]=0;c[Ad>>2]=0;c[Ad+4>>2]=0;c[Ad+8>>2]=Cd;c[Bd>>2]=Ad;Cd=c[c[vd>>2]>>2]|0;if(!Cd)Dd=Ad;else{c[vd>>2]=Cd;Dd=c[Bd>>2]|0}GN(c[pd>>2]|0,Dd);Dd=vd+8|0;c[Dd>>2]=(c[Dd>>2]|0)+1;Ed=Ad}else Ed=yd;zri(Ed+20|0,720520)|0;Ed=c[149478]|0;yd=Ed+4|0;Ad=c[yd>>2]|0;do if(Ad){Dd=Ad;while(1){vd=c[Dd+16>>2]|0;if((vd|0)>53){pd=c[Dd>>2]|0;if(!pd){Fd=Dd;Gd=Dd;o=343;break}else{Dd=pd;continue}}if((vd|0)>=53){Hd=Dd;o=347;break}vd=Dd+4|0;pd=c[vd>>2]|0;if(!pd){Id=vd;Jd=Dd;o=346;break}else Dd=pd}if((o|0)==343){c[d>>2]=Gd;Kd=Fd;Ld=Gd;break}else if((o|0)==346){c[d>>2]=Jd;Kd=Id;Ld=Jd;break}else if((o|0)==347){c[d>>2]=Hd;Kd=d;Ld=Hd;break}}else{Dd=Ed+4|0;c[d>>2]=Dd;Kd=Dd;Ld=Dd}while(0);Hd=c[Kd>>2]|0;if(!Hd){Jd=xCi(32)|0;c[Jd+16>>2]=53;Id=Jd+20|0;c[Id+0>>2]=0;c[Id+4>>2]=0;c[Id+8>>2]=0;c[Jd>>2]=0;c[Jd+4>>2]=0;c[Jd+8>>2]=Ld;c[Kd>>2]=Jd;Ld=c[c[Ed>>2]>>2]|0;if(!Ld)Md=Jd;else{c[Ed>>2]=Ld;Md=c[Kd>>2]|0}GN(c[yd>>2]|0,Md);Md=Ed+8|0;c[Md>>2]=(c[Md>>2]|0)+1;Nd=Jd}else Nd=Hd;zri(Nd+20|0,598056)|0;Nd=c[149478]|0;Hd=Nd+4|0;Jd=c[Hd>>2]|0;do if(Jd){Md=Jd;while(1){Ed=c[Md+16>>2]|0;if((Ed|0)>54){yd=c[Md>>2]|0;if(!yd){Od=Md;Pd=Md;o=356;break}else{Md=yd;continue}}if((Ed|0)>=54){Qd=Md;o=360;break}Ed=Md+4|0;yd=c[Ed>>2]|0;if(!yd){Rd=Ed;Sd=Md;o=359;break}else Md=yd}if((o|0)==356){c[d>>2]=Pd;Td=Od;Ud=Pd;break}else if((o|0)==359){c[d>>2]=Sd;Td=Rd;Ud=Sd;break}else if((o|0)==360){c[d>>2]=Qd;Td=d;Ud=Qd;break}}else{Md=Nd+4|0;c[d>>2]=Md;Td=Md;Ud=Md}while(0);Qd=c[Td>>2]|0;if(!Qd){Sd=xCi(32)|0;c[Sd+16>>2]=54;Rd=Sd+20|0;c[Rd+0>>2]=0;c[Rd+4>>2]=0;c[Rd+8>>2]=0;c[Sd>>2]=0;c[Sd+4>>2]=0;c[Sd+8>>2]=Ud;c[Td>>2]=Sd;Ud=c[c[Nd>>2]>>2]|0;if(!Ud)Vd=Sd;else{c[Nd>>2]=Ud;Vd=c[Td>>2]|0}GN(c[Hd>>2]|0,Vd);Vd=Nd+8|0;c[Vd>>2]=(c[Vd>>2]|0)+1;Wd=Sd}else Wd=Qd;zri(Wd+20|0,598064)|0;Wd=c[149478]|0;Qd=Wd+4|0;Sd=c[Qd>>2]|0;do if(Sd){Vd=Sd;while(1){Nd=c[Vd+16>>2]|0;if((Nd|0)>55){Hd=c[Vd>>2]|0;if(!Hd){Xd=Vd;Yd=Vd;o=369;break}else{Vd=Hd;continue}}if((Nd|0)>=55){Zd=Vd;o=373;break}Nd=Vd+4|0;Hd=c[Nd>>2]|0;if(!Hd){_d=Nd;$d=Vd;o=372;break}else Vd=Hd}if((o|0)==369){c[d>>2]=Yd;ae=Xd;be=Yd;break}else if((o|0)==372){c[d>>2]=$d;ae=_d;be=$d;break}else if((o|0)==373){c[d>>2]=Zd;ae=d;be=Zd;break}}else{Vd=Wd+4|0;c[d>>2]=Vd;ae=Vd;be=Vd}while(0);Zd=c[ae>>2]|0;if(!Zd){$d=xCi(32)|0;c[$d+16>>2]=55;_d=$d+20|0;c[_d+0>>2]=0;c[_d+4>>2]=0;c[_d+8>>2]=0;c[$d>>2]=0;c[$d+4>>2]=0;c[$d+8>>2]=be;c[ae>>2]=$d;be=c[c[Wd>>2]>>2]|0;if(!be)ce=$d;else{c[Wd>>2]=be;ce=c[ae>>2]|0}GN(c[Qd>>2]|0,ce);ce=Wd+8|0;c[ce>>2]=(c[ce>>2]|0)+1;de=$d}else de=Zd;zri(de+20|0,598072)|0;de=c[149478]|0;Zd=de+4|0;$d=c[Zd>>2]|0;do if($d){ce=$d;while(1){Wd=c[ce+16>>2]|0;if((Wd|0)>56){Qd=c[ce>>2]|0;if(!Qd){ee=ce;fe=ce;o=382;break}else{ce=Qd;continue}}if((Wd|0)>=56){ge=ce;o=386;break}Wd=ce+4|0;Qd=c[Wd>>2]|0;if(!Qd){he=Wd;ie=ce;o=385;break}else ce=Qd}if((o|0)==382){c[d>>2]=fe;je=ee;ke=fe;break}else if((o|0)==385){c[d>>2]=ie;je=he;ke=ie;break}else if((o|0)==386){c[d>>2]=ge;je=d;ke=ge;break}}else{ce=de+4|0;c[d>>2]=ce;je=ce;ke=ce}while(0);ge=c[je>>2]|0;if(!ge){ie=xCi(32)|0;c[ie+16>>2]=56;he=ie+20|0;c[he+0>>2]=0;c[he+4>>2]=0;c[he+8>>2]=0;c[ie>>2]=0;c[ie+4>>2]=0;c[ie+8>>2]=ke;c[je>>2]=ie;ke=c[c[de>>2]>>2]|0;if(!ke)le=ie;else{c[de>>2]=ke;le=c[je>>2]|0}GN(c[Zd>>2]|0,le);le=de+8|0;c[le>>2]=(c[le>>2]|0)+1;me=ie}else me=ge;zri(me+20|0,598080)|0;me=c[149478]|0;ge=me+4|0;ie=c[ge>>2]|0;do if(ie){le=ie;while(1){de=c[le+16>>2]|0;if((de|0)>57){Zd=c[le>>2]|0;if(!Zd){ne=le;oe=le;o=395;break}else{le=Zd;continue}}if((de|0)>=57){pe=le;o=399;break}de=le+4|0;Zd=c[de>>2]|0;if(!Zd){qe=de;re=le;o=398;break}else le=Zd}if((o|0)==395){c[d>>2]=oe;se=ne;te=oe;break}else if((o|0)==398){c[d>>2]=re;se=qe;te=re;break}else if((o|0)==399){c[d>>2]=pe;se=d;te=pe;break}}else{le=me+4|0;c[d>>2]=le;se=le;te=le}while(0);pe=c[se>>2]|0;if(!pe){re=xCi(32)|0;c[re+16>>2]=57;qe=re+20|0;c[qe+0>>2]=0;c[qe+4>>2]=0;c[qe+8>>2]=0;c[re>>2]=0;c[re+4>>2]=0;c[re+8>>2]=te;c[se>>2]=re;te=c[c[me>>2]>>2]|0;if(!te)ue=re;else{c[me>>2]=te;ue=c[se>>2]|0}GN(c[ge>>2]|0,ue);ue=me+8|0;c[ue>>2]=(c[ue>>2]|0)+1;ve=re}else ve=pe;zri(ve+20|0,598088)|0;ve=c[149478]|0;pe=ve+4|0;re=c[pe>>2]|0;do if(re){ue=re;while(1){me=c[ue+16>>2]|0;if((me|0)>58){ge=c[ue>>2]|0;if(!ge){we=ue;xe=ue;o=408;break}else{ue=ge;continue}}if((me|0)>=58){ye=ue;o=412;break}me=ue+4|0;ge=c[me>>2]|0;if(!ge){ze=me;Ae=ue;o=411;break}else ue=ge}if((o|0)==408){c[d>>2]=xe;Be=we;Ce=xe;break}else if((o|0)==411){c[d>>2]=Ae;Be=ze;Ce=Ae;break}else if((o|0)==412){c[d>>2]=ye;Be=d;Ce=ye;break}}else{ue=ve+4|0;c[d>>2]=ue;Be=ue;Ce=ue}while(0);ye=c[Be>>2]|0;if(!ye){Ae=xCi(32)|0;c[Ae+16>>2]=58;ze=Ae+20|0;c[ze+0>>2]=0;c[ze+4>>2]=0;c[ze+8>>2]=0;c[Ae>>2]=0;c[Ae+4>>2]=0;c[Ae+8>>2]=Ce;c[Be>>2]=Ae;Ce=c[c[ve>>2]>>2]|0;if(!Ce)De=Ae;else{c[ve>>2]=Ce;De=c[Be>>2]|0}GN(c[pe>>2]|0,De);De=ve+8|0;c[De>>2]=(c[De>>2]|0)+1;Ee=Ae}else Ee=ye;zri(Ee+20|0,598096)|0;Ee=c[149478]|0;ye=Ee+4|0;Ae=c[ye>>2]|0;do if(Ae){De=Ae;while(1){ve=c[De+16>>2]|0;if((ve|0)>59){pe=c[De>>2]|0;if(!pe){Fe=De;Ge=De;o=421;break}else{De=pe;continue}}if((ve|0)>=59){He=De;o=425;break}ve=De+4|0;pe=c[ve>>2]|0;if(!pe){Ie=ve;Je=De;o=424;break}else De=pe}if((o|0)==421){c[d>>2]=Ge;Ke=Fe;Le=Ge;break}else if((o|0)==424){c[d>>2]=Je;Ke=Ie;Le=Je;break}else if((o|0)==425){c[d>>2]=He;Ke=d;Le=He;break}}else{De=Ee+4|0;c[d>>2]=De;Ke=De;Le=De}while(0);He=c[Ke>>2]|0;if(!He){Je=xCi(32)|0;c[Je+16>>2]=59;Ie=Je+20|0;c[Ie+0>>2]=0;c[Ie+4>>2]=0;c[Ie+8>>2]=0;c[Je>>2]=0;c[Je+4>>2]=0;c[Je+8>>2]=Le;c[Ke>>2]=Je;Le=c[c[Ee>>2]>>2]|0;if(!Le)Me=Je;else{c[Ee>>2]=Le;Me=c[Ke>>2]|0}GN(c[ye>>2]|0,Me);Me=Ee+8|0;c[Me>>2]=(c[Me>>2]|0)+1;Ne=Je}else Ne=He;zri(Ne+20|0,598104)|0;Ne=c[149478]|0;He=Ne+4|0;Je=c[He>>2]|0;do if(Je){Me=Je;while(1){Ee=c[Me+16>>2]|0;if((Ee|0)>60){ye=c[Me>>2]|0;if(!ye){Oe=Me;Pe=Me;o=434;break}else{Me=ye;continue}}if((Ee|0)>=60){Qe=Me;o=438;break}Ee=Me+4|0;ye=c[Ee>>2]|0;if(!ye){Re=Ee;Se=Me;o=437;break}else Me=ye}if((o|0)==434){c[d>>2]=Pe;Te=Oe;Ue=Pe;break}else if((o|0)==437){c[d>>2]=Se;Te=Re;Ue=Se;break}else if((o|0)==438){c[d>>2]=Qe;Te=d;Ue=Qe;break}}else{Me=Ne+4|0;c[d>>2]=Me;Te=Me;Ue=Me}while(0);Qe=c[Te>>2]|0;if(!Qe){Se=xCi(32)|0;c[Se+16>>2]=60;Re=Se+20|0;c[Re+0>>2]=0;c[Re+4>>2]=0;c[Re+8>>2]=0;c[Se>>2]=0;c[Se+4>>2]=0;c[Se+8>>2]=Ue;c[Te>>2]=Se;Ue=c[c[Ne>>2]>>2]|0;if(!Ue)Ve=Se;else{c[Ne>>2]=Ue;Ve=c[Te>>2]|0}GN(c[He>>2]|0,Ve);Ve=Ne+8|0;c[Ve>>2]=(c[Ve>>2]|0)+1;We=Se}else We=Qe;zri(We+20|0,1081408)|0;We=c[149478]|0;Qe=We+4|0;Se=c[Qe>>2]|0;do if(Se){Ve=Se;while(1){Ne=c[Ve+16>>2]|0;if((Ne|0)>61){He=c[Ve>>2]|0;if(!He){Xe=Ve;Ye=Ve;o=447;break}else{Ve=He;continue}}if((Ne|0)>=61){Ze=Ve;o=451;break}Ne=Ve+4|0;He=c[Ne>>2]|0;if(!He){_e=Ne;$e=Ve;o=450;break}else Ve=He}if((o|0)==447){c[d>>2]=Ye;af=Xe;bf=Ye;break}else if((o|0)==450){c[d>>2]=$e;af=_e;bf=$e;break}else if((o|0)==451){c[d>>2]=Ze;af=d;bf=Ze;break}}else{Ve=We+4|0;c[d>>2]=Ve;af=Ve;bf=Ve}while(0);Ze=c[af>>2]|0;if(!Ze){$e=xCi(32)|0;c[$e+16>>2]=61;_e=$e+20|0;c[_e+0>>2]=0;c[_e+4>>2]=0;c[_e+8>>2]=0;c[$e>>2]=0;c[$e+4>>2]=0;c[$e+8>>2]=bf;c[af>>2]=$e;bf=c[c[We>>2]>>2]|0;if(!bf)cf=$e;else{c[We>>2]=bf;cf=c[af>>2]|0}GN(c[Qe>>2]|0,cf);cf=We+8|0;c[cf>>2]=(c[cf>>2]|0)+1;df=$e}else df=Ze;zri(df+20|0,598112)|0;df=c[149478]|0;Ze=df+4|0;$e=c[Ze>>2]|0;do if($e){cf=$e;while(1){We=c[cf+16>>2]|0;if((We|0)>62){Qe=c[cf>>2]|0;if(!Qe){ef=cf;ff=cf;o=460;break}else{cf=Qe;continue}}if((We|0)>=62){gf=cf;o=464;break}We=cf+4|0;Qe=c[We>>2]|0;if(!Qe){hf=We;jf=cf;o=463;break}else cf=Qe}if((o|0)==460){c[d>>2]=ff;kf=ef;lf=ff;break}else if((o|0)==463){c[d>>2]=jf;kf=hf;lf=jf;break}else if((o|0)==464){c[d>>2]=gf;kf=d;lf=gf;break}}else{cf=df+4|0;c[d>>2]=cf;kf=cf;lf=cf}while(0);gf=c[kf>>2]|0;if(!gf){jf=xCi(32)|0;c[jf+16>>2]=62;hf=jf+20|0;c[hf+0>>2]=0;c[hf+4>>2]=0;c[hf+8>>2]=0;c[jf>>2]=0;c[jf+4>>2]=0;c[jf+8>>2]=lf;c[kf>>2]=jf;lf=c[c[df>>2]>>2]|0;if(!lf)mf=jf;else{c[df>>2]=lf;mf=c[kf>>2]|0}GN(c[Ze>>2]|0,mf);mf=df+8|0;c[mf>>2]=(c[mf>>2]|0)+1;nf=jf}else nf=gf;zri(nf+20|0,1081384)|0;nf=c[149478]|0;gf=nf+4|0;jf=c[gf>>2]|0;do if(jf){mf=jf;while(1){df=c[mf+16>>2]|0;if((df|0)>63){Ze=c[mf>>2]|0;if(!Ze){of=mf;pf=mf;o=473;break}else{mf=Ze;continue}}if((df|0)>=63){qf=mf;o=477;break}df=mf+4|0;Ze=c[df>>2]|0;if(!Ze){rf=df;sf=mf;o=476;break}else mf=Ze}if((o|0)==473){c[d>>2]=pf;tf=of;uf=pf;break}else if((o|0)==476){c[d>>2]=sf;tf=rf;uf=sf;break}else if((o|0)==477){c[d>>2]=qf;tf=d;uf=qf;break}}else{mf=nf+4|0;c[d>>2]=mf;tf=mf;uf=mf}while(0);qf=c[tf>>2]|0;if(!qf){sf=xCi(32)|0;c[sf+16>>2]=63;rf=sf+20|0;c[rf+0>>2]=0;c[rf+4>>2]=0;c[rf+8>>2]=0;c[sf>>2]=0;c[sf+4>>2]=0;c[sf+8>>2]=uf;c[tf>>2]=sf;uf=c[c[nf>>2]>>2]|0;if(!uf)vf=sf;else{c[nf>>2]=uf;vf=c[tf>>2]|0}GN(c[gf>>2]|0,vf);vf=nf+8|0;c[vf>>2]=(c[vf>>2]|0)+1;wf=sf}else wf=qf;zri(wf+20|0,598120)|0;wf=c[149478]|0;qf=wf+4|0;sf=c[qf>>2]|0;do if(sf){vf=sf;while(1){nf=c[vf+16>>2]|0;if((nf|0)>64){gf=c[vf>>2]|0;if(!gf){xf=vf;yf=vf;o=486;break}else{vf=gf;continue}}if((nf|0)>=64){zf=vf;o=490;break}nf=vf+4|0;gf=c[nf>>2]|0;if(!gf){Af=nf;Bf=vf;o=489;break}else vf=gf}if((o|0)==486){c[d>>2]=yf;Cf=xf;Df=yf;break}else if((o|0)==489){c[d>>2]=Bf;Cf=Af;Df=Bf;break}else if((o|0)==490){c[d>>2]=zf;Cf=d;Df=zf;break}}else{vf=wf+4|0;c[d>>2]=vf;Cf=vf;Df=vf}while(0);zf=c[Cf>>2]|0;if(!zf){Bf=xCi(32)|0;c[Bf+16>>2]=64;Af=Bf+20|0;c[Af+0>>2]=0;c[Af+4>>2]=0;c[Af+8>>2]=0;c[Bf>>2]=0;c[Bf+4>>2]=0;c[Bf+8>>2]=Df;c[Cf>>2]=Bf;Df=c[c[wf>>2]>>2]|0;if(!Df)Ef=Bf;else{c[wf>>2]=Df;Ef=c[Cf>>2]|0}GN(c[qf>>2]|0,Ef);Ef=wf+8|0;c[Ef>>2]=(c[Ef>>2]|0)+1;Ff=Bf}else Ff=zf;zri(Ff+20|0,598128)|0;Ff=c[149478]|0;zf=Ff+4|0;Bf=c[zf>>2]|0;do if(Bf){Ef=Bf;while(1){wf=c[Ef+16>>2]|0;if((wf|0)>91){qf=c[Ef>>2]|0;if(!qf){Gf=Ef;Hf=Ef;o=499;break}else{Ef=qf;continue}}if((wf|0)>=91){If=Ef;o=503;break}wf=Ef+4|0;qf=c[wf>>2]|0;if(!qf){Jf=wf;Kf=Ef;o=502;break}else Ef=qf}if((o|0)==499){c[d>>2]=Hf;Lf=Gf;Mf=Hf;break}else if((o|0)==502){c[d>>2]=Kf;Lf=Jf;Mf=Kf;break}else if((o|0)==503){c[d>>2]=If;Lf=d;Mf=If;break}}else{Ef=Ff+4|0;c[d>>2]=Ef;Lf=Ef;Mf=Ef}while(0);If=c[Lf>>2]|0;if(!If){Kf=xCi(32)|0;c[Kf+16>>2]=91;Jf=Kf+20|0;c[Jf+0>>2]=0;c[Jf+4>>2]=0;c[Jf+8>>2]=0;c[Kf>>2]=0;c[Kf+4>>2]=0;c[Kf+8>>2]=Mf;c[Lf>>2]=Kf;Mf=c[c[Ff>>2]>>2]|0;if(!Mf)Nf=Kf;else{c[Ff>>2]=Mf;Nf=c[Lf>>2]|0}GN(c[zf>>2]|0,Nf);Nf=Ff+8|0;c[Nf>>2]=(c[Nf>>2]|0)+1;Of=Kf}else Of=If;zri(Of+20|0,598136)|0;Of=c[149478]|0;If=Of+4|0;Kf=c[If>>2]|0;do if(Kf){Nf=Kf;while(1){Ff=c[Nf+16>>2]|0;if((Ff|0)>92){zf=c[Nf>>2]|0;if(!zf){Pf=Nf;Qf=Nf;o=512;break}else{Nf=zf;continue}}if((Ff|0)>=92){Rf=Nf;o=516;break}Ff=Nf+4|0;zf=c[Ff>>2]|0;if(!zf){Sf=Ff;Tf=Nf;o=515;break}else Nf=zf}if((o|0)==512){c[d>>2]=Qf;Uf=Pf;Vf=Qf;break}else if((o|0)==515){c[d>>2]=Tf;Uf=Sf;Vf=Tf;break}else if((o|0)==516){c[d>>2]=Rf;Uf=d;Vf=Rf;break}}else{Nf=Of+4|0;c[d>>2]=Nf;Uf=Nf;Vf=Nf}while(0);Rf=c[Uf>>2]|0;if(!Rf){Tf=xCi(32)|0;c[Tf+16>>2]=92;Sf=Tf+20|0;c[Sf+0>>2]=0;c[Sf+4>>2]=0;c[Sf+8>>2]=0;c[Tf>>2]=0;c[Tf+4>>2]=0;c[Tf+8>>2]=Vf;c[Uf>>2]=Tf;Vf=c[c[Of>>2]>>2]|0;if(!Vf)Wf=Tf;else{c[Of>>2]=Vf;Wf=c[Uf>>2]|0}GN(c[If>>2]|0,Wf);Wf=Of+8|0;c[Wf>>2]=(c[Wf>>2]|0)+1;Xf=Tf}else Xf=Rf;zri(Xf+20|0,598144)|0;Xf=c[149478]|0;Rf=Xf+4|0;Tf=c[Rf>>2]|0;do if(Tf){Wf=Tf;while(1){Of=c[Wf+16>>2]|0;if((Of|0)>93){If=c[Wf>>2]|0;if(!If){Yf=Wf;Zf=Wf;o=525;break}else{Wf=If;continue}}if((Of|0)>=93){_f=Wf;o=529;break}Of=Wf+4|0;If=c[Of>>2]|0;if(!If){$f=Of;ag=Wf;o=528;break}else Wf=If}if((o|0)==525){c[d>>2]=Zf;bg=Yf;cg=Zf;break}else if((o|0)==528){c[d>>2]=ag;bg=$f;cg=ag;break}else if((o|0)==529){c[d>>2]=_f;bg=d;cg=_f;break}}else{Wf=Xf+4|0;c[d>>2]=Wf;bg=Wf;cg=Wf}while(0);_f=c[bg>>2]|0;if(!_f){ag=xCi(32)|0;c[ag+16>>2]=93;$f=ag+20|0;c[$f+0>>2]=0;c[$f+4>>2]=0;c[$f+8>>2]=0;c[ag>>2]=0;c[ag+4>>2]=0;c[ag+8>>2]=cg;c[bg>>2]=ag;cg=c[c[Xf>>2]>>2]|0;if(!cg)dg=ag;else{c[Xf>>2]=cg;dg=c[bg>>2]|0}GN(c[Rf>>2]|0,dg);dg=Xf+8|0;c[dg>>2]=(c[dg>>2]|0)+1;eg=ag}else eg=_f;zri(eg+20|0,598152)|0;eg=c[149478]|0;_f=eg+4|0;ag=c[_f>>2]|0;do if(ag){dg=ag;while(1){Xf=c[dg+16>>2]|0;if((Xf|0)>94){Rf=c[dg>>2]|0;if(!Rf){fg=dg;gg=dg;o=538;break}else{dg=Rf;continue}}if((Xf|0)>=94){hg=dg;o=542;break}Xf=dg+4|0;Rf=c[Xf>>2]|0;if(!Rf){ig=Xf;jg=dg;o=541;break}else dg=Rf}if((o|0)==538){c[d>>2]=gg;kg=fg;lg=gg;break}else if((o|0)==541){c[d>>2]=jg;kg=ig;lg=jg;break}else if((o|0)==542){c[d>>2]=hg;kg=d;lg=hg;break}}else{dg=eg+4|0;c[d>>2]=dg;kg=dg;lg=dg}while(0);hg=c[kg>>2]|0;if(!hg){jg=xCi(32)|0;c[jg+16>>2]=94;ig=jg+20|0;c[ig+0>>2]=0;c[ig+4>>2]=0;c[ig+8>>2]=0;c[jg>>2]=0;c[jg+4>>2]=0;c[jg+8>>2]=lg;c[kg>>2]=jg;lg=c[c[eg>>2]>>2]|0;if(!lg)mg=jg;else{c[eg>>2]=lg;mg=c[kg>>2]|0}GN(c[_f>>2]|0,mg);mg=eg+8|0;c[mg>>2]=(c[mg>>2]|0)+1;ng=jg}else ng=hg;zri(ng+20|0,598160)|0;ng=c[149478]|0;hg=ng+4|0;jg=c[hg>>2]|0;do if(jg){mg=jg;while(1){eg=c[mg+16>>2]|0;if((eg|0)>95){_f=c[mg>>2]|0;if(!_f){og=mg;pg=mg;o=551;break}else{mg=_f;continue}}if((eg|0)>=95){qg=mg;o=555;break}eg=mg+4|0;_f=c[eg>>2]|0;if(!_f){rg=eg;sg=mg;o=554;break}else mg=_f}if((o|0)==551){c[d>>2]=pg;tg=og;ug=pg;break}else if((o|0)==554){c[d>>2]=sg;tg=rg;ug=sg;break}else if((o|0)==555){c[d>>2]=qg;tg=d;ug=qg;break}}else{mg=ng+4|0;c[d>>2]=mg;tg=mg;ug=mg}while(0);qg=c[tg>>2]|0;if(!qg){sg=xCi(32)|0;c[sg+16>>2]=95;rg=sg+20|0;c[rg+0>>2]=0;c[rg+4>>2]=0;c[rg+8>>2]=0;c[sg>>2]=0;c[sg+4>>2]=0;c[sg+8>>2]=ug;c[tg>>2]=sg;ug=c[c[ng>>2]>>2]|0;if(!ug)vg=sg;else{c[ng>>2]=ug;vg=c[tg>>2]|0}GN(c[hg>>2]|0,vg);vg=ng+8|0;c[vg>>2]=(c[vg>>2]|0)+1;wg=sg}else wg=qg;zri(wg+20|0,2993032)|0;wg=c[149478]|0;qg=wg+4|0;sg=c[qg>>2]|0;do if(sg){vg=sg;while(1){ng=c[vg+16>>2]|0;if((ng|0)>96){hg=c[vg>>2]|0;if(!hg){xg=vg;yg=vg;o=564;break}else{vg=hg;continue}}if((ng|0)>=96){zg=vg;o=568;break}ng=vg+4|0;hg=c[ng>>2]|0;if(!hg){Ag=ng;Bg=vg;o=567;break}else vg=hg}if((o|0)==564){c[d>>2]=yg;Cg=xg;Dg=yg;break}else if((o|0)==567){c[d>>2]=Bg;Cg=Ag;Dg=Bg;break}else if((o|0)==568){c[d>>2]=zg;Cg=d;Dg=zg;break}}else{vg=wg+4|0;c[d>>2]=vg;Cg=vg;Dg=vg}while(0);zg=c[Cg>>2]|0;if(!zg){Bg=xCi(32)|0;c[Bg+16>>2]=96;Ag=Bg+20|0;c[Ag+0>>2]=0;c[Ag+4>>2]=0;c[Ag+8>>2]=0;c[Bg>>2]=0;c[Bg+4>>2]=0;c[Bg+8>>2]=Dg;c[Cg>>2]=Bg;Dg=c[c[wg>>2]>>2]|0;if(!Dg)Eg=Bg;else{c[wg>>2]=Dg;Eg=c[Cg>>2]|0}GN(c[qg>>2]|0,Eg);Eg=wg+8|0;c[Eg>>2]=(c[Eg>>2]|0)+1;Fg=Bg}else Fg=zg;zri(Fg+20|0,598168)|0;Fg=c[149478]|0;zg=Fg+4|0;Bg=c[zg>>2]|0;do if(Bg){Eg=Bg;while(1){wg=c[Eg+16>>2]|0;if((wg|0)>97){qg=c[Eg>>2]|0;if(!qg){Gg=Eg;Hg=Eg;o=577;break}else{Eg=qg;continue}}if((wg|0)>=97){Ig=Eg;o=581;break}wg=Eg+4|0;qg=c[wg>>2]|0;if(!qg){Jg=wg;Kg=Eg;o=580;break}else Eg=qg}if((o|0)==577){c[d>>2]=Hg;Lg=Gg;Mg=Hg;break}else if((o|0)==580){c[d>>2]=Kg;Lg=Jg;Mg=Kg;break}else if((o|0)==581){c[d>>2]=Ig;Lg=d;Mg=Ig;break}}else{Eg=Fg+4|0;c[d>>2]=Eg;Lg=Eg;Mg=Eg}while(0);Ig=c[Lg>>2]|0;if(!Ig){Kg=xCi(32)|0;c[Kg+16>>2]=97;Jg=Kg+20|0;c[Jg+0>>2]=0;c[Jg+4>>2]=0;c[Jg+8>>2]=0;c[Kg>>2]=0;c[Kg+4>>2]=0;c[Kg+8>>2]=Mg;c[Lg>>2]=Kg;Mg=c[c[Fg>>2]>>2]|0;if(!Mg)Ng=Kg;else{c[Fg>>2]=Mg;Ng=c[Lg>>2]|0}GN(c[zg>>2]|0,Ng);Ng=Fg+8|0;c[Ng>>2]=(c[Ng>>2]|0)+1;Og=Kg}else Og=Ig;zri(Og+20|0,3145320)|0;Og=c[149478]|0;Ig=Og+4|0;Kg=c[Ig>>2]|0;do if(Kg){Ng=Kg;while(1){Fg=c[Ng+16>>2]|0;if((Fg|0)>98){zg=c[Ng>>2]|0;if(!zg){Pg=Ng;Qg=Ng;o=590;break}else{Ng=zg;continue}}if((Fg|0)>=98){Rg=Ng;o=594;break}Fg=Ng+4|0;zg=c[Fg>>2]|0;if(!zg){Sg=Fg;Tg=Ng;o=593;break}else Ng=zg}if((o|0)==590){c[d>>2]=Qg;Ug=Pg;Vg=Qg;break}else if((o|0)==593){c[d>>2]=Tg;Ug=Sg;Vg=Tg;break}else if((o|0)==594){c[d>>2]=Rg;Ug=d;Vg=Rg;break}}else{Ng=Og+4|0;c[d>>2]=Ng;Ug=Ng;Vg=Ng}while(0);Rg=c[Ug>>2]|0;if(!Rg){Tg=xCi(32)|0;c[Tg+16>>2]=98;Sg=Tg+20|0;c[Sg+0>>2]=0;c[Sg+4>>2]=0;c[Sg+8>>2]=0;c[Tg>>2]=0;c[Tg+4>>2]=0;c[Tg+8>>2]=Vg;c[Ug>>2]=Tg;Vg=c[c[Og>>2]>>2]|0;if(!Vg)Wg=Tg;else{c[Og>>2]=Vg;Wg=c[Ug>>2]|0}GN(c[Ig>>2]|0,Wg);Wg=Og+8|0;c[Wg>>2]=(c[Wg>>2]|0)+1;Xg=Tg}else Xg=Rg;zri(Xg+20|0,3145560)|0;Xg=c[149478]|0;Rg=Xg+4|0;Tg=c[Rg>>2]|0;do if(Tg){Wg=Tg;while(1){Og=c[Wg+16>>2]|0;if((Og|0)>99){Ig=c[Wg>>2]|0;if(!Ig){Yg=Wg;Zg=Wg;o=603;break}else{Wg=Ig;continue}}if((Og|0)>=99){_g=Wg;o=607;break}Og=Wg+4|0;Ig=c[Og>>2]|0;if(!Ig){$g=Og;ah=Wg;o=606;break}else Wg=Ig}if((o|0)==603){c[d>>2]=Zg;bh=Yg;ch=Zg;break}else if((o|0)==606){c[d>>2]=ah;bh=$g;ch=ah;break}else if((o|0)==607){c[d>>2]=_g;bh=d;ch=_g;break}}else{Wg=Xg+4|0;c[d>>2]=Wg;bh=Wg;ch=Wg}while(0);_g=c[bh>>2]|0;if(!_g){ah=xCi(32)|0;c[ah+16>>2]=99;$g=ah+20|0;c[$g+0>>2]=0;c[$g+4>>2]=0;c[$g+8>>2]=0;c[ah>>2]=0;c[ah+4>>2]=0;c[ah+8>>2]=ch;c[bh>>2]=ah;ch=c[c[Xg>>2]>>2]|0;if(!ch)dh=ah;else{c[Xg>>2]=ch;dh=c[bh>>2]|0}GN(c[Rg>>2]|0,dh);dh=Xg+8|0;c[dh>>2]=(c[dh>>2]|0)+1;eh=ah}else eh=_g;zri(eh+20|0,3144120)|0;eh=c[149478]|0;_g=eh+4|0;ah=c[_g>>2]|0;do if(ah){dh=ah;while(1){Xg=c[dh+16>>2]|0;if((Xg|0)>100){Rg=c[dh>>2]|0;if(!Rg){fh=dh;gh=dh;o=616;break}else{dh=Rg;continue}}if((Xg|0)>=100){hh=dh;o=620;break}Xg=dh+4|0;Rg=c[Xg>>2]|0;if(!Rg){ih=Xg;jh=dh;o=619;break}else dh=Rg}if((o|0)==616){c[d>>2]=gh;kh=fh;lh=gh;break}else if((o|0)==619){c[d>>2]=jh;kh=ih;lh=jh;break}else if((o|0)==620){c[d>>2]=hh;kh=d;lh=hh;break}}else{dh=eh+4|0;c[d>>2]=dh;kh=dh;lh=dh}while(0);hh=c[kh>>2]|0;if(!hh){jh=xCi(32)|0;c[jh+16>>2]=100;ih=jh+20|0;c[ih+0>>2]=0;c[ih+4>>2]=0;c[ih+8>>2]=0;c[jh>>2]=0;c[jh+4>>2]=0;c[jh+8>>2]=lh;c[kh>>2]=jh;lh=c[c[eh>>2]>>2]|0;if(!lh)mh=jh;else{c[eh>>2]=lh;mh=c[kh>>2]|0}GN(c[_g>>2]|0,mh);mh=eh+8|0;c[mh>>2]=(c[mh>>2]|0)+1;nh=jh}else nh=hh;zri(nh+20|0,3145312)|0;nh=c[149478]|0;hh=nh+4|0;jh=c[hh>>2]|0;do if(jh){mh=jh;while(1){eh=c[mh+16>>2]|0;if((eh|0)>101){_g=c[mh>>2]|0;if(!_g){oh=mh;ph=mh;o=629;break}else{mh=_g;continue}}if((eh|0)>=101){qh=mh;o=633;break}eh=mh+4|0;_g=c[eh>>2]|0;if(!_g){rh=eh;sh=mh;o=632;break}else mh=_g}if((o|0)==629){c[d>>2]=ph;th=oh;uh=ph;break}else if((o|0)==632){c[d>>2]=sh;th=rh;uh=sh;break}else if((o|0)==633){c[d>>2]=qh;th=d;uh=qh;break}}else{mh=nh+4|0;c[d>>2]=mh;th=mh;uh=mh}while(0);qh=c[th>>2]|0;if(!qh){sh=xCi(32)|0;c[sh+16>>2]=101;rh=sh+20|0;c[rh+0>>2]=0;c[rh+4>>2]=0;c[rh+8>>2]=0;c[sh>>2]=0;c[sh+4>>2]=0;c[sh+8>>2]=uh;c[th>>2]=sh;uh=c[c[nh>>2]>>2]|0;if(!uh)vh=sh;else{c[nh>>2]=uh;vh=c[th>>2]|0}GN(c[hh>>2]|0,vh);vh=nh+8|0;c[vh>>2]=(c[vh>>2]|0)+1;wh=sh}else wh=qh;zri(wh+20|0,3141936)|0;wh=c[149478]|0;qh=wh+4|0;sh=c[qh>>2]|0;do if(sh){vh=sh;while(1){nh=c[vh+16>>2]|0;if((nh|0)>102){hh=c[vh>>2]|0;if(!hh){xh=vh;yh=vh;o=642;break}else{vh=hh;continue}}if((nh|0)>=102){zh=vh;o=646;break}nh=vh+4|0;hh=c[nh>>2]|0;if(!hh){Ah=nh;Bh=vh;o=645;break}else vh=hh}if((o|0)==642){c[d>>2]=yh;Ch=xh;Dh=yh;break}else if((o|0)==645){c[d>>2]=Bh;Ch=Ah;Dh=Bh;break}else if((o|0)==646){c[d>>2]=zh;Ch=d;Dh=zh;break}}else{vh=wh+4|0;c[d>>2]=vh;Ch=vh;Dh=vh}while(0);zh=c[Ch>>2]|0;if(!zh){Bh=xCi(32)|0;c[Bh+16>>2]=102;Ah=Bh+20|0;c[Ah+0>>2]=0;c[Ah+4>>2]=0;c[Ah+8>>2]=0;c[Bh>>2]=0;c[Bh+4>>2]=0;c[Bh+8>>2]=Dh;c[Ch>>2]=Bh;Dh=c[c[wh>>2]>>2]|0;if(!Dh)Eh=Bh;else{c[wh>>2]=Dh;Eh=c[Ch>>2]|0}GN(c[qh>>2]|0,Eh);Eh=wh+8|0;c[Eh>>2]=(c[Eh>>2]|0)+1;Fh=Bh}else Fh=zh;zri(Fh+20|0,3145592)|0;Fh=c[149478]|0;zh=Fh+4|0;Bh=c[zh>>2]|0;do if(Bh){Eh=Bh;while(1){wh=c[Eh+16>>2]|0;if((wh|0)>103){qh=c[Eh>>2]|0;if(!qh){Gh=Eh;Hh=Eh;o=655;break}else{Eh=qh;continue}}if((wh|0)>=103){Ih=Eh;o=659;break}wh=Eh+4|0;qh=c[wh>>2]|0;if(!qh){Jh=wh;Kh=Eh;o=658;break}else Eh=qh}if((o|0)==655){c[d>>2]=Hh;Lh=Gh;Mh=Hh;break}else if((o|0)==658){c[d>>2]=Kh;Lh=Jh;Mh=Kh;break}else if((o|0)==659){c[d>>2]=Ih;Lh=d;Mh=Ih;break}}else{Eh=Fh+4|0;c[d>>2]=Eh;Lh=Eh;Mh=Eh}while(0);Ih=c[Lh>>2]|0;if(!Ih){Kh=xCi(32)|0;c[Kh+16>>2]=103;Jh=Kh+20|0;c[Jh+0>>2]=0;c[Jh+4>>2]=0;c[Jh+8>>2]=0;c[Kh>>2]=0;c[Kh+4>>2]=0;c[Kh+8>>2]=Mh;c[Lh>>2]=Kh;Mh=c[c[Fh>>2]>>2]|0;if(!Mh)Nh=Kh;else{c[Fh>>2]=Mh;Nh=c[Lh>>2]|0}GN(c[zh>>2]|0,Nh);Nh=Fh+8|0;c[Nh>>2]=(c[Nh>>2]|0)+1;Oh=Kh}else Oh=Ih;zri(Oh+20|0,3145576)|0;Oh=c[149478]|0;Ih=Oh+4|0;Kh=c[Ih>>2]|0;do if(Kh){Nh=Kh;while(1){Fh=c[Nh+16>>2]|0;if((Fh|0)>104){zh=c[Nh>>2]|0;if(!zh){Ph=Nh;Qh=Nh;o=668;break}else{Nh=zh;continue}}if((Fh|0)>=104){Rh=Nh;o=672;break}Fh=Nh+4|0;zh=c[Fh>>2]|0;if(!zh){Sh=Fh;Th=Nh;o=671;break}else Nh=zh}if((o|0)==668){c[d>>2]=Qh;Uh=Ph;Vh=Qh;break}else if((o|0)==671){c[d>>2]=Th;Uh=Sh;Vh=Th;break}else if((o|0)==672){c[d>>2]=Rh;Uh=d;Vh=Rh;break}}else{Nh=Oh+4|0;c[d>>2]=Nh;Uh=Nh;Vh=Nh}while(0);Rh=c[Uh>>2]|0;if(!Rh){Th=xCi(32)|0;c[Th+16>>2]=104;Sh=Th+20|0;c[Sh+0>>2]=0;c[Sh+4>>2]=0;c[Sh+8>>2]=0;c[Th>>2]=0;c[Th+4>>2]=0;c[Th+8>>2]=Vh;c[Uh>>2]=Th;Vh=c[c[Oh>>2]>>2]|0;if(!Vh)Wh=Th;else{c[Oh>>2]=Vh;Wh=c[Uh>>2]|0}GN(c[Ih>>2]|0,Wh);Wh=Oh+8|0;c[Wh>>2]=(c[Wh>>2]|0)+1;Xh=Th}else Xh=Rh;zri(Xh+20|0,3145544)|0;Xh=c[149478]|0;Rh=Xh+4|0;Th=c[Rh>>2]|0;do if(Th){Wh=Th;while(1){Oh=c[Wh+16>>2]|0;if((Oh|0)>105){Ih=c[Wh>>2]|0;if(!Ih){Yh=Wh;Zh=Wh;o=681;break}else{Wh=Ih;continue}}if((Oh|0)>=105){_h=Wh;o=685;break}Oh=Wh+4|0;Ih=c[Oh>>2]|0;if(!Ih){$h=Oh;ai=Wh;o=684;break}else Wh=Ih}if((o|0)==681){c[d>>2]=Zh;bi=Yh;ci=Zh;break}else if((o|0)==684){c[d>>2]=ai;bi=$h;ci=ai;break}else if((o|0)==685){c[d>>2]=_h;bi=d;ci=_h;break}}else{Wh=Xh+4|0;c[d>>2]=Wh;bi=Wh;ci=Wh}while(0);_h=c[bi>>2]|0;if(!_h){ai=xCi(32)|0;c[ai+16>>2]=105;$h=ai+20|0;c[$h+0>>2]=0;c[$h+4>>2]=0;c[$h+8>>2]=0;c[ai>>2]=0;c[ai+4>>2]=0;c[ai+8>>2]=ci;c[bi>>2]=ai;ci=c[c[Xh>>2]>>2]|0;if(!ci)di=ai;else{c[Xh>>2]=ci;di=c[bi>>2]|0}GN(c[Rh>>2]|0,di);di=Xh+8|0;c[di>>2]=(c[di>>2]|0)+1;ei=ai}else ei=_h;zri(ei+20|0,3144184)|0;ei=c[149478]|0;_h=ei+4|0;ai=c[_h>>2]|0;do if(ai){di=ai;while(1){Xh=c[di+16>>2]|0;if((Xh|0)>106){Rh=c[di>>2]|0;if(!Rh){fi=di;gi=di;o=694;break}else{di=Rh;continue}}if((Xh|0)>=106){hi=di;o=698;break}Xh=di+4|0;Rh=c[Xh>>2]|0;if(!Rh){ii=Xh;ji=di;o=697;break}else di=Rh}if((o|0)==694){c[d>>2]=gi;ki=fi;li=gi;break}else if((o|0)==697){c[d>>2]=ji;ki=ii;li=ji;break}else if((o|0)==698){c[d>>2]=hi;ki=d;li=hi;break}}else{di=ei+4|0;c[d>>2]=di;ki=di;li=di}while(0);hi=c[ki>>2]|0;if(!hi){ji=xCi(32)|0;c[ji+16>>2]=106;ii=ji+20|0;c[ii+0>>2]=0;c[ii+4>>2]=0;c[ii+8>>2]=0;c[ji>>2]=0;c[ji+4>>2]=0;c[ji+8>>2]=li;c[ki>>2]=ji;li=c[c[ei>>2]>>2]|0;if(!li)mi=ji;else{c[ei>>2]=li;mi=c[ki>>2]|0}GN(c[_h>>2]|0,mi);mi=ei+8|0;c[mi>>2]=(c[mi>>2]|0)+1;ni=ji}else ni=hi;zri(ni+20|0,3145600)|0;ni=c[149478]|0;hi=ni+4|0;ji=c[hi>>2]|0;do if(ji){mi=ji;while(1){ei=c[mi+16>>2]|0;if((ei|0)>107){_h=c[mi>>2]|0;if(!_h){oi=mi;pi=mi;o=707;break}else{mi=_h;continue}}if((ei|0)>=107){qi=mi;o=711;break}ei=mi+4|0;_h=c[ei>>2]|0;if(!_h){ri=ei;si=mi;o=710;break}else mi=_h}if((o|0)==707){c[d>>2]=pi;ti=oi;ui=pi;break}else if((o|0)==710){c[d>>2]=si;ti=ri;ui=si;break}else if((o|0)==711){c[d>>2]=qi;ti=d;ui=qi;break}}else{mi=ni+4|0;c[d>>2]=mi;ti=mi;ui=mi}while(0);qi=c[ti>>2]|0;if(!qi){si=xCi(32)|0;c[si+16>>2]=107;ri=si+20|0;c[ri+0>>2]=0;c[ri+4>>2]=0;c[ri+8>>2]=0;c[si>>2]=0;c[si+4>>2]=0;c[si+8>>2]=ui;c[ti>>2]=si;ui=c[c[ni>>2]>>2]|0;if(!ui)vi=si;else{c[ni>>2]=ui;vi=c[ti>>2]|0}GN(c[hi>>2]|0,vi);vi=ni+8|0;c[vi>>2]=(c[vi>>2]|0)+1;wi=si}else wi=qi;zri(wi+20|0,3145608)|0;wi=c[149478]|0;qi=wi+4|0;si=c[qi>>2]|0;do if(si){vi=si;while(1){ni=c[vi+16>>2]|0;if((ni|0)>108){hi=c[vi>>2]|0;if(!hi){xi=vi;yi=vi;o=720;break}else{vi=hi;continue}}if((ni|0)>=108){zi=vi;o=724;break}ni=vi+4|0;hi=c[ni>>2]|0;if(!hi){Ai=ni;Bi=vi;o=723;break}else vi=hi}if((o|0)==720){c[d>>2]=yi;Ci=xi;Di=yi;break}else if((o|0)==723){c[d>>2]=Bi;Ci=Ai;Di=Bi;break}else if((o|0)==724){c[d>>2]=zi;Ci=d;Di=zi;break}}else{vi=wi+4|0;c[d>>2]=vi;Ci=vi;Di=vi}while(0);zi=c[Ci>>2]|0;if(!zi){Bi=xCi(32)|0;c[Bi+16>>2]=108;Ai=Bi+20|0;c[Ai+0>>2]=0;c[Ai+4>>2]=0;c[Ai+8>>2]=0;c[Bi>>2]=0;c[Bi+4>>2]=0;c[Bi+8>>2]=Di;c[Ci>>2]=Bi;Di=c[c[wi>>2]>>2]|0;if(!Di)Ei=Bi;else{c[wi>>2]=Di;Ei=c[Ci>>2]|0}GN(c[qi>>2]|0,Ei);Ei=wi+8|0;c[Ei>>2]=(c[Ei>>2]|0)+1;Fi=Bi}else Fi=zi;zri(Fi+20|0,3653496)|0;Fi=c[149478]|0;zi=Fi+4|0;Bi=c[zi>>2]|0;do if(Bi){Ei=Bi;while(1){wi=c[Ei+16>>2]|0;if((wi|0)>109){qi=c[Ei>>2]|0;if(!qi){Gi=Ei;Hi=Ei;o=733;break}else{Ei=qi;continue}}if((wi|0)>=109){Ii=Ei;o=737;break}wi=Ei+4|0;qi=c[wi>>2]|0;if(!qi){Ji=wi;Ki=Ei;o=736;break}else Ei=qi}if((o|0)==733){c[d>>2]=Hi;Li=Gi;Mi=Hi;break}else if((o|0)==736){c[d>>2]=Ki;Li=Ji;Mi=Ki;break}else if((o|0)==737){c[d>>2]=Ii;Li=d;Mi=Ii;break}}else{Ei=Fi+4|0;c[d>>2]=Ei;Li=Ei;Mi=Ei}while(0);Ii=c[Li>>2]|0;if(!Ii){Ki=xCi(32)|0;c[Ki+16>>2]=109;Ji=Ki+20|0;c[Ji+0>>2]=0;c[Ji+4>>2]=0;c[Ji+8>>2]=0;c[Ki>>2]=0;c[Ki+4>>2]=0;c[Ki+8>>2]=Mi;c[Li>>2]=Ki;Mi=c[c[Fi>>2]>>2]|0;if(!Mi)Ni=Ki;else{c[Fi>>2]=Mi;Ni=c[Li>>2]|0}GN(c[zi>>2]|0,Ni);Ni=Fi+8|0;c[Ni>>2]=(c[Ni>>2]|0)+1;Oi=Ki}else Oi=Ii;zri(Oi+20|0,3141976)|0;Oi=c[149478]|0;Ii=Oi+4|0;Ki=c[Ii>>2]|0;do if(Ki){Ni=Ki;while(1){Fi=c[Ni+16>>2]|0;if((Fi|0)>110){zi=c[Ni>>2]|0;if(!zi){Pi=Ni;Qi=Ni;o=746;break}else{Ni=zi;continue}}if((Fi|0)>=110){Ri=Ni;o=750;break}Fi=Ni+4|0;zi=c[Fi>>2]|0;if(!zi){Si=Fi;Ti=Ni;o=749;break}else Ni=zi}if((o|0)==746){c[d>>2]=Qi;Ui=Pi;Vi=Qi;break}else if((o|0)==749){c[d>>2]=Ti;Ui=Si;Vi=Ti;break}else if((o|0)==750){c[d>>2]=Ri;Ui=d;Vi=Ri;break}}else{Ni=Oi+4|0;c[d>>2]=Ni;Ui=Ni;Vi=Ni}while(0);Ri=c[Ui>>2]|0;if(!Ri){Ti=xCi(32)|0;c[Ti+16>>2]=110;Si=Ti+20|0;c[Si+0>>2]=0;c[Si+4>>2]=0;c[Si+8>>2]=0;c[Ti>>2]=0;c[Ti+4>>2]=0;c[Ti+8>>2]=Vi;c[Ui>>2]=Ti;Vi=c[c[Oi>>2]>>2]|0;if(!Vi)Wi=Ti;else{c[Oi>>2]=Vi;Wi=c[Ui>>2]|0}GN(c[Ii>>2]|0,Wi);Wi=Oi+8|0;c[Wi>>2]=(c[Wi>>2]|0)+1;Xi=Ti}else Xi=Ri;zri(Xi+20|0,2684920)|0;Xi=c[149478]|0;Ri=Xi+4|0;Ti=c[Ri>>2]|0;do if(Ti){Wi=Ti;while(1){Oi=c[Wi+16>>2]|0;if((Oi|0)>111){Ii=c[Wi>>2]|0;if(!Ii){Yi=Wi;Zi=Wi;o=759;break}else{Wi=Ii;continue}}if((Oi|0)>=111){_i=Wi;o=763;break}Oi=Wi+4|0;Ii=c[Oi>>2]|0;if(!Ii){$i=Oi;aj=Wi;o=762;break}else Wi=Ii}if((o|0)==759){c[d>>2]=Zi;bj=Yi;cj=Zi;break}else if((o|0)==762){c[d>>2]=aj;bj=$i;cj=aj;break}else if((o|0)==763){c[d>>2]=_i;bj=d;cj=_i;break}}else{Wi=Xi+4|0;c[d>>2]=Wi;bj=Wi;cj=Wi}while(0);_i=c[bj>>2]|0;if(!_i){aj=xCi(32)|0;c[aj+16>>2]=111;$i=aj+20|0;c[$i+0>>2]=0;c[$i+4>>2]=0;c[$i+8>>2]=0;c[aj>>2]=0;c[aj+4>>2]=0;c[aj+8>>2]=cj;c[bj>>2]=aj;cj=c[c[Xi>>2]>>2]|0;if(!cj)dj=aj;else{c[Xi>>2]=cj;dj=c[bj>>2]|0}GN(c[Ri>>2]|0,dj);dj=Xi+8|0;c[dj>>2]=(c[dj>>2]|0)+1;ej=aj}else ej=_i;zri(ej+20|0,3145584)|0;ej=c[149478]|0;_i=ej+4|0;aj=c[_i>>2]|0;do if(aj){dj=aj;while(1){Xi=c[dj+16>>2]|0;if((Xi|0)>112){Ri=c[dj>>2]|0;if(!Ri){fj=dj;gj=dj;o=772;break}else{dj=Ri;continue}}if((Xi|0)>=112){hj=dj;o=776;break}Xi=dj+4|0;Ri=c[Xi>>2]|0;if(!Ri){ij=Xi;jj=dj;o=775;break}else dj=Ri}if((o|0)==772){c[d>>2]=gj;kj=fj;lj=gj;break}else if((o|0)==775){c[d>>2]=jj;kj=ij;lj=jj;break}else if((o|0)==776){c[d>>2]=hj;kj=d;lj=hj;break}}else{dj=ej+4|0;c[d>>2]=dj;kj=dj;lj=dj}while(0);hj=c[kj>>2]|0;if(!hj){jj=xCi(32)|0;c[jj+16>>2]=112;ij=jj+20|0;c[ij+0>>2]=0;c[ij+4>>2]=0;c[ij+8>>2]=0;c[jj>>2]=0;c[jj+4>>2]=0;c[jj+8>>2]=lj;c[kj>>2]=jj;lj=c[c[ej>>2]>>2]|0;if(!lj)mj=jj;else{c[ej>>2]=lj;mj=c[kj>>2]|0}GN(c[_i>>2]|0,mj);mj=ej+8|0;c[mj>>2]=(c[mj>>2]|0)+1;nj=jj}else nj=hj;zri(nj+20|0,3145552)|0;nj=c[149478]|0;hj=nj+4|0;jj=c[hj>>2]|0;do if(jj){mj=jj;while(1){ej=c[mj+16>>2]|0;if((ej|0)>113){_i=c[mj>>2]|0;if(!_i){oj=mj;pj=mj;o=785;break}else{mj=_i;continue}}if((ej|0)>=113){qj=mj;o=789;break}ej=mj+4|0;_i=c[ej>>2]|0;if(!_i){rj=ej;sj=mj;o=788;break}else mj=_i}if((o|0)==785){c[d>>2]=pj;tj=oj;uj=pj;break}else if((o|0)==788){c[d>>2]=sj;tj=rj;uj=sj;break}else if((o|0)==789){c[d>>2]=qj;tj=d;uj=qj;break}}else{mj=nj+4|0;c[d>>2]=mj;tj=mj;uj=mj}while(0);qj=c[tj>>2]|0;if(!qj){sj=xCi(32)|0;c[sj+16>>2]=113;rj=sj+20|0;c[rj+0>>2]=0;c[rj+4>>2]=0;c[rj+8>>2]=0;c[sj>>2]=0;c[sj+4>>2]=0;c[sj+8>>2]=uj;c[tj>>2]=sj;uj=c[c[nj>>2]>>2]|0;if(!uj)vj=sj;else{c[nj>>2]=uj;vj=c[tj>>2]|0}GN(c[hj>>2]|0,vj);vj=nj+8|0;c[vj>>2]=(c[vj>>2]|0)+1;wj=sj}else wj=qj;zri(wj+20|0,2473736)|0;wj=c[149478]|0;qj=wj+4|0;sj=c[qj>>2]|0;do if(sj){vj=sj;while(1){nj=c[vj+16>>2]|0;if((nj|0)>114){hj=c[vj>>2]|0;if(!hj){xj=vj;yj=vj;o=798;break}else{vj=hj;continue}}if((nj|0)>=114){zj=vj;o=802;break}nj=vj+4|0;hj=c[nj>>2]|0;if(!hj){Aj=nj;Bj=vj;o=801;break}else vj=hj}if((o|0)==798){c[d>>2]=yj;Cj=xj;Dj=yj;break}else if((o|0)==801){c[d>>2]=Bj;Cj=Aj;Dj=Bj;break}else if((o|0)==802){c[d>>2]=zj;Cj=d;Dj=zj;break}}else{vj=wj+4|0;c[d>>2]=vj;Cj=vj;Dj=vj}while(0);zj=c[Cj>>2]|0;if(!zj){Bj=xCi(32)|0;c[Bj+16>>2]=114;Aj=Bj+20|0;c[Aj+0>>2]=0;c[Aj+4>>2]=0;c[Aj+8>>2]=0;c[Bj>>2]=0;c[Bj+4>>2]=0;c[Bj+8>>2]=Dj;c[Cj>>2]=Bj;Dj=c[c[wj>>2]>>2]|0;if(!Dj)Ej=Bj;else{c[wj>>2]=Dj;Ej=c[Cj>>2]|0}GN(c[qj>>2]|0,Ej);Ej=wj+8|0;c[Ej>>2]=(c[Ej>>2]|0)+1;Fj=Bj}else Fj=zj;zri(Fj+20|0,2417856)|0;Fj=c[149478]|0;zj=Fj+4|0;Bj=c[zj>>2]|0;do if(Bj){Ej=Bj;while(1){wj=c[Ej+16>>2]|0;if((wj|0)>115){qj=c[Ej>>2]|0;if(!qj){Gj=Ej;Hj=Ej;o=811;break}else{Ej=qj;continue}}if((wj|0)>=115){Ij=Ej;o=815;break}wj=Ej+4|0;qj=c[wj>>2]|0;if(!qj){Jj=wj;Kj=Ej;o=814;break}else Ej=qj}if((o|0)==811){c[d>>2]=Hj;Lj=Gj;Mj=Hj;break}else if((o|0)==814){c[d>>2]=Kj;Lj=Jj;Mj=Kj;break}else if((o|0)==815){c[d>>2]=Ij;Lj=d;Mj=Ij;break}}else{Ej=Fj+4|0;c[d>>2]=Ej;Lj=Ej;Mj=Ej}while(0);Ij=c[Lj>>2]|0;if(!Ij){Kj=xCi(32)|0;c[Kj+16>>2]=115;Jj=Kj+20|0;c[Jj+0>>2]=0;c[Jj+4>>2]=0;c[Jj+8>>2]=0;c[Kj>>2]=0;c[Kj+4>>2]=0;c[Kj+8>>2]=Mj;c[Lj>>2]=Kj;Mj=c[c[Fj>>2]>>2]|0;if(!Mj)Nj=Kj;else{c[Fj>>2]=Mj;Nj=c[Lj>>2]|0}GN(c[zj>>2]|0,Nj);Nj=Fj+8|0;c[Nj>>2]=(c[Nj>>2]|0)+1;Oj=Kj}else Oj=Ij;zri(Oj+20|0,3143208)|0;Oj=c[149478]|0;Ij=Oj+4|0;Kj=c[Ij>>2]|0;do if(Kj){Nj=Kj;while(1){Fj=c[Nj+16>>2]|0;if((Fj|0)>116){zj=c[Nj>>2]|0;if(!zj){Pj=Nj;Qj=Nj;o=824;break}else{Nj=zj;continue}}if((Fj|0)>=116){Rj=Nj;o=828;break}Fj=Nj+4|0;zj=c[Fj>>2]|0;if(!zj){Sj=Fj;Tj=Nj;o=827;break}else Nj=zj}if((o|0)==824){c[d>>2]=Qj;Uj=Pj;Vj=Qj;break}else if((o|0)==827){c[d>>2]=Tj;Uj=Sj;Vj=Tj;break}else if((o|0)==828){c[d>>2]=Rj;Uj=d;Vj=Rj;break}}else{Nj=Oj+4|0;c[d>>2]=Nj;Uj=Nj;Vj=Nj}while(0);Rj=c[Uj>>2]|0;if(!Rj){Tj=xCi(32)|0;c[Tj+16>>2]=116;Sj=Tj+20|0;c[Sj+0>>2]=0;c[Sj+4>>2]=0;c[Sj+8>>2]=0;c[Tj>>2]=0;c[Tj+4>>2]=0;c[Tj+8>>2]=Vj;c[Uj>>2]=Tj;Vj=c[c[Oj>>2]>>2]|0;if(!Vj)Wj=Tj;else{c[Oj>>2]=Vj;Wj=c[Uj>>2]|0}GN(c[Ij>>2]|0,Wj);Wj=Oj+8|0;c[Wj>>2]=(c[Wj>>2]|0)+1;Xj=Tj}else Xj=Rj;zri(Xj+20|0,3068392)|0;Xj=c[149478]|0;Rj=Xj+4|0;Tj=c[Rj>>2]|0;do if(Tj){Wj=Tj;while(1){Oj=c[Wj+16>>2]|0;if((Oj|0)>117){Ij=c[Wj>>2]|0;if(!Ij){Yj=Wj;Zj=Wj;o=837;break}else{Wj=Ij;continue}}if((Oj|0)>=117){_j=Wj;o=841;break}Oj=Wj+4|0;Ij=c[Oj>>2]|0;if(!Ij){$j=Oj;ak=Wj;o=840;break}else Wj=Ij}if((o|0)==837){c[d>>2]=Zj;bk=Yj;ck=Zj;break}else if((o|0)==840){c[d>>2]=ak;bk=$j;ck=ak;break}else if((o|0)==841){c[d>>2]=_j;bk=d;ck=_j;break}}else{Wj=Xj+4|0;c[d>>2]=Wj;bk=Wj;ck=Wj}while(0);_j=c[bk>>2]|0;if(!_j){ak=xCi(32)|0;c[ak+16>>2]=117;$j=ak+20|0;c[$j+0>>2]=0;c[$j+4>>2]=0;c[$j+8>>2]=0;c[ak>>2]=0;c[ak+4>>2]=0;c[ak+8>>2]=ck;c[bk>>2]=ak;ck=c[c[Xj>>2]>>2]|0;if(!ck)dk=ak;else{c[Xj>>2]=ck;dk=c[bk>>2]|0}GN(c[Rj>>2]|0,dk);dk=Xj+8|0;c[dk>>2]=(c[dk>>2]|0)+1;ek=ak}else ek=_j;zri(ek+20|0,598176)|0;ek=c[149478]|0;_j=ek+4|0;ak=c[_j>>2]|0;do if(ak){dk=ak;while(1){Xj=c[dk+16>>2]|0;if((Xj|0)>118){Rj=c[dk>>2]|0;if(!Rj){fk=dk;gk=dk;o=850;break}else{dk=Rj;continue}}if((Xj|0)>=118){hk=dk;o=854;break}Xj=dk+4|0;Rj=c[Xj>>2]|0;if(!Rj){ik=Xj;jk=dk;o=853;break}else dk=Rj}if((o|0)==850){c[d>>2]=gk;kk=fk;lk=gk;break}else if((o|0)==853){c[d>>2]=jk;kk=ik;lk=jk;break}else if((o|0)==854){c[d>>2]=hk;kk=d;lk=hk;break}}else{dk=ek+4|0;c[d>>2]=dk;kk=dk;lk=dk}while(0);hk=c[kk>>2]|0;if(!hk){jk=xCi(32)|0;c[jk+16>>2]=118;ik=jk+20|0;c[ik+0>>2]=0;c[ik+4>>2]=0;c[ik+8>>2]=0;c[jk>>2]=0;c[jk+4>>2]=0;c[jk+8>>2]=lk;c[kk>>2]=jk;lk=c[c[ek>>2]>>2]|0;if(!lk)mk=jk;else{c[ek>>2]=lk;mk=c[kk>>2]|0}GN(c[_j>>2]|0,mk);mk=ek+8|0;c[mk>>2]=(c[mk>>2]|0)+1;nk=jk}else nk=hk;zri(nk+20|0,3143408)|0;nk=c[149478]|0;hk=nk+4|0;jk=c[hk>>2]|0;do if(jk){mk=jk;while(1){ek=c[mk+16>>2]|0;if((ek|0)>119){_j=c[mk>>2]|0;if(!_j){ok=mk;pk=mk;o=863;break}else{mk=_j;continue}}if((ek|0)>=119){qk=mk;o=867;break}ek=mk+4|0;_j=c[ek>>2]|0;if(!_j){rk=ek;sk=mk;o=866;break}else mk=_j}if((o|0)==863){c[d>>2]=pk;tk=ok;uk=pk;break}else if((o|0)==866){c[d>>2]=sk;tk=rk;uk=sk;break}else if((o|0)==867){c[d>>2]=qk;tk=d;uk=qk;break}}else{mk=nk+4|0;c[d>>2]=mk;tk=mk;uk=mk}while(0);qk=c[tk>>2]|0;if(!qk){sk=xCi(32)|0;c[sk+16>>2]=119;rk=sk+20|0;c[rk+0>>2]=0;c[rk+4>>2]=0;c[rk+8>>2]=0;c[sk>>2]=0;c[sk+4>>2]=0;c[sk+8>>2]=uk;c[tk>>2]=sk;uk=c[c[nk>>2]>>2]|0;if(!uk)vk=sk;else{c[nk>>2]=uk;vk=c[tk>>2]|0}GN(c[hk>>2]|0,vk);vk=nk+8|0;c[vk>>2]=(c[vk>>2]|0)+1;wk=sk}else wk=qk;zri(wk+20|0,2419736)|0;wk=c[149478]|0;qk=wk+4|0;sk=c[qk>>2]|0;do if(sk){vk=sk;while(1){nk=c[vk+16>>2]|0;if((nk|0)>120){hk=c[vk>>2]|0;if(!hk){xk=vk;yk=vk;o=876;break}else{vk=hk;continue}}if((nk|0)>=120){zk=vk;o=880;break}nk=vk+4|0;hk=c[nk>>2]|0;if(!hk){Ak=nk;Bk=vk;o=879;break}else vk=hk}if((o|0)==876){c[d>>2]=yk;Ck=xk;Dk=yk;break}else if((o|0)==879){c[d>>2]=Bk;Ck=Ak;Dk=Bk;break}else if((o|0)==880){c[d>>2]=zk;Ck=d;Dk=zk;break}}else{vk=wk+4|0;c[d>>2]=vk;Ck=vk;Dk=vk}while(0);zk=c[Ck>>2]|0;if(!zk){Bk=xCi(32)|0;c[Bk+16>>2]=120;Ak=Bk+20|0;c[Ak+0>>2]=0;c[Ak+4>>2]=0;c[Ak+8>>2]=0;c[Bk>>2]=0;c[Bk+4>>2]=0;c[Bk+8>>2]=Dk;c[Ck>>2]=Bk;Dk=c[c[wk>>2]>>2]|0;if(!Dk)Ek=Bk;else{c[wk>>2]=Dk;Ek=c[Ck>>2]|0}GN(c[qk>>2]|0,Ek);Ek=wk+8|0;c[Ek>>2]=(c[Ek>>2]|0)+1;Fk=Bk}else Fk=zk;zri(Fk+20|0,3143216)|0;Fk=c[149478]|0;zk=Fk+4|0;Bk=c[zk>>2]|0;do if(Bk){Ek=Bk;while(1){wk=c[Ek+16>>2]|0;if((wk|0)>121){qk=c[Ek>>2]|0;if(!qk){Gk=Ek;Hk=Ek;o=889;break}else{Ek=qk;continue}}if((wk|0)>=121){Ik=Ek;o=893;break}wk=Ek+4|0;qk=c[wk>>2]|0;if(!qk){Jk=wk;Kk=Ek;o=892;break}else Ek=qk}if((o|0)==889){c[d>>2]=Hk;Lk=Gk;Mk=Hk;break}else if((o|0)==892){c[d>>2]=Kk;Lk=Jk;Mk=Kk;break}else if((o|0)==893){c[d>>2]=Ik;Lk=d;Mk=Ik;break}}else{Ek=Fk+4|0;c[d>>2]=Ek;Lk=Ek;Mk=Ek}while(0);Ik=c[Lk>>2]|0;if(!Ik){Kk=xCi(32)|0;c[Kk+16>>2]=121;Jk=Kk+20|0;c[Jk+0>>2]=0;c[Jk+4>>2]=0;c[Jk+8>>2]=0;c[Kk>>2]=0;c[Kk+4>>2]=0;c[Kk+8>>2]=Mk;c[Lk>>2]=Kk;Mk=c[c[Fk>>2]>>2]|0;if(!Mk)Nk=Kk;else{c[Fk>>2]=Mk;Nk=c[Lk>>2]|0}GN(c[zk>>2]|0,Nk);Nk=Fk+8|0;c[Nk>>2]=(c[Nk>>2]|0)+1;Ok=Kk}else Ok=Ik;zri(Ok+20|0,3143224)|0;Ok=c[149478]|0;Ik=Ok+4|0;Kk=c[Ik>>2]|0;do if(Kk){Nk=Kk;while(1){Fk=c[Nk+16>>2]|0;if((Fk|0)>122){zk=c[Nk>>2]|0;if(!zk){Pk=Nk;Qk=Nk;o=902;break}else{Nk=zk;continue}}if((Fk|0)>=122){Rk=Nk;o=906;break}Fk=Nk+4|0;zk=c[Fk>>2]|0;if(!zk){Sk=Fk;Tk=Nk;o=905;break}else Nk=zk}if((o|0)==902){c[d>>2]=Qk;Uk=Pk;Vk=Qk;break}else if((o|0)==905){c[d>>2]=Tk;Uk=Sk;Vk=Tk;break}else if((o|0)==906){c[d>>2]=Rk;Uk=d;Vk=Rk;break}}else{Nk=Ok+4|0;c[d>>2]=Nk;Uk=Nk;Vk=Nk}while(0);Rk=c[Uk>>2]|0;if(!Rk){Tk=xCi(32)|0;c[Tk+16>>2]=122;Sk=Tk+20|0;c[Sk+0>>2]=0;c[Sk+4>>2]=0;c[Sk+8>>2]=0;c[Tk>>2]=0;c[Tk+4>>2]=0;c[Tk+8>>2]=Vk;c[Uk>>2]=Tk;Vk=c[c[Ok>>2]>>2]|0;if(!Vk)Wk=Tk;else{c[Ok>>2]=Vk;Wk=c[Uk>>2]|0}GN(c[Ik>>2]|0,Wk);Wk=Ok+8|0;c[Wk>>2]=(c[Wk>>2]|0)+1;Xk=Tk}else Xk=Rk;zri(Xk+20|0,2416480)|0;Xk=c[149478]|0;Rk=Xk+4|0;Tk=c[Rk>>2]|0;do if(Tk){Wk=Tk;while(1){Ok=c[Wk+16>>2]|0;if((Ok|0)>127){Ik=c[Wk>>2]|0;if(!Ik){Yk=Wk;Zk=Wk;o=915;break}else{Wk=Ik;continue}}if((Ok|0)>=127){_k=Wk;o=919;break}Ok=Wk+4|0;Ik=c[Ok>>2]|0;if(!Ik){$k=Ok;al=Wk;o=918;break}else Wk=Ik}if((o|0)==915){c[d>>2]=Zk;bl=Yk;cl=Zk;break}else if((o|0)==918){c[d>>2]=al;bl=$k;cl=al;break}else if((o|0)==919){c[d>>2]=_k;bl=d;cl=_k;break}}else{Wk=Xk+4|0;c[d>>2]=Wk;bl=Wk;cl=Wk}while(0);_k=c[bl>>2]|0;if(!_k){al=xCi(32)|0;c[al+16>>2]=127;$k=al+20|0;c[$k+0>>2]=0;c[$k+4>>2]=0;c[$k+8>>2]=0;c[al>>2]=0;c[al+4>>2]=0;c[al+8>>2]=cl;c[bl>>2]=al;cl=c[c[Xk>>2]>>2]|0;if(!cl)dl=al;else{c[Xk>>2]=cl;dl=c[bl>>2]|0}GN(c[Rk>>2]|0,dl);dl=Xk+8|0;c[dl>>2]=(c[dl>>2]|0)+1;el=al}else el=_k;zri(el+20|0,598184)|0;el=c[149478]|0;_k=el+4|0;al=c[_k>>2]|0;do if(al){dl=al;while(1){Xk=c[dl+16>>2]|0;if((Xk|0)>160){Rk=c[dl>>2]|0;if(!Rk){fl=dl;gl=dl;o=928;break}else{dl=Rk;continue}}if((Xk|0)>=160){hl=dl;o=932;break}Xk=dl+4|0;Rk=c[Xk>>2]|0;if(!Rk){il=Xk;jl=dl;o=931;break}else dl=Rk}if((o|0)==928){c[d>>2]=gl;kl=fl;ll=gl;break}else if((o|0)==931){c[d>>2]=jl;kl=il;ll=jl;break}else if((o|0)==932){c[d>>2]=hl;kl=d;ll=hl;break}}else{dl=el+4|0;c[d>>2]=dl;kl=dl;ll=dl}while(0);hl=c[kl>>2]|0;if(!hl){jl=xCi(32)|0;c[jl+16>>2]=160;il=jl+20|0;c[il+0>>2]=0;c[il+4>>2]=0;c[il+8>>2]=0;c[jl>>2]=0;c[jl+4>>2]=0;c[jl+8>>2]=ll;c[kl>>2]=jl;ll=c[c[el>>2]>>2]|0;if(!ll)ml=jl;else{c[el>>2]=ll;ml=c[kl>>2]|0}GN(c[_k>>2]|0,ml);ml=el+8|0;c[ml>>2]=(c[ml>>2]|0)+1;nl=jl}else nl=hl;zri(nl+20|0,598192)|0;nl=c[149478]|0;hl=nl+4|0;jl=c[hl>>2]|0;do if(jl){ml=jl;while(1){el=c[ml+16>>2]|0;if((el|0)>161){_k=c[ml>>2]|0;if(!_k){ol=ml;pl=ml;o=941;break}else{ml=_k;continue}}if((el|0)>=161){ql=ml;o=945;break}el=ml+4|0;_k=c[el>>2]|0;if(!_k){rl=el;sl=ml;o=944;break}else ml=_k}if((o|0)==941){c[d>>2]=pl;tl=ol;ul=pl;break}else if((o|0)==944){c[d>>2]=sl;tl=rl;ul=sl;break}else if((o|0)==945){c[d>>2]=ql;tl=d;ul=ql;break}}else{ml=nl+4|0;c[d>>2]=ml;tl=ml;ul=ml}while(0);ql=c[tl>>2]|0;if(!ql){sl=xCi(32)|0;c[sl+16>>2]=161;rl=sl+20|0;c[rl+0>>2]=0;c[rl+4>>2]=0;c[rl+8>>2]=0;c[sl>>2]=0;c[sl+4>>2]=0;c[sl+8>>2]=ul;c[tl>>2]=sl;ul=c[c[nl>>2]>>2]|0;if(!ul)vl=sl;else{c[nl>>2]=ul;vl=c[tl>>2]|0}GN(c[hl>>2]|0,vl);vl=nl+8|0;c[vl>>2]=(c[vl>>2]|0)+1;wl=sl}else wl=ql;zri(wl+20|0,598200)|0;wl=c[149478]|0;ql=wl+4|0;sl=c[ql>>2]|0;do if(sl){vl=sl;while(1){nl=c[vl+16>>2]|0;if((nl|0)>162){hl=c[vl>>2]|0;if(!hl){xl=vl;yl=vl;o=954;break}else{vl=hl;continue}}if((nl|0)>=162){zl=vl;o=958;break}nl=vl+4|0;hl=c[nl>>2]|0;if(!hl){Al=nl;Bl=vl;o=957;break}else vl=hl}if((o|0)==954){c[d>>2]=yl;Cl=xl;Dl=yl;break}else if((o|0)==957){c[d>>2]=Bl;Cl=Al;Dl=Bl;break}else if((o|0)==958){c[d>>2]=zl;Cl=d;Dl=zl;break}}else{vl=wl+4|0;c[d>>2]=vl;Cl=vl;Dl=vl}while(0);zl=c[Cl>>2]|0;if(!zl){Bl=xCi(32)|0;c[Bl+16>>2]=162;Al=Bl+20|0;c[Al+0>>2]=0;c[Al+4>>2]=0;c[Al+8>>2]=0;c[Bl>>2]=0;c[Bl+4>>2]=0;c[Bl+8>>2]=Dl;c[Cl>>2]=Bl;Dl=c[c[wl>>2]>>2]|0;if(!Dl)El=Bl;else{c[wl>>2]=Dl;El=c[Cl>>2]|0}GN(c[ql>>2]|0,El);El=wl+8|0;c[El>>2]=(c[El>>2]|0)+1;Fl=Bl}else Fl=zl;zri(Fl+20|0,598208)|0;Fl=c[149478]|0;zl=Fl+4|0;Bl=c[zl>>2]|0;do if(Bl){El=Bl;while(1){wl=c[El+16>>2]|0;if((wl|0)>163){ql=c[El>>2]|0;if(!ql){Gl=El;Hl=El;o=967;break}else{El=ql;continue}}if((wl|0)>=163){Il=El;o=971;break}wl=El+4|0;ql=c[wl>>2]|0;if(!ql){Jl=wl;Kl=El;o=970;break}else El=ql}if((o|0)==967){c[d>>2]=Hl;Ll=Gl;Ml=Hl;break}else if((o|0)==970){c[d>>2]=Kl;Ll=Jl;Ml=Kl;break}else if((o|0)==971){c[d>>2]=Il;Ll=d;Ml=Il;break}}else{El=Fl+4|0;c[d>>2]=El;Ll=El;Ml=El}while(0);Il=c[Ll>>2]|0;if(!Il){Kl=xCi(32)|0;c[Kl+16>>2]=163;Jl=Kl+20|0;c[Jl+0>>2]=0;c[Jl+4>>2]=0;c[Jl+8>>2]=0;c[Kl>>2]=0;c[Kl+4>>2]=0;c[Kl+8>>2]=Ml;c[Ll>>2]=Kl;Ml=c[c[Fl>>2]>>2]|0;if(!Ml)Nl=Kl;else{c[Fl>>2]=Ml;Nl=c[Ll>>2]|0}GN(c[zl>>2]|0,Nl);Nl=Fl+8|0;c[Nl>>2]=(c[Nl>>2]|0)+1;Ol=Kl}else Ol=Il;zri(Ol+20|0,598216)|0;Ol=c[149478]|0;Il=Ol+4|0;Kl=c[Il>>2]|0;do if(Kl){Nl=Kl;while(1){Fl=c[Nl+16>>2]|0;if((Fl|0)>164){zl=c[Nl>>2]|0;if(!zl){Pl=Nl;Ql=Nl;o=980;break}else{Nl=zl;continue}}if((Fl|0)>=164){Rl=Nl;o=984;break}Fl=Nl+4|0;zl=c[Fl>>2]|0;if(!zl){Sl=Fl;Tl=Nl;o=983;break}else Nl=zl}if((o|0)==980){c[d>>2]=Ql;Ul=Pl;Vl=Ql;break}else if((o|0)==983){c[d>>2]=Tl;Ul=Sl;Vl=Tl;break}else if((o|0)==984){c[d>>2]=Rl;Ul=d;Vl=Rl;break}}else{Nl=Ol+4|0;c[d>>2]=Nl;Ul=Nl;Vl=Nl}while(0);Rl=c[Ul>>2]|0;if(!Rl){Tl=xCi(32)|0;c[Tl+16>>2]=164;Sl=Tl+20|0;c[Sl+0>>2]=0;c[Sl+4>>2]=0;c[Sl+8>>2]=0;c[Tl>>2]=0;c[Tl+4>>2]=0;c[Tl+8>>2]=Vl;c[Ul>>2]=Tl;Vl=c[c[Ol>>2]>>2]|0;if(!Vl)Wl=Tl;else{c[Ol>>2]=Vl;Wl=c[Ul>>2]|0}GN(c[Il>>2]|0,Wl);Wl=Ol+8|0;c[Wl>>2]=(c[Wl>>2]|0)+1;Xl=Tl}else Xl=Rl;zri(Xl+20|0,598224)|0;Xl=c[149478]|0;Rl=Xl+4|0;Tl=c[Rl>>2]|0;do if(Tl){Wl=Tl;while(1){Ol=c[Wl+16>>2]|0;if((Ol|0)>165){Il=c[Wl>>2]|0;if(!Il){Yl=Wl;Zl=Wl;o=993;break}else{Wl=Il;continue}}if((Ol|0)>=165){_l=Wl;o=997;break}Ol=Wl+4|0;Il=c[Ol>>2]|0;if(!Il){$l=Ol;am=Wl;o=996;break}else Wl=Il}if((o|0)==993){c[d>>2]=Zl;bm=Yl;cm=Zl;break}else if((o|0)==996){c[d>>2]=am;bm=$l;cm=am;break}else if((o|0)==997){c[d>>2]=_l;bm=d;cm=_l;break}}else{Wl=Xl+4|0;c[d>>2]=Wl;bm=Wl;cm=Wl}while(0);_l=c[bm>>2]|0;if(!_l){am=xCi(32)|0;c[am+16>>2]=165;$l=am+20|0;c[$l+0>>2]=0;c[$l+4>>2]=0;c[$l+8>>2]=0;c[am>>2]=0;c[am+4>>2]=0;c[am+8>>2]=cm;c[bm>>2]=am;cm=c[c[Xl>>2]>>2]|0;if(!cm)dm=am;else{c[Xl>>2]=cm;dm=c[bm>>2]|0}GN(c[Rl>>2]|0,dm);dm=Xl+8|0;c[dm>>2]=(c[dm>>2]|0)+1;em=am}else em=_l;zri(em+20|0,598232)|0;em=c[149478]|0;_l=em+4|0;am=c[_l>>2]|0;do if(am){dm=am;while(1){Xl=c[dm+16>>2]|0;if((Xl|0)>166){Rl=c[dm>>2]|0;if(!Rl){fm=dm;gm=dm;o=1006;break}else{dm=Rl;continue}}if((Xl|0)>=166){hm=dm;o=1010;break}Xl=dm+4|0;Rl=c[Xl>>2]|0;if(!Rl){im=Xl;jm=dm;o=1009;break}else dm=Rl}if((o|0)==1006){c[d>>2]=gm;km=fm;lm=gm;break}else if((o|0)==1009){c[d>>2]=jm;km=im;lm=jm;break}else if((o|0)==1010){c[d>>2]=hm;km=d;lm=hm;break}}else{dm=em+4|0;c[d>>2]=dm;km=dm;lm=dm}while(0);hm=c[km>>2]|0;if(!hm){jm=xCi(32)|0;c[jm+16>>2]=166;im=jm+20|0;c[im+0>>2]=0;c[im+4>>2]=0;c[im+8>>2]=0;c[jm>>2]=0;c[jm+4>>2]=0;c[jm+8>>2]=lm;c[km>>2]=jm;lm=c[c[em>>2]>>2]|0;if(!lm)mm=jm;else{c[em>>2]=lm;mm=c[km>>2]|0}GN(c[_l>>2]|0,mm);mm=em+8|0;c[mm>>2]=(c[mm>>2]|0)+1;nm=jm}else nm=hm;zri(nm+20|0,598240)|0;nm=c[149478]|0;hm=nm+4|0;jm=c[hm>>2]|0;do if(jm){mm=jm;while(1){em=c[mm+16>>2]|0;if((em|0)>167){_l=c[mm>>2]|0;if(!_l){om=mm;pm=mm;o=1019;break}else{mm=_l;continue}}if((em|0)>=167){qm=mm;o=1023;break}em=mm+4|0;_l=c[em>>2]|0;if(!_l){rm=em;sm=mm;o=1022;break}else mm=_l}if((o|0)==1019){c[d>>2]=pm;tm=om;um=pm;break}else if((o|0)==1022){c[d>>2]=sm;tm=rm;um=sm;break}else if((o|0)==1023){c[d>>2]=qm;tm=d;um=qm;break}}else{mm=nm+4|0;c[d>>2]=mm;tm=mm;um=mm}while(0);qm=c[tm>>2]|0;if(!qm){sm=xCi(32)|0;c[sm+16>>2]=167;rm=sm+20|0;c[rm+0>>2]=0;c[rm+4>>2]=0;c[rm+8>>2]=0;c[sm>>2]=0;c[sm+4>>2]=0;c[sm+8>>2]=um;c[tm>>2]=sm;um=c[c[nm>>2]>>2]|0;if(!um)vm=sm;else{c[nm>>2]=um;vm=c[tm>>2]|0}GN(c[hm>>2]|0,vm);vm=nm+8|0;c[vm>>2]=(c[vm>>2]|0)+1;wm=sm}else wm=qm;zri(wm+20|0,598248)|0;wm=c[149478]|0;qm=wm+4|0;sm=c[qm>>2]|0;do if(sm){vm=sm;while(1){nm=c[vm+16>>2]|0;if((nm|0)>168){hm=c[vm>>2]|0;if(!hm){xm=vm;ym=vm;o=1032;break}else{vm=hm;continue}}if((nm|0)>=168){zm=vm;o=1036;break}nm=vm+4|0;hm=c[nm>>2]|0;if(!hm){Am=nm;Bm=vm;o=1035;break}else vm=hm}if((o|0)==1032){c[d>>2]=ym;Cm=xm;Dm=ym;break}else if((o|0)==1035){c[d>>2]=Bm;Cm=Am;Dm=Bm;break}else if((o|0)==1036){c[d>>2]=zm;Cm=d;Dm=zm;break}}else{vm=wm+4|0;c[d>>2]=vm;Cm=vm;Dm=vm}while(0);zm=c[Cm>>2]|0;if(!zm){Bm=xCi(32)|0;c[Bm+16>>2]=168;Am=Bm+20|0;c[Am+0>>2]=0;c[Am+4>>2]=0;c[Am+8>>2]=0;c[Bm>>2]=0;c[Bm+4>>2]=0;c[Bm+8>>2]=Dm;c[Cm>>2]=Bm;Dm=c[c[wm>>2]>>2]|0;if(!Dm)Em=Bm;else{c[wm>>2]=Dm;Em=c[Cm>>2]|0}GN(c[qm>>2]|0,Em);Em=wm+8|0;c[Em>>2]=(c[Em>>2]|0)+1;Fm=Bm}else Fm=zm;zri(Fm+20|0,598256)|0;Fm=c[149478]|0;zm=Fm+4|0;Bm=c[zm>>2]|0;do if(Bm){Em=Bm;while(1){wm=c[Em+16>>2]|0;if((wm|0)>169){qm=c[Em>>2]|0;if(!qm){Gm=Em;Hm=Em;o=1045;break}else{Em=qm;continue}}if((wm|0)>=169){Im=Em;o=1049;break}wm=Em+4|0;qm=c[wm>>2]|0;if(!qm){Jm=wm;Km=Em;o=1048;break}else Em=qm}if((o|0)==1045){c[d>>2]=Hm;Lm=Gm;Mm=Hm;break}else if((o|0)==1048){c[d>>2]=Km;Lm=Jm;Mm=Km;break}else if((o|0)==1049){c[d>>2]=Im;Lm=d;Mm=Im;break}}else{Em=Fm+4|0;c[d>>2]=Em;Lm=Em;Mm=Em}while(0);Im=c[Lm>>2]|0;if(!Im){Km=xCi(32)|0;c[Km+16>>2]=169;Jm=Km+20|0;c[Jm+0>>2]=0;c[Jm+4>>2]=0;c[Jm+8>>2]=0;c[Km>>2]=0;c[Km+4>>2]=0;c[Km+8>>2]=Mm;c[Lm>>2]=Km;Mm=c[c[Fm>>2]>>2]|0;if(!Mm)Nm=Km;else{c[Fm>>2]=Mm;Nm=c[Lm>>2]|0}GN(c[zm>>2]|0,Nm);Nm=Fm+8|0;c[Nm>>2]=(c[Nm>>2]|0)+1;Om=Km}else Om=Im;zri(Om+20|0,598264)|0;Om=c[149478]|0;Im=Om+4|0;Km=c[Im>>2]|0;do if(Km){Nm=Km;while(1){Fm=c[Nm+16>>2]|0;if((Fm|0)>170){zm=c[Nm>>2]|0;if(!zm){Pm=Nm;Qm=Nm;o=1058;break}else{Nm=zm;continue}}if((Fm|0)>=170){Rm=Nm;o=1062;break}Fm=Nm+4|0;zm=c[Fm>>2]|0;if(!zm){Sm=Fm;Tm=Nm;o=1061;break}else Nm=zm}if((o|0)==1058){c[d>>2]=Qm;Um=Pm;Vm=Qm;break}else if((o|0)==1061){c[d>>2]=Tm;Um=Sm;Vm=Tm;break}else if((o|0)==1062){c[d>>2]=Rm;Um=d;Vm=Rm;break}}else{Nm=Om+4|0;c[d>>2]=Nm;Um=Nm;Vm=Nm}while(0);Rm=c[Um>>2]|0;if(!Rm){Tm=xCi(32)|0;c[Tm+16>>2]=170;Sm=Tm+20|0;c[Sm+0>>2]=0;c[Sm+4>>2]=0;c[Sm+8>>2]=0;c[Tm>>2]=0;c[Tm+4>>2]=0;c[Tm+8>>2]=Vm;c[Um>>2]=Tm;Vm=c[c[Om>>2]>>2]|0;if(!Vm)Wm=Tm;else{c[Om>>2]=Vm;Wm=c[Um>>2]|0}GN(c[Im>>2]|0,Wm);Wm=Om+8|0;c[Wm>>2]=(c[Wm>>2]|0)+1;Xm=Tm}else Xm=Rm;zri(Xm+20|0,598272)|0;Xm=c[149478]|0;Rm=Xm+4|0;Tm=c[Rm>>2]|0;do if(Tm){Wm=Tm;while(1){Om=c[Wm+16>>2]|0;if((Om|0)>171){Im=c[Wm>>2]|0;if(!Im){Ym=Wm;Zm=Wm;o=1071;break}else{Wm=Im;continue}}if((Om|0)>=171){_m=Wm;o=1075;break}Om=Wm+4|0;Im=c[Om>>2]|0;if(!Im){$m=Om;an=Wm;o=1074;break}else Wm=Im}if((o|0)==1071){c[d>>2]=Zm;bn=Ym;cn=Zm;break}else if((o|0)==1074){c[d>>2]=an;bn=$m;cn=an;break}else if((o|0)==1075){c[d>>2]=_m;bn=d;cn=_m;break}}else{Wm=Xm+4|0;c[d>>2]=Wm;bn=Wm;cn=Wm}while(0);_m=c[bn>>2]|0;if(!_m){an=xCi(32)|0;c[an+16>>2]=171;$m=an+20|0;c[$m+0>>2]=0;c[$m+4>>2]=0;c[$m+8>>2]=0;c[an>>2]=0;c[an+4>>2]=0;c[an+8>>2]=cn;c[bn>>2]=an;cn=c[c[Xm>>2]>>2]|0;if(!cn)dn=an;else{c[Xm>>2]=cn;dn=c[bn>>2]|0}GN(c[Rm>>2]|0,dn);dn=Xm+8|0;c[dn>>2]=(c[dn>>2]|0)+1;en=an}else en=_m;zri(en+20|0,598288)|0;en=c[149478]|0;_m=en+4|0;an=c[_m>>2]|0;do if(an){dn=an;while(1){Xm=c[dn+16>>2]|0;if((Xm|0)>172){Rm=c[dn>>2]|0;if(!Rm){fn=dn;gn=dn;o=1084;break}else{dn=Rm;continue}}if((Xm|0)>=172){hn=dn;o=1088;break}Xm=dn+4|0;Rm=c[Xm>>2]|0;if(!Rm){jn=Xm;kn=dn;o=1087;break}else dn=Rm}if((o|0)==1084){c[d>>2]=gn;ln=fn;mn=gn;break}else if((o|0)==1087){c[d>>2]=kn;ln=jn;mn=kn;break}else if((o|0)==1088){c[d>>2]=hn;ln=d;mn=hn;break}}else{dn=en+4|0;c[d>>2]=dn;ln=dn;mn=dn}while(0);hn=c[ln>>2]|0;if(!hn){kn=xCi(32)|0;c[kn+16>>2]=172;jn=kn+20|0;c[jn+0>>2]=0;c[jn+4>>2]=0;c[jn+8>>2]=0;c[kn>>2]=0;c[kn+4>>2]=0;c[kn+8>>2]=mn;c[ln>>2]=kn;mn=c[c[en>>2]>>2]|0;if(!mn)nn=kn;else{c[en>>2]=mn;nn=c[ln>>2]|0}GN(c[_m>>2]|0,nn);nn=en+8|0;c[nn>>2]=(c[nn>>2]|0)+1;on=kn}else on=hn;zri(on+20|0,598304)|0;on=c[149478]|0;hn=on+4|0;kn=c[hn>>2]|0;do if(kn){nn=kn;while(1){en=c[nn+16>>2]|0;if((en|0)>173){_m=c[nn>>2]|0;if(!_m){pn=nn;qn=nn;o=1097;break}else{nn=_m;continue}}if((en|0)>=173){rn=nn;o=1101;break}en=nn+4|0;_m=c[en>>2]|0;if(!_m){sn=en;tn=nn;o=1100;break}else nn=_m}if((o|0)==1097){c[d>>2]=qn;un=pn;vn=qn;break}else if((o|0)==1100){c[d>>2]=tn;un=sn;vn=tn;break}else if((o|0)==1101){c[d>>2]=rn;un=d;vn=rn;break}}else{nn=on+4|0;c[d>>2]=nn;un=nn;vn=nn}while(0);rn=c[un>>2]|0;if(!rn){tn=xCi(32)|0;c[tn+16>>2]=173;sn=tn+20|0;c[sn+0>>2]=0;c[sn+4>>2]=0;c[sn+8>>2]=0;c[tn>>2]=0;c[tn+4>>2]=0;c[tn+8>>2]=vn;c[un>>2]=tn;vn=c[c[on>>2]>>2]|0;if(!vn)wn=tn;else{c[on>>2]=vn;wn=c[un>>2]|0}GN(c[hn>>2]|0,wn);wn=on+8|0;c[wn>>2]=(c[wn>>2]|0)+1;xn=tn}else xn=rn;zri(xn+20|0,598320)|0;xn=c[149478]|0;rn=xn+4|0;tn=c[rn>>2]|0;do if(tn){wn=tn;while(1){on=c[wn+16>>2]|0;if((on|0)>174){hn=c[wn>>2]|0;if(!hn){yn=wn;zn=wn;o=1110;break}else{wn=hn;continue}}if((on|0)>=174){An=wn;o=1114;break}on=wn+4|0;hn=c[on>>2]|0;if(!hn){Bn=on;Cn=wn;o=1113;break}else wn=hn}if((o|0)==1110){c[d>>2]=zn;Dn=yn;En=zn;break}else if((o|0)==1113){c[d>>2]=Cn;Dn=Bn;En=Cn;break}else if((o|0)==1114){c[d>>2]=An;Dn=d;En=An;break}}else{wn=xn+4|0;c[d>>2]=wn;Dn=wn;En=wn}while(0);An=c[Dn>>2]|0;if(!An){Cn=xCi(32)|0;c[Cn+16>>2]=174;Bn=Cn+20|0;c[Bn+0>>2]=0;c[Bn+4>>2]=0;c[Bn+8>>2]=0;c[Cn>>2]=0;c[Cn+4>>2]=0;c[Cn+8>>2]=En;c[Dn>>2]=Cn;En=c[c[xn>>2]>>2]|0;if(!En)Fn=Cn;else{c[xn>>2]=En;Fn=c[Dn>>2]|0}GN(c[rn>>2]|0,Fn);Fn=xn+8|0;c[Fn>>2]=(c[Fn>>2]|0)+1;Gn=Cn}else Gn=An;zri(Gn+20|0,598336)|0;Gn=c[149478]|0;An=Gn+4|0;Cn=c[An>>2]|0;do if(Cn){Fn=Cn;while(1){xn=c[Fn+16>>2]|0;if((xn|0)>175){rn=c[Fn>>2]|0;if(!rn){Hn=Fn;In=Fn;o=1123;break}else{Fn=rn;continue}}if((xn|0)>=175){Jn=Fn;o=1127;break}xn=Fn+4|0;rn=c[xn>>2]|0;if(!rn){Kn=xn;Ln=Fn;o=1126;break}else Fn=rn}if((o|0)==1123){c[d>>2]=In;Mn=Hn;Nn=In;break}else if((o|0)==1126){c[d>>2]=Ln;Mn=Kn;Nn=Ln;break}else if((o|0)==1127){c[d>>2]=Jn;Mn=d;Nn=Jn;break}}else{Fn=Gn+4|0;c[d>>2]=Fn;Mn=Fn;Nn=Fn}while(0);Jn=c[Mn>>2]|0;if(!Jn){Ln=xCi(32)|0;c[Ln+16>>2]=175;Kn=Ln+20|0;c[Kn+0>>2]=0;c[Kn+4>>2]=0;c[Kn+8>>2]=0;c[Ln>>2]=0;c[Ln+4>>2]=0;c[Ln+8>>2]=Nn;c[Mn>>2]=Ln;Nn=c[c[Gn>>2]>>2]|0;if(!Nn)On=Ln;else{c[Gn>>2]=Nn;On=c[Mn>>2]|0}GN(c[An>>2]|0,On);On=Gn+8|0;c[On>>2]=(c[On>>2]|0)+1;Pn=Ln}else Pn=Jn;zri(Pn+20|0,598352)|0;Pn=c[149478]|0;Jn=Pn+4|0;Ln=c[Jn>>2]|0;do if(Ln){On=Ln;while(1){Gn=c[On+16>>2]|0;if((Gn|0)>176){An=c[On>>2]|0;if(!An){Qn=On;Rn=On;o=1136;break}else{On=An;continue}}if((Gn|0)>=176){Sn=On;o=1140;break}Gn=On+4|0;An=c[Gn>>2]|0;if(!An){Tn=Gn;Un=On;o=1139;break}else On=An}if((o|0)==1136){c[d>>2]=Rn;Vn=Qn;Wn=Rn;break}else if((o|0)==1139){c[d>>2]=Un;Vn=Tn;Wn=Un;break}else if((o|0)==1140){c[d>>2]=Sn;Vn=d;Wn=Sn;break}}else{On=Pn+4|0;c[d>>2]=On;Vn=On;Wn=On}while(0);Sn=c[Vn>>2]|0;if(!Sn){Un=xCi(32)|0;c[Un+16>>2]=176;Tn=Un+20|0;c[Tn+0>>2]=0;c[Tn+4>>2]=0;c[Tn+8>>2]=0;c[Un>>2]=0;c[Un+4>>2]=0;c[Un+8>>2]=Wn;c[Vn>>2]=Un;Wn=c[c[Pn>>2]>>2]|0;if(!Wn)Xn=Un;else{c[Pn>>2]=Wn;Xn=c[Vn>>2]|0}GN(c[Jn>>2]|0,Xn);Xn=Pn+8|0;c[Xn>>2]=(c[Xn>>2]|0)+1;Yn=Un}else Yn=Sn;zri(Yn+20|0,598368)|0;Yn=c[149478]|0;Sn=Yn+4|0;Un=c[Sn>>2]|0;do if(Un){Xn=Un;while(1){Pn=c[Xn+16>>2]|0;if((Pn|0)>177){Jn=c[Xn>>2]|0;if(!Jn){Zn=Xn;_n=Xn;o=1149;break}else{Xn=Jn;continue}}if((Pn|0)>=177){$n=Xn;o=1153;break}Pn=Xn+4|0;Jn=c[Pn>>2]|0;if(!Jn){ao=Pn;bo=Xn;o=1152;break}else Xn=Jn}if((o|0)==1149){c[d>>2]=_n;co=Zn;eo=_n;break}else if((o|0)==1152){c[d>>2]=bo;co=ao;eo=bo;break}else if((o|0)==1153){c[d>>2]=$n;co=d;eo=$n;break}}else{Xn=Yn+4|0;c[d>>2]=Xn;co=Xn;eo=Xn}while(0);$n=c[co>>2]|0;if(!$n){bo=xCi(32)|0;c[bo+16>>2]=177;ao=bo+20|0;c[ao+0>>2]=0;c[ao+4>>2]=0;c[ao+8>>2]=0;c[bo>>2]=0;c[bo+4>>2]=0;c[bo+8>>2]=eo;c[co>>2]=bo;eo=c[c[Yn>>2]>>2]|0;if(!eo)fo=bo;else{c[Yn>>2]=eo;fo=c[co>>2]|0}GN(c[Sn>>2]|0,fo);fo=Yn+8|0;c[fo>>2]=(c[fo>>2]|0)+1;go=bo}else go=$n;zri(go+20|0,598384)|0;go=c[149478]|0;$n=go+4|0;bo=c[$n>>2]|0;do if(bo){fo=bo;while(1){Yn=c[fo+16>>2]|0;if((Yn|0)>178){Sn=c[fo>>2]|0;if(!Sn){ho=fo;io=fo;o=1162;break}else{fo=Sn;continue}}if((Yn|0)>=178){jo=fo;o=1166;break}Yn=fo+4|0;Sn=c[Yn>>2]|0;if(!Sn){ko=Yn;lo=fo;o=1165;break}else fo=Sn}if((o|0)==1162){c[d>>2]=io;mo=ho;no=io;break}else if((o|0)==1165){c[d>>2]=lo;mo=ko;no=lo;break}else if((o|0)==1166){c[d>>2]=jo;mo=d;no=jo;break}}else{fo=go+4|0;c[d>>2]=fo;mo=fo;no=fo}while(0);jo=c[mo>>2]|0;if(!jo){lo=xCi(32)|0;c[lo+16>>2]=178;ko=lo+20|0;c[ko+0>>2]=0;c[ko+4>>2]=0;c[ko+8>>2]=0;c[lo>>2]=0;c[lo+4>>2]=0;c[lo+8>>2]=no;c[mo>>2]=lo;no=c[c[go>>2]>>2]|0;if(!no)oo=lo;else{c[go>>2]=no;oo=c[mo>>2]|0}GN(c[$n>>2]|0,oo);oo=go+8|0;c[oo>>2]=(c[oo>>2]|0)+1;po=lo}else po=jo;zri(po+20|0,598400)|0;po=c[149478]|0;jo=po+4|0;lo=c[jo>>2]|0;do if(lo){oo=lo;while(1){go=c[oo+16>>2]|0;if((go|0)>179){$n=c[oo>>2]|0;if(!$n){qo=oo;ro=oo;o=1175;break}else{oo=$n;continue}}if((go|0)>=179){so=oo;o=1179;break}go=oo+4|0;$n=c[go>>2]|0;if(!$n){to=go;uo=oo;o=1178;break}else oo=$n}if((o|0)==1175){c[d>>2]=ro;vo=qo;wo=ro;break}else if((o|0)==1178){c[d>>2]=uo;vo=to;wo=uo;break}else if((o|0)==1179){c[d>>2]=so;vo=d;wo=so;break}}else{oo=po+4|0;c[d>>2]=oo;vo=oo;wo=oo}while(0);so=c[vo>>2]|0;if(!so){uo=xCi(32)|0;c[uo+16>>2]=179;to=uo+20|0;c[to+0>>2]=0;c[to+4>>2]=0;c[to+8>>2]=0;c[uo>>2]=0;c[uo+4>>2]=0;c[uo+8>>2]=wo;c[vo>>2]=uo;wo=c[c[po>>2]>>2]|0;if(!wo)xo=uo;else{c[po>>2]=wo;xo=c[vo>>2]|0}GN(c[jo>>2]|0,xo);xo=po+8|0;c[xo>>2]=(c[xo>>2]|0)+1;yo=uo}else yo=so;zri(yo+20|0,598416)|0;yo=c[149478]|0;so=yo+4|0;uo=c[so>>2]|0;do if(uo){xo=uo;while(1){po=c[xo+16>>2]|0;if((po|0)>180){jo=c[xo>>2]|0;if(!jo){zo=xo;Ao=xo;o=1188;break}else{xo=jo;continue}}if((po|0)>=180){Bo=xo;o=1192;break}po=xo+4|0;jo=c[po>>2]|0;if(!jo){Co=po;Do=xo;o=1191;break}else xo=jo}if((o|0)==1188){c[d>>2]=Ao;Eo=zo;Fo=Ao;break}else if((o|0)==1191){c[d>>2]=Do;Eo=Co;Fo=Do;break}else if((o|0)==1192){c[d>>2]=Bo;Eo=d;Fo=Bo;break}}else{xo=yo+4|0;c[d>>2]=xo;Eo=xo;Fo=xo}while(0);Bo=c[Eo>>2]|0;if(!Bo){Do=xCi(32)|0;c[Do+16>>2]=180;Co=Do+20|0;c[Co+0>>2]=0;c[Co+4>>2]=0;c[Co+8>>2]=0;c[Do>>2]=0;c[Do+4>>2]=0;c[Do+8>>2]=Fo;c[Eo>>2]=Do;Fo=c[c[yo>>2]>>2]|0;if(!Fo)Go=Do;else{c[yo>>2]=Fo;Go=c[Eo>>2]|0}GN(c[so>>2]|0,Go);Go=yo+8|0;c[Go>>2]=(c[Go>>2]|0)+1;Ho=Do}else Ho=Bo;zri(Ho+20|0,598432)|0;Ho=c[149478]|0;Bo=Ho+4|0;Do=c[Bo>>2]|0;do if(Do){Go=Do;while(1){yo=c[Go+16>>2]|0;if((yo|0)>181){so=c[Go>>2]|0;if(!so){Io=Go;Jo=Go;o=1201;break}else{Go=so;continue}}if((yo|0)>=181){Ko=Go;o=1205;break}yo=Go+4|0;so=c[yo>>2]|0;if(!so){Lo=yo;Mo=Go;o=1204;break}else Go=so}if((o|0)==1201){c[d>>2]=Jo;No=Io;Oo=Jo;break}else if((o|0)==1204){c[d>>2]=Mo;No=Lo;Oo=Mo;break}else if((o|0)==1205){c[d>>2]=Ko;No=d;Oo=Ko;break}}else{Go=Ho+4|0;c[d>>2]=Go;No=Go;Oo=Go}while(0);Ko=c[No>>2]|0;if(!Ko){Mo=xCi(32)|0;c[Mo+16>>2]=181;Lo=Mo+20|0;c[Lo+0>>2]=0;c[Lo+4>>2]=0;c[Lo+8>>2]=0;c[Mo>>2]=0;c[Mo+4>>2]=0;c[Mo+8>>2]=Oo;c[No>>2]=Mo;Oo=c[c[Ho>>2]>>2]|0;if(!Oo)Po=Mo;else{c[Ho>>2]=Oo;Po=c[No>>2]|0}GN(c[Bo>>2]|0,Po);Po=Ho+8|0;c[Po>>2]=(c[Po>>2]|0)+1;Qo=Mo}else Qo=Ko;zri(Qo+20|0,598448)|0;Qo=c[149478]|0;Ko=Qo+4|0;Mo=c[Ko>>2]|0;do if(Mo){Po=Mo;while(1){Ho=c[Po+16>>2]|0;if((Ho|0)>182){Bo=c[Po>>2]|0;if(!Bo){Ro=Po;So=Po;o=1214;break}else{Po=Bo;continue}}if((Ho|0)>=182){To=Po;o=1218;break}Ho=Po+4|0;Bo=c[Ho>>2]|0;if(!Bo){Uo=Ho;Vo=Po;o=1217;break}else Po=Bo}if((o|0)==1214){c[d>>2]=So;Wo=Ro;Xo=So;break}else if((o|0)==1217){c[d>>2]=Vo;Wo=Uo;Xo=Vo;break}else if((o|0)==1218){c[d>>2]=To;Wo=d;Xo=To;break}}else{Po=Qo+4|0;c[d>>2]=Po;Wo=Po;Xo=Po}while(0);To=c[Wo>>2]|0;if(!To){Vo=xCi(32)|0;c[Vo+16>>2]=182;Uo=Vo+20|0;c[Uo+0>>2]=0;c[Uo+4>>2]=0;c[Uo+8>>2]=0;c[Vo>>2]=0;c[Vo+4>>2]=0;c[Vo+8>>2]=Xo;c[Wo>>2]=Vo;Xo=c[c[Qo>>2]>>2]|0;if(!Xo)Yo=Vo;else{c[Qo>>2]=Xo;Yo=c[Wo>>2]|0}GN(c[Ko>>2]|0,Yo);Yo=Qo+8|0;c[Yo>>2]=(c[Yo>>2]|0)+1;Zo=Vo}else Zo=To;zri(Zo+20|0,598464)|0;Zo=c[149478]|0;To=Zo+4|0;Vo=c[To>>2]|0;do if(Vo){Yo=Vo;while(1){Qo=c[Yo+16>>2]|0;if((Qo|0)>183){Ko=c[Yo>>2]|0;if(!Ko){_o=Yo;$o=Yo;o=1227;break}else{Yo=Ko;continue}}if((Qo|0)>=183){ap=Yo;o=1231;break}Qo=Yo+4|0;Ko=c[Qo>>2]|0;if(!Ko){bp=Qo;cp=Yo;o=1230;break}else Yo=Ko}if((o|0)==1227){c[d>>2]=$o;dp=_o;ep=$o;break}else if((o|0)==1230){c[d>>2]=cp;dp=bp;ep=cp;break}else if((o|0)==1231){c[d>>2]=ap;dp=d;ep=ap;break}}else{Yo=Zo+4|0;c[d>>2]=Yo;dp=Yo;ep=Yo}while(0);ap=c[dp>>2]|0;if(!ap){cp=xCi(32)|0;c[cp+16>>2]=183;bp=cp+20|0;c[bp+0>>2]=0;c[bp+4>>2]=0;c[bp+8>>2]=0;c[cp>>2]=0;c[cp+4>>2]=0;c[cp+8>>2]=ep;c[dp>>2]=cp;ep=c[c[Zo>>2]>>2]|0;if(!ep)fp=cp;else{c[Zo>>2]=ep;fp=c[dp>>2]|0}GN(c[To>>2]|0,fp);fp=Zo+8|0;c[fp>>2]=(c[fp>>2]|0)+1;gp=cp}else gp=ap;zri(gp+20|0,598480)|0;gp=c[149478]|0;ap=gp+4|0;cp=c[ap>>2]|0;do if(cp){fp=cp;while(1){Zo=c[fp+16>>2]|0;if((Zo|0)>184){To=c[fp>>2]|0;if(!To){hp=fp;ip=fp;o=1240;break}else{fp=To;continue}}if((Zo|0)>=184){jp=fp;o=1244;break}Zo=fp+4|0;To=c[Zo>>2]|0;if(!To){kp=Zo;lp=fp;o=1243;break}else fp=To}if((o|0)==1240){c[d>>2]=ip;mp=hp;np=ip;break}else if((o|0)==1243){c[d>>2]=lp;mp=kp;np=lp;break}else if((o|0)==1244){c[d>>2]=jp;mp=d;np=jp;break}}else{fp=gp+4|0;c[d>>2]=fp;mp=fp;np=fp}while(0);jp=c[mp>>2]|0;if(!jp){lp=xCi(32)|0;c[lp+16>>2]=184;kp=lp+20|0;c[kp+0>>2]=0;c[kp+4>>2]=0;c[kp+8>>2]=0;c[lp>>2]=0;c[lp+4>>2]=0;c[lp+8>>2]=np;c[mp>>2]=lp;np=c[c[gp>>2]>>2]|0;if(!np)op=lp;else{c[gp>>2]=np;op=c[mp>>2]|0}GN(c[ap>>2]|0,op);op=gp+8|0;c[op>>2]=(c[op>>2]|0)+1;pp=lp}else pp=jp;zri(pp+20|0,598496)|0;pp=c[149478]|0;jp=pp+4|0;lp=c[jp>>2]|0;do if(lp){op=lp;while(1){gp=c[op+16>>2]|0;if((gp|0)>185){ap=c[op>>2]|0;if(!ap){qp=op;rp=op;o=1253;break}else{op=ap;continue}}if((gp|0)>=185){sp=op;o=1257;break}gp=op+4|0;ap=c[gp>>2]|0;if(!ap){tp=gp;up=op;o=1256;break}else op=ap}if((o|0)==1253){c[d>>2]=rp;vp=qp;wp=rp;break}else if((o|0)==1256){c[d>>2]=up;vp=tp;wp=up;break}else if((o|0)==1257){c[d>>2]=sp;vp=d;wp=sp;break}}else{op=pp+4|0;c[d>>2]=op;vp=op;wp=op}while(0);sp=c[vp>>2]|0;if(!sp){up=xCi(32)|0;c[up+16>>2]=185;tp=up+20|0;c[tp+0>>2]=0;c[tp+4>>2]=0;c[tp+8>>2]=0;c[up>>2]=0;c[up+4>>2]=0;c[up+8>>2]=wp;c[vp>>2]=up;wp=c[c[pp>>2]>>2]|0;if(!wp)xp=up;else{c[pp>>2]=wp;xp=c[vp>>2]|0}GN(c[jp>>2]|0,xp);xp=pp+8|0;c[xp>>2]=(c[xp>>2]|0)+1;yp=up}else yp=sp;zri(yp+20|0,598512)|0;yp=c[149478]|0;sp=yp+4|0;up=c[sp>>2]|0;do if(up){xp=up;while(1){pp=c[xp+16>>2]|0;if((pp|0)>186){jp=c[xp>>2]|0;if(!jp){zp=xp;Ap=xp;o=1266;break}else{xp=jp;continue}}if((pp|0)>=186){Bp=xp;o=1270;break}pp=xp+4|0;jp=c[pp>>2]|0;if(!jp){Cp=pp;Dp=xp;o=1269;break}else xp=jp}if((o|0)==1266){c[d>>2]=Ap;Ep=zp;Fp=Ap;break}else if((o|0)==1269){c[d>>2]=Dp;Ep=Cp;Fp=Dp;break}else if((o|0)==1270){c[d>>2]=Bp;Ep=d;Fp=Bp;break}}else{xp=yp+4|0;c[d>>2]=xp;Ep=xp;Fp=xp}while(0);Bp=c[Ep>>2]|0;if(!Bp){Dp=xCi(32)|0;c[Dp+16>>2]=186;Cp=Dp+20|0;c[Cp+0>>2]=0;c[Cp+4>>2]=0;c[Cp+8>>2]=0;c[Dp>>2]=0;c[Dp+4>>2]=0;c[Dp+8>>2]=Fp;c[Ep>>2]=Dp;Fp=c[c[yp>>2]>>2]|0;if(!Fp)Gp=Dp;else{c[yp>>2]=Fp;Gp=c[Ep>>2]|0}GN(c[sp>>2]|0,Gp);Gp=yp+8|0;c[Gp>>2]=(c[Gp>>2]|0)+1;Hp=Dp}else Hp=Bp;zri(Hp+20|0,598528)|0;Hp=c[149478]|0;Bp=Hp+4|0;Dp=c[Bp>>2]|0;do if(Dp){Gp=Dp;while(1){yp=c[Gp+16>>2]|0;if((yp|0)>187){sp=c[Gp>>2]|0;if(!sp){Ip=Gp;Jp=Gp;o=1279;break}else{Gp=sp;continue}}if((yp|0)>=187){Kp=Gp;o=1283;break}yp=Gp+4|0;sp=c[yp>>2]|0;if(!sp){Lp=yp;Mp=Gp;o=1282;break}else Gp=sp}if((o|0)==1279){c[d>>2]=Jp;Np=Ip;Op=Jp;break}else if((o|0)==1282){c[d>>2]=Mp;Np=Lp;Op=Mp;break}else if((o|0)==1283){c[d>>2]=Kp;Np=d;Op=Kp;break}}else{Gp=Hp+4|0;c[d>>2]=Gp;Np=Gp;Op=Gp}while(0);Kp=c[Np>>2]|0;if(!Kp){Mp=xCi(32)|0;c[Mp+16>>2]=187;Lp=Mp+20|0;c[Lp+0>>2]=0;c[Lp+4>>2]=0;c[Lp+8>>2]=0;c[Mp>>2]=0;c[Mp+4>>2]=0;c[Mp+8>>2]=Op;c[Np>>2]=Mp;Op=c[c[Hp>>2]>>2]|0;if(!Op)Pp=Mp;else{c[Hp>>2]=Op;Pp=c[Np>>2]|0}GN(c[Bp>>2]|0,Pp);Pp=Hp+8|0;c[Pp>>2]=(c[Pp>>2]|0)+1;Qp=Mp}else Qp=Kp;zri(Qp+20|0,598544)|0;Qp=c[149478]|0;Kp=Qp+4|0;Mp=c[Kp>>2]|0;do if(Mp){Pp=Mp;while(1){Hp=c[Pp+16>>2]|0;if((Hp|0)>188){Bp=c[Pp>>2]|0;if(!Bp){Rp=Pp;Sp=Pp;o=1292;break}else{Pp=Bp;continue}}if((Hp|0)>=188){Tp=Pp;o=1296;break}Hp=Pp+4|0;Bp=c[Hp>>2]|0;if(!Bp){Up=Hp;Vp=Pp;o=1295;break}else Pp=Bp}if((o|0)==1292){c[d>>2]=Sp;Wp=Rp;Xp=Sp;break}else if((o|0)==1295){c[d>>2]=Vp;Wp=Up;Xp=Vp;break}else if((o|0)==1296){c[d>>2]=Tp;Wp=d;Xp=Tp;break}}else{Pp=Qp+4|0;c[d>>2]=Pp;Wp=Pp;Xp=Pp}while(0);Tp=c[Wp>>2]|0;if(!Tp){Vp=xCi(32)|0;c[Vp+16>>2]=188;Up=Vp+20|0;c[Up+0>>2]=0;c[Up+4>>2]=0;c[Up+8>>2]=0;c[Vp>>2]=0;c[Vp+4>>2]=0;c[Vp+8>>2]=Xp;c[Wp>>2]=Vp;Xp=c[c[Qp>>2]>>2]|0;if(!Xp)Yp=Vp;else{c[Qp>>2]=Xp;Yp=c[Wp>>2]|0}GN(c[Kp>>2]|0,Yp);Yp=Qp+8|0;c[Yp>>2]=(c[Yp>>2]|0)+1;Zp=Vp}else Zp=Tp;zri(Zp+20|0,598560)|0;Zp=c[149478]|0;Tp=Zp+4|0;Vp=c[Tp>>2]|0;do if(Vp){Yp=Vp;while(1){Qp=c[Yp+16>>2]|0;if((Qp|0)>189){Kp=c[Yp>>2]|0;if(!Kp){_p=Yp;$p=Yp;o=1305;break}else{Yp=Kp;continue}}if((Qp|0)>=189){aq=Yp;o=1309;break}Qp=Yp+4|0;Kp=c[Qp>>2]|0;if(!Kp){bq=Qp;cq=Yp;o=1308;break}else Yp=Kp}if((o|0)==1305){c[d>>2]=$p;dq=_p;eq=$p;break}else if((o|0)==1308){c[d>>2]=cq;dq=bq;eq=cq;break}else if((o|0)==1309){c[d>>2]=aq;dq=d;eq=aq;break}}else{Yp=Zp+4|0;c[d>>2]=Yp;dq=Yp;eq=Yp}while(0);aq=c[dq>>2]|0;if(!aq){cq=xCi(32)|0;c[cq+16>>2]=189;bq=cq+20|0;c[bq+0>>2]=0;c[bq+4>>2]=0;c[bq+8>>2]=0;c[cq>>2]=0;c[cq+4>>2]=0;c[cq+8>>2]=eq;c[dq>>2]=cq;eq=c[c[Zp>>2]>>2]|0;if(!eq)fq=cq;else{c[Zp>>2]=eq;fq=c[dq>>2]|0}GN(c[Tp>>2]|0,fq);fq=Zp+8|0;c[fq>>2]=(c[fq>>2]|0)+1;gq=cq}else gq=aq;zri(gq+20|0,598576)|0;gq=c[149478]|0;aq=gq+4|0;cq=c[aq>>2]|0;do if(cq){fq=cq;while(1){Zp=c[fq+16>>2]|0;if((Zp|0)>190){Tp=c[fq>>2]|0;if(!Tp){hq=fq;iq=fq;o=1318;break}else{fq=Tp;continue}}if((Zp|0)>=190){jq=fq;o=1322;break}Zp=fq+4|0;Tp=c[Zp>>2]|0;if(!Tp){kq=Zp;lq=fq;o=1321;break}else fq=Tp}if((o|0)==1318){c[d>>2]=iq;mq=hq;nq=iq;break}else if((o|0)==1321){c[d>>2]=lq;mq=kq;nq=lq;break}else if((o|0)==1322){c[d>>2]=jq;mq=d;nq=jq;break}}else{fq=gq+4|0;c[d>>2]=fq;mq=fq;nq=fq}while(0);jq=c[mq>>2]|0;if(!jq){lq=xCi(32)|0;c[lq+16>>2]=190;kq=lq+20|0;c[kq+0>>2]=0;c[kq+4>>2]=0;c[kq+8>>2]=0;c[lq>>2]=0;c[lq+4>>2]=0;c[lq+8>>2]=nq;c[mq>>2]=lq;nq=c[c[gq>>2]>>2]|0;if(!nq)oq=lq;else{c[gq>>2]=nq;oq=c[mq>>2]|0}GN(c[aq>>2]|0,oq);oq=gq+8|0;c[oq>>2]=(c[oq>>2]|0)+1;pq=lq}else pq=jq;zri(pq+20|0,598592)|0;pq=c[149478]|0;jq=pq+4|0;lq=c[jq>>2]|0;do if(lq){oq=lq;while(1){gq=c[oq+16>>2]|0;if((gq|0)>191){aq=c[oq>>2]|0;if(!aq){qq=oq;rq=oq;o=1331;break}else{oq=aq;continue}}if((gq|0)>=191){sq=oq;o=1335;break}gq=oq+4|0;aq=c[gq>>2]|0;if(!aq){tq=gq;uq=oq;o=1334;break}else oq=aq}if((o|0)==1331){c[d>>2]=rq;vq=qq;wq=rq;break}else if((o|0)==1334){c[d>>2]=uq;vq=tq;wq=uq;break}else if((o|0)==1335){c[d>>2]=sq;vq=d;wq=sq;break}}else{oq=pq+4|0;c[d>>2]=oq;vq=oq;wq=oq}while(0);sq=c[vq>>2]|0;if(!sq){uq=xCi(32)|0;c[uq+16>>2]=191;tq=uq+20|0;c[tq+0>>2]=0;c[tq+4>>2]=0;c[tq+8>>2]=0;c[uq>>2]=0;c[uq+4>>2]=0;c[uq+8>>2]=wq;c[vq>>2]=uq;wq=c[c[pq>>2]>>2]|0;if(!wq)xq=uq;else{c[pq>>2]=wq;xq=c[vq>>2]|0}GN(c[jq>>2]|0,xq);xq=pq+8|0;c[xq>>2]=(c[xq>>2]|0)+1;yq=uq}else yq=sq;zri(yq+20|0,598608)|0;yq=c[149478]|0;sq=yq+4|0;uq=c[sq>>2]|0;do if(uq){xq=uq;while(1){pq=c[xq+16>>2]|0;if((pq|0)>192){jq=c[xq>>2]|0;if(!jq){zq=xq;Aq=xq;o=1344;break}else{xq=jq;continue}}if((pq|0)>=192){Bq=xq;o=1348;break}pq=xq+4|0;jq=c[pq>>2]|0;if(!jq){Cq=pq;Dq=xq;o=1347;break}else xq=jq}if((o|0)==1344){c[d>>2]=Aq;Eq=zq;Fq=Aq;break}else if((o|0)==1347){c[d>>2]=Dq;Eq=Cq;Fq=Dq;break}else if((o|0)==1348){c[d>>2]=Bq;Eq=d;Fq=Bq;break}}else{xq=yq+4|0;c[d>>2]=xq;Eq=xq;Fq=xq}while(0);Bq=c[Eq>>2]|0;if(!Bq){Dq=xCi(32)|0;c[Dq+16>>2]=192;Cq=Dq+20|0;c[Cq+0>>2]=0;c[Cq+4>>2]=0;c[Cq+8>>2]=0;c[Dq>>2]=0;c[Dq+4>>2]=0;c[Dq+8>>2]=Fq;c[Eq>>2]=Dq;Fq=c[c[yq>>2]>>2]|0;if(!Fq)Gq=Dq;else{c[yq>>2]=Fq;Gq=c[Eq>>2]|0}GN(c[sq>>2]|0,Gq);Gq=yq+8|0;c[Gq>>2]=(c[Gq>>2]|0)+1;Hq=Dq}else Hq=Bq;zri(Hq+20|0,598624)|0;Hq=c[149478]|0;Bq=Hq+4|0;Dq=c[Bq>>2]|0;do if(Dq){Gq=Dq;while(1){yq=c[Gq+16>>2]|0;if((yq|0)>193){sq=c[Gq>>2]|0;if(!sq){Iq=Gq;Jq=Gq;o=1357;break}else{Gq=sq;continue}}if((yq|0)>=193){Kq=Gq;o=1361;break}yq=Gq+4|0;sq=c[yq>>2]|0;if(!sq){Lq=yq;Mq=Gq;o=1360;break}else Gq=sq}if((o|0)==1357){c[d>>2]=Jq;Nq=Iq;Oq=Jq;break}else if((o|0)==1360){c[d>>2]=Mq;Nq=Lq;Oq=Mq;break}else if((o|0)==1361){c[d>>2]=Kq;Nq=d;Oq=Kq;break}}else{Gq=Hq+4|0;c[d>>2]=Gq;Nq=Gq;Oq=Gq}while(0);Kq=c[Nq>>2]|0;if(!Kq){Mq=xCi(32)|0;c[Mq+16>>2]=193;Lq=Mq+20|0;c[Lq+0>>2]=0;c[Lq+4>>2]=0;c[Lq+8>>2]=0;c[Mq>>2]=0;c[Mq+4>>2]=0;c[Mq+8>>2]=Oq;c[Nq>>2]=Mq;Oq=c[c[Hq>>2]>>2]|0;if(!Oq)Pq=Mq;else{c[Hq>>2]=Oq;Pq=c[Nq>>2]|0}GN(c[Bq>>2]|0,Pq);Pq=Hq+8|0;c[Pq>>2]=(c[Pq>>2]|0)+1;Qq=Mq}else Qq=Kq;zri(Qq+20|0,598640)|0;Qq=c[149478]|0;Kq=Qq+4|0;Mq=c[Kq>>2]|0;do if(Mq){Pq=Mq;while(1){Hq=c[Pq+16>>2]|0;if((Hq|0)>194){Bq=c[Pq>>2]|0;if(!Bq){Rq=Pq;Sq=Pq;o=1370;break}else{Pq=Bq;continue}}if((Hq|0)>=194){Tq=Pq;o=1374;break}Hq=Pq+4|0;Bq=c[Hq>>2]|0;if(!Bq){Uq=Hq;Vq=Pq;o=1373;break}else Pq=Bq}if((o|0)==1370){c[d>>2]=Sq;Wq=Rq;Xq=Sq;break}else if((o|0)==1373){c[d>>2]=Vq;Wq=Uq;Xq=Vq;break}else if((o|0)==1374){c[d>>2]=Tq;Wq=d;Xq=Tq;break}}else{Pq=Qq+4|0;c[d>>2]=Pq;Wq=Pq;Xq=Pq}while(0);Tq=c[Wq>>2]|0;if(!Tq){Vq=xCi(32)|0;c[Vq+16>>2]=194;Uq=Vq+20|0;c[Uq+0>>2]=0;c[Uq+4>>2]=0;c[Uq+8>>2]=0;c[Vq>>2]=0;c[Vq+4>>2]=0;c[Vq+8>>2]=Xq;c[Wq>>2]=Vq;Xq=c[c[Qq>>2]>>2]|0;if(!Xq)Yq=Vq;else{c[Qq>>2]=Xq;Yq=c[Wq>>2]|0}GN(c[Kq>>2]|0,Yq);Yq=Qq+8|0;c[Yq>>2]=(c[Yq>>2]|0)+1;Zq=Vq}else Zq=Tq;zri(Zq+20|0,598656)|0;Zq=c[149478]|0;Tq=Zq+4|0;Vq=c[Tq>>2]|0;do if(Vq){Yq=Vq;while(1){Qq=c[Yq+16>>2]|0;if((Qq|0)>195){Kq=c[Yq>>2]|0;if(!Kq){_q=Yq;$q=Yq;o=1383;break}else{Yq=Kq;continue}}if((Qq|0)>=195){ar=Yq;o=1387;break}Qq=Yq+4|0;Kq=c[Qq>>2]|0;if(!Kq){br=Qq;cr=Yq;o=1386;break}else Yq=Kq}if((o|0)==1383){c[d>>2]=$q;dr=_q;er=$q;break}else if((o|0)==1386){c[d>>2]=cr;dr=br;er=cr;break}else if((o|0)==1387){c[d>>2]=ar;dr=d;er=ar;break}}else{Yq=Zq+4|0;c[d>>2]=Yq;dr=Yq;er=Yq}while(0);ar=c[dr>>2]|0;if(!ar){cr=xCi(32)|0;c[cr+16>>2]=195;br=cr+20|0;c[br+0>>2]=0;c[br+4>>2]=0;c[br+8>>2]=0;c[cr>>2]=0;c[cr+4>>2]=0;c[cr+8>>2]=er;c[dr>>2]=cr;er=c[c[Zq>>2]>>2]|0;if(!er)fr=cr;else{c[Zq>>2]=er;fr=c[dr>>2]|0}GN(c[Tq>>2]|0,fr);fr=Zq+8|0;c[fr>>2]=(c[fr>>2]|0)+1;gr=cr}else gr=ar;zri(gr+20|0,598672)|0;gr=c[149478]|0;ar=gr+4|0;cr=c[ar>>2]|0;do if(cr){fr=cr;while(1){Zq=c[fr+16>>2]|0;if((Zq|0)>196){Tq=c[fr>>2]|0;if(!Tq){hr=fr;ir=fr;o=1396;break}else{fr=Tq;continue}}if((Zq|0)>=196){jr=fr;o=1400;break}Zq=fr+4|0;Tq=c[Zq>>2]|0;if(!Tq){kr=Zq;lr=fr;o=1399;break}else fr=Tq}if((o|0)==1396){c[d>>2]=ir;mr=hr;nr=ir;break}else if((o|0)==1399){c[d>>2]=lr;mr=kr;nr=lr;break}else if((o|0)==1400){c[d>>2]=jr;mr=d;nr=jr;break}}else{fr=gr+4|0;c[d>>2]=fr;mr=fr;nr=fr}while(0);jr=c[mr>>2]|0;if(!jr){lr=xCi(32)|0;c[lr+16>>2]=196;kr=lr+20|0;c[kr+0>>2]=0;c[kr+4>>2]=0;c[kr+8>>2]=0;c[lr>>2]=0;c[lr+4>>2]=0;c[lr+8>>2]=nr;c[mr>>2]=lr;nr=c[c[gr>>2]>>2]|0;if(!nr)or=lr;else{c[gr>>2]=nr;or=c[mr>>2]|0}GN(c[ar>>2]|0,or);or=gr+8|0;c[or>>2]=(c[or>>2]|0)+1;pr=lr}else pr=jr;zri(pr+20|0,598688)|0;pr=c[149478]|0;jr=pr+4|0;lr=c[jr>>2]|0;do if(lr){or=lr;while(1){gr=c[or+16>>2]|0;if((gr|0)>197){ar=c[or>>2]|0;if(!ar){qr=or;rr=or;o=1409;break}else{or=ar;continue}}if((gr|0)>=197){sr=or;o=1413;break}gr=or+4|0;ar=c[gr>>2]|0;if(!ar){tr=gr;ur=or;o=1412;break}else or=ar}if((o|0)==1409){c[d>>2]=rr;vr=qr;wr=rr;break}else if((o|0)==1412){c[d>>2]=ur;vr=tr;wr=ur;break}else if((o|0)==1413){c[d>>2]=sr;vr=d;wr=sr;break}}else{or=pr+4|0;c[d>>2]=or;vr=or;wr=or}while(0);sr=c[vr>>2]|0;if(!sr){ur=xCi(32)|0;c[ur+16>>2]=197;tr=ur+20|0;c[tr+0>>2]=0;c[tr+4>>2]=0;c[tr+8>>2]=0;c[ur>>2]=0;c[ur+4>>2]=0;c[ur+8>>2]=wr;c[vr>>2]=ur;wr=c[c[pr>>2]>>2]|0;if(!wr)xr=ur;else{c[pr>>2]=wr;xr=c[vr>>2]|0}GN(c[jr>>2]|0,xr);xr=pr+8|0;c[xr>>2]=(c[xr>>2]|0)+1;yr=ur}else yr=sr;zri(yr+20|0,598704)|0;yr=c[149478]|0;sr=yr+4|0;ur=c[sr>>2]|0;do if(ur){xr=ur;while(1){pr=c[xr+16>>2]|0;if((pr|0)>198){jr=c[xr>>2]|0;if(!jr){zr=xr;Ar=xr;o=1422;break}else{xr=jr;continue}}if((pr|0)>=198){Br=xr;o=1426;break}pr=xr+4|0;jr=c[pr>>2]|0;if(!jr){Cr=pr;Dr=xr;o=1425;break}else xr=jr}if((o|0)==1422){c[d>>2]=Ar;Er=zr;Fr=Ar;break}else if((o|0)==1425){c[d>>2]=Dr;Er=Cr;Fr=Dr;break}else if((o|0)==1426){c[d>>2]=Br;Er=d;Fr=Br;break}}else{xr=yr+4|0;c[d>>2]=xr;Er=xr;Fr=xr}while(0);Br=c[Er>>2]|0;if(!Br){Dr=xCi(32)|0;c[Dr+16>>2]=198;Cr=Dr+20|0;c[Cr+0>>2]=0;c[Cr+4>>2]=0;c[Cr+8>>2]=0;c[Dr>>2]=0;c[Dr+4>>2]=0;c[Dr+8>>2]=Fr;c[Er>>2]=Dr;Fr=c[c[yr>>2]>>2]|0;if(!Fr)Gr=Dr;else{c[yr>>2]=Fr;Gr=c[Er>>2]|0}GN(c[sr>>2]|0,Gr);Gr=yr+8|0;c[Gr>>2]=(c[Gr>>2]|0)+1;Hr=Dr}else Hr=Br;zri(Hr+20|0,598720)|0;Hr=c[149478]|0;Br=Hr+4|0;Dr=c[Br>>2]|0;do if(Dr){Gr=Dr;while(1){yr=c[Gr+16>>2]|0;if((yr|0)>199){sr=c[Gr>>2]|0;if(!sr){Ir=Gr;Jr=Gr;o=1435;break}else{Gr=sr;continue}}if((yr|0)>=199){Kr=Gr;o=1439;break}yr=Gr+4|0;sr=c[yr>>2]|0;if(!sr){Lr=yr;Mr=Gr;o=1438;break}else Gr=sr}if((o|0)==1435){c[d>>2]=Jr;Nr=Ir;Or=Jr;break}else if((o|0)==1438){c[d>>2]=Mr;Nr=Lr;Or=Mr;break}else if((o|0)==1439){c[d>>2]=Kr;Nr=d;Or=Kr;break}}else{Gr=Hr+4|0;c[d>>2]=Gr;Nr=Gr;Or=Gr}while(0);Kr=c[Nr>>2]|0;if(!Kr){Mr=xCi(32)|0;c[Mr+16>>2]=199;Lr=Mr+20|0;c[Lr+0>>2]=0;c[Lr+4>>2]=0;c[Lr+8>>2]=0;c[Mr>>2]=0;c[Mr+4>>2]=0;c[Mr+8>>2]=Or;c[Nr>>2]=Mr;Or=c[c[Hr>>2]>>2]|0;if(!Or)Pr=Mr;else{c[Hr>>2]=Or;Pr=c[Nr>>2]|0}GN(c[Br>>2]|0,Pr);Pr=Hr+8|0;c[Pr>>2]=(c[Pr>>2]|0)+1;Qr=Mr}else Qr=Kr;zri(Qr+20|0,598736)|0;Qr=c[149478]|0;Kr=Qr+4|0;Mr=c[Kr>>2]|0;do if(Mr){Pr=Mr;while(1){Hr=c[Pr+16>>2]|0;if((Hr|0)>200){Br=c[Pr>>2]|0;if(!Br){Rr=Pr;Sr=Pr;o=1448;break}else{Pr=Br;continue}}if((Hr|0)>=200){Tr=Pr;o=1452;break}Hr=Pr+4|0;Br=c[Hr>>2]|0;if(!Br){Ur=Hr;Vr=Pr;o=1451;break}else Pr=Br}if((o|0)==1448){c[d>>2]=Sr;Wr=Rr;Xr=Sr;break}else if((o|0)==1451){c[d>>2]=Vr;Wr=Ur;Xr=Vr;break}else if((o|0)==1452){c[d>>2]=Tr;Wr=d;Xr=Tr;break}}else{Pr=Qr+4|0;c[d>>2]=Pr;Wr=Pr;Xr=Pr}while(0);Tr=c[Wr>>2]|0;if(!Tr){Vr=xCi(32)|0;c[Vr+16>>2]=200;Ur=Vr+20|0;c[Ur+0>>2]=0;c[Ur+4>>2]=0;c[Ur+8>>2]=0;c[Vr>>2]=0;c[Vr+4>>2]=0;c[Vr+8>>2]=Xr;c[Wr>>2]=Vr;Xr=c[c[Qr>>2]>>2]|0;if(!Xr)Yr=Vr;else{c[Qr>>2]=Xr;Yr=c[Wr>>2]|0}GN(c[Kr>>2]|0,Yr);Yr=Qr+8|0;c[Yr>>2]=(c[Yr>>2]|0)+1;Zr=Vr}else Zr=Tr;zri(Zr+20|0,598752)|0;Zr=c[149478]|0;Tr=Zr+4|0;Vr=c[Tr>>2]|0;do if(Vr){Yr=Vr;while(1){Qr=c[Yr+16>>2]|0;if((Qr|0)>201){Kr=c[Yr>>2]|0;if(!Kr){_r=Yr;$r=Yr;o=1461;break}else{Yr=Kr;continue}}if((Qr|0)>=201){as=Yr;o=1465;break}Qr=Yr+4|0;Kr=c[Qr>>2]|0;if(!Kr){bs=Qr;cs=Yr;o=1464;break}else Yr=Kr}if((o|0)==1461){c[d>>2]=$r;ds=_r;es=$r;break}else if((o|0)==1464){c[d>>2]=cs;ds=bs;es=cs;break}else if((o|0)==1465){c[d>>2]=as;ds=d;es=as;break}}else{Yr=Zr+4|0;c[d>>2]=Yr;ds=Yr;es=Yr}while(0);as=c[ds>>2]|0;if(!as){cs=xCi(32)|0;c[cs+16>>2]=201;bs=cs+20|0;c[bs+0>>2]=0;c[bs+4>>2]=0;c[bs+8>>2]=0;c[cs>>2]=0;c[cs+4>>2]=0;c[cs+8>>2]=es;c[ds>>2]=cs;es=c[c[Zr>>2]>>2]|0;if(!es)fs=cs;else{c[Zr>>2]=es;fs=c[ds>>2]|0}GN(c[Tr>>2]|0,fs);fs=Zr+8|0;c[fs>>2]=(c[fs>>2]|0)+1;gs=cs}else gs=as;zri(gs+20|0,598768)|0;gs=c[149478]|0;as=gs+4|0;cs=c[as>>2]|0;do if(cs){fs=cs;while(1){Zr=c[fs+16>>2]|0;if((Zr|0)>202){Tr=c[fs>>2]|0;if(!Tr){hs=fs;is=fs;o=1474;break}else{fs=Tr;continue}}if((Zr|0)>=202){js=fs;o=1478;break}Zr=fs+4|0;Tr=c[Zr>>2]|0;if(!Tr){ks=Zr;ls=fs;o=1477;break}else fs=Tr}if((o|0)==1474){c[d>>2]=is;ms=hs;ns=is;break}else if((o|0)==1477){c[d>>2]=ls;ms=ks;ns=ls;break}else if((o|0)==1478){c[d>>2]=js;ms=d;ns=js;break}}else{fs=gs+4|0;c[d>>2]=fs;ms=fs;ns=fs}while(0);js=c[ms>>2]|0;if(!js){ls=xCi(32)|0;c[ls+16>>2]=202;ks=ls+20|0;c[ks+0>>2]=0;c[ks+4>>2]=0;c[ks+8>>2]=0;c[ls>>2]=0;c[ls+4>>2]=0;c[ls+8>>2]=ns;c[ms>>2]=ls;ns=c[c[gs>>2]>>2]|0;if(!ns)os=ls;else{c[gs>>2]=ns;os=c[ms>>2]|0}GN(c[as>>2]|0,os);os=gs+8|0;c[os>>2]=(c[os>>2]|0)+1;ps=ls}else ps=js;zri(ps+20|0,598784)|0;ps=c[149478]|0;js=ps+4|0;ls=c[js>>2]|0;do if(ls){os=ls;while(1){gs=c[os+16>>2]|0;if((gs|0)>203){as=c[os>>2]|0;if(!as){qs=os;rs=os;o=1487;break}else{os=as;continue}}if((gs|0)>=203){ss=os;o=1491;break}gs=os+4|0;as=c[gs>>2]|0;if(!as){ts=gs;us=os;o=1490;break}else os=as}if((o|0)==1487){c[d>>2]=rs;vs=qs;ws=rs;break}else if((o|0)==1490){c[d>>2]=us;vs=ts;ws=us;break}else if((o|0)==1491){c[d>>2]=ss;vs=d;ws=ss;break}}else{os=ps+4|0;c[d>>2]=os;vs=os;ws=os}while(0);ss=c[vs>>2]|0;if(!ss){us=xCi(32)|0;c[us+16>>2]=203;ts=us+20|0;c[ts+0>>2]=0;c[ts+4>>2]=0;c[ts+8>>2]=0;c[us>>2]=0;c[us+4>>2]=0;c[us+8>>2]=ws;c[vs>>2]=us;ws=c[c[ps>>2]>>2]|0;if(!ws)xs=us;else{c[ps>>2]=ws;xs=c[vs>>2]|0}GN(c[js>>2]|0,xs);xs=ps+8|0;c[xs>>2]=(c[xs>>2]|0)+1;ys=us}else ys=ss;zri(ys+20|0,598800)|0;ys=c[149478]|0;ss=ys+4|0;us=c[ss>>2]|0;do if(us){xs=us;while(1){ps=c[xs+16>>2]|0;if((ps|0)>204){js=c[xs>>2]|0;if(!js){zs=xs;As=xs;o=1500;break}else{xs=js;continue}}if((ps|0)>=204){Bs=xs;o=1504;break}ps=xs+4|0;js=c[ps>>2]|0;if(!js){Cs=ps;Ds=xs;o=1503;break}else xs=js}if((o|0)==1500){c[d>>2]=As;Es=zs;Fs=As;break}else if((o|0)==1503){c[d>>2]=Ds;Es=Cs;Fs=Ds;break}else if((o|0)==1504){c[d>>2]=Bs;Es=d;Fs=Bs;break}}else{xs=ys+4|0;c[d>>2]=xs;Es=xs;Fs=xs}while(0);Bs=c[Es>>2]|0;if(!Bs){Ds=xCi(32)|0;c[Ds+16>>2]=204;Cs=Ds+20|0;c[Cs+0>>2]=0;c[Cs+4>>2]=0;c[Cs+8>>2]=0;c[Ds>>2]=0;c[Ds+4>>2]=0;c[Ds+8>>2]=Fs;c[Es>>2]=Ds;Fs=c[c[ys>>2]>>2]|0;if(!Fs)Gs=Ds;else{c[ys>>2]=Fs;Gs=c[Es>>2]|0}GN(c[ss>>2]|0,Gs);Gs=ys+8|0;c[Gs>>2]=(c[Gs>>2]|0)+1;Hs=Ds}else Hs=Bs;zri(Hs+20|0,598816)|0;Hs=c[149478]|0;Bs=Hs+4|0;Ds=c[Bs>>2]|0;do if(Ds){Gs=Ds;while(1){ys=c[Gs+16>>2]|0;if((ys|0)>205){ss=c[Gs>>2]|0;if(!ss){Is=Gs;Js=Gs;o=1513;break}else{Gs=ss;continue}}if((ys|0)>=205){Ks=Gs;o=1517;break}ys=Gs+4|0;ss=c[ys>>2]|0;if(!ss){Ls=ys;Ms=Gs;o=1516;break}else Gs=ss}if((o|0)==1513){c[d>>2]=Js;Ns=Is;Os=Js;break}else if((o|0)==1516){c[d>>2]=Ms;Ns=Ls;Os=Ms;break}else if((o|0)==1517){c[d>>2]=Ks;Ns=d;Os=Ks;break}}else{Gs=Hs+4|0;c[d>>2]=Gs;Ns=Gs;Os=Gs}while(0);Ks=c[Ns>>2]|0;if(!Ks){Ms=xCi(32)|0;c[Ms+16>>2]=205;Ls=Ms+20|0;c[Ls+0>>2]=0;c[Ls+4>>2]=0;c[Ls+8>>2]=0;c[Ms>>2]=0;c[Ms+4>>2]=0;c[Ms+8>>2]=Os;c[Ns>>2]=Ms;Os=c[c[Hs>>2]>>2]|0;if(!Os)Ps=Ms;else{c[Hs>>2]=Os;Ps=c[Ns>>2]|0}GN(c[Bs>>2]|0,Ps);Ps=Hs+8|0;c[Ps>>2]=(c[Ps>>2]|0)+1;Qs=Ms}else Qs=Ks;zri(Qs+20|0,598832)|0;Qs=c[149478]|0;Ks=Qs+4|0;Ms=c[Ks>>2]|0;do if(Ms){Ps=Ms;while(1){Hs=c[Ps+16>>2]|0;if((Hs|0)>206){Bs=c[Ps>>2]|0;if(!Bs){Rs=Ps;Ss=Ps;o=1526;break}else{Ps=Bs;continue}}if((Hs|0)>=206){Ts=Ps;o=1530;break}Hs=Ps+4|0;Bs=c[Hs>>2]|0;if(!Bs){Us=Hs;Vs=Ps;o=1529;break}else Ps=Bs}if((o|0)==1526){c[d>>2]=Ss;Ws=Rs;Xs=Ss;break}else if((o|0)==1529){c[d>>2]=Vs;Ws=Us;Xs=Vs;break}else if((o|0)==1530){c[d>>2]=Ts;Ws=d;Xs=Ts;break}}else{Ps=Qs+4|0;c[d>>2]=Ps;Ws=Ps;Xs=Ps}while(0);Ts=c[Ws>>2]|0;if(!Ts){Vs=xCi(32)|0;c[Vs+16>>2]=206;Us=Vs+20|0;c[Us+0>>2]=0;c[Us+4>>2]=0;c[Us+8>>2]=0;c[Vs>>2]=0;c[Vs+4>>2]=0;c[Vs+8>>2]=Xs;c[Ws>>2]=Vs;Xs=c[c[Qs>>2]>>2]|0;if(!Xs)Ys=Vs;else{c[Qs>>2]=Xs;Ys=c[Ws>>2]|0}GN(c[Ks>>2]|0,Ys);Ys=Qs+8|0;c[Ys>>2]=(c[Ys>>2]|0)+1;Zs=Vs}else Zs=Ts;zri(Zs+20|0,598848)|0;Zs=c[149478]|0;Ts=Zs+4|0;Vs=c[Ts>>2]|0;do if(Vs){Ys=Vs;while(1){Qs=c[Ys+16>>2]|0;if((Qs|0)>207){Ks=c[Ys>>2]|0;if(!Ks){_s=Ys;$s=Ys;o=1539;break}else{Ys=Ks;continue}}if((Qs|0)>=207){at=Ys;o=1543;break}Qs=Ys+4|0;Ks=c[Qs>>2]|0;if(!Ks){bt=Qs;ct=Ys;o=1542;break}else Ys=Ks}if((o|0)==1539){c[d>>2]=$s;dt=_s;et=$s;break}else if((o|0)==1542){c[d>>2]=ct;dt=bt;et=ct;break}else if((o|0)==1543){c[d>>2]=at;dt=d;et=at;break}}else{Ys=Zs+4|0;c[d>>2]=Ys;dt=Ys;et=Ys}while(0);at=c[dt>>2]|0;if(!at){ct=xCi(32)|0;c[ct+16>>2]=207;bt=ct+20|0;c[bt+0>>2]=0;c[bt+4>>2]=0;c[bt+8>>2]=0;c[ct>>2]=0;c[ct+4>>2]=0;c[ct+8>>2]=et;c[dt>>2]=ct;et=c[c[Zs>>2]>>2]|0;if(!et)ft=ct;else{c[Zs>>2]=et;ft=c[dt>>2]|0}GN(c[Ts>>2]|0,ft);ft=Zs+8|0;c[ft>>2]=(c[ft>>2]|0)+1;gt=ct}else gt=at;zri(gt+20|0,598864)|0;gt=c[149478]|0;at=gt+4|0;ct=c[at>>2]|0;do if(ct){ft=ct;while(1){Zs=c[ft+16>>2]|0;if((Zs|0)>208){Ts=c[ft>>2]|0;if(!Ts){ht=ft;it=ft;o=1552;break}else{ft=Ts;continue}}if((Zs|0)>=208){jt=ft;o=1556;break}Zs=ft+4|0;Ts=c[Zs>>2]|0;if(!Ts){kt=Zs;lt=ft;o=1555;break}else ft=Ts}if((o|0)==1552){c[d>>2]=it;mt=ht;nt=it;break}else if((o|0)==1555){c[d>>2]=lt;mt=kt;nt=lt;break}else if((o|0)==1556){c[d>>2]=jt;mt=d;nt=jt;break}}else{ft=gt+4|0;c[d>>2]=ft;mt=ft;nt=ft}while(0);jt=c[mt>>2]|0;if(!jt){lt=xCi(32)|0;c[lt+16>>2]=208;kt=lt+20|0;c[kt+0>>2]=0;c[kt+4>>2]=0;c[kt+8>>2]=0;c[lt>>2]=0;c[lt+4>>2]=0;c[lt+8>>2]=nt;c[mt>>2]=lt;nt=c[c[gt>>2]>>2]|0;if(!nt)ot=lt;else{c[gt>>2]=nt;ot=c[mt>>2]|0}GN(c[at>>2]|0,ot);ot=gt+8|0;c[ot>>2]=(c[ot>>2]|0)+1;pt=lt}else pt=jt;zri(pt+20|0,598880)|0;pt=c[149478]|0;jt=pt+4|0;lt=c[jt>>2]|0;do if(lt){ot=lt;while(1){gt=c[ot+16>>2]|0;if((gt|0)>209){at=c[ot>>2]|0;if(!at){qt=ot;rt=ot;o=1565;break}else{ot=at;continue}}if((gt|0)>=209){st=ot;o=1569;break}gt=ot+4|0;at=c[gt>>2]|0;if(!at){tt=gt;ut=ot;o=1568;break}else ot=at}if((o|0)==1565){c[d>>2]=rt;vt=qt;wt=rt;break}else if((o|0)==1568){c[d>>2]=ut;vt=tt;wt=ut;break}else if((o|0)==1569){c[d>>2]=st;vt=d;wt=st;break}}else{ot=pt+4|0;c[d>>2]=ot;vt=ot;wt=ot}while(0);st=c[vt>>2]|0;if(!st){ut=xCi(32)|0;c[ut+16>>2]=209;tt=ut+20|0;c[tt+0>>2]=0;c[tt+4>>2]=0;c[tt+8>>2]=0;c[ut>>2]=0;c[ut+4>>2]=0;c[ut+8>>2]=wt;c[vt>>2]=ut;wt=c[c[pt>>2]>>2]|0;if(!wt)xt=ut;else{c[pt>>2]=wt;xt=c[vt>>2]|0}GN(c[jt>>2]|0,xt);xt=pt+8|0;c[xt>>2]=(c[xt>>2]|0)+1;yt=ut}else yt=st;zri(yt+20|0,598896)|0;yt=c[149478]|0;st=yt+4|0;ut=c[st>>2]|0;do if(ut){xt=ut;while(1){pt=c[xt+16>>2]|0;if((pt|0)>210){jt=c[xt>>2]|0;if(!jt){zt=xt;At=xt;o=1578;break}else{xt=jt;continue}}if((pt|0)>=210){Bt=xt;o=1582;break}pt=xt+4|0;jt=c[pt>>2]|0;if(!jt){Ct=pt;Dt=xt;o=1581;break}else xt=jt}if((o|0)==1578){c[d>>2]=At;Et=zt;Ft=At;break}else if((o|0)==1581){c[d>>2]=Dt;Et=Ct;Ft=Dt;break}else if((o|0)==1582){c[d>>2]=Bt;Et=d;Ft=Bt;break}}else{xt=yt+4|0;c[d>>2]=xt;Et=xt;Ft=xt}while(0);Bt=c[Et>>2]|0;if(!Bt){Dt=xCi(32)|0;c[Dt+16>>2]=210;Ct=Dt+20|0;c[Ct+0>>2]=0;c[Ct+4>>2]=0;c[Ct+8>>2]=0;c[Dt>>2]=0;c[Dt+4>>2]=0;c[Dt+8>>2]=Ft;c[Et>>2]=Dt;Ft=c[c[yt>>2]>>2]|0;if(!Ft)Gt=Dt;else{c[yt>>2]=Ft;Gt=c[Et>>2]|0}GN(c[st>>2]|0,Gt);Gt=yt+8|0;c[Gt>>2]=(c[Gt>>2]|0)+1;Ht=Dt}else Ht=Bt;zri(Ht+20|0,598912)|0;Ht=c[149478]|0;Bt=Ht+4|0;Dt=c[Bt>>2]|0;do if(Dt){Gt=Dt;while(1){yt=c[Gt+16>>2]|0;if((yt|0)>211){st=c[Gt>>2]|0;if(!st){It=Gt;Jt=Gt;o=1591;break}else{Gt=st;continue}}if((yt|0)>=211){Kt=Gt;o=1595;break}yt=Gt+4|0;st=c[yt>>2]|0;if(!st){Lt=yt;Mt=Gt;o=1594;break}else Gt=st}if((o|0)==1591){c[d>>2]=Jt;Nt=It;Ot=Jt;break}else if((o|0)==1594){c[d>>2]=Mt;Nt=Lt;Ot=Mt;break}else if((o|0)==1595){c[d>>2]=Kt;Nt=d;Ot=Kt;break}}else{Gt=Ht+4|0;c[d>>2]=Gt;Nt=Gt;Ot=Gt}while(0);Kt=c[Nt>>2]|0;if(!Kt){Mt=xCi(32)|0;c[Mt+16>>2]=211;Lt=Mt+20|0;c[Lt+0>>2]=0;c[Lt+4>>2]=0;c[Lt+8>>2]=0;c[Mt>>2]=0;c[Mt+4>>2]=0;c[Mt+8>>2]=Ot;c[Nt>>2]=Mt;Ot=c[c[Ht>>2]>>2]|0;if(!Ot)Pt=Mt;else{c[Ht>>2]=Ot;Pt=c[Nt>>2]|0}GN(c[Bt>>2]|0,Pt);Pt=Ht+8|0;c[Pt>>2]=(c[Pt>>2]|0)+1;Qt=Mt}else Qt=Kt;zri(Qt+20|0,598928)|0;Qt=c[149478]|0;Kt=Qt+4|0;Mt=c[Kt>>2]|0;do if(Mt){Pt=Mt;while(1){Ht=c[Pt+16>>2]|0;if((Ht|0)>212){Bt=c[Pt>>2]|0;if(!Bt){Rt=Pt;St=Pt;o=1604;break}else{Pt=Bt;continue}}if((Ht|0)>=212){Tt=Pt;o=1608;break}Ht=Pt+4|0;Bt=c[Ht>>2]|0;if(!Bt){Ut=Ht;Vt=Pt;o=1607;break}else Pt=Bt}if((o|0)==1604){c[d>>2]=St;Wt=Rt;Xt=St;break}else if((o|0)==1607){c[d>>2]=Vt;Wt=Ut;Xt=Vt;break}else if((o|0)==1608){c[d>>2]=Tt;Wt=d;Xt=Tt;break}}else{Pt=Qt+4|0;c[d>>2]=Pt;Wt=Pt;Xt=Pt}while(0);Tt=c[Wt>>2]|0;if(!Tt){Vt=xCi(32)|0;c[Vt+16>>2]=212;Ut=Vt+20|0;c[Ut+0>>2]=0;c[Ut+4>>2]=0;c[Ut+8>>2]=0;c[Vt>>2]=0;c[Vt+4>>2]=0;c[Vt+8>>2]=Xt;c[Wt>>2]=Vt;Xt=c[c[Qt>>2]>>2]|0;if(!Xt)Yt=Vt;else{c[Qt>>2]=Xt;Yt=c[Wt>>2]|0}GN(c[Kt>>2]|0,Yt);Yt=Qt+8|0;c[Yt>>2]=(c[Yt>>2]|0)+1;Zt=Vt}else Zt=Tt;zri(Zt+20|0,598944)|0;Zt=c[149478]|0;Tt=Zt+4|0;Vt=c[Tt>>2]|0;do if(Vt){Yt=Vt;while(1){Qt=c[Yt+16>>2]|0;if((Qt|0)>213){Kt=c[Yt>>2]|0;if(!Kt){_t=Yt;$t=Yt;o=1617;break}else{Yt=Kt;continue}}if((Qt|0)>=213){au=Yt;o=1621;break}Qt=Yt+4|0;Kt=c[Qt>>2]|0;if(!Kt){bu=Qt;cu=Yt;o=1620;break}else Yt=Kt}if((o|0)==1617){c[d>>2]=$t;du=_t;eu=$t;break}else if((o|0)==1620){c[d>>2]=cu;du=bu;eu=cu;break}else if((o|0)==1621){c[d>>2]=au;du=d;eu=au;break}}else{Yt=Zt+4|0;c[d>>2]=Yt;du=Yt;eu=Yt}while(0);au=c[du>>2]|0;if(!au){cu=xCi(32)|0;c[cu+16>>2]=213;bu=cu+20|0;c[bu+0>>2]=0;c[bu+4>>2]=0;c[bu+8>>2]=0;c[cu>>2]=0;c[cu+4>>2]=0;c[cu+8>>2]=eu;c[du>>2]=cu;eu=c[c[Zt>>2]>>2]|0;if(!eu)fu=cu;else{c[Zt>>2]=eu;fu=c[du>>2]|0}GN(c[Tt>>2]|0,fu);fu=Zt+8|0;c[fu>>2]=(c[fu>>2]|0)+1;gu=cu}else gu=au;zri(gu+20|0,598960)|0;gu=c[149478]|0;au=gu+4|0;cu=c[au>>2]|0;do if(cu){fu=cu;while(1){Zt=c[fu+16>>2]|0;if((Zt|0)>214){Tt=c[fu>>2]|0;if(!Tt){hu=fu;iu=fu;o=1630;break}else{fu=Tt;continue}}if((Zt|0)>=214){ju=fu;o=1634;break}Zt=fu+4|0;Tt=c[Zt>>2]|0;if(!Tt){ku=Zt;lu=fu;o=1633;break}else fu=Tt}if((o|0)==1630){c[d>>2]=iu;mu=hu;nu=iu;break}else if((o|0)==1633){c[d>>2]=lu;mu=ku;nu=lu;break}else if((o|0)==1634){c[d>>2]=ju;mu=d;nu=ju;break}}else{fu=gu+4|0;c[d>>2]=fu;mu=fu;nu=fu}while(0);ju=c[mu>>2]|0;if(!ju){lu=xCi(32)|0;c[lu+16>>2]=214;ku=lu+20|0;c[ku+0>>2]=0;c[ku+4>>2]=0;c[ku+8>>2]=0;c[lu>>2]=0;c[lu+4>>2]=0;c[lu+8>>2]=nu;c[mu>>2]=lu;nu=c[c[gu>>2]>>2]|0;if(!nu)ou=lu;else{c[gu>>2]=nu;ou=c[mu>>2]|0}GN(c[au>>2]|0,ou);ou=gu+8|0;c[ou>>2]=(c[ou>>2]|0)+1;pu=lu}else pu=ju;zri(pu+20|0,598976)|0;pu=c[149478]|0;ju=pu+4|0;lu=c[ju>>2]|0;do if(lu){ou=lu;while(1){gu=c[ou+16>>2]|0;if((gu|0)>215){au=c[ou>>2]|0;if(!au){qu=ou;ru=ou;o=1643;break}else{ou=au;continue}}if((gu|0)>=215){su=ou;o=1647;break}gu=ou+4|0;au=c[gu>>2]|0;if(!au){tu=gu;uu=ou;o=1646;break}else ou=au}if((o|0)==1643){c[d>>2]=ru;vu=qu;wu=ru;break}else if((o|0)==1646){c[d>>2]=uu;vu=tu;wu=uu;break}else if((o|0)==1647){c[d>>2]=su;vu=d;wu=su;break}}else{ou=pu+4|0;c[d>>2]=ou;vu=ou;wu=ou}while(0);su=c[vu>>2]|0;if(!su){uu=xCi(32)|0;c[uu+16>>2]=215;tu=uu+20|0;c[tu+0>>2]=0;c[tu+4>>2]=0;c[tu+8>>2]=0;c[uu>>2]=0;c[uu+4>>2]=0;c[uu+8>>2]=wu;c[vu>>2]=uu;wu=c[c[pu>>2]>>2]|0;if(!wu)xu=uu;else{c[pu>>2]=wu;xu=c[vu>>2]|0}GN(c[ju>>2]|0,xu);xu=pu+8|0;c[xu>>2]=(c[xu>>2]|0)+1;yu=uu}else yu=su;zri(yu+20|0,598992)|0;yu=c[149478]|0;su=yu+4|0;uu=c[su>>2]|0;do if(uu){xu=uu;while(1){pu=c[xu+16>>2]|0;if((pu|0)>216){ju=c[xu>>2]|0;if(!ju){zu=xu;Au=xu;o=1656;break}else{xu=ju;continue}}if((pu|0)>=216){Bu=xu;o=1660;break}pu=xu+4|0;ju=c[pu>>2]|0;if(!ju){Cu=pu;Du=xu;o=1659;break}else xu=ju}if((o|0)==1656){c[d>>2]=Au;Eu=zu;Fu=Au;break}else if((o|0)==1659){c[d>>2]=Du;Eu=Cu;Fu=Du;break}else if((o|0)==1660){c[d>>2]=Bu;Eu=d;Fu=Bu;break}}else{xu=yu+4|0;c[d>>2]=xu;Eu=xu;Fu=xu}while(0);Bu=c[Eu>>2]|0;if(!Bu){Du=xCi(32)|0;c[Du+16>>2]=216;Cu=Du+20|0;c[Cu+0>>2]=0;c[Cu+4>>2]=0;c[Cu+8>>2]=0;c[Du>>2]=0;c[Du+4>>2]=0;c[Du+8>>2]=Fu;c[Eu>>2]=Du;Fu=c[c[yu>>2]>>2]|0;if(!Fu)Gu=Du;else{c[yu>>2]=Fu;Gu=c[Eu>>2]|0}GN(c[su>>2]|0,Gu);Gu=yu+8|0;c[Gu>>2]=(c[Gu>>2]|0)+1;Hu=Du}else Hu=Bu;zri(Hu+20|0,599008)|0;Hu=c[149478]|0;Bu=Hu+4|0;Du=c[Bu>>2]|0;do if(Du){Gu=Du;while(1){yu=c[Gu+16>>2]|0;if((yu|0)>217){su=c[Gu>>2]|0;if(!su){Iu=Gu;Ju=Gu;o=1669;break}else{Gu=su;continue}}if((yu|0)>=217){Ku=Gu;o=1673;break}yu=Gu+4|0;su=c[yu>>2]|0;if(!su){Lu=yu;Mu=Gu;o=1672;break}else Gu=su}if((o|0)==1669){c[d>>2]=Ju;Nu=Iu;Ou=Ju;break}else if((o|0)==1672){c[d>>2]=Mu;Nu=Lu;Ou=Mu;break}else if((o|0)==1673){c[d>>2]=Ku;Nu=d;Ou=Ku;break}}else{Gu=Hu+4|0;c[d>>2]=Gu;Nu=Gu;Ou=Gu}while(0);Ku=c[Nu>>2]|0;if(!Ku){Mu=xCi(32)|0;c[Mu+16>>2]=217;Lu=Mu+20|0;c[Lu+0>>2]=0;c[Lu+4>>2]=0;c[Lu+8>>2]=0;c[Mu>>2]=0;c[Mu+4>>2]=0;c[Mu+8>>2]=Ou;c[Nu>>2]=Mu;Ou=c[c[Hu>>2]>>2]|0;if(!Ou)Pu=Mu;else{c[Hu>>2]=Ou;Pu=c[Nu>>2]|0}GN(c[Bu>>2]|0,Pu);Pu=Hu+8|0;c[Pu>>2]=(c[Pu>>2]|0)+1;Qu=Mu}else Qu=Ku;zri(Qu+20|0,599024)|0;Qu=c[149478]|0;Ku=Qu+4|0;Mu=c[Ku>>2]|0;do if(Mu){Pu=Mu;while(1){Hu=c[Pu+16>>2]|0;if((Hu|0)>218){Bu=c[Pu>>2]|0;if(!Bu){Ru=Pu;Su=Pu;o=1682;break}else{Pu=Bu;continue}}if((Hu|0)>=218){Tu=Pu;o=1686;break}Hu=Pu+4|0;Bu=c[Hu>>2]|0;if(!Bu){Uu=Hu;Vu=Pu;o=1685;break}else Pu=Bu}if((o|0)==1682){c[d>>2]=Su;Wu=Ru;Xu=Su;break}else if((o|0)==1685){c[d>>2]=Vu;Wu=Uu;Xu=Vu;break}else if((o|0)==1686){c[d>>2]=Tu;Wu=d;Xu=Tu;break}}else{Pu=Qu+4|0;c[d>>2]=Pu;Wu=Pu;Xu=Pu}while(0);Tu=c[Wu>>2]|0;if(!Tu){Vu=xCi(32)|0;c[Vu+16>>2]=218;Uu=Vu+20|0;c[Uu+0>>2]=0;c[Uu+4>>2]=0;c[Uu+8>>2]=0;c[Vu>>2]=0;c[Vu+4>>2]=0;c[Vu+8>>2]=Xu;c[Wu>>2]=Vu;Xu=c[c[Qu>>2]>>2]|0;if(!Xu)Yu=Vu;else{c[Qu>>2]=Xu;Yu=c[Wu>>2]|0}GN(c[Ku>>2]|0,Yu);Yu=Qu+8|0;c[Yu>>2]=(c[Yu>>2]|0)+1;Zu=Vu}else Zu=Tu;zri(Zu+20|0,599040)|0;Zu=c[149478]|0;Tu=Zu+4|0;Vu=c[Tu>>2]|0;do if(Vu){Yu=Vu;while(1){Qu=c[Yu+16>>2]|0;if((Qu|0)>219){Ku=c[Yu>>2]|0;if(!Ku){_u=Yu;$u=Yu;o=1695;break}else{Yu=Ku;continue}}if((Qu|0)>=219){av=Yu;o=1699;break}Qu=Yu+4|0;Ku=c[Qu>>2]|0;if(!Ku){bv=Qu;cv=Yu;o=1698;break}else Yu=Ku}if((o|0)==1695){c[d>>2]=$u;dv=_u;ev=$u;break}else if((o|0)==1698){c[d>>2]=cv;dv=bv;ev=cv;break}else if((o|0)==1699){c[d>>2]=av;dv=d;ev=av;break}}else{Yu=Zu+4|0;c[d>>2]=Yu;dv=Yu;ev=Yu}while(0);av=c[dv>>2]|0;if(!av){cv=xCi(32)|0;c[cv+16>>2]=219;bv=cv+20|0;c[bv+0>>2]=0;c[bv+4>>2]=0;c[bv+8>>2]=0;c[cv>>2]=0;c[cv+4>>2]=0;c[cv+8>>2]=ev;c[dv>>2]=cv;ev=c[c[Zu>>2]>>2]|0;if(!ev)fv=cv;else{c[Zu>>2]=ev;fv=c[dv>>2]|0}GN(c[Tu>>2]|0,fv);fv=Zu+8|0;c[fv>>2]=(c[fv>>2]|0)+1;gv=cv}else gv=av;zri(gv+20|0,599056)|0;gv=c[149478]|0;av=gv+4|0;cv=c[av>>2]|0;do if(cv){fv=cv;while(1){Zu=c[fv+16>>2]|0;if((Zu|0)>220){Tu=c[fv>>2]|0;if(!Tu){hv=fv;iv=fv;o=1708;break}else{fv=Tu;continue}}if((Zu|0)>=220){jv=fv;o=1712;break}Zu=fv+4|0;Tu=c[Zu>>2]|0;if(!Tu){kv=Zu;lv=fv;o=1711;break}else fv=Tu}if((o|0)==1708){c[d>>2]=iv;mv=hv;nv=iv;break}else if((o|0)==1711){c[d>>2]=lv;mv=kv;nv=lv;break}else if((o|0)==1712){c[d>>2]=jv;mv=d;nv=jv;break}}else{fv=gv+4|0;c[d>>2]=fv;mv=fv;nv=fv}while(0);jv=c[mv>>2]|0;if(!jv){lv=xCi(32)|0;c[lv+16>>2]=220;kv=lv+20|0;c[kv+0>>2]=0;c[kv+4>>2]=0;c[kv+8>>2]=0;c[lv>>2]=0;c[lv+4>>2]=0;c[lv+8>>2]=nv;c[mv>>2]=lv;nv=c[c[gv>>2]>>2]|0;if(!nv)ov=lv;else{c[gv>>2]=nv;ov=c[mv>>2]|0}GN(c[av>>2]|0,ov);ov=gv+8|0;c[ov>>2]=(c[ov>>2]|0)+1;pv=lv}else pv=jv;zri(pv+20|0,599072)|0;pv=c[149478]|0;jv=pv+4|0;lv=c[jv>>2]|0;do if(lv){ov=lv;while(1){gv=c[ov+16>>2]|0;if((gv|0)>221){av=c[ov>>2]|0;if(!av){qv=ov;rv=ov;o=1721;break}else{ov=av;continue}}if((gv|0)>=221){sv=ov;o=1725;break}gv=ov+4|0;av=c[gv>>2]|0;if(!av){tv=gv;uv=ov;o=1724;break}else ov=av}if((o|0)==1721){c[d>>2]=rv;vv=qv;wv=rv;break}else if((o|0)==1724){c[d>>2]=uv;vv=tv;wv=uv;break}else if((o|0)==1725){c[d>>2]=sv;vv=d;wv=sv;break}}else{ov=pv+4|0;c[d>>2]=ov;vv=ov;wv=ov}while(0);sv=c[vv>>2]|0;if(!sv){uv=xCi(32)|0;c[uv+16>>2]=221;tv=uv+20|0;c[tv+0>>2]=0;c[tv+4>>2]=0;c[tv+8>>2]=0;c[uv>>2]=0;c[uv+4>>2]=0;c[uv+8>>2]=wv;c[vv>>2]=uv;wv=c[c[pv>>2]>>2]|0;if(!wv)xv=uv;else{c[pv>>2]=wv;xv=c[vv>>2]|0}GN(c[jv>>2]|0,xv);xv=pv+8|0;c[xv>>2]=(c[xv>>2]|0)+1;yv=uv}else yv=sv;zri(yv+20|0,599088)|0;yv=c[149478]|0;sv=yv+4|0;uv=c[sv>>2]|0;do if(uv){xv=uv;while(1){pv=c[xv+16>>2]|0;if((pv|0)>222){jv=c[xv>>2]|0;if(!jv){zv=xv;Av=xv;o=1734;break}else{xv=jv;continue}}if((pv|0)>=222){Bv=xv;o=1738;break}pv=xv+4|0;jv=c[pv>>2]|0;if(!jv){Cv=pv;Dv=xv;o=1737;break}else xv=jv}if((o|0)==1734){c[d>>2]=Av;Ev=zv;Fv=Av;break}else if((o|0)==1737){c[d>>2]=Dv;Ev=Cv;Fv=Dv;break}else if((o|0)==1738){c[d>>2]=Bv;Ev=d;Fv=Bv;break}}else{xv=yv+4|0;c[d>>2]=xv;Ev=xv;Fv=xv}while(0);Bv=c[Ev>>2]|0;if(!Bv){Dv=xCi(32)|0;c[Dv+16>>2]=222;Cv=Dv+20|0;c[Cv+0>>2]=0;c[Cv+4>>2]=0;c[Cv+8>>2]=0;c[Dv>>2]=0;c[Dv+4>>2]=0;c[Dv+8>>2]=Fv;c[Ev>>2]=Dv;Fv=c[c[yv>>2]>>2]|0;if(!Fv)Gv=Dv;else{c[yv>>2]=Fv;Gv=c[Ev>>2]|0}GN(c[sv>>2]|0,Gv);Gv=yv+8|0;c[Gv>>2]=(c[Gv>>2]|0)+1;Hv=Dv}else Hv=Bv;zri(Hv+20|0,599104)|0;Hv=c[149478]|0;Bv=Hv+4|0;Dv=c[Bv>>2]|0;do if(Dv){Gv=Dv;while(1){yv=c[Gv+16>>2]|0;if((yv|0)>223){sv=c[Gv>>2]|0;if(!sv){Iv=Gv;Jv=Gv;o=1747;break}else{Gv=sv;continue}}if((yv|0)>=223){Kv=Gv;o=1751;break}yv=Gv+4|0;sv=c[yv>>2]|0;if(!sv){Lv=yv;Mv=Gv;o=1750;break}else Gv=sv}if((o|0)==1747){c[d>>2]=Jv;Nv=Iv;Ov=Jv;break}else if((o|0)==1750){c[d>>2]=Mv;Nv=Lv;Ov=Mv;break}else if((o|0)==1751){c[d>>2]=Kv;Nv=d;Ov=Kv;break}}else{Gv=Hv+4|0;c[d>>2]=Gv;Nv=Gv;Ov=Gv}while(0);Kv=c[Nv>>2]|0;if(!Kv){Mv=xCi(32)|0;c[Mv+16>>2]=223;Lv=Mv+20|0;c[Lv+0>>2]=0;c[Lv+4>>2]=0;c[Lv+8>>2]=0;c[Mv>>2]=0;c[Mv+4>>2]=0;c[Mv+8>>2]=Ov;c[Nv>>2]=Mv;Ov=c[c[Hv>>2]>>2]|0;if(!Ov)Pv=Mv;else{c[Hv>>2]=Ov;Pv=c[Nv>>2]|0}GN(c[Bv>>2]|0,Pv);Pv=Hv+8|0;c[Pv>>2]=(c[Pv>>2]|0)+1;Qv=Mv}else Qv=Kv;zri(Qv+20|0,599120)|0;Qv=c[149478]|0;Kv=Qv+4|0;Mv=c[Kv>>2]|0;do if(Mv){Pv=Mv;while(1){Hv=c[Pv+16>>2]|0;if((Hv|0)>224){Bv=c[Pv>>2]|0;if(!Bv){Rv=Pv;Sv=Pv;o=1760;break}else{Pv=Bv;continue}}if((Hv|0)>=224){Tv=Pv;o=1764;break}Hv=Pv+4|0;Bv=c[Hv>>2]|0;if(!Bv){Uv=Hv;Vv=Pv;o=1763;break}else Pv=Bv}if((o|0)==1760){c[d>>2]=Sv;Wv=Rv;Xv=Sv;break}else if((o|0)==1763){c[d>>2]=Vv;Wv=Uv;Xv=Vv;break}else if((o|0)==1764){c[d>>2]=Tv;Wv=d;Xv=Tv;break}}else{Pv=Qv+4|0;c[d>>2]=Pv;Wv=Pv;Xv=Pv}while(0);Tv=c[Wv>>2]|0;if(!Tv){Vv=xCi(32)|0;c[Vv+16>>2]=224;Uv=Vv+20|0;c[Uv+0>>2]=0;c[Uv+4>>2]=0;c[Uv+8>>2]=0;c[Vv>>2]=0;c[Vv+4>>2]=0;c[Vv+8>>2]=Xv;c[Wv>>2]=Vv;Xv=c[c[Qv>>2]>>2]|0;if(!Xv)Yv=Vv;else{c[Qv>>2]=Xv;Yv=c[Wv>>2]|0}GN(c[Kv>>2]|0,Yv);Yv=Qv+8|0;c[Yv>>2]=(c[Yv>>2]|0)+1;Zv=Vv}else Zv=Tv;zri(Zv+20|0,599136)|0;Zv=c[149478]|0;Tv=Zv+4|0;Vv=c[Tv>>2]|0;do if(Vv){Yv=Vv;while(1){Qv=c[Yv+16>>2]|0;if((Qv|0)>225){Kv=c[Yv>>2]|0;if(!Kv){_v=Yv;$v=Yv;o=1773;break}else{Yv=Kv;continue}}if((Qv|0)>=225){aw=Yv;o=1777;break}Qv=Yv+4|0;Kv=c[Qv>>2]|0;if(!Kv){bw=Qv;cw=Yv;o=1776;break}else Yv=Kv}if((o|0)==1773){c[d>>2]=$v;dw=_v;ew=$v;break}else if((o|0)==1776){c[d>>2]=cw;dw=bw;ew=cw;break}else if((o|0)==1777){c[d>>2]=aw;dw=d;ew=aw;break}}else{Yv=Zv+4|0;c[d>>2]=Yv;dw=Yv;ew=Yv}while(0);aw=c[dw>>2]|0;if(!aw){cw=xCi(32)|0;c[cw+16>>2]=225;bw=cw+20|0;c[bw+0>>2]=0;c[bw+4>>2]=0;c[bw+8>>2]=0;c[cw>>2]=0;c[cw+4>>2]=0;c[cw+8>>2]=ew;c[dw>>2]=cw;ew=c[c[Zv>>2]>>2]|0;if(!ew)fw=cw;else{c[Zv>>2]=ew;fw=c[dw>>2]|0}GN(c[Tv>>2]|0,fw);fw=Zv+8|0;c[fw>>2]=(c[fw>>2]|0)+1;gw=cw}else gw=aw;zri(gw+20|0,599152)|0;gw=c[149478]|0;aw=gw+4|0;cw=c[aw>>2]|0;do if(cw){fw=cw;while(1){Zv=c[fw+16>>2]|0;if((Zv|0)>226){Tv=c[fw>>2]|0;if(!Tv){hw=fw;iw=fw;o=1786;break}else{fw=Tv;continue}}if((Zv|0)>=226){jw=fw;o=1790;break}Zv=fw+4|0;Tv=c[Zv>>2]|0;if(!Tv){kw=Zv;lw=fw;o=1789;break}else fw=Tv}if((o|0)==1786){c[d>>2]=iw;mw=hw;nw=iw;break}else if((o|0)==1789){c[d>>2]=lw;mw=kw;nw=lw;break}else if((o|0)==1790){c[d>>2]=jw;mw=d;nw=jw;break}}else{fw=gw+4|0;c[d>>2]=fw;mw=fw;nw=fw}while(0);jw=c[mw>>2]|0;if(!jw){lw=xCi(32)|0;c[lw+16>>2]=226;kw=lw+20|0;c[kw+0>>2]=0;c[kw+4>>2]=0;c[kw+8>>2]=0;c[lw>>2]=0;c[lw+4>>2]=0;c[lw+8>>2]=nw;c[mw>>2]=lw;nw=c[c[gw>>2]>>2]|0;if(!nw)ow=lw;else{c[gw>>2]=nw;ow=c[mw>>2]|0}GN(c[aw>>2]|0,ow);ow=gw+8|0;c[ow>>2]=(c[ow>>2]|0)+1;pw=lw}else pw=jw;zri(pw+20|0,599168)|0;pw=c[149478]|0;jw=pw+4|0;lw=c[jw>>2]|0;do if(lw){ow=lw;while(1){gw=c[ow+16>>2]|0;if((gw|0)>227){aw=c[ow>>2]|0;if(!aw){qw=ow;rw=ow;o=1799;break}else{ow=aw;continue}}if((gw|0)>=227){sw=ow;o=1803;break}gw=ow+4|0;aw=c[gw>>2]|0;if(!aw){tw=gw;uw=ow;o=1802;break}else ow=aw}if((o|0)==1799){c[d>>2]=rw;vw=qw;ww=rw;break}else if((o|0)==1802){c[d>>2]=uw;vw=tw;ww=uw;break}else if((o|0)==1803){c[d>>2]=sw;vw=d;ww=sw;break}}else{ow=pw+4|0;c[d>>2]=ow;vw=ow;ww=ow}while(0);sw=c[vw>>2]|0;if(!sw){uw=xCi(32)|0;c[uw+16>>2]=227;tw=uw+20|0;c[tw+0>>2]=0;c[tw+4>>2]=0;c[tw+8>>2]=0;c[uw>>2]=0;c[uw+4>>2]=0;c[uw+8>>2]=ww;c[vw>>2]=uw;ww=c[c[pw>>2]>>2]|0;if(!ww)xw=uw;else{c[pw>>2]=ww;xw=c[vw>>2]|0}GN(c[jw>>2]|0,xw);xw=pw+8|0;c[xw>>2]=(c[xw>>2]|0)+1;yw=uw}else yw=sw;zri(yw+20|0,599184)|0;yw=c[149478]|0;sw=yw+4|0;uw=c[sw>>2]|0;do if(uw){xw=uw;while(1){pw=c[xw+16>>2]|0;if((pw|0)>228){jw=c[xw>>2]|0;if(!jw){zw=xw;Aw=xw;o=1812;break}else{xw=jw;continue}}if((pw|0)>=228){Bw=xw;o=1816;break}pw=xw+4|0;jw=c[pw>>2]|0;if(!jw){Cw=pw;Dw=xw;o=1815;break}else xw=jw}if((o|0)==1812){c[d>>2]=Aw;Ew=zw;Fw=Aw;break}else if((o|0)==1815){c[d>>2]=Dw;Ew=Cw;Fw=Dw;break}else if((o|0)==1816){c[d>>2]=Bw;Ew=d;Fw=Bw;break}}else{xw=yw+4|0;c[d>>2]=xw;Ew=xw;Fw=xw}while(0);Bw=c[Ew>>2]|0;if(!Bw){Dw=xCi(32)|0;c[Dw+16>>2]=228;Cw=Dw+20|0;c[Cw+0>>2]=0;c[Cw+4>>2]=0;c[Cw+8>>2]=0;c[Dw>>2]=0;c[Dw+4>>2]=0;c[Dw+8>>2]=Fw;c[Ew>>2]=Dw;Fw=c[c[yw>>2]>>2]|0;if(!Fw)Gw=Dw;else{c[yw>>2]=Fw;Gw=c[Ew>>2]|0}GN(c[sw>>2]|0,Gw);Gw=yw+8|0;c[Gw>>2]=(c[Gw>>2]|0)+1;Hw=Dw}else Hw=Bw;zri(Hw+20|0,599200)|0;Hw=c[149478]|0;Bw=Hw+4|0;Dw=c[Bw>>2]|0;do if(Dw){Gw=Dw;while(1){yw=c[Gw+16>>2]|0;if((yw|0)>229){sw=c[Gw>>2]|0;if(!sw){Iw=Gw;Jw=Gw;o=1825;break}else{Gw=sw;continue}}if((yw|0)>=229){Kw=Gw;o=1829;break}yw=Gw+4|0;sw=c[yw>>2]|0;if(!sw){Lw=yw;Mw=Gw;o=1828;break}else Gw=sw}if((o|0)==1825){c[d>>2]=Jw;Nw=Iw;Ow=Jw;break}else if((o|0)==1828){c[d>>2]=Mw;Nw=Lw;Ow=Mw;break}else if((o|0)==1829){c[d>>2]=Kw;Nw=d;Ow=Kw;break}}else{Gw=Hw+4|0;c[d>>2]=Gw;Nw=Gw;Ow=Gw}while(0);Kw=c[Nw>>2]|0;if(!Kw){Mw=xCi(32)|0;c[Mw+16>>2]=229;Lw=Mw+20|0;c[Lw+0>>2]=0;c[Lw+4>>2]=0;c[Lw+8>>2]=0;c[Mw>>2]=0;c[Mw+4>>2]=0;c[Mw+8>>2]=Ow;c[Nw>>2]=Mw;Ow=c[c[Hw>>2]>>2]|0;if(!Ow)Pw=Mw;else{c[Hw>>2]=Ow;Pw=c[Nw>>2]|0}GN(c[Bw>>2]|0,Pw);Pw=Hw+8|0;c[Pw>>2]=(c[Pw>>2]|0)+1;Qw=Mw}else Qw=Kw;zri(Qw+20|0,599216)|0;Qw=c[149478]|0;Kw=Qw+4|0;Mw=c[Kw>>2]|0;do if(Mw){Pw=Mw;while(1){Hw=c[Pw+16>>2]|0;if((Hw|0)>230){Bw=c[Pw>>2]|0;if(!Bw){Rw=Pw;Sw=Pw;o=1838;break}else{Pw=Bw;continue}}if((Hw|0)>=230){Tw=Pw;o=1842;break}Hw=Pw+4|0;Bw=c[Hw>>2]|0;if(!Bw){Uw=Hw;Vw=Pw;o=1841;break}else Pw=Bw}if((o|0)==1838){c[d>>2]=Sw;Ww=Rw;Xw=Sw;break}else if((o|0)==1841){c[d>>2]=Vw;Ww=Uw;Xw=Vw;break}else if((o|0)==1842){c[d>>2]=Tw;Ww=d;Xw=Tw;break}}else{Pw=Qw+4|0;c[d>>2]=Pw;Ww=Pw;Xw=Pw}while(0);Tw=c[Ww>>2]|0;if(!Tw){Vw=xCi(32)|0;c[Vw+16>>2]=230;Uw=Vw+20|0;c[Uw+0>>2]=0;c[Uw+4>>2]=0;c[Uw+8>>2]=0;c[Vw>>2]=0;c[Vw+4>>2]=0;c[Vw+8>>2]=Xw;c[Ww>>2]=Vw;Xw=c[c[Qw>>2]>>2]|0;if(!Xw)Yw=Vw;else{c[Qw>>2]=Xw;Yw=c[Ww>>2]|0}GN(c[Kw>>2]|0,Yw);Yw=Qw+8|0;c[Yw>>2]=(c[Yw>>2]|0)+1;Zw=Vw}else Zw=Tw;zri(Zw+20|0,599232)|0;Zw=c[149478]|0;Tw=Zw+4|0;Vw=c[Tw>>2]|0;do if(Vw){Yw=Vw;while(1){Qw=c[Yw+16>>2]|0;if((Qw|0)>231){Kw=c[Yw>>2]|0;if(!Kw){_w=Yw;$w=Yw;o=1851;break}else{Yw=Kw;continue}}if((Qw|0)>=231){ax=Yw;o=1855;break}Qw=Yw+4|0;Kw=c[Qw>>2]|0;if(!Kw){bx=Qw;cx=Yw;o=1854;break}else Yw=Kw}if((o|0)==1851){c[d>>2]=$w;dx=_w;ex=$w;break}else if((o|0)==1854){c[d>>2]=cx;dx=bx;ex=cx;break}else if((o|0)==1855){c[d>>2]=ax;dx=d;ex=ax;break}}else{Yw=Zw+4|0;c[d>>2]=Yw;dx=Yw;ex=Yw}while(0);ax=c[dx>>2]|0;if(!ax){cx=xCi(32)|0;c[cx+16>>2]=231;bx=cx+20|0;c[bx+0>>2]=0;c[bx+4>>2]=0;c[bx+8>>2]=0;c[cx>>2]=0;c[cx+4>>2]=0;c[cx+8>>2]=ex;c[dx>>2]=cx;ex=c[c[Zw>>2]>>2]|0;if(!ex)fx=cx;else{c[Zw>>2]=ex;fx=c[dx>>2]|0}GN(c[Tw>>2]|0,fx);fx=Zw+8|0;c[fx>>2]=(c[fx>>2]|0)+1;gx=cx}else gx=ax;zri(gx+20|0,599248)|0;gx=c[149478]|0;ax=gx+4|0;cx=c[ax>>2]|0;do if(cx){fx=cx;while(1){Zw=c[fx+16>>2]|0;if((Zw|0)>232){Tw=c[fx>>2]|0;if(!Tw){hx=fx;ix=fx;o=1864;break}else{fx=Tw;continue}}if((Zw|0)>=232){jx=fx;o=1868;break}Zw=fx+4|0;Tw=c[Zw>>2]|0;if(!Tw){kx=Zw;lx=fx;o=1867;break}else fx=Tw}if((o|0)==1864){c[d>>2]=ix;mx=hx;nx=ix;break}else if((o|0)==1867){c[d>>2]=lx;mx=kx;nx=lx;break}else if((o|0)==1868){c[d>>2]=jx;mx=d;nx=jx;break}}else{fx=gx+4|0;c[d>>2]=fx;mx=fx;nx=fx}while(0);jx=c[mx>>2]|0;if(!jx){lx=xCi(32)|0;c[lx+16>>2]=232;kx=lx+20|0;c[kx+0>>2]=0;c[kx+4>>2]=0;c[kx+8>>2]=0;c[lx>>2]=0;c[lx+4>>2]=0;c[lx+8>>2]=nx;c[mx>>2]=lx;nx=c[c[gx>>2]>>2]|0;if(!nx)ox=lx;else{c[gx>>2]=nx;ox=c[mx>>2]|0}GN(c[ax>>2]|0,ox);ox=gx+8|0;c[ox>>2]=(c[ox>>2]|0)+1;px=lx}else px=jx;zri(px+20|0,599264)|0;px=c[149478]|0;jx=px+4|0;lx=c[jx>>2]|0;do if(lx){ox=lx;while(1){gx=c[ox+16>>2]|0;if((gx|0)>233){ax=c[ox>>2]|0;if(!ax){qx=ox;rx=ox;o=1877;break}else{ox=ax;continue}}if((gx|0)>=233){sx=ox;o=1881;break}gx=ox+4|0;ax=c[gx>>2]|0;if(!ax){tx=gx;ux=ox;o=1880;break}else ox=ax}if((o|0)==1877){c[d>>2]=rx;vx=qx;wx=rx;break}else if((o|0)==1880){c[d>>2]=ux;vx=tx;wx=ux;break}else if((o|0)==1881){c[d>>2]=sx;vx=d;wx=sx;break}}else{ox=px+4|0;c[d>>2]=ox;vx=ox;wx=ox}while(0);sx=c[vx>>2]|0;if(!sx){ux=xCi(32)|0;c[ux+16>>2]=233;tx=ux+20|0;c[tx+0>>2]=0;c[tx+4>>2]=0;c[tx+8>>2]=0;c[ux>>2]=0;c[ux+4>>2]=0;c[ux+8>>2]=wx;c[vx>>2]=ux;wx=c[c[px>>2]>>2]|0;if(!wx)xx=ux;else{c[px>>2]=wx;xx=c[vx>>2]|0}GN(c[jx>>2]|0,xx);xx=px+8|0;c[xx>>2]=(c[xx>>2]|0)+1;yx=ux}else yx=sx;zri(yx+20|0,599280)|0;yx=c[149478]|0;sx=yx+4|0;ux=c[sx>>2]|0;do if(ux){xx=ux;while(1){px=c[xx+16>>2]|0;if((px|0)>234){jx=c[xx>>2]|0;if(!jx){zx=xx;Ax=xx;o=1890;break}else{xx=jx;continue}}if((px|0)>=234){Bx=xx;o=1894;break}px=xx+4|0;jx=c[px>>2]|0;if(!jx){Cx=px;Dx=xx;o=1893;break}else xx=jx}if((o|0)==1890){c[d>>2]=Ax;Ex=zx;Fx=Ax;break}else if((o|0)==1893){c[d>>2]=Dx;Ex=Cx;Fx=Dx;break}else if((o|0)==1894){c[d>>2]=Bx;Ex=d;Fx=Bx;break}}else{xx=yx+4|0;c[d>>2]=xx;Ex=xx;Fx=xx}while(0);Bx=c[Ex>>2]|0;if(!Bx){Dx=xCi(32)|0;c[Dx+16>>2]=234;Cx=Dx+20|0;c[Cx+0>>2]=0;c[Cx+4>>2]=0;c[Cx+8>>2]=0;c[Dx>>2]=0;c[Dx+4>>2]=0;c[Dx+8>>2]=Fx;c[Ex>>2]=Dx;Fx=c[c[yx>>2]>>2]|0;if(!Fx)Gx=Dx;else{c[yx>>2]=Fx;Gx=c[Ex>>2]|0}GN(c[sx>>2]|0,Gx);Gx=yx+8|0;c[Gx>>2]=(c[Gx>>2]|0)+1;Hx=Dx}else Hx=Bx;zri(Hx+20|0,599296)|0;Hx=c[149478]|0;Bx=Hx+4|0;Dx=c[Bx>>2]|0;do if(Dx){Gx=Dx;while(1){yx=c[Gx+16>>2]|0;if((yx|0)>235){sx=c[Gx>>2]|0;if(!sx){Ix=Gx;Jx=Gx;o=1903;break}else{Gx=sx;continue}}if((yx|0)>=235){Kx=Gx;o=1907;break}yx=Gx+4|0;sx=c[yx>>2]|0;if(!sx){Lx=yx;Mx=Gx;o=1906;break}else Gx=sx}if((o|0)==1903){c[d>>2]=Jx;Nx=Ix;Ox=Jx;break}else if((o|0)==1906){c[d>>2]=Mx;Nx=Lx;Ox=Mx;break}else if((o|0)==1907){c[d>>2]=Kx;Nx=d;Ox=Kx;break}}else{Gx=Hx+4|0;c[d>>2]=Gx;Nx=Gx;Ox=Gx}while(0);Kx=c[Nx>>2]|0;if(!Kx){Mx=xCi(32)|0;c[Mx+16>>2]=235;Lx=Mx+20|0;c[Lx+0>>2]=0;c[Lx+4>>2]=0;c[Lx+8>>2]=0;c[Mx>>2]=0;c[Mx+4>>2]=0;c[Mx+8>>2]=Ox;c[Nx>>2]=Mx;Ox=c[c[Hx>>2]>>2]|0;if(!Ox)Px=Mx;else{c[Hx>>2]=Ox;Px=c[Nx>>2]|0}GN(c[Bx>>2]|0,Px);Px=Hx+8|0;c[Px>>2]=(c[Px>>2]|0)+1;Qx=Mx}else Qx=Kx;zri(Qx+20|0,599312)|0;Qx=c[149478]|0;Kx=Qx+4|0;Mx=c[Kx>>2]|0;do if(Mx){Px=Mx;while(1){Hx=c[Px+16>>2]|0;if((Hx|0)>236){Bx=c[Px>>2]|0;if(!Bx){Rx=Px;Sx=Px;o=1916;break}else{Px=Bx;continue}}if((Hx|0)>=236){Tx=Px;o=1920;break}Hx=Px+4|0;Bx=c[Hx>>2]|0;if(!Bx){Ux=Hx;Vx=Px;o=1919;break}else Px=Bx}if((o|0)==1916){c[d>>2]=Sx;Wx=Rx;Xx=Sx;break}else if((o|0)==1919){c[d>>2]=Vx;Wx=Ux;Xx=Vx;break}else if((o|0)==1920){c[d>>2]=Tx;Wx=d;Xx=Tx;break}}else{Px=Qx+4|0;c[d>>2]=Px;Wx=Px;Xx=Px}while(0);Tx=c[Wx>>2]|0;if(!Tx){Vx=xCi(32)|0;c[Vx+16>>2]=236;Ux=Vx+20|0;c[Ux+0>>2]=0;c[Ux+4>>2]=0;c[Ux+8>>2]=0;c[Vx>>2]=0;c[Vx+4>>2]=0;c[Vx+8>>2]=Xx;c[Wx>>2]=Vx;Xx=c[c[Qx>>2]>>2]|0;if(!Xx)Yx=Vx;else{c[Qx>>2]=Xx;Yx=c[Wx>>2]|0}GN(c[Kx>>2]|0,Yx);Yx=Qx+8|0;c[Yx>>2]=(c[Yx>>2]|0)+1;Zx=Vx}else Zx=Tx;zri(Zx+20|0,599328)|0;Zx=c[149478]|0;Tx=Zx+4|0;Vx=c[Tx>>2]|0;do if(Vx){Yx=Vx;while(1){Qx=c[Yx+16>>2]|0;if((Qx|0)>237){Kx=c[Yx>>2]|0;if(!Kx){_x=Yx;$x=Yx;o=1929;break}else{Yx=Kx;continue}}if((Qx|0)>=237){ay=Yx;o=1933;break}Qx=Yx+4|0;Kx=c[Qx>>2]|0;if(!Kx){by=Qx;cy=Yx;o=1932;break}else Yx=Kx}if((o|0)==1929){c[d>>2]=$x;dy=_x;ey=$x;break}else if((o|0)==1932){c[d>>2]=cy;dy=by;ey=cy;break}else if((o|0)==1933){c[d>>2]=ay;dy=d;ey=ay;break}}else{Yx=Zx+4|0;c[d>>2]=Yx;dy=Yx;ey=Yx}while(0);ay=c[dy>>2]|0;if(!ay){cy=xCi(32)|0;c[cy+16>>2]=237;by=cy+20|0;c[by+0>>2]=0;c[by+4>>2]=0;c[by+8>>2]=0;c[cy>>2]=0;c[cy+4>>2]=0;c[cy+8>>2]=ey;c[dy>>2]=cy;ey=c[c[Zx>>2]>>2]|0;if(!ey)fy=cy;else{c[Zx>>2]=ey;fy=c[dy>>2]|0}GN(c[Tx>>2]|0,fy);fy=Zx+8|0;c[fy>>2]=(c[fy>>2]|0)+1;gy=cy}else gy=ay;zri(gy+20|0,599344)|0;gy=c[149478]|0;ay=gy+4|0;cy=c[ay>>2]|0;do if(cy){fy=cy;while(1){Zx=c[fy+16>>2]|0;if((Zx|0)>238){Tx=c[fy>>2]|0;if(!Tx){hy=fy;iy=fy;o=1942;break}else{fy=Tx;continue}}if((Zx|0)>=238){jy=fy;o=1946;break}Zx=fy+4|0;Tx=c[Zx>>2]|0;if(!Tx){ky=Zx;ly=fy;o=1945;break}else fy=Tx}if((o|0)==1942){c[d>>2]=iy;my=hy;ny=iy;break}else if((o|0)==1945){c[d>>2]=ly;my=ky;ny=ly;break}else if((o|0)==1946){c[d>>2]=jy;my=d;ny=jy;break}}else{fy=gy+4|0;c[d>>2]=fy;my=fy;ny=fy}while(0);jy=c[my>>2]|0;if(!jy){ly=xCi(32)|0;c[ly+16>>2]=238;ky=ly+20|0;c[ky+0>>2]=0;c[ky+4>>2]=0;c[ky+8>>2]=0;c[ly>>2]=0;c[ly+4>>2]=0;c[ly+8>>2]=ny;c[my>>2]=ly;ny=c[c[gy>>2]>>2]|0;if(!ny)oy=ly;else{c[gy>>2]=ny;oy=c[my>>2]|0}GN(c[ay>>2]|0,oy);oy=gy+8|0;c[oy>>2]=(c[oy>>2]|0)+1;py=ly}else py=jy;zri(py+20|0,599360)|0;py=c[149478]|0;jy=py+4|0;ly=c[jy>>2]|0;do if(ly){oy=ly;while(1){gy=c[oy+16>>2]|0;if((gy|0)>239){ay=c[oy>>2]|0;if(!ay){qy=oy;ry=oy;o=1955;break}else{oy=ay;continue}}if((gy|0)>=239){sy=oy;o=1959;break}gy=oy+4|0;ay=c[gy>>2]|0;if(!ay){ty=gy;uy=oy;o=1958;break}else oy=ay}if((o|0)==1955){c[d>>2]=ry;vy=qy;wy=ry;break}else if((o|0)==1958){c[d>>2]=uy;vy=ty;wy=uy;break}else if((o|0)==1959){c[d>>2]=sy;vy=d;wy=sy;break}}else{oy=py+4|0;c[d>>2]=oy;vy=oy;wy=oy}while(0);sy=c[vy>>2]|0;if(!sy){uy=xCi(32)|0;c[uy+16>>2]=239;ty=uy+20|0;c[ty+0>>2]=0;c[ty+4>>2]=0;c[ty+8>>2]=0;c[uy>>2]=0;c[uy+4>>2]=0;c[uy+8>>2]=wy;c[vy>>2]=uy;wy=c[c[py>>2]>>2]|0;if(!wy)xy=uy;else{c[py>>2]=wy;xy=c[vy>>2]|0}GN(c[jy>>2]|0,xy);xy=py+8|0;c[xy>>2]=(c[xy>>2]|0)+1;yy=uy}else yy=sy;zri(yy+20|0,599376)|0;yy=c[149478]|0;sy=yy+4|0;uy=c[sy>>2]|0;do if(uy){xy=uy;while(1){py=c[xy+16>>2]|0;if((py|0)>240){jy=c[xy>>2]|0;if(!jy){zy=xy;Ay=xy;o=1968;break}else{xy=jy;continue}}if((py|0)>=240){By=xy;o=1972;break}py=xy+4|0;jy=c[py>>2]|0;if(!jy){Cy=py;Dy=xy;o=1971;break}else xy=jy}if((o|0)==1968){c[d>>2]=Ay;Ey=zy;Fy=Ay;break}else if((o|0)==1971){c[d>>2]=Dy;Ey=Cy;Fy=Dy;break}else if((o|0)==1972){c[d>>2]=By;Ey=d;Fy=By;break}}else{xy=yy+4|0;c[d>>2]=xy;Ey=xy;Fy=xy}while(0);By=c[Ey>>2]|0;if(!By){Dy=xCi(32)|0;c[Dy+16>>2]=240;Cy=Dy+20|0;c[Cy+0>>2]=0;c[Cy+4>>2]=0;c[Cy+8>>2]=0;c[Dy>>2]=0;c[Dy+4>>2]=0;c[Dy+8>>2]=Fy;c[Ey>>2]=Dy;Fy=c[c[yy>>2]>>2]|0;if(!Fy)Gy=Dy;else{c[yy>>2]=Fy;Gy=c[Ey>>2]|0}GN(c[sy>>2]|0,Gy);Gy=yy+8|0;c[Gy>>2]=(c[Gy>>2]|0)+1;Hy=Dy}else Hy=By;zri(Hy+20|0,599392)|0;Hy=c[149478]|0;By=Hy+4|0;Dy=c[By>>2]|0;do if(Dy){Gy=Dy;while(1){yy=c[Gy+16>>2]|0;if((yy|0)>241){sy=c[Gy>>2]|0;if(!sy){Iy=Gy;Jy=Gy;o=1981;break}else{Gy=sy;continue}}if((yy|0)>=241){Ky=Gy;o=1985;break}yy=Gy+4|0;sy=c[yy>>2]|0;if(!sy){Ly=yy;My=Gy;o=1984;break}else Gy=sy}if((o|0)==1981){c[d>>2]=Jy;Ny=Iy;Oy=Jy;break}else if((o|0)==1984){c[d>>2]=My;Ny=Ly;Oy=My;break}else if((o|0)==1985){c[d>>2]=Ky;Ny=d;Oy=Ky;break}}else{Gy=Hy+4|0;c[d>>2]=Gy;Ny=Gy;Oy=Gy}while(0);Ky=c[Ny>>2]|0;if(!Ky){My=xCi(32)|0;c[My+16>>2]=241;Ly=My+20|0;c[Ly+0>>2]=0;c[Ly+4>>2]=0;c[Ly+8>>2]=0;c[My>>2]=0;c[My+4>>2]=0;c[My+8>>2]=Oy;c[Ny>>2]=My;Oy=c[c[Hy>>2]>>2]|0;if(!Oy)Py=My;else{c[Hy>>2]=Oy;Py=c[Ny>>2]|0}GN(c[By>>2]|0,Py);Py=Hy+8|0;c[Py>>2]=(c[Py>>2]|0)+1;Qy=My}else Qy=Ky;zri(Qy+20|0,599408)|0;Qy=c[149478]|0;Ky=Qy+4|0;My=c[Ky>>2]|0;do if(My){Py=My;while(1){Hy=c[Py+16>>2]|0;if((Hy|0)>242){By=c[Py>>2]|0;if(!By){Ry=Py;Sy=Py;o=1994;break}else{Py=By;continue}}if((Hy|0)>=242){Ty=Py;o=1998;break}Hy=Py+4|0;By=c[Hy>>2]|0;if(!By){Uy=Hy;Vy=Py;o=1997;break}else Py=By}if((o|0)==1994){c[d>>2]=Sy;Wy=Ry;Xy=Sy;break}else if((o|0)==1997){c[d>>2]=Vy;Wy=Uy;Xy=Vy;break}else if((o|0)==1998){c[d>>2]=Ty;Wy=d;Xy=Ty;break}}else{Py=Qy+4|0;c[d>>2]=Py;Wy=Py;Xy=Py}while(0);Ty=c[Wy>>2]|0;if(!Ty){Vy=xCi(32)|0;c[Vy+16>>2]=242;Uy=Vy+20|0;c[Uy+0>>2]=0;c[Uy+4>>2]=0;c[Uy+8>>2]=0;c[Vy>>2]=0;c[Vy+4>>2]=0;c[Vy+8>>2]=Xy;c[Wy>>2]=Vy;Xy=c[c[Qy>>2]>>2]|0;if(!Xy)Yy=Vy;else{c[Qy>>2]=Xy;Yy=c[Wy>>2]|0}GN(c[Ky>>2]|0,Yy);Yy=Qy+8|0;c[Yy>>2]=(c[Yy>>2]|0)+1;Zy=Vy}else Zy=Ty;zri(Zy+20|0,599424)|0;Zy=c[149478]|0;Ty=Zy+4|0;Vy=c[Ty>>2]|0;do if(Vy){Yy=Vy;while(1){Qy=c[Yy+16>>2]|0;if((Qy|0)>243){Ky=c[Yy>>2]|0;if(!Ky){_y=Yy;$y=Yy;o=2007;break}else{Yy=Ky;continue}}if((Qy|0)>=243){az=Yy;o=2011;break}Qy=Yy+4|0;Ky=c[Qy>>2]|0;if(!Ky){bz=Qy;cz=Yy;o=2010;break}else Yy=Ky}if((o|0)==2007){c[d>>2]=$y;dz=_y;ez=$y;break}else if((o|0)==2010){c[d>>2]=cz;dz=bz;ez=cz;break}else if((o|0)==2011){c[d>>2]=az;dz=d;ez=az;break}}else{Yy=Zy+4|0;c[d>>2]=Yy;dz=Yy;ez=Yy}while(0);az=c[dz>>2]|0;if(!az){cz=xCi(32)|0;c[cz+16>>2]=243;bz=cz+20|0;c[bz+0>>2]=0;c[bz+4>>2]=0;c[bz+8>>2]=0;c[cz>>2]=0;c[cz+4>>2]=0;c[cz+8>>2]=ez;c[dz>>2]=cz;ez=c[c[Zy>>2]>>2]|0;if(!ez)fz=cz;else{c[Zy>>2]=ez;fz=c[dz>>2]|0}GN(c[Ty>>2]|0,fz);fz=Zy+8|0;c[fz>>2]=(c[fz>>2]|0)+1;gz=cz}else gz=az;zri(gz+20|0,599440)|0;gz=c[149478]|0;az=gz+4|0;cz=c[az>>2]|0;do if(cz){fz=cz;while(1){Zy=c[fz+16>>2]|0;if((Zy|0)>244){Ty=c[fz>>2]|0;if(!Ty){hz=fz;iz=fz;o=2020;break}else{fz=Ty;continue}}if((Zy|0)>=244){jz=fz;o=2024;break}Zy=fz+4|0;Ty=c[Zy>>2]|0;if(!Ty){kz=Zy;lz=fz;o=2023;break}else fz=Ty}if((o|0)==2020){c[d>>2]=iz;mz=hz;nz=iz;break}else if((o|0)==2023){c[d>>2]=lz;mz=kz;nz=lz;break}else if((o|0)==2024){c[d>>2]=jz;mz=d;nz=jz;break}}else{fz=gz+4|0;c[d>>2]=fz;mz=fz;nz=fz}while(0);jz=c[mz>>2]|0;if(!jz){lz=xCi(32)|0;c[lz+16>>2]=244;kz=lz+20|0;c[kz+0>>2]=0;c[kz+4>>2]=0;c[kz+8>>2]=0;c[lz>>2]=0;c[lz+4>>2]=0;c[lz+8>>2]=nz;c[mz>>2]=lz;nz=c[c[gz>>2]>>2]|0;if(!nz)oz=lz;else{c[gz>>2]=nz;oz=c[mz>>2]|0}GN(c[az>>2]|0,oz);oz=gz+8|0;c[oz>>2]=(c[oz>>2]|0)+1;pz=lz}else pz=jz;zri(pz+20|0,599456)|0;pz=c[149478]|0;jz=pz+4|0;lz=c[jz>>2]|0;do if(lz){oz=lz;while(1){gz=c[oz+16>>2]|0;if((gz|0)>245){az=c[oz>>2]|0;if(!az){qz=oz;rz=oz;o=2033;break}else{oz=az;continue}}if((gz|0)>=245){sz=oz;o=2037;break}gz=oz+4|0;az=c[gz>>2]|0;if(!az){tz=gz;uz=oz;o=2036;break}else oz=az}if((o|0)==2033){c[d>>2]=rz;vz=qz;wz=rz;break}else if((o|0)==2036){c[d>>2]=uz;vz=tz;wz=uz;break}else if((o|0)==2037){c[d>>2]=sz;vz=d;wz=sz;break}}else{oz=pz+4|0;c[d>>2]=oz;vz=oz;wz=oz}while(0);sz=c[vz>>2]|0;if(!sz){uz=xCi(32)|0;c[uz+16>>2]=245;tz=uz+20|0;c[tz+0>>2]=0;c[tz+4>>2]=0;c[tz+8>>2]=0;c[uz>>2]=0;c[uz+4>>2]=0;c[uz+8>>2]=wz;c[vz>>2]=uz;wz=c[c[pz>>2]>>2]|0;if(!wz)xz=uz;else{c[pz>>2]=wz;xz=c[vz>>2]|0}GN(c[jz>>2]|0,xz);xz=pz+8|0;c[xz>>2]=(c[xz>>2]|0)+1;yz=uz}else yz=sz;zri(yz+20|0,599472)|0;yz=c[149478]|0;sz=yz+4|0;uz=c[sz>>2]|0;do if(uz){xz=uz;while(1){pz=c[xz+16>>2]|0;if((pz|0)>246){jz=c[xz>>2]|0;if(!jz){zz=xz;Az=xz;o=2046;break}else{xz=jz;continue}}if((pz|0)>=246){Bz=xz;o=2050;break}pz=xz+4|0;jz=c[pz>>2]|0;if(!jz){Cz=pz;Dz=xz;o=2049;break}else xz=jz}if((o|0)==2046){c[d>>2]=Az;Ez=zz;Fz=Az;break}else if((o|0)==2049){c[d>>2]=Dz;Ez=Cz;Fz=Dz;break}else if((o|0)==2050){c[d>>2]=Bz;Ez=d;Fz=Bz;break}}else{xz=yz+4|0;c[d>>2]=xz;Ez=xz;Fz=xz}while(0);Bz=c[Ez>>2]|0;if(!Bz){Dz=xCi(32)|0;c[Dz+16>>2]=246;Cz=Dz+20|0;c[Cz+0>>2]=0;c[Cz+4>>2]=0;c[Cz+8>>2]=0;c[Dz>>2]=0;c[Dz+4>>2]=0;c[Dz+8>>2]=Fz;c[Ez>>2]=Dz;Fz=c[c[yz>>2]>>2]|0;if(!Fz)Gz=Dz;else{c[yz>>2]=Fz;Gz=c[Ez>>2]|0}GN(c[sz>>2]|0,Gz);Gz=yz+8|0;c[Gz>>2]=(c[Gz>>2]|0)+1;Hz=Dz}else Hz=Bz;zri(Hz+20|0,599488)|0;Hz=c[149478]|0;Bz=Hz+4|0;Dz=c[Bz>>2]|0;do if(Dz){Gz=Dz;while(1){yz=c[Gz+16>>2]|0;if((yz|0)>247){sz=c[Gz>>2]|0;if(!sz){Iz=Gz;Jz=Gz;o=2059;break}else{Gz=sz;continue}}if((yz|0)>=247){Kz=Gz;o=2063;break}yz=Gz+4|0;sz=c[yz>>2]|0;if(!sz){Lz=yz;Mz=Gz;o=2062;break}else Gz=sz}if((o|0)==2059){c[d>>2]=Jz;Nz=Iz;Oz=Jz;break}else if((o|0)==2062){c[d>>2]=Mz;Nz=Lz;Oz=Mz;break}else if((o|0)==2063){c[d>>2]=Kz;Nz=d;Oz=Kz;break}}else{Gz=Hz+4|0;c[d>>2]=Gz;Nz=Gz;Oz=Gz}while(0);Kz=c[Nz>>2]|0;if(!Kz){Mz=xCi(32)|0;c[Mz+16>>2]=247;Lz=Mz+20|0;c[Lz+0>>2]=0;c[Lz+4>>2]=0;c[Lz+8>>2]=0;c[Mz>>2]=0;c[Mz+4>>2]=0;c[Mz+8>>2]=Oz;c[Nz>>2]=Mz;Oz=c[c[Hz>>2]>>2]|0;if(!Oz)Pz=Mz;else{c[Hz>>2]=Oz;Pz=c[Nz>>2]|0}GN(c[Bz>>2]|0,Pz);Pz=Hz+8|0;c[Pz>>2]=(c[Pz>>2]|0)+1;Qz=Mz}else Qz=Kz;zri(Qz+20|0,599504)|0;Qz=c[149478]|0;Kz=Qz+4|0;Mz=c[Kz>>2]|0;do if(Mz){Pz=Mz;while(1){Hz=c[Pz+16>>2]|0;if((Hz|0)>248){Bz=c[Pz>>2]|0;if(!Bz){Rz=Pz;Sz=Pz;o=2072;break}else{Pz=Bz;continue}}if((Hz|0)>=248){Tz=Pz;o=2076;break}Hz=Pz+4|0;Bz=c[Hz>>2]|0;if(!Bz){Uz=Hz;Vz=Pz;o=2075;break}else Pz=Bz}if((o|0)==2072){c[d>>2]=Sz;Wz=Rz;Xz=Sz;break}else if((o|0)==2075){c[d>>2]=Vz;Wz=Uz;Xz=Vz;break}else if((o|0)==2076){c[d>>2]=Tz;Wz=d;Xz=Tz;break}}else{Pz=Qz+4|0;c[d>>2]=Pz;Wz=Pz;Xz=Pz}while(0);Tz=c[Wz>>2]|0;if(!Tz){Vz=xCi(32)|0;c[Vz+16>>2]=248;Uz=Vz+20|0;c[Uz+0>>2]=0;c[Uz+4>>2]=0;c[Uz+8>>2]=0;c[Vz>>2]=0;c[Vz+4>>2]=0;c[Vz+8>>2]=Xz;c[Wz>>2]=Vz;Xz=c[c[Qz>>2]>>2]|0;if(!Xz)Yz=Vz;else{c[Qz>>2]=Xz;Yz=c[Wz>>2]|0}GN(c[Kz>>2]|0,Yz);Yz=Qz+8|0;c[Yz>>2]=(c[Yz>>2]|0)+1;Zz=Vz}else Zz=Tz;zri(Zz+20|0,599520)|0;Zz=c[149478]|0;Tz=Zz+4|0;Vz=c[Tz>>2]|0;do if(Vz){Yz=Vz;while(1){Qz=c[Yz+16>>2]|0;if((Qz|0)>249){Kz=c[Yz>>2]|0;if(!Kz){_z=Yz;$z=Yz;o=2085;break}else{Yz=Kz;continue}}if((Qz|0)>=249){aA=Yz;o=2089;break}Qz=Yz+4|0;Kz=c[Qz>>2]|0;if(!Kz){bA=Qz;cA=Yz;o=2088;break}else Yz=Kz}if((o|0)==2085){c[d>>2]=$z;dA=_z;eA=$z;break}else if((o|0)==2088){c[d>>2]=cA;dA=bA;eA=cA;break}else if((o|0)==2089){c[d>>2]=aA;dA=d;eA=aA;break}}else{Yz=Zz+4|0;c[d>>2]=Yz;dA=Yz;eA=Yz}while(0);aA=c[dA>>2]|0;if(!aA){cA=xCi(32)|0;c[cA+16>>2]=249;bA=cA+20|0;c[bA+0>>2]=0;c[bA+4>>2]=0;c[bA+8>>2]=0;c[cA>>2]=0;c[cA+4>>2]=0;c[cA+8>>2]=eA;c[dA>>2]=cA;eA=c[c[Zz>>2]>>2]|0;if(!eA)fA=cA;else{c[Zz>>2]=eA;fA=c[dA>>2]|0}GN(c[Tz>>2]|0,fA);fA=Zz+8|0;c[fA>>2]=(c[fA>>2]|0)+1;gA=cA}else gA=aA;zri(gA+20|0,599536)|0;gA=c[149478]|0;aA=gA+4|0;cA=c[aA>>2]|0;do if(cA){fA=cA;while(1){Zz=c[fA+16>>2]|0;if((Zz|0)>250){Tz=c[fA>>2]|0;if(!Tz){hA=fA;iA=fA;o=2098;break}else{fA=Tz;continue}}if((Zz|0)>=250){jA=fA;o=2102;break}Zz=fA+4|0;Tz=c[Zz>>2]|0;if(!Tz){kA=Zz;lA=fA;o=2101;break}else fA=Tz}if((o|0)==2098){c[d>>2]=iA;mA=hA;nA=iA;break}else if((o|0)==2101){c[d>>2]=lA;mA=kA;nA=lA;break}else if((o|0)==2102){c[d>>2]=jA;mA=d;nA=jA;break}}else{fA=gA+4|0;c[d>>2]=fA;mA=fA;nA=fA}while(0);jA=c[mA>>2]|0;if(!jA){lA=xCi(32)|0;c[lA+16>>2]=250;kA=lA+20|0;c[kA+0>>2]=0;c[kA+4>>2]=0;c[kA+8>>2]=0;c[lA>>2]=0;c[lA+4>>2]=0;c[lA+8>>2]=nA;c[mA>>2]=lA;nA=c[c[gA>>2]>>2]|0;if(!nA)oA=lA;else{c[gA>>2]=nA;oA=c[mA>>2]|0}GN(c[aA>>2]|0,oA);oA=gA+8|0;c[oA>>2]=(c[oA>>2]|0)+1;pA=lA}else pA=jA;zri(pA+20|0,599552)|0;pA=c[149478]|0;jA=pA+4|0;lA=c[jA>>2]|0;do if(lA){oA=lA;while(1){gA=c[oA+16>>2]|0;if((gA|0)>251){aA=c[oA>>2]|0;if(!aA){qA=oA;rA=oA;o=2111;break}else{oA=aA;continue}}if((gA|0)>=251){sA=oA;o=2115;break}gA=oA+4|0;aA=c[gA>>2]|0;if(!aA){tA=gA;uA=oA;o=2114;break}else oA=aA}if((o|0)==2111){c[d>>2]=rA;vA=qA;wA=rA;break}else if((o|0)==2114){c[d>>2]=uA;vA=tA;wA=uA;break}else if((o|0)==2115){c[d>>2]=sA;vA=d;wA=sA;break}}else{oA=pA+4|0;c[d>>2]=oA;vA=oA;wA=oA}while(0);sA=c[vA>>2]|0;if(!sA){uA=xCi(32)|0;c[uA+16>>2]=251;tA=uA+20|0;c[tA+0>>2]=0;c[tA+4>>2]=0;c[tA+8>>2]=0;c[uA>>2]=0;c[uA+4>>2]=0;c[uA+8>>2]=wA;c[vA>>2]=uA;wA=c[c[pA>>2]>>2]|0;if(!wA)xA=uA;else{c[pA>>2]=wA;xA=c[vA>>2]|0}GN(c[jA>>2]|0,xA);xA=pA+8|0;c[xA>>2]=(c[xA>>2]|0)+1;yA=uA}else yA=sA;zri(yA+20|0,599568)|0;yA=c[149478]|0;sA=yA+4|0;uA=c[sA>>2]|0;do if(uA){xA=uA;while(1){pA=c[xA+16>>2]|0;if((pA|0)>252){jA=c[xA>>2]|0;if(!jA){zA=xA;AA=xA;o=2124;break}else{xA=jA;continue}}if((pA|0)>=252){BA=xA;o=2128;break}pA=xA+4|0;jA=c[pA>>2]|0;if(!jA){CA=pA;DA=xA;o=2127;break}else xA=jA}if((o|0)==2124){c[d>>2]=AA;EA=zA;FA=AA;break}else if((o|0)==2127){c[d>>2]=DA;EA=CA;FA=DA;break}else if((o|0)==2128){c[d>>2]=BA;EA=d;FA=BA;break}}else{xA=yA+4|0;c[d>>2]=xA;EA=xA;FA=xA}while(0);BA=c[EA>>2]|0;if(!BA){DA=xCi(32)|0;c[DA+16>>2]=252;CA=DA+20|0;c[CA+0>>2]=0;c[CA+4>>2]=0;c[CA+8>>2]=0;c[DA>>2]=0;c[DA+4>>2]=0;c[DA+8>>2]=FA;c[EA>>2]=DA;FA=c[c[yA>>2]>>2]|0;if(!FA)GA=DA;else{c[yA>>2]=FA;GA=c[EA>>2]|0}GN(c[sA>>2]|0,GA);GA=yA+8|0;c[GA>>2]=(c[GA>>2]|0)+1;HA=DA}else HA=BA;zri(HA+20|0,599584)|0;HA=c[149478]|0;BA=HA+4|0;DA=c[BA>>2]|0;do if(DA){GA=DA;while(1){yA=c[GA+16>>2]|0;if((yA|0)>253){sA=c[GA>>2]|0;if(!sA){IA=GA;JA=GA;o=2137;break}else{GA=sA;continue}}if((yA|0)>=253){KA=GA;o=2141;break}yA=GA+4|0;sA=c[yA>>2]|0;if(!sA){LA=yA;MA=GA;o=2140;break}else GA=sA}if((o|0)==2137){c[d>>2]=JA;NA=IA;OA=JA;break}else if((o|0)==2140){c[d>>2]=MA;NA=LA;OA=MA;break}else if((o|0)==2141){c[d>>2]=KA;NA=d;OA=KA;break}}else{GA=HA+4|0;c[d>>2]=GA;NA=GA;OA=GA}while(0);KA=c[NA>>2]|0;if(!KA){MA=xCi(32)|0;c[MA+16>>2]=253;LA=MA+20|0;c[LA+0>>2]=0;c[LA+4>>2]=0;c[LA+8>>2]=0;c[MA>>2]=0;c[MA+4>>2]=0;c[MA+8>>2]=OA;c[NA>>2]=MA;OA=c[c[HA>>2]>>2]|0;if(!OA)PA=MA;else{c[HA>>2]=OA;PA=c[NA>>2]|0}GN(c[BA>>2]|0,PA);PA=HA+8|0;c[PA>>2]=(c[PA>>2]|0)+1;QA=MA}else QA=KA;zri(QA+20|0,599600)|0;QA=c[149478]|0;KA=QA+4|0;MA=c[KA>>2]|0;do if(MA){PA=MA;while(1){HA=c[PA+16>>2]|0;if((HA|0)>254){BA=c[PA>>2]|0;if(!BA){RA=PA;SA=PA;o=2150;break}else{PA=BA;continue}}if((HA|0)>=254){TA=PA;o=2154;break}HA=PA+4|0;BA=c[HA>>2]|0;if(!BA){UA=HA;VA=PA;o=2153;break}else PA=BA}if((o|0)==2150){c[d>>2]=SA;WA=RA;XA=SA;break}else if((o|0)==2153){c[d>>2]=VA;WA=UA;XA=VA;break}else if((o|0)==2154){c[d>>2]=TA;WA=d;XA=TA;break}}else{PA=QA+4|0;c[d>>2]=PA;WA=PA;XA=PA}while(0);TA=c[WA>>2]|0;if(!TA){VA=xCi(32)|0;c[VA+16>>2]=254;UA=VA+20|0;c[UA+0>>2]=0;c[UA+4>>2]=0;c[UA+8>>2]=0;c[VA>>2]=0;c[VA+4>>2]=0;c[VA+8>>2]=XA;c[WA>>2]=VA;XA=c[c[QA>>2]>>2]|0;if(!XA)YA=VA;else{c[QA>>2]=XA;YA=c[WA>>2]|0}GN(c[KA>>2]|0,YA);YA=QA+8|0;c[YA>>2]=(c[YA>>2]|0)+1;ZA=VA}else ZA=TA;zri(ZA+20|0,599616)|0;ZA=c[149478]|0;TA=ZA+4|0;VA=c[TA>>2]|0;do if(VA){YA=VA;while(1){QA=c[YA+16>>2]|0;if((QA|0)>255){KA=c[YA>>2]|0;if(!KA){_A=YA;$A=YA;o=2163;break}else{YA=KA;continue}}if((QA|0)>=255){aB=YA;o=2167;break}QA=YA+4|0;KA=c[QA>>2]|0;if(!KA){bB=QA;cB=YA;o=2166;break}else YA=KA}if((o|0)==2163){c[d>>2]=$A;dB=_A;eB=$A;break}else if((o|0)==2166){c[d>>2]=cB;dB=bB;eB=cB;break}else if((o|0)==2167){c[d>>2]=aB;dB=d;eB=aB;break}}else{YA=ZA+4|0;c[d>>2]=YA;dB=YA;eB=YA}while(0);aB=c[dB>>2]|0;if(!aB){cB=xCi(32)|0;c[cB+16>>2]=255;bB=cB+20|0;c[bB+0>>2]=0;c[bB+4>>2]=0;c[bB+8>>2]=0;c[cB>>2]=0;c[cB+4>>2]=0;c[cB+8>>2]=eB;c[dB>>2]=cB;eB=c[c[ZA>>2]>>2]|0;if(!eB)fB=cB;else{c[ZA>>2]=eB;fB=c[dB>>2]|0}GN(c[TA>>2]|0,fB);fB=ZA+8|0;c[fB>>2]=(c[fB>>2]|0)+1;gB=cB}else gB=aB;zri(gB+20|0,599632)|0;gB=c[149478]|0;aB=gB+4|0;cB=c[aB>>2]|0;do if(cB){fB=cB;while(1){ZA=c[fB+16>>2]|0;if((ZA|0)>256){TA=c[fB>>2]|0;if(!TA){hB=fB;iB=fB;o=2176;break}else{fB=TA;continue}}if((ZA|0)>=256){jB=fB;o=2180;break}ZA=fB+4|0;TA=c[ZA>>2]|0;if(!TA){kB=ZA;lB=fB;o=2179;break}else fB=TA}if((o|0)==2176){c[d>>2]=iB;mB=hB;nB=iB;break}else if((o|0)==2179){c[d>>2]=lB;mB=kB;nB=lB;break}else if((o|0)==2180){c[d>>2]=jB;mB=d;nB=jB;break}}else{fB=gB+4|0;c[d>>2]=fB;mB=fB;nB=fB}while(0);jB=c[mB>>2]|0;if(!jB){lB=xCi(32)|0;c[lB+16>>2]=256;kB=lB+20|0;c[kB+0>>2]=0;c[kB+4>>2]=0;c[kB+8>>2]=0;c[lB>>2]=0;c[lB+4>>2]=0;c[lB+8>>2]=nB;c[mB>>2]=lB;nB=c[c[gB>>2]>>2]|0;if(!nB)oB=lB;else{c[gB>>2]=nB;oB=c[mB>>2]|0}GN(c[aB>>2]|0,oB);oB=gB+8|0;c[oB>>2]=(c[oB>>2]|0)+1;pB=lB}else pB=jB;zri(pB+20|0,599648)|0;pB=c[149478]|0;jB=pB+4|0;lB=c[jB>>2]|0;do if(lB){oB=lB;while(1){gB=c[oB+16>>2]|0;if((gB|0)>257){aB=c[oB>>2]|0;if(!aB){qB=oB;rB=oB;o=2189;break}else{oB=aB;continue}}if((gB|0)>=257){sB=oB;o=2193;break}gB=oB+4|0;aB=c[gB>>2]|0;if(!aB){tB=gB;uB=oB;o=2192;break}else oB=aB}if((o|0)==2189){c[d>>2]=rB;vB=qB;wB=rB;break}else if((o|0)==2192){c[d>>2]=uB;vB=tB;wB=uB;break}else if((o|0)==2193){c[d>>2]=sB;vB=d;wB=sB;break}}else{oB=pB+4|0;c[d>>2]=oB;vB=oB;wB=oB}while(0);sB=c[vB>>2]|0;if(!sB){uB=xCi(32)|0;c[uB+16>>2]=257;tB=uB+20|0;c[tB+0>>2]=0;c[tB+4>>2]=0;c[tB+8>>2]=0;c[uB>>2]=0;c[uB+4>>2]=0;c[uB+8>>2]=wB;c[vB>>2]=uB;wB=c[c[pB>>2]>>2]|0;if(!wB)xB=uB;else{c[pB>>2]=wB;xB=c[vB>>2]|0}GN(c[jB>>2]|0,xB);xB=pB+8|0;c[xB>>2]=(c[xB>>2]|0)+1;yB=uB}else yB=sB;zri(yB+20|0,599656)|0;yB=c[149478]|0;sB=yB+4|0;uB=c[sB>>2]|0;do if(uB){xB=uB;while(1){pB=c[xB+16>>2]|0;if((pB|0)>258){jB=c[xB>>2]|0;if(!jB){zB=xB;AB=xB;o=2202;break}else{xB=jB;continue}}if((pB|0)>=258){BB=xB;o=2206;break}pB=xB+4|0;jB=c[pB>>2]|0;if(!jB){CB=pB;DB=xB;o=2205;break}else xB=jB}if((o|0)==2202){c[d>>2]=AB;EB=zB;FB=AB;break}else if((o|0)==2205){c[d>>2]=DB;EB=CB;FB=DB;break}else if((o|0)==2206){c[d>>2]=BB;EB=d;FB=BB;break}}else{xB=yB+4|0;c[d>>2]=xB;EB=xB;FB=xB}while(0);BB=c[EB>>2]|0;if(!BB){DB=xCi(32)|0;c[DB+16>>2]=258;CB=DB+20|0;c[CB+0>>2]=0;c[CB+4>>2]=0;c[CB+8>>2]=0;c[DB>>2]=0;c[DB+4>>2]=0;c[DB+8>>2]=FB;c[EB>>2]=DB;FB=c[c[yB>>2]>>2]|0;if(!FB)GB=DB;else{c[yB>>2]=FB;GB=c[EB>>2]|0}GN(c[sB>>2]|0,GB);GB=yB+8|0;c[GB>>2]=(c[GB>>2]|0)+1;HB=DB}else HB=BB;zri(HB+20|0,599664)|0;HB=c[149478]|0;BB=HB+4|0;DB=c[BB>>2]|0;do if(DB){GB=DB;while(1){yB=c[GB+16>>2]|0;if((yB|0)>259){sB=c[GB>>2]|0;if(!sB){IB=GB;JB=GB;o=2215;break}else{GB=sB;continue}}if((yB|0)>=259){KB=GB;o=2219;break}yB=GB+4|0;sB=c[yB>>2]|0;if(!sB){LB=yB;MB=GB;o=2218;break}else GB=sB}if((o|0)==2215){c[d>>2]=JB;NB=IB;OB=JB;break}else if((o|0)==2218){c[d>>2]=MB;NB=LB;OB=MB;break}else if((o|0)==2219){c[d>>2]=KB;NB=d;OB=KB;break}}else{GB=HB+4|0;c[d>>2]=GB;NB=GB;OB=GB}while(0);KB=c[NB>>2]|0;if(!KB){MB=xCi(32)|0;c[MB+16>>2]=259;LB=MB+20|0;c[LB+0>>2]=0;c[LB+4>>2]=0;c[LB+8>>2]=0;c[MB>>2]=0;c[MB+4>>2]=0;c[MB+8>>2]=OB;c[NB>>2]=MB;OB=c[c[HB>>2]>>2]|0;if(!OB)PB=MB;else{c[HB>>2]=OB;PB=c[NB>>2]|0}GN(c[BB>>2]|0,PB);PB=HB+8|0;c[PB>>2]=(c[PB>>2]|0)+1;QB=MB}else QB=KB;zri(QB+20|0,599672)|0;QB=c[149478]|0;KB=QB+4|0;MB=c[KB>>2]|0;do if(MB){PB=MB;while(1){HB=c[PB+16>>2]|0;if((HB|0)>260){BB=c[PB>>2]|0;if(!BB){RB=PB;SB=PB;o=2228;break}else{PB=BB;continue}}if((HB|0)>=260){TB=PB;o=2232;break}HB=PB+4|0;BB=c[HB>>2]|0;if(!BB){UB=HB;VB=PB;o=2231;break}else PB=BB}if((o|0)==2228){c[d>>2]=SB;WB=RB;XB=SB;break}else if((o|0)==2231){c[d>>2]=VB;WB=UB;XB=VB;break}else if((o|0)==2232){c[d>>2]=TB;WB=d;XB=TB;break}}else{PB=QB+4|0;c[d>>2]=PB;WB=PB;XB=PB}while(0);TB=c[WB>>2]|0;if(!TB){VB=xCi(32)|0;c[VB+16>>2]=260;UB=VB+20|0;c[UB+0>>2]=0;c[UB+4>>2]=0;c[UB+8>>2]=0;c[VB>>2]=0;c[VB+4>>2]=0;c[VB+8>>2]=XB;c[WB>>2]=VB;XB=c[c[QB>>2]>>2]|0;if(!XB)YB=VB;else{c[QB>>2]=XB;YB=c[WB>>2]|0}GN(c[KB>>2]|0,YB);YB=QB+8|0;c[YB>>2]=(c[YB>>2]|0)+1;ZB=VB}else ZB=TB;zri(ZB+20|0,599680)|0;ZB=c[149478]|0;TB=ZB+4|0;VB=c[TB>>2]|0;do if(VB){YB=VB;while(1){QB=c[YB+16>>2]|0;if((QB|0)>261){KB=c[YB>>2]|0;if(!KB){_B=YB;$B=YB;o=2241;break}else{YB=KB;continue}}if((QB|0)>=261){aC=YB;o=2245;break}QB=YB+4|0;KB=c[QB>>2]|0;if(!KB){bC=QB;cC=YB;o=2244;break}else YB=KB}if((o|0)==2241){c[d>>2]=$B;dC=_B;eC=$B;break}else if((o|0)==2244){c[d>>2]=cC;dC=bC;eC=cC;break}else if((o|0)==2245){c[d>>2]=aC;dC=d;eC=aC;break}}else{YB=ZB+4|0;c[d>>2]=YB;dC=YB;eC=YB}while(0);aC=c[dC>>2]|0;if(!aC){cC=xCi(32)|0;c[cC+16>>2]=261;bC=cC+20|0;c[bC+0>>2]=0;c[bC+4>>2]=0;c[bC+8>>2]=0;c[cC>>2]=0;c[cC+4>>2]=0;c[cC+8>>2]=eC;c[dC>>2]=cC;eC=c[c[ZB>>2]>>2]|0;if(!eC)fC=cC;else{c[ZB>>2]=eC;fC=c[dC>>2]|0}GN(c[TB>>2]|0,fC);fC=ZB+8|0;c[fC>>2]=(c[fC>>2]|0)+1;gC=cC}else gC=aC;zri(gC+20|0,599688)|0;gC=c[149478]|0;aC=gC+4|0;cC=c[aC>>2]|0;do if(cC){fC=cC;while(1){ZB=c[fC+16>>2]|0;if((ZB|0)>262){TB=c[fC>>2]|0;if(!TB){hC=fC;iC=fC;o=2254;break}else{fC=TB;continue}}if((ZB|0)>=262){jC=fC;o=2258;break}ZB=fC+4|0;TB=c[ZB>>2]|0;if(!TB){kC=ZB;lC=fC;o=2257;break}else fC=TB}if((o|0)==2254){c[d>>2]=iC;mC=hC;nC=iC;break}else if((o|0)==2257){c[d>>2]=lC;mC=kC;nC=lC;break}else if((o|0)==2258){c[d>>2]=jC;mC=d;nC=jC;break}}else{fC=gC+4|0;c[d>>2]=fC;mC=fC;nC=fC}while(0);jC=c[mC>>2]|0;if(!jC){lC=xCi(32)|0;c[lC+16>>2]=262;kC=lC+20|0;c[kC+0>>2]=0;c[kC+4>>2]=0;c[kC+8>>2]=0;c[lC>>2]=0;c[lC+4>>2]=0;c[lC+8>>2]=nC;c[mC>>2]=lC;nC=c[c[gC>>2]>>2]|0;if(!nC)oC=lC;else{c[gC>>2]=nC;oC=c[mC>>2]|0}GN(c[aC>>2]|0,oC);oC=gC+8|0;c[oC>>2]=(c[oC>>2]|0)+1;pC=lC}else pC=jC;zri(pC+20|0,599696)|0;pC=c[149478]|0;jC=pC+4|0;lC=c[jC>>2]|0;do if(lC){oC=lC;while(1){gC=c[oC+16>>2]|0;if((gC|0)>263){aC=c[oC>>2]|0;if(!aC){qC=oC;rC=oC;o=2267;break}else{oC=aC;continue}}if((gC|0)>=263){sC=oC;o=2271;break}gC=oC+4|0;aC=c[gC>>2]|0;if(!aC){tC=gC;uC=oC;o=2270;break}else oC=aC}if((o|0)==2267){c[d>>2]=rC;vC=qC;wC=rC;break}else if((o|0)==2270){c[d>>2]=uC;vC=tC;wC=uC;break}else if((o|0)==2271){c[d>>2]=sC;vC=d;wC=sC;break}}else{oC=pC+4|0;c[d>>2]=oC;vC=oC;wC=oC}while(0);sC=c[vC>>2]|0;if(!sC){uC=xCi(32)|0;c[uC+16>>2]=263;tC=uC+20|0;c[tC+0>>2]=0;c[tC+4>>2]=0;c[tC+8>>2]=0;c[uC>>2]=0;c[uC+4>>2]=0;c[uC+8>>2]=wC;c[vC>>2]=uC;wC=c[c[pC>>2]>>2]|0;if(!wC)xC=uC;else{c[pC>>2]=wC;xC=c[vC>>2]|0}GN(c[jC>>2]|0,xC);xC=pC+8|0;c[xC>>2]=(c[xC>>2]|0)+1;yC=uC}else yC=sC;zri(yC+20|0,599704)|0;yC=c[149478]|0;sC=yC+4|0;uC=c[sC>>2]|0;do if(uC){xC=uC;while(1){pC=c[xC+16>>2]|0;if((pC|0)>264){jC=c[xC>>2]|0;if(!jC){zC=xC;AC=xC;o=2280;break}else{xC=jC;continue}}if((pC|0)>=264){BC=xC;o=2284;break}pC=xC+4|0;jC=c[pC>>2]|0;if(!jC){CC=pC;DC=xC;o=2283;break}else xC=jC}if((o|0)==2280){c[d>>2]=AC;EC=zC;FC=AC;break}else if((o|0)==2283){c[d>>2]=DC;EC=CC;FC=DC;break}else if((o|0)==2284){c[d>>2]=BC;EC=d;FC=BC;break}}else{xC=yC+4|0;c[d>>2]=xC;EC=xC;FC=xC}while(0);BC=c[EC>>2]|0;if(!BC){DC=xCi(32)|0;c[DC+16>>2]=264;CC=DC+20|0;c[CC+0>>2]=0;c[CC+4>>2]=0;c[CC+8>>2]=0;c[DC>>2]=0;c[DC+4>>2]=0;c[DC+8>>2]=FC;c[EC>>2]=DC;FC=c[c[yC>>2]>>2]|0;if(!FC)GC=DC;else{c[yC>>2]=FC;GC=c[EC>>2]|0}GN(c[sC>>2]|0,GC);GC=yC+8|0;c[GC>>2]=(c[GC>>2]|0)+1;HC=DC}else HC=BC;zri(HC+20|0,599712)|0;HC=c[149478]|0;BC=HC+4|0;DC=c[BC>>2]|0;do if(DC){GC=DC;while(1){yC=c[GC+16>>2]|0;if((yC|0)>265){sC=c[GC>>2]|0;if(!sC){IC=GC;JC=GC;o=2293;break}else{GC=sC;continue}}if((yC|0)>=265){KC=GC;o=2297;break}yC=GC+4|0;sC=c[yC>>2]|0;if(!sC){LC=yC;MC=GC;o=2296;break}else GC=sC}if((o|0)==2293){c[d>>2]=JC;NC=IC;OC=JC;break}else if((o|0)==2296){c[d>>2]=MC;NC=LC;OC=MC;break}else if((o|0)==2297){c[d>>2]=KC;NC=d;OC=KC;break}}else{GC=HC+4|0;c[d>>2]=GC;NC=GC;OC=GC}while(0);KC=c[NC>>2]|0;if(!KC){MC=xCi(32)|0;c[MC+16>>2]=265;LC=MC+20|0;c[LC+0>>2]=0;c[LC+4>>2]=0;c[LC+8>>2]=0;c[MC>>2]=0;c[MC+4>>2]=0;c[MC+8>>2]=OC;c[NC>>2]=MC;OC=c[c[HC>>2]>>2]|0;if(!OC)PC=MC;else{c[HC>>2]=OC;PC=c[NC>>2]|0}GN(c[BC>>2]|0,PC);PC=HC+8|0;c[PC>>2]=(c[PC>>2]|0)+1;QC=MC}else QC=KC;zri(QC+20|0,599720)|0;QC=c[149478]|0;KC=QC+4|0;MC=c[KC>>2]|0;do if(MC){PC=MC;while(1){HC=c[PC+16>>2]|0;if((HC|0)>266){BC=c[PC>>2]|0;if(!BC){RC=PC;SC=PC;o=2306;break}else{PC=BC;continue}}if((HC|0)>=266){TC=PC;o=2310;break}HC=PC+4|0;BC=c[HC>>2]|0;if(!BC){UC=HC;VC=PC;o=2309;break}else PC=BC}if((o|0)==2306){c[d>>2]=SC;WC=RC;XC=SC;break}else if((o|0)==2309){c[d>>2]=VC;WC=UC;XC=VC;break}else if((o|0)==2310){c[d>>2]=TC;WC=d;XC=TC;break}}else{PC=QC+4|0;c[d>>2]=PC;WC=PC;XC=PC}while(0);TC=c[WC>>2]|0;if(!TC){VC=xCi(32)|0;c[VC+16>>2]=266;UC=VC+20|0;c[UC+0>>2]=0;c[UC+4>>2]=0;c[UC+8>>2]=0;c[VC>>2]=0;c[VC+4>>2]=0;c[VC+8>>2]=XC;c[WC>>2]=VC;XC=c[c[QC>>2]>>2]|0;if(!XC)YC=VC;else{c[QC>>2]=XC;YC=c[WC>>2]|0}GN(c[KC>>2]|0,YC);YC=QC+8|0;c[YC>>2]=(c[YC>>2]|0)+1;ZC=VC}else ZC=TC;zri(ZC+20|0,599728)|0;ZC=c[149478]|0;TC=ZC+4|0;VC=c[TC>>2]|0;do if(VC){YC=VC;while(1){QC=c[YC+16>>2]|0;if((QC|0)>267){KC=c[YC>>2]|0;if(!KC){_C=YC;$C=YC;o=2319;break}else{YC=KC;continue}}if((QC|0)>=267){aD=YC;o=2323;break}QC=YC+4|0;KC=c[QC>>2]|0;if(!KC){bD=QC;cD=YC;o=2322;break}else YC=KC}if((o|0)==2319){c[d>>2]=$C;dD=_C;eD=$C;break}else if((o|0)==2322){c[d>>2]=cD;dD=bD;eD=cD;break}else if((o|0)==2323){c[d>>2]=aD;dD=d;eD=aD;break}}else{YC=ZC+4|0;c[d>>2]=YC;dD=YC;eD=YC}while(0);aD=c[dD>>2]|0;if(!aD){cD=xCi(32)|0;c[cD+16>>2]=267;bD=cD+20|0;c[bD+0>>2]=0;c[bD+4>>2]=0;c[bD+8>>2]=0;c[cD>>2]=0;c[cD+4>>2]=0;c[cD+8>>2]=eD;c[dD>>2]=cD;eD=c[c[ZC>>2]>>2]|0;if(!eD)fD=cD;else{c[ZC>>2]=eD;fD=c[dD>>2]|0}GN(c[TC>>2]|0,fD);fD=ZC+8|0;c[fD>>2]=(c[fD>>2]|0)+1;gD=cD}else gD=aD;zri(gD+20|0,599736)|0;gD=c[149478]|0;aD=gD+4|0;cD=c[aD>>2]|0;do if(cD){fD=cD;while(1){ZC=c[fD+16>>2]|0;if((ZC|0)>268){TC=c[fD>>2]|0;if(!TC){hD=fD;iD=fD;o=2332;break}else{fD=TC;continue}}if((ZC|0)>=268){jD=fD;o=2336;break}ZC=fD+4|0;TC=c[ZC>>2]|0;if(!TC){kD=ZC;lD=fD;o=2335;break}else fD=TC}if((o|0)==2332){c[d>>2]=iD;mD=hD;nD=iD;break}else if((o|0)==2335){c[d>>2]=lD;mD=kD;nD=lD;break}else if((o|0)==2336){c[d>>2]=jD;mD=d;nD=jD;break}}else{fD=gD+4|0;c[d>>2]=fD;mD=fD;nD=fD}while(0);jD=c[mD>>2]|0;if(!jD){lD=xCi(32)|0;c[lD+16>>2]=268;kD=lD+20|0;c[kD+0>>2]=0;c[kD+4>>2]=0;c[kD+8>>2]=0;c[lD>>2]=0;c[lD+4>>2]=0;c[lD+8>>2]=nD;c[mD>>2]=lD;nD=c[c[gD>>2]>>2]|0;if(!nD)oD=lD;else{c[gD>>2]=nD;oD=c[mD>>2]|0}GN(c[aD>>2]|0,oD);oD=gD+8|0;c[oD>>2]=(c[oD>>2]|0)+1;pD=lD}else pD=jD;zri(pD+20|0,599744)|0;pD=c[149478]|0;jD=pD+4|0;lD=c[jD>>2]|0;do if(lD){oD=lD;while(1){gD=c[oD+16>>2]|0;if((gD|0)>269){aD=c[oD>>2]|0;if(!aD){qD=oD;rD=oD;o=2345;break}else{oD=aD;continue}}if((gD|0)>=269){sD=oD;o=2349;break}gD=oD+4|0;aD=c[gD>>2]|0;if(!aD){tD=gD;uD=oD;o=2348;break}else oD=aD}if((o|0)==2345){c[d>>2]=rD;vD=qD;wD=rD;break}else if((o|0)==2348){c[d>>2]=uD;vD=tD;wD=uD;break}else if((o|0)==2349){c[d>>2]=sD;vD=d;wD=sD;break}}else{oD=pD+4|0;c[d>>2]=oD;vD=oD;wD=oD}while(0);sD=c[vD>>2]|0;if(!sD){uD=xCi(32)|0;c[uD+16>>2]=269;tD=uD+20|0;c[tD+0>>2]=0;c[tD+4>>2]=0;c[tD+8>>2]=0;c[uD>>2]=0;c[uD+4>>2]=0;c[uD+8>>2]=wD;c[vD>>2]=uD;wD=c[c[pD>>2]>>2]|0;if(!wD)xD=uD;else{c[pD>>2]=wD;xD=c[vD>>2]|0}GN(c[jD>>2]|0,xD);xD=pD+8|0;c[xD>>2]=(c[xD>>2]|0)+1;yD=uD}else yD=sD;zri(yD+20|0,599752)|0;yD=c[149478]|0;sD=yD+4|0;uD=c[sD>>2]|0;do if(uD){xD=uD;while(1){pD=c[xD+16>>2]|0;if((pD|0)>270){jD=c[xD>>2]|0;if(!jD){zD=xD;AD=xD;o=2358;break}else{xD=jD;continue}}if((pD|0)>=270){BD=xD;o=2362;break}pD=xD+4|0;jD=c[pD>>2]|0;if(!jD){CD=pD;DD=xD;o=2361;break}else xD=jD}if((o|0)==2358){c[d>>2]=AD;ED=zD;FD=AD;break}else if((o|0)==2361){c[d>>2]=DD;ED=CD;FD=DD;break}else if((o|0)==2362){c[d>>2]=BD;ED=d;FD=BD;break}}else{xD=yD+4|0;c[d>>2]=xD;ED=xD;FD=xD}while(0);BD=c[ED>>2]|0;if(!BD){DD=xCi(32)|0;c[DD+16>>2]=270;CD=DD+20|0;c[CD+0>>2]=0;c[CD+4>>2]=0;c[CD+8>>2]=0;c[DD>>2]=0;c[DD+4>>2]=0;c[DD+8>>2]=FD;c[ED>>2]=DD;FD=c[c[yD>>2]>>2]|0;if(!FD)GD=DD;else{c[yD>>2]=FD;GD=c[ED>>2]|0}GN(c[sD>>2]|0,GD);GD=yD+8|0;c[GD>>2]=(c[GD>>2]|0)+1;HD=DD}else HD=BD;zri(HD+20|0,599760)|0;HD=c[149478]|0;BD=HD+4|0;DD=c[BD>>2]|0;do if(DD){GD=DD;while(1){yD=c[GD+16>>2]|0;if((yD|0)>271){sD=c[GD>>2]|0;if(!sD){ID=GD;JD=GD;o=2371;break}else{GD=sD;continue}}if((yD|0)>=271){KD=GD;o=2375;break}yD=GD+4|0;sD=c[yD>>2]|0;if(!sD){LD=yD;MD=GD;o=2374;break}else GD=sD}if((o|0)==2371){c[d>>2]=JD;ND=ID;OD=JD;break}else if((o|0)==2374){c[d>>2]=MD;ND=LD;OD=MD;break}else if((o|0)==2375){c[d>>2]=KD;ND=d;OD=KD;break}}else{GD=HD+4|0;c[d>>2]=GD;ND=GD;OD=GD}while(0);KD=c[ND>>2]|0;if(!KD){MD=xCi(32)|0;c[MD+16>>2]=271;LD=MD+20|0;c[LD+0>>2]=0;c[LD+4>>2]=0;c[LD+8>>2]=0;c[MD>>2]=0;c[MD+4>>2]=0;c[MD+8>>2]=OD;c[ND>>2]=MD;OD=c[c[HD>>2]>>2]|0;if(!OD)PD=MD;else{c[HD>>2]=OD;PD=c[ND>>2]|0}GN(c[BD>>2]|0,PD);PD=HD+8|0;c[PD>>2]=(c[PD>>2]|0)+1;QD=MD}else QD=KD;zri(QD+20|0,597624)|0;QD=c[149478]|0;KD=QD+4|0;MD=c[KD>>2]|0;do if(MD){PD=MD;while(1){HD=c[PD+16>>2]|0;if((HD|0)>272){BD=c[PD>>2]|0;if(!BD){RD=PD;SD=PD;o=2384;break}else{PD=BD;continue}}if((HD|0)>=272){TD=PD;o=2388;break}HD=PD+4|0;BD=c[HD>>2]|0;if(!BD){UD=HD;VD=PD;o=2387;break}else PD=BD}if((o|0)==2384){c[d>>2]=SD;WD=RD;XD=SD;break}else if((o|0)==2387){c[d>>2]=VD;WD=UD;XD=VD;break}else if((o|0)==2388){c[d>>2]=TD;WD=d;XD=TD;break}}else{PD=QD+4|0;c[d>>2]=PD;WD=PD;XD=PD}while(0);TD=c[WD>>2]|0;if(!TD){VD=xCi(32)|0;c[VD+16>>2]=272;UD=VD+20|0;c[UD+0>>2]=0;c[UD+4>>2]=0;c[UD+8>>2]=0;c[VD>>2]=0;c[VD+4>>2]=0;c[VD+8>>2]=XD;c[WD>>2]=VD;XD=c[c[QD>>2]>>2]|0;if(!XD)YD=VD;else{c[QD>>2]=XD;YD=c[WD>>2]|0}GN(c[KD>>2]|0,YD);YD=QD+8|0;c[YD>>2]=(c[YD>>2]|0)+1;ZD=VD}else ZD=TD;zri(ZD+20|0,599768)|0;ZD=c[149478]|0;TD=ZD+4|0;VD=c[TD>>2]|0;do if(VD){YD=VD;while(1){QD=c[YD+16>>2]|0;if((QD|0)>273){KD=c[YD>>2]|0;if(!KD){_D=YD;$D=YD;o=2397;break}else{YD=KD;continue}}if((QD|0)>=273){aE=YD;o=2401;break}QD=YD+4|0;KD=c[QD>>2]|0;if(!KD){bE=QD;cE=YD;o=2400;break}else YD=KD}if((o|0)==2397){c[d>>2]=$D;dE=_D;eE=$D;break}else if((o|0)==2400){c[d>>2]=cE;dE=bE;eE=cE;break}else if((o|0)==2401){c[d>>2]=aE;dE=d;eE=aE;break}}else{YD=ZD+4|0;c[d>>2]=YD;dE=YD;eE=YD}while(0);aE=c[dE>>2]|0;if(!aE){cE=xCi(32)|0;c[cE+16>>2]=273;bE=cE+20|0;c[bE+0>>2]=0;c[bE+4>>2]=0;c[bE+8>>2]=0;c[cE>>2]=0;c[cE+4>>2]=0;c[cE+8>>2]=eE;c[dE>>2]=cE;eE=c[c[ZD>>2]>>2]|0;if(!eE)fE=cE;else{c[ZD>>2]=eE;fE=c[dE>>2]|0}GN(c[TD>>2]|0,fE);fE=ZD+8|0;c[fE>>2]=(c[fE>>2]|0)+1;gE=cE}else gE=aE;zri(gE+20|0,597712)|0;gE=c[149478]|0;aE=gE+4|0;cE=c[aE>>2]|0;do if(cE){fE=cE;while(1){ZD=c[fE+16>>2]|0;if((ZD|0)>274){TD=c[fE>>2]|0;if(!TD){hE=fE;iE=fE;o=2410;break}else{fE=TD;continue}}if((ZD|0)>=274){jE=fE;o=2414;break}ZD=fE+4|0;TD=c[ZD>>2]|0;if(!TD){kE=ZD;lE=fE;o=2413;break}else fE=TD}if((o|0)==2410){c[d>>2]=iE;mE=hE;nE=iE;break}else if((o|0)==2413){c[d>>2]=lE;mE=kE;nE=lE;break}else if((o|0)==2414){c[d>>2]=jE;mE=d;nE=jE;break}}else{fE=gE+4|0;c[d>>2]=fE;mE=fE;nE=fE}while(0);jE=c[mE>>2]|0;if(!jE){lE=xCi(32)|0;c[lE+16>>2]=274;kE=lE+20|0;c[kE+0>>2]=0;c[kE+4>>2]=0;c[kE+8>>2]=0;c[lE>>2]=0;c[lE+4>>2]=0;c[lE+8>>2]=nE;c[mE>>2]=lE;nE=c[c[gE>>2]>>2]|0;if(!nE)oE=lE;else{c[gE>>2]=nE;oE=c[mE>>2]|0}GN(c[aE>>2]|0,oE);oE=gE+8|0;c[oE>>2]=(c[oE>>2]|0)+1;pE=lE}else pE=jE;zri(pE+20|0,597720)|0;pE=c[149478]|0;jE=pE+4|0;lE=c[jE>>2]|0;do if(lE){oE=lE;while(1){gE=c[oE+16>>2]|0;if((gE|0)>275){aE=c[oE>>2]|0;if(!aE){qE=oE;rE=oE;o=2423;break}else{oE=aE;continue}}if((gE|0)>=275){sE=oE;o=2427;break}gE=oE+4|0;aE=c[gE>>2]|0;if(!aE){tE=gE;uE=oE;o=2426;break}else oE=aE}if((o|0)==2423){c[d>>2]=rE;vE=qE;wE=rE;break}else if((o|0)==2426){c[d>>2]=uE;vE=tE;wE=uE;break}else if((o|0)==2427){c[d>>2]=sE;vE=d;wE=sE;break}}else{oE=pE+4|0;c[d>>2]=oE;vE=oE;wE=oE}while(0);sE=c[vE>>2]|0;if(!sE){uE=xCi(32)|0;c[uE+16>>2]=275;tE=uE+20|0;c[tE+0>>2]=0;c[tE+4>>2]=0;c[tE+8>>2]=0;c[uE>>2]=0;c[uE+4>>2]=0;c[uE+8>>2]=wE;c[vE>>2]=uE;wE=c[c[pE>>2]>>2]|0;if(!wE)xE=uE;else{c[pE>>2]=wE;xE=c[vE>>2]|0}GN(c[jE>>2]|0,xE);xE=pE+8|0;c[xE>>2]=(c[xE>>2]|0)+1;yE=uE}else yE=sE;zri(yE+20|0,2531152)|0;yE=c[149478]|0;sE=yE+4|0;uE=c[sE>>2]|0;do if(uE){xE=uE;while(1){pE=c[xE+16>>2]|0;if((pE|0)>276){jE=c[xE>>2]|0;if(!jE){zE=xE;AE=xE;o=2436;break}else{xE=jE;continue}}if((pE|0)>=276){BE=xE;o=2440;break}pE=xE+4|0;jE=c[pE>>2]|0;if(!jE){CE=pE;DE=xE;o=2439;break}else xE=jE}if((o|0)==2436){c[d>>2]=AE;EE=zE;FE=AE;break}else if((o|0)==2439){c[d>>2]=DE;EE=CE;FE=DE;break}else if((o|0)==2440){c[d>>2]=BE;EE=d;FE=BE;break}}else{xE=yE+4|0;c[d>>2]=xE;EE=xE;FE=xE}while(0);BE=c[EE>>2]|0;if(!BE){DE=xCi(32)|0;c[DE+16>>2]=276;CE=DE+20|0;c[CE+0>>2]=0;c[CE+4>>2]=0;c[CE+8>>2]=0;c[DE>>2]=0;c[DE+4>>2]=0;c[DE+8>>2]=FE;c[EE>>2]=DE;FE=c[c[yE>>2]>>2]|0;if(!FE)GE=DE;else{c[yE>>2]=FE;GE=c[EE>>2]|0}GN(c[sE>>2]|0,GE);GE=yE+8|0;c[GE>>2]=(c[GE>>2]|0)+1;HE=DE}else HE=BE;zri(HE+20|0,2531144)|0;HE=c[149478]|0;BE=HE+4|0;DE=c[BE>>2]|0;do if(DE){GE=DE;while(1){yE=c[GE+16>>2]|0;if((yE|0)>274){sE=c[GE>>2]|0;if(!sE){IE=GE;JE=GE;o=2449;break}else{GE=sE;continue}}if((yE|0)>=274){KE=GE;o=2453;break}yE=GE+4|0;sE=c[yE>>2]|0;if(!sE){LE=yE;ME=GE;o=2452;break}else GE=sE}if((o|0)==2449){c[d>>2]=JE;NE=IE;OE=JE;break}else if((o|0)==2452){c[d>>2]=ME;NE=LE;OE=ME;break}else if((o|0)==2453){c[d>>2]=KE;NE=d;OE=KE;break}}else{GE=HE+4|0;c[d>>2]=GE;NE=GE;OE=GE}while(0);KE=c[NE>>2]|0;if(!KE){ME=xCi(32)|0;c[ME+16>>2]=274;LE=ME+20|0;c[LE+0>>2]=0;c[LE+4>>2]=0;c[LE+8>>2]=0;c[ME>>2]=0;c[ME+4>>2]=0;c[ME+8>>2]=OE;c[NE>>2]=ME;OE=c[c[HE>>2]>>2]|0;if(!OE)PE=ME;else{c[HE>>2]=OE;PE=c[NE>>2]|0}GN(c[BE>>2]|0,PE);PE=HE+8|0;c[PE>>2]=(c[PE>>2]|0)+1;QE=ME}else QE=KE;zri(QE+20|0,597720)|0;QE=c[149478]|0;KE=QE+4|0;ME=c[KE>>2]|0;do if(ME){PE=ME;while(1){HE=c[PE+16>>2]|0;if((HE|0)>277){BE=c[PE>>2]|0;if(!BE){RE=PE;SE=PE;o=2462;break}else{PE=BE;continue}}if((HE|0)>=277){TE=PE;o=2466;break}HE=PE+4|0;BE=c[HE>>2]|0;if(!BE){UE=HE;VE=PE;o=2465;break}else PE=BE}if((o|0)==2462){c[d>>2]=SE;WE=RE;XE=SE;break}else if((o|0)==2465){c[d>>2]=VE;WE=UE;XE=VE;break}else if((o|0)==2466){c[d>>2]=TE;WE=d;XE=TE;break}}else{PE=QE+4|0;c[d>>2]=PE;WE=PE;XE=PE}while(0);TE=c[WE>>2]|0;if(!TE){VE=xCi(32)|0;c[VE+16>>2]=277;UE=VE+20|0;c[UE+0>>2]=0;c[UE+4>>2]=0;c[UE+8>>2]=0;c[VE>>2]=0;c[VE+4>>2]=0;c[VE+8>>2]=XE;c[WE>>2]=VE;XE=c[c[QE>>2]>>2]|0;if(!XE)YE=VE;else{c[QE>>2]=XE;YE=c[WE>>2]|0}GN(c[KE>>2]|0,YE);YE=QE+8|0;c[YE>>2]=(c[YE>>2]|0)+1;ZE=VE}else ZE=TE;zri(ZE+20|0,599776)|0;ZE=c[149478]|0;TE=ZE+4|0;VE=c[TE>>2]|0;do if(VE){YE=VE;while(1){QE=c[YE+16>>2]|0;if((QE|0)>278){KE=c[YE>>2]|0;if(!KE){_E=YE;$E=YE;o=2475;break}else{YE=KE;continue}}if((QE|0)>=278){aF=YE;o=2479;break}QE=YE+4|0;KE=c[QE>>2]|0;if(!KE){bF=QE;cF=YE;o=2478;break}else YE=KE}if((o|0)==2475){c[d>>2]=$E;dF=_E;eF=$E;break}else if((o|0)==2478){c[d>>2]=cF;dF=bF;eF=cF;break}else if((o|0)==2479){c[d>>2]=aF;dF=d;eF=aF;break}}else{YE=ZE+4|0;c[d>>2]=YE;dF=YE;eF=YE}while(0);aF=c[dF>>2]|0;if(!aF){cF=xCi(32)|0;c[cF+16>>2]=278;bF=cF+20|0;c[bF+0>>2]=0;c[bF+4>>2]=0;c[bF+8>>2]=0;c[cF>>2]=0;c[cF+4>>2]=0;c[cF+8>>2]=eF;c[dF>>2]=cF;eF=c[c[ZE>>2]>>2]|0;if(!eF)fF=cF;else{c[ZE>>2]=eF;fF=c[dF>>2]|0}GN(c[TE>>2]|0,fF);fF=ZE+8|0;c[fF>>2]=(c[fF>>2]|0)+1;gF=cF}else gF=aF;zri(gF+20|0,599784)|0;gF=c[149478]|0;aF=gF+4|0;cF=c[aF>>2]|0;do if(cF){fF=cF;while(1){ZE=c[fF+16>>2]|0;if((ZE|0)>279){TE=c[fF>>2]|0;if(!TE){hF=fF;iF=fF;o=2488;break}else{fF=TE;continue}}if((ZE|0)>=279){jF=fF;o=2492;break}ZE=fF+4|0;TE=c[ZE>>2]|0;if(!TE){kF=ZE;lF=fF;o=2491;break}else fF=TE}if((o|0)==2488){c[d>>2]=iF;mF=hF;nF=iF;break}else if((o|0)==2491){c[d>>2]=lF;mF=kF;nF=lF;break}else if((o|0)==2492){c[d>>2]=jF;mF=d;nF=jF;break}}else{fF=gF+4|0;c[d>>2]=fF;mF=fF;nF=fF}while(0);jF=c[mF>>2]|0;if(!jF){lF=xCi(32)|0;c[lF+16>>2]=279;kF=lF+20|0;c[kF+0>>2]=0;c[kF+4>>2]=0;c[kF+8>>2]=0;c[lF>>2]=0;c[lF+4>>2]=0;c[lF+8>>2]=nF;c[mF>>2]=lF;nF=c[c[gF>>2]>>2]|0;if(!nF)oF=lF;else{c[gF>>2]=nF;oF=c[mF>>2]|0}GN(c[aF>>2]|0,oF);oF=gF+8|0;c[oF>>2]=(c[oF>>2]|0)+1;pF=lF}else pF=jF;zri(pF+20|0,3143904)|0;pF=c[149478]|0;jF=pF+4|0;lF=c[jF>>2]|0;do if(lF){oF=lF;while(1){gF=c[oF+16>>2]|0;if((gF|0)>280){aF=c[oF>>2]|0;if(!aF){qF=oF;rF=oF;o=2501;break}else{oF=aF;continue}}if((gF|0)>=280){sF=oF;o=2505;break}gF=oF+4|0;aF=c[gF>>2]|0;if(!aF){tF=gF;uF=oF;o=2504;break}else oF=aF}if((o|0)==2501){c[d>>2]=rF;vF=qF;wF=rF;break}else if((o|0)==2504){c[d>>2]=uF;vF=tF;wF=uF;break}else if((o|0)==2505){c[d>>2]=sF;vF=d;wF=sF;break}}else{oF=pF+4|0;c[d>>2]=oF;vF=oF;wF=oF}while(0);sF=c[vF>>2]|0;if(!sF){uF=xCi(32)|0;c[uF+16>>2]=280;tF=uF+20|0;c[tF+0>>2]=0;c[tF+4>>2]=0;c[tF+8>>2]=0;c[uF>>2]=0;c[uF+4>>2]=0;c[uF+8>>2]=wF;c[vF>>2]=uF;wF=c[c[pF>>2]>>2]|0;if(!wF)xF=uF;else{c[pF>>2]=wF;xF=c[vF>>2]|0}GN(c[jF>>2]|0,xF);xF=pF+8|0;c[xF>>2]=(c[xF>>2]|0)+1;yF=uF}else yF=sF;zri(yF+20|0,599792)|0;yF=c[149478]|0;sF=yF+4|0;uF=c[sF>>2]|0;do if(uF){xF=uF;while(1){pF=c[xF+16>>2]|0;if((pF|0)>281){jF=c[xF>>2]|0;if(!jF){zF=xF;AF=xF;o=2514;break}else{xF=jF;continue}}if((pF|0)>=281){BF=xF;o=2518;break}pF=xF+4|0;jF=c[pF>>2]|0;if(!jF){CF=pF;DF=xF;o=2517;break}else xF=jF}if((o|0)==2514){c[d>>2]=AF;EF=zF;FF=AF;break}else if((o|0)==2517){c[d>>2]=DF;EF=CF;FF=DF;break}else if((o|0)==2518){c[d>>2]=BF;EF=d;FF=BF;break}}else{xF=yF+4|0;c[d>>2]=xF;EF=xF;FF=xF}while(0);BF=c[EF>>2]|0;if(!BF){DF=xCi(32)|0;c[DF+16>>2]=281;CF=DF+20|0;c[CF+0>>2]=0;c[CF+4>>2]=0;c[CF+8>>2]=0;c[DF>>2]=0;c[DF+4>>2]=0;c[DF+8>>2]=FF;c[EF>>2]=DF;FF=c[c[yF>>2]>>2]|0;if(!FF)GF=DF;else{c[yF>>2]=FF;GF=c[EF>>2]|0}GN(c[sF>>2]|0,GF);GF=yF+8|0;c[GF>>2]=(c[GF>>2]|0)+1;HF=DF}else HF=BF;zri(HF+20|0,599800)|0;HF=c[149478]|0;BF=HF+4|0;DF=c[BF>>2]|0;do if(DF){GF=DF;while(1){yF=c[GF+16>>2]|0;if((yF|0)>282){sF=c[GF>>2]|0;if(!sF){IF=GF;JF=GF;o=2527;break}else{GF=sF;continue}}if((yF|0)>=282){KF=GF;o=2531;break}yF=GF+4|0;sF=c[yF>>2]|0;if(!sF){LF=yF;MF=GF;o=2530;break}else GF=sF}if((o|0)==2527){c[d>>2]=JF;NF=IF;OF=JF;break}else if((o|0)==2530){c[d>>2]=MF;NF=LF;OF=MF;break}else if((o|0)==2531){c[d>>2]=KF;NF=d;OF=KF;break}}else{GF=HF+4|0;c[d>>2]=GF;NF=GF;OF=GF}while(0);KF=c[NF>>2]|0;if(!KF){MF=xCi(32)|0;c[MF+16>>2]=282;LF=MF+20|0;c[LF+0>>2]=0;c[LF+4>>2]=0;c[LF+8>>2]=0;c[MF>>2]=0;c[MF+4>>2]=0;c[MF+8>>2]=OF;c[NF>>2]=MF;OF=c[c[HF>>2]>>2]|0;if(!OF)PF=MF;else{c[HF>>2]=OF;PF=c[NF>>2]|0}GN(c[BF>>2]|0,PF);PF=HF+8|0;c[PF>>2]=(c[PF>>2]|0)+1;QF=MF}else QF=KF;zri(QF+20|0,599816)|0;QF=c[149478]|0;KF=QF+4|0;MF=c[KF>>2]|0;do if(MF){PF=MF;while(1){HF=c[PF+16>>2]|0;if((HF|0)>283){BF=c[PF>>2]|0;if(!BF){RF=PF;SF=PF;o=2540;break}else{PF=BF;continue}}if((HF|0)>=283){TF=PF;o=2544;break}HF=PF+4|0;BF=c[HF>>2]|0;if(!BF){UF=HF;VF=PF;o=2543;break}else PF=BF}if((o|0)==2540){c[d>>2]=SF;WF=RF;XF=SF;break}else if((o|0)==2543){c[d>>2]=VF;WF=UF;XF=VF;break}else if((o|0)==2544){c[d>>2]=TF;WF=d;XF=TF;break}}else{PF=QF+4|0;c[d>>2]=PF;WF=PF;XF=PF}while(0);TF=c[WF>>2]|0;if(!TF){VF=xCi(32)|0;c[VF+16>>2]=283;UF=VF+20|0;c[UF+0>>2]=0;c[UF+4>>2]=0;c[UF+8>>2]=0;c[VF>>2]=0;c[VF+4>>2]=0;c[VF+8>>2]=XF;c[WF>>2]=VF;XF=c[c[QF>>2]>>2]|0;if(!XF)YF=VF;else{c[QF>>2]=XF;YF=c[WF>>2]|0}GN(c[KF>>2]|0,YF);YF=QF+8|0;c[YF>>2]=(c[YF>>2]|0)+1;ZF=VF}else ZF=TF;zri(ZF+20|0,599824)|0;ZF=c[149478]|0;TF=ZF+4|0;VF=c[TF>>2]|0;do if(VF){YF=VF;while(1){QF=c[YF+16>>2]|0;if((QF|0)>284){KF=c[YF>>2]|0;if(!KF){_F=YF;$F=YF;o=2553;break}else{YF=KF;continue}}if((QF|0)>=284){aG=YF;o=2557;break}QF=YF+4|0;KF=c[QF>>2]|0;if(!KF){bG=QF;cG=YF;o=2556;break}else YF=KF}if((o|0)==2553){c[d>>2]=$F;dG=_F;eG=$F;break}else if((o|0)==2556){c[d>>2]=cG;dG=bG;eG=cG;break}else if((o|0)==2557){c[d>>2]=aG;dG=d;eG=aG;break}}else{YF=ZF+4|0;c[d>>2]=YF;dG=YF;eG=YF}while(0);aG=c[dG>>2]|0;if(!aG){cG=xCi(32)|0;c[cG+16>>2]=284;bG=cG+20|0;c[bG+0>>2]=0;c[bG+4>>2]=0;c[bG+8>>2]=0;c[cG>>2]=0;c[cG+4>>2]=0;c[cG+8>>2]=eG;c[dG>>2]=cG;eG=c[c[ZF>>2]>>2]|0;if(!eG)fG=cG;else{c[ZF>>2]=eG;fG=c[dG>>2]|0}GN(c[TF>>2]|0,fG);fG=ZF+8|0;c[fG>>2]=(c[fG>>2]|0)+1;gG=cG}else gG=aG;zri(gG+20|0,599832)|0;gG=c[149478]|0;aG=gG+4|0;cG=c[aG>>2]|0;do if(cG){fG=cG;while(1){ZF=c[fG+16>>2]|0;if((ZF|0)>285){TF=c[fG>>2]|0;if(!TF){hG=fG;iG=fG;o=2566;break}else{fG=TF;continue}}if((ZF|0)>=285){jG=fG;o=2570;break}ZF=fG+4|0;TF=c[ZF>>2]|0;if(!TF){kG=ZF;lG=fG;o=2569;break}else fG=TF}if((o|0)==2566){c[d>>2]=iG;mG=hG;nG=iG;break}else if((o|0)==2569){c[d>>2]=lG;mG=kG;nG=lG;break}else if((o|0)==2570){c[d>>2]=jG;mG=d;nG=jG;break}}else{fG=gG+4|0;c[d>>2]=fG;mG=fG;nG=fG}while(0);jG=c[mG>>2]|0;if(!jG){lG=xCi(32)|0;c[lG+16>>2]=285;kG=lG+20|0;c[kG+0>>2]=0;c[kG+4>>2]=0;c[kG+8>>2]=0;c[lG>>2]=0;c[lG+4>>2]=0;c[lG+8>>2]=nG;c[mG>>2]=lG;nG=c[c[gG>>2]>>2]|0;if(!nG)oG=lG;else{c[gG>>2]=nG;oG=c[mG>>2]|0}GN(c[aG>>2]|0,oG);oG=gG+8|0;c[oG>>2]=(c[oG>>2]|0)+1;pG=lG}else pG=jG;zri(pG+20|0,599840)|0;pG=c[149478]|0;jG=pG+4|0;lG=c[jG>>2]|0;do if(lG){oG=lG;while(1){gG=c[oG+16>>2]|0;if((gG|0)>286){aG=c[oG>>2]|0;if(!aG){qG=oG;rG=oG;o=2579;break}else{oG=aG;continue}}if((gG|0)>=286){sG=oG;o=2583;break}gG=oG+4|0;aG=c[gG>>2]|0;if(!aG){tG=gG;uG=oG;o=2582;break}else oG=aG}if((o|0)==2579){c[d>>2]=rG;vG=qG;wG=rG;break}else if((o|0)==2582){c[d>>2]=uG;vG=tG;wG=uG;break}else if((o|0)==2583){c[d>>2]=sG;vG=d;wG=sG;break}}else{oG=pG+4|0;c[d>>2]=oG;vG=oG;wG=oG}while(0);sG=c[vG>>2]|0;if(!sG){uG=xCi(32)|0;c[uG+16>>2]=286;tG=uG+20|0;c[tG+0>>2]=0;c[tG+4>>2]=0;c[tG+8>>2]=0;c[uG>>2]=0;c[uG+4>>2]=0;c[uG+8>>2]=wG;c[vG>>2]=uG;wG=c[c[pG>>2]>>2]|0;if(!wG)xG=uG;else{c[pG>>2]=wG;xG=c[vG>>2]|0}GN(c[jG>>2]|0,xG);xG=pG+8|0;c[xG>>2]=(c[xG>>2]|0)+1;yG=uG}else yG=sG;zri(yG+20|0,599848)|0;yG=c[149478]|0;sG=yG+4|0;uG=c[sG>>2]|0;do if(uG){xG=uG;while(1){pG=c[xG+16>>2]|0;if((pG|0)>287){jG=c[xG>>2]|0;if(!jG){zG=xG;AG=xG;o=2592;break}else{xG=jG;continue}}if((pG|0)>=287){BG=xG;o=2596;break}pG=xG+4|0;jG=c[pG>>2]|0;if(!jG){CG=pG;DG=xG;o=2595;break}else xG=jG}if((o|0)==2592){c[d>>2]=AG;EG=zG;FG=AG;break}else if((o|0)==2595){c[d>>2]=DG;EG=CG;FG=DG;break}else if((o|0)==2596){c[d>>2]=BG;EG=d;FG=BG;break}}else{xG=yG+4|0;c[d>>2]=xG;EG=xG;FG=xG}while(0);BG=c[EG>>2]|0;if(!BG){DG=xCi(32)|0;c[DG+16>>2]=287;CG=DG+20|0;c[CG+0>>2]=0;c[CG+4>>2]=0;c[CG+8>>2]=0;c[DG>>2]=0;c[DG+4>>2]=0;c[DG+8>>2]=FG;c[EG>>2]=DG;FG=c[c[yG>>2]>>2]|0;if(!FG)GG=DG;else{c[yG>>2]=FG;GG=c[EG>>2]|0}GN(c[sG>>2]|0,GG);GG=yG+8|0;c[GG>>2]=(c[GG>>2]|0)+1;HG=DG}else HG=BG;zri(HG+20|0,599856)|0;HG=c[149478]|0;BG=HG+4|0;DG=c[BG>>2]|0;do if(DG){GG=DG;while(1){yG=c[GG+16>>2]|0;if((yG|0)>288){sG=c[GG>>2]|0;if(!sG){IG=GG;JG=GG;o=2605;break}else{GG=sG;continue}}if((yG|0)>=288){KG=GG;o=2609;break}yG=GG+4|0;sG=c[yG>>2]|0;if(!sG){LG=yG;MG=GG;o=2608;break}else GG=sG}if((o|0)==2605){c[d>>2]=JG;NG=IG;OG=JG;break}else if((o|0)==2608){c[d>>2]=MG;NG=LG;OG=MG;break}else if((o|0)==2609){c[d>>2]=KG;NG=d;OG=KG;break}}else{GG=HG+4|0;c[d>>2]=GG;NG=GG;OG=GG}while(0);KG=c[NG>>2]|0;if(!KG){MG=xCi(32)|0;c[MG+16>>2]=288;LG=MG+20|0;c[LG+0>>2]=0;c[LG+4>>2]=0;c[LG+8>>2]=0;c[MG>>2]=0;c[MG+4>>2]=0;c[MG+8>>2]=OG;c[NG>>2]=MG;OG=c[c[HG>>2]>>2]|0;if(!OG)PG=MG;else{c[HG>>2]=OG;PG=c[NG>>2]|0}GN(c[BG>>2]|0,PG);PG=HG+8|0;c[PG>>2]=(c[PG>>2]|0)+1;QG=MG}else QG=KG;zri(QG+20|0,599864)|0;QG=c[149478]|0;KG=QG+4|0;MG=c[KG>>2]|0;do if(MG){PG=MG;while(1){HG=c[PG+16>>2]|0;if((HG|0)>289){BG=c[PG>>2]|0;if(!BG){RG=PG;SG=PG;o=2618;break}else{PG=BG;continue}}if((HG|0)>=289){TG=PG;o=2622;break}HG=PG+4|0;BG=c[HG>>2]|0;if(!BG){UG=HG;VG=PG;o=2621;break}else PG=BG}if((o|0)==2618){c[d>>2]=SG;WG=RG;XG=SG;break}else if((o|0)==2621){c[d>>2]=VG;WG=UG;XG=VG;break}else if((o|0)==2622){c[d>>2]=TG;WG=d;XG=TG;break}}else{PG=QG+4|0;c[d>>2]=PG;WG=PG;XG=PG}while(0);TG=c[WG>>2]|0;if(!TG){VG=xCi(32)|0;c[VG+16>>2]=289;UG=VG+20|0;c[UG+0>>2]=0;c[UG+4>>2]=0;c[UG+8>>2]=0;c[VG>>2]=0;c[VG+4>>2]=0;c[VG+8>>2]=XG;c[WG>>2]=VG;XG=c[c[QG>>2]>>2]|0;if(!XG)YG=VG;else{c[QG>>2]=XG;YG=c[WG>>2]|0}GN(c[KG>>2]|0,YG);YG=QG+8|0;c[YG>>2]=(c[YG>>2]|0)+1;ZG=VG}else ZG=TG;zri(ZG+20|0,599872)|0;ZG=c[149478]|0;TG=ZG+4|0;VG=c[TG>>2]|0;do if(VG){YG=VG;while(1){QG=c[YG+16>>2]|0;if((QG|0)>290){KG=c[YG>>2]|0;if(!KG){_G=YG;$G=YG;o=2631;break}else{YG=KG;continue}}if((QG|0)>=290){aH=YG;o=2635;break}QG=YG+4|0;KG=c[QG>>2]|0;if(!KG){bH=QG;cH=YG;o=2634;break}else YG=KG}if((o|0)==2631){c[d>>2]=$G;dH=_G;eH=$G;break}else if((o|0)==2634){c[d>>2]=cH;dH=bH;eH=cH;break}else if((o|0)==2635){c[d>>2]=aH;dH=d;eH=aH;break}}else{YG=ZG+4|0;c[d>>2]=YG;dH=YG;eH=YG}while(0);aH=c[dH>>2]|0;if(!aH){cH=xCi(32)|0;c[cH+16>>2]=290;bH=cH+20|0;c[bH+0>>2]=0;c[bH+4>>2]=0;c[bH+8>>2]=0;c[cH>>2]=0;c[cH+4>>2]=0;c[cH+8>>2]=eH;c[dH>>2]=cH;eH=c[c[ZG>>2]>>2]|0;if(!eH)fH=cH;else{c[ZG>>2]=eH;fH=c[dH>>2]|0}GN(c[TG>>2]|0,fH);fH=ZG+8|0;c[fH>>2]=(c[fH>>2]|0)+1;gH=cH}else gH=aH;zri(gH+20|0,599880)|0;gH=c[149478]|0;aH=gH+4|0;cH=c[aH>>2]|0;do if(cH){fH=cH;while(1){ZG=c[fH+16>>2]|0;if((ZG|0)>291){TG=c[fH>>2]|0;if(!TG){hH=fH;iH=fH;o=2644;break}else{fH=TG;continue}}if((ZG|0)>=291){jH=fH;o=2648;break}ZG=fH+4|0;TG=c[ZG>>2]|0;if(!TG){kH=ZG;lH=fH;o=2647;break}else fH=TG}if((o|0)==2644){c[d>>2]=iH;mH=hH;nH=iH;break}else if((o|0)==2647){c[d>>2]=lH;mH=kH;nH=lH;break}else if((o|0)==2648){c[d>>2]=jH;mH=d;nH=jH;break}}else{fH=gH+4|0;c[d>>2]=fH;mH=fH;nH=fH}while(0);jH=c[mH>>2]|0;if(!jH){lH=xCi(32)|0;c[lH+16>>2]=291;kH=lH+20|0;c[kH+0>>2]=0;c[kH+4>>2]=0;c[kH+8>>2]=0;c[lH>>2]=0;c[lH+4>>2]=0;c[lH+8>>2]=nH;c[mH>>2]=lH;nH=c[c[gH>>2]>>2]|0;if(!nH)oH=lH;else{c[gH>>2]=nH;oH=c[mH>>2]|0}GN(c[aH>>2]|0,oH);oH=gH+8|0;c[oH>>2]=(c[oH>>2]|0)+1;pH=lH}else pH=jH;zri(pH+20|0,599888)|0;pH=c[149478]|0;jH=pH+4|0;lH=c[jH>>2]|0;do if(lH){oH=lH;while(1){gH=c[oH+16>>2]|0;if((gH|0)>292){aH=c[oH>>2]|0;if(!aH){qH=oH;rH=oH;o=2657;break}else{oH=aH;continue}}if((gH|0)>=292){sH=oH;o=2661;break}gH=oH+4|0;aH=c[gH>>2]|0;if(!aH){tH=gH;uH=oH;o=2660;break}else oH=aH}if((o|0)==2657){c[d>>2]=rH;vH=qH;wH=rH;break}else if((o|0)==2660){c[d>>2]=uH;vH=tH;wH=uH;break}else if((o|0)==2661){c[d>>2]=sH;vH=d;wH=sH;break}}else{oH=pH+4|0;c[d>>2]=oH;vH=oH;wH=oH}while(0);sH=c[vH>>2]|0;if(!sH){uH=xCi(32)|0;c[uH+16>>2]=292;tH=uH+20|0;c[tH+0>>2]=0;c[tH+4>>2]=0;c[tH+8>>2]=0;c[uH>>2]=0;c[uH+4>>2]=0;c[uH+8>>2]=wH;c[vH>>2]=uH;wH=c[c[pH>>2]>>2]|0;if(!wH)xH=uH;else{c[pH>>2]=wH;xH=c[vH>>2]|0}GN(c[jH>>2]|0,xH);xH=pH+8|0;c[xH>>2]=(c[xH>>2]|0)+1;yH=uH}else yH=sH;zri(yH+20|0,599896)|0;yH=c[149478]|0;sH=yH+4|0;uH=c[sH>>2]|0;do if(uH){xH=uH;while(1){pH=c[xH+16>>2]|0;if((pH|0)>293){jH=c[xH>>2]|0;if(!jH){zH=xH;AH=xH;o=2670;break}else{xH=jH;continue}}if((pH|0)>=293){BH=xH;o=2674;break}pH=xH+4|0;jH=c[pH>>2]|0;if(!jH){CH=pH;DH=xH;o=2673;break}else xH=jH}if((o|0)==2670){c[d>>2]=AH;EH=zH;FH=AH;break}else if((o|0)==2673){c[d>>2]=DH;EH=CH;FH=DH;break}else if((o|0)==2674){c[d>>2]=BH;EH=d;FH=BH;break}}else{xH=yH+4|0;c[d>>2]=xH;EH=xH;FH=xH}while(0);BH=c[EH>>2]|0;if(!BH){DH=xCi(32)|0;c[DH+16>>2]=293;CH=DH+20|0;c[CH+0>>2]=0;c[CH+4>>2]=0;c[CH+8>>2]=0;c[DH>>2]=0;c[DH+4>>2]=0;c[DH+8>>2]=FH;c[EH>>2]=DH;FH=c[c[yH>>2]>>2]|0;if(!FH)GH=DH;else{c[yH>>2]=FH;GH=c[EH>>2]|0}GN(c[sH>>2]|0,GH);GH=yH+8|0;c[GH>>2]=(c[GH>>2]|0)+1;HH=DH}else HH=BH;zri(HH+20|0,599904)|0;HH=c[149478]|0;BH=HH+4|0;DH=c[BH>>2]|0;do if(DH){GH=DH;while(1){yH=c[GH+16>>2]|0;if((yH|0)>294){sH=c[GH>>2]|0;if(!sH){IH=GH;JH=GH;o=2683;break}else{GH=sH;continue}}if((yH|0)>=294){KH=GH;o=2687;break}yH=GH+4|0;sH=c[yH>>2]|0;if(!sH){LH=yH;MH=GH;o=2686;break}else GH=sH}if((o|0)==2683){c[d>>2]=JH;NH=IH;OH=JH;break}else if((o|0)==2686){c[d>>2]=MH;NH=LH;OH=MH;break}else if((o|0)==2687){c[d>>2]=KH;NH=d;OH=KH;break}}else{GH=HH+4|0;c[d>>2]=GH;NH=GH;OH=GH}while(0);KH=c[NH>>2]|0;if(!KH){MH=xCi(32)|0;c[MH+16>>2]=294;LH=MH+20|0;c[LH+0>>2]=0;c[LH+4>>2]=0;c[LH+8>>2]=0;c[MH>>2]=0;c[MH+4>>2]=0;c[MH+8>>2]=OH;c[NH>>2]=MH;OH=c[c[HH>>2]>>2]|0;if(!OH)PH=MH;else{c[HH>>2]=OH;PH=c[NH>>2]|0}GN(c[BH>>2]|0,PH);PH=HH+8|0;c[PH>>2]=(c[PH>>2]|0)+1;QH=MH}else QH=KH;zri(QH+20|0,599912)|0;QH=c[149478]|0;KH=QH+4|0;MH=c[KH>>2]|0;do if(MH){PH=MH;while(1){HH=c[PH+16>>2]|0;if((HH|0)>295){BH=c[PH>>2]|0;if(!BH){RH=PH;SH=PH;o=2696;break}else{PH=BH;continue}}if((HH|0)>=295){TH=PH;o=2700;break}HH=PH+4|0;BH=c[HH>>2]|0;if(!BH){UH=HH;VH=PH;o=2699;break}else PH=BH}if((o|0)==2696){c[d>>2]=SH;WH=RH;XH=SH;break}else if((o|0)==2699){c[d>>2]=VH;WH=UH;XH=VH;break}else if((o|0)==2700){c[d>>2]=TH;WH=d;XH=TH;break}}else{PH=QH+4|0;c[d>>2]=PH;WH=PH;XH=PH}while(0);TH=c[WH>>2]|0;if(!TH){VH=xCi(32)|0;c[VH+16>>2]=295;UH=VH+20|0;c[UH+0>>2]=0;c[UH+4>>2]=0;c[UH+8>>2]=0;c[VH>>2]=0;c[VH+4>>2]=0;c[VH+8>>2]=XH;c[WH>>2]=VH;XH=c[c[QH>>2]>>2]|0;if(!XH)YH=VH;else{c[QH>>2]=XH;YH=c[WH>>2]|0}GN(c[KH>>2]|0,YH);YH=QH+8|0;c[YH>>2]=(c[YH>>2]|0)+1;ZH=VH}else ZH=TH;zri(ZH+20|0,599920)|0;ZH=c[149478]|0;TH=ZH+4|0;VH=c[TH>>2]|0;do if(VH){YH=VH;while(1){QH=c[YH+16>>2]|0;if((QH|0)>296){KH=c[YH>>2]|0;if(!KH){_H=YH;$H=YH;o=2709;break}else{YH=KH;continue}}if((QH|0)>=296){aI=YH;o=2713;break}QH=YH+4|0;KH=c[QH>>2]|0;if(!KH){bI=QH;cI=YH;o=2712;break}else YH=KH}if((o|0)==2709){c[d>>2]=$H;dI=_H;eI=$H;break}else if((o|0)==2712){c[d>>2]=cI;dI=bI;eI=cI;break}else if((o|0)==2713){c[d>>2]=aI;dI=d;eI=aI;break}}else{YH=ZH+4|0;c[d>>2]=YH;dI=YH;eI=YH}while(0);aI=c[dI>>2]|0;if(!aI){cI=xCi(32)|0;c[cI+16>>2]=296;bI=cI+20|0;c[bI+0>>2]=0;c[bI+4>>2]=0;c[bI+8>>2]=0;c[cI>>2]=0;c[cI+4>>2]=0;c[cI+8>>2]=eI;c[dI>>2]=cI;eI=c[c[ZH>>2]>>2]|0;if(!eI)fI=cI;else{c[ZH>>2]=eI;fI=c[dI>>2]|0}GN(c[TH>>2]|0,fI);fI=ZH+8|0;c[fI>>2]=(c[fI>>2]|0)+1;gI=cI}else gI=aI;zri(gI+20|0,599928)|0;gI=c[149478]|0;aI=gI+4|0;cI=c[aI>>2]|0;do if(cI){fI=cI;while(1){ZH=c[fI+16>>2]|0;if((ZH|0)>300){TH=c[fI>>2]|0;if(!TH){hI=fI;iI=fI;o=2722;break}else{fI=TH;continue}}if((ZH|0)>=300){jI=fI;o=2726;break}ZH=fI+4|0;TH=c[ZH>>2]|0;if(!TH){kI=ZH;lI=fI;o=2725;break}else fI=TH}if((o|0)==2722){c[d>>2]=iI;mI=hI;nI=iI;break}else if((o|0)==2725){c[d>>2]=lI;mI=kI;nI=lI;break}else if((o|0)==2726){c[d>>2]=jI;mI=d;nI=jI;break}}else{fI=gI+4|0;c[d>>2]=fI;mI=fI;nI=fI}while(0);jI=c[mI>>2]|0;if(!jI){lI=xCi(32)|0;c[lI+16>>2]=300;kI=lI+20|0;c[kI+0>>2]=0;c[kI+4>>2]=0;c[kI+8>>2]=0;c[lI>>2]=0;c[lI+4>>2]=0;c[lI+8>>2]=nI;c[mI>>2]=lI;nI=c[c[gI>>2]>>2]|0;if(!nI)oI=lI;else{c[gI>>2]=nI;oI=c[mI>>2]|0}GN(c[aI>>2]|0,oI);oI=gI+8|0;c[oI>>2]=(c[oI>>2]|0)+1;pI=lI}else pI=jI;zri(pI+20|0,599936)|0;pI=c[149478]|0;jI=pI+4|0;lI=c[jI>>2]|0;do if(lI){oI=lI;while(1){gI=c[oI+16>>2]|0;if((gI|0)>301){aI=c[oI>>2]|0;if(!aI){qI=oI;rI=oI;o=2735;break}else{oI=aI;continue}}if((gI|0)>=301){sI=oI;o=2739;break}gI=oI+4|0;aI=c[gI>>2]|0;if(!aI){tI=gI;uI=oI;o=2738;break}else oI=aI}if((o|0)==2735){c[d>>2]=rI;vI=qI;wI=rI;break}else if((o|0)==2738){c[d>>2]=uI;vI=tI;wI=uI;break}else if((o|0)==2739){c[d>>2]=sI;vI=d;wI=sI;break}}else{oI=pI+4|0;c[d>>2]=oI;vI=oI;wI=oI}while(0);sI=c[vI>>2]|0;if(!sI){uI=xCi(32)|0;c[uI+16>>2]=301;tI=uI+20|0;c[tI+0>>2]=0;c[tI+4>>2]=0;c[tI+8>>2]=0;c[uI>>2]=0;c[uI+4>>2]=0;c[uI+8>>2]=wI;c[vI>>2]=uI;wI=c[c[pI>>2]>>2]|0;if(!wI)xI=uI;else{c[pI>>2]=wI;xI=c[vI>>2]|0}GN(c[jI>>2]|0,xI);xI=pI+8|0;c[xI>>2]=(c[xI>>2]|0)+1;yI=uI}else yI=sI;zri(yI+20|0,599944)|0;yI=c[149478]|0;sI=yI+4|0;uI=c[sI>>2]|0;do if(uI){xI=uI;while(1){pI=c[xI+16>>2]|0;if((pI|0)>302){jI=c[xI>>2]|0;if(!jI){zI=xI;AI=xI;o=2748;break}else{xI=jI;continue}}if((pI|0)>=302){BI=xI;o=2752;break}pI=xI+4|0;jI=c[pI>>2]|0;if(!jI){CI=pI;DI=xI;o=2751;break}else xI=jI}if((o|0)==2748){c[d>>2]=AI;EI=zI;FI=AI;break}else if((o|0)==2751){c[d>>2]=DI;EI=CI;FI=DI;break}else if((o|0)==2752){c[d>>2]=BI;EI=d;FI=BI;break}}else{xI=yI+4|0;c[d>>2]=xI;EI=xI;FI=xI}while(0);BI=c[EI>>2]|0;if(!BI){DI=xCi(32)|0;c[DI+16>>2]=302;CI=DI+20|0;c[CI+0>>2]=0;c[CI+4>>2]=0;c[CI+8>>2]=0;c[DI>>2]=0;c[DI+4>>2]=0;c[DI+8>>2]=FI;c[EI>>2]=DI;FI=c[c[yI>>2]>>2]|0;if(!FI)GI=DI;else{c[yI>>2]=FI;GI=c[EI>>2]|0}GN(c[sI>>2]|0,GI);GI=yI+8|0;c[GI>>2]=(c[GI>>2]|0)+1;HI=DI}else HI=BI;zri(HI+20|0,599960)|0;HI=c[149478]|0;BI=HI+4|0;DI=c[BI>>2]|0;do if(DI){GI=DI;while(1){yI=c[GI+16>>2]|0;if((yI|0)>303){sI=c[GI>>2]|0;if(!sI){II=GI;JI=GI;o=2761;break}else{GI=sI;continue}}if((yI|0)>=303){KI=GI;o=2765;break}yI=GI+4|0;sI=c[yI>>2]|0;if(!sI){LI=yI;MI=GI;o=2764;break}else GI=sI}if((o|0)==2761){c[d>>2]=JI;NI=II;OI=JI;break}else if((o|0)==2764){c[d>>2]=MI;NI=LI;OI=MI;break}else if((o|0)==2765){c[d>>2]=KI;NI=d;OI=KI;break}}else{GI=HI+4|0;c[d>>2]=GI;NI=GI;OI=GI}while(0);KI=c[NI>>2]|0;if(!KI){MI=xCi(32)|0;c[MI+16>>2]=303;LI=MI+20|0;c[LI+0>>2]=0;c[LI+4>>2]=0;c[LI+8>>2]=0;c[MI>>2]=0;c[MI+4>>2]=0;c[MI+8>>2]=OI;c[NI>>2]=MI;OI=c[c[HI>>2]>>2]|0;if(!OI)PI=MI;else{c[HI>>2]=OI;PI=c[NI>>2]|0}GN(c[BI>>2]|0,PI);PI=HI+8|0;c[PI>>2]=(c[PI>>2]|0)+1;QI=MI}else QI=KI;zri(QI+20|0,599976)|0;QI=c[149478]|0;KI=QI+4|0;MI=c[KI>>2]|0;do if(MI){PI=MI;while(1){HI=c[PI+16>>2]|0;if((HI|0)>304){BI=c[PI>>2]|0;if(!BI){RI=PI;SI=PI;o=2774;break}else{PI=BI;continue}}if((HI|0)>=304){TI=PI;o=2778;break}HI=PI+4|0;BI=c[HI>>2]|0;if(!BI){UI=HI;VI=PI;o=2777;break}else PI=BI}if((o|0)==2774){c[d>>2]=SI;WI=RI;XI=SI;break}else if((o|0)==2777){c[d>>2]=VI;WI=UI;XI=VI;break}else if((o|0)==2778){c[d>>2]=TI;WI=d;XI=TI;break}}else{PI=QI+4|0;c[d>>2]=PI;WI=PI;XI=PI}while(0);TI=c[WI>>2]|0;if(!TI){VI=xCi(32)|0;c[VI+16>>2]=304;UI=VI+20|0;c[UI+0>>2]=0;c[UI+4>>2]=0;c[UI+8>>2]=0;c[VI>>2]=0;c[VI+4>>2]=0;c[VI+8>>2]=XI;c[WI>>2]=VI;XI=c[c[QI>>2]>>2]|0;if(!XI)YI=VI;else{c[QI>>2]=XI;YI=c[WI>>2]|0}GN(c[KI>>2]|0,YI);YI=QI+8|0;c[YI>>2]=(c[YI>>2]|0)+1;ZI=VI}else ZI=TI;zri(ZI+20|0,599992)|0;ZI=c[149478]|0;TI=ZI+4|0;VI=c[TI>>2]|0;do if(VI){YI=VI;while(1){QI=c[YI+16>>2]|0;if((QI|0)>305){KI=c[YI>>2]|0;if(!KI){_I=YI;$I=YI;o=2787;break}else{YI=KI;continue}}if((QI|0)>=305){aJ=YI;o=2791;break}QI=YI+4|0;KI=c[QI>>2]|0;if(!KI){bJ=QI;cJ=YI;o=2790;break}else YI=KI}if((o|0)==2787){c[d>>2]=$I;dJ=_I;eJ=$I;break}else if((o|0)==2790){c[d>>2]=cJ;dJ=bJ;eJ=cJ;break}else if((o|0)==2791){c[d>>2]=aJ;dJ=d;eJ=aJ;break}}else{YI=ZI+4|0;c[d>>2]=YI;dJ=YI;eJ=YI}while(0);aJ=c[dJ>>2]|0;if(!aJ){cJ=xCi(32)|0;c[cJ+16>>2]=305;bJ=cJ+20|0;c[bJ+0>>2]=0;c[bJ+4>>2]=0;c[bJ+8>>2]=0;c[cJ>>2]=0;c[cJ+4>>2]=0;c[cJ+8>>2]=eJ;c[dJ>>2]=cJ;eJ=c[c[ZI>>2]>>2]|0;if(!eJ)fJ=cJ;else{c[ZI>>2]=eJ;fJ=c[dJ>>2]|0}GN(c[TI>>2]|0,fJ);fJ=ZI+8|0;c[fJ>>2]=(c[fJ>>2]|0)+1;gJ=cJ}else gJ=aJ;zri(gJ+20|0,600008)|0;gJ=c[149478]|0;aJ=gJ+4|0;cJ=c[aJ>>2]|0;do if(cJ){fJ=cJ;while(1){ZI=c[fJ+16>>2]|0;if((ZI|0)>306){TI=c[fJ>>2]|0;if(!TI){hJ=fJ;iJ=fJ;o=2800;break}else{fJ=TI;continue}}if((ZI|0)>=306){jJ=fJ;o=2804;break}ZI=fJ+4|0;TI=c[ZI>>2]|0;if(!TI){kJ=ZI;lJ=fJ;o=2803;break}else fJ=TI}if((o|0)==2800){c[d>>2]=iJ;mJ=hJ;nJ=iJ;break}else if((o|0)==2803){c[d>>2]=lJ;mJ=kJ;nJ=lJ;break}else if((o|0)==2804){c[d>>2]=jJ;mJ=d;nJ=jJ;break}}else{fJ=gJ+4|0;c[d>>2]=fJ;mJ=fJ;nJ=fJ}while(0);jJ=c[mJ>>2]|0;if(!jJ){lJ=xCi(32)|0;c[lJ+16>>2]=306;kJ=lJ+20|0;c[kJ+0>>2]=0;c[kJ+4>>2]=0;c[kJ+8>>2]=0;c[lJ>>2]=0;c[lJ+4>>2]=0;c[lJ+8>>2]=nJ;c[mJ>>2]=lJ;nJ=c[c[gJ>>2]>>2]|0;if(!nJ)oJ=lJ;else{c[gJ>>2]=nJ;oJ=c[mJ>>2]|0}GN(c[aJ>>2]|0,oJ);oJ=gJ+8|0;c[oJ>>2]=(c[oJ>>2]|0)+1;pJ=lJ}else pJ=jJ;zri(pJ+20|0,597752)|0;pJ=c[149478]|0;jJ=pJ+4|0;lJ=c[jJ>>2]|0;do if(lJ){oJ=lJ;while(1){gJ=c[oJ+16>>2]|0;if((gJ|0)>307){aJ=c[oJ>>2]|0;if(!aJ){qJ=oJ;rJ=oJ;o=2813;break}else{oJ=aJ;continue}}if((gJ|0)>=307){sJ=oJ;o=2817;break}gJ=oJ+4|0;aJ=c[gJ>>2]|0;if(!aJ){tJ=gJ;uJ=oJ;o=2816;break}else oJ=aJ}if((o|0)==2813){c[d>>2]=rJ;vJ=qJ;wJ=rJ;break}else if((o|0)==2816){c[d>>2]=uJ;vJ=tJ;wJ=uJ;break}else if((o|0)==2817){c[d>>2]=sJ;vJ=d;wJ=sJ;break}}else{oJ=pJ+4|0;c[d>>2]=oJ;vJ=oJ;wJ=oJ}while(0);sJ=c[vJ>>2]|0;if(!sJ){uJ=xCi(32)|0;c[uJ+16>>2]=307;tJ=uJ+20|0;c[tJ+0>>2]=0;c[tJ+4>>2]=0;c[tJ+8>>2]=0;c[uJ>>2]=0;c[uJ+4>>2]=0;c[uJ+8>>2]=wJ;c[vJ>>2]=uJ;wJ=c[c[pJ>>2]>>2]|0;if(!wJ)xJ=uJ;else{c[pJ>>2]=wJ;xJ=c[vJ>>2]|0}GN(c[jJ>>2]|0,xJ);xJ=pJ+8|0;c[xJ>>2]=(c[xJ>>2]|0)+1;yJ=uJ}else yJ=sJ;zri(yJ+20|0,600024)|0;yJ=c[149478]|0;sJ=yJ+4|0;uJ=c[sJ>>2]|0;do if(uJ){xJ=uJ;while(1){pJ=c[xJ+16>>2]|0;if((pJ|0)>308){jJ=c[xJ>>2]|0;if(!jJ){zJ=xJ;AJ=xJ;o=2826;break}else{xJ=jJ;continue}}if((pJ|0)>=308){BJ=xJ;o=2830;break}pJ=xJ+4|0;jJ=c[pJ>>2]|0;if(!jJ){CJ=pJ;DJ=xJ;o=2829;break}else xJ=jJ}if((o|0)==2826){c[d>>2]=AJ;EJ=zJ;FJ=AJ;break}else if((o|0)==2829){c[d>>2]=DJ;EJ=CJ;FJ=DJ;break}else if((o|0)==2830){c[d>>2]=BJ;EJ=d;FJ=BJ;break}}else{xJ=yJ+4|0;c[d>>2]=xJ;EJ=xJ;FJ=xJ}while(0);BJ=c[EJ>>2]|0;if(!BJ){DJ=xCi(32)|0;c[DJ+16>>2]=308;CJ=DJ+20|0;c[CJ+0>>2]=0;c[CJ+4>>2]=0;c[CJ+8>>2]=0;c[DJ>>2]=0;c[DJ+4>>2]=0;c[DJ+8>>2]=FJ;c[EJ>>2]=DJ;FJ=c[c[yJ>>2]>>2]|0;if(!FJ)GJ=DJ;else{c[yJ>>2]=FJ;GJ=c[EJ>>2]|0}GN(c[sJ>>2]|0,GJ);GJ=yJ+8|0;c[GJ>>2]=(c[GJ>>2]|0)+1;HJ=DJ}else HJ=BJ;zri(HJ+20|0,597776)|0;HJ=c[149478]|0;BJ=HJ+4|0;DJ=c[BJ>>2]|0;do if(DJ){GJ=DJ;while(1){yJ=c[GJ+16>>2]|0;if((yJ|0)>309){sJ=c[GJ>>2]|0;if(!sJ){IJ=GJ;JJ=GJ;o=2839;break}else{GJ=sJ;continue}}if((yJ|0)>=309){KJ=GJ;o=2843;break}yJ=GJ+4|0;sJ=c[yJ>>2]|0;if(!sJ){LJ=yJ;MJ=GJ;o=2842;break}else GJ=sJ}if((o|0)==2839){c[d>>2]=JJ;NJ=IJ;OJ=JJ;break}else if((o|0)==2842){c[d>>2]=MJ;NJ=LJ;OJ=MJ;break}else if((o|0)==2843){c[d>>2]=KJ;NJ=d;OJ=KJ;break}}else{GJ=HJ+4|0;c[d>>2]=GJ;NJ=GJ;OJ=GJ}while(0);KJ=c[NJ>>2]|0;if(!KJ){MJ=xCi(32)|0;c[MJ+16>>2]=309;LJ=MJ+20|0;c[LJ+0>>2]=0;c[LJ+4>>2]=0;c[LJ+8>>2]=0;c[MJ>>2]=0;c[MJ+4>>2]=0;c[MJ+8>>2]=OJ;c[NJ>>2]=MJ;OJ=c[c[HJ>>2]>>2]|0;if(!OJ)PJ=MJ;else{c[HJ>>2]=OJ;PJ=c[NJ>>2]|0}GN(c[BJ>>2]|0,PJ);PJ=HJ+8|0;c[PJ>>2]=(c[PJ>>2]|0)+1;QJ=MJ}else QJ=KJ;zri(QJ+20|0,600040)|0;QJ=c[149478]|0;KJ=QJ+4|0;MJ=c[KJ>>2]|0;do if(MJ){PJ=MJ;while(1){HJ=c[PJ+16>>2]|0;if((HJ|0)>310){BJ=c[PJ>>2]|0;if(!BJ){RJ=PJ;SJ=PJ;o=2852;break}else{PJ=BJ;continue}}if((HJ|0)>=310){TJ=PJ;o=2856;break}HJ=PJ+4|0;BJ=c[HJ>>2]|0;if(!BJ){UJ=HJ;VJ=PJ;o=2855;break}else PJ=BJ}if((o|0)==2852){c[d>>2]=SJ;WJ=RJ;XJ=SJ;break}else if((o|0)==2855){c[d>>2]=VJ;WJ=UJ;XJ=VJ;break}else if((o|0)==2856){c[d>>2]=TJ;WJ=d;XJ=TJ;break}}else{PJ=QJ+4|0;c[d>>2]=PJ;WJ=PJ;XJ=PJ}while(0);TJ=c[WJ>>2]|0;if(!TJ){VJ=xCi(32)|0;c[VJ+16>>2]=310;UJ=VJ+20|0;c[UJ+0>>2]=0;c[UJ+4>>2]=0;c[UJ+8>>2]=0;c[VJ>>2]=0;c[VJ+4>>2]=0;c[VJ+8>>2]=XJ;c[WJ>>2]=VJ;XJ=c[c[QJ>>2]>>2]|0;if(!XJ)YJ=VJ;else{c[QJ>>2]=XJ;YJ=c[WJ>>2]|0}GN(c[KJ>>2]|0,YJ);YJ=QJ+8|0;c[YJ>>2]=(c[YJ>>2]|0)+1;ZJ=VJ}else ZJ=TJ;zri(ZJ+20|0,597800)|0;ZJ=c[149478]|0;TJ=ZJ+4|0;VJ=c[TJ>>2]|0;do if(VJ){YJ=VJ;while(1){QJ=c[YJ+16>>2]|0;if((QJ|0)>311){KJ=c[YJ>>2]|0;if(!KJ){_J=YJ;$J=YJ;o=2865;break}else{YJ=KJ;continue}}if((QJ|0)>=311){aK=YJ;o=2869;break}QJ=YJ+4|0;KJ=c[QJ>>2]|0;if(!KJ){bK=QJ;cK=YJ;o=2868;break}else YJ=KJ}if((o|0)==2865){c[d>>2]=$J;dK=_J;eK=$J;break}else if((o|0)==2868){c[d>>2]=cK;dK=bK;eK=cK;break}else if((o|0)==2869){c[d>>2]=aK;dK=d;eK=aK;break}}else{YJ=ZJ+4|0;c[d>>2]=YJ;dK=YJ;eK=YJ}while(0);aK=c[dK>>2]|0;if(!aK){cK=xCi(32)|0;c[cK+16>>2]=311;bK=cK+20|0;c[bK+0>>2]=0;c[bK+4>>2]=0;c[bK+8>>2]=0;c[cK>>2]=0;c[cK+4>>2]=0;c[cK+8>>2]=eK;c[dK>>2]=cK;eK=c[c[ZJ>>2]>>2]|0;if(!eK)fK=cK;else{c[ZJ>>2]=eK;fK=c[dK>>2]|0}GN(c[TJ>>2]|0,fK);fK=ZJ+8|0;c[fK>>2]=(c[fK>>2]|0)+1;gK=cK}else gK=aK;zri(gK+20|0,600056)|0;gK=c[149478]|0;aK=gK+4|0;cK=c[aK>>2]|0;do if(cK){fK=cK;while(1){ZJ=c[fK+16>>2]|0;if((ZJ|0)>312){TJ=c[fK>>2]|0;if(!TJ){hK=fK;iK=fK;o=2878;break}else{fK=TJ;continue}}if((ZJ|0)>=312){jK=fK;o=2882;break}ZJ=fK+4|0;TJ=c[ZJ>>2]|0;if(!TJ){kK=ZJ;lK=fK;o=2881;break}else fK=TJ}if((o|0)==2878){c[d>>2]=iK;mK=hK;nK=iK;break}else if((o|0)==2881){c[d>>2]=lK;mK=kK;nK=lK;break}else if((o|0)==2882){c[d>>2]=jK;mK=d;nK=jK;break}}else{fK=gK+4|0;c[d>>2]=fK;mK=fK;nK=fK}while(0);jK=c[mK>>2]|0;if(!jK){lK=xCi(32)|0;c[lK+16>>2]=312;kK=lK+20|0;c[kK+0>>2]=0;c[kK+4>>2]=0;c[kK+8>>2]=0;c[lK>>2]=0;c[lK+4>>2]=0;c[lK+8>>2]=nK;c[mK>>2]=lK;nK=c[c[gK>>2]>>2]|0;if(!nK)oK=lK;else{c[gK>>2]=nK;oK=c[mK>>2]|0}GN(c[aK>>2]|0,oK);oK=gK+8|0;c[oK>>2]=(c[oK>>2]|0)+1;pK=lK}else pK=jK;zri(pK+20|0,600072)|0;pK=c[149478]|0;jK=pK+4|0;lK=c[jK>>2]|0;do if(lK){oK=lK;while(1){gK=c[oK+16>>2]|0;if((gK|0)>313){aK=c[oK>>2]|0;if(!aK){qK=oK;rK=oK;o=2891;break}else{oK=aK;continue}}if((gK|0)>=313){sK=oK;o=2895;break}gK=oK+4|0;aK=c[gK>>2]|0;if(!aK){tK=gK;uK=oK;o=2894;break}else oK=aK}if((o|0)==2891){c[d>>2]=rK;vK=qK;wK=rK;break}else if((o|0)==2894){c[d>>2]=uK;vK=tK;wK=uK;break}else if((o|0)==2895){c[d>>2]=sK;vK=d;wK=sK;break}}else{oK=pK+4|0;c[d>>2]=oK;vK=oK;wK=oK}while(0);sK=c[vK>>2]|0;if(!sK){uK=xCi(32)|0;c[uK+16>>2]=313;tK=uK+20|0;c[tK+0>>2]=0;c[tK+4>>2]=0;c[tK+8>>2]=0;c[uK>>2]=0;c[uK+4>>2]=0;c[uK+8>>2]=wK;c[vK>>2]=uK;wK=c[c[pK>>2]>>2]|0;if(!wK)xK=uK;else{c[pK>>2]=wK;xK=c[vK>>2]|0}GN(c[jK>>2]|0,xK);xK=pK+8|0;c[xK>>2]=(c[xK>>2]|0)+1;yK=uK}else yK=sK;zri(yK+20|0,600088)|0;yK=c[149478]|0;sK=yK+4|0;uK=c[sK>>2]|0;do if(uK){xK=uK;while(1){pK=c[xK+16>>2]|0;if((pK|0)>314){jK=c[xK>>2]|0;if(!jK){zK=xK;AK=xK;o=2904;break}else{xK=jK;continue}}if((pK|0)>=314){BK=xK;o=2908;break}pK=xK+4|0;jK=c[pK>>2]|0;if(!jK){CK=pK;DK=xK;o=2907;break}else xK=jK}if((o|0)==2904){c[d>>2]=AK;EK=zK;FK=AK;break}else if((o|0)==2907){c[d>>2]=DK;EK=CK;FK=DK;break}else if((o|0)==2908){c[d>>2]=BK;EK=d;FK=BK;break}}else{xK=yK+4|0;c[d>>2]=xK;EK=xK;FK=xK}while(0);BK=c[EK>>2]|0;if(!BK){DK=xCi(32)|0;c[DK+16>>2]=314;CK=DK+20|0;c[CK+0>>2]=0;c[CK+4>>2]=0;c[CK+8>>2]=0;c[DK>>2]=0;c[DK+4>>2]=0;c[DK+8>>2]=FK;c[EK>>2]=DK;FK=c[c[yK>>2]>>2]|0;if(!FK)GK=DK;else{c[yK>>2]=FK;GK=c[EK>>2]|0}GN(c[sK>>2]|0,GK);GK=yK+8|0;c[GK>>2]=(c[GK>>2]|0)+1;HK=DK}else HK=BK;zri(HK+20|0,600096)|0;HK=c[149478]|0;BK=HK+4|0;DK=c[BK>>2]|0;do if(DK){GK=DK;while(1){yK=c[GK+16>>2]|0;if((yK|0)>315){sK=c[GK>>2]|0;if(!sK){IK=GK;JK=GK;o=2917;break}else{GK=sK;continue}}if((yK|0)>=315){KK=GK;o=2921;break}yK=GK+4|0;sK=c[yK>>2]|0;if(!sK){LK=yK;MK=GK;o=2920;break}else GK=sK}if((o|0)==2917){c[d>>2]=JK;NK=IK;OK=JK;break}else if((o|0)==2920){c[d>>2]=MK;NK=LK;OK=MK;break}else if((o|0)==2921){c[d>>2]=KK;NK=d;OK=KK;break}}else{GK=HK+4|0;c[d>>2]=GK;NK=GK;OK=GK}while(0);KK=c[NK>>2]|0;if(!KK){MK=xCi(32)|0;c[MK+16>>2]=315;LK=MK+20|0;c[LK+0>>2]=0;c[LK+4>>2]=0;c[LK+8>>2]=0;c[MK>>2]=0;c[MK+4>>2]=0;c[MK+8>>2]=OK;c[NK>>2]=MK;OK=c[c[HK>>2]>>2]|0;if(!OK)PK=MK;else{c[HK>>2]=OK;PK=c[NK>>2]|0}GN(c[BK>>2]|0,PK);PK=HK+8|0;c[PK>>2]=(c[PK>>2]|0)+1;QK=MK}else QK=KK;zri(QK+20|0,600104)|0;QK=c[149478]|0;KK=QK+4|0;MK=c[KK>>2]|0;do if(MK){PK=MK;while(1){HK=c[PK+16>>2]|0;if((HK|0)>316){BK=c[PK>>2]|0;if(!BK){RK=PK;SK=PK;o=2930;break}else{PK=BK;continue}}if((HK|0)>=316){TK=PK;o=2934;break}HK=PK+4|0;BK=c[HK>>2]|0;if(!BK){UK=HK;VK=PK;o=2933;break}else PK=BK}if((o|0)==2930){c[d>>2]=SK;WK=RK;XK=SK;break}else if((o|0)==2933){c[d>>2]=VK;WK=UK;XK=VK;break}else if((o|0)==2934){c[d>>2]=TK;WK=d;XK=TK;break}}else{PK=QK+4|0;c[d>>2]=PK;WK=PK;XK=PK}while(0);TK=c[WK>>2]|0;if(!TK){VK=xCi(32)|0;c[VK+16>>2]=316;UK=VK+20|0;c[UK+0>>2]=0;c[UK+4>>2]=0;c[UK+8>>2]=0;c[VK>>2]=0;c[VK+4>>2]=0;c[VK+8>>2]=XK;c[WK>>2]=VK;XK=c[c[QK>>2]>>2]|0;if(!XK)YK=VK;else{c[QK>>2]=XK;YK=c[WK>>2]|0}GN(c[KK>>2]|0,YK);YK=QK+8|0;c[YK>>2]=(c[YK>>2]|0)+1;ZK=VK}else ZK=TK;zri(ZK+20|0,600112)|0;ZK=c[149478]|0;TK=ZK+4|0;VK=c[TK>>2]|0;do if(VK){YK=VK;while(1){QK=c[YK+16>>2]|0;if((QK|0)>317){KK=c[YK>>2]|0;if(!KK){_K=YK;$K=YK;o=2943;break}else{YK=KK;continue}}if((QK|0)>=317){aL=YK;o=2947;break}QK=YK+4|0;KK=c[QK>>2]|0;if(!KK){bL=QK;cL=YK;o=2946;break}else YK=KK}if((o|0)==2943){c[d>>2]=$K;dL=_K;eL=$K;break}else if((o|0)==2946){c[d>>2]=cL;dL=bL;eL=cL;break}else if((o|0)==2947){c[d>>2]=aL;dL=d;eL=aL;break}}else{YK=ZK+4|0;c[d>>2]=YK;dL=YK;eL=YK}while(0);aL=c[dL>>2]|0;if(!aL){cL=xCi(32)|0;c[cL+16>>2]=317;bL=cL+20|0;c[bL+0>>2]=0;c[bL+4>>2]=0;c[bL+8>>2]=0;c[cL>>2]=0;c[cL+4>>2]=0;c[cL+8>>2]=eL;c[dL>>2]=cL;eL=c[c[ZK>>2]>>2]|0;if(!eL)fL=cL;else{c[ZK>>2]=eL;fL=c[dL>>2]|0}GN(c[TK>>2]|0,fL);fL=ZK+8|0;c[fL>>2]=(c[fL>>2]|0)+1;gL=cL}else gL=aL;zri(gL+20|0,600128)|0;gL=c[149478]|0;aL=gL+4|0;cL=c[aL>>2]|0;do if(cL){fL=cL;while(1){ZK=c[fL+16>>2]|0;if((ZK|0)>318){TK=c[fL>>2]|0;if(!TK){hL=fL;iL=fL;o=2956;break}else{fL=TK;continue}}if((ZK|0)>=318){jL=fL;o=2960;break}ZK=fL+4|0;TK=c[ZK>>2]|0;if(!TK){kL=ZK;lL=fL;o=2959;break}else fL=TK}if((o|0)==2956){c[d>>2]=iL;mL=hL;nL=iL;break}else if((o|0)==2959){c[d>>2]=lL;mL=kL;nL=lL;break}else if((o|0)==2960){c[d>>2]=jL;mL=d;nL=jL;break}}else{fL=gL+4|0;c[d>>2]=fL;mL=fL;nL=fL}while(0);jL=c[mL>>2]|0;if(!jL){lL=xCi(32)|0;c[lL+16>>2]=318;kL=lL+20|0;c[kL+0>>2]=0;c[kL+4>>2]=0;c[kL+8>>2]=0;c[lL>>2]=0;c[lL+4>>2]=0;c[lL+8>>2]=nL;c[mL>>2]=lL;nL=c[c[gL>>2]>>2]|0;if(!nL)oL=lL;else{c[gL>>2]=nL;oL=c[mL>>2]|0}GN(c[aL>>2]|0,oL);oL=gL+8|0;c[oL>>2]=(c[oL>>2]|0)+1;pL=lL}else pL=jL;zri(pL+20|0,600136)|0;pL=c[149478]|0;jL=pL+4|0;lL=c[jL>>2]|0;do if(lL){oL=lL;while(1){gL=c[oL+16>>2]|0;if((gL|0)>319){aL=c[oL>>2]|0;if(!aL){qL=oL;rL=oL;o=2969;break}else{oL=aL;continue}}if((gL|0)>=319){sL=oL;o=2973;break}gL=oL+4|0;aL=c[gL>>2]|0;if(!aL){tL=gL;uL=oL;o=2972;break}else oL=aL}if((o|0)==2969){c[d>>2]=rL;vL=qL;wL=rL;break}else if((o|0)==2972){c[d>>2]=uL;vL=tL;wL=uL;break}else if((o|0)==2973){c[d>>2]=sL;vL=d;wL=sL;break}}else{oL=pL+4|0;c[d>>2]=oL;vL=oL;wL=oL}while(0);sL=c[vL>>2]|0;if(!sL){uL=xCi(32)|0;c[uL+16>>2]=319;tL=uL+20|0;c[tL+0>>2]=0;c[tL+4>>2]=0;c[tL+8>>2]=0;c[uL>>2]=0;c[uL+4>>2]=0;c[uL+8>>2]=wL;c[vL>>2]=uL;wL=c[c[pL>>2]>>2]|0;if(!wL)xL=uL;else{c[pL>>2]=wL;xL=c[vL>>2]|0}GN(c[jL>>2]|0,xL);xL=pL+8|0;c[xL>>2]=(c[xL>>2]|0)+1;yL=uL}else yL=sL;zri(yL+20|0,600144)|0;yL=c[149478]|0;sL=yL+4|0;uL=c[sL>>2]|0;do if(uL){xL=uL;while(1){pL=c[xL+16>>2]|0;if((pL|0)>320){jL=c[xL>>2]|0;if(!jL){zL=xL;AL=xL;o=2982;break}else{xL=jL;continue}}if((pL|0)>=320){BL=xL;o=2986;break}pL=xL+4|0;jL=c[pL>>2]|0;if(!jL){CL=pL;DL=xL;o=2985;break}else xL=jL}if((o|0)==2982){c[d>>2]=AL;EL=zL;FL=AL;break}else if((o|0)==2985){c[d>>2]=DL;EL=CL;FL=DL;break}else if((o|0)==2986){c[d>>2]=BL;EL=d;FL=BL;break}}else{xL=yL+4|0;c[d>>2]=xL;EL=xL;FL=xL}while(0);BL=c[EL>>2]|0;if(!BL){DL=xCi(32)|0;c[DL+16>>2]=320;CL=DL+20|0;c[CL+0>>2]=0;c[CL+4>>2]=0;c[CL+8>>2]=0;c[DL>>2]=0;c[DL+4>>2]=0;c[DL+8>>2]=FL;c[EL>>2]=DL;FL=c[c[yL>>2]>>2]|0;if(!FL)GL=DL;else{c[yL>>2]=FL;GL=c[EL>>2]|0}GN(c[sL>>2]|0,GL);GL=yL+8|0;c[GL>>2]=(c[GL>>2]|0)+1;HL=DL}else HL=BL;zri(HL+20|0,600152)|0;HL=c[149478]|0;BL=HL+4|0;DL=c[BL>>2]|0;do if(DL){GL=DL;while(1){yL=c[GL+16>>2]|0;if((yL|0)>321){sL=c[GL>>2]|0;if(!sL){IL=GL;JL=GL;o=2995;break}else{GL=sL;continue}}if((yL|0)>=321){KL=GL;o=2999;break}yL=GL+4|0;sL=c[yL>>2]|0;if(!sL){LL=yL;ML=GL;o=2998;break}else GL=sL}if((o|0)==2995){c[d>>2]=JL;NL=IL;OL=JL;break}else if((o|0)==2998){c[d>>2]=ML;NL=LL;OL=ML;break}else if((o|0)==2999){c[d>>2]=KL;NL=d;OL=KL;break}}else{GL=HL+4|0;c[d>>2]=GL;NL=GL;OL=GL}while(0);KL=c[NL>>2]|0;if(!KL){ML=xCi(32)|0;c[ML+16>>2]=321;LL=ML+20|0;c[LL+0>>2]=0;c[LL+4>>2]=0;c[LL+8>>2]=0;c[ML>>2]=0;c[ML+4>>2]=0;c[ML+8>>2]=OL;c[NL>>2]=ML;OL=c[c[HL>>2]>>2]|0;if(!OL)PL=ML;else{c[HL>>2]=OL;PL=c[NL>>2]|0}GN(c[BL>>2]|0,PL);PL=HL+8|0;c[PL>>2]=(c[PL>>2]|0)+1;QL=ML}else QL=KL;zri(QL+20|0,600160)|0;QL=c[149478]|0;KL=QL+4|0;ML=c[KL>>2]|0;do if(ML){PL=ML;while(1){HL=c[PL+16>>2]|0;if((HL|0)>322){BL=c[PL>>2]|0;if(!BL){RL=PL;SL=PL;o=3008;break}else{PL=BL;continue}}if((HL|0)>=322){TL=PL;o=3012;break}HL=PL+4|0;BL=c[HL>>2]|0;if(!BL){UL=HL;VL=PL;o=3011;break}else PL=BL}if((o|0)==3008){c[d>>2]=SL;WL=RL;XL=SL;break}else if((o|0)==3011){c[d>>2]=VL;WL=UL;XL=VL;break}else if((o|0)==3012){c[d>>2]=TL;WL=d;XL=TL;break}}else{PL=QL+4|0;c[d>>2]=PL;WL=PL;XL=PL}while(0);TL=c[WL>>2]|0;if(!TL){VL=xCi(32)|0;c[VL+16>>2]=322;UL=VL+20|0;c[UL+0>>2]=0;c[UL+4>>2]=0;c[UL+8>>2]=0;c[VL>>2]=0;c[VL+4>>2]=0;c[VL+8>>2]=XL;c[WL>>2]=VL;XL=c[c[QL>>2]>>2]|0;if(!XL)YL=VL;else{c[QL>>2]=XL;YL=c[WL>>2]|0}GN(c[KL>>2]|0,YL);YL=QL+8|0;c[YL>>2]=(c[YL>>2]|0)+1;ZL=VL}else ZL=TL;zri(ZL+20|0,600168)|0;ZL=c[149478]|0;TL=ZL+4|0;VL=c[TL>>2]|0;do if(VL){YL=VL;while(1){QL=c[YL+16>>2]|0;if((QL|0)>323){KL=c[YL>>2]|0;if(!KL){_L=YL;$L=YL;o=3021;break}else{YL=KL;continue}}if((QL|0)>=323){aM=YL;o=3025;break}QL=YL+4|0;KL=c[QL>>2]|0;if(!KL){bM=QL;cM=YL;o=3024;break}else YL=KL}if((o|0)==3021){c[d>>2]=$L;dM=_L;eM=$L;break}else if((o|0)==3024){c[d>>2]=cM;dM=bM;eM=cM;break}else if((o|0)==3025){c[d>>2]=aM;dM=d;eM=aM;break}}else{YL=ZL+4|0;c[d>>2]=YL;dM=YL;eM=YL}while(0);aM=c[dM>>2]|0;if(!aM){cM=xCi(32)|0;c[cM+16>>2]=323;bM=cM+20|0;c[bM+0>>2]=0;c[bM+4>>2]=0;c[bM+8>>2]=0;c[cM>>2]=0;c[cM+4>>2]=0;c[cM+8>>2]=eM;c[dM>>2]=cM;eM=c[c[ZL>>2]>>2]|0;if(!eM)fM=cM;else{c[ZL>>2]=eM;fM=c[dM>>2]|0}GN(c[TL>>2]|0,fM);fM=ZL+8|0;c[fM>>2]=(c[fM>>2]|0)+1;gM=cM}else gM=aM;zri(gM+20|0,597768)|0;gM=c[149478]|0;aM=gM+4|0;cM=c[aM>>2]|0;do if(cM){fM=cM;while(1){ZL=c[fM+16>>2]|0;if((ZL|0)>324){TL=c[fM>>2]|0;if(!TL){hM=fM;iM=fM;o=3034;break}else{fM=TL;continue}}if((ZL|0)>=324){jM=fM;o=3038;break}ZL=fM+4|0;TL=c[ZL>>2]|0;if(!TL){kM=ZL;lM=fM;o=3037;break}else fM=TL}if((o|0)==3034){c[d>>2]=iM;mM=hM;nM=iM;break}else if((o|0)==3037){c[d>>2]=lM;mM=kM;nM=lM;break}else if((o|0)==3038){c[d>>2]=jM;mM=d;nM=jM;break}}else{fM=gM+4|0;c[d>>2]=fM;mM=fM;nM=fM}while(0);jM=c[mM>>2]|0;if(!jM){lM=xCi(32)|0;c[lM+16>>2]=324;kM=lM+20|0;c[kM+0>>2]=0;c[kM+4>>2]=0;c[kM+8>>2]=0;c[lM>>2]=0;c[lM+4>>2]=0;c[lM+8>>2]=nM;c[mM>>2]=lM;nM=c[c[gM>>2]>>2]|0;if(!nM)oM=lM;else{c[gM>>2]=nM;oM=c[mM>>2]|0}GN(c[aM>>2]|0,oM);oM=gM+8|0;c[oM>>2]=(c[oM>>2]|0)+1;pM=lM}else pM=jM;zri(pM+20|0,597792)|0;pM=c[149478]|0;jM=pM+4|0;lM=c[jM>>2]|0;do if(lM){oM=lM;while(1){gM=c[oM+16>>2]|0;if((gM|0)>325){aM=c[oM>>2]|0;if(!aM){qM=oM;rM=oM;o=3047;break}else{oM=aM;continue}}if((gM|0)>=325){sM=oM;o=3051;break}gM=oM+4|0;aM=c[gM>>2]|0;if(!aM){tM=gM;uM=oM;o=3050;break}else oM=aM}if((o|0)==3047){c[d>>2]=rM;vM=qM;wM=rM;break}else if((o|0)==3050){c[d>>2]=uM;vM=tM;wM=uM;break}else if((o|0)==3051){c[d>>2]=sM;vM=d;wM=sM;break}}else{oM=pM+4|0;c[d>>2]=oM;vM=oM;wM=oM}while(0);sM=c[vM>>2]|0;if(!sM){uM=xCi(32)|0;c[uM+16>>2]=325;tM=uM+20|0;c[tM+0>>2]=0;c[tM+4>>2]=0;c[tM+8>>2]=0;c[uM>>2]=0;c[uM+4>>2]=0;c[uM+8>>2]=wM;c[vM>>2]=uM;wM=c[c[pM>>2]>>2]|0;if(!wM)xM=uM;else{c[pM>>2]=wM;xM=c[vM>>2]|0}GN(c[jM>>2]|0,xM);xM=pM+8|0;c[xM>>2]=(c[xM>>2]|0)+1;yM=uM}else yM=sM;zri(yM+20|0,597816)|0;yM=c[149478]|0;sM=yM+4|0;uM=c[sM>>2]|0;do if(uM){xM=uM;while(1){pM=c[xM+16>>2]|0;if((pM|0)>326){jM=c[xM>>2]|0;if(!jM){zM=xM;AM=xM;o=3060;break}else{xM=jM;continue}}if((pM|0)>=326){BM=xM;o=3064;break}pM=xM+4|0;jM=c[pM>>2]|0;if(!jM){CM=pM;DM=xM;o=3063;break}else xM=jM}if((o|0)==3060){c[d>>2]=AM;EM=zM;FM=AM;break}else if((o|0)==3063){c[d>>2]=DM;EM=CM;FM=DM;break}else if((o|0)==3064){c[d>>2]=BM;EM=d;FM=BM;break}}else{xM=yM+4|0;c[d>>2]=xM;EM=xM;FM=xM}while(0);BM=c[EM>>2]|0;if(!BM){DM=xCi(32)|0;c[DM+16>>2]=326;CM=DM+20|0;c[CM+0>>2]=0;c[CM+4>>2]=0;c[CM+8>>2]=0;c[DM>>2]=0;c[DM+4>>2]=0;c[DM+8>>2]=FM;c[EM>>2]=DM;FM=c[c[yM>>2]>>2]|0;if(!FM)GM=DM;else{c[yM>>2]=FM;GM=c[EM>>2]|0}GN(c[sM>>2]|0,GM);GM=yM+8|0;c[GM>>2]=(c[GM>>2]|0)+1;HM=DM}else HM=BM;zri(HM+20|0,600176)|0;HM=c[149478]|0;BM=HM+4|0;DM=c[BM>>2]|0;do if(DM){GM=DM;while(1){yM=c[GM+16>>2]|0;if((yM|0)>327){sM=c[GM>>2]|0;if(!sM){IM=GM;JM=GM;o=3073;break}else{GM=sM;continue}}if((yM|0)>=327){KM=GM;o=3077;break}yM=GM+4|0;sM=c[yM>>2]|0;if(!sM){LM=yM;MM=GM;o=3076;break}else GM=sM}if((o|0)==3073){c[d>>2]=JM;NM=IM;OM=JM;break}else if((o|0)==3076){c[d>>2]=MM;NM=LM;OM=MM;break}else if((o|0)==3077){c[d>>2]=KM;NM=d;OM=KM;break}}else{GM=HM+4|0;c[d>>2]=GM;NM=GM;OM=GM}while(0);KM=c[NM>>2]|0;if(!KM){MM=xCi(32)|0;c[MM+16>>2]=327;LM=MM+20|0;c[LM+0>>2]=0;c[LM+4>>2]=0;c[LM+8>>2]=0;c[MM>>2]=0;c[MM+4>>2]=0;c[MM+8>>2]=OM;c[NM>>2]=MM;OM=c[c[HM>>2]>>2]|0;if(!OM)PM=MM;else{c[HM>>2]=OM;PM=c[NM>>2]|0}GN(c[BM>>2]|0,PM);PM=HM+8|0;c[PM>>2]=(c[PM>>2]|0)+1;QM=MM}else QM=KM;zri(QM+20|0,600184)|0;QM=c[149478]|0;KM=QM+4|0;MM=c[KM>>2]|0;do if(MM){PM=MM;while(1){HM=c[PM+16>>2]|0;if((HM|0)>328){BM=c[PM>>2]|0;if(!BM){RM=PM;SM=PM;o=3086;break}else{PM=BM;continue}}if((HM|0)>=328){TM=PM;o=3090;break}HM=PM+4|0;BM=c[HM>>2]|0;if(!BM){UM=HM;VM=PM;o=3089;break}else PM=BM}if((o|0)==3086){c[d>>2]=SM;WM=RM;XM=SM;break}else if((o|0)==3089){c[d>>2]=VM;WM=UM;XM=VM;break}else if((o|0)==3090){c[d>>2]=TM;WM=d;XM=TM;break}}else{PM=QM+4|0;c[d>>2]=PM;WM=PM;XM=PM}while(0);TM=c[WM>>2]|0;if(!TM){VM=xCi(32)|0;c[VM+16>>2]=328;UM=VM+20|0;c[UM+0>>2]=0;c[UM+4>>2]=0;c[UM+8>>2]=0;c[VM>>2]=0;c[VM+4>>2]=0;c[VM+8>>2]=XM;c[WM>>2]=VM;XM=c[c[QM>>2]>>2]|0;if(!XM)YM=VM;else{c[QM>>2]=XM;YM=c[WM>>2]|0}GN(c[KM>>2]|0,YM);YM=QM+8|0;c[YM>>2]=(c[YM>>2]|0)+1;ZM=VM}else ZM=TM;zri(ZM+20|0,600192)|0;ZM=c[149478]|0;TM=ZM+4|0;VM=c[TM>>2]|0;do if(VM){YM=VM;while(1){QM=c[YM+16>>2]|0;if((QM|0)>329){KM=c[YM>>2]|0;if(!KM){_M=YM;$M=YM;o=3099;break}else{YM=KM;continue}}if((QM|0)>=329){aN=YM;o=3103;break}QM=YM+4|0;KM=c[QM>>2]|0;if(!KM){bN=QM;cN=YM;o=3102;break}else YM=KM}if((o|0)==3099){c[d>>2]=$M;dN=_M;eN=$M;break}else if((o|0)==3102){c[d>>2]=cN;dN=bN;eN=cN;break}else if((o|0)==3103){c[d>>2]=aN;dN=d;eN=aN;break}}else{YM=ZM+4|0;c[d>>2]=YM;dN=YM;eN=YM}while(0);aN=c[dN>>2]|0;if(!aN){cN=xCi(32)|0;c[cN+16>>2]=329;bN=cN+20|0;c[bN+0>>2]=0;c[bN+4>>2]=0;c[bN+8>>2]=0;c[cN>>2]=0;c[cN+4>>2]=0;c[cN+8>>2]=eN;c[dN>>2]=cN;eN=c[c[ZM>>2]>>2]|0;if(!eN)fN=cN;else{c[ZM>>2]=eN;fN=c[dN>>2]|0}GN(c[TM>>2]|0,fN);fN=ZM+8|0;c[fN>>2]=(c[fN>>2]|0)+1;gN=cN}else gN=aN;zri(gN+20|0,600200)|0;gN=0;do{aN=(gN|0)==0;cN=(gN*20|0)+330|0;fN=0;do{if(aN){c[d>>2]=fN;rEi(e,100,600208,d)|0}else{c[d>>2]=gN;c[d+4>>2]=fN;rEi(e,100,1064224,d)|0}ZM=c[149478]|0;TM=cN+fN|0;dN=ZM+4|0;eN=c[dN>>2]|0;do if(eN){bN=eN;while(1){$M=c[bN+16>>2]|0;if((TM|0)<($M|0)){_M=c[bN>>2]|0;if(!_M){hN=bN;iN=bN;o=3117;break}else{bN=_M;continue}}if(($M|0)>=(TM|0)){jN=bN;o=3121;break}$M=bN+4|0;_M=c[$M>>2]|0;if(!_M){kN=$M;lN=bN;o=3120;break}else bN=_M}if((o|0)==3117){o=0;c[d>>2]=iN;mN=hN;nN=iN;break}else if((o|0)==3120){o=0;c[d>>2]=lN;mN=kN;nN=lN;break}else if((o|0)==3121){o=0;c[d>>2]=jN;mN=d;nN=jN;break}}else{bN=ZM+4|0;c[d>>2]=bN;mN=bN;nN=bN}while(0);eN=c[mN>>2]|0;if(!eN){bN=xCi(32)|0;c[bN+16>>2]=TM;_M=bN+20|0;c[_M+0>>2]=0;c[_M+4>>2]=0;c[_M+8>>2]=0;c[bN>>2]=0;c[bN+4>>2]=0;c[bN+8>>2]=nN;c[mN>>2]=bN;_M=c[c[ZM>>2]>>2]|0;if(!_M)oN=bN;else{c[ZM>>2]=_M;oN=c[mN>>2]|0}GN(c[dN>>2]|0,oN);_M=ZM+8|0;c[_M>>2]=(c[_M>>2]|0)+1;pN=bN}else pN=eN;zri(pN+20|0,e)|0;fN=fN+1|0}while((fN|0)!=20);gN=gN+1|0}while((gN|0)!=12);gN=c[149480]|0;PUb(gN,c[gN+4>>2]|0);c[gN+8>>2]=0;e=gN+4|0;c[gN>>2]=e;c[e>>2]=0;e=c[149478]|0;gN=c[e>>2]|0;if((gN|0)==(e+4|0)){i=b;return}else qN=gN;while(1){gN=c[qN+16>>2]|0;c[(ZVb(c[149480]|0,qN+20|0)|0)>>2]=gN;gN=c[qN+4>>2]|0;if(!gN){e=qN;while(1){pN=c[e+8>>2]|0;if((c[pN>>2]|0)==(e|0)){rN=pN;break}else e=pN}}else{e=gN;while(1){pN=c[e>>2]|0;if(!pN){rN=e;break}else e=pN}}if((rN|0)==((c[149478]|0)+4|0))break;else qN=rN}i=b;return}function qKc(b){b=b|0;var d=0,e=0,f=0;d=i;if(c[b+60>>2]|0)PEi(c[b+56>>2]|0,0,c[b+64>>2]<<2|0)|0;if(c[b+76>>2]|0)PEi(c[b+72>>2]|0,0,c[b+80>>2]<<2|0)|0;e=b+84|0;f=b+124|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;if(!(a[f>>0]&1)){a[f+1>>0]=0;a[f>>0]=0;i=d;return}else{a[c[b+132>>2]>>0]=0;c[b+128>>2]=0;i=d;return}}function rKc(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=0,r=0;b=i;d=a+116|0;e=c[d>>2]|0;f=a+112|0;h=c[f>>2]|0;if((e|0)!=(h|0)){j=c[h>>2]|0;k=h+4|0;l=c[k>>2]|0;if((j|0)==(l|0)){m=h;n=e}else{PEi(j|0,0,l+-4-j+4&-4|0)|0;m=c[f>>2]|0;n=c[d>>2]|0}d=m+12|0;if((d|0)!=(n|0)){f=c[h>>2]|0;h=(c[k>>2]|0)-f>>2;k=~h;j=m;m=d;while(1){d=c[j+12>>2]|0;l=(c[j+16>>2]|0)-d>>2;if((l>>>0<h>>>0?l:h)|0){e=~l;l=~(e>>>0>k>>>0?e:k);e=0;do{o=ea(g[d+(e<<2)>>2]);p=ea(S(ea(o)));q=f+(e<<2)|0;if(p>ea(S(ea(g[q>>2]))))g[q>>2]=o;e=e+1|0}while((e|0)!=(l|0))}l=j+24|0;if((l|0)==(n|0))break;else{e=m;m=l;j=e}}}}j=c[a+24>>2]|0;m=a+28|0;if((j|0)==(c[m>>2]|0)){i=b;return}else r=j;do{ko[c[c[r>>2]>>2]&4095](r);r=r+92|0}while((r|0)!=(c[m>>2]|0));i=b;return}function sKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;do if(d){f=b>>>5;g=a+40|0;h=c[g>>2]|0;j=1<<(b&31);if(!(c[h+(f<<2)>>2]&j)){k=(c[a+56>>2]|0)+(f<<2)|0;c[k>>2]=c[k>>2]|j;l=c[g>>2]|0;m=j}else{l=h;m=j}}else{j=b>>>5;h=1<<(b&31);g=a+40|0;if(c[(c[a+40>>2]|0)+(j<<2)>>2]&h){k=(c[a+72>>2]|0)+(j<<2)|0;c[k>>2]=c[k>>2]|h;k=c[g>>2]|0;if(d){l=k;m=h;break}else n=k}else n=c[g>>2]|0;g=n+(j<<2)|0;c[g>>2]=c[g>>2]&~h;i=e;return}while(0);n=l+(b>>>5<<2)|0;c[n>>2]=c[n>>2]|m;i=e;return}function tKc(b){b=b|0;return (a[b+156>>0]|0)!=0|0}function uKc(b){b=b|0;var d=0,e=0;d=i;if(a[b+157>>0]|0){e=1;i=d;return e|0}if(!(c[(rIc()|0)+8>>2]|0)){e=0;i=d;return e|0}e=(c[(c[(rIc()|0)+8>>2]|0)+24>>2]|0)!=0;i=d;return e|0}function vKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(180,e,1,16,3653512,42)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];gKc(f,e,b);i=d;return f|0}function wKc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}wKc(a,c[b>>2]|0);wKc(a,c[b+4>>2]|0);xri(b+20|0);ACi(b);i=d;return}function xKc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+96|0;g=f;add(a,d,c[142306]|0,b,e);OJc(g);$cd(a,2646336,2646336,f+92|0,0);add(a,3142592,600424,g,0);JKc(g,a);bdd(a);cdd(a);EKc(g);bdd(a);i=f;return}function yKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;LSb(a,b);rdd(b,2);f=a+24|0;a=qdd(b,600232,c[142306]|0,e,1)|0;if(a){if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else KKc(b,f,0);sdd(b)}if(!(xdd(b,1)|0)){i=d;return}jKc(f);i=d;return}function zKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}LKc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{MKc(r,a);r=r+92|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*92|0)|0;c[j>>2]=0;i=d;return}function AKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;LKc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{NKc(r,a);r=r+92|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*92|0)|0;c[j>>2]=0;i=d;return}function BKc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;e=i;i=i+128|0;f=e+100|0;h=e+84|0;j=e+52|0;k=e+48|0;l=e+80|0;m=e+88|0;n=e+104|0;o=e+24|0;p=e+12|0;q=e+56|0;r=e+36|0;s=e+68|0;t=e;FXb(d,b+4|0,2487248,0);FXb(d,b+16|0,600240,0);FXb(d,b+28|0,600256,0);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;u=c[b+44>>2]|0;v=c[149478]|0;w=c[v+4>>2]|0;x=v+4|0;if(w){v=x;y=w;a:while(1){w=y;while(1){if((c[w+16>>2]|0)>=(u|0)){z=w;break}w=c[w+4>>2]|0;if(!w){A=v;break a}}y=c[z>>2]|0;if(!y){A=z;break}else v=z}if((A|0)!=(x|0)?(c[A+16>>2]|0)<=(u|0):0){sri(n,A+20|0);A=a[n>>0]|0;if(!(A&1)){B=m;C=A;D=11}else{E=c[n+4>>2]|0;F=c[n+8>>2]|0;G=m}}else D=8}else D=8;if((D|0)==8){c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;B=m;C=0;D=11}if((D|0)==11){E=(C&255)>>>1;F=n+1|0;G=B}B=a[m>>0]|0;if(!(B&1)){H=10;I=B}else{B=c[m>>2]|0;H=(B&-2)+-1|0;I=B&255}B=(I&1)==0;do if(E>>>0<=H>>>0){if(B)J=m+1|0;else J=c[m+8>>2]|0;aFi(J|0,F|0,E|0)|0;a[J+E>>0]=0;if(!(a[m>>0]&1)){a[m>>0]=E<<1;break}else{c[m+4>>2]=E;break}}else{if(B)K=(I&255)>>>1;else K=c[m+4>>2]|0;eXb(G,H,E-H|0,K,0,K,E,F)}while(0);xri(n);FXb(d,m,600280,2048);if(a[m>>0]&1){n=c[m+8>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(n,f)};c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;n=c[b+40>>2]|0;l=c[149478]|0;m=c[l+4>>2]|0;F=l+4|0;if(m){l=F;E=m;b:while(1){m=E;while(1){if((c[m+16>>2]|0)>=(n|0)){L=m;break}m=c[m+4>>2]|0;if(!m){M=l;break b}}E=c[L>>2]|0;if(!E){M=L;break}else l=L}if((M|0)!=(F|0)?(c[M+16>>2]|0)<=(n|0):0){sri(p,M+20|0);M=a[p>>0]|0;if(!(M&1)){N=M;O=o;D=37}else{P=c[p+4>>2]|0;Q=c[p+8>>2]|0;R=o}}else D=34}else D=34;if((D|0)==34){c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;N=0;O=o;D=37}if((D|0)==37){P=(N&255)>>>1;Q=p+1|0;R=O}O=a[o>>0]|0;if(!(O&1)){S=10;T=O}else{O=c[o>>2]|0;S=(O&-2)+-1|0;T=O&255}O=(T&1)==0;do if(P>>>0<=S>>>0){if(O)U=o+1|0;else U=c[o+8>>2]|0;aFi(U|0,Q|0,P|0)|0;a[U+P>>0]=0;if(!(a[o>>0]&1)){a[o>>0]=P<<1;break}else{c[o+4>>2]=P;break}}else{if(O)V=(T&255)>>>1;else V=c[o+4>>2]|0;eXb(R,S,P-S|0,V,0,V,P,Q)}while(0);xri(p);FXb(d,o,600296,2048);if(a[o>>0]&1){p=c[o+8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(p,f)};c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;p=c[b+52>>2]|0;k=c[149478]|0;o=c[k+4>>2]|0;Q=k+4|0;if(o){k=Q;P=o;c:while(1){o=P;while(1){if((c[o+16>>2]|0)>=(p|0)){W=o;break}o=c[o+4>>2]|0;if(!o){X=k;break c}}P=c[W>>2]|0;if(!P){X=W;break}else k=W}if((X|0)!=(Q|0)?(c[X+16>>2]|0)<=(p|0):0){sri(r,X+20|0);X=a[r>>0]|0;if(!(X&1)){Y=X;Z=q;D=63}else{_=c[r+4>>2]|0;$=c[r+8>>2]|0;aa=q}}else D=60}else D=60;if((D|0)==60){c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Y=0;Z=q;D=63}if((D|0)==63){_=(Y&255)>>>1;$=r+1|0;aa=Z}Z=a[q>>0]|0;if(!(Z&1)){ba=10;ca=Z}else{Z=c[q>>2]|0;ba=(Z&-2)+-1|0;ca=Z&255}Z=(ca&1)==0;do if(_>>>0<=ba>>>0){if(Z)da=q+1|0;else da=c[q+8>>2]|0;aFi(da|0,$|0,_|0)|0;a[da+_>>0]=0;if(!(a[q>>0]&1)){a[q>>0]=_<<1;break}else{c[q+4>>2]=_;break}}else{if(Z)fa=(ca&255)>>>1;else fa=c[q+4>>2]|0;eXb(aa,ba,_-ba|0,fa,0,fa,_,$)}while(0);xri(r);FXb(d,q,600312,2048);if(a[q>>0]&1){r=c[q+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(r,f)};c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;r=c[b+48>>2]|0;j=c[149478]|0;q=c[j+4>>2]|0;$=j+4|0;if(q){j=$;_=q;d:while(1){q=_;while(1){if((c[q+16>>2]|0)>=(r|0)){ga=q;break}q=c[q+4>>2]|0;if(!q){ha=j;break d}}_=c[ga>>2]|0;if(!_){ha=ga;break}else j=ga}if((ha|0)!=($|0)?(c[ha+16>>2]|0)<=(r|0):0){sri(t,ha+20|0);ha=a[t>>0]|0;if(!(ha&1)){ia=ha;ja=s;D=89}else{ka=c[t+4>>2]|0;la=c[t+8>>2]|0;ma=s}}else D=86}else D=86;if((D|0)==86){c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;ia=0;ja=s;D=89}if((D|0)==89){ka=(ia&255)>>>1;la=t+1|0;ma=ja}ja=a[s>>0]|0;if(!(ja&1)){na=10;oa=ja}else{ja=c[s>>2]|0;na=(ja&-2)+-1|0;oa=ja&255}ja=(oa&1)==0;do if(ka>>>0<=na>>>0){if(ja)pa=s+1|0;else pa=c[s+8>>2]|0;aFi(pa|0,la|0,ka|0)|0;a[pa+ka>>0]=0;if(!(a[s>>0]&1)){a[s>>0]=ka<<1;break}else{c[s+4>>2]=ka;break}}else{if(ja)qa=(oa&255)>>>1;else qa=c[s+4>>2]|0;eXb(ma,na,ka-na|0,qa,0,qa,ka,la)}while(0);xri(t);FXb(d,s,600336,2048);if(a[s>>0]&1){t=c[s+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(t,f)}f=b+76|0;t=d+12|0;h=c[t>>2]|0;s=h+4|0;la=d+20|0;ka=c[la>>2]|0;if(s>>>0<ka>>>0){g[h>>2]=ea(g[f>>2]);c[t>>2]=s;ra=s;sa=ka}else{Gid(t,f,4);ra=c[t>>2]|0;sa=c[la>>2]|0}f=b+80|0;ka=ra+4|0;if(ka>>>0<sa>>>0){g[ra>>2]=ea(g[f>>2]);c[t>>2]=ka;ta=ka;ua=sa}else{Gid(t,f,4);ta=c[t>>2]|0;ua=c[la>>2]|0}f=b+84|0;sa=ta+4|0;if(sa>>>0<ua>>>0){g[ta>>2]=ea(g[f>>2]);c[t>>2]=sa;va=sa;wa=ua}else{Gid(t,f,4);va=c[t>>2]|0;wa=c[la>>2]|0}f=b+88|0;if((va+1|0)>>>0<wa>>>0){a[va>>0]=a[f>>0]|0;va=(c[t>>2]|0)+1|0;c[t>>2]=va;xa=va}else{Gid(t,f,1);xa=c[t>>2]|0}f=b+89|0;if((xa+1|0)>>>0<(c[la>>2]|0)>>>0){a[xa>>0]=a[f>>0]|0;c[t>>2]=(c[t>>2]|0)+1}else Gid(t,f,1);Tdd(d);d=b+60|0;f=c[t>>2]|0;xa=f+4|0;va=c[la>>2]|0;if(xa>>>0<va>>>0){c[f>>2]=c[d>>2];c[t>>2]=xa;ya=xa;za=va}else{Gid(t,d,4);ya=c[t>>2]|0;za=c[la>>2]|0}d=b+72|0;va=ya+4|0;if(va>>>0<za>>>0){c[ya>>2]=c[d>>2];c[t>>2]=va;Aa=va;Ba=za}else{Gid(t,d,4);Aa=c[t>>2]|0;Ba=c[la>>2]|0}la=b+56|0;b=Aa+4|0;if(b>>>0<Ba>>>0){c[Aa>>2]=c[la>>2];c[t>>2]=b;i=e;return}else{Gid(t,la,4);i=e;return}}function CKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;h=b+4|0;j=(c[h>>2]|0)-(c[b>>2]|0)|0;k=j>>2;if(!k){i=d;return}if(k>>>0>1073741823)vxi(a);l=xCi(j)|0;c[e>>2]=l;c[a>>2]=l;c[f>>2]=l+(k<<2);k=c[b>>2]|0;b=c[h>>2]|0;if((k|0)==(b|0)){i=d;return}h=(b+-4-k|0)>>>2;f=k;k=l;while(1){g[k>>2]=ea(g[f>>2]);f=f+4|0;if((f|0)==(b|0))break;else k=k+4|0}c[e>>2]=l+(h+1<<2);i=d;return}function DKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=357913941;r=(l-j|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;r=n+(m*12|0)|0;if(!s){u=p;v=f}else{CKc(s,b);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*12|0)|0;if((u|0)!=(v|0)){o=u;n=s;while(1){f=n+-12|0;o=o+-12|0;CKc(f,o);if((o|0)==(v|0)){w=f;break}else n=f}n=c[a>>2]|0;v=c[e>>2]|0;c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;if((v|0)==(n|0))x=n;else{w=v;do{v=w;w=w+-12|0;o=c[w>>2]|0;if(o){f=v+-8|0;v=c[f>>2]|0;if((v|0)!=(o|0))c[f>>2]=v+(~((v+-4-o|0)>>>2)<<2);ACi(o)}}while((w|0)!=(n|0));x=n}}else{c[a>>2]=s;c[e>>2]=b;c[h>>2]=r;x=u}if(!x){i=d;return}ACi(x);i=d;return}function EKc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[b>>2]=597448;if(a[b+28>>0]&1){j=c[b+36>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(j,e)}if(a[b+16>>0]&1){j=c[b+24>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(j,e)}if(!(a[b+4>>0]&1)){i=d;return}j=c[b+12>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function FKc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+16|0;g=f+4|0;h=f;c[d>>2]=597448;j=d+4|0;k=e+4|0;l=a[k>>0]|0;if(!(l&1)){m=(l&255)>>>1;n=k+1|0}else{m=c[e+8>>2]|0;n=c[e+12>>2]|0}if(m>>>0>2147483631)ori(j);if(m>>>0<11){a[j>>0]=m<<1;o=j+1|0}else{k=m+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];l=cOb(k,16,g,0,3653512,80)|0;c[d+12>>2]=l;c[j>>2]=k|1;c[d+8>>2]=m;o=l}YEi(o|0,n|0,m|0)|0;a[o+m>>0]=0;m=d+16|0;o=e+16|0;n=a[o>>0]|0;if(!(n&1)){p=(n&255)>>>1;q=o+1|0}else{p=c[e+20>>2]|0;q=c[e+24>>2]|0}if(p>>>0>2147483631)ori(m);if(p>>>0<11){a[m>>0]=p<<1;r=m+1|0}else{o=p+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];n=cOb(o,16,g,0,3653512,80)|0;c[d+24>>2]=n;c[m>>2]=o|1;c[d+20>>2]=p;r=n}YEi(r|0,q|0,p|0)|0;a[r+p>>0]=0;p=d+28|0;r=e+28|0;q=a[r>>0]|0;if(!(q&1)){s=(q&255)>>>1;t=r+1|0}else{s=c[e+32>>2]|0;t=c[e+36>>2]|0}if(s>>>0>2147483631)ori(p);if(s>>>0<11){a[p>>0]=s<<1;u=p+1|0;YEi(u|0,t|0,s|0)|0;v=u+s|0;a[v>>0]=0;w=d+40|0;x=e+40|0;y=w+0|0;z=x+0|0;A=y+48|0;do{c[y>>2]=c[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));b[w+48>>1]=b[x+48>>1]|0;i=f;return}else{r=s+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(r,16,g,0,3653512,80)|0;c[d+36>>2]=h;c[p>>2]=r|1;c[d+32>>2]=s;u=h;YEi(u|0,t|0,s|0)|0;v=u+s|0;a[v>>0]=0;w=d+40|0;x=e+40|0;y=w+0|0;z=x+0|0;A=y+48|0;do{c[y>>2]=c[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));b[w+48>>1]=b[x+48>>1]|0;i=f;return}}function GKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/92|0)+1|0;if(g>>>0>46684427)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/92|0;if(k>>>0<23342213){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/92|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=46684427;r=(l-j|0)/92|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*92|0)|0;o=r;p=s}s=n+(o*92|0)|0;r=n+(m*92|0)|0;if(!s){u=p;v=f}else{FKc(s,b);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*92|0)|0;if((u|0)!=(v|0)){o=u;n=s;while(1){f=n+-92|0;o=o+-92|0;FKc(f,o);if((o|0)==(v|0)){w=f;break}else n=f}n=c[a>>2]|0;v=c[e>>2]|0;c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;if((v|0)==(n|0))x=n;else{w=v;do{w=w+-92|0;EKc(w)}while((w|0)!=(n|0));x=n}}else{c[a>>2]=s;c[e>>2]=b;c[h>>2]=r;x=u}if(!x){i=d;return}ACi(x);i=d;return}function HKc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=597480;xri(a+136|0);xri(a+124|0);f=a+112|0;g=c[f>>2]|0;if(g){h=a+116|0;j=c[h>>2]|0;if((j|0)==(g|0))k=g;else{l=j;while(1){j=l+-12|0;c[h>>2]=j;m=c[j>>2]|0;if(!m)n=j;else{j=l+-8|0;o=c[j>>2]|0;if((o|0)!=(m|0))c[j>>2]=o+(~((o+-4-m|0)>>>2)<<2);ACi(m);n=c[h>>2]|0}if((n|0)==(g|0))break;else l=n}k=c[f>>2]|0}ACi(k)}k=c[a+72>>2]|0;c[e>>2]=c[a+68>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);k=c[a+56>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);k=c[a+40>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);d=a+24|0;k=c[d>>2]|0;if(!k){ZSb(a);i=b;return}e=a+28|0;f=c[e>>2]|0;if((f|0)==(k|0))p=k;else{n=f;do{f=n+-92|0;c[e>>2]=f;EKc(f);n=c[e>>2]|0}while((n|0)!=(k|0));p=c[d>>2]|0}ACi(p);ZSb(a);i=b;return}function IKc(a){a=a|0;var b=0;b=i;HKc(a);ACi(a);i=b;return}function JKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+12|0;j=e+16|0;k=e+64|0;l=e;m=e+20|0;n=e+48|0;o=e+36|0;ddd(d,3);p=c[142294]|0;add(d,2487248,p,b+4|0,0);$cd(d,2646336,2646336,f,1);q=c[142260]|0;add(d,3142592,q,g,0);r=d+12|0;s=d+20|0;c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);add(d,600240,p,b+16|0,0);$cd(d,2646336,2646336,f,1);add(d,3142592,q,g,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);add(d,600256,p,b+28|0,0);$cd(d,2646336,2646336,f,1);add(d,3142592,q,g,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;add(d,600280,p,l,2048);$cd(d,2646336,2646336,f,1);add(d,3142592,q,g,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);if(a[l>>0]&1){t=c[l+8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(t,f)};c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;add(d,600296,p,m,2048);$cd(d,2646336,2646336,f,1);add(d,3142592,q,g,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);if(a[m>>0]&1){t=c[m+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(t,f)};c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;add(d,600312,p,n,2048);$cd(d,2646336,2646336,f,1);add(d,3142592,q,g,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);if(a[n>>0]&1){t=c[n+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(t,f)};c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;add(d,600336,p,o,2048);$cd(d,2646336,2646336,f,1);add(d,3142592,q,g,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);if(a[o>>0]&1){q=c[o+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(q,f)}f=c[142268]|0;add(d,600360,f,b+76|0,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,600368,f,b+80|0,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,600376,f,b+84|0,2048);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(d);f=c[142258]|0;add(d,600392,f,b+88|0,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);add(d,600400,f,b+89|0,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=1;bdd(d);fdd(d);f=c[142270]|0;add(d,3144960,f,b+60|0,2048);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,600408,f,b+72|0,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,600416,f,b+56|0,0);c[(c[c[r>>2]>>2]|0)+((c[s>>2]|0)*24|0)+12>>2]=4;bdd(d);i=e;return}function KKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/92|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}LKc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,600424,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;OKc(r,a);t=r+92|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,600424,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else OKc(m,a);sdd(a)}m=m+92|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function LKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+44|0;f=d+32|0;g=d+16|0;h=d+36|0;j=d+12|0;k=d;l=d+28|0;m=d+40|0;n=d+48|0;o=a+4|0;p=c[a>>2]|0;q=p;r=((c[o>>2]|0)-q|0)/92|0;if(r>>>0>=b>>>0){if(r>>>0<=b>>>0){i=d;return}c[l>>2]=p;c[m>>2]=p+(b*92|0);c[f+0>>2]=c[l+0>>2];c[e+0>>2]=c[m+0>>2];SKc(k,f,e,n,0);n=c[k>>2]|0;m=c[a>>2]|0;c[k>>2]=m;c[a>>2]=n;n=k+4|0;l=c[n>>2]|0;p=c[o>>2]|0;c[n>>2]=p;c[o>>2]=l;l=k+8|0;s=a+8|0;t=c[l>>2]|0;c[l>>2]=c[s>>2];c[s>>2]=t;if(!m){i=d;return}if((p|0)==(m|0))u=m;else{t=p;do{p=t+-92|0;c[n>>2]=p;EKc(p);t=c[n>>2]|0}while((t|0)!=(m|0));u=c[k>>2]|0}ACi(u);i=d;return}u=a+8|0;if((((c[u>>2]|0)-q|0)/92|0|0)==(b|0)){RKc(a,b-r|0);i=d;return}c[g>>2]=0;r=g+4|0;c[r>>2]=0;q=g+8|0;c[q>>2]=0;PKc(g,b);c[h>>2]=c[a>>2];c[j>>2]=c[o>>2];c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];QKc(g,f,e);e=c[r>>2]|0;f=c[g>>2]|0;j=(e-f|0)/92|0;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b*92|0)|0,(e|0)!=(h|0)):0){f=e;do{k=f+-92|0;c[r>>2]=k;EKc(k);f=c[r>>2]|0}while((f|0)!=(h|0));v=h}else v=e;else{RKc(g,b-j|0);v=c[r>>2]|0}j=c[g>>2]|0;b=c[a>>2]|0;c[g>>2]=b;c[a>>2]=j;j=c[o>>2]|0;c[r>>2]=j;c[o>>2]=v;v=c[q>>2]|0;c[q>>2]=c[u>>2];c[u>>2]=v;if(!b){i=d;return}if((j|0)==(b|0))w=b;else{v=j;do{j=v+-92|0;c[r>>2]=j;EKc(j);v=c[r>>2]|0}while((v|0)!=(b|0));w=c[g>>2]|0}ACi(w);i=d;return}function MKc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+128|0;f=e+100|0;h=e+84|0;j=e+52|0;k=e+48|0;l=e+80|0;m=e+88|0;n=e+104|0;o=e+24|0;p=e+12|0;q=e+56|0;r=e+36|0;s=e+68|0;t=e;NXb(d,b+4|0,1);Ndd(d);NXb(d,b+16|0,1);Ndd(d);NXb(d,b+28|0,1);Ndd(d);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;NXb(d,m,1);Ndd(d);u=a[m>>0]|0;if(!(u&1)){v=m+1|0;w=(u&255)>>>1}else{v=c[m+8>>2]|0;w=c[m+4>>2]|0}rri(n,v,w);bWb(f,c[149480]|0,n);w=c[f>>2]|0;if((w|0)==((c[149480]|0)+4|0))x=0;else x=c[w+28>>2]|0;c[b+44>>2]=x;xri(n);if(a[m>>0]&1){n=c[m+8>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(n,f)};c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;NXb(d,o,1);Ndd(d);n=a[o>>0]|0;if(!(n&1)){y=o+1|0;z=(n&255)>>>1}else{y=c[o+8>>2]|0;z=c[o+4>>2]|0}rri(p,y,z);bWb(f,c[149480]|0,p);z=c[f>>2]|0;if((z|0)==((c[149480]|0)+4|0))A=0;else A=c[z+28>>2]|0;c[b+40>>2]=A;xri(p);if(a[o>>0]&1){p=c[o+8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(p,f)};c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;NXb(d,q,1);Ndd(d);p=a[q>>0]|0;if(!(p&1)){B=q+1|0;C=(p&255)>>>1}else{B=c[q+8>>2]|0;C=c[q+4>>2]|0}rri(r,B,C);bWb(f,c[149480]|0,r);C=c[f>>2]|0;if((C|0)==((c[149480]|0)+4|0))D=0;else D=c[C+28>>2]|0;c[b+52>>2]=D;xri(r);if(a[q>>0]&1){r=c[q+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(r,f)};c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;NXb(d,s,1);Ndd(d);r=a[s>>0]|0;if(!(r&1)){E=s+1|0;F=(r&255)>>>1}else{E=c[s+8>>2]|0;F=c[s+4>>2]|0}rri(t,E,F);bWb(f,c[149480]|0,t);F=c[f>>2]|0;if((F|0)==((c[149480]|0)+4|0))G=0;else G=c[F+28>>2]|0;c[b+48>>2]=G;xri(t);if(a[s>>0]&1){t=c[s+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(t,f)}f=b+76|0;t=d+12|0;h=c[t>>2]|0;s=h+4|0;G=d+20|0;F=c[G>>2]|0;if(s>>>0>F>>>0){Bid(t,f,4);H=c[t>>2]|0;I=c[G>>2]|0}else{g[f>>2]=ea(g[h>>2]);c[t>>2]=s;H=s;I=F}F=b+80|0;s=H+4|0;if(s>>>0>I>>>0){Bid(t,F,4);J=c[t>>2]|0;K=c[G>>2]|0}else{g[F>>2]=ea(g[H>>2]);c[t>>2]=s;J=s;K=I}I=b+84|0;s=J+4|0;if(s>>>0>K>>>0){Bid(t,I,4);L=c[t>>2]|0;M=c[G>>2]|0}else{g[I>>2]=ea(g[J>>2]);c[t>>2]=s;L=s;M=K}K=b+88|0;if((L+1|0)>>>0>M>>>0){Bid(t,K,1);N=c[t>>2]|0}else{a[K>>0]=a[L>>0]|0;L=(c[t>>2]|0)+1|0;c[t>>2]=L;N=L}L=b+89|0;if((N+1|0)>>>0>(c[G>>2]|0)>>>0)Bid(t,L,1);else{a[L>>0]=a[N>>0]|0;c[t>>2]=(c[t>>2]|0)+1}Ndd(d);d=b+60|0;N=c[t>>2]|0;L=N+4|0;K=c[G>>2]|0;if(L>>>0>K>>>0){Bid(t,d,4);O=c[t>>2]|0;P=c[G>>2]|0}else{c[d>>2]=c[N>>2];c[t>>2]=L;O=L;P=K}K=b+72|0;L=O+4|0;if(L>>>0>P>>>0){Bid(t,K,4);Q=c[t>>2]|0;R=c[G>>2]|0}else{c[K>>2]=c[O>>2];c[t>>2]=L;Q=L;R=P}P=b+56|0;b=Q+4|0;if(b>>>0>R>>>0){Bid(t,P,4);i=e;return}else{c[P>>2]=c[Q>>2];c[t>>2]=b;i=e;return}}function NKc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;e=i;i=i+128|0;f=e+100|0;h=e+84|0;j=e+52|0;l=e+48|0;m=e+80|0;n=e+88|0;o=e+104|0;p=e+24|0;q=e+12|0;r=e+56|0;s=e+36|0;t=e+68|0;u=e;OXb(d,b+4|0,1);Mdd(d);OXb(d,b+16|0,1);Mdd(d);OXb(d,b+28|0,1);Mdd(d);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;OXb(d,n,1);Mdd(d);v=a[n>>0]|0;if(!(v&1)){w=n+1|0;x=(v&255)>>>1}else{w=c[n+8>>2]|0;x=c[n+4>>2]|0}rri(o,w,x);bWb(f,c[149480]|0,o);x=c[f>>2]|0;if((x|0)==((c[149480]|0)+4|0))y=0;else y=c[x+28>>2]|0;c[b+44>>2]=y;xri(o);if(a[n>>0]&1){o=c[n+8>>2]|0;c[m>>2]=58;c[f+0>>2]=c[m+0>>2];eOb(o,f)};c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;OXb(d,p,1);Mdd(d);o=a[p>>0]|0;if(!(o&1)){z=p+1|0;A=(o&255)>>>1}else{z=c[p+8>>2]|0;A=c[p+4>>2]|0}rri(q,z,A);bWb(f,c[149480]|0,q);A=c[f>>2]|0;if((A|0)==((c[149480]|0)+4|0))B=0;else B=c[A+28>>2]|0;c[b+40>>2]=B;xri(q);if(a[p>>0]&1){q=c[p+8>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(q,f)};c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;OXb(d,r,1);Mdd(d);q=a[r>>0]|0;if(!(q&1)){C=r+1|0;D=(q&255)>>>1}else{C=c[r+8>>2]|0;D=c[r+4>>2]|0}rri(s,C,D);bWb(f,c[149480]|0,s);D=c[f>>2]|0;if((D|0)==((c[149480]|0)+4|0))E=0;else E=c[D+28>>2]|0;c[b+52>>2]=E;xri(s);if(a[r>>0]&1){s=c[r+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(s,f)};c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;OXb(d,t,1);Mdd(d);s=a[t>>0]|0;if(!(s&1)){F=t+1|0;G=(s&255)>>>1}else{F=c[t+8>>2]|0;G=c[t+4>>2]|0}rri(u,F,G);bWb(f,c[149480]|0,u);G=c[f>>2]|0;if((G|0)==((c[149480]|0)+4|0))H=0;else H=c[G+28>>2]|0;c[b+48>>2]=H;xri(u);if(a[t>>0]&1){u=c[t+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(u,f)}f=b+76|0;u=d+12|0;h=c[u>>2]|0;t=h+4|0;H=d+20|0;G=c[H>>2]|0;if(t>>>0>G>>>0){Bid(u,f,4);I=f;J=c[f>>2]|0;K=c[u>>2]|0;L=c[H>>2]|0}else{M=ea(g[h>>2]);g[f>>2]=M;c[u>>2]=t;I=f;J=(g[k>>2]=M,c[k>>2]|0);K=t;L=G}c[I>>2]=XEi(J|0)|0;J=b+80|0;I=K+4|0;if(I>>>0>L>>>0){Bid(u,J,4);N=J;O=c[J>>2]|0;P=c[u>>2]|0;Q=c[H>>2]|0}else{M=ea(g[K>>2]);g[J>>2]=M;c[u>>2]=I;N=J;O=(g[k>>2]=M,c[k>>2]|0);P=I;Q=L}c[N>>2]=XEi(O|0)|0;O=b+84|0;N=P+4|0;if(N>>>0>Q>>>0){Bid(u,O,4);R=O;S=c[O>>2]|0;T=c[u>>2]|0;U=c[H>>2]|0}else{M=ea(g[P>>2]);g[O>>2]=M;c[u>>2]=N;R=O;S=(g[k>>2]=M,c[k>>2]|0);T=N;U=Q}c[R>>2]=XEi(S|0)|0;S=b+88|0;if((T+1|0)>>>0>U>>>0){Bid(u,S,1);V=c[u>>2]|0}else{a[S>>0]=a[T>>0]|0;T=(c[u>>2]|0)+1|0;c[u>>2]=T;V=T}T=b+89|0;if((V+1|0)>>>0>(c[H>>2]|0)>>>0)Bid(u,T,1);else{a[T>>0]=a[V>>0]|0;c[u>>2]=(c[u>>2]|0)+1}Mdd(d);d=b+60|0;V=c[u>>2]|0;T=V+4|0;S=c[H>>2]|0;if(T>>>0>S>>>0){Bid(u,d,4);W=c[d>>2]|0;X=c[u>>2]|0;Y=c[H>>2]|0}else{U=c[V>>2]|0;c[d>>2]=U;c[u>>2]=T;W=U;X=T;Y=S}c[d>>2]=XEi(W|0)|0;W=b+72|0;d=X+4|0;if(d>>>0>Y>>>0){Bid(u,W,4);Z=c[W>>2]|0;_=c[u>>2]|0;$=c[H>>2]|0}else{H=c[X>>2]|0;c[W>>2]=H;c[u>>2]=d;Z=H;_=d;$=Y}c[W>>2]=XEi(Z|0)|0;Z=b+56|0;b=_+4|0;if(b>>>0>$>>>0){Bid(u,Z,4);aa=c[Z>>2]|0;ba=XEi(aa|0)|0;c[Z>>2]=ba;i=e;return}else{$=c[_>>2]|0;c[Z>>2]=$;c[u>>2]=b;aa=$;ba=XEi(aa|0)|0;c[Z>>2]=ba;i=e;return}}function OKc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+128|0;f=e+100|0;h=e+84|0;j=e+52|0;k=e+48|0;l=e+80|0;m=e+88|0;n=e+104|0;o=e+24|0;p=e+12|0;q=e+56|0;r=e+36|0;s=e+68|0;t=e;rdd(d,3);u=b+4|0;v=c[142294]|0;w=qdd(d,2487248,v,f,0)|0;if(w){if((w|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](u,d)|0}else zXb(d,u,1);sdd(d)}u=b+16|0;w=qdd(d,600240,v,f,0)|0;if(w){if((w|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](u,d)|0}else zXb(d,u,1);sdd(d)}u=b+28|0;w=qdd(d,600256,v,f,0)|0;if(w){if((w|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](u,d)|0}else zXb(d,u,1);sdd(d)};c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;u=qdd(d,600280,v,f,0)|0;if(u){if((u|0)<=0){u=c[f>>2]|0;if(u)_n[u&4095](m,d)|0}else zXb(d,m,1);sdd(d)}u=d+136|0;if(a[u>>0]|0){w=a[m>>0]|0;if(!(w&1)){x=m+1|0;y=(w&255)>>>1}else{x=c[m+8>>2]|0;y=c[m+4>>2]|0}rri(n,x,y);bWb(f,c[149480]|0,n);y=c[f>>2]|0;if((y|0)==((c[149480]|0)+4|0))z=0;else z=c[y+28>>2]|0;c[b+44>>2]=z;xri(n)}if(a[m>>0]&1){n=c[m+8>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(n,f)};c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;n=qdd(d,600296,v,f,0)|0;if(n){if((n|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](o,d)|0}else zXb(d,o,1);sdd(d)}if(a[u>>0]|0){n=a[o>>0]|0;if(!(n&1)){A=o+1|0;B=(n&255)>>>1}else{A=c[o+8>>2]|0;B=c[o+4>>2]|0}rri(p,A,B);bWb(f,c[149480]|0,p);B=c[f>>2]|0;if((B|0)==((c[149480]|0)+4|0))C=0;else C=c[B+28>>2]|0;c[b+40>>2]=C;xri(p)}if(a[o>>0]&1){p=c[o+8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(p,f)};c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;p=qdd(d,600312,v,f,0)|0;if(p){if((p|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](q,d)|0}else zXb(d,q,1);sdd(d)}if(a[u>>0]|0){p=a[q>>0]|0;if(!(p&1)){D=q+1|0;E=(p&255)>>>1}else{D=c[q+8>>2]|0;E=c[q+4>>2]|0}rri(r,D,E);bWb(f,c[149480]|0,r);E=c[f>>2]|0;if((E|0)==((c[149480]|0)+4|0))F=0;else F=c[E+28>>2]|0;c[b+52>>2]=F;xri(r)}if(a[q>>0]&1){r=c[q+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(r,f)};c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;r=qdd(d,600336,v,f,0)|0;if(r){if((r|0)<=0){r=c[f>>2]|0;if(r)_n[r&4095](s,d)|0}else zXb(d,s,1);sdd(d)}if(a[u>>0]|0){u=a[s>>0]|0;if(!(u&1)){G=s+1|0;H=(u&255)>>>1}else{G=c[s+8>>2]|0;H=c[s+4>>2]|0}rri(t,G,H);bWb(f,c[149480]|0,t);H=c[f>>2]|0;if((H|0)==((c[149480]|0)+4|0))I=0;else I=c[H+28>>2]|0;c[b+48>>2]=I;xri(t)}if(a[s>>0]&1){t=c[s+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(t,f)}t=b+76|0;h=c[142268]|0;s=qdd(d,600360,h,f,0)|0;if(s){do if((s|0)<=0){I=c[f>>2]|0;if(I)_n[I&4095](t,d)|0}else{I=d+12|0;H=c[d+16>>2]|0;G=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;u=H+G|0;c[I>>2]=u;do if((G|0)<0)J=84;else{r=H+(G+4)|0;if(r>>>0>(c[d+20>>2]|0)>>>0){J=84;break}g[t>>2]=ea(g[u>>2]);c[I>>2]=r}while(0);if((J|0)==84)Bid(I,t,4);if(!(c[d>>2]&512))break;c[t>>2]=XEi(c[t>>2]|0)|0}while(0);sdd(d)}t=b+80|0;s=qdd(d,600368,h,f,0)|0;if(s){do if((s|0)>0){u=d+12|0;G=c[d+16>>2]|0;H=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=G+H|0;c[u>>2]=r;do if((H|0)<0)J=95;else{v=G+(H+4)|0;if(v>>>0>(c[d+20>>2]|0)>>>0){J=95;break}g[t>>2]=ea(g[r>>2]);c[u>>2]=v}while(0);if((J|0)==95)Bid(u,t,4);if(!(c[d>>2]&512))break;c[t>>2]=XEi(c[t>>2]|0)|0}else{r=c[f>>2]|0;if(!r)break;_n[r&4095](t,d)|0}while(0);sdd(d)}t=b+84|0;s=qdd(d,600376,h,f,0)|0;if(s){do if((s|0)>0){h=d+12|0;r=c[d+16>>2]|0;H=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;G=r+H|0;c[h>>2]=G;do if((H|0)<0)J=106;else{I=r+(H+4)|0;if(I>>>0>(c[d+20>>2]|0)>>>0){J=106;break}g[t>>2]=ea(g[G>>2]);c[h>>2]=I}while(0);if((J|0)==106)Bid(h,t,4);if(!(c[d>>2]&512))break;c[t>>2]=XEi(c[t>>2]|0)|0}else{G=c[f>>2]|0;if(!G)break;_n[G&4095](t,d)|0}while(0);sdd(d)}t=b+88|0;s=c[142258]|0;G=qdd(d,600392,s,f,0)|0;if(G){a:do if((G|0)>0){H=d+12|0;r=c[d+16>>2]|0;u=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;I=r+u|0;c[H>>2]=I;do if((u|0)>=0){if((r+(u+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[t>>0]=a[I>>0]|0;c[H>>2]=(c[H>>2]|0)+1;break a}while(0);Bid(H,t,1)}else{I=c[f>>2]|0;if(!I)break;_n[I&4095](t,d)|0}while(0);sdd(d)}t=b+89|0;G=qdd(d,600400,s,f,0)|0;if(G){b:do if((G|0)>0){s=d+12|0;I=c[d+16>>2]|0;u=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=I+u|0;c[s>>2]=r;do if((u|0)>=0){if((I+(u+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[t>>0]=a[r>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break b}while(0);Bid(s,t,1)}else{r=c[f>>2]|0;if(!r)break;_n[r&4095](t,d)|0}while(0);sdd(d)}t=b+60|0;G=c[142270]|0;r=qdd(d,3144960,G,f,0)|0;if(r){do if((r|0)>0){u=d+12|0;I=c[d+16>>2]|0;H=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;h=I+H|0;c[u>>2]=h;do if((H|0)<0)J=135;else{v=I+(H+4)|0;if(v>>>0>(c[d+20>>2]|0)>>>0){J=135;break}c[t>>2]=c[h>>2];c[u>>2]=v}while(0);if((J|0)==135)Bid(u,t,4);if(!(c[d>>2]&512))break;c[t>>2]=XEi(c[t>>2]|0)|0}else{h=c[f>>2]|0;if(!h)break;_n[h&4095](t,d)|0}while(0);sdd(d)}t=b+72|0;r=qdd(d,600408,G,f,0)|0;if(r){do if((r|0)>0){h=d+12|0;H=c[d+16>>2]|0;I=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=H+I|0;c[h>>2]=s;do if((I|0)<0)J=146;else{v=H+(I+4)|0;if(v>>>0>(c[d+20>>2]|0)>>>0){J=146;break}c[t>>2]=c[s>>2];c[h>>2]=v}while(0);if((J|0)==146)Bid(h,t,4);if(!(c[d>>2]&512))break;c[t>>2]=XEi(c[t>>2]|0)|0}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](t,d)|0}while(0);sdd(d)}t=b+56|0;b=qdd(d,600416,G,f,0)|0;if(!b){i=e;return}do if((b|0)>0){G=d+12|0;r=c[d+16>>2]|0;s=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;I=r+s|0;c[G>>2]=I;do if((s|0)<0)J=157;else{H=r+(s+4)|0;if(H>>>0>(c[d+20>>2]|0)>>>0){J=157;break}c[t>>2]=c[I>>2];c[G>>2]=H}while(0);if((J|0)==157)Bid(G,t,4);if(!(c[d>>2]&512))break;c[t>>2]=XEi(c[t>>2]|0)|0}else{I=c[f>>2]|0;if(!I)break;_n[I&4095](t,d)|0}while(0);sdd(d);i=e;return}function PKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((((c[e>>2]|0)-g|0)/92|0)>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b*92|0)|0;l=k+(((j-g|0)/92|0)*92|0)|0;g=k+(b*92|0)|0;if((j|0)!=(f|0)){b=j;j=l;while(1){k=j+-92|0;b=b+-92|0;FKc(k,b);if((b|0)==(f|0)){m=k;break}else j=k}j=c[a>>2]|0;b=c[h>>2]|0;c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;if((b|0)==(j|0))n=j;else{m=b;do{m=m+-92|0;EKc(m)}while((m|0)!=(j|0));n=j}}else{c[a>>2]=l;c[h>>2]=l;c[e>>2]=g;n=f}if(!n){i=d;return}ACi(n);i=d;return}function QKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[b>>2]|0;g=c[d>>2]|0;h=f;j=(g-h|0)/92|0;k=a+8|0;l=c[k>>2]|0;m=c[a>>2]|0;n=m;if(j>>>0>((l-n|0)/92|0)>>>0){if(!m)o=l;else{l=a+4|0;p=c[l>>2]|0;if((p|0)==(m|0))q=m;else{r=p;do{p=r+-92|0;c[l>>2]=p;EKc(p);r=c[l>>2]|0}while((r|0)!=(m|0));q=c[a>>2]|0}ACi(q);c[k>>2]=0;c[l>>2]=0;c[a>>2]=0;o=0}if(j>>>0>46684427)vxi(a);l=(o-0|0)/92|0;if(l>>>0<23342213){o=l<<1;l=o>>>0<j>>>0?j:o;if(l>>>0>46684427)vxi(a);else s=l}else s=46684427;l=xCi(s*92|0)|0;o=a+4|0;c[o>>2]=l;c[a>>2]=l;c[k>>2]=l+(s*92|0);s=c[b>>2]|0;b=c[d>>2]|0;if((s|0)==(b|0)){i=e;return}else{t=l;u=s}do{FKc(t,u);t=(c[o>>2]|0)+92|0;c[o>>2]=t;u=u+92|0}while((u|0)!=(b|0));i=e;return}b=a+4|0;a=((c[b>>2]|0)-n|0)/92|0;if(j>>>0>a>>>0){v=f+(a*92|0)|0;w=1}else{v=g;w=0}if((f|0)==(v|0))x=m;else{a=((v+-92-h|0)>>>0)/92|0;h=m;j=f;while(1){TKc(h,j)|0;j=j+92|0;if((j|0)==(v|0))break;else h=h+92|0}x=m+((a+1|0)*92|0)|0}if(!w){w=c[b>>2]|0;if((w|0)==(x|0)){i=e;return}else y=w;do{w=y+-92|0;c[b>>2]=w;EKc(w);y=c[b>>2]|0}while((y|0)!=(x|0));i=e;return}if((v|0)==(g|0)){i=e;return}x=c[b>>2]|0;y=v;do{if(!x)z=0;else{FKc(x,y);z=c[b>>2]|0}x=z+92|0;c[b>>2]=x;y=y+92|0}while((y|0)!=(g|0));i=e;return}function RKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(((f-j|0)/92|0)>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{OJc(l);m=c[g>>2]|0}l=m+92|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=((j-k|0)/92|0)+b|0;if(l>>>0>46684427)vxi(a);j=k;k=(f-j|0)/92|0;if(k>>>0<23342213){f=k<<1;k=f>>>0<l>>>0?l:f;f=((c[g>>2]|0)-j|0)/92|0;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=46684427;r=((c[g>>2]|0)-j|0)/92|0;s=10}if((s|0)==10){n=q;o=xCi(q*92|0)|0;p=r}r=o+(p*92|0)|0;p=o+(n*92|0)|0;n=b;b=r;while(1){if(!b)t=0;else{OJc(b);t=b}o=t+92|0;n=n+-1|0;if(!n){u=o;break}else b=o}b=c[a>>2]|0;n=c[g>>2]|0;if((n|0)!=(b|0)){t=n;n=r;while(1){o=n+-92|0;t=t+-92|0;FKc(o,t);if((t|0)==(b|0)){v=o;break}else n=o}n=c[a>>2]|0;t=c[g>>2]|0;c[a>>2]=v;c[g>>2]=u;c[e>>2]=p;if((t|0)==(n|0))w=n;else{v=t;do{v=v+-92|0;EKc(v)}while((v|0)!=(n|0));w=n}}else{c[a>>2]=r;c[g>>2]=u;c[e>>2]=p;w=b}if(!w){i=d;return}ACi(w);i=d;return}function SKc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;g=a+8|0;c[g>>2]=0;h=c[b>>2]|0;b=c[d>>2]|0;d=b-h|0;j=(d|0)/92|0;if((b|0)==(h|0)){i=f;return}if(j>>>0>46684427)vxi(a);k=xCi(d)|0;c[e>>2]=k;c[a>>2]=k;c[g>>2]=k+(j*92|0);j=k;k=h;do{FKc(j,k);j=(c[e>>2]|0)+92|0;c[e>>2]=j;k=k+92|0}while((k|0)!=(b|0));i=f;return}function TKc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=d+4|0;h=e+4|0;j=(d|0)==(e|0);do if(!j){k=a[h>>0]|0;if(!(k&1)){l=(k&255)>>>1;m=h+1|0}else{l=c[e+8>>2]|0;m=c[e+12>>2]|0}k=a[g>>0]|0;if(!(k&1)){n=10;o=k}else{k=c[g>>2]|0;n=(k&-2)+-1|0;o=k&255}k=(o&1)==0;do if(l>>>0<=n>>>0){if(k)p=g+1|0;else p=c[d+12>>2]|0;aFi(p|0,m|0,l|0)|0;a[p+l>>0]=0;if(!(a[g>>0]&1)){a[g>>0]=l<<1;break}else{c[d+8>>2]=l;break}}else{if(k)q=(o&255)>>>1;else q=c[d+8>>2]|0;eXb(g,n,l-n|0,q,0,q,l,m)}while(0);k=d+16|0;r=e+16|0;if(!j){s=a[r>>0]|0;if(!(s&1)){t=(s&255)>>>1;u=r+1|0}else{t=c[e+20>>2]|0;u=c[e+24>>2]|0}r=a[k>>0]|0;if(!(r&1)){v=10;w=r}else{r=c[k>>2]|0;v=(r&-2)+-1|0;w=r&255}r=(w&1)==0;do if(t>>>0<=v>>>0){if(r)x=k+1|0;else x=c[d+24>>2]|0;aFi(x|0,u|0,t|0)|0;a[x+t>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=t<<1;break}else{c[d+20>>2]=t;break}}else{if(r)y=(w&255)>>>1;else y=c[d+20>>2]|0;eXb(k,v,t-v|0,y,0,y,t,u)}while(0);k=d+28|0;r=e+28|0;if(!j){s=a[r>>0]|0;if(!(s&1)){z=(s&255)>>>1;A=r+1|0}else{z=c[e+32>>2]|0;A=c[e+36>>2]|0}r=a[k>>0]|0;if(!(r&1)){B=10;C=r}else{r=c[k>>2]|0;B=(r&-2)+-1|0;C=r&255}r=(C&1)==0;if(z>>>0>B>>>0){if(r)D=(C&255)>>>1;else D=c[d+32>>2]|0;eXb(k,B,z-B|0,D,0,D,z,A);break}if(r)E=k+1|0;else E=c[d+36>>2]|0;aFi(E|0,A|0,z|0)|0;a[E+z>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=z<<1;break}else{c[d+32>>2]=z;break}}}}while(0);z=d+40|0;E=e+40|0;e=z+0|0;A=E+0|0;D=e+48|0;do{c[e>>2]=c[A>>2];e=e+4|0;A=A+4|0}while((e|0)<(D|0));b[z+48>>1]=b[E+48>>1]|0;i=f;return d|0}function UKc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=Im,n=Im,o=0.0;f=i;i=i+16|0;j=f+4|0;k=f;c[k>>2]=c[d>>2];c[j+0>>2]=c[k+0>>2];jSb(b,j,e);c[b>>2]=600448;e=b+56|0;c[b+132>>2]=0;a[b+184>>0]=0;a[b+185>>0]=0;j=b+40|0;k=b+188|0;d=b+24|0;l=d+96|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(l|0));g[k>>2]=ea(1.0);g[j>>2]=ea(.0199999996);g[b+192>>2]=ea(.333333343);h[b+200>>3]=0.0;c[b+208>>2]=-1;c[b+212>>2]=0;k=oVb()|0;d=b+88|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;m=k?ea(.0199999996):ea(0.0);n=k?ea(50.0):ea(0.0);g[b+72>>2]=m;g[b+84>>2]=n;g[b+76>>2]=ea(0.0);g[b+80>>2]=ea(0.0);k=b+24|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[b+52>>2]=ea(ea(1.0)/ea(g[j>>2]));c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];a[b+120>>0]=1;a[b+121>>0]=1;a[b+122>>0]=1;c[b+124>>2]=0;c[b+128>>2]=0;o=+Ype();h[b+144>>3]=o;h[b+152>>3]=o;e=b+160|0;c[b+136>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;i=f;return}function VKc(b,c){b=b|0;c=c|0;a[b+121>>0]=1;return}function WKc(b){b=b|0;var d=0,e=0,f=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=Im,r=Im,s=Im,t=Im,u=0;d=i;e=b+124|0;c[e>>2]=(c[e>>2]|0)+1;e=b+128|0;c[e>>2]=(c[e>>2]|0)+1;if(a[b+184>>0]|0){i=d;return}f=+Ype();j=f-+h[b+152>>3];e=b+168|0;h[b+176>>3]=j-+h[e>>3];h[e>>3]=j;e=b+144|0;j=f-+h[e>>3];k=c[b+136>>2]|0;do if((k|0)<=0){l=b+120|0;if(a[l>>0]|0){a[l>>0]=0;i=d;return}m=+h[b+56>>3];if(a[b+121>>0]|0){n=m;o=m+ +ea(ea(g[b+188>>2])*ea(.0199999996));break}p=j-m;q=ea(g[b+192>>2]);if(p>+q){n=m;o=m+ +ea(q*ea(g[b+188>>2]));break}q=ea(g[b+188>>2]);if(p<9.999999747378752e-06){n=m;o=m+ +ea(q*ea(9.99999974e-06));break}r=ea(q+ea(-1.0));if(r<ea(0.0))s=ea(-r);else s=r;if(!(s<=ea(9.99999997e-07))){n=m;o=m+ +ea(q*ea(p))}else{n=m;o=j}}else{m=+h[b+56>>3];q=ea(ea(1.0)/ea(k|0));n=m;o=m+ +ea(q*ea(g[b+188>>2]))}while(0);k=b+56|0;h[b+64>>3]=n;h[k>>3]=o;s=ea(o-n);g[b+72>>2]=s;if(s>ea(9.99999974e-06))t=ea(ea(1.0)/s);else t=ea(1.0);g[b+84>>2]=t;l=b+80|0;t=ea(ea(ea(g[l>>2])*ea(.800000011))+ea(.200000003));g[l>>2]=t;q=ea(ea(.200000003)/t);u=b+76|0;g[u>>2]=ea(ea(ea(ea(1.0)-q)*ea(g[u>>2]))+ea(q*s));u=b+88|0;c[u+0>>2]=c[k+0>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];c[u+12>>2]=c[k+12>>2];c[u+16>>2]=c[k+16>>2];c[u+20>>2]=c[k+20>>2];c[u+24>>2]=c[k+24>>2];c[u+28>>2]=c[k+28>>2];h[e>>3]=f-o;e=b+121|0;if(!(a[e>>0]|0)){i=d;return}a[e>>0]=0;g[l>>2]=ea(0.0);i=d;return}function XKc(b){b=b|0;var d=0,e=0,f=0.0,j=0.0,k=0,l=0,m=0,n=0,o=0;d=i;e=b+24|0;f=+h[e>>3];j=f+ +ea(g[b+40>>2]);k=b+56|0;l=a[b+122>>0]|0;do if(!(j>+h[k>>3])){h[b+32>>3]=f;m=b+122|0;if(!(l<<24>>24)){h[e>>3]=j;n=m}else n=m}else{if(l<<24>>24){h[b+32>>3]=f;n=b+122|0;break}m=b+88|0;c[m+0>>2]=c[k+0>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];c[m+12>>2]=c[k+12>>2];c[m+16>>2]=c[k+16>>2];c[m+20>>2]=c[k+20>>2];c[m+24>>2]=c[k+24>>2];c[m+28>>2]=c[k+28>>2];a[b+185>>0]=0;o=0;i=d;return o|0}while(0);k=b+88|0;c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[k+16>>2]=c[e+16>>2];c[k+20>>2]=c[e+20>>2];c[k+24>>2]=c[e+24>>2];c[k+28>>2]=c[e+28>>2];a[b+185>>0]=1;a[n>>0]=0;o=1;i=d;return o|0}function YKc(a,b){a=a|0;b=b|0;var c=Im;c=ea(g[a+40>>2]);g[a+52>>2]=ea(ea(1.0)/c);g[a+44>>2]=c;return}function ZKc(a){a=a|0;var b=0,c=Im,d=Im,e=0;b=a+40|0;c=ea(g[b>>2]);if(c<ea(.0000999999974))d=ea(.0000999999974);else{e=c>ea(10.0);d=e?ea(10.0):c}g[b>>2]=d;b=a+192|0;c=ea(g[b>>2]);g[b>>2]=c<d?d:c;return}function _Kc(b){b=b|0;h[b+160>>3]=-+h[b+56>>3];a[b+120>>0]=1;a[b+121>>0]=1;return}function $Kc(a){a=a|0;var b=0,c=0.0;b=i;c=+Ype();i=b;return +(c-+h[a+152>>3])}function aLc(){var a=0;a=i;QQb(5,151,0,0,0);i=a;return}function bLc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,600552,11);wQb(5,6,b,216,2630,0,0);xri(b);i=a;return}function cLc(a){a=a|0;return 5}function dLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;add(b,792072,600552,a,0);KSb(a,b);e=c[142268]|0;add(b,600568,e,a+40|0,2048);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,600584,e,a+192|0,2048);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,600616,e,a+188|0,2048);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);i=d;return}function eLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,600552,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else lLc(a,b);sdd(b);i=d;return}function fLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;MSb(a,b);e=a+40|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;k=b+20|0;b=c[k>>2]|0;if(j>>>0>b>>>0){Bid(f,e,4);l=c[f>>2]|0;m=c[k>>2]|0}else{g[e>>2]=ea(g[h>>2]);c[f>>2]=j;l=j;m=b}b=a+192|0;j=l+4|0;if(j>>>0>m>>>0){Bid(f,b,4);n=c[f>>2]|0;o=c[k>>2]|0}else{g[b>>2]=ea(g[l>>2]);c[f>>2]=j;n=j;o=m}m=a+188|0;a=n+4|0;if(a>>>0>o>>>0){Bid(f,m,4);i=d;return}else{g[m>>2]=ea(g[n>>2]);c[f>>2]=a;i=d;return}}function gLc(a,b){a=a|0;b=b|0;var c=0;c=i;mLc(a,b);i=c;return}function hLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;OSb(a,b);e=a+40|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;k=b+20|0;b=c[k>>2]|0;if(j>>>0<b>>>0){g[h>>2]=ea(g[e>>2]);c[f>>2]=j;l=j;m=b}else{Gid(f,e,4);l=c[f>>2]|0;m=c[k>>2]|0}e=a+192|0;b=l+4|0;if(b>>>0<m>>>0){g[l>>2]=ea(g[e>>2]);c[f>>2]=b;n=b;o=m}else{Gid(f,e,4);n=c[f>>2]|0;o=c[k>>2]|0}k=a+188|0;a=n+4|0;if(a>>>0<o>>>0){g[n>>2]=ea(g[k>>2]);c[f>>2]=a;i=d;return}else{Gid(f,k,4);i=d;return}}function iLc(a,b){a=a|0;b=b|0;var c=0;c=i;PSb(a,b);i=c;return}function jLc(){var a=0,b=0;a=i;b=rVb(7)|0;i=a;return b|0}function kLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(216,e,1,16,3653512,46)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];UKc(f,e,b);i=d;return f|0}function lLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;LSb(a,b);f=a+40|0;h=c[142268]|0;j=qdd(b,600568,h,e,0)|0;if(j){if((j|0)>0){j=b+12|0;k=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[f>>2]=ea(g[m>>2]);c[j>>2]=n}else Bid(j,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](f,b)|0}sdd(b)}f=a+192|0;j=qdd(b,600584,h,e,0)|0;if(j){if((j|0)>0){j=b+12|0;n=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=n+m|0;c[j>>2]=l;if((m|0)>=0?(k=n+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[f>>2]=ea(g[l>>2]);c[j>>2]=k}else Bid(j,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{j=c[e>>2]|0;if(j)_n[j&4095](f,b)|0}sdd(b)}f=a+188|0;a=qdd(b,600616,h,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[a>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[f>>2]=ea(g[k>>2]);c[a>>2]=l}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function mLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;NSb(a,b);e=a+40|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;l=b+20|0;b=c[l>>2]|0;if(j>>>0>b>>>0){Bid(f,e,4);m=e;n=c[f>>2]|0;o=c[l>>2]|0;p=c[e>>2]|0}else{q=ea(g[h>>2]);g[e>>2]=q;c[f>>2]=j;m=e;n=j;o=b;p=(g[k>>2]=q,c[k>>2]|0)}c[m>>2]=XEi(p|0)|0;p=a+192|0;m=n+4|0;if(m>>>0>o>>>0){Bid(f,p,4);r=p;s=c[p>>2]|0;t=c[f>>2]|0;u=c[l>>2]|0}else{q=ea(g[n>>2]);g[p>>2]=q;c[f>>2]=m;r=p;s=(g[k>>2]=q,c[k>>2]|0);t=m;u=o}c[r>>2]=XEi(s|0)|0;s=a+188|0;a=t+4|0;if(a>>>0>u>>>0){Bid(f,s,4);v=s;w=c[s>>2]|0;x=XEi(w|0)|0;c[v>>2]=x;i=d;return}else{q=ea(g[t>>2]);g[s>>2]=q;c[f>>2]=a;v=s;w=(g[k>>2]=q,c[k>>2]|0);x=XEi(w|0)|0;c[v>>2]=x;i=d;return}}function nLc(a){a=a|0;var b=0;b=i;c[a>>2]=600448;ZSb(a);i=b;return}function oLc(a){a=a|0;var b=0;b=i;c[a>>2]=600448;ZSb(a);ACi(a);i=b;return}function pLc(){return c[150160]|0}function qLc(a){a=a|0;c[150160]=a;return}function rLc(){return 0}function sLc(){return 0}function tLc(){return c[150162]|0}function uLc(a){a=a|0;c[150162]=a;return}function vLc(){return c[150164]|0}function wLc(a){a=a|0;c[150164]=a;return}function xLc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0;e=i;i=i+32|0;f=e;h=ea(g[a+16>>2]);j=ea(g[a+4>>2]);k=ea(h-j);h=ea(g[a+20>>2]);l=ea(g[a+8>>2]);m=ea(h-l);h=ea(g[a+24>>2]);n=ea(g[a+12>>2]);o=ea(k*ea(.5));k=ea(m*ea(.5));m=ea(ea(h-n)*ea(.5));h=ea(j+o);j=ea(l+k);l=ea(n+m);if(o<ea(0.0))p=ea(-o);else p=o;if(k<ea(0.0))q=ea(-k);else q=k;if(m<ea(0.0))r=ea(-m);else r=m;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;g[f>>2]=h;g[f+4>>2]=j;g[f+8>>2]=l;g[f+12>>2]=p;g[f+16>>2]=q;g[f+20>>2]=r;if(!d){s=0;i=e;return s|0}else t=0;while(1){if(lmc(f,b+(t*24|0)|0)|0){s=1;u=10;break}t=t+1|0;if(t>>>0>=d>>>0){s=0;u=10;break}}if((u|0)==10){i=e;return s|0}return 0}function yLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;d=i;e=a+12|0;f=a+16|0;h=a+20|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+0>>2]=c[150280];c[a+4>>2]=c[150281];c[a+8>>2]=c[150282];j=ea(-ea(g[150280]));k=ea(-ea(g[150281]));l=ea(-ea(g[150282]));g[e>>2]=j;g[f>>2]=k;g[h>>2]=l;m=c[b+8>>2]|0;if(!m){i=d;return}n=c[b>>2]|0;b=a+4|0;o=a+8|0;p=ea(g[a>>2]);q=ea(g[b>>2]);r=p;p=q;q=ea(g[o>>2]);s=j;j=k;k=l;t=0;while(1){l=ea(g[n+(t*28|0)+4>>2]);u=l<r?l:r;v=ea(g[n+(t*28|0)+8>>2]);w=v<p?v:p;x=ea(g[n+(t*28|0)+12>>2]);y=x<q?x:q;z=s<l?l:s;l=j<v?v:j;v=k<x?x:k;x=ea(g[n+(t*28|0)+16>>2]);A=x<u?x:u;u=ea(g[n+(t*28|0)+20>>2]);B=u<w?u:w;w=ea(g[n+(t*28|0)+24>>2]);C=w<y?w:y;y=z<x?x:z;z=l<u?u:l;l=v<w?w:v;t=t+1|0;if(t>>>0>=m>>>0){D=A;E=B;F=C;G=y;H=z;I=l;break}else{r=A;p=B;q=C;s=y;j=z;k=l}}g[a>>2]=D;g[b>>2]=E;g[o>>2]=F;g[e>>2]=G;g[f>>2]=H;g[h>>2]=I;i=d;return}function zLc(){return c[150166]|0}function ALc(a){a=a|0;c[150166]=a;return}function BLc(){return c[150168]|0}function CLc(a){a=a|0;c[150168]=a;return}function DLc(){return 0}function ELc(){return c[150170]|0}function FLc(a){a=a|0;c[150170]=a;return}function GLc(){return 0}function HLc(){return 0}function ILc(){return 0}function JLc(){var a=0;a=i;pl(0)|0;i=a;return}function KLc(){var a=0,b=0;a=i;if(!(qSc()|0)){b=-1;i=a;return b|0}b=vSc(rSc()|0)|0;i=a;return b|0}function LLc(){return}function MLc(d){d=d|0;var e=0,f=0,g=0;a[d+64>>0]=2;a[d+65>>0]=2;c[d+4>>2]=-1;c[d>>2]=-1;b[d+48>>1]=0;b[d+32>>1]=0;b[d+50>>1]=-1;b[d+34>>1]=-1;e=d+36|0;f=d+52|0;g=d+8|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;b[e+0>>1]=0;b[e+2>>1]=0;b[e+4>>1]=0;b[e+6>>1]=0;b[e+8>>1]=0;b[e+10>>1]=0;b[f+0>>1]=0;b[f+2>>1]=0;b[f+4>>1]=0;b[f+6>>1]=0;b[f+8>>1]=0;b[f+10>>1]=0;return}function NLc(a){a=a|0;return}function OLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[142262]|0;f=c[142304]|0;g=b+12|0;h=b+20|0;j=0;do{k=a+(j<<2)|0;add(b,c[600976+(j<<2)>>2]|0,e,k,1);ddd(b,2);add(b,614656,f,k,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);j=j+1|0}while((j|0)!=8);j=c[142296]|0;f=0;do{add(b,c[600816+(f<<2)>>2]|0,j,a+(f<<1)+32|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=2;bdd(b);f=f+1|0}while((f|0)!=8);l=0;do{add(b,c[600912+(l<<2)>>2]|0,j,a+(l<<1)+48|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=2;bdd(b);l=l+1|0}while((l|0)!=8);l=c[142302]|0;add(b,600944,l,a+64|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,600960,l,a+65|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function PLc(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+16|0;h=g+4|0;j=g;k=c[142262]|0;l=c[142304]|0;m=f+12|0;n=f+80|0;o=f+16|0;p=f+28|0;q=f+32|0;r=f+20|0;s=0;do{t=e+(s<<2)|0;u=qdd(f,c[600976+(s<<2)>>2]|0,k,j,1)|0;if(u){if((u|0)>0){rdd(f,2);u=(c[f>>2]&512|0)==0;v=qdd(f,614656,l,h,0)|0;if(v){if((v|0)>0){v=c[o>>2]|0;w=(c[(c[n>>2]|0)+12>>2]|0)-(da(c[q>>2]|0,c[p>>2]|0)|0)|0;x=v+w|0;c[m>>2]=x;if((w|0)>=0?(y=v+(w+4)|0,y>>>0<=(c[r>>2]|0)>>>0):0){c[t>>2]=c[x>>2];c[m>>2]=y}else Bid(m,t,4);if(c[f>>2]&512)c[t>>2]=XEi(c[t>>2]|0)|0}else{y=c[h>>2]|0;if(y)_n[y&4095](t,f)|0}sdd(f)}if(!u)c[t>>2]=XEi(c[t>>2]|0)|0}else{u=c[j>>2]|0;if(u)_n[u&4095](t,f)|0}sdd(f)}s=s+1|0}while((s|0)!=8);s=e+32|0;AUb(f,s,600752,1);j=e+34|0;AUb(f,j,600760,1);AUb(f,e+36|0,600768,1);AUb(f,e+38|0,600776,1);AUb(f,e+40|0,600784,1);AUb(f,e+42|0,600792,1);AUb(f,e+44|0,600800,1);AUb(f,e+46|0,600808,1);l=e+48|0;AUb(f,l,600848,1);k=e+50|0;AUb(f,k,600856,1);AUb(f,e+52|0,600864,1);AUb(f,e+54|0,600872,1);AUb(f,e+56|0,600880,1);AUb(f,e+58|0,600888,1);AUb(f,e+60|0,600896,1);AUb(f,e+62|0,600904,1);t=e+64|0;u=c[142302]|0;y=qdd(f,600944,u,h,0)|0;if(y){do if((y|0)<=0){x=c[h>>2]|0;if(x)_n[x&4095](t,f)|0}else{x=c[o>>2]|0;w=(c[(c[n>>2]|0)+12>>2]|0)-(da(c[q>>2]|0,c[p>>2]|0)|0)|0;v=x+w|0;c[m>>2]=v;if((w|0)>=0?(x+(w+1)|0)>>>0<=(c[r>>2]|0)>>>0:0){a[t>>0]=a[v>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,t,1)}while(0);sdd(f)}y=e+65|0;v=qdd(f,600960,u,h,0)|0;if(v){do if((v|0)<=0){u=c[h>>2]|0;if(u)_n[u&4095](y,f)|0}else{u=c[o>>2]|0;w=(c[(c[n>>2]|0)+12>>2]|0)-(da(c[q>>2]|0,c[p>>2]|0)|0)|0;x=u+w|0;c[m>>2]=x;if((w|0)>=0?(u+(w+1)|0)>>>0<=(c[r>>2]|0)>>>0:0){a[y>>0]=a[x>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,y,1)}while(0);sdd(f)}if((d[t>>0]|0)<2){a[t>>0]=2;t=e+4|0;a[t>>0]=a[e>>0]|0;a[t+1>>0]=a[e+1>>0]|0;a[t+2>>0]=a[e+2>>0]|0;b[s>>1]=0;b[j>>1]=-1}if((d[y>>0]|0)>=2){i=g;return}a[y>>0]=2;a[e+7>>0]=a[e+3>>0]|0;b[l>>1]=0;b[k>>1]=-1;i=g;return}function QLc(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;g=i;h=f+12|0;j=f+20|0;k=c[h>>2]|0;l=k+4|0;m=c[j>>2]|0;if(l>>>0>m>>>0){Bid(h,e,4);n=c[j>>2]|0;o=c[h>>2]|0}else{c[e>>2]=c[k>>2];c[h>>2]=l;n=m;o=l}l=e+4|0;m=o+4|0;if(m>>>0>n>>>0){Bid(h,l,4);p=c[h>>2]|0;q=c[j>>2]|0}else{c[l>>2]=c[o>>2];c[h>>2]=m;p=m;q=n}n=e+8|0;m=p+4|0;if(m>>>0>q>>>0){Bid(h,n,4);r=c[h>>2]|0;s=c[j>>2]|0}else{c[n>>2]=c[p>>2];c[h>>2]=m;r=m;s=q}q=e+12|0;m=r+4|0;if(m>>>0>s>>>0){Bid(h,q,4);t=c[h>>2]|0;u=c[j>>2]|0}else{c[q>>2]=c[r>>2];c[h>>2]=m;t=m;u=s}s=e+16|0;m=t+4|0;if(m>>>0>u>>>0){Bid(h,s,4);v=c[h>>2]|0;w=c[j>>2]|0}else{c[s>>2]=c[t>>2];c[h>>2]=m;v=m;w=u}u=e+20|0;m=v+4|0;if(m>>>0>w>>>0){Bid(h,u,4);x=c[h>>2]|0;y=c[j>>2]|0}else{c[u>>2]=c[v>>2];c[h>>2]=m;x=m;y=w}w=e+24|0;m=x+4|0;if(m>>>0>y>>>0){Bid(h,w,4);z=c[h>>2]|0;A=c[j>>2]|0}else{c[w>>2]=c[x>>2];c[h>>2]=m;z=m;A=y}y=e+28|0;m=z+4|0;if(m>>>0>A>>>0){Bid(h,y,4);B=c[h>>2]|0;C=c[j>>2]|0}else{c[y>>2]=c[z>>2];c[h>>2]=m;B=m;C=A}A=e+32|0;m=B+2|0;if(m>>>0>C>>>0){Bid(h,A,2);D=c[h>>2]|0;E=c[j>>2]|0}else{b[A>>1]=b[B>>1]|0;c[h>>2]=m;D=m;E=C}C=e+34|0;m=D+2|0;if(m>>>0>E>>>0){Bid(h,C,2);F=c[h>>2]|0;G=c[j>>2]|0}else{b[C>>1]=b[D>>1]|0;c[h>>2]=m;F=m;G=E}E=e+36|0;m=F+2|0;if(m>>>0>G>>>0){Bid(h,E,2);H=c[h>>2]|0;I=c[j>>2]|0}else{b[E>>1]=b[F>>1]|0;c[h>>2]=m;H=m;I=G}G=e+38|0;m=H+2|0;if(m>>>0>I>>>0){Bid(h,G,2);J=c[h>>2]|0;K=c[j>>2]|0}else{b[G>>1]=b[H>>1]|0;c[h>>2]=m;J=m;K=I}I=e+40|0;m=J+2|0;if(m>>>0>K>>>0){Bid(h,I,2);L=c[h>>2]|0;M=c[j>>2]|0}else{b[I>>1]=b[J>>1]|0;c[h>>2]=m;L=m;M=K}K=e+42|0;m=L+2|0;if(m>>>0>M>>>0){Bid(h,K,2);N=c[h>>2]|0;O=c[j>>2]|0}else{b[K>>1]=b[L>>1]|0;c[h>>2]=m;N=m;O=M}M=e+44|0;m=N+2|0;if(m>>>0>O>>>0){Bid(h,M,2);P=c[h>>2]|0;Q=c[j>>2]|0}else{b[M>>1]=b[N>>1]|0;c[h>>2]=m;P=m;Q=O}O=e+46|0;m=P+2|0;if(m>>>0>Q>>>0){Bid(h,O,2);R=c[j>>2]|0;S=c[h>>2]|0}else{b[O>>1]=b[P>>1]|0;c[h>>2]=m;R=Q;S=m}m=e+48|0;Q=S+2|0;if(Q>>>0>R>>>0){Bid(h,m,2);T=c[h>>2]|0;U=c[j>>2]|0}else{b[m>>1]=b[S>>1]|0;c[h>>2]=Q;T=Q;U=R}R=e+50|0;Q=T+2|0;if(Q>>>0>U>>>0){Bid(h,R,2);V=c[h>>2]|0;W=c[j>>2]|0}else{b[R>>1]=b[T>>1]|0;c[h>>2]=Q;V=Q;W=U}U=e+52|0;Q=V+2|0;if(Q>>>0>W>>>0){Bid(h,U,2);X=c[h>>2]|0;Y=c[j>>2]|0}else{b[U>>1]=b[V>>1]|0;c[h>>2]=Q;X=Q;Y=W}W=e+54|0;Q=X+2|0;if(Q>>>0>Y>>>0){Bid(h,W,2);Z=c[h>>2]|0;_=c[j>>2]|0}else{b[W>>1]=b[X>>1]|0;c[h>>2]=Q;Z=Q;_=Y}Y=e+56|0;Q=Z+2|0;if(Q>>>0>_>>>0){Bid(h,Y,2);$=c[h>>2]|0;aa=c[j>>2]|0}else{b[Y>>1]=b[Z>>1]|0;c[h>>2]=Q;$=Q;aa=_}_=e+58|0;Q=$+2|0;if(Q>>>0>aa>>>0){Bid(h,_,2);ba=c[h>>2]|0;ca=c[j>>2]|0}else{b[_>>1]=b[$>>1]|0;c[h>>2]=Q;ba=Q;ca=aa}aa=e+60|0;Q=ba+2|0;if(Q>>>0>ca>>>0){Bid(h,aa,2);da=c[h>>2]|0;ea=c[j>>2]|0}else{b[aa>>1]=b[ba>>1]|0;c[h>>2]=Q;da=Q;ea=ca}ca=e+62|0;Q=da+2|0;if(Q>>>0>ea>>>0){Bid(h,ca,2);fa=c[h>>2]|0;ga=c[j>>2]|0}else{b[ca>>1]=b[da>>1]|0;c[h>>2]=Q;fa=Q;ga=ea}ea=e+64|0;if((fa+1|0)>>>0>ga>>>0){Bid(h,ea,1);ha=c[h>>2]|0}else{a[ea>>0]=a[fa>>0]|0;fa=(c[h>>2]|0)+1|0;c[h>>2]=fa;ha=fa}fa=e+65|0;if((ha+1|0)>>>0>(c[j>>2]|0)>>>0)Bid(h,fa,1);else{a[fa>>0]=a[ha>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(f);if((d[ea>>0]|0)<2){a[ea>>0]=2;ea=e+4|0;a[ea>>0]=a[e>>0]|0;a[ea+1>>0]=a[e+1>>0]|0;a[ea+2>>0]=a[e+2>>0]|0;b[A>>1]=0;b[C>>1]=-1}if((d[fa>>0]|0)>=2){i=g;return}a[fa>>0]=2;a[e+7>>0]=a[e+3>>0]|0;b[m>>1]=0;b[R>>1]=-1;i=g;return}function RLc(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;h=f+12|0;j=f+20|0;k=0;do{l=e+(k<<2)|0;m=c[h>>2]|0;n=m+4|0;if(n>>>0>(c[j>>2]|0)>>>0){Bid(h,l,4);o=c[l>>2]|0}else{p=c[m>>2]|0;c[l>>2]=p;c[h>>2]=n;o=p}c[l>>2]=o;k=k+1|0}while((k|0)!=8);q=0;do{k=e+(q<<1)+32|0;o=c[h>>2]|0;l=o+2|0;if(l>>>0>(c[j>>2]|0)>>>0){Bid(h,k,2);r=b[k>>1]|0}else{p=b[o>>1]|0;b[k>>1]=p;c[h>>2]=l;r=p}p=r&65535;b[k>>1]=p<<8|p>>>8;q=q+1|0}while((q|0)!=8);s=0;do{q=e+(s<<1)+48|0;r=c[h>>2]|0;p=r+2|0;if(p>>>0>(c[j>>2]|0)>>>0){Bid(h,q,2);t=b[q>>1]|0}else{k=b[r>>1]|0;b[q>>1]=k;c[h>>2]=p;t=k}k=t&65535;b[q>>1]=k<<8|k>>>8;s=s+1|0}while((s|0)!=8);s=e+64|0;t=c[h>>2]|0;if((t+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(h,s,1);u=c[h>>2]|0}else{a[s>>0]=a[t>>0]|0;t=(c[h>>2]|0)+1|0;c[h>>2]=t;u=t}t=e+65|0;if((u+1|0)>>>0>(c[j>>2]|0)>>>0)Bid(h,t,1);else{a[t>>0]=a[u>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(f);if((d[s>>0]|0)<2){a[s>>0]=2;s=e+4|0;a[s>>0]=a[e>>0]|0;a[s+1>>0]=a[e+1>>0]|0;a[s+2>>0]=a[e+2>>0]|0;b[e+32>>1]=0;b[e+34>>1]=-1}if((d[t>>0]|0)>=2){i=g;return}a[t>>0]=2;a[e+7>>0]=a[e+3>>0]|0;b[e+48>>1]=0;b[e+50>>1]=-1;i=g;return}function SLc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;f=i;g=e+12|0;h=e+20|0;j=c[g>>2]|0;k=j+4|0;l=c[h>>2]|0;if(k>>>0<l>>>0){c[j>>2]=c[d>>2];c[g>>2]=k;m=l;n=k}else{Gid(g,d,4);m=c[h>>2]|0;n=c[g>>2]|0}k=d+4|0;l=n+4|0;if(l>>>0<m>>>0){c[n>>2]=c[k>>2];c[g>>2]=l;o=l;p=m}else{Gid(g,k,4);o=c[g>>2]|0;p=c[h>>2]|0}k=d+8|0;m=o+4|0;if(m>>>0<p>>>0){c[o>>2]=c[k>>2];c[g>>2]=m;q=m;r=p}else{Gid(g,k,4);q=c[g>>2]|0;r=c[h>>2]|0}k=d+12|0;p=q+4|0;if(p>>>0<r>>>0){c[q>>2]=c[k>>2];c[g>>2]=p;s=p;t=r}else{Gid(g,k,4);s=c[g>>2]|0;t=c[h>>2]|0}k=d+16|0;r=s+4|0;if(r>>>0<t>>>0){c[s>>2]=c[k>>2];c[g>>2]=r;u=r;v=t}else{Gid(g,k,4);u=c[g>>2]|0;v=c[h>>2]|0}k=d+20|0;t=u+4|0;if(t>>>0<v>>>0){c[u>>2]=c[k>>2];c[g>>2]=t;w=t;x=v}else{Gid(g,k,4);w=c[g>>2]|0;x=c[h>>2]|0}k=d+24|0;v=w+4|0;if(v>>>0<x>>>0){c[w>>2]=c[k>>2];c[g>>2]=v;y=v;z=x}else{Gid(g,k,4);y=c[g>>2]|0;z=c[h>>2]|0}k=d+28|0;x=y+4|0;if(x>>>0<z>>>0){c[y>>2]=c[k>>2];c[g>>2]=x;A=x;B=z}else{Gid(g,k,4);A=c[g>>2]|0;B=c[h>>2]|0}k=d+32|0;z=A+2|0;if(z>>>0<B>>>0){b[A>>1]=b[k>>1]|0;c[g>>2]=z;C=z;D=B}else{Gid(g,k,2);C=c[g>>2]|0;D=c[h>>2]|0}k=d+34|0;B=C+2|0;if(B>>>0<D>>>0){b[C>>1]=b[k>>1]|0;c[g>>2]=B;E=B;F=D}else{Gid(g,k,2);E=c[g>>2]|0;F=c[h>>2]|0}k=d+36|0;D=E+2|0;if(D>>>0<F>>>0){b[E>>1]=b[k>>1]|0;c[g>>2]=D;G=D;H=F}else{Gid(g,k,2);G=c[g>>2]|0;H=c[h>>2]|0}k=d+38|0;F=G+2|0;if(F>>>0<H>>>0){b[G>>1]=b[k>>1]|0;c[g>>2]=F;I=H;J=F}else{Gid(g,k,2);I=c[h>>2]|0;J=c[g>>2]|0}k=d+40|0;F=J+2|0;if(F>>>0<I>>>0){b[J>>1]=b[k>>1]|0;c[g>>2]=F;K=F;L=I}else{Gid(g,k,2);K=c[g>>2]|0;L=c[h>>2]|0}k=d+42|0;I=K+2|0;if(I>>>0<L>>>0){b[K>>1]=b[k>>1]|0;c[g>>2]=I;M=I;N=L}else{Gid(g,k,2);M=c[g>>2]|0;N=c[h>>2]|0}k=d+44|0;L=M+2|0;if(L>>>0<N>>>0){b[M>>1]=b[k>>1]|0;c[g>>2]=L;O=L;P=N}else{Gid(g,k,2);O=c[g>>2]|0;P=c[h>>2]|0}k=d+46|0;N=O+2|0;if(N>>>0<P>>>0){b[O>>1]=b[k>>1]|0;c[g>>2]=N;Q=P;R=N}else{Gid(g,k,2);Q=c[h>>2]|0;R=c[g>>2]|0}k=d+48|0;N=R+2|0;if(N>>>0<Q>>>0){b[R>>1]=b[k>>1]|0;c[g>>2]=N;S=N;T=Q}else{Gid(g,k,2);S=c[g>>2]|0;T=c[h>>2]|0}k=d+50|0;Q=S+2|0;if(Q>>>0<T>>>0){b[S>>1]=b[k>>1]|0;c[g>>2]=Q;U=Q;V=T}else{Gid(g,k,2);U=c[g>>2]|0;V=c[h>>2]|0}k=d+52|0;T=U+2|0;if(T>>>0<V>>>0){b[U>>1]=b[k>>1]|0;c[g>>2]=T;W=T;X=V}else{Gid(g,k,2);W=c[g>>2]|0;X=c[h>>2]|0}k=d+54|0;V=W+2|0;if(V>>>0<X>>>0){b[W>>1]=b[k>>1]|0;c[g>>2]=V;Y=V;Z=X}else{Gid(g,k,2);Y=c[g>>2]|0;Z=c[h>>2]|0}k=d+56|0;X=Y+2|0;if(X>>>0<Z>>>0){b[Y>>1]=b[k>>1]|0;c[g>>2]=X;_=X;$=Z}else{Gid(g,k,2);_=c[g>>2]|0;$=c[h>>2]|0}k=d+58|0;Z=_+2|0;if(Z>>>0<$>>>0){b[_>>1]=b[k>>1]|0;c[g>>2]=Z;aa=Z;ba=$}else{Gid(g,k,2);aa=c[g>>2]|0;ba=c[h>>2]|0}k=d+60|0;$=aa+2|0;if($>>>0<ba>>>0){b[aa>>1]=b[k>>1]|0;c[g>>2]=$;ca=$;da=ba}else{Gid(g,k,2);ca=c[g>>2]|0;da=c[h>>2]|0}k=d+62|0;ba=ca+2|0;if(ba>>>0<da>>>0){b[ca>>1]=b[k>>1]|0;c[g>>2]=ba;ea=ba;fa=da}else{Gid(g,k,2);ea=c[g>>2]|0;fa=c[h>>2]|0}k=d+64|0;if((ea+1|0)>>>0<fa>>>0){a[ea>>0]=a[k>>0]|0;ea=(c[g>>2]|0)+1|0;c[g>>2]=ea;ga=ea}else{Gid(g,k,1);ga=c[g>>2]|0}k=d+65|0;if((ga+1|0)>>>0<(c[h>>2]|0)>>>0){a[ga>>0]=a[k>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Tdd(e);i=f;return}else{Gid(g,k,1);Tdd(e);i=f;return}}function TLc(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b>>2]);g[a+4>>2]=ea(g[b+4>>2]);g[a+8>>2]=ea(g[b+8>>2]);g[a+12>>2]=ea(g[b+16>>2]);g[a+16>>2]=ea(g[b+20>>2]);g[a+20>>2]=ea(g[b+24>>2]);g[a+24>>2]=ea(g[b+32>>2]);g[a+28>>2]=ea(g[b+36>>2]);g[a+32>>2]=ea(g[b+40>>2]);return}function ULc(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b>>2]);g[a+12>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+16>>2]=ea(g[b+4>>2]);g[a+28>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+20>>2]=ea(0.0);g[a+32>>2]=ea(g[b+8>>2]);return a|0}function VLc(a){a=a|0;var b=0,c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im;b=i;i=i+64|0;c=b;_Lc(c,a);qMc(c,c)|0;g[a>>2]=ea(g[c>>2]);d=ea(g[c+4>>2]);e=ea(g[c+8>>2]);f=ea(g[c+16>>2]);g[a+16>>2]=ea(g[c+20>>2]);h=ea(g[c+24>>2]);j=ea(g[c+32>>2]);k=ea(g[c+36>>2]);g[a+32>>2]=ea(g[c+40>>2]);g[a+12>>2]=d;g[a+4>>2]=f;g[a+24>>2]=e;g[a+8>>2]=j;g[a+20>>2]=k;g[a+28>>2]=h;i=b;return}function WLc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=0;c=b+4|0;d=b+8|0;e=b+12|0;f=b+16|0;h=b+20|0;i=b+24|0;j=b+28|0;k=b+32|0;l=ea(g[a>>2]);m=a+12|0;n=ea(g[m>>2]);o=a+24|0;p=ea(g[o>>2]);q=ea(l*ea(g[b>>2]));r=ea(q+ea(n*ea(g[c>>2])));g[a>>2]=ea(r+ea(p*ea(g[d>>2])));r=ea(l*ea(g[e>>2]));q=ea(r+ea(n*ea(g[f>>2])));g[m>>2]=ea(q+ea(p*ea(g[h>>2])));q=ea(l*ea(g[i>>2]));l=ea(q+ea(n*ea(g[j>>2])));g[o>>2]=ea(l+ea(p*ea(g[k>>2])));o=a+4|0;p=ea(g[o>>2]);m=a+16|0;l=ea(g[m>>2]);s=a+28|0;n=ea(g[s>>2]);q=ea(p*ea(g[b>>2]));r=ea(q+ea(l*ea(g[c>>2])));g[o>>2]=ea(r+ea(n*ea(g[d>>2])));r=ea(p*ea(g[e>>2]));q=ea(r+ea(l*ea(g[f>>2])));g[m>>2]=ea(q+ea(n*ea(g[h>>2])));q=ea(p*ea(g[i>>2]));p=ea(q+ea(l*ea(g[j>>2])));g[s>>2]=ea(p+ea(n*ea(g[k>>2])));s=a+8|0;n=ea(g[s>>2]);m=a+20|0;p=ea(g[m>>2]);o=a+32|0;l=ea(g[o>>2]);q=ea(n*ea(g[b>>2]));r=ea(q+ea(p*ea(g[c>>2])));g[s>>2]=ea(r+ea(l*ea(g[d>>2])));r=ea(n*ea(g[e>>2]));q=ea(r+ea(p*ea(g[f>>2])));g[m>>2]=ea(q+ea(l*ea(g[h>>2])));q=ea(n*ea(g[i>>2]));n=ea(q+ea(p*ea(g[j>>2])));g[o>>2]=ea(n+ea(l*ea(g[k>>2])));return a|0}function XLc(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=0,j=0,k=Im;c=i;d=ea(g[a+28>>2]);if(!(d<ea(.999000012))){g[b>>2]=ea(-1.57079637);e=ea(-ea(g[a+12>>2]));f=ea(+$(+e,+ea(g[a>>2])));h=b+4|0;g[h>>2]=f;g[b+8>>2]=ea(0.0);g[b>>2]=ea(4.71238899);if(f<ea(-.0000999999974)){g[h>>2]=ea(f+ea(6.28318548));j=0;i=c;return j|0}if(!(f>ea(6.28308535))){j=0;i=c;return j|0}g[h>>2]=ea(f+ea(-6.28318548));j=0;i=c;return j|0}if(!(d>ea(-.999000012))){g[b>>2]=ea(1.57079637);f=ea(g[a+12>>2]);e=ea(+$(+f,+ea(g[a>>2])));h=b+4|0;g[h>>2]=e;g[b+8>>2]=ea(0.0);if(e<ea(-.0000999999974)){g[h>>2]=ea(e+ea(6.28318548));j=0;i=c;return j|0}if(!(e>ea(6.28308535))){j=0;i=c;return j|0}g[h>>2]=ea(e+ea(-6.28318548));j=0;i=c;return j|0}e=ea(+Z(+ea(-d)));g[b>>2]=e;d=ea(g[a+24>>2]);f=ea(+$(+d,+ea(g[a+32>>2])));h=b+4|0;g[h>>2]=f;d=ea(g[a+4>>2]);k=ea(+$(+d,+ea(g[a+16>>2])));a=b+8|0;g[a>>2]=k;if(!(e<ea(-.0000999999974))){if(e>ea(6.28308535))g[b>>2]=ea(e+ea(-6.28318548))}else g[b>>2]=ea(e+ea(6.28318548));if(!(f<ea(-.0000999999974))){if(f>ea(6.28308535))g[h>>2]=ea(f+ea(-6.28318548))}else g[h>>2]=ea(f+ea(6.28318548));if(k<ea(-.0000999999974)){g[a>>2]=ea(k+ea(6.28318548));j=1;i=c;return j|0}if(!(k>ea(6.28308535))){j=1;i=c;return j|0}g[a>>2]=ea(k+ea(-6.28318548));j=1;i=c;return j|0}function YLc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;d=i;e=ea(g[a>>2]);f=ea(g[a+4>>2]);h=ea(g[a+8>>2]);j=ea(T(ea(ea(ea(e*e)+ea(f*f))+ea(h*h))));k=ea(g[150276]);if(j<k){g[c>>2]=ea(1.0);g[c+12>>2]=ea(0.0);g[c+24>>2]=ea(0.0);g[c+4>>2]=ea(0.0);g[c+16>>2]=ea(1.0);g[c+28>>2]=ea(0.0);g[c+8>>2]=ea(0.0);g[c+20>>2]=ea(0.0);g[c+32>>2]=ea(1.0);l=0;i=d;return l|0}m=ea(e/j);e=ea(f/j);f=ea(h/j);j=ea(g[b+4>>2]);h=ea(f*j);n=ea(g[b+8>>2]);o=ea(h-ea(e*n));h=ea(m*n);n=ea(g[b>>2]);p=ea(h-ea(f*n));h=ea(ea(e*n)-ea(m*j));j=ea(T(ea(ea(h*h)+ea(ea(o*o)+ea(p*p)))));if(j<k){g[c>>2]=ea(1.0);g[c+12>>2]=ea(0.0);g[c+24>>2]=ea(0.0);g[c+4>>2]=ea(0.0);g[c+16>>2]=ea(1.0);g[c+28>>2]=ea(0.0);g[c+8>>2]=ea(0.0);g[c+20>>2]=ea(0.0);g[c+32>>2]=ea(1.0);l=0;i=d;return l|0}k=ea(o/j);o=ea(p/j);p=ea(h/j);j=ea(ea(e*p)-ea(f*o));h=ea(ea(f*k)-ea(m*p));n=ea(ea(m*o)-ea(e*k));q=ea(ea(ea(n*n)+ea(ea(j*j)+ea(h*h)))+ea(-1.0));if(q<ea(0.0))r=ea(-q);else r=q;if(!(r<=ea(9.99999997e-07))){l=0;i=d;return l|0}g[c>>2]=k;g[c+12>>2]=j;g[c+24>>2]=m;g[c+4>>2]=o;g[c+16>>2]=h;g[c+28>>2]=e;g[c+8>>2]=p;g[c+20>>2]=n;g[c+32>>2]=f;l=1;i=d;return l|0}function ZLc(a){a=a|0;g[a>>2]=ea(1.0);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+20>>2]=ea(1.0);g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(1.0);g[a+56>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);return a|0}function _Lc(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b>>2]);g[a+4>>2]=ea(g[b+4>>2]);g[a+8>>2]=ea(g[b+8>>2]);g[a+12>>2]=ea(0.0);g[a+16>>2]=ea(g[b+12>>2]);g[a+20>>2]=ea(g[b+16>>2]);g[a+24>>2]=ea(g[b+20>>2]);g[a+28>>2]=ea(0.0);g[a+32>>2]=ea(g[b+24>>2]);g[a+36>>2]=ea(g[b+28>>2]);g[a+40>>2]=ea(g[b+32>>2]);b=a+44|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+60>>2]=ea(1.0);return}function $Lc(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b>>2]);g[a+4>>2]=ea(g[b+4>>2]);g[a+8>>2]=ea(g[b+8>>2]);g[a+12>>2]=ea(0.0);g[a+16>>2]=ea(g[b+12>>2]);g[a+20>>2]=ea(g[b+16>>2]);g[a+24>>2]=ea(g[b+20>>2]);g[a+28>>2]=ea(0.0);g[a+32>>2]=ea(g[b+24>>2]);g[a+36>>2]=ea(g[b+28>>2]);g[a+40>>2]=ea(g[b+32>>2]);b=a+44|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;g[a+60>>2]=ea(1.0);return a|0}function aMc(a,b){a=a|0;b=ea(b);var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0;c=i;d=ea(ea(g[a>>2])+ea(-1.0));if(d<ea(0.0))e=ea(-d);else e=d;do if(e<=b){d=ea(g[a+16>>2]);if(d<ea(0.0))f=ea(-d);else f=d;if(f<=b){d=ea(g[a+32>>2]);if(d<ea(0.0))h=ea(-d);else h=d;if(h<=b){d=ea(g[a+48>>2]);if(d<ea(0.0))j=ea(-d);else j=d;if(j<=b){d=ea(g[a+4>>2]);if(d<ea(0.0))k=ea(-d);else k=d;if(k<=b){d=ea(ea(g[a+20>>2])+ea(-1.0));if(d<ea(0.0))l=ea(-d);else l=d;if(l<=b){d=ea(g[a+36>>2]);if(d<ea(0.0))m=ea(-d);else m=d;if(m<=b){d=ea(g[a+52>>2]);if(d<ea(0.0))n=ea(-d);else n=d;if(n<=b){d=ea(g[a+8>>2]);if(d<ea(0.0))o=ea(-d);else o=d;if(o<=b){d=ea(g[a+24>>2]);if(d<ea(0.0))p=ea(-d);else p=d;if(!(p<=b))break;d=ea(ea(g[a+40>>2])+ea(-1.0));if(d<ea(0.0))q=ea(-d);else q=d;if(!(q<=b))break;d=ea(g[a+56>>2]);if(d<ea(0.0))r=ea(-d);else r=d;if(!(r<=b))break;d=ea(g[a+12>>2]);if(d<ea(0.0))s=ea(-d);else s=d;if(!(s<=b))break;d=ea(g[a+28>>2]);if(d<ea(0.0))t=ea(-d);else t=d;if(!(t<=b))break;d=ea(g[a+44>>2]);if(d<ea(0.0))u=ea(-d);else u=d;if(!(u<=b))break;d=ea(ea(g[a+60>>2])+ea(-1.0));if(d<ea(0.0))v=ea(-d);else v=d;if(!(v<=b))break;else w=1;i=c;return w|0}}}}}}}}}while(0);w=0;i=c;return w|0}function bMc(a){a=a|0;var b=0.0,c=0.0,d=0.0,e=0.0,f=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0;b=+ea(g[a>>2]);c=+ea(g[a+16>>2]);d=+ea(g[a+32>>2]);e=+ea(g[a+48>>2]);f=+ea(g[a+4>>2]);h=+ea(g[a+20>>2]);i=+ea(g[a+36>>2]);j=+ea(g[a+52>>2]);k=+ea(g[a+8>>2]);l=+ea(g[a+24>>2]);m=+ea(g[a+40>>2]);n=+ea(g[a+56>>2]);o=+ea(g[a+12>>2]);p=+ea(g[a+28>>2]);q=+ea(g[a+44>>2]);r=+ea(g[a+60>>2]);s=e*i;t=d*j;u=e*h;v=c*j;w=d*h;x=c*i;y=e*f;e=b*j;j=d*f;d=b*i;i=c*f;f=b*h;return +(f*m*r+(j*l*r+(x*k*r+(i*n*q+(e*l*q+(u*k*q+(d*n*p+(y*m*p+(t*k*p+(w*n*o+(v*m*o+(s*l*o-t*l*o-u*m*o))-x*n*o-s*k*p))-e*m*p-j*n*p))-v*k*q-y*l*q))-f*n*q-w*k*r))-d*l*r-i*m*r))}function cMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+64|0;e=d;dMc(a,b,e);b=a+0|0;f=e+0|0;e=b+64|0;do{c[b>>2]=c[f>>2];b=b+4|0;f=f+4|0}while((b|0)<(e|0));i=d;return a|0}function dMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=Im,B=0,C=Im,D=0;d=i;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[b+8>>2]);j=ea(g[b+12>>2]);k=ea(g[b+16>>2]);l=ea(g[b+20>>2]);m=ea(g[b+24>>2]);n=ea(g[b+28>>2]);o=ea(g[b+32>>2]);p=ea(g[b+36>>2]);q=ea(g[b+40>>2]);r=ea(g[b+44>>2]);s=ea(g[b+48>>2]);t=ea(g[b+52>>2]);u=ea(g[b+56>>2]);v=ea(g[b+60>>2]);b=0;do{w=ea(g[a+(b<<2)>>2]);x=ea(w*e);y=b+4|0;z=ea(g[a+(y<<2)>>2]);A=ea(x+ea(z*f));B=b+8|0;x=ea(g[a+(B<<2)>>2]);C=ea(A+ea(x*h));D=b+12|0;A=ea(g[a+(D<<2)>>2]);g[c+(b<<2)>>2]=ea(C+ea(A*j));g[c+(y<<2)>>2]=ea(ea(ea(ea(w*k)+ea(z*l))+ea(x*m))+ea(A*n));g[c+(B<<2)>>2]=ea(ea(ea(ea(w*o)+ea(z*p))+ea(x*q))+ea(A*r));g[c+(D<<2)>>2]=ea(ea(ea(ea(w*s)+ea(z*t))+ea(x*u))+ea(A*v));b=b+1|0}while((b|0)!=4);i=d;return}function eMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=0,w=0,x=Im,y=0,z=0;d=i;e=b+4|0;f=b+8|0;h=b+16|0;j=b+20|0;k=b+24|0;l=b+32|0;m=b+36|0;n=b+40|0;o=b+48|0;p=b+52|0;q=b+56|0;r=0;do{s=a+(r<<2)|0;t=ea(g[s>>2]);u=ea(t*ea(g[b>>2]));v=r+4|0;w=a+(v<<2)|0;t=ea(g[w>>2]);x=ea(u+ea(t*ea(g[e>>2])));y=r+8|0;z=a+(y<<2)|0;t=ea(g[z>>2]);g[c+(r<<2)>>2]=ea(x+ea(t*ea(g[f>>2])));t=ea(g[s>>2]);x=ea(t*ea(g[h>>2]));t=ea(g[w>>2]);u=ea(x+ea(t*ea(g[j>>2])));t=ea(g[z>>2]);g[c+(v<<2)>>2]=ea(u+ea(t*ea(g[k>>2])));t=ea(g[s>>2]);u=ea(t*ea(g[l>>2]));t=ea(g[w>>2]);x=ea(u+ea(t*ea(g[m>>2])));t=ea(g[z>>2]);g[c+(y<<2)>>2]=ea(x+ea(t*ea(g[n>>2])));t=ea(g[s>>2]);x=ea(t*ea(g[o>>2]));t=ea(g[w>>2]);u=ea(x+ea(t*ea(g[p>>2])));t=ea(g[z>>2]);x=ea(u+ea(t*ea(g[q>>2])));z=r+12|0;g[c+(z<<2)>>2]=ea(ea(g[a+(z<<2)>>2])+x);r=r+1|0}while((r|0)!=3);g[c+12>>2]=ea(0.0);g[c+28>>2]=ea(0.0);g[c+44>>2]=ea(0.0);g[c+60>>2]=ea(1.0);i=d;return}function fMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;g[a>>2]=ea(g[b>>2]);g[a+16>>2]=ea(g[c>>2]);g[a+32>>2]=ea(g[d>>2]);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(g[b+4>>2]);g[a+20>>2]=ea(g[c+4>>2]);g[a+36>>2]=ea(g[d+4>>2]);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(g[b+8>>2]);g[a+24>>2]=ea(g[c+8>>2]);g[a+40>>2]=ea(g[d+8>>2]);g[a+56>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);return a|0}function gMc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;g[a>>2]=ea(g[b>>2]);g[a+4>>2]=ea(g[d>>2]);g[a+8>>2]=ea(g[e>>2]);g[a+12>>2]=ea(0.0);g[a+16>>2]=ea(g[b+4>>2]);g[a+20>>2]=ea(g[d+4>>2]);g[a+24>>2]=ea(g[e+4>>2]);g[a+28>>2]=ea(0.0);g[a+32>>2]=ea(g[b+8>>2]);g[a+36>>2]=ea(g[d+8>>2]);g[a+40>>2]=ea(g[e+8>>2]);e=a+44|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[a+60>>2]=ea(1.0);return a|0}function hMc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g[a>>2]=ea(g[c>>2]);g[a+16>>2]=ea(g[d>>2]);g[a+32>>2]=ea(g[e>>2]);g[a+48>>2]=ea(g[b>>2]);g[a+4>>2]=ea(g[c+4>>2]);g[a+20>>2]=ea(g[d+4>>2]);g[a+36>>2]=ea(g[e+4>>2]);g[a+52>>2]=ea(g[b+4>>2]);g[a+8>>2]=ea(g[c+8>>2]);g[a+24>>2]=ea(g[d+8>>2]);g[a+40>>2]=ea(g[e+8>>2]);g[a+56>>2]=ea(g[b+8>>2]);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);return a|0}function iMc(a,b){a=a|0;b=b|0;g[a>>2]=ea(g[b>>2]);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+20>>2]=ea(g[b+4>>2]);g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(g[b+8>>2]);g[a+56>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);return a|0}function jMc(a,b){a=a|0;b=b|0;var c=Im,d=0,e=0;c=ea(g[b>>2]);g[a>>2]=ea(c*ea(g[a>>2]));c=ea(g[b>>2]);d=a+4|0;g[d>>2]=ea(c*ea(g[d>>2]));c=ea(g[b>>2]);d=a+8|0;g[d>>2]=ea(c*ea(g[d>>2]));c=ea(g[b>>2]);d=a+12|0;g[d>>2]=ea(c*ea(g[d>>2]));d=b+4|0;c=ea(g[d>>2]);e=a+16|0;g[e>>2]=ea(c*ea(g[e>>2]));c=ea(g[d>>2]);e=a+20|0;g[e>>2]=ea(c*ea(g[e>>2]));c=ea(g[d>>2]);e=a+24|0;g[e>>2]=ea(c*ea(g[e>>2]));c=ea(g[d>>2]);d=a+28|0;g[d>>2]=ea(c*ea(g[d>>2]));d=b+8|0;c=ea(g[d>>2]);b=a+32|0;g[b>>2]=ea(c*ea(g[b>>2]));c=ea(g[d>>2]);b=a+36|0;g[b>>2]=ea(c*ea(g[b>>2]));c=ea(g[d>>2]);b=a+40|0;g[b>>2]=ea(c*ea(g[b>>2]));c=ea(g[d>>2]);d=a+44|0;g[d>>2]=ea(c*ea(g[d>>2]));return a|0}function kMc(a,b){a=a|0;b=b|0;g[a>>2]=ea(1.0);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(g[b>>2]);g[a+4>>2]=ea(0.0);g[a+20>>2]=ea(1.0);g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(g[b+4>>2]);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(1.0);g[a+56>>2]=ea(g[b+8>>2]);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);return a|0}function lMc(a,b,c,d,e,f,h){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=ea(f);h=ea(h);var i=Im,j=Im;i=ea(f*ea(2.0));j=ea(c-b);g[a>>2]=ea(i/j);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(ea(b+c)/j);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);j=ea(d-e);g[a+20>>2]=ea(i/j);g[a+36>>2]=ea(ea(d+e)/j);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);j=ea(h-f);g[a+40>>2]=ea(ea(-ea(f+h))/j);g[a+56>>2]=ea(ea(-ea(ea(h*ea(2.0))*f))/j);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(-1.0);g[a+60>>2]=ea(0.0);return a|0}function mMc(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);var f=Im;f=ea(ea(ea(ea(b*ea(.5))/ea(360.0))*ea(2.0))*ea(3.14159274));b=ea(ea(+V(+f))/ea(+W(+f)));f=ea(d-e);g[a>>2]=ea(b/c);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+20>>2]=b;g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(ea(d+e)/f);g[a+56>>2]=ea(ea(ea(d*ea(2.0))*e)/f);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(-1.0);g[a+60>>2]=ea(0.0);return a|0}function nMc(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);var e=Im;e=ea(c-d);g[a>>2]=b;g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+20>>2]=b;g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(ea(c+d)/e);g[a+56>>2]=ea(ea(ea(c*ea(2.0))*d)/e);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(-1.0);g[a+60>>2]=ea(0.0);return a|0}function oMc(a,b,c,d,e,f,h){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=ea(f);h=ea(h);var i=Im,j=Im,k=Im;g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+36>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);i=ea(c-b);j=ea(e-d);k=ea(h-f);g[a>>2]=ea(ea(2.0)/i);g[a+48>>2]=ea(ea(-ea(b+c))/i);g[a+20>>2]=ea(ea(2.0)/j);g[a+52>>2]=ea(ea(-ea(d+e))/j);g[a+40>>2]=ea(ea(-2.0)/k);g[a+56>>2]=ea(ea(-ea(f+h))/k);return a|0}function pMc(a,b){a=a|0;b=ea(b);var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=0.0,m=0;c=i;d=ea(g[a>>2]);e=ea(g[a+4>>2]);f=ea(g[a+8>>2]);h=ea(T(ea(ea(ea(d*d)+ea(e*e))+ea(f*f))));f=ea(g[a+16>>2]);e=ea(g[a+20>>2]);d=ea(g[a+24>>2]);j=ea(T(ea(ea(ea(f*f)+ea(e*e))+ea(d*d))));d=ea(g[a+32>>2]);e=ea(g[a+36>>2]);f=ea(g[a+40>>2]);k=ea(T(ea(ea(ea(d*d)+ea(e*e))+ea(f*f))));f=j<h?j:h;e=k<f?k:f;f=h<j?j:h;h=f<k?k:f;l=+b;if(!(+e<1.0-l)?!(+h>l+1.0):0){m=0;i=c;return m|0}if(e!=ea(0.0)?+ea(h/e)<l+1.0:0){m=1;i=c;return m|0}m=2;i=c;return m|0}function qMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+128|0;e=d;f=e+32|0;h=e+64|0;j=e+96|0;k=ea(g[a>>2]);g[e>>2]=k;g[e+4>>2]=ea(g[a+16>>2]);g[e+8>>2]=ea(g[a+32>>2]);g[e+12>>2]=ea(g[a+48>>2]);g[e+16>>2]=ea(1.0);g[e+28>>2]=ea(0.0);g[e+24>>2]=ea(0.0);g[e+20>>2]=ea(0.0);l=ea(g[a+4>>2]);g[f>>2]=l;g[e+36>>2]=ea(g[a+20>>2]);g[e+40>>2]=ea(g[a+36>>2]);g[e+44>>2]=ea(g[a+52>>2]);g[e+52>>2]=ea(1.0);g[e+60>>2]=ea(0.0);g[e+56>>2]=ea(0.0);g[e+48>>2]=ea(0.0);m=ea(g[a+8>>2]);g[h>>2]=m;g[e+68>>2]=ea(g[a+24>>2]);g[e+72>>2]=ea(g[a+40>>2]);g[e+76>>2]=ea(g[a+56>>2]);g[e+88>>2]=ea(1.0);g[e+92>>2]=ea(0.0);g[e+84>>2]=ea(0.0);g[e+80>>2]=ea(0.0);n=ea(g[a+12>>2]);g[j>>2]=n;g[e+100>>2]=ea(g[a+28>>2]);g[e+104>>2]=ea(g[a+44>>2]);g[e+108>>2]=ea(g[a+60>>2]);g[e+124>>2]=ea(1.0);g[e+120>>2]=ea(0.0);g[e+116>>2]=ea(0.0);g[e+112>>2]=ea(0.0);if(n<ea(0.0))o=ea(-n);else o=n;if(m<ea(0.0))p=ea(-m);else p=m;a=o>p;q=a?j:h;r=a?2:3;s=a?h:j;p=ea(g[q>>2]);if(p<ea(0.0))t=ea(-p);else t=p;if(l<ea(0.0))u=ea(-l);else u=l;j=t>u;h=j?q:f;a=j?f:q;u=ea(g[h>>2]);if(u<ea(0.0))v=ea(-u);else v=u;if(k<ea(0.0))w=ea(-k);else w=k;q=v>w;f=q?e:h;j=q?h:e;w=ea(g[j>>2]);if(w==ea(0.0)){x=b+0|0;y=x+64|0;do{c[x>>2]=0;x=x+4|0}while((x|0)<(y|0));z=0;i=d;return z|0}v=ea(ea(g[f>>2])/w);k=ea(ea(g[a>>2])/w);u=ea(ea(g[s>>2])/w);h=j+4|0;w=ea(g[h>>2]);t=ea(v*w);q=f+4|0;g[q>>2]=ea(ea(g[q>>2])-t);t=ea(k*w);A=a+4|0;g[A>>2]=ea(ea(g[A>>2])-t);t=ea(u*w);B=e+(r<<5)+4|0;g[B>>2]=ea(ea(g[B>>2])-t);C=j+8|0;t=ea(g[C>>2]);w=ea(v*t);D=f+8|0;g[D>>2]=ea(ea(g[D>>2])-w);w=ea(k*t);D=a+8|0;g[D>>2]=ea(ea(g[D>>2])-w);w=ea(u*t);D=e+(r<<5)+8|0;g[D>>2]=ea(ea(g[D>>2])-w);D=j+12|0;w=ea(g[D>>2]);t=ea(v*w);E=f+12|0;g[E>>2]=ea(ea(g[E>>2])-t);t=ea(k*w);E=a+12|0;g[E>>2]=ea(ea(g[E>>2])-t);t=ea(u*w);E=e+(r<<5)+12|0;g[E>>2]=ea(ea(g[E>>2])-t);E=j+16|0;t=ea(g[E>>2]);if(t!=ea(0.0)){w=ea(v*t);F=f+16|0;g[F>>2]=ea(ea(g[F>>2])-w);w=ea(k*t);F=a+16|0;g[F>>2]=ea(ea(g[F>>2])-w);w=ea(u*t);F=e+(r<<5)+16|0;g[F>>2]=ea(ea(g[F>>2])-w)}F=j+20|0;w=ea(g[F>>2]);if(w!=ea(0.0)){t=ea(v*w);G=f+20|0;g[G>>2]=ea(ea(g[G>>2])-t);t=ea(k*w);G=a+20|0;g[G>>2]=ea(ea(g[G>>2])-t);t=ea(u*w);G=e+(r<<5)+20|0;g[G>>2]=ea(ea(g[G>>2])-t)}G=j+24|0;t=ea(g[G>>2]);if(t!=ea(0.0)){w=ea(v*t);H=f+24|0;g[H>>2]=ea(ea(g[H>>2])-w);w=ea(k*t);H=a+24|0;g[H>>2]=ea(ea(g[H>>2])-w);w=ea(u*t);H=e+(r<<5)+24|0;g[H>>2]=ea(ea(g[H>>2])-w)}H=j+28|0;w=ea(g[H>>2]);if(w!=ea(0.0)){t=ea(v*w);I=f+28|0;g[I>>2]=ea(ea(g[I>>2])-t);t=ea(k*w);I=a+28|0;g[I>>2]=ea(ea(g[I>>2])-t);t=ea(u*w);I=e+(r<<5)+28|0;g[I>>2]=ea(ea(g[I>>2])-t)}t=ea(g[B>>2]);if(t<ea(0.0))J=ea(-t);else J=t;t=ea(g[A>>2]);if(t<ea(0.0))K=ea(-t);else K=t;A=J>K;B=A?s:a;I=A?a:s;K=ea(g[B+4>>2]);if(K<ea(0.0))L=ea(-K);else L=K;K=ea(g[q>>2]);if(K<ea(0.0))M=ea(-K);else M=K;q=L>M;s=q?B:f;a=q?f:B;B=s+4|0;M=ea(g[B>>2]);if(M==ea(0.0)){x=b+0|0;y=x+64|0;do{c[x>>2]=0;x=x+4|0}while((x|0)<(y|0));z=0;i=d;return z|0}L=ea(ea(g[a+4>>2])/M);K=ea(ea(g[I+4>>2])/M);f=s+8|0;M=ea(L*ea(g[f>>2]));q=a+8|0;g[q>>2]=ea(ea(g[q>>2])-M);M=ea(K*ea(g[f>>2]));A=I+8|0;g[A>>2]=ea(ea(g[A>>2])-M);r=s+12|0;M=ea(L*ea(g[r>>2]));e=a+12|0;g[e>>2]=ea(ea(g[e>>2])-M);M=ea(K*ea(g[r>>2]));e=I+12|0;g[e>>2]=ea(ea(g[e>>2])-M);e=s+16|0;M=ea(g[e>>2]);if(M!=ea(0.0)){J=ea(L*M);N=a+16|0;g[N>>2]=ea(ea(g[N>>2])-J);J=ea(K*M);N=I+16|0;g[N>>2]=ea(ea(g[N>>2])-J)}N=s+20|0;J=ea(g[N>>2]);if(J!=ea(0.0)){M=ea(L*J);O=a+20|0;g[O>>2]=ea(ea(g[O>>2])-M);M=ea(K*J);O=I+20|0;g[O>>2]=ea(ea(g[O>>2])-M)}O=s+24|0;M=ea(g[O>>2]);if(M!=ea(0.0)){J=ea(L*M);P=a+24|0;g[P>>2]=ea(ea(g[P>>2])-J);J=ea(K*M);P=I+24|0;g[P>>2]=ea(ea(g[P>>2])-J)}P=s+28|0;J=ea(g[P>>2]);if(J!=ea(0.0)){M=ea(L*J);s=a+28|0;g[s>>2]=ea(ea(g[s>>2])-M);M=ea(K*J);s=I+28|0;g[s>>2]=ea(ea(g[s>>2])-M)}M=ea(g[A>>2]);if(M<ea(0.0))Q=ea(-M);else Q=M;M=ea(g[q>>2]);if(M<ea(0.0))R=ea(-M);else R=M;q=Q>R;A=q?I:a;s=q?a:I;I=A+8|0;R=ea(g[I>>2]);if(R==ea(0.0)){x=b+0|0;y=x+64|0;do{c[x>>2]=0;x=x+4|0}while((x|0)<(y|0));z=0;i=d;return z|0}Q=ea(ea(g[s+8>>2])/R);a=A+12|0;R=ea(Q*ea(g[a>>2]));q=s+12|0;M=ea(ea(g[q>>2])-R);g[q>>2]=M;q=A+16|0;R=ea(Q*ea(g[q>>2]));S=s+16|0;J=ea(ea(g[S>>2])-R);g[S>>2]=J;T=A+20|0;R=ea(Q*ea(g[T>>2]));U=s+20|0;K=ea(ea(g[U>>2])-R);g[U>>2]=K;V=A+24|0;R=ea(Q*ea(g[V>>2]));W=s+24|0;L=ea(ea(g[W>>2])-R);g[W>>2]=L;X=A+28|0;R=ea(Q*ea(g[X>>2]));A=s+28|0;Q=ea(ea(g[A>>2])-R);g[A>>2]=Q;if(M==ea(0.0)){x=b+0|0;y=x+64|0;do{c[x>>2]=0;x=x+4|0}while((x|0)<(y|0));z=0;i=d;return z|0}else{R=ea(ea(1.0)/M);M=ea(R*J);g[S>>2]=M;g[U>>2]=ea(R*K);g[W>>2]=ea(R*L);g[A>>2]=ea(R*Q);Q=ea(g[a>>2]);R=ea(ea(1.0)/ea(g[I>>2]));g[q>>2]=ea(R*ea(ea(g[q>>2])-ea(Q*M)));M=ea(g[T>>2]);g[T>>2]=ea(R*ea(M-ea(Q*ea(g[U>>2]))));M=ea(g[V>>2]);g[V>>2]=ea(R*ea(M-ea(Q*ea(g[W>>2]))));M=ea(g[X>>2]);g[X>>2]=ea(R*ea(M-ea(Q*ea(g[A>>2]))));Q=ea(g[r>>2]);M=ea(Q*ea(g[S>>2]));g[e>>2]=ea(ea(g[e>>2])-M);M=ea(Q*ea(g[U>>2]));g[N>>2]=ea(ea(g[N>>2])-M);M=ea(Q*ea(g[W>>2]));g[O>>2]=ea(ea(g[O>>2])-M);M=ea(Q*ea(g[A>>2]));g[P>>2]=ea(ea(g[P>>2])-M);M=ea(g[D>>2]);Q=ea(M*ea(g[S>>2]));g[E>>2]=ea(ea(g[E>>2])-Q);Q=ea(M*ea(g[U>>2]));g[F>>2]=ea(ea(g[F>>2])-Q);Q=ea(M*ea(g[W>>2]));g[G>>2]=ea(ea(g[G>>2])-Q);Q=ea(M*ea(g[A>>2]));g[H>>2]=ea(ea(g[H>>2])-Q);Q=ea(g[f>>2]);M=ea(ea(1.0)/ea(g[B>>2]));R=ea(g[e>>2]);g[e>>2]=ea(M*ea(R-ea(Q*ea(g[q>>2]))));R=ea(g[N>>2]);g[N>>2]=ea(M*ea(R-ea(Q*ea(g[T>>2]))));R=ea(g[O>>2]);g[O>>2]=ea(M*ea(R-ea(Q*ea(g[V>>2]))));R=ea(g[P>>2]);g[P>>2]=ea(M*ea(R-ea(Q*ea(g[X>>2]))));Q=ea(g[C>>2]);R=ea(Q*ea(g[q>>2]));M=ea(ea(g[E>>2])-R);g[E>>2]=M;R=ea(Q*ea(g[T>>2]));L=ea(ea(g[F>>2])-R);g[F>>2]=L;R=ea(Q*ea(g[V>>2]));K=ea(ea(g[G>>2])-R);g[G>>2]=K;R=ea(Q*ea(g[X>>2]));Q=ea(ea(g[H>>2])-R);g[H>>2]=Q;R=ea(g[h>>2]);J=ea(ea(1.0)/ea(g[j>>2]));t=ea(J*ea(M-ea(R*ea(g[e>>2]))));g[E>>2]=t;M=ea(J*ea(L-ea(R*ea(g[N>>2]))));g[F>>2]=M;L=ea(J*ea(K-ea(R*ea(g[O>>2]))));g[G>>2]=L;K=ea(J*ea(Q-ea(R*ea(g[P>>2]))));g[H>>2]=K;g[b>>2]=t;g[b+16>>2]=M;g[b+32>>2]=L;g[b+48>>2]=K;g[b+4>>2]=ea(g[e>>2]);g[b+20>>2]=ea(g[N>>2]);g[b+36>>2]=ea(g[O>>2]);g[b+52>>2]=ea(g[P>>2]);g[b+8>>2]=ea(g[q>>2]);g[b+24>>2]=ea(g[T>>2]);g[b+40>>2]=ea(g[V>>2]);g[b+56>>2]=ea(g[X>>2]);g[b+12>>2]=ea(g[S>>2]);g[b+28>>2]=ea(g[U>>2]);g[b+44>>2]=ea(g[W>>2]);g[b+60>>2]=ea(g[A>>2]);z=1;i=d;return z|0}return 0}function rMc(a,b){a=a|0;b=b|0;var d=0,e=Im,f=0,h=Im,j=Im,k=0,l=Im,m=Im,n=0,o=Im,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0;d=i;e=ea(g[a>>2]);f=a+20|0;h=ea(g[f>>2]);j=ea(e*h);k=a+40|0;l=ea(g[k>>2]);m=ea(j*l);n=!(m>=ea(0.0));j=ea(m+ea(0.0));m=n?ea(0.0):j;o=n?j:ea(0.0);n=a+4|0;j=ea(g[n>>2]);p=a+24|0;q=ea(g[p>>2]);r=ea(j*q);s=a+32|0;t=ea(g[s>>2]);u=ea(r*t);if(!(u>=ea(0.0))){v=ea(o+u);w=m}else{v=o;w=ea(m+u)}x=a+8|0;u=ea(g[x>>2]);y=a+16|0;m=ea(g[y>>2]);o=ea(u*m);z=a+36|0;r=ea(g[z>>2]);A=ea(o*r);if(!(A>=ea(0.0))){B=ea(v+A);C=w}else{B=v;C=ea(w+A)}A=ea(ea(u*h)*t);if(!(A<=ea(-0.0))){D=ea(B-A);E=C}else{D=B;E=ea(C-A)}A=ea(ea(j*m)*l);if(!(A<=ea(-0.0))){F=ea(D-A);G=E}else{F=D;G=ea(E-A)}A=ea(ea(e*q)*r);if(!(A<=ea(-0.0))){H=ea(F-A);I=G}else{H=F;I=ea(G-A)}A=ea(I+H);if(+ea(A*A)<1.0e-25){J=b+0|0;K=J+64|0;do{c[J>>2]=0;J=J+4|0}while((J|0)<(K|0));L=0;i=d;return L|0}else{H=ea(ea(1.0)/A);A=ea(H*ea(ea(h*l)-ea(q*r)));g[b>>2]=A;r=ea(g[y>>2]);q=ea(r*ea(g[k>>2]));r=ea(g[p>>2]);l=ea(-ea(H*ea(q-ea(r*ea(g[s>>2])))));g[b+16>>2]=l;r=ea(g[y>>2]);q=ea(r*ea(g[z>>2]));r=ea(g[f>>2]);h=ea(H*ea(q-ea(r*ea(g[s>>2]))));g[b+32>>2]=h;r=ea(g[n>>2]);q=ea(r*ea(g[k>>2]));r=ea(g[x>>2]);I=ea(-ea(H*ea(q-ea(r*ea(g[z>>2])))));g[b+4>>2]=I;r=ea(g[a>>2]);q=ea(r*ea(g[k>>2]));r=ea(g[x>>2]);G=ea(H*ea(q-ea(r*ea(g[s>>2]))));g[b+20>>2]=G;r=ea(g[a>>2]);q=ea(r*ea(g[z>>2]));r=ea(g[n>>2]);F=ea(-ea(H*ea(q-ea(r*ea(g[s>>2])))));g[b+36>>2]=F;r=ea(g[n>>2]);q=ea(r*ea(g[p>>2]));r=ea(g[x>>2]);e=ea(H*ea(q-ea(r*ea(g[f>>2]))));g[b+8>>2]=e;r=ea(g[a>>2]);q=ea(r*ea(g[p>>2]));r=ea(g[x>>2]);E=ea(-ea(H*ea(q-ea(r*ea(g[y>>2])))));g[b+24>>2]=E;r=ea(g[a>>2]);q=ea(r*ea(g[f>>2]));r=ea(g[n>>2]);D=ea(H*ea(q-ea(r*ea(g[y>>2]))));g[b+40>>2]=D;y=a+48|0;r=ea(ea(g[y>>2])*A);n=a+52|0;A=ea(r+ea(ea(g[n>>2])*l));f=a+56|0;g[b+48>>2]=ea(-ea(A+ea(ea(g[f>>2])*h)));h=ea(ea(g[y>>2])*I);I=ea(h+ea(ea(g[n>>2])*G));g[b+52>>2]=ea(-ea(I+ea(ea(g[f>>2])*F)));F=ea(ea(g[y>>2])*e);e=ea(F+ea(ea(g[n>>2])*E));g[b+56>>2]=ea(-ea(e+ea(ea(g[f>>2])*D)));g[b+12>>2]=ea(0.0);g[b+28>>2]=ea(0.0);g[b+44>>2]=ea(0.0);g[b+60>>2]=ea(1.0);L=1;i=d;return L|0}return 0}function sMc(a){a=a|0;var b=0,c=0,d=Im;b=a+16|0;c=a+4|0;d=ea(g[b>>2]);g[b>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+32|0;b=a+8|0;d=ea(g[c>>2]);g[c>>2]=ea(g[b>>2]);g[b>>2]=d;b=a+48|0;c=a+12|0;d=ea(g[b>>2]);g[b>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+36|0;b=a+24|0;d=ea(g[c>>2]);g[c>>2]=ea(g[b>>2]);g[b>>2]=d;b=a+52|0;c=a+28|0;d=ea(g[b>>2]);g[b>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+56|0;b=a+44|0;d=ea(g[c>>2]);g[c>>2]=ea(g[b>>2]);g[b>>2]=d;return a|0}function tMc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=b+0|0;b=a+0|0;a=e+64|0;do{c[e>>2]=c[b>>2];e=e+4|0;b=b+4|0}while((e|0)<(a|0));i=d;return}function uMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GMc(c,a);g[a+48>>2]=ea(g[b>>2]);g[a+52>>2]=ea(g[b+4>>2]);g[a+56>>2]=ea(g[b+8>>2]);i=d;return}function vMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=Im,h=0;e=i;GMc(c,a);f=ea(g[d>>2]);g[a>>2]=ea(f*ea(g[a>>2]));f=ea(g[d>>2]);c=a+4|0;g[c>>2]=ea(f*ea(g[c>>2]));f=ea(g[d>>2]);c=a+8|0;g[c>>2]=ea(f*ea(g[c>>2]));c=d+4|0;f=ea(g[c>>2]);h=a+16|0;g[h>>2]=ea(f*ea(g[h>>2]));f=ea(g[c>>2]);h=a+20|0;g[h>>2]=ea(f*ea(g[h>>2]));f=ea(g[c>>2]);c=a+24|0;g[c>>2]=ea(f*ea(g[c>>2]));c=d+8|0;f=ea(g[c>>2]);d=a+32|0;g[d>>2]=ea(f*ea(g[d>>2]));f=ea(g[c>>2]);d=a+36|0;g[d>>2]=ea(f*ea(g[d>>2]));f=ea(g[c>>2]);c=a+40|0;g[c>>2]=ea(f*ea(g[c>>2]));g[a+48>>2]=ea(g[b>>2]);g[a+52>>2]=ea(g[b+4>>2]);g[a+56>>2]=ea(g[b+8>>2]);i=e;return}function wMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im;d=i;i=i+16|0;e=d;f=ea(-ea(g[c>>2]));h=ea(-ea(g[c+4>>2]));j=ea(-ea(g[c+8>>2]));k=ea(g[c+12>>2]);g[e>>2]=f;g[e+4>>2]=h;g[e+8>>2]=j;g[e+12>>2]=k;GMc(e,a);k=ea(-ea(g[b>>2]));j=ea(-ea(g[b+4>>2]));h=ea(-ea(g[b+8>>2]));f=ea(ea(g[a>>2])*k);l=ea(f+ea(ea(g[a+16>>2])*j));f=ea(l+ea(ea(g[a+32>>2])*h));b=a+48|0;g[b>>2]=ea(ea(g[b>>2])+f);f=ea(ea(g[a+4>>2])*k);l=ea(f+ea(ea(g[a+20>>2])*j));f=ea(l+ea(ea(g[a+36>>2])*h));b=a+52|0;g[b>>2]=ea(ea(g[b>>2])+f);f=ea(ea(g[a+8>>2])*k);l=ea(f+ea(ea(g[a+24>>2])*j));f=ea(l+ea(ea(g[a+40>>2])*h));b=a+56|0;g[b>>2]=ea(ea(g[b>>2])+f);f=ea(ea(g[a+12>>2])*k);k=ea(f+ea(ea(g[a+28>>2])*j));j=ea(k+ea(ea(g[a+44>>2])*h));b=a+60|0;g[b>>2]=ea(ea(g[b>>2])+j);i=d;return}function xMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;e=i;i=i+48|0;f=e;TLc(f,a);if((d|0)<=0){i=e;return}h=ea(g[f>>2]);j=ea(g[f+12>>2]);k=ea(g[f+24>>2]);l=ea(g[f+4>>2]);m=ea(g[f+16>>2]);n=ea(g[f+28>>2]);o=ea(g[f+8>>2]);p=ea(g[f+20>>2]);q=ea(g[f+32>>2]);f=0;do{r=ea(g[b+(f*12|0)>>2]);s=ea(h*r);t=ea(g[b+(f*12|0)+4>>2]);u=ea(s+ea(j*t));s=ea(g[b+(f*12|0)+8>>2]);v=ea(ea(ea(r*l)+ea(t*m))+ea(s*n));w=ea(ea(ea(r*o)+ea(t*p))+ea(s*q));g[c+(f*12|0)>>2]=ea(u+ea(k*s));g[c+(f*12|0)+4>>2]=v;g[c+(f*12|0)+8>>2]=w;f=f+1|0}while((f|0)!=(d|0));i=e;return}function yMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;h=i;i=i+48|0;j=h;TLc(j,a);if((f|0)<=0){i=h;return}a=j+12|0;k=j+24|0;l=j+4|0;m=j+16|0;n=j+28|0;o=j+8|0;p=j+20|0;q=j+32|0;r=d;d=b;b=0;while(1){s=ea(g[j>>2]);t=ea(g[d>>2]);u=ea(s*t);s=ea(g[a>>2]);v=ea(g[d+4>>2]);w=ea(u+ea(s*v));s=ea(g[k>>2]);u=ea(g[d+8>>2]);x=ea(w+ea(s*u));s=ea(t*ea(g[l>>2]));w=ea(s+ea(v*ea(g[m>>2])));s=ea(w+ea(u*ea(g[n>>2])));w=ea(t*ea(g[o>>2]));t=ea(w+ea(v*ea(g[p>>2])));v=ea(t+ea(u*ea(g[q>>2])));g[r>>2]=x;g[r+4>>2]=s;g[r+8>>2]=v;b=b+1|0;if((b|0)==(f|0))break;else{r=r+e|0;d=d+c|0}}i=h;return}function zMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;h=i;if((f|0)<=0){i=h;return}j=a+16|0;k=a+32|0;l=a+48|0;m=a+4|0;n=a+20|0;o=a+36|0;p=a+52|0;q=a+8|0;r=a+24|0;s=a+40|0;t=a+56|0;u=d;d=b;b=0;while(1){v=ea(g[a>>2]);w=ea(g[d>>2]);x=ea(v*w);v=ea(g[j>>2]);y=ea(g[d+4>>2]);z=ea(x+ea(v*y));v=ea(g[k>>2]);x=ea(g[d+8>>2]);A=ea(z+ea(v*x));v=ea(ea(g[l>>2])+A);A=ea(w*ea(g[m>>2]));z=ea(A+ea(y*ea(g[n>>2])));A=ea(z+ea(x*ea(g[o>>2])));z=ea(ea(g[p>>2])+A);A=ea(w*ea(g[q>>2]));w=ea(A+ea(y*ea(g[r>>2])));y=ea(w+ea(x*ea(g[s>>2])));x=ea(ea(g[t>>2])+y);g[u>>2]=v;g[u+4>>2]=z;g[u+8>>2]=x;b=b+1|0;if((b|0)==(f|0))break;else{u=u+e|0;d=d+c|0}}i=h;return}function AMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im;d=i;e=b+0|0;f=a+0|0;a=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0));f=b+16|0;e=b+4|0;h=ea(g[f>>2]);g[f>>2]=ea(g[e>>2]);g[e>>2]=h;e=b+32|0;f=b+8|0;h=ea(g[e>>2]);g[e>>2]=ea(g[f>>2]);g[f>>2]=h;f=b+48|0;e=b+12|0;h=ea(g[f>>2]);g[f>>2]=ea(g[e>>2]);g[e>>2]=h;e=b+36|0;f=b+24|0;h=ea(g[e>>2]);g[e>>2]=ea(g[f>>2]);g[f>>2]=h;f=b+52|0;e=b+28|0;h=ea(g[f>>2]);g[f>>2]=ea(g[e>>2]);g[e>>2]=h;e=b+56|0;f=b+44|0;h=ea(g[e>>2]);g[e>>2]=ea(g[f>>2]);g[f>>2]=h;i=d;return}function BMc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+64|0;g=f;if(!e){i=f;return}else h=0;do{dMc(a,b+(h<<6)|0,g);dMc(g,c+(h<<6)|0,d+(h<<6)|0);h=h+1|0}while((h|0)!=(e|0));i=f;return}function CMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;e=i;f=ea(g[b>>2]);h=ea(g[c>>2]);j=ea(f*h);k=ea(g[b+4>>2]);l=ea(g[c+4>>2]);m=ea(j+ea(k*l));j=ea(g[b+8>>2]);n=ea(g[c+8>>2]);o=ea(m+ea(j*n));m=ea(g[b+12>>2]);p=ea(g[c+12>>2]);q=ea(o+ea(m*p));if(q<ea(0.0)){r=ea(-h);s=ea(-l);t=ea(-n);u=ea(-p);v=ea(-q)}else{r=h;s=l;t=n;u=p;v=q}if(v<ea(.949999988)){q=ea(+Y(+v));v=ea(ea(1.0)/ea(+W(+q)));p=ea(+W(+ea(q*d)));n=ea(+W(+ea(ea(ea(1.0)-d)*q)));q=ea(v*ea(ea(s*p)+ea(n*k)));l=ea(v*ea(ea(t*p)+ea(n*j)));h=ea(v*ea(ea(u*p)+ea(n*m)));g[a>>2]=ea(v*ea(ea(r*p)+ea(n*f)));g[a+4>>2]=q;g[a+8>>2]=l;g[a+12>>2]=h;i=e;return}if(ea(ea(ea(ea(r*f)+ea(s*k))+ea(t*j))+ea(u*m))<ea(0.0)){w=ea(-t);x=ea(-s);y=ea(-r);z=ea(-u)}else{w=t;x=s;y=r;z=u}u=ea(f+ea(ea(y-f)*d));f=ea(k+ea(ea(x-k)*d));k=ea(j+ea(ea(w-j)*d));j=ea(m+ea(ea(z-m)*d));d=ea(T(ea(ea(j*j)+ea(ea(k*k)+ea(ea(f*f)+ea(u*u))))));m=ea(f/d);f=ea(k/d);k=ea(j/d);g[a>>2]=ea(u/d);g[a+4>>2]=m;g[a+8>>2]=f;g[a+12>>2]=k;i=e;return}function DMc(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;c=ea(ea(g[b>>2])*ea(.5));d=ea(+V(+c));e=ea(+W(+c));c=ea(ea(g[b+4>>2])*ea(.5));f=ea(+V(+c));h=ea(+W(+c));c=ea(ea(g[b+8>>2])*ea(.5));i=ea(+V(+c));j=ea(+W(+c));c=ea(d*ea(0.0));k=ea(h*ea(0.0));l=ea(ea(c+ea(e*f))+k);m=ea(f*ea(0.0));n=ea(e*ea(0.0));o=ea(n+ea(m+ea(d*h)));p=ea(ea(ea(c+m)+ea(0.0))-ea(e*h));h=ea(ea(ea(d*f)-n)-k);k=ea(h*ea(0.0));n=ea(p*ea(0.0));f=ea(ea(n+ea(k+ea(i*o)))-ea(l*j));d=ea(l*ea(0.0));e=ea(o*ea(0.0));m=ea(ea(d+ea(ea(h*j)+ea(i*p)))-e);c=ea(ea(ea(ea(h*i)-d)-e)-ea(j*p));g[a>>2]=ea(ea(ea(k+ea(l*i))+ea(o*j))-n);g[a+4>>2]=f;g[a+8>>2]=m;g[a+12>>2]=c;return}function EMc(a,b){a=a|0;b=b|0;var c=0,d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;c=i;i=i+48|0;d=c;g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0);e=ea(g[b>>2]);f=ea(e*ea(2.0));h=ea(g[b+4>>2]);j=ea(h*ea(2.0));k=ea(g[b+8>>2]);l=ea(k*ea(2.0));m=ea(e*f);n=ea(h*j);o=ea(k*l);k=ea(e*j);p=ea(e*l);e=ea(h*l);h=ea(g[b+12>>2]);q=ea(f*h);f=ea(j*h);j=ea(h*l);g[d>>2]=ea(ea(1.0)-ea(n+o));g[d+4>>2]=ea(k+j);g[d+8>>2]=ea(p-f);g[d+12>>2]=ea(k-j);g[d+16>>2]=ea(ea(1.0)-ea(m+o));g[d+20>>2]=ea(e+q);g[d+24>>2]=ea(p+f);g[d+28>>2]=ea(e-q);g[d+32>>2]=ea(ea(1.0)-ea(m+n));XLc(d,a)|0;i=c;return}function FMc(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im;c=ea(g[a>>2]);d=ea(c*ea(2.0));e=ea(g[a+4>>2]);f=ea(e*ea(2.0));h=ea(g[a+8>>2]);i=ea(h*ea(2.0));j=ea(c*d);k=ea(e*f);l=ea(h*i);h=ea(c*f);m=ea(c*i);c=ea(e*i);e=ea(g[a+12>>2]);n=ea(d*e);d=ea(f*e);f=ea(e*i);g[b>>2]=ea(ea(1.0)-ea(k+l));g[b+4>>2]=ea(h+f);g[b+8>>2]=ea(m-d);g[b+12>>2]=ea(h-f);g[b+16>>2]=ea(ea(1.0)-ea(j+l));g[b+20>>2]=ea(c+n);g[b+24>>2]=ea(m+d);g[b+28>>2]=ea(c-n);g[b+32>>2]=ea(ea(1.0)-ea(j+k));return}function GMc(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;d=ea(g[a>>2]);e=ea(d*ea(2.0));f=ea(g[a+4>>2]);h=ea(f*ea(2.0));i=ea(g[a+8>>2]);j=ea(i*ea(2.0));k=ea(d*e);l=ea(f*h);m=ea(i*j);i=ea(d*h);n=ea(d*j);d=ea(f*j);f=ea(g[a+12>>2]);o=ea(e*f);e=ea(h*f);h=ea(f*j);g[b>>2]=ea(ea(1.0)-ea(l+m));g[b+4>>2]=ea(i+h);g[b+8>>2]=ea(n-e);g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(i-h);g[b+20>>2]=ea(ea(1.0)-ea(k+m));g[b+24>>2]=ea(d+o);g[b+28>>2]=ea(0.0);g[b+32>>2]=ea(n+e);g[b+36>>2]=ea(d-o);g[b+40>>2]=ea(ea(1.0)-ea(k+l));a=b+44|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;g[b+60>>2]=ea(1.0);return}function HMc(a,b){a=a|0;b=b|0;var c=0,d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;c=i;i=i+48|0;d=c;e=ea(g[a>>2]);f=ea(g[a+16>>2]);h=ea(g[a+32>>2]);j=ea(g[a+4>>2]);k=ea(g[a+20>>2]);l=ea(g[a+36>>2]);m=ea(g[a+8>>2]);n=ea(g[a+24>>2]);o=ea(g[a+40>>2]);g[d>>2]=e;g[d+4>>2]=j;g[d+8>>2]=m;g[d+12>>2]=f;g[d+16>>2]=k;g[d+20>>2]=n;g[d+24>>2]=h;g[d+28>>2]=l;g[d+32>>2]=o;IMc(d,b);i=c;return}function IMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=Im,B=0,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=i;i=i+16|0;e=d;f=ea(g[a>>2]);h=ea(g[a+16>>2]);j=ea(f+h);k=ea(g[a+32>>2]);l=ea(j+k);if(l>ea(0.0)){j=ea(T(ea(l+ea(1.0))));l=ea(j*ea(.5));g[b+12>>2]=l;m=ea(ea(.5)/j);j=ea(g[a+20>>2]);n=ea(m*ea(j-ea(g[a+28>>2])));g[b>>2]=n;j=ea(g[a+24>>2]);o=ea(m*ea(j-ea(g[a+8>>2])));g[b+4>>2]=o;j=ea(g[a+4>>2]);p=ea(m*ea(j-ea(g[a+12>>2])));g[b+8>>2]=p;q=o;r=p;s=l;t=n;u=ea(t*t);v=b+4|0;w=ea(q*q);x=ea(u+w);y=b+8|0;z=ea(r*r);A=ea(x+z);B=b+12|0;C=ea(s*s);D=ea(A+C);E=ea(T(ea(D)));F=ea(t/E);G=ea(q/E);H=ea(r/E);I=ea(s/E);g[b>>2]=F;g[v>>2]=G;g[y>>2]=H;g[B>>2]=I;i=d;return}else{J=h>f;K=J&1;L=k>ea(g[a+((J?3:0)+K<<2)>>2]);J=L?2:K;K=c[601072+(J<<2)>>2]|0;L=c[601072+(K<<2)>>2]|0;M=J*3|0;k=ea(g[a+(J<<2<<2)>>2]);N=K*3|0;f=ea(k-ea(g[a+(K<<2<<2)>>2]));O=L*3|0;k=ea(T(ea(ea(f-ea(g[a+(L<<2<<2)>>2]))+ea(1.0))));c[e>>2]=b;P=b+4|0;c[e+4>>2]=P;Q=b+8|0;c[e+8>>2]=Q;f=ea(k*ea(.5));g[c[e+(J<<2)>>2]>>2]=f;f=ea(ea(.5)/k);k=ea(g[a+(N+L<<2)>>2]);R=b+12|0;g[R>>2]=ea(f*ea(k-ea(g[a+(O+K<<2)>>2])));k=ea(g[a+(M+K<<2)>>2]);h=ea(f*ea(k+ea(g[a+(N+J<<2)>>2])));g[c[e+(K<<2)>>2]>>2]=h;h=ea(g[a+(M+L<<2)>>2]);k=ea(f*ea(h+ea(g[a+(O+J<<2)>>2])));g[c[e+(L<<2)>>2]>>2]=k;k=ea(g[b>>2]);h=ea(g[P>>2]);f=ea(g[Q>>2]);q=h;r=f;s=ea(g[R>>2]);t=k;u=ea(t*t);v=b+4|0;w=ea(q*q);x=ea(u+w);y=b+8|0;z=ea(r*r);A=ea(x+z);B=b+12|0;C=ea(s*s);D=ea(A+C);E=ea(T(ea(D)));F=ea(t/E);G=ea(q/E);H=ea(r/E);I=ea(s/E);g[b>>2]=F;g[v>>2]=G;g[y>>2]=H;g[B>>2]=I;i=d;return}}function JMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+48|0;e=d;if(!(YLc(a,b,e)|0)){f=0;i=d;return f|0}IMc(e,c);f=1;i=d;return f|0}function KMc(a,b,c){a=a|0;b=b|0;c=c|0;return a+((b<<2)+c<<2)|0}function LMc(a,b){a=a|0;b=b|0;var c=0,d=0,e=Im,f=0;c=i;d=0;do{e=ea(g[b+(d<<2)>>2]);f=a+(d<<2)|0;g[f>>2]=ea(e+ea(g[f>>2]));d=d+1|0}while((d|0)!=27);i=c;return a|0}function MMc(a){a=a|0;var b=0,d=0;b=i;d=a+0|0;a=d+108|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function NMc(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=0;d=i;e=0;do{f=ea(ea(g[b+(e<<2)>>2])*c);h=a+(e<<2)|0;g[h>>2]=ea(ea(g[h>>2])+f);e=e+1|0}while((e|0)!=27);i=d;return}function OMc(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=0;d=i;i=i+112|0;e=d;PMc(e,b);b=0;do{f=ea(ea(g[e+(b<<2)>>2])*c);h=a+(b<<2)|0;g[h>>2]=ea(ea(g[h>>2])+f);b=b+1|0}while((b|0)!=27);i=d;return}function PMc(a,b){a=a|0;b=b|0;var d=0;d=i;g[a>>2]=ea(g[(KMc(b,0,0)|0)>>2]);g[a+36>>2]=ea(g[(KMc(b,1,0)|0)>>2]);g[a+72>>2]=ea(g[(KMc(b,2,0)|0)>>2]);g[a+4>>2]=ea(g[(KMc(b,0,2)|0)>>2]);g[a+40>>2]=ea(g[(KMc(b,1,2)|0)>>2]);g[a+76>>2]=ea(g[(KMc(b,2,2)|0)>>2]);g[a+8>>2]=ea(g[(KMc(b,0,3)|0)>>2]);g[a+44>>2]=ea(g[(KMc(b,1,3)|0)>>2]);g[a+80>>2]=ea(g[(KMc(b,2,3)|0)>>2]);g[a+12>>2]=ea(g[(KMc(b,0,1)|0)>>2]);g[a+48>>2]=ea(g[(KMc(b,1,1)|0)>>2]);g[a+84>>2]=ea(g[(KMc(b,2,1)|0)>>2]);b=a+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;b=a+52|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;b=a+88|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;i=d;return}function QMc(a,b){a=a|0;b=b|0;var c=Im,d=0;c=ea(g[b>>2]);g[a>>2]=ea(c+ea(g[a>>2]));c=ea(g[b+4>>2]);d=a+36|0;g[d>>2]=ea(c+ea(g[d>>2]));c=ea(g[b+8>>2]);b=a+72|0;g[b>>2]=ea(c+ea(g[b>>2]));return}function RMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=0,y=Im,z=Im;d=i;i=i+48|0;e=d;f=ea(g[b>>2]);h=ea(g[b+4>>2]);j=ea(g[b+8>>2]);g[e>>2]=ea(.282094806);k=ea(h*ea(-.488602519));b=e+4|0;g[b>>2]=k;l=ea(j*ea(.488602519));m=e+8|0;g[m>>2]=l;n=ea(f*ea(-.488602519));o=e+12|0;g[o>>2]=n;p=ea(ea(f*h)*ea(1.09254849));q=e+16|0;g[q>>2]=p;r=ea(ea(h*j)*ea(-1.09254849));s=e+20|0;g[s>>2]=r;t=ea(ea(ea(j*j)+ea(-.333333343))*ea(.946174681));u=e+24|0;g[u>>2]=t;v=ea(ea(f*j)*ea(-1.09254849));w=e+28|0;g[w>>2]=v;j=ea(ea(ea(f*f)-ea(h*h))*ea(.546274245));x=e+32|0;g[x>>2]=j;h=ea(ea(g[c>>2])*ea(2.95679307));f=ea(g[c+4>>2]);y=ea(g[c+8>>2]);z=ea(ea(h*ea(.282094806))*ea(.282094777));g[a>>2]=ea(ea(g[a>>2])+z);z=ea(ea(h*k)*ea(-.325734973));c=a+4|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*l)*ea(.325734973));c=a+8|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*n)*ea(-.325734973));c=a+12|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*p)*ea(.273137093));c=a+16|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*r)*ea(-.273137093));c=a+20|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*t)*ea(.0788478925));c=a+24|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*v)*ea(-.273137093));c=a+28|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(ea(h*j)*ea(.136568546));c=a+32|0;g[c>>2]=ea(ea(g[c>>2])+z);z=ea(f*ea(2.95679307));f=ea(y*ea(2.95679307));y=ea(ea(z*ea(.282094806))*ea(.282094777));c=a+36|0;g[c>>2]=ea(ea(g[c>>2])+y);y=ea(ea(z*k)*ea(-.325734973));c=a+40|0;g[c>>2]=ea(ea(g[c>>2])+y);y=ea(g[m>>2]);k=ea(ea(z*y)*ea(.325734973));m=a+44|0;g[m>>2]=ea(ea(g[m>>2])+k);k=ea(g[o>>2]);j=ea(ea(z*k)*ea(-.325734973));o=a+48|0;g[o>>2]=ea(ea(g[o>>2])+j);j=ea(g[q>>2]);h=ea(ea(z*j)*ea(.273137093));q=a+52|0;g[q>>2]=ea(ea(g[q>>2])+h);h=ea(g[s>>2]);v=ea(ea(z*h)*ea(-.273137093));s=a+56|0;g[s>>2]=ea(ea(g[s>>2])+v);v=ea(g[u>>2]);t=ea(ea(z*v)*ea(.0788478925));u=a+60|0;g[u>>2]=ea(ea(g[u>>2])+t);t=ea(g[w>>2]);r=ea(ea(z*t)*ea(-.273137093));w=a+64|0;g[w>>2]=ea(ea(g[w>>2])+r);r=ea(g[x>>2]);p=ea(ea(z*r)*ea(.136568546));x=a+68|0;g[x>>2]=ea(ea(g[x>>2])+p);p=ea(ea(f*ea(g[e>>2]))*ea(.282094777));e=a+72|0;g[e>>2]=ea(ea(g[e>>2])+p);p=ea(ea(f*ea(g[b>>2]))*ea(-.325734973));b=a+76|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*y)*ea(.325734973));b=a+80|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*k)*ea(-.325734973));b=a+84|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*j)*ea(.273137093));b=a+88|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*h)*ea(-.273137093));b=a+92|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*v)*ea(.0788478925));b=a+96|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*t)*ea(-.273137093));b=a+100|0;g[b>>2]=ea(ea(g[b>>2])+p);p=ea(ea(f*r)*ea(.136568546));b=a+104|0;g[b>>2]=ea(ea(g[b>>2])+p);i=d;return}function SMc(a){a=a|0;g[a+4>>2]=ea(x);c[a>>2]=0;g[a+32>>2]=ea(x);c[a+28>>2]=0;return}function TMc(a,b){a=a|0;b=b|0;var d=0,e=Im,f=Im,h=0,i=Im;d=c[b+64>>2]|0;if(!d){e=ea(-x);f=ea(x)}else{h=c[b+56>>2]|0;i=ea(g[h>>2]);e=ea(g[h+(d+-1<<4)>>2]);f=i}g[a>>2]=f;g[a+4>>2]=e;return}function UMc(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=Im,j=0,k=Im,l=Im,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=Im,S=Im,T=Im,U=Im,V=Im,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=Im,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;d=i;i=i+16|0;e=d;f=c[a+64>>2]|0;if((f|0)==1){h=ea(g[(c[a+56>>2]|0)+4>>2]);i=d;return ea(h)}j=a+4|0;k=ea(g[j>>2]);if(k<=b?ea(g[a+8>>2])>b:0){l=ea(b-k);k=ea(l*ea(g[a+12>>2]));m=ea(l*ea(k+ea(g[a+16>>2])));k=ea(l*ea(ea(g[a+20>>2])+m));m=ea(ea(g[a+24>>2])+k);g[e>>2]=m;h=m;i=d;return ea(h)}if(!f){h=ea(0.0);i=d;return ea(h)}n=c[a+56>>2]|0;m=ea(g[n>>2]);o=f+-1|0;k=ea(g[n+(o<<4)>>2]);do if(!(k<=b)){if(!(m>b)){p=c[a>>2]|0;a:do if((p|0)!=-1)if(ea(g[n+(p<<4)>>2])<b){q=0;while(1){r=q+p|0;s=r+1|0;if((s|0)<(f|0)?ea(g[n+(s<<4)>>2])>b:0){t=r;u=s;break}q=q+1|0;if((q|0)>=3){v=0;w=f;y=64;break a}}z=t;A=(o|0)<(u|0)?o:u;break}else{q=0;while(1){s=p-q|0;if((s|0)>-1?ea(g[n+(s<<4)>>2])<=b:0){B=s;break}q=q+1|0;if((q|0)>=3){v=0;w=f;y=64;break a}}q=B+1|0;z=B;A=(o|0)<(q|0)?o:q;break}else{v=0;w=f;y=64}while(0);if((y|0)==64){b:while(1){y=0;p=w;while(1){if((p|0)<=0){C=v;break b}q=p>>1;s=q+v|0;if(ea(g[n+(s<<4)>>2])>b)p=q;else{D=q;E=s;F=p;break}}v=E+1|0;w=F+-1-D|0;y=64}z=C+-1|0;A=(C|0)<(o|0)?C:o}l=ea(g[n+(z<<4)>>2]);G=ea(l+ea(0.0));g[j>>2]=G;H=ea(g[n+(A<<4)>>2]);g[a+8>>2]=ea(H+ea(0.0));c[a>>2]=z;I=ea(H-l);p=I<ea(.0000999999974);l=p?ea(.0000999999974):I;I=ea(g[n+(A<<4)+4>>2]);p=n+(z<<4)+4|0;H=ea(I-ea(g[p>>2]));I=ea(ea(1.0)/ea(l*l));s=n+(z<<4)+12|0;J=ea(g[s>>2]);q=n+(A<<4)+8|0;K=ea(l*J);L=ea(l*ea(g[q>>2]));M=ea(ea(I*ea(ea(ea(K+L)-H)-H))/l);r=a+12|0;g[r>>2]=M;l=ea(I*ea(ea(ea(ea(H+ea(H+H))-K)-K)-L));N=a+16|0;g[N>>2]=l;O=a+20|0;g[O>>2]=J;L=ea(g[p>>2]);P=a+24|0;g[P>>2]=L;if(!(ea(g[s>>2])==ea(x))?!(ea(g[q>>2])==ea(x)):0){Q=G;S=M;T=l;U=J;V=L;break}g[r>>2]=ea(0.0);g[N>>2]=ea(0.0);g[O>>2]=ea(0.0);L=ea(g[p>>2]);g[P>>2]=L;Q=G;S=ea(0.0);T=ea(0.0);U=ea(0.0);V=L;break}P=c[a+72>>2]|0;if((P|0)==1){L=ea(b-m);G=ea(k-m);J=ea(m+ea(L-ea(G*ea(R(ea(L/G))))));p=c[a>>2]|0;c:do if((p|0)!=-1)if(ea(g[n+(p<<4)>>2])<J){O=0;while(1){N=O+p|0;r=N+1|0;if((r|0)<(f|0)?ea(g[n+(r<<4)>>2])>J:0){W=N;X=r;break}O=O+1|0;if((O|0)>=3){Y=0;Z=f;y=45;break c}}_=W;$=(o|0)<(X|0)?o:X;break}else{O=0;while(1){r=p-O|0;if((r|0)>-1?ea(g[n+(r<<4)>>2])<=J:0){aa=r;break}O=O+1|0;if((O|0)>=3){Y=0;Z=f;y=45;break c}}O=aa+1|0;_=aa;$=(o|0)<(O|0)?o:O;break}else{Y=0;Z=f;y=45}while(0);if((y|0)==45){d:while(1){y=0;p=Z;while(1){if((p|0)<=0){ba=Y;break d}O=p>>1;r=O+Y|0;if(ea(g[n+(r<<4)>>2])>J)p=O;else{ca=O;da=r;fa=p;break}}Y=da+1|0;Z=fa+-1-ca|0;y=45}_=ba+-1|0;$=(ba|0)<(o|0)?ba:o}G=ea(b-J);L=ea(g[n+(_<<4)>>2]);l=ea(G+L);g[j>>2]=l;M=ea(g[n+($<<4)>>2]);g[a+8>>2]=ea(G+M);c[a>>2]=_;G=ea(M-L);p=G<ea(.0000999999974);L=p?ea(.0000999999974):G;G=ea(g[n+($<<4)+4>>2]);p=n+(_<<4)+4|0;M=ea(G-ea(g[p>>2]));G=ea(ea(1.0)/ea(L*L));r=n+(_<<4)+12|0;K=ea(g[r>>2]);O=n+($<<4)+8|0;H=ea(L*K);I=ea(L*ea(g[O>>2]));ga=ea(ea(G*ea(ea(ea(H+I)-M)-M))/L);N=a+12|0;g[N>>2]=ga;L=ea(G*ea(ea(ea(ea(M+ea(M+M))-H)-H)-I));q=a+16|0;g[q>>2]=L;s=a+20|0;g[s>>2]=K;I=ea(g[p>>2]);ha=a+24|0;g[ha>>2]=I;if(!(ea(g[r>>2])==ea(x))?!(ea(g[O>>2])==ea(x)):0){Q=l;S=ga;T=L;U=K;V=I;break}g[N>>2]=ea(0.0);g[q>>2]=ea(0.0);g[s>>2]=ea(0.0);I=ea(g[p>>2]);g[ha>>2]=I;Q=l;S=ea(0.0);T=ea(0.0);U=ea(0.0);V=I;break}else if((P|0)==2){I=ea(b+ea(-1.0e3));g[j>>2]=I;g[a+8>>2]=m;g[a+20>>2]=ea(0.0);g[a+16>>2]=ea(0.0);g[a+12>>2]=ea(0.0);l=ea(g[n+4>>2]);g[a+24>>2]=l;Q=I;S=ea(0.0);T=ea(0.0);U=ea(0.0);V=l;break}else{VMc(a,b,e);h=ea(g[e>>2]);i=d;return ea(h)}}else{ha=c[a+76>>2]|0;if((ha|0)==1){l=ea(b-m);I=ea(k-m);K=ea(VDi(ea(UDi(ea(m+ea(l-ea(I*ea(R(ea(l/I)))))),m)),k));p=c[a>>2]|0;e:do if((p|0)!=-1)if(ea(g[n+(p<<4)>>2])<K){s=0;while(1){q=s+p|0;N=q+1|0;if((N|0)<(f|0)?ea(g[n+(N<<4)>>2])>K:0){ia=q;ja=N;break}s=s+1|0;if((s|0)>=3){ka=0;la=f;y=23;break e}}ma=ia;na=(o|0)<(ja|0)?o:ja;break}else{s=0;while(1){N=p-s|0;if((N|0)>-1?ea(g[n+(N<<4)>>2])<=K:0){oa=N;break}s=s+1|0;if((s|0)>=3){ka=0;la=f;y=23;break e}}s=oa+1|0;ma=oa;na=(o|0)<(s|0)?o:s;break}else{ka=0;la=f;y=23}while(0);if((y|0)==23){f:while(1){y=0;p=la;while(1){if((p|0)<=0){pa=ka;break f}P=p>>1;s=P+ka|0;if(ea(g[n+(s<<4)>>2])>K)p=P;else{qa=P;ra=s;sa=p;break}}ka=ra+1|0;la=sa+-1-qa|0;y=23}ma=pa+-1|0;na=(pa|0)<(o|0)?pa:o}J=ea(b-K);I=ea(g[n+(ma<<4)>>2]);l=ea(J+I);g[j>>2]=l;L=ea(g[n+(na<<4)>>2]);g[a+8>>2]=ea(J+L);c[a>>2]=ma;J=ea(L-I);p=J<ea(.0000999999974);I=p?ea(.0000999999974):J;J=ea(g[n+(na<<4)+4>>2]);p=n+(ma<<4)+4|0;L=ea(J-ea(g[p>>2]));J=ea(ea(1.0)/ea(I*I));s=n+(ma<<4)+12|0;ga=ea(g[s>>2]);P=n+(na<<4)+8|0;H=ea(I*ga);M=ea(I*ea(g[P>>2]));G=ea(ea(J*ea(ea(ea(H+M)-L)-L))/I);N=a+12|0;g[N>>2]=G;I=ea(J*ea(ea(ea(ea(L+ea(L+L))-H)-H)-M));q=a+16|0;g[q>>2]=I;O=a+20|0;g[O>>2]=ga;M=ea(g[p>>2]);r=a+24|0;g[r>>2]=M;if(!(ea(g[s>>2])==ea(x))?!(ea(g[P>>2])==ea(x)):0){Q=l;S=G;T=I;U=ga;V=M;break}g[N>>2]=ea(0.0);g[q>>2]=ea(0.0);g[O>>2]=ea(0.0);M=ea(g[p>>2]);g[r>>2]=M;Q=l;S=ea(0.0);T=ea(0.0);U=ea(0.0);V=M;break}else if((ha|0)==2){g[j>>2]=k;g[a+8>>2]=ea(x);g[a+20>>2]=ea(0.0);g[a+16>>2]=ea(0.0);g[a+12>>2]=ea(0.0);M=ea(g[n+(o<<4)+4>>2]);g[a+24>>2]=M;Q=k;S=ea(0.0);T=ea(0.0);U=ea(0.0);V=M;break}else{VMc(a,b,e);h=ea(g[e>>2]);i=d;return ea(h)}}while(0);k=ea(b-Q);Q=ea(V+ea(k*ea(U+ea(k*ea(ea(k*S)+T)))));g[e>>2]=Q;h=Q;i=d;return ea(h)}function VMc(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=Im,B=Im,C=0,D=Im,E=Im,F=Im;e=i;f=c[a+64>>2]|0;if((f|0)==1){g[d>>2]=ea(g[(c[a+56>>2]|0)+4>>2]);i=e;return}h=ea(WMc(a,b));j=c[a+56>>2]|0;k=c[a>>2]|0;a:do if((k|0)!=-1)if(ea(g[j+(k<<4)>>2])<h){a=0;while(1){l=a+k|0;m=l+1|0;if((m|0)<(f|0)?ea(g[j+(m<<4)>>2])>h:0){n=l;o=m;break}a=a+1|0;if((a|0)>=3){p=0;q=f;r=16;break a}}a=f+-1|0;s=(a|0)<(o|0)?a:o;t=n;break}else{a=0;while(1){m=k-a|0;if((m|0)>-1?ea(g[j+(m<<4)>>2])<=h:0){u=m;break}a=a+1|0;if((a|0)>=3){p=0;q=f;r=16;break a}}a=u+1|0;m=f+-1|0;s=(m|0)<(a|0)?m:a;t=u;break}else{p=0;q=f;r=16}while(0);if((r|0)==16){b:while(1){r=0;u=q;while(1){if((u|0)<=0){v=p;break b}k=u>>1;n=k+p|0;if(ea(g[j+(n<<4)>>2])>h)u=k;else{w=k;y=n;z=u;break}}p=y+1|0;q=z+-1-w|0;r=16}r=f+-1|0;s=(v|0)<(r|0)?v:r;t=v+-1|0}b=ea(g[j+(s<<4)>>2]);A=ea(g[j+(t<<4)>>2]);B=ea(b-A);if(B!=ea(0.0)){b=ea(ea(h-A)/B);v=j+(t<<4)+12|0;A=ea(B*ea(g[v>>2]));C=v;D=A;E=ea(B*ea(g[j+(s<<4)+8>>2]));F=b}else{C=j+(t<<4)+12|0;D=ea(0.0);E=ea(0.0);F=ea(0.0)}v=j+(t<<4)+4|0;b=ea(g[v>>2]);B=ea(F*F);A=ea(F*B);h=ea(B*ea(3.0));g[d>>2]=ea(ea(ea(g[j+(s<<4)+4>>2])*ea(h+ea(A*ea(-2.0))))+ea(ea(E*ea(A-B))+ea(ea(D*ea(F+ea(A-ea(B*ea(2.0)))))+ea(b*ea(ea(ea(A*ea(2.0))-h)+ea(1.0))))));if(!(ea(g[C>>2])==ea(x))?!(ea(g[j+(s<<4)+8>>2])==ea(x)):0){i=e;return}g[d>>2]=ea(g[v>>2]);i=e;return}function WMc(a,b){a=a|0;b=ea(b);var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im;d=i;e=c[a+56>>2]|0;f=ea(g[e>>2]);h=ea(g[e+((c[a+64>>2]|0)+-1<<4)>>2]);if(f>b){e=c[a+72>>2]|0;if(!e){j=ea(b-f);k=ea(h-f);l=ea(k*ea(2.0));m=ea(ea(j-ea(l*ea(R(ea(j/l)))))-k);if(m<ea(0.0))n=ea(-m);else n=m;o=ea(f+ea(k-n));i=d;return ea(o)}else if((e|0)==2){o=f;i=d;return ea(o)}else{n=ea(b-f);k=ea(h-f);o=ea(f+ea(n-ea(k*ea(R(ea(n/k))))));i=d;return ea(o)}}if(!(h<b)){o=b;i=d;return ea(o)}e=c[a+76>>2]|0;if(!e){k=ea(b-f);n=ea(h-f);m=ea(n*ea(2.0));l=ea(ea(k-ea(m*ea(R(ea(k/m)))))-n);if(l<ea(0.0))p=ea(-l);else p=l;o=ea(f+ea(n-p));i=d;return ea(o)}else if((e|0)==2){o=h;i=d;return ea(o)}else{p=ea(b-f);b=ea(h-f);o=ea(f+ea(p-ea(b*ea(R(ea(p/b))))));i=d;return ea(o)}return ea(0.0)}function XMc(){var a=0;a=i;QQb(142,152,0,0,0);i=a;return}function YMc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,2347328,11);wQb(142,130,b,108,2631,0,0);xri(b);i=a;return}function ZMc(a){a=a|0;return 142}function _Mc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2347328,a,0);kNc(a,b);bdd(b);i=c;return}function $Mc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2347328,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else lNc(a,b);sdd(b);i=d;return}function aNc(a,b){a=a|0;b=b|0;var c=0;c=i;mNc(a,b);i=c;return}function bNc(a,b){a=a|0;b=b|0;var c=0;c=i;nNc(a,b);i=c;return}function cNc(a,b){a=a|0;b=b|0;var c=0;c=i;oNc(a,b);i=c;return}function dNc(a,b){a=a|0;b=b|0;var c=0;c=i;pNc(a,b);i=c;return}function eNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];mWb(b,g,e);c[b>>2]=601224;c[b+28>>2]=1;e=b+32|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;a[e+12>>0]=0;c[b+48>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;c[b+52>>2]=60;c[b+68>>2]=0;c[b+72>>2]=0;c[b+64>>2]=b+68;e=b+76|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;qbc(b+88|0);e=b+92|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;a[e+12>>0]=0;In[c[(c[b>>2]|0)+44>>2]&4095](b,61);i=f;return}function fNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;f=i;i=i+96|0;g=f+16|0;h=f+48|0;j=f+24|0;k=f+52|0;l=f+76|0;m=f;n=f+36|0;o=f+64|0;sri(j,e);e=a[j>>0]|0;if(!(e&1)){p=j+1|0;q=p;r=p;s=j+8|0}else{p=j+8|0;q=c[p>>2]|0;r=j+1|0;s=p}p=j+4|0;t=e;e=q;while(1){u=(t&1)==0;if(u){v=r;w=(t&255)>>>1}else{v=c[s>>2]|0;w=c[p>>2]|0}if((e|0)==(v+w|0))break;q=a[e>>0]|0;x=q<<24>>24;a[e>>0]=(q+-65<<24>>24&255)<26?x+32|0:x;t=a[j>>0]|0;e=e+1|0}if(u){y=j+1|0;z=(t&255)>>>1}else{y=c[j+8>>2]|0;z=c[p>>2]|0}t=y+z|0;if(z){z=y;do{if((a[z>>0]|0)==92)a[z>>0]=47;z=z+1|0}while((z|0)!=(t|0))}a:do if((Kri(j,47,0)|0)==-1){gsd(k,j);t=a[k>>0]|0;if(!(t&1))A=(t&255)>>>1;else A=c[k+4>>2]|0;t=(A|0)==0;xri(k);z=c[d+64>>2]|0;y=d+68|0;if((z|0)!=(y|0)){u=j+1|0;e=m+1|0;w=m+8|0;v=j+8|0;s=m+4|0;r=z;while(1){z=r+16|0;x=a[z>>0]|0;if(!(x&1)){B=z+1|0;C=(x&255)>>>1}else{B=c[r+24>>2]|0;C=c[r+20>>2]|0}rri(l,B,C);if(t)hsd(n,l);else sri(n,l);ksd(m,n);x=a[j>>0]|0;z=(x&1)==0;if(z)D=(x&255)>>>1;else D=c[p>>2]|0;x=a[m>>0]|0;q=(x&1)==0;if(q)E=(x&255)>>>1;else E=c[s>>2]|0;b:do if((D|0)==(E|0)){x=z?u:c[v>>2]|0;F=q?e:c[w>>2]|0;do if(z){if(!D){xri(m);xri(n);break}else{G=D;H=x;I=F}while(1){if((a[H>>0]|0)!=(a[I>>0]|0)){J=45;break}G=G+-1|0;if(!G){J=42;break}else{H=H+1|0;I=I+1|0}}if((J|0)==42){J=0;xri(m);xri(n);break}else if((J|0)==45){J=0;xri(m);xri(n);K=0;break b}}else{L=(FEi(x,F,D)|0)==0;xri(m);xri(n);if(!L){K=0;break b}}while(0);yri(j,l)|0;K=2}else{xri(m);xri(n);K=0}while(0);xri(l);if((K|0)==2)break a;z=c[r+4>>2]|0;if(!z){q=r;while(1){F=c[q+8>>2]|0;if((c[F>>2]|0)==(q|0)){M=F;break}else q=F}}else{q=z;while(1){F=c[q>>2]|0;if(!F){M=q;break}else q=F}}if((M|0)==(y|0))break;else r=M}}}while(0);M=a[j>>0]|0;if(!(M&1)){N=(M&255)>>>1;O=j+1|0}else{N=c[p>>2]|0;O=c[j+8>>2]|0}if(N>>>0>2147483631)ori(o);if(N>>>0<11){a[o>>0]=N<<1;P=o;Q=o+1|0}else{p=N+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];M=cOb(p,16,g,0,3653512,80)|0;c[o+8>>2]=M;c[o>>2]=p|1;c[o+4>>2]=N;P=o;Q=M}YEi(Q|0,O|0,N|0)|0;a[Q+N>>0]=0;rNc(g,d+64|0,o);c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];if(!(a[P>>0]&1)){xri(j);i=f;return}P=c[o+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(P,g);xri(j);i=f;return}function gNc(a,b){a=a|0;b=b|0;c[a>>2]=c[b+64>>2];c[a+4>>2]=b+68;return}function hNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+64>>2]|0;j=a+68|0;if((h|0)==(j|0)){k=0;i=e;return k|0}l=a+48|0;a=d+8|0;m=d+12|0;n=d+4|0;o=h;h=0;while(1){if((c[o+36>>2]|0)==(b|0)){p=o+32|0;if((c[p>>2]|0)>0){q=o+28|0;r=0;do{s=c[(c[l>>2]|0)+((c[q>>2]|0)+r<<2)>>2]|0;t=(c[a>>2]|0)+1|0;c[a>>2]=t;u=c[m>>2]|0;v=u&2147483647;if(t>>>0>v>>>0){w=u<<1;x=(w|0)==0?1:w;do if(v>>>0<x>>>0)if((u|0)>-1){c[m>>2]=x;w=c[d>>2]|0;c[g>>2]=c[n>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(w,x<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[n>>2];c[f+0>>2]=c[g+0>>2];w=cOb(x<<2,4,f,0,3653512,352)|0;YEi(w|0,c[d>>2]|0,c[a>>2]<<2|0)|0;c[m>>2]=x;c[d>>2]=w;break}while(0);y=c[a>>2]|0}else y=t;c[(c[d>>2]|0)+(y+-1<<2)>>2]=s;r=r+1|0}while((r|0)<(c[p>>2]|0));z=1}else z=1}else z=h;p=c[o+4>>2]|0;if(!p){r=o;while(1){q=c[r+8>>2]|0;if((c[q>>2]|0)==(r|0)){A=q;break}else r=q}}else{r=p;while(1){q=c[r>>2]|0;if(!q){A=r;break}else r=q}}if((A|0)==(j|0)){k=z;break}else{o=A;h=z}}i=e;return k|0}function iNc(a){a=a|0;return 1}function jNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(108,e,1,16,3653512,55)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];eNc(f,e,b);i=d;return f|0}function kNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;xWb(a,b);ddd(b,3);j=c[142306]|0;add(b,601336,j,a+48|0,0);c[g>>2]=0;$cd(b,2646336,2646336,f,0);add(b,3142592,c[142276]|0,g,0);k=e+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,g,1);l=b+12|0;m=b+20|0;c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,k,1);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);k=a+64|0;add(b,611672,c[142272]|0,k,0);uNc(b,k,0);bdd(b);k=a+32|0;add(b,601320,601480,k,0);vNc(k,b);bdd(b);add(b,601352,c[142304]|0,a+28|0,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142294]|0;add(b,601376,k,a+88|0,0);$cd(b,2646336,2646336,e,1);n=c[142260]|0;add(b,3142592,n,f,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,622128,j,a+92|0,0);c[h>>2]=0;qbc(h);$cd(b,2646336,2646336,g,0);add(b,3142592,k,h,0);$cd(b,2646336,2646336,e,1);add(b,3142592,n,f,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);cdd(b);ubc(h);bdd(b);add(b,601400,c[142258]|0,a+104|0,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function lNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;e=i;i=i+144|0;f=e+4|0;g=e+64|0;h=e+108|0;j=e;k=e+104|0;l=e+112|0;m=e+116|0;n=e+80|0;o=e+76|0;p=e+8|0;q=e+36|0;r=e+92|0;yWb(b,d);rdd(d,3);s=b+28|0;c[s>>2]=0;if(!(wdd(d,1)|0)){t=b+48|0;u=c[142306]|0;v=qdd(d,601336,u,f,1)|0;if(v){if((v|0)<=0){v=c[f>>2]|0;if(v)_n[v&4095](t,d)|0}else ANc(d,t,0);sdd(d)}t=b+64|0;v=qdd(d,611672,c[142272]|0,f,1)|0;if(v){if((v|0)<=0){v=c[f>>2]|0;if(v)_n[v&4095](t,d)|0}else BNc(d,t,0);sdd(d)}t=b+32|0;v=qdd(d,601320,601480,f,1)|0;if(v){if((v|0)<=0){v=c[f>>2]|0;if(v)_n[v&4095](t,d)|0}else CNc(t,d);sdd(d)}if(!(wdd(d,2)|0)?(t=qdd(d,601352,c[142304]|0,g,0)|0,(t|0)!=0):0){if((t|0)>0){t=d+12|0;v=c[d+16>>2]|0;w=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;x=v+w|0;c[t>>2]=x;if((w|0)>=0?(y=v+(w+4)|0,y>>>0<=(c[d+20>>2]|0)>>>0):0){c[s>>2]=c[x>>2];c[t>>2]=y}else Bid(t,s,4);if(c[d>>2]&512)c[s>>2]=XEi(c[s>>2]|0)|0}else{t=c[g>>2]|0;if(t)_n[t&4095](s,d)|0}sdd(d)}s=b+88|0;t=qdd(d,601376,c[142294]|0,f,1)|0;if(t){if((t|0)<=0){t=c[f>>2]|0;if(t)_n[t&4095](s,d)|0}else zUb(s,d);sdd(d)}s=b+92|0;t=qdd(d,622128,u,f,1)|0;if(t){if((t|0)<=0){t=c[f>>2]|0;if(t)_n[t&4095](s,d)|0}else DNc(d,s,0);sdd(d)}s=b+104|0;t=qdd(d,601400,c[142258]|0,f,0)|0;if(!t){i=e;return}do if((t|0)<=0){u=c[f>>2]|0;if(u)_n[u&4095](s,d)|0}else{u=d+12|0;y=c[d+16>>2]|0;x=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;w=y+x|0;c[u>>2]=w;if((x|0)>=0?(y+(x+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[s>>0]=a[w>>0]|0;c[u>>2]=(c[u>>2]|0)+1;break}Bid(u,s,1)}while(0);sdd(d);i=e;return}s=n+4|0;c[s>>2]=0;c[n+8>>2]=0;t=n+4|0;c[n>>2]=t;u=qdd(d,611672,c[142272]|0,f,1)|0;if(u){if((u|0)<=0){u=c[f>>2]|0;if(u)_n[u&4095](n,d)|0}else wNc(d,n,0);sdd(d)}c[o>>2]=0;u=qdd(d,601320,c[142276]|0,f,1)|0;if(u){if((u|0)<=0){u=c[f>>2]|0;if(u)_n[u&4095](o,d)|0}else dyc(o,d);sdd(d)}d=b+64|0;u=b+68|0;qNc(d,c[u>>2]|0);w=b+72|0;c[w>>2]=0;x=b+68|0;c[d>>2]=x;c[x>>2]=0;x=c[n>>2]|0;a:do if((x|0)!=(t|0)){y=r+1|0;v=q+1|0;z=q+12|0;A=q+20|0;B=q+24|0;C=p+1|0;D=p+12|0;E=p+20|0;F=p+24|0;G=m+1|0;H=m+12|0;I=m+20|0;J=m+24|0;K=r+8|0;L=q+8|0;M=p+8|0;N=m+8|0;O=m+4|0;P=p+4|0;Q=q+4|0;R=r+4|0;S=x;while(1){T=c[S+28>>2]|0;U=S+16|0;V=a[U>>0]|0;if(!(V&1)){W=(V&255)>>>1;X=U+1|0}else{W=c[S+20>>2]|0;X=c[S+24>>2]|0}if(W>>>0>2147483631){Y=20;break}if(W>>>0<11){a[r>>0]=W<<1;Z=y}else{U=W+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];V=cOb(U,16,f,0,3653512,80)|0;c[K>>2]=V;c[r>>2]=U|1;c[R>>2]=W;Z=V}YEi(Z|0,X|0,W|0)|0;a[Z+W>>0]=0;V=a[r>>0]|0;if(!(V&1)){_=(V&255)>>>1;$=y}else{_=c[R>>2]|0;$=c[K>>2]|0}if(_>>>0>2147483631){Y=28;break}if(_>>>0<11){a[q>>0]=_<<1;aa=v}else{V=_+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];U=cOb(V,16,f,0,3653512,80)|0;c[L>>2]=U;c[q>>2]=V|1;c[Q>>2]=_;aa=U}YEi(aa|0,$|0,_|0)|0;a[aa+_>>0]=0;U=z;c[U>>2]=0;c[U+4>>2]=0;c[A>>2]=T;a[B>>0]=0;T=a[q>>0]|0;if(!(T&1)){ba=(T&255)>>>1;ca=v}else{ba=c[Q>>2]|0;ca=c[L>>2]|0}if(ba>>>0>2147483631){Y=36;break}if(ba>>>0<11){a[p>>0]=ba<<1;ea=C}else{T=ba+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];U=cOb(T,16,f,0,3653512,80)|0;c[M>>2]=U;c[p>>2]=T|1;c[P>>2]=ba;ea=U}YEi(ea|0,ca|0,ba|0)|0;a[ea+ba>>0]=0;U=z;T=c[U+4>>2]|0;V=D;c[V>>2]=c[U>>2];c[V+4>>2]=T;c[E>>2]=c[A>>2];a[F>>0]=a[B>>0]|0;T=a[p>>0]|0;if(!(T&1)){fa=(T&255)>>>1;ga=C}else{fa=c[P>>2]|0;ga=c[M>>2]|0}if(fa>>>0>2147483631){Y=44;break}if(fa>>>0<11){a[m>>0]=fa<<1;ha=G}else{T=fa+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];V=cOb(T,16,f,0,3653512,80)|0;c[N>>2]=V;c[m>>2]=T|1;c[O>>2]=fa;ha=V}YEi(ha|0,ga|0,fa|0)|0;a[ha+fa>>0]=0;V=D;T=c[V+4>>2]|0;U=H;c[U>>2]=c[V>>2];c[U+4>>2]=T;c[I>>2]=c[E>>2];a[J>>0]=a[F>>0]|0;T=xNc(d,f,m)|0;yNc(g,d,m);U=c[g>>2]|0;c[g>>2]=0;V=c[f>>2]|0;c[U>>2]=0;c[U+4>>2]=0;c[U+8>>2]=V;c[T>>2]=U;V=c[c[d>>2]>>2]|0;if(!V)ia=U;else{c[d>>2]=V;ia=c[T>>2]|0}GN(c[u>>2]|0,ia);c[w>>2]=(c[w>>2]|0)+1;if(a[m>>0]&1){T=c[N>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(T,f)}if(a[p>>0]&1){T=c[M>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(T,f)}if(a[q>>0]&1){T=c[L>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(T,f)}if(a[r>>0]&1){T=c[K>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(T,f)}T=c[S+4>>2]|0;if(!T){V=S;while(1){U=c[V+8>>2]|0;if((c[U>>2]|0)==(V|0)){ja=U;break}else V=U}}else{V=T;while(1){U=c[V>>2]|0;if(!U){ja=V;break}else V=U}}if((ja|0)==(t|0))break a;else S=ja}if((Y|0)==20)ori(r);else if((Y|0)==28)ori(q);else if((Y|0)==36)ori(p);else if((Y|0)==44)ori(m)}while(0);c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=c[o>>2];zNc(n,c[s>>2]|0);i=e;return}function mNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;zWb(b,d);f=b+28|0;c[f>>2]=0;ENc(d,b+48|0,0);FNc(d,b+64|0,0);GNc(b+32|0,d);g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0)Bid(g,f,4);else{c[f>>2]=c[h>>2];c[g>>2]=j}CUb(b+88|0,d);HNc(d,b+92|0,0);j=b+104|0;b=c[g>>2]|0;if((b+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,j,1);Ndd(d);i=e;return}else{a[j>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Ndd(d);i=e;return}}function nNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;AWb(b,d);f=b+28|0;c[f>>2]=0;INc(d,b+48|0,0);JNc(d,b+64|0,0);KNc(b+32|0,d);g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0){Bid(g,f,4);l=c[f>>2]|0}else{m=c[h>>2]|0;c[f>>2]=m;c[g>>2]=j;l=m}c[f>>2]=XEi(l|0)|0;EUb(b+88|0,d);LNc(d,b+92|0,0);l=b+104|0;b=c[g>>2]|0;if((b+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,l,1);Mdd(d);i=e;return}else{a[l>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Mdd(d);i=e;return}}function oNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;BWb(b,d);g=b+56|0;h=c[g>>2]|0;c[f>>2]=h;j=d+12|0;k=c[j>>2]|0;l=k+4|0;m=d+20|0;if(l>>>0<(c[m>>2]|0)>>>0){c[k>>2]=h;c[j>>2]=l}else Gid(j,f,4);l=c[b+48>>2]|0;h=c[g>>2]|0;g=l+(h<<2)|0;if(h){h=l;do{Yxc(h,d);h=h+4|0}while((h|0)!=(g|0))}g=c[b+72>>2]|0;c[f>>2]=g;h=c[j>>2]|0;l=h+4|0;if(l>>>0<(c[m>>2]|0)>>>0){c[h>>2]=g;c[j>>2]=l}else Gid(j,f,4);l=b+68|0;g=c[b+64>>2]|0;if((g|0)!=(l|0)){h=c[142266]|0;k=g;while(1){FXb(d,k+16|0,h,0);MNc(k+28|0,d);g=c[k+4>>2]|0;if(!g){n=k;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=g;while(1){o=c[n>>2]|0;if(!o){p=n;break}else n=o}}if((p|0)==(l|0))break;else k=p}}MNc(b+32|0,d);p=b+28|0;k=c[j>>2]|0;l=k+4|0;if(l>>>0<(c[m>>2]|0)>>>0){c[k>>2]=c[p>>2];c[j>>2]=l}else Gid(j,p,4);GUb(b+88|0,d);p=b+96|0;l=c[p>>2]|0;k=b+92|0;h=c[k>>2]|0;n=l-h>>2;c[f>>2]=n;g=c[j>>2]|0;o=g+4|0;if(o>>>0<(c[m>>2]|0)>>>0){c[g>>2]=n;c[j>>2]=o;q=h;r=l}else{Gid(j,f,4);q=c[k>>2]|0;r=c[p>>2]|0}if((q|0)!=(r|0)){p=q;do{GUb(p,d);p=p+4|0}while((p|0)!=(r|0))}r=b+104|0;b=c[j>>2]|0;if((b+1|0)>>>0<(c[m>>2]|0)>>>0){a[b>>0]=a[r>>0]|0;c[j>>2]=(c[j>>2]|0)+1;Tdd(d);i=e;return}else{Gid(j,r,1);Tdd(d);i=e;return}}function pNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;CWb(b,d);f=c[b+48>>2]|0;g=c[b+56>>2]|0;h=f+(g<<2)|0;if(g){g=d+12|0;j=d+28|0;k=d+32|0;l=f;do{f=c[g>>2]|0;m=xo[c[c[f>>2]>>2]&2047](f,c[l>>2]|0,c[j>>2]|0)|0;if(a[k>>0]|0)c[l>>2]=m;l=l+4|0}while((l|0)!=(h|0))}h=c[b+64>>2]|0;l=b+68|0;k=d+12|0;j=d+28|0;g=d+32|0;if((h|0)!=(l|0)){d=h;while(1){h=d+36|0;m=c[k>>2]|0;f=xo[c[c[m>>2]>>2]&2047](m,c[h>>2]|0,c[j>>2]|0)|0;if(a[g>>0]|0)c[h>>2]=f;f=c[d+4>>2]|0;if(!f){h=d;while(1){m=c[h+8>>2]|0;if((c[m>>2]|0)==(h|0)){n=m;break}else h=m}}else{h=f;while(1){m=c[h>>2]|0;if(!m){n=h;break}else h=m}}if((n|0)==(l|0))break;else d=n}}n=b+40|0;b=c[k>>2]|0;k=xo[c[c[b>>2]>>2]&2047](b,c[n>>2]|0,c[j>>2]|0)|0;if(!(a[g>>0]|0)){i=e;return}c[n>>2]=k;i=e;return}function qNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!d){i=e;return}qNc(b,c[d>>2]|0);qNc(b,c[d+4>>2]|0);if(a[d+16>>0]&1){b=c[d+24>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f)}ACi(d);i=e;return}function rNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;g=d+4|0;h=c[d+4>>2]|0;a:do if(!h)j=g;else{d=a[e>>0]|0;k=(d&1)==0;l=(d&255)>>>1;d=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;o=g;p=h;b:while(1){q=p;while(1){r=q+16|0;s=k?l:n;t=a[r>>0]|0;u=(t&1)==0;if(u)v=(t&255)>>>1;else v=c[q+20>>2]|0;if(u)w=r+1|0;else w=c[q+24>>2]|0;x=FEi(k?d:m,w,v>>>0<s>>>0?v:s)|0;if(!x){if(s>>>0<v>>>0){y=q;z=q;break}}else if((x|0)<0){y=q;z=q;break}if(u)A=(t&255)>>>1;else A=c[q+20>>2]|0;t=k?l:n;if(u)B=r+1|0;else B=c[q+24>>2]|0;r=FEi(B,k?d:m,t>>>0<A>>>0?t:A)|0;if(!r){if(A>>>0>=t>>>0){C=o;D=q;E=q;break b}}else if((r|0)>=0){C=o;D=q;E=q;break b}q=c[q+4>>2]|0;if(!q){j=o;break a}}p=c[y>>2]|0;if(!p){j=z;break a}else o=z}o=c[D>>2]|0;c:do if(!o)F=E;else{p=k?l:n;q=k?d:m;r=E;t=o;while(1){u=t;while(1){x=u+16|0;s=a[x>>0]|0;if(!(s&1)){G=(s&255)>>>1;H=x+1|0}else{G=c[u+20>>2]|0;H=c[u+24>>2]|0}x=FEi(H,q,p>>>0<G>>>0?p:G)|0;if(!x){if(G>>>0>=p>>>0){I=u;break}}else if((x|0)>=0){I=u;break}u=c[u+4>>2]|0;if(!u){F=r;break c}}t=c[I>>2]|0;if(!t){F=I;break}else r=I}}while(0);o=c[D+4>>2]|0;d:do if(!o)J=C;else{r=k?l:n;t=k?d:m;p=C;q=o;while(1){u=q;while(1){x=u+16|0;s=a[x>>0]|0;if(!(s&1)){K=(s&255)>>>1;L=x+1|0}else{K=c[u+20>>2]|0;L=c[u+24>>2]|0}x=FEi(t,L,K>>>0<r>>>0?K:r)|0;if(!x){if(r>>>0<K>>>0){M=u;break}}else if((x|0)<0){M=u;break}u=c[u+4>>2]|0;if(!u){J=p;break d}}q=c[M>>2]|0;if(!q){J=M;break}else p=M}}while(0);c[b>>2]=F;c[b+4>>2]=J;i=f;return}while(0);c[b>>2]=j;c[b+4>>2]=j;i=f;return}function sNc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=601224;g=c[a+76>>2]|0;if(g)rwe(g);g=a+80|0;if(c[g>>2]|0){h=uPc()|0;sPc(h,(c[g>>2]|0)+28|0);h=c[g>>2]|0;j=c[153112]|0;if(!h){k=j;l=0;m=f}else{tPc(h);k=j;l=h;m=f}}else{k=c[153112]|0;l=0;m=f}c[f>>2]=k;c[d+0>>2]=c[f+0>>2];eOb(l,d);c[g>>2]=0;g=a+92|0;l=c[g>>2]|0;if(l){f=a+96|0;while(1){k=c[f>>2]|0;if((k|0)==(l|0))break;m=k+-4|0;c[f>>2]=m;ubc(m)}ACi(c[g>>2]|0)}ubc(a+88|0);qNc(a+64|0,c[a+68>>2]|0);if((c[a+60>>2]|0)<=-1){EWb(a);i=b;return}g=a+48|0;f=c[g>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[g>>2]=0;EWb(a);i=b;return}function tNc(a){a=a|0;var b=0;b=i;sNc(a);ACi(a);i=b;return}function uNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+48|0;f=d+36|0;g=d+32|0;h=d;$cd(b,2646336,2646336,d+28|0,e);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;a[h+24>>0]=0;add(b,3142592,c[142274]|0,h,0);add(b,c[142266]|0,c[142294]|0,h,0);$cd(b,2646336,2646336,f,1);add(b,3142592,c[142260]|0,g,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);e=h+12|0;add(b,c[142282]|0,601480,e,0);vNc(e,b);bdd(b);bdd(b);cdd(b);if(!(a[h>>0]&1)){i=d;return}b=c[h+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=d;return}function vNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=c[142270]|0;add(b,601432,f,a,0);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,601448,f,a+4|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+8|0;add(b,2486488,c[142276]|0,j,0);k=e+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,f,j,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,k,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,601464,c[142258]|0,a+12|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function wNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+80|0;f=e+4|0;g=e+32|0;h=e+8|0;j=e+44|0;k=e+64|0;l=e;m=e+16|0;n=e+48|0;o=d+8|0;c[l>>2]=c[o>>2];if(!(tdd(b,2646336,2646336,l)|0)){i=e;return};c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;p=d+4|0;zNc(d,c[p>>2]|0);c[o>>2]=0;q=d+4|0;c[d>>2]=q;c[q>>2]=0;a:do if((c[l>>2]|0)>0){q=c[142274]|0;r=m+1|0;s=n+1|0;t=m+12|0;u=n+12|0;v=k+1|0;w=k+12|0;x=n+8|0;y=k+8|0;z=k+4|0;A=n+4|0;B=m+8|0;C=m+4|0;D=0;while(1){E=qdd(b,3142592,q,f,1)|0;if(E){if((E|0)<=0){E=c[f>>2]|0;if(E)_n[E&4095](m,b)|0}else NNc(m,b);sdd(b)}E=a[m>>0]|0;if(!(E&1)){F=(E&255)>>>1;G=r}else{F=c[C>>2]|0;G=c[B>>2]|0}if(F>>>0>2147483631){H=14;break}if(F>>>0<11){a[n>>0]=F<<1;I=s}else{E=F+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];J=cOb(E,16,f,0,3653512,80)|0;c[x>>2]=J;c[n>>2]=E|1;c[A>>2]=F;I=J}YEi(I|0,G|0,F|0)|0;a[I+F>>0]=0;c[u>>2]=c[t>>2];J=a[n>>0]|0;if(!(J&1)){K=(J&255)>>>1;L=s}else{K=c[A>>2]|0;L=c[x>>2]|0}if(K>>>0>2147483631){H=22;break}if(K>>>0<11){a[k>>0]=K<<1;M=v}else{J=K+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];E=cOb(J,16,f,0,3653512,80)|0;c[y>>2]=E;c[k>>2]=J|1;c[z>>2]=K;M=E}YEi(M|0,L|0,K|0)|0;a[M+K>>0]=0;c[w>>2]=c[u>>2];E=ONc(d,f,k)|0;PNc(g,d,k);J=c[g>>2]|0;c[g>>2]=0;N=c[f>>2]|0;c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=N;c[E>>2]=J;N=c[c[d>>2]>>2]|0;if(!N)O=J;else{c[d>>2]=N;O=c[E>>2]|0}GN(c[p>>2]|0,O);c[o>>2]=(c[o>>2]|0)+1;if(a[k>>0]&1){E=c[y>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(E,f)}if(a[n>>0]&1){E=c[x>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(E,f)}D=D+1|0;if((D|0)>=(c[l>>2]|0))break a}if((H|0)==14)ori(n);else if((H|0)==22)ori(k)}while(0);udd(b);if(!(a[m>>0]&1)){i=e;return}b=c[m+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function xNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;if(!(h&1)){h=g;while(1){e=h+16|0;n=a[e>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=e+1|0}else{o=c[h+20>>2]|0;p=c[h+24>>2]|0}e=FEi(k,p,o>>>0<b>>>0?o:b)|0;if(!e)if(b>>>0<o>>>0)q=10;else q=9;else if((e|0)<0)q=10;else q=9;if((q|0)==9){q=0;e=h+4|0;n=c[e>>2]|0;if(!n){r=e;s=h;q=20;break}else{h=n;continue}}else if((q|0)==10){q=0;n=c[h>>2]|0;if(!n){t=h;u=h;q=18;break}else{h=n;continue}}}}else{h=g;while(1){g=h+16|0;o=a[g>>0]|0;if(!(o&1)){v=(o&255)>>>1;w=g+1|0}else{v=c[h+20>>2]|0;w=c[h+24>>2]|0}g=FEi(l,w,v>>>0<m>>>0?v:m)|0;if(!g)if(m>>>0<v>>>0)q=17;else q=19;else if((g|0)<0)q=17;else q=19;if((q|0)==17){q=0;g=c[h>>2]|0;if(!g){t=h;u=h;q=18;break}else{h=g;continue}}else if((q|0)==19){q=0;g=h+4|0;o=c[g>>2]|0;if(!o){r=g;s=h;q=20;break}else{h=o;continue}}}}if((q|0)==18){c[d>>2]=u;j=t;i=f;return j|0}else if((q|0)==20){c[d>>2]=s;j=r;i=f;return j|0}return 0}function yNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+4|0;h=f;j=xCi(44)|0;k=j+16|0;l=a[e>>0]|0;if(!(l&1)){m=(l&255)>>>1;n=e+1|0}else{m=c[e+4>>2]|0;n=c[e+8>>2]|0}if(m>>>0>2147483631)ori(k);if(m>>>0<11){a[k>>0]=m<<1;o=j+17|0}else{l=m+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(l,16,g,0,3653512,80)|0;c[j+24>>2]=h;c[k>>2]=l|1;c[j+20>>2]=m;o=h}YEi(o|0,n|0,m|0)|0;a[o+m>>0]=0;m=e+12|0;o=c[m+4>>2]|0;n=j+28|0;c[n>>2]=c[m>>2];c[n+4>>2]=o;c[j+36>>2]=c[e+20>>2];a[j+40>>0]=a[e+24>>0]|0;c[b>>2]=j;j=b+4|0;c[j>>2]=d+4;c[j+4>>2]=1;i=f;return}function zNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!d){i=e;return}zNc(b,c[d>>2]|0);zNc(b,c[d+4>>2]|0);if(a[d+16>>0]&1){b=c[d+24>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f)}ACi(d);i=e;return}function ANc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];QNc(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<2)|0;do if(c[f>>2]|0){j=c[142276]|0;g=qdd(a,3142592,j,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((g|0)==2){g=c[l>>2]|0;o=c[g+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(k|0)){q=0;r=g;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(h,r);t=h;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;dyc(s,a);u=s+4|0;if((u|0)==(k|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(k|0)){n=l;do{l=qdd(a,3142592,j,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else dyc(n,a);sdd(a)}n=n+4|0}while((n|0)!=(k|0))}}while(0);udd(a);i=d;return}function BNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+112|0;f=e+4|0;g=e+40|0;h=e+8|0;j=e+52|0;k=e+84|0;l=e;m=e+12|0;n=e+56|0;o=d+8|0;c[l>>2]=c[o>>2];if(!(tdd(b,2646336,2646336,l)|0)){i=e;return};c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;a[m+24>>0]=0;p=d+4|0;qNc(d,c[p>>2]|0);c[o>>2]=0;q=d+4|0;c[d>>2]=q;c[q>>2]=0;a:do if((c[l>>2]|0)>0){q=c[142274]|0;r=m+1|0;s=n+1|0;t=n+12|0;u=m+12|0;v=m+20|0;w=n+20|0;x=n+24|0;y=m+24|0;z=k+1|0;A=k+12|0;B=k+20|0;C=k+24|0;D=n+8|0;E=k+8|0;F=k+4|0;G=n+4|0;H=m+8|0;I=m+4|0;J=0;while(1){K=qdd(b,3142592,q,f,1)|0;if(K){if((K|0)<=0){K=c[f>>2]|0;if(K)_n[K&4095](m,b)|0}else RNc(m,b);sdd(b)}K=a[m>>0]|0;if(!(K&1)){L=(K&255)>>>1;M=r}else{L=c[I>>2]|0;M=c[H>>2]|0}if(L>>>0>2147483631){N=14;break}if(L>>>0<11){a[n>>0]=L<<1;O=s}else{K=L+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];P=cOb(K,16,f,0,3653512,80)|0;c[D>>2]=P;c[n>>2]=K|1;c[G>>2]=L;O=P}YEi(O|0,M|0,L|0)|0;a[O+L>>0]=0;P=u;K=c[P+4>>2]|0;Q=t;c[Q>>2]=c[P>>2];c[Q+4>>2]=K;c[w>>2]=c[v>>2];a[x>>0]=a[y>>0]|0;K=a[n>>0]|0;if(!(K&1)){R=(K&255)>>>1;S=s}else{R=c[G>>2]|0;S=c[D>>2]|0}if(R>>>0>2147483631){N=22;break}if(R>>>0<11){a[k>>0]=R<<1;T=z}else{K=R+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];Q=cOb(K,16,f,0,3653512,80)|0;c[E>>2]=Q;c[k>>2]=K|1;c[F>>2]=R;T=Q}YEi(T|0,S|0,R|0)|0;a[T+R>>0]=0;Q=t;K=c[Q+4>>2]|0;P=A;c[P>>2]=c[Q>>2];c[P+4>>2]=K;c[B>>2]=c[w>>2];a[C>>0]=a[x>>0]|0;K=xNc(d,f,k)|0;yNc(g,d,k);P=c[g>>2]|0;c[g>>2]=0;Q=c[f>>2]|0;c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=Q;c[K>>2]=P;Q=c[c[d>>2]>>2]|0;if(!Q)U=P;else{c[d>>2]=Q;U=c[K>>2]|0}GN(c[p>>2]|0,U);c[o>>2]=(c[o>>2]|0)+1;if(a[k>>0]&1){K=c[E>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(K,f)}if(a[n>>0]&1){K=c[D>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(K,f)}J=J+1|0;if((J|0)>=(c[l>>2]|0))break a}if((N|0)==14)ori(n);else if((N|0)==22)ori(k)}while(0);udd(b);if(!(a[m>>0]&1)){i=e;return}b=c[m+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function CNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=c[142270]|0;h=qdd(d,601432,g,f,0)|0;if(h){if((h|0)>0){h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[b>>2]=c[l>>2];c[h>>2]=m}else Bid(h,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](b,d)|0}sdd(d)}h=b+4|0;m=qdd(d,601448,g,f,0)|0;if(m){if((m|0)>0){m=d+12|0;g=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=g+l|0;c[m>>2]=k;if((l|0)>=0?(j=g+(l+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[m>>2]=j}else Bid(m,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}sdd(d)}h=b+8|0;m=qdd(d,2486488,c[142276]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else dyc(h,d);sdd(d)}h=b+12|0;b=qdd(d,601464,c[142258]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[m>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d);i=e;return}function DNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}SNc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142294]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;zUb(s,a);u=s+4|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else zUb(n,a);sdd(a)}n=n+4|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function ENc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];QNc(b,s,e);s=c[b>>2]|0;k=c[b+8>>2]|0;t=s+(k<<2)|0;if(!k){i=d;return}else u=s;do{Pxc(u,a);u=u+4|0}while((u|0)!=(t|0));i=d;return}if(r){Bid(l,h,4);v=c[l>>2]|0;w=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;v=o;w=q}q=v+4|0;if(q>>>0>w>>>0){Bid(l,g,4);x=c[g>>2]|0}else{w=c[v>>2]|0;c[g>>2]=w;c[l>>2]=q;x=w}w=c[h>>2]<<2;h=zid(l,x,w)|0;x=b+12|0;if((c[x>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=w>>2;c[b+8>>2]=e;c[x>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function FNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+112|0;f=e+4|0;g=e+40|0;h=e+8|0;j=e+52|0;k=e+84|0;l=e;m=e+12|0;n=e+56|0;o=b+12|0;p=c[o>>2]|0;q=p+4|0;if(q>>>0>(c[b+20>>2]|0)>>>0)Bid(o,l,4);else{c[l>>2]=c[p>>2];c[o>>2]=q};c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;a[m+24>>0]=0;q=d+4|0;qNc(d,c[q>>2]|0);o=d+8|0;c[o>>2]=0;p=d+4|0;c[d>>2]=p;c[p>>2]=0;a:do if((c[l>>2]|0)>0){p=m+12|0;r=m+1|0;s=n+1|0;t=n+12|0;u=m+20|0;v=n+20|0;w=n+24|0;x=m+24|0;y=k+1|0;z=k+12|0;A=k+20|0;B=k+24|0;C=n+8|0;D=k+8|0;E=k+4|0;F=n+4|0;G=m+8|0;H=m+4|0;I=0;while(1){NXb(b,m,1);Ndd(b);GNc(p,b);J=a[m>>0]|0;if(!(J&1)){K=(J&255)>>>1;L=r}else{K=c[H>>2]|0;L=c[G>>2]|0}if(K>>>0>2147483631){M=10;break}if(K>>>0<11){a[n>>0]=K<<1;N=s}else{J=K+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];O=cOb(J,16,f,0,3653512,80)|0;c[C>>2]=O;c[n>>2]=J|1;c[F>>2]=K;N=O}YEi(N|0,L|0,K|0)|0;a[N+K>>0]=0;O=p;J=c[O+4>>2]|0;P=t;c[P>>2]=c[O>>2];c[P+4>>2]=J;c[v>>2]=c[u>>2];a[w>>0]=a[x>>0]|0;J=a[n>>0]|0;if(!(J&1)){Q=(J&255)>>>1;R=s}else{Q=c[F>>2]|0;R=c[C>>2]|0}if(Q>>>0>2147483631){M=18;break}if(Q>>>0<11){a[k>>0]=Q<<1;S=y}else{J=Q+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];P=cOb(J,16,f,0,3653512,80)|0;c[D>>2]=P;c[k>>2]=J|1;c[E>>2]=Q;S=P}YEi(S|0,R|0,Q|0)|0;a[S+Q>>0]=0;P=t;J=c[P+4>>2]|0;O=z;c[O>>2]=c[P>>2];c[O+4>>2]=J;c[A>>2]=c[v>>2];a[B>>0]=a[w>>0]|0;J=xNc(d,f,k)|0;yNc(g,d,k);O=c[g>>2]|0;c[g>>2]=0;P=c[f>>2]|0;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=P;c[J>>2]=O;P=c[c[d>>2]>>2]|0;if(!P)T=O;else{c[d>>2]=P;T=c[J>>2]|0}GN(c[q>>2]|0,T);c[o>>2]=(c[o>>2]|0)+1;if(a[k>>0]&1){J=c[D>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(J,f)}if(a[n>>0]&1){J=c[C>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(J,f)}I=I+1|0;if((I|0)>=(c[l>>2]|0))break a}if((M|0)==10)ori(n);else if((M|0)==18)ori(k)}while(0);if(!(a[m>>0]&1)){i=e;return}k=c[m+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function GNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,b,4);l=c[j>>2]|0;m=c[f>>2]|0}else{c[b>>2]=c[g>>2];c[f>>2]=h;l=k;m=h}h=b+4|0;k=m+4|0;if(k>>>0>l>>>0)Bid(f,h,4);else{c[h>>2]=c[m>>2];c[f>>2]=k}Pxc(b+8|0,d);k=b+12|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,k,1);Ndd(d);i=e;return}else{a[k>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function HNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}SNc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{CUb(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function INc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];QNc(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<2)|0;if(!k){i=d;return}else u=t;do{Vxc(u,a);u=u+4|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<2;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>2;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function JNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+112|0;f=e+4|0;g=e+40|0;h=e+8|0;j=e+52|0;k=e+84|0;l=e;m=e+12|0;n=e+56|0;o=b+12|0;p=c[o>>2]|0;q=p+4|0;if(q>>>0>(c[b+20>>2]|0)>>>0){Bid(o,l,4);r=c[l>>2]|0}else{s=c[p>>2]|0;c[l>>2]=s;c[o>>2]=q;r=s}c[l>>2]=XEi(r|0)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;a[m+24>>0]=0;r=d+4|0;qNc(d,c[r>>2]|0);s=d+8|0;c[s>>2]=0;q=d+4|0;c[d>>2]=q;c[q>>2]=0;a:do if((c[l>>2]|0)>0){q=m+12|0;o=m+1|0;p=n+1|0;t=n+12|0;u=m+20|0;v=n+20|0;w=n+24|0;x=m+24|0;y=k+1|0;z=k+12|0;A=k+20|0;B=k+24|0;C=n+8|0;D=k+8|0;E=k+4|0;F=n+4|0;G=m+8|0;H=m+4|0;I=0;while(1){OXb(b,m,1);Mdd(b);KNc(q,b);J=a[m>>0]|0;if(!(J&1)){K=(J&255)>>>1;L=o}else{K=c[H>>2]|0;L=c[G>>2]|0}if(K>>>0>2147483631){M=10;break}if(K>>>0<11){a[n>>0]=K<<1;N=p}else{J=K+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];O=cOb(J,16,f,0,3653512,80)|0;c[C>>2]=O;c[n>>2]=J|1;c[F>>2]=K;N=O}YEi(N|0,L|0,K|0)|0;a[N+K>>0]=0;O=q;J=c[O+4>>2]|0;P=t;c[P>>2]=c[O>>2];c[P+4>>2]=J;c[v>>2]=c[u>>2];a[w>>0]=a[x>>0]|0;J=a[n>>0]|0;if(!(J&1)){Q=(J&255)>>>1;R=p}else{Q=c[F>>2]|0;R=c[C>>2]|0}if(Q>>>0>2147483631){M=18;break}if(Q>>>0<11){a[k>>0]=Q<<1;S=y}else{J=Q+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];P=cOb(J,16,f,0,3653512,80)|0;c[D>>2]=P;c[k>>2]=J|1;c[E>>2]=Q;S=P}YEi(S|0,R|0,Q|0)|0;a[S+Q>>0]=0;P=t;J=c[P+4>>2]|0;O=z;c[O>>2]=c[P>>2];c[O+4>>2]=J;c[A>>2]=c[v>>2];a[B>>0]=a[w>>0]|0;J=xNc(d,f,k)|0;yNc(g,d,k);O=c[g>>2]|0;c[g>>2]=0;P=c[f>>2]|0;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=P;c[J>>2]=O;P=c[c[d>>2]>>2]|0;if(!P)T=O;else{c[d>>2]=P;T=c[J>>2]|0}GN(c[r>>2]|0,T);c[s>>2]=(c[s>>2]|0)+1;if(a[k>>0]&1){J=c[D>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(J,f)}if(a[n>>0]&1){J=c[C>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(J,f)}I=I+1|0;if((I|0)>=(c[l>>2]|0))break a}if((M|0)==10)ori(n);else if((M|0)==18)ori(k)}while(0);if(!(a[m>>0]&1)){i=e;return}k=c[m+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function KNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,b,4);l=c[f>>2]|0;m=c[j>>2]|0;n=c[b>>2]|0}else{o=c[g>>2]|0;c[b>>2]=o;c[f>>2]=h;l=h;m=k;n=o}c[b>>2]=XEi(n|0)|0;n=b+4|0;o=l+4|0;if(o>>>0>m>>>0){Bid(f,n,4);p=c[n>>2]|0}else{m=c[l>>2]|0;c[n>>2]=m;c[f>>2]=o;p=m}c[n>>2]=XEi(p|0)|0;Vxc(b+8|0,d);p=b+12|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,p,1);Mdd(d);i=e;return}else{a[p>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function LNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;SNc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{EUb(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function MNc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0<k>>>0){c[g>>2]=c[b>>2];c[f>>2]=h;l=k;m=h}else{Gid(f,b,4);l=c[j>>2]|0;m=c[f>>2]|0}h=b+4|0;k=m+4|0;if(k>>>0<l>>>0){c[m>>2]=c[h>>2];c[f>>2]=k}else Gid(f,h,4);Yxc(b+8|0,d);h=b+12|0;b=c[f>>2]|0;if((b+1|0)>>>0<(c[j>>2]|0)>>>0){a[b>>0]=a[h>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Tdd(d);i=e;return}else{Gid(f,h,1);Tdd(d);i=e;return}}function NNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,c[142294]|0,e,0)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else zXb(b,a,1);sdd(b)}f=a+12|0;a=qdd(b,c[142282]|0,c[142276]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else dyc(f,b);sdd(b);i=d;return}function ONc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;if(!(h&1)){h=g;while(1){e=h+16|0;n=a[e>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=e+1|0}else{o=c[h+20>>2]|0;p=c[h+24>>2]|0}e=FEi(k,p,o>>>0<b>>>0?o:b)|0;if(!e)if(b>>>0<o>>>0)q=10;else q=9;else if((e|0)<0)q=10;else q=9;if((q|0)==9){q=0;e=h+4|0;n=c[e>>2]|0;if(!n){r=e;s=h;q=20;break}else{h=n;continue}}else if((q|0)==10){q=0;n=c[h>>2]|0;if(!n){t=h;u=h;q=18;break}else{h=n;continue}}}}else{h=g;while(1){g=h+16|0;o=a[g>>0]|0;if(!(o&1)){v=(o&255)>>>1;w=g+1|0}else{v=c[h+20>>2]|0;w=c[h+24>>2]|0}g=FEi(l,w,v>>>0<m>>>0?v:m)|0;if(!g)if(m>>>0<v>>>0)q=17;else q=19;else if((g|0)<0)q=17;else q=19;if((q|0)==17){q=0;g=c[h>>2]|0;if(!g){t=h;u=h;q=18;break}else{h=g;continue}}else if((q|0)==19){q=0;g=h+4|0;o=c[g>>2]|0;if(!o){r=g;s=h;q=20;break}else{h=o;continue}}}}if((q|0)==18){c[d>>2]=u;j=t;i=f;return j|0}else if((q|0)==20){c[d>>2]=s;j=r;i=f;return j|0}return 0}function PNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+4|0;h=f;j=xCi(32)|0;k=j+16|0;l=a[e>>0]|0;if(!(l&1)){m=(l&255)>>>1;n=e+1|0}else{m=c[e+4>>2]|0;n=c[e+8>>2]|0}if(m>>>0>2147483631)ori(k);if(m>>>0<11){a[k>>0]=m<<1;o=j+17|0}else{l=m+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(l,16,g,0,3653512,80)|0;c[j+24>>2]=h;c[k>>2]=l|1;c[j+20>>2]=m;o=h}YEi(o|0,n|0,m|0)|0;a[o+m>>0]=0;c[j+28>>2]=c[e+12>>2];c[b>>2]=j;j=b+4|0;c[j>>2]=d+4;c[j+4>>2]=1;i=f;return}function QNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a>>2]|0;if(!h)c[a+4>>2]=c[d>>2];d=a+12|0;j=c[d>>2]|0;do if((j&2147483647)>>>0<b>>>0)if((j|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=hOb(h,b<<2,4,f,0,3653512,370)|0;c[a>>2]=k;l=k;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];k=cOb(b<<2,4,f,0,3653512,352)|0;YEi(k|0,c[a>>2]|0,c[a+8>>2]<<2|0)|0;c[d>>2]=b;c[a>>2]=k;l=k;break}else l=h;while(0);h=a+8|0;a=c[h>>2]|0;if(a>>>0>=b>>>0){c[h>>2]=b;i=e;return}d=l+(b<<2)|0;if((a|0)==(b|0)){c[h>>2]=b;i=e;return}f=l+(a<<2)|0;do{if(f)c[f>>2]=0;f=f+4|0}while((f|0)!=(d|0));c[h>>2]=b;i=e;return}function RNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,c[142294]|0,e,0)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else zXb(b,a,1);sdd(b)}f=a+12|0;a=qdd(b,c[142282]|0,601480,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else CNc(f,b);sdd(b);i=d;return}function SNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+44|0;f=d+32|0;g=d+16|0;h=d+36|0;j=d+12|0;k=d;l=d+28|0;m=d+40|0;n=d+48|0;o=a+4|0;p=c[a>>2]|0;q=p;r=(c[o>>2]|0)-q>>2;if(r>>>0>=b>>>0){if(r>>>0<=b>>>0){i=d;return}c[l>>2]=p;c[m>>2]=p+(b<<2);c[f+0>>2]=c[l+0>>2];c[e+0>>2]=c[m+0>>2];WNc(k,f,e,n,0);n=c[k>>2]|0;m=c[a>>2]|0;c[k>>2]=m;c[a>>2]=n;n=k+4|0;l=c[n>>2]|0;p=c[o>>2]|0;c[n>>2]=p;c[o>>2]=l;l=k+8|0;s=a+8|0;t=c[l>>2]|0;c[l>>2]=c[s>>2];c[s>>2]=t;if(!m){i=d;return}else u=p;while(1){if((u|0)==(m|0))break;p=u+-4|0;c[n>>2]=p;ubc(p);u=c[n>>2]|0}ACi(c[k>>2]|0);i=d;return}k=a+8|0;if(((c[k>>2]|0)-q>>2|0)==(b|0)){VNc(a,b-r|0);i=d;return}c[g>>2]=0;r=g+4|0;c[r>>2]=0;q=g+8|0;c[q>>2]=0;TNc(g,b);c[h>>2]=c[a>>2];c[j>>2]=c[o>>2];c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];UNc(g,f,e);e=c[r>>2]|0;f=c[g>>2]|0;j=e-f>>2;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<2)|0,(e|0)!=(h|0)):0){f=e;do{n=f+-4|0;c[r>>2]=n;ubc(n);f=c[r>>2]|0}while((f|0)!=(h|0));v=h}else v=e;else{VNc(g,b-j|0);v=c[r>>2]|0}j=c[g>>2]|0;b=c[a>>2]|0;c[g>>2]=b;c[a>>2]=j;j=c[o>>2]|0;c[r>>2]=j;c[o>>2]=v;v=c[q>>2]|0;c[q>>2]=c[k>>2];c[k>>2]=v;if(!b){i=d;return}else w=j;while(1){if((w|0)==(b|0))break;j=w+-4|0;c[r>>2]=j;ubc(j);w=c[r>>2]|0}ACi(c[g>>2]|0);i=d;return}function TNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((c[e>>2]|0)-g>>2>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b<<2)|0;l=k+(j-g>>2<<2)|0;g=k+(b<<2)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=j+-4|0;b=b+-4|0;c[k>>2]=0;sbc(k,b);if((b|0)==(f|0)){p=k;break}else j=k}m=p;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-4|0;ubc(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function UNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[b>>2]|0;b=c[d>>2]|0;d=f;g=b-d>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>2>>>0){if(!k)m=j;else{j=a+4|0;while(1){n=c[j>>2]|0;if((n|0)==(k|0))break;o=n+-4|0;c[j>>2]=o;ubc(o)}ACi(c[a>>2]|0);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>1073741823)vxi(a);j=m-0|0;if(j>>2>>>0<536870911){m=j>>1;j=m>>>0<g>>>0?g:m;if(j>>>0>1073741823)vxi(a);else p=j}else p=1073741823;j=xCi(p<<2)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(p<<2);if((f|0)==(b|0)){i=e;return}else{q=j;r=f}do{c[q>>2]=0;sbc(q,r);q=(c[m>>2]|0)+4|0;c[m>>2]=q;r=r+4|0}while((r|0)!=(b|0));i=e;return}r=a+4|0;a=(c[r>>2]|0)-l>>2;if(g>>>0>a>>>0){s=f+(a<<2)|0;t=1}else{s=b;t=0}if((f|0)==(s|0))u=k;else{a=(s+-4-d|0)>>>2;d=k;g=f;while(1){rbc(d,g);g=g+4|0;if((g|0)==(s|0))break;else d=d+4|0}u=k+(a+1<<2)|0}if(!t){while(1){t=c[r>>2]|0;if((t|0)==(u|0))break;a=t+-4|0;c[r>>2]=a;ubc(a)}i=e;return}if((s|0)==(b|0)){i=e;return}u=c[r>>2]|0;a=s;do{if(!u)v=0;else{c[u>>2]=0;sbc(u,a);v=c[r>>2]|0}u=v+4|0;c[r>>2]=u;a=a+4|0}while((a|0)!=(b|0));i=e;return}function VNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l>>2]=0;qbc(l);m=c[g>>2]|0}l=m+4|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=k;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>2;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=1073741823;r=(c[g>>2]|0)-j>>2;s=10}if((s|0)==10){n=q;o=xCi(q<<2)|0;p=r}r=o+(p<<2)|0;p=o+(n<<2)|0;n=b;b=r;while(1){if(!b)t=0;else{c[b>>2]=0;qbc(b);t=b}o=t+4|0;n=n+-1|0;if(!n){u=o;break}else b=o}b=c[a>>2]|0;n=c[g>>2]|0;if((n|0)==(b|0)){v=r;w=b;x=b}else{t=n;n=r;while(1){r=n+-4|0;t=t+-4|0;c[r>>2]=0;sbc(r,t);if((t|0)==(b|0)){y=r;break}else n=r}v=y;w=c[a>>2]|0;x=c[g>>2]|0}c[a>>2]=v;c[g>>2]=u;c[e>>2]=p;p=x;while(1){if((p|0)==(w|0))break;x=p+-4|0;ubc(x);p=x}if(!w){i=d;return}ACi(w);i=d;return}function WNc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;g=a+8|0;c[g>>2]=0;h=c[b>>2]|0;b=c[d>>2]|0;d=b-h|0;j=d>>2;if(!j){i=f;return}if(j>>>0>1073741823)vxi(a);k=xCi(d)|0;c[e>>2]=k;c[a>>2]=k;c[g>>2]=k+(j<<2);if((h|0)==(b|0)){i=f;return}else{l=k;m=h}do{c[l>>2]=0;sbc(l,m);l=(c[e>>2]|0)+4|0;c[e>>2]=l;m=m+4|0}while((m|0)!=(b|0));i=f;return}function XNc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(32,b,0,16,3653512,12)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[150374]=d;i=a;return}function YNc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;h=c[150374]|0;j=c[153072]|0;if(h){if(a[h+12>>0]&1){k=c[h+20>>2]|0;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];eOb(k,d)}if(!(a[h>>0]&1))l=h;else{k=c[h+8>>2]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];eOb(k,d);l=h}}else l=0;c[g>>2]=j;c[d+0>>2]=c[g+0>>2];eOb(l,d);c[150374]=0;i=b;return}function ZNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;if(!(c[a+16>>2]|0)){f=1;i=d;return f|0}g=kfd()|0;h=+Ki()*1.0e6;j=~~h>>>0;k=+S(h)>=1.0?(h>0.0?(ha(+R(h/4294967296.0),4294967295.0)|0)>>>0:~~+ca((h-+(~~h>>>0))/4294967296.0)>>>0):0;h=+Ki()*1.0e6;l=ZEi(~~h>>>0|0,(+S(h)>=1.0?(h>0.0?(ha(+R(h/4294967296.0),4294967295.0)|0)>>>0:~~+ca((h-+(~~h>>>0))/4294967296.0)>>>0):0)|0,j|0,k|0)|0;m=Ycd(l,H)|0;l=hFi(m|0,H|0,1e6,0)|0;if((~~ea(+(l>>>0)+4294967296.0*+(H>>>0))|0)>=(b|0)){f=0;i=d;return f|0}while(1){if(!(eOc(a,e)|0)){f=0;n=5;break}Zed(g,c[e>>2]|0)|0;h=+Ki()*1.0e6;l=ZEi(~~h>>>0|0,(+S(h)>=1.0?(h>0.0?(ha(+R(h/4294967296.0),4294967295.0)|0)>>>0:~~+ca((h-+(~~h>>>0))/4294967296.0)>>>0):0)|0,j|0,k|0)|0;m=Ycd(l,H)|0;l=hFi(m|0,H|0,1e6,0)|0;if((~~ea(+(l>>>0)+4294967296.0*+(H>>>0))|0)>=(b|0)){f=0;n=5;break}}if((n|0)==5){i=d;return f|0}return 0}function _Nc(a){a=a|0;return c[a+56>>2]|0}function $Nc(a,b){a=a|0;b=b|0;c[a+56>>2]=b;return}function aOc(a){a=a|0;return 1}function bOc(a,b){a=a|0;b=b|0;return}function cOc(a){a=a|0;return 0}function dOc(a){a=a|0;return 1}function eOc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+20|0;j=c[h>>2]|0;k=j+16|0;l=(c[j+20>>2]|0)-(c[k>>2]|0)|0;m=c[j+12>>2]|0;n=m+-1&c[k>>2];k=m-n|0;if((k>>>0<l>>>0?k:l)>>>0<=3){o=0;i=e;return o|0}c[d>>2]=c[(c[j>>2]|0)+n>>2];n=(c[h>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+4;n=b+16|0;c[n>>2]=(c[n>>2]|0)+-4;if(!(c[(c[h>>2]|0)+24>>2]|0)){o=1;i=e;return o|0}n=c[h>>2]|0;if((c[n+20>>2]|0)!=(c[n+16>>2]|0)){o=1;i=e;return o|0}n=b+12|0;c[n>>2]=(c[n>>2]|0)-(c[(c[h>>2]|0)+12>>2]|0);n=c[h>>2]|0;c[h>>2]=c[(c[h>>2]|0)+24>>2];if(!n){o=1;i=e;return o|0}if(a[n+4>>0]|0){h=c[n>>2]|0;c[g>>2]=c[n+8>>2];c[f+0>>2]=c[g+0>>2];eOb(h,f)}ACi(n);o=1;i=e;return o|0}function fOc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(16,b,1,16,3653512,30)|0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[150376]=d;i=a;return}function gOc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[150376]|0;f=c[153072]|0;if((e|0)!=0?(g=e+4|0,h=c[g>>2]|0,(h|0)!=0):0){j=e+8|0;while(1){k=c[j>>2]|0;if((k|0)==(h|0))break;l=k+-8|0;c[j>>2]=l;ubc(l)}ACi(c[g>>2]|0)}c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[150376]=0;i=a;return}function hOc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+64|0;h=g+52|0;j=g+48|0;k=g+32|0;l=g+16|0;m=g;n=d+8|0;if(!(c[n>>2]|0)){i=g;return}o=kfd()|0;if((c[b>>2]|0)!=(c[b+4>>2]|0)){p=l+4|0;c[p>>2]=0;q=l+8|0;c[q>>2]=0;r=l+4|0;c[l>>2]=r;kOc(a,b,d,l);if((c[q>>2]|0)>>>0>(c[n>>2]|0)>>>0){q=c[153134]|0;c[m>>2]=0;b=m+4|0;c[b>>2]=q;c[m+8>>2]=0;q=m+12|0;c[q>>2]=0;a=c[l>>2]|0;if((a|0)!=(r|0)){s=a;while(1){iOc(0,c[s+16>>2]|0,m,e);a=c[s+4>>2]|0;if(!a){t=s;while(1){u=c[t+8>>2]|0;if((c[u>>2]|0)==(t|0)){v=u;break}else t=u}}else{t=a;while(1){u=c[t>>2]|0;if(!u){v=t;break}else t=u}}if((v|0)==(r|0))break;else s=v}}jOc(0,m,d);if((c[q>>2]|0)>-1){q=c[m>>2]|0;c[j>>2]=c[b>>2];c[h+0>>2]=c[j+0>>2];eOb(q,h);c[m>>2]=0}}nOc(l,c[p>>2]|0);i=g;return}if(e){p=d+4|0;l=c[p>>2]|0;m=c[d>>2]|0;q=c[n>>2]<<2;b=q>>2;v=(b|0)==0;if(v){w=0;x=0;y=0;z=0}else{c[j>>2]=l;c[h+0>>2]=c[j+0>>2];s=hOb(0,q,4,h,0,3653512,370)|0;w=s;x=q;y=s;z=b}YEi(w|0,m|0,x|0)|0;x=d+12|0;if((c[x>>2]|0)>-1){m=c[d>>2]|0;c[j>>2]=c[p>>2];c[h+0>>2]=c[j+0>>2];eOb(m,h);c[d>>2]=0}c[n>>2]=0;c[x>>2]=0;m=y+(b<<2)|0;if(!v){v=y;do{if((Led(o,c[v>>2]|0)|0)==115){b=c[v>>2]|0;w=(c[n>>2]|0)+1|0;c[n>>2]=w;s=c[x>>2]|0;q=s&2147483647;if(w>>>0>q>>>0){r=s<<1;t=(r|0)==0?1:r;do if(q>>>0<t>>>0)if((s|0)>-1){c[x>>2]=t;r=c[d>>2]|0;c[j>>2]=c[p>>2];c[h+0>>2]=c[j+0>>2];c[d>>2]=hOb(r,t<<2,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[p>>2];c[h+0>>2]=c[j+0>>2];r=cOb(t<<2,4,h,0,3653512,352)|0;YEi(r|0,c[d>>2]|0,c[n>>2]<<2|0)|0;c[x>>2]=t;c[d>>2]=r;break}while(0);A=c[n>>2]|0}else A=w;c[(c[d>>2]|0)+(A+-1<<2)>>2]=b}v=v+4|0}while((v|0)!=(m|0))}if((z|0)>-1){c[j>>2]=l;c[h+0>>2]=c[j+0>>2];eOb(y,h)}}if(!f){i=g;return}f=c[153134]|0;c[k>>2]=0;y=k+4|0;c[y>>2]=f;c[k+8>>2]=0;f=k+12|0;c[f>>2]=0;if(c[n>>2]|0){l=c[d>>2]|0;do{iOc(0,c[l>>2]|0,k,e);l=l+4|0}while((l|0)!=((c[d>>2]|0)+(c[n>>2]<<2)|0))}jOc(0,k,d);if((c[f>>2]|0)<=-1){i=g;return}f=c[k>>2]|0;c[j>>2]=c[y>>2];c[h+0>>2]=c[j+0>>2];eOb(f,h);c[k>>2]=0;i=g;return}function iOc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+48|0;f=a+36|0;g=a+32|0;h=a;j=kfd()|0;k=Led(j,b)|0;if((k|0)!=115&e){i=a;return}c[h>>2]=b;c[h+8>>2]=0;e=h+16|0;c[e>>2]=0;c[e+4>>2]=0;c[h+24>>2]=((k|0)==115)<<31>>31;Jed(j,b,h+8|0)|0;b=d+8|0;j=(c[b>>2]|0)+1|0;c[b>>2]=j;k=d+12|0;e=c[k>>2]|0;l=e&2147483647;if(j>>>0>l>>>0){m=e<<1;n=(m|0)==0?1:m;do if(l>>>0<n>>>0)if((e|0)>-1){c[k>>2]=n;m=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(m,n<<5,8,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];m=cOb(n<<5,8,f,0,3653512,352)|0;YEi(m|0,c[d>>2]|0,c[b>>2]<<5|0)|0;c[k>>2]=n;c[d>>2]=m;break}while(0);o=c[b>>2]|0}else o=j;j=(c[d>>2]|0)+(o+-1<<5)|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];c[j+16>>2]=c[h+16>>2];c[j+20>>2]=c[h+20>>2];c[j+24>>2]=c[h+24>>2];i=a;return}function jOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;e=a;f=a+4|0;g=c[b>>2]|0;h=b+8|0;oOc(g,g+(c[h>>2]<<5)|0,e);g=c[h>>2]|0;j=d+8|0;c[j>>2]=g;k=d+12|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<g>>>0)if((l|0)>-1){c[k>>2]=g;m=c[d>>2]|0;c[f>>2]=c[d+4>>2];c[e+0>>2]=c[f+0>>2];c[d>>2]=hOb(m,g<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[d+4>>2];c[e+0>>2]=c[f+0>>2];m=cOb(g<<2,4,e,0,3653512,352)|0;YEi(m|0,c[d>>2]|0,c[j>>2]<<2|0)|0;c[k>>2]=g;c[d>>2]=m;break}while(0);if(!(c[h>>2]|0)){i=a;return}g=c[b>>2]|0;b=c[d>>2]|0;d=0;k=g;while(1){c[b+(d<<2)>>2]=c[k>>2];k=k+32|0;if((k|0)==(g+(c[h>>2]<<5)|0))break;else d=d+1|0}i=a;return}function kOc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f;l=c[153134]|0;c[k>>2]=0;m=k+4|0;c[m>>2]=l;l=k+8|0;c[l>>2]=0;n=k+12|0;c[n>>2]=0;o=d+8|0;if(c[o>>2]|0){p=e+4|0;q=e+4|0;r=e+8|0;s=c[d>>2]|0;do{t=c[p>>2]|0;do if(t){u=c[s>>2]|0;v=t;while(1){w=c[v+16>>2]|0;if((u|0)<(w|0)){x=c[v>>2]|0;if(!x){y=v;z=v;A=7;break}else{v=x;continue}}if((w|0)>=(u|0)){B=v;A=11;break}w=v+4|0;x=c[w>>2]|0;if(!x){C=w;D=v;A=10;break}else v=x}if((A|0)==7){A=0;c[h>>2]=z;E=y;F=z;break}else if((A|0)==10){A=0;c[h>>2]=D;E=C;F=D;break}else if((A|0)==11){A=0;c[h>>2]=B;E=h;F=B;break}}else{c[h>>2]=q;E=q;F=q}while(0);if(!(c[E>>2]|0)){t=xCi(20)|0;c[t+16>>2]=c[s>>2];c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=F;c[E>>2]=t;v=c[c[e>>2]>>2]|0;if(!v)G=t;else{c[e>>2]=v;G=c[E>>2]|0}GN(c[p>>2]|0,G);c[r>>2]=(c[r>>2]|0)+1;v=lOc(a,c[s>>2]|0,b,k)|0;if(v){kOc(a,v+92|0,k,e);c[l>>2]=0}}s=s+4|0}while((s|0)!=((c[d>>2]|0)+(c[o>>2]<<2)|0));if((c[n>>2]|0)<=-1){i=f;return}}n=c[k>>2]|0;c[j>>2]=c[m>>2];c[g+0>>2]=c[j+0>>2];eOb(n,g);c[k>>2]=0;i=f;return}function lOc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=c[d>>2]|0;h=d+4|0;d=c[h>>2]|0;if((g|0)==(d|0)){j=0;i=f;return j|0}k=a+4|0;l=a+8|0;a=g;g=d;while(1){d=c[k>>2]|0;m=c[l>>2]|0;n=m-d>>3;if(!n)o=d;else{p=c[a>>2]|0;q=d;d=n;while(1){n=(d|0)/2|0;if((HEi(c[q+(n<<3)>>2]|0,p)|0)<0){r=q+(n+1<<3)|0;s=d+-1-n|0}else{r=q;s=n}if(!s){o=r;break}else{q=r;d=s}}}if((o|0)!=(m|0)?(d=(HEi(c[a>>2]|0,c[o>>2]|0)|0)<0,q=d?m:o,(q|0)!=(m|0)):0){d=c[q+4>>2]|0;if(hNc(d,b,e)|0){j=d;t=13;break}u=c[h>>2]|0}else u=g;a=a+4|0;if((a|0)==(u|0)){j=0;t=13;break}else g=u}if((t|0)==13){i=f;return j|0}return 0}function mOc(){return c[150376]|0}function nOc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{nOc(a,c[b>>2]|0);nOc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function oOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=i;i=i+32|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-32|0;j=a+-64|0;k=a+-8|0;l=a+-24|0;m=a+-16|0;n=g;b:while(1){o=n;p=b-o|0;q=p>>5;switch(q|0){case 1:case 0:{r=93;break a;break}case 4:{s=n;t=h;r=11;break a;break}case 2:{u=n;v=k;w=l;x=m;y=h;r=4;break a;break}case 3:{z=n;A=h;r=10;break a;break}case 5:{B=n;C=h;r=12;break a;break}default:{}}if((p|0)<992){D=n;E=a;r=14;break a}F=(q|0)/2|0;G=n+(F<<5)|0;if((p|0)>31968){p=(q|0)/4|0;H=rOc(n,n+(p<<5)|0,G,n+(p+F<<5)|0,h,d)|0}else H=pOc(n,G,h,d)|0;p=n+24|0;q=c[p>>2]|0;I=c[n+(F<<5)+24>>2]|0;if((q|0)==(I|0)){J=c[n+8>>2]|0;K=c[n+(F<<5)+8>>2]|0;if((J|0)>=(K|0))if((J|0)<=(K|0)?(K=n+16|0,J=c[K+4>>2]|0,L=n+(F<<5)+16|0,M=c[L+4>>2]|0,(J|0)<(M|0)|((J|0)==(M|0)?(c[K>>2]|0)>>>0<(c[L>>2]|0)>>>0:0)):0){N=h;O=H}else r=23;else{N=h;O=H}}else if((q|0)<(I|0)){N=h;O=H}else r=23;c:do if((r|0)==23){r=0;d:do if((n|0)!=(j|0)){L=n+(F<<5)+8|0;K=n+(F<<5)+16|0;M=a;J=j;P=h;while(1){Q=c[M+-40>>2]|0;if((Q|0)==(I|0)){R=c[M+-56>>2]|0;S=c[L>>2]|0;if((R|0)<(S|0)){T=J;break}if((R|0)<=(S|0)?(S=M+-48|0,R=c[S+4>>2]|0,U=K,V=c[U+4>>2]|0,(R|0)<(V|0)|((R|0)==(V|0)?(c[S>>2]|0)>>>0<(c[U>>2]|0)>>>0:0)):0){T=J;break}}else if((Q|0)<(I|0)){T=J;break}Q=P+-64|0;if((n|0)==(Q|0))break d;else{U=J;S=P;J=Q;P=U;M=S}}c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[f+16>>2]=c[n+16>>2];c[f+20>>2]=c[n+20>>2];c[f+24>>2]=c[n+24>>2];c[f+28>>2]=c[n+28>>2];c[n+0>>2]=c[T+0>>2];c[n+4>>2]=c[T+4>>2];c[n+8>>2]=c[T+8>>2];c[n+12>>2]=c[T+12>>2];c[n+16>>2]=c[T+16>>2];c[n+20>>2]=c[T+20>>2];c[n+24>>2]=c[T+24>>2];c[T+0>>2]=c[f+0>>2];c[T+4>>2]=c[f+4>>2];c[T+8>>2]=c[f+8>>2];c[T+12>>2]=c[f+12>>2];c[T+16>>2]=c[f+16>>2];c[T+20>>2]=c[f+20>>2];c[T+24>>2]=c[f+24>>2];N=T;O=H+1|0;break c}while(0);M=n+32|0;P=c[k>>2]|0;if((q|0)==(P|0)){J=c[n+8>>2]|0;K=c[l>>2]|0;if((J|0)>=(K|0))if((J|0)<=(K|0)?(K=n+16|0,J=c[K+4>>2]|0,L=m,S=c[L+4>>2]|0,(J|0)<(S|0)|((J|0)==(S|0)?(c[K>>2]|0)>>>0<(c[L>>2]|0)>>>0:0)):0)W=M;else r=30;else W=M}else if((q|0)<(P|0))W=M;else r=30;if((r|0)==30){r=0;if((M|0)==(h|0)){r=93;break a}P=n+8|0;L=n+16|0;K=n;S=M;while(1){M=c[S+24>>2]|0;if((q|0)==(M|0)){J=c[P>>2]|0;U=c[S+8>>2]|0;if((J|0)<(U|0)){X=S;break}if((J|0)<=(U|0)?(U=L,J=c[U+4>>2]|0,Q=S+16|0,V=c[Q+4>>2]|0,(J|0)<(V|0)|((J|0)==(V|0)?(c[U>>2]|0)>>>0<(c[Q>>2]|0)>>>0:0)):0){X=S;break}}else if((q|0)<(M|0)){X=S;break}M=K+64|0;if((M|0)==(h|0)){r=93;break a}else{Q=S;S=M;K=Q}}c[f+0>>2]=c[X+0>>2];c[f+4>>2]=c[X+4>>2];c[f+8>>2]=c[X+8>>2];c[f+12>>2]=c[X+12>>2];c[f+16>>2]=c[X+16>>2];c[f+20>>2]=c[X+20>>2];c[f+24>>2]=c[X+24>>2];c[f+28>>2]=c[X+28>>2];c[X+0>>2]=c[h+0>>2];c[X+4>>2]=c[h+4>>2];c[X+8>>2]=c[h+8>>2];c[X+12>>2]=c[h+12>>2];c[X+16>>2]=c[h+16>>2];c[X+20>>2]=c[h+20>>2];c[X+24>>2]=c[h+24>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];c[h+20>>2]=c[f+20>>2];c[h+24>>2]=c[f+24>>2];W=X+32|0}if((W|0)==(h|0)){r=93;break a}K=n+8|0;S=n+16|0;L=W;P=h;while(1){Q=c[p>>2]|0;M=L;while(1){U=c[M+24>>2]|0;if((Q|0)==(U|0)){V=c[K>>2]|0;J=c[M+8>>2]|0;if((V|0)<(J|0)){Y=M;break}if((V|0)<=(J|0)?(J=S,V=c[J+4>>2]|0,R=M+16|0,Z=c[R+4>>2]|0,(V|0)<(Z|0)|((V|0)==(Z|0)?(c[J>>2]|0)>>>0<(c[R>>2]|0)>>>0:0)):0){Y=M;break}}else if((Q|0)<(U|0)){Y=M;break}M=M+32|0}M=P;while(1){U=M+-32|0;R=c[M+-8>>2]|0;if((Q|0)!=(R|0))if((Q|0)<(R|0)){M=U;continue}else{_=U;break}R=c[K>>2]|0;J=c[M+-24>>2]|0;if((R|0)<(J|0)){M=U;continue}if((R|0)>(J|0)){_=U;break}J=S;R=c[J+4>>2]|0;Z=M+-16|0;V=c[Z+4>>2]|0;if((R|0)<(V|0)|((R|0)==(V|0)?(c[J>>2]|0)>>>0<(c[Z>>2]|0)>>>0:0))M=U;else{_=U;break}}if(Y>>>0>=_>>>0){n=Y;continue b};c[f+0>>2]=c[Y+0>>2];c[f+4>>2]=c[Y+4>>2];c[f+8>>2]=c[Y+8>>2];c[f+12>>2]=c[Y+12>>2];c[f+16>>2]=c[Y+16>>2];c[f+20>>2]=c[Y+20>>2];c[f+24>>2]=c[Y+24>>2];c[f+28>>2]=c[Y+28>>2];c[Y+0>>2]=c[_+0>>2];c[Y+4>>2]=c[_+4>>2];c[Y+8>>2]=c[_+8>>2];c[Y+12>>2]=c[_+12>>2];c[Y+16>>2]=c[_+16>>2];c[Y+20>>2]=c[_+20>>2];c[Y+24>>2]=c[_+24>>2];c[_+0>>2]=c[f+0>>2];c[_+4>>2]=c[f+4>>2];c[_+8>>2]=c[f+8>>2];c[_+12>>2]=c[f+12>>2];c[_+16>>2]=c[f+16>>2];c[_+20>>2]=c[f+20>>2];c[_+24>>2]=c[f+24>>2];L=Y+32|0;P=_}}while(0);p=n+32|0;e:do if(p>>>0<N>>>0){q=p;I=N;F=G;P=O;while(1){L=c[F+24>>2]|0;S=F+8|0;K=F+16|0;M=q;while(1){Q=c[M+24>>2]|0;if((Q|0)==(L|0)){U=c[M+8>>2]|0;Z=c[S>>2]|0;if((U|0)>=(Z|0)){if((U|0)>(Z|0)){$=M;break}Z=M+16|0;U=c[Z+4>>2]|0;J=K;V=c[J+4>>2]|0;if(!((U|0)<(V|0)|((U|0)==(V|0)?(c[Z>>2]|0)>>>0<(c[J>>2]|0)>>>0:0))){$=M;break}}}else if((Q|0)>=(L|0)){$=M;break}M=M+32|0}M=I;while(1){Q=M+-32|0;J=c[M+-8>>2]|0;if((J|0)!=(L|0))if((J|0)<(L|0)){aa=Q;break}else{M=Q;continue}J=c[M+-24>>2]|0;Z=c[S>>2]|0;if((J|0)<(Z|0)){aa=Q;break}if((J|0)>(Z|0)){M=Q;continue}Z=M+-16|0;J=c[Z+4>>2]|0;V=K;U=c[V+4>>2]|0;if((J|0)<(U|0)|((J|0)==(U|0)?(c[Z>>2]|0)>>>0<(c[V>>2]|0)>>>0:0)){aa=Q;break}else M=Q}if($>>>0>aa>>>0){ba=$;ca=F;da=P;break e};c[f+0>>2]=c[$+0>>2];c[f+4>>2]=c[$+4>>2];c[f+8>>2]=c[$+8>>2];c[f+12>>2]=c[$+12>>2];c[f+16>>2]=c[$+16>>2];c[f+20>>2]=c[$+20>>2];c[f+24>>2]=c[$+24>>2];c[f+28>>2]=c[$+28>>2];c[$+0>>2]=c[aa+0>>2];c[$+4>>2]=c[aa+4>>2];c[$+8>>2]=c[aa+8>>2];c[$+12>>2]=c[aa+12>>2];c[$+16>>2]=c[aa+16>>2];c[$+20>>2]=c[aa+20>>2];c[$+24>>2]=c[aa+24>>2];c[aa+0>>2]=c[f+0>>2];c[aa+4>>2]=c[f+4>>2];c[aa+8>>2]=c[f+8>>2];c[aa+12>>2]=c[f+12>>2];c[aa+16>>2]=c[f+16>>2];c[aa+20>>2]=c[f+20>>2];c[aa+24>>2]=c[f+24>>2];q=$+32|0;I=aa;F=(F|0)==($|0)?aa:F;P=P+1|0}}else{ba=p;ca=G;da=O}while(0);do if((ba|0)==(ca|0))ea=da;else{G=c[ca+24>>2]|0;p=c[ba+24>>2]|0;if((G|0)==(p|0)){P=c[ca+8>>2]|0;F=c[ba+8>>2]|0;if((P|0)>=(F|0)){if((P|0)>(F|0)){ea=da;break}F=ca+16|0;P=c[F+4>>2]|0;I=ba+16|0;q=c[I+4>>2]|0;if(!((P|0)<(q|0)|((P|0)==(q|0)?(c[F>>2]|0)>>>0<(c[I>>2]|0)>>>0:0))){ea=da;break}}}else if((G|0)>=(p|0)){ea=da;break};c[f+0>>2]=c[ba+0>>2];c[f+4>>2]=c[ba+4>>2];c[f+8>>2]=c[ba+8>>2];c[f+12>>2]=c[ba+12>>2];c[f+16>>2]=c[ba+16>>2];c[f+20>>2]=c[ba+20>>2];c[f+24>>2]=c[ba+24>>2];c[f+28>>2]=c[ba+28>>2];c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];c[ba+16>>2]=c[ca+16>>2];c[ba+20>>2]=c[ca+20>>2];c[ba+24>>2]=c[ca+24>>2];c[ca+0>>2]=c[f+0>>2];c[ca+4>>2]=c[f+4>>2];c[ca+8>>2]=c[f+8>>2];c[ca+12>>2]=c[f+12>>2];c[ca+16>>2]=c[f+16>>2];c[ca+20>>2]=c[f+20>>2];c[ca+24>>2]=c[f+24>>2];ea=da+1|0}while(0);if(!ea){fa=tOc(n,ba,d)|0;p=ba+32|0;if(tOc(p,a,d)|0){r=88;break}if(fa){n=p;continue}}p=ba;if((p-o|0)>=(b-p|0)){ga=n;ha=ba;r=92;break}oOc(n,ba,d);n=ba+32|0}if((r|0)==88){r=0;if(fa){r=93;break}else{g=n;a=ba;continue}}else if((r|0)==92){r=0;oOc(ha+32|0,a,d);g=ga;a=ha;continue}}if((r|0)==4){ha=c[v>>2]|0;v=c[u+24>>2]|0;if((ha|0)==(v|0)){a=c[w>>2]|0;w=c[u+8>>2]|0;if((a|0)>=(w|0)){if((a|0)>(w|0)){i=e;return}w=x;x=c[w+4>>2]|0;a=u+16|0;ga=c[a+4>>2]|0;if(!((x|0)<(ga|0)|((x|0)==(ga|0)?(c[w>>2]|0)>>>0<(c[a>>2]|0)>>>0:0))){i=e;return}}}else if((ha|0)>=(v|0)){i=e;return};c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[f+12>>2]=c[u+12>>2];c[f+16>>2]=c[u+16>>2];c[f+20>>2]=c[u+20>>2];c[f+24>>2]=c[u+24>>2];c[f+28>>2]=c[u+28>>2];c[u+0>>2]=c[y+0>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];c[u+12>>2]=c[y+12>>2];c[u+16>>2]=c[y+16>>2];c[u+20>>2]=c[y+20>>2];c[u+24>>2]=c[y+24>>2];c[y+0>>2]=c[f+0>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];c[y+12>>2]=c[f+12>>2];c[y+16>>2]=c[f+16>>2];c[y+20>>2]=c[f+20>>2];c[y+24>>2]=c[f+24>>2];i=e;return}else if((r|0)==10){pOc(z,z+32|0,A,d)|0;i=e;return}else if((r|0)==11){qOc(s,s+32|0,s+64|0,t,d)|0;i=e;return}else if((r|0)==12){rOc(B,B+32|0,B+64|0,B+96|0,C,d)|0;i=e;return}else if((r|0)==14){sOc(D,E,d);i=e;return}else if((r|0)==93){i=e;return}}function pOc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=b+24|0;h=c[g>>2]|0;j=a+24|0;k=c[j>>2]|0;if((h|0)==(k|0)){l=c[b+8>>2]|0;m=c[a+8>>2]|0;if((l|0)>=(m|0))if((l|0)>(m|0))n=0;else{m=b+16|0;l=c[m+4>>2]|0;o=a+16|0;p=c[o+4>>2]|0;n=(l|0)<(p|0)|((l|0)==(p|0)?(c[m>>2]|0)>>>0<(c[o>>2]|0)>>>0:0)}else n=1}else n=(h|0)<(k|0);k=d+24|0;o=c[k>>2]|0;if((o|0)==(h|0)){m=c[d+8>>2]|0;p=c[b+8>>2]|0;if((m|0)>=(p|0))if((m|0)>(p|0))q=0;else{p=d+16|0;m=c[p+4>>2]|0;l=b+16|0;r=c[l+4>>2]|0;q=(m|0)<(r|0)|((m|0)==(r|0)?(c[p>>2]|0)>>>0<(c[l>>2]|0)>>>0:0)}else q=1}else q=(o|0)<(h|0);if(!n){if(!q){s=0;i=e;return s|0};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];n=c[g>>2]|0;h=c[j>>2]|0;if((n|0)==(h|0)){j=c[b+8>>2]|0;o=c[a+8>>2]|0;if((j|0)>=(o|0)){if((j|0)>(o|0)){s=1;i=e;return s|0}o=b+16|0;j=c[o+4>>2]|0;l=a+16|0;p=c[l+4>>2]|0;if(!((j|0)<(p|0)|((j|0)==(p|0)?(c[o>>2]|0)>>>0<(c[l>>2]|0)>>>0:0))){s=1;i=e;return s|0}}}else if((n|0)>=(h|0)){s=1;i=e;return s|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];s=2;i=e;return s|0}if(q){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];s=1;i=e;return s|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];a=c[k>>2]|0;k=c[g>>2]|0;if((a|0)==(k|0)){g=c[d+8>>2]|0;q=c[b+8>>2]|0;if((g|0)>=(q|0)){if((g|0)>(q|0)){s=1;i=e;return s|0}q=d+16|0;g=c[q+4>>2]|0;h=b+16|0;n=c[h+4>>2]|0;if(!((g|0)<(n|0)|((g|0)==(n|0)?(c[q>>2]|0)>>>0<(c[h>>2]|0)>>>0:0))){s=1;i=e;return s|0}}}else if((a|0)>=(k|0)){s=1;i=e;return s|0};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];s=2;i=e;return s|0}function qOc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g;j=pOc(a,b,d,f)|0;f=c[e+24>>2]|0;k=d+24|0;l=c[k>>2]|0;if((f|0)==(l|0)){m=c[e+8>>2]|0;n=c[d+8>>2]|0;if((m|0)>=(n|0)){if((m|0)>(n|0)){o=j;i=g;return o|0}n=e+16|0;m=c[n+4>>2]|0;p=d+16|0;q=c[p+4>>2]|0;if(!((m|0)<(q|0)|((m|0)==(q|0)?(c[n>>2]|0)>>>0<(c[p>>2]|0)>>>0:0))){o=j;i=g;return o|0}}}else if((f|0)>=(l|0)){o=j;i=g;return o|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];e=j+1|0;l=c[k>>2]|0;k=b+24|0;f=c[k>>2]|0;if((l|0)==(f|0)){p=c[d+8>>2]|0;n=c[b+8>>2]|0;if((p|0)>=(n|0)){if((p|0)>(n|0)){o=e;i=g;return o|0}n=d+16|0;p=c[n+4>>2]|0;q=b+16|0;m=c[q+4>>2]|0;if(!((p|0)<(m|0)|((p|0)==(m|0)?(c[n>>2]|0)>>>0<(c[q>>2]|0)>>>0:0))){o=e;i=g;return o|0}}}else if((l|0)>=(f|0)){o=e;i=g;return o|0};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[h+20>>2]=c[b+20>>2];c[h+24>>2]=c[b+24>>2];c[h+28>>2]=c[b+28>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];d=j+2|0;e=c[k>>2]|0;k=c[a+24>>2]|0;if((e|0)==(k|0)){f=c[b+8>>2]|0;l=c[a+8>>2]|0;if((f|0)>=(l|0)){if((f|0)>(l|0)){o=d;i=g;return o|0}l=b+16|0;f=c[l+4>>2]|0;q=a+16|0;n=c[q+4>>2]|0;if(!((f|0)<(n|0)|((f|0)==(n|0)?(c[l>>2]|0)>>>0<(c[q>>2]|0)>>>0:0))){o=d;i=g;return o|0}}}else if((e|0)>=(k|0)){o=d;i=g;return o|0};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];c[b+20>>2]=c[h+20>>2];c[b+24>>2]=c[h+24>>2];o=j+3|0;i=g;return o|0}function rOc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h;k=qOc(a,b,d,e,g)|0;g=c[f+24>>2]|0;l=e+24|0;m=c[l>>2]|0;if((g|0)==(m|0)){n=c[f+8>>2]|0;o=c[e+8>>2]|0;if((n|0)>=(o|0)){if((n|0)>(o|0)){p=k;i=h;return p|0}o=f+16|0;n=c[o+4>>2]|0;q=e+16|0;r=c[q+4>>2]|0;if(!((n|0)<(r|0)|((n|0)==(r|0)?(c[o>>2]|0)>>>0<(c[q>>2]|0)>>>0:0))){p=k;i=h;return p|0}}}else if((g|0)>=(m|0)){p=k;i=h;return p|0};c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[j+20>>2]=c[e+20>>2];c[j+24>>2]=c[e+24>>2];c[j+28>>2]=c[e+28>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];f=k+1|0;m=c[l>>2]|0;l=d+24|0;g=c[l>>2]|0;if((m|0)==(g|0)){q=c[e+8>>2]|0;o=c[d+8>>2]|0;if((q|0)>=(o|0)){if((q|0)>(o|0)){p=f;i=h;return p|0}o=e+16|0;q=c[o+4>>2]|0;r=d+16|0;n=c[r+4>>2]|0;if(!((q|0)<(n|0)|((q|0)==(n|0)?(c[o>>2]|0)>>>0<(c[r>>2]|0)>>>0:0))){p=f;i=h;return p|0}}}else if((m|0)>=(g|0)){p=f;i=h;return p|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];c[j+24>>2]=c[d+24>>2];c[j+28>>2]=c[d+28>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];c[e+20>>2]=c[j+20>>2];c[e+24>>2]=c[j+24>>2];e=k+2|0;f=c[l>>2]|0;l=b+24|0;g=c[l>>2]|0;if((f|0)==(g|0)){m=c[d+8>>2]|0;r=c[b+8>>2]|0;if((m|0)>=(r|0)){if((m|0)>(r|0)){p=e;i=h;return p|0}r=d+16|0;m=c[r+4>>2]|0;o=b+16|0;n=c[o+4>>2]|0;if(!((m|0)<(n|0)|((m|0)==(n|0)?(c[r>>2]|0)>>>0<(c[o>>2]|0)>>>0:0))){p=e;i=h;return p|0}}}else if((f|0)>=(g|0)){p=e;i=h;return p|0};c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2];c[j+20>>2]=c[b+20>>2];c[j+24>>2]=c[b+24>>2];c[j+28>>2]=c[b+28>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[d+16>>2]=c[j+16>>2];c[d+20>>2]=c[j+20>>2];c[d+24>>2]=c[j+24>>2];d=k+3|0;e=c[l>>2]|0;l=c[a+24>>2]|0;if((e|0)==(l|0)){g=c[b+8>>2]|0;f=c[a+8>>2]|0;if((g|0)>=(f|0)){if((g|0)>(f|0)){p=d;i=h;return p|0}f=b+16|0;g=c[f+4>>2]|0;o=a+16|0;r=c[o+4>>2]|0;if(!((g|0)<(r|0)|((g|0)==(r|0)?(c[f>>2]|0)>>>0<(c[o>>2]|0)>>>0:0))){p=d;i=h;return p|0}}}else if((e|0)>=(l|0)){p=d;i=h;return p|0};c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[j+20>>2]=c[a+20>>2];c[j+24>>2]=c[a+24>>2];c[j+28>>2]=c[a+28>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];c[b+16>>2]=c[j+16>>2];c[b+20>>2]=c[j+20>>2];c[b+24>>2]=c[j+24>>2];p=k+4|0;i=h;return p|0}function sOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=a+64|0;pOc(a,a+32|0,f,d)|0;d=a+96|0;if((d|0)==(b|0)){i=e;return}else{g=d;h=f}while(1){f=g+24|0;d=c[f>>2]|0;j=c[h+24>>2]|0;if((d|0)==(j|0)){k=g+8|0;l=c[k>>2]|0;m=c[h+8>>2]|0;if((l|0)>=(m|0)){if((l|0)<=(m|0)?(m=g+16|0,l=c[m+4>>2]|0,n=h+16|0,o=c[n+4>>2]|0,(l|0)<(o|0)|((l|0)==(o|0)?(c[m>>2]|0)>>>0<(c[n>>2]|0)>>>0:0)):0){p=k;q=8}}else{p=k;q=8}}else if((d|0)<(j|0)){p=g+8|0;q=8}if((q|0)==8){q=0;j=g;d=c[j>>2]|0;k=c[j+4>>2]|0;j=c[p>>2]|0;n=c[g+12>>2]|0;m=g+16|0;o=c[m>>2]|0;l=c[m+4>>2]|0;m=c[f>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[g+16>>2]=c[h+16>>2];c[g+20>>2]=c[h+20>>2];c[g+24>>2]=c[h+24>>2];a:do if((h|0)==(a|0)){r=h;s=a}else{f=h;while(1){t=f+-32|0;u=c[f+-8>>2]|0;if((m|0)==(u|0)){v=c[f+-24>>2]|0;if((j|0)>=(v|0)){if((j|0)>(v|0)){r=f;s=f;break a}v=f+-16|0;w=c[v+4>>2]|0;if(!((l|0)<(w|0)|((l|0)==(w|0)?o>>>0<(c[v>>2]|0)>>>0:0))){r=f;s=f;break a}}}else if((m|0)>=(u|0)){r=f;s=f;break a};c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];c[f+16>>2]=c[t+16>>2];c[f+20>>2]=c[t+20>>2];c[f+24>>2]=c[t+24>>2];if((t|0)==(a|0)){r=t;s=a;break}else f=t}}while(0);f=s;c[f>>2]=d;c[f+4>>2]=k;c[s+8>>2]=j;c[r+12>>2]=n;f=s+16|0;c[f>>2]=o;c[f+4>>2]=l;c[s+24>>2]=m}f=g+32|0;if((f|0)==(b|0))break;else{t=g;g=f;h=t}}i=e;return}function tOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e;switch(b-a>>5|0){case 2:{g=b+-32|0;h=c[b+-8>>2]|0;j=c[a+24>>2]|0;if((h|0)==(j|0)){k=c[b+-24>>2]|0;l=c[a+8>>2]|0;if((k|0)>=(l|0)){if((k|0)>(l|0)){m=1;i=e;return m|0}l=b+-16|0;k=c[l+4>>2]|0;n=a+16|0;o=c[n+4>>2]|0;if(!((k|0)<(o|0)|((k|0)==(o|0)?(c[l>>2]|0)>>>0<(c[n>>2]|0)>>>0:0))){m=1;i=e;return m|0}}}else if((h|0)>=(j|0)){m=1;i=e;return m|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[a+16>>2]=c[g+16>>2];c[a+20>>2]=c[g+20>>2];c[a+24>>2]=c[g+24>>2];c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];c[g+16>>2]=c[f+16>>2];c[g+20>>2]=c[f+20>>2];c[g+24>>2]=c[f+24>>2];m=1;i=e;return m|0}case 3:{pOc(a,a+32|0,b+-32|0,d)|0;m=1;i=e;return m|0}case 4:{qOc(a,a+32|0,a+64|0,b+-32|0,d)|0;m=1;i=e;return m|0}case 5:{rOc(a,a+32|0,a+64|0,a+96|0,b+-32|0,d)|0;m=1;i=e;return m|0}case 1:case 0:{m=1;i=e;return m|0}default:{f=a+64|0;pOc(a,a+32|0,f,d)|0;d=a+96|0;if((d|0)==(b|0)){m=1;i=e;return m|0}else{p=0;q=d;r=f}while(1){f=q+24|0;d=c[f>>2]|0;g=c[r+24>>2]|0;if((d|0)==(g|0)){j=q+8|0;h=c[j>>2]|0;n=c[r+8>>2]|0;if((h|0)>=(n|0))if((h|0)<=(n|0)?(n=q+16|0,h=c[n+4>>2]|0,l=r+16|0,o=c[l+4>>2]|0,(h|0)<(o|0)|((h|0)==(o|0)?(c[n>>2]|0)>>>0<(c[l>>2]|0)>>>0:0)):0){s=j;t=18}else u=p;else{s=j;t=18}}else if((d|0)<(g|0)){s=q+8|0;t=18}else u=p;if((t|0)==18){t=0;g=q;d=c[g>>2]|0;j=c[g+4>>2]|0;g=c[s>>2]|0;l=c[q+12>>2]|0;n=q+16|0;o=c[n>>2]|0;h=c[n+4>>2]|0;n=c[f>>2]|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[q+16>>2]=c[r+16>>2];c[q+20>>2]=c[r+20>>2];c[q+24>>2]=c[r+24>>2];a:do if((r|0)==(a|0)){v=r;w=a}else{f=r;while(1){k=f+-32|0;x=c[f+-8>>2]|0;if((n|0)==(x|0)){y=c[f+-24>>2]|0;if((g|0)>=(y|0)){if((g|0)>(y|0)){v=f;w=f;break a}y=f+-16|0;z=c[y+4>>2]|0;if(!((h|0)<(z|0)|((h|0)==(z|0)?o>>>0<(c[y>>2]|0)>>>0:0))){v=f;w=f;break a}}}else if((n|0)>=(x|0)){v=f;w=f;break a};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2];c[f+20>>2]=c[k+20>>2];c[f+24>>2]=c[k+24>>2];if((k|0)==(a|0)){v=k;w=a;break}else f=k}}while(0);f=w;c[f>>2]=d;c[f+4>>2]=j;c[w+8>>2]=g;c[v+12>>2]=l;f=w+16|0;c[f>>2]=o;c[f+4>>2]=h;c[w+24>>2]=n;f=p+1|0;if((f|0)==8){A=q;break}else u=f}f=q+32|0;if((f|0)==(b|0)){m=1;t=28;break}else{k=q;p=u;q=f;r=k}}if((t|0)==28){i=e;return m|0}m=(A+32|0)==(b|0);i=e;return m|0}}return 0}function uOc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+12|0;g=e;rri(f,601512,9);yOc(g,d);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=a[f>>0]|0;h=(d&1)==0;if(h)j=(d&255)>>>1;else j=c[f+4>>2]|0;d=a[g>>0]|0;if(!(d&1))k=(d&255)>>>1;else k=c[g+4>>2]|0;if(h)l=f+1|0;else l=c[f+8>>2]|0;Pri(b,l,j,k+j|0);if(!(a[g>>0]&1))m=g+1|0;else m=c[g+8>>2]|0;Gri(b,m,k)|0;xri(g);xri(f);i=e;return}function vOc(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;gsd(c,a);a=(Ori(c,601528)|0)==0;xri(c);i=b;return a|0}function wOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+24|0;g=e+8|0;h=e;fNc(h,a,b);c[g>>2]=0;b=g+4|0;c[b>>2]=0;c[g+8>>2]=0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];zOc(a,f,d,g,1);d=c[g>>2]|0;g=c[b>>2]|0;if((d|0)==(g|0))if(!d){j=0;i=e;return j|0}else k=0;else{f=c[d>>2]|0;c[b>>2]=g+(~((g+-4-d|0)>>>2)<<2);k=f}ACi(d);j=k;i=e;return j|0}function xOc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+8|0;k=g;l=a[d>>0]|0;if(!(l&1))m=(l&255)>>>1;else m=c[d+4>>2]|0;if(!m)gNc(j,b);else fNc(j,b,d);d=j;j=c[d+4>>2]|0;m=k;c[m>>2]=c[d>>2];c[m+4>>2]=j;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];zOc(b,h,e,f,0);i=g;return}function yOc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+32|0;f=e+12|0;g=e;h=a[d>>0]|0;j=(h&1)==0;if(j){k=(h&255)>>>1;l=d+1|0}else{k=c[d+4>>2]|0;l=c[d+8>>2]|0}a:do if((k>>>0>=17?(m=l+k|0,(k|0)>=17):0)?(n=k+-16|0,o=l+n|0,(n|0)!=0):0){n=l;b:while(1){if((a[n>>0]|0)==67){p=n;q=601544;do{q=q+1|0;if((q|0)==601561){r=n;break b}p=p+1|0}while((a[p>>0]|0)==(a[q>>0]|0))}n=n+1|0;if((n|0)==(o|0)){s=12;break a}}if(!((r|0)!=(m|0)&(r|0)==(l|0)))s=12}else s=12;while(0);c:do if((s|0)==12){if(j){t=(h&255)>>>1;u=d+1|0}else{t=c[d+4>>2]|0;u=c[d+8>>2]|0}d:do if((t>>>0>=3?(l=u+t|0,(t|0)>=3):0)?(r=t+-2|0,k=u+r|0,(r|0)!=0):0){r=u;e:while(1){if((a[r>>0]|0)==67){o=r;n=601568;do{n=n+1|0;if((n|0)==601571){v=r;break e}o=o+1|0}while((a[o>>0]|0)==(a[n>>0]|0))}r=r+1|0;if((r|0)==(k|0))break d}if((v|0)!=(l|0)&(v|0)==(u|0))break c}while(0);if(j){w=(h&255)>>>1;x=d+1|0}else{w=c[d+4>>2]|0;x=c[d+8>>2]|0}f:do if((w>>>0>=11?(m=x+w|0,(w|0)>=11):0)?(k=w+-10|0,r=x+k|0,(k|0)!=0):0){k=x;g:while(1){if((a[k>>0]|0)==66){n=k;o=601576;do{o=o+1|0;if((o|0)==601587){y=k;break g}n=n+1|0}while((a[n>>0]|0)==(a[o>>0]|0))}k=k+1|0;if((k|0)==(r|0))break f}if((y|0)!=(m|0)&(y|0)==(x|0)){ksd(f,d);hsd(g,f);xri(f);yO(b,g,63e4);xri(g);i=e;return}}while(0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}while(0);yO(b,d,63e4);i=e;return}function zOc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;l=ssc(d)|0;d=c[b>>2]|0;m=c[b+4>>2]|0;if((d|0)==(m|0)){i=g;return}b=e+4|0;n=e+8|0;o=d;a:while(1){d=o+28|0;AOc(a,d,1);p=o+36|0;q=c[p>>2]|0;do if(q){c[j>>2]=q;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(h,r,j);s=c[h>>2]|0;t=c[r+28>>2]|0;if((s|0)==-1){u=t+(c[r+32>>2]<<3)|0;break}else{u=t+(s<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[u+4>>2]|0,(r|0)!=0):0){c[k>>2]=r;v=r}else w=14}else w=14;if((w|0)==14){w=0;r=hQb(c[p>>2]|0)|0;c[k>>2]=r;if(!r)break;else v=r}r=Ecd(v)|0;if((r|0)!=0?msc(vsc(r)|0,l)|0:0){AOc(a,d,0);r=c[b>>2]|0;if((r|0)==(c[n>>2]|0))KRb(e,k);else{if(!r)x=0;else{c[r>>2]=v;x=c[b>>2]|0}c[b>>2]=x+4}if(f){w=28;break a}}}else c[k>>2]=0;while(0);d=c[o+4>>2]|0;if(!d){p=o;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){y=q;break}else p=q}}else{p=d;while(1){q=c[p>>2]|0;if(!q){y=p;break}else p=q}}if((y|0)==(m|0)){w=28;break}else o=y}if((w|0)==28){i=g;return}}function AOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;k=c[153134]|0;c[j>>2]=0;l=j+4|0;c[l>>2]=k;k=j+8|0;c[k>>2]=0;m=j+12|0;c[m>>2]=0;n=b+4|0;a:do if((c[n>>2]|0)>0){o=a+48|0;p=1;q=0;r=0;s=0;while(1){t=c[(c[o>>2]|0)+((c[b>>2]|0)+s<<2)>>2]|0;c[k>>2]=p;u=q&2147483647;if(p>>>0>u>>>0){v=q<<1;w=(v|0)==0?1:v;do if(u>>>0<w>>>0)if((q|0)>-1){c[m>>2]=w;c[g>>2]=c[l>>2];c[f+0>>2]=c[g+0>>2];v=hOb(r,w<<2,4,f,0,3653512,370)|0;c[j>>2]=v;x=v;break}else{c[g>>2]=c[l>>2];c[f+0>>2]=c[g+0>>2];v=cOb(w<<2,4,f,0,3653512,352)|0;YEi(v|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[m>>2]=w;c[j>>2]=v;x=v;break}else x=r;while(0);y=c[k>>2]|0;z=x}else{y=p;z=r}c[z+(y+-1<<2)>>2]=t;w=s+1|0;if((w|0)>=(c[n>>2]|0))break a;p=(c[k>>2]|0)+1|0;q=c[m>>2]|0;r=z;s=w}}while(0);hOc(mOc()|0,a+92|0,j,d,0);if(c[k>>2]|0){d=0;do{a=c[(c[j>>2]|0)+(d<<2)>>2]|0;do if(a){c[g>>2]=a;z=c[137784]|0;if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(f,z,g);n=c[f>>2]|0;y=c[z+28>>2]|0;if((n|0)==-1){A=y+(c[z+32>>2]<<3)|0;break}else{A=y+(n<<3)|0;break}}else A=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);z=c[137784]|0;if((A|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(c[A+4>>2]|0)!=0:0)break}hQb(a)|0}while(0);d=d+1|0}while(d>>>0<(c[k>>2]|0)>>>0)}if((c[m>>2]|0)<=-1){i=e;return}m=c[j>>2]|0;c[h>>2]=c[l>>2];c[f+0>>2]=c[h+0>>2];eOb(m,f);c[j>>2]=0;i=e;return}function BOc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+16|0;m=l+4|0;n=l;if((2147483630-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))o=b+1|0;else o=c[b+8>>2]|0;if(d>>>0<1073741799){p=e+d|0;e=d<<1;q=p>>>0<e>>>0?e:p;if(q>>>0<11)r=11;else r=q+16&-16}else r=2147483631;c[n>>2]=46;c[m+0>>2]=c[n+0>>2];q=cOb(r,16,m,0,3653512,80)|0;if(g)YEi(q|0,o|0,g|0)|0;if(j)YEi(q+g|0,k|0,j|0)|0;k=f-h|0;if((k|0)!=(g|0))YEi(q+(j+g)|0,o+(h+g)|0,k-g|0)|0;if((d|0)==10){s=b+8|0;c[s>>2]=q;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=q+u|0;a[w>>0]=0;i=l;return}c[n>>2]=46;c[m+0>>2]=c[n+0>>2];eOb(o,m);s=b+8|0;c[s>>2]=q;t=r|1;c[b>>2]=t;u=k+j|0;v=b+4|0;c[v>>2]=u;w=q+u|0;a[w>>0]=0;i=l;return}function COc(a,b){a=a|0;b=b|0;return 1}function DOc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if(!d)g=0;else g=c[d+4>>2]|0;c[a+20>>2]=g;c[a+8>>2]=b;c[a+12>>2]=f;c[a+16>>2]=e;return}function EOc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+8|0;if(!(c[f>>2]|0)){i=b;return}g=a+20|0;h=c[g>>2]|0;do if(h){c[e>>2]=h;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=11}else o=11;if((o|0)==11){j=hQb(c[g>>2]|0)|0;if(!j)break;else n=j}In[c[f>>2]&4095](n,c[a+16>>2]|0)}while(0);n=c[a+12>>2]|0;if(n)ko[n&4095](c[a+16>>2]|0);c[f>>2]=0;i=b;return}function FOc(a){a=a|0;c[a>>2]=601600;return}function GOc(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function HOc(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=(c[b>>2]|0)+1;return}function IOc(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=(c[d>>2]|0)+-1;if((a|0)==0|(c[d>>2]|0)!=0){i=b;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);i=b;return}function JOc(a){a=a|0;return 0}function KOc(a,b){a=a|0;b=b|0;return}function LOc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+12|0;k=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];jSb(b,g,e);c[b>>2]=601640;c[b+64>>2]=0;c[b+68>>2]=0;c[b+72>>2]=0;c[b+80>>2]=0;c[b+84>>2]=0;c[b+88>>2]=0;e=b+108|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=b+124|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;g=b+92|0;h=b+24|0;d=h+36|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(d|0));a[g>>0]=1;a[b+93>>0]=1;a[b+94>>0]=1;a[b+101>>0]=1;a[b+102>>0]=1;a[b+103>>0]=1;g=b+96|0;a[g>>0]=0;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;a[b+100>>0]=1;a[b+104>>0]=1;a[b+105>>0]=1;a[b+95>>0]=1;a[b+107>>0]=0;a[b+106>>0]=1;a[j>>0]=10;g=j+1|0;a[g+0>>0]=a[601744]|0;a[g+1>>0]=a[601745]|0;a[g+2>>0]=a[601746]|0;a[g+3>>0]=a[601747]|0;a[g+4>>0]=a[601748]|0;a[j+6>>0]=0;do if((e|0)!=(j|0)){h=e+1|0;a[h+0>>0]=a[g+0>>0]|0;a[h+1>>0]=a[g+1>>0]|0;a[h+2>>0]=a[g+2>>0]|0;a[h+3>>0]=a[g+3>>0]|0;a[h+4>>0]=a[g+4>>0]|0;a[e+6>>0]=0;h=a[e>>0]|0;if(!(h&1)){a[e>>0]=10;l=10;m=6;break}c[b+128>>2]=5;if(!(h&1)){l=h;m=6}else{n=c[b+132>>2]|0;o=c[b+128>>2]|0}}else{l=0;m=6}while(0);if((m|0)==6){n=e+1|0;o=(l&255)>>>1}rri(k,n,o);if(!(a[k>>0]&1))p=k+1|0;else p=c[k+8>>2]|0;c[b+120>>2]=Psd(p)|0;xri(k);k=kbc()|0;p=0;while(1){b=k+(p<<2)+448|0;p=p+1|0;if(!(c[b>>2]|0)){q=b;break}if((p|0)>=16){m=14;break}}if((m|0)==14){i=f;return}c[q>>2]=153;i=f;return}function MOc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+80|0;f=e;g=e+40|0;h=e+44|0;j=e+56|0;k=e+16|0;l=e+4|0;m=e+28|0;n=b+36|0;o=b+24|0;p=b+28|0;VHc(n,c[o>>2]|0,c[p>>2]|0);q=c[n>>2]|0;r=b+40|0;do if((q|0)!=(c[r>>2]|0)){a[k>>0]=16;s=k+1|0;t=s;u=t;a[u>>0]=109;a[u+1>>0]=97;a[u+2>>0]=105;a[u+3>>0]=110;u=t+4|0;a[u>>0]=68;a[u+1>>0]=97;a[u+2>>0]=116;a[u+3>>0]=97;a[k+9>>0]=0;a:do if((q|0)!=(k|0)){u=a[q>>0]|0;do if(!(u&1))if(!(u&1))v=18;else v=17;else{t=c[q>>2]|0;w=t&-2;x=w+-1|0;y=(t&1|0)==0;if(x>>>0>=8)if(y){v=18;break}else{v=17;break}if(y)z=t>>>1&127;else z=c[q+4>>2]|0;eXb(q,x,9-w|0,z,0,z,8,s);break a}while(0);if((v|0)==17)A=c[q+8>>2]|0;else if((v|0)==18)A=q+1|0;u=s;w=u;x=d[w>>0]|d[w+1>>0]<<8|d[w+2>>0]<<16|d[w+3>>0]<<24;w=u+4|0;u=d[w>>0]|d[w+1>>0]<<8|d[w+2>>0]<<16|d[w+3>>0]<<24;w=A;t=w;a[t>>0]=x;a[t+1>>0]=x>>8;a[t+2>>0]=x>>16;a[t+3>>0]=x>>24;x=w+4|0;a[x>>0]=u;a[x+1>>0]=u>>8;a[x+2>>0]=u>>16;a[x+3>>0]=u>>24;a[A+8>>0]=0;if(!(a[q>>0]&1)){a[q>>0]=16;break}else{c[q+4>>2]=8;break}}while(0);if(a[k>>0]&1){s=c[k+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(s,f)}s=c[n>>2]|0;if((((c[r>>2]|0)-s|0)/12|0)>>>0>1){u=l+1|0;x=l+8|0;w=l+4|0;t=s;s=1;do{y=t+(s*12|0)|0;c[f>>2]=s+-1;Lsd(l,601752,f);B=a[l>>0]|0;if(!(B&1)){C=(B&255)>>>1;D=u}else{C=c[w>>2]|0;D=c[x>>2]|0}B=a[y>>0]|0;if(!(B&1)){E=10;F=B}else{B=c[y>>2]|0;E=(B&-2)+-1|0;F=B&255}B=(F&1)==0;do if(C>>>0<=E>>>0){if(B)G=y+1|0;else G=c[t+(s*12|0)+8>>2]|0;aFi(G|0,D|0,C|0)|0;a[G+C>>0]=0;if(!(a[y>>0]&1)){a[y>>0]=C<<1;break}else{c[t+(s*12|0)+4>>2]=C;break}}else{if(B)H=(F&255)>>>1;else H=c[t+(s*12|0)+4>>2]|0;eXb(y,E,C-E|0,H,0,H,C,D)}while(0);xri(l);s=s+1|0;t=c[n>>2]|0}while(s>>>0<(((c[r>>2]|0)-t|0)/12|0)>>>0)}}else{a[h>>0]=16;t=h+1|0;s=t;x=s;a[x>>0]=109;a[x+1>>0]=97;a[x+2>>0]=105;a[x+3>>0]=110;x=s+4|0;a[x>>0]=68;a[x+1>>0]=97;a[x+2>>0]=116;a[x+3>>0]=97;a[h+9>>0]=0;if((q|0)==(c[b+44>>2]|0))wXb(n,h);else{if(!q)I=0;else{a[q>>0]=16;x=t;t=x;s=d[t>>0]|d[t+1>>0]<<8|d[t+2>>0]<<16|d[t+3>>0]<<24;t=x+4|0;x=d[t>>0]|d[t+1>>0]<<8|d[t+2>>0]<<16|d[t+3>>0]<<24;t=q+1|0;w=t;a[w>>0]=s;a[w+1>>0]=s>>8;a[w+2>>0]=s>>16;a[w+3>>0]=s>>24;s=t+4|0;a[s>>0]=x;a[s+1>>0]=x>>8;a[s+2>>0]=x>>16;a[s+3>>0]=x>>24;a[q+9>>0]=0;I=c[r>>2]|0}c[r>>2]=I+12}x=c[p>>2]|0;s=c[b+32>>2]|0;a[j>>0]=0;a[j+1>>0]=0;if((x|0)==(s|0)){wXb(o,j);break}if(!x)J=0;else{a[x>>0]=0;a[x+1>>0]=0;J=c[p>>2]|0}c[p>>2]=J+12}while(0);J=b+124|0;p=a[J>>0]|0;if(!(p&1)){K=J+1|0;L=(p&255)>>>1}else{K=c[b+132>>2]|0;L=c[b+128>>2]|0}rri(m,K,L);if(!(a[m>>0]&1)){M=m+1|0;N=Psd(M)|0;O=b+120|0;c[O>>2]=N;xri(m);i=e;return}else{M=c[m+8>>2]|0;N=Psd(M)|0;O=b+120|0;c[O>>2]=N;xri(m);i=e;return}}function NOc(){var a=0,b=0;a=i;b=rVb(10)|0;i=a;return b|0}function OOc(){var a=0,b=0;a=i;b=tVb(10)|0;i=a;return b|0}function POc(){var a=0;a=i;QQb(141,154,0,0,0);i=a;return}function QOc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,601760,13);wQb(141,6,b,136,2632,0,0);xri(b);i=a;return}function ROc(a){a=a|0;return 141}function SOc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,601760,a,0);_Oc(a,b);bdd(b);i=c;return}function TOc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,601760,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else $Oc(a,b);sdd(b);i=d;return}function UOc(a,b){a=a|0;b=b|0;var c=0;c=i;aPc(a,b);i=c;return}function VOc(a,b){a=a|0;b=b|0;var c=0;c=i;bPc(a,b);i=c;return}function WOc(a,b){a=a|0;b=b|0;var c=0;c=i;cPc(a,b);i=c;return}function XOc(a,b){a=a|0;b=b|0;var c=0;c=i;PSb(a,b);i=c;return}function YOc(){return}function ZOc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(136,e,1,16,3653512,11)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];LOc(f,e,b);i=d;return f|0}function _Oc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d+32|0;f=d;KSb(a,b);ddd(b,2);vXb(b,a+24|0,601776,0);vXb(b,a+48|0,601784,0);g=c[142258]|0;add(b,601808,g,a+92|0,0);h=b+12|0;j=b+20|0;c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601832,g,a+93|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601848,g,a+96|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601872,g,a+97|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601896,g,a+98|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601920,g,a+99|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601936,g,a+100|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601960,g,a+101|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601976,g,a+102|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,601992,g,a+103|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,602016,g,a+94|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);g=c[142258]|0;add(b,602040,g,a+95|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,602064,g,a+104|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,602080,g,a+105|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,602104,g,a+106|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,602128,g,a+107|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);g=c[142294]|0;add(b,602152,g,a+124|0,0);$cd(b,2646336,2646336,e,1);k=c[142260]|0;add(b,3142592,k,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,602168,g,a+108|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,k,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);k=c[142272]|0;add(b,602184,k,a+60|0,0);c[f>>2]=0;g=f+8|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;$cd(b,2646336,2646336,e,0);l=c[142274]|0;add(b,3142592,l,f,0);m=c[142266]|0;add(b,m,c[142270]|0,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);j=c[142282]|0;add(b,j,616312,g,0);v6b(g,b);bdd(b);bdd(b);cdd(b);bdd(b);add(b,602208,k,a+76|0,0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;$cd(b,2646336,2646336,e,0);add(b,3142592,l,f,0);add(b,m,616312,f,0);v6b(f,b);bdd(b);m=f+16|0;add(b,j,616312,m,0);v6b(m,b);bdd(b);bdd(b);cdd(b);bdd(b);i=d;return}function $Oc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+12|0;g=e;LSb(b,d);rdd(d,2);h=b+24|0;j=c[142306]|0;k=qdd(d,601776,j,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else yXb(d,h,0);sdd(d)}h=b+48|0;k=qdd(d,601784,j,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else yXb(d,h,0);sdd(d)}h=b+92|0;k=c[142258]|0;j=qdd(d,601808,k,f,0)|0;if(j){do if((j|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[l>>2]=o;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}j=b+93|0;l=qdd(d,601832,k,f,0)|0;if(l){do if((l|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](j,d)|0}else{o=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+m|0;c[o>>2]=p;if((m|0)>=0?(n+(m+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[j>>0]=a[p>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break}Bid(o,j,1)}while(0);sdd(d)}l=b+96|0;o=qdd(d,601848,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+n|0;c[p>>2]=q;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+97|0;o=qdd(d,601872,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;q=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+n|0;c[p>>2]=m;if((n|0)>=0?(q+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[m>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+98|0;o=qdd(d,601896,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+n|0;c[p>>2]=q;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+99|0;o=qdd(d,601920,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;q=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+n|0;c[p>>2]=m;if((n|0)>=0?(q+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[m>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+100|0;o=qdd(d,601936,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+n|0;c[p>>2]=q;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+101|0;o=qdd(d,601960,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;q=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+n|0;c[p>>2]=m;if((n|0)>=0?(q+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[m>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+102|0;o=qdd(d,601976,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+n|0;c[p>>2]=q;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+103|0;o=qdd(d,601992,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;q=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+n|0;c[p>>2]=m;if((n|0)>=0?(q+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[m>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+94|0;o=qdd(d,602016,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+n|0;c[p>>2]=q;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+95|0;o=qdd(d,602040,k,f,0)|0;if(o){do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;q=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+n|0;c[p>>2]=m;if((n|0)>=0?(q+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[l>>0]=a[m>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,l,1)}while(0);sdd(d)}l=b+104|0;o=qdd(d,602064,k,f,0)|0;if(o){a:do if((o|0)<=0){p=c[f>>2]|0;if(p)_n[p&4095](l,d)|0}else{p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+n|0;c[p>>2]=q;do if((n|0)>=0){if((m+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[l>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break a}while(0);Bid(p,l,1)}while(0);sdd(d)}l=b+105|0;o=qdd(d,602080,k,f,0)|0;if(o){b:do if((o|0)<=0){q=c[f>>2]|0;if(q)_n[q&4095](l,d)|0}else{q=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=n+m|0;c[q>>2]=r;do if((m|0)>=0){if((n+(m+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[l>>0]=a[r>>0]|0;c[q>>2]=(c[q>>2]|0)+1;break b}while(0);Bid(q,l,1)}while(0);sdd(d)}l=b+106|0;o=qdd(d,602104,k,f,0)|0;if(o){c:do if((o|0)>0){r=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=m+n|0;c[r>>2]=p;do if((n|0)>=0){if((m+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[l>>0]=a[p>>0]|0;c[r>>2]=(c[r>>2]|0)+1;break c}while(0);Bid(r,l,1)}else{p=c[f>>2]|0;if(!p)break;_n[p&4095](l,d)|0}while(0);sdd(d)}l=b+107|0;o=qdd(d,602128,k,f,0)|0;if(o){d:do if((o|0)>0){k=d+12|0;p=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+n|0;c[k>>2]=m;do if((n|0)>=0){if((p+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[l>>0]=a[m>>0]|0;c[k>>2]=(c[k>>2]|0)+1;break d}while(0);Bid(k,l,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](l,d)|0}while(0);sdd(d)}if(wdd(d,1)|0)a[j>>0]=a[h>>0]|0;h=b+124|0;j=c[142294]|0;l=qdd(d,602152,j,f,0)|0;if(l){do if((l|0)>0)zXb(d,h,1);else{o=c[f>>2]|0;if(!o)break;_n[o&4095](h,d)|0}while(0);sdd(d)}l=b+108|0;o=qdd(d,602168,j,f,0)|0;if(o){do if((o|0)>0)zXb(d,l,1);else{j=c[f>>2]|0;if(!j)break;_n[j&4095](l,d)|0}while(0);sdd(d)}l=a[h>>0]|0;if(!(l&1)){s=h+1|0;t=(l&255)>>>1}else{s=c[b+132>>2]|0;t=c[b+128>>2]|0}rri(g,s,t);xri(g);g=b+60|0;t=c[142272]|0;s=qdd(d,602184,t,f,1)|0;if(s){do if((s|0)>0)fPc(d,g,0);else{l=c[f>>2]|0;if(!l)break;_n[l&4095](g,d)|0}while(0);sdd(d)}g=b+76|0;b=qdd(d,602208,t,f,1)|0;if(!b){i=e;return}do if((b|0)>0)gPc(d,g,0);else{t=c[f>>2]|0;if(!t)break;_n[t&4095](g,d)|0}while(0);sdd(d);i=e;return}function aPc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e;MSb(b,d);BXb(d,b+24|0,0);BXb(d,b+48|0,0);g=b+92|0;h=d+12|0;j=c[h>>2]|0;k=d+20|0;if((j+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,g,1);l=c[h>>2]|0}else{a[g>>0]=a[j>>0]|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;l=j}j=b+93|0;if((l+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,j,1);m=c[h>>2]|0}else{a[j>>0]=a[l>>0]|0;l=(c[h>>2]|0)+1|0;c[h>>2]=l;m=l}l=b+96|0;if((m+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,l,1);n=c[h>>2]|0}else{a[l>>0]=a[m>>0]|0;m=(c[h>>2]|0)+1|0;c[h>>2]=m;n=m}m=b+97|0;if((n+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,m,1);o=c[h>>2]|0}else{a[m>>0]=a[n>>0]|0;n=(c[h>>2]|0)+1|0;c[h>>2]=n;o=n}n=b+98|0;if((o+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,n,1);p=c[h>>2]|0}else{a[n>>0]=a[o>>0]|0;o=(c[h>>2]|0)+1|0;c[h>>2]=o;p=o}o=b+99|0;if((p+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,o,1);q=c[h>>2]|0}else{a[o>>0]=a[p>>0]|0;p=(c[h>>2]|0)+1|0;c[h>>2]=p;q=p}p=b+100|0;if((q+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,p,1);r=c[h>>2]|0}else{a[p>>0]=a[q>>0]|0;q=(c[h>>2]|0)+1|0;c[h>>2]=q;r=q}q=b+101|0;if((r+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,q,1);s=c[h>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[h>>2]|0)+1|0;c[h>>2]=r;s=r}r=b+102|0;if((s+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,r,1);t=c[h>>2]|0}else{a[r>>0]=a[s>>0]|0;s=(c[h>>2]|0)+1|0;c[h>>2]=s;t=s}s=b+103|0;if((t+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,s,1);u=c[h>>2]|0}else{a[s>>0]=a[t>>0]|0;t=(c[h>>2]|0)+1|0;c[h>>2]=t;u=t}t=b+94|0;if((u+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,t,1);v=c[h>>2]|0}else{a[t>>0]=a[u>>0]|0;u=(c[h>>2]|0)+1|0;c[h>>2]=u;v=u}u=b+95|0;if((v+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,u,1);w=c[h>>2]|0}else{a[u>>0]=a[v>>0]|0;v=(c[h>>2]|0)+1|0;c[h>>2]=v;w=v}v=b+104|0;if((w+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,v,1);x=c[h>>2]|0}else{a[v>>0]=a[w>>0]|0;w=(c[h>>2]|0)+1|0;c[h>>2]=w;x=w}w=b+105|0;if((x+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,w,1);y=c[h>>2]|0}else{a[w>>0]=a[x>>0]|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;y=x}x=b+106|0;if((y+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,x,1);z=c[h>>2]|0}else{a[x>>0]=a[y>>0]|0;y=(c[h>>2]|0)+1|0;c[h>>2]=y;z=y}y=b+107|0;if((z+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,y,1);else{a[y>>0]=a[z>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);h=b+124|0;NXb(d,h,1);Ndd(d);NXb(d,b+108|0,1);Ndd(d);z=a[h>>0]|0;if(!(z&1)){A=h+1|0;B=(z&255)>>>1}else{A=c[b+132>>2]|0;B=c[b+128>>2]|0}rri(f,A,B);if(!(a[f>>0]&1)){xri(f);C=b+60|0;hPc(d,C,0);D=b+76|0;iPc(d,D,0);i=e;return}else{xri(f);C=b+60|0;hPc(d,C,0);D=b+76|0;iPc(d,D,0);i=e;return}}function bPc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e;NSb(b,d);DXb(d,b+24|0,0);DXb(d,b+48|0,0);g=b+92|0;h=d+12|0;j=c[h>>2]|0;k=d+20|0;if((j+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,g,1);l=c[h>>2]|0}else{a[g>>0]=a[j>>0]|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;l=j}j=b+93|0;if((l+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,j,1);m=c[h>>2]|0}else{a[j>>0]=a[l>>0]|0;l=(c[h>>2]|0)+1|0;c[h>>2]=l;m=l}l=b+96|0;if((m+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,l,1);n=c[h>>2]|0}else{a[l>>0]=a[m>>0]|0;m=(c[h>>2]|0)+1|0;c[h>>2]=m;n=m}m=b+97|0;if((n+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,m,1);o=c[h>>2]|0}else{a[m>>0]=a[n>>0]|0;n=(c[h>>2]|0)+1|0;c[h>>2]=n;o=n}n=b+98|0;if((o+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,n,1);p=c[h>>2]|0}else{a[n>>0]=a[o>>0]|0;o=(c[h>>2]|0)+1|0;c[h>>2]=o;p=o}o=b+99|0;if((p+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,o,1);q=c[h>>2]|0}else{a[o>>0]=a[p>>0]|0;p=(c[h>>2]|0)+1|0;c[h>>2]=p;q=p}p=b+100|0;if((q+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,p,1);r=c[h>>2]|0}else{a[p>>0]=a[q>>0]|0;q=(c[h>>2]|0)+1|0;c[h>>2]=q;r=q}q=b+101|0;if((r+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,q,1);s=c[h>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[h>>2]|0)+1|0;c[h>>2]=r;s=r}r=b+102|0;if((s+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,r,1);t=c[h>>2]|0}else{a[r>>0]=a[s>>0]|0;s=(c[h>>2]|0)+1|0;c[h>>2]=s;t=s}s=b+103|0;if((t+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,s,1);u=c[h>>2]|0}else{a[s>>0]=a[t>>0]|0;t=(c[h>>2]|0)+1|0;c[h>>2]=t;u=t}t=b+94|0;if((u+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,t,1);v=c[h>>2]|0}else{a[t>>0]=a[u>>0]|0;u=(c[h>>2]|0)+1|0;c[h>>2]=u;v=u}u=b+95|0;if((v+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,u,1);w=c[h>>2]|0}else{a[u>>0]=a[v>>0]|0;v=(c[h>>2]|0)+1|0;c[h>>2]=v;w=v}v=b+104|0;if((w+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,v,1);x=c[h>>2]|0}else{a[v>>0]=a[w>>0]|0;w=(c[h>>2]|0)+1|0;c[h>>2]=w;x=w}w=b+105|0;if((x+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,w,1);y=c[h>>2]|0}else{a[w>>0]=a[x>>0]|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;y=x}x=b+106|0;if((y+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,x,1);z=c[h>>2]|0}else{a[x>>0]=a[y>>0]|0;y=(c[h>>2]|0)+1|0;c[h>>2]=y;z=y}y=b+107|0;if((z+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,y,1);else{a[y>>0]=a[z>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);h=b+124|0;OXb(d,h,1);Mdd(d);OXb(d,b+108|0,1);Mdd(d);z=a[h>>0]|0;if(!(z&1)){A=h+1|0;B=(z&255)>>>1}else{A=c[b+132>>2]|0;B=c[b+128>>2]|0}rri(f,A,B);if(!(a[f>>0]&1)){xri(f);C=b+60|0;jPc(d,C,0);D=b+76|0;kPc(d,D,0);i=e;return}else{xri(f);C=b+60|0;jPc(d,C,0);D=b+76|0;kPc(d,D,0);i=e;return}}function cPc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=i;i=i+16|0;f=e;OSb(b,d);g=b+28|0;h=c[g>>2]|0;j=b+24|0;k=c[j>>2]|0;l=(h-k|0)/12|0;c[f>>2]=l;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;if(o>>>0<(c[p>>2]|0)>>>0){c[n>>2]=l;c[m>>2]=o;q=k;r=h}else{Gid(m,f,4);q=c[j>>2]|0;r=c[g>>2]|0}if((q|0)!=(r|0)){g=q;do{FXb(d,g,3142592,0);g=g+12|0}while((g|0)!=(r|0))}r=b+52|0;g=c[r>>2]|0;q=b+48|0;j=c[q>>2]|0;h=(g-j|0)/12|0;c[f>>2]=h;k=c[m>>2]|0;o=k+4|0;if(o>>>0<(c[p>>2]|0)>>>0){c[k>>2]=h;c[m>>2]=o;s=j;t=g}else{Gid(m,f,4);s=c[q>>2]|0;t=c[r>>2]|0}if((s|0)!=(t|0)){r=s;do{FXb(d,r,3142592,0);r=r+12|0}while((r|0)!=(t|0))}t=b+92|0;r=c[m>>2]|0;if((r+1|0)>>>0<(c[p>>2]|0)>>>0){a[r>>0]=a[t>>0]|0;r=(c[m>>2]|0)+1|0;c[m>>2]=r;u=r}else{Gid(m,t,1);u=c[m>>2]|0}t=b+93|0;if((u+1|0)>>>0<(c[p>>2]|0)>>>0){a[u>>0]=a[t>>0]|0;u=(c[m>>2]|0)+1|0;c[m>>2]=u;v=u}else{Gid(m,t,1);v=c[m>>2]|0}t=b+96|0;if((v+1|0)>>>0<(c[p>>2]|0)>>>0){a[v>>0]=a[t>>0]|0;v=(c[m>>2]|0)+1|0;c[m>>2]=v;w=v}else{Gid(m,t,1);w=c[m>>2]|0}t=b+97|0;if((w+1|0)>>>0<(c[p>>2]|0)>>>0){a[w>>0]=a[t>>0]|0;w=(c[m>>2]|0)+1|0;c[m>>2]=w;x=w}else{Gid(m,t,1);x=c[m>>2]|0}t=b+98|0;if((x+1|0)>>>0<(c[p>>2]|0)>>>0){a[x>>0]=a[t>>0]|0;x=(c[m>>2]|0)+1|0;c[m>>2]=x;y=x}else{Gid(m,t,1);y=c[m>>2]|0}t=b+99|0;if((y+1|0)>>>0<(c[p>>2]|0)>>>0){a[y>>0]=a[t>>0]|0;y=(c[m>>2]|0)+1|0;c[m>>2]=y;z=y}else{Gid(m,t,1);z=c[m>>2]|0}t=b+100|0;if((z+1|0)>>>0<(c[p>>2]|0)>>>0){a[z>>0]=a[t>>0]|0;z=(c[m>>2]|0)+1|0;c[m>>2]=z;A=z}else{Gid(m,t,1);A=c[m>>2]|0}t=b+101|0;if((A+1|0)>>>0<(c[p>>2]|0)>>>0){a[A>>0]=a[t>>0]|0;A=(c[m>>2]|0)+1|0;c[m>>2]=A;B=A}else{Gid(m,t,1);B=c[m>>2]|0}t=b+102|0;if((B+1|0)>>>0<(c[p>>2]|0)>>>0){a[B>>0]=a[t>>0]|0;B=(c[m>>2]|0)+1|0;c[m>>2]=B;C=B}else{Gid(m,t,1);C=c[m>>2]|0}t=b+103|0;if((C+1|0)>>>0<(c[p>>2]|0)>>>0){a[C>>0]=a[t>>0]|0;C=(c[m>>2]|0)+1|0;c[m>>2]=C;D=C}else{Gid(m,t,1);D=c[m>>2]|0}t=b+94|0;if((D+1|0)>>>0<(c[p>>2]|0)>>>0){a[D>>0]=a[t>>0]|0;D=(c[m>>2]|0)+1|0;c[m>>2]=D;E=D}else{Gid(m,t,1);E=c[m>>2]|0}t=b+95|0;if((E+1|0)>>>0<(c[p>>2]|0)>>>0){a[E>>0]=a[t>>0]|0;E=(c[m>>2]|0)+1|0;c[m>>2]=E;F=E}else{Gid(m,t,1);F=c[m>>2]|0}t=b+104|0;if((F+1|0)>>>0<(c[p>>2]|0)>>>0){a[F>>0]=a[t>>0]|0;F=(c[m>>2]|0)+1|0;c[m>>2]=F;G=F}else{Gid(m,t,1);G=c[m>>2]|0}t=b+105|0;if((G+1|0)>>>0<(c[p>>2]|0)>>>0){a[G>>0]=a[t>>0]|0;G=(c[m>>2]|0)+1|0;c[m>>2]=G;H=G}else{Gid(m,t,1);H=c[m>>2]|0}t=b+106|0;if((H+1|0)>>>0<(c[p>>2]|0)>>>0){a[H>>0]=a[t>>0]|0;H=(c[m>>2]|0)+1|0;c[m>>2]=H;I=H}else{Gid(m,t,1);I=c[m>>2]|0}t=b+107|0;if((I+1|0)>>>0<(c[p>>2]|0)>>>0){a[I>>0]=a[t>>0]|0;c[m>>2]=(c[m>>2]|0)+1}else Gid(m,t,1);Tdd(d);FXb(d,b+124|0,602152,0);FXb(d,b+108|0,602168,0);t=b+68|0;I=c[t>>2]|0;H=b+64|0;G=c[H>>2]|0;F=(I-G|0)/24|0;c[f>>2]=F;E=c[m>>2]|0;D=E+4|0;if(D>>>0<(c[p>>2]|0)>>>0){c[E>>2]=F;c[m>>2]=D;J=G;K=I}else{Gid(m,f,4);J=c[H>>2]|0;K=c[t>>2]|0}if((J|0)!=(K|0)){t=J;do{J=c[m>>2]|0;H=J+4|0;if(H>>>0<(c[p>>2]|0)>>>0){c[J>>2]=c[t>>2];c[m>>2]=H}else Gid(m,t,4);M6b(t+8|0,d);t=t+24|0}while((t|0)!=(K|0))}K=b+84|0;t=c[K>>2]|0;H=b+80|0;b=c[H>>2]|0;J=t-b>>5;c[f>>2]=J;I=c[m>>2]|0;G=I+4|0;if(G>>>0<(c[p>>2]|0)>>>0){c[I>>2]=J;c[m>>2]=G;L=b;M=t}else{Gid(m,f,4);L=c[H>>2]|0;M=c[K>>2]|0}if((L|0)==(M|0)){i=e;return}else N=L;do{M6b(N,d);M6b(N+16|0,d);N=N+32|0}while((N|0)!=(M|0));i=e;return}function dPc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[b>>2]=601640;if(a[b+124>>0]&1){l=c[b+132>>2]|0;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];eOb(l,e)}if(a[b+108>>0]&1){l=c[b+116>>2]|0;c[j>>2]=58;c[e+0>>2]=c[j+0>>2];eOb(l,e)}l=c[b+80>>2]|0;if(l){j=b+84|0;k=c[j>>2]|0;if((k|0)!=(l|0))c[j>>2]=k+(~((k+-32-l|0)>>>5)<<5);ACi(l)}l=c[b+64>>2]|0;if(l){k=b+68|0;j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~(((j+-24-l|0)>>>0)/24|0)*24|0);ACi(l)}l=b+48|0;j=c[l>>2]|0;if(j){k=b+52|0;m=c[k>>2]|0;if((m|0)==(j|0))n=j;else{o=m;while(1){m=o+-12|0;c[k>>2]=m;if(!(a[m>>0]&1))p=m;else{m=c[o+-4>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(m,e);p=c[k>>2]|0}if((p|0)==(j|0))break;else o=p}n=c[l>>2]|0}ACi(n)}n=b+36|0;l=c[n>>2]|0;if(l){p=b+40|0;o=c[p>>2]|0;if((o|0)==(l|0))q=l;else{j=o;while(1){o=j+-12|0;c[p>>2]=o;if(!(a[o>>0]&1))r=o;else{o=c[j+-4>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(o,e);r=c[p>>2]|0}if((r|0)==(l|0))break;else j=r}q=c[n>>2]|0}ACi(q)}q=b+24|0;n=c[q>>2]|0;if(!n){ZSb(b);i=d;return}r=b+28|0;j=c[r>>2]|0;if((j|0)==(n|0))s=n;else{l=j;while(1){j=l+-12|0;c[r>>2]=j;if(!(a[j>>0]&1))t=j;else{j=c[l+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(j,e);t=c[r>>2]|0}if((t|0)==(n|0))break;else l=t}s=c[q>>2]|0}ACi(s);ZSb(b);i=d;return}function ePc(a){a=a|0;var b=0;b=i;dPc(a);ACi(a);i=b;return}function fPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+8|0;j=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[j>>2]|0)|0)/24|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;l=b+4|0;b=c[h>>2]|0;m=c[l>>2]|0;n=(b-m|0)/24|0;if(k>>>0<=n>>>0)if(k>>>0<n>>>0?(o=m+(k*24|0)|0,(b|0)!=(o|0)):0){m=b+(~(((b+-24-o|0)>>>0)/24|0)*24|0)|0;c[h>>2]=m;p=k;q=m}else{p=k;q=b}else{lPc(l,k-n|0);p=c[f>>2]|0;q=c[h>>2]|0}do if(p){h=c[142274]|0;f=qdd(a,3142592,h,0,1)|0;n=a+80|0;k=c[($hd(c[n>>2]|0)|0)+12>>2]|0;l=a+84|0;c[c[l>>2]>>2]=0;if((f|0)==2){f=c[n>>2]|0;b=c[f+12>>2]|0;m=c[j>>2]|0;a:do if((m|0)!=(q|0)){o=0;r=f;s=m;while(1){t=(da(o,k)|0)+b|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[l>>2]|0;c[u>>2]=(c[u>>2]|0)+1;mPc(s,a);u=s+24|0;if((u|0)==(q|0))break a;o=c[c[l>>2]>>2]|0;r=c[n>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);n=c[j>>2]|0;if((n|0)!=(q|0)){l=n;do{n=qdd(a,3142592,h,e,1)|0;if(n){if((n|0)<=0){n=c[e>>2]|0;if(n)_n[n&4095](l,a)|0}else mPc(l,a);sdd(a)}l=l+24|0}while((l|0)!=(q|0))}}while(0);udd(a);i=d;return}function gPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+8|0;j=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[j>>2]|0)>>5;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;l=b+4|0;b=c[h>>2]|0;m=c[l>>2]|0;n=b-m>>5;if(k>>>0<=n>>>0)if(k>>>0<n>>>0?(o=m+(k<<5)|0,(b|0)!=(o|0)):0){m=b+(~((b+-32-o|0)>>>5)<<5)|0;c[h>>2]=m;p=k;q=m}else{p=k;q=b}else{nPc(l,k-n|0);p=c[f>>2]|0;q=c[h>>2]|0}do if(p){h=c[142274]|0;f=qdd(a,3142592,h,0,1)|0;n=a+80|0;k=c[($hd(c[n>>2]|0)|0)+12>>2]|0;l=a+84|0;c[c[l>>2]>>2]=0;if((f|0)==2){f=c[n>>2]|0;b=c[f+12>>2]|0;m=c[j>>2]|0;a:do if((m|0)!=(q|0)){o=0;r=f;s=m;while(1){t=(da(o,k)|0)+b|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[l>>2]|0;c[u>>2]=(c[u>>2]|0)+1;oPc(s,a);u=s+32|0;if((u|0)==(q|0))break a;o=c[c[l>>2]>>2]|0;r=c[n>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);n=c[j>>2]|0;if((n|0)!=(q|0)){l=n;do{n=qdd(a,3142592,h,e,1)|0;if(n){if((n|0)<=0){n=c[e>>2]|0;if(n)_n[n&4095](l,a)|0}else oPc(l,a);sdd(a)}l=l+32|0}while((l|0)!=(q|0))}}while(0);udd(a);i=d;return}function hPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[h>>2]|0;q=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;p=l;q=n}n=p+4|0;if(n>>>0>q>>>0){Bid(h,e,4);r=c[e>>2]|0}else{q=c[p>>2]|0;c[e>>2]=q;c[h>>2]=n;r=q}zid(h,r,(c[f>>2]|0)*24|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);s=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;s=o}o=b+4|0;l=b+8|0;g=c[l>>2]|0;k=c[o>>2]|0;j=(g-k|0)/24|0;if(s>>>0<=j>>>0)if(s>>>0<j>>>0?(f=k+(s*24|0)|0,(g|0)!=(f|0)):0){r=g+(~(((g+-24-f|0)>>>0)/24|0)*24|0)|0;c[l>>2]=r;t=k;u=r}else{t=k;u=g}else{lPc(o,s-j|0);t=c[b+4>>2]|0;u=c[l>>2]|0}if((t|0)==(u|0)){i=d;return}else v=t;do{t=c[h>>2]|0;l=t+4|0;if(l>>>0>(c[m>>2]|0)>>>0)Bid(h,v,4);else{c[v>>2]=c[t>>2];c[h>>2]=l}C6b(v+8|0,a);v=v+24|0}while((v|0)!=(u|0));i=d;return}function iPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[h>>2]|0;q=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;p=l;q=n}n=p+4|0;if(n>>>0>q>>>0){Bid(h,e,4);r=c[e>>2]|0}else{q=c[p>>2]|0;c[e>>2]=q;c[h>>2]=n;r=q}zid(h,r,c[f>>2]<<5)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);s=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;s=o}o=b+4|0;l=b+8|0;h=c[l>>2]|0;g=c[o>>2]|0;k=h-g>>5;if(s>>>0<=k>>>0)if(s>>>0<k>>>0?(j=g+(s<<5)|0,(h|0)!=(j|0)):0){f=h+(~((h+-32-j|0)>>>5)<<5)|0;c[l>>2]=f;t=g;u=f}else{t=g;u=h}else{nPc(o,s-k|0);t=c[b+4>>2]|0;u=c[l>>2]|0}if((t|0)==(u|0)){i=d;return}else v=t;do{C6b(v,a);C6b(v+16|0,a);v=v+32|0}while((v|0)!=(u|0));i=d;return}function jPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{s=c[k>>2]|0;c[f>>2]=s;c[h>>2]=l;p=s;q=l;r=n}n=XEi(p|0)|0;c[f>>2]=n;p=q+4|0;if(p>>>0>r>>>0){Bid(h,e,4);t=c[e>>2]|0;u=c[f>>2]|0}else{f=c[q>>2]|0;c[e>>2]=f;c[h>>2]=p;t=f;u=n}n=XEi(t|0)|0;c[e>>2]=n;zid(h,n,u*24|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);v=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;v=o}o=XEi(v|0)|0;c[g>>2]=o;g=b+4|0;v=b+8|0;l=c[v>>2]|0;k=c[g>>2]|0;j=(l-k|0)/24|0;if(o>>>0<=j>>>0)if(o>>>0<j>>>0?(u=k+(o*24|0)|0,(l|0)!=(u|0)):0){n=l+(~(((l+-24-u|0)>>>0)/24|0)*24|0)|0;c[v>>2]=n;w=k;x=n}else{w=k;x=l}else{lPc(g,o-j|0);w=c[b+4>>2]|0;x=c[v>>2]|0}if((w|0)==(x|0)){i=d;return}else y=w;do{w=c[h>>2]|0;v=w+4|0;if(v>>>0>(c[m>>2]|0)>>>0){Bid(h,y,4);z=c[y>>2]|0}else{b=c[w>>2]|0;c[y>>2]=b;c[h>>2]=v;z=b}c[y>>2]=XEi(z|0)|0;H6b(y+8|0,a);y=y+24|0}while((y|0)!=(x|0));i=d;return}function kPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;p=m;q=l;r=n}n=XEi(p|0)|0;c[f>>2]=n;p=q+4|0;if(p>>>0>r>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[q>>2]|0;c[e>>2]=f;c[h>>2]=p;s=f;t=n}n=XEi(s|0)|0;c[e>>2]=n;zid(h,n,t<<5)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);u=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;u=o}o=XEi(u|0)|0;c[g>>2]=o;g=b+4|0;u=b+8|0;l=c[u>>2]|0;h=c[g>>2]|0;k=l-h>>5;if(o>>>0<=k>>>0)if(o>>>0<k>>>0?(j=h+(o<<5)|0,(l|0)!=(j|0)):0){t=l+(~((l+-32-j|0)>>>5)<<5)|0;c[u>>2]=t;v=h;w=t}else{v=h;w=l}else{nPc(g,o-k|0);v=c[b+4>>2]|0;w=c[u>>2]|0}if((v|0)==(w|0)){i=d;return}else x=v;do{H6b(x,a);H6b(x+16|0,a);x=x+32|0}while((x|0)!=(w|0));i=d;return}function lPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(((f-j|0)/24|0)>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l>>2]=0;h=l+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;m=c[g>>2]|0}l=m+24|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=((j-k|0)/24|0)+b|0;if(l>>>0>178956970)vxi(a);j=k;k=(f-j|0)/24|0;if(k>>>0<89478485){f=k<<1;k=f>>>0<l>>>0?l:f;f=((c[g>>2]|0)-j|0)/24|0;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=178956970;r=((c[g>>2]|0)-j|0)/24|0;s=10}if((s|0)==10){n=q;o=xCi(q*24|0)|0;p=r}r=b;b=o+(p*24|0)|0;while(1){if(!b)t=0;else{c[b>>2]=0;q=b+8|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;t=b}q=t+24|0;r=r+-1|0;if(!r){u=q;break}else b=q}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;t=o+((((r|0)/-24|0)+p|0)*24|0)|0;YEi(t|0,b|0,r|0)|0;c[a>>2]=t;c[g>>2]=u;c[e>>2]=o+(n*24|0);if(!b){i=d;return}ACi(b);i=d;return}function mPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,c[142270]|0,e,0)|0;if(f){if((f|0)>0){f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[j>>2];c[f>>2]=k}else Bid(f,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}sdd(b)}f=a+8|0;a=qdd(b,c[142282]|0,616312,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else b7b(f,b);sdd(b);i=d;return}function nPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>5>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0;m=c[g>>2]|0}l=m+32|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>5)+b|0;if(l>>>0>134217727)vxi(a);j=k;k=f-j|0;if(k>>5>>>0<67108863){f=k>>4;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>5;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=134217727;r=(c[g>>2]|0)-j>>5;s=10}if((s|0)==10){n=q;o=xCi(q<<5)|0;p=r}r=b;b=o+(p<<5)|0;while(1){if(!b)t=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;t=b}q=t+32|0;r=r+-1|0;if(!r){u=q;break}else b=q}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;t=o+(p-(r>>5)<<5)|0;YEi(t|0,b|0,r|0)|0;c[a>>2]=t;c[g>>2]=u;c[e>>2]=o+(n<<5);if(!b){i=d;return}ACi(b);i=d;return}function oPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,616312,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else b7b(a,b);sdd(b)}f=a+16|0;a=qdd(b,c[142282]|0,616312,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else b7b(f,b);sdd(b);i=d;return}function pPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b;if(!(qqd(a)|0)){e=0;i=b;return e|0}f=d+4|0;c[f>>2]=0;c[d+8>>2]=0;g=d+4|0;c[d>>2]=g;if(tqd(a,d)|0?(a=c[d>>2]|0,(a|0)!=(g|0)):0){h=a;a=0;while(1){j=h+16|0;if(qqd(j)|0)k=pPc(j)|0;else k=yqd(j)|0;j=k+a|0;l=c[h+4>>2]|0;if(!l){m=h;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){o=n;break}else m=n}}else{m=l;while(1){n=c[m>>2]|0;if(!n){o=m;break}else m=n}}if((o|0)==(g|0)){p=j;break}else{h=o;a=j}}}else p=0;WN(d,c[f>>2]|0);e=p;i=b;return e|0}function qPc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d+12|0;f=d;Wpe(e);g=a[e>>0]|0;if(!(g&1))h=(g&255)>>>1;else h=c[e+4>>2]|0;if(!h){sri(b,e);xri(e);i=d;return}else{rri(f,602224,10);fsd(b,e,f);xri(f);xri(e);i=d;return}}function rPc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+12|0;h=f;qPc(g);j=a[d>>0]|0;if(!(j&1))k=(j&255)>>>1;else k=c[d+4>>2]|0;if(!((k|0)!=0|e)){sri(b,g);xri(g);i=f;return}fsd(h,g,d);do if(e)if(GPc(h)|0){sri(b,h);break}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;break}else sri(b,h);while(0);xri(h);xri(g);i=f;return}function sPc(a,b){a=a|0;b=b|0;var d=0;d=i;HPc((c[a+4>>2]|0)+68|0,b)|0;i=d;return}function tPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+12|0;e=b;f=a+40|0;Dqd(f)|0;g=a+28|0;rri(e,602248,6);fsd(d,g,e);wqd(d)|0;xri(d);xri(e);Cqd(f);xri(g);g=a+16|0;f=c[g>>2]|0;if(!f){i=b;return}e=a+20|0;while(1){a=c[e>>2]|0;if((a|0)==(f|0))break;d=a+-12|0;c[e>>2]=d;xri(d)}ACi(c[g>>2]|0);i=b;return}function uPc(){var b=0,d=0,e=0;b=i;d=c[150568]|0;if(d){e=d;i=b;return e|0}d=xCi(12)|0;c[d+4>>2]=0;c[d>>2]=0;a[d+8>>0]=0;CPc(d);c[150568]=d;e=d;i=b;return e|0}function vPc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+36|0;k=f+24|0;l=f+12|0;m=f;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;rri(l,602288,6);fsd(k,b,l);b=uqd(j,k)|0;xri(k);xri(l);if(b){b=a[j>>0]|0;if(!(b&1)){n=j+1|0;o=(b&255)>>>1}else{n=c[j+8>>2]|0;o=c[j+4>>2]|0}isd(m,n,o,10);o=c[m>>2]|0;n=m+4|0;if((o|0)==(c[n>>2]|0)){p=0;q=o}else{if(!(a[o>>0]&1))r=o+1|0;else r=c[o+8>>2]|0;a:do if((Hsd(r)|0)<=-1?(b=o+12|0,l=c[n>>2]|0,(b|0)!=(l|0)):0){if(!d)s=l;else{if(!(a[b>>0]&1))t=b+1|0;else t=c[o+20>>2]|0;c[d>>2]=Hsd(t)|0;s=c[n>>2]|0}b=o+24|0;if((b|0)!=(s|0))if(e){if(!(a[b>>0]&1))u=b+1|0;else u=c[o+32>>2]|0;b=Hsd(u)|0;l=e+4|0;k=c[l>>2]|0;v=c[e>>2]|0;w=(k-v|0)/12|0;if(b>>>0<=w>>>0){if(b>>>0<w>>>0?(x=v+(b*12|0)|0,(k|0)!=(x|0)):0){v=k;do{k=v+-12|0;c[l>>2]=k;xri(k);v=c[l>>2]|0}while((v|0)!=(x|0))}}else IPc(e,b-w|0);x=o+36|0;if((x|0)!=(c[n>>2]|0))if((b|0)>0){v=x;x=0;while(1){yri((c[e>>2]|0)+(x*12|0)|0,v)|0;v=v+12|0;l=x;x=x+1|0;if((v|0)==(c[n>>2]|0)){y=l;break}if((x|0)>=(b|0)){z=1;break a}}z=(y|0)==(b+-1|0)}else z=1;else z=0}else z=1;else z=0}else z=0;while(0);p=z;q=c[m>>2]|0}if(!q)A=p;else{while(1){z=c[n>>2]|0;if((z|0)==(q|0))break;y=z+-12|0;c[n>>2]=y;xri(y)}ACi(c[m>>2]|0);A=p}}else A=0;if(!(a[j>>0]&1)){i=f;return A|0}p=c[j+8>>2]|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(p,g);i=f;return A|0}function wPc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+112|0;f=e;g=e+72|0;h=e+84|0;j=e+96|0;k=e+32|0;l=e+20|0;m=e+44|0;rri(h,3653512,0);fsd(f,b+4|0,h);rPc(g,f,0);xri(f);xri(h);if(!(qqd(g)|0)){xri(g);i=e;return}if(d){d=pl(0)|0;c[b+16>>2]=(c[b+48>>2]|0)+d}d=c[b+56>>2]|0;if((d|0)==(b+60|0)){n=0;o=0}else{h=c[d+36>>2]|0;n=h;o=((h|0)<0)<<31>>31}h=c[b+16>>2]|0;b=f;c[b>>2]=h;c[b+4>>2]=((h|0)<0)<<31>>31;c[f+8>>2]=1;h=f+12|0;c[h>>2]=n;c[h+4>>2]=o;Lsd(j,602256,f);rri(l,602288,6);fsd(k,g,l);xri(l);Bqd(m);if(Gqd(m,k,1,3)|0){zqd(k,10,10)|0;l=a[j>>0]|0;if(!(l&1)){p=j+1|0;q=(l&255)>>>1}else{p=c[j+8>>2]|0;q=c[j+4>>2]|0}Iqd(m,p,q)|0;Dqd(m)|0}Cqd(m);xri(k);xri(j);xri(g);i=e;return}function xPc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+96|0;g=f+40|0;h=f+48|0;j=f+60|0;k=f+72|0;l=f+16|0;m=f;n=f+44|0;c[g>>2]=0;vPc(d,g,0)|0;o=c[g>>2]|0;if((o|0)>0?(p=pl(0)|0,(o|0)<(p-(c[b+48>>2]|0)|0)):0){wqd(d)|0;i=f;return}p=b+24|0;o=p;q=_Ei(c[o>>2]|0,c[o+4>>2]|0,e|0,((e|0)<0)<<31>>31|0)|0;o=p;c[o>>2]=q;c[o+4>>2]=H;ksd(h,d);o=Mri(h,64,-1)|0;if((o|0)==-1)r=0;else{vri(j,h,o+1|0,-1,h);if(!(a[j>>0]&1))s=j+1|0;else s=c[j+8>>2]|0;q=Hsd(s)|0;xri(j);vri(k,h,0,o,h);yri(h,k)|0;xri(k);r=q}sri(m,d);d=c[g>>2]|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;yri(l,m)|0;c[l+12>>2]=e;c[l+16>>2]=r;c[l+20>>2]=d;JPc(n,b+56|0,l);xri(l);xri(m);ig();xri(h);i=f;return}function yPc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;rri(g,3653512,0);fsd(e,b+4|0,g);rPc(f,e,0);xri(e);xri(g);g=h+4|0;c[g>>2]=0;c[h+8>>2]=0;e=h+4|0;c[h>>2]=e;a:do if(tqd(f,h)|0?(j=c[h>>2]|0,(j|0)!=(e|0)):0){k=b+52|0;l=j;while(1){if(a[k>>0]|0)break a;j=l+16|0;if(qqd(j)|0)xPc(b,j,pPc(j)|0);j=c[l+4>>2]|0;if(!j){m=l;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){o=n;break}else m=n}}else{m=j;while(1){n=c[m>>2]|0;if(!n){o=m;break}else m=n}}if((o|0)==(e|0))break;else l=o}}while(0);wPc(b,0);a[b+52>>0]=1;WN(h,c[g>>2]|0);xri(f);i=d;return 0}function zPc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;i=i+64|0;g=b+52|0;h=b+48|0;j=b+36|0;k=b+24|0;l=b+12|0;m=b;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;rri(l,602288,6);fsd(k,d,l);d=uqd(j,k)|0;xri(k);xri(l);if(d){d=a[j>>0]|0;if(!(d&1)){n=j+1|0;o=(d&255)>>>1}else{n=c[j+8>>2]|0;o=c[j+4>>2]|0}isd(m,n,o,10);o=c[m>>2]|0;n=m+4|0;d=c[n>>2]|0;if((o|0)==(d|0)){p=0;q=o}else{if(!e)r=d;else{if(!(a[o>>0]&1))s=o+1|0;else s=c[o+8>>2]|0;c[e>>2]=Hsd(s)|0;r=c[n>>2]|0}s=o+12|0;if((s|0)!=(r|0)){if(!(a[s>>0]&1))t=s+1|0;else t=c[o+20>>2]|0;if((Hsd(t)|0)>=1?(t=o+24|0,(t|0)!=(c[n>>2]|0)):0)if(!f)u=1;else{if(!(a[t>>0]&1))v=t+1|0;else v=c[o+32>>2]|0;c[f>>2]=Hsd(v)|0;u=1}else u=0}else u=1;p=u;q=c[m>>2]|0}if(!q)w=p;else{while(1){u=c[n>>2]|0;if((u|0)==(q|0))break;v=u+-12|0;c[n>>2]=v;xri(v)}ACi(c[m>>2]|0);w=p}}else w=0;if(!(a[j>>0]&1)){i=b;return w|0}p=c[j+8>>2]|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(p,g);i=b;return w|0}function APc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+28|0;f=d+16|0;g=d+4|0;h=d;j=a+4|0;yri(j,b)|0;rri(g,3653512,0);fsd(e,j,g);rPc(f,e,0);xri(e);xri(g);g=pl(0)|0;c[h>>2]=g;e=a+16|0;c[e>>2]=(c[a+48>>2]|0)+g;zPc(0,f,e,h)|0;yPc(a)|0;xri(f);i=d;return 1}function BPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;i=i+64|0;b=a+48|0;d=a+36|0;e=a+24|0;f=a+12|0;g=a;rri(d,627504,4);rPc(b,d,0);xri(d);if(!(qqd(b)|0)){xri(b);i=a;return}d=e+4|0;c[d>>2]=0;c[e+8>>2]=0;h=e+4|0;c[e>>2]=h;if(tqd(b,e)|0?(j=c[e>>2]|0,(j|0)!=(h|0)):0){k=j;while(1){j=k+16|0;rri(g,602248,6);fsd(f,j,g);xri(g);if(!(rqd(f)|0?Aqd(j)|0:0))wqd(j)|0;xri(f);j=c[k+4>>2]|0;if(!j){l=k;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=j;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}if((n|0)==(h|0))break;else k=n}}WN(e,c[d>>2]|0);xri(b);i=a;return}function CPc(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;DPc(b);c[b>>2]=0;rri(e,602240,6);if(!(qqd(e)|0)){rri(f,602240,6);yri(e,f)|0;xri(f)}c[b>>2]=1;EPc(b,e,-1,2147483647,0);BPc(0);a[b+8>>0]=1;xri(e);i=d;return}function DPc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[150570]|0;if(!e){f=xCi(4)|0;c[f>>2]=0;c[150570]=f;g=f}else g=e;FPc(g);g=b+4|0;b=c[g>>2]|0;if(!b){i=d;return}a[b+52>>0]=1;WN(b+68|0,c[b+72>>2]|0);KPc(b+56|0,c[b+60>>2]|0);xri(b+4|0);ACi(b);c[g>>2]=0;i=d;return}function EPc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;k=b+4|0;b=c[k>>2]|0;if(b){a[b+52>>0]=1;WN(b+68|0,c[b+72>>2]|0);KPc(b+56|0,c[b+60>>2]|0);xri(b+4|0);ACi(b)}b=xCi(80)|0;l=b+4|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;l=b+60|0;c[l>>2]=0;c[b+64>>2]=0;c[b+56>>2]=l;l=b+72|0;c[l>>2]=0;c[b+76>>2]=0;c[b+68>>2]=l;l=b+24|0;c[l>>2]=0;c[l+4>>2]=0;c[b+16>>2]=2147483647;a[b+52>>0]=0;a[b>>0]=1;c[b+48>>2]=1296e4;c[k>>2]=b;rPc(j,d,0);b=qqd(j)|0;xri(j);if(b)wPc(c[k>>2]|0,1);b=c[k>>2]|0;k=b+32|0;c[k>>2]=e;c[k+4>>2]=f;k=b+40|0;c[k>>2]=e;c[k+4>>2]=f;a[b>>0]=g&1;APc(b,d,0)|0;i=h;return}function FPc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[b>>2]|0;if(!e){i=d;return}f=c[e>>2]|0;if((f|0)!=(c[e+4>>2]|0)){g=e;h=f;while(1){j=c[h>>2]|0;if(!j)k=g;else{a[j+52>>0]=1;WN(j+68|0,c[j+72>>2]|0);KPc(j+56|0,c[j+60>>2]|0);xri(j+4|0);ACi(j);k=c[b>>2]|0}j=h+4|0;if((j|0)==(c[k+4>>2]|0)){l=k;m=j;break}else{g=k;h=j}}if(l){n=l;o=m;p=7}}else{n=e;o=f;p=7}if((p|0)==7){p=c[n>>2]|0;if(p){if((o|0)!=(p|0))c[n+4>>2]=o+(~((o+-4-p|0)>>>2)<<2);ACi(p)}ACi(n)}c[b>>2]=0;i=d;return}function GPc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+12|0;f=d;if(qqd(b)|0){g=1;i=d;return g|0}jsd(e,b);h=qqd(e)|0;xri(e);if(h){if(rqd(b)|0){g=0;i=d;return g|0}g=xqd(b)|0;i=d;return g|0}h=Mri(b,47,-1)|0;if((h|0)==-1){g=1;i=d;return g|0};c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;if(!(a[b>>0]&1)){j=b+1|0;k=b+1|0}else{e=c[b+8>>2]|0;j=e;k=e}e=k+h|0;h=e-j|0;if(h>>>0>10?(Iri(f,10,h+-10|0,0,0,0,0),(a[f>>0]&1)!=0):0)l=c[f+8>>2]|0;else l=f+1|0;if((j|0)==(e|0))m=l;else{k=j;j=l;while(1){a[j>>0]=a[k>>0]|0;k=k+1|0;l=j+1|0;if((k|0)==(e|0)){m=l;break}else j=l}}a[m>>0]=0;if(!(a[f>>0]&1))a[f>>0]=h<<1;else c[f+4>>2]=h;if(GPc(f)|0)n=GPc(b)|0;else n=0;xri(f);g=n;i=d;return g|0}function HPc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=b+4|0;h=b+4|0;LPc(f,b,d,c[g>>2]|0,h);j=c[f>>2]|0;if((j|0)==(h|0)){k=0;i=e;return k|0}h=j+16|0;f=a[d>>0]|0;l=(f&1)==0;if(l)m=(f&255)>>>1;else m=c[d+4>>2]|0;f=a[h>>0]|0;n=(f&1)==0;if(n)o=(f&255)>>>1;else o=c[j+20>>2]|0;if(l)p=d+1|0;else p=c[d+8>>2]|0;if(n)q=h+1|0;else q=c[j+24>>2]|0;n=FEi(p,q,o>>>0<m>>>0?o:m)|0;if(!n){if(m>>>0<o>>>0){k=0;i=e;return k|0}}else if((n|0)<0){k=0;i=e;return k|0}n=c[j+4>>2]|0;if(!n){o=j;while(1){m=c[o+8>>2]|0;if((c[m>>2]|0)==(o|0)){r=m;break}else o=m}}else{o=n;while(1){n=c[o>>2]|0;if(!n){r=o;break}else o=n}}if((c[b>>2]|0)==(j|0))c[b>>2]=r;r=b+8|0;c[r>>2]=(c[r>>2]|0)+-1;tYb(c[g>>2]|0,j);xri(h);ACi(j);k=1;i=e;return k|0}function IPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(((f-j|0)/12|0)>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;m=c[g>>2]|0}l=m+12|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=((j-k|0)/12|0)+b|0;if(l>>>0>357913941)vxi(a);j=k;k=(f-j|0)/12|0;if(k>>>0<178956970){f=k<<1;k=f>>>0<l>>>0?l:f;f=((c[g>>2]|0)-j|0)/12|0;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=357913941;r=((c[g>>2]|0)-j|0)/12|0;s=10}if((s|0)==10){n=q;o=xCi(q*12|0)|0;p=r}r=o+(p*12|0)|0;p=b;b=r;while(1){if(!b)t=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;t=b}q=t+12|0;p=p+-1|0;if(!p){u=q;break}else b=q}b=o+(n*12|0)|0;n=c[a>>2]|0;o=c[g>>2]|0;if((o|0)==(n|0)){v=r;w=n;x=n}else{p=o;o=r;while(1){r=o+-12|0;p=p+-12|0;sri(r,p);if((p|0)==(n|0)){y=r;break}else o=r}v=y;w=c[a>>2]|0;x=c[g>>2]|0}c[a>>2]=v;c[g>>2]=u;c[e>>2]=b;b=x;while(1){if((b|0)==(w|0))break;x=b+-12|0;xri(x);b=x}if(!w){i=d;return}ACi(w);i=d;return}function JPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+4|0;g=c[f>>2]|0;if(!g){h=b+4|0;j=h;k=h}else{h=c[d+20>>2]|0;l=g;while(1)if((h|0)<(c[l+36>>2]|0)){g=c[l>>2]|0;if(!g){j=l;k=l;break}else{l=g;continue}}else{g=l+4|0;m=c[g>>2]|0;if(!m){j=g;k=l;break}else{l=m;continue}}}l=xCi(40)|0;sri(l+16|0,d);h=l+28|0;m=d+12|0;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=k;c[j>>2]=l;k=c[c[b>>2]>>2]|0;if(!k)n=l;else{c[b>>2]=k;n=c[j>>2]|0}GN(c[f>>2]|0,n);n=b+8|0;c[n>>2]=(c[n>>2]|0)+1;c[a>>2]=l;i=e;return}function KPc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}KPc(a,c[b>>2]|0);KPc(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function LPc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=a[e>>0]|0;k=(j&1)==0;l=(j&255)>>>1;j=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(k){f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=o+1|0}else{q=c[f+20>>2]|0;r=c[f+24>>2]|0}o=FEi(r,j,l>>>0<q>>>0?l:q)|0;if(!o){if(q>>>0>=l>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}else{f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){u=(p&255)>>>1;v=o+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}o=FEi(v,m,n>>>0<u>>>0?n:u)|0;if(!o){if(u>>>0>=n>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}while(0);g=c[s>>2]|0;if(!g){h=s;t=19;break}else e=s}if((t|0)==19){c[b>>2]=h;i=d;return}}function MPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+12|0;g=c[f>>2]|0;pwc(g,c[g+4>>2]|0,c[g+8>>2]|0,3,0);if(!(swc(c[f>>2]|0,a)|0))Krd(602296,0,3653512,241,1,0,0,0);g=c[f>>2]|0;if(g){f=c[g+16>>2]|0;c[e>>2]=c[153068];c[d+0>>2]=c[e+0>>2];eOb(f,d);ACi(g)}if(!a){i=b;return 0}xri(a);ACi(a);i=b;return 0}function NPc(){var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=Im,ia=0,ja=0,ka=0,la=0,ma=Im,na=0,oa=0,pa=0,qa=0;b=i;i=i+176|0;d=b+32|0;e=b+40|0;f=b;h=b+20|0;j=b+16|0;k=b+28|0;l=b+160|0;m=b+56|0;n=b+120|0;o=b+132|0;p=b+136|0;q=b+156|0;r=b+24|0;if(!0){i=b;return}s=ync()|0;t=n8b()|0;u=ea(g[t+56>>2]);v=ea(g[t+60>>2]);w=ea(g[t+64>>2]);x=~~w;y=~~ea(g[t+68>>2]);z=xCi(20)|0;if(0<=1){mwc(z,x,y,4);A=z+16|0;if(Km[c[(c[s>>2]|0)+592>>2]&127](s,~~u,~~v,x,y,c[A>>2]|0)|0)B=z;else{C=c[A>>2]|0;c[e>>2]=c[153068];c[d+0>>2]=c[e+0>>2];eOb(C,d);ACi(z);B=0}}else{mwc(z,0,0,4);mwc(p,x,y,4);c[e>>2]=60;c[d+0>>2]=c[e+0>>2];eOb(0,d);C=t+4|0;A=c[t+8>>2]|0;if((A|0)==(C|0)){D=0;E=0;F=0}else{G=A;A=0;H=0;I=0;while(1){J=G+8|0;K=c[J>>2]|0;do if(!K){L=H;M=A;N=I}else{c[o>>2]=K;O=c[137784]|0;if(O){do if((c[O+36>>2]|0)!=(c[O+4>>2]|0)){fRb(d,O,o);P=c[d>>2]|0;Q=c[O+28>>2]|0;if((P|0)==-1){R=Q+(c[O+32>>2]<<3)|0;break}else{R=Q+(P<<3)|0;break}}else R=(c[O+28>>2]|0)+(c[O+32>>2]<<3)|0;while(0);O=c[137784]|0;if((R|0)!=((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)?(O=c[R+4>>2]|0,(O|0)!=0):0)S=O;else T=14}else T=14;if((T|0)==14){T=0;O=hQb(c[J>>2]|0)|0;if(!O){L=H;M=A;N=I;break}else S=O}O=c[S+4>>2]|0;P=S+396|0;c[f+0>>2]=c[P+0>>2];c[f+4>>2]=c[P+4>>2];c[f+8>>2]=c[P+8>>2];c[f+12>>2]=c[P+12>>2];P=A+1|0;Q=H&2147483647;do if(P>>>0>Q>>>0?(U=H<<1,V=(U|0)==0?1:U,Q>>>0<V>>>0):0)if((H|0)>-1){c[e>>2]=60;c[d+0>>2]=c[e+0>>2];W=V;X=hOb(I,V*20|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=60;c[d+0>>2]=c[e+0>>2];U=cOb(V*20|0,4,d,0,3653512,352)|0;YEi(U|0,I|0,P*20|0)|0;W=V;X=U;break}else{W=H;X=I}while(0);c[X+(A*20|0)>>2]=O;Q=X+(A*20|0)+4|0;c[Q+0>>2]=c[f+0>>2];c[Q+4>>2]=c[f+4>>2];c[Q+8>>2]=c[f+8>>2];c[Q+12>>2]=c[f+12>>2];L=W;M=P;N=X}while(0);G=c[G+4>>2]|0;if((G|0)==(C|0)){D=M;E=N;F=L;break}else{A=M;H=L;I=N}}}w=Im;Y=ea(ea(-1.0)-ea(bEi(w)));c[n>>2]=0;N=n+4|0;c[N>>2]=0;c[n+8>>2]=0;CQb(27,n,0)|0;c[e>>2]=60;c[d+0>>2]=c[e+0>>2];eOb(0,d);I=(c[N>>2]|0)-(c[n>>2]|0)|0;L=I>>2;if(!L){Z=0;_=0}else{c[e>>2]=60;c[d+0>>2]=c[e+0>>2];Z=L;_=hOb(0,I<<1,4,d,0,3653512,370)|0}aGc(q,r);$Fc(16,16);I=c[N>>2]|0;L=c[n>>2]|0;if((I|0)==(L|0)){$=I;aa=I;ba=0;ca=_;fa=Z}else{I=L;L=0;H=Z;Z=_;while(1){_=c[I+(L<<2)>>2]|0;if(!_)ga=0;else ga=c[_+4>>2]|0;M=_+36|0;ha=ea(g[M>>2]);A=L+1|0;C=H&2147483647;do if(A>>>0>C>>>0?(G=H<<1,X=(G|0)==0?1:G,C>>>0<X>>>0):0)if((H|0)>-1){c[e>>2]=60;c[d+0>>2]=c[e+0>>2];ia=hOb(Z,X<<3,4,d,0,3653512,370)|0;ja=X;break}else{c[e>>2]=60;c[d+0>>2]=c[e+0>>2];G=cOb(X<<3,4,d,0,3653512,352)|0;YEi(G|0,Z|0,A<<3|0)|0;ia=G;ja=X;break}else{ia=Z;ja=H}while(0);c[ia+(L<<3)>>2]=ga;g[ia+(L<<3)+4>>2]=ha;if(mo[c[(c[_>>2]|0)+124>>2]&4095](_)|0?(mo[c[(c[_>>2]|0)+92>>2]&4095](_)|0)==2:0)g[M>>2]=ea(Y+ea(g[M>>2]));ko[c[(c[_>>2]|0)+132>>2]&4095](_);C=c[N>>2]|0;X=c[n>>2]|0;if(A>>>0<C-X>>2>>>0){I=X;L=A;H=ja;Z=ia}else{$=X;aa=C;ba=A;ca=ia;fa=ja;break}}}if($){if((aa|0)!=($|0))c[N>>2]=aa+(~((aa+-4-$|0)>>>2)<<2);ACi($)}if(0>0){$=(D|0)==0;aa=~~u;N=~~v;ja=p+16|0;ia=p+4|0;Z=p+8|0;H=z+16|0;L=e+8|0;I=e+12|0;n=m+32|0;ga=m+36|0;C=m+48|0;X=m+52|0;G=E+(D*20|0)|0;W=0;do{v=ea(ea(ea(W|0)/w)+ea(-.5));S=0;do{if(!$){u=ea(ea(ea(S|0)/w)+ea(-.5));R=E;do{o=c[R>>2]|0;do if(o){c[l>>2]=o;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(d,J,l);K=c[d>>2]|0;Q=c[J+28>>2]|0;if((K|0)==-1){ka=Q+(c[J+32>>2]<<3)|0;break}else{ka=Q+(K<<3)|0;break}}else ka=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((ka|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[ka+4>>2]|0,(J|0)!=0):0)la=J;else T=55}else T=55;if((T|0)==55){T=0;J=hQb(c[R>>2]|0)|0;if(!J)break;else la=J}a[la+613>>0]=1;a[la+609>>0]=1;a[la+610>>0]=1;a[la+614>>0]=1;a[la+611>>0]=1;u$b(e,la,1);Y=ea(u/ea(ea(g[L>>2])*ea(.5)));ma=ea(v/ea(ea(g[I>>2])*ea(.5)));J=m+0|0;K=(C$b(la)|0)+0|0;Q=J+64|0;do{c[J>>2]=c[K>>2];J=J+4|0;K=K+4|0}while((J|0)<(Q|0));if(!(a[la+616>>0]|0)){g[n>>2]=ea(Y+ea(g[n>>2]));g[ga>>2]=ea(ma+ea(g[ga>>2]))}else{g[C>>2]=ea(ea(g[C>>2])-Y);g[X>>2]=ea(ea(g[X>>2])-ma)}l0b(la,m)}while(0);R=R+20|0}while((R|0)!=(G|0))}f8b(t,0);_Hc(XHc()|0);if(c[141980]|0)$ke();Km[c[(c[s>>2]|0)+592>>2]&127](s,aa,N,x,y,c[ja>>2]|0)|0;R=c[ia>>2]|0;P=c[Z>>2]|0;O=0;if((P|0)>0?(o=0,(R|0)>0):0){K=(c[H>>2]|0)+((da(O,W)|0)+S<<2)|0;O=c[ja>>2]|0;J=0;while(1){Q=0;do{c[K+(0<<2)>>2]=c[O+(Q<<2)>>2];Q=Q+1|0}while((Q|0)!=(R|0));J=J+1|0;if((J|0)==(P|0))break;else{K=K+(o<<2)|0;O=O+(R<<2)|0}}}S=S+1|0}while((S|0)<0);W=W+1|0}while((W|0)<0)}$Fc(c[q>>2]|0,c[r>>2]|0);if(ba){r=ca+(ba<<3)|0;ba=ca;do{q=c[ba>>2]|0;do if(q){c[k>>2]=q;W=c[137784]|0;if(W){do if((c[W+36>>2]|0)!=(c[W+4>>2]|0)){fRb(d,W,k);ja=c[d>>2]|0;H=c[W+28>>2]|0;if((ja|0)==-1){na=H+(c[W+32>>2]<<3)|0;break}else{na=H+(ja<<3)|0;break}}else na=(c[W+28>>2]|0)+(c[W+32>>2]<<3)|0;while(0);W=c[137784]|0;if((na|0)!=((c[W+28>>2]|0)+(c[W+32>>2]<<3)|0)?(W=c[na+4>>2]|0,(W|0)!=0):0)oa=W;else T=82}else T=82;if((T|0)==82){T=0;W=hQb(c[ba>>2]|0)|0;if(!W)break;else oa=W}g[oa+36>>2]=ea(g[ba+4>>2]);ko[c[(c[oa>>2]|0)+132>>2]&4095](oa)}while(0);ba=ba+8|0}while((ba|0)!=(r|0))}if(D){r=E+(D*20|0)|0;D=E;do{ba=c[D>>2]|0;do if(ba){c[j>>2]=ba;oa=c[137784]|0;if(oa){do if((c[oa+36>>2]|0)!=(c[oa+4>>2]|0)){fRb(d,oa,j);na=c[d>>2]|0;k=c[oa+28>>2]|0;if((na|0)==-1){pa=k+(c[oa+32>>2]<<3)|0;break}else{pa=k+(na<<3)|0;break}}else pa=(c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0;while(0);oa=c[137784]|0;if((pa|0)!=((c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0)?(oa=c[pa+4>>2]|0,(oa|0)!=0):0)qa=oa;else T=96}else T=96;if((T|0)==96){T=0;oa=hQb(c[D>>2]|0)|0;if(!oa)break;else qa=oa}w$b(qa,D+4|0);a[qa+613>>0]=1;a[qa+609>>0]=1;a[qa+610>>0]=1;a[qa+614>>0]=1;a[qa+611>>0]=1}while(0);D=D+20|0}while((D|0)!=(r|0))}if((fa|0)>-1){c[h>>2]=60;c[d+0>>2]=c[h+0>>2];eOb(ca,d)}if((F|0)>-1){c[f>>2]=60;c[d+0>>2]=c[f+0>>2];eOb(E,d)}E=c[p+16>>2]|0;c[e>>2]=c[153068];c[d+0>>2]=c[e+0>>2];eOb(E,d);B=z}if(!B)Krd(602328,0,3653512,514,1,0,0,0);else{z=xCi(16)|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;zri(z,0)|0;c[z+12>>2]=B;MPc(z)|0}BDi(0);i=b;return}function OPc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;i=i+32|0;b=a+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;c[d>>2]=c[153108];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,26)|0;h=d+4|0;c[h>>2]=0;c[d+8>>2]=0;c[d>>2]=h;c[150590]=d;c[e>>2]=c[153108];c[b+0>>2]=c[e+0>>2];e=bOb(12,b,0,16,3653512,27)|0;d=e+4|0;c[d>>2]=0;c[e+8>>2]=0;c[e>>2]=d;c[150592]=e;c[f>>2]=c[153108];c[b+0>>2]=c[f+0>>2];f=bOb(12,b,0,16,3653512,28)|0;e=f+4|0;c[e>>2]=0;c[f+8>>2]=0;c[f>>2]=e;c[150594]=f;c[g>>2]=c[153108];c[b+0>>2]=c[g+0>>2];g=bOb(12,b,0,16,3653512,29)|0;b=g+4|0;c[b>>2]=0;c[g+8>>2]=0;c[g>>2]=b;c[150596]=g;i=a;return}function PPc(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[150590]|0;f=c[153108]|0;if(e)WPc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[150590]=0;e=c[150592]|0;f=c[153108]|0;if(e)WPc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[150592]=0;e=c[150594]|0;f=c[153108]|0;if(e)nOc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[150594]=0;e=c[150596]|0;f=c[153108]|0;if(!e){c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[150596]=0;i=a;return}nOc(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[150596]=0;i=a;return}function QPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;RPc();e=c[150590]|0;f=e+4|0;g=c[f>>2]|0;do if(g){h=g;while(1){j=c[h+16>>2]|0;if((j|0)>(a|0)){k=c[h>>2]|0;if(!k){l=h;m=h;n=4;break}else{h=k;continue}}if((j|0)>=(a|0)){o=h;n=8;break}j=h+4|0;k=c[j>>2]|0;if(!k){p=j;q=h;n=7;break}else h=k}if((n|0)==4){c[d>>2]=m;r=l;s=m;break}else if((n|0)==7){c[d>>2]=q;r=p;s=q;break}else if((n|0)==8){c[d>>2]=o;r=d;s=o;break}}else{h=e+4|0;c[d>>2]=h;r=h;s=h}while(0);d=c[r>>2]|0;if(d){t=d;u=t+20|0;i=b;return u|0}d=xCi(32)|0;c[d+16>>2]=a;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=s;c[r>>2]=d;s=c[c[e>>2]>>2]|0;if(!s)v=d;else{c[e>>2]=s;v=c[r>>2]|0}GN(c[f>>2]|0,v);v=e+8|0;c[v>>2]=(c[v>>2]|0)+1;t=d;u=t+20|0;i=b;return u|0}function RPc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+12|0;h=b;if(a[602392]|0){i=b;return}a[602392]=1;j=c[150590]|0;WPc(j,c[j+4>>2]|0);c[j+8>>2]=0;k=j+4|0;c[j>>2]=k;c[k>>2]=0;k=c[150592]|0;WPc(k,c[k+4>>2]|0);c[k+8>>2]=0;j=k+4|0;c[k>>2]=j;c[j>>2]=0;j=c[150594]|0;nOc(j,c[j+4>>2]|0);c[j+8>>2]=0;k=j+4|0;c[j>>2]=k;c[k>>2]=0;c[g>>2]=0;k=g+4|0;c[k>>2]=0;c[g+8>>2]=0;AQb(FQb(2459184)|0,g,1);j=c[g>>2]|0;l=c[k>>2]|0;m=h+4|0;c[m>>2]=0;n=h+8|0;c[n>>2]=0;o=h+4|0;c[h>>2]=o;if((j|0)!=(l|0)){p=j;do{c[f>>2]=o;c[d+0>>2]=c[f+0>>2];j=XPc(h,d,e,p)|0;if(!(c[j>>2]|0)){q=xCi(20)|0;c[q+16>>2]=c[p>>2];r=c[e>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=r;c[j>>2]=q;r=c[c[h>>2]>>2]|0;if(!r)s=q;else{c[h>>2]=r;s=c[j>>2]|0}GN(c[m>>2]|0,s);c[n>>2]=(c[n>>2]|0)+1}p=p+4|0}while((p|0)!=(l|0))}UPc(25,4);UPc(33,4);UPc(12,4);UPc(15,4);UPc(76,4);UPc(198,4);UPc(199,4);UPc(20,4);UPc(108,4);VPc(33,102);VPc(102,33);UPc(212,4);VPc(33,212);VPc(23,212);VPc(212,33);VPc(212,23);UPc(54,4);VPc(54,50);VPc(54,53);VPc(54,230);VPc(56,50);VPc(56,53);VPc(56,230);VPc(57,50);VPc(57,53);VPc(57,230);VPc(75,50);VPc(75,53);VPc(75,230);UPc(50,4);UPc(53,4);UPc(230,4);l=c[150594]|0;p=l+4|0;n=c[p>>2]|0;do if(n){s=n;while(1){e=c[s+16>>2]|0;if((e|0)>231){f=c[s>>2]|0;if(!f){t=s;u=s;v=12;break}else{s=f;continue}}if((e|0)>=231){w=s;v=16;break}e=s+4|0;f=c[e>>2]|0;if(!f){x=e;y=s;v=15;break}else s=f}if((v|0)==12){c[d>>2]=u;z=t;A=u;break}else if((v|0)==15){c[d>>2]=y;z=x;A=y;break}else if((v|0)==16){c[d>>2]=w;z=d;A=w;break}}else{s=l+4|0;c[d>>2]=s;z=s;A=s}while(0);if(!(c[z>>2]|0)){w=xCi(20)|0;c[w+16>>2]=231;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=A;c[z>>2]=w;A=c[c[l>>2]>>2]|0;if(!A)B=w;else{c[l>>2]=A;B=c[z>>2]|0}GN(c[p>>2]|0,B);B=l+8|0;c[B>>2]=(c[B>>2]|0)+1;B=c[150594]|0;C=B;D=c[B+4>>2]|0}else{C=l;D=n}n=C+4|0;do if(D){l=D;while(1){B=c[l+16>>2]|0;if((B|0)>232){p=c[l>>2]|0;if(!p){E=l;F=l;v=25;break}else{l=p;continue}}if((B|0)>=232){G=l;v=29;break}B=l+4|0;p=c[B>>2]|0;if(!p){H=B;I=l;v=28;break}else l=p}if((v|0)==25){c[d>>2]=F;J=E;K=F;break}else if((v|0)==28){c[d>>2]=I;J=H;K=I;break}else if((v|0)==29){c[d>>2]=G;J=d;K=G;break}}else{l=C+4|0;c[d>>2]=l;J=l;K=l}while(0);if(!(c[J>>2]|0)){G=xCi(20)|0;c[G+16>>2]=232;c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=K;c[J>>2]=G;K=c[c[C>>2]>>2]|0;if(!K)L=G;else{c[C>>2]=K;L=c[J>>2]|0}GN(c[n>>2]|0,L);L=C+8|0;c[L>>2]=(c[L>>2]|0)+1;M=c[150594]|0}else M=C;C=M+4|0;L=c[C>>2]|0;do if(L){n=L;while(1){J=c[n+16>>2]|0;if((J|0)>233){K=c[n>>2]|0;if(!K){N=n;O=n;v=38;break}else{n=K;continue}}if((J|0)>=233){P=n;v=42;break}J=n+4|0;K=c[J>>2]|0;if(!K){Q=J;R=n;v=41;break}else n=K}if((v|0)==38){c[d>>2]=O;S=N;T=O;break}else if((v|0)==41){c[d>>2]=R;S=Q;T=R;break}else if((v|0)==42){c[d>>2]=P;S=d;T=P;break}}else{n=M+4|0;c[d>>2]=n;S=n;T=n}while(0);if(!(c[S>>2]|0)){P=xCi(20)|0;c[P+16>>2]=233;c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=T;c[S>>2]=P;T=c[c[M>>2]>>2]|0;if(!T)U=P;else{c[M>>2]=T;U=c[S>>2]|0}GN(c[C>>2]|0,U);U=M+8|0;c[U>>2]=(c[U>>2]|0)+1;V=c[150594]|0}else V=M;M=V+4|0;U=c[M>>2]|0;do if(U){C=U;while(1){S=c[C+16>>2]|0;if((S|0)>234){T=c[C>>2]|0;if(!T){W=C;X=C;v=51;break}else{C=T;continue}}if((S|0)>=234){Y=C;v=55;break}S=C+4|0;T=c[S>>2]|0;if(!T){Z=S;_=C;v=54;break}else C=T}if((v|0)==51){c[d>>2]=X;$=W;aa=X;break}else if((v|0)==54){c[d>>2]=_;$=Z;aa=_;break}else if((v|0)==55){c[d>>2]=Y;$=d;aa=Y;break}}else{C=V+4|0;c[d>>2]=C;$=C;aa=C}while(0);if(!(c[$>>2]|0)){Y=xCi(20)|0;c[Y+16>>2]=234;c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=aa;c[$>>2]=Y;aa=c[c[V>>2]>>2]|0;if(!aa)ba=Y;else{c[V>>2]=aa;ba=c[$>>2]|0}GN(c[M>>2]|0,ba);ba=V+8|0;c[ba>>2]=(c[ba>>2]|0)+1;ca=c[150594]|0}else ca=V;V=ca+4|0;ba=c[V>>2]|0;do if(ba){M=ba;while(1){$=c[M+16>>2]|0;if(($|0)>235){aa=c[M>>2]|0;if(!aa){da=M;ea=M;v=64;break}else{M=aa;continue}}if(($|0)>=235){fa=M;v=68;break}$=M+4|0;aa=c[$>>2]|0;if(!aa){ga=$;ha=M;v=67;break}else M=aa}if((v|0)==64){c[d>>2]=ea;ia=da;ja=ea;break}else if((v|0)==67){c[d>>2]=ha;ia=ga;ja=ha;break}else if((v|0)==68){c[d>>2]=fa;ia=d;ja=fa;break}}else{M=ca+4|0;c[d>>2]=M;ia=M;ja=M}while(0);if(!(c[ia>>2]|0)){fa=xCi(20)|0;c[fa+16>>2]=235;c[fa>>2]=0;c[fa+4>>2]=0;c[fa+8>>2]=ja;c[ia>>2]=fa;ja=c[c[ca>>2]>>2]|0;if(!ja)ka=fa;else{c[ca>>2]=ja;ka=c[ia>>2]|0}GN(c[V>>2]|0,ka);ka=ca+8|0;c[ka>>2]=(c[ka>>2]|0)+1;la=c[150594]|0}else la=ca;ca=la+4|0;ka=c[ca>>2]|0;do if(ka){V=ka;while(1){ia=c[V+16>>2]|0;if((ia|0)>247){ja=c[V>>2]|0;if(!ja){ma=V;na=V;v=77;break}else{V=ja;continue}}if((ia|0)>=247){oa=V;v=81;break}ia=V+4|0;ja=c[ia>>2]|0;if(!ja){pa=ia;qa=V;v=80;break}else V=ja}if((v|0)==77){c[d>>2]=na;ra=ma;sa=na;break}else if((v|0)==80){c[d>>2]=qa;ra=pa;sa=qa;break}else if((v|0)==81){c[d>>2]=oa;ra=d;sa=oa;break}}else{V=la+4|0;c[d>>2]=V;ra=V;sa=V}while(0);if(!(c[ra>>2]|0)){oa=xCi(20)|0;c[oa+16>>2]=247;c[oa>>2]=0;c[oa+4>>2]=0;c[oa+8>>2]=sa;c[ra>>2]=oa;sa=c[c[la>>2]>>2]|0;if(!sa)ta=oa;else{c[la>>2]=sa;ta=c[ra>>2]|0}GN(c[ca>>2]|0,ta);ta=la+8|0;c[ta>>2]=(c[ta>>2]|0)+1}UPc(230,50);UPc(247,50);VPc(50,54);VPc(50,56);VPc(50,57);VPc(50,75);VPc(53,54);VPc(53,56);VPc(53,57);VPc(53,75);VPc(230,54);VPc(230,56);VPc(230,57);VPc(230,75);VPc(246,54);VPc(246,56);VPc(246,57);VPc(248,54);VPc(248,56);VPc(248,248);UPc(133,4);UPc(82,4);UPc(81,4);UPc(167,4);UPc(169,180);UPc(168,180);UPc(170,180);UPc(164,180);UPc(165,180);UPc(166,180);UPc(102,4);UPc(102,23);UPc(56,4);UPc(57,54);UPc(75,54);UPc(124,20);UPc(92,20);UPc(122,4);UPc(223,224);UPc(183,4);UPc(183,137);ta=c[150594]|0;la=ta+4|0;ca=c[la>>2]|0;do if(ca){ra=ca;while(1){sa=c[ra+16>>2]|0;if((sa|0)>59){oa=c[ra>>2]|0;if(!oa){ua=ra;va=ra;v=90;break}else{ra=oa;continue}}if((sa|0)>=59){wa=ra;v=94;break}sa=ra+4|0;oa=c[sa>>2]|0;if(!oa){xa=sa;ya=ra;v=93;break}else ra=oa}if((v|0)==90){c[d>>2]=va;za=ua;Aa=va;break}else if((v|0)==93){c[d>>2]=ya;za=xa;Aa=ya;break}else if((v|0)==94){c[d>>2]=wa;za=d;Aa=wa;break}}else{ra=ta+4|0;c[d>>2]=ra;za=ra;Aa=ra}while(0);if(!(c[za>>2]|0)){wa=xCi(20)|0;c[wa+16>>2]=59;c[wa>>2]=0;c[wa+4>>2]=0;c[wa+8>>2]=Aa;c[za>>2]=wa;Aa=c[c[ta>>2]>>2]|0;if(!Aa)Ba=wa;else{c[ta>>2]=Aa;Ba=c[za>>2]|0}GN(c[la>>2]|0,Ba);Ba=ta+8|0;c[Ba>>2]=(c[Ba>>2]|0)+1;Ba=c[150594]|0;Ca=Ba;Da=c[Ba+4>>2]|0}else{Ca=ta;Da=ca}ca=Ca+4|0;do if(Da){ta=Da;while(1){Ba=c[ta+16>>2]|0;if((Ba|0)>138){la=c[ta>>2]|0;if(!la){Ea=ta;Fa=ta;v=103;break}else{ta=la;continue}}if((Ba|0)>=138){Ga=ta;v=107;break}Ba=ta+4|0;la=c[Ba>>2]|0;if(!la){Ha=Ba;Ia=ta;v=106;break}else ta=la}if((v|0)==103){c[d>>2]=Fa;Ja=Ea;Ka=Fa;break}else if((v|0)==106){c[d>>2]=Ia;Ja=Ha;Ka=Ia;break}else if((v|0)==107){c[d>>2]=Ga;Ja=d;Ka=Ga;break}}else{ta=Ca+4|0;c[d>>2]=ta;Ja=ta;Ka=ta}while(0);if(!(c[Ja>>2]|0)){Ga=xCi(20)|0;c[Ga+16>>2]=138;c[Ga>>2]=0;c[Ga+4>>2]=0;c[Ga+8>>2]=Ka;c[Ja>>2]=Ga;Ka=c[c[Ca>>2]>>2]|0;if(!Ka)La=Ga;else{c[Ca>>2]=Ka;La=c[Ja>>2]|0}GN(c[ca>>2]|0,La);La=Ca+8|0;c[La>>2]=(c[La>>2]|0)+1;Ma=c[150594]|0}else Ma=Ca;Ca=Ma+4|0;La=c[Ca>>2]|0;do if(La){ca=La;while(1){Ja=c[ca+16>>2]|0;if((Ja|0)>144){Ka=c[ca>>2]|0;if(!Ka){Na=ca;Oa=ca;v=116;break}else{ca=Ka;continue}}if((Ja|0)>=144){Pa=ca;v=120;break}Ja=ca+4|0;Ka=c[Ja>>2]|0;if(!Ka){Qa=Ja;Ra=ca;v=119;break}else ca=Ka}if((v|0)==116){c[d>>2]=Oa;Sa=Na;Ta=Oa;break}else if((v|0)==119){c[d>>2]=Ra;Sa=Qa;Ta=Ra;break}else if((v|0)==120){c[d>>2]=Pa;Sa=d;Ta=Pa;break}}else{ca=Ma+4|0;c[d>>2]=ca;Sa=ca;Ta=ca}while(0);if(!(c[Sa>>2]|0)){Pa=xCi(20)|0;c[Pa+16>>2]=144;c[Pa>>2]=0;c[Pa+4>>2]=0;c[Pa+8>>2]=Ta;c[Sa>>2]=Pa;Ta=c[c[Ma>>2]>>2]|0;if(!Ta)Ua=Pa;else{c[Ma>>2]=Ta;Ua=c[Sa>>2]|0}GN(c[Ca>>2]|0,Ua);Ua=Ma+8|0;c[Ua>>2]=(c[Ua>>2]|0)+1;Va=c[150594]|0}else Va=Ma;Ma=Va+4|0;Ua=c[Ma>>2]|0;do if(Ua){Ca=Ua;while(1){Sa=c[Ca+16>>2]|0;if((Sa|0)>153){Ta=c[Ca>>2]|0;if(!Ta){Wa=Ca;Xa=Ca;v=129;break}else{Ca=Ta;continue}}if((Sa|0)>=153){Ya=Ca;v=133;break}Sa=Ca+4|0;Ta=c[Sa>>2]|0;if(!Ta){Za=Sa;_a=Ca;v=132;break}else Ca=Ta}if((v|0)==129){c[d>>2]=Xa;$a=Wa;ab=Xa;break}else if((v|0)==132){c[d>>2]=_a;$a=Za;ab=_a;break}else if((v|0)==133){c[d>>2]=Ya;$a=d;ab=Ya;break}}else{Ca=Va+4|0;c[d>>2]=Ca;$a=Ca;ab=Ca}while(0);if(!(c[$a>>2]|0)){Ya=xCi(20)|0;c[Ya+16>>2]=153;c[Ya>>2]=0;c[Ya+4>>2]=0;c[Ya+8>>2]=ab;c[$a>>2]=Ya;ab=c[c[Va>>2]>>2]|0;if(!ab)bb=Ya;else{c[Va>>2]=ab;bb=c[$a>>2]|0}GN(c[Ma>>2]|0,bb);bb=Va+8|0;c[bb>>2]=(c[bb>>2]|0)+1;cb=c[150594]|0}else cb=Va;Va=cb+4|0;bb=c[Va>>2]|0;do if(bb){Ma=bb;while(1){$a=c[Ma+16>>2]|0;if(($a|0)>145){ab=c[Ma>>2]|0;if(!ab){db=Ma;eb=Ma;v=142;break}else{Ma=ab;continue}}if(($a|0)>=145){fb=Ma;v=146;break}$a=Ma+4|0;ab=c[$a>>2]|0;if(!ab){gb=$a;hb=Ma;v=145;break}else Ma=ab}if((v|0)==142){c[d>>2]=eb;ib=db;jb=eb;break}else if((v|0)==145){c[d>>2]=hb;ib=gb;jb=hb;break}else if((v|0)==146){c[d>>2]=fb;ib=d;jb=fb;break}}else{Ma=cb+4|0;c[d>>2]=Ma;ib=Ma;jb=Ma}while(0);if(!(c[ib>>2]|0)){fb=xCi(20)|0;c[fb+16>>2]=145;c[fb>>2]=0;c[fb+4>>2]=0;c[fb+8>>2]=jb;c[ib>>2]=fb;jb=c[c[cb>>2]>>2]|0;if(!jb)kb=fb;else{c[cb>>2]=jb;kb=c[ib>>2]|0}GN(c[Va>>2]|0,kb);kb=cb+8|0;c[kb>>2]=(c[kb>>2]|0)+1;lb=c[150594]|0}else lb=cb;cb=lb+4|0;kb=c[cb>>2]|0;do if(kb){Va=kb;while(1){ib=c[Va+16>>2]|0;if((ib|0)>82){jb=c[Va>>2]|0;if(!jb){mb=Va;nb=Va;v=155;break}else{Va=jb;continue}}if((ib|0)>=82){ob=Va;v=159;break}ib=Va+4|0;jb=c[ib>>2]|0;if(!jb){pb=ib;qb=Va;v=158;break}else Va=jb}if((v|0)==155){c[d>>2]=nb;rb=mb;sb=nb;break}else if((v|0)==158){c[d>>2]=qb;rb=pb;sb=qb;break}else if((v|0)==159){c[d>>2]=ob;rb=d;sb=ob;break}}else{Va=lb+4|0;c[d>>2]=Va;rb=Va;sb=Va}while(0);if(!(c[rb>>2]|0)){ob=xCi(20)|0;c[ob+16>>2]=82;c[ob>>2]=0;c[ob+4>>2]=0;c[ob+8>>2]=sb;c[rb>>2]=ob;sb=c[c[lb>>2]>>2]|0;if(!sb)tb=ob;else{c[lb>>2]=sb;tb=c[rb>>2]|0}GN(c[cb>>2]|0,tb);tb=lb+8|0;c[tb>>2]=(c[tb>>2]|0)+1;ub=c[150594]|0}else ub=lb;lb=ub+4|0;tb=c[lb>>2]|0;do if(tb){cb=tb;while(1){rb=c[cb+16>>2]|0;if((rb|0)>191){sb=c[cb>>2]|0;if(!sb){vb=cb;wb=cb;v=168;break}else{cb=sb;continue}}if((rb|0)>=191){xb=cb;v=172;break}rb=cb+4|0;sb=c[rb>>2]|0;if(!sb){yb=rb;zb=cb;v=171;break}else cb=sb}if((v|0)==168){c[d>>2]=wb;Ab=vb;Bb=wb;break}else if((v|0)==171){c[d>>2]=zb;Ab=yb;Bb=zb;break}else if((v|0)==172){c[d>>2]=xb;Ab=d;Bb=xb;break}}else{cb=ub+4|0;c[d>>2]=cb;Ab=cb;Bb=cb}while(0);if(!(c[Ab>>2]|0)){xb=xCi(20)|0;c[xb+16>>2]=191;c[xb>>2]=0;c[xb+4>>2]=0;c[xb+8>>2]=Bb;c[Ab>>2]=xb;Bb=c[c[ub>>2]>>2]|0;if(!Bb)Cb=xb;else{c[ub>>2]=Bb;Cb=c[Ab>>2]|0}GN(c[lb>>2]|0,Cb);Cb=ub+8|0;c[Cb>>2]=(c[Cb>>2]|0)+1;Db=c[150594]|0}else Db=ub;ub=Db+4|0;Cb=c[ub>>2]|0;do if(Cb){lb=Cb;while(1){Ab=c[lb+16>>2]|0;if((Ab|0)>45){Bb=c[lb>>2]|0;if(!Bb){Eb=lb;Fb=lb;v=181;break}else{lb=Bb;continue}}if((Ab|0)>=45){Gb=lb;v=185;break}Ab=lb+4|0;Bb=c[Ab>>2]|0;if(!Bb){Hb=Ab;Ib=lb;v=184;break}else lb=Bb}if((v|0)==181){c[d>>2]=Fb;Jb=Eb;Kb=Fb;break}else if((v|0)==184){c[d>>2]=Ib;Jb=Hb;Kb=Ib;break}else if((v|0)==185){c[d>>2]=Gb;Jb=d;Kb=Gb;break}}else{lb=Db+4|0;c[d>>2]=lb;Jb=lb;Kb=lb}while(0);if(!(c[Jb>>2]|0)){Gb=xCi(20)|0;c[Gb+16>>2]=45;c[Gb>>2]=0;c[Gb+4>>2]=0;c[Gb+8>>2]=Kb;c[Jb>>2]=Gb;Kb=c[c[Db>>2]>>2]|0;if(!Kb)Lb=Gb;else{c[Db>>2]=Kb;Lb=c[Jb>>2]|0}GN(c[ub>>2]|0,Lb);Lb=Db+8|0;c[Lb>>2]=(c[Lb>>2]|0)+1;Mb=c[150594]|0}else Mb=Db;Db=Mb+4|0;Lb=c[Db>>2]|0;do if(Lb){ub=Lb;while(1){Jb=c[ub+16>>2]|0;if((Jb|0)>114){Kb=c[ub>>2]|0;if(!Kb){Nb=ub;Ob=ub;v=194;break}else{ub=Kb;continue}}if((Jb|0)>=114){Pb=ub;v=198;break}Jb=ub+4|0;Kb=c[Jb>>2]|0;if(!Kb){Qb=Jb;Rb=ub;v=197;break}else ub=Kb}if((v|0)==194){c[d>>2]=Ob;Sb=Nb;Tb=Ob;break}else if((v|0)==197){c[d>>2]=Rb;Sb=Qb;Tb=Rb;break}else if((v|0)==198){c[d>>2]=Pb;Sb=d;Tb=Pb;break}}else{ub=Mb+4|0;c[d>>2]=ub;Sb=ub;Tb=ub}while(0);if(!(c[Sb>>2]|0)){Pb=xCi(20)|0;c[Pb+16>>2]=114;c[Pb>>2]=0;c[Pb+4>>2]=0;c[Pb+8>>2]=Tb;c[Sb>>2]=Pb;Tb=c[c[Mb>>2]>>2]|0;if(!Tb)Ub=Pb;else{c[Mb>>2]=Tb;Ub=c[Sb>>2]|0}GN(c[Db>>2]|0,Ub);Ub=Mb+8|0;c[Ub>>2]=(c[Ub>>2]|0)+1;Vb=c[150594]|0}else Vb=Mb;Mb=Vb+4|0;Ub=c[Mb>>2]|0;do if(Ub){Db=Ub;while(1){Sb=c[Db+16>>2]|0;if((Sb|0)>148){Tb=c[Db>>2]|0;if(!Tb){Wb=Db;Xb=Db;v=207;break}else{Db=Tb;continue}}if((Sb|0)>=148){Yb=Db;v=211;break}Sb=Db+4|0;Tb=c[Sb>>2]|0;if(!Tb){Zb=Sb;_b=Db;v=210;break}else Db=Tb}if((v|0)==207){c[d>>2]=Xb;$b=Wb;ac=Xb;break}else if((v|0)==210){c[d>>2]=_b;$b=Zb;ac=_b;break}else if((v|0)==211){c[d>>2]=Yb;$b=d;ac=Yb;break}}else{Db=Vb+4|0;c[d>>2]=Db;$b=Db;ac=Db}while(0);if(!(c[$b>>2]|0)){Yb=xCi(20)|0;c[Yb+16>>2]=148;c[Yb>>2]=0;c[Yb+4>>2]=0;c[Yb+8>>2]=ac;c[$b>>2]=Yb;ac=c[c[Vb>>2]>>2]|0;if(!ac)bc=Yb;else{c[Vb>>2]=ac;bc=c[$b>>2]|0}GN(c[Mb>>2]|0,bc);bc=Vb+8|0;c[bc>>2]=(c[bc>>2]|0)+1;cc=c[150594]|0}else cc=Vb;Vb=cc+4|0;bc=c[Vb>>2]|0;do if(bc){Mb=bc;while(1){$b=c[Mb+16>>2]|0;if(($b|0)>65){ac=c[Mb>>2]|0;if(!ac){dc=Mb;ec=Mb;v=220;break}else{Mb=ac;continue}}if(($b|0)>=65){fc=Mb;v=224;break}$b=Mb+4|0;ac=c[$b>>2]|0;if(!ac){gc=$b;hc=Mb;v=223;break}else Mb=ac}if((v|0)==220){c[d>>2]=ec;ic=dc;jc=ec;break}else if((v|0)==223){c[d>>2]=hc;ic=gc;jc=hc;break}else if((v|0)==224){c[d>>2]=fc;ic=d;jc=fc;break}}else{Mb=cc+4|0;c[d>>2]=Mb;ic=Mb;jc=Mb}while(0);if(!(c[ic>>2]|0)){fc=xCi(20)|0;c[fc+16>>2]=65;c[fc>>2]=0;c[fc+4>>2]=0;c[fc+8>>2]=jc;c[ic>>2]=fc;jc=c[c[cc>>2]>>2]|0;if(!jc)kc=fc;else{c[cc>>2]=jc;kc=c[ic>>2]|0}GN(c[Vb>>2]|0,kc);kc=cc+8|0;c[kc>>2]=(c[kc>>2]|0)+1;lc=c[150594]|0}else lc=cc;cc=lc+4|0;kc=c[cc>>2]|0;do if(kc){Vb=kc;while(1){ic=c[Vb+16>>2]|0;if((ic|0)>135){jc=c[Vb>>2]|0;if(!jc){mc=Vb;nc=Vb;v=233;break}else{Vb=jc;continue}}if((ic|0)>=135){oc=Vb;v=237;break}ic=Vb+4|0;jc=c[ic>>2]|0;if(!jc){pc=ic;qc=Vb;v=236;break}else Vb=jc}if((v|0)==233){c[d>>2]=nc;rc=mc;sc=nc;break}else if((v|0)==236){c[d>>2]=qc;rc=pc;sc=qc;break}else if((v|0)==237){c[d>>2]=oc;rc=d;sc=oc;break}}else{Vb=lc+4|0;c[d>>2]=Vb;rc=Vb;sc=Vb}while(0);if(!(c[rc>>2]|0)){oc=xCi(20)|0;c[oc+16>>2]=135;c[oc>>2]=0;c[oc+4>>2]=0;c[oc+8>>2]=sc;c[rc>>2]=oc;sc=c[c[lc>>2]>>2]|0;if(!sc)tc=oc;else{c[lc>>2]=sc;tc=c[rc>>2]|0}GN(c[cc>>2]|0,tc);tc=lc+8|0;c[tc>>2]=(c[tc>>2]|0)+1;uc=c[150594]|0}else uc=lc;lc=uc+4|0;tc=c[lc>>2]|0;do if(tc){cc=tc;while(1){rc=c[cc+16>>2]|0;if((rc|0)>136){sc=c[cc>>2]|0;if(!sc){vc=cc;wc=cc;v=246;break}else{cc=sc;continue}}if((rc|0)>=136){xc=cc;v=250;break}rc=cc+4|0;sc=c[rc>>2]|0;if(!sc){yc=rc;zc=cc;v=249;break}else cc=sc}if((v|0)==246){c[d>>2]=wc;Ac=vc;Bc=wc;break}else if((v|0)==249){c[d>>2]=zc;Ac=yc;Bc=zc;break}else if((v|0)==250){c[d>>2]=xc;Ac=d;Bc=xc;break}}else{cc=uc+4|0;c[d>>2]=cc;Ac=cc;Bc=cc}while(0);if(!(c[Ac>>2]|0)){xc=xCi(20)|0;c[xc+16>>2]=136;c[xc>>2]=0;c[xc+4>>2]=0;c[xc+8>>2]=Bc;c[Ac>>2]=xc;Bc=c[c[uc>>2]>>2]|0;if(!Bc)Cc=xc;else{c[uc>>2]=Bc;Cc=c[Ac>>2]|0}GN(c[lc>>2]|0,Cc);Cc=uc+8|0;c[Cc>>2]=(c[Cc>>2]|0)+1;Dc=c[150594]|0}else Dc=uc;uc=Dc+4|0;Cc=c[uc>>2]|0;do if(Cc){lc=Cc;while(1){Ac=c[lc+16>>2]|0;if((Ac|0)>64){Bc=c[lc>>2]|0;if(!Bc){Ec=lc;Fc=lc;v=259;break}else{lc=Bc;continue}}if((Ac|0)>=64){Gc=lc;v=263;break}Ac=lc+4|0;Bc=c[Ac>>2]|0;if(!Bc){Hc=Ac;Ic=lc;v=262;break}else lc=Bc}if((v|0)==259){c[d>>2]=Fc;Jc=Ec;Kc=Fc;break}else if((v|0)==262){c[d>>2]=Ic;Jc=Hc;Kc=Ic;break}else if((v|0)==263){c[d>>2]=Gc;Jc=d;Kc=Gc;break}}else{lc=Dc+4|0;c[d>>2]=lc;Jc=lc;Kc=lc}while(0);if(!(c[Jc>>2]|0)){Gc=xCi(20)|0;c[Gc+16>>2]=64;c[Gc>>2]=0;c[Gc+4>>2]=0;c[Gc+8>>2]=Kc;c[Jc>>2]=Gc;Kc=c[c[Dc>>2]>>2]|0;if(!Kc)Lc=Gc;else{c[Dc>>2]=Kc;Lc=c[Jc>>2]|0}GN(c[uc>>2]|0,Lc);Lc=Dc+8|0;c[Lc>>2]=(c[Lc>>2]|0)+1;Mc=c[150594]|0}else Mc=Dc;Dc=Mc+4|0;Lc=c[Dc>>2]|0;do if(Lc){uc=Lc;while(1){Jc=c[uc+16>>2]|0;if((Jc|0)>58){Kc=c[uc>>2]|0;if(!Kc){Nc=uc;Oc=uc;v=272;break}else{uc=Kc;continue}}if((Jc|0)>=58){Pc=uc;v=276;break}Jc=uc+4|0;Kc=c[Jc>>2]|0;if(!Kc){Qc=Jc;Rc=uc;v=275;break}else uc=Kc}if((v|0)==272){c[d>>2]=Oc;Sc=Nc;Tc=Oc;break}else if((v|0)==275){c[d>>2]=Rc;Sc=Qc;Tc=Rc;break}else if((v|0)==276){c[d>>2]=Pc;Sc=d;Tc=Pc;break}}else{uc=Mc+4|0;c[d>>2]=uc;Sc=uc;Tc=uc}while(0);if(!(c[Sc>>2]|0)){Pc=xCi(20)|0;c[Pc+16>>2]=58;c[Pc>>2]=0;c[Pc+4>>2]=0;c[Pc+8>>2]=Tc;c[Sc>>2]=Pc;Tc=c[c[Mc>>2]>>2]|0;if(!Tc)Uc=Pc;else{c[Mc>>2]=Tc;Uc=c[Sc>>2]|0}GN(c[Dc>>2]|0,Uc);Uc=Mc+8|0;c[Uc>>2]=(c[Uc>>2]|0)+1;Vc=c[150594]|0}else Vc=Mc;Mc=Vc+4|0;Uc=c[Mc>>2]|0;do if(Uc){Dc=Uc;while(1){Sc=c[Dc+16>>2]|0;if((Sc|0)>61){Tc=c[Dc>>2]|0;if(!Tc){Wc=Dc;Xc=Dc;v=285;break}else{Dc=Tc;continue}}if((Sc|0)>=61){Yc=Dc;v=289;break}Sc=Dc+4|0;Tc=c[Sc>>2]|0;if(!Tc){Zc=Sc;_c=Dc;v=288;break}else Dc=Tc}if((v|0)==285){c[d>>2]=Xc;$c=Wc;ad=Xc;break}else if((v|0)==288){c[d>>2]=_c;$c=Zc;ad=_c;break}else if((v|0)==289){c[d>>2]=Yc;$c=d;ad=Yc;break}}else{Dc=Vc+4|0;c[d>>2]=Dc;$c=Dc;ad=Dc}while(0);if(!(c[$c>>2]|0)){Yc=xCi(20)|0;c[Yc+16>>2]=61;c[Yc>>2]=0;c[Yc+4>>2]=0;c[Yc+8>>2]=ad;c[$c>>2]=Yc;ad=c[c[Vc>>2]>>2]|0;if(!ad)bd=Yc;else{c[Vc>>2]=ad;bd=c[$c>>2]|0}GN(c[Mc>>2]|0,bd);bd=Vc+8|0;c[bd>>2]=(c[bd>>2]|0)+1;cd=c[150594]|0}else cd=Vc;Vc=cd+4|0;bd=c[Vc>>2]|0;do if(bd){Mc=bd;while(1){$c=c[Mc+16>>2]|0;if(($c|0)>68){ad=c[Mc>>2]|0;if(!ad){dd=Mc;ed=Mc;v=298;break}else{Mc=ad;continue}}if(($c|0)>=68){fd=Mc;v=302;break}$c=Mc+4|0;ad=c[$c>>2]|0;if(!ad){gd=$c;hd=Mc;v=301;break}else Mc=ad}if((v|0)==298){c[d>>2]=ed;id=dd;jd=ed;break}else if((v|0)==301){c[d>>2]=hd;id=gd;jd=hd;break}else if((v|0)==302){c[d>>2]=fd;id=d;jd=fd;break}}else{Mc=cd+4|0;c[d>>2]=Mc;id=Mc;jd=Mc}while(0);if(!(c[id>>2]|0)){fd=xCi(20)|0;c[fd+16>>2]=68;c[fd>>2]=0;c[fd+4>>2]=0;c[fd+8>>2]=jd;c[id>>2]=fd;jd=c[c[cd>>2]>>2]|0;if(!jd)kd=fd;else{c[cd>>2]=jd;kd=c[id>>2]|0}GN(c[Vc>>2]|0,kd);kd=cd+8|0;c[kd>>2]=(c[kd>>2]|0)+1;ld=c[150594]|0}else ld=cd;cd=ld+4|0;kd=c[cd>>2]|0;do if(kd){Vc=kd;while(1){id=c[Vc+16>>2]|0;if((id|0)>60){jd=c[Vc>>2]|0;if(!jd){md=Vc;nd=Vc;v=311;break}else{Vc=jd;continue}}if((id|0)>=60){od=Vc;v=315;break}id=Vc+4|0;jd=c[id>>2]|0;if(!jd){pd=id;qd=Vc;v=314;break}else Vc=jd}if((v|0)==311){c[d>>2]=nd;rd=md;sd=nd;break}else if((v|0)==314){c[d>>2]=qd;rd=pd;sd=qd;break}else if((v|0)==315){c[d>>2]=od;rd=d;sd=od;break}}else{Vc=ld+4|0;c[d>>2]=Vc;rd=Vc;sd=Vc}while(0);if(!(c[rd>>2]|0)){d=xCi(20)|0;c[d+16>>2]=60;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=sd;c[rd>>2]=d;sd=c[c[ld>>2]>>2]|0;if(!sd)td=d;else{c[ld>>2]=sd;td=c[rd>>2]|0}GN(c[cd>>2]|0,td);td=ld+8|0;c[td>>2]=(c[td>>2]|0)+1}nOc(h,c[m>>2]|0);m=c[g>>2]|0;if(!m){i=b;return}g=c[k>>2]|0;if((g|0)!=(m|0))c[k>>2]=g+(~((g+-4-m|0)>>>2)<<2);ACi(m);i=b;return}function SPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b;RPc();e=c[150592]|0;f=e+4|0;g=c[f>>2]|0;do if(g){h=g;while(1){j=c[h+16>>2]|0;if((j|0)>(a|0)){k=c[h>>2]|0;if(!k){l=h;m=h;n=4;break}else{h=k;continue}}if((j|0)>=(a|0)){o=h;n=8;break}j=h+4|0;k=c[j>>2]|0;if(!k){p=j;q=h;n=7;break}else h=k}if((n|0)==4){c[d>>2]=m;r=l;s=m;break}else if((n|0)==7){c[d>>2]=q;r=p;s=q;break}else if((n|0)==8){c[d>>2]=o;r=d;s=o;break}}else{h=e+4|0;c[d>>2]=h;r=h;s=h}while(0);d=c[r>>2]|0;if(d){t=d;u=t+20|0;i=b;return u|0}d=xCi(32)|0;c[d+16>>2]=a;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=s;c[r>>2]=d;s=c[c[e>>2]>>2]|0;if(!s)v=d;else{c[e>>2]=s;v=c[r>>2]|0}GN(c[f>>2]|0,v);v=e+8|0;c[v>>2]=(c[v>>2]|0)+1;t=d;u=t+20|0;i=b;return u|0}function TPc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;RPc();d=c[150594]|0;e=c[d+4>>2]|0;f=d+4|0;if(e){d=f;g=e;a:while(1){e=g;while(1){if((c[e+16>>2]|0)>=(a|0)){h=e;break}e=c[e+4>>2]|0;if(!e){j=d;break a}}g=c[h>>2]|0;if(!g){j=h;break}else d=h}if((j|0)!=(f|0)?(c[j+16>>2]|0)<=(a|0):0){k=j;l=(k|0)!=(f|0);i=b;return l|0}}k=f;l=(k|0)!=(f|0);i=b;return l|0}function UPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d;c[h>>2]=b;c[j>>2]=0;b=j+4|0;c[b>>2]=0;c[j+8>>2]=0;AQb(a,j,0);k=c[j>>2]|0;l=c[150590]|0;if((k|0)==(c[b>>2]|0))m=l;else{n=k;k=l;while(1){l=YPc(k,n)|0;o=c[l>>2]|0;p=c[l+4>>2]|0;q=p-o>>2;if(!q)r=o;else{s=c[h>>2]|0;t=o;o=q;while(1){q=(o|0)/2|0;if((c[t+(q<<2)>>2]|0)<(s|0)){u=t+(q+1<<2)|0;v=o+-1-q|0}else{u=t;v=q}if(!v){r=u;break}else{t=u;o=v}}}if(!((r|0)!=(p|0)?(c[h>>2]|0)>=(c[r>>2]|0):0)){c[g>>2]=r;c[e+0>>2]=c[g+0>>2];drc(f,l,e,h)}n=n+4|0;o=c[150590]|0;if((n|0)==(c[b>>2]|0)){m=o;break}else k=o}}k=m+4|0;n=c[k>>2]|0;do if(n){r=n;while(1){v=c[r+16>>2]|0;if((v|0)>(a|0)){u=c[r>>2]|0;if(!u){w=r;x=r;y=15;break}else{r=u;continue}}if((v|0)>=(a|0)){z=r;y=19;break}v=r+4|0;u=c[v>>2]|0;if(!u){A=v;B=r;y=18;break}else r=u}if((y|0)==15){c[e>>2]=x;C=w;D=x;break}else if((y|0)==18){c[e>>2]=B;C=A;D=B;break}else if((y|0)==19){c[e>>2]=z;C=e;D=z;break}}else{r=m+4|0;c[e>>2]=r;C=r;D=r}while(0);z=c[C>>2]|0;if(!z){y=xCi(32)|0;c[y+16>>2]=a;c[y+20>>2]=0;c[y+24>>2]=0;c[y+28>>2]=0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=D;c[C>>2]=y;D=c[c[m>>2]>>2]|0;if(!D)E=y;else{c[m>>2]=D;E=c[C>>2]|0}GN(c[k>>2]|0,E);E=m+8|0;c[E>>2]=(c[E>>2]|0)+1;F=y}else F=z;z=F+20|0;y=c[z>>2]|0;E=c[F+24>>2]|0;F=E-y>>2;if(!F)G=y;else{m=c[h>>2]|0;k=y;y=F;while(1){F=(y|0)/2|0;if((c[k+(F<<2)>>2]|0)<(m|0)){H=k+(F+1<<2)|0;I=y+-1-F|0}else{H=k;I=F}if(!I){G=H;break}else{k=H;y=I}}}if(!((G|0)!=(E|0)?(c[h>>2]|0)>=(c[G>>2]|0):0)){c[g>>2]=G;c[e+0>>2]=c[g+0>>2];drc(f,z,e,h)}h=c[j>>2]|0;if(!h){i=d;return}j=c[b>>2]|0;if((j|0)!=(h|0))c[b>>2]=j+(~((j+-4-h|0)>>>2)<<2);ACi(h);i=d;return}function VPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d;c[h>>2]=b;if((a|0)==-1|(b|0)==-1){i=d;return}c[j>>2]=0;b=j+4|0;c[b>>2]=0;c[j+8>>2]=0;AQb(a,j,0);k=c[j>>2]|0;l=c[150592]|0;if((k|0)==(c[b>>2]|0))m=l;else{n=l;l=k;while(1){k=YPc(n,l)|0;o=c[k>>2]|0;p=c[k+4>>2]|0;q=p-o>>2;if(!q)r=o;else{s=c[h>>2]|0;t=o;o=q;while(1){q=(o|0)/2|0;if((c[t+(q<<2)>>2]|0)<(s|0)){u=t+(q+1<<2)|0;v=o+-1-q|0}else{u=t;v=q}if(!v){r=u;break}else{t=u;o=v}}}if(!((r|0)!=(p|0)?(c[h>>2]|0)>=(c[r>>2]|0):0)){c[g>>2]=r;c[e+0>>2]=c[g+0>>2];drc(f,k,e,h)}l=l+4|0;o=c[150592]|0;if((l|0)==(c[b>>2]|0)){m=o;break}else n=o}}n=m+4|0;l=c[n>>2]|0;do if(l){r=l;while(1){v=c[r+16>>2]|0;if((v|0)>(a|0)){u=c[r>>2]|0;if(!u){w=r;x=r;y=16;break}else{r=u;continue}}if((v|0)>=(a|0)){z=r;y=20;break}v=r+4|0;u=c[v>>2]|0;if(!u){A=v;B=r;y=19;break}else r=u}if((y|0)==16){c[e>>2]=x;C=w;D=x;break}else if((y|0)==19){c[e>>2]=B;C=A;D=B;break}else if((y|0)==20){c[e>>2]=z;C=e;D=z;break}}else{r=m+4|0;c[e>>2]=r;C=r;D=r}while(0);z=c[C>>2]|0;if(!z){y=xCi(32)|0;c[y+16>>2]=a;c[y+20>>2]=0;c[y+24>>2]=0;c[y+28>>2]=0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=D;c[C>>2]=y;D=c[c[m>>2]>>2]|0;if(!D)E=y;else{c[m>>2]=D;E=c[C>>2]|0}GN(c[n>>2]|0,E);E=m+8|0;c[E>>2]=(c[E>>2]|0)+1;F=y}else F=z;z=F+20|0;y=c[z>>2]|0;E=c[F+24>>2]|0;F=E-y>>2;if(!F)G=y;else{m=c[h>>2]|0;n=y;y=F;while(1){F=(y|0)/2|0;if((c[n+(F<<2)>>2]|0)<(m|0)){H=n+(F+1<<2)|0;I=y+-1-F|0}else{H=n;I=F}if(!I){G=H;break}else{n=H;y=I}}}if(!((G|0)!=(E|0)?(c[h>>2]|0)>=(c[G>>2]|0):0)){c[g>>2]=G;c[e+0>>2]=c[g+0>>2];drc(f,z,e,h)}h=c[j>>2]|0;if(!h){i=d;return}j=c[b>>2]|0;if((j|0)!=(h|0))c[b>>2]=j+(~((j+-4-h|0)>>>2)<<2);ACi(h);i=d;return}function WPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b){i=d;return}WPc(a,c[b>>2]|0);WPc(a,c[b+4>>2]|0);a=c[b+20>>2]|0;if(a){e=b+24|0;f=c[e>>2]|0;if((f|0)!=(a|0))c[e>>2]=f+(~((f+-4-a|0)>>>2)<<2);ACi(a)}ACi(b);i=d;return}function XPc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function YPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=c[b>>2]|0;j=g;while(1){k=c[j+16>>2]|0;if((h|0)<(k|0)){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if((k|0)>=(h|0)){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=a+4|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+20|0;i=d;return v|0}e=xCi(32)|0;c[e+16>>2]=c[b>>2];c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=c[c[a>>2]>>2]|0;if(!t)w=e;else{c[a>>2]=t;w=c[s>>2]|0}GN(c[f>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;u=e;v=u+20|0;i=d;return v|0}function ZPc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;if(!c)f=0;else f=aad((Xbd()|0)+24|0,c)|0;g=pQc(a,b,c,f,d)|0;i=e;return g|0}function _Pc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f;h=f+44|0;j=f+32|0;k=f+20|0;l=f+8|0;if(!(a[(xQb(d)|0)+28>>0]|0)){m=1;i=f;return m|0};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[j>>2]=0;n=j+4|0;c[n>>2]=0;c[j+8>>2]=0;AQb(d,j,1);d=c[j>>2]|0;if((d|0)!=(c[n>>2]|0)){o=k+1|0;p=k+8|0;q=k+4|0;r=d;do{d=EQb(c[r>>2]|0)|0;if(!(a[d>>0]&1))s=d+1|0;else s=c[d+8>>2]|0;c[g>>2]=s;Lsd(k,602472,g);d=a[k>>0]|0;if(!(d&1)){t=o;u=(d&255)>>>1}else{t=c[p>>2]|0;u=c[q>>2]|0}Gri(h,t,u)|0;xri(k);d=c[n>>2]|0;if((r|0)==(d+-4|0))v=d;else{Eri(h,602480)|0;v=c[n>>2]|0}r=r+4|0}while((r|0)!=(v|0))}if(!(a[h>>0]&1))w=h+1|0;else w=c[h+8>>2]|0;v=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;c[g>>2]=w;c[g+4>>2]=v;Lsd(l,602488,g);yri(e,l)|0;xri(l);l=c[j>>2]|0;if(l){j=c[n>>2]|0;if((j|0)!=(l|0))c[n>>2]=j+(~((j+-4-l|0)>>>2)<<2);ACi(l)}xri(h);m=0;i=f;return m|0}function $Pc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+224|0;g=f+208|0;h=f+8|0;j=f;k=fsc(b)|0;b=(Atc()|0)+428|0;l=c[b+4>>2]|0;m=j;c[m>>2]=c[b>>2];c[m+4>>2]=l;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];jbd(h,g);cbd(h+32|0,k);k=ssc(nbd(h)|0)|0;c[d>>2]=k;if(!k){n=1;i=f;return n|0}k=a+32|0;if((c[k>>2]|0)<=0){n=1;i=f;return n|0}h=a+24|0;a=0;while(1){g=c[(c[h>>2]|0)+(a<<3)+4>>2]|0;if((((g|0)!=0?(j=(da(c[137788]|0,(c[g+8>>2]|0)>>>21)|0)+114|0,l=j>>5,(1<<j-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0):0)?(l=m9c(g)|0,(l|0)!=0):0)?msc(l,c[d>>2]|0)|0:0){o=l;break}a=a+1|0;if((a|0)>=(c[k>>2]|0)){n=1;p=10;break}}if((p|0)==10){i=f;return n|0}c[e>>2]=o;n=0;i=f;return n|0}function aQc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+64|0;h=g+52|0;j=g+48|0;k=g+32|0;l=g+16|0;m=g;n=c[153134]|0;c[k>>2]=0;o=k+4|0;c[o>>2]=n;p=k+8|0;c[p>>2]=0;q=k+12|0;c[q>>2]=0;c[l>>2]=0;r=l+4|0;c[r>>2]=n;c[l+8>>2]=0;n=l+12|0;c[n>>2]=0;s=(qQc(b,d,e,k,l,f)|0)^1;if((c[p>>2]|0)==0|s)t=0;else{s=m+1|0;e=m+8|0;d=m+4|0;u=0;do{c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;v=c[k>>2]|0;w=c[v+(u<<3)>>2]|0;x=c[v+(u<<3)+4>>2]|0;if(!x)y=0;else y=aad((Xbd()|0)+24|0,x)|0;v=pQc(b,w,x,y,m)|0;x=a[m>>0]|0;w=(x&1)==0;if(w)z=(x&255)>>>1;else z=c[d>>2]|0;if(z){if(w){A=s;B=(x&255)>>>1}else{A=c[e>>2]|0;B=c[d>>2]|0}Gri(f,A,B)|0}xri(m);u=u+1|0}while(u>>>0<(c[p>>2]|0)>>>0);t=v}if((c[n>>2]|0)>-1){n=c[l>>2]|0;c[j>>2]=c[r>>2];c[h+0>>2]=c[j+0>>2];eOb(n,h);c[l>>2]=0}if((c[q>>2]|0)<=-1){i=g;return t|0}q=c[k>>2]|0;c[j>>2]=c[o>>2];c[h+0>>2]=c[j+0>>2];eOb(q,h);c[k>>2]=0;i=g;return t|0}function bQc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e;g=e+28|0;h=e+16|0;j=e+4|0;k=Esd(b,602584)|0;l=k?b+12|0:b;b=FQb(l)|0;k=(b|0)==-1;if(!k?(m=(da(c[137788]|0,b)|0)+2|0,n=m>>5,(1<<m-(n<<5)&c[(c[137786]|0)+(n<<2)>>2]|0)!=0):0){o=aQc(a,b,0,d)|0;i=e;return o|0}b=(Xbd()|0)+24|0;rri(g,l,SEi(l|0)|0);n=$9c(b,g)|0;xri(g);if(n){o=aQc(a,114,gad(n)|0,d)|0;i=e;return o|0}if(!d){o=0;i=e;return o|0}if(k){c[f>>2]=l;Lsd(h,602600,f);yri(d,h)|0;xri(h);o=0;i=e;return o|0}else{c[f>>2]=l;Lsd(j,602656,f);yri(d,j)|0;xri(j);o=0;i=e;return o|0}return 0}function cQc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;if(!d){i=f;return};c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;if(!(bQc(b,d,g)|0)){if(!(a[g>>0]&1))h=g+1|0;else h=c[g+8>>2]|0;Krd(h,0,3653512,675,1,0,0,0)}h=c[e>>2]|0;d=c[h>>2]|0;c[e>>2]=h+4;if(d){h=g+1|0;j=g+8|0;k=d;do{if(!(bQc(b,k,g)|0))Krd((a[g>>0]&1)==0?h:c[j>>2]|0,0,3653512,683,1,0,0,0);d=c[e>>2]|0;k=c[d>>2]|0;c[e>>2]=d+4}while((k|0)!=0)}xri(g);i=f;return}function dQc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f;c[h>>2]=c[153106];c[g+0>>2]=c[h+0>>2];h=bOb(72,g,1,16,3653512,713)|0;c[j>>2]=c[153106];c[g+0>>2]=c[j+0>>2];nTb(h,g,0);g=pQb(h)|0;ko[c[(c[g>>2]|0)+24>>2]&4095](g);if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;In[c[(c[g>>2]|0)+36>>2]&4095](g,l);In[c[(c[g>>2]|0)+12>>2]&4095](g,4);FTb(g);c[k>>2]=e;cQc(g,d,k);i=f;return g|0}function eQc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h;c[k>>2]=c[153106];c[j+0>>2]=c[k+0>>2];k=bOb(72,j,1,16,3653512,743)|0;c[l>>2]=c[153106];c[j+0>>2]=c[l+0>>2];nTb(k,j,0);j=pQb(k)|0;In[c[(c[j>>2]|0)+44>>2]&4095](j,e);ko[c[(c[j>>2]|0)+24>>2]&4095](j);e=c[(c[j>>2]|0)+36>>2]|0;k=(a[b>>0]&1)==0;if(d){if(k)n=b+1|0;else n=c[b+8>>2]|0;In[e&4095](j,n);In[c[(c[j>>2]|0)+12>>2]&4095](j,4);FTb(j);c[m>>2]=g;cQc(j,f,m);i=h;return j|0}else{if(k)o=b+1|0;else o=c[b+8>>2]|0;In[e&4095](j,o);In[c[(c[j>>2]|0)+12>>2]&4095](j,4);c[m>>2]=g;cQc(j,f,m);i=h;return j|0}return 0}function fQc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+48|0;f=d;g=d+32|0;h=d+20|0;j=d+8|0;k=c[b+24>>2]|0;if(!k){l=0;i=d;return l|0}if((ETb(k,b)|0)==-1){l=0;i=d;return l|0}m=(c[b+8>>2]|0)>>>21;if((m|0)==4){if(!e){l=0;i=d;return l|0}c[f>>2]=mo[c[(c[k>>2]|0)+32>>2]&4095](k)|0;Lsd(g,602720,f);yri(e,g)|0;xri(g);l=0;i=d;return l|0}g=(da(c[137788]|0,m)|0)+114|0;n=g>>5;if(!(1<<g-(n<<5)&c[(c[137786]|0)+(n<<2)>>2]))o=0;else o=m9c(b)|0;n=k+32|0;do if((c[n>>2]|0)<=0){if(!e){l=1;i=d;return l|0}}else{g=k+24|0;p=(e|0)!=0;q=0;r=0;s=1;while(1){t=c[(c[g>>2]|0)+(r<<3)>>2]|0;u=QPc(t)|0;v=c[u>>2]|0;w=c[u+4>>2]|0;u=w-v>>2;if(!u)x=v;else{y=v;v=u;while(1){u=(v|0)/2|0;if((c[y+(u<<2)>>2]|0)<(m|0)){z=y+(u+1<<2)|0;A=v+-1-u|0}else{z=y;A=u}if(!A){x=z;break}else{y=z;v=A}}}if((x|0)!=(w|0)?(m|0)>=(c[x>>2]|0)&p:0){if(!s)Eri(e,1081768)|0;v=EQb(t)|0;y=a[v>>0]|0;if(!(y&1)){B=v+1|0;C=(y&255)>>>1}else{B=c[v+8>>2]|0;C=c[v+4>>2]|0}Gri(e,B,C)|0;D=0}else D=s;if((t|0)==114){v=m9c(c[(c[g>>2]|0)+(r<<3)+4>>2]|0)|0;E=(v|0)!=0&(o|0)==(v|0)}else E=(t|0)==(m|0);v=(E&1)+q|0;r=r+1|0;if((r|0)>=(c[n>>2]|0)){F=v;G=D;break}else{q=v;s=D}}s=(e|0)!=0;if(G|(F|0)>1){if(s)break;else l=1;i=d;return l|0}if(!s){l=0;i=d;return l|0}rQc(j,b);if(!(a[j>>0]&1))H=j+1|0;else H=c[j+8>>2]|0;if(!(a[e>>0]&1))I=e+1|0;else I=c[e+8>>2]|0;c[f>>2]=H;c[f+4>>2]=I;Lsd(h,602904,f);yri(e,h)|0;xri(h);xri(j);l=0;i=d;return l|0}while(0);zri(e,3653512)|0;l=1;i=d;return l|0}function gQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+64|0;e=d+48|0;f=d+40|0;g=d+36|0;h=d+32|0;j=d+16|0;k=d;l=c[153134]|0;c[j>>2]=0;m=j+4|0;c[m>>2]=l;l=j+8|0;c[l>>2]=0;n=j+12|0;c[n>>2]=0;DQb(1,j,0)|0;o=k+4|0;c[o>>2]=0;p=k+8|0;c[p>>2]=0;q=k+4|0;c[k>>2]=q;if(c[l>>2]|0){r=0;do{s=c[(c[j>>2]|0)+(r<<2)>>2]|0;if(vTb(s)|0){t=c[s+4>>2]|0;s=c[o>>2]|0;do if(s){u=s;while(1){v=c[u+16>>2]|0;if((t|0)<(v|0)){w=c[u>>2]|0;if(!w){x=u;y=u;z=7;break}else{u=w;continue}}if((v|0)>=(t|0)){A=u;z=11;break}v=u+4|0;w=c[v>>2]|0;if(!w){B=v;C=u;z=10;break}else u=w}if((z|0)==7){z=0;c[g>>2]=y;D=x;E=y;break}else if((z|0)==10){z=0;c[g>>2]=C;D=B;E=C;break}else if((z|0)==11){z=0;c[g>>2]=A;D=g;E=A;break}}else{c[g>>2]=q;D=q;E=q}while(0);if(!(c[D>>2]|0)){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];s=cOb(20,16,e,0,3653512,80)|0;c[s+16>>2]=t;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=E;c[D>>2]=s;u=c[c[k>>2]>>2]|0;if(!u)F=s;else{c[k>>2]=u;F=c[D>>2]|0}GN(c[o>>2]|0,F);c[p>>2]=(c[p>>2]|0)+1}}r=r+1|0}while(r>>>0<(c[l>>2]|0)>>>0);l=c[k>>2]|0;if((l|0)!=(q|0)){r=l;while(1){c[f>>2]=c[r+16>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,f);p=c[e>>2]|0;F=c[l+28>>2]|0;if((p|0)==-1){G=F+(c[l+32>>2]<<3)|0;break}else{G=F+(p<<3)|0;break}}else G=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if(((G|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[G+4>>2]|0,(l|0)!=0):0)?vTb(l)|0:0)LTb(l,a,b)}l=c[r+4>>2]|0;if(!l){t=r;while(1){p=c[t+8>>2]|0;if((c[p>>2]|0)==(t|0)){H=p;break}else t=p}}else{t=l;while(1){p=c[t>>2]|0;if(!p){H=t;break}else t=p}}if((H|0)==(q|0))break;else r=H}}}sQc(k,c[o>>2]|0);if((c[n>>2]|0)<=-1){i=d;return}n=c[j>>2]|0;c[h>>2]=c[m>>2];c[e+0>>2]=c[h+0>>2];eOb(n,e);c[j>>2]=0;i=d;return}function hQc(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;f=d+4|0;g=d;h=wTb()|0;j=c[h+4>>2]|0;if((j|0)==(h|0)){i=d;return}k=b+8|0;l=b+12|0;m=b+4|0;n=j;do{j=c[n+8>>2]|0;if((e[j+44>>1]|0|0)==(a|0)){o=(c[k>>2]|0)+1|0;c[k>>2]=o;p=c[l>>2]|0;q=p&2147483647;if(o>>>0>q>>>0){r=p<<1;s=(r|0)==0?1:r;do if(q>>>0<s>>>0)if((p|0)>-1){c[l>>2]=s;r=c[b>>2]|0;c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];c[b>>2]=hOb(r,s<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];r=cOb(s<<2,4,f,0,3653512,352)|0;YEi(r|0,c[b>>2]|0,c[k>>2]<<2|0)|0;c[l>>2]=s;c[b>>2]=r;break}while(0);t=c[k>>2]|0}else t=o;c[(c[b>>2]|0)+(t+-1<<2)>>2]=j}n=c[n+4>>2]|0}while((n|0)!=(h|0));i=d;return}function iQc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b;g=c[153134]|0;c[f>>2]=0;h=f+4|0;c[h>>2]=g;g=f+8|0;c[g>>2]=0;j=f+12|0;c[j>>2]=0;hQc(5,f);k=c[g>>2]|0;a:do if(!k)l=0;else{g=c[f>>2]|0;m=0;while(1){n=ATb(c[g+(m<<2)>>2]|0,20)|0;if((n|0)!=0?(a[n+28>>0]|0)!=0:0){o=n;break}m=m+1|0;if(m>>>0>=k>>>0){l=0;break a}}l=o}while(0);if((c[j>>2]|0)<=-1){i=b;return l|0}j=c[f>>2]|0;c[e>>2]=c[h>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[f>>2]=0;i=b;return l|0}function jQc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((b|0)!=114){f=CTb(a,b)|0;i=e;return f|0}if(!d){f=0;i=e;return f|0}b=gad(d)|0;if(!b){f=0;i=e;return f|0}d=c[a+32>>2]|0;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;a=0;while(1){h=c[g>>2]|0;j=(da(c[137788]|0,c[h+(a<<3)>>2]|0)|0)+114|0;k=j>>5;if(((1<<j-(k<<5)&c[(c[137786]|0)+(k<<2)>>2]|0)!=0?(k=c[h+(a<<3)+4>>2]|0,h=c[k+20>>2]|0,(h|0)!=0):0)?msc(vsc(h)|0,b)|0:0){f=k;l=11;break}a=a+1|0;if((a|0)>=(d|0)){f=0;l=11;break}}if((l|0)==11){i=e;return f|0}return 0}function kQc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+1040|0;d=b+1032|0;e=b;GTb(a,2);c[d>>2]=0;uQc(a,d);f=BTb(a)|0;if(f)kGc(f,1);f=c[d>>2]|0;if(!f){i=b;return}xQc(e,f);vQc(a,e);yQc(e);i=b;return}function lQc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+48|0;f=e;g=e+36|0;h=e+32|0;j=e+20|0;k=e+8|0;if(!b){i=e;return}l=b+8|0;m=da(c[137788]|0,(c[l>>2]|0)>>>21)|0;n=m+2|0;o=n>>5;p=c[137786]|0;if(!(1<<n-(o<<5)&c[p+(o<<2)>>2])){o=m+1|0;n=o>>5;if(!(c[p+(n<<2)>>2]&1<<o-(n<<5))){n=m+142|0;o=n>>5;if(!(c[p+(o<<2)>>2]&1<<n-(o<<5))){kQb(b);i=e;return}else{Krd(603768,0,3653512,1477,1,c[b+4>>2]|0,0,0);i=e;return}}if(SQb()|0){Krd(603536,0,3653512,1442,1,c[b+4>>2]|0,0,0);i=e;return}if(a[b+48>>0]|0){Krd(602952,0,3653512,1449,1,0,0,0);i=e;return}if(a[b+49>>0]|0){Krd(603696,0,3653512,1455,1,c[b+4>>2]|0,0,0);i=e;return}o=BTb(b)|0;if(((o|0)!=0?(n=c[o+156>>2]|0,(n|0)!=0):0)?(a[(c[n+24>>2]|0)+49>>0]|0)!=0:0){Krd(603696,0,3653512,1465,1,c[b+4>>2]|0,0,0);i=e;return}kQc(b);i=e;return}n=m+114|0;m=n>>5;if((c[p+(m<<2)>>2]&1<<n-(m<<5)|0)!=0?(a[b+131>>0]|0)!=0:0){Krd(602952,0,3653512,1354,1,0,0,0);i=e;return}m=b+24|0;n=c[m>>2]|0;if(!n)ko[c[(c[b>>2]|0)+100>>2]&4095](b);else{if(SQb()|0){Krd(603064,0,3653512,1364,1,c[b+4>>2]|0,0,0);i=e;return}if(a[n+48>>0]|0){Krd(602952,0,3653512,1370,1,0,0,0);i=e;return}if(a[n+49>>0]|0){Krd(603224,0,3653512,1377,1,c[n+4>>2]|0,0,0);i=e;return};c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;if(!d?!(fQc(b,0,j)|0):0){if(!(a[j>>0]&1))q=j+1|0;else q=c[j+8>>2]|0;Krd(q,0,3653512,1384,1,c[b+4>>2]|0,0,0);xri(j);i=e;return}if((c[l>>2]&-2097152|0)==469762048){c[f>>2]=mo[c[(c[n>>2]|0)+32>>2]&4095](n)|0;Lsd(k,603304,f);yri(j,k)|0;xri(k);if(!(a[j>>0]&1))r=j+1|0;else r=c[j+8>>2]|0;Krd(r,0,3653512,1398,1,c[b+4>>2]|0,0,0);xri(j);i=e;return}r=c[b+4>>2]|0;if(vTb(n)|0){In[c[(c[b>>2]|0)+104>>2]&4095](b,1);if(!r)s=0;else{c[g>>2]=r;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(f,k,g);l=c[f>>2]|0;q=c[k+28>>2]|0;if((l|0)==-1){t=q+(c[k+32>>2]<<3)|0;break}else{t=q+(l<<3)|0;break}}else t=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((t|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[t+4>>2]|0,(k|0)!=0):0)u=k;else v=34}else v=34;if((v|0)==34)u=hQb(r)|0;s=u}if((s|0)!=(b|0)){xri(j);i=e;return}}ko[c[(c[b>>2]|0)+100>>2]&4095](b);if(!r)w=0;else{c[h>>2]=r;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(f,s,h);u=c[f>>2]|0;k=c[s+28>>2]|0;if((u|0)==-1){x=k+(c[s+32>>2]<<3)|0;break}else{x=k+(u<<3)|0;break}}else x=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((x|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[x+4>>2]|0,(s|0)!=0):0)y=s;else v=46}else v=46;if((v|0)==46)y=hQb(r)|0;w=y}if((w|0)!=(b|0)){xri(j);i=e;return}w=ETb(n,b)|0;if((w|0)==-1)Krd(603496,0,3653512,1424,1,0,0,0);else DTb(c[m>>2]|0,w);xri(j)}kQb(b);i=e;return}function mQc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+64|0;f=e;g=e+56|0;h=e+44|0;j=e+32|0;k=e+20|0;l=e+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;if(!d){rri(b,603880,4);xri(h);i=e;return}if((c[d+8>>2]&-2097152|0)==239075328){m=((c[137788]|0)*114|0)+114|0;n=m>>5;N9c(k,(1<<m-(n<<5)&c[(c[137786]|0)+(n<<2)>>2]|0)==0?0:d);n=a[k>>0]|0;if(!(n&1)){o=k+1|0;p=(n&255)>>>1}else{o=c[k+8>>2]|0;p=c[k+4>>2]|0}rri(j,o,p);yri(h,j)|0;xri(j);if(a[k>>0]&1){j=c[k+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(j,f)}}else{_ri(l,602584,GQb(d)|0);yri(h,l)|0;xri(l)}l=mo[c[(c[d>>2]|0)+32>>2]&4095](d)|0;if(!(a[h>>0]&1))q=h+1|0;else q=c[h+8>>2]|0;c[f>>2]=l;c[f+4>>2]=q;Lsd(b,603888,f);xri(h);i=e;return}function nQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=BTb(a)|0;if(!e){f=0;i=d;return f|0}else g=e;while(1){e=ATb(c[g+24>>2]|0,b)|0;if(e){f=e;h=4;break}g=c[g+156>>2]|0;if(!g){f=0;h=4;break}}if((h|0)==4){i=d;return f|0}return 0}function oQc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[a+32>>2]|0;if((g|0)>0){h=a+24|0;j=0;do{k=c[h>>2]|0;if((c[k+(j<<3)>>2]|0)==(b|0)){c[f>>2]=c[k+(j<<3)+4>>2];tQc(d,f)}j=j+1|0}while((j|0)!=(g|0))}g=BTb(a)|0;a=c[g+148>>2]|0;if((a|0)<=0){i=e;return}j=g+140|0;g=0;do{oQc(c[(c[(c[j>>2]|0)+(g<<2)>>2]|0)+24>>2]|0,b,d);g=g+1|0}while((g|0)!=(a|0));i=e;return}function pQc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+28|0;m=h+24|0;n=h+12|0;o=h+8|0;p=(d|0)==4;if(p?(ATb(b,4)|0)!=0:0){if(!g){q=0;i=h;return q|0}r=EQb(4)|0;if(!(a[r>>0]&1))s=r+1|0;else s=c[r+8>>2]|0;c[j>>2]=s;Lsd(l,605328,j);yri(g,l)|0;xri(l);q=0;i=h;return q|0}c[m>>2]=c[153106];c[j+0>>2]=c[m+0>>2];m=yQb(d,0,j,0)|0;if(!m){if(!g){q=0;i=h;return q|0}l=EQb(d)|0;if(!(a[l>>0]&1))t=l+1|0;else t=c[l+8>>2]|0;c[j>>2]=t;Lsd(n,602400,j);yri(g,n)|0;xri(n);q=0;i=h;return q|0}ko[c[(c[m>>2]|0)+24>>2]&4095](m);zTb(b,m);n=(da(c[137788]|0,(c[m+8>>2]|0)>>>21)|0)+114|0;g=n>>5;do if(1<<n-(g<<5)&c[(c[137786]|0)+(g<<2)>>2]){t=c[m+4>>2]|0;if(!f)Q9c(m,e,0);else{c[o>>2]=c[f+4>>2];P9c(m,o,0)}if(!t){q=0;i=h;return q|0}c[k>>2]=t;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(j,l,k);s=c[j>>2]|0;r=c[l+28>>2]|0;if((s|0)==-1){u=r+(c[l+32>>2]<<3)|0;break}else{u=r+(s<<3)|0;break}}else u=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((u|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(c[u+4>>2]|0)!=0:0)break}if(!(hQb(t)|0)){q=0;i=h;return q|0}}while(0);ko[c[(c[m>>2]|0)+24>>2]&4095](m);ko[c[(c[m>>2]|0)+28>>2]&4095](m);if((d|0)==4|(d|0)==224)JTb(b,p,1)|0;In[c[(c[m>>2]|0)+12>>2]&4095](m,4);q=m;i=h;return q|0}function qQc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;j=i;i=i+208|0;k=j;l=j+124|0;m=j+16|0;n=j+76|0;o=j+40|0;p=j+52|0;q=j+64|0;r=j+28|0;s=j+88|0;t=j+100|0;u=j+112|0;v=j+128|0;w=j+140|0;x=j+152|0;y=j+164|0;z=j+176|0;A=j+180|0;B=j+184|0;C=j+196|0;D=(da(c[137788]|0,d)|0)+2|0;E=D>>5;if(!(1<<D-(E<<5)&c[(c[137786]|0)+(E<<2)>>2])){if(!h){F=0;i=j;return F|0}E=EQb(d)|0;if(!(a[E>>0]&1))G=E+1|0;else G=c[E+8>>2]|0;c[k>>2]=G;Lsd(t,602656,k);yri(h,t)|0;xri(t);F=0;i=j;return F|0}t=tTb(b,d)|0;if(t){if(!h){F=0;i=j;return F|0}G=EQb(d)|0;if(!(a[G>>0]&1))H=G+1|0;else H=c[G+8>>2]|0;G=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;E=EQb((c[t+8>>2]|0)>>>21)|0;if(!(a[E>>0]&1))I=E+1|0;else I=c[E+8>>2]|0;c[k>>2]=H;c[k+4>>2]=G;c[k+8>>2]=I;Lsd(u,603912,k);yri(h,u)|0;xri(u);F=0;i=j;return F|0}u=g+8|0;a:do if(((c[u>>2]|0)!=0?(I=SPc(d)|0,G=c[I>>2]|0,H=c[I+4>>2]|0,(G|0)!=(H|0)):0)?(I=c[g>>2]|0,E=c[u>>2]|0,(E|0)!=0):0){t=I+(E<<3)|0;E=c[137788]|0;D=c[137786]|0;J=I;b:while(1){I=da(c[J>>2]|0,E)|0;K=G;do{L=c[K>>2]|0;M=L+I|0;N=M>>5;K=K+4|0;if(1<<M-(N<<5)&c[D+(N<<2)>>2]){O=L;break b}}while((K|0)!=(H|0));J=J+8|0;if((J|0)==(t|0))break a}if((O|0)>-1){if(!h){F=0;i=j;return F|0}t=EQb(d)|0;if(!(a[t>>0]&1))P=t+1|0;else P=c[t+8>>2]|0;t=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;J=EQb(O)|0;if(!(a[J>>0]&1))Q=J+1|0;else Q=c[J+8>>2]|0;c[k>>2]=P;c[k+4>>2]=t;c[k+8>>2]=Q;Lsd(v,604008,k);yri(h,v)|0;xri(v);F=0;i=j;return F|0}}while(0);if(!((sTb(b,d)|0)!=0?!(TPc(d)|0):0))R=35;if((R|0)==35?(tTb(b,d)|0)==0:0){if((c[b+8>>2]&1179648|0)==1179648){if(!h){F=0;i=j;return F|0}v=EQb(d)|0;if(!(a[v>>0]&1))S=v+1|0;else S=c[v+8>>2]|0;v=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;c[k>>2]=S;c[k+4>>2]=v;Lsd(x,604192,k);yri(h,x)|0;xri(x);F=0;i=j;return F|0}if(a[(xQb(d)|0)+28>>0]|0){x=EQb(d)|0;if(!(a[x>>0]&1))T=x+1|0;else T=c[x+8>>2]|0;x=EQb(d)|0;if(!(a[x>>0]&1))U=x+1|0;else U=c[x+8>>2]|0;c[k>>2]=T;c[k+4>>2]=U;Lsd(y,604328,k);yri(h,y)|0;xri(y);F=0;i=j;return F|0}y=(c[u>>2]|0)+1|0;c[u>>2]=y;U=g+12|0;T=c[U>>2]|0;x=T&2147483647;if(y>>>0>x>>>0){v=T<<1;S=(v|0)==0?1:v;do if(x>>>0<S>>>0)if((T|0)>-1){c[U>>2]=S;v=c[g>>2]|0;c[l>>2]=c[g+4>>2];c[k+0>>2]=c[l+0>>2];c[g>>2]=hOb(v,S<<3,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[g+4>>2];c[k+0>>2]=c[l+0>>2];v=cOb(S<<3,4,k,0,3653512,352)|0;YEi(v|0,c[g>>2]|0,c[u>>2]<<3|0)|0;c[U>>2]=S;c[g>>2]=v;break}while(0);V=c[u>>2]|0}else V=y;y=e;S=(c[g>>2]|0)+(V+-1<<3)|0;c[S>>2]=d;c[S+4>>2]=y;S=QPc(d)|0;V=c[S>>2]|0;U=S+4|0;c:do if((V|0)!=(c[U>>2]|0)){S=V;d:while(1){e:do if(!(sTb(b,c[S>>2]|0)|0)){T=c[S>>2]|0;x=c[g>>2]|0;v=c[u>>2]|0;Q=x+(v<<3)|0;if(v){v=c[137788]|0;P=c[137786]|0;O=x;do{x=(da(c[O>>2]|0,v)|0)+T|0;t=x>>5;O=O+8|0;if(1<<x-(t<<5)&c[P+(t<<2)>>2])break e}while((O|0)!=(Q|0))}if(!(_Pc(b,T,h)|0)){F=0;R=129;break d}if(!(qQc(b,c[S>>2]|0,0,f,g,h)|0)){F=0;R=129;break d}}while(0);S=S+4|0;if((S|0)==(c[U>>2]|0))break c}if((R|0)==129){i=j;return F|0}}while(0);f:do if((d|0)==114){U=aad((Xbd()|0)+24|0,e)|0;if((U|0)!=0?(V=had(U)|0,(V|0)!=0):0){S=(h|0)!=0;if((V|0)==-3){if(!S){F=0;i=j;return F|0}c[k>>2]=mo[c[(c[U>>2]|0)+32>>2]&4095](U)|0;Lsd(m,604656,k);yri(h,m)|0;xri(m);F=0;i=j;return F|0}if(!S){F=0;i=j;return F|0}if(a[U+112>>0]|0){c[k>>2]=mo[c[(c[U>>2]|0)+32>>2]&4095](U)|0;Lsd(n,604776,k);yri(h,n)|0;xri(n);F=0;i=j;return F|0}if((V|0)==-1){c[k>>2]=mo[c[(c[U>>2]|0)+32>>2]&4095](U)|0;Lsd(o,604904,k);yri(h,o)|0;xri(o);F=0;i=j;return F|0}else if((V|0)==-4){c[k>>2]=mo[c[(c[U>>2]|0)+32>>2]&4095](U)|0;Lsd(p,605024,k);yri(h,p)|0;xri(p);F=0;i=j;return F|0}else if((V|0)!=-5){S=mo[c[(c[U>>2]|0)+32>>2]&4095](U)|0;if((V|0)==-6){c[k>>2]=S;Lsd(r,605168,k);yri(h,r)|0;xri(r);F=0;i=j;return F|0}else{c[k>>2]=S;Lsd(s,605248,k);yri(h,s)|0;xri(s);F=0;i=j;return F|0}}else{c[k>>2]=mo[c[(c[U>>2]|0)+32>>2]&4095](U)|0;Lsd(q,605096,k);yri(h,q)|0;xri(q);F=0;i=j;return F|0}}c[z>>2]=0;c[A>>2]=0;if(!($Pc(b,e,z,A)|0)){if(!h){F=0;i=j;return F|0}S=c[z>>2]|0;V=c[A>>2]|0;Q=mo[c[(c[U>>2]|0)+100>>2]&4095](U)|0;if(!(a[Q>>0]&1))W=Q+1|0;else W=c[Q+8>>2]|0;Q=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;U=ksc(V)|0;if((S|0)==(V|0)){c[k>>2]=W;c[k+4>>2]=Q;c[k+8>>2]=U;Lsd(B,604448,k);yri(h,B)|0;xri(B);F=0;i=j;return F|0}else{V=ksc(S)|0;c[k>>2]=W;c[k+4>>2]=Q;c[k+8>>2]=U;c[k+12>>2]=V;Lsd(C,604528,k);yri(h,C)|0;xri(C);F=0;i=j;return F|0}}V=U9c(e)|0;if((V|0)!=0?(yrc(V)|0)>0:0){U=b+32|0;Q=b+24|0;S=0;g:while(1){O=Src(V,S)|0;h:do if(O){P=ssc(O)|0;if(!((P|0)==0|(c[u>>2]|0)==0)){v=0;do{t=c[g>>2]|0;x=c[t+(v<<3)+4>>2]|0;if(!x){J=Atc()|0;H=Sbd(J,c[t+(v<<3)>>2]|0)|0;if(H){X=H;R=101}}else{X=x;R=101}if((R|0)==101){R=0;if((X|0)==(P|0))break h;if(msc(X,P)|0)break h}v=v+1|0}while(v>>>0<(c[u>>2]|0)>>>0)}if((c[U>>2]|0)>0){v=(P|0)!=0;T=0;do{x=c[(c[Q>>2]|0)+(T<<3)+4>>2]|0;H=(c[x+8>>2]|0)>>>21;t=(da(c[137788]|0,H)|0)+114|0;J=t>>5;if(!(1<<t-(J<<5)&c[(c[137786]|0)+(J<<2)>>2]))Y=Sbd(Atc()|0,H)|0;else Y=m9c(x)|0;if((Y|0)!=0&v){if((Y|0)==(P|0))break h;if(msc(Y,P)|0)break h}T=T+1|0}while((T|0)<(c[U>>2]|0))}do if(!(Gsd(lsc(P)|0,3516216)|0)){T=FQb(ksc(P)|0)|0;if((T|0)==-1){R=116;break}v=(da(c[137788]|0,T)|0)+2|0;x=v>>5;if(1<<v-(x<<5)&c[(c[137786]|0)+(x<<2)>>2]){Z=T;_=0}else R=116}else R=116;while(0);if((R|0)==116){R=0;T=aad((Xbd()|0)+24|0,P)|0;if(!T)break;else{Z=114;_=T}}if(!(_Pc(b,Z,h)|0)){F=0;R=129;break g}if(!_)$=0;else $=gad(_)|0;if(!(qQc(b,Z,$,f,g,h)|0)){F=0;R=129;break g}}while(0);S=S+1|0;if((S|0)>=(yrc(V)|0))break f}if((R|0)==129){i=j;return F|0}}}while(0);R=f+8|0;g=(c[R>>2]|0)+1|0;c[R>>2]=g;$=f+12|0;Z=c[$>>2]|0;_=Z&2147483647;if(g>>>0>_>>>0){Y=Z<<1;u=(Y|0)==0?1:Y;do if(_>>>0<u>>>0)if((Z|0)>-1){c[$>>2]=u;Y=c[f>>2]|0;c[l>>2]=c[f+4>>2];c[k+0>>2]=c[l+0>>2];c[f>>2]=hOb(Y,u<<3,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[f+4>>2];c[k+0>>2]=c[l+0>>2];Y=cOb(u<<3,4,k,0,3653512,352)|0;YEi(Y|0,c[f>>2]|0,c[R>>2]<<3|0)|0;c[$>>2]=u;c[f>>2]=Y;break}while(0);aa=c[R>>2]|0}else aa=g;g=(c[f>>2]|0)+(aa+-1<<3)|0;c[g>>2]=d;c[g+4>>2]=y;F=1;i=j;return F|0}if(!h){F=0;i=j;return F|0}y=EQb(d)|0;if(!(a[y>>0]&1))ba=y+1|0;else ba=c[y+8>>2]|0;y=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;c[k>>2]=ba;c[k+4>>2]=y;Lsd(w,604096,k);yri(h,w)|0;xri(w);F=0;i=j;return F|0}function rQc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+12|0;j=e;k=(da(c[137788]|0,(c[d+8>>2]|0)>>>21)|0)+114|0;l=k>>5;if(!(1<<k-(l<<5)&c[(c[137786]|0)+(l<<2)>>2])){sri(b,GQb(d)|0);i=e;return}A9c(j,d);d=a[j>>0]|0;if(!(d&1)){m=j+1|0;n=(d&255)>>>1}else{m=c[j+8>>2]|0;n=c[j+4>>2]|0}rri(h,m,n);Osd(b,h,603896);xri(h);if(!(a[j>>0]&1)){i=e;return}h=c[j+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(h,f);i=e;return}function sQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}sQc(a,c[b>>2]|0);sQc(a,c[b+4>>2]|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function tQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;b=a+8|0;h=(c[b>>2]|0)+1|0;c[b>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[b>>2]<<2|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[b>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}function uQc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(a[b+49>>0]|0){Krd(603696,0,3653512,1240,1,c[b+4>>2]|0,0,0);i=e;return}PTb(b);pTb(b);c[d>>2]=(c[b+32>>2]|0)+1+(c[d>>2]|0);f=BTb(b)|0;if(!f){i=e;return}b=f+140|0;g=f+148|0;if(!(c[g>>2]|0)){i=e;return}f=c[b>>2]|0;do{uQc(c[(c[f>>2]|0)+24>>2]|0,d);f=f+4|0}while((f|0)!=((c[b>>2]|0)+(c[g>>2]<<2)|0));i=e;return}function vQc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=BTb(b)|0;g=(f|0)!=0;if(g?(h=f+140|0,j=f+148|0,(c[j>>2]|0)!=0):0){k=c[h>>2]|0;do{vQc(c[(c[k>>2]|0)+24>>2]|0,d);k=k+4|0}while((k|0)!=((c[h>>2]|0)+(c[j>>2]<<2)|0))}if(a[b+49>>0]|0){if(g)kGc(f,1);Krd(603696,0,3653512,1223,1,c[b+4>>2]|0,0,0);i=e;return}f=b+32|0;if((c[f>>2]|0)>0){g=b+24|0;j=d+4|0;h=0;do{k=c[(c[g>>2]|0)+(h<<3)+4>>2]|0;if(c[k+8>>2]&1048576){l=kfd()|0;Oed(l,c[k+4>>2]|0,1)}l=c[j>>2]|0;if((l|0)==(c[d>>2]|0)){yQc(d);xQc(d,256);m=c[j>>2]|0}else m=l;c[j>>2]=m+1;c[d+(m<<2)+8>>2]=k;h=h+1|0}while((h|0)<(c[f>>2]|0))}if(c[b+8>>2]&1048576){f=kfd()|0;Oed(f,c[b+4>>2]|0,1)}f=d+4|0;h=c[f>>2]|0;if((h|0)==(c[d>>2]|0)){yQc(d);xQc(d,256);n=c[f>>2]|0}else n=h;c[f>>2]=n+1;c[d+(n<<2)+8>>2]=b;i=e;return}function wQc(){var b=0;b=i;if((a[605384]|0)==0?(cj(605392)|0)!=0:0)a[605384]=1;i=b;return}function xQc(a,b){a=a|0;b=b|0;c[a>>2]=b>>>0>256?256:b;c[a+4>>2]=0;return}function yQc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if(!e){i=b;return}else{f=e;g=0}while(1){e=c[a+(g<<2)+8>>2]|0;if(!e)h=f;else{qQb(e);TQb(e);h=c[d>>2]|0}g=g+1|0;if(g>>>0>=h>>>0)break;else f=h}i=b;return}function zQc(){return}function AQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+1056|0;e=d+1040|0;f=d+1032|0;g=d;if(!b){i=d;return}h=g+4|0;j=b;b=a;while(1){a=j>>>0>256?256:j;c[g>>2]=a;c[h>>2]=0;if(a){a=c[137784]|0;k=0;while(1){c[f>>2]=c[b+(k<<2)>>2];if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(e,a,f);l=c[e>>2]|0;m=c[a+28>>2]|0;if((l|0)==-1){n=m+(c[a+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);l=c[137784]|0;if((n|0)==((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)){o=0;p=l}else{o=c[n+4>>2]|0;p=l}}else{o=0;p=0}c[g+(k<<2)+8>>2]=o;k=k+1|0;l=c[g>>2]|0;if(k>>>0>=l>>>0){q=l;break}else a=p}c[h>>2]=q;if(!q)r=0;else{a=0;do{k=c[g+(a<<2)+8>>2]|0;if(k){qQb(k);TQb(k)}a=a+1|0}while(a>>>0<q>>>0);r=q}}else{c[h>>2]=0;r=0}if((j|0)==(r|0))break;else{j=j-r|0;b=b+(r<<2)|0}}i=d;return}function BQc(b){b=b|0;var d=0,e=0,f=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,fa=0,ga=0,ia=0,ja=0,ka=0.0,la=0.0,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=Im,mb=Im,nb=0.0,ob=0,pb=0,qb=0.0,rb=0.0,sb=Im,tb=Im,ub=0.0,vb=0,wb=0,xb=0.0,yb=0.0,zb=Im,Ab=Im,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0.0,Ib=Im,Jb=Im,Kb=0.0,Lb=0.0,Mb=Im,Nb=Im,Ob=0.0,Pb=0.0,Qb=0,Rb=0,Sb=0,Tb=0;d=i;i=i+240|0;e=d;f=d+236|0;j=d+160|0;l=d+144|0;m=d+136|0;n=d+40|0;o=+Ki()*1.0e6;p=~~o>>>0;q=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;r=c[137784]|0;s=(c[r+36>>2]|0)-(c[r+4>>2]|0)|0;r=c[153134]|0;c[n>>2]=0;t=n+4|0;c[t>>2]=r;r=n+8|0;c[r>>2]=0;u=n+12|0;c[u>>2]=0;c[n+16>>2]=0;v=n+24|0;c[v>>2]=0;w=n+28|0;c[w>>2]=0;x=n+20|0;c[x>>2]=60;c[n+40>>2]=0;y=n+44|0;a[y>>0]=0;z=n+45|0;a[z>>0]=0;A=n+48|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;A=n+68|0;c[A>>2]=32;B=n+72|0;c[B>>2]=0;c[n+80>>2]=16;c[n+76>>2]=6;C=n+84|0;a[C>>0]=0;D=n+92|0;a[D>>0]=b&1;b=n+88|0;c[b>>2]=s;o=+Ki()*1.0e6;E=~~o>>>0;F=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;G=c[137784]|0;I=G+4|0;J=(c[G+36>>2]|0)-(c[I>>2]|0)|0;c[b>>2]=J;c[r>>2]=J;K=c[u>>2]|0;do if((K&2147483647)>>>0<J>>>0)if((K|0)>-1){c[u>>2]=J;L=c[n>>2]|0;c[f>>2]=c[t>>2];c[e+0>>2]=c[f+0>>2];c[n>>2]=hOb(L,J<<3,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[t>>2];c[e+0>>2]=c[f+0>>2];L=cOb(J<<3,4,e,0,3653512,352)|0;YEi(L|0,c[n>>2]|0,c[r>>2]<<3|0)|0;c[u>>2]=J;c[n>>2]=L;break}while(0);J=c[G+28>>2]|0;K=c[G+32>>2]|0;L=J+(K<<3)|0;a:do if(!K){M=J;N=12}else{O=c[G+20>>2]|0;P=G+8|0;Q=G+12|0;T=J;do{U=c[T>>2]|0;if((O|0)!=(U|0)){if(!(a[P>>0]|0)){M=T;N=12;break a}if(!(c[I>>2]|0)){M=T;N=12;break a}if((c[Q>>2]|0)!=(U|0)){M=T;N=12;break a}}T=T+8|0}while((T|0)!=(L|0))}while(0);b:do if((N|0)==12?(I=c[n>>2]|0,(M|0)!=(L|0)):0){J=M;G=0;while(1){K=J;while(1){T=K;K=K+8|0;if((c[T>>2]|0)>>>0<=4294967293){V=K;W=T;break}if((K|0)==(L|0))break b}K=c[W+4>>2]|0;c[I+(G<<3)>>2]=K;T=K+8|0;K=I+(G<<3)+4|0;Q=c[K>>2]&-1073741824|(c[T>>2]|0)>>>21;c[K>>2]=Q;P=Q&-2147481601|c[T>>2]<<10&1073741824;c[K>>2]=P;c[K>>2]=P&1073743871|c[T>>2]<<12&-2147483648;if((V|0)==(L|0))break;else{J=V;G=G+1|0}}}while(0);V=c[r>>2]|0;L=c[n>>2]|0;W=n+16|0;M=c[w>>2]|0;do if((M&2147483647)>>>0<V>>>0)if((M|0)>-1){c[w>>2]=V;G=c[W>>2]|0;c[f>>2]=c[x>>2];c[e+0>>2]=c[f+0>>2];c[W>>2]=hOb(G,V<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[x>>2];c[e+0>>2]=c[f+0>>2];G=cOb(V<<2,4,e,0,3653512,352)|0;YEi(G|0,c[W>>2]|0,c[v>>2]<<2|0)|0;c[w>>2]=V;c[W>>2]=G;break}while(0);c:do if((V|0)>0){M=0;G=V;while(1){J=L+(M<<3)|0;I=L+(M<<3)+4|0;T=G;d:while(1){P=c[I>>2]|0;K=P&536870911;do if(!(P&1073741824)){if((K|0)==114){X=P;Y=T;N=26;break d}else if((K|0)==4|(K|0)==1)break;Q=(da(c[137788]|0,K)|0)+2|0;O=Q>>5;if(1<<Q-(O<<5)&c[(c[137786]|0)+(O<<2)>>2]){Z=T;N=31;break d}else N=28}else N=28;while(0);if((N|0)==28?(N=0,(K|0)!=142):0){_=P;$=T;N=29;break}O=T+-1|0;Q=L+(O<<3)|0;U=c[Q+4>>2]|0;aa=J;c[aa>>2]=c[Q>>2];c[aa+4>>2]=U;if((M|0)<(O|0))T=O;else{ba=O;break c}}if((N|0)==26){N=0;if(!(c[(c[J>>2]|0)+24>>2]|0)){_=X;$=Y;N=29}else{Z=Y;N=31}}if((N|0)==29){N=0;if(!(_>>31&2))fa=$;else{Z=$;N=31}}e:do if((N|0)==31){N=0;T=(c[n>>2]|0)+(M<<3)+4|0;I=c[T>>2]|0;c[T>>2]=I|536870912;switch(I&536870911|0){case 78:case 27:case 28:case 43:case 84:case 89:case 115:case 117:case 142:case 147:case 149:case 150:case 158:case 171:{fa=Z;break e;break}default:{}}I=(c[v>>2]|0)+1|0;c[v>>2]=I;T=c[w>>2]|0;O=T&2147483647;if(I>>>0>O>>>0){U=T<<1;aa=(U|0)==0?1:U;do if(O>>>0<aa>>>0)if((T|0)>-1){c[w>>2]=aa;U=c[W>>2]|0;c[f>>2]=c[x>>2];c[e+0>>2]=c[f+0>>2];c[W>>2]=hOb(U,aa<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[x>>2];c[e+0>>2]=c[f+0>>2];U=cOb(aa<<2,4,e,0,3653512,352)|0;YEi(U|0,c[W>>2]|0,c[v>>2]<<2|0)|0;c[w>>2]=aa;c[W>>2]=U;break}while(0);ga=c[v>>2]|0}else ga=I;c[(c[W>>2]|0)+(ga+-1<<2)>>2]=M;fa=Z}while(0);M=M+1|0;if((M|0)>=(fa|0)){ba=fa;break}else G=fa}}else ba=V;while(0);c[r>>2]=ba;V=c[u>>2]|0;do if((V&2147483647)>>>0<ba>>>0)if((V|0)>-1){c[u>>2]=ba;fa=c[n>>2]|0;c[f>>2]=c[t>>2];c[e+0>>2]=c[f+0>>2];c[n>>2]=hOb(fa,ba<<3,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[t>>2];c[e+0>>2]=c[f+0>>2];fa=cOb(ba<<3,4,e,0,3653512,352)|0;YEi(fa|0,c[n>>2]|0,c[r>>2]<<3|0)|0;c[u>>2]=ba;c[n>>2]=fa;break}while(0);o=+Ki()*1.0e6;ba=ZEi(~~o>>>0|0,(+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0)|0,E|0,F|0)|0;F=H;o=+Ki()*1.0e6;E=~~o>>>0;u=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;a[z>>0]=1;z=n+56|0;t=z;c[t>>2]=-1;c[t+4>>2]=0;t=c[A>>2]<<3;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];V=cOb(t,16,e,0,3653512,80)|0;c[n+64>>2]=V;t=V+(c[A>>2]<<3)|0;if((V|0)!=(t|0)){A=V;do{if(A){V=z;fa=c[V+4>>2]|0;Z=A;c[Z>>2]=c[V>>2];c[Z+4>>2]=fa}A=A+8|0}while((A|0)!=(t|0))}t=n+36|0;HQc(t);a[y>>0]=1;y=n+48|0;c[y>>2]=-2;c[y+4>>2]=0;y=c[r>>2]<<1;if((a[C>>0]|0)!=0|(y|0)==0)IQc(t);C=c[B>>2]|0;if(y>>>0>C>>>0)JQc(t,y-C|0,0);C=c[r>>2]|0;if(C){y=j+4|0;B=C;C=0;while(1){A=c[n>>2]|0;if(!(c[A+(C<<3)+4>>2]&536870912)){c[j>>2]=c[(c[A+(C<<3)>>2]|0)+4>>2];c[y>>2]=C;KQc(l,t,j);ia=c[r>>2]|0}else ia=B;C=C+1|0;if(C>>>0>=ia>>>0)break;else B=ia}}o=+Ki()*1.0e6;ia=ZEi(~~o>>>0|0,(+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0)|0,E|0,u|0)|0;u=H;o=+Ki()*1.0e6;E=~~o>>>0;B=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;C=0;do{if(tVb(C)|0)CQc(c[(tVb(C)|0)+4>>2]|0,n);C=C+1|0}while((C|0)!=21);C=j+4|0;c[C>>2]=n;t=j+8|0;c[t>>2]=0;y=j+16|0;c[y>>2]=0;A=j+20|0;c[A>>2]=0;z=j+12|0;c[z>>2]=60;hdd(j+32|0,33562624,0);fa=j+68|0;c[fa>>2]=605736;c[j+72>>2]=j;c[j+44>>2]=fa;fa=j+24|0;c[fa>>2]=0;Z=j+28|0;g[Z>>2]=ea(0.0);V=c[(c[C>>2]|0)+8>>2]|0;ga=j+8|0;W=c[A>>2]|0;do if((W&2147483647)>>>0<V>>>0)if((W|0)>-1){c[A>>2]=V;w=c[ga>>2]|0;c[f>>2]=c[z>>2];c[e+0>>2]=c[f+0>>2];c[ga>>2]=hOb(w,V<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[z>>2];c[e+0>>2]=c[f+0>>2];w=cOb(V<<2,4,e,0,3653512,352)|0;YEi(w|0,c[ga>>2]|0,c[y>>2]<<2|0)|0;c[A>>2]=V;c[ga>>2]=w;break}while(0);if(a[(c[C>>2]|0)+92>>0]|0)c[j>>2]=ftc(Sbd(Xbd()|0,0)|0,V,1819,j)|0;c[n+32>>2]=c[v>>2];if(a[D>>0]|0)fOb()|0;if(a[(c[C>>2]|0)+92>>0]|0)itc(c[j>>2]|0);o=+Ki()*1.0e6;v=c[C>>2]|0;V=v+32|0;c[V>>2]=(c[V>>2]|0)+-1;ga=v+16|0;while(1){v=c[V>>2]|0;if((v|0)>-1){GQc(j,c[(c[ga>>2]|0)+(v<<2)>>2]|0);c[fa>>2]=(c[fa>>2]|0)+1;v=c[y>>2]|0;if(v){ja=v;N=75}}else{v=c[y>>2]|0;if(!v)break;else{ja=v;N=75}}if((N|0)==75)while(1){N=0;v=ja+-1|0;W=c[(c[t>>2]|0)+(v<<2)>>2]|0;c[y>>2]=v;GQc(j,W);ja=c[y>>2]|0;if(!ja)break;else N=75}c[V>>2]=(c[V>>2]|0)+-1}ka=+Ki();V=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;la=ka*1.0e6;N=ZEi(~~la>>>0|0,(+S(la)>=1.0?(la>0.0?(ha(+R(la/4294967296.0),4294967295.0)|0)>>>0:~~+ca((la-+(~~la>>>0))/4294967296.0)>>>0):0)|0,~~o>>>0|0,V|0)|0;V=Ycd(N,H)|0;ma=ea((+(V>>>0)+4294967296.0*+(H>>>0))*1.0e-09);g[Z>>2]=ea(ma+ea(g[Z>>2]));if(a[D>>0]|0)fOb()|0;if(a[(c[C>>2]|0)+92>>0]|0)gtc(c[j>>2]|0);C=c[j+48>>2]|0;if(C){D=j+52|0;Z=c[D>>2]|0;if((Z|0)!=(C|0))c[D>>2]=Z+(~((Z+-4-C|0)>>>2)<<2);c[m>>2]=89;c[e+0>>2]=c[m+0>>2];eOb(C,e)}if((c[A>>2]|0)>-1){A=c[t>>2]|0;c[f>>2]=c[z>>2];c[e+0>>2]=c[f+0>>2];eOb(A,e);c[t>>2]=0}o=+Ki()*1.0e6;t=ZEi(~~o>>>0|0,(+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0)|0,E|0,B|0)|0;B=H;E=c[137784]|0;if((c[b>>2]|0)!=((c[E+36>>2]|0)-(c[E+4>>2]|0)|0))Krd(605432,0,3653512,259,1,0,0,0);o=+Ki()*1.0e6;E=~~o>>>0;b=+S(o)>=1.0?(o>0.0?(ha(+R(o/4294967296.0),4294967295.0)|0)>>>0:~~+ca((o-+(~~o>>>0))/4294967296.0)>>>0):0;A=c[r>>2]|0;do if(!A){na=0;oa=0;pa=0;qa=0;ra=0}else{c[f>>2]=60;c[e+0>>2]=c[f+0>>2];z=hOb(0,A<<2,4,e,0,3653512,370)|0;C=c[r>>2]|0;if(!C){na=0;oa=z;pa=0;qa=0;ra=A;break}c[f>>2]=60;c[e+0>>2]=c[f+0>>2];m=hOb(0,C<<2,4,e,0,3653512,370)|0;if(!(c[r>>2]|0)){na=0;oa=z;pa=C;qa=m;ra=A;break}Z=0;D=A;V=z;z=0;N=C;C=m;m=0;while(1){ja=c[n>>2]|0;y=ja+(m<<3)+4|0;do if(!(c[y>>2]&536870912)){fa=c[(c[ja+(m<<3)>>2]|0)+4>>2]|0;ga=Z+1|0;W=D&2147483647;do if(ga>>>0>W>>>0){v=D<<1;w=(v|0)==0?1:v;if(W>>>0>=w>>>0){sa=V;ta=D;break}if((D|0)>-1){c[f>>2]=60;c[e+0>>2]=c[f+0>>2];sa=hOb(V,w<<2,4,e,0,3653512,370)|0;ta=w;break}else{c[f>>2]=60;c[e+0>>2]=c[f+0>>2];v=cOb(w<<2,4,e,0,3653512,352)|0;YEi(v|0,V|0,ga<<2|0)|0;sa=v;ta=w;break}}else{sa=V;ta=D}while(0);c[sa+(Z<<2)>>2]=fa;if((c[y>>2]&536870911|0)!=114){ua=ta;va=ga;wa=sa;xa=N;ya=z;za=C;break}W=z+1|0;I=N&2147483647;do if(W>>>0>I>>>0){w=N<<1;v=(w|0)==0?1:w;if(I>>>0>=v>>>0){Aa=C;Ba=N;break}if((N|0)>-1){c[f>>2]=60;c[e+0>>2]=c[f+0>>2];Aa=hOb(C,v<<2,4,e,0,3653512,370)|0;Ba=v;break}else{c[f>>2]=60;c[e+0>>2]=c[f+0>>2];w=cOb(v<<2,4,e,0,3653512,352)|0;YEi(w|0,C|0,W<<2|0)|0;Aa=w;Ba=v;break}}else{Aa=C;Ba=N}while(0);c[Aa+(z<<2)>>2]=fa;ua=ta;va=ga;wa=sa;xa=Ba;ya=W;za=Aa}else{ua=D;va=Z;wa=V;xa=N;ya=z;za=C}while(0);m=m+1|0;if(m>>>0>=(c[r>>2]|0)>>>0){Ca=ua;Da=va;Ea=wa;Fa=xa;Ga=ya;Ha=za;break}else{Z=va;D=ua;V=wa;z=ya;N=xa;C=za}}if((Ga|0)<=0){na=Da;oa=Ea;pa=Fa;qa=Ha;ra=Ca;break}C=0;do{c[f>>2]=c[Ha+(C<<2)>>2];N=c[137784]|0;do if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,f);z=c[e>>2]|0;V=c[N+28>>2]|0;if((z|0)==-1){Ia=V+(c[N+32>>2]<<3)|0;break}else{Ia=V+(z<<3)|0;break}}else Ia=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);W=c[137784]|0;if((Ia|0)==((c[W+28>>2]|0)+(c[W+32>>2]<<3)|0))break;W=c[Ia+4>>2]|0;if(!W)break;h9c(W)|0}while(0);C=C+1|0}while((C|0)!=(Ga|0));na=Da;oa=Ea;pa=Fa;qa=Ha;ra=Ca}while(0);AQc(oa,na);if((pa|0)>-1){c[j>>2]=60;c[e+0>>2]=c[j+0>>2];eOb(qa,e)}if((ra|0)<=-1){Ja=+Ki();Ka=Ja*1.0e6;La=~~Ka>>>0;Ma=+S(Ka)>=1.0?(Ka>0.0?(ha(+R(Ka/4294967296.0),4294967295.0)|0)>>>0:~~+ca((Ka-+(~~Ka>>>0))/4294967296.0)>>>0):0;Na=ZEi(La|0,Ma|0,E|0,b|0)|0;Oa=H;Pa=c[137784]|0;Qa=Pa+36|0;Ra=c[Qa>>2]|0;Sa=Pa+4|0;Ta=c[Sa>>2]|0;Ua=+Ki();Va=s-Ra|0;Wa=Va+Ta|0;Xa=c[137784]|0;Ya=Xa+36|0;Za=c[Ya>>2]|0;_a=Xa+4|0;$a=c[_a>>2]|0;ab=Za-$a|0;c[e>>2]=Wa;bb=e+4|0;c[bb>>2]=ab;Ird(605536,e);cb=Ua*1.0e6;db=~~cb>>>0;eb=+S(cb)>=1.0?(cb>0.0?(ha(+R(cb/4294967296.0),4294967295.0)|0)>>>0:~~+ca((cb-+(~~cb>>>0))/4294967296.0)>>>0):0;fb=ZEi(db|0,eb|0,p|0,q|0)|0;gb=H;hb=Ycd(fb,gb)|0;ib=H;jb=+(hb>>>0)+4294967296.0*+(ib>>>0);kb=jb*1.0e-09;lb=ea(kb);mb=ea(lb*ea(1.0e3));nb=+mb;ob=Ycd(ba,F)|0;pb=H;qb=+(ob>>>0)+4294967296.0*+(pb>>>0);rb=qb*1.0e-09;sb=ea(rb);tb=ea(sb*ea(1.0e3));ub=+tb;vb=Ycd(ia,u)|0;wb=H;xb=+(vb>>>0)+4294967296.0*+(wb>>>0);yb=xb*1.0e-09;zb=ea(yb);Ab=ea(zb*ea(1.0e3));Bb=+Ab;Cb=Ycd(t,B)|0;Db=H;Eb=Ycd(Na,Oa)|0;Fb=H;Gb=+(Cb>>>0)+4294967296.0*+(Db>>>0);Hb=Gb*1.0e-09;Ib=ea(Hb);Jb=ea(Ib*ea(1.0e3));Kb=+(Eb>>>0)+4294967296.0*+(Fb>>>0);Lb=Kb*1.0e-09;Mb=ea(Lb);Nb=ea(Mb*ea(1.0e3));Ob=+Jb;Pb=+Nb;h[k>>3]=nb;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Qb=e+8|0;h[k>>3]=ub;c[Qb>>2]=c[k>>2];c[Qb+4>>2]=c[k+4>>2];Rb=e+16|0;h[k>>3]=Bb;c[Rb>>2]=c[k>>2];c[Rb+4>>2]=c[k+4>>2];Sb=e+24|0;h[k>>3]=Ob;c[Sb>>2]=c[k>>2];c[Sb+4>>2]=c[k+4>>2];Tb=e+32|0;h[k>>3]=Pb;c[Tb>>2]=c[k>>2];c[Tb+4>>2]=c[k+4>>2];Ird(605616,e);MQc(n);i=d;return}c[l>>2]=60;c[e+0>>2]=c[l+0>>2];eOb(oa,e);Ja=+Ki();Ka=Ja*1.0e6;La=~~Ka>>>0;Ma=+S(Ka)>=1.0?(Ka>0.0?(ha(+R(Ka/4294967296.0),4294967295.0)|0)>>>0:~~+ca((Ka-+(~~Ka>>>0))/4294967296.0)>>>0):0;Na=ZEi(La|0,Ma|0,E|0,b|0)|0;Oa=H;Pa=c[137784]|0;Qa=Pa+36|0;Ra=c[Qa>>2]|0;Sa=Pa+4|0;Ta=c[Sa>>2]|0;Ua=+Ki();Va=s-Ra|0;Wa=Va+Ta|0;Xa=c[137784]|0;Ya=Xa+36|0;Za=c[Ya>>2]|0;_a=Xa+4|0;$a=c[_a>>2]|0;ab=Za-$a|0;c[e>>2]=Wa;bb=e+4|0;c[bb>>2]=ab;Ird(605536,e);cb=Ua*1.0e6;db=~~cb>>>0;eb=+S(cb)>=1.0?(cb>0.0?(ha(+R(cb/4294967296.0),4294967295.0)|0)>>>0:~~+ca((cb-+(~~cb>>>0))/4294967296.0)>>>0):0;fb=ZEi(db|0,eb|0,p|0,q|0)|0;gb=H;hb=Ycd(fb,gb)|0;ib=H;jb=+(hb>>>0)+4294967296.0*+(ib>>>0);kb=jb*1.0e-09;lb=ea(kb);mb=ea(lb*ea(1.0e3));nb=+mb;ob=Ycd(ba,F)|0;pb=H;qb=+(ob>>>0)+4294967296.0*+(pb>>>0);rb=qb*1.0e-09;sb=ea(rb);tb=ea(sb*ea(1.0e3));ub=+tb;vb=Ycd(ia,u)|0;wb=H;xb=+(vb>>>0)+4294967296.0*+(wb>>>0);yb=xb*1.0e-09;zb=ea(yb);Ab=ea(zb*ea(1.0e3));Bb=+Ab;Cb=Ycd(t,B)|0;Db=H;Eb=Ycd(Na,Oa)|0;Fb=H;Gb=+(Cb>>>0)+4294967296.0*+(Db>>>0);Hb=Gb*1.0e-09;Ib=ea(Hb);Jb=ea(Ib*ea(1.0e3));Kb=+(Eb>>>0)+4294967296.0*+(Fb>>>0);Lb=Kb*1.0e-09;Mb=ea(Lb);Nb=ea(Mb*ea(1.0e3));Ob=+Jb;Pb=+Nb;h[k>>3]=nb;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Qb=e+8|0;h[k>>3]=ub;c[Qb>>2]=c[k>>2];c[Qb+4>>2]=c[k+4>>2];Rb=e+16|0;h[k>>3]=Bb;c[Rb>>2]=c[k>>2];c[Rb+4>>2]=c[k+4>>2];Sb=e+24|0;h[k>>3]=Ob;c[Sb>>2]=c[k>>2];c[Sb+4>>2]=c[k+4>>2];Tb=e+32|0;h[k>>3]=Pb;c[Tb>>2]=c[k>>2];c[Tb+4>>2]=c[k+4>>2];Ird(605616,e);MQc(n);i=d;return}function CQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;c[f>>2]=a;if(!a){i=d;return}do if((c[b+72>>2]|0)!=(c[b+40>>2]|0)){NQc(e,b+36|0,f);a=c[e>>2]|0;g=c[b+64>>2]|0;h=c[b+68>>2]|0;if((a|0)==-1){j=g;k=h;l=g+(h<<3)|0;break}else{j=g;k=h;l=g+(a<<3)|0;break}}else{a=c[b+64>>2]|0;g=c[b+68>>2]|0;j=a;k=g;l=a+(g<<3)|0}while(0);if((l|0)==(j+(k<<3)|0)){i=d;return}k=c[l+4>>2]|0;if((k|0)==-1){i=d;return}l=(c[b>>2]|0)+(k<<3)+4|0;j=c[l>>2]|0;if(j&536870912){i=d;return}g=b+16|0;c[l>>2]=j|536870912;switch(j&536870911|0){case 78:case 27:case 28:case 43:case 84:case 89:case 115:case 117:case 142:case 147:case 149:case 150:case 158:case 171:{i=d;return}default:{}}j=b+24|0;l=(c[j>>2]|0)+1|0;c[j>>2]=l;a=b+28|0;h=c[a>>2]|0;m=h&2147483647;if(l>>>0>m>>>0){n=h<<1;o=(n|0)==0?1:n;do if(m>>>0<o>>>0)if((h|0)>-1){c[a>>2]=o;n=c[g>>2]|0;c[f>>2]=c[b+20>>2];c[e+0>>2]=c[f+0>>2];c[g>>2]=hOb(n,o<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+20>>2];c[e+0>>2]=c[f+0>>2];n=cOb(o<<2,4,e,0,3653512,352)|0;YEi(n|0,c[g>>2]|0,c[j>>2]<<2|0)|0;c[a>>2]=o;c[g>>2]=n;break}while(0);p=c[j>>2]|0}else p=l;c[(c[g>>2]|0)+(p+-1<<2)>>2]=k;i=d;return}function DQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b+4|0;h=c[g>>2]|0;c[f>>2]=a;if(!a){i=d;return}do if((c[h+72>>2]|0)!=(c[h+40>>2]|0)){NQc(e,h+36|0,f);a=c[e>>2]|0;j=c[h+64>>2]|0;k=c[h+68>>2]|0;if((a|0)==-1){l=j;m=k;n=j+(k<<3)|0;break}else{l=j;m=k;n=j+(a<<3)|0;break}}else{a=c[h+64>>2]|0;j=c[h+68>>2]|0;l=a;m=j;n=a+(j<<3)|0}while(0);if((n|0)==(l+(m<<3)|0)){i=d;return}m=c[n+4>>2]|0;if((m|0)==-1){i=d;return}n=(c[c[g>>2]>>2]|0)+(m<<3)+4|0;g=c[n>>2]|0;if(g&536870912){i=d;return}l=b+8|0;c[n>>2]=g|536870912;switch(g&536870911|0){case 78:case 27:case 28:case 43:case 84:case 89:case 115:case 117:case 142:case 147:case 149:case 150:case 158:case 171:{i=d;return}default:{}}g=b+16|0;n=(c[g>>2]|0)+1|0;c[g>>2]=n;h=b+20|0;j=c[h>>2]|0;a=j&2147483647;if(n>>>0>a>>>0){k=j<<1;o=(k|0)==0?1:k;do if(a>>>0<o>>>0)if((j|0)>-1){c[h>>2]=o;k=c[l>>2]|0;c[f>>2]=c[b+12>>2];c[e+0>>2]=c[f+0>>2];c[l>>2]=hOb(k,o<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+12>>2];c[e+0>>2]=c[f+0>>2];k=cOb(o<<2,4,e,0,3653512,352)|0;YEi(k|0,c[l>>2]|0,c[g>>2]<<2|0)|0;c[h>>2]=o;c[l>>2]=k;break}while(0);p=c[g>>2]|0}else p=n;c[(c[l>>2]|0)+(p+-1<<2)>>2]=m;i=d;return}function EQc(a,b){a=a|0;b=b|0;var d=0;d=i;DQc(c[a+4>>2]|0,b);i=d;return}function FQc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;OQc(a,b);i=c;return b|0}function GQc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+4|0;g=c[f>>2]|0;h=c[g>>2]|0;j=h+(d<<3)|0;k=c[h+(d<<3)+4>>2]|0;switch(k&536870911|0){case 65:{if(k&1073741824)eUb(c[j>>2]|0,b);DQc(c[(c[j>>2]|0)+28>>2]|0,b);i=e;return}case 21:{Mjd(c[j>>2]|0,b);i=e;return}case 23:{if(k&1073741824)eUb(c[j>>2]|0,b);d=c[j>>2]|0;h=c[d+220>>2]|0;l=c[d+228>>2]|0;m=h+(l<<2)|0;if(l){l=h;do{DQc(c[l>>2]|0,b);l=l+4|0}while((l|0)!=(m|0))}DQc(c[d+212>>2]|0,b);DQc(c[d+304>>2]|0,b);i=e;return}case 114:{d=c[j>>2]|0;if(!(k&1073741824))n=g;else{eUb(d,b);n=c[f>>2]|0}if(a[n+92>>0]|0){DQc(c[d+32>>2]|0,b);n=Ecd(c[j>>2]|0)|0;if(n)htc(n,c[b>>2]|0);n=d+56|0;d=c[n+4>>2]|0;if((d|0)!=(n|0)){g=d;do{htc(c[g+8>>2]|0,c[b>>2]|0);g=c[g+4>>2]|0}while((g|0)!=(n|0))}if(a[(c[f>>2]|0)+92>>0]|0){i=e;return}else o=j}else o=j;break}case 64:{if(k&1073741824)eUb(c[j>>2]|0,b);f=c[j>>2]|0;DQc(c[f+28>>2]|0,b);DQc(c[f+60>>2]|0,b);i=e;return}case 33:{if(k&1073741824)eUb(c[j>>2]|0,b);DQc(c[(c[j>>2]|0)+28>>2]|0,b);i=e;return}case 4:{if(k&1073741824)eUb(c[j>>2]|0,b);f=c[j>>2]|0;n=c[f+140>>2]|0;g=c[f+148>>2]|0;d=n+(g<<2)|0;if(g){g=n;do{DQc(c[(c[g>>2]|0)+4>>2]|0,b);g=g+4|0}while((g|0)!=(d|0))}d=c[f+156>>2]|0;if(!d)p=0;else p=c[d+4>>2]|0;DQc(p,b);i=e;return}case 1:{if(!(k&1073741824)){i=e;return}NTb(c[j>>2]|0,b);i=e;return}default:o=j}j=c[o>>2]|0;In[c[(c[j>>2]|0)+72>>2]&4095](j,b+32|0);i=e;return}function HQc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e;j=d+4|0;if(!(c[j>>2]|0)){i=e;return}k=h+4|0;c[k>>2]=0;l=h+8|0;m=d+8|0;a[l>>0]=a[m>>0]|0;n=h+9|0;o=d+9|0;a[n>>0]=a[o>>0]|0;p=h+12|0;q=d+12|0;r=q;s=c[r+4>>2]|0;t=p;c[t>>2]=c[r>>2];c[t+4>>2]=s;s=h+20|0;t=d+20|0;r=t;u=c[r+4>>2]|0;v=s;c[v>>2]=c[r>>2];c[v+4>>2]=u;u=h+28|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;a[u+20>>0]=0;RQc(h,d,0);v=c[j>>2]|0;c[j>>2]=c[k>>2];c[k>>2]=v;v=a[m>>0]|0;k=b[l>>1]|0;a[m>>0]=k;a[l>>0]=v;v=a[o>>0]|0;a[o>>0]=(k&65535)>>>8;a[n>>0]=v;v=q;n=c[v>>2]|0;k=c[v+4>>2]|0;v=p;o=c[v+4>>2]|0;l=q;c[l>>2]=c[v>>2];c[l+4>>2]=o;o=p;c[o>>2]=n;c[o+4>>2]=k;k=t;o=c[k>>2]|0;n=c[k+4>>2]|0;k=s;p=c[k+4>>2]|0;l=t;c[l>>2]=c[k>>2];c[l+4>>2]=p;p=s;c[p>>2]=o;c[p+4>>2]=n;n=d+28|0;p=c[n>>2]|0;c[n>>2]=c[u>>2];c[u>>2]=p;u=d+32|0;n=h+32|0;o=c[u>>2]|0;s=c[n>>2]|0;c[u>>2]=s;c[n>>2]=o;n=d+36|0;u=h+36|0;l=c[n>>2]|0;c[n>>2]=c[u>>2];c[u>>2]=l;w=ea(s>>>0);c[d+44>>2]=~~ea(w*ea(.5))>>>0;c[d+40>>2]=~~ea(w*ea(.200000003))>>>0;a[d+48>>0]=0;w=ea(o>>>0);c[h+44>>2]=~~ea(w*ea(.5))>>>0;c[h+40>>2]=~~ea(w*ea(.200000003))>>>0;a[h+48>>0]=0;if(!p){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(p,f);i=e;return}function IQc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e;j=d+36|0;k=d+4|0;l=(c[j>>2]|0)-(c[k>>2]|0)|0;m=d+40|0;if(l>>>0>=(c[m>>2]|0)>>>0){n=d+48|0;a[n>>0]=0;i=e;return}o=d+32|0;p=c[o>>2]|0;if(p>>>0<=32){n=d+48|0;a[n>>0]=0;i=e;return}q=ea(l>>>0);l=p;while(1){p=l>>>1;if(l>>>0<66){r=p;break}if(q<ea(ea(p>>>0)*ea(.200000003)))l=p;else{r=p;break}}l=h+4|0;c[l>>2]=0;p=h+8|0;s=d+8|0;a[p>>0]=a[s>>0]|0;t=h+9|0;u=d+9|0;a[t>>0]=a[u>>0]|0;v=h+12|0;w=d+12|0;x=w;y=c[x+4>>2]|0;z=v;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=h+20|0;z=d+20|0;x=z;A=c[x+4>>2]|0;B=y;c[B>>2]=c[x>>2];c[B+4>>2]=A;A=h+28|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;a[A+20>>0]=0;RQc(h,d,r);r=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=r;r=a[s>>0]|0;l=b[p>>1]|0;a[s>>0]=l;a[p>>0]=r;r=a[u>>0]|0;a[u>>0]=(l&65535)>>>8;a[t>>0]=r;r=w;t=c[r>>2]|0;l=c[r+4>>2]|0;r=v;u=c[r+4>>2]|0;p=w;c[p>>2]=c[r>>2];c[p+4>>2]=u;u=v;c[u>>2]=t;c[u+4>>2]=l;l=z;u=c[l>>2]|0;t=c[l+4>>2]|0;l=y;v=c[l+4>>2]|0;p=z;c[p>>2]=c[l>>2];c[p+4>>2]=v;v=y;c[v>>2]=u;c[v+4>>2]=t;t=d+28|0;v=c[t>>2]|0;c[t>>2]=c[A>>2];c[A>>2]=v;A=h+32|0;t=c[o>>2]|0;u=c[A>>2]|0;c[o>>2]=u;c[A>>2]=t;A=h+36|0;o=c[j>>2]|0;c[j>>2]=c[A>>2];c[A>>2]=o;q=ea(u>>>0);c[d+44>>2]=~~ea(q*ea(.5))>>>0;c[m>>2]=~~ea(q*ea(.200000003))>>>0;a[d+48>>0]=0;q=ea(t>>>0);c[h+44>>2]=~~ea(q*ea(.5))>>>0;c[h+40>>2]=~~ea(q*ea(.200000003))>>>0;a[h+48>>0]=0;if(!v){n=d+48|0;a[n>>0]=0;i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(v,f);n=d+48|0;a[n>>0]=0;i=e;return}function JQc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+64|0;h=g+56|0;j=g+52|0;k=g;l=d+48|0;if(a[l>>0]|0)IQc(d);m=d+32|0;n=c[m>>2]|0;o=c[d+36>>2]|0;if(n>>>0>f>>>0?(o+e|0)>>>0<=(c[d+44>>2]|0)>>>0:0){i=g;return}p=d+36|0;q=o+e|0;r=ea(q>>>0);e=32;while(1){if(e>>>0>=f>>>0?!(r>=ea(ea(e>>>0)*ea(.5))):0){s=e;break}e=e<<1}if(s>>>0<=n>>>0){i=g;return}n=d+4|0;r=ea((q-(c[n>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=f>>>0?!(r>=ea(ea(q>>>0)*ea(.5))):0){t=q;break}q=q<<1}q=k+4|0;c[q>>2]=0;f=k+8|0;s=d+8|0;a[f>>0]=a[s>>0]|0;e=k+9|0;o=d+9|0;a[e>>0]=a[o>>0]|0;u=k+12|0;v=d+12|0;w=v;x=c[w+4>>2]|0;y=u;c[y>>2]=c[w>>2];c[y+4>>2]=x;x=k+20|0;y=d+20|0;w=y;z=c[w+4>>2]|0;A=x;c[A>>2]=c[w>>2];c[A+4>>2]=z;z=k+28|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;a[z+20>>0]=0;RQc(k,d,t);t=c[n>>2]|0;c[n>>2]=c[q>>2];c[q>>2]=t;t=a[s>>0]|0;q=b[f>>1]|0;a[s>>0]=q;a[f>>0]=t;t=a[o>>0]|0;a[o>>0]=(q&65535)>>>8;a[e>>0]=t;t=v;e=c[t>>2]|0;q=c[t+4>>2]|0;t=u;o=c[t+4>>2]|0;f=v;c[f>>2]=c[t>>2];c[f+4>>2]=o;o=u;c[o>>2]=e;c[o+4>>2]=q;q=y;o=c[q>>2]|0;e=c[q+4>>2]|0;q=x;u=c[q+4>>2]|0;f=y;c[f>>2]=c[q>>2];c[f+4>>2]=u;u=x;c[u>>2]=o;c[u+4>>2]=e;e=d+28|0;u=c[e>>2]|0;c[e>>2]=c[z>>2];c[z>>2]=u;z=k+32|0;e=c[m>>2]|0;o=c[z>>2]|0;c[m>>2]=o;c[z>>2]=e;z=k+36|0;m=c[p>>2]|0;c[p>>2]=c[z>>2];c[z>>2]=m;r=ea(o>>>0);c[d+44>>2]=~~ea(r*ea(.5))>>>0;c[d+40>>2]=~~ea(r*ea(.200000003))>>>0;a[l>>0]=0;r=ea(e>>>0);c[k+44>>2]=~~ea(r*ea(.5))>>>0;c[k+40>>2]=~~ea(r*ea(.200000003))>>>0;a[k+48>>0]=0;if(!u){i=g;return}c[j>>2]=89;c[h+0>>2]=c[j+0>>2];eOb(u,h);i=g;return}function KQc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;JQc(d,1,0);NQc(g,d,e);h=c[g>>2]|0;if((h|0)!=-1){j=c[d+28>>2]|0;k=j+(c[d+32>>2]<<3)|0;c[b>>2]=d;c[b+4>>2]=j+(h<<3);c[b+8>>2]=k;a[b+12>>0]=0;i=f;return}k=c[g+4>>2]|0;if(((a[d+8>>0]|0)!=0?(g=d+4|0,h=c[g>>2]|0,(h|0)!=0):0)?(j=c[d+28>>2]|0,(c[d+12>>2]|0)==(c[j+(k<<3)>>2]|0)):0){c[g>>2]=h+-1;l=j}else{j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;l=c[d+28>>2]|0}j=l+(k<<3)|0;if(!j)m=l;else{l=e;e=c[l+4>>2]|0;h=j;c[h>>2]=c[l>>2];c[h+4>>2]=e;m=c[d+28>>2]|0}e=m+(c[d+32>>2]<<3)|0;c[b>>2]=d;c[b+4>>2]=m+(k<<3);c[b+8>>2]=e;a[b+12>>0]=1;i=f;return}function LQc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((b|0)>0)f=0;else{i=e;return}do{DQc(Grc(c[a+(f<<2)>>2]|0)|0,d);f=f+1|0}while((f|0)!=(b|0));i=e;return}function MQc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a+64>>2]|0;if(g){c[f>>2]=89;c[d+0>>2]=c[f+0>>2];eOb(g,d)}if((c[a+28>>2]|0)>-1){g=a+16|0;f=c[g>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[g>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}g=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[a>>2]=0;i=b;return}function NQc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=(c[d+32>>2]|0)+-1|0;h=c[e>>2]|0;e=h+2127912214+(h<<12)|0;j=e^-949894596^e>>>19;e=j+374761393+(j<<5)|0;j=e+-744332180^e<<9;e=j+-42973499+(j<<3)|0;j=(e^-1252372727^e>>>16)&g;e=c[d+28>>2]|0;k=c[d+20>>2]|0;l=c[e+(j<<3)>>2]|0;a:do if((k|0)==(l|0)){m=j;n=5}else{o=d+4|0;p=d+12|0;b:do if(!(a[d+8>>0]|0)){q=l;r=j;s=0;while(1){if((h|0)==(q|0)){t=r;break b}s=s+1|0;u=s+r&g;q=c[e+(u<<3)>>2]|0;if((k|0)==(q|0)){m=u;n=5;break a}else r=u}}else{r=l;q=-1;s=j;u=0;while(1){if((c[o>>2]|0)!=0?(c[p>>2]|0)==(r|0):0)v=(q|0)==-1?s:q;else if((h|0)==(r|0)){t=s;break b}else v=q;u=u+1|0;w=u+s&g;r=c[e+(w<<3)>>2]|0;if((k|0)==(r|0)){x=v;y=w;break}else{q=v;s=w}}c[b>>2]=-1;s=b+4|0;if((x|0)==-1){z=y;A=s;break a}c[s>>2]=x;i=f;return}while(0);c[b>>2]=t;c[b+4>>2]=-1;i=f;return}while(0);if((n|0)==5){c[b>>2]=-1;z=m;A=b+4|0}c[A>>2]=z;i=f;return}function OQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+4|0;a=c[(c[g>>2]|0)+4>>2]|0;c[f>>2]=b;if(!b){i=d;return}do if((c[a+72>>2]|0)!=(c[a+40>>2]|0)){NQc(e,a+36|0,f);b=c[e>>2]|0;h=c[a+64>>2]|0;j=c[a+68>>2]|0;if((b|0)==-1){k=h;l=j;m=h+(j<<3)|0;break}else{k=h;l=j;m=h+(b<<3)|0;break}}else{b=c[a+64>>2]|0;h=c[a+68>>2]|0;k=b;l=h;m=b+(h<<3)|0}while(0);if((m|0)==(k+(l<<3)|0)){i=d;return}l=c[m+4>>2]|0;if((l|0)==-1){i=d;return}m=c[g>>2]|0;g=(c[c[m+4>>2]>>2]|0)+(l<<3)+4|0;k=c[g>>2]|0;if(k&536870912){i=d;return}a=m+8|0;c[g>>2]=k|536870912;switch(k&536870911|0){case 78:case 27:case 28:case 43:case 84:case 89:case 115:case 117:case 142:case 147:case 149:case 150:case 158:case 171:{i=d;return}default:{}}k=m+16|0;g=(c[k>>2]|0)+1|0;c[k>>2]=g;h=m+20|0;b=c[h>>2]|0;j=b&2147483647;if(g>>>0>j>>>0){n=b<<1;o=(n|0)==0?1:n;do if(j>>>0<o>>>0)if((b|0)>-1){c[h>>2]=o;n=c[a>>2]|0;c[f>>2]=c[m+12>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(n,o<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[m+12>>2];c[e+0>>2]=c[f+0>>2];n=cOb(o<<2,4,e,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,c[k>>2]<<2|0)|0;c[h>>2]=o;c[a>>2]=n;break}while(0);p=c[k>>2]|0}else p=g;c[(c[a>>2]|0)+(p+-1<<2)>>2]=l;i=d;return}function PQc(a){a=a|0;return}function QQc(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function RQc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+28|0;k=b+32|0;c[k>>2]=32;l=b+44|0;c[l>>2]=16;m=b+40|0;c[m>>2]=6;n=b+48|0;a[n>>0]=0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];o=cOb(256,16,g,0,3653512,80)|0;p=c[j>>2]|0;if(p){c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(p,g)}c[j>>2]=o;p=o+(c[k>>2]<<3)|0;if((o|0)!=(p|0)){q=b+20|0;r=o;do{if(r){o=q;s=c[o+4>>2]|0;t=r;c[t>>2]=c[o>>2];c[t+4>>2]=s}r=r+8|0}while((r|0)!=(p|0))}p=b+36|0;c[p>>2]=0;c[b+4>>2]=0;r=d+4|0;u=ea(((c[d+36>>2]|0)-(c[r>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=e>>>0?(v=ea(q>>>0),w=ea(v*ea(.5)),!(u>=w)):0){x=v;y=w;z=q;break}q=q<<1}q=c[k>>2]|0;if(z>>>0>q>>>0){c[h>>2]=89;c[g+0>>2]=c[h+0>>2];e=cOb(z<<3,16,g,0,3653512,80)|0;s=c[j>>2]|0;if(s){t=c[k>>2]|0;o=s+(t<<3)|0;if(!t)A=s;else{t=e;B=s;while(1){if(t){s=B;C=c[s+4>>2]|0;D=t;c[D>>2]=c[s>>2];c[D+4>>2]=C}B=B+8|0;if((B|0)==(o|0))break;else t=t+8|0}A=c[j>>2]|0}c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(A,g)}g=c[k>>2]|0;A=e+(z<<3)|0;if((g|0)!=(z|0)){h=b+20|0;t=e+(g<<3)|0;do{if(t){g=h;o=c[g+4>>2]|0;B=t;c[B>>2]=c[g>>2];c[B+4>>2]=o}t=t+8|0}while((t|0)!=(A|0))}c[j>>2]=e;c[k>>2]=z;c[l>>2]=~~y>>>0;c[m>>2]=~~ea(x*ea(.200000003))>>>0;a[n>>0]=0;E=z}else E=q;q=d+28|0;z=c[q>>2]|0;n=d+32|0;m=c[n>>2]|0;l=z+(m<<3)|0;a:do if(m){e=c[d+20>>2]|0;A=c[d+12>>2]|0;if((c[r>>2]|0)!=0&(a[d+8>>0]|0)!=0){t=z;do{h=c[t>>2]|0;if(!((e|0)==(h|0)|(A|0)==(h|0))){F=t;break a}t=t+8|0}while((t|0)!=(l|0));i=f;return}else{t=z;do{if((e|0)!=(c[t>>2]|0)){F=t;break a}t=t+8|0}while((t|0)!=(l|0));i=f;return}}else F=z;while(0);if((F|0)==(l|0)){i=f;return}z=b+20|0;b=d+20|0;m=d+8|0;t=d+12|0;d=E;E=F;while(1){F=d+-1|0;e=c[E>>2]|0;A=e+2127912214+(e<<12)|0;e=A^-949894596^A>>>19;A=e+374761393+(e<<5)|0;e=A+-744332180^A<<9;A=e+-42973499+(e<<3)|0;e=(A^-1252372727^A>>>16)&F;A=c[j>>2]|0;h=c[z>>2]|0;if((h|0)==(c[A+(e<<3)>>2]|0))G=e;else{o=e;e=0;while(1){e=e+1|0;B=e+o&F;if((h|0)==(c[A+(B<<3)>>2]|0)){G=B;break}else o=B}}o=A+(G<<3)|0;if(o){h=E;F=c[h+4>>2]|0;e=o;c[e>>2]=c[h>>2];c[e+4>>2]=F}c[p>>2]=(c[p>>2]|0)+1;F=E+8|0;b:do if((F|0)!=(l|0)){e=c[b>>2]|0;h=c[t>>2]|0;if((c[r>>2]|0)!=0&(a[m>>0]|0)!=0){o=E;B=F;while(1){g=c[o+8>>2]|0;if(!((e|0)==(g|0)|(h|0)==(g|0))){H=B;break b}g=o+16|0;if((g|0)==(l|0)){H=l;break}else{C=B;B=g;o=C}}}else{o=E;B=F;while(1){if((e|0)!=(c[o+8>>2]|0)){H=B;break b}h=o+16|0;if((h|0)==(l|0)){H=l;break}else{C=B;B=h;o=C}}}}else H=l;while(0);if((H|0)==((c[q>>2]|0)+(c[n>>2]<<3)|0))break;d=c[k>>2]|0;E=H}i=f;return}function SQc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d;if(Ttc(b)|0){g=-1;i=d;return g|0}Utc(f,b);if(!(a[f>>0]&1))h=f+1|0;else h=c[f+8>>2]|0;c[e>>2]=-1;itd(e,h);h=c[e>>2]|0;xri(f);g=h;i=d;return g|0}function TQc(a){a=a|0;var b=0,d=0;b=i;d=c[a+40>>2]|0;if(d)BCi(d);i=b;return}function UQc(a){a=a|0;var b=0;b=a+4|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[a>>2]=11;b=a+20|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;return}function VQc(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;f=a+4|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;h=d+4|0;j=c[h+4>>2]|0;k=f;c[k>>2]=c[h>>2];c[k+4>>2]=j;j=d+12|0;k=c[j+4>>2]|0;h=a+12|0;c[h>>2]=c[j>>2];c[h+4>>2]=k;c[a>>2]=c[d>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];g[a+28>>2]=ea(g[d+28>>2]);c[a+32>>2]=c[d+32>>2];b[a+36>>1]=b[d+36>>1]|0;b[a+38>>1]=b[d+38>>1]|0;k=d+40|0;d=c[k>>2]|0;if(!d){c[a+40>>2]=0;i=e;return}else{h=zCi((SEi(d|0)|0)+1|0)|0;c[a+40>>2]=h;a=c[k>>2]|0;YEi(h|0,a|0,(SEi(a|0)|0)+1|0)|0;i=e;return}}function WQc(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;f=d+4|0;h=c[f+4>>2]|0;j=a+4|0;c[j>>2]=c[f>>2];c[j+4>>2]=h;h=d+12|0;j=c[h+4>>2]|0;f=a+12|0;c[f>>2]=c[h>>2];c[f+4>>2]=j;c[a>>2]=c[d>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];g[a+28>>2]=ea(g[d+28>>2]);c[a+32>>2]=c[d+32>>2];b[a+36>>1]=b[d+36>>1]|0;b[a+38>>1]=b[d+38>>1]|0;j=a+40|0;a=c[j>>2]|0;if(a){BCi(a);c[j>>2]=0}a=d+40|0;d=c[a>>2]|0;if(!d){i=e;return}f=zCi((SEi(d|0)|0)+1|0)|0;c[j>>2]=f;j=c[a>>2]|0;YEi(f|0,j|0,(SEi(j|0)|0)+1|0)|0;i=e;return}function XQc(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+24|0;f=c[e>>2]|0;if(f&2)b[a+36>>1]=0;g=b[a+38>>1]|0;if((g+-256<<16>>16&65535)<17){h=f&-65;c[e>>2]=h;j=h}else j=f;switch(g&65535|0){case 296:case 295:case 294:case 293:case 292:case 291:case 290:case 289:case 288:case 287:case 286:case 285:case 284:case 283:case 282:case 8:case 127:case 281:case 280:case 279:case 278:case 275:case 276:case 274:case 273:{c[e>>2]=j|64;b[a+36>>1]=0;i=d;return}default:{}}if((b[a+36>>1]|0)!=13){i=d;return}b[a+36>>1]=10;i=d;return}function YQc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;c[h+8>>2]=0;j=h+12|0;c[j>>2]=0;k=h+4|0;c[k>>2]=60;l=ZQc(a,h,b,d)|0;if((c[j>>2]|0)<=-1){i=e;return l|0}j=c[h>>2]|0;c[g>>2]=c[k>>2];c[f+0>>2]=c[g+0>>2];eOb(j,f);c[h>>2]=0;i=e;return l|0}function ZQc(a,d,f,h){a=a|0;d=d|0;f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=0,H=0,I=Im,J=Im,K=0,L=0,M=0,N=0,O=0;j=i;i=i+16|0;l=j+4|0;m=j;n=a+8|0;o=c[n>>2]|0;p=o+-1|0;q=p>>>1|p;p=q>>>2|q;q=p>>>4|p;p=q>>>8|q;q=p>>>16|p;p=q+1|0;r=(p|0)==0&1;s=r+p|0;p=s+o|0;t=zCi(p>>>0>1073741823?-1:p<<2)|0;p=h+8|0;c[p>>2]=o;u=h+12|0;v=c[u>>2]|0;do if((v&2147483647)>>>0<o>>>0)if((v|0)>-1){c[u>>2]=o;w=c[h>>2]|0;c[m>>2]=c[h+4>>2];c[l+0>>2]=c[m+0>>2];c[h>>2]=hOb(w,o<<1,2,l,0,3653512,370)|0;break}else{c[m>>2]=c[h+4>>2];c[l+0>>2]=c[m+0>>2];w=cOb(o<<1,2,l,0,3653512,352)|0;YEi(w|0,c[h>>2]|0,c[p>>2]<<1|0)|0;c[u>>2]=o;c[h>>2]=w;break}while(0);PEi(t|0,-1,s<<2|0)|0;o=c[n>>2]|0;if(!o)x=0;else{u=r+q|0;q=d+8|0;r=o;o=0;p=0;while(1){v=c[a>>2]|0;w=v+(o*12|0)|0;y=c[w>>2]|0;z=c[v+(o*12|0)+4>>2]|0;A=c[v+(o*12|0)+8>>2]|0;B=(z*11|0)+y+(da(A,-17)|0)&2147483647;C=t+(((B>>>12^B^B>>>22)&u)<<2)|0;B=c[C>>2]|0;D=(c[k>>2]=y,ea(g[k>>2]));E=(c[k>>2]=z,ea(g[k>>2]));F=(c[k>>2]=A,ea(g[k>>2]));a:do if((B|0)==-1)G=24;else{A=c[d>>2]|0;z=A+(o<<5)|0;b:do if(!(c[q>>2]|0)){y=B;while(1){if((ea(g[v+(y*12|0)>>2])==D?ea(g[v+(y*12|0)+4>>2])==E:0)?ea(g[v+(y*12|0)+8>>2])==F:0){H=y;break b}y=c[t+(y+s<<2)>>2]|0;if((y|0)==-1){G=24;break a}}}else{y=B;while(1){c:do if((ea(g[v+(y*12|0)>>2])==D?ea(g[v+(y*12|0)+4>>2])==E:0)?ea(g[v+(y*12|0)+8>>2])==F:0){I=ea(g[z>>2]);J=ea(I-ea(g[A+(y<<5)>>2]));if(J<ea(0.0)){if(!(J>=ea(-9.99999997e-07)))break;else K=0;while(1){if((c[A+(o<<5)+(K<<2)+16>>2]|0)!=(c[A+(y<<5)+(K<<2)+16>>2]|0))break c;K=K+1|0;if((K|0)>=4){H=y;break b}}}else{if(!(J<=ea(9.99999997e-07)))break;else L=0;while(1){if((c[A+(o<<5)+(L<<2)+16>>2]|0)!=(c[A+(y<<5)+(L<<2)+16>>2]|0))break c;L=L+1|0;if((L|0)>=4){H=y;break b}}}}while(0);y=c[t+(y+s<<2)>>2]|0;if((y|0)==-1){G=24;break a}}}while(0);b[(c[h>>2]|0)+(o<<1)>>1]=H;M=r;N=p}while(0);if((G|0)==24){G=0;b[(c[h>>2]|0)+(o<<1)>>1]=p;B=v+(p*12|0)|0;c[B+0>>2]=c[w+0>>2];c[B+4>>2]=c[w+4>>2];c[B+8>>2]=c[w+8>>2];if(c[q>>2]|0){B=c[d>>2]|0;A=B+(p<<5)|0;z=B+(o<<5)|0;c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];c[A+12>>2]=c[z+12>>2];c[A+16>>2]=c[z+16>>2];c[A+20>>2]=c[z+20>>2];c[A+24>>2]=c[z+24>>2];c[A+28>>2]=c[z+28>>2]}c[t+(p+s<<2)>>2]=c[C>>2];c[C>>2]=p;M=c[n>>2]|0;N=p+1|0}o=o+1|0;if(o>>>0>=M>>>0){x=N;break}else{r=M;p=N}}}BCi(t);if(x>>>0>=(c[n>>2]|0)>>>0){O=0;i=j;return O|0}c[n>>2]=x;t=a+12|0;N=c[t>>2]|0;do if((N&2147483647)>>>0<x>>>0)if((N|0)>-1){c[t>>2]=x;p=c[a>>2]|0;c[m>>2]=c[a+4>>2];c[l+0>>2]=c[m+0>>2];c[a>>2]=hOb(p,x*12|0,4,l,0,3653512,370)|0;break}else{c[m>>2]=c[a+4>>2];c[l+0>>2]=c[m+0>>2];p=cOb(x*12|0,4,l,0,3653512,352)|0;YEi(p|0,c[a>>2]|0,(c[n>>2]|0)*12|0)|0;c[t>>2]=x;c[a>>2]=p;break}while(0);a=d+8|0;do if((c[a>>2]|0)!=0?(c[a>>2]=x,t=d+12|0,n=c[t>>2]|0,(n&2147483647)>>>0<x>>>0):0)if((n|0)>-1){c[t>>2]=x;n=c[d>>2]|0;c[m>>2]=c[d+4>>2];c[l+0>>2]=c[m+0>>2];c[d>>2]=hOb(n,x<<5,16,l,0,3653512,370)|0;break}else{c[m>>2]=c[d+4>>2];c[l+0>>2]=c[m+0>>2];n=cOb(x<<5,16,l,0,3653512,352)|0;YEi(n|0,c[d>>2]|0,c[a>>2]<<5|0)|0;c[t>>2]=x;c[d>>2]=n;break}while(0);d=c[f+8>>2]|0;if(!d){O=1;i=j;return O|0}x=c[f>>2]|0;f=c[h>>2]|0;h=0;do{a=x+(h<<1)|0;b[a>>1]=b[f+((e[a>>1]|0)<<1)>>1]|0;h=h+1|0}while(h>>>0<d>>>0);O=1;i=j;return O|0}function _Qc(b){b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im;d=i;e=b+4|0;if(!(a[e>>0]|0)){f=Ecd(c[b+12>>2]|0)|0;h=Ecd(c[b+20>>2]|0)|0;j=ea(-ea(g[b+48>>2]));k=ea(-ea(g[b+52>>2]));l=f;m=h;n=j;o=k;p=ea(-ea(g[b+56>>2]))}else{h=Ecd(c[b+8>>2]|0)|0;f=Ecd(c[b+16>>2]|0)|0;k=ea(g[b+48>>2]);j=ea(g[b+52>>2]);l=h;m=f;n=k;o=j;p=ea(g[b+56>>2])}f=c[(Atc()|0)+264>>2]|0;h=b+60|0;q=Isc(f,32,c[b+68>>2]|0)|0;f=c[b+64>>2]|0;if((f|0)==(h|0)){r=Atc()|0;s=r+260|0;t=c[s>>2]|0;u=ds(t)|0;v=u+8|0;g[v>>2]=n;w=u+12|0;g[w>>2]=o;x=u+16|0;g[x>>2]=p;y=u+20|0;c[y>>2]=l;z=u+24|0;c[z>>2]=m;A=u+28|0;c[A>>2]=q;i=d;return u|0}else{B=f;C=0}while(1){f=Gsc(q,C,32)|0;b=B+8|0;D=B+16|0;c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];if(!(a[e>>0]|0)){D=c[b>>2]|0;if(!D)E=0;else E=c[D+4>>2]|0;c[f+24>>2]=E;D=c[B+12>>2]|0;if(!D)F=0;else F=c[D+4>>2]|0;c[f+28>>2]=F;D=f+12|0;G=B+28|0;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2]}else{G=c[B+12>>2]|0;if(!G)H=0;else H=c[G+4>>2]|0;c[f+24>>2]=H;G=c[b>>2]|0;if(!G)I=0;else I=c[G+4>>2]|0;c[f+28>>2]=I;j=ea(-ea(g[B+28>>2]));k=ea(-ea(g[B+32>>2]));J=ea(-ea(g[B+36>>2]));g[f+12>>2]=j;g[f+16>>2]=k;g[f+20>>2]=J}B=c[B+4>>2]|0;if((B|0)==(h|0))break;else C=C+1|0}r=Atc()|0;s=r+260|0;t=c[s>>2]|0;u=ds(t)|0;v=u+8|0;g[v>>2]=n;w=u+12|0;g[w>>2]=o;x=u+16|0;g[x>>2]=p;y=u+20|0;c[y>>2]=l;z=u+24|0;c[z>>2]=m;A=u+28|0;c[A>>2]=q;i=d;return u|0}function $Qc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=c[a+4>>2]|0;if(!d){i=b;return}e=a+4|0;f=c[a+8>>2]|0;a=d+12|0;g=c[a>>2]|0;h=g+-1|0;if((h|0)==(f|0))j=g;else{g=d+4|0;d=c[g>>2]|0;k=d+(h<<3)|0;l=c[k+4>>2]|0;m=d+(f<<3)|0;c[m>>2]=c[k>>2];c[m+4>>2]=l;l=c[g>>2]|0;g=c[l+(h<<3)+4>>2]|0;m=(c[l+(h<<3)>>2]|0)+4|0;if((g|0)==-1)n=m;else n=(c[m>>2]|0)+(g<<3)|0;c[n+4>>2]=f;j=c[a>>2]|0}c[a>>2]=j+-1;j=e;c[j>>2]=0;c[j+4>>2]=-1;i=b;return}function aRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[e>>2]|0;if(!f)g=b+8|0;else{h=b+4|0;j=b+8|0;k=c[j>>2]|0;l=f+12|0;m=c[l>>2]|0;n=m+-1|0;if((n|0)==(k|0))o=m;else{m=f+4|0;f=c[m>>2]|0;p=f+(n<<3)|0;q=c[p+4>>2]|0;r=f+(k<<3)|0;c[r>>2]=c[p>>2];c[r+4>>2]=q;q=c[m>>2]|0;m=c[q+(n<<3)+4>>2]|0;r=(c[q+(n<<3)>>2]|0)+4|0;if((m|0)==-1)s=r;else s=(c[r>>2]|0)+(m<<3)|0;c[s+4>>2]=k;o=c[l>>2]|0}c[l>>2]=o+-1;o=h;c[o>>2]=0;c[o+4>>2]=-1;g=j}c[e>>2]=a;c[g>>2]=c[a+12>>2];g=bRc(a+4|0)|0;c[g>>2]=b;c[g+4>>2]=-1;i=d;return}function bRc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;do if(g>>>0>k>>>0?(l=j<<1,m=(l|0)==0?1:l,k>>>0<m>>>0):0)if((j|0)>-1){c[h>>2]=m;l=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(l,m<<3,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];l=cOb(m<<3,4,d,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[f>>2]<<3|0)|0;c[h>>2]=m;c[a>>2]=l;break}while(0);i=b;return (c[a>>2]|0)+((c[f>>2]|0)+-1<<3)|0}function cRc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;dRc(605816,a,b,c);i=d;return}function dRc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;g=i;i=i+96|0;h=g+76|0;j=g+32|0;k=g+12|0;l=g+16|0;m=g+88|0;n=g;o=g+20|0;p=g+64|0;q=g+52|0;r=n+4|0;c[r>>2]=0;c[n+8>>2]=0;s=n+4|0;c[n>>2]=s;t=b+4|0;u=b+12|0;v=c[u>>2]|0;a:do if(v){w=c[t>>2]|0;x=w;y=v;z=w;do{w=c[z>>2]|0;A=x;B=y;while(1){if(!w){C=B;D=A}else{c[m>>2]=w;E=c[137784]|0;if(E){do if((c[E+36>>2]|0)!=(c[E+4>>2]|0)){fRb(h,E,m);F=c[h>>2]|0;G=c[E+28>>2]|0;if((F|0)==-1){H=G+(c[E+32>>2]<<3)|0;break}else{H=G+(F<<3)|0;break}}else H=(c[E+28>>2]|0)+(c[E+32>>2]<<3)|0;while(0);E=c[137784]|0;if((H|0)!=((c[E+28>>2]|0)+(c[E+32>>2]<<3)|0)?(E=c[H+4>>2]|0,(E|0)!=0):0){I=E;break}}E=hQb(c[z>>2]|0)|0;if(E){I=E;break}C=c[u>>2]|0;D=c[t>>2]|0}B=C+-1|0;w=c[D+(B<<2)>>2]|0;c[z>>2]=w;c[u>>2]=B;if((z|0)==(D+(B<<2)|0))break a;else A=D}Xhd(I,n);z=z+4|0;x=c[t>>2]|0;y=c[u>>2]|0}while((z|0)!=(x+(y<<2)|0))}while(0);u=o+4|0;c[u>>2]=0;c[o+8>>2]=0;c[o>>2]=o+4;t=p+4|0;c[t>>2]=0;I=p+8|0;c[I>>2]=0;D=p+4|0;c[p>>2]=D;C=c[n>>2]|0;if((C|0)!=(s|0)){H=C;while(1){C=c[H+16>>2]|0;do if(C){c[k>>2]=C;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(h,m,k);v=c[h>>2]|0;y=c[m+28>>2]|0;if((v|0)==-1){J=y+(c[m+32>>2]<<3)|0;break}else{J=y+(v<<3)|0;break}}else J=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((J|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[J+4>>2]|0,(m|0)!=0):0)K=m;else L=28}else L=28;if((L|0)==28){L=0;m=hQb(C)|0;if(!m)break;else K=m}m=K+8|0;v=c[m>>2]|0;if(!(v&65536)){y=c[K+4>>2]|0;x=c[t>>2]|0;do if(x){z=x;while(1){A=c[z+16>>2]|0;if((y|0)<(A|0)){B=c[z>>2]|0;if(!B){M=z;N=z;L=33;break}else{z=B;continue}}if((A|0)>=(y|0)){O=z;L=37;break}A=z+4|0;B=c[A>>2]|0;if(!B){P=A;Q=z;L=36;break}else z=B}if((L|0)==33){L=0;c[h>>2]=N;R=M;S=N;break}else if((L|0)==36){L=0;c[h>>2]=Q;R=P;S=Q;break}else if((L|0)==37){L=0;c[h>>2]=O;R=h;S=O;break}}else{c[h>>2]=D;R=D;S=D}while(0);if(!(c[R>>2]|0)){x=xCi(20)|0;c[x+16>>2]=y;c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=S;c[R>>2]=x;z=c[c[p>>2]>>2]|0;if(!z)T=x;else{c[p>>2]=z;T=c[R>>2]|0}GN(c[t>>2]|0,T);c[I>>2]=(c[I>>2]|0)+1;U=c[m>>2]|0}else U=v;c[m>>2]=U|65536}}while(0);C=c[H+4>>2]|0;if(!C){z=H;while(1){x=c[z+8>>2]|0;if((c[x>>2]|0)==(z|0)){V=x;break}else z=x}}else{z=C;while(1){x=c[z>>2]|0;if(!x){V=z;break}else z=x}}if((V|0)==(s|0))break;else H=V}}DVc();V=c[p>>2]|0;if((V|0)!=(D|0)){H=V;while(1){V=H+16|0;s=c[V>>2]|0;do if(s){c[l>>2]=s;U=c[137784]|0;if(U){do if((c[U+36>>2]|0)!=(c[U+4>>2]|0)){fRb(h,U,l);I=c[h>>2]|0;T=c[U+28>>2]|0;if((I|0)==-1){W=T+(c[U+32>>2]<<3)|0;break}else{W=T+(I<<3)|0;break}}else W=(c[U+28>>2]|0)+(c[U+32>>2]<<3)|0;while(0);U=c[137784]|0;if((W|0)!=((c[U+28>>2]|0)+(c[U+32>>2]<<3)|0)?(U=c[W+4>>2]|0,(U|0)!=0):0)X=U;else L=60}else L=60;if((L|0)==60){L=0;U=hQb(c[V>>2]|0)|0;if(!U)break;else X=U}U=X+8|0;c[U>>2]=c[U>>2]&-65537}while(0);V=c[H+4>>2]|0;if(!V){s=H;while(1){U=c[s+8>>2]|0;if((c[U>>2]|0)==(s|0)){Y=U;break}else s=U}}else{s=V;while(1){U=c[s>>2]|0;if(!U){Y=s;break}else s=U}}if((Y|0)==(D|0))break;else H=Y}}c[b>>2]=d;Y=b+20|0;a[Y>>0]=0;do if((d|0)<0){a[Y>>0]=1;H=b+24|0;D=b+36|0;X=a[D>>0]|0;if(!(X&1)){Z=(X&255)>>>1;_=D+1|0}else{Z=c[b+40>>2]|0;_=c[b+44>>2]|0}X=a[H>>0]|0;if(!(X&1)){$=10;aa=X}else{X=c[H>>2]|0;$=(X&-2)+-1|0;aa=X&255}X=(aa&1)==0;do if(Z>>>0<=$>>>0){if(X)ba=H+1|0;else ba=c[b+32>>2]|0;aFi(ba|0,_|0,Z|0)|0;a[ba+Z>>0]=0;if(!(a[H>>0]&1)){a[H>>0]=Z<<1;break}else{c[b+28>>2]=Z;break}}else{if(X)ca=(aa&255)>>>1;else ca=c[b+28>>2]|0;eXb(H,$,Z-$|0,ca,0,ca,Z,_)}while(0);if(!(a[D>>0]&1)){a[D+1>>0]=0;a[D>>0]=0;break}else{a[c[b+44>>2]>>0]=0;c[b+40>>2]=0;break}}while(0);BVc(e,f);c[q>>2]=1e5;c[q+4>>2]=d;c[q+8>>2]=0;c[j+0>>2]=c[138994];c[j+4>>2]=c[138995];c[j+8>>2]=c[138996];c[j+12>>2]=c[138997];c[j+16>>2]=c[138998];c[h+0>>2]=c[q+0>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];gQc(j,h);vqc(kbc()|0);_Kc(jLc()|0);rRc(p,c[t>>2]|0);sRc(o,c[u>>2]|0);nOc(n,c[r>>2]|0);i=g;return}function eRc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+48|0;d=b+32|0;e=b+12|0;f=b;g=c[151466]|0;if((g|0)==(a|0)){i=b;return}if((g|0)==2&(a|0)==1){i=b;return}if(!(OOc()|0)){i=b;return}g=ELc()|0;if(g)In[c[c[g>>2]>>2]&4095](g,(a|0)!=0);g=(a|0)==2;VKc(jLc()|0,g);do if(!g){if(!a){h=10;break}c[151466]=a;if(a&-3){i=b;return}}else{j=ECc()|0;In[c[(c[j>>2]|0)+76>>2]&4095](j,0);QCc(ECc()|0,0);h=10}while(0);if((h|0)==10)c[151466]=a;c[f>>2]=100001;c[f+4>>2]=g&1;c[f+8>>2]=0;c[e+0>>2]=c[139006];c[e+4>>2]=c[139007];c[e+8>>2]=c[139008];c[e+12>>2]=c[139009];c[e+16>>2]=c[139010];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];gQc(e,d);i=b;return}function fRc(){return c[151466]|0}function gRc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d+32|0;f=d+12|0;g=d;if(!(OOc()|0)){i=d;return}if(!(a[605880]|0)){h=c[(NOc()|0)+120>>2]|0;j=(h|0)>(Psd(605888)|0)&1;a[605872]=j;a[605880]=1;k=j}else k=a[605872]|0;if(!(k<<24>>24)){i=d;return}c[g>>2]=100001;c[g+4>>2]=b&1;c[g+8>>2]=0;c[f+0>>2]=c[139018];c[f+4>>2]=c[139019];c[f+8>>2]=c[139020];c[f+12>>2]=c[139021];c[f+16>>2]=c[139022];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];gQc(f,e);i=d;return}function hRc(){var b=0,c=0;b=i;if(!(qSc()|0)){c=0;i=b;return c|0}c=(a[(rSc()|0)+177>>0]|0)!=0;i=b;return c|0}function iRc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d+48|0;f=d+36|0;g=d+24|0;h=d+12|0;j=d;k=kfd()|0;rri(e,619704,31);rri(g,606472,33);fsd(f,b,g);wfd(k,e,f);xri(f);xri(g);xri(e);rri(h,606440,29);e=a[h>>0]|0;if(!(e&1)){g=h+1|0;l=g;m=g;n=h+8|0}else{g=h+8|0;l=c[g>>2]|0;m=h+1|0;n=g}g=h+4|0;f=e;e=l;while(1){if(!(f&1)){o=m;p=(f&255)>>>1}else{o=c[n>>2]|0;p=c[g>>2]|0}if((e|0)==(o+p|0))break;l=a[e>>0]|0;k=l<<24>>24;a[e>>0]=(l+-65<<24>>24&255)<26?k+32|0:k;f=a[h>>0]|0;e=e+1|0}e=kfd()|0;rri(j,606440,29);wfd(e,h,j);xri(j);xri(h);i=d;return}function jRc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+64|0;f=e;g=e+40|0;h=e+28|0;j=e+16|0;k=e+4|0;wQc();rri(h,611760,SEi(611760)|0);fsd(g,b,h);l=rqd(g)|0;xri(g);xri(h);if(!l){Ird(605896,f);m=0;i=e;return m|0}Ded();Eqd(b);iRc(d);if(!(sVc()|0)){Ird(605944,f);m=0;i=e;return m|0}rri(k,611760,SEi(611760)|0);yVb(j,k);xri(k);k=a[j>>0]|0;d=(k&1)==0;if(d)n=(k&255)>>>1;else n=c[j+4>>2]|0;if(!n){vqc((kbc()|0)+448|0);o=1}else{if(d)p=j+1|0;else p=c[j+8>>2]|0;c[f>>2]=p;Ird(606e3,f);o=0}xri(j);m=o;i=e;return m|0}function kRc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+4|0;if(!(tVc(b)|0)){Ird(606048,e);h=0;i=d;return h|0}Ijd(f,620920);b=a[f>>0]|0;j=(b&1)==0;if(j)k=(b&255)>>>1;else k=c[f+4>>2]|0;if(!k){zVb(g,611760);k=a[g>>0]|0;b=(k&1)==0;if(b)l=(k&255)>>>1;else l=c[g+4>>2]|0;if(!l){uvd(ea(-1.0));OIc(0);m=1}else{if(b)n=g+1|0;else n=c[g+8>>2]|0;c[e>>2]=n;Ird(606168,e);m=0}xri(g);o=m}else{if(j)p=f+1|0;else p=c[f+8>>2]|0;c[e>>2]=p;Ird(606112,e);o=0}xri(f);h=o;i=d;return h|0}function lRc(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+192|0;d=b+180|0;e=b+176|0;f=b+32|0;g=b+24|0;h=b+12|0;j=b;if((c[151458]|0)>-1){k=c[151455]|0;c[e>>2]=c[151456];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[151455]=0}c[151457]=0;c[151458]=0;c[151454]=0;a[605836]=0;if(!(a[605840]&1)){a[605841]=0;a[605840]=0}else{a[c[151462]>>0]=0;c[151461]=0}if(!(a[605852]&1)){a[605853]=0;a[605852]=0}else{a[c[151465]>>0]=0;c[151464]=0}c[g>>2]=c[153134];c[d+0>>2]=c[g+0>>2];eed(f,d);BVb(f);rri(h,611760,SEi(611760)|0);rri(j,606416,20);g=cSc(h,j,0,2,1)|0;xri(j);xri(h);zRc(vRc()|0);IOc(g);USc(dTc()|0);g=f+144|0;do{h=g;g=g+-16|0;if((c[h+-4>>2]|0)>-1){j=c[g>>2]|0;c[e>>2]=c[h+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[g>>2]=0}}while((g|0)!=(f|0));i=b;return}function mRc(){var b=0;b=i;if(a[606200]|0){i=b;return}a[606200]=1;lOb();eod(_nd()|0);Erd();i=b;return}function nRc(b){b=b|0;var d=0,e=0,f=0;d=i;e=ync()|0;while(1){if(mo[c[(c[e>>2]|0)+516>>2]&4095](e)|0)break;if(!(mo[c[(c[e>>2]|0)+520>>2]&4095](e)|0)){f=4;break}}if((f|0)==4){Krd(606336,0,3653512,1421,4,0,0,0);i=d;return}d8b(n8b()|0);f8b(n8b()|0,0);if(!(a[(ync()|0)+5832>>0]|0)){f=ync()|0;ko[c[(c[f>>2]|0)+500>>2]&4095](f)}if(c[141980]|0)$ke();f=FCc()|0;if((f|0)!=0?mo[c[(c[f>>2]|0)+96>>2]&4095](f)|0:0){f=ync()|0;_Hc(XHc()|0);Tuc();RRb();In[c[(c[f>>2]|0)+772>>2]&4095](f,1);_Hc(XHc()|0);Tuc();RRb();In[c[(c[f>>2]|0)+772>>2]&4095](f,0)}else{_Hc(XHc()|0);Tuc();RRb()}f=ync()|0;ko[c[(c[f>>2]|0)+320>>2]&4095](f);a[606216]=1;if(!b){i=d;return}ko[c[(c[f>>2]|0)+504>>2]&4095](f);f=ync()|0;In[c[(c[f>>2]|0)+512>>2]&4095](f,0);a[606216]=0;i=d;return}function oRc(){var a=0,b=0,d=0,e=0,f=Im,g=Im,h=Im,j=0,k=0,l=0;a=i;i=i+16|0;b=a;d=qyc()|0;if(d){e=c[(c[d+24>>2]|0)+((c[d+40>>2]|0)*96|0)+68>>2]|0;f=ea(-1);if((e|0)>0){d=ECc()|0;In[c[(c[d>>2]|0)+28>>2]&4095](b,d);d=c[b+8>>2]|0;g=ea(d|0);h=ea(((d|0)>0?g:ea(60.0))/ea(e|0));j=1;k=b}else{h=f;j=0;k=b}}else{h=ea(-1);j=0;k=b}if(!(h<=ea(0.0))){b=h>ea(1.0e3);l=b?1e3:~~h}else l=1e3;b=jLc()|0;c[b+208>>2]=j?l:0;l=jLc()|0;ko[c[(c[l>>2]|0)+100>>2]&4095](l);i=a;return}function pRc(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0;h=i;i=i+224|0;j=h+208|0;k=h+8|0;l=h;if(!((HLc()|0)!=0?(m=HLc()|0,!(mo[c[(c[m>>2]|0)+8>>2]&4095](m)|0)):0))oRc();if(a[606208]|0){Krd(606232,0,3653512,1566,1,0,0,0);i=h;return}a[606208]=1;m=ync()|0;if(!(mo[c[(c[m>>2]|0)+516>>2]&4095](m)|0)?!(mo[c[(c[m>>2]|0)+520>>2]&4095](m)|0):0)Krd(606264,0,3653512,1575,4,0,0,0);else n=9;do if((n|0)==9){if(!b){o=fKc()|0;p=ea(g[o+100>>2]);q=ea(g[o+104>>2]);if(!(p<ea(0.0))?(o=ECc()|0,!(p>ea(mo[c[(c[o>>2]|0)+80>>2]&4095](o)|0))):0)r=1;else r=0;if(!(q<ea(0.0))?(o=ECc()|0,!(q>ea(mo[c[(c[o>>2]|0)+84>>2]&4095](o)|0))):0)s=r;else s=0;o=ECc()|0;In[c[(c[o>>2]|0)+76>>2]&4095](o,s)}o=mo[c[(c[m>>2]|0)+496>>2]&4095](m)|0;t=oVb()|0;if(!b?!((o|0)!=0|(a[606216]|0)==0):0){if(0)fa(1);u=ync()|0;In[c[(c[u>>2]|0)+512>>2]&4095](u,0);a[606216]=0;if(0)fa(0);v=605752;w=v+60|0;do{c[v>>2]=0;v=v+4|0}while((v|0)<(w|0))}if(!o)ko[c[(c[m>>2]|0)+616>>2]&4095](m);uwe();ARc(vRc()|0);if(e)Mac(Lac()|0);Izc(Gzc()|0,15);if(c[141988]|0)h5d();if(c[141982]|0)ale();if(t)rKc(fKc()|0);x=+Ki()*1.0e6;u=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;y=elc()|0;In[c[(c[y>>2]|0)+100>>2]&4095](y,4);z=+Ki()*1.0e6;y=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,u|0)|0;u=605776;A=_Ei(y|0,H|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=605776;c[u>>2]=A;c[u+4>>2]=H;q=ea(g[(jLc()|0)+188>>2]);if(q<ea(0.0))B=ea(-q);else B=q;u=B<=ea(9.99999997e-07);if(u&(c[141970]|0)!=0){tGd();C=0}else C=0;while(1){if(!(XKc(jLc()|0)|0)){D=C;break}if(t){if((C|0)==0&(c[141974]|0)!=0)vGd();u=ELc()|0;if(u)ko[c[(c[u>>2]|0)+4>>2]&4095](u);x=+Ki()*1.0e6;u=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;A=zkc()|0;ko[c[(c[A>>2]|0)+8>>2]&4095](A);z=+Ki()*1.0e6;A=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,u|0)|0;u=605752;y=_Ei(A|0,H|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=605752;c[u>>2]=y;c[u+4>>2]=H;x=+Ki()*1.0e6;u=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;if(c[141964]|0)PXd();if(0)fa();z=+Ki()*1.0e6;y=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,u|0)|0;u=605792;A=_Ei(y|0,H|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=605792;c[u>>2]=A;c[u+4>>2]=H;x=+Ki()*1.0e6;u=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;if(c[141966]|0)rGd();if(0)fa();z=+Ki()*1.0e6;A=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,u|0)|0;u=605760;y=_Ei(A|0,H|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=605760;c[u>>2]=y;c[u+4>>2]=H;if(c[141958]|0)MXd();x=+Ki()*1.0e6;u=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;y=elc()|0;In[c[(c[y>>2]|0)+100>>2]&4095](y,1);z=+Ki()*1.0e6;y=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,u|0)|0;u=605776;A=_Ei(y|0,H|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=605776;c[u>>2]=A;c[u+4>>2]=H}C=C+1|0}c[151452]=D;if(t){if(c[141968]|0)sGd();if(0)fa()}u=tKc(fKc()|0)|0;aIc(XHc()|0);if(t?(a[(NOc()|0)+105>>0]|0)!=0:0){A=d[(XHc()|0)+8>>0]|0;y=(Xbd()|0)+524|0;E=c[y+4>>2]|0;F=l;c[F>>2]=c[y>>2];c[F+4>>2]=E;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];jbd(k,j);E=k+32|0;$ad(E,A);$ad(E,1);nbd(k)|0}if(0)fa();if(c[141990]|0)Wbc();x=+Ki()*1.0e6;E=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;A=ykc()|0;ko[c[(c[A>>2]|0)+8>>2]&4095](A);z=+Ki()*1.0e6;A=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,E|0)|0;E=605768;F=_Ei(A|0,H|0,c[E>>2]|0,c[E+4>>2]|0)|0;E=605768;c[E>>2]=F;c[E+4>>2]=H;x=+Ki()*1.0e6;E=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;F=elc()|0;In[c[(c[F>>2]|0)+100>>2]&4095](F,2);z=+Ki()*1.0e6;F=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,E|0)|0;E=605776;A=_Ei(F|0,H|0,c[E>>2]|0,c[E+4>>2]|0)|0;E=605776;c[E>>2]=A;c[E+4>>2]=H;if(0)fa();if(t){x=+Ki()*1.0e6;E=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;if(c[141962]|0)OXd();if(0)fa();if(c[141960]|0)NXd();z=+Ki()*1.0e6;A=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,E|0)|0;E=605792;F=_Ei(A|0,H|0,c[E>>2]|0,c[E+4>>2]|0)|0;E=605792;c[E>>2]=F;c[E+4>>2]=H}if(0)fa();x=+Ki()*1.0e6;E=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;F=Akc()|0;ko[c[(c[F>>2]|0)+8>>2]&4095](F);z=+Ki()*1.0e6;F=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,E|0)|0;E=605768;A=_Ei(F|0,H|0,c[E>>2]|0,c[E+4>>2]|0)|0;E=605768;c[E>>2]=A;c[E+4>>2]=H;x=+Ki()*1.0e6;E=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;A=elc()|0;In[c[(c[A>>2]|0)+100>>2]&4095](A,2);z=+Ki()*1.0e6;A=ZEi(~~z>>>0|0,(+S(z)>=1.0?(z>0.0?(ha(+R(z/4294967296.0),4294967295.0)|0)>>>0:~~+ca((z-+(~~z>>>0))/4294967296.0)>>>0):0)|0,~~x>>>0|0,E|0)|0;E=605776;F=_Ei(A|0,H|0,c[E>>2]|0,c[E+4>>2]|0)|0;E=605776;c[E>>2]=F;c[E+4>>2]=H;E=ELc()|0;if(E)ko[c[(c[E>>2]|0)+8>>2]&4095](E);if(0)fa();do if(e){E=mo[c[(c[m>>2]|0)+516>>2]&4095](m)|0;if(!(E&(c[141972]|0)!=0))break;uGd()}while(0);if(0)fa();m8b();if(0)fa();t=(f|0)!=0;if(t)ko[c[c[f>>2]>>2]&4095](f);x=+Ki()*1.0e6;E=~~x>>>0;F=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;do if(e){if(!(mo[c[(c[m>>2]|0)+516>>2]&4095](m)|0))break;Kcc(1,0)}while(0);x=+Ki()*1.0e6;A=ZEi(~~x>>>0|0,(+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0)|0,E|0,F|0)|0;y=605784;G=_Ei(A|0,H|0,c[y>>2]|0,c[y+4>>2]|0)|0;y=605784;c[y>>2]=G;c[y+4>>2]=H;y=Bkc()|0;ko[c[(c[y>>2]|0)+8>>2]&4095](y);if(t)ko[c[c[f>>2]>>2]&4095](f);if(c[141984]|0)ble();if(c[141986]|0)cle();if(c[141976]|0)Zke();if(c[141978]|0)_ke();if(e){x=+Ki()*1.0e6;y=~~x>>>0;G=+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0;if(b){A=elc()|0;In[c[(c[A>>2]|0)+100>>2]&4095](A,32);NPc()}else{nRc(0);A=elc()|0;In[c[(c[A>>2]|0)+100>>2]&4095](A,32);NPc();ko[c[(c[m>>2]|0)+504>>2]&4095](m);do if(!o){if(!(a[606224]|0))break;if(0)fa(1);A=ync()|0;In[c[(c[A>>2]|0)+512>>2]&4095](A,0);a[606216]=0;if(0)fa(0);v=605752;w=v+60|0;do{c[v>>2]=0;v=v+4|0}while((v|0)<(w|0))}else if((o|0)==1){if(0)fa(1);A=ync()|0;In[c[(c[A>>2]|0)+512>>2]&4095](A,0);a[606216]=0;if(0)fa(0);v=605752;w=v+60|0;do{c[v>>2]=0;v=v+4|0}while((v|0)<(w|0))}while(0);a[606224]=0}x=+Ki()*1.0e6;t=ZEi(~~x>>>0|0,(+S(x)>=1.0?(x>0.0?(ha(+R(x/4294967296.0),4294967295.0)|0)>>>0:~~+ca((x-+(~~x>>>0))/4294967296.0)>>>0):0)|0,y|0,G|0)|0;F=605800;E=_Ei(t|0,H|0,c[F>>2]|0,c[F+4>>2]|0)|0;F=605800;c[F>>2]=E;c[F+4>>2]=H}yac(Lac()|0);F=ECc()|0;if(mo[c[(c[F>>2]|0)+12>>2]&4095](F)|0){a[606216]=0;a[606224]=1}qKc(fKc()|0);AJc(EJc()|0);Wld();if(!(u|(tKc(fKc()|0)|0)^1))mKc(fKc()|0);sOb(fOb()|0,0);if((o|0)!=1)break;ko[c[(c[m>>2]|0)+616>>2]&4095](m)}while(0);a[606208]=0;i=h;return}function qRc(){var a=0;a=i;tRc(605816);i=a;return}function rRc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{rRc(a,c[b>>2]|0);rRc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function sRc(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{sRc(a,c[b>>2]|0);sRc(a,c[b+4>>2]|0);ACi(b);i=d;return}}function tRc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+4|0;c[g>>2]=0;h=b+12|0;c[h>>2]=0;j=b+16|0;c[j>>2]=0;c[b+8>>2]=60;k=b+24|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[f>>2]=60;c[e+0>>2]=c[f+0>>2];eOb(0,e);c[g>>2]=0;g=b+24|0;e=(a[g>>0]&1)==0;c[h>>2]=0;c[j>>2]=0;c[b>>2]=-1;a[b+20>>0]=0;if(e){a[g+1>>0]=0;a[g>>0]=0}else{a[c[b+32>>2]>>0]=0;c[b+28>>2]=0}g=b+36|0;if(!(a[g>>0]&1)){a[g+1>>0]=0;a[g>>0]=0;i=d;return}else{a[c[b+44>>2]>>0]=0;c[b+40>>2]=0;i=d;return}}function uRc(){return}function vRc(){var a=0,b=0,d=0;a=i;b=c[151628]|0;if(b){d=b;i=a;return d|0}b=xCi(36)|0;c[b>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=60;c[b+16>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+20>>2]=60;c[b+32>>2]=0;c[151628]=b;d=b;i=a;return d|0}function wRc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;HOc(b);ERc(a,e);i=d;return}function xRc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=a+8|0;if(!(c[e>>2]|0)){i=b;return}f=c[c[a>>2]>>2]|0;g=mo[c[(c[f>>2]|0)+16>>2]&4095](f)|0;f=c[e>>2]|0;if(f>>>0>1){h=g;g=1;j=0;while(1){k=c[(c[a>>2]|0)+(g<<2)>>2]|0;if((mo[c[(c[k>>2]|0)+16>>2]&4095](k)|0)>(h|0)){k=c[(c[a>>2]|0)+(g<<2)>>2]|0;l=mo[c[(c[k>>2]|0)+16>>2]&4095](k)|0;m=g}else{l=h;m=j}g=g+1|0;k=c[e>>2]|0;if(g>>>0>=k>>>0){n=k;o=m;break}else{h=l;j=m}}}else{n=f;o=0}f=c[a>>2]|0;m=f+(o<<2)|0;j=c[m>>2]|0;c[d>>2]=j;l=o+1|0;aFi(m|0,f+(l<<2)|0,n-l<<2|0)|0;c[e>>2]=(c[e>>2]|0)+-1;ERc(a+16|0,d);if(!j){i=b;return}ko[c[(c[j>>2]|0)+32>>2]&4095](j);mo[c[(c[j>>2]|0)+48>>2]&4095](j)|0;c[j+24>>2]=1;i=b;return}function yRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0;d=i;xRc(a);e=a+24|0;if(!(c[e>>2]|0)){i=d;return}f=a+16|0;a=c[c[f>>2]>>2]|0;if(!a){i=d;return}g=a+24|0;h=c[g>>2]|0;j=+Ki()*1.0e6;k=+S(j)>=1.0?(j>0.0?(ha(+R(j/4294967296.0),4294967295.0)|0)>>>0:~~+ca((j-+(~~j>>>0))/4294967296.0)>>>0):0;l=_n[c[(c[a>>2]|0)+36>>2]&4095](a,10)|0;m=+Ki()*1.0e6;n=+S(m)>=1.0?(m>0.0?(ha(+R(m/4294967296.0),4294967295.0)|0)>>>0:~~+ca((m-+(~~m>>>0))/4294967296.0)>>>0):0;o=a+40|0;p=o;q=ZEi(c[p>>2]|0,c[p+4>>2]|0,~~j>>>0|0,k|0)|0;k=_Ei(q|0,H|0,~~m>>>0|0,n|0)|0;n=o;c[n>>2]=k;c[n+4>>2]=H;if(!l){i=d;return}if((h|0)!=1|(mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0|b)^1){i=d;return}b=c[f>>2]|0;aFi(b|0,b+4|0,(c[e>>2]<<2)+-4|0)|0;c[e>>2]=(c[e>>2]|0)+-1;ko[c[(c[a>>2]|0)+40>>2]&4095](a);c[g>>2]=2;EOc(a);IOc(a);i=d;return}function zRc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+24|0;e=a+8|0;while(1){if((c[e>>2]|0)==0?(c[d>>2]|0)==0:0)break;yRc(a,0)}i=b;return}function ARc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=a+8|0;if(!(c[d>>2]|0))e=0;else{f=0;g=0;while(1){h=c[(c[a>>2]|0)+(f<<2)>>2]|0;j=g|(mo[c[(c[h>>2]|0)+44>>2]&4095](h)|0);f=f+1|0;if(f>>>0>=(c[d>>2]|0)>>>0){e=j;break}else g=j}}g=a+24|0;if(!(c[g>>2]|0))k=e;else{f=a+16|0;j=0;h=e;while(1){e=c[(c[f>>2]|0)+(j<<2)>>2]|0;l=h|(mo[c[(c[e>>2]|0)+44>>2]&4095](e)|0);j=j+1|0;if(j>>>0>=(c[g>>2]|0)>>>0){k=l;break}else h=l}}if(!k){yRc(a,0);i=b;return}while(1){if((c[d>>2]|0)==0?(c[g>>2]|0)==0:0)break;yRc(a,0)}i=b;return}function BRc(a){a=a|0;var b=Im;b=ea(g[a+60>>2]);return ea(b)}function CRc(a){a=a|0;return (c[a+24>>2]|0)==2|0}function DRc(a){a=a|0;var b=0;c[a>>2]=601600;c[a+4>>2]=1;c[a+20>>2]=0;c[a+8>>2]=0;c[a>>2]=606528;c[a+56>>2]=0;c[a+24>>2]=0;g[a+60>>2]=ea(0.0);b=a+32|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;return}function ERc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;b=a+8|0;h=(c[b>>2]|0)+1|0;c[b>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[b>>2]<<2|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[b>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}function FRc(a){a=a|0;var b=0;b=i;FOc(a);ACi(a);i=b;return}function GRc(a){a=a|0;return}function HRc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,606584,a,0);QRc(a,b);bdd(b);i=c;return}function IRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,606584,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else RRc(a,b);sdd(b);i=d;return}function JRc(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);ENc(b,a+28|0,0);HNc(b,a+44|0,0);i=c;return}function KRc(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);INc(b,a+28|0,0);LNc(b,a+44|0,0);i=c;return}function LRc(a,b){a=a|0;b=b|0;var c=0;c=i;SRc(a,b);i=c;return}function MRc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;CWb(b,d);f=c[b+28>>2]|0;g=c[b+36>>2]|0;b=f+(g<<2)|0;if(!g){i=e;return}g=d+12|0;h=d+28|0;j=d+32|0;d=f;do{f=c[g>>2]|0;k=xo[c[c[f>>2]>>2]&2047](f,c[d>>2]|0,c[h>>2]|0)|0;if(a[j>>0]|0)c[d>>2]=k;d=d+4|0}while((d|0)!=(b|0));i=e;return}function NRc(){var a=0;a=i;QQb(150,155,0,0,0);i=a;return}function ORc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,606584,11);wQb(150,130,b,56,2633,0,0);xri(b);i=a;return}function PRc(a){a=a|0;return 150}function QRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;xWb(a,b);j=c[142306]|0;add(b,606704,j,a+28|0,0);c[g>>2]=0;$cd(b,2646336,2646336,f,0);add(b,3142592,c[142276]|0,g,0);k=e+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,g,1);l=b+12|0;m=b+20|0;c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,k,1);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);add(b,622128,j,a+44|0,0);c[h>>2]=0;qbc(h);$cd(b,2646336,2646336,g,0);add(b,3142592,c[142294]|0,h,0);$cd(b,2646336,2646336,e,1);add(b,3142592,c[142260]|0,f,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);cdd(b);ubc(h);bdd(b);i=d;return}function RRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;yWb(a,b);f=a+28|0;g=c[142306]|0;h=qdd(b,606704,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else ANc(b,f,0);sdd(b)}f=a+44|0;a=qdd(b,622128,g,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else DNc(b,f,0);sdd(b);i=d;return}function SRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;BWb(a,b);f=a+36|0;g=c[f>>2]|0;c[e>>2]=g;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);k=c[a+28>>2]|0;g=c[f>>2]|0;f=k+(g<<2)|0;if(g){g=k;do{Yxc(g,b);g=g+4|0}while((g|0)!=(f|0))}f=a+48|0;g=c[f>>2]|0;k=a+44|0;a=c[k>>2]|0;j=g-a>>2;c[e>>2]=j;m=c[h>>2]|0;n=m+4|0;if(n>>>0<(c[l>>2]|0)>>>0){c[m>>2]=j;c[h>>2]=n;o=a;p=g}else{Gid(h,e,4);o=c[k>>2]|0;p=c[f>>2]|0}if((o|0)==(p|0)){i=d;return}else q=o;do{GUb(q,b);q=q+4|0}while((q|0)!=(p|0));i=d;return}function TRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(56,e,1,16,3653512,11)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];mWb(g,e,b);c[g>>2]=606608;c[g+28>>2]=0;c[g+36>>2]=0;c[g+40>>2]=0;c[g+32>>2]=60;c[g+44>>2]=0;c[g+48>>2]=0;c[g+52>>2]=0;i=d;return g|0}function URc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=606608;f=a+44|0;g=c[f>>2]|0;if(g){h=a+48|0;while(1){j=c[h>>2]|0;if((j|0)==(g|0))break;k=j+-4|0;c[h>>2]=k;ubc(k)}ACi(c[f>>2]|0)}if((c[a+40>>2]|0)<=-1){EWb(a);i=b;return}f=a+28|0;h=c[f>>2]|0;c[e>>2]=c[a+32>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0;EWb(a);i=b;return}function VRc(a){a=a|0;var b=0;b=i;URc(a);ACi(a);i=b;return}function WRc(a){a=a|0;return 1}function XRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=da(c[137788]|0,(c[a+8>>2]|0)>>>21)|0;g=f+74|0;h=g>>5;j=c[137786]|0;if(((1<<g-(h<<5)&c[j+(h<<2)>>2]|0)==0?(h=f+27|0,g=h>>5,(c[j+(g<<2)>>2]&1<<h-(g<<5)|0)==0):0)?(g=f+43|0,f=g>>5,(c[j+(f<<2)>>2]&1<<g-(f<<5)|0)==0):0){i=d;return}c[e>>2]=c[a+4>>2];gSc(b,e)|0;i=d;return}function YRc(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;d=i;i=i+96|0;e=d+8|0;f=d+24|0;h=d+16|0;j=d+32|0;k=d+72|0;l=d;m=d+20|0;n=d+48|0;o=kfd()|0;p=b+104|0;q=a[p>>0]|0;if(!(q&1))r=(q&255)>>>1;else r=c[b+108>>2]|0;do if(r){q=Ked(o,p,1,0)|0;c[f>>2]=q;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,f);t=c[e>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0))w=c[v+4>>2]|0;else w=0}else w=0;if(!w){s=$ed(o,q)|0;if(!s)break;else x=s}else x=w;s=(da(c[137788]|0,(c[x+8>>2]|0)>>>21)|0)+150|0;t=s>>5;if(!((x|0)==0?1:(1<<s-(t<<5)&c[(c[137786]|0)+(t<<2)>>2]|0)==0)){t=x+28|0;s=c[t+8>>2]|0;u=b+72|0;y=b+80|0;c[y>>2]=s;z=b+84|0;A=c[z>>2]|0;do if((A&2147483647)>>>0<s>>>0)if((A|0)>-1){c[z>>2]=s;B=c[u>>2]|0;c[f>>2]=c[b+76>>2];c[e+0>>2]=c[f+0>>2];c[u>>2]=hOb(B,s<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+76>>2];c[e+0>>2]=c[f+0>>2];B=cOb(s<<2,4,e,0,3653512,352)|0;YEi(B|0,c[u>>2]|0,c[y>>2]<<2|0)|0;c[z>>2]=s;c[u>>2]=B;break}while(0);if((s|0)>0){z=c[u>>2]|0;y=c[t>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[y+(A<<2)>>2];A=A+1|0}while((A|0)!=(s|0))}hOc(mOc()|0,x+44|0,u,0,0)}}while(0);x=c[153134]|0;w=b+92|0;v=a[w>>0]|0;if(!(v&1))C=(v&255)>>>1;else C=c[b+96>>2]|0;if(C){C=c[b+116>>2]|0;hfd(kfd()|0);v=c[153134]|0;c[j>>2]=0;r=j+4|0;c[r>>2]=v;s=j+8|0;c[s>>2]=0;A=j+12|0;c[A>>2]=0;c[k>>2]=0;y=k+4|0;c[y>>2]=v;c[k+8>>2]=0;v=k+12|0;c[v>>2]=0;Ned(kfd()|0,w,j,k);z=c[s>>2]|0;if(z){c[f>>2]=x;c[e+0>>2]=c[f+0>>2];t=hOb(0,z<<3,8,e,0,3653512,370)|0;q=c[s>>2]|0;if(q){c[f>>2]=x;c[e+0>>2]=c[f+0>>2];B=hOb(0,q<<2,4,e,0,3653512,370)|0;D=c[s>>2]|0;if(!D){E=z;F=0;G=t;H=q;I=0;J=B}else{K=(C&-5|0)!=1;C=0;L=q;q=B;B=0;M=z;N=t;O=D;D=0;while(1){P=(c[j>>2]|0)+(D<<3)|0;Q=c[P>>2]|0;R=c[P+4>>2]|0;P=c[(c[k>>2]|0)+(D<<2)>>2]|0;S=da(c[137788]|0,P)|0;T=S+6|0;U=T>>5;V=c[137786]|0;do if(!(1<<T-(U<<5)&c[V+(U<<2)>>2])){W=S+3|0;X=W>>5;if(!((c[V+(X<<2)>>2]&1<<W-(X<<5)|0)==0|K)?!((P|0)==157|(P|0)==196):0){Y=O;Z=M;_=B;$=N;aa=L;ba=C;ca=q;break}X=S+21|0;W=X>>5;if(((((c[V+(W<<2)>>2]&1<<X-(W<<5)|0)==0?(W=S+213|0,X=W>>5,(c[V+(X<<2)>>2]&1<<W-(X<<5)|0)==0):0)?(X=S+74|0,W=X>>5,(c[V+(W<<2)>>2]&1<<X-(W<<5)|0)==0):0)?(W=S+27|0,X=W>>5,(c[V+(X<<2)>>2]&1<<W-(X<<5)|0)==0):0)?(X=S+43|0,W=X>>5,(c[V+(W<<2)>>2]&1<<X-(W<<5)|0)==0):0){W=C+1|0;X=L&2147483647;do if(W>>>0>X>>>0){fa=L<<1;ga=(fa|0)==0?1:fa;if(X>>>0>=ga>>>0){ha=q;ia=L;break}if((L|0)>-1){c[f>>2]=x;c[e+0>>2]=c[f+0>>2];ha=hOb(q,ga<<2,4,e,0,3653512,370)|0;ia=ga;break}else{c[f>>2]=x;c[e+0>>2]=c[f+0>>2];fa=cOb(ga<<2,4,e,0,3653512,352)|0;YEi(fa|0,q|0,W<<2|0)|0;ha=fa;ia=ga;break}}else{ha=q;ia=L}while(0);c[ha+(C<<2)>>2]=B;ja=ia;ka=W;la=ha}else{ja=L;ka=C;la=q}X=B+1|0;ga=M&2147483647;do if(X>>>0>ga>>>0?(fa=M<<1,ma=(fa|0)==0?1:fa,ga>>>0<ma>>>0):0)if((M|0)>-1){c[f>>2]=x;c[e+0>>2]=c[f+0>>2];na=hOb(N,ma<<3,8,e,0,3653512,370)|0;oa=ma;break}else{c[f>>2]=x;c[e+0>>2]=c[f+0>>2];fa=cOb(ma<<3,8,e,0,3653512,352)|0;YEi(fa|0,N|0,X<<3|0)|0;na=fa;oa=ma;break}else{na=N;oa=M}while(0);ga=na+(B<<3)|0;c[ga>>2]=Q;c[ga+4>>2]=R;Y=c[s>>2]|0;Z=oa;_=X;$=na;aa=ja;ba=ka;ca=la}else{Y=O;Z=M;_=B;$=N;aa=L;ba=C;ca=q}while(0);D=D+1|0;if(D>>>0>=Y>>>0){E=Z;F=_;G=$;H=aa;I=ba;J=ca;break}else{C=ba;L=aa;q=ca;B=_;M=Z;N=$;O=Y}}}}else{E=z;F=0;G=t;H=0;I=0;J=0}}else{E=0;F=0;G=0;H=0;I=0;J=0}ifd(kfd()|0);if((c[v>>2]|0)>-1){v=c[k>>2]|0;c[f>>2]=c[y>>2];c[e+0>>2]=c[f+0>>2];eOb(v,e);c[k>>2]=0}if((c[A>>2]|0)>-1){A=c[j>>2]|0;c[f>>2]=c[r>>2];c[e+0>>2]=c[f+0>>2];eOb(A,e);c[j>>2]=0;pa=F;qa=G;ra=I;sa=J;ta=H;ua=E}else{pa=F;qa=G;ra=I;sa=J;ta=H;ua=E}}else{pa=0;qa=0;ra=0;sa=0;ta=0;ua=0}E=b+80|0;H=(c[E>>2]|0)+pa|0;J=b+60|0;c[n>>2]=J;g[n+4>>2]=ea(.899999976);g[n+8>>2]=ea(H>>>0);g[n+12>>2]=ea(0.0);H=b+128|0;c[n+20>>2]=2675;c[n+16>>2]=H;I=kfd()|0;dfd(I,c[b+72>>2]|0,c[E>>2]|0,n);ffd(o,p,0,0,-1,0,n)|0;efd(o,H);E=c[153134]|0;if(!pa){va=0;wa=0}else{c[f>>2]=E;c[e+0>>2]=c[f+0>>2];va=hOb(0,pa<<2,4,e,0,3653512,370)|0;wa=pa}hfd(o);I=o+95|0;a[I>>0]=0;ffd(o,w,qa,va,pa,1,n)|0;a[I>>0]=0;I=c[153134]|0;if(!ra){xa=0;ya=0}else{c[f>>2]=I;c[e+0>>2]=c[f+0>>2];n=hOb(0,ra<<2,4,e,0,3653512,370)|0;pa=0;do{c[n+(pa<<2)>>2]=c[va+(c[sa+(pa<<2)>>2]<<2)>>2];pa=pa+1|0}while((pa|0)!=(ra|0));xa=n;ya=ra}Wed(o,xa,ra,b+156|0);efd(o,H);H=kfd()|0;if(!(tfd(H,w)|0))sfd(H,w,1);if(!(tfd(H,p)|0))sfd(H,p,1);ifd(o);g[J>>2]=ea(.899999976);if((ya|0)>-1){c[f>>2]=I;c[e+0>>2]=c[f+0>>2];eOb(xa,e)}if((wa|0)>-1){c[h>>2]=E;c[e+0>>2]=c[h+0>>2];eOb(va,e)}if((ta|0)>-1){c[l>>2]=x;c[e+0>>2]=c[l+0>>2];eOb(sa,e)}if((ua|0)<=-1){i=d;return}c[m>>2]=x;c[e+0>>2]=c[m+0>>2];eOb(qa,e);i=d;return}function ZRc(b){b=b|0;return (a[b+68>>0]|0)!=0|0}function _Rc(b,c){b=b|0;c=c|0;a[b+68>>0]=c&1;return}function $Rc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+84|0;if((c[g>>2]|0)>-1){h=b+72|0;j=c[h>>2]|0;c[f>>2]=c[b+76>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[h>>2]=0}c[b+80>>2]=0;c[g>>2]=0;ned(b+156|0);g=b+148|0;b=c[g>>2]|0;if(!b){c[g>>2]=0;i=d;return}h=b;do{b=h;h=c[h+24>>2]|0;if(a[b+4>>0]|0){j=c[b>>2]|0;c[f>>2]=c[b+8>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e)}ACi(b)}while((h|0)!=0);c[g>>2]=0;i=d;return}function aSc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ZNc(a+128|0,b)|0;i=c;return d|0}function bSc(a){a=a|0;var b=0,d=0;b=i;d=c[a+116>>2]|0;if((d|0)==2)AVc(a+156|0);else if(!d)cRc(c[a+88>>2]|0,a+92|0,a+156|0);else if((d|0)==5|(d|0)==1)xVc(a+92|0,a+156|0,d);$Rc(a);g[a+60>>2]=ea(1.0);i=b;return}function cSc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;if(!g)if(!(a[(NOc()|0)+93>>0]|0)){Krd(606720,0,3653512,287,1,0,0,0);j=1}else j=0;else j=1;g=xCi(304)|0;dSc(g);yri(g+92|0,b)|0;yri(g+104|0,d)|0;c[g+116>>2]=f;c[g+88>>2]=e;a[g+124>>0]=j;wRc(vRc()|0,g);if(!((f|0)==0|(f|0)==3)){i=h;return g|0}IOc(iSc(1)|0);i=h;return g|0}function dSc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;DRc(b);c[b>>2]=606872;c[b+72>>2]=0;c[b+80>>2]=0;c[b+84>>2]=0;c[b+76>>2]=60;h=b+92|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;h=c[153100]|0;c[b+128>>2]=-1;c[b+132>>2]=4096;c[b+136>>2]=h;j=xCi(28)|0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+12>>2]=4096;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];c[j>>2]=cOb(4096,16,e,0,3653512,112)|0;a[j+4>>0]=1;c[j+8>>2]=h;c[j+24>>2]=0;h=b+148|0;c[h>>2]=j;c[b+152>>2]=c[h>>2];c[b+140>>2]=c[(c[h>>2]|0)+12>>2];c[b+144>>2]=0;c[g>>2]=c[153100];c[e+0>>2]=c[g+0>>2];eed(b+156|0,e);c[b+88>>2]=-1;a[b+124>>0]=0;a[b+68>>0]=1;c[b+120>>2]=42;i=d;return}function eSc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=606872;g=b+156|0;h=b+300|0;do{j=h;h=h+-16|0;if((c[j+-4>>2]|0)>-1){k=c[h>>2]|0;c[f>>2]=c[j+-12>>2];c[e+0>>2]=c[f+0>>2];eOb(k,e);c[h>>2]=0}}while((h|0)!=(g|0));g=b+148|0;h=c[g>>2]|0;if(h){k=h;do{h=k;k=c[k+24>>2]|0;if(a[h+4>>0]|0){j=c[h>>2]|0;c[f>>2]=c[h+8>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e)}ACi(h)}while((k|0)!=0)}c[g>>2]=0;xri(b+104|0);xri(b+92|0);if((c[b+84>>2]|0)<=-1){FOc(b);i=d;return}g=b+72|0;k=c[g>>2]|0;c[f>>2]=c[b+76>>2];c[e+0>>2]=c[f+0>>2];eOb(k,e);c[g>>2]=0;FOc(b);i=d;return}function fSc(a){a=a|0;var b=0;b=i;eSc(a);ACi(a);i=b;return}function gSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+16|0;j=(c[b>>2]|0)-(c[h>>2]|0)|0;k=j>>>0<4?j:4;j=b+24|0;l=c[j>>2]|0;m=l+20|0;n=c[l+12>>2]|0;o=n-(c[m>>2]|0)+(c[l+16>>2]|0)|0;p=n+-1&c[m>>2];m=n-p|0;n=m>>>0<o>>>0?m:o;if(((n>>>0<k>>>0?n:k)|0)!=4){q=0;i=e;return q|0}c[(c[l>>2]|0)+p>>2]=c[d>>2];d=(c[j>>2]|0)+20|0;c[d>>2]=(c[d>>2]|0)+4;c[h>>2]=(c[h>>2]|0)+4;d=c[j>>2]|0;if(((c[d+12>>2]|0)-(c[d+20>>2]|0)|0)!=(0-(c[d+16>>2]|0)|0)){q=1;i=e;return q|0}if((c[b>>2]|0)==(c[h>>2]|0)){q=1;i=e;return q|0}h=xCi(28)|0;d=c[b+8>>2]|0;p=b+12|0;b=c[p>>2]|0;c[h+16>>2]=0;c[h+20>>2]=0;l=1<<31-(QEi((b<<1)+-1|0)|0);b=h+12|0;c[b>>2]=l;c[g>>2]=d;c[f+0>>2]=c[g+0>>2];c[h>>2]=cOb(l,16,f,0,3653512,112)|0;a[h+4>>0]=1;c[h+8>>2]=d;c[h+24>>2]=0;c[(c[j>>2]|0)+24>>2]=h;c[j>>2]=h;c[p>>2]=(c[p>>2]|0)+(c[b>>2]|0);q=1;i=e;return q|0}function hSc(b){b=b|0;return (a[b+124>>0]|0)!=0|0}function iSc(b){b=b|0;var d=0,e=0;d=i;e=xCi(72)|0;DRc(e);c[e>>2]=606936;a[e+68>>0]=b&1;wRc(vRc()|0,e);i=d;return e|0}function jSc(a){a=a|0;a=i;rfd(kfd()|0);i=a;return}function kSc(b){b=b|0;var c=0;c=i;BQc((a[b+68>>0]|0)!=0);g[b+60>>2]=ea(1.0);i=c;return}function lSc(a){a=a|0;var b=0;b=i;FOc(a);ACi(a);i=b;return}function mSc(a){a=a|0;return 0}function nSc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+12|0;n=g;c[l>>2]=c[e>>2];c[h+0>>2]=c[l+0>>2];jSb(d,h,f);c[d>>2]=607e3;f=d+132|0;l=d+24|0;e=l+60|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(e|0));a[f+0>>0]=1;a[f+1>>0]=1;a[f+2>>0]=1;a[f+3>>0]=1;a[f+4>>0]=1;c[d+140>>2]=1;c[d+144>>2]=1;c[d+148>>2]=0;a[d+152>>0]=1;a[d+153>>0]=0;a[d+154>>0]=1;a[d+155>>0]=0;c[d+224>>2]=0;f=d+264|0;o=d+276|0;c[d+308>>2]=0;c[d+312>>2]=0;p=d+304|0;l=d+240|0;e=l+64|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(e|0));c[p>>2]=60;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];p=cOb(32,16,h,0,3653512,80)|0;q=m+8|0;c[q>>2]=p;c[m>>2]=33;r=m+4|0;c[r>>2]=23;l=p+0|0;s=607104|0;e=l+23|0;do{a[l>>0]=a[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(e|0));a[p+23>>0]=0;do if((f|0)!=(m|0)){p=a[m>>0]|0;if(!(p&1)){t=(p&255)>>>1;u=m+1|0}else{t=c[r>>2]|0;u=c[q>>2]|0}p=a[f>>0]|0;if(!(p&1)){v=10;w=p}else{p=c[f>>2]|0;v=(p&-2)+-1|0;w=p&255}p=(w&1)==0;if(t>>>0>v>>>0){if(p)x=(w&255)>>>1;else x=c[d+268>>2]|0;eXb(f,v,t-v|0,x,0,x,t,u);break}if(p)y=f+1|0;else y=c[d+272>>2]|0;aFi(y|0,u|0,t|0)|0;a[y+t>>0]=0;if(!(a[f>>0]&1)){a[f>>0]=t<<1;break}else{c[d+268>>2]=t;break}}while(0);if(a[m>>0]&1){m=c[q>>2]|0;c[k>>2]=58;c[h+0>>2]=c[k+0>>2];eOb(m,h)}a[n>>0]=6;m=n+1|0;a[m+0>>0]=a[607128]|0;a[m+1>>0]=a[607129]|0;a[m+2>>0]=a[607130]|0;a[n+4>>0]=0;a:do if((o|0)!=(n|0)){k=a[o>>0]|0;do if(!(k&1))if(!(k&1))z=26;else z=25;else{q=c[o>>2]|0;t=q&-2;f=t+-1|0;y=(q&1|0)==0;if(f>>>0>=3)if(y){z=26;break}else{z=25;break}if(y)A=q>>>1&127;else A=c[d+280>>2]|0;eXb(o,f,4-t|0,A,0,A,3,m);break a}while(0);if((z|0)==25)B=c[d+284>>2]|0;else if((z|0)==26)B=o+1|0;aFi(B|0,m|0,3)|0;a[B+3>>0]=0;if(!(a[o>>0]&1)){a[o>>0]=6;break}else{c[d+280>>2]=3;break}}while(0);if(a[n>>0]&1){o=c[n+8>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(o,h)}a[d+175>>0]=1;a[d+176>>0]=1;c[d+128>>2]=1;c[d+112>>2]=1024;c[d+116>>2]=768;c[d+120>>2]=960;c[d+124>>2]=600;c[d+220>>2]=0;a[d+84>>0]=0;c[d+88>>2]=4;h=d+168|0;a[h+0>>0]=1;a[h+1>>0]=1;a[h+2>>0]=1;a[h+3>>0]=1;a[h+4>>0]=1;a[h+5>>0]=1;a[d+174>>0]=0;c[d+160>>2]=-1;c[d+156>>2]=-1;c[d+164>>2]=0;a[d+177>>0]=0;a[d+178>>0]=0;c[d+92>>2]=2;c[d+96>>2]=-1;c[d+100>>2]=-1;c[d+104>>2]=0;c[d+108>>2]=60;a[d+179>>0]=0;a[d+180>>0]=0;a[d+181>>0]=1;a[d+182>>0]=1;a[d+183>>0]=0;a[d+200>>0]=0;a[d+201>>0]=0;a[d+184>>0]=0;c[d+188>>2]=2;c[d+192>>2]=1;c[d+196>>2]=1;a[d+185>>0]=0;h=d+202|0;o=d+208|0;c[d+216>>2]=0;c[d+228>>2]=0;a[d+316>>0]=0;a[d+317>>0]=0;a[d+318>>0]=0;c[d+232>>2]=0;a[h+0>>0]=0;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;a[h+4>>0]=0;c[o+0>>2]=0;b[o+4>>1]=0;a[o+6>>0]=0;a[d+236>>0]=1;i=g;return}function oSc(){var a=0;a=i;Ydd(607136,607152,607176);Ydd(607136,607200,607224);Ydd(607136,607248,607272);Ydd(607136,607296,607320);Ydd(607136,607336,607360);i=a;return}function pSc(){var a=0;a=i;if(!(tVb(0)|0)){i=a;return}sSc(rVb(0)|0);i=a;return}function qSc(){var a=0,b=0;a=i;b=tVb(0)|0;i=a;return b|0}function rSc(){var a=0,b=0;a=i;b=rVb(0)|0;i=a;return b|0}function sSc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b;g=a+72|0;h=c[g>>2]|0;if(!h)j=0;else{c[e>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,e);k=c[d>>2]|0;l=c[h+28>>2]|0;if((k|0)==-1){m=l+(c[h+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((m|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[m+4>>2]|0,(h|0)!=0):0)n=h;else o=10}else o=10;if((o|0)==10)n=hQb(c[g>>2]|0)|0;j=n}n=a+76|0;a=c[n+4>>2]|0;g=f;c[g>>2]=c[n>>2];c[g+4>>2]=a;c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];qpe(j,d);i=b;return}function tSc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+140|0;e=c[d>>2]|0;if((e|0)<0)f=0;else f=(e|0)>3?3:e;c[d>>2]=f;f=a+148|0;a=c[f>>2]|0;if((a|0)<0){g=0;c[f>>2]=g;i=b;return}g=(a|0)>1?1:a;c[f>>2]=g;i=b;return}function uSc(a,b){a=a|0;b=b|0;var c=0;c=i;if((b+-1|0)>>>0<2?xnc()|0:0)sSc(a);i=c;return}function vSc(b){b=b|0;var d=0;if(!(a[621153]|0))d=0;else d=c[b+148>>2]|0;return d|0}function wSc(a){a=a|0;return c[a+140>>2]|0}function xSc(){var a=0;a=i;QQb(129,156,157,158,159);i=a;return}function ySc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,607136,14);wQb(129,6,b,320,2634,0,0);xri(b);i=a;return}function zSc(a){a=a|0;return 129}function ASc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,607136,a,0);ISc(a,b);bdd(b);i=c;return}function BSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,607136,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else JSc(a,b);sdd(b);i=d;return}function CSc(a,b){a=a|0;b=b|0;var c=0;c=i;KSc(a,b);i=c;return}function DSc(a,b){a=a|0;b=b|0;var c=0;c=i;LSc(a,b);i=c;return}function ESc(a,b){a=a|0;b=b|0;var c=0;c=i;MSc(a,b);i=c;return}function FSc(a,b){a=a|0;b=b|0;var c=0;c=i;NSc(a,b);i=c;return}function GSc(){return}function HSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(320,e,1,16,3653512,71)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];nSc(f,e,b);i=d;return f|0}function ISc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;KSb(a,b);ddd(b,6);add(b,607376,c[142258]|0,a+84|0,0);h=b+12|0;j=b+20|0;c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);k=c[142270]|0;add(b,607392,k,a+88|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607424,k,a+92|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);l=a+96|0;add(b,607440,k,l,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);if(!(c[l>>2]|0))c[l>>2]=-1;add(b,607464,k,a+100|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);l=a+104|0;add(b,607488,k,l,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);m=c[l>>2]|0;if((m|0)==2)c[l>>2]=0;else if((m|0)==1)c[l>>2]=6;add(b,607512,k,a+108|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);l=c[142294]|0;add(b,607536,l,a+24|0,0);$cd(b,2646336,2646336,e,1);m=c[142260]|0;add(b,3142592,m,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,607552,l,a+36|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,m,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,607568,l,a+60|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,m,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);m=a+72|0;add(b,607584,614680,m,0);l=e+8|0;n=l;c[n>>2]=0;c[n+4>>2]=0;c[e>>2]=0;add(b,792256,k,m,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,l,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);l=a+76|0;add(b,607600,c[142308]|0,l,0);m=c[($hd(b+16|0)|0)+20>>2]|2097152;c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+20>>2]=m;m=c[142268]|0;add(b,3143216,m,l,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,m,a+80|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);m=c[142270]|0;add(b,607616,m,a+112|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607640,m,a+116|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607176,m,a+120|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607224,m,a+124|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607664,m,a+140|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607680,m,a+144|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607704,m,a+148|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);m=c[142258]|0;add(b,607728,m,a+152|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,607744,m,a+153|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,607768,m,a+154|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,607784,m,a+155|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);l=c[142270]|0;add(b,607808,l,a+160|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607848,l,a+156|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607888,l,a+164|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607920,l,a+128|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,607944,m,a+168|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,607976,m,a+169|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608016,m,a+170|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);m=c[142258]|0;add(b,608056,m,a+171|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608096,m,a+172|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608120,m,a+173|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608144,m,a+174|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,608176,m,a+175|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608200,m,a+176|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608232,m,a+177|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608248,m,a+178|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608272,m,a+179|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608296,m,a+180|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,607360,m,a+181|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);m=c[142258]|0;add(b,608328,m,a+182|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608344,m,a+183|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608368,m,a+200|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608392,m,a+201|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608408,m,a+184|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608440,m,a+202|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608456,m,a+203|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608480,m,a+204|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608504,m,a+205|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608528,m,a+206|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608560,m,a+212|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);m=c[142258]|0;add(b,608584,m,a+185|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);l=c[142270]|0;add(b,608608,l,a+188|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,608632,l,a+192|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,608656,l,a+196|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);add(b,608680,c[142304]|0,a+208|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,608696,m,a+213|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608728,m,a+214|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,608744,l,a+216|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);m=a+224|0;add(b,608768,614680,m,0);k=e+8|0;n=k;c[n>>2]=0;c[n+4>>2]=0;c[e>>2]=0;add(b,792256,l,m,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,k,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);k=c[142270]|0;add(b,608784,k,a+228|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,608816,k,a+232|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,608832,c[142258]|0,a+236|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);m=a+132|0;add(b,608848,609048,m,0);QSc(m,b);bdd(b);m=c[142294]|0;add(b,607272,m,a+264|0,0);$cd(b,2646336,2646336,e,1);l=c[142260]|0;add(b,3142592,l,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,607320,m,a+276|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,l,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,608872,c[142306]|0,a+300|0,0);c[g>>2]=0;$cd(b,2646336,2646336,f,0);add(b,3142592,c[142276]|0,g,0);f=e+8|0;l=f;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,k,g,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,f,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);f=c[142258]|0;add(b,608888,f,a+316|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608928,f,a+317|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,608968,f,a+318|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function JSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+4|0;g=e;LSb(b,d);rdd(d,6);h=b+84|0;j=c[142258]|0;k=qdd(d,607376,j,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[l>>2]=o;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+88|0;k=c[142270]|0;l=qdd(d,607392,k,f,0)|0;if(l){if((l|0)>0){l=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[l>>2]=m;if((n|0)>=0?(p=o+(n+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[m>>2];c[l>>2]=p}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}h=b+92|0;l=qdd(d,607424,k,f,0)|0;if(l){if((l|0)>0){l=d+12|0;p=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+m|0;c[l>>2]=n;if((m|0)>=0?(o=p+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[l>>2]=o}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}h=b+96|0;l=qdd(d,607440,k,f,0)|0;if(l){if((l|0)>0){l=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[l>>2]=m;if((n|0)>=0?(p=o+(n+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[m>>2];c[l>>2]=p}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}if(!(c[h>>2]|0))c[h>>2]=-1;h=b+100|0;l=qdd(d,607464,k,f,0)|0;if(l){if((l|0)>0){l=d+12|0;p=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+m|0;c[l>>2]=n;if((m|0)>=0?(o=p+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[l>>2]=o}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}h=b+104|0;l=qdd(d,607488,k,f,0)|0;if(l){if((l|0)>0){l=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[l>>2]=m;if((n|0)>=0?(p=o+(n+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[m>>2];c[l>>2]=p}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}l=c[h>>2]|0;if((l|0)==2)c[h>>2]=0;else if((l|0)==1)c[h>>2]=6;h=b+108|0;l=qdd(d,607512,k,f,0)|0;if(l){if((l|0)>0){l=d+12|0;p=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+m|0;c[l>>2]=n;if((m|0)>=0?(o=p+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[l>>2]=o}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}h=b+24|0;l=c[142294]|0;o=qdd(d,607536,l,f,0)|0;if(o){if((o|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}else zXb(d,h,1);sdd(d)}h=b+36|0;o=qdd(d,607552,l,f,0)|0;if(o){if((o|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}else zXb(d,h,1);sdd(d)}h=b+60|0;o=qdd(d,607568,l,f,0)|0;if(o){if((o|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}else zXb(d,h,1);sdd(d)}h=b+72|0;o=qdd(d,607584,614680,f,1)|0;if(o){if((o|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}else g9b(h,d);sdd(d)}h=b+76|0;o=qdd(d,607600,c[142308]|0,f,1)|0;if(o){if((o|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}else hgc(h,d);sdd(d)}h=b+112|0;o=qdd(d,607616,k,f,0)|0;if(o){if((o|0)>0){o=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+m|0;c[o>>2]=p;if((m|0)>=0?(q=n+(m+4)|0,q>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[p>>2];c[o>>2]=q}else Bid(o,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}sdd(d)}h=b+116|0;o=qdd(d,607640,k,f,0)|0;if(o){if((o|0)>0){o=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[o>>2]=m;do if((p|0)<0)r=127;else{n=q+(p+4)|0;if(n>>>0>(c[d+20>>2]|0)>>>0){r=127;break}c[h>>2]=c[m>>2];c[o>>2]=n}while(0);if((r|0)==127)Bid(o,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}sdd(d)}h=b+120|0;o=qdd(d,607176,k,f,0)|0;if(o){do if((o|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)<0)r=138;else{s=p+(q+4)|0;if(s>>>0>(c[d+20>>2]|0)>>>0){r=138;break}c[h>>2]=c[n>>2];c[m>>2]=s}while(0);if((r|0)==138)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}while(0);sdd(d)}h=b+124|0;o=qdd(d,607224,k,f,0)|0;if(o){do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)<0)r=149;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=149;break}c[h>>2]=c[s>>2];c[n>>2]=t}while(0);if((r|0)==149)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+140|0;o=qdd(d,607664,k,f,0)|0;if(o){do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)<0)r=160;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=160;break}c[h>>2]=c[m>>2];c[s>>2]=t}while(0);if((r|0)==160)Bid(s,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+144|0;o=qdd(d,607680,k,f,0)|0;if(o){do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)<0)r=171;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=171;break}c[h>>2]=c[n>>2];c[m>>2]=t}while(0);if((r|0)==171)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+148|0;o=qdd(d,607704,k,f,0)|0;if(o){do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)<0)r=182;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=182;break}c[h>>2]=c[s>>2];c[n>>2]=t}while(0);if((r|0)==182)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+152|0;o=qdd(d,607728,j,f,0)|0;if(o){a:do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break a}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+153|0;o=qdd(d,607744,j,f,0)|0;if(o){b:do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break b}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+154|0;o=qdd(d,607768,j,f,0)|0;if(o){c:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break c}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+155|0;o=qdd(d,607784,j,f,0)|0;if(o){d:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break d}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+160|0;o=qdd(d,607808,k,f,0)|0;if(o){do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)<0)r=229;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=229;break}c[h>>2]=c[n>>2];c[m>>2]=t}while(0);if((r|0)==229)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+156|0;o=qdd(d,607848,k,f,0)|0;if(o){do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)<0)r=240;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=240;break}c[h>>2]=c[s>>2];c[n>>2]=t}while(0);if((r|0)==240)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+164|0;o=qdd(d,607888,k,f,0)|0;if(o){do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)<0)r=251;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=251;break}c[h>>2]=c[m>>2];c[s>>2]=t}while(0);if((r|0)==251)Bid(s,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+128|0;o=qdd(d,607920,k,f,0)|0;if(o){do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)<0)r=262;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=262;break}c[h>>2]=c[n>>2];c[m>>2]=t}while(0);if((r|0)==262)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+168|0;o=qdd(d,607944,j,f,0)|0;if(o){e:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break e}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+169|0;o=qdd(d,607976,j,f,0)|0;if(o){f:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break f}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+170|0;o=qdd(d,608016,j,f,0)|0;if(o){g:do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break g}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+171|0;o=qdd(d,608056,j,f,0)|0;if(o){h:do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break h}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+172|0;o=qdd(d,608096,j,f,0)|0;if(o){i:do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break i}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+173|0;o=qdd(d,608120,j,f,0)|0;if(o){j:do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break j}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+174|0;o=qdd(d,608144,j,f,0)|0;if(o){k:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break k}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+175|0;o=qdd(d,608176,j,f,0)|0;if(o){l:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break l}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+176|0;o=qdd(d,608200,j,f,0)|0;if(o){m:do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break m}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+177|0;o=qdd(d,608232,j,f,0)|0;if(o){n:do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break n}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+178|0;o=qdd(d,608248,j,f,0)|0;if(o){o:do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break o}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+179|0;o=qdd(d,608272,j,f,0)|0;if(o){p:do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break p}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+180|0;o=qdd(d,608296,j,f,0)|0;if(o){q:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break q}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+181|0;o=qdd(d,607360,j,f,0)|0;if(o){r:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break r}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+182|0;o=qdd(d,608328,j,f,0)|0;if(o){s:do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break s}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+183|0;o=qdd(d,608344,j,f,0)|0;if(o){t:do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break t}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+200|0;o=qdd(d,608368,j,f,0)|0;if(o){u:do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break u}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+201|0;o=qdd(d,608392,j,f,0)|0;if(o){v:do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break v}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+184|0;o=qdd(d,608408,j,f,0)|0;if(o){w:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break w}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+202|0;o=qdd(d,608440,j,f,0)|0;if(o){x:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break x}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+203|0;o=qdd(d,608456,j,f,0)|0;if(o){y:do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break y}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+204|0;o=qdd(d,608480,j,f,0)|0;if(o){z:do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break z}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+205|0;o=qdd(d,608504,j,f,0)|0;if(o){A:do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break A}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+206|0;o=qdd(d,608528,j,f,0)|0;if(o){B:do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break B}while(0);Bid(m,h,1)}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+212|0;o=qdd(d,608560,j,f,0)|0;if(o){C:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break C}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+185|0;o=qdd(d,608584,j,f,0)|0;if(o){D:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break D}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+188|0;o=qdd(d,608608,k,f,0)|0;if(o){do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)<0)r=507;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=507;break}c[h>>2]=c[n>>2];c[m>>2]=t}while(0);if((r|0)==507)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+192|0;o=qdd(d,608632,k,f,0)|0;if(o){do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)<0)r=518;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=518;break}c[h>>2]=c[s>>2];c[n>>2]=t}while(0);if((r|0)==518)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+196|0;o=qdd(d,608656,k,f,0)|0;if(o){do if((o|0)>0){s=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=q+p|0;c[s>>2]=m;do if((p|0)<0)r=529;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=529;break}c[h>>2]=c[m>>2];c[s>>2]=t}while(0);if((r|0)==529)Bid(s,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+208|0;o=qdd(d,608680,c[142304]|0,f,0)|0;if(o){do if((o|0)>0){m=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=p+q|0;c[m>>2]=n;do if((q|0)<0)r=540;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=540;break}c[h>>2]=c[n>>2];c[m>>2]=t}while(0);if((r|0)==540)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+213|0;o=qdd(d,608696,j,f,0)|0;if(o){E:do if((o|0)>0){n=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=q+p|0;c[n>>2]=s;do if((p|0)>=0){if((q+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break E}while(0);Bid(n,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+214|0;o=qdd(d,608728,j,f,0)|0;if(o){F:do if((o|0)>0){s=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=p+q|0;c[s>>2]=m;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break F}while(0);Bid(s,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+216|0;o=qdd(d,608744,k,f,0)|0;if(o){do if((o|0)>0){m=d+12|0;q=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=q+p|0;c[m>>2]=n;do if((p|0)<0)r=569;else{t=q+(p+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=569;break}c[h>>2]=c[n>>2];c[m>>2]=t}while(0);if((r|0)==569)Bid(m,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+224|0;o=qdd(d,608768,614680,f,1)|0;if(o){do if((o|0)>0)g9b(h,d);else{n=c[f>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+228|0;o=qdd(d,608784,k,f,0)|0;if(o){do if((o|0)>0){n=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[n>>2]=s;do if((q|0)<0)r=586;else{t=p+(q+4)|0;if(t>>>0>(c[d+20>>2]|0)>>>0){r=586;break}c[h>>2]=c[s>>2];c[n>>2]=t}while(0);if((r|0)==586)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+232|0;o=qdd(d,608816,k,f,0)|0;if(o){do if((o|0)>0){k=d+12|0;s=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=s+q|0;c[k>>2]=p;do if((q|0)<0)r=597;else{m=s+(q+4)|0;if(m>>>0>(c[d+20>>2]|0)>>>0){r=597;break}c[h>>2]=c[p>>2];c[k>>2]=m}while(0);if((r|0)==597)Bid(k,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{p=c[f>>2]|0;if(!p)break;_n[p&4095](h,d)|0}while(0);sdd(d)}h=b+236|0;r=qdd(d,608832,j,f,0)|0;if(r){G:do if((r|0)>0){o=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;s=p+q|0;c[o>>2]=s;do if((q|0)>=0){if((p+(q+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[s>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break G}while(0);Bid(o,h,1)}else{s=c[f>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+132|0;r=qdd(d,608848,609048,g,1)|0;if(r){do if((r|0)>0){s=b+133|0;q=qdd(d,609016,j,f,0)|0;if(q){H:do if((q|0)>0){p=d+12|0;k=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=k+n|0;c[p>>2]=m;do if((n|0)>=0){if((k+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[s>>0]=a[m>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break H}while(0);Bid(p,s,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](s,d)|0}while(0);sdd(d)}s=b+134|0;q=qdd(d,609024,j,f,0)|0;if(q){I:do if((q|0)>0){o=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=m+n|0;c[o>>2]=k;do if((n|0)>=0){if((m+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[s>>0]=a[k>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break I}while(0);Bid(o,s,1)}else{k=c[f>>2]|0;if(!k)break;_n[k&4095](s,d)|0}while(0);sdd(d)}s=b+135|0;q=qdd(d,609032,j,f,0)|0;if(q){J:do if((q|0)>0){k=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+m|0;c[k>>2]=p;do if((m|0)>=0){if((n+(m+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[s>>0]=a[p>>0]|0;c[k>>2]=(c[k>>2]|0)+1;break J}while(0);Bid(k,s,1)}else{p=c[f>>2]|0;if(!p)break;_n[p&4095](s,d)|0}while(0);sdd(d)}s=b+136|0;q=qdd(d,609040,j,f,0)|0;if(q){K:do if((q|0)>0){p=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[p>>2]=o;do if((n|0)>=0){if((m+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[s>>0]=a[o>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break K}while(0);Bid(p,s,1)}else{o=c[f>>2]|0;if(!o)break;_n[o&4095](s,d)|0}while(0);sdd(d)}s=qdd(d,609008,j,f,0)|0;if(!s)break;L:do if((s|0)>0){q=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[q>>2]=m;do if((n|0)>=0){if((o+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[q>>2]=(c[q>>2]|0)+1;break L}while(0);Bid(q,h,1)}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}else{s=c[g>>2]|0;if(!s)break;_n[s&4095](h,d)|0}while(0);sdd(d)}h=b+264|0;f=qdd(d,607272,l,g,0)|0;if(f){do if((f|0)>0)zXb(d,h,1);else{r=c[g>>2]|0;if(!r)break;_n[r&4095](h,d)|0}while(0);sdd(d)}h=b+276|0;f=qdd(d,607320,l,g,0)|0;if(f){do if((f|0)>0)zXb(d,h,1);else{l=c[g>>2]|0;if(!l)break;_n[l&4095](h,d)|0}while(0);sdd(d)}h=b+300|0;f=qdd(d,608872,c[142306]|0,g,1)|0;if(f){do if((f|0)>0)ANc(d,h,0);else{l=c[g>>2]|0;if(!l)break;_n[l&4095](h,d)|0}while(0);sdd(d)}h=b+316|0;f=qdd(d,608888,j,g,0)|0;if(f){M:do if((f|0)>0){l=d+12|0;r=c[d+16>>2]|0;s=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=r+s|0;c[l>>2]=m;do if((s|0)>=0){if((r+(s+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[m>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break M}while(0);Bid(l,h,1)}else{m=c[g>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+317|0;f=qdd(d,608928,j,g,0)|0;if(f){N:do if((f|0)>0){m=d+12|0;s=c[d+16>>2]|0;r=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=s+r|0;c[m>>2]=n;do if((r|0)>=0){if((s+(r+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break N}while(0);Bid(m,h,1)}else{n=c[g>>2]|0;if(!n)break;_n[n&4095](h,d)|0}while(0);sdd(d)}h=b+318|0;b=qdd(d,608968,j,g,0)|0;if(!b){i=e;return}O:do if((b|0)>0){j=d+12|0;f=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=f+n|0;c[j>>2]=r;do if((n|0)>=0){if((f+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[r>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break O}while(0);Bid(j,h,1)}else{r=c[g>>2]|0;if(!r)break;_n[r&4095](h,d)|0}while(0);sdd(d);i=e;return}function KSc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;e=i;MSb(b,d);f=b+84|0;h=d+12|0;j=c[h>>2]|0;k=d+20|0;if((j+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,f,1);else{a[f>>0]=a[j>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);j=b+88|0;f=c[h>>2]|0;l=f+4|0;m=c[k>>2]|0;if(l>>>0>m>>>0){Bid(h,j,4);n=c[h>>2]|0;o=c[k>>2]|0}else{c[j>>2]=c[f>>2];c[h>>2]=l;n=l;o=m}m=b+92|0;l=n+4|0;if(l>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[k>>2]|0}else{c[m>>2]=c[n>>2];c[h>>2]=l;p=l;q=o}o=b+96|0;l=p+4|0;if(l>>>0>q>>>0){Bid(h,o,4);r=c[o>>2]|0}else{q=c[p>>2]|0;c[o>>2]=q;c[h>>2]=l;r=q}if(!r)c[o>>2]=-1;o=b+100|0;r=c[h>>2]|0;q=r+4|0;l=c[k>>2]|0;if(q>>>0>l>>>0){Bid(h,o,4);s=c[h>>2]|0;t=c[k>>2]|0}else{c[o>>2]=c[r>>2];c[h>>2]=q;s=q;t=l}l=b+104|0;q=s+4|0;if(q>>>0>t>>>0){Bid(h,l,4);u=c[l>>2]|0}else{t=c[s>>2]|0;c[l>>2]=t;c[h>>2]=q;u=t}if((u|0)==1)c[l>>2]=6;else if((u|0)==2)c[l>>2]=0;l=b+108|0;u=c[h>>2]|0;t=u+4|0;if(t>>>0>(c[k>>2]|0)>>>0)Bid(h,l,4);else{c[l>>2]=c[u>>2];c[h>>2]=t}Ndd(d);NXb(d,b+24|0,1);Ndd(d);NXb(d,b+36|0,1);Ndd(d);NXb(d,b+60|0,1);Ndd(d);k9b(b+72|0,d);t=b+76|0;u=c[h>>2]|0;l=u+4|0;q=c[k>>2]|0;if(l>>>0>q>>>0){Bid(h,t,4);v=c[h>>2]|0;w=c[k>>2]|0}else{g[t>>2]=ea(g[u>>2]);c[h>>2]=l;v=l;w=q}q=b+80|0;l=v+4|0;if(l>>>0>w>>>0){Bid(h,q,4);x=c[h>>2]|0;y=c[k>>2]|0}else{g[q>>2]=ea(g[v>>2]);c[h>>2]=l;x=l;y=w}w=b+112|0;l=x+4|0;if(l>>>0>y>>>0){Bid(h,w,4);z=c[h>>2]|0;A=c[k>>2]|0}else{c[w>>2]=c[x>>2];c[h>>2]=l;z=l;A=y}y=b+116|0;l=z+4|0;if(l>>>0>A>>>0){Bid(h,y,4);B=c[h>>2]|0;C=c[k>>2]|0}else{c[y>>2]=c[z>>2];c[h>>2]=l;B=l;C=A}A=b+120|0;l=B+4|0;if(l>>>0>C>>>0){Bid(h,A,4);D=c[h>>2]|0;E=c[k>>2]|0}else{c[A>>2]=c[B>>2];c[h>>2]=l;D=l;E=C}C=b+124|0;l=D+4|0;if(l>>>0>E>>>0){Bid(h,C,4);F=c[h>>2]|0;G=c[k>>2]|0}else{c[C>>2]=c[D>>2];c[h>>2]=l;F=l;G=E}E=b+140|0;l=F+4|0;if(l>>>0>G>>>0){Bid(h,E,4);H=c[h>>2]|0;I=c[k>>2]|0}else{c[E>>2]=c[F>>2];c[h>>2]=l;H=l;I=G}G=b+144|0;l=H+4|0;if(l>>>0>I>>>0){Bid(h,G,4);J=c[h>>2]|0;K=c[k>>2]|0}else{c[G>>2]=c[H>>2];c[h>>2]=l;J=l;K=I}I=b+148|0;l=J+4|0;if(l>>>0>K>>>0){Bid(h,I,4);L=c[h>>2]|0;M=c[k>>2]|0}else{c[I>>2]=c[J>>2];c[h>>2]=l;L=l;M=K}K=b+152|0;if((L+1|0)>>>0>M>>>0){Bid(h,K,1);N=c[h>>2]|0}else{a[K>>0]=a[L>>0]|0;L=(c[h>>2]|0)+1|0;c[h>>2]=L;N=L}L=b+153|0;if((N+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,L,1);O=c[h>>2]|0}else{a[L>>0]=a[N>>0]|0;N=(c[h>>2]|0)+1|0;c[h>>2]=N;O=N}N=b+154|0;if((O+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,N,1);P=c[h>>2]|0}else{a[N>>0]=a[O>>0]|0;O=(c[h>>2]|0)+1|0;c[h>>2]=O;P=O}O=b+155|0;if((P+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,O,1);else{a[O>>0]=a[P>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);P=b+160|0;O=c[h>>2]|0;N=O+4|0;L=c[k>>2]|0;if(N>>>0>L>>>0){Bid(h,P,4);Q=c[h>>2]|0;R=c[k>>2]|0}else{c[P>>2]=c[O>>2];c[h>>2]=N;Q=N;R=L}L=b+156|0;N=Q+4|0;if(N>>>0>R>>>0){Bid(h,L,4);S=c[h>>2]|0;T=c[k>>2]|0}else{c[L>>2]=c[Q>>2];c[h>>2]=N;S=N;T=R}R=b+164|0;N=S+4|0;if(N>>>0>T>>>0){Bid(h,R,4);U=c[h>>2]|0;V=c[k>>2]|0}else{c[R>>2]=c[S>>2];c[h>>2]=N;U=N;V=T}T=b+128|0;N=U+4|0;if(N>>>0>V>>>0){Bid(h,T,4);W=c[h>>2]|0;X=c[k>>2]|0}else{c[T>>2]=c[U>>2];c[h>>2]=N;W=N;X=V}V=b+168|0;if((W+1|0)>>>0>X>>>0){Bid(h,V,1);Y=c[h>>2]|0}else{a[V>>0]=a[W>>0]|0;W=(c[h>>2]|0)+1|0;c[h>>2]=W;Y=W}W=b+169|0;if((Y+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,W,1);Z=c[h>>2]|0}else{a[W>>0]=a[Y>>0]|0;Y=(c[h>>2]|0)+1|0;c[h>>2]=Y;Z=Y}Y=b+170|0;if((Z+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,Y,1);_=c[h>>2]|0}else{a[Y>>0]=a[Z>>0]|0;Z=(c[h>>2]|0)+1|0;c[h>>2]=Z;_=Z}Z=b+171|0;if((_+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,Z,1);$=c[h>>2]|0}else{a[Z>>0]=a[_>>0]|0;_=(c[h>>2]|0)+1|0;c[h>>2]=_;$=_}_=b+172|0;if(($+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,_,1);aa=c[h>>2]|0}else{a[_>>0]=a[$>>0]|0;$=(c[h>>2]|0)+1|0;c[h>>2]=$;aa=$}$=b+173|0;if((aa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,$,1);ba=c[h>>2]|0}else{a[$>>0]=a[aa>>0]|0;aa=(c[h>>2]|0)+1|0;c[h>>2]=aa;ba=aa}aa=b+174|0;if((ba+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,aa,1);else{a[aa>>0]=a[ba>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);ba=b+175|0;aa=c[h>>2]|0;if((aa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ba,1);ca=c[h>>2]|0}else{a[ba>>0]=a[aa>>0]|0;aa=(c[h>>2]|0)+1|0;c[h>>2]=aa;ca=aa}aa=b+176|0;if((ca+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,aa,1);da=c[h>>2]|0}else{a[aa>>0]=a[ca>>0]|0;ca=(c[h>>2]|0)+1|0;c[h>>2]=ca;da=ca}ca=b+177|0;if((da+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ca,1);fa=c[h>>2]|0}else{a[ca>>0]=a[da>>0]|0;da=(c[h>>2]|0)+1|0;c[h>>2]=da;fa=da}da=b+178|0;if((fa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,da,1);ga=c[h>>2]|0}else{a[da>>0]=a[fa>>0]|0;fa=(c[h>>2]|0)+1|0;c[h>>2]=fa;ga=fa}fa=b+179|0;if((ga+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,fa,1);ha=c[h>>2]|0}else{a[fa>>0]=a[ga>>0]|0;ga=(c[h>>2]|0)+1|0;c[h>>2]=ga;ha=ga}ga=b+180|0;if((ha+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ga,1);ia=c[h>>2]|0}else{a[ga>>0]=a[ha>>0]|0;ha=(c[h>>2]|0)+1|0;c[h>>2]=ha;ia=ha}ha=b+181|0;if((ia+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ha,1);ja=c[h>>2]|0}else{a[ha>>0]=a[ia>>0]|0;ia=(c[h>>2]|0)+1|0;c[h>>2]=ia;ja=ia}ia=b+182|0;if((ja+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ia,1);ka=c[h>>2]|0}else{a[ia>>0]=a[ja>>0]|0;ja=(c[h>>2]|0)+1|0;c[h>>2]=ja;ka=ja}ja=b+183|0;if((ka+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ja,1);la=c[h>>2]|0}else{a[ja>>0]=a[ka>>0]|0;ka=(c[h>>2]|0)+1|0;c[h>>2]=ka;la=ka}ka=b+200|0;if((la+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ka,1);ma=c[h>>2]|0}else{a[ka>>0]=a[la>>0]|0;la=(c[h>>2]|0)+1|0;c[h>>2]=la;ma=la}la=b+201|0;if((ma+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,la,1);na=c[h>>2]|0}else{a[la>>0]=a[ma>>0]|0;ma=(c[h>>2]|0)+1|0;c[h>>2]=ma;na=ma}ma=b+184|0;if((na+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ma,1);oa=c[h>>2]|0}else{a[ma>>0]=a[na>>0]|0;na=(c[h>>2]|0)+1|0;c[h>>2]=na;oa=na}na=b+202|0;if((oa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,na,1);pa=c[h>>2]|0}else{a[na>>0]=a[oa>>0]|0;oa=(c[h>>2]|0)+1|0;c[h>>2]=oa;pa=oa}oa=b+203|0;if((pa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,oa,1);qa=c[h>>2]|0}else{a[oa>>0]=a[pa>>0]|0;pa=(c[h>>2]|0)+1|0;c[h>>2]=pa;qa=pa}pa=b+204|0;if((qa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,pa,1);ra=c[h>>2]|0}else{a[pa>>0]=a[qa>>0]|0;qa=(c[h>>2]|0)+1|0;c[h>>2]=qa;ra=qa}qa=b+205|0;if((ra+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,qa,1);sa=c[h>>2]|0}else{a[qa>>0]=a[ra>>0]|0;ra=(c[h>>2]|0)+1|0;c[h>>2]=ra;sa=ra}ra=b+206|0;if((sa+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,ra,1);ta=c[h>>2]|0}else{a[ra>>0]=a[sa>>0]|0;sa=(c[h>>2]|0)+1|0;c[h>>2]=sa;ta=sa}sa=b+212|0;if((ta+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,sa,1);ua=c[h>>2]|0}else{a[sa>>0]=a[ta>>0]|0;ta=(c[h>>2]|0)+1|0;c[h>>2]=ta;ua=ta}ta=b+185|0;if((ua+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,ta,1);else{a[ta>>0]=a[ua>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);ua=b+188|0;ta=c[h>>2]|0;sa=ta+4|0;ra=c[k>>2]|0;if(sa>>>0>ra>>>0){Bid(h,ua,4);va=c[h>>2]|0;wa=c[k>>2]|0}else{c[ua>>2]=c[ta>>2];c[h>>2]=sa;va=sa;wa=ra}ra=b+192|0;sa=va+4|0;if(sa>>>0>wa>>>0){Bid(h,ra,4);xa=c[h>>2]|0;ya=c[k>>2]|0}else{c[ra>>2]=c[va>>2];c[h>>2]=sa;xa=sa;ya=wa}wa=b+196|0;sa=xa+4|0;if(sa>>>0>ya>>>0)Bid(h,wa,4);else{c[wa>>2]=c[xa>>2];c[h>>2]=sa}Ndd(d);sa=b+208|0;xa=c[h>>2]|0;wa=xa+4|0;ya=c[k>>2]|0;if(wa>>>0>ya>>>0){Bid(h,sa,4);za=c[h>>2]|0;Aa=c[k>>2]|0}else{c[sa>>2]=c[xa>>2];c[h>>2]=wa;za=wa;Aa=ya}ya=b+213|0;if((za+1|0)>>>0>Aa>>>0){Bid(h,ya,1);Ba=c[h>>2]|0}else{a[ya>>0]=a[za>>0]|0;za=(c[h>>2]|0)+1|0;c[h>>2]=za;Ba=za}za=b+214|0;if((Ba+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(h,za,1);else{a[za>>0]=a[Ba>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);Ba=b+216|0;za=c[h>>2]|0;ya=za+4|0;if(ya>>>0>(c[k>>2]|0)>>>0)Bid(h,Ba,4);else{c[Ba>>2]=c[za>>2];c[h>>2]=ya}Ndd(d);k9b(b+224|0,d);ya=b+228|0;za=c[h>>2]|0;Ba=za+4|0;Aa=c[k>>2]|0;if(Ba>>>0>Aa>>>0){Bid(h,ya,4);Ca=c[h>>2]|0;Da=c[k>>2]|0}else{c[ya>>2]=c[za>>2];c[h>>2]=Ba;Ca=Ba;Da=Aa}Aa=b+232|0;Ba=Ca+4|0;if(Ba>>>0>Da>>>0){Bid(h,Aa,4);Ea=c[h>>2]|0;Fa=c[k>>2]|0}else{c[Aa>>2]=c[Ca>>2];c[h>>2]=Ba;Ea=Ba;Fa=Da}Da=b+236|0;if((Ea+1|0)>>>0>Fa>>>0)Bid(h,Da,1);else{a[Da>>0]=a[Ea>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);RSc(b+132|0,d);NXb(d,b+264|0,1);Ndd(d);NXb(d,b+276|0,1);Ndd(d);ENc(d,b+300|0,0);Ea=b+316|0;Da=c[h>>2]|0;if((Da+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,Ea,1);Ga=c[h>>2]|0}else{a[Ea>>0]=a[Da>>0]|0;Da=(c[h>>2]|0)+1|0;c[h>>2]=Da;Ga=Da}Da=b+317|0;if((Ga+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,Da,1);Ha=c[h>>2]|0}else{a[Da>>0]=a[Ga>>0]|0;Ga=(c[h>>2]|0)+1|0;c[h>>2]=Ga;Ha=Ga}Ga=b+318|0;if((Ha+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(h,Ga,1);Ndd(d);i=e;return}else{a[Ga>>0]=a[Ha>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Ndd(d);i=e;return}}
function LSc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0;e=i;NSb(b,d);f=b+84|0;h=d+12|0;j=c[h>>2]|0;l=d+20|0;if((j+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,f,1);else{a[f>>0]=a[j>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);j=b+88|0;f=c[h>>2]|0;m=f+4|0;n=c[l>>2]|0;if(m>>>0>n>>>0){Bid(h,j,4);o=c[j>>2]|0;p=c[h>>2]|0;q=c[l>>2]|0}else{r=c[f>>2]|0;c[j>>2]=r;c[h>>2]=m;o=r;p=m;q=n}c[j>>2]=XEi(o|0)|0;o=b+92|0;j=p+4|0;if(j>>>0>q>>>0){Bid(h,o,4);s=c[o>>2]|0;t=c[h>>2]|0;u=c[l>>2]|0}else{n=c[p>>2]|0;c[o>>2]=n;c[h>>2]=j;s=n;t=j;u=q}c[o>>2]=XEi(s|0)|0;s=b+96|0;o=t+4|0;if(o>>>0>u>>>0){Bid(h,s,4);v=c[s>>2]|0;w=c[h>>2]|0;x=c[l>>2]|0}else{q=c[t>>2]|0;c[s>>2]=q;c[h>>2]=o;v=q;w=o;x=u}u=XEi(v|0)|0;c[s>>2]=(v|0)==0?-1:u;u=b+100|0;v=w+4|0;if(v>>>0>x>>>0){Bid(h,u,4);y=c[u>>2]|0;z=c[h>>2]|0;A=c[l>>2]|0}else{s=c[w>>2]|0;c[u>>2]=s;c[h>>2]=v;y=s;z=v;A=x}c[u>>2]=XEi(y|0)|0;y=b+104|0;u=z+4|0;if(u>>>0>A>>>0){Bid(h,y,4);B=c[y>>2]|0}else{A=c[z>>2]|0;c[y>>2]=A;c[h>>2]=u;B=A}A=XEi(B|0)|0;c[y>>2]=A;if((A|0)==2)c[y>>2]=0;else if((A|0)==1)c[y>>2]=6;y=b+108|0;A=c[h>>2]|0;B=A+4|0;if(B>>>0>(c[l>>2]|0)>>>0){Bid(h,y,4);C=c[y>>2]|0}else{u=c[A>>2]|0;c[y>>2]=u;c[h>>2]=B;C=u}c[y>>2]=XEi(C|0)|0;Mdd(d);OXb(d,b+24|0,1);Mdd(d);OXb(d,b+36|0,1);Mdd(d);OXb(d,b+60|0,1);Mdd(d);n9b(b+72|0,d);C=b+76|0;y=c[h>>2]|0;u=y+4|0;B=c[l>>2]|0;if(u>>>0>B>>>0){Bid(h,C,4);D=C;E=c[C>>2]|0;F=c[h>>2]|0;G=c[l>>2]|0}else{H=ea(g[y>>2]);g[C>>2]=H;c[h>>2]=u;D=C;E=(g[k>>2]=H,c[k>>2]|0);F=u;G=B}c[D>>2]=XEi(E|0)|0;E=b+80|0;D=F+4|0;if(D>>>0>G>>>0){Bid(h,E,4);I=E;J=c[E>>2]|0;K=c[h>>2]|0;L=c[l>>2]|0}else{H=ea(g[F>>2]);g[E>>2]=H;c[h>>2]=D;I=E;J=(g[k>>2]=H,c[k>>2]|0);K=D;L=G}c[I>>2]=XEi(J|0)|0;J=b+112|0;I=K+4|0;if(I>>>0>L>>>0){Bid(h,J,4);M=c[J>>2]|0;N=c[h>>2]|0;O=c[l>>2]|0}else{G=c[K>>2]|0;c[J>>2]=G;c[h>>2]=I;M=G;N=I;O=L}c[J>>2]=XEi(M|0)|0;M=b+116|0;J=N+4|0;if(J>>>0>O>>>0){Bid(h,M,4);P=c[l>>2]|0;Q=c[M>>2]|0;R=c[h>>2]|0}else{L=c[N>>2]|0;c[M>>2]=L;c[h>>2]=J;P=O;Q=L;R=J}c[M>>2]=XEi(Q|0)|0;Q=b+120|0;M=R+4|0;if(M>>>0>P>>>0){Bid(h,Q,4);S=c[Q>>2]|0;T=c[h>>2]|0;U=c[l>>2]|0}else{J=c[R>>2]|0;c[Q>>2]=J;c[h>>2]=M;S=J;T=M;U=P}c[Q>>2]=XEi(S|0)|0;S=b+124|0;Q=T+4|0;if(Q>>>0>U>>>0){Bid(h,S,4);V=c[S>>2]|0;W=c[h>>2]|0;X=c[l>>2]|0}else{P=c[T>>2]|0;c[S>>2]=P;c[h>>2]=Q;V=P;W=Q;X=U}c[S>>2]=XEi(V|0)|0;V=b+140|0;S=W+4|0;if(S>>>0>X>>>0){Bid(h,V,4);Y=c[V>>2]|0;Z=c[h>>2]|0;_=c[l>>2]|0}else{U=c[W>>2]|0;c[V>>2]=U;c[h>>2]=S;Y=U;Z=S;_=X}c[V>>2]=XEi(Y|0)|0;Y=b+144|0;V=Z+4|0;if(V>>>0>_>>>0){Bid(h,Y,4);$=c[Y>>2]|0;aa=c[h>>2]|0;ba=c[l>>2]|0}else{X=c[Z>>2]|0;c[Y>>2]=X;c[h>>2]=V;$=X;aa=V;ba=_}c[Y>>2]=XEi($|0)|0;$=b+148|0;Y=aa+4|0;if(Y>>>0>ba>>>0){Bid(h,$,4);ca=c[$>>2]|0;da=c[h>>2]|0;fa=c[l>>2]|0}else{_=c[aa>>2]|0;c[$>>2]=_;c[h>>2]=Y;ca=_;da=Y;fa=ba}c[$>>2]=XEi(ca|0)|0;ca=b+152|0;if((da+1|0)>>>0>fa>>>0){Bid(h,ca,1);ga=c[h>>2]|0}else{a[ca>>0]=a[da>>0]|0;da=(c[h>>2]|0)+1|0;c[h>>2]=da;ga=da}da=b+153|0;if((ga+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,da,1);ha=c[h>>2]|0}else{a[da>>0]=a[ga>>0]|0;ga=(c[h>>2]|0)+1|0;c[h>>2]=ga;ha=ga}ga=b+154|0;if((ha+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,ga,1);ia=c[h>>2]|0}else{a[ga>>0]=a[ha>>0]|0;ha=(c[h>>2]|0)+1|0;c[h>>2]=ha;ia=ha}ha=b+155|0;if((ia+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,ha,1);else{a[ha>>0]=a[ia>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);ia=b+160|0;ha=c[h>>2]|0;ga=ha+4|0;da=c[l>>2]|0;if(ga>>>0>da>>>0){Bid(h,ia,4);ja=c[ia>>2]|0;ka=c[h>>2]|0;la=c[l>>2]|0}else{ca=c[ha>>2]|0;c[ia>>2]=ca;c[h>>2]=ga;ja=ca;ka=ga;la=da}c[ia>>2]=XEi(ja|0)|0;ja=b+156|0;ia=ka+4|0;if(ia>>>0>la>>>0){Bid(h,ja,4);ma=c[ja>>2]|0;na=c[h>>2]|0;oa=c[l>>2]|0}else{da=c[ka>>2]|0;c[ja>>2]=da;c[h>>2]=ia;ma=da;na=ia;oa=la}c[ja>>2]=XEi(ma|0)|0;ma=b+164|0;ja=na+4|0;if(ja>>>0>oa>>>0){Bid(h,ma,4);pa=c[ma>>2]|0;qa=c[h>>2]|0;ra=c[l>>2]|0}else{la=c[na>>2]|0;c[ma>>2]=la;c[h>>2]=ja;pa=la;qa=ja;ra=oa}c[ma>>2]=XEi(pa|0)|0;pa=b+128|0;ma=qa+4|0;if(ma>>>0>ra>>>0){Bid(h,pa,4);sa=c[pa>>2]|0;ta=c[h>>2]|0;ua=c[l>>2]|0}else{oa=c[qa>>2]|0;c[pa>>2]=oa;c[h>>2]=ma;sa=oa;ta=ma;ua=ra}c[pa>>2]=XEi(sa|0)|0;sa=b+168|0;if((ta+1|0)>>>0>ua>>>0){Bid(h,sa,1);va=c[h>>2]|0}else{a[sa>>0]=a[ta>>0]|0;ta=(c[h>>2]|0)+1|0;c[h>>2]=ta;va=ta}ta=b+169|0;if((va+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,ta,1);wa=c[h>>2]|0}else{a[ta>>0]=a[va>>0]|0;va=(c[h>>2]|0)+1|0;c[h>>2]=va;wa=va}va=b+170|0;if((wa+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,va,1);xa=c[h>>2]|0}else{a[va>>0]=a[wa>>0]|0;wa=(c[h>>2]|0)+1|0;c[h>>2]=wa;xa=wa}wa=b+171|0;if((xa+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,wa,1);ya=c[h>>2]|0}else{a[wa>>0]=a[xa>>0]|0;xa=(c[h>>2]|0)+1|0;c[h>>2]=xa;ya=xa}xa=b+172|0;if((ya+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,xa,1);za=c[h>>2]|0}else{a[xa>>0]=a[ya>>0]|0;ya=(c[h>>2]|0)+1|0;c[h>>2]=ya;za=ya}ya=b+173|0;if((za+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,ya,1);Aa=c[h>>2]|0}else{a[ya>>0]=a[za>>0]|0;za=(c[h>>2]|0)+1|0;c[h>>2]=za;Aa=za}za=b+174|0;if((Aa+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,za,1);else{a[za>>0]=a[Aa>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);Aa=b+175|0;za=c[h>>2]|0;if((za+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Aa,1);Ba=c[h>>2]|0}else{a[Aa>>0]=a[za>>0]|0;za=(c[h>>2]|0)+1|0;c[h>>2]=za;Ba=za}za=b+176|0;if((Ba+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,za,1);Ca=c[h>>2]|0}else{a[za>>0]=a[Ba>>0]|0;Ba=(c[h>>2]|0)+1|0;c[h>>2]=Ba;Ca=Ba}Ba=b+177|0;if((Ca+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ba,1);Da=c[h>>2]|0}else{a[Ba>>0]=a[Ca>>0]|0;Ca=(c[h>>2]|0)+1|0;c[h>>2]=Ca;Da=Ca}Ca=b+178|0;if((Da+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ca,1);Ea=c[h>>2]|0}else{a[Ca>>0]=a[Da>>0]|0;Da=(c[h>>2]|0)+1|0;c[h>>2]=Da;Ea=Da}Da=b+179|0;if((Ea+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Da,1);Fa=c[h>>2]|0}else{a[Da>>0]=a[Ea>>0]|0;Ea=(c[h>>2]|0)+1|0;c[h>>2]=Ea;Fa=Ea}Ea=b+180|0;if((Fa+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ea,1);Ga=c[h>>2]|0}else{a[Ea>>0]=a[Fa>>0]|0;Fa=(c[h>>2]|0)+1|0;c[h>>2]=Fa;Ga=Fa}Fa=b+181|0;if((Ga+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Fa,1);Ha=c[h>>2]|0}else{a[Fa>>0]=a[Ga>>0]|0;Ga=(c[h>>2]|0)+1|0;c[h>>2]=Ga;Ha=Ga}Ga=b+182|0;if((Ha+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ga,1);Ia=c[h>>2]|0}else{a[Ga>>0]=a[Ha>>0]|0;Ha=(c[h>>2]|0)+1|0;c[h>>2]=Ha;Ia=Ha}Ha=b+183|0;if((Ia+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ha,1);Ja=c[h>>2]|0}else{a[Ha>>0]=a[Ia>>0]|0;Ia=(c[h>>2]|0)+1|0;c[h>>2]=Ia;Ja=Ia}Ia=b+200|0;if((Ja+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ia,1);Ka=c[h>>2]|0}else{a[Ia>>0]=a[Ja>>0]|0;Ja=(c[h>>2]|0)+1|0;c[h>>2]=Ja;Ka=Ja}Ja=b+201|0;if((Ka+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ja,1);La=c[h>>2]|0}else{a[Ja>>0]=a[Ka>>0]|0;Ka=(c[h>>2]|0)+1|0;c[h>>2]=Ka;La=Ka}Ka=b+184|0;if((La+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ka,1);Ma=c[h>>2]|0}else{a[Ka>>0]=a[La>>0]|0;La=(c[h>>2]|0)+1|0;c[h>>2]=La;Ma=La}La=b+202|0;if((Ma+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,La,1);Na=c[h>>2]|0}else{a[La>>0]=a[Ma>>0]|0;Ma=(c[h>>2]|0)+1|0;c[h>>2]=Ma;Na=Ma}Ma=b+203|0;if((Na+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Ma,1);Oa=c[h>>2]|0}else{a[Ma>>0]=a[Na>>0]|0;Na=(c[h>>2]|0)+1|0;c[h>>2]=Na;Oa=Na}Na=b+204|0;if((Oa+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Na,1);Pa=c[h>>2]|0}else{a[Na>>0]=a[Oa>>0]|0;Oa=(c[h>>2]|0)+1|0;c[h>>2]=Oa;Pa=Oa}Oa=b+205|0;if((Pa+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Oa,1);Qa=c[h>>2]|0}else{a[Oa>>0]=a[Pa>>0]|0;Pa=(c[h>>2]|0)+1|0;c[h>>2]=Pa;Qa=Pa}Pa=b+206|0;if((Qa+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Pa,1);Ra=c[h>>2]|0}else{a[Pa>>0]=a[Qa>>0]|0;Qa=(c[h>>2]|0)+1|0;c[h>>2]=Qa;Ra=Qa}Qa=b+212|0;if((Ra+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,Qa,1);Sa=c[h>>2]|0}else{a[Qa>>0]=a[Ra>>0]|0;Ra=(c[h>>2]|0)+1|0;c[h>>2]=Ra;Sa=Ra}Ra=b+185|0;if((Sa+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,Ra,1);else{a[Ra>>0]=a[Sa>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);Sa=b+188|0;Ra=c[h>>2]|0;Qa=Ra+4|0;Pa=c[l>>2]|0;if(Qa>>>0>Pa>>>0){Bid(h,Sa,4);Ta=c[Sa>>2]|0;Ua=c[h>>2]|0;Va=c[l>>2]|0}else{Oa=c[Ra>>2]|0;c[Sa>>2]=Oa;c[h>>2]=Qa;Ta=Oa;Ua=Qa;Va=Pa}c[Sa>>2]=XEi(Ta|0)|0;Ta=b+192|0;Sa=Ua+4|0;if(Sa>>>0>Va>>>0){Bid(h,Ta,4);Wa=c[Ta>>2]|0;Xa=c[h>>2]|0;Ya=c[l>>2]|0}else{Pa=c[Ua>>2]|0;c[Ta>>2]=Pa;c[h>>2]=Sa;Wa=Pa;Xa=Sa;Ya=Va}c[Ta>>2]=XEi(Wa|0)|0;Wa=b+196|0;Ta=Xa+4|0;if(Ta>>>0>Ya>>>0){Bid(h,Wa,4);Za=c[Wa>>2]|0}else{Ya=c[Xa>>2]|0;c[Wa>>2]=Ya;c[h>>2]=Ta;Za=Ya}c[Wa>>2]=XEi(Za|0)|0;Mdd(d);Za=b+208|0;Wa=c[h>>2]|0;Ya=Wa+4|0;Ta=c[l>>2]|0;if(Ya>>>0>Ta>>>0){Bid(h,Za,4);_a=c[Za>>2]|0;$a=c[h>>2]|0;ab=c[l>>2]|0}else{Xa=c[Wa>>2]|0;c[Za>>2]=Xa;c[h>>2]=Ya;_a=Xa;$a=Ya;ab=Ta}c[Za>>2]=XEi(_a|0)|0;_a=b+213|0;if(($a+1|0)>>>0>ab>>>0){Bid(h,_a,1);bb=c[h>>2]|0}else{a[_a>>0]=a[$a>>0]|0;$a=(c[h>>2]|0)+1|0;c[h>>2]=$a;bb=$a}$a=b+214|0;if((bb+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,$a,1);else{a[$a>>0]=a[bb>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);bb=b+216|0;$a=c[h>>2]|0;_a=$a+4|0;if(_a>>>0>(c[l>>2]|0)>>>0){Bid(h,bb,4);cb=c[bb>>2]|0}else{ab=c[$a>>2]|0;c[bb>>2]=ab;c[h>>2]=_a;cb=ab}c[bb>>2]=XEi(cb|0)|0;Mdd(d);n9b(b+224|0,d);cb=b+228|0;bb=c[h>>2]|0;ab=bb+4|0;_a=c[l>>2]|0;if(ab>>>0>_a>>>0){Bid(h,cb,4);db=c[cb>>2]|0;eb=c[h>>2]|0;fb=c[l>>2]|0}else{$a=c[bb>>2]|0;c[cb>>2]=$a;c[h>>2]=ab;db=$a;eb=ab;fb=_a}c[cb>>2]=XEi(db|0)|0;db=b+232|0;cb=eb+4|0;if(cb>>>0>fb>>>0){Bid(h,db,4);gb=c[db>>2]|0;hb=c[h>>2]|0;ib=c[l>>2]|0}else{_a=c[eb>>2]|0;c[db>>2]=_a;c[h>>2]=cb;gb=_a;hb=cb;ib=fb}c[db>>2]=XEi(gb|0)|0;gb=b+236|0;if((hb+1|0)>>>0>ib>>>0)Bid(h,gb,1);else{a[gb>>0]=a[hb>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);SSc(b+132|0,d);OXb(d,b+264|0,1);Mdd(d);OXb(d,b+276|0,1);Mdd(d);INc(d,b+300|0,0);hb=b+316|0;gb=c[h>>2]|0;if((gb+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,hb,1);jb=c[h>>2]|0}else{a[hb>>0]=a[gb>>0]|0;gb=(c[h>>2]|0)+1|0;c[h>>2]=gb;jb=gb}gb=b+317|0;if((jb+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,gb,1);kb=c[h>>2]|0}else{a[gb>>0]=a[jb>>0]|0;jb=(c[h>>2]|0)+1|0;c[h>>2]=jb;kb=jb}jb=b+318|0;if((kb+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,jb,1);Mdd(d);i=e;return}else{a[jb>>0]=a[kb>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Mdd(d);i=e;return}}function MSc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;e=i;i=i+16|0;f=e;OSb(b,d);h=b+84|0;j=d+12|0;k=c[j>>2]|0;l=d+20|0;if((k+1|0)>>>0<(c[l>>2]|0)>>>0){a[k>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(d);h=b+88|0;k=c[j>>2]|0;m=k+4|0;n=c[l>>2]|0;if(m>>>0<n>>>0){c[k>>2]=c[h>>2];c[j>>2]=m;o=m;p=n}else{Gid(j,h,4);o=c[j>>2]|0;p=c[l>>2]|0}h=b+92|0;n=o+4|0;if(n>>>0<p>>>0){c[o>>2]=c[h>>2];c[j>>2]=n;q=n;r=p}else{Gid(j,h,4);q=c[j>>2]|0;r=c[l>>2]|0}h=b+96|0;p=q+4|0;if(p>>>0<r>>>0){c[q>>2]=c[h>>2];c[j>>2]=p}else Gid(j,h,4);if(!(c[h>>2]|0))c[h>>2]=-1;h=b+100|0;p=c[j>>2]|0;q=p+4|0;r=c[l>>2]|0;if(q>>>0<r>>>0){c[p>>2]=c[h>>2];c[j>>2]=q;s=q;t=r}else{Gid(j,h,4);s=c[j>>2]|0;t=c[l>>2]|0}h=b+104|0;r=s+4|0;if(r>>>0<t>>>0){c[s>>2]=c[h>>2];c[j>>2]=r}else Gid(j,h,4);r=c[h>>2]|0;if((r|0)==2)c[h>>2]=0;else if((r|0)==1)c[h>>2]=6;h=b+108|0;r=c[j>>2]|0;s=r+4|0;if(s>>>0<(c[l>>2]|0)>>>0){c[r>>2]=c[h>>2];c[j>>2]=s}else Gid(j,h,4);Tdd(d);FXb(d,b+24|0,607536,0);FXb(d,b+36|0,607552,0);FXb(d,b+60|0,607568,0);q9b(b+72|0,d);h=b+76|0;s=c[j>>2]|0;r=s+4|0;t=c[l>>2]|0;if(r>>>0<t>>>0){g[s>>2]=ea(g[h>>2]);c[j>>2]=r;u=r;v=t}else{Gid(j,h,4);u=c[j>>2]|0;v=c[l>>2]|0}h=b+80|0;t=u+4|0;if(t>>>0<v>>>0){g[u>>2]=ea(g[h>>2]);c[j>>2]=t;w=t;x=v}else{Gid(j,h,4);w=c[j>>2]|0;x=c[l>>2]|0}h=b+112|0;v=w+4|0;if(v>>>0<x>>>0){c[w>>2]=c[h>>2];c[j>>2]=v;y=v;z=x}else{Gid(j,h,4);y=c[j>>2]|0;z=c[l>>2]|0}h=b+116|0;x=y+4|0;if(x>>>0<z>>>0){c[y>>2]=c[h>>2];c[j>>2]=x;A=x;B=z}else{Gid(j,h,4);A=c[j>>2]|0;B=c[l>>2]|0}h=b+120|0;z=A+4|0;if(z>>>0<B>>>0){c[A>>2]=c[h>>2];c[j>>2]=z;C=z;D=B}else{Gid(j,h,4);C=c[j>>2]|0;D=c[l>>2]|0}h=b+124|0;B=C+4|0;if(B>>>0<D>>>0){c[C>>2]=c[h>>2];c[j>>2]=B;E=B;F=D}else{Gid(j,h,4);E=c[j>>2]|0;F=c[l>>2]|0}h=b+140|0;D=E+4|0;if(D>>>0<F>>>0){c[E>>2]=c[h>>2];c[j>>2]=D;G=D;H=F}else{Gid(j,h,4);G=c[j>>2]|0;H=c[l>>2]|0}h=b+144|0;F=G+4|0;if(F>>>0<H>>>0){c[G>>2]=c[h>>2];c[j>>2]=F;I=F;J=H}else{Gid(j,h,4);I=c[j>>2]|0;J=c[l>>2]|0}h=b+148|0;H=I+4|0;if(H>>>0<J>>>0){c[I>>2]=c[h>>2];c[j>>2]=H;K=H;L=J}else{Gid(j,h,4);K=c[j>>2]|0;L=c[l>>2]|0}h=b+152|0;if((K+1|0)>>>0<L>>>0){a[K>>0]=a[h>>0]|0;K=(c[j>>2]|0)+1|0;c[j>>2]=K;M=K}else{Gid(j,h,1);M=c[j>>2]|0}h=b+153|0;if((M+1|0)>>>0<(c[l>>2]|0)>>>0){a[M>>0]=a[h>>0]|0;M=(c[j>>2]|0)+1|0;c[j>>2]=M;N=M}else{Gid(j,h,1);N=c[j>>2]|0}h=b+154|0;if((N+1|0)>>>0<(c[l>>2]|0)>>>0){a[N>>0]=a[h>>0]|0;N=(c[j>>2]|0)+1|0;c[j>>2]=N;O=N}else{Gid(j,h,1);O=c[j>>2]|0}h=b+155|0;if((O+1|0)>>>0<(c[l>>2]|0)>>>0){a[O>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(d);h=b+160|0;O=c[j>>2]|0;N=O+4|0;M=c[l>>2]|0;if(N>>>0<M>>>0){c[O>>2]=c[h>>2];c[j>>2]=N;P=N;Q=M}else{Gid(j,h,4);P=c[j>>2]|0;Q=c[l>>2]|0}h=b+156|0;M=P+4|0;if(M>>>0<Q>>>0){c[P>>2]=c[h>>2];c[j>>2]=M;R=M;S=Q}else{Gid(j,h,4);R=c[j>>2]|0;S=c[l>>2]|0}h=b+164|0;Q=R+4|0;if(Q>>>0<S>>>0){c[R>>2]=c[h>>2];c[j>>2]=Q;T=Q;U=S}else{Gid(j,h,4);T=c[j>>2]|0;U=c[l>>2]|0}h=b+128|0;S=T+4|0;if(S>>>0<U>>>0){c[T>>2]=c[h>>2];c[j>>2]=S;V=S;W=U}else{Gid(j,h,4);V=c[j>>2]|0;W=c[l>>2]|0}h=b+168|0;if((V+1|0)>>>0<W>>>0){a[V>>0]=a[h>>0]|0;V=(c[j>>2]|0)+1|0;c[j>>2]=V;X=V}else{Gid(j,h,1);X=c[j>>2]|0}h=b+169|0;if((X+1|0)>>>0<(c[l>>2]|0)>>>0){a[X>>0]=a[h>>0]|0;X=(c[j>>2]|0)+1|0;c[j>>2]=X;Y=X}else{Gid(j,h,1);Y=c[j>>2]|0}h=b+170|0;if((Y+1|0)>>>0<(c[l>>2]|0)>>>0){a[Y>>0]=a[h>>0]|0;Y=(c[j>>2]|0)+1|0;c[j>>2]=Y;Z=Y}else{Gid(j,h,1);Z=c[j>>2]|0}h=b+171|0;if((Z+1|0)>>>0<(c[l>>2]|0)>>>0){a[Z>>0]=a[h>>0]|0;Z=(c[j>>2]|0)+1|0;c[j>>2]=Z;_=Z}else{Gid(j,h,1);_=c[j>>2]|0}h=b+172|0;if((_+1|0)>>>0<(c[l>>2]|0)>>>0){a[_>>0]=a[h>>0]|0;_=(c[j>>2]|0)+1|0;c[j>>2]=_;$=_}else{Gid(j,h,1);$=c[j>>2]|0}h=b+173|0;if(($+1|0)>>>0<(c[l>>2]|0)>>>0){a[$>>0]=a[h>>0]|0;$=(c[j>>2]|0)+1|0;c[j>>2]=$;aa=$}else{Gid(j,h,1);aa=c[j>>2]|0}h=b+174|0;if((aa+1|0)>>>0<(c[l>>2]|0)>>>0){a[aa>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(d);h=b+175|0;aa=c[j>>2]|0;if((aa+1|0)>>>0<(c[l>>2]|0)>>>0){a[aa>>0]=a[h>>0]|0;aa=(c[j>>2]|0)+1|0;c[j>>2]=aa;ba=aa}else{Gid(j,h,1);ba=c[j>>2]|0}h=b+176|0;if((ba+1|0)>>>0<(c[l>>2]|0)>>>0){a[ba>>0]=a[h>>0]|0;ba=(c[j>>2]|0)+1|0;c[j>>2]=ba;ca=ba}else{Gid(j,h,1);ca=c[j>>2]|0}h=b+177|0;if((ca+1|0)>>>0<(c[l>>2]|0)>>>0){a[ca>>0]=a[h>>0]|0;ca=(c[j>>2]|0)+1|0;c[j>>2]=ca;da=ca}else{Gid(j,h,1);da=c[j>>2]|0}h=b+178|0;if((da+1|0)>>>0<(c[l>>2]|0)>>>0){a[da>>0]=a[h>>0]|0;da=(c[j>>2]|0)+1|0;c[j>>2]=da;fa=da}else{Gid(j,h,1);fa=c[j>>2]|0}h=b+179|0;if((fa+1|0)>>>0<(c[l>>2]|0)>>>0){a[fa>>0]=a[h>>0]|0;fa=(c[j>>2]|0)+1|0;c[j>>2]=fa;ga=fa}else{Gid(j,h,1);ga=c[j>>2]|0}h=b+180|0;if((ga+1|0)>>>0<(c[l>>2]|0)>>>0){a[ga>>0]=a[h>>0]|0;ga=(c[j>>2]|0)+1|0;c[j>>2]=ga;ha=ga}else{Gid(j,h,1);ha=c[j>>2]|0}h=b+181|0;if((ha+1|0)>>>0<(c[l>>2]|0)>>>0){a[ha>>0]=a[h>>0]|0;ha=(c[j>>2]|0)+1|0;c[j>>2]=ha;ia=ha}else{Gid(j,h,1);ia=c[j>>2]|0}h=b+182|0;if((ia+1|0)>>>0<(c[l>>2]|0)>>>0){a[ia>>0]=a[h>>0]|0;ia=(c[j>>2]|0)+1|0;c[j>>2]=ia;ja=ia}else{Gid(j,h,1);ja=c[j>>2]|0}h=b+183|0;if((ja+1|0)>>>0<(c[l>>2]|0)>>>0){a[ja>>0]=a[h>>0]|0;ja=(c[j>>2]|0)+1|0;c[j>>2]=ja;ka=ja}else{Gid(j,h,1);ka=c[j>>2]|0}h=b+200|0;if((ka+1|0)>>>0<(c[l>>2]|0)>>>0){a[ka>>0]=a[h>>0]|0;ka=(c[j>>2]|0)+1|0;c[j>>2]=ka;la=ka}else{Gid(j,h,1);la=c[j>>2]|0}h=b+201|0;if((la+1|0)>>>0<(c[l>>2]|0)>>>0){a[la>>0]=a[h>>0]|0;la=(c[j>>2]|0)+1|0;c[j>>2]=la;ma=la}else{Gid(j,h,1);ma=c[j>>2]|0}h=b+184|0;if((ma+1|0)>>>0<(c[l>>2]|0)>>>0){a[ma>>0]=a[h>>0]|0;ma=(c[j>>2]|0)+1|0;c[j>>2]=ma;na=ma}else{Gid(j,h,1);na=c[j>>2]|0}h=b+202|0;if((na+1|0)>>>0<(c[l>>2]|0)>>>0){a[na>>0]=a[h>>0]|0;na=(c[j>>2]|0)+1|0;c[j>>2]=na;oa=na}else{Gid(j,h,1);oa=c[j>>2]|0}h=b+203|0;if((oa+1|0)>>>0<(c[l>>2]|0)>>>0){a[oa>>0]=a[h>>0]|0;oa=(c[j>>2]|0)+1|0;c[j>>2]=oa;pa=oa}else{Gid(j,h,1);pa=c[j>>2]|0}h=b+204|0;if((pa+1|0)>>>0<(c[l>>2]|0)>>>0){a[pa>>0]=a[h>>0]|0;pa=(c[j>>2]|0)+1|0;c[j>>2]=pa;qa=pa}else{Gid(j,h,1);qa=c[j>>2]|0}h=b+205|0;if((qa+1|0)>>>0<(c[l>>2]|0)>>>0){a[qa>>0]=a[h>>0]|0;qa=(c[j>>2]|0)+1|0;c[j>>2]=qa;ra=qa}else{Gid(j,h,1);ra=c[j>>2]|0}h=b+206|0;if((ra+1|0)>>>0<(c[l>>2]|0)>>>0){a[ra>>0]=a[h>>0]|0;ra=(c[j>>2]|0)+1|0;c[j>>2]=ra;sa=ra}else{Gid(j,h,1);sa=c[j>>2]|0}h=b+212|0;if((sa+1|0)>>>0<(c[l>>2]|0)>>>0){a[sa>>0]=a[h>>0]|0;sa=(c[j>>2]|0)+1|0;c[j>>2]=sa;ta=sa}else{Gid(j,h,1);ta=c[j>>2]|0}h=b+185|0;if((ta+1|0)>>>0<(c[l>>2]|0)>>>0){a[ta>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(d);h=b+188|0;ta=c[j>>2]|0;sa=ta+4|0;ra=c[l>>2]|0;if(sa>>>0<ra>>>0){c[ta>>2]=c[h>>2];c[j>>2]=sa;ua=sa;va=ra}else{Gid(j,h,4);ua=c[j>>2]|0;va=c[l>>2]|0}h=b+192|0;ra=ua+4|0;if(ra>>>0<va>>>0){c[ua>>2]=c[h>>2];c[j>>2]=ra;wa=ra;xa=va}else{Gid(j,h,4);wa=c[j>>2]|0;xa=c[l>>2]|0}h=b+196|0;va=wa+4|0;if(va>>>0<xa>>>0){c[wa>>2]=c[h>>2];c[j>>2]=va}else Gid(j,h,4);Tdd(d);h=b+208|0;va=c[j>>2]|0;wa=va+4|0;xa=c[l>>2]|0;if(wa>>>0<xa>>>0){c[va>>2]=c[h>>2];c[j>>2]=wa;ya=wa;za=xa}else{Gid(j,h,4);ya=c[j>>2]|0;za=c[l>>2]|0}h=b+213|0;if((ya+1|0)>>>0<za>>>0){a[ya>>0]=a[h>>0]|0;ya=(c[j>>2]|0)+1|0;c[j>>2]=ya;Aa=ya}else{Gid(j,h,1);Aa=c[j>>2]|0}h=b+214|0;if((Aa+1|0)>>>0<(c[l>>2]|0)>>>0){a[Aa>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(d);h=b+216|0;Aa=c[j>>2]|0;ya=Aa+4|0;if(ya>>>0<(c[l>>2]|0)>>>0){c[Aa>>2]=c[h>>2];c[j>>2]=ya}else Gid(j,h,4);Tdd(d);q9b(b+224|0,d);h=b+228|0;ya=c[j>>2]|0;Aa=ya+4|0;za=c[l>>2]|0;if(Aa>>>0<za>>>0){c[ya>>2]=c[h>>2];c[j>>2]=Aa;Ba=Aa;Ca=za}else{Gid(j,h,4);Ba=c[j>>2]|0;Ca=c[l>>2]|0}h=b+232|0;za=Ba+4|0;if(za>>>0<Ca>>>0){c[Ba>>2]=c[h>>2];c[j>>2]=za;Da=za;Ea=Ca}else{Gid(j,h,4);Da=c[j>>2]|0;Ea=c[l>>2]|0}h=b+236|0;if((Da+1|0)>>>0<Ea>>>0){a[Da>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(d);TSc(b+132|0,d);FXb(d,b+264|0,607272,0);FXb(d,b+276|0,607320,0);h=b+308|0;Da=c[h>>2]|0;c[f>>2]=Da;Ea=c[j>>2]|0;Ca=Ea+4|0;if(Ca>>>0<(c[l>>2]|0)>>>0){c[Ea>>2]=Da;c[j>>2]=Ca}else Gid(j,f,4);f=c[b+300>>2]|0;Ca=c[h>>2]|0;h=f+(Ca<<2)|0;if(Ca){Ca=f;do{Yxc(Ca,d);Ca=Ca+4|0}while((Ca|0)!=(h|0))}h=b+316|0;Ca=c[j>>2]|0;if((Ca+1|0)>>>0<(c[l>>2]|0)>>>0){a[Ca>>0]=a[h>>0]|0;Ca=(c[j>>2]|0)+1|0;c[j>>2]=Ca;Fa=Ca}else{Gid(j,h,1);Fa=c[j>>2]|0}h=b+317|0;if((Fa+1|0)>>>0<(c[l>>2]|0)>>>0){a[Fa>>0]=a[h>>0]|0;Fa=(c[j>>2]|0)+1|0;c[j>>2]=Fa;Ga=Fa}else{Gid(j,h,1);Ga=c[j>>2]|0}h=b+318|0;if((Ga+1|0)>>>0<(c[l>>2]|0)>>>0){a[Ga>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1;Tdd(d);i=e;return}else{Gid(j,h,1);Tdd(d);i=e;return}}function NSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;PSb(b,d);f=b+96|0;if(!(c[f>>2]|0))c[f>>2]=-1;f=b+104|0;g=c[f>>2]|0;if((g|0)==1)c[f>>2]=6;else if((g|0)==2)c[f>>2]=0;f=b+72|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=b+224|0;f=c[g>>2]|0;d=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=d;d=c[b+300>>2]|0;k=c[b+308>>2]|0;b=d+(k<<2)|0;if(!k){i=e;return}else l=d;do{d=c[g>>2]|0;k=xo[c[c[d>>2]>>2]&2047](d,c[l>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[l>>2]=k;l=l+4|0}while((l|0)!=(b|0));i=e;return}function OSc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d;f=d+16|0;g=d+28|0;h=d+4|0;j=d+32|0;k=d+36|0;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;c[b>>2]=607e3;if((c[b+312>>2]|0)>-1){p=b+300|0;q=c[p>>2]|0;c[f>>2]=c[b+304>>2];c[e+0>>2]=c[f+0>>2];eOb(q,e);c[p>>2]=0}if(a[b+288>>0]&1){p=c[b+296>>2]|0;c[o>>2]=58;c[e+0>>2]=c[o+0>>2];eOb(p,e)}if(a[b+276>>0]&1){p=c[b+284>>2]|0;c[n>>2]=58;c[e+0>>2]=c[n+0>>2];eOb(p,e)}if(a[b+264>>0]&1){p=c[b+272>>2]|0;c[m>>2]=58;c[e+0>>2]=c[m+0>>2];eOb(p,e)}if(a[b+252>>0]&1){p=c[b+260>>2]|0;c[l>>2]=58;c[e+0>>2]=c[l+0>>2];eOb(p,e)}if(a[b+240>>0]&1){p=c[b+248>>2]|0;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];eOb(p,e)}if(a[b+60>>0]&1){p=c[b+68>>2]|0;c[j>>2]=58;c[e+0>>2]=c[j+0>>2];eOb(p,e)}if(a[b+48>>0]&1){p=c[b+56>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(p,e)}if(a[b+36>>0]&1){p=c[b+44>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(p,e)}if(!(a[b+24>>0]&1)){ZSb(b);i=d;return}p=c[b+32>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(p,e);ZSb(b);i=d;return}function PSc(a){a=a|0;var b=0;b=i;OSc(a);ACi(a);i=b;return}function QSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142258]|0;f=b+12|0;g=b+20|0;add(b,609016,e,a+1|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,609024,e,a+2|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,609032,e,a+3|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,609040,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,609008,e,a,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function RSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d+12|0;g=d+20|0;h=b+1|0;j=c[f>>2]|0;if((j+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,h,1);k=c[f>>2]|0}else{a[h>>0]=a[j>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}j=b+2|0;if((k+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,j,1);l=c[f>>2]|0}else{a[j>>0]=a[k>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}k=b+3|0;if((l+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,k,1);m=c[f>>2]|0}else{a[k>>0]=a[l>>0]|0;l=(c[f>>2]|0)+1|0;c[f>>2]=l;m=l}l=b+4|0;if((m+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,l,1);n=c[f>>2]|0}else{a[l>>0]=a[m>>0]|0;m=(c[f>>2]|0)+1|0;c[f>>2]=m;n=m}if((n+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,b,1);Ndd(d);i=e;return}else{a[b>>0]=a[n>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function SSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d+12|0;g=d+20|0;h=b+1|0;j=c[f>>2]|0;if((j+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,h,1);k=c[f>>2]|0}else{a[h>>0]=a[j>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}j=b+2|0;if((k+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,j,1);l=c[f>>2]|0}else{a[j>>0]=a[k>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}k=b+3|0;if((l+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,k,1);m=c[f>>2]|0}else{a[k>>0]=a[l>>0]|0;l=(c[f>>2]|0)+1|0;c[f>>2]=l;m=l}l=b+4|0;if((m+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,l,1);n=c[f>>2]|0}else{a[l>>0]=a[m>>0]|0;m=(c[f>>2]|0)+1|0;c[f>>2]=m;n=m}if((n+1|0)>>>0>(c[g>>2]|0)>>>0){Bid(f,b,1);Mdd(d);i=e;return}else{a[b>>0]=a[n>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function TSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d+12|0;g=d+20|0;h=b+1|0;j=c[f>>2]|0;if((j+1|0)>>>0<(c[g>>2]|0)>>>0){a[j>>0]=a[h>>0]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;k=j}else{Gid(f,h,1);k=c[f>>2]|0}h=b+2|0;if((k+1|0)>>>0<(c[g>>2]|0)>>>0){a[k>>0]=a[h>>0]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;l=k}else{Gid(f,h,1);l=c[f>>2]|0}h=b+3|0;if((l+1|0)>>>0<(c[g>>2]|0)>>>0){a[l>>0]=a[h>>0]|0;l=(c[f>>2]|0)+1|0;c[f>>2]=l;m=l}else{Gid(f,h,1);m=c[f>>2]|0}h=b+4|0;if((m+1|0)>>>0<(c[g>>2]|0)>>>0){a[m>>0]=a[h>>0]|0;m=(c[f>>2]|0)+1|0;c[f>>2]=m;n=m}else{Gid(f,h,1);n=c[f>>2]|0}if((n+1|0)>>>0<(c[g>>2]|0)>>>0){a[n>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Tdd(d);i=e;return}else{Gid(f,b,1);Tdd(d);i=e;return}}function USc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+12|0;h=b;eTc(g,a+72|0);VSc(a,g);j=c[g>>2]|0;if(j){k=g+4|0;g=c[k>>2]|0;if((g|0)!=(j|0))c[k>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=6;c[d+0>>2]=c[f+0>>2];eOb(j,d)}eTc(h,a+84|0);VSc(a,h);a=c[h>>2]|0;if(!a){i=b;return}j=h+4|0;h=c[j>>2]|0;if((h|0)!=(a|0))c[j>>2]=h+(~((h+-4-a|0)>>>2)<<2);c[e>>2]=6;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function VSc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+208|0;f=e;g=c[d>>2]|0;h=(c[d+4>>2]|0)-g>>2;if(!h){i=e;return}j=b+60|0;k=b+48|0;l=b+24|0;m=b+36|0;b=g;g=0;while(1){n=c[b+(g<<2)>>2]|0;o=c[j>>2]|0;p=c[o+(n*20|0)>>2]|0;q=c[k>>2]|0;r=c[q+(p<<5)>>2]|0;s=c[l>>2]|0;t=c[q+(p<<5)+4>>2]|0;u=c[m>>2]|0;v=s+(r*12|0)|0;if(!(a[v>>0]&1))w=v+1|0;else w=c[s+(r*12|0)+8>>2]|0;r=u+(t*12|0)|0;if(!(a[r>>0]&1))x=r+1|0;else x=c[u+(t*12|0)+8>>2]|0;t=q+(p<<5)+8|0;if(!(a[t>>0]&1))y=t+1|0;else y=c[q+(p<<5)+16>>2]|0;p=Asc(w,x,y)|0;if(p){q=o+(n*20|0)+4|0;if(!(a[q>>0]&1))z=q+1|0;else z=c[o+(n*20|0)+12>>2]|0;lbd(f,p,z);nbd(f)|0}p=g+1|0;if((p|0)==(h|0))break;b=c[d>>2]|0;g=p}i=e;return}function WSc(){var a=0;a=i;QQb(300,160,0,0,0);i=a;return}function XSc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,609176,30);wQb(300,6,b,108,2635,0,0);xri(b);i=a;return}function YSc(a){a=a|0;return 300}function ZSc(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,609176,a,0);gTc(a,b);bdd(b);i=c;return}function _Sc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,609176,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else hTc(a,b);sdd(b);i=d;return}function $Sc(a,b){a=a|0;b=b|0;var c=0;c=i;iTc(a,b);i=c;return}function aTc(a,b){a=a|0;b=b|0;var c=0;c=i;jTc(a,b);i=c;return}function bTc(a,b){a=a|0;b=b|0;var c=0;c=i;kTc(a,b);i=c;return}function cTc(a,b){a=a|0;b=b|0;var c=0;c=i;PSb(a,b);i=c;return}function dTc(){var a=0,b=0;a=i;b=rVb(15)|0;i=a;return b|0}function eTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;g=a+4|0;c[g>>2]=0;h=a+8|0;c[h>>2]=0;j=b+4|0;k=(c[j>>2]|0)-(c[b>>2]|0)|0;l=k>>2;if(!l){i=d;return}if((k|0)<0)vxi(a);c[f>>2]=6;c[e+0>>2]=c[f+0>>2];f=cOb(k,16,e,0,3653512,80)|0;c[g>>2]=f;c[a>>2]=f;c[h>>2]=f+(l<<2);l=c[b>>2]|0;b=c[j>>2]|0;if((l|0)==(b|0)){i=d;return}j=(b+-4-l|0)>>>2;h=l;l=f;while(1){if(l)c[l>>2]=c[h>>2];h=h+4|0;if((h|0)==(b|0))break;else l=l+4|0}c[g>>2]=f+(j+1<<2);i=d;return}function fTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(108,e,1,16,3653512,64)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];jSb(g,e,b);c[g>>2]=609072;b=g+24|0;e=b+84|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));i=d;return g|0}function gTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;KSb(a,b);ddd(b,1);oTc(b,a+24|0,609208,0);oTc(b,a+36|0,609224,0);fdd(b);g=a+48|0;h=c[142306]|0;add(b,609248,h,g,0);pTc(b,g,0);bdd(b);fdd(b);g=a+60|0;add(b,609264,h,g,0);qTc(b,g,0);bdd(b);fdd(b);add(b,609288,h,a+72|0,0);$cd(b,2646336,2646336,e,0);g=c[142270]|0;add(b,3142592,g,f,0);j=b+12|0;k=b+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);cdd(b);bdd(b);add(b,609320,h,a+84|0,0);$cd(b,2646336,2646336,e,0);add(b,3142592,g,f,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);cdd(b);bdd(b);fdd(b);fdd(b);i=d;return}function hTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;LSb(a,b);rdd(b,1);f=a+24|0;g=c[142306]|0;h=qdd(b,609208,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else rTc(b,f,0);sdd(b)}f=a+36|0;h=qdd(b,609224,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else rTc(b,f,0);sdd(b)}f=a+48|0;h=qdd(b,609248,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else sTc(b,f,0);sdd(b)}f=a+60|0;h=qdd(b,609264,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else tTc(b,f,0);sdd(b)}f=a+72|0;h=qdd(b,609288,g,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else uTc(b,f,0);sdd(b)}f=a+84|0;a=qdd(b,609320,g,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else uTc(b,f,0);sdd(b);i=d;return}function iTc(a,b){a=a|0;b=b|0;var c=0;c=i;MSb(a,b);vTc(b,a+24|0,0);vTc(b,a+36|0,0);Ndd(b);wTc(b,a+48|0,0);Ndd(b);xTc(b,a+60|0,0);Ndd(b);yTc(b,a+72|0,0);yTc(b,a+84|0,0);Ndd(b);Ndd(b);i=c;return}function jTc(a,b){a=a|0;b=b|0;var c=0;c=i;NSb(a,b);zTc(b,a+24|0,0);zTc(b,a+36|0,0);Mdd(b);ATc(b,a+48|0,0);Mdd(b);BTc(b,a+60|0,0);Mdd(b);CTc(b,a+72|0,0);CTc(b,a+84|0,0);Mdd(b);Mdd(b);i=c;return}function kTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;OSb(a,b);f=a+28|0;g=c[f>>2]|0;h=a+24|0;j=c[h>>2]|0;k=(g-j|0)/12|0;c[e>>2]=k;l=b+12|0;m=c[l>>2]|0;n=m+4|0;o=b+20|0;if(n>>>0<(c[o>>2]|0)>>>0){c[m>>2]=k;c[l>>2]=n;p=j;q=g}else{Gid(l,e,4);p=c[h>>2]|0;q=c[f>>2]|0}if((p|0)!=(q|0)){f=p;do{FXb(b,f,3142592,0);f=f+12|0}while((f|0)!=(q|0))}q=a+40|0;f=c[q>>2]|0;p=a+36|0;h=c[p>>2]|0;g=(f-h|0)/12|0;c[e>>2]=g;j=c[l>>2]|0;n=j+4|0;if(n>>>0<(c[o>>2]|0)>>>0){c[j>>2]=g;c[l>>2]=n;r=h;s=f}else{Gid(l,e,4);r=c[p>>2]|0;s=c[q>>2]|0}if((r|0)!=(s|0)){q=r;do{FXb(b,q,3142592,0);q=q+12|0}while((q|0)!=(s|0))}Tdd(b);s=a+52|0;q=c[s>>2]|0;r=a+48|0;p=c[r>>2]|0;f=q-p>>5;c[e>>2]=f;h=c[l>>2]|0;n=h+4|0;if(n>>>0<(c[o>>2]|0)>>>0){c[h>>2]=f;c[l>>2]=n;t=p;u=q}else{Gid(l,e,4);t=c[r>>2]|0;u=c[s>>2]|0}if((t|0)!=(u|0)){s=t;do{DTc(s,b);s=s+32|0}while((s|0)!=(u|0))}Tdd(b);ETc(b,a+60|0,0);Tdd(b);u=a+76|0;s=c[u>>2]|0;t=a+72|0;r=c[t>>2]|0;q=s-r>>2;c[e>>2]=q;p=c[l>>2]|0;n=p+4|0;if(n>>>0<(c[o>>2]|0)>>>0){c[p>>2]=q;c[l>>2]=n;v=r;w=s}else{Gid(l,e,4);v=c[t>>2]|0;w=c[u>>2]|0}if((v|0)!=(w|0)){u=v;do{v=c[l>>2]|0;t=v+4|0;if(t>>>0<(c[o>>2]|0)>>>0){c[v>>2]=c[u>>2];c[l>>2]=t}else Gid(l,u,4);u=u+4|0}while((u|0)!=(w|0))}w=a+88|0;u=c[w>>2]|0;t=a+84|0;a=c[t>>2]|0;v=u-a>>2;c[e>>2]=v;s=c[l>>2]|0;r=s+4|0;if(r>>>0<(c[o>>2]|0)>>>0){c[s>>2]=v;c[l>>2]=r;x=a;y=u}else{Gid(l,e,4);x=c[t>>2]|0;y=c[w>>2]|0}if((x|0)==(y|0)){Tdd(b);Tdd(b);i=d;return}else z=x;do{x=c[l>>2]|0;w=x+4|0;if(w>>>0<(c[o>>2]|0)>>>0){c[x>>2]=c[z>>2];c[l>>2]=w}else Gid(l,z,4);z=z+4|0}while((z|0)!=(y|0));Tdd(b);Tdd(b);i=d;return}function lTc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+64|0;e=d+44|0;f=d+36|0;g=d+20|0;h=d+16|0;j=d+32|0;k=d+40|0;l=d+48|0;m=d+8|0;n=d+4|0;o=d+24|0;p=d+12|0;q=d+28|0;r=d;c[b>>2]=609072;s=b+96|0;t=c[s>>2]|0;if(t){u=b+100|0;v=c[u>>2]|0;if((v|0)==(t|0))w=t;else{x=v;while(1){v=x+-12|0;c[u>>2]=v;if(!(a[v>>0]&1))y=v;else{v=c[x+-4>>2]|0;c[q>>2]=58;c[e+0>>2]=c[q+0>>2];eOb(v,e);y=c[u>>2]|0}if((y|0)==(t|0))break;else x=y}w=c[s>>2]|0}c[r>>2]=6;c[e+0>>2]=c[r+0>>2];eOb(w,e)}w=c[b+84>>2]|0;if(w){r=b+88|0;s=c[r>>2]|0;if((s|0)!=(w|0))c[r>>2]=s+(~((s+-4-w|0)>>>2)<<2);c[p>>2]=6;c[e+0>>2]=c[p+0>>2];eOb(w,e)}w=c[b+72>>2]|0;if(w){p=b+76|0;s=c[p>>2]|0;if((s|0)!=(w|0))c[p>>2]=s+(~((s+-4-w|0)>>>2)<<2);c[o>>2]=6;c[e+0>>2]=c[o+0>>2];eOb(w,e)}w=b+60|0;o=c[w>>2]|0;if(o){s=b+64|0;p=c[s>>2]|0;if((p|0)==(o|0))z=o;else{r=p;while(1){p=r+-20|0;c[s>>2]=p;if(!(a[r+-16>>0]&1))A=p;else{p=c[r+-8>>2]|0;c[m>>2]=58;c[e+0>>2]=c[m+0>>2];eOb(p,e);A=c[s>>2]|0}if((A|0)==(o|0))break;else r=A}z=c[w>>2]|0}c[n>>2]=6;c[e+0>>2]=c[n+0>>2];eOb(z,e)}z=b+48|0;n=c[z>>2]|0;if(n){w=b+52|0;A=c[w>>2]|0;if((A|0)==(n|0))B=n;else{r=A;while(1){A=r+-32|0;c[w>>2]=A;if(!(a[r+-24>>0]&1))C=A;else{A=c[r+-16>>2]|0;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];eOb(A,e);C=c[w>>2]|0}if((C|0)==(n|0))break;else r=C}B=c[z>>2]|0}c[l>>2]=6;c[e+0>>2]=c[l+0>>2];eOb(B,e)}B=b+36|0;l=c[B>>2]|0;if(l){z=b+40|0;C=c[z>>2]|0;if((C|0)==(l|0))D=l;else{r=C;while(1){C=r+-12|0;c[z>>2]=C;if(!(a[C>>0]&1))E=C;else{C=c[r+-4>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(C,e);E=c[z>>2]|0}if((E|0)==(l|0))break;else r=E}D=c[B>>2]|0}c[j>>2]=6;c[e+0>>2]=c[j+0>>2];eOb(D,e)}D=b+24|0;j=c[D>>2]|0;if(!j){ZSb(b);i=d;return}B=b+28|0;E=c[B>>2]|0;if((E|0)==(j|0))F=j;else{r=E;while(1){E=r+-12|0;c[B>>2]=E;if(!(a[E>>0]&1))G=E;else{E=c[r+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(E,e);G=c[B>>2]|0}if((G|0)==(j|0))break;else r=G}F=c[D>>2]|0}c[g>>2]=6;c[e+0>>2]=c[g+0>>2];eOb(F,e);ZSb(b);i=d;return}function mTc(a){a=a|0;var b=0;b=i;lTc(a);ACi(a);i=b;return}function nTc(a){a=a|0;return}function oTc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g;add(b,e,c[142306]|0,d,f);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;$cd(b,2646336,2646336,g+12|0,0);add(b,3142592,c[142294]|0,k,0);$cd(b,2646336,2646336,h,1);add(b,3142592,c[142260]|0,j,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);cdd(b);if(!(a[k>>0]&1)){bdd(b);i=g;return}f=c[k+8>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(f,h);bdd(b);i=g;return}function pTc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+48|0;f=d+36|0;g=d+32|0;h=d;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;$cd(b,2646336,2646336,f,e);add(b,3142592,609504,h,0);FTc(h,b);bdd(b);cdd(b);if(!(a[h+8>>0]&1)){i=d;return}b=c[h+16>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=d;return}function qTc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+32|0;f=d+24|0;g=d+20|0;h=d;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;$cd(b,2646336,2646336,f,e);add(b,3142592,609488,h,0);GTc(h,b);bdd(b);cdd(b);if(!(a[h+4>>0]&1)){i=d;return}b=c[h+12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=d;return}function rTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/12|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}HTc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142294]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;zXb(a,s,1);u=s+12|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,0)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else zXb(a,n,1);sdd(a)}n=n+12|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function sTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>5;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}ITc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,609504,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;JTc(r,a);t=r+32|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,609504,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else JTc(m,a);sdd(a)}m=m+32|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function tTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/20|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}KTc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,609488,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;LTc(r,a);t=r+20|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,609488,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else LTc(m,a);sdd(a)}m=m+20|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function uTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}MTc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142270]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=k;x=p;while(1){y=(da(v,m)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(g,w);y=g;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+4)|0,B>>>0<=(c[u>>2]|0)>>>0):0){c[x>>2]=c[y>>2];c[q>>2]=B}else Bid(q,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0;B=x+4|0;if((B|0)==(j|0))break a;v=c[c[n>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(j|0)){o=a+12|0;m=a+16|0;p=a+28|0;k=a+32|0;x=a+20|0;w=n;do{n=qdd(a,3142592,h,e,0)|0;if(n){if((n|0)>0){n=c[m>>2]|0;v=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[k>>2]|0,c[p>>2]|0)|0)|0;q=n+v|0;c[o>>2]=q;if((v|0)>=0?(u=n+(v+4)|0,u>>>0<=(c[x>>2]|0)>>>0):0){c[w>>2]=c[q>>2];c[o>>2]=u}else Bid(o,w,4);if(c[a>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{u=c[e>>2]|0;if(u)_n[u&4095](w,a)|0}sdd(a)}w=w+4|0}while((w|0)!=(j|0))}}while(0);udd(a);i=d;return}function vTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}HTc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{NXb(a,r,1);Ndd(a);r=r+12|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*12|0)|0;c[j>>2]=0;i=d;return}function wTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}ITc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{NTc(r,a);r=r+32|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<5)|0;c[j>>2]=0;i=d;return}function xTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}KTc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{OTc(r,a);r=r+20|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*20|0)|0;c[j>>2]=0;i=d;return}function yTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}MTc(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function zTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;HTc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{OXb(a,r,1);Mdd(a);r=r+12|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*12|0)|0;c[j>>2]=0;i=d;return}function ATc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;ITc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{PTc(r,a);r=r+32|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<5)|0;c[j>>2]=0;i=d;return}function BTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;KTc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{QTc(r,a);r=r+20|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*20|0)|0;c[j>>2]=0;i=d;return}function CTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<2)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;MTc(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,4);w=c[v>>2]|0}else{u=c[g>>2]|0;c[v>>2]=u;c[h>>2]=b;w=u}c[v>>2]=XEi(w|0)|0;v=v+4|0}while((v|0)!=(n|0));i=d;return}function DTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0<k>>>0){c[g>>2]=c[b>>2];c[f>>2]=h;l=k;m=h}else{Gid(f,b,4);l=c[j>>2]|0;m=c[f>>2]|0}h=b+4|0;k=m+4|0;if(k>>>0<l>>>0){c[m>>2]=c[h>>2];c[f>>2]=k}else Gid(f,h,4);Tdd(d);FXb(d,b+8|0,616088,0);Tdd(d);h=b+20|0;k=c[f>>2]|0;m=k+4|0;l=c[j>>2]|0;if(m>>>0<l>>>0){c[k>>2]=c[h>>2];c[f>>2]=m;n=m;o=l}else{Gid(f,h,4);n=c[f>>2]|0;o=c[j>>2]|0}h=b+24|0;l=n+4|0;if(l>>>0<o>>>0){c[n>>2]=c[h>>2];c[f>>2]=l}else Gid(f,h,4);Tdd(d);h=b+28|0;b=c[f>>2]|0;if((b+1|0)>>>0<(c[j>>2]|0)>>>0){a[b>>0]=a[h>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Tdd(d);i=e;return}else{Gid(f,h,1);Tdd(d);i=e;return}}function ETc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=b+4|0;g=c[f>>2]|0;h=c[b>>2]|0;j=(g-h|0)/20|0;c[e>>2]=j;k=a+12|0;l=c[k>>2]|0;m=l+4|0;n=a+20|0;if(m>>>0<(c[n>>2]|0)>>>0){c[l>>2]=j;c[k>>2]=m;o=h;p=g}else{Gid(k,e,4);o=c[b>>2]|0;p=c[f>>2]|0}if((o|0)==(p|0)){i=d;return}else q=o;do{o=c[k>>2]|0;f=o+4|0;if(f>>>0<(c[n>>2]|0)>>>0){c[o>>2]=c[q>>2];c[k>>2]=f}else Gid(k,q,4);FXb(a,q+4|0,609360,0);Tdd(a);f=q+16|0;o=c[k>>2]|0;b=o+4|0;if(b>>>0<(c[n>>2]|0)>>>0){c[o>>2]=c[f>>2];c[k>>2]=b}else Gid(k,f,4);Tdd(a);q=q+20|0}while((q|0)!=(p|0));i=d;return}function FTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=c[142270]|0;add(b,609392,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,609416,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);add(b,616088,c[142294]|0,a+8|0,0);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);fdd(b);add(b,609440,e,a+20|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,609456,e,a+24|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);add(b,609472,c[142258]|0,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function GTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=c[142270]|0;add(b,609344,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,609360,c[142294]|0,a+4|0,0);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);fdd(b);add(b,609376,e,a+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);i=d;return}function HTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+52|0;j=e;k=e+48|0;l=e+56|0;m=e+4|0;n=e+40|0;o=e+36|0;p=e+16|0;q=e+28|0;r=e+44|0;s=e+64|0;t=b+4|0;u=c[b>>2]|0;v=u;w=((c[t>>2]|0)-v|0)/12|0;if(w>>>0>=d>>>0){if(w>>>0<=d>>>0){i=e;return}c[q>>2]=u;c[r>>2]=u+(d*12|0);c[g+0>>2]=c[q+0>>2];c[f+0>>2]=c[r+0>>2];UTc(p,g,f,s,0);s=c[p>>2]|0;r=c[b>>2]|0;c[p>>2]=r;c[b>>2]=s;s=p+4|0;q=c[s>>2]|0;u=c[t>>2]|0;c[s>>2]=u;c[t>>2]=q;q=p+8|0;x=b+8|0;y=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=y;if(!r){i=e;return}if((u|0)==(r|0))z=r;else{y=u;while(1){u=y+-12|0;c[s>>2]=u;if(!(a[u>>0]&1))A=u;else{u=c[y+-4>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(u,f);A=c[s>>2]|0}if((A|0)==(r|0))break;else y=A}z=c[p>>2]|0}c[l>>2]=6;c[f+0>>2]=c[l+0>>2];eOb(z,f);i=e;return}z=b+8|0;if((((c[z>>2]|0)-v|0)/12|0|0)==(d|0)){TTc(b,d-w|0);i=e;return}c[m>>2]=0;w=m+4|0;c[w>>2]=0;v=m+8|0;c[v>>2]=0;RTc(m,d);c[n>>2]=c[b>>2];c[o>>2]=c[t>>2];c[g+0>>2]=c[n+0>>2];c[f+0>>2]=c[o+0>>2];STc(m,g,f);o=c[w>>2]|0;n=c[m>>2]|0;l=(o-n|0)/12|0;if(l>>>0>=d>>>0)if(l>>>0>d>>>0?(p=n+(d*12|0)|0,(o|0)!=(p|0)):0){n=o;while(1){A=n+-12|0;c[w>>2]=A;if(!(a[A>>0]&1))B=A;else{A=c[n+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(A,f);B=c[w>>2]|0}if((B|0)==(p|0)){C=p;break}else n=B}}else C=o;else{TTc(m,d-l|0);C=c[w>>2]|0}l=c[m>>2]|0;d=c[b>>2]|0;c[m>>2]=d;c[b>>2]=l;l=c[t>>2]|0;c[w>>2]=l;c[t>>2]=C;C=c[v>>2]|0;c[v>>2]=c[z>>2];c[z>>2]=C;if(!d){i=e;return}if((l|0)==(d|0))D=d;else{C=l;while(1){l=C+-12|0;c[w>>2]=l;if(!(a[l>>0]&1))E=l;else{l=c[C+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);E=c[w>>2]|0}if((E|0)==(d|0))break;else C=E}D=c[m>>2]|0}c[h>>2]=6;c[f+0>>2]=c[h+0>>2];eOb(D,f);i=e;return}function ITc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+52|0;j=e;k=e+48|0;l=e+56|0;m=e+4|0;n=e+40|0;o=e+36|0;p=e+16|0;q=e+28|0;r=e+44|0;s=e+64|0;t=b+4|0;u=c[b>>2]|0;v=u;w=(c[t>>2]|0)-v>>5;if(w>>>0>=d>>>0){if(w>>>0<=d>>>0){i=e;return}c[q>>2]=u;c[r>>2]=u+(d<<5);c[g+0>>2]=c[q+0>>2];c[f+0>>2]=c[r+0>>2];YTc(p,g,f,s,0);s=c[p>>2]|0;r=c[b>>2]|0;c[p>>2]=r;c[b>>2]=s;s=p+4|0;q=c[s>>2]|0;u=c[t>>2]|0;c[s>>2]=u;c[t>>2]=q;q=p+8|0;x=b+8|0;y=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=y;if(!r){i=e;return}if((u|0)==(r|0))z=r;else{y=u;while(1){u=y+-32|0;c[s>>2]=u;if(!(a[y+-24>>0]&1))A=u;else{u=c[y+-16>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(u,f);A=c[s>>2]|0}if((A|0)==(r|0))break;else y=A}z=c[p>>2]|0}c[l>>2]=6;c[f+0>>2]=c[l+0>>2];eOb(z,f);i=e;return}z=b+8|0;if(((c[z>>2]|0)-v>>5|0)==(d|0)){XTc(b,d-w|0);i=e;return}c[m>>2]=0;w=m+4|0;c[w>>2]=0;v=m+8|0;c[v>>2]=0;VTc(m,d);c[n>>2]=c[b>>2];c[o>>2]=c[t>>2];c[g+0>>2]=c[n+0>>2];c[f+0>>2]=c[o+0>>2];WTc(m,g,f);o=c[w>>2]|0;n=c[m>>2]|0;l=o-n>>5;if(l>>>0>=d>>>0)if(l>>>0>d>>>0?(p=n+(d<<5)|0,(o|0)!=(p|0)):0){n=o;while(1){A=n+-32|0;c[w>>2]=A;if(!(a[n+-24>>0]&1))B=A;else{A=c[n+-16>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(A,f);B=c[w>>2]|0}if((B|0)==(p|0)){C=p;break}else n=B}}else C=o;else{XTc(m,d-l|0);C=c[w>>2]|0}l=c[m>>2]|0;d=c[b>>2]|0;c[m>>2]=d;c[b>>2]=l;l=c[t>>2]|0;c[w>>2]=l;c[t>>2]=C;C=c[v>>2]|0;c[v>>2]=c[z>>2];c[z>>2]=C;if(!d){i=e;return}if((l|0)==(d|0))D=d;else{C=l;while(1){l=C+-32|0;c[w>>2]=l;if(!(a[C+-24>>0]&1))E=l;else{l=c[C+-16>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);E=c[w>>2]|0}if((E|0)==(d|0))break;else C=E}D=c[m>>2]|0}c[h>>2]=6;c[f+0>>2]=c[h+0>>2];eOb(D,f);i=e;return}function JTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[142270]|0;h=qdd(d,609392,g,f,0)|0;if(h){if((h|0)>0){h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[b>>2]=c[l>>2];c[h>>2]=m}else Bid(h,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](b,d)|0}sdd(d)}h=b+4|0;m=qdd(d,609416,g,f,0)|0;if(m){if((m|0)>0){m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[j>>2];c[m>>2]=n}else Bid(m,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}sdd(d)}h=b+8|0;m=qdd(d,616088,c[142294]|0,f,0)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else zXb(d,h,1);sdd(d)}h=b+20|0;m=qdd(d,609440,g,f,0)|0;if(m){if((m|0)>0){m=d+12|0;n=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[m>>2]=l}else Bid(m,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}sdd(d)}h=b+24|0;m=qdd(d,609456,g,f,0)|0;if(m){if((m|0)>0){m=d+12|0;g=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=g+l|0;c[m>>2]=k;if((l|0)>=0?(j=g+(l+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[m>>2]=j}else Bid(m,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}sdd(d)}h=b+28|0;b=qdd(d,609472,c[142258]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[m>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d);i=e;return}function KTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+52|0;j=e;k=e+48|0;l=e+56|0;m=e+4|0;n=e+40|0;o=e+36|0;p=e+16|0;q=e+28|0;r=e+44|0;s=e+64|0;t=b+4|0;u=c[b>>2]|0;v=u;w=((c[t>>2]|0)-v|0)/20|0;if(w>>>0>=d>>>0){if(w>>>0<=d>>>0){i=e;return}c[q>>2]=u;c[r>>2]=u+(d*20|0);c[g+0>>2]=c[q+0>>2];c[f+0>>2]=c[r+0>>2];aUc(p,g,f,s,0);s=c[p>>2]|0;r=c[b>>2]|0;c[p>>2]=r;c[b>>2]=s;s=p+4|0;q=c[s>>2]|0;u=c[t>>2]|0;c[s>>2]=u;c[t>>2]=q;q=p+8|0;x=b+8|0;y=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=y;if(!r){i=e;return}if((u|0)==(r|0))z=r;else{y=u;while(1){u=y+-20|0;c[s>>2]=u;if(!(a[y+-16>>0]&1))A=u;else{u=c[y+-8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(u,f);A=c[s>>2]|0}if((A|0)==(r|0))break;else y=A}z=c[p>>2]|0}c[l>>2]=6;c[f+0>>2]=c[l+0>>2];eOb(z,f);i=e;return}z=b+8|0;if((((c[z>>2]|0)-v|0)/20|0|0)==(d|0)){$Tc(b,d-w|0);i=e;return}c[m>>2]=0;w=m+4|0;c[w>>2]=0;v=m+8|0;c[v>>2]=0;ZTc(m,d);c[n>>2]=c[b>>2];c[o>>2]=c[t>>2];c[g+0>>2]=c[n+0>>2];c[f+0>>2]=c[o+0>>2];_Tc(m,g,f);o=c[w>>2]|0;n=c[m>>2]|0;l=(o-n|0)/20|0;if(l>>>0>=d>>>0)if(l>>>0>d>>>0?(p=n+(d*20|0)|0,(o|0)!=(p|0)):0){n=o;while(1){A=n+-20|0;c[w>>2]=A;if(!(a[n+-16>>0]&1))B=A;else{A=c[n+-8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(A,f);B=c[w>>2]|0}if((B|0)==(p|0)){C=p;break}else n=B}}else C=o;else{$Tc(m,d-l|0);C=c[w>>2]|0}l=c[m>>2]|0;d=c[b>>2]|0;c[m>>2]=d;c[b>>2]=l;l=c[t>>2]|0;c[w>>2]=l;c[t>>2]=C;C=c[v>>2]|0;c[v>>2]=c[z>>2];c[z>>2]=C;if(!d){i=e;return}if((l|0)==(d|0))D=d;else{C=l;while(1){l=C+-20|0;c[w>>2]=l;if(!(a[C+-16>>0]&1))E=l;else{l=c[C+-8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);E=c[w>>2]|0}if((E|0)==(d|0))break;else C=E}D=c[m>>2]|0}c[h>>2]=6;c[f+0>>2]=c[h+0>>2];eOb(D,f);i=e;return}function LTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=c[142270]|0;g=qdd(b,609344,f,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[g>>2]=l}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+4|0;l=qdd(b,609360,c[142294]|0,e,0)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}else zXb(b,g,1);sdd(b)}g=a+16|0;a=qdd(b,609376,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=f+l|0;c[a>>2]=k;if((l|0)>=0?(j=f+(l+4)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[k>>2];c[a>>2]=j}else Bid(a,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}sdd(b);i=d;return}function MTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>2;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<2);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];dUc(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[h>>2]=6;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>2|0)==(b|0)){cUc(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=6,c[e+0>>2]=c[f+0>>2],h=cOb(b<<2,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>2)<<2)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<2),(p|0)!=0):0){c[g>>2]=6;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];bUc(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>2;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<2)|0,(l|0)!=(g|0)):0){h=l+(~((l+-4-g|0)>>>2)<<2)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{cUc(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-4-p|0)>>>2)<<2);c[f>>2]=6;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function NTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,b,4);l=c[j>>2]|0;m=c[f>>2]|0}else{c[b>>2]=c[g>>2];c[f>>2]=h;l=k;m=h}h=b+4|0;k=m+4|0;if(k>>>0>l>>>0)Bid(f,h,4);else{c[h>>2]=c[m>>2];c[f>>2]=k}Ndd(d);NXb(d,b+8|0,1);Ndd(d);Ndd(d);k=b+20|0;m=c[f>>2]|0;h=m+4|0;l=c[j>>2]|0;if(h>>>0>l>>>0){Bid(f,k,4);n=c[f>>2]|0;o=c[j>>2]|0}else{c[k>>2]=c[m>>2];c[f>>2]=h;n=h;o=l}l=b+24|0;h=n+4|0;if(h>>>0>o>>>0)Bid(f,l,4);else{c[l>>2]=c[n>>2];c[f>>2]=h}Ndd(d);h=b+28|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,h,1);Ndd(d);i=e;return}else{a[h>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function OTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;if(g>>>0>(c[h>>2]|0)>>>0)Bid(e,a,4);else{c[a>>2]=c[f>>2];c[e>>2]=g}NXb(b,a+4|0,1);Ndd(b);Ndd(b);g=a+16|0;a=c[e>>2]|0;f=a+4|0;if(f>>>0>(c[h>>2]|0)>>>0){Bid(e,g,4);Ndd(b);i=d;return}else{c[g>>2]=c[a>>2];c[e>>2]=f;Ndd(b);i=d;return}}function PTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=d+12|0;g=c[f>>2]|0;h=g+4|0;j=d+20|0;k=c[j>>2]|0;if(h>>>0>k>>>0){Bid(f,b,4);l=c[f>>2]|0;m=c[j>>2]|0;n=c[b>>2]|0}else{o=c[g>>2]|0;c[b>>2]=o;c[f>>2]=h;l=h;m=k;n=o}c[b>>2]=XEi(n|0)|0;n=b+4|0;o=l+4|0;if(o>>>0>m>>>0){Bid(f,n,4);p=c[n>>2]|0}else{m=c[l>>2]|0;c[n>>2]=m;c[f>>2]=o;p=m}c[n>>2]=XEi(p|0)|0;Mdd(d);OXb(d,b+8|0,1);Mdd(d);Mdd(d);p=b+20|0;n=c[f>>2]|0;m=n+4|0;o=c[j>>2]|0;if(m>>>0>o>>>0){Bid(f,p,4);q=c[p>>2]|0;r=c[f>>2]|0;s=c[j>>2]|0}else{l=c[n>>2]|0;c[p>>2]=l;c[f>>2]=m;q=l;r=m;s=o}c[p>>2]=XEi(q|0)|0;q=b+24|0;p=r+4|0;if(p>>>0>s>>>0){Bid(f,q,4);t=c[q>>2]|0}else{s=c[r>>2]|0;c[q>>2]=s;c[f>>2]=p;t=s}c[q>>2]=XEi(t|0)|0;Mdd(d);t=b+28|0;b=c[f>>2]|0;if((b+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(f,t,1);Mdd(d);i=e;return}else{a[t>>0]=a[b>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function QTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;if(g>>>0>(c[h>>2]|0)>>>0){Bid(e,a,4);j=c[a>>2]|0}else{k=c[f>>2]|0;c[a>>2]=k;c[e>>2]=g;j=k}c[a>>2]=XEi(j|0)|0;OXb(b,a+4|0,1);Mdd(b);Mdd(b);j=a+16|0;a=c[e>>2]|0;k=a+4|0;if(k>>>0>(c[h>>2]|0)>>>0){Bid(e,j,4);l=c[j>>2]|0;m=XEi(l|0)|0;c[j>>2]=m;Mdd(b);i=d;return}else{h=c[a>>2]|0;c[j>>2]=h;c[e>>2]=k;l=h;m=XEi(l|0)|0;c[j>>2]=m;Mdd(b);i=d;return}}function RTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b>>2]|0;if((((c[b+8>>2]|0)-k|0)/12|0)>>>0>=d>>>0){i=e;return}l=((c[b+4>>2]|0)-k|0)/12|0;k=j+12|0;c[k>>2]=0;c[j+16>>2]=b+8;if(!d)m=0;else{c[g>>2]=6;c[f+0>>2]=c[g+0>>2];m=cOb(d*12|0,16,f,0,3653512,80)|0}c[j>>2]=m;n=m+(l*12|0)|0;l=j+8|0;c[l>>2]=n;o=j+4|0;c[o>>2]=n;c[k>>2]=m+(d*12|0);eUc(b,j);b=c[o>>2]|0;o=c[l>>2]|0;if((o|0)!=(b|0)){d=o;do{o=d;d=d+-12|0;c[l>>2]=d;if(a[d>>0]&1){m=c[o+-4>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(m,f)}}while((d|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function STc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;k=j;l=d-k|0;m=(l|0)/12|0;n=b+8|0;o=c[b>>2]|0;p=o;if(m>>>0>(((c[n>>2]|0)-p|0)/12|0)>>>0){fUc(b);if((l|0)<0)vxi(b);l=((c[n>>2]|0)-(c[b>>2]|0)|0)/12|0;if(l>>>0<1073741823){q=l<<1;l=q>>>0<m>>>0?m:q;if((l|0)<0)vxi(b);else r=l}else r=2147483647;c[h>>2]=6;c[g+0>>2]=c[h+0>>2];l=cOb(r*12|0,16,g,0,3653512,80)|0;q=b+4|0;c[q>>2]=l;c[b>>2]=l;c[n>>2]=l+(r*12|0);if((j|0)==(d|0)){i=f;return}r=l;l=j;while(1){if(!r)s=0;else{n=a[l>>0]|0;if(!(n&1)){t=(n&255)>>>1;u=l+1|0}else{t=c[l+4>>2]|0;u=c[l+8>>2]|0}if(t>>>0>2147483631){v=56;break}if(t>>>0<11){a[r>>0]=t<<1;w=r+1|0}else{n=t+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];x=cOb(n,16,g,0,3653512,80)|0;c[r+8>>2]=x;c[r>>2]=n|1;c[r+4>>2]=t;w=x}YEi(w|0,u|0,t|0)|0;a[w+t>>0]=0;s=c[q>>2]|0}x=s+12|0;c[q>>2]=x;l=l+12|0;if((l|0)==(d|0)){v=62;break}else r=x}if((v|0)==56)ori(r);else if((v|0)==62){i=f;return}}r=b+4|0;b=((c[r>>2]|0)-p|0)/12|0;if(m>>>0>b>>>0){y=j+(b*12|0)|0;z=1}else{y=d;z=0}if((j|0)==(y|0))A=o;else{d=((y+-12-k|0)>>>0)/12|0;k=o;b=j;while(1){do if((k|0)!=(b|0)){j=a[b>>0]|0;if(!(j&1)){B=(j&255)>>>1;C=b+1|0}else{B=c[b+4>>2]|0;C=c[b+8>>2]|0}j=a[k>>0]|0;if(!(j&1)){D=10;E=j}else{j=c[k>>2]|0;D=(j&-2)+-1|0;E=j&255}j=(E&1)==0;if(B>>>0>D>>>0){if(j)F=(E&255)>>>1;else F=c[k+4>>2]|0;eXb(k,D,B-D|0,F,0,F,B,C);break}if(j)G=k+1|0;else G=c[k+8>>2]|0;aFi(G|0,C|0,B|0)|0;a[G+B>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=B<<1;break}else{c[k+4>>2]=B;break}}while(0);b=b+12|0;if((b|0)==(y|0))break;else k=k+12|0}A=o+((d+1|0)*12|0)|0}if(!z){z=c[r>>2]|0;if((z|0)==(A|0)){i=f;return}d=z;while(1){z=d+-12|0;c[r>>2]=z;if(!(a[z>>0]&1))H=z;else{z=c[d+-4>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(z,g);H=c[r>>2]|0}if((H|0)==(A|0))break;else d=H}i=f;return}H=c[e>>2]|0;if((y|0)==(H|0)){i=f;return}e=c[r>>2]|0;d=y;while(1){if(!e)I=0;else{y=a[d>>0]|0;if(!(y&1)){J=d+1|0;K=(y&255)>>>1}else{J=c[d+8>>2]|0;K=c[d+4>>2]|0}if(K>>>0>2147483631){v=33;break}if(K>>>0<11){a[e>>0]=K<<1;L=e+1|0}else{y=K+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];A=cOb(y,16,g,0,3653512,80)|0;c[e+8>>2]=A;c[e>>2]=y|1;c[e+4>>2]=K;L=A}YEi(L|0,J|0,K|0)|0;a[L+K>>0]=0;I=c[r>>2]|0}A=I+12|0;c[r>>2]=A;d=d+12|0;if((d|0)==(H|0)){v=62;break}else e=A}if((v|0)==33)ori(e);else if((v|0)==62){i=f;return}}function TTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b+8>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/12|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;q=c[l>>2]|0}p=q+12|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/12|0)+d|0;if((p|0)<0)vxi(b);n=o;o=(k-n|0)/12|0;if(o>>>0<1073741823){k=o<<1;r=k>>>0<p>>>0?p:k}else r=2147483647;k=((c[l>>2]|0)-n|0)/12|0;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!r)s=0;else{c[g>>2]=6;c[f+0>>2]=c[g+0>>2];s=cOb(r*12|0,16,f,0,3653512,80)|0}c[j>>2]=s;l=s+(k*12|0)|0;k=j+8|0;c[k>>2]=l;p=j+4|0;c[p>>2]=l;c[n>>2]=s+(r*12|0);r=d;d=l;while(1){if(!d)t=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;t=d}l=t+12|0;r=r+-1|0;if(!r){u=l;break}else d=l}c[k>>2]=u;eUc(b,j);b=c[p>>2]|0;p=c[k>>2]|0;if((p|0)!=(b|0)){u=p;do{p=u;u=u+-12|0;c[k>>2]=u;if(a[u>>0]&1){d=c[p+-4>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((u|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function UTc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=6;c[f+0>>2]=c[h+0>>2];m=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=m;c[b>>2]=m;c[k>>2]=m+(((e|0)/12|0)*12|0);e=m;m=l;while(1){if(!e)n=0;else{l=a[m>>0]|0;if(!(l&1)){o=(l&255)>>>1;p=m+1|0}else{o=c[m+4>>2]|0;p=c[m+8>>2]|0}if(o>>>0>2147483631){q=10;break}if(o>>>0<11){a[e>>0]=o<<1;r=e+1|0}else{l=o+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];k=cOb(l,16,f,0,3653512,80)|0;c[e+8>>2]=k;c[e>>2]=l|1;c[e+4>>2]=o;r=k}YEi(r|0,p|0,o|0)|0;a[r+o>>0]=0;n=c[j>>2]|0}k=n+12|0;c[j>>2]=k;m=m+12|0;if((m|0)==(d|0)){q=16;break}else e=k}if((q|0)==10)ori(e);else if((q|0)==16){i=g;return}}function VTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b>>2]|0;if((c[b+8>>2]|0)-k>>5>>>0>=d>>>0){i=e;return}l=(c[b+4>>2]|0)-k>>5;k=j+12|0;c[k>>2]=0;c[j+16>>2]=b+8;if(!d)m=0;else{c[g>>2]=6;c[f+0>>2]=c[g+0>>2];m=cOb(d<<5,16,f,0,3653512,80)|0}c[j>>2]=m;n=m+(l<<5)|0;l=j+8|0;c[l>>2]=n;o=j+4|0;c[o>>2]=n;c[k>>2]=m+(d<<5);gUc(b,j);b=c[o>>2]|0;o=c[l>>2]|0;if((o|0)!=(b|0)){d=o;do{o=d;d=d+-32|0;c[l>>2]=d;if(a[o+-24>>0]&1){m=c[o+-16>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(m,f)}}while((d|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function WTc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;k=j;l=d-k|0;m=l>>5;n=b+8|0;o=c[b>>2]|0;p=o;if(m>>>0>(c[n>>2]|0)-p>>5>>>0){hUc(b);if((l|0)<0)vxi(b);l=(c[n>>2]|0)-(c[b>>2]|0)|0;if(l>>5>>>0<1073741823){q=l>>4;l=q>>>0<m>>>0?m:q;if((l|0)<0)vxi(b);else r=l}else r=2147483647;c[h>>2]=6;c[g+0>>2]=c[h+0>>2];l=cOb(r<<5,16,g,0,3653512,80)|0;q=b+4|0;c[q>>2]=l;c[b>>2]=l;c[n>>2]=l+(r<<5);if((j|0)==(d|0)){i=f;return}r=l;l=j;while(1){if(!r)s=0;else{n=l;t=c[n+4>>2]|0;u=r;c[u>>2]=c[n>>2];c[u+4>>2]=t;v=r+8|0;t=l+8|0;u=a[t>>0]|0;if(!(u&1)){w=(u&255)>>>1;x=t+1|0}else{w=c[l+12>>2]|0;x=c[l+16>>2]|0}if(w>>>0>2147483631){y=56;break}if(w>>>0<11){a[v>>0]=w<<1;z=v+1|0}else{t=w+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];u=cOb(t,16,g,0,3653512,80)|0;c[r+16>>2]=u;c[v>>2]=t|1;c[r+12>>2]=w;z=u}YEi(z|0,x|0,w|0)|0;a[z+w>>0]=0;u=r+20|0;t=l+20|0;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];a[u+8>>0]=a[t+8>>0]|0;s=c[q>>2]|0}r=s+32|0;c[q>>2]=r;l=l+32|0;if((l|0)==(d|0)){y=62;break}}if((y|0)==56)ori(v);else if((y|0)==62){i=f;return}}v=b+4|0;b=(c[v>>2]|0)-p>>5;if(m>>>0>b>>>0){A=j+(b<<5)|0;B=1}else{A=d;B=0}if((j|0)==(A|0))C=o;else{d=(A+-32-k|0)>>>5;k=o;b=j;while(1){j=b;m=c[j+4>>2]|0;p=k;c[p>>2]=c[j>>2];c[p+4>>2]=m;m=k+8|0;p=b+8|0;do if((k|0)!=(b|0)){j=a[p>>0]|0;if(!(j&1)){D=(j&255)>>>1;E=p+1|0}else{D=c[b+12>>2]|0;E=c[b+16>>2]|0}j=a[m>>0]|0;if(!(j&1)){F=10;G=j}else{j=c[m>>2]|0;F=(j&-2)+-1|0;G=j&255}j=(G&1)==0;if(D>>>0>F>>>0){if(j)H=(G&255)>>>1;else H=c[k+12>>2]|0;eXb(m,F,D-F|0,H,0,H,D,E);break}if(j)I=m+1|0;else I=c[k+16>>2]|0;aFi(I|0,E|0,D|0)|0;a[I+D>>0]=0;if(!(a[m>>0]&1)){a[m>>0]=D<<1;break}else{c[k+12>>2]=D;break}}while(0);m=k+20|0;p=b+20|0;c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];a[m+8>>0]=a[p+8>>0]|0;b=b+32|0;if((b|0)==(A|0))break;else k=k+32|0}C=o+(d+1<<5)|0}if(!B){B=c[v>>2]|0;if((B|0)==(C|0)){i=f;return}d=B;while(1){B=d+-32|0;c[v>>2]=B;if(!(a[d+-24>>0]&1))J=B;else{B=c[d+-16>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(B,g);J=c[v>>2]|0}if((J|0)==(C|0))break;else d=J}i=f;return}J=c[e>>2]|0;if((A|0)==(J|0)){i=f;return}e=c[v>>2]|0;d=A;while(1){if(!e)K=0;else{A=d;C=c[A+4>>2]|0;B=e;c[B>>2]=c[A>>2];c[B+4>>2]=C;L=e+8|0;C=d+8|0;B=a[C>>0]|0;if(!(B&1)){M=(B&255)>>>1;N=C+1|0}else{M=c[d+12>>2]|0;N=c[d+16>>2]|0}if(M>>>0>2147483631){y=33;break}if(M>>>0<11){a[L>>0]=M<<1;O=L+1|0}else{C=M+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];B=cOb(C,16,g,0,3653512,80)|0;c[e+16>>2]=B;c[L>>2]=C|1;c[e+12>>2]=M;O=B}YEi(O|0,N|0,M|0)|0;a[O+M>>0]=0;B=e+20|0;C=d+20|0;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];a[B+8>>0]=a[C+8>>0]|0;K=c[v>>2]|0}e=K+32|0;c[v>>2]=e;d=d+32|0;if((d|0)==(J|0)){y=62;break}}if((y|0)==33)ori(L);else if((y|0)==62){i=f;return}}function XTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b+8>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(k-n>>5>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;q=c[l>>2]|0}p=q+32|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=(n-o>>5)+d|0;if((p|0)<0)vxi(b);n=o;o=k-n|0;if(o>>5>>>0<1073741823){k=o>>4;r=k>>>0<p>>>0?p:k}else r=2147483647;k=(c[l>>2]|0)-n>>5;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!r)s=0;else{c[g>>2]=6;c[f+0>>2]=c[g+0>>2];s=cOb(r<<5,16,f,0,3653512,80)|0}c[j>>2]=s;l=s+(k<<5)|0;k=j+8|0;c[k>>2]=l;p=j+4|0;c[p>>2]=l;c[n>>2]=s+(r<<5);r=d;d=l;while(1){if(!d)t=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;t=d}l=t+32|0;r=r+-1|0;if(!r){u=l;break}else d=l}c[k>>2]=u;gUc(b,j);b=c[p>>2]|0;p=c[k>>2]|0;if((p|0)!=(b|0)){u=p;do{p=u;u=u+-32|0;c[k>>2]=u;if(a[p+-24>>0]&1){d=c[p+-16>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((u|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function YTc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;m=e>>5;if(!m){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=6;c[f+0>>2]=c[h+0>>2];n=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=n;c[b>>2]=n;c[k>>2]=n+(m<<5);if((l|0)==(d|0)){i=g;return}m=n;n=l;while(1){if(!m)o=0;else{l=n;k=c[l+4>>2]|0;b=m;c[b>>2]=c[l>>2];c[b+4>>2]=k;p=m+8|0;k=n+8|0;b=a[k>>0]|0;if(!(b&1)){q=(b&255)>>>1;r=k+1|0}else{q=c[n+12>>2]|0;r=c[n+16>>2]|0}if(q>>>0>2147483631){s=11;break}if(q>>>0<11){a[p>>0]=q<<1;t=p+1|0}else{k=q+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];b=cOb(k,16,f,0,3653512,80)|0;c[m+16>>2]=b;c[p>>2]=k|1;c[m+12>>2]=q;t=b}YEi(t|0,r|0,q|0)|0;a[t+q>>0]=0;b=m+20|0;k=n+20|0;c[b+0>>2]=c[k+0>>2];c[b+4>>2]=c[k+4>>2];a[b+8>>0]=a[k+8>>0]|0;o=c[j>>2]|0}m=o+32|0;c[j>>2]=m;n=n+32|0;if((n|0)==(d|0)){s=17;break}}if((s|0)==11)ori(p);else if((s|0)==17){i=g;return}}function ZTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b>>2]|0;if((((c[b+8>>2]|0)-k|0)/20|0)>>>0>=d>>>0){i=e;return}l=((c[b+4>>2]|0)-k|0)/20|0;k=j+12|0;c[k>>2]=0;c[j+16>>2]=b+8;if(!d)m=0;else{c[g>>2]=6;c[f+0>>2]=c[g+0>>2];m=cOb(d*20|0,16,f,0,3653512,80)|0}c[j>>2]=m;n=m+(l*20|0)|0;l=j+8|0;c[l>>2]=n;o=j+4|0;c[o>>2]=n;c[k>>2]=m+(d*20|0);iUc(b,j);b=c[o>>2]|0;o=c[l>>2]|0;if((o|0)!=(b|0)){d=o;do{o=d;d=d+-20|0;c[l>>2]=d;if(a[o+-16>>0]&1){m=c[o+-8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(m,f)}}while((d|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function _Tc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;k=j;l=d-k|0;m=(l|0)/20|0;n=b+8|0;o=c[b>>2]|0;p=o;if(m>>>0>(((c[n>>2]|0)-p|0)/20|0)>>>0){jUc(b);if((l|0)<0)vxi(b);l=((c[n>>2]|0)-(c[b>>2]|0)|0)/20|0;if(l>>>0<1073741823){q=l<<1;l=q>>>0<m>>>0?m:q;if((l|0)<0)vxi(b);else r=l}else r=2147483647;c[h>>2]=6;c[g+0>>2]=c[h+0>>2];l=cOb(r*20|0,16,g,0,3653512,80)|0;q=b+4|0;c[q>>2]=l;c[b>>2]=l;c[n>>2]=l+(r*20|0);if((j|0)==(d|0)){i=f;return}r=l;l=j;while(1){if(!r)s=0;else{c[r>>2]=c[l>>2];t=r+4|0;n=l+4|0;u=a[n>>0]|0;if(!(u&1)){v=(u&255)>>>1;w=n+1|0}else{v=c[l+8>>2]|0;w=c[l+12>>2]|0}if(v>>>0>2147483631){x=56;break}if(v>>>0<11){a[t>>0]=v<<1;y=t+1|0}else{n=v+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];u=cOb(n,16,g,0,3653512,80)|0;c[r+12>>2]=u;c[t>>2]=n|1;c[r+8>>2]=v;y=u}YEi(y|0,w|0,v|0)|0;a[y+v>>0]=0;c[r+16>>2]=c[l+16>>2];s=c[q>>2]|0}r=s+20|0;c[q>>2]=r;l=l+20|0;if((l|0)==(d|0)){x=62;break}}if((x|0)==56)ori(t);else if((x|0)==62){i=f;return}}t=b+4|0;b=((c[t>>2]|0)-p|0)/20|0;if(m>>>0>b>>>0){z=j+(b*20|0)|0;A=1}else{z=d;A=0}if((j|0)==(z|0))B=o;else{d=((z+-20-k|0)>>>0)/20|0;k=o;b=j;while(1){c[k>>2]=c[b>>2];j=k+4|0;m=b+4|0;do if((k|0)!=(b|0)){p=a[m>>0]|0;if(!(p&1)){C=(p&255)>>>1;D=m+1|0}else{C=c[b+8>>2]|0;D=c[b+12>>2]|0}p=a[j>>0]|0;if(!(p&1)){E=10;F=p}else{p=c[j>>2]|0;E=(p&-2)+-1|0;F=p&255}p=(F&1)==0;if(C>>>0>E>>>0){if(p)G=(F&255)>>>1;else G=c[k+8>>2]|0;eXb(j,E,C-E|0,G,0,G,C,D);break}if(p)H=j+1|0;else H=c[k+12>>2]|0;aFi(H|0,D|0,C|0)|0;a[H+C>>0]=0;if(!(a[j>>0]&1)){a[j>>0]=C<<1;break}else{c[k+8>>2]=C;break}}while(0);c[k+16>>2]=c[b+16>>2];b=b+20|0;if((b|0)==(z|0))break;else k=k+20|0}B=o+((d+1|0)*20|0)|0}if(!A){A=c[t>>2]|0;if((A|0)==(B|0)){i=f;return}d=A;while(1){A=d+-20|0;c[t>>2]=A;if(!(a[d+-16>>0]&1))I=A;else{A=c[d+-8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(A,g);I=c[t>>2]|0}if((I|0)==(B|0))break;else d=I}i=f;return}I=c[e>>2]|0;if((z|0)==(I|0)){i=f;return}e=c[t>>2]|0;d=z;while(1){if(!e)J=0;else{c[e>>2]=c[d>>2];K=e+4|0;z=d+4|0;B=a[z>>0]|0;if(!(B&1)){L=z+1|0;M=(B&255)>>>1}else{L=c[d+12>>2]|0;M=c[d+8>>2]|0}if(M>>>0>2147483631){x=33;break}if(M>>>0<11){a[K>>0]=M<<1;N=K+1|0}else{B=M+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];z=cOb(B,16,g,0,3653512,80)|0;c[e+12>>2]=z;c[K>>2]=B|1;c[e+8>>2]=M;N=z}YEi(N|0,L|0,M|0)|0;a[N+M>>0]=0;c[e+16>>2]=c[d+16>>2];J=c[t>>2]|0}e=J+20|0;c[t>>2]=e;d=d+20|0;if((d|0)==(I|0)){x=62;break}}if((x|0)==33)ori(K);else if((x|0)==62){i=f;return}}function $Tc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b+8>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/20|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;q=c[l>>2]|0}p=q+20|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/20|0)+d|0;if((p|0)<0)vxi(b);n=o;o=(k-n|0)/20|0;if(o>>>0<1073741823){k=o<<1;r=k>>>0<p>>>0?p:k}else r=2147483647;k=((c[l>>2]|0)-n|0)/20|0;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!r)s=0;else{c[g>>2]=6;c[f+0>>2]=c[g+0>>2];s=cOb(r*20|0,16,f,0,3653512,80)|0}c[j>>2]=s;l=s+(k*20|0)|0;k=j+8|0;c[k>>2]=l;p=j+4|0;c[p>>2]=l;c[n>>2]=s+(r*20|0);r=d;d=l;while(1){if(!d)t=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;t=d}l=t+20|0;r=r+-1|0;if(!r){u=l;break}else d=l}c[k>>2]=u;iUc(b,j);b=c[p>>2]|0;p=c[k>>2]|0;if((p|0)!=(b|0)){u=p;do{p=u;u=u+-20|0;c[k>>2]=u;if(a[p+-16>>0]&1){d=c[p+-8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((u|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function aUc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=6;c[f+0>>2]=c[h+0>>2];m=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=m;c[b>>2]=m;c[k>>2]=m+(((e|0)/20|0)*20|0);e=m;m=l;while(1){if(!e)n=0;else{c[e>>2]=c[m>>2];o=e+4|0;l=m+4|0;k=a[l>>0]|0;if(!(k&1)){p=(k&255)>>>1;q=l+1|0}else{p=c[m+8>>2]|0;q=c[m+12>>2]|0}if(p>>>0>2147483631){r=10;break}if(p>>>0<11){a[o>>0]=p<<1;s=o+1|0}else{l=p+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];k=cOb(l,16,f,0,3653512,80)|0;c[e+12>>2]=k;c[o>>2]=l|1;c[e+8>>2]=p;s=k}YEi(s|0,q|0,p|0)|0;a[s+p>>0]=0;c[e+16>>2]=c[m+16>>2];n=c[j>>2]|0}e=n+20|0;c[j>>2]=e;m=m+20|0;if((m|0)==(d|0)){r=16;break}}if((r|0)==10)ori(o);else if((r|0)==16){i=g;return}}function bUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>2>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>2;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>2<<2)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-4-t|0)>>>2)<<2);i=e;return}t=h+(r<<2)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-4-t|0)>>>2;s=q;u=t;while(1){if(s)c[s>>2]=c[u>>2];u=u+4|0;if((u|0)==(b|0))break;else s=s+4|0}c[p>>2]=q+(r+1<<2);i=e;return}if(!n)v=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[g>>2]=6;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;v=0}if((j|0)<0)vxi(a);j=v-0|0;if(j>>2>>>0<1073741823){v=j>>1;j=v>>>0<k>>>0?k:v;if((j|0)<0)vxi(a);else w=j}else w=2147483647;c[g>>2]=6;c[f+0>>2]=c[g+0>>2];g=cOb(w<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(w<<2);if((h|0)==(b|0)){i=e;return}w=(b+-4-d|0)>>>2;d=g;l=h;while(1){if(d)c[d>>2]=c[l>>2];l=l+4|0;if((l|0)==(b|0))break;else d=d+4|0}c[f>>2]=g+(w+1<<2);i=e;return}function cUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)c[n>>2]=0;m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>2>>>0<1073741823){h=k>>1;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=(c[j>>2]|0)-l>>2;t=11}if((t|0)==11){c[f>>2]=6;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r<<2,16,e,0,3653512,80)|0;q=s}s=b;r=p+(q<<2)|0;while(1){if(r)c[r>>2]=0;s=s+-1|0;if(!s)break;else r=r+4|0}r=c[a>>2]|0;s=(c[j>>2]|0)-r|0;t=p+(q-(s>>2)<<2)|0;YEi(t|0,r|0,s|0)|0;s=c[a>>2]|0;c[a>>2]=t;c[j>>2]=p+(q+b<<2);c[g>>2]=p+(o<<2);if(!s){i=d;return}c[f>>2]=6;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function dUc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=6;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function eUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=n+-12|0;p=m;m=m+-12|0;q=a[m>>0]|0;if(!(q&1)){r=(q&255)>>>1;s=m+1|0}else{r=c[p+-8>>2]|0;s=c[p+-4>>2]|0}if(r>>>0>2147483631){t=8;break}if(r>>>0<11){a[o>>0]=r<<1;u=o+1|0}else{p=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];q=cOb(p,16,f,0,3653512,80)|0;c[n+-4>>2]=q;c[o>>2]=p|1;c[n+-8>>2]=r;u=q}YEi(u|0,s|0,r|0)|0;a[u+r>>0]=0;q=(c[l>>2]|0)+-12|0;c[l>>2]=q;if((m|0)==(h|0)){v=q;t=13;break}else n=q}if((t|0)==8)ori(o);else if((t|0)==13){w=v;x=c[b>>2]|0;break}}else{w=c[l>>2]|0;x=h}while(0);c[b>>2]=w;c[l>>2]=x;x=d+8|0;w=c[j>>2]|0;c[j>>2]=c[x>>2];c[x>>2]=w;w=b+8|0;b=d+12|0;x=c[w>>2]|0;c[w>>2]=c[b>>2];c[b>>2]=x;c[d>>2]=c[l>>2];i=e;return}function fUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;if(!h){i=d;return}j=b+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-12|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[b>>2]|0}c[g>>2]=6;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[b+8>>2]=0;c[j>>2]=0;c[b>>2]=0;i=d;return}function gUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;if((k|0)==(h|0)){m=c[l>>2]|0;n=h;c[b>>2]=m;c[l>>2]=n;o=d+8|0;p=c[j>>2]|0;q=c[o>>2]|0;c[j>>2]=q;c[o>>2]=p;r=b+8|0;s=d+12|0;t=c[r>>2]|0;u=c[s>>2]|0;c[r>>2]=u;c[s>>2]=t;v=c[l>>2]|0;c[d>>2]=v;i=e;return}w=k;k=c[l>>2]|0;while(1){x=w;w=w+-32|0;y=w;z=c[y+4>>2]|0;A=k+-32|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;B=k+-24|0;z=x+-24|0;A=a[z>>0]|0;if(!(A&1)){C=(A&255)>>>1;D=z+1|0}else{C=c[x+-20>>2]|0;D=c[x+-16>>2]|0}if(C>>>0>2147483631){E=8;break}if(C>>>0<11){a[B>>0]=C<<1;F=B+1|0}else{z=C+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];A=cOb(z,16,f,0,3653512,80)|0;c[k+-16>>2]=A;c[B>>2]=z|1;c[k+-20>>2]=C;F=A}YEi(F|0,D|0,C|0)|0;a[F+C>>0]=0;A=k+-12|0;z=x+-12|0;c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];a[A+8>>0]=a[z+8>>0]|0;z=(c[l>>2]|0)+-32|0;c[l>>2]=z;if((w|0)==(h|0)){G=z;break}else k=z}if((E|0)==8)ori(B);m=G;n=c[b>>2]|0;c[b>>2]=m;c[l>>2]=n;o=d+8|0;p=c[j>>2]|0;q=c[o>>2]|0;c[j>>2]=q;c[o>>2]=p;r=b+8|0;s=d+12|0;t=c[r>>2]|0;u=c[s>>2]|0;c[r>>2]=u;c[s>>2]=t;v=c[l>>2]|0;c[d>>2]=v;i=e;return}function hUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;if(!h){i=d;return}j=b+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-32|0;c[j>>2]=k;if(!(a[m+-24>>0]&1))n=k;else{k=c[m+-16>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[b>>2]|0}c[g>>2]=6;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[b+8>>2]=0;c[j>>2]=0;c[b>>2]=0;i=d;return}function iUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=m;m=m+-20|0;c[n+-20>>2]=c[m>>2];p=n+-16|0;q=o+-16|0;r=a[q>>0]|0;if(!(r&1)){s=(r&255)>>>1;t=q+1|0}else{s=c[o+-12>>2]|0;t=c[o+-8>>2]|0}if(s>>>0>2147483631){u=8;break}if(s>>>0<11){a[p>>0]=s<<1;v=p+1|0}else{q=s+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];r=cOb(q,16,f,0,3653512,80)|0;c[n+-8>>2]=r;c[p>>2]=q|1;c[n+-12>>2]=s;v=r}YEi(v|0,t|0,s|0)|0;a[v+s>>0]=0;c[n+-4>>2]=c[o+-4>>2];o=(c[l>>2]|0)+-20|0;c[l>>2]=o;if((m|0)==(h|0)){w=o;u=13;break}else n=o}if((u|0)==8)ori(p);else if((u|0)==13){x=w;y=c[b>>2]|0;break}}else{x=c[l>>2]|0;y=h}while(0);c[b>>2]=x;c[l>>2]=y;y=d+8|0;x=c[j>>2]|0;c[j>>2]=c[y>>2];c[y>>2]=x;x=b+8|0;b=d+12|0;y=c[x>>2]|0;c[x>>2]=c[b>>2];c[b>>2]=y;c[d>>2]=c[l>>2];i=e;return}function jUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;if(!h){i=d;return}j=b+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-20|0;c[j>>2]=k;if(!(a[m+-16>>0]&1))n=k;else{k=c[m+-8>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[b>>2]|0}c[g>>2]=6;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[b+8>>2]=0;c[j>>2]=0;c[b>>2]=0;i=d;return}function kUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;d=i;i=i+32|0;e=d;f=b+12|0;zri(f,609520)|0;c[b+24>>2]=63;a[b+28>>0]=1;c[e>>2]=621888;c[e+4>>2]=FQb(2436792)|0;g=e+8|0;c[g>>2]=17;c[g+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,17,0)|0;a[e+20>>0]=0;g=b+4|0;h=c[g>>2]|0;j=b+8|0;if((h|0)==(c[j>>2]|0))BUc(b,e);else{if(!h)k=0;else{c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[h+16>>2]=c[e+16>>2];c[h+20>>2]=c[e+20>>2];k=c[g>>2]|0}c[g>>2]=k+24}c[e>>2]=609552;c[e+4>>2]=FQb(2436792)|0;k=e+8|0;c[k>>2]=62;c[k+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,62,0)|0;a[e+20>>0]=0;k=c[g>>2]|0;if((k|0)==(c[j>>2]|0))BUc(b,e);else{if(!k)l=0;else{c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[k+16>>2]=c[e+16>>2];c[k+20>>2]=c[e+20>>2];l=c[g>>2]|0}c[g>>2]=l+24}c[e>>2]=609592;c[e+4>>2]=FQb(2436792)|0;l=e+8|0;c[l>>2]=64;c[l+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,64,0)|0;a[e+20>>0]=0;l=c[g>>2]|0;if((l|0)==(c[j>>2]|0))BUc(b,e);else{if(!l)m=0;else{c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[l+16>>2]=c[e+16>>2];c[l+20>>2]=c[e+20>>2];m=c[g>>2]|0}c[g>>2]=m+24}c[e>>2]=609632;c[e+4>>2]=FQb(2436792)|0;m=e+8|0;c[m>>2]=65;c[m+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,65,0)|0;a[e+20>>0]=0;m=c[g>>2]|0;if((m|0)==(c[j>>2]|0))BUc(b,e);else{if(!m)n=0;else{c[m+0>>2]=c[e+0>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];c[m+16>>2]=c[e+16>>2];c[m+20>>2]=c[e+20>>2];n=c[g>>2]|0}c[g>>2]=n+24}c[e>>2]=609672;c[e+4>>2]=FQb(2436792)|0;n=e+8|0;c[n>>2]=66;c[n+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,66,0)|0;a[e+20>>0]=0;n=c[g>>2]|0;if((n|0)==(c[j>>2]|0))BUc(b,e);else{if(!n)o=0;else{c[n+0>>2]=c[e+0>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];o=c[g>>2]|0}c[g>>2]=o+24}c[e>>2]=609704;c[e+4>>2]=FQb(2436792)|0;o=e+8|0;c[o>>2]=68;c[o+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,68,0)|0;a[e+20>>0]=0;o=c[g>>2]|0;if((o|0)==(c[j>>2]|0))BUc(b,e);else{if(!o)p=0;else{c[o+0>>2]=c[e+0>>2];c[o+4>>2]=c[e+4>>2];c[o+8>>2]=c[e+8>>2];c[o+12>>2]=c[e+12>>2];c[o+16>>2]=c[e+16>>2];c[o+20>>2]=c[e+20>>2];p=c[g>>2]|0}c[g>>2]=p+24}c[e>>2]=609728;c[e+4>>2]=FQb(2436792)|0;p=e+8|0;c[p>>2]=102;c[p+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,102,0)|0;a[e+20>>0]=0;p=c[g>>2]|0;if((p|0)==(c[j>>2]|0))BUc(b,e);else{if(!p)q=0;else{c[p+0>>2]=c[e+0>>2];c[p+4>>2]=c[e+4>>2];c[p+8>>2]=c[e+8>>2];c[p+12>>2]=c[e+12>>2];c[p+16>>2]=c[e+16>>2];c[p+20>>2]=c[e+20>>2];q=c[g>>2]|0}c[g>>2]=q+24}c[e>>2]=609752;c[e+4>>2]=FQb(2436792)|0;q=e+8|0;c[q>>2]=105;c[q+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,105,0)|0;a[e+20>>0]=0;q=c[g>>2]|0;if((q|0)==(c[j>>2]|0))BUc(b,e);else{if(!q)r=0;else{c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2];r=c[g>>2]|0}c[g>>2]=r+24}c[e>>2]=609776;c[e+4>>2]=FQb(2359424)|0;r=e+8|0;c[r>>2]=10001;c[r+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10001,0)|0;a[e+20>>0]=0;r=c[g>>2]|0;if((r|0)==(c[j>>2]|0))BUc(b,e);else{if(!r)s=0;else{c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r+20>>2]=c[e+20>>2];s=c[g>>2]|0}c[g>>2]=s+24}c[e>>2]=609792;c[e+4>>2]=FQb(2436792)|0;s=e+8|0;c[s>>2]=9e3;c[s+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,9e3,0)|0;a[e+20>>0]=0;s=c[g>>2]|0;if((s|0)==(c[j>>2]|0))BUc(b,e);else{if(!s)t=0;else{c[s+0>>2]=c[e+0>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];c[s+12>>2]=c[e+12>>2];c[s+16>>2]=c[e+16>>2];c[s+20>>2]=c[e+20>>2];t=c[g>>2]|0}c[g>>2]=t+24}c[e>>2]=609824;c[e+4>>2]=FQb(2436792)|0;t=e+8|0;c[t>>2]=9001;c[t+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,9001,0)|0;a[e+20>>0]=0;t=c[g>>2]|0;if((t|0)==(c[j>>2]|0))BUc(b,e);else{if(!t)u=0;else{c[t+0>>2]=c[e+0>>2];c[t+4>>2]=c[e+4>>2];c[t+8>>2]=c[e+8>>2];c[t+12>>2]=c[e+12>>2];c[t+16>>2]=c[e+16>>2];c[t+20>>2]=c[e+20>>2];u=c[g>>2]|0}c[g>>2]=u+24}c[e>>2]=609864;c[e+4>>2]=FQb(2436792)|0;u=e+8|0;c[u>>2]=9002;c[u+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,9002,0)|0;a[e+20>>0]=0;u=c[g>>2]|0;if((u|0)==(c[j>>2]|0))BUc(b,e);else{if(!u)v=0;else{c[u+0>>2]=c[e+0>>2];c[u+4>>2]=c[e+4>>2];c[u+8>>2]=c[e+8>>2];c[u+12>>2]=c[e+12>>2];c[u+16>>2]=c[e+16>>2];c[u+20>>2]=c[e+20>>2];v=c[g>>2]|0}c[g>>2]=v+24}c[e>>2]=609896;c[e+4>>2]=FQb(2436792)|0;v=e+8|0;c[v>>2]=9003;c[v+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,9003,0)|0;a[e+20>>0]=0;v=c[g>>2]|0;if((v|0)==(c[j>>2]|0))BUc(b,e);else{if(!v)w=0;else{c[v+0>>2]=c[e+0>>2];c[v+4>>2]=c[e+4>>2];c[v+8>>2]=c[e+8>>2];c[v+12>>2]=c[e+12>>2];c[v+16>>2]=c[e+16>>2];c[v+20>>2]=c[e+20>>2];w=c[g>>2]|0}c[g>>2]=w+24}c[e>>2]=724424;c[e+4>>2]=FQb(2438376)|0;w=e+8|0;c[w>>2]=10100;c[w+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10100,0)|0;a[e+20>>0]=0;w=c[g>>2]|0;if((w|0)==(c[j>>2]|0))BUc(b,e);else{if(!w)x=0;else{c[w+0>>2]=c[e+0>>2];c[w+4>>2]=c[e+4>>2];c[w+8>>2]=c[e+8>>2];c[w+12>>2]=c[e+12>>2];c[w+16>>2]=c[e+16>>2];c[w+20>>2]=c[e+20>>2];x=c[g>>2]|0}c[g>>2]=x+24}c[e>>2]=609928;c[e+4>>2]=FQb(2436792)|0;x=e+8|0;c[x>>2]=10101;c[x+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10101,0)|0;a[e+20>>0]=1;x=c[g>>2]|0;if((x|0)==(c[j>>2]|0))BUc(b,e);else{if(!x)y=0;else{c[x+0>>2]=c[e+0>>2];c[x+4>>2]=c[e+4>>2];c[x+8>>2]=c[e+8>>2];c[x+12>>2]=c[e+12>>2];c[x+16>>2]=c[e+16>>2];c[x+20>>2]=c[e+20>>2];y=c[g>>2]|0}c[g>>2]=y+24}c[e>>2]=724424;c[e+4>>2]=FQb(2497152)|0;y=e+8|0;c[y>>2]=10102;c[y+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10102,0)|0;a[e+20>>0]=1;y=c[g>>2]|0;if((y|0)==(c[j>>2]|0))BUc(b,e);else{if(!y)z=0;else{c[y+0>>2]=c[e+0>>2];c[y+4>>2]=c[e+4>>2];c[y+8>>2]=c[e+8>>2];c[y+12>>2]=c[e+12>>2];c[y+16>>2]=c[e+16>>2];c[y+20>>2]=c[e+20>>2];z=c[g>>2]|0}c[g>>2]=z+24}c[e>>2]=724424;c[e+4>>2]=FQb(2359424)|0;z=e+8|0;c[z>>2]=10103;c[z+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10103,0)|0;a[e+20>>0]=0;z=c[g>>2]|0;if((z|0)==(c[j>>2]|0))BUc(b,e);else{if(!z)A=0;else{c[z+0>>2]=c[e+0>>2];c[z+4>>2]=c[e+4>>2];c[z+8>>2]=c[e+8>>2];c[z+12>>2]=c[e+12>>2];c[z+16>>2]=c[e+16>>2];c[z+20>>2]=c[e+20>>2];A=c[g>>2]|0}c[g>>2]=A+24}c[e>>2]=609944;c[e+4>>2]=FQb(617744)|0;A=e+8|0;c[A>>2]=10202;c[A+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10202,0)|0;a[e+20>>0]=1;A=c[g>>2]|0;if((A|0)==(c[j>>2]|0))BUc(b,e);else{if(!A)B=0;else{c[A+0>>2]=c[e+0>>2];c[A+4>>2]=c[e+4>>2];c[A+8>>2]=c[e+8>>2];c[A+12>>2]=c[e+12>>2];c[A+16>>2]=c[e+16>>2];c[A+20>>2]=c[e+20>>2];B=c[g>>2]|0}c[g>>2]=B+24}c[e>>2]=609960;c[e+4>>2]=FQb(617744)|0;B=e+8|0;c[B>>2]=10206;c[B+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10206,0)|0;a[e+20>>0]=1;B=c[g>>2]|0;if((B|0)==(c[j>>2]|0))BUc(b,e);else{if(!B)C=0;else{c[B+0>>2]=c[e+0>>2];c[B+4>>2]=c[e+4>>2];c[B+8>>2]=c[e+8>>2];c[B+12>>2]=c[e+12>>2];c[B+16>>2]=c[e+16>>2];c[B+20>>2]=c[e+20>>2];C=c[g>>2]|0}c[g>>2]=C+24}c[e>>2]=609984;c[e+4>>2]=FQb(617744)|0;C=e+8|0;c[C>>2]=10207;c[C+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10207,0)|0;a[e+20>>0]=1;C=c[g>>2]|0;if((C|0)==(c[j>>2]|0))BUc(b,e);else{if(!C)D=0;else{c[C+0>>2]=c[e+0>>2];c[C+4>>2]=c[e+4>>2];c[C+8>>2]=c[e+8>>2];c[C+12>>2]=c[e+12>>2];c[C+16>>2]=c[e+16>>2];c[C+20>>2]=c[e+20>>2];D=c[g>>2]|0}c[g>>2]=D+24}c[e>>2]=61e4;c[e+4>>2]=FQb(617744)|0;D=e+8|0;c[D>>2]=10208;c[D+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10208,0)|0;a[e+20>>0]=1;D=c[g>>2]|0;if((D|0)==(c[j>>2]|0))BUc(b,e);else{if(!D)E=0;else{c[D+0>>2]=c[e+0>>2];c[D+4>>2]=c[e+4>>2];c[D+8>>2]=c[e+8>>2];c[D+12>>2]=c[e+12>>2];c[D+16>>2]=c[e+16>>2];c[D+20>>2]=c[e+20>>2];E=c[g>>2]|0}c[g>>2]=E+24}c[e>>2]=610016;c[e+4>>2]=FQb(617744)|0;E=e+8|0;c[E>>2]=10209;c[E+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10209,0)|0;a[e+20>>0]=1;E=c[g>>2]|0;if((E|0)==(c[j>>2]|0))BUc(b,e);else{if(!E)F=0;else{c[E+0>>2]=c[e+0>>2];c[E+4>>2]=c[e+4>>2];c[E+8>>2]=c[e+8>>2];c[E+12>>2]=c[e+12>>2];c[E+16>>2]=c[e+16>>2];c[E+20>>2]=c[e+20>>2];F=c[g>>2]|0}c[g>>2]=F+24}c[e>>2]=610032;c[e+4>>2]=FQb(617744)|0;F=e+8|0;c[F>>2]=10210;c[F+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10210,0)|0;a[e+20>>0]=1;F=c[g>>2]|0;if((F|0)==(c[j>>2]|0))BUc(b,e);else{if(!F)G=0;else{c[F+0>>2]=c[e+0>>2];c[F+4>>2]=c[e+4>>2];c[F+8>>2]=c[e+8>>2];c[F+12>>2]=c[e+12>>2];c[F+16>>2]=c[e+16>>2];c[F+20>>2]=c[e+20>>2];G=c[g>>2]|0}c[g>>2]=G+24}c[e>>2]=610048;c[e+4>>2]=FQb(617744)|0;G=e+8|0;c[G>>2]=10211;c[G+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10211,0)|0;a[e+20>>0]=0;G=c[g>>2]|0;if((G|0)==(c[j>>2]|0))BUc(b,e);else{if(!G)H=0;else{c[G+0>>2]=c[e+0>>2];c[G+4>>2]=c[e+4>>2];c[G+8>>2]=c[e+8>>2];c[G+12>>2]=c[e+12>>2];c[G+16>>2]=c[e+16>>2];c[G+20>>2]=c[e+20>>2];H=c[g>>2]|0}c[g>>2]=H+24}c[e>>2]=610064;c[e+4>>2]=FQb(617744)|0;H=e+8|0;c[H>>2]=10212;c[H+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10212,0)|0;a[e+20>>0]=0;H=c[g>>2]|0;if((H|0)==(c[j>>2]|0))BUc(b,e);else{if(!H)I=0;else{c[H+0>>2]=c[e+0>>2];c[H+4>>2]=c[e+4>>2];c[H+8>>2]=c[e+8>>2];c[H+12>>2]=c[e+12>>2];c[H+16>>2]=c[e+16>>2];c[H+20>>2]=c[e+20>>2];I=c[g>>2]|0}c[g>>2]=I+24}c[e>>2]=610080;c[e+4>>2]=FQb(617744)|0;I=e+8|0;c[I>>2]=10213;c[I+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10213,0)|0;a[e+20>>0]=0;I=c[g>>2]|0;if((I|0)==(c[j>>2]|0))BUc(b,e);else{if(!I)J=0;else{c[I+0>>2]=c[e+0>>2];c[I+4>>2]=c[e+4>>2];c[I+8>>2]=c[e+8>>2];c[I+12>>2]=c[e+12>>2];c[I+16>>2]=c[e+16>>2];c[I+20>>2]=c[e+20>>2];J=c[g>>2]|0}c[g>>2]=J+24}c[e>>2]=610096;c[e+4>>2]=FQb(617744)|0;J=e+8|0;c[J>>2]=10200;c[J+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10200,0)|0;a[e+20>>0]=0;J=c[g>>2]|0;if((J|0)==(c[j>>2]|0))BUc(b,e);else{if(!J)K=0;else{c[J+0>>2]=c[e+0>>2];c[J+4>>2]=c[e+4>>2];c[J+8>>2]=c[e+8>>2];c[J+12>>2]=c[e+12>>2];c[J+16>>2]=c[e+16>>2];c[J+20>>2]=c[e+20>>2];K=c[g>>2]|0}c[g>>2]=K+24}c[e>>2]=610112;c[e+4>>2]=FQb(617744)|0;K=e+8|0;c[K>>2]=10203;c[K+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10203,0)|0;a[e+20>>0]=0;K=c[g>>2]|0;if((K|0)==(c[j>>2]|0))BUc(b,e);else{if(!K)L=0;else{c[K+0>>2]=c[e+0>>2];c[K+4>>2]=c[e+4>>2];c[K+8>>2]=c[e+8>>2];c[K+12>>2]=c[e+12>>2];c[K+16>>2]=c[e+16>>2];c[K+20>>2]=c[e+20>>2];L=c[g>>2]|0}c[g>>2]=L+24}c[e>>2]=610128;c[e+4>>2]=FQb(617744)|0;L=e+8|0;c[L>>2]=10204;c[L+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10204,0)|0;a[e+20>>0]=0;L=c[g>>2]|0;if((L|0)==(c[j>>2]|0))BUc(b,e);else{if(!L)M=0;else{c[L+0>>2]=c[e+0>>2];c[L+4>>2]=c[e+4>>2];c[L+8>>2]=c[e+8>>2];c[L+12>>2]=c[e+12>>2];c[L+16>>2]=c[e+16>>2];c[L+20>>2]=c[e+20>>2];M=c[g>>2]|0}c[g>>2]=M+24}c[e>>2]=610144;c[e+4>>2]=FQb(617744)|0;M=e+8|0;c[M>>2]=10205;c[M+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10205,0)|0;a[e+20>>0]=0;M=c[g>>2]|0;if((M|0)==(c[j>>2]|0))BUc(b,e);else{if(!M)N=0;else{c[M+0>>2]=c[e+0>>2];c[M+4>>2]=c[e+4>>2];c[M+8>>2]=c[e+8>>2];c[M+12>>2]=c[e+12>>2];c[M+16>>2]=c[e+16>>2];c[M+20>>2]=c[e+20>>2];N=c[g>>2]|0}c[g>>2]=N+24}c[e>>2]=610160;c[e+4>>2]=FQb(2359424)|0;N=e+8|0;c[N>>2]=10400;c[N+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10400,0)|0;a[e+20>>0]=0;N=c[g>>2]|0;if((N|0)==(c[j>>2]|0))BUc(b,e);else{if(!N)O=0;else{c[N+0>>2]=c[e+0>>2];c[N+4>>2]=c[e+4>>2];c[N+8>>2]=c[e+8>>2];c[N+12>>2]=c[e+12>>2];c[N+16>>2]=c[e+16>>2];c[N+20>>2]=c[e+20>>2];O=c[g>>2]|0}c[g>>2]=O+24}c[e>>2]=610192;c[e+4>>2]=FQb(2359424)|0;O=e+8|0;c[O>>2]=10401;c[O+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10401,0)|0;a[e+20>>0]=0;O=c[g>>2]|0;if((O|0)==(c[j>>2]|0))BUc(b,e);else{if(!O)P=0;else{c[O+0>>2]=c[e+0>>2];c[O+4>>2]=c[e+4>>2];c[O+8>>2]=c[e+8>>2];c[O+12>>2]=c[e+12>>2];c[O+16>>2]=c[e+16>>2];c[O+20>>2]=c[e+20>>2];P=c[g>>2]|0}c[g>>2]=P+24}c[e>>2]=610216;c[e+4>>2]=FQb(2359424)|0;P=e+8|0;c[P>>2]=10402;c[P+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10402,0)|0;a[e+20>>0]=0;P=c[g>>2]|0;if((P|0)==(c[j>>2]|0))BUc(b,e);else{if(!P)Q=0;else{c[P+0>>2]=c[e+0>>2];c[P+4>>2]=c[e+4>>2];c[P+8>>2]=c[e+8>>2];c[P+12>>2]=c[e+12>>2];c[P+16>>2]=c[e+16>>2];c[P+20>>2]=c[e+20>>2];Q=c[g>>2]|0}c[g>>2]=Q+24}c[e>>2]=610240;c[e+4>>2]=FQb(2359424)|0;Q=e+8|0;c[Q>>2]=10407;c[Q+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10407,0)|0;a[e+20>>0]=0;Q=c[g>>2]|0;if((Q|0)==(c[j>>2]|0))BUc(b,e);else{if(!Q)R=0;else{c[Q+0>>2]=c[e+0>>2];c[Q+4>>2]=c[e+4>>2];c[Q+8>>2]=c[e+8>>2];c[Q+12>>2]=c[e+12>>2];c[Q+16>>2]=c[e+16>>2];c[Q+20>>2]=c[e+20>>2];R=c[g>>2]|0}c[g>>2]=R+24}c[e>>2]=610272;c[e+4>>2]=FQb(2359424)|0;R=e+8|0;c[R>>2]=10408;c[R+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10408,0)|0;a[e+20>>0]=0;R=c[g>>2]|0;if((R|0)==(c[j>>2]|0))BUc(b,e);else{if(!R)S=0;else{c[R+0>>2]=c[e+0>>2];c[R+4>>2]=c[e+4>>2];c[R+8>>2]=c[e+8>>2];c[R+12>>2]=c[e+12>>2];c[R+16>>2]=c[e+16>>2];c[R+20>>2]=c[e+20>>2];S=c[g>>2]|0}c[g>>2]=S+24}c[e>>2]=610296;c[e+4>>2]=FQb(2359424)|0;S=e+8|0;c[S>>2]=10409;c[S+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10409,0)|0;a[e+20>>0]=0;S=c[g>>2]|0;if((S|0)==(c[j>>2]|0))BUc(b,e);else{if(!S)T=0;else{c[S+0>>2]=c[e+0>>2];c[S+4>>2]=c[e+4>>2];c[S+8>>2]=c[e+8>>2];c[S+12>>2]=c[e+12>>2];c[S+16>>2]=c[e+16>>2];c[S+20>>2]=c[e+20>>2];T=c[g>>2]|0}c[g>>2]=T+24}c[e>>2]=610320;c[e+4>>2]=FQb(2359424)|0;T=e+8|0;c[T>>2]=10410;c[T+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10410,0)|0;a[e+20>>0]=0;T=c[g>>2]|0;if((T|0)==(c[j>>2]|0))BUc(b,e);else{if(!T)U=0;else{c[T+0>>2]=c[e+0>>2];c[T+4>>2]=c[e+4>>2];c[T+8>>2]=c[e+8>>2];c[T+12>>2]=c[e+12>>2];c[T+16>>2]=c[e+16>>2];c[T+20>>2]=c[e+20>>2];U=c[g>>2]|0}c[g>>2]=U+24}c[e>>2]=610344;c[e+4>>2]=FQb(2359424)|0;U=e+8|0;c[U>>2]=10411;c[U+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10411,0)|0;a[e+20>>0]=0;U=c[g>>2]|0;if((U|0)==(c[j>>2]|0))BUc(b,e);else{if(!U)V=0;else{c[U+0>>2]=c[e+0>>2];c[U+4>>2]=c[e+4>>2];c[U+8>>2]=c[e+8>>2];c[U+12>>2]=c[e+12>>2];c[U+16>>2]=c[e+16>>2];c[U+20>>2]=c[e+20>>2];V=c[g>>2]|0}c[g>>2]=V+24}c[e>>2]=610360;c[e+4>>2]=FQb(2359424)|0;V=e+8|0;c[V>>2]=10413;c[V+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10413,0)|0;a[e+20>>0]=0;V=c[g>>2]|0;if((V|0)==(c[j>>2]|0))BUc(b,e);else{if(!V)W=0;else{c[V+0>>2]=c[e+0>>2];c[V+4>>2]=c[e+4>>2];c[V+8>>2]=c[e+8>>2];c[V+12>>2]=c[e+12>>2];c[V+16>>2]=c[e+16>>2];c[V+20>>2]=c[e+20>>2];W=c[g>>2]|0}c[g>>2]=W+24}c[e>>2]=610392;c[e+4>>2]=FQb(2359424)|0;W=e+8|0;c[W>>2]=10414;c[W+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10414,0)|0;a[e+20>>0]=0;W=c[g>>2]|0;if((W|0)==(c[j>>2]|0))BUc(b,e);else{if(!W)X=0;else{c[W+0>>2]=c[e+0>>2];c[W+4>>2]=c[e+4>>2];c[W+8>>2]=c[e+8>>2];c[W+12>>2]=c[e+12>>2];c[W+16>>2]=c[e+16>>2];c[W+20>>2]=c[e+20>>2];X=c[g>>2]|0}c[g>>2]=X+24}c[e>>2]=610424;c[e+4>>2]=FQb(2359424)|0;X=e+8|0;c[X>>2]=10403;c[X+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10403,0)|0;a[e+20>>0]=0;X=c[g>>2]|0;if((X|0)==(c[j>>2]|0))BUc(b,e);else{if(!X)Y=0;else{c[X+0>>2]=c[e+0>>2];c[X+4>>2]=c[e+4>>2];c[X+8>>2]=c[e+8>>2];c[X+12>>2]=c[e+12>>2];c[X+16>>2]=c[e+16>>2];c[X+20>>2]=c[e+20>>2];Y=c[g>>2]|0}c[g>>2]=Y+24}c[e>>2]=610440;c[e+4>>2]=FQb(2359424)|0;Y=e+8|0;c[Y>>2]=10404;c[Y+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10404,0)|0;a[e+20>>0]=0;Y=c[g>>2]|0;if((Y|0)==(c[j>>2]|0))BUc(b,e);else{if(!Y)Z=0;else{c[Y+0>>2]=c[e+0>>2];c[Y+4>>2]=c[e+4>>2];c[Y+8>>2]=c[e+8>>2];c[Y+12>>2]=c[e+12>>2];c[Y+16>>2]=c[e+16>>2];c[Y+20>>2]=c[e+20>>2];Z=c[g>>2]|0}c[g>>2]=Z+24}c[e>>2]=610464;c[e+4>>2]=FQb(2359424)|0;Z=e+8|0;c[Z>>2]=10406;c[Z+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10406,0)|0;a[e+20>>0]=0;Z=c[g>>2]|0;if((Z|0)==(c[j>>2]|0))BUc(b,e);else{if(!Z)_=0;else{c[Z+0>>2]=c[e+0>>2];c[Z+4>>2]=c[e+4>>2];c[Z+8>>2]=c[e+8>>2];c[Z+12>>2]=c[e+12>>2];c[Z+16>>2]=c[e+16>>2];c[Z+20>>2]=c[e+20>>2];_=c[g>>2]|0}c[g>>2]=_+24}c[e>>2]=610488;c[e+4>>2]=FQb(2436792)|0;_=e+8|0;c[_>>2]=10753;c[_+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10753,0)|0;a[e+20>>0]=1;_=c[g>>2]|0;if((_|0)==(c[j>>2]|0))BUc(b,e);else{if(!_)$=0;else{c[_+0>>2]=c[e+0>>2];c[_+4>>2]=c[e+4>>2];c[_+8>>2]=c[e+8>>2];c[_+12>>2]=c[e+12>>2];c[_+16>>2]=c[e+16>>2];c[_+20>>2]=c[e+20>>2];$=c[g>>2]|0}c[g>>2]=$+24}c[e>>2]=610512;c[e+4>>2]=FQb(2438376)|0;$=e+8|0;c[$>>2]=10754;c[$+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,10754,0)|0;a[e+20>>0]=1;$=c[g>>2]|0;if(($|0)==(c[j>>2]|0))BUc(b,e);else{if(!$)aa=0;else{c[$+0>>2]=c[e+0>>2];c[$+4>>2]=c[e+4>>2];c[$+8>>2]=c[e+8>>2];c[$+12>>2]=c[e+12>>2];c[$+16>>2]=c[e+16>>2];c[$+20>>2]=c[e+20>>2];aa=c[g>>2]|0}c[g>>2]=aa+24}c[e>>2]=610536;c[e+4>>2]=FQb(2454944)|0;aa=e+8|0;c[aa>>2]=11e3;c[aa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11e3,0)|0;a[e+20>>0]=0;aa=c[g>>2]|0;if((aa|0)==(c[j>>2]|0))BUc(b,e);else{if(!aa)ba=0;else{c[aa+0>>2]=c[e+0>>2];c[aa+4>>2]=c[e+4>>2];c[aa+8>>2]=c[e+8>>2];c[aa+12>>2]=c[e+12>>2];c[aa+16>>2]=c[e+16>>2];c[aa+20>>2]=c[e+20>>2];ba=c[g>>2]|0}c[g>>2]=ba+24}c[e>>2]=610568;c[e+4>>2]=FQb(2359424)|0;ba=e+8|0;c[ba>>2]=11001;c[ba+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11001,0)|0;a[e+20>>0]=0;ba=c[g>>2]|0;if((ba|0)==(c[j>>2]|0))BUc(b,e);else{if(!ba)ca=0;else{c[ba+0>>2]=c[e+0>>2];c[ba+4>>2]=c[e+4>>2];c[ba+8>>2]=c[e+8>>2];c[ba+12>>2]=c[e+12>>2];c[ba+16>>2]=c[e+16>>2];c[ba+20>>2]=c[e+20>>2];ca=c[g>>2]|0}c[g>>2]=ca+24}c[e>>2]=610592;c[e+4>>2]=FQb(2359424)|0;ca=e+8|0;c[ca>>2]=11002;c[ca+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11002,0)|0;a[e+20>>0]=0;ca=c[g>>2]|0;if((ca|0)==(c[j>>2]|0))BUc(b,e);else{if(!ca)da=0;else{c[ca+0>>2]=c[e+0>>2];c[ca+4>>2]=c[e+4>>2];c[ca+8>>2]=c[e+8>>2];c[ca+12>>2]=c[e+12>>2];c[ca+16>>2]=c[e+16>>2];c[ca+20>>2]=c[e+20>>2];da=c[g>>2]|0}c[g>>2]=da+24}c[e>>2]=610624;c[e+4>>2]=FQb(2359424)|0;da=e+8|0;c[da>>2]=11003;c[da+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11003,0)|0;a[e+20>>0]=0;da=c[g>>2]|0;if((da|0)==(c[j>>2]|0))BUc(b,e);else{if(!da)ea=0;else{c[da+0>>2]=c[e+0>>2];c[da+4>>2]=c[e+4>>2];c[da+8>>2]=c[e+8>>2];c[da+12>>2]=c[e+12>>2];c[da+16>>2]=c[e+16>>2];c[da+20>>2]=c[e+20>>2];ea=c[g>>2]|0}c[g>>2]=ea+24}c[e>>2]=610656;c[e+4>>2]=FQb(2359424)|0;ea=e+8|0;c[ea>>2]=11004;c[ea+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11004,0)|0;a[e+20>>0]=0;ea=c[g>>2]|0;if((ea|0)==(c[j>>2]|0))BUc(b,e);else{if(!ea)fa=0;else{c[ea+0>>2]=c[e+0>>2];c[ea+4>>2]=c[e+4>>2];c[ea+8>>2]=c[e+8>>2];c[ea+12>>2]=c[e+12>>2];c[ea+16>>2]=c[e+16>>2];c[ea+20>>2]=c[e+20>>2];fa=c[g>>2]|0}c[g>>2]=fa+24}c[e>>2]=610688;c[e+4>>2]=FQb(2359424)|0;fa=e+8|0;c[fa>>2]=11005;c[fa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11005,0)|0;a[e+20>>0]=0;fa=c[g>>2]|0;if((fa|0)==(c[j>>2]|0))BUc(b,e);else{if(!fa)ga=0;else{c[fa+0>>2]=c[e+0>>2];c[fa+4>>2]=c[e+4>>2];c[fa+8>>2]=c[e+8>>2];c[fa+12>>2]=c[e+12>>2];c[fa+16>>2]=c[e+16>>2];c[fa+20>>2]=c[e+20>>2];ga=c[g>>2]|0}c[g>>2]=ga+24}c[e>>2]=610712;c[e+4>>2]=FQb(2359424)|0;ga=e+8|0;c[ga>>2]=11006;c[ga+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11006,0)|0;a[e+20>>0]=0;ga=c[g>>2]|0;if((ga|0)==(c[j>>2]|0))BUc(b,e);else{if(!ga)ha=0;else{c[ga+0>>2]=c[e+0>>2];c[ga+4>>2]=c[e+4>>2];c[ga+8>>2]=c[e+8>>2];c[ga+12>>2]=c[e+12>>2];c[ga+16>>2]=c[e+16>>2];c[ga+20>>2]=c[e+20>>2];ha=c[g>>2]|0}c[g>>2]=ha+24}c[e>>2]=610736;c[e+4>>2]=FQb(2359424)|0;ha=e+8|0;c[ha>>2]=11007;c[ha+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11007,0)|0;a[e+20>>0]=0;ha=c[g>>2]|0;if((ha|0)==(c[j>>2]|0))BUc(b,e);else{if(!ha)ia=0;else{c[ha+0>>2]=c[e+0>>2];c[ha+4>>2]=c[e+4>>2];c[ha+8>>2]=c[e+8>>2];c[ha+12>>2]=c[e+12>>2];c[ha+16>>2]=c[e+16>>2];c[ha+20>>2]=c[e+20>>2];ia=c[g>>2]|0}c[g>>2]=ia+24}c[e>>2]=610776;c[e+4>>2]=FQb(2359424)|0;ia=e+8|0;c[ia>>2]=11008;c[ia+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11008,0)|0;a[e+20>>0]=0;ia=c[g>>2]|0;if((ia|0)==(c[j>>2]|0))BUc(b,e);else{if(!ia)ja=0;else{c[ia+0>>2]=c[e+0>>2];c[ia+4>>2]=c[e+4>>2];c[ia+8>>2]=c[e+8>>2];c[ia+12>>2]=c[e+12>>2];c[ia+16>>2]=c[e+16>>2];c[ia+20>>2]=c[e+20>>2];ja=c[g>>2]|0}c[g>>2]=ja+24}c[e>>2]=610816;c[e+4>>2]=FQb(2359424)|0;ja=e+8|0;c[ja>>2]=11009;c[ja+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11009,0)|0;a[e+20>>0]=0;ja=c[g>>2]|0;if((ja|0)==(c[j>>2]|0))BUc(b,e);else{if(!ja)ka=0;else{c[ja+0>>2]=c[e+0>>2];c[ja+4>>2]=c[e+4>>2];c[ja+8>>2]=c[e+8>>2];c[ja+12>>2]=c[e+12>>2];c[ja+16>>2]=c[e+16>>2];c[ja+20>>2]=c[e+20>>2];ka=c[g>>2]|0}c[g>>2]=ka+24}c[e>>2]=610848;c[e+4>>2]=FQb(2359424)|0;ka=e+8|0;c[ka>>2]=11010;c[ka+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11010,0)|0;a[e+20>>0]=0;ka=c[g>>2]|0;if((ka|0)==(c[j>>2]|0))BUc(b,e);else{if(!ka)la=0;else{c[ka+0>>2]=c[e+0>>2];c[ka+4>>2]=c[e+4>>2];c[ka+8>>2]=c[e+8>>2];c[ka+12>>2]=c[e+12>>2];c[ka+16>>2]=c[e+16>>2];c[ka+20>>2]=c[e+20>>2];la=c[g>>2]|0}c[g>>2]=la+24}c[e>>2]=610888;c[e+4>>2]=FQb(2359424)|0;la=e+8|0;c[la>>2]=11011;c[la+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11011,0)|0;a[e+20>>0]=0;la=c[g>>2]|0;if((la|0)==(c[j>>2]|0))BUc(b,e);else{if(!la)ma=0;else{c[la+0>>2]=c[e+0>>2];c[la+4>>2]=c[e+4>>2];c[la+8>>2]=c[e+8>>2];c[la+12>>2]=c[e+12>>2];c[la+16>>2]=c[e+16>>2];c[la+20>>2]=c[e+20>>2];ma=c[g>>2]|0}c[g>>2]=ma+24}c[e>>2]=610920;c[e+4>>2]=FQb(2359424)|0;ma=e+8|0;c[ma>>2]=11012;c[ma+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11012,0)|0;a[e+20>>0]=0;ma=c[g>>2]|0;if((ma|0)==(c[j>>2]|0))BUc(b,e);else{if(!ma)na=0;else{c[ma+0>>2]=c[e+0>>2];c[ma+4>>2]=c[e+4>>2];c[ma+8>>2]=c[e+8>>2];c[ma+12>>2]=c[e+12>>2];c[ma+16>>2]=c[e+16>>2];c[ma+20>>2]=c[e+20>>2];na=c[g>>2]|0}c[g>>2]=na+24}c[e>>2]=610952;c[e+4>>2]=FQb(2359424)|0;na=e+8|0;c[na>>2]=11013;c[na+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11013,0)|0;a[e+20>>0]=0;na=c[g>>2]|0;if((na|0)==(c[j>>2]|0))BUc(b,e);else{if(!na)oa=0;else{c[na+0>>2]=c[e+0>>2];c[na+4>>2]=c[e+4>>2];c[na+8>>2]=c[e+8>>2];c[na+12>>2]=c[e+12>>2];c[na+16>>2]=c[e+16>>2];c[na+20>>2]=c[e+20>>2];oa=c[g>>2]|0}c[g>>2]=oa+24}c[e>>2]=610984;c[e+4>>2]=FQb(2359424)|0;oa=e+8|0;c[oa>>2]=11014;c[oa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11014,0)|0;a[e+20>>0]=0;oa=c[g>>2]|0;if((oa|0)==(c[j>>2]|0))BUc(b,e);else{if(!oa)pa=0;else{c[oa+0>>2]=c[e+0>>2];c[oa+4>>2]=c[e+4>>2];c[oa+8>>2]=c[e+8>>2];c[oa+12>>2]=c[e+12>>2];c[oa+16>>2]=c[e+16>>2];c[oa+20>>2]=c[e+20>>2];pa=c[g>>2]|0}c[g>>2]=pa+24}c[e>>2]=611016;c[e+4>>2]=FQb(2359424)|0;pa=e+8|0;c[pa>>2]=11015;c[pa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11015,0)|0;a[e+20>>0]=0;pa=c[g>>2]|0;if((pa|0)==(c[j>>2]|0))BUc(b,e);else{if(!pa)qa=0;else{c[pa+0>>2]=c[e+0>>2];c[pa+4>>2]=c[e+4>>2];c[pa+8>>2]=c[e+8>>2];c[pa+12>>2]=c[e+12>>2];c[pa+16>>2]=c[e+16>>2];c[pa+20>>2]=c[e+20>>2];qa=c[g>>2]|0}c[g>>2]=qa+24}c[e>>2]=611048;c[e+4>>2]=FQb(2359424)|0;qa=e+8|0;c[qa>>2]=11016;c[qa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11016,0)|0;a[e+20>>0]=0;qa=c[g>>2]|0;if((qa|0)==(c[j>>2]|0))BUc(b,e);else{if(!qa)ra=0;else{c[qa+0>>2]=c[e+0>>2];c[qa+4>>2]=c[e+4>>2];c[qa+8>>2]=c[e+8>>2];c[qa+12>>2]=c[e+12>>2];c[qa+16>>2]=c[e+16>>2];c[qa+20>>2]=c[e+20>>2];ra=c[g>>2]|0}c[g>>2]=ra+24}c[e>>2]=611072;c[e+4>>2]=FQb(2359424)|0;ra=e+8|0;c[ra>>2]=11017;c[ra+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11017,0)|0;a[e+20>>0]=0;ra=c[g>>2]|0;if((ra|0)==(c[j>>2]|0))BUc(b,e);else{if(!ra)sa=0;else{c[ra+0>>2]=c[e+0>>2];c[ra+4>>2]=c[e+4>>2];c[ra+8>>2]=c[e+8>>2];c[ra+12>>2]=c[e+12>>2];c[ra+16>>2]=c[e+16>>2];c[ra+20>>2]=c[e+20>>2];sa=c[g>>2]|0}c[g>>2]=sa+24}c[e>>2]=611104;c[e+4>>2]=FQb(2359424)|0;sa=e+8|0;c[sa>>2]=11018;c[sa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11018,0)|0;a[e+20>>0]=0;sa=c[g>>2]|0;if((sa|0)==(c[j>>2]|0))BUc(b,e);else{if(!sa)ta=0;else{c[sa+0>>2]=c[e+0>>2];c[sa+4>>2]=c[e+4>>2];c[sa+8>>2]=c[e+8>>2];c[sa+12>>2]=c[e+12>>2];c[sa+16>>2]=c[e+16>>2];c[sa+20>>2]=c[e+20>>2];ta=c[g>>2]|0}c[g>>2]=ta+24}c[e>>2]=611128;c[e+4>>2]=FQb(2359424)|0;ta=e+8|0;c[ta>>2]=11019;c[ta+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11019,0)|0;a[e+20>>0]=0;ta=c[g>>2]|0;if((ta|0)==(c[j>>2]|0))BUc(b,e);else{if(!ta)ua=0;else{c[ta+0>>2]=c[e+0>>2];c[ta+4>>2]=c[e+4>>2];c[ta+8>>2]=c[e+8>>2];c[ta+12>>2]=c[e+12>>2];c[ta+16>>2]=c[e+16>>2];c[ta+20>>2]=c[e+20>>2];ua=c[g>>2]|0}c[g>>2]=ua+24}c[e>>2]=611168;c[e+4>>2]=FQb(2359424)|0;ua=e+8|0;c[ua>>2]=11020;c[ua+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11020,0)|0;a[e+20>>0]=0;ua=c[g>>2]|0;if((ua|0)==(c[j>>2]|0))BUc(b,e);else{if(!ua)va=0;else{c[ua+0>>2]=c[e+0>>2];c[ua+4>>2]=c[e+4>>2];c[ua+8>>2]=c[e+8>>2];c[ua+12>>2]=c[e+12>>2];c[ua+16>>2]=c[e+16>>2];c[ua+20>>2]=c[e+20>>2];va=c[g>>2]|0}c[g>>2]=va+24}c[e>>2]=611200;c[e+4>>2]=FQb(2359424)|0;va=e+8|0;c[va>>2]=11021;c[va+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11021,0)|0;a[e+20>>0]=0;va=c[g>>2]|0;if((va|0)==(c[j>>2]|0))BUc(b,e);else{if(!va)wa=0;else{c[va+0>>2]=c[e+0>>2];c[va+4>>2]=c[e+4>>2];c[va+8>>2]=c[e+8>>2];c[va+12>>2]=c[e+12>>2];c[va+16>>2]=c[e+16>>2];c[va+20>>2]=c[e+20>>2];wa=c[g>>2]|0}c[g>>2]=wa+24}c[e>>2]=611232;c[e+4>>2]=FQb(2359424)|0;wa=e+8|0;c[wa>>2]=11022;c[wa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11022,0)|0;a[e+20>>0]=0;wa=c[g>>2]|0;if((wa|0)==(c[j>>2]|0))BUc(b,e);else{if(!wa)xa=0;else{c[wa+0>>2]=c[e+0>>2];c[wa+4>>2]=c[e+4>>2];c[wa+8>>2]=c[e+8>>2];c[wa+12>>2]=c[e+12>>2];c[wa+16>>2]=c[e+16>>2];c[wa+20>>2]=c[e+20>>2];xa=c[g>>2]|0}c[g>>2]=xa+24}c[e>>2]=611256;c[e+4>>2]=FQb(2359424)|0;xa=e+8|0;c[xa>>2]=11023;c[xa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11023,0)|0;a[e+20>>0]=0;xa=c[g>>2]|0;if((xa|0)==(c[j>>2]|0))BUc(b,e);else{if(!xa)ya=0;else{c[xa+0>>2]=c[e+0>>2];c[xa+4>>2]=c[e+4>>2];c[xa+8>>2]=c[e+8>>2];c[xa+12>>2]=c[e+12>>2];c[xa+16>>2]=c[e+16>>2];c[xa+20>>2]=c[e+20>>2];ya=c[g>>2]|0}c[g>>2]=ya+24}c[e>>2]=611280;c[e+4>>2]=FQb(2359424)|0;ya=e+8|0;c[ya>>2]=11024;c[ya+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11024,0)|0;a[e+20>>0]=0;ya=c[g>>2]|0;if((ya|0)==(c[j>>2]|0))BUc(b,e);else{if(!ya)za=0;else{c[ya+0>>2]=c[e+0>>2];c[ya+4>>2]=c[e+4>>2];c[ya+8>>2]=c[e+8>>2];c[ya+12>>2]=c[e+12>>2];c[ya+16>>2]=c[e+16>>2];c[ya+20>>2]=c[e+20>>2];za=c[g>>2]|0}c[g>>2]=za+24}c[e>>2]=611304;c[e+4>>2]=FQb(2359424)|0;za=e+8|0;c[za>>2]=11025;c[za+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11025,0)|0;a[e+20>>0]=0;za=c[g>>2]|0;if((za|0)==(c[j>>2]|0))BUc(b,e);else{if(!za)Aa=0;else{c[za+0>>2]=c[e+0>>2];c[za+4>>2]=c[e+4>>2];c[za+8>>2]=c[e+8>>2];c[za+12>>2]=c[e+12>>2];c[za+16>>2]=c[e+16>>2];c[za+20>>2]=c[e+20>>2];Aa=c[g>>2]|0}c[g>>2]=Aa+24}c[e>>2]=611336;c[e+4>>2]=FQb(2359424)|0;Aa=e+8|0;c[Aa>>2]=11026;c[Aa+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11026,0)|0;a[e+20>>0]=0;Aa=c[g>>2]|0;if((Aa|0)==(c[j>>2]|0))BUc(b,e);else{if(!Aa)Ba=0;else{c[Aa+0>>2]=c[e+0>>2];c[Aa+4>>2]=c[e+4>>2];c[Aa+8>>2]=c[e+8>>2];c[Aa+12>>2]=c[e+12>>2];c[Aa+16>>2]=c[e+16>>2];c[Aa+20>>2]=c[e+20>>2];Ba=c[g>>2]|0}c[g>>2]=Ba+24}c[e>>2]=611368;c[e+4>>2]=FQb(616048)|0;Ba=e+8|0;c[Ba>>2]=11998;c[Ba+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11998,0)|0;a[e+20>>0]=0;Ba=c[g>>2]|0;if((Ba|0)==(c[j>>2]|0))BUc(b,e);else{if(!Ba)Ca=0;else{c[Ba+0>>2]=c[e+0>>2];c[Ba+4>>2]=c[e+4>>2];c[Ba+8>>2]=c[e+8>>2];c[Ba+12>>2]=c[e+12>>2];c[Ba+16>>2]=c[e+16>>2];c[Ba+20>>2]=c[e+20>>2];Ca=c[g>>2]|0}c[g>>2]=Ca+24}c[e>>2]=2528240;c[e+4>>2]=FQb(616048)|0;Ca=e+8|0;c[Ca>>2]=11999;c[Ca+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,11999,0)|0;a[e+20>>0]=0;Ca=c[g>>2]|0;if((Ca|0)==(c[j>>2]|0))BUc(b,e);else{if(!Ca)Da=0;else{c[Ca+0>>2]=c[e+0>>2];c[Ca+4>>2]=c[e+4>>2];c[Ca+8>>2]=c[e+8>>2];c[Ca+12>>2]=c[e+12>>2];c[Ca+16>>2]=c[e+16>>2];c[Ca+20>>2]=c[e+20>>2];Da=c[g>>2]|0}c[g>>2]=Da+24}c[e>>2]=2386184;c[e+4>>2]=FQb(616048)|0;Da=e+8|0;c[Da>>2]=12001;c[Da+4>>2]=0;c[e+16>>2]=Ked(kfd()|0,f,12001,0)|0;a[e+20>>0]=0;f=c[g>>2]|0;if((f|0)==(c[j>>2]|0)){BUc(b,e);Ea=c[g>>2]|0;Fa=c[b>>2]|0;CUc(Fa,Ea,e);i=d;return}if(!f)Ga=0;else{c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];Ga=c[g>>2]|0}f=Ga+24|0;c[g>>2]=f;Ea=f;Fa=c[b>>2]|0;CUc(Fa,Ea,e);i=d;return}function lUc(){var a=0;a=i;kUc(c[152884]|0);i=a;return}function mUc(){return c[152884]|0}function nUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+32|0;h=f+24|0;j=f+12|0;k=f;if(((((((a[b+28>>0]|0)==0?(Ori(e,609752)|0)!=0:0)?(Ori(e,609864)|0)!=0:0)?(Ori(e,609776)|0)!=0:0)?(Ori(e,611392)|0)!=0:0)?(Ori(e,611416)|0)!=0:0)?(Ori(e,611448)|0)!=0:0){l=0;i=f;return l|0}m=oUc(b,d,e)|0;do if(m){c[h>>2]=m;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(g,b,h);n=c[g>>2]|0;o=c[b+28>>2]|0;if((n|0)==-1){p=o+(c[b+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((p|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[p+4>>2]|0,(b|0)!=0):0)q=b;else r=17}else r=17;if((r|0)==17){b=hQb(m)|0;if(!b)break;else q=b}b=(da(c[137788]|0,(c[q+8>>2]|0)>>>21)|0)+d|0;n=b>>5;if(1<<b-(n<<5)&c[(c[137786]|0)+(n<<2)>>2]){l=q;i=f;return l|0}}while(0);_ri(k,611472,e);yO(j,k,611488);if(!(a[j>>0]&1))s=j+1|0;else s=c[j+8>>2]|0;Krd(s,0,3653512,1058,1,0,0,0);xri(j);xri(k);l=0;i=f;return l|0}function oUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if(!(a[e>>0]&1))g=e+1|0;else g=c[e+8>>2]|0;e=c[b>>2]|0;h=c[b+4>>2]|0;if((h|0)==(e|0))j=e;else{b=e;k=(h-e|0)/24|0;while(1){e=(k|0)/2|0;l=HEi(c[b+(e*24|0)>>2]|0,g)|0;if(!l)if((c[b+(e*24|0)+4>>2]|0)<(d|0))m=9;else{n=b;o=e}else if((l|0)<0)m=9;else{n=b;o=e}if((m|0)==9){m=0;n=b+((e+1|0)*24|0)|0;o=k+-1-e|0}if(!o){j=n;break}else{b=n;k=o}}}if((j|0)==(h|0)){p=0;i=f;return p|0}o=HEi(g,c[j>>2]|0)|0;if(!o){if((j|0)==(h|0)?1:(c[j+4>>2]|0)>(d|0)){p=0;i=f;return p|0}}else if((o|0)<0|(j|0)==(h|0)){p=0;i=f;return p|0}p=c[j+16>>2]|0;i=f;return p|0}function pUc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153108];c[b+0>>2]=c[d+0>>2];d=bOb(32,b,0,16,3653512,1115)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[152884]=d;i=a;return}function qUc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[152884]|0;f=c[153108]|0;if((e|0)!=0?(xri(e+12|0),g=c[e>>2]|0,(g|0)!=0):0){h=e+4|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~(((j+-24-g|0)>>>0)/24|0)*24|0);ACi(g)}c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[152884]=0;i=a;return}function rUc(a){a=a|0;return 1}function sUc(){var a=0;a=i;QQb(147,161,0,0,0);i=a;return}function tUc(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,611656,15);wQb(147,6,b,52,2636,0,0);xri(b);i=a;return}function uUc(a){a=a|0;return 147}function vUc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;add(b,792072,611656,a,0);KSb(a,b);e=a+36|0;add(b,611672,c[142272]|0,e,0);EUc(b,e,0);bdd(b);e=a+24|0;add(b,611688,c[142306]|0,e,0);FUc(b,e,0);bdd(b);bdd(b);i=d;return}function wUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,611656,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else GUc(a,b);sdd(b);i=d;return}function xUc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;MSb(a,b);HUc(b,a+36|0,0);e=a+24|0;IUc(b,e,0);JUc(c[e>>2]|0,c[a+28>>2]|0,d);i=d;return}function yUc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;NSb(a,b);KUc(b,a+36|0,0);e=a+24|0;LUc(b,e,0);JUc(c[e>>2]|0,c[a+28>>2]|0,d);i=d;return}function zUc(a,b){a=a|0;b=b|0;var c=0;c=i;MUc(a,b);i=c;return}function AUc(a,b){a=a|0;b=b|0;var c=0;c=i;NUc(a,b);i=c;return}function BUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/24|0)+1|0;if(g>>>0>178956970)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/24|0;if(k>>>0<89478485){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/24|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=178956970;r=(l|0)/24|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*24|0)|0;o=r;p=s}s=n+(o*24|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];c[s+16>>2]=c[b+16>>2];c[s+20>>2]=c[b+20>>2]}b=n+((((p|0)/-24|0)+o|0)*24|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*24|0);c[h>>2]=n+(m*24|0);if(!f){i=d;return}ACi(f);i=d;return}function CUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+32|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-24|0;j=a+-48|0;k=a+-20|0;l=g;b:while(1){m=l;n=b-m|0;switch((n|0)/24|0|0){case 3:{o=l;p=h;q=8;break a;break}case 5:{r=l;s=h;q=10;break a;break}case 1:case 0:{q=73;break a;break}case 2:{t=l;u=h;v=k;w=h;q=4;break a;break}case 4:{x=l;y=h;q=9;break a;break}default:{}}if((n|0)<744){z=l;A=a;q=12;break a}B=(n|0)/48|0;C=l+(B*24|0)|0;if((n|0)>23976){D=(n|0)/96|0;E=SUc(l,l+(D*24|0)|0,C,l+((D+B|0)*24|0)|0,h,d)|0}else E=QUc(l,C,h,d)|0;D=c[l>>2]|0;n=c[C>>2]|0;F=HEi(D,n)|0;if(!F)if((c[l+4>>2]|0)<(c[l+(B*24|0)+4>>2]|0)){G=h;H=E}else q=19;else if((F|0)<0){G=h;H=E}else q=19;c:do if((q|0)==19){q=0;d:do if((l|0)!=(j|0)){F=l+(B*24|0)+4|0;I=j;J=a;K=h;while(1){L=HEi(c[J+-48>>2]|0,n)|0;if(!L){if((c[J+-44>>2]|0)<(c[F>>2]|0)){M=I;break}}else if((L|0)<0){M=I;break}L=K+-48|0;if((l|0)==(L|0))break d;else{N=I;O=K;I=L;K=N;J=O}}c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[f+16>>2]=c[l+16>>2];c[f+20>>2]=c[l+20>>2];c[l+0>>2]=c[M+0>>2];c[l+4>>2]=c[M+4>>2];c[l+8>>2]=c[M+8>>2];c[l+12>>2]=c[M+12>>2];c[l+16>>2]=c[M+16>>2];c[l+20>>2]=c[M+20>>2];c[M+0>>2]=c[f+0>>2];c[M+4>>2]=c[f+4>>2];c[M+8>>2]=c[f+8>>2];c[M+12>>2]=c[f+12>>2];c[M+16>>2]=c[f+16>>2];c[M+20>>2]=c[f+20>>2];G=M;H=E+1|0;break c}while(0);J=l+24|0;K=HEi(D,c[h>>2]|0)|0;if(!K)if((c[l+4>>2]|0)<(c[k>>2]|0))P=J;else q=24;else if((K|0)<0)P=J;else q=24;if((q|0)==24){q=0;if((J|0)==(h|0)){q=73;break a}K=l+4|0;I=l;F=J;while(1){J=HEi(D,c[F>>2]|0)|0;if(!J){if((c[K>>2]|0)<(c[F+4>>2]|0)){Q=F;break}}else if((J|0)<0){Q=F;break}J=I+48|0;if((J|0)==(h|0)){q=73;break a}else{O=F;F=J;I=O}}c[f+0>>2]=c[Q+0>>2];c[f+4>>2]=c[Q+4>>2];c[f+8>>2]=c[Q+8>>2];c[f+12>>2]=c[Q+12>>2];c[f+16>>2]=c[Q+16>>2];c[f+20>>2]=c[Q+20>>2];c[Q+0>>2]=c[h+0>>2];c[Q+4>>2]=c[h+4>>2];c[Q+8>>2]=c[h+8>>2];c[Q+12>>2]=c[h+12>>2];c[Q+16>>2]=c[h+16>>2];c[Q+20>>2]=c[h+20>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];c[h+20>>2]=c[f+20>>2];P=Q+24|0}if((P|0)==(h|0)){q=73;break a}I=l+4|0;F=P;K=h;while(1){O=c[l>>2]|0;J=F;while(1){N=HEi(O,c[J>>2]|0)|0;if(!N){if((c[I>>2]|0)<(c[J+4>>2]|0)){R=J;break}}else if((N|0)<0){R=J;break}J=J+24|0}J=K;while(1){N=J+-24|0;L=HEi(O,c[N>>2]|0)|0;if(!L)if((c[I>>2]|0)<(c[J+-20>>2]|0)){J=N;continue}else{S=N;break}else if((L|0)<0){J=N;continue}else{S=N;break}}if(R>>>0>=S>>>0){l=R;continue b};c[f+0>>2]=c[R+0>>2];c[f+4>>2]=c[R+4>>2];c[f+8>>2]=c[R+8>>2];c[f+12>>2]=c[R+12>>2];c[f+16>>2]=c[R+16>>2];c[f+20>>2]=c[R+20>>2];c[R+0>>2]=c[S+0>>2];c[R+4>>2]=c[S+4>>2];c[R+8>>2]=c[S+8>>2];c[R+12>>2]=c[S+12>>2];c[R+16>>2]=c[S+16>>2];c[R+20>>2]=c[S+20>>2];c[S+0>>2]=c[f+0>>2];c[S+4>>2]=c[f+4>>2];c[S+8>>2]=c[f+8>>2];c[S+12>>2]=c[f+12>>2];c[S+16>>2]=c[f+16>>2];c[S+20>>2]=c[f+20>>2];F=R+24|0;K=S}}while(0);D=l+24|0;e:do if(D>>>0<G>>>0){n=D;B=G;K=C;F=H;while(1){I=c[K>>2]|0;J=K+4|0;O=n;while(1){N=HEi(c[O>>2]|0,I)|0;if(!N){if((c[O+4>>2]|0)>=(c[J>>2]|0)){T=O;break}}else if((N|0)>=0){T=O;break}O=O+24|0}O=B;while(1){N=O+-24|0;L=HEi(c[N>>2]|0,I)|0;if(!L)if((c[O+-20>>2]|0)<(c[J>>2]|0)){U=N;break}else{O=N;continue}else if((L|0)<0){U=N;break}else{O=N;continue}}if(T>>>0>U>>>0){V=T;W=K;X=F;break e};c[f+0>>2]=c[T+0>>2];c[f+4>>2]=c[T+4>>2];c[f+8>>2]=c[T+8>>2];c[f+12>>2]=c[T+12>>2];c[f+16>>2]=c[T+16>>2];c[f+20>>2]=c[T+20>>2];c[T+0>>2]=c[U+0>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];c[T+12>>2]=c[U+12>>2];c[T+16>>2]=c[U+16>>2];c[T+20>>2]=c[U+20>>2];c[U+0>>2]=c[f+0>>2];c[U+4>>2]=c[f+4>>2];c[U+8>>2]=c[f+8>>2];c[U+12>>2]=c[f+12>>2];c[U+16>>2]=c[f+16>>2];c[U+20>>2]=c[f+20>>2];n=T+24|0;B=U;K=(K|0)==(T|0)?U:K;F=F+1|0}}else{V=D;W=C;X=H}while(0);do if((V|0)==(W|0))Y=X;else{C=HEi(c[W>>2]|0,c[V>>2]|0)|0;if(!C){if((c[W+4>>2]|0)>=(c[V+4>>2]|0)){Y=X;break}}else if((C|0)>=0){Y=X;break};c[f+0>>2]=c[V+0>>2];c[f+4>>2]=c[V+4>>2];c[f+8>>2]=c[V+8>>2];c[f+12>>2]=c[V+12>>2];c[f+16>>2]=c[V+16>>2];c[f+20>>2]=c[V+20>>2];c[V+0>>2]=c[W+0>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];c[V+12>>2]=c[W+12>>2];c[V+16>>2]=c[W+16>>2];c[V+20>>2]=c[W+20>>2];c[W+0>>2]=c[f+0>>2];c[W+4>>2]=c[f+4>>2];c[W+8>>2]=c[f+8>>2];c[W+12>>2]=c[f+12>>2];c[W+16>>2]=c[f+16>>2];c[W+20>>2]=c[f+20>>2];Y=X+1|0}while(0);if(!Y){Z=UUc(l,V,d)|0;C=V+24|0;if(UUc(C,a,d)|0){q=68;break}if(Z){l=C;continue}}C=V;if((C-m|0)>=(b-C|0)){_=l;$=V;q=72;break}CUc(l,V,d);l=V+24|0}if((q|0)==68){q=0;if(Z){q=73;break}else{g=l;a=V;continue}}else if((q|0)==72){q=0;CUc($+24|0,a,d);g=_;a=$;continue}}if((q|0)==4){$=HEi(c[u>>2]|0,c[t>>2]|0)|0;if(!$){if((c[v>>2]|0)>=(c[t+4>>2]|0)){i=e;return}}else if(($|0)>=0){i=e;return};c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];c[f+16>>2]=c[t+16>>2];c[f+20>>2]=c[t+20>>2];c[t+0>>2]=c[w+0>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];c[t+12>>2]=c[w+12>>2];c[t+16>>2]=c[w+16>>2];c[t+20>>2]=c[w+20>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];c[w+16>>2]=c[f+16>>2];c[w+20>>2]=c[f+20>>2];i=e;return}else if((q|0)==8){QUc(o,o+24|0,p,d)|0;i=e;return}else if((q|0)==9){RUc(x,x+24|0,x+48|0,y,d)|0;i=e;return}else if((q|0)==10){SUc(r,r+24|0,r+48|0,r+72|0,s,d)|0;i=e;return}else if((q|0)==12){TUc(z,A,d);i=e;return}else if((q|0)==73){i=e;return}}function DUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(52,f,1,16,3653512,189)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];jSb(h,f,d);c[h>>2]=611552;c[h+24>>2]=0;c[h+28>>2]=0;c[h+32>>2]=0;d=h+40|0;c[d>>2]=0;c[h+44>>2]=0;c[h+36>>2]=d;a[h+48>>0]=1;i=e;return h|0}function EUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+32|0;f=d+24|0;g=d+20|0;h=d;$cd(b,2646336,2646336,d+16|0,e);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;add(b,3142592,c[142274]|0,h,0);VUc(h,b);bdd(b);cdd(b);if(!(a[h>>0]&1)){i=d;return}b=c[h+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=d;return}function FUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;i=i+32|0;e=b;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;$cd(a,2646336,2646336,b+16|0,d);add(a,3142592,611728,e,0);WUc(e,a);bdd(a);cdd(a);a=c[e+4>>2]|0;if(!a){i=b;return}d=e+8|0;e=c[d>>2]|0;if((e|0)!=(a|0))c[d>>2]=e+(~((e+-4-a|0)>>>2)<<2);ACi(a);i=b;return}function GUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;LSb(a,b);f=a+36|0;g=qdd(b,611672,c[142272]|0,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else wNc(b,f,0);sdd(b)}f=a+24|0;g=qdd(b,611688,c[142306]|0,e,1)|0;if(!g){h=c[f>>2]|0;j=a+28|0;k=c[j>>2]|0;JUc(h,k,e);i=d;return}if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else XUc(b,f,0);sdd(b);h=c[f>>2]|0;j=a+28|0;k=c[j>>2]|0;JUc(h,k,e);i=d;return}function HUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+80|0;f=e+64|0;g=e+28|0;h=e+16|0;j=e+20|0;k=e+68|0;l=e;m=e+24|0;n=e+48|0;o=e+32|0;p=b+12|0;q=c[p>>2]|0;r=q+4|0;if(r>>>0>(c[b+20>>2]|0)>>>0)Bid(p,m,4);else{c[m>>2]=c[q>>2];c[p>>2]=r};c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;zNc(d,c[d+4>>2]|0);c[d+8>>2]=0;r=d+4|0;c[d>>2]=r;c[r>>2]=0;a:do if((c[m>>2]|0)>0){r=n+12|0;p=n+1|0;q=o+1|0;s=n+12|0;t=o+12|0;u=l+1|0;v=l+12|0;w=o+8|0;x=l+8|0;y=l+4|0;z=o+4|0;A=n+8|0;B=n+4|0;C=0;while(1){NXb(b,n,1);Ndd(b);Pxc(r,b);D=a[n>>0]|0;if(!(D&1)){E=(D&255)>>>1;F=p}else{E=c[B>>2]|0;F=c[A>>2]|0}if(E>>>0>2147483631){G=10;break}if(E>>>0<11){a[o>>0]=E<<1;H=q}else{D=E+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];I=cOb(D,16,f,0,3653512,80)|0;c[w>>2]=I;c[o>>2]=D|1;c[z>>2]=E;H=I}YEi(H|0,F|0,E|0)|0;a[H+E>>0]=0;c[t>>2]=c[s>>2];I=a[o>>0]|0;if(!(I&1)){J=(I&255)>>>1;K=q}else{J=c[z>>2]|0;K=c[w>>2]|0}if(J>>>0>2147483631){G=18;break}if(J>>>0<11){a[l>>0]=J<<1;L=u}else{I=J+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];D=cOb(I,16,f,0,3653512,80)|0;c[x>>2]=D;c[l>>2]=I|1;c[y>>2]=J;L=D}YEi(L|0,K|0,J|0)|0;a[L+J>>0]=0;c[v>>2]=c[t>>2];YUc(k,d,l);if(a[l>>0]&1){D=c[x>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(D,f)}if(a[o>>0]&1){D=c[w>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(D,f)}C=C+1|0;if((C|0)>=(c[m>>2]|0))break a}if((G|0)==10)ori(o);else if((G|0)==18)ori(l)}while(0);if(!(a[n>>0]&1)){i=e;return}l=c[n+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);i=e;return}function IUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}ZUc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{Pxc(r,a);_Uc(a,r+4|0,0);r=r+16|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}function JUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;e=i;i=i+32|0;f=e+16|0;g=e;h=f+4|0;j=f+4|0;k=f+8|0;l=f+4|0;m=f+4|0;n=f+8|0;o=g+4|0;p=g+4|0;q=g+8|0;r=f+4|0;s=f+4|0;t=f+8|0;u=f+4|0;v=f+4|0;w=f+8|0;x=a;a=b;a:while(1){b=a;y=a+-16|0;z=(f|0)==(y|0);A=a+-12|0;B=a+-12|0;C=a+-8|0;D=x;b:while(1){E=D;F=b-E|0;G=F>>4;switch(G|0){case 2:{H=D;I=y;J=y;K=A;L=B;M=C;N=4;break a;break}case 4:{O=D;P=y;N=14;break a;break}case 5:{Q=D;R=y;N=15;break a;break}case 3:{S=D;T=y;N=13;break a;break}case 1:case 0:{N=87;break a;break}default:{}}if((F|0)<112){U=D;V=a;N=17;break a}W=(G|0)/2|0;X=D+(W<<4)|0;if((F|0)>15984){F=(G|0)/4|0;Y=dVc(D,D+(F<<4)|0,X,D+(F+W<<4)|0,y,d)|0}else Y=bVc(D,X,y,d)|0;W=c[D>>2]|0;F=c[X>>2]|0;do if((W|0)<(F|0)){Z=y;_=Y}else{G=a;$=y;while(1){aa=G+-32|0;if((D|0)==(aa|0))break;if((c[aa>>2]|0)<(F|0)){ba=aa;ca=G;da=aa;N=49;break}else{ea=$;$=aa;G=ea}}if((N|0)==49){N=0;c[f>>2]=W;G=D+4|0;$Uc(u,G);c[D>>2]=c[ba>>2];aVc(G,c[ca+-28>>2]|0,c[ca+-24>>2]|0);c[ba>>2]=c[f>>2];if((f|0)!=(da|0))aVc(ca+-28|0,c[v>>2]|0,c[w>>2]|0);G=c[v>>2]|0;if(G){$=c[w>>2]|0;if(($|0)!=(G|0))c[w>>2]=$+(~(($+-4-G|0)>>>2)<<2);ACi(G)}Z=da;_=Y+1|0;break}G=D+16|0;if((W|0)<(c[y>>2]|0))fa=G;else{if((G|0)==(y|0)){N=87;break a}else{ga=D;ha=G}while(1){G=c[ha>>2]|0;$=ga+32|0;if((W|0)<(G|0)){ia=ha;ja=G;ka=ha;break}if(($|0)==(y|0)){N=87;break a}else{G=ha;ha=$;ga=G}}c[f>>2]=ja;G=ka+4|0;$Uc(r,G);c[ia>>2]=c[y>>2];aVc(G,c[B>>2]|0,c[C>>2]|0);c[y>>2]=c[f>>2];if(!z)aVc(A,c[s>>2]|0,c[t>>2]|0);G=c[s>>2]|0;if(G){$=c[t>>2]|0;if(($|0)!=(G|0))c[t>>2]=$+(~(($+-4-G|0)>>>2)<<2);ACi(G)}fa=ka+16|0}if((fa|0)==(y|0)){N=87;break a}else{la=fa;ma=y}while(1){G=c[D>>2]|0;$=la;while(1){ea=c[$>>2]|0;aa=$+16|0;if((G|0)<(ea|0)){na=$;oa=ea;pa=aa;qa=$;break}else $=aa}$=ma;while(1){aa=$+-16|0;if((G|0)<(c[aa>>2]|0))$=aa;else{ra=aa;sa=aa;ta=$;break}}if(qa>>>0>=ra>>>0){D=qa;continue b}c[g>>2]=oa;$=qa+4|0;$Uc(o,$);c[na>>2]=c[sa>>2];if((qa|0)!=(ra|0))aVc($,c[ta+-12>>2]|0,c[ta+-8>>2]|0);c[sa>>2]=c[g>>2];if((g|0)!=(ra|0))aVc(ta+-12|0,c[p>>2]|0,c[q>>2]|0);$=c[p>>2]|0;if(!$){la=pa;ma=ra;continue}G=c[q>>2]|0;if((G|0)!=($|0))c[q>>2]=G+(~((G+-4-$|0)>>>2)<<2);ACi($);la=pa;ma=ra}}while(0);W=D+16|0;c:do if(W>>>0<Z>>>0){F=W;$=Z;G=X;aa=_;while(1){ea=c[G>>2]|0;ua=F;while(1){va=c[ua>>2]|0;wa=ua+16|0;if((va|0)<(ea|0))ua=wa;else{xa=ua;ya=va;za=wa;Aa=ua;break}}ua=$;while(1){wa=ua+-16|0;if((c[wa>>2]|0)<(ea|0)){Ba=wa;Ca=wa;Da=ua;break}else ua=wa}if(Aa>>>0>Ba>>>0){Ea=Aa;Fa=G;Ga=aa;break c}c[f>>2]=ya;ua=Aa+4|0;$Uc(l,ua);c[xa>>2]=c[Ca>>2];if((Aa|0)!=(Ba|0))aVc(ua,c[Da+-12>>2]|0,c[Da+-8>>2]|0);c[Ca>>2]=c[f>>2];if((f|0)!=(Ba|0))aVc(Da+-12|0,c[m>>2]|0,c[n>>2]|0);ua=c[m>>2]|0;if(ua){ea=c[n>>2]|0;if((ea|0)!=(ua|0))c[n>>2]=ea+(~((ea+-4-ua|0)>>>2)<<2);ACi(ua)}F=za;$=Ba;G=(G|0)==(Aa|0)?Ba:G;aa=aa+1|0}}else{Ea=W;Fa=X;Ga=_}while(0);if((Ea|0)!=(Fa|0)?(X=c[Ea>>2]|0,(c[Fa>>2]|0)<(X|0)):0){c[f>>2]=X;X=Ea+4|0;$Uc(h,X);c[Ea>>2]=c[Fa>>2];aVc(X,c[Fa+4>>2]|0,c[Fa+8>>2]|0);c[Fa>>2]=c[f>>2];if((f|0)!=(Fa|0))aVc(Fa+4|0,c[j>>2]|0,c[k>>2]|0);X=c[j>>2]|0;if(X){W=c[k>>2]|0;if((W|0)!=(X|0))c[k>>2]=W+(~((W+-4-X|0)>>>2)<<2);ACi(X)}Ha=Ga+1|0}else Ha=Ga;if(!Ha){Ia=fVc(D,Ea,d)|0;X=Ea+16|0;if(fVc(X,a,d)|0){N=82;break}if(Ia){D=X;continue}}X=Ea;if((X-E|0)>=(b-X|0)){Ja=D;Ka=Ea;N=86;break}JUc(D,Ea,d);D=Ea+16|0}if((N|0)==82){N=0;if(Ia){N=87;break}else{x=D;a=Ea;continue}}else if((N|0)==86){N=0;JUc(Ka+16|0,a,d);x=Ja;a=Ka;continue}}if((N|0)==4){Ka=c[H>>2]|0;if((c[J>>2]|0)>=(Ka|0)){i=e;return}c[f>>2]=Ka;Ka=H+4|0;$Uc(f+4|0,Ka);c[H>>2]=c[J>>2];if((H|0)!=(I|0))aVc(Ka,c[L>>2]|0,c[M>>2]|0);c[J>>2]=c[f>>2];J=f+4|0;if((f|0)!=(I|0))aVc(K,c[J>>2]|0,c[f+8>>2]|0);K=c[J>>2]|0;if(!K){i=e;return}J=f+8|0;f=c[J>>2]|0;if((f|0)!=(K|0))c[J>>2]=f+(~((f+-4-K|0)>>>2)<<2);ACi(K);i=e;return}else if((N|0)==13){bVc(S,S+16|0,T,d)|0;i=e;return}else if((N|0)==14){cVc(O,O+16|0,O+32|0,P,d)|0;i=e;return}else if((N|0)==15){dVc(Q,Q+16|0,Q+32|0,Q+48|0,R,d)|0;i=e;return}else if((N|0)==17){eVc(U,V,d);i=e;return}else if((N|0)==87){i=e;return}}function KUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+80|0;f=e+64|0;g=e+28|0;h=e+16|0;j=e+20|0;k=e+68|0;l=e;m=e+24|0;n=e+48|0;o=e+32|0;p=b+12|0;q=c[p>>2]|0;r=q+4|0;if(r>>>0>(c[b+20>>2]|0)>>>0){Bid(p,m,4);s=c[m>>2]|0}else{t=c[q>>2]|0;c[m>>2]=t;c[p>>2]=r;s=t}c[m>>2]=XEi(s|0)|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;zNc(d,c[d+4>>2]|0);c[d+8>>2]=0;s=d+4|0;c[d>>2]=s;c[s>>2]=0;a:do if((c[m>>2]|0)>0){s=n+12|0;t=n+1|0;r=o+1|0;p=n+12|0;q=o+12|0;u=l+1|0;v=l+12|0;w=o+8|0;x=l+8|0;y=l+4|0;z=o+4|0;A=n+8|0;B=n+4|0;C=0;while(1){OXb(b,n,1);Mdd(b);Vxc(s,b);D=a[n>>0]|0;if(!(D&1)){E=(D&255)>>>1;F=t}else{E=c[B>>2]|0;F=c[A>>2]|0}if(E>>>0>2147483631){G=10;break}if(E>>>0<11){a[o>>0]=E<<1;H=r}else{D=E+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];I=cOb(D,16,f,0,3653512,80)|0;c[w>>2]=I;c[o>>2]=D|1;c[z>>2]=E;H=I}YEi(H|0,F|0,E|0)|0;a[H+E>>0]=0;c[q>>2]=c[p>>2];I=a[o>>0]|0;if(!(I&1)){J=(I&255)>>>1;K=r}else{J=c[z>>2]|0;K=c[w>>2]|0}if(J>>>0>2147483631){G=18;break}if(J>>>0<11){a[l>>0]=J<<1;L=u}else{I=J+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];D=cOb(I,16,f,0,3653512,80)|0;c[x>>2]=D;c[l>>2]=I|1;c[y>>2]=J;L=D}YEi(L|0,K|0,J|0)|0;a[L+J>>0]=0;c[v>>2]=c[q>>2];YUc(k,d,l);if(a[l>>0]&1){D=c[x>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(D,f)}if(a[o>>0]&1){D=c[w>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(D,f)}C=C+1|0;if((C|0)>=(c[m>>2]|0))break a}if((G|0)==10)ori(o);else if((G|0)==18)ori(l)}while(0);if(!(a[n>>0]&1)){i=e;return}l=c[n+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);i=e;return}function LUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;ZUc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{Vxc(r,a);gVc(a,r+4|0,0);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function MUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;OSb(a,b);f=c[a+44>>2]|0;c[e>>2]=f;g=b+12|0;h=c[g>>2]|0;j=h+4|0;if(j>>>0<(c[b+20>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=j}else Gid(g,e,4);e=a+40|0;g=c[a+36>>2]|0;if((g|0)==(e|0)){k=a+24|0;hVc(b,k,0);i=d;return}j=c[142266]|0;f=g;while(1){FXb(b,f+16|0,j,0);Yxc(f+28|0,b);g=c[f+4>>2]|0;if(!g){h=f;while(1){l=c[h+8>>2]|0;if((c[l>>2]|0)==(h|0)){m=l;break}else h=l}}else{h=g;while(1){l=c[h>>2]|0;if(!l){m=h;break}else h=l}}if((m|0)==(e|0))break;else f=m}k=a+24|0;hVc(b,k,0);i=d;return}function NUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;PSb(b,d);f=c[b+36>>2]|0;g=b+40|0;if((f|0)!=(g|0)){h=d+12|0;j=d+28|0;k=d+32|0;l=f;while(1){f=l+28|0;m=c[h>>2]|0;n=xo[c[c[m>>2]>>2]&2047](m,c[f>>2]|0,c[j>>2]|0)|0;if(a[k>>0]|0)c[f>>2]=n;n=c[l+4>>2]|0;if(!n){f=l;while(1){m=c[f+8>>2]|0;if((c[m>>2]|0)==(f|0)){o=m;break}else f=m}}else{f=n;while(1){m=c[f>>2]|0;if(!m){o=f;break}else f=m}}if((o|0)==(g|0))break;else l=o}}o=c[b+24>>2]|0;l=c[b+28>>2]|0;if((o|0)==(l|0)){i=e;return}b=d+12|0;g=d+28|0;k=d+32|0;d=o;do{o=c[b>>2]|0;j=xo[c[c[o>>2]>>2]&2047](o,c[d>>2]|0,c[g>>2]|0)|0;if(a[k>>0]|0)c[d>>2]=j;j=c[d+4>>2]|0;o=c[d+8>>2]|0;if((j|0)!=(o|0)){h=j;do{j=c[b>>2]|0;f=xo[c[c[j>>2]>>2]&2047](j,c[h>>2]|0,c[g>>2]|0)|0;if(a[k>>0]|0)c[h>>2]=f;h=h+4|0}while((h|0)!=(o|0))}d=d+16|0}while((d|0)!=(l|0));i=e;return}function OUc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;c[a>>2]=611552;zNc(a+36|0,c[a+40>>2]|0);d=a+24|0;e=c[d>>2]|0;if(!e){ZSb(a);i=b;return}f=a+28|0;g=c[f>>2]|0;if((g|0)==(e|0))h=e;else{j=g;while(1){g=j+-16|0;c[f>>2]=g;k=c[j+-12>>2]|0;if(!k)l=g;else{g=j+-8|0;m=c[g>>2]|0;if((m|0)!=(k|0))c[g>>2]=m+(~((m+-4-k|0)>>>2)<<2);ACi(k);l=c[f>>2]|0}if((l|0)==(e|0))break;else j=l}h=c[d>>2]|0}ACi(h);ZSb(a);i=b;return}function PUc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;c[a>>2]=611552;zNc(a+36|0,c[a+40>>2]|0);d=a+24|0;e=c[d>>2]|0;if(!e){ZSb(a);ACi(a);i=b;return}f=a+28|0;g=c[f>>2]|0;if((g|0)==(e|0))h=e;else{j=g;while(1){g=j+-16|0;c[f>>2]=g;k=c[j+-12>>2]|0;if(!k)l=g;else{g=j+-8|0;m=c[g>>2]|0;if((m|0)!=(k|0))c[g>>2]=m+(~((m+-4-k|0)>>>2)<<2);ACi(k);l=c[f>>2]|0}if((l|0)==(e|0))break;else j=l}h=c[d>>2]|0}ACi(h);ZSb(a);ACi(a);i=b;return}function QUc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=c[b>>2]|0;h=HEi(g,c[a>>2]|0)|0;if(!h)j=(c[b+4>>2]|0)<(c[a+4>>2]|0);else j=(h|0)<0;h=HEi(c[d>>2]|0,g)|0;if(!h)k=(c[d+4>>2]|0)<(c[b+4>>2]|0);else k=(h|0)<0;if(!j){if(!k){l=0;i=e;return l|0};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];j=HEi(c[b>>2]|0,c[a>>2]|0)|0;if(!j){if((c[b+4>>2]|0)>=(c[a+4>>2]|0)){l=1;i=e;return l|0}}else if((j|0)>=0){l=1;i=e;return l|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];l=2;i=e;return l|0}if(k){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];l=1;i=e;return l|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];a=HEi(c[d>>2]|0,c[b>>2]|0)|0;if(!a){if((c[d+4>>2]|0)>=(c[b+4>>2]|0)){l=1;i=e;return l|0}}else if((a|0)>=0){l=1;i=e;return l|0};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];l=2;i=e;return l|0}function RUc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g;j=QUc(a,b,d,f)|0;f=HEi(c[e>>2]|0,c[d>>2]|0)|0;if(!f){if((c[e+4>>2]|0)>=(c[d+4>>2]|0)){k=j;i=g;return k|0}}else if((f|0)>=0){k=j;i=g;return k|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];e=j+1|0;f=HEi(c[d>>2]|0,c[b>>2]|0)|0;if(!f){if((c[d+4>>2]|0)>=(c[b+4>>2]|0)){k=e;i=g;return k|0}}else if((f|0)>=0){k=e;i=g;return k|0};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[h+20>>2]=c[b+20>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];d=j+2|0;e=HEi(c[b>>2]|0,c[a>>2]|0)|0;if(!e){if((c[b+4>>2]|0)>=(c[a+4>>2]|0)){k=d;i=g;return k|0}}else if((e|0)>=0){k=d;i=g;return k|0};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];c[b+20>>2]=c[h+20>>2];k=j+3|0;i=g;return k|0}function SUc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=h;k=RUc(a,b,d,e,g)|0;g=HEi(c[f>>2]|0,c[e>>2]|0)|0;if(!g){if((c[f+4>>2]|0)>=(c[e+4>>2]|0)){l=k;i=h;return l|0}}else if((g|0)>=0){l=k;i=h;return l|0};c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[j+20>>2]=c[e+20>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];f=k+1|0;g=HEi(c[e>>2]|0,c[d>>2]|0)|0;if(!g){if((c[e+4>>2]|0)>=(c[d+4>>2]|0)){l=f;i=h;return l|0}}else if((g|0)>=0){l=f;i=h;return l|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];c[e+20>>2]=c[j+20>>2];e=k+2|0;f=HEi(c[d>>2]|0,c[b>>2]|0)|0;if(!f){if((c[d+4>>2]|0)>=(c[b+4>>2]|0)){l=e;i=h;return l|0}}else if((f|0)>=0){l=e;i=h;return l|0};c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2];c[j+20>>2]=c[b+20>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[d+16>>2]=c[j+16>>2];c[d+20>>2]=c[j+20>>2];d=k+3|0;e=HEi(c[b>>2]|0,c[a>>2]|0)|0;if(!e){if((c[b+4>>2]|0)>=(c[a+4>>2]|0)){l=d;i=h;return l|0}}else if((e|0)>=0){l=d;i=h;return l|0};c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[j+20>>2]=c[a+20>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];c[b+16>>2]=c[j+16>>2];c[b+20>>2]=c[j+20>>2];l=k+4|0;i=h;return l|0}function TUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=a+48|0;QUc(a,a+24|0,g,d)|0;d=a+72|0;if((d|0)==(b|0)){i=e;return}h=d;d=g;while(1){g=c[h>>2]|0;j=HEi(g,c[d>>2]|0)|0;if(!j){k=c[h+4>>2]|0;if((k|0)<(c[d+4>>2]|0)){l=k;m=7}}else if((j|0)<0){l=c[h+4>>2]|0;m=7}if((m|0)==7){m=0;j=h+8|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];a:do if((d|0)==(a|0))n=a;else{j=d;while(1){k=j;j=j+-24|0;o=HEi(g,c[j>>2]|0)|0;if(!o){if((l|0)>=(c[k+-20>>2]|0)){n=k;break a}}else if((o|0)>=0){n=k;break a};c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[k+16>>2]=c[j+16>>2];c[k+20>>2]=c[j+20>>2];if((j|0)==(a|0)){n=a;break}}}while(0);c[n>>2]=g;c[n+4>>2]=l;j=n+8|0;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}j=h+24|0;if((j|0)==(b|0))break;else{k=h;h=j;d=k}}i=e;return}function UUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+48|0;f=e+16|0;g=e;switch((b-a|0)/24|0|0){case 5:{SUc(a,a+24|0,a+48|0,a+72|0,b+-24|0,d)|0;h=1;i=e;return h|0}case 4:{RUc(a,a+24|0,a+48|0,b+-24|0,d)|0;h=1;i=e;return h|0}case 2:{j=b+-24|0;k=HEi(c[j>>2]|0,c[a>>2]|0)|0;if(!k){if((c[b+-20>>2]|0)>=(c[a+4>>2]|0)){h=1;i=e;return h|0}}else if((k|0)>=0){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[a+16>>2]=c[j+16>>2];c[a+20>>2]=c[j+20>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];h=1;i=e;return h|0}case 3:{QUc(a,a+24|0,b+-24|0,d)|0;h=1;i=e;return h|0}case 1:case 0:{h=1;i=e;return h|0}default:{f=a+48|0;QUc(a,a+24|0,f,d)|0;d=a+72|0;if((d|0)==(b|0)){h=1;i=e;return h|0}j=0;k=d;d=f;while(1){f=c[k>>2]|0;l=HEi(f,c[d>>2]|0)|0;if(!l){m=c[k+4>>2]|0;if((m|0)<(c[d+4>>2]|0)){n=m;o=15}else p=j}else if((l|0)<0){n=c[k+4>>2]|0;o=15}else p=j;if((o|0)==15){o=0;l=k+8|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[k+16>>2]=c[d+16>>2];c[k+20>>2]=c[d+20>>2];a:do if((d|0)==(a|0))q=a;else{l=d;while(1){m=l;l=l+-24|0;r=HEi(f,c[l>>2]|0)|0;if(!r){if((n|0)>=(c[m+-20>>2]|0)){q=m;break a}}else if((r|0)>=0){q=m;break a};c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[m+16>>2]=c[l+16>>2];c[m+20>>2]=c[l+20>>2];if((l|0)==(a|0)){q=a;break}}}while(0);c[q>>2]=f;c[q+4>>2]=n;l=q+8|0;c[l+0>>2]=c[g+0>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];l=j+1|0;if((l|0)==8){s=k;break}else p=l}l=k+24|0;if((l|0)==(b|0)){h=1;o=23;break}else{m=k;j=p;k=l;d=m}}if((o|0)==23){i=e;return h|0}h=(s+24|0)==(b|0);i=e;return h|0}}return 0}function VUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;add(b,c[142266]|0,c[142294]|0,a,0);$cd(b,2646336,2646336,e,1);add(b,3142592,c[142260]|0,d+16|0,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);h=a+12|0;add(b,c[142282]|0,c[142276]|0,h,0);a=e+8|0;j=a;c[j>>2]=0;c[j+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,h,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,a,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);i=d;return}function WUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=c[142276]|0;add(b,611712,g,a,0);h=e+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[e>>2]=0;j=c[142270]|0;add(b,792256,j,a,1);k=b+12|0;l=b+20|0;c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);m=c[142290]|0;add(b,792272,m,h,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,622128,c[142306]|0,a+4|0,0);c[f>>2]=0;$cd(b,2646336,2646336,d+20|0,0);add(b,3142592,g,f,0);g=e+8|0;a=g;c[a>>2]=0;c[a+4>>2]=0;c[e>>2]=0;add(b,792256,j,f,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,m,g,1);c[(c[c[k>>2]>>2]|0)+((c[l>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);i=d;return}function XUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}ZUc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,611728,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;iVc(r,a);t=r+16|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,611728,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else iVc(m,a);sdd(a)}m=m+16|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function YUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;if(!j){k=d+4|0;l=k;m=k}else{k=a[e>>0]|0;n=(k&1)==0;o=n?(k&255)>>>1:c[e+4>>2]|0;k=n?e+1|0:c[e+8>>2]|0;n=j;while(1){j=n+16|0;p=a[j>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=j+1|0}else{q=c[n+20>>2]|0;r=c[n+24>>2]|0}j=FEi(k,r,q>>>0<o>>>0?q:o)|0;if(!j)if(o>>>0<q>>>0)s=9;else s=10;else if((j|0)<0)s=9;else s=10;if((s|0)==9){s=0;j=c[n>>2]|0;if(!j){l=n;m=n;break}else{n=j;continue}}else if((s|0)==10){s=0;j=n+4|0;p=c[j>>2]|0;if(!p){l=j;m=n;break}else{n=p;continue}}}}PNc(g,d,e);e=c[g>>2]|0;c[g>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=m;c[l>>2]=e;m=c[c[d>>2]>>2]|0;if(!m){t=e;u=c[h>>2]|0;GN(u,t);v=d+8|0;w=c[v>>2]|0;x=w+1|0;c[v>>2]=x;c[b>>2]=e;i=f;return}c[d>>2]=m;t=c[l>>2]|0;u=c[h>>2]|0;GN(u,t);v=d+8|0;w=c[v>>2]|0;x=w+1|0;c[v>>2]=x;c[b>>2]=e;i=f;return}function ZUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+64|0;e=d+44|0;f=d+32|0;g=d+16|0;h=d+36|0;j=d+12|0;k=d;l=d+28|0;m=d+40|0;n=d+48|0;o=a+4|0;p=c[a>>2]|0;q=p;r=(c[o>>2]|0)-q>>4;if(r>>>0>=b>>>0){if(r>>>0<=b>>>0){i=d;return}c[l>>2]=p;c[m>>2]=p+(b<<4);c[f+0>>2]=c[l+0>>2];c[e+0>>2]=c[m+0>>2];mVc(k,f,e,n,0);n=c[k>>2]|0;m=c[a>>2]|0;c[k>>2]=m;c[a>>2]=n;n=k+4|0;l=c[n>>2]|0;p=c[o>>2]|0;c[n>>2]=p;c[o>>2]=l;l=k+8|0;s=a+8|0;t=c[l>>2]|0;c[l>>2]=c[s>>2];c[s>>2]=t;if(!m){i=d;return}if((p|0)==(m|0))u=m;else{t=p;while(1){p=t+-16|0;c[n>>2]=p;s=c[t+-12>>2]|0;if(!s)v=p;else{p=t+-8|0;l=c[p>>2]|0;if((l|0)!=(s|0))c[p>>2]=l+(~((l+-4-s|0)>>>2)<<2);ACi(s);v=c[n>>2]|0}if((v|0)==(m|0))break;else t=v}u=c[k>>2]|0}ACi(u);i=d;return}u=a+8|0;if(((c[u>>2]|0)-q>>4|0)==(b|0)){lVc(a,b-r|0);i=d;return}c[g>>2]=0;r=g+4|0;c[r>>2]=0;q=g+8|0;c[q>>2]=0;jVc(g,b);c[h>>2]=c[a>>2];c[j>>2]=c[o>>2];c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];kVc(g,f,e);e=c[r>>2]|0;f=c[g>>2]|0;j=e-f>>4;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<4)|0,(e|0)!=(h|0)):0){f=e;while(1){k=f+-16|0;c[r>>2]=k;v=c[f+-12>>2]|0;if(!v)w=k;else{k=f+-8|0;t=c[k>>2]|0;if((t|0)!=(v|0))c[k>>2]=t+(~((t+-4-v|0)>>>2)<<2);ACi(v);w=c[r>>2]|0}if((w|0)==(h|0)){x=h;break}else f=w}}else x=e;else{lVc(g,b-j|0);x=c[r>>2]|0}j=c[g>>2]|0;b=c[a>>2]|0;c[g>>2]=b;c[a>>2]=j;j=c[o>>2]|0;c[r>>2]=j;c[o>>2]=x;x=c[q>>2]|0;c[q>>2]=c[u>>2];c[u>>2]=x;if(!b){i=d;return}if((j|0)==(b|0))y=b;else{x=j;while(1){j=x+-16|0;c[r>>2]=j;u=c[x+-12>>2]|0;if(!u)z=j;else{j=x+-8|0;q=c[j>>2]|0;if((q|0)!=(u|0))c[j>>2]=q+(~((q+-4-u|0)>>>2)<<2);ACi(u);z=c[r>>2]|0}if((z|0)==(b|0))break;else x=z}y=c[g>>2]|0}ACi(y);i=d;return}function _Uc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}nVc(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{Pxc(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function $Uc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=(c[g>>2]|0)-(c[b>>2]|0)|0;j=h>>2;if(!j){i=d;return}if(j>>>0>1073741823)vxi(a);k=xCi(h)|0;c[e>>2]=k;c[a>>2]=k;c[f>>2]=k+(j<<2);j=c[b>>2]|0;b=c[g>>2]|0;if((j|0)==(b|0)){i=d;return}g=(b+-4-j|0)>>>2;f=j;j=k;while(1){c[j>>2]=c[f>>2];f=f+4|0;if((f|0)==(b|0))break;else j=j+4|0}c[e>>2]=k+(g+1<<2);i=d;return}function aVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=b;g=d-f>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>2>>>0){if(!k)m=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>1073741823)vxi(a);j=m-0|0;if(j>>2>>>0<536870911){m=j>>1;j=m>>>0<g>>>0?g:m;if(j>>>0>1073741823)vxi(a);else o=j}else o=1073741823;j=xCi(o<<2)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(o<<2);if((b|0)==(d|0)){i=e;return}o=(d+-4-f|0)>>>2;h=b;n=j;while(1){c[n>>2]=c[h>>2];h=h+4|0;if((h|0)==(d|0))break;else n=n+4|0}c[m>>2]=j+(o+1<<2);i=e;return}o=a+4|0;a=c[o>>2]|0;j=a-l>>2;if(g>>>0>j>>>0){p=1;q=b+(j<<2)|0}else{p=0;q=d}if((q|0)==(b|0))r=k;else{j=q+-4-f|0;f=b;b=k;while(1){c[b>>2]=c[f>>2];f=f+4|0;if((f|0)==(q|0))break;else b=b+4|0}r=k+((j>>>2)+1<<2)|0}if(!p){if((a|0)==(r|0)){i=e;return}c[o>>2]=a+(~((a+-4-r|0)>>>2)<<2);i=e;return}if((q|0)==(d|0)){i=e;return}r=(d+-4-q|0)>>>2;p=q;q=a;while(1){if(q)c[q>>2]=c[p>>2];p=p+4|0;if((p|0)==(d|0))break;else q=q+4|0}c[o>>2]=a+(r+1<<2);i=e;return}function bVc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;j=c[b>>2]|0;k=c[a>>2]|0;l=(c[d>>2]|0)<(j|0);if((j|0)>=(k|0)){if(!l){m=0;i=e;return m|0}c[f>>2]=j;j=b+4|0;$Uc(f+4|0,j);c[b>>2]=c[d>>2];if((b|0)!=(d|0))aVc(j,c[d+4>>2]|0,c[d+8>>2]|0);c[d>>2]=c[f>>2];if((f|0)==(d|0))n=d+4|0;else{o=f+4|0;aVc(d+4|0,c[o>>2]|0,c[f+8>>2]|0);n=o}o=c[n>>2]|0;if(o){n=f+8|0;p=c[n>>2]|0;if((p|0)!=(o|0))c[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);ACi(o)}o=c[a>>2]|0;if((c[b>>2]|0)>=(o|0)){m=1;i=e;return m|0}c[g>>2]=o;o=a+4|0;$Uc(g+4|0,o);c[a>>2]=c[b>>2];if((a|0)!=(b|0))aVc(o,c[b+4>>2]|0,c[b+8>>2]|0);c[b>>2]=c[g>>2];o=g+4|0;if((g|0)!=(b|0))aVc(j,c[o>>2]|0,c[g+8>>2]|0);j=c[o>>2]|0;if(!j){m=2;i=e;return m|0}o=g+8|0;g=c[o>>2]|0;if((g|0)!=(j|0))c[o>>2]=g+(~((g+-4-j|0)>>>2)<<2);ACi(j);m=2;i=e;return m|0}if(l){c[f>>2]=k;l=a+4|0;$Uc(f+4|0,l);c[a>>2]=c[d>>2];if((a|0)!=(d|0))aVc(l,c[d+4>>2]|0,c[d+8>>2]|0);c[d>>2]=c[f>>2];if((f|0)==(d|0))q=d+4|0;else{l=f+4|0;aVc(d+4|0,c[l>>2]|0,c[f+8>>2]|0);q=l}l=c[q>>2]|0;if(!l){m=1;i=e;return m|0}q=f+8|0;j=c[q>>2]|0;if((j|0)!=(l|0))c[q>>2]=j+(~((j+-4-l|0)>>>2)<<2);ACi(l);m=1;i=e;return m|0}c[f>>2]=k;k=a+4|0;$Uc(f+4|0,k);c[a>>2]=c[b>>2];if((a|0)!=(b|0))aVc(k,c[b+4>>2]|0,c[b+8>>2]|0);c[b>>2]=c[f>>2];if((f|0)==(b|0))r=b+4|0;else{k=f+4|0;aVc(b+4|0,c[k>>2]|0,c[f+8>>2]|0);r=k}k=c[r>>2]|0;if(k){r=f+8|0;f=c[r>>2]|0;if((f|0)!=(k|0))c[r>>2]=f+(~((f+-4-k|0)>>>2)<<2);ACi(k)}k=c[b>>2]|0;if((c[d>>2]|0)>=(k|0)){m=1;i=e;return m|0}c[h>>2]=k;k=b+4|0;$Uc(h+4|0,k);c[b>>2]=c[d>>2];if((b|0)!=(d|0))aVc(k,c[d+4>>2]|0,c[d+8>>2]|0);c[d>>2]=c[h>>2];if((h|0)==(d|0))s=d+4|0;else{k=h+4|0;aVc(d+4|0,c[k>>2]|0,c[h+8>>2]|0);s=k}k=c[s>>2]|0;if(!k){m=2;i=e;return m|0}s=h+8|0;h=c[s>>2]|0;if((h|0)!=(k|0))c[s>>2]=h+(~((h+-4-k|0)>>>2)<<2);ACi(k);m=2;i=e;return m|0}function cVc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=bVc(a,b,d,f)|0;f=c[d>>2]|0;if((c[e>>2]|0)>=(f|0)){k=j;i=g;return k|0}c[h>>2]=f;f=d+4|0;$Uc(h+4|0,f);c[d>>2]=c[e>>2];if((d|0)!=(e|0))aVc(f,c[e+4>>2]|0,c[e+8>>2]|0);c[e>>2]=c[h>>2];if((h|0)==(e|0))l=e+4|0;else{m=h+4|0;aVc(e+4|0,c[m>>2]|0,c[h+8>>2]|0);l=m}m=c[l>>2]|0;if(m){l=h+8|0;e=c[l>>2]|0;if((e|0)!=(m|0))c[l>>2]=e+(~((e+-4-m|0)>>>2)<<2);ACi(m)}m=c[b>>2]|0;if((c[d>>2]|0)>=(m|0)){k=j+1|0;i=g;return k|0}c[h>>2]=m;m=b+4|0;$Uc(h+4|0,m);c[b>>2]=c[d>>2];if((b|0)!=(d|0))aVc(m,c[d+4>>2]|0,c[d+8>>2]|0);c[d>>2]=c[h>>2];e=h+4|0;if((h|0)!=(d|0))aVc(f,c[e>>2]|0,c[h+8>>2]|0);f=c[e>>2]|0;if(f){e=h+8|0;d=c[e>>2]|0;if((d|0)!=(f|0))c[e>>2]=d+(~((d+-4-f|0)>>>2)<<2);ACi(f)}f=c[a>>2]|0;if((c[b>>2]|0)>=(f|0)){k=j+2|0;i=g;return k|0}c[h>>2]=f;f=a+4|0;$Uc(h+4|0,f);c[a>>2]=c[b>>2];if((a|0)!=(b|0))aVc(f,c[b+4>>2]|0,c[b+8>>2]|0);c[b>>2]=c[h>>2];f=h+4|0;if((h|0)!=(b|0))aVc(m,c[f>>2]|0,c[h+8>>2]|0);m=c[f>>2]|0;if(m){f=h+8|0;h=c[f>>2]|0;if((h|0)!=(m|0))c[f>>2]=h+(~((h+-4-m|0)>>>2)<<2);ACi(m)}k=j+3|0;i=g;return k|0}function dVc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h;k=cVc(a,b,d,e,g)|0;g=c[e>>2]|0;if((c[f>>2]|0)>=(g|0)){l=k;i=h;return l|0}c[j>>2]=g;g=e+4|0;$Uc(j+4|0,g);c[e>>2]=c[f>>2];if((e|0)!=(f|0))aVc(g,c[f+4>>2]|0,c[f+8>>2]|0);c[f>>2]=c[j>>2];if((j|0)==(f|0))m=f+4|0;else{n=j+4|0;aVc(f+4|0,c[n>>2]|0,c[j+8>>2]|0);m=n}n=c[m>>2]|0;if(n){m=j+8|0;f=c[m>>2]|0;if((f|0)!=(n|0))c[m>>2]=f+(~((f+-4-n|0)>>>2)<<2);ACi(n)}n=c[d>>2]|0;if((c[e>>2]|0)>=(n|0)){l=k+1|0;i=h;return l|0}c[j>>2]=n;n=d+4|0;$Uc(j+4|0,n);c[d>>2]=c[e>>2];if((d|0)!=(e|0))aVc(n,c[e+4>>2]|0,c[e+8>>2]|0);c[e>>2]=c[j>>2];f=j+4|0;if((j|0)!=(e|0))aVc(g,c[f>>2]|0,c[j+8>>2]|0);g=c[f>>2]|0;if(g){f=j+8|0;e=c[f>>2]|0;if((e|0)!=(g|0))c[f>>2]=e+(~((e+-4-g|0)>>>2)<<2);ACi(g)}g=c[b>>2]|0;if((c[d>>2]|0)>=(g|0)){l=k+2|0;i=h;return l|0}c[j>>2]=g;g=b+4|0;$Uc(j+4|0,g);c[b>>2]=c[d>>2];if((b|0)!=(d|0))aVc(g,c[d+4>>2]|0,c[d+8>>2]|0);c[d>>2]=c[j>>2];e=j+4|0;if((j|0)!=(d|0))aVc(n,c[e>>2]|0,c[j+8>>2]|0);n=c[e>>2]|0;if(n){e=j+8|0;d=c[e>>2]|0;if((d|0)!=(n|0))c[e>>2]=d+(~((d+-4-n|0)>>>2)<<2);ACi(n)}n=c[a>>2]|0;if((c[b>>2]|0)>=(n|0)){l=k+3|0;i=h;return l|0}c[j>>2]=n;n=a+4|0;$Uc(j+4|0,n);c[a>>2]=c[b>>2];if((a|0)!=(b|0))aVc(n,c[b+4>>2]|0,c[b+8>>2]|0);c[b>>2]=c[j>>2];n=j+4|0;if((j|0)!=(b|0))aVc(g,c[n>>2]|0,c[j+8>>2]|0);g=c[n>>2]|0;if(g){n=j+8|0;j=c[n>>2]|0;if((j|0)!=(g|0))c[n>>2]=j+(~((j+-4-g|0)>>>2)<<2);ACi(g)}l=k+4|0;i=h;return l|0}function eVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;g=a+32|0;bVc(a,a+16|0,g,d)|0;d=a+48|0;if((d|0)==(b|0)){i=e;return}h=f+4|0;j=f+4|0;k=f+8|0;l=d;d=g;while(1){g=c[l>>2]|0;if((g|0)<(c[d>>2]|0)){c[f>>2]=g;$Uc(h,l+4|0);g=c[d>>2]|0;m=l;n=d;while(1){c[m>>2]=g;aVc(m+4|0,c[n+4>>2]|0,c[n+8>>2]|0);if((n|0)==(a|0)){o=n;p=6;break}q=n+-16|0;r=c[f>>2]|0;g=c[q>>2]|0;if((r|0)>=(g|0)){s=r;t=n;u=n;break}else{r=n;n=q;m=r}}if((p|0)==6){p=0;s=c[f>>2]|0;t=o;u=a}c[t>>2]=s;if((u|0)!=(f|0))aVc(u+4|0,c[j>>2]|0,c[k>>2]|0);m=c[j>>2]|0;if(m){n=c[k>>2]|0;if((n|0)!=(m|0))c[k>>2]=n+(~((n+-4-m|0)>>>2)<<2);ACi(m)}}m=l+16|0;if((m|0)==(b|0))break;else{n=l;l=m;d=n}}i=e;return}function fVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+32|0;f=e+16|0;g=e;switch(b-a>>4|0){case 4:{cVc(a,a+16|0,a+32|0,b+-16|0,d)|0;h=1;i=e;return h|0}case 3:{bVc(a,a+16|0,b+-16|0,d)|0;h=1;i=e;return h|0}case 5:{dVc(a,a+16|0,a+32|0,a+48|0,b+-16|0,d)|0;h=1;i=e;return h|0}case 2:{j=b+-16|0;k=c[a>>2]|0;if((c[j>>2]|0)>=(k|0)){h=1;i=e;return h|0}c[f>>2]=k;k=a+4|0;$Uc(f+4|0,k);c[a>>2]=c[j>>2];if((j|0)!=(a|0))aVc(k,c[b+-12>>2]|0,c[b+-8>>2]|0);c[j>>2]=c[f>>2];if((f|0)==(j|0))l=f+4|0;else{j=f+4|0;aVc(b+-12|0,c[j>>2]|0,c[f+8>>2]|0);l=j}j=c[l>>2]|0;if(!j){h=1;i=e;return h|0}l=f+8|0;f=c[l>>2]|0;if((f|0)!=(j|0))c[l>>2]=f+(~((f+-4-j|0)>>>2)<<2);ACi(j);h=1;i=e;return h|0}case 1:case 0:{h=1;i=e;return h|0}default:{j=a+32|0;bVc(a,a+16|0,j,d)|0;d=a+48|0;if((d|0)==(b|0)){h=1;i=e;return h|0}f=g+4|0;l=g+4|0;k=g+8|0;m=0;n=0;o=d;d=j;while(1){j=c[o>>2]|0;if((j|0)<(c[d>>2]|0)){c[g>>2]=j;$Uc(f,o+4|0);j=c[d>>2]|0;p=o;q=d;while(1){c[p>>2]=j;if((p|0)!=(q|0))aVc(p+4|0,c[q+4>>2]|0,c[q+8>>2]|0);if((q|0)==(a|0)){r=q;s=22;break}t=q+-16|0;u=c[g>>2]|0;j=c[t>>2]|0;if((u|0)>=(j|0)){v=u;w=q;x=q;break}else{u=q;q=t;p=u}}if((s|0)==22){s=0;v=c[g>>2]|0;w=r;x=a}c[w>>2]=v;if((x|0)!=(g|0))aVc(x+4|0,c[l>>2]|0,c[k>>2]|0);p=n+1|0;if((p|0)==8){q=o+16|0;y=1;z=(q|0)==(b|0);A=q}else{y=0;z=m;A=o}q=c[l>>2]|0;if(q){j=c[k>>2]|0;if((j|0)!=(q|0))c[k>>2]=j+(~((j+-4-q|0)>>>2)<<2);ACi(q)}if(y){h=z;s=34;break}else{B=z;C=p;D=A}}else{B=m;C=n;D=o}o=D+16|0;if((o|0)==(b|0)){h=1;s=34;break}else{m=B;n=C;d=D}}if((s|0)==34){i=e;return h|0}}}return 0}function gVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;nVc(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{Vxc(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function hVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+4|0;h=c[g>>2]|0;j=c[b>>2]|0;k=h-j>>4;c[f>>2]=k;l=a+12|0;m=c[l>>2]|0;n=m+4|0;o=a+20|0;if(n>>>0<(c[o>>2]|0)>>>0){c[m>>2]=k;c[l>>2]=n;p=j;q=h}else{Gid(l,f,4);p=c[b>>2]|0;q=c[g>>2]|0}if((p|0)==(q|0)){i=d;return}g=p;do{Yxc(g,a);p=g+8|0;b=c[p>>2]|0;f=g+4|0;h=c[f>>2]|0;j=b-h>>2;c[e>>2]=j;n=c[l>>2]|0;k=n+4|0;if(k>>>0<(c[o>>2]|0)>>>0){c[n>>2]=j;c[l>>2]=k;r=h;s=b}else{Gid(l,e,4);r=c[f>>2]|0;s=c[p>>2]|0}if((r|0)!=(s|0)){p=r;do{Yxc(p,a);p=p+4|0}while((p|0)!=(s|0))}g=g+16|0}while((g|0)!=(q|0));i=d;return}function iVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,611712,c[142276]|0,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else dyc(a,b);sdd(b)}f=a+4|0;a=qdd(b,622128,c[142306]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else oVc(b,f,0);sdd(b);i=d;return}function jVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((c[e>>2]|0)-g>>4>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b<<4)|0;l=k+(j-g>>4<<4)|0;g=k+(b<<4)|0;if((j|0)!=(f|0)){b=j;j=l;while(1){k=b;b=b+-16|0;c[j+-16>>2]=c[b>>2];$Uc(j+-12|0,k+-12|0);k=j+-16|0;if((b|0)==(f|0)){m=k;break}else j=k}j=c[a>>2]|0;b=c[h>>2]|0;c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;if((b|0)==(j|0))n=j;else{m=b;do{b=c[m+-12>>2]|0;if(b){k=m+-8|0;o=c[k>>2]|0;if((o|0)!=(b|0))c[k>>2]=o+(~((o+-4-b|0)>>>2)<<2);ACi(b)}m=m+-16|0}while((m|0)!=(j|0));n=j}}else{c[a>>2]=l;c[h>>2]=l;c[e>>2]=g;n=f}if(!n){i=d;return}ACi(n);i=d;return}function kVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;f=c[b>>2]|0;g=c[d>>2]|0;h=f;j=g-h>>4;k=a+8|0;l=c[k>>2]|0;m=c[a>>2]|0;n=m;if(j>>>0>l-n>>4>>>0){if(!m)o=l;else{l=a+4|0;p=c[l>>2]|0;if((p|0)==(m|0))q=m;else{r=p;while(1){p=r+-16|0;c[l>>2]=p;s=c[r+-12>>2]|0;if(!s)t=p;else{p=r+-8|0;u=c[p>>2]|0;if((u|0)!=(s|0))c[p>>2]=u+(~((u+-4-s|0)>>>2)<<2);ACi(s);t=c[l>>2]|0}if((t|0)==(m|0))break;else r=t}q=c[a>>2]|0}ACi(q);c[k>>2]=0;c[l>>2]=0;c[a>>2]=0;o=0}if(j>>>0>268435455)vxi(a);l=o-0|0;if(l>>4>>>0<134217727){o=l>>3;l=o>>>0<j>>>0?j:o;if(l>>>0>268435455)vxi(a);else v=l}else v=268435455;l=xCi(v<<4)|0;o=a+4|0;c[o>>2]=l;c[a>>2]=l;c[k>>2]=l+(v<<4);v=c[b>>2]|0;b=c[d>>2]|0;if((v|0)==(b|0)){i=e;return}else{w=v;x=l}do{c[x>>2]=c[w>>2];$Uc(x+4|0,w+4|0);x=(c[o>>2]|0)+16|0;c[o>>2]=x;w=w+16|0}while((w|0)!=(b|0));i=e;return}b=a+4|0;a=(c[b>>2]|0)-n>>4;if(j>>>0>a>>>0){y=f+(a<<4)|0;z=1}else{y=g;z=0}if((f|0)==(y|0))A=m;else{a=(y+-16-h|0)>>>4;h=m;j=f;while(1){c[h>>2]=c[j>>2];if((h|0)!=(j|0))aVc(h+4|0,c[j+4>>2]|0,c[j+8>>2]|0);j=j+16|0;if((j|0)==(y|0))break;else h=h+16|0}A=m+(a+1<<4)|0}if(z){if((y|0)==(g|0)){i=e;return}z=c[b>>2]|0;a=y;do{if(!z)B=0;else{c[z>>2]=c[a>>2];$Uc(z+4|0,a+4|0);B=c[b>>2]|0}z=B+16|0;c[b>>2]=z;a=a+16|0}while((a|0)!=(g|0));i=e;return}g=c[b>>2]|0;if((g|0)==(A|0)){i=e;return}else C=g;while(1){g=C+-16|0;c[b>>2]=g;a=c[C+-12>>2]|0;if(!a)D=g;else{g=C+-8|0;z=c[g>>2]|0;if((z|0)!=(a|0))c[g>>2]=z+(~((z+-4-a|0)>>>2)<<2);ACi(a);D=c[b>>2]|0}if((D|0)==(A|0))break;else C=D}i=e;return}function lVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>4>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;m=c[g>>2]|0}l=m+16|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>4)+b|0;if(l>>>0>268435455)vxi(a);j=k;k=f-j|0;if(k>>4>>>0<134217727){f=k>>3;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>4;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=268435455;r=(c[g>>2]|0)-j>>4;s=10}if((s|0)==10){n=q;o=xCi(q<<4)|0;p=r}r=o+(p<<4)|0;p=b;b=r;while(1){if(!b)t=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;t=b}q=t+16|0;p=p+-1|0;if(!p){u=q;break}else b=q}b=o+(n<<4)|0;n=c[a>>2]|0;o=c[g>>2]|0;if((o|0)!=(n|0)){p=o;o=r;while(1){t=p;p=p+-16|0;c[o+-16>>2]=c[p>>2];$Uc(o+-12|0,t+-12|0);t=o+-16|0;if((p|0)==(n|0)){v=t;break}else o=t}o=c[a>>2]|0;p=c[g>>2]|0;c[a>>2]=v;c[g>>2]=u;c[e>>2]=b;if((p|0)==(o|0))w=o;else{v=p;do{p=c[v+-12>>2]|0;if(p){t=v+-8|0;q=c[t>>2]|0;if((q|0)!=(p|0))c[t>>2]=q+(~((q+-4-p|0)>>>2)<<2);ACi(p)}v=v+-16|0}while((v|0)!=(o|0));w=o}}else{c[a>>2]=r;c[g>>2]=u;c[e>>2]=b;w=n}if(!w){i=d;return}ACi(w);i=d;return}function mVc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;g=a+8|0;c[g>>2]=0;h=c[b>>2]|0;b=c[d>>2]|0;d=b-h|0;j=d>>4;if(!j){i=f;return}if(j>>>0>268435455)vxi(a);k=xCi(d)|0;c[e>>2]=k;c[a>>2]=k;c[g>>2]=k+(j<<4);if((h|0)==(b|0)){i=f;return}else{l=h;m=k}do{c[m>>2]=c[l>>2];$Uc(m+4|0,l+4|0);m=(c[e>>2]|0)+16|0;c[e>>2]=m;l=l+16|0}while((l|0)!=(b|0));i=f;return}function nVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d;l=a+4|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;p=m-o>>2;if(p>>>0>=b>>>0){if(p>>>0<=b>>>0){i=d;return}q=n+(b<<2)|0;c[k>>2]=0;r=k+4|0;c[r>>2]=0;s=k+8|0;c[s>>2]=0;t=b<<2;u=t>>2;if(u){if(u>>>0>1073741823)vxi(k);v=xCi(t)|0;c[r>>2]=v;c[k>>2]=v;w=v+(u<<2)|0;c[s>>2]=w;if(!b){x=v;y=v;z=w}else{u=t+-4|0;t=n;A=v;while(1){c[A>>2]=c[t>>2];t=t+4|0;if((t|0)==(q|0))break;else A=A+4|0}A=v+((u>>>2)+1<<2)|0;c[r>>2]=A;x=v;y=A;z=w}}else{x=0;y=0;z=0}w=c[a>>2]|0;c[k>>2]=w;c[a>>2]=x;x=c[l>>2]|0;c[r>>2]=x;c[l>>2]=y;y=a+8|0;c[s>>2]=c[y>>2];c[y>>2]=z;if(!w){i=d;return}if((x|0)!=(w|0))c[r>>2]=x+(~((x+-4-w|0)>>>2)<<2);ACi(w);i=d;return}w=a+8|0;if(((c[w>>2]|0)-o>>2|0)==(b|0)){qVc(a,b-p|0);i=d;return}c[g>>2]=0;p=g+4|0;c[p>>2]=0;o=g+8|0;c[o>>2]=0;if(b){x=xCi(b<<2)|0;c[g>>2]=x;c[p>>2]=x;c[o>>2]=x+(b<<2)}c[h>>2]=n;c[j>>2]=m;c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];pVc(g,f,e);e=c[p>>2]|0;f=c[g>>2]|0;j=e-f>>2;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<2)|0,(e|0)!=(h|0)):0){m=e+(~((e+-4-h|0)>>>2)<<2)|0;c[p>>2]=m;B=f;C=m}else{B=f;C=e}else{qVc(g,b-j|0);B=c[g>>2]|0;C=c[p>>2]|0}j=c[a>>2]|0;c[g>>2]=j;c[a>>2]=B;B=c[l>>2]|0;c[p>>2]=B;c[l>>2]=C;C=c[o>>2]|0;c[o>>2]=c[w>>2];c[w>>2]=C;if(!j){i=d;return}if((B|0)!=(j|0))c[p>>2]=B+(~((B+-4-j|0)>>>2)<<2);ACi(j);i=d;return}function oVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}nVc(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142276]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;dyc(s,a);u=s+4|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else dyc(n,a);sdd(a)}n=n+4|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function pVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b>>2]|0;b=c[d>>2]|0;d=f;g=b-d>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>2>>>0){if(!k)m=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>1073741823)vxi(a);j=m-0|0;if(j>>2>>>0<536870911){m=j>>1;j=m>>>0<g>>>0?g:m;if(j>>>0>1073741823)vxi(a);else o=j}else o=1073741823;j=xCi(o<<2)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(o<<2);if((f|0)==(b|0)){i=e;return}o=(b+-4-d|0)>>>2;h=f;n=j;while(1){c[n>>2]=c[h>>2];h=h+4|0;if((h|0)==(b|0))break;else n=n+4|0}c[m>>2]=j+(o+1<<2);i=e;return}o=a+4|0;a=c[o>>2]|0;j=a-l>>2;if(g>>>0>j>>>0){p=f+(j<<2)|0;q=1}else{p=b;q=0}if((f|0)==(p|0))r=k;else{j=(p+-4-d|0)>>>2;d=k;g=f;while(1){c[d>>2]=c[g>>2];g=g+4|0;if((g|0)==(p|0))break;else d=d+4|0}r=k+(j+1<<2)|0}if(!q){if((a|0)==(r|0)){i=e;return}c[o>>2]=a+(~((a+-4-r|0)>>>2)<<2);i=e;return}if((p|0)==(b|0)){i=e;return}r=(b+-4-p|0)>>>2;q=a;j=p;while(1){if(q)c[q>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else q=q+4|0}c[o>>2]=a+(r+1<<2);i=e;return}function qVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;while(1){if(l)c[l>>2]=0;k=k+-1|0;if(!k)break;else l=l+4|0}c[g>>2]=h+(b<<2);i=d;return}h=c[a>>2]|0;l=(j-h>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=h;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=c[g>>2]|0;l=f-j>>2;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=c[g>>2]|0;q=1073741823;r=f-j>>2;s=f;t=11}if((t|0)==11){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;r=b;q=s;while(1){if(q)c[q>>2]=0;r=r+-1|0;if(!r)break;else q=q+4|0}q=n+(m<<2)|0;m=n+(o+b<<2)|0;if((p|0)==(h|0)){u=s;v=h}else{b=p+-4-j|0;j=p;p=s;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(h|0))break;else p=p+-4|0}u=n+(o+~(b>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[g>>2]=m;c[e>>2]=q;if(!v){i=d;return}ACi(v);i=d;return}function rVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;CQb(1,f,0)|0;h=c[f>>2]|0;j=c[g>>2]|0;if((h|0)==(j|0)){k=h;l=h}else{m=a+8|0;n=a+12|0;o=a+4|0;p=h;h=j;while(1){j=c[p>>2]|0;if(!(c[j+8>>2]&1114112)){q=c[j+4>>2]|0;j=(c[m>>2]|0)+1|0;c[m>>2]=j;r=c[n>>2]|0;s=r&2147483647;if(j>>>0>s>>>0){t=r<<1;u=(t|0)==0?1:t;do if(s>>>0<u>>>0)if((r|0)>-1){c[n>>2]=u;t=c[a>>2]|0;c[e>>2]=c[o>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(t,u<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[o>>2];c[d+0>>2]=c[e+0>>2];t=cOb(u<<2,4,d,0,3653512,352)|0;YEi(t|0,c[a>>2]|0,c[m>>2]<<2|0)|0;c[n>>2]=u;c[a>>2]=t;break}while(0);v=c[g>>2]|0;w=c[m>>2]|0}else{v=h;w=j}c[(c[a>>2]|0)+(w+-1<<2)>>2]=q;x=v}else x=h;p=p+4|0;if((p|0)==(x|0)){y=x;break}else h=x}k=c[f>>2]|0;l=y}if(!k){i=b;return}if((l|0)!=(k|0))c[g>>2]=l+(~((l+-4-k|0)>>>2)<<2);ACi(k);i=b;return}function sVc(){var a=0,b=0;a=i;obh();IQb();Tsd();TTb();sVb();Fzc();b=xbc()|0;wbc(b);vqc(b);DCc();WHc();JQb();i=a;return 1}function tVc(b){b=b|0;var d=0,e=0;b=i;i=i+16|0;d=b;if(a[611776]|0){e=1;i=b;return e|0}c[d>>2]=611816;Ird(611784,d);if(!(xqc()|0)){e=0;i=b;return e|0}Ond();tvd();KQb();STb();lUc();Bld();if(y2b()|0)m2b(x2b()|0);a[611776]=1;vqc((kbc()|0)+512|0);e=1;i=b;return e|0}function uVc(){var a=0,b=0;a=i;vqc((kbc()|0)+320|0);Izc(Gzc()|0,0);b=ync()|0;ko[c[(c[b>>2]|0)+8>>2]&4095](b);Prd();m8b();b=hSb(9)|0;if(b)In[c[(c[b>>2]|0)+12>>2]&4095](b,0);b=elc()|0;In[c[(c[b>>2]|0)+100>>2]&4095](b,16);uyc(pyc()|0,-1,0);i=a;return}function vVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[(Vwc()|0)+76>>2]|0;if(!f){i=b;return}g=a+88|0;if(!(c[g>>2]|0)){i=b;return}h=a+80|0;a=0;do{c[e>>2]=c[(c[h>>2]|0)+(a*12|0)+4>>2];j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if(((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)?(k=(da(c[137788]|0,(c[j+8>>2]|0)>>>21)|0)+25|0,l=k>>5,(1<<k-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0):0){l=j+28|0;k=l+36|0;n=c[k>>2]|0;if((n&65534|0)==254)o=n;else{EAc(j,(Z_b(l,0)|0)+f|0,0);o=c[k>>2]|0}if((o&-131072|0)!=16646144)EAc(j,(Z_b(l,0)|0)+f|0,1)}}a=a+1|0}while(a>>>0<(c[g>>2]|0)>>>0);i=b;return}function wVc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+12|0;g=CVc(b)|0;if(!g){i=d;return}h=g+68|0;if(c[g+76>>2]|0){j=Hwc(Vwc()|0)|0;k=Hwc(g)|0;if((k|0)!=(j|0)){l=c[589392+(j<<2)>>2]|0;j=c[589392+(k<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=l;Lsd(f,611840,e);if(!(a[f>>0]&1))m=f+1|0;else m=c[f+8>>2]|0;Krd(m,0,3653512,565,512,0,0,0);xri(f)}vVc(b);Gwc(Vwc()|0,h)}lQc(g,0);i=d;return}function xVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;ged(b);f=kbc()|0;g=0;do{h=c[f+(g<<2)+192>>2]|0;if(h)co[h&2047](a,b,d);g=g+1|0}while((g|0)!=16);ked(b);g=kbc()|0;f=0;do{h=c[g+(f<<2)+256>>2]|0;if(h)co[h&2047](a,b,d);f=f+1|0}while((f|0)!=16);wVc(b);i=e;return}function yVc(a){a=a|0;return}function zVc(a){a=a|0;return}function AVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;xVb();ged(a);BVb(a);rri(d,611760,SEi(611760)|0);e=kbc()|0;f=0;do{g=c[e+(f<<2)+192>>2]|0;if(g)co[g&2047](d,a,2);f=f+1|0}while((f|0)!=16);ked(a);f=kbc()|0;e=0;do{g=c[f+(e<<2)+256>>2]|0;if(g)co[g&2047](d,a,2);e=e+1|0}while((e|0)!=16);xri(d);d=hSb(9)|0;if(d)In[c[(c[d>>2]|0)+12>>2]&4095](d,0);d=elc()|0;In[c[(c[d>>2]|0)+100>>2]&4095](d,16);uyc(pyc()|0,-1,0);m8b();i=b;return}function BVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;ged(b);BVb(b);e=kbc()|0;f=0;do{g=c[e+(f<<2)+192>>2]|0;if(g)co[g&2047](a,b,0);f=f+1|0}while((f|0)!=16);ked(b);f=kbc()|0;e=0;do{g=c[f+(e<<2)+256>>2]|0;if(g)co[g&2047](a,b,0);e=e+1|0}while((e|0)!=16);uVc();i=d;return}function CVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+8|0;if(!(c[f>>2]|0)){g=0;i=b;return g|0}h=0;a:while(1){j=c[(c[a>>2]|0)+(h*12|0)+4>>2]|0;do if(j){c[e>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,e);l=c[d>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[n+4>>2]|0,(k|0)!=0):0)o=k;else p=12}else p=12;if((p|0)==12){p=0;k=hQb(j)|0;if(!k)break;else o=k}k=(da(c[137788]|0,(c[o+8>>2]|0)>>>21)|0)+157|0;l=k>>5;if(!((o|0)==0?1:(1<<k-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)==0)){q=o;break a}}while(0);h=h+1|0;if(h>>>0>=(c[f>>2]|0)>>>0){g=0;p=16;break}}if((p|0)==16){i=b;return g|0}g=q;i=b;return g|0}function DVc(){var a=0,b=0,d=0,e=0,f=0,g=0.0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;a=i;i=i+32|0;b=a;d=a+28|0;e=a+24|0;f=a+8|0;g=+Ki()*1.0e6;j=~~g>>>0;l=+S(g)>=1.0?(g>0.0?(ha(+R(g/4294967296.0),4294967295.0)|0)>>>0:~~+ca((g-+(~~g>>>0))/4294967296.0)>>>0):0;c[f>>2]=0;m=f+8|0;c[m>>2]=0;n=f+12|0;c[n>>2]=0;o=f+4|0;c[o>>2]=60;rVc(f);p=c[f>>2]|0;if(!(c[m>>2]|0)){q=0;r=p}else{s=p;do{c[e>>2]=c[s>>2];p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(b,p,e);t=c[b>>2]|0;u=c[p+28>>2]|0;if((t|0)==-1){v=u+(c[p+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[v+4>>2]|0,(p|0)!=0):0)?(t=(da(c[137788]|0,(c[p+8>>2]|0)>>>21)|0)+1|0,u=t>>5,(1<<t-(u<<5)&c[(c[137786]|0)+(u<<2)>>2]|0)!=0):0)?(c[(BTb(p)|0)+156>>2]|0)==0:0)lQc(p,0)}s=s+4|0;p=c[f>>2]|0;u=c[m>>2]|0}while((s|0)!=(p+(u<<2)|0));q=u;r=p}if(!q)w=r;else{q=r;do{c[d>>2]=c[q>>2];r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(b,r,d);s=c[b>>2]|0;v=c[r+28>>2]|0;if((s|0)==-1){x=v+(c[r+32>>2]<<3)|0;break}else{x=v+(s<<3)|0;break}}else x=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((x|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0))y=c[x+4>>2]|0;else y=0}else y=0;lQc(y,0);q=q+4|0;r=c[f>>2]|0}while((q|0)!=(r+(c[m>>2]<<2)|0));w=r}if((c[n>>2]|0)>-1){c[d>>2]=c[o>>2];c[b+0>>2]=c[d+0>>2];eOb(w,b);c[f>>2]=0}c[m>>2]=0;c[n>>2]=0;wVb(f,0);if(c[m>>2]|0){w=c[f>>2]|0;do{c[d>>2]=c[w>>2];q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(b,q,d);y=c[b>>2]|0;x=c[q+28>>2]|0;if((y|0)==-1){z=x+(c[q+32>>2]<<3)|0;break}else{z=x+(y<<3)|0;break}}else z=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((z|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0))A=c[z+4>>2]|0;else A=0}else A=0;lQc(A,0);w=w+4|0}while((w|0)!=((c[f>>2]|0)+(c[m>>2]<<2)|0))}vqc((kbc()|0)+128|0);g=+Ki()*1.0e6;m=ZEi(~~g>>>0|0,(+S(g)>=1.0?(g>0.0?(ha(+R(g/4294967296.0),4294967295.0)|0)>>>0:~~+ca((g-+(~~g>>>0))/4294967296.0)>>>0):0)|0,j|0,l|0)|0;l=Ycd(m,H)|0;g=+ea(ea((+(l>>>0)+4294967296.0*+(H>>>0))*1.0e-09)*ea(1.0e3));h[k>>3]=g;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Ird(611952,b);if((c[n>>2]|0)<=-1){i=a;return}n=c[f>>2]|0;c[d>>2]=c[o>>2];c[b+0>>2]=c[d+0>>2];eOb(n,b);c[f>>2]=0;i=a;return}function EVc(){return 17}function FVc(a){a=a|0;return (a+-3|0)>>>0<3|0}function GVc(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;j=i;k=c[d>>2]|0;l=c[f>>2]|0;a:do if(k>>>0<e>>>0){m=(h|0)==0;n=k;o=l;b:while(1){p=a[n>>0]|0;q=p&255;r=a[611976+q>>0]|0;s=r&65535;if((n+s|0)>>>0>=e>>>0){t=1;u=n;v=o;break a}if((s|0)==3){w=a[n+3>>0]|0;if(w<<24>>24>-1|(w&255)>191){t=3;u=n;v=o;break a}else x=6}else if((s|0)==2)x=6;else if((s|0)==1)x=7;else if(s){t=3;u=n;v=o;break a}if((x|0)==6){x=0;w=a[n+2>>0]|0;if(w<<24>>24>-1|(w&255)>191){t=3;u=n;v=o;break a}else x=7}do if((x|0)==7){x=0;w=a[n+1>>0]|0;if((w&255)>191){t=3;u=n;v=o;break a}if((q|0)==240)if((w&255)<144){t=3;u=n;v=o;break a}else break;else if((q|0)==224)if((w&255)<160){t=3;u=n;v=o;break a}else break;else if((q|0)==237)if((w&255)>159){t=3;u=n;v=o;break a}else break;else if((q|0)==244)if((w&255)>143){t=3;u=n;v=o;break a}else break;else if(w<<24>>24>-1){t=3;u=n;v=o;break a}else break}while(0);if(!(((p&255)>193|p<<24>>24>-1)&(p&255)<245)){t=3;u=n;v=o;break a}switch(s|0){case 3:{y=p;z=0;A=n;x=18;break}case 4:{B=p;C=0;D=n;x=17;break}case 5:{w=n+1|0;B=a[w>>0]|0;C=q<<6;D=w;x=17;break}case 2:{E=p;F=0;G=n;x=19;break}case 1:{H=p;I=0;J=n;x=20;break}case 0:{K=p;L=0;M=n;x=21;break}default:{N=0;O=n}}if((x|0)==17){x=0;w=D+1|0;y=a[w>>0]|0;z=(B&255)+C<<6;A=w;x=18}if((x|0)==18){x=0;w=A+1|0;E=a[w>>0]|0;F=(y&255)+z<<6;G=w;x=19}if((x|0)==19){x=0;w=G+1|0;H=a[w>>0]|0;I=(E&255)+F<<6;J=w;x=20}if((x|0)==20){x=0;w=J+1|0;K=a[w>>0]|0;L=(H&255)+I<<6;M=w;x=21}if((x|0)==21){x=0;N=(K&255)+L|0;O=M+1|0}w=N-(c[612232+(s<<2)>>2]|0)|0;do if(w>>>0>=65536)if(w>>>0>1114111){if(m){P=r;Q=O;R=o;x=30;break b}b[o>>1]=-3;S=o+2|0;break}else{T=o+2|0;if(T>>>0>=g>>>0){U=r;V=O;W=o;x=34;break b}X=w+-65536|0;b[o>>1]=(X>>>10)+55296;b[T>>1]=X&1023|56320;S=o+4|0;break}else{if((w&-2048|0)!=55296){b[o>>1]=w;S=o+2|0;break}if(m){Y=r;Z=O;_=o;x=25;break b}b[o>>1]=-3;S=o+2|0}while(0);if(O>>>0<e>>>0){n=O;o=S}else{t=0;u=O;v=S;break a}}if((x|0)==25){t=3;u=Z+((Y|-65536)^65535)|0;v=_;break}else if((x|0)==30){t=3;u=Q+((P|-65536)^65535)|0;v=R;break}else if((x|0)==34){t=2;u=V+((U|-65536)^65535)|0;v=W;break}}else{t=0;u=k;v=l}while(0);c[d>>2]=u;c[f>>2]=v;i=j;return t|0}function HVc(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;l=c[e>>2]|0;m=c[g>>2]|0;a:do if(l>>>0<f>>>0){if(!j){n=l;o=m}else{p=l;q=m;while(1){r=p+2|0;s=b[p>>1]|0;t=s&65535;if((s&-1024)<<16>>16==-10240&r>>>0<f>>>0?(s=b[r>>1]|0,(s&-1024)<<16>>16==-9216):0){u=(t<<10)+-56613888+(s&65535)|0;v=p+4|0}else{u=t;v=r}if(u>>>0>=128)if(u>>>0>=2048)if(u>>>0<65536){w=3;x=u}else{r=u>>>0<2097152;w=r?4:2;x=r?u:65533}else{w=2;x=u}else{w=1;x=u}if((q+w|0)>>>0>h>>>0){y=2;z=p;A=q;break a}if((w|0)==1){B=x;C=30}else if((w|0)==2){D=x;C=29}else if((w|0)==3){E=x;C=28}else if((w|0)==4){a[q+3>>0]=x&63|128;E=x>>>6;C=28}else F=w;if((C|0)==28){C=0;a[q+2>>0]=E&63|128;D=E>>>6;C=29}if((C|0)==29){C=0;a[q+1>>0]=D&63|128;B=D>>>6;C=30}if((C|0)==30){C=0;a[q>>0]=d[612256+w>>0]|0|B;F=0}r=q+(F+w)|0;if(v>>>0<f>>>0){p=v;q=r}else{y=0;z=v;A=r;break a}}}while(1){q=n+2|0;p=b[n>>1]|0;r=p&65535;t=p&-1024;if(!(t<<16>>16==-10240&q>>>0<f>>>0))if(t<<16>>16==-9216){y=3;z=n;A=o;break a}else{G=r;H=q}else{t=b[q>>1]|0;if((t&-1024)<<16>>16!=-9216){y=3;z=n;A=o;break a}G=(r<<10)+-56613888+(t&65535)|0;H=n+4|0}if(G>>>0>=128)if(G>>>0>=2048)if(G>>>0<65536){I=3;J=G}else{t=G>>>0<2097152;I=t?4:2;J=t?G:65533}else{I=2;J=G}else{I=1;J=G}if((o+I|0)>>>0>h>>>0){y=2;z=n;A=o;break a}if((I|0)==1){K=J;C=16}else if((I|0)==4){a[o+3>>0]=J&63|128;L=J>>>6;C=14}else if((I|0)==2){M=J;C=15}else if((I|0)==3){L=J;C=14}else N=I;if((C|0)==14){C=0;a[o+2>>0]=L&63|128;M=L>>>6;C=15}if((C|0)==15){C=0;a[o+1>>0]=M&63|128;K=M>>>6;C=16}if((C|0)==16){C=0;a[o>>0]=d[612256+I>>0]|0|K;N=0}t=o+(N+I)|0;if(H>>>0<f>>>0){n=H;o=t}else{y=0;z=H;A=t;break}}}else{y=0;z=l;A=m}while(0);c[e>>2]=z;c[g>>2]=A;i=k;return y|0}function IVc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=d;c[h>>2]=a;if((GVc(h,a+b|0,g,d+(b<<1)|0,1)|0)==3){j=0;k=0;c[e>>2]=k;i=f;return j|0}j=1;k=(c[g>>2]|0)-d>>1;c[e>>2]=k;i=f;return j|0}function JVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a[b>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[b+4>>2]|0;h=d+8|0;c[h>>2]=j;k=d+12|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<j>>>0)if((l|0)>-1){c[k>>2]=j;m=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(m,j<<1,2,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];m=cOb(j<<1,2,f,0,3653512,352)|0;YEi(m|0,c[d>>2]|0,c[h>>2]<<1|0)|0;c[k>>2]=j;c[d>>2]=m;break}while(0);j=a[b>>0]|0;if(!(j&1)){n=b+1|0;o=(j&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=c[d>>2]|0;c[f>>2]=b;c[g>>2]=n;if((GVc(g,n+o|0,f,b+(o<<1)|0,1)|0)==3){p=0;q=0}else{p=1;q=(c[f>>2]|0)-b>>1}c[h>>2]=q;b=c[k>>2]|0;if((b&2147483647)>>>0>=q>>>0){i=e;return p|0}if((b|0)>-1){c[k>>2]=q;b=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(b,q<<1,2,f,0,3653512,370)|0;i=e;return p|0}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];g=cOb(q<<1,2,f,0,3653512,352)|0;YEi(g|0,c[d>>2]|0,c[h>>2]<<1|0)|0;c[k>>2]=q;c[d>>2]=g;i=e;return p|0}return 0}function KVc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=d;c[h>>2]=a;if((HVc(h,a+(b<<1)|0,g,d+(b<<2)|0,1)|0)==3){j=0;k=0;c[e>>2]=k;i=f;return j|0}j=1;k=(c[g>>2]|0)-d|0;c[e>>2]=k;i=f;return j|0}function LVc(){c[153066]=1;c[153068]=2;c[153070]=4;c[153072]=6;c[153074]=8;c[153076]=13;c[153078]=14;c[153080]=16;c[153082]=17;c[153084]=18;c[153086]=19;c[153088]=23;c[153090]=24;c[153092]=25;c[153094]=26;c[153096]=27;c[153098]=28;c[153100]=30;c[153102]=31;c[153104]=40;c[153106]=42;c[153108]=43;c[153110]=44;c[153112]=46;c[153114]=52;c[153116]=54;c[153118]=58;c[153120]=60;c[153122]=61;c[153124]=62;c[153126]=64;c[153128]=67;c[153130]=68;c[153132]=71;c[153134]=89;c[153136]=90;c[153138]=91;return}function MVc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=e+4|0;if(!(c[h>>2]|0)){a[b>>0]=1;c[b+4>>2]=0;c[b+8>>2]=0;i=g;return}j=Nsc(d)|0;k=c[(c[h>>2]|0)+((a[e>>0]|0)!=0?j:j+-8|0)>>2]|0;j=$sc(Osc(d)|0)|0;if(!k){l=ds(j)|0;Wrc(l);if(f){f=Nsc(d)|0;c[(c[h>>2]|0)+((a[e>>0]|0)!=0?f:f+-8|0)>>2]=l;m=l}else m=l}else m=k;a[b>>0]=1;c[b+4>>2]=m;c[b+8>>2]=j;i=g;return}function NVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[153104]|0;if(a){h=a+8|0;j=a+148|0;do{if((c[j+-4>>2]|0)>-1){k=j+-16|0;l=c[k>>2]|0;c[e>>2]=c[j+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[k>>2]=0}j=j+-20|0}while((j|0)!=(h|0))}c[f>>2]=g;c[d+0>>2]=c[f+0>>2];eOb(a,d);i=b;return}function OVc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+208|0;h=g+196|0;j=g+192|0;k=g+172|0;l=g+152|0;m=g+8|0;n=g;if(!d){o=0;i=g;return o|0}p=d+36|0;q=c[p>>2]|0;do if(!q){r=c[d+4>>2]|0;c[n>>2]=c[153104];c[h+0>>2]=c[n+0>>2];s=bOb(148,h,0,16,3653512,106)|0;t=s+4|0;c[s+12>>2]=0;c[s+20>>2]=0;c[s+24>>2]=0;c[s+0>>2]=0;c[s+4>>2]=0;b[s+8>>1]=0;c[s+16>>2]=60;a[s+28>>0]=0;a[s+29>>0]=0;c[s+32>>2]=0;c[s+40>>2]=0;c[s+44>>2]=0;c[s+36>>2]=60;a[s+48>>0]=0;a[s+49>>0]=0;c[s+52>>2]=0;c[s+60>>2]=0;c[s+64>>2]=0;c[s+56>>2]=60;a[s+68>>0]=0;a[s+69>>0]=0;c[s+72>>2]=0;c[s+80>>2]=0;c[s+84>>2]=0;c[s+76>>2]=60;a[s+88>>0]=0;a[s+89>>0]=0;c[s+92>>2]=0;c[s+100>>2]=0;c[s+104>>2]=0;c[s+96>>2]=60;a[s+108>>0]=0;a[s+109>>0]=0;c[s+112>>2]=0;c[s+120>>2]=0;c[s+124>>2]=0;c[s+116>>2]=60;a[s+128>>0]=0;a[s+129>>0]=0;c[s+132>>2]=0;c[s+140>>2]=0;c[s+144>>2]=0;c[s+136>>2]=60;c[m>>2]=0;c[m+4>>2]=0;tid(m+12|0);c[k>>2]=r;c[k+4>>2]=r;c[k+8>>2]=(Xbd()|0)+36;c[k+12>>2]=0;b[k+16>>1]=1;c[l>>2]=0;c[l+8>>2]=0;u=l+12|0;c[u>>2]=0;v=l+4|0;c[v>>2]=60;w=l+16|0;a[w>>0]=a[f>>0]|0;YVc(k,l,s,0);x=c[t>>2]|0;c[t>>2]=x+1;ZVc(s+(x*20|0)+12|0,l)|0;y=s+(x*20|0)+8|0;a[y>>0]=1;a[y+1>>0]=0;a[f>>0]=(a[f>>0]|0)==0?a[w>>0]|0:1;if((c[u>>2]|0)>-1){u=c[l>>2]|0;c[j>>2]=c[v>>2];c[h+0>>2]=c[j+0>>2];eOb(u,h);c[l>>2]=0}c[k>>2]=r;c[k+4>>2]=r;c[k+8>>2]=(Xbd()|0)+36;c[k+12>>2]=0;b[k+16>>1]=3;c[l>>2]=0;c[l+8>>2]=0;u=l+12|0;c[u>>2]=0;v=l+4|0;c[v>>2]=60;w=l+16|0;a[w>>0]=a[f>>0]|0;_Vc(k,l,s,0);y=c[t>>2]|0;c[t>>2]=y+1;ZVc(s+(y*20|0)+12|0,l)|0;x=s+(y*20|0)+8|0;a[x>>0]=3;a[x+1>>0]=0;a[f>>0]=(a[f>>0]|0)==0?a[w>>0]|0:1;if((c[u>>2]|0)>-1){u=c[l>>2]|0;c[j>>2]=c[v>>2];c[h+0>>2]=c[j+0>>2];eOb(u,h);c[l>>2]=0}c[k>>2]=r;c[k+4>>2]=r;c[k+8>>2]=(Xbd()|0)+36;c[k+12>>2]=0;b[k+16>>1]=6;c[l>>2]=0;c[l+8>>2]=0;u=l+12|0;c[u>>2]=0;v=l+4|0;c[v>>2]=60;w=l+16|0;a[w>>0]=a[f>>0]|0;$Vc(k,l,s,0);x=c[t>>2]|0;c[t>>2]=x+1;ZVc(s+(x*20|0)+12|0,l)|0;y=s+(x*20|0)+8|0;a[y>>0]=6;a[y+1>>0]=0;a[f>>0]=(a[f>>0]|0)==0?a[w>>0]|0:1;if((c[u>>2]|0)>-1){u=c[l>>2]|0;c[j>>2]=c[v>>2];c[h+0>>2]=c[j+0>>2];eOb(u,h);c[l>>2]=0}c[k>>2]=r;c[k+4>>2]=r;c[k+8>>2]=(Xbd()|0)+36;c[k+12>>2]=0;b[k+16>>1]=263;c[l>>2]=0;c[l+8>>2]=0;u=l+12|0;c[u>>2]=0;v=l+4|0;c[v>>2]=60;w=l+16|0;a[w>>0]=a[f>>0]|0;aWc(k,l,s,0);y=c[t>>2]|0;c[t>>2]=y+1;ZVc(s+(y*20|0)+12|0,l)|0;x=s+(y*20|0)+8|0;a[x>>0]=7;a[x+1>>0]=1;a[f>>0]=(a[f>>0]|0)==0?a[w>>0]|0:1;if((c[u>>2]|0)>-1){u=c[l>>2]|0;c[j>>2]=c[v>>2];c[h+0>>2]=c[j+0>>2];eOb(u,h);c[l>>2]=0}c[m>>2]=0;c[m+4>>2]=0;tid(m+12|0);c[m+72>>2]=0;c[m+76>>2]=0;u=m+88|0;v=u+48|0;do{c[u>>2]=0;u=u+4|0}while((u|0)<(v|0));c[k>>2]=r;c[k+4>>2]=r;c[k+8>>2]=(Xbd()|0)+36;c[k+12>>2]=0;b[k+16>>1]=5;c[l>>2]=0;c[l+8>>2]=0;u=l+12|0;c[u>>2]=0;v=l+4|0;c[v>>2]=60;w=l+16|0;a[w>>0]=a[f>>0]|0;bWc(k,l,s,0);x=c[t>>2]|0;c[t>>2]=x+1;ZVc(s+(x*20|0)+12|0,l)|0;y=s+(x*20|0)+8|0;a[y>>0]=5;a[y+1>>0]=0;a[f>>0]=(a[f>>0]|0)==0?a[w>>0]|0:1;if((c[u>>2]|0)>-1){u=c[l>>2]|0;c[j>>2]=c[v>>2];c[h+0>>2]=c[j+0>>2];eOb(u,h);c[l>>2]=0}odd(m);if(!(c[p>>2]|0)){c[p>>2]=s;z=s;break}NVc(s);o=OVc(d,e,f)|0;i=g;return o|0}else z=q;while(0);q=c[z+4>>2]|0;if(!q){o=0;i=g;return o|0}f=a[e>>0]|0;d=a[e+1>>0]|0;e=0;while(1){if((a[z+(e*20|0)+8>>0]|0)==f<<24>>24?(a[z+(e*20|0)+9>>0]|0)==d<<24>>24:0){A=e;break}e=e+1|0;if((e|0)==(q|0)){o=0;B=22;break}}if((B|0)==22){i=g;return o|0}o=z+(A*20|0)+12|0;i=g;return o|0}function PVc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+64|0;k=h+40|0;l=h+88|0;m=h+93|0;n=h+60|0;o=h;p=h+20|0;q=h+90|0;a[l>>0]=3;a[l+1>>0]=0;a[m>>0]=0;r=OVc(g,l,m)|0;c[n>>2]=0;c[o>>2]=0;c[o+8>>2]=0;m=o+12|0;c[m>>2]=0;g=o+4|0;c[g>>2]=60;a[o+16>>0]=0;if(!r){c[p>>2]=f;c[p+4>>2]=f;c[p+8>>2]=(Xbd()|0)+36;c[p+12>>2]=0;b[p+16>>1]=b[l>>1]|0;_Vc(p,o,n,0);s=o}else s=r;r=c[s>>2]|0;n=c[s+8>>2]|0;s=r+(n<<6)|0;p=k+4|0;c[p>>2]=r;c[k>>2]=r;l=k+8|0;c[l>>2]=s;t=n<<6>>6;c[k+16>>2]=t;u=k+12|0;c[u>>2]=t;c[j+16>>2]=d;a[j>>0]=1;d=j+1|0;a[d+0>>0]=a[q+0>>0]|0;a[d+1>>0]=a[q+1>>0]|0;a[d+2>>0]=a[q+2>>0]|0;c[j+4>>2]=e;c[j+8>>2]=f;c[j+12>>2]=k;if(n){n=r;r=s;do{s=n+64|0;c[p>>2]=s;c[u>>2]=r-s>>6;In[c[n>>2]&4095](n+4|0,j);n=c[p>>2]|0;r=c[l>>2]|0}while((n|0)!=(r|0))}if((c[m>>2]|0)<=-1){i=h;return}m=c[o>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];eOb(m,j);c[o>>2]=0;i=h;return}function QVc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+64|0;k=h+40|0;l=h+88|0;m=h+93|0;n=h+60|0;o=h;p=h+20|0;q=h+90|0;a[l>>0]=1;a[l+1>>0]=0;a[m>>0]=0;r=OVc(g,l,m)|0;c[n>>2]=0;c[o>>2]=0;c[o+8>>2]=0;m=o+12|0;c[m>>2]=0;g=o+4|0;c[g>>2]=60;a[o+16>>0]=0;if(!r){c[p>>2]=f;c[p+4>>2]=f;c[p+8>>2]=(Xbd()|0)+36;c[p+12>>2]=0;b[p+16>>1]=b[l>>1]|0;YVc(p,o,n,0);s=o}else s=r;r=c[s>>2]|0;n=c[s+8>>2]|0;s=r+(n<<6)|0;p=k+4|0;c[p>>2]=r;c[k>>2]=r;l=k+8|0;c[l>>2]=s;t=n<<6>>6;c[k+16>>2]=t;u=k+12|0;c[u>>2]=t;c[j+16>>2]=d;a[j>>0]=1;d=j+1|0;a[d+0>>0]=a[q+0>>0]|0;a[d+1>>0]=a[q+1>>0]|0;a[d+2>>0]=a[q+2>>0]|0;c[j+4>>2]=e;c[j+8>>2]=f;c[j+12>>2]=k;if(n){n=r;r=s;do{s=n+64|0;c[p>>2]=s;c[u>>2]=r-s>>6;In[c[n>>2]&4095](n+4|0,j);n=c[p>>2]|0;r=c[l>>2]|0}while((n|0)!=(r|0))}if((c[m>>2]|0)<=-1){i=h;return}m=c[o>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];eOb(m,j);c[o>>2]=0;i=h;return}function RVc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+64|0;k=h+40|0;l=h+88|0;m=h+93|0;n=h+60|0;o=h;p=h+20|0;q=h+90|0;a[l>>0]=7;a[l+1>>0]=1;a[m>>0]=0;r=OVc(g,l,m)|0;c[n>>2]=0;c[o>>2]=0;c[o+8>>2]=0;m=o+12|0;c[m>>2]=0;g=o+4|0;c[g>>2]=60;a[o+16>>0]=0;if(!r){c[p>>2]=f;c[p+4>>2]=f;c[p+8>>2]=(Xbd()|0)+36;c[p+12>>2]=0;b[p+16>>1]=b[l>>1]|0;aWc(p,o,n,0);s=o}else s=r;r=c[s>>2]|0;n=c[s+8>>2]|0;s=r+(n<<6)|0;p=k+4|0;c[p>>2]=r;c[k>>2]=r;l=k+8|0;c[l>>2]=s;t=n<<6>>6;c[k+16>>2]=t;u=k+12|0;c[u>>2]=t;c[j+16>>2]=d;a[j>>0]=1;d=j+1|0;a[d+0>>0]=a[q+0>>0]|0;a[d+1>>0]=a[q+1>>0]|0;a[d+2>>0]=a[q+2>>0]|0;c[j+4>>2]=e;c[j+8>>2]=f;c[j+12>>2]=k;if(n){n=r;r=s;do{s=n+64|0;c[p>>2]=s;c[u>>2]=r-s>>6;In[c[n>>2]&4095](n+4|0,j);n=c[p>>2]|0;r=c[l>>2]|0}while((n|0)!=(r|0))}if((c[m>>2]|0)<=-1){i=h;return}m=c[o>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];eOb(m,j);c[o>>2]=0;i=h;return}function SVc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+64|0;k=h+40|0;l=h+88|0;m=h+93|0;n=h+60|0;o=h;p=h+20|0;q=h+90|0;a[l>>0]=6;a[l+1>>0]=0;a[m>>0]=0;r=OVc(g,l,m)|0;c[n>>2]=0;c[o>>2]=0;c[o+8>>2]=0;m=o+12|0;c[m>>2]=0;g=o+4|0;c[g>>2]=60;a[o+16>>0]=0;if(!r){c[p>>2]=f;c[p+4>>2]=f;c[p+8>>2]=(Xbd()|0)+36;c[p+12>>2]=0;b[p+16>>1]=b[l>>1]|0;$Vc(p,o,n,0);s=o}else s=r;r=c[s>>2]|0;n=c[s+8>>2]|0;s=r+(n<<6)|0;p=k+4|0;c[p>>2]=r;c[k>>2]=r;l=k+8|0;c[l>>2]=s;t=n<<6>>6;c[k+16>>2]=t;u=k+12|0;c[u>>2]=t;c[j+16>>2]=d;a[j>>0]=1;d=j+1|0;a[d+0>>0]=a[q+0>>0]|0;a[d+1>>0]=a[q+1>>0]|0;a[d+2>>0]=a[q+2>>0]|0;c[j+4>>2]=e;c[j+8>>2]=f;c[j+12>>2]=k;if(n){n=r;r=s;do{s=n+64|0;c[p>>2]=s;c[u>>2]=r-s>>6;In[c[n>>2]&4095](n+4|0,j);n=c[p>>2]|0;r=c[l>>2]|0}while((n|0)!=(r|0))}if((c[m>>2]|0)<=-1){i=h;return}m=c[o>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];eOb(m,j);c[o>>2]=0;i=h;return}function TVc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+64|0;k=h+40|0;l=h+88|0;m=h+93|0;n=h+60|0;o=h;p=h+20|0;q=h+90|0;a[l>>0]=5;a[l+1>>0]=0;a[m>>0]=0;r=OVc(g,l,m)|0;c[n>>2]=0;c[o>>2]=0;c[o+8>>2]=0;m=o+12|0;c[m>>2]=0;g=o+4|0;c[g>>2]=60;a[o+16>>0]=0;if(!r){c[p>>2]=f;c[p+4>>2]=f;c[p+8>>2]=(Xbd()|0)+36;c[p+12>>2]=0;b[p+16>>1]=b[l>>1]|0;bWc(p,o,n,0);s=o}else s=r;r=c[s>>2]|0;n=c[s+8>>2]|0;s=r+(n<<6)|0;p=k+4|0;c[p>>2]=r;c[k>>2]=r;l=k+8|0;c[l>>2]=s;t=n<<6>>6;c[k+16>>2]=t;u=k+12|0;c[u>>2]=t;c[j+16>>2]=d;a[j>>0]=1;d=j+1|0;a[d+0>>0]=a[q+0>>0]|0;a[d+1>>0]=a[q+1>>0]|0;a[d+2>>0]=a[q+2>>0]|0;c[j+4>>2]=e;c[j+8>>2]=f;c[j+12>>2]=k;if(n){n=r;r=s;do{s=n+64|0;c[p>>2]=s;c[u>>2]=r-s>>6;In[c[n>>2]&4095](n+4|0,j);n=c[p>>2]|0;r=c[l>>2]|0}while((n|0)!=(r|0))}if((c[m>>2]|0)<=-1){i=h;return}m=c[o>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];eOb(m,j);c[o>>2]=0;i=h;return}function UVc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+64|0;k=h+40|0;l=h+88|0;m=h+93|0;n=h+60|0;o=h;p=h+20|0;q=h+90|0;a[l>>0]=2;a[l+1>>0]=0;a[m>>0]=0;r=OVc(g,l,m)|0;c[n>>2]=0;c[o>>2]=0;c[o+8>>2]=0;m=o+12|0;c[m>>2]=0;g=o+4|0;c[g>>2]=60;a[o+16>>0]=0;if(!r){c[p>>2]=f;c[p+4>>2]=f;c[p+8>>2]=(Xbd()|0)+36;c[p+12>>2]=0;b[p+16>>1]=b[l>>1]|0;cWc(p,o,n,0);s=o}else s=r;r=c[s>>2]|0;n=c[s+8>>2]|0;s=r+(n<<6)|0;p=k+4|0;c[p>>2]=r;c[k>>2]=r;l=k+8|0;c[l>>2]=s;t=n<<6>>6;c[k+16>>2]=t;u=k+12|0;c[u>>2]=t;c[j+16>>2]=d;a[j>>0]=1;d=j+1|0;a[d+0>>0]=a[q+0>>0]|0;a[d+1>>0]=a[q+1>>0]|0;a[d+2>>0]=a[q+2>>0]|0;c[j+4>>2]=e;c[j+8>>2]=f;c[j+12>>2]=k;if(n){n=r;r=s;do{s=n+64|0;c[p>>2]=s;c[u>>2]=r-s>>6;In[c[n>>2]&4095](n+4|0,j);n=c[p>>2]|0;r=c[l>>2]|0}while((n|0)!=(r|0))}if((c[m>>2]|0)<=-1){i=h;return}m=c[o>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];eOb(m,j);c[o>>2]=0;i=h;return}function VVc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h;k=h+32|0;l=h+20|0;m=h+8|0;c[f+28>>2]=2048;n=f+16|0;if(c[n>>2]&176){o=0;i=h;return o|0}p=f+12|0;if((c[p>>2]|0)==18){q=Qsc(c[f+8>>2]|0)|0;if(msc(q,c[g+140>>2]|0)|0){o=0;i=h;return o|0}q=f+4|0;r=c[q>>2]|0;if((r|0)==(Msc(c[f>>2]|0)|0)?!(msc(c[q>>2]|0,c[g+252>>2]|0)|0):0){o=0;i=h;return o|0}}do if((e|0)>7){if(((c[p>>2]|0)!=18?(q=c[f+4>>2]|0,(Psc(gsc(q)|0)|0)!=29):0)?!(Trc(q)|0):0)break;q=b+16|0;if(a[q>>0]|0){o=0;i=h;return o|0}r=lsc(d)|0;s=ksc(d)|0;rri(k,s,SEi(s|0)|0);if((r|0)!=0?(a[r>>0]|0)!=0:0){c[j>>2]=r;c[j+4>>2]=s;Lsd(l,614752,j);yri(k,l)|0;xri(l)}s=aad((Xbd()|0)+24|0,d)|0;if(!(a[k>>0]&1))t=k+1|0;else t=c[k+8>>2]|0;c[j>>2]=t;Lsd(m,614760,j);if(!s)u=0;else u=c[s+4>>2]|0;if(!(a[m>>0]&1))v=m+1|0;else v=c[m+8>>2]|0;Krd(v,0,3653512,67,1,u,0,0);xri(m);xri(k);a[q>>0]=1;o=0;i=h;return o|0}while(0);if(hCi(c[f+20>>2]|0,46)|0){o=0;i=h;return o|0}if(Xrc(c[n>>2]|0)|0){o=1;i=h;return o|0}if(btc(d,c[(Xbd()|0)+296>>2]|0)|0){o=1;i=h;return o|0}else{o=atc(d,c[f>>2]|0,c[g+96>>2]|0)|0;i=h;return o|0}return 0}function WVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+144|0;e=d;f=c[b+16>>2]|0;c[e>>2]=0;c[e+4>>2]=d+16;c[e+8>>2]=c[a+28>>2];dWc(f,e,c[a+4>>2]|0,c[a+24>>2]|0);i=d;return}function XVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+160|0;e=d+12|0;f=d;c[e>>2]=0;c[e+4>>2]=d+32;c[e+8>>2]=c[a+28>>2];c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;add(h,c[a+4>>2]|0,c[142306]|0,f,c[a+24>>2]|0);$cd(h,2646336,2646336,d+24|0,0);dWc(h,e,3142592,0);cdd(h);bdd(h);h=c[f>>2]|0;if(!h){i=d;return}f=c[g>>2]|0;if((f|0)!=(h|0))c[g>>2]=f+(~(((f+-12-h|0)>>>0)/12|0)*12|0);ACi(h);i=d;return}function YVc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+8|0;n=j+176|0;o=j;p=j+40|0;q=j+36|0;r=j+16|0;s=j+184|0;t=c[e>>2]|0;u=e+8|0;v=c[u>>2]|0;if((!h?(w=v+268|0,x=c[w>>2]|0,y=c[w+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(w=tsc(t)|0,z=m,c[z>>2]=x,c[z+4>>2]=y&255,c[k+0>>2]=c[m+0>>2],c[k+4>>2]=c[m+4>>2],wsc(l,w,k),(c[l>>2]|0)!=0):0){A=k+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[k>>2]=2676;w=k+52|0;c[w+0>>2]=c[l+0>>2];a[w+4>>0]=a[l+4>>0]|0;a[k+61>>0]=0;a[k+60>>0]=1;gWc(f,k)}l=isc(t)|0;if((((l|0)!=0?(c[v>>2]|0)!=(l|0):0)?(c[v+8>>2]|0)!=(l|0):0)?(c[v+112>>2]|0)!=(l|0):0){c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r>>2]=l;YVc(r,f,g,1)}c[s>>2]=0;r=s+4|0;c[r>>2]=0;c[s+8>>2]=0;Ssc(t,s);l=c[s>>2]|0;if((l|0)!=(c[r>>2]|0)){w=k+24|0;m=k+25|0;y=k+8|0;z=k+12|0;x=k+4|0;C=k+16|0;D=k+20|0;E=e+16|0;F=e+12|0;e=k+32|0;G=k+28|0;H=k+36|0;I=l;do{l=c[I>>2]|0;a[w>>0]=0;a[m>>0]=0;c[k>>2]=l;J=Osc(l)|0;c[y>>2]=J;c[z>>2]=Psc(J)|0;c[x>>2]=$sc(J)|0;c[C>>2]=Lsc(l)|0;c[D>>2]=Ksc(l)|0;b[w>>1]=d[E>>0]|d[E+1>>0]<<8;l=c[F>>2]|0;c[e>>2]=l;c[G>>2]=0;J=c[u>>2]|0;c[H>>2]=J;if(VVc(f,t,l,k,J)|0)hWc(k,f,g);I=I+4|0}while((I|0)!=(c[r>>2]|0))}if((!h?(h=v+276|0,I=c[h>>2]|0,g=c[h+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(v=tsc(t)|0,t=o,c[t>>2]=I,c[t+4>>2]=g&255,c[k+0>>2]=c[o+0>>2],c[k+4>>2]=c[o+4>>2],wsc(n,v,k),(c[n>>2]|0)!=0):0){A=p+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[p>>2]=2676;A=p+52|0;c[A+0>>2]=c[n+0>>2];a[A+4>>0]=a[n+4>>0]|0;a[p+61>>0]=1;a[p+60>>0]=0;gWc(f,p)}p=c[s>>2]|0;if(!p){i=j;return}s=c[r>>2]|0;if((s|0)!=(p|0))c[r>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[q>>2]=89;c[k+0>>2]=c[q+0>>2];eOb(p,k);i=j;return}function ZVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;if((b|0)==(a|0)){i=d;return a|0}g=c[b>>2]|0;h=c[b+8>>2]<<6;b=h>>6;j=a+8|0;c[j>>2]=b;k=a+12|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<b>>>0)if((l|0)>-1){c[k>>2]=b;m=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];n=hOb(m,h,4,e,0,3653512,370)|0;c[a>>2]=n;o=n;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];n=cOb(h,4,e,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,c[j>>2]<<6|0)|0;c[k>>2]=b;c[a>>2]=n;o=n;break}else o=c[a>>2]|0;while(0);YEi(o|0,g|0,c[j>>2]<<6|0)|0;i=d;return a|0}function _Vc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+8|0;n=j+176|0;o=j;p=j+40|0;q=j+36|0;r=j+16|0;s=j+184|0;t=c[e>>2]|0;u=e+8|0;v=c[u>>2]|0;if((!h?(w=v+268|0,x=c[w>>2]|0,y=c[w+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(w=tsc(t)|0,z=m,c[z>>2]=x,c[z+4>>2]=y&255,c[k+0>>2]=c[m+0>>2],c[k+4>>2]=c[m+4>>2],wsc(l,w,k),(c[l>>2]|0)!=0):0){A=k+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[k>>2]=2677;w=k+52|0;c[w+0>>2]=c[l+0>>2];a[w+4>>0]=a[l+4>>0]|0;a[k+61>>0]=0;a[k+60>>0]=1;gWc(f,k)}l=isc(t)|0;if((((l|0)!=0?(c[v>>2]|0)!=(l|0):0)?(c[v+8>>2]|0)!=(l|0):0)?(c[v+112>>2]|0)!=(l|0):0){c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r>>2]=l;_Vc(r,f,g,1)}c[s>>2]=0;r=s+4|0;c[r>>2]=0;c[s+8>>2]=0;Ssc(t,s);l=c[s>>2]|0;if((l|0)!=(c[r>>2]|0)){w=k+24|0;m=k+25|0;y=k+8|0;z=k+12|0;x=k+4|0;C=k+16|0;D=k+20|0;E=e+16|0;F=e+12|0;e=k+32|0;G=k+28|0;H=k+36|0;I=l;do{l=c[I>>2]|0;a[w>>0]=0;a[m>>0]=0;c[k>>2]=l;J=Osc(l)|0;c[y>>2]=J;c[z>>2]=Psc(J)|0;c[x>>2]=$sc(J)|0;c[C>>2]=Lsc(l)|0;c[D>>2]=Ksc(l)|0;b[w>>1]=d[E>>0]|d[E+1>>0]<<8;l=c[F>>2]|0;c[e>>2]=l;c[G>>2]=0;J=c[u>>2]|0;c[H>>2]=J;if(VVc(f,t,l,k,J)|0)jWc(k,f,g);I=I+4|0}while((I|0)!=(c[r>>2]|0))}if((!h?(h=v+276|0,I=c[h>>2]|0,g=c[h+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(v=tsc(t)|0,t=o,c[t>>2]=I,c[t+4>>2]=g&255,c[k+0>>2]=c[o+0>>2],c[k+4>>2]=c[o+4>>2],wsc(n,v,k),(c[n>>2]|0)!=0):0){A=p+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[p>>2]=2677;A=p+52|0;c[A+0>>2]=c[n+0>>2];a[A+4>>0]=a[n+4>>0]|0;a[p+61>>0]=1;a[p+60>>0]=0;gWc(f,p)}p=c[s>>2]|0;if(!p){i=j;return}s=c[r>>2]|0;if((s|0)!=(p|0))c[r>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[q>>2]=89;c[k+0>>2]=c[q+0>>2];eOb(p,k);i=j;return}function $Vc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+8|0;n=j+176|0;o=j;p=j+40|0;q=j+36|0;r=j+16|0;s=j+184|0;t=c[e>>2]|0;u=e+8|0;v=c[u>>2]|0;if((!h?(w=v+268|0,x=c[w>>2]|0,y=c[w+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(w=tsc(t)|0,z=m,c[z>>2]=x,c[z+4>>2]=y&255,c[k+0>>2]=c[m+0>>2],c[k+4>>2]=c[m+4>>2],wsc(l,w,k),(c[l>>2]|0)!=0):0){A=k+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[k>>2]=2678;w=k+52|0;c[w+0>>2]=c[l+0>>2];a[w+4>>0]=a[l+4>>0]|0;a[k+61>>0]=0;a[k+60>>0]=1;gWc(f,k)}l=isc(t)|0;if((((l|0)!=0?(c[v>>2]|0)!=(l|0):0)?(c[v+8>>2]|0)!=(l|0):0)?(c[v+112>>2]|0)!=(l|0):0){c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r>>2]=l;$Vc(r,f,g,1)}c[s>>2]=0;r=s+4|0;c[r>>2]=0;c[s+8>>2]=0;Ssc(t,s);l=c[s>>2]|0;if((l|0)!=(c[r>>2]|0)){w=k+24|0;m=k+25|0;y=k+8|0;z=k+12|0;x=k+4|0;C=k+16|0;D=k+20|0;E=e+16|0;F=e+12|0;e=k+32|0;G=k+28|0;H=k+36|0;I=l;do{l=c[I>>2]|0;a[w>>0]=0;a[m>>0]=0;c[k>>2]=l;J=Osc(l)|0;c[y>>2]=J;c[z>>2]=Psc(J)|0;c[x>>2]=$sc(J)|0;c[C>>2]=Lsc(l)|0;c[D>>2]=Ksc(l)|0;b[w>>1]=d[E>>0]|d[E+1>>0]<<8;l=c[F>>2]|0;c[e>>2]=l;c[G>>2]=0;J=c[u>>2]|0;c[H>>2]=J;if(VVc(f,t,l,k,J)|0)lWc(k,f,g);I=I+4|0}while((I|0)!=(c[r>>2]|0))}if((!h?(h=v+276|0,I=c[h>>2]|0,g=c[h+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(v=tsc(t)|0,t=o,c[t>>2]=I,c[t+4>>2]=g&255,c[k+0>>2]=c[o+0>>2],c[k+4>>2]=c[o+4>>2],wsc(n,v,k),(c[n>>2]|0)!=0):0){A=p+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[p>>2]=2678;A=p+52|0;c[A+0>>2]=c[n+0>>2];a[A+4>>0]=a[n+4>>0]|0;a[p+61>>0]=1;a[p+60>>0]=0;gWc(f,p)}p=c[s>>2]|0;if(!p){i=j;return}s=c[r>>2]|0;if((s|0)!=(p|0))c[r>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[q>>2]=89;c[k+0>>2]=c[q+0>>2];eOb(p,k);i=j;return}function aWc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+8|0;n=j+176|0;o=j;p=j+40|0;q=j+36|0;r=j+16|0;s=j+184|0;t=c[e>>2]|0;u=e+8|0;v=c[u>>2]|0;if((!h?(w=v+268|0,x=c[w>>2]|0,y=c[w+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(w=tsc(t)|0,z=m,c[z>>2]=x,c[z+4>>2]=y&255,c[k+0>>2]=c[m+0>>2],c[k+4>>2]=c[m+4>>2],wsc(l,w,k),(c[l>>2]|0)!=0):0){A=k+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[k>>2]=2679;w=k+52|0;c[w+0>>2]=c[l+0>>2];a[w+4>>0]=a[l+4>>0]|0;a[k+61>>0]=0;a[k+60>>0]=1;gWc(f,k)}l=isc(t)|0;if((((l|0)!=0?(c[v>>2]|0)!=(l|0):0)?(c[v+8>>2]|0)!=(l|0):0)?(c[v+112>>2]|0)!=(l|0):0){c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r>>2]=l;aWc(r,f,g,1)}c[s>>2]=0;r=s+4|0;c[r>>2]=0;c[s+8>>2]=0;Ssc(t,s);l=c[s>>2]|0;if((l|0)!=(c[r>>2]|0)){w=k+24|0;m=k+25|0;y=k+8|0;z=k+12|0;x=k+4|0;C=k+16|0;D=k+20|0;E=e+16|0;F=e+12|0;e=k+32|0;G=k+28|0;H=k+36|0;I=l;do{l=c[I>>2]|0;a[w>>0]=0;a[m>>0]=0;c[k>>2]=l;J=Osc(l)|0;c[y>>2]=J;c[z>>2]=Psc(J)|0;c[x>>2]=$sc(J)|0;c[C>>2]=Lsc(l)|0;c[D>>2]=Ksc(l)|0;b[w>>1]=d[E>>0]|d[E+1>>0]<<8;l=c[F>>2]|0;c[e>>2]=l;c[G>>2]=0;J=c[u>>2]|0;c[H>>2]=J;if(VVc(f,t,l,k,J)|0)nWc(k,f,g);I=I+4|0}while((I|0)!=(c[r>>2]|0))}if((!h?(h=v+276|0,I=c[h>>2]|0,g=c[h+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(v=tsc(t)|0,t=o,c[t>>2]=I,c[t+4>>2]=g&255,c[k+0>>2]=c[o+0>>2],c[k+4>>2]=c[o+4>>2],wsc(n,v,k),(c[n>>2]|0)!=0):0){A=p+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[p>>2]=2679;A=p+52|0;c[A+0>>2]=c[n+0>>2];a[A+4>>0]=a[n+4>>0]|0;a[p+61>>0]=1;a[p+60>>0]=0;gWc(f,p)}p=c[s>>2]|0;if(!p){i=j;return}s=c[r>>2]|0;if((s|0)!=(p|0))c[r>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[q>>2]=89;c[k+0>>2]=c[q+0>>2];eOb(p,k);i=j;return}function bWc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+8|0;n=j+176|0;o=j;p=j+40|0;q=j+36|0;r=j+16|0;s=j+184|0;t=c[e>>2]|0;u=e+8|0;v=c[u>>2]|0;if((!h?(w=v+268|0,x=c[w>>2]|0,y=c[w+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(w=tsc(t)|0,z=m,c[z>>2]=x,c[z+4>>2]=y&255,c[k+0>>2]=c[m+0>>2],c[k+4>>2]=c[m+4>>2],wsc(l,w,k),(c[l>>2]|0)!=0):0){A=k+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[k>>2]=2680;w=k+52|0;c[w+0>>2]=c[l+0>>2];a[w+4>>0]=a[l+4>>0]|0;a[k+61>>0]=0;a[k+60>>0]=1;gWc(f,k)}l=isc(t)|0;if((((l|0)!=0?(c[v>>2]|0)!=(l|0):0)?(c[v+8>>2]|0)!=(l|0):0)?(c[v+112>>2]|0)!=(l|0):0){c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r>>2]=l;bWc(r,f,g,1)}c[s>>2]=0;r=s+4|0;c[r>>2]=0;c[s+8>>2]=0;Ssc(t,s);l=c[s>>2]|0;if((l|0)!=(c[r>>2]|0)){w=k+24|0;m=k+25|0;y=k+8|0;z=k+12|0;x=k+4|0;C=k+16|0;D=k+20|0;E=e+16|0;F=e+12|0;e=k+32|0;G=k+28|0;H=k+36|0;I=l;do{l=c[I>>2]|0;a[w>>0]=0;a[m>>0]=0;c[k>>2]=l;J=Osc(l)|0;c[y>>2]=J;c[z>>2]=Psc(J)|0;c[x>>2]=$sc(J)|0;c[C>>2]=Lsc(l)|0;c[D>>2]=Ksc(l)|0;b[w>>1]=d[E>>0]|d[E+1>>0]<<8;l=c[F>>2]|0;c[e>>2]=l;c[G>>2]=0;J=c[u>>2]|0;c[H>>2]=J;if(VVc(f,t,l,k,J)|0)pWc(k,f,g);I=I+4|0}while((I|0)!=(c[r>>2]|0))}if((!h?(h=v+276|0,I=c[h>>2]|0,g=c[h+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(v=tsc(t)|0,t=o,c[t>>2]=I,c[t+4>>2]=g&255,c[k+0>>2]=c[o+0>>2],c[k+4>>2]=c[o+4>>2],wsc(n,v,k),(c[n>>2]|0)!=0):0){A=p+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[p>>2]=2680;A=p+52|0;c[A+0>>2]=c[n+0>>2];a[A+4>>0]=a[n+4>>0]|0;a[p+61>>0]=1;a[p+60>>0]=0;gWc(f,p)}p=c[s>>2]|0;if(!p){i=j;return}s=c[r>>2]|0;if((s|0)!=(p|0))c[r>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[q>>2]=89;c[k+0>>2]=c[q+0>>2];eOb(p,k);i=j;return}function cWc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+8|0;n=j+176|0;o=j;p=j+40|0;q=j+36|0;r=j+16|0;s=j+184|0;t=c[e>>2]|0;u=e+8|0;v=c[u>>2]|0;if((!h?(w=v+268|0,x=c[w>>2]|0,y=c[w+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(w=tsc(t)|0,z=m,c[z>>2]=x,c[z+4>>2]=y&255,c[k+0>>2]=c[m+0>>2],c[k+4>>2]=c[m+4>>2],wsc(l,w,k),(c[l>>2]|0)!=0):0){A=k+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[k>>2]=2681;w=k+52|0;c[w+0>>2]=c[l+0>>2];a[w+4>>0]=a[l+4>>0]|0;a[k+61>>0]=0;a[k+60>>0]=1;gWc(f,k)}l=isc(t)|0;if((((l|0)!=0?(c[v>>2]|0)!=(l|0):0)?(c[v+8>>2]|0)!=(l|0):0)?(c[v+112>>2]|0)!=(l|0):0){c[r+0>>2]=c[e+0>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];c[r+16>>2]=c[e+16>>2];c[r>>2]=l;cWc(r,f,g,1)}c[s>>2]=0;r=s+4|0;c[r>>2]=0;c[s+8>>2]=0;Ssc(t,s);l=c[s>>2]|0;if((l|0)!=(c[r>>2]|0)){w=k+24|0;m=k+25|0;y=k+8|0;z=k+12|0;x=k+4|0;C=k+16|0;D=k+20|0;E=e+16|0;F=e+12|0;e=k+32|0;G=k+28|0;H=k+36|0;I=l;do{l=c[I>>2]|0;a[w>>0]=0;a[m>>0]=0;c[k>>2]=l;J=Osc(l)|0;c[y>>2]=J;c[z>>2]=Psc(J)|0;c[x>>2]=$sc(J)|0;c[C>>2]=Lsc(l)|0;c[D>>2]=Ksc(l)|0;b[w>>1]=d[E>>0]|d[E+1>>0]<<8;l=c[F>>2]|0;c[e>>2]=l;c[G>>2]=0;J=c[u>>2]|0;c[H>>2]=J;if(VVc(f,t,l,k,J)|0)rWc(k,f,g);I=I+4|0}while((I|0)!=(c[r>>2]|0))}if((!h?(h=v+276|0,I=c[h>>2]|0,g=c[h+4>>2]|0,msc(t,c[v+264>>2]|0)|0):0)?(v=tsc(t)|0,t=o,c[t>>2]=I,c[t+4>>2]=g&255,c[k+0>>2]=c[o+0>>2],c[k+4>>2]=c[o+4>>2],wsc(n,v,k),(c[n>>2]|0)!=0):0){A=p+4|0;B=A+60|0;do{c[A>>2]=0;A=A+4|0}while((A|0)<(B|0));c[p>>2]=2681;A=p+52|0;c[A+0>>2]=c[n+0>>2];a[A+4>>0]=a[n+4>>0]|0;a[p+61>>0]=1;a[p+60>>0]=0;gWc(f,p)}p=c[s>>2]|0;if(!p){i=j;return}s=c[r>>2]|0;if((s|0)!=(p|0))c[r>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[q>>2]=89;c[k+0>>2]=c[q+0>>2];eOb(p,k);i=j;return}function dWc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=c[d+4>>2]|0;if(!j)k=614344;else{l=c[d+8>>2]|0;a[j>>0]=80;a[j+1>>0]=80;a[j+2>>0]=116;a[j+3>>0]=114;a[j+4>>0]=60;m=j+6|0;a[j+5>>0]=36;n=ksc(l)|0;l=a[n>>0]|0;if(!(l<<24>>24))o=m;else{p=l;l=m;m=n;while(1){a[l>>0]=p;n=l+1|0;m=m+1|0;p=a[m>>0]|0;if(!(p<<24>>24)){o=n;break}else l=n}}a[o>>0]=62;a[o+1>>0]=0;k=j}add(b,e,k,d,f);f=h+8|0;k=f;c[k>>2]=0;c[k+4>>2]=0;c[h>>2]=0;add(b,792256,c[142270]|0,d,1);d=b+12|0;h=b+20|0;c[(c[c[d>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,f,1);c[(c[c[d>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);i=g;return}function eWc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+8|0;$cd(a,2646336,2646336,e,d);d=c[b+12>>2]|0;if(!d)g=614328;else g=ksc(d)|0;add(a,3142592,g,b,0);g=c[b>>2]|0;c[f+16>>2]=a;d=b+4|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=g;d=g+4|0;b=c[d>>2]|0;h=g+8|0;j=c[h>>2]|0;if((b|0)==(j|0)){bdd(a);cdd(a);i=e;return}k=g+12|0;g=b;b=j;do{j=g+64|0;c[d>>2]=j;c[k>>2]=b-j>>6;In[c[g>>2]&4095](g+4|0,f);g=c[d>>2]|0;b=c[h>>2]|0}while((g|0)!=(b|0));bdd(a);cdd(a);i=e;return}function fWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;if(a[b+56>>0]|0){i=e;return}j=b+48|0;b=c[j+4>>2]|0;k=h;c[k>>2]=c[j>>2];c[k+4>>2]=b;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+12>>2]=c[d+4>>2];a[g+24>>0]=a[d>>0]|0;xbd(g)|0;i=e;return}function gWc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<6)|0;q=p+0|0;r=b+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));i=d;return}h=k<<1;t=(h|0)==0?1:h;do if(l>>>0<t>>>0)if((k|0)>-1){c[j>>2]=t;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,t<<6,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(t<<6,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<6|0)|0;c[j>>2]=t;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<6)|0;q=p+0|0;r=b+0|0;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));i=d;return}function hWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+128|0;g=f+64|0;h=f+112|0;j=f;k=b+4|0;l=c[k>>2]|0;if((Psc(gsc(l)|0)|0)!=29?!(Trc(l)|0):0){l=c[b>>2]|0;c[g+4>>2]=Ksc(l)|0;m=$sc(Osc(l)|0)|0;c[g+12>>2]=m;c[g+16>>2]=Psc(Osc(l)|0)|0;c[g+20>>2]=Nsc(l)|0;c[g+8>>2]=ksc(m)|0;c[g>>2]=l;c[g+24>>2]=c[b+28>>2];c[g+28>>2]=c[k>>2];k=b+12|0;c[g+32>>2]=c[k>>2];l=tWc(b,g,h)|0;if(!l){if(((c[k>>2]|0)+-17|0)>>>0>=2){i=f;return}uWc(b,d,e);i=f;return}else{if((a[b+25>>0]|0)!=0&(a[h>>0]|0)==0){i=f;return}h=j+4|0;k=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(k|0));c[j>>2]=l;h=j+4|0;l=g+0|0;k=h+48|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(k|0));gWc(d,j);i=f;return}}sWc(b,d,e);i=f;return}function iWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;if(a[b+57>>0]|0){i=e;return}j=b+48|0;b=c[j+4>>2]|0;k=h;c[k>>2]=c[j>>2];c[k+4>>2]=b;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+12>>2]=c[d+4>>2];a[g+24>>0]=a[d>>0]|0;xbd(g)|0;i=e;return}function jWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+128|0;g=f+64|0;h=f+112|0;j=f;k=b+4|0;l=c[k>>2]|0;if((Psc(gsc(l)|0)|0)!=29?!(Trc(l)|0):0){l=c[b>>2]|0;c[g+4>>2]=Ksc(l)|0;m=$sc(Osc(l)|0)|0;c[g+12>>2]=m;c[g+16>>2]=Psc(Osc(l)|0)|0;c[g+20>>2]=Nsc(l)|0;c[g+8>>2]=ksc(m)|0;c[g>>2]=l;c[g+24>>2]=c[b+28>>2];c[g+28>>2]=c[k>>2];k=b+12|0;c[g+32>>2]=c[k>>2];l=wWc(b,g,h)|0;if(!l){if(((c[k>>2]|0)+-17|0)>>>0>=2){i=f;return}xWc(b,d,e);i=f;return}else{if((a[b+25>>0]|0)!=0&(a[h>>0]|0)==0){i=f;return}h=j+4|0;k=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(k|0));c[j>>2]=l;h=j+4|0;l=g+0|0;k=h+48|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(k|0));gWc(d,j);i=f;return}}vWc(b,d,e);i=f;return}function kWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;if(a[b+57>>0]|0){i=e;return}if(a[b+56>>0]|0){i=e;return}j=b+48|0;b=c[j+4>>2]|0;k=h;c[k>>2]=c[j>>2];c[k+4>>2]=b;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+12>>2]=c[d+4>>2];a[g+24>>0]=a[d>>0]|0;xbd(g)|0;i=e;return}function lWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+128|0;g=f+64|0;h=f+112|0;j=f;k=b+4|0;l=c[k>>2]|0;if((Psc(gsc(l)|0)|0)!=29?!(Trc(l)|0):0){l=c[b>>2]|0;c[g+4>>2]=Ksc(l)|0;m=$sc(Osc(l)|0)|0;c[g+12>>2]=m;c[g+16>>2]=Psc(Osc(l)|0)|0;c[g+20>>2]=Nsc(l)|0;c[g+8>>2]=ksc(m)|0;c[g>>2]=l;c[g+24>>2]=c[b+28>>2];c[g+28>>2]=c[k>>2];k=b+12|0;c[g+32>>2]=c[k>>2];l=zWc(b,g,h)|0;if(!l){if(((c[k>>2]|0)+-17|0)>>>0>=2){i=f;return}AWc(b,d,e);i=f;return}else{if((a[b+25>>0]|0)!=0&(a[h>>0]|0)==0){i=f;return}h=j+4|0;k=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(k|0));c[j>>2]=l;h=j+4|0;l=g+0|0;k=h+48|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(k|0));gWc(d,j);i=f;return}}yWc(b,d,e);i=f;return}function mWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;if((a[b+57>>0]|0)!=0?(a[(c[d+16>>2]|0)+32>>0]|0)==0:0){i=e;return}j=b+48|0;b=c[j+4>>2]|0;k=h;c[k>>2]=c[j>>2];c[k+4>>2]=b;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+12>>2]=c[d+4>>2];a[g+24>>0]=a[d>>0]|0;xbd(g)|0;i=e;return}function nWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+128|0;g=f+64|0;h=f+112|0;j=f;k=b+4|0;l=c[k>>2]|0;if((Psc(gsc(l)|0)|0)!=29?!(Trc(l)|0):0){l=c[b>>2]|0;c[g+4>>2]=Ksc(l)|0;m=$sc(Osc(l)|0)|0;c[g+12>>2]=m;c[g+16>>2]=Psc(Osc(l)|0)|0;c[g+20>>2]=Nsc(l)|0;c[g+8>>2]=ksc(m)|0;c[g>>2]=l;c[g+24>>2]=c[b+28>>2];c[g+28>>2]=c[k>>2];k=b+12|0;c[g+32>>2]=c[k>>2];l=CWc(b,g,h)|0;if(!l){if(((c[k>>2]|0)+-17|0)>>>0>=2){i=f;return}DWc(b,d,e);i=f;return}else{if((a[b+25>>0]|0)!=0&(a[h>>0]|0)==0){i=f;return}h=j+4|0;k=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(k|0));c[j>>2]=l;h=j+4|0;l=g+0|0;k=h+48|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(k|0));gWc(d,j);i=f;return}}BWc(b,d,e);i=f;return}function oWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;if(a[b+56>>0]|0){i=e;return}j=b+48|0;b=c[j+4>>2]|0;k=h;c[k>>2]=c[j>>2];c[k+4>>2]=b;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+12>>2]=c[d+4>>2];a[g+24>>0]=a[d>>0]|0;xbd(g)|0;i=e;return}function pWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+128|0;g=f+64|0;h=f+112|0;j=f;k=b+4|0;l=c[k>>2]|0;if((Psc(gsc(l)|0)|0)!=29?!(Trc(l)|0):0){l=c[b>>2]|0;c[g+4>>2]=Ksc(l)|0;m=$sc(Osc(l)|0)|0;c[g+12>>2]=m;c[g+16>>2]=Psc(Osc(l)|0)|0;c[g+20>>2]=Nsc(l)|0;c[g+8>>2]=ksc(m)|0;c[g>>2]=l;c[g+24>>2]=c[b+28>>2];c[g+28>>2]=c[k>>2];k=b+12|0;c[g+32>>2]=c[k>>2];l=FWc(b,g,h)|0;if(!l){if(((c[k>>2]|0)+-17|0)>>>0>=2){i=f;return}GWc(b,d,e);i=f;return}else{if((a[b+25>>0]|0)!=0&(a[h>>0]|0)==0){i=f;return}h=j+4|0;k=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(k|0));c[j>>2]=l;h=j+4|0;l=g+0|0;k=h+48|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(k|0));gWc(d,j);i=f;return}}EWc(b,d,e);i=f;return}function qWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;if(a[b+56>>0]|0){i=e;return}j=b+48|0;b=c[j+4>>2]|0;k=h;c[k>>2]=c[j>>2];c[k+4>>2]=b;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+12>>2]=c[d+4>>2];a[g+24>>0]=a[d>>0]|0;xbd(g)|0;i=e;return}function rWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+128|0;g=f+64|0;h=f+112|0;j=f;k=b+4|0;l=c[k>>2]|0;if((Psc(gsc(l)|0)|0)!=29?!(Trc(l)|0):0){l=c[b>>2]|0;c[g+4>>2]=Ksc(l)|0;m=$sc(Osc(l)|0)|0;c[g+12>>2]=m;c[g+16>>2]=Psc(Osc(l)|0)|0;c[g+20>>2]=Nsc(l)|0;c[g+8>>2]=ksc(m)|0;c[g>>2]=l;c[g+24>>2]=c[b+28>>2];c[g+28>>2]=c[k>>2];k=b+12|0;c[g+32>>2]=c[k>>2];l=IWc(b,g,h)|0;if(!l){if(((c[k>>2]|0)+-17|0)>>>0>=2){i=f;return}JWc(b,d,e);i=f;return}else{if((a[b+25>>0]|0)!=0&(a[h>>0]|0)==0){i=f;return}h=j+4|0;k=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(k|0));c[j>>2]=l;h=j+4|0;l=g+0|0;k=h+48|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(k|0));gWc(d,j);i=f;return}}HWc(b,d,e);i=f;return}function sWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+176|0;g=f+128|0;h=f+116|0;j=f+64|0;k=f;l=f+168|0;a[h>>0]=1;c[h+4>>2]=0;c[h+8>>2]=0;C8c(g,h,c[b>>2]|0);h=j+0|0;m=b+0|0;n=h+40|0;do{c[h>>2]=c[m>>2];h=h+4|0;m=m+4|0}while((h|0)<(n|0));m=c[b>>2]|0;c[j>>2]=m;b=F8c(g)|0;c[j+40>>2]=b;g=Psc(gsc(b)|0)|0;c[j+44>>2]=g;o=j+32|0;c[o>>2]=(c[o>>2]|0)+1;h=k+4|0;n=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(n|0));c[k>>2]=2682;h=Ksc(m)|0;n=$sc(Osc(m)|0)|0;o=Psc(Osc(m)|0)|0;p=Nsc(m)|0;q=ksc(n)|0;r=c[j+28>>2]|0;c[k+4>>2]=m;c[k+8>>2]=h;c[k+12>>2]=q;c[k+16>>2]=n;c[k+20>>2]=o;c[k+24>>2]=p;c[k+28>>2]=r;c[k+32>>2]=b;c[k+36>>2]=g;b=LWc(j,k+4|0,l)|0;if(!b){if((g+-17|0)>>>0>=2){i=f;return}MWc(j,k,d,e);i=f;return}else{if(((a[l>>0]^1)&a[j+25>>0])<<24>>24){i=f;return}c[k+44>>2]=b;gWc(d,k);i=f;return}}function tWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+12>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 10:{l=2690;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2684;break}case 4:{l=2685;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2686;break}case 7:{l=2684;break}case 6:{l=2687;break}case 13:{l=2693;break}case 5:{l=2686;break}case 12:{l=2692;break}case 11:{l=2691;break}case 14:{l=2683;break}case 8:{l=2688;break}case 9:{l=2689;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2686;break a}else if((m|0)==8){l=2688;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2707;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2708}else l=0}else l=2706;else l=2705;else l=2704}else l=0;else l=2703;else l=2702;else l=2701;else l=2700;else l=2699;else l=2698;else l=2697;else l=2696;else l=2695;else l=2694}while(0);i=f;return l|0}function uWc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+128|0;j=h+56|0;k=h+52|0;l=h+32|0;m=h+12|0;n=h;o=e+4|0;if(!(lXc(c[o>>2]|0)|0)){i=h;return}p=c[o>>2]|0;q=e+24|0;c[l>>2]=p;c[l+4>>2]=p;c[l+8>>2]=(Xbd()|0)+36;b[l+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[l+12>>2]=(c[e+32>>2]|0)+1;c[m>>2]=0;q=m+8|0;c[q>>2]=0;p=m+12|0;c[p>>2]=0;r=m+4|0;c[r>>2]=60;s=m+16|0;t=f+16|0;a[s>>0]=a[t>>0]|0;YVc(l,m,g,0);g=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(g|0)==0)){q=j+4|0;l=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(l|0));c[j>>2]=2709;q=c[e>>2]|0;l=Ksc(q)|0;u=$sc(Osc(q)|0)|0;v=Psc(Osc(q)|0)|0;w=Nsc(q)|0;x=ksc(u)|0;y=c[e+28>>2]|0;z=c[o>>2]|0;o=c[e+12>>2]|0;c[j+4>>2]=q;c[j+8>>2]=l;c[j+12>>2]=x;c[j+16>>2]=u;c[j+20>>2]=v;c[j+24>>2]=w;c[j+28>>2]=y;c[j+32>>2]=z;c[j+36>>2]=o;o=n;n=c[o+4>>2]|0;z=j+40|0;c[z>>2]=c[o>>2];c[z+4>>2]=n;c[j+48>>2]=g;gWc(f,j);nXc(f,m);a[t>>0]=(a[t>>0]|0)==0?a[s>>0]|0:1}if((c[p>>2]|0)<=-1){i=h;return}p=c[m>>2]|0;c[k>>2]=c[r>>2];c[j+0>>2]=c[k+0>>2];eOb(p,j);c[m>>2]=0;i=h;return}function vWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+176|0;g=f+128|0;h=f+116|0;j=f+64|0;k=f;l=f+168|0;a[h>>0]=1;c[h+4>>2]=0;c[h+8>>2]=0;C8c(g,h,c[b>>2]|0);h=j+0|0;m=b+0|0;n=h+40|0;do{c[h>>2]=c[m>>2];h=h+4|0;m=m+4|0}while((h|0)<(n|0));m=c[b>>2]|0;c[j>>2]=m;b=F8c(g)|0;c[j+40>>2]=b;g=Psc(gsc(b)|0)|0;c[j+44>>2]=g;o=j+32|0;c[o>>2]=(c[o>>2]|0)+1;h=k+4|0;n=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(n|0));c[k>>2]=2710;h=Ksc(m)|0;n=$sc(Osc(m)|0)|0;o=Psc(Osc(m)|0)|0;p=Nsc(m)|0;q=ksc(n)|0;r=c[j+28>>2]|0;c[k+4>>2]=m;c[k+8>>2]=h;c[k+12>>2]=q;c[k+16>>2]=n;c[k+20>>2]=o;c[k+24>>2]=p;c[k+28>>2]=r;c[k+32>>2]=b;c[k+36>>2]=g;b=pXc(j,k+4|0,l)|0;if(!b){if((g+-17|0)>>>0>=2){i=f;return}qXc(j,k,d,e);i=f;return}else{if(((a[l>>0]^1)&a[j+25>>0])<<24>>24){i=f;return}c[k+44>>2]=b;gWc(d,k);i=f;return}}function wWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+12>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 12:{l=2720;break}case 8:{l=2716;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2712;break}case 11:{l=2719;break}case 6:{l=2715;break}case 13:{l=2721;break}case 5:{l=2714;break}case 9:{l=2717;break}case 4:{l=2713;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2714;break}case 7:{l=2712;break}case 10:{l=2718;break}case 14:{l=2711;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2714;break a}else if((m|0)==8){l=2716;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2735;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2736}else l=0}else l=2734;else l=2733;else l=2732}else l=0;else l=2731;else l=2730;else l=2729;else l=2728;else l=2727;else l=2726;else l=2725;else l=2724;else l=2723;else l=2722}while(0);i=f;return l|0}function xWc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+128|0;j=h+56|0;k=h+52|0;l=h+32|0;m=h+12|0;n=h;o=e+4|0;if(!(lXc(c[o>>2]|0)|0)){i=h;return}p=c[o>>2]|0;q=e+24|0;c[l>>2]=p;c[l+4>>2]=p;c[l+8>>2]=(Xbd()|0)+36;b[l+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[l+12>>2]=(c[e+32>>2]|0)+1;c[m>>2]=0;q=m+8|0;c[q>>2]=0;p=m+12|0;c[p>>2]=0;r=m+4|0;c[r>>2]=60;s=m+16|0;t=f+16|0;a[s>>0]=a[t>>0]|0;_Vc(l,m,g,0);g=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(g|0)==0)){q=j+4|0;l=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(l|0));c[j>>2]=2737;q=c[e>>2]|0;l=Ksc(q)|0;u=$sc(Osc(q)|0)|0;v=Psc(Osc(q)|0)|0;w=Nsc(q)|0;x=ksc(u)|0;y=c[e+28>>2]|0;z=c[o>>2]|0;o=c[e+12>>2]|0;c[j+4>>2]=q;c[j+8>>2]=l;c[j+12>>2]=x;c[j+16>>2]=u;c[j+20>>2]=v;c[j+24>>2]=w;c[j+28>>2]=y;c[j+32>>2]=z;c[j+36>>2]=o;o=n;n=c[o+4>>2]|0;z=j+40|0;c[z>>2]=c[o>>2];c[z+4>>2]=n;c[j+48>>2]=g;gWc(f,j);nXc(f,m);a[t>>0]=(a[t>>0]|0)==0?a[s>>0]|0:1}if((c[p>>2]|0)<=-1){i=h;return}p=c[m>>2]|0;c[k>>2]=c[r>>2];c[j+0>>2]=c[k+0>>2];eOb(p,j);c[m>>2]=0;i=h;return}function yWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+176|0;g=f+128|0;h=f+116|0;j=f+64|0;k=f;l=f+168|0;a[h>>0]=1;c[h+4>>2]=0;c[h+8>>2]=0;C8c(g,h,c[b>>2]|0);h=j+0|0;m=b+0|0;n=h+40|0;do{c[h>>2]=c[m>>2];h=h+4|0;m=m+4|0}while((h|0)<(n|0));m=c[b>>2]|0;c[j>>2]=m;b=F8c(g)|0;c[j+40>>2]=b;g=Psc(gsc(b)|0)|0;c[j+44>>2]=g;o=j+32|0;c[o>>2]=(c[o>>2]|0)+1;h=k+4|0;n=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(n|0));c[k>>2]=2738;h=Ksc(m)|0;n=$sc(Osc(m)|0)|0;o=Psc(Osc(m)|0)|0;p=Nsc(m)|0;q=ksc(n)|0;r=c[j+28>>2]|0;c[k+4>>2]=m;c[k+8>>2]=h;c[k+12>>2]=q;c[k+16>>2]=n;c[k+20>>2]=o;c[k+24>>2]=p;c[k+28>>2]=r;c[k+32>>2]=b;c[k+36>>2]=g;b=TXc(j,k+4|0,l)|0;if(!b){if((g+-17|0)>>>0>=2){i=f;return}UXc(j,k,d,e);i=f;return}else{if(((a[l>>0]^1)&a[j+25>>0])<<24>>24){i=f;return}c[k+44>>2]=b;gWc(d,k);i=f;return}}function zWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+12>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 14:{l=2739;break}case 13:{l=2749;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2740;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2742;break}case 8:{l=2744;break}case 7:{l=2740;break}case 4:{l=2741;break}case 9:{l=2745;break}case 5:{l=2742;break}case 6:{l=2743;break}case 12:{l=2748;break}case 11:{l=2747;break}case 10:{l=2746;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==8){l=2744;break a}else if((m|0)==5){l=2742;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2763;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2764}else l=0}else l=2762;else l=2761;else l=2760}else l=0;else l=2759;else l=2758;else l=2757;else l=2756;else l=2755;else l=2754;else l=2753;else l=2752;else l=2751;else l=2750}while(0);i=f;return l|0}function AWc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+128|0;j=h+56|0;k=h+52|0;l=h+32|0;m=h+12|0;n=h;o=e+4|0;if(!(lXc(c[o>>2]|0)|0)){i=h;return}p=c[o>>2]|0;q=e+24|0;c[l>>2]=p;c[l+4>>2]=p;c[l+8>>2]=(Xbd()|0)+36;b[l+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[l+12>>2]=(c[e+32>>2]|0)+1;c[m>>2]=0;q=m+8|0;c[q>>2]=0;p=m+12|0;c[p>>2]=0;r=m+4|0;c[r>>2]=60;s=m+16|0;t=f+16|0;a[s>>0]=a[t>>0]|0;$Vc(l,m,g,0);g=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(g|0)==0)){q=j+4|0;l=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(l|0));c[j>>2]=2765;q=c[e>>2]|0;l=Ksc(q)|0;u=$sc(Osc(q)|0)|0;v=Psc(Osc(q)|0)|0;w=Nsc(q)|0;x=ksc(u)|0;y=c[e+28>>2]|0;z=c[o>>2]|0;o=c[e+12>>2]|0;c[j+4>>2]=q;c[j+8>>2]=l;c[j+12>>2]=x;c[j+16>>2]=u;c[j+20>>2]=v;c[j+24>>2]=w;c[j+28>>2]=y;c[j+32>>2]=z;c[j+36>>2]=o;o=n;n=c[o+4>>2]|0;z=j+40|0;c[z>>2]=c[o>>2];c[z+4>>2]=n;c[j+48>>2]=g;gWc(f,j);nXc(f,m);a[t>>0]=(a[t>>0]|0)==0?a[s>>0]|0:1}if((c[p>>2]|0)<=-1){i=h;return}p=c[m>>2]|0;c[k>>2]=c[r>>2];c[j+0>>2]=c[k+0>>2];eOb(p,j);c[m>>2]=0;i=h;return}function BWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+176|0;g=f+128|0;h=f+116|0;j=f+64|0;k=f;l=f+168|0;a[h>>0]=1;c[h+4>>2]=0;c[h+8>>2]=0;C8c(g,h,c[b>>2]|0);h=j+0|0;m=b+0|0;n=h+40|0;do{c[h>>2]=c[m>>2];h=h+4|0;m=m+4|0}while((h|0)<(n|0));m=c[b>>2]|0;c[j>>2]=m;b=F8c(g)|0;c[j+40>>2]=b;g=Psc(gsc(b)|0)|0;c[j+44>>2]=g;o=j+32|0;c[o>>2]=(c[o>>2]|0)+1;h=k+4|0;n=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(n|0));c[k>>2]=2766;h=Ksc(m)|0;n=$sc(Osc(m)|0)|0;o=Psc(Osc(m)|0)|0;p=Nsc(m)|0;q=ksc(n)|0;r=c[j+28>>2]|0;c[k+4>>2]=m;c[k+8>>2]=h;c[k+12>>2]=q;c[k+16>>2]=n;c[k+20>>2]=o;c[k+24>>2]=p;c[k+28>>2]=r;c[k+32>>2]=b;c[k+36>>2]=g;b=uYc(j,k+4|0,l)|0;if(!b){if((g+-17|0)>>>0>=2){i=f;return}vYc(j,k,d,e);i=f;return}else{if(((a[l>>0]^1)&a[j+25>>0])<<24>>24){i=f;return}c[k+44>>2]=b;gWc(d,k);i=f;return}}function CWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+12>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 3:{l=d+24|0;c[l>>2]=c[l>>2]|33554432;m=2768;break}case 8:{m=2772;break}case 11:{m=2775;break}case 4:{m=2769;break}case 10:{m=2774;break}case 13:{m=2777;break}case 7:{m=2768;break}case 12:{m=2776;break}case 9:{m=2773;break}case 2:{l=d+24|0;c[l>>2]=c[l>>2]|256;m=2770;break}case 5:{m=2770;break}case 6:{m=2771;break}case 14:{m=2767;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){l=Psc(Usc(h)|0)|0;if((l|0)==5){m=2770;break a}else if((l|0)==8){m=2772;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);m=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;m=2791;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;m=2792}else m=0}else m=2790;else m=2789;else m=2788}else m=0;else m=2787;else m=2786;else m=2785;else m=2784;else m=2783;else m=2782;else m=2781;else m=2780;else m=2779;else m=2778}while(0);i=f;return m|0}function DWc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+128|0;j=h+56|0;k=h+52|0;l=h+32|0;m=h+12|0;n=h;o=e+4|0;if(!(lXc(c[o>>2]|0)|0)){i=h;return}p=c[o>>2]|0;q=e+24|0;c[l>>2]=p;c[l+4>>2]=p;c[l+8>>2]=(Xbd()|0)+36;b[l+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[l+12>>2]=(c[e+32>>2]|0)+1;c[m>>2]=0;q=m+8|0;c[q>>2]=0;p=m+12|0;c[p>>2]=0;r=m+4|0;c[r>>2]=60;s=m+16|0;t=f+16|0;a[s>>0]=a[t>>0]|0;aWc(l,m,g,0);g=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(g|0)==0)){q=j+4|0;l=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(l|0));c[j>>2]=2793;q=c[e>>2]|0;l=Ksc(q)|0;u=$sc(Osc(q)|0)|0;v=Psc(Osc(q)|0)|0;w=Nsc(q)|0;x=ksc(u)|0;y=c[e+28>>2]|0;z=c[o>>2]|0;o=c[e+12>>2]|0;c[j+4>>2]=q;c[j+8>>2]=l;c[j+12>>2]=x;c[j+16>>2]=u;c[j+20>>2]=v;c[j+24>>2]=w;c[j+28>>2]=y;c[j+32>>2]=z;c[j+36>>2]=o;o=n;n=c[o+4>>2]|0;z=j+40|0;c[z>>2]=c[o>>2];c[z+4>>2]=n;c[j+48>>2]=g;gWc(f,j);nXc(f,m);a[t>>0]=(a[t>>0]|0)==0?a[s>>0]|0:1}if((c[p>>2]|0)<=-1){i=h;return}p=c[m>>2]|0;c[k>>2]=c[r>>2];c[j+0>>2]=c[k+0>>2];eOb(p,j);c[m>>2]=0;i=h;return}function EWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+176|0;g=f+128|0;h=f+116|0;j=f+64|0;k=f;l=f+168|0;a[h>>0]=1;c[h+4>>2]=0;c[h+8>>2]=0;C8c(g,h,c[b>>2]|0);h=j+0|0;m=b+0|0;n=h+40|0;do{c[h>>2]=c[m>>2];h=h+4|0;m=m+4|0}while((h|0)<(n|0));m=c[b>>2]|0;c[j>>2]=m;b=F8c(g)|0;c[j+40>>2]=b;g=Psc(gsc(b)|0)|0;c[j+44>>2]=g;o=j+32|0;c[o>>2]=(c[o>>2]|0)+1;h=k+4|0;n=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(n|0));c[k>>2]=2794;h=Ksc(m)|0;n=$sc(Osc(m)|0)|0;o=Psc(Osc(m)|0)|0;p=Nsc(m)|0;q=ksc(n)|0;r=c[j+28>>2]|0;c[k+4>>2]=m;c[k+8>>2]=h;c[k+12>>2]=q;c[k+16>>2]=n;c[k+20>>2]=o;c[k+24>>2]=p;c[k+28>>2]=r;c[k+32>>2]=b;c[k+36>>2]=g;b=YYc(j,k+4|0,l)|0;if(!b){if((g+-17|0)>>>0>=2){i=f;return}ZYc(j,k,d,e);i=f;return}else{if(((a[l>>0]^1)&a[j+25>>0])<<24>>24){i=f;return}c[k+44>>2]=b;gWc(d,k);i=f;return}}function FWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+12>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 11:{l=2803;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2798;break}case 13:{l=2805;break}case 7:{l=2796;break}case 8:{l=2800;break}case 4:{l=2797;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2796;break}case 5:{l=2798;break}case 10:{l=2802;break}case 12:{l=2804;break}case 9:{l=2801;break}case 14:{l=2795;break}case 6:{l=2799;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2798;break a}else if((m|0)==8){l=2800;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2819;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2820}else l=0}else l=2818;else l=2817;else l=2816}else l=0;else l=2815;else l=2814;else l=2813;else l=2812;else l=2811;else l=2810;else l=2809;else l=2808;else l=2807;else l=2806}while(0);i=f;return l|0}function GWc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+128|0;j=h+56|0;k=h+52|0;l=h+32|0;m=h+12|0;n=h;o=e+4|0;if(!(lXc(c[o>>2]|0)|0)){i=h;return}p=c[o>>2]|0;q=e+24|0;c[l>>2]=p;c[l+4>>2]=p;c[l+8>>2]=(Xbd()|0)+36;b[l+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[l+12>>2]=(c[e+32>>2]|0)+1;c[m>>2]=0;q=m+8|0;c[q>>2]=0;p=m+12|0;c[p>>2]=0;r=m+4|0;c[r>>2]=60;s=m+16|0;t=f+16|0;a[s>>0]=a[t>>0]|0;bWc(l,m,g,0);g=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(g|0)==0)){q=j+4|0;l=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(l|0));c[j>>2]=2821;q=c[e>>2]|0;l=Ksc(q)|0;u=$sc(Osc(q)|0)|0;v=Psc(Osc(q)|0)|0;w=Nsc(q)|0;x=ksc(u)|0;y=c[e+28>>2]|0;z=c[o>>2]|0;o=c[e+12>>2]|0;c[j+4>>2]=q;c[j+8>>2]=l;c[j+12>>2]=x;c[j+16>>2]=u;c[j+20>>2]=v;c[j+24>>2]=w;c[j+28>>2]=y;c[j+32>>2]=z;c[j+36>>2]=o;o=n;n=c[o+4>>2]|0;z=j+40|0;c[z>>2]=c[o>>2];c[z+4>>2]=n;c[j+48>>2]=g;gWc(f,j);nXc(f,m);a[t>>0]=(a[t>>0]|0)==0?a[s>>0]|0:1}if((c[p>>2]|0)<=-1){i=h;return}p=c[m>>2]|0;c[k>>2]=c[r>>2];c[j+0>>2]=c[k+0>>2];eOb(p,j);c[m>>2]=0;i=h;return}function HWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+176|0;g=f+128|0;h=f+116|0;j=f+64|0;k=f;l=f+168|0;a[h>>0]=1;c[h+4>>2]=0;c[h+8>>2]=0;C8c(g,h,c[b>>2]|0);h=j+0|0;m=b+0|0;n=h+40|0;do{c[h>>2]=c[m>>2];h=h+4|0;m=m+4|0}while((h|0)<(n|0));m=c[b>>2]|0;c[j>>2]=m;b=F8c(g)|0;c[j+40>>2]=b;g=Psc(gsc(b)|0)|0;c[j+44>>2]=g;o=j+32|0;c[o>>2]=(c[o>>2]|0)+1;h=k+4|0;n=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(n|0));c[k>>2]=2822;h=Ksc(m)|0;n=$sc(Osc(m)|0)|0;o=Psc(Osc(m)|0)|0;p=Nsc(m)|0;q=ksc(n)|0;r=c[j+28>>2]|0;c[k+4>>2]=m;c[k+8>>2]=h;c[k+12>>2]=q;c[k+16>>2]=n;c[k+20>>2]=o;c[k+24>>2]=p;c[k+28>>2]=r;c[k+32>>2]=b;c[k+36>>2]=g;b=AZc(j,k+4|0,l)|0;if(!b){if((g+-17|0)>>>0>=2){i=f;return}BZc(j,k,d,e);i=f;return}else{if(((a[l>>0]^1)&a[j+25>>0])<<24>>24){i=f;return}c[k+44>>2]=b;gWc(d,k);i=f;return}}function IWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+4>>2]|0;j=c[b+12>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 13:{l=2833;break}case 6:{l=2827;break}case 7:{l=2824;break}case 12:{l=2832;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2826;break}case 4:{l=2825;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2824;break}case 11:{l=2831;break}case 8:{l=2828;break}case 9:{l=2829;break}case 14:{l=2823;break}case 10:{l=2830;break}case 5:{l=2826;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2826;break a}else if((m|0)==8){l=2828;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2847;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2848}else l=0}else l=2846;else l=2845;else l=2844}else l=0;else l=2843;else l=2842;else l=2841;else l=2840;else l=2839;else l=2838;else l=2837;else l=2836;else l=2835;else l=2834}while(0);i=f;return l|0}function JWc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+128|0;j=h+56|0;k=h+52|0;l=h+32|0;m=h+12|0;n=h;o=e+4|0;if(!(lXc(c[o>>2]|0)|0)){i=h;return}p=c[o>>2]|0;q=e+24|0;c[l>>2]=p;c[l+4>>2]=p;c[l+8>>2]=(Xbd()|0)+36;b[l+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[l+12>>2]=(c[e+32>>2]|0)+1;c[m>>2]=0;q=m+8|0;c[q>>2]=0;p=m+12|0;c[p>>2]=0;r=m+4|0;c[r>>2]=60;s=m+16|0;t=f+16|0;a[s>>0]=a[t>>0]|0;cWc(l,m,g,0);g=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(g|0)==0)){q=j+4|0;l=q+60|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(l|0));c[j>>2]=2849;q=c[e>>2]|0;l=Ksc(q)|0;u=$sc(Osc(q)|0)|0;v=Psc(Osc(q)|0)|0;w=Nsc(q)|0;x=ksc(u)|0;y=c[e+28>>2]|0;z=c[o>>2]|0;o=c[e+12>>2]|0;c[j+4>>2]=q;c[j+8>>2]=l;c[j+12>>2]=x;c[j+16>>2]=u;c[j+20>>2]=v;c[j+24>>2]=w;c[j+28>>2]=y;c[j+32>>2]=z;c[j+36>>2]=o;o=n;n=c[o+4>>2]|0;z=j+40|0;c[z>>2]=c[o>>2];c[z+4>>2]=n;c[j+48>>2]=g;gWc(f,j);nXc(f,m);a[t>>0]=(a[t>>0]|0)==0?a[s>>0]|0:1}if((c[p>>2]|0)<=-1){i=h;return}p=c[m>>2]|0;c[k>>2]=c[r>>2];c[j+0>>2]=c[k+0>>2];eOb(p,j);c[m>>2]=0;i=h;return}function KWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+80|0;f=e+40|0;g=e+8|0;h=e;j=e+16|0;C8c(f,d,c[b>>2]|0);c[g>>2]=0;k=g+4|0;c[k>>2]=-1;l=d+4|0;if(!(c[l>>2]|0))m=0;else{D8c(h,f);n=h;h=c[n+4>>2]|0;o=g;c[o>>2]=c[n>>2];c[o+4>>2]=h;m=c[l>>2]|0}a[j>>0]=a[d>>0]|0;c[j+4>>2]=m;c[j+8>>2]=c[d+8>>2];m=d+12|0;d=c[m+4>>2]|0;l=j+12|0;c[l>>2]=c[m>>2];c[l+4>>2]=d;c[j+20>>2]=g;In[c[b+40>>2]&4095](b,j);if((c[k>>2]|0)==-1){i=e;return}E8c(f,g);i=e;return}function LWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+40>>2]|0;j=c[b+44>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 6:{l=2854;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2851;break}case 5:{l=2853;break}case 7:{l=2851;break}case 4:{l=2852;break}case 11:{l=2858;break}case 10:{l=2857;break}case 13:{l=2860;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2853;break}case 8:{l=2855;break}case 12:{l=2859;break}case 14:{l=2850;break}case 9:{l=2856;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2853;break a}else if((m|0)==8){l=2855;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2874;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2875}else l=0}else l=2873;else l=2872;else l=2871}else l=0;else l=2870;else l=2869;else l=2868;else l=2867;else l=2866;else l=2865;else l=2864;else l=2863;else l=2862;else l=2861}while(0);i=f;return l|0}function MWc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+20|0;n=j;o=e+40|0;if(!(B_c(c[o>>2]|0)|0)){i=j;return}p=c[o>>2]|0;q=e+24|0;c[m>>2]=p;c[m+4>>2]=p;c[m+8>>2]=(Xbd()|0)+36;b[m+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[m+12>>2]=c[e+32>>2];c[n>>2]=0;q=n+8|0;c[q>>2]=0;p=n+12|0;c[p>>2]=0;r=n+4|0;c[r>>2]=60;a[n+16>>0]=0;YVc(m,n,h,0);h=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(h|0)==0)){c[f+44>>2]=2876;c[f+48>>2]=h;c[f+40>>2]=ksc(c[o>>2]|0)|0;gWc(g,f);nXc(g,n)}if((c[p>>2]|0)<=-1){i=j;return}p=c[n>>2]|0;c[l>>2]=c[r>>2];c[k+0>>2]=c[l+0>>2];eOb(p,k);c[n>>2]=0;i=j;return}function NWc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[d+20>>2]|0;d=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=e+16|0;e=c[g>>2]|0;h=e+12|0;j=c[h>>2]|0;k=j+2|0;if(k>>>0>(c[e+20>>2]|0)>>>0){Bid(h,d,2);l=c[g>>2]|0;Ndd(l);i=f;return}else{b[d>>1]=b[j>>1]|0;c[h>>2]=k;l=e;Ndd(l);i=f;return}}function OWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=d+16|0;d=c[f>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(g,b,1);j=c[f>>2]|0;Ndd(j);i=e;return}else{a[b>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1;j=c[f>>2]|0;Ndd(j);i=e;return}}function PWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=d+16|0;d=c[f>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(g,b,1);j=c[f>>2]|0;Ndd(j);i=e;return}else{a[b>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1;j=c[f>>2]|0;Ndd(j);i=e;return}}function QWc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[d+20>>2]|0;d=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=e+16|0;e=c[g>>2]|0;h=e+12|0;j=c[h>>2]|0;k=j+2|0;if(k>>>0>(c[e+20>>2]|0)>>>0){Bid(h,d,2);l=c[g>>2]|0;Ndd(l);i=f;return}else{b[d>>1]=b[j>>1]|0;c[h>>2]=k;l=e;Ndd(l);i=f;return}}function RWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);i=e;return}else{c[b>>2]=c[g>>2];c[d>>2]=h;i=e;return}}function SWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);i=e;return}else{c[b>>2]=c[g>>2];c[d>>2]=h;i=e;return}}function TWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+8|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,8);i=e;return}else{f=g;g=c[f+4>>2]|0;j=b;c[j>>2]=c[f>>2];c[j+4>>2]=g;c[d>>2]=h;i=e;return}}function UWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+8|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,8);i=e;return}else{f=g;g=c[f+4>>2]|0;j=b;c[j>>2]=c[f>>2];c[j+4>>2]=g;c[d>>2]=h;i=e;return}}function VWc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;h=c[d>>2]|0;j=h+4|0;if(j>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);i=e;return}else{g[b>>2]=ea(g[h>>2]);c[d>>2]=j;i=e;return}}function WWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;if((g+8|0)>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,8);i=e;return}else{a[k>>0]=a[g>>0];a[k+1>>0]=a[g+1>>0];a[k+2>>0]=a[g+2>>0];a[k+3>>0]=a[g+3>>0];a[k+4>>0]=a[g+4>>0];a[k+5>>0]=a[g+5>>0];a[k+6>>0]=a[g+6>>0];a[k+7>>0]=a[g+7>>0];h[k>>3]=+h[k>>3];a[b>>0]=a[k>>0];a[b+1>>0]=a[k+1>>0];a[b+2>>0]=a[k+2>>0];a[b+3>>0]=a[k+3>>0];a[b+4>>0]=a[k+4>>0];a[b+5>>0]=a[k+5>>0];a[b+6>>0]=a[k+6>>0];a[b+7>>0]=a[k+7>>0];c[d>>2]=(c[d>>2]|0)+8;i=e;return}}function XWc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];D_c(a,b,e);i=d;return}function YWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=c[d+16>>2]|0;h=c[b+28>>2]|0;j=c[g>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Pxc(f,g);g=Z8c(c[f>>2]|0,h,0,j)|0;j=c[b+20>>2]|0;c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?j:j+-8|0)>>2]=g;i=e;return}function ZWc(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;E_c(a,b,c);i=c;return}function _Wc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+b|0;j=c[d+16>>2]|0;d=j+12|0;k=c[d>>2]|0;l=k+4|0;m=j+20|0;j=c[m>>2]|0;if(l>>>0>j>>>0){Bid(d,h,4);n=c[d>>2]|0;o=c[m>>2]|0}else{g[h>>2]=ea(g[k>>2]);c[d>>2]=l;n=l;o=j}j=f+(b+4)|0;l=n+4|0;if(l>>>0>o>>>0){Bid(d,j,4);p=c[d>>2]|0;q=c[m>>2]|0}else{g[j>>2]=ea(g[n>>2]);c[d>>2]=l;p=l;q=o}o=f+(b+8)|0;b=p+4|0;if(b>>>0>q>>>0){Bid(d,o,4);i=e;return}else{g[o>>2]=ea(g[p>>2]);c[d>>2]=b;i=e;return}}function $Wc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+b|0;j=c[d+16>>2]|0;d=j+12|0;k=c[d>>2]|0;l=k+4|0;m=j+20|0;j=c[m>>2]|0;if(l>>>0>j>>>0){Bid(d,h,4);n=c[d>>2]|0;o=c[m>>2]|0}else{g[h>>2]=ea(g[k>>2]);c[d>>2]=l;n=l;o=j}j=f+(b+4)|0;b=n+4|0;if(b>>>0>o>>>0){Bid(d,j,4);i=e;return}else{g[j>>2]=ea(g[n>>2]);c[d>>2]=b;i=e;return}}function aXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;Qxc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function bXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;KYb(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function cXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;yHc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function dXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;rgc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function eXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;cdc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function fXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;JYb((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function gXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);i=e;return}else{c[b>>2]=c[g>>2];c[d>>2]=h;i=e;return}}function hXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);i=e;return}else{c[b>>2]=c[g>>2];c[d>>2]=h;i=e;return}}function iXc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];F_c(a,b,e);i=d;return}function jXc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];G_c(a,b,e);i=d;return}function kXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+28>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;H_c(f,c[d+16>>2]|0);h=b+20|0;b=c[h>>2]|0;j=d+4|0;k=c[(c[j>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2]|0;if(!k){b=ds(g)|0;Wrc(b);l=b}else l=k;k=c[l+8>>2]|0;c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];f=c[h>>2]|0;c[(c[j>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)>>2]=l;i=e;return}function lXc(a){a=a|0;var b=0,c=0,d=0;b=i;if(((((Rsc(a)|0)&8192|0)!=0?!(Vsc(a)|0):0)?!(Wsc(a)|0):0)?(c=etc(a)|0,(c|0)!=(dtc()|0)):0)d=(otc(Atc()|0,c)|0)!=-1;else d=0;i=b;return d|0}function mXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e+32|0;g=e+56|0;h=e+20|0;j=e;k=c[d+16>>2]|0;l=c[d+4>>2]|0;m=(c[b+32>>2]|0)==17;do if(l)if(m){n=c[b+20>>2]|0;o=l+((a[d>>0]|0)!=0?n:n+-8|0)|0;n=c[b+12>>2]|0;a[h>>0]=0;c[h+4>>2]=o;c[h+8>>2]=n;p=0;q=o;r=n;break}else{MVc(h,c[b>>2]|0,d,1);p=a[h>>0]|0;q=c[h+4>>2]|0;r=c[h+8>>2]|0;break}else{n=b+12|0;if(m)s=0;else s=ds(c[n>>2]|0)|0;o=c[n>>2]|0;a[h>>0]=1;c[h+4>>2]=s;c[h+8>>2]=o;p=1;q=s;r=o}while(0);s=h+1|0;a[g+0>>0]=a[s+0>>0]|0;a[g+1>>0]=a[s+1>>0]|0;a[g+2>>0]=a[s+2>>0]|0;s=c[b+44>>2]|0;b=(c[d+12>>2]|0)+4|0;d=c[b>>2]|0;h=d+(s<<6)|0;c[b>>2]=h;b=j+4|0;c[b>>2]=d;c[j>>2]=d;m=j+8|0;c[m>>2]=h;l=s<<6>>6;c[j+16>>2]=l;o=j+12|0;c[o>>2]=l;c[f+16>>2]=k;a[f>>0]=p;p=f+1|0;a[p+0>>0]=a[g+0>>0]|0;a[p+1>>0]=a[g+1>>0]|0;a[p+2>>0]=a[g+2>>0]|0;c[f+4>>2]=q;c[f+8>>2]=r;c[f+12>>2]=j;if(!s){i=e;return}else{t=d;u=h}do{h=t+64|0;c[b>>2]=h;c[o>>2]=u-h>>6;In[c[t>>2]&4095](t+4|0,f);t=c[b>>2]|0;u=c[m>>2]|0}while((t|0)!=(u|0));i=e;return}function nXc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+8|0;if(!(c[g>>2]|0)){i=d;return}h=a+8|0;j=a+12|0;k=a+4|0;l=c[b>>2]|0;do{m=(c[h>>2]|0)+1|0;c[h>>2]=m;n=c[j>>2]|0;o=n&2147483647;if(m>>>0>o>>>0){p=n<<1;q=(p|0)==0?1:p;do if(o>>>0<q>>>0)if((n|0)>-1){c[j>>2]=q;p=c[a>>2]|0;c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(p,q<<6,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[k>>2];c[e+0>>2]=c[f+0>>2];p=cOb(q<<6,4,e,0,3653512,352)|0;YEi(p|0,c[a>>2]|0,c[h>>2]<<6|0)|0;c[j>>2]=q;c[a>>2]=p;break}while(0);r=c[h>>2]|0}else r=m;q=(c[a>>2]|0)+(r+-1<<6)+0|0;n=l+0|0;o=q+64|0;do{c[q>>2]=c[n>>2];q=q+4|0;n=n+4|0}while((q|0)<(o|0));l=l+64|0}while((l|0)!=((c[b>>2]|0)+(c[g>>2]<<6)|0));i=d;return}function oXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+80|0;f=e+40|0;g=e+8|0;h=e;j=e+16|0;C8c(f,d,c[b>>2]|0);c[g>>2]=0;k=g+4|0;c[k>>2]=-1;l=d+4|0;if(!((c[l>>2]|0)!=0?(D8c(h,f),m=h,h=c[m>>2]|0,n=c[m+4>>2]|0,m=g,c[m>>2]=h,c[m+4>>2]=n,!(n>>>0>4294967294|(n|0)==-2&h>>>0>4294967295)):0)){h=F8c(f)|0;c[g>>2]=Isc(h,Zsc(h)|0,0)|0;c[k>>2]=0}a[j>>0]=a[d>>0]|0;c[j+4>>2]=c[l>>2];c[j+8>>2]=c[d+8>>2];l=d+12|0;d=c[l+4>>2]|0;k=j+12|0;c[k>>2]=c[l>>2];c[k+4>>2]=d;c[j+20>>2]=g;In[c[b+40>>2]&4095](b,j);i=e;return}function pXc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+40>>2]|0;j=c[b+44>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 10:{l=2884;break}case 7:{l=2878;break}case 6:{l=2881;break}case 9:{l=2883;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2880;break}case 4:{l=2879;break}case 8:{l=2882;break}case 11:{l=2885;break}case 12:{l=2886;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2878;break}case 13:{l=2887;break}case 14:{l=2877;break}case 5:{l=2880;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2880;break a}else if((m|0)==8){l=2882;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2901;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2902}else l=0}else l=2900;else l=2899;else l=2898}else l=0;else l=2897;else l=2896;else l=2895;else l=2894;else l=2893;else l=2892;else l=2891;else l=2890;else l=2889;else l=2888}while(0);i=f;return l|0}function qXc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+20|0;n=j;o=e+40|0;if(!(B_c(c[o>>2]|0)|0)){i=j;return}p=c[o>>2]|0;q=e+24|0;c[m>>2]=p;c[m+4>>2]=p;c[m+8>>2]=(Xbd()|0)+36;b[m+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[m+12>>2]=c[e+32>>2];c[n>>2]=0;q=n+8|0;c[q>>2]=0;p=n+12|0;c[p>>2]=0;r=n+4|0;c[r>>2]=60;a[n+16>>0]=0;_Vc(m,n,h,0);h=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(h|0)==0)){c[f+44>>2]=2903;c[f+48>>2]=h;c[f+40>>2]=ksc(c[o>>2]|0)|0;gWc(g,f);nXc(g,n)}if((c[p>>2]|0)<=-1){i=j;return}p=c[n>>2]|0;c[l>>2]=c[r>>2];c[k+0>>2]=c[l+0>>2];eOb(p,k);c[n>>2]=0;i=j;return}function rXc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[d+20>>2]|0;d=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=e+16|0;e=c[g>>2]|0;h=e+12|0;j=c[h>>2]|0;k=j+2|0;if(k>>>0<(c[e+20>>2]|0)>>>0){b[j>>1]=b[d>>1]|0;c[h>>2]=k;l=e;Tdd(l);i=f;return}else{Gid(h,d,2);l=c[g>>2]|0;Tdd(l);i=f;return}}function sXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=d+16|0;d=c[f>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h+1|0)>>>0<(c[d+20>>2]|0)>>>0){a[h>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;j=c[f>>2]|0;Tdd(j);i=e;return}else{Gid(g,b,1);j=c[f>>2]|0;Tdd(j);i=e;return}}function tXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=d+16|0;d=c[f>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h+1|0)>>>0<(c[d+20>>2]|0)>>>0){a[h>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;j=c[f>>2]|0;Tdd(j);i=e;return}else{Gid(g,b,1);j=c[f>>2]|0;Tdd(j);i=e;return}}function uXc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[d+20>>2]|0;d=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=e+16|0;e=c[g>>2]|0;h=e+12|0;j=c[h>>2]|0;k=j+2|0;if(k>>>0<(c[e+20>>2]|0)>>>0){b[j>>1]=b[d>>1]|0;c[h>>2]=k;l=e;Tdd(l);i=f;return}else{Gid(h,d,2);l=c[g>>2]|0;Tdd(l);i=f;return}}function vXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0<(c[f+20>>2]|0)>>>0){c[g>>2]=c[b>>2];c[d>>2]=h;i=e;return}else{Gid(d,b,4);i=e;return}}function wXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0<(c[f+20>>2]|0)>>>0){c[g>>2]=c[b>>2];c[d>>2]=h;i=e;return}else{Gid(d,b,4);i=e;return}}function xXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+8|0;if(h>>>0<(c[f+20>>2]|0)>>>0){f=b;j=c[f+4>>2]|0;k=g;c[k>>2]=c[f>>2];c[k+4>>2]=j;c[d>>2]=h;i=e;return}else{Gid(d,b,8);i=e;return}}function yXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+8|0;if(h>>>0<(c[f+20>>2]|0)>>>0){f=b;j=c[f+4>>2]|0;k=g;c[k>>2]=c[f>>2];c[k+4>>2]=j;c[d>>2]=h;i=e;return}else{Gid(d,b,8);i=e;return}}function zXc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;h=c[d>>2]|0;j=h+4|0;if(j>>>0<(c[f+20>>2]|0)>>>0){g[h>>2]=ea(g[b>>2]);c[d>>2]=j;i=e;return}else{Gid(d,b,4);i=e;return}}function AXc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[b+20>>2]|0;b=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=c[e+16>>2]|0;e=g+12|0;h=c[e>>2]|0;if((h+8|0)>>>0<(c[g+20>>2]|0)>>>0){g=b;j=g;k=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;j=g+4|0;g=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;j=h;h=j;a[h>>0]=k;a[h+1>>0]=k>>8;a[h+2>>0]=k>>16;a[h+3>>0]=k>>24;k=j+4|0;a[k>>0]=g;a[k+1>>0]=g>>8;a[k+2>>0]=g>>16;a[k+3>>0]=g>>24;c[e>>2]=(c[e>>2]|0)+8;i=f;return}else{Gid(e,b,8);i=f;return}}function BXc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];h$c(a,b,e);i=d;return}function CXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;c[f+4>>2]=0;c[f+8>>2]=0;g=c[d+16>>2]|0;h=c[b+20>>2]|0;c[f>>2]=Grc(c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?h:h+-8|0)>>2]|0)|0;Yxc(f,g);i=e;return}function DXc(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;i$c(a,b,c);i=c;return}function EXc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+b|0;j=c[d+16>>2]|0;d=j+12|0;k=c[d>>2]|0;l=k+4|0;m=j+20|0;j=c[m>>2]|0;if(l>>>0<j>>>0){g[k>>2]=ea(g[h>>2]);c[d>>2]=l;n=l;o=j}else{Gid(d,h,4);n=c[d>>2]|0;o=c[m>>2]|0}h=f+(b+4)|0;j=n+4|0;if(j>>>0<o>>>0){g[n>>2]=ea(g[h>>2]);c[d>>2]=j;p=j;q=o}else{Gid(d,h,4);p=c[d>>2]|0;q=c[m>>2]|0}m=f+(b+8)|0;b=p+4|0;if(b>>>0<q>>>0){g[p>>2]=ea(g[m>>2]);c[d>>2]=b;i=e;return}else{Gid(d,m,4);i=e;return}}function FXc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+b|0;j=c[d+16>>2]|0;d=j+12|0;k=c[d>>2]|0;l=k+4|0;m=j+20|0;j=c[m>>2]|0;if(l>>>0<j>>>0){g[k>>2]=ea(g[h>>2]);c[d>>2]=l;n=l;o=j}else{Gid(d,h,4);n=c[d>>2]|0;o=c[m>>2]|0}m=f+(b+4)|0;b=n+4|0;if(b>>>0<o>>>0){g[n>>2]=ea(g[m>>2]);c[d>>2]=b;i=e;return}else{Gid(d,m,4);i=e;return}}function GXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;mjc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function HXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;QYb(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function IXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;EHc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function JXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;Pfc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function KXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;jdc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function LXc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;PYb((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function MXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0<(c[f+20>>2]|0)>>>0){c[g>>2]=c[b>>2];c[d>>2]=h;i=e;return}else{Gid(d,b,4);i=e;return}}function NXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0<(c[f+20>>2]|0)>>>0){c[g>>2]=c[b>>2];c[d>>2]=h;i=e;return}else{Gid(d,b,4);i=e;return}}function OXc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];j$c(a,b,e);i=d;return}function PXc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];k$c(a,b,e);i=d;return}function QXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=c[b+28>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;h=c[d+16>>2]|0;j=c[b+20>>2]|0;b=c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?j:j+-8|0)>>2]|0;if(!b){j=ds(g)|0;Wrc(j);k=j}else k=b;b=c[k+8>>2]|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];l$c(f,h);i=e;return}function RXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e+32|0;g=e+56|0;h=e+20|0;j=e;k=c[d+16>>2]|0;l=c[d+4>>2]|0;m=(c[b+32>>2]|0)==17;do if(l)if(m){n=c[b+20>>2]|0;o=l+((a[d>>0]|0)!=0?n:n+-8|0)|0;n=c[b+12>>2]|0;a[h>>0]=0;c[h+4>>2]=o;c[h+8>>2]=n;p=0;q=o;r=n;break}else{MVc(h,c[b>>2]|0,d,1);p=a[h>>0]|0;q=c[h+4>>2]|0;r=c[h+8>>2]|0;break}else{n=b+12|0;if(m)s=0;else s=ds(c[n>>2]|0)|0;o=c[n>>2]|0;a[h>>0]=1;c[h+4>>2]=s;c[h+8>>2]=o;p=1;q=s;r=o}while(0);s=h+1|0;a[g+0>>0]=a[s+0>>0]|0;a[g+1>>0]=a[s+1>>0]|0;a[g+2>>0]=a[s+2>>0]|0;s=c[b+44>>2]|0;b=(c[d+12>>2]|0)+4|0;d=c[b>>2]|0;h=d+(s<<6)|0;c[b>>2]=h;b=j+4|0;c[b>>2]=d;c[j>>2]=d;m=j+8|0;c[m>>2]=h;l=s<<6>>6;c[j+16>>2]=l;o=j+12|0;c[o>>2]=l;c[f+16>>2]=k;a[f>>0]=p;p=f+1|0;a[p+0>>0]=a[g+0>>0]|0;a[p+1>>0]=a[g+1>>0]|0;a[p+2>>0]=a[g+2>>0]|0;c[f+4>>2]=q;c[f+8>>2]=r;c[f+12>>2]=j;if(!s){i=e;return}else{t=d;u=h}do{h=t+64|0;c[b>>2]=h;c[o>>2]=u-h>>6;In[c[t>>2]&4095](t+4|0,f);t=c[b>>2]|0;u=c[m>>2]|0}while((t|0)!=(u|0));i=e;return}function SXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+80|0;f=e+40|0;g=e+8|0;h=e;j=e+16|0;C8c(f,d,c[b>>2]|0);c[g>>2]=0;c[g+4>>2]=-1;k=d+4|0;if(!(c[k>>2]|0))l=0;else{D8c(h,f);f=h;h=c[f+4>>2]|0;m=g;c[m>>2]=c[f>>2];c[m+4>>2]=h;l=c[k>>2]|0}a[j>>0]=a[d>>0]|0;c[j+4>>2]=l;c[j+8>>2]=c[d+8>>2];l=d+12|0;d=c[l+4>>2]|0;k=j+12|0;c[k>>2]=c[l>>2];c[k+4>>2]=d;c[j+20>>2]=g;In[c[b+40>>2]&4095](b,j);i=e;return}function TXc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+40>>2]|0;j=c[b+44>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 12:{l=2913;break}case 6:{l=2908;break}case 13:{l=2914;break}case 8:{l=2909;break}case 4:{l=2906;break}case 14:{l=2904;break}case 7:{l=2905;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2905;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2907;break}case 5:{l=2907;break}case 10:{l=2911;break}case 11:{l=2912;break}case 9:{l=2910;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==8){l=2909;break a}else if((m|0)==5){l=2907;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2928;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2929}else l=0}else l=2927;else l=2926;else l=2925}else l=0;else l=2924;else l=2923;else l=2922;else l=2921;else l=2920;else l=2919;else l=2918;else l=2917;else l=2916;else l=2915}while(0);i=f;return l|0}function UXc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+20|0;n=j;o=e+40|0;if(!(B_c(c[o>>2]|0)|0)){i=j;return}p=c[o>>2]|0;q=e+24|0;c[m>>2]=p;c[m+4>>2]=p;c[m+8>>2]=(Xbd()|0)+36;b[m+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[m+12>>2]=c[e+32>>2];c[n>>2]=0;q=n+8|0;c[q>>2]=0;p=n+12|0;c[p>>2]=0;r=n+4|0;c[r>>2]=60;a[n+16>>0]=0;$Vc(m,n,h,0);h=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(h|0)==0)){c[f+44>>2]=2930;c[f+48>>2]=h;c[f+40>>2]=ksc(c[o>>2]|0)|0;gWc(g,f);nXc(g,n)}if((c[p>>2]|0)<=-1){i=j;return}p=c[n>>2]|0;c[l>>2]=c[r>>2];c[k+0>>2]=c[l+0>>2];eOb(p,k);c[n>>2]=0;i=j;return}function VXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;g=d+16|0;h=c[g>>2]|0;add(h,c[b+4>>2]|0,c[142296]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[h+12>>2]>>2]|0)+((c[h+20>>2]|0)*24|0)+12>>2]=2;bdd(h);fdd(c[g>>2]|0);i=e;return}function WXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;g=d+16|0;h=c[g>>2]|0;add(h,c[b+4>>2]|0,c[142292]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[h+12>>2]>>2]|0)+((c[h+20>>2]|0)*24|0)+12>>2]=1;bdd(h);fdd(c[g>>2]|0);i=e;return}function XXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;g=d+16|0;h=c[g>>2]|0;add(h,c[b+4>>2]|0,c[142302]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[h+12>>2]>>2]|0)+((c[h+20>>2]|0)*24|0)+12>>2]=1;bdd(h);fdd(c[g>>2]|0);i=e;return}function YXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[b+20>>2]|0;g=d+16|0;h=c[g>>2]|0;add(h,c[b+4>>2]|0,c[142286]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[h+12>>2]>>2]|0)+((c[h+20>>2]|0)*24|0)+12>>2]=2;bdd(h);fdd(c[g>>2]|0);i=e;return}function ZXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=c[d+16>>2]|0;add(g,c[b+4>>2]|0,c[142270]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[g+12>>2]>>2]|0)+((c[g+20>>2]|0)*24|0)+12>>2]=4;bdd(g);i=e;return}function _Xc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=c[d+16>>2]|0;add(g,c[b+4>>2]|0,c[142304]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[g+12>>2]>>2]|0)+((c[g+20>>2]|0)*24|0)+12>>2]=4;bdd(g);i=e;return}function $Xc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=c[d+16>>2]|0;add(g,c[b+4>>2]|0,c[142290]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[g+12>>2]>>2]|0)+((c[g+20>>2]|0)*24|0)+12>>2]=8;bdd(g);i=e;return}function aYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=c[d+16>>2]|0;add(g,c[b+4>>2]|0,c[142300]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[g+12>>2]>>2]|0)+((c[g+20>>2]|0)*24|0)+12>>2]=8;bdd(g);i=e;return}function bYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=c[d+16>>2]|0;add(g,c[b+4>>2]|0,c[142268]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[g+12>>2]>>2]|0)+((c[g+20>>2]|0)*24|0)+12>>2]=4;bdd(g);i=e;return}function cYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=c[d+16>>2]|0;add(g,c[b+4>>2]|0,c[142264]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+24>>2]|0);c[(c[c[g+12>>2]>>2]|0)+((c[g+20>>2]|0)*24|0)+12>>2]=8;bdd(g);i=e;return}function dYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];M$c(a,b,e);i=d;return}function eYc(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;N$c(a,b,c);i=c;return}function fYc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;gfc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function gYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+20>>2]|0;g=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+g|0;j=c[d+16>>2]|0;add(j,c[b+4>>2]|0,c[142308]|0,h,c[b+24>>2]|0);b=c[($hd(j+16|0)|0)+20>>2]|2097152;d=j+12|0;k=j+20|0;c[(c[c[d>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=b;b=c[142268]|0;add(j,3143216,b,h,0);c[(c[c[d>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(j);add(j,3143224,b,f+(g+4)|0,0);c[(c[c[d>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(j);bdd(j);i=e;return}function hYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,c[142312]|0,g,c[b+24>>2]|0);ljc(g,f);bdd(f);i=e;return}function iYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,c[142280]|0,g,c[b+24>>2]|0);FYb(g,f);bdd(f);i=e;return}function jYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,c[142278]|0,g,c[b+24>>2]|0);uHc(g,f);bdd(f);i=e;return}function kYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,614736,g,c[b+24>>2]|0);cfc(g,f);bdd(f);i=e;return}function lYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;g=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+g|0;j=c[d+16>>2]|0;add(j,c[b+4>>2]|0,614728,h,c[b+24>>2]|0);gfc(j,h,2490904,0);gfc(j,f+(g+12)|0,614664,0);bdd(j);i=e;return}function mYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,c[142262]|0,g,c[b+24>>2]|0);EYb(g,f);bdd(f);i=e;return}function nYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,c[142262]|0,g,c[b+24>>2]|0);ddd(f,2);add(f,614656,c[142304]|0,g,1);c[(c[c[f+12>>2]>>2]|0)+((c[f+20>>2]|0)*24|0)+12>>2]=4;bdd(f);bdd(f);i=e;return}function oYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+20>>2]|0;g=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;add(f,c[b+4>>2]|0,614712,g,c[b+24>>2]|0);ddd(f,2);add(f,614648,c[142304]|0,g,4194305);c[(c[c[f+12>>2]>>2]|0)+((c[f+20>>2]|0)*24|0)+12>>2]=4;bdd(f);bdd(f);i=e;return}function pYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];O$c(a,b,e);i=d;return}function qYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];P$c(a,b,e);i=d;return}function rYc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;f=c[b+16>>2]|0;add(f,c[a+4>>2]|0,2390464,e,c[a+24>>2]|0);Q$c(e,f);bdd(f);i=d;return}function sYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+80|0;f=e+48|0;g=e+32|0;h=e+20|0;j=e;k=c[d+16>>2]|0;l=g+4|0;a[l>>0]=1;c[g+8>>2]=0;c[g+12>>2]=0;m=c[d+4>>2]|0;n=(c[b+32>>2]|0)==17;do if(m)if(n){o=c[b+20>>2]|0;p=m+((a[d>>0]|0)!=0?o:o+-8|0)|0;o=c[b+12>>2]|0;a[h>>0]=0;c[h+4>>2]=p;c[h+8>>2]=o;q=h;break}else{MVc(h,c[b>>2]|0,d,1);q=h;break}else{o=b+12|0;if(n)r=0;else r=ds(c[o>>2]|0)|0;p=c[o>>2]|0;a[h>>0]=1;c[h+4>>2]=r;c[h+8>>2]=p;q=h}while(0);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];q=c[b+44>>2]|0;h=(c[d+12>>2]|0)+4|0;d=c[h>>2]|0;r=d+(q<<6)|0;c[h>>2]=r;c[j+4>>2]=d;c[j>>2]=d;c[j+8>>2]=r;r=q<<6>>6;c[j+16>>2]=r;c[j+12>>2]=r;c[g>>2]=j;add(k,c[b+4>>2]|0,c[b+8>>2]|0,g,c[b+24>>2]|0);b=c[g>>2]|0;c[f+16>>2]=k;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=b;l=b+4|0;g=c[l>>2]|0;j=b+8|0;r=c[j>>2]|0;if((g|0)==(r|0)){bdd(k);i=e;return}q=b+12|0;b=g;g=r;do{r=b+64|0;c[l>>2]=r;c[q>>2]=g-r>>6;In[c[b>>2]&4095](b+4|0,f);b=c[l>>2]|0;g=c[j>>2]|0}while((b|0)!=(g|0));bdd(k);i=e;return}function tYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+80|0;f=e+40|0;g=e+8|0;h=e;j=e+16|0;k=c[d+16>>2]|0;C8c(f,d,c[b>>2]|0);c[g>>2]=0;l=g+4|0;c[l>>2]=-1;m=d+4|0;if(!((c[m>>2]|0)!=0?(D8c(h,f),n=h,h=c[n>>2]|0,o=c[n+4>>2]|0,n=g,c[n>>2]=h,c[n+4>>2]=o,!(o>>>0>4294967294|(o|0)==-2&h>>>0>4294967295)):0)){h=F8c(f)|0;c[g>>2]=Isc(h,Zsc(h)|0,0)|0;c[l>>2]=0}a[j>>0]=a[d>>0]|0;c[j+4>>2]=c[m>>2];c[j+8>>2]=c[d+8>>2];m=d+12|0;d=c[m+4>>2]|0;h=j+12|0;c[h>>2]=c[m>>2];c[h+4>>2]=d;c[j+20>>2]=g;In[c[b+40>>2]&4095](b,j);if((a[k+32>>0]|0)==0|(c[l>>2]|0)==-1){i=e;return}E8c(f,g);i=e;return}function uYc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+40>>2]|0;j=c[b+44>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 2:{l=d+24|0;c[l>>2]=c[l>>2]|256;m=2934;break}case 6:{m=2935;break}case 11:{m=2939;break}case 8:{m=2936;break}case 3:{l=d+24|0;c[l>>2]=c[l>>2]|33554432;m=2932;break}case 10:{m=2938;break}case 4:{m=2933;break}case 13:{m=2941;break}case 12:{m=2940;break}case 5:{m=2934;break}case 9:{m=2937;break}case 7:{m=2932;break}case 14:{m=2931;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){l=Psc(Usc(h)|0)|0;if((l|0)==5){m=2934;break a}else if((l|0)==8){m=2936;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);m=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;m=2955;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;m=2956}else m=0}else m=2954;else m=2953;else m=2952}else m=0;else m=2951;else m=2950;else m=2949;else m=2948;else m=2947;else m=2946;else m=2945;else m=2944;else m=2943;else m=2942}while(0);i=f;return m|0}function vYc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+20|0;n=j;o=e+40|0;if(!(B_c(c[o>>2]|0)|0)){i=j;return}p=c[o>>2]|0;q=e+24|0;c[m>>2]=p;c[m+4>>2]=p;c[m+8>>2]=(Xbd()|0)+36;b[m+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[m+12>>2]=c[e+32>>2];c[n>>2]=0;q=n+8|0;c[q>>2]=0;p=n+12|0;c[p>>2]=0;r=n+4|0;c[r>>2]=60;a[n+16>>0]=0;aWc(m,n,h,0);h=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(h|0)==0)){c[f+44>>2]=2957;c[f+48>>2]=h;c[f+40>>2]=ksc(c[o>>2]|0)|0;gWc(g,f);nXc(g,n)}if((c[p>>2]|0)<=-1){i=j;return}p=c[n>>2]|0;c[l>>2]=c[r>>2];c[k+0>>2]=c[l+0>>2];eOb(p,k);c[n>>2]=0;i=j;return}function wYc(a,b){a=a|0;b=b|0;return}function xYc(a,b){a=a|0;b=b|0;return}function yYc(a,b){a=a|0;b=b|0;return}function zYc(a,b){a=a|0;b=b|0;return}function AYc(a,b){a=a|0;b=b|0;return}function BYc(a,b){a=a|0;b=b|0;return}function CYc(a,b){a=a|0;b=b|0;return}function DYc(a,b){a=a|0;b=b|0;return}function EYc(a,b){a=a|0;b=b|0;return}function FYc(a,b){a=a|0;b=b|0;return}function GYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];q0c(a,b,e);i=d;return}function HYc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[c[b+16>>2]>>2]|0;c[e>>2]=c[a+28>>2];c[e+4>>2]=f;c[e+8>>2]=0;r0c(a,b,e);i=d;return}function IYc(a,b){a=a|0;b=b|0;return}function JYc(a,b){a=a|0;b=b|0;return}function KYc(a,b){a=a|0;b=b|0;return}function LYc(a,b){a=a|0;b=b|0;return}function MYc(a,b){a=a|0;b=b|0;return}function NYc(a,b){a=a|0;b=b|0;return}function OYc(a,b){a=a|0;b=b|0;return}function PYc(a,b){a=a|0;b=b|0;return}function QYc(a,b){a=a|0;b=b|0;return}function RYc(a,b){a=a|0;b=b|0;return}function SYc(a,b){a=a|0;b=b|0;return}function TYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];s0c(a,b,e);i=d;return}function UYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];t0c(a,b,e);i=d;return}function VYc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];u0c(a,b,e);i=d;return}function WYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e+32|0;g=e+56|0;h=e+20|0;j=e;k=c[d+16>>2]|0;l=c[d+4>>2]|0;m=(c[b+32>>2]|0)==17;do if(l)if(m){n=c[b+20>>2]|0;o=l+((a[d>>0]|0)!=0?n:n+-8|0)|0;n=c[b+12>>2]|0;a[h>>0]=0;c[h+4>>2]=o;c[h+8>>2]=n;p=0;q=o;r=n;break}else{MVc(h,c[b>>2]|0,d,1);p=a[h>>0]|0;q=c[h+4>>2]|0;r=c[h+8>>2]|0;break}else{n=b+12|0;if(m)s=0;else s=ds(c[n>>2]|0)|0;o=c[n>>2]|0;a[h>>0]=1;c[h+4>>2]=s;c[h+8>>2]=o;p=1;q=s;r=o}while(0);s=h+1|0;a[g+0>>0]=a[s+0>>0]|0;a[g+1>>0]=a[s+1>>0]|0;a[g+2>>0]=a[s+2>>0]|0;s=c[b+44>>2]|0;h=(c[d+12>>2]|0)+4|0;d=c[h>>2]|0;m=d+(s<<6)|0;c[h>>2]=m;h=j+4|0;c[h>>2]=d;c[j>>2]=d;l=j+8|0;c[l>>2]=m;o=s<<6>>6;c[j+16>>2]=o;n=j+12|0;c[n>>2]=o;o=c[b+24>>2]|0;if(!o){c[f+16>>2]=k;a[f>>0]=p;b=f+1|0;a[b+0>>0]=a[g+0>>0]|0;a[b+1>>0]=a[g+1>>0]|0;a[b+2>>0]=a[g+2>>0]|0;c[f+4>>2]=q;c[f+8>>2]=r;c[f+12>>2]=j;if(!s){i=e;return}else{t=d;u=m}do{m=t+64|0;c[h>>2]=m;c[n>>2]=u-m>>6;In[c[t>>2]&4095](t+4|0,f);t=c[h>>2]|0;u=c[l>>2]|0}while((t|0)!=(u|0));i=e;return}else{idd(k,o);c[f+16>>2]=k;a[f>>0]=p;p=f+1|0;a[p+0>>0]=a[g+0>>0]|0;a[p+1>>0]=a[g+1>>0]|0;a[p+2>>0]=a[g+2>>0]|0;c[f+4>>2]=q;c[f+8>>2]=r;c[f+12>>2]=j;j=c[h>>2]|0;r=c[l>>2]|0;if((j|0)!=(r|0)){q=j;j=r;do{r=q+64|0;c[h>>2]=r;c[n>>2]=j-r>>6;In[c[q>>2]&4095](q+4|0,f);q=c[h>>2]|0;j=c[l>>2]|0}while((q|0)!=(j|0))}jdd(k);i=e;return}}function XYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+80|0;f=e+40|0;g=e+8|0;h=e;j=e+16|0;C8c(f,d,c[b>>2]|0);c[g>>2]=0;k=g+4|0;c[k>>2]=-1;l=d+4|0;if(!(c[l>>2]|0))m=0;else{D8c(h,f);n=h;h=c[n+4>>2]|0;o=g;c[o>>2]=c[n>>2];c[o+4>>2]=h;m=c[l>>2]|0}a[j>>0]=a[d>>0]|0;c[j+4>>2]=m;c[j+8>>2]=c[d+8>>2];m=d+12|0;d=c[m+4>>2]|0;l=j+12|0;c[l>>2]=c[m>>2];c[l+4>>2]=d;c[j+20>>2]=g;In[c[b+40>>2]&4095](b,j);if((c[k>>2]|0)==-1){i=e;return}E8c(f,g);i=e;return}function YYc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+40>>2]|0;j=c[b+44>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 9:{l=2964;break}case 2:{m=d+24|0;c[m>>2]=c[m>>2]|256;l=2961;break}case 11:{l=2966;break}case 5:{l=2961;break}case 7:{l=2959;break}case 6:{l=2962;break}case 4:{l=2960;break}case 8:{l=2963;break}case 10:{l=2965;break}case 13:{l=2968;break}case 12:{l=2967;break}case 3:{m=d+24|0;c[m>>2]=c[m>>2]|33554432;l=2959;break}case 14:{l=2958;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){m=Psc(Usc(h)|0)|0;if((m|0)==5){l=2961;break a}else if((m|0)==8){l=2963;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);l=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;l=2982;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;l=2983}else l=0}else l=2981;else l=2980;else l=2979}else l=0;else l=2978;else l=2977;else l=2976;else l=2975;else l=2974;else l=2973;else l=2972;else l=2971;else l=2970;else l=2969}while(0);i=f;return l|0}function ZYc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+20|0;n=j;o=e+40|0;if(!(B_c(c[o>>2]|0)|0)){i=j;return}p=c[o>>2]|0;q=e+24|0;c[m>>2]=p;c[m+4>>2]=p;c[m+8>>2]=(Xbd()|0)+36;b[m+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[m+12>>2]=c[e+32>>2];c[n>>2]=0;q=n+8|0;c[q>>2]=0;p=n+12|0;c[p>>2]=0;r=n+4|0;c[r>>2]=60;a[n+16>>0]=0;bWc(m,n,h,0);h=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(h|0)==0)){c[f+44>>2]=2984;c[f+48>>2]=h;c[f+40>>2]=ksc(c[o>>2]|0)|0;gWc(g,f);nXc(g,n)}if((c[p>>2]|0)<=-1){i=j;return}p=c[n>>2]|0;c[l>>2]=c[r>>2];c[k+0>>2]=c[l+0>>2];eOb(p,k);c[n>>2]=0;i=j;return}function _Yc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;AUb(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function $Yc(a,b){a=a|0;b=b|0;var c=0;c=i;W0c(a,b);i=c;return}function aZc(a,b){a=a|0;b=b|0;var c=0;c=i;X0c(a,b);i=c;return}function bZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;RAc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function cZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142270]|0,f,0)|0;if(!d){i=e;return}if((d|0)>0){d=g+12|0;b=c[g+16>>2]|0;j=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;k=b+j|0;c[d>>2]=k;if((j|0)>=0?(l=b+(j+4)|0,l>>>0<=(c[g+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[d>>2]=l}else Bid(d,h,4);if(c[g>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}sdd(g);i=e;return}function dZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142304]|0,f,0)|0;if(!d){i=e;return}if((d|0)>0){d=g+12|0;b=c[g+16>>2]|0;j=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;k=b+j|0;c[d>>2]=k;if((j|0)>=0?(l=b+(j+4)|0,l>>>0<=(c[g+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[d>>2]=l}else Bid(d,h,4);if(c[g>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}sdd(g);i=e;return}function eZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(a[d>>0]|0)!=0?g:g+-8|0;g=c[d+4>>2]|0;j=g+h|0;k=c[d+16>>2]|0;d=qdd(k,c[b+4>>2]|0,c[142290]|0,f,0)|0;if(!d){i=e;return}if((d|0)>0){d=k+12|0;b=c[k+16>>2]|0;l=(c[(c[k+80>>2]|0)+12>>2]|0)-(da(c[k+32>>2]|0,c[k+28>>2]|0)|0)|0;m=b+l|0;c[d>>2]=m;if((l|0)>=0?(n=b+(l+8)|0,n>>>0<=(c[k+20>>2]|0)>>>0):0){l=m;m=c[l+4>>2]|0;b=j;c[b>>2]=c[l>>2];c[b+4>>2]=m;c[d>>2]=n}else Bid(d,j,8);if(c[k>>2]&512){d=XEi(c[j>>2]|0)|0;n=g+(h+4)|0;c[j>>2]=XEi(c[n>>2]|0)|0;c[n>>2]=d}}else{d=c[f>>2]|0;if(d)_n[d&4095](j,k)|0}sdd(k);i=e;return}function fZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(a[d>>0]|0)!=0?g:g+-8|0;g=c[d+4>>2]|0;j=g+h|0;k=c[d+16>>2]|0;d=qdd(k,c[b+4>>2]|0,c[142300]|0,f,0)|0;if(!d){i=e;return}if((d|0)>0){d=k+12|0;b=c[k+16>>2]|0;l=(c[(c[k+80>>2]|0)+12>>2]|0)-(da(c[k+32>>2]|0,c[k+28>>2]|0)|0)|0;m=b+l|0;c[d>>2]=m;if((l|0)>=0?(n=b+(l+8)|0,n>>>0<=(c[k+20>>2]|0)>>>0):0){l=m;m=c[l+4>>2]|0;b=j;c[b>>2]=c[l>>2];c[b+4>>2]=m;c[d>>2]=n}else Bid(d,j,8);if(c[k>>2]&512){d=XEi(c[j>>2]|0)|0;n=g+(h+4)|0;c[j>>2]=XEi(c[n>>2]|0)|0;c[n>>2]=d}}else{d=c[f>>2]|0;if(d)_n[d&4095](j,k)|0}sdd(k);i=e;return}function gZc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;h=c[b+20>>2]|0;j=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?h:h+-8|0)|0;h=c[d+16>>2]|0;d=qdd(h,c[b+4>>2]|0,c[142268]|0,f,0)|0;if(!d){i=e;return}if((d|0)>0){d=h+12|0;b=c[h+16>>2]|0;k=(c[(c[h+80>>2]|0)+12>>2]|0)-(da(c[h+32>>2]|0,c[h+28>>2]|0)|0)|0;l=b+k|0;c[d>>2]=l;if((k|0)>=0?(m=b+(k+4)|0,m>>>0<=(c[h+20>>2]|0)>>>0):0){g[j>>2]=ea(g[l>>2]);c[d>>2]=m}else Bid(d,j,4);if(c[h>>2]&512)c[j>>2]=XEi(c[j>>2]|0)|0}else{d=c[f>>2]|0;if(d)_n[d&4095](j,h)|0}sdd(h);i=e;return}function hZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;Y0c(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function iZc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];Z0c(a,b,e);i=d;return}function jZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=c[d+16>>2]|0;h=c[b+28>>2]|0;j=c[g>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;_0c(g,f,c[b+4>>2]|0,c[b+24>>2]|0);if(!(a[g+136>>0]|0)){i=e;return}g=Z8c(c[f>>2]|0,h,0,j)|0;j=c[b+20>>2]|0;c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?j:j+-8|0)>>2]=g;i=e;return}function kZc(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;$0c(a,b,c);i=c;return}function lZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142310]|0,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else _6b(h,g);sdd(g);i=e;return}function mZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142308]|0,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else hgc(h,g);sdd(g);i=e;return}function nZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142312]|0,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else igc(h,g);sdd(g);i=e;return}function oZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142280]|0,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else a1c(h,g);sdd(g);i=e;return}function pZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142278]|0,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else vHc(h,g);sdd(g);i=e;return}function qZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,614736,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else cgc(h,g);sdd(g);i=e;return}function rZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,614728,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else _cc(h,g);sdd(g);i=e;return}function sZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142262]|0,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else HYb(h,g);sdd(g);i=e;return}function tZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;jkc(c[d+16>>2]|0,(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[b+4>>2]|0,c[b+24>>2]|0);i=e;return}function uZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,614712,f,1)|0;if(!d){i=e;return}if((d|0)<=0){d=c[f>>2]|0;if(d)_n[d&4095](h,g)|0}else b1c(h,g);sdd(g);i=e;return}function vZc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];c1c(a,b,e);i=d;return}function wZc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];d1c(a,b,e);i=d;return}function xZc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];e1c(a,b,e);i=d;return}function yZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+80|0;f=e+56|0;g=e+48|0;h=e+32|0;j=e+20|0;k=e;l=c[d+16>>2]|0;m=h+4|0;a[m>>0]=1;c[h+8>>2]=0;c[h+12>>2]=0;n=c[d+4>>2]|0;o=(c[b+32>>2]|0)==17;do if(n)if(o){p=c[b+20>>2]|0;q=n+((a[d>>0]|0)!=0?p:p+-8|0)|0;p=c[b+12>>2]|0;a[j>>0]=0;c[j+4>>2]=q;c[j+8>>2]=p;r=j;break}else{MVc(j,c[b>>2]|0,d,1);r=j;break}else{p=b+12|0;if(o)s=0;else s=ds(c[p>>2]|0)|0;q=c[p>>2]|0;a[j>>0]=1;c[j+4>>2]=s;c[j+8>>2]=q;r=j}while(0);c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];r=c[b+44>>2]|0;j=(c[d+12>>2]|0)+4|0;d=c[j>>2]|0;s=d+(r<<6)|0;c[j>>2]=s;j=k+4|0;c[j>>2]=d;c[k>>2]=d;d=k+8|0;c[d>>2]=s;s=r<<6>>6;c[k+16>>2]=s;r=k+12|0;c[r>>2]=s;c[h>>2]=k;s=qdd(l,c[b+4>>2]|0,c[b+8>>2]|0,g,1)|0;if(!s){i=e;return}if((s|0)>0){c[f+16>>2]=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=k;k=c[j>>2]|0;m=c[d>>2]|0;if((k|0)!=(m|0)){s=k;k=m;do{m=s+64|0;c[j>>2]=m;c[r>>2]=k-m>>6;In[c[s>>2]&4095](s+4|0,f);s=c[j>>2]|0;k=c[d>>2]|0}while((s|0)!=(k|0))}}else{k=c[g>>2]|0;if(k)_n[k&4095](h,l)|0}sdd(l);i=e;return}function zZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+80|0;f=e+40|0;g=e+8|0;h=e;j=e+16|0;C8c(f,d,c[b>>2]|0);c[g>>2]=0;k=g+4|0;c[k>>2]=-1;l=d+4|0;if(!(c[l>>2]|0))m=0;else{D8c(h,f);n=h;h=c[n+4>>2]|0;o=g;c[o>>2]=c[n>>2];c[o+4>>2]=h;m=c[l>>2]|0}a[j>>0]=a[d>>0]|0;c[j+4>>2]=m;c[j+8>>2]=c[d+8>>2];m=d+12|0;d=c[m+4>>2]|0;l=j+12|0;c[l>>2]=c[m>>2];c[l+4>>2]=d;c[j+20>>2]=g;In[c[b+40>>2]&4095](b,j);if((c[k>>2]|0)==-1){i=e;return}E8c(f,g);i=e;return}function AZc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[b+40>>2]|0;j=c[b+44>>2]|0;a[e>>0]=0;k=c[b+36>>2]|0;a:do switch(j|0){case 3:{l=d+24|0;c[l>>2]=c[l>>2]|33554432;m=2986;break}case 7:{m=2986;break}case 2:{l=d+24|0;c[l>>2]=c[l>>2]|256;m=2988;break}case 13:{m=2995;break}case 10:{m=2992;break}case 4:{m=2987;break}case 5:{m=2988;break}case 6:{m=2989;break}case 8:{m=2990;break}case 12:{m=2994;break}case 9:{m=2991;break}case 11:{m=2993;break}case 14:{m=2985;break}default:if((h|0)!=(c[k+16>>2]|0))if((h|0)!=(c[k+12>>2]|0))if((h|0)!=(c[k+20>>2]|0))if((h|0)!=(c[k+24>>2]|0))if((h|0)!=(c[k+32>>2]|0))if((h|0)!=(c[k+36>>2]|0))if((h|0)!=(c[k+40>>2]|0))if((h|0)!=(c[k+52>>2]|0))if((h|0)!=(c[k+56>>2]|0))if((h|0)!=(c[k+92>>2]|0))if((h|0)!=(c[k+504>>2]|0)?(h|0)!=(c[k+508>>2]|0):0){if(jsc(h)|0){l=Psc(Usc(h)|0)|0;if((l|0)==8){m=2990;break a}else if((l|0)==5){m=2988;break a}Urc(g,c[b>>2]|0);if(!(a[g>>0]&1))n=g+1|0;else n=c[g+8>>2]|0;Krd(n,0,3653512,190,1,0,0,0);xri(g);m=0;break a}if((h|0)!=(c[k+292>>2]|0))if((h|0)!=(c[k+516>>2]|0))if((h|0)!=(c[k+28>>2]|0)){if((h|0)==(c[k+284>>2]|0)){a[e>>0]=1;m=3009;break a}if((j|0)==18?msc(h,c[k+252>>2]|0)|0:0){a[e>>0]=1;m=3010}else m=0}else m=3008;else m=3007;else m=3006}else m=0;else m=3005;else m=3004;else m=3003;else m=3002;else m=3001;else m=3e3;else m=2999;else m=2998;else m=2997;else m=2996}while(0);i=f;return m|0}function BZc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+20|0;n=j;o=e+40|0;if(!(B_c(c[o>>2]|0)|0)){i=j;return}p=c[o>>2]|0;q=e+24|0;c[m>>2]=p;c[m+4>>2]=p;c[m+8>>2]=(Xbd()|0)+36;b[m+16>>1]=d[q>>0]|d[q+1>>0]<<8;c[m+12>>2]=c[e+32>>2];c[n>>2]=0;q=n+8|0;c[q>>2]=0;p=n+12|0;c[p>>2]=0;r=n+4|0;c[r>>2]=60;a[n+16>>0]=0;cWc(m,n,h,0);h=c[q>>2]|0;if(!((a[e+25>>0]|0)!=0&(h|0)==0)){c[f+44>>2]=3011;c[f+48>>2]=h;c[f+40>>2]=ksc(c[o>>2]|0)|0;gWc(g,f);nXc(g,n)}if((c[p>>2]|0)<=-1){i=j;return}p=c[n>>2]|0;c[l>>2]=c[r>>2];c[k+0>>2]=c[l+0>>2];eOb(p,k);c[n>>2]=0;i=j;return}function CZc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=c[d+20>>2]|0;d=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=e+16|0;e=c[g>>2]|0;h=e+12|0;j=c[h>>2]|0;k=j+2|0;if(k>>>0>(c[e+20>>2]|0)>>>0){Bid(h,d,2);l=b[d>>1]|0;m=c[g>>2]|0}else{g=b[j>>1]|0;b[d>>1]=g;c[h>>2]=k;l=g;m=e}e=l&65535;b[d>>1]=e<<8|e>>>8;Mdd(m);i=f;return}function DZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=d+16|0;d=c[f>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(g,b,1);j=c[f>>2]|0;Mdd(j);i=e;return}else{a[b>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1;j=c[f>>2]|0;Mdd(j);i=e;return}}function EZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=d+16|0;d=c[f>>2]|0;g=d+12|0;h=c[g>>2]|0;if((h+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(g,b,1);j=c[f>>2]|0;Mdd(j);i=e;return}else{a[b>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1;j=c[f>>2]|0;Mdd(j);i=e;return}}function FZc(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=c[d+20>>2]|0;d=(c[e+4>>2]|0)+((a[e>>0]|0)!=0?g:g+-8|0)|0;g=e+16|0;e=c[g>>2]|0;h=e+12|0;j=c[h>>2]|0;k=j+2|0;if(k>>>0>(c[e+20>>2]|0)>>>0){Bid(h,d,2);l=b[d>>1]|0;m=c[g>>2]|0}else{g=b[j>>1]|0;b[d>>1]=g;c[h>>2]=k;l=g;m=e}e=l&65535;b[d>>1]=e<<8|e>>>8;Mdd(m);i=f;return}function GZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);j=c[b>>2]|0;k=XEi(j|0)|0;c[b>>2]=k;i=e;return}else{f=c[g>>2]|0;c[b>>2]=f;c[d>>2]=h;j=f;k=XEi(j|0)|0;c[b>>2]=k;i=e;return}}function HZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);j=c[b>>2]|0;k=XEi(j|0)|0;c[b>>2]=k;i=e;return}else{f=c[g>>2]|0;c[b>>2]=f;c[d>>2]=h;j=f;k=XEi(j|0)|0;c[b>>2]=k;i=e;return}}function IZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;g=f+b|0;h=c[d+16>>2]|0;d=h+12|0;j=c[d>>2]|0;k=j+8|0;if(k>>>0>(c[h+20>>2]|0)>>>0){Bid(d,g,8);h=f+(b+4)|0;l=g;m=h;n=c[g>>2]|0;o=c[h>>2]|0;p=XEi(n|0)|0;q=XEi(o|0)|0;c[l>>2]=q;c[m>>2]=p;i=e;return}else{h=j;j=c[h>>2]|0;r=c[h+4>>2]|0;h=g;c[h>>2]=j;c[h+4>>2]=r;c[d>>2]=k;l=g;m=f+(b+4)|0;n=j;o=r;p=XEi(n|0)|0;q=XEi(o|0)|0;c[l>>2]=q;c[m>>2]=p;i=e;return}}function JZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;g=f+b|0;h=c[d+16>>2]|0;d=h+12|0;j=c[d>>2]|0;k=j+8|0;if(k>>>0>(c[h+20>>2]|0)>>>0){Bid(d,g,8);h=f+(b+4)|0;l=g;m=h;n=c[g>>2]|0;o=c[h>>2]|0;p=XEi(n|0)|0;q=XEi(o|0)|0;c[l>>2]=q;c[m>>2]=p;i=e;return}else{h=j;j=c[h>>2]|0;r=c[h+4>>2]|0;h=g;c[h>>2]=j;c[h+4>>2]=r;c[d>>2]=k;l=g;m=f+(b+4)|0;n=j;o=r;p=XEi(n|0)|0;q=XEi(o|0)|0;c[l>>2]=q;c[m>>2]=p;i=e;return}}function KZc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=Im;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;h=c[d>>2]|0;j=h+4|0;if(j>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);l=b;m=c[b>>2]|0;n=XEi(m|0)|0;c[l>>2]=n;i=e;return}else{o=ea(g[h>>2]);g[b>>2]=o;c[d>>2]=j;l=b;m=(g[k>>2]=o,c[k>>2]|0);n=XEi(m|0)|0;c[l>>2]=n;i=e;return}}function LZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;g=f+b|0;j=c[d+16>>2]|0;d=j+12|0;l=c[d>>2]|0;if((l+8|0)>>>0>(c[j+20>>2]|0)>>>0){Bid(d,g,8);j=f+(b+4)|0;m=g;n=j;o=c[g>>2]|0;p=c[j>>2]|0;q=XEi(o|0)|0;r=XEi(p|0)|0;c[m>>2]=r;c[n>>2]=q;i=e;return}else{a[k>>0]=a[l>>0];a[k+1>>0]=a[l+1>>0];a[k+2>>0]=a[l+2>>0];a[k+3>>0]=a[l+3>>0];a[k+4>>0]=a[l+4>>0];a[k+5>>0]=a[l+5>>0];a[k+6>>0]=a[l+6>>0];a[k+7>>0]=a[l+7>>0];s=+h[k>>3];h[k>>3]=s;a[g>>0]=a[k>>0];a[g+1>>0]=a[k+1>>0];a[g+2>>0]=a[k+2>>0];a[g+3>>0]=a[k+3>>0];a[g+4>>0]=a[k+4>>0];a[g+5>>0]=a[k+5>>0];a[g+6>>0]=a[k+6>>0];a[g+7>>0]=a[k+7>>0];c[d>>2]=(c[d>>2]|0)+8;h[k>>3]=s;m=g;n=f+(b+4)|0;o=c[k>>2]|0;p=c[k+4>>2]|0;q=XEi(o|0)|0;r=XEi(p|0)|0;c[m>>2]=r;c[n>>2]=q;i=e;return}}function MZc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];G1c(a,b,e);i=d;return}function NZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=c[d+16>>2]|0;h=c[b+28>>2]|0;j=c[g>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Vxc(f,g);g=Z8c(c[f>>2]|0,h,0,j)|0;j=c[b+20>>2]|0;c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?j:j+-8|0)>>2]=g;i=e;return}function OZc(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;H1c(a,b,c);i=c;return}function PZc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+b|0;j=c[d+16>>2]|0;d=j+12|0;l=c[d>>2]|0;m=l+4|0;n=j+20|0;j=c[n>>2]|0;if(m>>>0>j>>>0){Bid(d,h,4);o=h;p=c[h>>2]|0;q=c[d>>2]|0;r=c[n>>2]|0}else{s=ea(g[l>>2]);g[h>>2]=s;c[d>>2]=m;o=h;p=(g[k>>2]=s,c[k>>2]|0);q=m;r=j}c[o>>2]=XEi(p|0)|0;p=f+(b+4)|0;o=q+4|0;if(o>>>0>r>>>0){Bid(d,p,4);t=p;u=c[p>>2]|0;v=c[d>>2]|0;w=c[n>>2]|0}else{s=ea(g[q>>2]);g[p>>2]=s;c[d>>2]=o;t=p;u=(g[k>>2]=s,c[k>>2]|0);v=o;w=r}c[t>>2]=XEi(u|0)|0;u=f+(b+8)|0;b=v+4|0;if(b>>>0>w>>>0){Bid(d,u,4);x=u;y=c[u>>2]|0;z=XEi(y|0)|0;c[x>>2]=z;i=e;return}else{s=ea(g[v>>2]);g[u>>2]=s;c[d>>2]=b;x=u;y=(g[k>>2]=s,c[k>>2]|0);z=XEi(y|0)|0;c[x>>2]=z;i=e;return}}function QZc(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0;e=i;f=c[b+20>>2]|0;b=(a[d>>0]|0)!=0?f:f+-8|0;f=c[d+4>>2]|0;h=f+b|0;j=c[d+16>>2]|0;d=j+12|0;l=c[d>>2]|0;m=l+4|0;n=j+20|0;j=c[n>>2]|0;if(m>>>0>j>>>0){Bid(d,h,4);o=h;p=c[h>>2]|0;q=c[d>>2]|0;r=c[n>>2]|0}else{s=ea(g[l>>2]);g[h>>2]=s;c[d>>2]=m;o=h;p=(g[k>>2]=s,c[k>>2]|0);q=m;r=j}c[o>>2]=XEi(p|0)|0;p=f+(b+4)|0;b=q+4|0;if(b>>>0>r>>>0){Bid(d,p,4);t=p;u=c[p>>2]|0;v=XEi(u|0)|0;c[t>>2]=v;i=e;return}else{s=ea(g[q>>2]);g[p>>2]=s;c[d>>2]=b;t=p;u=(g[k>>2]=s,c[k>>2]|0);v=XEi(u|0)|0;c[t>>2]=v;i=e;return}}function RZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;ojc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function SZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;NYb((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function TZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;BHc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function UZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;xgc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function VZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;gdc((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function WZc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+20>>2]|0;MYb((c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0,c[d+16>>2]|0);i=e;return}function XZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);j=c[b>>2]|0;c[b>>2]=j;i=e;return}else{f=c[g>>2]|0;c[b>>2]=f;c[d>>2]=h;j=f;c[b>>2]=j;i=e;return}}function YZc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+20>>2]|0;b=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)|0;f=c[d+16>>2]|0;d=f+12|0;g=c[d>>2]|0;h=g+4|0;if(h>>>0>(c[f+20>>2]|0)>>>0){Bid(d,b,4);j=c[b>>2]|0;k=XEi(j|0)|0;c[b>>2]=k;i=e;return}else{f=c[g>>2]|0;c[b>>2]=f;c[d>>2]=h;j=f;k=XEi(j|0)|0;c[b>>2]=k;i=e;return}}function ZZc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];I1c(a,b,e);i=d;return}function _Zc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];J1c(a,b,e);i=d;return}function $Zc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+28>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;K1c(f,c[d+16>>2]|0);h=b+20|0;b=c[h>>2]|0;j=d+4|0;k=c[(c[j>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2]|0;if(!k){b=ds(g)|0;Wrc(b);l=b}else l=k;k=c[l+8>>2]|0;c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];f=c[h>>2]|0;c[(c[j>>2]|0)+((a[d>>0]|0)!=0?f:f+-8|0)>>2]=l;i=e;return}function a_c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e+32|0;g=e+56|0;h=e+20|0;j=e;k=c[d+16>>2]|0;l=c[d+4>>2]|0;m=(c[b+32>>2]|0)==17;do if(l)if(m){n=c[b+20>>2]|0;o=l+((a[d>>0]|0)!=0?n:n+-8|0)|0;n=c[b+12>>2]|0;a[h>>0]=0;c[h+4>>2]=o;c[h+8>>2]=n;p=0;q=o;r=n;break}else{MVc(h,c[b>>2]|0,d,1);p=a[h>>0]|0;q=c[h+4>>2]|0;r=c[h+8>>2]|0;break}else{n=b+12|0;if(m)s=0;else s=ds(c[n>>2]|0)|0;o=c[n>>2]|0;a[h>>0]=1;c[h+4>>2]=s;c[h+8>>2]=o;p=1;q=s;r=o}while(0);s=h+1|0;a[g+0>>0]=a[s+0>>0]|0;a[g+1>>0]=a[s+1>>0]|0;a[g+2>>0]=a[s+2>>0]|0;s=c[b+44>>2]|0;b=(c[d+12>>2]|0)+4|0;d=c[b>>2]|0;h=d+(s<<6)|0;c[b>>2]=h;b=j+4|0;c[b>>2]=d;c[j>>2]=d;m=j+8|0;c[m>>2]=h;l=s<<6>>6;c[j+16>>2]=l;o=j+12|0;c[o>>2]=l;c[f+16>>2]=k;a[f>>0]=p;p=f+1|0;a[p+0>>0]=a[g+0>>0]|0;a[p+1>>0]=a[g+1>>0]|0;a[p+2>>0]=a[g+2>>0]|0;c[f+4>>2]=q;c[f+8>>2]=r;c[f+12>>2]=j;if(!s){i=e;return}else{t=d;u=h}do{h=t+64|0;c[b>>2]=h;c[o>>2]=u-h>>6;In[c[t>>2]&4095](t+4|0,f);t=c[b>>2]|0;u=c[m>>2]|0}while((t|0)!=(u|0));i=e;return}function b_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;L1c(a,b,d);Ndd(c[b+16>>2]|0);i=d;return}function c_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;M1c(a,b,d);Ndd(c[b+16>>2]|0);i=d;return}function d_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;N1c(a,b,d);Ndd(c[b+16>>2]|0);i=d;return}function e_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;O1c(a,b,d);Ndd(c[b+16>>2]|0);i=d;return}function f_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;P1c(a,b,c);i=c;return}function g_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;Q1c(a,b,c);i=c;return}function h_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;R1c(a,b,c);i=c;return}function i_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;S1c(a,b,c);i=c;return}function j_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;T1c(a,b,c);i=c;return}function k_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;U1c(a,b,c);i=c;return}function l_c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];V1c(a,b,e);i=d;return}function m_c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[c[b+16>>2]>>2]|0;c[e>>2]=c[a+28>>2];c[e+4>>2]=f;c[e+8>>2]=0;W1c(a,b,e);i=d;return}function n_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;X1c(a,b,c);i=c;return}function o_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;Y1c(a,b,c);i=c;return}function p_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;Z1c(a,b,c);i=c;return}function q_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;_1c(a,b,c);i=c;return}function r_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;$1c(a,b,c);i=c;return}function s_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;a2c(a,b,c);i=c;return}function t_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;b2c(a,b,c);i=c;return}function u_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;c2c(a,b,c);i=c;return}function v_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;d2c(a,b,c);i=c;return}function w_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;e2c(a,b,c);i=c;return}function x_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;f2c(a,b,c);i=c;return}function y_c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];g2c(a,b,e);i=d;return}function z_c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];h2c(a,b,e);i=d;return}function A_c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];i2c(a,b,e);i=d;return}function B_c(a){a=a|0;var b=0,c=0,d=0;b=i;if(((((Rsc(a)|0)&8192|0)!=0?!(Vsc(a)|0):0)?!(Wsc(a)|0):0)?(c=etc(a)|0,(c|0)!=(dtc()|0)):0)d=(otc(Atc()|0,c)|0)!=-1;else d=0;i=b;return d|0}function C_c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d;g=c[b+16>>2]|0;c[e>>2]=c[b+20>>2];c[e+4>>2]=c[a+28>>2];h=c[a+44>>2]|0;a=(c[b+12>>2]|0)+4|0;b=c[a>>2]|0;j=b+(h<<6)|0;c[a>>2]=j;c[f+4>>2]=b;c[f>>2]=b;c[f+8>>2]=j;j=h<<6>>6;c[f+16>>2]=j;c[f+12>>2]=j;c[e+8>>2]=f;j2c(g,e,0);i=d;return}function D_c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+352|0;g=f+344|0;h=f+8|0;j=f+312|0;k=f;l=f+16|0;MIc(l);k2c(l,c[d+16>>2]|0);m=b+20|0;b=c[m>>2]|0;n=d+4|0;o=c[(c[n>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2]|0;if(!o){b=ds(c[e>>2]|0)|0;Wrc(b);p=b}else p=o;l2c(c[p+8>>2]|0,l)|0;o=c[m>>2]|0;c[(c[n>>2]|0)+((a[d>>0]|0)!=0?o:o+-8|0)>>2]=p;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){o=h;d=c[o+4>>2]|0;n=k;c[n>>2]=c[o>>2];c[n+4>>2]=d;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[j+12>>2]=p;xbd(j)|0}if(!(a[l>>0]&1)){i=f;return}j=c[l+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(j,g);i=f;return}function E_c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=c[d+16>>2]|0;eVb(j,h,1);Ndd(j);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;j=ysc(k)|0;k=c[b+20>>2]|0;c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?k:k+-8|0)>>2]=j;if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function F_c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+96|0;h=f+92|0;j=f+88|0;k=f+8|0;l=f;g[k+4>>2]=ea(x);c[k>>2]=0;m=k+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;g[k+32>>2]=ea(x);c[k+28>>2]=0;m=k+36|0;c[k+64>>2]=0;n=k+68|0;c[n>>2]=0;o=k+60|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[o>>2]=60;m=k+76|0;c[m>>2]=2;p=k+72|0;c[p>>2]=2;q=c[d+16>>2]|0;m2c(q,k+56|0,0);r=q+12|0;s=c[r>>2]|0;t=s+4|0;u=q+20|0;q=c[u>>2]|0;if(t>>>0>q>>>0){Bid(r,p,4);v=c[r>>2]|0;w=c[u>>2]|0}else{c[p>>2]=c[s>>2];c[r>>2]=t;v=t;w=q}q=v+4|0;if(q>>>0>w>>>0)Bid(r,m,4);else{c[m>>2]=c[v>>2];c[r>>2]=q}SMc(k);q=b+20|0;b=c[q>>2]|0;r=d+4|0;c[l>>2]=c[(c[r>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2];n2c(e,k,l);e=c[q>>2]|0;c[(c[r>>2]|0)+((a[d>>0]|0)!=0?e:e+-8|0)>>2]=c[l>>2];if((c[n>>2]|0)<=-1){i=f;return}n=k+56|0;k=c[n>>2]|0;c[j>>2]=c[o>>2];c[h+0>>2]=c[j+0>>2];eOb(k,h);c[n>>2]=0;i=f;return}function G_c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;MLc(h);QLc(h,c[e+16>>2]|0);j=d+20|0;d=c[j>>2]|0;k=e+4|0;l=c[(c[k>>2]|0)+((a[e>>0]|0)!=0?d:d+-8|0)>>2]|0;if(!l){d=ds(c[f>>2]|0)|0;Wrc(d);m=d}else m=l;l=c[m+8>>2]|0;c[l>>2]=c[h>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];c[l+16>>2]=c[h+16>>2];c[l+20>>2]=c[h+20>>2];c[l+24>>2]=c[h+24>>2];c[l+28>>2]=c[h+28>>2];d=l+32|0;l=h+32|0;h=d+34|0;do{b[d>>1]=b[l>>1]|0;d=d+2|0;l=l+2|0}while((d|0)<(h|0));l=c[j>>2]|0;c[(c[k>>2]|0)+((a[e>>0]|0)!=0?l:l+-8|0)>>2]=m;i=g;return}function H_c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;b=c[h>>2]|0;if(g>>>0>b>>>0){Bid(e,a,4);j=c[h>>2]|0;k=c[e>>2]|0}else{c[a>>2]=c[f>>2];c[e>>2]=g;j=b;k=g}g=a+4|0;b=k+4|0;if(b>>>0>j>>>0){Bid(e,g,4);l=c[e>>2]|0;m=c[h>>2]|0}else{c[g>>2]=c[k>>2];c[e>>2]=b;l=b;m=j}j=a+8|0;b=l+4|0;if(b>>>0>m>>>0){Bid(e,j,4);n=c[e>>2]|0;o=c[h>>2]|0}else{c[j>>2]=c[l>>2];c[e>>2]=b;n=b;o=m}m=a+12|0;a=n+4|0;if(a>>>0>o>>>0){Bid(e,m,4);i=d;return}else{c[m>>2]=c[n>>2];c[e>>2]=a;i=d;return}}function I_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;o2c(a,b,d);Tdd(c[b+16>>2]|0);i=d;return}function J_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;p2c(a,b,d);Tdd(c[b+16>>2]|0);i=d;return}function K_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;q2c(a,b,d);Tdd(c[b+16>>2]|0);i=d;return}function L_c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;r2c(a,b,d);Tdd(c[b+16>>2]|0);i=d;return}function M_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;s2c(a,b,c);i=c;return}function N_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;t2c(a,b,c);i=c;return}function O_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;u2c(a,b,c);i=c;return}function P_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;v2c(a,b,c);i=c;return}function Q_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;w2c(a,b,c);i=c;return}function R_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;x2c(a,b,c);i=c;return}function S_c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];y2c(a,b,e);i=d;return}function T_c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[c[b+16>>2]>>2]|0;c[e>>2]=c[a+28>>2];c[e+4>>2]=f;c[e+8>>2]=0;z2c(a,b,e);i=d;return}function U_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;A2c(a,b,c);i=c;return}function V_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;B2c(a,b,c);i=c;return}function W_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;C2c(a,b,c);i=c;return}function X_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;D2c(a,b,c);i=c;return}function Y_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;E2c(a,b,c);i=c;return}function Z_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;F2c(a,b,c);i=c;return}function __c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;G2c(a,b,c);i=c;return}function $_c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;H2c(a,b,c);i=c;return}function a$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;I2c(a,b,c);i=c;return}function b$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;J2c(a,b,c);i=c;return}function c$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;K2c(a,b,c);i=c;return}function d$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];L2c(a,b,e);i=d;return}function e$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];M2c(a,b,e);i=d;return}function f$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];N2c(a,b,e);i=d;return}function g$c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d;g=c[b+16>>2]|0;c[e>>2]=c[b+20>>2];c[e+4>>2]=c[a+28>>2];h=c[a+44>>2]|0;a=(c[b+12>>2]|0)+4|0;b=c[a>>2]|0;j=b+(h<<6)|0;c[a>>2]=j;c[f+4>>2]=b;c[f>>2]=b;c[f+8>>2]=j;j=h<<6>>6;c[f+16>>2]=j;c[f+12>>2]=j;c[e+8>>2]=f;O2c(g,e,0);i=d;return}function h$c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+304|0;g=f+296|0;h=f+292|0;j=f;MIc(j);k=c[d+16>>2]|0;l=c[b+20>>2]|0;b=c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?l:l+-8|0)>>2]|0;if(!b){l=ds(c[e>>2]|0)|0;Wrc(l);m=l}else m=b;l2c(j,c[m+8>>2]|0)|0;P2c(j,k);if(!(a[j>>0]&1)){i=f;return}k=c[j+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(k,g);i=f;return}function i$c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;k=c[d+16>>2]|0;l=c[b+20>>2]|0;Q2c(e,c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?l:l+-8|0)>>2]|0,j);R2c(k,j,c[b+4>>2]|0,c[b+24>>2]|0);if(!(a[j>>0]&1)){i=f;return}b=c[j+8>>2]|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(b,g);i=f;return}function j$c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+96|0;h=f+92|0;j=f+88|0;k=f+8|0;l=f;g[k+4>>2]=ea(x);c[k>>2]=0;m=k+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;g[k+32>>2]=ea(x);c[k+28>>2]=0;m=k+36|0;c[k+64>>2]=0;n=k+68|0;c[n>>2]=0;o=k+60|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[o>>2]=60;c[k+76>>2]=2;c[k+72>>2]=2;m=c[d+16>>2]|0;p=c[b+20>>2]|0;c[l>>2]=c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?p:p+-8|0)>>2];S2c(e,l,k);T2c(k,m);if((c[n>>2]|0)<=-1){i=f;return}n=k+56|0;k=c[n>>2]|0;c[j>>2]=c[o>>2];c[h+0>>2]=c[j+0>>2];eOb(k,h);c[n>>2]=0;i=f;return}function k$c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+80|0;h=g;MLc(h);j=c[e+16>>2]|0;k=c[d+20>>2]|0;d=c[(c[e+4>>2]|0)+((a[e>>0]|0)!=0?k:k+-8|0)>>2]|0;if(!d){k=ds(c[f>>2]|0)|0;Wrc(k);l=k}else l=d;d=c[l+8>>2]|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];l=h+32|0;k=d+32|0;d=l+34|0;do{b[l>>1]=b[k>>1]|0;l=l+2|0;k=k+2|0}while((l|0)<(d|0));SLc(h,j);i=g;return}function l$c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;b=c[h>>2]|0;if(g>>>0<b>>>0){c[f>>2]=c[a>>2];c[e>>2]=g;j=b;k=g}else{Gid(e,a,4);j=c[h>>2]|0;k=c[e>>2]|0}g=a+4|0;b=k+4|0;if(b>>>0<j>>>0){c[k>>2]=c[g>>2];c[e>>2]=b;l=b;m=j}else{Gid(e,g,4);l=c[e>>2]|0;m=c[h>>2]|0}g=a+8|0;j=l+4|0;if(j>>>0<m>>>0){c[l>>2]=c[g>>2];c[e>>2]=j;n=j;o=m}else{Gid(e,g,4);n=c[e>>2]|0;o=c[h>>2]|0}h=a+12|0;a=n+4|0;if(a>>>0<o>>>0){c[n>>2]=c[h>>2];c[e>>2]=a;i=d;return}else{Gid(e,h,4);i=d;return}}function m$c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;U2c(a,b,d);fdd(c[b+16>>2]|0);i=d;return}function n$c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;V2c(a,b,d);fdd(c[b+16>>2]|0);i=d;return}function o$c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;W2c(a,b,d);fdd(c[b+16>>2]|0);i=d;return}function p$c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;X2c(a,b,d);fdd(c[b+16>>2]|0);i=d;return}function q$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;Y2c(a,b,c);i=c;return}function r$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;Z2c(a,b,c);i=c;return}function s$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;_2c(a,b,c);i=c;return}function t$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;$2c(a,b,c);i=c;return}function u$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;a3c(a,b,c);i=c;return}function v$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;b3c(a,b,c);i=c;return}function w$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];c3c(a,b,e);i=d;return}function x$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;d3c(a,b,c);i=c;return}function y$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;e3c(a,b,c);i=c;return}function z$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;f3c(a,b,c);i=c;return}function A$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;g3c(a,b,c);i=c;return}function B$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;h3c(a,b,c);i=c;return}function C$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;i3c(a,b,c);i=c;return}function D$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;j3c(a,b,c);i=c;return}function E$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;k3c(a,b,c);i=c;return}function F$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;l3c(a,b,c);i=c;return}function G$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;m3c(a,b,c);i=c;return}function H$c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;n3c(a,b,c);i=c;return}function I$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];o3c(a,b,e);i=d;return}function J$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];p3c(a,b,e);i=d;return}function K$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];q3c(a,b,e);i=d;return}function L$c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+32|0;g=e+20|0;h=e;j=c[d+16>>2]|0;c[g>>2]=c[d+20>>2];c[g+4>>2]=c[b+28>>2];k=c[b+44>>2]|0;l=(c[d+12>>2]|0)+4|0;d=c[l>>2]|0;m=d+(k<<6)|0;c[l>>2]=m;c[h+4>>2]=d;c[h>>2]=d;c[h+8>>2]=m;m=k<<6>>6;c[h+16>>2]=m;c[h+12>>2]=m;m=g+8|0;c[m>>2]=h;add(j,c[b+4>>2]|0,c[b+36>>2]|0,g,c[b+24>>2]|0);a[f+4>>0]=1;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=c[m>>2];eWc(j,f,0);bdd(j);i=e;return}function M$c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+304|0;f=e+296|0;g=e+292|0;h=e;MIc(h);j=c[d+16>>2]|0;add(j,c[b+4>>2]|0,2394192,h,c[b+24>>2]|0);r3c(h,j);bdd(j);if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function N$c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=c[d+16>>2]|0;add(j,c[b+4>>2]|0,c[142294]|0,h,c[b+24>>2]|0);$cd(j,2646336,2646336,f,1);add(j,3142592,c[142260]|0,g,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=1;bdd(j);cdd(j);fdd(j);bdd(j);if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function O$c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;d=i;i=i+96|0;e=d+84|0;f=d+80|0;h=d;g[h+4>>2]=ea(x);c[h>>2]=0;j=h+8|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;g[h+32>>2]=ea(x);c[h+28>>2]=0;j=h+36|0;c[h+64>>2]=0;k=h+68|0;c[k>>2]=0;l=h+60|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[l>>2]=60;c[h+76>>2]=2;c[h+72>>2]=2;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,2470664,h,c[a+24>>2]|0);s3c(h,j);bdd(j);if((c[k>>2]|0)<=-1){i=d;return}k=h+56|0;h=c[k>>2]|0;c[f>>2]=c[l>>2];c[e+0>>2]=c[f+0>>2];eOb(h,e);c[k>>2]=0;i=d;return}function P$c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;i=i+80|0;e=d;MLc(e);f=c[b+16>>2]|0;add(f,c[a+4>>2]|0,614696,e,c[a+24>>2]|0);OLc(e,f);bdd(f);i=d;return}function Q$c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142270]|0;add(b,614528,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614536,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614544,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614552,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function R$c(a,b){a=a|0;b=b|0;return}function S$c(a,b){a=a|0;b=b|0;return}function T$c(a,b){a=a|0;b=b|0;return}function U$c(a,b){a=a|0;b=b|0;return}function V$c(a,b){a=a|0;b=b|0;return}function W$c(a,b){a=a|0;b=b|0;return}function X$c(a,b){a=a|0;b=b|0;return}function Y$c(a,b){a=a|0;b=b|0;return}function Z$c(a,b){a=a|0;b=b|0;return}function _$c(a,b){a=a|0;b=b|0;return}function $$c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];t3c(a,b,e);i=d;return}function a0c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[c[b+16>>2]>>2]|0;c[e>>2]=c[a+28>>2];c[e+4>>2]=f;c[e+8>>2]=0;u3c(a,b,e);i=d;return}function b0c(a,b){a=a|0;b=b|0;return}function c0c(a,b){a=a|0;b=b|0;return}function d0c(a,b){a=a|0;b=b|0;return}function e0c(a,b){a=a|0;b=b|0;return}function f0c(a,b){a=a|0;b=b|0;return}function g0c(a,b){a=a|0;b=b|0;return}function h0c(a,b){a=a|0;b=b|0;return}function i0c(a,b){a=a|0;b=b|0;return}function j0c(a,b){a=a|0;b=b|0;return}function k0c(a,b){a=a|0;b=b|0;return}function l0c(a,b){a=a|0;b=b|0;return}function m0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];v3c(a,b,e);i=d;return}function n0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];w3c(a,b,e);i=d;return}function o0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];x3c(a,b,e);i=d;return}function p0c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d;g=c[b+16>>2]|0;c[e>>2]=c[b+20>>2];c[e+4>>2]=c[a+28>>2];h=c[a+44>>2]|0;j=(c[b+12>>2]|0)+4|0;b=c[j>>2]|0;k=b+(h<<6)|0;c[j>>2]=k;c[f+4>>2]=b;c[f>>2]=b;c[f+8>>2]=k;k=h<<6>>6;c[f+16>>2]=k;c[f+12>>2]=k;c[e+8>>2]=f;f=c[a+24>>2]|0;if(!f){y3c(g,e,0);i=d;return}else{idd(g,f);y3c(g,e,0);jdd(g);i=d;return}}function q0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+352|0;g=f+344|0;h=f+8|0;j=f+312|0;k=f;l=f+16|0;MIc(l);m=c[d+16>>2]|0;n=b+20|0;o=c[n>>2]|0;p=d+4|0;q=c[(c[p>>2]|0)+((a[d>>0]|0)!=0?o:o+-8|0)>>2]|0;if(!q){o=ds(c[e>>2]|0)|0;Wrc(o);r=o}else r=q;l2c(l,c[r+8>>2]|0)|0;r=c[b+24>>2]|0;if(!r)z3c(l,m);else{idd(m,r);z3c(l,m);jdd(m)}m=c[n>>2]|0;r=c[(c[p>>2]|0)+((a[d>>0]|0)!=0?m:m+-8|0)>>2]|0;if(!r){m=ds(c[e>>2]|0)|0;Wrc(m);s=m}else s=r;l2c(c[s+8>>2]|0,l)|0;r=c[n>>2]|0;c[(c[p>>2]|0)+((a[d>>0]|0)!=0?r:r+-8|0)>>2]=s;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){r=h;d=c[r+4>>2]|0;p=k;c[p>>2]=c[r>>2];c[p+4>>2]=d;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[j+12>>2]=s;xbd(j)|0}if(!(a[l>>0]&1)){i=f;return}j=c[l+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(j,g);i=f;return}function r0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=c[d+16>>2]|0;h=b+20|0;j=c[h>>2]|0;k=d+4|0;l=Grc(c[(c[k>>2]|0)+((a[d>>0]|0)!=0?j:j+-8|0)>>2]|0)|0;j=c[b+24>>2]|0;b=(j|0)!=0;if(b)idd(g,j);j=c[g+12>>2]|0;m=xo[c[c[j>>2]>>2]&2047](j,l,c[g+28>>2]|0)|0;j=(a[g+32>>0]|0)==0?l:m;if(b)jdd(g);g=Z8c(j,c[e>>2]|0,c[e+8>>2]|0,c[e+4>>2]|0)|0;e=c[h>>2]|0;c[(c[k>>2]|0)+((a[d>>0]|0)!=0?e:e+-8|0)>>2]=g;i=f;return}function s0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+96|0;h=f+92|0;j=f+88|0;k=f+8|0;l=f+4|0;m=f;g[k+4>>2]=ea(x);c[k>>2]=0;n=k+8|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;g[k+32>>2]=ea(x);c[k+28>>2]=0;n=k+36|0;c[k+64>>2]=0;o=k+68|0;c[o>>2]=0;p=k+60|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[p>>2]=60;c[k+76>>2]=2;c[k+72>>2]=2;n=b+20|0;b=c[n>>2]|0;q=d+4|0;c[l>>2]=c[(c[q>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2];S2c(e,l,k);l=c[n>>2]|0;c[m>>2]=c[(c[q>>2]|0)+((a[d>>0]|0)!=0?l:l+-8|0)>>2];n2c(e,k,m);e=c[n>>2]|0;c[(c[q>>2]|0)+((a[d>>0]|0)!=0?e:e+-8|0)>>2]=c[m>>2];if((c[o>>2]|0)<=-1){i=f;return}o=k+56|0;k=c[o>>2]|0;c[j>>2]=c[p>>2];c[h+0>>2]=c[j+0>>2];eOb(k,h);c[o>>2]=0;i=f;return}function t0c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+80|0;h=g;MLc(h);j=d+20|0;d=c[j>>2]|0;k=a[e>>0]|0;l=e+4|0;m=c[l>>2]|0;n=c[m+(k<<24>>24!=0?d:d+-8|0)>>2]|0;if(!n){o=ds(c[f>>2]|0)|0;Wrc(o);p=o;q=a[e>>0]|0;r=c[j>>2]|0;s=c[l>>2]|0}else{p=n;q=k;r=d;s=m}m=c[p+8>>2]|0;p=c[m>>2]|0;c[h>>2]=p;d=h+4|0;c[d>>2]=c[m+4>>2];k=h+8|0;c[k>>2]=c[m+8>>2];n=h+12|0;c[n>>2]=c[m+12>>2];o=h+16|0;c[o>>2]=c[m+16>>2];t=h+20|0;c[t>>2]=c[m+20>>2];u=h+24|0;c[u>>2]=c[m+24>>2];v=h+28|0;c[v>>2]=c[m+28>>2];w=h+32|0;x=w+0|0;y=m+32|0;m=x+34|0;do{b[x>>1]=b[y>>1]|0;x=x+2|0;y=y+2|0}while((x|0)<(m|0));z=c[s+(q<<24>>24!=0?r:r+-8|0)>>2]|0;if(!z){r=ds(c[f>>2]|0)|0;Wrc(r);A=r;B=c[h>>2]|0}else{A=z;B=p}p=c[A+8>>2]|0;c[p>>2]=B;c[p+4>>2]=c[d>>2];c[p+8>>2]=c[k>>2];c[p+12>>2]=c[n>>2];c[p+16>>2]=c[o>>2];c[p+20>>2]=c[t>>2];c[p+24>>2]=c[u>>2];c[p+28>>2]=c[v>>2];x=p+32|0;y=w+0|0;m=x+34|0;do{b[x>>1]=b[y>>1]|0;x=x+2|0;y=y+2|0}while((x|0)<(m|0));y=c[j>>2]|0;c[(c[l>>2]|0)+((a[e>>0]|0)!=0?y:y+-8|0)>>2]=A;i=g;return}function u0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;h=c[d+16>>2]|0;j=b+20|0;k=c[j>>2]|0;l=d+4|0;m=c[(c[l>>2]|0)+((a[d>>0]|0)!=0?k:k+-8|0)>>2]|0;if(!m){k=ds(c[e>>2]|0)|0;Wrc(k);n=k}else n=m;m=c[n+8>>2]|0;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];m=c[b+24>>2]|0;if(m){idd(h,m);jdd(h)}h=c[j>>2]|0;m=c[(c[l>>2]|0)+((a[d>>0]|0)!=0?h:h+-8|0)>>2]|0;if(!m){h=ds(c[e>>2]|0)|0;Wrc(h);o=h}else o=m;m=c[o+8>>2]|0;c[m+0>>2]=c[g+0>>2];c[m+4>>2]=c[g+4>>2];c[m+8>>2]=c[g+8>>2];c[m+12>>2]=c[g+12>>2];g=c[j>>2]|0;c[(c[l>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)>>2]=o;i=f;return}function v0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;A3c(a,b,c);i=c;return}function w0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;B3c(a,b,c);i=c;return}function x0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;C3c(a,b,c);i=c;return}function y0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;D3c(a,b,c);i=c;return}function z0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;E3c(a,b,c);i=c;return}function A0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;F3c(a,b,c);i=c;return}function B0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;G3c(a,b,c);i=c;return}function C0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;H3c(a,b,c);i=c;return}function D0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;I3c(a,b,c);i=c;return}function E0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;J3c(a,b,c);i=c;return}function F0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];K3c(a,b,e);i=d;return}function G0c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[c[b+16>>2]>>2]|0;c[e>>2]=c[a+28>>2];c[e+4>>2]=f;c[e+8>>2]=0;L3c(a,b,e);i=d;return}function H0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;M3c(a,b,c);i=c;return}function I0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;N3c(a,b,c);i=c;return}function J0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;O3c(a,b,c);i=c;return}function K0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;P3c(a,b,c);i=c;return}function L0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;Q3c(a,b,c);i=c;return}function M0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;R3c(a,b,c);i=c;return}function N0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;S3c(a,b,c);i=c;return}function O0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;T3c(a,b,c);i=c;return}function P0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;U3c(a,b,c);i=c;return}function Q0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;V3c(a,b,c);i=c;return}function R0c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;W3c(a,b,c);i=c;return}function S0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];X3c(a,b,e);i=d;return}function T0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];Y3c(a,b,e);i=d;return}function U0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];Z3c(a,b,e);i=d;return}function V0c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+48|0;e=d+32|0;f=d+20|0;g=d;h=c[b+16>>2]|0;c[f>>2]=c[b+20>>2];c[f+4>>2]=c[a+28>>2];j=c[a+44>>2]|0;k=(c[b+12>>2]|0)+4|0;b=c[k>>2]|0;l=b+(j<<6)|0;c[k>>2]=l;c[g+4>>2]=b;c[g>>2]=b;c[g+8>>2]=l;l=j<<6>>6;c[g+16>>2]=l;c[g+12>>2]=l;c[f+8>>2]=g;g=qdd(h,c[a+4>>2]|0,c[a+36>>2]|0,e,1)|0;if(!g){i=d;return}if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,h)|0}else _3c(h,f,0);sdd(h);i=d;return}function W0c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142292]|0,f,0)|0;if(!d){i=e;return}do if((d|0)<=0){b=c[f>>2]|0;if(b)_n[b&4095](h,g)|0}else{b=g+12|0;j=c[g+16>>2]|0;k=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;l=j+k|0;c[b>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[g+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[b>>2]=(c[b>>2]|0)+1;break}Bid(b,h,1)}while(0);sdd(g);i=e;return}function X0c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=c[b+20>>2]|0;h=(c[d+4>>2]|0)+((a[d>>0]|0)!=0?g:g+-8|0)|0;g=c[d+16>>2]|0;d=qdd(g,c[b+4>>2]|0,c[142302]|0,f,0)|0;if(!d){i=e;return}do if((d|0)<=0){b=c[f>>2]|0;if(b)_n[b&4095](h,g)|0}else{b=g+12|0;j=c[g+16>>2]|0;k=(c[(c[g+80>>2]|0)+12>>2]|0)-(da(c[g+32>>2]|0,c[g+28>>2]|0)|0)|0;l=j+k|0;c[b>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[g+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[b>>2]=(c[b>>2]|0)+1;break}Bid(b,h,1)}while(0);sdd(g);i=e;return}function Y0c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0;f=i;i=i+16|0;g=f;j=qdd(b,e,c[142264]|0,g,0)|0;if(!j){i=f;return}if((j|0)>0){j=b+12|0;e=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=e+l|0;c[j>>2]=m;if((l|0)>=0?(e+(l+8)|0)>>>0<=(c[b+20>>2]|0)>>>0:0){a[k>>0]=a[m>>0];a[k+1>>0]=a[m+1>>0];a[k+2>>0]=a[m+2>>0];a[k+3>>0]=a[m+3>>0];a[k+4>>0]=a[m+4>>0];a[k+5>>0]=a[m+5>>0];a[k+6>>0]=a[m+6>>0];a[k+7>>0]=a[m+7>>0];h[k>>3]=+h[k>>3];a[d>>0]=a[k>>0];a[d+1>>0]=a[k+1>>0];a[d+2>>0]=a[k+2>>0];a[d+3>>0]=a[k+3>>0];a[d+4>>0]=a[k+4>>0];a[d+5>>0]=a[k+5>>0];a[d+6>>0]=a[k+6>>0];a[d+7>>0]=a[k+7>>0];c[j>>2]=(c[j>>2]|0)+8}else Bid(j,d,8);if(c[b>>2]&512){j=XEi(c[d>>2]|0)|0;m=d+4|0;c[d>>2]=XEi(c[m>>2]|0)|0;c[m>>2]=j}}else{j=c[g>>2]|0;if(j)_n[j&4095](d,b)|0}sdd(b);i=f;return}function Z0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+352|0;g=f+344|0;h=f+8|0;j=f+312|0;k=f;l=f+308|0;m=f+16|0;MIc(m);n=c[d+16>>2]|0;o=qdd(n,c[b+4>>2]|0,2394192,g,1)|0;if(o){if((o|0)<=0){o=c[g>>2]|0;if(o)_n[o&4095](m,n)|0}else $3c(m,n);sdd(n)}if(a[n+136>>0]|0){n=b+20|0;b=c[n>>2]|0;o=d+4|0;p=c[(c[o>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2]|0;if(!p){b=ds(c[e>>2]|0)|0;Wrc(b);q=b}else q=p;l2c(c[q+8>>2]|0,m)|0;p=c[n>>2]|0;c[(c[o>>2]|0)+((a[d>>0]|0)!=0?p:p+-8|0)>>2]=q;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){p=h;h=c[p+4>>2]|0;d=k;c[d>>2]=c[p>>2];c[d+4>>2]=h;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[j+12>>2]=q;xbd(j)|0}}if(!(a[m>>0]&1)){i=f;return}j=c[m+8>>2]|0;c[l>>2]=58;c[g+0>>2]=c[l+0>>2];eOb(j,g);i=f;return}function _0c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=c[d+4>>2]|0;if(!h)j=614344;else{k=c[d+8>>2]|0;a[h>>0]=80;a[h+1>>0]=80;a[h+2>>0]=116;a[h+3>>0]=114;a[h+4>>0]=60;l=h+6|0;a[h+5>>0]=36;m=ksc(k)|0;k=a[m>>0]|0;if(!(k<<24>>24))n=l;else{o=k;k=l;l=m;while(1){a[k>>0]=o;m=k+1|0;l=l+1|0;o=a[l>>0]|0;if(!(o<<24>>24)){n=m;break}else k=m}}a[n>>0]=62;a[n+1>>0]=0;j=h}h=qdd(b,e,j,g,1)|0;if(!h){i=f;return}if((h|0)<=0){h=c[g>>2]|0;if(h)_n[h&4095](d,b)|0}else dyc(d,b);sdd(b);i=f;return}function $0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=c[d+16>>2]|0;k=qdd(j,c[b+4>>2]|0,c[142294]|0,f,0)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,j)|0}else cVb(j,h,1);sdd(j)}if(a[j+136>>0]|0){if(!(a[h>>0]&1))l=h+1|0;else l=c[h+8>>2]|0;j=ysc(l)|0;l=c[b+20>>2]|0;c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?l:l+-8|0)>>2]=j}if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function a1c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;rdd(b,2);f=c[142268]|0;h=qdd(b,3143216,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,3143224,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,2684928,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;a=qdd(b,2497752,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function b1c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;rdd(b,2);f=qdd(b,614648,c[142304]|0,e,0)|0;if(f){if((f|0)>0){f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[j>>2];c[f>>2]=k}else Bid(f,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}sdd(b)}if(!(wdd(b,1)|0)){i=d;return}b=c[a>>2]|0;if(!(b&32)){i=d;return}c[a>>2]=b|-65536;i=d;return}function c1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+96|0;h=f+92|0;j=f+88|0;k=f+8|0;l=f;g[k+4>>2]=ea(x);c[k>>2]=0;m=k+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;g[k+32>>2]=ea(x);c[k+28>>2]=0;m=k+36|0;c[k+64>>2]=0;n=k+68|0;c[n>>2]=0;o=k+60|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[o>>2]=60;c[k+76>>2]=2;c[k+72>>2]=2;m=c[d+16>>2]|0;p=qdd(m,c[b+4>>2]|0,2470664,h,1)|0;if(p){if((p|0)<=0){p=c[h>>2]|0;if(p)_n[p&4095](k,m)|0}else a4c(k,m);sdd(m)}if(a[m+136>>0]|0){m=b+20|0;b=c[m>>2]|0;p=d+4|0;c[l>>2]=c[(c[p>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2];n2c(e,k,l);e=c[m>>2]|0;c[(c[p>>2]|0)+((a[d>>0]|0)!=0?e:e+-8|0)>>2]=c[l>>2]}if((c[n>>2]|0)<=-1){i=f;return}n=k+56|0;k=c[n>>2]|0;c[j>>2]=c[o>>2];c[h+0>>2]=c[j+0>>2];eOb(k,h);c[n>>2]=0;i=f;return}function d1c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g+68|0;j=g;MLc(j);k=c[e+16>>2]|0;l=qdd(k,c[d+4>>2]|0,614696,h,1)|0;if(l){if((l|0)<=0){l=c[h>>2]|0;if(l)_n[l&4095](j,k)|0}else PLc(j,k);sdd(k)}if(!(a[k+136>>0]|0)){i=g;return}k=d+20|0;d=c[k>>2]|0;l=e+4|0;h=c[(c[l>>2]|0)+((a[e>>0]|0)!=0?d:d+-8|0)>>2]|0;if(!h){d=ds(c[f>>2]|0)|0;Wrc(d);m=d}else m=h;h=c[m+8>>2]|0;c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];c[h+24>>2]=c[j+24>>2];c[h+28>>2]=c[j+28>>2];d=h+32|0;h=j+32|0;j=d+34|0;do{b[d>>1]=b[h>>1]|0;d=d+2|0;h=h+2|0}while((d|0)<(j|0));h=c[k>>2]|0;c[(c[l>>2]|0)+((a[e>>0]|0)!=0?h:h+-8|0)>>2]=m;i=g;return}function e1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;j=c[d+16>>2]|0;k=qdd(j,c[b+4>>2]|0,2390464,g,1)|0;if(k){if((k|0)<=0){k=c[g>>2]|0;if(k)_n[k&4095](h,j)|0}else b4c(h,j);sdd(j)}if(!(a[j+136>>0]|0)){i=f;return}j=b+20|0;b=c[j>>2]|0;k=d+4|0;g=c[(c[k>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2]|0;if(!g){b=ds(c[e>>2]|0)|0;Wrc(b);l=b}else l=g;g=c[l+8>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];h=c[j>>2]|0;c[(c[k>>2]|0)+((a[d>>0]|0)!=0?h:h+-8|0)>>2]=l;i=f;return}function f1c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c4c(a,b,d);Mdd(c[b+16>>2]|0);i=d;return}function g1c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;d4c(a,b,d);Mdd(c[b+16>>2]|0);i=d;return}function h1c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;e4c(a,b,d);Mdd(c[b+16>>2]|0);i=d;return}function i1c(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;f4c(a,b,d);Mdd(c[b+16>>2]|0);i=d;return}function j1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;g4c(a,b,c);i=c;return}function k1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;h4c(a,b,c);i=c;return}function l1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;i4c(a,b,c);i=c;return}function m1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;j4c(a,b,c);i=c;return}function n1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;k4c(a,b,c);i=c;return}function o1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;l4c(a,b,c);i=c;return}function p1c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];m4c(a,b,e);i=d;return}function q1c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[c[b+16>>2]>>2]|0;c[e>>2]=c[a+28>>2];c[e+4>>2]=f;c[e+8>>2]=0;n4c(a,b,e);i=d;return}function r1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;o4c(a,b,c);i=c;return}function s1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;p4c(a,b,c);i=c;return}function t1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;q4c(a,b,c);i=c;return}function u1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;r4c(a,b,c);i=c;return}function v1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;s4c(a,b,c);i=c;return}function w1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;t4c(a,b,c);i=c;return}function x1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;u4c(a,b,c);i=c;return}function y1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;v4c(a,b,c);i=c;return}function z1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;w4c(a,b,c);i=c;return}function A1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;x4c(a,b,c);i=c;return}function B1c(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+16|0;y4c(a,b,c);i=c;return}function C1c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];z4c(a,b,e);i=d;return}function D1c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];A4c(a,b,e);i=d;return}function E1c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a+28>>2];B4c(a,b,e);i=d;return}function F1c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d;g=c[b+16>>2]|0;c[e>>2]=c[b+20>>2];c[e+4>>2]=c[a+28>>2];h=c[a+44>>2]|0;a=(c[b+12>>2]|0)+4|0;b=c[a>>2]|0;j=b+(h<<6)|0;c[a>>2]=j;c[f+4>>2]=b;c[f>>2]=b;c[f+8>>2]=j;j=h<<6>>6;c[f+16>>2]=j;c[f+12>>2]=j;c[e+8>>2]=f;C4c(g,e,0);i=d;return}function G1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+352|0;g=f+344|0;h=f+8|0;j=f+312|0;k=f;l=f+16|0;MIc(l);D4c(l,c[d+16>>2]|0);m=b+20|0;b=c[m>>2]|0;n=d+4|0;o=c[(c[n>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2]|0;if(!o){b=ds(c[e>>2]|0)|0;Wrc(b);p=b}else p=o;l2c(c[p+8>>2]|0,l)|0;o=c[m>>2]|0;c[(c[n>>2]|0)+((a[d>>0]|0)!=0?o:o+-8|0)>>2]=p;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){o=h;d=c[o+4>>2]|0;n=k;c[n>>2]=c[o>>2];c[n+4>>2]=d;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[j+12>>2]=p;xbd(j)|0}if(!(a[l>>0]&1)){i=f;return}j=c[l+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(j,g);i=f;return}function H1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=c[d+16>>2]|0;gVb(j,h,1);Mdd(j);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;j=ysc(k)|0;k=c[b+20>>2]|0;c[(c[d+4>>2]|0)+((a[d>>0]|0)!=0?k:k+-8|0)>>2]=j;if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function I1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;f=i;i=i+96|0;h=f+92|0;j=f+88|0;k=f+8|0;l=f;g[k+4>>2]=ea(x);c[k>>2]=0;m=k+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;g[k+32>>2]=ea(x);c[k+28>>2]=0;m=k+36|0;c[k+64>>2]=0;n=k+68|0;c[n>>2]=0;o=k+60|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[o>>2]=60;m=k+76|0;c[m>>2]=2;p=k+72|0;c[p>>2]=2;q=c[d+16>>2]|0;E4c(q,k+56|0,0);r=q+12|0;s=c[r>>2]|0;t=s+4|0;u=q+20|0;q=c[u>>2]|0;if(t>>>0>q>>>0){Bid(r,p,4);v=c[p>>2]|0;w=c[r>>2]|0;y=c[u>>2]|0}else{u=c[s>>2]|0;c[p>>2]=u;c[r>>2]=t;v=u;w=t;y=q}c[p>>2]=XEi(v|0)|0;v=w+4|0;if(v>>>0>y>>>0){Bid(r,m,4);z=c[m>>2]|0}else{y=c[w>>2]|0;c[m>>2]=y;c[r>>2]=v;z=y}c[m>>2]=XEi(z|0)|0;SMc(k);z=b+20|0;b=c[z>>2]|0;m=d+4|0;c[l>>2]=c[(c[m>>2]|0)+((a[d>>0]|0)!=0?b:b+-8|0)>>2];n2c(e,k,l);e=c[z>>2]|0;c[(c[m>>2]|0)+((a[d>>0]|0)!=0?e:e+-8|0)>>2]=c[l>>2];if((c[n>>2]|0)<=-1){i=f;return}n=k+56|0;k=c[n>>2]|0;c[j>>2]=c[o>>2];c[h+0>>2]=c[j+0>>2];eOb(k,h);c[n>>2]=0;i=f;return}function J1c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;MLc(h);RLc(h,c[e+16>>2]|0);j=d+20|0;d=c[j>>2]|0;k=e+4|0;l=c[(c[k>>2]|0)+((a[e>>0]|0)!=0?d:d+-8|0)>>2]|0;if(!l){d=ds(c[f>>2]|0)|0;Wrc(d);m=d}else m=l;l=c[m+8>>2]|0;c[l>>2]=c[h>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];c[l+16>>2]=c[h+16>>2];c[l+20>>2]=c[h+20>>2];c[l+24>>2]=c[h+24>>2];c[l+28>>2]=c[h+28>>2];d=l+32|0;l=h+32|0;h=d+34|0;do{b[d>>1]=b[l>>1]|0;d=d+2|0;l=l+2|0}while((d|0)<(h|0));l=c[j>>2]|0;c[(c[k>>2]|0)+((a[e>>0]|0)!=0?l:l+-8|0)>>2]=m;i=g;return}function K1c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=b+12|0;f=c[e>>2]|0;g=f+4|0;h=b+20|0;b=c[h>>2]|0;if(g>>>0>b>>>0){Bid(e,a,4);j=c[e>>2]|0;k=c[h>>2]|0;l=c[a>>2]|0}else{m=c[f>>2]|0;c[a>>2]=m;c[e>>2]=g;j=g;k=b;l=m}c[a>>2]=XEi(l|0)|0;l=a+4|0;m=j+4|0;if(m>>>0>k>>>0){Bid(e,l,4);n=c[l>>2]|0;o=c[e>>2]|0;p=c[h>>2]|0}else{b=c[j>>2]|0;c[l>>2]=b;c[e>>2]=m;n=b;o=m;p=k}c[l>>2]=XEi(n|0)|0;n=a+8|0;l=o+4|0;if(l>>>0>p>>>0){Bid(e,n,4);q=c[n>>2]|0;r=c[e>>2]|0;s=c[h>>2]|0}else{h=c[o>>2]|0;c[n>>2]=h;c[e>>2]=l;q=h;r=l;s=p}c[n>>2]=XEi(q|0)|0;q=a+12|0;a=r+4|0;if(a>>>0>s>>>0){Bid(e,q,4);t=c[q>>2]|0;u=XEi(t|0)|0;c[q>>2]=u;i=d;return}else{s=c[r>>2]|0;c[q>>2]=s;c[e>>2]=a;t=s;u=XEi(t|0)|0;c[q>>2]=u;i=d;return}}function L1c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;F4c(c[d+16>>2]|0,h,0);k=d+20|0;d=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>1;m=d+4|0;if((c[m>>2]|0)!=(a|0)){c[d>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[d>>2]|0,m,2)|0;b[l>>1]=b[(c[h>>2]|0)+(m<<1)>>1]|0;m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-2-k|0)>>>1)<<1);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function M1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;G4c(c[d+16>>2]|0,h,0);k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=b-m|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,1)|0;a[b>>0]=a[(c[h>>2]|0)+m>>0]|0;m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}if((c[j>>2]|0)!=(k|0))c[j>>2]=k;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function N1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;H4c(k,h,0);Ndd(k);k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=b-m|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,1)|0;a[b>>0]=a[(c[h>>2]|0)+m>>0]|0;m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}if((c[j>>2]|0)!=(k|0))c[j>>2]=k;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function O1c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;I4c(c[d+16>>2]|0,h,0);k=d+20|0;d=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>1;m=d+4|0;if((c[m>>2]|0)!=(a|0)){c[d>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[d>>2]|0,m,2)|0;b[l>>1]=b[(c[h>>2]|0)+(m<<1)>>1]|0;m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-2-k|0)>>>1)<<1);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function P1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;J4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function Q1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;K4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function R1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;L4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>3;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,8)|0;m=(c[g>>2]|0)+(l<<3)|0;n=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function S1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;M4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>3;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,8)|0;m=(c[g>>2]|0)+(l<<3)|0;n=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function T1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;N4c(c[b+16>>2]|0,h,0);k=b+20|0;b=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>2;m=b+4|0;if((c[m>>2]|0)!=(a|0)){c[b>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[b>>2]|0,m,4)|0;g[l>>2]=ea(g[(c[h>>2]|0)+(m<<2)>>2]);m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=d;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-4-k|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function U1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;j=g+4|0;c[j>>2]=0;c[g+8>>2]=0;O4c(c[b+16>>2]|0,g,0);k=b+20|0;b=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[g>>2]|0)>>3;m=b+4|0;if((c[m>>2]|0)!=(a|0)){c[b>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[b>>2]|0,m,8)|0;h[l>>3]=+h[(c[g>>2]|0)+(m<<3)>>3];m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[g>>2]|0;if(!k){i=d;return}g=c[j>>2]|0;if((g|0)!=(k|0))c[j>>2]=g+(~((g+-8-k|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function V1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+80|0;g=f+64|0;h=f+8|0;j=f+32|0;k=f;l=f+16|0;c[l>>2]=0;m=l+4|0;c[m>>2]=0;c[l+8>>2]=0;c[l+12>>2]=c[e>>2];P4c(c[d+16>>2]|0,l,0);e=d+20|0;Q4c(l,c[e>>2]|0,c[b+28>>2]|0);b=c[e>>2]|0;if(c[b+4>>2]|0){d=j+12|0;n=b;b=0;do{o=c[(Rrc(c[n>>2]|0,b)|0)>>2]|0;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){p=h;q=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=q;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[d>>2]=o;xbd(j)|0}b=b+1|0;n=c[e>>2]|0}while((b|0)!=(c[n+4>>2]|0))}n=c[l>>2]|0;if(!n){i=f;return}b=c[m>>2]|0;if((b|0)==(n|0))s=n;else{e=b;while(1){b=e+-292|0;c[m>>2]=b;if(!(a[b>>0]&1))t=b;else{b=c[e+-284>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(b,g);t=c[m>>2]|0}if((t|0)==(n|0))break;else e=t}s=c[l>>2]|0}c[j>>2]=89;c[g+0>>2]=c[j+0>>2];eOb(s,g);i=f;return}function W1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=h+12|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];R4c(c[b+16>>2]|0,h,0);d=b+20|0;b=c[d>>2]|0;k=c[a+28>>2]|0;a=c[j>>2]|0;l=c[h>>2]|0;m=(a-l|0)/12|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=h+12|0;a=h+20|0;n=h+16|0;k=0;do{o=Rrc(c[b>>2]|0,k)|0;c[o>>2]=Z8c(c[(c[h>>2]|0)+(k*12|0)>>2]|0,c[l>>2]|0,c[a>>2]|0,c[n>>2]|0)|0;k=k+1|0}while((k|0)!=(m|0))}m=c[d>>2]|0;if(c[m+4>>2]|0){k=m;m=0;do{Rrc(c[k>>2]|0,m)|0;m=m+1|0;k=c[d>>2]|0}while((m|0)!=(c[k+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~(((h+-12-k|0)>>>0)/12|0)*12|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function X1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;S4c(c[d+16>>2]|0,j,0);l=d+20|0;d=c[l>>2]|0;m=c[b+28>>2]|0;b=c[k>>2]|0;n=c[j>>2]|0;o=(b-n|0)/12|0;p=d+4|0;if((c[p>>2]|0)!=(o|0)){c[d>>2]=Isc(m,Zsc(m)|0,o)|0;c[p>>2]=o}if((b|0)!=(n|0)){n=0;do{b=Rrc(c[d>>2]|0,n)|0;p=c[j>>2]|0;m=p+(n*12|0)|0;if(!(a[m>>0]&1))q=m+1|0;else q=c[p+(n*12|0)+8>>2]|0;c[b>>2]=ysc(q)|0;n=n+1|0}while((n|0)!=(o|0))}o=c[l>>2]|0;if(c[o+4>>2]|0){n=o;o=0;do{Rrc(c[n>>2]|0,o)|0;o=o+1|0;n=c[l>>2]|0}while((o|0)!=(c[n+4>>2]|0))}n=c[j>>2]|0;if(!n){i=e;return}o=c[k>>2]|0;if((o|0)==(n|0))r=n;else{l=o;while(1){o=l+-12|0;c[k>>2]=o;if(!(a[o>>0]&1))s=o;else{o=c[l+-4>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);s=c[k>>2]|0}if((s|0)==(n|0))break;else l=s}r=c[j>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(r,f);i=e;return}function Y1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;T4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=c[h>>2]|0;l=c[g>>2]|0;m=(a-l|0)/12|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=0;do{a=Gsc(c[b>>2]|0,l,12)|0;n=(c[g>>2]|0)+(l*12|0)|0;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];l=l+1|0}while((l|0)!=(m|0))}if(c[(c[j>>2]|0)+4>>2]|0){m=0;do m=m+1|0;while((m|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~(((g+-12-j|0)>>>0)/12|0)*12|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function Z1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;U4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>3;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,8)|0;m=(c[g>>2]|0)+(l<<3)|0;n=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function _1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;V4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>4;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,16)|0;m=(c[g>>2]|0)+(l<<4)|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function $1c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;W4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>4;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,16)|0;m=(c[g>>2]|0)+(l<<4)|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function a2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;X4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>4;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,16)|0;m=(c[g>>2]|0)+(l<<4)|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function b2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;Y4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>6;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,64)|0;m=k+0|0;k=(c[g>>2]|0)+(l<<6)+0|0;n=m+64|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(n|0));l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-64-j|0)>>>6)<<6);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function c2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;Z4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=c[h>>2]|0;l=c[g>>2]|0;m=(a-l|0)/24|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=0;do{a=Gsc(c[b>>2]|0,l,24)|0;n=(c[g>>2]|0)+(l*24|0)|0;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];l=l+1|0}while((l|0)!=(m|0))}if(c[(c[j>>2]|0)+4>>2]|0){m=0;do m=m+1|0;while((m|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~(((g+-24-j|0)>>>0)/24|0)*24|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function d2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;_4c(c[b+16>>2]|0,h,0);k=b+20|0;b=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>4;m=b+4|0;if((c[m>>2]|0)!=(a|0)){c[b>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[b>>2]|0,m,16)|0;n=c[h>>2]|0;o=ea(g[n+(m<<4)>>2]);p=ea(g[n+(m<<4)+4>>2]);q=ea(g[n+(m<<4)+8>>2]);r=ea(g[n+(m<<4)+12>>2]);g[l>>2]=o;g[l+4>>2]=p;g[l+8>>2]=q;g[l+12>>2]=r;m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=d;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-16-k|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function e2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;$4c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function f2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;a5c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function g2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];b5c(c[b+16>>2]|0,h,0);d=b+20|0;b=c[d>>2]|0;k=c[a+28>>2]|0;a=c[j>>2]|0;l=c[h>>2]|0;m=(a-l|0)/80|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=h+12|0;a=0;do{n=Rrc(c[b>>2]|0,a)|0;n2c(l,(c[h>>2]|0)+(a*80|0)|0,n);a=a+1|0}while((a|0)!=(m|0))}m=c[d>>2]|0;if(c[m+4>>2]|0){a=m;m=0;do{Rrc(c[a>>2]|0,m)|0;m=m+1|0;a=c[d>>2]|0}while((m|0)!=(c[a+4>>2]|0))}a=c[h>>2]|0;if(!a){i=e;return}m=c[j>>2]|0;if((m|0)==(a|0))o=a;else{d=m;while(1){m=d+-80|0;c[j>>2]=m;if((c[d+-12>>2]|0)>-1){l=d+-24|0;b=c[l>>2]|0;c[g>>2]=c[d+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(b,f);c[l>>2]=0;p=c[j>>2]|0}else p=m;if((p|0)==(a|0))break;else d=p}o=c[h>>2]|0}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);i=e;return}function h2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];c5c(c[b+16>>2]|0,h,0);d=b+20|0;d5c(h,c[d>>2]|0,c[a+28>>2]|0);a=c[d>>2]|0;if(c[a+4>>2]|0){b=a;a=0;do{Rrc(c[b>>2]|0,a)|0;a=a+1|0;b=c[d>>2]|0}while((a|0)!=(c[b+4>>2]|0))}b=c[h>>2]|0;if(!b){i=e;return}while(1){a=c[j>>2]|0;if((a|0)==(b|0))break;c[j>>2]=a+-68}j=c[h>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function i2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];e5c(c[b+16>>2]|0,h,0);d=b+20|0;f5c(h,c[d>>2]|0,c[a+28>>2]|0);a=c[d>>2]|0;if(c[a+4>>2]|0){b=a;a=0;do{Rrc(c[b>>2]|0,a)|0;a=a+1|0;b=c[d>>2]|0}while((a|0)!=(c[b+4>>2]|0))}b=c[h>>2]|0;if(!b){i=e;return}h=c[j>>2]|0;if((h|0)!=(b|0))c[j>>2]=h+(~((h+-16-b|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function j2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+112|0;f=e+72|0;g=e+102|0;h=e+4|0;j=e;k=e+64|0;l=e+8|0;m=e+99|0;n=e+96|0;o=b+12|0;p=b+48|0;q=c[o>>2]|0;r=q+4|0;s=b+20|0;t=c[s>>2]|0;u=r>>>0>t>>>0;if(c[p>>2]|0){if(u){Bid(o,j,4);v=c[o>>2]|0;w=c[s>>2]|0}else{c[j>>2]=c[q>>2];c[o>>2]=r;v=r;w=t}t=v+4|0;if(t>>>0>w>>>0){Bid(o,h,4);x=c[h>>2]|0}else{w=c[v>>2]|0;c[h>>2]=w;c[o>>2]=t;x=w}zid(o,x,c[j>>2]<<4)|0;c[p>>2]=0;i=e;return}if(u){Bid(o,k,4);y=c[k>>2]|0}else{u=c[q>>2]|0;c[k>>2]=u;c[o>>2]=r;y=u}u=c[d>>2]|0;r=d+4|0;if((c[u+4>>2]|0)==(y|0))z=u;else{u=Zsc(c[r>>2]|0)|0;o=Isc(c[r>>2]|0,u,y)|0;u=c[d>>2]|0;c[u>>2]=o;c[u+4>>2]=y;z=u}u=l+24|0;a[u>>0]=1;o=l+28|0;c[o>>2]=0;k=l+32|0;c[k>>2]=0;q=l+40|0;c[q>>2]=0;p=l+44|0;c[p>>2]=0;j=(dsc(c[r>>2]|0)|0)&1;x=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;w=c[r>>2]|0;r=c[d+8>>2]|0;d=c[r>>2]|0;t=c[r+8>>2]|0;r=t-d>>6;c[l>>2]=z;h=l+4|0;a[h>>0]=j;j=l+5|0;a[j+0>>0]=a[m+0>>0]|0;a[j+1>>0]=a[m+1>>0]|0;a[j+2>>0]=a[m+2>>0]|0;m=l+8|0;c[m>>2]=x;j=l+12|0;c[j>>2]=0;v=l+16|0;c[v>>2]=w;w=l+20|0;a[u>>0]=1;s=l+25|0;a[s+0>>0]=a[n+0>>0]|0;a[s+1>>0]=a[n+1>>0]|0;a[s+2>>0]=a[n+2>>0]|0;c[o>>2]=0;c[k>>2]=0;c[l+36>>2]=d;c[q>>2]=d;c[p>>2]=t;c[l+48>>2]=r;c[l+52>>2]=r;if(!y){i=e;return}r=l+36|0;t=f+16|0;p=f+12|0;n=d;d=z;z=0;A=x;while(1){c[q>>2]=n;c[w>>2]=r;x=Gsc(c[d>>2]|0,z,A)|0;if(!(a[h>>0]|0)){B=c[x>>2]|0;if(!B){C=ds(c[v>>2]|0)|0;Wrc(C);Qrc(c[c[l>>2]>>2]|0,c[j>>2]|0,C);D=C}else D=B;B=c[v>>2]|0;a[u>>0]=1;a[s+0>>0]=a[g+0>>0]|0;a[s+1>>0]=a[g+1>>0]|0;a[s+2>>0]=a[g+2>>0]|0;E=B;F=D}else{B=c[v>>2]|0;a[u>>0]=0;a[s+0>>0]=a[f+0>>0]|0;a[s+1>>0]=a[f+1>>0]|0;a[s+2>>0]=a[f+2>>0]|0;E=B;F=x}c[o>>2]=F;c[k>>2]=E;x=c[w>>2]|0;c[t>>2]=b;c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[p>>2]=x;B=x+4|0;C=c[B>>2]|0;G=x+8|0;H=c[G>>2]|0;if((C|0)!=(H|0)){I=x+12|0;x=C;C=H;do{H=x+64|0;c[B>>2]=H;c[I>>2]=C-H>>6;In[c[x>>2]&4095](x+4|0,f);x=c[B>>2]|0;C=c[G>>2]|0}while((x|0)!=(C|0))}C=(c[j>>2]|0)+1|0;c[j>>2]=C;if((C|0)==(y|0))break;n=c[r>>2]|0;d=c[l>>2]|0;z=C;A=c[m>>2]|0}i=e;return}function k2c(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;NXb(d,b,1);Ndd(d);Ndd(d);k9b(b+12|0,d);JYb(b+16|0,d);k9b(b+32|0,d);JYb(b+36|0,d);k9b(b+52|0,d);JYb(b+56|0,d);k9b(b+72|0,d);JYb(b+76|0,d);k9b(b+92|0,d);JYb(b+96|0,d);k9b(b+112|0,d);JYb(b+116|0,d);k9b(b+132|0,d);JYb(b+136|0,d);k9b(b+152|0,d);JYb(b+156|0,d);H_c(b+172|0,d);H_c(b+188|0,d);H_c(b+204|0,d);H_c(b+220|0,d);g5c(b+236|0,d);f=b+280|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0>m>>>0){Bid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}else{c[f>>2]=c[j>>2];c[h>>2]=k;n=k;o=m}m=b+284|0;k=n+4|0;if(k>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{c[m>>2]=c[n>>2];c[h>>2]=k;p=k;q=o}o=b+240|0;k=p+4|0;if(k>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{c[o>>2]=c[p>>2];c[h>>2]=k;r=k;s=q}q=b+244|0;if((r+1|0)>>>0>s>>>0){Bid(h,q,1);t=c[h>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[h>>2]|0)+1|0;c[h>>2]=r;t=r}r=b+245|0;if((t+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,r,1);else{a[r>>0]=a[t>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);t=b+248|0;r=c[h>>2]|0;q=r+4|0;s=c[l>>2]|0;if(q>>>0>s>>>0){Bid(h,t,4);u=c[h>>2]|0;v=c[l>>2]|0}else{c[t>>2]=c[r>>2];c[h>>2]=q;u=q;v=s}s=b+252|0;q=u+4|0;if(q>>>0>v>>>0){Bid(h,s,4);w=c[h>>2]|0;x=c[l>>2]|0}else{c[s>>2]=c[u>>2];c[h>>2]=q;w=q;x=v}v=b+256|0;q=w+4|0;if(q>>>0>x>>>0){Bid(h,v,4);y=c[h>>2]|0;z=c[l>>2]|0}else{g[v>>2]=ea(g[w>>2]);c[h>>2]=q;y=q;z=x}x=b+260|0;q=y+4|0;if(q>>>0>z>>>0){Bid(h,x,4);A=c[h>>2]|0;B=c[l>>2]|0}else{g[x>>2]=ea(g[y>>2]);c[h>>2]=q;A=q;B=z}z=b+272|0;q=A+4|0;if(q>>>0>B>>>0){Bid(h,z,4);C=c[h>>2]|0;D=c[l>>2]|0}else{g[z>>2]=ea(g[A>>2]);c[h>>2]=q;C=q;D=B}B=b+276|0;q=C+4|0;if(q>>>0>D>>>0){Bid(h,B,4);E=c[h>>2]|0;F=c[l>>2]|0}else{g[B>>2]=ea(g[C>>2]);c[h>>2]=q;E=q;F=D}D=b+288|0;if((E+1|0)>>>0>F>>>0){Bid(h,D,1);G=c[h>>2]|0}else{a[D>>0]=a[E>>0]|0;E=(c[h>>2]|0)+1|0;c[h>>2]=E;G=E}E=b+289|0;if((G+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,E,1);Ndd(d);i=e;return}else{a[E>>0]=a[G>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Ndd(d);i=e;return}}function l2c(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im;f=i;do if((d|0)!=(e|0)){h=a[e>>0]|0;if(!(h&1)){j=(h&255)>>>1;k=e+1|0}else{j=c[e+4>>2]|0;k=c[e+8>>2]|0}h=a[d>>0]|0;if(!(h&1)){l=10;m=h}else{h=c[d>>2]|0;l=(h&-2)+-1|0;m=h&255}h=(m&1)==0;if(j>>>0>l>>>0){if(h)n=(m&255)>>>1;else n=c[d+4>>2]|0;eXb(d,l,j-l|0,n,0,n,j,k);break}if(h)o=d+1|0;else o=c[d+8>>2]|0;aFi(o|0,k|0,j|0)|0;a[o+j>>0]=0;if(!(a[d>>0]&1)){a[d>>0]=j<<1;break}else{c[d+4>>2]=j;break}}while(0);c[d+12>>2]=c[e+12>>2];p=ea(g[e+16>>2]);q=ea(g[e+20>>2]);r=ea(g[e+24>>2]);s=ea(g[e+28>>2]);g[d+16>>2]=p;g[d+20>>2]=q;g[d+24>>2]=r;g[d+28>>2]=s;c[d+32>>2]=c[e+32>>2];s=ea(g[e+36>>2]);r=ea(g[e+40>>2]);q=ea(g[e+44>>2]);p=ea(g[e+48>>2]);g[d+36>>2]=s;g[d+40>>2]=r;g[d+44>>2]=q;g[d+48>>2]=p;c[d+52>>2]=c[e+52>>2];p=ea(g[e+56>>2]);q=ea(g[e+60>>2]);r=ea(g[e+64>>2]);s=ea(g[e+68>>2]);g[d+56>>2]=p;g[d+60>>2]=q;g[d+64>>2]=r;g[d+68>>2]=s;c[d+72>>2]=c[e+72>>2];s=ea(g[e+76>>2]);r=ea(g[e+80>>2]);q=ea(g[e+84>>2]);p=ea(g[e+88>>2]);g[d+76>>2]=s;g[d+80>>2]=r;g[d+84>>2]=q;g[d+88>>2]=p;c[d+92>>2]=c[e+92>>2];p=ea(g[e+96>>2]);q=ea(g[e+100>>2]);r=ea(g[e+104>>2]);s=ea(g[e+108>>2]);g[d+96>>2]=p;g[d+100>>2]=q;g[d+104>>2]=r;g[d+108>>2]=s;c[d+112>>2]=c[e+112>>2];s=ea(g[e+116>>2]);r=ea(g[e+120>>2]);q=ea(g[e+124>>2]);p=ea(g[e+128>>2]);g[d+116>>2]=s;g[d+120>>2]=r;g[d+124>>2]=q;g[d+128>>2]=p;c[d+132>>2]=c[e+132>>2];p=ea(g[e+136>>2]);q=ea(g[e+140>>2]);r=ea(g[e+144>>2]);s=ea(g[e+148>>2]);g[d+136>>2]=p;g[d+140>>2]=q;g[d+144>>2]=r;g[d+148>>2]=s;c[d+152>>2]=c[e+152>>2];s=ea(g[e+156>>2]);r=ea(g[e+160>>2]);q=ea(g[e+164>>2]);p=ea(g[e+168>>2]);g[d+156>>2]=s;g[d+160>>2]=r;g[d+164>>2]=q;g[d+168>>2]=p;j=d+172|0;o=e+172|0;k=j+64|0;do{c[j>>2]=c[o>>2];j=j+4|0;o=o+4|0}while((j|0)<(k|0));c[d+236>>2]=c[e+236>>2];n=d+240|0;l=e+240|0;j=n+0|0;o=l+0|0;k=j+48|0;do{c[j>>2]=c[o>>2];j=j+4|0;o=o+4|0}while((j|0)<(k|0));b[n+48>>1]=b[l+48>>1]|0;i=f;return d|0}function m2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];h5c(b,s,e);s=c[j>>2]|0;if(!s){i=d;return}Ldd(a,c[b>>2]|0,s<<4);i=d;return}if(r){Bid(l,h,4);u=c[l>>2]|0;v=c[p>>2]|0}else{c[h>>2]=c[n>>2];c[l>>2]=o;u=o;v=q}q=u+4|0;if(q>>>0>v>>>0){Bid(l,g,4);w=c[g>>2]|0}else{v=c[u>>2]|0;c[g>>2]=v;c[l>>2]=q;w=v}v=c[h>>2]<<4;h=zid(l,w,v)|0;w=b+12|0;if((c[w>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=v>>4;c[b+8>>2]=e;c[w>>2]=e|-2147483648;c[b>>2]=h;c[m>>2]=0;i=d;return}function n2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[d>>2]|0;if(!h){j=ds(c[a>>2]|0)|0;Wrc(j);c[d>>2]=j;k=j}else k=h;h=c[k+8>>2]|0;c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[h+20>>2]=c[b+20>>2];c[h+24>>2]=c[b+24>>2];k=h+28|0;j=b+28|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[k+16>>2]=c[j+16>>2];c[k+20>>2]=c[j+20>>2];c[k+24>>2]=c[j+24>>2];j=h+56|0;if((h|0)==(b|0)){l=h+72|0;m=b+72|0;n=m;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;t=l;u=t;c[u>>2]=p;v=t+4|0;w=v;c[w>>2]=s;i=e;return}k=c[b+56>>2]|0;d=c[b+64>>2]<<4;a=d>>4;x=h+64|0;c[x>>2]=a;y=h+68|0;z=c[y>>2]|0;do if((z&2147483647)>>>0<a>>>0)if((z|0)>-1){c[y>>2]=a;A=c[j>>2]|0;c[g>>2]=c[h+60>>2];c[f+0>>2]=c[g+0>>2];B=hOb(A,d,4,f,0,3653512,370)|0;c[j>>2]=B;C=B;break}else{c[g>>2]=c[h+60>>2];c[f+0>>2]=c[g+0>>2];B=cOb(d,4,f,0,3653512,352)|0;YEi(B|0,c[j>>2]|0,c[x>>2]<<4|0)|0;c[y>>2]=a;c[j>>2]=B;C=B;break}else C=c[j>>2]|0;while(0);YEi(C|0,k|0,c[x>>2]<<4|0)|0;l=h+72|0;m=b+72|0;n=m;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;t=l;u=t;c[u>>2]=p;v=t+4|0;w=v;c[w>>2]=s;i=e;return}function o2c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;a=e+20|0;f=e+16|0;g=e;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[d+16>>2]|0;k=c[d+20>>2]|0;d=c[k+4>>2]|0;if(!d)l=c[g>>2]|0;else{RHc(g,d);m=0;do{n=b[(Gsc(c[k>>2]|0,m,2)|0)>>1]|0;o=c[g>>2]|0;b[o+(m<<1)>>1]=n;m=m+1|0}while((m|0)!=(d|0));l=o}d=c[h>>2]|0;m=d-l>>1;c[a>>2]=m;k=j+12|0;o=c[k>>2]|0;n=o+4|0;p=j+20|0;if(n>>>0<(c[p>>2]|0)>>>0){c[o>>2]=m;c[k>>2]=n;q=l;r=d}else{Gid(k,a,4);q=c[g>>2]|0;r=c[h>>2]|0}if((q|0)==(r|0))s=q;else{d=q;do{q=c[k>>2]|0;l=q+2|0;if(l>>>0<(c[p>>2]|0)>>>0){b[q>>1]=b[d>>1]|0;c[k>>2]=l}else Gid(k,d,2);d=d+2|0}while((d|0)!=(r|0));s=c[g>>2]|0}if(!s){i=e;return}g=c[h>>2]|0;if((g|0)!=(s|0))c[h>>2]=g+(~((g+-2-s|0)>>>1)<<1);c[f>>2]=89;c[a+0>>2]=c[f+0>>2];eOb(s,a);i=e;return}function p2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;b=e+20|0;f=e+16|0;g=e;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[d+16>>2]|0;k=c[d+20>>2]|0;d=c[k+4>>2]|0;if(d){i5c(g,d);l=0;do{m=a[(Gsc(c[k>>2]|0,l,1)|0)>>0]|0;a[(c[g>>2]|0)+l>>0]=m;l=l+1|0}while((l|0)!=(d|0))}d=c[h>>2]|0;l=c[g>>2]|0;k=d-l|0;c[b>>2]=k;m=j+12|0;n=c[m>>2]|0;o=n+4|0;p=j+20|0;if(o>>>0<(c[p>>2]|0)>>>0){c[n>>2]=k;c[m>>2]=o;q=l;r=d}else{Gid(m,b,4);q=c[g>>2]|0;r=c[h>>2]|0}if((q|0)==(r|0))s=q;else{d=q;do{q=c[m>>2]|0;if((q+1|0)>>>0<(c[p>>2]|0)>>>0){a[q>>0]=a[d>>0]|0;c[m>>2]=(c[m>>2]|0)+1}else Gid(m,d,1);d=d+1|0}while((d|0)!=(r|0));s=c[g>>2]|0}if(!s){i=e;return}if((c[h>>2]|0)!=(s|0))c[h>>2]=s;c[f>>2]=89;c[b+0>>2]=c[f+0>>2];eOb(s,b);i=e;return}function q2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;b=e+20|0;f=e+16|0;g=e;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[d+16>>2]|0;k=c[d+20>>2]|0;d=c[k+4>>2]|0;if(d){j5c(g,d);l=0;do{m=a[(Gsc(c[k>>2]|0,l,1)|0)>>0]|0;a[(c[g>>2]|0)+l>>0]=m;l=l+1|0}while((l|0)!=(d|0))}d=c[h>>2]|0;l=c[g>>2]|0;k=d-l|0;c[b>>2]=k;m=j+12|0;n=c[m>>2]|0;o=n+4|0;p=j+20|0;if(o>>>0<(c[p>>2]|0)>>>0){c[n>>2]=k;c[m>>2]=o;q=l;r=d}else{Gid(m,b,4);q=c[g>>2]|0;r=c[h>>2]|0}if((q|0)!=(r|0)){d=q;do{q=c[m>>2]|0;if((q+1|0)>>>0<(c[p>>2]|0)>>>0){a[q>>0]=a[d>>0]|0;c[m>>2]=(c[m>>2]|0)+1}else Gid(m,d,1);d=d+1|0}while((d|0)!=(r|0))}Tdd(j);j=c[g>>2]|0;if(!j){i=e;return}if((c[h>>2]|0)!=(j|0))c[h>>2]=j;c[f>>2]=89;c[b+0>>2]=c[f+0>>2];eOb(j,b);i=e;return}function r2c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;a=e+20|0;f=e+16|0;g=e;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[d+16>>2]|0;k=c[d+20>>2]|0;d=c[k+4>>2]|0;if(!d)l=c[g>>2]|0;else{k5c(g,d);m=0;do{n=b[(Gsc(c[k>>2]|0,m,2)|0)>>1]|0;o=c[g>>2]|0;b[o+(m<<1)>>1]=n;m=m+1|0}while((m|0)!=(d|0));l=o}d=c[h>>2]|0;m=d-l>>1;c[a>>2]=m;k=j+12|0;o=c[k>>2]|0;n=o+4|0;p=j+20|0;if(n>>>0<(c[p>>2]|0)>>>0){c[o>>2]=m;c[k>>2]=n;q=l;r=d}else{Gid(k,a,4);q=c[g>>2]|0;r=c[h>>2]|0}if((q|0)==(r|0))s=q;else{d=q;do{q=c[k>>2]|0;l=q+2|0;if(l>>>0<(c[p>>2]|0)>>>0){b[q>>1]=b[d>>1]|0;c[k>>2]=l}else Gid(k,d,2);d=d+2|0}while((d|0)!=(r|0));s=c[g>>2]|0}if(!s){i=e;return}g=c[h>>2]|0;if((g|0)!=(s|0))c[h>>2]=g+(~((g+-2-s|0)>>>1)<<1);c[f>>2]=89;c[a+0>>2]=c[f+0>>2];eOb(s,a);i=e;return}function s2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{l5c(f,b);l=0;do{m=c[(Gsc(c[j>>2]|0,l,4)|0)>>2]|0;n=c[f>>2]|0;c[n+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(b|0));k=n}b=c[g>>2]|0;l=b-k>>2;c[a>>2]=l;j=h+12|0;n=c[j>>2]|0;m=n+4|0;o=h+20|0;if(m>>>0<(c[o>>2]|0)>>>0){c[n>>2]=l;c[j>>2]=m;p=k;q=b}else{Gid(j,a,4);p=c[f>>2]|0;q=c[g>>2]|0}if((p|0)==(q|0))r=p;else{b=p;do{p=c[j>>2]|0;k=p+4|0;if(k>>>0<(c[o>>2]|0)>>>0){c[p>>2]=c[b>>2];c[j>>2]=k}else Gid(j,b,4);b=b+4|0}while((b|0)!=(q|0));r=c[f>>2]|0}if(!r){i=d;return}f=c[g>>2]|0;if((f|0)!=(r|0))c[g>>2]=f+(~((f+-4-r|0)>>>2)<<2);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(r,a);i=d;return}function t2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{Qec(f,b);l=0;do{m=c[(Gsc(c[j>>2]|0,l,4)|0)>>2]|0;n=c[f>>2]|0;c[n+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(b|0));k=n}b=c[g>>2]|0;l=b-k>>2;c[a>>2]=l;j=h+12|0;n=c[j>>2]|0;m=n+4|0;o=h+20|0;if(m>>>0<(c[o>>2]|0)>>>0){c[n>>2]=l;c[j>>2]=m;p=k;q=b}else{Gid(j,a,4);p=c[f>>2]|0;q=c[g>>2]|0}if((p|0)==(q|0))r=p;else{b=p;do{p=c[j>>2]|0;k=p+4|0;if(k>>>0<(c[o>>2]|0)>>>0){c[p>>2]=c[b>>2];c[j>>2]=k}else Gid(j,b,4);b=b+4|0}while((b|0)!=(q|0));r=c[f>>2]|0}if(!r){i=d;return}f=c[g>>2]|0;if((f|0)!=(r|0))c[g>>2]=f+(~((f+-4-r|0)>>>2)<<2);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(r,a);i=d;return}function u2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{m5c(f,b);l=0;do{m=Gsc(c[j>>2]|0,l,8)|0;n=c[m+4>>2]|0;o=c[f>>2]|0;p=o+(l<<3)|0;c[p>>2]=c[m>>2];c[p+4>>2]=n;l=l+1|0}while((l|0)!=(b|0));k=o}b=c[g>>2]|0;l=b-k>>3;c[a>>2]=l;j=h+12|0;o=c[j>>2]|0;n=o+4|0;p=h+20|0;if(n>>>0<(c[p>>2]|0)>>>0){c[o>>2]=l;c[j>>2]=n;q=k;r=b}else{Gid(j,a,4);q=c[f>>2]|0;r=c[g>>2]|0}if((q|0)==(r|0))s=q;else{b=q;do{q=c[j>>2]|0;k=q+8|0;if(k>>>0<(c[p>>2]|0)>>>0){n=b;l=c[n+4>>2]|0;o=q;c[o>>2]=c[n>>2];c[o+4>>2]=l;c[j>>2]=k}else Gid(j,b,8);b=b+8|0}while((b|0)!=(r|0));s=c[f>>2]|0}if(!s){i=d;return}f=c[g>>2]|0;if((f|0)!=(s|0))c[g>>2]=f+(~((f+-8-s|0)>>>3)<<3);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(s,a);i=d;return}function v2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{n5c(f,b);l=0;do{m=Gsc(c[j>>2]|0,l,8)|0;n=c[m+4>>2]|0;o=c[f>>2]|0;p=o+(l<<3)|0;c[p>>2]=c[m>>2];c[p+4>>2]=n;l=l+1|0}while((l|0)!=(b|0));k=o}b=c[g>>2]|0;l=b-k>>3;c[a>>2]=l;j=h+12|0;o=c[j>>2]|0;n=o+4|0;p=h+20|0;if(n>>>0<(c[p>>2]|0)>>>0){c[o>>2]=l;c[j>>2]=n;q=k;r=b}else{Gid(j,a,4);q=c[f>>2]|0;r=c[g>>2]|0}if((q|0)==(r|0))s=q;else{b=q;do{q=c[j>>2]|0;k=q+8|0;if(k>>>0<(c[p>>2]|0)>>>0){n=b;l=c[n+4>>2]|0;o=q;c[o>>2]=c[n>>2];c[o+4>>2]=l;c[j>>2]=k}else Gid(j,b,8);b=b+8|0}while((b|0)!=(r|0));s=c[f>>2]|0}if(!s){i=d;return}f=c[g>>2]|0;if((f|0)!=(s|0))c[g>>2]=f+(~((f+-8-s|0)>>>3)<<3);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(s,a);i=d;return}function w2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;h=f+4|0;c[h>>2]=0;c[f+8>>2]=0;j=c[b+16>>2]|0;k=c[b+20>>2]|0;b=c[k+4>>2]|0;if(!b)l=c[f>>2]|0;else{o5c(f,b);m=0;do{n=ea(g[(Gsc(c[k>>2]|0,m,4)|0)>>2]);o=c[f>>2]|0;g[o+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(b|0));l=o}b=c[h>>2]|0;m=b-l>>2;c[a>>2]=m;k=j+12|0;o=c[k>>2]|0;p=o+4|0;q=j+20|0;if(p>>>0<(c[q>>2]|0)>>>0){c[o>>2]=m;c[k>>2]=p;r=l;s=b}else{Gid(k,a,4);r=c[f>>2]|0;s=c[h>>2]|0}if((r|0)==(s|0))t=r;else{b=r;do{r=c[k>>2]|0;l=r+4|0;if(l>>>0<(c[q>>2]|0)>>>0){g[r>>2]=ea(g[b>>2]);c[k>>2]=l}else Gid(k,b,4);b=b+4|0}while((b|0)!=(s|0));t=c[f>>2]|0}if(!t){i=d;return}f=c[h>>2]|0;if((f|0)!=(t|0))c[h>>2]=f+(~((f+-4-t|0)>>>2)<<2);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(t,a);i=d;return}function x2c(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+32|0;b=f+20|0;g=f+16|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[e+16>>2]|0;m=c[e+20>>2]|0;e=c[m+4>>2]|0;if(!e)n=c[j>>2]|0;else{p5c(j,e);o=0;do{p=+h[(Gsc(c[m>>2]|0,o,8)|0)>>3];q=c[j>>2]|0;h[q+(o<<3)>>3]=p;o=o+1|0}while((o|0)!=(e|0));n=q}e=c[k>>2]|0;o=e-n>>3;c[b>>2]=o;m=l+12|0;q=c[m>>2]|0;r=q+4|0;s=l+20|0;if(r>>>0<(c[s>>2]|0)>>>0){c[q>>2]=o;c[m>>2]=r;t=n;u=e}else{Gid(m,b,4);t=c[j>>2]|0;u=c[k>>2]|0}if((t|0)==(u|0))v=t;else{e=t;do{t=c[m>>2]|0;if((t+8|0)>>>0<(c[s>>2]|0)>>>0){n=e;r=n;o=d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24;r=n+4|0;n=d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24;r=t;t=r;a[t>>0]=o;a[t+1>>0]=o>>8;a[t+2>>0]=o>>16;a[t+3>>0]=o>>24;o=r+4|0;a[o>>0]=n;a[o+1>>0]=n>>8;a[o+2>>0]=n>>16;a[o+3>>0]=n>>24;c[m>>2]=(c[m>>2]|0)+8}else Gid(m,e,8);e=e+8|0}while((e|0)!=(u|0));v=c[j>>2]|0}if(!v){i=f;return}j=c[k>>2]|0;if((j|0)!=(v|0))c[k>>2]=j+(~((j+-8-v|0)>>>3)<<3);c[g>>2]=89;c[b+0>>2]=c[g+0>>2];eOb(v,b);i=f;return}function y2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;c[j+12>>2]=c[e>>2];e=c[d+16>>2]|0;q5c(j,c[d+20>>2]|0);d=c[k>>2]|0;l=c[j>>2]|0;m=(d-l|0)/292|0;c[f>>2]=m;n=e+12|0;o=c[n>>2]|0;p=o+4|0;if(p>>>0<(c[e+20>>2]|0)>>>0){c[o>>2]=m;c[n>>2]=p;q=l;r=d}else{Gid(n,f,4);q=c[j>>2]|0;r=c[k>>2]|0}if((q|0)==(r|0))s=q;else{n=q;do{P2c(n,e);n=n+292|0}while((n|0)!=(r|0));s=c[j>>2]|0}if(!s){i=b;return}r=c[k>>2]|0;if((r|0)==(s|0))t=s;else{n=r;while(1){r=n+-292|0;c[k>>2]=r;if(!(a[r>>0]&1))u=r;else{r=c[n+-284>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(r,f);u=c[k>>2]|0}if((u|0)==(s|0))break;else n=u}t=c[j>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(t,f);i=b;return}function z2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=i;i=i+32|0;e=a+28|0;f=a+24|0;g=a;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+12|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];d=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(b){r5c(g,b);k=0;do{l=c[(Rrc(c[j>>2]|0,k)|0)>>2]|0;if(l){m=c[g>>2]|0;c[m+(k*12|0)>>2]=Grc(l)|0}k=k+1|0}while((k|0)!=(b|0))}b=c[h>>2]|0;k=c[g>>2]|0;j=(b-k|0)/12|0;c[e>>2]=j;l=d+12|0;m=c[l>>2]|0;n=m+4|0;if(n>>>0<(c[d+20>>2]|0)>>>0){c[m>>2]=j;c[l>>2]=n;o=k;p=b}else{Gid(l,e,4);o=c[g>>2]|0;p=c[h>>2]|0}if((o|0)==(p|0))q=o;else{l=o;do{Yxc(l,d);l=l+12|0}while((l|0)!=(p|0));q=c[g>>2]|0}if(!q){i=a;return}g=c[h>>2]|0;if((g|0)!=(q|0))c[h>>2]=g+(~(((g+-12-q|0)>>>0)/12|0)*12|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(q,e);i=a;return}function A2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;b=e+24|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;s5c(h,c[d+20>>2]|0);d=c[j>>2]|0;l=c[h>>2]|0;m=(d-l|0)/12|0;c[b>>2]=m;n=k+12|0;o=c[n>>2]|0;p=o+4|0;if(p>>>0<(c[k+20>>2]|0)>>>0){c[o>>2]=m;c[n>>2]=p;q=l;r=d}else{Gid(n,b,4);q=c[h>>2]|0;r=c[j>>2]|0}if((q|0)==(r|0))s=q;else{n=q;do{R2c(k,n,3142592,0);n=n+12|0}while((n|0)!=(r|0));s=c[h>>2]|0}if(!s){i=e;return}r=c[j>>2]|0;if((r|0)==(s|0))t=s;else{n=r;while(1){r=n+-12|0;c[j>>2]=r;if(!(a[r>>0]&1))u=r;else{r=c[n+-4>>2]|0;c[f>>2]=89;c[b+0>>2]=c[f+0>>2];eOb(r,b);u=c[j>>2]|0}if((u|0)==(s|0))break;else n=u}t=c[h>>2]|0}c[g>>2]=89;c[b+0>>2]=c[g+0>>2];eOb(t,b);i=e;return}function B2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(b){t5c(f,b);k=0;do{l=Gsc(c[j>>2]|0,k,12)|0;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];l=(c[f>>2]|0)+(k*12|0)|0;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];k=k+1|0}while((k|0)!=(b|0))}u5c(h,f,0);h=c[f>>2]|0;if(!h){i=d;return}f=c[g>>2]|0;if((f|0)!=(h|0))c[g>>2]=f+(~(((f+-12-h|0)>>>0)/12|0)*12|0);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(h,a);i=d;return}function C2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;h=f+4|0;c[h>>2]=0;c[f+8>>2]=0;j=c[b+16>>2]|0;k=c[b+20>>2]|0;b=c[k+4>>2]|0;if(b){v5c(f,b);l=0;do{m=Gsc(c[k>>2]|0,l,8)|0;n=c[m+4>>2]|0;o=(c[f>>2]|0)+(l<<3)|0;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(b|0))}b=c[h>>2]|0;l=c[f>>2]|0;k=b-l>>3;c[a>>2]=k;n=j+12|0;o=c[n>>2]|0;m=o+4|0;p=j+20|0;if(m>>>0<(c[p>>2]|0)>>>0){c[o>>2]=k;c[n>>2]=m;q=l;r=b}else{Gid(n,a,4);q=c[f>>2]|0;r=c[h>>2]|0}if((q|0)==(r|0))s=q;else{b=q;do{q=c[n>>2]|0;l=q+4|0;m=c[p>>2]|0;if(l>>>0<m>>>0){g[q>>2]=ea(g[b>>2]);c[n>>2]=l;t=l;u=m}else{Gid(n,b,4);t=c[n>>2]|0;u=c[p>>2]|0}m=b+4|0;l=t+4|0;if(l>>>0<u>>>0){g[t>>2]=ea(g[m>>2]);c[n>>2]=l}else Gid(n,m,4);b=b+8|0}while((b|0)!=(r|0));s=c[f>>2]|0}if(!s){i=d;return}f=c[h>>2]|0;if((f|0)!=(s|0))c[h>>2]=f+(~((f+-8-s|0)>>>3)<<3);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(s,a);i=d;return}function D2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;a=d+24|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(b){w5c(f,b);k=0;do{l=Gsc(c[j>>2]|0,k,16)|0;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];l=(c[f>>2]|0)+(k<<4)|0;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];k=k+1|0}while((k|0)!=(b|0))}b=c[g>>2]|0;k=c[f>>2]|0;j=b-k>>4;c[a>>2]=j;l=h+12|0;m=c[l>>2]|0;n=m+4|0;if(n>>>0<(c[h+20>>2]|0)>>>0){c[m>>2]=j;c[l>>2]=n;o=k;p=b}else{Gid(l,a,4);o=c[f>>2]|0;p=c[g>>2]|0}if((o|0)==(p|0))q=o;else{l=o;do{mjc(h,l,3142592,0);l=l+16|0}while((l|0)!=(p|0));q=c[f>>2]|0}if(!q){i=d;return}f=c[g>>2]|0;if((f|0)!=(q|0))c[g>>2]=f+(~((f+-16-q|0)>>>4)<<4);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(q,a);i=d;return}function E2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;a=d+24|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(b){x5c(f,b);k=0;do{l=Gsc(c[j>>2]|0,k,16)|0;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];l=(c[f>>2]|0)+(k<<4)|0;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];k=k+1|0}while((k|0)!=(b|0))}b=c[g>>2]|0;k=c[f>>2]|0;j=b-k>>4;c[a>>2]=j;l=h+12|0;m=c[l>>2]|0;n=m+4|0;if(n>>>0<(c[h+20>>2]|0)>>>0){c[m>>2]=j;c[l>>2]=n;o=k;p=b}else{Gid(l,a,4);o=c[f>>2]|0;p=c[g>>2]|0}if((o|0)==(p|0))q=o;else{l=o;do{QYb(h,l,3142592,0);l=l+16|0}while((l|0)!=(p|0));q=c[f>>2]|0}if(!q){i=d;return}f=c[g>>2]|0;if((f|0)!=(q|0))c[g>>2]=f+(~((f+-16-q|0)>>>4)<<4);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(q,a);i=d;return}function F2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;a=d+24|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(b){y5c(f,b);k=0;do{l=Gsc(c[j>>2]|0,k,16)|0;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];l=(c[f>>2]|0)+(k<<4)|0;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];k=k+1|0}while((k|0)!=(b|0))}b=c[g>>2]|0;k=c[f>>2]|0;j=b-k>>4;c[a>>2]=j;l=h+12|0;m=c[l>>2]|0;n=m+4|0;if(n>>>0<(c[h+20>>2]|0)>>>0){c[m>>2]=j;c[l>>2]=n;o=k;p=b}else{Gid(l,a,4);o=c[f>>2]|0;p=c[g>>2]|0}if((o|0)==(p|0))q=o;else{l=o;do{EHc(h,l,3142592,0);l=l+16|0}while((l|0)!=(p|0));q=c[f>>2]|0}if(!q){i=d;return}f=c[g>>2]|0;if((f|0)!=(q|0))c[g>>2]=f+(~((f+-16-q|0)>>>4)<<4);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(q,a);i=d;return}function G2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{z5c(f,b);l=0;do{m=Gsc(c[j>>2]|0,l,64)|0;n=c[f>>2]|0;aFi(n+(l<<6)|0,m|0,64)|0;l=l+1|0}while((l|0)!=(b|0));k=n}b=c[g>>2]|0;l=b-k>>6;c[a>>2]=l;j=h+12|0;n=c[j>>2]|0;m=n+4|0;if(m>>>0<(c[h+20>>2]|0)>>>0){c[n>>2]=l;c[j>>2]=m;o=k;p=b}else{Gid(j,a,4);o=c[f>>2]|0;p=c[g>>2]|0}if((o|0)==(p|0))q=o;else{j=o;do{Pfc(j,h);j=j+64|0}while((j|0)!=(p|0));q=c[f>>2]|0}if(!q){i=d;return}f=c[g>>2]|0;if((f|0)!=(q|0))c[g>>2]=f+(~((f+-64-q|0)>>>6)<<6);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(q,a);i=d;return}function H2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{A5c(f,b);l=0;do{m=Gsc(c[j>>2]|0,l,24)|0;n=c[f>>2]|0;aFi(n+(l*24|0)|0,m|0,24)|0;l=l+1|0}while((l|0)!=(b|0));k=n}b=c[g>>2]|0;l=(b-k|0)/24|0;c[a>>2]=l;j=h+12|0;n=c[j>>2]|0;m=n+4|0;if(m>>>0<(c[h+20>>2]|0)>>>0){c[n>>2]=l;c[j>>2]=m;o=k;p=b}else{Gid(j,a,4);o=c[f>>2]|0;p=c[g>>2]|0}if((o|0)==(p|0))q=o;else{j=o;do{jdc(j,h);j=j+24|0}while((j|0)!=(p|0));q=c[f>>2]|0}if(!q){i=d;return}f=c[g>>2]|0;if((f|0)!=(q|0))c[g>>2]=f+(~(((f+-24-q|0)>>>0)/24|0)*24|0);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(q,a);i=d;return}function I2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;h=f+4|0;c[h>>2]=0;c[f+8>>2]=0;j=c[b+16>>2]|0;k=c[b+20>>2]|0;b=c[k+4>>2]|0;if(!b)l=c[f>>2]|0;else{B5c(f,b);m=0;do{n=Gsc(c[k>>2]|0,m,16)|0;o=ea(g[n>>2]);p=ea(g[n+4>>2]);q=ea(g[n+8>>2]);r=ea(g[n+12>>2]);n=c[f>>2]|0;g[n+(m<<4)>>2]=o;g[n+(m<<4)+4>>2]=p;g[n+(m<<4)+8>>2]=q;g[n+(m<<4)+12>>2]=r;m=m+1|0}while((m|0)!=(b|0));l=n}b=c[h>>2]|0;m=b-l>>4;c[a>>2]=m;k=j+12|0;n=c[k>>2]|0;s=n+4|0;if(s>>>0<(c[j+20>>2]|0)>>>0){c[n>>2]=m;c[k>>2]=s;t=l;u=b}else{Gid(k,a,4);t=c[f>>2]|0;u=c[h>>2]|0}if((t|0)==(u|0))v=t;else{k=t;do{PYb(k,j);k=k+16|0}while((k|0)!=(u|0));v=c[f>>2]|0}if(!v){i=d;return}f=c[h>>2]|0;if((f|0)!=(v|0))c[h>>2]=f+(~((f+-16-v|0)>>>4)<<4);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(v,a);i=d;return}function J2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{C5c(f,b);l=0;do{m=c[(Gsc(c[j>>2]|0,l,4)|0)>>2]|0;n=c[f>>2]|0;c[n+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(b|0));k=n}b=c[g>>2]|0;l=b-k>>2;c[a>>2]=l;j=h+12|0;n=c[j>>2]|0;m=n+4|0;o=h+20|0;if(m>>>0<(c[o>>2]|0)>>>0){c[n>>2]=l;c[j>>2]=m;p=k;q=b}else{Gid(j,a,4);p=c[f>>2]|0;q=c[g>>2]|0}if((p|0)==(q|0))r=p;else{b=p;do{p=c[j>>2]|0;k=p+4|0;if(k>>>0<(c[o>>2]|0)>>>0){c[p>>2]=c[b>>2];c[j>>2]=k}else Gid(j,b,4);b=b+4|0}while((b|0)!=(q|0));r=c[f>>2]|0}if(!r){i=d;return}f=c[g>>2]|0;if((f|0)!=(r|0))c[g>>2]=f+(~((f+-4-r|0)>>>2)<<2);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(r,a);i=d;return}function K2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;a=d+20|0;e=d+16|0;f=d;c[f>>2]=0;g=f+4|0;c[g>>2]=0;c[f+8>>2]=0;h=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(!b)k=c[f>>2]|0;else{D5c(f,b);l=0;do{m=c[(Gsc(c[j>>2]|0,l,4)|0)>>2]|0;n=c[f>>2]|0;c[n+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(b|0));k=n}b=c[g>>2]|0;l=b-k>>2;c[a>>2]=l;j=h+12|0;n=c[j>>2]|0;m=n+4|0;o=h+20|0;if(m>>>0<(c[o>>2]|0)>>>0){c[n>>2]=l;c[j>>2]=m;p=k;q=b}else{Gid(j,a,4);p=c[f>>2]|0;q=c[g>>2]|0}if((p|0)==(q|0))r=p;else{b=p;do{p=c[j>>2]|0;k=p+4|0;if(k>>>0<(c[o>>2]|0)>>>0){c[p>>2]=c[b>>2];c[j>>2]=k}else Gid(j,b,4);b=b+4|0}while((b|0)!=(q|0));r=c[f>>2]|0}if(!r){i=d;return}f=c[g>>2]|0;if((f|0)!=(r|0))c[g>>2]=f+(~((f+-4-r|0)>>>2)<<2);c[e>>2]=89;c[a+0>>2]=c[e+0>>2];eOb(r,a);i=d;return}function L2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;i=i+32|0;e=a+20|0;f=a+16|0;g=a;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;c[g+12>>2]=c[d>>2];d=c[b+16>>2]|0;E5c(g,c[b+20>>2]|0);b=c[h>>2]|0;j=c[g>>2]|0;k=(b-j|0)/80|0;c[e>>2]=k;l=d+12|0;m=c[l>>2]|0;n=m+4|0;if(n>>>0<(c[d+20>>2]|0)>>>0){c[m>>2]=k;c[l>>2]=n;o=j;p=b}else{Gid(l,e,4);o=c[g>>2]|0;p=c[h>>2]|0}if((o|0)==(p|0))q=o;else{l=o;do{T2c(l,d);l=l+80|0}while((l|0)!=(p|0));q=c[g>>2]|0}if(!q){i=a;return}p=c[h>>2]|0;if((p|0)==(q|0))r=q;else{l=p;while(1){p=l+-80|0;c[h>>2]=p;if((c[l+-12>>2]|0)>-1){d=l+-24|0;o=c[d>>2]|0;c[f>>2]=c[l+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(o,e);c[d>>2]=0;s=c[h>>2]|0}else s=p;if((s|0)==(q|0))break;else l=s}r=c[g>>2]|0}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=a;return}function M2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=i;i=i+32|0;e=a+20|0;f=a+16|0;g=a;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;c[g+12>>2]=c[d>>2];d=c[b+16>>2]|0;F5c(g,c[b+20>>2]|0);b=c[h>>2]|0;j=c[g>>2]|0;k=(b-j|0)/68|0;c[e>>2]=k;l=d+12|0;m=c[l>>2]|0;n=m+4|0;if(n>>>0<(c[d+20>>2]|0)>>>0){c[m>>2]=k;c[l>>2]=n;o=j;p=b}else{Gid(l,e,4);o=c[g>>2]|0;p=c[h>>2]|0}if((o|0)==(p|0))q=o;else{l=o;do{SLc(l,d);l=l+68|0}while((l|0)!=(p|0));q=c[g>>2]|0}if(!q){i=a;return}while(1){p=c[h>>2]|0;if((p|0)==(q|0))break;c[h>>2]=p+-68}h=c[g>>2]|0;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(h,e);i=a;return}function N2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=i;i=i+32|0;e=a+20|0;f=a+16|0;g=a;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;c[g+12>>2]=c[d>>2];d=c[b+16>>2]|0;j=c[b+20>>2]|0;b=c[j+4>>2]|0;if(b){G5c(g,b);k=0;do{l=c[(Rrc(c[j>>2]|0,k)|0)>>2]|0;if(l){m=(c[g>>2]|0)+(k<<4)|0;n=c[l+8>>2]|0;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2]}k=k+1|0}while((k|0)!=(b|0))}b=c[h>>2]|0;k=c[g>>2]|0;j=b-k>>4;c[e>>2]=j;n=d+12|0;m=c[n>>2]|0;l=m+4|0;if(l>>>0<(c[d+20>>2]|0)>>>0){c[m>>2]=j;c[n>>2]=l;o=k;p=b}else{Gid(n,e,4);o=c[g>>2]|0;p=c[h>>2]|0}if((o|0)==(p|0))q=o;else{n=o;do{l$c(n,d);n=n+16|0}while((n|0)!=(p|0));q=c[g>>2]|0}if(!q){i=a;return}g=c[h>>2]|0;if((g|0)!=(q|0))c[h>>2]=g+(~((g+-16-q|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(q,e);i=a;return}function O2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+96|0;f=e+64|0;g=e+88|0;h=e+56|0;j=e;k=c[d>>2]|0;l=c[k+4>>2]|0;c[h>>2]=l;m=b+12|0;n=c[m>>2]|0;o=n+4|0;if(o>>>0<(c[b+20>>2]|0)>>>0){c[n>>2]=l;c[m>>2]=o;p=k}else{Gid(m,h,4);p=c[d>>2]|0}h=c[p+4>>2]|0;m=j+24|0;a[m>>0]=1;k=j+28|0;c[k>>2]=0;o=j+32|0;c[o>>2]=0;l=j+40|0;c[j>>2]=p;n=j+12|0;c[n>>2]=0;q=d+4|0;r=j+4|0;a[r>>0]=(dsc(c[q>>2]|0)|0)&1;s=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;t=j+8|0;c[t>>2]=s;u=j+16|0;c[u>>2]=c[q>>2];q=c[d+8>>2]|0;d=c[q>>2]|0;v=c[q+8>>2]|0;c[l>>2]=d;c[j+36>>2]=d;c[j+44>>2]=v;q=v-d>>6;c[j+52>>2]=q;c[j+48>>2]=q;if(!h){i=e;return}q=j+36|0;v=j+20|0;w=j+25|0;x=f+16|0;y=f+12|0;z=d;d=p;p=0;A=s;while(1){c[l>>2]=z;c[v>>2]=q;s=Gsc(c[d>>2]|0,p,A)|0;if(!(a[r>>0]|0)){B=c[s>>2]|0;if(!B){C=ds(c[u>>2]|0)|0;Wrc(C);Qrc(c[c[j>>2]>>2]|0,c[n>>2]|0,C);D=C}else D=B;B=c[u>>2]|0;a[m>>0]=1;a[w+0>>0]=a[g+0>>0]|0;a[w+1>>0]=a[g+1>>0]|0;a[w+2>>0]=a[g+2>>0]|0;E=B;F=D}else{B=c[u>>2]|0;a[m>>0]=0;a[w+0>>0]=a[f+0>>0]|0;a[w+1>>0]=a[f+1>>0]|0;a[w+2>>0]=a[f+2>>0]|0;E=B;F=s}c[k>>2]=F;c[o>>2]=E;s=c[v>>2]|0;c[x>>2]=b;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[y>>2]=s;B=s+4|0;C=c[B>>2]|0;G=s+8|0;H=c[G>>2]|0;if((C|0)!=(H|0)){I=s+12|0;s=C;C=H;do{H=s+64|0;c[B>>2]=H;c[I>>2]=C-H>>6;In[c[s>>2]&4095](s+4|0,f);s=c[B>>2]|0;C=c[G>>2]|0}while((s|0)!=(C|0))}C=(c[n>>2]|0)+1|0;c[n>>2]=C;if((C|0)==(h|0))break;z=c[q>>2]|0;d=c[j>>2]|0;p=C;A=c[t>>2]|0}i=e;return}function P2c(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;FXb(d,b,2487248,0);Tdd(d);q9b(b+12|0,d);PYb(b+16|0,d);q9b(b+32|0,d);PYb(b+36|0,d);q9b(b+52|0,d);PYb(b+56|0,d);q9b(b+72|0,d);PYb(b+76|0,d);q9b(b+92|0,d);PYb(b+96|0,d);q9b(b+112|0,d);PYb(b+116|0,d);q9b(b+132|0,d);PYb(b+136|0,d);q9b(b+152|0,d);PYb(b+156|0,d);l$c(b+172|0,d);l$c(b+188|0,d);l$c(b+204|0,d);l$c(b+220|0,d);H5c(b+236|0,d);f=b+280|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){c[j>>2]=c[f>>2];c[h>>2]=k;n=k;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=b+284|0;m=n+4|0;if(m>>>0<o>>>0){c[n>>2]=c[f>>2];c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=b+240|0;o=p+4|0;if(o>>>0<q>>>0){c[p>>2]=c[f>>2];c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=b+244|0;if((r+1|0)>>>0<s>>>0){a[r>>0]=a[f>>0]|0;r=(c[h>>2]|0)+1|0;c[h>>2]=r;t=r}else{Gid(h,f,1);t=c[h>>2]|0}f=b+245|0;if((t+1|0)>>>0<(c[l>>2]|0)>>>0){a[t>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);f=b+248|0;t=c[h>>2]|0;r=t+4|0;s=c[l>>2]|0;if(r>>>0<s>>>0){c[t>>2]=c[f>>2];c[h>>2]=r;u=r;v=s}else{Gid(h,f,4);u=c[h>>2]|0;v=c[l>>2]|0}f=b+252|0;s=u+4|0;if(s>>>0<v>>>0){c[u>>2]=c[f>>2];c[h>>2]=s;w=s;x=v}else{Gid(h,f,4);w=c[h>>2]|0;x=c[l>>2]|0}f=b+256|0;v=w+4|0;if(v>>>0<x>>>0){g[w>>2]=ea(g[f>>2]);c[h>>2]=v;y=v;z=x}else{Gid(h,f,4);y=c[h>>2]|0;z=c[l>>2]|0}f=b+260|0;x=y+4|0;if(x>>>0<z>>>0){g[y>>2]=ea(g[f>>2]);c[h>>2]=x;A=x;B=z}else{Gid(h,f,4);A=c[h>>2]|0;B=c[l>>2]|0}f=b+272|0;z=A+4|0;if(z>>>0<B>>>0){g[A>>2]=ea(g[f>>2]);c[h>>2]=z;C=z;D=B}else{Gid(h,f,4);C=c[h>>2]|0;D=c[l>>2]|0}f=b+276|0;B=C+4|0;if(B>>>0<D>>>0){g[C>>2]=ea(g[f>>2]);c[h>>2]=B;E=B;F=D}else{Gid(h,f,4);E=c[h>>2]|0;F=c[l>>2]|0}f=b+288|0;if((E+1|0)>>>0<F>>>0){a[E>>0]=a[f>>0]|0;E=(c[h>>2]|0)+1|0;c[h>>2]=E;G=E}else{Gid(h,f,1);G=c[h>>2]|0}f=b+289|0;if((G+1|0)>>>0<(c[l>>2]|0)>>>0){a[G>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Tdd(d);i=e;return}else{Gid(h,f,1);Tdd(d);i=e;return}}function Q2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;f=b;Yrc(f,d);d=a[f>>0]|0;g=(d&1)==0;if(g)h=(d&255)>>>1;else h=c[f+4>>2]|0;do if(!h)if(!(a[e>>0]&1)){a[e+1>>0]=0;a[e>>0]=0;break}else{a[c[e+8>>2]>>0]=0;c[e+4>>2]=0;break}else{if(g)j=f+1|0;else j=c[f+8>>2]|0;d=SEi(j|0)|0;k=a[e>>0]|0;if(!(k&1)){l=10;m=k}else{k=c[e>>2]|0;l=(k&-2)+-1|0;m=k&255}k=(m&1)==0;if(d>>>0>l>>>0){if(k)n=(m&255)>>>1;else n=c[e+4>>2]|0;AOb(e,l,d-l|0,n,0,n,d,j);break}if(k)o=e+1|0;else o=c[e+8>>2]|0;aFi(o|0,j|0,d|0)|0;a[o+d>>0]=0;if(!(a[e>>0]&1)){a[e>>0]=d<<1;break}else{c[e+4>>2]=d;break}}while(0);xri(f);i=b;return}function R2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f;g=a[d>>0]|0;if(!(g&1))h=(g&255)>>>1;else h=c[d+4>>2]|0;c[e>>2]=h;g=b+12|0;j=c[g>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=h;c[g>>2]=k}else Gid(g,e,4);e=a[d>>0]|0;if(!(e&1)){m=d+1|0;n=d+((e&255)>>>1)+1|0}else{e=c[d+8>>2]|0;m=e;n=e+(c[d+4>>2]|0)|0}if((m|0)==(n|0)){Tdd(b);i=f;return}else o=m;do{m=c[g>>2]|0;if((m+1|0)>>>0<(c[l>>2]|0)>>>0){a[m>>0]=a[o>>0]|0;c[g>>2]=(c[g>>2]|0)+1}else Gid(g,o,1);o=o+1|0}while((o|0)!=(n|0));Tdd(b);i=f;return}function S2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;if(!h){j=ds(c[a>>2]|0)|0;Wrc(j);c[b>>2]=j;k=j}else k=h;h=c[k+8>>2]|0;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];k=d+28|0;j=h+28|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[k+16>>2]=c[j+16>>2];c[k+20>>2]=c[j+20>>2];c[k+24>>2]=c[j+24>>2];j=d+56|0;if((h|0)==(d|0)){l=d+72|0;m=h+72|0;n=m;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;t=l;u=t;c[u>>2]=p;v=t+4|0;w=v;c[w>>2]=s;i=e;return}k=c[h+56>>2]|0;b=c[h+64>>2]<<4;a=b>>4;x=d+64|0;c[x>>2]=a;y=d+68|0;z=c[y>>2]|0;do if((z&2147483647)>>>0<a>>>0)if((z|0)>-1){c[y>>2]=a;A=c[j>>2]|0;c[g>>2]=c[d+60>>2];c[f+0>>2]=c[g+0>>2];B=hOb(A,b,4,f,0,3653512,370)|0;c[j>>2]=B;C=B;break}else{c[g>>2]=c[d+60>>2];c[f+0>>2]=c[g+0>>2];B=cOb(b,4,f,0,3653512,352)|0;YEi(B|0,c[j>>2]|0,c[x>>2]<<4|0)|0;c[y>>2]=a;c[j>>2]=B;C=B;break}else C=c[j>>2]|0;while(0);YEi(C|0,k|0,c[x>>2]<<4|0)|0;l=d+72|0;m=h+72|0;n=m;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;t=l;u=t;c[u>>2]=p;v=t+4|0;w=v;c[w>>2]=s;i=e;return}function T2c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=a+64|0;g=c[f>>2]|0;c[e>>2]=g;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=g;c[h>>2]=k}else Gid(h,e,4);e=c[a+56>>2]|0;k=c[f>>2]|0;f=e+(k<<4)|0;if(k){k=e;do{I5c(k,b);k=k+16|0}while((k|0)!=(f|0))}f=a+72|0;k=c[h>>2]|0;b=k+4|0;e=c[l>>2]|0;if(b>>>0<e>>>0){c[k>>2]=c[f>>2];c[h>>2]=b;m=b;n=e}else{Gid(h,f,4);m=c[h>>2]|0;n=c[l>>2]|0}l=a+76|0;a=m+4|0;if(a>>>0<n>>>0){c[m>>2]=c[l>>2];c[h>>2]=a;i=d;return}else{Gid(h,l,4);i=d;return}}function U2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142296]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=2;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-2-j|0)>>>1)<<1);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function V2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142292]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=1;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}if((c[h>>2]|0)!=(j|0))c[h>>2]=j;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function W2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142302]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=1;bdd(j);cdd(j);fdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}if((c[h>>2]|0)!=(j|0))c[h>>2]=j;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function X2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142286]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=2;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-2-j|0)>>>1)<<1);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function Y2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142270]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=4;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function Z2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142304]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=4;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function _2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+24|0;f=d;g=d+8|0;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142290]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=8;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function $2c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+24|0;f=d;g=d+8|0;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142300]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=8;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function a3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142268]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=4;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function b3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+24|0;f=d;g=d+8|0;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142264]|0,f,0);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=8;bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function c3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f;c[k>>2]=0;l=k+4|0;c[l>>2]=0;c[k+8>>2]=0;c[k+12>>2]=c[e>>2];e=c[d+16>>2]|0;add(e,c[b+4>>2]|0,c[142306]|0,k,c[b+24>>2]|0);J5c(e,k,0);bdd(e);e=c[k>>2]|0;if(!e){i=f;return}b=c[l>>2]|0;if((b|0)==(e|0))m=e;else{d=b;while(1){b=d+-292|0;c[l>>2]=b;if(!(a[b>>0]&1))n=b;else{b=c[d+-284>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(b,g);n=c[l>>2]|0}if((n|0)==(e|0))break;else d=n}m=c[k>>2]|0}c[j>>2]=89;c[g+0>>2]=c[j+0>>2];eOb(m,g);i=f;return}function d3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;K5c(c[d+16>>2]|0,j,c[b+4>>2]|0,c[b+24>>2]|0);b=c[j>>2]|0;if(!b){i=e;return}d=c[k>>2]|0;if((d|0)==(b|0))l=b;else{m=d;while(1){d=m+-12|0;c[k>>2]=d;if(!(a[d>>0]&1))n=d;else{d=c[m+-4>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(d,f);n=c[k>>2]|0}if((n|0)==(b|0))break;else m=n}l=c[j>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(l,f);i=e;return}function e3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+28|0;f=d+16|0;h=d;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[b+16>>2]|0;add(k,c[a+4>>2]|0,c[142306]|0,h,c[a+24>>2]|0);g[f>>2]=ea(0.0);g[f+4>>2]=ea(0.0);g[f+8>>2]=ea(0.0);$cd(k,2646336,2646336,e,0);gfc(k,f,3142592,0);cdd(k);bdd(k);k=c[h>>2]|0;if(!k){i=d;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~(((h+-12-k|0)>>>0)/12|0)*12|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function f3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;h=d;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[b+16>>2]|0;add(k,c[a+4>>2]|0,c[142306]|0,h,c[a+24>>2]|0);g[f>>2]=ea(0.0);a=f+4|0;g[a>>2]=ea(0.0);$cd(k,2646336,2646336,e,0);add(k,3142592,c[142308]|0,f,0);b=c[($hd(k+16|0)|0)+20>>2]|2097152;l=k+12|0;m=k+20|0;c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+20>>2]=b;b=c[142268]|0;add(k,3143216,b,f,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=4;bdd(k);add(k,3143224,b,a,0);c[(c[c[l>>2]>>2]|0)+((c[m>>2]|0)*24|0)+12>>2]=4;bdd(k);bdd(k);cdd(k);bdd(k);k=c[h>>2]|0;if(!k){i=d;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-8-k|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function g3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+32|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142312]|0,f,0);ljc(f,j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function h3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+32|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;$cd(j,2646336,2646336,e,0);add(j,3142592,c[142280]|0,f,0);FYb(f,j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function i3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+32|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142278]|0,f,0);uHc(f,j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function j3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+96|0;e=d+80|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,614736,f,0);cfc(f,j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-64-j|0)>>>6)<<6);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function k3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+40|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;$cd(j,2646336,2646336,e,0);add(j,3142592,614728,f,0);gfc(j,f,2490904,0);gfc(j,f+12|0,614664,0);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~(((g+-24-j|0)>>>0)/24|0)*24|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function l3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+32|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142262]|0,f,0);EYb(f,j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function m3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,c[142262]|0,f,0);ddd(j,2);add(j,614656,c[142304]|0,f,1);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=4;bdd(j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function n3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=c[b+16>>2]|0;add(j,c[a+4>>2]|0,c[142306]|0,g,c[a+24>>2]|0);$cd(j,2646336,2646336,e,0);add(j,3142592,614712,f,0);ddd(j,2);add(j,614648,c[142304]|0,f,4194305);c[(c[c[j+12>>2]>>2]|0)+((c[j+20>>2]|0)*24|0)+12>>2]=4;bdd(j);bdd(j);cdd(j);bdd(j);j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function o3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];d=c[b+16>>2]|0;add(d,c[a+4>>2]|0,c[142306]|0,h,c[a+24>>2]|0);L5c(d,h,0);bdd(d);d=c[h>>2]|0;if(!d){i=e;return}a=c[j>>2]|0;if((a|0)==(d|0))k=d;else{b=a;while(1){a=b+-80|0;c[j>>2]=a;if((c[b+-12>>2]|0)>-1){l=b+-24|0;m=c[l>>2]|0;c[g>>2]=c[b+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(m,f);c[l>>2]=0;n=c[j>>2]|0}else n=a;if((n|0)==(d|0))break;else b=n}k=c[h>>2]|0}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function p3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];M5c(c[b+16>>2]|0,h,c[a+4>>2]|0,c[a+24>>2]|0);a=c[h>>2]|0;if(!a){i=e;return}while(1){b=c[j>>2]|0;if((b|0)==(a|0))break;c[j>>2]=b+-68}j=c[h>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function q3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];d=c[b+16>>2]|0;add(d,c[a+4>>2]|0,c[142306]|0,h,c[a+24>>2]|0);c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;$cd(d,2646336,2646336,f,0);add(d,3142592,2390464,g,0);Q$c(g,d);bdd(d);cdd(d);bdd(d);d=c[h>>2]|0;if(!d){i=e;return}h=c[j>>2]|0;if((h|0)!=(d|0))c[j>>2]=h+(~((h+-16-d|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(d,f);i=e;return}function r3c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;add(b,2487248,c[142294]|0,a,0);$cd(b,2646336,2646336,e,1);add(b,3142592,c[142260]|0,d+16|0,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);fdd(b);h=a+12|0;add(b,2391880,2388280,h,0);N5c(h,b);bdd(b);h=a+32|0;add(b,2391920,2388280,h,0);N5c(h,b);bdd(b);h=a+52|0;add(b,2391952,2388280,h,0);N5c(h,b);bdd(b);h=a+72|0;add(b,2391992,2388280,h,0);N5c(h,b);bdd(b);h=a+92|0;add(b,2392032,2388280,h,0);N5c(h,b);bdd(b);h=a+112|0;add(b,2392072,2388280,h,0);N5c(h,b);bdd(b);h=a+132|0;add(b,2392112,2388280,h,0);N5c(h,b);bdd(b);h=a+152|0;add(b,2392152,2388280,h,0);N5c(h,b);bdd(b);h=a+172|0;add(b,2392192,2390464,h,0);Q$c(h,b);bdd(b);h=a+188|0;add(b,2373768,2390464,h,0);Q$c(h,b);bdd(b);h=a+204|0;add(b,2392232,2390464,h,0);Q$c(h,b);bdd(b);h=a+220|0;add(b,2392296,2390464,h,0);Q$c(h,b);bdd(b);h=a+236|0;add(b,2380056,723592,h,0);j=e+8|0;k=j;c[k>>2]=0;c[k+4>>2]=0;c[e>>2]=0;e=c[142270]|0;add(b,792256,e,h,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,j,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,723488,e,a+280|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614352,e,a+284|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614368,e,a+240|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);j=c[142258]|0;add(b,614384,j,a+244|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,614400,j,a+245|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,614416,e,a+248|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614432,e,a+252|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=a+256|0;add(b,614448,c[142308]|0,e,0);h=c[($hd(b+16|0)|0)+20>>2]|2097152;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+20>>2]=h;h=c[142268]|0;add(b,3143216,h,e,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,h,a+260|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);add(b,614464,h,a+272|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614480,h,a+276|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614496,j,a+288|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,614512,c[142258]|0,a+289|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function s3c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;ddd(b,2);add(b,614584,c[142306]|0,a+56|0,1);$cd(b,2646336,2646336,d+16|0,0);add(b,3142592,2469920,e,0);O5c(e,b);bdd(b);cdd(b);bdd(b);e=c[142270]|0;add(b,614592,e,a+72|0,1);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614608,e,a+76|0,1);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function t3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+80|0;g=f+64|0;h=f+8|0;j=f+32|0;k=f;l=f+16|0;c[l>>2]=0;m=l+4|0;c[m>>2]=0;c[l+8>>2]=0;c[l+12>>2]=c[e>>2];e=c[d+16>>2]|0;n=d+20|0;q5c(l,c[n>>2]|0);d=c[b+24>>2]|0;if(!d){o=c[l>>2]|0;p=c[m>>2]|0;if((o|0)!=(p|0)){q=o;do{z3c(q,e);q=q+292|0}while((q|0)!=(p|0))}}else{idd(e,d);d=c[l>>2]|0;p=c[m>>2]|0;if((d|0)!=(p|0)){q=d;do{z3c(q,e);q=q+292|0}while((q|0)!=(p|0))}jdd(e)}Q4c(l,c[n>>2]|0,c[b+28>>2]|0);b=c[n>>2]|0;if(c[b+4>>2]|0){e=j+12|0;p=b;b=0;do{q=c[(Rrc(c[p>>2]|0,b)|0)>>2]|0;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){d=h;o=c[d+4>>2]|0;r=k;c[r>>2]=c[d>>2];c[r+4>>2]=o;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[e>>2]=q;xbd(j)|0}b=b+1|0;p=c[n>>2]|0}while((b|0)!=(c[p+4>>2]|0))}p=c[l>>2]|0;if(!p){i=f;return}b=c[m>>2]|0;if((b|0)==(p|0))s=p;else{n=b;while(1){b=n+-292|0;c[m>>2]=b;if(!(a[b>>0]&1))t=b;else{b=c[n+-284>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(b,g);t=c[m>>2]|0}if((t|0)==(p|0))break;else n=t}s=c[l>>2]|0}c[j>>2]=89;c[g+0>>2]=c[j+0>>2];eOb(s,g);i=f;return}function u3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=j+12|0;c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];e=c[d+16>>2]|0;l=d+20|0;d=c[l>>2]|0;m=c[d+4>>2]|0;if(m){r5c(j,m);n=0;do{o=c[(Rrc(c[d>>2]|0,n)|0)>>2]|0;if(o){p=c[j>>2]|0;c[p+(n*12|0)>>2]=Grc(o)|0}n=n+1|0}while((n|0)!=(m|0))}m=c[b+24>>2]|0;if(!m){n=c[j>>2]|0;d=c[k>>2]|0;if((n|0)!=(d|0)){o=e+12|0;p=e+28|0;q=e+32|0;r=n;do{n=c[o>>2]|0;s=xo[c[c[n>>2]>>2]&2047](n,c[r>>2]|0,c[p>>2]|0)|0;if(a[q>>0]|0)c[r>>2]=s;r=r+12|0}while((r|0)!=(d|0))}}else{idd(e,m);m=c[j>>2]|0;d=c[k>>2]|0;if((m|0)!=(d|0)){r=e+12|0;q=e+28|0;p=e+32|0;o=m;do{m=c[r>>2]|0;s=xo[c[c[m>>2]>>2]&2047](m,c[o>>2]|0,c[q>>2]|0)|0;if(a[p>>0]|0)c[o>>2]=s;o=o+12|0}while((o|0)!=(d|0))}jdd(e)}e=c[l>>2]|0;d=c[b+28>>2]|0;b=c[k>>2]|0;o=c[j>>2]|0;p=(b-o|0)/12|0;q=e+4|0;if((c[q>>2]|0)!=(p|0)){c[e>>2]=Isc(d,Zsc(d)|0,p)|0;c[q>>2]=p}if((b|0)!=(o|0)){o=j+12|0;b=j+20|0;q=j+16|0;d=0;do{r=Rrc(c[e>>2]|0,d)|0;c[r>>2]=Z8c(c[(c[j>>2]|0)+(d*12|0)>>2]|0,c[o>>2]|0,c[b>>2]|0,c[q>>2]|0)|0;d=d+1|0}while((d|0)!=(p|0))}p=c[l>>2]|0;if(c[p+4>>2]|0){d=p;p=0;do{Rrc(c[d>>2]|0,p)|0;p=p+1|0;d=c[l>>2]|0}while((p|0)!=(c[d+4>>2]|0))}d=c[j>>2]|0;if(!d){i=f;return}j=c[k>>2]|0;if((j|0)!=(d|0))c[k>>2]=j+(~(((j+-12-d|0)>>>0)/12|0)*12|0);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(d,g);i=f;return}function v3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];d=b+20|0;E5c(h,c[d>>2]|0);b=c[d>>2]|0;k=c[a+28>>2]|0;a=c[j>>2]|0;l=c[h>>2]|0;m=(a-l|0)/80|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=h+12|0;a=0;do{n=Rrc(c[b>>2]|0,a)|0;n2c(l,(c[h>>2]|0)+(a*80|0)|0,n);a=a+1|0}while((a|0)!=(m|0))}m=c[d>>2]|0;if(c[m+4>>2]|0){a=m;m=0;do{Rrc(c[a>>2]|0,m)|0;m=m+1|0;a=c[d>>2]|0}while((m|0)!=(c[a+4>>2]|0))}a=c[h>>2]|0;if(!a){i=e;return}m=c[j>>2]|0;if((m|0)==(a|0))o=a;else{d=m;while(1){m=d+-80|0;c[j>>2]=m;if((c[d+-12>>2]|0)>-1){l=d+-24|0;b=c[l>>2]|0;c[g>>2]=c[d+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(b,f);c[l>>2]=0;p=c[j>>2]|0}else p=m;if((p|0)==(a|0))break;else d=p}o=c[h>>2]|0}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);i=e;return}function w3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];d=b+20|0;F5c(h,c[d>>2]|0);d5c(h,c[d>>2]|0,c[a+28>>2]|0);a=c[d>>2]|0;if(c[a+4>>2]|0){b=a;a=0;do{Rrc(c[b>>2]|0,a)|0;a=a+1|0;b=c[d>>2]|0}while((a|0)!=(c[b+4>>2]|0))}b=c[h>>2]|0;if(!b){i=e;return}while(1){a=c[j>>2]|0;if((a|0)==(b|0))break;c[j>>2]=a+-68}j=c[h>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function x3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];d=c[b+16>>2]|0;k=b+20|0;b=c[k>>2]|0;l=c[b+4>>2]|0;if(l){G5c(h,l);m=0;do{n=c[(Rrc(c[b>>2]|0,m)|0)>>2]|0;if(n){o=(c[h>>2]|0)+(m<<4)|0;p=c[n+8>>2]|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2]}m=m+1|0}while((m|0)!=(l|0))}l=c[a+24>>2]|0;if(l){idd(d,l);jdd(d)}f5c(h,c[k>>2]|0,c[a+28>>2]|0);a=c[k>>2]|0;if(c[a+4>>2]|0){d=a;a=0;do{Rrc(c[d>>2]|0,a)|0;a=a+1|0;d=c[k>>2]|0}while((a|0)!=(c[d+4>>2]|0))}d=c[h>>2]|0;if(!d){i=e;return}h=c[j>>2]|0;if((h|0)!=(d|0))c[j>>2]=h+(~((h+-16-d|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(d,f);i=e;return}function y3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;f=i;i=i+96|0;g=f+56|0;h=f+83|0;j=f+80|0;k=f;l=k+24|0;a[l>>0]=1;m=k+28|0;c[m>>2]=0;n=k+32|0;c[n>>2]=0;o=k+40|0;p=c[d>>2]|0;c[k>>2]=p;q=k+12|0;c[q>>2]=0;r=d+4|0;s=k+4|0;a[s>>0]=(dsc(c[r>>2]|0)|0)&1;t=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;u=k+8|0;c[u>>2]=t;v=k+16|0;c[v>>2]=c[r>>2];r=c[d+8>>2]|0;w=c[r>>2]|0;x=c[r+8>>2]|0;c[o>>2]=w;c[k+36>>2]=w;c[k+44>>2]=x;r=x-w>>6;c[k+52>>2]=r;c[k+48>>2]=r;r=c[(c[d>>2]|0)+4>>2]|0;if(!r){i=f;return}d=k+36|0;x=k+20|0;y=k+25|0;z=k+20|0;A=g+16|0;B=g+12|0;C=g+16|0;D=g+12|0;if(!e){E=w;F=p;G=0;H=t;while(1){c[o>>2]=E;c[x>>2]=d;I=Gsc(c[F>>2]|0,G,H)|0;if(!(a[s>>0]|0)){J=c[I>>2]|0;if(!J){K=ds(c[v>>2]|0)|0;Wrc(K);Qrc(c[c[k>>2]>>2]|0,c[q>>2]|0,K);L=K}else L=J;J=c[v>>2]|0;a[l>>0]=1;a[y+0>>0]=a[j+0>>0]|0;a[y+1>>0]=a[j+1>>0]|0;a[y+2>>0]=a[j+2>>0]|0;M=J;N=L}else{J=c[v>>2]|0;a[l>>0]=0;a[y+0>>0]=a[h+0>>0]|0;a[y+1>>0]=a[h+1>>0]|0;a[y+2>>0]=a[h+2>>0]|0;M=J;N=I}c[m>>2]=N;c[n>>2]=M;I=c[z>>2]|0;c[A>>2]=b;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[B>>2]=I;J=I+4|0;K=c[J>>2]|0;O=I+8|0;P=c[O>>2]|0;if((K|0)!=(P|0)){Q=I+12|0;I=K;K=P;do{P=I+64|0;c[J>>2]=P;c[Q>>2]=K-P>>6;In[c[I>>2]&4095](I+4|0,g);I=c[J>>2]|0;K=c[O>>2]|0}while((I|0)!=(K|0))}K=(c[q>>2]|0)+1|0;c[q>>2]=K;if((K|0)==(r|0))break;E=c[d>>2]|0;F=c[k>>2]|0;G=K;H=c[u>>2]|0}i=f;return}else{H=w;w=p;p=0;G=t;while(1){c[o>>2]=H;c[x>>2]=d;t=Gsc(c[w>>2]|0,p,G)|0;if(!(a[s>>0]|0)){F=c[t>>2]|0;if(!F){E=ds(c[v>>2]|0)|0;Wrc(E);Qrc(c[c[k>>2]>>2]|0,c[q>>2]|0,E);R=E}else R=F;F=c[v>>2]|0;a[l>>0]=1;a[y+0>>0]=a[j+0>>0]|0;a[y+1>>0]=a[j+1>>0]|0;a[y+2>>0]=a[j+2>>0]|0;S=F;T=R}else{F=c[v>>2]|0;a[l>>0]=0;a[y+0>>0]=a[h+0>>0]|0;a[y+1>>0]=a[h+1>>0]|0;a[y+2>>0]=a[h+2>>0]|0;S=F;T=t}c[m>>2]=T;c[n>>2]=S;idd(b,e);t=c[z>>2]|0;c[C>>2]=b;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[D>>2]=t;F=t+4|0;E=c[F>>2]|0;B=t+8|0;A=c[B>>2]|0;if((E|0)!=(A|0)){M=t+12|0;t=E;E=A;do{A=t+64|0;c[F>>2]=A;c[M>>2]=E-A>>6;In[c[t>>2]&4095](t+4|0,g);t=c[F>>2]|0;E=c[B>>2]|0}while((t|0)!=(E|0))}jdd(b);E=(c[q>>2]|0)+1|0;c[q>>2]=E;if((E|0)==(r|0))break;H=c[d>>2]|0;w=c[k>>2]|0;p=E;G=c[u>>2]|0}i=f;return}}function z3c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+12|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=b+32|0;f=c[g>>2]|0;d=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=d;d=b+52|0;k=c[g>>2]|0;f=xo[c[c[k>>2]>>2]&2047](k,c[d>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[d>>2]=f;f=b+72|0;d=c[g>>2]|0;k=xo[c[c[d>>2]>>2]&2047](d,c[f>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[f>>2]=k;k=b+92|0;f=c[g>>2]|0;d=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=d;d=b+112|0;k=c[g>>2]|0;f=xo[c[c[k>>2]>>2]&2047](k,c[d>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[d>>2]=f;f=b+132|0;d=c[g>>2]|0;k=xo[c[c[d>>2]>>2]&2047](d,c[f>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[f>>2]=k;k=b+152|0;f=c[g>>2]|0;d=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=d;d=b+236|0;b=c[g>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[d>>2]|0,c[j>>2]|0)|0;if(!(a[h>>0]|0)){i=e;return}c[d>>2]=g;i=e;return}function A3c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[e+16>>2]|0;m=qdd(l,c[d+4>>2]|0,c[142306]|0,g,1)|0;if(m){if((m|0)<=0){m=c[g>>2]|0;if(m)_n[m&4095](j,l)|0}else P5c(l,j,0);sdd(l)}if(a[l+136>>0]|0){l=e+20|0;e=c[l>>2]|0;m=c[d+28>>2]|0;d=(c[k>>2]|0)-(c[j>>2]|0)>>1;n=e+4|0;if((c[n>>2]|0)!=(d|0)){c[e>>2]=Isc(m,Zsc(m)|0,d)|0;c[n>>2]=d}if(d){n=0;do{m=Gsc(c[e>>2]|0,n,2)|0;b[m>>1]=b[(c[j>>2]|0)+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(d|0))}if(c[(c[l>>2]|0)+4>>2]|0){d=0;do d=d+1|0;while((d|0)!=(c[(c[l>>2]|0)+4>>2]|0))}}l=c[j>>2]|0;if(!l){i=f;return}j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~((j+-2-l|0)>>>1)<<1);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(l,g);i=f;return}function B3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else Q5c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=b-m|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,1)|0;a[b>>0]=a[(c[h>>2]|0)+m>>0]|0;m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}if((c[j>>2]|0)!=(k|0))c[j>>2]=k;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function C3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else R5c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=b-m|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,1)|0;a[b>>0]=a[(c[h>>2]|0)+m>>0]|0;m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}if((c[j>>2]|0)!=(k|0))c[j>>2]=k;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function D3c(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[e+16>>2]|0;m=qdd(l,c[d+4>>2]|0,c[142306]|0,g,1)|0;if(m){if((m|0)<=0){m=c[g>>2]|0;if(m)_n[m&4095](j,l)|0}else S5c(l,j,0);sdd(l)}if(a[l+136>>0]|0){l=e+20|0;e=c[l>>2]|0;m=c[d+28>>2]|0;d=(c[k>>2]|0)-(c[j>>2]|0)>>1;n=e+4|0;if((c[n>>2]|0)!=(d|0)){c[e>>2]=Isc(m,Zsc(m)|0,d)|0;c[n>>2]=d}if(d){n=0;do{m=Gsc(c[e>>2]|0,n,2)|0;b[m>>1]=b[(c[j>>2]|0)+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(d|0))}if(c[(c[l>>2]|0)+4>>2]|0){d=0;do d=d+1|0;while((d|0)!=(c[(c[l>>2]|0)+4>>2]|0))}}l=c[j>>2]|0;if(!l){i=f;return}j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~((j+-2-l|0)>>>1)<<1);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(l,g);i=f;return}function E3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else T5c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>2;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,4)|0;c[l>>2]=c[(c[h>>2]|0)+(m<<2)>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-4-k|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function F3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else U5c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>2;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,4)|0;c[l>>2]=c[(c[h>>2]|0)+(m<<2)>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-4-k|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function G3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else V5c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>3;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,8)|0;n=(c[h>>2]|0)+(m<<3)|0;o=c[n+4>>2]|0;p=l;c[p>>2]=c[n>>2];c[p+4>>2]=o;m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-8-k|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function H3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else W5c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>3;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,8)|0;n=(c[h>>2]|0)+(m<<3)|0;o=c[n+4>>2]|0;p=l;c[p>>2]=c[n>>2];c[p+4>>2]=o;m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-8-k|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function I3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;h=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[d+16>>2]|0;m=qdd(l,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](j,l)|0}else X5c(l,j,0);sdd(l)}if(a[l+136>>0]|0){l=d+20|0;d=c[l>>2]|0;m=c[b+28>>2]|0;b=(c[k>>2]|0)-(c[j>>2]|0)>>2;n=d+4|0;if((c[n>>2]|0)!=(b|0)){c[d>>2]=Isc(m,Zsc(m)|0,b)|0;c[n>>2]=b}if(b){n=0;do{m=Gsc(c[d>>2]|0,n,4)|0;g[m>>2]=ea(g[(c[j>>2]|0)+(n<<2)>>2]);n=n+1|0}while((n|0)!=(b|0))}if(c[(c[l>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[l>>2]|0)+4>>2]|0))}}l=c[j>>2]|0;if(!l){i=e;return}j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~((j+-4-l|0)>>>2)<<2);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(l,f);i=e;return}function J3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[d+16>>2]|0;m=qdd(l,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](j,l)|0}else Y5c(l,j,0);sdd(l)}if(a[l+136>>0]|0){l=d+20|0;d=c[l>>2]|0;m=c[b+28>>2]|0;b=(c[k>>2]|0)-(c[j>>2]|0)>>3;n=d+4|0;if((c[n>>2]|0)!=(b|0)){c[d>>2]=Isc(m,Zsc(m)|0,b)|0;c[n>>2]=b}if(b){n=0;do{m=Gsc(c[d>>2]|0,n,8)|0;h[m>>3]=+h[(c[j>>2]|0)+(n<<3)>>3];n=n+1|0}while((n|0)!=(b|0))}if(c[(c[l>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[l>>2]|0)+4>>2]|0))}}l=c[j>>2]|0;if(!l){i=e;return}j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~((j+-8-l|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(l,f);i=e;return}function K3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+80|0;g=f+64|0;h=f+8|0;j=f+32|0;k=f;l=f+16|0;c[l>>2]=0;m=l+4|0;c[m>>2]=0;c[l+8>>2]=0;c[l+12>>2]=c[e>>2];e=c[d+16>>2]|0;n=qdd(e,c[b+4>>2]|0,c[142306]|0,g,1)|0;if(n){if((n|0)<=0){n=c[g>>2]|0;if(n)_n[n&4095](l,e)|0}else Z5c(e,l,0);sdd(e)}if((a[e+136>>0]|0)!=0?(e=d+20|0,Q4c(l,c[e>>2]|0,c[b+28>>2]|0),b=c[e>>2]|0,(c[b+4>>2]|0)!=0):0){d=j+12|0;n=b;b=0;do{o=c[(Rrc(c[n>>2]|0,b)|0)>>2]|0;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){p=h;q=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=q;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[d>>2]=o;xbd(j)|0}b=b+1|0;n=c[e>>2]|0}while((b|0)!=(c[n+4>>2]|0))}n=c[l>>2]|0;if(!n){i=f;return}b=c[m>>2]|0;if((b|0)==(n|0))s=n;else{e=b;while(1){b=e+-292|0;c[m>>2]=b;if(!(a[b>>0]&1))t=b;else{b=c[e+-284>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(b,g);t=c[m>>2]|0}if((t|0)==(n|0))break;else e=t}s=c[l>>2]|0}c[j>>2]=89;c[g+0>>2]=c[j+0>>2];eOb(s,g);i=f;return}function L3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=j+12|0;c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];e=c[d+16>>2]|0;l=qdd(e,c[b+4>>2]|0,c[142306]|0,g,1)|0;if(l){if((l|0)<=0){l=c[g>>2]|0;if(l)_n[l&4095](j,e)|0}else _5c(e,j,0);sdd(e)}if(a[e+136>>0]|0){e=d+20|0;d=c[e>>2]|0;l=c[b+28>>2]|0;b=c[k>>2]|0;m=c[j>>2]|0;n=(b-m|0)/12|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=j+12|0;b=j+20|0;o=j+16|0;l=0;do{p=Rrc(c[d>>2]|0,l)|0;c[p>>2]=Z8c(c[(c[j>>2]|0)+(l*12|0)>>2]|0,c[m>>2]|0,c[b>>2]|0,c[o>>2]|0)|0;l=l+1|0}while((l|0)!=(n|0))}n=c[e>>2]|0;if(c[n+4>>2]|0){l=n;n=0;do{Rrc(c[l>>2]|0,n)|0;n=n+1|0;l=c[e>>2]|0}while((n|0)!=(c[l+4>>2]|0))}}l=c[j>>2]|0;if(!l){i=f;return}j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~(((j+-12-l|0)>>>0)/12|0)*12|0);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(l,g);i=f;return}function M3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[d+16>>2]|0;m=qdd(l,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](j,l)|0}else $5c(l,j,0);sdd(l)}if(a[l+136>>0]|0){l=d+20|0;d=c[l>>2]|0;m=c[b+28>>2]|0;b=c[k>>2]|0;n=c[j>>2]|0;o=(b-n|0)/12|0;p=d+4|0;if((c[p>>2]|0)!=(o|0)){c[d>>2]=Isc(m,Zsc(m)|0,o)|0;c[p>>2]=o}if((b|0)!=(n|0)){n=0;do{b=Rrc(c[d>>2]|0,n)|0;p=c[j>>2]|0;m=p+(n*12|0)|0;if(!(a[m>>0]&1))q=m+1|0;else q=c[p+(n*12|0)+8>>2]|0;c[b>>2]=ysc(q)|0;n=n+1|0}while((n|0)!=(o|0))}o=c[l>>2]|0;if(c[o+4>>2]|0){n=o;o=0;do{Rrc(c[n>>2]|0,o)|0;o=o+1|0;n=c[l>>2]|0}while((o|0)!=(c[n+4>>2]|0))}}n=c[j>>2]|0;if(!n){i=e;return}o=c[k>>2]|0;if((o|0)==(n|0))r=n;else{l=o;while(1){o=l+-12|0;c[k>>2]=o;if(!(a[o>>0]&1))s=o;else{o=c[l+-4>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);s=c[k>>2]|0}if((s|0)==(n|0))break;else l=s}r=c[j>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(r,f);i=e;return}function N3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else a6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=(b-m|0)/12|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,12)|0;o=(c[h>>2]|0)+(m*12|0)|0;c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~(((h+-12-k|0)>>>0)/12|0)*12|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function O3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else b6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>3;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,8)|0;n=(c[h>>2]|0)+(m<<3)|0;o=c[n+4>>2]|0;p=l;c[p>>2]=c[n>>2];c[p+4>>2]=o;m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-8-k|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function P3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else c6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>4;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,16)|0;n=(c[h>>2]|0)+(m<<4)|0;c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-16-k|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function Q3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else d6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>4;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,16)|0;n=(c[h>>2]|0)+(m<<4)|0;c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-16-k|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function R3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else e6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>4;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,16)|0;n=(c[h>>2]|0)+(m<<4)|0;c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-16-k|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function S3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else f6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>6;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,64)|0;n=l+0|0;l=(c[h>>2]|0)+(m<<6)+0|0;o=n+64|0;do{c[n>>2]=c[l>>2];n=n+4|0;l=l+4|0}while((n|0)<(o|0));m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-64-k|0)>>>6)<<6);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function T3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else g6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=(b-m|0)/24|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,24)|0;o=(c[h>>2]|0)+(m*24|0)|0;c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];c[b+12>>2]=c[o+12>>2];c[b+16>>2]=c[o+16>>2];c[b+20>>2]=c[o+20>>2];m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~(((h+-24-k|0)>>>0)/24|0)*24|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function U3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im;e=i;i=i+32|0;f=e+20|0;h=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;l=c[d+16>>2]|0;m=qdd(l,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](j,l)|0}else h6c(l,j,0);sdd(l)}if(a[l+136>>0]|0){l=d+20|0;d=c[l>>2]|0;m=c[b+28>>2]|0;b=(c[k>>2]|0)-(c[j>>2]|0)>>4;n=d+4|0;if((c[n>>2]|0)!=(b|0)){c[d>>2]=Isc(m,Zsc(m)|0,b)|0;c[n>>2]=b}if(b){n=0;do{m=Gsc(c[d>>2]|0,n,16)|0;o=c[j>>2]|0;p=ea(g[o+(n<<4)>>2]);q=ea(g[o+(n<<4)+4>>2]);r=ea(g[o+(n<<4)+8>>2]);s=ea(g[o+(n<<4)+12>>2]);g[m>>2]=p;g[m+4>>2]=q;g[m+8>>2]=r;g[m+12>>2]=s;n=n+1|0}while((n|0)!=(b|0))}if(c[(c[l>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[l>>2]|0)+4>>2]|0))}}l=c[j>>2]|0;if(!l){i=e;return}j=c[k>>2]|0;if((j|0)!=(l|0))c[k>>2]=j+(~((j+-16-l|0)>>>4)<<4);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(l,f);i=e;return}function V3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else i6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>2;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,4)|0;c[l>>2]=c[(c[h>>2]|0)+(m<<2)>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-4-k|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function W3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;l=qdd(k,c[b+4>>2]|0,c[142306]|0,f,1)|0;if(l){if((l|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,k)|0}else j6c(k,h,0);sdd(k)}if(a[k+136>>0]|0){k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=(c[j>>2]|0)-(c[h>>2]|0)>>2;m=d+4|0;if((c[m>>2]|0)!=(b|0)){c[d>>2]=Isc(l,Zsc(l)|0,b)|0;c[m>>2]=b}if(b){m=0;do{l=Gsc(c[d>>2]|0,m,4)|0;c[l>>2]=c[(c[h>>2]|0)+(m<<2)>>2];m=m+1|0}while((m|0)!=(b|0))}if(c[(c[k>>2]|0)+4>>2]|0){b=0;do b=b+1|0;while((b|0)!=(c[(c[k>>2]|0)+4>>2]|0))}}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-4-k|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function X3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;c[j+12>>2]=c[e>>2];e=c[d+16>>2]|0;l=qdd(e,c[b+4>>2]|0,c[142306]|0,g,1)|0;if(l){if((l|0)<=0){l=c[g>>2]|0;if(l)_n[l&4095](j,e)|0}else k6c(e,j,0);sdd(e)}if(a[e+136>>0]|0){e=d+20|0;d=c[e>>2]|0;l=c[b+28>>2]|0;b=c[k>>2]|0;m=c[j>>2]|0;n=(b-m|0)/80|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=j+12|0;b=0;do{o=Rrc(c[d>>2]|0,b)|0;n2c(m,(c[j>>2]|0)+(b*80|0)|0,o);b=b+1|0}while((b|0)!=(n|0))}n=c[e>>2]|0;if(c[n+4>>2]|0){b=n;n=0;do{Rrc(c[b>>2]|0,n)|0;n=n+1|0;b=c[e>>2]|0}while((n|0)!=(c[b+4>>2]|0))}}b=c[j>>2]|0;if(!b){i=f;return}n=c[k>>2]|0;if((n|0)==(b|0))p=b;else{e=n;while(1){n=e+-80|0;c[k>>2]=n;if((c[e+-12>>2]|0)>-1){m=e+-24|0;d=c[m>>2]|0;c[h>>2]=c[e+-20>>2];c[g+0>>2]=c[h+0>>2];eOb(d,g);c[m>>2]=0;q=c[k>>2]|0}else q=n;if((q|0)==(b|0))break;else e=q}p=c[j>>2]|0}c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(p,g);i=f;return}function Y3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;c[j+12>>2]=c[e>>2];e=c[d+16>>2]|0;l=qdd(e,c[b+4>>2]|0,c[142306]|0,g,1)|0;if(l){if((l|0)<=0){l=c[g>>2]|0;if(l)_n[l&4095](j,e)|0}else l6c(e,j,0);sdd(e)}if((a[e+136>>0]|0)!=0?(e=d+20|0,d5c(j,c[e>>2]|0,c[b+28>>2]|0),b=c[e>>2]|0,(c[b+4>>2]|0)!=0):0){d=b;b=0;do{Rrc(c[d>>2]|0,b)|0;b=b+1|0;d=c[e>>2]|0}while((b|0)!=(c[d+4>>2]|0))}d=c[j>>2]|0;if(!d){i=f;return}while(1){b=c[k>>2]|0;if((b|0)==(d|0))break;c[k>>2]=b+-68}k=c[j>>2]|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(k,g);i=f;return}function Z3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;c[j+12>>2]=c[e>>2];e=c[d+16>>2]|0;l=qdd(e,c[b+4>>2]|0,c[142306]|0,g,1)|0;if(l){if((l|0)<=0){l=c[g>>2]|0;if(l)_n[l&4095](j,e)|0}else m6c(e,j,0);sdd(e)}if((a[e+136>>0]|0)!=0?(e=d+20|0,f5c(j,c[e>>2]|0,c[b+28>>2]|0),b=c[e>>2]|0,(c[b+4>>2]|0)!=0):0){d=b;b=0;do{Rrc(c[d>>2]|0,b)|0;b=b+1|0;d=c[e>>2]|0}while((b|0)!=(c[d+4>>2]|0))}d=c[j>>2]|0;if(!d){i=f;return}j=c[k>>2]|0;if((j|0)!=(d|0))c[k>>2]=j+(~((j+-16-d|0)>>>4)<<4);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(d,g);i=f;return}function _3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=i;i=i+192|0;f=e+152|0;g=e+182|0;h=e+72|0;j=e+64|0;k=e+8|0;l=e+96|0;m=e+188|0;n=e+185|0;o=e;p=e+179|0;q=e+176|0;c[j>>2]=c[(c[d>>2]|0)+4>>2];if(!(tdd(b,2646336,2646336,j)|0)){i=e;return}r=c[j>>2]|0;s=c[d>>2]|0;if((c[s+4>>2]|0)==(r|0)){t=r;u=s}else{s=d+4|0;v=Zsc(c[s>>2]|0)|0;w=Isc(c[s>>2]|0,v,r)|0;v=c[d>>2]|0;c[v>>2]=w;c[v+4>>2]=r;t=c[j>>2]|0;u=v}v=k+24|0;a[v>>0]=1;j=k+28|0;c[j>>2]=0;w=k+32|0;c[w>>2]=0;s=k+40|0;c[s>>2]=0;x=k+44|0;c[x>>2]=0;a:do if(t){y=l+24|0;a[y>>0]=1;z=l+28|0;c[z>>2]=0;A=l+32|0;c[A>>2]=0;c[l>>2]=u;B=l+12|0;c[B>>2]=0;C=d+4|0;D=l+4|0;a[D>>0]=(dsc(c[C>>2]|0)|0)&1;E=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;c[l+8>>2]=E;F=l+16|0;c[F>>2]=c[C>>2];G=d+8|0;H=c[G>>2]|0;I=c[H>>2]|0;J=c[H+8>>2]|0;c[l+36>>2]=I;c[l+44>>2]=J;H=J-I>>6;c[l+52>>2]=H;c[l+48>>2]=H;c[l+40>>2]=I;c[l+20>>2]=l+36;I=Gsc(c[c[l>>2]>>2]|0,c[B>>2]|0,E)|0;if(!(a[D>>0]|0)){D=c[I>>2]|0;if(!D){E=ds(c[F>>2]|0)|0;Wrc(E);Qrc(c[c[l>>2]>>2]|0,c[B>>2]|0,E);K=E}else K=D;D=c[F>>2]|0;a[y>>0]=1;E=l+25|0;a[E+0>>0]=a[g+0>>0]|0;a[E+1>>0]=a[g+1>>0]|0;a[E+2>>0]=a[g+2>>0]|0;L=D;M=K}else{D=c[F>>2]|0;a[y>>0]=0;y=l+25|0;a[y+0>>0]=a[f+0>>0]|0;a[y+1>>0]=a[f+1>>0]|0;a[y+2>>0]=a[f+2>>0]|0;L=D;M=I}c[z>>2]=M;c[A>>2]=L;if(!L)N=614328;else N=ksc(L)|0;A=qdd(b,3142592,N,0,1)|0;z=b+80|0;I=c[($hd(c[z>>2]|0)|0)+12>>2]|0;D=b+84|0;c[c[D>>2]>>2]=0;if((A|0)==2){A=c[(c[z>>2]|0)+12>>2]|0;y=c[d>>2]|0;F=(dsc(c[C>>2]|0)|0)&1;E=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;B=c[C>>2]|0;H=c[G>>2]|0;J=c[H>>2]|0;O=c[H+8>>2]|0;H=O-J>>6;c[k>>2]=y;y=k+4|0;a[y>>0]=F;F=k+5|0;a[F+0>>0]=a[m+0>>0]|0;a[F+1>>0]=a[m+1>>0]|0;a[F+2>>0]=a[m+2>>0]|0;F=k+8|0;c[F>>2]=E;E=k+12|0;c[E>>2]=0;P=k+16|0;c[P>>2]=B;B=k+20|0;a[v>>0]=1;Q=k+25|0;a[Q+0>>0]=a[n+0>>0]|0;a[Q+1>>0]=a[n+1>>0]|0;a[Q+2>>0]=a[n+2>>0]|0;c[j>>2]=0;c[w>>2]=0;c[k+36>>2]=J;c[s>>2]=J;c[x>>2]=O;c[k+48>>2]=H;c[k+52>>2]=H;if(r){H=k+36|0;O=f+16|0;J=f+12|0;do{R=(da(c[c[D>>2]>>2]|0,I)|0)+A|0;S=c[z>>2]|0;c[S+20>>2]=R;c[S+12>>2]=R;cid(o,S);R=o;T=c[R+4>>2]|0;U=S+24|0;c[U>>2]=c[R>>2];c[U+4>>2]=T;T=c[D>>2]|0;c[T>>2]=(c[T>>2]|0)+1;c[s>>2]=c[H>>2];c[B>>2]=H;T=Gsc(c[c[k>>2]>>2]|0,c[E>>2]|0,c[F>>2]|0)|0;if(!(a[y>>0]|0)){U=c[T>>2]|0;if(!U){R=ds(c[P>>2]|0)|0;Wrc(R);Qrc(c[c[k>>2]>>2]|0,c[E>>2]|0,R);V=R}else V=U;U=c[P>>2]|0;a[v>>0]=1;a[Q+0>>0]=a[g+0>>0]|0;a[Q+1>>0]=a[g+1>>0]|0;a[Q+2>>0]=a[g+2>>0]|0;W=U;X=V}else{U=c[P>>2]|0;a[v>>0]=0;a[Q+0>>0]=a[f+0>>0]|0;a[Q+1>>0]=a[f+1>>0]|0;a[Q+2>>0]=a[f+2>>0]|0;W=U;X=T}c[j>>2]=X;c[w>>2]=W;T=c[B>>2]|0;c[O>>2]=b;c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[J>>2]=T;U=T+4|0;R=c[U>>2]|0;S=T+8|0;Y=c[S>>2]|0;if((R|0)!=(Y|0)){Z=T+12|0;T=R;R=Y;do{Y=T+64|0;c[U>>2]=Y;c[Z>>2]=R-Y>>6;In[c[T>>2]&4095](T+4|0,f);T=c[U>>2]|0;R=c[S>>2]|0}while((T|0)!=(R|0))}R=(c[E>>2]|0)+1|0;c[E>>2]=R}while((R|0)!=(r|0))}sdd(b);break}sdd(b);E=c[d>>2]|0;J=(dsc(c[C>>2]|0)|0)&1;O=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;B=c[C>>2]|0;Q=c[G>>2]|0;P=c[Q>>2]|0;y=c[Q+8>>2]|0;Q=y-P>>6;c[k>>2]=E;F=k+4|0;a[F>>0]=J;J=k+5|0;a[J+0>>0]=a[p+0>>0]|0;a[J+1>>0]=a[p+1>>0]|0;a[J+2>>0]=a[p+2>>0]|0;J=k+8|0;c[J>>2]=O;H=k+12|0;c[H>>2]=0;D=k+16|0;c[D>>2]=B;B=k+20|0;a[v>>0]=1;z=k+25|0;a[z+0>>0]=a[q+0>>0]|0;a[z+1>>0]=a[q+1>>0]|0;a[z+2>>0]=a[q+2>>0]|0;c[j>>2]=0;c[w>>2]=0;c[k+36>>2]=P;c[s>>2]=P;c[x>>2]=y;c[k+48>>2]=Q;c[k+52>>2]=Q;if(r){Q=k+36|0;y=k+20|0;A=h+16|0;I=h+12|0;R=P;P=E;E=0;T=O;while(1){c[s>>2]=R;c[B>>2]=Q;O=Gsc(c[P>>2]|0,E,T)|0;if(!(a[F>>0]|0)){S=c[O>>2]|0;if(!S){U=ds(c[D>>2]|0)|0;Wrc(U);Qrc(c[c[k>>2]>>2]|0,c[H>>2]|0,U);_=U}else _=S;S=c[D>>2]|0;a[v>>0]=1;a[z+0>>0]=a[g+0>>0]|0;a[z+1>>0]=a[g+1>>0]|0;a[z+2>>0]=a[g+2>>0]|0;$=S;aa=_}else{S=c[D>>2]|0;a[v>>0]=0;a[z+0>>0]=a[f+0>>0]|0;a[z+1>>0]=a[f+1>>0]|0;a[z+2>>0]=a[f+2>>0]|0;$=S;aa=O}c[j>>2]=aa;c[w>>2]=$;if(!$)ba=614328;else ba=ksc($)|0;O=qdd(b,3142592,ba,f,1)|0;if(O){if((O|0)>0){O=c[y>>2]|0;c[A>>2]=b;c[h+0>>2]=c[v+0>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];c[I>>2]=O;S=O+4|0;U=c[S>>2]|0;Z=O+8|0;Y=c[Z>>2]|0;if((U|0)!=(Y|0)){ca=O+12|0;O=U;U=Y;do{Y=O+64|0;c[S>>2]=Y;c[ca>>2]=U-Y>>6;In[c[O>>2]&4095](O+4|0,h);O=c[S>>2]|0;U=c[Z>>2]|0}while((O|0)!=(U|0))}}else{U=c[f>>2]|0;if(U)_n[U&4095](y,b)|0}sdd(b)}U=(c[H>>2]|0)+1|0;c[H>>2]=U;if((U|0)==(r|0))break a;R=c[Q>>2]|0;P=c[k>>2]|0;E=U;T=c[J>>2]|0}}}while(0);udd(b);i=e;return}function $3c(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;h=qdd(d,2487248,c[142294]|0,f,0)|0;if(h){if((h|0)<=0){h=c[f>>2]|0;if(h)_n[h&4095](b,d)|0}else zXb(d,b,1);sdd(d)}h=b+12|0;j=qdd(d,2391880,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+32|0;j=qdd(d,2391920,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+52|0;j=qdd(d,2391952,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+72|0;j=qdd(d,2391992,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+92|0;j=qdd(d,2392032,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+112|0;j=qdd(d,2392072,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+132|0;j=qdd(d,2392112,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+152|0;j=qdd(d,2392152,2388280,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else n6c(h,d);sdd(d)}h=b+172|0;j=qdd(d,2392192,2390464,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else b4c(h,d);sdd(d)}h=b+188|0;j=qdd(d,2373768,2390464,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else b4c(h,d);sdd(d)}h=b+204|0;j=qdd(d,2392232,2390464,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else b4c(h,d);sdd(d)}h=b+220|0;j=qdd(d,2392296,2390464,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else b4c(h,d);sdd(d)}h=b+236|0;j=qdd(d,2380056,723592,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else o6c(h,d);sdd(d)}h=b+280|0;j=c[142270]|0;k=qdd(d,723488,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;do if((m|0)<0)o=90;else{p=l+(m+4)|0;if(p>>>0>(c[d+20>>2]|0)>>>0){o=90;break}c[h>>2]=c[n>>2];c[k>>2]=p}while(0);if((o|0)==90)Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+284|0;k=qdd(d,614352,j,f,0)|0;if(k){do if((k|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}else{n=d+12|0;m=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=m+l|0;c[n>>2]=p;do if((l|0)<0)o=101;else{q=m+(l+4)|0;if(q>>>0>(c[d+20>>2]|0)>>>0){o=101;break}c[h>>2]=c[p>>2];c[n>>2]=q}while(0);if((o|0)==101)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}while(0);sdd(d)}h=b+240|0;k=qdd(d,614368,j,f,0)|0;if(k){do if((k|0)>0){p=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=l+m|0;c[p>>2]=q;do if((m|0)<0)o=112;else{r=l+(m+4)|0;if(r>>>0>(c[d+20>>2]|0)>>>0){o=112;break}c[h>>2]=c[q>>2];c[p>>2]=r}while(0);if((o|0)==112)Bid(p,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{q=c[f>>2]|0;if(!q)break;_n[q&4095](h,d)|0}while(0);sdd(d)}h=b+244|0;k=c[142258]|0;q=qdd(d,614384,k,f,0)|0;if(q){a:do if((q|0)>0){m=d+12|0;l=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=l+n|0;c[m>>2]=r;do if((n|0)>=0){if((l+(n+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[r>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break a}while(0);Bid(m,h,1)}else{r=c[f>>2]|0;if(!r)break;_n[r&4095](h,d)|0}while(0);sdd(d)}h=b+245|0;q=qdd(d,614400,k,f,0)|0;if(q){b:do if((q|0)>0){r=d+12|0;n=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+l|0;c[r>>2]=p;do if((l|0)>=0){if((n+(l+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[p>>0]|0;c[r>>2]=(c[r>>2]|0)+1;break b}while(0);Bid(r,h,1)}else{p=c[f>>2]|0;if(!p)break;_n[p&4095](h,d)|0}while(0);sdd(d)}h=b+248|0;q=qdd(d,614416,j,f,0)|0;if(q){do if((q|0)>0){p=d+12|0;l=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=l+n|0;c[p>>2]=m;do if((n|0)<0)o=141;else{s=l+(n+4)|0;if(s>>>0>(c[d+20>>2]|0)>>>0){o=141;break}c[h>>2]=c[m>>2];c[p>>2]=s}while(0);if((o|0)==141)Bid(p,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+252|0;q=qdd(d,614432,j,f,0)|0;if(q){do if((q|0)>0){j=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=m+n|0;c[j>>2]=l;do if((n|0)<0)o=152;else{r=m+(n+4)|0;if(r>>>0>(c[d+20>>2]|0)>>>0){o=152;break}c[h>>2]=c[l>>2];c[j>>2]=r}while(0);if((o|0)==152)Bid(j,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(!l)break;_n[l&4095](h,d)|0}while(0);sdd(d)}h=b+256|0;q=qdd(d,614448,c[142308]|0,f,1)|0;if(q){do if((q|0)>0)hgc(h,d);else{l=c[f>>2]|0;if(!l)break;_n[l&4095](h,d)|0}while(0);sdd(d)}h=b+272|0;q=c[142268]|0;l=qdd(d,614464,q,f,0)|0;if(l){do if((l|0)>0){n=d+12|0;m=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=m+p|0;c[n>>2]=r;do if((p|0)<0)o=169;else{s=m+(p+4)|0;if(s>>>0>(c[d+20>>2]|0)>>>0){o=169;break}g[h>>2]=ea(g[r>>2]);c[n>>2]=s}while(0);if((o|0)==169)Bid(n,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{r=c[f>>2]|0;if(!r)break;_n[r&4095](h,d)|0}while(0);sdd(d)}h=b+276|0;l=qdd(d,614480,q,f,0)|0;if(l){do if((l|0)>0){q=d+12|0;r=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=r+p|0;c[q>>2]=m;do if((p|0)<0)o=180;else{j=r+(p+4)|0;if(j>>>0>(c[d+20>>2]|0)>>>0){o=180;break}g[h>>2]=ea(g[m>>2]);c[q>>2]=j}while(0);if((o|0)==180)Bid(q,h,4);if(!(c[d>>2]&512))break;c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](h,d)|0}while(0);sdd(d)}h=b+288|0;o=qdd(d,614496,k,f,0)|0;if(o){c:do if((o|0)>0){l=d+12|0;m=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=m+p|0;c[l>>2]=r;do if((p|0)>=0){if((m+(p+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[r>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break c}while(0);Bid(l,h,1)}else{r=c[f>>2]|0;if(!r)break;_n[r&4095](h,d)|0}while(0);sdd(d)}h=b+289|0;b=qdd(d,614512,k,f,0)|0;if(!b){i=e;return}d:do if((b|0)>0){k=d+12|0;o=c[d+16>>2]|0;r=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=o+r|0;c[k>>2]=p;do if((r|0)>=0){if((o+(r+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[h>>0]=a[p>>0]|0;c[k>>2]=(c[k>>2]|0)+1;break d}while(0);Bid(k,h,1)}else{p=c[f>>2]|0;if(!p)break;_n[p&4095](h,d)|0}while(0);sdd(d);i=e;return}function a4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;rdd(b,2);f=a+56|0;g=qdd(b,614584,c[142306]|0,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else p6c(b,f,0);sdd(b)}f=a+72|0;g=c[142270]|0;h=qdd(b,614592,g,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[l>>2];c[h>>2]=m}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}f=a+76|0;h=qdd(b,614608,g,e,0)|0;if(!h){SMc(a);i=d;return}if((h|0)>0){h=b+12|0;g=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=g+m|0;c[h>>2]=l;if((m|0)>=0?(k=g+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[l>>2];c[h>>2]=k}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b);SMc(a);i=d;return}function b4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[142270]|0;g=qdd(b,614528,f,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[g>>2]=l}else Bid(g,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}sdd(b)}g=a+4|0;l=qdd(b,614536,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;k=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;h=k+j|0;c[l>>2]=h;if((j|0)>=0?(m=k+(j+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[h>>2];c[l>>2]=m}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+8|0;l=qdd(b,614544,f,e,0)|0;if(l){if((l|0)>0){l=b+12|0;m=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=m+h|0;c[l>>2]=j;if((h|0)>=0?(k=m+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[j>>2];c[l>>2]=k}else Bid(l,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{l=c[e>>2]|0;if(l)_n[l&4095](g,b)|0}sdd(b)}g=a+12|0;a=qdd(b,614552,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=f+l|0;c[a>>2]=k;if((l|0)>=0?(j=f+(l+4)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){c[g>>2]=c[k>>2];c[a>>2]=j}else Bid(a,g,4);if(c[b>>2]&512)c[g>>2]=XEi(c[g>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}sdd(b);i=d;return}function c4c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;q6c(c[d+16>>2]|0,h,0);k=d+20|0;d=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>1;m=d+4|0;if((c[m>>2]|0)!=(a|0)){c[d>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[d>>2]|0,m,2)|0;b[l>>1]=b[(c[h>>2]|0)+(m<<1)>>1]|0;m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-2-k|0)>>>1)<<1);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function d4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;r6c(c[d+16>>2]|0,h,0);k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=b-m|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,1)|0;a[b>>0]=a[(c[h>>2]|0)+m>>0]|0;m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}if((c[j>>2]|0)!=(k|0))c[j>>2]=k;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function e4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=c[d+16>>2]|0;s6c(k,h,0);Mdd(k);k=d+20|0;d=c[k>>2]|0;l=c[b+28>>2]|0;b=c[j>>2]|0;m=c[h>>2]|0;n=b-m|0;o=d+4|0;if((c[o>>2]|0)!=(n|0)){c[d>>2]=Isc(l,Zsc(l)|0,n)|0;c[o>>2]=n}if((b|0)!=(m|0)){m=0;do{b=Gsc(c[d>>2]|0,m,1)|0;a[b>>0]=a[(c[h>>2]|0)+m>>0]|0;m=m+1|0}while((m|0)!=(n|0))}if(c[(c[k>>2]|0)+4>>2]|0){n=0;do n=n+1|0;while((n|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}if((c[j>>2]|0)!=(k|0))c[j>>2]=k;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function f4c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;t6c(c[d+16>>2]|0,h,0);k=d+20|0;d=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>1;m=d+4|0;if((c[m>>2]|0)!=(a|0)){c[d>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[d>>2]|0,m,2)|0;b[l>>1]=b[(c[h>>2]|0)+(m<<1)>>1]|0;m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-2-k|0)>>>1)<<1);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function g4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;u6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function h4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;v6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function i4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;w6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>3;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,8)|0;m=(c[g>>2]|0)+(l<<3)|0;n=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function j4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;x6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>3;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,8)|0;m=(c[g>>2]|0)+(l<<3)|0;n=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function k4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;y6c(c[b+16>>2]|0,h,0);k=b+20|0;b=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>2;m=b+4|0;if((c[m>>2]|0)!=(a|0)){c[b>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[b>>2]|0,m,4)|0;g[l>>2]=ea(g[(c[h>>2]|0)+(m<<2)>>2]);m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=d;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-4-k|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function l4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;j=g+4|0;c[j>>2]=0;c[g+8>>2]=0;z6c(c[b+16>>2]|0,g,0);k=b+20|0;b=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[g>>2]|0)>>3;m=b+4|0;if((c[m>>2]|0)!=(a|0)){c[b>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[b>>2]|0,m,8)|0;h[l>>3]=+h[(c[g>>2]|0)+(m<<3)>>3];m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[g>>2]|0;if(!k){i=d;return}g=c[j>>2]|0;if((g|0)!=(k|0))c[j>>2]=g+(~((g+-8-k|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function m4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+80|0;g=f+64|0;h=f+8|0;j=f+32|0;k=f;l=f+16|0;c[l>>2]=0;m=l+4|0;c[m>>2]=0;c[l+8>>2]=0;c[l+12>>2]=c[e>>2];A6c(c[d+16>>2]|0,l,0);e=d+20|0;Q4c(l,c[e>>2]|0,c[b+28>>2]|0);b=c[e>>2]|0;if(c[b+4>>2]|0){d=j+12|0;n=b;b=0;do{o=c[(Rrc(c[n>>2]|0,b)|0)>>2]|0;Hcd(h,c[(Xbd()|0)+320>>2]|0,614296,1);if(c[h>>2]|0){p=h;q=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=q;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];vbd(j,g);c[d>>2]=o;xbd(j)|0}b=b+1|0;n=c[e>>2]|0}while((b|0)!=(c[n+4>>2]|0))}n=c[l>>2]|0;if(!n){i=f;return}b=c[m>>2]|0;if((b|0)==(n|0))s=n;else{e=b;while(1){b=e+-292|0;c[m>>2]=b;if(!(a[b>>0]&1))t=b;else{b=c[e+-284>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(b,g);t=c[m>>2]|0}if((t|0)==(n|0))break;else e=t}s=c[l>>2]|0}c[j>>2]=89;c[g+0>>2]=c[j+0>>2];eOb(s,g);i=f;return}function n4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=h+12|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];B6c(c[b+16>>2]|0,h,0);d=b+20|0;b=c[d>>2]|0;k=c[a+28>>2]|0;a=c[j>>2]|0;l=c[h>>2]|0;m=(a-l|0)/12|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=h+12|0;a=h+20|0;n=h+16|0;k=0;do{o=Rrc(c[b>>2]|0,k)|0;c[o>>2]=Z8c(c[(c[h>>2]|0)+(k*12|0)>>2]|0,c[l>>2]|0,c[a>>2]|0,c[n>>2]|0)|0;k=k+1|0}while((k|0)!=(m|0))}m=c[d>>2]|0;if(c[m+4>>2]|0){k=m;m=0;do{Rrc(c[k>>2]|0,m)|0;m=m+1|0;k=c[d>>2]|0}while((m|0)!=(c[k+4>>2]|0))}k=c[h>>2]|0;if(!k){i=e;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~(((h+-12-k|0)>>>0)/12|0)*12|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function o4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;c[j>>2]=0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;C6c(c[d+16>>2]|0,j,0);l=d+20|0;d=c[l>>2]|0;m=c[b+28>>2]|0;b=c[k>>2]|0;n=c[j>>2]|0;o=(b-n|0)/12|0;p=d+4|0;if((c[p>>2]|0)!=(o|0)){c[d>>2]=Isc(m,Zsc(m)|0,o)|0;c[p>>2]=o}if((b|0)!=(n|0)){n=0;do{b=Rrc(c[d>>2]|0,n)|0;p=c[j>>2]|0;m=p+(n*12|0)|0;if(!(a[m>>0]&1))q=m+1|0;else q=c[p+(n*12|0)+8>>2]|0;c[b>>2]=ysc(q)|0;n=n+1|0}while((n|0)!=(o|0))}o=c[l>>2]|0;if(c[o+4>>2]|0){n=o;o=0;do{Rrc(c[n>>2]|0,o)|0;o=o+1|0;n=c[l>>2]|0}while((o|0)!=(c[n+4>>2]|0))}n=c[j>>2]|0;if(!n){i=e;return}o=c[k>>2]|0;if((o|0)==(n|0))r=n;else{l=o;while(1){o=l+-12|0;c[k>>2]=o;if(!(a[o>>0]&1))s=o;else{o=c[l+-4>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);s=c[k>>2]|0}if((s|0)==(n|0))break;else l=s}r=c[j>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(r,f);i=e;return}function p4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;D6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=c[h>>2]|0;l=c[g>>2]|0;m=(a-l|0)/12|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=0;do{a=Gsc(c[b>>2]|0,l,12)|0;n=(c[g>>2]|0)+(l*12|0)|0;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];l=l+1|0}while((l|0)!=(m|0))}if(c[(c[j>>2]|0)+4>>2]|0){m=0;do m=m+1|0;while((m|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~(((g+-12-j|0)>>>0)/12|0)*12|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function q4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;E6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>3;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,8)|0;m=(c[g>>2]|0)+(l<<3)|0;n=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=n;l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-8-j|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function r4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;F6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>4;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,16)|0;m=(c[g>>2]|0)+(l<<4)|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function s4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;G6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>4;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,16)|0;m=(c[g>>2]|0)+(l<<4)|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function t4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;H6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>4;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,16)|0;m=(c[g>>2]|0)+(l<<4)|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-16-j|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function u4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;I6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>6;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,64)|0;m=k+0|0;k=(c[g>>2]|0)+(l<<6)+0|0;n=m+64|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(n|0));l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-64-j|0)>>>6)<<6);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function v4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;J6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=c[h>>2]|0;l=c[g>>2]|0;m=(a-l|0)/24|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=0;do{a=Gsc(c[b>>2]|0,l,24)|0;n=(c[g>>2]|0)+(l*24|0)|0;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];l=l+1|0}while((l|0)!=(m|0))}if(c[(c[j>>2]|0)+4>>2]|0){m=0;do m=m+1|0;while((m|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~(((g+-24-j|0)>>>0)/24|0)*24|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function w4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;K6c(c[b+16>>2]|0,h,0);k=b+20|0;b=c[k>>2]|0;l=c[a+28>>2]|0;a=(c[j>>2]|0)-(c[h>>2]|0)>>4;m=b+4|0;if((c[m>>2]|0)!=(a|0)){c[b>>2]=Isc(l,Zsc(l)|0,a)|0;c[m>>2]=a}if(a){m=0;do{l=Gsc(c[b>>2]|0,m,16)|0;n=c[h>>2]|0;o=ea(g[n+(m<<4)>>2]);p=ea(g[n+(m<<4)+4>>2]);q=ea(g[n+(m<<4)+8>>2]);r=ea(g[n+(m<<4)+12>>2]);g[l>>2]=o;g[l+4>>2]=p;g[l+8>>2]=q;g[l+12>>2]=r;m=m+1|0}while((m|0)!=(a|0))}if(c[(c[k>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[k>>2]|0)+4>>2]|0))}k=c[h>>2]|0;if(!k){i=d;return}h=c[j>>2]|0;if((h|0)!=(k|0))c[j>>2]=h+(~((h+-16-k|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);i=d;return}function x4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;L6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function y4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;M6c(c[b+16>>2]|0,g,0);j=b+20|0;b=c[j>>2]|0;k=c[a+28>>2]|0;a=(c[h>>2]|0)-(c[g>>2]|0)>>2;l=b+4|0;if((c[l>>2]|0)!=(a|0)){c[b>>2]=Isc(k,Zsc(k)|0,a)|0;c[l>>2]=a}if(a){l=0;do{k=Gsc(c[b>>2]|0,l,4)|0;c[k>>2]=c[(c[g>>2]|0)+(l<<2)>>2];l=l+1|0}while((l|0)!=(a|0))}if(c[(c[j>>2]|0)+4>>2]|0){a=0;do a=a+1|0;while((a|0)!=(c[(c[j>>2]|0)+4>>2]|0))}j=c[g>>2]|0;if(!j){i=d;return}g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-j|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function z4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];N6c(c[b+16>>2]|0,h,0);d=b+20|0;b=c[d>>2]|0;k=c[a+28>>2]|0;a=c[j>>2]|0;l=c[h>>2]|0;m=(a-l|0)/80|0;n=b+4|0;if((c[n>>2]|0)!=(m|0)){c[b>>2]=Isc(k,Zsc(k)|0,m)|0;c[n>>2]=m}if((a|0)!=(l|0)){l=h+12|0;a=0;do{n=Rrc(c[b>>2]|0,a)|0;n2c(l,(c[h>>2]|0)+(a*80|0)|0,n);a=a+1|0}while((a|0)!=(m|0))}m=c[d>>2]|0;if(c[m+4>>2]|0){a=m;m=0;do{Rrc(c[a>>2]|0,m)|0;m=m+1|0;a=c[d>>2]|0}while((m|0)!=(c[a+4>>2]|0))}a=c[h>>2]|0;if(!a){i=e;return}m=c[j>>2]|0;if((m|0)==(a|0))o=a;else{d=m;while(1){m=d+-80|0;c[j>>2]=m;if((c[d+-12>>2]|0)>-1){l=d+-24|0;b=c[l>>2]|0;c[g>>2]=c[d+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(b,f);c[l>>2]=0;p=c[j>>2]|0}else p=m;if((p|0)==(a|0))break;else d=p}o=c[h>>2]|0}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);i=e;return}function A4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];O6c(c[b+16>>2]|0,h,0);d=b+20|0;d5c(h,c[d>>2]|0,c[a+28>>2]|0);a=c[d>>2]|0;if(c[a+4>>2]|0){b=a;a=0;do{Rrc(c[b>>2]|0,a)|0;a=a+1|0;b=c[d>>2]|0}while((a|0)!=(c[b+4>>2]|0))}b=c[h>>2]|0;if(!b){i=e;return}while(1){a=c[j>>2]|0;if((a|0)==(b|0))break;c[j>>2]=a+-68}j=c[h>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function B4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;c[h+12>>2]=c[d>>2];P6c(c[b+16>>2]|0,h,0);d=b+20|0;f5c(h,c[d>>2]|0,c[a+28>>2]|0);a=c[d>>2]|0;if(c[a+4>>2]|0){b=a;a=0;do{Rrc(c[b>>2]|0,a)|0;a=a+1|0;b=c[d>>2]|0}while((a|0)!=(c[b+4>>2]|0))}b=c[h>>2]|0;if(!b){i=e;return}h=c[j>>2]|0;if((h|0)!=(b|0))c[j>>2]=h+(~((h+-16-b|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function C4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+112|0;f=e+72|0;g=e+102|0;h=e+4|0;j=e;k=e+64|0;l=e+8|0;m=e+99|0;n=e+96|0;o=b+12|0;p=b+48|0;q=c[o>>2]|0;r=q+4|0;s=b+20|0;t=c[s>>2]|0;u=r>>>0>t>>>0;if(c[p>>2]|0){if(u){Bid(o,j,4);v=c[j>>2]|0;w=c[o>>2]|0;x=c[s>>2]|0}else{s=c[q>>2]|0;c[j>>2]=s;c[o>>2]=r;v=s;w=r;x=t}t=XEi(v|0)|0;c[j>>2]=t;v=w+4|0;if(v>>>0>x>>>0){Bid(o,h,4);y=c[h>>2]|0;z=c[j>>2]|0}else{j=c[w>>2]|0;c[h>>2]=j;c[o>>2]=v;y=j;z=t}t=XEi(y|0)|0;c[h>>2]=t;zid(o,t,z<<4)|0;c[p>>2]=0;i=e;return}if(u){Bid(o,k,4);A=c[k>>2]|0}else{u=c[q>>2]|0;c[k>>2]=u;c[o>>2]=r;A=u}u=XEi(A|0)|0;c[k>>2]=u;k=c[d>>2]|0;r=d+4|0;if((c[k+4>>2]|0)==(u|0))B=k;else{k=Zsc(c[r>>2]|0)|0;o=Isc(c[r>>2]|0,k,u)|0;k=c[d>>2]|0;c[k>>2]=o;c[k+4>>2]=u;B=k}k=l+24|0;a[k>>0]=1;o=l+28|0;c[o>>2]=0;q=l+32|0;c[q>>2]=0;p=l+40|0;c[p>>2]=0;z=l+44|0;c[z>>2]=0;t=(dsc(c[r>>2]|0)|0)&1;h=_sc(vsc(c[c[d>>2]>>2]|0)|0)|0;y=c[r>>2]|0;r=c[d+8>>2]|0;d=c[r>>2]|0;j=c[r+8>>2]|0;r=j-d>>6;c[l>>2]=B;v=l+4|0;a[v>>0]=t;t=l+5|0;a[t+0>>0]=a[m+0>>0]|0;a[t+1>>0]=a[m+1>>0]|0;a[t+2>>0]=a[m+2>>0]|0;m=l+8|0;c[m>>2]=h;t=l+12|0;c[t>>2]=0;w=l+16|0;c[w>>2]=y;y=l+20|0;a[k>>0]=1;x=l+25|0;a[x+0>>0]=a[n+0>>0]|0;a[x+1>>0]=a[n+1>>0]|0;a[x+2>>0]=a[n+2>>0]|0;c[o>>2]=0;c[q>>2]=0;c[l+36>>2]=d;c[p>>2]=d;c[z>>2]=j;c[l+48>>2]=r;c[l+52>>2]=r;if(!A){i=e;return}A=l+36|0;r=f+16|0;j=f+12|0;z=d;d=B;B=0;n=h;while(1){c[p>>2]=z;c[y>>2]=A;h=Gsc(c[d>>2]|0,B,n)|0;if(!(a[v>>0]|0)){s=c[h>>2]|0;if(!s){C=ds(c[w>>2]|0)|0;Wrc(C);Qrc(c[c[l>>2]>>2]|0,c[t>>2]|0,C);D=C}else D=s;s=c[w>>2]|0;a[k>>0]=1;a[x+0>>0]=a[g+0>>0]|0;a[x+1>>0]=a[g+1>>0]|0;a[x+2>>0]=a[g+2>>0]|0;E=s;F=D}else{s=c[w>>2]|0;a[k>>0]=0;a[x+0>>0]=a[f+0>>0]|0;a[x+1>>0]=a[f+1>>0]|0;a[x+2>>0]=a[f+2>>0]|0;E=s;F=h}c[o>>2]=F;c[q>>2]=E;h=c[y>>2]|0;c[r>>2]=b;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[j>>2]=h;s=h+4|0;C=c[s>>2]|0;G=h+8|0;H=c[G>>2]|0;if((C|0)!=(H|0)){I=h+12|0;h=C;C=H;do{H=h+64|0;c[s>>2]=H;c[I>>2]=C-H>>6;In[c[h>>2]&4095](h+4|0,f);h=c[s>>2]|0;C=c[G>>2]|0}while((h|0)!=(C|0))}C=(c[t>>2]|0)+1|0;c[t>>2]=C;if((C|0)==(u|0))break;z=c[A>>2]|0;d=c[l>>2]|0;B=C;n=c[m>>2]|0}i=e;return}function D4c(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;OXb(d,b,1);Mdd(d);Mdd(d);n9b(b+12|0,d);MYb(b+16|0,d);n9b(b+32|0,d);MYb(b+36|0,d);n9b(b+52|0,d);MYb(b+56|0,d);n9b(b+72|0,d);MYb(b+76|0,d);n9b(b+92|0,d);MYb(b+96|0,d);n9b(b+112|0,d);MYb(b+116|0,d);n9b(b+132|0,d);MYb(b+136|0,d);n9b(b+152|0,d);MYb(b+156|0,d);K1c(b+172|0,d);K1c(b+188|0,d);K1c(b+204|0,d);K1c(b+220|0,d);Q6c(b+236|0,d);f=b+280|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[j>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=n}c[f>>2]=XEi(o|0)|0;o=b+284|0;f=p+4|0;if(f>>>0>q>>>0){Bid(h,o,4);s=c[o>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{n=c[p>>2]|0;c[o>>2]=n;c[h>>2]=f;s=n;t=f;u=q}c[o>>2]=XEi(s|0)|0;s=b+240|0;o=t+4|0;if(o>>>0>u>>>0){Bid(h,s,4);v=c[s>>2]|0;w=c[h>>2]|0;x=c[m>>2]|0}else{q=c[t>>2]|0;c[s>>2]=q;c[h>>2]=o;v=q;w=o;x=u}c[s>>2]=XEi(v|0)|0;v=b+244|0;if((w+1|0)>>>0>x>>>0){Bid(h,v,1);y=c[h>>2]|0}else{a[v>>0]=a[w>>0]|0;w=(c[h>>2]|0)+1|0;c[h>>2]=w;y=w}w=b+245|0;if((y+1|0)>>>0>(c[m>>2]|0)>>>0)Bid(h,w,1);else{a[w>>0]=a[y>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);y=b+248|0;w=c[h>>2]|0;v=w+4|0;x=c[m>>2]|0;if(v>>>0>x>>>0){Bid(h,y,4);z=c[y>>2]|0;A=c[h>>2]|0;B=c[m>>2]|0}else{s=c[w>>2]|0;c[y>>2]=s;c[h>>2]=v;z=s;A=v;B=x}c[y>>2]=XEi(z|0)|0;z=b+252|0;y=A+4|0;if(y>>>0>B>>>0){Bid(h,z,4);C=c[z>>2]|0;D=c[h>>2]|0;E=c[m>>2]|0}else{x=c[A>>2]|0;c[z>>2]=x;c[h>>2]=y;C=x;D=y;E=B}c[z>>2]=XEi(C|0)|0;C=b+256|0;z=D+4|0;if(z>>>0>E>>>0){Bid(h,C,4);F=C;G=c[C>>2]|0;H=c[h>>2]|0;I=c[m>>2]|0}else{J=ea(g[D>>2]);g[C>>2]=J;c[h>>2]=z;F=C;G=(g[k>>2]=J,c[k>>2]|0);H=z;I=E}c[F>>2]=XEi(G|0)|0;G=b+260|0;F=H+4|0;if(F>>>0>I>>>0){Bid(h,G,4);K=G;L=c[m>>2]|0;M=c[G>>2]|0;N=c[h>>2]|0}else{J=ea(g[H>>2]);g[G>>2]=J;c[h>>2]=F;K=G;L=I;M=(g[k>>2]=J,c[k>>2]|0);N=F}c[K>>2]=XEi(M|0)|0;M=b+272|0;K=N+4|0;if(K>>>0>L>>>0){Bid(h,M,4);O=M;P=c[M>>2]|0;Q=c[h>>2]|0;R=c[m>>2]|0}else{J=ea(g[N>>2]);g[M>>2]=J;c[h>>2]=K;O=M;P=(g[k>>2]=J,c[k>>2]|0);Q=K;R=L}c[O>>2]=XEi(P|0)|0;P=b+276|0;O=Q+4|0;if(O>>>0>R>>>0){Bid(h,P,4);S=P;T=c[P>>2]|0;U=c[h>>2]|0;V=c[m>>2]|0}else{J=ea(g[Q>>2]);g[P>>2]=J;c[h>>2]=O;S=P;T=(g[k>>2]=J,c[k>>2]|0);U=O;V=R}c[S>>2]=XEi(T|0)|0;T=b+288|0;if((U+1|0)>>>0>V>>>0){Bid(h,T,1);W=c[h>>2]|0}else{a[T>>0]=a[U>>0]|0;U=(c[h>>2]|0)+1|0;c[h>>2]=U;W=U}U=b+289|0;if((W+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(h,U,1);Mdd(d);i=e;return}else{a[U>>0]=a[W>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Mdd(d);i=e;return}}function E4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=a+12|0;m=a+48|0;n=c[l>>2]|0;o=n+4|0;p=a+20|0;q=c[p>>2]|0;r=o>>>0>q>>>0;if(!(c[m>>2]|0)){if(r){Bid(l,j,4);s=c[j>>2]|0}else{t=c[n>>2]|0;c[j>>2]=t;c[l>>2]=o;s=t}t=XEi(s|0)|0;c[j>>2]=t;c[k>>2]=c[a+8>>2];c[e+0>>2]=c[k+0>>2];h5c(b,t,e);t=c[b>>2]|0;k=c[b+8>>2]|0;j=t+(k<<4)|0;if(!k){i=d;return}else u=t;do{R6c(u,a);u=u+16|0}while((u|0)!=(j|0));i=d;return}if(r){Bid(l,h,4);v=c[h>>2]|0;w=c[l>>2]|0;x=c[p>>2]|0}else{p=c[n>>2]|0;c[h>>2]=p;c[l>>2]=o;v=p;w=o;x=q}q=XEi(v|0)|0;c[h>>2]=q;v=w+4|0;if(v>>>0>x>>>0){Bid(l,g,4);y=c[g>>2]|0;z=c[h>>2]|0}else{h=c[w>>2]|0;c[g>>2]=h;c[l>>2]=v;y=h;z=q}q=XEi(y|0)|0;c[g>>2]=q;g=z<<4;z=zid(l,q,g)|0;q=b+12|0;if((c[q>>2]|0)>-1){l=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[b>>2]=0}e=g>>4;c[b+8>>2]=e;c[q>>2]=e|-2147483648;c[b>>2]=z;c[m>>2]=0;i=d;return}function F4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}S6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<1);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<1)|0;c[j>>2]=0;i=d;return}function G4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}T6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]|0)|0;c[j>>2]=0;i=d;return}function H4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}U6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]|0)|0;c[j>>2]=0;i=d;return}function I4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}V6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<1);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<1)|0;c[j>>2]=0;i=d;return}function J4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}W6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function K4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}X6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function L4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}Y6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<3);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<3)|0;c[j>>2]=0;i=d;return}function M4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}Z6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<3);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<3)|0;c[j>>2]=0;i=d;return}function N4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}_6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function O4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}$6c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<3);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<3)|0;c[j>>2]=0;i=d;return}function P4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}a7c(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{k2c(r,a);r=r+292|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*292|0)|0;c[j>>2]=0;i=d;return}function Q4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[a+4>>2]|0;g=c[a>>2]|0;h=(f-g|0)/292|0;j=b+4|0;if((c[j>>2]|0)!=(h|0)){c[b>>2]=Isc(d,Zsc(d)|0,h)|0;c[j>>2]=h}if((f|0)==(g|0)){i=e;return}g=a+12|0;f=0;do{j=Rrc(c[b>>2]|0,f)|0;d=(c[a>>2]|0)+(f*292|0)|0;k=c[j>>2]|0;if(!k){l=ds(c[g>>2]|0)|0;Wrc(l);c[j>>2]=l;m=l}else m=k;l2c(c[m+8>>2]|0,d)|0;f=f+1|0}while((f|0)!=(h|0));i=e;return}function R4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}b7c(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{Pxc(r,a);r=r+12|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*12|0)|0;c[j>>2]=0;i=d;return}function S4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}c7c(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{eVb(a,r,1);Ndd(a);r=r+12|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*12|0)|0;c[j>>2]=0;i=d;return}function T4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}d7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p*12|0);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,(c[f>>2]|0)*12|0)|0;c[j>>2]=0;i=d;return}function U4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}e7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<3);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<3)|0;c[j>>2]=0;i=d;return}function V4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}f7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<4);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}function W4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}g7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<4);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}function X4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}h7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<4);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}function Y4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}i7c(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{rgc(r,a);r=r+64|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<6)|0;c[j>>2]=0;i=d;return}function Z4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}j7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p*24|0);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,(c[f>>2]|0)*24|0)|0;c[j>>2]=0;i=d;return}function _4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}k7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<4);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}function $4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}l7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function a5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}m7c(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function b5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[h>>2]|0;q=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;p=l;q=n}n=p+4|0;if(n>>>0>q>>>0){Bid(h,e,4);r=c[e>>2]|0}else{q=c[p>>2]|0;c[e>>2]=q;c[h>>2]=n;r=q}zid(h,r,(c[f>>2]|0)*80|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);s=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;s=o}n7c(b,s);s=c[b+4>>2]|0;o=c[b>>2]|0;if((o|0)==(s|0)){i=d;return}else t=o;do{m2c(a,t+56|0,0);o=t+72|0;b=c[h>>2]|0;l=b+4|0;g=c[m>>2]|0;if(l>>>0>g>>>0){Bid(h,o,4);u=c[h>>2]|0;v=c[m>>2]|0}else{c[o>>2]=c[b>>2];c[h>>2]=l;u=l;v=g}g=t+76|0;l=u+4|0;if(l>>>0>v>>>0)Bid(h,g,4);else{c[g>>2]=c[u>>2];c[h>>2]=l}SMc(t);t=t+80|0}while((t|0)!=(s|0));i=d;return}function c5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}o7c(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{QLc(r,a);r=r+68|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*68|0)|0;c[j>>2]=0;i=d;return}function d5c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[a+4>>2]|0;h=c[a>>2]|0;j=(g-h|0)/68|0;k=d+4|0;if((c[k>>2]|0)!=(j|0)){c[d>>2]=Isc(e,Zsc(e)|0,j)|0;c[k>>2]=j}if((g|0)==(h|0)){i=f;return}h=a+12|0;g=0;do{k=Rrc(c[d>>2]|0,g)|0;e=c[a>>2]|0;l=c[k>>2]|0;if(!l){m=ds(c[h>>2]|0)|0;Wrc(m);c[k>>2]=m;n=m}else n=l;l=c[n+8>>2]|0;c[l>>2]=c[e+(g*68|0)>>2];c[l+4>>2]=c[e+(g*68|0)+4>>2];c[l+8>>2]=c[e+(g*68|0)+8>>2];c[l+12>>2]=c[e+(g*68|0)+12>>2];c[l+16>>2]=c[e+(g*68|0)+16>>2];c[l+20>>2]=c[e+(g*68|0)+20>>2];c[l+24>>2]=c[e+(g*68|0)+24>>2];c[l+28>>2]=c[e+(g*68|0)+28>>2];m=l+32|0;l=e+(g*68|0)+32|0;e=m+34|0;do{b[m>>1]=b[l>>1]|0;m=m+2|0;l=l+2|0}while((m|0)<(e|0));g=g+1|0}while((g|0)!=(j|0));i=f;return}function e5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}p7c(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{H_c(r,a);r=r+16|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<4)|0;c[j>>2]=0;i=d;return}function f5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=(c[a+4>>2]|0)-(c[a>>2]|0)>>4;g=b+4|0;if((c[g>>2]|0)!=(f|0)){c[b>>2]=Isc(d,Zsc(d)|0,f)|0;c[g>>2]=f}if(!f){i=e;return}g=a+12|0;d=0;do{h=Rrc(c[b>>2]|0,d)|0;j=(c[a>>2]|0)+(d<<4)|0;k=c[h>>2]|0;if(!k){l=ds(c[g>>2]|0)|0;Wrc(l);c[h>>2]=l;m=l}else m=k;k=c[m+8>>2]|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];d=d+1|0}while((d|0)!=(f|0));i=e;return}function g5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function h5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;j=c[a>>2]|0;if(!j)c[a+4>>2]=c[d>>2];d=a+12|0;k=c[d>>2]|0;do if((k&2147483647)>>>0<b>>>0)if((k|0)>-1){c[d>>2]=b;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=hOb(j,b<<4,4,f,0,3653512,370)|0;c[a>>2]=l;m=l;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];l=cOb(b<<4,4,f,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,c[a+8>>2]<<4|0)|0;c[d>>2]=b;c[a>>2]=l;m=l;break}else m=j;while(0);j=a+8|0;a=c[j>>2]|0;if(a>>>0>=b>>>0){c[j>>2]=b;i=e;return}d=m+(b<<4)|0;if((a|0)==(b|0)){c[j>>2]=b;i=e;return}f=m+(a<<4)|0;do{if(f){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2]}f=f+16|0}while((f|0)!=(d|0));c[j>>2]=b;i=e;return}function i5c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if((j-m|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{a[o>>0]=0;p=c[k>>2]|0}o=p+1|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=m-n+d|0;if((o|0)<0)vxi(b);m=n;n=j-m|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m|0;if(!n){q=0;r=0;s=j}else{t=n;u=j;v=10}}else{t=2147483647;u=(c[k>>2]|0)-m|0;v=10}if((v|0)==10){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];q=t;r=cOb(t,16,f,0,3653512,80)|0;s=u}u=d;d=r+s|0;while(1){if(!d)w=0;else{a[d>>0]=0;w=d}t=w+1|0;u=u+-1|0;if(!u){x=t;break}else d=t}d=c[b>>2]|0;u=(c[k>>2]|0)-d|0;w=r+(s-u)|0;YEi(w|0,d|0,u|0)|0;u=c[b>>2]|0;c[b>>2]=w;c[k>>2]=x;c[h>>2]=r+q;if(!u){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(u,f);i=e;return}function j5c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if((j-m|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{a[o>>0]=0;p=c[k>>2]|0}o=p+1|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=m-n+d|0;if((o|0)<0)vxi(b);m=n;n=j-m|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m|0;if(!n){q=0;r=0;s=j}else{t=n;u=j;v=10}}else{t=2147483647;u=(c[k>>2]|0)-m|0;v=10}if((v|0)==10){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];q=t;r=cOb(t,16,f,0,3653512,80)|0;s=u}u=d;d=r+s|0;while(1){if(!d)w=0;else{a[d>>0]=0;w=d}t=w+1|0;u=u+-1|0;if(!u){x=t;break}else d=t}d=c[b>>2]|0;u=(c[k>>2]|0)-d|0;w=r+(s-u)|0;YEi(w|0,d|0,u|0)|0;u=c[b>>2]|0;c[b>>2]=w;c[k>>2]=x;c[h>>2]=r+q;if(!u){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(u,f);i=e;return}function k5c(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>1>>>0>=d>>>0){n=d;o=l;while(1){if(o)b[o>>1]=0;n=n+-1|0;if(!n)break;else o=o+2|0}c[k>>2]=l+(d<<1);i=e;return}l=c[a>>2]|0;o=(m-l>>1)+d|0;if((o|0)<0)vxi(a);m=l;l=j-m|0;if(l>>1>>>0<1073741823){j=l>>>0<o>>>0?o:l;l=(c[k>>2]|0)-m>>1;if(!j){p=0;q=0;r=l}else{s=j;t=l;u=11}}else{s=2147483647;t=(c[k>>2]|0)-m>>1;u=11}if((u|0)==11){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];p=s;q=cOb(s<<1,16,f,0,3653512,80)|0;r=t}t=d;s=q+(r<<1)|0;while(1){if(s)b[s>>1]=0;t=t+-1|0;if(!t)break;else s=s+2|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+(r-(t>>1)<<1)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+(r+d<<1);c[h>>2]=q+(p<<1);if(!t){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(t,f);i=e;return}function l5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)c[n>>2]=0;m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>2>>>0<1073741823){h=k>>1;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=(c[j>>2]|0)-l>>2;t=11}if((t|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r<<2,16,e,0,3653512,80)|0;q=s}s=b;r=p+(q<<2)|0;while(1){if(r)c[r>>2]=0;s=s+-1|0;if(!s)break;else r=r+4|0}r=c[a>>2]|0;s=(c[j>>2]|0)-r|0;t=p+(q-(s>>2)<<2)|0;YEi(t|0,r|0,s|0)|0;s=c[a>>2]|0;c[a>>2]=t;c[j>>2]=p+(q+b<<2);c[g>>2]=p+(o<<2);if(!s){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function m5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>3>>>0>=b>>>0){m=b;n=k;while(1){if(n){o=n;c[o>>2]=0;c[o+4>>2]=0}m=m+-1|0;if(!m)break;else n=n+8|0}c[j>>2]=k+(b<<3);i=d;return}k=c[a>>2]|0;n=(l-k>>3)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>3>>>0<1073741823){h=k>>2;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>3;if(!k){p=0;q=0;r=h}else{s=k;t=h;u=11}}else{s=2147483647;t=(c[j>>2]|0)-l>>3;u=11}if((u|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<3,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r<<3)|0;while(1){if(s){u=s;c[u>>2]=0;c[u+4>>2]=0}t=t+-1|0;if(!t)break;else s=s+8|0}s=c[a>>2]|0;t=(c[j>>2]|0)-s|0;u=q+(r-(t>>3)<<3)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[j>>2]=q+(r+b<<3);c[g>>2]=q+(p<<3);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function n5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>3>>>0>=b>>>0){m=b;n=k;while(1){if(n){o=n;c[o>>2]=0;c[o+4>>2]=0}m=m+-1|0;if(!m)break;else n=n+8|0}c[j>>2]=k+(b<<3);i=d;return}k=c[a>>2]|0;n=(l-k>>3)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>3>>>0<1073741823){h=k>>2;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>3;if(!k){p=0;q=0;r=h}else{s=k;t=h;u=11}}else{s=2147483647;t=(c[j>>2]|0)-l>>3;u=11}if((u|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<3,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r<<3)|0;while(1){if(s){u=s;c[u>>2]=0;c[u+4>>2]=0}t=t+-1|0;if(!t)break;else s=s+8|0}s=c[a>>2]|0;t=(c[j>>2]|0)-s|0;u=q+(r-(t>>3)<<3)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[j>>2]=q+(r+b<<3);c[g>>2]=q+(p<<3);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function o5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>2>>>0>=b>>>0){n=b;o=l;while(1){if(o)g[o>>2]=ea(0.0);n=n+-1|0;if(!n)break;else o=o+4|0}c[k>>2]=l+(b<<2);i=d;return}l=c[a>>2]|0;o=(m-l>>2)+b|0;if((o|0)<0)vxi(a);m=l;l=j-m|0;if(l>>2>>>0<1073741823){j=l>>1;l=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m>>2;if(!l){p=0;q=0;r=j}else{s=l;t=j;u=11}}else{s=2147483647;t=(c[k>>2]|0)-m>>2;u=11}if((u|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<2,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r<<2)|0;while(1){if(s)g[s>>2]=ea(0.0);t=t+-1|0;if(!t)break;else s=s+4|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+(r-(t>>2)<<2)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+(r+b<<2);c[h>>2]=q+(p<<2);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function p5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;j=c[g>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>3>>>0>=b>>>0){n=b;o=l;while(1){if(o)h[o>>3]=0.0;n=n+-1|0;if(!n)break;else o=o+8|0}c[k>>2]=l+(b<<3);i=d;return}l=c[a>>2]|0;o=(m-l>>3)+b|0;if((o|0)<0)vxi(a);m=l;l=j-m|0;if(l>>3>>>0<1073741823){j=l>>2;l=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m>>3;if(!l){p=0;q=0;r=j}else{s=l;t=j;u=11}}else{s=2147483647;t=(c[k>>2]|0)-m>>3;u=11}if((u|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<3,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r<<3)|0;while(1){if(s)h[s>>3]=0.0;t=t+-1|0;if(!t)break;else s=s+8|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+(r-(t>>3)<<3)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+(r+b<<3);c[g>>2]=q+(p<<3);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function q5c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[d+4>>2]|0;j=b+4|0;k=c[j>>2]|0;l=c[b>>2]|0;m=(k-l|0)/292|0;if(h>>>0<=m>>>0){if(h>>>0<m>>>0?(n=l+(h*292|0)|0,(k|0)!=(n|0)):0){l=k;while(1){k=l+-292|0;c[j>>2]=k;if(!(a[k>>0]&1))o=k;else{k=c[l+-284>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(k,f);o=c[j>>2]|0}if((o|0)==(n|0))break;else l=o}}}else q7c(b,h-m|0);if(!h){i=e;return}m=0;do{o=c[(Rrc(c[d>>2]|0,m)|0)>>2]|0;if(o)l2c((c[b>>2]|0)+(m*292|0)|0,c[o+8>>2]|0)|0;m=m+1|0}while((m|0)!=(h|0));i=e;return}function r5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/12|0)>>>0>=b>>>0){m=b;n=k;while(1){if(n){c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0}m=m+-1|0;if(!m)break;else n=n+12|0}c[j>>2]=k+(b*12|0);i=d;return}k=c[a>>2]|0;n=((l-k|0)/12|0)+b|0;if((n|0)<0)vxi(a);l=k;k=(h-l|0)/12|0;if(k>>>0<1073741823){h=k<<1;k=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/12|0;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=((c[j>>2]|0)-l|0)/12|0;t=11}if((t|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r*12|0,16,e,0,3653512,80)|0;q=s}s=p+(q*12|0)|0;r=b;t=s;while(1){if(t){c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0}r=r+-1|0;if(!r)break;else t=t+12|0}t=p+(o*12|0)|0;o=p+((q+b|0)*12|0)|0;b=c[a>>2]|0;r=c[j>>2]|0;if((r|0)==(b|0)){u=s;v=b}else{l=q+-1-(((r+-12-b|0)>>>0)/12|0)|0;q=r;r=s;while(1){s=q;q=q+-12|0;c[r+-12>>2]=c[q>>2];h=s+-8|0;s=c[h+4>>2]|0;k=r+-8|0;c[k>>2]=c[h>>2];c[k+4>>2]=s;if((q|0)==(b|0))break;else r=r+-12|0}u=p+(l*12|0)|0;v=c[a>>2]|0}c[a>>2]=u;c[j>>2]=o;c[g>>2]=t;if(!v){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(v,e);i=d;return}function s5c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[d+4>>2]|0;j=b+4|0;k=c[j>>2]|0;l=c[b>>2]|0;m=(k-l|0)/12|0;if(h>>>0<=m>>>0){if(h>>>0<m>>>0?(n=l+(h*12|0)|0,(k|0)!=(n|0)):0){l=k;while(1){k=l+-12|0;c[j>>2]=k;if(!(a[k>>0]&1))o=k;else{k=c[l+-4>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);o=c[j>>2]|0}if((o|0)==(n|0))break;else l=o}}}else r7c(b,h-m|0);if(!h){i=e;return}m=b+12|0;o=0;do{l=c[(Rrc(c[d>>2]|0,o)|0)>>2]|0;if(l)Q2c(m,l,(c[b>>2]|0)+(o*12|0)|0);o=o+1|0}while((o|0)!=(h|0));i=e;return}function t5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/12|0)>>>0>=b>>>0){n=b;o=l;while(1){if(o){g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0);g[o+8>>2]=ea(0.0)}n=n+-1|0;if(!n)break;else o=o+12|0}c[k>>2]=l+(b*12|0);i=d;return}l=c[a>>2]|0;o=((m-l|0)/12|0)+b|0;if((o|0)<0)vxi(a);m=l;l=(j-m|0)/12|0;if(l>>>0<1073741823){j=l<<1;l=j>>>0<o>>>0?o:j;j=((c[k>>2]|0)-m|0)/12|0;if(!l){p=0;q=0;r=j}else{s=l;t=j;u=11}}else{s=2147483647;t=((c[k>>2]|0)-m|0)/12|0;u=11}if((u|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s*12|0,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r*12|0)|0;while(1){if(s){g[s>>2]=ea(0.0);g[s+4>>2]=ea(0.0);g[s+8>>2]=ea(0.0)}t=t+-1|0;if(!t)break;else s=s+12|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+((((t|0)/-12|0)+r|0)*12|0)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+((r+b|0)*12|0);c[h>>2]=q+(p*12|0);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function u5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d;f=b+4|0;h=c[f>>2]|0;j=c[b>>2]|0;k=(h-j|0)/12|0;c[e>>2]=k;l=a+12|0;m=c[l>>2]|0;n=m+4|0;o=a+20|0;if(n>>>0<(c[o>>2]|0)>>>0){c[m>>2]=k;c[l>>2]=n;p=j;q=h}else{Gid(l,e,4);p=c[b>>2]|0;q=c[f>>2]|0}if((p|0)==(q|0)){i=d;return}else r=p;do{p=c[l>>2]|0;f=p+4|0;b=c[o>>2]|0;if(f>>>0<b>>>0){g[p>>2]=ea(g[r>>2]);c[l>>2]=f;s=f;t=b}else{Gid(l,r,4);s=c[l>>2]|0;t=c[o>>2]|0}b=r+4|0;f=s+4|0;if(f>>>0<t>>>0){g[s>>2]=ea(g[b>>2]);c[l>>2]=f;u=f;v=t}else{Gid(l,b,4);u=c[l>>2]|0;v=c[o>>2]|0}b=r+8|0;f=u+4|0;if(f>>>0<v>>>0){g[u>>2]=ea(g[b>>2]);c[l>>2]=f}else Gid(l,b,4);r=r+12|0}while((r|0)!=(q|0));i=d;return}function v5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>3>>>0>=b>>>0){n=b;o=l;while(1){if(o){g[o>>2]=ea(0.0);g[o+4>>2]=ea(0.0)}n=n+-1|0;if(!n)break;else o=o+8|0}c[k>>2]=l+(b<<3);i=d;return}l=c[a>>2]|0;o=(m-l>>3)+b|0;if((o|0)<0)vxi(a);m=l;l=j-m|0;if(l>>3>>>0<1073741823){j=l>>2;l=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m>>3;if(!l){p=0;q=0;r=j}else{s=l;t=j;u=11}}else{s=2147483647;t=(c[k>>2]|0)-m>>3;u=11}if((u|0)==11){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<3,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r<<3)|0;while(1){if(s){g[s>>2]=ea(0.0);g[s+4>>2]=ea(0.0)}t=t+-1|0;if(!t)break;else s=s+8|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+(r-(t>>3)<<3)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+(r+b<<3);c[h>>2]=q+(p<<3);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function w5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>4>>>0>=b>>>0){c[j>>2]=k+(b<<4);i=d;return}k=c[a>>2]|0;m=(l-k>>4)+b|0;if((m|0)<0)vxi(a);l=k;n=h-l|0;if(n>>4>>>0<1073741823){h=n>>3;n=h>>>0<m>>>0?m:h;h=c[j>>2]|0;m=h-l>>4;if(!n){o=0;p=0;q=m;r=h;s=k}else{t=n;u=m;v=8}}else{t=2147483647;u=(c[j>>2]|0)-l>>4;v=8}if((v|0)==8){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];v=cOb(t<<4,16,e,0,3653512,80)|0;o=t;p=v;q=u;r=c[j>>2]|0;s=c[a>>2]|0}u=r-s|0;r=p+(q-(u>>4)<<4)|0;YEi(r|0,s|0,u|0)|0;u=c[a>>2]|0;c[a>>2]=r;c[j>>2]=p+(q+b<<4);c[g>>2]=p+(o<<4);if(!u){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(u,e);i=d;return}function x5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>4>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;o=c[j>>2]|0}n=o+16|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=(l-m>>4)+b|0;if((n|0)<0)vxi(a);l=m;m=h-l|0;if(m>>4>>>0<1073741823){h=m>>3;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>4;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=(c[j>>2]|0)-l>>4;u=10}if((u|0)==10){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<4,16,e,0,3653512,80)|0;r=t}t=b;b=q+(r<<4)|0;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;v=b}s=v+16|0;t=t+-1|0;if(!t){w=s;break}else b=s}b=c[a>>2]|0;t=(c[j>>2]|0)-b|0;v=q+(r-(t>>4)<<4)|0;YEi(v|0,b|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=v;c[j>>2]=w;c[g>>2]=q+(p<<4);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function y5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>4>>>0>=b>>>0){c[j>>2]=k+(b<<4);i=d;return}k=c[a>>2]|0;m=(l-k>>4)+b|0;if((m|0)<0)vxi(a);l=k;n=h-l|0;if(n>>4>>>0<1073741823){h=n>>3;n=h>>>0<m>>>0?m:h;h=c[j>>2]|0;m=h-l>>4;if(!n){o=0;p=0;q=m;r=h;s=k}else{t=n;u=m;v=8}}else{t=2147483647;u=(c[j>>2]|0)-l>>4;v=8}if((v|0)==8){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];v=cOb(t<<4,16,e,0,3653512,80)|0;o=t;p=v;q=u;r=c[j>>2]|0;s=c[a>>2]|0}u=r-s|0;r=p+(q-(u>>4)<<4)|0;YEi(r|0,s|0,u|0)|0;u=c[a>>2]|0;c[a>>2]=r;c[j>>2]=p+(q+b<<4);c[g>>2]=p+(o<<4);if(!u){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(u,e);i=d;return}function z5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>6>>>0>=b>>>0){c[j>>2]=k+(b<<6);i=d;return}k=c[a>>2]|0;m=(l-k>>6)+b|0;if((m|0)<0)vxi(a);l=k;n=h-l|0;if(n>>6>>>0<1073741823){h=n>>5;n=h>>>0<m>>>0?m:h;h=c[j>>2]|0;m=h-l>>6;if(!n){o=0;p=0;q=m;r=h;s=k}else{t=n;u=m;v=8}}else{t=2147483647;u=(c[j>>2]|0)-l>>6;v=8}if((v|0)==8){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];v=cOb(t<<6,16,e,0,3653512,80)|0;o=t;p=v;q=u;r=c[j>>2]|0;s=c[a>>2]|0}u=r-s|0;r=p+(q-(u>>6)<<6)|0;YEi(r|0,s|0,u|0)|0;u=c[a>>2]|0;c[a>>2]=r;c[j>>2]=p+(q+b<<6);c[g>>2]=p+(o<<6);if(!u){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(u,e);i=d;return}function A5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/24|0)>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;o=c[j>>2]|0}n=o+24|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=((l-m|0)/24|0)+b|0;if((n|0)<0)vxi(a);l=m;m=(h-l|0)/24|0;if(m>>>0<1073741823){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/24|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=((c[j>>2]|0)-l|0)/24|0;u=10}if((u|0)==10){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s*24|0,16,e,0,3653512,80)|0;r=t}t=b;b=q+(r*24|0)|0;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;v=b}s=v+24|0;t=t+-1|0;if(!t){w=s;break}else b=s}b=c[a>>2]|0;t=(c[j>>2]|0)-b|0;v=q+((((t|0)/-24|0)+r|0)*24|0)|0;YEi(v|0,b|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=v;c[j>>2]=w;c[g>>2]=q+(p*24|0);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function B5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>4>>>0>=b>>>0){c[j>>2]=k+(b<<4);i=d;return}k=c[a>>2]|0;m=(l-k>>4)+b|0;if((m|0)<0)vxi(a);l=k;n=h-l|0;if(n>>4>>>0<1073741823){h=n>>3;n=h>>>0<m>>>0?m:h;h=c[j>>2]|0;m=h-l>>4;if(!n){o=0;p=0;q=m;r=h;s=k}else{t=n;u=m;v=8}}else{t=2147483647;u=(c[j>>2]|0)-l>>4;v=8}if((v|0)==8){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];v=cOb(t<<4,16,e,0,3653512,80)|0;o=t;p=v;q=u;r=c[j>>2]|0;s=c[a>>2]|0}u=r-s|0;r=p+(q-(u>>4)<<4)|0;YEi(r|0,s|0,u|0)|0;u=c[a>>2]|0;c[a>>2]=r;c[j>>2]=p+(q+b<<4);c[g>>2]=p+(o<<4);if(!u){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(u,e);i=d;return}function C5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;m=(l-k>>2)+b|0;if((m|0)<0)vxi(a);l=k;n=h-l|0;if(n>>2>>>0<1073741823){h=n>>1;n=h>>>0<m>>>0?m:h;h=c[j>>2]|0;m=h-l>>2;if(!n){o=0;p=0;q=m;r=h;s=k}else{t=n;u=m;v=8}}else{t=2147483647;u=(c[j>>2]|0)-l>>2;v=8}if((v|0)==8){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];v=cOb(t<<2,16,e,0,3653512,80)|0;o=t;p=v;q=u;r=c[j>>2]|0;s=c[a>>2]|0}u=r-s|0;r=p+(q-(u>>2)<<2)|0;YEi(r|0,s|0,u|0)|0;u=c[a>>2]|0;c[a>>2]=r;c[j>>2]=p+(q+b<<2);c[g>>2]=p+(o<<2);if(!u){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(u,e);i=d;return}function D5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n>>2]=0;o=c[j>>2]|0}n=o+4|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=(l-m>>2)+b|0;if((n|0)<0)vxi(a);l=m;m=h-l|0;if(m>>2>>>0<1073741823){h=m>>1;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=(c[j>>2]|0)-l>>2;u=10}if((u|0)==10){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<2,16,e,0,3653512,80)|0;r=t}t=b;b=q+(r<<2)|0;while(1){if(!b)v=0;else{c[b>>2]=0;v=b}s=v+4|0;t=t+-1|0;if(!t){w=s;break}else b=s}b=c[a>>2]|0;t=(c[j>>2]|0)-b|0;v=q+(r-(t>>2)<<2)|0;YEi(v|0,b|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=v;c[j>>2]=w;c[g>>2]=q+(p<<2);if(!t){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function E5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b+4>>2]|0;h=a+4|0;j=c[h>>2]|0;k=c[a>>2]|0;l=(j-k|0)/80|0;if(g>>>0<=l>>>0){if(g>>>0<l>>>0?(m=k+(g*80|0)|0,(j|0)!=(m|0)):0){k=j;while(1){j=k+-80|0;c[h>>2]=j;if((c[k+-12>>2]|0)>-1){n=k+-24|0;o=c[n>>2]|0;c[f>>2]=c[k+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(o,e);c[n>>2]=0;p=c[h>>2]|0}else p=j;if((p|0)==(m|0))break;else k=p}}}else s7c(a,g-l|0);if(!g){i=d;return}l=a+12|0;p=0;do{k=Rrc(c[b>>2]|0,p)|0;if(c[k>>2]|0)S2c(l,k,(c[a>>2]|0)+(p*80|0)|0);p=p+1|0}while((p|0)!=(g|0));i=d;return}function F5c(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[d+4>>2]|0;g=a+4|0;h=c[g>>2]|0;j=c[a>>2]|0;k=(h-j|0)/68|0;if(f>>>0<=k>>>0){if(f>>>0<k>>>0?(l=j+(f*68|0)|0,(h|0)!=(l|0)):0){j=h;do{c[g>>2]=j+-68;j=c[g>>2]|0}while((j|0)!=(l|0))}}else t7c(a,f-k|0);if(!f){i=e;return}k=0;do{l=c[(Rrc(c[d>>2]|0,k)|0)>>2]|0;if(l){j=c[a>>2]|0;g=c[l+8>>2]|0;c[j+(k*68|0)>>2]=c[g>>2];c[j+(k*68|0)+4>>2]=c[g+4>>2];c[j+(k*68|0)+8>>2]=c[g+8>>2];c[j+(k*68|0)+12>>2]=c[g+12>>2];c[j+(k*68|0)+16>>2]=c[g+16>>2];c[j+(k*68|0)+20>>2]=c[g+20>>2];c[j+(k*68|0)+24>>2]=c[g+24>>2];c[j+(k*68|0)+28>>2]=c[g+28>>2];l=j+(k*68|0)+32|0;j=g+32|0;g=l+34|0;do{b[l>>1]=b[j>>1]|0;l=l+2|0;j=j+2|0}while((l|0)<(g|0))}k=k+1|0}while((k|0)!=(f|0));i=e;return}function G5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>4>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;o=c[j>>2]|0}n=o+16|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=(l-m>>4)+b|0;if((n|0)<0)vxi(a);l=m;m=h-l|0;if(m>>4>>>0<1073741823){h=m>>3;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>4;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=(c[j>>2]|0)-l>>4;u=10}if((u|0)==10){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<4,16,e,0,3653512,80)|0;r=t}t=q+(r<<4)|0;s=b;b=t;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;v=b}u=v+16|0;s=s+-1|0;if(!s){w=u;break}else b=u}b=q+(p<<4)|0;p=c[a>>2]|0;s=c[j>>2]|0;if((s|0)==(p|0)){x=t;y=p}else{v=s+-16-p|0;u=s;s=t;while(1){t=u;u=u+-16|0;c[s+-16>>2]=c[u>>2];c[s+-12>>2]=c[t+-12>>2];c[s+-8>>2]=c[t+-8>>2];c[s+-4>>2]=c[t+-4>>2];if((u|0)==(p|0))break;else s=s+-16|0}x=q+(r+~(v>>>4)<<4)|0;y=c[a>>2]|0}c[a>>2]=x;c[j>>2]=w;c[g>>2]=b;if(!y){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(y,e);i=d;return}function H5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function I5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=b;l=h}else{Gid(e,a,4);k=c[j>>2]|0;l=c[e>>2]|0}h=a+4|0;b=l+4|0;if(b>>>0<k>>>0){g[l>>2]=ea(g[h>>2]);c[e>>2]=b;m=b;n=k}else{Gid(e,h,4);m=c[e>>2]|0;n=c[j>>2]|0}h=a+8|0;k=m+4|0;if(k>>>0<n>>>0){g[m>>2]=ea(g[h>>2]);c[e>>2]=k;o=k;p=n}else{Gid(e,h,4);o=c[e>>2]|0;p=c[j>>2]|0}j=a+12|0;a=o+4|0;if(a>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function J5c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+304|0;f=d+296|0;g=d+292|0;h=d;MIc(h);$cd(b,2646336,2646336,f,e);add(b,3142592,2394192,h,0);r3c(h,b);bdd(b);cdd(b);if(!(a[h>>0]&1)){i=d;return}b=c[h+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=d;return}function K5c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g;add(b,e,c[142306]|0,d,f);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;$cd(b,2646336,2646336,g+12|0,0);add(b,3142592,c[142294]|0,k,0);$cd(b,2646336,2646336,h,1);add(b,3142592,c[142260]|0,j,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);cdd(b);if(!(a[k>>0]&1)){bdd(b);i=g;return}f=c[k+8>>2]|0;c[j>>2]=89;c[h+0>>2]=c[j+0>>2];eOb(f,h);bdd(b);i=g;return}function L5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;b=i;i=i+96|0;e=b+84|0;f=b+80|0;h=b;g[h+4>>2]=ea(x);c[h>>2]=0;j=h+8|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;g[h+32>>2]=ea(x);c[h+28>>2]=0;j=h+36|0;c[h+64>>2]=0;k=h+68|0;c[k>>2]=0;l=h+60|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[l>>2]=60;c[h+76>>2]=2;c[h+72>>2]=2;$cd(a,2646336,2646336,e,d);add(a,3142592,2470664,h,0);s3c(h,a);bdd(a);cdd(a);if((c[k>>2]|0)<=-1){i=b;return}k=h+56|0;h=c[k>>2]|0;c[f>>2]=c[l>>2];c[e+0>>2]=c[f+0>>2];eOb(h,e);c[k>>2]=0;i=b;return}function M5c(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+80|0;g=f;add(a,d,c[142306]|0,b,e);MLc(g);$cd(a,2646336,2646336,f+68|0,0);add(a,3142592,614696,g,0);OLc(g,a);bdd(a);cdd(a);bdd(a);i=f;return}function N5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;add(b,2387736,614680,a,0);f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,a,1);e=b+12|0;g=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,f,1);c[(c[c[e>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);g=a+4|0;add(b,614568,c[142262]|0,g,0);EYb(g,b);bdd(b);i=d;return}function O5c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[142268]|0;add(b,3142608,e,a,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3116392,e,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614624,e,a+8|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,614632,e,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);i=d;return}function P5c(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=f+8|0;h=f;j=d+4|0;c[g>>2]=(c[j>>2]|0)-(c[d>>2]|0)>>1;if(!(tdd(a,2646336,2646336,g)|0)){i=f;return}S6c(d,c[g>>2]|0);k=c[j>>2]|0;a:do if(c[g>>2]|0){j=qdd(a,3142592,c[142296]|0,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((j|0)!=2){sdd(a);j=c[d>>2]|0;if((j|0)==(k|0))break;else o=j;while(1){AUb(a,o,3142592,0);o=o+2|0;if((o|0)==(k|0))break a}}j=c[l>>2]|0;p=c[j+12>>2]|0;q=c[d>>2]|0;b:do if((q|0)!=(k|0)){r=a+12|0;s=a+16|0;t=a+28|0;u=a+32|0;v=a+20|0;w=0;x=j;y=q;while(1){z=(da(w,m)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[n>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(C=A+(B+2)|0,C>>>0<=(c[v>>2]|0)>>>0):0){b[y>>1]=b[z>>1]|0;c[r>>2]=C}else Bid(r,y,2);if(c[a>>2]&512){C=e[y>>1]|0;b[y>>1]=C<<8|C>>>8}C=y+2|0;if((C|0)==(k|0))break b;w=c[c[n>>2]>>2]|0;x=c[l>>2]|0;y=C}}while(0);sdd(a)}while(0);udd(a);i=f;return}function Q5c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e;j=d+4|0;c[g>>2]=(c[j>>2]|0)-(c[d>>2]|0);if(!(tdd(b,2646336,2646336,g)|0)){i=e;return}T6c(d,c[g>>2]|0);k=c[j>>2]|0;do if(c[g>>2]|0){j=c[142292]|0;l=qdd(b,3142592,j,0,0)|0;m=b+80|0;n=c[($hd(c[m>>2]|0)|0)+12>>2]|0;o=b+84|0;c[c[o>>2]>>2]=0;if((l|0)==2){l=c[m>>2]|0;p=c[l+12>>2]|0;q=c[d>>2]|0;a:do if((q|0)!=(k|0)){r=b+12|0;s=b+16|0;t=b+28|0;u=b+32|0;v=b+20|0;w=0;x=l;y=q;while(1){z=(da(w,n)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[o>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(A+(B+1)|0)>>>0<=(c[v>>2]|0)>>>0:0){a[y>>0]=a[z>>0]|0;c[r>>2]=(c[r>>2]|0)+1}else Bid(r,y,1);z=y+1|0;if((z|0)==(k|0))break a;w=c[c[o>>2]>>2]|0;x=c[m>>2]|0;y=z}}while(0);sdd(b);break}sdd(b);o=c[d>>2]|0;if((o|0)!=(k|0)){p=b+12|0;n=b+16|0;q=b+28|0;l=b+32|0;y=b+20|0;x=o;do{o=qdd(b,3142592,j,f,0)|0;if(o){do if((o|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](x,b)|0}else{w=c[n>>2]|0;r=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[l>>2]|0,c[q>>2]|0)|0)|0;v=w+r|0;c[p>>2]=v;if((r|0)>=0?(w+(r+1)|0)>>>0<=(c[y>>2]|0)>>>0:0){a[x>>0]=a[v>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,x,1)}while(0);sdd(b)}x=x+1|0}while((x|0)!=(k|0))}}while(0);udd(b);i=e;return}function R5c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e;j=d+4|0;c[g>>2]=(c[j>>2]|0)-(c[d>>2]|0);if(!(tdd(b,2646336,2646336,g)|0)){i=e;return}U6c(d,c[g>>2]|0);k=c[j>>2]|0;do if(c[g>>2]|0){j=c[142302]|0;l=qdd(b,3142592,j,0,0)|0;m=b+80|0;n=c[($hd(c[m>>2]|0)|0)+12>>2]|0;o=b+84|0;c[c[o>>2]>>2]=0;if((l|0)==2){l=c[m>>2]|0;p=c[l+12>>2]|0;q=c[d>>2]|0;a:do if((q|0)!=(k|0)){r=b+12|0;s=b+16|0;t=b+28|0;u=b+32|0;v=b+20|0;w=0;x=l;y=q;while(1){z=(da(w,n)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[o>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(A+(B+1)|0)>>>0<=(c[v>>2]|0)>>>0:0){a[y>>0]=a[z>>0]|0;c[r>>2]=(c[r>>2]|0)+1}else Bid(r,y,1);z=y+1|0;if((z|0)==(k|0))break a;w=c[c[o>>2]>>2]|0;x=c[m>>2]|0;y=z}}while(0);sdd(b);break}sdd(b);o=c[d>>2]|0;if((o|0)!=(k|0)){p=b+12|0;n=b+16|0;q=b+28|0;l=b+32|0;y=b+20|0;x=o;do{o=qdd(b,3142592,j,f,0)|0;if(o){do if((o|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](x,b)|0}else{w=c[n>>2]|0;r=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[l>>2]|0,c[q>>2]|0)|0)|0;v=w+r|0;c[p>>2]=v;if((r|0)>=0?(w+(r+1)|0)>>>0<=(c[y>>2]|0)>>>0:0){a[x>>0]=a[v>>0]|0;c[p>>2]=(c[p>>2]|0)+1;break}Bid(p,x,1)}while(0);sdd(b)}x=x+1|0}while((x|0)!=(k|0))}}while(0);udd(b);i=e;return}function S5c(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=f+8|0;h=f;j=d+4|0;c[g>>2]=(c[j>>2]|0)-(c[d>>2]|0)>>1;if(!(tdd(a,2646336,2646336,g)|0)){i=f;return}V6c(d,c[g>>2]|0);k=c[j>>2]|0;a:do if(c[g>>2]|0){j=qdd(a,3142592,c[142286]|0,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((j|0)!=2){sdd(a);j=c[d>>2]|0;if((j|0)==(k|0))break;else o=j;while(1){RAc(a,o,3142592,0);o=o+2|0;if((o|0)==(k|0))break a}}j=c[l>>2]|0;p=c[j+12>>2]|0;q=c[d>>2]|0;b:do if((q|0)!=(k|0)){r=a+12|0;s=a+16|0;t=a+28|0;u=a+32|0;v=a+20|0;w=0;x=j;y=q;while(1){z=(da(w,m)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[n>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(C=A+(B+2)|0,C>>>0<=(c[v>>2]|0)>>>0):0){b[y>>1]=b[z>>1]|0;c[r>>2]=C}else Bid(r,y,2);if(c[a>>2]&512){C=e[y>>1]|0;b[y>>1]=C<<8|C>>>8}C=y+2|0;if((C|0)==(k|0))break b;w=c[c[n>>2]>>2]|0;x=c[l>>2]|0;y=C}}while(0);sdd(a)}while(0);udd(a);i=f;return}function T5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}W6c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142270]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=k;x=p;while(1){y=(da(v,m)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(g,w);y=g;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+4)|0,B>>>0<=(c[u>>2]|0)>>>0):0){c[x>>2]=c[y>>2];c[q>>2]=B}else Bid(q,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0;B=x+4|0;if((B|0)==(j|0))break a;v=c[c[n>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(j|0)){o=a+12|0;m=a+16|0;p=a+28|0;k=a+32|0;x=a+20|0;w=n;do{n=qdd(a,3142592,h,e,0)|0;if(n){if((n|0)>0){n=c[m>>2]|0;v=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[k>>2]|0,c[p>>2]|0)|0)|0;q=n+v|0;c[o>>2]=q;if((v|0)>=0?(u=n+(v+4)|0,u>>>0<=(c[x>>2]|0)>>>0):0){c[w>>2]=c[q>>2];c[o>>2]=u}else Bid(o,w,4);if(c[a>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{u=c[e>>2]|0;if(u)_n[u&4095](w,a)|0}sdd(a)}w=w+4|0}while((w|0)!=(j|0))}}while(0);udd(a);i=d;return}function U5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}X6c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142304]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=k;x=p;while(1){y=(da(v,m)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(g,w);y=g;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+4)|0,B>>>0<=(c[u>>2]|0)>>>0):0){c[x>>2]=c[y>>2];c[q>>2]=B}else Bid(q,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0;B=x+4|0;if((B|0)==(j|0))break a;v=c[c[n>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(j|0)){o=a+12|0;m=a+16|0;p=a+28|0;k=a+32|0;x=a+20|0;w=n;do{n=qdd(a,3142592,h,e,0)|0;if(n){if((n|0)>0){n=c[m>>2]|0;v=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[k>>2]|0,c[p>>2]|0)|0)|0;q=n+v|0;c[o>>2]=q;if((v|0)>=0?(u=n+(v+4)|0,u>>>0<=(c[x>>2]|0)>>>0):0){c[w>>2]=c[q>>2];c[o>>2]=u}else Bid(o,w,4);if(c[a>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0}else{u=c[e>>2]|0;if(u)_n[u&4095](w,a)|0}sdd(a)}w=w+4|0}while((w|0)!=(j|0))}}while(0);udd(a);i=d;return}function V5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>3;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}Y6c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142290]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=k;x=p;while(1){y=(da(v,m)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(g,w);y=g;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+8)|0,B>>>0<=(c[u>>2]|0)>>>0):0){A=y;y=c[A+4>>2]|0;z=x;c[z>>2]=c[A>>2];c[z+4>>2]=y;c[q>>2]=B}else Bid(q,x,8);if(c[a>>2]&512){B=XEi(c[x>>2]|0)|0;y=x+4|0;c[x>>2]=XEi(c[y>>2]|0)|0;c[y>>2]=B}B=x+8|0;if((B|0)==(j|0))break a;v=c[c[n>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(j|0)){o=a+12|0;m=a+16|0;p=a+28|0;k=a+32|0;x=a+20|0;w=n;do{n=qdd(a,3142592,h,e,0)|0;if(n){if((n|0)>0){n=c[m>>2]|0;v=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[k>>2]|0,c[p>>2]|0)|0)|0;q=n+v|0;c[o>>2]=q;if((v|0)>=0?(u=n+(v+8)|0,u>>>0<=(c[x>>2]|0)>>>0):0){v=q;q=c[v+4>>2]|0;n=w;c[n>>2]=c[v>>2];c[n+4>>2]=q;c[o>>2]=u}else Bid(o,w,8);if(c[a>>2]&512){u=XEi(c[w>>2]|0)|0;q=w+4|0;c[w>>2]=XEi(c[q>>2]|0)|0;c[q>>2]=u}}else{u=c[e>>2]|0;if(u)_n[u&4095](w,a)|0}sdd(a)}w=w+8|0}while((w|0)!=(j|0))}}while(0);udd(a);i=d;return}function W5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>3;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}Z6c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142300]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=a+12|0;r=a+16|0;s=a+28|0;t=a+32|0;u=a+20|0;v=0;w=k;x=p;while(1){y=(da(v,m)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(g,w);y=g;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[n>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(B=z+(A+8)|0,B>>>0<=(c[u>>2]|0)>>>0):0){A=y;y=c[A+4>>2]|0;z=x;c[z>>2]=c[A>>2];c[z+4>>2]=y;c[q>>2]=B}else Bid(q,x,8);if(c[a>>2]&512){B=XEi(c[x>>2]|0)|0;y=x+4|0;c[x>>2]=XEi(c[y>>2]|0)|0;c[y>>2]=B}B=x+8|0;if((B|0)==(j|0))break a;v=c[c[n>>2]>>2]|0;w=c[l>>2]|0;x=B}}while(0);sdd(a);break}sdd(a);n=c[b>>2]|0;if((n|0)!=(j|0)){o=a+12|0;m=a+16|0;p=a+28|0;k=a+32|0;x=a+20|0;w=n;do{n=qdd(a,3142592,h,e,0)|0;if(n){if((n|0)>0){n=c[m>>2]|0;v=(c[(c[l>>2]|0)+12>>2]|0)-(da(c[k>>2]|0,c[p>>2]|0)|0)|0;q=n+v|0;c[o>>2]=q;if((v|0)>=0?(u=n+(v+8)|0,u>>>0<=(c[x>>2]|0)>>>0):0){v=q;q=c[v+4>>2]|0;n=w;c[n>>2]=c[v>>2];c[n+4>>2]=q;c[o>>2]=u}else Bid(o,w,8);if(c[a>>2]&512){u=XEi(c[w>>2]|0)|0;q=w+4|0;c[w>>2]=XEi(c[q>>2]|0)|0;c[q>>2]=u}}else{u=c[e>>2]|0;if(u)_n[u&4095](w,a)|0}sdd(a)}w=w+8|0}while((w|0)!=(j|0))}}while(0);udd(a);i=d;return}function X5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d;j=b+4|0;c[f>>2]=(c[j>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}_6c(b,c[f>>2]|0);k=c[j>>2]|0;do if(c[f>>2]|0){j=c[142268]|0;l=qdd(a,3142592,j,0,0)|0;m=a+80|0;n=c[($hd(c[m>>2]|0)|0)+12>>2]|0;o=a+84|0;c[c[o>>2]>>2]=0;if((l|0)==2){l=c[m>>2]|0;p=c[l+12>>2]|0;q=c[b>>2]|0;a:do if((q|0)!=(k|0)){r=a+12|0;s=a+16|0;t=a+28|0;u=a+32|0;v=a+20|0;w=0;x=l;y=q;while(1){z=(da(w,n)|0)+p|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(h,x);z=h;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[o>>2]|0;c[A>>2]=(c[A>>2]|0)+1;A=c[s>>2]|0;B=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;z=A+B|0;c[r>>2]=z;if((B|0)>=0?(C=A+(B+4)|0,C>>>0<=(c[v>>2]|0)>>>0):0){g[y>>2]=ea(g[z>>2]);c[r>>2]=C}else Bid(r,y,4);if(c[a>>2]&512)c[y>>2]=XEi(c[y>>2]|0)|0;C=y+4|0;if((C|0)==(k|0))break a;w=c[c[o>>2]>>2]|0;x=c[m>>2]|0;y=C}}while(0);sdd(a);break}sdd(a);o=c[b>>2]|0;if((o|0)!=(k|0)){p=a+12|0;n=a+16|0;q=a+28|0;l=a+32|0;y=a+20|0;x=o;do{o=qdd(a,3142592,j,e,0)|0;if(o){if((o|0)>0){o=c[n>>2]|0;w=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[l>>2]|0,c[q>>2]|0)|0)|0;r=o+w|0;c[p>>2]=r;if((w|0)>=0?(v=o+(w+4)|0,v>>>0<=(c[y>>2]|0)>>>0):0){g[x>>2]=ea(g[r>>2]);c[p>>2]=v}else Bid(p,x,4);if(c[a>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0}else{v=c[e>>2]|0;if(v)_n[v&4095](x,a)|0}sdd(a)}x=x+4|0}while((x|0)!=(k|0))}}while(0);udd(a);i=d;return}function Y5c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e+8|0;g=e;j=d+4|0;c[f>>2]=(c[j>>2]|0)-(c[d>>2]|0)>>3;if(!(tdd(b,2646336,2646336,f)|0)){i=e;return}$6c(d,c[f>>2]|0);l=c[j>>2]|0;a:do if(c[f>>2]|0){j=qdd(b,3142592,c[142264]|0,0,0)|0;m=b+80|0;n=c[($hd(c[m>>2]|0)|0)+12>>2]|0;o=b+84|0;c[c[o>>2]>>2]=0;if((j|0)!=2){sdd(b);j=c[d>>2]|0;if((j|0)==(l|0))break;else p=j;while(1){Y0c(b,p,3142592,0);p=p+8|0;if((p|0)==(l|0))break a}}j=c[m>>2]|0;q=c[j+12>>2]|0;r=c[d>>2]|0;b:do if((r|0)!=(l|0)){s=b+12|0;t=b+16|0;u=b+28|0;v=b+32|0;w=b+20|0;x=0;y=j;z=r;while(1){A=(da(x,n)|0)+q|0;c[y+20>>2]=A;c[y+12>>2]=A;cid(g,y);A=g;B=c[A+4>>2]|0;C=y+24|0;c[C>>2]=c[A>>2];c[C+4>>2]=B;B=c[o>>2]|0;c[B>>2]=(c[B>>2]|0)+1;B=c[t>>2]|0;C=(c[(c[m>>2]|0)+12>>2]|0)-(da(c[v>>2]|0,c[u>>2]|0)|0)|0;A=B+C|0;c[s>>2]=A;if((C|0)>=0?(B+(C+8)|0)>>>0<=(c[w>>2]|0)>>>0:0){a[k>>0]=a[A>>0];a[k+1>>0]=a[A+1>>0];a[k+2>>0]=a[A+2>>0];a[k+3>>0]=a[A+3>>0];a[k+4>>0]=a[A+4>>0];a[k+5>>0]=a[A+5>>0];a[k+6>>0]=a[A+6>>0];a[k+7>>0]=a[A+7>>0];h[k>>3]=+h[k>>3];a[z>>0]=a[k>>0];a[z+1>>0]=a[k+1>>0];a[z+2>>0]=a[k+2>>0];a[z+3>>0]=a[k+3>>0];a[z+4>>0]=a[k+4>>0];a[z+5>>0]=a[k+5>>0];a[z+6>>0]=a[k+6>>0];a[z+7>>0]=a[k+7>>0];c[s>>2]=(c[s>>2]|0)+8}else Bid(s,z,8);if(c[b>>2]&512){A=XEi(c[z>>2]|0)|0;C=z+4|0;c[z>>2]=XEi(c[C>>2]|0)|0;c[C>>2]=A}A=z+8|0;if((A|0)==(l|0))break b;x=c[c[o>>2]>>2]|0;y=c[m>>2]|0;z=A}}while(0);sdd(b)}while(0);udd(b);i=e;return}function Z5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/292|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}a7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,2394192,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;$3c(r,a);t=r+292|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,2394192,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else $3c(m,a);sdd(a)}m=m+292|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function _5c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d+4|0;c[f>>2]=((c[h>>2]|0)-(c[d>>2]|0)|0)/12|0;if(!(tdd(b,2646336,2646336,f)|0)){i=e;return}b7c(d,c[f>>2]|0);j=c[h>>2]|0;a:do if(c[f>>2]|0){h=c[d>>2]|0;k=c[h+4>>2]|0;if(!k)l=614344;else{m=c[h+8>>2]|0;a[k>>0]=80;a[k+1>>0]=80;a[k+2>>0]=116;a[k+3>>0]=114;a[k+4>>0]=60;h=k+6|0;a[k+5>>0]=36;n=ksc(m)|0;m=a[n>>0]|0;if(!(m<<24>>24))o=h;else{p=m;m=h;h=n;while(1){a[m>>0]=p;n=m+1|0;h=h+1|0;p=a[h>>0]|0;if(!(p<<24>>24)){o=n;break}else m=n}}a[o>>0]=62;a[o+1>>0]=0;l=k}m=qdd(b,3142592,l,0,1)|0;p=b+80|0;h=c[($hd(c[p>>2]|0)|0)+12>>2]|0;n=b+84|0;c[c[n>>2]>>2]=0;if((m|0)!=2){sdd(b);m=c[d>>2]|0;if((m|0)==(j|0))break;else q=m;while(1){_0c(b,q,3142592,0);q=q+12|0;if((q|0)==(j|0))break a}}k=c[p>>2]|0;m=c[k+12>>2]|0;r=c[d>>2]|0;b:do if((r|0)!=(j|0)){s=0;t=k;u=r;while(1){v=(da(s,h)|0)+m|0;c[t+20>>2]=v;c[t+12>>2]=v;cid(g,t);v=g;w=c[v+4>>2]|0;x=t+24|0;c[x>>2]=c[v>>2];c[x+4>>2]=w;w=c[n>>2]|0;c[w>>2]=(c[w>>2]|0)+1;dyc(u,b);w=u+12|0;if((w|0)==(j|0))break b;s=c[c[n>>2]>>2]|0;t=c[p>>2]|0;u=w}}while(0);sdd(b)}while(0);udd(b);i=e;return}function $5c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/12|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}c7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142294]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;cVb(a,s,1);u=s+12|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,0)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else cVb(a,n,1);sdd(a)}n=n+12|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function a6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/12|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}d7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142310]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;_6b(s,a);u=s+12|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else _6b(n,a);sdd(a)}n=n+12|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function b6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>3;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}e7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142308]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;hgc(s,a);u=s+8|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else hgc(n,a);sdd(a)}n=n+8|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function c6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}f7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142312]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;igc(s,a);u=s+16|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else igc(n,a);sdd(a)}n=n+16|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function d6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}g7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142280]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;a1c(s,a);u=s+16|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else a1c(n,a);sdd(a)}n=n+16|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function e6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}h7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142278]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;vHc(s,a);u=s+16|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else vHc(n,a);sdd(a)}n=n+16|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function f6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>6;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}i7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,614736,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;cgc(r,a);t=r+64|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,614736,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else cgc(m,a);sdd(a)}m=m+64|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function g6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/24|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}j7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,614728,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;_cc(r,a);t=r+24|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,614728,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else _cc(m,a);sdd(a)}m=m+24|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function h6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142262]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;HYb(s,a);u=s+16|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else HYb(n,a);sdd(a)}n=n+16|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function i6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}l7c(b,c[f>>2]|0);j=c[h>>2]|0;a:do if(c[f>>2]|0){h=qdd(a,3142592,c[142262]|0,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)!=2){sdd(a);h=c[b>>2]|0;if((h|0)==(j|0))break;else n=h;while(1){jkc(a,n,3142592,0);n=n+4|0;if((n|0)==(j|0))break a}}h=c[k>>2]|0;o=c[h+12>>2]|0;p=c[b>>2]|0;b:do if((p|0)!=(j|0)){q=c[142304]|0;r=a+12|0;s=a+16|0;t=a+28|0;u=a+32|0;v=a+20|0;w=0;x=h;y=p;while(1){z=(da(w,l)|0)+o|0;c[x+20>>2]=z;c[x+12>>2]=z;cid(g,x);z=g;A=c[z+4>>2]|0;B=x+24|0;c[B>>2]=c[z>>2];c[B+4>>2]=A;A=c[m>>2]|0;c[A>>2]=(c[A>>2]|0)+1;rdd(a,2);A=(c[a>>2]&512|0)==0;B=qdd(a,614656,q,e,0)|0;if(B){if((B|0)>0){B=c[s>>2]|0;z=(c[(c[k>>2]|0)+12>>2]|0)-(da(c[u>>2]|0,c[t>>2]|0)|0)|0;C=B+z|0;c[r>>2]=C;if((z|0)>=0?(D=B+(z+4)|0,D>>>0<=(c[v>>2]|0)>>>0):0){c[y>>2]=c[C>>2];c[r>>2]=D}else Bid(r,y,4);if(c[a>>2]&512)c[y>>2]=XEi(c[y>>2]|0)|0}else{D=c[e>>2]|0;if(D)_n[D&4095](y,a)|0}sdd(a)}if(!A)c[y>>2]=XEi(c[y>>2]|0)|0;A=y+4|0;if((A|0)==(j|0))break b;w=c[c[m>>2]>>2]|0;x=c[k>>2]|0;y=A}}while(0);sdd(a)}while(0);udd(a);i=d;return}function j6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}m7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,614712,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;b1c(r,a);t=r+4|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,614712,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else b1c(m,a);sdd(a)}m=m+4|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function k6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/80|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}n7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,2470664,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;a4c(r,a);t=r+80|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,2470664,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else a4c(m,a);sdd(a)}m=m+80|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function l6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/68|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}o7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,614696,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;PLc(r,a);t=r+68|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,614696,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else PLc(m,a);sdd(a)}m=m+68|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function m6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>4;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}p7c(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,2390464,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;b4c(r,a);t=r+16|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,2390464,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else b4c(m,a);sdd(a)}m=m+16|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function n6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,2387736,614680,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else g9b(a,b);sdd(b)}f=a+4|0;a=qdd(b,614568,c[142262]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else HYb(f,b);sdd(b);i=d;return}function o6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function p6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=b+8|0;c[f>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;c[g>>2]=c[a+8>>2];c[e+0>>2]=c[g+0>>2];h5c(b,k,e);k=(c[b>>2]|0)+(c[j>>2]<<4)|0;do if(c[f>>2]|0){j=qdd(a,3142592,2469920,0,1)|0;g=a+80|0;l=c[($hd(c[g>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((j|0)==2){j=c[g>>2]|0;n=c[j+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(k|0)){p=0;q=j;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(h,q);s=h;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;u7c(r,a);t=r+16|0;if((t|0)==(k|0))break a;p=c[c[m>>2]>>2]|0;q=c[g>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);g=c[b>>2]|0;if((g|0)!=(k|0)){m=g;do{g=qdd(a,3142592,2469920,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](m,a)|0}else u7c(m,a);sdd(a)}m=m+16|0}while((m|0)!=(k|0))}}while(0);udd(a);i=d;return}function q6c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=a+12|0;k=a+48|0;l=c[j>>2]|0;m=l+4|0;n=a+20|0;a=c[n>>2]|0;o=m>>>0>a>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=a}a=XEi(p|0)|0;c[g>>2]=a;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=a}a=XEi(t|0)|0;c[f>>2]=a;zid(j,a,u<<1)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;S6c(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;d=h+2|0;if(d>>>0>(c[n>>2]|0)>>>0){Bid(j,w,2);x=b[w>>1]|0}else{v=b[h>>1]|0;b[w>>1]=v;c[j>>2]=d;x=v}v=x&65535;b[w>>1]=v<<8|v>>>8;w=w+2|0}while((w|0)!=(o|0));i=e;return}function r6c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+12|0;k=b+48|0;l=c[j>>2]|0;m=l+4|0;n=b+20|0;b=c[n>>2]|0;o=m>>>0>b>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=b}b=XEi(p|0)|0;c[g>>2]=b;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=b}b=XEi(t|0)|0;c[f>>2]=b;zid(j,b,u)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;T6c(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;if((h+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(j,w,1);else{a[w>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}w=w+1|0}while((w|0)!=(o|0));i=e;return}function s6c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+12|0;k=b+48|0;l=c[j>>2]|0;m=l+4|0;n=b+20|0;b=c[n>>2]|0;o=m>>>0>b>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=b}b=XEi(p|0)|0;c[g>>2]=b;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=b}b=XEi(t|0)|0;c[f>>2]=b;zid(j,b,u)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;U6c(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;if((h+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(j,w,1);else{a[w>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}w=w+1|0}while((w|0)!=(o|0));i=e;return}function t6c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=a+12|0;k=a+48|0;l=c[j>>2]|0;m=l+4|0;n=a+20|0;a=c[n>>2]|0;o=m>>>0>a>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=a}a=XEi(p|0)|0;c[g>>2]=a;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=a}a=XEi(t|0)|0;c[f>>2]=a;zid(j,a,u<<1)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;V6c(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;d=h+2|0;if(d>>>0>(c[n>>2]|0)>>>0){Bid(j,w,2);x=b[w>>1]|0}else{v=b[h>>1]|0;b[w>>1]=v;c[j>>2]=d;x=v}v=x&65535;b[w>>1]=v<<8|v>>>8;w=w+2|0}while((w|0)!=(o|0));i=e;return}function u6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<2)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;W6c(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,4);w=c[v>>2]|0}else{u=c[g>>2]|0;c[v>>2]=u;c[h>>2]=b;w=u}c[v>>2]=XEi(w|0)|0;v=v+4|0}while((v|0)!=(n|0));i=d;return}function v6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<2)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;X6c(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,4);w=c[v>>2]|0}else{u=c[g>>2]|0;c[v>>2]=u;c[h>>2]=b;w=u}c[v>>2]=XEi(w|0)|0;v=v+4|0}while((v|0)!=(n|0));i=d;return}function w6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<3)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;Y6c(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+8|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,8);u=v+4|0;w=v;x=u;y=c[v>>2]|0;z=c[u>>2]|0}else{u=g;g=c[u>>2]|0;l=c[u+4>>2]|0;u=v;c[u>>2]=g;c[u+4>>2]=l;c[h>>2]=b;w=v;x=v+4|0;y=g;z=l}l=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=l;v=v+8|0}while((v|0)!=(n|0));i=d;return}function x6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<3)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;Z6c(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+8|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,8);u=v+4|0;w=v;x=u;y=c[v>>2]|0;z=c[u>>2]|0}else{u=g;g=c[u>>2]|0;l=c[u+4>>2]|0;u=v;c[u>>2]=g;c[u+4>>2]=l;c[h>>2]=b;w=v;x=v+4|0;y=g;z=l}l=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=l;v=v+8|0}while((v|0)!=(n|0));i=d;return}function y6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im;d=i;i=i+16|0;e=d+8|0;f=d+4|0;h=d;j=a+12|0;l=a+48|0;m=c[j>>2]|0;n=m+4|0;o=a+20|0;a=c[o>>2]|0;p=n>>>0>a>>>0;if(c[l>>2]|0){if(p){Bid(j,f,4);q=c[f>>2]|0;r=c[j>>2]|0;s=c[o>>2]|0}else{t=c[m>>2]|0;c[f>>2]=t;c[j>>2]=n;q=t;r=n;s=a}a=XEi(q|0)|0;c[f>>2]=a;q=r+4|0;if(q>>>0>s>>>0){Bid(j,e,4);u=c[e>>2]|0;v=c[f>>2]|0}else{f=c[r>>2]|0;c[e>>2]=f;c[j>>2]=q;u=f;v=a}a=XEi(u|0)|0;c[e>>2]=a;zid(j,a,v<<2)|0;c[l>>2]=0;i=d;return}if(p){Bid(j,h,4);w=c[h>>2]|0}else{p=c[m>>2]|0;c[h>>2]=p;c[j>>2]=n;w=p}p=XEi(w|0)|0;c[h>>2]=p;_6c(b,p);p=c[b+4>>2]|0;h=c[b>>2]|0;if((h|0)==(p|0)){i=d;return}else x=h;do{h=c[j>>2]|0;b=h+4|0;if(b>>>0>(c[o>>2]|0)>>>0){Bid(j,x,4);y=x;z=c[x>>2]|0}else{A=ea(g[h>>2]);g[x>>2]=A;c[j>>2]=b;y=x;z=(g[k>>2]=A,c[k>>2]|0)}c[y>>2]=XEi(z|0)|0;x=x+4|0}while((x|0)!=(p|0));i=d;return}function z6c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;l=b+12|0;m=b+48|0;n=c[l>>2]|0;o=n+4|0;p=b+20|0;b=c[p>>2]|0;q=o>>>0>b>>>0;if(c[m>>2]|0){if(q){Bid(l,g,4);r=c[g>>2]|0;s=c[l>>2]|0;t=c[p>>2]|0}else{u=c[n>>2]|0;c[g>>2]=u;c[l>>2]=o;r=u;s=o;t=b}b=XEi(r|0)|0;c[g>>2]=b;r=s+4|0;if(r>>>0>t>>>0){Bid(l,f,4);v=c[f>>2]|0;w=c[g>>2]|0}else{g=c[s>>2]|0;c[f>>2]=g;c[l>>2]=r;v=g;w=b}b=XEi(v|0)|0;c[f>>2]=b;zid(l,b,w<<3)|0;c[m>>2]=0;i=e;return}if(q){Bid(l,j,4);x=c[j>>2]|0}else{q=c[n>>2]|0;c[j>>2]=q;c[l>>2]=o;x=q}q=XEi(x|0)|0;c[j>>2]=q;$6c(d,q);q=c[d+4>>2]|0;j=c[d>>2]|0;if((j|0)==(q|0)){i=e;return}else y=j;do{j=c[l>>2]|0;if((j+8|0)>>>0>(c[p>>2]|0)>>>0){Bid(l,y,8);d=y+4|0;z=y;A=d;B=c[y>>2]|0;C=c[d>>2]|0}else{a[k>>0]=a[j>>0];a[k+1>>0]=a[j+1>>0];a[k+2>>0]=a[j+2>>0];a[k+3>>0]=a[j+3>>0];a[k+4>>0]=a[j+4>>0];a[k+5>>0]=a[j+5>>0];a[k+6>>0]=a[j+6>>0];a[k+7>>0]=a[j+7>>0];D=+h[k>>3];h[k>>3]=D;a[y>>0]=a[k>>0];a[y+1>>0]=a[k+1>>0];a[y+2>>0]=a[k+2>>0];a[y+3>>0]=a[k+3>>0];a[y+4>>0]=a[k+4>>0];a[y+5>>0]=a[k+5>>0];a[y+6>>0]=a[k+6>>0];a[y+7>>0]=a[k+7>>0];c[l>>2]=(c[l>>2]|0)+8;h[k>>3]=D;z=y;A=y+4|0;B=c[k>>2]|0;C=c[k+4>>2]|0}j=XEi(B|0)|0;c[z>>2]=XEi(C|0)|0;c[A>>2]=j;y=y+8|0}while((y|0)!=(q|0));i=e;return}function A6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;a7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{D4c(r,a);r=r+292|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*292|0)|0;c[j>>2]=0;i=d;return}function B6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;b7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{Vxc(r,a);r=r+12|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*12|0)|0;c[j>>2]=0;i=d;return}function C6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;c7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{gVb(a,r,1);Mdd(a);r=r+12|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*12|0)|0;c[j>>2]=0;i=d;return}function D6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;h=d;j=a+12|0;l=a+48|0;m=c[j>>2]|0;n=m+4|0;o=a+20|0;a=c[o>>2]|0;p=n>>>0>a>>>0;if(c[l>>2]|0){if(p){Bid(j,f,4);q=c[f>>2]|0;r=c[j>>2]|0;s=c[o>>2]|0}else{t=c[m>>2]|0;c[f>>2]=t;c[j>>2]=n;q=t;r=n;s=a}a=XEi(q|0)|0;c[f>>2]=a;q=r+4|0;if(q>>>0>s>>>0){Bid(j,e,4);u=c[e>>2]|0;v=c[f>>2]|0}else{f=c[r>>2]|0;c[e>>2]=f;c[j>>2]=q;u=f;v=a}a=XEi(u|0)|0;c[e>>2]=a;zid(j,a,v*12|0)|0;c[l>>2]=0;i=d;return}if(p){Bid(j,h,4);w=c[h>>2]|0}else{p=c[m>>2]|0;c[h>>2]=p;c[j>>2]=n;w=p}p=XEi(w|0)|0;c[h>>2]=p;d7c(b,p);p=c[b+4>>2]|0;h=c[b>>2]|0;if((h|0)==(p|0)){i=d;return}else x=h;do{h=c[j>>2]|0;b=h+4|0;w=c[o>>2]|0;if(b>>>0>w>>>0){Bid(j,x,4);y=x;z=c[x>>2]|0;A=c[j>>2]|0;B=c[o>>2]|0}else{C=ea(g[h>>2]);g[x>>2]=C;c[j>>2]=b;y=x;z=(g[k>>2]=C,c[k>>2]|0);A=b;B=w}c[y>>2]=XEi(z|0)|0;w=x+4|0;b=A+4|0;if(b>>>0>B>>>0){Bid(j,w,4);D=w;E=c[w>>2]|0;F=c[j>>2]|0;G=c[o>>2]|0}else{C=ea(g[A>>2]);g[w>>2]=C;c[j>>2]=b;D=w;E=(g[k>>2]=C,c[k>>2]|0);F=b;G=B}c[D>>2]=XEi(E|0)|0;b=x+8|0;w=F+4|0;if(w>>>0>G>>>0){Bid(j,b,4);H=b;I=c[b>>2]|0}else{C=ea(g[F>>2]);g[b>>2]=C;c[j>>2]=w;H=b;I=(g[k>>2]=C,c[k>>2]|0)}c[H>>2]=XEi(I|0)|0;x=x+12|0}while((x|0)!=(p|0));i=d;return}function E6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;h=d;j=a+12|0;l=a+48|0;m=c[j>>2]|0;n=m+4|0;o=a+20|0;a=c[o>>2]|0;p=n>>>0>a>>>0;if(c[l>>2]|0){if(p){Bid(j,f,4);q=c[f>>2]|0;r=c[j>>2]|0;s=c[o>>2]|0}else{t=c[m>>2]|0;c[f>>2]=t;c[j>>2]=n;q=t;r=n;s=a}a=XEi(q|0)|0;c[f>>2]=a;q=r+4|0;if(q>>>0>s>>>0){Bid(j,e,4);u=c[e>>2]|0;v=c[f>>2]|0}else{f=c[r>>2]|0;c[e>>2]=f;c[j>>2]=q;u=f;v=a}a=XEi(u|0)|0;c[e>>2]=a;zid(j,a,v<<3)|0;c[l>>2]=0;i=d;return}if(p){Bid(j,h,4);w=c[h>>2]|0}else{p=c[m>>2]|0;c[h>>2]=p;c[j>>2]=n;w=p}p=XEi(w|0)|0;c[h>>2]=p;e7c(b,p);p=c[b+4>>2]|0;h=c[b>>2]|0;if((h|0)==(p|0)){i=d;return}else x=h;do{h=c[j>>2]|0;b=h+4|0;w=c[o>>2]|0;if(b>>>0>w>>>0){Bid(j,x,4);y=x;z=c[x>>2]|0;A=c[j>>2]|0;B=c[o>>2]|0}else{C=ea(g[h>>2]);g[x>>2]=C;c[j>>2]=b;y=x;z=(g[k>>2]=C,c[k>>2]|0);A=b;B=w}c[y>>2]=XEi(z|0)|0;w=x+4|0;b=A+4|0;if(b>>>0>B>>>0){Bid(j,w,4);D=w;E=c[w>>2]|0}else{C=ea(g[A>>2]);g[w>>2]=C;c[j>>2]=b;D=w;E=(g[k>>2]=C,c[k>>2]|0)}c[D>>2]=XEi(E|0)|0;x=x+8|0}while((x|0)!=(p|0));i=d;return}function F6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;f7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{ojc(r,a);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function G6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;g7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{NYb(r,a);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function H6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;h7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{BHc(r,a);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function I6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;i7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{xgc(r,a);r=r+64|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<6)|0;c[j>>2]=0;i=d;return}function J6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;j7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{gdc(r,a);r=r+24|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*24|0)|0;c[j>>2]=0;i=d;return}function K6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;k7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{MYb(r,a);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function L6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<2)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;l7c(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,4);w=c[v>>2]|0}else{u=c[g>>2]|0;c[v>>2]=u;c[h>>2]=b;w=u}c[v>>2]=w;v=v+4|0}while((v|0)!=(n|0));i=d;return}function M6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<2)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;m7c(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,4);w=c[v>>2]|0}else{u=c[g>>2]|0;c[v>>2]=u;c[h>>2]=b;w=u}c[v>>2]=XEi(w|0)|0;v=v+4|0}while((v|0)!=(n|0));i=d;return}function N6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{s=c[k>>2]|0;c[f>>2]=s;c[h>>2]=l;p=s;q=l;r=n}n=XEi(p|0)|0;c[f>>2]=n;p=q+4|0;if(p>>>0>r>>>0){Bid(h,e,4);t=c[e>>2]|0;u=c[f>>2]|0}else{f=c[q>>2]|0;c[e>>2]=f;c[h>>2]=p;t=f;u=n}n=XEi(t|0)|0;c[e>>2]=n;zid(h,n,u*80|0)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);v=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;v=o}o=XEi(v|0)|0;c[g>>2]=o;n7c(b,o);o=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(o|0)){i=d;return}else w=g;do{E4c(a,w+56|0,0);g=w+72|0;b=c[h>>2]|0;v=b+4|0;l=c[m>>2]|0;if(v>>>0>l>>>0){Bid(h,g,4);x=c[g>>2]|0;y=c[h>>2]|0;z=c[m>>2]|0}else{k=c[b>>2]|0;c[g>>2]=k;c[h>>2]=v;x=k;y=v;z=l}c[g>>2]=XEi(x|0)|0;g=w+76|0;l=y+4|0;if(l>>>0>z>>>0){Bid(h,g,4);A=c[g>>2]|0}else{v=c[y>>2]|0;c[g>>2]=v;c[h>>2]=l;A=v}c[g>>2]=XEi(A|0)|0;SMc(w);w=w+80|0}while((w|0)!=(o|0));i=d;return}function O6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;o7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{RLc(r,a);r=r+68|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*68|0)|0;c[j>>2]=0;i=d;return}function P6c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;p7c(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{K1c(r,a);r=r+16|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<4)|0;c[j>>2]=0;i=d;return}function Q6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function R6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;a=w+4|0;if(a>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=XEi(z|0)|0;c[y>>2]=A;i=d;return}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=a;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=XEi(z|0)|0;c[y>>2]=A;i=d;return}}function S6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>1;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<1);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];w7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-2-o|0)>>>1)<<1);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>1|0)==(b|0)){RHc(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<1,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>1)<<1)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<1),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];v7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>1;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<1)|0,(l|0)!=(g|0)):0){h=l+(~((l+-2-g|0)>>>1)<<1)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{RHc(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-2-p|0)>>>1)<<1);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function T6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+b;c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];y7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=o;c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s|0)==(b|0)){i5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b,16,e,0,3653512,80)|0,p=c[j>>2]|0,r=(c[t>>2]|0)-p|0,u=h+(0-r)|0,YEi(u|0,p|0,r|0)|0,r=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+b,(r|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(r,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];x7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;r=l-k|0;if(r>>>0>=b>>>0)if(r>>>0>b>>>0?(g=k+b|0,(l|0)!=(g|0)):0){c[t>>2]=g;v=k;w=g}else{v=k;w=l}else{i5c(j,b-r|0);v=c[j>>2]|0;w=c[t>>2]|0}r=c[a>>2]|0;c[j>>2]=r;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!r){i=d;return}if((v|0)!=(r|0))c[t>>2]=r;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function U6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+b;c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];A7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=o;c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s|0)==(b|0)){j5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b,16,e,0,3653512,80)|0,p=c[j>>2]|0,r=(c[t>>2]|0)-p|0,u=h+(0-r)|0,YEi(u|0,p|0,r|0)|0,r=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+b,(r|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(r,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];z7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;r=l-k|0;if(r>>>0>=b>>>0)if(r>>>0>b>>>0?(g=k+b|0,(l|0)!=(g|0)):0){c[t>>2]=g;v=k;w=g}else{v=k;w=l}else{j5c(j,b-r|0);v=c[j>>2]|0;w=c[t>>2]|0}r=c[a>>2]|0;c[j>>2]=r;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!r){i=d;return}if((v|0)!=(r|0))c[t>>2]=r;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function V6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>1;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<1);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];C7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-2-o|0)>>>1)<<1);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>1|0)==(b|0)){k5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<1,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>1)<<1)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<1),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];B7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>1;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<1)|0,(l|0)!=(g|0)):0){h=l+(~((l+-2-g|0)>>>1)<<1)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{k5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-2-p|0)>>>1)<<1);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function W6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>2;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<2);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];E7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>2|0)==(b|0)){l5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<2,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>2)<<2)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<2),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];D7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>2;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<2)|0,(l|0)!=(g|0)):0){h=l+(~((l+-4-g|0)>>>2)<<2)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{l5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-4-p|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function X6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>2;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<2);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];F7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>2|0)==(b|0)){Qec(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<2,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>2)<<2)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<2),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];SHc(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>2;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<2)|0,(l|0)!=(g|0)):0){h=l+(~((l+-4-g|0)>>>2)<<2)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{Qec(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-4-p|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function Y6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>3;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<3);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];H7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>3|0)==(b|0)){m5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<3,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>3)<<3)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<3),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];G7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>3;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<3)|0,(l|0)!=(g|0)):0){h=l+(~((l+-8-g|0)>>>3)<<3)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{m5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-8-p|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function Z6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>3;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<3);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];J7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>3|0)==(b|0)){n5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<3,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>3)<<3)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<3),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];I7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>3;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<3)|0,(l|0)!=(g|0)):0){h=l+(~((l+-8-g|0)>>>3)<<3)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{n5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-8-p|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function _6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>2;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<2);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];L7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>2|0)==(b|0)){o5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<2,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>2)<<2)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<2),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];K7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>2;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<2)|0,(l|0)!=(g|0)):0){h=l+(~((l+-4-g|0)>>>2)<<2)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{o5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-4-p|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function $6c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>3;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<3);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];N7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>3|0)==(b|0)){p5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<3,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>3)<<3)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<3),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];M7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>3;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<3)|0,(l|0)!=(g|0)):0){h=l+(~((l+-8-g|0)>>>3)<<3)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{p5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-8-p|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function a7c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+52|0;j=e;k=e+48|0;l=e+56|0;m=e+4|0;n=e+40|0;o=e+36|0;p=e+16|0;q=e+28|0;r=e+44|0;s=e+64|0;t=b+4|0;u=c[b>>2]|0;v=u;w=((c[t>>2]|0)-v|0)/292|0;if(w>>>0>=d>>>0){if(w>>>0<=d>>>0){i=e;return}c[q>>2]=u;c[r>>2]=u+(d*292|0);c[g+0>>2]=c[q+0>>2];c[f+0>>2]=c[r+0>>2];Q7c(p,g,f,s,0);s=c[p>>2]|0;r=c[b>>2]|0;c[p>>2]=r;c[b>>2]=s;s=p+4|0;q=c[s>>2]|0;u=c[t>>2]|0;c[s>>2]=u;c[t>>2]=q;q=p+8|0;x=b+8|0;y=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=y;if(!r){i=e;return}if((u|0)==(r|0))z=r;else{y=u;while(1){u=y+-292|0;c[s>>2]=u;if(!(a[u>>0]&1))A=u;else{u=c[y+-284>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(u,f);A=c[s>>2]|0}if((A|0)==(r|0))break;else y=A}z=c[p>>2]|0}c[l>>2]=89;c[f+0>>2]=c[l+0>>2];eOb(z,f);i=e;return}z=b+8|0;if((((c[z>>2]|0)-v|0)/292|0|0)==(d|0)){q7c(b,d-w|0);i=e;return}c[m>>2]=0;w=m+4|0;c[w>>2]=0;v=m+8|0;c[v>>2]=0;O7c(m,d);c[n>>2]=c[b>>2];c[o>>2]=c[t>>2];c[g+0>>2]=c[n+0>>2];c[f+0>>2]=c[o+0>>2];P7c(m,g,f);o=c[w>>2]|0;n=c[m>>2]|0;l=(o-n|0)/292|0;if(l>>>0>=d>>>0)if(l>>>0>d>>>0?(p=n+(d*292|0)|0,(o|0)!=(p|0)):0){n=o;while(1){A=n+-292|0;c[w>>2]=A;if(!(a[A>>0]&1))B=A;else{A=c[n+-284>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(A,f);B=c[w>>2]|0}if((B|0)==(p|0)){C=p;break}else n=B}}else C=o;else{q7c(m,d-l|0);C=c[w>>2]|0}l=c[m>>2]|0;d=c[b>>2]|0;c[m>>2]=d;c[b>>2]=l;l=c[t>>2]|0;c[w>>2]=l;c[t>>2]=C;C=c[v>>2]|0;c[v>>2]=c[z>>2];c[z>>2]=C;if(!d){i=e;return}if((l|0)==(d|0))D=d;else{C=l;while(1){l=C+-292|0;c[w>>2]=l;if(!(a[l>>0]&1))E=l;else{l=c[C+-284>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);E=c[w>>2]|0}if((E|0)==(d|0))break;else C=E}D=c[m>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(D,f);i=e;return}function b7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=((c[p>>2]|0)-r|0)/12|0;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b*12|0);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];T7c(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;l=a+8|0;t=c[m>>2]|0;c[m>>2]=c[l>>2];c[l>>2]=t;if(!n){i=d;return}if((q|0)!=(n|0))c[o>>2]=q+(~(((q+-12-n|0)>>>0)/12|0)*12|0);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(n,e);i=d;return}n=a+8|0;if((((c[n>>2]|0)-r|0)/12|0|0)==(b|0)){r5c(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;R7c(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];S7c(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=(k-j|0)/12|0;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(q=j+(b*12|0)|0,(k|0)!=(q|0)):0){o=k+(~(((k+-12-q|0)>>>0)/12|0)*12|0)|0;c[s>>2]=o;u=j;v=o}else{u=j;v=k}else{r5c(h,b-g|0);u=c[h>>2]|0;v=c[s>>2]|0}g=c[a>>2]|0;c[h>>2]=g;c[a>>2]=u;u=c[p>>2]|0;c[s>>2]=u;c[p>>2]=v;v=c[r>>2]|0;c[r>>2]=c[n>>2];c[n>>2]=v;if(!g){i=d;return}if((u|0)!=(g|0))c[s>>2]=u+(~(((u+-12-g|0)>>>0)/12|0)*12|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function c7c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+52|0;j=e;k=e+48|0;l=e+56|0;m=e+4|0;n=e+40|0;o=e+36|0;p=e+16|0;q=e+28|0;r=e+44|0;s=e+64|0;t=b+4|0;u=c[b>>2]|0;v=u;w=((c[t>>2]|0)-v|0)/12|0;if(w>>>0>=d>>>0){if(w>>>0<=d>>>0){i=e;return}c[q>>2]=u;c[r>>2]=u+(d*12|0);c[g+0>>2]=c[q+0>>2];c[f+0>>2]=c[r+0>>2];W7c(p,g,f,s,0);s=c[p>>2]|0;r=c[b>>2]|0;c[p>>2]=r;c[b>>2]=s;s=p+4|0;q=c[s>>2]|0;u=c[t>>2]|0;c[s>>2]=u;c[t>>2]=q;q=p+8|0;x=b+8|0;y=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=y;if(!r){i=e;return}if((u|0)==(r|0))z=r;else{y=u;while(1){u=y+-12|0;c[s>>2]=u;if(!(a[u>>0]&1))A=u;else{u=c[y+-4>>2]|0;c[k>>2]=89;c[f+0>>2]=c[k+0>>2];eOb(u,f);A=c[s>>2]|0}if((A|0)==(r|0))break;else y=A}z=c[p>>2]|0}c[l>>2]=89;c[f+0>>2]=c[l+0>>2];eOb(z,f);i=e;return}z=b+8|0;if((((c[z>>2]|0)-v|0)/12|0|0)==(d|0)){r7c(b,d-w|0);i=e;return}c[m>>2]=0;w=m+4|0;c[w>>2]=0;v=m+8|0;c[v>>2]=0;U7c(m,d);c[n>>2]=c[b>>2];c[o>>2]=c[t>>2];c[g+0>>2]=c[n+0>>2];c[f+0>>2]=c[o+0>>2];V7c(m,g,f);o=c[w>>2]|0;n=c[m>>2]|0;l=(o-n|0)/12|0;if(l>>>0>=d>>>0)if(l>>>0>d>>>0?(p=n+(d*12|0)|0,(o|0)!=(p|0)):0){n=o;while(1){A=n+-12|0;c[w>>2]=A;if(!(a[A>>0]&1))B=A;else{A=c[n+-4>>2]|0;c[j>>2]=89;c[f+0>>2]=c[j+0>>2];eOb(A,f);B=c[w>>2]|0}if((B|0)==(p|0)){C=p;break}else n=B}}else C=o;else{r7c(m,d-l|0);C=c[w>>2]|0}l=c[m>>2]|0;d=c[b>>2]|0;c[m>>2]=d;c[b>>2]=l;l=c[t>>2]|0;c[w>>2]=l;c[t>>2]=C;C=c[v>>2]|0;c[v>>2]=c[z>>2];c[z>>2]=C;if(!d){i=e;return}if((l|0)==(d|0))D=d;else{C=l;while(1){l=C+-12|0;c[w>>2]=l;if(!(a[l>>0]&1))E=l;else{l=c[C+-4>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(l,f);E=c[w>>2]|0}if((E|0)==(d|0))break;else C=E}D=c[m>>2]|0}c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(D,f);i=e;return}function d7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=((c[q>>2]|0)-s|0)/12|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b*12|0);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];Y7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~(((r+-12-o|0)>>>0)/12|0)*12|0);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if((((c[o>>2]|0)-s|0)/12|0|0)==(b|0)){t5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b*12|0,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(((p|0)/-12|0)*12|0)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b*12|0),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];X7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=(l-k|0)/12|0;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b*12|0)|0,(l|0)!=(g|0)):0){h=l+(~(((l+-12-g|0)>>>0)/12|0)*12|0)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{t5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~(((v+-12-p|0)>>>0)/12|0)*12|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function e7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>3;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<3);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];_7c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>3|0)==(b|0)){v5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<3,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>3)<<3)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<3),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];Z7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>3;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<3)|0,(l|0)!=(g|0)):0){h=l+(~((l+-8-g|0)>>>3)<<3)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{v5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-8-p|0)>>>3)<<3);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function f7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>4;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<4);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];a8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>4|0)==(b|0)){w5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<4,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>4)<<4)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<4),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];$7c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>4;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<4)|0,(l|0)!=(g|0)):0){h=l+(~((l+-16-g|0)>>>4)<<4)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{w5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-16-p|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function g7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>4;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<4);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];c8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>4|0)==(b|0)){x5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<4,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>4)<<4)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<4),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];b8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>4;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<4)|0,(l|0)!=(g|0)):0){h=l+(~((l+-16-g|0)>>>4)<<4)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{x5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-16-p|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function h7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>4;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<4);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];e8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>4|0)==(b|0)){y5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<4,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>4)<<4)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<4),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];d8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>4;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<4)|0,(l|0)!=(g|0)):0){h=l+(~((l+-16-g|0)>>>4)<<4)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{y5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-16-p|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function i7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>6;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<6);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];g8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-64-o|0)>>>6)<<6);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>6|0)==(b|0)){z5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<6,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>6)<<6)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<6),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];f8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>6;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<6)|0,(l|0)!=(g|0)):0){h=l+(~((l+-64-g|0)>>>6)<<6)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{z5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-64-p|0)>>>6)<<6);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function j7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=((c[q>>2]|0)-s|0)/24|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b*24|0);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];i8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~(((r+-24-o|0)>>>0)/24|0)*24|0);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if((((c[o>>2]|0)-s|0)/24|0|0)==(b|0)){A5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b*24|0,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(((p|0)/-24|0)*24|0)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b*24|0),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];h8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=(l-k|0)/24|0;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b*24|0)|0,(l|0)!=(g|0)):0){h=l+(~(((l+-24-g|0)>>>0)/24|0)*24|0)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{A5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~(((v+-24-p|0)>>>0)/24|0)*24|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function k7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>4;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<4);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];k8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>4|0)==(b|0)){B5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<4,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>4)<<4)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<4),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];j8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>4;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<4)|0,(l|0)!=(g|0)):0){h=l+(~((l+-16-g|0)>>>4)<<4)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{B5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-16-p|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function l7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>2;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<2);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];m8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>2|0)==(b|0)){C5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<2,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>2)<<2)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<2),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];l8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>2;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<2)|0,(l|0)!=(g|0)):0){h=l+(~((l+-4-g|0)>>>2)<<2)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{C5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-4-p|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function m7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>2;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<2);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];o8c(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>2|0)==(b|0)){D5c(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b<<2,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>2)<<2)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<2),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];n8c(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>2;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<2)|0,(l|0)!=(g|0)):0){h=l+(~((l+-4-g|0)>>>2)<<2)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{D5c(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-4-p|0)>>>2)<<2);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function n7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=((c[p>>2]|0)-r|0)/80|0;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b*80|0);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];r8c(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;t=a+8|0;u=c[m>>2]|0;c[m>>2]=c[t>>2];c[t>>2]=u;if(!n){i=d;return}if((q|0)==(n|0))v=n;else{u=q;while(1){q=u+-80|0;c[o>>2]=q;if((c[u+-12>>2]|0)>-1){t=u+-24|0;m=c[t>>2]|0;c[f>>2]=c[u+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(m,e);c[t>>2]=0;w=c[o>>2]|0}else w=q;if((w|0)==(n|0))break;else u=w}v=c[l>>2]|0}c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(v,e);i=d;return}v=a+8|0;if((((c[v>>2]|0)-r|0)/80|0|0)==(b|0)){s7c(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;p8c(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];q8c(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=(k-j|0)/80|0;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(l=j+(b*80|0)|0,(k|0)!=(l|0)):0){j=k;while(1){w=j+-80|0;c[s>>2]=w;if((c[j+-12>>2]|0)>-1){u=j+-24|0;n=c[u>>2]|0;c[f>>2]=c[j+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(n,e);c[u>>2]=0;x=c[s>>2]|0}else x=w;if((x|0)==(l|0)){y=l;break}else j=x}}else y=k;else{s7c(h,b-g|0);y=c[s>>2]|0}g=c[h>>2]|0;b=c[a>>2]|0;c[h>>2]=b;c[a>>2]=g;g=c[p>>2]|0;c[s>>2]=g;c[p>>2]=y;y=c[r>>2]|0;c[r>>2]=c[v>>2];c[v>>2]=y;if(!b){i=d;return}if((g|0)==(b|0))z=b;else{y=g;while(1){g=y+-80|0;c[s>>2]=g;if((c[y+-12>>2]|0)>-1){v=y+-24|0;r=c[v>>2]|0;c[f>>2]=c[y+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(r,e);c[v>>2]=0;A=c[s>>2]|0}else A=g;if((A|0)==(b|0))break;else y=A}z=c[h>>2]|0}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(z,e);i=d;return}function o7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=((c[p>>2]|0)-r|0)/68|0;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b*68|0);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];u8c(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;t=a+8|0;u=c[m>>2]|0;c[m>>2]=c[t>>2];c[t>>2]=u;if(!n){i=d;return}else v=q;while(1){if((v|0)==(n|0))break;c[o>>2]=v+-68;v=c[o>>2]|0}o=c[l>>2]|0;c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(o,e);i=d;return}o=a+8|0;if((((c[o>>2]|0)-r|0)/68|0|0)==(b|0)){t7c(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;s8c(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];t8c(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=(k-j|0)/68|0;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(l=j+(b*68|0)|0,(k|0)!=(l|0)):0){j=k;do{c[s>>2]=j+-68;j=c[s>>2]|0}while((j|0)!=(l|0));w=l}else w=k;else{t7c(h,b-g|0);w=c[s>>2]|0}g=c[h>>2]|0;b=c[a>>2]|0;c[h>>2]=b;c[a>>2]=g;g=c[p>>2]|0;c[s>>2]=g;c[p>>2]=w;w=c[r>>2]|0;c[r>>2]=c[o>>2];c[o>>2]=w;if(!b){i=d;return}else x=g;while(1){if((x|0)==(b|0))break;c[s>>2]=x+-68;x=c[s>>2]|0}s=c[h>>2]|0;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(s,e);i=d;return}function p7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=(c[p>>2]|0)-r>>4;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b<<4);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];x8c(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;l=a+8|0;t=c[m>>2]|0;c[m>>2]=c[l>>2];c[l>>2]=t;if(!n){i=d;return}if((q|0)!=(n|0))c[o>>2]=q+(~((q+-16-n|0)>>>4)<<4);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(n,e);i=d;return}n=a+8|0;if(((c[n>>2]|0)-r>>4|0)==(b|0)){G5c(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;v8c(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];w8c(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=k-j>>4;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(q=j+(b<<4)|0,(k|0)!=(q|0)):0){o=k+(~((k+-16-q|0)>>>4)<<4)|0;c[s>>2]=o;u=j;v=o}else{u=j;v=k}else{G5c(h,b-g|0);u=c[h>>2]|0;v=c[s>>2]|0}g=c[a>>2]|0;c[h>>2]=g;c[a>>2]=u;u=c[p>>2]|0;c[s>>2]=u;c[p>>2]=v;v=c[r>>2]|0;c[r>>2]=c[n>>2];c[n>>2]=v;if(!g){i=d;return}if((u|0)!=(g|0))c[s>>2]=u+(~((u+-16-g|0)>>>4)<<4);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function q7c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+8|0;k=c[j>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/292|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{MIc(p);q=c[l>>2]|0}p=q+292|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/292|0)+d|0;if((p|0)<0)vxi(b);n=o;o=(k-n|0)/292|0;if(o>>>0<1073741823){k=o<<1;o=k>>>0<p>>>0?p:k;k=((c[l>>2]|0)-n|0)/292|0;if(!o){r=0;s=0;t=k}else{u=o;v=k;w=10}}else{u=2147483647;v=((c[l>>2]|0)-n|0)/292|0;w=10}if((w|0)==10){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];r=u;s=cOb(u*292|0,16,f,0,3653512,80)|0;t=v}v=s+(t*292|0)|0;t=s+(r*292|0)|0;r=d;d=v;while(1){if(!d)x=0;else{MIc(d);x=d}s=x+292|0;r=r+-1|0;if(!r){y=s;break}else d=s}d=c[b>>2]|0;r=c[l>>2]|0;if((r|0)!=(d|0)){x=r;r=v;while(1){s=r+-292|0;x=x+-292|0;NIc(s,x);if((x|0)==(d|0)){z=s;break}else r=s}r=c[b>>2]|0;x=c[l>>2]|0;c[b>>2]=z;c[l>>2]=y;c[j>>2]=t;if((x|0)==(r|0))A=r;else{z=x;do{x=z;z=z+-292|0;if(a[z>>0]&1){s=c[x+-284>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(s,f)}}while((z|0)!=(r|0));A=r}}else{c[b>>2]=v;c[l>>2]=y;c[j>>2]=t;A=d}if(!A){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(A,f);i=e;return}function r7c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b+8>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/12|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;q=c[l>>2]|0}p=q+12|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/12|0)+d|0;if((p|0)<0)vxi(b);n=o;o=(k-n|0)/12|0;if(o>>>0<1073741823){k=o<<1;r=k>>>0<p>>>0?p:k}else r=2147483647;k=((c[l>>2]|0)-n|0)/12|0;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!r)s=0;else{c[g>>2]=89;c[f+0>>2]=c[g+0>>2];s=cOb(r*12|0,16,f,0,3653512,80)|0}c[j>>2]=s;l=s+(k*12|0)|0;k=j+8|0;c[k>>2]=l;p=j+4|0;c[p>>2]=l;c[n>>2]=s+(r*12|0);r=d;d=l;while(1){if(!d)t=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;t=d}l=t+12|0;r=r+-1|0;if(!r){u=l;break}else d=l}c[k>>2]=u;y8c(b,j);b=c[p>>2]|0;p=c[k>>2]|0;if((p|0)!=(b|0)){u=p;do{p=u;u=u+-12|0;c[k>>2]=u;if(a[u>>0]&1){d=c[p+-4>>2]|0;c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((u|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function s7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+16|0;e=d+4|0;f=d;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/80|0)>>>0>=b>>>0){n=b;o=l;do{if(!o)p=0;else{g[o+4>>2]=ea(x);c[o>>2]=0;l=o+8|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;g[o+32>>2]=ea(x);c[o+28>>2]=0;l=o+36|0;c[o+64>>2]=0;c[o+68>>2]=0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[o+60>>2]=60;c[o+76>>2]=2;c[o+72>>2]=2;p=c[k>>2]|0}o=p+80|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=d;return}n=c[a>>2]|0;o=((m-n|0)/80|0)+b|0;if((o|0)<0)vxi(a);m=n;n=(j-m|0)/80|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=((c[k>>2]|0)-m|0)/80|0;if(!n){q=0;r=0;s=j}else{t=n;u=j;v=10}}else{t=2147483647;u=((c[k>>2]|0)-m|0)/80|0;v=10}if((v|0)==10){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];q=t;r=cOb(t*80|0,16,e,0,3653512,80)|0;s=u}u=r+(s*80|0)|0;s=b;b=u;while(1){if(!b)w=0;else{g[b+4>>2]=ea(x);c[b>>2]=0;t=b+8|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;g[b+32>>2]=ea(x);c[b+28>>2]=0;t=b+36|0;c[b+64>>2]=0;c[b+68>>2]=0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t+20>>2]=0;c[b+60>>2]=60;c[b+76>>2]=2;c[b+72>>2]=2;w=b}t=w+80|0;s=s+-1|0;if(!s){y=t;break}else b=t}b=r+(q*80|0)|0;q=c[a>>2]|0;r=c[k>>2]|0;if((r|0)!=(q|0)){s=r;r=u;while(1){w=r+-80|0;t=s;s=s+-80|0;v=w+0|0;m=s+0|0;j=v+56|0;do{c[v>>2]=c[m>>2];v=v+4|0;m=m+4|0}while((v|0)<(j|0));m=c[t+-20>>2]|0;c[r+-20>>2]=m;v=r+-16|0;c[v>>2]=0;j=r+-12|0;c[j>>2]=0;n=r+-24|0;c[n>>2]=0;o=c[t+-24>>2]|0;p=c[t+-16>>2]<<4;l=p>>4;c[v>>2]=l;if(!l){z=0;A=0}else{c[j>>2]=l;c[f>>2]=m;c[e+0>>2]=c[f+0>>2];m=hOb(0,p,4,e,0,3653512,370)|0;c[n>>2]=m;z=m;A=c[v>>2]<<4}YEi(z|0,o|0,A|0)|0;o=t+-8|0;v=c[o+4>>2]|0;m=r+-8|0;c[m>>2]=c[o>>2];c[m+4>>2]=v;if((s|0)==(q|0)){B=w;break}else r=w}r=c[a>>2]|0;s=c[k>>2]|0;c[a>>2]=B;c[k>>2]=y;c[h>>2]=b;if((s|0)==(r|0))C=r;else{B=s;do{if((c[B+-12>>2]|0)>-1){s=B+-24|0;A=c[s>>2]|0;c[f>>2]=c[B+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(A,e);c[s>>2]=0}B=B+-80|0}while((B|0)!=(r|0));C=r}}else{c[a>>2]=u;c[k>>2]=y;c[h>>2]=b;C=q}if(!C){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(C,e);i=d;return}function t7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/68|0)>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{MLc(n);o=c[j>>2]|0}n=o+68|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=((l-m|0)/68|0)+b|0;if((n|0)<0)vxi(a);l=m;m=(h-l|0)/68|0;if(m>>>0<1073741823){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/68|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=2147483647;t=((c[j>>2]|0)-l|0)/68|0;u=10}if((u|0)==10){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s*68|0,16,e,0,3653512,80)|0;r=t}t=q+(r*68|0)|0;s=q+(p*68|0)|0;p=b;b=t;while(1){if(!b)v=0;else{MLc(b);v=b}u=v+68|0;p=p+-1|0;if(!p){w=u;break}else b=u}b=c[a>>2]|0;p=c[j>>2]|0;if((p|0)==(b|0)){x=t;y=b;z=b}else{v=r+-1-(((p+-68-b|0)>>>0)/68|0)|0;r=p;p=t;while(1){r=r+-68|0;t=p+-68+0|0;u=r+0|0;l=t+68|0;do{c[t>>2]=c[u>>2];t=t+4|0;u=u+4|0}while((t|0)<(l|0));if((r|0)==(b|0))break;else p=p+-68|0}x=q+(v*68|0)|0;y=c[a>>2]|0;z=c[j>>2]|0}c[a>>2]=x;c[j>>2]=w;c[g>>2]=s;s=z;while(1){if((s|0)==(y|0))break;s=s+-68|0}if(!y){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(y,e);i=d;return}function u7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[142268]|0;h=qdd(b,3142608,f,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){g[a>>2]=ea(g[l>>2]);c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=a+4|0;m=qdd(b,3116392,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+8|0;m=qdd(b,614624,f,e,0)|0;if(m){if((m|0)>0){m=b+12|0;n=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=n+j|0;c[m>>2]=k;if((j|0)>=0?(l=n+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[k>>2]);c[m>>2]=l}else Bid(m,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[e>>2]|0;if(m)_n[m&4095](h,b)|0}sdd(b)}h=a+12|0;a=qdd(b,614632,f,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;f=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=f+m|0;c[a>>2]=l;if((m|0)>=0?(k=f+(m+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[a>>2]=k}else Bid(a,h,4);if(c[b>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](h,b)|0}sdd(b);i=d;return}function v7c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=k>>1;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0<=n-p>>1>>>0){q=a+4|0;r=(c[q>>2]|0)-p|0;s=r>>1;if(l>>>0<=s>>>0){t=d-e|0;aFi(o|0,j|0,t|0)|0;u=o+(t>>1<<1)|0;t=c[q>>2]|0;if((t|0)==(u|0)){i=f;return}c[q>>2]=t+(~((t+-2-u|0)>>>1)<<1);i=f;return}u=j+(s<<1)|0;aFi(o|0,j|0,r|0)|0;if((u|0)==(d|0)){i=f;return}r=c[q>>2]|0;s=(d+-2-u|0)>>>1;t=r;v=u;while(1){if(t)b[t>>1]=b[v>>1]|0;v=v+2|0;if((v|0)==(d|0))break;else t=t+2|0}c[q>>2]=r+(s+1<<1);i=f;return}if(!o)w=n;else{n=a+4|0;s=c[n>>2]|0;if((s|0)!=(o|0))c[n>>2]=s+(~((s+-2-p|0)>>>1)<<1);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(o,g);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;w=0}if((k|0)<0)vxi(a);k=w-0|0;if(k>>1>>>0<1073741823){w=k>>>0<l>>>0?l:k;if((w|0)<0)vxi(a);else x=w}else x=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];h=cOb(x<<1,16,g,0,3653512,80)|0;g=a+4|0;c[g>>2]=h;c[a>>2]=h;c[m>>2]=h+(x<<1);if((j|0)==(d|0)){i=f;return}x=(d+-2-e|0)>>>1;e=h;m=j;while(1){if(e)b[e>>1]=b[m>>1]|0;m=m+2|0;if((m|0)==(d|0))break;else e=e+2|0}c[g>>2]=h+(x+1<<1);i=f;return}function w7c(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;f=g+4|0;h=g;c[a>>2]=0;j=a+4|0;c[j>>2]=0;k=a+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=l;m=d-e|0;n=m>>1;if(!n){i=g;return}if((m|0)<0)vxi(a);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];h=cOb(m,16,f,0,3653512,80)|0;c[j>>2]=h;c[a>>2]=h;c[k>>2]=h+(n<<1);if((l|0)==(d|0)){i=g;return}n=(d+-2-e|0)>>>1;e=h;k=l;while(1){if(e)b[e>>1]=b[k>>1]|0;k=k+2|0;if((k|0)==(d|0))break;else e=e+2|0}c[j>>2]=h+(n+1<<1);i=g;return}function x7c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=b+8|0;m=c[l>>2]|0;n=c[b>>2]|0;o=n;if(k>>>0<=(m-o|0)>>>0){p=b+4|0;q=(c[p>>2]|0)-o|0;if(k>>>0<=q>>>0){o=d-e|0;aFi(n|0,j|0,o|0)|0;e=n+o|0;if((c[p>>2]|0)==(e|0)){i=f;return}c[p>>2]=e;i=f;return}e=j+q|0;aFi(n|0,j|0,q|0)|0;if((e|0)==(d|0)){i=f;return}q=c[p>>2]|0;o=e;do{if(!q)r=0;else{a[q>>0]=a[o>>0]|0;r=c[p>>2]|0}q=r+1|0;c[p>>2]=q;o=o+1|0}while((o|0)!=(d|0));i=f;return}if(!n)s=m;else{m=b+4|0;if((c[m>>2]|0)!=(n|0))c[m>>2]=n;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(n,g);c[l>>2]=0;c[m>>2]=0;c[b>>2]=0;s=0}if((k|0)<0)vxi(b);m=s-0|0;if(m>>>0<1073741823){s=m<<1;m=s>>>0<k>>>0?k:s;if((m|0)<0)vxi(b);else t=m}else t=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];h=cOb(t,16,g,0,3653512,80)|0;g=b+4|0;c[g>>2]=h;c[b>>2]=h;c[l>>2]=h+t;if((j|0)==(d|0)){i=f;return}else{u=h;v=j}do{if(!u)w=0;else{a[u>>0]=a[v>>0]|0;w=c[g>>2]|0}u=w+1|0;c[g>>2]=u;v=v+1|0}while((v|0)!=(d|0));i=f;return}function y7c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];h=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=h;c[b>>2]=h;c[k>>2]=h+e;e=h;h=l;do{if(!e)m=0;else{a[e>>0]=a[h>>0]|0;m=c[j>>2]|0}e=m+1|0;c[j>>2]=e;h=h+1|0}while((h|0)!=(d|0));i=g;return}function z7c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=b+8|0;m=c[l>>2]|0;n=c[b>>2]|0;o=n;if(k>>>0<=(m-o|0)>>>0){p=b+4|0;q=(c[p>>2]|0)-o|0;if(k>>>0<=q>>>0){o=d-e|0;aFi(n|0,j|0,o|0)|0;e=n+o|0;if((c[p>>2]|0)==(e|0)){i=f;return}c[p>>2]=e;i=f;return}e=j+q|0;aFi(n|0,j|0,q|0)|0;if((e|0)==(d|0)){i=f;return}q=c[p>>2]|0;o=e;do{if(!q)r=0;else{a[q>>0]=a[o>>0]|0;r=c[p>>2]|0}q=r+1|0;c[p>>2]=q;o=o+1|0}while((o|0)!=(d|0));i=f;return}if(!n)s=m;else{m=b+4|0;if((c[m>>2]|0)!=(n|0))c[m>>2]=n;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(n,g);c[l>>2]=0;c[m>>2]=0;c[b>>2]=0;s=0}if((k|0)<0)vxi(b);m=s-0|0;if(m>>>0<1073741823){s=m<<1;m=s>>>0<k>>>0?k:s;if((m|0)<0)vxi(b);else t=m}else t=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];h=cOb(t,16,g,0,3653512,80)|0;g=b+4|0;c[g>>2]=h;c[b>>2]=h;c[l>>2]=h+t;if((j|0)==(d|0)){i=f;return}else{u=h;v=j}do{if(!u)w=0;else{a[u>>0]=a[v>>0]|0;w=c[g>>2]|0}u=w+1|0;c[g>>2]=u;v=v+1|0}while((v|0)!=(d|0));i=f;return}function A7c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];h=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=h;c[b>>2]=h;c[k>>2]=h+e;e=h;h=l;do{if(!e)m=0;else{a[e>>0]=a[h>>0]|0;m=c[j>>2]|0}e=m+1|0;c[j>>2]=e;h=h+1|0}while((h|0)!=(d|0));i=g;return}function B7c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=k>>1;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0<=n-p>>1>>>0){q=a+4|0;r=(c[q>>2]|0)-p|0;s=r>>1;if(l>>>0<=s>>>0){t=d-e|0;aFi(o|0,j|0,t|0)|0;u=o+(t>>1<<1)|0;t=c[q>>2]|0;if((t|0)==(u|0)){i=f;return}c[q>>2]=t+(~((t+-2-u|0)>>>1)<<1);i=f;return}u=j+(s<<1)|0;aFi(o|0,j|0,r|0)|0;if((u|0)==(d|0)){i=f;return}r=c[q>>2]|0;s=(d+-2-u|0)>>>1;t=r;v=u;while(1){if(t)b[t>>1]=b[v>>1]|0;v=v+2|0;if((v|0)==(d|0))break;else t=t+2|0}c[q>>2]=r+(s+1<<1);i=f;return}if(!o)w=n;else{n=a+4|0;s=c[n>>2]|0;if((s|0)!=(o|0))c[n>>2]=s+(~((s+-2-p|0)>>>1)<<1);c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(o,g);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;w=0}if((k|0)<0)vxi(a);k=w-0|0;if(k>>1>>>0<1073741823){w=k>>>0<l>>>0?l:k;if((w|0)<0)vxi(a);else x=w}else x=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];h=cOb(x<<1,16,g,0,3653512,80)|0;g=a+4|0;c[g>>2]=h;c[a>>2]=h;c[m>>2]=h+(x<<1);if((j|0)==(d|0)){i=f;return}x=(d+-2-e|0)>>>1;e=h;m=j;while(1){if(e)b[e>>1]=b[m>>1]|0;m=m+2|0;if((m|0)==(d|0))break;else e=e+2|0}c[g>>2]=h+(x+1<<1);i=f;return}function C7c(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;f=g+4|0;h=g;c[a>>2]=0;j=a+4|0;c[j>>2]=0;k=a+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=l;m=d-e|0;n=m>>1;if(!n){i=g;return}if((m|0)<0)vxi(a);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];h=cOb(m,16,f,0,3653512,80)|0;c[j>>2]=h;c[a>>2]=h;c[k>>2]=h+(n<<1);if((l|0)==(d|0)){i=g;return}n=(d+-2-e|0)>>>1;e=h;k=l;while(1){if(e)b[e>>1]=b[k>>1]|0;k=k+2|0;if((k|0)==(d|0))break;else e=e+2|0}c[j>>2]=h+(n+1<<1);i=g;return}function D7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>2>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>2;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>2<<2)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-4-t|0)>>>2)<<2);i=e;return}t=h+(r<<2)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-4-t|0)>>>2;s=q;u=t;while(1){if(s)c[s>>2]=c[u>>2];u=u+4|0;if((u|0)==(b|0))break;else s=s+4|0}c[p>>2]=q+(r+1<<2);i=e;return}if(!n)v=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;v=0}if((j|0)<0)vxi(a);j=v-0|0;if(j>>2>>>0<1073741823){v=j>>1;j=v>>>0<k>>>0?k:v;if((j|0)<0)vxi(a);else w=j}else w=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(w<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(w<<2);if((h|0)==(b|0)){i=e;return}w=(b+-4-d|0)>>>2;d=g;l=h;while(1){if(d)c[d>>2]=c[l>>2];l=l+4|0;if((l|0)==(b|0))break;else d=d+4|0}c[f>>2]=g+(w+1<<2);i=e;return}function E7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function F7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function G7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>3;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>3>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>3;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>3<<3)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-8-t|0)>>>3)<<3);i=e;return}t=h+(r<<3)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-8-t|0)>>>3;s=q;u=t;while(1){if(s){t=u;v=c[t+4>>2]|0;w=s;c[w>>2]=c[t>>2];c[w+4>>2]=v}u=u+8|0;if((u|0)==(b|0))break;else s=s+8|0}c[p>>2]=q+(r+1<<3);i=e;return}if(!n)x=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=x-0|0;if(j>>3>>>0<1073741823){x=j>>2;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(y<<3,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y<<3);if((h|0)==(b|0)){i=e;return}y=(b+-8-d|0)>>>3;d=g;l=h;while(1){if(d){h=l;a=c[h+4>>2]|0;j=d;c[j>>2]=c[h>>2];c[j+4>>2]=a}l=l+8|0;if((l|0)==(b|0))break;else d=d+8|0}c[f>>2]=g+(y+1<<3);i=e;return}function H7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>3;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<3);if((k|0)==(b|0)){i=f;return}m=(b+-8-d|0)>>>3;d=g;j=k;while(1){if(d){k=j;a=c[k+4>>2]|0;e=d;c[e>>2]=c[k>>2];c[e+4>>2]=a}j=j+8|0;if((j|0)==(b|0))break;else d=d+8|0}c[h>>2]=g+(m+1<<3);i=f;return}function I7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>3;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>3>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>3;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>3<<3)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-8-t|0)>>>3)<<3);i=e;return}t=h+(r<<3)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-8-t|0)>>>3;s=q;u=t;while(1){if(s){t=u;v=c[t+4>>2]|0;w=s;c[w>>2]=c[t>>2];c[w+4>>2]=v}u=u+8|0;if((u|0)==(b|0))break;else s=s+8|0}c[p>>2]=q+(r+1<<3);i=e;return}if(!n)x=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=x-0|0;if(j>>3>>>0<1073741823){x=j>>2;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(y<<3,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y<<3);if((h|0)==(b|0)){i=e;return}y=(b+-8-d|0)>>>3;d=g;l=h;while(1){if(d){h=l;a=c[h+4>>2]|0;j=d;c[j>>2]=c[h>>2];c[j+4>>2]=a}l=l+8|0;if((l|0)==(b|0))break;else d=d+8|0}c[f>>2]=g+(y+1<<3);i=e;return}function J7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>3;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<3);if((k|0)==(b|0)){i=f;return}m=(b+-8-d|0)>>>3;d=g;j=k;while(1){if(d){k=j;a=c[k+4>>2]|0;e=d;c[e>>2]=c[k>>2];c[e+4>>2]=a}j=j+8|0;if((j|0)==(b|0))break;else d=d+8|0}c[h>>2]=g+(m+1<<3);i=f;return}function K7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;h=e;j=c[b>>2]|0;b=c[d>>2]|0;d=j;k=b-d|0;l=k>>2;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0<=n-p>>2>>>0){q=a+4|0;r=(c[q>>2]|0)-p|0;s=r>>2;if(l>>>0<=s>>>0){t=b-d|0;aFi(o|0,j|0,t|0)|0;u=o+(t>>2<<2)|0;t=c[q>>2]|0;if((t|0)==(u|0)){i=e;return}c[q>>2]=t+(~((t+-4-u|0)>>>2)<<2);i=e;return}u=j+(s<<2)|0;aFi(o|0,j|0,r|0)|0;if((u|0)==(b|0)){i=e;return}r=c[q>>2]|0;s=(b+-4-u|0)>>>2;t=r;v=u;while(1){if(t)g[t>>2]=ea(g[v>>2]);v=v+4|0;if((v|0)==(b|0))break;else t=t+4|0}c[q>>2]=r+(s+1<<2);i=e;return}if(!o)w=n;else{n=a+4|0;s=c[n>>2]|0;if((s|0)!=(o|0))c[n>>2]=s+(~((s+-4-p|0)>>>2)<<2);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(o,f);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;w=0}if((k|0)<0)vxi(a);k=w-0|0;if(k>>2>>>0<1073741823){w=k>>1;k=w>>>0<l>>>0?l:w;if((k|0)<0)vxi(a);else x=k}else x=2147483647;c[h>>2]=89;c[f+0>>2]=c[h+0>>2];h=cOb(x<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=h;c[a>>2]=h;c[m>>2]=h+(x<<2);if((j|0)==(b|0)){i=e;return}x=(b+-4-d|0)>>>2;d=h;m=j;while(1){if(d)g[d>>2]=ea(g[m>>2]);m=m+4|0;if((m|0)==(b|0))break;else d=d+4|0}c[f>>2]=h+(x+1<<2);i=e;return}function L7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;e=f+4|0;h=f;c[a>>2]=0;j=a+4|0;c[j>>2]=0;k=a+8|0;c[k>>2]=0;l=c[b>>2]|0;b=c[d>>2]|0;d=l;m=b-d|0;n=m>>2;if(!n){i=f;return}if((m|0)<0)vxi(a);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];h=cOb(m,16,e,0,3653512,80)|0;c[j>>2]=h;c[a>>2]=h;c[k>>2]=h+(n<<2);if((l|0)==(b|0)){i=f;return}n=(b+-4-d|0)>>>2;d=h;k=l;while(1){if(d)g[d>>2]=ea(g[k>>2]);k=k+4|0;if((k|0)==(b|0))break;else d=d+4|0}c[j>>2]=h+(n+1<<2);i=f;return}function M7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;j=c[b>>2]|0;b=c[d>>2]|0;d=j;k=b-d|0;l=k>>3;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0<=n-p>>3>>>0){q=a+4|0;r=(c[q>>2]|0)-p|0;s=r>>3;if(l>>>0<=s>>>0){t=b-d|0;aFi(o|0,j|0,t|0)|0;u=o+(t>>3<<3)|0;t=c[q>>2]|0;if((t|0)==(u|0)){i=e;return}c[q>>2]=t+(~((t+-8-u|0)>>>3)<<3);i=e;return}u=j+(s<<3)|0;aFi(o|0,j|0,r|0)|0;if((u|0)==(b|0)){i=e;return}r=c[q>>2]|0;s=(b+-8-u|0)>>>3;t=r;v=u;while(1){if(t)h[t>>3]=+h[v>>3];v=v+8|0;if((v|0)==(b|0))break;else t=t+8|0}c[q>>2]=r+(s+1<<3);i=e;return}if(!o)w=n;else{n=a+4|0;s=c[n>>2]|0;if((s|0)!=(o|0))c[n>>2]=s+(~((s+-8-p|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(o,f);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;w=0}if((k|0)<0)vxi(a);k=w-0|0;if(k>>3>>>0<1073741823){w=k>>2;k=w>>>0<l>>>0?l:w;if((k|0)<0)vxi(a);else x=k}else x=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(x<<3,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[m>>2]=g+(x<<3);if((j|0)==(b|0)){i=e;return}x=(b+-8-d|0)>>>3;d=g;m=j;while(1){if(d)h[d>>3]=+h[m>>3];m=m+8|0;if((m|0)==(b|0))break;else d=d+8|0}c[f>>2]=g+(x+1<<3);i=e;return}function N7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;j=a+4|0;c[j>>2]=0;k=a+8|0;c[k>>2]=0;l=c[b>>2]|0;b=c[d>>2]|0;d=l;m=b-d|0;n=m>>3;if(!n){i=f;return}if((m|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(m,16,e,0,3653512,80)|0;c[j>>2]=g;c[a>>2]=g;c[k>>2]=g+(n<<3);if((l|0)==(b|0)){i=f;return}n=(b+-8-d|0)>>>3;d=g;k=l;while(1){if(d)h[d>>3]=+h[k>>3];k=k+8|0;if((k|0)==(b|0))break;else d=d+8|0}c[j>>2]=g+(n+1<<3);i=f;return}function O7c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+8|0;k=c[b>>2]|0;l=k;if((((c[j>>2]|0)-l|0)/292|0)>>>0>=d>>>0){i=e;return}m=b+4|0;n=c[m>>2]|0;if(!d){o=0;p=n;q=k}else{c[g>>2]=89;c[f+0>>2]=c[g+0>>2];k=cOb(d*292|0,16,f,0,3653512,80)|0;o=k;p=c[m>>2]|0;q=c[b>>2]|0}k=o+(((n-l|0)/292|0)*292|0)|0;l=o+(d*292|0)|0;if((p|0)!=(q|0)){d=p;o=k;while(1){n=o+-292|0;d=d+-292|0;NIc(n,d);if((d|0)==(q|0)){r=n;break}else o=n}o=c[b>>2]|0;q=c[m>>2]|0;c[b>>2]=r;c[m>>2]=k;c[j>>2]=l;if((q|0)==(o|0))s=o;else{r=q;do{q=r;r=r+-292|0;if(a[r>>0]&1){d=c[q+-284>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((r|0)!=(o|0));s=o}}else{c[b>>2]=k;c[m>>2]=k;c[j>>2]=l;s=p}if(!s){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(s,f);i=e;return}function P7c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=(k|0)/292|0;m=b+8|0;n=c[b>>2]|0;o=n;if(l>>>0>(((c[m>>2]|0)-o|0)/292|0)>>>0){z8c(b);if((k|0)<0)vxi(b);k=((c[m>>2]|0)-(c[b>>2]|0)|0)/292|0;if(k>>>0<1073741823){p=k<<1;k=p>>>0<l>>>0?l:p;if((k|0)<0)vxi(b);else q=k}else q=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];k=cOb(q*292|0,16,g,0,3653512,80)|0;p=b+4|0;c[p>>2]=k;c[b>>2]=k;c[m>>2]=k+(q*292|0);if((j|0)==(d|0)){i=f;return}else{r=k;s=j}do{if(!r)t=0;else{NIc(r,s);t=c[p>>2]|0}r=t+292|0;c[p>>2]=r;s=s+292|0}while((s|0)!=(d|0));i=f;return}s=b+4|0;b=((c[s>>2]|0)-o|0)/292|0;if(l>>>0>b>>>0){u=j+(b*292|0)|0;v=1}else{u=d;v=0}if((j|0)==(u|0))w=n;else{b=((u+-292-e|0)>>>0)/292|0;e=n;l=j;while(1){l2c(e,l)|0;l=l+292|0;if((l|0)==(u|0))break;else e=e+292|0}w=n+((b+1|0)*292|0)|0}if(v){if((u|0)==(d|0)){i=f;return}v=c[s>>2]|0;b=u;do{if(!v)x=0;else{NIc(v,b);x=c[s>>2]|0}v=x+292|0;c[s>>2]=v;b=b+292|0}while((b|0)!=(d|0));i=f;return}else{d=c[s>>2]|0;if((d|0)==(w|0)){i=f;return}b=d;while(1){d=b+-292|0;c[s>>2]=d;if(!(a[d>>0]&1))y=d;else{d=c[b+-284>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(d,g);y=c[s>>2]|0}if((y|0)==(w|0))break;else b=y}i=f;return}}function Q7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/292|0)*292|0);d=g;g=k;do{if(!d)l=0;else{NIc(d,g);l=c[h>>2]|0}d=l+292|0;c[h>>2]=d;g=g+292|0}while((g|0)!=(b|0));i=f;return}function R7c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((((c[g>>2]|0)-j|0)/12|0)>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;m=(l-j|0)/12|0;if(!b){n=0;o=l;p=h}else{c[f>>2]=89;c[e+0>>2]=c[f+0>>2];h=cOb(b*12|0,16,e,0,3653512,80)|0;n=h;o=c[k>>2]|0;p=c[a>>2]|0}h=n+(m*12|0)|0;l=n+(b*12|0)|0;if((o|0)==(p|0)){q=h;r=o}else{b=m+-1-(((o+-12-p|0)>>>0)/12|0)|0;m=o;o=h;while(1){j=m;m=m+-12|0;c[o+-12>>2]=c[m>>2];s=j+-8|0;j=c[s+4>>2]|0;t=o+-8|0;c[t>>2]=c[s>>2];c[t+4>>2]=j;if((m|0)==(p|0))break;else o=o+-12|0}q=n+(b*12|0)|0;r=c[a>>2]|0}c[a>>2]=q;c[k>>2]=h;c[g>>2]=l;if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function S7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=(j|0)/12|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>((m-o|0)/12|0)>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~(((q+-12-o|0)>>>0)/12|0)*12|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if((j|0)<0)vxi(a);j=(p-0|0)/12|0;if(j>>>0<1073741823){p=j<<1;j=p>>>0<k>>>0?k:p;if((j|0)<0)vxi(a);else r=j}else r=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(r*12|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(r*12|0);if((h|0)==(b|0)){i=e;return}else{s=g;t=h}do{if(!s)u=0;else{c[s>>2]=c[t>>2];g=t+4|0;r=c[g+4>>2]|0;l=s+4|0;c[l>>2]=c[g>>2];c[l+4>>2]=r;u=c[f>>2]|0}s=u+12|0;c[f>>2]=s;t=t+12|0}while((t|0)!=(b|0));i=e;return}t=a+4|0;a=((c[t>>2]|0)-o|0)/12|0;if(k>>>0>a>>>0){v=h+(a*12|0)|0;w=1}else{v=b;w=0}if((h|0)==(v|0))x=n;else{a=((v+-12-d|0)>>>0)/12|0;d=n;k=h;while(1){c[d>>2]=c[k>>2];h=k+4|0;o=c[h+4>>2]|0;s=d+4|0;c[s>>2]=c[h>>2];c[s+4>>2]=o;k=k+12|0;if((k|0)==(v|0))break;else d=d+12|0}x=n+((a+1|0)*12|0)|0}if(!w){w=c[t>>2]|0;if((w|0)==(x|0)){i=e;return}c[t>>2]=w+(~(((w+-12-x|0)>>>0)/12|0)*12|0);i=e;return}if((v|0)==(b|0)){i=e;return}x=c[t>>2]|0;w=v;do{if(!x)y=0;else{c[x>>2]=c[w>>2];v=w+4|0;a=c[v+4>>2]|0;n=x+4|0;c[n>>2]=c[v>>2];c[n+4>>2]=a;y=c[t>>2]|0}x=y+12|0;c[t>>2]=x;w=w+12|0}while((w|0)!=(b|0));i=e;return}function T7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/12|0)*12|0);d=g;g=k;do{if(!d)l=0;else{c[d>>2]=c[g>>2];k=g+4|0;j=c[k+4>>2]|0;a=d+4|0;c[a>>2]=c[k>>2];c[a+4>>2]=j;l=c[h>>2]|0}d=l+12|0;c[h>>2]=d;g=g+12|0}while((g|0)!=(b|0));i=f;return}function U7c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b>>2]|0;if((((c[b+8>>2]|0)-k|0)/12|0)>>>0>=d>>>0){i=e;return}l=((c[b+4>>2]|0)-k|0)/12|0;k=j+12|0;c[k>>2]=0;c[j+16>>2]=b+8;if(!d)m=0;else{c[g>>2]=89;c[f+0>>2]=c[g+0>>2];m=cOb(d*12|0,16,f,0,3653512,80)|0}c[j>>2]=m;n=m+(l*12|0)|0;l=j+8|0;c[l>>2]=n;o=j+4|0;c[o>>2]=n;c[k>>2]=m+(d*12|0);y8c(b,j);b=c[o>>2]|0;o=c[l>>2]|0;if((o|0)!=(b|0)){d=o;do{o=d;d=d+-12|0;c[l>>2]=d;if(a[d>>0]&1){m=c[o+-4>>2]|0;c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(m,f)}}while((d|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function V7c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;k=j;l=d-k|0;m=(l|0)/12|0;n=b+8|0;o=c[b>>2]|0;p=o;if(m>>>0>(((c[n>>2]|0)-p|0)/12|0)>>>0){A8c(b);if((l|0)<0)vxi(b);l=((c[n>>2]|0)-(c[b>>2]|0)|0)/12|0;if(l>>>0<1073741823){q=l<<1;l=q>>>0<m>>>0?m:q;if((l|0)<0)vxi(b);else r=l}else r=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];l=cOb(r*12|0,16,g,0,3653512,80)|0;q=b+4|0;c[q>>2]=l;c[b>>2]=l;c[n>>2]=l+(r*12|0);if((j|0)==(d|0)){i=f;return}r=l;l=j;a:while(1){do if(r){if(!(a[l>>0]&1)){c[r+0>>2]=c[l+0>>2];c[r+4>>2]=c[l+4>>2];c[r+8>>2]=c[l+8>>2];break}n=c[l+8>>2]|0;s=c[l+4>>2]|0;if(s>>>0>2147483631){t=54;break a}if(s>>>0<11){a[r>>0]=s<<1;u=r+1|0}else{v=s+16&-16;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];w=cOb(v,16,g,0,3653512,80)|0;c[r+8>>2]=w;c[r>>2]=v|1;c[r+4>>2]=s;u=w}YEi(u|0,n|0,s|0)|0;a[u+s>>0]=0}while(0);s=(c[q>>2]|0)+12|0;c[q>>2]=s;l=l+12|0;if((l|0)==(d|0)){t=60;break}else r=s}if((t|0)==54)ori(r);else if((t|0)==60){i=f;return}}r=b+4|0;b=((c[r>>2]|0)-p|0)/12|0;if(m>>>0>b>>>0){x=j+(b*12|0)|0;y=1}else{x=d;y=0}if((j|0)==(x|0))z=o;else{d=((x+-12-k|0)>>>0)/12|0;k=o;b=j;while(1){do if((k|0)!=(b|0)){j=a[b>>0]|0;if(!(j&1)){A=(j&255)>>>1;B=b+1|0}else{A=c[b+4>>2]|0;B=c[b+8>>2]|0}j=a[k>>0]|0;if(!(j&1)){C=10;D=j}else{j=c[k>>2]|0;C=(j&-2)+-1|0;D=j&255}j=(D&1)==0;if(A>>>0>C>>>0){if(j)E=(D&255)>>>1;else E=c[k+4>>2]|0;AOb(k,C,A-C|0,E,0,E,A,B);break}if(j)F=k+1|0;else F=c[k+8>>2]|0;aFi(F|0,B|0,A|0)|0;a[F+A>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=A<<1;break}else{c[k+4>>2]=A;break}}while(0);b=b+12|0;if((b|0)==(x|0))break;else k=k+12|0}z=o+((d+1|0)*12|0)|0}if(!y){y=c[r>>2]|0;if((y|0)==(z|0)){i=f;return}d=y;while(1){y=d+-12|0;c[r>>2]=y;if(!(a[y>>0]&1))G=y;else{y=c[d+-4>>2]|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(y,g);G=c[r>>2]|0}if((G|0)==(z|0))break;else d=G}i=f;return}G=c[e>>2]|0;if((x|0)==(G|0)){i=f;return}e=c[r>>2]|0;d=x;b:while(1){do if(e){if(!(a[d>>0]&1)){c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];break}x=c[d+8>>2]|0;z=c[d+4>>2]|0;if(z>>>0>2147483631){t=32;break b}if(z>>>0<11){a[e>>0]=z<<1;H=e+1|0}else{y=z+16&-16;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];o=cOb(y,16,g,0,3653512,80)|0;c[e+8>>2]=o;c[e>>2]=y|1;c[e+4>>2]=z;H=o}YEi(H|0,x|0,z|0)|0;a[H+z>>0]=0}while(0);z=(c[r>>2]|0)+12|0;c[r>>2]=z;d=d+12|0;if((d|0)==(G|0)){t=60;break}else e=z}if((t|0)==32)ori(e);else if((t|0)==60){i=f;return}}function W7c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];m=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=m;c[b>>2]=m;c[k>>2]=m+(((e|0)/12|0)*12|0);e=m;m=l;a:while(1){do if(e){if(!(a[m>>0]&1)){c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];break}l=c[m+8>>2]|0;k=c[m+4>>2]|0;if(k>>>0>2147483631){n=9;break a}if(k>>>0<11){a[e>>0]=k<<1;o=e+1|0}else{b=k+16&-16;c[h>>2]=89;c[f+0>>2]=c[h+0>>2];p=cOb(b,16,f,0,3653512,80)|0;c[e+8>>2]=p;c[e>>2]=b|1;c[e+4>>2]=k;o=p}YEi(o|0,l|0,k|0)|0;a[o+k>>0]=0}while(0);k=(c[j>>2]|0)+12|0;c[j>>2]=k;m=m+12|0;if((m|0)==(d|0)){n=15;break}else e=k}if((n|0)==9)ori(e);else if((n|0)==15){i=g;return}}function X7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=(j|0)/12|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=((m-o|0)/12|0)>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=(q|0)/12|0;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(((s|0)/12|0)*12|0)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~(((s+-12-d|0)>>>0)/12|0)*12|0);i=e;return}d=h+(r*12|0)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];t=c[p>>2]|0}q=t+12|0;c[p>>2]=q;r=r+12|0}while((r|0)!=(b|0));i=e;return}if(!n)u=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~(((r+-12-o|0)>>>0)/12|0)*12|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;u=0}if((j|0)<0)vxi(a);j=(u-0|0)/12|0;if(j>>>0<1073741823){u=j<<1;j=u>>>0<k>>>0?k:u;if((j|0)<0)vxi(a);else v=j}else v=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(v*12|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(v*12|0);if((h|0)==(b|0)){i=e;return}else{w=g;x=h}do{if(!w)y=0;else{c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];y=c[f>>2]|0}w=y+12|0;c[f>>2]=w;x=x+12|0}while((x|0)!=(b|0));i=e;return}function Y7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/12|0)*12|0);d=g;g=k;do{if(!d)l=0;else{c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];l=c[h>>2]|0}d=l+12|0;c[h>>2]=d;g=g+12|0}while((g|0)!=(b|0));i=f;return}function Z7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>3;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>3>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>3;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(s>>3<<3)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~((s+-8-d|0)>>>3)<<3);i=e;return}d=h+(r<<3)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{d=r;s=c[d+4>>2]|0;u=q;c[u>>2]=c[d>>2];c[u+4>>2]=s;t=c[p>>2]|0}q=t+8|0;c[p>>2]=q;r=r+8|0}while((r|0)!=(b|0));i=e;return}if(!n)v=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;v=0}if((j|0)<0)vxi(a);j=v-0|0;if(j>>3>>>0<1073741823){v=j>>2;j=v>>>0<k>>>0?k:v;if((j|0)<0)vxi(a);else w=j}else w=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(w<<3,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(w<<3);if((h|0)==(b|0)){i=e;return}else{x=g;y=h}do{if(!x)z=0;else{h=y;g=c[h+4>>2]|0;w=x;c[w>>2]=c[h>>2];c[w+4>>2]=g;z=c[f>>2]|0}x=z+8|0;c[f>>2]=x;y=y+8|0}while((y|0)!=(b|0));i=e;return}function _7c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>3;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<3);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{k=n;g=c[k+4>>2]|0;l=m;c[l>>2]=c[k>>2];c[l+4>>2]=g;o=c[h>>2]|0}m=o+8|0;c[h>>2]=m;n=n+8|0}while((n|0)!=(b|0));i=f;return}function $7c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>4;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>4>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>4;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(s>>4<<4)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~((s+-16-d|0)>>>4)<<4);i=e;return}d=h+(r<<4)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];t=c[p>>2]|0}q=t+16|0;c[p>>2]=q;r=r+16|0}while((r|0)!=(b|0));i=e;return}if(!n)u=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;u=0}if((j|0)<0)vxi(a);j=u-0|0;if(j>>4>>>0<1073741823){u=j>>3;j=u>>>0<k>>>0?k:u;if((j|0)<0)vxi(a);else v=j}else v=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(v<<4,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(v<<4);if((h|0)==(b|0)){i=e;return}else{w=g;x=h}do{if(!w)y=0;else{c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];y=c[f>>2]|0}w=y+16|0;c[f>>2]=w;x=x+16|0}while((x|0)!=(b|0));i=e;return}function a8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>4;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<4);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];o=c[h>>2]|0}m=o+16|0;c[h>>2]=m;n=n+16|0}while((n|0)!=(b|0));i=f;return}function b8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>4;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>4>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>4;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(s>>4<<4)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~((s+-16-d|0)>>>4)<<4);i=e;return}d=h+(r<<4)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];t=c[p>>2]|0}q=t+16|0;c[p>>2]=q;r=r+16|0}while((r|0)!=(b|0));i=e;return}if(!n)u=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;u=0}if((j|0)<0)vxi(a);j=u-0|0;if(j>>4>>>0<1073741823){u=j>>3;j=u>>>0<k>>>0?k:u;if((j|0)<0)vxi(a);else v=j}else v=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(v<<4,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(v<<4);if((h|0)==(b|0)){i=e;return}else{w=g;x=h}do{if(!w)y=0;else{c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];y=c[f>>2]|0}w=y+16|0;c[f>>2]=w;x=x+16|0}while((x|0)!=(b|0));i=e;return}function c8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>4;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<4);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];o=c[h>>2]|0}m=o+16|0;c[h>>2]=m;n=n+16|0}while((n|0)!=(b|0));i=f;return}function d8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>4;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>4>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>4;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(s>>4<<4)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~((s+-16-d|0)>>>4)<<4);i=e;return}d=h+(r<<4)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];t=c[p>>2]|0}q=t+16|0;c[p>>2]=q;r=r+16|0}while((r|0)!=(b|0));i=e;return}if(!n)u=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;u=0}if((j|0)<0)vxi(a);j=u-0|0;if(j>>4>>>0<1073741823){u=j>>3;j=u>>>0<k>>>0?k:u;if((j|0)<0)vxi(a);else v=j}else v=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(v<<4,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(v<<4);if((h|0)==(b|0)){i=e;return}else{w=g;x=h}do{if(!w)y=0;else{c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];y=c[f>>2]|0}w=y+16|0;c[f>>2]=w;x=x+16|0}while((x|0)!=(b|0));i=e;return}function e8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>4;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<4);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];o=c[h>>2]|0}m=o+16|0;c[h>>2]=m;n=n+16|0}while((n|0)!=(b|0));i=f;return}function f8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>6;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>6>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>6;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(s>>6<<6)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~((s+-64-d|0)>>>6)<<6);i=e;return}d=h+(r<<6)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{u=q+0|0;v=r+0|0;w=u+64|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=c[p>>2]|0}q=t+64|0;c[p>>2]=q;r=r+64|0}while((r|0)!=(b|0));i=e;return}if(!n)x=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-64-o|0)>>>6)<<6);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=x-0|0;if(j>>6>>>0<1073741823){x=j>>5;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(y<<6,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y<<6);if((h|0)==(b|0)){i=e;return}else{z=g;A=h}do{if(!z)B=0;else{u=z+0|0;v=A+0|0;w=u+64|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));B=c[f>>2]|0}z=B+64|0;c[f>>2]=z;A=A+64|0}while((A|0)!=(b|0));i=e;return}function g8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>6;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<6);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{k=m+0|0;g=n+0|0;l=k+64|0;do{c[k>>2]=c[g>>2];k=k+4|0;g=g+4|0}while((k|0)<(l|0));o=c[h>>2]|0}m=o+64|0;c[h>>2]=m;n=n+64|0}while((n|0)!=(b|0));i=f;return}function h8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=(j|0)/24|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=((m-o|0)/24|0)>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=(q|0)/24|0;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(((s|0)/24|0)*24|0)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~(((s+-24-d|0)>>>0)/24|0)*24|0);i=e;return}d=h+(r*24|0)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[q+16>>2]=c[r+16>>2];c[q+20>>2]=c[r+20>>2];t=c[p>>2]|0}q=t+24|0;c[p>>2]=q;r=r+24|0}while((r|0)!=(b|0));i=e;return}if(!n)u=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~(((r+-24-o|0)>>>0)/24|0)*24|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;u=0}if((j|0)<0)vxi(a);j=(u-0|0)/24|0;if(j>>>0<1073741823){u=j<<1;j=u>>>0<k>>>0?k:u;if((j|0)<0)vxi(a);else v=j}else v=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(v*24|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(v*24|0);if((h|0)==(b|0)){i=e;return}else{w=g;x=h}do{if(!w)y=0;else{c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];c[w+16>>2]=c[x+16>>2];c[w+20>>2]=c[x+20>>2];y=c[f>>2]|0}w=y+24|0;c[f>>2]=w;x=x+24|0}while((x|0)!=(b|0));i=e;return}function i8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/24|0)*24|0);d=g;g=k;do{if(!d)l=0;else{c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];c[d+16>>2]=c[g+16>>2];c[d+20>>2]=c[g+20>>2];l=c[h>>2]|0}d=l+24|0;c[h>>2]=d;g=g+24|0}while((g|0)!=(b|0));i=f;return}function j8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=0,F=0;e=i;i=i+16|0;f=e+4|0;h=e;j=c[b>>2]|0;b=c[d>>2]|0;d=j;k=b-d|0;l=k>>4;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0>n-p>>4>>>0){if(!o)q=n;else{n=a+4|0;r=c[n>>2]|0;if((r|0)!=(o|0))c[n>>2]=r+(~((r+-16-p|0)>>>4)<<4);c[h>>2]=89;c[f+0>>2]=c[h+0>>2];eOb(o,f);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;q=0}if((k|0)<0)vxi(a);k=q-0|0;if(k>>4>>>0<1073741823){q=k>>3;k=q>>>0<l>>>0?l:q;if((k|0)<0)vxi(a);else s=k}else s=2147483647;c[h>>2]=89;c[f+0>>2]=c[h+0>>2];h=cOb(s<<4,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=h;c[a>>2]=h;c[m>>2]=h+(s<<4);if((j|0)==(b|0)){i=e;return}else{t=h;u=j}do{if(!t)v=0;else{c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];v=c[f>>2]|0}t=v+16|0;c[f>>2]=t;u=u+16|0}while((u|0)!=(b|0));i=e;return}u=a+4|0;a=c[u>>2]|0;t=a-p>>4;if(l>>>0>t>>>0){w=j+(t<<4)|0;x=1}else{w=b;x=0}if((j|0)==(w|0))y=o;else{t=(w+-16-d|0)>>>4;d=o;l=j;while(1){z=ea(g[l>>2]);A=ea(g[l+4>>2]);B=ea(g[l+8>>2]);C=ea(g[l+12>>2]);g[d>>2]=z;g[d+4>>2]=A;g[d+8>>2]=B;g[d+12>>2]=C;l=l+16|0;if((l|0)==(w|0))break;else d=d+16|0}y=o+(t+1<<4)|0}if(!x){if((a|0)==(y|0)){i=e;return}c[u>>2]=a+(~((a+-16-y|0)>>>4)<<4);i=e;return}if((w|0)==(b|0)){i=e;return}else{D=a;E=w}do{if(!D)F=0;else{c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];c[D+12>>2]=c[E+12>>2];F=c[u>>2]|0}D=F+16|0;c[u>>2]=D;E=E+16|0}while((E|0)!=(b|0));i=e;return}function k8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>4;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<4);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];o=c[h>>2]|0}m=o+16|0;c[h>>2]=m;n=n+16|0}while((n|0)!=(b|0));i=f;return}function l8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>m-o>>2>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~((q+-4-o|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if((j|0)<0)vxi(a);j=p-0|0;if(j>>2>>>0<1073741823){p=j>>1;j=p>>>0<k>>>0?k:p;if((j|0)<0)vxi(a);else r=j}else r=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(r<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(r<<2);if((h|0)==(b|0)){i=e;return}else{s=g;t=h}do{if(!s)u=0;else{c[s>>2]=c[t>>2];u=c[f>>2]|0}s=u+4|0;c[f>>2]=s;t=t+4|0}while((t|0)!=(b|0));i=e;return}t=a+4|0;a=c[t>>2]|0;s=a-o>>2;if(k>>>0>s>>>0){v=h+(s<<2)|0;w=1}else{v=b;w=0}if((h|0)==(v|0))x=n;else{s=(v+-4-d|0)>>>2;d=n;k=h;while(1){c[d>>2]=c[k>>2];k=k+4|0;if((k|0)==(v|0))break;else d=d+4|0}x=n+(s+1<<2)|0}if(!w){if((a|0)==(x|0)){i=e;return}c[t>>2]=a+(~((a+-4-x|0)>>>2)<<2);i=e;return}if((v|0)==(b|0)){i=e;return}else{y=a;z=v}do{if(!y)A=0;else{c[y>>2]=c[z>>2];A=c[t>>2]|0}y=A+4|0;c[t>>2]=y;z=z+4|0}while((z|0)!=(b|0));i=e;return}function m8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>2;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<2);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{c[m>>2]=c[n>>2];o=c[h>>2]|0}m=o+4|0;c[h>>2]=m;n=n+4|0}while((n|0)!=(b|0));i=f;return}function n8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>2>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>2;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>2<<2)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-4-t|0)>>>2)<<2);i=e;return}t=h+(r<<2)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-4-t|0)>>>2;s=q;u=t;while(1){if(s)c[s>>2]=c[u>>2];u=u+4|0;if((u|0)==(b|0))break;else s=s+4|0}c[p>>2]=q+(r+1<<2);i=e;return}if(!n)v=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-4-o|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;v=0}if((j|0)<0)vxi(a);j=v-0|0;if(j>>2>>>0<1073741823){v=j>>1;j=v>>>0<k>>>0?k:v;if((j|0)<0)vxi(a);else w=j}else w=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(w<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(w<<2);if((h|0)==(b|0)){i=e;return}w=(b+-4-d|0)>>>2;d=g;l=h;while(1){if(d)c[d>>2]=c[l>>2];l=l+4|0;if((l|0)==(b|0))break;else d=d+4|0}c[f>>2]=g+(w+1<<2);i=e;return}function o8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function p8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((((c[g>>2]|0)-j|0)/80|0)>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;if(!b){m=0;n=l;o=h}else{c[f>>2]=89;c[e+0>>2]=c[f+0>>2];h=cOb(b*80|0,16,e,0,3653512,80)|0;m=h;n=c[k>>2]|0;o=c[a>>2]|0}h=m+(((l-j|0)/80|0)*80|0)|0;j=m+(b*80|0)|0;if((n|0)!=(o|0)){b=n;m=h;while(1){l=m+-80|0;p=b;b=b+-80|0;q=l+0|0;r=b+0|0;s=q+56|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));r=c[p+-20>>2]|0;c[m+-20>>2]=r;q=m+-16|0;c[q>>2]=0;s=m+-12|0;c[s>>2]=0;t=m+-24|0;c[t>>2]=0;u=c[p+-24>>2]|0;v=c[p+-16>>2]<<4;w=v>>4;c[q>>2]=w;if(!w){x=0;y=0}else{c[s>>2]=w;c[f>>2]=r;c[e+0>>2]=c[f+0>>2];r=hOb(0,v,4,e,0,3653512,370)|0;c[t>>2]=r;x=r;y=c[q>>2]<<4}YEi(x|0,u|0,y|0)|0;u=p+-8|0;q=c[u+4>>2]|0;r=m+-8|0;c[r>>2]=c[u>>2];c[r+4>>2]=q;if((b|0)==(o|0)){z=l;break}else m=l}m=c[a>>2]|0;o=c[k>>2]|0;c[a>>2]=z;c[k>>2]=h;c[g>>2]=j;if((o|0)==(m|0))A=m;else{z=o;do{if((c[z+-12>>2]|0)>-1){o=z+-24|0;b=c[o>>2]|0;c[f>>2]=c[z+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(b,e);c[o>>2]=0}z=z+-80|0}while((z|0)!=(m|0));A=m}}else{c[a>>2]=h;c[k>>2]=h;c[g>>2]=j;A=n}if(!A){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(A,e);i=d;return}function q8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;j=h;k=b-j|0;l=(k|0)/80|0;m=a+8|0;n=c[a>>2]|0;o=n;if(l>>>0>(((c[m>>2]|0)-o|0)/80|0)>>>0){B8c(a);if((k|0)<0)vxi(a);k=((c[m>>2]|0)-(c[a>>2]|0)|0)/80|0;if(k>>>0<1073741823){p=k<<1;k=p>>>0<l>>>0?l:p;if((k|0)<0)vxi(a);else q=k}else q=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];k=cOb(q*80|0,16,f,0,3653512,80)|0;p=a+4|0;c[p>>2]=k;c[a>>2]=k;c[m>>2]=k+(q*80|0);if((h|0)==(b|0)){i=e;return}q=k;k=h;do{if(!q)r=0;else{s=q+0|0;t=k+0|0;u=s+56|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));m=c[k+60>>2]|0;c[q+60>>2]=m;v=q+64|0;c[v>>2]=0;w=q+68|0;c[w>>2]=0;x=q+56|0;c[x>>2]=0;y=c[k+56>>2]|0;z=c[k+64>>2]<<4;A=z>>4;c[v>>2]=A;if(!A){B=0;C=0}else{c[w>>2]=A;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];m=hOb(0,z,4,f,0,3653512,370)|0;c[x>>2]=m;B=m;C=c[v>>2]<<4}YEi(B|0,y|0,C|0)|0;y=k+72|0;v=c[y+4>>2]|0;m=q+72|0;c[m>>2]=c[y>>2];c[m+4>>2]=v;r=c[p>>2]|0}q=r+80|0;c[p>>2]=q;k=k+80|0}while((k|0)!=(b|0));i=e;return}k=a+4|0;a=((c[k>>2]|0)-o|0)/80|0;if(l>>>0>a>>>0){D=h+(a*80|0)|0;E=1}else{D=b;E=0}if((h|0)==(D|0))F=n;else{b=((D+-80-j|0)>>>0)/80|0;j=n;a=h;while(1){c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[j+20>>2]=c[a+20>>2];c[j+24>>2]=c[a+24>>2];h=j+28|0;l=a+28|0;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[h+16>>2]=c[l+16>>2];c[h+20>>2]=c[l+20>>2];c[h+24>>2]=c[l+24>>2];l=j+56|0;if((a|0)!=(j|0)){h=c[a+56>>2]|0;o=c[a+64>>2]<<4;q=o>>4;p=j+64|0;c[p>>2]=q;r=j+68|0;C=c[r>>2]|0;do if((C&2147483647)>>>0<q>>>0)if((C|0)>-1){c[r>>2]=q;B=c[l>>2]|0;c[g>>2]=c[j+60>>2];c[f+0>>2]=c[g+0>>2];v=hOb(B,o,4,f,0,3653512,370)|0;c[l>>2]=v;G=v;break}else{c[g>>2]=c[j+60>>2];c[f+0>>2]=c[g+0>>2];v=cOb(o,4,f,0,3653512,352)|0;YEi(v|0,c[l>>2]|0,c[p>>2]<<4|0)|0;c[r>>2]=q;c[l>>2]=v;G=v;break}else G=c[l>>2]|0;while(0);YEi(G|0,h|0,c[p>>2]<<4|0)|0}l=a+72|0;q=c[l+4>>2]|0;r=j+72|0;c[r>>2]=c[l>>2];c[r+4>>2]=q;a=a+80|0;if((a|0)==(D|0))break;else j=j+80|0}F=n+((b+1|0)*80|0)|0}if(!E){E=c[k>>2]|0;if((E|0)==(F|0)){i=e;return}b=E;while(1){E=b+-80|0;c[k>>2]=E;if((c[b+-12>>2]|0)>-1){n=b+-24|0;j=c[n>>2]|0;c[g>>2]=c[b+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(j,f);c[n>>2]=0;H=c[k>>2]|0}else H=E;if((H|0)==(F|0))break;else b=H}i=e;return}H=c[d>>2]|0;if((D|0)==(H|0)){i=e;return}d=c[k>>2]|0;b=D;do{if(!d)I=0;else{s=d+0|0;t=b+0|0;u=s+56|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));p=c[b+60>>2]|0;c[d+60>>2]=p;h=d+64|0;c[h>>2]=0;D=d+68|0;c[D>>2]=0;F=d+56|0;c[F>>2]=0;E=c[b+56>>2]|0;n=c[b+64>>2]<<4;j=n>>4;c[h>>2]=j;if(!j){J=0;K=0}else{c[D>>2]=j;c[g>>2]=p;c[f+0>>2]=c[g+0>>2];p=hOb(0,n,4,f,0,3653512,370)|0;c[F>>2]=p;J=p;K=c[h>>2]<<4}YEi(J|0,E|0,K|0)|0;E=b+72|0;h=c[E+4>>2]|0;p=d+72|0;c[p>>2]=c[E>>2];c[p+4>>2]=h;I=c[k>>2]|0}d=I+80|0;c[k>>2]=d;b=b+80|0}while((b|0)!=(H|0));i=e;return}function r8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];l=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=l;c[a>>2]=l;c[j>>2]=l+(((d|0)/80|0)*80|0);d=l;l=k;do{if(!d)m=0;else{k=d+0|0;j=l+0|0;a=k+56|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(a|0));j=c[l+60>>2]|0;c[d+60>>2]=j;k=d+64|0;c[k>>2]=0;a=d+68|0;c[a>>2]=0;n=d+56|0;c[n>>2]=0;o=c[l+56>>2]|0;p=c[l+64>>2]<<4;q=p>>4;c[k>>2]=q;if(!q){r=0;s=0}else{c[a>>2]=q;c[g>>2]=j;c[e+0>>2]=c[g+0>>2];j=hOb(0,p,4,e,0,3653512,370)|0;c[n>>2]=j;r=j;s=c[k>>2]<<4}YEi(r|0,o|0,s|0)|0;o=l+72|0;k=c[o+4>>2]|0;j=d+72|0;c[j>>2]=c[o>>2];c[j+4>>2]=k;m=c[h>>2]|0}d=m+80|0;c[h>>2]=d;l=l+80|0}while((l|0)!=(b|0));i=f;return}function s8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((((c[g>>2]|0)-j|0)/68|0)>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;m=(l-j|0)/68|0;if(!b){n=0;o=l;p=h}else{c[f>>2]=89;c[e+0>>2]=c[f+0>>2];h=cOb(b*68|0,16,e,0,3653512,80)|0;n=h;o=c[k>>2]|0;p=c[a>>2]|0}h=n+(m*68|0)|0;l=n+(b*68|0)|0;if((o|0)==(p|0)){q=h;r=o;s=o}else{b=m+-1-(((o+-68-p|0)>>>0)/68|0)|0;m=o;o=h;while(1){m=m+-68|0;j=o+-68+0|0;t=m+0|0;u=j+68|0;do{c[j>>2]=c[t>>2];j=j+4|0;t=t+4|0}while((j|0)<(u|0));if((m|0)==(p|0))break;else o=o+-68|0}q=n+(b*68|0)|0;r=c[a>>2]|0;s=c[k>>2]|0}c[a>>2]=q;c[k>>2]=h;c[g>>2]=l;l=s;while(1){if((l|0)==(r|0))break;l=l+-68|0}if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function t8c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=(k|0)/68|0;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0>((n-p|0)/68|0)>>>0){if(!o)q=n;else{n=a+4|0;while(1){r=c[n>>2]|0;if((r|0)==(o|0))break;c[n>>2]=r+-68}r=c[a>>2]|0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(r,g);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;q=0}if((k|0)<0)vxi(a);k=(q-0|0)/68|0;if(k>>>0<1073741823){q=k<<1;k=q>>>0<l>>>0?l:q;if((k|0)<0)vxi(a);else s=k}else s=2147483647;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];h=cOb(s*68|0,16,g,0,3653512,80)|0;g=a+4|0;c[g>>2]=h;c[a>>2]=h;c[m>>2]=h+(s*68|0);if((j|0)==(d|0)){i=f;return}else{t=h;u=j}do{if(!t)v=0;else{w=t+0|0;x=u+0|0;y=w+68|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));v=c[g>>2]|0}t=v+68|0;c[g>>2]=t;u=u+68|0}while((u|0)!=(d|0));i=f;return}u=a+4|0;a=((c[u>>2]|0)-p|0)/68|0;if(l>>>0>a>>>0){z=j+(a*68|0)|0;A=1}else{z=d;A=0}if((j|0)==(z|0))B=o;else{a=((z+-68-e|0)>>>0)/68|0;e=o;l=j;while(1){c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];c[e+16>>2]=c[l+16>>2];c[e+20>>2]=c[l+20>>2];c[e+24>>2]=c[l+24>>2];c[e+28>>2]=c[l+28>>2];w=e+32|0;x=l+32|0;y=w+34|0;do{b[w>>1]=b[x>>1]|0;w=w+2|0;x=x+2|0}while((w|0)<(y|0));l=l+68|0;if((l|0)==(z|0))break;else e=e+68|0}B=o+((a+1|0)*68|0)|0}if(!A){while(1){A=c[u>>2]|0;if((A|0)==(B|0))break;c[u>>2]=A+-68}i=f;return}if((z|0)==(d|0)){i=f;return}B=c[u>>2]|0;A=z;do{if(!B)C=0;else{w=B+0|0;x=A+0|0;y=w+68|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));C=c[u>>2]|0}B=C+68|0;c[u>>2]=B;A=A+68|0}while((A|0)!=(d|0));i=f;return}function u8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/68|0)*68|0);d=g;g=k;do{if(!d)l=0;else{k=d+0|0;j=g+0|0;a=k+68|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(a|0));l=c[h>>2]|0}d=l+68|0;c[h>>2]=d;g=g+68|0}while((g|0)!=(b|0));i=f;return}function v8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((c[g>>2]|0)-j>>4>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;m=l-j>>4;if(!b){n=h;o=0;p=l}else{c[f>>2]=89;c[e+0>>2]=c[f+0>>2];l=cOb(b<<4,16,e,0,3653512,80)|0;n=c[a>>2]|0;o=l;p=c[k>>2]|0}l=o+(m<<4)|0;h=o+(b<<4)|0;if((p|0)==(n|0)){q=l;r=p}else{b=p+-16-n|0;j=p;p=l;while(1){s=j;j=j+-16|0;c[p+-16>>2]=c[j>>2];c[p+-12>>2]=c[s+-12>>2];c[p+-8>>2]=c[s+-8>>2];c[p+-4>>2]=c[s+-4>>2];if((j|0)==(n|0))break;else p=p+-16|0}q=o+(m+~(b>>>4)<<4)|0;r=n}c[a>>2]=q;c[k>>2]=l;c[g>>2]=h;if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function w8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>4;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=m-o>>4>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=q>>4;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;t=n+(s>>4<<4)|0;s=c[p>>2]|0;if((s|0)==(t|0)){i=e;return}c[p>>2]=s+(~((s+-16-t|0)>>>4)<<4);i=e;return}t=h+(r<<4)|0;aFi(n|0,h|0,q|0)|0;if((t|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=(b+-16-t|0)>>>4;s=q;u=t;while(1){if(s){c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2]}u=u+16|0;if((u|0)==(b|0))break;else s=s+16|0}c[p>>2]=q+(r+1<<4);i=e;return}if(!n)v=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~((r+-16-o|0)>>>4)<<4);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;v=0}if((j|0)<0)vxi(a);j=v-0|0;if(j>>4>>>0<1073741823){v=j>>3;j=v>>>0<k>>>0?k:v;if((j|0)<0)vxi(a);else w=j}else w=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(w<<4,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(w<<4);if((h|0)==(b|0)){i=e;return}w=(b+-16-d|0)>>>4;d=g;l=h;while(1){if(d){c[d>>2]=c[l>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2]}l=l+16|0;if((l|0)==(b|0))break;else d=d+16|0}c[f>>2]=g+(w+1<<4);i=e;return}function x8c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>4;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<4);if((k|0)==(b|0)){i=f;return}m=(b+-16-d|0)>>>4;d=g;j=k;while(1){if(d){c[d>>2]=c[j>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2]}j=j+16|0;if((j|0)==(b|0))break;else d=d+16|0}c[h>>2]=g+(m+1<<4);i=f;return}function y8c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=n+-12|0;p=m;m=m+-12|0;if(!(a[m>>0]&1)){c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2]}else{q=c[p+-4>>2]|0;r=c[p+-8>>2]|0;if(r>>>0>2147483631){s=7;break}if(r>>>0<11){a[o>>0]=r<<1;t=o+1|0}else{p=r+16&-16;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];u=cOb(p,16,f,0,3653512,80)|0;c[n+-4>>2]=u;c[o>>2]=p|1;c[n+-8>>2]=r;t=u}YEi(t|0,q|0,r|0)|0;a[t+r>>0]=0}r=(c[l>>2]|0)+-12|0;c[l>>2]=r;if((m|0)==(h|0)){v=r;s=13;break}else n=r}if((s|0)==7)ori(o);else if((s|0)==13){w=v;x=c[b>>2]|0;break}}else{w=c[l>>2]|0;x=h}while(0);c[b>>2]=w;c[l>>2]=x;x=d+8|0;w=c[j>>2]|0;c[j>>2]=c[x>>2];c[x>>2]=w;w=b+8|0;b=d+12|0;x=c[w>>2]|0;c[w>>2]=c[b>>2];c[b>>2]=x;c[d>>2]=c[l>>2];i=e;return}function z8c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;if(!h){i=d;return}j=b+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-292|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-284>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[b>>2]|0}c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[b+8>>2]=0;c[j>>2]=0;c[b>>2]=0;i=d;return}function A8c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;if(!h){i=d;return}j=b+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-12|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-4>>2]|0;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[b>>2]|0}c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[b+8>>2]=0;c[j>>2]=0;c[b>>2]=0;i=d;return}function B8c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(!f){i=b;return}g=a+4|0;h=c[g>>2]|0;if((h|0)==(f|0))j=f;else{k=h;while(1){h=k+-80|0;c[g>>2]=h;if((c[k+-12>>2]|0)>-1){l=k+-24|0;m=c[l>>2]|0;c[e>>2]=c[k+-20>>2];c[d+0>>2]=c[e+0>>2];eOb(m,d);c[l>>2]=0;n=c[g>>2]|0}else n=h;if((n|0)==(f|0))break;else k=n}j=c[a>>2]|0}c[e>>2]=89;c[d+0>>2]=c[e+0>>2];eOb(j,d);c[a+8>>2]=0;c[g>>2]=0;c[a>>2]=0;i=b;return}function C8c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;c[b>>2]=0;h=b+4|0;a[h>>0]=1;j=b+8|0;c[j>>2]=0;c[b+12>>2]=0;k=b+28|0;a[k>>0]=1;c[b+32>>2]=0;c[b+36>>2]=0;l=Osc(e)|0;m=(Psc(l)|0)==29;a[b+20>>0]=m&1;if(m){c[b>>2]=e;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[b+16>>2]=Qsc(l)|0;i=f;return}m=$sc(l)|0;c[b>>2]=Vrc(m)|0;MVc(g,e,d,0);c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];if(!(c[j>>2]|0))ds(m)|0;c[b+24>>2]=e;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[b+16>>2]=Qsc(Osc(c[b>>2]|0)|0)|0;i=f;return}function D8c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+4|0;c[f>>2]=-1;g=Nsc(c[d>>2]|0)|0;h=c[d+8>>2]|0;j=c[h+((a[d+4>>0]|0)!=0?g:g+-8|0)>>2]|0;c[b>>2]=j;if(!j){i=e;return}if(!(a[d+20>>0]|0))k=c[h+12>>2]|0;else k=Ysc(j)|0;c[f>>2]=k;i=e;return}function E8c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=Nsc(c[b>>2]|0)|0;g=b+8|0;c[(c[g>>2]|0)+((a[b+4>>0]|0)!=0?f:f+-8|0)>>2]=c[d>>2];if(a[b+20>>0]|0){i=e;return}f=c[g>>2]|0;c[f+12>>2]=c[d+4>>2];d=Nsc(c[b+24>>2]|0)|0;c[(c[b+32>>2]|0)+((a[b+28>>0]|0)!=0?d:d+-8|0)>>2]=f;i=e;return}function F8c(a){a=a|0;return c[a+16>>2]|0}function G8c(b){b=b|0;c[b>>2]=0;c[b+4>>2]=0;c[b+16>>2]=0;c[b+24>>2]=0;c[b+32>>2]=0;a[b+52>>0]=0;return}function H8c(b,d){b=b|0;d=d|0;var e=0;e=b+24|0;c[e+0>>2]=c[d+0>>2];a[e+4>>0]=a[d+4>>0]|0;return}function I8c(b,d){b=b|0;d=d|0;var e=0;e=b+32|0;c[e+0>>2]=c[d+0>>2];a[e+4>>0]=a[d+4>>0]|0;return}function J8c(a,b){a=a|0;b=b|0;var d=0;d=i;if((c[b+40>>2]|0)==(a|0)){K8c(b);i=d;return}else{Krd(614888,0,3653512,65,1,0,0,0);i=d;return}}function K8c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+224|0;d=b+216|0;e=b+8|0;f=b;g=b+208|0;h=a+44|0;c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=0;j=a+24|0;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k;c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];jbd(e,d);c[e+12>>2]=c[a+8>>2];d=a+40|0;c[e+20>>2]=m9c(c[d>>2]|0)|0;c[e+16>>2]=c[(c[d>>2]|0)+4>>2];if(obd(e,g)|0)m=(c[g>>2]|0)==0;else m=0;e=(c[h>>2]|0)==1;h=a+56|0;L8c(a);if(e|(c[g>>2]|0)!=0){i=b;return}if(m){if(!(c[d>>2]|0)){i=b;return}N8c(a);i=b;return}a=c[h>>2]|0;if(!a){i=b;return}c[a+60>>2]=0;c[h>>2]=0;if(c[a+40>>2]|0)K8c(a);L8c(a);i=b;return}function L8c(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+44|0;f=(c[e>>2]|0)+-1|0;c[e>>2]=f;if((f|0)>0){i=d;return}a[b+52>>0]=1;f=b+56|0;e=c[f>>2]|0;if(e){L8c(e);c[f>>2]=0}f=c[b+60>>2]|0;if(f)c[f+56>>2]=0;f=c[b>>2]|0;if(f){e=b+4|0;c[f+4>>2]=c[e>>2];c[c[e>>2]>>2]=f;c[b>>2]=0;c[e>>2]=0}e=b+64|0;f=c[e>>2]|0;if(f){DOc(f,0,0,0,0);IOc(c[e>>2]|0);c[e>>2]=0}e=b+12|0;Csc(c[e>>2]|0);c[e>>2]=0;if((c[b+48>>2]|0)!=0|(b|0)==0){i=d;return}ACi(b);i=d;return}function M8c(a){a=a|0;var b=0,d=0;b=i;d=a+48|0;if(!(c[d>>2]|0)){i=b;return}if(c[a+44>>2]|0){c[d>>2]=0;i=b;return}if(c[a>>2]|0)Krd(614920,0,3653512,151,1,0,0,0);if(!a){i=b;return}ACi(a);i=b;return}function N8c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+224|0;d=b+216|0;e=b+212|0;f=b+8|0;g=b;h=b+208|0;c[e>>2]=0;j=a+32|0;k=c[j+4>>2]|0;l=g;c[l>>2]=c[j>>2];c[l+4>>2]=k;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];jbd(f,d);c[f+12>>2]=c[a+8>>2];d=a+40|0;g=c[d>>2]|0;c[f+16>>2]=c[g+4>>2];c[f+20>>2]=m9c(g)|0;g=qbd(f,e)|0;if(c[e>>2]|0){i=b;return}if(g){O8c(a,g);i=b;return}g=a+44|0;c[g>>2]=(c[g>>2]|0)+1;g=c[d>>2]|0;if(!g)m=0;else m=c[g+4>>2]|0;c[h>>2]=m;dlc(3012,h,ea(0.0),a,ea(0.0),3512,10);i=b;return}function O8c(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+32|0;f=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;n=vsc(d)|0;o=Atc()|0;if(msc(n,c[o+220>>2]|0)|0){p=b+44|0;c[p>>2]=(c[p>>2]|0)+1;q=ea(g[d+8>>2]);p=c[b+40>>2]|0;if(!p)r=0;else r=c[p+4>>2]|0;c[f>>2]=r;dlc(3012,f,q,b,ea(0.0),3512,10);i=e;return}if(msc(n,c[o+224>>2]|0)|0){f=b+44|0;c[f>>2]=(c[f>>2]|0)+1;f=c[b+40>>2]|0;if(!f)s=0;else s=c[f+4>>2]|0;c[h>>2]=s;dlc(3012,h,ea(0.0),b,ea(0.0),3512,1);i=e;return}if(msc(n,c[o+228>>2]|0)|0){h=b+44|0;c[h>>2]=(c[h>>2]|0)+1;h=c[b+40>>2]|0;if(!h)t=0;else t=c[h+4>>2]|0;c[j>>2]=t;dlc(3012,j,ea(-1.0),b,ea(0.0),3512,32);i=e;return}if(msc(n,c[o+256>>2]|0)|0){j=c[d+8>>2]|0;if(a[j+52>>0]|0){K8c(b);i=e;return}t=j+56|0;if(!(c[t>>2]|0)){h=b+44|0;c[h>>2]=(c[h>>2]|0)+1;c[t>>2]=b;c[b+60>>2]=j;i=e;return}j=c[b+40>>2]|0;if(!j)u=0;else u=c[j+4>>2]|0;Krd(614944,0,3653512,341,4,u,0,0);i=e;return}u=c[o+248>>2]|0;if((u|0)!=0?msc(n,u)|0:0){u=c[d+8>>2]|0;if(!u){i=e;return}j=b+44|0;c[j>>2]=(c[j>>2]|0)+1;scc(u,3012,c[b+40>>2]|0,b,3512);i=e;return}if(!((d|0)==0|(msc(n,c[o+488>>2]|0)|0)^1)?(o=c[d+8>>2]|0,(o|0)!=0):0){d=b+44|0;c[d>>2]=(c[d>>2]|0)+1;if(mo[c[(c[o>>2]|0)+8>>2]&4095](o)|0){d=c[b+40>>2]|0;if(!d)v=0;else v=c[d+4>>2]|0;c[k>>2]=v;dlc(3012,k,ea(0.0),b,ea(0.0),3512,10);i=e;return}if(!(c[o+8>>2]|0)){DOc(o,3012,c[b+40>>2]|0,b,3512);c[b+64>>2]=o;HOc(o);i=e;return}Krd(615064,0,3653512,381,1,0,0,0);o=c[b+40>>2]|0;if(!o)w=0;else w=c[o+4>>2]|0;c[l>>2]=w;dlc(3012,l,ea(0.0),b,ea(0.0),3512,10);i=e;return}l=b+44|0;c[l>>2]=(c[l>>2]|0)+1;l=c[b+40>>2]|0;if(!l)x=0;else x=c[l+4>>2]|0;c[m>>2]=x;dlc(3012,m,ea(0.0),b,ea(0.0),3512,10);i=e;return}function P8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;Hkc(b,d);c[a>>2]=c[b+32>>2];add(d,620384,615200,a,0);g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;add(d,792256,c[142270]|0,a,1);a=d+12|0;h=d+20|0;c[(c[c[a>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(d);add(d,792272,c[142290]|0,g,1);c[(c[c[a>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(d);bdd(d);add(d,2487248,c[142294]|0,b+36|0,1);$cd(d,2646336,2646336,f,1);add(d,3142592,c[142260]|0,e+16|0,0);c[(c[c[a>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);i=e;return}function Q8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;qdd(b,792072,2454944,0,1)|0;Y8c(e,a,b);P9c(a,e,0);e=a+20|0;if(!(c[e>>2]|0)){sdd(b);i=d;return}pdd(b,ksc(m9c(a)|0)|0);f=c[e>>2]|0;e=m9c(a)|0;TVc(b,f,e,c[a+48>>2]|0);sdd(b);i=d;return}function R8c(a,b){a=a|0;b=b|0;var c=0;c=i;S8c(a,b);i=c;return}function S8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;Kkc(a,b);c[e>>2]=c[a+32>>2];Ptc(e,b);OXb(b,a+36|0,1);Mdd(b);P9c(a,e,0);e=c[a+20>>2]|0;if(!e){i=d;return}f=m9c(a)|0;UVc(b,e,f,c[a+48>>2]|0);i=d;return}function T8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;Lkc(a,b);c[e>>2]=c[a+32>>2];Qtc(e,b);FXb(b,a+36|0,2487248,1);e=c[a+20>>2]|0;if(!e){i=d;return}f=m9c(a)|0;PVc(b,e,f,c[a+48>>2]|0);i=d;return}function U8c(a,b){a=a|0;b=b|0;var c=0;c=i;V8c(a,b);i=c;return}function V8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;Jkc(a,b);c[e>>2]=c[a+32>>2];Ntc(e,b);NXb(b,a+36|0,1);Ndd(b);P9c(a,e,0);e=c[a+20>>2]|0;if(!e){i=d;return}f=m9c(a)|0;QVc(b,e,f,c[a+48>>2]|0);i=d;return}function W8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;add(b,792072,2454944,0,0);P8c(d,a,b);e=c[a+20>>2]|0;if(!e){bdd(b);i=d;return}f=m9c(a)|0;SVc(b,e,f,c[a+48>>2]|0);bdd(b);i=d;return}function X8c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;Mkc(b,d);g=c[b+32>>2]|0;c[f>>2]=g;h=c[d+12>>2]|0;j=xo[c[c[h>>2]>>2]&2047](h,g,c[d+28>>2]|0)|0;if(a[d+32>>0]|0){c[f>>2]=j;P9c(b,f,0)}f=c[b+20>>2]|0;if(!f){i=e;return}j=m9c(b)|0;RVc(d,f,j,c[b+48>>2]|0);i=e;return}function Y8c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;Ikc(b,d);c[a>>2]=c[b+32>>2];g=qdd(d,620384,615200,f,1)|0;if(g){if((g|0)<=0){g=c[f>>2]|0;if(g)_n[g&4095](a,d)|0}else Rtc(a,d);sdd(d)}a=b+36|0;b=qdd(d,2487248,c[142294]|0,f,0)|0;if(!b){i=e;return}if((b|0)<=0){b=c[f>>2]|0;if(b)_n[b&4095](a,d)|0}else zXb(d,a,1);sdd(d);i=e;return}function Z8c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=i;b=_8c(a,d)|0;i=c;return b|0}function _8c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d;if(!b){g=Pcd(a)|0;i=d;return g|0}if(!a){g=0;i=d;return g|0}c[f>>2]=a;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,f);h=c[e>>2]|0;j=c[b+28>>2]|0;if((h|0)==-1){k=j+(c[b+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((k|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[k+4>>2]|0,(b|0)!=0):0){g=Ecd(b)|0;i=d;return g|0}}b=cfd(kfd()|0,a)|0;if(!b){g=0;i=d;return g|0}g=Ecd(b)|0;i=d;return g|0}function $8c(){var a=0;a=i;QQb(114,162,163,0,164);i=a;return}function a9c(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,2454944,13);wQb(114,8,b,136,2637,0,1);xri(b);i=a;return}function b9c(){var a=0;a=i;RTb(114,1820,1733);Ydd(2386184,2484168,2381360);Ydd(2454944,615720,615744);Rad();i=a;return}function c9c(){var a=0;a=i;Sad();i=a;return}function d9c(a){a=a|0;return 114}function e9c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];bUb(b,g,e);a[b+28>>0]=1;a[b+29>>0]=0;c[b>>2]=615232;e=b+32|0;g=b+56|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[g>>2]=g;c[b+60>>2]=g;c[b+64>>2]=0;c[b+68>>2]=0;c[b+72>>2]=b;c[b+76>>2]=0;c[b+80>>2]=0;c[b+84>>2]=b;c[b+88>>2]=0;c[b+92>>2]=0;c[b+96>>2]=b;c[b+100>>2]=0;c[b+104>>2]=0;c[b+108>>2]=b;c[b+112>>2]=0;c[b+116>>2]=0;c[b+120>>2]=b;c[b+52>>2]=0;c[b+48>>2]=0;a[b+131>>0]=0;a[b+129>>0]=0;a[b+128>>0]=0;a[b+130>>0]=1;c[b+124>>2]=0;c[b+132>>2]=0;i=f;return}function f9c(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+64|0;e=c[d>>2]|0;if(e){f=a+68|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}f=a+76|0;d=c[f>>2]|0;if(d){e=a+80|0;c[d+4>>2]=c[e>>2];c[c[e>>2]>>2]=d;c[f>>2]=0;c[e>>2]=0}e=a+88|0;f=c[e>>2]|0;if(f){d=a+92|0;c[f+4>>2]=c[d>>2];c[c[d>>2]>>2]=f;c[e>>2]=0;c[d>>2]=0}d=a+100|0;e=c[d>>2]|0;if(e){f=a+104|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}f=a+112|0;d=c[f>>2]|0;if(d){e=a+116|0;c[d+4>>2]=c[e>>2];c[c[e>>2]>>2]=d;c[f>>2]=0;c[e>>2]=0}e=ELc()|0;In[c[(c[e>>2]|0)+48>>2]&4095](e,c[a+132>>2]|0);e=a+48|0;a=c[e>>2]|0;if(!a){i=b;return}Iad(a);c[e>>2]=0;i=b;return}function g9c(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+124|0;a=c[d>>2]|0;if(a){e=a;i=b;return e|0}a=xCi(44)|0;sIc(a);c[d>>2]=a;e=a;i=b;return e|0}function h9c(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+224|0;f=e+216|0;g=e+8|0;h=e;j=e+208|0;k=b+32|0;l=c[k>>2]|0;if(!l){m=1;i=e;return m|0}c[j>>2]=l;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,j);n=c[f>>2]|0;o=c[l+28>>2]|0;if((n|0)==-1){p=o+(c[l+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((p|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[p+4>>2]|0,(l|0)!=0):0)q=l;else r=10}else r=10;if((r|0)==10)q=hQb(c[k>>2]|0)|0;k=b+20|0;r=c[k>>2]|0;if((r|0)==0|(q|0)==0){m=1;i=e;return m|0}q=c[b+48>>2]|0;do if(q){if(!(a[q+32>>0]|0)){if(((c[q+24>>2]|0)+-1|0)>>>0>=2)break}else if((a[q+33>>0]|0)==0?(c[b+8>>2]&1048576|0)!=0:0)break;l=b+52|0;p=(c[l>>2]|0)+64|0;j=c[p>>2]|0;n=c[p+4>>2]|0;if(j){p=h;c[p>>2]=j;c[p+4>>2]=n;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];jbd(g,f);c[g+12>>2]=r;a[g+25>>0]=1;c[g+16>>2]=Grc(r)|0;sbd(g);zbd(g)|0}if((Erc(r)|0)!=0?(p=c[l>>2]|0,l=c[p+72>>2]|0,(l|0)!=0):0){j=d[p+76>>0]|n&-256;n=c[k>>2]|0;p=h;c[p>>2]=l;c[p+4>>2]=j;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];jbd(g,f);c[g+12>>2]=n;a[g+25>>0]=1;c[g+16>>2]=Grc(n)|0;sbd(g);zbd(g)|0}}while(0);m=(Erc(r)|0)!=0;i=e;return m|0}function i9c(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+224|0;f=e+208|0;g=e+8|0;h=e;j=b+131|0;if(a[j>>0]|0){Krd(615368,0,3653512,249,1,0,0,0);i=e;return}a[j>>0]=1;j=b+20|0;k=c[j>>2]|0;if(!k){i=e;return}if(!(a[b+128>>0]|0)){i=e;return}l=c[b+48>>2]|0;if((l|0)!=0?((c[l+24>>2]|0)+-1|0)>>>0<2:0){l=b+52|0;m=c[l>>2]|0;n=c[m+64>>2]|0;o=a[m+68>>0]|0;if(n){m=h;c[m>>2]=n;c[m+4>>2]=o&255;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];jbd(g,f);c[g+12>>2]=k;a[g+25>>0]=1;c[g+16>>2]=Grc(k)|0;sbd(g);zbd(g)|0}if(Erc(k)|0){m=c[l>>2]|0;l=c[m+72>>2]|0;n=a[m+76>>0]|0;m=n&255;if(!l)p=m;else{q=c[j>>2]|0;r=h;c[r>>2]=l;c[r+4>>2]=n&255;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];jbd(g,f);c[g+12>>2]=q;a[g+25>>0]=1;c[g+16>>2]=Grc(q)|0;sbd(g);zbd(g)|0;p=m}}else p=o&255}else p=0;if(!(Erc(k)|0)){i=e;return}k=c[b+52>>2]|0;b=c[k+128>>2]|0;if(!b){i=e;return}o=d[k+132>>0]|p&-256;p=c[j>>2]|0;j=h;c[j>>2]=b;c[j+4>>2]=o;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];jbd(g,f);c[g+12>>2]=p;a[g+25>>0]=1;c[g+16>>2]=Grc(p)|0;sbd(g);zbd(g)|0;i=e;return}function j9c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+240|0;e=d+224|0;f=d+8|0;g=d;h=d+212|0;j=d+208|0;k=b+64|0;l=c[k>>2]|0;if(l){m=b+68|0;c[l+4>>2]=c[m>>2];c[c[m>>2]>>2]=l;c[k>>2]=0;c[m>>2]=0}m=b+76|0;k=c[m>>2]|0;if(k){l=b+80|0;c[k+4>>2]=c[l>>2];c[c[l>>2]>>2]=k;c[m>>2]=0;c[l>>2]=0}l=b+88|0;m=c[l>>2]|0;if(m){k=b+92|0;c[m+4>>2]=c[k>>2];c[c[k>>2]>>2]=m;c[l>>2]=0;c[k>>2]=0}k=b+100|0;l=c[k>>2]|0;if(l){m=b+104|0;c[l+4>>2]=c[m>>2];c[c[m>>2]>>2]=l;c[k>>2]=0;c[m>>2]=0}m=b+112|0;k=c[m>>2]|0;if(k){l=b+116|0;c[k+4>>2]=c[l>>2];c[c[l>>2]>>2]=k;c[m>>2]=0;c[l>>2]=0}l=b+20|0;if(((c[l>>2]|0)!=0?(c[(c[b+52>>2]|0)+96>>2]|0)!=0:0)?(m=ATb(c[b+24>>2]|0,20)|0,(m|0)!=0):0){c[h>>2]=b;c[h+4>>2]=1821;a[h+8>>0]=0;a[h+9>>0]=0;n0b(m,h)}h=c[b+48>>2]|0;if((((h|0)!=0?(a[h+32>>0]|0)!=0:0)?(a[h+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0){i=d;return}h=c[l>>2]|0;if(!h){i=d;return}if(((Erc(h)|0)!=0?(m=(c[b+52>>2]|0)+64|0,(c[m>>2]|0)!=0):0)?(a[b+128>>0]|0)!=0:0){k=m;m=c[k+4>>2]|0;n=c[l>>2]|0;o=g;c[o>>2]=c[k>>2];c[o+4>>2]=m;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];jbd(f,e);c[f+12>>2]=n;a[f+25>>0]=1;c[f+16>>2]=Grc(n)|0;sbd(f);zbd(f)|0}if(((Erc(h)|0)!=0?(n=(c[b+52>>2]|0)+72|0,(c[n>>2]|0)!=0):0)?(a[b+128>>0]|0)!=0:0){m=n;n=c[m+4>>2]|0;o=c[l>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=n;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];jbd(f,e);c[f+12>>2]=o;a[f+25>>0]=1;c[f+16>>2]=Grc(o)|0;sbd(f);zbd(f)|0}do if(Erc(h)|0){f=c[b+52>>2]|0;if((c[f+80>>2]|0)==0?(c[f+88>>2]|0)==0:0)break;f=elc()|0;if(!b)p=0;else p=c[b+4>>2]|0;c[j>>2]=p;flc(f,j,3013,0,0)}while(0);if(!(Erc(h)|0)){i=d;return}h=ELc()|0;if(!h){i=d;return}j=ELc()|0;if(!j){i=d;return}p=b+132|0;f=c[p>>2]|0;do if(!f){o=c[b+52>>2]|0;if(!o){i=d;return}if(!(c[o+136>>2]|0)){i=d;return}o=c[b+24>>2]|0;if(!o){i=d;return}if(vTb(o)|0){o=_n[c[(c[j>>2]|0)+44>>2]&4095](j,b)|0;c[p>>2]=o;q=o;break}else{i=d;return}}else q=f;while(0);f=_n[c[(c[j>>2]|0)+40>>2]&4095](j,q)|0;if(!f){i=d;return}co[c[(c[h>>2]|0)+56>>2]&2047](h,f,1);i=d;return}function k9c(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+224|0;h=g+216|0;j=g+16|0;k=g+8|0;l=g;m=c[b+48>>2]|0;if((((m|0)!=0?(a[m+32>>0]|0)!=0:0)?(a[m+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0){i=g;return}m=b+20|0;if(!(c[m>>2]|0)){i=g;return}n=b+129|0;if(!(a[n>>0]|0)){a[n>>0]=1;n=b+52|0;o=c[n>>2]|0;p=c[o+88>>2]|0;if(!p)q=o;else{r=d[o+92>>0]|0;o=j;c[o>>2]=p;c[o+4>>2]=r;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];B9c(b,h,0)|0;q=c[n>>2]|0}r=c[q+80>>2]|0;if(!r)s=n;else{o=d[q+84>>0]|0;q=k;c[q>>2]=r;c[q+4>>2]=o;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];B9c(b,h,0)|0;s=n}}else s=b+52|0;n=(c[s>>2]|0)+96|0;s=c[n>>2]|0;k=c[n+4>>2]|0;if(!s){i=g;return}n=c[m>>2]|0;m=l;c[m>>2]=s;c[m+4>>2]=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];jbd(j,h);c[j+12>>2]=n;n=j+32|0;cbd(n,Ecd(e)|0);cbd(n,Ecd(f)|0);c[j+16>>2]=c[b+4>>2];nbd(j)|0;i=g;return}function l9c(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=b+129|0;if(a[j>>0]|0){i=e;return}a[j>>0]=1;j=b+52|0;k=c[j>>2]|0;l=c[k+88>>2]|0;if(!l)m=k;else{n=d[k+92>>0]|0;k=g;c[k>>2]=l;c[k+4>>2]=n;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];B9c(b,f,0)|0;m=c[j>>2]|0}j=c[m+80>>2]|0;if(!j){i=e;return}g=d[m+84>>0]|0;m=h;c[m>>2]=j;c[m+4>>2]=g;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];B9c(b,f,0)|0;i=e;return}function m9c(a){a=a|0;var b=0,d=0;b=c[a+48>>2]|0;if(!b)d=0;else d=c[b+4>>2]|0;return d|0}function n9c(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+464|0;h=g+208|0;j=g+8|0;k=g;l=g+456|0;m=g+424|0;n=g+408|0;o=b+20|0;if(!(c[o>>2]|0)){p=0;i=g;return p|0}q=b+52|0;r=c[q>>2]|0;s=r+112|0;t=c[s>>2]|0;u=c[s+4>>2]|0;s=t;if(!t){p=0;i=g;return p|0}t=b+129|0;if(!(a[t>>0]|0)){a[t>>0]=1;t=c[r+88>>2]|0;if(!t)v=r;else{w=d[r+92>>0]|0;r=j;c[r>>2]=t;c[r+4>>2]=w;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];B9c(b,h,0)|0;v=c[q>>2]|0}q=c[v+80>>2]|0;if(q){w=d[v+84>>0]|0;v=k;c[v>>2]=q;c[v+4>>2]=w;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];B9c(b,h,0)|0}}if(!b){x=0;y=c[1]|0}else{k=c[b+4>>2]|0;x=k;y=k}k=c[o>>2]|0;o=rIc()|0;w=o+96|0;v=o+280|0;nIc(w,c[v>>2]|0);q=b+124|0;b=c[q>>2]|0;if(!b){r=xCi(44)|0;sIc(r);c[q>>2]=r;z=r}else z=b;yIc(o,z);ibd(h);z=h+32|0;$ad(z,f);$ad(z,y);$ad(z,e);z=h+4|0;y=(Xbd()|0)+436|0;c[z+0>>2]=c[y+0>>2];a[z+4>>0]=a[y+4>>0]|0;nbd(h)|0;c[l>>2]=c[h+28>>2];ubd(m);c[m+4>>2]=s;a[m+8>>0]=u;c[m+12>>2]=k;a[m+25>>0]=0;ybd(m,l)|0;if(!(c[l>>2]|0)){ibd(j);m=j+4|0;k=(Xbd()|0)+444|0;c[m+0>>2]=c[k+0>>2];a[m+4>>0]=a[k+4>>0]|0;$ad(j+32|0,e);nbd(j)|0;zIc(o);oIc(w,c[v>>2]|0);p=(c[c[v>>2]>>2]|0)==12;i=g;return p|0}kbd(j,3516336,3516216,2378232,2377968);cbd(j+32|0,c[l>>2]|0);e=pbd(j)|0;pIc(w);zIc(o);if(e){p=(c[c[v>>2]>>2]|0)==12;i=g;return p|0}else{v=c[l>>2]|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Rcd(v,x,n);xri(n);p=0;i=g;return p|0}return 0}function o9c(b){b=b|0;return (a[b+130>>0]|0)!=0|0}function p9c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=ELc()|0;do if(!d)e=0;else{f=a+132|0;g=c[f>>2]|0;if(!g){h=c[a+52>>2]|0;if(!h){e=0;break}if(!(c[h+136>>2]|0)){e=0;break}h=c[a+24>>2]|0;if(!h){e=0;break}if(!(vTb(h)|0)){e=0;break}h=_n[c[(c[d>>2]|0)+44>>2]&4095](d,a)|0;c[f>>2]=h;j=h}else j=g;e=_n[c[(c[d>>2]|0)+40>>2]&4095](d,j)|0}while(0);i=b;return e|0}function q9c(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=ELc()|0;if((d|0)!=0?(e=c[a+132>>2]|0,(e|0)!=0):0)f=_n[c[(c[d>>2]|0)+52>>2]&4095](d,e)|0;else f=0;i=b;return f|0}function r9c(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f+56|0;h=f+16|0;j=f+8|0;k=f+24|0;l=f;m=c[b+48>>2]|0;if((((m|0)!=0?(a[m+32>>0]|0)!=0:0)?(a[m+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0){i=f;return}m=b+20|0;n=c[m>>2]|0;if(!n){i=f;return}o=b+129|0;if(!(a[o>>0]|0)){a[o>>0]=1;o=b+52|0;p=c[o>>2]|0;q=c[p+88>>2]|0;if(!q)r=p;else{s=d[p+92>>0]|0;p=h;c[p>>2]=q;c[p+4>>2]=s;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];B9c(b,g,0)|0;r=c[o>>2]|0}o=c[r+80>>2]|0;if(o){h=d[r+84>>0]|0;r=j;c[r>>2]=o;c[r+4>>2]=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];B9c(b,g,0)|0}}if(!(Erc(n)|0)){i=f;return}n=(c[b+52>>2]|0)+(e<<3)|0;e=c[n>>2]|0;j=c[n+4>>2]|0;if(!e){i=f;return}n=c[b+24>>2]|0;if(!n){i=f;return}if(!(vTb(n)|0)){i=f;return}n=l;c[n>>2]=e;c[n+4>>2]=j;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];vbd(k,g);c[k+16>>2]=c[b+4>>2];c[k+12>>2]=c[m>>2];xbd(k)|0;i=f;return}function s9c(a){a=a|0;var b=0;b=i;r9c(a,0);i=b;return}function t9c(a){a=a|0;var b=0;b=i;r9c(a,1);i=b;return}function u9c(a){a=a|0;var b=0;b=i;r9c(a,2);i=b;return}function v9c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(c[b+20>>2]|0)){f=587032;g=c[f+4>>2]|0;h=a;c[h>>2]=c[f>>2];c[h+4>>2]=g;i=e;return}else{Hcd(a,c[(c[b+48>>2]|0)+4>>2]|0,d,1);i=e;return}}function w9c(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+40|0;g=e+8|0;h=e;j=b+20|0;if(!(c[j>>2]|0)){i=e;return}k=b+129|0;if(!(a[k>>0]|0)){a[k>>0]=1;k=b+52|0;l=c[k>>2]|0;m=c[l+88>>2]|0;if(!m)n=l;else{o=d[l+92>>0]|0;l=g;c[l>>2]=m;c[l+4>>2]=o;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];B9c(b,f,0)|0;n=c[k>>2]|0}o=c[n+80>>2]|0;if(!o)p=k;else{l=d[n+84>>0]|0;n=h;c[n>>2]=o;c[n+4>>2]=l;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];B9c(b,f,0)|0;p=k}}else p=b+52|0;k=(c[p>>2]|0)+48|0;p=c[k>>2]|0;l=c[k+4>>2]|0;if(!p){i=e;return}k=c[b+24>>2]|0;if(!k){i=e;return}if(!(vTb(k)|0)){i=e;return}k=h;c[k>>2]=p;c[k+4>>2]=l;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];vbd(g,f);c[g+16>>2]=c[b+4>>2];c[g+12>>2]=c[j>>2];xbd(g)|0;i=e;return}function x9c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+80|0;g=f+8|0;h=f+32|0;j=f+40|0;k=f+48|0;l=f+56|0;m=f+64|0;n=f+24|0;o=f+16|0;p=f;q=(Xbd()|0)+388|0;r=c[q+4>>2]|0;s=j;c[s>>2]=c[q>>2];c[s+4>>2]=r;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];wsc(h,d,g);j=(Xbd()|0)+404|0;r=c[j+4>>2]|0;s=l;c[s>>2]=c[j>>2];c[s+4>>2]=r;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];wsc(k,d,g);if((c[k>>2]|0)!=0?(c[h>>2]|0)!=0:0){l=xCi(68)|0;G8c(l);c[l+12>>2]=Bsc(d)|0;c[l+8>>2]=d;d=l+16|0;c[d+0>>2]=c[e+0>>2];a[d+4>>0]=a[e+4>>0]|0;d=h;h=c[d+4>>2]|0;r=o;c[r>>2]=c[d>>2];c[r+4>>2]=h;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];H8c(l,g);o=k;k=c[o+4>>2]|0;h=p;c[h>>2]=c[o>>2];c[h+4>>2]=k;c[g+0>>2]=c[p+0>>2];c[g+4>>2]=c[p+4>>2];I8c(l,g);c[l+40>>2]=b;c[l+56>>2]=0;c[l+60>>2]=0;c[l+64>>2]=0;p=l+44|0;c[p>>2]=1;c[l+48>>2]=0;k=b+56|0;if((l|0)==(k|0))t=k;else{h=c[l>>2]|0;o=l+4|0;if(h){c[h+4>>2]=c[o>>2];c[c[o>>2]>>2]=h;c[l>>2]=0;c[o>>2]=0}h=c[k>>2]|0;c[l>>2]=h;c[o>>2]=k;c[h+4>>2]=l;c[c[o>>2]>>2]=l;t=k}K8c(c[t>>2]|0);t=(c[p>>2]|0)<2;L8c(l);u=t?0:l;i=f;return u|0}if(!(c[e>>2]|0))rri(m,615504,30);else{l=e;e=c[l+4>>2]|0;t=n;c[t>>2]=c[l>>2];c[t+4>>2]=e;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g>>2]=asc(g)|0;Lsd(m,615464,g)}if(!b)v=0;else v=c[b+4>>2]|0;if(!(a[m>>0]&1))w=m+1|0;else w=c[m+8>>2]|0;Krd(w,0,3653512,741,4,v,0,0);xri(m);u=0;i=f;return u|0}function y9c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=b;b=c[j>>2]|0;k=c[j+4>>2]|0;j=c[(Atc()|0)+144>>2]|0;l=g;c[l>>2]=b;c[l+4>>2]=k&255;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];if(($sc(qsc(f)|0)|0)!=(j|0)){m=0;i=e;return m|0}j=h;c[j>>2]=b;c[j+4>>2]=k;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];m=x9c(a,d,f)|0;i=e;return m|0}function z9c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;j=i;i=i+560|0;k=j+464|0;l=j+32|0;m=j+508|0;n=j+8|0;o=j+256|0;p=j+456|0;q=j+472|0;r=j+240|0;s=j+484|0;t=j+512|0;u=j;v=j+496|0;w=j+16|0;x=j+524|0;y=j+536|0;z=j+232|0;A=j+24|0;B=j+248|0;C=d;d=c[C>>2]|0;D=c[C+4>>2]|0;C=n;c[C>>2]=d;c[C+4>>2]=D;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];n=_rc(k)|0;C=p;c[C>>2]=d;c[C+4>>2]=D;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];jbd(o,k);p=b+20|0;c[o+12>>2]=c[p>>2];a[o+25>>0]=0;if(!n){E=qbd(o,f)|0;i=j;return E|0}if(!e){C=r;c[C>>2]=d;c[C+4>>2]=D;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];r=asc(k)|0;A9c(s,b);if(!(a[s>>0]&1))F=s+1|0;else F=c[s+8>>2]|0;c[k>>2]=r;c[k+4>>2]=F;Lsd(q,615536,k);if(a[s>>0]&1){F=c[s+8>>2]|0;c[m>>2]=58;c[k+0>>2]=c[m+0>>2];eOb(F,k)}F=u;c[F>>2]=d;c[F+4>>2]=D;c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];c[k>>2]=asc(k)|0;c[k+4>>2]=n;Lsd(t,615576,k);u=a[t>>0]|0;if(!(u&1)){G=t+1|0;H=(u&255)>>>1}else{G=c[t+8>>2]|0;H=c[t+4>>2]|0}Gri(q,G,H)|0;xri(t);if(!b)I=0;else I=c[b+4>>2]|0;if(!(a[q>>0]&1))J=q+1|0;else J=c[q+8>>2]|0;Krd(J,0,3653512,848,1,I,0,0);xri(q);E=0;i=j;return E|0}if((n|0)!=1){q=w;c[q>>2]=d;c[q+4>>2]=D;c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];w=asc(k)|0;A9c(x,b);if(!(a[x>>0]&1))K=x+1|0;else K=c[x+8>>2]|0;c[k>>2]=w;c[k+4>>2]=K;Lsd(v,615536,k);if(a[x>>0]&1){K=c[x+8>>2]|0;c[l>>2]=58;c[k+0>>2]=c[l+0>>2];eOb(K,k)}K=z;c[K>>2]=d;c[K+4>>2]=D;c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k>>2]=asc(k)|0;c[k+4>>2]=n;Lsd(y,615648,k);n=a[y>>0]|0;if(!(n&1)){L=y+1|0;M=(n&255)>>>1}else{L=c[y+8>>2]|0;M=c[y+4>>2]|0}Gri(v,L,M)|0;xri(y);if(!b)N=0;else N=c[b+4>>2]|0;if(!(a[v>>0]&1))O=v+1|0;else O=c[v+8>>2]|0;Krd(O,0,3653512,854,1,N,0,0);xri(v);E=0;i=j;return E|0}v=vsc(e)|0;N=$r(d,0)|0;O=$sc(N)|0;b=Psc(N)|0;a:do if((b+-2|0)>>>0<12){N=Psc(gsc(vsc(e)|0)|0)|0;do if((N|0)!=(b|0)){y=Atc()|0;if((b|0)==12)if((N|0)==13){M=tsc(c[y+212>>2]|0)|0;g[M+8>>2]=ea(+h[e+8>>3]);P=M;break}else if((N|0)==8){M=tsc(c[y+212>>2]|0)|0;g[M+8>>2]=ea(c[e+8>>2]|0);P=M;break}else break a;else if((b|0)==13)if((N|0)==12){M=tsc(c[y+216>>2]|0)|0;h[M+8>>3]=+ea(g[e+8>>2]);P=M;break}else if((N|0)==8){M=tsc(c[y+216>>2]|0)|0;h[M+8>>3]=+(c[e+8>>2]|0);P=M;break}else break a;else if((b|0)==8)if((N|0)==12){M=tsc(c[y+204>>2]|0)|0;c[M+8>>2]=~~ea(g[e+8>>2]);P=M;break}else if((N|0)==13){M=tsc(c[y+204>>2]|0)|0;c[M+8>>2]=~~+h[e+8>>3];P=M;break}else break a;else break a}else P=e;while(0);if(P)dbd(o+32|0,P+8|0)}else if((b|0)==28){cbd(o+32|0,e);break}else if((b|0)==18){if(!(msc(v,O)|0))break;cbd(o+32|0,e);break}else if((b|0)==17){if((v|0)!=(O|0))break;dbd(o+32|0,e+8|0);break}else if((b|0)==14){if((Psc(gsc(v)|0)|0)!=14)break;cbd(o+32|0,e);break}else break;while(0);if((fbd(o+32|0)|0)==1){E=rbd(o,f,0)|0;i=j;return E|0}else{o=(Atc()|0)+340|0;v=c[o+4>>2]|0;b=A;c[b>>2]=c[o>>2];c[b+4>>2]=v;c[k+0>>2]=c[A+0>>2];c[k+4>>2]=c[A+4>>2];jbd(l,k);a[l+25>>0]=0;A=l+32|0;cbd(A,c[p>>2]|0);p=B;c[p>>2]=d;c[p+4>>2]=D;c[k+0>>2]=c[B+0>>2];c[k+4>>2]=c[B+4>>2];bbd(A,asc(k)|0);cbd(A,e);E=rbd(l,f,0)|0;i=j;return E|0}return 0}function A9c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+8|0;g=e;c[g>>2]=c[d+32>>2];h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(f,h,g);j=c[f>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0))m=c[l+4>>2]|0;else m=0}else m=0;if((m|0)!=0?(l=(da(c[137788]|0,(c[m+8>>2]|0)>>>21)|0)+115|0,h=l>>5,(1<<l-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]|0)!=0):0){h=mo[c[(c[m>>2]|0)+100>>2]&4095](m)|0;m=a[h>>0]|0;if(!(m&1)){n=(m&255)>>>1;o=h+1|0}else{n=c[h+4>>2]|0;o=c[h+8>>2]|0}if(n>>>0>2147483631)ori(b);if(n>>>0<11){a[b>>0]=n<<1;p=b+1|0}else{h=n+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];m=cOb(h,16,f,0,3653512,80)|0;c[b+8>>2]=m;c[b>>2]=h|1;c[b+4>>2]=n;p=m}YEi(p|0,o|0,n|0)|0;a[p+n>>0]=0;i=e;return}n=c[d+48>>2]|0;if((n|0)!=0?(d=c[n+4>>2]|0,(d|0)!=0):0){n=ksc(d)|0;d=SEi(n|0)|0;if(d>>>0>2147483631)ori(b);if(d>>>0<11){a[b>>0]=d<<1;q=b+1|0}else{p=d+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];g=cOb(p,16,f,0,3653512,80)|0;c[b+8>>2]=g;c[b>>2]=p|1;c[b+4>>2]=d;q=g}YEi(q|0,n|0,d|0)|0;a[q+d>>0]=0;i=e;return};c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}function B9c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+40|0;g=e+16|0;h=e+8|0;j=e+36|0;k=e;l=e+24|0;m=c[a+20>>2]|0;c[j>>2]=0;n=b;b=c[n>>2]|0;o=c[n+4>>2]|0;n=k;c[n>>2]=b;c[n+4>>2]=o;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];k=z9c(a,f,d,j)|0;d=c[j>>2]|0;j=(d|0)==0;if((k|0)!=0&j){n=c[(Atc()|0)+144>>2]|0;p=g;c[p>>2]=b;c[p+4>>2]=o&255;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];if(($sc(qsc(f)|0)|0)!=(n|0)){q=0;i=e;return q|0}n=h;c[n>>2]=b;c[n+4>>2]=o;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];q=x9c(a,k,f)|0;i=e;return q|0}else{if(j){q=0;i=e;return q|0}j=Grc(m)|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Rcd(d,j,l);xri(l);q=0;i=e;return q|0}return 0}function C9c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=a+60|0;f=a+56|0;if((c[e>>2]|0)==(f|0)){i=b;return}g=elc()|0;c[d>>2]=c[a+4>>2];glc(g,d,3012,2665);d=c[e>>2]|0;if((d|0)==(f|0)){i=b;return}else h=d;do{d=c[h>>2]|0;if(d){g=h+4|0;c[d+4>>2]=c[g>>2];c[c[g>>2]>>2]=d;c[h>>2]=0;c[g>>2]=0}c[h+40>>2]=0;g=h+60|0;d=c[g>>2]|0;if(!d){if(c[h+64>>2]|0)L8c(h)}else{c[d+56>>2]=0;c[g>>2]=0;L8c(h)}h=c[e>>2]|0}while((h|0)!=(f|0));i=b;return}function D9c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+224|0;e=d+216|0;f=d+16|0;g=d+8|0;h=d;j=b+20|0;if(!(c[j>>2]|0)){i=d;return}if(oVb()|0){i=d;return}k=c[b+48>>2]|0;if(!k)l=0;else l=c[k+4>>2]|0;Hcd(h,l,2984200,4);if(!(c[h>>2]|0)){i=d;return}l=h;h=c[l+4>>2]|0;k=c[j>>2]|0;j=g;c[j>>2]=c[l>>2];c[j+4>>2]=h;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];jbd(f,e);c[f+12>>2]=k;a[f+25>>0]=1;c[f+16>>2]=Grc(k)|0;sbd(f);zbd(f)|0;i=d;return}function E9c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+272|0;g=f+200|0;h=f+232|0;j=f+240|0;k=f+256|0;l=f;m=f+224|0;n=f+264|0;o=c[b+48>>2]|0;if((((o|0)!=0?(a[o+32>>0]|0)!=0:0)?(a[o+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0){i=f;return}o=b+20|0;if(!(c[o>>2]|0)){i=f;return}p=(c[b+52>>2]|0)+(d+26<<3)|0;q=c[p>>2]|0;r=c[p+4>>2]|0;if(!q){i=f;return}if((a[b+28>>0]|0)==0?(VVb(g,UTb()|0,d),(c[g+16>>2]&4|0)!=0):0){i=f;return}d=m;c[d>>2]=q;c[d+4>>2]=r;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];jbd(l,g);c[l+12>>2]=c[o>>2];o=b+4|0;c[l+16>>2]=c[o>>2];m=l+32|0;d=c[e>>2]|0;if((d|0)==100002)abd(m,ea(c[e+4>>2]|0));else if((d|0)==100001)_ad(m,(c[e+4>>2]|0)!=0);else if((d|0)==100003){p=c[e+8>>2]|0;cbd(m,p);if((((p|0)!=0?(s=r&255,t=h,c[t>>2]=q,c[t+4>>2]=s,c[g+0>>2]=c[h+0>>2],c[g+4>>2]=c[h+4>>2],t=$rc(g,0)|0,(t|0)!=0):0)?(u=$sc(t)|0,(u|0)!=0):0)?(t=vsc(p)|0,!(msc(t,u)|0)):0){p=k;c[p>>2]=q;c[p+4>>2]=s;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];k=asc(g)|0;s=ksc(u)|0;u=ksc(t)|0;c[g>>2]=k;c[g+4>>2]=s;c[g+8>>2]=u;Lsd(j,615840,g);if(!(a[j>>0]&1))v=j+1|0;else v=c[j+8>>2]|0;Krd(v,0,3653512,1232,1,c[o>>2]|0,0,0);xri(j);i=f;return}}else if((d|0)==100004){o=tLc()|0;cbd(m,_n[c[(c[o>>2]|0)+20>>2]&4095](o,c[e+4>>2]|0)|0)}else if((d|0)==1e5)$ad(m,c[e+4>>2]|0);else if((d|0)==100007){o=sLc()|0;cbd(m,_n[c[(c[o>>2]|0)+16>>2]&4095](o,c[e+4>>2]|0)|0)}else if(d)cbd(m,Ecd(c[e+4>>2]|0)|0);c[n>>2]=0;e=qbd(l,n)|0;if(!((c[n>>2]|0)==0&(e|0)!=0)){i=f;return}n=c[(Atc()|0)+144>>2]|0;l=h;c[l>>2]=q;c[l+4>>2]=r&255;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];if(($sc(qsc(g)|0)|0)!=(n|0)){i=f;return}n=j;c[n>>2]=q;c[n+4>>2]=r;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];x9c(b,e,g)|0;i=f;return}function F9c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;if(!(c[a+20>>2]|0)){e=0;i=d;return e|0}e=(c[(c[a+52>>2]|0)+(b+26<<3)>>2]|0)!=0;i=d;return e|0}function G9c(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if(!(c[a+20>>2]|0)){d=0;i=b;return d|0}e=c[a+52>>2]|0;a=(c[e+((c[138498]|0)+26<<3)>>2]|0)!=0|((c[e+((c[138488]|0)+26<<3)>>2]|0)==0?((c[e+((c[138476]|0)+26<<3)>>2]|0)==0?0:2):2);f=(c[e+((c[138766]|0)+26<<3)>>2]|0)==0?a:a|16;a=(c[e+((c[138816]|0)+26<<3)>>2]|0)==0?f:f|64;f=(c[e+((c[138838]|0)+26<<3)>>2]|0)==0?a:a|128;a=f|256;d=(c[e+((c[138532]|0)+26<<3)>>2]|0)==0?((c[e+((c[138520]|0)+26<<3)>>2]|0)==0?((c[e+((c[138508]|0)+26<<3)>>2]|0)==0?f:a):a):a;i=b;return d|0}function H9c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+256|0;f=e+248|0;g=e+16|0;h=e+8|0;j=e+216|0;k=e;l=b+24|0;m=c[l>>2]|0;if(m)rTb(m);m=b+20|0;n=c[m>>2]|0;if(!n){okc(b,d);i=e;return}do if(((d&16|0)!=0?(o=c[l>>2]|0,(o|0)!=0):0)?vTb(o)|0:0){o=c[b+48>>2]|0;if((((o|0)!=0?(a[o+32>>0]|0)!=0:0)?(a[o+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0)break;o=(c[b+52>>2]|0)+144|0;p=c[o>>2]|0;q=c[o+4>>2]|0;if(((p|0)!=0?(o=c[l>>2]|0,(o|0)!=0):0)?vTb(o)|0:0){o=k;c[o>>2]=p;c[o+4>>2]=q;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];vbd(j,f);c[j+16>>2]=c[b+4>>2];c[j+12>>2]=c[m>>2];xbd(j)|0}}while(0);j=b+48|0;k=c[j>>2]|0;if((((k|0)!=0?(a[k+32>>0]|0)!=0:0)?(a[k+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0)r=k;else s=20;do if((s|0)==20)if((a[b+28>>0]|0)!=0?(q=c[l>>2]|0,(q|0)!=0):0){if(!(vTb(q)|0)){r=c[j>>2]|0;break}okc(b,d);i=e;return}else r=k;while(0);if((((r|0)!=0?(a[r+32>>0]|0)!=0:0)?(a[r+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0){t=b+128|0;u=0}else{r=b+128|0;if((a[r>>0]|0)==0?(k=c[l>>2]|0,(k|0)!=0):0){t=r;u=vTb(k)|0}else{t=r;u=0}}do if((a[t>>0]|0)==0?(r=c[j>>2]|0,(r|0)!=0):0){if(!(a[r+32>>0]|0)){v=((c[r+24>>2]|0)+-1|0)>>>0<2;s=39;break}if(!(a[r+33>>0]|0)){v=(c[b+8>>2]&1048576|0)==0;s=39}else{w=1;s=40}}else{v=0;s=39}while(0);if((s|0)==39?u|v:0){w=v;s=40}if((s|0)==40){a[t>>0]=1;t=(c[b+52>>2]|0)+24|0;s=c[t>>2]|0;v=c[t+4>>2]|0;if((s|0)!=0?(t=c[m>>2]|0,u=h,c[u>>2]=s,c[u+4>>2]=v,c[f+0>>2]=c[h+0>>2],c[f+4>>2]=c[h+4>>2],jbd(g,f),c[g+12>>2]=t,a[g+25>>0]=1,c[g+16>>2]=Grc(t)|0,sbd(g),zbd(g)|0,(c[g+28>>2]|0)!=0):0)In[c[(c[b>>2]|0)+120>>2]&4095](b,0);if(!(Erc(n)|0)){i=e;return}if((w?(w=(c[b+52>>2]|0)+56|0,t=c[w>>2]|0,v=c[w+4>>2]|0,(t|0)!=0):0)?(w=c[m>>2]|0,m=h,c[m>>2]=t,c[m+4>>2]=v,c[f+0>>2]=c[h+0>>2],c[f+4>>2]=c[h+4>>2],jbd(g,f),c[g+12>>2]=w,a[g+25>>0]=1,c[g+16>>2]=Grc(w)|0,sbd(g),zbd(g)|0,(Erc(n)|0)==0):0){i=e;return}}okc(b,d);i=e;return}function I9c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+8|0;g=d;h=d+16|0;j=b+52|0;if((c[(c[j>>2]|0)+96>>2]|0)!=0?(k=ATb(c[b+24>>2]|0,20)|0,(k|0)!=0):0){l=(c[j>>2]|0)+96|0;m=c[l+4>>2]|0;n=f;c[n>>2]=c[l>>2];c[n+4>>2]=m;m=c[(Xbd()|0)+504>>2]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=bsc(e,m)|0;m=(c[j>>2]|0)+96|0;n=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=n;n=c[(Xbd()|0)+512>>2]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];g=bsc(e,n)|0;c[h>>2]=b;c[h+4>>2]=1821;a[h+8>>0]=g&1;a[h+9>>0]=f&1;m0b(k,h)}h=ELc()|0;if(!h){i=d;return}k=ELc()|0;if(!k){i=d;return}f=b+132|0;g=c[f>>2]|0;do if(!g){n=c[j>>2]|0;if(!n){i=d;return}if(!(c[n+136>>2]|0)){i=d;return}n=c[b+24>>2]|0;if(!n){i=d;return}if(vTb(n)|0){n=_n[c[(c[k>>2]|0)+44>>2]&4095](k,b)|0;c[f>>2]=n;o=n;break}else{i=d;return}}else o=g;while(0);g=_n[c[(c[k>>2]|0)+40>>2]&4095](k,o)|0;if(!g){i=d;return}co[c[(c[h>>2]|0)+56>>2]&2047](h,g,0);i=d;return}function J9c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+32|0;g=c[f>>2]|0;do if(!g)h=0;else{c[e>>2]=g;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=10}else o=10;if((o|0)==10){j=hQb(c[f>>2]|0)|0;if(!j){h=0;break}else n=j}h=c[n+52>>2]|0}while(0);n=a+52|0;f=c[n>>2]|0;if(!(c[f>>2]|0))p=f;else{xkc(ykc()|0,a+64|0,h);p=c[n>>2]|0}if(!(c[p+16>>2]|0))q=p;else{xkc(zkc()|0,a+76|0,h);q=c[n>>2]|0}if(!(c[q+8>>2]|0))r=q;else{xkc(Akc()|0,a+88|0,h);r=c[n>>2]|0}if((c[r+48>>2]|0)!=0?(r=a+112|0,h=(n8b()|0)+100|0,(r|0)!=(h|0)):0){q=c[r>>2]|0;p=a+116|0;if(q){c[q+4>>2]=c[p>>2];c[c[p>>2]>>2]=q;c[r>>2]=0;c[p>>2]=0}q=c[h>>2]|0;c[r>>2]=q;c[p>>2]=h;c[q+4>>2]=r;c[c[p>>2]>>2]=r}if(!(c[(c[n>>2]|0)+112>>2]|0)){i=b;return}ZHc(XHc()|0,a+100|0);i=b;return}function K9c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+224|0;e=d+216|0;f=d+8|0;g=d;h=d+208|0;j=b+20|0;k=c[j>>2]|0;if(!k){i=d;return}l=c[b+48>>2]|0;if((((l|0)!=0?(a[l+32>>0]|0)!=0:0)?(a[l+33>>0]|0)==0:0)?(c[b+8>>2]&1048576|0)!=0:0){i=d;return}l=b+52|0;m=c[l>>2]|0;if(!((c[m+80>>2]|0)==0?(c[m+88>>2]|0)==0:0)){if(!b)n=0;else n=c[b+4>>2]|0;c[h>>2]=n;dlc(3013,h,ea(-10.0),0,ea(0.0),0,7)}J9c(b);h=b+128|0;if(!(a[h>>0]|0)){a[h>>0]=1;h=(c[l>>2]|0)+24|0;n=c[h>>2]|0;m=c[h+4>>2]|0;if((n|0)!=0?(h=c[j>>2]|0,o=g,c[o>>2]=n,c[o+4>>2]=m,c[e+0>>2]=c[g+0>>2],c[e+4>>2]=c[g+4>>2],jbd(f,e),c[f+12>>2]=h,a[f+25>>0]=1,c[f+16>>2]=Grc(h)|0,sbd(f),zbd(f)|0,(c[f+28>>2]|0)!=0):0)In[c[(c[b>>2]|0)+120>>2]&4095](b,0);if(!(Erc(k)|0)){i=d;return}if(!(a[b+28>>0]|0)){i=d;return}}h=c[l>>2]|0;if(c[h+56>>2]|0){l=h+56|0;h=c[l>>2]|0;m=c[l+4>>2]|0;if(((h|0)!=0?(l=c[b+24>>2]|0,(l|0)!=0):0)?vTb(l)|0:0){l=g;c[l>>2]=h;c[l+4>>2]=m;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];vbd(f,e);c[f+16>>2]=c[b+4>>2];c[f+12>>2]=c[j>>2];xbd(f)|0}if(!(Erc(k)|0)){i=d;return}if(!(a[b+28>>0]|0)){i=d;return}}I9c(b);i=d;return}function L9c(a,b){a=a|0;b=b|0;var c=0;c=i;C9c(a);pkc(a,b);i=c;return}function M9c(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+96|0;j=h;k=h+40|0;l=h+44|0;m=h+48|0;n=h+16|0;o=h+4|0;p=h+28|0;q=h+60|0;r=h+72|0;s=h+76|0;t=b+20|0;if(c[t>>2]|0)In[c[(c[b>>2]|0)+56>>2]&4095](b,0);u=b+52|0;c[u>>2]=0;v=b+48|0;w=c[v>>2]|0;if(w){Iad(w);c[v>>2]=0}do if(!g)if(!e){w=Lad(0,2,b)|0;c[v>>2]=w;x=w;break}else{w=Lad(e,2,b)|0;c[v>>2]=w;x=w;break}else{w=d[g+112>>0]|0;y=Lad(gad(g)|0,w,b)|0;c[v>>2]=y;x=y}while(0);Jad(x);x=c[(c[v>>2]|0)+24>>2]|0;if(oVb()|0?!(Mad(x)|0):0){N9c(o,b);g=a[o>>0]|0;if(!(g&1)){z=o+1|0;A=(g&255)>>>1}else{z=c[o+8>>2]|0;A=c[o+4>>2]|0}rri(n,z,A);Nad(m,x,n);if(!b)B=0;else B=c[b+4>>2]|0;if(!(a[m>>0]&1))C=m+1|0;else C=c[m+8>>2]|0;Krd(C,0,3653512,1560,512,B,0,0);xri(m);xri(n);if(a[o>>0]&1){n=c[o+8>>2]|0;c[l>>2]=58;c[j+0>>2]=c[l+0>>2];eOb(n,j)}}if(!(Mad(x)|0)){i=h;return}x=c[v>>2]|0;c[u>>2]=c[x+8>>2];if(f){Fcd(f,b)|0;i=h;return}f=tsc(c[x+4>>2]|0)|0;if(f){Fcd(f,b)|0;x=c[153944]|0;c[153944]=x+1;c[r>>2]=0;usc(c[t>>2]|0,r);c[153944]=x;x=c[r>>2]|0;if(!x){i=h;return}r=Grc(f)|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;Rcd(x,r,s);xri(s);i=h;return}if(!(oVb()|0)){i=h;return}N9c(p,b);if(!(a[p>>0]&1))D=p+1|0;else D=c[p+8>>2]|0;c[j>>2]=D;Lsd(q,615784,j);if(!b)E=0;else E=c[b+4>>2]|0;if(!(a[q>>0]&1))F=q+1|0;else F=c[q+8>>2]|0;Krd(F,0,3653512,1584,512,E,0,0);xri(q);if(!(a[p>>0]&1)){i=h;return}q=c[p+8>>2]|0;c[k>>2]=58;c[j+0>>2]=c[k+0>>2];eOb(q,j);i=h;return}function N9c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+80|0;f=e+64|0;g=e+32|0;h=e+12|0;j=e+16|0;k=e+72|0;l=e;m=e+20|0;n=e+48|0;o=e+36|0;c[g>>2]=c[d+32>>2];p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,g);q=c[f>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0))t=c[s+4>>2]|0;else t=0}else t=0;if((t|0)!=0?(s=(da(c[137788]|0,(c[t+8>>2]|0)>>>21)|0)+115|0,p=s>>5,(1<<s-(p<<5)&c[(c[137786]|0)+(p<<2)>>2]|0)!=0):0){fad(b,t);i=e;return}t=d+48|0;d=c[t>>2]|0;if((d|0)!=0?(p=c[d+4>>2]|0,(p|0)!=0):0){d=lsc(p)|0;p=SEi(d|0)|0;if(p>>>0>2147483631)ori(l);if(p>>>0<11){a[l>>0]=p<<1;u=l+1|0}else{s=p+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];q=cOb(s,16,f,0,3653512,80)|0;c[l+8>>2]=q;c[l>>2]=s|1;c[l+4>>2]=p;u=q}YEi(u|0,d|0,p|0)|0;a[u+p>>0]=0;p=ksc(c[(c[t>>2]|0)+4>>2]|0)|0;t=SEi(p|0)|0;if(t>>>0>2147483631)ori(m);if(t>>>0<11){a[m>>0]=t<<1;v=m+1|0}else{u=t+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];d=cOb(u,16,f,0,3653512,80)|0;c[m+8>>2]=d;c[m>>2]=u|1;c[m+4>>2]=t;v=d}YEi(v|0,p|0,t|0)|0;a[v+t>>0]=0;t=a[l>>0]|0;if(!(t&1))w=(t&255)>>>1;else w=c[l+4>>2]|0;if(w){VJc(o,l,3672776);X9c(n,o,m);w=a[n>>0]|0;if(!(w&1)){x=(w&255)>>>1;y=n+1|0}else{x=c[n+4>>2]|0;y=c[n+8>>2]|0}if(x>>>0>2147483631)ori(b);if(x>>>0<11){a[b>>0]=x<<1;z=b+1|0}else{w=x+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];t=cOb(w,16,f,0,3653512,80)|0;c[b+8>>2]=t;c[b>>2]=w|1;c[b+4>>2]=x;z=t}YEi(z|0,y|0,x|0)|0;a[z+x>>0]=0;if(a[n>>0]&1){x=c[n+8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(x,f)}if(a[o>>0]&1){x=c[o+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(x,f)}}else{x=a[m>>0]|0;if(!(x&1)){A=(x&255)>>>1;B=m+1|0}else{A=c[m+4>>2]|0;B=c[m+8>>2]|0}if(A>>>0>2147483631)ori(b);if(A>>>0<11){a[b>>0]=A<<1;C=b+1|0}else{x=A+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];j=cOb(x,16,f,0,3653512,80)|0;c[b+8>>2]=j;c[b>>2]=x|1;c[b+4>>2]=A;C=j}YEi(C|0,B|0,A|0)|0;a[C+A>>0]=0}if(a[m>>0]&1){A=c[m+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(A,f)}if(!(a[l>>0]&1)){i=e;return}A=c[l+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(A,f);i=e;return};c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}function O9c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f+8|0;h=f;j=b+29|0;if(a[j>>0]|0)ko[c[(c[b>>2]|0)+128>>2]&4095](b);k=b+32|0;l=c[k>>2]|0;if(!l)m=0;else{c[h>>2]=l;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(g,l,h);n=c[g>>2]|0;o=c[l+28>>2]|0;if((n|0)==-1){p=o+(c[l+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((p|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[p+4>>2]|0,(l|0)!=0):0)q=l;else r=12}else r=12;if((r|0)==12)q=hQb(c[k>>2]|0)|0;m=q}M9c(b,d,e,m);if(!(a[j>>0]|0)){i=f;return}ko[c[(c[b>>2]|0)+124>>2]&4095](b);i=f;return}function P9c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+8|0;g=e;h=a+32|0;j=c[b>>2]|0;if((c[h>>2]|0)==(j|0)){k=c[a+48>>2]|0;if((k|0)!=0?(c[k+4>>2]|0)!=0:0){i=e;return}if(!(oVb()|0)){i=e;return}if(!a)l=0;else l=c[a+4>>2]|0;Krd(617008,0,3653512,1713,512,l,0,0);i=e;return}c[h>>2]=j;j=c[b>>2]|0;do if(!j)m=0;else{c[g>>2]=j;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(f,h,g);l=c[f>>2]|0;k=c[h+28>>2]|0;if((l|0)==-1){n=k+(c[h+32>>2]<<3)|0;break}else{n=k+(l<<3)|0;break}}else n=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((n|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[n+4>>2]|0,(h|0)!=0):0)o=h;else p=17}else p=17;if((p|0)==17){h=hQb(c[b>>2]|0)|0;if(!h){m=0;break}else o=h}m=gad(o)|0}while(0);O9c(a,m,d);i=e;return}function Q9c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+8|0;k=f+4|0;if(!d){l=c[b+48>>2]|0;if((l|0)!=0?(c[l+4>>2]|0)!=0:0){i=f;return}if(!(oVb()|0)){i=f;return}if(!b)m=0;else m=c[b+4>>2]|0;Krd(617008,0,3653512,1713,512,m,0,0);i=f;return}m=aad((Xbd()|0)+24|0,d)|0;do if(!m)Xbd()|0;else{if(((had(m)|0)!=0?(had(m)|0)!=1:0)?(had(m)|0)!=2:0){c[g>>2]=ksc(d)|0;Lsd(h,618712,g);if(!(a[h>>0]&1))n=h+1|0;else n=c[h+8>>2]|0;Krd(n,0,3653512,1655,1,0,0,0);xri(h);break}if(gad(m)|0){c[k>>2]=c[m+4>>2];P9c(b,k,e);i=f;return}c[g>>2]=ksc(d)|0;Lsd(j,618808,g);if(!(a[j>>0]&1))o=j+1|0;else o=c[j+8>>2]|0;Krd(o,0,3653512,1661,1,0,0,0);xri(j)}while(0);O9c(b,d,e);i=f;return}function R9c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=b+32|0;j=c[h>>2]|0;do if(j){c[f>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,f);l=c[e>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if(!((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(c[n+4>>2]|0)!=0:0))o=10}else o=10;if((o|0)==10?(hQb(j)|0)==0:0)break;c[g>>2]=c[h>>2];P9c(a,g,0);i=d;return}while(0);g=c[b+48>>2]|0;if(!g)p=0;else p=c[g+4>>2]|0;Q9c(a,p,0);i=d;return}function S9c(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+24>>2]|0;if(e){f=mo[c[(c[e>>2]|0)+32>>2]&4095](e)|0;i=d;return f|0}e=b+36|0;if(!(a[e>>0]&1)){f=e+1|0;i=d;return f|0}else{f=c[b+44>>2]|0;i=d;return f|0}return 0}function T9c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;j=c[b+24>>2]|0;if(j){In[c[(c[j>>2]|0)+36>>2]&4095](j,d);i=e;return}j=b+36|0;k=SEi(d|0)|0;if(k>>>0>2147483631)ori(h);if(k>>>0<11){a[h>>0]=k<<1;l=h+1|0}else{m=k+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];n=cOb(m,16,f,0,3653512,80)|0;c[h+8>>2]=n;c[h>>2]=m|1;c[h+4>>2]=k;l=n}YEi(l|0,d|0,k|0)|0;a[l+k>>0]=0;do if((j|0)!=(h|0)){k=a[h>>0]|0;if(!(k&1)){o=(k&255)>>>1;p=h+1|0}else{o=c[h+4>>2]|0;p=c[h+8>>2]|0}k=a[j>>0]|0;if(!(k&1)){q=10;r=k}else{k=c[j>>2]|0;q=(k&-2)+-1|0;r=k&255}k=(r&1)==0;if(o>>>0>q>>>0){if(k)s=(r&255)>>>1;else s=c[b+40>>2]|0;eXb(j,q,o-q|0,s,0,s,o,p);break}if(k)t=j+1|0;else t=c[b+44>>2]|0;aFi(t|0,p|0,o|0)|0;a[t+o>>0]=0;if(!(a[j>>0]&1)){a[j>>0]=o<<1;break}else{c[b+40>>2]=o;break}}while(0);if(!(a[h>>0]&1)){i=e;return}o=c[h+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(o,f);i=e;return}function U9c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+224|0;d=b+208|0;e=b+8|0;f=b;g=fsc(a)|0;a=(Atc()|0)+420|0;h=c[a+4>>2]|0;j=f;c[j>>2]=c[a>>2];c[j+4>>2]=h;c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];jbd(e,d);cbd(e+32|0,g);g=hsc(nbd(e)|0)|0;i=b;return g|0}function V9c(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+24>>2]&4095](a);ko[c[(c[a>>2]|0)+28>>2]&4095](a);In[c[(c[a>>2]|0)+12>>2]&4095](a,4);i=b;return}function W9c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(136,f,1,16,3653512,58)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];bUb(h,f,d);a[h+28>>0]=1;a[h+29>>0]=0;c[h>>2]=615232;d=h+32|0;f=h+56|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[f>>2]=f;c[h+60>>2]=f;c[h+64>>2]=0;c[h+68>>2]=0;c[h+72>>2]=h;c[h+76>>2]=0;c[h+80>>2]=0;c[h+84>>2]=h;c[h+88>>2]=0;c[h+92>>2]=0;c[h+96>>2]=h;c[h+100>>2]=0;c[h+104>>2]=0;c[h+108>>2]=h;c[h+112>>2]=0;c[h+116>>2]=0;c[h+120>>2]=h;c[h+52>>2]=0;c[h+48>>2]=0;a[h+131>>0]=0;a[h+129>>0]=0;a[h+128>>0]=0;a[h+130>>0]=1;c[h+124>>2]=0;c[h+132>>2]=0;i=e;return h|0}function X9c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+4|0;h=f;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;j=a[d>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[d+4>>2]|0;j=a[e>>0]|0;if(!(j&1))m=(j&255)>>>1;else m=c[e+4>>2]|0;if(k)n=d+1|0;else n=c[d+8>>2]|0;d=m+l|0;if(d>>>0>2147483631)ori(b);if(d>>>0<11){a[b>>0]=l<<1;o=b+1|0}else{k=d+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(k,16,g,0,3653512,80)|0;c[b+8>>2]=h;c[b>>2]=k|1;c[b+4>>2]=l;o=h}YEi(o|0,n|0,l|0)|0;a[o+l>>0]=0;if(!(a[e>>0]&1))p=e+1|0;else p=c[e+8>>2]|0;e=a[b>>0]|0;if(!(e&1)){q=e;r=10}else{e=c[b>>2]|0;q=e&255;r=(e&-2)+-1|0}e=(q&1)==0;if(e)s=(q&255)>>>1;else s=c[b+4>>2]|0;if((r-s|0)>>>0<m>>>0){eXb(b,r,m-r+s|0,s,s,0,m,p);i=f;return}if(!m){i=f;return}if(e)t=b+1|0;else t=c[b+8>>2]|0;YEi(t+s|0,p|0,m|0)|0;p=s+m|0;if(!(a[b>>0]&1))a[b>>0]=p<<1;else c[b+4>>2]=p;a[t+p>>0]=0;i=f;return}function Y9c(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=615232;g=c[b+124>>2]|0;if(g){tIc(g);ACi(g)}c[b+60>>2]=0;c[b+56>>2]=0;if(!(a[b+36>>0]&1)){c[b>>2]=577608;WUb(b);i=d;return}g=c[b+44>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);c[b>>2]=577608;WUb(b);i=d;return}function Z9c(a){a=a|0;var b=0;b=i;Y9c(a);ACi(a);i=b;return}function _9c(a){a=a|0;return 1}function $9c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;if(!(a[d>>0]&1))g=d+1|0;else g=c[d+8>>2]|0;c[f>>2]=g;g=bad(b,f)|0;i=e;return g|0}function aad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!b){f=0;i=d;return f|0}c[e>>2]=b;f=cad(a,e)|0;i=d;return f|0}function bad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;j=a+4|0;if((h|0)==(j|0)){k=0;i=d;return k|0}l=a+8|0;m=a+4|0;n=h;a:while(1){h=n+4|0;o=c[h>>2]|0;if(!o){p=n;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){r=q;break}else p=q}}else{p=o;while(1){q=c[p>>2]|0;if(!q){r=p;break}else p=q}}p=n+16|0;q=c[p>>2]|0;do if(q){c[f>>2]=q;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,f);t=c[e>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[v+4>>2]|0,(s|0)!=0):0)w=s;else x=16}else x=16;if((x|0)==16){x=0;s=hQb(c[p>>2]|0)|0;if(!s){y=c[h>>2]|0;x=18;break}else w=s}if(dad(b,w)|0){k=w;x=27;break a}}else{y=o;x=18}while(0);if((x|0)==18){x=0;if(!y){o=n;while(1){h=c[o+8>>2]|0;if((c[h>>2]|0)==(o|0)){z=h;break}else o=h}}else{o=y;while(1){h=c[o>>2]|0;if(!h){z=o;break}else o=h}}if((c[a>>2]|0)==(n|0))c[a>>2]=z;c[l>>2]=(c[l>>2]|0)+-1;tYb(c[m>>2]|0,n);c[g>>2]=68;c[e+0>>2]=c[g+0>>2];eOb(n,e)}if((r|0)==(j|0)){k=0;x=27;break}else n=r}if((x|0)==27){i=d;return k|0}return 0}function cad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;j=a+4|0;if((h|0)==(j|0)){k=0;i=d;return k|0}l=a+8|0;m=a+4|0;n=h;a:while(1){h=n+4|0;o=c[h>>2]|0;if(!o){p=n;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){r=q;break}else p=q}}else{p=o;while(1){q=c[p>>2]|0;if(!q){r=p;break}else p=q}}p=n+16|0;q=c[p>>2]|0;do if(q){c[f>>2]=q;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,f);t=c[e>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[v+4>>2]|0,(s|0)!=0):0)w=s;else x=16}else x=16;if((x|0)==16){x=0;s=hQb(c[p>>2]|0)|0;if(!s){y=c[h>>2]|0;x=18;break}else w=s}s=gad(w)|0;if((s|0)==(c[b>>2]|0)){k=w;x=27;break a}}else{y=o;x=18}while(0);if((x|0)==18){x=0;if(!y){o=n;while(1){h=c[o+8>>2]|0;if((c[h>>2]|0)==(o|0)){z=h;break}else o=h}}else{o=y;while(1){h=c[o>>2]|0;if(!h){z=o;break}else o=h}}if((c[a>>2]|0)==(n|0))c[a>>2]=z;c[l>>2]=(c[l>>2]|0)+-1;tYb(c[m>>2]|0,n);c[g>>2]=68;c[e+0>>2]=c[g+0>>2];eOb(n,e)}if((r|0)==(j|0)){k=0;x=27;break}else n=r}if((x|0)==27){i=d;return k|0}return 0}function dad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=mo[c[(c[d>>2]|0)+100>>2]&4095](d)|0;d=c[b>>2]|0;b=SEi(d|0)|0;g=a[f>>0]|0;if(!(g&1))h=(g&255)>>>1;else h=c[f+4>>2]|0;if((b|0)==-1)pri(f);if(!(g&1))j=f+1|0;else j=c[f+8>>2]|0;f=h>>>0>b>>>0;g=FEi(j,d,f?b:h)|0;if(g){k=g;l=(k|0)==0;i=e;return l|0}k=h>>>0<b>>>0?-1:f&1;l=(k|0)==0;i=e;return l|0}function ead(a){a=a|0;var b=0,d=0;b=i;d=a+72|0;a=c[d>>2]|0;if(!a){i=b;return}Iad(a);c[d>>2]=0;i=b;return}function fad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+12|0;k=e;l=d+88|0;m=a[l>>0]|0;if(!(m&1))n=(m&255)>>>1;else n=c[d+92>>2]|0;if(!n){n=d+76|0;m=a[n>>0]|0;if(!(m&1)){o=(m&255)>>>1;p=n+1|0}else{o=c[d+80>>2]|0;p=c[d+84>>2]|0}if(o>>>0>2147483631)ori(b);if(o>>>0<11){a[b>>0]=o<<1;q=b+1|0}else{n=o+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];m=cOb(n,16,f,0,3653512,80)|0;c[b+8>>2]=m;c[b>>2]=n|1;c[b+4>>2]=o;q=m}YEi(q|0,p|0,o|0)|0;a[q+o>>0]=0;i=e;return}VJc(k,l,3672776);X9c(j,k,d+76|0);d=a[j>>0]|0;if(!(d&1)){r=(d&255)>>>1;s=j+1|0}else{r=c[j+4>>2]|0;s=c[j+8>>2]|0}if(r>>>0>2147483631)ori(b);if(r>>>0<11){a[b>>0]=r<<1;t=b+1|0}else{d=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];l=cOb(d,16,f,0,3653512,80)|0;c[b+8>>2]=l;c[b>>2]=d|1;c[b+4>>2]=r;t=l}YEi(t|0,s|0,r|0)|0;a[t+r>>0]=0;if(a[j>>0]&1){r=c[j+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(r,f)}if(!(a[k>>0]&1)){i=e;return}r=c[k+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(r,f);i=e;return}function gad(a){a=a|0;var b=0,d=0;b=c[a+72>>2]|0;if(!b)d=0;else d=c[b+4>>2]|0;return d|0}function had(a){a=a|0;var b=0,d=0;b=c[a+72>>2]|0;if(!b)d=-1;else d=c[b+24>>2]|0;return d|0}function iad(b){b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+100|0;if(!(a[f>>0]&1))g=f+1|0;else g=c[b+108>>2]|0;f=b+88|0;if(!(a[f>>0]&1))h=f+1|0;else h=c[b+96>>2]|0;f=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;f=Asc(g,h,j)|0;j=b+72|0;h=c[j>>2]|0;if(h){Iad(h);c[j>>2]=0}h=Lad(f,d[b+112>>0]|0,b)|0;c[j>>2]=h;Jad(h);i=e;return}function jad(a,b){a=a|0;b=b|0;var c=0;c=i;if(!(b&2))iad(a);i=c;return}function kad(a){a=a|0;var b=0;b=i;iad(a);i=b;return}function lad(a){a=a|0;return 1}function mad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+112|0;f=e+92|0;g=e+84|0;h=e+52|0;j=e+48|0;k=e+80|0;l=e+88|0;m=e+96|0;n=e+24|0;o=e+12|0;p=e+56|0;q=e+36|0;r=e+68|0;s=e;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;t=ksc(c[d>>2]|0)|0;u=SEi(t|0)|0;if(u>>>0>2147483631)ori(q);if(u>>>0<11){a[q>>0]=u<<1;v=q;w=q+1|0}else{x=u+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];y=cOb(x,16,f,0,3653512,80)|0;c[q+8>>2]=y;c[q>>2]=x|1;c[q+4>>2]=u;v=q;w=y}YEi(w|0,t|0,u|0)|0;a[w+u>>0]=0;u=a[v>>0]|0;if(!(u&1)){z=(u&255)>>>1;A=q+1|0}else{z=c[q+4>>2]|0;A=c[q+8>>2]|0}u=a[n>>0]|0;if(!(u&1)){B=10;C=u}else{u=c[n>>2]|0;B=(u&-2)+-1|0;C=u&255}u=(C&1)==0;do if(z>>>0<=B>>>0){if(u)D=n+1|0;else D=c[n+8>>2]|0;aFi(D|0,A|0,z|0)|0;a[D+z>>0]=0;if(!(a[n>>0]&1)){a[n>>0]=z<<1;break}else{c[n+4>>2]=z;break}}else{if(u)E=(C&255)>>>1;else E=c[n+4>>2]|0;eXb(n,B,z-B|0,E,0,E,z,A)}while(0);if(a[v>>0]&1){v=c[q+8>>2]|0;c[m>>2]=58;c[f+0>>2]=c[m+0>>2];eOb(v,f)}v=lsc(c[d>>2]|0)|0;m=SEi(v|0)|0;if(m>>>0>2147483631)ori(r);if(m>>>0<11){a[r>>0]=m<<1;F=r;G=r+1|0}else{q=m+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];A=cOb(q,16,f,0,3653512,80)|0;c[r+8>>2]=A;c[r>>2]=q|1;c[r+4>>2]=m;F=r;G=A}YEi(G|0,v|0,m|0)|0;a[G+m>>0]=0;m=a[F>>0]|0;if(!(m&1)){H=(m&255)>>>1;I=r+1|0}else{H=c[r+4>>2]|0;I=c[r+8>>2]|0}m=a[o>>0]|0;if(!(m&1)){J=10;K=m}else{m=c[o>>2]|0;J=(m&-2)+-1|0;K=m&255}m=(K&1)==0;do if(H>>>0<=J>>>0){if(m)L=o+1|0;else L=c[o+8>>2]|0;aFi(L|0,I|0,H|0)|0;a[L+H>>0]=0;if(!(a[o>>0]&1)){a[o>>0]=H<<1;break}else{c[o+4>>2]=H;break}}else{if(m)M=(K&255)>>>1;else M=c[o+4>>2]|0;eXb(o,J,H-J|0,M,0,M,H,I)}while(0);if(a[F>>0]&1){F=c[r+8>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(F,f)}F=Jsc(c[d>>2]|0)|0;d=SEi(F|0)|0;if(d>>>0>2147483631)ori(s);if(d>>>0<11){a[s>>0]=d<<1;N=s;O=s+1|0}else{l=d+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];r=cOb(l,16,f,0,3653512,80)|0;c[s+8>>2]=r;c[s>>2]=l|1;c[s+4>>2]=d;N=s;O=r}YEi(O|0,F|0,d|0)|0;a[O+d>>0]=0;d=a[N>>0]|0;if(!(d&1)){P=(d&255)>>>1;Q=s+1|0}else{P=c[s+4>>2]|0;Q=c[s+8>>2]|0}d=a[p>>0]|0;if(!(d&1)){R=10;S=d}else{d=c[p>>2]|0;R=(d&-2)+-1|0;S=d&255}d=(S&1)==0;do if(P>>>0<=R>>>0){if(d)T=p+1|0;else T=c[p+8>>2]|0;aFi(T|0,Q|0,P|0)|0;a[T+P>>0]=0;if(!(a[p>>0]&1)){a[p>>0]=P<<1;break}else{c[p+4>>2]=P;break}}else{if(d)U=(S&255)>>>1;else U=c[p+4>>2]|0;eXb(p,R,P-R|0,U,0,U,P,Q)}while(0);if(a[N>>0]&1){N=c[s+8>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(N,f)}nad(b,p,o,n);if(a[p>>0]&1){b=c[p+8>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(b,f)}if(a[o>>0]&1){b=c[o+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(b,f)}if(!(a[n>>0]&1)){i=e;return}b=c[n+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function nad(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+12|0;if(!(a[d>>0]&1))l=d+1|0;else l=c[d+8>>2]|0;if(!(a[e>>0]&1))m=e+1|0;else m=c[e+8>>2]|0;if(!(a[f>>0]&1))n=f+1|0;else n=c[f+8>>2]|0;c[h>>2]=l;c[h+4>>2]=m;c[h+8>>2]=n;Lsd(k,616032,h);n=a[k>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=k+1|0}else{o=c[k+4>>2]|0;p=c[k+8>>2]|0}if(o>>>0>2147483631)ori(b);if(o>>>0<11){a[b>>0]=o<<1;q=b+1|0;YEi(q|0,p|0,o|0)|0;r=q+o|0;a[r>>0]=0;xri(k);i=g;return}else{n=o+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];j=cOb(n,16,h,0,3653512,80)|0;c[b+8>>2]=j;c[b>>2]=n|1;c[b+4>>2]=o;q=j;YEi(q|0,p|0,o|0)|0;r=q+o|0;a[r>>0]=0;xri(k);i=g;return}}function oad(){var a=0;a=i;QQb(115,165,0,0,0);i=a;return}function pad(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(49)|0))ocd();rri(b,616048,10);wQb(115,49,b,120,2638,0,0);xri(b);i=a;return}function qad(a){a=a|0;return 115}function rad(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,616048,a,0);yad(a,b);bdd(b);i=c;return}function sad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,616048,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else zad(a,b);sdd(b);i=d;return}function tad(a,b){a=a|0;b=b|0;var c=0;c=i;Aad(a,b);i=c;return}function uad(a,b){a=a|0;b=b|0;var c=0;c=i;Bad(a,b);i=c;return}function vad(a,b){a=a|0;b=b|0;var c=0;c=i;Cad(a,b);i=c;return}function wad(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function xad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(120,f,1,16,3653512,20)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];gcd(h,f,d);c[h>>2]=615928;d=h+52|0;f=d+0|0;g=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));a[d+60>>0]=0;i=e;return h|0}function yad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+4|0;xWb(a,b);ddd(b,4);add(b,616064,c[142270]|0,a+52|0,16);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+56|0;add(b,616288,616312,j,16);v6b(j,b);bdd(b);j=c[142294]|0;add(b,616088,j,a+76|0,16);$cd(b,2646336,2646336,e,1);k=c[142260]|0;add(b,3142592,k,f,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,616104,j,a+88|0,16);$cd(b,2646336,2646336,e,1);add(b,3142592,k,f,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,616120,j,a+100|0,16);$cd(b,2646336,2646336,e,1);add(b,3142592,k,f,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,616136,c[142258]|0,a+112|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);i=d;return}function zad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;e=i;i=i+112|0;f=e+92|0;g=e+84|0;h=e+52|0;j=e+48|0;k=e+80|0;l=e+88|0;m=e+96|0;n=e+24|0;o=e+12|0;p=e+56|0;q=e+36|0;r=e+68|0;s=e;yWb(b,d);rdd(d,4);t=b+52|0;u=qdd(d,616064,c[142270]|0,f,0)|0;if(u){if((u|0)>0){u=d+12|0;v=c[d+16>>2]|0;w=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;x=v+w|0;c[u>>2]=x;if((w|0)>=0?(y=v+(w+4)|0,y>>>0<=(c[d+20>>2]|0)>>>0):0){c[t>>2]=c[x>>2];c[u>>2]=y}else Bid(u,t,4);if(c[d>>2]&512)c[t>>2]=XEi(c[t>>2]|0)|0}else{u=c[f>>2]|0;if(u)_n[u&4095](t,d)|0}sdd(d)}t=b+56|0;u=qdd(d,616288,616312,f,1)|0;if(u){if((u|0)<=0){u=c[f>>2]|0;if(u)_n[u&4095](t,d)|0}else b7b(t,d);sdd(d)}t=b+76|0;u=c[142294]|0;y=qdd(d,616088,u,f,0)|0;if(y){if((y|0)<=0){y=c[f>>2]|0;if(y)_n[y&4095](t,d)|0}else zXb(d,t,1);sdd(d)}t=b+88|0;y=qdd(d,616104,u,f,0)|0;if(y){if((y|0)<=0){y=c[f>>2]|0;if(y)_n[y&4095](t,d)|0}else zXb(d,t,1);sdd(d)}y=b+100|0;x=qdd(d,616120,u,f,0)|0;if(x){if((x|0)<=0){x=c[f>>2]|0;if(x)_n[x&4095](y,d)|0}else zXb(d,y,1);sdd(d)}x=b+112|0;w=qdd(d,616136,c[142258]|0,f,0)|0;if(w){do if((w|0)<=0){v=c[f>>2]|0;if(v)_n[v&4095](x,d)|0}else{v=d+12|0;z=c[d+16>>2]|0;A=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;B=z+A|0;c[v>>2]=B;if((A|0)>=0?(z+(A+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[x>>0]=a[B>>0]|0;c[v>>2]=(c[v>>2]|0)+1;break}Bid(v,x,1)}while(0);sdd(d)}if(!(xdd(d,1)|0)){i=e;return}x=qdd(d,616160,u,f,0)|0;if(x){if((x|0)<=0){x=c[f>>2]|0;if(x)_n[x&4095](y,d)|0}else zXb(d,y,1);sdd(d)}d=a[y>>0]|0;x=(d&1)==0;if(x){C=(d&255)>>>1;D=y+1|0}else{C=c[b+104>>2]|0;D=c[b+108>>2]|0}u=C>>>0>20;if((FEi(D,616184,u?20:C)|0)==0?C>>>0>19&(u^1):0){c[g>>2]=58;c[f+0>>2]=c[g+0>>2];u=cOb(16,16,f,0,3653512,80)|0;C=n+8|0;c[C>>2]=u;c[n>>2]=17;D=n+4|0;c[D>>2]=15;E=u+0|0;F=3516336|0;G=E+15|0;do{a[E>>0]=a[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));a[u+15>>0]=0;do if((y|0)!=(n|0)){u=a[n>>0]|0;if(!(u&1)){H=(u&255)>>>1;I=n+1|0}else{H=c[D>>2]|0;I=c[C>>2]|0}u=a[y>>0]|0;if(!(u&1)){J=10;K=u}else{u=c[y>>2]|0;J=(u&-2)+-1|0;K=u&255}u=(K&1)==0;if(H>>>0>J>>>0){if(u)L=(K&255)>>>1;else L=c[b+104>>2]|0;eXb(y,J,H-J|0,L,0,L,H,I);break}if(u)M=y+1|0;else M=c[b+108>>2]|0;aFi(M|0,I|0,H|0)|0;a[M+H>>0]=0;if(!(a[y>>0]&1)){a[y>>0]=H<<1;break}else{c[b+104>>2]=H;break}}while(0);if(a[n>>0]&1){n=c[C>>2]|0;c[m>>2]=58;c[f+0>>2]=c[m+0>>2];eOb(n,f)}c[g>>2]=58;c[f+0>>2]=c[g+0>>2];n=cOb(16,16,f,0,3653512,80)|0;m=o+8|0;c[m>>2]=n;c[o>>2]=17;C=o+4|0;c[C>>2]=11;E=n+0|0;F=3516216|0;G=E+11|0;do{a[E>>0]=a[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));a[n+11>>0]=0;do if((t|0)!=(o|0)){n=a[o>>0]|0;if(!(n&1)){N=(n&255)>>>1;O=o+1|0}else{N=c[C>>2]|0;O=c[m>>2]|0}n=a[t>>0]|0;if(!(n&1)){P=10;Q=n}else{n=c[t>>2]|0;P=(n&-2)+-1|0;Q=n&255}n=(Q&1)==0;if(N>>>0>P>>>0){if(n)R=(Q&255)>>>1;else R=c[b+92>>2]|0;eXb(t,P,N-P|0,R,0,R,N,O);break}if(n)S=t+1|0;else S=c[b+96>>2]|0;aFi(S|0,O|0,N|0)|0;a[S+N>>0]=0;if(!(a[t>>0]&1)){a[t>>0]=N<<1;break}else{c[b+92>>2]=N;break}}while(0);if(!(a[o>>0]&1)){i=e;return}o=c[m>>2]|0;c[l>>2]=58;c[f+0>>2]=c[l+0>>2];eOb(o,f);i=e;return}if(x){T=(d&255)>>>1;U=y+1|0}else{T=c[b+104>>2]|0;U=c[b+108>>2]|0}d=T>>>0>20;if((FEi(U,616208,d?20:T)|0)==0?T>>>0>19&(d^1):0){c[g>>2]=58;c[f+0>>2]=c[g+0>>2];d=cOb(16,16,f,0,3653512,80)|0;T=p+8|0;c[T>>2]=d;c[p>>2]=17;U=p+4|0;c[U>>2]=15;E=d+0|0;F=616232|0;G=E+15|0;do{a[E>>0]=a[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));a[d+15>>0]=0;do if((y|0)!=(p|0)){d=a[p>>0]|0;if(!(d&1)){V=(d&255)>>>1;W=p+1|0}else{V=c[U>>2]|0;W=c[T>>2]|0}d=a[y>>0]|0;if(!(d&1)){X=10;Y=d}else{d=c[y>>2]|0;X=(d&-2)+-1|0;Y=d&255}d=(Y&1)==0;if(V>>>0>X>>>0){if(d)Z=(Y&255)>>>1;else Z=c[b+104>>2]|0;eXb(y,X,V-X|0,Z,0,Z,V,W);break}if(d)_=y+1|0;else _=c[b+108>>2]|0;aFi(_|0,W|0,V|0)|0;a[_+V>>0]=0;if(!(a[y>>0]&1)){a[y>>0]=V<<1;break}else{c[b+104>>2]=V;break}}while(0);if(a[p>>0]&1){p=c[T>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(p,f)}c[g>>2]=58;c[f+0>>2]=c[g+0>>2];p=cOb(16,16,f,0,3653512,80)|0;k=q+8|0;c[k>>2]=p;c[q>>2]=17;T=q+4|0;c[T>>2]=11;E=p+0|0;F=616248|0;G=E+11|0;do{a[E>>0]=a[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));a[p+11>>0]=0;do if((t|0)!=(q|0)){p=a[q>>0]|0;if(!(p&1)){$=(p&255)>>>1;aa=q+1|0}else{$=c[T>>2]|0;aa=c[k>>2]|0}p=a[t>>0]|0;if(!(p&1)){ba=10;ca=p}else{p=c[t>>2]|0;ba=(p&-2)+-1|0;ca=p&255}p=(ca&1)==0;if($>>>0>ba>>>0){if(p)ea=(ca&255)>>>1;else ea=c[b+92>>2]|0;eXb(t,ba,$-ba|0,ea,0,ea,$,aa);break}if(p)fa=t+1|0;else fa=c[b+96>>2]|0;aFi(fa|0,aa|0,$|0)|0;a[fa+$>>0]=0;if(!(a[t>>0]&1)){a[t>>0]=$<<1;break}else{c[b+92>>2]=$;break}}while(0);if(!(a[q>>0]&1)){i=e;return}q=c[k>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(q,f);i=e;return}Gad(s,616264,y);VJc(r,s,616280);q=a[r>>0]|0;if(!(q&1)){ga=(q&255)>>>1;ha=r+1|0}else{ga=c[r+4>>2]|0;ha=c[r+8>>2]|0}q=a[y>>0]|0;if(!(q&1)){ia=10;ja=q}else{q=c[y>>2]|0;ia=(q&-2)+-1|0;ja=q&255}q=(ja&1)==0;do if(ga>>>0<=ia>>>0){if(q)ka=y+1|0;else ka=c[b+108>>2]|0;aFi(ka|0,ha|0,ga|0)|0;a[ka+ga>>0]=0;if(!(a[y>>0]&1)){a[y>>0]=ga<<1;break}else{c[b+104>>2]=ga;break}}else{if(q)la=(ja&255)>>>1;else la=c[b+104>>2]|0;eXb(y,ia,ga-ia|0,la,0,la,ga,ha)}while(0);if(a[r>>0]&1){ha=c[r+8>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(ha,f)}if(!(a[s>>0]&1)){i=e;return}ha=c[s+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(ha,f);i=e;return}function Aad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;zWb(b,d);f=b+52|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0)Bid(g,f,4);else{c[f>>2]=c[h>>2];c[g>>2]=j}C6b(b+56|0,d);NXb(d,b+76|0,1);Ndd(d);NXb(d,b+88|0,1);Ndd(d);NXb(d,b+100|0,1);Ndd(d);d=b+112|0;b=c[g>>2]|0;if((b+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,d,1);i=e;return}else{a[d>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}}function Bad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;AWb(b,d);f=b+52|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0){Bid(g,f,4);l=c[f>>2]|0}else{m=c[h>>2]|0;c[f>>2]=m;c[g>>2]=j;l=m}c[f>>2]=XEi(l|0)|0;H6b(b+56|0,d);OXb(d,b+76|0,1);Mdd(d);OXb(d,b+88|0,1);Mdd(d);OXb(d,b+100|0,1);Mdd(d);d=b+112|0;b=c[g>>2]|0;if((b+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,d,1);i=e;return}else{a[d>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}}function Cad(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;BWb(b,d);f=b+52|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0<(c[k>>2]|0)>>>0){c[h>>2]=c[f>>2];c[g>>2]=j}else Gid(g,f,4);M6b(b+56|0,d);FXb(d,b+76|0,616088,16);FXb(d,b+88|0,616104,16);FXb(d,b+100|0,616120,16);d=b+112|0;b=c[g>>2]|0;if((b+1|0)>>>0<(c[k>>2]|0)>>>0){a[b>>0]=a[d>>0]|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}else{Gid(g,d,1);i=e;return}}function Dad(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[b>>2]=615928;if(a[b+100>>0]&1){j=c[b+108>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(j,e)}if(a[b+88>>0]&1){j=c[b+96>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(j,e)}if(!(a[b+76>>0]&1)){Had(b);i=d;return}j=c[b+84>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(j,e);Had(b);i=d;return}function Ead(a){a=a|0;var b=0;b=i;Dad(a);ACi(a);i=b;return}function Fad(a){a=a|0;return a+76|0}function Gad(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f+4|0;h=f;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;j=SEi(d|0)|0;k=a[e>>0]|0;if(!(k&1))l=(k&255)>>>1;else l=c[e+4>>2]|0;k=l+j|0;if(k>>>0>2147483631)ori(b);if(k>>>0<11){a[b>>0]=j<<1;m=b+1|0}else{n=k+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(n,16,g,0,3653512,80)|0;c[b+8>>2]=h;c[b>>2]=n|1;c[b+4>>2]=j;m=h}YEi(m|0,d|0,j|0)|0;a[m+j>>0]=0;if(!(a[e>>0]&1))o=e+1|0;else o=c[e+8>>2]|0;e=a[b>>0]|0;if(!(e&1)){p=e;q=10}else{e=c[b>>2]|0;p=e&255;q=(e&-2)+-1|0}e=(p&1)==0;if(e)r=(p&255)>>>1;else r=c[b+4>>2]|0;if((q-r|0)>>>0<l>>>0){eXb(b,q,l-q+r|0,r,r,0,l,o);i=f;return}if(!l){i=f;return}if(e)s=b+1|0;else s=c[b+8>>2]|0;YEi(s+r|0,o|0,l|0)|0;o=r+l|0;if(!(a[b>>0]&1))a[b>>0]=o<<1;else c[b+4>>2]=o;a[s+o>>0]=0;i=f;return}function Had(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[b>>2]=618280;if(a[b+40>>0]&1){h=c[b+48>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(h,e)}if(!(a[b+28>>0]&1)){EWb(b);i=d;return}h=c[b+36>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(h,e);EWb(b);i=d;return}function Iad(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=(c[a>>2]|0)+-1;if(c[a>>2]|0){g=Xbd()|0;Wbd(g,c[a+28>>2]|0);i=b;return}g=c[153130]|0;if((c[a+20>>2]|0)>-1){h=a+8|0;j=c[h>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[h>>2]=0}c[f>>2]=g;c[d+0>>2]=c[f+0>>2];eOb(a,d);i=b;return}function Jad(a){a=a|0;var b=0;b=i;c[a>>2]=(c[a>>2]|0)+1;Vbd(Xbd()|0,a);i=b;return}function Kad(a){a=a|0;return c[a>>2]|0}function Lad(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0;e=i;i=i+464|0;g=e+212|0;h=e+384|0;j=e+16|0;k=e+144|0;l=e+72|0;m=e+408|0;n=e+48|0;o=e+248|0;p=e+188|0;q=e+40|0;r=e+80|0;s=e+92|0;t=e+104|0;u=e+116|0;v=e+24|0;w=e+224|0;x=e+356|0;y=e+372|0;z=e+396|0;A=e+420|0;B=e+436|0;C=e+448|0;D=e+32|0;E=e+244|0;F=e+8|0;G=e;H=e+272|0;I=e+284|0;J=e+296|0;K=e+128|0;L=e+320|0;M=e+332|0;N=e+152|0;O=e+344|0;P=e+200|0;Q=e+60|0;R=e+168|0;S=e+368|0;T=e+164|0;U=e+432|0;V=e+308|0;W=e+260|0;c[U>>2]=b;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];b=cOb(16,16,g,0,3653512,80)|0;X=V+8|0;c[X>>2]=b;c[V>>2]=17;Y=V+4|0;c[Y>>2]=13;Z=b+0|0;_=616600|0;$=Z+13|0;do{a[Z>>0]=a[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));a[b+13>>0]=0;if(c[U>>2]|0){mad(W,U);b=a[W>>0]|0;if(!(b&1)){aa=(b&255)>>>1;ba=W+1|0}else{aa=c[W+4>>2]|0;ba=c[W+8>>2]|0}b=a[V>>0]|0;if(!(b&1)){ca=10;ea=b}else{b=c[V>>2]|0;ca=(b&-2)+-1|0;ea=b&255}b=(ea&1)==0;do if(aa>>>0<=ca>>>0){if(b)fa=V+1|0;else fa=c[X>>2]|0;aFi(fa|0,ba|0,aa|0)|0;a[fa+aa>>0]=0;if(!(a[V>>0]&1)){a[V>>0]=aa<<1;break}else{c[Y>>2]=aa;break}}else{if(b)ga=(ea&255)>>>1;else ga=c[Y>>2]|0;eXb(V,ca,aa-ca|0,ga,0,ga,aa,ba)}while(0);if(a[W>>0]&1){ba=c[W+8>>2]|0;c[T>>2]=58;c[g+0>>2]=c[T+0>>2];eOb(ba,g)}}ba=Xbd()|0;T=a[V>>0]|0;if(!(T&1)){ha=V+1|0;ia=(T&255)>>>1}else{ha=c[X>>2]|0;ia=c[Y>>2]|0}T=Ubd(ba,Rsd(ha,ia,-804401139)|0)|0;do if(!T){ia=c[U>>2]|0;c[S>>2]=c[153130];c[g+0>>2]=c[S+0>>2];ha=bOb(40,g,0,16,3653512,530)|0;c[ha>>2]=1;ba=ha+8|0;c[ba>>2]=0;W=ha+16|0;c[W>>2]=0;aa=ha+20|0;c[aa>>2]=0;ga=ha+12|0;c[ga>>2]=60;ca=ha+24|0;c[ca>>2]=-1;ea=ha+4|0;c[ea>>2]=0;b=ha+28|0;c[b>>2]=0;c[ha+36>>2]=0;fa=ha+32|0;a[fa>>0]=0;_=ha+33|0;a[_>>0]=0;c[ea>>2]=ia;Z=a[V>>0]|0;if(!(Z&1)){ja=V+1|0;ka=(Z&255)>>>1}else{ja=c[X>>2]|0;ka=c[Y>>2]|0}c[b>>2]=Rsd(ja,ka,-804401139)|0;if(!ia){c[ca>>2]=-7;la=ha;break}if(Vsc(ia)|0){c[ca>>2]=-4;la=ha;break}if(Xsc(ia)|0){c[ca>>2]=-6;la=ha;break}b=Atc()|0;if(!(msc(ia,c[b+36>>2]|0)|0))if(msc(ia,c[b+44>>2]|0)|0)ma=1;else{c[ca>>2]=-2;la=ha;break}else ma=0;c[ca>>2]=ma;ca=c[ea>>2]|0;b=c[(UTb()|0)+32>>2]|0;Z=b+26|0;$=c[aa>>2]|0;do if(($&2147483647)>>>0<Z>>>0)if(($|0)>-1){c[aa>>2]=Z;na=c[ba>>2]|0;c[h>>2]=c[ga>>2];c[g+0>>2]=c[h+0>>2];c[ba>>2]=hOb(na,Z<<3,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[ga>>2];c[g+0>>2]=c[h+0>>2];na=cOb(Z<<3,4,g,0,3653512,352)|0;YEi(na|0,c[ba>>2]|0,c[W>>2]<<3|0)|0;c[aa>>2]=Z;c[ba>>2]=na;break}while(0);aa=c[W>>2]|0;if(aa>>>0<Z>>>0?(ga=c[ba>>2]|0,$=ga+(Z<<3)|0,(aa|0)!=(Z|0)):0){na=ga+(aa<<3)|0;do{if(na){aa=587032;ga=c[aa+4>>2]|0;oa=na;c[oa>>2]=c[aa>>2];c[oa+4>>2]=ga}na=na+8|0}while((na|0)!=($|0))}c[W>>2]=Z;$=c[(Xbd()|0)+288>>2]|0;c[B>>2]=0;na=B+4|0;c[na>>2]=0;c[B+8>>2]=0;ga=c[ea>>2]|0;while(1){if(!ga)break;nsc(ga,B);if((ga|0)==($|0))break;ga=isc(ga)|0}ga=C+4|0;c[ga>>2]=0;c[C+8>>2]=0;$=C+4|0;c[C>>2]=$;ea=c[na>>2]|0;Z=c[B>>2]|0;if((ea|0)!=(Z|0)){W=ea;do{W=W+-8|0;ea=W;oa=c[ea+4>>2]|0;aa=D;c[aa>>2]=c[ea>>2];c[aa+4>>2]=oa;c[g+0>>2]=c[D+0>>2];c[g+4>>2]=c[D+4>>2];if(Zrc(g)|0){oa=W;aa=c[oa+4>>2]|0;ea=F;c[ea>>2]=c[oa>>2];c[ea+4>>2]=aa;c[g+0>>2]=c[F+0>>2];c[g+4>>2]=c[F+4>>2];c[E>>2]=asc(g)|0;aa=Oad(C,E)|0;c[aa+0>>2]=c[W+0>>2];a[aa+4>>0]=a[W+4>>0]|0}}while((W|0)!=(Z|0))}Z=(ca|0)==0;W=g+4|0;aa=g+8|0;ea=l+4|0;oa=g+4|0;pa=k+4|0;qa=(f|0)==0;ra=M+1|0;sa=M+8|0;ta=f+4|0;ua=H+1|0;va=H+8|0;wa=0;do{xa=616488+(wa<<2)|0;ya=c[ga>>2]|0;if(ya){za=c[xa>>2]|0;Aa=$;Ba=ya;a:while(1){ya=Ba;while(1){if((HEi(c[ya+16>>2]|0,za)|0)>=0){Ca=ya;break}ya=c[ya+4>>2]|0;if(!ya){Da=Aa;break a}}Ba=c[Ca>>2]|0;if(!Ba){Da=Ca;break}else Aa=Ca}if((Da|0)!=($|0)?(HEi(za,c[Da+16>>2]|0)|0)>=0:0)Ea=Da+20|0;else Ea=587032}else Ea=587032;Aa=Ea;Ba=c[Aa>>2]|0;ya=c[Aa+4>>2]|0;Aa=ya&255;Fa=Atc()|0;b:do if(Ba){Ga=G;c[Ga>>2]=Ba;c[Ga+4>>2]=ya;c[g+0>>2]=c[G+0>>2];c[g+4>>2]=c[G+4>>2];Ga=_rc(g)|0;if((wa|0)==12){Ha=c[Fa+124>>2]|0;c[g>>2]=Ha;c[oa>>2]=Ha;if(Pad(Ba,Aa,ca,g,2,f,Fa)|0){Ia=Ba;Ja=Aa;break}Ia=c[146758]|0;Ja=a[587036]|0;break}else if((wa|0)==17){Ha=c[Fa+204>>2]|0;c[g>>2]=c[Fa+580>>2];c[oa>>2]=Ha;if(Pad(Ba,Aa,ca,g,2,f,Fa)|0){Ia=Ba;Ja=Aa;break}Ia=c[146758]|0;Ja=a[587036]|0;break}else{if((wa+-19|0)>>>0<5){Ha=c[xa>>2]|0;Ka=c[(Xbd()|0)+596>>2]|0;La=587032;Ma=c[La>>2]|0;if(Z){Na=c[La+4>>2]&255;if(!Ma){Ia=0;Ja=Na;break}else{Oa=Ma;Pa=Na;Qa=Ma}}else{Ma=ca;while(1){psc(l,ca,Ha,-1,8);Na=c[l>>2]|0;La=a[ea>>0]|0;if(Na){Ra=Na;Sa=La;break}Ma=isc(Ma)|0;if(!((Ma|0)!=(Ka|0)&(Ma|0)!=0)){Ia=0;Ja=La;break b}}Oa=Ra;Pa=Sa;Qa=Ra}Ma=c[Fa+568>>2]|0;Ka=c[Fa+204>>2]|0;c[g>>2]=c[Fa+564>>2];c[W>>2]=Ma;c[aa>>2]=Ka;if(Pad(Oa,Pa,ca,g,3,f,Fa)|0){Ia=Qa;Ja=Pa;break}Ia=c[146758]|0;Ja=a[587036]|0;break}Ka=wa&-2;if((Ka|0)==24){Ma=c[xa>>2]|0;Ha=c[(Xbd()|0)+596>>2]|0;La=587032;Na=c[La>>2]|0;if(Z){Ta=c[La+4>>2]&255;if(!Na){Ia=0;Ja=Ta;break}else{Ua=Na;Va=Ta;Wa=Na}}else{Na=ca;while(1){psc(k,ca,Ma,-1,8);Ta=c[k>>2]|0;La=a[pa>>0]|0;if(Ta){Xa=Ta;Ya=La;break}Na=isc(Na)|0;if(!((Na|0)!=(Ha|0)&(Na|0)!=0)){Ia=0;Ja=La;break b}}Ua=Xa;Va=Ya;Wa=Xa}Na=c[Fa+204>>2]|0;c[g>>2]=c[Fa+564>>2];c[oa>>2]=Na;if(Pad(Ua,Va,ca,g,2,f,Fa)|0){Ia=Wa;Ja=Va;break}Ia=c[146758]|0;Ja=a[587036]|0;break}if(Ga){Na=c[146758]|0;Ha=a[587036]|0;Ma=ksc(ca)|0;rri(L,617064,14);yO(K,L,Ma);yO(J,K,617080);yO(I,J,c[xa>>2]|0);yO(H,I,617088);if(qa)Za=0;else Za=c[ta>>2]|0;Krd((a[H>>0]&1)==0?ua:c[va>>2]|0,0,617120,391,2052,Za,c[Fa+4>>2]|0,0);xri(H);xri(I);xri(J);xri(K);xri(L);Ia=Na;Ja=Ha;break}Ha=j;c[Ha>>2]=Ba;c[Ha+4>>2]=ya&255;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Ha=qsc(g)|0;if(!Ha){Ia=Ba;Ja=Aa;break}Na=$sc(Ha)|0;if((Na|0)!=(c[Fa+144>>2]|0)){Ia=Ba;Ja=Aa;break}if((Ka|0)==4){Ia=c[146758]|0;Ja=a[587036]|0;break}else if((Ka|0)==10){Ia=Ba;Ja=Aa;break}Na=c[146758]|0;Ha=a[587036]|0;Ma=ksc(ca)|0;rri(Q,617064,14);yO(P,Q,Ma);yO(O,P,617080);yO(N,O,c[xa>>2]|0);yO(M,N,617184);if(qa)_a=0;else _a=c[ta>>2]|0;Krd((a[M>>0]&1)==0?ra:c[sa>>2]|0,0,617120,401,2052,_a,c[Fa+4>>2]|0,0);xri(M);xri(N);xri(O);xri(P);xri(Q);Ia=Na;Ja=Ha;break}}else{Ia=0;Ja=Aa}while(0);Aa=c[ba>>2]|0;c[Aa+(wa<<3)>>2]=Ia;a[Aa+(wa<<3)+4>>0]=Ja;wa=wa+1|0}while((wa|0)<26);if((b|0)>0){wa=R+16|0;sa=o+1|0;ra=s+1|0;ca=p+1|0;va=r+1|0;ua=r+8|0;oa=p+8|0;pa=s+8|0;Z=p+4|0;aa=s+4|0;W=u+1|0;ea=t+1|0;Aa=t+8|0;Fa=u+8|0;xa=u+4|0;Ba=w+4|0;ya=w+12|0;za=y+1|0;Ha=x+1|0;Na=x+8|0;Ma=y+8|0;La=y+4|0;Ta=o+8|0;$a=o+4|0;ab=0;do{bb=UTb()|0;VVb(R,bb,ab);if(c[wa>>2]&1){cb=TVb(bb,ab)|0;bb=c[ga>>2]|0;do if(bb){db=$;eb=bb;c:while(1){fb=eb;while(1){if((HEi(c[fb+16>>2]|0,cb)|0)>=0){gb=fb;break}fb=c[fb+4>>2]|0;if(!fb){hb=db;break c}}eb=c[gb>>2]|0;if(!eb){hb=gb;break}else db=gb}if((hb|0)!=($|0)){if((HEi(cb,c[hb+16>>2]|0)|0)<0){ib=587032;break}ib=hb+20|0}else ib=587032}else ib=587032;while(0);cb=ib;bb=c[cb>>2]|0;db=c[cb+4>>2]|0;do if(!bb){jb=0;kb=db}else{cb=Atc()|0;eb=UTb()|0;Ka=TVb(eb,ab)|0;rri(h,Ka,SEi(Ka|0)|0);sri(o,h);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Ka=a[o>>0]|0;if(!(Ka&1))lb=(Ka&255)>>>1;else lb=c[$a>>2]|0;Pri(n,617216,14,lb+14|0);Gri(n,(a[o>>0]&1)==0?sa:c[Ta>>2]|0,lb)|0;yO(m,n,1072968);xri(n);xri(o);rri(p,617232,28);Ka=db&255;Ga=q;c[Ga>>2]=bb;c[Ga+4>>2]=Ka;c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];Ga=_rc(g)|0;d:do if(Ga>>>0>1){yO(s,m,617264);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;fb=a[s>>0]|0;mb=(fb&1)==0;if(mb)nb=(fb&255)>>>1;else nb=c[aa>>2]|0;fb=a[p>>0]|0;if(!(fb&1))ob=(fb&255)>>>1;else ob=c[Z>>2]|0;Pri(r,mb?ra:c[pa>>2]|0,nb,ob+nb|0);Gri(r,(a[p>>0]&1)==0?ca:c[oa>>2]|0,ob)|0;if(qa)pb=0;else pb=c[ta>>2]|0;Krd((a[r>>0]&1)==0?va:c[ua>>2]|0,0,617120,164,2052,pb,c[cb+4>>2]|0,0);xri(r);xri(s);qb=0}else{mb=c[(Xbd()|0)+148>>2]|0;fb=c[(Xbd()|0)+136>>2]|0;if((Ga|0)!=1){qb=1;break}if(!(UVb(eb,ab)|0)){yO(u,m,617312);c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;rb=a[u>>0]|0;sb=(rb&1)==0;if(sb)tb=(rb&255)>>>1;else tb=c[xa>>2]|0;rb=a[p>>0]|0;if(!(rb&1))ub=(rb&255)>>>1;else ub=c[Z>>2]|0;Pri(t,sb?W:c[Fa>>2]|0,tb,ub+tb|0);Gri(t,(a[p>>0]&1)==0?ca:c[oa>>2]|0,ub)|0;if(qa)vb=0;else vb=c[ta>>2]|0;Krd((a[t>>0]&1)==0?ea:c[Aa>>2]|0,0,617120,177,2052,vb,c[cb+4>>2]|0,0);xri(t);xri(u);qb=0;break}sb=v;c[sb>>2]=bb;c[sb+4>>2]=Ka;c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];sb=$sc($rc(g,0)|0)|0;VVb(w,eb,ab);rb=c[Ba>>2]|0;if(!rb)wb=3653512;else{xb=csc(fb,3516216,rb)|0;if((sb|0)==(xb|0)&(xb|0)!=0){qb=1;break}wb=c[Ba>>2]|0}if((sb|0)==(mb|0)){qb=1;break}mb=c[ya>>2]|0;do if((mb|0)==100004)if((sb|0)==(c[cb+260>>2]|0)){qb=1;break d}else yb=617752;else if((mb|0)==100007)if((sb|0)==(c[cb+272>>2]|0)){qb=1;break d}else yb=617808;else{if(!((mb|0)>-1&(c[137788]|0)>(mb|0))){yb=wb;break}do if(sb){xb=Qcd(sb)|0;rb=c[137788]|0;fb=c[ya>>2]|0;if(!((xb|0)>-1&(rb|0)>(xb|0))){zb=fb;break}Ab=(da(fb,rb)|0)+xb|0;xb=Ab>>5;if(!(c[(c[137786]|0)+(xb<<2)>>2]&1<<Ab-(xb<<5)))zb=fb;else{qb=1;break d}}else zb=mb;while(0);fb=EQb(zb)|0;if(!(a[fb>>0]&1)){yb=fb+1|0;break}else{yb=c[fb+8>>2]|0;break}}while(0);if((c[ya>>2]|0)==100003){qb=1;break}mb=(sb|0)==(c[(Xbd()|0)+172>>2]|0);if(mb&(c[ya>>2]|0)==100001){qb=1;break}mb=(sb|0)==(c[(Xbd()|0)+204>>2]|0);if(mb&(c[ya>>2]|0)==1e5){qb=1;break}mb=(sb|0)==(c[(Xbd()|0)+212>>2]|0);if(mb&(c[ya>>2]|0)==100002){qb=1;break}yO(A,m,617360);yO(z,A,yb);yO(y,z,1072968);c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;mb=a[y>>0]|0;fb=(mb&1)==0;if(fb)Bb=(mb&255)>>>1;else Bb=c[La>>2]|0;mb=a[p>>0]|0;if(!(mb&1))Cb=(mb&255)>>>1;else Cb=c[Z>>2]|0;Pri(x,fb?za:c[Ma>>2]|0,Bb,Cb+Bb|0);Gri(x,(a[p>>0]&1)==0?ca:c[oa>>2]|0,Cb)|0;if(qa)Db=0;else Db=c[ta>>2]|0;Krd((a[x>>0]&1)==0?Ha:c[Na>>2]|0,0,617120,247,2052,Db,c[cb+4>>2]|0,0);xri(x);xri(y);xri(z);xri(A);qb=0}while(0);xri(p);xri(m);xri(h);if(qb){jb=bb;kb=db;break}jb=c[146758]|0;kb=d[587036]|0|db&-256}while(0);db=ab+26|0;bb=c[ba>>2]|0;c[bb+(db<<3)>>2]=jb;a[bb+(db<<3)+4>>0]=kb}ab=ab+1|0}while((ab|0)<(b|0))}Qad(C,c[ga>>2]|0);b=c[B>>2]|0;if(b){ab=c[na>>2]|0;if((ab|0)!=(b|0))c[na>>2]=ab+(~((ab+-8-b|0)>>>3)<<3);c[m>>2]=89;c[g+0>>2]=c[m+0>>2];eOb(b,g)}a[fa>>0]=(msc(ia,c[(Xbd()|0)+596>>2]|0)|0)&1;a[_>>0]=(btc(ia,c[(Xbd()|0)+592>>2]|0)|0)&1;la=ha}else la=T;while(0);if(!(a[V>>0]&1)){i=e;return la|0}V=c[X>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(V,g);i=e;return la|0}function Mad(a){a=a|0;return (a&-3|0)==0|(a|0)==1|0}function Nad(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+4|0;sri(h,e);e=a[h>>0]|0;if(!(e&1))k=(e&255)>>>1;else k=c[h+4>>2]|0;if(!k){rri(j,2789600,7);yri(h,j)|0;xri(j)}switch(d|0){case -7:{rri(b,617008,51);break}case -6:{if(!(a[h>>0]&1))l=h+1|0;else l=c[h+8>>2]|0;c[g>>2]=l;Lsd(b,616880,g);break}case -5:{if(!(a[h>>0]&1))m=h+1|0;else m=c[h+8>>2]|0;c[g>>2]=m;Lsd(b,616808,g);break}case -4:{if(!(a[h>>0]&1))n=h+1|0;else n=c[h+8>>2]|0;c[g>>2]=n;Lsd(b,616736,g);break}case -2:{if(!(a[h>>0]&1))o=h+1|0;else o=c[h+8>>2]|0;c[g>>2]=o;Lsd(b,616656,g);break}case -1:{if(!(a[h>>0]&1))p=h+1|0;else p=c[h+8>>2]|0;c[g>>2]=p;Lsd(b,616960,g);break}case -3:{if(!(a[h>>0]&1))q=h+1|0;else q=c[h+8>>2]|0;c[g>>2]=q;Lsd(b,616616,g);break}default:rri(b,3653512,0)}xri(h);i=f;return}function Oad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+4|0;j=c[h>>2]|0;do if(j){k=c[b>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((HEi(k,m)|0)<0){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((HEi(m,k)|0)>=0){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=a+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=g;x=w+20|0;i=d;return x|0}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];f=cOb(28,16,e,0,3653512,80)|0;c[f+16>>2]=c[b>>2];c[f+20>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=v;c[u>>2]=f;v=c[c[a>>2]>>2]|0;if(!v)y=f;else{c[a>>2]=v;y=c[u>>2]|0}GN(c[h>>2]|0,y);y=a+8|0;c[y>>2]=(c[y>>2]|0)+1;w=f;x=w+20|0;i=d;return x|0}function Pad(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;k=i;i=i+176|0;l=k+32|0;m=b;b=k+16|0;n=k+104|0;o=k+8|0;p=k+56|0;q=k+92|0;r=k+24|0;s=k+68|0;t=k;u=k+128|0;v=k+44|0;w=k+80|0;x=k+116|0;y=k+140|0;z=k+152|0;A=d&255;d=b;c[d>>2]=m;c[d+4>>2]=A;c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];if((_rc(l)|0)!=(g|0)){b=ksc(e)|0;d=o;c[d>>2]=m;c[d+4>>2]=A;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];o=asc(l)|0;c[l>>2]=b;c[l+4>>2]=o;Lsd(n,617408,l);rri(p,617432,29);if(!(a[n>>0]&1))B=n+1|0;else B=c[n+8>>2]|0;if(!(a[p>>0]&1))C=p+1|0;else C=c[p+8>>2]|0;c[l>>2]=B;c[l+4>>2]=g;c[l+8>>2]=C;Lsd(q,617464,l);if(!h)D=0;else D=c[h+4>>2]|0;if(!(a[q>>0]&1))E=q+1|0;else E=c[q+8>>2]|0;Krd(E,0,617120,85,2052,D,c[j+4>>2]|0,0);xri(q);xri(p);xri(n);F=0;i=k;return F|0}if(!g){F=1;i=k;return F|0}else G=0;while(1){n=r;c[n>>2]=m;c[n+4>>2]=A;c[l+0>>2]=c[r+0>>2];c[l+4>>2]=c[r+4>>2];n=$sc($rc(l,G)|0)|0;if((n|0)!=(c[(Xbd()|0)+148>>2]|0)?!(msc(c[f+(G<<2)>>2]|0,n)|0):0)break;G=G+1|0;if(G>>>0>=g>>>0){F=1;H=50;break}}if((H|0)==50){i=k;return F|0}H=ksc(e)|0;e=t;c[e>>2]=m;c[e+4>>2]=A;c[l+0>>2]=c[t+0>>2];c[l+4>>2]=c[t+4>>2];t=asc(l)|0;c[l>>2]=H;c[l+4>>2]=t;Lsd(s,617520,l);rri(u,617432,29);c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;l=g+-1|0;t=0;do{Eri(v,ksc(c[f+(t<<2)>>2]|0)|0)|0;Eri(v,t>>>0<l>>>0?617544:3672776)|0;t=t+1|0}while(t>>>0<g>>>0);yO(z,s,617552);c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;g=a[z>>0]|0;t=(g&1)==0;if(t)I=(g&255)>>>1;else I=c[z+4>>2]|0;g=a[v>>0]|0;if(!(g&1))J=(g&255)>>>1;else J=c[v+4>>2]|0;if(t)K=z+1|0;else K=c[z+8>>2]|0;Pri(y,K,I,J+I|0);if(!(a[v>>0]&1))L=v+1|0;else L=c[v+8>>2]|0;Gri(y,L,J)|0;yO(x,y,1072968);c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;J=a[x>>0]|0;L=(J&1)==0;if(L)M=(J&255)>>>1;else M=c[x+4>>2]|0;J=a[u>>0]|0;if(!(J&1))N=(J&255)>>>1;else N=c[u+4>>2]|0;if(L)O=x+1|0;else O=c[x+8>>2]|0;Pri(w,O,M,N+M|0);if(!(a[u>>0]&1))P=u+1|0;else P=c[u+8>>2]|0;Gri(w,P,N)|0;if(!h)Q=0;else Q=c[h+4>>2]|0;if(!(a[w>>0]&1))R=w+1|0;else R=c[w+8>>2]|0;Krd(R,0,617120,114,2052,Q,c[j+4>>2]|0,0);xri(w);xri(x);xri(y);xri(z);xri(v);xri(u);xri(s);F=0;i=k;return F|0}function Qad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Qad(a,c[b>>2]|0);Qad(a,c[b+4>>2]|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Rad(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;if(!(pLc()|0)){i=a;return}c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];d=bOb(4,b,0,16,3653512,64)|0;c[d>>2]=617616;c[154400]=d;d=pLc()|0;Dn[c[(c[d>>2]|0)+4>>2]&511](d,114,24,c[154400]|0);i=a;return}function Sad(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[154400]|0;c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[154400]=0;i=a;return}function Tad(b,d){b=b|0;d=d|0;var e=Im;e=(a[(c[d+12>>2]|0)+28>>0]|0)!=0?ea(1.0):ea(0.0);return ea(e)}function Uad(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0;a=i;e=c[b+12>>2]|0;if(d>ea(.00100000005))f=1;else f=d<ea(-.00100000005);In[c[(c[e>>2]|0)+120>>2]&4095](e,f);i=a;return}function Vad(a,b,c){a=a|0;b=b|0;c=c|0;return}function Wad(a,b){a=a|0;b=b|0;return 0}function Xad(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;b=a[d>>0]|0;if(!(b&1)){g=(b&255)>>>1;h=d+1|0}else{g=c[d+4>>2]|0;h=c[d+8>>2]|0}d=g>>>0>9;b=FEi(h,667608,d?9:g)|0;if(b){j=b;k=(j|0)==0;l=e^1;m=k&l;i=f;return m|0}j=g>>>0<9?-1:d&1;k=(j|0)==0;l=e^1;m=k&l;i=f;return m|0}function Yad(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 100001}function Zad(a){a=a|0;var b=0;b=i;PEi(a|0,0,164)|0;i=b;return}function _ad(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[a+(c[d>>2]<<2)>>2]=b&1;b=c[d>>2]|0;c[a+(b<<2)+80>>2]=a+(b<<2);c[a+(c[d>>2]<<2)+120>>2]=0;c[d>>2]=(c[d>>2]|0)+1;return}function $ad(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[a+(c[d>>2]<<2)>>2]=b;b=c[d>>2]|0;c[a+(b<<2)+80>>2]=a+(b<<2);c[a+(c[d>>2]<<2)+120>>2]=1;c[d>>2]=(c[d>>2]|0)+1;return}function abd(a,b){a=a|0;b=ea(b);var d=0,e=0;d=a+160|0;g[a+(c[d>>2]<<2)>>2]=b;e=c[d>>2]|0;c[a+(e<<2)+80>>2]=a+(e<<2);c[a+(c[d>>2]<<2)+120>>2]=2;c[d>>2]=(c[d>>2]|0)+1;return}function bbd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ysc(b)|0;b=a+160|0;c[a+(c[b>>2]<<2)+80>>2]=e;c[a+(c[b>>2]<<2)+120>>2]=3;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function cbd(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[a+(c[d>>2]<<2)+80>>2]=b;c[a+(c[d>>2]<<2)+120>>2]=4;c[d>>2]=(c[d>>2]|0)+1;return}function dbd(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[a+(c[d>>2]<<2)+80>>2]=b;c[a+(c[d>>2]<<2)+120>>2]=5;c[d>>2]=(c[d>>2]|0)+1;return}function ebd(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[a+(c[d>>2]<<2)+80>>2]=b;c[a+(c[d>>2]<<2)+120>>2]=6;c[d>>2]=(c[d>>2]|0)+1;return}function fbd(a){a=a|0;return c[a+160>>2]|0}function gbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=_rc(e)|0;e=a+160|0;if((f|0)>=(c[e>>2]|0)){i=d;return}c[e>>2]=f;i=d;return}function hbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=_rc(e)|0;i=d;return (f|0)==(c[a+160>>2]|0)|0}function ibd(a){a=a|0;var b=0;b=i;ubd(a);c[a>>2]=617656;Zad(a+32|0);i=b;return}function jbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];vbd(a,e);c[a>>2]=617656;Zad(a+32|0);i=d;return}function kbd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h;ubd(b);c[b>>2]=617656;Zad(b+32|0);k=b+4|0;Gcd(j,d,e,f,g);c[k+0>>2]=c[j+0>>2];a[k+4>>0]=a[j+4>>0]|0;i=h;return}function lbd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;ubd(b);c[b>>2]=617656;Zad(b+32|0);h=b+4|0;osc(g,d,e,-1);c[h+0>>2]=c[g+0>>2];a[h+4>>0]=a[g+4>>0]|0;i=f;return}function mbd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b;if(!(wbd(a)|0)){f=0;i=b;return f|0}g=a+4|0;h=c[g+4>>2]|0;j=e;c[j>>2]=c[g>>2];c[j+4>>2]=h;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];f=hbd(a+32|0,d)|0;i=b;return f|0}function nbd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=_n[c[c[a>>2]>>2]&4095](a,d)|0;i=b;return e|0}function obd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=_n[c[c[b>>2]>>2]&4095](b,d)|0;if(c[d>>2]|0){g=0;i=e;return g|0}g=(a[f+8>>0]|0)!=0;i=e;return g|0}function pbd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e>>2]=0;f=_n[c[c[b>>2]>>2]&4095](b,e)|0;if(c[e>>2]|0){g=0;i=d;return g|0}g=(a[f+8>>0]|0)!=0;i=d;return g|0}function qbd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rbd(a,b,0)|0;i=c;return d|0}function rbd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f;j=f+8|0;c[d>>2]=0;k=b+4|0;l=c[k+4>>2]|0;m=h;c[m>>2]=c[k>>2];c[m+4>>2]=l;l=c[b+12>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];h=Arc(g,l,b+32|0,d,e)|0;e=c[d>>2]|0;if(!e){n=h;i=f;return n|0}c[b+28>>2]=e;if(!(a[b+25>>0]|0)){n=0;i=f;return n|0}e=c[d>>2]|0;d=c[b+16>>2]|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Rcd(e,d,j);xri(j);n=0;i=f;return n|0}function sbd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+4|0;g=c[f+4>>2]|0;h=e;c[h>>2]=c[f>>2];c[h+4>>2]=g;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];gbd(a+32|0,d);i=b;return}function tbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+224|0;e=d+208|0;f=d+200|0;g=d;h=a;a=c[h+4>>2]|0;j=f;c[j>>2]=c[h>>2];c[j+4>>2]=a;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];vbd(g,e);c[g>>2]=617656;f=g+32|0;Zad(f);cbd(f,Ecd(b)|0);c[e>>2]=0;_n[c[c[g>>2]>>2]&4095](g,e)|0;i=d;return}function ubd(b){b=b|0;var d=0;c[b>>2]=617672;d=b+4|0;c[d>>2]=0;c[b+12>>2]=0;c[d+0>>2]=c[146758];a[d+4>>0]=a[587036]|0;c[b+20>>2]=0;a[b+24>>0]=1;a[b+25>>0]=1;c[b+16>>2]=0;c[b+28>>2]=0;return}function vbd(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=617672;e=b+4|0;c[b+12>>2]=0;c[b+20>>2]=0;a[b+24>>0]=1;a[b+25>>0]=1;c[b+16>>2]=0;c[b+28>>2]=0;c[e+0>>2]=c[d+0>>2];a[e+4>>0]=a[d+4>>0]|0;return}function wbd(a){a=a|0;return 1}function xbd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=_n[c[c[a>>2]>>2]&4095](a,d)|0;i=b;return e|0}function ybd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+208|0;f=e+192|0;g=e+8|0;h=e;j=e+176|0;c[d>>2]=0;Zad(g);k=b+4|0;l=c[k+4>>2]|0;m=h;c[m>>2]=c[k>>2];c[m+4>>2]=l;l=c[b+12>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=rsc(f,l,g,d)|0;g=c[d>>2]|0;if(!g){n=h;i=e;return n|0}c[b+28>>2]=g;if(!(a[b+25>>0]|0)){n=0;i=e;return n|0}g=c[d>>2]|0;d=c[b+16>>2]|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Rcd(g,d,j);xri(j);n=0;i=e;return n|0}function zbd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if(!(mo[c[(c[a>>2]|0)+4>>2]&4095](a)|0)){e=0;i=b;return e|0}c[d>>2]=0;e=_n[c[c[a>>2]>>2]&4095](a,d)|0;i=b;return e|0}
function Abd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+80|0;e=d;f=d+48|0;g=d+40|0;h=d+16|0;j=d+32|0;k=d+8|0;l=d+24|0;m=d+56|0;n=d+72|0;o=b+4|0;p=c[o>>2]|0;if(!p)Nrc(617680,e);q=c[153134]|0;c[m>>2]=0;r=m+4|0;c[r>>2]=q;q=m+8|0;c[q>>2]=0;s=m+12|0;c[s>>2]=0;c[n>>2]=0;t=b+13|0;u=(a[t>>0]|0)==0;v=u?m:n;c[l>>2]=v;w=c[b+16>>2]|0;a:do if((w|0)!=1|u){if((w|0)==1&u){x=Xbd()|0;y=Tbd(x,ssc(p)|0)|0;if((y|0)==-1){c[j>>2]=2;z=ssc(p)|0;A=2}else{c[j>>2]=0;z=y;A=0}c[j+4>>2]=z;y=(A|0)==0;x=(a[b+12>>0]|0)==0;if(!(x|y^1)){Dbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,j,l);break}if(y&x){Ebd(c[b>>2]|0,(a[b+14>>0]|0)!=0,j,l)|0;break}y=(A|0)==2;if(!(x|y^1)){Fbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,j,l);break}if(!(y&x))break;Gbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,j,l)|0;break}if((w|0)!=0|u){if(!((w|0)==0&u))break;x=Xbd()|0;y=Tbd(x,ssc(p)|0)|0;if((y|0)==-1){c[g>>2]=2;B=ssc(p)|0;C=2}else{c[g>>2]=0;B=y;C=0}c[g+4>>2]=B;y=(C|0)==0;x=(a[b+12>>0]|0)==0;if(!(x|y^1)){Jbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,g,l);break}if(y&x){Ebd(c[b>>2]|0,(a[b+14>>0]|0)!=0,g,l)|0;break}y=(C|0)==2;if(!(x|y^1)){Kbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,g,l);break}if(!(y&x))break;Gbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,g,l)|0;break}x=Xbd()|0;y=Tbd(x,ssc(p)|0)|0;if((y|0)==-1){c[h>>2]=2;D=ssc(p)|0;E=2}else{c[h>>2]=0;D=y;E=0}c[h+4>>2]=D;y=(E|0)==0;x=(a[b+12>>0]|0)==0;F=D;if(!(x|y^1)){Hbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,h,l)|0;break}if(y&x){y=c[b>>2]|0;G=(a[b+14>>0]|0)==0;c[v>>2]=0;if(G?!(vTb(y)|0):0)break;G=c[y+24>>2]|0;H=c[y+32>>2]|0;y=G+(H<<3)|0;if(!H)break;H=c[137788]|0;I=c[137786]|0;J=G;while(1){G=c[J>>2]|0;if((G|0)==(D|0)){K=J;break}L=(da(G,H)|0)+D|0;G=L>>5;if(c[I+(G<<2)>>2]&1<<L-(G<<5)){K=J;break}J=J+8|0;if((J|0)==(y|0))break a}c[v>>2]=c[K+4>>2];break}y=(E|0)==2;if(!(x|y^1)){Ibd(c[b>>2]|0,(a[b+14>>0]|0)!=0,h,l)|0;break}if(y&x){y=c[b>>2]|0;J=(a[b+14>>0]|0)==0;c[v>>2]=0;if(J?!(vTb(y)|0):0)break;J=c[y+24>>2]|0;I=c[y+32>>2]|0;y=J+(I<<3)|0;if(I){I=J;while(1){if((c[I>>2]|0)==114?(J=I+4|0,H=m9c(c[J>>2]|0)|0,(H|0)!=0):0){if((H|0)==(F|0)){M=J;break}if(msc(H,F)|0){M=J;break}}I=I+8|0;if((I|0)==(y|0))break a}c[v>>2]=c[M>>2]}}}else{y=Xbd()|0;I=Tbd(y,ssc(p)|0)|0;if((I|0)==-1){c[k>>2]=2;N=ssc(p)|0;O=2}else{c[k>>2]=0;N=I;O=0}c[k+4>>2]=N;I=(O|0)==0;y=(a[b+12>>0]|0)==0;F=N;if(!(y|I^1)){Bbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,k,l)|0;break}if(I&y){I=c[b>>2]|0;x=(a[b+14>>0]|0)==0;c[v>>2]=0;if(x?!(vTb(I)|0):0)break;x=c[I+24>>2]|0;J=c[I+32>>2]|0;I=x+(J<<3)|0;if(!J)break;J=c[137788]|0;H=c[137786]|0;G=x;while(1){x=c[G>>2]|0;if((x|0)==(N|0)){P=G;break}L=(da(x,J)|0)+N|0;x=L>>5;if(c[H+(x<<2)>>2]&1<<L-(x<<5)){P=G;break}G=G+8|0;if((G|0)==(I|0))break a}c[v>>2]=c[P+4>>2];break}I=(O|0)==2;if(!(y|I^1)){Cbd(c[b>>2]|0,(a[b+14>>0]|0)!=0,k,l)|0;break}if(I&y){I=c[b>>2]|0;G=(a[b+14>>0]|0)==0;c[v>>2]=0;if(G?!(vTb(I)|0):0)break;G=c[I+24>>2]|0;H=c[I+32>>2]|0;I=G+(H<<3)|0;if(H){H=G;while(1){if((c[H>>2]|0)==114?(G=H+4|0,J=m9c(c[G>>2]|0)|0,(J|0)!=0):0){if((J|0)==(F|0)){Q=G;break}if(msc(J,F)|0){Q=G;break}}H=H+8|0;if((H|0)==(I|0))break a}c[v>>2]=c[Q>>2]}}}while(0);do if(a[t>>0]|0){Q=c[n>>2]|0;if(!Q)R=0;else R=Ecd(Q)|0}else{if(!(a[b+20>>0]|0))S=c[(Xbd()|0)+40>>2]|0;else S=ssc(c[o>>2]|0)|0;Q=c[b+8>>2]|0;if(!Q){v=Isc(S,4,c[q>>2]|0)|0;l=yrc(v)|0;if(!(c[q>>2]|0))T=0;else{k=0;O=c[m>>2]|0;while(1){Qrc(v,k,Ecd(c[O>>2]|0)|0);P=k+1|0;O=O+4|0;if((O|0)==((c[m>>2]|0)+(c[q>>2]<<2)|0)){T=P;break}else k=P}}if((T|0)<(l|0)){k=T;do{c[(Gsc(v,k,4)|0)>>2]=0;k=k+1|0}while((k|0)!=(l|0))}R=v;break}l=Q+8|0;k=yrc(c[l>>2]|0)|0;O=c[q>>2]|0;if(k>>>0<O>>>0){k=Isc(S,4,O)|0;c[l>>2]=k;U=k}else U=c[l>>2]|0;l=yrc(U)|0;if(!(c[q>>2]|0)){V=0;W=0}else{k=0;O=c[m>>2]|0;while(1){Qrc(U,k,Ecd(c[O>>2]|0)|0);P=k+1|0;O=O+4|0;N=c[q>>2]|0;if((O|0)==((c[m>>2]|0)+(N<<2)|0)){V=N;W=P;break}else k=P}}if((W|0)<(l|0)){k=W;do{c[(Gsc(U,k,4)|0)>>2]=0;k=k+1|0}while((k|0)!=(l|0));X=c[q>>2]|0}else X=V;c[Q+12>>2]=X;l=Q+16|0;c[l>>2]=(c[l>>2]|0)+1;R=0}while(0);if((c[s>>2]|0)<=-1){i=d;return R|0}s=c[m>>2]|0;c[f>>2]=c[r>>2];c[e+0>>2]=c[f+0>>2];eOb(s,e);c[m>>2]=0;i=d;return R|0}function Bbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;c[c[e>>2]>>2]=0;if(!(!b?!(vTb(a)|0):0))g=3;a:do if((g|0)==3?(h=c[d+4>>2]|0,j=c[a+24>>2]|0,k=c[a+32>>2]|0,l=j+(k<<3)|0,(k|0)!=0):0){k=c[137788]|0;m=c[137786]|0;n=j;while(1){j=c[n>>2]|0;if((j|0)==(h|0)){o=n;break}p=(da(j,k)|0)+h|0;j=p>>5;if(c[m+(j<<2)>>2]&1<<p-(j<<5)){o=n;break}n=n+8|0;if((n|0)==(l|0))break a}c[c[e>>2]>>2]=c[o+4>>2];q=1;i=f;return q|0}while(0);o=c[(BTb(a)|0)+156>>2]|0;if(!o){q=0;i=f;return q|0}q=Bbd(c[o+24>>2]|0,b,d,e)|0;i=f;return q|0}function Cbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;c[c[e>>2]>>2]=0;if(!(!b?!(vTb(a)|0):0))g=3;a:do if((g|0)==3?(h=c[a+24>>2]|0,j=c[a+32>>2]|0,k=h+(j<<3)|0,(j|0)!=0):0){j=d+4|0;l=h;while(1){h=c[j>>2]|0;if((c[l>>2]|0)==114?(m=l+4|0,n=m9c(c[m>>2]|0)|0,(n|0)!=0):0){if((n|0)==(h|0)){o=m;break}if(msc(n,h)|0){o=m;break}}l=l+8|0;if((l|0)==(k|0))break a}c[c[e>>2]>>2]=c[o>>2];p=1;i=f;return p|0}while(0);o=c[(BTb(a)|0)+156>>2]|0;if(!o){p=0;i=f;return p|0}p=Cbd(c[o+24>>2]|0,b,d,e)|0;i=f;return p|0}function Dbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;Ebd(a,b,d,e)|0;g=c[(BTb(a)|0)+156>>2]|0;if(!g){i=f;return}Dbd(c[g+24>>2]|0,b,d,e);i=f;return}function Ebd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;if(!b?!(vTb(a)|0):0){k=0;i=f;return k|0}b=c[d+4>>2]|0;d=c[a+24>>2]|0;l=c[a+32>>2]|0;a=d+(l<<3)|0;if(!l){k=0;i=f;return k|0}l=0;m=d;while(1){d=c[m>>2]|0;if((d|0)!=(b|0)?(n=(da(c[137788]|0,d)|0)+b|0,d=n>>5,(1<<n-(d<<5)&c[(c[137786]|0)+(d<<2)>>2]|0)==0):0)o=l;else{c[j>>2]=c[m+4>>2];d=c[e>>2]|0;n=d+8|0;do if((c[n>>2]|0)==0?(p=d+12|0,q=c[p>>2]|0,(q&2147483646)>>>0<10):0)if((q|0)>-1){c[p>>2]=10;q=c[d>>2]|0;c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];c[d>>2]=hOb(q,40,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];q=cOb(40,4,g,0,3653512,352)|0;YEi(q|0,c[d>>2]|0,c[n>>2]<<2|0)|0;c[p>>2]=10;c[d>>2]=q;break}while(0);tQc(d,j);o=1}m=m+8|0;if((m|0)==(a|0)){k=o;break}else l=o}i=f;return k|0}function Fbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;Gbd(a,b,d,e)|0;g=c[(BTb(a)|0)+156>>2]|0;if(!g){i=f;return}Fbd(c[g+24>>2]|0,b,d,e);i=f;return}function Gbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;if(!b?!(vTb(a)|0):0){k=0;i=f;return k|0}b=c[a+24>>2]|0;l=c[a+32>>2]|0;a=b+(l<<3)|0;if(!l){k=0;i=f;return k|0}l=d+4|0;d=0;m=b;while(1){b=c[l>>2]|0;do if((c[m>>2]|0)==114?(n=m+4|0,o=m9c(c[n>>2]|0)|0,(o|0)!=0):0){if((o|0)!=(b|0)?!(msc(o,b)|0):0){p=d;break}c[j>>2]=c[n>>2];n=c[e>>2]|0;o=n+8|0;do if((c[o>>2]|0)==0?(q=n+12|0,r=c[q>>2]|0,(r&2147483646)>>>0<10):0)if((r|0)>-1){c[q>>2]=10;r=c[n>>2]|0;c[h>>2]=c[n+4>>2];c[g+0>>2]=c[h+0>>2];c[n>>2]=hOb(r,40,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[n+4>>2];c[g+0>>2]=c[h+0>>2];r=cOb(40,4,g,0,3653512,352)|0;YEi(r|0,c[n>>2]|0,c[o>>2]<<2|0)|0;c[q>>2]=10;c[n>>2]=r;break}while(0);tQc(n,j);p=1}else p=d;while(0);m=m+8|0;if((m|0)==(a|0)){k=p;break}else d=p}i=f;return k|0}function Hbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;c[c[e>>2]>>2]=0;if(!(!b?!(vTb(a)|0):0))g=3;a:do if((g|0)==3?(h=c[d+4>>2]|0,j=c[a+24>>2]|0,k=c[a+32>>2]|0,l=j+(k<<3)|0,(k|0)!=0):0){k=c[137788]|0;m=c[137786]|0;n=j;while(1){j=c[n>>2]|0;if((j|0)==(h|0)){o=n;break}p=(da(j,k)|0)+h|0;j=p>>5;if(c[m+(j<<2)>>2]&1<<p-(j<<5)){o=n;break}n=n+8|0;if((n|0)==(l|0))break a}c[c[e>>2]>>2]=c[o+4>>2];q=1;i=f;return q|0}while(0);o=BTb(a)|0;a=c[o+148>>2]|0;if((a|0)<=0){q=0;i=f;return q|0}l=o+140|0;o=0;while(1){if(Hbd(c[(c[(c[l>>2]|0)+(o<<2)>>2]|0)+24>>2]|0,b,d,e)|0){q=1;g=13;break}o=o+1|0;if((o|0)>=(a|0)){q=0;g=13;break}}if((g|0)==13){i=f;return q|0}return 0}function Ibd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;c[c[e>>2]>>2]=0;if(!(!b?!(vTb(a)|0):0))g=3;a:do if((g|0)==3?(h=c[a+24>>2]|0,j=c[a+32>>2]|0,k=h+(j<<3)|0,(j|0)!=0):0){j=d+4|0;l=h;while(1){h=c[j>>2]|0;if((c[l>>2]|0)==114?(m=l+4|0,n=m9c(c[m>>2]|0)|0,(n|0)!=0):0){if((n|0)==(h|0)){o=m;break}if(msc(n,h)|0){o=m;break}}l=l+8|0;if((l|0)==(k|0))break a}c[c[e>>2]>>2]=c[o>>2];p=1;i=f;return p|0}while(0);o=BTb(a)|0;a=c[o+148>>2]|0;if((a|0)<=0){p=0;i=f;return p|0}k=o+140|0;o=0;while(1){if(Ibd(c[(c[(c[k>>2]|0)+(o<<2)>>2]|0)+24>>2]|0,b,d,e)|0){p=1;g=15;break}o=o+1|0;if((o|0)>=(a|0)){p=0;g=15;break}}if((g|0)==15){i=f;return p|0}return 0}function Jbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;Ebd(a,b,d,e)|0;g=BTb(a)|0;a=c[g+148>>2]|0;if((a|0)<=0){i=f;return}h=g+140|0;g=0;do{Jbd(c[(c[(c[h>>2]|0)+(g<<2)>>2]|0)+24>>2]|0,b,d,e);g=g+1|0}while((g|0)!=(a|0));i=f;return}function Kbd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;Gbd(a,b,d,e)|0;g=BTb(a)|0;a=c[g+148>>2]|0;if((a|0)<=0){i=f;return}h=g+140|0;g=0;do{Kbd(c[(c[(c[h>>2]|0)+(g<<2)>>2]|0)+24>>2]|0,b,d,e);g=g+1|0}while((g|0)!=(a|0));i=f;return}function Lbd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+224|0;e=d+200|0;f=d+184|0;g=d+88|0;h=d+96|0;j=d+168|0;k=d+32|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+160|0;q=d+176|0;r=d+192|0;s=d+208|0;t=d+104|0;u=d+112|0;v=d+120|0;w=d+128|0;x=d+136|0;y=d+24|0;z=d+16|0;A=d+144|0;B=d+72|0;C=d+152|0;D=d+8|0;E=d;F=d+80|0;c[b>>2]=Mbd(3516336,3516216,2454944)|0;c[b+4>>2]=Mbd(3516336,3516216,2459184)|0;c[b+8>>2]=Mbd(3516336,3516216,2353128)|0;c[b+12>>2]=Mbd(3516336,3516216,2416168)|0;c[b+16>>2]=Mbd(3516336,3516216,2417560)|0;c[b+20>>2]=Mbd(3516336,3516216,2432056)|0;c[b+24>>2]=Mbd(3516336,3516216,2422256)|0;c[b+28>>2]=Mbd(3516336,3516216,2390464)|0;c[b+32>>2]=Mbd(3516336,3516216,2420672)|0;c[b+36>>2]=Mbd(3516336,3516216,2426952)|0;c[b+40>>2]=Mbd(3516336,3516216,2431088)|0;c[b+44>>2]=Mbd(3516336,3516216,2357736)|0;c[b+48>>2]=Mbd(3516336,3516216,2464312)|0;c[b+52>>2]=Mbd(3516336,3516216,2509024)|0;c[b+56>>2]=Mbd(3516336,3516216,2419248)|0;c[b+60>>2]=Mbd(3516336,2441696,2441672)|0;c[b+68>>2]=Asc(3516336,3516216,617704)|0;c[b+72>>2]=Asc(3516336,3516216,617720)|0;c[b+76>>2]=Asc(3516336,3516216,2486536)|0;c[b+80>>2]=Asc(3516336,3516216,667576)|0;c[b+84>>2]=Mbd(3516336,3516216,2449160)|0;c[b+88>>2]=Mbd(3516336,3516216,2362368)|0;c[b+92>>2]=Mbd(3516336,3516216,2349360)|0;c[b+184>>2]=Mbd(3516336,3516216,2350656)|0;c[b+188>>2]=Mbd(3516336,3516216,2351104)|0;c[b+192>>2]=Mbd(3516336,3516216,2351384)|0;c[b+196>>2]=Mbd(3516336,3516216,2495816)|0;G=b+200|0;Nbd(e,3516336,3516216,2497152,2496960);c[G+0>>2]=c[e+0>>2];a[G+4>>0]=a[e+4>>0]|0;c[b+212>>2]=Asc(3516336,3516216,617736)|0;c[b+216>>2]=Asc(3516336,3516216,617744)|0;c[b+220>>2]=Mbd(3516336,3516216,2351896)|0;c[b+224>>2]=Asc(3516336,3516216,617752)|0;c[b+228>>2]=Asc(3516336,3516216,617768)|0;c[b+232>>2]=Asc(3516336,3516216,617784)|0;c[b+236>>2]=Asc(3516336,3516216,617808)|0;c[b+240>>2]=Asc(3516336,3516216,617824)|0;c[b+244>>2]=Asc(3516336,3516216,617840)|0;e=b+252|0;c[e>>2]=Mbd(3516336,3516216,3126408)|0;c[b+248>>2]=Mbd(3516336,3516216,3029720)|0;c[b+96>>2]=Mbd(3516336,3516216,2435752)|0;c[b+260>>2]=zrc(2435616,0)|0;c[b+256>>2]=zrc(2529368,1)|0;c[b+100>>2]=etc(c[e>>2]|0)|0;c[b+264>>2]=Mbd(3516336,3516216,2436144)|0;e=b+268|0;Nbd(f,3516336,3516216,2436144,2435816);c[e+0>>2]=c[f+0>>2];a[e+4>>0]=a[f+4>>0]|0;f=b+276|0;Nbd(g,3516336,3516216,2436144,2436064);c[f+0>>2]=c[g+0>>2];a[f+4>>0]=a[g+4>>0]|0;c[b+284>>2]=Mbd(3516336,3516216,2394192)|0;c[b+288>>2]=Mbd(3516336,3516216,2503176)|0;c[b+292>>2]=Mbd(3516336,3516216,2470664)|0;c[b+300>>2]=Mbd(3516336,3516216,2355816)|0;c[b+424>>2]=Asc(3516336,3516216,2492024)|0;c[b+428>>2]=Asc(3516336,3516216,617864)|0;c[b+432>>2]=Asc(3516336,3516216,617880)|0;c[b+436>>2]=Asc(3516336,3516216,617896)|0;c[b+440>>2]=Asc(3516336,3516216,617912)|0;c[b+444>>2]=Mbd(3516336,3516216,2469376)|0;c[b+448>>2]=Mbd(3516336,3516216,2346528)|0;c[b+452>>2]=Mbd(3516336,3516216,2442896)|0;c[b+208>>2]=Mbd(3516336,3516216,2345816)|0;c[b+456>>2]=Mbd(3516336,3516216,2442256)|0;c[b+460>>2]=Asc(3516336,3516216,617928)|0;c[b+296>>2]=Mbd(3516336,3516216,2469920)|0;c[b+464>>2]=Mbd(3516336,3516216,3029720)|0;c[b+468>>2]=Asc(3516336,3516216,617944)|0;c[b+472>>2]=Asc(3516336,2441696,617968)|0;c[b+476>>2]=Asc(3516336,3516216,617984)|0;c[b+108>>2]=Mbd(3649424,2721352,2568288)|0;c[b+112>>2]=Mbd(3649424,3496376,3126408)|0;c[b+172>>2]=Mbd(3649424,3496376,3126928)|0;c[b+168>>2]=Mbd(3649424,3496376,3126664)|0;g=b+176|0;c[g>>2]=Mbd(3649424,3496376,3126792)|0;c[b+180>>2]=Mbd(3649424,3496376,3126824)|0;c[b+164>>2]=Mbd(3649424,3496376,3126568)|0;c[b+116>>2]=Mbd(3649424,3496376,2605856)|0;c[b+120>>2]=Mbd(3649424,3496376,3126632)|0;c[b+124>>2]=Mbd(3649424,3496376,3126696)|0;c[b+128>>2]=Mbd(3649424,3496376,3126600)|0;c[b+132>>2]=Mbd(3649424,3496376,3126728)|0;c[b+136>>2]=Mbd(3649424,3496376,3126472)|0;c[b+140>>2]=Mbd(3649424,3496376,2609112)|0;c[b+144>>2]=Mbd(3649424,2721352,2738312)|0;c[b+148>>2]=Mbd(3649424,2721352,2721336)|0;c[b+160>>2]=Mbd(3649424,2721352,2648448)|0;c[b+156>>2]=Mbd(3649424,2721352,2739320)|0;c[b+152>>2]=Mbd(3649424,3496376,3126888)|0;f=b+384|0;Nbd(h,3516336,3516216,2506016,2505824);c[f+0>>2]=c[h+0>>2];a[f+4>>0]=a[h+4>>0]|0;h=b+392|0;Nbd(j,3516336,3516216,2506016,2505704);c[h+0>>2]=c[j+0>>2];a[h+4>>0]=a[j+4>>0]|0;j=b+304|0;Nbd(k,3516336,3516216,2507784,3096792);c[j+0>>2]=c[k+0>>2];a[j+4>>0]=a[k+4>>0]|0;k=b+312|0;Nbd(l,3516336,3516216,2507784,2507672);c[k+0>>2]=c[l+0>>2];a[k+4>>0]=a[l+4>>0]|0;l=b+320|0;Nbd(m,3516336,3516216,2506016,2505920);c[l+0>>2]=c[m+0>>2];a[l+4>>0]=a[m+4>>0]|0;m=b+328|0;Nbd(n,3516336,3516216,2513848,2513192);c[m+0>>2]=c[n+0>>2];a[m+4>>0]=a[n+4>>0]|0;n=b+336|0;Nbd(o,3516336,3516216,2513848,2513488);c[n+0>>2]=c[o+0>>2];a[n+4>>0]=a[o+4>>0]|0;o=b+344|0;Nbd(p,3516336,3516216,2513848,2513624);c[o+0>>2]=c[p+0>>2];a[o+4>>0]=a[p+4>>0]|0;p=b+352|0;Nbd(q,3649424,2721352,2568288,2970280);c[p+0>>2]=c[q+0>>2];a[p+4>>0]=a[q+4>>0]|0;q=b+360|0;Nbd(r,3516336,3516216,2444016,2443896);c[q+0>>2]=c[r+0>>2];a[q+4>>0]=a[r+4>>0]|0;r=b+368|0;Nbd(s,3649424,2721352,2568288,2970352);c[r+0>>2]=c[s+0>>2];a[r+4>>0]=a[s+4>>0]|0;s=b+376|0;Nbd(t,3649424,3496376,2568888,2963568);c[s+0>>2]=c[t+0>>2];a[s+4>>0]=a[t+4>>0]|0;t=b+400|0;Nbd(u,3516336,3516216,2378232,2377680);c[t+0>>2]=c[u+0>>2];a[t+4>>0]=a[u+4>>0]|0;u=b+408|0;Nbd(v,3516336,3516216,2378232,2377888);c[u+0>>2]=c[v+0>>2];a[u+4>>0]=a[v+4>>0]|0;v=b+416|0;Nbd(w,3516336,3516216,2367720,2367552);c[v+0>>2]=c[w+0>>2];a[v+4>>0]=a[w+4>>0]|0;w=b+480|0;Nbd(x,3516336,3516216,3029720,2396920);c[w+0>>2]=c[x+0>>2];a[w+4>>0]=a[x+4>>0]|0;x=b+488|0;Nbd(y,3516336,3516216,2512272,2512072);c[x+0>>2]=c[y+0>>2];a[x+4>>0]=a[y+4>>0]|0;y=b+496|0;Nbd(z,3516336,3516216,2513848,2513096);c[y+0>>2]=c[z+0>>2];a[y+4>>0]=a[z+4>>0]|0;c[b+104>>2]=Mbd(3649424,3496376,3029544)|0;c[b+544>>2]=Hsc(c[g>>2]|0,1)|0;c[b+512>>2]=Mbd(3516336,3516216,2508392)|0;c[b+516>>2]=Mbd(3516336,3516216,2364712)|0;c[b+520>>2]=Mbd(3516336,3516216,2363728)|0;c[b+524>>2]=Mbd(3516336,3516216,2364104)|0;c[b+528>>2]=Mbd(3516336,3516216,2490224)|0;c[b+532>>2]=Mbd(3516336,3516216,2488424)|0;c[b+536>>2]=Mbd(3516336,3516216,2489568)|0;c[b+540>>2]=Mbd(3516336,3516216,2487176)|0;c[b+548>>2]=Mbd(3516336,3516216,2490600)|0;c[b+552>>2]=Mbd(3516336,3516216,2491704)|0;c[b+556>>2]=Mbd(3516336,3516216,2514776)|0;c[b+560>>2]=Mbd(3516336,3516216,2515848)|0;c[b+564>>2]=Mbd(3516336,3516216,2504944)|0;c[b+568>>2]=Mbd(3516336,3516216,2497480)|0;c[b+572>>2]=Mbd(3516336,3516216,2497784)|0;c[b+576>>2]=Mbd(3516336,3516216,2454496)|0;g=b+580|0;Nbd(A,3516336,3516216,2454496,2453232);c[g+0>>2]=c[A+0>>2];a[g+4>>0]=a[A+4>>0]|0;A=b+588|0;Nbd(B,3516336,3516216,2454496,2453328);c[A+0>>2]=c[B+0>>2];a[A+4>>0]=a[B+4>>0]|0;B=b+596|0;Nbd(C,3516336,3516216,2454496,2453008);c[B+0>>2]=c[C+0>>2];a[B+4>>0]=a[C+4>>0]|0;C=b+604|0;Nbd(D,3516336,3516216,2449160,2448360);c[C+0>>2]=c[D+0>>2];a[C+4>>0]=a[D+4>>0]|0;D=b+612|0;Nbd(E,3516336,3516216,2449160,2448448);c[D+0>>2]=c[E+0>>2];a[D+4>>0]=a[E+4>>0]|0;E=b+620|0;Nbd(F,3516336,3516216,2449160,2448536);c[E+0>>2]=c[F+0>>2];a[E+4>>0]=a[F+4>>0]|0;c[b+628>>2]=Mbd(3516336,2441696,618016)|0;i=d;return}function Mbd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=f+12|0;j=Asc(b,d,e)|0;if(j){i=f;return j|0}c[g>>2]=b;c[g+4>>2]=d;c[g+8>>2]=e;Lsd(h,618088,g);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;Krd(k,0,3653512,32,1,0,0,0);xri(h);i=f;return j|0}function Nbd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=h;k=h+16|0;Gcd(b,d,e,f,g);if(c[b>>2]|0){i=h;return}c[j>>2]=g;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=f;Lsd(k,618048,j);if(!(a[k>>0]&1))l=k+1|0;else l=c[k+8>>2]|0;Krd(l,0,3653512,18,1,0,0,0);xri(k);i=h;return}function Obd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];jSb(a,f,d);c[a>>2]=618160;c[a+28>>2]=0;c[a+32>>2]=0;c[a+24>>2]=a+28;c[a+236>>2]=0;c[a+304>>2]=0;c[a+312>>2]=0;c[a+340>>2]=0;c[a+348>>2]=0;c[a+356>>2]=0;c[a+364>>2]=0;c[a+372>>2]=0;c[a+380>>2]=0;c[a+388>>2]=0;c[a+396>>2]=0;c[a+404>>2]=0;c[a+412>>2]=0;c[a+420>>2]=0;c[a+428>>2]=0;c[a+436>>2]=0;c[a+444>>2]=0;c[a+452>>2]=0;c[a+516>>2]=0;c[a+524>>2]=0;c[a+532>>2]=0;c[a+616>>2]=0;c[a+624>>2]=0;c[a+632>>2]=0;c[a+640>>2]=0;c[a+648>>2]=0;c[a+656>>2]=0;c[a+668>>2]=0;c[a+672>>2]=0;c[a+676>>2]=0;c[a+684>>2]=0;c[a+688>>2]=0;c[a+680>>2]=a+684;c[a+696>>2]=0;c[a+700>>2]=0;c[a+704>>2]=0;uVb(5,a);i=e;return}function Pbd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=618160;d=c[a+696>>2]|0;if(d){e=a+700|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-8-d|0)>>>3)<<3);ACi(d)}Ybd(a+680|0,c[a+684>>2]|0);d=c[a+668>>2]|0;if(d){f=a+672|0;e=c[f>>2]|0;if((e|0)!=(d|0))c[f>>2]=e+(~((e+-4-d|0)>>>2)<<2);ACi(d)}Mtc(a+24|0,c[a+28>>2]|0);ZSb(a);i=b;return}function Qbd(a){a=a|0;var b=0;b=i;Pbd(a);ACi(a);i=b;return}function Rbd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+32|0;e=d+12|0;f=d+8|0;g=d;c[e>>2]=0;h=e+4|0;c[h>>2]=0;c[e+8>>2]=0;AQb(0,e,0);j=c[h>>2]|0;k=c[e>>2]|0;if((j|0)==(k|0))l=1;else{m=j-k>>2;j=0;n=0;while(1){o=c[k+(n<<2)>>2]|0;p=(o|0)<(j|0)?j:o;n=n+1|0;if(n>>>0>=m>>>0){q=p;break}else j=p}l=q+1|0}q=b+668|0;j=c[q>>2]|0;m=b+672|0;n=c[m>>2]|0;k=j;if((n|0)==(j|0))r=j;else{p=n+(~((n+-4-k|0)>>>2)<<2)|0;c[m>>2]=p;r=p}c[f>>2]=0;p=r-k>>2;if(l>>>0<=p>>>0)if(l>>>0<p>>>0?(k=j+(l<<2)|0,(r|0)!=(k|0)):0){c[m>>2]=r+(~((r+-4-k|0)>>>2)<<2);s=j}else s=j;else{Zbd(q,l-p|0,f);s=c[q>>2]|0}c[154536]=c[s>>2];s=c[b+696>>2]|0;f=b+700|0;p=c[f>>2]|0;if((p|0)!=(s|0))c[f>>2]=p+(~((p+-8-s|0)>>>3)<<3);s=Asc(3516336,3516216,3126408)|0;p=c[e>>2]|0;if((c[h>>2]|0)!=(p|0)){l=g+4|0;j=b+704|0;k=b+696|0;r=p;p=0;do{m=c[r+(p<<2)>>2]|0;n=m;while(1){o=EQb(n)|0;if(!(a[o>>0]&1))t=o+1|0;else t=c[o+8>>2]|0;o=Asc(3516336,3516216,t)|0;if(!o){u=Asc(3516336,618120,t)|0;if(u){v=u;w=22}}else{v=o;w=22}if((w|0)==22?(w=0,msc(v,s)|0):0){x=v;break}if(!n){x=0;break}n=HQb(n)|0}c[(c[q>>2]|0)+(m<<2)>>2]=x;n=EQb(m)|0;if(!(a[n>>0]&1))y=n+1|0;else y=c[n+8>>2]|0;n=Asc(3516336,3516216,y)|0;if(!n){o=Asc(3516336,618120,y)|0;if(o){z=o;w=30}}else{z=n;w=30}do if((w|0)==30?(w=0,msc(z,s)|0):0){c[g>>2]=z;c[l>>2]=m;n=c[f>>2]|0;if((n|0)==(c[j>>2]|0)){_bd(k,g);break}if(!n)A=0;else{o=g;u=c[o+4>>2]|0;B=n;c[B>>2]=c[o>>2];c[B+4>>2]=u;A=c[f>>2]|0}c[f>>2]=A+8}while(0);p=p+1|0;r=c[e>>2]|0}while(p>>>0<(c[h>>2]|0)-r>>2>>>0)}$bd(b+692|0);b=c[e>>2]|0;if(!b){i=d;return}e=c[h>>2]|0;if((e|0)!=(b|0))c[h>>2]=e+(~((e+-4-b|0)>>>2)<<2);ACi(b);i=d;return}function Sbd(a,b){a=a|0;b=b|0;return c[(c[a+668>>2]|0)+(b<<2)>>2]|0}function Tbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+696>>2]|0;f=c[a+700>>2]|0;a=f-e>>3;if(!a)g=e;else{h=e;e=a;while(1){a=(e|0)/2|0;if((c[h+(a<<3)>>2]|0)>>>0<b>>>0){j=h+(a+1<<3)|0;k=e+-1-a|0}else{j=h;k=a}if(!k){g=j;break}else{h=j;e=k}}}if((g|0)==(f|0)){l=-1;i=d;return l|0}k=(c[g>>2]|0)>>>0>b>>>0?f:g;if((k|0)==(f|0)){l=-1;i=d;return l|0}l=c[k+4>>2]|0;i=d;return l|0}function Ubd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+684>>2]|0;f=a+684|0;if(!e){g=0;i=d;return g|0}else{h=f;j=e}a:while(1){e=j;while(1){if((c[e+16>>2]|0)>=(b|0)){k=e;break}e=c[e+4>>2]|0;if(!e){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)==(f|0)){g=0;i=d;return g|0}if((c[l+16>>2]|0)>(b|0)){g=0;i=d;return g|0}g=c[l+20>>2]|0;i=d;return g|0}function Vbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[b+28>>2]|0;g=c[a+684>>2]|0;h=a+684|0;if(g){j=h;k=g;a:while(1){g=k;while(1){if((c[g+16>>2]|0)>=(f|0)){l=g;break}g=c[g+4>>2]|0;if(!g){m=j;break a}}k=c[l>>2]|0;if(!k){m=l;break}else j=l}if(((m|0)!=(h|0)?(c[m+16>>2]|0)<=(f|0):0)?(c[m+20>>2]|0)!=0:0){i=d;return}}c[e>>2]=f;c[(acd(a+680|0,e)|0)>>2]=b;i=d;return}function Wbd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[a+684>>2]|0;g=a+684|0;if(f){h=g;j=f;a:while(1){f=j;while(1){if((c[f+16>>2]|0)>=(b|0)){k=f;break}f=c[f+4>>2]|0;if(!f){l=h;break a}}j=c[k>>2]|0;if(!j){l=k;break}else h=k}if((l|0)!=(g|0)?(c[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8)m=g;g=c[m+20>>2]|0;if((Kad(g)|0)>1){i=d;return}c[e>>2]=b;bcd(a+680|0,e)|0;Iad(g);i=d;return}function Xbd(){var a=0,b=0;a=i;b=rVb(5)|0;i=a;return b|0}function Ybd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Ybd(a,c[b>>2]|0);Ybd(a,c[b+4>>2]|0);c[f>>2]=68;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Zbd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(g-k>>2>>>0>=b>>>0){l=b;m=j;do{if(!m)n=0;else{c[m>>2]=c[d>>2];n=c[h>>2]|0}m=n+4|0;c[h>>2]=m;l=l+-1|0}while((l|0)!=0);i=e;return}l=c[a>>2]|0;m=(k-l>>2)+b|0;if(m>>>0>1073741823)vxi(a);k=l;l=g-k|0;if(l>>2>>>0<536870911){g=l>>1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k>>2;if(!l){o=0;p=0;q=g}else{r=l;s=g;t=10}}else{r=1073741823;s=(c[h>>2]|0)-k>>2;t=10}if((t|0)==10){o=r;p=xCi(r<<2)|0;q=s}s=b;b=p+(q<<2)|0;while(1){if(!b)u=0;else{c[b>>2]=c[d>>2];u=b}r=u+4|0;s=s+-1|0;if(!s){v=r;break}else b=r}b=c[a>>2]|0;s=(c[h>>2]|0)-b|0;u=p+(q-(s>>2)<<2)|0;YEi(u|0,b|0,s|0)|0;c[a>>2]=u;c[h>>2]=v;c[f>>2]=p+(o<<2);if(!b){i=e;return}ACi(b);i=e;return}function _bd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>3)+1|0;if(g>>>0>536870911)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>3>>>0<268435455){l=k>>2;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>3;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=536870911;r=l>>3;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<3)|0;o=r;p=s}s=n+(o<<3)|0;if(s){r=b;b=c[r+4>>2]|0;q=s;c[q>>2]=c[r>>2];c[q+4>>2]=b}YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<3);c[h>>2]=n+(m<<3);if(!f){i=d;return}ACi(f);i=d;return}function $bd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;k=b+4|0;l=c[k>>2]|0;m=b+8|0;n=c[m>>2]|0;if((l|0)==(n|0)){i=d;return}a[j>>0]=a[b>>0]|0;b=n-l|0;o=b>>3;if((b|0)>0){b=o;while(1){p=yCi(b<<3,3667768)|0;if(p){q=p;r=b;break}if((b|0)>1)b=(b|0)/2|0;else{q=0;r=0;break}}s=q;t=r}else{s=0;t=0}c[g>>2]=l;c[h>>2]=n;c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];ccd(f,e,j,o,s,t);if(s)ACi(s);s=c[k>>2]|0;k=c[m>>2]|0;a:do if((s|0)==(k|0))u=s;else{t=s;while(1){o=t+8|0;if((o|0)==(k|0)){v=23;break}j=c[t>>2]|0;if(j>>>0<(c[o>>2]|0)>>>0)t=o;else{w=t;x=o;y=j;break}}if((v|0)==23){i=d;return}if((w|0)==(k|0)){i=d;return}else{z=w;A=y;B=x;C=x;D=w}while(1){t=c[z+8>>2]|0;if(A>>>0<t>>>0){c[B>>2]=t;c[B+4>>2]=c[C+4>>2];E=B+8|0}else E=B;t=z+16|0;j=D+8|0;if((t|0)==(k|0)){u=E;break a}o=C;A=c[j>>2]|0;B=E;C=t;D=j;z=o}}while(0);if((u|0)==(k|0)){i=d;return}z=u;u=z-s>>3;D=s+(u<<3)|0;C=s+(u+(k-z>>3)<<3)|0;if((C|0)==(k|0))F=D;else{z=k+-8|0;E=C;B=D;while(1){c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];E=E+8|0;if((E|0)==(k|0))break;else B=B+8|0}F=s+(u+1+((z-C|0)>>>3)<<3)|0}if((k|0)==(F|0)){i=d;return}c[m>>2]=k+(~((k+-8-F|0)>>>3)<<3);i=d;return}function acd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+4|0;j=c[h>>2]|0;do if(j){k=c[b>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((k|0)<(m|0)){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((m|0)>=(k|0)){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=a+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=g;x=w+20|0;i=d;return x|0}c[f>>2]=68;c[e+0>>2]=c[f+0>>2];f=cOb(24,16,e,0,3653512,80)|0;c[f+16>>2]=c[b>>2];c[f+20>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=v;c[u>>2]=f;v=c[c[a>>2]>>2]|0;if(!v)y=f;else{c[a>>2]=v;y=c[u>>2]|0}GN(c[h>>2]|0,y);y=a+8|0;c[y>>2]=(c[y>>2]|0)+1;w=f;x=w+20|0;i=d;return x|0}function bcd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a+4>>2]|0;h=a+4|0;if(!g){j=0;i=d;return j|0}k=c[b>>2]|0;b=h;l=g;a:while(1){m=l;while(1){if((c[m+16>>2]|0)>=(k|0)){n=m;break}m=c[m+4>>2]|0;if(!m){o=b;break a}}l=c[n>>2]|0;if(!l){o=n;break}else b=n}if((o|0)==(h|0)){j=0;i=d;return j|0}if((k|0)<(c[o+16>>2]|0)){j=0;i=d;return j|0}k=c[o+4>>2]|0;if(!k){h=o;while(1){n=c[h+8>>2]|0;if((c[n>>2]|0)==(h|0)){p=n;break}else h=n}}else{h=k;while(1){k=c[h>>2]|0;if(!k){p=h;break}else h=k}}if((c[a>>2]|0)==(o|0))c[a>>2]=p;p=a+8|0;c[p>>2]=(c[p>>2]|0)+-1;tYb(g,o);c[f>>2]=68;c[e+0>>2]=c[f+0>>2];eOb(o,e);j=1;i=d;return j|0}function ccd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+64|0;j=h+24|0;k=h+20|0;l=h+44|0;m=h+36|0;n=h+32|0;o=h+40|0;p=h+48|0;q=h+52|0;r=h+8|0;s=h+4|0;t=h+28|0;u=h+12|0;v=h;w=h+16|0;if((e|0)==2){x=c[b>>2]|0;y=x+-8|0;c[b>>2]=y;z=c[a>>2]|0;A=c[y>>2]|0;B=c[z>>2]|0;if(A>>>0>=B>>>0){i=h;return}c[z>>2]=A;c[y>>2]=B;B=z+4|0;z=x+-4|0;x=c[B>>2]|0;c[B>>2]=c[z>>2];c[z>>2]=x;i=h;return}else if((e|0)==1|(e|0)==0){i=h;return}else{if((e|0)<1){x=c[a>>2]|0;z=c[b>>2]|0;if((x|0)==(z|0)){i=h;return}B=x+8|0;if((B|0)==(z|0)){i=h;return}else{C=B;D=x}while(1){B=C;y=c[B+4>>2]|0;A=c[B>>2]|0;a:do if((C|0)==(x|0))E=x;else{B=C;while(1){F=B;B=B+-8|0;G=c[B>>2]|0;if(A>>>0>=G>>>0){E=F;break a}c[F>>2]=G;c[F+4>>2]=c[F+-4>>2];if((B|0)==(x|0)){E=x;break}}}while(0);c[E>>2]=A;c[E+4>>2]=y;B=D+16|0;if((B|0)==(z|0))break;else{F=C;C=B;D=F}}i=h;return}D=(e|0)/2|0;C=c[a>>2]|0;a=C+(D<<3)|0;if((e|0)>(g|0)){c[q>>2]=C;c[r>>2]=a;c[k+0>>2]=c[q+0>>2];c[j+0>>2]=c[r+0>>2];ccd(k,j,d,D,f,g);c[s>>2]=a;r=c[b>>2]|0;c[t>>2]=r;q=e-D|0;c[k+0>>2]=c[s+0>>2];c[j+0>>2]=c[t+0>>2];ccd(k,j,d,q,f,g);c[u>>2]=C;c[v>>2]=a;c[w>>2]=r;c[l+0>>2]=c[u+0>>2];c[k+0>>2]=c[v+0>>2];c[j+0>>2]=c[w+0>>2];ecd(l,k,j,d,D,q,f,g);i=h;return}c[m>>2]=C;c[n>>2]=a;c[k+0>>2]=c[m+0>>2];c[j+0>>2]=c[n+0>>2];dcd(k,j,d,D,f);c[o>>2]=a;c[p>>2]=c[b>>2];b=f+(D<<3)|0;c[k+0>>2]=c[o+0>>2];c[j+0>>2]=c[p+0>>2];dcd(k,j,d,e-D|0,b);D=f+(e<<3)|0;b:do if((e+1|0)>>>0<3){H=b;I=C}else{d=b;j=f;k=C;while(1){if((d|0)==(D|0)){J=j;K=k;break}p=c[d>>2]|0;o=c[j>>2]|0;if(p>>>0<o>>>0){c[k>>2]=p;L=d;M=d+8|0;N=j}else{c[k>>2]=o;L=j;M=d;N=j+8|0}c[k+4>>2]=c[L+4>>2];o=k+8|0;if((N|0)==(b|0)){H=M;I=o;break b}else{d=M;j=N;k=o}}if((J|0)==(b|0)){i=h;return}else{O=J;P=K}while(1){c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];O=O+8|0;if((O|0)==(b|0))break;else P=P+8|0}i=h;return}while(0);if((H|0)==(D|0)){i=h;return}else{Q=H;R=I}while(1){c[R>>2]=c[Q>>2];c[R+4>>2]=c[Q+4>>2];Q=Q+8|0;if((Q|0)==(D|0))break;else R=R+8|0}i=h;return}}function dcd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;if(!e){i=g;return}else if((e|0)==1){if(!f){i=g;return}o=c[a>>2]|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;i=g;return}else if((e|0)==2){p=(c[b>>2]|0)+-8|0;c[b>>2]=p;q=c[a>>2]|0;o=(f|0)==0;if((c[p>>2]|0)>>>0<(c[q>>2]|0)>>>0){if(!o){r=p;s=c[r+4>>2]|0;t=f;c[t>>2]=c[r>>2];c[t+4>>2]=s}s=q;t=c[s+4>>2]|0;r=f+8|0;c[r>>2]=c[s>>2];c[r+4>>2]=t;i=g;return}else{if(!o){o=q;q=c[o+4>>2]|0;t=f;c[t>>2]=c[o>>2];c[t+4>>2]=q}q=p;p=c[q+4>>2]|0;t=f+8|0;c[t>>2]=c[q>>2];c[t+4>>2]=p;i=g;return}}else{if((e|0)<9){p=c[a>>2]|0;t=c[b>>2]|0;if((p|0)==(t|0)){i=g;return}if(!f)u=0;else{q=p;o=c[q+4>>2]|0;r=f;c[r>>2]=c[q>>2];c[r+4>>2]=o;u=f}o=p+8|0;if((o|0)==(t|0)){i=g;return}else{v=o;w=p;x=u}while(1){u=x;x=x+8|0;if((c[w+8>>2]|0)>>>0<(c[u>>2]|0)>>>0){p=u;o=c[p+4>>2]|0;r=x;c[r>>2]=c[p>>2];c[r+4>>2]=o;a:do if((u|0)==(f|0))y=f;else{o=u;while(1){r=o;o=o+-8|0;p=c[o>>2]|0;if((c[v>>2]|0)>>>0>=p>>>0){y=r;break a}c[r>>2]=p;c[r+4>>2]=c[r+-4>>2];if((o|0)==(f|0)){y=f;break}}}while(0);c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2]}else{u=v;o=c[u+4>>2]|0;r=x;c[r>>2]=c[u>>2];c[r+4>>2]=o}o=w+16|0;if((o|0)==(t|0))break;else{r=v;v=o;w=r}}i=g;return}w=(e|0)/2|0;v=c[a>>2]|0;a=v+(w<<3)|0;c[k>>2]=v;c[l>>2]=a;c[j+0>>2]=c[k+0>>2];c[h+0>>2]=c[l+0>>2];ccd(j,h,d,w,f,w);c[m>>2]=a;l=c[b>>2]|0;c[n>>2]=l;b=e-w|0;c[j+0>>2]=c[m+0>>2];c[h+0>>2]=c[n+0>>2];ccd(j,h,d,b,f+(w<<3)|0,b);b:do if((e+1|0)>>>0<3){z=f;A=v}else{b=f;w=a;d=v;while(1){if((w|0)==(l|0)){B=b;C=d;break}h=(b|0)==0;if((c[w>>2]|0)>>>0<(c[d>>2]|0)>>>0){if(!h){j=w;n=c[j+4>>2]|0;m=b;c[m>>2]=c[j>>2];c[m+4>>2]=n}D=d;E=w+8|0}else{if(!h){h=d;n=c[h+4>>2]|0;m=b;c[m>>2]=c[h>>2];c[m+4>>2]=n}D=d+8|0;E=w}n=b+8|0;if((D|0)==(a|0)){z=n;A=E;break b}else{b=n;w=E;d=D}}if((C|0)==(a|0)){i=g;return}else{F=B;G=C}while(1){if(F){d=G;w=c[d+4>>2]|0;b=F;c[b>>2]=c[d>>2];c[b+4>>2]=w}G=G+8|0;if((G|0)==(a|0))break;else F=F+8|0}i=g;return}while(0);if((A|0)==(l|0)){i=g;return}else{H=z;I=A}while(1){if(H){A=I;z=c[A+4>>2]|0;F=H;c[F>>2]=c[A>>2];c[F+4>>2]=z}I=I+8|0;if((I|0)==(l|0))break;else H=H+8|0}i=g;return}}function ecd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;k=i;i=i+48|0;l=k+4|0;m=k+16|0;n=k+36|0;o=k;p=k+32|0;q=k+40|0;r=k+44|0;s=k+24|0;t=k+20|0;u=k+8|0;v=k+12|0;w=k+28|0;if((g|0)==0|(f|0)==0){i=k;return}x=g;g=f;f=c[b>>2]|0;a:while(1){y=c[f>>2]|0;z=g;A=c[a>>2]|0;while(1){B=c[A>>2]|0;if(y>>>0<B>>>0){C=z;D=A;E=A;F=B;break}A=A+8|0;c[a>>2]=A;z=z+-1|0;if(!z){G=36;break a}}if(!((C|0)>(j|0)&(x|0)>(j|0))){H=x;I=C;J=D;K=f;G=7;break}if((C|0)<(x|0)){z=(x|0)/2|0;A=f+(z<<3)|0;B=D;L=f-B>>3;if(!L)M=D;else{N=c[A>>2]|0;O=D;P=L;while(1){L=(P|0)/2|0;if(N>>>0<(c[O+(L<<3)>>2]|0)>>>0){Q=O;R=L}else{Q=O+(L+1<<3)|0;R=P+-1-L|0}if(!R){M=Q;break}else{O=Q;P=R}}}S=M;T=A;U=M-B>>3;V=z}else{if((C|0)==1){W=D;X=E;Y=F;Z=f;_=f;$=y;G=16;break}P=(C|0)/2|0;O=D+(P<<3)|0;N=f;L=(c[d>>2]|0)-N>>3;if(!L)aa=f;else{ba=c[O>>2]|0;ca=f;da=L;while(1){L=(da|0)/2|0;if((c[ca+(L<<3)>>2]|0)>>>0<ba>>>0){ea=ca+(L+1<<3)|0;fa=da+-1-L|0}else{ea=ca;fa=L}if(!fa){aa=ea;break}else{ca=ea;da=fa}}}S=O;T=aa;U=P;V=aa-N>>3}da=C-U|0;ca=x-V|0;b:do if((S|0)!=(f|0))if((f|0)!=(T|0)){ba=c[S>>2]|0;c[S>>2]=c[f>>2];c[f>>2]=ba;ba=S+4|0;y=f+4|0;z=c[ba>>2]|0;c[ba>>2]=c[y>>2];c[y>>2]=z;z=S+8|0;y=f+8|0;if((y|0)==(T|0)){ga=z;ha=f}else{ba=z;z=f;B=y;y=S;A=f;while(1){L=(ba|0)==(z|0)?B:z;ia=y+8|0;ja=A+8|0;ka=c[ia>>2]|0;c[ia>>2]=c[ja>>2];c[ja>>2]=ka;ka=y+12|0;ja=A+12|0;ia=c[ka>>2]|0;c[ka>>2]=c[ja>>2];c[ja>>2]=ia;ia=y+16|0;ja=A+16|0;if((ja|0)==(T|0)){ga=ia;ha=L;break}else{ka=B;la=ba;ba=ia;z=L;B=ja;A=ka;y=la}}}if((ga|0)==(ha|0))ma=ha;else{y=ha;A=ga;B=ha;while(1){z=A;ba=B;while(1){la=c[z>>2]|0;c[z>>2]=c[ba>>2];c[ba>>2]=la;la=z+4|0;ka=ba+4|0;ja=c[la>>2]|0;c[la>>2]=c[ka>>2];c[ka>>2]=ja;z=z+8|0;ja=ba+8|0;ka=(z|0)==(y|0);if((ja|0)!=(T|0)){na=z;oa=ja;pa=ka;break}if(ka){ma=ga;break b}else ba=y}y=pa?oa:y;A=na;B=oa}}}else ma=S;else ma=T;while(0);c[b>>2]=ma;if((V+U|0)<(ca+da|0)){c[r>>2]=c[a>>2];c[s>>2]=S;c[t>>2]=ma;c[n+0>>2]=c[r+0>>2];c[m+0>>2]=c[s+0>>2];c[l+0>>2]=c[t+0>>2];ecd(n,m,l,e,U,V,h,j);c[a>>2]=ma;qa=da;ra=ca;sa=T}else{c[u>>2]=ma;c[v>>2]=T;c[w>>2]=c[d>>2];c[n+0>>2]=c[u+0>>2];c[m+0>>2]=c[v+0>>2];c[l+0>>2]=c[w+0>>2];ecd(n,m,l,e,da,ca,h,j);c[d>>2]=ma;qa=U;ra=V;sa=S}c[b>>2]=sa;if((ra|0)==0|(qa|0)==0){G=36;break}else{x=ra;g=qa;f=sa}}if((G|0)==7){c[o>>2]=J;c[p>>2]=K;c[q>>2]=c[d>>2];c[n+0>>2]=c[o+0>>2];c[m+0>>2]=c[p+0>>2];c[l+0>>2]=c[q+0>>2];fcd(n,m,l,e,I,H,h);i=k;return}else if((G|0)==16){c[X>>2]=$;c[_>>2]=Y;Y=W+4|0;W=Z+4|0;Z=c[Y>>2]|0;c[Y>>2]=c[W>>2];c[W>>2]=Z;i=k;return}else if((G|0)==36){i=k;return}}function fcd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;if((f|0)>(g|0)){g=c[b>>2]|0;f=g;j=c[d>>2]|0;if((g|0)==(j|0)){k=g;l=h}else{m=((j+-8-f|0)>>>3)+1|0;n=g;o=h;while(1){if(o){p=n;q=c[p+4>>2]|0;r=o;c[r>>2]=c[p>>2];c[r+4>>2]=q}n=n+8|0;if((n|0)==(j|0))break;else o=o+8|0}k=j;l=h+(m<<3)|0}m=c[a>>2]|0;j=l;a:do if((g|0)==(m|0)){s=j;t=k}else{o=j;n=f;q=l;r=g;p=k;u=g;while(1){if((o|0)==(h|0)){v=p;w=u;break}x=c[q+-8>>2]|0;y=c[r+-8>>2]|0;z=p+-8|0;if(x>>>0<y>>>0){c[z>>2]=y;y=r+-8|0;A=o;B=y;C=r;D=q;E=y}else{c[z>>2]=x;x=q+-8|0;A=x;B=n;C=q;D=x;E=r}c[p+-4>>2]=c[C+-4>>2];x=p+-8|0;u=B;if((u|0)==(m|0)){s=A;t=x;break a}else{o=A;n=B;q=D;r=E;p=x}}if((w|0)==(m|0)){i=e;return}else{F=w;G=v}while(1){c[G+-8>>2]=c[F+-8>>2];c[G+-4>>2]=c[F+-4>>2];F=F+-8|0;if((F|0)==(m|0))break;else G=G+-8|0}i=e;return}while(0);G=s;if((G|0)==(h|0)){i=e;return}else{H=G;I=t}while(1){c[I+-8>>2]=c[H+-8>>2];c[I+-4>>2]=c[H+-4>>2];H=H+-8|0;if((H|0)==(h|0))break;else I=I+-8|0}i=e;return}else{I=c[a>>2]|0;a=c[b>>2]|0;b:do if((I|0)!=(a|0)){b=((a+-8-I|0)>>>3)+1|0;H=I;t=h;while(1){if(t){G=H;s=c[G+4>>2]|0;m=t;c[m>>2]=c[G>>2];c[m+4>>2]=s}H=H+8|0;if((H|0)==(a|0))break;else t=t+8|0}t=h+(b<<3)|0;H=c[d>>2]|0;if((t|0)==(h|0)){J=a;K=I;L=H}else{s=a;m=h;G=I;while(1){if((s|0)==(H|0)){M=G;N=m;break}F=c[s>>2]|0;v=c[m>>2]|0;if(F>>>0<v>>>0){c[G>>2]=F;O=s;P=s+8|0;Q=m}else{c[G>>2]=v;O=m;P=s;Q=m+8|0}c[G+4>>2]=c[O+4>>2];v=G+8|0;if((Q|0)==(t|0)){J=P;K=v;L=H;break b}else{s=P;m=Q;G=v}}if((N|0)==(t|0)){i=e;return}else{R=N;S=M}while(1){c[S>>2]=c[R>>2];c[S+4>>2]=c[R+4>>2];R=R+8|0;if((R|0)==(t|0))break;else S=S+8|0}i=e;return}}else{J=I;K=I;L=c[d>>2]|0}while(0);if((J|0)==(L|0)){i=e;return}else{T=J;U=K}while(1){c[U>>2]=c[T>>2];c[U+4>>2]=c[T+4>>2];T=T+8|0;if((T|0)==(L|0))break;else U=U+8|0}i=e;return}}function gcd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];mWb(a,f,d);c[a>>2]=618280;d=a+28|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=e;return}function hcd(a){a=a|0;return}function icd(a,b){a=a|0;b=b|0;return}function jcd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+40|0;if((f|0)==(d|0)){i=e;return}g=a[d>>0]|0;if(!(g&1)){h=(g&255)>>>1;j=d+1|0}else{h=c[d+4>>2]|0;j=c[d+8>>2]|0}d=a[f>>0]|0;if(!(d&1)){k=10;l=d}else{d=c[f>>2]|0;k=(d&-2)+-1|0;l=d&255}d=(l&1)==0;if(h>>>0>k>>>0){if(d)m=(l&255)>>>1;else m=c[b+44>>2]|0;eXb(f,k,h-k|0,m,0,m,h,j);i=e;return}if(d)n=f+1|0;else n=c[b+48>>2]|0;aFi(n|0,j|0,h|0)|0;a[n+h>>0]=0;if(!(a[f>>0]&1)){a[f>>0]=h<<1;i=e;return}else{c[b+44>>2]=h;i=e;return}}function kcd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=xo[c[(c[a>>2]|0)+92>>2]&2047](a,b,0)|0;i=d;return e|0}function lcd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+40|0;if((f|0)==(d|0)){i=e;return 1}g=a[d>>0]|0;if(!(g&1)){h=(g&255)>>>1;j=d+1|0}else{h=c[d+4>>2]|0;j=c[d+8>>2]|0}d=a[f>>0]|0;if(!(d&1)){k=10;l=d}else{d=c[f>>2]|0;k=(d&-2)+-1|0;l=d&255}d=(l&1)==0;if(h>>>0>k>>>0){if(d)m=(l&255)>>>1;else m=c[b+44>>2]|0;eXb(f,k,h-k|0,m,0,m,h,j);i=e;return 1}if(d)n=f+1|0;else n=c[b+48>>2]|0;aFi(n|0,j|0,h|0)|0;a[n+h>>0]=0;if(!(a[f>>0]&1)){a[f>>0]=h<<1;i=e;return 1}else{c[b+44>>2]=h;i=e;return 1}return 0}function mcd(b){b=b|0;b=i;if(a[618400]|0){i=b;return 618384};c[154596]=0;c[154597]=0;c[154598]=0;a[618400]=1;i=b;return 618384}function ncd(){var a=0;a=i;QQb(49,166,0,0,0);i=a;return}function ocd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,618408,9);wQb(49,130,b,52,2639,0,0);xri(b);i=a;return}function pcd(a){a=a|0;return 49}function qcd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,618408,a,0);wcd(a,b);bdd(b);i=c;return}function rcd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,618408,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else xcd(a,b);sdd(b);i=d;return}function scd(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);NXb(b,a+40|0,1);Ndd(b);NXb(b,a+28|0,1);Ndd(b);i=c;return}function tcd(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);OXb(b,a+40|0,1);Mdd(b);OXb(b,a+28|0,1);Mdd(b);i=c;return}function ucd(a,b){a=a|0;b=b|0;var c=0;c=i;BWb(a,b);FXb(b,a+40|0,620384,67108865);FXb(b,a+28|0,618424,1);i=c;return}function vcd(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function wcd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+4|0;xWb(a,b);g=c[142294]|0;add(b,620384,g,a+40|0,67108865);$cd(b,2646336,2646336,e,1);h=c[142260]|0;add(b,3142592,h,f,0);j=b+12|0;k=b+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,618424,g,a+28|0,1);$cd(b,2646336,2646336,e,1);add(b,3142592,h,f,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);i=d;return}function xcd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;yWb(a,b);f=a+40|0;g=c[142294]|0;h=qdd(b,620384,g,e,0)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}else zXb(b,f,1);sdd(b)}f=a+28|0;a=qdd(b,618424,g,e,0)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else zXb(b,f,1);sdd(b);i=d;return}function ycd(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);NXb(b,a+40|0,1);Ndd(b);NXb(b,a+28|0,1);Ndd(b);i=c;return}function zcd(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);OXb(b,a+40|0,1);Mdd(b);OXb(b,a+28|0,1);Mdd(b);i=c;return}function Acd(a,b){a=a|0;b=b|0;var c=0;c=i;BWb(a,b);FXb(b,a+40|0,620384,67108865);FXb(b,a+28|0,618424,1);i=c;return}function Bcd(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function Ccd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(52,e,1,16,3653512,14)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];mWb(g,e,b);c[g>>2]=618280;b=g+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return g|0}function Dcd(a){a=a|0;var b=0;b=i;Had(a);ACi(a);i=b;return}function Ecd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;do if(a){d=a+20|0;e=c[d>>2]|0;if(!e){f=(c[a+8>>2]|0)>>>21;if((f|0)!=114?(g=Irc(f)|0,(g|0)!=0):0){f=c[d>>2]|0;if(!f){Frc(g,a);Hrc(g,c[a+4>>2]|0);In[c[(c[a>>2]|0)+56>>2]&4095](a,g);h=g;break}else{h=f;break}}else h=0}else h=e}else h=0;while(0);i=b;return h|0}function Fcd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+20>>2]|0;if(!e){Frc(a,b);Hrc(a,c[b+4>>2]|0);In[c[(c[b>>2]|0)+56>>2]&4095](b,a);f=a;i=d;return f|0}else{f=e;i=d;return f|0}return 0}function Gcd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Asc(b,d,e)|0;if(!h){e=587032;d=c[e+4>>2]|0;b=a;c[b>>2]=c[e>>2];c[b+4>>2]=d;i=g;return}else{osc(a,h,f,-1);i=g;return}}function Hcd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=g+8|0;if(!d){k=587032;l=c[k+4>>2]|0;m=b;c[m>>2]=c[k>>2];c[m+4>>2]=l;i=g;return}psc(h,d,e,-1,f);if((c[h>>2]|0)==0&(f&8|0)==0?(l=isc(d)|0,(l|0)!=0):0){Hcd(j,l,e,f);c[h+0>>2]=c[j+0>>2];a[h+4>>0]=a[j+4>>0]|0}j=h;h=c[j+4>>2]|0;f=b;c[f>>2]=c[j>>2];c[f+4>>2]=h;i=g;return}function Icd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;if(!(vTb(a)|0)){k=0;i=e;return k|0}l=c[a+4>>2]|0;m=a+32|0;if((c[m>>2]|0)<=0){k=0;i=e;return k|0}n=a+24|0;if(!l){a=0;while(1){o=c[n>>2]|0;if(((c[o+(a<<3)>>2]|0)==114?(p=c[o+(a<<3)+4>>2]|0,(c[p+20>>2]|0)!=0):0)?(v9c(h,p,b),(c[h>>2]|0)!=0):0){q=p;break}a=a+1|0;if((a|0)>=(c[m>>2]|0)){k=0;r=22;break}}if((r|0)==22){i=e;return k|0}a=h;p=c[a+4>>2]|0;o=j;c[o>>2]=c[a>>2];c[o+4>>2]=p;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];B9c(q,f,d)|0;k=1;i=e;return k|0}else{s=0;t=0}a:while(1){q=c[n>>2]|0;do if(((c[q+(t<<3)>>2]|0)==114?(p=c[q+(t<<3)+4>>2]|0,(c[p+20>>2]|0)!=0):0)?(v9c(h,p,b),(c[h>>2]|0)!=0):0){o=h;a=c[o+4>>2]|0;u=j;c[u>>2]=c[o>>2];c[u+4>>2]=a;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];B9c(p,f,d)|0;c[g>>2]=l;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,g);a=c[f>>2]|0;u=c[p+28>>2]|0;if((a|0)==-1){v=u+(c[p+32>>2]<<3)|0;break}else{v=u+(a<<3)|0;break}}else v=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(c[v+4>>2]|0)!=0:0){w=1;break}}if(!(hQb(l)|0)){k=1;r=22;break a}else w=1}else w=s;while(0);t=t+1|0;if((t|0)>=(c[m>>2]|0)){k=w;r=22;break}else s=w}if((r|0)==22){i=e;return k|0}return 0}function Jcd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;if(!(a[d>>0]&1))g=d+1|0;else g=c[d+8>>2]|0;d=Icd(b,g,e)|0;i=f;return d|0}function Kcd(a,b){a=a|0;b=b|0;b=i;lQc(a,0);i=b;return}function Lcd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;if(!(oVb()|0)){Krd(618440,0,3653512,329,1,0,0,0);i=d;return}h=c[a>>2]|0;if(!h){i=d;return}c[g>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,g);j=c[e>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if(!((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0))m=12}else m=12;if((m|0)==12?(hQb(c[a>>2]|0)|0)==0:0){i=d;return}if(b<=ea(0.0)){m=Tcd(a)|0;if(m)In[c[(c[m>>2]|0)+120>>2]&4095](m,0);m=Ucd(a)|0;if(m){l=m+32|0;h=c[l>>2]|0;if(h){g=m+24|0;j=h;h=0;while(1){k=c[(c[g>>2]|0)+(h<<3)+4>>2]|0;if((k|0)!=0?(n=(da(c[137788]|0,(c[k+8>>2]|0)>>>21)|0)+8|0,o=n>>5,(1<<n-(o<<5)&c[(c[137786]|0)+(o<<2)>>2]|0)!=0):0){In[c[(c[k>>2]|0)+120>>2]&4095](k,0);p=c[l>>2]|0}else p=j;h=h+1|0;if(h>>>0>=p>>>0)break;else j=p}}p=BTb(m)|0;m=p+148|0;j=c[m>>2]|0;if((j|0)>0){h=p+140|0;p=j;j=0;while(1){l=c[(c[(c[h>>2]|0)+(j<<2)>>2]|0)+24>>2]|0;g=l+32|0;k=c[g>>2]|0;if(!k)q=p;else{o=l+24|0;l=k;k=0;while(1){n=c[(c[o>>2]|0)+(k<<3)+4>>2]|0;if((n|0)!=0?(r=(da(c[137788]|0,(c[n+8>>2]|0)>>>21)|0)+8|0,s=r>>5,(1<<r-(s<<5)&c[(c[137786]|0)+(s<<2)>>2]|0)!=0):0){In[c[(c[n>>2]|0)+120>>2]&4095](n,0);t=c[g>>2]|0}else t=l;k=k+1|0;if(k>>>0>=t>>>0)break;else l=t}q=c[m>>2]|0}j=j+1|0;if((j|0)>=(q|0))break;else p=q}}}}q=c[a>>2]|0;do if(!q)u=0;else{c[f>>2]=q;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,f);j=c[e>>2]|0;m=c[p+28>>2]|0;if((j|0)==-1){v=m+(c[p+32>>2]<<3)|0;break}else{v=m+(j<<3)|0;break}}else v=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[v+4>>2]|0,(p|0)!=0):0){u=p;break}}u=hQb(c[a>>2]|0)|0}while(0);Olc(u,b);i=d;return}function Mcd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=ssc(a)|0;if(!g){h=0;i=b;return h|0}c[e>>2]=c[153106];c[d+0>>2]=c[e+0>>2];e=bOb(136,d,1,16,3653512,422)|0;c[f>>2]=c[153106];c[d+0>>2]=c[f+0>>2];e9c(e,d,0);d=pQb(e)|0;Q9c(d,g,0);V9c(d);h=c[d+20>>2]|0;i=b;return h|0}function Ncd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+28|0;h=d+40|0;j=d+8|0;k=d+4|0;l=d+12|0;m=$9c((Xbd()|0)+24|0,b)|0;if(!m){if(!(a[b>>0]&1))n=b+1|0;else n=c[b+8>>2]|0;c[e>>2]=n;Lsd(f,618632,e);if(!(a[f>>0]&1))o=f+1|0;else o=c[f+8>>2]|0;Krd(o,0,3653512,458,1,0,0,0);xri(f);p=0;i=d;return p|0}if((had(m)|0)!=1){if(!(a[b>>0]&1))q=b+1|0;else q=c[b+8>>2]|0;c[e>>2]=q;Lsd(g,618712,e);if(!(a[g>>0]&1))r=g+1|0;else r=c[g+8>>2]|0;Krd(r,0,3653512,469,1,0,0,0);xri(g);p=0;i=d;return p|0}if(gad(m)|0){c[j>>2]=c[153106];c[e+0>>2]=c[j+0>>2];j=bOb(136,e,1,16,3653512,479)|0;c[k>>2]=c[153106];c[e+0>>2]=c[k+0>>2];e9c(j,e,0);k=pQb(j)|0;c[l>>2]=c[m+4>>2];P9c(k,l,0);V9c(k);p=c[k+20>>2]|0;i=d;return p|0}if(!(a[b>>0]&1))s=b+1|0;else s=c[b+8>>2]|0;c[e>>2]=s;Lsd(h,618808,e);if(!(a[h>>0]&1))t=h+1|0;else t=c[h+8>>2]|0;Krd(t,0,3653512,475,1,0,0,0);xri(h);p=0;i=d;return p|0}function Ocd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;if(Grc(b)|0){i=d;return}j=vsc(b)|0;k=lsc(j)|0;l=ksc(j)|0;m=(a[k>>0]|0)!=0?3672776:3653512;c[e>>2]=k;c[e+4>>2]=m;c[e+8>>2]=l;c[e+12>>2]=l;Lsd(f,618896,e);if(!(a[f>>0]&1))n=f+1|0;else n=c[f+8>>2]|0;Krd(n,0,3653512,503,512,0,0,0);xri(f);c[g>>2]=c[153106];c[e+0>>2]=c[g+0>>2];g=bOb(136,e,1,16,3653512,505)|0;c[h>>2]=c[153106];c[e+0>>2]=c[h+0>>2];e9c(g,e,0);e=pQb(g)|0;Q9c(e,j,b);V9c(e);i=d;return}function Pcd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;if(!a){f=0;i=b;return f|0}c[e>>2]=a;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0)l=g;else m=10}else m=10;if((m|0)==10)l=hQb(a)|0;f=Ecd(l)|0;i=b;return f|0}function Qcd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=a;while(1){if(!(msc(d,c[(Xbd()|0)+288>>2]|0)|0)){e=-1;f=11;break}a=ksc(d)|0;g=lsc(d)|0;if(!(HEi(a,2353128)|0)){h=(HEi(g,3516216)|0)==0;j=h?2454944:a}else j=a;a=FQb(j)|0;if(msc(d,c[(Xbd()|0)+36>>2]|0)|0)k=1;else k=msc(d,c[(Xbd()|0)+44>>2]|0)|0;h=c[137788]|0;if((a|0)>-1&(h|0)>(a|0)){g=(da(h,a)|0)+114|0;l=g>>5;m=(1<<g-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0;n=1}else{m=0;n=0}l=n&(k^m)?-1:a;if((l|0)>-1&(h|0)>(l|0)){e=l;f=11;break}d=isc(d)|0;if(!d){e=l;f=11;break}}if((f|0)==11){i=b;return e|0}return 0}function Rcd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+80|0;g=f+16|0;h=f;j=g+40|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;k=g+0|0;l=k+36|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));Fsc(b,g);b=a[e>>0]|0;k=(b&1)==0;if(k)m=(b&255)>>>1;else m=c[e+4>>2]|0;if(m){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;if(k)n=(b&255)>>>1;else n=c[e+4>>2]|0;b=a[g>>0]|0;if(!(b&1))o=(b&255)>>>1;else o=c[g+4>>2]|0;if(k)p=e+1|0;else p=c[e+8>>2]|0;Pri(h,p,n,o+n|0);if(!(a[g>>0]&1))q=g+1|0;else q=c[g+8>>2]|0;Gri(h,q,o)|0;yri(g,h)|0;xri(h)}if(!(a[g>>0]&1))r=g+1|0;else r=c[g+8>>2]|0;h=g+12|0;if(!(a[h>>0]&1))s=h+1|0;else s=c[g+20>>2]|0;h=g+24|0;if(!(a[h>>0]&1))t=h+1|0;else t=c[g+32>>2]|0;h=c[g+36>>2]|0;if(!(a[j>>0]&1)){u=j+1|0;v=g+52|0;w=c[v>>2]|0;Mrd(r,s,t,h,u,w,131332,d,0,0);Vcd(g);i=f;return}else{u=c[g+48>>2]|0;v=g+52|0;w=c[v>>2]|0;Mrd(r,s,t,h,u,w,131332,d,0,0);Vcd(g);i=f;return}}function Scd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(!a){e=0;i=d;return e|0}f=c[a>>2]|0;do if(f){g=Dsc(f)|0;if(!g){Csc(c[a>>2]|0);c[a>>2]=0;break}else{e=g;i=d;return e|0}}while(0);f=tsc(b)|0;c[a>>2]=Bsc(f)|0;c[f+8>>2]=a;e=f;i=d;return e|0}function Tcd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[a>>2]|0;do if(f){c[e>>2]=f;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0)l=g;else m=10}else m=10;if((m|0)==10){g=hQb(c[a>>2]|0)|0;if(!g)break;else l=g}g=(da(c[137788]|0,(c[l+8>>2]|0)>>>21)|0)+8|0;h=g>>5;if(1<<g-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]){n=l;i=b;return n|0}}while(0);n=0;i=b;return n|0}function Ucd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[a>>2]|0;do if(f){c[e>>2]=f;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0)l=g;else m=10}else m=10;if((m|0)==10){g=hQb(c[a>>2]|0)|0;if(!g)break;else l=g}g=(da(c[137788]|0,(c[l+8>>2]|0)>>>21)|0)+1|0;h=g>>5;if(1<<g-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]){n=l;i=b;return n|0}}while(0);n=0;i=b;return n|0}function Vcd(a){a=a|0;var b=0;b=i;xri(a+40|0);xri(a+24|0);xri(a+12|0);xri(a);i=b;return}function Wcd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;if(!((a&2|0)==0|b^1)){e=0;i=d;return e|0}if(!((a&1|0)==0|b)){e=0;i=d;return e|0}e=(c|0)<1|(a&4|0)==0;i=d;return e|0}function Xcd(a){a=a|0;return (a&7|0)!=0|0}function Ycd(a,b){a=a|0;b=b|0;var c=0;c=i;H=b;i=c;return a|0}function Zcd(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a+4>>2]=0;c[a+12>>2]=d;c[a+16>>2]=0;c[a+20>>2]=0;c[a>>2]=e;e=a+40|0;c[e+0>>2]=0;c[e+4>>2]=0;b[e+8>>1]=0;c[a+24>>2]=f;c[a+28>>2]=g;c[a+32>>2]=0;c[a+36>>2]=0;return}function _cd(a,b,d){a=a|0;b=b|0;d=d|0;c[a+32>>2]=b;c[a+36>>2]=d;return}function $cd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;add(b,d,e,0,g);g=b+12|0;e=b+20|0;a[(c[c[g>>2]>>2]|0)+((c[e>>2]|0)*24|0)+3>>0]=1;add(b,3144144,c[142270]|0,f,0);c[(c[c[g>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);i=h;return}function add(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+8|0;j=g;c[h>>2]=0;c[h+4>>2]=0;k=a+16|0;l=a+12|0;m=c[l>>2]|0;if(!(c[k>>2]|0)){n=h;c[n>>2]=m;c[n+4>>2]=0;n=c[m>>2]|0;c[n+20>>2]=f;o=n}else{iid(j,m,k);m=j;j=c[m+4>>2]|0;n=h;c[n>>2]=c[m>>2];c[n+4>>2]=j;n=c[c[l>>2]>>2]|0;c[n+(j*24|0)+20>>2]=(c[($hd(k)|0)+20>>2]|f)&-32769;o=n+(j*24|0)|0}kid(c[l>>2]|0,h,d);lid(c[l>>2]|0,h,b);c[o+12>>2]=0;if((c[($hd(h)|0)+20>>2]&4096|0)!=0?(c[a>>2]&32|0)!=0:0)p=-1;else{b=a+40|0;d=c[b>>2]|0;c[b>>2]=d+1;p=d}c[o+16>>2]=p;p=c[a+24>>2]|0;do if((p|0)!=0&(e|0)!=0){o=e;d=o-p|0;if((d|0)>-1?(d|0)<(c[a+28>>2]|0):0){mid(c[l>>2]|0,h,d);break}d=o-(c[a+32>>2]|0)|0;if((d|0)>-1?(d|0)<(c[a+36>>2]|0):0)mid(c[l>>2]|0,h,d|-2147483648)}while(0);l=h;h=c[l+4>>2]|0;a=k;c[a>>2]=c[l>>2];c[a+4>>2]=h;i=g;return}function bdd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+16|0;g=f;h=c[g+4>>2]|0;j=d;c[j>>2]=c[g>>2];c[j+4>>2]=h;eid(e,f);h=e;e=c[h>>2]|0;j=c[h+4>>2]|0;h=f;c[h>>2]=e;c[h+4>>2]=j;if(!e){i=b;return}if((c[($hd(d)|0)+12>>2]|0)!=-1?(c[($hd(f)|0)+12>>2]|0)!=-1:0){e=c[($hd(f)|0)+12>>2]|0;k=(c[($hd(d)|0)+12>>2]|0)+e|0}else k=-1;e=a+12|0;f=a+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=k;if(!(c[($hd(d)|0)+20>>2]&32768)){i=b;return}d=(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+20|0;c[d>>2]=c[d>>2]|32768;i=b;return}function cdd(a){a=a|0;var b=0;b=i;c[(c[c[a+12>>2]>>2]|0)+((c[a+20>>2]|0)*24|0)+12>>2]=-1;bdd(a);i=b;return}function ddd(a,d){a=a|0;d=d|0;b[(c[c[a+12>>2]>>2]|0)+((c[a+20>>2]|0)*24|0)>>1]=d;return}function edd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;d=i;i=i+48|0;g=d+24|0;h=d+16|0;j=d+8|0;add(b,e,619032,0,f);e=b+12|0;k=b+20|0;a[(c[c[e>>2]>>2]|0)+((c[k>>2]|0)*24|0)+3>>0]=1;add(b,3144144,c[142270]|0,d,0);c[(c[c[e>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3142592,c[142302]|0,d+32|0,f);c[(c[c[e>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);a[b+49>>0]=1;c[(c[c[e>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=-1;bdd(b);f=b+44|0;c[f>>2]=(c[f>>2]|0)+3&-4;f=b+16|0;if(!(c[f>>2]|0)){i=d;return}cid(g,f);if(!(c[g>>2]|0)){i=d;return}g=c[e>>2]|0;cid(j,f);fid(h,j);j=(c[g>>2]|0)+((c[h+4>>2]|0)*24|0)+20|0;c[j>>2]=c[j>>2]|16384;j=(c[c[e>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20|0;c[j>>2]=c[j>>2]|32768;i=d;return}function fdd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b;g=a+44|0;c[g>>2]=(c[g>>2]|0)+3&-4;g=a+16|0;if(!(c[g>>2]|0)){i=b;return}cid(d,g);if(!(c[d>>2]|0)){i=b;return}d=a+12|0;h=c[d>>2]|0;cid(f,g);fid(e,f);f=(c[h>>2]|0)+((c[e+4>>2]|0)*24|0)+20|0;c[f>>2]=c[f>>2]|16384;f=(c[c[d>>2]>>2]|0)+((c[a+20>>2]|0)*24|0)+20|0;c[f>>2]=c[f>>2]|32768;i=b;return}function gdd(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;a[b+49>>0]=0;return}function hdd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=b+16|0;c[k>>2]=0;l=b+20|0;c[l>>2]=0;m=b+24|0;c[m>>2]=0;a[b+32>>0]=e&1;c[b>>2]=d;c[b+4>>2]=0;c[b+12>>2]=0;c[h>>2]=89;c[g+0>>2]=c[h+0>>2];d=cOb(16,16,g,0,3653512,80)|0;e=c[k>>2]|0;n=(c[l>>2]|0)-e|0;o=d+(0-(n>>2)<<2)|0;YEi(o|0,e|0,n|0)|0;n=c[k>>2]|0;c[k>>2]=o;c[l>>2]=d;c[m>>2]=d+16;if(n){c[h>>2]=89;c[g+0>>2]=c[h+0>>2];eOb(n,g);g=c[l>>2]|0;n=c[m>>2]|0;c[j>>2]=0;if((g|0)==(n|0)){kdd(k,j);p=b+28|0;c[p>>2]=0;i=f;return}else q=g}else{c[j>>2]=0;q=d}if(q)c[q>>2]=0;c[l>>2]=q+4;p=b+28|0;c[p>>2]=0;i=f;return}function idd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=a+20|0;g=c[f>>2]|0;h=c[g+-4>>2]|b;c[e>>2]=h;if((g|0)==(c[a+24>>2]|0)){kdd(a+16|0,e);j=c[f>>2]|0;k=j+-4|0;l=c[k>>2]|0;m=a+28|0;c[m>>2]=l;i=d;return}if(g)c[g>>2]=h;h=g+4|0;c[f>>2]=h;j=h;k=j+-4|0;l=c[k>>2]|0;m=a+28|0;c[m>>2]=l;i=d;return}function jdd(a){a=a|0;var b=0,d=0;b=a+20|0;d=c[b>>2]|0;c[b>>2]=d+-4;c[a+28>>2]=c[d+-8>>2];return}function kdd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>2)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>2>>>0<1073741823){m=h>>1;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>2;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>2;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<2,16,e,0,3653512,80)|0;p=r}r=o+(p<<2)|0;if(r)c[r>>2]=c[b>>2];b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>2)<<2)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<2);c[k>>2]=o+(n<<2);if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function ldd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e;g=a;h=c[154748]|0;j=h+4|0;k=c[j>>2]|0;do if(k){l=k;while(1){m=l+16|0;n=c[m+4>>2]|0;o=c[m>>2]|0;m=HEi(a,o)|0;if(!m)p=HEi(b,n)|0;else p=m;if((p|0)<0){m=c[l>>2]|0;if(!m){q=l;r=l;s=6;break}else{l=m;continue}}m=HEi(o,a)|0;if(!m)t=HEi(n,b)|0;else t=m;if((t|0)>=0){u=l;s=12;break}m=l+4|0;n=c[m>>2]|0;if(!n){v=m;w=l;s=11;break}else l=n}if((s|0)==6){c[f>>2]=r;x=q;y=r;break}else if((s|0)==11){c[f>>2]=w;x=v;y=w;break}else if((s|0)==12){c[f>>2]=u;x=f;y=u;break}}else{l=h+4|0;c[f>>2]=l;x=l;y=l}while(0);f=c[x>>2]|0;if(f){z=f;A=z+24|0;c[A>>2]=d;i=e;return}f=xCi(28)|0;u=f+16|0;c[u>>2]=g;c[u+4>>2]=b;c[f+24>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=y;c[x>>2]=f;y=c[c[h>>2]>>2]|0;if(!y)B=f;else{c[h>>2]=y;B=c[x>>2]|0}GN(c[j>>2]|0,B);B=h+8|0;c[B>>2]=(c[B>>2]|0)+1;z=f;A=z+24|0;c[A>>2]=d;i=e;return}function mdd(){var a=0,b=0,d=0;a=i;b=c[154748]|0;Bdd(b,c[b+4>>2]|0);c[b+8>>2]=0;d=b+4|0;c[b>>2]=d;c[d>>2]=0;i=a;return}function ndd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=d;d=c[i+4>>2]|0;j=b+72|0;c[j>>2]=c[i>>2];c[j+4>>2]=d;c[b+64>>2]=e;c[b+8>>2]=c[h>>2];c[b+68>>2]=f;c[b>>2]=g;c[b+4>>2]=0;a[b+136>>0]=0;c[b+140>>2]=0;return b+12|0}function odd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;d=a+116|0;e=c[d>>2]|0;f=a+128|0;g=c[f>>2]|0;h=e+(((g>>>0)/341|0)<<2)|0;j=a+120|0;k=c[j>>2]|0;if((k|0)==(e|0)){l=0;m=a+132|0;n=0}else{o=a+132|0;p=(c[o>>2]|0)+g|0;l=(c[e+(((p>>>0)/341|0)<<2)>>2]|0)+(((p>>>0)%341|0)*12|0)|0;m=o;n=(c[h>>2]|0)+(((g>>>0)%341|0)*12|0)|0}g=n;n=h;a:while(1){h=g;do{if((h|0)==(l|0))break a;h=h+12|0}while((h-(c[n>>2]|0)|0)!=4092);h=n+4|0;g=c[h>>2]|0;n=h}c[m>>2]=0;m=k-e>>2;if(m>>>0>2){k=e;do{ACi(c[k>>2]|0);k=(c[d>>2]|0)+4|0;c[d>>2]=k;e=(c[j>>2]|0)-k>>2}while(e>>>0>2);q=e}else q=m;if((q|0)==1)c[f>>2]=170;else if((q|0)==2)c[f>>2]=341;f=c[d>>2]|0;q=c[j>>2]|0;if((f|0)!=(q|0)){m=f;do{ACi(c[m>>2]|0);m=m+4|0}while((m|0)!=(q|0));q=c[d>>2]|0;d=c[j>>2]|0;if((d|0)!=(q|0))c[j>>2]=d+(~((d+-4-q|0)>>>2)<<2)}q=c[a+112>>2]|0;if(!q){r=a+88|0;Cdd(r);i=b;return}ACi(q);r=a+88|0;Cdd(r);i=b;return}function pdd(a,b){a=a|0;b=b|0;var d=0;d=(c[a+108>>2]|0)+-1+(c[a+104>>2]|0)|0;c[(c[(c[a+92>>2]|0)+(d>>>7<<2)>>2]|0)+((d&127)<<5)+8>>2]=b;return}function qdd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0;h=i;i=i+144|0;j=h+120|0;k=h+112|0;l=h+64|0;m=h+96|0;n=h+32|0;o=h+104|0;p=h+128|0;q=h+40|0;r=h+48|0;s=h;t=h+56|0;u=(f|0)!=0;if(u)c[f>>2]=0;a[b+136>>0]=0;v=b+88|0;w=b+108|0;if(!(c[w>>2]|0)){x=b+72|0;y=aid(x)|0;do if(d)if(y){z=c[142254]|0;A=c[142256]|0;if(z>>>0<=y>>>0&A>>>0>y>>>0?z>>>0<=d>>>0&A>>>0>d>>>0:0)if((y|0)==(d|0))break;else{B=11;break}if(HEi(d,y)|0)B=11}else{C=0;B=6}else{C=y;B=6}while(0);if((B|0)==6?(C|0)!=(d|0):0)B=11;if((B|0)==11)Krd(619e3,0,3653512,166,1,0,0,0);c[l+24>>2]=0;c[l+28>>2]=0;C=x;x=c[C+4>>2]|0;y=l;c[y>>2]=c[C>>2];c[y+4>>2]=x;x=b+64|0;c[l+12>>2]=c[x>>2];c[l+16>>2]=1;c[l+8>>2]=e;cid(m,l);y=m;m=c[y+4>>2]|0;C=l+24|0;c[C>>2]=c[y>>2];c[C+4>>2]=m;c[l+20>>2]=c[x>>2];x=b+96|0;m=c[x>>2]|0;C=b+92|0;y=c[C>>2]|0;if((m|0)==(y|0))D=0;else D=(m-y<<5)+-1|0;A=b+104|0;z=c[A>>2]|0;E=c[w>>2]|0;if((D-z|0)==(E|0)){Edd(v);F=c[w>>2]|0;G=c[A>>2]|0;H=c[x>>2]|0;I=c[C>>2]|0}else{F=E;G=z;H=m;I=y}y=F+G|0;if((H|0)!=(I|0)){m=(c[I+(y>>>7<<2)>>2]|0)+((y&127)<<5)|0;if(!m){J=F;K=G;L=I}else{c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[m+16>>2]=c[l+16>>2];c[m+20>>2]=c[l+20>>2];c[m+24>>2]=c[l+24>>2];c[m+28>>2]=c[l+28>>2];J=c[w>>2]|0;K=c[A>>2]|0;L=c[C>>2]|0}}else{J=F;K=G;L=H}c[w>>2]=J+1;H=K+J|0;c[b+80>>2]=(c[L+(H>>>7<<2)>>2]|0)+((H&127)<<5);M=1;i=h;return M|0}c[n>>2]=0;H=n+4|0;c[H>>2]=0;L=b+80|0;J=c[L>>2]|0;cid(o,J);K=J+20|0;c[p>>2]=c[K>>2];G=J+24|0;F=G;C=c[F>>2]|0;A=c[F+4>>2]|0;F=n;c[F>>2]=C;c[F+4>>2]=A;a:do if(C){A=(d|0)==0;F=b+12|0;l=c[142254]|0;m=c[142256]|0;b:while(1){I=aid(n)|0;do if(!A)if(I)if(m>>>0<=I>>>0|l>>>0>I>>>0|(m>>>0<=d>>>0|l>>>0>d>>>0))if(!(HEi(d,I)|0))break b;else break;else if((I|0)==(d|0))break b;else break;else{N=0;B=24}else{N=I;B=24}while(0);if((B|0)==24?(B=0,(N|0)==(d|0)):0)break;Ddd(n,F,p,(c[b>>2]&512|0)!=0);did(q,n);I=q;y=c[I>>2]|0;z=c[I+4>>2]|0;I=n;c[I>>2]=y;c[I+4>>2]=z;if(!y){B=30;break a}}if(c[n>>2]|0){O=l;P=m}else B=30}else B=30;while(0);if((B|0)==30){q=Zdd()|0;N=J+8|0;C=Wdd(q,c[N>>2]|0,d)|0;q=Wdd(c[b+140>>2]|0,c[N>>2]|0,d)|0;c[p>>2]=c[J+12>>2];N=o;F=c[N>>2]|0;A=c[N+4>>2]|0;N=n;c[N>>2]=F;c[N+4>>2]=A;if(!F){M=0;i=h;return M|0}F=(q|0)==0;A=(C|0)==0;N=b+12|0;y=C+4|0;C=q+4|0;q=c[142254]|0;z=c[142256]|0;c:do if(!d){while(1){if(!(aid(n)|0))break c;I=aid(n)|0;if(!F?(E=c[C>>2]|0,(E|0)!=0):0){x=E;do{E=c[x+16>>2]|0;if((HEi(I,E)|0)<0)Q=x;else{if((HEi(E,I)|0)>=0)break c;Q=x+4|0}x=c[Q>>2]|0}while((x|0)!=0)}x=aid(n)|0;if(!A?(I=c[y>>2]|0,(I|0)!=0):0){E=I;do{I=c[E+16>>2]|0;if((HEi(x,I)|0)<0)R=E;else{if((HEi(I,x)|0)>=0)break c;R=E+4|0}E=c[R>>2]|0}while((E|0)!=0)}Ddd(n,N,p,(c[b>>2]&512|0)!=0);did(r,n);E=r;x=c[E>>2]|0;I=c[E+4>>2]|0;E=n;c[E>>2]=x;c[E+4>>2]=I;if(!x){M=0;break}}i=h;return M|0}else{while(1){m=aid(n)|0;do if(m)if(z>>>0<=m>>>0|q>>>0>m>>>0|(z>>>0<=d>>>0|q>>>0>d>>>0))if(!(HEi(d,m)|0))break c;else break;else if((m|0)==(d|0))break c;else break;while(0);m=aid(n)|0;if(!F?(l=c[C>>2]|0,(l|0)!=0):0){x=l;do{l=c[x+16>>2]|0;if((HEi(m,l)|0)<0)S=x;else{if((HEi(l,m)|0)>=0)break c;S=x+4|0}x=c[S>>2]|0}while((x|0)!=0)}x=aid(n)|0;if(!A?(m=c[y>>2]|0,(m|0)!=0):0){l=m;do{m=c[l+16>>2]|0;if((HEi(x,m)|0)<0)T=l;else{if((HEi(m,x)|0)>=0)break c;T=l+4|0}l=c[T>>2]|0}while((l|0)!=0)}Ddd(n,N,p,(c[b>>2]&512|0)!=0);did(r,n);l=r;x=c[l>>2]|0;m=c[l+4>>2]|0;l=n;c[l>>2]=x;c[l+4>>2]=m;if(!x){M=0;break}}i=h;return M|0}while(0);if(!(c[n>>2]|0)){M=0;i=h;return M|0}else{O=q;P=z}}z=n;q=c[z+4>>2]|0;r=G;c[r>>2]=c[z>>2];c[r+4>>2]=q;c[K>>2]=c[p>>2];do if(a[($hd(J)|0)+3>>0]|0){if((c[n>>2]|0)==(c[o>>2]|0)?(c[H>>2]|0)==(c[o+4>>2]|0):0)break;K=b+84|0;q=c[c[K>>2]>>2]|0;if((c[($hd(n)|0)+12>>2]|0)!=-1?(c[($hd(n)|0)+20>>2]&49152|0)==0:0){r=da(c[($hd(n)|0)+12>>2]|0,q)|0;c[p>>2]=(c[p>>2]|0)+r}else{r=(c[b+132>>2]|0)+-1+(c[b+128>>2]|0)|0;z=c[(c[b+116>>2]|0)+(((r>>>0)/341|0)<<2)>>2]|0;G=(r>>>0)%341|0;r=z+(G*12|0)+8|0;if((c[r>>2]|0)>(q|0))U=0;else{c[p>>2]=c[z+(G*12|0)+4>>2];U=c[r>>2]|0}if((U|0)<(q|0)){N=b+12|0;T=U;do{Ddd(n,N,p,(c[b>>2]&512|0)!=0);T=T+1|0}while((T|0)!=(q|0))}c[r>>2]=q;c[z+(G*12|0)+4>>2]=c[p>>2]}T=c[K>>2]|0;c[T>>2]=(c[T>>2]|0)+1}while(0);c[s+24>>2]=0;c[s+28>>2]=0;U=n;o=c[U+4>>2]|0;H=s;c[H>>2]=c[U>>2];c[H+4>>2]=o;c[s+12>>2]=c[p>>2];c[s+16>>2]=1;cid(t,s);o=t;t=c[o+4>>2]|0;H=s+24|0;c[H>>2]=c[o>>2];c[H+4>>2]=t;c[s+20>>2]=c[p>>2];c[s+8>>2]=e;p=b+96|0;t=c[p>>2]|0;H=b+92|0;o=c[H>>2]|0;if((t|0)==(o|0))V=0;else V=(t-o<<5)+-1|0;U=b+104|0;b=c[U>>2]|0;J=c[w>>2]|0;if((V-b|0)==(J|0)){Edd(v);W=c[w>>2]|0;X=c[U>>2]|0;Y=c[p>>2]|0;Z=c[H>>2]|0}else{W=J;X=b;Y=t;Z=o}o=W+X|0;if((Y|0)!=(Z|0)){t=(c[Z+(o>>>7<<2)>>2]|0)+((o&127)<<5)|0;if(!t){_=W;$=X;aa=Z}else{c[t+0>>2]=c[s+0>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];c[t+12>>2]=c[s+12>>2];c[t+16>>2]=c[s+16>>2];c[t+20>>2]=c[s+20>>2];c[t+24>>2]=c[s+24>>2];c[t+28>>2]=c[s+28>>2];_=c[w>>2]|0;$=c[U>>2]|0;aa=c[H>>2]|0}}else{_=W;$=X;aa=Y}c[w>>2]=_+1;Y=$+_|0;c[L>>2]=(c[aa+(Y>>>7<<2)>>2]|0)+((Y&127)<<5);Y=bid(n)|0;do if(e)if(!Y){ba=0;B=90}else{if(O>>>0<=Y>>>0&P>>>0>Y>>>0?O>>>0<=e>>>0&P>>>0>e>>>0:0){ca=(Y|0)==(e|0);break}ca=(HEi(e,Y)|0)==0}else{ba=Y;B=90}while(0);if((B|0)==90)ca=(ba|0)==(e|0);if(!(ca|g)?(c[w>>2]|0)!=1:0){if(!u){M=-1;i=h;return M|0}c[j>>2]=bid(n)|0;c[j+4>>2]=e;Add(k,c[154748]|0,j);j=c[k>>2]|0;if((j|0)==((c[154748]|0)+4|0))ea=0;else ea=c[j+24>>2]|0;c[f>>2]=ea;M=-1;i=h;return M|0}if((c[($hd(n)|0)+12>>2]|0)==-1){M=1;i=h;return M|0}else{M=(c[($hd(n)|0)+20>>2]&49152|0)==0;i=h;return (M?2:1)|0}return 0}function rdd(a,b){a=a|0;b=b|0;c[(c[a+80>>2]|0)+16>>2]=b;return}function sdd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=b+108|0;f=c[e>>2]|0;g=b+104|0;h=f+-1|0;c[e>>2]=h;j=b+96|0;k=c[j>>2]|0;l=b+92|0;m=c[l>>2]|0;if((k|0)==(m|0))n=0;else n=(k-m<<5)+-1|0;if((1-f+n-(c[g>>2]|0)|0)>>>0>255){ACi(c[k+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;o=c[e>>2]|0}else o=h;if(!o){p=0;q=b+80|0;c[q>>2]=p;r=b+136|0;a[r>>0]=1;i=d;return}h=o+-1+(c[g>>2]|0)|0;p=(c[(c[l>>2]|0)+(h>>>7<<2)>>2]|0)+((h&127)<<5)|0;q=b+80|0;c[q>>2]=p;r=b+136|0;a[r>>0]=1;i=d;return}function tdd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;if(!(qdd(a,b,d,0,0)|0)){g=0;i=f;return g|0}Fdd(a,e,3144144,c[142270]|0,0);e=a+120|0;d=c[e>>2]|0;b=a+116|0;h=c[b>>2]|0;j=d-h>>2;if(!j)k=0;else k=(j*341|0)+-1|0;j=a+128|0;l=c[j>>2]|0;m=a+132|0;n=c[m>>2]|0;if((k-l|0)==(n|0)){Gdd(a+112|0);o=c[m>>2]|0;p=c[j>>2]|0;q=c[e>>2]|0;r=c[b>>2]|0}else{o=n;p=l;q=d;r=h}h=o+p|0;if((q|0)!=(r|0)){d=c[r+(((h>>>0)/341|0)<<2)>>2]|0;l=(h>>>0)%341|0;h=d+(l*12|0)|0;if(!h){s=o;t=p;u=r}else{c[h>>2]=0;c[d+(l*12|0)+4>>2]=-1;c[d+(l*12|0)+8>>2]=2147483647;s=c[m>>2]|0;t=c[j>>2]|0;u=c[b>>2]|0}}else{s=o;t=p;u=q}c[m>>2]=s+1;m=t+s|0;c[a+84>>2]=(c[u+(((m>>>0)/341|0)<<2)>>2]|0)+(((m>>>0)%341|0)*12|0);g=1;i=f;return g|0}function udd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=b+132|0;f=c[e>>2]|0;g=b+128|0;h=f+-1|0;c[e>>2]=h;j=b+120|0;k=c[j>>2]|0;l=b+116|0;m=k-(c[l>>2]|0)>>2;if(!m)n=0;else n=(m*341|0)+-1|0;if((1-f+n-(c[g>>2]|0)|0)>>>0>681){ACi(c[k+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;o=c[e>>2]|0}else o=h;if(!o)p=0;else{h=o+-1+(c[g>>2]|0)|0;p=(c[(c[l>>2]|0)+(((h>>>0)/341|0)<<2)>>2]|0)+(((h>>>0)%341|0)*12|0)|0}c[b+84>>2]=p;p=b+108|0;h=c[p>>2]|0;l=b+104|0;g=h+-1|0;c[p>>2]=g;o=b+96|0;e=c[o>>2]|0;j=b+92|0;k=c[j>>2]|0;if((e|0)==(k|0))q=0;else q=(e-k<<5)+-1|0;if((1-h+q-(c[l>>2]|0)|0)>>>0>255){ACi(c[e+-4>>2]|0);c[o>>2]=(c[o>>2]|0)+-4;r=c[p>>2]|0}else r=g;if(!r){s=0;t=b+80|0;c[t>>2]=s;u=b+136|0;a[u>>0]=1;i=d;return}g=r+-1+(c[l>>2]|0)|0;s=(c[(c[j>>2]|0)+(g>>>7<<2)>>2]|0)+((g&127)<<5)|0;t=b+80|0;c[t>>2]=s;u=b+136|0;a[u>>0]=1;i=d;return}function vdd(a){a=a|0;var d=0,e=0,f=0;d=i;e=c[a+80>>2]|0;a=c[e+16>>2]|0;f=(a|0)==(b[($hd(e)|0)>>1]|0);i=d;return f|0}function wdd(a,d){a=a|0;d=d|0;var e=0,f=0;e=i;f=(b[($hd(c[a+80>>2]|0)|0)>>1]|0)==(d|0);i=e;return f|0}function xdd(a,d){a=a|0;d=d|0;var e=0,f=0;e=i;f=(b[($hd(c[a+80>>2]|0)|0)>>1]|0)<=(d|0);i=e;return f|0}function ydd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;if(tdd(a,d,619032,f)|0){c[b>>2]=c[f>>2];udd(a);i=e;return}else{c[b>>2]=0;i=e;return}}function zdd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;if((c|0)==0|(b|0)==0){i=d;return}Aid(a+12|0,c,b);i=d;return}function Add(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[b+4>>2]|0;g=b+4|0;if(f){b=d;d=c[b>>2]|0;h=c[b+4>>2]|0;b=g;j=f;a:while(1){f=j;while(1){k=f+16|0;l=c[k+4>>2]|0;m=HEi(c[k>>2]|0,d)|0;if(!m)n=HEi(l,h)|0;else n=m;if((n|0)>=0){o=f;break}f=c[f+4>>2]|0;if(!f){p=b;break a}}j=c[o>>2]|0;if(!j){p=o;break}else b=o}if((p|0)!=(g|0)){o=p+16|0;b=c[o+4>>2]|0;j=HEi(d,c[o>>2]|0)|0;if(!j)q=HEi(h,b)|0;else q=j;if((q|0)>=0){c[a>>2]=p;i=e;return}}}c[a>>2]=g;i=e;return}function Bdd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Bdd(a,c[b>>2]|0);Bdd(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Cdd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+16|0;g=c[f>>2]|0;h=e+(g>>>7<<2)|0;j=a+8|0;k=c[j>>2]|0;if((k|0)==(e|0)){l=0;m=a+20|0;n=0}else{o=a+20|0;p=(c[o>>2]|0)+g|0;l=(c[e+(p>>>7<<2)>>2]|0)+((p&127)<<5)|0;m=o;n=(c[h>>2]|0)+((g&127)<<5)|0}g=n;n=h;a:while(1){h=g;do{if((h|0)==(l|0))break a;h=h+32|0}while((h-(c[n>>2]|0)|0)!=4096);h=n+4|0;g=c[h>>2]|0;n=h}c[m>>2]=0;m=k-e>>2;if(m>>>0>2){k=e;do{ACi(c[k>>2]|0);k=(c[d>>2]|0)+4|0;c[d>>2]=k;e=(c[j>>2]|0)-k>>2}while(e>>>0>2);q=e}else q=m;if((q|0)==2)c[f>>2]=128;else if((q|0)==1)c[f>>2]=64;f=c[d>>2]|0;q=c[j>>2]|0;if((f|0)!=(q|0)){m=f;do{ACi(c[m>>2]|0);m=m+4|0}while((m|0)!=(q|0));q=c[d>>2]|0;d=c[j>>2]|0;if((d|0)!=(q|0))c[j>>2]=d+(~((d+-4-q|0)>>>2)<<2)}q=c[a>>2]|0;if(!q){i=b;return}ACi(q);i=b;return}function Ddd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+24|0;k=g+16|0;l=g+8|0;m=g;if((c[($hd(b)|0)+12>>2]|0)!=-1?(c[($hd(b)|0)+20>>2]&32768|0)==0:0){n=c[($hd(b)|0)+12>>2]|0;c[e>>2]=(c[e>>2]|0)+n}else o=4;a:do if((o|0)==4){if(!(a[($hd(b)|0)+3>>0]|0)){cid(l,b);if(!(c[l>>2]|0))break;while(1){Ddd(l,d,e,f);did(m,l);n=m;p=c[n>>2]|0;q=c[n+4>>2]|0;n=l;c[n>>2]=p;c[n+4>>2]=q;if(!p)break a}}p=c[d+4>>2]|0;q=(c[e>>2]|0)-(da(c[d+20>>2]|0,c[d+16>>2]|0)|0)|0;n=p+q|0;c[d>>2]=n;if((q|0)>=0?(r=p+(q+4)|0,r>>>0<=(c[d+8>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[d>>2]=r}else Bid(d,h,4);if(f)c[h>>2]=XEi(c[h>>2]|0)|0;c[e>>2]=(c[e>>2]|0)+4;cid(k,b);did(j,k);if((c[($hd(j)|0)+12>>2]|0)!=-1?(c[($hd(j)|0)+20>>2]&49152|0)==0:0){r=c[h>>2]|0;n=da(c[($hd(j)|0)+12>>2]|0,r)|0;c[e>>2]=(c[e>>2]|0)+n;break}if((c[h>>2]|0)>0){n=0;do{Ddd(j,d,e,f);n=n+1|0}while((n|0)<(c[h>>2]|0))}}while(0);if(!(c[($hd(b)|0)+20>>2]&16384)){i=g;return}c[e>>2]=(c[e>>2]|0)+3&-4;i=g;return}function Edd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;i=i+16|0;d=b;e=a+16|0;f=c[e>>2]|0;if(f>>>0>127){c[e>>2]=f+-128;f=a+4|0;e=c[f>>2]|0;g=c[e>>2]|0;h=e+4|0;c[f>>2]=h;j=a+8|0;k=c[j>>2]|0;l=a+12|0;do if((k|0)==(c[l>>2]|0)){m=c[a>>2]|0;if(h>>>0>m>>>0){n=h;o=((n-m>>2)+1|0)/-2|0;p=k-n|0;aFi(e+(o+1<<2)|0,h|0,p|0)|0;n=e+((p>>2)+1+o<<2)|0;c[j>>2]=n;c[f>>2]=(c[f>>2]|0)+(o<<2);q=n;r=13;break}n=k-m>>1;o=(n|0)==0?1:n;n=xCi(o<<2)|0;p=n+(o>>>2<<2)|0;s=n+(o<<2)|0;if((h|0)==(k|0)){t=p;u=m}else{m=p;o=h;v=e;while(1){if(!m)w=0;else{c[m>>2]=c[o>>2];w=m}x=w+4|0;y=v+8|0;if((y|0)==(k|0)){z=x;break}else{A=o;m=x;o=y;v=A}}t=z;u=c[a>>2]|0}c[a>>2]=n;c[f>>2]=p;c[j>>2]=t;c[l>>2]=s;if(!u){B=t;r=12}else{ACi(u);B=c[j>>2]|0;r=12}}else{B=k;r=12}while(0);if((r|0)==12)if(!B)C=0;else{q=B;r=13}if((r|0)==13){c[q>>2]=g;C=c[j>>2]|0}c[j>>2]=C+4;i=b;return}C=a+8|0;j=c[C>>2]|0;g=a+4|0;q=j-(c[g>>2]|0)|0;B=q>>2;k=a+12|0;u=c[k>>2]|0;t=u-(c[a>>2]|0)|0;if(B>>>0<t>>2>>>0){l=xCi(4096)|0;if((u|0)!=(j|0)){if(!j)D=0;else{c[j>>2]=l;D=c[C>>2]|0}c[C>>2]=D+4;i=b;return}c[d>>2]=l;Jdd(a,d);d=c[g>>2]|0;l=c[d>>2]|0;D=d+4|0;c[g>>2]=D;j=c[C>>2]|0;do if((j|0)==(c[k>>2]|0)){u=c[a>>2]|0;if(D>>>0>u>>>0){f=D;z=((f-u>>2)+1|0)/-2|0;w=j-f|0;aFi(d+(z+1<<2)|0,D|0,w|0)|0;f=d+((w>>2)+1+z<<2)|0;c[C>>2]=f;c[g>>2]=(c[g>>2]|0)+(z<<2);E=f;r=31;break}f=j-u>>1;z=(f|0)==0?1:f;f=xCi(z<<2)|0;w=f+(z>>>2<<2)|0;e=f+(z<<2)|0;if((D|0)==(j|0)){F=w;G=u}else{u=w;z=D;h=d;while(1){if(!u)H=0;else{c[u>>2]=c[z>>2];H=u}v=H+4|0;o=h+8|0;if((o|0)==(j|0)){I=v;break}else{m=z;u=v;z=o;h=m}}F=I;G=c[a>>2]|0}c[a>>2]=f;c[g>>2]=w;c[C>>2]=F;c[k>>2]=e;if(!G){J=F;r=30}else{ACi(G);J=c[C>>2]|0;r=30}}else{J=j;r=30}while(0);if((r|0)==30)if(!J)K=0;else{E=J;r=31}if((r|0)==31){c[E>>2]=l;K=c[C>>2]|0}c[C>>2]=K+4;i=b;return}K=t>>1;t=(K|0)==0?1:K;K=xCi(t<<2)|0;l=K+(t<<2)|0;E=xCi(4096)|0;r=K+(B<<2)|0;do if((B|0)==(t|0))if((q|0)>0){L=K+(((B+1|0)/-2|0)+B<<2)|0;M=l;N=K;break}else{J=q>>1;j=(J|0)==0?1:J;J=xCi(j<<2)|0;ACi(K);L=J+(j>>>2<<2)|0;M=J+(j<<2)|0;N=J;break}else{L=r;M=l;N=K}while(0);if(!L)O=0;else{c[L>>2]=E;O=L}E=O+4|0;O=c[C>>2]|0;if((O|0)==(c[g>>2]|0)){P=M;Q=E;R=L;S=N}else{K=L;L=N;N=E;E=M;M=O;while(1){M=M+-4|0;do if((K|0)==(L|0)){O=E;if(N>>>0<E>>>0){l=N;r=((O-l>>2)+1|0)/2|0;q=l-L|0;l=N+(r-(q>>2)<<2)|0;aFi(l|0,L|0,q|0)|0;T=l;U=E;V=N+(r<<2)|0;W=L;break}r=O-L>>1;O=(r|0)==0?1:r;r=xCi(O<<2)|0;l=r+((O+3|0)>>>2<<2)|0;q=r+(O<<2)|0;if((L|0)==(N|0))X=l;else{O=l;B=L;while(1){if(!O)Y=0;else{c[O>>2]=c[B>>2];Y=O}t=Y+4|0;B=B+4|0;if((B|0)==(N|0)){X=t;break}else O=t}}if(!L){T=l;U=q;V=X;W=r}else{ACi(L);T=l;U=q;V=X;W=r}}else{T=K;U=E;V=N;W=L}while(0);e=T+-4|0;c[e>>2]=c[M>>2];if((M|0)==(c[g>>2]|0)){P=U;Q=V;R=e;S=W;break}else{K=e;L=W;N=V;E=U}}}U=c[a>>2]|0;c[a>>2]=S;c[g>>2]=R;c[C>>2]=Q;c[k>>2]=P;if(!U){i=b;return}ACi(U);i=b;return}function Fdd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=qdd(b,e,f,h,0)|0;if(!j){i=g;return}if((j|0)>0){j=b+12|0;f=c[b+16>>2]|0;e=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=f+e|0;c[j>>2]=k;if((e|0)>=0?(l=f+(e+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[d>>2]=c[k>>2];c[j>>2]=l}else Bid(j,d,4);if(c[b>>2]&512)c[d>>2]=XEi(c[d>>2]|0)|0}else{j=c[h>>2]|0;if(j)_n[j&4095](d,b)|0}d=b+108|0;j=c[d>>2]|0;h=b+104|0;l=j+-1|0;c[d>>2]=l;k=b+96|0;e=c[k>>2]|0;f=b+92|0;m=c[f>>2]|0;if((e|0)==(m|0))n=0;else n=(e-m<<5)+-1|0;if((1-j+n-(c[h>>2]|0)|0)>>>0>255){ACi(c[e+-4>>2]|0);c[k>>2]=(c[k>>2]|0)+-4;o=c[d>>2]|0}else o=l;if(!o)p=0;else{l=o+-1+(c[h>>2]|0)|0;p=(c[(c[f>>2]|0)+(l>>>7<<2)>>2]|0)+((l&127)<<5)|0}c[b+80>>2]=p;a[b+136>>0]=1;i=g;return}function Gdd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;i=i+16|0;d=b;e=a+16|0;f=c[e>>2]|0;if(f>>>0>340){c[e>>2]=f+-341;f=a+4|0;e=c[f>>2]|0;g=c[e>>2]|0;h=e+4|0;c[f>>2]=h;j=a+8|0;k=c[j>>2]|0;l=a+12|0;do if((k|0)==(c[l>>2]|0)){m=c[a>>2]|0;if(h>>>0>m>>>0){n=h;o=((n-m>>2)+1|0)/-2|0;p=k-n|0;aFi(e+(o+1<<2)|0,h|0,p|0)|0;n=e+((p>>2)+1+o<<2)|0;c[j>>2]=n;c[f>>2]=(c[f>>2]|0)+(o<<2);q=n;r=13;break}n=k-m>>1;o=(n|0)==0?1:n;n=xCi(o<<2)|0;p=n+(o>>>2<<2)|0;s=n+(o<<2)|0;if((h|0)==(k|0)){t=p;u=m}else{m=p;o=h;v=e;while(1){if(!m)w=0;else{c[m>>2]=c[o>>2];w=m}x=w+4|0;y=v+8|0;if((y|0)==(k|0)){z=x;break}else{A=o;m=x;o=y;v=A}}t=z;u=c[a>>2]|0}c[a>>2]=n;c[f>>2]=p;c[j>>2]=t;c[l>>2]=s;if(!u){B=t;r=12}else{ACi(u);B=c[j>>2]|0;r=12}}else{B=k;r=12}while(0);if((r|0)==12)if(!B)C=0;else{q=B;r=13}if((r|0)==13){c[q>>2]=g;C=c[j>>2]|0}c[j>>2]=C+4;i=b;return}C=a+8|0;j=c[C>>2]|0;g=a+4|0;q=j-(c[g>>2]|0)|0;B=q>>2;k=a+12|0;u=c[k>>2]|0;t=u-(c[a>>2]|0)|0;if(B>>>0<t>>2>>>0){l=xCi(4092)|0;if((u|0)!=(j|0)){if(!j)D=0;else{c[j>>2]=l;D=c[C>>2]|0}c[C>>2]=D+4;i=b;return}c[d>>2]=l;Kdd(a,d);d=c[g>>2]|0;l=c[d>>2]|0;D=d+4|0;c[g>>2]=D;j=c[C>>2]|0;do if((j|0)==(c[k>>2]|0)){u=c[a>>2]|0;if(D>>>0>u>>>0){f=D;z=((f-u>>2)+1|0)/-2|0;w=j-f|0;aFi(d+(z+1<<2)|0,D|0,w|0)|0;f=d+((w>>2)+1+z<<2)|0;c[C>>2]=f;c[g>>2]=(c[g>>2]|0)+(z<<2);E=f;r=31;break}f=j-u>>1;z=(f|0)==0?1:f;f=xCi(z<<2)|0;w=f+(z>>>2<<2)|0;e=f+(z<<2)|0;if((D|0)==(j|0)){F=w;G=u}else{u=w;z=D;h=d;while(1){if(!u)H=0;else{c[u>>2]=c[z>>2];H=u}v=H+4|0;o=h+8|0;if((o|0)==(j|0)){I=v;break}else{m=z;u=v;z=o;h=m}}F=I;G=c[a>>2]|0}c[a>>2]=f;c[g>>2]=w;c[C>>2]=F;c[k>>2]=e;if(!G){J=F;r=30}else{ACi(G);J=c[C>>2]|0;r=30}}else{J=j;r=30}while(0);if((r|0)==30)if(!J)K=0;else{E=J;r=31}if((r|0)==31){c[E>>2]=l;K=c[C>>2]|0}c[C>>2]=K+4;i=b;return}K=t>>1;t=(K|0)==0?1:K;K=xCi(t<<2)|0;l=K+(t<<2)|0;E=xCi(4092)|0;r=K+(B<<2)|0;do if((B|0)==(t|0))if((q|0)>0){L=K+(((B+1|0)/-2|0)+B<<2)|0;M=l;N=K;break}else{J=q>>1;j=(J|0)==0?1:J;J=xCi(j<<2)|0;ACi(K);L=J+(j>>>2<<2)|0;M=J+(j<<2)|0;N=J;break}else{L=r;M=l;N=K}while(0);if(!L)O=0;else{c[L>>2]=E;O=L}E=O+4|0;O=c[C>>2]|0;if((O|0)==(c[g>>2]|0)){P=M;Q=E;R=L;S=N}else{K=L;L=N;N=E;E=M;M=O;while(1){M=M+-4|0;do if((K|0)==(L|0)){O=E;if(N>>>0<E>>>0){l=N;r=((O-l>>2)+1|0)/2|0;q=l-L|0;l=N+(r-(q>>2)<<2)|0;aFi(l|0,L|0,q|0)|0;T=l;U=E;V=N+(r<<2)|0;W=L;break}r=O-L>>1;O=(r|0)==0?1:r;r=xCi(O<<2)|0;l=r+((O+3|0)>>>2<<2)|0;q=r+(O<<2)|0;if((L|0)==(N|0))X=l;else{O=l;B=L;while(1){if(!O)Y=0;else{c[O>>2]=c[B>>2];Y=O}t=Y+4|0;B=B+4|0;if((B|0)==(N|0)){X=t;break}else O=t}}if(!L){T=l;U=q;V=X;W=r}else{ACi(L);T=l;U=q;V=X;W=r}}else{T=K;U=E;V=N;W=L}while(0);e=T+-4|0;c[e>>2]=c[M>>2];if((M|0)==(c[g>>2]|0)){P=U;Q=V;R=e;S=W;break}else{K=e;L=W;N=V;E=U}}}U=c[a>>2]|0;c[a>>2]=S;c[g>>2]=R;c[C>>2]=Q;c[k>>2]=P;if(!U){i=b;return}ACi(U);i=b;return}function Hdd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153100];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,21)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[154748]=d;i=a;return}function Idd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[154748]|0;f=c[153100]|0;if(e)Bdd(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[154748]=0;i=a;return}function Jdd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function Kdd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function Ldd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Aid(a+12|0,b,c);i=d;return}function Mdd(a){a=a|0;var b=0;b=i;Did(a+12|0);i=b;return}function Ndd(a){a=a|0;var b=0;b=i;Did(a+12|0);i=b;return}function Odd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=i;if(!b){i=d;return}e=a+12|0;if(!c)Cid(e,b);else Aid(e,c,b);Did(e);i=d;return}function Pdd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=i;if(!b){i=d;return}e=a+12|0;if(!c)Cid(e,b);else Aid(e,c,b);Did(e);i=d;return}function Qdd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+16|0;d=e;f=a+12|0;g=c[f>>2]|0;h=g+4|0;if(h>>>0>(c[a+20>>2]|0)>>>0){Bid(f,d,4);j=c[d>>2]|0}else{a=c[g>>2]|0;c[d>>2]=a;c[f>>2]=h;j=a}c[b>>2]=XEi(j|0)|0;i=e;return}function Rdd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+16|0;d=e;f=a+12|0;g=c[f>>2]|0;h=g+4|0;if(h>>>0>(c[a+20>>2]|0)>>>0){Bid(f,d,4);j=c[d>>2]|0;c[b>>2]=j;i=e;return}else{a=c[g>>2]|0;c[d>>2]=a;c[f>>2]=h;j=a;c[b>>2]=j;i=e;return}}function Sdd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a>>2]=b;c[a+4>>2]=0;b=d;d=c[b+4>>2]|0;e=a+32|0;c[e>>2]=c[b>>2];c[e+4>>2]=d;return a+12|0}function Tdd(a){a=a|0;var b=0;b=i;Eid(a+12|0);i=b;return}function Udd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+16|0;d=e;f=c[b>>2]|0;c[d>>2]=f;b=a+12|0;g=c[b>>2]|0;h=g+4|0;if(h>>>0<(c[a+20>>2]|0)>>>0){c[g>>2]=f;c[b>>2]=h;i=e;return}else{Gid(b,d,4);i=e;return}}function Vdd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=i;e=a+12|0;Fid(e,c,b);Eid(e);i=d;return}function Wdd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;if(!a){i=e;return 0}else{c[g>>2]=b;c[g+4>>2]=d;_dd(f,a,g);g=c[f>>2]|0;i=e;return ((g|0)==(a+4|0)?0:g+24|0)|0}return 0}function Xdd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+32|0;h=g+16|0;j=g+8|0;k=g+4|0;l=g;m=b+12|0;if(!(a[m>>0]|0))n=e;else{o=SEi(e|0)|0;c[j>>2]=c[153100];c[h+0>>2]=c[j+0>>2];j=cOb(o+1|0,16,h,0,3653512,37)|0;UEi(j|0,e|0,o|0)|0;a[j+o>>0]=0;n=j}j=d;o=b+4|0;e=c[o>>2]|0;do if(e){p=e;while(1){q=p+16|0;r=c[q+4>>2]|0;s=c[q>>2]|0;q=HEi(d,s)|0;if(!q)t=HEi(f,r)|0;else t=q;if((t|0)<0){q=c[p>>2]|0;if(!q){u=p;v=p;w=8;break}else{p=q;continue}}q=HEi(s,d)|0;if(!q)x=HEi(r,f)|0;else x=q;if((x|0)>=0){y=p;w=14;break}q=p+4|0;r=c[q>>2]|0;if(!r){z=q;A=p;w=13;break}else p=r}if((w|0)==8){c[h>>2]=v;B=u;C=v;break}else if((w|0)==13){c[h>>2]=A;B=z;C=A;break}else if((w|0)==14){c[h>>2]=y;B=h;C=y;break}}else{p=b+4|0;c[h>>2]=p;B=p;C=p}while(0);y=c[B>>2]|0;if(!y){w=xCi(36)|0;A=w+16|0;c[A>>2]=j;c[A+4>>2]=f;f=w+28|0;c[f>>2]=0;c[w+32>>2]=0;c[w+24>>2]=f;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=C;c[B>>2]=w;C=c[c[b>>2]>>2]|0;if(!C)D=w;else{c[b>>2]=C;D=c[B>>2]|0}GN(c[o>>2]|0,D);D=b+8|0;c[D>>2]=(c[D>>2]|0)+1;E=w}else E=y;c[k>>2]=n;$dd(h,E+24|0,k);if((a[h+4>>0]|0)!=0|(a[m>>0]|0)==0){i=g;return}c[l>>2]=c[153100];c[h+0>>2]=c[l+0>>2];eOb(n,h);i=g;return}function Ydd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Xdd(c[154762]|0,a,b,d);i=e;return}function Zdd(){return c[154762]|0}function _dd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[b+4>>2]|0;g=b+4|0;if(f){b=d;d=c[b>>2]|0;h=c[b+4>>2]|0;b=g;j=f;a:while(1){f=j;while(1){k=f+16|0;l=c[k+4>>2]|0;m=HEi(c[k>>2]|0,d)|0;if(!m)n=HEi(l,h)|0;else n=m;if((n|0)>=0){o=f;break}f=c[f+4>>2]|0;if(!f){p=b;break a}}j=c[o>>2]|0;if(!j){p=o;break}else b=o}if((p|0)!=(g|0)){o=p+16|0;b=c[o+4>>2]|0;j=HEi(d,c[o>>2]|0)|0;if(!j)q=HEi(h,b)|0;else q=j;if((q|0)>=0){c[a>>2]=p;i=e;return}}}c[a>>2]=g;i=e;return}function $dd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=c[e>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((HEi(k,m)|0)<0){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((HEi(m,k)|0)>=0){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=d+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=0;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}g=xCi(20)|0;c[g+16>>2]=c[e>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=v;c[u>>2]=g;v=c[c[d>>2]>>2]|0;if(!v)z=g;else{c[d>>2]=v;z=c[u>>2]|0}GN(c[h>>2]|0,z);z=d+8|0;c[z>>2]=(c[z>>2]|0)+1;w=1;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function aed(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{aed(a,c[b>>2]|0);aed(a,c[b+4>>2]|0);ded(b+24|0,c[b+28>>2]|0);ACi(b);i=d;return}}function bed(){var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[153100];c[d+0>>2]=c[e+0>>2];e=bOb(16,d,1,16,3653512,91)|0;d=e+4|0;c[d>>2]=0;c[e+8>>2]=0;c[e>>2]=d;a[e+12>>0]=0;c[154762]=e;i=b;return}function ced(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[154762]|0;f=c[153100]|0;if(e)aed(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[154762]=0;i=a;return}function ded(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{ded(a,c[b>>2]|0);ded(a,c[b+4>>2]|0);ACi(b);i=d;return}}function eed(a,b){a=a|0;b=b|0;var d=0;c[a>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;c[a+32>>2]=0;c[a+40>>2]=0;c[a+44>>2]=0;c[a+48>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;c[a+64>>2]=0;c[a+72>>2]=0;c[a+76>>2]=0;c[a+80>>2]=0;c[a+88>>2]=0;c[a+92>>2]=0;c[a+96>>2]=0;c[a+104>>2]=0;c[a+108>>2]=0;c[a+112>>2]=0;c[a+120>>2]=0;c[a+124>>2]=0;c[a+128>>2]=0;c[a+136>>2]=0;c[a+140>>2]=0;d=c[b>>2]|0;c[a+4>>2]=d;c[a+20>>2]=d;c[a+36>>2]=d;c[a+52>>2]=d;c[a+68>>2]=d;c[a+84>>2]=d;c[a+100>>2]=d;c[a+116>>2]=d;c[a+132>>2]=d;return}function fed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b*12|0;h=0;while(1){if(!h){h=h+1|0;continue}j=a+(h<<4)|0;k=a+(h<<4)+12|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<b>>>0)if((l|0)>-1){c[k>>2]=b;m=c[j>>2]|0;c[f>>2]=c[a+(h<<4)+4>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(m,g,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+(h<<4)+4>>2];c[e+0>>2]=c[f+0>>2];m=cOb(g,4,e,0,3653512,352)|0;YEi(m|0,c[j>>2]|0,(c[a+(h<<4)+8>>2]|0)*12|0)|0;c[k>>2]=b;c[j>>2]=m;break}while(0);h=h+1|0;if((h|0)==9)break}i=d;return}function ged(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=0;do{e=c[a+(d<<4)>>2]|0;f=c[a+(d<<4)+8>>2]|0;if(f){g=0;do{oQb(c[e+(g*12|0)>>2]|0);g=g+1|0}while((g|0)!=(f|0))}d=d+1|0}while((d|0)!=9);i=b;return}function hed(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;e=f+4|0;d=f;g=c[b+4>>2]|0;h=(c[b+8>>2]|0)>>>21;do if((h|0)==95)j=6;else if((h|0)==156)j=7;else if((h|0)!=114)if((h&2043|0)!=50){k=da(c[137788]|0,h)|0;l=k+53|0;m=l>>5;n=c[137786]|0;if(!(1<<l-(m<<5)&c[n+(m<<2)>>2])){if((h|0)==223){j=4;break}else if((h|0)!=1?(m=k+2|0,l=m>>5,(c[n+(l<<2)>>2]&1<<m-(l<<5)|0)==0):0){l=k+9|0;k=l>>5;j=(c[n+(k<<2)>>2]&1<<l-(k<<5)|0)==0&1;break}j=5}else j=3}else j=2;else j=8;while(0);k=a+(j<<4)|0;l=a+(j<<4)+8|0;n=(c[l>>2]|0)+1|0;c[l>>2]=n;m=a+(j<<4)+12|0;o=c[m>>2]|0;p=o&2147483647;if(n>>>0<=p>>>0){q=n;r=q+-1|0;s=c[k>>2]|0;t=s+(r*12|0)|0;c[t>>2]=b;u=s+(r*12|0)+4|0;c[u>>2]=g;v=s+(r*12|0)+8|0;c[v>>2]=h;i=f;return}n=o<<1;w=(n|0)==0?1:n;do if(p>>>0<w>>>0)if((o|0)>-1){c[m>>2]=w;n=c[k>>2]|0;c[d>>2]=c[a+(j<<4)+4>>2];c[e+0>>2]=c[d+0>>2];c[k>>2]=hOb(n,w*12|0,4,e,0,3653512,370)|0;break}else{c[d>>2]=c[a+(j<<4)+4>>2];c[e+0>>2]=c[d+0>>2];n=cOb(w*12|0,4,e,0,3653512,352)|0;YEi(n|0,c[k>>2]|0,(c[l>>2]|0)*12|0)|0;c[m>>2]=w;c[k>>2]=n;break}while(0);q=c[l>>2]|0;r=q+-1|0;s=c[k>>2]|0;t=s+(r*12|0)|0;c[t>>2]=b;u=s+(r*12|0)+4|0;c[u>>2]=g;v=s+(r*12|0)+8|0;c[v>>2]=h;i=f;return}function ied(a,b){a=a|0;b=b|0;return (c[a+4>>2]|0)<(c[b+4>>2]|0)|0}function jed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;do if(a){c[g>>2]=a;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,g);l=c[e>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[n+4>>2]|0,(k|0)!=0):0)o=k;else p=10}else p=10;if((p|0)==10){k=hQb(a)|0;if(!k){q=0;break}else o=k}k=(da(c[137788]|0,(c[o+8>>2]|0)>>>21)|0)+114|0;l=k>>5;if((1<<k-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0?(l=c[o+32>>2]|0,(l|0)!=0):0){c[j>>2]=l;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,j);m=c[e>>2]|0;r=c[k+28>>2]|0;if((m|0)==-1){s=r+(c[k+32>>2]<<3)|0;break}else{s=r+(m<<3)|0;break}}else s=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((s|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[s+4>>2]|0,(k|0)!=0):0)t=k;else p=21}else p=21;if((p|0)==21){k=hQb(l)|0;if(!k){q=0;break}else t=k}q=c[t+52>>2]|0}else q=0}else q=0;while(0);if(!b){u=0;v=(q|0)==(u|0);w=(q|0)<(u|0);x=(a|0)>(b|0);y=v?x:w;i=d;return y|0}c[f>>2]=b;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(e,t,f);s=c[e>>2]|0;j=c[t+28>>2]|0;if((s|0)==-1){z=j+(c[t+32>>2]<<3)|0;break}else{z=j+(s<<3)|0;break}}else z=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((z|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[z+4>>2]|0,(t|0)!=0):0)A=t;else p=32}else p=32;if((p|0)==32){t=hQb(b)|0;if(!t){u=0;v=(q|0)==(u|0);w=(q|0)<(u|0);x=(a|0)>(b|0);y=v?x:w;i=d;return y|0}else A=t}t=(da(c[137788]|0,(c[A+8>>2]|0)>>>21)|0)+114|0;z=t>>5;if(!(1<<t-(z<<5)&c[(c[137786]|0)+(z<<2)>>2])){u=0;v=(q|0)==(u|0);w=(q|0)<(u|0);x=(a|0)>(b|0);y=v?x:w;i=d;return y|0}z=c[A+32>>2]|0;if(!z){u=0;v=(q|0)==(u|0);w=(q|0)<(u|0);x=(a|0)>(b|0);y=v?x:w;i=d;return y|0}c[h>>2]=z;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(e,A,h);t=c[e>>2]|0;f=c[A+28>>2]|0;if((t|0)==-1){B=f+(c[A+32>>2]<<3)|0;break}else{B=f+(t<<3)|0;break}}else B=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if((B|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0)?(A=c[B+4>>2]|0,(A|0)!=0):0)C=A;else p=43}else p=43;if((p|0)==43){p=hQb(z)|0;if(!p){u=0;v=(q|0)==(u|0);w=(q|0)<(u|0);x=(a|0)>(b|0);y=v?x:w;i=d;return y|0}else C=p}u=c[C+52>>2]|0;v=(q|0)==(u|0);w=(q|0)<(u|0);x=(a|0)>(b|0);y=v?x:w;i=d;return y|0}function ked(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=0;do{f=c[a+(e<<4)>>2]|0;g=c[a+(e<<4)+8>>2]|0;c[d>>2]=2640;ted(f,f+(g*12|0)|0,d);oed(f,g,3);e=e+1|0}while((e|0)!=9);i=b;return}function led(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+(b<<4)>>2]|0;h=c[a+(b<<4)+8>>2]|0;c[f>>2]=2640;ted(g,g+(h*12|0)|0,f);oed(g,h,d);i=e;return}function med(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+(b<<4)+12|0;if((c[g>>2]|0)>-1){h=a+(b<<4)|0;j=c[h>>2]|0;c[f>>2]=c[a+(b<<4)+4>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[h>>2]=0}c[a+(b<<4)+8>>2]=0;c[g>>2]=0;i=d;return}function ned(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=0;do{g=a+(f<<4)+12|0;if((c[g>>2]|0)>-1){h=a+(f<<4)|0;j=c[h>>2]|0;c[e>>2]=c[a+(f<<4)+4>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[h>>2]=0}c[a+(f<<4)+8>>2]=0;c[g>>2]=0;f=f+1|0}while((f|0)!=9);i=b;return}function oed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+8|0;g=e;if(!b){i=e;return}h=0;do{j=a+(h*12|0)+4|0;k=c[j>>2]|0;do if(k){c[g>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,g);m=c[f>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[o+4>>2]|0,(l|0)!=0):0)p=l;else q=12}else q=12;if((q|0)==12){q=0;l=hQb(c[j>>2]|0)|0;if(!l)break;else p=l}In[c[(c[p>>2]|0)+12>>2]&4095](p,d)}while(0);h=h+1|0}while((h|0)!=(b|0));i=e;return}function ped(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;if(d){d=0;do{if((d|0)==8){g=c[a+128>>2]|0;h=g+((c[a+136>>2]|0)*12|0)|0;c[f>>2]=2641;ted(g,h,f)}h=c[a+(d<<4)>>2]|0;g=c[a+(d<<4)+8>>2]|0;qed(h,g);red(h,g,b);d=d+1|0}while((d|0)!=9);i=e;return}else{d=0;do{if((d|0)==8){g=c[a+128>>2]|0;h=g+((c[a+136>>2]|0)*12|0)|0;c[f>>2]=2641;ted(g,h,f)}red(c[a+(d<<4)>>2]|0,c[a+(d<<4)+8>>2]|0,b);d=d+1|0}while((d|0)!=9);i=e;return}}function qed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;if(!b){i=d;return}g=0;do{h=a+(g*12|0)+4|0;j=c[h>>2]|0;do if(j){c[f>>2]=j;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,f);l=c[e>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[n+4>>2]|0,(k|0)!=0):0)o=k;else p=12}else p=12;if((p|0)==12){p=0;k=hQb(c[h>>2]|0)|0;if(!k)break;else o=k}ko[c[(c[o>>2]|0)+20>>2]&4095](o)}while(0);g=g+1|0}while((g|0)!=(b|0));i=d;return}function red(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+8|0;g=e;if(!b){i=e;return}h=0;do{j=a+(h*12|0)+4|0;k=c[j>>2]|0;do if(k){c[g>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,g);m=c[f>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[o+4>>2]|0,(l|0)!=0):0)p=l;else q=12}else q=12;if((q|0)==12){q=0;l=hQb(c[j>>2]|0)|0;if(!l)break;else p=l}In[c[(c[p>>2]|0)+12>>2]&4095](p,d)}while(0);h=h+1|0}while((h|0)!=(b|0));i=e;return}function sed(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[a>>2]|0)+12>>2]&4095](a,b);i=d;return}function ted(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+16|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-12|0;j=a+-8|0;k=a+-4|0;l=g;b:while(1){m=l;n=b-m|0;switch((n|0)/12|0|0){case 4:{o=l;p=h;q=7;break a;break}case 2:{r=l;s=h;t=h;u=j;v=k;q=4;break a;break}case 3:{w=l;x=h;q=6;break a;break}case 5:{y=l;z=h;q=8;break a;break}case 1:case 0:{q=54;break a;break}default:{}}if((n|0)<84){A=l;B=a;q=10;break a}C=(n|0)/24|0;D=l+(C*12|0)|0;if((n|0)>11988){E=(n|0)/48|0;F=xed(l,l+(E*12|0)|0,D,l+((E+C|0)*12|0)|0,h,d)|0}else F=ved(l,D,h,d)|0;do if(_n[c[d>>2]&4095](l,D)|0){G=h;H=F}else{C=a;E=h;while(1){n=C+-24|0;if((l|0)==(n|0))break;if(_n[c[d>>2]&4095](n,D)|0){I=C;J=n;q=36;break}else{K=E;E=n;C=K}}if((q|0)==36){q=0;C=c[l>>2]|0;E=l+4|0;K=c[E>>2]|0;n=l+8|0;L=c[n>>2]|0;c[l>>2]=c[J>>2];M=I+-20|0;c[E>>2]=c[M>>2];E=I+-16|0;c[n>>2]=c[E>>2];c[J>>2]=C;c[M>>2]=K;c[E>>2]=L;G=J;H=F+1|0;break}L=l+12|0;if(_n[c[d>>2]&4095](l,h)|0)N=L;else{if((L|0)==(h|0)){q=54;break a}else{O=l;P=L}while(1){L=O+24|0;if(_n[c[d>>2]&4095](l,P)|0){Q=P;break}if((L|0)==(h|0)){q=54;break a}else{E=P;P=L;O=E}}E=c[Q>>2]|0;L=Q+4|0;K=c[L>>2]|0;M=Q+8|0;C=c[M>>2]|0;c[Q>>2]=c[h>>2];c[L>>2]=c[j>>2];c[M>>2]=c[k>>2];c[h>>2]=E;c[j>>2]=K;c[k>>2]=C;N=Q+12|0}if((N|0)==(h|0)){q=54;break a}else{R=N;S=h}while(1){C=R;while(1){K=C+12|0;if(_n[c[d>>2]&4095](l,C)|0){T=K;U=C;break}else C=K}C=S;while(1){K=C+-12|0;if(_n[c[d>>2]&4095](l,K)|0)C=K;else{V=K;W=C;break}}if(U>>>0>=V>>>0){l=U;continue b}C=c[U>>2]|0;K=U+4|0;E=c[K>>2]|0;M=U+8|0;L=c[M>>2]|0;c[U>>2]=c[V>>2];n=W+-8|0;c[K>>2]=c[n>>2];K=W+-4|0;c[M>>2]=c[K>>2];c[V>>2]=C;c[n>>2]=E;c[K>>2]=L;R=T;S=V}}while(0);L=l+12|0;c:do if(L>>>0<G>>>0){K=L;E=G;n=D;C=H;while(1){M=K;while(1){X=M+12|0;if(_n[c[d>>2]&4095](M,n)|0)M=X;else{Y=X;Z=M;break}}M=E;while(1){X=M+-12|0;if(_n[c[d>>2]&4095](X,n)|0){_=X;$=M;break}else M=X}if(Z>>>0>_>>>0){aa=Z;ba=n;ca=C;break c}M=c[Z>>2]|0;X=Z+4|0;da=c[X>>2]|0;ea=Z+8|0;fa=c[ea>>2]|0;c[Z>>2]=c[_>>2];ga=$+-8|0;c[X>>2]=c[ga>>2];X=$+-4|0;c[ea>>2]=c[X>>2];c[_>>2]=M;c[ga>>2]=da;c[X>>2]=fa;K=Y;E=_;n=(n|0)==(Z|0)?_:n;C=C+1|0}}else{aa=L;ba=D;ca=H}while(0);if((aa|0)!=(ba|0)?_n[c[d>>2]&4095](ba,aa)|0:0){D=c[aa>>2]|0;L=aa+4|0;C=c[L>>2]|0;n=aa+8|0;E=c[n>>2]|0;c[aa>>2]=c[ba>>2];K=ba+4|0;c[L>>2]=c[K>>2];L=ba+8|0;c[n>>2]=c[L>>2];c[ba>>2]=D;c[K>>2]=C;c[L>>2]=E;ha=ca+1|0}else ha=ca;if(!ha){ia=yed(l,aa,d)|0;E=aa+12|0;if(yed(E,a,d)|0){q=49;break}if(ia){l=E;continue}}E=aa;if((E-m|0)>=(b-E|0)){ja=l;ka=aa;q=53;break}ted(l,aa,d);l=aa+12|0}if((q|0)==49){q=0;if(ia){q=54;break}else{g=l;a=aa;continue}}else if((q|0)==53){q=0;ted(ka+12|0,a,d);g=ja;a=ka;continue}}if((q|0)==4){if(!(_n[c[d>>2]&4095](s,r)|0)){i=e;return}s=c[r>>2]|0;ka=r+4|0;a=c[ka>>2]|0;ja=r+8|0;g=c[ja>>2]|0;c[r>>2]=c[t>>2];c[ka>>2]=c[u>>2];c[ja>>2]=c[v>>2];c[t>>2]=s;c[u>>2]=a;c[v>>2]=g;i=e;return}else if((q|0)==6){ved(w,w+12|0,x,d)|0;i=e;return}else if((q|0)==7){wed(o,o+12|0,o+24|0,p,d)|0;i=e;return}else if((q|0)==8){xed(y,y+12|0,y+24|0,y+36|0,z,d)|0;i=e;return}else if((q|0)==10){z=A+24|0;ved(A,A+12|0,z,d)|0;y=A+36|0;if((y|0)==(B|0)){i=e;return}p=f+4|0;o=f+8|0;x=y;y=z;while(1){if(_n[c[d>>2]&4095](x,y)|0){c[f>>2]=c[x>>2];c[p>>2]=c[x+4>>2];c[o>>2]=c[x+8>>2];z=x;w=y;while(1){c[z>>2]=c[w>>2];g=w+4|0;c[z+4>>2]=c[g>>2];v=w+8|0;c[z+8>>2]=c[v>>2];if((w|0)==(A|0)){la=w;ma=g;na=v;break}a=w+-12|0;if(_n[c[d>>2]&4095](f,a)|0){u=w;w=a;z=u}else{la=w;ma=g;na=v;break}}c[la>>2]=c[f>>2];c[ma>>2]=c[p>>2];c[na>>2]=c[o>>2]}w=x+12|0;if((w|0)==(B|0))break;else{z=x;x=w;y=z}}i=e;return}else if((q|0)==54){i=e;return}}function ued(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=jed(c[a+4>>2]|0,c[b+4>>2]|0)|0;i=d;return e|0}function ved(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=_n[c[e>>2]&4095](b,a)|0;h=_n[c[e>>2]&4095](d,b)|0;if(!g){if(!h){j=0;i=f;return j|0}g=c[b>>2]|0;k=b+4|0;l=c[k>>2]|0;m=b+8|0;n=c[m>>2]|0;c[b>>2]=c[d>>2];o=d+4|0;c[k>>2]=c[o>>2];p=d+8|0;c[m>>2]=c[p>>2];c[d>>2]=g;c[o>>2]=l;c[p>>2]=n;if(!(_n[c[e>>2]&4095](b,a)|0)){j=1;i=f;return j|0}n=c[a>>2]|0;p=a+4|0;l=c[p>>2]|0;o=a+8|0;g=c[o>>2]|0;c[a>>2]=c[b>>2];c[p>>2]=c[k>>2];c[o>>2]=c[m>>2];c[b>>2]=n;c[k>>2]=l;c[m>>2]=g;j=2;i=f;return j|0}g=c[a>>2]|0;m=a+4|0;l=c[m>>2]|0;k=a+8|0;n=c[k>>2]|0;if(h){c[a>>2]=c[d>>2];h=d+4|0;c[m>>2]=c[h>>2];o=d+8|0;c[k>>2]=c[o>>2];c[d>>2]=g;c[h>>2]=l;c[o>>2]=n;j=1;i=f;return j|0}c[a>>2]=c[b>>2];a=b+4|0;c[m>>2]=c[a>>2];m=b+8|0;c[k>>2]=c[m>>2];c[b>>2]=g;c[a>>2]=l;c[m>>2]=n;if(!(_n[c[e>>2]&4095](d,b)|0)){j=1;i=f;return j|0}e=c[b>>2]|0;n=c[a>>2]|0;l=c[m>>2]|0;c[b>>2]=c[d>>2];b=d+4|0;c[a>>2]=c[b>>2];a=d+8|0;c[m>>2]=c[a>>2];c[d>>2]=e;c[b>>2]=n;c[a>>2]=l;j=2;i=f;return j|0}function wed(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=ved(a,b,d,f)|0;if(!(_n[c[f>>2]&4095](e,d)|0)){j=h;i=g;return j|0}k=c[d>>2]|0;l=d+4|0;m=c[l>>2]|0;n=d+8|0;o=c[n>>2]|0;c[d>>2]=c[e>>2];p=e+4|0;c[l>>2]=c[p>>2];q=e+8|0;c[n>>2]=c[q>>2];c[e>>2]=k;c[p>>2]=m;c[q>>2]=o;if(!(_n[c[f>>2]&4095](d,b)|0)){j=h+1|0;i=g;return j|0}o=c[b>>2]|0;q=b+4|0;m=c[q>>2]|0;p=b+8|0;k=c[p>>2]|0;c[b>>2]=c[d>>2];c[q>>2]=c[l>>2];c[p>>2]=c[n>>2];c[d>>2]=o;c[l>>2]=m;c[n>>2]=k;if(!(_n[c[f>>2]&4095](b,a)|0)){j=h+2|0;i=g;return j|0}f=c[a>>2]|0;k=a+4|0;n=c[k>>2]|0;m=a+8|0;l=c[m>>2]|0;c[a>>2]=c[b>>2];c[k>>2]=c[q>>2];c[m>>2]=c[p>>2];c[b>>2]=f;c[q>>2]=n;c[p>>2]=l;j=h+3|0;i=g;return j|0}function xed(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=wed(a,b,d,e,g)|0;if(!(_n[c[g>>2]&4095](f,e)|0)){k=j;i=h;return k|0}l=c[e>>2]|0;m=e+4|0;n=c[m>>2]|0;o=e+8|0;p=c[o>>2]|0;c[e>>2]=c[f>>2];q=f+4|0;c[m>>2]=c[q>>2];r=f+8|0;c[o>>2]=c[r>>2];c[f>>2]=l;c[q>>2]=n;c[r>>2]=p;if(!(_n[c[g>>2]&4095](e,d)|0)){k=j+1|0;i=h;return k|0}p=c[d>>2]|0;r=d+4|0;n=c[r>>2]|0;q=d+8|0;l=c[q>>2]|0;c[d>>2]=c[e>>2];c[r>>2]=c[m>>2];c[q>>2]=c[o>>2];c[e>>2]=p;c[m>>2]=n;c[o>>2]=l;if(!(_n[c[g>>2]&4095](d,b)|0)){k=j+2|0;i=h;return k|0}l=c[b>>2]|0;o=b+4|0;n=c[o>>2]|0;m=b+8|0;p=c[m>>2]|0;c[b>>2]=c[d>>2];c[o>>2]=c[r>>2];c[m>>2]=c[q>>2];c[d>>2]=l;c[r>>2]=n;c[q>>2]=p;if(!(_n[c[g>>2]&4095](b,a)|0)){k=j+3|0;i=h;return k|0}g=c[a>>2]|0;p=a+4|0;q=c[p>>2]|0;n=a+8|0;r=c[n>>2]|0;c[a>>2]=c[b>>2];c[p>>2]=c[o>>2];c[n>>2]=c[m>>2];c[b>>2]=g;c[o>>2]=q;c[m>>2]=r;k=j+4|0;i=h;return k|0}function yed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e;switch((b-a|0)/12|0|0){case 5:{xed(a,a+12|0,a+24|0,a+36|0,b+-12|0,d)|0;g=1;i=e;return g|0}case 2:{h=b+-12|0;if(!(_n[c[d>>2]&4095](h,a)|0)){g=1;i=e;return g|0}j=c[a>>2]|0;k=a+4|0;l=c[k>>2]|0;m=a+8|0;n=c[m>>2]|0;c[a>>2]=c[h>>2];o=b+-8|0;c[k>>2]=c[o>>2];k=b+-4|0;c[m>>2]=c[k>>2];c[h>>2]=j;c[o>>2]=l;c[k>>2]=n;g=1;i=e;return g|0}case 4:{wed(a,a+12|0,a+24|0,b+-12|0,d)|0;g=1;i=e;return g|0}case 1:case 0:{g=1;i=e;return g|0}case 3:{ved(a,a+12|0,b+-12|0,d)|0;g=1;i=e;return g|0}default:{n=a+24|0;ved(a,a+12|0,n,d)|0;k=a+36|0;if((k|0)==(b|0)){g=1;i=e;return g|0}l=f+4|0;o=f+8|0;j=0;h=k;k=n;while(1){if(_n[c[d>>2]&4095](h,k)|0){c[f>>2]=c[h>>2];c[l>>2]=c[h+4>>2];c[o>>2]=c[h+8>>2];n=h;m=k;while(1){c[n>>2]=c[m>>2];p=m+4|0;c[n+4>>2]=c[p>>2];q=m+8|0;c[n+8>>2]=c[q>>2];if((m|0)==(a|0)){r=m;s=p;t=q;break}u=m+-12|0;if(_n[c[d>>2]&4095](f,u)|0){v=m;m=u;n=v}else{r=m;s=p;t=q;break}}c[r>>2]=c[f>>2];c[s>>2]=c[l>>2];c[t>>2]=c[o>>2];m=j+1|0;if((m|0)==8){w=h;break}else x=m}else x=j;m=h+12|0;if((m|0)==(b|0)){g=1;y=16;break}else{n=h;j=x;h=m;k=n}}if((y|0)==16){i=e;return g|0}g=(w+12|0)==(b|0);i=e;return g|0}}return 0}function zed(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+96|0;g=f+32|0;h=f+56|0;j=f+72|0;k=f+76|0;l=f+16|0;m=f;n=f+40|0;sri(k,d);o=a[k>>0]|0;if(!(o&1)){p=k+1|0;q=p;r=p;s=k+8|0}else{p=k+8|0;q=c[p>>2]|0;r=k+1|0;s=p}p=k+4|0;t=o;o=q;while(1){if(!(t&1)){u=r;v=(t&255)>>>1}else{u=c[s>>2]|0;v=c[p>>2]|0}if((o|0)==(u+v|0))break;q=a[o>>0]|0;w=q<<24>>24;a[o>>0]=(q+-65<<24>>24&255)<26?w+32|0:w;t=a[k>>0]|0;o=o+1|0}o=b+176|0;t=b+180|0;Eed(j,o,k,c[b+180>>2]|0,t);v=c[j>>2]|0;do if((v|0)!=(t|0)){j=v+16|0;u=a[k>>0]|0;s=(u&1)==0;if(s)x=(u&255)>>>1;else x=c[p>>2]|0;u=a[j>>0]|0;r=(u&1)==0;if(r)y=(u&255)>>>1;else y=c[v+20>>2]|0;if(s)z=k+1|0;else z=c[k+8>>2]|0;if(r)A=j+1|0;else A=c[v+24>>2]|0;j=FEi(z,A,y>>>0<x>>>0?y:x)|0;if(!j){if(x>>>0<y>>>0)break}else if((j|0)<0)break;B=c[v+28>>2]|0;xri(k);i=f;return B|0}while(0);if(!e){B=-1;xri(k);i=f;return B|0}sri(n,k);e=b+188|0;v=b+192|0;y=c[v>>2]|0;x=c[e>>2]|0;sri(m,n);A=m+12|0;c[A>>2]=(y-x|0)/12|0;sri(l,m);x=l+12|0;c[x>>2]=c[A>>2];sri(h,l);c[h+12>>2]=c[x>>2];Fed(g,o,h);xri(h);xri(l);xri(m);xri(n);n=c[v>>2]|0;if((n|0)==(c[b+196>>2]|0))nO(e,d);else{if(!n)C=0;else{sri(n,d);C=c[v>>2]|0}c[v>>2]=C+12}vfd(b);B=(((c[v>>2]|0)-(c[e>>2]|0)|0)/12|0)+-1|0;xri(k);i=f;return B|0}function Aed(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=c[(c[b>>2]|0)+12>>2]|0;j=a[d>>0]|0;if(!(j&1)){k=d+1|0;l=(j&255)>>>1}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0}rri(g,k,l);l=xo[h&2047](b,g,e)|0;xri(g);i=f;return l|0}function Bed(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;g=c[d+188>>2]|0;d=g+(e*12|0)|0;h=a[d>>0]|0;if(!(h&1)){j=(h&255)>>>1;k=d+1|0}else{j=c[g+(e*12|0)+4>>2]|0;k=c[g+(e*12|0)+8>>2]|0}if(j>>>0>10){eXb(b,10,j+-10|0,0,0,0,j,k);i=f;return}else{aFi(b+1|0,k|0,j|0)|0;a[b+j+1>>0]=0;a[b>>0]=j<<1;i=f;return}}function Ced(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;sri(a,(c[b+188>>2]|0)+(d*12|0)|0);i=e;return}function Ded(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(200,b,1,16,3653512,49)|0;lfd(d,0,2);c[d>>2]=619064;b=d+180|0;c[b>>2]=0;c[d+184>>2]=0;c[d+176>>2]=b;c[d+188>>2]=0;c[d+192>>2]=0;c[d+196>>2]=0;i=a;return}function Eed(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=a[e>>0]|0;k=(j&1)==0;l=(j&255)>>>1;j=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(k){f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=o+1|0}else{q=c[f+20>>2]|0;r=c[f+24>>2]|0}o=FEi(r,j,l>>>0<q>>>0?l:q)|0;if(!o){if(q>>>0>=l>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}else{f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){u=(p&255)>>>1;v=o+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}o=FEi(v,m,n>>>0<u>>>0?n:u)|0;if(!o){if(u>>>0>=n>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}while(0);g=c[s>>2]|0;if(!g){h=s;t=19;break}else e=s}if((t|0)==19){c[b>>2]=h;i=d;return}}function Fed(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=Ied(d,g,e)|0;j=c[h>>2]|0;if(j){k=0;l=j;c[b>>2]=l;m=b+4|0;a[m>>0]=k;i=f;return}j=xCi(32)|0;sri(j+16|0,e);c[j+28>>2]=c[e+12>>2];e=c[g>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=e;c[h>>2]=j;e=c[c[d>>2]>>2]|0;if(!e)n=j;else{c[d>>2]=e;n=c[h>>2]|0}GN(c[d+4>>2]|0,n);n=d+8|0;c[n>>2]=(c[n>>2]|0)+1;k=1;l=j;c[b>>2]=l;m=b+4|0;a[m>>0]=k;i=f;return}function Ged(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=619064;d=a+188|0;e=c[d>>2]|0;if(e){f=a+192|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-12|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}PUb(a+176|0,c[a+180>>2]|0);mfd(a);i=b;return}function Hed(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=619064;d=a+188|0;e=c[d>>2]|0;if(e){f=a+192|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-12|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}PUb(a+176|0,c[a+180>>2]|0);mfd(a);ACi(a);i=b;return}function Ied(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&1)==0;k=(h&255)>>>1;h=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;e=g;while(1){g=e+16|0;n=b?k:m;o=a[g>>0]|0;p=(o&1)==0;if(p)q=(o&255)>>>1;else q=c[e+20>>2]|0;if(p)r=g+1|0;else r=c[e+24>>2]|0;s=FEi(b?h:l,r,q>>>0<n>>>0?q:n)|0;if(!s){if(n>>>0<q>>>0)t=12}else if((s|0)<0)t=12;if((t|0)==12){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=13;break}else{e=s;continue}}if(p)w=(o&255)>>>1;else w=c[e+20>>2]|0;o=b?k:m;if(p)x=g+1|0;else x=c[e+24>>2]|0;g=FEi(x,b?h:l,o>>>0<w>>>0?o:w)|0;if(!g){if(w>>>0>=o>>>0){y=e;t=25;break}}else if((g|0)>=0){y=e;t=25;break}g=e+4|0;o=c[g>>2]|0;if(!o){z=g;A=e;t=24;break}else e=o}if((t|0)==13){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==24){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==25){c[d>>2]=y;j=d;i=f;return j|0}return 0}function Jed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[a+44>>2]|0;a=c[f+36>>2]|0;if(((a|0)!=-1?(g=c[f+28>>2]|0,(g|0)<=(b|0)):0)?(c[f+32>>2]|0)>=(b|0):0){c[d>>2]=a;a=(b-g|0)/2|0;g=d+8|0;c[g>>2]=a;c[g+4>>2]=((a|0)<0)<<31>>31;h=1;i=e;return h|0}a=c[f+16>>2]|0;g=f+16|0;if(a){f=g;j=a;a:while(1){a=j;while(1){if((c[a+16>>2]|0)>=(b|0)){k=a;break}a=c[a+4>>2]|0;if(!a){l=f;break a}}j=c[k>>2]|0;if(!j){l=k;break}else f=k}if((l|0)!=(g|0)?(c[l+16>>2]|0)<=(b|0):0){b=l+24|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];h=1;i=e;return h|0}}c[d>>2]=-1;b=d+8|0;c[b>>2]=0;c[b+4>>2]=0;h=0;i=e;return h|0}function Ked(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=xo[c[(c[a>>2]|0)+12>>2]&2047](a,b,1)|0;b=g+8|0;c[b>>2]=d;c[b+4>>2]=e;e=xfd(c[a+44>>2]|0,g)|0;i=f;return e|0}function Led(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=c[a+44>>2]|0;f=c[e+36>>2]|0;if(((f|0)!=-1?(g=c[e+28>>2]|0,(g|0)<=(b|0)):0)?(c[e+32>>2]|0)>=(b|0):0){h=(b-g|0)/2|0;j=f;k=h;l=((h|0)<0)<<31>>31}else m=5;do if((m|0)==5){h=c[e+16>>2]|0;f=e+16|0;if(!h){n=-1;i=d;return n|0}else{o=f;p=h}a:while(1){h=p;while(1){if((c[h+16>>2]|0)>=(b|0)){q=h;break}h=c[h+4>>2]|0;if(!h){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if((r|0)==(f|0)){n=-1;i=d;return n|0}if((c[r+16>>2]|0)>(b|0)){n=-1;i=d;return n|0}else{h=r+32|0;j=c[r+24>>2]|0;k=c[h>>2]|0;l=c[h+4>>2]|0;break}}while(0);if((j|0)==-1){n=-1;i=d;return n|0}r=ofd(a,j)|0;j=c[r>>2]|0;if(!j){n=-1;i=d;return n|0}if(!(fgd(j,k,l)|0)){n=-1;i=d;return n|0}j=c[r+16>>2]|0;b:do if(j){a=c[j>>2]|0;b=c[j+8>>2]|0;q=a+(b<<3)|0;c:do if(!b)s=a;else{o=a;while(1){p=o;if((c[p>>2]|0)==(k|0)?(c[p+4>>2]|0)==(l|0):0){s=o;break c}o=o+8|0;if((o|0)==(q|0))break b}}while(0);if((s|0)!=(q|0)){n=-1;i=d;return n|0}}while(0);s=c[r>>2]|0;if(!s){n=-1;i=d;return n|0}n=ggd(s,k,l)|0;i=d;return n|0}function Med(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=xo[c[(c[a>>2]|0)+12>>2]&2047](a,b,1)|0;if((f|0)==-1){i=e;return}b=ofd(a,f)|0;f=c[b>>2]|0;if(!f){i=e;return}hgd(f,d);f=d+8|0;a=c[f>>2]|0;if(!a){i=e;return}g=c[d>>2]|0;h=b+16|0;b=a;a=g;j=g;a:while(1){g=j;j=j+8|0;k=j;l=a;m=b;b:while(1){n=g;o=c[n>>2]|0;p=c[n+4>>2]|0;n=c[h>>2]|0;if(!n){q=l;r=m;break}s=c[n>>2]|0;t=c[n+8>>2]|0;n=s+(t<<3)|0;c:do if(!t)u=s;else{v=s;while(1){w=v;if((c[w>>2]|0)==(o|0)?(c[w+4>>2]|0)==(p|0):0){u=v;break c}v=v+8|0;if((v|0)==(n|0)){q=l;r=m;break b}}}while(0);if((u|0)==(n|0)){q=l;r=m;break}aFi(g|0,j|0,l+(m<<3)-k|0)|0;m=(c[f>>2]|0)+-1|0;c[f>>2]=m;l=c[d>>2]|0;if((g|0)==(l+(m<<3)|0)){x=13;break a}}if((j|0)==(q+(r<<3)|0)){x=13;break}else{b=r;a=q}}if((x|0)==13){i=e;return}}function Ned(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f;k=xo[c[(c[a>>2]|0)+12>>2]&2047](a,b,1)|0;if((k|0)==-1){i=f;return}b=ofd(a,k)|0;k=c[b>>2]|0;if(!k){i=f;return}a=c[153134]|0;c[j>>2]=0;l=j+4|0;c[l>>2]=a;a=j+8|0;c[a>>2]=0;m=j+12|0;c[m>>2]=0;hgd(k,j);k=c[a>>2]|0;n=d+12|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<k>>>0)if((o|0)>-1){c[n>>2]=k;p=c[d>>2]|0;c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];c[d>>2]=hOb(p,k<<3,8,g,0,3653512,370)|0;break}else{c[h>>2]=c[d+4>>2];c[g+0>>2]=c[h+0>>2];p=cOb(k<<3,8,g,0,3653512,352)|0;YEi(p|0,c[d>>2]|0,c[d+8>>2]<<3|0)|0;c[n>>2]=k;c[d>>2]=p;break}while(0);k=c[a>>2]|0;o=e+12|0;p=c[o>>2]|0;if((p&2147483647)>>>0<k>>>0){if((p|0)>-1){c[o>>2]=k;p=c[e>>2]|0;c[h>>2]=c[e+4>>2];c[g+0>>2]=c[h+0>>2];c[e>>2]=hOb(p,k<<2,4,g,0,3653512,370)|0}else{c[h>>2]=c[e+4>>2];c[g+0>>2]=c[h+0>>2];p=cOb(k<<2,4,g,0,3653512,352)|0;YEi(p|0,c[e>>2]|0,c[e+8>>2]<<2|0)|0;c[o>>2]=k;c[e>>2]=p}q=c[a>>2]|0}else q=k;k=c[j>>2]|0;if(!q)r=k;else{p=b+16|0;s=d+8|0;t=d+4|0;u=e+8|0;v=e+4|0;w=q;q=k;x=k;while(1){k=x;y=c[k>>2]|0;z=c[k+4>>2]|0;k=c[p>>2]|0;a:do if(k){A=c[k>>2]|0;B=c[k+8>>2]|0;C=A+(B<<3)|0;b:do if(!B)D=A;else{E=A;while(1){F=E;if((c[F>>2]|0)==(y|0)?(c[F+4>>2]|0)==(z|0):0){D=E;break b}E=E+8|0;if((E|0)==(C|0)){G=19;break a}}}while(0);if((D|0)!=(C|0)){H=q;I=w}else G=19}else G=19;while(0);if((G|0)==19){G=0;k=(c[s>>2]|0)+1|0;c[s>>2]=k;A=c[n>>2]|0;B=A&2147483647;if(k>>>0>B>>>0){E=A<<1;F=(E|0)==0?1:E;do if(B>>>0<F>>>0)if((A|0)>-1){c[n>>2]=F;E=c[d>>2]|0;c[h>>2]=c[t>>2];c[g+0>>2]=c[h+0>>2];c[d>>2]=hOb(E,F<<3,8,g,0,3653512,370)|0;break}else{c[h>>2]=c[t>>2];c[g+0>>2]=c[h+0>>2];E=cOb(F<<3,8,g,0,3653512,352)|0;YEi(E|0,c[d>>2]|0,c[s>>2]<<3|0)|0;c[n>>2]=F;c[d>>2]=E;break}while(0);J=c[s>>2]|0}else J=k;F=(c[d>>2]|0)+(J+-1<<3)|0;c[F>>2]=y;c[F+4>>2]=z;F=x;A=ggd(c[b>>2]|0,c[F>>2]|0,c[F+4>>2]|0)|0;F=(c[u>>2]|0)+1|0;c[u>>2]=F;B=c[o>>2]|0;E=B&2147483647;if(F>>>0>E>>>0){K=B<<1;L=(K|0)==0?1:K;do if(E>>>0<L>>>0)if((B|0)>-1){c[o>>2]=L;K=c[e>>2]|0;c[h>>2]=c[v>>2];c[g+0>>2]=c[h+0>>2];c[e>>2]=hOb(K,L<<2,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[v>>2];c[g+0>>2]=c[h+0>>2];K=cOb(L<<2,4,g,0,3653512,352)|0;YEi(K|0,c[e>>2]|0,c[u>>2]<<2|0)|0;c[o>>2]=L;c[e>>2]=K;break}while(0);M=c[u>>2]|0}else M=F;c[(c[e>>2]|0)+(M+-1<<2)>>2]=A;H=c[j>>2]|0;I=c[a>>2]|0}x=x+8|0;if((x|0)==(H+(I<<3)|0)){r=H;break}else{w=I;q=H}}}if((c[m>>2]|0)<=-1){i=f;return}c[h>>2]=c[l>>2];c[g+0>>2]=c[h+0>>2];eOb(r,g);c[j>>2]=0;i=f;return}function Oed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e+8|0;g=e;c[g>>2]=b;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(f,h,g);j=c[f>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[l+4>>2]|0,(h|0)!=0):0)if(!(c[h+8>>2]&1048576)){i=e;return}else{m=h;n=1}else{m=0;n=0}}else{m=0;n=0}if((d|0)==1)Ped(a,b);yfd(c[a+44>>2]|0,b);if(!n){i=e;return}tQb(m,0);i=e;return}function Ped(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a+44>>2]|0;j=c[h+36>>2]|0;if(((j|0)!=-1?(k=c[h+28>>2]|0,(k|0)<=(b|0)):0)?(c[h+32>>2]|0)>=(b|0):0){l=(b-k|0)/2|0;m=j;n=l;o=((l|0)<0)<<31>>31}else p=5;do if((p|0)==5){l=c[h+16>>2]|0;j=h+16|0;if(!l){i=d;return}else{q=j;r=l}a:while(1){l=r;while(1){if((c[l+16>>2]|0)>=(b|0)){s=l;break}l=c[l+4>>2]|0;if(!l){t=q;break a}}r=c[s>>2]|0;if(!r){t=s;break}else q=s}if((t|0)==(j|0)){i=d;return}if((c[t+16>>2]|0)>(b|0)){i=d;return}else{l=t+32|0;m=c[t+24>>2]|0;n=c[l>>2]|0;o=c[l+4>>2]|0;break}}while(0);if((m|0)==-1){i=d;return}t=ofd(a,m)|0;if(!(c[t>>2]|0)){i=d;return}m=t+16|0;t=c[m>>2]|0;if(!t){c[g>>2]=c[153100];c[e+0>>2]=c[g+0>>2];g=bOb(16,e,1,16,3653512,72)|0;c[g>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+4>>2]=60;c[m>>2]=g;u=g}else u=t;t=u+8|0;g=(c[t>>2]|0)+1|0;c[t>>2]=g;m=u+12|0;a=c[m>>2]|0;b=a&2147483647;if(g>>>0>b>>>0){s=a<<1;q=(s|0)==0?1:s;do if(b>>>0<q>>>0)if((a|0)>-1){c[m>>2]=q;s=c[u>>2]|0;c[f>>2]=c[u+4>>2];c[e+0>>2]=c[f+0>>2];c[u>>2]=hOb(s,q<<3,8,e,0,3653512,370)|0;break}else{c[f>>2]=c[u+4>>2];c[e+0>>2]=c[f+0>>2];s=cOb(q<<3,8,e,0,3653512,352)|0;YEi(s|0,c[u>>2]|0,c[t>>2]<<3|0)|0;c[m>>2]=q;c[u>>2]=s;break}while(0);v=c[t>>2]|0}else v=g;g=(c[u>>2]|0)+(v+-1<<3)|0;c[g>>2]=n;c[g+4>>2]=o;i=d;return}function Qed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Red(a,c[a+68>>2]|0,b,d);i=e;return}function Red(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;h=g;j=e+8|0;k=c[j>>2]|0;l=c[j+4>>2]|0;j=c[e>>2]|0;if((k|0)==0&(l|0)==0){c[f>>2]=0;i=g;return}do if(!j)m=d;else{e=c[b+32>>2]|0;n=c[e+(d<<4)+4>>2]|0;o=c[e+(d<<4)+8>>2]|0;e=o-n>>3;if(!e)p=n;else{q=n;n=e;while(1){e=(n|0)/2|0;if((c[q+(e<<3)>>2]|0)<(j|0)){r=q+(e+1<<3)|0;s=n+-1-e|0}else{r=q;s=e}if(!s){p=r;break}else{q=r;n=s}}}if((p|0)!=(o|0)?(n=(j|0)<(c[p>>2]|0)?o:p,(n|0)!=(o|0)):0){m=c[n+4>>2]|0;break}c[f>>2]=0;i=g;return}while(0);c[h>>2]=m;m=h+8|0;c[m>>2]=k;c[m+4>>2]=l;l=xfd(c[b+44>>2]|0,h)|0;c[f>>2]=l;if((a[b+95>>0]|0)==0|(l|0)==0){i=g;return}iQb(l,1)|0;i=g;return}function Sed(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+40|0;k=f+32|0;l=f;m=e+8|0;n=c[m>>2]|0;o=c[m+4>>2]|0;m=c[d+72>>2]|0;p=c[d+20>>2]|0;q=c[d+32>>2]|0;r=p+(m<<4)+4|0;s=c[r>>2]|0;t=p+(m<<4)+8|0;u=c[t>>2]|0;v=u-s>>3;if(!v)w=s;else{x=c[e>>2]|0;y=s;s=v;while(1){v=(s|0)/2|0;if((c[y+(v<<3)>>2]|0)<(x|0)){z=y+(v+1<<3)|0;A=s+-1-v|0}else{z=y;A=v}if(!A){w=z;break}else{y=z;s=A}}}if((w|0)!=(u|0)?(A=(c[e>>2]|0)<(c[w>>2]|0)?u:w,(A|0)!=(u|0)):0){B=c[A+4>>2]|0;C=b+8|0;c[b>>2]=B;D=C;E=D;c[E>>2]=n;F=D+4|0;G=F;c[G>>2]=o;i=f;return}A=c[(c[d+4>>2]|0)+(m*24|0)>>2]|0;co[c[(c[d>>2]|0)+20>>2]&2047](l,d,c[e>>2]|0);lgd(A,l);d=c[A+84>>2]|0;A=c[r>>2]|0;r=c[t>>2]|0;t=r-A>>3;if(!t)H=A;else{u=c[e>>2]|0;w=A;A=t;while(1){t=(A|0)/2|0;if((c[w+(t<<3)>>2]|0)<(u|0)){I=w+(t+1<<3)|0;J=A+-1-t|0}else{I=w;J=t}if(!J){H=I;break}else{w=I;A=J}}}if((H|0)!=(r|0)){r=c[e>>2]|0;if((r|0)<(c[H>>2]|0)){K=r;L=16}else M=H}else{K=c[e>>2]|0;L=16}if((L|0)==16){c[h>>2]=H;c[j>>2]=K;c[j+4>>2]=0;c[g+0>>2]=c[h+0>>2];zfd(k,p+(m<<4)+4|0,g,j);M=c[k>>2]|0}c[M+4>>2]=d;M=c[e>>2]|0;e=c[q+(m<<4)+4>>2]|0;p=c[q+(m<<4)+8>>2]|0;K=p-e>>3;if(!K)N=e;else{H=e;e=K;while(1){K=(e|0)/2|0;if((c[H+(K<<3)>>2]|0)<(d|0)){O=H+(K+1<<3)|0;P=e+-1-K|0}else{O=H;P=K}if(!P){N=O;break}else{H=O;e=P}}}if((N|0)!=(p|0)?(d|0)>=(c[N>>2]|0):0)Q=N;else{c[h>>2]=N;c[j>>2]=d;c[j+4>>2]=0;c[g+0>>2]=c[h+0>>2];zfd(k,q+(m<<4)+4|0,g,j);Q=c[k>>2]|0}c[Q+4>>2]=M;if(!(a[l>>0]&1)){B=d;C=b+8|0;c[b>>2]=B;D=C;E=D;c[E>>2]=n;F=D+4|0;G=F;c[G>>2]=o;i=f;return}M=c[l+8>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(M,g);B=d;C=b+8|0;c[b>>2]=B;D=C;E=D;c[E>>2]=n;F=D+4|0;G=F;c[G>>2]=o;i=f;return}function Ted(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+16|0;g=e;if(!b){c[d>>2]=0;h=d+8|0;c[h>>2]=0;c[h+4>>2]=0;i=e;return}c[f>>2]=0;h=f+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;j=c[a+44>>2]|0;k=c[j+36>>2]|0;if(((k|0)!=-1?(l=c[j+28>>2]|0,(l|0)<=(b|0)):0)?(c[j+32>>2]|0)>=(b|0):0){c[f>>2]=k;k=(b-l|0)/2|0;l=h;c[l>>2]=k;c[l+4>>2]=((k|0)<0)<<31>>31}else m=7;do if((m|0)==7){k=c[j+16>>2]|0;l=j+16|0;if(k){n=l;o=k;a:while(1){k=o;while(1){if((c[k+16>>2]|0)>=(b|0)){p=k;break}k=c[k+4>>2]|0;if(!k){q=n;break a}}o=c[p>>2]|0;if(!o){q=p;break}else n=p}if((q|0)!=(l|0)?(c[q+16>>2]|0)<=(b|0):0){n=q+24|0;c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];break}}c[f>>2]=-1;n=h;c[n>>2]=0;c[n+4>>2]=0;c[d>>2]=0;n=d+8|0;c[n>>2]=0;c[n+4>>2]=0;i=e;return}while(0);Sed(g,a,f);c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];i=e;return}function Ued(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+160|0;d=b+156|0;e=b+152|0;f=b+8|0;g=b;c[g>>2]=c[153134];c[d+0>>2]=c[g+0>>2];eed(f,d);Ved(a,f);ged(f);ked(f);a=f+144|0;do{g=a;a=a+-16|0;if((c[g+-4>>2]|0)>-1){h=c[a>>2]|0;c[e>>2]=c[g+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[a>>2]=0}}while((a|0)!=(f|0));i=b;return}function Ved(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=b+156|0;g=b+100|0;fed(d,(c[f>>2]|0)-(c[g>>2]|0)|0);h=b+148|0;j=c[h>>2]|0;k=b+152|0;l=c[k>>2]|0;m=j+(l*20|0)|0;a:do if(!l){n=j;o=8}else{p=c[b+128>>2]|0;q=b+104|0;r=b+108|0;s=j;while(1){t=c[s>>2]|0;if((p|0)!=(t|0)){if(!(a[q>>0]|0)){n=s;o=8;break a}if(!(c[g>>2]|0)){n=s;o=8;break a}if((c[r>>2]|0)!=(t|0)){n=s;o=8;break a}}s=s+20|0;if((s|0)==(m|0)){u=j;break}}}while(0);if((o|0)==8)if((n|0)==(m|0))u=j;else{j=b+128|0;o=b+104|0;l=b+108|0;s=n;b:while(1){n=c[s+12>>2]|0;if(n)hed(d,n,c[s+8>>2]|0,(a[s+16>>0]|0)!=0,-1);n=s+20|0;if((n|0)==(m|0))break;r=c[j>>2]|0;q=s;p=n;while(1){n=c[q+20>>2]|0;if((r|0)!=(n|0)){if(!(a[o>>0]|0)){v=p;break}if(!(c[g>>2]|0)){v=p;break}if((c[l>>2]|0)!=(n|0)){v=p;break}}n=q+40|0;if((n|0)==(m|0))break b;else{t=p;p=n;q=t}}if((v|0)==(m|0))break;else s=v}u=c[h>>2]|0}c[k>>2]=32;c[b+164>>2]=16;c[b+160>>2]=6;a[b+168>>0]=0;v=xCi(640)|0;if(!u)w=32;else{ACi(u);w=c[k>>2]|0}c[h>>2]=v;h=v+(w*20|0)|0;if((v|0)==(h|0)){c[f>>2]=0;c[g>>2]=0;i=e;return}w=b+128|0;b=v;do{c[b+0>>2]=c[w+0>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];c[b+12>>2]=c[w+12>>2];c[b+16>>2]=c[w+16>>2];b=b+20|0}while((b|0)!=(h|0));c[f>>2]=0;c[g>>2]=0;i=e;return}function Wed(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;h=g+8|0;j=g;fed(f,e);if(!e){i=g;return}k=b+156|0;l=b+100|0;m=b+148|0;n=b+152|0;o=b+104|0;p=b+108|0;q=b+168|0;r=b+108|0;s=b+96|0;b=0;do{c[j>>2]=c[d+(b<<2)>>2];do if((c[k>>2]|0)!=(c[l>>2]|0)){Afd(h,s,j);t=c[h>>2]|0;u=c[m>>2]|0;if((t|0)==-1){v=c[n>>2]|0;w=u;x=v;y=u+(v*20|0)|0;break}else{w=u;x=c[n>>2]|0;y=u+(t*20|0)|0;break}}else{t=c[m>>2]|0;u=c[n>>2]|0;w=t;x=u;y=t+(u*20|0)|0}while(0);do if((y|0)!=(w+(x*20|0)|0)){u=c[y+12>>2]|0;if(!u){z=w;A=x}else{hed(f,u,c[y+8>>2]|0,(a[y+16>>0]|0)!=0,-1);z=c[m>>2]|0;A=c[n>>2]|0}if((y|0)!=(z+(A*20|0)|0)){if((a[o>>0]|0)!=0?(c[l>>2]|0)!=0:0){u=(c[r>>2]|0)==(c[y>>2]|0);c[y+0>>2]=c[p+0>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];c[y+12>>2]=c[p+12>>2];c[y+16>>2]=c[p+16>>2];if(u)break}else{c[y+0>>2]=c[p+0>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];c[y+12>>2]=c[p+12>>2];c[y+16>>2]=c[p+16>>2]}c[l>>2]=(c[l>>2]|0)+1;a[q>>0]=1}}while(0);b=b+1|0}while((b|0)!=(e|0));i=g;return}function Xed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;f=d+4|0;g=c[a+44>>2]|0;h=c[b+4>>2]|0;j=c[g+36>>2]|0;if(((j|0)!=-1?(k=c[g+28>>2]|0,(h|0)>=(k|0)):0)?(c[g+32>>2]|0)>=(h|0):0){l=(h-k|0)/2|0;m=j;n=l;o=((l|0)<0)<<31>>31}else p=5;do if((p|0)==5){l=c[g+16>>2]|0;j=g+16|0;if(l){k=j;q=l;a:while(1){l=q;while(1){if((c[l+16>>2]|0)>=(h|0)){r=l;break}l=c[l+4>>2]|0;if(!l){s=k;break a}}q=c[r>>2]|0;if(!q){s=r;break}else k=r}if((s|0)!=(j|0)?(c[s+16>>2]|0)<=(h|0):0){k=s+32|0;m=c[s+24>>2]|0;n=c[k>>2]|0;o=c[k+4>>2]|0;break}}Krd(619088,0,3653512,955,1,0,0,0);t=0;i=d;return t|0}while(0);b:do if(((m|0)!=-1?(s=ofd(a,m)|0,h=c[s>>2]|0,(h|0)!=0):0)?fgd(h,n,o)|0:0){h=c[s+16>>2]|0;c:do if(h){r=c[h>>2]|0;g=c[h+8>>2]|0;p=r+(g<<3)|0;d:do if(!g)u=r;else{k=r;while(1){q=k;if((c[q>>2]|0)==(n|0)?(c[q+4>>2]|0)==(o|0):0){u=k;break d}k=k+8|0;if((k|0)==(p|0))break c}}while(0);if((u|0)!=(p|0))break b}while(0);h=c[s>>2]|0;if(h){j=a+68|0;c[j>>2]=m;kgd(h,n,o,1,1,e,f,b);ko[c[(c[b>>2]|0)+16>>2]&4095](b);c[j>>2]=-1;sed(b,3);j=a+156|0;h=a+100|0;if((c[j>>2]|0)==(c[h>>2]|0)){t=1;i=d;return t|0}do{Yed(a);Ued(a)}while((c[j>>2]|0)!=(c[h>>2]|0));t=1;i=d;return t|0}}while(0);Krd(619152,0,3653512,962,1,0,0,0);t=0;i=d;return t|0}function Yed(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[153134]|0;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];h=b+148|0;j=b+152|0;k=b+128|0;l=b+104|0;m=b+100|0;n=b+108|0;o=100;p=hOb(0,400,4,e,0,3653512,370)|0;a:while(1){q=c[h>>2]|0;r=c[j>>2]|0;s=q+(r*20|0)|0;b:do if(!r)t=q;else{u=c[k>>2]|0;v=q;while(1){w=c[v>>2]|0;if((u|0)!=(w|0)){if(!(a[l>>0]|0)){t=v;break b}if(!(c[m>>2]|0)){t=v;break b}if((c[n>>2]|0)!=(w|0)){t=v;break b}}v=v+20|0;if((v|0)==(s|0)){x=p;y=o;break a}}}while(0);if((t|0)==(s|0)){x=p;y=o;break}else{z=t;A=0;B=o;C=p}while(1){if(!(a[z+18>>0]|0)){q=c[z+4>>2]|0;r=A+1|0;v=B&2147483647;do if(r>>>0>v>>>0?(u=B<<1,w=(u|0)==0?1:u,v>>>0<w>>>0):0)if((B|0)>-1){c[f>>2]=g;c[e+0>>2]=c[f+0>>2];D=hOb(C,w<<2,4,e,0,3653512,370)|0;E=w;break}else{c[f>>2]=g;c[e+0>>2]=c[f+0>>2];u=cOb(w<<2,4,e,0,3653512,352)|0;YEi(u|0,C|0,r<<2|0)|0;D=u;E=w;break}else{D=C;E=B}while(0);c[D+(A<<2)>>2]=q;F=E;G=r;H=D}else{F=B;G=A;H=C}v=z+20|0;c:do if((v|0)==(s|0))I=s;else{w=c[k>>2]|0;u=z;J=v;while(1){K=c[u+20>>2]|0;if((w|0)!=(K|0)){if(!(a[l>>0]|0)){I=J;break c}if(!(c[m>>2]|0)){I=J;break c}if((c[n>>2]|0)!=(K|0)){I=J;break c}}K=u+40|0;if((K|0)==(s|0)){I=s;break}else{L=J;J=K;u=L}}}while(0);if((I|0)==((c[h>>2]|0)+((c[j>>2]|0)*20|0)|0)){M=F;N=G;O=H;break}else{z=I;A=G;B=F;C=H}}if(!N){x=O;y=M;break}else P=0;while(1){$ed(b,c[O+(P<<2)>>2]|0)|0;s=P+1|0;if(s>>>0<N>>>0)P=s;else{o=M;p=O;continue a}}}if((y|0)<=-1){i=d;return}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(x,e);i=d;return}function Zed(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+8|0;g=e;c[g>>2]=d;d=b+100|0;do if((c[b+156>>2]|0)!=(c[d>>2]|0)){Afd(f,b+96|0,g);h=c[f>>2]|0;j=c[b+148>>2]|0;if((h|0)==-1){k=c[b+152>>2]|0;l=j;m=k;n=j+(k*20|0)|0;break}else{l=j;m=c[b+152>>2]|0;n=j+(h*20|0)|0;break}}else{h=c[b+148>>2]|0;j=c[b+152>>2]|0;l=h;m=j;n=h+(j*20|0)|0}while(0);if((n|0)==(l+(m*20|0)|0)){o=0;i=e;return o|0}if(!(a[n+17>>0]|0)){o=0;i=e;return o|0}m=c[n+12>>2]|0;do if((n|0)!=(l+((c[b+152>>2]|0)*20|0)|0)){if((a[b+104>>0]|0)!=0?(c[d>>2]|0)!=0:0){f=(c[b+108>>2]|0)==(c[n>>2]|0);g=b+108|0;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];c[n+12>>2]=c[g+12>>2];c[n+16>>2]=c[g+16>>2];if(f)break}else{f=b+108|0;c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];c[n+16>>2]=c[f+16>>2]}c[d>>2]=(c[d>>2]|0)+1;a[b+168>>0]=1}while(0);nQb(m);sed(m,3);o=m;i=e;return o|0}function _ed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;e=Zed(a,b)|0;if(e){f=e;i=d;return f|0}if((c[a+68>>2]|0)!=-1){Krd(619208,0,3653512,1040,1,0,0,0);f=0;i=d;return f|0}e=$ed(a,b)|0;if(!e){f=0;i=d;return f|0}b=a+156|0;g=a+100|0;if((c[b>>2]|0)==(c[g>>2]|0)){f=e;i=d;return f|0}do{Yed(a);Ued(a)}while((c[b>>2]|0)!=(c[g>>2]|0));f=e;i=d;return f|0}function $ed(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+96|0;f=e+16|0;g=e+40|0;h=e+64|0;j=e+48|0;k=e;l=e+36|0;m=e+32|0;n=e+84|0;c[l>>2]=d;o=b+156|0;p=b+100|0;do if((c[o>>2]|0)!=(c[p>>2]|0)){Afd(f,b+96|0,l);q=c[f>>2]|0;r=c[b+148>>2]|0;if((q|0)==-1){s=c[b+152>>2]|0;t=r;u=s;v=r+(s*20|0)|0;break}else{t=r;u=c[b+152>>2]|0;v=r+(q*20|0)|0;break}}else{q=c[b+148>>2]|0;r=c[b+152>>2]|0;t=q;u=r;v=q+(r*20|0)|0}while(0);l=b+148|0;r=b+152|0;if((v|0)!=(t+(u*20|0)|0)?(a[v+18>>0]|0)!=0:0){w=c[v+12>>2]|0;i=e;return w|0}v=c[b+44>>2]|0;u=c[v+36>>2]|0;if(((u|0)!=-1?(t=c[v+28>>2]|0,(t|0)<=(d|0)):0)?(c[v+32>>2]|0)>=(d|0):0){q=(d-t|0)/2|0;x=0;y=u;z=q;A=((q|0)<0)<<31>>31}else B=13;do if((B|0)==13){q=c[v+16>>2]|0;u=v+16|0;if(!q){w=0;i=e;return w|0}else{C=u;D=q}a:while(1){q=D;while(1){if((c[q+16>>2]|0)>=(d|0)){E=q;break}q=c[q+4>>2]|0;if(!q){F=C;break a}}D=c[E>>2]|0;if(!D){F=E;break}else C=E}if((F|0)==(u|0)){w=0;i=e;return w|0}if((c[F+16>>2]|0)>(d|0)){w=0;i=e;return w|0}else{q=F+32|0;x=c[F+28>>2]|0;y=c[F+24>>2]|0;z=c[q>>2]|0;A=c[q+4>>2]|0;break}}while(0);if((y|0)==-1){w=0;i=e;return w|0}F=ofd(b,y)|0;E=c[F>>2]|0;if(!E){w=0;i=e;return w|0}if(!(fgd(E,z,A)|0)){w=0;i=e;return w|0}E=c[F+16>>2]|0;b:do if(E){C=c[E>>2]|0;D=c[E+8>>2]|0;v=C+(D<<3)|0;c:do if(!D)G=C;else{B=C;while(1){q=B;if((c[q>>2]|0)==(z|0)?(c[q+4>>2]|0)==(A|0):0){G=B;break c}B=B+8|0;if((B|0)==(v|0))break b}}while(0);if((G|0)!=(v|0)){w=0;i=e;return w|0}}while(0);G=c[F>>2]|0;if(!G){w=0;i=e;return w|0}c[k>>2]=y;c[k+4>>2]=x;x=k+8|0;c[x>>2]=z;c[x+4>>2]=A;c[g>>2]=d;x=b+96|0;do if((c[o>>2]|0)!=(c[p>>2]|0)){Afd(f,x,g);F=c[f>>2]|0;E=c[l>>2]|0;C=c[r>>2]|0;if((F|0)==-1){H=E;I=C;J=E+(C*20|0)|0;break}else{H=E;I=C;J=E+(F*20|0)|0;break}}else{F=c[l>>2]|0;E=c[r>>2]|0;H=F;I=E;J=F+(E*20|0)|0}while(0);if((J|0)==(H+(I*20|0)|0)){c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];k=afd(b,G,f,d,1)|0;if(!k)K=0;else{c[h>>2]=d;c[h+4>>2]=d;c[h+8>>2]=0;c[h+12>>2]=k;a[h+16>>0]=0;a[h+17>>0]=0;a[h+18>>0]=1;Bfd(j,x,h);K=(c[j+4>>2]|0)+4|0}}else{a[J+18>>0]=1;K=J+4|0}if(!K){w=0;i=e;return w|0}J=b+68|0;c[J>>2]=y;y=c[K+8>>2]|0;kgd(G,z,A,1,1,m,n,y);c[J>>2]=-1;J=c[m>>2]|0;m=a[n>>0]|0;c[g>>2]=d;do if((c[o>>2]|0)!=(c[p>>2]|0)){Afd(f,x,g);d=c[f>>2]|0;n=c[l>>2]|0;if((d|0)==-1){L=n+((c[r>>2]|0)*20|0)|0;break}else{L=n+(d*20|0)|0;break}}else L=(c[l>>2]|0)+((c[r>>2]|0)*20|0)|0;while(0);r=c[L+12>>2]|0;ko[c[(c[r>>2]|0)+16>>2]&4095](r);c[L+8>>2]=J;a[L+16>>0]=m;a[L+17>>0]=1;w=y;i=e;return w|0}function afd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+80|0;j=h+16|0;k=h+32|0;l=h+36|0;m=h+40|0;n=h;o=h+68|0;p=h+28|0;q=h+44|0;r=h+56|0;s=h+24|0;t=n+8|0;u=t;c[u>>2]=0;c[u+4>>2]=0;c[n>>2]=0;u=e+8|0;if(!(jgd(d,c[u>>2]|0,c[u+4>>2]|0,m,n,o)|0)){v=0;i=h;return v|0}u=c[m>>2]|0;c[p>>2]=c[o>>2];c[j+0>>2]=c[p+0>>2];p=yQb(u,f,j,g)|0;if(!p){Isd(r,c[m>>2]|0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;m=a[r>>0]|0;if(!(m&1))w=(m&255)>>>1;else w=c[r+4>>2]|0;Pri(q,619432,32,w+32|0);if(!(a[r>>0]&1))x=r+1|0;else x=c[r+8>>2]|0;Gri(q,x,w)|0;if(!(a[q>>0]&1))y=q+1|0;else y=c[q+8>>2]|0;Krd(y,0,3653512,1185,1,0,0,0);xri(q);xri(r);v=0;i=h;return v|0}r=t;if((c[r>>2]|0)==0&(c[r+4>>2]|0)==0){v=p;i=h;return v|0}r=(da(c[137788]|0,(c[p+8>>2]|0)>>>21)|0)+114|0;t=r>>5;if(!(1<<r-(t<<5)&c[(c[137786]|0)+(t<<2)>>2])){v=p;i=h;return v|0}c[s>>2]=0;Red(b,c[e>>2]|0,n,s);n=c[s>>2]|0;c[k>>2]=n;do if((c[b+156>>2]|0)!=(c[b+100>>2]|0)){Afd(j,b+96|0,k);s=c[j>>2]|0;e=c[b+148>>2]|0;t=c[b+152>>2]|0;if((s|0)==-1){z=e;A=t;B=e+(t*20|0)|0;break}else{z=e;A=t;B=e+(s*20|0)|0;break}}else{s=c[b+148>>2]|0;e=c[b+152>>2]|0;z=s;A=e;B=s+(e*20|0)|0}while(0);if(((B|0)!=(z+(A*20|0)|0)?(A=c[B+12>>2]|0,(A|0)!=0):0)?(B=(da(c[137788]|0,(c[A+8>>2]|0)>>>21)|0)+115|0,z=B>>5,(1<<B-(z<<5)&c[(c[137786]|0)+(z<<2)>>2]|0)!=0):0){c[p+32>>2]=n;C=A;D=36}else D=24;do if((D|0)==24){c[l>>2]=n;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(j,A,l);z=c[j>>2]|0;B=c[A+28>>2]|0;if((z|0)==-1){E=B+(c[A+32>>2]<<3)|0;break}else{E=B+(z<<3)|0;break}}else E=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if((E|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0))F=c[E+4>>2]|0;else F=0}else F=0;if((F|0)!=0?(A=(da(c[137788]|0,(c[F+8>>2]|0)>>>21)|0)+115|0,z=A>>5,(1<<A-(z<<5)&c[(c[137786]|0)+(z<<2)>>2]|0)!=0):0){c[p+32>>2]=n;C=F;D=36;break}c[p+32>>2]=n;G=0;H=0}while(0);if((D|0)==36){G=gad(C)|0;H=C}M9c(p,G,0,H);v=p;i=h;return v|0}function bfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+16|0;g=f;h=f+4|0;c[h>>2]=0;j=h+4|0;c[j>>2]=0;k=h+8|0;c[k>>2]=0;l=c[b+156>>2]|0;m=b+100|0;n=c[m>>2]|0;o=l-n|0;if((l|0)==(n|0)){p=0;q=0}else{if((l|0)==(n|0))r=0;else r=xCi(o<<2)|0;l=r+(o<<2)|0;c[h>>2]=r;c[j>>2]=r;c[k>>2]=l;p=r;q=l}l=c[b+148>>2]|0;r=c[b+152>>2]|0;o=l+(r*20|0)|0;a:do if(!r){s=l;t=11}else{u=c[b+128>>2]|0;v=b+104|0;w=b+108|0;x=l;while(1){y=c[x>>2]|0;if((u|0)!=(y|0)){if((a[v>>0]|0)==0|(n|0)==0){s=x;t=11;break a}if((c[w>>2]|0)!=(y|0)){s=x;t=11;break a}}x=x+20|0;if((x|0)==(o|0)){z=p;A=p;break}}}while(0);if((t|0)==11)if((s|0)==(o|0)){z=p;A=p}else{t=b+128|0;n=b+104|0;l=b+108|0;b=s;s=p;p=q;b:while(1){q=b+4|0;if((s|0)==(p|0))JO(h,q);else{if(s)c[s>>2]=c[q>>2];c[j>>2]=s+4}q=b+20|0;if((q|0)==(o|0))break;r=c[t>>2]|0;x=q;q=b;while(1){w=c[q+20>>2]|0;if((r|0)!=(w|0)){if(!(a[n>>0]|0)){B=x;break}if(!(c[m>>2]|0)){B=x;break}if((c[l>>2]|0)!=(w|0)){B=x;break}}w=q+40|0;if((w|0)==(o|0))break b;else{v=x;x=w;q=v}}if((B|0)==(o|0))break;b=B;s=c[j>>2]|0;p=c[k>>2]|0}z=c[h>>2]|0;A=c[j>>2]|0}JRb(z,A,g);c:do if((e|0)>0){g=c[h>>2]|0;A=c[j>>2]|0;z=A-g>>2;if(!z){k=0;while(1){p=d+(k<<2)|0;if((g|0)!=(A|0)?(c[p>>2]|0)>=(c[g>>2]|0):0)c[p>>2]=0;k=k+1|0;if((k|0)==(e|0))break c}}else C=0;do{k=d+(C<<2)|0;p=c[k>>2]|0;s=g;B=z;while(1){b=(B|0)/2|0;if((c[s+(b<<2)>>2]|0)<(p|0)){D=s+(b+1<<2)|0;E=B+-1-b|0}else{D=s;E=b}if(!E){F=D;break}else{s=D;B=E}}if((F|0)!=(A|0)?(c[k>>2]|0)>=(c[F>>2]|0):0)c[k>>2]=0;C=C+1|0}while((C|0)!=(e|0))}while(0);zQb(d,e);e=c[h>>2]|0;if(!e){i=f;return}h=c[j>>2]|0;if((h|0)!=(e|0))c[j>>2]=h+(~((h+-4-e|0)>>>2)<<2);ACi(e);i=f;return}function cfd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+80|0;f=e+16|0;g=e+72|0;h=e+68|0;j=e+48|0;k=e+32|0;l=e;c[g>>2]=d;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(f,m,g);n=c[f>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0))q=c[p+4>>2]|0;else q=0}else q=0;if(q){r=q;i=e;return r|0}c[g>>2]=d;q=b+156|0;p=b+100|0;do if((c[q>>2]|0)!=(c[p>>2]|0)){Afd(f,b+96|0,g);m=c[f>>2]|0;n=c[b+148>>2]|0;o=c[b+152>>2]|0;if((m|0)==-1){s=n;t=o;u=n+(o*20|0)|0;break}else{s=n;t=o;u=n+(m*20|0)|0;break}}else{m=c[b+148>>2]|0;n=c[b+152>>2]|0;s=m;t=n;u=m+(n*20|0)|0}while(0);if((u|0)!=(s+(t*20|0)|0)?(t=c[u+12>>2]|0,(t|0)!=0):0){r=t;i=e;return r|0}t=c[b+44>>2]|0;u=c[t+36>>2]|0;if(((u|0)!=-1?(s=c[t+28>>2]|0,(s|0)<=(d|0)):0)?(c[t+32>>2]|0)>=(d|0):0){g=(d-s|0)/2|0;v=u;w=g;x=((g|0)<0)<<31>>31;y=0}else z=21;do if((z|0)==21){g=c[t+16>>2]|0;u=t+16|0;if(!g){r=0;i=e;return r|0}else{A=u;B=g}a:while(1){g=B;while(1){if((c[g+16>>2]|0)>=(d|0)){C=g;break}g=c[g+4>>2]|0;if(!g){D=A;break a}}B=c[C>>2]|0;if(!B){D=C;break}else A=C}if((D|0)==(u|0)){r=0;i=e;return r|0}if((c[D+16>>2]|0)>(d|0)){r=0;i=e;return r|0}else{g=D+32|0;v=c[D+24>>2]|0;w=c[g>>2]|0;x=c[g+4>>2]|0;y=c[D+28>>2]|0;break}}while(0);if((v|0)==-1){r=0;i=e;return r|0}D=ofd(b,v)|0;C=c[D>>2]|0;if(!C){r=0;i=e;return r|0}if(!(fgd(C,w,x)|0)){r=0;i=e;return r|0}C=c[D+16>>2]|0;b:do if(C){A=c[C>>2]|0;B=c[C+8>>2]|0;t=A+(B<<3)|0;c:do if(!B)E=A;else{z=A;while(1){g=z;if((c[g>>2]|0)==(w|0)?(c[g+4>>2]|0)==(x|0):0){E=z;break c}z=z+8|0;if((z|0)==(t|0))break b}}while(0);if((E|0)!=(t|0)){r=0;i=e;return r|0}}while(0);E=c[D>>2]|0;if(!E){r=0;i=e;return r|0}c[l>>2]=v;c[l+4>>2]=y;y=l+8|0;c[y>>2]=w;c[y+4>>2]=x;c[h>>2]=d;x=b+96|0;do if((c[q>>2]|0)!=(c[p>>2]|0)){Afd(f,x,h);y=c[f>>2]|0;w=c[b+148>>2]|0;v=c[b+152>>2]|0;if((y|0)==-1){F=w;G=v;H=w+(v*20|0)|0;break}else{F=w;G=v;H=w+(y*20|0)|0;break}}else{y=c[b+148>>2]|0;w=c[b+152>>2]|0;F=y;G=w;H=y+(w*20|0)|0}while(0);if((H|0)==(F+(G*20|0)|0)){c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];l=afd(b,E,f,d,1)|0;if(!l)I=0;else{c[j>>2]=d;c[j+4>>2]=d;c[j+8>>2]=0;c[j+12>>2]=l;a[j+16>>0]=0;a[j+17>>0]=0;a[j+18>>0]=0;Bfd(k,x,j);I=(c[k+4>>2]|0)+4|0}}else I=H+4|0;if(!I){r=0;i=e;return r|0}r=c[I+8>>2]|0;i=e;return r|0}function dfd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=0,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;h=i;i=i+96|0;j=h+16|0;k=h+48|0;l=h+72|0;m=h+56|0;n=h;o=h+36|0;p=h+32|0;q=h+92|0;if(!e){i=h;return}c[o>>2]=0;r=o+4|0;c[r>>2]=0;c[o+8>>2]=0;eWb(o,d,d+(e<<2)|0);bfd(b,c[o>>2]|0,e);if((e|0)>0){d=f+8|0;s=f+12|0;t=b+44|0;u=n+4|0;v=n+8|0;w=b+96|0;x=b+156|0;y=b+100|0;z=b+148|0;A=b+152|0;B=l+4|0;C=l+8|0;D=l+12|0;E=l+16|0;F=l+17|0;G=l+18|0;H=m+4|0;I=b+68|0;J=f+20|0;K=f+16|0;L=f+4|0;M=0;N=0;while(1){O=ea(ea(g[s>>2])+ea(1.0));P=ea(g[d>>2]);Q=O<P?O:P;g[s>>2]=Q;R=c[f>>2]|0;if(R){if(P==ea(0.0))S=ea(1.0);else S=ea(ea(Q*ea(g[L>>2]))/P);g[R>>2]=S}R=c[(c[o>>2]|0)+(N<<2)>>2]|0;a:do if(R){T=c[t>>2]|0;U=c[T+36>>2]|0;if(((U|0)!=-1?(V=c[T+28>>2]|0,(R|0)>=(V|0)):0)?(c[T+32>>2]|0)>=(R|0):0){W=(R-V|0)/2|0;X=M;Y=U;Z=W;_=((W|0)<0)<<31>>31}else{W=c[T+16>>2]|0;U=T+16|0;if(!W){$=M;break}else{aa=U;ba=W}b:while(1){W=ba;while(1){if((c[W+16>>2]|0)>=(R|0)){ca=W;break}W=c[W+4>>2]|0;if(!W){da=aa;break b}}ba=c[ca>>2]|0;if(!ba){da=ca;break}else aa=ca}if((da|0)==(U|0)){$=M;break}if((c[da+16>>2]|0)>(R|0)){$=M;break}W=da+32|0;X=c[da+28>>2]|0;Y=c[da+24>>2]|0;Z=c[W>>2]|0;_=c[W+4>>2]|0}if(((Y|0)!=-1?(W=ofd(b,Y)|0,T=c[W>>2]|0,(T|0)!=0):0)?fgd(T,Z,_)|0:0){T=c[W+16>>2]|0;c:do if(T){V=c[T>>2]|0;fa=c[T+8>>2]|0;ga=V+(fa<<3)|0;d:do if(!fa)ha=V;else{ia=V;while(1){ja=ia;if((c[ja>>2]|0)==(Z|0)?(c[ja+4>>2]|0)==(_|0):0){ha=ia;break d}ia=ia+8|0;if((ia|0)==(ga|0))break c}}while(0);if((ha|0)!=(ga|0)){$=X;break a}}while(0);T=c[W>>2]|0;if(T){c[n>>2]=Y;c[u>>2]=X;U=v;c[U>>2]=Z;c[U+4>>2]=_;c[k>>2]=R;do if((c[x>>2]|0)!=(c[y>>2]|0)){Afd(j,w,k);U=c[j>>2]|0;V=c[z>>2]|0;if((U|0)==-1){fa=c[A>>2]|0;ka=V;la=fa;ma=V+(fa*20|0)|0;break}else{ka=V;la=c[A>>2]|0;ma=V+(U*20|0)|0;break}}else{U=c[z>>2]|0;V=c[A>>2]|0;ka=U;la=V;ma=U+(V*20|0)|0}while(0);if((ma|0)==(ka+(la*20|0)|0)){c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];W=afd(b,T,j,R,1)|0;if(!W)na=0;else{c[l>>2]=R;c[B>>2]=R;c[C>>2]=0;c[D>>2]=W;a[E>>0]=0;a[F>>0]=0;a[G>>0]=1;Bfd(m,w,l);na=(c[H>>2]|0)+4|0}}else{a[ma+18>>0]=1;na=ma+4|0}if(na){c[I>>2]=Y;W=c[na+8>>2]|0;kgd(T,Z,_,1,1,p,q,W);V=c[p>>2]|0;U=a[q>>0]|0;c[k>>2]=R;do if((c[x>>2]|0)!=(c[y>>2]|0)){Afd(j,w,k);fa=c[j>>2]|0;ia=c[z>>2]|0;if((fa|0)==-1){oa=ia+((c[A>>2]|0)*20|0)|0;break}else{oa=ia+(fa*20|0)|0;break}}else oa=(c[z>>2]|0)+((c[A>>2]|0)*20|0)|0;while(0);T=c[oa+12>>2]|0;ko[c[(c[T>>2]|0)+16>>2]&4095](T);c[oa+8>>2]=V;a[oa+16>>0]=U;a[oa+17>>0]=1;c[I>>2]=-1;T=c[J>>2]|0;if(T){In[T&4095](W,c[K>>2]|0);$=X}else $=X}else $=X}else $=X}else $=X}else $=M;while(0);N=N+1|0;if((N|0)>=(e|0))break;else M=$}}Yed(b);b=c[o>>2]|0;if(!b){i=h;return}o=c[r>>2]|0;if((o|0)!=(b|0))c[r>>2]=o+(~((o+-4-b|0)>>>2)<<2);ACi(b);i=h;return}function efd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[b+148>>2]|0;h=c[b+152>>2]|0;j=g+(h*20|0)|0;a:do if(!h)k=g;else{l=c[b+128>>2]|0;m=b+104|0;n=b+100|0;o=b+108|0;p=g;do{q=c[p>>2]|0;if((l|0)!=(q|0)){if(!(a[m>>0]|0)){k=p;break a}if(!(c[n>>2]|0)){k=p;break a}if((c[o>>2]|0)!=(q|0)){k=p;break a}}p=p+20|0}while((p|0)!=(j|0));i=e;return}while(0);if((k|0)==(j|0)){i=e;return}g=b+128|0;h=b+104|0;p=b+100|0;o=b+108|0;b=k;b:while(1){c[f>>2]=c[b>>2];gSc(d,f)|0;k=b+20|0;if((k|0)==(j|0)){r=18;break}n=c[g>>2]|0;m=b;l=k;while(1){k=c[m+20>>2]|0;if((n|0)!=(k|0)){if(!(a[h>>0]|0)){s=l;break}if(!(c[p>>2]|0)){s=l;break}if((c[o>>2]|0)!=(k|0)){s=l;break}}k=m+40|0;if((k|0)==(j|0)){r=18;break b}else{q=l;l=k;m=q}}if((s|0)==(j|0)){r=18;break}else b=s}if((r|0)==18){i=e;return}}function ffd(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=Im,ba=0,ca=Im,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;l=i;i=i+128|0;m=l+32|0;n=l+52|0;o=l+72|0;p=l+96|0;q=l+16|0;r=l+56|0;s=l;t=l+48|0;u=l+112|0;v=xo[c[(c[b>>2]|0)+12>>2]&2047](b,d,1)|0;if((v|0)==-1){w=1;i=l;return w|0}x=c[(ofd(b,v)|0)>>2]|0;if(!x){w=1;i=l;return w|0}y=c[153134]|0;c[r>>2]=0;z=r+4|0;c[z>>2]=y;A=r+8|0;c[A>>2]=0;B=r+12|0;c[B>>2]=0;if((h|0)==-1){Med(b,d,r);d=c[r>>2]|0;C=c[A>>2]|0;D=ea(C|0);A=k+8|0;g[A>>2]=ea(ea(g[A>>2])+D);if(!C){E=d;F=0;G=0;I=0;J=0}else{c[n>>2]=y;c[m+0>>2]=c[n+0>>2];A=hOb(0,C<<2,4,m,0,3653512,370)|0;K=A+(C<<2)|0;L=A;do{if(L)c[L>>2]=0;L=L+4|0}while((L|0)!=(K|0));E=d;F=A;G=C;I=C;J=A}}else{E=e;F=f;G=h;I=0;J=0}h=(G|0)>0;a:do if(j){if(h){f=0;e=0;A=0;while(1){C=E+(A<<3)|0;d=c[C>>2]|0;K=c[C+4>>2]|0;C=(f|0)<(K|0)|(f|0)==(K|0)&e>>>0<d>>>0;L=C?d:e;d=C?K:f;A=A+1|0;if((A|0)==(G|0)){M=L;N=d;break}else{f=d;e=L}}e=cFi(M|0,N|0,1)|0;O=e;P=H}else{O=0;P=0}e=c[b+44>>2]|0;f=e+24|0;A=(c[f>>2]|0)+2|0;L=e+28|0;c[L>>2]=A;d=_Ei(A|0,0,O|0,P|0)|0;c[f>>2]=d;c[e+32>>2]=d;c[e+36>>2]=v;if(h){Q=A;R=0}else{A=b+68|0;c[A>>2]=v;S=A;break}while(1){A=E+(R<<3)|0;e=cFi(c[A>>2]|0,c[A+4>>2]|0,1)|0;A=_Ei(Q|0,0,e|0,H|0)|0;c[F+(R<<2)>>2]=A;A=R+1|0;if((A|0)==(G|0)){T=21;break a}Q=c[L>>2]|0;R=A}}else{if(h){L=b+44|0;A=s+8|0;e=0;do{d=E+(e<<3)|0;f=c[d>>2]|0;K=c[d+4>>2]|0;d=c[L>>2]|0;c[s>>2]=v;C=A;c[C>>2]=f;c[C+4>>2]=K;c[F+(e<<2)>>2]=xfd(d,s)|0;e=e+1|0}while((e|0)<(G|0))}bfd(b,F,G);T=21}while(0);b:do if((T|0)==21){s=b+68|0;c[s>>2]=v;if((G|0)>0){h=b+172|0;R=k+8|0;Q=k+12|0;P=q+8|0;O=b+96|0;N=b+156|0;M=b+100|0;e=b+148|0;A=b+152|0;L=o+4|0;d=o+8|0;K=o+12|0;C=o+16|0;f=o+17|0;U=o+18|0;V=p+4|0;W=j^1;X=k+20|0;Y=k+16|0;Z=k+4|0;_=0;while(1){if(a[h>>0]|0){S=s;break b}D=ea(ea(g[Q>>2])+ea(1.0));$=ea(g[R>>2]);aa=D<$?D:$;g[Q>>2]=aa;ba=c[k>>2]|0;if(ba){if($==ea(0.0))ca=ea(1.0);else ca=ea(ea(aa*ea(g[Z>>2]))/$);g[ba>>2]=ca}ba=c[F+(_<<2)>>2]|0;if(ba){da=TEi(0,c[E+(_<<3)>>2]|0,32)|0;fa=H;c[q>>2]=v;ga=P;c[ga>>2]=da;c[ga+4>>2]=fa;c[n>>2]=ba;do if((c[N>>2]|0)!=(c[M>>2]|0)){Afd(m,O,n);ga=c[m>>2]|0;ha=c[e>>2]|0;if((ga|0)==-1){ia=c[A>>2]|0;ja=ha;ka=ia;la=ha+(ia*20|0)|0;break}else{ja=ha;ka=c[A>>2]|0;la=ha+(ga*20|0)|0;break}}else{ga=c[e>>2]|0;ha=c[A>>2]|0;ja=ga;ka=ha;la=ga+(ha*20|0)|0}while(0);if((la|0)==(ja+(ka*20|0)|0)){c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];c[m+12>>2]=c[q+12>>2];ha=afd(b,x,m,ba,1)|0;if(!ha)ma=0;else{c[o>>2]=ba;c[L>>2]=ba;c[d>>2]=0;c[K>>2]=ha;a[C>>0]=0;a[f>>0]=0;a[U>>0]=1;Bfd(p,O,o);ma=(c[V>>2]|0)+4|0}}else{a[la+18>>0]=1;ma=la+4|0}if(ma){ha=c[ma+8>>2]|0;kgd(x,da,fa,1,W,t,u,ha);ga=c[t>>2]|0;ia=a[u>>0]|0;c[n>>2]=ba;do if((c[N>>2]|0)!=(c[M>>2]|0)){Afd(m,O,n);na=c[m>>2]|0;oa=c[e>>2]|0;if((na|0)==-1){pa=oa+((c[A>>2]|0)*20|0)|0;break}else{pa=oa+(na*20|0)|0;break}}else pa=(c[e>>2]|0)+((c[A>>2]|0)*20|0)|0;while(0);ba=c[pa+12>>2]|0;ko[c[(c[ba>>2]|0)+16>>2]&4095](ba);c[pa+8>>2]=ga;a[pa+16>>0]=ia;a[pa+17>>0]=1;ba=c[X>>2]|0;if(ba)In[ba&4095](ha,c[Y>>2]|0)}}_=_+1|0;if((_|0)>=(G|0)){S=s;break}}}else S=s}while(0);c[S>>2]=-1;Yed(b);if(j){j=c[b+44>>2]|0;c[j+28>>2]=0;c[j+32>>2]=0;c[j+36>>2]=-1}if((I|0)>-1){c[n>>2]=y;c[m+0>>2]=c[n+0>>2];eOb(J,m)}if((c[B>>2]|0)<=-1){w=0;i=l;return w|0}B=c[r>>2]|0;c[o>>2]=c[z>>2];c[m+0>>2]=c[o+0>>2];eOb(B,m);c[r>>2]=0;w=0;i=l;return w|0}function gfd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=c[b+44>>2]|0;g=c[f+36>>2]|0;if(((g|0)!=-1?(h=c[f+28>>2]|0,(h|0)<=(d|0)):0)?(c[f+32>>2]|0)>=(d|0):0){j=(d-h|0)/2|0;k=g;l=j;m=((j|0)<0)<<31>>31}else n=5;do if((n|0)==5){j=c[f+16>>2]|0;g=f+16|0;if(!j){o=0;i=e;return o|0}else{p=g;q=j}a:while(1){j=q;while(1){if((c[j+16>>2]|0)>=(d|0)){r=j;break}j=c[j+4>>2]|0;if(!j){s=p;break a}}q=c[r>>2]|0;if(!q){s=r;break}else p=r}if((s|0)==(g|0)){o=0;i=e;return o|0}if((c[s+16>>2]|0)>(d|0)){o=0;i=e;return o|0}else{j=s+32|0;k=c[s+24>>2]|0;l=c[j>>2]|0;m=c[j+4>>2]|0;break}}while(0);if((k|0)==-1){o=0;i=e;return o|0}s=ofd(b,k)|0;k=c[s>>2]|0;if(!k){o=0;i=e;return o|0}if(!(fgd(k,l,m)|0)){o=0;i=e;return o|0}k=c[s+16>>2]|0;b:do if(k){b=c[k>>2]|0;d=c[k+8>>2]|0;r=b+(d<<3)|0;c:do if(!d)t=b;else{p=b;while(1){q=p;if((c[q>>2]|0)==(l|0)?(c[q+4>>2]|0)==(m|0):0){t=p;break c}p=p+8|0;if((p|0)==(r|0))break b}}while(0);if((t|0)!=(r|0)){o=0;i=e;return o|0}}while(0);t=c[s>>2]|0;if(!t){o=0;i=e;return o|0}s=xQb(ggd(t,l,m)|0)|0;if((s|0)!=0?(a[s+28>>0]|0)==0:0){o=1;i=e;return o|0}o=0;i=e;return o|0}function hfd(a){a=a|0;return}function ifd(a){a=a|0;return}function jfd(a){a=a|0;var b=0,d=0;b=i;d=(c[a+44>>2]|0)+24|0;if((c[d>>2]|0)<1e4)c[d>>2]=1e4;UQb();i=b;return}function kfd(){return c[154868]|0}function lfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+16|0;c[b>>2]=619488;c[b+4>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+8>>2]=60;k=b+20|0;c[b+52>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;c[b+84>>2]=0;c[b+88>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[b+80>>2]=b+84;c[b+100>>2]=0;a[b+104>>0]=0;k=b+105|0;a[k>>0]=0;l=b+108|0;m=l+44|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=b+96|0;m=b+152|0;c[m>>2]=32;c[b+156>>2]=0;c[b+164>>2]=16;c[b+160>>2]=6;a[b+168>>0]=0;c[154868]=b;c[b+76>>2]=d;c[b+64>>2]=e;a[b+95>>0]=0;e=b+68|0;c[e>>2]=-1;c[e+4>>2]=-1;c[h>>2]=c[153100];c[g+0>>2]=c[h+0>>2];h=bOb(40,g,1,16,3653512,1789)|0;e=h+4|0;c[e>>2]=0;c[h+8>>2]=0;c[h>>2]=e;e=h+16|0;c[e>>2]=0;c[h+20>>2]=0;c[h+12>>2]=e;c[h+24>>2]=0;c[h+28>>2]=0;c[h+32>>2]=0;c[h+36>>2]=-1;c[b+44>>2]=h;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;a[k>>0]=1;k=b+128|0;c[b+128>>2]=-1;h=b+132|0;c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[h+12>>2]=c[g+12>>2];g=c[m>>2]|0;m=xCi(g*20|0)|0;c[b+148>>2]=m;h=m+(g*20|0)|0;if((m|0)==(h|0)){c[j>>2]=-2;Cfd(l,j);mgd();n=b+172|0;a[n>>0]=0;i=f;return}else o=m;do{c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[o+16>>2]=c[k+16>>2];o=o+20|0}while((o|0)!=(h|0));c[j>>2]=-2;Cfd(l,j);mgd();n=b+172|0;a[n>>0]=0;i=f;return}function mfd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=619488;g=a+4|0;h=a+12|0;if(c[h>>2]|0){j=c[g>>2]|0;do{k=j+16|0;l=c[k>>2]|0;c[k>>2]=0;k=c[153100]|0;if((l|0)!=0?(c[l+12>>2]|0)>-1:0){m=c[l>>2]|0;c[e>>2]=c[l+4>>2];c[d+0>>2]=c[e+0>>2];eOb(m,d);c[l>>2]=0}c[f>>2]=k;c[d+0>>2]=c[f+0>>2];eOb(l,d);l=c[j>>2]|0;if(l){cgd(l);c[j>>2]=0}j=j+24|0}while((j|0)!=((c[g>>2]|0)+((c[h>>2]|0)*24|0)|0))}h=a+44|0;j=c[h>>2]|0;f=c[153100]|0;if(j){Gfd(j+12|0,c[j+16>>2]|0);Hfd(j,c[j+4>>2]|0)}c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(j,d);c[h>>2]=0;ngd();h=c[a+148>>2]|0;if(h)ACi(h);Dfd(a+80|0,c[a+84>>2]|0);Efd(a+52|0);Ffd(a+32|0);Ffd(a+20|0);if((c[a+16>>2]|0)<=-1){i=b;return}h=c[g>>2]|0;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;i=b;return}function nfd(a){a=a|0;var b=0;b=i;mfd(a);ACi(a);i=b;return}function ofd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+64|0;f=e+52|0;g=e+40|0;h=e+28|0;j=e+24|0;k=e+12|0;l=e;m=b+4|0;n=(c[m>>2]|0)+(d*24|0)|0;if(c[n>>2]|0){o=n;i=e;return o|0}co[c[(c[b>>2]|0)+16>>2]&2047](g,b,d);p=a[g>>0]|0;if(!(p&1))q=(p&255)>>>1;else q=c[g+4>>2]|0;if(!q)r=n;else{q=b+48|0;Ifd(f,q,g);p=b+56|0;s=c[f>>2]|0;if((s|0)==(c[p>>2]|0))sqd(h,g);else sri(h,s+12|0);do if(rqd(h)|0){if(!(a[g>>0]&1))t=g+1|0;else t=c[g+8>>2]|0;if(Gsd(t,619704)|0){if(!(a[g>>0]&1))u=g+1|0;else u=c[g+8>>2]|0;if(Gsd(u,619632)|0)v=0;else w=18}else w=18;if((w|0)==18)v=16777216;c[j>>2]=c[153100];c[f+0>>2]=c[j+0>>2];s=bOb(128,f,1,16,3653512,1907)|0;_fd(s);c[n>>2]=s;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;s=c[n>>2]|0;Ifd(f,q,g);x=c[f>>2]|0;if((x|0)==(c[p>>2]|0))sqd(l,g);else sri(l,x+12|0);x=$fd(s,l,k,7168,c[b+64>>2]|0,v,0,-1)|0;xri(l);if(x){pfd(b,n,d);y=(c[m>>2]|0)+(d*24|0)|0;break}x=c[n>>2]|0;if(x){cgd(x);c[n>>2]=0;y=n}else y=n}else y=n;while(0);xri(h);r=y}xri(g);o=r;i=e;return o|0}function pfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f;n=d+8|0;o=igd(c[d>>2]|0)|0;p=H;q=n;r=c[q>>2]|0;s=c[q+4>>2]|0;q=(s|0)<(p|0)|(s|0)==(p|0)&r>>>0<o>>>0;t=n;c[t>>2]=q?o:r;c[t+4>>2]=q?p:s;s=c[d>>2]|0;d=s+84|0;a:do if(!(c[d>>2]|0))u=b+20|0;else{p=s+80|0;q=s+92|0;t=m+1|0;r=m+12|0;o=b+20|0;n=j+4|0;v=b+32|0;w=j+4|0;x=m+8|0;y=m+4|0;z=0;while(1){A=c[(c[b>>2]|0)+8>>2]|0;B=c[p>>2]|0;C=(z>>>0)%(B>>>0)|0;D=c[c[(c[q>>2]|0)+(((z>>>0)/(B>>>0)|0)<<2)>>2]>>2]|0;B=D+(C<<5)|0;E=a[B>>0]|0;if(!(E&1)){F=(E&255)>>>1;G=B+1|0}else{F=c[D+(C<<5)+4>>2]|0;G=c[D+(C<<5)+8>>2]|0}if(F>>>0>2147483631)break;if(F>>>0<11){a[m>>0]=F<<1;I=t}else{B=F+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];E=cOb(B,16,g,0,3653512,80)|0;c[x>>2]=E;c[m>>2]=B|1;c[y>>2]=F;I=E}YEi(I|0,G|0,F|0)|0;a[I+F>>0]=0;E=D+(C<<5)+12|0;c[r+0>>2]=c[E+0>>2];c[r+4>>2]=c[E+4>>2];c[r+8>>2]=c[E+8>>2];c[r+12>>2]=c[E+12>>2];c[r+16>>2]=c[E+16>>2];E=xo[A&2047](b,m,1)|0;if(a[m>>0]&1){A=c[x>>2]|0;c[l>>2]=58;c[g+0>>2]=c[l+0>>2];eOb(A,g)}z=z+1|0;A=c[o>>2]|0;C=c[A+(e<<4)+4>>2]|0;D=c[A+(e<<4)+8>>2]|0;B=D-C>>3;if(!B)J=C;else{K=C;C=B;while(1){B=(C|0)/2|0;if((c[K+(B<<3)>>2]|0)<(E|0)){L=K+(B+1<<3)|0;M=C+-1-B|0}else{L=K;M=B}if(!M){J=L;break}else{K=L;C=M}}}if((J|0)!=(D|0)?(E|0)>=(c[J>>2]|0):0)N=J;else{c[h>>2]=J;c[j>>2]=E;c[n>>2]=0;c[g+0>>2]=c[h+0>>2];zfd(k,A+(e<<4)+4|0,g,j);N=c[k>>2]|0}c[N+4>>2]=z;C=c[v>>2]|0;K=c[C+(e<<4)+4>>2]|0;B=c[C+(e<<4)+8>>2]|0;O=B-K>>3;if(!O)P=K;else{Q=K;K=O;while(1){O=(K|0)/2|0;if((c[Q+(O<<3)>>2]|0)<(z|0)){R=Q+(O+1<<3)|0;S=K+-1-O|0}else{R=Q;S=O}if(!S){P=R;break}else{Q=R;K=S}}}if((P|0)!=(B|0)?(z|0)>=(c[P>>2]|0):0)T=P;else{c[h>>2]=P;c[j>>2]=z;c[w>>2]=0;c[g+0>>2]=c[h+0>>2];zfd(k,C+(e<<4)+4|0,g,j);T=c[k>>2]|0}c[T+4>>2]=E;if((z|0)==(c[d>>2]|0)){u=o;break a}}ori(m)}while(0);m=c[u>>2]|0;u=c[m+(e<<4)+4>>2]|0;d=c[m+(e<<4)+8>>2]|0;T=d-u>>3;if(!T)U=u;else{P=u;u=T;while(1){T=(u|0)/2|0;if((c[P+(T<<3)>>2]|0)<(e|0)){V=P+(T+1<<3)|0;W=u+-1-T|0}else{V=P;W=T}if(!W){U=V;break}else{P=V;u=W}}}if((U|0)!=(d|0)?(c[U>>2]|0)<=(e|0):0)X=U;else{c[h>>2]=U;c[j>>2]=e;c[j+4>>2]=0;c[g+0>>2]=c[h+0>>2];zfd(k,m+(e<<4)+4|0,g,j);X=c[k>>2]|0}c[X+4>>2]=0;X=c[b+32>>2]|0;b=c[X+(e<<4)+4>>2]|0;m=c[X+(e<<4)+8>>2]|0;U=m-b>>3;if(!U)Y=b;else{d=b;b=U;while(1){U=(b|0)/2|0;if((c[d+(U<<3)>>2]|0)<0){Z=d+(U+1<<3)|0;_=b+-1-U|0}else{Z=d;_=U}if(!_){Y=Z;break}else{d=Z;b=_}}}if((Y|0)!=(m|0)?(c[Y>>2]|0)<=0:0){$=Y;aa=$+4|0;c[aa>>2]=e;i=f;return}c[h>>2]=Y;c[j>>2]=0;c[j+4>>2]=0;c[g+0>>2]=c[h+0>>2];zfd(k,X+(e<<4)+4|0,g,j);$=c[k>>2]|0;aa=$+4|0;c[aa>>2]=e;i=f;return}function qfd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+16|0;l=j+4|0;m=j;n=xo[c[(c[b>>2]|0)+12>>2]&2047](b,d,1)|0;if((n|0)==-1){o=0;i=j;return o|0}p=(c[b+4>>2]|0)+(n*24|0)|0;if(c[p>>2]|0){Krd(619512,0,3653512,1955,1,0,0,0);o=0;i=j;return o|0}if(!(rqd(e)|0)){o=0;i=j;return o|0};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[m>>2]=c[153100];c[k+0>>2]=c[m+0>>2];m=bOb(128,k,1,16,3653512,1964)|0;_fd(m);c[p>>2]=m;q=$fd(m,e,l,7168,c[b+64>>2]|0,f,g,h)|0;h=c[p>>2]|0;if(q){a[h+38>>0]=1;pfd(b,p,n);Jfd(k,b+80|0,d);o=1;i=j;return o|0}if(!h){o=0;i=j;return o|0}cgd(h);c[p>>2]=0;o=0;i=j;return o|0}function rfd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;h=b+12|0;j=c[h>>2]|0;if(!j){k=0;l=0;c[e>>2]=l;m=e+4|0;c[m>>2]=k;Ird(619560,e);i=d;return}n=b+4|0;o=b+20|0;p=b+32|0;b=j;j=0;q=0;r=0;while(1){s=c[n>>2]|0;t=s+(j*24|0)|0;u=c[t>>2]|0;do if(!u){v=b;w=q;x=r}else{if((a[u+37>>0]|0)==0?(a[u+38>>0]|0)==0:0){y=s+(j*24|0)+16|0;z=c[y>>2]|0;if(z){if(c[z+8>>2]|0){v=b;w=q+1|0;x=r;break}c[y>>2]=0;A=c[153100]|0;if((c[z+12>>2]|0)>-1){B=c[z>>2]|0;c[f>>2]=c[z+4>>2];c[e+0>>2]=c[f+0>>2];eOb(B,e);c[z>>2]=0;C=A;D=z}else{C=A;D=z}}else{c[y>>2]=0;C=c[153100]|0;D=0}c[g>>2]=C;c[e+0>>2]=c[g+0>>2];eOb(D,e);y=c[t>>2]|0;if(y){cgd(y);c[t>>2]=0}y=c[o>>2]|0;z=c[y+(j<<4)+4>>2]|0;A=y+(j<<4)+8|0;y=c[A>>2]|0;if((y|0)!=(z|0))c[A>>2]=y+(~((y+-8-z|0)>>>3)<<3);z=c[p>>2]|0;y=c[z+(j<<4)+4>>2]|0;A=z+(j<<4)+8|0;z=c[A>>2]|0;if((z|0)!=(y|0))c[A>>2]=z+(~((z+-8-y|0)>>>3)<<3);v=c[h>>2]|0;w=q;x=r+1|0;break}v=b;w=q+1|0;x=r}while(0);j=j+1|0;if(j>>>0>=v>>>0){k=w;l=x;break}else{b=v;q=w;r=x}}c[e>>2]=l;m=e+4|0;c[m>>2]=k;Ird(619560,e);i=d;return}function sfd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;k=xo[c[(c[a>>2]|0)+12>>2]&2047](a,b,0)|0;if((k|0)==-1){i=e;return}l=c[a+4>>2]|0;m=l+(k*24|0)|0;n=c[m>>2]|0;if(!n){i=e;return}if(d){d=l+(k*24|0)+16|0;l=c[d>>2]|0;c[d>>2]=0;d=c[153100]|0;if((l|0)!=0?(c[l+12>>2]|0)>-1:0){o=c[l>>2]|0;c[g>>2]=c[l+4>>2];c[f+0>>2]=c[g+0>>2];eOb(o,f);c[l>>2]=0}c[h>>2]=d;c[f+0>>2]=c[h+0>>2];eOb(l,f);l=c[m>>2]|0;if(l){p=l;q=8}}else{p=n;q=8}if((q|0)==8){cgd(p);c[m>>2]=0}m=c[a+20>>2]|0;p=c[m+(k<<4)+4>>2]|0;q=m+(k<<4)+8|0;m=c[q>>2]|0;if((m|0)!=(p|0))c[q>>2]=m+(~((m+-8-p|0)>>>3)<<3);p=c[a+32>>2]|0;m=c[p+(k<<4)+4>>2]|0;q=p+(k<<4)+8|0;k=c[q>>2]|0;if((k|0)!=(m|0))c[q>>2]=k+(~((k+-8-m|0)>>>3)<<3);m=a+80|0;Kfd(j,m,b);b=c[j>>2]|0;if((b|0)==(a+84|0)){i=e;return}j=c[b+4>>2]|0;if(!j){k=b;while(1){q=c[k+8>>2]|0;if((c[q>>2]|0)==(k|0)){r=q;break}else k=q}}else{k=j;while(1){j=c[k>>2]|0;if(!j){r=k;break}else k=j}}if((c[m>>2]|0)==(b|0))c[m>>2]=r;r=a+88|0;c[r>>2]=(c[r>>2]|0)+-1;tYb(c[a+84>>2]|0,b);xri(b+16|0);c[g>>2]=30;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function tfd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Lfd(a+80|0,b)|0)==1;i=c;return d|0}function ufd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=xo[c[(c[a>>2]|0)+12>>2]&2047](a,b,0)|0;if((e|0)==-1){f=0;i=d;return f|0}f=(c[(c[a+4>>2]|0)+(e*24|0)>>2]|0)!=0;i=d;return f|0}function vfd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+16|0;g=b;h=a+4|0;j=a+12|0;k=(c[j>>2]|0)+1|0;c[j>>2]=k;l=a+16|0;m=c[l>>2]|0;n=m&2147483647;if(k>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[l>>2]=p;o=c[h>>2]|0;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];c[h>>2]=hOb(o,p*24|0,8,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];o=cOb(p*24|0,8,d,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,(c[j>>2]|0)*24|0)|0;c[l>>2]=p;c[h>>2]=o;break}while(0);q=c[j>>2]|0}else q=k;k=q+-1|0;q=c[h>>2]|0;c[q+(k*24|0)>>2]=0;h=q+(k*24|0)+8|0;c[h>>2]=0;c[h+4>>2]=0;c[q+(k*24|0)+16>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;k=a+24|0;q=c[k>>2]|0;if((q|0)==(c[a+28>>2]|0))Nfd(a+20|0,f);else{if(!q)r=0;else{Mfd(q+4|0,f+4|0);r=c[k>>2]|0}c[k>>2]=r+16}r=a+36|0;k=c[r>>2]|0;f=c[a+40>>2]|0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;if((k|0)==(f|0)){Nfd(a+32|0,g);i=b;return}if(!k)s=0;else{Mfd(k+4|0,g+4|0);s=c[r>>2]|0}c[r>>2]=s+16;i=b;return}function wfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+32|0;h=f+20|0;j=f+8|0;k=a[e>>0]|0;if(!(k&1))l=(k&255)>>>1;else l=c[e+4>>2]|0;k=b+48|0;if(!l){Pfd(k,d)|0;i=f;return}else{sri(h,d);sri(j,e);sri(g,h);e=g+12|0;sri(e,j);Ofd(f,k,g);xri(e);xri(g);xri(j);xri(h);i=f;return}}function xfd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+64|0;f=e+48|0;g=e;h=e+24|0;j=c[d>>2]|0;if((j|0)==-1){k=0;i=e;return k|0}l=c[b+36>>2]|0;if((l|0)!=-1&(l|0)==(j|0)){j=d+8|0;l=cFi(c[j>>2]|0,c[j+4>>2]|0,1)|0;j=_Ei(c[b+28>>2]|0,0,l|0,H|0)|0;k=j;i=e;return k|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=0;Qfd(f,b,g);j=c[f>>2]|0;if(!(a[f+4>>0]|0)){k=c[j+32>>2]|0;i=e;return k|0}l=b+24|0;m=(c[l>>2]|0)+2|0;c[l>>2]=m;c[j+32>>2]=m;j=h+4|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[g+16>>2]=c[h+16>>2];h=b+16|0;d=c[h>>2]|0;do if(d){j=d;while(1){l=c[j+16>>2]|0;if((m|0)<(l|0)){n=c[j>>2]|0;if(!n){o=j;p=j;q=8;break}else{j=n;continue}}if((l|0)>=(m|0)){r=j;q=12;break}l=j+4|0;n=c[l>>2]|0;if(!n){s=l;t=j;q=11;break}else j=n}if((q|0)==8){c[f>>2]=p;u=o;v=p;break}else if((q|0)==11){c[f>>2]=t;u=s;v=t;break}else if((q|0)==12){c[f>>2]=r;u=f;v=r;break}}else{j=b+16|0;c[f>>2]=j;u=j;v=j}while(0);if(c[u>>2]|0){k=m;i=e;return k|0}f=xCi(40)|0;c[f+16>>2]=m;r=f+20|0;c[r+0>>2]=c[g+0>>2];c[r+4>>2]=c[g+4>>2];c[r+8>>2]=c[g+8>>2];c[r+12>>2]=c[g+12>>2];c[r+16>>2]=c[g+16>>2];c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=v;c[u>>2]=f;v=b+12|0;g=c[c[v>>2]>>2]|0;if(!g)w=f;else{c[v>>2]=g;w=c[u>>2]|0}GN(c[h>>2]|0,w);w=b+20|0;c[w>>2]=(c[w>>2]|0)+1;k=m;i=e;return k|0}function yfd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=c[a+16>>2]|0;f=a+16|0;if(!e){i=d;return}else{g=f;h=e}a:while(1){j=h;while(1){if((c[j+16>>2]|0)>=(b|0)){k=j;break}j=c[j+4>>2]|0;if(!j){l=g;break a}}h=c[k>>2]|0;if(!h){l=k;break}else g=k}if((l|0)==(f|0)){i=d;return}if((c[l+16>>2]|0)>(b|0)){i=d;return}b=a+4|0;f=c[b>>2]|0;k=a+4|0;if(f){g=c[l+24>>2]|0;h=l+32|0;j=c[h>>2]|0;m=c[h+4>>2]|0;h=k;n=f;b:while(1){f=n;while(1){o=c[f+16>>2]|0;if((o|0)>=(g|0)){if((o|0)>(g|0)){p=f;break}o=f+24|0;q=c[o+4>>2]|0;if(!((q|0)<(m|0)|((q|0)==(m|0)?(c[o>>2]|0)>>>0<j>>>0:0))){p=f;break}}f=c[f+4>>2]|0;if(!f){r=h;break b}}n=c[p>>2]|0;if(!n){r=p;break}else h=p}if((r|0)!=(k|0)?(p=c[r+16>>2]|0,(g|0)>=(p|0)):0)if((g|0)<=(p|0)?(p=r+24|0,g=c[p+4>>2]|0,(m|0)<(g|0)|((m|0)==(g|0)?j>>>0<(c[p>>2]|0)>>>0:0)):0)s=20;else t=r;else s=20}else s=20;if((s|0)==20)t=k;k=c[l+4>>2]|0;if(!k){s=l;while(1){r=c[s+8>>2]|0;if((c[r>>2]|0)==(s|0)){u=r;break}else s=r}}else{s=k;while(1){k=c[s>>2]|0;if(!k){u=s;break}else s=k}}s=a+12|0;if((c[s>>2]|0)==(l|0))c[s>>2]=u;u=a+20|0;c[u>>2]=(c[u>>2]|0)+-1;tYb(e,l);ACi(l);l=c[t+4>>2]|0;if(!l){e=t;while(1){u=c[e+8>>2]|0;if((c[u>>2]|0)==(e|0)){v=u;break}else e=u}}else{e=l;while(1){l=c[e>>2]|0;if(!l){v=e;break}else e=l}}if((c[a>>2]|0)==(t|0))c[a>>2]=v;v=a+8|0;c[v>>2]=(c[v>>2]|0)+-1;tYb(c[b>>2]|0,t);ACi(t);i=d;return}function zfd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[b>>2]|0;l=k;m=(c[d>>2]|0)-l>>3;d=k+(m<<3)|0;n=b+4|0;o=c[n>>2]|0;p=b+8|0;q=c[p>>2]|0;if(o>>>0<q>>>0){if((d|0)==(o|0)){if(!d)r=0;else{s=e;t=c[s+4>>2]|0;u=d;c[u>>2]=c[s>>2];c[u+4>>2]=t;r=c[n>>2]|0}c[n>>2]=r+8;v=d;c[a>>2]=v;i=f;return}r=o-(k+(m+1<<3))>>3;t=k+(r+m<<3)|0;if(t>>>0<o>>>0){u=o;s=t;while(1){if(!u)w=0;else{x=s;y=c[x+4>>2]|0;z=u;c[z>>2]=c[x>>2];c[z+4>>2]=y;w=c[n>>2]|0}s=s+8|0;y=w+8|0;c[n>>2]=y;if(s>>>0>=o>>>0){A=y;break}else u=y}}else A=o;if(r){r=t;t=o;do{u=t;t=t+-8|0;s=r;r=r+-8|0;c[t>>2]=c[r>>2];c[u+-4>>2]=c[s+-4>>2]}while((r|0)!=(d|0))}if(d>>>0>e>>>0)B=e;else B=A>>>0>e>>>0?e+8|0:e;c[d>>2]=c[B>>2];c[k+(m<<3)+4>>2]=c[B+4>>2];v=d;c[a>>2]=v;i=f;return}B=(o-l>>3)+1|0;if((B|0)<0)vxi(b);l=k;k=q-l|0;if(k>>3>>>0<1073741823){q=k>>2;k=q>>>0<B>>>0?B:q;q=d;B=q-l>>3;if(!k){C=0;D=q;E=0;F=B}else{G=k;H=B;I=q;J=20}}else{q=d;G=2147483647;H=q-l>>3;I=q;J=20}if((J|0)==20){c[h>>2]=30;c[g+0>>2]=c[h+0>>2];C=G;D=I;E=cOb(G<<3,16,g,0,3653512,80)|0;F=H}H=E+(F<<3)|0;G=E+(C<<3)|0;do if((F|0)==(C|0)){if((F|0)>0){K=E+(((F+1|0)/-2|0)+F<<3)|0;L=G;break}I=(F|0)==0?1:F<<1;c[h>>2]=30;c[g+0>>2]=c[h+0>>2];J=cOb(I<<3,16,g,0,3653512,80)|0;q=J+(I>>>2<<3)|0;l=J+(I<<3)|0;if(!E){K=q;L=l}else{c[h>>2]=30;c[g+0>>2]=c[h+0>>2];eOb(E,g);K=q;L=l}}else{K=H;L=G}while(0);if(!K)M=0;else{G=e;e=c[G+4>>2]|0;H=K;c[H>>2]=c[G>>2];c[H+4>>2]=e;M=K}e=c[b>>2]|0;H=D-e|0;G=K+(0-(H>>3)<<3)|0;YEi(G|0,e|0,H|0)|0;H=(c[n>>2]|0)-D|0;YEi(M+8|0,d|0,H|0)|0;d=c[b>>2]|0;c[b>>2]=G;c[n>>2]=M+((H>>3)+1<<3);c[p>>2]=L;if(!d){v=K;c[a>>2]=v;i=f;return}c[j>>2]=30;c[g+0>>2]=c[j+0>>2];eOb(d,g);v=K;c[a>>2]=v;i=f;return}function Afd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=(c[d+56>>2]|0)+-1|0;h=c[e>>2]|0;e=h+2127912214+(h<<12)|0;j=e^-949894596^e>>>19;e=j+374761393+(j<<5)|0;j=e+-744332180^e<<9;e=j+-42973499+(j<<3)|0;j=(e^-1252372727^e>>>16)&g;e=c[d+52>>2]|0;k=c[d+32>>2]|0;l=c[e+(j*20|0)>>2]|0;a:do if((k|0)==(l|0)){m=j;n=5}else{o=d+4|0;p=d+12|0;b:do if(!(a[d+8>>0]|0)){q=l;r=j;s=0;while(1){if((h|0)==(q|0)){t=r;break b}s=s+1|0;u=s+r&g;q=c[e+(u*20|0)>>2]|0;if((k|0)==(q|0)){m=u;n=5;break a}else r=u}}else{r=l;q=-1;s=j;u=0;while(1){if((c[o>>2]|0)!=0?(c[p>>2]|0)==(r|0):0)v=(q|0)==-1?s:q;else if((h|0)==(r|0)){t=s;break b}else v=q;u=u+1|0;w=u+s&g;r=c[e+(w*20|0)>>2]|0;if((k|0)==(r|0)){x=v;y=w;break}else{q=v;s=w}}c[b>>2]=-1;s=b+4|0;if((x|0)==-1){z=y;A=s;break a}c[s>>2]=x;i=f;return}while(0);c[b>>2]=t;c[b+4>>2]=-1;i=f;return}while(0);if((n|0)==5){c[b>>2]=-1;z=m;A=b+4|0}c[A>>2]=z;i=f;return}function Bfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;Rfd(d,1,0);Afd(g,d,e);h=c[g>>2]|0;if((h|0)!=-1){j=c[d+52>>2]|0;k=j+((c[d+56>>2]|0)*20|0)|0;c[b>>2]=d;c[b+4>>2]=j+(h*20|0);c[b+8>>2]=k;a[b+12>>0]=0;i=f;return}k=c[g+4>>2]|0;if(((a[d+8>>0]|0)!=0?(g=d+4|0,h=c[g>>2]|0,(h|0)!=0):0)?(j=c[d+52>>2]|0,(c[d+12>>2]|0)==(c[j+(k*20|0)>>2]|0)):0){c[g>>2]=h+-1;l=j}else{j=d+60|0;c[j>>2]=(c[j>>2]|0)+1;l=c[d+52>>2]|0}j=l+(k*20|0)|0;if(!j)m=l;else{c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];m=c[d+52>>2]|0}e=m+((c[d+56>>2]|0)*20|0)|0;c[b>>2]=d;c[b+4>>2]=m+(k*20|0);c[b+8>>2]=e;a[b+12>>0]=1;i=f;return}function Cfd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im;f=i;i=i+144|0;g=f+112|0;h=f+92|0;j=f+16|0;k=f;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;l=c[e>>2]|0;e=d+4|0;if(!(c[e>>2]|0)){m=d+8|0;n=d+12|0;a[m>>0]=1;c[n>>2]=l;o=n+4|0;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];i=f;return}p=j+4|0;c[p>>2]=0;q=j+8|0;r=d+8|0;a[q>>0]=a[r>>0]|0;s=j+9|0;t=d+9|0;a[s>>0]=a[t>>0]|0;u=j+12|0;v=d+12|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];w=j+32|0;x=d+32|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];c[w+16>>2]=c[x+16>>2];y=j+52|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;a[y+20>>0]=0;Sfd(j,d,0);z=c[e>>2]|0;c[e>>2]=c[p>>2];c[p>>2]=z;z=a[r>>0]|0;p=b[q>>1]|0;a[r>>0]=p;a[q>>0]=z;z=a[t>>0]|0;a[t>>0]=(p&65535)>>>8;a[s>>0]=z;c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];c[g+16>>2]=c[v+16>>2];c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[u+0>>2]=c[g+0>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];c[u+12>>2]=c[g+12>>2];c[u+16>>2]=c[g+16>>2];c[h+0>>2]=c[x+0>>2];c[h+4>>2]=c[x+4>>2];c[h+8>>2]=c[x+8>>2];c[h+12>>2]=c[x+12>>2];c[h+16>>2]=c[x+16>>2];c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[x+12>>2]=c[w+12>>2];c[x+16>>2]=c[w+16>>2];c[w+0>>2]=c[h+0>>2];c[w+4>>2]=c[h+4>>2];c[w+8>>2]=c[h+8>>2];c[w+12>>2]=c[h+12>>2];c[w+16>>2]=c[h+16>>2];h=d+52|0;w=c[h>>2]|0;c[h>>2]=c[y>>2];c[y>>2]=w;y=d+56|0;h=j+56|0;x=c[y>>2]|0;g=c[h>>2]|0;c[y>>2]=g;c[h>>2]=x;h=d+60|0;y=j+60|0;u=c[h>>2]|0;c[h>>2]=c[y>>2];c[y>>2]=u;A=ea(g>>>0);c[d+68>>2]=~~ea(A*ea(.5))>>>0;c[d+64>>2]=~~ea(A*ea(.200000003))>>>0;a[d+72>>0]=0;A=ea(x>>>0);c[j+68>>2]=~~ea(A*ea(.5))>>>0;c[j+64>>2]=~~ea(A*ea(.200000003))>>>0;a[j+72>>0]=0;if(!w){m=r;n=v;a[m>>0]=1;c[n>>2]=l;o=n+4|0;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];i=f;return}ACi(w);m=r;n=v;a[m>>0]=1;c[n>>2]=l;o=n+4|0;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];i=f;return}function Dfd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Dfd(a,c[b>>2]|0);Dfd(a,c[b+4>>2]|0);xri(b+16|0);c[f>>2]=30;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Efd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(!f){i=b;return}g=a+4|0;while(1){h=c[g>>2]|0;if((h|0)==(f|0))break;j=h+-24|0;c[g>>2]=j;xri(h+-12|0);xri(j)}g=c[a>>2]|0;c[e>>2]=30;c[d+0>>2]=c[e+0>>2];eOb(g,d);i=b;return}function Ffd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a>>2]|0;if(!g){i=b;return}h=a+4|0;j=c[h>>2]|0;if((j|0)==(g|0))k=g;else{l=j;while(1){j=l+-16|0;c[h>>2]=j;m=c[l+-12>>2]|0;if(!m)n=j;else{j=l+-8|0;o=c[j>>2]|0;if((o|0)!=(m|0))c[j>>2]=o+(~((o+-8-m|0)>>>3)<<3);c[e>>2]=30;c[d+0>>2]=c[e+0>>2];eOb(m,d);n=c[h>>2]|0}if((n|0)==(g|0))break;else l=n}k=c[a>>2]|0}c[f>>2]=30;c[d+0>>2]=c[f+0>>2];eOb(k,d);i=b;return}function Gfd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Gfd(a,c[b>>2]|0);Gfd(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Hfd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Hfd(a,c[b>>2]|0);Hfd(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Ifd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[d+4>>2]|0;h=d+8|0;d=c[h>>2]|0;do if((d|0)!=(g|0)){j=e+1|0;k=e+8|0;l=g;m=(d-g|0)/24|0;while(1){n=(m|0)/2|0;o=l+(n*24|0)|0;if(!(a[o>>0]&1))p=o+1|0;else p=c[l+(n*24|0)+8>>2]|0;if((Gsd(p,(a[e>>0]&1)==0?j:c[k>>2]|0)|0)<0){q=l+((n+1|0)*24|0)|0;r=m+-1-n|0}else{q=l;r=n}if(!r){s=q;break}else{l=q;m=r}}m=c[h>>2]|0;if((s|0)==(m|0))t=m;else{if(!(a[e>>0]&1))u=e+1|0;else u=c[e+8>>2]|0;if(!(a[s>>0]&1))v=s+1|0;else v=c[s+8>>2]|0;if((Gsd(u,v)|0)<0){t=c[h>>2]|0;break}c[b>>2]=s;i=f;return}}else t=g;while(0);c[b>>2]=t;i=f;return}function Jfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=Tfd(d,j,e)|0;l=c[k>>2]|0;if(l){m=0;n=l;c[b>>2]=n;o=b+4|0;a[o>>0]=m;i=f;return}c[h>>2]=30;c[g+0>>2]=c[h+0>>2];h=cOb(28,16,g,0,3653512,80)|0;sri(h+16|0,e);e=c[j>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=e;c[k>>2]=h;e=c[c[d>>2]>>2]|0;if(!e)p=h;else{c[d>>2]=e;p=c[k>>2]|0}GN(c[d+4>>2]|0,p);p=d+8|0;c[p>>2]=(c[p>>2]|0)+1;m=1;n=h;c[b>>2]=n;o=b+4|0;a[o>>0]=m;i=f;return}function Kfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[d+4>>2]|0;h=d+4|0;do if(g){d=a[e>>0]|0;j=(d&1)==0;k=(d&255)>>>1;d=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;n=j?k:m;o=j?d:l;p=h;q=g;a:while(1){r=q;while(1){s=r+16|0;t=a[s>>0]|0;if(!(t&1)){u=(t&255)>>>1;v=s+1|0}else{u=c[r+20>>2]|0;v=c[r+24>>2]|0}s=FEi(v,o,n>>>0<u>>>0?n:u)|0;if(!s){if(u>>>0>=n>>>0){w=r;break}}else if((s|0)>=0){w=r;break}r=c[r+4>>2]|0;if(!r){x=p;break a}}q=c[w>>2]|0;if(!q){x=w;break}else p=w}if((x|0)!=(h|0)){p=x+16|0;q=j?k:m;n=a[p>>0]|0;o=(n&1)==0;if(o)y=(n&255)>>>1;else y=c[x+20>>2]|0;if(o)z=p+1|0;else z=c[x+24>>2]|0;p=FEi(j?d:l,z,y>>>0<q>>>0?y:q)|0;if(!p){if(q>>>0<y>>>0)break}else if((p|0)<0)break;c[b>>2]=x;i=f;return}}while(0);c[b>>2]=h;i=f;return}function Lfd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[b+4>>2]|0;if(!f){g=0;i=e;return g|0}b=a[d>>0]|0;h=(b&1)==0;j=(b&255)>>>1;b=d+1|0;k=c[d+8>>2]|0;l=c[d+4>>2]|0;d=f;while(1){f=d+16|0;m=h?j:l;n=a[f>>0]|0;o=(n&1)==0;if(o)p=(n&255)>>>1;else p=c[d+20>>2]|0;if(o)q=f+1|0;else q=c[d+24>>2]|0;r=FEi(h?b:k,q,p>>>0<m>>>0?p:m)|0;if(!r)if(m>>>0<p>>>0)s=12;else s=13;else if((r|0)<0)s=12;else s=13;if((s|0)==12){s=0;t=d}else if((s|0)==13){s=0;if(o)u=(n&255)>>>1;else u=c[d+20>>2]|0;n=h?j:l;if(o)v=f+1|0;else v=c[d+24>>2]|0;f=FEi(v,h?b:k,n>>>0<u>>>0?n:u)|0;if(!f){if(u>>>0>=n>>>0){g=1;s=24;break}}else if((f|0)>=0){g=1;s=24;break}t=d+4|0}d=c[t>>2]|0;if(!d){g=0;s=24;break}}if((s|0)==24){i=e;return g|0}return 0}function Mfd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;g=a+4|0;c[g>>2]=0;h=a+8|0;c[h>>2]=0;j=b+4|0;k=(c[j>>2]|0)-(c[b>>2]|0)|0;l=k>>3;if(!l){i=d;return}if((k|0)<0)vxi(a);c[f>>2]=30;c[e+0>>2]=c[f+0>>2];f=cOb(k,16,e,0,3653512,80)|0;c[g>>2]=f;c[a>>2]=f;c[h>>2]=f+(l<<3);l=c[b>>2]|0;b=c[j>>2]|0;if((l|0)==(b|0)){i=d;return}else{m=l;n=f}do{if(!n)o=0;else{f=m;l=c[f+4>>2]|0;j=n;c[j>>2]=c[f>>2];c[j+4>>2]=l;o=c[g>>2]|0}n=o+8|0;c[g>>2]=n;m=m+8|0}while((m|0)!=(b|0));i=d;return}function Nfd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=b+4|0;k=c[b>>2]|0;l=((c[j>>2]|0)-k>>4)+1|0;if((l|0)<0)vxi(b);m=b+8|0;n=k;k=(c[m>>2]|0)-n|0;if(k>>4>>>0<1073741823){o=k>>3;p=o>>>0<l>>>0?l:o}else p=2147483647;o=(c[j>>2]|0)-n>>4;n=h+12|0;c[n>>2]=0;c[h+16>>2]=b+8;if(!p)q=0;else{c[g>>2]=30;c[f+0>>2]=c[g+0>>2];q=cOb(p<<4,16,f,0,3653512,80)|0}c[h>>2]=q;f=q+(o<<4)|0;g=h+8|0;c[g>>2]=f;l=h+4|0;c[l>>2]=f;k=q+(p<<4)|0;c[n>>2]=k;if(f){a[f>>0]=a[d>>0]|0;Mfd(q+(o<<4)+4|0,d+4|0)}d=q+(o+1<<4)|0;c[g>>2]=d;o=c[b>>2]|0;q=c[j>>2]|0;if((q|0)==(o|0)){r=f;s=o;t=d;u=o;v=k;c[b>>2]=r;c[l>>2]=s;c[j>>2]=t;c[g>>2]=u;w=c[m>>2]|0;c[m>>2]=v;c[n>>2]=w;c[h>>2]=s;Ufd(h);i=e;return}else{x=q;y=f}while(1){f=x;x=x+-16|0;a[y+-16>>0]=a[x>>0]|0;Mfd(y+-12|0,f+-12|0);f=(c[l>>2]|0)+-16|0;c[l>>2]=f;if((x|0)==(o|0)){z=f;break}else y=f}r=z;s=c[b>>2]|0;t=c[g>>2]|0;u=c[j>>2]|0;v=c[n>>2]|0;c[b>>2]=r;c[l>>2]=s;c[j>>2]=t;c[g>>2]=u;w=c[m>>2]|0;c[m>>2]=v;c[n>>2]=w;c[h>>2]=s;Ufd(h);i=e;return}function Ofd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d+4>>2]|0;l=d+8|0;m=c[l>>2]|0;if((m|0)!=(k|0)){n=e+1|0;o=e+8|0;p=k;q=(m-k|0)/24|0;while(1){m=(q|0)/2|0;r=p+(m*24|0)|0;if(!(a[r>>0]&1))s=r+1|0;else s=c[p+(m*24|0)+8>>2]|0;if((Gsd(s,(a[e>>0]&1)==0?n:c[o>>2]|0)|0)<0){t=p+((m+1|0)*24|0)|0;u=q+-1-m|0}else{t=p;u=m}if(!u){v=t;break}else{p=t;q=u}}if((v|0)!=(c[l>>2]|0)){if(!(a[e>>0]&1))w=e+1|0;else w=c[e+8>>2]|0;if(!(a[v>>0]&1))x=v+1|0;else x=c[v+8>>2]|0;if((Gsd(w,x)|0)>=0){c[b>>2]=v;a[b+4>>0]=0;i=f;return}else y=v}else y=v}else y=k;c[j>>2]=y;c[g+0>>2]=c[j+0>>2];Vfd(h,d+4|0,g,e);c[b>>2]=c[h>>2];a[b+4>>0]=1;i=f;return}function Pfd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=b+4|0;g=c[f>>2]|0;h=b+8|0;b=c[h>>2]|0;if((b|0)==(g|0)){j=0;i=e;return j|0}k=d+1|0;l=d+8|0;m=g;n=(b-g|0)/24|0;while(1){g=(n|0)/2|0;b=m+(g*24|0)|0;if(!(a[b>>0]&1))o=b+1|0;else o=c[m+(g*24|0)+8>>2]|0;if((Gsd(o,(a[d>>0]&1)==0?k:c[l>>2]|0)|0)<0){p=m+((g+1|0)*24|0)|0;q=n+-1-g|0}else{p=m;q=g}if(!q){r=p;break}else{m=p;n=q}}if((r|0)==(c[h>>2]|0)){j=0;i=e;return j|0}if(!(a[d>>0]&1))s=d+1|0;else s=c[d+8>>2]|0;if(!(a[r>>0]&1))t=r+1|0;else t=c[r+8>>2]|0;if((Gsd(s,t)|0)<0){j=0;i=e;return j|0}t=c[f>>2]|0;f=(r-t|0)/24|0;r=t+(f*24|0)|0;s=f+1|0;f=t+(s*24|0)|0;d=c[h>>2]|0;if((f|0)==(d|0))u=r;else{q=d+-24|0;n=f;p=r;while(1){yri(p,n)|0;yri(p+12|0,n+12|0)|0;n=n+24|0;if((n|0)==(d|0))break;else p=p+24|0}u=t+(((((q-f|0)>>>0)/24|0)+s|0)*24|0)|0}while(1){s=c[h>>2]|0;if((s|0)==(u|0)){j=1;break}f=s+-24|0;c[h>>2]=f;xri(s+-12|0);xri(f)}i=e;return j|0}function Qfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=c[e>>2]|0;l=e+8|0;m=c[l>>2]|0;n=c[l+4>>2]|0;l=j;a:while(1){o=c[l+16>>2]|0;do if((k|0)>=(o|0)){if((k|0)<=(o|0)){p=l+24|0;q=c[p>>2]|0;r=c[p+4>>2]|0;if((n|0)<(r|0)|(n|0)==(r|0)&m>>>0<q>>>0)break;if(!((r|0)<(n|0)|(r|0)==(n|0)&q>>>0<m>>>0)){s=l;t=11;break a}}q=l+4|0;r=c[q>>2]|0;if(!r){u=q;v=l;t=10;break a}else{l=r;continue a}}while(0);o=c[l>>2]|0;if(!o){w=l;x=l;t=7;break}else l=o}if((t|0)==7){c[g>>2]=x;y=w;z=x;break}else if((t|0)==10){c[g>>2]=v;y=u;z=v;break}else if((t|0)==11){c[g>>2]=s;y=g;z=s;break}}else{l=d+4|0;c[g>>2]=l;y=l;z=l}while(0);g=c[y>>2]|0;if(g){A=0;B=g;c[b>>2]=B;C=b+4|0;a[C>>0]=A;i=f;return}g=xCi(40)|0;s=g+16|0;c[s+0>>2]=c[e+0>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];c[s+12>>2]=c[e+12>>2];c[s+16>>2]=c[e+16>>2];c[s+20>>2]=c[e+20>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=z;c[y>>2]=g;z=c[c[d>>2]>>2]|0;if(!z)D=g;else{c[d>>2]=z;D=c[y>>2]|0}GN(c[h>>2]|0,D);D=d+8|0;c[D>>2]=(c[D>>2]|0)+1;A=1;B=g;c[b>>2]=B;C=b+4|0;a[C>>0]=A;i=f;return}function Rfd(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+128|0;h=g+96|0;j=g+76|0;k=g;l=d+72|0;if(a[l>>0]|0)Wfd(d);m=d+56|0;n=c[m>>2]|0;o=c[d+60>>2]|0;if(n>>>0>f>>>0?(o+e|0)>>>0<=(c[d+68>>2]|0)>>>0:0){i=g;return}p=d+60|0;q=o+e|0;r=ea(q>>>0);e=32;while(1){if(e>>>0>=f>>>0?!(r>=ea(ea(e>>>0)*ea(.5))):0){s=e;break}e=e<<1}if(s>>>0<=n>>>0){i=g;return}n=d+4|0;r=ea((q-(c[n>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=f>>>0?!(r>=ea(ea(q>>>0)*ea(.5))):0){t=q;break}q=q<<1}q=k+4|0;c[q>>2]=0;f=k+8|0;s=d+8|0;a[f>>0]=a[s>>0]|0;e=k+9|0;o=d+9|0;a[e>>0]=a[o>>0]|0;u=k+12|0;v=d+12|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];w=k+32|0;x=d+32|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];c[w+16>>2]=c[x+16>>2];y=k+52|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;a[y+20>>0]=0;Sfd(k,d,t);t=c[n>>2]|0;c[n>>2]=c[q>>2];c[q>>2]=t;t=a[s>>0]|0;q=b[f>>1]|0;a[s>>0]=q;a[f>>0]=t;t=a[o>>0]|0;a[o>>0]=(q&65535)>>>8;a[e>>0]=t;c[h+0>>2]=c[v+0>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];c[h+12>>2]=c[v+12>>2];c[h+16>>2]=c[v+16>>2];c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[u+0>>2]=c[h+0>>2];c[u+4>>2]=c[h+4>>2];c[u+8>>2]=c[h+8>>2];c[u+12>>2]=c[h+12>>2];c[u+16>>2]=c[h+16>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];c[j+16>>2]=c[x+16>>2];c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[x+12>>2]=c[w+12>>2];c[x+16>>2]=c[w+16>>2];c[w+0>>2]=c[j+0>>2];c[w+4>>2]=c[j+4>>2];c[w+8>>2]=c[j+8>>2];c[w+12>>2]=c[j+12>>2];c[w+16>>2]=c[j+16>>2];j=d+52|0;w=c[j>>2]|0;c[j>>2]=c[y>>2];c[y>>2]=w;y=k+56|0;j=c[m>>2]|0;x=c[y>>2]|0;c[m>>2]=x;c[y>>2]=j;y=k+60|0;m=c[p>>2]|0;c[p>>2]=c[y>>2];c[y>>2]=m;r=ea(x>>>0);c[d+68>>2]=~~ea(r*ea(.5))>>>0;c[d+64>>2]=~~ea(r*ea(.200000003))>>>0;a[l>>0]=0;r=ea(j>>>0);c[k+68>>2]=~~ea(r*ea(.5))>>>0;c[k+64>>2]=~~ea(r*ea(.200000003))>>>0;a[k+72>>0]=0;if(!w){i=g;return}ACi(w);i=g;return}function Sfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;g=b+52|0;h=b+56|0;c[h>>2]=32;j=b+68|0;c[j>>2]=16;k=b+64|0;c[k>>2]=6;l=b+72|0;a[l>>0]=0;m=xCi(640)|0;n=c[g>>2]|0;if(!n)o=32;else{ACi(n);o=c[h>>2]|0}c[g>>2]=m;n=m+(o*20|0)|0;if((m|0)!=(n|0)){o=b+32|0;p=m;do{c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];c[p+12>>2]=c[o+12>>2];c[p+16>>2]=c[o+16>>2];p=p+20|0}while((p|0)!=(n|0))}n=b+60|0;c[n>>2]=0;c[b+4>>2]=0;p=d+4|0;q=ea(((c[d+60>>2]|0)-(c[p>>2]|0)|0)>>>0);o=32;while(1){if(o>>>0>=e>>>0?(r=ea(o>>>0),s=ea(r*ea(.5)),!(q>=s)):0){t=r;u=s;v=o;break}o=o<<1}o=c[h>>2]|0;if(v>>>0>o>>>0){e=xCi(v*20|0)|0;m=c[g>>2]|0;w=o>>>0>v>>>0?v:o;x=m+(w*20|0)|0;if(!w)y=o;else{w=e;z=m;while(1){c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];c[w+12>>2]=c[z+12>>2];c[w+16>>2]=c[z+16>>2];z=z+20|0;if((z|0)==(x|0))break;else w=w+20|0}y=c[h>>2]|0}w=e+(v*20|0)|0;if((y|0)!=(v|0)){x=b+32|0;z=e+(y*20|0)|0;do{if(z){c[z+0>>2]=c[x+0>>2];c[z+4>>2]=c[x+4>>2];c[z+8>>2]=c[x+8>>2];c[z+12>>2]=c[x+12>>2];c[z+16>>2]=c[x+16>>2]}z=z+20|0}while((z|0)!=(w|0))}ACi(c[g>>2]|0);c[g>>2]=e;c[h>>2]=v;c[j>>2]=~~u>>>0;c[k>>2]=~~ea(t*ea(.200000003))>>>0;a[l>>0]=0;A=v}else A=o;o=d+52|0;v=c[o>>2]|0;l=d+56|0;k=c[l>>2]|0;j=v+(k*20|0)|0;a:do if(k){e=c[d+32>>2]|0;w=c[d+12>>2]|0;if((c[p>>2]|0)!=0&(a[d+8>>0]|0)!=0){z=v;do{x=c[z>>2]|0;if(!((e|0)==(x|0)|(w|0)==(x|0))){B=z;break a}z=z+20|0}while((z|0)!=(j|0));i=f;return}else{z=v;do{if((e|0)!=(c[z>>2]|0)){B=z;break a}z=z+20|0}while((z|0)!=(j|0));i=f;return}}else B=v;while(0);if((B|0)==(j|0)){i=f;return}v=b+32|0;b=d+32|0;k=d+8|0;z=d+12|0;d=A;A=B;while(1){B=d+-1|0;e=c[A>>2]|0;w=e+2127912214+(e<<12)|0;e=w^-949894596^w>>>19;w=e+374761393+(e<<5)|0;e=w+-744332180^w<<9;w=e+-42973499+(e<<3)|0;e=(w^-1252372727^w>>>16)&B;w=c[g>>2]|0;x=c[v>>2]|0;if((x|0)==(c[w+(e*20|0)>>2]|0))C=e;else{y=e;e=0;while(1){e=e+1|0;m=e+y&B;if((x|0)==(c[w+(m*20|0)>>2]|0)){C=m;break}else y=m}}y=w+(C*20|0)|0;if(y){c[y+0>>2]=c[A+0>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];c[y+12>>2]=c[A+12>>2];c[y+16>>2]=c[A+16>>2]}c[n>>2]=(c[n>>2]|0)+1;y=A+20|0;b:do if((y|0)!=(j|0)){x=c[b>>2]|0;B=c[z>>2]|0;if((c[p>>2]|0)!=0&(a[k>>0]|0)!=0){e=A;m=y;while(1){D=c[e+20>>2]|0;if(!((x|0)==(D|0)|(B|0)==(D|0))){E=m;break b}D=e+40|0;if((D|0)==(j|0)){E=j;break}else{F=m;m=D;e=F}}}else{e=A;m=y;while(1){if((x|0)!=(c[e+20>>2]|0)){E=m;break b}B=e+40|0;if((B|0)==(j|0)){E=j;break}else{F=m;m=B;e=F}}}}else E=j;while(0);if((E|0)==((c[o>>2]|0)+((c[l>>2]|0)*20|0)|0))break;d=c[h>>2]|0;A=E}i=f;return}function Tfd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&1)==0;k=(h&255)>>>1;h=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;e=g;while(1){g=e+16|0;n=b?k:m;o=a[g>>0]|0;p=(o&1)==0;if(p)q=(o&255)>>>1;else q=c[e+20>>2]|0;if(p)r=g+1|0;else r=c[e+24>>2]|0;s=FEi(b?h:l,r,q>>>0<n>>>0?q:n)|0;if(!s){if(n>>>0<q>>>0)t=12}else if((s|0)<0)t=12;if((t|0)==12){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=13;break}else{e=s;continue}}if(p)w=(o&255)>>>1;else w=c[e+20>>2]|0;o=b?k:m;if(p)x=g+1|0;else x=c[e+24>>2]|0;g=FEi(x,b?h:l,o>>>0<w>>>0?o:w)|0;if(!g){if(w>>>0>=o>>>0){y=e;t=25;break}}else if((g|0)>=0){y=e;t=25;break}g=e+4|0;o=c[g>>2]|0;if(!o){z=g;A=e;t=24;break}else e=o}if((t|0)==13){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==24){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==25){c[d>>2]=y;j=d;i=f;return j|0}return 0}function Ufd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a+4>>2]|0;h=a+8|0;j=c[h>>2]|0;if((j|0)!=(g|0)){k=j;while(1){j=k+-16|0;c[h>>2]=j;l=c[k+-12>>2]|0;if(!l)m=j;else{j=k+-8|0;n=c[j>>2]|0;if((n|0)!=(l|0))c[j>>2]=n+(~((n+-8-l|0)>>>3)<<3);c[f>>2]=30;c[d+0>>2]=c[f+0>>2];eOb(l,d);m=c[h>>2]|0}if((m|0)==(g|0))break;else k=m}}m=c[a>>2]|0;if(!m){i=b;return}c[e>>2]=30;c[d+0>>2]=c[e+0>>2];eOb(m,d);i=b;return}function Vfd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+20|0;k=f;l=c[b>>2]|0;m=l;n=((c[d>>2]|0)-m|0)/24|0;d=l+(n*24|0)|0;o=b+4|0;p=c[o>>2]|0;q=c[b+8>>2]|0;if(p>>>0<q>>>0)if((d|0)==(p|0)){if(!d)r=0;else{sri(d,e);sri(l+(n*24|0)+12|0,e+12|0);r=c[o>>2]|0}c[o>>2]=r+24;s=d;c[a>>2]=s;i=f;return}else{Xfd(b,d,p,l+((n+1|0)*24|0)|0);if(d>>>0>e>>>0)t=e;else t=(c[o>>2]|0)>>>0>e>>>0?e+24|0:e;yri(d,t)|0;yri(l+(n*24|0)+12|0,t+12|0)|0;s=d;c[a>>2]=s;i=f;return}t=b+8|0;n=((p-m|0)/24|0)+1|0;if((n|0)<0)vxi(b);m=l;l=(q-m|0)/24|0;if(l>>>0<1073741823){q=l<<1;u=q>>>0<n>>>0?n:q}else u=2147483647;q=d-m|0;m=(q|0)/24|0;n=k+12|0;c[n>>2]=0;c[k+16>>2]=t;if(!u)v=0;else{c[h>>2]=30;c[g+0>>2]=c[h+0>>2];v=cOb(u*24|0,16,g,0,3653512,80)|0}c[k>>2]=v;l=v+(m*24|0)|0;p=k+8|0;c[p>>2]=l;o=k+4|0;c[o>>2]=l;c[n>>2]=v+(u*24|0);do if((m|0)==(u|0)){r=(q|0)/24|0;if((q|0)>0){w=v+((m+((r+1|0)/-2|0)|0)*24|0)|0;c[p>>2]=w;c[o>>2]=w;x=w;break}else{w=r<<1;r=(w|0)==0?1:w;c[j+16>>2]=t;c[h>>2]=30;c[g+0>>2]=c[h+0>>2];w=cOb(r*24|0,16,g,0,3653512,80)|0;y=w+((r>>>2)*24|0)|0;c[k>>2]=w;c[j>>2]=v;c[o>>2]=y;c[j+4>>2]=l;c[p>>2]=y;c[j+8>>2]=l;c[n>>2]=w+(r*24|0);c[j+12>>2]=l;Yfd(j);x=y;break}}else x=l;while(0);if(!x)z=0;else{sri(x,e);sri(x+12|0,e+12|0);z=x}c[p>>2]=z+24;z=Zfd(b,k,d)|0;Yfd(k);s=z;c[a>>2]=s;i=f;return}function Wfd(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+128|0;f=e+96|0;g=e+76|0;h=e;j=d+60|0;k=d+4|0;l=(c[j>>2]|0)-(c[k>>2]|0)|0;m=d+64|0;if(l>>>0>=(c[m>>2]|0)>>>0){n=d+72|0;a[n>>0]=0;i=e;return}o=d+56|0;p=c[o>>2]|0;if(p>>>0<=32){n=d+72|0;a[n>>0]=0;i=e;return}q=ea(l>>>0);l=p;while(1){p=l>>>1;if(l>>>0<66){r=p;break}if(q<ea(ea(p>>>0)*ea(.200000003)))l=p;else{r=p;break}}l=h+4|0;c[l>>2]=0;p=h+8|0;s=d+8|0;a[p>>0]=a[s>>0]|0;t=h+9|0;u=d+9|0;a[t>>0]=a[u>>0]|0;v=h+12|0;w=d+12|0;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];x=h+32|0;y=d+32|0;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];c[x+16>>2]=c[y+16>>2];z=h+52|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;a[z+20>>0]=0;Sfd(h,d,r);r=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=r;r=a[s>>0]|0;l=b[p>>1]|0;a[s>>0]=l;a[p>>0]=r;r=a[u>>0]|0;a[u>>0]=(l&65535)>>>8;a[t>>0]=r;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[w+16>>2]=c[v+16>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];c[v+16>>2]=c[f+16>>2];c[g+0>>2]=c[y+0>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];c[g+12>>2]=c[y+12>>2];c[g+16>>2]=c[y+16>>2];c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];c[y+12>>2]=c[x+12>>2];c[y+16>>2]=c[x+16>>2];c[x+0>>2]=c[g+0>>2];c[x+4>>2]=c[g+4>>2];c[x+8>>2]=c[g+8>>2];c[x+12>>2]=c[g+12>>2];c[x+16>>2]=c[g+16>>2];g=d+52|0;x=c[g>>2]|0;c[g>>2]=c[z>>2];c[z>>2]=x;z=h+56|0;g=c[o>>2]|0;y=c[z>>2]|0;c[o>>2]=y;c[z>>2]=g;z=h+60|0;o=c[j>>2]|0;c[j>>2]=c[z>>2];c[z>>2]=o;q=ea(y>>>0);c[d+68>>2]=~~ea(q*ea(.5))>>>0;c[m>>2]=~~ea(q*ea(.200000003))>>>0;a[d+72>>0]=0;q=ea(g>>>0);c[h+68>>2]=~~ea(q*ea(.5))>>>0;c[h+64>>2]=~~ea(q*ea(.200000003))>>>0;a[h+72>>0]=0;if(!x){n=d+72|0;a[n>>0]=0;i=e;return}ACi(x);n=d+72|0;a[n>>0]=0;i=e;return}function Xfd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a+4|0;a=c[g>>2]|0;h=b+(((a-e|0)/24|0)*24|0)|0;if(h>>>0<d>>>0){j=a;k=h;do{if(!j)l=0;else{sri(j,k);sri(j+12|0,k+12|0);l=c[g>>2]|0}k=k+24|0;j=l+24|0;c[g>>2]=j}while(k>>>0<d>>>0)}if((a|0)==(e|0)){i=f;return}else{m=h;n=a}do{a=n;n=n+-24|0;h=m;m=m+-24|0;yri(n,m)|0;yri(a+-12|0,h+-12|0)|0}while((m|0)!=(b|0));i=f;return}function Yfd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+4>>2]|0;g=a+8|0;while(1){h=c[g>>2]|0;if((h|0)==(f|0))break;j=h+-24|0;c[g>>2]=j;xri(h+-12|0);xri(j)}g=c[a>>2]|0;if(!g){i=b;return}c[e>>2]=30;c[d+0>>2]=c[e+0>>2];eOb(g,d);i=b;return}function Zfd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=b+4|0;g=c[f>>2]|0;h=c[a>>2]|0;if((h|0)==(d|0))j=g;else{k=d;l=g;while(1){m=k;k=k+-24|0;sri(l+-24|0,k);sri(l+-12|0,m+-12|0);m=(c[f>>2]|0)+-24|0;c[f>>2]=m;if((k|0)==(h|0)){j=m;break}else l=m}}l=a+4|0;h=c[l>>2]|0;k=b+8|0;if((h|0)==(d|0))n=j;else{j=d;d=c[k>>2]|0;do{if(!d)o=0;else{sri(d,j);sri(d+12|0,j+12|0);o=c[k>>2]|0}j=j+24|0;d=o+24|0;c[k>>2]=d}while((j|0)!=(h|0));n=c[f>>2]|0}h=c[a>>2]|0;c[a>>2]=n;c[f>>2]=h;h=c[l>>2]|0;c[l>>2]=c[k>>2];c[k>>2]=h;h=a+8|0;a=b+12|0;k=c[h>>2]|0;c[h>>2]=c[a>>2];c[a>>2]=k;c[b>>2]=c[f>>2];i=e;return g|0}function _fd(b){b=b|0;var d=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b>>2]=b+4;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=0;c[b+64>>2]=0;c[b+72>>2]=0;c[b+76>>2]=0;c[b+68>>2]=60;d=c[153100]|0;c[b+80>>2]=1024;c[b+84>>2]=0;c[b+88>>2]=d;c[b+92>>2]=0;c[b+100>>2]=0;c[b+104>>2]=0;c[b+96>>2]=60;d=b+112|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[b+124>>2]=1;c[b+12>>2]=0;c[b+16>>2]=0;c[b+56>>2]=0;a[b+37>>0]=0;a[b+39>>0]=0;a[b+38>>0]=0;c[b+48>>2]=-2;c[b+52>>2]=0;a[b+44>>0]=0;c[b+60>>2]=42;c[b+108>>2]=0;return}function $fd(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;i=i+16|0;m=l+4|0;n=l;c[b+12>>2]=j;c[n>>2]=c[153112];c[m+0>>2]=c[n+0>>2];n=bOb(156,m,0,16,3653512,272)|0;Pid(n,d,f,g);g=b+108|0;c[g>>2]=n;if((k|0)==-1){f=mo[c[(c[n>>2]|0)+28>>2]&4095](n)|0;o=f;p=c[g>>2]|0}else{o=k;p=n}c[b+16>>2]=o;o=b+112|0;c[o+0>>2]=c[e+0>>2];c[o+4>>2]=c[e+4>>2];c[o+8>>2]=c[e+8>>2];c[b+40>>2]=h|256;a[b+36>>0]=h>>>9&1;if(!p){q=1;i=l;return q|0}q=agd(b)|0;i=l;return q|0}function agd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d;j=b+16|0;if((c[j>>2]|0)>>>0<20){k=0;i=d;return k|0}l=b+108|0;m=b+12|0;Zid(c[l>>2]|0,h,c[m>>2]|0,20);n=c[h>>2]|0;o=XEi(n|0)|0;c[h>>2]=o;p=h+4|0;q=XEi(c[p>>2]|0)|0;c[p>>2]=q;p=h+8|0;r=c[p>>2]|0;s=XEi(r|0)|0;c[p>>2]=s;t=h+12|0;u=XEi(c[t>>2]|0)|0;c[t>>2]=u;if((n|0)==-1){k=0;i=d;return k|0}if((r|0)==16777216|s>>>0>14){k=0;i=d;return k|0}do if(s>>>0>8)if(u>>>0>q>>>0?1:(q+(c[m>>2]|0)|0)>>>0>(c[j>>2]|0)>>>0){k=0;i=d;return k|0}else{r=a[h+16>>0]|0;a[b+36>>0]=r;v=r;w=q;x=u;y=20;z=o;break}else{r=q-o|0;if(!n){k=0;i=d;return k|0}t=c[m>>2]|0;if(r>>>0>q>>>0?1:(t+q|0)>>>0>(c[j>>2]|0)>>>0){k=0;i=d;return k|0}else{A=b+36|0;Zid(c[l>>2]|0,A,t+r|0,1);v=a[A>>0]|0;w=r;x=0;y=r+1|0;z=o+-1|0;break}}while(0);if((v&255)>=2){k=0;i=d;return k|0}v=c[153100]|0;if(!z){B=0;C=0}else{c[f>>2]=v;c[e+0>>2]=c[f+0>>2];B=hOb(0,z,1,e,0,3653512,370)|0;C=z}Zid(c[l>>2]|0,B,(c[m>>2]|0)+y|0,z);y=c[p>>2]|0;if(!(a[b+36>>0]|0))D=pgd(b,y,x,B,z,w)|0;else D=qgd(b,y,x,B,z,w)|0;do if(D){if((c[p>>2]|0)<=10?!(dgd(b)|0):0){E=0;break}egd(b);E=1}else E=0;while(0);if((C|0)<=-1){k=E;i=d;return k|0}c[g>>2]=v;c[e+0>>2]=c[g+0>>2];eOb(B,e);k=E;i=d;return k|0}function bgd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+108|0;g=c[f>>2]|0;h=c[153112]|0;if(g)ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;rgd(a+80|0);if((c[a+104>>2]|0)>-1){f=a+92|0;g=c[f>>2]|0;c[e>>2]=c[a+96>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+76>>2]|0)>-1){f=a+64|0;g=c[f>>2]|0;c[e>>2]=c[a+68>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=c[a+24>>2]|0;if(!f){j=a+4|0;k=c[j>>2]|0;sgd(a,k);i=b;return}d=a+28|0;g=c[d>>2]|0;if((g|0)!=(f|0))c[d>>2]=g+(~(((g+-24-f|0)>>>0)/24|0)*24|0);ACi(f);j=a+4|0;k=c[j>>2]|0;sgd(a,k);i=b;return}function cgd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+124|0;c[f>>2]=(c[f>>2]|0)+-1;if(c[f>>2]|0){i=b;return}f=c[153100]|0;bgd(a);c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function dgd(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;i=i+32|0;f=e+8|0;g=e;h=e+24|0;j=e+16|0;k=d+24|0;l=c[k>>2]|0;m=d+28|0;n=c[m>>2]|0;if((l|0)==(n|0)){o=1;i=e;return o|0}p=d+4|0;q=d+4|0;r=d+72|0;s=d+76|0;t=d+64|0;u=d+68|0;v=j+4|0;w=d+12|0;x=d+108|0;y=d+36|0;d=c[142254]|0;z=c[142256]|0;A=z>>>0<=620384>>>0|d>>>0>620384>>>0;B=h+4|0;C=l;l=n;a:while(1){if((b[C+20>>1]|0)==114){n=C;D=c[n>>2]|0;E=c[n+4>>2]|0;n=c[k>>2]|0;if((l|0)==(n|0)){F=20;break}G=n;H=(l-n|0)/24|0;while(1){n=(H|0)/2|0;I=G+(n*24|0)|0;J=c[I+4>>2]|0;if((J|0)<(E|0)|((J|0)==(E|0)?(c[I>>2]|0)>>>0<D>>>0:0)){K=G+((n+1|0)*24|0)|0;L=H+-1-n|0}else{K=G;L=n}if(!L){M=K;break}else{G=K;H=L}}if((M|0)==(l|0)){F=20;break}H=M;G=c[H+4>>2]|0;n=(G|0)>(E|0)|((G|0)==(E|0)?(c[H>>2]|0)>>>0>D>>>0:0)?l:M;if((n|0)==(l|0)){F=20;break}H=c[p>>2]|0;if(!H){F=20;break}G=c[n+16>>2]|0;n=q;I=H;b:while(1){H=I;while(1){if((c[H+16>>2]|0)>=(G|0)){N=H;break}H=c[H+4>>2]|0;if(!H){O=n;break b}}I=c[N>>2]|0;if(!I){O=N;break}else n=N}if((O|0)==(q|0)){F=20;break}if((G|0)<(c[O+16>>2]|0)){F=20;break}n=c[O+60>>2]|0;if(!n){F=20;break}I=c[r>>2]|0;b[C+22>>1]=I;D=I+1|0;c[r>>2]=D;I=c[s>>2]|0;E=I&2147483647;do if(D>>>0>E>>>0?(H=I<<1,J=(H|0)==0?1:H,E>>>0<J>>>0):0)if((I|0)>-1){c[s>>2]=J;H=c[t>>2]|0;c[g>>2]=c[u>>2];c[f+0>>2]=c[g+0>>2];c[t>>2]=hOb(H,J<<4,8,f,0,3653512,370)|0;break}else{c[g>>2]=c[u>>2];c[f+0>>2]=c[g+0>>2];H=cOb(J<<4,8,f,0,3653512,352)|0;YEi(H|0,c[t>>2]|0,c[r>>2]<<4|0)|0;c[s>>2]=J;c[t>>2]=H;break}while(0);c[j>>2]=n;c[v>>2]=0;I=(c[w>>2]|0)+(c[C+8>>2]|0)|0;E=c[x>>2]|0;D=(a[y>>0]|0)==0;G=(c[r>>2]|0)+-1|0;H=c[t>>2]|0;cid(f,j);if(!(c[f>>2]|0)){F=39;break}else P=0;c:while(1){if((c[($hd(f)|0)+12>>2]|0)==-1){F=39;break a}J=aid(f)|0;do if(J)if(z>>>0<=J>>>0|d>>>0>J>>>0|A)if(!(HEi(620384,J)|0)){Q=P;break c}else break;else if((J|0)==620384){Q=P;break c}else break;while(0);J=(c[($hd(f)|0)+12>>2]|0)+P|0;if(!(c[($hd(f)|0)+20>>2]&16384))R=J;else R=J+3&-4;did(g,f);J=g;S=c[J>>2]|0;T=c[J+4>>2]|0;J=f;c[J>>2]=S;c[J+4>>2]=T;if(!S){F=39;break a}else P=R}Zid(E,h,I+Q|0,8);n=c[h>>2]|0;if(D){U=n;V=c[B>>2]|0}else{S=XEi(n|0)|0;c[h>>2]=S;n=XEi(c[B>>2]|0)|0;c[B>>2]=n;U=S;V=n}c[H+(G<<4)>>2]=U;n=H+(G<<4)+8|0;c[n>>2]=V;c[n+4>>2]=((V|0)<0)<<31>>31;W=c[m>>2]|0}else W=l;C=C+24|0;if((C|0)==(W|0)){o=1;F=41;break}else l=W}if((F|0)==20){Krd(619672,0,3653512,1281,1,0,0,0);o=0;i=e;return o|0}else if((F|0)==39){Krd(619672,0,3653512,1289,1,0,0,0);o=0;i=e;return o|0}else if((F|0)==41){i=e;return o|0}return 0}function egd(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[d+24>>2]|0;g=d+28|0;if((f|0)==(c[g>>2]|0)){i=e;return}h=d+64|0;j=d+80|0;k=d+92|0;d=f;do{f=d+20|0;l=b[f>>1]|0;if(l<<16>>16==114){m=d+22|0;n=b[m>>1]|0;if(n<<16>>16!=-1?(o=n<<16>>16,n=c[h>>2]|0,p=c[n+(o<<4)>>2]|0,(p|0)>=1):0){q=n+(o<<4)+8|0;o=c[q>>2]|0;n=c[q+4>>2]|0;q=p+-1|0;p=c[j>>2]|0;r=(q>>>0)%(p>>>0)|0;s=c[c[(c[k>>2]|0)+(((q>>>0)/(p>>>0)|0)<<2)>>2]>>2]|0;p=s+(r<<5)|0;if(!(a[p>>0]&1))t=p+1|0;else t=c[s+(r<<5)+8>>2]|0;p=(Fsd(t,619704)|0)==0;if((o|0)==12e3&(n|0)==0){if(((c[s+(r<<5)+16>>2]|0)==0?(c[s+(r<<5)+20>>2]|0)==0:0)?(c[s+(r<<5)+24>>2]|0)==14:0)u=(c[s+(r<<5)+28>>2]|0)==0;else u=0;if(u|p){b[f>>1]=218;b[m>>1]=-1}}}}else{m=l<<16>>16;if((m|0)==1012)v=1011;else if((m|0)==245)v=272;else if((m|0)==241)v=240;else if((m|0)==243)v=273;else v=l;b[f>>1]=v}d=d+24|0}while((d|0)!=(c[g>>2]|0));i=e;return}function fgd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[a+24>>2]|0;g=c[a+28>>2]|0;if((g|0)==(f|0))h=f;else{a=f;j=(g-f|0)/24|0;while(1){f=(j|0)/2|0;k=a+(f*24|0)|0;l=c[k+4>>2]|0;if((l|0)<(d|0)|((l|0)==(d|0)?(c[k>>2]|0)>>>0<b>>>0:0)){m=a+((f+1|0)*24|0)|0;n=j+-1-f|0}else{m=a;n=f}if(!n){h=m;break}else{a=m;j=n}}}if((h|0)==(g|0)){o=g;p=(o|0)!=(g|0);i=e;return p|0}n=h;j=c[n+4>>2]|0;o=(j|0)>(d|0)|((j|0)==(d|0)?(c[n>>2]|0)>>>0>b>>>0:0)?g:h;p=(o|0)!=(g|0);i=e;return p|0}function ggd(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[a+24>>2]|0;h=c[a+28>>2]|0;if((h|0)==(g|0))j=g;else{a=g;k=(h-g|0)/24|0;while(1){g=(k|0)/2|0;l=a+(g*24|0)|0;m=c[l+4>>2]|0;if((m|0)<(e|0)|((m|0)==(e|0)?(c[l>>2]|0)>>>0<d>>>0:0)){n=a+((g+1|0)*24|0)|0;o=k+-1-g|0}else{n=a;o=g}if(!o){j=n;break}else{a=n;k=o}}}if((j|0)==(h|0)){p=h;q=p+20|0;r=b[q>>1]|0;s=r<<16>>16;i=f;return s|0}o=j;k=c[o+4>>2]|0;p=(k|0)>(e|0)|((k|0)==(e|0)?(c[o>>2]|0)>>>0>d>>>0:0)?h:j;q=p+20|0;r=b[q>>1]|0;s=r<<16>>16;i=f;return s|0}function hgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+28|0;j=a+24|0;a=((c[h>>2]|0)-(c[j>>2]|0)|0)/24|0;k=d+12|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<a>>>0)if((l|0)>-1){c[k>>2]=a;m=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(m,a<<3,8,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];m=cOb(a<<3,8,f,0,3653512,352)|0;YEi(m|0,c[d>>2]|0,c[d+8>>2]<<3|0)|0;c[k>>2]=a;c[d>>2]=m;break}while(0);a=c[j>>2]|0;if((a|0)==(c[h>>2]|0)){i=e;return}j=d+8|0;l=d+4|0;m=a;do{a=xQb(b[m+20>>1]|0)|0;if((a|0)!=0?(c[a+4>>2]|0)!=0:0){a=m;n=c[a>>2]|0;o=c[a+4>>2]|0;a=(c[j>>2]|0)+1|0;c[j>>2]=a;p=c[k>>2]|0;q=p&2147483647;if(a>>>0>q>>>0){r=p<<1;s=(r|0)==0?1:r;do if(q>>>0<s>>>0)if((p|0)>-1){c[k>>2]=s;r=c[d>>2]|0;c[g>>2]=c[l>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(r,s<<3,8,f,0,3653512,370)|0;break}else{c[g>>2]=c[l>>2];c[f+0>>2]=c[g+0>>2];r=cOb(s<<3,8,f,0,3653512,352)|0;YEi(r|0,c[d>>2]|0,c[j>>2]<<3|0)|0;c[k>>2]=s;c[d>>2]=r;break}while(0);t=c[j>>2]|0}else t=a;s=(c[d>>2]|0)+(t+-1<<3)|0;c[s>>2]=n;c[s+4>>2]=o}m=m+24|0}while((m|0)!=(c[h>>2]|0));i=e;return}function igd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+28>>2]|0;if((c[a+24>>2]|0)==(d|0)){e=0;f=0;H=e;i=b;return f|0}a=d+-24|0;e=c[a+4>>2]|0;f=c[a>>2]|0;H=e;i=b;return f|0}function jgd(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;k=c[a+24>>2]|0;l=c[a+28>>2]|0;if((l|0)==(k|0))m=k;else{n=k;o=(l-k|0)/24|0;while(1){k=(o|0)/2|0;p=n+(k*24|0)|0;q=c[p+4>>2]|0;if((q|0)<(e|0)|((q|0)==(e|0)?(c[p>>2]|0)>>>0<d>>>0:0)){r=n+((k+1|0)*24|0)|0;s=o+-1-k|0}else{r=n;s=k}if(!s){m=r;break}else{n=r;o=s}}}if((m|0)==(l|0)){t=0;i=j;return t|0}s=m;o=c[s+4>>2]|0;r=(o|0)>(e|0)|((o|0)==(e|0)?(c[s>>2]|0)>>>0>d>>>0:0)?l:m;if((r|0)==(l|0)){t=0;i=j;return t|0}c[f>>2]=b[r+20>>1];f=g+8|0;c[f>>2]=0;c[f+4>>2]=0;c[g>>2]=-1;f=b[r+22>>1]|0;if(f<<16>>16!=-1){r=(c[a+64>>2]|0)+(f<<16>>16<<4)|0;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2]}c[h>>2]=c[a+60>>2];t=1;i=j;return t|0}function kgd(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;m=i;i=i+240|0;n=m+168|0;o=m+24|0;p=m+16|0;q=m+8|0;r=m;a[k>>0]=0;s=c[d+24>>2]|0;t=c[d+28>>2]|0;if((t|0)==(s|0))u=s;else{v=s;w=(t-s|0)/24|0;while(1){s=(w|0)/2|0;x=v+(s*24|0)|0;y=c[x+4>>2]|0;if((y|0)<(f|0)|((y|0)==(f|0)?(c[x>>2]|0)>>>0<e>>>0:0)){z=v+((s+1|0)*24|0)|0;A=w+-1-s|0}else{z=v;A=s}if(!A){u=z;break}else{v=z;w=A}}}if((u|0)==(t|0)){i=m;return}A=u;w=c[A+4>>2]|0;z=(w|0)>(f|0)|((w|0)==(f|0)?(c[A>>2]|0)>>>0>e>>>0:0)?t:u;if((z|0)==(t|0)){i=m;return}t=z+16|0;u=d+4|0;e=c[u>>2]|0;do if(e){A=c[t>>2]|0;f=e;while(1){w=c[f+16>>2]|0;if((A|0)<(w|0)){v=c[f>>2]|0;if(!v){B=f;C=f;D=12;break}else{f=v;continue}}if((w|0)>=(A|0)){E=f;D=16;break}w=f+4|0;v=c[w>>2]|0;if(!v){F=w;G=f;D=15;break}else f=v}if((D|0)==12){c[n>>2]=C;H=B;I=C;break}else if((D|0)==15){c[n>>2]=G;H=F;I=G;break}else if((D|0)==16){c[n>>2]=E;H=n;I=E;break}}else{f=d+4|0;c[n>>2]=f;H=f;I=f}while(0);E=c[H>>2]|0;if(!E){G=xCi(72)|0;c[G+16>>2]=c[t>>2];F=G+64|0;J=G+24|0;K=J+40|0;do{c[J>>2]=0;J=J+4|0}while((J|0)<(K|0));c[F>>2]=-1;c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=I;c[H>>2]=G;I=c[c[d>>2]>>2]|0;if(!I)L=G;else{c[d>>2]=I;L=c[H>>2]|0}GN(c[u>>2]|0,L);L=d+8|0;c[L>>2]=(c[L>>2]|0)+1;M=G}else M=E;if((a[d+44>>0]|0)!=0?(E=M+64|0,(c[E>>2]|0)==-1?((c[l+8>>2]|0)>>>21|0)==(c[t>>2]|0):0):0){c[p>>2]=c[153128];c[n+0>>2]=c[p+0>>2];p=bOb(48,n,0,16,3653512,1671)|0;hid(p);Vhd(l,p,c[d+40>>2]|8192);t=c[M+60>>2]|0;if((t|0)!=0&(p|0)!=0?(c[n>>2]=t,c[n+4>>2]=0,c[o>>2]=p,c[o+4>>2]=0,pid(n,o)|0):0)N=0;else N=1;c[E>>2]=N;N=c[153128]|0;if(p)ogd(p);c[o>>2]=N;c[n+0>>2]=c[o+0>>2];eOb(p,n)}p=d+40|0;N=d+36|0;E=((a[N>>0]|0)!=0?513:1)|c[p>>2];t=(g|0)==1?E|8388608:E;tQb(l,h);h=z+8|0;E=d+12|0;g=(c[E>>2]|0)+(c[h>>2]|0)|0;G=M+60|0;if((c[G>>2]|0)!=0?(c[M+64>>2]|0)!=0:0){c[o>>2]=0;c[o+4>>2]=0;tid(o+12|0);c[o+72>>2]=0;c[o+76>>2]=0;J=o+88|0;K=J+48|0;do{c[J>>2]=0;J=J+4|0}while((J|0)<(K|0));c[q>>2]=c[G>>2];c[q+4>>2]=0;J=z+12|0;K=c[J>>2]|0;c[r>>2]=VQb(l)|0;c[n+0>>2]=c[r+0>>2];r=ndd(o,q,g,K,t,n)|0;uid(r,c[d+108>>2]|0,g,c[J>>2]|0);ko[c[(c[l>>2]|0)+24>>2]&4095](l);In[c[(c[l>>2]|0)+84>>2]&4095](l,o);K=(wid(r)|0)-g|0;r=c[J>>2]|0;if((K|0)>(r|0))tgd(b[z+20>>1]|0,r,K);a[k>>0]=1;odd(o)}else D=35;do if((D|0)==35)if(!(a[N>>0]|0)){c[n>>2]=0;o=n+4|0;c[o>>2]=0;k=n+12|0;tid(k);c[n+8>>2]=VQb(l)|0;c[o>>2]=0;c[n>>2]=t;o=z+12|0;uid(k,c[d+108>>2]|0,(c[E>>2]|0)+(c[h>>2]|0)|0,c[o>>2]|0);vid(k,d+112|0);In[c[(c[l>>2]|0)+68>>2]&4095](l,n);K=(wid(k)|0)-g|0;k=c[o>>2]|0;if((K|0)!=(k|0))tgd(b[z+20>>1]|0,k,K);break}else{c[n>>2]=0;K=n+4|0;c[K>>2]=0;k=n+12|0;tid(k);c[n+8>>2]=VQb(l)|0;c[K>>2]=0;c[n>>2]=t;K=z+12|0;uid(k,c[d+108>>2]|0,g,c[K>>2]|0);In[c[(c[l>>2]|0)+80>>2]&4095](l,n);o=(wid(k)|0)-g|0;k=c[K>>2]|0;if((o|0)!=(k|0))tgd(b[z+20>>1]|0,k,o);break}while(0);c[j>>2]=c[G>>2];if(!(c[p>>2]&16777216)){i=m;return}p=l+8|0;c[p>>2]=c[p>>2]|1032192;i=m;return}function lgd(a,b){a=a|0;b=b|0;var c=0;c=i;ugd(a+80|0,b);i=c;return}function mgd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;b=c[142268]|0;d=c[142264]|0;ldd(b,d,2642);ldd(d,b,2643);d=c[142270]|0;ldd(d,b,2644);b=c[142300]|0;ldd(b,b,2645);e=c[142290]|0;ldd(b,e,2646);ldd(b,d,2647);f=c[142304]|0;ldd(b,f,2648);g=c[142296]|0;ldd(b,g,2649);h=c[142286]|0;ldd(b,h,2650);j=c[142302]|0;ldd(b,j,2651);k=c[142292]|0;ldd(b,k,2652);l=c[142258]|0;ldd(b,l,2653);ldd(d,b,2654);ldd(d,e,2655);ldd(d,d,2656);ldd(d,f,2657);ldd(d,g,2658);ldd(d,h,2659);ldd(d,j,2660);ldd(d,k,2661);ldd(d,l,2662);ldd(f,b,2663);ldd(f,e,2664);ldd(f,d,2665);ldd(f,f,2666);ldd(f,g,2667);ldd(f,h,2668);ldd(f,j,2669);ldd(f,k,2670);ldd(f,l,2671);ldd(g,b,2672);ldd(g,e,2673);ldd(g,d,2674);ldd(g,f,2675);ldd(g,g,2676);ldd(g,h,2677);ldd(g,j,2678);ldd(g,k,2679);ldd(g,l,2680);ldd(h,b,2681);ldd(h,e,2682);ldd(h,d,2683);ldd(h,f,2684);ldd(h,g,2685);ldd(h,h,2686);ldd(h,j,2687);ldd(h,k,2688);ldd(h,l,2689);ldd(j,b,2690);ldd(j,e,2691);ldd(j,d,2692);ldd(j,f,2693);ldd(j,g,2694);ldd(j,h,2695);ldd(j,j,2696);ldd(j,k,2697);ldd(j,l,2698);ldd(k,b,2699);ldd(k,e,2700);ldd(k,d,2701);ldd(k,f,2702);ldd(k,g,2703);ldd(k,h,2704);ldd(k,j,2705);ldd(k,k,2706);ldd(k,l,2707);ldd(l,b,2708);ldd(l,e,2709);ldd(l,d,2710);ldd(l,f,2711);ldd(l,g,2712);ldd(l,h,2713);ldd(l,j,2714);ldd(l,k,2715);ldd(l,l,2716);i=a;return}function ngd(){var a=0;a=i;mdd();i=a;return}function ogd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+44>>2]|0)>-1){f=a+32|0;g=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function pgd(e,f,g,h,j,k){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;l=i;i=i+144|0;m=l;n=l+60|0;o=l+40|0;p=l+24|0;q=l+64|0;r=l+44|0;s=l+48|0;t=l+28|0;u=l+68|0;v=l+72|0;w=l+84|0;x=l+96|0;y=l+108|0;z=l+120|0;c[r>>2]=h;A=h+j|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;a:do if((f|0)>6)if(Whd(s,r,A)|0){if((f|0)<=7){B=c[r>>2]|0;C=29;break}j=e+48|0;D=c[r>>2]|0;E=d[D>>0]|d[D+1>>0]<<8|d[D+2>>0]<<16|d[D+3>>0]<<24;a[j>>0]=E;a[j+1>>0]=E>>8;a[j+2>>0]=E>>16;a[j+3>>0]=E>>24;j=D+4|0;c[r>>2]=j;if((E|0)!=20){c[m>>2]=E;Lsd(t,619736,m);if(!(a[t>>0]&1))F=t+1|0;else F=c[t+8>>2]|0;Krd(F,0,3653512,862,1,0,0,0);xri(t);G=0;break}if((f|0)>12){E=e+44|0;a[E>>0]=a[j>>0]|0;H=D+5|0;c[r>>2]=H;I=d[H>>0]|d[H+1>>0]<<8|d[H+2>>0]<<16|d[H+3>>0]<<24;H=D+9|0;c[r>>2]=H;if((I|0)>0){D=e+4|0;J=e+4|0;K=e+8|0;L=H;H=1;while(1){M=d[L>>0]|d[L+1>>0]<<8|d[L+2>>0]<<16|d[L+3>>0]<<24;c[r>>2]=L+4;N=c[D>>2]|0;do if(N){O=N;while(1){P=c[O+16>>2]|0;if((M|0)<(P|0)){Q=c[O>>2]|0;if(!Q){R=O;S=O;C=18;break}else{O=Q;continue}}if((P|0)>=(M|0)){T=O;C=22;break}P=O+4|0;Q=c[P>>2]|0;if(!Q){U=P;V=O;C=21;break}else O=Q}if((C|0)==18){C=0;c[m>>2]=S;W=R;X=S;break}else if((C|0)==21){C=0;c[m>>2]=V;W=U;X=V;break}else if((C|0)==22){C=0;c[m>>2]=T;W=m;X=T;break}}else{c[m>>2]=J;W=J;X=J}while(0);N=c[W>>2]|0;if(!N){O=xCi(72)|0;c[O+16>>2]=M;Q=O+64|0;Y=O+24|0;Z=Y+40|0;do{c[Y>>2]=0;Y=Y+4|0}while((Y|0)<(Z|0));c[Q>>2]=-1;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=X;c[W>>2]=O;P=c[c[e>>2]>>2]|0;if(!P)_=O;else{c[e>>2]=P;_=c[W>>2]|0}GN(c[D>>2]|0,_);c[K>>2]=(c[K>>2]|0)+1;$=O}else $=N;if(!(Qhd($+24|0,f,(a[E>>0]|0)!=0,M,r,A)|0)){G=0;break a}if((H|0)>=(I|0)){C=50;break a}L=c[r>>2]|0;H=H+1|0}}else C=50}else{B=j;C=29}}else G=0;else{B=h;C=29}while(0);b:do if((C|0)==29){$=d[B>>0]|d[B+1>>0]<<8|d[B+2>>0]<<16|d[B+3>>0]<<24;_=B+4|0;c[r>>2]=_;W=($|0)>0;a[e+44>>0]=W&1;if(W){W=e+4|0;X=e+4|0;T=e+8|0;V=_;_=1;while(1){U=d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24;c[r>>2]=V+4;c[u>>2]=c[153128];c[m+0>>2]=c[u+0>>2];S=bOb(48,m,0,16,3653512,912)|0;hid(S);if(!(oid(S,r,A,f,0)|0)){aa=S;ba=S;break}R=c[W>>2]|0;do if(R){t=R;while(1){F=c[t+16>>2]|0;if((U|0)<(F|0)){H=c[t>>2]|0;if(!H){ca=t;da=t;C=38;break}else{t=H;continue}}if((F|0)>=(U|0)){ea=t;C=42;break}F=t+4|0;H=c[F>>2]|0;if(!H){fa=F;ga=t;C=41;break}else t=H}if((C|0)==38){C=0;c[m>>2]=da;ha=ca;ia=da;break}else if((C|0)==41){C=0;c[m>>2]=ga;ha=fa;ia=ga;break}else if((C|0)==42){C=0;c[m>>2]=ea;ha=m;ia=ea;break}}else{c[m>>2]=X;ha=X;ia=X}while(0);R=c[ha>>2]|0;if(!R){M=xCi(72)|0;c[M+16>>2]=U;N=M+64|0;Y=M+24|0;Z=Y+40|0;do{c[Y>>2]=0;Y=Y+4|0}while((Y|0)<(Z|0));c[N>>2]=-1;c[M>>2]=0;c[M+4>>2]=0;c[M+8>>2]=ia;c[ha>>2]=M;U=c[c[e>>2]>>2]|0;if(!U)ja=M;else{c[e>>2]=U;ja=c[ha>>2]|0}GN(c[W>>2]|0,ja);c[T>>2]=(c[T>>2]|0)+1;ka=M}else ka=R;c[ka+60>>2]=S;if((_|0)>=($|0)){C=50;break b}V=c[r>>2]|0;_=_+1|0}_=c[153128]|0;if(aa)ogd(ba);c[o>>2]=_;c[m+0>>2]=c[o+0>>2];eOb(aa,m);G=0}else C=50}while(0);c:do if((C|0)==50){aa=c[r>>2]|0;if((f+-7|0)>>>0<7){o=aa+4|0;c[r>>2]=o;la=o}else la=aa;aa=d[la>>0]|d[la+1>>0]<<8|d[la+2>>0]<<16|d[la+3>>0]<<24;c[r>>2]=la+4;o=e+32|0;ba=e+24|0;ka=c[ba>>2]|0;ja=ka;if((((c[o>>2]|0)-ja|0)/24|0)>>>0<aa>>>0){ha=e+28|0;ia=(c[ha>>2]|0)-ja|0;ja=(ia|0)/24|0;if(!aa)ma=0;else ma=xCi(aa*24|0)|0;Y=ma+((((ia|0)/-24|0)+ja|0)*24|0)|0;YEi(Y|0,ka|0,ia|0)|0;c[ba>>2]=Y;c[ha>>2]=ma+(ja*24|0);c[o>>2]=ma+(aa*24|0);if(ka)ACi(ka)}if((aa|0)>0){ka=(f|0)>13;ja=3-h|0;ha=(f|0)<11;Y=m+8|0;ia=m+12|0;Z=m+16|0;ea=m+20|0;ga=m+22|0;fa=e+28|0;da=e+24|0;ca=0;while(1){u=c[r>>2]|0;if(ka){B=ja+u&-4;_=h+B|0;V=_;$=d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24;V=_+4|0;_=d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24;V=h+(B+8)|0;c[r>>2]=V;na=V;oa=$;pa=_}else{_=d[u>>0]|d[u+1>>0]<<8|d[u+2>>0]<<16|d[u+3>>0]<<24;$=u+4|0;c[r>>2]=$;na=$;oa=_;pa=((_|0)<0)<<31>>31}_=d[na>>0]|d[na+1>>0]<<8|d[na+2>>0]<<16|d[na+3>>0]<<24;$=na+4|0;c[r>>2]=$;u=d[$>>0]|d[$+1>>0]<<8|d[$+2>>0]<<16|d[$+3>>0]<<24;$=na+8|0;c[r>>2]=$;V=d[$>>0]|d[$+1>>0]<<8|d[$+2>>0]<<16|d[$+3>>0]<<24;$=na+12|0;c[r>>2]=$;B=d[$>>0]|d[$+1>>0]<<8;$=na+14|0;c[r>>2]=$;if(ha)qa=-1;else qa=d[$>>0]|d[$+1>>0]<<8;c[r>>2]=na+16;$=_+g|0;if(($|0)<0){G=0;break c}if((u|0)<0|($+u|0)>(k|0)){G=0;break c}_=m;c[_>>2]=oa;c[_+4>>2]=pa;c[Y>>2]=$;c[ia>>2]=u;c[Z>>2]=V;b[ea>>1]=B;b[ga>>1]=qa;B=c[fa>>2]|0;if((B|0)==(c[o>>2]|0))Rhd(da,m);else{if(!B)ra=0;else{c[B+0>>2]=c[m+0>>2];c[B+4>>2]=c[m+4>>2];c[B+8>>2]=c[m+8>>2];c[B+12>>2]=c[m+12>>2];c[B+16>>2]=c[m+16>>2];c[B+20>>2]=c[m+20>>2];ra=c[fa>>2]|0}c[fa>>2]=ra+24}ca=ca+1|0;if((ca|0)>=(aa|0)){sa=fa;break}}}else sa=e+28|0;do if(((c[ba>>2]|0)!=(c[sa>>2]|0)?(a[e+44>>0]|0)==0:0)?(c[e+40>>2]&16777216|0)==0:0){fa=a[s>>0]|0;aa=(fa&1)==0;if(aa){ta=(fa&255)>>>1;ua=s+1|0}else{ta=c[s+4>>2]|0;ua=c[s+8>>2]|0}if(((ta|0)!=0?(ca=EEi(ua,10,ta)|0,(ca|0)!=0):0)?(da=ca-ua|0,(da|0)!=-1):0){if(aa){va=s+1|0;wa=(fa&255)>>>1;xa=s+(da+1)+1|0}else{ca=c[s+8>>2]|0;va=ca;wa=c[s+4>>2]|0;xa=ca+(da+1)|0}da=va+wa|0;ca=da-xa|0;if(ca>>>0>4294967279)ori(v);if(ca>>>0<11){a[v>>0]=ca<<1;ya=v+1|0}else{o=ca+16&-16;ga=xCi(o)|0;c[v+8>>2]=ga;c[v>>2]=o|1;c[v+4>>2]=ca;ya=ga}if((xa|0)==(da|0))za=ya;else{ga=xa;o=ya;while(1){a[o>>0]=a[ga>>0]|0;ga=ga+1|0;if((ga|0)==(da|0))break;else o=o+1|0}za=ya+ca|0}a[za>>0]=0;o=Ori(v,619664)|0;xri(v);if(!o)break}else{if(aa){Aa=(fa&255)>>>1;Ba=s+1|0}else{Aa=c[s+4>>2]|0;Ba=c[s+8>>2]|0}o=Aa>>>0>8;if((FEi(Ba,619976,o?8:Aa)|0)==0?Aa>>>0>7&(o^1):0)break}o=c[e+108>>2]|0;In[c[(c[o>>2]|0)+24>>2]&4095](x,o);if(!(a[x>>0]&1))Ca=x+1|0;else Ca=c[x+8>>2]|0;if(!(a[s>>0]&1))Da=s+1|0;else Da=c[s+8>>2]|0;c[m>>2]=Ca;c[m+4>>2]=Da;Lsd(w,619992,m);if(!(a[w>>0]&1))Ea=w+1|0;else Ea=c[w+8>>2]|0;Krd(Ea,0,3653512,999,1,0,0,0);xri(w);xri(x);G=0;break c}while(0);if((f|0)>10){ba=c[r>>2]|0;o=d[ba>>0]|d[ba+1>>0]<<8|d[ba+2>>0]<<16|d[ba+3>>0]<<24;c[r>>2]=ba+4;ba=e+64|0;da=e+72|0;c[da>>2]=o;ga=e+76|0;S=c[ga>>2]|0;do if((S&2147483647)>>>0<o>>>0)if((S|0)>-1){c[ga>>2]=o;R=c[ba>>2]|0;c[n>>2]=c[e+68>>2];c[m+0>>2]=c[n+0>>2];c[ba>>2]=hOb(R,o<<4,8,m,0,3653512,370)|0;break}else{c[n>>2]=c[e+68>>2];c[m+0>>2]=c[n+0>>2];R=cOb(o<<4,8,m,0,3653512,352)|0;YEi(R|0,c[ba>>2]|0,c[da>>2]<<4|0)|0;c[ga>>2]=o;c[ba>>2]=R;break}while(0);if((o|0)>0){ga=3-h|0;da=c[ba>>2]|0;S=c[r>>2]|0;if((f|0)>13){R=da;M=S;N=0;do{ea=R+(N<<4)|0;Z=d[M>>0]|d[M+1>>0]<<8|d[M+2>>0]<<16|d[M+3>>0]<<24;a[ea>>0]=Z;a[ea+1>>0]=Z>>8;a[ea+2>>0]=Z>>16;a[ea+3>>0]=Z>>24;Z=ga+((c[r>>2]|0)+4)&-4;ea=h+Z|0;ia=ea;Y=d[ia>>0]|d[ia+1>>0]<<8|d[ia+2>>0]<<16|d[ia+3>>0]<<24;ia=ea+4|0;ea=d[ia>>0]|d[ia+1>>0]<<8|d[ia+2>>0]<<16|d[ia+3>>0]<<24;M=h+(Z+8)|0;c[r>>2]=M;R=c[ba>>2]|0;Z=R+(N<<4)+8|0;c[Z>>2]=Y;c[Z+4>>2]=ea;N=N+1|0}while((N|0)!=(o|0))}else{N=da;R=S;M=0;do{ga=N+(M<<4)|0;ea=d[R>>0]|d[R+1>>0]<<8|d[R+2>>0]<<16|d[R+3>>0]<<24;a[ga>>0]=ea;a[ga+1>>0]=ea>>8;a[ga+2>>0]=ea>>16;a[ga+3>>0]=ea>>24;ea=c[r>>2]|0;ga=ea+4|0;c[r>>2]=ga;Z=d[ga>>0]|d[ga+1>>0]<<8|d[ga+2>>0]<<16|d[ga+3>>0]<<24;R=ea+8|0;c[r>>2]=R;N=c[ba>>2]|0;ea=N+(M<<4)+8|0;c[ea>>2]=Z;c[ea+4>>2]=((Z|0)<0)<<31>>31;M=M+1|0}while((M|0)!=(o|0))}}}o=c[r>>2]|0;M=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;c[r>>2]=o+4;o=e+80|0;N=e+84|0;ba=c[N>>2]|0;if(ba>>>0<M>>>0){do{Shd(o);R=c[N>>2]|0}while(R>>>0<M>>>0);Fa=R}else Fa=ba;if(Fa>>>0>M>>>0)do Thd(o);while((c[N>>2]|0)>>>0>M>>>0);N=(f|0)>4;d:do if((M|0)>0){ba=(f|0)>5;R=y+8|0;S=e+92|0;if(N)Ga=0;else{da=0;while(1){Z=c[o>>2]|0;if(!(Whd((c[c[(c[S>>2]|0)+(((da>>>0)/(Z>>>0)|0)<<2)>>2]>>2]|0)+(((da>>>0)%(Z>>>0)|0)<<5)|0,r,A)|0)){G=0;break c}da=da+1|0;if((da|0)>=(M|0))break d}}do{if(ba){c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;da=Whd(y,r,A)|0;if(a[y>>0]&1){fa=c[R>>2]|0;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];eOb(fa,m)}if(!da){G=0;break c}}da=c[o>>2]|0;fa=(c[c[(c[S>>2]|0)+(((Ga>>>0)/(da>>>0)|0)<<2)>>2]>>2]|0)+(((Ga>>>0)%(da>>>0)|0)<<5)+16|0;da=c[r>>2]|0;aa=d[da>>0]|d[da+1>>0]<<8|d[da+2>>0]<<16|d[da+3>>0]<<24;a[fa>>0]=aa;a[fa+1>>0]=aa>>8;a[fa+2>>0]=aa>>16;a[fa+3>>0]=aa>>24;aa=(c[r>>2]|0)+4|0;c[r>>2]=aa;fa=c[o>>2]|0;da=(c[c[(c[S>>2]|0)+(((Ga>>>0)/(fa>>>0)|0)<<2)>>2]>>2]|0)+(((Ga>>>0)%(fa>>>0)|0)<<5)+20|0;fa=d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24;a[da>>0]=fa;a[da+1>>0]=fa>>8;a[da+2>>0]=fa>>16;a[da+3>>0]=fa>>24;fa=(c[r>>2]|0)+4|0;c[r>>2]=fa;da=c[o>>2]|0;aa=(c[c[(c[S>>2]|0)+(((Ga>>>0)/(da>>>0)|0)<<2)>>2]>>2]|0)+(((Ga>>>0)%(da>>>0)|0)<<5)+24|0;da=d[fa>>0]|d[fa+1>>0]<<8|d[fa+2>>0]<<16|d[fa+3>>0]<<24;a[aa>>0]=da;a[aa+1>>0]=da>>8;a[aa+2>>0]=da>>16;a[aa+3>>0]=da>>24;da=(c[r>>2]|0)+4|0;c[r>>2]=da;aa=c[o>>2]|0;fa=(c[c[(c[S>>2]|0)+(((Ga>>>0)/(aa>>>0)|0)<<2)>>2]>>2]|0)+(((Ga>>>0)%(aa>>>0)|0)<<5)+28|0;aa=d[da>>0]|d[da+1>>0]<<8|d[da+2>>0]<<16|d[da+3>>0]<<24;a[fa>>0]=aa;a[fa+1>>0]=aa>>8;a[fa+2>>0]=aa>>16;a[fa+3>>0]=aa>>24;aa=(c[r>>2]|0)+4|0;c[r>>2]=aa;fa=c[o>>2]|0;da=(c[c[(c[S>>2]|0)+(((Ga>>>0)/(fa>>>0)|0)<<2)>>2]>>2]|0)+(((Ga>>>0)%(fa>>>0)|0)<<5)+12|0;fa=d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24;a[da>>0]=fa;a[da+1>>0]=fa>>8;a[da+2>>0]=fa>>16;a[da+3>>0]=fa>>24;c[r>>2]=(c[r>>2]|0)+4;fa=c[o>>2]|0;if(!(Whd((c[c[(c[S>>2]|0)+(((Ga>>>0)/(fa>>>0)|0)<<2)>>2]>>2]|0)+(((Ga>>>0)%(fa>>>0)|0)<<5)|0,r,A)|0)){G=0;break c}Ga=Ga+1|0}while((Ga|0)<(M|0))}while(0);if(N){c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;M=Whd(z,r,A)|0;if(a[z>>0]&1){o=c[z+8>>2]|0;c[p>>2]=58;c[m+0>>2]=c[p+0>>2];eOb(o,m)}if(!M){G=0;break}}G=1}while(0);if(!(a[s>>0]&1)){i=l;return G|0}p=c[s+8>>2]|0;c[q>>2]=58;c[m+0>>2]=c[q+0>>2];eOb(p,m);i=l;return G|0}function qgd(e,f,g,h,j,k){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;l=i;i=i+144|0;m=l;n=l+60|0;o=l+40|0;p=l+24|0;q=l+64|0;r=l+44|0;s=l+48|0;t=l+28|0;u=l+68|0;v=l+72|0;w=l+84|0;x=l+96|0;y=l+108|0;z=l+120|0;c[r>>2]=h;A=h+j|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;a:do if((f|0)>6)if(Whd(s,r,A)|0){if((f|0)<=7){B=c[r>>2]|0;C=29;break}j=c[r>>2]|0;D=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;E=XEi(D|0)|0;c[e+48>>2]=E;F=j+4|0;c[r>>2]=F;if((D|0)!=335544320){c[m>>2]=E;Lsd(t,619736,m);if(!(a[t>>0]&1))G=t+1|0;else G=c[t+8>>2]|0;Krd(G,0,3653512,862,1,0,0,0);xri(t);H=0;break}if((f|0)>12){E=e+44|0;a[E>>0]=a[F>>0]|0;D=j+5|0;c[r>>2]=D;I=XEi(d[D>>0]|d[D+1>>0]<<8|d[D+2>>0]<<16|d[D+3>>0]<<24|0)|0;D=j+9|0;c[r>>2]=D;if((I|0)>0){j=e+4|0;J=e+4|0;K=e+8|0;L=D;D=1;while(1){M=XEi(d[L>>0]|d[L+1>>0]<<8|d[L+2>>0]<<16|d[L+3>>0]<<24|0)|0;c[r>>2]=L+4;N=c[j>>2]|0;do if(N){O=N;while(1){P=c[O+16>>2]|0;if((M|0)<(P|0)){Q=c[O>>2]|0;if(!Q){R=O;S=O;C=18;break}else{O=Q;continue}}if((P|0)>=(M|0)){T=O;C=22;break}P=O+4|0;Q=c[P>>2]|0;if(!Q){U=P;V=O;C=21;break}else O=Q}if((C|0)==18){C=0;c[m>>2]=S;W=R;X=S;break}else if((C|0)==21){C=0;c[m>>2]=V;W=U;X=V;break}else if((C|0)==22){C=0;c[m>>2]=T;W=m;X=T;break}}else{c[m>>2]=J;W=J;X=J}while(0);N=c[W>>2]|0;if(!N){O=xCi(72)|0;c[O+16>>2]=M;Q=O+64|0;Y=O+24|0;Z=Y+40|0;do{c[Y>>2]=0;Y=Y+4|0}while((Y|0)<(Z|0));c[Q>>2]=-1;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=X;c[W>>2]=O;P=c[c[e>>2]>>2]|0;if(!P)_=O;else{c[e>>2]=P;_=c[W>>2]|0}GN(c[j>>2]|0,_);c[K>>2]=(c[K>>2]|0)+1;$=O}else $=N;if(!(Uhd($+24|0,f,(a[E>>0]|0)!=0,M,r,A)|0)){H=0;break a}if((D|0)>=(I|0)){C=50;break a}L=c[r>>2]|0;D=D+1|0}}else C=50}else{B=F;C=29}}else H=0;else{B=h;C=29}while(0);b:do if((C|0)==29){$=XEi(d[B>>0]|d[B+1>>0]<<8|d[B+2>>0]<<16|d[B+3>>0]<<24|0)|0;_=B+4|0;c[r>>2]=_;W=($|0)>0;a[e+44>>0]=W&1;if(W){W=e+4|0;X=e+4|0;T=e+8|0;V=_;_=1;while(1){U=XEi(d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24|0)|0;c[r>>2]=V+4;c[u>>2]=c[153128];c[m+0>>2]=c[u+0>>2];S=bOb(48,m,0,16,3653512,912)|0;hid(S);if(!(oid(S,r,A,f,1)|0)){aa=S;ba=S;break}R=c[W>>2]|0;do if(R){t=R;while(1){G=c[t+16>>2]|0;if((U|0)<(G|0)){D=c[t>>2]|0;if(!D){ca=t;da=t;C=38;break}else{t=D;continue}}if((G|0)>=(U|0)){ea=t;C=42;break}G=t+4|0;D=c[G>>2]|0;if(!D){fa=G;ga=t;C=41;break}else t=D}if((C|0)==38){C=0;c[m>>2]=da;ha=ca;ia=da;break}else if((C|0)==41){C=0;c[m>>2]=ga;ha=fa;ia=ga;break}else if((C|0)==42){C=0;c[m>>2]=ea;ha=m;ia=ea;break}}else{c[m>>2]=X;ha=X;ia=X}while(0);R=c[ha>>2]|0;if(!R){M=xCi(72)|0;c[M+16>>2]=U;N=M+64|0;Y=M+24|0;Z=Y+40|0;do{c[Y>>2]=0;Y=Y+4|0}while((Y|0)<(Z|0));c[N>>2]=-1;c[M>>2]=0;c[M+4>>2]=0;c[M+8>>2]=ia;c[ha>>2]=M;U=c[c[e>>2]>>2]|0;if(!U)ja=M;else{c[e>>2]=U;ja=c[ha>>2]|0}GN(c[W>>2]|0,ja);c[T>>2]=(c[T>>2]|0)+1;ka=M}else ka=R;c[ka+60>>2]=S;if((_|0)>=($|0)){C=50;break b}V=c[r>>2]|0;_=_+1|0}_=c[153128]|0;if(aa)ogd(ba);c[o>>2]=_;c[m+0>>2]=c[o+0>>2];eOb(aa,m);H=0}else C=50}while(0);c:do if((C|0)==50){aa=c[r>>2]|0;if((f+-7|0)>>>0<7){o=aa+4|0;c[r>>2]=o;la=o}else la=aa;aa=d[la>>0]|d[la+1>>0]<<8|d[la+2>>0]<<16|d[la+3>>0]<<24;o=XEi(aa|0)|0;c[r>>2]=la+4;ba=e+32|0;ka=e+24|0;ja=c[ka>>2]|0;ha=ja;if((((c[ba>>2]|0)-ha|0)/24|0)>>>0<o>>>0){ia=e+28|0;Y=(c[ia>>2]|0)-ha|0;ha=(Y|0)/24|0;if(!aa)ma=0;else ma=xCi(o*24|0)|0;aa=ma+((((Y|0)/-24|0)+ha|0)*24|0)|0;YEi(aa|0,ja|0,Y|0)|0;c[ka>>2]=aa;c[ia>>2]=ma+(ha*24|0);c[ba>>2]=ma+(o*24|0);if(ja)ACi(ja)}if((o|0)>0){ja=(f|0)>13;ha=3-h|0;ia=(f|0)<11;aa=m+8|0;Y=m+12|0;Z=m+16|0;ea=m+20|0;ga=m+22|0;fa=e+28|0;da=e+24|0;ca=0;while(1){u=c[r>>2]|0;if(ja){B=ha+u&-4;_=h+B|0;V=_;$=_+4|0;_=d[$>>0]|d[$+1>>0]<<8|d[$+2>>0]<<16|d[$+3>>0]<<24;$=XEi(d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24|0)|0;V=XEi(_|0)|0;_=h+(B+8)|0;c[r>>2]=_;na=_;oa=V;pa=$}else{$=XEi(d[u>>0]|d[u+1>>0]<<8|d[u+2>>0]<<16|d[u+3>>0]<<24|0)|0;V=u+4|0;c[r>>2]=V;na=V;oa=$;pa=(($|0)<0)<<31>>31}$=XEi(d[na>>0]|d[na+1>>0]<<8|d[na+2>>0]<<16|d[na+3>>0]<<24|0)|0;V=na+4|0;c[r>>2]=V;u=XEi(d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24|0)|0;V=na+8|0;c[r>>2]=V;_=XEi(d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24|0)|0;V=na+12|0;c[r>>2]=V;B=(d[V>>0]|d[V+1>>0]<<8)&65535;V=na+14|0;c[r>>2]=V;if(ia)qa=-1;else{T=(d[V>>0]|d[V+1>>0]<<8)&65535;qa=(T<<8|T>>>8)&65535}c[r>>2]=na+16;T=$+g|0;if((T|0)<0){H=0;break c}if((u|0)<0|(u+T|0)>(k|0)){H=0;break c}$=m;c[$>>2]=oa;c[$+4>>2]=pa;c[aa>>2]=T;c[Y>>2]=u;c[Z>>2]=_;b[ea>>1]=B<<8|B>>>8;b[ga>>1]=qa;B=c[fa>>2]|0;if((B|0)==(c[ba>>2]|0))Rhd(da,m);else{if(!B)ra=0;else{c[B+0>>2]=c[m+0>>2];c[B+4>>2]=c[m+4>>2];c[B+8>>2]=c[m+8>>2];c[B+12>>2]=c[m+12>>2];c[B+16>>2]=c[m+16>>2];c[B+20>>2]=c[m+20>>2];ra=c[fa>>2]|0}c[fa>>2]=ra+24}ca=ca+1|0;if((ca|0)>=(o|0)){sa=fa;break}}}else sa=e+28|0;do if(((c[ka>>2]|0)!=(c[sa>>2]|0)?(a[e+44>>0]|0)==0:0)?(c[e+40>>2]&16777216|0)==0:0){fa=a[s>>0]|0;o=(fa&1)==0;if(o){ta=(fa&255)>>>1;ua=s+1|0}else{ta=c[s+4>>2]|0;ua=c[s+8>>2]|0}if(((ta|0)!=0?(ca=EEi(ua,10,ta)|0,(ca|0)!=0):0)?(da=ca-ua|0,(da|0)!=-1):0){if(o){va=s+1|0;wa=(fa&255)>>>1;xa=s+(da+1)+1|0}else{ca=c[s+8>>2]|0;va=ca;wa=c[s+4>>2]|0;xa=ca+(da+1)|0}da=va+wa|0;ca=da-xa|0;if(ca>>>0>4294967279)ori(v);if(ca>>>0<11){a[v>>0]=ca<<1;ya=v+1|0}else{ba=ca+16&-16;ga=xCi(ba)|0;c[v+8>>2]=ga;c[v>>2]=ba|1;c[v+4>>2]=ca;ya=ga}if((xa|0)==(da|0))za=ya;else{ga=xa;ba=ya;while(1){a[ba>>0]=a[ga>>0]|0;ga=ga+1|0;if((ga|0)==(da|0))break;else ba=ba+1|0}za=ya+ca|0}a[za>>0]=0;ba=Ori(v,619664)|0;xri(v);if(!ba)break}else{if(o){Aa=(fa&255)>>>1;Ba=s+1|0}else{Aa=c[s+4>>2]|0;Ba=c[s+8>>2]|0}ba=Aa>>>0>8;if((FEi(Ba,619976,ba?8:Aa)|0)==0?Aa>>>0>7&(ba^1):0)break}ba=c[e+108>>2]|0;In[c[(c[ba>>2]|0)+24>>2]&4095](x,ba);if(!(a[x>>0]&1))Ca=x+1|0;else Ca=c[x+8>>2]|0;if(!(a[s>>0]&1))Da=s+1|0;else Da=c[s+8>>2]|0;c[m>>2]=Ca;c[m+4>>2]=Da;Lsd(w,619992,m);if(!(a[w>>0]&1))Ea=w+1|0;else Ea=c[w+8>>2]|0;Krd(Ea,0,3653512,999,1,0,0,0);xri(w);xri(x);H=0;break c}while(0);if((f|0)>10){ka=c[r>>2]|0;ba=XEi(d[ka>>0]|d[ka+1>>0]<<8|d[ka+2>>0]<<16|d[ka+3>>0]<<24|0)|0;c[r>>2]=ka+4;ka=e+64|0;da=e+72|0;c[da>>2]=ba;ga=e+76|0;S=c[ga>>2]|0;do if((S&2147483647)>>>0<ba>>>0)if((S|0)>-1){c[ga>>2]=ba;R=c[ka>>2]|0;c[n>>2]=c[e+68>>2];c[m+0>>2]=c[n+0>>2];c[ka>>2]=hOb(R,ba<<4,8,m,0,3653512,370)|0;break}else{c[n>>2]=c[e+68>>2];c[m+0>>2]=c[n+0>>2];R=cOb(ba<<4,8,m,0,3653512,352)|0;YEi(R|0,c[ka>>2]|0,c[da>>2]<<4|0)|0;c[ga>>2]=ba;c[ka>>2]=R;break}while(0);if((ba|0)>0){ga=(f|0)>13;da=3-h|0;S=c[ka>>2]|0;R=c[r>>2]|0;M=0;while(1){c[S+(M<<4)>>2]=XEi(d[R>>0]|d[R+1>>0]<<8|d[R+2>>0]<<16|d[R+3>>0]<<24|0)|0;N=R+4|0;c[r>>2]=N;if(ga){ea=da+N&-4;Z=h+ea|0;Y=Z;aa=Z+4|0;Z=d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24;aa=XEi(d[Y>>0]|d[Y+1>>0]<<8|d[Y+2>>0]<<16|d[Y+3>>0]<<24|0)|0;Y=XEi(Z|0)|0;Z=h+(ea+8)|0;c[r>>2]=Z;Fa=Y;Ga=aa;Ha=Z}else{Z=XEi(d[N>>0]|d[N+1>>0]<<8|d[N+2>>0]<<16|d[N+3>>0]<<24|0)|0;N=R+8|0;c[r>>2]=N;Fa=Z;Ga=((Z|0)<0)<<31>>31;Ha=N}N=S+(M<<4)+8|0;c[N>>2]=Fa;c[N+4>>2]=Ga;M=M+1|0;if((M|0)==(ba|0))break;else R=Ha}}}R=c[r>>2]|0;ba=XEi(d[R>>0]|d[R+1>>0]<<8|d[R+2>>0]<<16|d[R+3>>0]<<24|0)|0;c[r>>2]=R+4;R=e+80|0;M=e+84|0;S=c[M>>2]|0;if(S>>>0<ba>>>0){do{Shd(R);da=c[M>>2]|0}while(da>>>0<ba>>>0);Ia=da}else Ia=S;if(Ia>>>0>ba>>>0)do Thd(R);while((c[M>>2]|0)>>>0>ba>>>0);M=(f|0)>4;if((ba|0)>0){S=(f|0)>5;da=y+8|0;ga=e+92|0;ka=0;do{if(M){if(S){c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;N=Whd(y,r,A)|0;if(a[y>>0]&1){Z=c[da>>2]|0;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];eOb(Z,m)}if(!N){H=0;break c}}N=c[R>>2]|0;Z=c[ga>>2]|0;aa=(c[c[Z+(((ka>>>0)/(N>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(N>>>0)|0)<<5)+16|0;N=c[r>>2]|0;c[aa>>2]=XEi(d[N>>0]|d[N+1>>0]<<8|d[N+2>>0]<<16|d[N+3>>0]<<24|0)|0;aa=N+4|0;c[r>>2]=aa;Y=c[R>>2]|0;ea=(c[c[Z+(((ka>>>0)/(Y>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(Y>>>0)|0)<<5)+20|0;c[ea>>2]=XEi(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24|0)|0;aa=N+8|0;c[r>>2]=aa;ea=c[R>>2]|0;Y=(c[c[Z+(((ka>>>0)/(ea>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(ea>>>0)|0)<<5)+24|0;c[Y>>2]=XEi(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24|0)|0;aa=N+12|0;c[r>>2]=aa;Y=c[R>>2]|0;ea=(c[c[Z+(((ka>>>0)/(Y>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(Y>>>0)|0)<<5)+28|0;c[ea>>2]=XEi(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24|0)|0;aa=N+16|0;c[r>>2]=aa;ea=c[R>>2]|0;Y=(c[c[Z+(((ka>>>0)/(ea>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(ea>>>0)|0)<<5)+12|0;c[Y>>2]=XEi(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24|0)|0;c[r>>2]=N+20;N=c[R>>2]|0;if(!(Whd((c[c[Z+(((ka>>>0)/(N>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(N>>>0)|0)<<5)|0,r,A)|0)){H=0;break c}}else{N=c[R>>2]|0;if(!(Whd((c[c[(c[ga>>2]|0)+(((ka>>>0)/(N>>>0)|0)<<2)>>2]>>2]|0)+(((ka>>>0)%(N>>>0)|0)<<5)|0,r,A)|0)){H=0;break c}}ka=ka+1|0}while((ka|0)<(ba|0))}if(M){c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;ba=Whd(z,r,A)|0;if(a[z>>0]&1){ka=c[z+8>>2]|0;c[p>>2]=58;c[m+0>>2]=c[p+0>>2];eOb(ka,m)}if(!ba){H=0;break}}H=1}while(0);if(!(a[s>>0]&1)){i=l;return H|0}p=c[s+8>>2]|0;c[q>>2]=58;c[m+0>>2]=c[q+0>>2];eOb(p,m);i=l;return H|0}function rgd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;j=b+4|0;k=c[j>>2]|0;if(k){l=b+12|0;m=k;k=0;while(1){n=c[b>>2]|0;o=(k>>>0)%(n>>>0)|0;p=c[c[(c[l>>2]|0)+(((k>>>0)/(n>>>0)|0)<<2)>>2]>>2]|0;if(!(a[p+(o<<5)>>0]&1))q=m;else{n=c[p+(o<<5)+8>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(n,e);q=c[j>>2]|0}k=k+1|0;if(k>>>0>=q>>>0)break;else m=q}}q=b+12|0;m=b+20|0;if(c[m>>2]|0){k=b+8|0;h=0;do{l=c[(c[q>>2]|0)+(h<<2)>>2]|0;n=c[k>>2]|0;if((l|0)!=0?(c[l+12>>2]|0)>-1:0){o=c[l>>2]|0;c[f>>2]=c[l+4>>2];c[e+0>>2]=c[f+0>>2];eOb(o,e);c[l>>2]=0}c[g>>2]=n;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[(c[q>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while(h>>>0<(c[m>>2]|0)>>>0)}h=b+24|0;if((c[h>>2]|0)<=-1){c[m>>2]=0;c[h>>2]=0;c[j>>2]=0;i=d;return}g=c[q>>2]|0;c[f>>2]=c[b+16>>2];c[e+0>>2]=c[f+0>>2];eOb(g,e);c[q>>2]=0;c[m>>2]=0;c[h>>2]=0;c[j>>2]=0;i=d;return}function sgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}sgd(a,c[b>>2]|0);sgd(a,c[b+4>>2]|0);a=c[b+60>>2]|0;g=c[153128]|0;if(a)ogd(a);c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(a,e);ACi(b);i=d;return}function tgd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f;h=f+24|0;j=f+12|0;if((b|0)==114){c[g>>2]=e;c[g+4>>2]=d;Lsd(h,620088,g);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;Krd(k,0,3653512,1599,1,0,0,0);xri(h);i=f;return}h=EQb(b)|0;if(!(a[h>>0]&1))l=h+1|0;else l=c[h+8>>2]|0;c[g>>2]=l;c[g+4>>2]=e;c[g+8>>2]=d;Lsd(j,620288,g);if(!(a[j>>0]&1))m=j+1|0;else m=c[j+8>>2]|0;Krd(m,0,3653512,1603,1,0,0,0);xri(j);i=f;return}function ugd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+4|0;k=c[j>>2]|0;l=c[b>>2]|0;m=(k>>>0)/(l>>>0)|0;n=(k>>>0)%(l>>>0)|0;l=b+12|0;k=b+20|0;if((m|0)==(c[k>>2]|0)){o=b+8|0;c[h>>2]=c[o>>2];c[f+0>>2]=c[h+0>>2];h=bOb(16,f,0,16,3653512,102)|0;p=c[b>>2]|0;q=c[o>>2]|0;c[h+4>>2]=q;c[h+8>>2]=p;c[h+12>>2]=p;c[g>>2]=q;c[f+0>>2]=c[g+0>>2];c[h>>2]=cOb(p<<5,4,f,0,3653512,352)|0;p=(c[k>>2]|0)+1|0;c[k>>2]=p;q=b+24|0;o=c[q>>2]|0;r=o&2147483647;if(p>>>0>r>>>0){s=o<<1;t=(s|0)==0?1:s;do if(r>>>0<t>>>0)if((o|0)>-1){c[q>>2]=t;s=c[l>>2]|0;c[g>>2]=c[b+16>>2];c[f+0>>2]=c[g+0>>2];c[l>>2]=hOb(s,t<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[b+16>>2];c[f+0>>2]=c[g+0>>2];s=cOb(t<<2,4,f,0,3653512,352)|0;YEi(s|0,c[l>>2]|0,c[k>>2]<<2|0)|0;c[q>>2]=t;c[l>>2]=s;break}while(0);u=c[k>>2]|0}else u=p;c[(c[l>>2]|0)+(u+-1<<2)>>2]=h;v=l}else v=l;l=c[c[(c[v>>2]|0)+(m<<2)>>2]>>2]|0;m=l+(n<<5)|0;v=a[d>>0]|0;if(!(v&1)){w=(v&255)>>>1;x=d+1|0}else{w=c[d+4>>2]|0;x=c[d+8>>2]|0}if(w>>>0>2147483631)ori(m);if(w>>>0<11){a[m>>0]=w<<1;y=m+1|0;YEi(y|0,x|0,w|0)|0;z=y+w|0;a[z>>0]=0;A=l+(n<<5)+12|0;B=d+12|0;c[A+0>>2]=c[B+0>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];c[A+12>>2]=c[B+12>>2];c[A+16>>2]=c[B+16>>2];C=c[j>>2]|0;D=C+1|0;c[j>>2]=D;i=e;return}else{v=w+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];g=cOb(v,16,f,0,3653512,80)|0;c[l+(n<<5)+8>>2]=g;c[m>>2]=v|1;c[l+(n<<5)+4>>2]=w;y=g;YEi(y|0,x|0,w|0)|0;z=y+w|0;a[z>>0]=0;A=l+(n<<5)+12|0;B=d+12|0;c[A+0>>2]=c[B+0>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];c[A+12>>2]=c[B+12>>2];c[A+16>>2]=c[B+16>>2];C=c[j>>2]|0;D=C+1|0;c[j>>2]=D;i=e;return}}function vgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,l=0,m=0,n=0,o=Im,p=0.0;d=i;i=i+16|0;e=d;f=b+12|0;j=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+l|0;c[f>>2]=m;if((l|0)>=0?(n=j+(l+4)|0,n>>>0<=(c[b+20>>2]|0)>>>0):0){g[e>>2]=ea(g[m>>2]);c[f>>2]=n}else Bid(f,e,4);if(!(c[b>>2]&512)){o=ea(g[e>>2]);p=+o;h[a>>3]=p;i=d;return 1}else{b=XEi(c[e>>2]|0)|0;c[e>>2]=b;o=(c[k>>2]=b,ea(g[k>>2]));p=+o;h[a>>3]=p;i=d;return 1}return 0}function wgd(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,l=0,m=0,n=0,o=0.0,p=Im;e=i;i=i+16|0;f=e;j=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[j>>2]=n;if((m|0)>=0?(l+(m+8)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[k>>0]=a[n>>0];a[k+1>>0]=a[n+1>>0];a[k+2>>0]=a[n+2>>0];a[k+3>>0]=a[n+3>>0];a[k+4>>0]=a[n+4>>0];a[k+5>>0]=a[n+5>>0];a[k+6>>0]=a[n+6>>0];a[k+7>>0]=a[n+7>>0];h[f>>3]=+h[k>>3];c[j>>2]=l+(m+8)}else Bid(j,f,8);if(!(c[d>>2]&512)){o=+h[f>>3];p=ea(o);g[b>>2]=p;i=e;return 1}d=XEi(c[f>>2]|0)|0;j=f+4|0;c[f>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=d;o=+h[f>>3];p=ea(o);g[b>>2]=p;i=e;return 1}function xgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im;d=i;i=i+16|0;e=d;f=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[f>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[k>>2];c[f>>2]=l}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){m=f;n=ea(m|0);g[a>>2]=n;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;m=b;n=ea(m|0);g[a>>2]=n;i=d;return 1}function ygd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+8)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){h=j;j=c[h+4>>2]|0;g=e;c[g>>2]=c[h>>2];c[g+4>>2]=j;c[f>>2]=k}else Bid(f,e,8);if(!(c[b>>2]&512)){l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;r=a;s=r;c[s>>2]=n;t=r+4|0;u=t;c[u>>2]=q;i=d;return 1}b=XEi(c[e>>2]|0)|0;f=e+4|0;c[e>>2]=XEi(c[f>>2]|0)|0;c[f>>2]=b;l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;r=a;s=r;c[s>>2]=n;t=r+4|0;u=t;c[u>>2]=q;i=d;return 1}function zgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+8)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){h=j;j=c[h+4>>2]|0;g=e;c[g>>2]=c[h>>2];c[g+4>>2]=j;c[f>>2]=k}else Bid(f,e,8);if(!(c[b>>2]&512)){l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;r=a;s=r;c[s>>2]=n;t=r+4|0;u=t;c[u>>2]=q;i=d;return 1}b=XEi(c[e>>2]|0)|0;f=e+4|0;c[e>>2]=XEi(c[f>>2]|0)|0;c[f>>2]=b;l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;r=a;s=r;c[s>>2]=n;t=r+4|0;u=t;c[u>>2]=q;i=d;return 1}function Agd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+8)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){h=j;j=c[h+4>>2]|0;g=e;c[g>>2]=c[h>>2];c[g+4>>2]=j;c[f>>2]=k}else Bid(f,e,8);if(!(c[b>>2]&512)){l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;c[a>>2]=n;i=d;return 1}b=XEi(c[e>>2]|0)|0;f=e+4|0;c[e>>2]=XEi(c[f>>2]|0)|0;c[f>>2]=b;l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;c[a>>2]=n;i=d;return 1}function Bgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+8)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){h=j;j=c[h+4>>2]|0;g=e;c[g>>2]=c[h>>2];c[g+4>>2]=j;c[f>>2]=k}else Bid(f,e,8);if(!(c[b>>2]&512)){l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;c[a>>2]=n;i=d;return 1}b=XEi(c[e>>2]|0)|0;f=e+4|0;c[e>>2]=XEi(c[f>>2]|0)|0;c[f>>2]=b;l=e;m=l;n=c[m>>2]|0;o=l+4|0;p=o;q=c[p>>2]|0;c[a>>2]=n;i=d;return 1}function Cgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+8)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){j=k;k=c[j+4>>2]|0;h=f;c[h>>2]=c[j>>2];c[h+4>>2]=k;c[g>>2]=l}else Bid(g,f,8);if(!(c[d>>2]&512)){m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&65535;b[a>>1]=s;i=e;return 1}d=XEi(c[f>>2]|0)|0;g=f+4|0;c[f>>2]=XEi(c[g>>2]|0)|0;c[g>>2]=d;m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&65535;b[a>>1]=s;i=e;return 1}function Dgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+8)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){j=k;k=c[j+4>>2]|0;h=f;c[h>>2]=c[j>>2];c[h+4>>2]=k;c[g>>2]=l}else Bid(g,f,8);if(!(c[d>>2]&512)){m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&65535;b[a>>1]=s;i=e;return 1}d=XEi(c[f>>2]|0)|0;g=f+4|0;c[f>>2]=XEi(c[g>>2]|0)|0;c[g>>2]=d;m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&65535;b[a>>1]=s;i=e;return 1}function Egd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+8)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){j=k;k=c[j+4>>2]|0;h=f;c[h>>2]=c[j>>2];c[h+4>>2]=k;c[g>>2]=l}else Bid(g,f,8);if(!(c[d>>2]&512)){m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&255;a[b>>0]=s;i=e;return 1}d=XEi(c[f>>2]|0)|0;g=f+4|0;c[f>>2]=XEi(c[g>>2]|0)|0;c[g>>2]=d;m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&255;a[b>>0]=s;i=e;return 1}function Fgd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+8)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){j=k;k=c[j+4>>2]|0;h=f;c[h>>2]=c[j>>2];c[h+4>>2]=k;c[g>>2]=l}else Bid(g,f,8);if(!(c[d>>2]&512)){m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&255;a[b>>0]=s;i=e;return 1}d=XEi(c[f>>2]|0)|0;g=f+4|0;c[f>>2]=XEi(c[g>>2]|0)|0;c[g>>2]=d;m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=o&255;a[b>>0]=s;i=e;return 1}function Ggd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+8)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){j=k;k=c[j+4>>2]|0;h=f;c[h>>2]=c[j>>2];c[h+4>>2]=k;c[g>>2]=l}else Bid(g,f,8);if(!(c[d>>2]&512)){m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=(o|0)!=0;t=(r|0)!=0;u=s|t;v=u&1;a[b>>0]=v;i=e;return 1}d=XEi(c[f>>2]|0)|0;g=f+4|0;c[f>>2]=XEi(c[g>>2]|0)|0;c[g>>2]=d;m=f;n=m;o=c[n>>2]|0;p=m+4|0;q=p;r=c[q>>2]|0;s=(o|0)!=0;t=(r|0)!=0;u=s|t;v=u&1;a[b>>0]=v;i=e;return 1}function Hgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;m=(l|0)<0;n=m<<31>>31;o=a;p=o;c[p>>2]=l;q=o+4|0;r=q;c[r>>2]=n;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;m=(l|0)<0;n=m<<31>>31;o=a;p=o;c[p>>2]=l;q=o+4|0;r=q;c[r>>2]=n;i=d;return 1}function Igd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;m=(l|0)<0;n=m<<31>>31;o=a;p=o;c[p>>2]=l;q=o+4|0;r=q;c[r>>2]=n;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;m=(l|0)<0;n=m<<31>>31;o=a;p=o;c[p>>2]=l;q=o+4|0;r=q;c[r>>2]=n;i=d;return 1}function Jgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;c[a>>2]=l;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;c[a>>2]=l;i=d;return 1}function Kgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;c[a>>2]=l;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;c[a>>2]=l;i=d;return 1}function Lgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;b[a>>1]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&65535;b[a>>1]=n;i=e;return 1}function Mgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;b[a>>1]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&65535;b[a>>1]=n;i=e;return 1}function Ngd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&255;a[b>>0]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&255;a[b>>0]=n;i=e;return 1}function Ogd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&255;a[b>>0]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&255;a[b>>0]=n;i=e;return 1}function Pgd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=(m|0)!=0;o=n&1;a[b>>0]=o;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=(m|0)!=0;o=n&1;a[b>>0]=o;i=e;return 1}function Qgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;m=a;n=m;c[n>>2]=l;o=m+4|0;p=o;c[p>>2]=0;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;m=a;n=m;c[n>>2]=l;o=m+4|0;p=o;c[p>>2]=0;i=d;return 1}function Rgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;m=a;n=m;c[n>>2]=l;o=m+4|0;p=o;c[p>>2]=0;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;m=a;n=m;c[n>>2]=l;o=m+4|0;p=o;c[p>>2]=0;i=d;return 1}function Sgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;c[a>>2]=l;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;c[a>>2]=l;i=d;return 1}function Tgd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=g+h|0;c[f>>2]=j;if((h|0)>=0?(k=g+(h+4)|0,k>>>0<=(c[b+20>>2]|0)>>>0):0){c[e>>2]=c[j>>2];c[f>>2]=k}else Bid(f,e,4);f=c[e>>2]|0;if(!(c[b>>2]&512)){l=f;c[a>>2]=l;i=d;return 1}b=XEi(f|0)|0;c[e>>2]=b;l=b;c[a>>2]=l;i=d;return 1}function Ugd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;b[a>>1]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&65535;b[a>>1]=n;i=e;return 1}function Vgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;b[a>>1]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&65535;b[a>>1]=n;i=e;return 1}function Wgd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&255;a[b>>0]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&255;a[b>>0]=n;i=e;return 1}function Xgd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=m&255;a[b>>0]=n;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=m&255;a[b>>0]=n;i=e;return 1}function Ygd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);g=c[f>>2]|0;if(!(c[d>>2]&512)){m=g;n=(m|0)!=0;o=n&1;a[b>>0]=o;i=e;return 1}d=XEi(g|0)|0;c[f>>2]=d;m=d;n=(m|0)!=0;o=n&1;a[b>>0]=o;i=e;return 1}function Zgd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;o=a;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m&65535;o=a;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}function _gd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;o=a;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m&65535;o=a;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}function $gd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;c[a>>2]=n;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m&65535;c[a>>2]=n;i=e;return 1}function ahd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m&65535;c[a>>2]=n;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m&65535;c[a>>2]=n;i=e;return 1}function bhd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;b[a>>1]=m;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;b[a>>1]=m;i=e;return 1}function chd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;b[a>>1]=m;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;b[a>>1]=m;i=e;return 1}function dhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+2)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){b[g>>1]=b[l>>1]|0;c[h>>2]=m}else Bid(h,g,2);h=b[g>>1]|0;if(!(c[e>>2]&512)){n=h&255;a[d>>0]=n;i=f;return 1}else{e=h&65535;h=e>>>8;b[g>>1]=e<<8|h;n=h&255;a[d>>0]=n;i=f;return 1}return 0}function ehd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+2)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){b[g>>1]=b[l>>1]|0;c[h>>2]=m}else Bid(h,g,2);h=b[g>>1]|0;if(!(c[e>>2]&512)){n=h&255;a[d>>0]=n;i=f;return 1}else{e=h&65535;h=e>>>8;b[g>>1]=e<<8|h;n=h&255;a[d>>0]=n;i=f;return 1}return 0}function fhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+2)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){b[g>>1]=b[l>>1]|0;c[h>>2]=m}else Bid(h,g,2);h=b[g>>1]|0;if(!(c[e>>2]&512)){n=h;o=n<<16>>16!=0;p=o&1;a[d>>0]=p;i=f;return 1}e=h&65535;h=(e<<8|e>>>8)&65535;b[g>>1]=h;n=h;o=n<<16>>16!=0;p=o&1;a[d>>0]=p;i=f;return 1}function ghd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m<<16>>16;o=(n|0)<0;p=o<<31>>31;q=a;r=q;c[r>>2]=n;s=q+4|0;t=s;c[t>>2]=p;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m<<16>>16;o=(n|0)<0;p=o<<31>>31;q=a;r=q;c[r>>2]=n;s=q+4|0;t=s;c[t>>2]=p;i=e;return 1}function hhd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m<<16>>16;o=(n|0)<0;p=o<<31>>31;q=a;r=q;c[r>>2]=n;s=q+4|0;t=s;c[t>>2]=p;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m<<16>>16;o=(n|0)<0;p=o<<31>>31;q=a;r=q;c[r>>2]=n;s=q+4|0;t=s;c[t>>2]=p;i=e;return 1}function ihd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m<<16>>16;c[a>>2]=n;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m<<16>>16;c[a>>2]=n;i=e;return 1}function jhd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;n=m<<16>>16;c[a>>2]=n;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;n=m<<16>>16;c[a>>2]=n;i=e;return 1}function khd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;b[a>>1]=m;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;b[a>>1]=m;i=e;return 1}function lhd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+2)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){b[f>>1]=b[k>>1]|0;c[g>>2]=l}else Bid(g,f,2);g=b[f>>1]|0;if(!(c[d>>2]&512)){m=g;b[a>>1]=m;i=e;return 1}d=g&65535;g=(d<<8|d>>>8)&65535;b[f>>1]=g;m=g;b[a>>1]=m;i=e;return 1}function mhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+2)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){b[g>>1]=b[l>>1]|0;c[h>>2]=m}else Bid(h,g,2);h=b[g>>1]|0;if(!(c[e>>2]&512)){n=h&255;a[d>>0]=n;i=f;return 1}else{e=h&65535;h=e>>>8;b[g>>1]=e<<8|h;n=h&255;a[d>>0]=n;i=f;return 1}return 0}function nhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+2)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){b[g>>1]=b[l>>1]|0;c[h>>2]=m}else Bid(h,g,2);h=b[g>>1]|0;if(!(c[e>>2]&512)){n=h&255;a[d>>0]=n;i=f;return 1}else{e=h&65535;h=e>>>8;b[g>>1]=e<<8|h;n=h&255;a[d>>0]=n;i=f;return 1}return 0}function ohd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+2)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){b[g>>1]=b[l>>1]|0;c[h>>2]=m}else Bid(h,g,2);h=b[g>>1]|0;if(!(c[e>>2]&512)){n=h;o=n<<16>>16!=0;p=o&1;a[d>>0]=p;i=f;return 1}e=h&65535;h=(e<<8|e>>>8)&65535;b[g>>1]=h;n=h;o=n<<16>>16!=0;p=o&1;a[d>>0]=p;i=f;return 1}function phd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l&255;n=b;o=n;c[o>>2]=m;p=n+4|0;q=p;c[q>>2]=0;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l&255;n=b;o=n;c[o>>2]=m;p=n+4|0;q=p;c[q>>2]=0;i=e;return 1}function qhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l&255;n=b;o=n;c[o>>2]=m;p=n+4|0;q=p;c[q>>2]=0;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l&255;n=b;o=n;c[o>>2]=m;p=n+4|0;q=p;c[q>>2]=0;i=e;return 1}function rhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l&255;c[b>>2]=m;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l&255;c[b>>2]=m;i=e;return 1}function shd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l&255;c[b>>2]=m;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l&255;c[b>>2]=m;i=e;return 1}function thd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){e=a[l>>0]|0;a[g>>0]=e;c[h>>2]=j+(k+1);m=e;n=m&255;b[d>>1]=n;i=f;return 1}Bid(h,g,1);m=a[g>>0]|0;n=m&255;b[d>>1]=n;i=f;return 1}function uhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){e=a[l>>0]|0;a[g>>0]=e;c[h>>2]=j+(k+1);m=e;n=m&255;b[d>>1]=n;i=f;return 1}Bid(h,g,1);m=a[g>>0]|0;n=m&255;b[d>>1]=n;i=f;return 1}function vhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;a[b>>0]=l;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;a[b>>0]=l;i=e;return 1}function whd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;a[b>>0]=l;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;a[b>>0]=l;i=e;return 1}function xhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l<<24>>24!=0;n=m&1;a[b>>0]=n;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l<<24>>24!=0;n=m&1;a[b>>0]=n;i=e;return 1}function yhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l<<24>>24;n=(m|0)<0;o=n<<31>>31;p=b;q=p;c[q>>2]=m;r=p+4|0;s=r;c[s>>2]=o;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l<<24>>24;n=(m|0)<0;o=n<<31>>31;p=b;q=p;c[q>>2]=m;r=p+4|0;s=r;c[s>>2]=o;i=e;return 1}function zhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l<<24>>24;n=(m|0)<0;o=n<<31>>31;p=b;q=p;c[q>>2]=m;r=p+4|0;s=r;c[s>>2]=o;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l<<24>>24;n=(m|0)<0;o=n<<31>>31;p=b;q=p;c[q>>2]=m;r=p+4|0;s=r;c[s>>2]=o;i=e;return 1}function Ahd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l<<24>>24;c[b>>2]=m;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l<<24>>24;c[b>>2]=m;i=e;return 1}function Bhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l<<24>>24;c[b>>2]=m;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l<<24>>24;c[b>>2]=m;i=e;return 1}function Chd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){e=a[l>>0]|0;a[g>>0]=e;c[h>>2]=j+(k+1);m=e;n=m<<24>>24;b[d>>1]=n;i=f;return 1}Bid(h,g,1);m=a[g>>0]|0;n=m<<24>>24;b[d>>1]=n;i=f;return 1}function Dhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){e=a[l>>0]|0;a[g>>0]=e;c[h>>2]=j+(k+1);m=e;n=m<<24>>24;b[d>>1]=n;i=f;return 1}Bid(h,g,1);m=a[g>>0]|0;n=m<<24>>24;b[d>>1]=n;i=f;return 1}function Ehd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;a[b>>0]=l;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;a[b>>0]=l;i=e;return 1}function Fhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;a[b>>0]=l;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;a[b>>0]=l;i=e;return 1}function Ghd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(h+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=h+(j+1);l=d;m=l<<24>>24!=0;n=m&1;a[b>>0]=n;i=e;return 1}Bid(g,f,1);l=a[f>>0]|0;m=l<<24>>24!=0;n=m&1;a[b>>0]=n;i=e;return 1}function Hhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;n=m&255;o=b;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;n=m&255;o=b;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}function Ihd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;n=m&255;o=b;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;n=m&255;o=b;p=o;c[p>>2]=n;q=o+4|0;r=q;c[r>>2]=0;i=e;return 1}function Jhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;n=m&255;c[b>>2]=n;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;n=m&255;c[b>>2]=n;i=e;return 1}function Khd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;n=m&255;c[b>>2]=n;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;n=m&255;c[b>>2]=n;i=e;return 1}function Lhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+1)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){e=a[l>>0]|0;a[g>>0]=e;c[h>>2]=m;n=e;o=n&255;b[d>>1]=o;i=f;return 1}Bid(h,g,1);n=a[g>>0]|0;o=n&255;b[d>>1]=o;i=f;return 1}function Mhd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=e+12|0;j=c[e+16>>2]|0;k=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+1)|0,m>>>0<=(c[e+20>>2]|0)>>>0):0){e=a[l>>0]|0;a[g>>0]=e;c[h>>2]=m;n=e;o=n&255;b[d>>1]=o;i=f;return 1}Bid(h,g,1);n=a[g>>0]|0;o=n&255;b[d>>1]=o;i=f;return 1}function Nhd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;a[b>>0]=m;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;a[b>>0]=m;i=e;return 1}function Ohd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;a[b>>0]=m;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;a[b>>0]=m;i=e;return 1}function Phd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=d+12|0;h=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+1)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){d=a[k>>0]|0;a[f>>0]=d;c[g>>2]=l;m=d;a[b>>0]=m;i=e;return 1}Bid(g,f,1);m=a[f>>0]|0;a[b>>0]=m;i=e;return 1}function Qhd(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k+8|0;m=k+4|0;n=k;if((g|0)<0){g=c[h>>2]|0;o=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;a[b>>0]=o;a[b+1>>0]=o>>8;a[b+2>>0]=o>>16;a[b+3>>0]=o>>24;o=(c[h>>2]|0)+4|0;c[h>>2]=o;g=b+4|0;p=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;a[g>>0]=p;a[g+1>>0]=p>>8;a[g+2>>0]=p>>16;a[g+3>>0]=p>>24;p=(c[h>>2]|0)+4|0;c[h>>2]=p;g=b+8|0;o=d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24;a[g>>0]=o;a[g+1>>0]=o>>8;a[g+2>>0]=o>>16;a[g+3>>0]=o>>24;o=(c[h>>2]|0)+4|0;c[h>>2]=o;g=b+12|0;p=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;a[g>>0]=p;a[g+1>>0]=p>>8;a[g+2>>0]=p>>16;a[g+3>>0]=p>>24;p=(c[h>>2]|0)+4|0;c[h>>2]=p;q=p}else q=c[h>>2]|0;p=b+16|0;g=d[q>>0]|d[q+1>>0]<<8|d[q+2>>0]<<16|d[q+3>>0]<<24;a[p>>0]=g;a[p+1>>0]=g>>8;a[p+2>>0]=g>>16;a[p+3>>0]=g>>24;g=(c[h>>2]|0)+4|0;c[h>>2]=g;q=p+4|0;o=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;a[q>>0]=o;a[q+1>>0]=o>>8;a[q+2>>0]=o>>16;a[q+3>>0]=o>>24;o=(c[h>>2]|0)+4|0;c[h>>2]=o;q=b+24|0;g=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;a[q>>0]=g;a[q+1>>0]=g>>8;a[q+2>>0]=g>>16;a[q+3>>0]=g>>24;g=(c[h>>2]|0)+4|0;c[h>>2]=g;q=p+12|0;p=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;a[q>>0]=p;a[q+1>>0]=p>>8;a[q+2>>0]=p>>16;a[q+3>>0]=p>>24;c[h>>2]=(c[h>>2]|0)+4;if(!f){r=1;i=k;return r|0}c[n>>2]=c[153128];c[l+0>>2]=c[n+0>>2];n=bOb(48,l,0,16,3653512,195)|0;hid(n);if(oid(n,h,j,e,0)|0){c[b+36>>2]=n;r=1;i=k;return r|0}b=c[153128]|0;if(n)ogd(n);c[m>>2]=b;c[l+0>>2]=c[m+0>>2];eOb(n,l);r=0;i=k;return r|0}function Rhd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/24|0)+1|0;if(g>>>0>178956970)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/24|0;if(k>>>0<89478485){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/24|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=178956970;r=(l|0)/24|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*24|0)|0;o=r;p=s}s=n+(o*24|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];c[s+16>>2]=c[b+16>>2];c[s+20>>2]=c[b+20>>2]}b=n+((((p|0)/-24|0)+o|0)*24|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*24|0);c[h>>2]=n+(m*24|0);if(!f){i=d;return}ACi(f);i=d;return}function Shd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+4|0;h=c[g>>2]|0;j=c[a>>2]|0;k=(h>>>0)/(j>>>0)|0;l=(h>>>0)%(j>>>0)|0;j=a+12|0;h=a+20|0;if((k|0)!=(c[h>>2]|0)){m=j;n=c[m>>2]|0;o=n+(k<<2)|0;p=c[o>>2]|0;q=c[p>>2]|0;r=q+(l<<5)|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;c[r+24>>2]=0;c[r+28>>2]=0;s=c[g>>2]|0;t=s+1|0;c[g>>2]=t;i=b;return}u=a+8|0;c[f>>2]=c[u>>2];c[d+0>>2]=c[f+0>>2];f=bOb(16,d,0,16,3653512,90)|0;v=c[a>>2]|0;w=c[u>>2]|0;c[f+4>>2]=w;c[f+8>>2]=v;c[f+12>>2]=v;c[e>>2]=w;c[d+0>>2]=c[e+0>>2];c[f>>2]=cOb(v<<5,4,d,0,3653512,352)|0;v=(c[h>>2]|0)+1|0;c[h>>2]=v;w=a+24|0;u=c[w>>2]|0;x=u&2147483647;if(v>>>0>x>>>0){y=u<<1;z=(y|0)==0?1:y;do if(x>>>0<z>>>0)if((u|0)>-1){c[w>>2]=z;y=c[j>>2]|0;c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];c[j>>2]=hOb(y,z<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];y=cOb(z<<2,4,d,0,3653512,352)|0;YEi(y|0,c[j>>2]|0,c[h>>2]<<2|0)|0;c[w>>2]=z;c[j>>2]=y;break}while(0);A=c[h>>2]|0}else A=v;c[(c[j>>2]|0)+(A+-1<<2)>>2]=f;m=j;n=c[m>>2]|0;o=n+(k<<2)|0;p=c[o>>2]|0;q=c[p>>2]|0;r=q+(l<<5)|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;c[r+24>>2]=0;c[r+28>>2]=0;s=c[g>>2]|0;t=s+1|0;c[g>>2]=t;i=b;return}function Thd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;j=b+4|0;k=c[j>>2]|0;l=k+-1|0;m=c[b>>2]|0;n=b+12|0;o=(l>>>0)%(m>>>0)|0;p=c[c[(c[n>>2]|0)+(((l>>>0)/(m>>>0)|0)<<2)>>2]>>2]|0;if(!(a[p+(o<<5)>>0]&1)){q=k;r=m}else{m=c[p+(o<<5)+8>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(m,e);q=c[j>>2]|0;r=c[b>>2]|0}m=q+-1|0;c[j>>2]=m;j=b+20|0;q=c[j>>2]|0;if((((m>>>0)/(r>>>0)|0)+1|0)>>>0>=q>>>0){i=d;return}r=c[(c[n>>2]|0)+(q+-1<<2)>>2]|0;q=c[b+8>>2]|0;if((r|0)!=0?(c[r+12>>2]|0)>-1:0){b=c[r>>2]|0;c[g>>2]=c[r+4>>2];c[e+0>>2]=c[g+0>>2];eOb(b,e);c[r>>2]=0}c[h>>2]=q;c[e+0>>2]=c[h+0>>2];eOb(r,e);e=(c[j>>2]|0)+-1|0;c[(c[n>>2]|0)+(e<<2)>>2]=0;c[j>>2]=e;i=d;return}function Uhd(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;if((f|0)<0){f=c[g>>2]|0;c[a>>2]=XEi(d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24|0)|0;n=f+4|0;c[g>>2]=n;c[a+4>>2]=XEi(d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24|0)|0;n=f+8|0;c[g>>2]=n;c[a+8>>2]=XEi(d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24|0)|0;n=f+12|0;c[g>>2]=n;c[a+12>>2]=XEi(d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24|0)|0;n=f+16|0;c[g>>2]=n;o=n}else o=c[g>>2]|0;n=a+16|0;c[n>>2]=XEi(d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24|0)|0;f=o+4|0;c[g>>2]=f;c[n+4>>2]=XEi(d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24|0)|0;f=o+8|0;c[g>>2]=f;c[a+24>>2]=XEi(d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24|0)|0;f=o+12|0;c[g>>2]=f;c[n+12>>2]=XEi(d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24|0)|0;c[g>>2]=o+16;if(!e){p=1;i=j;return p|0}c[m>>2]=c[153128];c[k+0>>2]=c[m+0>>2];m=bOb(48,k,0,16,3653512,195)|0;hid(m);if(oid(m,g,h,b,1)|0){c[a+36>>2]=m;p=1;i=j;return p|0}a=c[153128]|0;if(m)ogd(m);c[l>>2]=a;c[k+0>>2]=c[l+0>>2];eOb(m,k);p=0;i=j;return p|0}function Vhd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+112|0;f=e+52|0;g=e+48|0;h=e;hid(h);if((h|0)!=(b|0)){j=c[h>>2]|0;k=(c[h+8>>2]|0)*24|0;l=(k|0)/24|0;m=b+8|0;c[m>>2]=l;n=b+12|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<l>>>0)if((o|0)>-1){c[n>>2]=l;p=c[b>>2]|0;c[g>>2]=c[b+4>>2];c[f+0>>2]=c[g+0>>2];q=hOb(p,k,4,f,0,3653512,370)|0;c[b>>2]=q;r=q;break}else{c[g>>2]=c[b+4>>2];c[f+0>>2]=c[g+0>>2];q=cOb(k,4,f,0,3653512,352)|0;YEi(q|0,c[b>>2]|0,(c[m>>2]|0)*24|0)|0;c[n>>2]=l;c[b>>2]=q;r=q;break}else r=c[b>>2]|0;while(0);YEi(r|0,j|0,(c[m>>2]|0)*24|0)|0;m=b+16|0;j=c[h+16>>2]|0;r=c[h+24>>2]|0;l=b+24|0;c[l>>2]=r;n=b+28|0;k=c[n>>2]|0;do if((k&2147483647)>>>0<r>>>0)if((k|0)>-1){c[n>>2]=r;o=c[m>>2]|0;c[g>>2]=c[b+20>>2];c[f+0>>2]=c[g+0>>2];q=hOb(o,r,1,f,0,3653512,370)|0;c[m>>2]=q;s=q;break}else{c[g>>2]=c[b+20>>2];c[f+0>>2]=c[g+0>>2];q=cOb(r,1,f,0,3653512,352)|0;YEi(q|0,c[m>>2]|0,c[l>>2]|0)|0;c[n>>2]=r;c[m>>2]=q;s=q;break}else s=c[m>>2]|0;while(0);YEi(s|0,j|0,c[l>>2]|0)|0;l=b+32|0;j=c[h+32>>2]|0;s=c[h+40>>2]<<2;m=s>>2;r=b+40|0;c[r>>2]=m;n=b+44|0;k=c[n>>2]|0;do if((k&2147483647)>>>0<m>>>0)if((k|0)>-1){c[n>>2]=m;q=c[l>>2]|0;c[g>>2]=c[b+36>>2];c[f+0>>2]=c[g+0>>2];o=hOb(q,s,4,f,0,3653512,370)|0;c[l>>2]=o;t=o;break}else{c[g>>2]=c[b+36>>2];c[f+0>>2]=c[g+0>>2];o=cOb(s,4,f,0,3653512,352)|0;YEi(o|0,c[l>>2]|0,c[r>>2]<<2|0)|0;c[n>>2]=m;c[l>>2]=o;t=o;break}else t=c[l>>2]|0;while(0);YEi(t|0,j|0,c[r>>2]<<2|0)|0}ogd(h);h=a+8|0;Zcd(f,b,d,a,c[(xQb((c[h>>2]|0)>>>21)|0)+24>>2]|0);if((c[h>>2]&-2097152|0)!=239075328){u=c[a>>2]|0;v=u+76|0;w=c[v>>2]|0;In[w&4095](a,f);i=e;return}h=c[a+20>>2]|0;if(!h)x=0;else x=esc(vsc(h)|0)|0;_cd(f,h,x);u=c[a>>2]|0;v=u+76|0;w=c[v>>2]|0;In[w&4095](a,f);i=e;return}function Whd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[d>>2]|0;a:do if(g>>>0<e>>>0){h=g;while(1){if(!(a[h>>0]|0)){j=h;break a}k=h+1|0;c[d>>2]=k;if(k>>>0<e>>>0)h=k;else{j=k;break}}}else j=g;while(0);e=j-g|0;h=a[b>>0]|0;if(!(h&1)){l=10;m=h}else{h=c[b>>2]|0;l=(h&-2)+-1|0;m=h&255}if(e>>>0>l>>>0){if(!(m&1))n=(m&255)>>>1;else n=c[b+4>>2]|0;TXb(b,l,e-l|0,n,0,n,0);o=a[b>>0]|0}else o=m;if(!(o&1))p=b+1|0;else p=c[b+8>>2]|0;if((g|0)==(j|0))q=p;else{o=g;g=p;while(1){a[g>>0]=a[o>>0]|0;o=o+1|0;if((o|0)==(j|0))break;else g=g+1|0}q=p+e|0}a[q>>0]=0;if(!(a[b>>0]&1)){a[b>>0]=e<<1;r=c[d>>2]|0;s=r+1|0;c[d>>2]=s;i=f;return 1}else{c[b+4>>2]=e;r=c[d>>2]|0;s=r+1|0;c[d>>2]=s;i=f;return 1}return 0}function Xhd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=620408;c[e+4>>2]=b;Yhd(e,c[a+4>>2]|0,64)|0;i=d;return}function Yhd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+64|0;f=e+48|0;g=e+40|0;h=e+36|0;j=e;if((d&64|0)==0|(b|0)==0){i=e;return b|0}c[h>>2]=b;d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(f,d,h);k=c[f>>2]|0;l=c[d+28>>2]|0;if((k|0)==-1){m=l+(c[d+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((m|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[m+4>>2]|0,(d|0)!=0):0)n=d;else o=10}else o=10;if((o|0)==10){d=hQb(b)|0;if(!d){i=e;return b|0}else n=d}d=c[a+4>>2]|0;m=d+4|0;h=c[m>>2]|0;do if(h){k=h;while(1){l=c[k+16>>2]|0;if((l|0)>(b|0)){p=c[k>>2]|0;if(!p){q=k;r=k;o=14;break}else{k=p;continue}}if((l|0)>=(b|0)){s=k;o=18;break}l=k+4|0;p=c[l>>2]|0;if(!p){t=l;u=k;o=17;break}else k=p}if((o|0)==14){c[f>>2]=r;v=q;w=r;break}else if((o|0)==17){c[f>>2]=u;v=t;w=u;break}else if((o|0)==18){c[f>>2]=s;v=f;w=s;break}}else{k=d+4|0;c[f>>2]=k;v=k;w=k}while(0);if(c[v>>2]|0){i=e;return b|0}s=xCi(20)|0;c[s+16>>2]=b;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=w;c[v>>2]=s;w=c[c[d>>2]>>2]|0;if(!w)x=s;else{c[d>>2]=w;x=c[v>>2]|0}GN(c[m>>2]|0,x);x=d+8|0;c[x>>2]=(c[x>>2]|0)+1;hdd(j,0,0);c[j+12>>2]=a;In[c[(c[n>>2]|0)+72>>2]&4095](n,j);n=c[j+16>>2]|0;if(!n){i=e;return b|0}a=j+20|0;j=c[a>>2]|0;if((j|0)!=(n|0))c[a>>2]=j+(~((j+-4-n|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);i=e;return b|0}function Zhd(a){a=a|0;return}function _hd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function $hd(a){a=a|0;return (c[c[a>>2]>>2]|0)+((c[a+4>>2]|0)*24|0)|0}function aid(a){a=a|0;var b=0,d=0;b=c[a>>2]|0;d=c[(c[b>>2]|0)+((c[a+4>>2]|0)*24|0)+8>>2]|0;return ((d|0)<0?c[142254]|0:c[b+16>>2]|0)+(d&2147483647)|0}function bid(a){a=a|0;var b=0,d=0;b=c[a>>2]|0;d=c[(c[b>>2]|0)+((c[a+4>>2]|0)*24|0)+4>>2]|0;return ((d|0)<0?c[142254]|0:c[b+16>>2]|0)+(d&2147483647)|0}function cid(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;f=c[b>>2]|0;g=c[b+4>>2]|0;b=c[f>>2]|0;h=g+1|0;if((h|0)<(c[f+8>>2]|0)?(d[b+(h*24|0)+2>>0]|0|0)==((d[b+(g*24|0)+2>>0]|0)+1|0):0){c[a>>2]=f;c[a+4>>2]=h;i=e;return}c[a>>2]=0;c[a+4>>2]=0;i=e;return}function did(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[d>>2]|0;g=c[d+4>>2]|0;d=c[f>>2]|0;h=a[d+(g*24|0)+2>>0]|0;j=d+((c[f+8>>2]|0)*24|0)|0;k=d+(g*24|0)|0;while(1){g=k+24|0;if(g>>>0>=j>>>0){l=7;break}m=a[k+26>>0]|0;if((m&255)>(h&255))k=g;else{n=m;o=g;break}}if((l|0)==7){c[b>>2]=0;c[b+4>>2]=0;i=e;return}if(n<<24>>24==h<<24>>24){c[b>>2]=f;c[b+4>>2]=(o-d|0)/24|0;i=e;return}else{c[b>>2]=0;c[b+4>>2]=0;i=e;return}}function eid(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[b>>2]|0;g=c[b+4>>2]|0;b=c[f>>2]|0;h=(d[b+(g*24|0)+2>>0]|0)+-1|0;j=b+(g*24|0)|0;while(1){g=j+-24|0;if(g>>>0<b>>>0){k=5;break}if((d[j+-22>>0]|0|0)==(h|0)){l=g;k=4;break}else j=g}if((k|0)==4){c[a>>2]=f;c[a+4>>2]=(l-b|0)/24|0;i=e;return}else if((k|0)==5){c[a>>2]=0;c[a+4>>2]=0;i=e;return}}function fid(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=d;d=c[f+4>>2]|0;g=c[f>>2]|0;a:while(1){f=b;c[f>>2]=g;c[f+4>>2]=d;f=g;h=c[f>>2]|0;j=a[h+(d*24|0)+2>>0]|0;k=h+((c[f+8>>2]|0)*24|0)|0;f=h+(d*24|0)|0;while(1){l=f+24|0;if(l>>>0>=k>>>0){m=7;break a}n=a[f+26>>0]|0;if((n&255)>(j&255))f=l;else{o=n;p=l;break}}if(o<<24>>24!=j<<24>>24){m=7;break}if((g|0)==0&0==0){m=7;break}else d=(p-h|0)/24|0}if((m|0)==7){i=e;return}}function gid(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=c[a>>2]|0;if(d>>>0>=(c[e+40>>2]|0)>>>0){f=-1;i=b;return f|0}f=c[(c[e+32>>2]|0)+(d<<2)>>2]|0;i=b;return f|0}function hid(d){d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[153128]|0;c[d+4>>2]=h;j=d+8|0;c[j>>2]=1;c[d+12>>2]=1;c[g>>2]=h;c[f+0>>2]=c[g+0>>2];g=cOb(24,4,f,0,3653512,352)|0;c[d>>2]=g;f=c[153128]|0;c[d+16>>2]=0;c[d+20>>2]=f;c[d+24>>2]=0;c[d+28>>2]=0;f=c[153128]|0;c[d+32>>2]=0;c[d+36>>2]=f;c[d+40>>2]=0;c[d+44>>2]=0;d=(c[j>>2]|0)+-1|0;a[g+(d*24|0)+2>>0]=0;c[g+(d*24|0)+8>>2]=0;c[g+(d*24|0)+4>>2]=0;c[g+(d*24|0)+16>>2]=-1;a[g+(d*24|0)+3>>0]=0;b[g+(d*24|0)>>1]=1;c[g+(d*24|0)+20>>2]=0;c[g+(d*24|0)+12>>2]=-1;i=e;return}function iid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;jid(b,c[d+4>>2]|0);d=(c[b+8>>2]|0)+-1|0;c[a>>2]=b;c[a+4>>2]=d;i=e;return}function jid(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;h=g+4|0;j=g;k=e+8|0;l=(c[k>>2]|0)+1|0;c[k>>2]=l;m=e+12|0;n=c[m>>2]|0;o=n&2147483647;if(l>>>0>o>>>0){p=n<<1;q=(p|0)==0?1:p;do if(o>>>0<q>>>0)if((n|0)>-1){c[m>>2]=q;p=c[e>>2]|0;c[j>>2]=c[e+4>>2];c[h+0>>2]=c[j+0>>2];c[e>>2]=hOb(p,q*24|0,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[e+4>>2];c[h+0>>2]=c[j+0>>2];p=cOb(q*24|0,4,h,0,3653512,352)|0;YEi(p|0,c[e>>2]|0,(c[k>>2]|0)*24|0)|0;c[m>>2]=q;c[e>>2]=p;break}while(0);r=c[k>>2]|0}else r=l;l=r+-1|0;r=c[e>>2]|0;a[r+(l*24|0)+2>>0]=(d[r+(f*24|0)+2>>0]|0)+1;c[r+(l*24|0)+8>>2]=0;c[r+(l*24|0)+4>>2]=0;c[r+(l*24|0)+16>>2]=-1;a[r+(l*24|0)+3>>0]=0;b[r+(l*24|0)>>1]=1;c[r+(l*24|0)+20>>2]=0;c[r+(l*24|0)+12>>2]=-1;i=g;return}function kid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;qid((c[a>>2]|0)+((c[b+4>>2]|0)*24|0)+4|0,a+16|0,d);i=e;return}function lid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;qid((c[a>>2]|0)+((c[b+4>>2]|0)*24|0)+8|0,a+16|0,d);i=e;return}function mid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+4|0;b=c[h>>2]|0;j=a+32|0;k=a+40|0;if(b>>>0<(c[k>>2]|0)>>>0){l=b;m=c[j>>2]|0;n=m+(l<<2)|0;c[n>>2]=d;i=e;return}o=b+1|0;b=a+44|0;p=c[b>>2]|0;q=p&2147483647;do if(q>>>0<o>>>0?(r=p<<1,s=r>>>0>o>>>0?r:o,q>>>0<s>>>0):0)if((p|0)>-1){c[b>>2]=s;r=c[j>>2]|0;c[g>>2]=c[a+36>>2];c[f+0>>2]=c[g+0>>2];c[j>>2]=hOb(r,s<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[a+36>>2];c[f+0>>2]=c[g+0>>2];r=cOb(s<<2,4,f,0,3653512,352)|0;YEi(r|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[b>>2]=s;c[j>>2]=r;break}while(0);b=c[k>>2]|0;if(b>>>0<o>>>0?(f=c[j>>2]|0,g=f+(o<<2)|0,(b|0)!=(o|0)):0){a=f+(b<<2)|0;do{if(a)c[a>>2]=-1;a=a+4|0}while((a|0)!=(g|0))}c[k>>2]=o;l=c[h>>2]|0;m=c[j>>2]|0;n=m+(l<<2)|0;c[n>>2]=d;i=e;return}function nid(a,f,g,h,j){a=a|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+16|0;k=h+4|0;l=h;m=c[f>>2]|0;n=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;o=m+4|0;c[f>>2]=o;p=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;c[f>>2]=m+8;if(j){o=XEi(n|0)|0;q=XEi(p|0)|0;r=o}else{q=p;r=n}n=r*24|0;if((m+(n+q+8)|0)>>>0>g>>>0){s=0;i=h;return s|0}g=a+8|0;c[g>>2]=r;m=a+12|0;p=c[m>>2]|0;do if((p&2147483647)>>>0<r>>>0)if((p|0)>-1){c[m>>2]=r;o=c[a>>2]|0;c[l>>2]=c[a+4>>2];c[k+0>>2]=c[l+0>>2];c[a>>2]=hOb(o,n,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[a+4>>2];c[k+0>>2]=c[l+0>>2];o=cOb(n,4,k,0,3653512,352)|0;YEi(o|0,c[a>>2]|0,(c[g>>2]|0)*24|0)|0;c[m>>2]=r;c[a>>2]=o;break}while(0);m=a+16|0;g=a+24|0;c[g>>2]=q;p=a+28|0;o=c[p>>2]|0;do if((o&2147483647)>>>0<q>>>0)if((o|0)>-1){c[p>>2]=q;t=c[m>>2]|0;c[l>>2]=c[a+20>>2];c[k+0>>2]=c[l+0>>2];c[m>>2]=hOb(t,q,1,k,0,3653512,370)|0;u=m;break}else{c[l>>2]=c[a+20>>2];c[k+0>>2]=c[l+0>>2];t=cOb(q,1,k,0,3653512,352)|0;YEi(t|0,c[m>>2]|0,c[g>>2]|0)|0;c[p>>2]=q;c[m>>2]=t;u=m;break}else u=m;while(0);YEi(c[a>>2]|0,c[f>>2]|0,n|0)|0;m=(c[f>>2]|0)+n|0;c[f>>2]=m;YEi(c[u>>2]|0,m|0,q|0)|0;c[f>>2]=(c[f>>2]|0)+q;if((r|0)==0|j^1){s=1;i=h;return s|0}j=c[a>>2]|0;a=0;do{q=j+(a*24|0)|0;f=e[q>>1]|0;b[q>>1]=f<<8|f>>>8;f=j+(a*24|0)+4|0;c[f>>2]=XEi(c[f>>2]|0)|0;f=j+(a*24|0)+8|0;c[f>>2]=XEi(c[f>>2]|0)|0;f=j+(a*24|0)+12|0;c[f>>2]=XEi(c[f>>2]|0)|0;f=j+(a*24|0)+16|0;c[f>>2]=XEi(c[f>>2]|0)|0;f=j+(a*24|0)+20|0;c[f>>2]=XEi(c[f>>2]|0)|0;a=a+1|0}while((a|0)!=(r|0));s=1;i=h;return s|0}function oid(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+8|0;j=g;if((e|0)>11|(e|0)==10){k=nid(a,b,d,0,f)|0;i=g;return k|0}if(f){c[h>>2]=a;c[h+4>>2]=0;k=rid(a,h,b,d,e)|0;i=g;return k|0}else{c[j>>2]=a;c[j+4>>2]=0;k=sid(a,j,b,d,e)|0;i=g;return k|0}return 0}function pid(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=i;i=i+16|0;h=g+8|0;j=g;k=c[e>>2]|0;l=c[e+4>>2]|0;e=c[k>>2]|0;m=c[f>>2]|0;n=c[f+4>>2]|0;f=c[m>>2]|0;if((c[e+(l*24|0)+12>>2]|0)!=(c[f+(n*24|0)+12>>2]|0)){o=0;i=g;return o|0}if((b[e+(l*24|0)>>1]|0)!=(b[f+(n*24|0)>>1]|0)){o=0;i=g;return o|0}p=c[e+(l*24|0)+8>>2]|0;q=c[k+16>>2]|0;r=c[142254]|0;s=((p|0)<0?r:q)+(p&2147483647)|0;p=c[f+(n*24|0)+8>>2]|0;t=c[m+16>>2]|0;u=((p|0)<0?r:t)+(p&2147483647)|0;do if(u)if(s){p=c[142256]|0;if(r>>>0<=s>>>0&p>>>0>s>>>0?r>>>0<=u>>>0&p>>>0>u>>>0:0){if((s|0)==(u|0))break;else o=0;i=g;return o|0}if(HEi(u,s)|0){o=0;i=g;return o|0}}else{v=0;w=5}else{v=s;w=5}while(0);if((w|0)==5?(v|0)!=(u|0):0){o=0;i=g;return o|0}u=c[e+(l*24|0)+4>>2]|0;v=((u|0)<0?r:q)+(u&2147483647)|0;u=c[f+(n*24|0)+4>>2]|0;q=((u|0)<0?r:t)+(u&2147483647)|0;do if(q)if(v){u=c[142256]|0;if(r>>>0<=v>>>0&u>>>0>v>>>0?r>>>0<=q>>>0&u>>>0>q>>>0:0){if((v|0)==(q|0))break;else o=0;i=g;return o|0}if(HEi(q,v)|0){o=0;i=g;return o|0}}else{x=0;w=12}else{x=v;w=12}while(0);if((w|0)==12?(x|0)!=(q|0):0){o=0;i=g;return o|0}if((c[f+(n*24|0)+20>>2]^c[e+(l*24|0)+20>>2])&16384){o=0;i=g;return o|0}q=l+1|0;if((q|0)<(c[k+8>>2]|0)?(d[e+(q*24|0)+2>>0]|0)==((d[e+(l*24|0)+2>>0]|0)+1|0):0){c[h>>2]=k;c[h+4>>2]=q;y=q;z=k}else{c[h>>2]=0;c[h+4>>2]=0;y=0;z=0}k=n+1|0;if((k|0)<(c[m+8>>2]|0)?(d[f+(k*24|0)+2>>0]|0)==((d[f+(n*24|0)+2>>0]|0)+1|0):0){c[j>>2]=m;c[j+4>>2]=k;A=z;B=m;C=y;D=k}else{c[j>>2]=0;c[j+4>>2]=0;A=z;B=0;C=y;D=0}while(1){y=(B|0)==0;if(!A){if(y){o=1;w=42;break}if((A|0)==0|(B|0)==0){o=0;w=42;break}}else if(y){o=0;w=42;break}if(!(pid(h,j)|0)){o=0;w=42;break}y=c[A>>2]|0;z=a[y+(C*24|0)+2>>0]|0;k=y+((c[A+8>>2]|0)*24|0)|0;m=y+(C*24|0)|0;while(1){n=m+24|0;if(n>>>0>=k>>>0){E=0;F=0;G=0;H=0;break}f=a[m+26>>0]|0;if((f&255)>(z&255))m=n;else{I=f;J=n;w=34;break}}if((w|0)==34){w=0;if(I<<24>>24==z<<24>>24){E=0;F=A;G=(J-y|0)/24|0;H=0}else{E=0;F=0;G=0;H=0}}m=h;c[m>>2]=E|F;c[m+4>>2]=G|H;m=c[B>>2]|0;k=a[m+(D*24|0)+2>>0]|0;n=m+((c[B+8>>2]|0)*24|0)|0;f=F;q=m+(D*24|0)|0;while(1){l=q+24|0;if(l>>>0>=n>>>0){K=0;L=0;M=0;N=0;break}e=a[q+26>>0]|0;if((e&255)>(k&255))q=l;else{O=e;P=l;w=39;break}}if((w|0)==39){w=0;if(O<<24>>24==k<<24>>24){K=0;L=B;M=(P-m|0)/24|0;N=0}else{K=0;L=0;M=0;N=0}}q=j;c[q>>2]=K|L;c[q+4>>2]=M|N;A=f;B=L;C=G;D=M}if((w|0)==42){i=g;return o|0}return 0}function qid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+4|0;g=e;h=mbc(pbc()|0,d)|0;if(h){c[a>>2]=h-(c[142254]|0)|-2147483648;i=e;return}h=c[b>>2]|0;j=b+8|0;k=c[j>>2]|0;l=h+k|0;a:do if((k|0)>0){m=h;while(1){if(!(HEi(m,d)|0)){n=m;break}m=m+((SEi(m|0)|0)+1)|0;if(m>>>0>=l>>>0)break a}c[a>>2]=n-h;i=e;return}while(0);n=SEi(d|0)|0;l=n+1|0;m=k+l|0;c[j>>2]=m;o=b+12|0;p=c[o>>2]|0;q=p&2147483647;do if(q>>>0<m>>>0?(r=p<<1,s=r>>>0>m>>>0?r:m,q>>>0<s>>>0):0)if((p|0)>-1){c[o>>2]=s;c[g>>2]=c[b+4>>2];c[f+0>>2]=c[g+0>>2];r=hOb(h,s,1,f,0,3653512,370)|0;c[b>>2]=r;t=r;break}else{c[g>>2]=c[b+4>>2];c[f+0>>2]=c[g+0>>2];r=cOb(s,1,f,0,3653512,352)|0;YEi(r|0,c[b>>2]|0,c[j>>2]|0)|0;c[o>>2]=s;c[b>>2]=r;t=r;break}else t=h;while(0);YEi(t+k|0,d|0,l|0)|0;c[a>>2]=(c[j>>2]|0)+~n;i=e;return}function rid(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;k=i;i=i+16|0;l=k;m=c[e>>2]|0;n=f+4|0;f=c[n>>2]|0;o=m+(f*24|0)|0;p=c[g>>2]|0;q=p;do{if(q>>>0>=h>>>0){r=q;s=4;break}t=(a[q>>0]|0)==0;q=q+1|0;c[g>>2]=q}while(!t);if((s|0)==4)c[g>>2]=r+1;if(!p){u=0;i=k;return u|0}r=e+16|0;qid((c[e>>2]|0)+(f*24|0)+4|0,r,p);p=m+(f*24|0)+4|0;q=c[p>>2]|0;do if((q|0)<=-1){t=c[142254]|0;v=t+(q&2147483647)|0;if((v|0)==(c[142288]|0)){c[p>>2]=(c[142270]|0)-t|-2147483648;break}if((v|0)==(c[142298]|0))c[p>>2]=(c[142304]|0)-t|-2147483648}while(0);p=c[g>>2]|0;q=p;do{if(q>>>0>=h>>>0){w=q;s=14;break}t=(a[q>>0]|0)==0;q=q+1|0;c[g>>2]=q}while(!t);if((s|0)==14)c[g>>2]=w+1;if(!p){u=0;i=k;return u|0}qid((c[e>>2]|0)+((c[n>>2]|0)*24|0)+8|0,r,p);p=c[g>>2]|0;c[m+(f*24|0)+12>>2]=XEi(d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24|0)|0;r=p+4|0;c[g>>2]=r;if((j|0)==2){w=p+8|0;c[g>>2]=w;x=w;y=12;z=8;s=18}else if((j|0)==3){w=(d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24)>>>24;q=p+8|0;c[g>>2]=q;a[m+(f*24|0)+3>>0]=w;w=XEi(d[q>>0]|d[q+1>>0]<<8|d[q+2>>0]<<16|d[q+3>>0]<<24|0)|0;q=p+12|0;c[g>>2]=q;b[o>>1]=w;A=q;B=16}else{x=r;y=8;z=4;s=18}if((s|0)==18){c[m+(f*24|0)+16>>2]=XEi(d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24|0)|0;x=p+y|0;c[g>>2]=x;y=(d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24)>>>24;x=p+(z+8)|0;c[g>>2]=x;a[m+(f*24|0)+3>>0]=y;y=XEi(d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24|0)|0;x=p+(z+12)|0;c[g>>2]=x;b[o>>1]=y;c[m+(f*24|0)+20>>2]=XEi(d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24|0)|0;x=z|16;z=p+x|0;c[g>>2]=z;A=z;B=x+4|0}x=XEi(d[A>>0]|d[A+1>>0]<<8|d[A+2>>0]<<16|d[A+3>>0]<<24|0)|0;c[g>>2]=p+B;B=c[155122]|0;p=B+1|0;c[155122]=p;if((B|0)>49|(x|0)<0|(x|0)>5e3){c[155122]=B;Krd(620432,0,3653512,540,1,0,0,0);u=0;i=k;return u|0}do if((x|0)>0){B=e+8|0;A=l+4|0;z=0;while(1){jid(e,c[n>>2]|0);f=(c[B>>2]|0)+-1|0;c[l>>2]=e;c[A>>2]=f;z=z+1|0;if(!(rid(e,l,g,h,j)|0))break;if((z|0)>=(x|0)){s=27;break}}if((s|0)==27){C=c[155122]|0;break}c[155122]=(c[155122]|0)+-1;u=0;i=k;return u|0}else C=p;while(0);c[155122]=C+-1;u=1;i=k;return u|0}function sid(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;i=i+16|0;l=k;m=c[e>>2]|0;n=f+4|0;f=c[n>>2]|0;o=m+(f*24|0)|0;p=c[g>>2]|0;q=p;do{if(q>>>0>=h>>>0){r=q;s=4;break}t=(a[q>>0]|0)==0;q=q+1|0;c[g>>2]=q}while(!t);if((s|0)==4)c[g>>2]=r+1;if(!p){u=0;i=k;return u|0}r=e+16|0;qid((c[e>>2]|0)+(f*24|0)+4|0,r,p);p=m+(f*24|0)+4|0;q=c[p>>2]|0;do if((q|0)<=-1){t=c[142254]|0;v=t+(q&2147483647)|0;if((v|0)==(c[142288]|0)){c[p>>2]=(c[142270]|0)-t|-2147483648;break}if((v|0)==(c[142298]|0))c[p>>2]=(c[142304]|0)-t|-2147483648}while(0);p=c[g>>2]|0;q=p;do{if(q>>>0>=h>>>0){w=q;s=14;break}t=(a[q>>0]|0)==0;q=q+1|0;c[g>>2]=q}while(!t);if((s|0)==14)c[g>>2]=w+1;if(!p){u=0;i=k;return u|0}qid((c[e>>2]|0)+((c[n>>2]|0)*24|0)+8|0,r,p);p=m+(f*24|0)+12|0;r=c[g>>2]|0;w=d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24;a[p>>0]=w;a[p+1>>0]=w>>8;a[p+2>>0]=w>>16;a[p+3>>0]=w>>24;w=c[g>>2]|0;p=w+4|0;c[g>>2]=p;if((j|0)==2){r=w+8|0;c[g>>2]=r;x=r;s=18}else if((j|0)==3){r=d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24;q=w+8|0;c[g>>2]=q;a[m+(f*24|0)+3>>0]=r;r=d[q>>0]|d[q+1>>0]<<8|d[q+2>>0]<<16|d[q+3>>0]<<24;q=w+12|0;c[g>>2]=q;b[o>>1]=r;y=q}else{x=p;s=18}if((s|0)==18){p=m+(f*24|0)+16|0;q=d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24;a[p>>0]=q;a[p+1>>0]=q>>8;a[p+2>>0]=q>>16;a[p+3>>0]=q>>24;q=c[g>>2]|0;p=q+4|0;c[g>>2]=p;x=d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24;p=q+8|0;c[g>>2]=p;a[m+(f*24|0)+3>>0]=x;x=d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24;p=q+12|0;c[g>>2]=p;b[o>>1]=x;x=m+(f*24|0)+20|0;f=d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24;a[x>>0]=f;a[x+1>>0]=f>>8;a[x+2>>0]=f>>16;a[x+3>>0]=f>>24;f=(c[g>>2]|0)+4|0;c[g>>2]=f;y=f}f=d[y>>0]|d[y+1>>0]<<8|d[y+2>>0]<<16|d[y+3>>0]<<24;c[g>>2]=y+4;y=c[155106]|0;x=y+1|0;c[155106]=x;if((y|0)>49|(f|0)<0|(f|0)>5e3){c[155106]=y;Krd(620432,0,3653512,540,1,0,0,0);u=0;i=k;return u|0}do if((f|0)>0){y=e+8|0;p=l+4|0;m=0;while(1){jid(e,c[n>>2]|0);o=(c[y>>2]|0)+-1|0;c[l>>2]=e;c[p>>2]=o;m=m+1|0;if(!(sid(e,l,g,h,j)|0))break;if((m|0)>=(f|0)){s=27;break}}if((s|0)==27){z=c[155106]|0;break}c[155106]=(c[155106]|0)+-1;u=0;i=k;return u|0}else z=x;while(0);c[155106]=z+-1;u=1;i=k;return u|0}function tid(b){b=b|0;var d=0;d=b+40|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=-1;a[b+32>>0]=0;c[b+36>>2]=0;return}function uid(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=b+12|0;c[h>>2]=d;j=mo[c[(c[d>>2]|0)+20>>2]&4095](d)|0;d=b+20|0;c[d>>2]=j;k=(e>>>0)/(j>>>0)|0;j=b+16|0;c[j>>2]=k;l=b+28|0;c[l>>2]=f+e;c[b+24>>2]=e;f=c[h>>2]|0;m=b+4|0;n=b+8|0;Dn[c[(c[f>>2]|0)+12>>2]&511](f,k,m,n);k=(c[l>>2]|0)-(da(c[d>>2]|0,c[j>>2]|0)|0)|0;l=(c[m>>2]|0)+k|0;k=c[n>>2]|0;c[n>>2]=l>>>0<k>>>0?l:k;xid(b,e,0);if(a[b+32>>0]|0){i=g;return}k=c[d>>2]|0;l=(e>>>0)/(k>>>0)|0;f=c[j>>2]|0;if((l|0)==(f|0)){o=l;p=k}else{k=c[h>>2]|0;In[c[(c[k>>2]|0)+16>>2]&4095](k,f);f=(e>>>0)/((c[d>>2]|0)>>>0)|0;c[j>>2]=f;k=c[h>>2]|0;Dn[c[(c[k>>2]|0)+12>>2]&511](k,f,m,n);o=c[j>>2]|0;p=c[d>>2]|0}d=e-(da(o,p)|0)|0;c[b>>2]=(c[m>>2]|0)+d;i=g;return}function vid(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];return}function wid(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+16|0;e=(da(c[a+20>>2]|0,c[d>>2]|0)|0)+((c[a>>2]|0)-(c[a+4>>2]|0))|0;xid(a,e,0);f=c[a+12>>2]|0;In[c[(c[f>>2]|0)+16>>2]&4095](f,c[d>>2]|0);c[d>>2]=-1;i=b;return e|0}function xid(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+112|0;g=f+84|0;h=f+48|0;j=f+12|0;k=f+24|0;l=f+96|0;m=f;n=f+36|0;o=f+72|0;p=f+60|0;q=b+32|0;if(a[q>>0]|0){i=f;return}r=e+d|0;e=b+12|0;s=c[e>>2]|0;if(r>>>0>(mo[c[(c[s>>2]|0)+28>>2]&4095](s)|0)>>>0){s=c[e>>2]|0;In[c[(c[s>>2]|0)+24>>2]&4095](j,s);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;s=a[j>>0]|0;if(!(s&1))t=(s&255)>>>1;else t=c[j+4>>2]|0;Pri(h,620544,10,t+10|0);if(!(a[j>>0]&1))u=j+1|0;else u=c[j+8>>2]|0;Gri(h,u,t)|0;yO(g,h,620560);if(!(a[g>>0]&1))v=g+1|0;else v=c[g+8>>2]|0;Krd(v,0,3653512,234,32785,0,0,0);xri(g);xri(h);xri(j);a[q>>0]=1}if(r>>>0>(c[b+28>>2]|0)>>>0){r=c[e>>2]|0;In[c[(c[r>>2]|0)+24>>2]&4095](m,r);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;r=a[m>>0]|0;if(!(r&1))w=(r&255)>>>1;else w=c[m+4>>2]|0;Pri(l,620544,10,w+10|0);if(!(a[m>>0]&1))x=m+1|0;else x=c[m+8>>2]|0;Gri(l,x,w)|0;yO(k,l,620560);if(!(a[k>>0]&1))y=k+1|0;else y=c[k+8>>2]|0;Krd(y,0,3653512,240,32785,0,0,0);xri(k);xri(l);xri(m);a[q>>0]=1}if((c[b+24>>2]|0)>>>0<=d>>>0){i=f;return}d=c[e>>2]|0;In[c[(c[d>>2]|0)+24>>2]&4095](p,d);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;d=a[p>>0]|0;if(!(d&1))z=(d&255)>>>1;else z=c[p+4>>2]|0;Pri(o,620544,10,z+10|0);if(!(a[p>>0]&1))A=p+1|0;else A=c[p+8>>2]|0;Gri(o,A,z)|0;yO(n,o,620560);if(!(a[n>>0]&1))B=n+1|0;else B=c[n+8>>2]|0;Krd(B,0,3653512,246,32785,0,0,0);xri(n);xri(o);xri(p);a[q>>0]=1;i=f;return}function yid(a){a=a|0;return}function zid(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+24|0;g=e+12|0;h=e;j=c[b+36>>2]|0;if(j){k=(c[j>>2]|0)+d|0;i=e;return k|0}d=c[b+12>>2]|0;In[c[(c[d>>2]|0)+24>>2]&4095](h,d);c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;d=a[h>>0]|0;if(!(d&1))l=(d&255)>>>1;else l=c[h+4>>2]|0;Pri(g,620496,20,l+20|0);if(!(a[h>>0]&1))m=h+1|0;else m=c[h+8>>2]|0;Gri(g,m,l)|0;yO(f,g,620520);if(!(a[f>>0]&1))n=f+1|0;else n=c[f+8>>2]|0;Krd(n,0,3653512,106,1,0,0,0);xri(f);xri(g);xri(h);k=0;i=e;return k|0}function Aid(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c[b>>2]|0;if((g+e|0)>>>0<=(c[b+8>>2]|0)>>>0){YEi(d|0,g|0,e|0)|0;c[b>>2]=(c[b>>2]|0)+e;i=f;return}h=b+20|0;j=(da(c[h>>2]|0,c[b+16>>2]|0)|0)+(g-(c[b+4>>2]|0))|0;xid(b,j,e);if(a[b+32>>0]|0){PEi(d|0,0,e|0)|0;i=f;return}g=c[h>>2]|0;if(!((j>>>0)%(g>>>0)|0)){k=d;l=e;m=j}else{n=(da(((j>>>0)/(g>>>0)|0)+1|0,g)|0)-j|0;g=(n|0)<(e|0)?n:e;Bid(b,d,g);k=d+g|0;l=e-g|0;m=g+j|0}j=l+m|0;g=b+12|0;e=c[g>>2]|0;d=mo[c[(c[e>>2]|0)+28>>2]&4095](e)|0;e=c[h>>2]|0;n=(((d>>>0<j>>>0?d:j)-m|0)>>>0)/(e>>>0)|0;if((n|0)>0){j=da(n,e)|0;e=c[g>>2]|0;Dn[c[(c[e>>2]|0)+8>>2]&511](e,k,m,j);c[b>>2]=(c[b>>2]|0)+j;o=k+j|0;p=l-j|0}else{o=k;p=l}if(!p){i=f;return}else{q=p;r=o}while(1){o=c[h>>2]|0;p=(o|0)<(q|0)?o:q;Bid(b,r,p);if((q|0)==(p|0))break;else{q=q-p|0;r=r+p|0}}i=f;return}function Bid(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=b+4|0;h=b+16|0;j=b+20|0;k=(da(c[j>>2]|0,c[h>>2]|0)|0)+((c[b>>2]|0)-(c[g>>2]|0))|0;xid(b,k,e);l=b+32|0;if(a[l>>0]|0){PEi(d|0,0,e|0)|0;i=f;return}xid(b,k,0);if(!(a[l>>0]|0)){m=c[j>>2]|0;n=(k>>>0)/(m>>>0)|0;o=c[h>>2]|0;if((n|0)==(o|0)){p=n;q=m}else{m=b+12|0;n=c[m>>2]|0;In[c[(c[n>>2]|0)+16>>2]&4095](n,o);o=(k>>>0)/((c[j>>2]|0)>>>0)|0;c[h>>2]=o;n=c[m>>2]|0;Dn[c[(c[n>>2]|0)+12>>2]&511](n,o,g,b+8|0);p=c[h>>2]|0;q=c[j>>2]|0}o=k-(da(p,q)|0)|0;q=c[g>>2]|0;p=q+o|0;c[b>>2]=p;r=p;s=q}else{r=c[b>>2]|0;s=c[g>>2]|0}q=b+8|0;p=c[q>>2]|0;if(r>>>0<s>>>0)t=s;else t=r>>>0>p>>>0?p:r;o=r+e|0;if(o>>>0<s>>>0)u=s;else u=o>>>0>p>>>0?p:o;o=t;t=o-r|0;YEi(d+t|0,r+t|0,u-o|0)|0;o=(c[b>>2]|0)+e|0;if(o>>>0<=(c[q>>2]|0)>>>0){c[b>>2]=o;i=f;return}o=k+e|0;xid(b,o,0);if(!(a[l>>0]|0)){l=c[j>>2]|0;u=(o>>>0)/(l>>>0)|0;t=c[h>>2]|0;if((u|0)==(t|0)){v=u;w=l}else{l=b+12|0;u=c[l>>2]|0;In[c[(c[u>>2]|0)+16>>2]&4095](u,t);t=(o>>>0)/((c[j>>2]|0)>>>0)|0;c[h>>2]=t;u=c[l>>2]|0;Dn[c[(c[u>>2]|0)+12>>2]&511](u,t,g,q);v=c[h>>2]|0;w=c[j>>2]|0}t=o-(da(v,w)|0)|0;o=c[g>>2]|0;c[b>>2]=o+t;x=w;y=v;z=o}else{x=c[j>>2]|0;y=c[h>>2]|0;z=c[g>>2]|0}g=k-(da(x,y)|0)|0;y=z+g|0;x=c[q>>2]|0;if((g|0)<0)A=z;else A=y>>>0>x>>>0?x:y;q=g+e|0;e=z+q|0;if((q|0)<0)B=z;else B=e>>>0>x>>>0?x:e;e=A;A=e-y|0;YEi(d+A|0,z+(A+g)|0,B-e|0)|0;i=f;return}function Cid(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[b>>2]|0;g=f+d|0;h=b+8|0;if(g>>>0<=(c[h>>2]|0)>>>0){c[b>>2]=g;i=e;return}g=b+4|0;j=b+16|0;k=b+20|0;l=f+d-(c[g>>2]|0)+(da(c[k>>2]|0,c[j>>2]|0)|0)|0;xid(b,l,0);if(a[b+32>>0]|0){i=e;return}d=c[k>>2]|0;f=(l>>>0)/(d>>>0)|0;m=c[j>>2]|0;if((f|0)==(m|0)){n=f;o=d}else{d=b+12|0;f=c[d>>2]|0;In[c[(c[f>>2]|0)+16>>2]&4095](f,m);m=(l>>>0)/((c[k>>2]|0)>>>0)|0;c[j>>2]=m;f=c[d>>2]|0;Dn[c[(c[f>>2]|0)+12>>2]&511](f,m,g,h);n=c[j>>2]|0;o=c[k>>2]|0}k=l-(da(n,o)|0)|0;c[b>>2]=(c[g>>2]|0)+k;i=e;return}function Did(a){a=a|0;var b=0;b=c[a+4>>2]|0;c[a>>2]=b+((c[a>>2]|0)+3-b&-4);return}function Eid(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[b>>2]|0;g=f-(c[b+4>>2]|0)|0;h=g+3&-4;j=h-g|0;a[e>>0]=0;if((h|0)==(g|0)){i=d;return}g=b+8|0;h=f;f=1;while(1){if((h+1|0)>>>0<(c[g>>2]|0)>>>0){a[h>>0]=0;c[b>>2]=(c[b>>2]|0)+1}else Gid(b,e,1);if(f>>>0>=j>>>0)break;h=c[b>>2]|0;f=f+1|0}i=d;return}function Fid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[a>>2]|0;if((f+d|0)>>>0<(c[a+8>>2]|0)>>>0){YEi(f|0,b|0,d|0)|0;c[a>>2]=(c[a>>2]|0)+d;i=e;return}if(!d){i=e;return}f=a+16|0;g=b;b=d;while(1){d=c[f>>2]|0;h=mo[c[(c[d>>2]|0)+24>>2]&4095](d)|0;d=h>>>0<b>>>0?h:b;Gid(a,g,d);if((b|0)==(d|0))break;else{g=g+d|0;b=b-d|0}}i=e;return}function Gid(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=a+16|0;g=c[f>>2]|0;if((mo[c[(c[g>>2]|0)+24>>2]&4095](g)|0)>>>0<d>>>0){i=e;return}g=a+4|0;h=(c[a>>2]|0)-(c[g>>2]|0)|0;j=a+12|0;k=c[j>>2]|0;l=c[f>>2]|0;m=(da(mo[c[(c[l>>2]|0)+24>>2]&4095](l)|0,k)|0)+h|0;h=c[f>>2]|0;k=mo[c[(c[h>>2]|0)+24>>2]&4095](h)|0;h=c[a>>2]|0;l=c[g>>2]|0;n=a+8|0;o=c[n>>2]|0;if(h>>>0<l>>>0)p=l;else p=h>>>0>o>>>0?o:h;q=h+d|0;if(q>>>0<l>>>0)r=l;else r=q>>>0>o>>>0?o:q;q=p;p=q-h|0;YEi(h+p|0,b+p|0,r-q|0)|0;q=m+d|0;r=c[f>>2]|0;p=mo[c[(c[r>>2]|0)+24>>2]&4095](r)|0;r=(q>>>0)/(p>>>0)|0;h=c[j>>2]|0;do if((r|0)!=(h|0))if((r|0)==(h+1|0)){o=c[f>>2]|0;In[c[(c[o>>2]|0)+20>>2]&4095](o,h);c[j>>2]=r;o=c[f>>2]|0;Dn[c[(c[o>>2]|0)+16>>2]&511](o,r,g,n);s=c[j>>2]|0;t=10;break}else{u=h;v=c[g>>2]|0;break}else{s=r;t=10}while(0);if((t|0)==10){t=q-(da(s,p)|0)|0;p=c[g>>2]|0;c[a>>2]=p+t;u=s;v=p}p=m-(da(u,k)|0)|0;k=v+p|0;u=c[n>>2]|0;if((p|0)<0)w=v;else w=k>>>0>u>>>0?u:k;n=p+d|0;d=v+n|0;if((n|0)<0)x=v;else x=d>>>0>u>>>0?u:d;d=w;w=d-k|0;YEi(v+(w+p)|0,b+w|0,x-d|0)|0;i=e;return}function Hid(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(c[a>>2]|0)-(c[a+4>>2]|0)|0;e=c[a+12>>2]|0;f=c[a+16>>2]|0;a=d+(da(mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0,e)|0)|0;i=b;return a|0}function Iid(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+16|0;e=c[d>>2]|0;f=a+12|0;In[c[(c[e>>2]|0)+20>>2]&4095](e,c[f>>2]|0);e=c[d>>2]|0;d=c[e>>2]|0;g=c[d+8>>2]|0;h=(c[a>>2]|0)-(c[a+4>>2]|0)|0;a=c[f>>2]|0;f=h+(da(mo[c[d+24>>2]&4095](e)|0,a)|0)|0;a=_n[g&4095](e,f)|0;i=b;return a|0}function Jid(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+16>>2]=b;c[a+12>>2]=0;e=a+4|0;Dn[c[(c[b>>2]|0)+16>>2]&511](b,0,e,a+8|0);c[a>>2]=c[e>>2];i=d;return}function Kid(a){a=a|0;return}function Lid(a){a=a|0;a=i;Krd(620640,0,3653512,9,1,0,0,0);i=a;return 0}function Mid(a){a=a|0;return}function Nid(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Oid(a){a=a|0;a=i;Krd(620712,0,3653512,17,1,0,0,0);i=a;return 0}function Pid(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+1088|0;g=f+1072|0;h=f+1068|0;j=f+1056|0;k=f;c[b>>2]=620792;l=b+12|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[b+28>>2]=-1;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=-1;c[b+44>>2]=0;m=b+48|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[b+72>>2]=3;c[b+76>>2]=0;a[b+80>>0]=0;m=b+84|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[b+108>>2]=3;c[b+112>>2]=0;a[b+116>>0]=0;m=b+120|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[b+144>>2]=3;c[b+148>>2]=0;a[b+152>>0]=0;sqd(j,d);yri(l,j)|0;xri(j);j=b+4|0;c[j>>2]=e;if(!(a[l>>0]&1))n=l+1|0;else n=c[b+20>>2]|0;god(k,n);n=lod(k)|0;c[b+8>>2]=n;n=0;do{l=c[j>>2]|0;c[h>>2]=c[153112];c[g+0>>2]=c[h+0>>2];c[b+(n*12|0)+24>>2]=cOb(l,16,g,0,3653512,30)|0;c[b+(n*12|0)+28>>2]=-1;n=n+1|0}while((n|0)<2);Bod(k);i=f;return}function Qid(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=620792;f=0;do{g=a+(f*12|0)+24|0;h=c[g>>2]|0;c[e>>2]=c[153112];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;f=f+1|0}while((f|0)<2);f=a+12|0;Wsd(f);xri(a+120|0);d=a+48|0;e=a+120|0;do{e=e+-36|0;xri(e)}while((e|0)!=(d|0));xri(f);i=b;return}function Rid(a){a=a|0;var b=0;b=i;Qid(a);ACi(a);i=b;return}function Sid(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(((c[a+8>>2]|0)-d|0)>>>0<e>>>0)Krd(620832,0,3653512,73,32785,0,0,0);g=a+120|0;yri(g,a+12|0)|0;c[a+132>>2]=b;c[a+136>>2]=e;c[a+140>>2]=d;Usd(g);i=f;return}function Tid(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=0;do{if((c[a+(e*12|0)+28>>2]|0)==(b|0)){f=e;g=8;break}e=e+1|0}while((e|0)<2);if((g|0)==8){i=d;return f|0}g=(c[a+108>>2]|0)==1?((c[a+72>>2]|0)==1)<<31>>31:1;if((g|0)==-1)h=0;else h=g;g=a+(h*36|0)+48|0;e=c[a+8>>2]|0;j=e-(da(mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0,b)|0)|0;e=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0;k=(e|0)<(j|0)?e:j;if((k|0)<1){f=h;i=d;return f|0}yri(g,a+12|0)|0;c[a+(h*36|0)+60>>2]=c[a+(h*12|0)+24>>2];c[a+(h*36|0)+64>>2]=k;c[a+(h*36|0)+68>>2]=da(c[a+4>>2]|0,b)|0;c[a+(h*12|0)+28>>2]=b;Usd(g);f=h;i=d;return f|0}function Uid(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=Tid(a,b)|0;h=(g|0)==0&1;j=b+1|0;b=a+(h*36|0)+48|0;if(((c[a+(h*36|0)+72>>2]|0)!=1?(k=a+(h*12|0)+28|0,(c[k>>2]|0)!=(j|0)):0)?(l=c[a+8>>2]|0,m=l-(da(mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0,j)|0)|0,l=mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0,n=(l|0)<(m|0)?l:m,(n|0)>=1):0){yri(b,a+12|0)|0;c[a+(h*36|0)+60>>2]=c[a+(h*12|0)+24>>2];c[a+(h*36|0)+64>>2]=n;c[a+(h*36|0)+68>>2]=da(c[a+4>>2]|0,j)|0;c[k>>2]=j;Usd(b)}c[a+(g*12|0)+32>>2]=1;b=a+(g*12|0)+24|0;c[d>>2]=c[b>>2];c[e>>2]=(c[b>>2]|0)+(c[a+(g*36|0)+64>>2]|0);i=f;return}function Vid(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=0;while(1){if((c[a+(e*12|0)+28>>2]|0)==(b|0)?(f=a+(e*12|0)+32|0,(c[f>>2]|0)==1):0){g=f;break}e=e+1|0;if((e|0)>=2){h=6;break}}if((h|0)==6){i=d;return}c[g>>2]=0;i=d;return}function Wid(a,b){a=a|0;b=b|0;var c=0;c=i;sri(a,b+12|0);i=c;return}function Xid(a){a=a|0;return c[a+4>>2]|0}function Yid(a){a=a|0;return c[a+8>>2]|0}function Zid(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+4|0;h=f;j=(d>>>0)/((mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0)>>>0)|0;k=e+d|0;e=((k+-1|0)>>>0)/((mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0)>>>0)|0;if((j|0)>(e|0)){i=f;return}l=j;while(1){Dn[c[(c[a>>2]|0)+12>>2]&511](a,l,g,h);j=c[g>>2]|0;m=j+(d-(da(mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0,l)|0))|0;j=c[g>>2]|0;if(m>>>0<j>>>0)n=j;else{o=c[h>>2]|0;n=m>>>0>o>>>0?o:m}o=j+(k-(da(mo[c[(c[a>>2]|0)+20>>2]&4095](a)|0,l)|0))|0;j=c[g>>2]|0;if(o>>>0<j>>>0)p=j;else{j=c[h>>2]|0;p=o>>>0>j>>>0?j:o}o=n;YEi(b+(o-m)|0,n|0,p-o|0)|0;In[c[(c[a>>2]|0)+16>>2]&4095](a,l);if((l|0)<(e|0))l=l+1|0;else break}i=f;return}function _id(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=620872;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;return}function $id(a){a=a|0;return}function ajd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bjd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[a+4>>2]|0)+(b<<2)>>2]|0;c[d>>2]=g;d=mo[c[(c[a>>2]|0)+28>>2]&4095](a)|0;h=c[a+12>>2]|0;a=d-(da(h,b)|0)|0;c[e>>2]=g+((h|0)<(a|0)?h:a);i=f;return}function cjd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Zid(a,b,c,d);i=e;return}function djd(a,b){a=a|0;b=b|0;return}function ejd(a){a=a|0;return c[a+12>>2]|0}function fjd(a,b){a=a|0;b=b|0;b=i;rri(a,2386816,4);i=b;return}function gjd(a){a=a|0;return c[a+8>>2]|0}function hjd(a){a=a|0;return c[c[a+4>>2]>>2]|0}function ijd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;c[b+4>>2]=0;c[b+12>>2]=d;c[b+16>>2]=f;a[b+20>>0]=1;a[b+21>>0]=0;d=b+24|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[b>>2]=e;a[b+23>>0]=e>>>9&1;a[b+22>>0]=(rjd(f)|0)&1;i=g;return}function jjd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+16|0;h=g;j=b+12|0;k=c[(c[j>>2]|0)+8>>2]|0;l=(f+-1&0-k)+k|0;k=b+32|0;f=c[k>>2]|0;m=b+28|0;n=c[m>>2]|0;if((f|0)==(n|0))o=0;else o=(f-n<<6)+-1|0;p=b+40|0;q=c[p>>2]|0;r=b+44|0;s=c[r>>2]|0;if((o-q|0)==(s|0)){ojd(b+24|0);t=c[r>>2]|0;u=c[p>>2]|0;v=c[k>>2]|0;w=c[m>>2]|0}else{t=s;u=q;v=f;w=n}n=t+u|0;if((v|0)!=(w|0)?(v=c[w+(n>>>8<<2)>>2]|0,w=n&255,n=v+(w<<4)|0,(n|0)!=0):0){c[n>>2]=l;c[v+(w<<4)+4>>2]=0;c[v+(w<<4)+8>>2]=e;c[v+(w<<4)+12>>2]=d;x=c[r>>2]|0}else x=t;c[r>>2]=x+1;x=c[j>>2]|0;a[h>>0]=0;pjd(x,l+d|0,h,0);a[b+20>>0]=0;i=g;return}function kjd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;a[b+20>>0]=d&1;h=b+12|0;j=c[h>>2]|0;k=c[j+8>>2]|0;l=(f+-1&0-k)+k|0;k=b+44|0;f=b+40|0;m=(c[k>>2]|0)+-1+(c[f>>2]|0)|0;n=b+28|0;o=c[(c[n>>2]|0)+(m>>>8<<2)>>2]|0;p=m&255;m=(c[o+(p<<4)+4>>2]|0)+(c[o+(p<<4)>>2]|0)|0;p=b+22|0;o=d?l-m|0:0;q=(a[b+23>>0]|0)==0;if(!(a[p>>0]|0)){if(q)r=o;else r=XEi(o|0)|0;s=(c[j>>2]|0)+m|0;a[s>>0]=r;a[s+1>>0]=r>>8;a[s+2>>0]=r>>16;a[s+3>>0]=r>>24}else{if(q){t=o;u=0;v=0}else{t=0;u=0;v=XEi(o|0)|0}o=t|u;u=(c[j>>2]|0)+m|0;m=u;a[m>>0]=o;a[m+1>>0]=o>>8;a[m+2>>0]=o>>16;a[m+3>>0]=o>>24;o=u+4|0;a[o>>0]=v;a[o+1>>0]=v>>8;a[o+2>>0]=v>>16;a[o+3>>0]=v>>24}do if(e)if(d){v=(c[k>>2]|0)+-1+(c[f>>2]|0)|0;o=c[(c[n>>2]|0)+(v>>>8<<2)>>2]|0;u=v&255;c[e>>2]=(c[o+(u<<4)+4>>2]|0)+(c[o+(u<<4)>>2]|0);c[e+4>>2]=l;c[e+8>>2]=c[(c[h>>2]|0)+8>>2];break}else{c[e>>2]=1048575;c[e+4>>2]=1048575;c[e+8>>2]=1048575;break}while(0);e=c[f>>2]|0;f=(c[k>>2]|0)+-1+e|0;h=c[n>>2]|0;n=(c[h+(f>>>8<<2)>>2]|0)+((f&255)<<4)+4|0;c[n>>2]=(c[n>>2]|0)+((a[p>>0]|0)!=0?8:4);if((c[b+16>>2]|0)!=-2){i=g;return}b=(c[k>>2]|0)+-1+e|0;e=(c[h+(b>>>8<<2)>>2]|0)+((b&255)<<4)+4|0;c[e>>2]=(c[e>>2]|0)+4;i=g;return}function ljd(a){a=a|0;return (c[a+16>>2]|0)==-2|0}function mjd(a,b,c){a=a|0;b=b|0;c=c|0;return}function njd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;if(!(a[b+21>>0]|0)){i=f;return}h=c[d+4>>2]|0;if((h|0)==1048575){i=f;return}j=b+12|0;k=c[j>>2]|0;l=(c[k+8>>2]|0)-h|0;if(!h){i=f;return}m=c[k>>2]|0;k=0;while(1){if(!(FEi(m+k|0,m+h|0,l)|0)){n=k;break}k=k+e|0;if(k>>>0>=h>>>0){o=15;break}}if((o|0)==15){i=f;return}o=c[d>>2]|0;h=n-o|0;n=(a[b+23>>0]|0)==0;if(!(a[b+22>>0]|0)){if(n)p=h;else p=XEi(h|0)|0;b=m+o|0;a[b>>0]=p;a[b+1>>0]=p>>8;a[b+2>>0]=p>>16;a[b+3>>0]=p>>24}else{if(n){q=h;r=0;s=0}else{q=0;r=0;s=XEi(h|0)|0}h=q|r;r=m+o|0;o=r;a[o>>0]=h;a[o+1>>0]=h>>8;a[o+2>>0]=h>>16;a[o+3>>0]=h>>24;h=r+4|0;a[h>>0]=s;a[h+1>>0]=s>>8;a[h+2>>0]=s>>16;a[h+3>>0]=s>>24}s=c[j>>2]|0;j=c[d+8>>2]|0;a[g>>0]=0;pjd(s,j,g,0);i=f;return}function ojd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;i=i+16|0;d=b;e=a+16|0;f=c[e>>2]|0;if(f>>>0>255){c[e>>2]=f+-256;f=a+4|0;e=c[f>>2]|0;g=c[e>>2]|0;h=e+4|0;c[f>>2]=h;j=a+8|0;k=c[j>>2]|0;l=a+12|0;do if((k|0)==(c[l>>2]|0)){m=c[a>>2]|0;if(h>>>0>m>>>0){n=h;o=((n-m>>2)+1|0)/-2|0;p=k-n|0;aFi(e+(o+1<<2)|0,h|0,p|0)|0;n=e+((p>>2)+1+o<<2)|0;c[j>>2]=n;c[f>>2]=(c[f>>2]|0)+(o<<2);q=n;r=13;break}n=k-m>>1;o=(n|0)==0?1:n;n=xCi(o<<2)|0;p=n+(o>>>2<<2)|0;s=n+(o<<2)|0;if((h|0)==(k|0)){t=p;u=m}else{m=p;o=h;v=e;while(1){if(!m)w=0;else{c[m>>2]=c[o>>2];w=m}x=w+4|0;y=v+8|0;if((y|0)==(k|0)){z=x;break}else{A=o;m=x;o=y;v=A}}t=z;u=c[a>>2]|0}c[a>>2]=n;c[f>>2]=p;c[j>>2]=t;c[l>>2]=s;if(!u){B=t;r=12}else{ACi(u);B=c[j>>2]|0;r=12}}else{B=k;r=12}while(0);if((r|0)==12)if(!B)C=0;else{q=B;r=13}if((r|0)==13){c[q>>2]=g;C=c[j>>2]|0}c[j>>2]=C+4;i=b;return}C=a+8|0;j=c[C>>2]|0;g=a+4|0;q=j-(c[g>>2]|0)|0;B=q>>2;k=a+12|0;u=c[k>>2]|0;t=u-(c[a>>2]|0)|0;if(B>>>0<t>>2>>>0){l=xCi(4096)|0;if((u|0)!=(j|0)){if(!j)D=0;else{c[j>>2]=l;D=c[C>>2]|0}c[C>>2]=D+4;i=b;return}c[d>>2]=l;qjd(a,d);d=c[g>>2]|0;l=c[d>>2]|0;D=d+4|0;c[g>>2]=D;j=c[C>>2]|0;do if((j|0)==(c[k>>2]|0)){u=c[a>>2]|0;if(D>>>0>u>>>0){f=D;z=((f-u>>2)+1|0)/-2|0;w=j-f|0;aFi(d+(z+1<<2)|0,D|0,w|0)|0;f=d+((w>>2)+1+z<<2)|0;c[C>>2]=f;c[g>>2]=(c[g>>2]|0)+(z<<2);E=f;r=31;break}f=j-u>>1;z=(f|0)==0?1:f;f=xCi(z<<2)|0;w=f+(z>>>2<<2)|0;e=f+(z<<2)|0;if((D|0)==(j|0)){F=w;G=u}else{u=w;z=D;h=d;while(1){if(!u)H=0;else{c[u>>2]=c[z>>2];H=u}v=H+4|0;o=h+8|0;if((o|0)==(j|0)){I=v;break}else{m=z;u=v;z=o;h=m}}F=I;G=c[a>>2]|0}c[a>>2]=f;c[g>>2]=w;c[C>>2]=F;c[k>>2]=e;if(!G){J=F;r=30}else{ACi(G);J=c[C>>2]|0;r=30}}else{J=j;r=30}while(0);if((r|0)==30)if(!J)K=0;else{E=J;r=31}if((r|0)==31){c[E>>2]=l;K=c[C>>2]|0}c[C>>2]=K+4;i=b;return}K=t>>1;t=(K|0)==0?1:K;K=xCi(t<<2)|0;l=K+(t<<2)|0;E=xCi(4096)|0;r=K+(B<<2)|0;do if((B|0)==(t|0))if((q|0)>0){L=K+(((B+1|0)/-2|0)+B<<2)|0;M=l;N=K;break}else{J=q>>1;j=(J|0)==0?1:J;J=xCi(j<<2)|0;ACi(K);L=J+(j>>>2<<2)|0;M=J+(j<<2)|0;N=J;break}else{L=r;M=l;N=K}while(0);if(!L)O=0;else{c[L>>2]=E;O=L}E=O+4|0;O=c[C>>2]|0;if((O|0)==(c[g>>2]|0)){P=M;Q=E;R=L;S=N}else{K=L;L=N;N=E;E=M;M=O;while(1){M=M+-4|0;do if((K|0)==(L|0)){O=E;if(N>>>0<E>>>0){l=N;r=((O-l>>2)+1|0)/2|0;q=l-L|0;l=N+(r-(q>>2)<<2)|0;aFi(l|0,L|0,q|0)|0;T=l;U=E;V=N+(r<<2)|0;W=L;break}r=O-L>>1;O=(r|0)==0?1:r;r=xCi(O<<2)|0;l=r+((O+3|0)>>>2<<2)|0;q=r+(O<<2)|0;if((L|0)==(N|0))X=l;else{O=l;B=L;while(1){if(!O)Y=0;else{c[O>>2]=c[B>>2];Y=O}t=Y+4|0;B=B+4|0;if((B|0)==(N|0)){X=t;break}else O=t}}if(!L){T=l;U=q;V=X;W=r}else{ACi(L);T=l;U=q;V=X;W=r}}else{T=K;U=E;V=N;W=L}while(0);e=T+-4|0;c[e>>2]=c[M>>2];if((M|0)==(c[g>>2]|0)){P=U;Q=V;R=e;S=W;break}else{K=e;L=W;N=V;E=U}}}U=c[a>>2]|0;c[a>>2]=S;c[g>>2]=R;c[C>>2]=Q;c[k>>2]=P;if(!U){i=b;return}ACi(U);i=b;return}function pjd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g+4|0;j=g;k=b+12|0;l=c[k>>2]|0;m=l&2147483647;do if(m>>>0<d>>>0){if(f){n=l<<1;o=n>>>0>d>>>0?n:d}else o=d;if(m>>>0<o>>>0)if((l|0)>-1){c[k>>2]=o;n=c[b>>2]|0;c[j>>2]=c[b+4>>2];c[h+0>>2]=c[j+0>>2];c[b>>2]=hOb(n,o,16,h,0,3653512,370)|0;break}else{c[j>>2]=c[b+4>>2];c[h+0>>2]=c[j+0>>2];n=cOb(o,16,h,0,3653512,352)|0;YEi(n|0,c[b>>2]|0,c[b+8>>2]|0)|0;c[k>>2]=o;c[b>>2]=n;break}}while(0);o=b+8|0;k=c[o>>2]|0;if(k>>>0>=d>>>0){c[o>>2]=d;i=g;return}h=c[b>>2]|0;b=h+d|0;if((k|0)==(d|0)){c[o>>2]=d;i=g;return}j=h+k|0;do{if(j)a[j>>0]=a[e>>0]|0;j=j+1|0}while((j|0)!=(b|0));c[o>>2]=d;i=g;return}function qjd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function rjd(a){a=a|0;var b=0,c=0,d=0,e=0;b=i;if((a|0)==25|(a|0)==19|(a|0)==24){c=1;d=3}else if((a|0)==-2)e=0;else{c=0;d=3}if((d|0)==3)e=c;i=b;return e|0}function sjd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Hwd(a+12|0);d=a+148|0;e=a+160|0;f=a+172|0;g=a+132|0;a=g+88|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));vjd(d,8);wjd(e,4);xjd(f,4);i=b;return}function tjd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e;rri(g,d,SEi(d|0)|0);sri(f,g);d=f+12|0;c[d>>2]=b;b=a+188|0;h=c[b>>2]|0;if((h|0)==(c[a+192>>2]|0)){zjd(a+184|0,f);xri(f);xri(g);i=e;return}if(!h)j=0;else{sri(h,f);c[h+12>>2]=c[d>>2];j=c[b>>2]|0}c[b>>2]=j+16;xri(f);xri(g);i=e;return}function ujd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+208|0;e=c[d>>2]|0;if(e){f=a+212|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-16|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}d=a+196|0;f=c[d>>2]|0;if(f){e=a+200|0;while(1){h=c[e>>2]|0;if((h|0)==(f|0))break;g=h+-40|0;c[e>>2]=g;yjd(g)}ACi(c[d>>2]|0)}d=a+184|0;e=c[d>>2]|0;if(e){f=a+188|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-16|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}d=a+172|0;f=c[d>>2]|0;if(f){e=a+176|0;while(1){h=c[e>>2]|0;if((h|0)==(f|0))break;g=h+-24|0;c[e>>2]=g;xri(g)}ACi(c[d>>2]|0)}d=a+160|0;e=c[d>>2]|0;if(e){f=a+164|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-24|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}d=a+148|0;f=c[d>>2]|0;if(!f){xri(a);i=b;return}e=a+152|0;while(1){h=c[e>>2]|0;if((h|0)==(f|0))break;g=h+-24|0;c[e>>2]=g;xri(g)}ACi(c[d>>2]|0);xri(a);i=b;return}function vjd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((((c[e>>2]|0)-g|0)/24|0)>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b*24|0)|0;l=k+(((j-g|0)/24|0)*24|0)|0;g=k+(b*24|0)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=b;b=b+-24|0;sri(j+-24|0,b);p=j+-12|0;q=k+-12|0;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];q=j+-24|0;if((b|0)==(f|0)){r=q;break}else j=q}m=r;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-24|0;xri(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function wjd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((((c[e>>2]|0)-g|0)/24|0)>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b*24|0)|0;l=k+(((j-g|0)/24|0)*24|0)|0;g=k+(b*24|0)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=b;b=b+-24|0;sri(j+-24|0,b);p=j+-12|0;q=k+-12|0;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];q=j+-24|0;if((b|0)==(f|0)){r=q;break}else j=q}m=r;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-24|0;xri(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function xjd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((((c[e>>2]|0)-g|0)/24|0)>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b*24|0)|0;l=k+(((j-g|0)/24|0)*24|0)|0;g=k+(b*24|0)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=b;b=b+-24|0;sri(j+-24|0,b);p=j+-12|0;q=k+-12|0;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];q=j+-24|0;if((b|0)==(f|0)){r=q;break}else j=q}m=r;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-24|0;xri(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function yjd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+24|0;e=c[d>>2]|0;if(e){f=a+28|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-24|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}d=a+12|0;f=c[d>>2]|0;if(!f){xri(a);i=b;return}e=a+16|0;while(1){h=c[e>>2]|0;if((h|0)==(f|0))break;g=h+-24|0;c[e>>2]=g;xri(g)}ACi(c[d>>2]|0);xri(a);i=b;return}function zjd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>4)+1|0;if(g>>>0>268435455)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>4>>>0<134217727){l=k>>3;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=l-j>>4;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=268435455;r=l-j>>4;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<4)|0;o=r;p=s}s=n+(o<<4)|0;r=n+(m<<4)|0;if(!s){u=p;v=f}else{sri(s,b);c[n+(o<<4)+12>>2]=c[b+12>>2];u=c[e>>2]|0;v=c[a>>2]|0}b=n+(o+1<<4)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=o;o=o+-16|0;sri(u+-16|0,o);c[u+-4>>2]=c[s+-4>>2];s=u+-16|0;if((o|0)==(v|0)){z=s;break}else u=s}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-16|0;xri(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function Ajd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+224|0;e=d+212|0;f=d+16|0;g=d;h=b+40|0;if(a[h>>0]|0){i=d;return}a[h>>0]=1;if(!(c[b+36>>2]|0)){i=d;return}h=ync()|0;if(!(a[h+5832>>0]|0)){ko[c[(c[h>>2]|0)+500>>2]&4095](h);if(mo[c[(c[h>>2]|0)+516>>2]&4095](h)|0){j=1;k=5}}else{j=0;k=5}if((k|0)==5){k=Mnc(ync()|0)|0;if(gn[c[(c[k>>2]|0)+8>>2]&127](k,60,3,0,1,e,0)|0){PEi(c[e>>2]|0,0,180)|0;co[c[(c[k>>2]|0)+12>>2]&2047](k,3,0);t1b(f,ync()|0);l1b(ea(-1.0),ea(100.0),0,ync()|0);e=(c[158074]|0)+4|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Bjd(b,116,k,0);k=(c[158074]|0)+4|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];u1b(f)}if(!(j<<24>>24)){i=d;return}}j=ync()|0;ko[c[(c[j>>2]|0)+504>>2]&4095](j);i=d;return}function Bjd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+16|0;g=f+8|0;h=f;j=c[a+28>>2]|0;k=a+32|0;if((j|0)==(k|0)){i=f;return}a=j;while(1){j=a+16|0;l=c[j>>2]|0;a:do if(l){c[h>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(g,m,h);n=c[g>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[p+4>>2]|0,(m|0)!=0):0)q=m;else r=12}else r=12;if((r|0)==12){r=0;m=hQb(c[j>>2]|0)|0;if(!m)break;else q=m}m=q+52|0;n=c[m>>2]|0;if((n|0)!=0?(o=a+20|0,s=c[o>>2]|0,t=c[a+24>>2]|0,(s|0)!=(t|0)):0){u=(t-s|0)/20|0;t=s;s=n;n=0;while(1){v=c[t+(n*20|0)+16>>2]|0;b:do if(v>>>0<=11?(w=Tld()|0,x=c[s>>2]|0,y=(c[s+4>>2]|0)-x>>2,(y|0)!=0):0){z=0;c:while(1){A=c[x+(z<<2)>>2]|0;if((c[A+32>>2]|0)<=(w|0)?(B=c[A+16>>2]|0,(B|0)!=0):0){C=c[A>>2]|0;A=0;do{D=c[C+(A<<2)>>2]|0;A=A+1|0;if((c[D+584>>2]|0)==(v|0)){E=D;F=z;break c}}while((A|0)!=(B|0))}z=z+1|0;if((z|0)==(y|0))break b}if((E|0)!=0?(c[E+640>>2]|0)==0:0)rn[b&127](q,F,E,t+(n*20|0)|0,d,e)}while(0);v=n+1|0;if((v|0)==(u|0))break a;t=c[o>>2]|0;s=c[m>>2]|0;n=v}}}while(0);j=c[a+4>>2]|0;if(!j){l=a;while(1){n=c[l+8>>2]|0;if((c[n>>2]|0)==(l|0)){G=n;break}else l=n}}else{l=j;while(1){n=c[l>>2]|0;if(!n){G=l;break}else l=n}}if((G|0)==(k|0))break;else a=G}i=f;return}function Cjd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;g=i;b=(c[158074]|0)+4|0;c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];e=Ftd(d,0,c[(c[a+52>>2]|0)+72>>2]|0,c[158074]|0,a,0)|0;a=c[(c[f>>2]|0)+16>>2]|0;d=c[e+4>>2]|0;b=c[155228]|0;if(b){h=b;j=qic(h,d,0)|0;co[a&2047](f,e,j);i=g;return}b=tic(uic()|0,159)|0;c[155228]=b;h=b;j=qic(h,d,0)|0;co[a&2047](f,e,j);i=g;return}function Djd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eVb(d,h,1);Ndd(d);if(!(a[h>>0]&1))j=h+1|0;else j=c[h+8>>2]|0;itd(b,j);if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function Ejd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=ftd(b)|0;b=SEi(j|0)|0;if(b>>>0>10)AOb(h,10,b+-10|0,0,0,0,b,j);else{aFi(h+1|0,j|0,b|0)|0;a[h+b+1>>0]=0;a[h>>0]=b<<1}R2c(d,h,3147344,0);if(!(a[h>>0]&1)){i=e;return}d=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(d,f);i=e;return}function Fjd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;add(d,3147344,c[142294]|0,g,0);$cd(d,2646336,2646336,e,1);add(d,3142592,c[142260]|0,f,0);c[(c[c[d+12>>2]>>2]|0)+((c[d+20>>2]|0)*24|0)+12>>2]=1;bdd(d);cdd(d);fdd(d);bdd(d);if(!(a[g>>0]&1)){i=b;return}d=c[g+8>>2]|0;c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(d,e);i=b;return}function Gjd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;gVb(d,h,1);Mdd(d);if(!(a[h>>0]&1))j=h+1|0;else j=c[h+8>>2]|0;itd(b,j);if(!(a[h>>0]&1)){i=e;return}j=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);i=e;return}function Hjd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;j=qdd(d,3147344,c[142294]|0,f,0)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else cVb(d,h,1);sdd(d)}if(a[d+136>>0]|0){if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;itd(b,k)}if(!(a[h>>0]&1)){i=e;return}k=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function Ijd(a,b){a=a|0;b=b|0;b=i;rri(a,3653512,0);i=b;return}function Jjd(b){b=b|0;var d=0,e=0,f=0;d=i;Vpe()|0;if(((((c[b+68>>2]|0)>29?(a[b+238>>0]|0)!=0:0)?(a[b+199>>0]|0)!=0:0)?(a[b+243>>0]|0)!=0:0)?(a[b+250>>0]|0)!=0:0){a[b+260>>0]=1;e=(c[b+116>>2]|0)>3&1;f=b+261|0;a[f>>0]=e;i=d;return}a[b+260>>0]=0;e=0;f=b+261|0;a[f>>0]=e;i=d;return}function Kjd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[155326]|0;if(!e){f=mo[c[1064952+232>>2]&4095](7939)|0;c[155326]=f;if(!f)g=0;else{h=f;j=3}}else{h=e;j=3}a:do if((j|0)==3)if((((b|0)!=0?(a[b>>0]|0)!=0:0)?(hCi(b,32)|0)==0:0)?(e=mCi(h,b)|0,(e|0)!=0):0){f=SEi(b|0)|0;k=e;e=h;while(1){if(!((k|0)!=(e|0)?(a[k+-1>>0]|0)!=32:0))j=10;e=k+f|0;if((j|0)==10?(j=0,l=a[e>>0]|0,l<<24>>24==0|l<<24>>24==32):0){g=1;break a}k=mCi(e,b)|0;if(!k){g=0;break}}}else g=0;while(0);i=d;return g|0}function Ljd(){var d=0,e=0,f=0;d=i;PEi(620920,0,380)|0;e=621058|0;f=e+22|0;do{b[e>>1]=257;e=e+2|0}while((e|0)<(f|0));a[621125]=1;a[621127]=1;e=620920|0;f=e+60|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[155247]=20;c[155248]=4;g[155249]=ea(16.0);c[155251]=8;c[155252]=1;c[155253]=8;c[155254]=1;c[155255]=1;c[155256]=256;c[155257]=64;c[155258]=128;c[155259]=1;a[621040]=0;a[621044]=1;c[155286]=0;c[155287]=0;a[621152]=0;a[621156]=1;a[621167]=1;a[621171]=1;a[621162]=1;a[621178]=1;c[155296]=0;i=d;return}function Mjd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;DQc(c[a+28>>2]|0,b);e=a+76|0;f=c[a+72>>2]|0;if((f|0)==(e|0)){i=d;return}else g=f;while(1){DQc(c[g+36>>2]|0,b);f=c[g+4>>2]|0;if(!f){a=g;while(1){h=c[a+8>>2]|0;if((c[h>>2]|0)==(a|0)){j=h;break}else a=h}}else{a=f;while(1){h=c[a>>2]|0;if(!h){j=a;break}else a=h}}if((j|0)==(e|0))break;else g=j}i=d;return}function Njd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+28|0;g=c[f>>2]|0;if(!g){h=0;Ojd(a,h);i=b;return}c[e>>2]=g;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);j=c[d>>2]|0;k=c[g+28>>2]|0;if((j|0)==-1){l=k+(c[g+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((l|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[l+4>>2]|0,(g|0)!=0):0)m=g;else n=10}else n=10;if((n|0)==10)m=hQb(c[f>>2]|0)|0;h=m;Ojd(a,h);i=b;return}function Ojd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e;c[b+64>>2]=-1;j=b+32|0;k=c[j>>2]|0;if(k){l=c[153078]|0;m=k+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0)){ko[c[c[k>>2]>>2]&4095](k);c[g>>2]=l;c[f+0>>2]=c[g+0>>2];eOb(k,f)}c[j>>2]=0}a[b+36>>0]=1;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;c[h>>2]=h+4;j=h+16|0;c[j>>2]=0;c[h+20>>2]=0;c[h+12>>2]=h+16;f=h+28|0;c[f>>2]=0;c[h+32>>2]=0;c[h+24>>2]=h+28;Ujc(b+72|0,h)|0;Vjc(h+24|0,c[f>>2]|0);Wjc(h+12|0,c[j>>2]|0);Xjc(h,c[h+4>>2]|0);h=b+28|0;if(!d){c[h>>2]=0;if(!(Ald()|0)){i=e;return}}else c[h>>2]=c[d+4>>2];ymd(b+108|0,b+120|0);Qjd(b);i=e;return}function Pjd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+32|0;h=c[g>>2]|0;if(!h){j=b+36|0;a[j>>0]=1;i=d;return}k=c[153078]|0;l=h+4|0;c[l>>2]=(c[l>>2]|0)+-1;if(!(c[l>>2]|0)){ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[g>>2]=0;j=b+36|0;a[j>>0]=1;i=d;return}function Qjd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+32|0;g=c[f>>2]|0;if(g){h=c[153078]|0;j=g+4|0;c[j>>2]=(c[j>>2]|0)+-1;if(!(c[j>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[f>>2]=0}g=a+28|0;h=c[g>>2]|0;do if(h){c[e>>2]=h;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0){n=j;break}}j=hQb(c[g>>2]|0)|0;if(j)n=j;else o=16}else o=16;while(0);if((o|0)==16)n=Ald()|0;o=n+52|0;if(!(c[o>>2]|0)){i=b;return}g=Dld(n)|0;c[f>>2]=g;c[g+80>>2]=a;g=a+72|0;wnd(g,c[(c[o>>2]|0)+72>>2]|0)|0;vnd(g,c[f>>2]|0);Tjd(a);i=b;return}function Rjd(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+64>>2]|0;if((d|0)>-1){e=d;i=b;return e|0}e=c[(c[(Sjd(a)|0)+52>>2]|0)+36>>2]|0;i=b;return e|0}function Sjd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+28|0;a=c[f>>2]|0;if(a){c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);g=c[d>>2]|0;h=c[a+28>>2]|0;if((g|0)==-1){j=h+(c[a+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((j|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[j+4>>2]|0,(a|0)!=0):0){k=a;i=b;return k|0}}a=hQb(c[f>>2]|0)|0;if(a){k=a;i=b;return k|0}}k=Ald()|0;i=b;return k|0}function Tjd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+136|0;c[f>>2]=0;g=a+140|0;c[g>>2]=0;h=a+28|0;j=c[h>>2]|0;if(!j){i=b;return}c[e>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=10}else o=10;if((o|0)==10){o=hQb(c[h>>2]|0)|0;if(!o){i=b;return}else n=o}o=a+32|0;h=c[o>>2]|0;if(!h){i=b;return}j=c[158074]|0;m=c[n+56>>2]|0;if(!m)p=h;else{c[f>>2]=Ktd(m,a+120|0,h,j,n)|0;p=c[o>>2]|0}h=n+52|0;n=Ltd((c[h>>2]|0)+56|0,p,j)|0;c[g>>2]=n;xtd(c[h>>2]|0,n,c[o>>2]|0,j);i=b;return}function Ujd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+8|0;f=d;g=a+28|0;h=c[g>>2]|0;if(!h){i=d;return}c[f>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,f);j=c[e>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[l+4>>2]|0,(h|0)!=0):0)m=h;else n=10}else n=10;if((n|0)==10){n=hQb(c[g>>2]|0)|0;if(!n){i=d;return}else m=n}n=a+32|0;g=c[n>>2]|0;if(!g){i=d;return}h=c[158074]|0;l=c[m+56>>2]|0;if(l){e=c[b>>2]|0;f=c[l+680>>2]|0;j=c[l+684>>2]|0;k=j-f>>2;if(!k)o=f;else{p=f;f=k;while(1){k=(f|0)/2|0;if((c[p+(k<<2)>>2]|0)<(e|0)){q=p+(k+1<<2)|0;r=f+-1-k|0}else{q=p;r=k}if(!r){o=q;break}else{p=q;f=r}}}if((o|0)!=(j|0)?(((e|0)<(c[o>>2]|0)?j:o)|0)!=(j|0):0)c[a+136>>2]=Ktd(l,a+120|0,g,h,m)|0}g=m+52|0;m=c[g>>2]|0;l=m+56|0;j=c[l>>2]|0;o=c[m+64>>2]|0;m=j+(o<<2)|0;a:do if(!o)s=j;else{e=c[b>>2]|0;r=j;do{if((c[r>>2]|0)==(e|0)){s=r;break a}r=r+4|0}while((r|0)!=(m|0));i=d;return}while(0);if((s|0)==(m|0)){i=d;return}m=Ltd(l,c[n>>2]|0,h)|0;c[a+140>>2]=m;xtd(c[g>>2]|0,m,c[n>>2]|0,h);i=d;return}function Vjd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+16|0;d=b+4|0;e=b;f=yrd()|0;c[d>>2]=c[a+28>>2];g=Ard(Ard(f,d,4)|0,a+120|0,16)|0;d=c[a+72>>2]|0;f=a+76|0;if((d|0)==(f|0))h=g;else{j=d;d=g;while(1){g=Ard(Ard(Ard(d,j+16|0,4)|0,j+20|0,8)|0,j+28|0,8)|0;c[e>>2]=c[j+36>>2];k=Ard(g,e,4)|0;g=c[j+4>>2]|0;if(!g){l=j;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=g;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}if((n|0)==(f|0)){h=k;break}else{j=n;d=k}}}d=c[a+84>>2]|0;n=a+88|0;if((d|0)==(n|0))o=h;else{j=d;d=h;while(1){h=Ard(d,j+16|0,8)|0;f=c[j+4>>2]|0;if(!f){e=j;while(1){l=c[e+8>>2]|0;if((c[l>>2]|0)==(e|0)){p=l;break}else e=l}}else{e=f;while(1){k=c[e>>2]|0;if(!k){p=e;break}else e=k}}if((p|0)==(n|0)){o=h;break}else{j=p;d=h}}}d=c[a+96>>2]|0;p=a+100|0;if((d|0)==(p|0)){q=o;r=zrd(q)|0;i=b;return r|0}else{s=d;t=o}while(1){o=Ard(t,s+16|0,20)|0;d=c[s+4>>2]|0;if(!d){a=s;while(1){j=c[a+8>>2]|0;if((c[j>>2]|0)==(a|0)){u=j;break}else a=j}}else{a=d;while(1){h=c[a>>2]|0;if(!h){u=a;break}else a=h}}if((u|0)==(p|0)){q=o;break}else{s=u;t=o}}r=zrd(q)|0;i=b;return r|0}function Wjd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;ymd(b+108|0,b+120|0);g=b+32|0;h=c[g>>2]|0;if(!h){j=b+36|0;a[j>>0]=1;Qjd(b);i=d;return}k=c[153078]|0;l=h+4|0;c[l>>2]=(c[l>>2]|0)+-1;if(!(c[l>>2]|0)){ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[g>>2]=0;j=b+36|0;a[j>>0]=1;Qjd(b);i=d;return}function Xjd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153078];c[b+0>>2]=c[d+0>>2];d=bOb(8,b,0,16,3653512,302)|0;c[d>>2]=d;c[d+4>>2]=d;c[155328]=d;i=a;return}function Yjd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[155328]|0;f=c[153078]|0;if(e){c[e+4>>2]=0;c[e>>2]=0}c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[155328]=0;i=a;return}function Zjd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];mWb(b,g,e);c[b>>2]=621328;e=b+40|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[b+60>>2]=b;c[b+68>>2]=0;c[b+76>>2]=0;c[b+80>>2]=0;c[b+72>>2]=b+76;c[b+88>>2]=0;c[b+92>>2]=0;c[b+84>>2]=b+88;c[b+100>>2]=0;c[b+104>>2]=0;c[b+96>>2]=b+100;e=b+108|0;c[b+32>>2]=0;a[b+36>>0]=0;c[b+28>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[b+64>>2]=-1;c[b+136>>2]=0;c[b+140>>2]=0;i=f;return}function _jd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+40|0;h=c[g>>2]|0;j=(c[b+44>>2]|0)-h|0;k=(j|0)/44|0;a:do if((j|0)>0){l=h;m=0;while(1){n=c[l+(m*44|0)+8>>2]|0;if((n|0)>0){o=l+(m*44|0)|0;p=0;do{q=(c[o>>2]|0)+(p*28|0)|0;r=c[q>>2]|0;if(r){s=r+4|0;c[s>>2]=(c[s>>2]|0)+-1;if(!(c[s>>2]|0))ko[c[(c[r>>2]|0)+4>>2]&4095](r);c[q>>2]=0}p=p+1|0}while((p|0)!=(n|0))}n=l+(m*44|0)+16|0;p=c[n>>2]|0;if(p){o=p+4|0;c[o>>2]=(c[o>>2]|0)+-1;if(!(c[o>>2]|0))ko[c[(c[p>>2]|0)+4>>2]&4095](p);c[n>>2]=0}n=m+1|0;if((n|0)>=(k|0))break a;l=c[g>>2]|0;m=n}}while(0);a[b+36>>0]=0;g=b+32|0;b=c[g>>2]|0;if(!b){i=d;return}k=c[153078]|0;h=b+4|0;c[h>>2]=(c[h>>2]|0)+-1;if(!(c[h>>2]|0)){ko[c[c[b>>2]>>2]&4095](b);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(b,e)}c[g>>2]=0;i=d;return}function $jd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+32>>2]|0;if(d)mud(d);d=a+52|0;e=c[d>>2]|0;if(!e){i=b;return}f=a+56|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0;i=b;return}function akd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+28|0;if(!d){c[f>>2]=0;i=e;return}c[f>>2]=c[d+4>>2];Qjd(b);d=b+40|0;f=c[d>>2]|0;g=(c[b+44>>2]|0)-f|0;h=(g|0)/44|0;a:do if((g|0)>0){j=f;k=0;while(1){l=c[j+(k*44|0)+8>>2]|0;if((l|0)>0){m=j+(k*44|0)|0;n=0;do{o=(c[m>>2]|0)+(n*28|0)|0;p=c[o>>2]|0;if(p){q=p+4|0;c[q>>2]=(c[q>>2]|0)+-1;if(!(c[q>>2]|0))ko[c[(c[p>>2]|0)+4>>2]&4095](p);c[o>>2]=0}n=n+1|0}while((n|0)!=(l|0))}l=j+(k*44|0)+16|0;n=c[l>>2]|0;if(n){m=n+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0))ko[c[(c[n>>2]|0)+4>>2]&4095](n);c[l>>2]=0}l=k+1|0;if((l|0)>=(h|0))break a;j=c[d>>2]|0;k=l}}while(0);a[b+36>>0]=0;i=e;return}function bkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[153106];c[e+0>>2]=c[f+0>>2];f=Tjc(4,e)|0;In[c[(c[f>>2]|0)+44>>2]&4095](f,b);b=c[(c[f>>2]|0)+36>>2]|0;e=mo[c[(c[a>>2]|0)+32>>2]&4095](a)|0;In[b&4095](f,e);c[f+28>>2]=c[a+4>>2];Qjd(f);i=d;return f|0}function ckd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[155356]|0;if(e){f=e;i=a;return f|0}c[d>>2]=c[153106];c[b+0>>2]=c[d+0>>2];d=Tjc(4,b)|0;c[155356]=d;In[c[(c[d>>2]|0)+44>>2]&4095](d,61);f=c[155356]|0;i=a;return f|0}function dkd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=i;i=i+80|0;j=h;k=h+68|0;l=h+64|0;m=h+44|0;n=h+16|0;o=b+120|0;c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];o=m+16|0;c[o>>2]=e;p=e+4|0;c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];q=c[e>>2]|0;if((q|0)>0){r=0;do{c[e+(r<<2)+4>>2]=c[j+(r<<2)>>2]|c[m+(r<<2)>>2];r=r+1|0}while((r|0)!=(q|0))}q=b+28|0;r=c[q>>2]|0;do if(r){c[l>>2]=r;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(j,s,l);t=c[j>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[v+4>>2]|0,(s|0)!=0):0){w=s;break}}s=hQb(c[q>>2]|0)|0;if(s)w=s;else x=14}else x=14;while(0);if((x|0)==14)w=Ald()|0;q=b+32|0;if(!(c[q>>2]|0))Qjd(b);v=b+36|0;if(a[v>>0]|0){l=b+40|0;r=c[l>>2]|0;s=(c[b+44>>2]|0)-r|0;t=(s|0)/44|0;a:do if((s|0)>0){u=r;y=0;while(1){z=c[u+(y*44|0)+8>>2]|0;if((z|0)>0){A=u+(y*44|0)|0;B=0;do{C=(c[A>>2]|0)+(B*28|0)|0;D=c[C>>2]|0;if(D){E=D+4|0;c[E>>2]=(c[E>>2]|0)+-1;if(!(c[E>>2]|0))ko[c[(c[D>>2]|0)+4>>2]&4095](D);c[C>>2]=0}B=B+1|0}while((B|0)!=(z|0))}z=u+(y*44|0)+16|0;B=c[z>>2]|0;if(B){A=B+4|0;c[A>>2]=(c[A>>2]|0)+-1;if(!(c[A>>2]|0))ko[c[(c[B>>2]|0)+4>>2]&4095](B);c[z>>2]=0}z=y+1|0;if((z|0)>=(t|0))break a;u=c[l>>2]|0;y=z}}while(0);a[v>>0]=0}l=ync()|0;ko[c[(c[l>>2]|0)+352>>2]&4095](l);if(g?(a[v>>0]|0)==0:0){v=b+40|0;g=b+44|0;t=c[g>>2]|0;r=c[v>>2]|0;s=(t-r|0)/44|0;do if(s>>>0<=f>>>0){y=f+1|0;if(y>>>0>s>>>0){Pkd(v,y-s|0);break}if(y>>>0<s>>>0?(u=r+(y*44|0)|0,(t|0)!=(u|0)):0){y=t;while(1){z=y+-44|0;c[g>>2]=z;if((c[y+-32>>2]|0)>-1){B=c[z>>2]|0;c[k>>2]=c[y+-40>>2];c[j+0>>2]=c[k+0>>2];eOb(B,j);c[z>>2]=0;F=c[g>>2]|0}else F=z;if((F|0)==(u|0))break;else y=F}}}while(0);F=c[v>>2]|0;v=F+(f*44|0)|0;g=F+(f*44|0)+8|0;if((c[g>>2]|0)>>>0<=d>>>0){c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+24>>2]=0;t=d+1|0;r=F+(f*44|0)+12|0;s=c[r>>2]|0;do if((s&2147483647)>>>0<t>>>0)if((s|0)>-1){c[r>>2]=t;y=c[v>>2]|0;c[k>>2]=c[F+(f*44|0)+4>>2];c[j+0>>2]=c[k+0>>2];c[v>>2]=hOb(y,t*28|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[F+(f*44|0)+4>>2];c[j+0>>2]=c[k+0>>2];y=cOb(t*28|0,4,j,0,3653512,352)|0;YEi(y|0,c[v>>2]|0,(c[g>>2]|0)*28|0)|0;c[r>>2]=t;c[v>>2]=y;break}while(0);r=c[g>>2]|0;if(r>>>0<t>>>0?(j=c[v>>2]|0,k=j+(t*28|0)|0,(r|0)!=(t|0)):0){F=j+(r*28|0)|0;do{if(F){c[F+0>>2]=c[n+0>>2];c[F+4>>2]=c[n+4>>2];c[F+8>>2]=c[n+8>>2];c[F+12>>2]=c[n+12>>2];c[F+16>>2]=c[n+16>>2];c[F+20>>2]=c[n+20>>2];c[F+24>>2]=c[n+24>>2]}F=F+28|0}while((F|0)!=(k|0))}c[g>>2]=t}t=c[v>>2]|0;v=t+(d*28|0)|0;if(v){g=c[v>>2]|0;if(g){k=0;while(1){if((c[t+(d*28|0)+(k<<2)+8>>2]|0)!=(c[e+(k<<2)+4>>2]|0))break;k=k+1|0;if((k|0)>=4){x=60;break}}if((x|0)==60?(c[t+(d*28|0)+24>>2]|0)==(c[164530]|0):0){In[c[(c[g>>2]|0)+8>>2]&4095](g,e);G=c[t+(d*28|0)+4>>2]|0;H=c[o>>2]|0;I=H+4|0;c[I+0>>2]=c[m+0>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];c[I+12>>2]=c[m+12>>2];i=h;return G|0}t=g+4|0;c[t>>2]=(c[t>>2]|0)+-1;if(!(c[t>>2]|0))ko[c[(c[g>>2]|0)+4>>2]&4095](g);c[v>>2]=0}if(Fld(w,f,d)|0){J=v;K=mo[c[(c[l>>2]|0)+584>>2]&4095](l)|0}else{J=v;K=0}}else{J=0;K=0}}else{J=0;K=0}v=c[b+140>>2]|0;g=c[q>>2]|0;if(!g){Qjd(b);L=c[q>>2]|0}else L=g;g=Eld(w,f,d,v,L,e)|0;if(!K){G=g;H=c[o>>2]|0;I=H+4|0;c[I+0>>2]=c[m+0>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];c[I+12>>2]=c[m+12>>2];i=h;return G|0}if(!(xo[c[(c[l>>2]|0)+588>>2]&2047](l,J,e)|0)){G=g;H=c[o>>2]|0;I=H+4|0;c[I+0>>2]=c[m+0>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];c[I+12>>2]=c[m+12>>2];i=h;return G|0}c[J+4>>2]=g;e=J+8|0;c[e+0>>2]=c[p+0>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[e+12>>2]=c[p+12>>2];c[J+24>>2]=c[164530];J=b+52|0;if(c[J>>2]|0){G=g;H=c[o>>2]|0;I=H+4|0;c[I+0>>2]=c[m+0>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];c[I+12>>2]=c[m+12>>2];i=h;return G|0}p=c[(c[155328]|0)+4>>2]|0;if((J|0)==(p|0)){G=g;H=c[o>>2]|0;I=H+4|0;c[I+0>>2]=c[m+0>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];c[I+12>>2]=c[m+12>>2];i=h;return G|0}e=b+56|0;b=c[p>>2]|0;c[J>>2]=b;c[e>>2]=p;c[b+4>>2]=J;c[c[e>>2]>>2]=J;G=g;H=c[o>>2]|0;I=H+4|0;c[I+0>>2]=c[m+0>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];c[I+12>>2]=c[m+12>>2];i=h;return G|0}function ekd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g;j=g+36|0;k=g+16|0;l=a+28|0;m=c[l>>2]|0;if(!m)n=0;else{c[j>>2]=m;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(h,m,j);o=c[h>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){q=p+(c[m+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0)r=m;else s=10}else s=10;if((s|0)==10)r=hQb(c[l>>2]|0)|0;n=r}if((n|0)==(d|0)){t=dkd(a,b,e,f,1)|0;i=g;return t|0}n=a+120|0;c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[k+16>>2]=e;n=e+4|0;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];r=c[e>>2]|0;if((r|0)>0){l=0;do{c[e+(l<<2)+4>>2]=c[h+(l<<2)>>2]|c[k+(l<<2)>>2];l=l+1|0}while((l|0)!=(r|0))}r=c[a+140>>2]|0;l=a+32|0;h=c[l>>2]|0;if(!h){Qjd(a);u=c[l>>2]|0}else u=h;h=Eld(d,f,b,r,u,e)|0;c[n+0>>2]=c[k+0>>2];c[n+4>>2]=c[k+4>>2];c[n+8>>2]=c[k+8>>2];c[n+12>>2]=c[k+12>>2];t=h;i=g;return t|0}function fkd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+48|0;g=f;h=f+40|0;j=f+20|0;k=f+16|0;l=a+28|0;m=c[l>>2]|0;if(!m)n=0;else{c[h>>2]=m;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(g,m,h);o=c[g>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){q=p+(c[m+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0)r=m;else s=10}else s=10;if((s|0)==10)r=hQb(c[l>>2]|0)|0;n=r}if((n|0)==(b|0)){t=gkd(a,e,d)|0;i=f;return t|0}n=ync()|0;ko[c[(c[n>>2]|0)+352>>2]&4095](n);n=a+120|0;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[j+16>>2]=d;n=d+4|0;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];r=c[d>>2]|0;if((r|0)>0){l=0;do{c[d+(l<<2)+4>>2]=c[g+(l<<2)>>2]|c[j+(l<<2)>>2];l=l+1|0}while((l|0)!=(r|0))}r=Gld(b,e,k)|0;e=c[a+140>>2]|0;l=a+32|0;g=c[l>>2]|0;if(!g){Qjd(a);u=c[l>>2]|0}else u=g;g=Ftd(r,e,u,d,b,c[k>>2]|0)|0;c[n+0>>2]=c[j+0>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];c[n+12>>2]=c[j+12>>2];t=g;i=f;return t|0}function gkd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+48|0;g=f;h=f+40|0;j=f+20|0;k=f+16|0;l=b+120|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];l=j+16|0;c[l>>2]=e;m=e+4|0;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];n=c[e>>2]|0;if((n|0)>0){o=0;do{c[e+(o<<2)+4>>2]=c[g+(o<<2)>>2]|c[j+(o<<2)>>2];o=o+1|0}while((o|0)!=(n|0))}n=hkd(b)|0;o=Gld(n,d,k)|0;p=b+32|0;if(!(c[p>>2]|0))Qjd(b);q=ync()|0;ko[c[(c[q>>2]|0)+352>>2]&4095](q);r=b+36|0;s=b+44|0;if(a[r>>0]|0){t=b+40|0;u=c[t>>2]|0;v=(c[s>>2]|0)-u|0;w=(v|0)/44|0;a:do if((v|0)>0){x=u;y=0;while(1){z=c[x+(y*44|0)+8>>2]|0;if((z|0)>0){A=x+(y*44|0)|0;B=0;do{C=(c[A>>2]|0)+(B*28|0)|0;D=c[C>>2]|0;if(D){E=D+4|0;c[E>>2]=(c[E>>2]|0)+-1;if(!(c[E>>2]|0))ko[c[(c[D>>2]|0)+4>>2]&4095](D);c[C>>2]=0}B=B+1|0}while((B|0)!=(z|0))}z=x+(y*44|0)+16|0;B=c[z>>2]|0;if(B){A=B+4|0;c[A>>2]=(c[A>>2]|0)+-1;if(!(c[A>>2]|0))ko[c[(c[B>>2]|0)+4>>2]&4095](B);c[z>>2]=0}z=y+1|0;if((z|0)>=(w|0))break a;x=c[t>>2]|0;y=z}}while(0);a[r>>0]=0}r=b+40|0;t=c[s>>2]|0;w=c[r>>2]|0;u=(t-w|0)/44|0;do if(u>>>0<=d>>>0){v=d+1|0;if(v>>>0>u>>>0){Pkd(r,v-u|0);break}if(v>>>0<u>>>0?(y=w+(v*44|0)|0,(t|0)!=(y|0)):0){v=t;while(1){x=v+-44|0;c[s>>2]=x;if((c[v+-32>>2]|0)>-1){z=c[x>>2]|0;c[h>>2]=c[v+-40>>2];c[g+0>>2]=c[h+0>>2];eOb(z,g);c[x>>2]=0;F=c[s>>2]|0}else F=x;if((F|0)==(y|0))break;else v=F}}}while(0);F=c[r>>2]|0;r=F+(d*44|0)+16|0;s=c[r>>2]|0;do if(!s)G=37;else{g=0;while(1){if((c[F+(d*44|0)+(g<<2)+24>>2]|0)!=(c[e+(g<<2)+4>>2]|0))break;g=g+1|0;if((g|0)>=4){G=33;break}}if((G|0)==33){In[c[(c[s>>2]|0)+8>>2]&4095](s,e);H=c[F+(d*44|0)+20>>2]|0;break}g=s+4|0;c[g>>2]=(c[g>>2]|0)+-1;if(!(c[g>>2]|0))ko[c[(c[s>>2]|0)+4>>2]&4095](s);c[r>>2]=0;G=37}while(0);if((G|0)==37){if((c[o+640>>2]|0)!=2?(a[o+356>>0]|0)==0:0)I=mo[c[(c[q>>2]|0)+584>>2]&4095](q)|0;else I=0;G=c[b+140>>2]|0;s=c[p>>2]|0;if(!s){Qjd(b);J=c[p>>2]|0}else J=s;s=Ftd(o,G,J,e,n,c[k>>2]|0)|0;if(((I?xo[c[(c[q>>2]|0)+588>>2]&2047](q,r,e)|0:0)?(c[F+(d*44|0)+20>>2]=s,e=F+(d*44|0)+24|0,c[e+0>>2]=c[m+0>>2],c[e+4>>2]=c[m+4>>2],c[e+8>>2]=c[m+8>>2],c[e+12>>2]=c[m+12>>2],m=b+52|0,(c[m>>2]|0)==0):0)?(e=c[(c[155328]|0)+4>>2]|0,(m|0)!=(e|0)):0){d=b+56|0;b=c[e>>2]|0;c[m>>2]=b;c[d>>2]=e;c[b+4>>2]=m;c[c[d>>2]>>2]=m;H=s}else H=s}s=(c[l>>2]|0)+4|0;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];i=f;return H|0}function hkd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+28|0;a=c[f>>2]|0;if(a){c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);g=c[d>>2]|0;h=c[a+28>>2]|0;if((g|0)==-1){j=h+(c[a+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((j|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[j+4>>2]|0,(a|0)!=0):0){k=a;i=b;return k|0}}a=hQb(c[f>>2]|0)|0;if(a){k=a;i=b;return k|0}}k=Ald()|0;i=b;return k|0}function ikd(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=jkd(b,vvd(c)|0,d)|0;if((g|0)<0){sri(a,e);i=f;return}else{wvd(a,g);i=f;return}}function jkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+8|0;g=e;h=a+28|0;a=c[h>>2]|0;if(!a){j=-1;i=e;return j|0}c[g>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(f,a,g);k=c[f>>2]|0;l=c[a+28>>2]|0;if((k|0)==-1){m=l+(c[a+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((m|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[m+4>>2]|0,(a|0)!=0):0)n=a;else o=10}else o=10;if((o|0)==10){o=hQb(c[h>>2]|0)|0;if(!o){j=-1;i=e;return j|0}else n=o}j=otd(c[n+52>>2]|0,b,d)|0;i=e;return j|0}function kkd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+28|0;a=c[f>>2]|0;do if(a){c[e>>2]=a;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0){l=g;break}}g=hQb(c[f>>2]|0)|0;if(g)l=g;else m=12}else m=12;while(0);if((m|0)==12)l=Ald()|0;m=c[l+52>>2]|0;i=b;return c[(c[(c[m>>2]|0)+(c[m+32>>2]<<2)>>2]|0)+16>>2]|0}function lkd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=Im,z=Im,A=Im;f=i;i=i+32|0;h=f+24|0;j=f+8|0;k=f;l=c[b+100>>2]|0;m=b+100|0;if(l){n=c[d>>2]|0;o=m;p=l;a:while(1){l=p;while(1){if((c[l+16>>2]|0)>=(n|0)){q=l;break}l=c[l+4>>2]|0;if(!l){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if((r|0)!=(m|0)?(n|0)>=(c[r+16>>2]|0):0){s=ea(g[e>>2]);t=ea(g[e+4>>2]);u=ea(g[e+8>>2]);v=ea(g[e+12>>2]);g[r+20>>2]=s;g[r+24>>2]=t;g[r+28>>2]=u;g[r+32>>2]=v}}r=b+32|0;n=c[r>>2]|0;if(!n){Qjd(b);w=c[r>>2]|0}else w=n;a[b+36>>0]=1;if(!(yud(w,d)|0)){oud(w,d,e);x=c[d>>2]|0;c[k>>2]=x;c[h+0>>2]=c[k+0>>2];Ujd(b,h);i=f;return}if((KLc()|0)==1){v=ea(g[e>>2]);do if(!(v<=ea(.0404499993)))if(v<ea(1.0)){y=ea(+U(+ea(ea(v+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{y=ea(+U(+v,2.20000005));break}else y=ea(v/ea(12.9200001));while(0);v=ea(g[e+4>>2]);do if(!(v<=ea(.0404499993)))if(v<ea(1.0)){z=ea(+U(+ea(ea(v+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{z=ea(+U(+v,2.20000005));break}else z=ea(v/ea(12.9200001));while(0);v=ea(g[e+8>>2]);do if(!(v<=ea(.0404499993)))if(v<ea(1.0)){A=ea(+U(+ea(ea(v+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{A=ea(+U(+v,2.20000005));break}else A=ea(v/ea(12.9200001));while(0);v=ea(g[e+12>>2]);g[j>>2]=y;g[j+4>>2]=z;g[j+8>>2]=A;g[j+12>>2]=v}else{c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2]}oud(w,d,j);x=c[d>>2]|0;c[k>>2]=x;c[h+0>>2]=c[k+0>>2];Ujd(b,h);i=f;return}function mkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;e=i;f=b+32|0;h=c[f>>2]|0;if(!h){Qjd(b);j=c[f>>2]|0}else j=h;h=c[j+24>>2]|0;f=j+24|0;if(h){b=c[d>>2]|0;k=f;l=h;a:while(1){h=l;while(1){if((c[h+16>>2]|0)>=(b|0)){m=h;break}h=c[h+4>>2]|0;if(!h){n=k;break a}}l=c[m>>2]|0;if(!l){n=m;break}else k=m}if((n|0)!=(f|0)?(b|0)>=(c[n+16>>2]|0):0){o=ea(g[n+20>>2]);p=ea(g[n+24>>2]);q=ea(g[n+28>>2]);r=ea(g[n+32>>2]);if(!(yud(j,d)|0)){g[a>>2]=o;g[a+4>>2]=p;g[a+8>>2]=q;g[a+12>>2]=r;i=e;return}if((KLc()|0)!=1){g[a>>2]=o;g[a+4>>2]=p;g[a+8>>2]=q;g[a+12>>2]=r;i=e;return}do if(!(o<=ea(0.0))){if(o<=ea(.00313080009)){s=ea(o*ea(12.9200001));break}if(!(o<=ea(1.0))){s=ea(+U(+o,.454545468));break}else{s=ea(ea(ea(+U(+o,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else s=ea(0.0);while(0);do if(!(p<=ea(0.0))){if(p<=ea(.00313080009)){t=ea(p*ea(12.9200001));break}if(!(p<=ea(1.0))){t=ea(+U(+p,.454545468));break}else{t=ea(ea(ea(+U(+p,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else t=ea(0.0);while(0);do if(!(q<=ea(0.0))){if(q<=ea(.00313080009)){u=ea(q*ea(12.9200001));break}if(!(q<=ea(1.0))){u=ea(+U(+q,.454545468));break}else{u=ea(ea(ea(+U(+q,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else u=ea(0.0);while(0);g[a>>2]=s;g[a+4>>2]=t;g[a+8>>2]=u;g[a+12>>2]=r;i=e;return}};c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=e;return}function nkd(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;h=f+4|0;j=f;k=c[b+88>>2]|0;l=b+88|0;if(k){m=c[d>>2]|0;n=l;o=k;a:while(1){k=o;while(1){if((c[k+16>>2]|0)>=(m|0)){p=k;break}k=c[k+4>>2]|0;if(!k){q=n;break a}}o=c[p>>2]|0;if(!o){q=p;break}else n=p}if((q|0)!=(l|0)?(m|0)>=(c[q+16>>2]|0):0)g[q+20>>2]=e}q=b+32|0;m=c[q>>2]|0;if(!m){Qjd(b);r=c[q>>2]|0}else r=m;a[b+36>>0]=1;nud(r,d,e);c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];Ujd(b,h);i=f;return}function okd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=0,l=0;d=i;e=a+32|0;f=c[e>>2]|0;if(!f){Qjd(a);h=c[e>>2]|0}else h=f;f=c[h+12>>2]|0;e=h+12|0;if(!f){j=ea(0.0);i=d;return ea(j)}h=c[b>>2]|0;b=e;a=f;a:while(1){f=a;while(1){if((c[f+16>>2]|0)>=(h|0)){k=f;break}f=c[f+4>>2]|0;if(!f){l=b;break a}}a=c[k>>2]|0;if(!a){l=k;break}else b=k}if((l|0)==(e|0)){j=ea(0.0);i=d;return ea(j)}if((h|0)<(c[l+16>>2]|0)){j=ea(0.0);i=d;return ea(j)}j=ea(g[l+20>>2]);i=d;return ea(j)}function pkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+32|0;f=c[e>>2]|0;if(!f){Qjd(a);g=c[e>>2]|0}else g=f;f=zud(g,b)|0;i=d;return f|0}function qkd(a){a=a|0;return}function rkd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;k=f;l=c[b+76>>2]|0;m=b+76|0;if(l){n=c[d>>2]|0;o=m;p=l;a:while(1){l=p;while(1){if((c[l+16>>2]|0)>=(n|0)){q=l;break}l=c[l+4>>2]|0;if(!l){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if((r|0)!=(m|0)?(n|0)>=(c[r+16>>2]|0):0){if(!e)s=0;else s=c[e+4>>2]|0;c[r+36>>2]=s}}s=b+28|0;r=c[s>>2]|0;if(!r){t=c[d>>2]|0;c[k>>2]=t;c[g+0>>2]=c[k+0>>2];Ujd(b,g);i=f;return}c[h>>2]=r;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(g,r,h);n=c[g>>2]|0;m=c[r+28>>2]|0;if((n|0)==-1){u=m+(c[r+32>>2]<<3)|0;break}else{u=m+(n<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if(!((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(c[u+4>>2]|0)!=0:0))v=21}else v=21;if((v|0)==21?(hQb(c[s>>2]|0)|0)==0:0){t=c[d>>2]|0;c[k>>2]=t;c[g+0>>2]=c[k+0>>2];Ujd(b,g);i=f;return}c[j>>2]=c[s>>2];u=c[137784]|0;if(u){do if((c[u+36>>2]|0)!=(c[u+4>>2]|0)){fRb(g,u,j);r=c[g>>2]|0;h=c[u+28>>2]|0;if((r|0)==-1){w=h+(c[u+32>>2]<<3)|0;break}else{w=h+(r<<3)|0;break}}else w=(c[u+28>>2]|0)+(c[u+32>>2]<<3)|0;while(0);u=c[137784]|0;if((w|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[w+4>>2]|0,(u|0)!=0):0)x=u;else v=30}else v=30;if((v|0)==30)x=hQb(c[s>>2]|0)|0;if(!(c[x+52>>2]|0)){t=c[d>>2]|0;c[k>>2]=t;c[g+0>>2]=c[k+0>>2];Ujd(b,g);i=f;return}x=b+32|0;s=c[x>>2]|0;if(!s){Qjd(b);y=c[x>>2]|0}else y=s;a[b+36>>0]=1;qud(y,d,e)|0;t=c[d>>2]|0;c[k>>2]=t;c[g+0>>2]=c[k+0>>2];Ujd(b,g);i=f;return}function skd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;if(!(c[a+32>>2]|0))Qjd(a);g=c[a+76>>2]|0;h=a+76|0;if(!g){j=0;i=d;return j|0}a=c[b>>2]|0;b=h;k=g;a:while(1){g=k;while(1){if((c[g+16>>2]|0)>=(a|0)){l=g;break}g=c[g+4>>2]|0;if(!g){m=b;break a}}k=c[l>>2]|0;if(!k){m=l;break}else b=l}if((m|0)==(h|0)){j=0;i=d;return j|0}if((a|0)<(c[m+16>>2]|0)){j=0;i=d;return j|0}a=c[m+36>>2]|0;if(!a){j=0;i=d;return j|0}c[f>>2]=a;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(e,m,f);h=c[e>>2]|0;l=c[m+28>>2]|0;if((h|0)==-1){n=l+(c[m+32>>2]<<3)|0;break}else{n=l+(h<<3)|0;break}}else n=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((n|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[n+4>>2]|0,(m|0)!=0):0)o=m;else p=20}else p=20;if((p|0)==20)o=hQb(a)|0;j=o;i=d;return j|0}function tkd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0;f=i;i=i+16|0;h=f+4|0;j=f;k=c[b+76>>2]|0;l=b+76|0;if(k){m=c[d>>2]|0;n=l;o=k;a:while(1){k=o;while(1){if((c[k+16>>2]|0)>=(m|0)){p=k;break}k=c[k+4>>2]|0;if(!k){q=n;break a}}o=c[p>>2]|0;if(!o){q=p;break}else n=p}if((q|0)!=(l|0)?(m|0)>=(c[q+16>>2]|0):0){r=ea(g[e>>2]);s=ea(g[e+4>>2]);g[q+28>>2]=r;g[q+32>>2]=s}}q=b+32|0;m=c[q>>2]|0;if(!m){Qjd(b);t=c[q>>2]|0}else t=m;a[b+36>>0]=1;s=ea(g[e>>2]);vud(t,d,s,ea(g[e+4>>2]));c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];Ujd(b,h);i=f;return}function ukd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=0;f=i;i=i+16|0;h=f+4|0;j=f;k=c[b+76>>2]|0;l=b+76|0;if(k){m=c[d>>2]|0;n=l;o=k;a:while(1){k=o;while(1){if((c[k+16>>2]|0)>=(m|0)){p=k;break}k=c[k+4>>2]|0;if(!k){q=n;break a}}o=c[p>>2]|0;if(!o){q=p;break}else n=p}if((q|0)!=(l|0)?(m|0)>=(c[q+16>>2]|0):0){r=ea(g[e>>2]);s=ea(g[e+4>>2]);g[q+20>>2]=r;g[q+24>>2]=s}}q=b+32|0;m=c[q>>2]|0;if(!m){Qjd(b);t=c[q>>2]|0}else t=m;a[b+36>>0]=1;s=ea(g[e>>2]);wud(t,d,s,ea(g[e+4>>2]));c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];Ujd(b,h);i=f;return}function vkd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;Ujc(b+72|0,d+72|0)|0;j=b+32|0;k=c[j>>2]|0;if(k){l=c[153078]|0;m=k+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0)){ko[c[c[k>>2]>>2]&4095](k);c[g>>2]=l;c[f+0>>2]=c[g+0>>2];eOb(k,f)}c[j>>2]=0}c[h>>2]=c[153078];c[f+0>>2]=c[h+0>>2];h=bOb(84,f,0,16,3653512,1072)|0;k=d+32|0;l=c[k>>2]|0;if(!l){Qjd(d);n=c[k>>2]|0}else n=l;iud(h,n);c[j>>2]=h;c[h+80>>2]=b;a[b+36>>0]=1;h=b+28|0;j=c[h>>2]|0;if(j){c[g>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(f,j,g);n=c[f>>2]|0;l=c[j+28>>2]|0;if((n|0)==-1){o=l+(c[j+32>>2]<<3)|0;break}else{o=l+(n<<3)|0;break}}else o=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((o|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(c[o+4>>2]|0)!=0:0){Tjd(b);i=e;return}}if(hQb(c[h>>2]|0)|0){Tjd(b);i=e;return}}Ald()|0;Tjd(b);i=e;return}function wkd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=WQb(a)|0;e=c[a+32>>2]|0;if(!e){f=d;i=b;return f|0}f=(Aud(e)|0)+d|0;i=b;return f|0}function xkd(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;d=c[155328]|0;e=c[d+4>>2]|0;if((e|0)==(d|0)){i=b;return}else{f=e;g=d}while(1){d=c[f+8>>2]|0;e=d+40|0;h=c[e>>2]|0;j=(c[d+44>>2]|0)-h|0;k=(j|0)/44|0;if((j|0)>0){j=h;h=0;while(1){l=c[j+(h*44|0)+8>>2]|0;if((l|0)>0){m=j+(h*44|0)|0;n=0;do{o=(c[m>>2]|0)+(n*28|0)|0;p=c[o>>2]|0;if(p){q=p+4|0;c[q>>2]=(c[q>>2]|0)+-1;if(!(c[q>>2]|0))ko[c[(c[p>>2]|0)+4>>2]&4095](p);c[o>>2]=0}n=n+1|0}while((n|0)!=(l|0))}l=j+(h*44|0)+16|0;n=c[l>>2]|0;if(n){m=n+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0))ko[c[(c[n>>2]|0)+4>>2]&4095](n);c[l>>2]=0}l=h+1|0;if((l|0)>=(k|0))break;j=c[e>>2]|0;h=l}r=c[155328]|0}else r=g;a[d+36>>0]=0;h=c[r+4>>2]|0;if((h|0)!=(r|0)){e=c[h>>2]|0;if(!e){s=h;t=r}else{j=h+4|0;c[e+4>>2]=c[j>>2];c[c[j>>2]>>2]=e;c[h>>2]=0;c[j>>2]=0;j=c[155328]|0;s=c[j+4>>2]|0;t=j}}else{s=r;t=r}if((s|0)==(t|0))break;else{f=s;g=t}}i=b;return}function ykd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;d=xmd(f)|0;f=b+(d>>>5<<2)+120|0;g=c[f>>2]|0;h=1<<(d&31);if(h&g){i=e;return}c[f>>2]=h|g;Amd(b+120|0,b+108|0);Tjd(b);i=e;return}function zkd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;d=xmd(f)|0;f=b+(d>>>5<<2)+120|0;g=c[f>>2]|0;h=1<<(d&31);if(!(h&g)){i=e;return}c[f>>2]=g&~h;Amd(b+120|0,b+108|0);Tjd(b);i=e;return}function Akd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;ymd(b,e);b=a+120|0;f=0;while(1){if((c[a+(f<<2)+120>>2]|0)!=(c[e+(f<<2)>>2]|0))break;f=f+1|0;if((f|0)>=4){g=5;break}}if((g|0)==5){i=d;return};c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];Amd(b,a+108|0);Tjd(a);i=d;return}function Bkd(a,b){a=a|0;b=b|0;var d=0;d=a+64|0;if((c[d>>2]|0)!=(b|0))c[d>>2]=b;return}function Ckd(){var a=0;a=i;QQb(21,167,168,0,169);i=a;return}function Dkd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,2438376,8);wQb(21,130,b,144,2717,0,0);xri(b);i=a;return}function Ekd(a){a=a|0;return 21}function Fkd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2438376,a,0);Lkd(a,b);bdd(b);i=c;return}function Gkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2438376,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Mkd(a,b);sdd(b);i=d;return}function Hkd(a,b){a=a|0;b=b|0;var c=0;c=i;Nkd(a,b);i=c;return}function Ikd(a,b){a=a|0;b=b|0;var c=0;c=i;Okd(a,b);i=c;return}function Jkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;BWb(a,b);R2b(a+28|0,b);FXb(b,a+108|0,621448,0);e=a+64|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;if(h>>>0<(c[b+20>>2]|0)>>>0){c[g>>2]=c[e>>2];c[f>>2]=h;j=a+72|0;Rkd(j,b);i=d;return}else{Gid(f,e,4);j=a+72|0;Rkd(j,b);i=d;return}}function Kkd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;CWb(b,d);f=b+28|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=c[b+72>>2]|0;f=b+76|0;if((k|0)==(f|0)){i=e;return}b=k;while(1){k=b+36|0;d=c[g>>2]|0;l=xo[c[c[d>>2]>>2]&2047](d,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=l;l=c[b+4>>2]|0;if(!l){k=b;while(1){d=c[k+8>>2]|0;if((c[d>>2]|0)==(k|0)){m=d;break}else k=d}}else{k=l;while(1){d=c[k>>2]|0;if(!d){m=k;break}else k=d}}if((m|0)==(f|0))break;else b=m}i=e;return}function Lkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;ddd(b,4);xWb(a,b);f=a+28|0;add(b,621432,623064,f,0);g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[142270]|0;add(b,792256,h,f,1);f=b+12|0;j=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,g,1);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,621448,c[142294]|0,a+108|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,c[142260]|0,d+16|0,0);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);add(b,621472,h,a+64|0,0);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+72|0;add(b,621496,621576,j,0);Skd(j,b);bdd(b);i=d;return}function Mkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;rdd(b,4);yWb(a,b);f=a+28|0;g=qdd(b,621432,623064,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else T2b(f,b);sdd(b)}f=a+108|0;g=qdd(b,621448,c[142294]|0,e,0)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else zXb(b,f,1);sdd(b)}f=a+64|0;g=qdd(b,621472,c[142270]|0,e,0)|0;if(g){if((g|0)>0){g=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[g>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[k>>2];c[g>>2]=l}else Bid(g,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}sdd(b)}f=a+72|0;g=qdd(b,621496,621576,e,1)|0;if(!g){Ukd(a,b);i=d;return}if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else Tkd(f,b);sdd(b);Ukd(a,b);i=d;return}function Nkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;zWb(a,b);L2b(a+28|0,b);NXb(b,a+108|0,1);Ndd(b);e=a+64|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;if(h>>>0>(c[b+20>>2]|0)>>>0)Bid(f,e,4);else{c[e>>2]=c[g>>2];c[f>>2]=h}Vkd(b,a+72|0,0);Wkd(b,a+84|0,0);Xkd(b,a+96|0,0);i=d;return}function Okd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;AWb(a,b);O2b(a+28|0,b);OXb(b,a+108|0,1);Mdd(b);e=a+64|0;f=b+12|0;g=c[f>>2]|0;h=g+4|0;if(h>>>0>(c[b+20>>2]|0)>>>0){Bid(f,e,4);j=c[e>>2]|0}else{k=c[g>>2]|0;c[e>>2]=k;c[f>>2]=h;j=k}c[e>>2]=XEi(j|0)|0;Ykd(b,a+72|0,0);Zkd(b,a+84|0,0);_kd(b,a+96|0,0);i=d;return}function Pkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/44|0)>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+4>>2]=60;k=n+16|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;o=c[j>>2]|0}n=o+44|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=((l-m|0)/44|0)+b|0;if(n>>>0>97612893)vxi(a);l=m;m=(h-l|0)/44|0;if(m>>>0<48806446){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/44|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=97612893;t=((c[j>>2]|0)-l|0)/44|0;u=10}if((u|0)==10){p=s;q=xCi(s*44|0)|0;r=t}t=q+(r*44|0)|0;r=b;b=t;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=60;s=b+16|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;c[s+20>>2]=0;c[s+24>>2]=0;v=b}s=v+44|0;r=r+-1|0;if(!r){w=s;break}else b=s}b=q+(p*44|0)|0;p=c[a>>2]|0;q=c[j>>2]|0;if((q|0)!=(p|0)){r=q;q=t;while(1){v=r;r=r+-44|0;s=c[v+-40>>2]|0;c[q+-40>>2]=s;u=q+-36|0;c[u>>2]=0;l=q+-32|0;c[l>>2]=0;h=q+-44|0;c[h>>2]=0;m=c[r>>2]|0;n=(c[v+-36>>2]|0)*28|0;o=(n|0)/28|0;c[u>>2]=o;if(!n){x=o;y=0}else{c[l>>2]=o;c[f>>2]=s;c[e+0>>2]=c[f+0>>2];s=hOb(0,n,4,e,0,3653512,370)|0;c[h>>2]=s;x=c[u>>2]|0;y=s}YEi(y|0,m|0,x*28|0)|0;m=q+-28|0;s=v+-28|0;c[m+0>>2]=c[s+0>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];c[m+16>>2]=c[s+16>>2];c[m+20>>2]=c[s+20>>2];c[m+24>>2]=c[s+24>>2];s=q+-44|0;if((r|0)==(p|0)){z=s;break}else q=s}q=c[a>>2]|0;r=c[j>>2]|0;c[a>>2]=z;c[j>>2]=w;c[g>>2]=b;if((r|0)==(q|0))A=q;else{z=r;do{r=z;z=z+-44|0;if((c[r+-32>>2]|0)>-1){x=c[z>>2]|0;c[f>>2]=c[r+-40>>2];c[e+0>>2]=c[f+0>>2];eOb(x,e);c[z>>2]=0}}while((z|0)!=(q|0));A=q}}else{c[a>>2]=t;c[j>>2]=w;c[g>>2]=b;A=p}if(!A){i=d;return}ACi(A);i=d;return}function Qkd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(144,f,1,16,3653512,36)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];mWb(h,f,d);c[h>>2]=621328;d=h+40|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[h+60>>2]=h;c[h+68>>2]=0;d=h+76|0;c[d>>2]=0;c[h+80>>2]=0;c[h+72>>2]=d;d=h+88|0;c[d>>2]=0;c[h+92>>2]=0;c[h+84>>2]=d;d=h+100|0;c[d>>2]=0;c[h+104>>2]=0;c[h+96>>2]=d;d=h+108|0;c[h+32>>2]=0;a[h+36>>0]=0;c[h+28>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[h+64>>2]=-1;c[h+136>>2]=0;c[h+140>>2]=0;i=e;return h|0}function Rkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=c[a+8>>2]|0;c[e>>2]=f;h=b+12|0;j=c[h>>2]|0;k=j+4|0;l=b+20|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=f;c[h>>2]=k}else Gid(h,e,4);k=a+4|0;f=c[a>>2]|0;if((f|0)!=(k|0)){j=f;while(1){Ejd(j+16|0,b);ald(j+20|0,b);f=c[j+4>>2]|0;if(!f){m=j;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){o=n;break}else m=n}}else{m=f;while(1){n=c[m>>2]|0;if(!n){o=m;break}else m=n}}if((o|0)==(k|0))break;else j=o}}o=c[a+20>>2]|0;c[e>>2]=o;j=c[h>>2]|0;k=j+4|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=o;c[h>>2]=k}else Gid(h,e,4);k=a+16|0;o=c[a+12>>2]|0;if((o|0)!=(k|0)){j=o;while(1){Ejd(j+16|0,b);o=j+20|0;m=c[h>>2]|0;f=m+4|0;if(f>>>0<(c[l>>2]|0)>>>0){g[m>>2]=ea(g[o>>2]);c[h>>2]=f}else Gid(h,o,4);o=c[j+4>>2]|0;if(!o){f=j;while(1){m=c[f+8>>2]|0;if((c[m>>2]|0)==(f|0)){p=m;break}else f=m}}else{f=o;while(1){m=c[f>>2]|0;if(!m){p=f;break}else f=m}}if((p|0)==(k|0))break;else j=p}}p=c[a+32>>2]|0;c[e>>2]=p;j=c[h>>2]|0;k=j+4|0;if(k>>>0<(c[l>>2]|0)>>>0){c[j>>2]=p;c[h>>2]=k}else Gid(h,e,4);e=a+28|0;h=c[a+24>>2]|0;if((h|0)==(e|0)){i=d;return}a=h;while(1){Ejd(a+16|0,b);PYb(a+20|0,b);h=c[a+4>>2]|0;if(!h){k=a;while(1){p=c[k+8>>2]|0;if((c[p>>2]|0)==(k|0)){q=p;break}else k=p}}else{k=h;while(1){p=c[k>>2]|0;if(!p){q=k;break}else k=p}}if((q|0)==(e|0))break;else a=q}i=d;return}function Skd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d;ddd(b,2);h=c[142272]|0;add(b,621520,h,a,0);$cd(b,2646336,2646336,e,0);c[f>>2]=-1;j=f+4|0;und(j);k=c[142274]|0;add(b,3142592,k,f,0);l=c[142266]|0;add(b,l,621600,f,0);Fjd(f,b);bdd(b);m=c[142282]|0;add(b,m,621624,j,0);bld(j,b);bdd(b);bdd(b);cdd(b);bdd(b);add(b,621536,h,a+12|0,0);$cd(b,2646336,2646336,e,0);c[f>>2]=-1;j=f+4|0;g[j>>2]=ea(0.0);add(b,3142592,k,f,0);add(b,l,621600,f,0);Fjd(f,b);bdd(b);add(b,m,c[142268]|0,j,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);cdd(b);bdd(b);add(b,621552,h,a+24|0,0);$cd(b,2646336,2646336,e,0);c[f>>2]=-1;add(b,3142592,k,f,0);add(b,l,621600,f,0);Fjd(f,b);bdd(b);l=f+4|0;add(b,m,c[142262]|0,l,0);EYb(l,b);bdd(b);bdd(b);cdd(b);bdd(b);i=d;return}function Tkd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;rdd(b,2);f=c[142272]|0;g=qdd(b,621520,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else cld(b,a,0);sdd(b)}g=a+12|0;h=qdd(b,621536,f,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}else dld(b,g,0);sdd(b)}g=a+24|0;a=qdd(b,621552,f,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}else eld(b,g,0);sdd(b);i=d;return}function Ukd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e;if(!(xdd(d,3)|0)){i=e;return}c[h>>2]=0;j=h+4|0;c[j>>2]=0;c[h+8>>2]=0;k=qdd(d,621448,c[142306]|0,f,1)|0;if(k){if((k|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else yXb(d,h,0);sdd(d)}Bmd(h,b+108|0);b=c[h>>2]|0;if(!b){i=e;return}d=c[j>>2]|0;if((d|0)==(b|0))l=b;else{k=d;while(1){d=k+-12|0;c[j>>2]=d;if(!(a[d>>0]&1))m=d;else{d=c[k+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(d,f);m=c[j>>2]|0}if((m|0)==(b|0))break;else k=m}l=c[h>>2]|0}ACi(l);i=e;return}function Vkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+48|0;e=d+44|0;f=d;g=d+40|0;h=d+16|0;j=a+12|0;k=c[j>>2]|0;l=k+4|0;if(l>>>0>(c[a+20>>2]|0)>>>0)Bid(j,g,4);else{c[g>>2]=c[k>>2];c[j>>2]=l}c[h>>2]=-1;l=h+4|0;und(l);j=b+4|0;Xjc(b,c[j>>2]|0);k=b+8|0;c[k>>2]=0;m=b+4|0;c[b>>2]=m;c[m>>2]=0;if((c[g>>2]|0)<=0){i=d;return}n=h+20|0;o=0;do{Djd(h,a);fld(l,a);p=c[h>>2]|0;q=c[n>>2]|0;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];r=c[j>>2]|0;do if(r){s=r;while(1){t=c[s+16>>2]|0;if((p|0)<(t|0)){u=c[s>>2]|0;if(!u){v=s;w=s;x=9;break}else{s=u;continue}}if((t|0)>=(p|0)){y=s;x=13;break}t=s+4|0;u=c[t>>2]|0;if(!u){z=t;A=s;x=12;break}else s=u}if((x|0)==9){x=0;c[e>>2]=w;B=v;C=w;break}else if((x|0)==12){x=0;c[e>>2]=A;B=z;C=A;break}else if((x|0)==13){x=0;c[e>>2]=y;B=e;C=y;break}}else{c[e>>2]=m;B=m;C=m}while(0);if(!(c[B>>2]|0)){r=xCi(40)|0;s=r+20|0;c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];c[r+36>>2]=q;c[r+16>>2]=p;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=C;c[B>>2]=r;s=c[c[b>>2]>>2]|0;if(!s)D=r;else{c[b>>2]=s;D=c[B>>2]|0}GN(c[j>>2]|0,D);c[k>>2]=(c[k>>2]|0)+1}o=o+1|0}while((o|0)<(c[g>>2]|0));i=d;return}function Wkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d;j=a+12|0;k=c[j>>2]|0;l=k+4|0;m=a+20|0;if(l>>>0>(c[m>>2]|0)>>>0)Bid(j,f,4);else{c[f>>2]=c[k>>2];c[j>>2]=l}c[h>>2]=-1;l=h+4|0;g[l>>2]=ea(0.0);k=b+4|0;Wjc(b,c[k>>2]|0);n=b+8|0;c[n>>2]=0;o=b+4|0;c[b>>2]=o;c[o>>2]=0;if((c[f>>2]|0)<=0){i=d;return}p=0;do{Djd(h,a);q=c[j>>2]|0;r=q+4|0;if(r>>>0>(c[m>>2]|0)>>>0){Bid(j,l,4);s=ea(g[l>>2])}else{t=ea(g[q>>2]);g[l>>2]=t;c[j>>2]=r;s=t}r=c[h>>2]|0;t=ea(s);q=c[k>>2]|0;do if(q){u=q;while(1){v=c[u+16>>2]|0;if((r|0)<(v|0)){w=c[u>>2]|0;if(!w){x=u;y=u;z=12;break}else{u=w;continue}}if((v|0)>=(r|0)){A=u;z=16;break}v=u+4|0;w=c[v>>2]|0;if(!w){B=v;C=u;z=15;break}else u=w}if((z|0)==12){z=0;c[e>>2]=y;D=x;E=y;break}else if((z|0)==15){z=0;c[e>>2]=C;D=B;E=C;break}else if((z|0)==16){z=0;c[e>>2]=A;D=e;E=A;break}}else{c[e>>2]=o;D=o;E=o}while(0);if(!(c[D>>2]|0)){q=xCi(24)|0;u=q+16|0;c[u>>2]=r;g[u+4>>2]=t;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=E;c[D>>2]=q;u=c[c[b>>2]>>2]|0;if(!u)F=q;else{c[b>>2]=u;F=c[D>>2]|0}GN(c[k>>2]|0,F);c[n>>2]=(c[n>>2]|0)+1}p=p+1|0}while((p|0)<(c[f>>2]|0));i=d;return}function Xkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+48|0;e=d+40|0;f=d;g=d+36|0;h=d+16|0;j=a+12|0;k=c[j>>2]|0;l=k+4|0;if(l>>>0>(c[a+20>>2]|0)>>>0)Bid(j,g,4);else{c[g>>2]=c[k>>2];c[j>>2]=l}c[h>>2]=-1;l=b+4|0;Vjc(b,c[l>>2]|0);j=b+8|0;c[j>>2]=0;k=b+4|0;c[b>>2]=k;c[k>>2]=0;if((c[g>>2]|0)<=0){i=d;return}m=h+4|0;n=0;do{Djd(h,a);JYb(m,a);o=c[h>>2]|0;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];p=c[l>>2]|0;do if(p){q=p;while(1){r=c[q+16>>2]|0;if((o|0)<(r|0)){s=c[q>>2]|0;if(!s){t=q;u=q;v=9;break}else{q=s;continue}}if((r|0)>=(o|0)){w=q;v=13;break}r=q+4|0;s=c[r>>2]|0;if(!s){x=r;y=q;v=12;break}else q=s}if((v|0)==9){v=0;c[e>>2]=u;z=t;A=u;break}else if((v|0)==12){v=0;c[e>>2]=y;z=x;A=y;break}else if((v|0)==13){v=0;c[e>>2]=w;z=e;A=w;break}}else{c[e>>2]=k;z=k;A=k}while(0);if(!(c[z>>2]|0)){p=xCi(36)|0;c[p+16>>2]=o;q=p+20|0;c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=A;c[z>>2]=p;q=c[c[b>>2]>>2]|0;if(!q)B=p;else{c[b>>2]=q;B=c[z>>2]|0}GN(c[l>>2]|0,B);c[j>>2]=(c[j>>2]|0)+1}n=n+1|0}while((n|0)<(c[g>>2]|0));i=d;return}function Ykd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+48|0;e=d+44|0;f=d;g=d+40|0;h=d+16|0;j=a+12|0;k=c[j>>2]|0;l=k+4|0;if(l>>>0>(c[a+20>>2]|0)>>>0){Bid(j,g,4);m=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[j>>2]=l;m=n}c[g>>2]=XEi(m|0)|0;c[h>>2]=-1;m=h+4|0;und(m);n=b+4|0;Xjc(b,c[n>>2]|0);l=b+8|0;c[l>>2]=0;j=b+4|0;c[b>>2]=j;c[j>>2]=0;if((c[g>>2]|0)<=0){i=d;return}k=h+20|0;o=0;do{Gjd(h,a);gld(m,a);p=c[h>>2]|0;q=c[k>>2]|0;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];r=c[n>>2]|0;do if(r){s=r;while(1){t=c[s+16>>2]|0;if((p|0)<(t|0)){u=c[s>>2]|0;if(!u){v=s;w=s;x=9;break}else{s=u;continue}}if((t|0)>=(p|0)){y=s;x=13;break}t=s+4|0;u=c[t>>2]|0;if(!u){z=t;A=s;x=12;break}else s=u}if((x|0)==9){x=0;c[e>>2]=w;B=v;C=w;break}else if((x|0)==12){x=0;c[e>>2]=A;B=z;C=A;break}else if((x|0)==13){x=0;c[e>>2]=y;B=e;C=y;break}}else{c[e>>2]=j;B=j;C=j}while(0);if(!(c[B>>2]|0)){r=xCi(40)|0;s=r+20|0;c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];c[r+36>>2]=q;c[r+16>>2]=p;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=C;c[B>>2]=r;s=c[c[b>>2]>>2]|0;if(!s)D=r;else{c[b>>2]=s;D=c[B>>2]|0}GN(c[n>>2]|0,D);c[l>>2]=(c[l>>2]|0)+1}o=o+1|0}while((o|0)<(c[g>>2]|0));i=d;return}function Zkd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d;j=a+12|0;l=c[j>>2]|0;m=l+4|0;n=a+20|0;if(m>>>0>(c[n>>2]|0)>>>0){Bid(j,f,4);o=c[f>>2]|0}else{p=c[l>>2]|0;c[f>>2]=p;c[j>>2]=m;o=p}c[f>>2]=XEi(o|0)|0;c[h>>2]=-1;o=h+4|0;g[o>>2]=ea(0.0);p=b+4|0;Wjc(b,c[p>>2]|0);m=b+8|0;c[m>>2]=0;l=b+4|0;c[b>>2]=l;c[l>>2]=0;if((c[f>>2]|0)<=0){i=d;return}q=0;do{Gjd(h,a);r=c[j>>2]|0;s=r+4|0;if(s>>>0>(c[n>>2]|0)>>>0){Bid(j,o,4);t=c[o>>2]|0}else{u=ea(g[r>>2]);g[o>>2]=u;c[j>>2]=s;t=(g[k>>2]=u,c[k>>2]|0)}s=XEi(t|0)|0;c[o>>2]=s;r=c[h>>2]|0;v=c[p>>2]|0;do if(v){w=v;while(1){x=c[w+16>>2]|0;if((r|0)<(x|0)){y=c[w>>2]|0;if(!y){z=w;A=w;B=12;break}else{w=y;continue}}if((x|0)>=(r|0)){C=w;B=16;break}x=w+4|0;y=c[x>>2]|0;if(!y){D=x;E=w;B=15;break}else w=y}if((B|0)==12){B=0;c[e>>2]=A;F=z;G=A;break}else if((B|0)==15){B=0;c[e>>2]=E;F=D;G=E;break}else if((B|0)==16){B=0;c[e>>2]=C;F=e;G=C;break}}else{c[e>>2]=l;F=l;G=l}while(0);if(!(c[F>>2]|0)){v=xCi(24)|0;w=v+16|0;c[w>>2]=r;c[w+4>>2]=s;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=G;c[F>>2]=v;w=c[c[b>>2]>>2]|0;if(!w)H=v;else{c[b>>2]=w;H=c[F>>2]|0}GN(c[p>>2]|0,H);c[m>>2]=(c[m>>2]|0)+1}q=q+1|0}while((q|0)<(c[f>>2]|0));i=d;return}function _kd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+48|0;e=d+40|0;f=d;g=d+36|0;h=d+16|0;j=a+12|0;k=c[j>>2]|0;l=k+4|0;if(l>>>0>(c[a+20>>2]|0)>>>0){Bid(j,g,4);m=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[j>>2]=l;m=n}c[g>>2]=XEi(m|0)|0;c[h>>2]=-1;m=b+4|0;Vjc(b,c[m>>2]|0);n=b+8|0;c[n>>2]=0;l=b+4|0;c[b>>2]=l;c[l>>2]=0;if((c[g>>2]|0)<=0){i=d;return}j=h+4|0;k=0;do{Gjd(h,a);MYb(j,a);o=c[h>>2]|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];p=c[m>>2]|0;do if(p){q=p;while(1){r=c[q+16>>2]|0;if((o|0)<(r|0)){s=c[q>>2]|0;if(!s){t=q;u=q;v=9;break}else{q=s;continue}}if((r|0)>=(o|0)){w=q;v=13;break}r=q+4|0;s=c[r>>2]|0;if(!s){x=r;y=q;v=12;break}else q=s}if((v|0)==9){v=0;c[e>>2]=u;z=t;A=u;break}else if((v|0)==12){v=0;c[e>>2]=y;z=x;A=y;break}else if((v|0)==13){v=0;c[e>>2]=w;z=e;A=w;break}}else{c[e>>2]=l;z=l;A=l}while(0);if(!(c[z>>2]|0)){p=xCi(36)|0;c[p+16>>2]=o;q=p+20|0;c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=A;c[z>>2]=p;q=c[c[b>>2]>>2]|0;if(!q)B=p;else{c[b>>2]=q;B=c[z>>2]|0}GN(c[m>>2]|0,B);c[n>>2]=(c[n>>2]|0)+1}k=k+1|0}while((k|0)<(c[g>>2]|0));i=d;return}function $kd(a){a=a|0;var b=0;b=i;UHc(a);ACi(a);i=b;return}function ald(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;OYb(a+16|0,b);e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){g[f>>2]=ea(g[a>>2]);c[e>>2]=h;k=h;l=b}else{Gid(e,a,4);k=c[e>>2]|0;l=c[j>>2]|0}b=a+4|0;h=k+4|0;if(h>>>0<l>>>0){g[k>>2]=ea(g[b>>2]);c[e>>2]=h;m=h;n=l}else{Gid(e,b,4);m=c[e>>2]|0;n=c[j>>2]|0}b=a+8|0;l=m+4|0;if(l>>>0<n>>>0){g[m>>2]=ea(g[b>>2]);c[e>>2]=l;o=l;p=n}else{Gid(e,b,4);o=c[e>>2]|0;p=c[j>>2]|0}j=a+12|0;a=o+4|0;if(a>>>0<p>>>0){g[o>>2]=ea(g[j>>2]);c[e>>2]=a;i=d;return}else{Gid(e,j,4);i=d;return}}function bld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=a+16|0;add(b,723352,723608,f,0);g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,g,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);g=c[142308]|0;add(b,621568,g,a,0);h=b+16|0;j=c[($hd(h)|0)+20>>2]|2097152;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+20>>2]=j;j=c[142268]|0;add(b,3143216,j,a,0);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,j,a+4|0,0);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);k=a+8|0;add(b,632240,g,k,0);g=c[($hd(h)|0)+20>>2]|2097152;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+20>>2]=g;add(b,3143216,j,k,0);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,j,a+12|0,0);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);i=d;return}function cld(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+48|0;e=d+44|0;f=d;g=d+40|0;h=d+16|0;j=b+8|0;c[g>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,g)|0)){i=d;return}c[h>>2]=-1;k=h+4|0;und(k);l=b+4|0;Xjc(b,c[l>>2]|0);c[j>>2]=0;m=b+4|0;c[b>>2]=m;c[m>>2]=0;if((c[g>>2]|0)>0){n=c[142274]|0;o=h+20|0;p=0;do{q=qdd(a,3142592,n,e,1)|0;if(q){if((q|0)<=0){q=c[e>>2]|0;if(q)_n[q&4095](h,a)|0}else hld(h,a);sdd(a)}q=c[h>>2]|0;r=c[o>>2]|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];s=c[l>>2]|0;do if(s){t=s;while(1){u=c[t+16>>2]|0;if((q|0)<(u|0)){v=c[t>>2]|0;if(!v){w=t;x=t;y=13;break}else{t=v;continue}}if((u|0)>=(q|0)){z=t;y=17;break}u=t+4|0;v=c[u>>2]|0;if(!v){A=u;B=t;y=16;break}else t=v}if((y|0)==13){y=0;c[e>>2]=x;C=w;D=x;break}else if((y|0)==16){y=0;c[e>>2]=B;C=A;D=B;break}else if((y|0)==17){y=0;c[e>>2]=z;C=e;D=z;break}}else{c[e>>2]=m;C=m;D=m}while(0);if(!(c[C>>2]|0)){s=xCi(40)|0;t=s+20|0;c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];c[s+36>>2]=r;c[s+16>>2]=q;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=D;c[C>>2]=s;t=c[c[b>>2]>>2]|0;if(!t)E=s;else{c[b>>2]=t;E=c[C>>2]|0}GN(c[l>>2]|0,E);c[j>>2]=(c[j>>2]|0)+1}p=p+1|0}while((p|0)<(c[g>>2]|0))}udd(a);i=d;return}function dld(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+12|0;j=d+8|0;k=d;l=b+8|0;c[j>>2]=c[l>>2];if(!(tdd(a,2646336,2646336,j)|0)){i=d;return}c[k>>2]=-1;m=k+4|0;g[m>>2]=ea(0.0);n=b+4|0;Wjc(b,c[n>>2]|0);c[l>>2]=0;o=b+4|0;c[b>>2]=o;c[o>>2]=0;if((c[j>>2]|0)>0){p=c[142274]|0;q=c[142266]|0;r=c[142282]|0;s=c[142268]|0;t=a+12|0;u=a+80|0;v=a+16|0;w=a+28|0;x=a+32|0;y=a+20|0;z=0;do{A=qdd(a,3142592,p,h,1)|0;if(A){if((A|0)>0){A=qdd(a,q,621600,f,1)|0;if(A){if((A|0)<=0){A=c[f>>2]|0;if(A)_n[A&4095](k,a)|0}else Hjd(k,a);sdd(a)}A=qdd(a,r,s,e,0)|0;if(A){if((A|0)>0){A=c[v>>2]|0;B=(c[(c[u>>2]|0)+12>>2]|0)-(da(c[x>>2]|0,c[w>>2]|0)|0)|0;C=A+B|0;c[t>>2]=C;if((B|0)>=0?(D=A+(B+4)|0,D>>>0<=(c[y>>2]|0)>>>0):0){g[m>>2]=ea(g[C>>2]);c[t>>2]=D}else Bid(t,m,4);if(c[a>>2]&512)c[m>>2]=XEi(c[m>>2]|0)|0}else{D=c[e>>2]|0;if(D)_n[D&4095](m,a)|0}sdd(a)}}else{D=c[h>>2]|0;if(D)_n[D&4095](k,a)|0}sdd(a)}D=c[k>>2]|0;E=ea(g[m>>2]);F=ea(E);C=c[n>>2]|0;do if(C){B=C;while(1){A=c[B+16>>2]|0;if((D|0)<(A|0)){G=c[B>>2]|0;if(!G){H=B;I=B;J=29;break}else{B=G;continue}}if((A|0)>=(D|0)){K=B;J=33;break}A=B+4|0;G=c[A>>2]|0;if(!G){L=A;M=B;J=32;break}else B=G}if((J|0)==29){J=0;c[f>>2]=I;N=H;O=I;break}else if((J|0)==32){J=0;c[f>>2]=M;N=L;O=M;break}else if((J|0)==33){J=0;c[f>>2]=K;N=f;O=K;break}}else{c[f>>2]=o;N=o;O=o}while(0);if(!(c[N>>2]|0)){C=xCi(24)|0;B=C+16|0;c[B>>2]=D;g[B+4>>2]=F;c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=O;c[N>>2]=C;B=c[c[b>>2]>>2]|0;if(!B)P=C;else{c[b>>2]=B;P=c[N>>2]|0}GN(c[n>>2]|0,P);c[l>>2]=(c[l>>2]|0)+1}z=z+1|0}while((z|0)<(c[j>>2]|0))}udd(a);i=d;return}function eld(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+48|0;e=d+40|0;f=d;g=d+36|0;h=d+16|0;j=b+8|0;c[g>>2]=c[j>>2];if(!(tdd(a,2646336,2646336,g)|0)){i=d;return}c[h>>2]=-1;k=b+4|0;Vjc(b,c[k>>2]|0);c[j>>2]=0;l=b+4|0;c[b>>2]=l;c[l>>2]=0;if((c[g>>2]|0)>0){m=c[142274]|0;n=h+4|0;o=0;do{p=qdd(a,3142592,m,e,1)|0;if(p){if((p|0)<=0){p=c[e>>2]|0;if(p)_n[p&4095](h,a)|0}else ild(h,a);sdd(a)}p=c[h>>2]|0;c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];q=c[k>>2]|0;do if(q){r=q;while(1){s=c[r+16>>2]|0;if((p|0)<(s|0)){t=c[r>>2]|0;if(!t){u=r;v=r;w=13;break}else{r=t;continue}}if((s|0)>=(p|0)){x=r;w=17;break}s=r+4|0;t=c[s>>2]|0;if(!t){y=s;z=r;w=16;break}else r=t}if((w|0)==13){w=0;c[e>>2]=v;A=u;B=v;break}else if((w|0)==16){w=0;c[e>>2]=z;A=y;B=z;break}else if((w|0)==17){w=0;c[e>>2]=x;A=e;B=x;break}}else{c[e>>2]=l;A=l;B=l}while(0);if(!(c[A>>2]|0)){q=xCi(36)|0;c[q+16>>2]=p;r=q+20|0;c[r+0>>2]=c[f+0>>2];c[r+4>>2]=c[f+4>>2];c[r+8>>2]=c[f+8>>2];c[r+12>>2]=c[f+12>>2];c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=B;c[A>>2]=q;r=c[c[b>>2]>>2]|0;if(!r)C=q;else{c[b>>2]=r;C=c[A>>2]|0}GN(c[k>>2]|0,C);c[j>>2]=(c[j>>2]|0)+1}o=o+1|0}while((o|0)<(c[g>>2]|0))}udd(a);i=d;return}function fld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;IYb(a+16|0,b);e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);k=c[e>>2]|0;l=c[j>>2]|0}else{g[a>>2]=ea(g[f>>2]);c[e>>2]=h;k=h;l=b}b=a+4|0;h=k+4|0;if(h>>>0>l>>>0){Bid(e,b,4);m=c[e>>2]|0;n=c[j>>2]|0}else{g[b>>2]=ea(g[k>>2]);c[e>>2]=h;m=h;n=l}l=a+8|0;h=m+4|0;if(h>>>0>n>>>0){Bid(e,l,4);o=c[e>>2]|0;p=c[j>>2]|0}else{g[l>>2]=ea(g[m>>2]);c[e>>2]=h;o=h;p=n}n=a+12|0;a=o+4|0;if(a>>>0>p>>>0){Bid(e,n,4);i=d;return}else{g[n>>2]=ea(g[o>>2]);c[e>>2]=a;i=d;return}}function gld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;LYb(a+16|0,b);e=b+12|0;f=c[e>>2]|0;h=f+4|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(e,a,4);l=a;m=c[e>>2]|0;n=c[j>>2]|0;o=c[a>>2]|0}else{p=ea(g[f>>2]);g[a>>2]=p;c[e>>2]=h;l=a;m=h;n=b;o=(g[k>>2]=p,c[k>>2]|0)}c[l>>2]=XEi(o|0)|0;o=a+4|0;l=m+4|0;if(l>>>0>n>>>0){Bid(e,o,4);q=o;r=c[o>>2]|0;s=c[e>>2]|0;t=c[j>>2]|0}else{p=ea(g[m>>2]);g[o>>2]=p;c[e>>2]=l;q=o;r=(g[k>>2]=p,c[k>>2]|0);s=l;t=n}c[q>>2]=XEi(r|0)|0;r=a+8|0;q=s+4|0;if(q>>>0>t>>>0){Bid(e,r,4);u=r;v=c[r>>2]|0;w=c[e>>2]|0;x=c[j>>2]|0}else{p=ea(g[s>>2]);g[r>>2]=p;c[e>>2]=q;u=r;v=(g[k>>2]=p,c[k>>2]|0);w=q;x=t}c[u>>2]=XEi(v|0)|0;v=a+12|0;a=w+4|0;if(a>>>0>x>>>0){Bid(e,v,4);y=v;z=c[v>>2]|0;A=XEi(z|0)|0;c[y>>2]=A;i=d;return}else{p=ea(g[w>>2]);g[v>>2]=p;c[e>>2]=a;y=v;z=(g[k>>2]=p,c[k>>2]|0);A=XEi(z|0)|0;c[y>>2]=A;i=d;return}}function hld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,621600,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Hjd(a,b);sdd(b)}f=a+4|0;a=qdd(b,c[142282]|0,621624,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else jld(f,b);sdd(b);i=d;return}function ild(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,621600,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Hjd(a,b);sdd(b)}f=a+4|0;a=qdd(b,c[142282]|0,c[142262]|0,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else HYb(f,b);sdd(b);i=d;return}function jld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=a+16|0;g=qdd(b,723352,723608,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](f,b)|0}else GYb(f,b);sdd(b)}f=c[142308]|0;g=qdd(b,621568,f,e,1)|0;if(g){if((g|0)<=0){g=c[e>>2]|0;if(g)_n[g&4095](a,b)|0}else hgc(a,b);sdd(b)}g=a+8|0;a=qdd(b,632240,f,e,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](g,b)|0}else hgc(g,b);sdd(b);i=d;return}function kld(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+16|0;h=g+4|0;j=g;c[a>>2]=0;k=a+8|0;c[k>>2]=0;l=a+12|0;c[l>>2]=0;c[a+4>>2]=60;m=a+16|0;c[m>>2]=0;n=a+24|0;c[n>>2]=0;o=a+28|0;c[o>>2]=0;p=a+20|0;c[p>>2]=60;c[a+32>>2]=0;c[j>>2]=60;c[h+0>>2]=c[j+0>>2];eOb(0,h);q=(c[o>>2]|0)>-1;r=d<<4>>4;c[k>>2]=r;c[l>>2]=r|-2147483648;c[a>>2]=b;if(!q){s=f<<2;t=s>>2;c[n>>2]=t;u=t|-2147483648;c[o>>2]=u;c[m>>2]=e;i=g;return}q=c[m>>2]|0;c[j>>2]=c[p>>2];c[h+0>>2]=c[j+0>>2];eOb(q,h);c[m>>2]=0;s=f<<2;t=s>>2;c[n>>2]=t;u=t|-2147483648;c[o>>2]=u;c[m>>2]=e;i=g;return}function lld(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;k=j+4|0;l=j;m=b+16|0;n=b+24|0;o=c[n>>2]|0;p=c[d>>2]|0;d=b+8|0;q=(c[d>>2]|0)+1|0;c[d>>2]=q;r=b+12|0;s=c[r>>2]|0;t=s&2147483647;if(q>>>0>t>>>0){u=s<<1;v=(u|0)==0?1:u;do if(t>>>0<v>>>0)if((s|0)>-1){c[r>>2]=v;u=c[b>>2]|0;c[l>>2]=c[b+4>>2];c[k+0>>2]=c[l+0>>2];c[b>>2]=hOb(u,v<<4,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[b+4>>2];c[k+0>>2]=c[l+0>>2];u=cOb(v<<4,4,k,0,3653512,352)|0;YEi(u|0,c[b>>2]|0,c[d>>2]<<4|0)|0;c[r>>2]=v;c[b>>2]=u;break}while(0);w=c[d>>2]|0}else w=q;q=w+-1|0;w=c[b>>2]|0;c[w+(q<<4)>>2]=p;a[w+(q<<4)+4>>0]=f;a[w+(q<<4)+5>>0]=g;a[w+(q<<4)+6>>0]=0;c[w+(q<<4)+8>>2]=h;c[w+(q<<4)+12>>2]=o;q=da(da(g&255,f&255)|0,h)|0;h=o+q|0;c[n>>2]=h;f=b+28|0;g=c[f>>2]|0;if((g&2147483647)>>>0>=h>>>0){x=c[m>>2]|0;y=x+(o<<2)|0;z=q<<2;YEi(y|0,e|0,z|0)|0;i=j;return}if((g|0)>-1){c[f>>2]=h;g=c[m>>2]|0;c[l>>2]=c[b+20>>2];c[k+0>>2]=c[l+0>>2];w=hOb(g,h<<2,4,k,0,3653512,370)|0;c[m>>2]=w;x=w;y=x+(o<<2)|0;z=q<<2;YEi(y|0,e|0,z|0)|0;i=j;return}else{c[l>>2]=c[b+20>>2];c[k+0>>2]=c[l+0>>2];l=cOb(h<<2,4,k,0,3653512,352)|0;YEi(l|0,c[m>>2]|0,c[n>>2]<<2|0)|0;c[f>>2]=h;c[m>>2]=l;x=l;y=x+(o<<2)|0;z=q<<2;YEi(y|0,e|0,z|0)|0;i=j;return}}function mld(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;lld(b,d,f,1,1,1);a[(c[b>>2]|0)+((c[b+8>>2]|0)+-1<<4)+6>>0]=e;i=g;return}function nld(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0;d=i;i=i+16|0;e=d;g[e>>2]=c;lld(a,b,e,1,1,1);i=d;return}function old(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lld(a,b,c,1,4,1);i=d;return}function pld(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im;e=i;i=i+16|0;f=e;if((KLc()|0)!=1){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];h=f;lld(a,b,h,1,4,1);i=e;return}j=ea(g[d>>2]);do if(!(j<=ea(.0404499993)))if(j<ea(1.0)){k=ea(+U(+ea(ea(j+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{k=ea(+U(+j,2.20000005));break}else k=ea(j/ea(12.9200001));while(0);j=ea(g[d+4>>2]);do if(!(j<=ea(.0404499993)))if(j<ea(1.0)){l=ea(+U(+ea(ea(j+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{l=ea(+U(+j,2.20000005));break}else l=ea(j/ea(12.9200001));while(0);j=ea(g[d+8>>2]);do if(!(j<=ea(.0404499993)))if(j<ea(1.0)){m=ea(+U(+ea(ea(j+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{m=ea(+U(+j,2.20000005));break}else m=ea(j/ea(12.9200001));while(0);j=ea(g[d+12>>2]);g[f>>2]=k;g[f+4>>2]=l;g[f+8>>2]=m;g[f+12>>2]=j;h=f;lld(a,b,h,1,4,1);i=e;return}function qld(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lld(a,b,c,4,4,1);i=d;return}function rld(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;sld(a,b,c,1,0);i=d;return}function sld(b,d,e,f,h){b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+16|0;k=j;l=c[b+8>>2]|0;a:do if(l){m=c[b>>2]|0;n=c[d>>2]|0;o=0;while(1){if((c[m+(o<<4)>>2]|0)==(n|0)){p=o;break}o=o+1|0;if(o>>>0>=l>>>0)break a}if((p|0)!=-1){if(((a[m+(p<<4)+4>>0]|0)==1?(a[m+(p<<4)+5>>0]|0)==f<<24>>24:0)?(c[m+(p<<4)+8>>2]|0)==1:0){g[(c[b+16>>2]|0)+((c[m+(p<<4)+12>>2]|0)+(h&255)<<2)>>2]=e;i=j;return}Krd(621648,0,3653512,161,1,0,0,0);i=j;return}}while(0);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[k+((h&255)<<2)>>2]=e;lld(b,d,k,1,f,1);i=j;return}function tld(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;var f=0,g=Im;f=i;do if((KLc()|0)==1){if(c<=ea(.0404499993)){g=ea(c/ea(12.9200001));break}if(c<ea(1.0)){g=ea(+U(+ea(ea(c+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{g=ea(+U(+c,2.20000005));break}}else g=c;while(0);sld(a,b,g,d,e);i=f;return}function uld(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[b+8>>2]|0;if(!f){g=0;i=e;return g|0}h=c[b>>2]|0;j=c[d>>2]|0;d=0;while(1){if(((j|0)==(c[h+(d<<4)>>2]|0)?(a[h+(d<<4)+5>>0]|0)==1:0)?(a[h+(d<<4)+4>>0]|0)==1:0){k=d;break}d=d+1|0;if((d|0)==(f|0)){g=0;l=8;break}}if((l|0)==8){i=e;return g|0}g=(c[b+16>>2]|0)+(c[h+(k<<4)+12>>2]<<2)|0;i=e;return g|0}function vld(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[b+8>>2]|0;if(!f){g=0;i=e;return g|0}h=c[b>>2]|0;j=c[d>>2]|0;d=0;while(1){if(((j|0)==(c[h+(d<<4)>>2]|0)?(a[h+(d<<4)+5>>0]|0)==4:0)?(a[h+(d<<4)+4>>0]|0)==1:0){k=d;break}d=d+1|0;if((d|0)==(f|0)){g=0;l=8;break}}if((l|0)==8){i=e;return g|0}g=(c[b+16>>2]|0)+(c[h+(k<<4)+12>>2]<<2)|0;i=e;return g|0}function wld(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im;f=i;h=c[b+8>>2]|0;if(!h){j=0;i=f;return j|0}k=c[b>>2]|0;l=c[d>>2]|0;d=0;while(1){if(((l|0)==(c[k+(d<<4)>>2]|0)?(a[k+(d<<4)+5>>0]|0)==4:0)?(a[k+(d<<4)+4>>0]|0)==1:0){m=d;break}d=d+1|0;if((d|0)==(h|0)){j=0;n=29;break}}if((n|0)==29){i=f;return j|0}n=c[k+(m<<4)+12>>2]|0;m=c[b+16>>2]|0;b=m+(n<<2)|0;if(!b){j=0;i=f;return j|0}k=(KLc()|0)==1;o=ea(g[b>>2]);do if(k){do if(!(o<=ea(0.0))){if(o<=ea(.00313080009)){p=ea(o*ea(12.9200001));break}if(!(o<=ea(1.0))){p=ea(+U(+o,.454545468));break}else{p=ea(ea(ea(+U(+o,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else p=ea(0.0);while(0);q=ea(g[m+(n+1<<2)>>2]);do if(!(q<=ea(0.0))){if(q<=ea(.00313080009)){r=ea(q*ea(12.9200001));break}if(!(q<=ea(1.0))){r=ea(+U(+q,.454545468));break}else{r=ea(ea(ea(+U(+q,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else r=ea(0.0);while(0);q=ea(g[m+(n+2<<2)>>2]);if(!(q<=ea(0.0))){if(q<=ea(.00313080009)){s=p;t=r;u=ea(q*ea(12.9200001));break}if(!(q<=ea(1.0))){s=p;t=r;u=ea(+U(+q,.454545468));break}else{s=p;t=r;u=ea(ea(ea(+U(+q,.416660011))*ea(1.05499995))+ea(-.0549999997));break}}else{s=p;t=r;u=ea(0.0)}}else{q=ea(g[m+(n+1<<2)>>2]);s=o;t=q;u=ea(g[m+(n+2<<2)>>2])}while(0);o=ea(g[m+(n+3<<2)>>2]);g[e>>2]=s;g[e+4>>2]=t;g[e+8>>2]=u;g[e+12>>2]=o;j=1;i=f;return j|0}function xld(a){a=a|0;var b=0;b=i;c[a+32>>2]=Rsd(c[a+16>>2]|0,c[a+24>>2]<<2,-1756908916)|0;i=b;return}function yld(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[j>>2]=c[d>>2];c[g+0>>2]=c[j+0>>2];gcd(b,g,e);c[b>>2]=621768;j=b+64|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;a[j+24>>0]=0;j=c[155468]|0;if(!j){c[h>>2]=c[153078];c[g+0>>2]=c[h+0>>2];c[155430]=bOb(4,g,1,16,3653512,598)|0;tvd();k=c[155468]|0}else k=j;c[b+52>>2]=k;c[b+56>>2]=0;c[b+60>>2]=0;a[b+89>>0]=0;if((e|0)==1){i=f;return}zld(b);i=f;return}function zld(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+32|0;e=d+12|0;f=d;g=b+52|0;h=c[g>>2]|0;if(!h){c[b+56>>2]=0;c[b+60>>2]=0;i=d;return}std(h);h=c[g>>2]|0;g=b+60|0;if(!(a[622168]|0)){rri(e,659104,9);j=vvd(e)|0;xri(e);c[155540]=j;a[622168]=1}j=c[h>>2]|0;e=h+4|0;h=c[e>>2]|0;a:do if((j|0)==(h|0))k=23;else{l=f+1|0;m=f+8|0;n=j;o=h;b:while(1){p=c[n>>2]|0;q=p+16|0;r=c[q>>2]|0;if((r|0)>0){s=r;r=0;while(1){t=c[(c[p>>2]|0)+(r<<2)>>2]|0;u=c[t+668>>2]|0;v=t+668|0;if(u){t=c[155540]|0;w=v;x=u;c:while(1){u=x;while(1){if((c[u+16>>2]|0)>=(t|0)){y=u;break}u=c[u+4>>2]|0;if(!u){z=w;break c}}x=c[y>>2]|0;if(!x){z=y;break}else w=y}if((z|0)!=(v|0)?(t|0)>=(c[z+16>>2]|0):0){wvd(f,c[z+20>>2]|0);w=(Gsd((a[f>>0]&1)==0?l:c[m>>2]|0,659136)|0)==0;xri(f);if(w){A=p;B=r;break b}C=c[q>>2]|0}else C=s}else C=s;r=r+1|0;if((r|0)>=(C|0))break;else s=C}D=c[e>>2]|0}else D=o;n=n+4|0;if((n|0)==(D|0)){k=23;break a}else o=D}c[g>>2]=B;E=c[(c[A>>2]|0)+(B<<2)>>2]|0}while(0);if((k|0)==23){c[g>>2]=0;E=0}c[b+56>>2]=E;i=d;return}function Ald(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;d=c[155470]|0;if(d){e=d;i=a;return e|0}rri(b,621888,27);c[155470]=nUc(mUc()|0,48,b)|0;xri(b);b=c[155470]|0;if(!b){e=0;i=a;return e|0}c[155468]=c[b+52>>2];e=b;i=a;return e|0}function Bld(){var a=0;a=i;Ald()|0;i=a;return}function Cld(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+52|0;a=c[f>>2]|0;if((a|0)==(c[155468]|0)){i=b;return}g=c[153078]|0;if(a)ntd(a);c[e>>2]=g;c[d+0>>2]=c[e+0>>2];eOb(a,d);c[f>>2]=0;i=b;return}function Dld(a){a=a|0;var b=0,d=0;b=i;d=rtd(c[a+52>>2]|0)|0;i=b;return d|0}function Eld(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=Ftd(c[(c[c[(c[c[a+52>>2]>>2]|0)+(b<<2)>>2]>>2]|0)+(d<<2)>>2]|0,e,f,g,a,d)|0;i=h;return j|0}function Fld(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[c[(c[c[b+52>>2]>>2]|0)+(d<<2)>>2]>>2]|0)+(e<<2)>>2]|0;if((c[g+640>>2]|0)==2){h=0;i=f;return h|0}h=(a[g+356>>0]|0)==0;i=f;return h|0}function Gld(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;c[e>>2]=0;g=c[(c[c[b+52>>2]>>2]|0)+(d<<2)>>2]|0;if(!(a[g+44>>0]|0)){h=0;i=f;return h|0}d=c[g+48>>2]|0;if((d|0)>-1){c[e>>2]=d;h=c[(c[g>>2]|0)+(d<<2)>>2]|0;i=f;return h|0}else{c[e>>2]=c[b+60>>2];h=c[b+56>>2]|0;i=f;return h|0}return 0}function Hld(a){a=a|0;return c[(c[a+52>>2]|0)+32>>2]|0}function Ild(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;xkd();jcd(b,d);c[b+56>>2]=0;c[b+60>>2]=0;f=a[d>>0]|0;if(!(f&1)){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}Jld(b,g,h);zld(b);i=e;return (c[b+52>>2]|0)!=(c[155468]|0)|0}function Jld(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+288|0;g=f;h=f+20|0;j=f+8|0;k=f+4|0;l=f+24|0;a[b+89>>0]=0;m=b+52|0;n=c[m>>2]|0;if((n|0)!=(c[155468]|0)){if(!(c[b+4>>2]|0))o=c[m>>2]|0;else o=n;n=c[153078]|0;if(o)ntd(o);c[h>>2]=n;c[g+0>>2]=c[h+0>>2];eOb(o,g);c[m>>2]=0}o=j+4|0;c[o>>2]=0;c[j+8>>2]=0;c[j>>2]=j+4;c[k>>2]=0;n=a[b+88>>0]|0;c[m>>2]=Svd(d,e,b+76|0,n<<24>>24!=0,k,j,c[(ync()|0)+5980>>2]|0,b)|0;n=c[k>>2]|0;e=c[153078]|0;if(n)Lwd(n);c[h>>2]=e;c[g+0>>2]=c[h+0>>2];eOb(n,g);c[k>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;k=b+64|0;n=a[653480]|0;if(!(n&1)){p=(n&255)>>>1;q=653481}else{p=c[163371]|0;q=c[163372]|0}n=a[k>>0]|0;if(!(n&1)){r=10;s=n}else{n=c[k>>2]|0;r=(n&-2)+-1|0;s=n&255}n=(s&1)==0;do if(p>>>0<=r>>>0){if(n)t=k+1|0;else t=c[b+72>>2]|0;aFi(t|0,q|0,p|0)|0;a[t+p>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=p<<1;break}else{c[b+68>>2]=p;break}}else{if(n)u=(s&255)>>>1;else u=c[b+68>>2]|0;eXb(k,r,p-r|0,u,0,u,p,q)}while(0);if(!(a[621044]|0)){q=c[m>>2]|0;if((q|0)!=0&(c[155468]|0)!=0){p=c[(c[q>>2]|0)+(c[q+32>>2]<<2)>>2]|0;if(!(a[p+42>>0]|0))v=32;else{Ird(659312,g);if(!(a[k>>0]&1))w=k+1|0;else w=c[b+72>>2]|0;c[g>>2]=w;Ird(621920,g);w=c[155468]|0;cxd(p,c[c[c[(c[w>>2]|0)+(c[w+32>>2]<<2)>>2]>>2]>>2]|0);v=32}}else x=q}else v=32;if((v|0)==32)x=c[m>>2]|0;if(!x){Ird(659312,g);if(!(a[k>>0]&1))y=k+1|0;else y=c[b+72>>2]|0;c[g>>2]=y;Ird(621968,g);c[m>>2]=c[155468];z=c[o>>2]|0;fmd(j,z);i=f;return}if((c[x>>2]|0)!=(c[x+4>>2]|0)){z=c[o>>2]|0;fmd(j,z);i=f;return}Ird(622016,g);if(!(a[k>>0]&1))A=k+1|0;else A=c[b+72>>2]|0;c[g>>2]=A;Ird(622032,g);A=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;if(!(a[A>>0]&1))B=A+1|0;else B=c[A+8>>2]|0;c[g>>2]=B;rEi(l,255,622088,g)|0;if(!b)C=0;else C=c[b+4>>2]|0;Krd(l,0,3653512,432,1,C,0,0);C=c[m>>2]|0;l=c[153078]|0;if(C)ntd(C);c[h>>2]=l;c[g+0>>2]=c[h+0>>2];eOb(C,g);c[m>>2]=0;c[m>>2]=c[155468];z=c[o>>2]|0;fmd(j,z);i=f;return}function Kld(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;e=b+40|0;f=a[e>>0]|0;if(!(f&1)){g=e+1|0;h=(f&255)>>>1}else{g=c[b+48>>2]|0;h=c[b+44>>2]|0}Jld(b,g,h);zld(b);i=d;return}function Lld(b){b=b|0;var d=0,e=0;d=i;e=b+52|0;if((c[e>>2]|0)!=(c[155468]|0)){i=d;return}c[e>>2]=0;c[b+56>>2]=0;c[b+60>>2]=0;a[b+89>>0]=1;i=d;return}function Mld(b){b=b|0;var d=0,e=0,f=0;d=i;e=mo[c[(c[b>>2]|0)+100>>2]&4095](b)|0;if(!(a[e>>0]&1)){f=e+1|0;i=d;return f|0}else{f=c[e+8>>2]|0;i=d;return f|0}return 0}function Nld(a){a=a|0;return (c[a+52>>2]|0)!=(c[155468]|0)|0}function Old(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[a+52>>2]|0;a=c[f>>2]|0;g=c[f+4>>2]|0;if((a|0)==(g|0)){h=-1;i=e;return h|0}else{j=a;k=0}while(1){a=c[j>>2]|0;f=c[a+24>>2]|0;l=a+24|0;if(f){a=l;m=f;a:while(1){f=m;while(1){if((c[f+16>>2]|0)>=(b|0)){n=f;break}f=c[f+4>>2]|0;if(!f){o=a;break a}}m=c[n>>2]|0;if(!m){o=n;break}else a=n}if(((o|0)!=(l|0)?(c[o+16>>2]|0)<=(b|0):0)?(c[o+20>>2]|0)==(d|0):0){h=k;p=11;break}}j=j+4|0;if((j|0)==(g|0)){h=-1;p=11;break}else k=k+1|0}if((p|0)==11){i=e;return h|0}return 0}function Pld(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+52>>2]|0;if(!f){g=0;i=e;return g|0}h=ptd(f,d)|0;if(!h){g=0;i=e;return g|0}d=a[h>>0]|0;if(!(d&1))j=(d&255)>>>1;else j=c[h+4>>2]|0;if(!j){g=0;i=e;return g|0}g=Ymd(h,b+76|0,(a[b+88>>0]|0)!=0)|0;i=e;return g|0}function Qld(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;if((k|0)!=(h|0))c[j>>2]=k+(~((k+-4-h|0)>>>2)<<2);BQb(48,b,0)|0;h=c[b>>2]|0;if((h|0)==(c[j>>2]|0)){xkd();i=d;return}b=h;do{h=c[b>>2]|0;if(!h)l=0;else{c[f>>2]=h;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,f);m=c[e>>2]|0;n=c[k+28>>2]|0;if((m|0)==-1){o=n+(c[k+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((o|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[o+4>>2]|0,(k|0)!=0):0)p=k;else q=14}else q=14;if((q|0)==14){q=0;p=hQb(h)|0}l=p}k=l+52|0;m=c[k>>2]|0;if((m|0)!=(c[155468]|0)){if((l|0)!=0?(c[l+4>>2]|0)==0:0)r=c[k>>2]|0;else r=m;m=c[153078]|0;if(r)ntd(r);c[g>>2]=m;c[e+0>>2]=c[g+0>>2];eOb(r,e);c[k>>2]=0;c[l+56>>2]=0;c[l+60>>2]=0;a[l+89>>0]=1}b=b+4|0}while((b|0)!=(c[j>>2]|0));xkd();i=d;return}function Rld(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+12|0;h=d;j=c[b>>2]|0;k=b+4|0;if((j|0)!=(c[k>>2]|0)){b=j;do{j=c[b>>2]|0;if(!j)l=0;else{c[f>>2]=j;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(e,m,f);n=c[e>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[p+4>>2]|0,(m|0)!=0):0)q=m;else r=12}else r=12;if((r|0)==12){r=0;q=hQb(j)|0}l=q}if((l|0)!=(c[155470]|0)){m=l+40|0;n=a[m>>0]|0;if(!(n&1)){s=m+1|0;t=(n&255)>>>1}else{s=c[l+48>>2]|0;t=c[l+44>>2]|0}Jld(l,s,t);zld(l)}b=b+4|0}while((b|0)!=(c[k>>2]|0))}c[h>>2]=0;k=h+4|0;c[k>>2]=0;c[h+8>>2]=0;BQb(21,h,0)|0;b=c[h>>2]|0;if((b|0)==(c[k>>2]|0)){u=b;v=b}else{l=b;while(1){b=c[l>>2]|0;do if(b){c[g>>2]=b;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(e,t,g);s=c[e>>2]|0;q=c[t+28>>2]|0;if((s|0)==-1){w=q+(c[t+32>>2]<<3)|0;break}else{w=q+(s<<3)|0;break}}else w=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((w|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[w+4>>2]|0,(t|0)!=0):0)x=t;else r=31}else r=31;if((r|0)==31){r=0;t=hQb(b)|0;if(!t)break;else x=t}Tjd(x)}while(0);b=l+4|0;if((b|0)==(c[k>>2]|0)){y=b;break}else l=b}u=c[h>>2]|0;v=y}if(!u){i=d;return}if((v|0)!=(u|0))c[k>>2]=v+(~((v+-4-u|0)>>>2)<<2);ACi(u);i=d;return}function Sld(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;c[b>>2]=0;d=b+4|0;c[d>>2]=0;c[b+8>>2]=0;Qld(b);Rld(b);e=c[b>>2]|0;if(!e){i=a;return}b=c[d>>2]|0;if((b|0)!=(e|0))c[d>>2]=b+(~((b+-4-e|0)>>>2)<<2);ACi(e);i=a;return}function Tld(){return 2147483647}function Uld(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if(!a)e=0;else e=c[a+4>>2]|0;c[d>>2]=e;gmd(621728,d);i=b;return}function Vld(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if(!a)e=0;else e=c[a+4>>2]|0;c[d>>2]=e;gmd(621744,d);i=b;return}function Wld(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;i=i+32|0;b=a+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;h=c[155438]|0;if(!(h|c[155434])){i=a;return}if(h){j=0;do{k=(c[155436]|0)+(j<<2)|0;l=c[k>>2]|0;do if(l){c[e>>2]=l;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(b,m,e);n=c[b>>2]|0;o=c[m+28>>2]|0;if((n|0)==-1){p=o+(c[m+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((p|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[p+4>>2]|0,(m|0)!=0):0)q=m;else r=13}else r=13;if((r|0)==13){r=0;m=hQb(c[k>>2]|0)|0;if(!m)break;else q=m}m=q+52|0;n=c[m>>2]|0;if((n|0)!=(c[155468]|0)?(vtd(n),n=c[m>>2]|0,(c[n>>2]|0)==(c[n+4>>2]|0)):0){c[g>>2]=c[q+4>>2];gmd(621728,g)}}while(0);j=j+1|0}while((j|0)!=(h|0))}if((c[155439]|0)>-1){h=c[155436]|0;c[d>>2]=c[155437];c[b+0>>2]=c[d+0>>2];eOb(h,b);c[155436]=0}c[155438]=0;c[155439]=0;h=c[155434]|0;if(h){j=0;do{g=(c[155432]|0)+(j<<2)|0;q=c[g>>2]|0;do if(q){c[d>>2]=q;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(b,p,d);e=c[b>>2]|0;k=c[p+28>>2]|0;if((e|0)==-1){s=k+(c[p+32>>2]<<3)|0;break}else{s=k+(e<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[s+4>>2]|0,(p|0)!=0):0)t=p;else r=31}else r=31;if((r|0)==31){r=0;p=hQb(c[g>>2]|0)|0;if(!p)break;else t=p}p=t+52|0;e=c[p>>2]|0;if((e|0)!=(c[155468]|0)){if(!(c[t+4>>2]|0))u=c[p>>2]|0;else u=e;e=c[153078]|0;if(u)ntd(u);c[f>>2]=e;c[b+0>>2]=c[f+0>>2];eOb(u,b);c[p>>2]=0;c[p>>2]=c[155468];c[t+56>>2]=0;c[t+60>>2]=0}}while(0);j=j+1|0}while((j|0)!=(h|0))}if((c[155435]|0)>-1){h=c[155432]|0;c[f>>2]=c[155433];c[b+0>>2]=c[f+0>>2];eOb(h,b);c[155432]=0}c[155434]=0;c[155435]=0;xkd();i=a;return}function Xld(){var a=0;a=i;QQb(48,170,0,0,0);i=a;return}function Yld(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(49)|0))ocd();rri(b,2436792,6);wQb(48,49,b,92,2718,0,0);xri(b);i=a;return}function Zld(a){a=a|0;return 48}function _ld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d;f=d+16|0;add(b,792072,2436792,a,0);wcd(a,b);add(b,622128,c[142306]|0,a+76|0,0);c[f>>2]=0;$cd(b,2646336,2646336,d+20|0,0);add(b,3142592,623064,f,0);g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,g,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);cdd(b);bdd(b);add(b,622144,c[142258]|0,a+88|0,0);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);bdd(b);i=d;return}function $ld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2436792,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else imd(a,b);sdd(b);i=d;return}function amd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;ycd(b,d);jmd(d,b+76|0,0);f=b+88|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(b,f,1);Ndd(d);i=e;return}else{a[f>>0]=a[g>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Ndd(d);i=e;return}}function bmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;zcd(b,d);kmd(d,b+76|0,0);f=b+88|0;b=d+12|0;g=c[b>>2]|0;if((g+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(b,f,1);Mdd(d);i=e;return}else{a[f>>0]=a[g>>0]|0;c[b>>2]=(c[b>>2]|0)+1;Mdd(d);i=e;return}}function cmd(a,b){a=a|0;b=b|0;var c=0;c=i;lmd(a,b);i=c;return}function dmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;Bcd(b,d);f=c[b+76>>2]|0;g=c[b+80>>2]|0;if((f|0)==(g|0)){i=e;return}b=d+12|0;h=d+28|0;j=d+32|0;d=f;do{f=c[b>>2]|0;k=xo[c[c[f>>2]>>2]&2047](f,c[d>>2]|0,c[h>>2]|0)|0;if(a[j>>0]|0)c[d>>2]=k;d=d+4|0}while((d|0)!=(g|0));i=e;return}function emd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;e=c[(c[a+52>>2]|0)+48>>2]|0;if((e|0)==1)f=1;else if((e|0)==2)f=b!=ea(0.0);else f=0;i=d;return f|0}function fmd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{fmd(a,c[b>>2]|0);fmd(a,c[b+4>>2]|0);rmd(b+16|0);ACi(b);i=d;return}}function gmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<2)|0;c[q>>2]=p;i=d;return}h=k<<1;r=(h|0)==0?1:h;do if(l>>>0<r>>>0)if((k|0)>-1){c[j>>2]=r;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(r<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<2|0)|0;c[j>>2]=r;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<2)|0;c[q>>2]=p;i=d;return}function hmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(92,e,1,16,3653512,34)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];yld(f,e,b);i=d;return f|0}function imd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;xcd(b,d);g=b+76|0;h=qdd(d,622128,c[142306]|0,f,1)|0;if(h){if((h|0)<=0){h=c[f>>2]|0;if(h)_n[h&4095](g,d)|0}else smd(d,g,0);sdd(d)}g=b+88|0;b=qdd(d,622144,c[142258]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){h=c[f>>2]|0;if(h)_n[h&4095](g,d)|0}else{h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(j+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[l>>0]|0;c[h>>2]=(c[h>>2]|0)+1;break}Bid(h,g,1)}while(0);sdd(d);i=e;return}function jmd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}tmd(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{L2b(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function kmd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;tmd(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{O2b(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function lmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=e+4|0;Acd(b,d);h=b+80|0;j=c[h>>2]|0;k=b+76|0;b=c[k>>2]|0;l=j-b>>2;c[f>>2]=l;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;if(o>>>0<(c[p>>2]|0)>>>0){c[n>>2]=l;c[m>>2]=o;q=b;r=j}else{Gid(m,f,4);q=c[k>>2]|0;r=c[h>>2]|0}if((q|0)!=(r|0)){h=q;do{R2b(h,d);h=h+4|0}while((h|0)!=(r|0))}a[g>>0]=1;r=c[m>>2]|0;if((r+1|0)>>>0<(c[p>>2]|0)>>>0){a[r>>0]=1;c[m>>2]=(c[m>>2]|0)+1;Tdd(d);i=e;return}else{Gid(m,g,1);Tdd(d);i=e;return}}function mmd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=621768;if((c[155470]|0)==(b|0))c[155470]=0;g=c[b+76>>2]|0;if(g){h=b+80|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~((j+-4-g|0)>>>2)<<2);ACi(g)}if(!(a[b+64>>0]&1)){Had(b);i=d;return}g=c[b+72>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);Had(b);i=d;return}function nmd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=621768;if((c[155470]|0)==(b|0))c[155470]=0;g=c[b+76>>2]|0;if(g){h=b+80|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~((j+-4-g|0)>>>2)<<2);ACi(g)}if(!(a[b+64>>0]&1)){Had(b);ACi(b);i=d;return}g=c[b+72>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);Had(b);ACi(b);i=d;return}function omd(a){a=a|0;return a+64|0}function pmd(){return}function qmd(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;if((c[155435]|0)>-1){e=c[155432]|0;c[d>>2]=c[155433];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[155432]=0}c[155434]=0;c[155435]=0;if((c[155439]|0)<=-1){c[155438]=0;c[155439]=0;i=a;return}e=c[155436]|0;c[d>>2]=c[155437];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[155436]=0;c[155438]=0;c[155439]=0;i=a;return}function rmd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;if(a[b+24>>0]&1){j=c[b+32>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(j,e)}if(a[b+12>>0]&1){j=c[b+20>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(j,e)}if(!(a[b>>0]&1)){i=d;return}j=c[b+8>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function smd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}tmd(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,623064,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;T2b(r,a);t=r+4|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,623064,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else T2b(m,a);sdd(a)}m=m+4|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function tmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d;l=a+4|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;p=m-o>>2;if(p>>>0>=b>>>0){if(p>>>0<=b>>>0){i=d;return}q=n+(b<<2)|0;c[k>>2]=0;r=k+4|0;c[r>>2]=0;s=k+8|0;c[s>>2]=0;t=b<<2;u=t>>2;if(u){if(u>>>0>1073741823)vxi(k);v=xCi(t)|0;c[r>>2]=v;c[k>>2]=v;w=v+(u<<2)|0;c[s>>2]=w;if(!b){x=v;y=v;z=w}else{u=t+-4|0;t=n;A=v;while(1){c[A>>2]=c[t>>2];t=t+4|0;if((t|0)==(q|0))break;else A=A+4|0}A=v+((u>>>2)+1<<2)|0;c[r>>2]=A;x=v;y=A;z=w}}else{x=0;y=0;z=0}w=c[a>>2]|0;c[k>>2]=w;c[a>>2]=x;x=c[l>>2]|0;c[r>>2]=x;c[l>>2]=y;y=a+8|0;c[s>>2]=c[y>>2];c[y>>2]=z;if(!w){i=d;return}if((x|0)!=(w|0))c[r>>2]=x+(~((x+-4-w|0)>>>2)<<2);ACi(w);i=d;return}w=a+8|0;if(((c[w>>2]|0)-o>>2|0)==(b|0)){vmd(a,b-p|0);i=d;return}c[g>>2]=0;p=g+4|0;c[p>>2]=0;o=g+8|0;c[o>>2]=0;if(b){x=xCi(b<<2)|0;c[g>>2]=x;c[p>>2]=x;c[o>>2]=x+(b<<2)}c[h>>2]=n;c[j>>2]=m;c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];umd(g,f,e);e=c[p>>2]|0;f=c[g>>2]|0;j=e-f>>2;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<2)|0,(e|0)!=(h|0)):0){m=e+(~((e+-4-h|0)>>>2)<<2)|0;c[p>>2]=m;B=f;C=m}else{B=f;C=e}else{vmd(g,b-j|0);B=c[g>>2]|0;C=c[p>>2]|0}j=c[a>>2]|0;c[g>>2]=j;c[a>>2]=B;B=c[l>>2]|0;c[p>>2]=B;c[l>>2]=C;C=c[o>>2]|0;c[o>>2]=c[w>>2];c[w>>2]=C;if(!j){i=d;return}if((B|0)!=(j|0))c[p>>2]=B+(~((B+-4-j|0)>>>2)<<2);ACi(j);i=d;return}function umd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b>>2]|0;b=c[d>>2]|0;d=f;g=b-d>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>2>>>0){if(!k)m=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>1073741823)vxi(a);j=m-0|0;if(j>>2>>>0<536870911){m=j>>1;j=m>>>0<g>>>0?g:m;if(j>>>0>1073741823)vxi(a);else o=j}else o=1073741823;j=xCi(o<<2)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(o<<2);if((f|0)==(b|0)){i=e;return}o=(b+-4-d|0)>>>2;h=f;n=j;while(1){c[n>>2]=c[h>>2];h=h+4|0;if((h|0)==(b|0))break;else n=n+4|0}c[m>>2]=j+(o+1<<2);i=e;return}o=a+4|0;a=c[o>>2]|0;j=a-l>>2;if(g>>>0>j>>>0){p=f+(j<<2)|0;q=1}else{p=b;q=0}if((f|0)==(p|0))r=k;else{j=(p+-4-d|0)>>>2;d=k;g=f;while(1){c[d>>2]=c[g>>2];g=g+4|0;if((g|0)==(p|0))break;else d=d+4|0}r=k+(j+1<<2)|0}if(!q){if((a|0)==(r|0)){i=e;return}c[o>>2]=a+(~((a+-4-r|0)>>>2)<<2);i=e;return}if((p|0)==(b|0)){i=e;return}r=(b+-4-p|0)>>>2;q=a;j=p;while(1){if(q)c[q>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else q=q+4|0}c[o>>2]=a+(r+1<<2);i=e;return}function vmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;while(1){if(l)c[l>>2]=0;k=k+-1|0;if(!k)break;else l=l+4|0}c[g>>2]=h+(b<<2);i=d;return}h=c[a>>2]|0;l=(j-h>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=h;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=c[g>>2]|0;l=f-j>>2;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=c[g>>2]|0;q=1073741823;r=f-j>>2;s=f;t=11}if((t|0)==11){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;r=b;q=s;while(1){if(q)c[q>>2]=0;r=r+-1|0;if(!r)break;else q=q+4|0}q=n+(m<<2)|0;m=n+(o+b<<2)|0;if((p|0)==(h|0)){u=s;v=h}else{b=p+-4-j|0;j=p;p=s;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(h|0))break;else p=p+-4|0}u=n+(o+~(b>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[g>>2]=m;c[e>>2]=q;if(!v){i=d;return}ACi(v);i=d;return}function wmd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153078];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,17)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[155544]=d;xmd(622184)|0;xmd(622192)|0;xmd(622208)|0;xmd(622232)|0;xmd(622240)|0;xmd(622256)|0;xmd(622272)|0;xmd(622288)|0;xmd(622304)|0;xmd(622320)|0;xmd(622336)|0;xmd(622360)|0;xmd(622376)|0;xmd(622400)|0;xmd(622416)|0;xmd(622432)|0;xmd(622448)|0;xmd(622472)|0;xmd(622496)|0;xmd(622520)|0;xmd(622544)|0;xmd(622560)|0;xmd(622568)|0;xmd(622584)|0;xmd(622600)|0;xmd(622624)|0;xmd(622640)|0;xmd(622664)|0;i=a;return}function xmd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;d=b+8|0;e=b;f=b+20|0;g=b+16|0;h=c[155544]|0;if(!h){wmd();j=c[155544]|0}else j=h;h=c[j+4>>2]|0;k=j+4|0;if(h){l=k;m=h;a:while(1){h=m;while(1){if((HEi(c[h+16>>2]|0,a)|0)>=0){n=h;break}h=c[h+4>>2]|0;if(!h){o=l;break a}}m=c[n>>2]|0;if(!m){o=n;break}else l=n}if((o|0)!=(k|0)?!((HEi(a,c[o+16>>2]|0)|0)<0|(o|0)==(k|0)):0){p=c[o+20>>2]|0;i=b;return p|0}}o=c[j+8>>2]|0;if((o|0)<=127){j=(SEi(a|0)|0)+1|0;c[g>>2]=c[153078];c[d+0>>2]=c[g+0>>2];g=cOb(j,16,d,0,3653512,108)|0;YEi(g|0,a|0,j|0)|0;j=c[155544]|0;k=e;c[k>>2]=g;c[k+4>>2]=o;Cmd(d,j,e);c[c[158074]>>2]=((o|0)/32|0)+1;p=o;i=b;return p|0}c[d>>2]=128;c[d+4>>2]=a;Lsd(f,622688,d);d=c[155544]|0;a=c[d>>2]|0;o=d+4|0;if((a|0)!=(o|0)){d=a;while(1){Fri(f,32);Eri(f,c[d+16>>2]|0)|0;a=c[d+4>>2]|0;if(!a){e=d;while(1){j=c[e+8>>2]|0;if((c[j>>2]|0)==(e|0)){q=j;break}else e=j}}else{e=a;while(1){j=c[e>>2]|0;if(!j){q=e;break}else e=j}}if((q|0)==(o|0))break;else d=q}}Ord(f,256,0);xri(f);p=127;i=b;return p|0}function ymd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;j=a[b>>0]|0;if(!(j&1))k=(j&255)>>>1;else k=c[b+4>>2]|0;j=k+16|0;if(j>>>0<2e3)if((k|0)==-1){l=0;m=0}else{k=i;i=i+((1*j|0)+15&-16)|0;l=0;m=k}else{c[h>>2]=c[153134];c[f+0>>2]=c[h+0>>2];h=cOb(j,16,f,0,3653512,150)|0;l=h;m=h}h=m+15&-16;m=b+1|0;j=b+4|0;k=b+8|0;n=0;while(1){o=a[b>>0]|0;p=(o&1)==0;if(p){q=(o&255)>>>1;r=m}else{q=c[j>>2]|0;r=c[k>>2]|0}if((q>>>0>n>>>0?(s=EEi(r+n|0,32,q-n|0)|0,(s|0)!=0):0)?(t=s-r|0,(t|0)!=-1):0){s=t-n|0;if(p){u=t;v=t;w=m;x=0;y=s}else{z=t;A=t;B=0;C=s;D=19}}else D=15;do if((D|0)==15){D=0;if(p){s=(o&255)>>>1;u=-1;v=s;w=m;x=1;y=s-n|0;break}else{s=c[j>>2]|0;z=-1;A=s;B=1;C=s-n|0;D=19;break}}while(0);if((D|0)==19){D=0;u=z;v=A;w=c[k>>2]|0;x=B;y=C}YEi(h|0,w+n|0,y|0)|0;a[h+y>>0]=0;if((v|0)!=(n|0)){o=xmd(h)|0;p=d+(o>>>5<<2)|0;c[p>>2]=c[p>>2]|1<<(o&31)}if(x)break;else n=u+1|0}if(!l){i=e;return}c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];eOb(l,f);i=e;return}function zmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;f=d+4|0;g=c[b>>2]|0;h=b+4|0;while(1){j=c[h>>2]|0;if((j|0)==(g|0))break;k=j+-12|0;c[h>>2]=k;xri(k)}g=c[c[158074]>>2]|0;if((g|0)>0){k=0;j=0;while(1){l=c[a+(j<<2)>>2]|0;m=l-(l>>>1&1431655765)|0;l=(m>>>2&858993459)+(m&858993459)|0;m=((da((l>>>4)+l&252645135,16843009)|0)>>>24)+k|0;j=j+1|0;if((j|0)==(g|0)){n=m;break}else k=m}}else n=0;Dmd(b,n);n=b+8|0;k=0;do{if(c[a+(k>>>5<<2)>>2]&1<<(k&31)){g=c[155544]|0;if(!g){wmd();o=c[155544]|0}else o=g;g=c[o>>2]|0;j=o+4|0;a:do if((g|0)==(j|0))p=3653512;else{m=g;while(1){if((c[m+20>>2]|0)==(k|0)){q=m;break}l=c[m+4>>2]|0;if(!l){r=m;while(1){s=c[r+8>>2]|0;if((c[s>>2]|0)==(r|0)){t=s;break}else r=s}}else{r=l;while(1){s=c[r>>2]|0;if(!s){t=r;break}else r=s}}if((t|0)==(j|0)){p=3653512;break a}else m=t}p=c[q+16>>2]|0}while(0);rri(f,p,SEi(p|0)|0);j=c[h>>2]|0;if((j|0)==(c[n>>2]|0))nO(b,f);else{if(!j)u=0;else{sri(j,f);u=c[h>>2]|0}c[h>>2]=u+12}xri(f)}k=k+1|0}while((k|0)<128);Emd(c[b>>2]|0,c[h>>2]|0,e);i=d;return}function Amd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e>>2]=0;f=e+4|0;c[f>>2]=0;c[e+8>>2]=0;zmd(a,e);Fmd(e,b);b=c[e>>2]|0;if(!b){i=d;return}while(1){a=c[f>>2]|0;if((a|0)==(b|0))break;g=a+-12|0;c[f>>2]=g;xri(g)}ACi(c[e>>2]|0);i=d;return}function Bmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+12|0;h=d+8|0;j=d+4|0;c[g>>2]=0;k=g+4|0;c[k>>2]=0;c[g+8>>2]=0;c[h>>2]=c[a>>2];c[j>>2]=c[a+4>>2];c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];Gmd(g,f,e);Emd(c[g>>2]|0,c[k>>2]|0,e);Fmd(g,b);b=c[g>>2]|0;if(!b){i=d;return}while(1){e=c[k>>2]|0;if((e|0)==(b|0))break;f=e+-12|0;c[k>>2]=f;xri(f)}ACi(c[g>>2]|0);i=d;return}function Cmd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=c[e>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((HEi(k,m)|0)<0){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((HEi(m,k)|0)>=0){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=d+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=0;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}g=xCi(24)|0;r=e;e=c[r+4>>2]|0;q=g+16|0;c[q>>2]=c[r>>2];c[q+4>>2]=e;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=v;c[u>>2]=g;v=c[c[d>>2]>>2]|0;if(!v)z=g;else{c[d>>2]=v;z=c[u>>2]|0}GN(c[h>>2]|0,z);z=d+8|0;c[z>>2]=(c[z>>2]|0)+1;w=1;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function Dmd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((((c[e>>2]|0)-g|0)/12|0)>>>0>=b>>>0){i=d;return}h=a+4|0;j=c[h>>2]|0;if(!b)k=0;else k=xCi(b*12|0)|0;l=k+(((j-g|0)/12|0)*12|0)|0;g=k+(b*12|0)|0;if((j|0)==(f|0)){m=l;n=f;o=f}else{b=j;j=l;while(1){k=j+-12|0;b=b+-12|0;sri(k,b);if((b|0)==(f|0)){p=k;break}else j=k}m=p;n=c[a>>2]|0;o=c[h>>2]|0}c[a>>2]=m;c[h>>2]=l;c[e>>2]=g;g=o;while(1){if((g|0)==(n|0))break;o=g+-12|0;xri(o);g=o}if(!n){i=d;return}ACi(n);i=d;return}function Emd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0;f=i;i=i+16|0;g=f;h=b;b=d;a:while(1){d=b;j=b+-12|0;k=b+-24|0;l=j+1|0;m=b+-4|0;n=b+-8|0;o=h;b:while(1){p=o;q=d-p|0;switch((q|0)/12|0|0){case 1:case 0:{r=179;break a;break}case 3:{s=o;t=j;r=19;break a;break}case 5:{u=o;v=j;r=21;break a;break}case 2:{w=o;x=j;y=l;z=m;A=n;r=4;break a;break}case 4:{B=o;C=j;r=20;break a;break}default:{}}if((q|0)<84){D=o;E=b;r=23;break a}F=(q|0)/24|0;G=o+(F*12|0)|0;if((q|0)>11988){H=(q|0)/48|0;I=Jmd(o,o+(H*12|0)|0,G,o+((H+F|0)*12|0)|0,j,e)|0}else I=Hmd(o,G,j,e)|0;H=a[o>>0]|0;q=(H&1)==0;if(q)J=(H&255)>>>1;else J=c[o+4>>2]|0;K=a[G>>0]|0;L=(K&1)==0;if(L)M=(K&255)>>>1;else M=c[o+(F*12|0)+4>>2]|0;if(q)N=o+1|0;else N=c[o+8>>2]|0;if(L)O=G+1|0;else O=c[o+(F*12|0)+8>>2]|0;P=FEi(N,O,M>>>0<J>>>0?M:J)|0;if(!P)if(J>>>0<M>>>0){Q=j;R=I}else r=42;else if((P|0)<0){Q=j;R=I}else r=42;c:do if((r|0)==42){r=0;d:do if((o|0)!=(k|0)){P=(K&255)>>>1;S=G+1|0;T=o+(F*12|0)+8|0;U=o+(F*12|0)+4|0;e:do if(L){V=k;W=b;X=j;while(1){Y=a[V>>0]|0;if(!(Y&1)){Z=(Y&255)>>>1;_=V+1|0}else{Z=c[W+-20>>2]|0;_=c[W+-16>>2]|0}Y=FEi(_,S,P>>>0<Z>>>0?P:Z)|0;if(!Y){if(Z>>>0<P>>>0){$=V;aa=V;break e}}else if((Y|0)<0){$=V;aa=V;break e}Y=X+-24|0;if((o|0)==(Y|0))break d;else{ba=V;ca=X;V=Y;X=ba;W=ca}}}else{W=k;X=b;V=j;while(1){ca=a[W>>0]|0;if(!(ca&1)){da=(ca&255)>>>1;ea=W+1|0}else{da=c[X+-20>>2]|0;ea=c[X+-16>>2]|0}ca=c[U>>2]|0;ba=FEi(ea,c[T>>2]|0,ca>>>0<da>>>0?ca:da)|0;if(!ba){if(da>>>0<ca>>>0){$=W;aa=W;break e}}else if((ba|0)<0){$=W;aa=W;break e}ba=V+-24|0;if((o|0)==(ba|0))break d;else{ca=W;Y=V;W=ba;V=ca;X=Y}}}while(0);c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[o+0>>2]=c[$+0>>2];c[o+4>>2]=c[$+4>>2];c[o+8>>2]=c[$+8>>2];c[$+0>>2]=c[g+0>>2];c[$+4>>2]=c[g+4>>2];c[$+8>>2]=c[g+8>>2];Q=aa;R=I+1|0;break c}while(0);T=o+12|0;if(q)fa=(H&255)>>>1;else fa=c[o+4>>2]|0;U=a[j>>0]|0;P=(U&1)==0;if(P)ga=(U&255)>>>1;else ga=c[n>>2]|0;if(q)ha=o+1|0;else ha=c[o+8>>2]|0;if(P)ia=l;else ia=c[m>>2]|0;P=FEi(ha,ia,ga>>>0<fa>>>0?ga:fa)|0;if(!P)if(fa>>>0<ga>>>0)ja=T;else r=65;else if((P|0)<0)ja=T;else r=65;if((r|0)==65){r=0;if((T|0)==(j|0)){r=179;break a}P=(H&255)>>>1;U=o+1|0;S=o+8|0;X=o+4|0;f:do if(q){V=o;W=T;while(1){Y=a[W>>0]|0;if(!(Y&1)){ka=(Y&255)>>>1;la=W+1|0}else{ka=c[W+4>>2]|0;la=c[W+8>>2]|0}Y=FEi(U,la,ka>>>0<P>>>0?ka:P)|0;if(!Y){if(P>>>0<ka>>>0){ma=W;na=W;break f}}else if((Y|0)<0){ma=W;na=W;break f}Y=V+24|0;if((Y|0)==(j|0)){r=179;break a}else{ca=W;W=Y;V=ca}}}else{V=o;W=T;while(1){ca=c[X>>2]|0;Y=a[W>>0]|0;if(!(Y&1)){oa=(Y&255)>>>1;pa=W+1|0}else{oa=c[W+4>>2]|0;pa=c[W+8>>2]|0}Y=FEi(c[S>>2]|0,pa,oa>>>0<ca>>>0?oa:ca)|0;if(!Y){if(ca>>>0<oa>>>0){ma=W;na=W;break f}}else if((Y|0)<0){ma=W;na=W;break f}Y=V+24|0;if((Y|0)==(j|0)){r=179;break a}else{ca=W;W=Y;V=ca}}}while(0);c[g+0>>2]=c[ma+0>>2];c[g+4>>2]=c[ma+4>>2];c[g+8>>2]=c[ma+8>>2];c[ma+0>>2]=c[j+0>>2];c[ma+4>>2]=c[j+4>>2];c[ma+8>>2]=c[j+8>>2];c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];ja=na+12|0}if((ja|0)==(j|0)){r=179;break a}S=o+1|0;X=o+8|0;T=o+4|0;P=ja;U=j;while(1){V=a[o>>0]|0;W=(V&1)==0;ca=(V&255)>>>1;V=P;while(1){if(W)qa=ca;else qa=c[T>>2]|0;Y=a[V>>0]|0;ba=(Y&1)==0;if(ba)ra=(Y&255)>>>1;else ra=c[V+4>>2]|0;if(W)sa=S;else sa=c[X>>2]|0;if(ba)ta=V+1|0;else ta=c[V+8>>2]|0;ba=FEi(sa,ta,ra>>>0<qa>>>0?ra:qa)|0;if(!ba){if(qa>>>0<ra>>>0){ua=V;va=V;break}}else if((ba|0)<0){ua=V;va=V;break}V=V+12|0}V=U;while(1){ba=V+-12|0;if(W)wa=ca;else wa=c[T>>2]|0;Y=a[ba>>0]|0;xa=(Y&1)==0;if(xa)ya=(Y&255)>>>1;else ya=c[V+-8>>2]|0;if(W)za=S;else za=c[X>>2]|0;if(xa)Aa=ba+1|0;else Aa=c[V+-4>>2]|0;xa=FEi(za,Aa,ya>>>0<wa>>>0?ya:wa)|0;if(!xa)if(wa>>>0<ya>>>0){V=ba;continue}else{Ba=ba;Ca=ba;break}else if((xa|0)<0){V=ba;continue}else{Ba=ba;Ca=ba;break}}if(va>>>0>=Ba>>>0){o=va;continue b};c[g+0>>2]=c[ua+0>>2];c[g+4>>2]=c[ua+4>>2];c[g+8>>2]=c[ua+8>>2];c[ua+0>>2]=c[Ca+0>>2];c[ua+4>>2]=c[Ca+4>>2];c[ua+8>>2]=c[Ca+8>>2];c[Ca+0>>2]=c[g+0>>2];c[Ca+4>>2]=c[g+4>>2];c[Ca+8>>2]=c[g+8>>2];P=va+12|0;U=Ba}}while(0);q=o+12|0;g:do if(q>>>0<Q>>>0){H=q;L=Q;F=G;K=R;while(1){U=a[F>>0]|0;P=(U&1)==0;X=(U&255)>>>1;U=F+1|0;S=F+8|0;T=F+4|0;V=H;while(1){W=a[V>>0]|0;ca=(W&1)==0;if(ca)Da=(W&255)>>>1;else Da=c[V+4>>2]|0;if(P)Ea=X;else Ea=c[T>>2]|0;if(ca)Fa=V+1|0;else Fa=c[V+8>>2]|0;if(P)Ga=U;else Ga=c[S>>2]|0;ca=FEi(Fa,Ga,Ea>>>0<Da>>>0?Ea:Da)|0;if(!ca){if(Da>>>0>=Ea>>>0){Ha=V;Ia=V;break}}else if((ca|0)>=0){Ha=V;Ia=V;break}V=V+12|0}V=L;while(1){ca=V+-12|0;W=a[ca>>0]|0;ba=(W&1)==0;if(ba)Ja=(W&255)>>>1;else Ja=c[V+-8>>2]|0;if(P)Ka=X;else Ka=c[T>>2]|0;if(ba)La=ca+1|0;else La=c[V+-4>>2]|0;if(P)Ma=U;else Ma=c[S>>2]|0;ba=FEi(La,Ma,Ka>>>0<Ja>>>0?Ka:Ja)|0;if(!ba)if(Ja>>>0<Ka>>>0){Na=ca;Oa=ca;break}else{V=ca;continue}else if((ba|0)<0){Na=ca;Oa=ca;break}else{V=ca;continue}}if(Ia>>>0>Na>>>0){Pa=Ia;Qa=F;Ra=K;break g};c[g+0>>2]=c[Ha+0>>2];c[g+4>>2]=c[Ha+4>>2];c[g+8>>2]=c[Ha+8>>2];c[Ha+0>>2]=c[Oa+0>>2];c[Ha+4>>2]=c[Oa+4>>2];c[Ha+8>>2]=c[Oa+8>>2];c[Oa+0>>2]=c[g+0>>2];c[Oa+4>>2]=c[g+4>>2];c[Oa+8>>2]=c[g+8>>2];H=Ia+12|0;L=Na;F=(F|0)==(Ia|0)?Na:F;K=K+1|0}}else{Pa=q;Qa=G;Ra=R}while(0);do if((Pa|0)==(Qa|0))Sa=Ra;else{G=a[Qa>>0]|0;q=(G&1)==0;if(q)Ta=(G&255)>>>1;else Ta=c[Qa+4>>2]|0;G=a[Pa>>0]|0;K=(G&1)==0;if(K)Ua=(G&255)>>>1;else Ua=c[Pa+4>>2]|0;if(q)Va=Qa+1|0;else Va=c[Qa+8>>2]|0;if(K)Wa=Pa+1|0;else Wa=c[Pa+8>>2]|0;K=FEi(Va,Wa,Ua>>>0<Ta>>>0?Ua:Ta)|0;if(!K){if(Ta>>>0>=Ua>>>0){Sa=Ra;break}}else if((K|0)>=0){Sa=Ra;break};c[g+0>>2]=c[Pa+0>>2];c[g+4>>2]=c[Pa+4>>2];c[g+8>>2]=c[Pa+8>>2];c[Pa+0>>2]=c[Qa+0>>2];c[Pa+4>>2]=c[Qa+4>>2];c[Pa+8>>2]=c[Qa+8>>2];c[Qa+0>>2]=c[g+0>>2];c[Qa+4>>2]=c[g+4>>2];c[Qa+8>>2]=c[g+8>>2];Sa=Ra+1|0}while(0);if(!Sa){Xa=Lmd(o,Pa,e)|0;K=Pa+12|0;if(Lmd(K,b,e)|0){r=174;break}if(Xa){o=K;continue}}K=Pa;if((K-p|0)>=(d-K|0)){Ya=o;Za=Pa;r=178;break}Emd(o,Pa,e);o=Pa+12|0}if((r|0)==174){r=0;if(Xa){r=179;break}else{h=o;b=Pa;continue}}else if((r|0)==178){r=0;Emd(Za+12|0,b,e);h=Ya;b=Za;continue}}if((r|0)==4){Za=a[x>>0]|0;b=(Za&1)==0;if(b)_a=(Za&255)>>>1;else _a=c[A>>2]|0;A=a[w>>0]|0;Za=(A&1)==0;if(Za)$a=(A&255)>>>1;else $a=c[w+4>>2]|0;if(b)ab=y;else ab=c[z>>2]|0;if(Za)bb=w+1|0;else bb=c[w+8>>2]|0;Za=FEi(ab,bb,$a>>>0<_a>>>0?$a:_a)|0;if(!Za){if(_a>>>0>=$a>>>0){i=f;return}}else if((Za|0)>=0){i=f;return};c[g+0>>2]=c[w+0>>2];c[g+4>>2]=c[w+4>>2];c[g+8>>2]=c[w+8>>2];c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[x+0>>2]=c[g+0>>2];c[x+4>>2]=c[g+4>>2];c[x+8>>2]=c[g+8>>2];i=f;return}else if((r|0)==19){Hmd(s,s+12|0,t,e)|0;i=f;return}else if((r|0)==20){Imd(B,B+12|0,B+24|0,C,e)|0;i=f;return}else if((r|0)==21){Jmd(u,u+12|0,u+24|0,u+36|0,v,e)|0;i=f;return}else if((r|0)==23){Kmd(D,E,e);i=f;return}else if((r|0)==179){i=f;return}}function Fmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=b+4|0;g=c[f>>2]|0;h=c[b>>2]|0;if((g|0)==(h|0))j=0;else{k=(g-h|0)/12|0;g=0;l=0;while(1){m=a[h+(g*12|0)>>0]|0;if(!(m&1))n=(m&255)>>>1;else n=c[h+(g*12|0)+4>>2]|0;m=n+((l|0)==0?0:l+1|0)|0;g=g+1|0;if((g|0)==(k|0)){j=m;break}else l=m}}if(!(a[d>>0]&1)){a[d+1>>0]=0;a[d>>0]=0}else{a[c[d+8>>2]>>0]=0;c[d+4>>2]=0}Mmd(d,j);j=c[b>>2]|0;if((c[f>>2]|0)==(j|0)){i=e;return}l=d+4|0;k=d+1|0;g=d+8|0;n=j;j=0;do{h=a[d>>0]|0;m=h&1;if(!(m<<24>>24))o=(h&255)>>>1;else o=c[l>>2]|0;if(!o)p=n;else{q=m<<24>>24!=0;if(q){r=(c[d>>2]&-2)+-1|0;s=c[l>>2]|0}else{r=10;s=(h&255)>>>1}if((s|0)==(r|0)){TXb(d,r,1,r,r,0,0);if(!(a[d>>0]&1))t=22;else t=23}else if(q)t=23;else t=22;if((t|0)==22){t=0;a[d>>0]=(s<<1)+2;u=k;v=s+1|0}else if((t|0)==23){t=0;q=c[g>>2]|0;h=s+1|0;c[l>>2]=h;u=q;v=h}a[u+s>>0]=32;a[u+v>>0]=0;p=c[b>>2]|0}h=p+(j*12|0)|0;if(!(a[h>>0]&1))w=h+1|0;else w=c[p+(j*12|0)+8>>2]|0;HHc(d,w)|0;j=j+1|0;n=c[b>>2]|0}while((j|0)!=(((c[f>>2]|0)-n|0)/12|0|0));i=e;return}function Gmd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=f;h=c[d>>2]|0;d=c[e>>2]|0;e=(d-h|0)/12|0;j=b+8|0;k=c[j>>2]|0;l=c[b>>2]|0;m=l;if(e>>>0>((k-m|0)/12|0)>>>0){if(!l)n=k;else{k=b+4|0;while(1){o=c[k>>2]|0;if((o|0)==(l|0))break;p=o+-12|0;c[k>>2]=p;xri(p)}ACi(c[b>>2]|0);c[j>>2]=0;c[k>>2]=0;c[b>>2]=0;n=0}if(e>>>0>357913941)vxi(b);k=(n-0|0)/12|0;if(k>>>0<178956970){n=k<<1;k=n>>>0<e>>>0?e:n;if(k>>>0>357913941)vxi(b);else q=k}else q=357913941;k=xCi(q*12|0)|0;n=b+4|0;c[n>>2]=k;c[b>>2]=k;c[j>>2]=k+(q*12|0);if((h|0)==(d|0)){i=f;return}else{r=h;s=k}do{k=a[r>>0]|0;if(!(k&1)){t=r+1|0;u=(k&255)>>>1}else{t=c[r+8>>2]|0;u=c[r+4>>2]|0}rri(s,t,u);s=(c[n>>2]|0)+12|0;c[n>>2]=s;r=r+12|0}while((r|0)!=(d|0));i=f;return}r=b+4|0;b=((c[r>>2]|0)-m|0)/12|0;if(e>>>0>b>>>0){v=h+(b*12|0)|0;w=1}else{v=d;w=0}if((h|0)==(v|0))x=l;else{b=l;l=h;while(1){h=a[l>>0]|0;if(!(h&1)){y=l+1|0;z=(h&255)>>>1}else{y=c[l+8>>2]|0;z=c[l+4>>2]|0}rri(g,y,z);yri(b,g)|0;xri(g);l=l+12|0;h=b+12|0;if((l|0)==(v|0)){x=h;break}else b=h}}if(!w){while(1){w=c[r>>2]|0;if((w|0)==(x|0))break;b=w+-12|0;c[r>>2]=b;xri(b)}i=f;return}if((v|0)==(d|0)){i=f;return}x=c[r>>2]|0;b=v;do{if(!x)A=0;else{v=a[b>>0]|0;if(!(v&1)){B=b+1|0;C=(v&255)>>>1}else{B=c[b+8>>2]|0;C=c[b+4>>2]|0}rri(x,B,C);A=c[r>>2]|0}x=A+12|0;c[r>>2]=x;b=b+12|0}while((b|0)!=(d|0));i=f;return}function Hmd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+16|0;g=f;h=a[d>>0]|0;j=(h&1)==0;if(j)k=(h&255)>>>1;else k=c[d+4>>2]|0;l=a[b>>0]|0;m=(l&1)==0;if(m)n=(l&255)>>>1;else n=c[b+4>>2]|0;if(j)o=d+1|0;else o=c[d+8>>2]|0;if(m)p=b+1|0;else p=c[b+8>>2]|0;m=n>>>0<k>>>0;l=FEi(o,p,m?n:k)|0;if(!l)q=k>>>0<n>>>0?-1:m&1;else q=l;l=a[e>>0]|0;m=(l&1)==0;if(m)r=(l&255)>>>1;else r=c[e+4>>2]|0;if(j)s=(h&255)>>>1;else s=c[d+4>>2]|0;if(m)t=e+1|0;else t=c[e+8>>2]|0;if(j)u=d+1|0;else u=c[d+8>>2]|0;j=s>>>0<r>>>0;m=FEi(t,u,j?s:r)|0;if(!m)v=r>>>0<s>>>0?-1:j&1;else v=m;m=(v|0)<0;if((q|0)>=0){if(!m){w=0;i=f;return w|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];q=a[d>>0]|0;v=(q&1)==0;if(v)x=(q&255)>>>1;else x=c[d+4>>2]|0;q=a[b>>0]|0;j=(q&1)==0;if(j)y=(q&255)>>>1;else y=c[b+4>>2]|0;if(v)z=d+1|0;else z=c[d+8>>2]|0;if(j)A=b+1|0;else A=c[b+8>>2]|0;j=FEi(z,A,y>>>0<x>>>0?y:x)|0;if(!j){if(x>>>0>=y>>>0){w=1;i=f;return w|0}}else if((j|0)>=0){w=1;i=f;return w|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];w=2;i=f;return w|0}if(m){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];w=1;i=f;return w|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];b=a[e>>0]|0;m=(b&1)==0;if(m)B=(b&255)>>>1;else B=c[e+4>>2]|0;b=a[d>>0]|0;j=(b&1)==0;if(j)C=(b&255)>>>1;else C=c[d+4>>2]|0;if(m)D=e+1|0;else D=c[e+8>>2]|0;if(j)E=d+1|0;else E=c[d+8>>2]|0;j=FEi(D,E,C>>>0<B>>>0?C:B)|0;if(!j){if(B>>>0>=C>>>0){w=1;i=f;return w|0}}else if((j|0)>=0){w=1;i=f;return w|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];w=2;i=f;return w|0}function Imd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+16|0;j=h;k=Hmd(b,d,e,g)|0;g=a[f>>0]|0;l=(g&1)==0;if(l)m=(g&255)>>>1;else m=c[f+4>>2]|0;g=a[e>>0]|0;n=(g&1)==0;if(n)o=(g&255)>>>1;else o=c[e+4>>2]|0;if(l)p=f+1|0;else p=c[f+8>>2]|0;if(n)q=e+1|0;else q=c[e+8>>2]|0;n=FEi(p,q,o>>>0<m>>>0?o:m)|0;if(!n){if(m>>>0>=o>>>0){r=k;i=h;return r|0}}else if((n|0)>=0){r=k;i=h;return r|0};c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];f=k+1|0;n=a[e>>0]|0;o=(n&1)==0;if(o)s=(n&255)>>>1;else s=c[e+4>>2]|0;n=a[d>>0]|0;m=(n&1)==0;if(m)t=(n&255)>>>1;else t=c[d+4>>2]|0;if(o)u=e+1|0;else u=c[e+8>>2]|0;if(m)v=d+1|0;else v=c[d+8>>2]|0;m=FEi(u,v,t>>>0<s>>>0?t:s)|0;if(!m){if(s>>>0>=t>>>0){r=f;i=h;return r|0}}else if((m|0)>=0){r=f;i=h;return r|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];e=k+2|0;f=a[d>>0]|0;m=(f&1)==0;if(m)w=(f&255)>>>1;else w=c[d+4>>2]|0;f=a[b>>0]|0;t=(f&1)==0;if(t)x=(f&255)>>>1;else x=c[b+4>>2]|0;if(m)y=d+1|0;else y=c[d+8>>2]|0;if(t)z=b+1|0;else z=c[b+8>>2]|0;t=FEi(y,z,x>>>0<w>>>0?x:w)|0;if(!t){if(w>>>0>=x>>>0){r=e;i=h;return r|0}}else if((t|0)>=0){r=e;i=h;return r|0};c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];r=k+3|0;i=h;return r|0}function Jmd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+16|0;k=j;l=Imd(b,d,e,f,h)|0;h=a[g>>0]|0;m=(h&1)==0;if(m)n=(h&255)>>>1;else n=c[g+4>>2]|0;h=a[f>>0]|0;o=(h&1)==0;if(o)p=(h&255)>>>1;else p=c[f+4>>2]|0;if(m)q=g+1|0;else q=c[g+8>>2]|0;if(o)r=f+1|0;else r=c[f+8>>2]|0;o=FEi(q,r,p>>>0<n>>>0?p:n)|0;if(!o){if(n>>>0>=p>>>0){s=l;i=j;return s|0}}else if((o|0)>=0){s=l;i=j;return s|0};c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];g=l+1|0;o=a[f>>0]|0;p=(o&1)==0;if(p)t=(o&255)>>>1;else t=c[f+4>>2]|0;o=a[e>>0]|0;n=(o&1)==0;if(n)u=(o&255)>>>1;else u=c[e+4>>2]|0;if(p)v=f+1|0;else v=c[f+8>>2]|0;if(n)w=e+1|0;else w=c[e+8>>2]|0;n=FEi(v,w,u>>>0<t>>>0?u:t)|0;if(!n){if(t>>>0>=u>>>0){s=g;i=j;return s|0}}else if((n|0)>=0){s=g;i=j;return s|0};c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];f=l+2|0;g=a[e>>0]|0;n=(g&1)==0;if(n)x=(g&255)>>>1;else x=c[e+4>>2]|0;g=a[d>>0]|0;u=(g&1)==0;if(u)y=(g&255)>>>1;else y=c[d+4>>2]|0;if(n)z=e+1|0;else z=c[e+8>>2]|0;if(u)A=d+1|0;else A=c[d+8>>2]|0;u=FEi(z,A,y>>>0<x>>>0?y:x)|0;if(!u){if(x>>>0>=y>>>0){s=f;i=j;return s|0}}else if((u|0)>=0){s=f;i=j;return s|0};c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];e=l+3|0;f=a[d>>0]|0;u=(f&1)==0;if(u)B=(f&255)>>>1;else B=c[d+4>>2]|0;f=a[b>>0]|0;y=(f&1)==0;if(y)C=(f&255)>>>1;else C=c[b+4>>2]|0;if(u)D=d+1|0;else D=c[d+8>>2]|0;if(y)E=b+1|0;else E=c[b+8>>2]|0;y=FEi(D,E,C>>>0<B>>>0?C:B)|0;do if(!y){if(B>>>0<C>>>0)break;else s=e;i=j;return s|0}else{if((y|0)<0)break;else s=e;i=j;return s|0}while(0);c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];s=l+4|0;i=j;return s|0}function Kmd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f;h=b+24|0;Hmd(b,b+12|0,h,e)|0;e=b+36|0;if((e|0)==(d|0)){i=f;return}j=g+1|0;k=g+8|0;l=g+4|0;m=e;e=h;while(1){h=a[m>>0]|0;n=(h&1)==0;if(n)o=(h&255)>>>1;else o=c[m+4>>2]|0;h=a[e>>0]|0;p=(h&1)==0;if(p)q=(h&255)>>>1;else q=c[e+4>>2]|0;if(n)r=m+1|0;else r=c[m+8>>2]|0;if(p)s=e+1|0;else s=c[e+8>>2]|0;p=FEi(r,s,q>>>0<o>>>0?q:o)|0;if(!p){if(o>>>0<q>>>0)t=18}else if((p|0)<0)t=18;if((t|0)==18){t=0;sri(g,m);p=m;n=e;while(1){yri(p,n)|0;if((n|0)==(b|0)){u=b;break}h=n+-12|0;v=a[g>>0]|0;w=(v&1)==0;if(w)x=(v&255)>>>1;else x=c[l>>2]|0;v=a[h>>0]|0;y=(v&1)==0;if(y)z=(v&255)>>>1;else z=c[n+-8>>2]|0;if(y)A=h+1|0;else A=c[n+-4>>2]|0;y=FEi(w?j:c[k>>2]|0,A,z>>>0<x>>>0?z:x)|0;if(!y)if(x>>>0<z>>>0){B=n;n=h;p=B;continue}else{u=n;break}else if((y|0)<0){B=n;n=h;p=B;continue}else{u=n;break}}yri(u,g)|0;xri(g)}n=m+12|0;if((n|0)==(d|0))break;else{p=m;m=n;e=p}}i=f;return}function Lmd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+32|0;g=f;h=f+12|0;switch((d-b|0)/12|0|0){case 2:{j=d+-12|0;k=a[j>>0]|0;l=(k&1)==0;if(l)m=(k&255)>>>1;else m=c[d+-8>>2]|0;k=a[b>>0]|0;n=(k&1)==0;if(n)o=(k&255)>>>1;else o=c[b+4>>2]|0;if(l)p=j+1|0;else p=c[d+-4>>2]|0;if(n)q=b+1|0;else q=c[b+8>>2]|0;n=FEi(p,q,o>>>0<m>>>0?o:m)|0;if(!n){if(m>>>0>=o>>>0){r=1;i=f;return r|0}}else if((n|0)>=0){r=1;i=f;return r|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];r=1;i=f;return r|0}case 5:{Jmd(b,b+12|0,b+24|0,b+36|0,d+-12|0,e)|0;r=1;i=f;return r|0}case 4:{Imd(b,b+12|0,b+24|0,d+-12|0,e)|0;r=1;i=f;return r|0}case 3:{Hmd(b,b+12|0,d+-12|0,e)|0;r=1;i=f;return r|0}case 1:case 0:{r=1;i=f;return r|0}default:{g=b+24|0;Hmd(b,b+12|0,g,e)|0;e=b+36|0;if((e|0)==(d|0)){r=1;i=f;return r|0}j=h+1|0;n=h+8|0;o=h+4|0;m=0;q=e;e=g;while(1){g=a[q>>0]|0;p=(g&1)==0;if(p)s=(g&255)>>>1;else s=c[q+4>>2]|0;g=a[e>>0]|0;l=(g&1)==0;if(l)t=(g&255)>>>1;else t=c[e+4>>2]|0;if(p)u=q+1|0;else u=c[q+8>>2]|0;if(l)v=e+1|0;else v=c[e+8>>2]|0;l=FEi(u,v,t>>>0<s>>>0?t:s)|0;if(!l)if(s>>>0<t>>>0)w=38;else x=m;else if((l|0)<0)w=38;else x=m;if((w|0)==38){w=0;sri(h,q);l=q;p=e;while(1){yri(l,p)|0;if((p|0)==(b|0)){y=b;break}g=p+-12|0;k=a[h>>0]|0;z=(k&1)==0;if(z)A=(k&255)>>>1;else A=c[o>>2]|0;k=a[g>>0]|0;B=(k&1)==0;if(B)C=(k&255)>>>1;else C=c[p+-8>>2]|0;if(B)D=g+1|0;else D=c[p+-4>>2]|0;B=FEi(z?j:c[n>>2]|0,D,C>>>0<A>>>0?C:A)|0;if(!B)if(A>>>0<C>>>0){E=p;p=g;l=E;continue}else{y=p;break}else if((B|0)<0){E=p;p=g;l=E;continue}else{y=p;break}}yri(y,h)|0;p=m+1|0;if((p|0)==8){F=q;break}xri(h);x=p}p=q+12|0;if((p|0)==(d|0)){r=1;w=56;break}else{l=q;m=x;q=p;e=l}}if((w|0)==56){i=f;return r|0}xri(h);r=(F+12|0)==(d|0);i=f;return r|0}}return 0}function Mmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;if(d>>>0>2147483631)ori(b);j=a[b>>0]|0;if(!(j&1)){k=j;l=10}else{j=c[b>>2]|0;k=j&255;l=(j&-2)+-1|0}if(!(k&1))m=(k&255)>>>1;else m=c[b+4>>2]|0;j=m>>>0>d>>>0?m:d;if(j>>>0<11)n=10;else n=(j+16&-16)+-1|0;if((n|0)==(l|0)){i=e;return}do if((n|0)!=10){j=n+1|0;if(n>>>0>l>>>0){c[g>>2]=58;c[f+0>>2]=c[g+0>>2];o=cOb(j,16,f,0,3653512,80)|0}else{c[g>>2]=58;c[f+0>>2]=c[g+0>>2];o=cOb(j,16,f,0,3653512,80)|0}j=a[b>>0]|0;if(!(j&1)){p=j;q=o;r=1;s=b+1|0;t=0;break}else{p=j;q=o;r=1;s=c[b+8>>2]|0;t=1;break}}else{p=k;q=b+1|0;r=0;s=c[b+8>>2]|0;t=1}while(0);if(!(p&1))u=(p&255)>>>1;else u=c[b+4>>2]|0;YEi(q|0,s|0,u+1|0)|0;if(t){c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(s,f)}if(r){c[b>>2]=n+1|1;c[b+4>>2]=m;c[b+8>>2]=q;i=e;return}else{a[b>>0]=m<<1;i=e;return}}function Nmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;g=b+28|0;b=Zmd(g,d)|0;if(b){h=b;i=e;return h|0}b=(a[d>>0]&1)==0?d+1|0:c[d+8>>2]|0;d=0;while(1){j=d<<1;d=d+1|0;if(!(HEi(c[623080+(j<<2)>>2]|0,b)|0)){k=j;break}if((d|0)>=77){h=0;l=6;break}}if((l|0)==6){i=e;return h|0}l=c[623080+((k|1)<<2)>>2]|0;rri(f,l,SEi(l|0)|0);l=Zmd(g,f)|0;xri(f);h=l;i=e;return h|0}function Omd(){var a=0;a=i;QQb(94,171,0,0,0);i=a;return}function Pmd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,622976,12);wQb(94,6,b,56,2719,0,0);xri(b);i=a;return}function Qmd(a){a=a|0;return 94}function Rmd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,622976,a,0);$md(a,b);bdd(b);i=c;return}function Smd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,622976,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else and(a,b);sdd(b);i=d;return}function Tmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;MSb(b,d);f=b+24|0;if(!((c[d>>2]&33554432|0)!=0&(a[f>>0]|0)==0)){g=b+28|0;bnd(d,g,0);cnd(g)}g=d+12|0;b=c[g>>2]|0;if((b+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(g,f,1);i=e;return}else{a[f>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}}function Umd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;NSb(b,d);f=b+24|0;if(!((c[d>>2]&33554432|0)!=0&(a[f>>0]|0)==0)){g=b+28|0;dnd(d,g,0);cnd(g)}g=d+12|0;b=c[g>>2]|0;if((b+1|0)>>>0>(c[d+20>>2]|0)>>>0){Bid(g,f,1);i=e;return}else{a[f>>0]=a[b>>0]|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}}function Vmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;OSb(b,d);g=b+24|0;if(!((c[d>>2]&33554432|0)!=0&(a[g>>0]|0)==0)){h=c[b+36>>2]|0;c[f>>2]=h;j=d+12|0;k=c[j>>2]|0;l=k+4|0;m=d+20|0;if(l>>>0<(c[m>>2]|0)>>>0){c[k>>2]=h;c[j>>2]=l}else Gid(j,f,4);f=b+32|0;l=c[b+28>>2]|0;if((l|0)==(f|0)){n=j;o=m;p=j}else{b=c[142282]|0;h=l;while(1){R2b(h+16|0,d);FXb(d,h+20|0,b,0);l=c[h+4>>2]|0;if(!l){k=h;while(1){q=c[k+8>>2]|0;if((c[q>>2]|0)==(k|0)){r=q;break}else k=q}}else{k=l;while(1){q=c[k>>2]|0;if(!q){r=k;break}else k=q}}if((r|0)==(f|0)){n=j;o=m;p=j;break}else h=r}}}else{r=d+12|0;n=r;o=d+20|0;p=r}r=c[n>>2]|0;if((r+1|0)>>>0<(c[o>>2]|0)>>>0){a[r>>0]=a[g>>0]|0;c[n>>2]=(c[n>>2]|0)+1;i=e;return}else{Gid(p,g,1);i=e;return}}function Wmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;PSb(b,d);if((c[d>>2]&33554432|0)!=0?(a[b+24>>0]|0)==0:0){i=e;return}f=c[b+28>>2]|0;g=b+32|0;if((f|0)==(g|0)){i=e;return}b=d+12|0;h=d+28|0;j=d+32|0;d=f;while(1){f=d+16|0;k=c[b>>2]|0;l=xo[c[c[k>>2]>>2]&2047](k,c[f>>2]|0,c[h>>2]|0)|0;if(a[j>>0]|0)c[f>>2]=l;l=c[d+4>>2]|0;if(!l){f=d;while(1){k=c[f+8>>2]|0;if((c[k>>2]|0)==(f|0)){m=k;break}else f=k}}else{f=l;while(1){k=c[f>>2]|0;if(!k){m=f;break}else f=k}}if((m|0)==(g|0))break;else d=m}i=e;return}function Xmd(){var a=0,b=0;a=i;b=rVb(4)|0;i=a;return b|0}function Ymd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+64|0;g=f+48|0;h=f+40|0;j=f+28|0;k=f+16|0;l=f+4|0;m=f;sri(j,653480);a:do if(e){n=d+4|0;o=c[d>>2]|0;if((c[n>>2]|0)==(o|0))p=0;else{q=k+1|0;r=b+1|0;s=b+8|0;t=k+8|0;u=l+1|0;v=l+8|0;w=b+4|0;x=k+4|0;y=o;o=0;z=0;while(1){A=y+(o<<2)|0;B=c[A>>2]|0;do if(B){c[h>>2]=B;C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(g,C,h);D=c[g>>2]|0;E=c[C+28>>2]|0;if((D|0)==-1){F=E+(c[C+32>>2]<<3)|0;break}else{F=E+(D<<3)|0;break}}else F=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((F|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[F+4>>2]|0,(C|0)!=0):0)G=C;else H=13}else H=13;if((H|0)==13){H=0;C=hQb(c[A>>2]|0)|0;if(!C){I=z;break}else G=C}end(G);C=mo[c[(c[G>>2]|0)+100>>2]&4095](G)|0;D=a[C>>0]|0;if(!(D&1)){J=C+1|0;K=(D&255)>>>1}else{J=c[C+8>>2]|0;K=c[C+4>>2]|0}rri(k,J,K);C=a[k>>0]|0;D=(C&1)==0;if(D)L=(C&255)>>>1;else L=c[x>>2]|0;C=a[b>>0]|0;E=(C&1)==0;if(E)M=(C&255)>>>1;else M=c[w>>2]|0;b:do if((L|0)==(M|0)){C=D?q:c[t>>2]|0;N=E?r:c[s>>2]|0;if(!D)if(!(FEi(C,N,L)|0)){O=4;P=G;break}else{H=29;break}if(!L){O=4;P=G}else{Q=L;R=C;C=N;while(1){if((a[R>>0]|0)!=(a[C>>0]|0)){H=29;break b}Q=Q+-1|0;if(!Q){O=4;P=G;break}else{R=R+1|0;C=C+1|0}}}}else H=29;while(0);do if((H|0)==29){H=0;D=E?r:c[s>>2]|0;rri(l,D,SEi(D|0)|0);D=(a[l>>0]&1)==0?u:c[v>>2]|0;C=0;while(1){R=C<<1;C=C+1|0;if(!(HEi(c[623080+(R<<2)>>2]|0,D)|0)){S=R;H=32;break}if((C|0)>=77){T=0;break}}if((H|0)==32){H=0;T=c[623080+((S|1)<<2)>>2]|0}xri(l);if((T|0)!=0?(HEi((a[k>>0]&1)==0?q:c[t>>2]|0,T)|0)==0:0){O=4;P=G;break}O=0;P=z}while(0);xri(k);if((O|0)==4){p=P;break a}else I=P}else I=z;while(0);o=o+1|0;y=c[d>>2]|0;if(o>>>0>=(c[n>>2]|0)-y>>2>>>0){p=I;break}else z=I}}}else p=Nmd(rVb(4)|0,b)|0;while(0);yri(653480,j)|0;if(!p){U=0;xri(j);i=f;return U|0}end(p);if(e){U=p;xri(j);i=f;return U|0}e=c[p+4>>2]|0;c[m>>2]=e;b=c[d>>2]|0;I=d+4|0;P=c[I>>2]|0;c:do if((b|0)!=(P|0)){O=b;while(1){if((c[O>>2]|0)==(e|0)){V=O;break}O=O+4|0;if((O|0)==(P|0)){W=P;break c}}if((V|0)==(P|0))W=P;else{U=p;xri(j);i=f;return U|0}}else W=b;while(0);if((W|0)==(c[d+8>>2]|0)){fnd(d,m);U=p;xri(j);i=f;return U|0}if(W)c[W>>2]=e;c[I>>2]=W+4;U=p;xri(j);i=f;return U|0}function Zmd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+12|0;j=e;k=a[d>>0]|0;if(!(k&1)){l=(k&255)>>>1;m=d+1|0}else{l=c[d+4>>2]|0;m=c[d+8>>2]|0}if(l>>>0>2147483631)ori(j);if(l>>>0<11){a[j>>0]=l<<1;n=j;o=j+1|0}else{d=l+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];k=cOb(d,16,f,0,3653512,80)|0;c[j+8>>2]=k;c[j>>2]=d|1;c[j+4>>2]=l;n=j;o=k}YEi(o|0,m|0,l|0)|0;a[o+l>>0]=0;lnd(f,b+12|0,j);b=c[f>>2]|0;l=c[f+4>>2]|0;if(a[n>>0]&1){n=c[j+8>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(n,f)}if((b|0)==(l|0)){p=0;i=e;return p|0}n=b;b=0;a:while(1){g=(b|0)==0;j=n;b:while(1){o=c[j+4>>2]|0;if(!o){m=j;while(1){k=c[m+8>>2]|0;if((c[k>>2]|0)==(m|0)){q=k;break}else m=k}}else{m=o;while(1){k=c[m>>2]|0;if(!k){q=m;break}else m=k}}m=j+28|0;o=c[m>>2]|0;do if(o){c[h>>2]=o;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(f,k,h);d=c[f>>2]|0;r=c[k+28>>2]|0;if((d|0)==-1){s=r+(c[k+32>>2]<<3)|0;break}else{s=r+(d<<3)|0;break}}else s=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((s|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[s+4>>2]|0,(k|0)!=0):0)t=k;else u=26}else u=26;if((u|0)==26){u=0;k=hQb(c[m>>2]|0)|0;if(!k)break;else t=k}if(g){v=q;w=t;break b}if((c[t+8>>2]&999424|0)!=999424){v=q;w=t;break b}}while(0);if((q|0)==(l|0)){p=b;u=32;break a}else j=q}if((v|0)==(l|0)){p=w;u=32;break}else{n=v;b=w}}if((u|0)==32){i=e;return p|0}return 0}function _md(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;c[h>>2]=j;c[f+0>>2]=c[h+0>>2];h=bOb(56,f,1,16,3653512,19)|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];jSb(h,f,d);c[h>>2]=622872;d=h+32|0;c[d>>2]=0;c[h+36>>2]=0;c[h+28>>2]=d;d=h+44|0;c[d>>2]=0;c[h+48>>2]=0;c[h+40>>2]=d;c[h+52>>2]=h;a[h+24>>0]=0;i=e;return h|0}function $md(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;KSb(b,d);f=b+24|0;if(!((c[d>>2]&33554432|0)!=0?(a[f>>0]|0)==0:0)){g=b+28|0;add(d,622992,623048,g,0);add(d,623032,c[142272]|0,g,0);mnd(d,g,0);bdd(d);bdd(d)}add(d,623008,c[142258]|0,f,0);c[(c[c[d+12>>2]>>2]|0)+((c[d+20>>2]|0)*24|0)+12>>2]=1;bdd(d);i=e;return}function and(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;LSb(b,d);if(!((c[d>>2]&33554432|0)!=0?(a[b+24>>0]|0)==0:0))h=3;if((h|0)==3?(h=b+28|0,j=qdd(d,622992,623048,g,1)|0,(j|0)!=0):0){if((j|0)<=0){j=c[g>>2]|0;if(j)_n[j&4095](h,d)|0}else{j=qdd(d,623032,c[142272]|0,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else nnd(d,h,0);sdd(d)}cnd(h)}sdd(d)}h=b+24|0;b=qdd(d,623008,c[142258]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else{j=d+12|0;g=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=g+k|0;c[j>>2]=l;if((k|0)>=0?(g+(k+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,h,1)}while(0);sdd(d);i=e;return}function bnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+80|0;f=e+64|0;g=e+28|0;h=e+16|0;j=e+20|0;k=e+72|0;l=e;m=e+24|0;n=e+48|0;o=e+32|0;p=b+12|0;q=c[p>>2]|0;r=q+4|0;if(r>>>0>(c[b+20>>2]|0)>>>0)Bid(p,m,4);else{c[m>>2]=c[q>>2];c[p>>2]=r};c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;ond(d,c[d+4>>2]|0);c[d+8>>2]=0;r=d+4|0;c[d>>2]=r;c[r>>2]=0;a:do if((c[m>>2]|0)>0){r=n+4|0;p=o+4|0;q=r+1|0;s=p+1|0;t=l+4|0;u=t+1|0;v=l+4|0;w=o+4|0;x=o+12|0;y=l+12|0;z=l+8|0;A=o+8|0;B=n+12|0;C=n+8|0;D=0;while(1){L2b(n,b);NXb(b,r,1);Ndd(b);c[o>>2]=c[n>>2];E=a[r>>0]|0;if(!(E&1)){F=(E&255)>>>1;G=q}else{F=c[C>>2]|0;G=c[B>>2]|0}if(F>>>0>2147483631){H=10;break}if(F>>>0<11){a[p>>0]=F<<1;I=s}else{E=F+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];J=cOb(E,16,f,0,3653512,80)|0;c[x>>2]=J;c[p>>2]=E|1;c[A>>2]=F;I=J}YEi(I|0,G|0,F|0)|0;a[I+F>>0]=0;c[l>>2]=c[o>>2];J=a[p>>0]|0;if(!(J&1)){K=(J&255)>>>1;L=s}else{K=c[A>>2]|0;L=c[x>>2]|0}if(K>>>0>2147483631){H=18;break}if(K>>>0<11){a[t>>0]=K<<1;M=u}else{J=K+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];E=cOb(J,16,f,0,3653512,80)|0;c[y>>2]=E;c[t>>2]=J|1;c[z>>2]=K;M=E}YEi(M|0,L|0,K|0)|0;a[M+K>>0]=0;ind(k,d,l);if(a[v>>0]&1){E=c[y>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(E,f)}if(a[w>>0]&1){E=c[x>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(E,f)}D=D+1|0;if((D|0)>=(c[m>>2]|0))break a}if((H|0)==10)ori(p);else if((H|0)==18)ori(t)}while(0);if(!(a[n+4>>0]&1)){i=e;return}H=c[n+12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(H,f);i=e;return}function cnd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=i;i=i+112|0;e=d;f=d+40|0;g=d+80|0;h=d+4|0;j=d+84|0;k=d+88|0;l=d+24|0;m=d+64|0;n=d+48|0;o=d+8|0;p=b+12|0;q=b+16|0;pnd(p,c[q>>2]|0);r=b+20|0;c[r>>2]=0;s=b+16|0;c[p>>2]=s;c[s>>2]=0;s=c[b>>2]|0;t=b+4|0;if((s|0)==(t|0)){i=d;return}b=o+1|0;u=n+1|0;v=n+12|0;w=m+1|0;x=m+12|0;y=l+1|0;z=l+12|0;A=o+8|0;B=n+8|0;C=m+8|0;D=l+8|0;E=l+4|0;F=m+4|0;G=n+4|0;H=o+4|0;I=s;while(1){s=I+20|0;J=a[s>>0]|0;if(!(J&1)){K=(J&255)>>>1;L=s+1|0}else{K=c[I+24>>2]|0;L=c[I+28>>2]|0}if(K>>>0>2147483631){M=7;break}if(K>>>0<11){a[o>>0]=K<<1;N=b}else{s=K+16&-16;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];J=cOb(s,16,e,0,3653512,80)|0;c[A>>2]=J;c[o>>2]=s|1;c[H>>2]=K;N=J}YEi(N|0,L|0,K|0)|0;a[N+K>>0]=0;J=c[I+16>>2]|0;s=a[o>>0]|0;if(!(s&1)){O=(s&255)>>>1;P=b}else{O=c[H>>2]|0;P=c[A>>2]|0}if(O>>>0>2147483631){M=15;break}if(O>>>0<11){a[n>>0]=O<<1;Q=u}else{s=O+16&-16;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];R=cOb(s,16,e,0,3653512,80)|0;c[B>>2]=R;c[n>>2]=s|1;c[G>>2]=O;Q=R}YEi(Q|0,P|0,O|0)|0;a[Q+O>>0]=0;c[v>>2]=J;J=a[n>>0]|0;if(!(J&1)){S=(J&255)>>>1;T=u}else{S=c[G>>2]|0;T=c[B>>2]|0}if(S>>>0>2147483631){M=23;break}if(S>>>0<11){a[m>>0]=S<<1;U=w}else{J=S+16&-16;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];R=cOb(J,16,e,0,3653512,80)|0;c[C>>2]=R;c[m>>2]=J|1;c[F>>2]=S;U=R}YEi(U|0,T|0,S|0)|0;a[U+S>>0]=0;c[x>>2]=c[v>>2];R=a[m>>0]|0;if(!(R&1)){V=(R&255)>>>1;W=w}else{V=c[F>>2]|0;W=c[C>>2]|0}if(V>>>0>2147483631){M=31;break}if(V>>>0<11){a[l>>0]=V<<1;X=y}else{R=V+16&-16;c[k>>2]=58;c[e+0>>2]=c[k+0>>2];J=cOb(R,16,e,0,3653512,80)|0;c[D>>2]=J;c[l>>2]=R|1;c[E>>2]=V;X=J}YEi(X|0,W|0,V|0)|0;a[X+V>>0]=0;c[z>>2]=c[x>>2];J=jnd(p,e,l)|0;knd(k,p,l);R=c[k>>2]|0;c[k>>2]=0;s=c[e>>2]|0;c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=s;c[J>>2]=R;s=c[c[p>>2]>>2]|0;if(!s)Y=R;else{c[p>>2]=s;Y=c[J>>2]|0}GN(c[q>>2]|0,Y);c[r>>2]=(c[r>>2]|0)+1;if(a[l>>0]&1){J=c[D>>2]|0;c[j>>2]=58;c[e+0>>2]=c[j+0>>2];eOb(J,e)}if(a[m>>0]&1){J=c[C>>2]|0;c[h>>2]=58;c[e+0>>2]=c[h+0>>2];eOb(J,e)}if(a[n>>0]&1){J=c[B>>2]|0;c[g>>2]=58;c[e+0>>2]=c[g+0>>2];eOb(J,e)}if(a[o>>0]&1){J=c[A>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(J,e)}J=c[I+4>>2]|0;if(!J){s=I;while(1){R=c[s+8>>2]|0;if((c[R>>2]|0)==(s|0)){Z=R;break}else s=R}}else{s=J;while(1){R=c[s>>2]|0;if(!R){Z=s;break}else s=R}}if((Z|0)==(t|0)){M=50;break}else I=Z}if((M|0)==7)ori(o);else if((M|0)==15)ori(n);else if((M|0)==23)ori(m);else if((M|0)==31)ori(l);else if((M|0)==50){i=d;return}}function dnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+80|0;f=e+64|0;g=e+28|0;h=e+16|0;j=e+20|0;k=e+72|0;l=e;m=e+24|0;n=e+48|0;o=e+32|0;p=b+12|0;q=c[p>>2]|0;r=q+4|0;if(r>>>0>(c[b+20>>2]|0)>>>0){Bid(p,m,4);s=c[m>>2]|0}else{t=c[q>>2]|0;c[m>>2]=t;c[p>>2]=r;s=t}c[m>>2]=XEi(s|0)|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;ond(d,c[d+4>>2]|0);c[d+8>>2]=0;s=d+4|0;c[d>>2]=s;c[s>>2]=0;a:do if((c[m>>2]|0)>0){s=n+4|0;t=o+4|0;r=s+1|0;p=t+1|0;q=l+4|0;u=q+1|0;v=l+4|0;w=o+4|0;x=o+12|0;y=l+12|0;z=l+8|0;A=o+8|0;B=n+12|0;C=n+8|0;D=0;while(1){O2b(n,b);OXb(b,s,1);Mdd(b);c[o>>2]=c[n>>2];E=a[s>>0]|0;if(!(E&1)){F=(E&255)>>>1;G=r}else{F=c[C>>2]|0;G=c[B>>2]|0}if(F>>>0>2147483631){H=10;break}if(F>>>0<11){a[t>>0]=F<<1;I=p}else{E=F+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];J=cOb(E,16,f,0,3653512,80)|0;c[x>>2]=J;c[t>>2]=E|1;c[A>>2]=F;I=J}YEi(I|0,G|0,F|0)|0;a[I+F>>0]=0;c[l>>2]=c[o>>2];J=a[t>>0]|0;if(!(J&1)){K=(J&255)>>>1;L=p}else{K=c[A>>2]|0;L=c[x>>2]|0}if(K>>>0>2147483631){H=18;break}if(K>>>0<11){a[q>>0]=K<<1;M=u}else{J=K+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];E=cOb(J,16,f,0,3653512,80)|0;c[y>>2]=E;c[q>>2]=J|1;c[z>>2]=K;M=E}YEi(M|0,L|0,K|0)|0;a[M+K>>0]=0;ind(k,d,l);if(a[v>>0]&1){E=c[y>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(E,f)}if(a[w>>0]&1){E=c[x>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(E,f)}D=D+1|0;if((D|0)>=(c[m>>2]|0))break a}if((H|0)==10)ori(t);else if((H|0)==18)ori(q)}while(0);if(!(a[n+4>>0]&1)){i=e;return}H=c[n+12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(H,f);i=e;return}function end(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;if(!(a[b+89>>0]|0)){i=d;return}sri(e,653480);f=b+40|0;g=a[f>>0]|0;if(!(g&1)){h=f+1|0;j=(g&255)>>>1}else{h=c[b+48>>2]|0;j=c[b+44>>2]|0}Jld(b,h,j);zld(b);yri(653480,e)|0;xri(e);i=d;return}function fnd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=l-j>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=1073741823;r=l-j>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;r=n+(m<<2)|0;if(s)c[s>>2]=c[b>>2];b=n+(o+1<<2)|0;if((p|0)==(f|0)){u=s;v=f}else{m=p+-4-j|0;j=p;p=s;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(f|0))break;else p=p+-4|0}u=n+(o+~(m>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[e>>2]=b;c[h>>2]=r;if(!v){i=d;return}ACi(v);i=d;return}function gnd(a){a=a|0;var b=0;b=i;c[a>>2]=622872;pnd(a+40|0,c[a+44>>2]|0);ond(a+28|0,c[a+32>>2]|0);ZSb(a);i=b;return}function hnd(a){a=a|0;var b=0;b=i;c[a>>2]=622872;pnd(a+40|0,c[a+44>>2]|0);ond(a+28|0,c[a+32>>2]|0);ZSb(a);ACi(a);i=b;return}function ind(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+16|0;g=f+12|0;h=f;j=d+4|0;k=c[j>>2]|0;do if(k){l=c[e>>2]|0;m=k;while(1){n=c[m+16>>2]|0;if((l|0)<(n|0)){o=c[m>>2]|0;if(!o){p=m;q=m;r=5;break}else{m=o;continue}}if((n|0)>=(l|0)){s=m;r=9;break}n=m+4|0;o=c[n>>2]|0;if(!o){t=n;u=m;r=8;break}else m=o}if((r|0)==5){c[g>>2]=q;v=p;w=q;break}else if((r|0)==8){c[g>>2]=u;v=t;w=u;break}else if((r|0)==9){c[g>>2]=s;v=g;w=s;break}}else{m=d+4|0;c[g>>2]=m;v=m;w=m}while(0);g=c[v>>2]|0;if(g){x=0;y=g;c[b>>2]=y;z=b+4|0;a[z>>0]=x;i=f;return}qnd(h,d,e);e=c[h>>2]|0;c[h>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=w;c[v>>2]=e;w=c[c[d>>2]>>2]|0;if(!w)A=e;else{c[d>>2]=w;A=c[v>>2]|0}GN(c[j>>2]|0,A);A=d+8|0;c[A>>2]=(c[A>>2]|0)+1;x=1;y=e;c[b>>2]=y;z=b+4|0;a[z>>0]=x;i=f;return}function jnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;if(!(h&1)){h=g;while(1){e=h+16|0;n=a[e>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=e+1|0}else{o=c[h+20>>2]|0;p=c[h+24>>2]|0}e=FEi(k,p,o>>>0<b>>>0?o:b)|0;if(!e)if(b>>>0<o>>>0)q=10;else q=9;else if((e|0)<0)q=10;else q=9;if((q|0)==9){q=0;e=h+4|0;n=c[e>>2]|0;if(!n){r=e;s=h;q=20;break}else{h=n;continue}}else if((q|0)==10){q=0;n=c[h>>2]|0;if(!n){t=h;u=h;q=18;break}else{h=n;continue}}}}else{h=g;while(1){g=h+16|0;o=a[g>>0]|0;if(!(o&1)){v=(o&255)>>>1;w=g+1|0}else{v=c[h+20>>2]|0;w=c[h+24>>2]|0}g=FEi(l,w,v>>>0<m>>>0?v:m)|0;if(!g)if(m>>>0<v>>>0)q=17;else q=19;else if((g|0)<0)q=17;else q=19;if((q|0)==17){q=0;g=c[h>>2]|0;if(!g){t=h;u=h;q=18;break}else{h=g;continue}}else if((q|0)==19){q=0;g=h+4|0;o=c[g>>2]|0;if(!o){r=g;s=h;q=20;break}else{h=o;continue}}}}if((q|0)==18){c[d>>2]=u;j=t;i=f;return j|0}else if((q|0)==20){c[d>>2]=s;j=r;i=f;return j|0}return 0}function knd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+4|0;h=f;j=xCi(32)|0;k=j+16|0;l=a[e>>0]|0;if(!(l&1)){m=(l&255)>>>1;n=e+1|0}else{m=c[e+4>>2]|0;n=c[e+8>>2]|0}if(m>>>0>2147483631)ori(k);if(m>>>0<11){a[k>>0]=m<<1;o=j+17|0}else{l=m+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(l,16,g,0,3653512,80)|0;c[j+24>>2]=h;c[k>>2]=l|1;c[j+20>>2]=m;o=h}YEi(o|0,n|0,m|0)|0;a[o+m>>0]=0;c[j+28>>2]=c[e+12>>2];c[b>>2]=j;j=b+4|0;c[j>>2]=d+4;c[j+4>>2]=1;i=f;return}function lnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[d+4>>2]|0;a:do if(!j)k=h;else{l=a[e>>0]|0;m=(l&1)==0;n=(l&255)>>>1;l=e+1|0;o=e+8|0;p=c[o>>2]|0;q=e+4|0;r=c[q>>2]|0;s=h;t=j;b:while(1){u=t;while(1){v=u+16|0;w=m?n:r;x=a[v>>0]|0;y=(x&1)==0;if(y)z=(x&255)>>>1;else z=c[u+20>>2]|0;if(y)A=v+1|0;else A=c[u+24>>2]|0;B=FEi(m?l:p,A,z>>>0<w>>>0?z:w)|0;if(!B){if(w>>>0<z>>>0){C=u;D=u;break}}else if((B|0)<0){C=u;D=u;break}if(y)E=(x&255)>>>1;else E=c[u+20>>2]|0;x=m?n:r;if(y)F=v+1|0;else F=c[u+24>>2]|0;v=FEi(F,m?l:p,x>>>0<E>>>0?x:E)|0;if(!v){if(E>>>0>=x>>>0){G=s;H=u;I=u;break b}}else if((v|0)>=0){G=s;H=u;I=u;break b}u=c[u+4>>2]|0;if(!u){k=s;break a}}t=c[C>>2]|0;if(!t){k=D;break a}else s=D}rnd(g,d,e,c[H>>2]|0,I);s=c[H+4>>2]|0;c:do if(!s)J=G;else{t=a[e>>0]|0;p=(t&1)==0;m=p?(t&255)>>>1:c[q>>2]|0;t=p?l:c[o>>2]|0;p=G;r=s;while(1){n=r;while(1){u=n+16|0;v=a[u>>0]|0;if(!(v&1)){K=(v&255)>>>1;L=u+1|0}else{K=c[n+20>>2]|0;L=c[n+24>>2]|0}u=FEi(t,L,K>>>0<m>>>0?K:m)|0;if(!u){if(m>>>0<K>>>0){M=n;break}}else if((u|0)<0){M=n;break}n=c[n+4>>2]|0;if(!n){J=p;break c}}r=c[M>>2]|0;if(!r){J=M;break}else p=M}}while(0);c[b>>2]=c[g>>2];c[b+4>>2]=J;i=f;return}while(0);c[b>>2]=k;c[b+4>>2]=k;i=f;return}function mnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+32|0;f=d+24|0;g=d+20|0;h=d;$cd(b,2646336,2646336,d+16|0,e);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;add(b,3142592,c[142274]|0,h,0);snd(h,b);bdd(b);cdd(b);if(!(a[h+4>>0]&1)){i=d;return}b=c[h+12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=d;return}function nnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=i;i=i+80|0;f=e+64|0;g=e+28|0;h=e+16|0;j=e+20|0;k=e+72|0;l=e;m=e+24|0;n=e+48|0;o=e+32|0;p=d+8|0;c[m>>2]=c[p>>2];if(!(tdd(b,2646336,2646336,m)|0)){i=e;return};c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;ond(d,c[d+4>>2]|0);c[p>>2]=0;p=d+4|0;c[d>>2]=p;c[p>>2]=0;a:do if((c[m>>2]|0)>0){p=c[142274]|0;q=o+4|0;r=n+4|0;s=r+1|0;t=q+1|0;u=l+4|0;v=u+1|0;w=l+4|0;x=o+4|0;y=o+12|0;z=l+12|0;A=l+8|0;B=o+8|0;C=n+12|0;D=n+8|0;E=0;while(1){F=qdd(b,3142592,p,f,1)|0;if(F){if((F|0)<=0){F=c[f>>2]|0;if(F)_n[F&4095](n,b)|0}else tnd(n,b);sdd(b)}c[o>>2]=c[n>>2];F=a[r>>0]|0;if(!(F&1)){G=(F&255)>>>1;H=s}else{G=c[D>>2]|0;H=c[C>>2]|0}if(G>>>0>2147483631){I=14;break}if(G>>>0<11){a[q>>0]=G<<1;J=t}else{F=G+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];K=cOb(F,16,f,0,3653512,80)|0;c[y>>2]=K;c[q>>2]=F|1;c[B>>2]=G;J=K}YEi(J|0,H|0,G|0)|0;a[J+G>>0]=0;c[l>>2]=c[o>>2];K=a[q>>0]|0;if(!(K&1)){L=(K&255)>>>1;M=t}else{L=c[B>>2]|0;M=c[y>>2]|0}if(L>>>0>2147483631){I=22;break}if(L>>>0<11){a[u>>0]=L<<1;N=v}else{K=L+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];F=cOb(K,16,f,0,3653512,80)|0;c[z>>2]=F;c[u>>2]=K|1;c[A>>2]=L;N=F}YEi(N|0,M|0,L|0)|0;a[N+L>>0]=0;ind(k,d,l);if(a[w>>0]&1){F=c[z>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(F,f)}if(a[x>>0]&1){F=c[y>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(F,f)}E=E+1|0;if((E|0)>=(c[m>>2]|0))break a}if((I|0)==14)ori(q);else if((I|0)==22)ori(u)}while(0);udd(b);if(!(a[n+4>>0]&1)){i=e;return}b=c[n+12>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function ond(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!d){i=e;return}ond(b,c[d>>2]|0);ond(b,c[d+4>>2]|0);if(a[d+20>>0]&1){b=c[d+28>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f)}ACi(d);i=e;return}function pnd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!d){i=e;return}pnd(b,c[d>>2]|0);pnd(b,c[d+4>>2]|0);if(a[d+16>>0]&1){b=c[d+24>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(b,f)}ACi(d);i=e;return}function qnd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+4|0;h=f;j=xCi(32)|0;c[j+16>>2]=c[e>>2];k=j+20|0;l=e+4|0;m=a[l>>0]|0;if(!(m&1)){n=(m&255)>>>1;o=l+1|0}else{n=c[e+8>>2]|0;o=c[e+12>>2]|0}if(n>>>0>2147483631)ori(k);if(n>>>0<11){a[k>>0]=n<<1;p=j+21|0}else{e=n+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(e,16,g,0,3653512,80)|0;c[j+28>>2]=h;c[k>>2]=e|1;c[j+24>>2]=n;p=h}YEi(p|0,o|0,n|0)|0;a[p+n>>0]=0;c[b>>2]=j;j=b+4|0;c[j>>2]=d+4;c[j+4>>2]=1;i=f;return}function rnd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=a[e>>0]|0;k=(j&1)==0;l=(j&255)>>>1;j=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(k){f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=o+1|0}else{q=c[f+20>>2]|0;r=c[f+24>>2]|0}o=FEi(r,j,l>>>0<q>>>0?l:q)|0;if(!o){if(q>>>0>=l>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}else{f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){u=(p&255)>>>1;v=o+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}o=FEi(v,m,n>>>0<u>>>0?n:u)|0;if(!o){if(u>>>0>=n>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}while(0);g=c[s>>2]|0;if(!g){h=s;t=19;break}else e=s}if((t|0)==19){c[b>>2]=h;i=d;return}}function snd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d;add(b,c[142266]|0,623064,a,0);f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,a,1);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,f,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,c[142282]|0,c[142294]|0,a+4|0,0);$cd(b,2646336,2646336,e,1);add(b,3142592,c[142260]|0,d+16|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);i=d;return}function tnd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,623064,e,1)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else T2b(a,b);sdd(b)}f=a+4|0;a=qdd(b,c[142282]|0,c[142294]|0,e,0)|0;if(!a){i=d;return}if((a|0)<=0){a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}else zXb(b,f,1);sdd(b);i=d;return}function und(a){a=a|0;var b=0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;b=a;c[b>>2]=1065353216;c[b+4>>2]=1065353216;b=a+8|0;c[b>>2]=0;c[b+4>>2]=0;c[a+16>>2]=0;return}function vnd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;i=i+64|0;e=d+48|0;f=d+40|0;h=d+32|0;j=d+16|0;k=d+8|0;l=d;m=c[b+8>>2]|0;n=b+12|0;a:do if((m|0)!=(n|0)){o=c[a+16>>2]|0;p=a+16|0;if(!o){q=m;while(1){r=c[q+4>>2]|0;if(!r){s=q;while(1){t=c[s+8>>2]|0;if((c[t>>2]|0)==(s|0)){u=t;break}else s=t}}else{s=r;while(1){t=c[s>>2]|0;if(!t){u=s;break}else s=t}}if((u|0)==(n|0))break a;else q=u}}else v=m;while(1){q=c[v+16>>2]|0;s=p;r=o;b:while(1){t=r;while(1){if((c[t+16>>2]|0)>=(q|0)){w=t;break}t=c[t+4>>2]|0;if(!t){x=s;break b}}r=c[w>>2]|0;if(!r){x=w;break}else s=w}if((x|0)!=(p|0)?(q|0)>=(c[x+16>>2]|0):0)g[v+20>>2]=ea(g[x+20>>2]);s=c[v+4>>2]|0;if(!s){r=v;while(1){t=c[r+8>>2]|0;if((c[t>>2]|0)==(r|0)){y=t;break}else r=t}}else{r=s;while(1){q=c[r>>2]|0;if(!q){y=r;break}else r=q}}if((y|0)==(n|0))break;else v=y}}while(0);y=c[b+20>>2]|0;v=b+24|0;if((y|0)!=(v|0)){n=a+28|0;x=a+28|0;w=j+4|0;m=j+8|0;u=j+12|0;p=y;while(1){y=p+16|0;o=c[n>>2]|0;do if(o){r=c[y>>2]|0;s=x;q=o;c:while(1){t=q;while(1){if((c[t+16>>2]|0)>=(r|0)){z=t;break}t=c[t+4>>2]|0;if(!t){A=s;break c}}q=c[z>>2]|0;if(!q){A=z;break}else s=z}if((A|0)!=(x|0)?(r|0)>=(c[A+16>>2]|0):0){s=A+20|0;if(!(yud(b,y)|0)){oud(b,y,s);break}if((KLc()|0)==1){B=ea(g[s>>2]);do if(!(B<=ea(.0404499993)))if(B<ea(1.0)){C=ea(+U(+ea(ea(B+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{C=ea(+U(+B,2.20000005));break}else C=ea(B/ea(12.9200001));while(0);B=ea(g[A+24>>2]);do if(!(B<=ea(.0404499993)))if(B<ea(1.0)){D=ea(+U(+ea(ea(B+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{D=ea(+U(+B,2.20000005));break}else D=ea(B/ea(12.9200001));while(0);B=ea(g[A+28>>2]);do if(!(B<=ea(.0404499993)))if(B<ea(1.0)){E=ea(+U(+ea(ea(B+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{E=ea(+U(+B,2.20000005));break}else E=ea(B/ea(12.9200001));while(0);B=ea(g[A+32>>2]);g[j>>2]=C;g[w>>2]=D;g[m>>2]=E;g[u>>2]=B}else{c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2]}oud(b,y,j)}}while(0);y=c[p+4>>2]|0;if(!y){o=p;while(1){r=c[o+8>>2]|0;if((c[r>>2]|0)==(o|0)){F=r;break}else o=r}}else{o=y;while(1){r=c[o>>2]|0;if(!r){F=o;break}else o=r}}if((F|0)==(v|0))break;else p=F}}F=c[b+44>>2]|0;p=b+48|0;if((F|0)==(p|0)){i=d;return}v=a+4|0;j=a+4|0;a=F;while(1){F=a+16|0;u=c[v>>2]|0;if(u){m=c[F>>2]|0;w=j;A=u;d:while(1){u=A;while(1){if((c[u+16>>2]|0)>=(m|0)){G=u;break}u=c[u+4>>2]|0;if(!u){H=w;break d}}A=c[G>>2]|0;if(!A){H=G;break}else w=G}if((H|0)!=(j|0)?(m|0)>=(c[H+16>>2]|0):0){w=H+36|0;A=c[w>>2]|0;if(!A)I=0;else{c[h>>2]=A;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(e,A,h);u=c[e>>2]|0;s=c[A+28>>2]|0;if((u|0)==-1){J=s+(c[A+32>>2]<<3)|0;break}else{J=s+(u<<3)|0;break}}else J=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if((J|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0)?(A=c[J+4>>2]|0,(A|0)!=0):0)K=A;else L=76}else L=76;if((L|0)==76){L=0;K=hQb(c[w>>2]|0)|0}I=K}A=H+20|0;m=c[A+4>>2]|0;u=k;c[u>>2]=c[A>>2];c[u+4>>2]=m;m=H+28|0;u=c[m+4>>2]|0;A=l;c[A>>2]=c[m>>2];c[A+4>>2]=u;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];uud(b,F,I,f,e)}}u=c[a+4>>2]|0;if(!u){A=a;while(1){m=c[A+8>>2]|0;if((c[m>>2]|0)==(A|0)){M=m;break}else A=m}}else{A=u;while(1){F=c[A>>2]|0;if(!F){M=A;break}else A=F}}if((M|0)==(p|0))break;else a=M}i=d;return}function wnd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=Im,aa=0;d=i;i=i+16|0;e=d;f=c[b+8>>2]|0;h=b+12|0;if((f|0)==(h|0))j=0;else{k=a+16|0;l=a+16|0;m=a+12|0;n=a+20|0;o=f;f=0;while(1){p=c[o+16>>2]|0;q=ea(g[o+20>>2]);r=ea(q);s=c[k>>2]|0;do if(s){t=s;while(1){u=c[t+16>>2]|0;if((p|0)<(u|0)){v=c[t>>2]|0;if(!v){w=t;x=t;y=6;break}else{t=v;continue}}if((u|0)>=(p|0)){z=t;y=10;break}u=t+4|0;v=c[u>>2]|0;if(!v){A=u;B=t;y=9;break}else t=v}if((y|0)==6){y=0;c[e>>2]=x;C=w;D=x;break}else if((y|0)==9){y=0;c[e>>2]=B;C=A;D=B;break}else if((y|0)==10){y=0;c[e>>2]=z;C=e;D=z;break}}else{c[e>>2]=l;C=l;D=l}while(0);if(!(c[C>>2]|0)){s=xCi(24)|0;t=s+16|0;c[t>>2]=p;g[t+4>>2]=r;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=D;c[C>>2]=s;t=c[c[m>>2]>>2]|0;if(!t)E=s;else{c[m>>2]=t;E=c[C>>2]|0}GN(c[k>>2]|0,E);c[n>>2]=(c[n>>2]|0)+1;F=1}else F=0;t=f|F;s=c[o+4>>2]|0;if(!s){v=o;while(1){u=c[v+8>>2]|0;if((c[u>>2]|0)==(v|0)){G=u;break}else v=u}}else{v=s;while(1){p=c[v>>2]|0;if(!p){G=v;break}else v=p}}if((G|0)==(h|0)){j=t;break}else{o=G;f=t}}}f=c[b+20>>2]|0;G=b+24|0;o=b+44|0;h=c[o>>2]|0;F=b+48|0;if((f|0)==(G|0)){H=h;I=j}else{b=a+28|0;n=a+28|0;E=a+24|0;k=a+32|0;C=h;h=f;f=j;while(1){a:do if((C|0)==(F|0))y=35;else{j=h+20|0;m=C;while(1){if((c[m+24>>2]|0)==(j|0)){J=f;break a}if((c[m+28>>2]|0)==(j|0)){J=f;break a}if((c[m+32>>2]|0)==(j|0)){J=f;break a}D=c[m+4>>2]|0;if(!D){l=m;while(1){z=c[l+8>>2]|0;if((c[z>>2]|0)==(l|0)){K=z;break}else l=z}}else{l=D;while(1){z=c[l>>2]|0;if(!z){K=l;break}else l=z}}if((K|0)==(F|0)){y=35;break}else m=K}}while(0);if((y|0)==35){y=0;t=c[h+16>>2]|0;r=ea(g[h+20>>2]);q=ea(g[h+24>>2]);L=ea(g[h+28>>2]);M=ea(g[h+32>>2]);m=c[b>>2]|0;do if(m){j=m;while(1){l=c[j+16>>2]|0;if((t|0)<(l|0)){D=c[j>>2]|0;if(!D){N=j;O=j;y=38;break}else{j=D;continue}}if((l|0)>=(t|0)){P=j;y=42;break}l=j+4|0;D=c[l>>2]|0;if(!D){Q=l;R=j;y=41;break}else j=D}if((y|0)==38){y=0;c[e>>2]=O;S=N;T=O;break}else if((y|0)==41){y=0;c[e>>2]=R;S=Q;T=R;break}else if((y|0)==42){y=0;c[e>>2]=P;S=e;T=P;break}}else{c[e>>2]=n;S=n;T=n}while(0);if(!(c[S>>2]|0)){m=xCi(36)|0;c[m+16>>2]=t;g[m+20>>2]=r;g[m+24>>2]=q;g[m+28>>2]=L;g[m+32>>2]=M;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=T;c[S>>2]=m;j=c[c[E>>2]>>2]|0;if(!j)U=m;else{c[E>>2]=j;U=c[S>>2]|0}GN(c[b>>2]|0,U);c[k>>2]=(c[k>>2]|0)+1;V=1}else V=0;J=f|V}j=c[h+4>>2]|0;if(!j){m=h;while(1){D=c[m+8>>2]|0;if((c[D>>2]|0)==(m|0)){W=D;break}else m=D}}else{m=j;while(1){t=c[m>>2]|0;if(!t){W=m;break}else m=t}}m=c[o>>2]|0;if((W|0)==(G|0)){H=m;I=J;break}else{C=m;h=W;f=J}}}if((H|0)==(F|0)){X=I;i=d;return X|0}J=a+4|0;f=a+4|0;W=H;H=I;while(1){I=W+16|0;h=c[J>>2]|0;if(h){C=c[I>>2]|0;G=f;o=h;b:while(1){h=o;while(1){if((c[h+16>>2]|0)>=(C|0)){Y=h;break}h=c[h+4>>2]|0;if(!h){Z=G;break b}}o=c[Y>>2]|0;if(!o){Z=Y;break}else G=Y}if((Z|0)!=(f|0)?(C|0)>=(c[Z+16>>2]|0):0)_=H;else y=62}else y=62;if((y|0)==62){y=0;G=c[W+20>>2]|0;M=ea(g[G+44>>2]);L=ea(g[G+48>>2]);q=ea(M);M=ea(L);L=ea(g[G+52>>2]);r=ea(g[G+56>>2]);$=ea(L);L=ea(r);G=ynd(a,I)|0;o=G;g[o>>2]=q;g[o+4>>2]=M;o=G+8|0;g[o>>2]=$;g[o+4>>2]=L;c[G+16>>2]=0;_=1}G=c[W+4>>2]|0;if(!G){o=W;while(1){h=c[o+8>>2]|0;if((c[h>>2]|0)==(o|0)){aa=h;break}else o=h}}else{o=G;while(1){I=c[o>>2]|0;if(!I){aa=o;break}else o=I}}if((aa|0)==(F|0)){X=_;break}else{W=aa;H=_}}i=d;return X|0}function xnd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=0,Z=0,_=0,$=0;d=i;i=i+16|0;e=d+4|0;f=d;h=c[b+12>>2]|0;j=b+16|0;if((h|0)!=(j|0)){k=a+16|0;l=a+16|0;m=a+12|0;n=a+20|0;o=h;while(1){h=o+16|0;p=c[k>>2]|0;q=(p|0)==0;do if(!q){r=c[h>>2]|0;s=l;t=p;a:while(1){u=t;while(1){if((c[u+16>>2]|0)>=(r|0)){v=u;break}u=c[u+4>>2]|0;if(!u){w=s;break a}}t=c[v>>2]|0;if(!t){w=v;break}else s=v}if((w|0)!=(l|0)?(r|0)>=(c[w+16>>2]|0):0)break;x=ea(g[o+20>>2]);if(!q){s=c[h>>2]|0;t=p;while(1){u=c[t+16>>2]|0;if((s|0)<(u|0)){y=c[t>>2]|0;if(!y){z=t;A=t;B=16;break}else{t=y;continue}}if((u|0)>=(s|0)){C=t;B=20;break}u=t+4|0;y=c[u>>2]|0;if(!y){D=u;E=t;B=19;break}else t=y}if((B|0)==16){B=0;c[e>>2]=A;F=z;G=A;H=x;B=22;break}else if((B|0)==19){B=0;c[e>>2]=E;F=D;G=E;H=x;B=22;break}else if((B|0)==20){B=0;c[e>>2]=C;F=e;G=C;H=x;B=22;break}}else{I=x;B=21}}else{I=ea(g[o+20>>2]);B=21}while(0);if((B|0)==21){B=0;c[e>>2]=l;F=l;G=l;H=I;B=22}if((B|0)==22){B=0;p=c[F>>2]|0;if(!p){q=xCi(24)|0;c[q+16>>2]=c[h>>2];g[q+20>>2]=ea(0.0);c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=G;c[F>>2]=q;t=c[c[m>>2]>>2]|0;if(!t)J=q;else{c[m>>2]=t;J=c[F>>2]|0}GN(c[k>>2]|0,J);c[n>>2]=(c[n>>2]|0)+1;K=q}else K=p;g[K+20>>2]=H}p=c[o+4>>2]|0;if(!p){q=o;while(1){t=c[q+8>>2]|0;if((c[t>>2]|0)==(q|0)){L=t;break}else q=t}}else{q=p;while(1){h=c[q>>2]|0;if(!h){L=q;break}else q=h}}if((L|0)==(j|0))break;else o=L}}L=c[b+24>>2]|0;o=b+28|0;if((L|0)!=(o|0)){j=a+28|0;K=a+28|0;n=a+24|0;J=a+32|0;k=L;while(1){L=k+16|0;F=c[j>>2]|0;m=(F|0)==0;do if(!m){G=c[L>>2]|0;l=K;e=F;b:while(1){C=e;while(1){if((c[C+16>>2]|0)>=(G|0)){M=C;break}C=c[C+4>>2]|0;if(!C){N=l;break b}}e=c[M>>2]|0;if(!e){N=M;break}else l=M}if((N|0)!=(K|0)?(G|0)>=(c[N+16>>2]|0):0)break;if(!m){l=c[L>>2]|0;e=F;while(1){C=c[e+16>>2]|0;if((l|0)<(C|0)){E=c[e>>2]|0;if(!E){O=e;P=e;B=46;break}else{e=E;continue}}if((C|0)>=(l|0)){Q=e;B=50;break}C=e+4|0;E=c[C>>2]|0;if(!E){R=C;S=e;B=49;break}else e=E}if((B|0)==46){B=0;c[f>>2]=P;T=O;U=P;B=52;break}else if((B|0)==49){B=0;c[f>>2]=S;T=R;U=S;B=52;break}else if((B|0)==50){B=0;c[f>>2]=Q;T=f;U=Q;B=52;break}}else B=51}else B=51;while(0);if((B|0)==51){B=0;c[f>>2]=K;T=K;U=K;B=52}if((B|0)==52){B=0;F=c[T>>2]|0;if(!F){m=xCi(36)|0;c[m+16>>2]=c[L>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=U;c[T>>2]=m;e=c[c[n>>2]>>2]|0;if(!e)V=m;else{c[n>>2]=e;V=c[T>>2]|0}GN(c[j>>2]|0,V);c[J>>2]=(c[J>>2]|0)+1;W=m}else W=F;x=ea(g[k+20>>2]);H=ea(g[k+24>>2]);I=ea(g[k+28>>2]);X=ea(g[k+32>>2]);g[W+20>>2]=x;g[W+24>>2]=H;g[W+28>>2]=I;g[W+32>>2]=X}F=c[k+4>>2]|0;if(!F){m=k;while(1){e=c[m+8>>2]|0;if((c[e>>2]|0)==(m|0)){Y=e;break}else m=e}}else{m=F;while(1){L=c[m>>2]|0;if(!L){Y=m;break}else m=L}}if((Y|0)==(o|0))break;else k=Y}}Y=c[b>>2]|0;k=b+4|0;if((Y|0)==(k|0)){i=d;return}b=a+4|0;o=a+4|0;W=Y;while(1){Y=W+16|0;J=c[b>>2]|0;if(J){V=c[Y>>2]|0;j=o;T=J;c:while(1){J=T;while(1){if((c[J+16>>2]|0)>=(V|0)){Z=J;break}J=c[J+4>>2]|0;if(!J){_=j;break c}}T=c[Z>>2]|0;if(!T){_=Z;break}else j=Z}if(!((_|0)!=(o|0)?(V|0)>=(c[_+16>>2]|0):0))B=72}else B=72;if((B|0)==72){B=0;j=ynd(a,Y)|0;T=W+20|0;c[j+0>>2]=c[T+0>>2];c[j+4>>2]=c[T+4>>2];c[j+8>>2]=c[T+8>>2];c[j+12>>2]=c[T+12>>2];c[j+16>>2]=c[W+36>>2]}j=c[W+4>>2]|0;if(!j){T=W;while(1){J=c[T+8>>2]|0;if((c[J>>2]|0)==(T|0)){$=J;break}else T=J}}else{T=j;while(1){Y=c[T>>2]|0;if(!Y){$=T;break}else T=Y}}if(($|0)==(k|0))break;else W=$}i=d;return}function ynd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=c[b>>2]|0;j=g;while(1){k=c[j+16>>2]|0;if((h|0)<(k|0)){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if((k|0)>=(h|0)){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=a+4|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+20|0;i=d;return v|0}e=xCi(40)|0;c[e+16>>2]=c[b>>2];b=e+20|0;c[b>>2]=1065353216;c[b+4>>2]=1065353216;b=e+28|0;c[b>>2]=0;c[b+4>>2]=0;c[e+36>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=c[c[a>>2]>>2]|0;if(!t)w=e;else{c[a>>2]=t;w=c[s>>2]|0}GN(c[f>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;u=e;v=u+20|0;i=d;return v|0}function znd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=Pnd()|0;if(f){g=((b|0)/(d|0)|0)+1|0;d=(f<<1)+2|0;f=(d|0)<(g|0)?d:g;if((f|0)<=16)if(!f){h=0;i=e;return h|0}else j=f;else j=16}else j=1;f=(b|0)/(j|0)|0;g=j+-1|0;d=0;do{k=da(d,f)|0;c[a+(d*12|0)>>2]=k;c[a+(d*12|0)+4>>2]=(d|0)==(g|0)?b-k|0:f;c[a+(d*12|0)+8>>2]=j;d=d+1|0}while((d|0)!=(j|0));h=j;i=e;return h|0}function And(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=(b|0)/(d|0)|0;if(!d){i=e;return d|0}g=d+-1|0;h=0;do{j=da(h,f)|0;c[a+(h*12|0)>>2]=j;c[a+(h*12|0)+4>>2]=(h|0)==(g|0)?b-j|0:f;c[a+(h*12|0)+8>>2]=d;h=h+1|0}while((h|0)!=(d|0));i=e;return d|0}function Bnd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+16|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[f>>2]=d;c[a+20>>2]=0;if(!(b&2)){b=a+8|0;c[b>>2]=0;c[b+4>>2]=0}if((c[f>>2]|0)!=-2){i=e;return}c[f>>2]=1;i=e;return}function Cnd(a){a=a|0;return}function Dnd(a){a=a|0;return}function End(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;Hnd(b,c,d,0);i=e;return}function Fnd(a){a=a|0;c[a>>2]=0;return}function Gnd(a){a=a|0;c[a>>2]=0;return}function Hnd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;if(c[a>>2]|0)c[a>>2]=0;ko[b&4095](d);d=a;c[d>>2]=0;c[d+4>>2]=0;i=e;return}function Ind(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;f=i;if(c[a>>2]|0)c[a>>2]=0;ko[b&4095](d);d=a;c[d>>2]=0;c[d+4>>2]=0;i=f;return}function Jnd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if(c[a>>2]|0)c[a>>2]=0;if(e){h=0;do{In[b&4095](d,h);h=h+1|0}while((h|0)!=(e|0))}if(f)ko[f&4095](d);d=a;c[d>>2]=0;c[d+4>>2]=0;i=g;return}function Knd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;if(c[a>>2]|0)c[a>>2]=0;if(e){f=0;do{In[b&4095](d,f);f=f+1|0}while((f|0)!=(e|0))}if(g)ko[g&4095](d);d=a;c[d>>2]=0;c[d+4>>2]=0;i=h;return}function Lnd(a,b){a=a|0;b=b|0;return}function Mnd(a,b){a=a|0;b=b|0;return}function Nnd(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;Knd(a,b,c,d,e,f,g);i=h;return}function Ond(){var a=0;a=i;Snd();i=a;return}function Pnd(){return 0}function Qnd(){return 0}function Rnd(){return c[156870]|0}function Snd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153070];c[b+0>>2]=c[d+0>>2];c[156870]=bOb(1,b,0,16,3653512,15)|0;i=a;return}function Tnd(){var a=0;a=i;rri(627488,627504,4);i=a;return}function Und(){return}function Vnd(){return}function Wnd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[153112]|0;c[a+8>>2]=0;c[a+12>>2]=g;c[a+16>>2]=0;c[a+20>>2]=0;c[e>>2]=c[153112];c[d+0>>2]=c[e+0>>2];e=bOb(4,d,0,16,3653512,62)|0;c[e>>2]=630104;c[a>>2]=e;c[f>>2]=c[153112];c[d+0>>2]=c[f+0>>2];f=bOb(32,d,0,16,3653512,65)|0;Vod(f,627512);c[a+4>>2]=f;i=b;return}function Xnd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;a=i;i=i+1056|0;e=a;god(e,b);b=e+1040|0;f=c[b>>2]|0;if(!f){g=0;i=a;return g|0}h=xo[c[(c[f>>2]|0)+116>>2]&2047](f,e,d)|0;d=c[(c[156880]|0)+4>>2]|0;f=c[b>>2]|0;if((f|0)==(d|0)){a:do if(Zod(d)|0?(j=c[156880]|0,k=j+8|0,l=c[k>>2]|0,m=j+16|0,j=c[m>>2]|0,(j|0)!=0):0){n=j;o=l;p=l+(j<<2)|0;j=l;while(1){l=j+4|0;q=l;r=p;s=n;t=o;while(1){if((c[j>>2]|0)!=(f|0)){u=s;v=t;break}aFi(j|0,l|0,r-q|0)|0;s=(c[m>>2]|0)+-1|0;c[m>>2]=s;t=c[k>>2]|0;r=t+(s<<2)|0;if((j|0)==(r|0))break a}r=v+(u<<2)|0;if((l|0)==(r|0))break;else{n=u;o=v;p=r;j=l}}}while(0);w=c[b>>2]|0}else w=f;if(!w){g=h;i=a;return g|0}In[c[(c[w>>2]|0)+64>>2]&4095](w,e);g=h;i=a;return g|0}function Ynd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+1040|0;f=c[e>>2]|0;if(!f){g=0;i=d;return g|0}h=xo[c[(c[f>>2]|0)+116>>2]&2047](f,a,b)|0;b=c[(c[156880]|0)+4>>2]|0;a=c[e>>2]|0;if((a|0)!=(b|0)){g=h;i=d;return g|0}if(!(Zod(b)|0)){g=h;i=d;return g|0}b=c[156880]|0;e=b+8|0;f=c[e>>2]|0;j=b+16|0;b=c[j>>2]|0;if(!b){g=h;i=d;return g|0}k=b;l=f;m=f+(b<<2)|0;b=f;a:while(1){f=b+4|0;n=f;o=m;p=k;q=l;while(1){if((c[b>>2]|0)!=(a|0)){r=p;s=q;break}aFi(b|0,f|0,o-n|0)|0;p=(c[j>>2]|0)+-1|0;c[j>>2]=p;q=c[e>>2]|0;o=q+(p<<2)|0;if((b|0)==(o|0)){g=h;t=10;break a}}o=s+(r<<2)|0;if((f|0)==(o|0)){g=h;t=10;break}else{k=r;l=s;m=o;b=f}}if((t|0)==10){i=d;return g|0}return 0}function Znd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+1072|0;h=b+8|0;j=b;k=c[156880]|0;l=c[k+16>>2]|0;a:do if(!l)m=5;else{n=k+8|0;o=l;while(1){if(!o){m=5;break a}o=o+-1|0;p=c[(c[n>>2]|0)+(o<<2)>>2]|0;if(_n[c[(c[p>>2]|0)+48>>2]&4095](p,d)|0){q=p;break}}}while(0);if((m|0)==5)q=c[k>>2]|0;k=h+1040|0;a[h>>0]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;UEi(h|0,d|0,1040)|0;In[c[(c[q>>2]|0)+60>>2]&4095](q,h);c[j>>2]=0;q=c[k>>2]|0;d=Km[c[(c[q>>2]|0)+148>>2]&127](q,h,e,f,j,g)|0;g=c[k>>2]|0;if(!g){i=b;return d|0}In[c[(c[g>>2]|0)+64>>2]&4095](g,h);i=b;return d|0}function _nd(){return c[156880]|0}function $nd(a,b){a=a|0;b=b|0;b=i;God(a);i=b;return}function aod(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Hod(a,c);i=b;return}function bod(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+16>>2]|0;a:do if(f){g=b+8|0;h=f;do{if(!h)break a;h=h+-1|0;j=c[(c[g>>2]|0)+(h<<2)>>2]|0}while(!(_n[c[(c[j>>2]|0)+56>>2]&4095](j,d)|0));rri(a,d,SEi(d|0)|0);i=e;return}while(0);f=c[b>>2]|0;co[c[(c[f>>2]|0)+52>>2]&2047](a,f,d);i=e;return}function cod(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+1040>>2]|0;if(!d){e=0;i=b;return e|0}e=_n[c[(c[d>>2]|0)+112>>2]&4095](d,a)|0;i=b;return e|0}function dod(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;In[c[(c[e>>2]|0)+188>>2]&4095](a,e);i=d;return}function eod(a){a=a|0;var b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153112];c[b+0>>2]=c[d+0>>2];d=bOb(24,b,1,16,3653512,290)|0;Wnd(d);c[156880]=d;i=a;return}function fod(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;UEi(b|0,d|0,1040)|0;a[b+1039>>0]=0;f=c[d+1040>>2]|0;c[b+1040>>2]=f;c[b+1044>>2]=c[d+1044>>2];c[b+1048>>2]=0;c[b+1052>>2]=0;if(!f){i=e;return b|0}In[c[(c[f>>2]|0)+60>>2]&4095](f,b);i=e;return b|0}function god(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+1056|0;f=e;g=b+1040|0;a[b>>0]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;g=f+1040|0;a[f>>0]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;UEi(b|0,f|0,1040)|0;f=b+1039|0;g=f+17|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(g|0));UEi(b|0,d|0,1040)|0;msd(b);f=c[156880]|0;g=c[f+16>>2]|0;a:do if(g){h=f+8|0;j=g;while(1){if(!j)break a;j=j+-1|0;k=c[(c[h>>2]|0)+(j<<2)>>2]|0;if(_n[c[(c[k>>2]|0)+48>>2]&4095](k,d)|0){l=k;break}}m=c[l>>2]|0;n=m+60|0;o=c[n>>2]|0;In[o&4095](l,b);i=e;return}while(0);l=c[f>>2]|0;m=c[l>>2]|0;n=m+60|0;o=c[n>>2]|0;In[o&4095](l,b);i=e;return}function hod(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+1056|0;f=e;g=f+1040|0;a[f>>0]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;UEi(b|0,f|0,1040)|0;f=b+1039|0;g=f+17|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(g|0));UEi(b|0,d|0,1040)|0;msd(b);f=c[156880]|0;g=c[f+16>>2]|0;a:do if(g){h=f+8|0;j=g;while(1){if(!j)break a;j=j+-1|0;k=c[(c[h>>2]|0)+(j<<2)>>2]|0;if(_n[c[(c[k>>2]|0)+48>>2]&4095](k,d)|0){l=k;break}}m=c[l>>2]|0;n=m+60|0;o=c[n>>2]|0;In[o&4095](l,b);i=e;return}while(0);l=c[f>>2]|0;m=c[l>>2]|0;n=m+60|0;o=c[n>>2]|0;In[o&4095](l,b);i=e;return}function iod(a){a=a|0;return a|0}function jod(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+1040>>2]|0;if(!f){g=0;i=e;return g|0}g=kn[c[(c[f>>2]|0)+104>>2]&511](f,a,b,d)|0;i=e;return g|0}function kod(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+1040>>2]|0;if(!d){e=0;i=b;return e|0}e=_n[c[(c[d>>2]|0)+80>>2]&4095](d,a)|0;i=b;return e|0}function lod(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+1044>>2]|0;if(!d){e=0;f=0;H=e;i=b;return f|0}g=_n[c[(c[d>>2]|0)+44>>2]&4095](d,a)|0;e=H;f=g;H=e;i=b;return f|0}function mod(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=b+4|0;UEi(h|0,d|0,1040)|0;a[b+1043>>0]=0;j=c[d+1040>>2]|0;c[b+1044>>2]=j;k=c[d+1044>>2]|0;d=b+1048|0;c[d>>2]=k;l=b+1052|0;c[l>>2]=0;c[b+1056>>2]=0;if(!j)m=k;else{In[c[(c[j>>2]|0)+60>>2]&4095](j,h);m=c[d>>2]|0}c[l>>2]=0;a[b+1060>>0]=1;b=kn[c[(c[m>>2]|0)+8>>2]&511](m,h,e,f)|0;i=g;return b|0}function nod(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+1048>>2]|0;if(!d){e=0;f=0;H=f;i=b;return e|0}g=_n[c[(c[d>>2]|0)+44>>2]&4095](d,a+4|0)|0;e=g;f=H;H=f;i=b;return e|0}function ood(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=c[a+1048>>2]|0;if(!h){j=0;i=g;return j|0}j=Km[c[(c[h>>2]|0)+16>>2]&127](h,a+4|0,b,d,e,f)|0;i=g;return j|0}function pod(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=c[a+1048>>2]|0;if(!h){j=0;i=g;return j|0}j=Km[c[(c[h>>2]|0)+24>>2]&127](h,a+4|0,b,d,e,f)|0;i=g;return j|0}function qod(b){b=b|0;var d=0,e=0,f=0;d=i;if(!(a[b+1060>>0]|0)){e=1;i=d;return e|0}f=c[b+1048>>2]|0;if(!f){e=0;i=d;return e|0}e=_n[c[(c[f>>2]|0)+28>>2]&4095](f,b+4|0)|0;i=d;return e|0}function rod(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+1040>>2]|0;if(!d){e=0;i=b;return e|0}e=_n[c[(c[d>>2]|0)+156>>2]&4095](d,a)|0;i=b;return e|0}function sod(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+1040|0;e=c[d>>2]|0;if(((e|0)!=0?_n[c[(c[e>>2]|0)+80>>2]&4095](e,a)|0:0)?(e=c[d>>2]|0,(e|0)!=0):0)f=_n[c[(c[e>>2]|0)+156>>2]&4095](e,a)|0;else f=0;i=b;return f|0}function tod(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+1040>>2]|0;if(!d){e=0;i=b;return e|0}e=_n[c[(c[d>>2]|0)+96>>2]&4095](d,a)|0;i=b;return e|0}function uod(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+1056|0;e=d;c[b>>2]=627536;f=b+1044|0;g=b+4|0;a[g>>0]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;f=e+1040|0;a[e>>0]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;UEi(g|0,e|0,1040)|0;e=b+1052|0;g=b+1043|0;f=g+17|0;do{a[g>>0]=0;g=g+1|0}while((g|0)<(f|0));c[e>>2]=0;a[b+1060>>0]=0;i=d;return}function vod(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=627536;if((a[b+1060>>0]|0)!=0?(e=c[b+1048>>2]|0,(e|0)!=0):0)_n[c[(c[e>>2]|0)+28>>2]&4095](e,b+4|0)|0;e=c[b+1044>>2]|0;if(!e){i=d;return}In[c[(c[e>>2]|0)+64>>2]&4095](e,b+4|0);i=d;return}function wod(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=627536;if((a[b+1060>>0]|0)!=0?(e=c[b+1048>>2]|0,(e|0)!=0):0)_n[c[(c[e>>2]|0)+28>>2]&4095](e,b+4|0)|0;e=c[b+1044>>2]|0;if(!e){ACi(b);i=d;return}In[c[(c[e>>2]|0)+64>>2]&4095](e,b+4|0);ACi(b);i=d;return}function xod(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+1056|0;h=g;god(h,d);d=b+1060|0;a[d>>0]=1;j=b+4|0;UEi(j|0,h|0,1040)|0;a[b+1043>>0]=0;k=h+1040|0;l=c[k>>2]|0;c[b+1044>>2]=l;m=c[h+1044>>2]|0;n=b+1048|0;c[n>>2]=m;o=b+1052|0;c[o>>2]=0;c[b+1056>>2]=0;if(!l)p=m;else{In[c[(c[l>>2]|0)+60>>2]&4095](l,j);p=c[n>>2]|0}c[o>>2]=0;a[d>>0]=1;d=kn[c[(c[p>>2]|0)+8>>2]&511](p,j,e,f)|0;f=c[k>>2]|0;if(!f){i=g;return d|0}In[c[(c[f>>2]|0)+64>>2]&4095](f,h);i=g;return d|0}function yod(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;k=c[a+1048>>2]|0;if(!k){l=0;i=j;return l|0}l=Oo[c[(c[k>>2]|0)+12>>2]&63](k,a+4|0,b,d,e,f,g,h)|0;i=j;return l|0}function zod(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[a+1048>>2]|0;if(!g){h=0;i=f;return h|0}h=Bn[c[(c[g>>2]|0)+32>>2]&255](g,a+4|0,b,d,e)|0;i=f;return h|0}function Aod(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;UEi(b|0,d|0,1040)|0;a[b+1039>>0]=0;f=c[d+1040>>2]|0;c[b+1040>>2]=f;c[b+1044>>2]=c[d+1044>>2];c[b+1048>>2]=0;c[b+1052>>2]=0;if(!f){i=e;return}In[c[(c[f>>2]|0)+60>>2]&4095](f,b);i=e;return}function Bod(a){a=a|0;var b=0,d=0;b=i;d=c[a+1040>>2]|0;if(!d){i=b;return}In[c[(c[d>>2]|0)+64>>2]&4095](d,a);i=b;return}function Cod(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=b;g=(d-f|0)/12|0;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>((j-l|0)/12|0)>>>0){if(!k)m=j;else{j=a+4|0;while(1){n=c[j>>2]|0;if((n|0)==(k|0))break;o=n+-12|0;c[j>>2]=o;xri(o)}ACi(c[a>>2]|0);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>357913941)vxi(a);j=(m-0|0)/12|0;if(j>>>0<178956970){m=j<<1;j=m>>>0<g>>>0?g:m;if(j>>>0>357913941)vxi(a);else p=j}else p=357913941;j=xCi(p*12|0)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(p*12|0);if((b|0)==(d|0)){i=e;return}else{q=b;r=j}do{sri(r,q);r=(c[m>>2]|0)+12|0;c[m>>2]=r;q=q+12|0}while((q|0)!=(d|0));i=e;return}q=a+4|0;a=((c[q>>2]|0)-l|0)/12|0;if(g>>>0>a>>>0){s=1;t=b+(a*12|0)|0}else{s=0;t=d}if((t|0)==(b|0))u=k;else{a=t+-12-f|0;f=b;b=k;while(1){yri(b,f)|0;f=f+12|0;if((f|0)==(t|0))break;else b=b+12|0}u=k+((((a>>>0)/12|0)+1|0)*12|0)|0}if(!s){while(1){s=c[q>>2]|0;if((s|0)==(u|0))break;a=s+-12|0;c[q>>2]=a;xri(a)}i=e;return}if((t|0)==(d|0)){i=e;return}u=t;t=c[q>>2]|0;do{if(!t)v=0;else{sri(t,u);v=c[q>>2]|0}t=v+12|0;c[q>>2]=t;u=u+12|0}while((u|0)!=(d|0));i=e;return}function Dod(a,b){a=a|0;b=b|0;return 1}function Eod(a,b){a=a|0;b=b|0;c[b+1040>>2]=a;c[b+1044>>2]=a;return}function Fod(a,b){a=a|0;b=b|0;return}function God(a){a=a|0;var b=0;b=i;rri(a,627544,SEi(627544)|0);i=b;return}function Hod(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;rri(b,627544,SEi(627544)|0);if(!(a[d>>0]&1)){f=d+1|0;UEi(627544,f|0,1040)|0;i=e;return}else{f=c[d+8>>2]|0;UEi(627544,f|0,1040)|0;i=e;return}}function Iod(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+12|0;g=e;rri(f,d,SEi(d|0)|0);if(_n[c[(c[b>>2]|0)+56>>2]&4095](b,d)|0){sri(a,f);xri(f);i=e;return}else{$nd(g,_nd()|0);fsd(a,g,f);xri(g);xri(f);i=e;return}}function Jod(b,c){b=b|0;c=c|0;return (a[c>>0]|0)==47|0}function Kod(a,b){a=a|0;b=b|0;b=i;rri(a,3653512,0);i=b;return}function Lod(a){a=a|0;return 0}function Mod(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if(d){f=0;i=e;return f|0}f=_n[c[(c[a>>2]|0)+156>>2]&4095](a,b)|0;i=e;return f|0}function Nod(a){a=a|0;return}function Ood(a){a=a|0;return 3062352}function Pod(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Qod(a,b){a=a|0;b=b|0;var d=0;d=i;xo[c[(c[a>>2]|0)+116>>2]&2047](a,b,1)|0;i=d;return 1}function Rod(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Sod(a,b,d){a=a|0;b=b|0;d=d|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;return}function Tod(a,b){a=a|0;b=b|0;return 0}function Uod(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+16|0;l=k+4|0;m=k;if((2147483631-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))n=b+1|0;else n=c[b+8>>2]|0;if(d>>>0<1073741799){o=e+d|0;e=d<<1;p=o>>>0<e>>>0?e:o;if(p>>>0<11)q=11;else q=p+16&-16}else q=2147483631;c[m>>2]=46;c[l+0>>2]=c[m+0>>2];p=cOb(q,16,l,0,3653512,80)|0;if(g)YEi(p|0,n|0,g|0)|0;o=f-h|0;if((o|0)!=(g|0))YEi(p+(j+g)|0,n+(h+g)|0,o-g|0)|0;if((d|0)==10){r=b+8|0;c[r>>2]=p;s=q|1;c[b>>2]=s;i=k;return}c[m>>2]=46;c[l+0>>2]=c[m+0>>2];eOb(n,l);r=b+8|0;c[r>>2]=p;s=q|1;c[b>>2]=s;i=k;return}function Vod(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;c[b>>2]=629632;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=b+8;h=b+20|0;j=SEi(d|0)|0;if(j>>>0>2147483631)ori(h);if(j>>>0<11){a[h>>0]=j<<1;k=h;l=h+1|0}else{m=j+16&-16;c[g>>2]=46;c[f+0>>2]=c[g+0>>2];g=cOb(m,16,f,0,3653512,80)|0;c[b+28>>2]=g;c[h>>2]=m|1;c[b+24>>2]=j;k=h;l=g}YEi(l|0,d|0,j|0)|0;a[l+j>>0]=0;j=a[k>>0]|0;l=(j&1)==0;if(l)n=(j&255)>>>1;else n=c[b+24>>2]|0;if(!n){Wod(b,3653512,1)|0;i=e;return}if(l){o=(j&255)>>>1;p=h+1|0}else{o=c[b+24>>2]|0;p=c[b+28>>2]|0}if((a[p+(o+-1)>>0]|0)!=47){Wod(b,3653512,1)|0;i=e;return}if(l){q=(j&255)>>>1;r=(j&255)>>>1}else{o=c[b+24>>2]|0;q=o;r=o}o=q+-1|0;if(o>>>0<=r>>>0)if(l){a[h+o+1>>0]=0;a[k>>0]=o<<1;Wod(b,3653512,1)|0;i=e;return}else{a[(c[b+28>>2]|0)+o>>0]=0;c[b+24>>2]=o;Wod(b,3653512,1)|0;i=e;return}q=o-r|0;if((o|0)==(r|0)){Wod(b,3653512,1)|0;i=e;return}if(l){s=j;t=10}else{j=c[h>>2]|0;s=j&255;t=(j&-2)+-1|0}if(!(s&1))u=(s&255)>>>1;else u=c[b+24>>2]|0;if((t-u|0)>>>0<q>>>0){Uod(h,t,q-t+u|0,u,u,0,0);v=a[k>>0]|0}else v=s;if(!(v&1))w=h+1|0;else w=c[b+28>>2]|0;PEi(w+u|0,0,q|0)|0;h=u+q|0;if(!(a[k>>0]&1))a[k>>0]=h<<1;else c[b+24>>2]=h;a[w+h>>0]=0;Wod(b,3653512,1)|0;i=e;return}function Wod(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+96|0;g=f+8|0;h=f+28|0;j=f+40|0;k=f+56|0;l=f+12|0;m=f+72|0;n=f+24|0;o=f+60|0;p=f+64|0;q=f;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Bpd(b,d,l);if(!(a[l>>0]&1)){c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];r=m}else{d=c[l+8>>2]|0;s=c[l+4>>2]|0;if(s>>>0>2147483631)ori(m);if(s>>>0<11){a[m>>0]=s<<1;t=m;u=m+1|0}else{v=s+16&-16;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];w=cOb(v,16,g,0,3653512,80)|0;c[m+8>>2]=w;c[m>>2]=v|1;c[m+4>>2]=s;t=m;u=w}YEi(u|0,d|0,s|0)|0;a[u+s>>0]=0;r=t}t=m+12|0;c[t>>2]=0;s=b+4|0;if(!(a[r>>0]&1)){c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];x=0}else{u=c[m+8>>2]|0;d=c[m+4>>2]|0;if(d>>>0>2147483631)ori(j);if(d>>>0<11){a[j>>0]=d<<1;y=j+1|0}else{w=d+16&-16;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];v=cOb(w,16,g,0,3653512,80)|0;c[j+8>>2]=v;c[j>>2]=w|1;c[j+4>>2]=d;y=v}YEi(y|0,u|0,d|0)|0;a[y+d>>0]=0;x=c[t>>2]|0}c[j+12>>2]=x;x=Mpd(s,g,j)|0;t=c[x>>2]|0;if(!t){Npd(h,s,j);d=c[h>>2]|0;c[h>>2]=0;y=c[g>>2]|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=y;c[x>>2]=d;y=c[c[s>>2]>>2]|0;if(!y)z=d;else{c[s>>2]=y;z=c[x>>2]|0}GN(c[b+8>>2]|0,z);z=b+12|0;c[z>>2]=(c[z>>2]|0)+1;A=d}else A=t;if(a[j>>0]&1){t=c[j+8>>2]|0;c[k>>2]=46;c[g+0>>2]=c[k+0>>2];eOb(t,g)}if(a[r>>0]&1){r=c[m+8>>2]|0;c[j>>2]=46;c[g+0>>2]=c[j+0>>2];eOb(r,g)}r=A+28|0;A=c[r>>2]|0;if(!A){c[n>>2]=c[153112];c[g+0>>2]=c[n+0>>2];n=bOb(16,g,0,16,3653512,563)|0;c[n>>2]=0;j=n+4|0;Brd(j);c[n+12>>2]=8;if(e)B=0;else{c[o>>2]=c[153112];c[g+0>>2]=c[o+0>>2];o=bOb(40,g,0,16,3653512,564)|0;c[p>>2]=c[153112];e=c[157466]|0;c[g+0>>2]=c[p+0>>2];fqd(o,g,e);B=o}c[n>>2]=B;Brd(q);B=q;q=c[B+4>>2]|0;o=j;c[o>>2]=c[B>>2];c[o+4>>2]=q;c[r>>2]=n;C=n}else C=A;if(!(a[l>>0]&1)){i=f;return C|0}A=c[l+8>>2]|0;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];eOb(A,g);i=f;return C|0}function Xod(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[b>>2]=629632;h=b+4|0;j=c[h>>2]|0;k=b+8|0;if((j|0)!=(k|0)){l=j;while(1){j=l+28|0;m=c[c[j>>2]>>2]|0;if((m|0)!=0?(n=c[153112]|0,o=m+4|0,c[o>>2]=(c[o>>2]|0)+-1,(c[o>>2]|0)==0):0){ko[c[c[m>>2]>>2]&4095](m);c[f>>2]=n;c[e+0>>2]=c[f+0>>2];eOb(m,e)}m=c[j>>2]|0;c[g>>2]=c[153112];c[e+0>>2]=c[g+0>>2];eOb(m,e);c[j>>2]=0;j=c[l+4>>2]|0;if(!j){m=l;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){p=n;break}else m=n}}else{m=j;while(1){n=c[m>>2]|0;if(!n){p=m;break}else m=n}}if((p|0)==(k|0))break;else l=p}}if(a[b+20>>0]&1){p=c[b+28>>2]|0;c[g>>2]=46;c[e+0>>2]=c[g+0>>2];eOb(p,e)}Lpd(h,c[b+8>>2]|0);i=d;return}function Yod(a){a=a|0;var b=0;b=i;Xod(a);ACi(a);i=b;return}function Zod(a){a=a|0;return (c[a+12>>2]|0)==1|0}function _od(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+4|0;j=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Bpd(b,d,h);Opd(j,b+4|0,h);d=c[j>>2]|0;if((d|0)==(b+8|0))k=0;else k=c[d+28>>2]|0;if(!(a[h>>0]&1)){i=e;return k|0}d=c[h+8>>2]|0;c[g>>2]=46;c[f+0>>2]=c[g+0>>2];eOb(d,f);i=e;return k|0}function $od(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+20|0;if(!(a[f>>0]&1))g=f+1|0;else g=c[b+28>>2]|0;b=(mCi(d,g)|0)!=0;i=e;return b|0}function apd(a,b){a=a|0;b=b|0;c[b+1040>>2]=a;c[b+1044>>2]=a;return}function bpd(a,b){a=a|0;b=b|0;return}function cpd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+12|0;h=f;j=d+20|0;if(!(a[j>>0]&1))k=j+1|0;else k=c[d+28>>2]|0;rri(g,k,SEi(k|0)|0);rri(h,e,SEi(e|0)|0);fsd(b,g,h);xri(h);xri(g);i=f;return}function dpd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+20|0;g=a[f>>0]|0;if(!(g&1)){h=f+1|0;j=(g&255)>>>1}else{h=c[b+28>>2]|0;j=c[b+24>>2]|0}b=(IEi(d,h,j)|0)==0;i=e;return b|0}function epd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;do if(!d){m=fpd(a,b)|0;if(!m){n=0;i=e;return n|0}o=m+12|0;if((c[m>>2]|0)!=0?(c[o>>2]|0)==2:0){n=0;i=e;return n|0}c[o>>2]=1;c[h>>2]=c[153112];c[f+0>>2]=c[h+0>>2];o=bOb(24,f,0,16,3653512,127)|0;p=c[m>>2]|0;c[j>>2]=c[153112];c[f+0>>2]=c[j+0>>2];Tpd(o,p,0,f);q=o;r=14}else if((d|0)==2|(d|0)==3|(d|0)==1){o=Wod(a,b,0)|0;if(!o){n=0;i=e;return n|0}if(!(c[o>>2]|0)){n=0;i=e;return n|0}p=o+12|0;if((c[p>>2]|0)==2){n=0;i=e;return n|0}c[p>>2]=2;c[k>>2]=c[153112];c[f+0>>2]=c[k+0>>2];p=bOb(24,f,0,16,3653512,141)|0;m=c[o>>2]|0;c[l>>2]=c[153112];c[f+0>>2]=c[l+0>>2];Tpd(p,m,d,f);if((d|0)==3){if(kn[c[(c[p>>2]|0)+32>>2]&511](p,0,0,3)|0){q=p;r=14;break}mo[c[(c[p>>2]|0)+12>>2]&4095](p)|0;s=p;break}else if((d|0)==1){if(xo[c[(c[p>>2]|0)+40>>2]&2047](p,0,0)|0){q=p;r=14;break}mo[c[(c[p>>2]|0)+12>>2]&4095](p)|0;s=p;break}else{q=p;r=14;break}}else{n=0;i=e;return n|0}while(0);if((r|0)==14)if(!q){n=0;i=e;return n|0}else s=q;if(mo[c[(c[s>>2]|0)+8>>2]&4095](s)|0){c[b+1040>>2]=a;c[b+1044>>2]=a;c[b+1048>>2]=s;n=1;i=e;return n|0}else{a=c[153112]|0;ko[c[c[s>>2]>>2]&4095](s);c[g>>2]=a;c[f+0>>2]=c[g+0>>2];eOb(s,f);c[b+1052>>2]=-1;n=0;i=e;return n|0}return 0}function fpd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+4|0;j=e;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Bpd(b,d,h);Ppd(j,b+4|0,h);d=c[j>>2]|0;if((d|0)==(b+8|0))k=0;else k=c[d+28>>2]|0;if(!(a[h>>0]&1)){i=e;return k|0}d=c[h+8>>2]|0;c[g>>2]=46;c[f+0>>2]=c[g+0>>2];eOb(d,f);i=e;return k|0}function gpd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+1048|0;h=c[g>>2]|0;if(!h){j=0;i=d;return j|0}k=c[153112]|0;ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(h,e);c[b+1052>>2]=0;c[g>>2]=0;g=fpd(a,b)|0;if(!g){j=1;i=d;return j|0}b=c[g>>2]|0;if((b|0)!=0?(c[b+4>>2]|0)!=1:0){j=1;i=d;return j|0}c[g+12>>2]=8;j=1;i=d;return j|0}function hpd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;a=i;k=c[b+1048>>2]|0;if(!k){l=0;i=a;return l|0}l=gn[c[(c[k>>2]|0)+16>>2]&127](k,d,e,f,g,h,j)|0;i=a;return l|0}function ipd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;h=c[b+1048>>2]|0;if(!h){j=0;i=a;return j|0}j=Bn[c[(c[h>>2]|0)+20>>2]&255](h,d,e,f,g)|0;i=a;return j|0}function jpd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;a=i;k=c[b+1048>>2]|0;if(!k){l=0;i=a;return l|0}l=gn[c[(c[k>>2]|0)+24>>2]&127](k,d,e,f,g,h,j)|0;i=a;return l|0}function kpd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;h=c[b+1048>>2]|0;if(!h){j=0;i=a;return j|0}j=Bn[c[(c[h>>2]|0)+28>>2]&255](h,d,e,f,g)|0;i=a;return j|0}function lpd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=i;g=c[b+1048>>2]|0;if(!g){h=0;i=a;return h|0}h=kn[c[(c[g>>2]|0)+32>>2]&511](g,d,e,f)|0;i=a;return h|0}function mpd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[b+1048>>2]|0;if(!d){e=0;f=0;H=e;i=a;return f|0}b=mo[c[(c[d>>2]|0)+36>>2]&4095](d)|0;e=H;f=b;H=e;i=a;return f|0}function npd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;f=c[b+1048>>2]|0;if(!f){g=0;i=a;return g|0}g=xo[c[(c[f>>2]|0)+40>>2]&2047](f,d,e)|0;i=a;return g|0}function opd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b+1048>>2]|0;if(!e){f=_od(a,b)|0;if((f|0)!=0?(b=c[f>>2]|0,(b|0)!=0):0){f=mo[c[(c[b>>2]|0)+28>>2]&4095](b)|0;g=H;h=f}else{g=0;h=0}}else{f=mo[c[(c[e>>2]|0)+44>>2]&4095](e)|0;g=H;h=f}H=g;i=d;return h|0}function ppd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+12|0;h=f;rri(h,d,SEi(d|0)|0);jsd(g,h);yri(e,g)|0;xri(g);xri(h);if(!(a[e>>0]&1)){j=e+1|0;k=fpd(b,j)|0;l=(k|0)!=0;i=f;return l|0}else{j=c[e+8>>2]|0;k=fpd(b,j)|0;l=(k|0)!=0;i=f;return l|0}return 0}function qpd(a,b){a=a|0;b=b|0;var c=0,d=0;a=i;c=lCi(b,47)|0;if(!c)d=lCi(b,92)|0;else d=c;i=a;return ((d|0)==0?b:d+1|0)|0}function rpd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=_od(a,b)|0;if(!e){f=0;i=d;return f|0}f=(c[e>>2]|0)==0;i=d;return f|0}function spd(a,b){a=a|0;b=b|0;return 0}function tpd(a,b){a=a|0;b=b|0;return 0}function upd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_od(b,d)|0;if(!f){Brd(a);i=e;return}else{d=f+4|0;f=c[d+4>>2]|0;b=a;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}}function vpd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=fpd(a,b)|0;if((e|0)!=0?(c[e>>2]|0)!=0:0)f=(c[e+12>>2]|0)==2;else f=0;i=d;return f|0}function wpd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function xpd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function ypd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(fpd(a,b)|0){d=0;i=c;return d|0}d=(Wod(a,b,0)|0)!=0;i=c;return d|0}function zpd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+24|0;j=e+12|0;k=e;rri(k,d,SEi(d|0)|0);lsd(j,k);if(!(a[j>>0]&1))l=j+1|0;else l=c[j+8>>2]|0;d=SEi(l|0)|0;if(d>>>0>2147483631)ori(h);if(d>>>0<11){a[h>>0]=d<<1;m=h+1|0}else{n=d+16&-16;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];o=cOb(n,16,f,0,3653512,80)|0;c[h+8>>2]=o;c[h>>2]=n|1;c[h+4>>2]=d;m=o}YEi(m|0,l|0,d|0)|0;a[m+d>>0]=0;xri(j);xri(k);if(!(a[h>>0]&1))p=h+1|0;else p=c[h+8>>2]|0;if(!(fpd(b,p)|0)){if(!(a[h>>0]&1))q=h+1|0;else q=c[h+8>>2]|0;r=(Wod(b,q,1)|0)!=0}else r=0;if(!(a[h>>0]&1)){i=e;return r|0}q=c[h+8>>2]|0;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(q,f);i=e;return r|0}function Apd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f=i;i=i+64|0;g=f;h=f+16|0;j=f+36|0;k=f+4|0;l=f+40|0;m=f+44|0;n=f+12|0;o=f+24|0;p=f+20|0;q=f+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Bpd(b,d,m);d=a[m>>0]|0;r=(d&1)==0;if(r)s=(d&255)>>>1;else s=c[m+4>>2]|0;a:do if(s){if(r)t=m+1|0;else t=c[m+8>>2]|0;d=SEi(t|0)|0;if(d>>>0>2147483631)ori(o);if(d>>>0<11){a[o>>0]=d<<1;u=o;v=o+1|0}else{w=d+16&-16;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];x=cOb(w,16,g,0,3653512,80)|0;c[o+8>>2]=x;c[o>>2]=w|1;c[o+4>>2]=d;u=o;v=x}YEi(v|0,t|0,d|0)|0;a[v+d>>0]=0;d=b+4|0;Ppd(n,d,o);if(a[u>>0]&1){x=c[o+8>>2]|0;c[l>>2]=46;c[g+0>>2]=c[l+0>>2];eOb(x,g)}x=b+8|0;w=c[n>>2]|0;if((w|0)!=(x|0)){y=c[c[w+28>>2]>>2]|0;if(!y){z=c[w+4>>2]|0;if(!z){A=w;while(1){w=c[A+8>>2]|0;if((c[w>>2]|0)==(A|0)){B=w;break}else A=w}}else{A=z;while(1){w=c[A>>2]|0;if(!w){B=A;break}else A=w}}b:do if((B|0)!=(x|0)){A=m+1|0;z=m+4|0;w=m+8|0;C=B;while(1){D=C+16|0;if(!(a[D>>0]&1))E=D+1|0;else E=c[C+24>>2]|0;D=a[m>>0]|0;if(!(D&1)){F=A;G=(D&255)>>>1}else{F=c[w>>2]|0;G=c[z>>2]|0}if(IEi(E,F,G)|0)break b;if(!e){H=0;break a}D=C+28|0;I=c[c[D>>2]>>2]|0;do if(I){J=c[153112]|0;K=I+4|0;c[K>>2]=(c[K>>2]|0)+-1;if(c[K>>2]|0)break;ko[c[c[I>>2]>>2]&4095](I);c[h>>2]=J;c[g+0>>2]=c[h+0>>2];eOb(I,g)}while(0);I=c[D>>2]|0;c[j>>2]=c[153112];c[g+0>>2]=c[j+0>>2];eOb(I,g);c[D>>2]=0;I=c[C+4>>2]|0;if(!I){J=C;while(1){K=c[J+8>>2]|0;if((c[K>>2]|0)==(J|0)){L=K;break}else J=K}}else{J=I;while(1){D=c[J>>2]|0;if(!D){L=J;break}else J=D}}c[j>>2]=C;c[g+0>>2]=c[j+0>>2];Qpd(p,d,g);if((L|0)==(x|0))break;else C=L}}while(0);x=c[c[(c[n>>2]|0)+28>>2]>>2]|0;if(x){M=x;N=39}}else{M=y;N=39}if((N|0)==39?(x=c[153112]|0,C=M+4|0,c[C>>2]=(c[C>>2]|0)+-1,(c[C>>2]|0)==0):0){ko[c[c[M>>2]>>2]&4095](M);c[j>>2]=x;c[g+0>>2]=c[j+0>>2];eOb(M,g)}x=c[n>>2]|0;C=x+28|0;z=c[C>>2]|0;c[k>>2]=c[153112];c[g+0>>2]=c[k+0>>2];eOb(z,g);c[C>>2]=0;c[k>>2]=x;c[g+0>>2]=c[k+0>>2];Qpd(q,d,g);H=1}else H=0}else H=0;while(0);if(!(a[m>>0]&1)){i=f;return H|0}q=c[m+8>>2]|0;c[k>>2]=46;c[g+0>>2]=c[k+0>>2];eOb(q,g);i=f;return H|0}function Bpd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=b+20|0;h=a[g>>0]|0;j=(h&1)==0;if(j)k=g+1|0;else k=c[b+28>>2]|0;g=mCi(d,k)|0;if(!g)l=d;else{if(j)m=(h&255)>>>1;else m=c[b+24>>2]|0;l=g+m|0}m=(a[l>>0]|0)==47?l+1|0:l;l=SEi(m|0)|0;g=a[e>>0]|0;if(!(g&1)){n=10;o=g}else{g=c[e>>2]|0;n=(g&-2)+-1|0;o=g&255}g=(o&1)==0;do if(l>>>0<=n>>>0){if(g)p=e+1|0;else p=c[e+8>>2]|0;aFi(p|0,m|0,l|0)|0;a[p+l>>0]=0;b=a[e>>0]|0;if(!(b&1)){h=l<<1&255;a[e>>0]=h;q=h;break}else{c[e+4>>2]=l;q=b;break}}else{if(g)r=(o&255)>>>1;else r=c[e+4>>2]|0;BOc(e,n,l-n|0,r,0,r,l,m);q=a[e>>0]|0}while(0);if(!(q&1)){m=e+1|0;s=m;t=m;u=e+8|0}else{m=e+8|0;s=c[m>>2]|0;t=e+1|0;u=m}m=e+4|0;l=q;q=s;while(1){if(!(l&1)){v=t;w=(l&255)>>>1}else{v=c[u>>2]|0;w=c[m>>2]|0}if((q|0)==(v+w|0))break;s=a[q>>0]|0;r=s<<24>>24;a[q>>0]=(s+-65<<24>>24&255)<26?r+32|0:r;l=a[e>>0]|0;q=q+1|0}i=f;return}function Cpd(a,b){a=a|0;b=b|0;return 0}function Dpd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Epd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Fpd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Gpd(a,b,d){a=a|0;b=b|0;d=d|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;return}function Hpd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Ipd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;g=i;i=i+80|0;j=g;k=g+32|0;l=g+60|0;m=g+4|0;n=g+64|0;o=g+76|0;p=g+20|0;q=g+48|0;r=g+36|0;s=g+8|0;t=_n[c[(c[b>>2]|0)+56>>2]&4095](b,d)|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Bpd(b,d,n);Rpd(n)|0;d=a[n>>0]|0;u=(d&1)==0;if(u)v=(d&255)>>>1;else v=c[n+4>>2]|0;d=b+4|0;if(v){if(u)w=n+1|0;else w=c[n+8>>2]|0;u=SEi(w|0)|0;if(u>>>0>2147483631)ori(p);if(u>>>0<11){a[p>>0]=u<<1;x=p;y=p+1|0}else{v=u+16&-16;c[k>>2]=46;c[j+0>>2]=c[k+0>>2];z=cOb(v,16,j,0,3653512,80)|0;c[p+8>>2]=z;c[p>>2]=v|1;c[p+4>>2]=u;x=p;y=z}YEi(y|0,w|0,u|0)|0;a[y+u>>0]=0;Opd(o,d,p);if(a[x>>0]&1){x=c[p+8>>2]|0;c[l>>2]=46;c[j+0>>2]=c[l+0>>2];eOb(x,j)}}else c[o>>2]=c[d>>2];d=b+8|0;x=c[o>>2]|0;if((x|0)!=(d|0)){c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;l=a[n>>0]|0;p=(l&1)==0;if(p)A=(l&255)>>>1;else A=c[n+4>>2]|0;if(!A){B=x;C=0}else{if(p)D=(l&255)>>>1;else D=c[n+4>>2]|0;p=D+1|0;D=c[x+4>>2]|0;if(!D){A=x;while(1){x=c[A+8>>2]|0;if((c[x>>2]|0)==(A|0)){E=x;break}else A=x}}else{A=D;while(1){D=c[A>>2]|0;if(!D){E=A;break}else A=D}}c[o>>2]=E;B=E;C=p}a:do if((B|0)!=(d|0)){p=e+8|0;E=e+12|0;A=e+4|0;D=b+20|0;x=D+1|0;u=q+4|0;y=q+1|0;w=q+8|0;z=b+28|0;v=r+1|0;F=(h|0)==0;G=(h&8|0)==0;H=(h&2|0)==0;I=(h&32|0)==0;J=(h&16|0)==0;K=(h&4|0)==0;L=r+8|0;M=n+1|0;N=n+4|0;O=n+8|0;P=B;Q=l;while(1){R=(Q&1)==0;if(R)S=(Q&255)>>>1;else S=c[N>>2]|0;if(S){T=P+16|0;if(!(a[T>>0]&1))U=T+1|0;else U=c[P+24>>2]|0;if(R){V=M;W=(Q&255)>>>1}else{V=c[O>>2]|0;W=c[N>>2]|0}if(IEi(U,V,W)|0)break a}if(!f){R=P+16|0;T=a[R>>0]|0;if(!(T&1)){X=(T&255)>>>1;Y=R+1|0}else{X=c[P+20>>2]|0;Y=c[P+24>>2]|0}if(!((X>>>0>C>>>0?(R=EEi(Y+C|0,47,X-C|0)|0,(R|0)!=0):0)?(R-Y|0)!=-1:0))Z=49}else Z=49;if((Z|0)==49){Z=0;R=(c[p>>2]|0)+1|0;c[p>>2]=R;T=c[E>>2]|0;_=T&2147483647;if(R>>>0>_>>>0){$=T<<1;aa=($|0)==0?1:$;do if(_>>>0<aa>>>0)if((T|0)>-1){c[E>>2]=aa;$=c[e>>2]|0;c[k>>2]=c[A>>2];c[j+0>>2]=c[k+0>>2];c[e>>2]=hOb($,aa*1088|0,8,j,0,3653512,370)|0;break}else{c[k>>2]=c[A>>2];c[j+0>>2]=c[k+0>>2];$=cOb(aa*1088|0,8,j,0,3653512,352)|0;YEi($|0,c[e>>2]|0,(c[p>>2]|0)*1088|0)|0;c[E>>2]=aa;c[e>>2]=$;break}while(0);ba=c[p>>2]|0}else ba=R;aa=ba+-1|0;T=c[e>>2]|0;do if(t){if(!(a[D>>0]&1))ca=x;else ca=c[z>>2]|0;_=SEi(ca|0)|0;$=a[q>>0]|0;if(!($&1)){da=10;ea=$}else{$=c[q>>2]|0;da=($&-2)+-1|0;ea=$&255}$=(ea&1)==0;do if(_>>>0<=da>>>0){fa=$?y:c[w>>2]|0;aFi(fa|0,ca|0,_|0)|0;a[fa+_>>0]=0;fa=a[q>>0]|0;if(!(fa&1)){ga=_<<1&255;a[q>>0]=ga;ha=ga;break}else{c[u>>2]=_;ha=fa;break}}else{if($)ia=(ea&255)>>>1;else ia=c[u>>2]|0;AOb(q,da,_-da|0,ia,0,ia,_,ca);ha=a[q>>0]|0}while(0);_=(ha&1)!=0;if(_){ja=(c[q>>2]&-2)+-1|0;ka=c[u>>2]|0}else{ja=10;ka=(ha&255)>>>1}if((ka|0)==(ja|0)){nVb(q,ja,1,ja,ja,0,0);if(!(a[q>>0]&1))Z=74;else Z=75}else if(_)Z=75;else Z=74;if((Z|0)==74){Z=0;a[q>>0]=(ka<<1)+2;la=y;ma=ka+1|0}else if((Z|0)==75){Z=0;_=c[w>>2]|0;$=ka+1|0;c[u>>2]=$;la=_;ma=$}a[la+ka>>0]=47;a[la+ma>>0]=0;$=P+16|0;if(!(a[$>>0]&1))na=$+1|0;else na=c[P+24>>2]|0;BOb(q,na)|0}else{$=P+16|0;if(!(a[$>>0]&1))oa=$+1|0;else oa=c[P+24>>2]|0;$=SEi(oa|0)|0;_=a[q>>0]|0;if(!(_&1)){pa=10;qa=_}else{_=c[q>>2]|0;pa=(_&-2)+-1|0;qa=_&255}_=(qa&1)==0;if($>>>0<=pa>>>0){fa=_?y:c[w>>2]|0;aFi(fa|0,oa|0,$|0)|0;a[fa+$>>0]=0;if(!(a[q>>0]&1)){a[q>>0]=$<<1;break}else{c[u>>2]=$;break}}if(_)ra=(qa&255)>>>1;else ra=c[u>>2]|0;AOb(q,pa,$-pa|0,ra,0,ra,$,oa)}while(0);UEi(T+(aa*1088|0)|0,((a[q>>0]&1)==0?y:c[w>>2]|0)|0,1040)|0;a[T+(aa*1088|0)+1039>>0]=0;R=c[P+28>>2]|0;$=T+(aa*1088|0)+1080|0;a[$>>0]=(c[R>>2]|0)==0&1;_=R+4|0;R=c[_+4>>2]|0;fa=T+(aa*1088|0)+1072|0;c[fa>>2]=c[_>>2];c[fa+4>>2]=R;a[T+(aa*1088|0)+1081>>0]=0;R=T+(aa*1088|0)+1082|0;a[R>>0]=0;fa=(a[q>>0]&1)==0?y:c[w>>2]|0;rri(s,fa,SEi(fa|0)|0);ksd(r,s);xri(s);fa=(a[r>>0]&1)==0?v:c[L>>2]|0;do if(!F){_=(a[R>>0]|0)==0;do if(!(a[$>>0]|0))if(_)if(G){Z=101;break}else break;else if(H){Z=101;break}else break;else if(_)if(J){Z=101;break}else break;else if(K){Z=101;break}else break;while(0);if((Z|0)==101){Z=0;if(I)break;if((a[fa>>0]|0)!=46)break}c[p>>2]=(c[p>>2]|0)+-1}while(0);xri(r)}fa=c[P+4>>2]|0;if(!fa){$=P;while(1){R=c[$+8>>2]|0;if((c[R>>2]|0)==($|0)){sa=R;break}else $=R}}else{$=fa;while(1){R=c[$>>2]|0;if(!R){sa=$;break}else $=R}}c[o>>2]=sa;if((sa|0)==(d|0))break a;P=sa;Q=a[n>>0]|0}}while(0);if(!(a[q>>0]&1))ta=1;else{sa=c[q+8>>2]|0;c[k>>2]=89;c[j+0>>2]=c[k+0>>2];eOb(sa,j);ta=1}}else ta=0;if(!(a[n>>0]&1)){i=g;return ta|0}sa=c[n+8>>2]|0;c[m>>2]=46;c[j+0>>2]=c[m+0>>2];eOb(sa,j);i=g;return ta|0}function Jpd(a,b){a=a|0;b=b|0;return 0}function Kpd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(_od(a,b)|0)!=0;i=c;return d|0}function Lpd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;if(!d){i=e;return}Lpd(b,c[d>>2]|0);Lpd(b,c[d+4>>2]|0);if(a[d+16>>0]&1){b=c[d+24>>2]|0;c[g>>2]=46;c[f+0>>2]=c[g+0>>2];eOb(b,f)}c[h>>2]=46;c[f+0>>2]=c[h+0>>2];eOb(d,f);i=e;return}function Mpd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;a:do if(!(h&1)){e=g;while(1){n=e+16|0;o=a[n>>0]|0;p=(o&1)==0;if(p){q=(o&255)>>>1;r=n+1|0}else{q=c[e+20>>2]|0;r=c[e+24>>2]|0}s=FEi(k,r,q>>>0<b>>>0?q:b)|0;if(!s){if(b>>>0<q>>>0)t=16}else if((s|0)<0)t=16;if((t|0)==16){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){w=(o&255)>>>1;x=n+1|0}else{w=c[e+20>>2]|0;x=c[e+24>>2]|0}n=FEi(x,k,b>>>0<w>>>0?b:w)|0;if(!n){if(w>>>0>=b>>>0){y=e;t=33;break a}}else if((n|0)>=0){y=e;t=33;break a}n=e+4|0;o=c[n>>2]|0;if(!o){z=n;A=e;t=32;break}else e=o}}else{e=g;while(1){o=e+16|0;n=a[o>>0]|0;p=(n&1)==0;if(p){B=(n&255)>>>1;C=o+1|0}else{B=c[e+20>>2]|0;C=c[e+24>>2]|0}s=FEi(l,C,B>>>0<m>>>0?B:m)|0;if(!s){if(m>>>0<B>>>0)t=23}else if((s|0)<0)t=23;if((t|0)==23){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){D=(n&255)>>>1;E=o+1|0}else{D=c[e+20>>2]|0;E=c[e+24>>2]|0}o=FEi(E,l,m>>>0<D>>>0?m:D)|0;if(!o){if(D>>>0>=m>>>0){y=e;t=33;break a}}else if((o|0)>=0){y=e;t=33;break a}o=e+4|0;n=c[o>>2]|0;if(!n){z=o;A=e;t=32;break}else e=n}}while(0);if((t|0)==24){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==32){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==33){c[d>>2]=y;j=d;i=f;return j|0}return 0}function Npd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];j=cOb(32,16,g,0,3653512,80)|0;k=d+4|0;d=j+16|0;if(!(a[e>>0]&1)){c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];l=j+28|0;m=e+12|0;n=c[m>>2]|0;c[l>>2]=n;c[b>>2]=j;o=b+4|0;p=o;q=p;c[q>>2]=k;r=p+4|0;s=r;c[s>>2]=1;i=f;return}t=c[e+8>>2]|0;u=c[e+4>>2]|0;if(u>>>0>2147483631)ori(d);if(u>>>0<11){a[d>>0]=u<<1;v=j+17|0}else{w=u+16&-16;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];h=cOb(w,16,g,0,3653512,80)|0;c[j+24>>2]=h;c[d>>2]=w|1;c[j+20>>2]=u;v=h}YEi(v|0,t|0,u|0)|0;a[v+u>>0]=0;l=j+28|0;m=e+12|0;n=c[m>>2]|0;c[l>>2]=n;c[b>>2]=j;o=b+4|0;p=o;q=p;c[q>>2]=k;r=p+4|0;s=r;c[s>>2]=1;i=f;return}function Opd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[d+4>>2]|0;h=d+4|0;do if(g){d=a[e>>0]|0;j=(d&1)==0;k=(d&255)>>>1;d=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;n=j?k:m;o=j?d:l;p=h;q=g;a:while(1){r=q;while(1){s=r+16|0;t=a[s>>0]|0;if(!(t&1)){u=(t&255)>>>1;v=s+1|0}else{u=c[r+20>>2]|0;v=c[r+24>>2]|0}s=FEi(v,o,n>>>0<u>>>0?n:u)|0;if(!s){if(u>>>0>=n>>>0){w=r;break}}else if((s|0)>=0){w=r;break}r=c[r+4>>2]|0;if(!r){x=p;break a}}q=c[w>>2]|0;if(!q){x=w;break}else p=w}if((x|0)!=(h|0)){p=x+16|0;q=j?k:m;n=a[p>>0]|0;o=(n&1)==0;if(o)y=(n&255)>>>1;else y=c[x+20>>2]|0;if(o)z=p+1|0;else z=c[x+24>>2]|0;p=FEi(j?d:l,z,y>>>0<q>>>0?y:q)|0;if(!p){if(q>>>0<y>>>0)break}else if((p|0)<0)break;c[b>>2]=x;i=f;return}}while(0);c[b>>2]=h;i=f;return}function Ppd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[d+4>>2]|0;h=d+4|0;do if(g){d=a[e>>0]|0;j=(d&1)==0;k=(d&255)>>>1;d=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;n=j?k:m;o=j?d:l;p=h;q=g;a:while(1){r=q;while(1){s=r+16|0;t=a[s>>0]|0;if(!(t&1)){u=(t&255)>>>1;v=s+1|0}else{u=c[r+20>>2]|0;v=c[r+24>>2]|0}s=FEi(v,o,n>>>0<u>>>0?n:u)|0;if(!s){if(u>>>0>=n>>>0){w=r;break}}else if((s|0)>=0){w=r;break}r=c[r+4>>2]|0;if(!r){x=p;break a}}q=c[w>>2]|0;if(!q){x=w;break}else p=w}if((x|0)!=(h|0)){p=x+16|0;q=j?k:m;n=a[p>>0]|0;o=(n&1)==0;if(o)y=(n&255)>>>1;else y=c[x+20>>2]|0;if(o)z=p+1|0;else z=c[x+24>>2]|0;p=FEi(j?d:l,z,y>>>0<q>>>0?y:q)|0;if(!p){if(q>>>0<y>>>0)break}else if((p|0)<0)break;c[b>>2]=x;i=f;return}}while(0);c[b>>2]=h;i=f;return}function Qpd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[e>>2]|0;c[b>>2]=k;e=c[k+4>>2]|0;if(!e){l=k;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=e;while(1){e=c[l>>2]|0;if(!e){n=l;break}else l=e}}c[b>>2]=n;if((c[d>>2]|0)==(k|0))c[d>>2]=n;n=d+8|0;c[n>>2]=(c[n>>2]|0)+-1;tYb(c[d+4>>2]|0,k);if(!(a[k+16>>0]&1)){c[j>>2]=46;c[g+0>>2]=c[j+0>>2];eOb(k,g);i=f;return}d=c[k+24>>2]|0;c[h>>2]=46;c[g+0>>2]=c[h+0>>2];eOb(d,g);c[j>>2]=46;c[g+0>>2]=c[j+0>>2];eOb(k,g);i=f;return}function Rpd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=a[b>>0]|0;f=(e&1)==0;if(f)g=(e&255)>>>1;else g=c[b+4>>2]|0;if(!g){i=d;return b|0}if(f){h=(e&255)>>>1;j=b+1|0}else{h=c[b+4>>2]|0;j=c[b+8>>2]|0}if((a[j+(h+-1)>>0]|0)!=47){i=d;return b|0}if(f){k=(e&255)>>>1;l=(e&255)>>>1}else{h=c[b+4>>2]|0;k=h;l=h}h=k+-1|0;if(h>>>0<=l>>>0)if(f){a[b+h+1>>0]=0;a[b>>0]=h<<1;i=d;return b|0}else{a[(c[b+8>>2]|0)+h>>0]=0;c[b+4>>2]=h;i=d;return b|0}k=h-l|0;if((h|0)==(l|0)){i=d;return b|0}if(f){m=e;n=10}else{e=c[b>>2]|0;m=e&255;n=(e&-2)+-1|0}if(!(m&1))o=(m&255)>>>1;else o=c[b+4>>2]|0;if((n-o|0)>>>0<k>>>0){Uod(b,n,k-n+o|0,o,o,0,0);p=a[b>>0]|0}else p=m;if(!(p&1))q=b+1|0;else q=c[b+8>>2]|0;PEi(q+o|0,0,k|0)|0;p=o+k|0;if(!(a[b>>0]&1))a[b>>0]=p<<1;else c[b+4>>2]=p;a[q+p>>0]=0;i=d;return b|0}function Spd(a){a=a|0;return 629792}function Tpd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[a>>2]=629808;k=a+4|0;c[k>>2]=b;c[a+8>>2]=d;d=c[e>>2]|0;e=a+12|0;c[e>>2]=d;l=a+16|0;c[l>>2]=0;c[l+4>>2]=0;if(!b){c[h>>2]=d;c[g+0>>2]=c[h+0>>2];h=bOb(40,g,0,16,3653512,13)|0;c[j>>2]=c[e>>2];e=c[157466]|0;c[g+0>>2]=c[j+0>>2];fqd(h,g,e);c[k>>2]=h;i=f;return}else{h=b+4|0;c[h>>2]=(c[h>>2]|0)+1;i=f;return}}function Upd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=629808;f=a+4|0;g=c[f>>2]|0;if(!g){i=b;return}h=c[a+12>>2]|0;a=g+4|0;c[a>>2]=(c[a>>2]|0)+-1;if(!(c[a>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[f>>2]=0;i=b;return}function Vpd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=629808;f=c[a+4>>2]|0;if(!f){ACi(a);i=b;return}g=c[a+12>>2]|0;h=f+4|0;c[h>>2]=(c[h>>2]|0)+-1;if(c[h>>2]|0){ACi(a);i=b;return}ko[c[c[f>>2]>>2]&4095](f);c[e>>2]=g;c[d+0>>2]=c[e+0>>2];eOb(f,d);ACi(a);i=b;return}function Wpd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+4|0;g=c[f>>2]|0;if(!g){i=b;return 1}h=c[a+12>>2]|0;a=g+4|0;c[a>>2]=(c[a>>2]|0)+-1;if(!(c[a>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[f>>2]=0;i=b;return 1}function Xpd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;k=c[a+4>>2]|0;if(!k){l=0;i=j;return l|0}if(c[a+8>>2]&-3){l=0;i=j;return l|0}m=Km[c[(c[k>>2]|0)+16>>2]&127](k,b,d,e,f,g)|0;g=H;f=_Ei(m|0,g|0,b|0,d|0)|0;d=a+16|0;c[d>>2]=f;c[d+4>>2]=H;if(!h){l=1;i=j;return l|0}d=h;c[d>>2]=m;c[d+4>>2]=g;l=1;i=j;return l|0}function Ypd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=a+16|0;j=gn[c[(c[a>>2]|0)+16>>2]&127](a,c[h>>2]|0,c[h+4>>2]|0,b,d,e,f)|0;i=g;return j|0}function Zpd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;k=c[a+4>>2]|0;if(!k){l=0;i=j;return l|0}if(!(c[a+8>>2]|0)){l=0;i=j;return l|0}m=Km[c[(c[k>>2]|0)+20>>2]&127](k,b,d,e,f,g)|0;g=H;f=_Ei(m|0,g|0,b|0,d|0)|0;d=a+16|0;c[d>>2]=f;c[d+4>>2]=H;if(!h){l=1;i=j;return l|0}d=h;c[d>>2]=m;c[d+4>>2]=g;l=1;i=j;return l|0}function _pd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=a+16|0;j=gn[c[(c[a>>2]|0)+24>>2]&127](a,c[h>>2]|0,c[h+4>>2]|0,b,d,e,f)|0;i=g;return j|0}function $pd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=a+4|0;h=c[g>>2]|0;if(!h){j=0;i=f;return j|0}if((e|0)==3){k=mo[c[(c[h>>2]|0)+28>>2]&4095](h)|0;l=ZEi(k|0,H|0,b|0,d|0)|0;m=c[g>>2]|0;n=H;o=l}else if((e|0)==2){e=a+16|0;l=_Ei(c[e>>2]|0,c[e+4>>2]|0,b|0,d|0)|0;m=h;n=H;o=l}else{m=h;n=d;o=b}h=mo[c[(c[m>>2]|0)+28>>2]&4095](m)|0;m=H;if(n>>>0>m>>>0|(n|0)==(m|0)&o>>>0>h>>>0){j=0;i=f;return j|0}h=a+16|0;c[h>>2]=b;c[h+4>>2]=d;j=1;i=f;return j|0}function aqd(a){a=a|0;var b=0,d=0;b=i;d=a+16|0;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function bqd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+4>>2]|0;if((f|0)!=0?(c[a+8>>2]|0)!=0:0){co[c[(c[f>>2]|0)+24>>2]&2047](f,b,d);g=1}else g=0;i=e;return g|0}function cqd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;if(!d){e=0;f=0;H=e;i=b;return f|0}a=mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0;e=H;f=a;H=e;i=b;return f|0}function dqd(a){a=a|0;return 1}function eqd(a){a=a|0;return (c[a+4>>2]|0)!=0|0}function fqd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;c[a>>2]=575440;c[a+4>>2]=1;c[a>>2]=629880;h=c[b>>2]|0;c[a+8>>2]=h;c[a+12>>2]=d;d=a+16|0;c[d>>2]=0;c[a+20>>2]=h;c[a+24>>2]=0;c[a+32>>2]=0;c[a+28>>2]=64;c[g>>2]=h;c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(0,256,4,f,0,3653512,370)|0;i=e;return}function gqd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=629880;g=a+16|0;h=a+24|0;if(c[h>>2]|0){j=a+8|0;k=0;do{l=c[(c[g>>2]|0)+(k<<2)>>2]|0;c[f>>2]=c[j>>2];c[d+0>>2]=c[f+0>>2];eOb(l,d);k=k+1|0}while(k>>>0<(c[h>>2]|0)>>>0)}if((c[a+28>>2]|0)<=-1){i=b;return}h=c[g>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;i=b;return}function hqd(a){a=a|0;var b=0;b=i;gqd(a);ACi(a);i=b;return}function iqd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+32|0;h=c[g>>2]|0;if(!h){c[b>>2]=0;i=d;return 1}if(h>>>0>(c[a+12>>2]|0)>>>0){c[f>>2]=c[a+8>>2];c[e+0>>2]=c[f+0>>2];f=cOb(h,16,e,0,3653512,38)|0;c[b>>2]=f;Km[c[(c[a>>2]|0)+16>>2]&127](a,0,0,c[g>>2]|0,0,f)|0;i=d;return 1}else{c[b>>2]=c[c[a+16>>2]>>2];i=d;return 1}return 0}function jqd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if((c[c[a+16>>2]>>2]|0)==(b|0)){i=d;return}c[f>>2]=c[a+8>>2];c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function kqd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;j=a+12|0;k=c[j>>2]|0;l=hFi(b|0,d|0,k|0,0)|0;m=_Ei(e|0,f|0,b|0,d|0)|0;n=H;o=c[a+32>>2]|0;p=n>>>0>0|(n|0)==0&m>>>0>o>>>0;m=ZEi(o|0,0,b|0,d|0)|0;o=p?m:e;e=p?H:f;f=a+24|0;if((o|0)==0&(e|0)==0){q=0;r=0;H=q;i=h;return r|0}p=ZEi(b|0,d|0,da(l,k)|0,0)|0;k=a+16|0;a=0;d=0;b=l;l=p;p=0;while(1){if(b>>>0>=(c[f>>2]|0)>>>0){q=d;r=a;s=8;break}m=(c[j>>2]|0)-l|0;n=ZEi(o|0,e|0,a|0,d|0)|0;t=n>>>0<m>>>0?n:m;m=c[(c[k>>2]|0)+(b<<2)>>2]|0;n=g+p|0;if(!m)PEi(n|0,0,t|0)|0;else YEi(n|0,m+l|0,t|0)|0;p=t+p|0;if(!(e>>>0>0|(e|0)==0&o>>>0>p>>>0)){q=0;r=p;s=8;break}else{a=p;d=0;b=b+1|0;l=0}}if((s|0)==8){H=q;i=h;return r|0}return 0}function lqd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h+4|0;k=h;l=_Ei(e|0,f|0,b|0,d|0)|0;m=a+12|0;n=c[m>>2]|0;o=hFi(l|0,H|0,n|0,0)|0;l=_Ei(o|0,H|0,1,0)|0;if(l>>>0>(c[a+24>>2]|0)>>>0){mqd(a,l);p=c[m>>2]|0}else p=n;n=hFi(b|0,d|0,p|0,0)|0;if((e|0)==0&(f|0)==0){q=0;r=0;s=a+32|0;t=_Ei(q|0,r|0,b|0,d|0)|0;u=H;v=c[s>>2]|0;w=v>>>0<t>>>0;x=w?t:v;c[s>>2]=x;H=r;i=h;return q|0}l=ZEi(b|0,d|0,da(n,p)|0,0)|0;o=a+16|0;y=a+8|0;z=p;p=0;A=0;B=n;n=l;l=0;while(1){C=z-n|0;D=ZEi(e|0,f|0,p|0,A|0)|0;E=D>>>0<C>>>0?D:C;C=c[(c[o>>2]|0)+(B<<2)>>2]|0;if(!C){c[k>>2]=c[y>>2];c[j+0>>2]=c[k+0>>2];D=cOb(z,16,j,0,3653512,108)|0;c[(c[o>>2]|0)+(B<<2)>>2]=D;F=c[(c[o>>2]|0)+(B<<2)>>2]|0}else F=C;YEi(F+n|0,g+l|0,E|0)|0;C=E+l|0;if(!(0<f>>>0|0==(f|0)&C>>>0<e>>>0)){q=C;r=0;break}z=c[m>>2]|0;p=C;A=0;B=B+1|0;n=0;l=C}s=a+32|0;t=_Ei(q|0,r|0,b|0,d|0)|0;u=H;v=c[s>>2]|0;w=v>>>0<t>>>0;x=w?t:v;c[s>>2]=x;H=r;i=h;return q|0}function mqd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+16|0;j=a+24|0;k=c[j>>2]|0;if(k>>>0>b>>>0){l=a+8|0;m=b;do{n=c[(c[h>>2]|0)+(m<<2)>>2]|0;c[g>>2]=c[l>>2];c[e+0>>2]=c[g+0>>2];eOb(n,e);m=m+1|0}while((m|0)!=(k|0))}c[j>>2]=b;m=a+28|0;g=c[m>>2]|0;l=g&2147483647;do if(l>>>0<b>>>0?(n=g<<1,o=n>>>0>b>>>0?n:b,l>>>0<o>>>0):0)if((g|0)>-1){c[m>>2]=o;n=c[h>>2]|0;c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];c[h>>2]=hOb(n,o<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];n=cOb(o<<2,4,e,0,3653512,352)|0;YEi(n|0,c[h>>2]|0,c[j>>2]<<2|0)|0;c[m>>2]=o;c[h>>2]=n;break}while(0);if(k>>>0>=b>>>0){i=d;return}m=k;do{c[(c[h>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(b|0));i=d;return}function nqd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=hFi(b|0,d|0,c[a+12>>2]|0,0)|0;mqd(a,f);c[a+32>>2]=b;i=e;return}function oqd(a){a=a|0;var b=0;b=i;H=0;i=b;return c[a+32>>2]|0}function pqd(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[153112]|0;if(0)ko[c[c[0>>2]>>2]&4095](0);c[d>>2]=e;c[b+0>>2]=c[d+0>>2];eOb(0,b);i=a;return}function qqd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+1072|0;e=d+16|0;f=d;g=_nd()|0;if(!(a[b>>0]&1))h=b+1|0;else h=c[b+8>>2]|0;bod(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;god(e,j);xri(f);f=sod(e)|0;Bod(e);i=d;return f|0}function rqd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+1072|0;e=d+16|0;f=d;g=_nd()|0;if(!(a[b>>0]&1))h=b+1|0;else h=c[b+8>>2]|0;bod(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;god(e,j);xri(f);if(kod(e)|0){k=0;Bod(e);i=d;return k|0}k=rod(e)|0;Bod(e);i=d;return k|0}function sqd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=_nd()|0;if(!(a[d>>0]&1))g=d+1|0;else g=c[d+8>>2]|0;bod(b,f,g);i=e;return}function tqd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+1104|0;f=e+1096|0;g=e+1088|0;h=e+32|0;j=e+16|0;k=e;if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;god(h,l);c[j>>2]=0;l=j+8|0;c[l>>2]=0;b=j+12|0;c[b>>2]=0;m=j+4|0;c[m>>2]=60;n=_nd()|0;Znd(n,iod(h)|0,j,0,0)|0;n=c[j>>2]|0;if(!(c[l>>2]|0))o=n;else{p=n;do{rri(k,p,SEi(p|0)|0);lO(f,d,k);xri(k);p=p+1088|0;n=c[j>>2]|0}while((p|0)!=(n+((c[l>>2]|0)*1088|0)|0));o=n}if((c[b>>2]|0)<=-1){Bod(h);i=e;return 1}c[g>>2]=c[m>>2];c[f+0>>2]=c[g+0>>2];eOb(o,f);c[j>>2]=0;Bod(h);i=e;return 1}function uqd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+2128|0;f=e+1072|0;g=e+8|0;h=e;if(!(a[d>>0]&1))j=d+1|0;else j=c[d+8>>2]|0;god(f,j);j=lod(f)|0;uod(g);if(!(mod(g,f,0,0)|0)){k=0;vod(g);Bod(f);i=e;return k|0}d=a[b>>0]|0;l=(d&1)==0;if(l)m=(d&255)>>>1;else m=c[b+4>>2]|0;do if(j>>>0>m>>>0){n=j-m|0;if((j|0)!=(m|0)){if(l){o=d;p=10}else{q=c[b>>2]|0;o=q&255;p=(q&-2)+-1|0}if(!(o&1))r=(o&255)>>>1;else r=c[b+4>>2]|0;if((p-r|0)>>>0<n>>>0){nVb(b,p,n-p+r|0,r,r,0,0);s=a[b>>0]|0}else s=o;if(!(s&1))t=b+1|0;else t=c[b+8>>2]|0;PEi(t+r|0,0,n|0)|0;q=r+n|0;if(!(a[b>>0]&1))a[b>>0]=q<<1;else c[b+4>>2]=q;a[t+q>>0]=0}}else if(l){a[b+j+1>>0]=0;a[b>>0]=j<<1;break}else{a[(c[b+8>>2]|0)+j>>0]=0;c[b+4>>2]=j;break}while(0);l=h;c[l>>2]=0;c[l+4>>2]=0;if(j){if(!(a[b>>0]&1))u=b+1|0;else u=c[b+8>>2]|0;l=ood(g,j,0,u,h)|0;qod(g)|0;if(l)v=33}else{qod(g)|0;v=33}if((v|0)==33?(v=h,(c[v+4>>2]|0)==0?(c[v>>2]|0)==(j|0):0):0){k=1;vod(g);Bod(f);i=e;return k|0}if(!(a[b>>0]&1)){a[b+1>>0]=0;a[b>>0]=0;k=0;vod(g);Bod(f);i=e;return k|0}else{a[c[b+8>>2]>>0]=0;c[b+4>>2]=0;k=0;vod(g);Bod(f);i=e;return k|0}return 0}function vqd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+2128|0;g=f+1072|0;h=f+8|0;j=f;if(!(a[e>>0]&1))k=e+1|0;else k=c[e+8>>2]|0;god(g,k);uod(h);if(!(mod(h,g,1,0)|0)){l=0;vod(h);Bod(g);i=f;return l|0}k=j;c[k>>2]=0;c[k+4>>2]=0;k=pod(h,d,((d|0)<0)<<31>>31,b,j)|0;qod(h)|0;l=k;vod(h);Bod(g);i=f;return l|0}function wqd(b){b=b|0;var d=0,e=0,f=0;d=i;e=_nd()|0;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;b=Xnd(e,f,1)|0;i=d;return b|0}function xqd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+1104|0;e=d;f=d+1080|0;g=d+24|0;h=d+8|0;if(rqd(b)|0){j=0;i=d;return j|0}if(qqd(b)|0){j=1;i=d;return j|0}k=_nd()|0;if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;bod(f,k,l);if(!(a[b>>0]&1))m=b+1|0;else m=c[b+8>>2]|0;god(g,m);if(cod(g)|0)n=1;else{if(!(a[f>>0]&1))o=f+1|0;else o=c[f+8>>2]|0;dod(h,_nd()|0);if(!(a[h>>0]&1))p=h+1|0;else p=c[h+8>>2]|0;c[e>>2]=o;c[e+4>>2]=p;Ird(629912,e);xri(h);n=0}Bod(g);xri(f);j=n;i=d;return j|0}function yqd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+1056|0;e=d;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;god(e,f);f=lod(e)|0;Bod(e);i=d;return f|0}function zqd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+1056|0;g=f;if(!(a[b>>0]&1))h=b+1|0;else h=c[b+8>>2]|0;god(g,h);h=jod(g,d,e)|0;Bod(g);i=f;return h|0}function Aqd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+1056|0;e=d;if(!(a[b>>0]&1))f=b+1|0;else f=c[b+8>>2]|0;god(e,f);f=tod(e)|0;Bod(e);i=d;return f|0}function Bqd(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function Cqd(a){a=a|0;var b=0;b=i;Dqd(a)|0;xri(a+12|0);i=b;return}function Dqd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;h=b+4|0;j=c[h>>2]|0;if((j|0)!=0?!(qod(j)|0):0){rri(g,629952,13);Eri(g,iod(c[b>>2]|0)|0)|0;if(!(a[g>>0]&1))k=g+1|0;else k=c[g+8>>2]|0;Krd(k,0,3653512,399,1,0,0,0);xri(g);l=0}else l=1;g=c[b>>2]|0;k=c[153108]|0;if(g)Bod(g);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(g,e);c[b>>2]=0;b=c[h>>2]|0;g=c[153108]|0;if(!b){c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(b,e);c[h>>2]=0;i=d;return l|0}ko[c[c[b>>2]>>2]&4095](b);c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(b,e);c[h>>2]=0;i=d;return l|0}function Eqd(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;aod(c,_nd()|0,a);xri(c);i=b;return}function Fqd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;m=c[b>>2]|0;if(m){n=c[153108]|0;Bod(m);c[j>>2]=n;c[h+0>>2]=c[j+0>>2];eOb(m,h);c[b>>2]=0}m=b+4|0;n=c[m>>2]|0;if(n){qod(n)|0;n=c[m>>2]|0;o=c[153108]|0;if(n)ko[c[c[n>>2]>>2]&4095](n);c[j>>2]=o;c[h+0>>2]=c[j+0>>2];eOb(n,h);c[m>>2]=0}c[b+8>>2]=0;c[k>>2]=c[153108];c[h+0>>2]=c[k+0>>2];k=bOb(1056,h,0,16,3653512,322)|0;n=k+1040|0;a[k>>0]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;fod(k,d)|0;c[b>>2]=k;c[l>>2]=c[153108];c[h+0>>2]=c[l+0>>2];l=bOb(1064,h,0,16,3653512,323)|0;uod(l);c[m>>2]=l;m=c[b>>2]|0;h=(f&2|0)!=0?5:0;do{if(mod(l,m,e,0)|0){p=1;q=11;break}h=h+-1|0}while((h|0)>0);if((q|0)==11){i=g;return p|0}Dqd(b)|0;p=0;i=g;return p|0}function Gqd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+1056|0;h=g;if(!(a[d>>0]&1))j=d+1|0;else j=c[d+8>>2]|0;god(h,j);j=Fqd(b,h,e,f)|0;Bod(h);i=g;return j|0}function Hqd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=g;c[h>>2]=0;c[h+4>>2]=0;h=((b|0)<0)<<31>>31;yod(c[a+4>>2]|0,b,h,e,((e|0)<0)<<31>>31,d,g)|0;d=g;g=c[d>>2]|0;e=_Ei(g|0,c[d+4>>2]|0,b|0,h|0)|0;c[a+8>>2]=e;i=f;return g|0}function Iqd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=f;c[g>>2]=0;c[g+4>>2]=0;g=((d|0)<0)<<31>>31;h=pod(c[a+4>>2]|0,d,g,b,f)|0;b=f;f=c[b>>2]|0;j=c[b+4>>2]|0;b=a+8|0;a=_Ei(c[b>>2]|0,0,f|0,j|0)|0;c[b>>2]=a;i=e;return h&((f|0)==(d|0)&(j|0)==(g|0))|0}function Jqd(a){a=a|0;var b=0;if(!(c[a>>2]|0))b=0;else b=(c[a+4>>2]|0)!=0;return b|0}function Kqd(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+80|0;d=a;if(id(b|0,d|0)|0){e=0;i=a;return e|0}e=(c[d+12>>2]&61440|0)==16384;i=a;return e|0}function Lqd(a,b){a=a|0;b=b|0;return 0}function Mqd(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+80|0;d=a;if(zm(b|0,d|0)|0){e=0;i=a;return e|0}e=(c[d+12>>2]&61440|0)==40960;i=a;return e|0}function Nqd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+80|0;d=a;if(!(id(b|0,d|0)|0)){b=c[d+36>>2]|0;e=((b|0)<0)<<31>>31;f=b}else{e=0;f=0}H=e;i=a;return f|0}function Oqd(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;d=i;i=i+80|0;f=d;Brd(a);if(id(e|0,f|0)|0){i=d;return}e=(c[f+56>>2]|0)+-2082844800|0;b[a+2>>1]=0;c[a+4>>2]=e;b[a>>1]=((e|0)<0)<<31>>31;i=d;return}function Pqd(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+32|0;g=b+12|0;h=b;rri(g,e,SEi(e|0)|0);e=a[g>>0]|0;if(!(e&1)){j=g+1|0;k=(e&255)>>>1;l=g+1|0}else{m=c[g+8>>2]|0;j=m;k=c[g+4>>2]|0;l=m}m=j+k|0;if((l|0)==(m|0))n=e;else{e=l;do{if((a[e>>0]|0)==92)a[e>>0]=47;e=e+1|0}while((e|0)!=(m|0));n=a[g>>0]|0}if(!(n&1)){o=g+1|0;p=(n&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}n=o+p|0;while(1){if((n|0)==(o|0)){q=0;break}p=n+-1|0;if(!(EEi(629968,d[p>>0]|0,2)|0)){r=p;s=15;break}else n=p}if((s|0)==15)q=1-o+r|0;Jri(g,q,-1)|0;q=Mri(g,47,-1)|0;if((q|0)==-1){t=0;xri(g);i=b;return t|0}vri(h,g,0,q,g);yri(f,h)|0;xri(h);h=a[f>>0]|0;if(!(h&1))u=(h&255)>>>1;else u=c[f+4>>2]|0;f=a[g>>0]|0;if(!(f&1))v=(f&255)>>>1;else v=c[g+4>>2]|0;t=u>>>0<v>>>0;xri(g);i=b;return t|0}function Qqd(a,b){a=a|0;b=b|0;var c=0,d=0;a=i;c=lCi(b,47)|0;if(!c)d=lCi(b,92)|0;else d=c;i=a;return d+1|0}function Rqd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;a=(Ih(b|0,c|0)|0)==0;i=d;return a|0}function Sqd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 1}function Tqd(a,b){a=a|0;b=b|0;var c=0,d=0;a=i;c=ed(b|0,2419736)|0;if(!c)d=0;else{dj(c|0)|0;d=1}i=a;return d|0}function Uqd(a,b){a=a|0;b=b|0;var c=0;a=i;c=(fi(b|0,493)|0)==0;i=a;return c|0}function Vqd(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function Wqd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+1088|0;f=e+32|0;g=e+24|0;h=e+8|0;j=e;if(!(_n[c[(c[a>>2]|0)+80>>2]&4095](a,b)|0)){k=cl(b|0)|0;l=(k|0)==0;i=e;return l|0}if(d?!(_n[c[(c[a>>2]|0)+88>>2]&4095](a,b)|0):0){c[h>>2]=0;d=h+8|0;c[d>>2]=0;m=h+12|0;c[m>>2]=0;n=h+4|0;c[n>>2]=60;c[j>>2]=0;Km[c[(c[a>>2]|0)+148>>2]&127](a,b,h,0,j,0)|0;j=c[h>>2]|0;if(!(c[d>>2]|0))o=j;else{p=j;do{god(f,p);Ynd(f,1)|0;Bod(f);p=p+1088|0;j=c[h>>2]|0}while((p|0)!=(j+((c[d>>2]|0)*1088|0)|0));o=j}if((c[m>>2]|0)>-1){c[g>>2]=c[n>>2];c[f+0>>2]=c[g+0>>2];eOb(o,f);c[h>>2]=0}}if(_n[c[(c[a>>2]|0)+88>>2]&4095](a,b)|0){k=cl(b|0)|0;l=(k|0)==0;i=e;return l|0}else{k=Uj(b|0)|0;l=(k|0)==0;i=e;return l|0}return 0}function Xqd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+1040|0;g=f+16|0;h=f;if(!(_n[c[(c[b>>2]|0)+88>>2]&4095](b,d)|0)){hod(e,d);j=1;i=f;return j|0}b=tg(d|0,g|0,1024)|0;if((b|0)>=1024){j=0;i=f;return j|0}rri(h,g,b);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;hod(e,k);xri(h);j=1;i=f;return j|0}function Yqd(a,b){a=a|0;b=b|0;var c=0;a=i;c=(vl(b|0,0)|0)==0;i=a;return c|0}function Zqd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+1104|0;e=d+1092|0;f=d+1080|0;g=d+1068|0;h=d+1056|0;j=d;rri(e,b,SEi(b|0)|0);k=qqd(e)|0;xri(e);if(!k){rri(h,b,SEi(b|0)|0);k=rqd(h)|0;xri(h);if(!k){l=0;i=d;return l|0}Aod(j,b);k=j+1048|0;c[k>>2]=0;if(kn[c[(c[a>>2]|0)+8>>2]&511](a,j,0,0)|0){h=ke(c[k>>2]|0)|0;k=Dh(h|0,6)|0;Dh(h|0,12)|0;_n[c[(c[a>>2]|0)+28>>2]&4095](a,j)|0;m=(k|0)!=0}else m=1;Bod(j);l=m;i=d;return l|0}m=f+4|0;c[m>>2]=0;c[f+8>>2]=0;j=f+4|0;c[f>>2]=j;rri(g,b,SEi(b|0)|0);b=tqd(g,f)|0;xri(g);a:do if(b?(g=c[f>>2]|0,(g|0)!=(j|0)):0){k=g;while(1){if(Aqd(k+16|0)|0)break;g=c[k+4>>2]|0;if(!g){a=k;while(1){h=c[a+8>>2]|0;if((c[h>>2]|0)==(a|0)){n=h;break}else a=h}}else{a=g;while(1){h=c[a>>2]|0;if(!h){n=a;break}else a=h}}if((n|0)==(j|0))break a;else k=n}WN(f,c[m>>2]|0);l=1;i=d;return l|0}while(0);WN(f,c[m>>2]|0);l=0;i=d;return l|0}function _qd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+12|0;h=f;co[c[(c[b>>2]|0)+52>>2]&2047](g,b,d);if(!(a[g>>0]&1))j=g+1|0;else j=c[g+8>>2]|0;co[c[(c[b>>2]|0)+52>>2]&2047](h,b,e);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;e=Re(j|0,k|0)|0;xri(h);xri(g);i=f;return (e|0)==0|0}function $qd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;i=i+2160|0;e=a+1088|0;f=a+1080|0;g=a+1084|0;h=a+1096|0;j=a+16|0;k=a;l=a+8|0;uod(h);uod(j);if(xod(h,b,0,0)|0?xod(j,d,1,0)|0:0){d=nod(h)|0;b=H;m=b>>>0<0|(b|0)==0&d>>>0<65536;n=m?d:65536;if(n){m=c[153134]|0;c[f>>2]=m;c[e+0>>2]=c[f+0>>2];f=hOb(0,n,1,e,0,3653512,370)|0;a:do if((d|0)==0&(b|0)==0){o=1;p=9}else{q=0;r=0;while(1){if(!(ood(h,n,0,f,k)|0)){o=0;p=9;break a}s=k;if(!(pod(j,c[s>>2]|0,c[s+4>>2]|0,f,l)|0)){t=0;break a}s=l;q=_Ei(c[s>>2]|0,c[s+4>>2]|0,q|0,r|0)|0;r=H;if((q|0)==(d|0)&(r|0)==(b|0)){o=1;p=9;break}}}while(0);if((p|0)==9)t=(qod(j)|0)&o;if((n|0)>-1){c[g>>2]=m;c[e+0>>2]=c[g+0>>2];eOb(f,e);u=t}else u=t}else u=1}else u=0;vod(j);vod(h);i=a;return u|0}function ard(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;if((d|0)==2)f=629976;else if((d|0)==1)f=1067832;else if((d|0)==3)f=629984;else f=1067824;g=ed(b|0,f|0)|0;if(!((g|0)==0&(d|0)==2))if((g|0)!=0&(d|0)==3){yg(g|0,0,2)|0;h=g}else h=g;else h=ed(b|0,629992)|0;c[b+1048>>2]=h;c[b+1040>>2]=a;c[b+1044>>2]=a;i=e;return (h|0)!=0|0}function brd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0;g=i;e=c[b+1048>>2]|0;if(!e){k=0;i=g;return k|0}yg(e|0,d|0,0)|0;d=j;c[d>>2]=ik(h|0,1,f|0,e|0)|0;c[d+4>>2]=0;d=Zd(e|0)|0;c[b+1052>>2]=d;k=(d|0)==0;i=g;return k|0}function crd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=i;a=c[b+1048>>2]|0;if(!a){i=e;return 0}else{h=ik(f|0,1,d|0,a|0)|0;d=g;c[d>>2]=h;c[d+4>>2]=0;d=Zd(a|0)|0;c[b+1052>>2]=d;i=e;return (d|0)==0&(h|0)!=0|0}return 0}function drd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;d=b+1048|0;e=c[d>>2]|0;if(!e){f=1;i=a;return f|0}g=b+1052|0;c[g>>2]=0;c[d>>2]=0;if(!(dj(e|0)|0))h=c[g>>2]|0;else{e=c[(xd()|0)>>2]|0;c[g>>2]=e;h=e}f=(h|0)==0;i=a;return f|0}function erd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;e=i;k=c[b+1048>>2]|0;if(!k){l=0;i=e;return l|0}yg(k|0,d|0,0)|0;l=Km[c[(c[a>>2]|0)+24>>2]&127](a,b,f,g,h,j)|0;i=e;return l|0}function frd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;e=i;a=c[b+1048>>2]|0;if(!a){h=0;i=e;return h|0}j=g;c[j>>2]=_f(f|0,1,d|0,a|0)|0;c[j+4>>2]=0;j=Zd(a|0)|0;c[b+1052>>2]=j;h=(j|0)==0;i=e;return h|0}function grd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;a=c[b+1048>>2]|0;if(!a){g=0;i=e;return g|0}if((f|0)==2)h=1;else if((f|0)==3)h=2;else h=0;g=(yg(a|0,d|0,h|0)|0)==0;i=e;return g|0}function hrd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[b+1048>>2]|0;if(!d){e=0;f=0}else{b=Hc(d|0)|0;e=((b|0)<0)<<31>>31;f=b}H=e;i=a;return f|0}function ird(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+112|0;l=k;m=k+96|0;n=k+84|0;o=k+8|0;p=Dm(e|0)|0;if(!p){q=0;i=k;return q|0}rri(n,e,SEi(e|0)|0);e=a[n>>0]|0;r=(e&1)==0;if(r)s=(e&255)>>>1;else s=c[n+4>>2]|0;if(s){if(r){t=(e&255)>>>1;u=n+1|0}else{t=c[n+4>>2]|0;u=c[n+8>>2]|0}if((a[u+(t+-1)>>0]|0)!=47)v=10}else v=10;if((v|0)==10)Eri(n,63e4)|0;t=f+8|0;u=f+12|0;e=f+4|0;r=n+1|0;s=o+12|0;w=o+56|0;x=(j|0)==0;y=(j&8|0)==0;z=(j&2|0)==0;A=(j&32|0)==0;B=(j&16|0)==0;C=(j&4|0)==0;D=n+8|0;a:while(1){E=bf(p|0)|0;if(!E){F=1;break}G=E+11|0;if(!(HEi(G,3672776)|0))continue;if(!(HEi(G,630008)|0))continue;E=(c[t>>2]|0)+1|0;c[t>>2]=E;H=c[u>>2]|0;I=H&2147483647;if(E>>>0>I>>>0){J=H<<1;K=(J|0)==0?1:J;do if(I>>>0<K>>>0)if((H|0)>-1){c[u>>2]=K;J=c[f>>2]|0;c[m>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[f>>2]=hOb(J,K*1088|0,8,l,0,3653512,370)|0;break}else{c[m>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];J=cOb(K*1088|0,8,l,0,3653512,352)|0;YEi(J|0,c[f>>2]|0,(c[t>>2]|0)*1088|0)|0;c[u>>2]=K;c[f>>2]=J;break}while(0);L=c[t>>2]|0}else L=E;K=L+-1|0;H=c[f>>2]|0;I=H+(K*1088|0)|0;c[l>>2]=(a[n>>0]&1)==0?r:c[D>>2]|0;c[l+4>>2]=G;sEi(I,630016,l)|0;id(I|0,o|0)|0;J=c[s>>2]&61440;M=(J|0)==16384;a[H+(K*1088|0)+1080>>0]=M&1;a[H+(K*1088|0)+1081>>0]=(J|0)==40960&1;J=(a[G>>0]|0)==46;a[H+(K*1088|0)+1082>>0]=J&1;N=(c[w>>2]|0)+-2082844800|0;b[H+(K*1088|0)+1074>>1]=0;c[H+(K*1088|0)+1076>>2]=N;b[H+(K*1088|0)+1072>>1]=((N|0)<0)<<31>>31;do if(!x){do if(M)if(J)if(C){v=29;break}else break;else if(B){v=29;break}else break;else if(J)if(z){v=29;break}else break;else if(y){v=29;break}else break;while(0);if((v|0)==29){v=0;if(A)break;if((a[G>>0]|0)!=46)break}c[t>>2]=(c[t>>2]|0)+-1;continue a}while(0);if(!(M&g))continue;if(!(Km[c[(c[d>>2]|0)+148>>2]&127](d,I,f,g,h,j)|0)){F=0;break}}gi(p|0)|0;xri(n);q=F;i=k;return q|0}function jrd(a,b){a=a|0;b=b|0;b=i;rri(a,628584,SEi(628584)|0);i=b;return}function krd(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[b>>2]|0)+184>>2]&4095](a,b);i=d;return}function lrd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+12|0;g=e;In[c[(c[d>>2]|0)+180>>2]&4095](b,d);d=a[b>>0]|0;if(!(d&1))h=(d&255)>>>1;else h=c[b+4>>2]|0;if(!h){i=e;return}rri(g,630024,6);fsd(f,b,g);yri(b,f)|0;xri(f);xri(g);xqd(b)|0;i=e;return}function mrd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;In[c[(c[b>>2]|0)+160>>2]&4095](a,b);jsd(e,a);yri(a,e)|0;xri(e);i=d;return}function nrd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;In[c[(c[b>>2]|0)+172>>2]&4095](e,b);rri(f,2865792,7);fsd(a,e,f);xri(f);xri(e);i=d;return}function ord(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;In[c[(c[b>>2]|0)+164>>2]&4095](e,b);rri(f,2777952,4);fsd(a,e,f);xri(f);xri(e);i=d;return}function prd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+4|0;h=cj(630032)|0;rri(b,h,SEi(h|0)|0);h=a[b>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[b+4>>2]|0;if(!j){i=d;return}rri(g,630040,15);fsd(f,b,g);yri(b,f)|0;xri(f);xri(g);if(qqd(b)|0){i=d;return}if(!(a[b>>0]&1))k=b+1|0;else k=c[b+8>>2]|0;c[e>>2]=k;Ird(630056,e);if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;fi(l|0,448)|0;i=d;return}function qrd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function rrd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+48|0;e=d+24|0;f=d+12|0;g=d;c[157576]=a;c[157578]=b;rri(e,630320,9);srd(e)|0;xri(e);rri(f,630336,9);srd(f)|0;xri(f);rri(g,630352,12);srd(g)|0;xri(g);i=d;return}function srd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;if((c[157576]|0)<=0){f=0;i=d;return f|0}g=e+1|0;h=e+8|0;j=0;while(1){k=(c[157578]|0)+(j<<2)|0;_ri(e,630368,b);l=(Gsd(c[k>>2]|0,(a[e>>0]&1)==0?g:c[h>>2]|0)|0)==0;xri(e);j=j+1|0;if(l){f=1;m=5;break}if((j|0)>=(c[157576]|0)){f=0;m=5;break}}if((m|0)==5){i=d;return f|0}return 0}function trd(){return c[157576]|0}function urd(){return c[157578]|0}function vrd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+12|0;g=e;c[b>>2]=0;h=b+4|0;c[h>>2]=0;j=b+8|0;c[j>>2]=0;Dmd(b,c[157576]|0);if((c[157576]|0)<=0){i=e;return}k=g+1|0;l=g+8|0;m=0;n=0;while(1){o=(c[157578]|0)+(n<<2)|0;if(m){p=c[o>>2]|0;if((a[p>>0]|0)==45){q=13;break}rri(f,p,SEi(p|0)|0);p=c[h>>2]|0;if((p|0)==(c[j>>2]|0))nO(b,f);else{if(!p)r=0;else{sri(p,f);r=c[h>>2]|0}c[h>>2]=r+12}xri(f);s=1}else{_ri(g,630368,d);p=Gsd(c[o>>2]|0,(a[g>>0]&1)==0?k:c[l>>2]|0)|0;xri(g);s=(p|0)==0}n=n+1|0;if((n|0)>=(c[157576]|0)){q=13;break}else m=s}if((q|0)==13){i=e;return}}function wrd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;vrd(e,b);b=c[e>>2]|0;f=e+4|0;if((b|0)==(c[f>>2]|0)){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g=b}else{sri(a,b);g=c[e>>2]|0}if(!g){i=d;return}while(1){b=c[f>>2]|0;if((b|0)==(g|0))break;a=b+-12|0;c[f>>2]=a;xri(a)}ACi(c[e>>2]|0);i=d;return}function xrd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=ADi(1024)|0;d=0;do{e=b+(d<<2)|0;f=(d>>>7&1|(d>>>5&2|(d>>>3&4|(d>>>1&8|(d<<1&16|(d<<3&32|(d<<5&64|d<<7&128)))))))<<25;g=(d<<31>>31&79764919^f)<<1;h=(f>>31&79764919^g)<<1;f=(g>>31&79764919^h)<<1;g=(h>>31&79764919^f)<<1;h=(f>>31&79764919^g)<<1;f=(g>>31&79764919^h)<<1;g=f>>31&79764919^(h>>31&79764919^f)<<1;c[e>>2]=g;f=g;g=1;h=0;while(1){if(!(f&1))j=h;else j=1<<32-g|h;if((g|0)==32){k=j;break}else{f=f>>>1;g=g+1|0;h=j}}c[e>>2]=k;d=d+1|0}while((d|0)!=256);i=a;return b|0}function yrd(){return -1}function zrd(a){a=a|0;return ~a|0}function Ard(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[157594]|0;if(!g){h=xrd()|0;c[157594]=h;j=h}else j=g;if(!e){k=a;i=f;return k|0}else{l=b;m=a;n=e}while(1){n=n+-1|0;e=c[j+(((d[l>>0]|0)^m&255)<<2)>>2]^m>>>8;if(!n){k=e;break}else{l=l+1|0;m=e}}i=f;return k|0}function Brd(a){a=a|0;b[a>>1]=0;c[a+4>>2]=0;b[a+2>>1]=0;return}function Crd(b){b=b|0;var c=0,d=0;c=i;d=b+0|0;b=d+16|0;do{a[d>>0]=0;d=d+1|0}while((d|0)<(b|0));i=c;return}function Drd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;b=i;g=c[157596]|0;if((g|0)>99)rl(-1);else{c[630396+(g<<4)>>2]=d;c[630400+(g<<4)>>2]=e;c[630392+(g<<4)>>2]=f;a[630404+(g<<4)>>0]=0;c[157596]=g+1;i=b;return}}function Erd(){var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;Frd(630392,630392+(c[157596]<<4)|0,b);d=c[157596]|0;if((d|0)>0){e=d;f=0}else{i=b;return}while(1){d=c[630396+(f<<4)>>2]|0;if((d|0)!=0?(g=630404+(f<<4)|0,(a[g>>0]|0)==0):0){eo[d&511]();a[g>>0]=1;h=c[157596]|0}else h=e;f=f+1|0;if((f|0)>=(h|0))break;else e=h}i=b;return}function Frd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=i;i=i+32|0;f=e+16|0;g=e;h=a;a=b;a:while(1){b=a;j=a+-16|0;k=h;b:while(1){l=k;m=b-l|0;n=m>>4;switch(n|0){case 5:{o=k;p=j;q=j;r=15;break a;break}case 2:{s=k;t=j;u=j;r=4;break a;break}case 4:{v=k;w=j;r=14;break a;break}case 1:case 0:{r=84;break a;break}case 3:{x=k;y=j;z=j;r=6;break a;break}default:{}}if((m|0)<496){A=k;B=a;r=21;break a}C=(n|0)/2|0;D=k+(C<<4)|0;do if((m|0)>15984){E=(n|0)/4|0;F=k+(E<<4)|0;G=k+(E+C<<4)|0;E=Grd(k,F,D,G,d)|0;if((c[j>>2]|0)>=(c[G>>2]|0)){H=D;I=E;break};c[f+0>>2]=c[G+0>>2];c[f+4>>2]=c[G+4>>2];c[f+8>>2]=c[G+8>>2];c[f+12>>2]=c[G+12>>2];c[G+0>>2]=c[j+0>>2];c[G+4>>2]=c[j+4>>2];c[G+8>>2]=c[j+8>>2];c[G+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];J=E+1|0;if((c[G>>2]|0)<(c[D>>2]|0)){c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];c[D+12>>2]=c[G+12>>2];c[G+0>>2]=c[f+0>>2];c[G+4>>2]=c[f+4>>2];c[G+8>>2]=c[f+8>>2];c[G+12>>2]=c[f+12>>2];G=E+2|0;if((c[D>>2]|0)<(c[F>>2]|0)){c[f+0>>2]=c[F+0>>2];c[f+4>>2]=c[F+4>>2];c[f+8>>2]=c[F+8>>2];c[f+12>>2]=c[F+12>>2];c[F+0>>2]=c[D+0>>2];c[F+4>>2]=c[D+4>>2];c[F+8>>2]=c[D+8>>2];c[F+12>>2]=c[D+12>>2];c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];if((c[F>>2]|0)<(c[k>>2]|0)){c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[F+0>>2];c[k+4>>2]=c[F+4>>2];c[k+8>>2]=c[F+8>>2];c[k+12>>2]=c[F+12>>2];c[F+0>>2]=c[f+0>>2];c[F+4>>2]=c[f+4>>2];c[F+8>>2]=c[f+8>>2];c[F+12>>2]=c[f+12>>2];H=D;I=E+4|0}else{H=D;I=E+3|0}}else{H=D;I=G}}else{H=D;I=J}}else{J=c[D>>2]|0;G=(c[j>>2]|0)<(J|0);if((J|0)>=(c[k>>2]|0)){if(!G){H=D;I=0;break};c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];c[D+0>>2]=c[j+0>>2];c[D+4>>2]=c[j+4>>2];c[D+8>>2]=c[j+8>>2];c[D+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];if((c[D>>2]|0)>=(c[k>>2]|0)){H=D;I=1;break};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];H=D;I=2;break}if(G){c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];H=D;I=1;break};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];if((c[j>>2]|0)<(c[D>>2]|0)){c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];c[D+0>>2]=c[j+0>>2];c[D+4>>2]=c[j+4>>2];c[D+8>>2]=c[j+8>>2];c[D+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];H=D;I=2}else{H=D;I=1}}while(0);C=c[k>>2]|0;n=c[H>>2]|0;do if((C|0)<(n|0)){K=j;L=I}else{m=a;G=j;while(1){J=m+-32|0;if((k|0)==(J|0))break;if((c[J>>2]|0)<(n|0)){M=J;r=66;break}else{E=G;G=J;m=E}}if((r|0)==66){r=0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[M+0>>2];c[k+4>>2]=c[M+4>>2];c[k+8>>2]=c[M+8>>2];c[k+12>>2]=c[M+12>>2];c[M+0>>2]=c[f+0>>2];c[M+4>>2]=c[f+4>>2];c[M+8>>2]=c[f+8>>2];c[M+12>>2]=c[f+12>>2];K=M;L=I+1|0;break}m=k+16|0;if((C|0)<(c[j>>2]|0))N=m;else{if((m|0)==(j|0)){r=84;break a}else{O=k;P=m}while(1){m=O+32|0;if((C|0)<(c[P>>2]|0)){Q=P;break}if((m|0)==(j|0)){r=84;break a}else{G=P;P=m;O=G}}c[f+0>>2]=c[Q+0>>2];c[f+4>>2]=c[Q+4>>2];c[f+8>>2]=c[Q+8>>2];c[f+12>>2]=c[Q+12>>2];c[Q+0>>2]=c[j+0>>2];c[Q+4>>2]=c[j+4>>2];c[Q+8>>2]=c[j+8>>2];c[Q+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];N=Q+16|0}if((N|0)==(j|0)){r=84;break a}else{R=N;S=j}while(1){G=c[k>>2]|0;m=R;while(1){E=m+16|0;if((G|0)<(c[m>>2]|0)){T=E;U=m;break}else m=E}m=S;while(1){E=m+-16|0;if((G|0)<(c[E>>2]|0))m=E;else{V=E;break}}if(U>>>0>=V>>>0){k=U;continue b};c[f+0>>2]=c[U+0>>2];c[f+4>>2]=c[U+4>>2];c[f+8>>2]=c[U+8>>2];c[f+12>>2]=c[U+12>>2];c[U+0>>2]=c[V+0>>2];c[U+4>>2]=c[V+4>>2];c[U+8>>2]=c[V+8>>2];c[U+12>>2]=c[V+12>>2];c[V+0>>2]=c[f+0>>2];c[V+4>>2]=c[f+4>>2];c[V+8>>2]=c[f+8>>2];c[V+12>>2]=c[f+12>>2];R=T;S=V}}while(0);C=k+16|0;c:do if(C>>>0<K>>>0){n=C;m=K;G=D;E=L;while(1){J=c[G>>2]|0;F=n;while(1){W=F+16|0;if((c[F>>2]|0)<(J|0))F=W;else{X=W;Y=F;break}}F=m;while(1){W=F+-16|0;if((c[W>>2]|0)<(J|0)){Z=W;break}else F=W}if(Y>>>0>Z>>>0){_=Y;$=G;aa=E;break c};c[f+0>>2]=c[Y+0>>2];c[f+4>>2]=c[Y+4>>2];c[f+8>>2]=c[Y+8>>2];c[f+12>>2]=c[Y+12>>2];c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];c[Z+0>>2]=c[f+0>>2];c[Z+4>>2]=c[f+4>>2];c[Z+8>>2]=c[f+8>>2];c[Z+12>>2]=c[f+12>>2];n=X;m=Z;G=(G|0)==(Y|0)?Z:G;E=E+1|0}}else{_=C;$=D;aa=L}while(0);if((_|0)!=($|0)?(c[$>>2]|0)<(c[_>>2]|0):0){c[f+0>>2]=c[_+0>>2];c[f+4>>2]=c[_+4>>2];c[f+8>>2]=c[_+8>>2];c[f+12>>2]=c[_+12>>2];c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];c[$+0>>2]=c[f+0>>2];c[$+4>>2]=c[f+4>>2];c[$+8>>2]=c[f+8>>2];c[$+12>>2]=c[f+12>>2];ba=aa+1|0}else ba=aa;if(!ba){ca=Hrd(k,_,d)|0;D=_+16|0;if(Hrd(D,a,d)|0){r=79;break}if(ca){k=D;continue}}D=_;if((D-l|0)>=(b-D|0)){da=k;ea=_;r=83;break}Frd(k,_,d);k=_+16|0}if((r|0)==79){r=0;if(ca){r=84;break}else{h=k;a=_;continue}}else if((r|0)==83){r=0;Frd(ea+16|0,a,d);h=da;a=ea;continue}}if((r|0)==4){if((c[t>>2]|0)>=(c[s>>2]|0)){i=e;return};c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];i=e;return}else if((r|0)==6){u=x+16|0;s=c[u>>2]|0;t=(c[y>>2]|0)<(s|0);if((s|0)>=(c[x>>2]|0)){if(!t){i=e;return};c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[f+12>>2]=c[u+12>>2];c[u+0>>2]=c[z+0>>2];c[u+4>>2]=c[z+4>>2];c[u+8>>2]=c[z+8>>2];c[u+12>>2]=c[z+12>>2];c[z+0>>2]=c[f+0>>2];c[z+4>>2]=c[f+4>>2];c[z+8>>2]=c[f+8>>2];c[z+12>>2]=c[f+12>>2];if((c[u>>2]|0)>=(c[x>>2]|0)){i=e;return};c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[x+0>>2]=c[u+0>>2];c[x+4>>2]=c[u+4>>2];c[x+8>>2]=c[u+8>>2];c[x+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];i=e;return}if(t){c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[z+0>>2]=c[f+0>>2];c[z+4>>2]=c[f+4>>2];c[z+8>>2]=c[f+8>>2];c[z+12>>2]=c[f+12>>2];i=e;return};c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[x+0>>2]=c[u+0>>2];c[x+4>>2]=c[u+4>>2];c[x+8>>2]=c[u+8>>2];c[x+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];if((c[y>>2]|0)>=(c[u>>2]|0)){i=e;return};c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[f+12>>2]=c[u+12>>2];c[u+0>>2]=c[z+0>>2];c[u+4>>2]=c[z+4>>2];c[u+8>>2]=c[z+8>>2];c[u+12>>2]=c[z+12>>2];c[z+0>>2]=c[f+0>>2];c[z+4>>2]=c[f+4>>2];c[z+8>>2]=c[f+8>>2];c[z+12>>2]=c[f+12>>2];i=e;return}else if((r|0)==14){Grd(v,v+16|0,v+32|0,w,d)|0;i=e;return}else if((r|0)==15){w=o+16|0;v=o+32|0;z=o+48|0;Grd(o,w,v,z,d)|0;if((c[p>>2]|0)>=(c[z>>2]|0)){i=e;return};c[f+0>>2]=c[z+0>>2];c[f+4>>2]=c[z+4>>2];c[f+8>>2]=c[z+8>>2];c[f+12>>2]=c[z+12>>2];c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];if((c[z>>2]|0)>=(c[v>>2]|0)){i=e;return};c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[z+0>>2];c[v+4>>2]=c[z+4>>2];c[v+8>>2]=c[z+8>>2];c[v+12>>2]=c[z+12>>2];c[z+0>>2]=c[f+0>>2];c[z+4>>2]=c[f+4>>2];c[z+8>>2]=c[f+8>>2];c[z+12>>2]=c[f+12>>2];if((c[v>>2]|0)>=(c[w>>2]|0)){i=e;return};c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];if((c[w>>2]|0)>=(c[o>>2]|0)){i=e;return};c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];i=e;return}else if((r|0)==21){w=A+32|0;o=A+16|0;v=c[o>>2]|0;z=c[A>>2]|0;q=c[w>>2]|0;p=(q|0)<(v|0);do if((v|0)<(z|0)){if(p){c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];c[A+0>>2]=c[o+0>>2];c[A+4>>2]=c[o+4>>2];c[A+8>>2]=c[o+8>>2];c[A+12>>2]=c[o+12>>2];c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];if((q|0)<(c[o>>2]|0)){c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2]}}else if(p?(c[f+0>>2]=c[o+0>>2],c[f+4>>2]=c[o+4>>2],c[f+8>>2]=c[o+8>>2],c[f+12>>2]=c[o+12>>2],c[o+0>>2]=c[w+0>>2],c[o+4>>2]=c[w+4>>2],c[o+8>>2]=c[w+8>>2],c[o+12>>2]=c[w+12>>2],c[w+0>>2]=c[f+0>>2],c[w+4>>2]=c[f+4>>2],c[w+8>>2]=c[f+8>>2],c[w+12>>2]=c[f+12>>2],(c[o>>2]|0)<(z|0)):0){c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];c[A+0>>2]=c[o+0>>2];c[A+4>>2]=c[o+4>>2];c[A+8>>2]=c[o+8>>2];c[A+12>>2]=c[o+12>>2];c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2]}while(0);f=A+48|0;if((f|0)==(B|0)){i=e;return}else{fa=f;ga=w}while(1){w=c[fa>>2]|0;if((w|0)<(c[ga>>2]|0)){f=fa+4|0;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];f=fa;o=ga;while(1){c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];if((o|0)==(A|0)){ha=A;break}z=o+-16|0;if((w|0)<(c[z>>2]|0)){p=o;o=z;f=p}else{ha=o;break}}c[ha>>2]=w;o=ha+4|0;c[o+0>>2]=c[g+0>>2];c[o+4>>2]=c[g+4>>2];c[o+8>>2]=c[g+8>>2]}o=fa+16|0;if((o|0)==(B|0))break;else{f=fa;fa=o;ga=f}}i=e;return}else if((r|0)==84){i=e;return}}function Grd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=c[b>>2]|0;j=(c[d>>2]|0)<(h|0);do if((h|0)<(c[a>>2]|0)){if(j){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];k=1;break};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];if((c[d>>2]|0)<(c[b>>2]|0)){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];k=2}else k=1}else if(j){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];if((c[b>>2]|0)<(c[a>>2]|0)){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];k=2}else k=1}else k=0;while(0);if((c[e>>2]|0)>=(c[d>>2]|0)){l=k;i=f;return l|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if((c[d>>2]|0)>=(c[b>>2]|0)){l=k+1|0;i=f;return l|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];if((c[b>>2]|0)>=(c[a>>2]|0)){l=k+2|0;i=f;return l|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];l=k+3|0;i=f;return l|0}function Hrd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+16|0;g=e;switch(b-a>>4|0){case 1:case 0:{h=1;i=e;return h|0}case 3:{j=a+16|0;k=b+-16|0;l=c[j>>2]|0;m=(c[k>>2]|0)<(l|0);if((l|0)>=(c[a>>2]|0)){if(!m){h=1;i=e;return h|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];if((c[j>>2]|0)>=(c[a>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];h=1;i=e;return h|0}if(m){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];if((c[k>>2]|0)>=(c[j>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];h=1;i=e;return h|0}case 5:{k=a+16|0;j=a+32|0;m=a+48|0;l=b+-16|0;Grd(a,k,j,m,d)|0;if((c[l>>2]|0)>=(c[m>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];if((c[m>>2]|0)>=(c[j>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];if((c[j>>2]|0)>=(c[k>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];if((c[k>>2]|0)>=(c[a>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];h=1;i=e;return h|0}case 2:{k=b+-16|0;if((c[k>>2]|0)>=(c[a>>2]|0)){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];h=1;i=e;return h|0}case 4:{Grd(a,a+16|0,a+32|0,b+-16|0,d)|0;h=1;i=e;return h|0}default:{d=a+32|0;k=a+16|0;j=c[k>>2]|0;m=c[a>>2]|0;l=c[d>>2]|0;n=(l|0)<(j|0);do if((j|0)<(m|0)){if(n){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];if((l|0)<(c[k>>2]|0)){c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2]}}else if(n?(c[f+0>>2]=c[k+0>>2],c[f+4>>2]=c[k+4>>2],c[f+8>>2]=c[k+8>>2],c[f+12>>2]=c[k+12>>2],c[k+0>>2]=c[d+0>>2],c[k+4>>2]=c[d+4>>2],c[k+8>>2]=c[d+8>>2],c[k+12>>2]=c[d+12>>2],c[d+0>>2]=c[f+0>>2],c[d+4>>2]=c[f+4>>2],c[d+8>>2]=c[f+8>>2],c[d+12>>2]=c[f+12>>2],(c[k>>2]|0)<(m|0)):0){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2]}while(0);f=a+48|0;if((f|0)==(b|0)){h=1;i=e;return h|0}k=0;m=f;f=d;while(1){d=c[m>>2]|0;if((d|0)<(c[f>>2]|0)){n=m+4|0;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=m;l=f;while(1){c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];if((l|0)==(a|0)){o=a;break}j=l+-16|0;if((d|0)<(c[j>>2]|0)){p=l;l=j;n=p}else{o=l;break}}c[o>>2]=d;l=o+4|0;c[l+0>>2]=c[g+0>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];l=k+1|0;if((l|0)==8){q=m;break}else r=l}else r=k;l=m+16|0;if((l|0)==(b|0)){h=1;s=35;break}else{n=m;k=r;m=l;f=n}}if((s|0)==35){i=e;return h|0}h=(q+16|0)==(b|0);i=e;return h|0}}return 0}function Ird(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d;c[f>>2]=b;c[e>>2]=c[f>>2];if(0!=0?!(fa(5,a|0,e|0)|0):0){i=d;return}f=c[157998]|0;if(!f){b=c[r>>2]|0;c[157998]=b;if(!b){i=d;return}else g=b}else g=f;lg(g|0,a|0,e|0)|0;Wg(c[157998]|0)|0;i=d;return}function Jrd(a){a=a|0;c[158002]=a;return}function Krd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;i=i+48|0;l=k+24|0;m=k+12|0;n=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Mrd(a,m+1|0,l+1|0,b,d,e,f,g,h,j);xri(n);xri(m);xri(l);i=k;return}function Lrd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;if(!0){i=e;return}g=c[1]|0;if(!g){i=e;return}h=g;do{c[f>>2]=d;xo[c[h+8>>2]&2047](a,b,f)|0;h=c[h+4>>2]|0}while((h|0)!=0);i=e;return}function Mrd(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;n=i;i=i+80|0;o=n;p=n+56|0;q=n+44|0;r=n+32|0;s=n+20|0;t=n+8|0;if(!(j&131072))if(!(j&1059153))if(!(j&2))u=(j&4736|0)==0?3:2;else u=1;else u=0;else u=4;if((c[158e3]|0)==1){i=n;return}c[158e3]=1;if(0){rri(p,b,SEi(b|0)|0);rri(q,d,SEi(d|0)|0);fa(p|0,q|0,u|0);xri(q);xri(p)}rri(r,b,SEi(b|0)|0);if(e){Eri(r,1072968)|0;Eri(r,e)|0}rri(s,b,SEi(b|0)|0);if(d){Eri(s,1072968)|0;Eri(s,d)|0}if(!f){c[o>>2]=b;Lrd(u,632040,o)}else{c[o>>2]=b;c[o+4>>2]=f;Lrd(u,632016,o)}if(!(a[s>>0]&1))v=s+1|0;else v=c[s+8>>2]|0;c[o>>2]=v;Lsd(t,653152,o);if(!(a[t>>0]&1))w=t+1|0;else w=c[t+8>>2]|0;pi(w|0,u|0);xri(t);if(0)fa(s|0,f|0,g|0,h|0,j|0,k|0,l|0,m|0);c[158e3]=0;xri(s);xri(r);i=n;return}function Nrd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e;g=e+4|0;h=(d|0)==-1;j=b;while(1){b=a[j>>0]|0;if(!(b<<24>>24==10|b<<24>>24==13)){k=j;break}j=j+1|0}j=h?1023:d;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;d=a[k>>0]|0;if(!(d<<24>>24)){xri(g);i=e;return}h=g+1|0;b=g+8|0;l=d;d=k;while(1){k=l;m=d;while(1){if(k<<24>>24==0|k<<24>>24==10|k<<24>>24==13){n=k;o=m;break}p=m+1|0;k=a[p>>0]|0;m=p}m=d;if((o-m|0)>(j|0)){k=d+j|0;q=a[k>>0]|0;r=k}else{q=n;r=o}Ari(g,d,r-m|0)|0;c[f>>2]=(a[g>>0]&1)==0?h:c[b>>2]|0;Ird(653152,f);a:do if(q<<24>>24==10|q<<24>>24==13){m=r;while(1){k=a[m>>0]|0;if(!(k<<24>>24==10|k<<24>>24==13)){s=k;t=m;break a}m=m+1|0}}else{s=a[r>>0]|0;t=r}while(0);if(!(s<<24>>24))break;else{l=s;d=t}}xri(g);i=e;return}function Ord(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+24|0;h=f+4|0;j=f;do if(c[158012]|0){sri(h,b);c[h+12>>2]=d;c[h+16>>2]=e;Qrd(j,c[158012]|0,h);k=c[158012]|0;if((c[j>>2]|0)==(k+4|0)){Rrd(g,k,h);xri(h);break}xri(h);i=f;return}while(0);if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;Krd(l,0,3653512,0,d,e,0,0);i=f;return}function Prd(){var a=0,b=0,d=0;a=i;b=c[158012]|0;if(!b){i=a;return}Srd(b,c[b+4>>2]|0);c[b+8>>2]=0;d=b+4|0;c[b>>2]=d;c[d>>2]=0;i=a;return}function Qrd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;g=f;h=d+4|0;Vrd(g,d,e,c[d+4>>2]|0,h);d=c[g>>2]|0;a:do if((d|0)!=(h|0)){g=d+16|0;j=c[e+16>>2]|0;k=c[d+32>>2]|0;do if((j|0)==(k|0)){l=c[e+12>>2]|0;m=c[d+28>>2]|0;if((l|0)!=(m|0))if((l|0)<(m|0))break a;else break;m=a[e>>0]|0;l=(m&1)==0;if(l)n=(m&255)>>>1;else n=c[e+4>>2]|0;m=a[g>>0]|0;o=(m&1)==0;if(o)p=(m&255)>>>1;else p=c[d+20>>2]|0;if(l)q=e+1|0;else q=c[e+8>>2]|0;if(o)r=g+1|0;else r=c[d+24>>2]|0;o=FEi(q,r,p>>>0<n>>>0?p:n)|0;if(!o)if(n>>>0<p>>>0)break a;else break;else if((o|0)<0)break a;else break}else if((j|0)<(k|0))break a;while(0);c[b>>2]=d;i=f;return}while(0);c[b>>2]=h;i=f;return}function Rrd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=Wrd(d,j,e)|0;l=c[k>>2]|0;if(l){m=0;n=l;c[b>>2]=n;o=b+4|0;a[o>>0]=m;i=f;return}c[h>>2]=62;c[g+0>>2]=c[h+0>>2];h=cOb(36,16,g,0,3653512,80)|0;sri(h+16|0,e);g=e+12|0;e=c[g+4>>2]|0;l=h+28|0;c[l>>2]=c[g>>2];c[l+4>>2]=e;e=c[j>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=e;c[k>>2]=h;e=c[c[d>>2]>>2]|0;if(!e)p=h;else{c[d>>2]=e;p=c[k>>2]|0}GN(c[d+4>>2]|0,p);p=d+8|0;c[p>>2]=(c[p>>2]|0)+1;m=1;n=h;c[b>>2]=n;o=b+4|0;a[o>>0]=m;i=f;return}function Srd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}Srd(a,c[b>>2]|0);Srd(a,c[b+4>>2]|0);xri(b+16|0);c[f>>2]=62;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Trd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153124];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,1,16,3653512,38)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[158012]=d;i=a;return}function Urd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[158012]|0;f=c[153124]|0;if(e)Srd(e,c[e+4>>2]|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[158012]=0;i=a;return}function Vrd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=c[e+16>>2]|0;k=c[e+12>>2]|0;l=a[e>>0]|0;m=(l&1)==0;n=(l&255)>>>1;l=e+1|0;o=c[e+8>>2]|0;p=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(m){f=g;while(1){q=f+16|0;r=c[f+32>>2]|0;do if((r|0)==(j|0)){s=c[f+28>>2]|0;if((s|0)!=(k|0))if((s|0)<(k|0))break;else{t=f;break b}s=a[q>>0]|0;if(!(s&1)){u=(s&255)>>>1;v=q+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}s=FEi(v,l,n>>>0<u>>>0?n:u)|0;if(!s)if(u>>>0<n>>>0)break;else{t=f;break b}else if((s|0)<0)break;else{t=f;break b}}else if((r|0)>=(j|0)){t=f;break b}while(0);f=c[f+4>>2]|0;if(!f){h=e;w=27;break a}}}else{f=g;while(1){r=f+16|0;q=c[f+32>>2]|0;do if((q|0)==(j|0)){s=c[f+28>>2]|0;if((s|0)!=(k|0))if((s|0)<(k|0))break;else{t=f;break b}s=a[r>>0]|0;if(!(s&1)){x=(s&255)>>>1;y=r+1|0}else{x=c[f+20>>2]|0;y=c[f+24>>2]|0}s=FEi(y,o,p>>>0<x>>>0?p:x)|0;if(!s)if(x>>>0<p>>>0)break;else{t=f;break b}else if((s|0)<0)break;else{t=f;break b}}else if((q|0)>=(j|0)){t=f;break b}while(0);f=c[f+4>>2]|0;if(!f){h=e;w=27;break a}}}while(0);g=c[t>>2]|0;if(!g){h=t;w=27;break}else e=t}if((w|0)==27){c[b>>2]=h;i=d;return}}function Wrd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=c[e+16>>2]|0;b=c[e+12>>2]|0;k=a[e>>0]|0;l=(k&1)==0;m=(k&255)>>>1;k=e+1|0;n=c[e+8>>2]|0;o=c[e+4>>2]|0;e=g;a:while(1){g=e+16|0;p=c[e+32>>2]|0;q=(h|0)==(p|0);do if(q){r=c[e+28>>2]|0;if((b|0)==(r|0)){s=l?m:o;t=a[g>>0]|0;u=(t&1)==0;if(u)v=(t&255)>>>1;else v=c[e+20>>2]|0;if(u)w=g+1|0;else w=c[e+24>>2]|0;u=FEi(l?k:n,w,v>>>0<s>>>0?v:s)|0;if(!u){if(s>>>0<v>>>0){x=16;break}}else if((u|0)<0){x=16;break}if(!q){x=19;break}}else if((b|0)<(r|0)){x=16;break}r=c[e+28>>2]|0;if((r|0)!=(b|0))if((r|0)<(b|0))break;else{y=e;x=33;break a}r=a[g>>0]|0;u=(r&1)==0;if(u)z=(r&255)>>>1;else z=c[e+20>>2]|0;r=l?m:o;if(u)A=g+1|0;else A=c[e+24>>2]|0;u=FEi(A,l?k:n,r>>>0<z>>>0?r:z)|0;if(!u)if(z>>>0<r>>>0)break;else{y=e;x=33;break a}else if((u|0)<0)break;else{y=e;x=33;break a}}else if((h|0)<(p|0))x=16;else x=19;while(0);if((x|0)==16){x=0;g=c[e>>2]|0;if(!g){B=e;C=e;x=17;break}else{e=g;continue}}else if((x|0)==19?(x=0,(p|0)>=(h|0)):0){y=e;x=33;break}g=e+4|0;q=c[g>>2]|0;if(!q){D=g;E=e;x=32;break}else e=q}if((x|0)==17){c[d>>2]=C;j=B;i=f;return j|0}else if((x|0)==32){c[d>>2]=E;j=D;i=f;return j|0}else if((x|0)==33){c[d>>2]=y;j=d;i=f;return j|0}return 0}function Xrd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,9)|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[158014]=d;i=a;return}function Yrd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[158014]|0;g=f+4|0;h=c[g>>2]|0;j=c[f>>2]|0;if((h|0)==(j|0)){k=f;l=g;m=h;n=h}else{h=j;j=0;while(1){g=c[h+(j<<2)>>2]|0;f=c[153126]|0;if(g)$rd(g);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(g,b);c[(c[c[158014]>>2]|0)+(j<<2)>>2]=0;j=j+1|0;g=c[158014]|0;f=g+4|0;o=c[f>>2]|0;p=c[g>>2]|0;if(j>>>0>=o-p>>2>>>0){k=g;l=f;m=p;n=o;break}else h=p}}h=c[153126]|0;if((k|0)==0|(m|0)==0){c[e>>2]=h;c[b+0>>2]=c[e+0>>2];eOb(k,b);c[158014]=0;i=a;return}if((n|0)!=(m|0))c[l>>2]=n+(~((n+-4-m|0)>>>2)<<2);c[d>>2]=64;c[b+0>>2]=c[d+0>>2];eOb(m,b);c[e>>2]=h;c[b+0>>2]=c[e+0>>2];eOb(k,b);c[158014]=0;i=a;return}function Zrd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;c[d>>2]=a;e=c[158014]|0;f=e+4|0;g=c[f>>2]|0;if((g|0)==(c[e+8>>2]|0)){esd(e,d);i=b;return}if(!g)h=0;else{c[g>>2]=a;h=c[f>>2]|0}c[f>>2]=h+4;i=b;return}function _rd(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;e=c[h>>2]|0;c[b+12>>2]=0;c[b+16>>2]=e;c[b+20>>2]=0;c[b+24>>2]=0;c[b+36>>2]=i;c[b+40>>2]=e;e=(f|0)<4?4:f;c[b>>2]=e;f=g+4095&-4096;c[b+4>>2]=f;c[b+8>>2]=(f>>>0)/(e>>>0)|0;a[b+32>>0]=1;c[b+28>>2]=0;return}function $rd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+12|0;h=c[g>>2]|0;j=a+20|0;k=c[j>>2]|0;l=h+(k<<2)|0;if(k){k=a+40|0;m=h;do{h=c[m>>2]|0;c[f>>2]=c[k>>2];c[d+0>>2]=c[f+0>>2];eOb(h,d);m=m+4|0}while((m|0)!=(l|0))}l=a+24|0;if((c[l>>2]|0)>-1){m=c[g>>2]|0;c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];eOb(m,d);c[g>>2]=0}c[j>>2]=0;c[l>>2]=0;c[a+28>>2]=0;l=c[g>>2]|0;c[e>>2]=c[a+16>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[g>>2]=0;i=b;return}function asd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;if(!(a[b+32>>0]|0)){i=d;return}h=c[b+4>>2]|0;j=c[b+36>>2]|0;c[g>>2]=c[b+40>>2];c[e+0>>2]=c[g+0>>2];g=cOb(h,j,e,0,3653512,100)|0;j=b+12|0;h=b+20|0;k=(c[h>>2]|0)+1|0;c[h>>2]=k;l=b+24|0;m=c[l>>2]|0;n=m&2147483647;if(k>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[l>>2]=p;o=c[j>>2]|0;c[f>>2]=c[b+16>>2];c[e+0>>2]=c[f+0>>2];c[j>>2]=hOb(o,p<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+16>>2];c[e+0>>2]=c[f+0>>2];o=cOb(p<<2,4,e,0,3653512,352)|0;YEi(o|0,c[j>>2]|0,c[h>>2]<<2|0)|0;c[l>>2]=p;c[j>>2]=o;break}while(0);q=c[h>>2]|0}else q=k;c[(c[j>>2]|0)+(q+-1<<2)>>2]=g;q=b+28|0;j=c[q>>2]|0;c[q>>2]=g;k=(c[b+8>>2]|0)+-1|0;if((k|0)>0){h=c[b>>2]|0;b=g+(da(h,(k|0)>1?k:1)|0)|0;p=0;l=g;do{e=l;l=l+h|0;c[e>>2]=l;p=p+1|0}while((p|0)<(k|0));r=b}else r=g;c[r>>2]=j;if(c[q>>2]|0){i=d;return}Krd(632064,0,3653512,123,1,0,0,0);i=d;return}function bsd(a){a=a|0;var b=0,d=0;b=i;d=csd(a,c[a>>2]|0)|0;i=b;return d|0}function csd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=e+8|0;h=c[b>>2]|0;if(h>>>0<d>>>0){c[f>>2]=d;c[f+4>>2]=h;Lsd(g,632080,f);if(!(a[g>>0]&1))j=g+1|0;else j=c[g+8>>2]|0;Krd(j,0,3653512,142,1,0,0,0);xri(g);k=0;i=e;return k|0}else{g=b+28|0;j=c[g>>2]|0;if(!j){asd(b);b=c[g>>2]|0;if(!b){k=0;i=e;return k|0}else l=b}else l=j;c[g>>2]=c[l>>2];k=l;i=e;return k|0}return 0}function dsd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){i=d;return}e=a+28|0;c[b>>2]=c[e>>2];c[e>>2]=b;i=d;return}function esd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>2)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>2>>>0<1073741823){m=h>>1;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>2;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>2;s=6}if((s|0)==6){c[f>>2]=64;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<2,16,e,0,3653512,80)|0;p=r}r=o+(p<<2)|0;if(r)c[r>>2]=c[b>>2];b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>2)<<2)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<2);c[k>>2]=o+(n<<2);if(!r){i=d;return}c[f>>2]=64;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function fsd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;nsd(b,d,a);i=e;return}function gsd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a[d>>0]|0;if(!(f&1)){g=(f&255)>>>1;h=d+1|0}else{g=c[d+4>>2]|0;h=c[d+8>>2]|0}a:do if(!g)j=3653512;else{d=0;while(1){f=g-d|0;k=a[h+(f+-1)>>0]|0;if(k<<24>>24==47){j=3653512;break a}else if(k<<24>>24==46){l=f;break}d=d+1|0;if(d>>>0>=g>>>0){j=3653512;break a}}j=h+l|0}while(0);rri(b,j,SEi(j|0)|0);i=e;return}function hsd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Mri(d,47,-1)|0;g=Mri(d,46,-1)|0;if((g|0)!=-1?(f|0)==-1|g>>>0>f>>>0:0){if(!(a[d>>0]&1))h=d+1|0;else h=c[d+8>>2]|0;rri(b,h,g);i=e;return}sri(b,d);i=e;return}function isd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+16|0;h=g;j=d+e|0;c[b>>2]=0;k=b+4|0;c[k>>2]=0;l=b+8|0;c[l>>2]=0;if(!e){i=g;return}e=h+1|0;m=h+8|0;n=h+4|0;o=d;while(1){d=o;while(1){if((a[d>>0]|0)==f<<24>>24){p=d;break}d=d+1|0;if((d|0)==(j|0)){p=j;break}}if((p|0)!=(o|0)){d=p-o|0;if(d>>>0>4294967279){q=8;break}if(d>>>0<11){a[h>>0]=d<<1;r=e}else{s=d+16&-16;t=xCi(s)|0;c[m>>2]=t;c[h>>2]=s|1;c[n>>2]=d;r=t}t=o;s=r;while(1){a[s>>0]=a[t>>0]|0;t=t+1|0;if((t|0)==(p|0))break;else s=s+1|0}a[r+d>>0]=0;s=c[k>>2]|0;if((s|0)==(c[l>>2]|0))nO(b,h);else{if(!s)u=0;else{sri(s,h);u=c[k>>2]|0}c[k>>2]=u+12}xri(h)}o=p+1|0;if((p|0)==(j|0)|(o|0)==(j|0)){q=21;break}}if((q|0)==8)ori(h);else if((q|0)==21){i=g;return}}function jsd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=Mri(d,47,-1)|0;if((f|0)==-1){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;i=e;return}if(!(a[d>>0]&1))g=d+1|0;else g=c[d+8>>2]|0;rri(b,g,f);i=e;return}function ksd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a[d>>0]|0;if(!(f&1)){g=(f&255)>>>1;h=d+1|0}else{g=c[d+4>>2]|0;h=c[d+8>>2]|0}a:do if(!g)j=h;else{d=0;while(1){f=g-d|0;d=d+1|0;if((a[h+(f+-1)>>0]|0)==47){k=f;break}if(d>>>0>=g>>>0){j=h;break a}}j=h+k|0}while(0);rri(b,j,SEi(j|0)|0);i=e;return}function lsd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a[d>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[d+4>>2]|0;if(!h){sri(b,d);i=e;return}if(g)j=d+1|0;else j=c[d+8>>2]|0;if((a[j>>0]|0)==47){if(g)k=(f&255)>>>1;else k=c[d+4>>2]|0;if(k>>>0>1){if(g)l=d+1|0;else l=c[d+8>>2]|0;if((a[l+1>>0]|0)!=47){if(g){m=d+1|0;n=(f&255)>>>1}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0}rri(b,m+1|0,n+-1|0);i=e;return}}}sri(b,d);i=e;return}function msd(b){b=b|0;var c=0,d=0;c=i;d=b;while(1){b=a[d>>0]|0;if(!(b<<24>>24))break;else if(b<<24>>24==92)a[d>>0]=47;d=d+1|0}i=c;return}function nsd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;g=a[b>>0]|0;if(!(g&1))h=(g&255)>>>1;else h=c[b+4>>2]|0;g=a[d>>0]|0;if(!(g&1))j=(g&255)>>>1;else j=c[d+4>>2]|0;Dri(e,h+1+j|0);j=a[b>>0]|0;h=(j&1)==0;if(h)k=(j&255)>>>1;else k=c[b+4>>2]|0;if(k){k=a[d>>0]|0;g=(k&1)==0;if(g)l=(k&255)>>>1;else l=c[d+4>>2]|0;if(l){if(h){m=(j&255)>>>1;n=b+1|0}else{m=c[b+4>>2]|0;n=c[b+8>>2]|0}l=(a[n+(m+-1)>>0]|0)==47;if(g)o=d+1|0;else o=c[d+8>>2]|0;g=(a[o>>0]|0)==47;if(h){p=b+1|0;q=(j&255)>>>1}else{p=c[b+8>>2]|0;q=c[b+4>>2]|0}Gri(e,p,q)|0;if(!l)if(g){l=a[d>>0]|0;if(!(l&1)){r=d+1|0;s=(l&255)>>>1}else{r=c[d+8>>2]|0;s=c[d+4>>2]|0}Gri(e,r,s)|0;i=f;return}else{Fri(e,47);s=a[d>>0]|0;if(!(s&1)){t=d+1|0;u=(s&255)>>>1}else{t=c[d+8>>2]|0;u=c[d+4>>2]|0}Gri(e,t,u)|0;i=f;return}u=a[d>>0]|0;t=(u&1)==0;if(!g){if(t){v=d+1|0;w=(u&255)>>>1}else{v=c[d+8>>2]|0;w=c[d+4>>2]|0}Gri(e,v,w)|0;i=f;return}if(t){x=d+1|0;y=d+1|0;z=(u&255)>>>1}else{u=c[d+8>>2]|0;x=u;y=u;z=c[d+4>>2]|0}u=x+1|0;t=y+z|0;z=a[e>>0]|0;if(!(z&1)){A=z;B=10;C=(z&255)>>>1}else{z=c[e>>2]|0;A=z&255;B=(z&-2)+-1|0;C=c[e+4>>2]|0}z=t-u|0;if((t|0)==(u|0)){i=f;return}if((B-C|0)>>>0<z>>>0){Iri(e,B,C+z-B|0,C,C,0,0);D=a[e>>0]|0}else D=A;if(!(D&1))E=e+1|0;else E=c[e+8>>2]|0;D=u;u=x;x=E+C|0;while(1){a[x>>0]=a[D>>0]|0;E=x+1|0;A=u+2|0;if((A|0)==(t|0)){F=E;break}else{B=D;D=A;x=E;u=B}}a[F>>0]=0;F=C+z|0;if(!(a[e>>0]&1)){a[e>>0]=F<<1;i=f;return}else{c[e+4>>2]=F;i=f;return}}}if(h)G=(j&255)>>>1;else G=c[b+4>>2]|0;if(!G){yri(e,d)|0;i=f;return}else{yri(e,b)|0;i=f;return}}function osd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;g=i;h=b&31;j=e;k=c[j>>2]|0;l=c[j+4>>2]|0;j=f;m=c[j>>2]|0;n=c[j+4>>2]|0;if(b>>>0>15){j=b>>>5;o=a+(j<<2<<3)|0;if(a>>>0<o>>>0){p=a+(j<<5)|0;j=a;q=-559038737;r=-559038737;s=-559038737;t=-559038737;u=k;v=l;w=m;x=n;while(1){y=j;z=_Ei(c[y>>2]|0,c[y+4>>2]|0,q|0,r|0)|0;y=H;A=j+8|0;B=_Ei(c[A>>2]|0,c[A+4>>2]|0,s|0,t|0)|0;A=H;C=cFi(z|0,y|0,50)|0;D=H;E=VEi(z|0,y|0,14)|0;y=_Ei(E|C|0,H|D|0,B|0,A|0)|0;D=H;C=y^u;E=D^v;z=cFi(B|0,A|0,52)|0;F=H;G=VEi(B|0,A|0,12)|0;A=_Ei(C|0,E|0,G|z|0,H|F|0)|0;F=H;z=A^w;G=F^x;B=cFi(C|0,E|0,30)|0;I=H;J=VEi(C|0,E|0,34)|0;E=_Ei(J|B|0,H|I|0,z|0,G|0)|0;I=H;B=E^y;y=I^D;D=cFi(z|0,G|0,41)|0;J=H;C=VEi(z|0,G|0,23)|0;G=_Ei(C|D|0,H|J|0,B|0,y|0)|0;J=H;D=G^A;A=J^F;F=cFi(B|0,y|0,54)|0;C=H;z=VEi(B|0,y|0,10)|0;y=_Ei(z|F|0,H|C|0,D|0,A|0)|0;C=H;F=y^E;E=C^I;I=cFi(D|0,A|0,48)|0;z=H;B=VEi(D|0,A|0,16)|0;A=_Ei(B|I|0,H|z|0,F|0,E|0)|0;z=H;I=A^G;G=z^J;J=cFi(F|0,E|0,38)|0;B=H;D=VEi(F|0,E|0,26)|0;E=_Ei(D|J|0,H|B|0,I|0,G|0)|0;B=H;J=E^y;y=B^C;C=cFi(I|0,G|0,37)|0;D=H;F=VEi(I|0,G|0,27)|0;G=_Ei(F|C|0,H|D|0,J|0,y|0)|0;D=H;C=G^A;A=D^z;z=cFi(J|0,y|0,62)|0;F=H;I=VEi(J|0,y|0,2)|0;y=_Ei(I|z|0,H|F|0,C|0,A|0)|0;F=H;z=y^E;E=F^B;B=cFi(C|0,A|0,34)|0;I=H;J=VEi(C|0,A|0,30)|0;A=_Ei(J|B|0,H|I|0,z|0,E|0)|0;I=H;B=A^G;G=I^D;D=cFi(z|0,E|0,5)|0;J=H;C=VEi(z|0,E|0,59)|0;E=_Ei(C|D|0,H|J|0,B|0,G|0)|0;J=H;D=E^y;y=J^F;F=cFi(B|0,G|0,36)|0;C=H;z=VEi(B|0,G|0,28)|0;G=_Ei(z|F|0,H|C|0,D|0,y|0)|0;C=H;F=G^A;A=C^I;I=j+16|0;z=_Ei(E|0,J|0,c[I>>2]|0,c[I+4>>2]|0)|0;I=H;J=j+24|0;E=_Ei(G|0,C|0,c[J>>2]|0,c[J+4>>2]|0)|0;J=H;j=j+32|0;if(j>>>0>=o>>>0){K=E;L=J;M=z;N=I;O=F;P=A;Q=D;R=y;break}else{q=D;r=y;s=F;t=A;u=z;v=I;w=E;x=J}}S=p;T=Q;U=R;V=O;W=P;X=M;Y=N;Z=K;_=L;$=p}else{S=a;T=-559038737;U=-559038737;V=-559038737;W=-559038737;X=k;Y=l;Z=m;_=n;$=a}if(h>>>0>15){p=S;S=_Ei(c[p>>2]|0,c[p+4>>2]|0,T|0,U|0)|0;p=H;L=$+8|0;K=_Ei(c[L>>2]|0,c[L+4>>2]|0,V|0,W|0)|0;L=H;N=cFi(S|0,p|0,50)|0;M=H;P=VEi(S|0,p|0,14)|0;p=_Ei(P|N|0,H|M|0,K|0,L|0)|0;M=H;N=p^X;P=M^Y;S=cFi(K|0,L|0,52)|0;O=H;R=VEi(K|0,L|0,12)|0;L=_Ei(N|0,P|0,R|S|0,H|O|0)|0;O=H;S=L^Z;R=O^_;K=cFi(N|0,P|0,30)|0;Q=H;x=VEi(N|0,P|0,34)|0;P=_Ei(x|K|0,H|Q|0,S|0,R|0)|0;Q=H;K=P^p;p=Q^M;M=cFi(S|0,R|0,41)|0;x=H;N=VEi(S|0,R|0,23)|0;R=_Ei(N|M|0,H|x|0,K|0,p|0)|0;x=H;M=R^L;L=x^O;O=cFi(K|0,p|0,54)|0;N=H;S=VEi(K|0,p|0,10)|0;p=_Ei(S|O|0,H|N|0,M|0,L|0)|0;N=H;O=p^P;P=N^Q;Q=cFi(M|0,L|0,48)|0;S=H;K=VEi(M|0,L|0,16)|0;L=_Ei(K|Q|0,H|S|0,O|0,P|0)|0;S=H;Q=L^R;R=S^x;x=cFi(O|0,P|0,38)|0;K=H;M=VEi(O|0,P|0,26)|0;P=_Ei(M|x|0,H|K|0,Q|0,R|0)|0;K=H;x=P^p;p=K^N;N=cFi(Q|0,R|0,37)|0;M=H;O=VEi(Q|0,R|0,27)|0;R=_Ei(O|N|0,H|M|0,x|0,p|0)|0;M=H;N=R^L;L=M^S;S=cFi(x|0,p|0,62)|0;O=H;Q=VEi(x|0,p|0,2)|0;p=_Ei(Q|S|0,H|O|0,N|0,L|0)|0;O=H;S=p^P;P=O^K;K=cFi(N|0,L|0,34)|0;Q=H;x=VEi(N|0,L|0,30)|0;L=_Ei(x|K|0,H|Q|0,S|0,P|0)|0;Q=H;K=L^R;R=Q^M;M=cFi(S|0,P|0,5)|0;x=H;N=VEi(S|0,P|0,59)|0;P=_Ei(N|M|0,H|x|0,K|0,R|0)|0;x=H;M=P^p;p=x^O;O=cFi(K|0,R|0,36)|0;N=H;S=VEi(K|0,R|0,28)|0;R=_Ei(S|O|0,H|N|0,M|0,p|0)|0;N=H;aa=R^L;ba=N^Q;ca=M;da=p;ea=P;fa=x;ga=R;ha=N;ia=h+-16|0;ja=$+16|0}else{aa=V;ba=W;ca=T;da=U;ea=X;fa=Y;ga=Z;ha=_;ia=h;ja=$}}else{aa=-559038737;ba=-559038737;ca=-559038737;da=-559038737;ea=k;fa=l;ga=m;ha=n;ia=h;ja=a}a=cFi(b|0,0,56)|0;b=_Ei(aa|0,ba|0,a|0,H|0)|0;a=H;switch(ia|0){case 6:{ka=ca;la=da;ma=18;break}case 9:{na=b;oa=a;ma=15;break}case 0:{ia=_Ei(ca|0,da|0,-559038737,-559038737)|0;ba=H;pa=_Ei(b|0,a|0,-559038737,-559038737)|0;qa=ia;ra=H;sa=ba;break}case 2:{ta=ca;ua=da;ma=22;break}case 14:{va=b;wa=a;ma=10;break}case 5:{xa=ca;ya=da;ma=19;break}case 4:{za=ca;Aa=da;ma=20;break}case 7:{ka=_Ei(cFi(d[ja+6>>0]|0|0,0,48)|0,H|0,ca|0,da|0)|0;la=H;ma=18;break}case 3:{ta=_Ei(cFi(d[ja+2>>0]|0|0,0,16)|0,H|0,ca|0,da|0)|0;ua=H;ma=22;break}case 11:{Ba=_Ei(cFi(d[ja+10>>0]|0|0,0,16)|0,H|0,b|0,a|0)|0;Ca=H;ma=14;break}case 12:{Da=b;Ea=a;ma=12;break}case 15:{va=_Ei(cFi(d[ja+14>>0]|0|0,0,48)|0,H|0,b|0,a|0)|0;wa=H;ma=10;break}case 1:{Fa=ca;Ga=da;ma=23;break}case 10:{Ba=b;Ca=a;ma=14;break}case 8:{Ha=b;Ia=a;ma=16;break}case 13:{Ja=b;Ka=a;ma=11;break}default:{pa=b;qa=ca;ra=a;sa=da}}if((ma|0)==10){ba=cFi(d[ja+13>>0]|0|0,0,40)|0;ia=_Ei(ba|0,H|0,va|0,wa|0)|0;Ja=ia;Ka=H;ma=11}else if((ma|0)==14){ia=cFi(d[ja+9>>0]|0|0,0,8)|0;wa=_Ei(ia|0,H|0,Ba|0,Ca|0)|0;na=wa;oa=H;ma=15}else if((ma|0)==18){wa=cFi(d[ja+5>>0]|0|0,0,40)|0;Ca=_Ei(wa|0,H|0,ka|0,la|0)|0;xa=Ca;ya=H;ma=19}else if((ma|0)==22){Ca=cFi(d[ja+1>>0]|0|0,0,8)|0;la=_Ei(Ca|0,H|0,ta|0,ua|0)|0;Fa=la;Ga=H;ma=23}if((ma|0)==11){la=_Ei(0,d[ja+12>>0]|0|0,Ja|0,Ka|0)|0;Da=la;Ea=H;ma=12}else if((ma|0)==15){la=_Ei(d[ja+8>>0]|0|0,0,na|0,oa|0)|0;Ha=la;Ia=H;ma=16}else if((ma|0)==19){la=_Ei(0,d[ja+4>>0]|0|0,xa|0,ya|0)|0;za=la;Aa=H;ma=20}else if((ma|0)==23){la=_Ei(d[ja>>0]|0|0,0,Fa|0,Ga|0)|0;pa=b;qa=la;ra=a;sa=H}if((ma|0)==12){la=_Ei(c[ja+8>>2]|0,0,Da|0,Ea|0)|0;Ea=H;Da=ja;Ga=_Ei(c[Da>>2]|0,c[Da+4>>2]|0,ca|0,da|0)|0;pa=la;qa=Ga;ra=Ea;sa=H}else if((ma|0)==16){Ea=ja;Ga=_Ei(c[Ea>>2]|0,c[Ea+4>>2]|0,ca|0,da|0)|0;pa=Ha;qa=Ga;ra=Ia;sa=H}else if((ma|0)==20){ma=_Ei(c[ja>>2]|0,0,za|0,Aa|0)|0;pa=b;qa=ma;ra=a;sa=H}a=cFi(qa|0,sa|0,15)|0;ma=H;b=VEi(qa|0,sa|0,49)|0;Aa=b|a;a=H|ma;ma=_Ei(Aa|0,a|0,pa^qa|0,ra^sa|0)|0;sa=H;ra=cFi(ma|0,sa|0,52)|0;qa=H;pa=VEi(ma|0,sa|0,12)|0;b=pa|ra;ra=H|qa;qa=_Ei(b|0,ra|0,ma^ea|0,sa^fa|0)|0;fa=H;sa=cFi(qa|0,fa|0,26)|0;ea=H;ma=VEi(qa|0,fa|0,38)|0;pa=ma|sa;sa=H|ea;ea=_Ei(pa|0,sa|0,qa^ga|0,fa^ha|0)|0;ha=H;fa=cFi(ea|0,ha|0,51)|0;ga=H;qa=VEi(ea|0,ha|0,13)|0;ma=qa|fa;fa=H|ga;ga=_Ei(ma|0,fa|0,ea^Aa|0,ha^a|0)|0;a=H;ha=cFi(ga|0,a|0,28)|0;Aa=H;ea=VEi(ga|0,a|0,36)|0;qa=ea|ha;ha=H|Aa;Aa=_Ei(qa|0,ha|0,ga^b|0,a^ra|0)|0;ra=H;a=cFi(Aa|0,ra|0,9)|0;b=H;ga=VEi(Aa|0,ra|0,55)|0;ea=ga|a;a=H|b;b=_Ei(ea|0,a|0,Aa^pa|0,ra^sa|0)|0;sa=H;ra=cFi(b|0,sa|0,47)|0;pa=H;Aa=VEi(b|0,sa|0,17)|0;ga=Aa|ra;ra=H|pa;pa=_Ei(ga|0,ra|0,b^ma|0,sa^fa|0)|0;fa=H;sa=cFi(pa|0,fa|0,54)|0;ma=H;b=VEi(pa|0,fa|0,10)|0;Aa=b|sa;sa=H|ma;ma=_Ei(Aa|0,sa|0,pa^qa|0,fa^ha|0)|0;ha=H;fa=_Ei(ha|0,ma|0,ma^ea|0,ha^a|0)|0;a=H;ha=cFi(fa|0,a|0,25)|0;ea=H;ma=VEi(fa|0,a|0,39)|0;qa=_Ei(ma|ha|0,H|ea|0,fa^ga|0,a^ra|0)|0;ra=H;a=cFi(qa|0,ra|0,63)|0;ga=H;fa=VEi(qa|0,ra|0,1)|0;ea=fa|a;a=H|ga;ga=_Ei(ea|0,a|0,qa^Aa|0,ra^sa|0)|0;sa=e;c[sa>>2]=ea;c[sa+4>>2]=a;a=f;c[a>>2]=ga;c[a+4>>2]=H;i=g;return}function psd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;g=i;i=i+192|0;h=g+176|0;j=g+160|0;k=g+128|0;l=g+120|0;m=g+152|0;n=g+168|0;o=g+184|0;p=g+104|0;q=g+96|0;r=g+136|0;s=g+112|0;t=g+144|0;u=g;if(d>>>0<192){osd(b,d,e,f);i=g;return}v=e;w=c[v>>2]|0;x=c[v+4>>2]|0;v=r;c[v>>2]=w;c[v+4>>2]=x;v=o;c[v>>2]=w;c[v+4>>2]=x;v=l;c[v>>2]=w;c[v+4>>2]=x;v=h;c[v>>2]=w;c[v+4>>2]=x;v=f;y=c[v>>2]|0;z=c[v+4>>2]|0;v=s;c[v>>2]=y;c[v+4>>2]=z;v=p;c[v>>2]=y;c[v+4>>2]=z;v=m;c[v>>2]=y;c[v+4>>2]=z;v=j;c[v>>2]=y;c[v+4>>2]=z;v=t;c[v>>2]=-559038737;c[v+4>>2]=-559038737;v=q;c[v>>2]=-559038737;c[v+4>>2]=-559038737;v=n;c[v>>2]=-559038737;c[v+4>>2]=-559038737;v=k;c[v>>2]=-559038737;c[v+4>>2]=-559038737;v=b+(((d>>>0)/96|0)*12<<3)|0;if(b>>>0<v>>>0){A=b;do{qsd(A,h,j,k,l,m,n,o,p,q,r,s,t);A=A+96|0}while(A>>>0<v>>>0);A=h;B=j;C=k;D=l;E=m;F=n;G=o;I=p;J=q;K=r;L=s;M=t;N=c[A>>2]|0;O=c[A+4>>2]|0;P=c[B>>2]|0;Q=c[B+4>>2]|0;R=c[C>>2]|0;S=c[C+4>>2]|0;T=c[D>>2]|0;U=c[D+4>>2]|0;V=c[E>>2]|0;W=c[E+4>>2]|0;X=c[F>>2]|0;Y=c[F+4>>2]|0;Z=c[G>>2]|0;_=c[G+4>>2]|0;$=c[I>>2]|0;aa=c[I+4>>2]|0;ba=c[J>>2]|0;ca=c[J+4>>2]|0;da=c[K>>2]|0;ea=c[K+4>>2]|0;fa=c[L>>2]|0;ga=c[L+4>>2]|0;ha=c[M>>2]|0;ia=c[M+4>>2]|0}else{N=w;O=x;P=y;Q=z;R=-559038737;S=-559038737;T=w;U=x;V=y;W=z;X=-559038737;Y=-559038737;Z=w;_=x;$=y;aa=z;ba=-559038737;ca=-559038737;da=w;ea=x;fa=y;ga=z;ha=-559038737;ia=-559038737}z=b-v+d|0;YEi(u|0,v|0,z|0)|0;PEi(u+z|0,0,96-z|0)|0;a[u+95>>0]=z;z=u;v=_Ei(N|0,O|0,c[z>>2]|0,c[z+4>>2]|0)|0;z=H;O=u+8|0;N=_Ei(P|0,Q|0,c[O>>2]|0,c[O+4>>2]|0)|0;O=H;Q=u+16|0;P=_Ei(R|0,S|0,c[Q>>2]|0,c[Q+4>>2]|0)|0;Q=H;S=u+24|0;R=_Ei(T|0,U|0,c[S>>2]|0,c[S+4>>2]|0)|0;S=H;U=u+32|0;T=_Ei(V|0,W|0,c[U>>2]|0,c[U+4>>2]|0)|0;U=H;W=u+40|0;V=_Ei(X|0,Y|0,c[W>>2]|0,c[W+4>>2]|0)|0;W=H;Y=u+48|0;X=_Ei(Z|0,_|0,c[Y>>2]|0,c[Y+4>>2]|0)|0;Y=H;_=u+56|0;Z=_Ei($|0,aa|0,c[_>>2]|0,c[_+4>>2]|0)|0;_=H;aa=u+64|0;$=_Ei(ba|0,ca|0,c[aa>>2]|0,c[aa+4>>2]|0)|0;aa=H;ca=u+72|0;ba=_Ei(da|0,ea|0,c[ca>>2]|0,c[ca+4>>2]|0)|0;ca=H;ea=u+80|0;da=_Ei(fa|0,ga|0,c[ea>>2]|0,c[ea+4>>2]|0)|0;ea=H;ga=u+88|0;u=_Ei(ha|0,ia|0,c[ga>>2]|0,c[ga+4>>2]|0)|0;ga=_Ei(u|0,H|0,N|0,O|0)|0;u=H;ia=P^ga;P=Q^u;Q=cFi(N|0,O|0,44)|0;ha=H;fa=VEi(N|0,O|0,20)|0;O=H|ha;ha=_Ei(v|0,z|0,ia|0,P|0)|0;z=H;v=R^ha;R=S^z;S=cFi(ia|0,P|0,15)|0;N=H;d=VEi(ia|0,P|0,49)|0;P=H|N;N=_Ei(fa|Q|0,O|0,v|0,R|0)|0;O=H;Q=T^N;T=U^O;U=cFi(v|0,R|0,34)|0;fa=H;ia=VEi(v|0,R|0,30)|0;R=H|fa;fa=_Ei(d|S|0,P|0,Q|0,T|0)|0;P=H;S=V^fa;V=W^P;W=cFi(Q|0,T|0,21)|0;d=H;v=VEi(Q|0,T|0,43)|0;T=H|d;d=_Ei(ia|U|0,R|0,S|0,V|0)|0;R=H;U=X^d;X=Y^R;Y=cFi(S|0,V|0,38)|0;ia=H;Q=VEi(S|0,V|0,26)|0;V=H|ia;ia=_Ei(v|W|0,T|0,U|0,X|0)|0;T=H;W=Z^ia;Z=_^T;_=cFi(U|0,X|0,33)|0;v=H;S=VEi(U|0,X|0,31)|0;X=H|v;v=_Ei(Q|Y|0,V|0,W|0,Z|0)|0;V=H;Y=$^v;$=aa^V;aa=cFi(W|0,Z|0,10)|0;Q=H;U=VEi(W|0,Z|0,54)|0;Z=H|Q;Q=_Ei(S|_|0,X|0,Y|0,$|0)|0;X=H;_=ba^Q;ba=ca^X;ca=cFi(Y|0,$|0,13)|0;S=H;W=VEi(Y|0,$|0,51)|0;$=H|S;S=_Ei(U|aa|0,Z|0,_|0,ba|0)|0;Z=H;aa=da^S;da=ea^Z;ea=cFi(_|0,ba|0,38)|0;U=H;Y=VEi(_|0,ba|0,26)|0;ba=H|U;U=_Ei(W|ca|0,$|0,aa|0,da|0)|0;$=H;ca=ga^U;ga=u^$;u=cFi(aa|0,da|0,53)|0;W=H;_=VEi(aa|0,da|0,11)|0;da=H|W;W=_Ei(Y|ea|0,ba|0,ca|0,ga|0)|0;ba=H;ea=ha^W;ha=z^ba;z=cFi(ca|0,ga|0,42)|0;Y=H;aa=VEi(ca|0,ga|0,22)|0;ga=H|Y;Y=_Ei(_|u|0,da|0,ea|0,ha|0)|0;da=H;u=N^Y;N=O^da;O=cFi(ea|0,ha|0,54)|0;_=H;ca=VEi(ea|0,ha|0,10)|0;ha=H|_;_=_Ei(aa|z|0,ga|0,u|0,N|0)|0;ga=H;z=fa^_;fa=P^ga;P=cFi(u|0,N|0,44)|0;aa=H;ea=VEi(u|0,N|0,20)|0;N=H|aa;aa=_Ei(ca|O|0,ha|0,z|0,fa|0)|0;ha=H;O=d^aa;d=R^ha;R=cFi(z|0,fa|0,15)|0;ca=H;u=VEi(z|0,fa|0,49)|0;fa=H|ca;ca=_Ei(ea|P|0,N|0,O|0,d|0)|0;N=H;P=ia^ca;ia=T^N;T=cFi(O|0,d|0,34)|0;ea=H;z=VEi(O|0,d|0,30)|0;d=H|ea;ea=_Ei(u|R|0,fa|0,P|0,ia|0)|0;fa=H;R=v^ea;v=V^fa;V=cFi(P|0,ia|0,21)|0;u=H;O=VEi(P|0,ia|0,43)|0;ia=H|u;u=_Ei(z|T|0,d|0,R|0,v|0)|0;d=H;T=Q^u;Q=X^d;X=cFi(R|0,v|0,38)|0;z=H;P=VEi(R|0,v|0,26)|0;v=H|z;z=_Ei(O|V|0,ia|0,T|0,Q|0)|0;ia=H;V=S^z;S=Z^ia;Z=cFi(T|0,Q|0,33)|0;O=H;R=VEi(T|0,Q|0,31)|0;Q=H|O;O=_Ei(P|X|0,v|0,V|0,S|0)|0;v=H;X=U^O;U=$^v;$=cFi(V|0,S|0,10)|0;P=H;T=VEi(V|0,S|0,54)|0;S=H|P;P=_Ei(R|Z|0,Q|0,X|0,U|0)|0;Q=H;Z=W^P;W=ba^Q;ba=cFi(X|0,U|0,13)|0;R=H;V=VEi(X|0,U|0,51)|0;U=H|R;R=_Ei(T|$|0,S|0,Z|0,W|0)|0;S=H;$=Y^R;Y=da^S;da=cFi(Z|0,W|0,38)|0;T=H;X=VEi(Z|0,W|0,26)|0;W=H|T;T=_Ei(V|ba|0,U|0,$|0,Y|0)|0;U=H;ba=_^T;_=ga^U;ga=cFi($|0,Y|0,53)|0;V=H;Z=VEi($|0,Y|0,11)|0;Y=H|V;V=_Ei(X|da|0,W|0,ba|0,_|0)|0;W=H;da=aa^V;aa=ha^W;ha=cFi(ba|0,_|0,42)|0;X=H;$=VEi(ba|0,_|0,22)|0;_=H|X;X=_Ei(Z|ga|0,Y|0,da|0,aa|0)|0;Y=H;ga=ca^X;ca=N^Y;N=cFi(da|0,aa|0,54)|0;Z=H;ba=VEi(da|0,aa|0,10)|0;aa=H|Z;Z=_Ei($|ha|0,_|0,ga|0,ca|0)|0;_=H;ha=ea^Z;ea=fa^_;fa=cFi(ga|0,ca|0,44)|0;$=H;da=VEi(ga|0,ca|0,20)|0;ca=H|$;$=_Ei(ba|N|0,aa|0,ha|0,ea|0)|0;aa=H;N=u^$;u=d^aa;d=cFi(ha|0,ea|0,15)|0;ba=H;ga=VEi(ha|0,ea|0,49)|0;ea=H|ba;ba=_Ei(da|fa|0,ca|0,N|0,u|0)|0;ca=H;fa=z^ba;z=ia^ca;ia=cFi(N|0,u|0,34)|0;da=H;ha=VEi(N|0,u|0,30)|0;u=H|da;da=_Ei(ga|d|0,ea|0,fa|0,z|0)|0;ea=H;d=k;c[d>>2]=da;c[d+4>>2]=ea;d=O^da;da=v^ea;ea=cFi(fa|0,z|0,21)|0;v=H;O=VEi(fa|0,z|0,43)|0;z=H|v;v=_Ei(ha|ia|0,u|0,d|0,da|0)|0;u=H;ia=l;c[ia>>2]=v;c[ia+4>>2]=u;ia=P^v;v=Q^u;u=cFi(d|0,da|0,38)|0;Q=H;P=VEi(d|0,da|0,26)|0;da=H|Q;Q=_Ei(O|ea|0,z|0,ia|0,v|0)|0;z=H;ea=m;c[ea>>2]=Q;c[ea+4>>2]=z;ea=R^Q;Q=S^z;z=cFi(ia|0,v|0,33)|0;S=H;R=VEi(ia|0,v|0,31)|0;v=H|S;S=_Ei(P|u|0,da|0,ea|0,Q|0)|0;da=H;u=n;c[u>>2]=S;c[u+4>>2]=da;u=T^S;S=U^da;da=cFi(ea|0,Q|0,10)|0;U=H;T=VEi(ea|0,Q|0,54)|0;Q=H|U;U=_Ei(R|z|0,v|0,u|0,S|0)|0;v=H;z=o;c[z>>2]=U;c[z+4>>2]=v;z=V^U;U=W^v;v=cFi(u|0,S|0,13)|0;W=H;V=VEi(u|0,S|0,51)|0;S=H|W;W=_Ei(T|da|0,Q|0,z|0,U|0)|0;Q=H;da=p;c[da>>2]=W;c[da+4>>2]=Q;da=X^W;W=Y^Q;Q=cFi(z|0,U|0,38)|0;Y=H;X=VEi(z|0,U|0,26)|0;U=H|Y;Y=_Ei(V|v|0,S|0,da|0,W|0)|0;S=H;v=q;c[v>>2]=Y;c[v+4>>2]=S;v=Z^Y;Y=_^S;S=cFi(da|0,W|0,53)|0;_=H;Z=VEi(da|0,W|0,11)|0;W=H|_;_=_Ei(X|Q|0,U|0,v|0,Y|0)|0;U=H;Q=r;c[Q>>2]=_;c[Q+4>>2]=U;Q=$^_;_=aa^U;U=cFi(v|0,Y|0,42)|0;aa=H;$=VEi(v|0,Y|0,22)|0;Y=t;c[Y>>2]=$|U;c[Y+4>>2]=H|aa;aa=_Ei(Z|S|0,W|0,Q|0,_|0)|0;W=H;S=s;c[S>>2]=aa;c[S+4>>2]=W;S=ba^aa;aa=ca^W;W=j;c[W>>2]=S;c[W+4>>2]=aa;W=cFi(Q|0,_|0,54)|0;j=H;ca=VEi(Q|0,_|0,10)|0;_=ca|W;W=H|j;j=h;c[j>>2]=_;c[j+4>>2]=W;j=e;c[j>>2]=_;c[j+4>>2]=W;W=f;c[W>>2]=S;c[W+4>>2]=aa;i=g;return}function qsd(a,b,d,e,f,g,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;q=a;r=b;s=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[q>>2]|0,c[q+4>>2]|0)|0;q=b;c[q>>2]=s;c[q+4>>2]=H;q=n;s=e;r=c[s+4>>2]^c[q+4>>2];t=e;c[t>>2]=c[s>>2]^c[q>>2];c[t+4>>2]=r;r=b;t=o;q=c[t+4>>2]^c[r+4>>2];s=o;c[s>>2]=c[t>>2]^c[r>>2];c[s+4>>2]=q;q=b;s=c[q>>2]|0;r=c[q+4>>2]|0;q=cFi(s|0,r|0,11)|0;t=H;u=VEi(s|0,r|0,53)|0;r=b;c[r>>2]=u|q;c[r+4>>2]=H|t;t=d;r=o;q=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[t>>2]|0,c[t+4>>2]|0)|0;t=o;c[t>>2]=q;c[t+4>>2]=H;t=a+8|0;q=d;r=_Ei(c[q>>2]|0,c[q+4>>2]|0,c[t>>2]|0,c[t+4>>2]|0)|0;t=d;c[t>>2]=r;c[t+4>>2]=H;t=o;r=f;q=c[r+4>>2]^c[t+4>>2];u=f;c[u>>2]=c[r>>2]^c[t>>2];c[u+4>>2]=q;q=d;u=b;t=c[u+4>>2]^c[q+4>>2];r=b;c[r>>2]=c[u>>2]^c[q>>2];c[r+4>>2]=t;t=d;r=c[t>>2]|0;q=d;c[q>>2]=c[t+4>>2];c[q+4>>2]=r;r=e;q=b;t=_Ei(c[q>>2]|0,c[q+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)|0;r=b;c[r>>2]=t;c[r+4>>2]=H;r=a+16|0;t=e;q=_Ei(c[t>>2]|0,c[t+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)|0;r=e;c[r>>2]=q;c[r+4>>2]=H;r=b;q=g;t=c[q+4>>2]^c[r+4>>2];u=g;c[u>>2]=c[q>>2]^c[r>>2];c[u+4>>2]=t;t=e;u=d;r=c[u+4>>2]^c[t+4>>2];q=d;c[q>>2]=c[u>>2]^c[t>>2];c[q+4>>2]=r;r=e;q=c[r>>2]|0;t=c[r+4>>2]|0;r=cFi(q|0,t|0,43)|0;u=H;s=VEi(q|0,t|0,21)|0;t=e;c[t>>2]=s|r;c[t+4>>2]=H|u;u=f;t=d;r=_Ei(c[t>>2]|0,c[t+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=d;c[u>>2]=r;c[u+4>>2]=H;u=a+24|0;r=f;t=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=f;c[u>>2]=t;c[u+4>>2]=H;u=d;t=h;r=c[t+4>>2]^c[u+4>>2];s=h;c[s>>2]=c[t>>2]^c[u>>2];c[s+4>>2]=r;r=f;s=e;u=c[s+4>>2]^c[r+4>>2];t=e;c[t>>2]=c[s>>2]^c[r>>2];c[t+4>>2]=u;u=f;t=c[u>>2]|0;r=c[u+4>>2]|0;u=cFi(t|0,r|0,31)|0;s=H;q=VEi(t|0,r|0,33)|0;r=f;c[r>>2]=q|u;c[r+4>>2]=H|s;s=g;r=e;u=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=e;c[s>>2]=u;c[s+4>>2]=H;s=a+32|0;u=g;r=_Ei(c[u>>2]|0,c[u+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=g;c[s>>2]=r;c[s+4>>2]=H;s=e;e=j;r=c[e+4>>2]^c[s+4>>2];u=j;c[u>>2]=c[e>>2]^c[s>>2];c[u+4>>2]=r;r=g;u=f;s=c[u+4>>2]^c[r+4>>2];e=f;c[e>>2]=c[u>>2]^c[r>>2];c[e+4>>2]=s;s=g;e=c[s>>2]|0;r=c[s+4>>2]|0;s=cFi(e|0,r|0,17)|0;u=H;q=VEi(e|0,r|0,47)|0;r=g;c[r>>2]=q|s;c[r+4>>2]=H|u;u=h;r=f;s=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=f;c[u>>2]=s;c[u+4>>2]=H;u=a+40|0;s=h;r=_Ei(c[s>>2]|0,c[s+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=h;c[u>>2]=r;c[u+4>>2]=H;u=f;f=k;r=c[f+4>>2]^c[u+4>>2];s=k;c[s>>2]=c[f>>2]^c[u>>2];c[s+4>>2]=r;r=h;s=g;u=c[s+4>>2]^c[r+4>>2];f=g;c[f>>2]=c[s>>2]^c[r>>2];c[f+4>>2]=u;u=h;f=c[u>>2]|0;r=c[u+4>>2]|0;u=cFi(f|0,r|0,28)|0;s=H;q=VEi(f|0,r|0,36)|0;r=h;c[r>>2]=q|u;c[r+4>>2]=H|s;s=j;r=g;u=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=g;c[s>>2]=u;c[s+4>>2]=H;s=a+48|0;u=j;r=_Ei(c[u>>2]|0,c[u+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=j;c[s>>2]=r;c[s+4>>2]=H;s=g;g=l;r=c[g+4>>2]^c[s+4>>2];u=l;c[u>>2]=c[g>>2]^c[s>>2];c[u+4>>2]=r;r=j;u=h;s=c[u+4>>2]^c[r+4>>2];g=h;c[g>>2]=c[u>>2]^c[r>>2];c[g+4>>2]=s;s=j;g=c[s>>2]|0;r=c[s+4>>2]|0;s=cFi(g|0,r|0,39)|0;u=H;q=VEi(g|0,r|0,25)|0;r=j;c[r>>2]=q|s;c[r+4>>2]=H|u;u=k;r=h;s=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=h;c[u>>2]=s;c[u+4>>2]=H;u=a+56|0;s=k;r=_Ei(c[s>>2]|0,c[s+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=k;c[u>>2]=r;c[u+4>>2]=H;u=h;h=m;r=c[h+4>>2]^c[u+4>>2];s=m;c[s>>2]=c[h>>2]^c[u>>2];c[s+4>>2]=r;r=k;s=j;u=c[s+4>>2]^c[r+4>>2];h=j;c[h>>2]=c[s>>2]^c[r>>2];c[h+4>>2]=u;u=k;h=c[u>>2]|0;r=c[u+4>>2]|0;u=cFi(h|0,r|0,57)|0;s=H;q=VEi(h|0,r|0,7)|0;r=k;c[r>>2]=q|u;c[r+4>>2]=H|s;s=l;r=j;u=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=j;c[s>>2]=u;c[s+4>>2]=H;s=a+64|0;u=l;r=_Ei(c[u>>2]|0,c[u+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=l;c[s>>2]=r;c[s+4>>2]=H;s=j;j=n;r=c[j+4>>2]^c[s+4>>2];u=n;c[u>>2]=c[j>>2]^c[s>>2];c[u+4>>2]=r;r=l;u=k;s=c[u+4>>2]^c[r+4>>2];j=k;c[j>>2]=c[u>>2]^c[r>>2];c[j+4>>2]=s;s=l;j=c[s>>2]|0;r=c[s+4>>2]|0;s=cFi(j|0,r|0,55)|0;u=H;q=VEi(j|0,r|0,9)|0;r=l;c[r>>2]=q|s;c[r+4>>2]=H|u;u=m;r=k;s=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=k;c[u>>2]=s;c[u+4>>2]=H;u=a+72|0;s=m;r=_Ei(c[s>>2]|0,c[s+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=m;c[u>>2]=r;c[u+4>>2]=H;u=k;k=o;r=c[k+4>>2]^c[u+4>>2];s=o;c[s>>2]=c[k>>2]^c[u>>2];c[s+4>>2]=r;r=m;s=l;u=c[s+4>>2]^c[r+4>>2];k=l;c[k>>2]=c[s>>2]^c[r>>2];c[k+4>>2]=u;u=m;k=c[u>>2]|0;r=c[u+4>>2]|0;u=cFi(k|0,r|0,54)|0;s=H;q=VEi(k|0,r|0,10)|0;r=m;c[r>>2]=q|u;c[r+4>>2]=H|s;s=n;r=l;u=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=l;c[s>>2]=u;c[s+4>>2]=H;s=a+80|0;u=n;r=_Ei(c[u>>2]|0,c[u+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=n;c[s>>2]=r;c[s+4>>2]=H;s=l;l=b;r=c[l+4>>2]^c[s+4>>2];u=b;c[u>>2]=c[l>>2]^c[s>>2];c[u+4>>2]=r;r=n;u=m;s=c[u+4>>2]^c[r+4>>2];l=m;c[l>>2]=c[u>>2]^c[r>>2];c[l+4>>2]=s;s=n;l=c[s>>2]|0;r=c[s+4>>2]|0;s=cFi(l|0,r|0,22)|0;u=H;q=VEi(l|0,r|0,42)|0;r=n;c[r>>2]=q|s;c[r+4>>2]=H|u;u=o;r=m;s=_Ei(c[r>>2]|0,c[r+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=m;c[u>>2]=s;c[u+4>>2]=H;u=a+88|0;a=o;s=_Ei(c[a>>2]|0,c[a+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=o;c[u>>2]=s;c[u+4>>2]=H;u=m;m=d;s=c[m+4>>2]^c[u+4>>2];a=d;c[a>>2]=c[m>>2]^c[u>>2];c[a+4>>2]=s;s=o;a=n;u=c[a+4>>2]^c[s+4>>2];m=n;c[m>>2]=c[a>>2]^c[s>>2];c[m+4>>2]=u;u=o;m=c[u>>2]|0;s=c[u+4>>2]|0;u=cFi(m|0,s|0,46)|0;a=H;d=VEi(m|0,s|0,18)|0;s=o;c[s>>2]=d|u;c[s+4>>2]=H|a;a=b;b=n;s=_Ei(c[b>>2]|0,c[b+4>>2]|0,c[a>>2]|0,c[a+4>>2]|0)|0;a=n;c[a>>2]=s;c[a+4>>2]=H;i=p;return}function rsd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;c[a>>2]=0;c[a+4>>2]=g;b=a+8|0;c[b>>2]=1;c[a+12>>2]=1;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];f=hOb(0,4,4,e,0,3653512,370)|0;c[a>>2]=f;c[f+((c[b>>2]|0)+-1<<2)>>2]=16777215;c[a+16>>2]=1;i=d;return}function ssd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+12|0;if((c[f>>2]|0)>-1){g=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[a>>2]=0}c[a+8>>2]=0;c[f>>2]=0;c[a+16>>2]=-1;i=b;return}function tsd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+16|0;h=c[g>>2]|0;j=b+8|0;if((h|0)==(c[j>>2]|0)){k=h+1|0;l=k&16777215;c[j>>2]=k;m=b+12|0;n=c[m>>2]|0;o=n&2147483647;if(k>>>0>o>>>0){p=n<<1;q=(p|0)==0?1:p;do if(o>>>0<q>>>0)if((n|0)>-1){c[m>>2]=q;p=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];c[b>>2]=hOb(p,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];p=cOb(q<<2,4,e,0,3653512,352)|0;YEi(p|0,c[b>>2]|0,c[j>>2]<<2|0)|0;c[m>>2]=q;c[b>>2]=p;break}while(0);r=c[j>>2]|0}else r=k;c[(c[b>>2]|0)+(r+-1<<2)>>2]=l;s=b;t=c[g>>2]|0}else{s=b;t=h}h=(c[s>>2]|0)+(t<<2)|0;b=c[h>>2]|0;c[g>>2]=b&16777215;g=t&16777215;c[h>>2]=c[h>>2]&-16777216|g;h=(c[s>>2]|0)+(t<<2)|0;t=b+16777216&-16777216;c[h>>2]=c[h>>2]&16777215|t;c[a>>2]=t|g;i=d;return}function usd(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b>>2]&16777215;b=a+16|0;e=(c[a>>2]|0)+(d<<2)|0;c[e>>2]=c[e>>2]&-16777216|c[b>>2]&16777215;c[b>>2]=d;return}function vsd(a,b){a=a|0;b=b|0;var d=0,e=0;d=a+16|0;e=(c[a>>2]|0)+(b<<2)|0;c[e>>2]=c[e>>2]&-16777216|c[d>>2]&16777215;c[d>>2]=b;return}function wsd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+8|0;e=c[d>>2]|0;if(e>>>0<=1){i=b;return}f=a+16|0;g=e;e=1;while(1){h=(c[a>>2]|0)+(e<<2)|0;j=c[h>>2]|0;if((j&16777215|0)==(e|0)){c[h>>2]=j&-16777216|c[f>>2]&16777215;c[f>>2]=e;k=c[d>>2]|0}else k=g;e=e+1|0;if(e>>>0>=k>>>0)break;else g=k}i=b;return}function xsd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;tsd(d,a);i=b;return c[d>>2]&16777215|0}function ysd(a,b){a=a|0;b=b|0;var d=0;d=c[b>>2]|0;return (c[(c[a>>2]|0)+((d&16777215)<<2)>>2]|0)==(d|0)|0}function zsd(){return 632152}function Asd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+48|0;d=b;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+8|0;k=(c[a+4>>2]|0)==0;l=a+12|0;a=c[l>>2]|0;if(!a)m=0;else{c[h>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,h);n=c[d>>2]|0;o=c[a+28>>2]|0;if((n|0)==-1){p=o+(c[a+32>>2]<<3)|0;break}else{p=o+(n<<3)|0;break}}else p=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((p|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[p+4>>2]|0,(a|0)!=0):0)q=a;else r=10}else r=10;if((r|0)==10)q=hQb(c[l>>2]|0)|0;m=(q|0)!=0}if(k){if(!m){s=0;i=b;return s|0}k=c[l>>2]|0;if(!k)t=0;else{c[e>>2]=k;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,e);q=c[d>>2]|0;a=c[k+28>>2]|0;if((q|0)==-1){u=a+(c[k+32>>2]<<3)|0;break}else{u=a+(q<<3)|0;break}}else u=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((u|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[u+4>>2]|0,(k|0)!=0):0)v=k;else r=44}else r=44;if((r|0)==44)v=hQb(c[l>>2]|0)|0;t=v}lQc(t,1);s=0;i=b;return s|0}if(!m){rri(j,3653512,0);c[d>>2]=2528240;c[d+4>>2]=0;c[l>>2]=c[(dQc(j,2462344,d)|0)+4>>2];xri(j);c[g>>2]=c[l>>2];j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,g);m=c[d>>2]|0;t=c[j+28>>2]|0;if((m|0)==-1){w=t+(c[j+32>>2]<<3)|0;break}else{w=t+(m<<3)|0;break}}else w=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((w|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[w+4>>2]|0,(j|0)!=0):0)x=j;else r=22}else r=22;if((r|0)==22)x=hQb(c[l>>2]|0)|0;In[c[(c[x>>2]|0)+44>>2]&4095](x,1)}c[f>>2]=c[l>>2];x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(d,x,f);j=c[d>>2]|0;w=c[x+28>>2]|0;if((j|0)==-1){y=w+(c[x+32>>2]<<3)|0;break}else{y=w+(j<<3)|0;break}}else y=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((y|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[y+4>>2]|0,(x|0)!=0):0)z=x;else r=32}else r=32;if((r|0)==32)z=hQb(c[l>>2]|0)|0;s=ATb(z,114)|0;i=b;return s|0}function Bsd(a,b){a=a|0;b=b|0;c[a>>2]=575440;c[a+4>>2]=1;c[a>>2]=632176;c[a+8>>2]=c[b>>2];return}function Csd(a){a=a|0;return}function Dsd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Esd(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=c;c=b;while(1){b=a[e>>0]|0;if(!(b<<24>>24)){f=1;g=4;break}if((a[c>>0]|0)==b<<24>>24){e=e+1|0;c=c+1|0}else{f=0;g=4;break}}if((g|0)==4){i=d;return f|0}return 0}function Fsd(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b;b=c;while(1){c=a[e>>0]|0;f=a[b>>0]|0;if(!(c<<24>>24)){g=0;h=f;break}if(c<<24>>24==f<<24>>24){e=e+1|0;b=b+1|0}else{g=c;h=f;break}}i=d;return (g&255)-(h&255)|0}function Gsd(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=b;b=c;while(1){c=a[e>>0]|0;f=c<<24>>24;g=(c+-65<<24>>24&255)<26?f+32|0:f;f=g&255;c=a[b>>0]|0;h=c<<24>>24;j=(c+-65<<24>>24&255)<26?h+32|0:h;if(!(f<<24>>24)){k=g;l=j;m=4;break}if(f<<24>>24==(j&255)<<24>>24){e=e+1|0;b=b+1|0}else{k=g;l=j;m=4;break}}if((m|0)==4){i=d;return (k&255)-(l&255)|0}return 0}function Hsd(a){a=a|0;var b=0,c=0;b=i;c=xEi(a)|0;i=b;return c|0}function Isd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+272|0;e=d;f=d+4|0;c[e>>2]=b;rEi(f,255,632192,e)|0;rri(a,f,SEi(f|0)|0);i=d;return}function Jsd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=Im;e=i;f=a[b>>0]|0;g=f<<24>>24;if((g|0)==43){h=0;j=3}else if((g|0)==45){h=1;j=3}else{k=f;l=0;m=b}if((j|0)==3){j=b+1|0;k=a[j>>0]|0;l=h;m=j}if((k+-48<<24>>24&255)<10){j=k;n=0.0;h=m;while(1){o=n*10.0+ +((j<<24>>24)+-48|0);f=h+1|0;g=a[f>>0]|0;if((g+-48<<24>>24&255)<10){j=g;n=o;h=f}else{p=g;q=o;r=f;break}}}else{p=k;q=0.0;r=m}if(p<<24>>24==46){p=r+1|0;m=a[p>>0]|0;if((m+-48<<24>>24&255)<10){k=m;m=r;n=q;h=p;o=.1;while(1){s=n+o*+((k<<24>>24)+-48|0);j=m+2|0;k=a[j>>0]|0;if((k+-48<<24>>24&255)>=10){t=s;u=j;break}else{f=h;n=s;h=j;o=o*.1;m=f}}}else{t=q;u=p}}else{t=q;u=r}if(l)v=-t;else v=t;if(!d){w=ea(v);i=e;return ea(w)}c[d>>2]=u-b;w=ea(v);i=e;return ea(w)}function Ksd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=c[e>>2];uEi(a,b,d,g)|0;i=f;return}function Lsd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+10272|0;f=e+16|0;g=e+32|0;h=e;c[h>>2]=d;c[f>>2]=c[h>>2];uEi(g,10240,b,f)|0;rri(a,g,SEi(g|0)|0);i=e;return}function Msd(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if(!c){i=e;return}else f=0;do{g=f<<1;h=a[b+g>>0]|0;j=h<<24>>24;do if(h<<24>>24>=58){k=j<<4;if(h<<24>>24<91){l=k+-880|0;break}else{l=k+144|0;break}}else l=(j<<4)+-768|0;while(0);j=a[b+(g|1)>>0]|0;h=j<<24>>24;do if(j<<24>>24>=58)if(j<<24>>24<91){m=h+-55|l&255;break}else{m=h+169|l;break}else m=h+-48|l&255;while(0);a[d+f>>0]=m;f=f+1|0}while((f|0)!=(c|0));i=e;return}function Nsd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;f=SEi(b|0)|0;g=SEi(d|0)|0;Dri(a,g+f|0);Ari(a,b,f)|0;Gri(a,d,g)|0;i=e;return}function Osd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=SEi(e|0)|0;h=a[d>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[d+4>>2]|0;Dri(b,j+g|0);j=a[d>>0]|0;if(!(j&1)){k=d+1|0;l=(j&255)>>>1}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0}Ari(b,k,l)|0;Gri(b,e,g)|0;i=f;return}function Psd(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=i;d=a[b>>0]|0;if(!(d<<24>>24)){e=0;i=c;return e|0}f=b+1|0;g=(d<<24>>24)+-48|0;d=a[f>>0]|0;if((d+-48<<24>>24&255)<9){h=b+2|0;j=3;k=4;l=a[h>>0]|0;m=(g*10|0)+-48+(d<<24>>24)|0;n=h}else{j=2;k=3;l=d;m=g;n=f}if(!(l<<24>>24)){o=0;p=0;q=0;r=114}else if(l<<24>>24==46){f=a[b+j>>0]|0;if(!(f<<24>>24)){o=0;p=0;q=0;r=114}else{j=b+k|0;s=a[j>>0]|0;t=(f<<24>>24)+-48|0;u=j;v=7}}else{s=l;t=0;u=n;v=7}do if((v|0)==7){if(!(s<<24>>24)){o=0;p=t;q=0;r=114;break}else if(s<<24>>24==46){n=a[u+1>>0]|0;if(!(n<<24>>24)){o=0;p=t;q=0;r=114;break}l=u+2|0;w=a[l>>0]|0;x=(n<<24>>24)+-48|0;y=l}else{w=s;x=0;y=u}if(w<<24>>24){l=w<<24>>24;n=a[y+1>>0]|0;if(n<<24>>24){j=(n<<24>>24)+-48|0;n=a[y+2>>0]|0;if(n<<24>>24){f=(j*10|0)+-48+(n<<24>>24)|0;n=a[y+3>>0]|0;if(!(n<<24>>24)){o=x;p=t;q=f;r=l}else{o=x;p=t;q=(f*10|0)+-48+(n<<24>>24)|0;r=l}}else{o=x;p=t;q=j;r=l}}else{o=x;p=t;q=0;r=l}}else{o=x;p=t;q=0;r=114}}while(0);t=((m|0)%10|0)<<24|(((m|0)/10|0|0)%10|0)<<28|((p|0)%10|0)<<20|((o|0)%10|0)<<16;switch(r|0){case 98:case 66:{z=t|24576;break}case 114:case 102:case 82:case 70:{z=t|32768;break}case 100:case 68:{z=t|8192;break}case 97:case 65:{z=t|16384;break}default:z=t}e=(((q|0)/100|0|0)%10|0)<<8|z|(((q|0)/10|0|0)%10|0)<<4|((q|0)%10|0);i=c;return e|0}function Qsd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+32|0;h=g+12|0;j=g;a:do if((f|0)==1)k=0;else{l=e+4|0;m=e+8|0;n=f;o=0;while(1){p=Kri(b,d,o)|0;if((p|0)==-1){k=o;break a}if(p>>>0>o>>>0){vri(j,b,o,p-o|0,b);q=c[l>>2]|0;if((q|0)==(c[m>>2]|0))nO(e,j);else{if(!q)r=0;else{sri(q,j);r=c[l>>2]|0}c[l>>2]=r+12}xri(j);s=n+-1|0}else s=n;q=p+1|0;if((s|0)==1){k=q;break}else{n=s;o=q}}}while(0);s=a[b>>0]|0;if(!(s&1))t=(s&255)>>>1;else t=c[b+4>>2]|0;if(k>>>0>=t>>>0){i=g;return}vri(h,b,k,-1,b);b=e+4|0;k=c[b>>2]|0;if((k|0)==(c[e+8>>2]|0))nO(e,h);else{if(!k)u=0;else{sri(k,h);u=c[b>>2]|0}c[b>>2]=u+12}xri(h);i=g;return}function Rsd(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;if((b|0)>3){g=b+-4|0;h=g&-4;j=h+4|0;k=b;l=a;m=e;while(1){n=da(c[l>>2]|0,1540483477)|0;o=(da(n>>>24^n,1540483477)|0)^(da(m,1540483477)|0);k=k+-4|0;if((k|0)<=3){p=o;break}else{l=l+4|0;m=o}}q=g-h|0;r=a+j|0;s=p}else{q=b;r=a;s=e}if((q|0)==3){t=(d[r+2>>0]|0)<<16;u=7}else if((q|0)==1){v=0;u=8}else if((q|0)==2){t=0;u=7}else w=0;if((u|0)==7){v=(d[r+1>>0]|0)<<8|t;u=8}if((u|0)==8)w=da((d[r>>0]|0)^v,1540483477)|0;v=da(b,1540483477)|0;b=(da((da(w>>>24^w,1540483477)|0)^(da(s,1540483477)|0),1540483477)|0)^(da(v>>>24^v,1540483477)|0);v=da(b>>>13^b,1540483477)|0;i=f;return v>>>15^v|0}function Ssd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+64|0;e=d+48|0;f=d+36|0;g=d+24|0;h=d+12|0;j=d;Xpe(e);k=a[e>>0]|0;if(!(k&1))l=(k&255)>>>1;else l=c[e+4>>2]|0;if(!l){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;xri(e);i=d;return}rri(g,3653512,0);fsd(f,e,g);xri(g);if(qqd(f)|0)yri(e,f)|0;else{rri(j,3653512,0);fsd(h,e,j);yri(e,h)|0;xri(h);xri(j)}if(GPc(e)|0)sri(b,e);else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0}xri(f);xri(e);i=d;return}function Tsd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(224,b,1,16,3653512,14)|0;Xsd(d);c[158050]=d;i=a;return}function Usd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=Ysd(c[158050]|0,a)|0;if(!d){c[a+24>>2]=2;i=b;return}e=a+16|0;f=Hqd(d,c[a+20>>2]|0,c[a+12>>2]|0,c[e>>2]|0)|0;d=a+24|0;if((f|0)==(c[e>>2]|0)){c[d>>2]=0;i=b;return}else{c[d>>2]=2;i=b;return}}function Vsd(a){a=a|0;return}function Wsd(a){a=a|0;var b=0;b=i;Zsd(c[158050]|0,a);i=b;return}function Xsd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+140|0;e=a;do{Bqd(e);e=e+28|0}while((e|0)!=(d|0));d=a+140|0;a=d+84|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function Ysd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+16|0;f=e;g=e+4|0;h=b+220|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;k=a[d>>0]|0;l=(k&255)>>>1;m=d+1|0;n=d+8|0;o=c[n>>2]|0;p=c[d+4>>2]|0;a:do if(!(k&1)){q=0;do{r=b+(q*12|0)+140|0;s=a[r>>0]|0;t=(s&1)==0;if(t)u=(s&255)>>>1;else u=c[b+(q*12|0)+144>>2]|0;b:do if((l|0)==(u|0)){if(t)v=r+1|0;else v=c[b+(q*12|0)+148>>2]|0;if(!l){w=q;x=21;break a}else{y=l;z=m;A=v}while(1){if((a[z>>0]|0)!=(a[A>>0]|0))break b;y=y+-1|0;if(!y){w=q;x=21;break a}else{z=z+1|0;A=A+1|0}}}while(0);q=q+1|0}while((q|0)<5)}else{q=0;do{r=b+(q*12|0)+140|0;t=a[r>>0]|0;s=(t&1)==0;if(s)B=(t&255)>>>1;else B=c[b+(q*12|0)+144>>2]|0;if((p|0)==(B|0)){if(s)C=r+1|0;else C=c[b+(q*12|0)+148>>2]|0;if(!(FEi(o,C,p)|0)){w=q;x=21;break a}}q=q+1|0}while((q|0)<5)}while(0);if((x|0)==21){c[b+(w<<2)+200>>2]=j;D=b+(w*28|0)|0;i=e;return D|0}w=c[b+200>>2]|0;j=c[b+204>>2]|0;x=j>>>0<w>>>0;p=x?j:w;w=c[b+208>>2]|0;j=w>>>0<p>>>0;C=j?w:p;p=c[b+212>>2]|0;w=p>>>0<C>>>0;o=(c[b+216>>2]|0)>>>0<(w?p:C)>>>0?4:w?3:j?2:x&1;x=b+(o*28|0)|0;if(Jqd(x)|0)Dqd(x)|0;if(Gqd(x,d,0,0)|0){c[b+(o<<2)+200>>2]=c[h>>2];yri(b+(o*12|0)+140|0,d)|0;D=x;i=e;return D|0}c[f>>2]=(a[d>>0]&1)==0?m:c[n>>2]|0;Lsd(g,632208,f);if(!(a[g>>0]&1))E=g+1|0;else E=c[g+8>>2]|0;Krd(E,0,3653512,54,1,0,0,0);xri(g);c[b+(o<<2)+200>>2]=0;g=b+(o*12|0)+140|0;if(!(a[g>>0]&1)){a[g+1>>0]=0;a[g>>0]=0;D=0;i=e;return D|0}else{a[c[b+(o*12|0)+148>>2]>>0]=0;c[b+(o*12|0)+144>>2]=0;D=0;i=e;return D|0}return 0}function Zsd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a[d>>0]|0;g=(f&255)>>>1;h=d+1|0;j=c[d+8>>2]|0;k=c[d+4>>2]|0;a:do if(!(f&1)){d=0;do{l=b+(d*12|0)+140|0;m=a[l>>0]|0;n=(m&1)==0;if(n)o=(m&255)>>>1;else o=c[b+(d*12|0)+144>>2]|0;b:do if((o|0)==(g|0)){if(!n)if(!(FEi(c[b+(d*12|0)+148>>2]|0,h,g)|0)){p=l;q=l;r=d;break a}else break;if(!g){p=l;q=l;r=d;break a}else{s=g;t=l+1|0;u=h}while(1){if((a[t>>0]|0)!=(a[u>>0]|0))break b;s=s+-1|0;if(!s){p=l;q=l;r=d;break a}else{t=t+1|0;u=u+1|0}}}while(0);d=d+1|0}while((d|0)<5);i=e;return}else{d=0;do{l=b+(d*12|0)+140|0;n=a[l>>0]|0;m=(n&1)==0;if(m)v=(n&255)>>>1;else v=c[b+(d*12|0)+144>>2]|0;c:do if((v|0)==(k|0)){if(!m)if(!(FEi(c[b+(d*12|0)+148>>2]|0,j,k)|0)){p=l;q=l;r=d;break a}else break;if(!k){p=l;q=l;r=d;break a}else{w=k;x=l+1|0;y=j}while(1){if((a[x>>0]|0)!=(a[y>>0]|0))break c;w=w+-1|0;if(!w){p=l;q=l;r=d;break a}else{x=x+1|0;y=y+1|0}}}while(0);d=d+1|0}while((d|0)<5);i=e;return}while(0);Dqd(b+(r*28|0)|0)|0;if(!(a[p>>0]&1)){a[q+1>>0]=0;a[p>>0]=0}else{a[c[b+(r*12|0)+148>>2]>>0]=0;c[b+(r*12|0)+144>>2]=0}c[b+(r<<2)+200>>2]=0;i=e;return}function _sd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=a[b>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[b+4>>2]|0;j=a[d>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[d+4>>2]|0;if((h|0)!=(l|0)){m=0;i=e;return m|0}if(g)n=b+1|0;else n=c[b+8>>2]|0;if(k)o=d+1|0;else o=c[d+8>>2]|0;if(g)p=(f&255)>>>1;else p=c[b+4>>2]|0;if(IEi(n,o,p)|0){m=0;i=e;return m|0}p=b+16|0;o=d+16|0;if(!((c[p>>2]|0)==(c[o>>2]|0)?(c[p+4>>2]|0)==(c[o+4>>2]|0):0)){m=0;i=e;return m|0}o=b+24|0;b=d+24|0;m=(c[o>>2]|0)==(c[b>>2]|0)?(c[o+4>>2]|0)==(c[b+4>>2]|0):0;i=e;return m|0}function $sd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;add(b,2467304,c[142294]|0,a,1);$cd(b,2646336,2646336,d,1);add(b,3142592,c[142260]|0,d+4|0,0);e=b+12|0;f=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);g=c[142300]|0;add(b,632240,g,a+16|0,1);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=8;bdd(b);add(b,2462848,g,a+24|0,1);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=8;bdd(b);i=d;return}function atd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=qdd(b,2467304,c[142294]|0,e,0)|0;if(f){if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else zXb(b,a,1);sdd(b)}f=a+16|0;g=c[142300]|0;h=qdd(b,632240,g,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+8)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){k=l;l=c[k+4>>2]|0;j=f;c[j>>2]=c[k>>2];c[j+4>>2]=l;c[h>>2]=m}else Bid(h,f,8);if(c[b>>2]&512){h=XEi(c[f>>2]|0)|0;m=f+4|0;c[f>>2]=XEi(c[m>>2]|0)|0;c[m>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}f=a+24|0;a=qdd(b,2462848,g,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;g=c[b+16>>2]|0;h=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=g+h|0;c[a>>2]=m;if((h|0)>=0?(l=g+(h+8)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){h=m;m=c[h+4>>2]|0;g=f;c[g>>2]=c[h>>2];c[g+4>>2]=m;c[a>>2]=l}else Bid(a,f,8);if(c[b>>2]&512){a=XEi(c[f>>2]|0)|0;l=f+4|0;c[f>>2]=XEi(c[l>>2]|0)|0;c[l>>2]=a}}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function btd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;NXb(b,a,1);Ndd(b);e=a+16|0;f=b+12|0;g=c[f>>2]|0;h=g+8|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(f,e,8);k=c[f>>2]|0;l=c[j>>2]|0}else{j=g;g=c[j+4>>2]|0;m=e;c[m>>2]=c[j>>2];c[m+4>>2]=g;c[f>>2]=h;k=h;l=b}b=a+24|0;a=k+8|0;if(a>>>0>l>>>0){Bid(f,b,8);i=d;return}else{l=k;k=c[l+4>>2]|0;h=b;c[h>>2]=c[l>>2];c[h+4>>2]=k;c[f>>2]=a;i=d;return}}function ctd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;OXb(b,a,1);Mdd(b);e=a+16|0;f=b+12|0;g=c[f>>2]|0;h=g+8|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0>b>>>0){Bid(f,e,8);k=e+4|0;l=e;m=k;n=c[e>>2]|0;o=c[k>>2]|0;p=c[f>>2]|0;q=c[j>>2]|0}else{j=g;g=c[j>>2]|0;k=c[j+4>>2]|0;j=e;c[j>>2]=g;c[j+4>>2]=k;c[f>>2]=h;l=e;m=e+4|0;n=g;o=k;p=h;q=b}b=XEi(n|0)|0;c[l>>2]=XEi(o|0)|0;c[m>>2]=b;b=a+24|0;a=p+8|0;if(a>>>0>q>>>0){Bid(f,b,8);q=b+4|0;r=b;s=q;t=c[b>>2]|0;u=c[q>>2]|0;v=XEi(t|0)|0;w=XEi(u|0)|0;c[r>>2]=w;c[s>>2]=v;i=d;return}else{q=p;p=c[q>>2]|0;m=c[q+4>>2]|0;q=b;c[q>>2]=p;c[q+4>>2]=m;c[f>>2]=a;r=b;s=b+4|0;t=p;u=m;v=XEi(t|0)|0;w=XEi(u|0)|0;c[r>>2]=w;c[s>>2]=v;i=d;return}}function dtd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;FXb(b,a,2467304,1);e=a+16|0;f=b+12|0;g=c[f>>2]|0;h=g+8|0;j=b+20|0;b=c[j>>2]|0;if(h>>>0<b>>>0){k=e;l=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=l;c[f>>2]=h;n=h;o=b}else{Gid(f,e,8);n=c[f>>2]|0;o=c[j>>2]|0}j=a+24|0;a=n+8|0;if(a>>>0<o>>>0){o=j;e=c[o+4>>2]|0;b=n;c[b>>2]=c[o>>2];c[b+4>>2]=e;c[f>>2]=a;i=d;return}else{Gid(f,j,8);i=d;return}}function etd(a,b){a=a|0;b=b|0;return}function ftd(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a>>2]|0;do if((d|0)!=-1){a=d&-1073741824;if((a|0)==1073741824){e=Umc(d&1073741823)|0;break}else if((a|0)==-2147483648){e=Tmc(d&1073741823)|0;break}else if((a|0)==-1073741824){e=Vmc(d&1073741823)|0;break}else{if((d|0)<=-1){e=632256;break}a=c[158068]|0;if(d>>>0>=(c[a+8>>2]|0)>>>0){e=632256;break}e=c[(c[a>>2]|0)+(d<<2)>>2]|0;break}}else e=632256;while(0);i=b;return e|0}function gtd(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;e=-1;f=0;g=0;while(1){if(!(e&1))h=g;else h=1<<31-f|g;f=f+1|0;if((f|0)==32){j=h;break}else{e=e>>>1;g=h}}h=SEi(a|0)|0;g=a+h|0;if((h|0)>0){k=j;l=a}else{m=j;n=m&268435455;o=n^268435455;i=b;return o|0}while(1){j=c[572464+(((d[l>>0]|0)^k&255)<<2)>>2]^k>>>8;l=l+1|0;if((l|0)==(g|0)){m=j;break}else k=j}n=m&268435455;o=n^268435455;i=b;return o|0}function htd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;c[a>>2]=-1;f=c[158070]|0;if(!f){i=e;return}g=c[f>>2]|0;h=f+4|0;if((g|0)==(h|0)){i=e;return}else j=g;while(1){g=c[j+16>>2]|0;f=-1;k=0;l=0;while(1){if(!(f&1))m=l;else m=1<<31-k|l;k=k+1|0;if((k|0)==32){n=m;break}else{f=f>>>1;l=m}}l=SEi(g|0)|0;f=g+l|0;if((l|0)>0){l=n;k=g;while(1){o=c[572464+(((d[k>>0]|0)^l&255)<<2)>>2]^l>>>8;k=k+1|0;if((k|0)==(f|0)){p=o;break}else l=o}}else p=n;if((p&268435455^268435455|0)==(b|0))c[a>>2]=c[j+20>>2];l=c[j+4>>2]|0;if(!l){f=j;while(1){k=c[f+8>>2]|0;if((c[k>>2]|0)==(f|0)){q=k;break}else f=k}}else{f=l;while(1){k=c[f>>2]|0;if(!k){q=f;break}else f=k}}if((q|0)==(h|0))break;else j=q}i=e;return}function itd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+16|0;f=d;g=d+8|0;h=c[158070]|0;if(!h){Wmc();j=xCi(12)|0;k=j+4|0;c[k>>2]=0;c[j+8>>2]=0;c[j>>2]=k;c[158070]=j;k=xCi(16)|0;c[k>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+4>>2]=60;c[158068]=k;l=j}else l=h;h=c[l+4>>2]|0;j=l+4|0;if(h){l=j;k=h;a:while(1){h=k;while(1){if((HEi(c[h+16>>2]|0,b)|0)>=0){m=h;break}h=c[h+4>>2]|0;if(!h){n=l;break a}}k=c[m>>2]|0;if(!k){n=m;break}else l=m}if((n|0)!=(j|0)?!((HEi(b,c[n+16>>2]|0)|0)<0|(n|0)==(j|0)):0){c[a>>2]=c[n+20>>2];i=d;return}}n=(SEi(b|0)|0)+1|0;j=zCi(n)|0;YEi(j|0,b|0,n|0)|0;c[g>>2]=-1;do if(Ymc(b,g)|0){n=c[g>>2]|1073741824;c[a>>2]=n;o=n}else{if(Zmc(b,g)|0){n=c[g>>2]|-2147483648;c[a>>2]=n;o=n;break}if(_mc(b,g)|0){n=c[g>>2]|-1073741824;c[a>>2]=n;o=n;break}n=c[158072]|0;c[158072]=n+1;c[a>>2]=n;m=c[158068]|0;l=m+8|0;k=(c[l>>2]|0)+1|0;c[l>>2]=k;h=m+12|0;p=c[h>>2]|0;q=p&2147483647;if(k>>>0>q>>>0){r=p<<1;s=(r|0)==0?1:r;do if(q>>>0<s>>>0)if((p|0)>-1){c[h>>2]=s;r=c[m>>2]|0;c[f>>2]=c[m+4>>2];c[e+0>>2]=c[f+0>>2];c[m>>2]=hOb(r,s<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[m+4>>2];c[e+0>>2]=c[f+0>>2];r=cOb(s<<2,4,e,0,3653512,352)|0;YEi(r|0,c[m>>2]|0,c[l>>2]<<2|0)|0;c[h>>2]=s;c[m>>2]=r;break}while(0);t=c[a>>2]|0;u=c[l>>2]|0}else{t=n;u=k}c[(c[m>>2]|0)+(u+-1<<2)>>2]=j;o=t}while(0);t=c[158070]|0;u=f;c[u>>2]=j;c[u+4>>2]=o;jtd(e,t,f);i=d;return}function jtd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=c[e>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((HEi(k,m)|0)<0){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((HEi(m,k)|0)>=0){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[g>>2]=p;u=o;v=p;break}else if((q|0)==8){c[g>>2]=t;u=s;v=t;break}else if((q|0)==9){c[g>>2]=r;u=g;v=r;break}}else{l=d+4|0;c[g>>2]=l;u=l;v=l}while(0);g=c[u>>2]|0;if(g){w=0;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}g=xCi(24)|0;r=e;e=c[r+4>>2]|0;q=g+16|0;c[q>>2]=c[r>>2];c[q+4>>2]=e;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=v;c[u>>2]=g;v=c[c[d>>2]>>2]|0;if(!v)z=g;else{c[d>>2]=v;z=c[u>>2]|0}GN(c[h>>2]|0,z);z=d+8|0;c[z>>2]=(c[z>>2]|0)+1;w=1;x=g;c[b>>2]=x;y=b+4|0;a[y>>0]=w;i=f;return}function ktd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153078];c[b+0>>2]=c[d+0>>2];d=bOb(104,b,0,16,3653512,12)|0;b=d+4|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;b=d+20|0;c[b>>2]=575440;c[d+24>>2]=1;c[b>>2]=633304;b=d+32|0;c[b>>2]=0;c[d+36>>2]=0;c[d+28>>2]=b;b=d+44|0;c[b>>2]=0;c[d+48>>2]=0;c[d+40>>2]=b;b=d+56|0;c[b>>2]=0;c[d+60>>2]=0;c[d+52>>2]=b;b=d+68|0;c[b>>2]=0;c[d+72>>2]=0;c[d+64>>2]=b;b=d+80|0;c[b>>2]=0;c[d+84>>2]=0;c[d+76>>2]=b;b=d+92|0;c[b>>2]=0;c[d+96>>2]=0;c[d+88>>2]=b;c[d+100>>2]=0;c[158074]=d;i=a;return}function ltd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[158074]|0;f=c[153078]|0;if(e)kud(e+20|0);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[158074]=0;i=a;return}function mtd(b){b=b|0;var d=0,e=0,f=0;d=i;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+32>>2]=0;c[b+36>>2]=2e3;c[b+40>>2]=-1;a[b+44>>0]=0;c[b+48>>2]=0;a[b+52>>0]=0;c[b+56>>2]=0;c[b+64>>2]=0;c[b+68>>2]=0;c[b+60>>2]=60;e=b+12|0;f=b+72|0;b=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(b|0));c[e+0>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;c[e+16>>2]=-1;i=d;return}function ntd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+72|0;g=c[f>>2]|0;if(g){h=g+4|0;c[h>>2]=(c[h>>2]|0)+-1;if(!(c[h>>2]|0))ko[c[(c[g>>2]|0)+4>>2]&4095](g);c[f>>2]=0}f=c[a>>2]|0;g=a+4|0;if((f|0)!=(c[g>>2]|0)){h=f;do{f=c[h>>2]|0;j=c[153078]|0;if(f)_wd(f);c[e>>2]=j;c[d+0>>2]=c[e+0>>2];eOb(f,d);c[h>>2]=0;h=h+4|0}while((h|0)!=(c[g>>2]|0))}h=a+100|0;f=c[h>>2]|0;if(f){j=a+104|0;while(1){k=c[j>>2]|0;if((k|0)==(f|0))break;l=k+-24|0;c[j>>2]=l;xri(k+-12|0);xri(l)}ACi(c[h>>2]|0)}xri(a+88|0);xri(a+76|0);if((c[a+68>>2]|0)>-1){h=a+56|0;j=c[h>>2]|0;c[e>>2]=c[a+60>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[h>>2]=0}h=c[a>>2]|0;if(!h){i=b;return}a=c[g>>2]|0;if((a|0)!=(h|0))c[g>>2]=a+(~((a+-4-h|0)>>>2)<<2);ACi(h);i=b;return}function otd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;if(d){d=c[(c[a>>2]|0)+(c[a+32>>2]<<2)>>2]|0;f=c[d+24>>2]|0;g=d+24|0;if(!f){h=-1;i=e;return h|0}else{j=g;k=f}a:while(1){f=k;while(1){if((c[f+16>>2]|0)>=(b|0)){l=f;break}f=c[f+4>>2]|0;if(!f){m=j;break a}}k=c[l>>2]|0;if(!k){m=l;break}else j=l}if((m|0)==(g|0)){h=-1;i=e;return h|0}if((c[m+16>>2]|0)>(b|0)){h=-1;i=e;return h|0}h=c[m+20>>2]|0;i=e;return h|0}m=c[a+4>>2]|0;g=c[a>>2]|0;if((m|0)==(g|0)){h=-1;i=e;return h|0}else n=0;while(1){a=c[g+(n<<2)>>2]|0;l=c[a+24>>2]|0;j=a+24|0;if(l){a=j;k=l;b:while(1){l=k;while(1){if((c[l+16>>2]|0)>=(b|0)){o=l;break}l=c[l+4>>2]|0;if(!l){p=a;break b}}k=c[o>>2]|0;if(!k){p=o;break}else a=o}if((p|0)!=(j|0)?(c[p+16>>2]|0)<=(b|0):0){q=p;break}}n=n+1|0;if(n>>>0>=m-g>>2>>>0){h=-1;r=20;break}}if((r|0)==20){i=e;return h|0}h=c[q+20>>2]|0;i=e;return h|0}function ptd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[b+104>>2]|0;g=c[b+100>>2]|0;b=(f-g|0)/24|0;if((f|0)==(g|0)){h=0;i=e;return h|0}f=a[d>>0]|0;j=(f&255)>>>1;k=d+1|0;l=c[d+8>>2]|0;m=c[d+4>>2]|0;a:do if(!(f&1)){d=0;while(1){n=g+(d*24|0)|0;o=a[n>>0]|0;p=(o&1)==0;if(p)q=(o&255)>>>1;else q=c[g+(d*24|0)+4>>2]|0;b:do if((q|0)==(j|0)){if(!p)if(!(FEi(c[g+(d*24|0)+8>>2]|0,k,j)|0)){r=d;break a}else break;if(!j){r=d;break a}else{s=j;t=n+1|0;u=k}while(1){if((a[t>>0]|0)!=(a[u>>0]|0))break b;s=s+-1|0;if(!s){r=d;break a}else{t=t+1|0;u=u+1|0}}}while(0);d=d+1|0;if(d>>>0>=b>>>0){h=0;break}}i=e;return h|0}else{d=0;while(1){n=g+(d*24|0)|0;p=a[n>>0]|0;o=(p&1)==0;if(o)v=(p&255)>>>1;else v=c[g+(d*24|0)+4>>2]|0;c:do if((v|0)==(m|0)){if(!o)if(!(FEi(c[g+(d*24|0)+8>>2]|0,l,m)|0)){r=d;break a}else break;if(!m){r=d;break a}else{w=m;x=n+1|0;y=l}while(1){if((a[x>>0]|0)!=(a[y>>0]|0))break c;w=w+-1|0;if(!w){r=d;break a}else{x=x+1|0;y=y+1|0}}}while(0);d=d+1|0;if(d>>>0>=b>>>0){h=0;break}}i=e;return h|0}while(0);h=g+(r*24|0)+12|0;i=e;return h|0}function qtd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[(c[a>>2]|0)+(b<<2)>>2]|0)+52>>2]|0;if((e|0)!=-1){f=e;i=d;return f|0}f=c[a+36>>2]|0;i=d;return f|0}function rtd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[153078];c[d+0>>2]=c[e+0>>2];e=bOb(84,d,0,16,3653512,85)|0;iud(e,c[a+72>>2]|0);i=b;return e|0}function std(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+96|0;e=d+12|0;f=d+48|0;g=d+24|0;h=d+60|0;j=d+84|0;k=d;l=d+36|0;m=d+72|0;n=b+52|0;a[n>>0]=0;o=b+4|0;p=c[b>>2]|0;if((c[o>>2]|0)==(p|0))q=0;else{r=p;p=0;do{dxd(c[r+(p<<2)>>2]|0);r=c[b>>2]|0;a[n>>0]=a[n>>0]|a[(c[r+(p<<2)>>2]|0)+43>>0];p=p+1|0;s=(c[o>>2]|0)-r>>2}while(p>>>0<s>>>0);q=s}p=c[b+40>>2]|0;r=(p|0)==-1?2147483647:p;p=b+32|0;c[p>>2]=-1;o=(q|0)==0;n=0;while(1){s=b+(n<<2)+12|0;c[s>>2]=-1;a:do if(!o){t=c[b>>2]|0;u=1<<n;v=0;while(1){w=c[t+(v<<2)>>2]|0;if((c[w+16>>2]|0)>0?(c[w+32>>2]|0)<=(r|0):0){if((c[p>>2]|0)<0)c[p>>2]=v;if(c[w+36>>2]&u){x=v;break}}v=v+1|0;if(v>>>0>=q>>>0)break a}c[s>>2]=x}while(0);if((n|0)==1){n=n+1|0;continue}v=c[s>>2]|0;b:do if((v|0)!=-1&(n|0)>0){u=0;while(1){t=c[b+(u<<2)+12>>2]|0;if((t|0)!=-1&(t|0)<(v|0))break;u=u+1|0;if((u|0)>=(n|0))break b}c[s>>2]=-1}while(0);n=n+1|0;if((n|0)==5)break}n=c[p>>2]|0;if((n|0)<0){c[p>>2]=0;y=0}else y=n;n=c[(c[b>>2]|0)+(y<<2)>>2]|0;if(!(a[632448]|0)){rri(e,659568,5);y=vvd(e)|0;xri(e);c[158110]=y;a[632448]=1}if(!(a[632464]|0)){rri(f,632472,15);y=vvd(f)|0;xri(f);c[158114]=y;a[632464]=1}if(!(a[632496]|0)){rri(g,632504,15);y=vvd(g)|0;xri(g);c[158122]=y;a[632496]=1}if(!(a[632528]|0)){rri(h,3655040,4);y=vvd(h)|0;xri(h);c[158130]=y;a[632528]=1}if(!(a[632544]|0)){rri(j,632552,9);y=vvd(j)|0;xri(j);c[158134]=y;a[632544]=1}y=b+36|0;c[y>>2]=2e3;j=n+24|0;h=c[j>>2]|0;g=n+24|0;if(h){n=c[158110]|0;f=g;e=h;c:while(1){p=e;while(1){if((c[p+16>>2]|0)>=(n|0)){z=p;break}p=c[p+4>>2]|0;if(!p){A=f;break c}}e=c[z>>2]|0;if(!e){A=z;break}else f=z}if((A|0)!=(g|0)?(n|0)>=(c[A+16>>2]|0):0){wvd(k,c[A+20>>2]|0);if(!(ttd(k,y)|0)){c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;y=a[k>>0]|0;if(!(y&1))B=(y&255)>>>1;else B=c[k+4>>2]|0;Pri(m,659576,18,B+18|0);if(!(a[k>>0]&1))C=k+1|0;else C=c[k+8>>2]|0;Gri(m,C,B)|0;yO(l,m,659600);if(!(a[l>>0]&1))D=l+1|0;else D=c[l+8>>2]|0;Krd(D,0,3653512,217,1,0,0,0);xri(l);xri(m)}xri(k);E=c[j>>2]|0}else E=h;h=b+44|0;a[h>>0]=0;j=(E|0)==0;if(!j){k=c[158114]|0;m=g;l=E;d:while(1){D=l;while(1){if((c[D+16>>2]|0)>=(k|0)){F=D;break}D=c[D+4>>2]|0;if(!D){G=m;break d}}l=c[F>>2]|0;if(!l){G=F;break}else m=F}if(((G|0)!=(g|0)?(k|0)>=(c[G+16>>2]|0):0)?(c[G+20>>2]|0)==(c[158130]|0):0){a[h>>0]=1;h=b+48|0;c[h>>2]=0;if(j){i=d;return}else H=h}else{h=b+48|0;c[h>>2]=0;if(j){i=d;return}else H=h}h=c[158122]|0;j=g;G=E;e:while(1){E=G;while(1){if((c[E+16>>2]|0)>=(h|0)){I=E;break}E=c[E+4>>2]|0;if(!E){J=j;break e}}G=c[I>>2]|0;if(!G){J=I;break}else j=I}if((J|0)==(g|0)){i=d;return}if((h|0)<(c[J+16>>2]|0)){i=d;return}h=c[J+20>>2]|0;if((h|0)==(c[158130]|0)){c[H>>2]=1;i=d;return}if((h|0)!=(c[158134]|0)){i=d;return}c[H>>2]=2;i=d;return}}else a[b+44>>0]=0;c[b+48>>2]=0;i=d;return}function ttd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+16|0;f=e+4|0;g=e;sri(f,b);h=a[f>>0]|0;if(!(h&1)){j=f+1|0;k=j;l=j;m=f+8|0}else{j=f+8|0;k=c[j>>2]|0;l=f+1|0;m=j}j=f+4|0;n=k;k=h;while(1){o=(k&1)==0;if(o){p=l;q=(k&255)>>>1}else{p=c[m>>2]|0;q=c[j>>2]|0}if((n|0)==(p+q|0))break;h=a[n>>0]|0;r=h<<24>>24;a[n>>0]=(h+-97<<24>>24&255)<26?r+224|0:r;n=n+1|0;k=a[f>>0]|0}if(o)s=f+1|0;else s=c[f+8>>2]|0;o=b+4|0;k=0;while(1){n=a[b>>0]|0;q=(n&1)==0;if(q)t=(n&255)>>>1;else t=c[o>>2]|0;p=c[632308+(k*12|0)>>2]|0;if((t|0)>=(p|0)?(FEi(s,c[632304+(k*12|0)>>2]|0,p)|0)==0:0){if(q)u=(n&255)>>>1;else u=c[o>>2]|0;if((u|0)==(p|0)){v=k;w=23;break}c[g>>2]=0;n=s+p|0;p=DEi(n,g,10)|0;if((c[g>>2]|0)!=(n|0)){x=p;y=k;w=25;break}}k=k+1|0;if(k>>>0>=5){z=0;w=27;break}}if((w|0)==23){c[d>>2]=c[632312+(v*12|0)>>2];z=1;xri(f);i=e;return z|0}else if((w|0)==25){c[d>>2]=(c[632312+(y*12|0)>>2]|0)+x;z=1;xri(f);i=e;return z|0}else if((w|0)==27){xri(f);i=e;return z|0}return 0}function utd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+16|0;e=h;d=h+8|0;j=b+88|0;k=a[j>>0]|0;if(!(k&1))l=(k&255)>>>1;else l=c[b+92>>2]|0;if(!l){i=h;return}l=Ymd(j,f,g)|0;if(!l){if(!(a[j>>0]&1))m=j+1|0;else m=c[b+96>>2]|0;c[e>>2]=(a[653480]&1)==0?653481|0:c[163372]|0;c[e+4>>2]=m;Ird(632624,e);i=h;return}m=c[l+52>>2]|0;if(!m){if(!(a[j>>0]&1))n=j+1|0;else n=c[b+96>>2]|0;c[e>>2]=(a[653480]&1)==0?653481|0:c[163372]|0;c[e+4>>2]=n;Ird(632568,e);i=h;return}e=b+4|0;n=c[b>>2]|0;j=n;l=(c[e>>2]|0)-j|0;g=l>>2;f=m+4|0;k=((c[f>>2]|0)-(c[m>>2]|0)>>2)+g|0;o=b+8|0;if((c[o>>2]|0)-j>>2>>>0<k>>>0){if(!k)p=0;else p=xCi(k<<2)|0;YEi(p|0,n|0,l|0)|0;c[b>>2]=p;c[e>>2]=p+(g<<2);c[o>>2]=p+(k<<2);if(n)ACi(n)}n=c[m>>2]|0;if((c[f>>2]|0)==(n|0)){i=h;return}else{q=n;r=0}do{n=Ywd(c[q+(r<<2)>>2]|0)|0;c[d>>2]=n;k=c[e>>2]|0;if((k|0)==(c[o>>2]|0))ytd(b,d);else{if(!k)s=0;else{c[k>>2]=n;s=c[e>>2]|0}c[e>>2]=s+4}r=r+1|0;q=c[m>>2]|0}while(r>>>0<(c[f>>2]|0)-q>>2>>>0);i=h;return}function vtd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=d+8|0;a[g>>0]=0;h=b+4|0;j=c[b>>2]|0;k=(c[h>>2]|0)-j>>2;if(!k){i=d;return}l=b+72|0;m=k;k=j;while(1){j=m+-1|0;if(!(bxd(c[k+(j<<2)>>2]|0,c[l>>2]|0,g)|0)){n=(c[b>>2]|0)+(j<<2)|0;o=c[n>>2]|0;p=c[153078]|0;if(o)_wd(o);c[f>>2]=p;c[e+0>>2]=c[f+0>>2];eOb(o,e);c[n>>2]=0;o=c[b>>2]|0;p=n-o>>2;n=o+(p+1<<2)|0;q=(c[h>>2]|0)-n|0;aFi(o+(p<<2)|0,n|0,q|0)|0;n=o+((q>>2)+p<<2)|0;p=c[h>>2]|0;if((p|0)!=(n|0))c[h>>2]=p+(~((p+-4-n|0)>>>2)<<2)}if(!j)break;m=j;k=c[b>>2]|0}i=d;return}function wtd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=b+104|0;j=b+100|0;k=c[j>>2]|0;if((c[h>>2]|0)!=(k|0)){l=k;k=0;do{m=l+(k*24|0)+12|0;if(!(Ymd(m,d,e)|0)){n=l+(k*24|0)|0;if(!(a[n>>0]&1))o=n+1|0;else o=c[l+(k*24|0)+8>>2]|0;if(!(a[m>>0]&1))p=m+1|0;else p=c[l+(k*24|0)+20>>2]|0;c[g>>2]=(a[653480]&1)==0?653481|0:c[163372]|0;c[g+4>>2]=o;c[g+8>>2]=p;Ird(632672,g)}k=k+1|0;l=c[j>>2]|0}while(k>>>0<(((c[h>>2]|0)-l|0)/24|0)>>>0)}vtd(b);l=c[b>>2]|0;h=b+4|0;if((l|0)==(c[h>>2]|0)){i=f;return}k=b+72|0;j=b+56|0;b=l;do{l=c[b>>2]|0;axd(l,c[k>>2]|0);g=l+16|0;if((c[g>>2]|0)>0){p=0;do{iwd((c[(c[l>>2]|0)+(p<<2)>>2]|0)+4|0,c[k>>2]|0,j);p=p+1|0}while((p|0)<(c[g>>2]|0))}b=b+4|0}while((b|0)!=(c[h>>2]|0));i=f;return}function xtd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=c[a>>2]|0;h=a+4|0;a=c[h>>2]|0;if((g|0)==(a|0)){i=f;return}else{j=a;k=g}while(1){g=c[k>>2]|0;a=g+16|0;if((c[a>>2]|0)>0){l=0;do{hwd((c[(c[g>>2]|0)+(l<<2)>>2]|0)+4|0,b,d,e);l=l+1|0}while((l|0)<(c[a>>2]|0));m=c[h>>2]|0}else m=j;k=k+4|0;if((k|0)==(m|0))break;else j=m}i=f;return}function ytd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function ztd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;dwd(a+4|0);hnc(a+592|0);e=a+628|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[a+640>>2]=b;c[a+644>>2]=0;c[a+648>>2]=0;c[a+652>>2]=0;c[a+656>>2]=1;c[a+660>>2]=0;c[a+668>>2]=0;c[a+672>>2]=0;c[a+664>>2]=a+668;c[a+676>>2]=-1;b=a+680|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return}function Atd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b+648>>2]|0;if(g)BCi(g);g=ync()|0;In[c[(c[g>>2]|0)+204>>2]&4095](g,b+652|0);g=c[b+680>>2]|0;if(g){h=b+684|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~((j+-4-g|0)>>>2)<<2);ACi(g)}Ntd(b+664|0,c[b+668>>2]|0);if(!(a[b+628>>0]&1)){k=b+4|0;lwd(k);i=d;return}g=c[b+636>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);k=b+4|0;lwd(k);i=d;return}function Btd(a){a=a|0;var b=0;b=a+656|0;c[b>>2]=(c[b>>2]|0)+1;return}function Ctd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+656|0;g=(c[f>>2]|0)+-1|0;c[f>>2]=g;if(g){i=b;return}Atd(a);c[e>>2]=c[153078];c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function Dtd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[g>>2]=c[a>>2];c[f+0>>2]=c[g+0>>2];g=xvd(b,d,f,5,e+4|0)|0;i=e;return g|0}function Etd(){var a=0,b=0,d=0,e=0;a=i;b=Gzc()|0;d=c[158232]|0;if(d){Jzc(b,d);c[158232]=0}d=c[158238]|0;if((d|0)>0)e=0;else{c[158238]=0;i=a;return}do{Jzc(b,c[(c[158234]|0)+(e<<3)+4>>2]|0);e=e+1|0}while((e|0)!=(d|0));c[158238]=0;i=a;return}function Ftd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;j=i;i=i+80|0;k=j+24|0;l=j+36|0;m=j+40|0;n=j+56|0;o=j+8|0;p=j;q=j+32|0;r=ync()|0;s=c[b+640>>2]|0;if((s|0)==2){t=b+676|0;u=n8b()|0;v=c[u>>2]|0;if(!v){w=0;i=j;return w|0}c[p>>2]=v;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(k,v,p);x=c[k>>2]|0;y=c[v+28>>2]|0;if((x|0)==-1){z=y+(c[v+32>>2]<<3)|0;break}else{z=y+(x<<3)|0;break}}else z=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((z|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[z+4>>2]|0,(v|0)!=0):0)A=v;else B=14}else B=14;if((B|0)==14){v=hQb(c[u>>2]|0)|0;if(!v){w=0;i=j;return w|0}else A=v}v=tBc()|0;if(!v){u$b(m,A,1);u=~~ea(ea(g[m+8>>2])+ea(.5))>>>0;C=~~ea(ea(g[m+12>>2])+ea(.5))>>>0;D=u}else{C=c[v+104>>2]|0;D=c[v+100>>2]|0}v=Gzc()|0;u=c[t>>2]|0;a:do if((u|0)==-1){m=c[158232]|0;if(m){Jzc(v,m);c[158232]=0}m=Hzc(v,D,C,2,(a[A+620>>0]|0)!=0?9:7,0,0,1)|0;if(m)In[c[(c[m>>2]|0)+36>>2]&4095](m,633264);c[158232]=m;E=0;F=m;B=38}else{m=c[158238]|0;b:do if((m|0)>0){z=c[158234]|0;p=0;while(1){if((c[z+(p<<3)>>2]|0)==(u|0)){G=p;break}p=p+1|0;if((p|0)>=(m|0)){H=0;break b}}p=c[z+(G<<3)+4>>2]|0;if(!p)H=1;else{I=p;break a}}else H=0;while(0);m=Hzc(v,D,C,2,(a[A+620>>0]|0)!=0?9:7,0,0,1)|0;if(m)In[c[(c[m>>2]|0)+36>>2]&4095](m,633264);p=c[t>>2]|0;x=(c[158238]|0)+1|0;c[158238]=x;y=c[158240]|0;J=y&2147483647;if(x>>>0>J>>>0){K=y<<1;L=(K|0)==0?1:K;do if(J>>>0<L>>>0)if((y|0)>-1){c[158240]=L;K=c[158234]|0;c[l>>2]=c[158236];c[k+0>>2]=c[l+0>>2];c[158234]=hOb(K,L<<3,4,k,0,3653512,370)|0;break}else{c[l>>2]=c[158236];c[k+0>>2]=c[l+0>>2];K=cOb(L<<3,4,k,0,3653512,352)|0;YEi(K|0,c[158234]|0,c[158238]<<3|0)|0;c[158240]=L;c[158234]=K;break}while(0);M=c[158238]|0}else M=x;L=M+-1|0;y=c[158234]|0;c[y+(L<<3)>>2]=p;c[y+(L<<3)+4>>2]=m;E=H;F=m;B=38}while(0);if((B|0)==38)if((F|0)==0|E)I=F;else{B$b(n,A);n1b(o,n);zBc(F,c[o>>2]|0,c[o+4>>2]|0,c[o+8>>2]|0,c[o+12>>2]|0);ABc(F,0);I=F}if(!I){w=0;i=j;return w|0}F=(c[t>>2]|0)!=-1?t:632904;LDc(I,1);NBc(I,F)|0;w=0;i=j;return w|0}else if(!s){s=owd(b+4|0,d,e,f,h,b)|0;if(!(_n[c[(c[r>>2]|0)+232>>2]&4095](r,2)|0)){h=c[(c[r>>2]|0)+208>>2]|0;c[q>>2]=c[b+652>>2];c[k+0>>2]=c[q+0>>2];Dn[h&511](r,k,e,f)}w=(s|0)!=0?s:b+592|0;i=j;return w|0}else{w=0;i=j;return w|0}return 0}function Gtd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+592|0;inc(j,0,0);if(a[b+224>>0]|0)inc(j,1,2);if(c[b+292>>2]|0)inc(j,2,1);k=b+644|0;if((c[k>>2]|0)<=0){i=e;return}l=b+648|0;b=0;do{m=c[158074]|0;c[g>>2]=c[(c[l>>2]|0)+(b*52|0)>>2];c[f+0>>2]=c[g+0>>2];yvd(d,m,f,h);inc(j,3,b+4|0);b=b+1|0}while((b|0)<(c[k>>2]|0));i=e;return}function Htd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b+592|0;if(!(c[f>>2]|0)){Gtd(b,d);i=e;return}if(c[b+300>>2]|0){jnc(f,3);i=e;return}g=a[b+603>>0]|0;h=g<<24>>24;if(g<<24>>24!=-1){g=b+644|0;j=c[g>>2]|0;if((j|0)>0){k=d+48|0;l=d+48|0;d=b+648|0;b=j;j=0;while(1){m=c[k>>2]|0;if(m){n=c[(c[d>>2]|0)+(j*52|0)>>2]|0;o=l;p=m;a:while(1){m=p;while(1){if((c[m+16>>2]|0)>=(n|0)){q=m;break}m=c[m+4>>2]|0;if(!m){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if(((r|0)!=(l|0)?(n|0)>=(c[r+16>>2]|0):0)?(c[r+20>>2]|0)!=0:0){inc(f,h,j+4|0);s=c[g>>2]|0}else s=b}else s=b;j=j+1|0;if((j|0)>=(s|0))break;else b=s}}jnc(f,3)}inc(f,0,0);i=e;return}function Itd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=c[b+640>>2]|0;if((g|0)==2){h=rBc()|0;if(!(h&(c[155287]|0)>0)){j=0;i=e;return j|0}j=(a[621178]|0)!=0;i=e;return j|0}else if((g|0)==1){j=0;i=e;return j|0}else{do if(!(a[621044]|0)){if((c[b+300>>2]|0)!=0?(c[b+304>>2]|0)!=0:0)break;Ird(659312,f);g=b+628|0;if(!(a[g>>0]&1))k=g+1|0;else k=c[b+636>>2]|0;c[f>>2]=(a[653480]&1)==0?653481:c[163372]|0;c[f+4>>2]=k;Ird(632968,f);j=0;i=e;return j|0}while(0);if(!(mwd(b+4|0)|0)){j=0;i=e;return j|0}k=b+644|0;if((c[k>>2]|0)>4){Ird(659312,f);c[f>>2]=(a[653480]&1)==0?653481:c[163372]|0;c[f+4>>2]=4;Ird(633056,f);j=0;i=e;return j|0}g=b+652|0;if(c[g>>2]|0){j=1;i=e;return j|0}if(((a[b+224>>0]|0)==0?(c[b+300>>2]|0)==0:0)?(a[b+601>>0]|0)==-1:0)l=(c[b+292>>2]|0)!=0;else l=1;h=ync()|0;m=Km[c[(c[h>>2]|0)+200>>2]&127](h,c[k>>2]|0,c[b+648>>2]|0,d,l,(a[b+225>>0]|0)!=0)|0;c[g>>2]=m;if(m){j=1;i=e;return j|0}Ird(659312,f);c[f>>2]=(a[653480]&1)==0?653481:c[163372]|0;Ird(633128,f);j=0;i=e;return j|0}return 0}function Jtd(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+64|0;f=e+48|0;g=e+36|0;h=e+24|0;j=e+12|0;k=e;if(!(a[633184]|0)){rri(f,659104,9);l=vvd(f)|0;xri(f);c[158294]=l;a[633184]=1}if(!(a[633200]|0)){rri(g,633208,14);l=vvd(g)|0;xri(g);c[158298]=l;a[633200]=1}l=b+668|0;g=c[l>>2]|0;f=b+668|0;if(g){m=c[158294]|0;n=f;o=g;a:while(1){p=o;while(1){if((c[p+16>>2]|0)>=(m|0)){q=p;break}p=c[p+4>>2]|0;if(!p){r=n;break a}}o=c[q>>2]|0;if(!o){r=q;break}else n=q}if((r|0)!=(f|0)?(m|0)>=(c[r+16>>2]|0):0){wvd(h,c[r+20>>2]|0);r=h+1|0;m=h+8|0;q=0;while(1){n=q+1|0;if(!(Gsd((a[h>>0]&1)==0?r:c[m>>2]|0,c[632856+(q<<2)>>2]|0)|0)){s=q;break}if((n|0)<12)q=n;else{s=n;break}}if((s|0)==12){c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;q=a[h>>0]|0;if(!(q&1))t=(q&255)>>>1;else t=c[h+4>>2]|0;Pri(j,633224,19,t+19|0);Gri(j,(a[h>>0]&1)==0?r:c[m>>2]|0,t)|0;if(!(a[j>>0]&1))u=j+1|0;else u=c[j+8>>2]|0;Krd(u,0,3653512,444,1,0,0,0);xri(j);v=0}else v=s;xri(h);w=c[l>>2]|0;x=v}else y=13}else y=13;if((y|0)==13){w=g;x=d[b+224>>0]|0}if(!w){z=0;A=b+584|0;c[A>>2]=x;B=b+660|0;c[B>>2]=z;i=e;return}g=c[158298]|0;y=f;v=w;b:while(1){w=v;while(1){if((c[w+16>>2]|0)>=(g|0)){C=w;break}w=c[w+4>>2]|0;if(!w){D=y;break b}}v=c[C>>2]|0;if(!v){D=C;break}else y=C}if((D|0)==(f|0)){z=0;A=b+584|0;c[A>>2]=x;B=b+660|0;c[B>>2]=z;i=e;return}if((g|0)<(c[D+16>>2]|0)){z=0;A=b+584|0;c[A>>2]=x;B=b+660|0;c[B>>2]=z;i=e;return}wvd(k,c[D+20>>2]|0);D=a[k>>0]|0;if(!(D&1)){g=k+1|0;E=g;F=g;G=k+8|0}else{g=k+8|0;E=c[g>>2]|0;F=k+1|0;G=g}g=k+4|0;f=D;D=E;while(1){H=(f&1)==0;if(H){I=F;J=(f&255)>>>1}else{I=c[G>>2]|0;J=c[g>>2]|0}if((D|0)==(I+J|0))break;E=a[D>>0]|0;C=E<<24>>24;a[D>>0]=(E+-97<<24>>24&255)<26?C+224|0:C;f=a[k>>0]|0;D=D+1|0}if(H)K=mCi(k+1|0,633248)|0;else K=mCi(c[k+8>>2]|0,633248)|0;xri(k);z=(K|0)!=0&1;A=b+584|0;c[A>>2]=x;B=b+660|0;c[B>>2]=z;i=e;return}function Ktd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+16|0;m=h+8|0;n=h+4|0;o=h;p=b;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;q=c[b+296>>2]|0;if((q|0)!=0?(r=_td(q,g,b,d,l,m)|0,(r|0)!=0):0)s=(c[(c[r>>2]|0)+156>>2]|0)+20|0;else s=20;r=c[b+300>>2]|0;if((r|0)!=0?(q=_td(r,g,b,d,l,m)|0,(q|0)!=0):0)t=(c[(c[q>>2]|0)+156>>2]|0)+s|0;else t=s;s=c[b+304>>2]|0;if((s|0)!=0?(q=_td(s,g,b,d,l,m)|0,(q|0)!=0):0)u=(c[(c[q>>2]|0)+156>>2]|0)+t|0;else u=t;t=c[b+308>>2]|0;if((t|0)!=0?(q=_td(t,g,b,d,l,m)|0,(q|0)!=0):0)v=(c[(c[q>>2]|0)+156>>2]|0)+u|0;else v=u;u=c[b+312>>2]|0;if((u|0)!=0?(q=_td(u,g,b,d,l,m)|0,(q|0)!=0):0)w=(c[(c[q>>2]|0)+156>>2]|0)+v|0;else w=v;v=c[b+316>>2]|0;if((v|0)!=0?(q=_td(v,g,b,d,l,m)|0,(q|0)!=0):0)x=(c[(c[q>>2]|0)+156>>2]|0)+w|0;else x=w;w=x+15|0;if(w>>>0<2e3)if(!x){y=0;z=0}else{q=i;i=i+((1*w|0)+15&-16)|0;y=0;z=q}else{c[n>>2]=c[153134];c[j+0>>2]=c[n+0>>2];n=cOb(w,16,j,0,3653512,502)|0;y=n;z=n}n=z+15&-16;z=n;PEi(z|0,0,x|0)|0;c[n>>2]=p;p=z+4|0;n=d+0|0;w=p+16|0;do{a[p>>0]=a[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(w|0));n=z+20|0;p=0;while(1){w=c[b+(p<<2)+296>>2]|0;if((w|0)!=0?(q=_td(w,g,b,d,l,o)|0,(q|0)!=0):0)A=Rqc(c[q>>2]|0,e,f,n,0,0,0)|0;else A=n;p=p+1|0;if((p|0)>=6)break;else n=A}A=Rsd(z,x,-1756908916)|0;if(!y){i=h;return A|0}c[k>>2]=c[153134];c[j+0>>2]=c[k+0>>2];eOb(y,j);i=h;return A|0}function Ltd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;l=c[a+8>>2]|0;if(!l){m=0;i=e;return m|0}n=l<<2;o=n+15|0;if(o>>>0<2e3){p=i;i=i+((1*o|0)+15&-16)|0;q=0;r=p}else{c[k>>2]=c[153134];c[f+0>>2]=c[k+0>>2];k=cOb(o,16,f,0,3653512,539)|0;q=k;r=k}k=r+15&-16;r=k;o=k;k=0;while(1){c[j>>2]=c[(c[a>>2]|0)+(k<<2)>>2];c[f+0>>2]=c[j+0>>2];g[o>>2]=ea(g[(zvd(b,d,f,h)|0)>>2]);k=k+1|0;if((k|0)==(l|0))break;else o=o+4|0}o=Rsd(r,n,-1756908916)|0;if(!q){m=o;i=e;return m|0}c[h>>2]=c[153134];c[f+0>>2]=c[h+0>>2];eOb(q,f);m=o;i=e;return m|0}function Mtd(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,632912);c[158226]=c[b>>2];c[158232]=0;c[158234]=0;c[158238]=0;c[158240]=0;c[158236]=60;i=a;return}function Ntd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Ntd(a,c[b>>2]|0);Ntd(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Otd(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;c[a>>2]=0;hnc(a+4|0);g=a+40|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;sri(a+60|0,d);d=a+72|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[a+84>>2]=e;e=xCi(164)|0;c[e>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+4>>2]=60;c[e+16>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;c[e+20>>2]=60;g=e+32|0;c[e+52>>2]=0;c[e+56>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[e+48>>2]=60;c[e+60>>2]=0;c[e+64>>2]=0;c[e+68>>2]=0;c[e+72>>2]=-1;b[e+76>>1]=0;b[e+78>>1]=0;c[e+80>>2]=0;c[e+84>>2]=-1;b[e+88>>1]=0;b[e+90>>1]=0;c[e+92>>2]=0;c[e+96>>2]=-1;b[e+100>>1]=0;b[e+102>>1]=0;c[e+104>>2]=0;c[e+108>>2]=-1;b[e+112>>1]=0;b[e+114>>1]=0;c[e+116>>2]=0;c[e+120>>2]=-1;b[e+124>>1]=0;b[e+126>>1]=0;c[e+128>>2]=0;c[e+132>>2]=-1;b[e+136>>1]=0;b[e+138>>1]=0;c[e+140>>2]=0;c[e+144>>2]=-1;g=e+148|0;b[g+0>>1]=0;b[g+2>>1]=0;b[g+4>>1]=0;b[g+6>>1]=0;b[g+8>>1]=0;b[g+10>>1]=0;b[g+12>>1]=0;b[g+14>>1]=0;c[a>>2]=e;yri(d,653480)|0;i=f;return}function Ptd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+40|0;if(c[d>>2]|0){e=znc()|0;In[c[(c[e>>2]|0)+240>>2]&4095](e,c[d>>2]|0)}c[d>>2]=0;d=c[a>>2]|0;if(d){hrc(d);ACi(d)}xri(a+72|0);xri(a+60|0);i=b;return}function Qtd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=b+40|0;if(c[f>>2]|0){i=d;return}Zqc(e);c[e+8>>2]=c[b+84>>2];g=b+72|0;c[e+12>>2]=g;h=ync()|0;j=b+60|0;k=xo[c[(c[h>>2]|0)+224>>2]&2047](h,j,e)|0;c[f>>2]=k;if(!(a[g>>0]&1))l=g+1|0;else l=c[b+80>>2]|0;co[c[(c[h>>2]|0)+660>>2]&2047](h,k,l);l=c[e>>2]|0;if(l)$td(c[b>>2]|0,l)|0;l=c[e+4>>2]|0;if(l){k=b+4|0;h=l+0|0;l=k+36|0;do{c[k>>2]=c[h>>2];k=k+4|0;h=h+4|0}while((k|0)<(l|0))}do if(c[f>>2]|0){if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[b+68>>2]>>0]=0;c[b+64>>2]=0}if(!(a[g>>0]&1)){a[g+1>>0]=0;a[g>>0]=0;break}else{a[c[b+80>>2]>>0]=0;c[b+76>>2]=0;break}}while(0);_qc(e);i=d;return}function Rtd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+4|0;h=f;c[b>>2]=575440;c[b+4>>2]=1;c[b>>2]=633288;j=b+8|0;c[j>>2]=0;c[b+16>>2]=0;k=b+20|0;c[k>>2]=0;c[b+12>>2]=60;l=b+24|0;c[l>>2]=0;m=b+32|0;c[m>>2]=0;n=b+36|0;c[n>>2]=0;o=b+28|0;c[o>>2]=60;c[b+44>>2]=0;a[b+48>>0]=0;p=b+49|0;a[p>>0]=0;q=b+52|0;r=q+44|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));q=b+96|0;c[q>>2]=32;c[b+100>>2]=0;c[b+108>>2]=16;c[b+104>>2]=6;a[b+112>>0]=0;c[b+116>>2]=-1;c[b+120>>2]=e;c[b+124>>2]=0;c[b+132>>2]=0;c[b+136>>2]=0;c[b+128>>2]=60;a[b+140>>0]=0;a[b+141>>0]=0;if(!d)s=0;else{c[k>>2]=d;c[h>>2]=60;c[g+0>>2]=c[h+0>>2];c[j>>2]=hOb(0,d<<2,4,g,0,3653512,370)|0;s=c[n>>2]|0}do if((s&2147483647)>>>0<d>>>0)if((s|0)>-1){c[n>>2]=d;j=c[l>>2]|0;c[h>>2]=c[o>>2];c[g+0>>2]=c[h+0>>2];c[l>>2]=hOb(j,d<<4,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[o>>2];c[g+0>>2]=c[h+0>>2];j=cOb(d<<4,4,g,0,3653512,352)|0;YEi(j|0,c[l>>2]|0,c[m>>2]<<4|0)|0;c[n>>2]=d;c[l>>2]=j;break}while(0);a[p>>0]=1;p=b+72|0;l=p;c[l>>2]=-1;c[l+4>>2]=-1;l=b+80|0;c[l>>2]=0;c[l+4>>2]=0;c[b+88>>2]=0;l=(c[q>>2]|0)*20|0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];h=cOb(l,16,g,0,3653512,80)|0;c[b+92>>2]=h;b=h+((c[q>>2]|0)*20|0)|0;if((h|0)==(b|0)){i=f;return}else t=h;do{if(t){c[t+0>>2]=c[p+0>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];c[t+16>>2]=c[p+16>>2]}t=t+20|0}while((t|0)!=(b|0));i=f;return}function Std(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=633288;g=a+8|0;h=a+16|0;j=c[h>>2]|0;if(j){k=j;j=0;while(1){if(!(c[(c[g>>2]|0)+(j<<2)>>2]|0))l=k;else{m=ync()|0;In[c[(c[m>>2]|0)+236>>2]&4095](m,c[(c[g>>2]|0)+(j<<2)>>2]|0);l=c[h>>2]|0}j=j+1|0;if(j>>>0>=l>>>0)break;else k=l}}if((c[a+136>>2]|0)>-1){l=a+124|0;k=c[l>>2]|0;c[e>>2]=c[a+128>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[l>>2]=0}l=c[a+92>>2]|0;if(l){c[f>>2]=57;c[d+0>>2]=c[f+0>>2];eOb(l,d)}if((c[a+36>>2]|0)>-1){l=a+24|0;f=c[l>>2]|0;c[e>>2]=c[a+28>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[l>>2]=0}if((c[a+20>>2]|0)<=-1){i=b;return}l=c[g>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[g>>2]=0;i=b;return}function Ttd(a){a=a|0;var b=0;b=i;Std(a);ACi(a);i=b;return}function Utd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+4|0;g=e;a[b+140>>0]=1;h=c[d+40>>2]|0;if(((h|0)!=0?!(mo[c[(c[h>>2]|0)+12>>2]&4095](h)|0):0)?(c[(ync()|0)+5980>>2]|0)!=4:0){aud(b+124|0,d+44|0);if(!d){i=e;return}Ptd(d);ACi(d);i=e;return}h=b+8|0;j=b+16|0;k=(c[j>>2]|0)+1|0;c[j>>2]=k;l=b+20|0;m=c[l>>2]|0;n=m&2147483647;if(k>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[l>>2]=p;o=c[h>>2]|0;c[g>>2]=c[b+12>>2];c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(o,p<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[b+12>>2];c[f+0>>2]=c[g+0>>2];o=cOb(p<<2,4,f,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,c[j>>2]<<2|0)|0;c[l>>2]=p;c[h>>2]=o;break}while(0);q=c[j>>2]|0}else q=k;c[(c[h>>2]|0)+(q+-1<<2)>>2]=d;aud(b+24|0,d+44|0);i=e;return}function Vtd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+141|0;a[e>>0]=0;f=c[b+32>>2]|0;if(!f){i=d;return}g=c[b+24>>2]|0;b=0;while(1){if(c[g+(b<<4)>>2]&448)break;b=b+1|0;if(b>>>0>=f>>>0){h=6;break}}if((h|0)==6){i=d;return}a[e>>0]=1;i=d;return}function Wtd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+124|0;f=c[e>>2]|0;g=c[a+132>>2]|0;a=f+(g<<4)|0;a:do if(!g){h=f;j=6}else{k=f;do{l=0;while(1){if((c[k+(l<<2)>>2]|0)!=(c[b+(l<<2)>>2]|0))break;l=l+1|0;if((l|0)>=4){h=k;j=6;break a}}k=k+16|0}while((k|0)!=(a|0))}while(0);if((j|0)==6?(h|0)!=(a|0):0){i=d;return}aud(e,b);i=d;return}function Xtd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+92|0;j=b+96|0;c[j>>2]=32;c[b+108>>2]=16;c[b+104>>2]=6;a[b+112>>0]=0;c[g>>2]=57;c[f+0>>2]=c[g+0>>2];k=cOb(640,16,f,0,3653512,80)|0;l=c[h>>2]|0;if(l){c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(l,f)}c[h>>2]=k;h=k+((c[j>>2]|0)*20|0)|0;if((k|0)!=(h|0)){j=b+72|0;f=k;do{if(f){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2]}f=f+20|0}while((f|0)!=(h|0))}c[b+100>>2]=0;c[b+44>>2]=0;h=b+32|0;f=c[d+8>>2]|0;if(!f){i=e;return}j=b+24|0;k=b+8|0;l=b+16|0;b=c[h>>2]|0;g=0;while(1){a:do if(!b)m=0;else{n=b;o=0;while(1){p=c[d>>2]|0;q=c[j>>2]|0;r=o;b:while(1){s=0;while(1){if((c[p+(g<<4)+(s<<2)>>2]|0)!=(c[q+(r<<4)+(s<<2)>>2]|0))break;s=s+1|0;if((s|0)>=4){t=r;break b}}r=r+1|0;if((r|0)==(n|0)){m=n;break a}}r=c[k>>2]|0;if(!(c[r+(t<<2)>>2]|0))u=r;else{r=ync()|0;In[c[(c[r>>2]|0)+236>>2]&4095](r,c[(c[k>>2]|0)+(t<<2)>>2]|0);u=c[k>>2]|0}n=n+-1|0;c[u+(t<<2)>>2]=c[u+(n<<2)>>2];r=c[j>>2]|0;q=r+(t<<4)|0;p=r+(n<<4)|0;c[q+0>>2]=c[p+0>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[q+12>>2]=c[p+12>>2];c[l>>2]=(c[l>>2]|0)+-1;c[h>>2]=(c[h>>2]|0)+-1;if((t|0)==(n|0)){m=t;break}else o=t}}while(0);g=g+1|0;if((g|0)==(f|0))break;else b=m}i=e;return}function Ytd(b,d){b=b|0;d=d|0;var e=0;d=i;if(!(a[b+140>>0]|0)){e=0;i=d;return e|0}e=(c[b+16>>2]|0)!=0;i=d;return e|0}function Ztd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;e=c[a+32>>2]|0;if(!e){f=0;i=d;return f|0}g=c[a+24>>2]|0;h=c[c[158074]>>2]|0;j=a+132|0;k=a+124|0;if((h|0)>0){l=-2147483648;m=-1;n=0;while(1){o=0;p=0;q=0;while(1){r=c[g+(n<<4)+(o<<2)>>2]|0;s=c[b+(o<<2)>>2]|0;t=s&r;u=r&~s;s=t-(t>>>1&1431655765)|0;t=(s>>>2&858993459)+(s&858993459)|0;s=((da((t>>>4)+t&252645135,16843009)|0)>>>24)+p|0;t=u-(u>>>1&1431655765)|0;u=(t>>>2&858993459)+(t&858993459)|0;t=((da((u>>>4)+u&252645135,16843009)|0)>>>24)+q|0;o=o+1|0;if((o|0)==(h|0)){v=s;w=t;break}else{p=s;q=t}}q=v-(w<<4)|0;if((q|0)>(l|0)){p=c[j>>2]|0;if(!p)x=0;else{o=c[k>>2]|0;t=o+(p<<4)|0;p=o;a:while(1){o=0;while(1){if((c[p+(o<<2)>>2]|0)!=(c[g+(n<<4)+(o<<2)>>2]|0))break;o=o+1|0;if((o|0)>=4){y=p;break a}}p=p+16|0;if((p|0)==(t|0)){y=t;break}}x=(y|0)!=(t|0)}z=x?l:q;A=x?m:n}else{z=l;A=m}n=n+1|0;if(n>>>0>=e>>>0){B=A;break}else{l=z;m=A}}}else{A=-2147483648;m=-1;z=0;while(1){if((A|0)<0){l=c[j>>2]|0;if(!l)C=0;else{n=c[k>>2]|0;x=n+(l<<4)|0;l=n;b:while(1){n=0;while(1){if((c[l+(n<<2)>>2]|0)!=(c[g+(z<<4)+(n<<2)>>2]|0))break;n=n+1|0;if((n|0)>=4){D=l;break b}}l=l+16|0;if((l|0)==(x|0)){D=x;break}}C=(D|0)!=(x|0)}E=C?A:0;F=C?m:z}else{E=A;F=m}z=z+1|0;if(z>>>0>=e>>>0){B=F;break}else{A=E;m=F}}}if((B|0)<=-1){f=0;i=d;return f|0}f=c[(c[a+8>>2]|0)+(B<<2)>>2]|0;i=d;return f|0}function _td(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+48|0;d=e+40|0;j=e+16|0;k=e;c[h>>2]=0;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];if((c[b+116>>2]|0)==-1?(c[b+16>>2]|0)==0:0){l=0;i=e;return l|0}m=b+40|0;do if((c[b+100>>2]|0)!=(c[b+44>>2]|0)){bud(d,m,f);n=c[d>>2]|0;o=c[b+92>>2]|0;if((n|0)==-1){p=c[b+96>>2]|0;q=o;r=p;s=o+(p*20|0)|0;break}else{q=o;r=c[b+96>>2]|0;s=o+(n*20|0)|0;break}}else{n=c[b+92>>2]|0;o=c[b+96>>2]|0;q=n;r=o;s=n+(o*20|0)|0}while(0);if((s|0)!=(q+(r*20|0)|0)){r=c[s+16>>2]|0;if(!r){l=0;i=e;return l|0}s=r+44|0;c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];l=r;i=e;return l|0}if((c[h>>2]|0)==2){l=0;i=e;return l|0}r=Ztd(b,f)|0;do if(r){c[h>>2]=0;s=r+44|0;c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];Qtd(r);s=c[r+40>>2]|0;if((s|0)!=0?mo[c[(c[s>>2]|0)+12>>2]&4095](s)|0:0)break;if((c[(ync()|0)+5980>>2]|0)!=4){s=b+124|0;q=c[s>>2]|0;d=b+132|0;o=c[d>>2]|0;n=q+(o<<4)|0;a:do if(!o){t=q;u=21}else{p=q;while(1){v=0;while(1){if((c[p+(v<<2)>>2]|0)!=(c[f+(v<<2)>>2]|0))break;v=v+1|0;if((v|0)>=4){t=p;u=21;break a}}p=p+16|0;if((p|0)==(n|0)){u=22;break}}}while(0);if((u|0)==21)if((t|0)==(n|0))u=22;else{w=q;x=o}if((u|0)==22){aud(s,f);w=c[s>>2]|0;x=c[d>>2]|0}p=w+(x<<4)|0;b:do if(!x){y=w;u=28}else{v=w;while(1){z=0;while(1){if((c[v+(z<<2)>>2]|0)!=(c[g+(z<<2)>>2]|0))break;z=z+1|0;if((z|0)>=4){y=v;u=28;break b}}v=v+16|0;if((v|0)==(p|0)){u=29;break}}}while(0);if((u|0)==28?(y|0)==(p|0):0)u=29;if((u|0)==29)aud(s,g);c[h>>2]=2;a[b+140>>0]=1}}while(0);if((c[h>>2]|0)==2){l=r;i=e;return l|0};c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=r;cud(k,m,j);l=r;i=e;return l|0}function $td(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;g=(b|0)==(a|0);do if(!g){h=c[b>>2]|0;j=(c[b+8>>2]|0)*20|0;k=(j|0)/20|0;l=a+8|0;c[l>>2]=k;m=a+12|0;n=c[m>>2]|0;if((n&2147483647)>>>0<k>>>0){if((n|0)>-1){c[m>>2]=k;n=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];o=hOb(n,j,4,e,0,3653512,370)|0;c[a>>2]=o;p=o}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];o=cOb(j,4,e,0,3653512,352)|0;YEi(o|0,c[a>>2]|0,(c[l>>2]|0)*20|0)|0;c[m>>2]=k;c[a>>2]=o;p=o}YEi(p|0,h|0,(c[l>>2]|0)*20|0)|0;if(g)break}else YEi(c[a>>2]|0,h|0,(c[l>>2]|0)*20|0)|0;l=a+16|0;h=c[b+16>>2]|0;o=c[b+24>>2]<<3;k=o>>3;m=a+24|0;c[m>>2]=k;j=a+28|0;n=c[j>>2]|0;do if((n&2147483647)>>>0<k>>>0)if((n|0)>-1){c[j>>2]=k;q=c[l>>2]|0;c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];r=hOb(q,o,4,e,0,3653512,370)|0;c[l>>2]=r;s=r;break}else{c[f>>2]=c[a+20>>2];c[e+0>>2]=c[f+0>>2];r=cOb(o,4,e,0,3653512,352)|0;YEi(r|0,c[l>>2]|0,c[m>>2]<<3|0)|0;c[j>>2]=k;c[l>>2]=r;s=r;break}else s=c[l>>2]|0;while(0);YEi(s|0,h|0,c[m>>2]<<3|0)|0;if(!g){dud(a+32|0,c[b+32>>2]|0,c[b+36>>2]|0);l=a+44|0;k=c[b+44>>2]|0;j=c[b+52>>2]<<3;o=j>>3;n=a+52|0;c[n>>2]=o;r=a+56|0;q=c[r>>2]|0;if((q&2147483647)>>>0<o>>>0){if((q|0)>-1){c[r>>2]=o;q=c[l>>2]|0;c[f>>2]=c[a+48>>2];c[e+0>>2]=c[f+0>>2];t=hOb(q,j,4,e,0,3653512,370)|0;c[l>>2]=t;u=t}else{c[f>>2]=c[a+48>>2];c[e+0>>2]=c[f+0>>2];t=cOb(j,4,e,0,3653512,352)|0;YEi(t|0,c[l>>2]|0,c[n>>2]<<3|0)|0;c[r>>2]=o;c[l>>2]=t;u=t}YEi(u|0,k|0,c[n>>2]<<3|0)|0;if(g)break}else YEi(c[l>>2]|0,k|0,c[n>>2]<<3|0)|0;eud(a+60|0,c[b+60>>2]|0,c[b+64>>2]|0)}}while(0);g=a+72|0;u=b+72|0;b=g+92|0;do{c[g>>2]=c[u>>2];g=g+4|0;u=u+4|0}while((g|0)<(b|0));i=d;return a|0}function aud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<4)|0;c[p+0>>2]=c[b+0>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<4,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<4,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<4|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<4)|0;c[p+0>>2]=c[b+0>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];i=d;return}function bud(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=(c[d+56>>2]|0)+-1|0;h=e;j=c[h>>2]|0;k=c[h+4>>2]|0;h=_Ei(j|0,k|0,2127912214,0)|0;l=H;m=cFi(j|0,k|0,12)|0;k=_Ei(h|0,l|0,m|0,H|0)|0;m=H;l=VEi(k|0,m|0,19)|0;h=k^-949894596^l;l=m^H;m=_Ei(h|0,l|0,374761393,0)|0;k=H;j=cFi(h|0,l|0,5)|0;l=_Ei(m|0,k|0,j|0,H|0)|0;j=c[d+52>>2]|0;k=d+8|0;m=d+4|0;h=l;l=-1;n=0;a:while(1){o=h&g;p=0;while(1){if((c[d+(p<<2)+32>>2]|0)!=(c[j+(o*20|0)+(p<<2)>>2]|0))break;p=p+1|0;if((p|0)>=4){q=l;r=o;break a}}b:do if((a[k>>0]|0)!=0?(c[m>>2]|0)!=0:0){p=0;do{if((c[d+(p<<2)+12>>2]|0)!=(c[j+(o*20|0)+(p<<2)>>2]|0)){s=0;t=14;break b}p=p+1|0}while((p|0)<4);u=(l|0)==-1?o:l}else{s=0;t=14}while(0);c:do if((t|0)==14)while(1){t=0;if((c[e+(s<<2)>>2]|0)!=(c[j+(o*20|0)+(s<<2)>>2]|0)){u=l;break c}s=s+1|0;if((s|0)>=4){v=o;t=15;break a}else t=14}while(0);p=n+1|0;h=p+o|0;l=u;n=p}if((t|0)==15){c[b>>2]=v;c[b+4>>2]=-1;i=f;return}c[b>>2]=-1;v=b+4|0;if((q|0)==-1){c[v>>2]=r;i=f;return}else{c[v>>2]=q;i=f;return}}function cud(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;fud(d,1,0);bud(g,d,e);h=c[g>>2]|0;if((h|0)!=-1){j=c[d+52>>2]|0;k=j+((c[d+56>>2]|0)*20|0)|0;c[b>>2]=d;c[b+4>>2]=j+(h*20|0);c[b+8>>2]=k;a[b+12>>0]=0;i=f;return}k=c[g+4>>2]|0;a:do if((a[d+8>>0]|0)!=0?(g=d+4|0,h=c[g>>2]|0,(h|0)!=0):0){j=c[d+52>>2]|0;l=0;do{if((c[d+(l<<2)+12>>2]|0)!=(c[j+(k*20|0)+(l<<2)>>2]|0)){m=9;break a}l=l+1|0}while((l|0)<4);c[g>>2]=h+-1;n=j}else m=9;while(0);if((m|0)==9){m=d+60|0;c[m>>2]=(c[m>>2]|0)+1;n=c[d+52>>2]|0}m=n+(k*20|0)|0;if(!m)o=n;else{c[m+0>>2]=c[e+0>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];c[m+16>>2]=c[e+16>>2];o=c[d+52>>2]|0}e=o+((c[d+56>>2]|0)*20|0)|0;c[b>>2]=d;c[b+4>>2]=o+(k*20|0);c[b+8>>2]=e;a[b+12>>0]=1;i=f;return}function dud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=b;g=d-f>>4;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=j-l>>4>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=n>>4;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;f=k+(p>>4<<4)|0;p=c[m>>2]|0;if((p|0)==(f|0)){i=e;return}c[m>>2]=p+(~((p+-16-f|0)>>>4)<<4);i=e;return}f=b+(o<<4)|0;aFi(k|0,b|0,n|0)|0;if((f|0)==(d|0)){i=e;return}n=f;f=c[m>>2]|0;do{if(!f)q=0;else{c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];q=c[m>>2]|0}f=q+16|0;c[m>>2]=f;n=n+16|0}while((n|0)!=(d|0));i=e;return}if(!k)r=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-16-l|0)>>>4)<<4);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;r=0}if(g>>>0>268435455)vxi(a);j=r-0|0;if(j>>4>>>0<134217727){r=j>>3;j=r>>>0<g>>>0?g:r;if(j>>>0>268435455)vxi(a);else s=j}else s=268435455;j=xCi(s<<4)|0;r=a+4|0;c[r>>2]=j;c[a>>2]=j;c[h>>2]=j+(s<<4);if((b|0)==(d|0)){i=e;return}else{t=b;u=j}do{c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];c[u+12>>2]=c[t+12>>2];u=(c[r>>2]|0)+16|0;c[r>>2]=u;t=t+16|0}while((t|0)!=(d|0));i=e;return}function eud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b;j=(d-h|0)/28|0;k=a+8|0;l=c[k>>2]|0;m=c[a>>2]|0;n=m;if(j>>>0>((l-n|0)/28|0)>>>0){if(!m)o=l;else{l=a+4|0;p=c[l>>2]|0;if((p|0)==(m|0))q=m;else{r=p;while(1){p=r+-28|0;c[l>>2]=p;if((c[r+-12>>2]|0)>-1){s=r+-24|0;t=c[s>>2]|0;c[g>>2]=c[r+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(t,f);c[s>>2]=0;u=c[l>>2]|0}else u=p;if((u|0)==(m|0))break;else r=u}q=c[a>>2]|0}ACi(q);c[k>>2]=0;c[l>>2]=0;c[a>>2]=0;o=0}if(j>>>0>153391689)vxi(a);l=(o-0|0)/28|0;if(l>>>0<76695844){o=l<<1;l=o>>>0<j>>>0?j:o;if(l>>>0>153391689)vxi(a);else v=l}else v=153391689;l=xCi(v*28|0)|0;o=a+4|0;c[o>>2]=l;c[a>>2]=l;c[k>>2]=l+(v*28|0);if((b|0)==(d|0)){i=e;return}v=b;k=l;do{c[k>>2]=c[v>>2];l=c[v+8>>2]|0;c[k+8>>2]=l;q=k+12|0;c[q>>2]=0;u=k+16|0;c[u>>2]=0;r=k+4|0;c[r>>2]=0;p=c[v+4>>2]|0;s=(c[v+12>>2]|0)*20|0;t=(s|0)/20|0;c[q>>2]=t;if(!s){w=t;x=0}else{c[u>>2]=t;c[g>>2]=l;c[f+0>>2]=c[g+0>>2];l=hOb(0,s,4,f,0,3653512,370)|0;c[r>>2]=l;w=c[q>>2]|0;x=l}YEi(x|0,p|0,w*20|0)|0;p=v+20|0;l=c[p+4>>2]|0;q=k+20|0;c[q>>2]=c[p>>2];c[q+4>>2]=l;k=(c[o>>2]|0)+28|0;c[o>>2]=k;v=v+28|0}while((v|0)!=(d|0));i=e;return}v=a+4|0;a=((c[v>>2]|0)-n|0)/28|0;if(j>>>0>a>>>0){y=1;z=b+(a*28|0)|0}else{y=0;z=d}if((z|0)==(b|0))A=m;else{a=z+-28-h|0;h=b;b=m;while(1){c[b>>2]=c[h>>2];j=b+4|0;if((h|0)!=(b|0)){n=c[h+4>>2]|0;k=(c[h+12>>2]|0)*20|0;o=(k|0)/20|0;w=b+12|0;c[w>>2]=o;x=b+16|0;l=c[x>>2]|0;do if((l&2147483647)>>>0<o>>>0)if((l|0)>-1){c[x>>2]=o;q=c[j>>2]|0;c[g>>2]=c[b+8>>2];c[f+0>>2]=c[g+0>>2];p=hOb(q,k,4,f,0,3653512,370)|0;c[j>>2]=p;B=p;break}else{c[g>>2]=c[b+8>>2];c[f+0>>2]=c[g+0>>2];p=cOb(k,4,f,0,3653512,352)|0;YEi(p|0,c[j>>2]|0,(c[w>>2]|0)*20|0)|0;c[x>>2]=o;c[j>>2]=p;B=p;break}else B=c[j>>2]|0;while(0);YEi(B|0,n|0,(c[w>>2]|0)*20|0)|0}j=h+20|0;o=c[j+4>>2]|0;x=b+20|0;c[x>>2]=c[j>>2];c[x+4>>2]=o;h=h+28|0;if((h|0)==(z|0))break;else b=b+28|0}A=m+((((a>>>0)/28|0)+1|0)*28|0)|0}if(!y){y=c[v>>2]|0;if((y|0)==(A|0)){i=e;return}a=y;while(1){y=a+-28|0;c[v>>2]=y;if((c[a+-12>>2]|0)>-1){m=a+-24|0;b=c[m>>2]|0;c[g>>2]=c[a+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(b,f);c[m>>2]=0;C=c[v>>2]|0}else C=y;if((C|0)==(A|0))break;else a=C}i=e;return}if((z|0)==(d|0)){i=e;return}C=z;z=c[v>>2]|0;do{if(!z)D=0;else{c[z>>2]=c[C>>2];a=c[C+8>>2]|0;c[z+8>>2]=a;A=z+12|0;c[A>>2]=0;y=z+16|0;c[y>>2]=0;m=z+4|0;c[m>>2]=0;b=c[C+4>>2]|0;h=(c[C+12>>2]|0)*20|0;B=(h|0)/20|0;c[A>>2]=B;if(!h){E=B;F=0}else{c[y>>2]=B;c[g>>2]=a;c[f+0>>2]=c[g+0>>2];a=hOb(0,h,4,f,0,3653512,370)|0;c[m>>2]=a;E=c[A>>2]|0;F=a}YEi(F|0,b|0,E*20|0)|0;b=C+20|0;a=c[b+4>>2]|0;A=z+20|0;c[A>>2]=c[b>>2];c[A+4>>2]=a;D=c[v>>2]|0}z=D+28|0;c[v>>2]=z;C=C+28|0}while((C|0)!=(d|0));i=e;return}function fud(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+128|0;h=g+96|0;j=g+76|0;k=g;l=d+72|0;if(a[l>>0]|0)gud(d);m=d+56|0;n=c[m>>2]|0;o=c[d+60>>2]|0;if(n>>>0>f>>>0?(o+e|0)>>>0<=(c[d+68>>2]|0)>>>0:0){i=g;return}p=d+60|0;q=o+e|0;r=ea(q>>>0);e=32;while(1){if(e>>>0>=f>>>0?!(r>=ea(ea(e>>>0)*ea(.5))):0){s=e;break}e=e<<1}if(s>>>0<=n>>>0){i=g;return}n=d+4|0;r=ea((q-(c[n>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=f>>>0?!(r>=ea(ea(q>>>0)*ea(.5))):0){t=q;break}q=q<<1}q=k+4|0;c[q>>2]=0;f=k+8|0;s=d+8|0;a[f>>0]=a[s>>0]|0;e=k+9|0;o=d+9|0;a[e>>0]=a[o>>0]|0;u=k+12|0;v=d+12|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];w=k+32|0;x=d+32|0;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];c[w+16>>2]=c[x+16>>2];y=k+52|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;a[y+20>>0]=0;hud(k,d,t);t=c[n>>2]|0;c[n>>2]=c[q>>2];c[q>>2]=t;t=a[s>>0]|0;q=b[f>>1]|0;a[s>>0]=q;a[f>>0]=t;t=a[o>>0]|0;a[o>>0]=(q&65535)>>>8;a[e>>0]=t;c[h+0>>2]=c[v+0>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];c[h+12>>2]=c[v+12>>2];c[h+16>>2]=c[v+16>>2];c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[u+0>>2]=c[h+0>>2];c[u+4>>2]=c[h+4>>2];c[u+8>>2]=c[h+8>>2];c[u+12>>2]=c[h+12>>2];c[u+16>>2]=c[h+16>>2];c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];c[j+16>>2]=c[x+16>>2];c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[x+12>>2]=c[w+12>>2];c[x+16>>2]=c[w+16>>2];c[w+0>>2]=c[j+0>>2];c[w+4>>2]=c[j+4>>2];c[w+8>>2]=c[j+8>>2];c[w+12>>2]=c[j+12>>2];c[w+16>>2]=c[j+16>>2];w=d+52|0;x=c[w>>2]|0;c[w>>2]=c[y>>2];c[y>>2]=x;y=k+56|0;w=c[m>>2]|0;u=c[y>>2]|0;c[m>>2]=u;c[y>>2]=w;y=k+60|0;m=c[p>>2]|0;c[p>>2]=c[y>>2];c[y>>2]=m;r=ea(u>>>0);c[d+68>>2]=~~ea(r*ea(.5))>>>0;c[d+64>>2]=~~ea(r*ea(.200000003))>>>0;a[l>>0]=0;r=ea(w>>>0);c[k+68>>2]=~~ea(r*ea(.5))>>>0;c[k+64>>2]=~~ea(r*ea(.200000003))>>>0;a[k+72>>0]=0;if(!x){i=g;return}c[j>>2]=57;c[h+0>>2]=c[j+0>>2];eOb(x,h);i=g;return}function gud(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+128|0;f=e+96|0;g=e+76|0;h=e;j=d+60|0;k=d+4|0;l=(c[j>>2]|0)-(c[k>>2]|0)|0;m=d+64|0;if(l>>>0>=(c[m>>2]|0)>>>0){n=d+72|0;a[n>>0]=0;i=e;return}o=d+56|0;p=c[o>>2]|0;if(p>>>0<=32){n=d+72|0;a[n>>0]=0;i=e;return}q=ea(l>>>0);l=p;while(1){p=l>>>1;if(l>>>0<66){r=p;break}if(q<ea(ea(p>>>0)*ea(.200000003)))l=p;else{r=p;break}}l=h+4|0;c[l>>2]=0;p=h+8|0;s=d+8|0;a[p>>0]=a[s>>0]|0;t=h+9|0;u=d+9|0;a[t>>0]=a[u>>0]|0;v=h+12|0;w=d+12|0;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];x=h+32|0;y=d+32|0;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];c[x+16>>2]=c[y+16>>2];z=h+52|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;a[z+20>>0]=0;hud(h,d,r);r=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=r;r=a[s>>0]|0;l=b[p>>1]|0;a[s>>0]=l;a[p>>0]=r;r=a[u>>0]|0;a[u>>0]=(l&65535)>>>8;a[t>>0]=r;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[w+16>>2]=c[v+16>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];c[v+16>>2]=c[f+16>>2];c[g+0>>2]=c[y+0>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];c[g+12>>2]=c[y+12>>2];c[g+16>>2]=c[y+16>>2];c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];c[y+12>>2]=c[x+12>>2];c[y+16>>2]=c[x+16>>2];c[x+0>>2]=c[g+0>>2];c[x+4>>2]=c[g+4>>2];c[x+8>>2]=c[g+8>>2];c[x+12>>2]=c[g+12>>2];c[x+16>>2]=c[g+16>>2];x=d+52|0;y=c[x>>2]|0;c[x>>2]=c[z>>2];c[z>>2]=y;z=h+56|0;x=c[o>>2]|0;v=c[z>>2]|0;c[o>>2]=v;c[z>>2]=x;z=h+60|0;o=c[j>>2]|0;c[j>>2]=c[z>>2];c[z>>2]=o;q=ea(v>>>0);c[d+68>>2]=~~ea(q*ea(.5))>>>0;c[m>>2]=~~ea(q*ea(.200000003))>>>0;a[d+72>>0]=0;q=ea(x>>>0);c[h+68>>2]=~~ea(q*ea(.5))>>>0;c[h+64>>2]=~~ea(q*ea(.200000003))>>>0;a[h+72>>0]=0;if(!y){n=d+72|0;a[n>>0]=0;i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(y,f);n=d+72|0;a[n>>0]=0;i=e;return}function hud(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+52|0;k=b+56|0;c[k>>2]=32;l=b+68|0;c[l>>2]=16;m=b+64|0;c[m>>2]=6;n=b+72|0;a[n>>0]=0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];o=cOb(640,16,g,0,3653512,80)|0;p=c[j>>2]|0;if(p){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(p,g)}c[j>>2]=o;p=o+((c[k>>2]|0)*20|0)|0;if((o|0)!=(p|0)){q=b+32|0;r=o;do{if(r){c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];c[r+16>>2]=c[q+16>>2]}r=r+20|0}while((r|0)!=(p|0))}p=b+60|0;c[p>>2]=0;c[b+4>>2]=0;r=d+4|0;s=ea(((c[d+60>>2]|0)-(c[r>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=e>>>0?(t=ea(q>>>0),u=ea(t*ea(.5)),!(s>=u)):0){v=t;w=u;x=q;break}q=q<<1}q=c[k>>2]|0;if(x>>>0>q>>>0){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];e=cOb(x*20|0,16,g,0,3653512,80)|0;o=c[j>>2]|0;y=c[k>>2]|0;z=y>>>0>x>>>0?x:y;A=o+(z*20|0)|0;if(!z)B=y;else{y=e;z=o;while(1){if(y){c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2]}z=z+20|0;if((z|0)==(A|0))break;else y=y+20|0}B=c[k>>2]|0}y=e+(x*20|0)|0;if((B|0)!=(x|0)){A=b+32|0;z=e+(B*20|0)|0;do{if(z){c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2]}z=z+20|0}while((z|0)!=(y|0))}y=c[j>>2]|0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(y,g);c[j>>2]=e;c[k>>2]=x;c[l>>2]=~~w>>>0;c[m>>2]=~~ea(v*ea(.200000003))>>>0;a[n>>0]=0;C=x}else C=q;q=d+52|0;x=c[q>>2]|0;n=d+56|0;m=c[n>>2]|0;l=x+(m*20|0)|0;a:do if(!m)D=x;else{e=(a[d+8>>0]|0)==0|(c[r>>2]|0)==0;g=x;do{y=0;do{if((c[d+(y<<2)+32>>2]|0)!=(c[g+(y<<2)>>2]|0)){E=29;break}y=y+1|0}while((y|0)<4);if((E|0)==29){E=0;if(e){D=g;break a}else F=0;do{if((c[d+(F<<2)+12>>2]|0)!=(c[g+(F<<2)>>2]|0)){D=g;break a}F=F+1|0}while((F|0)<4)}g=g+20|0}while((g|0)!=(l|0));i=f;return}while(0);if((D|0)==(l|0)){i=f;return}F=d+8|0;x=C;C=D;while(1){D=x+-1|0;m=C;g=c[m>>2]|0;e=c[m+4>>2]|0;m=_Ei(g|0,e|0,2127912214,0)|0;y=H;h=cFi(g|0,e|0,12)|0;e=_Ei(m|0,y|0,h|0,H|0)|0;h=H;y=VEi(e|0,h|0,19)|0;m=e^-949894596^y;y=h^H;h=_Ei(m|0,y|0,374761393,0)|0;e=H;g=cFi(m|0,y|0,5)|0;y=_Ei(h|0,e|0,g|0,H|0)|0;g=c[j>>2]|0;e=y;y=0;b:while(1){h=e&D;m=0;while(1){if((c[b+(m<<2)+32>>2]|0)!=(c[g+(h*20|0)+(m<<2)>>2]|0))break;m=m+1|0;if((m|0)>=4){G=h;break b}}m=y+1|0;e=m+h|0;y=m}y=g+(G*20|0)|0;if(y){c[y+0>>2]=c[C+0>>2];c[y+4>>2]=c[C+4>>2];c[y+8>>2]=c[C+8>>2];c[y+12>>2]=c[C+12>>2];c[y+16>>2]=c[C+16>>2]}c[p>>2]=(c[p>>2]|0)+1;y=C+20|0;c:do if((y|0)==(l|0))I=l;else{if((a[F>>0]|0)==0|(c[r>>2]|0)==0){e=C;D=y;while(1){m=0;do{if((c[d+(m<<2)+32>>2]|0)!=(c[e+(m<<2)+20>>2]|0)){I=D;break c}m=m+1|0}while((m|0)<4);m=e+40|0;if((m|0)==(l|0)){I=l;break c}else{z=D;D=m;e=z}}}else{J=C;K=y}while(1){e=0;do{if((c[d+(e<<2)+32>>2]|0)!=(c[J+(e<<2)+20>>2]|0)){L=0;E=54;break}e=e+1|0}while((e|0)<4);if((E|0)==54)while(1){E=0;if((c[d+(L<<2)+12>>2]|0)!=(c[J+(L<<2)+20>>2]|0)){I=K;break c}L=L+1|0;if((L|0)>=4)break;else E=54}e=J+40|0;if((e|0)==(l|0)){I=l;break}else{D=K;K=e;J=D}}}while(0);if((I|0)==((c[q>>2]|0)+((c[n>>2]|0)*20|0)|0))break;x=c[k>>2]|0;C=I}i=f;return}function iud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+128|0;e=d+112|0;f=d+72|0;g=d+108|0;h=d;j=d+104|0;k=d+88|0;c[a>>2]=575440;c[a+4>>2]=1;c[a>>2]=633304;l=a+8|0;m=a+12|0;c[m>>2]=0;n=a+16|0;c[n>>2]=0;o=a+12|0;c[l>>2]=o;p=c[b+8>>2]|0;q=b+12|0;if((p|0)!=(q|0)){r=p;while(1){p=r+16|0;s=c[p>>2]|0;t=c[p+4>>2]|0;p=h;c[p>>2]=s;c[p+4>>2]=t;c[g>>2]=o;c[e+0>>2]=c[g+0>>2];p=ckc(l,e,f,h)|0;if(!(c[p>>2]|0)){u=xCi(24)|0;v=u+16|0;c[v>>2]=s;c[v+4>>2]=t;t=c[f>>2]|0;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=t;c[p>>2]=u;t=c[c[l>>2]>>2]|0;if(!t)w=u;else{c[l>>2]=t;w=c[p>>2]|0}GN(c[m>>2]|0,w);c[n>>2]=(c[n>>2]|0)+1}p=c[r+4>>2]|0;if(!p){t=r;while(1){u=c[t+8>>2]|0;if((c[u>>2]|0)==(t|0)){x=u;break}else t=u}}else{t=p;while(1){u=c[t>>2]|0;if(!u){x=t;break}else t=u}}if((x|0)==(q|0))break;else r=x}}x=a+20|0;r=a+24|0;c[r>>2]=0;q=a+28|0;c[q>>2]=0;n=a+24|0;c[x>>2]=n;w=c[b+20>>2]|0;m=b+24|0;if((w|0)!=(m|0)){l=w;while(1){w=l+16|0;c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];c[h+16>>2]=c[w+16>>2];c[g>>2]=n;c[e+0>>2]=c[g+0>>2];w=Bud(x,e,f,h)|0;if(!(c[w>>2]|0)){o=xCi(36)|0;t=o+16|0;c[t+0>>2]=c[h+0>>2];c[t+4>>2]=c[h+4>>2];c[t+8>>2]=c[h+8>>2];c[t+12>>2]=c[h+12>>2];c[t+16>>2]=c[h+16>>2];t=c[f>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=t;c[w>>2]=o;t=c[c[x>>2]>>2]|0;if(!t)y=o;else{c[x>>2]=t;y=c[w>>2]|0}GN(c[r>>2]|0,y);c[q>>2]=(c[q>>2]|0)+1}w=c[l+4>>2]|0;if(!w){t=l;while(1){o=c[t+8>>2]|0;if((c[o>>2]|0)==(t|0)){z=o;break}else t=o}}else{t=w;while(1){o=c[t>>2]|0;if(!o){z=t;break}else t=o}}if((z|0)==(m|0))break;else l=z}}z=a+32|0;l=a+36|0;c[l>>2]=0;m=a+40|0;c[m>>2]=0;q=a+36|0;c[z>>2]=q;y=c[b+32>>2]|0;r=b+36|0;if((y|0)!=(r|0)){x=y;while(1){y=h+0|0;n=x+16|0;t=y+68|0;do{c[y>>2]=c[n>>2];y=y+4|0;n=n+4|0}while((y|0)<(t|0));c[g>>2]=q;c[e+0>>2]=c[g+0>>2];w=Cud(z,e,f,h)|0;if(!(c[w>>2]|0)){o=xCi(84)|0;y=o+16|0;n=h+0|0;t=y+68|0;do{c[y>>2]=c[n>>2];y=y+4|0;n=n+4|0}while((y|0)<(t|0));n=c[f>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=n;c[w>>2]=o;n=c[c[z>>2]>>2]|0;if(!n)A=o;else{c[z>>2]=n;A=c[w>>2]|0}GN(c[l>>2]|0,A);c[m>>2]=(c[m>>2]|0)+1}n=c[x+4>>2]|0;if(!n){y=x;while(1){t=c[y+8>>2]|0;if((c[t>>2]|0)==(y|0)){B=t;break}else y=t}}else{y=n;while(1){w=c[y>>2]|0;if(!w){B=y;break}else y=w}}if((B|0)==(r|0))break;else x=B}}B=a+44|0;x=a+48|0;c[x>>2]=0;r=a+52|0;c[r>>2]=0;m=a+48|0;c[B>>2]=m;A=a+56|0;l=a+60|0;c[l>>2]=0;z=a+64|0;c[z>>2]=0;q=a+60|0;c[A>>2]=q;y=c[b+56>>2]|0;n=b+60|0;if((y|0)!=(n|0)){w=y;while(1){y=w+16|0;c[g>>2]=q;c[e+0>>2]=c[g+0>>2];o=Dud(A,e,f,y)|0;if(!(c[o>>2]|0)){t=xCi(20)|0;c[t+16>>2]=c[y>>2];y=c[f>>2]|0;c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=y;c[o>>2]=t;y=c[c[A>>2]>>2]|0;if(!y)C=t;else{c[A>>2]=y;C=c[o>>2]|0}GN(c[l>>2]|0,C);c[z>>2]=(c[z>>2]|0)+1}o=c[w+4>>2]|0;if(!o){y=w;while(1){t=c[y+8>>2]|0;if((c[t>>2]|0)==(y|0)){D=t;break}else y=t}}else{y=o;while(1){t=c[y>>2]|0;if(!t){D=y;break}else y=t}}if((D|0)==(n|0))break;else w=D}}D=a+68|0;w=a+72|0;c[w>>2]=0;n=a+76|0;c[n>>2]=0;z=a+72|0;c[D>>2]=z;C=c[b+68>>2]|0;l=b+72|0;if((C|0)!=(l|0)){A=C;while(1){C=A+16|0;q=c[C>>2]|0;y=c[C+4>>2]|0;C=h;c[C>>2]=q;c[C+4>>2]=y;c[g>>2]=z;c[e+0>>2]=c[g+0>>2];C=Eud(D,e,f,h)|0;if(!(c[C>>2]|0)){o=xCi(24)|0;t=o+16|0;c[t>>2]=q;c[t+4>>2]=y;y=c[f>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=y;c[C>>2]=o;y=c[c[D>>2]>>2]|0;if(!y)E=o;else{c[D>>2]=y;E=c[C>>2]|0}GN(c[w>>2]|0,E);c[n>>2]=(c[n>>2]|0)+1}C=c[A+4>>2]|0;if(!C){y=A;while(1){o=c[y+8>>2]|0;if((c[o>>2]|0)==(y|0)){F=o;break}else y=o}}else{y=C;while(1){o=c[y>>2]|0;if(!o){F=y;break}else y=o}}if((F|0)==(l|0))break;else A=F}}c[a+80>>2]=0;F=c[b+44>>2]|0;A=b+48|0;if((F|0)==(A|0)){i=d;return}b=k+12|0;l=k+8|0;n=k+4|0;E=F;while(1){c[j>>2]=c[E+16>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;F=xCi(64)|0;exd(F,c[E+20>>2]|0);c[k>>2]=F;c[F+24>>2]=a;sud(a,j,k);F=c[E+24>>2]|0;if(F){w=c[n>>2]|0;c[w+0>>2]=c[F+0>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];c[w+12>>2]=c[F+12>>2]}F=c[E+28>>2]|0;if(F){w=c[l>>2]|0;c[w+0>>2]=c[F+0>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];c[w+12>>2]=c[F+12>>2]}F=c[E+32>>2]|0;if(F){w=c[b>>2]|0;c[w+0>>2]=c[F+0>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];c[w+12>>2]=c[F+12>>2]}F=c[j>>2]|0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];w=c[x>>2]|0;do if(w){D=w;while(1){h=c[D+16>>2]|0;if((F|0)<(h|0)){g=c[D>>2]|0;if(!g){G=D;H=D;I=67;break}else{D=g;continue}}if((h|0)>=(F|0)){J=D;I=71;break}h=D+4|0;g=c[h>>2]|0;if(!g){K=h;L=D;I=70;break}else D=g}if((I|0)==67){I=0;c[e>>2]=H;M=G;N=H;break}else if((I|0)==70){I=0;c[e>>2]=L;M=K;N=L;break}else if((I|0)==71){I=0;c[e>>2]=J;M=e;N=J;break}}else{c[e>>2]=m;M=m;N=m}while(0);if(!(c[M>>2]|0)){w=xCi(36)|0;c[w+16>>2]=F;D=w+20|0;c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=N;c[M>>2]=w;D=c[c[B>>2]>>2]|0;if(!D)O=w;else{c[B>>2]=D;O=c[M>>2]|0}GN(c[x>>2]|0,O);c[r>>2]=(c[r>>2]|0)+1}D=c[E+4>>2]|0;if(!D){w=E;while(1){g=c[w+8>>2]|0;if((c[g>>2]|0)==(w|0)){P=g;break}else w=g}}else{w=D;while(1){F=c[w>>2]|0;if(!F){P=w;break}else w=F}}if((P|0)==(A|0))break;else E=P}i=d;return}function jud(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;sud(a,b,d);if(!e){i=f;return}b=c[e+4>>2]|0;if(b){a=c[d+4>>2]|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2]}b=c[e+8>>2]|0;if(b){a=c[d+8>>2]|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2]}b=c[e+12>>2]|0;if(!b){i=f;return}e=c[d+12>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];i=f;return}function kud(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;c[a>>2]=633304;d=a+44|0;e=c[d>>2]|0;f=a+48|0;if((e|0)!=(f|0)){g=e;while(1){e=c[g+20>>2]|0;if(e){gxd(e);ACi(e)}e=c[g+4>>2]|0;if(!e){h=g;while(1){j=c[h+8>>2]|0;if((c[j>>2]|0)==(h|0)){k=j;break}else h=j}}else{h=e;while(1){j=c[h>>2]|0;if(!j){k=h;break}else h=j}}if((k|0)==(f|0))break;else g=k}}Iud(a+68|0,c[a+72>>2]|0);Hud(a+56|0,c[a+60>>2]|0);Jud(d,c[a+48>>2]|0);Gud(a+32|0,c[a+36>>2]|0);Fud(a+20|0,c[a+24>>2]|0);Wjc(a+8|0,c[a+12>>2]|0);i=b;return}function lud(a){a=a|0;var b=0;b=i;kud(a);ACi(a);i=b;return}function mud(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+48|0;e=c[a+44>>2]|0;if((e|0)==(d|0)){i=b;return}else f=e;while(1){e=c[f+20>>2]|0;if(e)hxd(e);e=c[f+4>>2]|0;if(!e){a=f;while(1){g=c[a+8>>2]|0;if((c[g>>2]|0)==(a|0)){h=g;break}else a=g}}else{a=e;while(1){g=c[a>>2]|0;if(!g){h=a;break}else a=g}}if((h|0)==(d|0))break;else f=h}i=b;return}function nud(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e;h=a+12|0;j=c[h>>2]|0;do if(j){k=c[b>>2]|0;l=j;while(1){m=c[l+16>>2]|0;if((k|0)<(m|0)){n=c[l>>2]|0;if(!n){o=l;p=l;q=5;break}else{l=n;continue}}if((m|0)>=(k|0)){r=l;q=9;break}m=l+4|0;n=c[m>>2]|0;if(!n){s=m;t=l;q=8;break}else l=n}if((q|0)==5){c[f>>2]=p;u=o;v=p;break}else if((q|0)==8){c[f>>2]=t;u=s;v=t;break}else if((q|0)==9){c[f>>2]=r;u=f;v=r;break}}else{l=a+12|0;c[f>>2]=l;u=l;v=l}while(0);f=c[u>>2]|0;if(f){w=f;x=w+20|0;g[x>>2]=d;i=e;return}f=xCi(24)|0;c[f+16>>2]=c[b>>2];g[f+20>>2]=ea(0.0);c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=v;c[u>>2]=f;v=a+8|0;b=c[c[v>>2]>>2]|0;if(!b)y=f;else{c[v>>2]=b;y=c[u>>2]|0}GN(c[h>>2]|0,y);y=a+16|0;c[y>>2]=(c[y>>2]|0)+1;w=f;x=w+20|0;g[x>>2]=d;i=e;return}function oud(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Kud(a+20|0,b,c)|0;i=d;return}function pud(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Lud(a+32|0,b,c)|0;i=d;return}function qud(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0;f=i;i=i+80|0;h=f;j=f+64|0;k=f+48|0;l=f+36|0;m=f+32|0;n=f+16|0;o=rud(b,d)|0;sud(b,d,o);b=c[o>>2]|0;if(e){c[j>>2]=c[e+44>>2];p=mo[c[(c[e>>2]|0)+92>>2]&4095](e)|0;q=c[o+4>>2]|0;c[h+0>>2]=c[j+0>>2];kxd(b,h,p,e,q);q=c[o+8>>2]|0;r=ea(g[e+72>>2]);s=ea(g[e+76>>2]);t=ea(mo[c[(c[e>>2]|0)+116>>2]&4095](e)|0);u=ea(mo[c[(c[e>>2]|0)+120>>2]&4095](e)|0);g[q>>2]=r;g[q+4>>2]=s;g[q+8>>2]=t;g[q+12>>2]=u;q=c[o+12>>2]|0;p=c[e+52>>2]|0;if((KLc()|0)==1)v=c[e+56>>2]|0;else v=0;qwc(k,p,v,ea(1.0));c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];k=b+4|0;if((c[k>>2]|0)!=5?(q=mo[c[(c[e>>2]|0)+92>>2]&4095](e)|0,(q|0)!=(c[k>>2]|0)):0){q=c[659672+((mo[c[(c[e>>2]|0)+92>>2]&4095](e)|0)<<2)>>2]|0;e=c[659672+(c[k>>2]<<2)>>2]|0;k=ftd(d)|0;c[h>>2]=q;c[h+4>>2]=e;c[h+8>>2]=k;Lsd(l,633312,h);if(!(a[l>>0]&1))w=l+1|0;else w=c[l+8>>2]|0;Krd(w,0,3653512,102,1,0,0,0);xri(l)}}else{c[m>>2]=0;l=c[o+4>>2]|0;c[h+0>>2]=c[m+0>>2];kxd(b,h,0,0,l);l=c[o+8>>2]|0;g[l>>2]=ea(1.0);g[l+4>>2]=ea(1.0);g[l+8>>2]=ea(1.0);g[l+12>>2]=ea(1.0);l=c[o+12>>2]|0;qwc(n,0,0,ea(1.0));c[l+0>>2]=c[n+0>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2]}n=c[o+4>>2]|0;l=c[o>>2]|0;u=ea(g[l+44>>2]);t=ea(u*ea(g[l+32>>2]));u=ea(g[l+48>>2]);s=ea(u*ea(g[l+36>>2]));u=ea(g[l+52>>2]);r=ea(g[l+56>>2]);g[n>>2]=t;g[n+4>>2]=s;g[n+8>>2]=u;g[n+12>>2]=r;i=f;return c[o>>2]|0}function rud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+48|0;e=d+32|0;f=d;h=d+16|0;j=a+48|0;k=c[j>>2]|0;l=a+48|0;if(k){m=c[b>>2]|0;n=l;o=k;a:while(1){k=o;while(1){if((c[k+16>>2]|0)>=(m|0)){p=k;break}k=c[k+4>>2]|0;if(!k){q=n;break a}}o=c[p>>2]|0;if(!o){q=p;break}else n=p}if((q|0)!=(l|0)?(m|0)>=(c[q+16>>2]|0):0){r=q;s=r+20|0;i=d;return s|0}};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;q=xCi(64)|0;m=q+8|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[q+60>>2]=-1;c[m>>2]=0;c[q+12>>2]=0;c[q>>2]=0;c[q+4>>2]=5;g[q+36>>2]=ea(1.0);g[q+32>>2]=ea(1.0);g[q+40>>2]=ea(0.0);g[q+44>>2]=ea(1.0);g[q+48>>2]=ea(1.0);g[q+52>>2]=ea(0.0);g[q+56>>2]=ea(0.0);c[h>>2]=q;c[q+24>>2]=a;sud(a,b,h);q=c[b>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];h=c[j>>2]|0;do if(h){b=h;while(1){m=c[b+16>>2]|0;if((q|0)<(m|0)){p=c[b>>2]|0;if(!p){t=b;u=b;v=12;break}else{b=p;continue}}if((m|0)>=(q|0)){w=b;v=16;break}m=b+4|0;p=c[m>>2]|0;if(!p){x=m;y=b;v=15;break}else b=p}if((v|0)==12){c[e>>2]=u;z=t;A=u;break}else if((v|0)==15){c[e>>2]=y;z=x;A=y;break}else if((v|0)==16){c[e>>2]=w;z=e;A=w;break}}else{c[e>>2]=l;z=l;A=l}while(0);l=c[z>>2]|0;if(l){r=l;s=r+20|0;i=d;return s|0}l=xCi(36)|0;c[l+16>>2]=q;q=l+20|0;c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=A;c[z>>2]=l;A=a+44|0;f=c[c[A>>2]>>2]|0;if(!f)B=l;else{c[A>>2]=f;B=c[z>>2]|0}GN(c[j>>2]|0,B);B=a+52|0;c[B>>2]=(c[B>>2]|0)+1;r=l;s=r+20|0;i=d;return s|0}function sud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+128|0;f=e+100|0;h=e+56|0;j=e+16|0;k=e+32|0;l=e+112|0;m=e;n=e+44|0;o=e+88|0;p=e+72|0;q=d+4|0;if(!(c[q>>2]|0)){r=ftd(b)|0;rri(h,r,SEi(r|0)|0);yO(f,h,633392);xri(h);g[j>>2]=ea(1.0);g[j+4>>2]=ea(1.0);g[j+8>>2]=ea(0.0);g[j+12>>2]=ea(0.0);c[q>>2]=Mud(a+20|0,f,j)|0;xri(f)}f=d+8|0;if(!(c[f>>2]|0)){j=ftd(b)|0;rri(l,j,SEi(j|0)|0);yO(k,l,633400);xri(l);g[m>>2]=ea(1.0);g[m+4>>2]=ea(1.0);g[m+8>>2]=ea(1.0);g[m+12>>2]=ea(1.0);c[f>>2]=Mud(a+20|0,k,m)|0;xri(k)}k=d+12|0;if(c[k>>2]|0){i=e;return}d=ftd(b)|0;rri(o,d,SEi(d|0)|0);yO(n,o,633416);xri(o);qwc(p,0,0,ea(1.0));c[k>>2]=Mud(a+20|0,n,p)|0;xri(n);i=e;return}function tud(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=ea(j);k=ea(k);l=ea(l);var m=0,n=0,o=0,p=0,q=0,r=0;m=i;i=i+32|0;n=m+24|0;o=m+20|0;p=m+16|0;q=m;r=rud(a,b)|0;sud(a,b,r);b=c[d>>2]|0;d=c[r>>2]|0;if(!b){c[p>>2]=0;a=c[r+4>>2]|0;c[n+0>>2]=c[p+0>>2];kxd(d,n,0,0,a);a=c[r+8>>2]|0;g[a>>2]=ea(1.0);g[a+4>>2]=ea(1.0);g[a+8>>2]=ea(1.0);g[a+12>>2]=ea(1.0)}else{c[o>>2]=b;b=c[r+4>>2]|0;c[n+0>>2]=c[o+0>>2];kxd(d,n,2,0,b);nxd(c[r>>2]|0,k,l);b=c[r+8>>2]|0;l=ea(e|0);k=ea(f|0);g[b>>2]=h;g[b+4>>2]=j;g[b+8>>2]=l;g[b+12>>2]=k}b=c[r+4>>2]|0;f=c[r>>2]|0;k=ea(g[f+44>>2]);l=ea(k*ea(g[f+32>>2]));k=ea(g[f+48>>2]);j=ea(k*ea(g[f+36>>2]));k=ea(g[f+52>>2]);h=ea(g[f+56>>2]);g[b>>2]=l;g[b+4>>2]=j;g[b+8>>2]=k;g[b+12>>2]=h;b=c[r+12>>2]|0;qwc(q,0,0,ea(1.0));c[b+0>>2]=c[q+0>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];c[b+12>>2]=c[q+12>>2];i=m;return}function uud(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=0;j=i;i=i+80|0;k=j;l=j+68|0;m=j+64|0;n=j+48|0;o=j+32|0;p=j+16|0;q=rud(b,d)|0;sud(b,d,q);b=(e|0)!=0;r=c[q>>2]|0;if(b){c[l>>2]=c[e+44>>2];s=mo[c[(c[e>>2]|0)+92>>2]&4095](e)|0;t=c[q+4>>2]|0;c[k+0>>2]=c[l+0>>2];kxd(r,k,s,e,t)}else{c[m>>2]=0;t=c[q+4>>2]|0;c[k+0>>2]=c[m+0>>2];kxd(r,k,0,0,t)}u=ea(g[h>>2]);jxd(c[q>>2]|0,u,ea(g[h+4>>2]));u=ea(g[f>>2]);ixd(c[q>>2]|0,u,ea(g[f+4>>2]));f=c[q+4>>2]|0;h=c[q>>2]|0;u=ea(g[h+44>>2]);v=ea(u*ea(g[h+32>>2]));u=ea(g[h+48>>2]);w=ea(u*ea(g[h+36>>2]));u=ea(g[h+52>>2]);x=ea(g[h+56>>2]);g[f>>2]=v;g[f+4>>2]=w;g[f+8>>2]=u;g[f+12>>2]=x;f=c[q+8>>2]|0;if(!b){g[f>>2]=ea(1.0);g[f+4>>2]=ea(1.0);g[f+8>>2]=ea(1.0);g[f+12>>2]=ea(1.0);b=c[q+12>>2]|0;qwc(p,0,0,ea(1.0));c[b+0>>2]=c[p+0>>2];c[b+4>>2]=c[p+4>>2];c[b+8>>2]=c[p+8>>2];c[b+12>>2]=c[p+12>>2];i=j;return}x=ea(g[e+72>>2]);u=ea(g[e+76>>2]);w=ea(mo[c[(c[e>>2]|0)+116>>2]&4095](e)|0);v=ea(mo[c[(c[e>>2]|0)+120>>2]&4095](e)|0);g[f>>2]=x;g[f+4>>2]=u;g[f+8>>2]=w;g[f+12>>2]=v;f=c[q+12>>2]|0;p=c[e+52>>2]|0;if((KLc()|0)==1)y=c[e+56>>2]|0;else y=0;qwc(n,p,y,ea(1.0));c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];if((c[(c[q>>2]|0)+4>>2]|0)==5){i=j;return}n=mo[c[(c[e>>2]|0)+92>>2]&4095](e)|0;if((n|0)==(c[(c[q>>2]|0)+4>>2]|0)){i=j;return}n=c[659672+((mo[c[(c[e>>2]|0)+92>>2]&4095](e)|0)<<2)>>2]|0;e=c[659672+(c[(c[q>>2]|0)+4>>2]<<2)>>2]|0;q=ftd(d)|0;c[k>>2]=n;c[k+4>>2]=e;c[k+8>>2]=q;Lsd(o,633312,k);if(!(a[o>>0]&1))z=o+1|0;else z=c[o+8>>2]|0;Krd(z,0,3653512,154,1,0,0,0);xri(o);i=j;return}function vud(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=ea(e);var f=0,h=0;f=i;h=rud(a,b)|0;jxd(c[h>>2]|0,d,e);b=c[h+4>>2]|0;if(!b){i=f;return}g[b+8>>2]=d;g[b+12>>2]=e;i=f;return}function wud(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=ea(e);var f=0,h=0;f=i;h=rud(a,b)|0;ixd(c[h>>2]|0,d,e);b=c[h+4>>2]|0;if(!b){i=f;return}a=c[h>>2]|0;g[b>>2]=ea(ea(g[a+32>>2])*d);g[b+4>>2]=ea(ea(g[a+36>>2])*e);i=f;return}function xud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;f=a+60|0;g=c[f>>2]|0;do if(g){h=c[b>>2]|0;j=g;while(1){k=c[j+16>>2]|0;if((h|0)<(k|0)){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if((k|0)>=(h|0)){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=a+60|0;c[e>>2]=j;s=j;t=j}while(0);if(c[s>>2]|0){i=d;return}e=xCi(20)|0;c[e+16>>2]=c[b>>2];c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=a+56|0;b=c[c[t>>2]>>2]|0;if(!b)u=e;else{c[t>>2]=b;u=c[s>>2]|0}GN(c[f>>2]|0,u);u=a+64|0;c[u>>2]=(c[u>>2]|0)+1;i=d;return}function yud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+60>>2]|0;if(!e){f=0;i=d;return f|0}a=c[b>>2]|0;b=e;while(1){e=c[b+16>>2]|0;if((a|0)<(e|0))g=b;else{if((e|0)>=(a|0)){f=1;h=8;break}g=b+4|0}b=c[g>>2]|0;if(!b){f=0;h=8;break}}if((h|0)==8){i=d;return f|0}return 0}function zud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[a+12>>2]|0;a:do if(e){f=c[b>>2]|0;g=e;while(1){h=c[g+16>>2]|0;if((f|0)<(h|0))j=g;else{if((h|0)>=(f|0)){k=1;break}j=g+4|0}g=c[j>>2]|0;if(!g)break a}i=d;return k|0}while(0);j=c[a+24>>2]|0;b:do if(j){e=c[b>>2]|0;g=j;while(1){f=c[g+16>>2]|0;if((e|0)<(f|0))l=g;else{if((f|0)>=(e|0)){k=1;break}l=g+4|0}g=c[l>>2]|0;if(!g)break b}i=d;return k|0}while(0);l=c[a+36>>2]|0;c:do if(l){j=c[b>>2]|0;g=l;while(1){e=c[g+16>>2]|0;if((j|0)<(e|0))m=g;else{if((e|0)>=(j|0)){k=1;break}m=g+4|0}g=c[m>>2]|0;if(!g)break c}i=d;return k|0}while(0);m=c[a+48>>2]|0;d:do if(m){l=c[b>>2]|0;g=m;while(1){j=c[g+16>>2]|0;if((l|0)<(j|0))n=g;else{if((j|0)>=(l|0)){k=1;break}n=g+4|0}g=c[n>>2]|0;if(!g)break d}i=d;return k|0}while(0);n=c[a+72>>2]|0;if(!n){k=0;i=d;return k|0}a=c[b>>2]|0;b=n;while(1){n=c[b+16>>2]|0;if((a|0)<(n|0))o=b;else{if((n|0)>=(a|0)){k=1;p=36;break}o=b+4|0}b=c[o>>2]|0;if(!b){k=0;p=36;break}}if((p|0)==36){i=d;return k|0}return 0}function Aud(a){a=a|0;return ((c[a+40>>2]|0)*68|0)+84+((c[a+64>>2]|0)+(c[a+16>>2]|0)+(c[a+76>>2]|0)<<3)+(((c[a+52>>2]|0)+(c[a+28>>2]|0)|0)*20|0)|0}function Bud(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function Cud(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function Dud(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function Eud(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function Fud(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Fud(a,c[b>>2]|0);Fud(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Gud(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Gud(a,c[b>>2]|0);Gud(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Hud(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Hud(a,c[b>>2]|0);Hud(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Iud(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Iud(a,c[b>>2]|0);Iud(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Jud(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Jud(a,c[b>>2]|0);Jud(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Kud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=a+4|0;l=c[k>>2]|0;m=a+4|0;n=c[b>>2]|0;if(l){b=m;o=l;a:while(1){l=o;while(1){if((c[l+16>>2]|0)>=(n|0)){p=l;break}l=c[l+4>>2]|0;if(!l){q=b;break a}}o=c[p>>2]|0;if(!o){q=p;break}else b=p}if((q|0)!=(m|0))if((n|0)<(c[q+16>>2]|0))r=q;else{p=q+20|0;c[p+0>>2]=c[d+0>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];s=0;i=e;return s|0}else r=m}else r=m;c[j>>2]=n;n=j+4|0;c[n+0>>2]=c[d+0>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[d+12>>2];c[h>>2]=r;c[f+0>>2]=c[h+0>>2];h=Bud(a,f,g,j)|0;if(c[h>>2]|0){s=1;i=e;return s|0}f=xCi(36)|0;r=f+16|0;c[r+0>>2]=c[j+0>>2];c[r+4>>2]=c[j+4>>2];c[r+8>>2]=c[j+8>>2];c[r+12>>2]=c[j+12>>2];c[r+16>>2]=c[j+16>>2];j=c[g>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=j;c[h>>2]=f;j=c[c[a>>2]>>2]|0;if(!j)t=f;else{c[a>>2]=j;t=c[h>>2]|0}GN(c[k>>2]|0,t);t=a+8|0;c[t>>2]=(c[t>>2]|0)+1;s=1;i=e;return s|0}function Lud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+80|0;f=e+76|0;g=e+72|0;h=e+68|0;j=e;k=a+4|0;l=c[k>>2]|0;m=a+4|0;n=c[b>>2]|0;if(l){b=m;o=l;a:while(1){l=o;while(1){if((c[l+16>>2]|0)>=(n|0)){p=l;break}l=c[l+4>>2]|0;if(!l){q=b;break a}}o=c[p>>2]|0;if(!o){q=p;break}else b=p}if((q|0)!=(m|0))if((n|0)<(c[q+16>>2]|0))r=q;else{s=q+20|0;t=d+0|0;u=s+64|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));v=0;i=e;return v|0}else r=m}else r=m;c[j>>2]=n;s=j+4|0;t=d+0|0;u=s+64|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));c[h>>2]=r;c[f+0>>2]=c[h+0>>2];h=Cud(a,f,g,j)|0;if(c[h>>2]|0){v=1;i=e;return v|0}f=xCi(84)|0;s=f+16|0;t=j+0|0;u=s+68|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));t=c[g>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=t;c[h>>2]=f;t=c[c[a>>2]>>2]|0;if(!t)w=f;else{c[a>>2]=t;w=c[h>>2]|0}GN(c[k>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;v=1;i=e;return v|0}function Mud(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+32|0;g=f+20|0;h=f;j=f+16|0;c[j>>2]=-1;if(!(a[d>>0]&1))k=d+1|0;else k=c[d+8>>2]|0;if(Ymc(k,j)|0){k=ync()|0;l=k+(c[j>>2]<<4)+4|0;i=f;return l|0}if(!(a[d>>0]&1))m=d+1|0;else m=c[d+8>>2]|0;c[g>>2]=-1;itd(g,m);m=c[g>>2]|0;c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];e=b+4|0;d=c[e>>2]|0;do if(d){j=d;while(1){k=c[j+16>>2]|0;if((m|0)<(k|0)){n=c[j>>2]|0;if(!n){o=j;p=j;q=12;break}else{j=n;continue}}if((k|0)>=(m|0)){r=j;q=16;break}k=j+4|0;n=c[k>>2]|0;if(!n){s=k;t=j;q=15;break}else j=n}if((q|0)==12){c[g>>2]=p;u=o;v=p;break}else if((q|0)==15){c[g>>2]=t;u=s;v=t;break}else if((q|0)==16){c[g>>2]=r;u=g;v=r;break}}else{j=b+4|0;c[g>>2]=j;u=j;v=j}while(0);g=c[u>>2]|0;if(!g){r=xCi(36)|0;c[r+16>>2]=m;m=r+20|0;c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=v;c[u>>2]=r;v=c[c[b>>2]>>2]|0;if(!v)w=r;else{c[b>>2]=v;w=c[u>>2]|0}GN(c[e>>2]|0,w);w=b+8|0;c[w>>2]=(c[w>>2]|0)+1;x=r}else x=g;l=x+20|0;i=f;return l|0}function Nud(){var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;e=i;i=i+272|0;f=e+8|0;h=e;if(!(c[158364]|0)){c[158364]=1;if(!(c[158366]|0))c[158366]=1;if(!(c[158356]|0))c[158356]=c[q>>2];if(!(c[158358]|0))c[158358]=c[r>>2];j=c[158368]|0;do if(!j){c[h>>2]=c[153078];c[f+0>>2]=c[h+0>>2];k=cOb(4,16,f,0,3653512,478)|0;c[158368]=k;if(!k)Uud(653160);else{c[k>>2]=0;c[163286]=1;l=17;break}}else{k=c[j>>2]|0;if(!k){m=c[163286]|0;if(0>=(m+-1|0)>>>0){n=m+8|0;c[h>>2]=c[153078];c[f+0>>2]=c[h+0>>2];m=hOb(j,n<<2,16,f,0,3653512,482)|0;c[158368]=m;if(!m)Uud(653160);else{o=m+(c[163286]<<2)|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[o+28>>2]=0;c[163286]=n;l=17;break}}else l=17}else{p=j;s=0;t=k}}while(0);if((l|0)==17){j=Oud(c[158356]|0,16384)|0;c[c[158368]>>2]=j;j=c[158368]|0;p=j;s=0;t=c[j>>2]|0}c[163224]=c[t+16>>2];j=c[t+8>>2]|0;c[158370]=j;c[158362]=j;c[158356]=c[c[p+(s<<2)>>2]>>2];a[633488]=a[j>>0]|0}a:while(1){j=c[158370]|0;a[j>>0]=a[633488]|0;s=j;p=j;j=c[158366]|0;b:while(1){t=p;h=j;while(1){k=c[633496+(d[t>>0]<<2)>>2]|0;if(!(b[634520+(h<<1)>>1]|0)){u=k;v=h}else{c[159198]=h;c[159200]=t;u=k;v=h}c:while(1){k=u&255;n=v;while(1){o=(b[636808+(n<<1)>>1]|0)+k|0;if((b[639096+(o<<1)>>1]|0)==(n|0)){w=o;break c}o=b[644656+(n<<1)>>1]|0;m=o<<16>>16;if(o<<16>>16>1133){x=m;break}else n=m}u=c[646944+(k<<2)>>2]|0;v=x}n=b[647264+(w<<1)>>1]|0;if(n<<16>>16==1133)break;else{t=t+1|0;h=n<<16>>16}}h=s;t=636800;n=c[159198]|0;d:while(1){m=t;o=n;e:while(1){y=c[m>>2]|0;z=b[634520+(o<<1)>>1]|0;c[158362]=h;A=y;a[633488]=a[y>>0]|0;a[y>>0]=0;c[158370]=y;B=y;C=z;f:while(1){switch(C|0){case 39:{l=69;break a;break}case 19:{l=49;break a;break}case 13:{l=43;break a;break}case 106:{l=141;break a;break}case 107:{l=142;break a;break}case 108:{l=143;break a;break}case 212:{l=247;break a;break}case 70:{l=99;break a;break}case 71:{l=100;break a;break}case 103:{l=132;break a;break}case 104:{l=133;break a;break}case 227:{l=310;break a;break}case 238:case 237:case 236:case 235:case 234:case 233:case 232:case 231:case 230:{l=311;break a;break}case 124:{l=159;break a;break}case 125:{l=160;break a;break}case 126:{l=161;break a;break}case 153:{l=188;break a;break}case 154:{l=189;break a;break}case 50:{l=80;break a;break}case 194:{l=229;break a;break}case 195:{l=230;break a;break}case 196:{l=231;break a;break}case 197:{l=232;break a;break}case 130:{l=165;break a;break}case 131:{l=166;break a;break}case 132:{l=167;break a;break}case 112:{l=147;break a;break}case 113:{l=148;break a;break}case 114:{l=149;break a;break}case 34:{l=64;break a;break}case 202:{l=237;break a;break}case 203:{l=238;break a;break}case 204:{l=239;break a;break}case 205:{l=240;break a;break}case 20:{l=50;break a;break}case 29:{l=59;break a;break}case 211:{l=246;break a;break}case 160:{l=195;break a;break}case 161:{l=196;break a;break}case 61:{l=91;break a;break}case 62:{l=92;break a;break}case 167:{l=202;break a;break}case 168:{l=203;break a;break}case 17:{l=47;break a;break}case 151:{l=186;break a;break}case 152:{l=187;break a;break}case 213:{l=248;break a;break}case 214:{l=249;break a;break}case 215:{D=B;l=250;break b;break}case 88:{l=117;break a;break}case 89:{l=118;break a;break}case 30:{l=60;break a;break}case 155:{l=190;break a;break}case 156:{l=191;break a;break}case 105:{l=140;break a;break}case 37:{l=67;break a;break}case 190:{l=225;break a;break}case 191:{l=226;break a;break}case 192:{l=227;break a;break}case 193:{l=228;break a;break}case 45:{l=75;break a;break}case 66:{l=95;break a;break}case 67:{l=96;break a;break}case 14:{l=44;break a;break}case 12:{l=42;break a;break}case 27:{l=57;break a;break}case 1:{l=355;break a;break}case 63:case 2:{l=356;break a;break}case 3:{E=299;break a;break}case 175:{l=210;break a;break}case 176:{l=211;break a;break}case 177:{l=212;break a;break}case 165:{l=200;break a;break}case 166:{l=201;break a;break}case 55:{l=85;break a;break}case 56:{l=86;break a;break}case 64:{l=93;break a;break}case 65:{l=94;break a;break}case 41:{l=71;break a;break}case 169:{l=204;break a;break}case 170:{l=205;break a;break}case 171:{l=206;break a;break}case 157:{l=192;break a;break}case 158:{l=193;break a;break}case 159:{l=194;break a;break}case 44:{l=74;break a;break}case 48:{l=78;break a;break}case 51:{l=81;break a;break}case 136:{l=171;break a;break}case 137:{l=172;break a;break}case 138:{l=173;break a;break}case 49:{l=79;break a;break}case 133:{l=168;break a;break}case 134:{l=169;break a;break}case 135:{l=170;break a;break}case 100:{l=129;break a;break}case 101:{l=130;break a;break}case 102:{l=131;break a;break}case 181:{l=216;break a;break}case 182:{l=217;break a;break}case 183:{l=218;break a;break}case 40:{l=70;break a;break}case 180:{l=215;break a;break}case 59:{l=89;break a;break}case 60:{l=90;break a;break}case 82:{l=111;break a;break}case 83:{l=112;break a;break}case 21:{l=51;break a;break}case 127:{l=162;break a;break}case 128:{l=163;break a;break}case 129:{l=164;break a;break}case 142:{l=177;break a;break}case 143:{l=178;break a;break}case 144:{l=179;break a;break}case 109:{l=144;break a;break}case 110:{l=145;break a;break}case 111:{l=146;break a;break}case 97:{l=126;break a;break}case 98:{l=127;break a;break}case 99:{l=128;break a;break}case 139:{l=174;break a;break}case 140:{l=175;break a;break}case 141:{l=176;break a;break}case 145:{l=180;break a;break}case 146:{l=181;break a;break}case 147:{l=182;break a;break}case 35:{l=65;break a;break}case 25:{l=55;break a;break}case 80:{l=109;break a;break}case 81:{l=110;break a;break}case 15:{l=45;break a;break}case 42:{l=72;break a;break}case 31:{l=61;break a;break}case 86:{l=115;break a;break}case 87:{l=116;break a;break}case 43:{l=73;break a;break}case 84:{l=113;break a;break}case 85:{l=114;break a;break}case 72:{l=101;break a;break}case 73:{l=102;break a;break}case 26:{l=56;break a;break}case 121:{l=156;break a;break}case 122:{l=157;break a;break}case 123:{l=158;break a;break}case 11:{l=41;break a;break}case 28:{l=58;break a;break}case 148:{l=183;break a;break}case 149:{l=184;break a;break}case 150:{l=185;break a;break}case 162:{l=197;break a;break}case 163:{l=198;break a;break}case 164:{l=199;break a;break}case 118:{l=153;break a;break}case 119:{l=154;break a;break}case 120:{l=155;break a;break}case 52:{l=82;break a;break}case 47:{l=77;break a;break}case 22:{l=52;break a;break}case 23:{l=53;break a;break}case 74:{l=103;break a;break}case 75:{l=104;break a;break}case 46:{l=76;break a;break}case 24:{l=54;break a;break}case 115:{l=150;break a;break}case 116:{l=151;break a;break}case 117:{l=152;break a;break}case 33:{l=63;break a;break}case 90:{l=119;break a;break}case 91:{l=120;break a;break}case 18:{l=48;break a;break}case 206:{l=241;break a;break}case 207:{l=242;break a;break}case 208:{l=243;break a;break}case 209:{l=244;break a;break}case 16:{l=46;break a;break}case 32:{l=62;break a;break}case 10:{l=40;break a;break}case 184:{l=219;break a;break}case 185:{l=220;break a;break}case 186:{l=221;break a;break}case 178:{l=213;break a;break}case 179:{l=214;break a;break}case 187:{l=222;break a;break}case 188:{l=223;break a;break}case 189:{l=224;break a;break}case 94:{l=123;break a;break}case 95:{l=124;break a;break}case 96:{l=125;break a;break}case 38:{l=68;break a;break}case 92:{l=121;break a;break}case 93:{l=122;break a;break}case 36:{l=66;break a;break}case 210:{l=245;break a;break}case 68:{l=97;break a;break}case 69:{l=98;break a;break}case 198:{l=233;break a;break}case 199:{l=234;break a;break}case 200:{l=235;break a;break}case 201:{l=236;break a;break}case 57:{l=87;break a;break}case 58:{l=88;break a;break}case 78:{l=107;break a;break}case 79:{l=108;break a;break}case 172:{l=207;break a;break}case 173:{l=208;break a;break}case 174:{l=209;break a;break}case 53:{l=83;break a;break}case 54:{l=84;break a;break}case 229:break;case 216:{l=264;break b;break}case 217:{l=265;break b;break}case 218:{l=266;break a;break}case 219:{l=267;break a;break}case 222:{l=271;break b;break}case 223:{l=272;break b;break}case 224:{l=273;break b;break}case 225:{l=274;break b;break}case 226:{F=1;l=275;break b;break}case 76:{l=105;break a;break}case 77:{l=106;break a;break}case 228:case 221:case 220:{continue a;break}case 5:{l=35;break a;break}case 4:{l=34;break a;break}case 6:{l=36;break a;break}case 9:{l=39;break a;break}case 8:{l=38;break a;break}case 7:{l=37;break a;break}case 0:{break f;break}default:{l=354;break a}}z=c[158362]|0;a[y>>0]=a[633488]|0;G=c[c[158368]>>2]|0;if(!(c[G+44>>2]|0)){c[163224]=c[G+16>>2];c[G>>2]=c[158356];H=c[158368]|0;c[(c[H>>2]|0)+44>>2]=1;I=c[H>>2]|0}else I=G;if((c[158370]|0)>>>0<=((c[I+4>>2]|0)+(c[163224]|0)|0)>>>0){J=z;K=A;break e}G=Vud()|0;if(!G){L=z;M=A;break d}else if((G|0)==2){l=344;break e}else if((G|0)!=1)continue a;G=c[158362]|0;c[158370]=G;B=G;C=(((c[158366]|0)+-1|0)/2|0)+230|0}a[y>>0]=a[633488]|0;m=636800;o=c[159198]|0}if((l|0)==344){l=0;o=(c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0;c[158370]=o;m=c[158366]|0;C=c[158362]|0;if(C>>>0<o>>>0){N=C;O=m}else{h=C;t=633480;n=m;continue}while(1){m=a[N>>0]|0;if(!(m<<24>>24))P=1;else P=c[633496+((m&255)<<2)>>2]|0;if(!(b[634520+(O<<1)>>1]|0)){Q=P;R=O}else{c[159198]=O;c[159200]=N;Q=P;R=O}g:while(1){m=Q&255;B=R;while(1){A=(b[636808+(B<<1)>>1]|0)+m|0;if((b[639096+(A<<1)>>1]|0)==(B|0)){S=A;break g}A=b[644656+(B<<1)>>1]|0;k=A<<16>>16;if(A<<16>>16>1133){T=k;break}else B=k}Q=c[646944+(m<<2)>>2]|0;R=T}y=b[647264+(S<<1)>>1]|0;B=N+1|0;if((B|0)==(o|0)){h=C;t=633480;n=y;continue d}else{N=B;O=y}}}C=K-J|0;o=C+-1|0;y=c[158362]|0;B=y+o|0;c[158370]=B;k=c[158366]|0;if((o|0)>0){o=y;A=k;while(1){G=a[o>>0]|0;if(!(G<<24>>24))U=1;else U=c[633496+((G&255)<<2)>>2]|0;if(!(b[634520+(A<<1)>>1]|0)){V=U;W=A}else{c[159198]=A;c[159200]=o;V=U;W=A}h:while(1){G=V&255;z=W;while(1){H=(b[636808+(z<<1)>>1]|0)+G|0;if((b[639096+(H<<1)>>1]|0)==(z|0)){X=H;break h}H=b[644656+(z<<1)>>1]|0;Y=H<<16>>16;if(H<<16>>16>1133){Z=Y;break}else z=Y}V=c[646944+(G<<2)>>2]|0;W=Z}z=b[647264+(X<<1)>>1]|0;o=o+1|0;if(o>>>0>=B>>>0){_=z;break}else A=z}}else _=k;if(b[634520+(_<<1)>>1]|0){c[159198]=_;c[159200]=B}A=(b[636808+(_<<1)>>1]|0)+1|0;if((b[639096+(A<<1)>>1]|0)==(_|0))$=A;else{A=_;do{o=b[644656+(A<<1)>>1]|0;A=o<<16>>16;z=(b[636808+(A<<1)>>1]|0)+1|0}while((b[639096+(z<<1)>>1]|0)!=o<<16>>16);$=z}A=b[647264+($<<1)>>1]|0;B=A<<16>>16==1133?0:A<<16>>16;if(B){aa=C;ba=y;ca=B;l=330;break}h=y;t=636800;n=c[159198]|0}if((l|0)==330){l=0;n=ba+aa|0;c[158370]=n;s=ba;p=n;j=ca;continue}n=M-L+-1|0;t=c[158362]|0;h=t+n|0;c[158370]=h;B=c[158366]|0;if((n|0)>0){da=t;fa=B}else{s=t;p=h;j=B;continue}while(1){B=a[da>>0]|0;if(!(B<<24>>24))ga=1;else ga=c[633496+((B&255)<<2)>>2]|0;if(!(b[634520+(fa<<1)>>1]|0)){ha=ga;ia=fa}else{c[159198]=fa;c[159200]=da;ha=ga;ia=fa}i:while(1){B=ha&255;n=ia;while(1){A=(b[636808+(n<<1)>>1]|0)+B|0;if((b[639096+(A<<1)>>1]|0)==(n|0)){ja=A;break i}A=b[644656+(n<<1)>>1]|0;k=A<<16>>16;if(A<<16>>16>1133){ka=k;break}else n=k}ha=c[646944+(B<<2)>>2]|0;ia=ka}y=b[647264+(ja<<1)>>1]|0;C=da+1|0;if(C>>>0<h>>>0){da=C;fa=y}else{s=t;p=h;j=y;continue b}}}if((l|0)==250){l=0;j=a[633488]|0;p=D;s=0;j:while(1){h=j;t=p;while(1){a[t>>0]=h;y=c[158370]|0;do if(!(a[y>>0]|0)){if(y>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[y>>0]=0;break}C=c[158362]|0;c[158370]=y+1;n=Vud()|0;if((n|0)==2){la=s;l=256;break j}else if((n|0)==1){ma=s;break j}else if(n)break;c[158370]=(c[158362]|0)+(y-C)}while(0);y=c[158370]|0;C=a[y>>0]|0;n=C&255;a[y>>0]=0;y=(c[158370]|0)+1|0;c[158370]=y;k=a[y>>0]|0;a[633488]=k;if((n|0)==9|(n|0)==32){h=k;t=y}else{na=C;oa=n;pa=y;qa=k;break}}if((oa+-48|0)>>>0>9|(s|0)>254){ma=s;break}if(!(na<<24>>24)){l=261;break a}a[f+s>>0]=na;j=qa;p=pa;s=s+1|0}if((l|0)==256){l=0;Pud(c[158356]|0);ma=la}a[f+ma>>0]=0;c[158360]=wEi(f)|0;continue}else if((l|0)==264){l=0;if(Wud(1)|0)continue;else{E=0;break}}else if((l|0)==265){l=0;if(Wud(0)|0)continue;else{E=0;break}}else if((l|0)==271){l=0;c[158360]=(c[158360]|0)+1;continue}else if((l|0)==272){l=0;c[158360]=(c[158360]|0)+1;continue}else if((l|0)==273){l=0;c[158360]=(c[158360]|0)+1;continue}else if((l|0)==274){l=0;c[158360]=(c[158360]|0)+1;continue}else if((l|0)==275)while(1){l=0;k:while(1){a[c[158370]>>0]=a[633488]|0;s=c[158370]|0;do if(!(a[s>>0]|0)){if(s>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[s>>0]=0;break}p=c[158362]|0;c[158370]=s+1;j=Vud()|0;if((j|0)==1){l=309;break a}else if((j|0)==2){l=280;break a}else if(j)break;c[158370]=(c[158362]|0)+(s-p)}while(0);s=c[158370]|0;p=d[s>>0]|0;a[s>>0]=0;s=(c[158370]|0)+1|0;c[158370]=s;j=a[s>>0]|0;a[633488]=j;switch(p|0){case 0:{l=309;break a;break}case 47:{ra=j;sa=s;ta=F;l=300;break k;break}case 10:{c[158360]=(c[158360]|0)+1;continue k;break}case 42:{ua=j;va=s;l=292;break k;break}case 13:break;default:continue k}c[158360]=(c[158360]|0)+1;a[s>>0]=j;j=c[158370]|0;do if(!(a[j>>0]|0)){if(j>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[j>>0]=0;break}s=c[158362]|0;c[158370]=j+1;p=Vud()|0;if((p|0)==2){Pud(c[158356]|0);continue k}else if(!p){c[158370]=(c[158362]|0)+(j-s);break}else if((p|0)==1)continue k;else break}while(0);j=c[158370]|0;p=a[j>>0]|0;a[j>>0]=0;j=(c[158370]|0)+1|0;c[158370]=j;a[633488]=a[j>>0]|0;if(p<<24>>24!=13)continue;c[158360]=(c[158360]|0)+1}l:do if((l|0)==292){while(1){l=0;a[va>>0]=ua;p=c[158370]|0;do if(!(a[p>>0]|0)){if(p>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[p>>0]=0;break}j=c[158362]|0;c[158370]=p+1;s=Vud()|0;if((s|0)==1){l=309;break a}else if((s|0)==2){l=296;break a}else if(s)break;c[158370]=(c[158362]|0)+(p-j)}while(0);p=c[158370]|0;B=d[p>>0]|0;a[p>>0]=0;p=(c[158370]|0)+1|0;c[158370]=p;j=a[p>>0]|0;a[633488]=j;if((B|0)==47){wa=p;xa=j;break}else if((B|0)==42){ua=j;va=p;l=292}else{ya=B;za=F;break l}}B=F+-1|0;if(!B)continue a;else{ra=xa;sa=wa;ta=B;l=300}}while(0);if((l|0)==300){l=0;a[sa>>0]=ra;B=c[158370]|0;do if(!(a[B>>0]|0)){if(B>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[B>>0]=0;l=306;break}p=c[158362]|0;c[158370]=B+1;j=Vud()|0;if(!j){c[158370]=(c[158362]|0)+(B-p);l=306;break}else if((j|0)==1){Aa=0;break}else if((j|0)==2){Pud(c[158356]|0);Aa=0;break}else{l=306;break}}else l=306;while(0);if((l|0)==306){l=0;B=c[158370]|0;j=d[B>>0]|0;a[B>>0]=0;B=(c[158370]|0)+1|0;c[158370]=B;a[633488]=a[B>>0]|0;Aa=j}ya=Aa;za=((Aa|0)==42&1)+ta|0}if((ya|0)==0|(ya|0)==-1){l=309;break a}else{F=za;l=275}}}m:switch(l|0){case 34:{c[158366]=13;E=299;break}case 35:{E=298;break}case 36:{c[158366]=1;c[163380]=0;E=354;break}case 37:{c[158366]=1;c[163380]=1;E=354;break}case 38:{c[158366]=1;c[163380]=1;E=354;break}case 39:{c[158366]=1;c[163380]=2;E=354;break}case 40:{c[158366]=1;c[163380]=3;E=354;break}case 41:{c[158366]=1;c[163380]=4;E=354;break}case 42:{c[158366]=1;c[163380]=5;E=354;break}case 43:{c[158366]=1;c[163380]=6;E=354;break}case 44:{c[158366]=1;c[163380]=7;E=354;break}case 45:{c[158366]=1;c[163380]=8;E=354;break}case 46:{c[158366]=1;c[163380]=9;E=354;break}case 47:{c[158366]=1;c[163380]=10;E=354;break}case 48:{c[158366]=1;c[163380]=11;E=354;break}case 49:{c[158366]=1;c[163380]=12;E=354;break}case 50:{c[158366]=1;c[163380]=13;E=354;break}case 51:{c[158366]=1;c[163380]=14;E=354;break}case 52:{c[158366]=1;c[163380]=15;E=354;break}case 53:{c[158366]=1;c[163380]=16;E=354;break}case 54:{c[158366]=1;c[163380]=17;E=354;break}case 55:{c[158366]=1;c[163380]=18;E=354;break}case 56:{c[158366]=1;c[163380]=19;E=354;break}case 57:{c[158366]=1;c[163380]=20;E=354;break}case 58:{c[158366]=1;c[163380]=21;E=354;break}case 59:{c[158366]=1;c[163380]=22;E=354;break}case 60:{c[158366]=1;c[163380]=23;E=354;break}case 61:{c[158366]=1;c[163380]=24;E=354;break}case 62:{c[158366]=1;c[163380]=25;E=354;break}case 63:{c[158366]=1;c[163380]=26;E=354;break}case 64:{c[158366]=1;c[163380]=27;E=354;break}case 65:{E=300;break}case 66:{E=309;break}case 67:{E=258;break}case 68:{E=277;break}case 69:{E=306;break}case 70:{E=307;break}case 71:{E=308;break}case 72:{E=311;break}case 73:{E=326;break}case 74:{E=327;break}case 75:{E=270;break}case 76:{E=302;break}case 77:{E=303;break}case 78:{E=295;break}case 79:{c[158366]=15;E=264;break}case 80:{c[158366]=15;E=265;break}case 81:{c[163380]=1;c[158366]=1;E=351;break}case 82:{c[163380]=2;c[158366]=1;E=351;break}case 83:{c[163380]=3;c[158366]=1;E=351;break}case 84:{c[163380]=4;c[158366]=1;E=351;break}case 85:{c[163380]=5;c[158366]=1;E=351;break}case 86:{c[163380]=6;c[158366]=1;E=351;break}case 87:{c[163380]=7;c[158366]=1;E=351;break}case 88:{c[163380]=8;c[158366]=1;E=351;break}case 89:{c[158366]=5;E=301;break}case 90:{E=280;break}case 91:{E=325;break}case 92:{E=324;break}case 93:{c[163380]=0;E=355;break}case 94:{c[163380]=1;E=355;break}case 95:{c[163380]=2;E=355;break}case 96:{c[163380]=3;E=355;break}case 97:{c[163380]=-1;E=355;break}case 98:{c[158366]=1;E=125;break}case 99:{c[158366]=9;E=328;break}case 100:{E=329;break}case 101:{E=330;break}case 102:{E=331;break}case 103:{E=332;break}case 104:{E=336;break}case 105:{E=340;break}case 106:{c[163380]=1;E=351;break}case 107:{c[163380]=2;E=351;break}case 108:{c[163380]=3;E=351;break}case 109:{c[163380]=4;E=351;break}case 110:{c[163380]=5;E=351;break}case 111:{c[163380]=6;E=351;break}case 112:{c[163380]=7;E=351;break}case 113:{c[163380]=8;E=351;break}case 114:{E=333;break}case 115:{E=334;break}case 116:{E=335;break}case 117:{E=337;break}case 118:{E=338;break}case 119:{E=339;break}case 120:{E=341;break}case 121:{E=342;break}case 122:{E=343;break}case 123:{c[163380]=0;E=359;break}case 124:{c[163380]=1;E=359;break}case 125:{c[163380]=2;E=359;break}case 126:{c[163380]=3;E=359;break}case 127:{c[163380]=4;E=359;break}case 128:{c[163380]=5;E=359;break}case 129:{c[163380]=6;E=359;break}case 130:{c[163380]=7;E=359;break}case 131:{c[158366]=1;E=125;break}case 132:{c[158366]=17;c[163380]=0;E=269;break}case 133:{c[158366]=1;c[163380]=0;za=c[158362]|0;F=a[za>>0]|0;if(!(F<<24>>24))E=353;else{ya=F;F=0;ta=0;Aa=0;ra=0;sa=za;while(1){sa=sa+1|0;switch(ya<<24>>24|0){case 65:case 97:{za=ra|1;c[163380]=za;Ba=za;Ca=za;Da=za;Ea=za;break}case 82:case 114:{za=F|8;c[163380]=za;Ba=za;Ca=za;Da=za;Ea=za;break}case 71:case 103:{za=ta|4;c[163380]=za;Ba=za;Ca=za;Da=za;Ea=za;break}case 66:case 98:{za=Aa|2;c[163380]=za;Ba=za;Ca=za;Da=za;Ea=za;break}default:{Ba=ra;Ca=Aa;Da=ta;Ea=F}}ya=a[sa>>0]|0;if(!(ya<<24>>24)){E=353;break m}else{F=Ea;ta=Da;Aa=Ca;ra=Ba}}}break}case 140:{E=283;break}case 141:{E=266;break}case 142:{c[163380]=1;E=348;break}case 143:{c[163380]=2;E=348;break}case 144:{E=284;break}case 145:{E=285;break}case 146:{E=286;break}case 147:{E=287;break}case 148:{E=288;break}case 149:{E=289;break}case 150:{c[158366]=1;E=267;break}case 151:{c[163380]=0;E=349;break}case 152:{c[163380]=1;E=349;break}case 153:{c[163380]=2;E=349;break}case 154:{c[163380]=3;E=349;break}case 155:{c[163380]=4;E=349;break}case 156:{c[163380]=5;E=349;break}case 157:{c[163380]=6;E=349;break}case 158:{c[163380]=7;E=349;break}case 159:{c[163380]=8;E=349;break}case 160:{c[163380]=9;E=349;break}case 161:{c[163380]=10;E=349;break}case 162:{c[163380]=1;E=349;break}case 163:{c[163380]=0;E=349;break}case 164:{c[163380]=1;E=349;break}case 165:{c[163380]=0;E=349;break}case 166:{c[158366]=1;E=268;break}case 167:{c[163380]=0;E=350;break}case 168:{c[163380]=1;E=350;break}case 169:{c[163380]=2;E=350;break}case 170:{c[163380]=3;E=350;break}case 171:{c[163380]=4;E=350;break}case 172:{c[163380]=5;E=350;break}case 173:{c[163380]=6;E=350;break}case 174:{c[163380]=7;E=350;break}case 175:{c[163380]=8;E=350;break}case 176:{c[163380]=9;E=350;break}case 177:{c[163380]=10;E=350;break}case 178:{c[163380]=11;E=350;break}case 179:{c[163380]=12;E=350;break}case 180:{c[163380]=13;E=350;break}case 181:{c[163380]=14;E=350;break}case 182:{c[163380]=15;E=350;break}case 183:{c[163380]=16;E=350;break}case 184:{c[163380]=17;E=350;break}case 185:{c[163380]=18;E=350;break}case 186:{c[163380]=19;E=350;break}case 187:{c[163380]=20;E=350;break}case 188:{c[158366]=7;E=294;break}case 189:{c[158366]=1;c[163380]=1;E=358;break}case 190:{c[158366]=1;c[163380]=2;E=358;break}case 191:{E=280;break}case 192:{E=282;break}case 193:{c[158366]=1;E=259;break}case 194:{c[158366]=1;E=261;break}case 195:{c[158366]=1;E=260;break}case 196:{c[158366]=3;E=276;break}case 197:{E=281;break}case 198:{E=271;break}case 199:{c[163380]=0;E=356;break}case 200:{c[163380]=1;E=356;break}case 201:{c[163380]=2;E=356;break}case 202:{c[163380]=3;E=356;break}case 203:{c[163380]=4;E=356;break}case 204:{c[163380]=5;E=356;break}case 205:{c[163380]=6;E=356;break}case 206:{c[163380]=7;E=356;break}case 207:{E=272;break}case 208:{E=296;break}case 209:{E=297;break}case 210:{E=273;break}case 211:{E=274;break}case 212:{E=275;break}case 213:{E=279;break}case 214:{c[158366]=11;E=278;break}case 215:{c[158366]=1;E=a[c[158362]>>0]|0;break}case 216:{c[163380]=2;c[158366]=3;E=357;break}case 217:{c[163380]=3;c[158366]=3;E=357;break}case 218:{c[163380]=4;c[158366]=3;E=357;break}case 219:{c[163380]=2;c[158366]=3;E=357;break}case 220:{c[163380]=5;c[158366]=3;E=357;break}case 221:{c[158366]=3;c[163380]=0;E=352;break}case 222:{c[158366]=3;c[163380]=0;E=352;break}case 223:{c[158366]=3;c[163380]=0;E=352;break}case 224:{c[158366]=3;c[163380]=0;E=352;break}case 225:{c[158366]=3;c[163380]=0;E=352;break}case 226:{c[158366]=1;E=305;break}case 227:{c[158366]=1;E=310;break}case 228:{E=312;break}case 229:{E=291;break}case 230:{E=293;break}case 231:{E=291;break}case 232:{E=262;break}case 233:{E=263;break}case 234:{E=304;break}case 235:{E=313;break}case 236:{E=314;break}case 237:{E=315;break}case 238:{E=316;break}case 239:{E=317;break}case 240:{E=318;break}case 241:{E=319;break}case 242:{E=320;break}case 243:{E=321;break}case 244:{E=322;break}case 245:{E=323;break}case 246:{Ba=c[158362]|0;ra=SEi(Ba|0)|0;Ca=c[164622]|0;Aa=xo[c[(c[Ca>>2]|0)+8>>2]&2047](Ca,ra+-1|0,1)|0;Ca=ra+-2|0;YEi(Aa|0,Ba+1|0,Ca|0)|0;a[Aa+Ca>>0]=0;c[163380]=Aa;E=346;break}case 247:{Aa=c[158362]|0;Ca=SEi(Aa|0)|0;Ba=c[164622]|0;ra=xo[c[(c[Ba>>2]|0)+8>>2]&2047](Ba,Ca+-1|0,1)|0;Ba=Ca+-2|0;YEi(ra|0,Aa+1|0,Ba|0)|0;a[ra+Ba>>0]=0;c[163380]=ra;E=346;break}case 248:{g[163380]=ea(Jsd(c[158362]|0,0));E=347;break}case 249:{g[163380]=ea(Jsd(c[158362]|0,0));E=347;break}case 261:{Yud(652824)|0;E=0;break}case 266:{ra=c[158362]|0;Ba=(SEi(ra|0)|0)+1|0;Aa=c[164622]|0;Ca=xo[c[(c[Aa>>2]|0)+8>>2]&2047](Aa,Ba,1)|0;YEi(Ca|0,ra|0,Ba|0)|0;c[163380]=Ca;E=344;break}case 267:{Ca=c[158362]|0;Ba=SEi(Ca|0)|0;ra=c[164622]|0;Aa=xo[c[(c[ra>>2]|0)+8>>2]&2047](ra,Ba+-1|0,1)|0;ra=Ba+-2|0;YEi(Aa|0,Ca+1|0,ra|0)|0;a[Aa+ra>>0]=0;c[163380]=Aa;ra=Aa;while(1){Aa=a[ra>>0]|0;if(!(Aa<<24>>24)){E=345;break m}else if(Aa<<24>>24==10)c[158360]=(c[158360]|0)+1;ra=ra+1|0}break}case 280:{Pud(c[158356]|0);l=309;break}case 296:{Pud(c[158356]|0);l=309;break}case 310:{E=a[c[158362]>>0]|0;break}case 311:{E=0;break}case 354:{Uud(652904);break}case 355:{E=290;break}case 356:{E=292;break}}if((l|0)==309){Yud(652848)|0;E=0}i=e;return E|0}function Oud(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[153078];c[f+0>>2]=c[g+0>>2];h=cOb(48,16,f,0,3653512,478)|0;if(!h)Uud(652960);c[h+12>>2]=d;c[g>>2]=c[153078];c[f+0>>2]=c[g+0>>2];g=cOb(d+2|0,16,f,0,3653512,478)|0;f=h+4|0;c[f>>2]=g;if(!g)Uud(652960);c[h+20>>2]=1;d=xd()|0;j=c[d>>2]|0;c[h+16>>2]=0;a[g>>0]=0;a[(c[f>>2]|0)+1>>0]=0;c[h+8>>2]=c[f>>2];c[h+28>>2]=1;c[h+44>>2]=0;f=c[158368]|0;if(!f)k=0;else k=c[f>>2]|0;if((k|0)==(h|0)){k=c[f>>2]|0;c[163224]=c[k+16>>2];g=c[k+8>>2]|0;c[158370]=g;c[158362]=g;c[158356]=c[c[f>>2]>>2];a[633488]=a[g>>0]|0}c[h>>2]=b;c[h+40>>2]=1;b=c[158368]|0;if(!b)l=0;else l=c[b>>2]|0;if((l|0)==(h|0)){m=h+24|0;c[m>>2]=0;c[d>>2]=j;i=e;return h|0}c[h+32>>2]=1;c[h+36>>2]=0;m=h+24|0;c[m>>2]=0;c[d>>2]=j;i=e;return h|0}function Pud(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[158368]|0;do if(!g){c[f>>2]=c[153078];c[e+0>>2]=c[f+0>>2];h=cOb(4,16,e,0,3653512,478)|0;c[158368]=h;if(!h)Uud(653160);else{c[h>>2]=0;c[163286]=1;j=10;break}}else if(!(c[g>>2]|0)){h=c[163286]|0;if(0>=(h+-1|0)>>>0){k=h+8|0;c[f>>2]=c[153078];c[e+0>>2]=c[f+0>>2];h=hOb(g,k<<2,16,e,0,3653512,482)|0;c[158368]=h;if(!h)Uud(653160);else{l=h+(c[163286]<<2)|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0;c[163286]=k;j=10;break}}else j=10}else{m=g;n=0;j=12}while(0);if((j|0)==10){g=Oud(c[158356]|0,16384)|0;c[c[158368]>>2]=g;g=c[158368]|0;if(!g){e=xd()|0;o=0;p=c[e>>2]|0;q=e}else{m=g;n=0;j=12}}if((j|0)==12){j=c[m+(n<<2)>>2]|0;n=xd()|0;m=c[n>>2]|0;if(j){c[j+16>>2]=0;g=j+4|0;a[c[g>>2]>>0]=0;a[(c[g>>2]|0)+1>>0]=0;c[j+8>>2]=c[g>>2];c[j+28>>2]=1;c[j+44>>2]=0;g=c[158368]|0;if(!g)r=0;else r=c[g>>2]|0;if((r|0)==(j|0)){r=c[g>>2]|0;c[163224]=c[r+16>>2];e=c[r+8>>2]|0;c[158370]=e;c[158362]=e;c[158356]=c[c[g>>2]>>2];a[633488]=a[e>>0]|0;o=j;p=m;q=n}else{o=j;p=m;q=n}}else{o=0;p=m;q=n}}c[o>>2]=b;c[o+40>>2]=1;b=c[158368]|0;if(!b)s=0;else s=c[b>>2]|0;if((s|0)==(o|0)){t=o+24|0;c[t>>2]=0;c[q>>2]=p;u=c[b>>2]|0;v=u+16|0;w=c[v>>2]|0;c[163224]=w;x=u+8|0;y=c[x>>2]|0;c[158370]=y;c[158362]=y;z=c[b>>2]|0;A=c[z>>2]|0;c[158356]=A;B=a[y>>0]|0;a[633488]=B;i=d;return}c[o+32>>2]=1;c[o+36>>2]=0;t=o+24|0;c[t>>2]=0;c[q>>2]=p;u=c[b>>2]|0;v=u+16|0;w=c[v>>2]|0;c[163224]=w;x=u+8|0;y=c[x>>2]|0;c[158370]=y;c[158362]=y;z=c[b>>2]|0;A=c[z>>2]|0;c[158356]=A;B=a[y>>0]|0;a[633488]=B;i=d;return}function Qud(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[158368]|0;do if(!g){c[f>>2]=c[153078];c[e+0>>2]=c[f+0>>2];h=cOb(4,16,e,0,3653512,478)|0;c[158368]=h;if(!h)Uud(653160);else{c[h>>2]=0;c[163286]=1;j=c[158368]|0;k=9;break}}else{h=c[163286]|0;if(0>=(h+-1|0)>>>0){l=h+8|0;c[f>>2]=c[153078];c[e+0>>2]=c[f+0>>2];h=hOb(g,l<<2,16,e,0,3653512,482)|0;c[158368]=h;if(!h)Uud(653160);else{m=h+(c[163286]<<2)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m+24>>2]=0;c[m+28>>2]=0;c[163286]=l;j=h;k=9;break}}else{n=g;k=10}}while(0);if((k|0)==9)if(!j){o=0;p=0}else{n=j;k=10}if((k|0)==10){o=c[n>>2]|0;p=n}if((o|0)==(b|0)){i=d;return}if(!(c[p>>2]|0))q=p;else{a[c[158370]>>0]=a[633488]|0;c[(c[c[158368]>>2]|0)+8>>2]=c[158370];p=c[158368]|0;c[(c[p>>2]|0)+16>>2]=c[163224];q=p}c[q>>2]=b;b=c[158368]|0;q=c[b>>2]|0;c[163224]=c[q+16>>2];p=c[q+8>>2]|0;c[158370]=p;c[158362]=p;c[158356]=c[c[b>>2]>>2];a[633488]=a[p>>0]|0;i=d;return}function Rud(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[153078];c[f+0>>2]=c[g+0>>2];h=cOb(d+2|0,16,f,0,3653512,478)|0;if(!h)Uud(653056);if(d){j=0;do{a[h+j>>0]=a[b+j>>0]|0;j=j+1|0}while((j|0)!=(d|0));a[h+(d+1)>>0]=0;a[h+d>>0]=0;if(d>>>0>4294967293)Uud(653104)}else{a[h+(d+1)>>0]=0;a[h+d>>0]=0}c[g>>2]=c[153078];c[f+0>>2]=c[g+0>>2];g=cOb(48,16,f,0,3653512,478)|0;if(!g)Uud(653008);else{c[g+12>>2]=d;c[g+4>>2]=h;c[g+8>>2]=h;h=g+20|0;c[h>>2]=0;c[g>>2]=0;c[g+16>>2]=d;c[g+24>>2]=0;c[g+28>>2]=1;c[g+40>>2]=0;c[g+44>>2]=0;Qud(g);c[h>>2]=1;i=e;return g|0}return 0}function Sud(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Rud(a,b)|0;c[163284]=e;Qud(e);c[158360]=1;c[158366]=1;i=d;return}function Tud(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[158368]|0;if(!e){i=a;return}f=c[e>>2]|0;if(!f){i=a;return}c[e>>2]=0;if(c[f+20>>2]|0){e=c[f+4>>2]|0;c[d>>2]=c[153078];c[b+0>>2]=c[d+0>>2];eOb(e,b)}c[d>>2]=c[153078];c[b+0>>2]=c[d+0>>2];eOb(f,b);i=a;return}function Uud(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;b=c[p>>2]|0;c[d>>2]=a;Li(b|0,653152,d|0)|0;rl(2)}function Vud(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[158368]|0;g=c[f>>2]|0;h=c[g+4>>2]|0;j=c[158362]|0;k=c[158370]|0;if(k>>>0>(h+((c[163224]|0)+1)|0)>>>0)Uud(653216);l=k;k=j;m=l-k|0;if(!(c[g+40>>2]|0)){n=(m|0)==1?1:2;i=b;return n|0}o=m+-1|0;if((o|0)>0){m=l+-1-k|0;k=h;h=0;l=j;while(1){a[k>>0]=a[l>>0]|0;h=h+1|0;if((h|0)==(m|0))break;else{k=k+1|0;l=l+1|0}}l=c[158368]|0;p=l;q=c[l>>2]|0}else{p=f;q=g}if((c[q+44>>2]|0)==2){c[163224]=0;c[q+16>>2]=0;r=p}else{g=(c[q+12>>2]|0)-o+-1|0;a:do if(!g){f=p;l=q;while(1){k=(f|0)==0?0:l;m=k+4|0;h=c[m>>2]|0;j=(c[158370]|0)-h|0;if(!(c[k+20>>2]|0)){s=m;break}t=k+12|0;k=c[t>>2]|0;u=k<<1;if(!u)v=(k>>>3)+k|0;else v=u;c[t>>2]=v;c[e>>2]=c[153078];c[d+0>>2]=c[e+0>>2];t=hOb(h,v+2|0,16,d,0,3653512,482)|0;c[m>>2]=t;if(!t){w=18;break}c[158370]=t+j;j=c[158368]|0;t=c[j>>2]|0;m=(c[t+12>>2]|0)-o+-1|0;if(!m){f=j;l=t}else{x=t;y=j;z=m;break a}}if((w|0)==18)Uud(653272);c[s>>2]=0;Uud(653272)}else{x=q;y=p;z=g}while(0);g=z>>>0>8192?8192:z;b:do if(!(c[x+24>>2]|0)){z=xd()|0;c[z>>2]=0;p=ik((c[(c[y>>2]|0)+4>>2]|0)+o|0,1,g|0,c[158356]|0)|0;c[163224]=p;if(!p){while(1){q=c[158356]|0;if(!(Zd(q|0)|0)){A=0;break b}if((c[z>>2]|0)!=4)break;c[z>>2]=0;ph(q|0);q=ik((c[(c[c[158368]>>2]|0)+4>>2]|0)+o|0,1,g|0,c[158356]|0)|0;c[163224]=q;if(q){A=q;break b}}Uud(653320)}else A=p}else{do if(g){z=0;while(1){q=Qj(c[158356]|0)|0;if((q|0)==-1){B=z;break}else if((q|0)==10){C=z;w=25;break}a[(c[(c[c[158368]>>2]|0)+4>>2]|0)+(z+o)>>0]=q;s=z+1|0;if(s>>>0<g>>>0)z=s;else{D=s;E=q;w=24;break}}if((w|0)==24)if((E|0)==-1)B=D;else if((E|0)==10){C=D;w=25}else{F=D;break}if((w|0)==25){a[(c[(c[c[158368]>>2]|0)+4>>2]|0)+(C+o)>>0]=10;F=C+1|0;break}if(!(Zd(c[158356]|0)|0))F=B;else Uud(653320)}else F=0;while(0);c[163224]=F;A=F}while(0);F=c[158368]|0;c[(c[F>>2]|0)+16>>2]=A;r=F}do if(!(c[163224]|0))if(!o){Pud(c[158356]|0);G=c[158368]|0;H=1;break}else{c[(c[r>>2]|0)+44>>2]=2;G=r;H=2;break}else{G=r;H=0}while(0);r=c[163224]|0;F=r+o|0;A=c[G>>2]|0;do if(F>>>0>(c[A+12>>2]|0)>>>0){G=c[A+4>>2]|0;c[e>>2]=c[153078];c[d+0>>2]=c[e+0>>2];B=hOb(G,F+(r>>>1)|0,16,d,0,3653512,482)|0;c[(c[c[158368]>>2]|0)+4>>2]=B;B=c[(c[c[158368]>>2]|0)+4>>2]|0;if(!B)Uud(653352);else{I=c[163224]|0;J=B;break}}else{I=r;J=c[A+4>>2]|0}while(0);A=I+o|0;c[163224]=A;a[J+A>>0]=0;a[(c[(c[c[158368]>>2]|0)+4>>2]|0)+((c[163224]|0)+1)>>0]=0;c[158362]=c[(c[c[158368]>>2]|0)+4>>2];n=H;i=b;return n|0}function Wud(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=a[633488]|0;g=c[158370]|0;a:while(1){a[g>>0]=f;h=c[158370]|0;do if(!(a[h>>0]|0)){if(h>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[h>>0]=0;break}j=c[158362]|0;c[158370]=h+1;k=Vud()|0;if((k|0)==1)break a;else if((k|0)==2){l=6;break a}else if(k)break;c[158370]=(c[158362]|0)+(h-j)}while(0);h=c[158370]|0;j=a[h>>0]|0;a[h>>0]=0;h=(c[158370]|0)+1|0;c[158370]=h;k=a[h>>0]|0;a[633488]=k;switch(j&255|0){case 32:case 9:{f=k;g=h;break}case 10:case 13:case 0:{break a;break}default:{m=j;l=10;break a}}}if((l|0)==6)Pud(c[158356]|0);else if((l|0)==10){c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Fri(e,m);b:while(1){a[c[158370]>>0]=a[633488]|0;m=c[158370]|0;do if(!(a[m>>0]|0)){if(m>>>0<((c[(c[c[158368]>>2]|0)+4>>2]|0)+(c[163224]|0)|0)>>>0){a[m>>0]=0;break}g=c[158362]|0;c[158370]=m+1;f=Vud()|0;if((f|0)==1){l=19;break b}else if((f|0)==2){l=15;break b}else if(f)break;c[158370]=(c[158362]|0)+(m-g)}while(0);m=c[158370]|0;g=a[m>>0]|0;f=g&255;a[m>>0]=0;m=(c[158370]|0)+1|0;c[158370]=m;a[633488]=a[m>>0]|0;if(!f){l=19;break}else if((f|0)==10|(f|0)==13){l=20;break}Fri(e,g)}if((l|0)==15){Pud(c[158356]|0);l=19}else if((l|0)==20){Evd(c[163374]|0,e,c[158360]|0,b,0);n=1}if((l|0)==19){Yud(b?653400:653424)|0;n=0}xri(e);o=n;i=d;return o|0}Yud(b?653400:653424)|0;o=0;i=d;return o|0}
function Xud(){var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=Im,Wb=Im,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=Im,Kc=Im;f=i;i=i+1760|0;h=f;j=f+1044|0;k=f+1028|0;l=f+1252|0;m=f+1308|0;n=f+1292|0;o=f+52|0;p=f+1068|0;q=f+8|0;r=f+80|0;s=f+1352|0;t=f+96|0;u=f+896|0;v=f+920|0;w=f+932|0;x=f+956|0;y=f+68|0;z=f+56|0;A=f+980|0;B=f+992|0;C=f+1004|0;D=f+1256|0;E=f+1280|0;F=f+1296|0;G=f+1312|0;H=f+1324|0;I=f+1336|0;J=f+1072|0;K=f+1084|0;L=f+1096|0;M=f+1108|0;N=f+944|0;O=f+1132|0;P=f+1144|0;Q=f+1156|0;R=f+968|0;S=f+1180|0;T=f+1192|0;U=f+1204|0;V=f+1216|0;W=f+1228|0;X=f+40|0;Y=f+1120|0;Z=f+1168|0;_=f+16|0;$=f+28|0;aa=f+1240|0;ba=f+1016|0;ca=f+1268|0;da=f+1032|0;fa=f+1056|0;ga=f+84|0;c[163382]=0;c[163378]=-2;ha=u+12|0;ia=v+1|0;ja=v+8|0;ka=v+4|0;la=F+1|0;ma=F+8|0;na=F+4|0;oa=s;pa=s;qa=200;ra=0;sa=t;ta=t;a:while(1){b[pa>>1]=ra;if((oa+(qa+-1<<1)|0)>>>0<=pa>>>0){t=pa-oa>>1;ua=t+1|0;if(qa>>>0>9999){va=oa;wa=614;break}xa=qa<<1;ya=xa>>>0>1e4?1e4:xa;xa=ADi(ya*6|3)|0;if(!xa){va=oa;wa=614;break}YEi(xa|0,oa|0,ua<<1|0)|0;za=xa+((ya>>>1&1073741823)<<2)|0;YEi(za|0,sa|0,ua<<2|0)|0;if((oa|0)!=(s|0))BDi(oa);if((ya+-1|0)>(t|0)){Aa=xa;Ba=xa+(t<<1)|0;Ca=ya;Da=za;Ea=za+(t<<2)|0}else{Fa=1;Ga=xa;break}}else{Aa=oa;Ba=pa;Ca=qa;Da=sa;Ea=ta}xa=b[653536+(ra<<1)>>1]|0;t=xa<<16>>16;if(xa<<16>>16!=-239){xa=c[163378]|0;if((xa|0)==-2){za=Nud()|0;c[163378]=za;Ha=za}else Ha=xa;if((Ha|0)>=1)if(Ha>>>0<360){Ia=Ha;Ja=d[654352+Ha>>0]|0}else{Ia=Ha;Ja=2}else{c[163378]=0;Ia=0;Ja=0}xa=Ja+t|0;if(xa>>>0<=430?(b[654712+(xa<<1)>>1]|0)==(Ja|0):0){t=b[655576+(xa<<1)>>1]|0;if(!(t<<16>>16)){Ka=Aa;wa=613;break}if((xa|0)==63){Fa=0;Ga=Aa;break}if(Ia)c[163378]=-2;xa=Ea+4|0;c[xa>>2]=c[163380];La=Ba;Ma=t&65535;Na=xa}else wa=23}else wa=23;do if((wa|0)==23){wa=0;xa=a[656440+ra>>0]|0;t=xa&255;if(!(xa<<24>>24)){Ka=Aa;wa=613;break a}xa=d[656848+t>>0]|0;za=Ea+(1-xa<<2)|0;ya=c[za>>2]|0;b:do switch(t|0){case 25:{ua=xCi(44)|0;c[ua+4>>2]=2;c[ua>>2]=658072;Oa=ua+8|0;Pa=ua+36|0;c[Pa>>2]=0;c[ua+40>>2]=0;c[Oa+0>>2]=0;c[Oa+4>>2]=0;c[Oa+8>>2]=0;c[Oa+12>>2]=0;c[Oa+16>>2]=0;c[Oa+20>>2]=0;c[ua+32>>2]=Pa;Qa=ua;break}case 27:{ua=c[Ea+-8>>2]|0;Pa=ua;Oa=c[Ea>>2]|0;rri(w,Oa,SEi(Oa|0)|0);sri(v,w);Oa=a[v>>0]|0;Ra=Oa;Sa=(Oa&1)==0?ia:c[ja>>2]|0;while(1){Ta=(Ra&1)==0;if(Ta){Ua=ia;Va=(Ra&255)>>>1}else{Ua=c[ja>>2]|0;Va=c[ka>>2]|0}if((Sa|0)==(Ua+Va|0))break;Oa=a[Sa>>0]|0;Wa=Oa<<24>>24;a[Sa>>0]=(Oa+-97<<24>>24&255)<26?Wa+224|0:Wa;Ra=a[v>>0]|0;Sa=Sa+1|0}Sa=ua+8|0;if(Ta){Xa=(Ra&255)>>>1;Ya=ia}else{Xa=c[ka>>2]|0;Ya=c[ja>>2]|0}Wa=a[Sa>>0]|0;if(!(Wa&1)){Za=10;_a=Wa}else{Wa=c[Sa>>2]|0;Za=(Wa&-2)+-1|0;_a=Wa&255}Wa=(_a&1)==0;do if(Xa>>>0<=Za>>>0){if(Wa)$a=Sa+1|0;else $a=c[ua+16>>2]|0;aFi($a|0,Ya|0,Xa|0)|0;a[$a+Xa>>0]=0;if(!(a[Sa>>0]&1)){a[Sa>>0]=Xa<<1;break}else{c[ua+12>>2]=Xa;break}}else{if(Wa)ab=(_a&255)>>>1;else ab=c[ua+12>>2]|0;eXb(Sa,Za,Xa-Za|0,ab,0,ab,Xa,Ya)}while(0);xri(v);xri(w);Sa=c[164622]|0;In[c[(c[Sa>>2]|0)+16>>2]&4095](Sa,c[Ea>>2]|0);Qa=Pa;break}case 19:{Sa=xCi(12)|0;c[Sa>>2]=0;c[Sa+4>>2]=0;c[Sa+8>>2]=0;evd(Sa,Ea);Qa=Sa;break}case 17:{Sa=c[163368]|0;ua=Ea+-8|0;Wa=c[ua>>2]|0;Ra=c[Ea>>2]|0;rri(u,Wa,SEi(Wa|0)|0);rri(ha,Ra,SEi(Ra|0)|0);Ra=Sa+64|0;Wa=c[Ra>>2]|0;if((Wa|0)==(c[Sa+68>>2]|0))dvd(Sa+60|0,u);else{if(!Wa)bb=0;else{sri(Wa,u);sri(Wa+12|0,ha);bb=c[Ra>>2]|0}c[Ra>>2]=bb+24}xri(ha);xri(u);Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[ua>>2]|0);ua=c[164622]|0;In[c[(c[ua>>2]|0)+16>>2]&4095](ua,c[Ea>>2]|0);Qa=ya;break}case 23:{Qa=c[Ea+-4>>2]|0;break}case 21:{avd();c[164260]=0;c[164261]=0;c[164262]=0;c[164263]=0;c[164264]=0;c[164265]=0;Qa=ya;break}case 20:{ua=c[Ea+-8>>2]|0;Ra=ua;Wa=ua+4|0;Sa=c[Wa>>2]|0;if((Sa|0)==(c[ua+8>>2]|0)){evd(ua,Ea);Qa=Ra;break b}if(!Sa)cb=0;else{c[Sa>>2]=c[Ea>>2];cb=c[Wa>>2]|0}c[Wa>>2]=cb+4;Qa=Ra;break}case 40:{Ra=c[Ea+-4>>2]|0;Wa=c[Ea>>2]|0;rri(y,Wa,SEi(Wa|0)|0);Wa=Ra+4|0;Sa=c[Wa>>2]|0;if((Sa|0)==(c[Ra+8>>2]|0))nO(Ra,y);else{if(!Sa)db=0;else{sri(Sa,y);db=c[Wa>>2]|0}c[Wa>>2]=db+12}xri(y);Wa=c[164622]|0;In[c[(c[Wa>>2]|0)+16>>2]&4095](Wa,c[Ea>>2]|0);Qa=Ra;break}case 39:{Ra=xCi(12)|0;c[Ra>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;Qa=Ra;break}case 22:{Ra=xCi(700)|0;Wa=(c[163367]|0)+-1+(c[163366]|0)|0;Sa=c[(c[(c[163363]|0)+(Wa>>>10<<2)>>2]|0)+((Wa&1023)<<2)>>2]|0;c[Ra+4>>2]=0;c[Ra>>2]=659080;fvd(Ra+8|0,Sa);Sa=Ra+664|0;c[Sa+0>>2]=0;c[Sa+4>>2]=0;c[Sa+8>>2]=0;Wa=Ra+676|0;c[Wa+0>>2]=c[164260];c[Wa+4>>2]=c[164261];c[Wa+8>>2]=c[164262];c[Wa+12>>2]=c[164263];c[Wa+16>>2]=c[164264];c[Wa+20>>2]=c[164265];c[164260]=0;c[164261]=0;c[164262]=0;c[164263]=0;c[164264]=0;c[164265]=0;Wa=Ea+-4|0;ua=c[Wa>>2]|0;if((Sa|0)==(ua|0))eb=Sa;else{gvd(Sa,c[ua>>2]|0,c[ua+4>>2]|0);eb=c[Wa>>2]|0}Wa=Ra;if(eb){Ra=c[eb>>2]|0;if(Ra){ua=eb+4|0;Sa=c[ua>>2]|0;if((Sa|0)!=(Ra|0))c[ua>>2]=Sa+(~(((Sa+-52-Ra|0)>>>0)/52|0)*52|0);ACi(Ra)}ACi(eb)}Ra=c[163367]|0;Sa=c[163366]|0;ua=Ra+-1|0;Oa=ua+Sa|0;fb=c[163363]|0;gb=c[(c[fb+(Oa>>>10<<2)>>2]|0)+((Oa&1023)<<2)>>2]|0;c[163367]=ua;ua=c[163364]|0;if((ua|0)==(fb|0))hb=0;else hb=(ua-fb<<8)+-1|0;if((1-Ra-Sa+hb|0)>>>0>2047){ACi(c[ua+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(!gb)Qa=Wa;else{Ntd(gb+640|0,c[gb+644>>2]|0);if(a[gb>>0]&1){ua=c[gb+8>>2]|0;c[n>>2]=58;c[h+0>>2]=c[n+0>>2];eOb(ua,h)}ACi(gb);Qa=Wa}break}case 24:{Wa=xCi(20)|0;gb=c[Ea>>2]|0;c[Wa+4>>2]=1;c[Wa>>2]=658088;ib=Wa+8|0;ua=SEi(gb|0)|0;if(ua>>>0>2147483631){wa=114;break a}if(ua>>>0<11){a[ib>>0]=ua<<1;jb=Wa+9|0}else{Sa=ua+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];Ra=cOb(Sa,16,h,0,3653512,80)|0;c[Wa+16>>2]=Ra;c[ib>>2]=Sa|1;c[Wa+12>>2]=ua;jb=Ra}YEi(jb|0,gb|0,ua|0)|0;a[jb+ua>>0]=0;ua=c[164622]|0;In[c[(c[ua>>2]|0)+16>>2]&4095](ua,c[Ea>>2]|0);Qa=Wa;break}case 16:{a[(c[163368]|0)+72>>0]=1;Qa=ya;break}case 45:{Wa=c[Ea+-12>>2]|0;ua=Wa;gb=c[Ea>>2]|0;rri(D,gb,SEi(gb|0)|0);gb=vvd(D)|0;Ra=Ea+-8|0;Sa=c[Ra>>2]|0;rri(E,Sa,SEi(Sa|0)|0);Sa=vvd(E)|0;fb=Wa+4|0;Oa=c[fb>>2]|0;do if(Oa){kb=Oa;while(1){lb=c[kb+16>>2]|0;if((Sa|0)<(lb|0)){mb=c[kb>>2]|0;if(!mb){nb=kb;ob=kb;wa=232;break}else{kb=mb;continue}}if((lb|0)>=(Sa|0)){pb=kb;wa=236;break}lb=kb+4|0;mb=c[lb>>2]|0;if(!mb){qb=lb;rb=kb;wa=235;break}else kb=mb}if((wa|0)==232){wa=0;c[h>>2]=ob;sb=nb;tb=ob;break}else if((wa|0)==235){wa=0;c[h>>2]=rb;sb=qb;tb=rb;break}else if((wa|0)==236){wa=0;c[h>>2]=pb;sb=h;tb=pb;break}}else{kb=Wa+4|0;c[h>>2]=kb;sb=kb;tb=kb}while(0);Oa=c[sb>>2]|0;if(!Oa){Pa=xCi(24)|0;c[Pa+16>>2]=Sa;c[Pa+20>>2]=0;c[Pa>>2]=0;c[Pa+4>>2]=0;c[Pa+8>>2]=tb;c[sb>>2]=Pa;kb=c[c[Wa>>2]>>2]|0;if(!kb)ub=Pa;else{c[Wa>>2]=kb;ub=c[sb>>2]|0}GN(c[fb>>2]|0,ub);kb=Wa+8|0;c[kb>>2]=(c[kb>>2]|0)+1;vb=Pa}else vb=Oa;c[vb+20>>2]=gb;xri(E);xri(D);Oa=c[164622]|0;In[c[(c[Oa>>2]|0)+16>>2]&4095](Oa,c[Ra>>2]|0);Oa=c[164622]|0;In[c[(c[Oa>>2]|0)+16>>2]&4095](Oa,c[Ea>>2]|0);Qa=ua;break}case 38:{Oa=c[Ea+-48>>2]|0;Pa=Oa;kb=c[Ea+-4>>2]|0;mb=Ea+-12|0;zri(kb,c[mb>>2]|0)|0;lb=c[164622]|0;In[c[(c[lb>>2]|0)+16>>2]&4095](lb,c[mb>>2]|0);c[kb+12>>2]=c[Ea+-24>>2];mb=Ea+-40|0;lb=Ea+-32|0;wb=Ea+-44|0;Ewd(Oa,c[mb>>2]|0,c[lb>>2]|0,c[wb>>2]|0,kb);Oa=c[wb>>2]|0;if(Oa){wb=c[Oa>>2]|0;if(wb){xb=Oa+4|0;while(1){yb=c[xb>>2]|0;if((yb|0)==(wb|0))break;zb=yb+-12|0;c[xb>>2]=zb;xri(zb)}ACi(c[Oa>>2]|0)}ACi(Oa)}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[mb>>2]|0);xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[lb>>2]|0);if(!kb)Qa=Pa;else{xri(kb);ACi(kb);Qa=Pa}break}case 33:{xb=c[Ea+-36>>2]|0;wb=xb;ua=Ea+-28|0;Ra=Ea+-20|0;gb=Ea+-32|0;Bwd(xb,c[ua>>2]|0,c[Ra>>2]|0,c[gb>>2]|0,c[Ea>>2]|0);xb=c[Ea>>2]|0;if(xb)ACi(xb);xb=c[gb>>2]|0;if(xb){gb=c[xb>>2]|0;if(gb){Wa=xb+4|0;while(1){fb=c[Wa>>2]|0;if((fb|0)==(gb|0))break;Sa=fb+-12|0;c[Wa>>2]=Sa;xri(Sa)}ACi(c[xb>>2]|0)}ACi(xb)}Wa=c[164622]|0;In[c[(c[Wa>>2]|0)+16>>2]&4095](Wa,c[ua>>2]|0);Wa=c[164622]|0;In[c[(c[Wa>>2]|0)+16>>2]&4095](Wa,c[Ra>>2]|0);Qa=wb;break}case 15:{Wa=Ea+-8|0;zri((c[163368]|0)+48|0,c[Wa>>2]|0)|0;gb=c[164622]|0;In[c[(c[gb>>2]|0)+16>>2]&4095](gb,c[Wa>>2]|0);Qa=ya;break}case 32:{Wa=c[Ea+-36>>2]|0;gb=Wa;Pa=Ea+-28|0;kb=Ea+-20|0;lb=Ea+-32|0;Cwd(Wa,c[Pa>>2]|0,c[kb>>2]|0,c[lb>>2]|0,c[Ea>>2]|0);Wa=c[Ea>>2]|0;if(Wa)ACi(Wa);Wa=c[lb>>2]|0;if(Wa){lb=c[Wa>>2]|0;if(lb){mb=Wa+4|0;while(1){Oa=c[mb>>2]|0;if((Oa|0)==(lb|0))break;Sa=Oa+-12|0;c[mb>>2]=Sa;xri(Sa)}ACi(c[Wa>>2]|0)}ACi(Wa)}mb=c[164622]|0;In[c[(c[mb>>2]|0)+16>>2]&4095](mb,c[Pa>>2]|0);mb=c[164622]|0;In[c[(c[mb>>2]|0)+16>>2]&4095](mb,c[kb>>2]|0);Qa=gb;break}case 43:{mb=xCi(12)|0;lb=mb+4|0;c[lb>>2]=0;c[mb+8>>2]=0;c[mb>>2]=lb;Qa=mb;break}case 18:{zri((c[163368]|0)+36|0,c[Ea>>2]|0)|0;mb=c[164622]|0;In[c[(c[mb>>2]|0)+16>>2]&4095](mb,c[Ea>>2]|0);Qa=ya;break}case 26:{mb=c[Ea+-16>>2]|0;lb=mb;wb=Ea+-4|0;hvd(mb,c[wb>>2]|0);mb=c[wb>>2]|0;if(!mb)Qa=lb;else{Ntd(mb,c[mb+4>>2]|0);ACi(mb);Qa=lb}break}case 31:{lb=xCi(12)|0;c[lb+0>>2]=0;c[lb+4>>2]=0;c[lb+8>>2]=0;Qa=lb;break}case 37:{lb=c[Ea+-36>>2]|0;mb=lb;wb=xCi(16)|0;Fwd(wb);zri(wb,c[Ea>>2]|0)|0;Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[Ea>>2]|0);c[wb+12>>2]=c[Ea+-12>>2];Ra=Ea+-28|0;ua=Ea+-20|0;xb=Ea+-32|0;Ewd(lb,c[Ra>>2]|0,c[ua>>2]|0,c[xb>>2]|0,wb);lb=c[xb>>2]|0;if(lb){xb=c[lb>>2]|0;if(xb){Sa=lb+4|0;while(1){Oa=c[Sa>>2]|0;if((Oa|0)==(xb|0))break;fb=Oa+-12|0;c[Sa>>2]=fb;xri(fb)}ACi(c[lb>>2]|0)}ACi(lb)}Sa=c[164622]|0;In[c[(c[Sa>>2]|0)+16>>2]&4095](Sa,c[Ra>>2]|0);Sa=c[164622]|0;In[c[(c[Sa>>2]|0)+16>>2]&4095](Sa,c[ua>>2]|0);xri(wb);ACi(wb);Qa=mb;break}case 30:{Qa=c[Ea+-4>>2]|0;break}case 29:{Qa=0;break}case 42:{Sa=c[Ea+-16>>2]|0;xb=Ea+-8|0;gb=c[xb>>2]|0;rri(A,gb,SEi(gb|0)|0);gb=gnc(A)|0;xri(A);Iwd(Sa,gb,c[Ea>>2]|0,1,c[163374]|0);gb=c[164622]|0;In[c[(c[gb>>2]|0)+16>>2]&4095](gb,c[xb>>2]|0);Qa=Sa;break}case 44:{Sa=c[Ea+-12>>2]|0;xb=Sa;gb=c[Ea>>2]|0;rri(B,gb,SEi(gb|0)|0);gb=vvd(B)|0;kb=Ea+-8|0;Pa=c[kb>>2]|0;rri(C,Pa,SEi(Pa|0)|0);Pa=vvd(C)|0;Wa=Sa+4|0;fb=c[Wa>>2]|0;do if(fb){Oa=fb;while(1){zb=c[Oa+16>>2]|0;if((Pa|0)<(zb|0)){yb=c[Oa>>2]|0;if(!yb){Ab=Oa;Bb=Oa;wa=218;break}else{Oa=yb;continue}}if((zb|0)>=(Pa|0)){Cb=Oa;wa=222;break}zb=Oa+4|0;yb=c[zb>>2]|0;if(!yb){Db=zb;Eb=Oa;wa=221;break}else Oa=yb}if((wa|0)==218){wa=0;c[h>>2]=Bb;Fb=Ab;Gb=Bb;break}else if((wa|0)==221){wa=0;c[h>>2]=Eb;Fb=Db;Gb=Eb;break}else if((wa|0)==222){wa=0;c[h>>2]=Cb;Fb=h;Gb=Cb;break}}else{Oa=Sa+4|0;c[h>>2]=Oa;Fb=Oa;Gb=Oa}while(0);fb=c[Fb>>2]|0;if(!fb){mb=xCi(24)|0;c[mb+16>>2]=Pa;c[mb+20>>2]=0;c[mb>>2]=0;c[mb+4>>2]=0;c[mb+8>>2]=Gb;c[Fb>>2]=mb;wb=c[c[Sa>>2]>>2]|0;if(!wb)Hb=mb;else{c[Sa>>2]=wb;Hb=c[Fb>>2]|0}GN(c[Wa>>2]|0,Hb);wb=Sa+8|0;c[wb>>2]=(c[wb>>2]|0)+1;Ib=mb}else Ib=fb;c[Ib+20>>2]=gb;xri(C);xri(B);fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[kb>>2]|0);fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[Ea>>2]|0);Qa=xb;break}case 14:{zri((c[163368]|0)+48|0,c[Ea>>2]|0)|0;fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[Ea>>2]|0);Qa=ya;break}case 28:{fb=c[Ea+-4>>2]|0;mb=c[Ea>>2]|0;rri(x,mb,SEi(mb|0)|0);yri(fb+20|0,x)|0;xri(x);mb=c[164622]|0;In[c[(c[mb>>2]|0)+16>>2]&4095](mb,c[Ea>>2]|0);Qa=fb;break}case 2:{zri(653480,c[Ea>>2]|0)|0;zri((c[163368]|0)+24|0,c[Ea>>2]|0)|0;fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[Ea>>2]|0);Qa=ya;break}case 7:{fb=c[Ea>>2]|0;if(!fb)Qa=ya;else{mb=c[163368]|0;wb=mb+16|0;ua=c[wb>>2]|0;if((ua|0)==(c[mb+20>>2]|0)){$ud(mb+12|0,Ea);Qa=ya;break b}if(!ua)Jb=0;else{c[ua>>2]=fb;Jb=c[wb>>2]|0}c[wb>>2]=Jb+4;Qa=ya}break}case 10:{avd();Qa=ya;break}case 13:{wb=xCi(28)|0;c[wb>>2]=0;c[wb+4>>2]=0;c[wb+8>>2]=0;fb=wb+16|0;c[fb>>2]=0;ua=wb+20|0;c[ua>>2]=0;mb=wb+12|0;c[mb>>2]=fb;Ra=wb+24|0;c[Ra>>2]=0;lb=wb;Oa=(c[163367]|0)+-1+(c[163366]|0)|0;yb=c[(c[(c[163363]|0)+(Oa>>>10<<2)>>2]|0)+((Oa&1023)<<2)>>2]|0;Oa=yb+640|0;if((mb|0)!=(Oa|0)?(Ntd(mb,0),c[ua>>2]=0,c[mb>>2]=fb,c[fb>>2]=0,zb=c[Oa>>2]|0,Oa=yb+644|0,(zb|0)!=(Oa|0)):0){Kb=zb;while(1){zb=Kb+16|0;Lb=c[zb>>2]|0;Mb=c[zb+4>>2]|0;zb=q;c[zb>>2]=Lb;c[zb+4>>2]=Mb;c[p>>2]=fb;c[h+0>>2]=c[p+0>>2];zb=bvd(mb,h,j,q)|0;if(!(c[zb>>2]|0)){Nb=xCi(24)|0;Ob=Nb+16|0;c[Ob>>2]=Lb;c[Ob+4>>2]=Mb;Mb=c[j>>2]|0;c[Nb>>2]=0;c[Nb+4>>2]=0;c[Nb+8>>2]=Mb;c[zb>>2]=Nb;Mb=c[c[mb>>2]>>2]|0;if(!Mb)Pb=Nb;else{c[mb>>2]=Mb;Pb=c[zb>>2]|0}GN(c[fb>>2]|0,Pb);c[ua>>2]=(c[ua>>2]|0)+1}zb=c[Kb+4>>2]|0;if(!zb){Mb=Kb;while(1){Nb=c[Mb+8>>2]|0;if((c[Nb>>2]|0)==(Mb|0)){Qb=Nb;break}else Mb=Nb}}else{Mb=zb;while(1){Nb=c[Mb>>2]|0;if(!Nb){Qb=Mb;break}else Mb=Nb}}if((Qb|0)==(Oa|0))break;else Kb=Qb}}c[Ra>>2]=c[yb+652>>2];Kb=Ea+-4|0;Oa=c[Kb>>2]|0;if((wb|0)==(Oa|0))Rb=Oa;else{cvd(wb,c[Oa>>2]|0,c[Oa+4>>2]|0);Rb=c[Kb>>2]|0}if(Rb){Kb=c[Rb>>2]|0;if(Kb){Oa=Rb+4|0;ua=c[Oa>>2]|0;if((ua|0)!=(Kb|0))c[Oa>>2]=ua+(~((ua+-4-Kb|0)>>>2)<<2);ACi(Kb)}ACi(Rb)}Kb=c[163367]|0;ua=c[163366]|0;Oa=Kb+-1|0;fb=Oa+ua|0;mb=c[163363]|0;xb=c[(c[mb+(fb>>>10<<2)>>2]|0)+((fb&1023)<<2)>>2]|0;c[163367]=Oa;Oa=c[163364]|0;if((Oa|0)==(mb|0))Sb=0;else Sb=(Oa-mb<<8)+-1|0;if((1-Kb-ua+Sb|0)>>>0>2047){ACi(c[Oa+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(!xb)Qa=lb;else{Ntd(xb+640|0,c[xb+644>>2]|0);if(a[xb>>0]&1){Oa=c[xb+8>>2]|0;c[o>>2]=58;c[h+0>>2]=c[o+0>>2];eOb(Oa,h)}ACi(xb);Qa=lb}break}case 3:{xb=c[Ea>>2]|0;if(!xb)Qa=ya;else{Oa=c[163368]|0;if((Oa|0)!=(xb|0)){Zud(Oa,c[xb>>2]|0,c[xb+4>>2]|0);Oa=c[Ea>>2]|0;if(!Oa){Qa=ya;break b}else Tb=Oa}else Tb=xb;xb=c[Tb>>2]|0;if(xb){Oa=Tb+4|0;while(1){ua=c[Oa>>2]|0;if((ua|0)==(xb|0))break;Kb=ua+-76|0;c[Oa>>2]=Kb;_ud(Kb)}ACi(c[Tb>>2]|0)}ACi(Tb);Qa=ya}break}case 12:{avd();Qa=ya;break}case 11:{Oa=c[163367]|0;xb=c[163366]|0;lb=Oa+-1|0;wb=lb+xb|0;yb=c[163363]|0;Ra=c[(c[yb+(wb>>>10<<2)>>2]|0)+((wb&1023)<<2)>>2]|0;c[163367]=lb;lb=c[163364]|0;if((lb|0)==(yb|0))Ub=0;else Ub=(lb-yb<<8)+-1|0;if((1-Oa-xb+Ub|0)>>>0>2047){ACi(c[lb+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(!Ra)Qa=ya;else{Ntd(Ra+640|0,c[Ra+644>>2]|0);if(a[Ra>>0]&1){lb=c[Ra+8>>2]|0;c[r>>2]=58;c[h+0>>2]=c[r+0>>2];eOb(lb,h)}ACi(Ra);Qa=ya}break}case 67:{Ra=c[Ea+-24>>2]|0;lb=Ra;xb=Ea+-16|0;Oa=c[xb>>2]|0;yb=c[Oa+4>>2]|0;wb=Ra+88|0;c[wb>>2]=c[Oa>>2];c[wb+4>>2]=yb;yb=c[xb>>2]|0;if(yb)ACi(yb);yb=Ea+-12|0;xb=c[yb>>2]|0;wb=c[xb+4>>2]|0;Oa=Ra+96|0;c[Oa>>2]=c[xb>>2];c[Oa+4>>2]=wb;wb=c[yb>>2]|0;if(wb)ACi(wb);wb=Ea+-4|0;yb=c[wb>>2]|0;Oa=c[yb+4>>2]|0;xb=Ra+104|0;c[xb>>2]=c[yb>>2];c[xb+4>>2]=Oa;Oa=c[wb>>2]|0;if(Oa)ACi(Oa);Oa=c[Ea>>2]|0;wb=c[Oa+4>>2]|0;xb=Ra+112|0;c[xb>>2]=c[Oa>>2];c[xb+4>>2]=wb;wb=c[Ea>>2]|0;if(!wb)Qa=lb;else{ACi(wb);Qa=lb}break}case 66:{lb=c[Ea+-8>>2]|0;g[lb+52>>2]=ea(0.0);c[lb+56>>2]=-1;Qa=lb;break}case 65:{lb=c[Ea+-8>>2]|0;wb=lb;xb=c[Ea>>2]|0;Oa=c[xb+4>>2]|0;Ra=lb+52|0;c[Ra>>2]=c[xb>>2];c[Ra+4>>2]=Oa;Oa=c[Ea>>2]|0;if(!Oa)Qa=wb;else{ACi(Oa);Qa=wb}break}case 64:{wb=c[Ea+-8>>2]|0;g[wb+28>>2]=ea(0.0);c[wb+32>>2]=-1;Qa=wb;break}case 41:{wb=xCi(120)|0;Hwd(wb);Oa=Ea+-8|0;Ra=c[Oa>>2]|0;rri(z,Ra,SEi(Ra|0)|0);Ra=gnc(z)|0;xri(z);Iwd(wb,Ra,c[Ea>>2]|0,1,c[163374]|0);Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[Oa>>2]|0);Qa=wb;break}case 34:{wb=c[Ea+-36>>2]|0;Oa=wb;Ra=Ea+-28|0;xb=Ea+-20|0;lb=Ea+-32|0;Bwd(wb,c[Ra>>2]|0,c[xb>>2]|0,c[lb>>2]|0,c[Ea>>2]|0);wb=c[Ea>>2]|0;if(wb)ACi(wb);wb=c[lb>>2]|0;if(wb){lb=c[wb>>2]|0;if(lb){yb=wb+4|0;while(1){Kb=c[yb>>2]|0;if((Kb|0)==(lb|0))break;ua=Kb+-12|0;c[yb>>2]=ua;xri(ua)}ACi(c[wb>>2]|0)}ACi(wb)}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ra>>2]|0);yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[xb>>2]|0);Qa=Oa;break}case 35:{yb=c[Ea+-36>>2]|0;lb=yb;ua=Ea+-28|0;Kb=Ea+-20|0;mb=Ea+-32|0;Awd(yb,c[ua>>2]|0,c[Kb>>2]|0,c[mb>>2]|0,ea(g[Ea>>2]));yb=c[mb>>2]|0;if(yb){mb=c[yb>>2]|0;if(mb){fb=yb+4|0;while(1){kb=c[fb>>2]|0;if((kb|0)==(mb|0))break;gb=kb+-12|0;c[fb>>2]=gb;xri(gb)}ACi(c[yb>>2]|0)}ACi(yb)}fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[ua>>2]|0);fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[Kb>>2]|0);Qa=lb;break}case 36:{fb=c[Ea+-56>>2]|0;mb=Ea+-48|0;Oa=Ea+-40|0;Vb=ea(g[Ea>>2]);Wb=ea(g[Ea+-24>>2]);Dwd(fb,c[mb>>2]|0,c[Oa>>2]|0,c[Ea+-52>>2]|0,Vb,Wb,ea(g[Ea+-16>>2]));xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[mb>>2]|0);mb=c[164622]|0;In[c[(c[mb>>2]|0)+16>>2]&4095](mb,c[Oa>>2]|0);Qa=fb;break}case 47:{fb=c[Ea+-8>>2]|0;c[fb+652>>2]=~~ea(g[Ea>>2]);Qa=fb;break}case 46:{fb=(c[163367]|0)+-1+(c[163366]|0)|0;Qa=c[(c[(c[163363]|0)+(fb>>>10<<2)>>2]|0)+((fb&1023)<<2)>>2]|0;break}case 48:{fb=c[Ea+-8>>2]|0;Oa=fb;mb=c[Ea>>2]|0;rri(G,mb,SEi(mb|0)|0);sri(F,G);mb=a[F>>0]|0;xb=mb;Ra=(mb&1)==0?la:c[ma>>2]|0;while(1){Xb=(xb&1)==0;if(Xb){Yb=la;Zb=(xb&255)>>>1}else{Yb=c[ma>>2]|0;Zb=c[na>>2]|0}if((Ra|0)==(Yb+Zb|0))break;mb=a[Ra>>0]|0;wb=mb<<24>>24;a[Ra>>0]=(mb+-97<<24>>24&255)<26?wb+224|0:wb;xb=a[F>>0]|0;Ra=Ra+1|0}if(Xb){_b=(xb&255)>>>1;$b=la}else{_b=c[na>>2]|0;$b=c[ma>>2]|0}Ra=a[fb>>0]|0;if(!(Ra&1)){ac=10;bc=Ra}else{Ra=c[fb>>2]|0;ac=(Ra&-2)+-1|0;bc=Ra&255}Ra=(bc&1)==0;do if(_b>>>0<=ac>>>0){if(Ra)cc=fb+1|0;else cc=c[fb+8>>2]|0;aFi(cc|0,$b|0,_b|0)|0;a[cc+_b>>0]=0;if(!(a[fb>>0]&1)){a[fb>>0]=_b<<1;break}else{c[fb+4>>2]=_b;break}}else{if(Ra)dc=(bc&255)>>>1;else dc=c[fb+4>>2]|0;eXb(fb,ac,_b-ac|0,dc,0,dc,_b,$b)}while(0);xri(F);xri(G);fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[Ea>>2]|0);Qa=Oa;break}case 50:{fb=c[Ea+-16>>2]|0;Ra=fb;xb=Ea+-4|0;Jwd(fb+520|0,c[xb>>2]|0);fb=c[xb>>2]|0;if(!fb)Qa=Ra;else{ACi(fb);Qa=Ra}break}case 49:{Ra=c[Ea+-16>>2]|0;fb=Ra;xb=Ea+-4|0;ivd(Ra,c[xb>>2]|0);Ra=c[xb>>2]|0;if(!Ra)Qa=fb;else{Ntd(Ra,c[Ra+4>>2]|0);ACi(Ra);Qa=fb}break}case 51:{fb=c[Ea+-16>>2]|0;Ra=fb;xb=c[Ea+-4>>2]|0;ec=fb+216|0;fc=xb+216|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));ec=fb+180|0;fc=xb+180|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));ec=fb+252|0;fc=xb+252|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));ec=fb+288|0;fc=xb+288|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));Oa=xb+44|0;lb=c[Oa+4>>2]|0;Kb=fb+44|0;c[Kb>>2]=c[Oa>>2];c[Kb+4>>2]=lb;lb=c[163367]|0;Kb=c[163366]|0;Oa=lb+-1|0;ua=Oa+Kb|0;yb=c[163363]|0;wb=c[(c[yb+(ua>>>10<<2)>>2]|0)+((ua&1023)<<2)>>2]|0;c[163367]=Oa;Oa=c[163364]|0;if((Oa|0)==(yb|0))hc=0;else hc=(Oa-yb<<8)+-1|0;if((1-lb-Kb+hc|0)>>>0>2047){ACi(c[Oa+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(!wb)Qa=Ra;else{Ntd(wb+640|0,c[wb+644>>2]|0);if(a[wb>>0]&1){Oa=c[wb+8>>2]|0;c[m>>2]=58;c[h+0>>2]=c[m+0>>2];eOb(Oa,h)}ACi(wb);Qa=Ra}break}case 52:{wb=c[Ea+-16>>2]|0;Oa=wb;Kb=c[Ea+-4>>2]|0;ec=wb+472|0;fc=Kb+472|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));c[wb+508>>2]=c[Kb+508>>2];Ra=Kb+464|0;fb=c[Ra+4>>2]|0;xb=wb+464|0;c[xb>>2]=c[Ra>>2];c[xb+4>>2]=fb;fb=Kb+448|0;xb=c[fb+4>>2]|0;Ra=wb+448|0;c[Ra>>2]=c[fb>>2];c[Ra+4>>2]=xb;xb=Kb+456|0;Ra=c[xb+4>>2]|0;fb=wb+456|0;c[fb>>2]=c[xb>>2];c[fb+4>>2]=Ra;Ra=c[163367]|0;fb=c[163366]|0;xb=Ra+-1|0;lb=xb+fb|0;yb=c[163363]|0;ua=c[(c[yb+(lb>>>10<<2)>>2]|0)+((lb&1023)<<2)>>2]|0;c[163367]=xb;xb=c[163364]|0;if((xb|0)==(yb|0))ic=0;else ic=(xb-yb<<8)+-1|0;if((1-Ra-fb+ic|0)>>>0>2047){ACi(c[xb+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(!ua)Qa=Oa;else{Ntd(ua+640|0,c[ua+644>>2]|0);if(a[ua>>0]&1){xb=c[ua+8>>2]|0;c[l>>2]=58;c[h+0>>2]=c[l+0>>2];eOb(xb,h)}ACi(ua);Qa=Oa}break}case 53:{ua=c[Ea+-8>>2]|0;xb=ua;ec=ua+144|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));Oa=c[Ea>>2]|0;if(!Oa)Qa=xb;else{xri(Oa);ACi(Oa);Qa=xb}break}case 55:{Oa=c[Ea+-8>>2]|0;wb=Oa;Kb=c[Ea>>2]|0;ua=c[Kb+4>>2]|0;fb=Oa+80|0;c[fb>>2]=c[Kb>>2];c[fb+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=wb;else{ACi(ua);Qa=wb}break}case 54:{wb=c[Ea+-8>>2]|0;a[wb+76>>0]=a[Ea>>0]|0;Qa=wb;break}case 56:{wb=c[Ea+-8>>2]|0;ua=wb;fb=c[Ea>>2]|0;Kb=c[fb+4>>2]|0;Oa=wb+12|0;c[Oa>>2]=c[fb>>2];c[Oa+4>>2]=Kb;Kb=c[Ea>>2]|0;if(!Kb)Qa=ua;else{ACi(Kb);Qa=ua}break}case 59:{ua=c[Ea+-8>>2]|0;Kb=ua;Oa=c[Ea>>2]|0;fb=c[Oa+4>>2]|0;wb=ua+20|0;c[wb>>2]=c[Oa>>2];c[wb+4>>2]=fb;fb=c[Ea>>2]|0;if(!fb)Qa=Kb;else{ACi(fb);Qa=Kb}break}case 57:{Kb=c[Ea+-8>>2]|0;g[Kb+12>>2]=ea(4.0);c[Kb+16>>2]=-1;Qa=Kb;break}case 58:{Kb=c[Ea+-8>>2]|0;g[Kb+12>>2]=ea(0.0);c[Kb+16>>2]=-1;Qa=Kb;break}case 61:{Kb=c[Ea+-8>>2]|0;fb=Kb;wb=c[Ea>>2]|0;Oa=c[wb+4>>2]|0;ua=Kb+136|0;c[ua>>2]=c[wb>>2];c[ua+4>>2]=Oa;Oa=c[Ea>>2]|0;if(!Oa)Qa=fb;else{ACi(Oa);Qa=fb}break}case 60:{fb=c[Ea+-8>>2]|0;c[fb+516>>2]=c[Ea>>2];Qa=fb;break}case 62:{fb=c[Ea+-12>>2]|0;Oa=fb;ua=Ea+-4|0;wb=c[ua>>2]|0;Kb=c[wb+4>>2]|0;Ra=fb+28|0;c[Ra>>2]=c[wb>>2];c[Ra+4>>2]=Kb;Kb=c[ua>>2]|0;if(Kb)ACi(Kb);Kb=c[Ea>>2]|0;ua=c[Kb+4>>2]|0;Ra=fb+36|0;c[Ra>>2]=c[Kb>>2];c[Ra+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=Oa;else{ACi(ua);Qa=Oa}break}case 63:{Oa=c[Ea+-12>>2]|0;ua=Oa;g[Oa+28>>2]=ea(4.0);c[Oa+32>>2]=-1;Ra=c[Ea>>2]|0;Kb=c[Ra+4>>2]|0;fb=Oa+36|0;c[fb>>2]=c[Ra>>2];c[fb+4>>2]=Kb;Kb=c[Ea>>2]|0;if(!Kb)Qa=ua;else{ACi(Kb);Qa=ua}break}case 68:{ua=c[Ea+-12>>2]|0;Kb=ua;fb=Ea+-4|0;Ra=c[fb>>2]|0;Oa=c[Ra+4>>2]|0;wb=ua+88|0;c[wb>>2]=c[Ra>>2];c[wb+4>>2]=Oa;Oa=c[fb>>2]|0;wb=c[Oa+4>>2]|0;Ra=ua+104|0;c[Ra>>2]=c[Oa>>2];c[Ra+4>>2]=wb;wb=c[fb>>2]|0;if(wb)ACi(wb);wb=c[Ea>>2]|0;fb=c[wb+4>>2]|0;Ra=ua+96|0;c[Ra>>2]=c[wb>>2];c[Ra+4>>2]=fb;fb=c[Ea>>2]|0;Ra=c[fb+4>>2]|0;wb=ua+112|0;c[wb>>2]=c[fb>>2];c[wb+4>>2]=Ra;Ra=c[Ea>>2]|0;if(!Ra)Qa=Kb;else{ACi(Ra);Qa=Kb}break}case 70:{Kb=c[Ea+-16>>2]|0;Ra=Kb;wb=Ea+-8|0;fb=c[wb>>2]|0;ua=c[fb+4>>2]|0;Oa=Kb+120|0;c[Oa>>2]=c[fb>>2];c[Oa+4>>2]=ua;ua=c[wb>>2]|0;if(ua)ACi(ua);ua=c[Ea>>2]|0;wb=c[ua+4>>2]|0;Oa=Kb+128|0;c[Oa>>2]=c[ua>>2];c[Oa+4>>2]=wb;wb=c[Ea>>2]|0;if(!wb)Qa=Ra;else{ACi(wb);Qa=Ra}break}case 71:{Ra=c[Ea+-8>>2]|0;wb=Ra;Oa=c[Ea>>2]|0;ua=c[Oa+4>>2]|0;Kb=Ra+120|0;c[Kb>>2]=c[Oa>>2];c[Kb+4>>2]=ua;ua=c[Ea>>2]|0;Kb=c[ua+4>>2]|0;Oa=Ra+128|0;c[Oa>>2]=c[ua>>2];c[Oa+4>>2]=Kb;Kb=c[Ea>>2]|0;if(!Kb)Qa=wb;else{ACi(Kb);Qa=wb}break}case 69:{wb=c[Ea+-8>>2]|0;g[wb+88>>2]=ea(1.0);c[wb+92>>2]=-1;g[wb+104>>2]=ea(1.0);c[wb+108>>2]=-1;g[wb+96>>2]=ea(0.0);c[wb+100>>2]=-1;g[wb+112>>2]=ea(0.0);c[wb+116>>2]=-1;Qa=wb;break}case 72:{wb=c[Ea+-16>>2]|0;Kb=wb;Oa=c[Ea+-4>>2]|0;ua=Oa+440|0;Ra=c[ua+4>>2]|0;fb=wb+440|0;c[fb>>2]=c[ua>>2];c[fb+4>>2]=Ra;Ra=Oa+424|0;fb=c[Ra+4>>2]|0;ua=wb+424|0;c[ua>>2]=c[Ra>>2];c[ua+4>>2]=fb;fb=Oa+432|0;ua=c[fb+4>>2]|0;Ra=wb+432|0;c[Ra>>2]=c[fb>>2];c[Ra+4>>2]=ua;ua=wb+328|0;Ra=Oa+328|0;c[ua+0>>2]=c[Ra+0>>2];c[ua+4>>2]=c[Ra+4>>2];c[ua+8>>2]=c[Ra+8>>2];c[ua+12>>2]=c[Ra+12>>2];c[ua+16>>2]=c[Ra+16>>2];c[ua+20>>2]=c[Ra+20>>2];c[ua+24>>2]=c[Ra+24>>2];c[ua+28>>2]=c[Ra+28>>2];Ra=wb+360|0;ua=Oa+360|0;c[Ra+0>>2]=c[ua+0>>2];c[Ra+4>>2]=c[ua+4>>2];c[Ra+8>>2]=c[ua+8>>2];c[Ra+12>>2]=c[ua+12>>2];c[Ra+16>>2]=c[ua+16>>2];c[Ra+20>>2]=c[ua+20>>2];c[Ra+24>>2]=c[ua+24>>2];c[Ra+28>>2]=c[ua+28>>2];ua=wb+392|0;wb=Oa+392|0;c[ua+0>>2]=c[wb+0>>2];c[ua+4>>2]=c[wb+4>>2];c[ua+8>>2]=c[wb+8>>2];c[ua+12>>2]=c[wb+12>>2];c[ua+16>>2]=c[wb+16>>2];c[ua+20>>2]=c[wb+20>>2];c[ua+24>>2]=c[wb+24>>2];c[ua+28>>2]=c[wb+28>>2];wb=c[163367]|0;ua=c[163366]|0;Oa=wb+-1|0;Ra=Oa+ua|0;fb=c[163363]|0;yb=c[(c[fb+(Ra>>>10<<2)>>2]|0)+((Ra&1023)<<2)>>2]|0;c[163367]=Oa;Oa=c[163364]|0;if((Oa|0)==(fb|0))jc=0;else jc=(Oa-fb<<8)+-1|0;if((1-wb-ua+jc|0)>>>0>2047){ACi(c[Oa+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(!yb)Qa=Kb;else{Ntd(yb+640|0,c[yb+644>>2]|0);if(a[yb>>0]&1){Oa=c[yb+8>>2]|0;c[k>>2]=58;c[h+0>>2]=c[k+0>>2];eOb(Oa,h)}ACi(yb);Qa=Kb}break}case 74:{Kb=Ea+-16|0;yb=c[Kb>>2]|0;Oa=yb;ua=Ea+-8|0;wb=c[ua>>2]|0;fb=c[wb+4>>2]|0;Ra=yb+60|0;c[Ra>>2]=c[wb>>2];c[Ra+4>>2]=fb;fb=c[ua>>2]|0;if(fb)ACi(fb);fb=c[Ea>>2]|0;ua=c[fb+4>>2]|0;Ra=(c[Kb>>2]|0)+68|0;c[Ra>>2]=c[fb>>2];c[Ra+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=Oa;else{ACi(ua);Qa=Oa}break}case 73:{Oa=c[Ea+-8>>2]|0;a[Oa+324>>0]=a[Ea>>0]|0;Qa=Oa;break}case 75:{Oa=c[Ea+-8>>2]|0;c[Oa+512>>2]=~~ea(g[Ea>>2]);Qa=Oa;break}case 76:{Oa=c[Ea+-20>>2]|0;ua=Ea+-12|0;Ra=c[ua>>2]|0;if(HEi(657064,Ra)|0)if(HEi(3144080,Ra)|0)if(HEi(657072,Ra)|0)if(HEi(657080,Ra)|0)if(HEi(657088,Ra)|0){fb=c[163374]|0;rri(I,657144,25);Evd(fb,I,c[158360]|0,0,0);xri(I);fb=c[Ea+-4>>2]|0;if(fb){twd(fb);ACi(fb)}}else{kc=5;wa=350}else{kc=4;wa=350}else{kc=3;wa=350}else{kc=2;wa=350}else{kc=1;wa=350}if((wa|0)==350){wa=0;fb=657040+(kc<<2)|0;if((c[fb>>2]|0)!=0?(Kb=c[163374]|0,c[h>>2]=Ra,Lsd(H,657096,h),Evd(Kb,H,c[158360]|0,0,0),xri(H),Kb=c[fb>>2]|0,(Kb|0)!=0):0){twd(Kb);ACi(Kb)}c[fb>>2]=c[Ea+-4>>2]}fb=c[164622]|0;In[c[(c[fb>>2]|0)+16>>2]&4095](fb,c[ua>>2]|0);Qa=Oa;break}case 77:{avd();Oa=(c[163367]|0)+-1+(c[163366]|0)|0;Qa=c[(c[(c[163363]|0)+(Oa>>>10<<2)>>2]|0)+((Oa&1023)<<2)>>2]|0;break}case 78:{Oa=c[Ea+-8>>2]|0;ua=Oa;ec=Oa+472|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));xb=c[Ea>>2]|0;if(!xb)Qa=ua;else{xri(xb);ACi(xb);Qa=ua}break}case 80:{xb=c[Ea+-8>>2]|0;Oa=xb;fb=c[Ea>>2]|0;Kb=c[fb+4>>2]|0;Ra=xb+464|0;c[Ra>>2]=c[fb>>2];c[Ra+4>>2]=Kb;Kb=c[Ea>>2]|0;if(!Kb)Qa=Oa;else{ACi(Kb);Qa=Oa}break}case 79:{Oa=c[Ea+-8>>2]|0;c[Oa+508>>2]=c[Ea>>2];Qa=Oa;break}case 81:{Oa=Ea+-16|0;Kb=c[Oa>>2]|0;Ra=Kb;fb=Ea+-8|0;xb=c[fb>>2]|0;wb=c[xb+4>>2]|0;yb=Kb+448|0;c[yb>>2]=c[xb>>2];c[yb+4>>2]=wb;wb=c[fb>>2]|0;if(wb)ACi(wb);wb=c[Ea>>2]|0;fb=c[wb+4>>2]|0;yb=(c[Oa>>2]|0)+456|0;c[yb>>2]=c[wb>>2];c[yb+4>>2]=fb;fb=c[Ea>>2]|0;if(!fb)Qa=Ra;else{ACi(fb);Qa=Ra}break}case 82:{avd();Ra=(c[163367]|0)+-1+(c[163366]|0)|0;Qa=c[(c[(c[163363]|0)+(Ra>>>10<<2)>>2]|0)+((Ra&1023)<<2)>>2]|0;break}case 83:{Ra=c[Ea+-8>>2]|0;fb=Ra;ec=Ra+216|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));ua=c[Ea>>2]|0;if(!ua)Qa=fb;else{xri(ua);ACi(ua);Qa=fb}break}case 84:{ua=c[Ea+-8>>2]|0;Ra=ua;ec=ua+180|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));fb=c[Ea>>2]|0;if(!fb)Qa=Ra;else{xri(fb);ACi(fb);Qa=Ra}break}case 85:{fb=c[Ea+-8>>2]|0;ua=fb;ec=fb+252|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));Ra=c[Ea>>2]|0;if(!Ra)Qa=ua;else{xri(Ra);ACi(Ra);Qa=ua}break}case 86:{Ra=c[Ea+-8>>2]|0;fb=Ra;ec=Ra+288|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));ua=c[Ea>>2]|0;if(!ua)Qa=fb;else{xri(ua);ACi(ua);Qa=fb}break}case 87:{ua=c[Ea+-8>>2]|0;Ra=ua;yb=c[Ea>>2]|0;wb=c[yb+4>>2]|0;Oa=ua+44|0;c[Oa>>2]=c[yb>>2];c[Oa+4>>2]=wb;wb=c[Ea>>2]|0;if(!wb)Qa=Ra;else{ACi(wb);Qa=Ra}break}case 90:{Ra=c[Ea+-8>>2]|0;wb=Ra;Oa=c[Ea>>2]|0;yb=c[Oa+4>>2]|0;ua=Ra+424|0;c[ua>>2]=c[Oa>>2];c[ua+4>>2]=yb;yb=c[Ea>>2]|0;if(!yb)Qa=wb;else{ACi(yb);Qa=wb}break}case 88:{avd();wb=(c[163367]|0)+-1+(c[163366]|0)|0;Qa=c[(c[(c[163363]|0)+(wb>>>10<<2)>>2]|0)+((wb&1023)<<2)>>2]|0;break}case 89:{wb=c[Ea+-8>>2]|0;yb=wb;ua=c[Ea>>2]|0;Oa=c[ua+4>>2]|0;Ra=wb+440|0;c[Ra>>2]=c[ua>>2];c[Ra+4>>2]=Oa;Oa=c[Ea>>2]|0;if(!Oa)Qa=yb;else{ACi(Oa);Qa=yb}break}case 92:{yb=c[Ea+-8>>2]|0;Oa=yb;Ra=c[Ea>>2]|0;ua=c[Ra+4>>2]|0;wb=yb+352|0;c[wb>>2]=c[Ra>>2];c[wb+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=Oa;else{ACi(ua);Qa=Oa}break}case 91:{Oa=c[Ea+-8>>2]|0;ua=Oa;wb=c[Ea>>2]|0;Ra=c[wb+4>>2]|0;yb=Oa+432|0;c[yb>>2]=c[wb>>2];c[yb+4>>2]=Ra;Ra=c[Ea>>2]|0;if(!Ra)Qa=ua;else{ACi(Ra);Qa=ua}break}case 94:{ua=c[Ea+-8>>2]|0;Ra=ua;yb=c[Ea>>2]|0;wb=c[yb+4>>2]|0;Oa=ua+336|0;c[Oa>>2]=c[yb>>2];c[Oa+4>>2]=wb;wb=c[Ea>>2]|0;if(!wb)Qa=Ra;else{ACi(wb);Qa=Ra}break}case 93:{Ra=c[Ea+-8>>2]|0;wb=Ra;Oa=c[Ea>>2]|0;yb=c[Oa+4>>2]|0;ua=Ra+328|0;c[ua>>2]=c[Oa>>2];c[ua+4>>2]=yb;yb=c[Ea>>2]|0;if(!yb)Qa=wb;else{ACi(yb);Qa=wb}break}case 96:{wb=c[Ea+-8>>2]|0;yb=wb;ua=c[Ea>>2]|0;Oa=c[ua+4>>2]|0;Ra=wb+384|0;c[Ra>>2]=c[ua>>2];c[Ra+4>>2]=Oa;Oa=c[Ea>>2]|0;if(!Oa)Qa=yb;else{ACi(Oa);Qa=yb}break}case 95:{yb=c[Ea+-8>>2]|0;Oa=yb;Ra=c[Ea>>2]|0;ua=c[Ra+4>>2]|0;wb=yb+344|0;c[wb>>2]=c[Ra>>2];c[wb+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=Oa;else{ACi(ua);Qa=Oa}break}case 98:{Oa=c[Ea+-8>>2]|0;ua=Oa;wb=c[Ea>>2]|0;Ra=c[wb+4>>2]|0;yb=Oa+368|0;c[yb>>2]=c[wb>>2];c[yb+4>>2]=Ra;Ra=c[Ea>>2]|0;if(!Ra)Qa=ua;else{ACi(Ra);Qa=ua}break}case 97:{ua=c[Ea+-8>>2]|0;Ra=ua;yb=c[Ea>>2]|0;wb=c[yb+4>>2]|0;Oa=ua+360|0;c[Oa>>2]=c[yb>>2];c[Oa+4>>2]=wb;wb=c[Ea>>2]|0;if(!wb)Qa=Ra;else{ACi(wb);Qa=Ra}break}case 100:{Ra=c[Ea+-8>>2]|0;wb=Ra;Oa=c[Ea>>2]|0;yb=c[Oa+4>>2]|0;ua=Ra+416|0;c[ua>>2]=c[Oa>>2];c[ua+4>>2]=yb;yb=c[Ea>>2]|0;if(!yb)Qa=wb;else{ACi(yb);Qa=wb}break}case 99:{wb=c[Ea+-8>>2]|0;yb=wb;ua=c[Ea>>2]|0;Oa=c[ua+4>>2]|0;Ra=wb+376|0;c[Ra>>2]=c[ua>>2];c[Ra+4>>2]=Oa;Oa=c[Ea>>2]|0;if(!Oa)Qa=yb;else{ACi(Oa);Qa=yb}break}case 102:{yb=c[Ea+-8>>2]|0;Oa=yb;Ra=c[Ea>>2]|0;ua=c[Ra+4>>2]|0;wb=yb+400|0;c[wb>>2]=c[Ra>>2];c[wb+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=Oa;else{ACi(ua);Qa=Oa}break}case 101:{Oa=c[Ea+-8>>2]|0;ua=Oa;wb=c[Ea>>2]|0;Ra=c[wb+4>>2]|0;yb=Oa+392|0;c[yb>>2]=c[wb>>2];c[yb+4>>2]=Ra;Ra=c[Ea>>2]|0;if(!Ra)Qa=ua;else{ACi(Ra);Qa=ua}break}case 105:{ua=c[Ea+-4>>2]|0;Ra=ua;yb=c[Ea>>2]|0;wb=ua+4|0;Oa=c[wb>>2]|0;if((Oa|0)==(c[ua+8>>2]|0))jvd(ua,yb);else{if(!Oa)lc=0;else{ec=Oa+0|0;fc=yb+0|0;gc=ec+52|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));lc=c[wb>>2]|0}c[wb>>2]=lc+52}fb=c[Ea>>2]|0;if(!fb)Qa=Ra;else{ACi(fb);Qa=Ra}break}case 104:{fb=xCi(12)|0;c[fb>>2]=0;c[fb+4>>2]=0;c[fb+8>>2]=0;Qa=fb;break}case 103:{fb=c[Ea+-8>>2]|0;yb=fb;Oa=c[Ea>>2]|0;ua=c[Oa+4>>2]|0;xb=fb+408|0;c[xb>>2]=c[Oa>>2];c[xb+4>>2]=ua;ua=c[Ea>>2]|0;if(!ua)Qa=yb;else{ACi(ua);Qa=yb}break}case 106:{yb=xCi(52)|0;c[yb>>2]=-1;c[yb+4>>2]=16842752;c[yb+8>>2]=17104900;g[yb+12>>2]=ea(0.0);c[yb+16>>2]=-1;g[yb+20>>2]=ea(0.0);c[yb+24>>2]=-1;g[yb+28>>2]=ea(0.0);c[yb+32>>2]=-1;g[yb+36>>2]=ea(0.0);c[yb+40>>2]=-1;c[yb+44>>2]=-1;a[yb+48>>0]=0;a[yb+49>>0]=0;ua=c[Ea>>2]|0;c[h>>2]=-1;itd(h,ua);c[yb>>2]=c[h>>2];ua=c[164622]|0;In[c[(c[ua>>2]|0)+16>>2]&4095](ua,c[Ea>>2]|0);Qa=yb;break}case 107:{yb=c[Ea+-4>>2]|0;ua=Ea+-12|0;xb=c[ua>>2]|0;c[h>>2]=-1;itd(h,xb);c[yb>>2]=c[h>>2];xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[ua>>2]|0);Qa=yb;break}case 108:{yb=xCi(52)|0;c[yb>>2]=-1;c[yb+4>>2]=16842752;c[yb+8>>2]=17104900;g[yb+12>>2]=ea(0.0);c[yb+16>>2]=-1;g[yb+20>>2]=ea(0.0);c[yb+24>>2]=-1;g[yb+28>>2]=ea(0.0);c[yb+32>>2]=-1;g[yb+36>>2]=ea(0.0);c[yb+40>>2]=-1;c[yb+44>>2]=-1;a[yb+48>>0]=0;a[yb+49>>0]=0;Qa=yb;break}case 109:{yb=c[Ea+-8>>2]|0;ua=yb;ec=yb+12|0;fc=(c[Ea>>2]|0)+12|0;gc=ec+36|0;do{c[ec>>2]=c[fc>>2];ec=ec+4|0;fc=fc+4|0}while((ec|0)<(gc|0));a[yb+48>>0]=1;Ra=c[Ea>>2]|0;if(!Ra)Qa=ua;else{xri(Ra);ACi(Ra);Qa=ua}break}case 110:{Ra=c[Ea+-8>>2]|0;c[Ra+4>>2]=c[Ea>>2];c[Ra+8>>2]=c[Ea>>2];Qa=Ra;break}case 111:{Ra=c[Ea+-16>>2]|0;c[Ra+4>>2]=c[Ea+-8>>2];c[Ra+8>>2]=c[Ea>>2]|262148;Qa=Ra;break}case 112:{Ra=c[Ea+-8>>2]|0;if(!(Fsd(c[Ea>>2]|0,657176)|0))a[Ra+49>>0]=1;else{wb=c[163374]|0;c[h>>2]=c[Ea>>2];Lsd(J,657200,h);Evd(wb,J,c[158360]|0,1,0);xri(J)}wb=c[164622]|0;In[c[(c[wb>>2]|0)+16>>2]&4095](wb,c[Ea>>2]|0);Qa=Ra;break}case 113:{Ra=xCi(12)|0;c[Ra>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;Qa=Ra;break}case 114:{a[657272]=(Yvd(c[163376]|0,c[Ea+-4>>2]|0)|0)&1;Qa=ya;break}case 115:{Ra=c[Ea+-24>>2]|0;wb=Ra;xb=Ea+-4|0;Oa=c[xb>>2]|0;do if(Oa){fb=Ra+4|0;Kb=c[fb>>2]|0;if((Kb|0)==(c[Ra+8>>2]|0)){kvd(Ra,xb);break}if(!Kb)mc=0;else{c[Kb>>2]=Oa;mc=c[fb>>2]|0}c[fb>>2]=mc+4}while(0);Oa=c[164622]|0;In[c[(c[Oa>>2]|0)+16>>2]&4095](Oa,c[Ea+-16>>2]|0);a[657272]=0;Qa=wb;break}case 116:{Oa=c[Ea+-16>>2]|0;xb=Oa;a[657272]=0;Ra=Ea+-4|0;ua=Oa+4|0;yb=c[ua>>2]|0;if((yb|0)==(c[Oa+8>>2]|0))kvd(Oa,Ra);else{if(!yb)nc=0;else{c[yb>>2]=c[Ra>>2];nc=c[ua>>2]|0}c[ua>>2]=nc+4}a[657272]=0;Qa=xb;break}case 117:{if(!(a[657272]|0)){xb=xCi(220)|0;sjd(xb);oc=xb}else oc=0;Qa=oc;break}case 118:{xb=c[Ea+-4>>2]|0;if(!xb)pc=Ea;else{zri(xb,c[Ea>>2]|0)|0;pc=Ea}ua=c[164622]|0;In[c[(c[ua>>2]|0)+16>>2]&4095](ua,c[pc>>2]|0);Qa=xb;break}case 119:{xb=Ea+-12|0;ua=c[xb>>2]|0;Ra=Ea+-4|0;if(ua){yb=c[Ra>>2]|0;rri(K,yb,SEi(yb|0)|0);yb=gnc(K)|0;xri(K);Iwd((c[xb>>2]|0)+12|0,yb,c[Ea>>2]|0,0,0)}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ra>>2]|0);Qa=ua;break}case 120:{ua=c[Ea+-12>>2]|0;if(!ua)qc=Ea;else{Ra=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(L,yb,SEi(yb|0)|0);xwd(ua,0,Ra,1,L);xri(L);qc=Ea}Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[qc>>2]|0);Qa=ua;break}case 121:{ua=c[Ea+-12>>2]|0;if(!ua)rc=Ea;else{Ra=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(M,yb,SEi(yb|0)|0);xwd(ua,0,Ra,4,M);xri(M);rc=Ea}Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[rc>>2]|0);Qa=ua;break}case 122:{ua=c[Ea+-16>>2]|0;if(!ua)sc=Ea+-4|0;else{Ra=~~ea(g[Ea+-8>>2]);yb=~~ea(g[Ea>>2]);xb=Ea+-4|0;Oa=c[xb>>2]|0;rri(N,Oa,SEi(Oa|0)|0);xwd(ua,0,Ra,yb,N);xri(N);sc=xb}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[sc>>2]|0);Qa=ua;break}case 123:{ua=c[Ea+-12>>2]|0;if(!ua)tc=Ea;else{xb=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(O,yb,SEi(yb|0)|0);xwd(ua,1,xb,1,O);xri(O);tc=Ea}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[tc>>2]|0);Qa=ua;break}case 124:{ua=c[Ea+-16>>2]|0;if(!ua)uc=Ea+-4|0;else{xb=~~ea(g[Ea+-8>>2]);yb=~~ea(g[Ea>>2]);Ra=Ea+-4|0;Oa=c[Ra>>2]|0;rri(P,Oa,SEi(Oa|0)|0);xwd(ua,1,xb,yb,P);xri(P);uc=Ra}Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[uc>>2]|0);Qa=ua;break}case 125:{ua=c[Ea+-12>>2]|0;if(!ua)vc=Ea;else{Ra=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(Q,yb,SEi(yb|0)|0);xwd(ua,2,Ra,1,Q);xri(Q);vc=Ea}Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[vc>>2]|0);Qa=ua;break}case 126:{ua=c[Ea+-16>>2]|0;if(!ua)wc=Ea+-4|0;else{Ra=~~ea(g[Ea+-8>>2]);yb=~~ea(g[Ea>>2]);xb=Ea+-4|0;Oa=c[xb>>2]|0;rri(R,Oa,SEi(Oa|0)|0);xwd(ua,2,Ra,yb,R);xri(R);wc=xb}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[wc>>2]|0);Qa=ua;break}case 127:{ua=c[Ea+-12>>2]|0;if(!ua)xc=Ea;else{xb=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(S,yb,SEi(yb|0)|0);xwd(ua,3,xb,1,S);xri(S);xc=Ea}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[xc>>2]|0);Qa=ua;break}case 128:{ua=c[Ea+-16>>2]|0;if(!ua)yc=Ea+-4|0;else{xb=~~ea(g[Ea+-8>>2]);yb=~~ea(g[Ea>>2]);Ra=Ea+-4|0;Oa=c[Ra>>2]|0;rri(T,Oa,SEi(Oa|0)|0);xwd(ua,3,xb,yb,T);xri(T);yc=Ra}Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[yc>>2]|0);Qa=ua;break}case 129:{ua=c[Ea+-12>>2]|0;if(!ua)zc=Ea;else{Ra=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(U,yb,SEi(yb|0)|0);xwd(ua,4,Ra,1,U);xri(U);zc=Ea}Ra=c[164622]|0;In[c[(c[Ra>>2]|0)+16>>2]&4095](Ra,c[zc>>2]|0);Qa=ua;break}case 130:{ua=c[Ea+-16>>2]|0;if(!ua)Ac=Ea+-4|0;else{Ra=~~ea(g[Ea+-8>>2]);yb=~~ea(g[Ea>>2]);xb=Ea+-4|0;Oa=c[xb>>2]|0;rri(V,Oa,SEi(Oa|0)|0);xwd(ua,4,Ra,yb,V);xri(V);Ac=xb}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[Ac>>2]|0);Qa=ua;break}case 131:{ua=c[Ea+-12>>2]|0;if(!ua)Bc=Ea;else{xb=~~ea(g[Ea+-4>>2]);yb=c[Ea>>2]|0;rri(W,yb,SEi(yb|0)|0);ywd(ua,0,xb,W,4);xri(W);Bc=Ea}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[Bc>>2]|0);Qa=ua;break}case 132:{ua=c[Ea+-16>>2]|0;if(!ua)Cc=Ea+-4|0;else{xb=~~ea(g[Ea+-8>>2]);yb=Ea+-4|0;Ra=c[yb>>2]|0;rri(X,Ra,SEi(Ra|0)|0);ywd(ua,0,xb,X,~~ea(g[Ea>>2]));xri(X);Cc=yb}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Cc>>2]|0);Qa=ua;break}case 133:{ua=c[Ea+-12>>2]|0;if(!ua)Dc=Ea;else{yb=~~ea(g[Ea+-4>>2]);xb=c[Ea>>2]|0;rri(Y,xb,SEi(xb|0)|0);ywd(ua,3,yb,Y,4);xri(Y);Dc=Ea}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Dc>>2]|0);Qa=ua;break}case 134:{ua=c[Ea+-16>>2]|0;if(!ua)Ec=Ea+-4|0;else{yb=~~ea(g[Ea+-8>>2]);xb=Ea+-4|0;Ra=c[xb>>2]|0;rri(Z,Ra,SEi(Ra|0)|0);ywd(ua,3,yb,Z,~~ea(g[Ea>>2]));xri(Z);Ec=xb}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[Ec>>2]|0);Qa=ua;break}case 135:{ua=c[Ea+-20>>2]|0;if(!ua)Fc=Ea+-8|0;else{xb=~~ea(g[Ea+-12>>2]);yb=Ea+-8|0;zwd(ua,xb,c[yb>>2]|0,c[Ea+-4>>2]|0,~~ea(g[Ea>>2]));Fc=yb}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Fc>>2]|0);Qa=ua;break}case 136:{ua=c[Ea+-16>>2]|0;if(!ua)Gc=Ea+-4|0;else{yb=~~ea(g[Ea+-8>>2]);xb=Ea+-4|0;zwd(ua,yb,c[xb>>2]|0,c[Ea>>2]|0,yb);Gc=xb}xb=c[164622]|0;In[c[(c[xb>>2]|0)+16>>2]&4095](xb,c[Gc>>2]|0);Qa=ua;break}case 137:{ua=c[Ea+-12>>2]|0;xb=Ea+-4|0;if(ua){yb=((c[ua+176>>2]|0)-(c[ua+172>>2]|0)|0)/24|0;zwd(ua,yb,c[xb>>2]|0,c[Ea>>2]|0,yb)}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[xb>>2]|0);Qa=ua;break}case 138:{ua=c[Ea+-16>>2]|0;xb=ua;yb=Ea+-4|0;if(ua)uwd(ua,c[yb>>2]|0);ua=c[yb>>2]|0;if(!ua)Qa=xb;else{yb=c[ua>>2]|0;if(yb){Ra=ua+4|0;while(1){Oa=c[Ra>>2]|0;if((Oa|0)==(yb|0))break;fb=Oa+-12|0;c[Ra>>2]=fb;xri(fb)}ACi(c[ua>>2]|0)}ACi(ua);Qa=xb}break}case 139:{Ra=c[Ea+-12>>2]|0;yb=Ea+-4|0;if(Ra)vwd(Ra,c[yb>>2]|0,~~ea(g[Ea>>2]));wb=c[164622]|0;In[c[(c[wb>>2]|0)+16>>2]&4095](wb,c[yb>>2]|0);Qa=Ra;break}case 140:{Ra=c[Ea+-12>>2]|0;yb=Ea+-4|0;if(Ra)wwd(Ra,c[yb>>2]|0,~~ea(g[Ea>>2]));wb=c[164622]|0;In[c[(c[wb>>2]|0)+16>>2]&4095](wb,c[yb>>2]|0);Qa=Ra;break}case 141:{Ra=c[Ea+-12>>2]|0;if(!Ra)Hc=Ea;else{yb=~~ea(g[Ea+-4>>2]);tjd(Ra,yb,c[Ea>>2]|0);Hc=Ea}yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Hc>>2]|0);Qa=Ra;break}case 142:{Ra=xCi(12)|0;c[Ra>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;Qa=Ra;break}case 143:{Ra=c[Ea+-4>>2]|0;yb=c[Ea>>2]|0;rri(_,yb,SEi(yb|0)|0);yb=Ra+4|0;wb=c[yb>>2]|0;if((wb|0)==(c[Ra+8>>2]|0))nO(Ra,_);else{if(!wb)Ic=0;else{sri(wb,_);Ic=c[yb>>2]|0}c[yb>>2]=Ic+12}xri(_);yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 144:{Ra=xCi(16)|0;Fwd(Ra);Qa=Ra;break}case 145:{Ra=c[Ea+-4>>2]|0;c[Ra+12>>2]=c[Ea>>2];Qa=Ra;break}case 146:{Ra=c[Ea+-8>>2]|0;yb=c[163374]|0;rri($,657280,54);Evd(yb,$,c[158360]|0,1,0);xri($);Qa=Ra;break}case 148:{Qa=c[Ea+-4>>2]|0;break}case 147:{Ra=c[Ea+-8>>2]|0;yb=c[163374]|0;c[h>>2]=c[Ea>>2];Lsd(aa,657200,h);Evd(yb,aa,c[158360]|0,1,0);xri(aa);yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 149:{Qa=c[Ea+-8>>2]<<8|c[Ea+-12>>2]<<16|c[Ea+-4>>2]|c[Ea>>2]<<24;break}case 150:{Qa=c[Ea+-4>>2]<<16|c[Ea>>2]<<24;break}case 151:{Qa=c[Ea+-4>>2]|c[Ea+-12>>2]<<16|c[Ea>>2]<<24|256;break}case 152:{Qa=c[Ea+-12>>2]<<8|c[Ea+-20>>2]<<16|c[Ea+-4>>2]|c[Ea>>2]<<24|40960;break}case 153:{Ra=c[Ea+-16>>2]|0;yb=c[Ea+-24>>2]|0;wb=c[Ea+-4>>2]|0;fb=c[Ea>>2]|0;Oa=c[163374]|0;rri(ba,657336,52);Evd(Oa,ba,c[158360]|0,1,0);xri(ba);Qa=Ra<<8|yb<<16|wb|fb<<24|40960;break}case 154:{fb=c[Ea+-12>>2]|0;wb=c[Ea+-20>>2]|0;yb=c[Ea+-4>>2]|0;Ra=c[Ea>>2]|0;Oa=c[163374]|0;rri(ca,657392,51);Evd(Oa,ca,c[158360]|0,1,0);xri(ca);Qa=fb<<8|wb<<16|yb|Ra<<24|40960;break}case 155:{Qa=c[Ea>>2]|8;break}case 156:{Qa=c[Ea>>2]|0;break}case 157:{Qa=1;break}case 158:{Qa=2;break}case 159:{Qa=4;break}case 160:{Qa=2;break}case 161:{Ra=c[163374]|0;rri(da,657448,51);Evd(Ra,da,c[158360]|0,1,0);xri(da);Qa=2;break}case 162:{Qa=4;break}case 164:{Ra=c[163374]|0;rri(ga,657560,57);Evd(Ra,ga,c[158360]|0,1,0);xri(ga);Qa=2;break}case 163:{Ra=c[163374]|0;rri(fa,657504,53);Evd(Ra,fa,c[158360]|0,1,0);xri(fa);Qa=2;break}case 165:{Qa=c[Ea+-4>>2]|128;break}case 166:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);g[Ra>>2]=ea(g[Ea>>2]);c[Ra+4>>2]=-1;Qa=Ra;break}case 167:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 168:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 169:{Ra=xCi(8)|0;yb=Ra+4|0;c[yb>>2]=-1;g[Ra>>2]=ea(c[Ea>>2]|0);c[yb>>2]=-1;Qa=Ra;break}case 170:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 171:{Ra=xCi(8)|0;yb=Ra+4|0;c[yb>>2]=-1;g[Ra>>2]=ea(c[Ea>>2]|0);c[yb>>2]=-1;Qa=Ra;break}case 172:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 173:{Ra=xCi(8)|0;yb=Ra+4|0;c[yb>>2]=-1;g[Ra>>2]=ea(c[Ea>>2]|0);c[yb>>2]=-1;Qa=Ra;break}case 174:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);c[Ra+4>>2]=-1;Qa=Ra;break}case 175:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 176:{Ra=xCi(8)|0;yb=Ra+4|0;c[yb>>2]=-1;g[Ra>>2]=ea(c[Ea>>2]|0);c[yb>>2]=-1;Qa=Ra;break}case 177:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 178:{Ra=xCi(8)|0;yb=Ra+4|0;c[yb>>2]=-1;g[Ra>>2]=ea(c[Ea>>2]|0);c[yb>>2]=-1;Qa=Ra;break}case 179:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 180:{Ra=xCi(8)|0;yb=Ra+4|0;c[yb>>2]=-1;g[Ra>>2]=ea(c[Ea>>2]|0);c[yb>>2]=-1;Qa=Ra;break}case 181:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);yb=Ra+4|0;c[yb>>2]=-1;wb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,wb);c[yb>>2]=c[h>>2];yb=c[164622]|0;In[c[(c[yb>>2]|0)+16>>2]&4095](yb,c[Ea>>2]|0);Qa=Ra;break}case 182:{Ra=xCi(8)|0;g[Ra>>2]=ea(1.0);c[Ra+4>>2]=-1;Qa=Ra;break}case 183:{Ra=xCi(8)|0;g[Ra>>2]=ea(0.0);c[Ra+4>>2]=-1;Qa=Ra;break}case 184:{Qa=ya&-256|1;break}case 185:{Qa=ya&-256;break}case 186:{Ra=xCi(48)|0;c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;c[Ra+12>>2]=0;c[Ra+16>>2]=-1;yb=Ra+20|0;g[yb>>2]=ea(0.0);c[Ra+24>>2]=-1;wb=Ra+28|0;g[wb>>2]=ea(0.0);c[Ra+32>>2]=-1;fb=Ra+36|0;g[fb>>2]=ea(0.0);c[Ra+40>>2]=-1;Oa=Ra+44|0;c[Oa>>2]=-1;Kb=Ra;lb=Ea+-28|0;mb=Ea+-20|0;gb=c[mb>>2]|0;kb=Ea+-12|0;Sa=c[kb>>2]|0;Wa=Ea+-4|0;Pa=c[Wa>>2]|0;Mb=c[lb>>2]|0;zb=c[Mb+4>>2]|0;Nb=Ra+12|0;c[Nb>>2]=c[Mb>>2];c[Nb+4>>2]=zb;zb=gb;gb=c[zb+4>>2]|0;Nb=yb;c[Nb>>2]=c[zb>>2];c[Nb+4>>2]=gb;gb=Sa;Sa=c[gb+4>>2]|0;Nb=wb;c[Nb>>2]=c[gb>>2];c[Nb+4>>2]=Sa;Sa=Pa;Pa=c[Sa+4>>2]|0;Nb=fb;c[Nb>>2]=c[Sa>>2];c[Nb+4>>2]=Pa;c[Oa>>2]=-1;Oa=c[lb>>2]|0;if(Oa)ACi(Oa);Oa=c[mb>>2]|0;if(Oa)ACi(Oa);Oa=c[kb>>2]|0;if(Oa)ACi(Oa);Oa=c[Wa>>2]|0;if(!Oa)Qa=Kb;else{ACi(Oa);Qa=Kb}break}case 187:{Kb=xCi(48)|0;c[Kb+0>>2]=0;c[Kb+4>>2]=0;c[Kb+8>>2]=0;c[Kb+12>>2]=0;c[Kb+16>>2]=-1;Oa=Kb+20|0;g[Oa>>2]=ea(0.0);c[Kb+24>>2]=-1;Wa=Kb+28|0;g[Wa>>2]=ea(0.0);c[Kb+32>>2]=-1;kb=Kb+36|0;g[kb>>2]=ea(0.0);mb=Kb+40|0;c[mb>>2]=-1;lb=Kb+44|0;c[lb>>2]=-1;Pa=Kb;Nb=Ea+-20|0;Sa=Ea+-12|0;fb=c[Sa>>2]|0;gb=Ea+-4|0;wb=c[gb>>2]|0;zb=c[Nb>>2]|0;yb=c[zb+4>>2]|0;Mb=Kb+12|0;c[Mb>>2]=c[zb>>2];c[Mb+4>>2]=yb;yb=fb;fb=c[yb+4>>2]|0;Mb=Oa;c[Mb>>2]=c[yb>>2];c[Mb+4>>2]=fb;fb=wb;wb=c[fb+4>>2]|0;Mb=Wa;c[Mb>>2]=c[fb>>2];c[Mb+4>>2]=wb;g[kb>>2]=ea(1.0);c[mb>>2]=-1;c[lb>>2]=-1;lb=c[Nb>>2]|0;if(lb)ACi(lb);lb=c[Sa>>2]|0;if(lb)ACi(lb);lb=c[gb>>2]|0;if(!lb)Qa=Pa;else{ACi(lb);Qa=Pa}break}case 188:{Pa=xCi(48)|0;c[Pa+0>>2]=0;c[Pa+4>>2]=0;c[Pa+8>>2]=0;c[Pa+12>>2]=0;c[Pa+16>>2]=-1;g[Pa+20>>2]=ea(0.0);c[Pa+24>>2]=-1;g[Pa+28>>2]=ea(0.0);c[Pa+32>>2]=-1;g[Pa+36>>2]=ea(0.0);c[Pa+40>>2]=-1;lb=Pa+44|0;c[lb>>2]=-1;zri(Pa,c[Ea>>2]|0)|0;gb=c[Ea>>2]|0;c[h>>2]=-1;itd(h,gb);c[lb>>2]=c[h>>2];lb=c[164622]|0;In[c[(c[lb>>2]|0)+16>>2]&4095](lb,c[Ea>>2]|0);Qa=Pa;break}case 189:{Pa=xCi(16)|0;Wb=ea(g[Ea+-28>>2]);Vb=ea(g[Ea+-20>>2]);Jc=ea(g[Ea+-12>>2]);Kc=ea(g[Ea+-4>>2]);g[Pa>>2]=Wb;g[Pa+4>>2]=Vb;g[Pa+8>>2]=Jc;g[Pa+12>>2]=Kc;Qa=Pa;break}case 190:{Pa=xCi(16)|0;Kc=ea(g[Ea+-20>>2]);Jc=ea(g[Ea+-12>>2]);Vb=ea(g[Ea+-4>>2]);g[Pa>>2]=Kc;g[Pa+4>>2]=Jc;g[Pa+8>>2]=Vb;g[Pa+12>>2]=ea(1.0);Qa=Pa;break}default:Qa=ya}while(0);ya=Ba+(0-xa<<1)|0;c[za>>2]=Qa;Pa=(d[657624+t>>0]|0)+-114|0;lb=b[ya>>1]|0;gb=(lb<<16>>16)+(b[657816+(Pa<<1)>>1]|0)|0;if(gb>>>0<431?(b[654712+(gb<<1)>>1]|0)==lb<<16>>16:0){La=ya;Ma=e[655576+(gb<<1)>>1]|0;Na=za;break}La=ya;Ma=b[657912+(Pa<<1)>>1]|0;Na=za}while(0);oa=Aa;pa=La+2|0;qa=Ca;ra=Ma;sa=Da;ta=Na}if((wa|0)==114)ori(ib);else if((wa|0)==613){c[163382]=(c[163382]|0)+1;ib=c[163374]|0;c[h>>2]=658008;Lsd(j,658048,h);Evd(ib,j,c[158360]|0,0,0);xri(j);Fa=1;Ga=Ka}else if((wa|0)==614){wa=c[163374]|0;c[h>>2]=658024;Lsd(j,658048,h);Evd(wa,j,c[158360]|0,0,0);xri(j);Fa=2;Ga=va}if((Ga|0)==(s|0)){i=f;return Fa|0}BDi(Ga);i=f;return Fa|0}function Yud(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+4|0;f=c[163374]|0;c[d>>2]=a;Lsd(e,658048,d);Evd(f,e,c[158360]|0,0,0);xri(e);i=b;return 0}function Zud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=b;g=(d-f|0)/76|0;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>((j-l|0)/76|0)>>>0){if(!k)m=j;else{j=a+4|0;while(1){n=c[j>>2]|0;if((n|0)==(k|0))break;o=n+-76|0;c[j>>2]=o;_ud(o)}ACi(c[a>>2]|0);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>56512727)vxi(a);j=(m-0|0)/76|0;if(j>>>0<28256363){m=j<<1;j=m>>>0<g>>>0?g:m;if(j>>>0>56512727)vxi(a);else p=j}else p=56512727;j=xCi(p*76|0)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(p*76|0);if((b|0)==(d|0)){i=e;return}else{q=b;r=j}do{qvd(r,q);r=(c[m>>2]|0)+76|0;c[m>>2]=r;q=q+76|0}while((q|0)!=(d|0));i=e;return}q=a+4|0;a=((c[q>>2]|0)-l|0)/76|0;if(g>>>0>a>>>0){s=1;t=b+(a*76|0)|0}else{s=0;t=d}if((t|0)==(b|0))u=k;else{a=t+-76-f|0;f=b;b=k;while(1){yri(b,f)|0;yri(b+12|0,f+12|0)|0;if((b|0)!=(f|0))Cod(b+24|0,c[f+24>>2]|0,c[f+28>>2]|0);g=b+36|0;l=f+36|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];yri(b+60|0,f+60|0)|0;c[b+72>>2]=c[f+72>>2];f=f+76|0;if((f|0)==(t|0))break;else b=b+76|0}u=k+((((a>>>0)/76|0)+1|0)*76|0)|0}if(!s){while(1){s=c[q>>2]|0;if((s|0)==(u|0))break;a=s+-76|0;c[q>>2]=a;_ud(a)}i=e;return}if((t|0)==(d|0)){i=e;return}u=t;t=c[q>>2]|0;do{if(!t)v=0;else{qvd(t,u);v=c[q>>2]|0}t=v+76|0;c[q>>2]=t;u=u+76|0}while((u|0)!=(d|0));i=e;return}function _ud(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;xri(a+60|0);d=a+24|0;e=c[d>>2]|0;if(e){f=a+28|0;while(1){g=c[f>>2]|0;if((g|0)==(e|0))break;h=g+-12|0;c[f>>2]=h;xri(h)}ACi(c[d>>2]|0)}xri(a+12|0);xri(a);i=b;return}function $ud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function avd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;b=xCi(656)|0;d=(c[163367]|0)+-1+(c[163366]|0)|0;fvd(b,c[(c[(c[163363]|0)+(d>>>10<<2)>>2]|0)+((d&1023)<<2)>>2]|0);d=c[163364]|0;e=c[163363]|0;if((d|0)==(e|0))f=0;else f=(d-e<<8)+-1|0;g=c[163366]|0;h=c[163367]|0;if((f-g|0)==(h|0)){rvd(653448);j=c[163367]|0;k=c[163366]|0;l=c[163364]|0;m=c[163363]|0}else{j=h;k=g;l=d;m=e}e=j+k|0;if((l|0)==(m|0)){n=j+1|0;c[163367]=n;i=a;return}l=(c[m+(e>>>10<<2)>>2]|0)+((e&1023)<<2)|0;if(!l){n=j+1|0;c[163367]=n;i=a;return}c[l>>2]=b;n=j+1|0;c[163367]=n;i=a;return}function bvd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=a+4|0;h=c[b>>2]|0;if((h|0)!=(g|0)?(b=c[e>>2]|0,j=c[h+16>>2]|0,(b|0)>=(j|0)):0){if((j|0)>=(b|0)){c[d>>2]=h;k=d;i=f;return k|0}j=h+4|0;l=c[j>>2]|0;m=(l|0)==0;if(m){n=h;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=l;while(1){l=c[n>>2]|0;if(!l){p=n;break}else n=l}}if((p|0)!=(g|0)?(b|0)>=(c[p+16>>2]|0):0){n=c[a+4>>2]|0;if(!n){c[d>>2]=g;k=g;i=f;return k|0}else q=n;while(1){n=c[q+16>>2]|0;if((b|0)<(n|0)){l=c[q>>2]|0;if(!l){r=q;s=q;t=34;break}else{q=l;continue}}if((n|0)>=(b|0)){u=q;t=38;break}n=q+4|0;l=c[n>>2]|0;if(!l){v=n;w=q;t=37;break}else q=l}if((t|0)==34){c[d>>2]=s;k=r;i=f;return k|0}else if((t|0)==37){c[d>>2]=w;k=v;i=f;return k|0}else if((t|0)==38){c[d>>2]=u;k=d;i=f;return k|0}}if(m){c[d>>2]=h;k=j;i=f;return k|0}else{c[d>>2]=p;k=p;i=f;return k|0}}p=c[h>>2]|0;if((h|0)!=(c[a>>2]|0)){if(!p){j=h;while(1){m=c[j+8>>2]|0;if((c[m>>2]|0)==(j|0))j=m;else{x=m;break}}}else{j=p;while(1){m=c[j+4>>2]|0;if(!m){x=j;break}else j=m}}j=c[e>>2]|0;if((c[x+16>>2]|0)>=(j|0)){e=c[a+4>>2]|0;if(!e){c[d>>2]=g;k=g;i=f;return k|0}else y=e;while(1){e=c[y+16>>2]|0;if((j|0)<(e|0)){g=c[y>>2]|0;if(!g){z=y;A=y;t=15;break}else{y=g;continue}}if((e|0)>=(j|0)){B=y;t=19;break}e=y+4|0;g=c[e>>2]|0;if(!g){C=e;D=y;t=18;break}else y=g}if((t|0)==15){c[d>>2]=A;k=z;i=f;return k|0}else if((t|0)==18){c[d>>2]=D;k=C;i=f;return k|0}else if((t|0)==19){c[d>>2]=B;k=d;i=f;return k|0}}else E=x}else E=h;if(!p){c[d>>2]=h;k=h;i=f;return k|0}else{c[d>>2]=E;k=E+4|0;i=f;return k|0}return 0}function cvd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=b;g=d-f>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=j-l>>2>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=n>>2;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;f=k+(p>>2<<2)|0;p=c[m>>2]|0;if((p|0)==(f|0)){i=e;return}c[m>>2]=p+(~((p+-4-f|0)>>>2)<<2);i=e;return}f=b+(o<<2)|0;aFi(k|0,b|0,n|0)|0;if((f|0)==(d|0)){i=e;return}n=f;f=c[m>>2]|0;do{if(!f)q=0;else{c[f>>2]=c[n>>2];q=c[m>>2]|0}f=q+4|0;c[m>>2]=f;n=n+4|0}while((n|0)!=(d|0));i=e;return}if(!k)r=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;r=0}if(g>>>0>1073741823)vxi(a);j=r-0|0;if(j>>2>>>0<536870911){r=j>>1;j=r>>>0<g>>>0?g:r;if(j>>>0>1073741823)vxi(a);else s=j}else s=1073741823;j=xCi(s<<2)|0;r=a+4|0;c[r>>2]=j;c[a>>2]=j;c[h>>2]=j+(s<<2);if((b|0)==(d|0)){i=e;return}else{t=b;u=j}do{c[u>>2]=c[t>>2];u=(c[r>>2]|0)+4|0;c[r>>2]=u;t=t+4|0}while((t|0)!=(d|0));i=e;return}function dvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/24|0)+1|0;if(g>>>0>178956970)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/24|0;if(k>>>0<89478485){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/24|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=178956970;r=(l-j|0)/24|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*24|0)|0;o=r;p=s}s=n+(o*24|0)|0;r=n+(m*24|0)|0;if(!s){u=p;v=f}else{sri(s,b);sri(n+(o*24|0)+12|0,b+12|0);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*24|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=o;o=o+-24|0;sri(u+-24|0,o);sri(u+-12|0,s+-12|0);s=u+-24|0;if((o|0)==(v|0)){z=s;break}else u=s}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-24|0;xri(r+-12|0);xri(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function evd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function fvd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;k=a[d>>0]|0;if(!(k&1)){l=(k&255)>>>1;m=d+1|0}else{l=c[d+4>>2]|0;m=c[d+8>>2]|0}if(l>>>0>2147483631)ori(b);if(l>>>0<11){a[b>>0]=l<<1;n=b+1|0}else{k=l+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];o=cOb(k,16,f,0,3653512,80)|0;c[b+8>>2]=o;c[b>>2]=k|1;c[b+4>>2]=l;n=o}YEi(n|0,m|0,l|0)|0;a[n+l>>0]=0;YEi(b+12|0,d+12|0,628)|0;l=b+640|0;n=b+644|0;c[n>>2]=0;m=b+648|0;c[m>>2]=0;o=b+644|0;c[l>>2]=o;k=c[d+640>>2]|0;p=d+644|0;if((k|0)==(p|0)){q=b+652|0;r=d+652|0;s=c[r>>2]|0;c[q>>2]=s;i=e;return}t=k;while(1){k=t+16|0;u=c[k>>2]|0;v=c[k+4>>2]|0;k=j;c[k>>2]=u;c[k+4>>2]=v;c[h>>2]=o;c[f+0>>2]=c[h+0>>2];k=bvd(l,f,g,j)|0;if(!(c[k>>2]|0)){w=xCi(24)|0;x=w+16|0;c[x>>2]=u;c[x+4>>2]=v;v=c[g>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=v;c[k>>2]=w;v=c[c[l>>2]>>2]|0;if(!v)y=w;else{c[l>>2]=v;y=c[k>>2]|0}GN(c[n>>2]|0,y);c[m>>2]=(c[m>>2]|0)+1}k=c[t+4>>2]|0;if(!k){v=t;while(1){w=c[v+8>>2]|0;if((c[w>>2]|0)==(v|0)){z=w;break}else v=w}}else{v=k;while(1){w=c[v>>2]|0;if(!w){z=v;break}else v=w}}if((z|0)==(p|0))break;else t=z}q=b+652|0;r=d+652|0;s=c[r>>2]|0;c[q>>2]=s;i=e;return}function gvd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=b;g=(d-f|0)/52|0;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=((j-l|0)/52|0)>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=(n|0)/52|0;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;f=k+(((p|0)/52|0)*52|0)|0;p=c[m>>2]|0;if((p|0)==(f|0)){i=e;return}c[m>>2]=p+(~(((p+-52-f|0)>>>0)/52|0)*52|0);i=e;return}f=b+(o*52|0)|0;aFi(k|0,b|0,n|0)|0;if((f|0)==(d|0)){i=e;return}n=f;f=c[m>>2]|0;do{if(!f)q=0;else{r=f+0|0;s=n+0|0;t=r+52|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));q=c[m>>2]|0}f=q+52|0;c[m>>2]=f;n=n+52|0}while((n|0)!=(d|0));i=e;return}if(!k)u=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~(((n+-52-l|0)>>>0)/52|0)*52|0);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;u=0}if(g>>>0>82595524)vxi(a);j=(u-0|0)/52|0;if(j>>>0<41297762){u=j<<1;j=u>>>0<g>>>0?g:u;if(j>>>0>82595524)vxi(a);else v=j}else v=82595524;j=xCi(v*52|0)|0;u=a+4|0;c[u>>2]=j;c[a>>2]=j;c[h>>2]=j+(v*52|0);if((b|0)==(d|0)){i=e;return}else{w=b;x=j}do{r=x+0|0;s=w+0|0;t=r+52|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));x=(c[u>>2]|0)+52|0;c[u>>2]=x;w=w+52|0}while((w|0)!=(d|0));i=e;return}function hvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=a+32|0;k=c[b>>2]|0;l=b+4|0;b=a+36|0;if((k|0)==(l|0)){i=d;return}m=a+36|0;n=a+40|0;a=k;while(1){k=a+16|0;o=c[k>>2]|0;p=c[k+4>>2]|0;k=h;c[k>>2]=o;c[k+4>>2]=p;c[g>>2]=b;c[e+0>>2]=c[g+0>>2];k=bvd(j,e,f,h)|0;if(!(c[k>>2]|0)){q=xCi(24)|0;r=q+16|0;c[r>>2]=o;c[r+4>>2]=p;p=c[f>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=p;c[k>>2]=q;p=c[c[j>>2]>>2]|0;if(!p)s=q;else{c[j>>2]=p;s=c[k>>2]|0}GN(c[m>>2]|0,s);c[n>>2]=(c[n>>2]|0)+1}k=c[a+4>>2]|0;if(!k){p=a;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){t=q;break}else p=q}}else{p=k;while(1){q=c[p>>2]|0;if(!q){t=p;break}else p=q}}if((t|0)==(l|0))break;else a=t}i=d;return}function ivd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d;j=a+640|0;k=c[b>>2]|0;l=b+4|0;b=a+644|0;if((k|0)==(l|0)){i=d;return}m=a+644|0;n=a+648|0;a=k;while(1){k=a+16|0;o=c[k>>2]|0;p=c[k+4>>2]|0;k=h;c[k>>2]=o;c[k+4>>2]=p;c[g>>2]=b;c[e+0>>2]=c[g+0>>2];k=bvd(j,e,f,h)|0;if(!(c[k>>2]|0)){q=xCi(24)|0;r=q+16|0;c[r>>2]=o;c[r+4>>2]=p;p=c[f>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=p;c[k>>2]=q;p=c[c[j>>2]>>2]|0;if(!p)s=q;else{c[j>>2]=p;s=c[k>>2]|0}GN(c[m>>2]|0,s);c[n>>2]=(c[n>>2]|0)+1}k=c[a+4>>2]|0;if(!k){p=a;while(1){q=c[p+8>>2]|0;if((c[q>>2]|0)==(p|0)){t=q;break}else p=q}}else{p=k;while(1){q=c[p>>2]|0;if(!q){t=p;break}else p=q}}if((t|0)==(l|0))break;else a=t}i=d;return}function jvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/52|0)+1|0;if(g>>>0>82595524)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/52|0;if(k>>>0<41297762){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/52|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=82595524;r=(l|0)/52|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*52|0)|0;o=r;p=s}s=n+(o*52|0)|0;r=n+(m*52|0)|0;if(s){m=s+0|0;s=b+0|0;b=m+52|0;do{c[m>>2]=c[s>>2];m=m+4|0;s=s+4|0}while((m|0)<(b|0))}s=n+((((p|0)/-52|0)+o|0)*52|0)|0;YEi(s|0,f|0,p|0)|0;c[a>>2]=s;c[e>>2]=n+((o+1|0)*52|0);c[h>>2]=r;if(!f){i=d;return}ACi(f);i=d;return}function kvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function lvd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=658072;Ntd(b+32|0,c[b+36>>2]|0);xri(b+20|0);if(!(a[b+8>>0]&1)){i=d;return}g=c[b+16>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function mvd(a){a=a|0;var b=0;b=i;lvd(a);ACi(a);i=b;return}function nvd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=658088;if(!(a[b+8>>0]&1)){i=d;return}g=c[b+16>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function ovd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=658088;if(!(a[b+8>>0]&1)){ACi(b);i=d;return}g=c[b+16>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);ACi(b);i=d;return}function pvd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+16|0;g=c[f>>2]|0;h=e+(g>>>10<<2)|0;j=a+8|0;k=c[j>>2]|0;if((k|0)==(e|0)){l=0;m=a+20|0;n=0}else{o=a+20|0;p=(c[o>>2]|0)+g|0;l=(c[e+(p>>>10<<2)>>2]|0)+((p&1023)<<2)|0;m=o;n=(c[h>>2]|0)+((g&1023)<<2)|0}g=n;n=h;a:while(1){h=g;do{if((h|0)==(l|0))break a;h=h+4|0}while((h-(c[n>>2]|0)|0)!=4096);h=n+4|0;g=c[h>>2]|0;n=h}c[m>>2]=0;m=k-e>>2;if(m>>>0>2){k=e;do{ACi(c[k>>2]|0);k=(c[d>>2]|0)+4|0;c[d>>2]=k;e=(c[j>>2]|0)-k>>2}while(e>>>0>2);q=e}else q=m;if((q|0)==1)c[f>>2]=512;else if((q|0)==2)c[f>>2]=1024;f=c[d>>2]|0;q=c[j>>2]|0;if((f|0)!=(q|0)){m=f;do{ACi(c[m>>2]|0);m=m+4|0}while((m|0)!=(q|0));q=c[d>>2]|0;d=c[j>>2]|0;if((d|0)!=(q|0))c[j>>2]=d+(~((d+-4-q|0)>>>2)<<2)}q=c[a>>2]|0;if(!q){i=b;return}ACi(q);i=b;return}function qvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;sri(a,b);sri(a+12|0,b+12|0);aQ(a+24|0,b+24|0);e=a+36|0;f=b+36|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];sri(a+60|0,b+60|0);c[a+72>>2]=c[b+72>>2];i=d;return}function rvd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=i;i=i+16|0;d=b;e=a+16|0;f=c[e>>2]|0;if(f>>>0>1023){c[e>>2]=f+-1024;f=a+4|0;e=c[f>>2]|0;g=c[e>>2]|0;h=e+4|0;c[f>>2]=h;j=a+8|0;k=c[j>>2]|0;l=a+12|0;do if((k|0)==(c[l>>2]|0)){m=c[a>>2]|0;if(h>>>0>m>>>0){n=h;o=((n-m>>2)+1|0)/-2|0;p=k-n|0;aFi(e+(o+1<<2)|0,h|0,p|0)|0;n=e+((p>>2)+1+o<<2)|0;c[j>>2]=n;c[f>>2]=(c[f>>2]|0)+(o<<2);q=n;r=13;break}n=k-m>>1;o=(n|0)==0?1:n;n=xCi(o<<2)|0;p=n+(o>>>2<<2)|0;s=n+(o<<2)|0;if((h|0)==(k|0)){t=p;u=m}else{m=p;o=h;v=e;while(1){if(!m)w=0;else{c[m>>2]=c[o>>2];w=m}x=w+4|0;y=v+8|0;if((y|0)==(k|0)){z=x;break}else{A=o;m=x;o=y;v=A}}t=z;u=c[a>>2]|0}c[a>>2]=n;c[f>>2]=p;c[j>>2]=t;c[l>>2]=s;if(!u){B=t;r=12}else{ACi(u);B=c[j>>2]|0;r=12}}else{B=k;r=12}while(0);if((r|0)==12)if(!B)C=0;else{q=B;r=13}if((r|0)==13){c[q>>2]=g;C=c[j>>2]|0}c[j>>2]=C+4;i=b;return}C=a+8|0;j=c[C>>2]|0;g=a+4|0;q=j-(c[g>>2]|0)|0;B=q>>2;k=a+12|0;u=c[k>>2]|0;t=u-(c[a>>2]|0)|0;if(B>>>0<t>>2>>>0){l=xCi(4096)|0;if((u|0)!=(j|0)){if(!j)D=0;else{c[j>>2]=l;D=c[C>>2]|0}c[C>>2]=D+4;i=b;return}c[d>>2]=l;svd(a,d);d=c[g>>2]|0;l=c[d>>2]|0;D=d+4|0;c[g>>2]=D;j=c[C>>2]|0;do if((j|0)==(c[k>>2]|0)){u=c[a>>2]|0;if(D>>>0>u>>>0){f=D;z=((f-u>>2)+1|0)/-2|0;w=j-f|0;aFi(d+(z+1<<2)|0,D|0,w|0)|0;f=d+((w>>2)+1+z<<2)|0;c[C>>2]=f;c[g>>2]=(c[g>>2]|0)+(z<<2);E=f;r=31;break}f=j-u>>1;z=(f|0)==0?1:f;f=xCi(z<<2)|0;w=f+(z>>>2<<2)|0;e=f+(z<<2)|0;if((D|0)==(j|0)){F=w;G=u}else{u=w;z=D;h=d;while(1){if(!u)H=0;else{c[u>>2]=c[z>>2];H=u}v=H+4|0;o=h+8|0;if((o|0)==(j|0)){I=v;break}else{m=z;u=v;z=o;h=m}}F=I;G=c[a>>2]|0}c[a>>2]=f;c[g>>2]=w;c[C>>2]=F;c[k>>2]=e;if(!G){J=F;r=30}else{ACi(G);J=c[C>>2]|0;r=30}}else{J=j;r=30}while(0);if((r|0)==30)if(!J)K=0;else{E=J;r=31}if((r|0)==31){c[E>>2]=l;K=c[C>>2]|0}c[C>>2]=K+4;i=b;return}K=t>>1;t=(K|0)==0?1:K;K=xCi(t<<2)|0;l=K+(t<<2)|0;E=xCi(4096)|0;r=K+(B<<2)|0;do if((B|0)==(t|0))if((q|0)>0){L=K+(((B+1|0)/-2|0)+B<<2)|0;M=l;N=K;break}else{J=q>>1;j=(J|0)==0?1:J;J=xCi(j<<2)|0;ACi(K);L=J+(j>>>2<<2)|0;M=J+(j<<2)|0;N=J;break}else{L=r;M=l;N=K}while(0);if(!L)O=0;else{c[L>>2]=E;O=L}E=O+4|0;O=c[C>>2]|0;if((O|0)==(c[g>>2]|0)){P=M;Q=E;R=L;S=N}else{K=L;L=N;N=E;E=M;M=O;while(1){M=M+-4|0;do if((K|0)==(L|0)){O=E;if(N>>>0<E>>>0){l=N;r=((O-l>>2)+1|0)/2|0;q=l-L|0;l=N+(r-(q>>2)<<2)|0;aFi(l|0,L|0,q|0)|0;T=l;U=E;V=N+(r<<2)|0;W=L;break}r=O-L>>1;O=(r|0)==0?1:r;r=xCi(O<<2)|0;l=r+((O+3|0)>>>2<<2)|0;q=r+(O<<2)|0;if((L|0)==(N|0))X=l;else{O=l;B=L;while(1){if(!O)Y=0;else{c[O>>2]=c[B>>2];Y=O}t=Y+4|0;B=B+4|0;if((B|0)==(N|0)){X=t;break}else O=t}}if(!L){T=l;U=q;V=X;W=r}else{ACi(L);T=l;U=q;V=X;W=r}}else{T=K;U=E;V=N;W=L}while(0);e=T+-4|0;c[e>>2]=c[M>>2];if((M|0)==(c[g>>2]|0)){P=U;Q=V;R=e;S=W;break}else{K=e;L=W;N=V;E=U}}}U=c[a>>2]|0;c[a>>2]=S;c[g>>2]=R;c[C>>2]=Q;c[k>>2]=P;if(!U){i=b;return}ACi(U);i=b;return}function svd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+4|0;f=c[e>>2]|0;do if((f|0)==(c[a>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=a+12|0;k=c[j>>2]|0;l=k;if(h>>>0<k>>>0){k=h;m=((l-k>>2)+1|0)/2|0;n=k-f|0;k=h+(m-(n>>2)<<2)|0;aFi(k|0,f|0,n|0)|0;c[e>>2]=k;c[g>>2]=(c[g>>2]|0)+(m<<2);o=k;break}k=l-f>>1;l=(k|0)==0?1:k;k=xCi(l<<2)|0;m=k+((l+3|0)>>>2<<2)|0;n=k+(l<<2)|0;if((f|0)==(h|0)){p=m;q=f}else{l=m;r=f;while(1){if(!l)s=0;else{c[l>>2]=c[r>>2];s=l}t=s+4|0;r=r+4|0;if((r|0)==(h|0)){u=t;break}else l=t}p=u;q=c[a>>2]|0}c[a>>2]=k;c[e>>2]=m;c[g>>2]=p;c[j>>2]=n;if(!q)o=m;else{ACi(q);o=c[e>>2]|0}}else o=f;while(0);c[o+-4>>2]=c[b>>2];c[e>>2]=(c[e>>2]|0)+-4;i=d;return}function tvd(){var b=0,d=0,e=0,f=0,h=0;b=i;if(a[658152]|0){i=b;return}a[658152]=1;d=zCi(388)|0;c[d>>2]=6;e=d+4|0;f=d+12|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[d+64>>2]=-1;c[f>>2]=0;c[d+16>>2]=0;c[e>>2]=0;f=d+8|0;c[f>>2]=5;g[d+40>>2]=ea(1.0);g[d+36>>2]=ea(1.0);g[d+44>>2]=ea(0.0);g[d+48>>2]=ea(1.0);g[d+52>>2]=ea(1.0);g[d+56>>2]=ea(0.0);g[d+60>>2]=ea(0.0);h=d+76|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[d+128>>2]=-1;c[h>>2]=0;c[d+80>>2]=0;c[d+68>>2]=0;c[d+72>>2]=5;g[d+104>>2]=ea(1.0);g[d+100>>2]=ea(1.0);g[d+108>>2]=ea(0.0);g[d+112>>2]=ea(1.0);g[d+116>>2]=ea(1.0);g[d+120>>2]=ea(0.0);g[d+124>>2]=ea(0.0);h=d+140|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[d+192>>2]=-1;c[h>>2]=0;c[d+144>>2]=0;c[d+132>>2]=0;c[d+136>>2]=5;g[d+168>>2]=ea(1.0);g[d+164>>2]=ea(1.0);g[d+172>>2]=ea(0.0);g[d+176>>2]=ea(1.0);g[d+180>>2]=ea(1.0);g[d+184>>2]=ea(0.0);g[d+188>>2]=ea(0.0);h=d+204|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[d+256>>2]=-1;c[h>>2]=0;c[d+208>>2]=0;c[d+196>>2]=0;c[d+200>>2]=5;g[d+232>>2]=ea(1.0);g[d+228>>2]=ea(1.0);g[d+236>>2]=ea(0.0);g[d+240>>2]=ea(1.0);g[d+244>>2]=ea(1.0);g[d+248>>2]=ea(0.0);g[d+252>>2]=ea(0.0);h=d+268|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[d+320>>2]=-1;c[h>>2]=0;c[d+272>>2]=0;g[d+296>>2]=ea(1.0);g[d+292>>2]=ea(1.0);g[d+300>>2]=ea(0.0);g[d+304>>2]=ea(1.0);g[d+308>>2]=ea(1.0);g[d+312>>2]=ea(0.0);g[d+316>>2]=ea(0.0);h=d+332|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[d+384>>2]=-1;c[h>>2]=0;c[d+336>>2]=0;g[d+360>>2]=ea(1.0);g[d+356>>2]=ea(1.0);g[d+364>>2]=ea(0.0);g[d+368>>2]=ea(1.0);g[d+372>>2]=ea(1.0);g[d+376>>2]=ea(0.0);g[d+380>>2]=ea(0.0);c[164540]=e;c[f>>2]=0;c[e>>2]=0;c[d+72>>2]=1;c[d+68>>2]=1;c[d+136>>2]=2;c[d+132>>2]=2;c[d+200>>2]=3;c[d+196>>2]=3;c[d+264>>2]=4;c[d+260>>2]=4;c[d+328>>2]=5;c[d+324>>2]=5;i=b;return}function uvd(a){a=ea(a);var b=0,c=0,d=0,e=Im,f=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;b=i;c=ync()|0;d=jLc()|0;e=ea(+h[d+88>>3]+ +h[d+160>>3]);f=!(a>=ea(0.0));j=f?e:a;a=ea(g[d+104>>2]);if(a<ea(.00499999989))k=ea(.00499999989);else{f=a>ea(.200000003);k=f?ea(.200000003):a}a=ea(g[d+108>>2]);if(a<ea(.00499999989))l=ea(.00499999989);else{d=a>ea(.200000003);l=d?ea(.200000003):a}a=ea(j*ea(2.0));e=ea(j*ea(3.0));g[c+1092>>2]=ea(j*ea(.0500000007));g[c+1096>>2]=j;g[c+1100>>2]=a;g[c+1104>>2]=e;m=ea(j*ea(.125));n=ea(j*ea(.25));o=ea(+W(+n));p=ea(j*ea(.5));q=ea(+W(+p));r=ea(+W(+j));g[c+1108>>2]=ea(+W(+m));g[c+1112>>2]=o;g[c+1116>>2]=q;g[c+1120>>2]=r;r=ea(+V(+n));n=ea(+V(+p));p=ea(+V(+j));g[c+1124>>2]=ea(+V(+m));g[c+1128>>2]=r;g[c+1132>>2]=n;g[c+1136>>2]=p;p=ea(XDi(j,ea(3.14159274)));n=ea(XDi(a,ea(3.14159274)));a=ea(XDi(e,ea(3.14159274)));e=ea(XDi(ea(j*ea(4.0)),ea(3.14159274)));g[c+1140>>2]=p;g[c+1144>>2]=n;g[c+1148>>2]=a;g[c+1152>>2]=e;e=ea(ea(1.0)/k);a=ea(ea(1.0)/l);g[c+1156>>2]=k;g[c+1160>>2]=e;g[c+1164>>2]=l;g[c+1168>>2]=a;d=(KLc()|0)==1;a=d?ea(.214041144):ea(.5);g[c+1316>>2]=a;g[c+1320>>2]=a;g[c+1324>>2]=a;g[c+1328>>2]=ea(.5);d=(KLc()|0)==1;a=d?ea(4.5947938):ea(2.0);g[c+1332>>2]=a;g[c+1336>>2]=a;g[c+1340>>2]=a;g[c+1344>>2]=ea(2.0);d=(KLc()|0)==1;a=d?ea(.0400020517):ea(.220922261);l=ea(ea(1.0)-a);g[c+1508>>2]=a;g[c+1512>>2]=a;g[c+1516>>2]=a;g[c+1520>>2]=l;d=(KLc()|0)==0;l=d?ea(.60024792):ea(.797884523);a=d?ea(97.005867):ea(8.0);e=d?ea(.0217741616):ea(.159154937);g[c+1348>>2]=d?ea(.579373181):ea(.785398185);g[c+1352>>2]=e;g[c+1356>>2]=a;g[c+1360>>2]=l;i=b;return}function vvd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d+32|0;f=d+16|0;g=d;h=c[164535]|0;if(h){j=b+1|0;k=b+8|0;l=658140|0;m=h;a:while(1){h=m;while(1){n=h+16|0;if(!(a[n>>0]&1))o=n+1|0;else o=c[h+24>>2]|0;if((Gsd(o,(a[b>>0]&1)==0?j:c[k>>2]|0)|0)>=0){p=h;break}h=c[h+4>>2]|0;if(!h){q=l;break a}}m=c[p>>2]|0;if(!m){q=p;break}else l=p}if((q|0)!=(658140|0)){p=q+16|0;if(!(a[p>>0]&1))r=p+1|0;else r=c[q+24>>2]|0;if((Gsd((a[b>>0]&1)==0?j:c[k>>2]|0,r)|0)>-1){s=c[q+28>>2]|0;i=d;return s|0}}}q=c[164536]|0;if(!(a[b>>0]&1))t=b+1|0;else t=c[b+8>>2]|0;rri(g,t,SEi(t|0)|0);t=g+12|0;c[t>>2]=q;sri(f,g);c[f+12>>2]=c[t>>2];Dvd(e,658136,f);xri(f);xri(g);s=q;i=d;return s|0}function wvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[164534]|0;a:do if((e|0)!=(658140|0)){f=e;while(1){if((c[f+28>>2]|0)==(b|0)){g=f;break}h=c[f+4>>2]|0;if(!h){j=f;while(1){k=c[j+8>>2]|0;if((c[k>>2]|0)==(j|0)){l=k;break}else j=k}}else{j=h;while(1){k=c[j>>2]|0;if(!k){l=j;break}else j=k}}if((l|0)==(658140|0))break a;else f=l}sri(a,g+16|0);i=d;return}while(0);rri(a,658168,13);i=d;return}function xvd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=c[d>>2]|0;if(((h|0)!=-1&h>>>0>1073741823?(d=ync()|0,j=h&1073741823,k=d+(j<<6)+3748|0,c[f>>2]=2,(c[d+(j<<6)+3756>>2]|0)!=0):0)?((e|0)==5?1:(c[k>>2]|0)==(e|0)):0){l=k;i=g;return l|0}k=c[a+48>>2]|0;j=a+48|0;do if(k){a=j;d=k;a:while(1){m=d;while(1){if((c[m+16>>2]|0)>=(h|0)){n=m;break}m=c[m+4>>2]|0;if(!m){o=a;break a}}d=c[n>>2]|0;if(!d){o=n;break}else a=n}if(((o|0)!=(j|0)?(h|0)>=(c[o+16>>2]|0):0)?(a=c[o+20>>2]|0,(a|0)!=0):0){c[f>>2]=0;if((c[a+8>>2]|0)!=0?((e|0)==5?1:(c[a>>2]|0)==(e|0)):0){l=a;i=g;return l|0}d=a+60|0;a=c[d>>2]|0;if((a|0)!=-1&a>>>0>1073741823){m=ync()|0;p=c[d>>2]&1073741823;d=m+(p<<6)+3748|0;c[f>>2]=2;if(!(c[m+(p<<6)+3756>>2]|0))break;if((e|0)==5?1:(c[d>>2]|0)==(e|0))l=d;else break;i=g;return l|0}d=c[b+68>>2]|0;p=b+68|0;if(d){m=p;q=d;b:while(1){d=q;while(1){if((c[d+16>>2]|0)>=(a|0)){r=d;break}d=c[d+4>>2]|0;if(!d){s=m;break b}}q=c[r>>2]|0;if(!q){s=r;break}else m=r}if((s|0)!=(p|0)?(a|0)>=(c[s+16>>2]|0):0){m=c[s+20>>2]|0;c[f>>2]=1;if(!m)break;if(!(c[m+8>>2]|0))break;if((e|0)==5?1:(c[m>>2]|0)==(e|0))l=m;else break;i=g;return l|0}}c[f>>2]=1}}while(0);s=c[b+68>>2]|0;r=b+68|0;if(s){b=r;o=s;c:while(1){s=o;while(1){if((c[s+16>>2]|0)>=(h|0)){t=s;break}s=c[s+4>>2]|0;if(!s){u=b;break c}}o=c[t>>2]|0;if(!o){u=t;break}else b=t}if((u|0)!=(r|0)?(h|0)>=(c[u+16>>2]|0):0){h=c[u+20>>2]|0;c[f>>2]=1;if(((h|0)!=0?(c[h+8>>2]|0)!=0:0)?((e|0)==5?1:(c[h>>2]|0)==(e|0)):0){l=h;i=g;return l|0}}else v=35}else v=35;if((v|0)==35)c[f>>2]=1;c[f>>2]=4;l=(c[164540]|0)+(e<<6)|0;i=g;return l|0}function yvd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=c[d>>2]|0;do if(!((g|0)!=-1&g>>>0>1073741823)){d=c[a+48>>2]|0;h=a+48|0;if(d){j=h;k=d;a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(g|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=j;break a}}k=c[l>>2]|0;if(!k){m=l;break}else j=l}if(((m|0)!=(h|0)?(g|0)>=(c[m+16>>2]|0):0)?(j=c[m+20>>2]|0,(j|0)!=0):0){n=j;break}}j=c[b+68>>2]|0;k=b+68|0;if(!j){o=-1;c[e>>2]=o;i=f;return}else{p=k;q=j}b:while(1){j=q;while(1){if((c[j+16>>2]|0)>=(g|0)){r=j;break}j=c[j+4>>2]|0;if(!j){s=p;break b}}q=c[r>>2]|0;if(!q){s=r;break}else p=r}if((s|0)==(k|0)){o=-1;c[e>>2]=o;i=f;return}if((g|0)<(c[s+16>>2]|0)){o=-1;c[e>>2]=o;i=f;return}h=c[s+20>>2]|0;if(!h){o=-1;c[e>>2]=o;i=f;return}else n=h}else n=(ync()|0)+((g&1073741823)<<6)+3748|0;while(0);o=c[n>>2]|0;c[e>>2]=o;i=f;return}function zvd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[d>>2]|0;if((g|0)==-1){c[e>>2]=3;h=658184;i=f;return h|0}if(g>>>0>1073741823){c[e>>2]=2;h=(ync()|0)+((g&1073741823)<<4)+4|0;i=f;return h|0}d=c[a+12>>2]|0;j=a+12|0;if(d){a=j;k=d;a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(g|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=a;break a}}k=c[l>>2]|0;if(!k){m=l;break}else a=l}if((m|0)!=(j|0)?(g|0)>=(c[m+16>>2]|0):0){c[e>>2]=0;h=m+20|0;i=f;return h|0}}m=c[b+32>>2]|0;j=b+32|0;if(m){b=j;l=m;b:while(1){m=l;while(1){if((c[m+16>>2]|0)>=(g|0)){n=m;break}m=c[m+4>>2]|0;if(!m){o=b;break b}}l=c[n>>2]|0;if(!l){o=n;break}else b=n}if((o|0)!=(j|0)?(g|0)>=(c[o+16>>2]|0):0){c[e>>2]=1;h=o+20|0;i=f;return h|0}}c[e>>2]=4;h=658184;i=f;return h|0}function Avd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[d>>2]|0;if((g|0)==-1){c[e>>2]=3;h=658096;i=f;return h|0}if(g>>>0>1073741823){c[e>>2]=2;h=(ync()|0)+((g&1073741823)<<4)+4|0;i=f;return h|0}d=c[a+24>>2]|0;j=a+24|0;if(d){a=j;k=d;a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(g|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=a;break a}}k=c[l>>2]|0;if(!k){m=l;break}else a=l}if((m|0)!=(j|0)?(g|0)>=(c[m+16>>2]|0):0){c[e>>2]=0;h=m+20|0;i=f;return h|0}}m=c[b+44>>2]|0;j=b+44|0;if(m){b=j;l=m;b:while(1){m=l;while(1){if((c[m+16>>2]|0)>=(g|0)){n=m;break}m=c[m+4>>2]|0;if(!m){o=b;break b}}l=c[n>>2]|0;if(!l){o=n;break}else b=n}if((o|0)!=(j|0)?(g|0)>=(c[o+16>>2]|0):0){c[e>>2]=1;h=o+20|0;i=f;return h|0}}c[e>>2]=4;h=658096;i=f;return h|0}function Bvd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[d>>2]|0;if((g|0)==-1){c[e>>2]=3;h=601008;i=f;return h|0}if(g>>>0>1073741823){c[e>>2]=2;h=(ync()|0)+((g&1073741823)<<6)+2724|0;i=f;return h|0}d=c[a+36>>2]|0;j=a+36|0;if(d){a=j;k=d;a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(g|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=a;break a}}k=c[l>>2]|0;if(!k){m=l;break}else a=l}if((m|0)!=(j|0)?(g|0)>=(c[m+16>>2]|0):0){c[e>>2]=0;h=m+20|0;i=f;return h|0}}m=c[b+56>>2]|0;j=b+56|0;if(m){b=j;l=m;b:while(1){m=l;while(1){if((c[m+16>>2]|0)>=(g|0)){n=m;break}m=c[m+4>>2]|0;if(!m){o=b;break b}}l=c[n>>2]|0;if(!l){o=n;break}else b=n}if((o|0)!=(j|0)?(g|0)>=(c[o+16>>2]|0):0){c[e>>2]=1;h=o+20|0;i=f;return h|0}}c[e>>2]=4;h=601008;i=f;return h|0}function Cvd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[d>>2]|0;if((g|0)==-1){c[e>>2]=3;h=658112;i=f;return h|0}d=c[a+72>>2]|0;j=a+72|0;if(d){a=j;k=d;a:while(1){d=k;while(1){if((c[d+16>>2]|0)>=(g|0)){l=d;break}d=c[d+4>>2]|0;if(!d){m=a;break a}}k=c[l>>2]|0;if(!k){m=l;break}else a=l}if(((m|0)!=(j|0)?(j=m+20|0,(g|0)>=(c[m+16>>2]|0)):0)?(c[j>>2]|0)!=0:0){c[e>>2]=0;h=j;i=f;return h|0}}j=c[b+92>>2]|0;m=b+92|0;if(j){b=m;l=j;b:while(1){j=l;while(1){if((c[j+16>>2]|0)>=(g|0)){n=j;break}j=c[j+4>>2]|0;if(!j){o=b;break b}}l=c[n>>2]|0;if(!l){o=n;break}else b=n}if(((o|0)!=(m|0)?(m=o+20|0,(g|0)>=(c[o+16>>2]|0)):0)?(c[m>>2]|0)!=0:0){c[e>>2]=1;h=m;i=f;return h|0}}c[e>>2]=4;h=658112;i=f;return h|0}function Dvd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=e+1|0;l=e+8|0;m=j;while(1){n=m+16|0;if(!(a[n>>0]&1))o=n+1|0;else o=c[m+24>>2]|0;if((Gsd((a[e>>0]&1)==0?k:c[l>>2]|0,o)|0)<0){p=c[m>>2]|0;if(!p){q=m;r=m;s=8;break}else{m=p;continue}}if(!(a[n>>0]&1))t=n+1|0;else t=c[m+24>>2]|0;if((Gsd(t,(a[e>>0]&1)==0?k:c[l>>2]|0)|0)>=0){u=m;s=15;break}n=m+4|0;p=c[n>>2]|0;if(!p){v=n;w=m;s=14;break}else m=p}if((s|0)==8){c[g>>2]=r;x=q;y=r;break}else if((s|0)==14){c[g>>2]=w;x=v;y=w;break}else if((s|0)==15){c[g>>2]=u;x=g;y=u;break}}else{m=d+4|0;c[g>>2]=m;x=m;y=m}while(0);g=c[x>>2]|0;if(g){z=0;A=g;c[b>>2]=A;B=b+4|0;a[B>>0]=z;i=f;return}g=xCi(32)|0;sri(g+16|0,e);c[g+28>>2]=c[e+12>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=y;c[x>>2]=g;y=c[c[d>>2]>>2]|0;if(!y)C=g;else{c[d>>2]=y;C=c[x>>2]|0}GN(c[h>>2]|0,C);C=d+8|0;c[C>>2]=(c[C>>2]|0)+1;z=1;A=g;c[b>>2]=A;B=b+4|0;a[B>>0]=z;i=f;return}function Evd(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+80|0;g=f+24|0;h=f+12|0;j=f;rri(h,3653512,0);rri(j,3653512,0);Hvd(g,b,h,j,-1,c,d,e);Ivd(f+72|0,a,g);rmd(g);xri(j);xri(h);i=f;return}function Fvd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=c[b>>2]|0;f=b+4|0;if((e|0)==(f|0)){i=d;return}g=b+8|0;h=b+4|0;j=e;while(1){e=j+16|0;k=c[j+4>>2]|0;l=(k|0)==0;a:do if(!(a[j+61>>0]|0)){if(l){m=j;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){o=n;break}else m=n}}else{m=k;while(1){n=c[m>>2]|0;if(!n){o=m;break}else m=n}}if(l){m=j;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){p=n;break}else m=n}}else{m=k;while(1){n=c[m>>2]|0;if(!n){p=m;break}else m=n}}if((c[b>>2]|0)==(j|0))c[b>>2]=p;c[g>>2]=(c[g>>2]|0)+-1;tYb(c[h>>2]|0,j);rmd(e);ACi(j);q=o}else{if(!l){m=k;while(1){n=c[m>>2]|0;if(!n){q=m;break a}else m=n}}m=j;while(1){n=c[m+8>>2]|0;if((c[n>>2]|0)==(m|0)){q=n;break}else m=n}}while(0);if((q|0)==(f|0))break;else j=q}i=d;return}function Gvd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[b>>2]|0;f=b+4|0;if((e|0)==(f|0)){g=0;i=d;return g|0}else h=e;while(1){if(!(a[h+60>>0]|0)){g=1;j=8;break}e=c[h+4>>2]|0;if(!e){b=h;while(1){k=c[b+8>>2]|0;if((c[k>>2]|0)==(b|0)){l=k;break}else b=k}}else{b=e;while(1){k=c[b>>2]|0;if(!k){l=b;break}else b=k}}if((l|0)==(f|0)){g=0;j=8;break}else h=l}if((j|0)==8){i=d;return g|0}return 0}function Hvd(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=i;i=i+16|0;m=l+4|0;n=l;o=a[d>>0]|0;if(!(o&1)){p=(o&255)>>>1;q=d+1|0}else{p=c[d+4>>2]|0;q=c[d+8>>2]|0}if(p>>>0>2147483631)ori(b);if(p>>>0<11){a[b>>0]=p<<1;r=b+1|0}else{d=p+16&-16;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];o=cOb(d,16,m,0,3653512,80)|0;c[b+8>>2]=o;c[b>>2]=d|1;c[b+4>>2]=p;r=o}YEi(r|0,q|0,p|0)|0;a[r+p>>0]=0;p=b+12|0;r=a[e>>0]|0;if(!(r&1)){s=(r&255)>>>1;t=e+1|0}else{s=c[e+4>>2]|0;t=c[e+8>>2]|0}if(s>>>0>2147483631)ori(p);if(s>>>0<11){a[p>>0]=s<<1;u=p+1|0}else{e=s+16&-16;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];r=cOb(e,16,m,0,3653512,80)|0;c[b+20>>2]=r;c[p>>2]=e|1;c[b+16>>2]=s;u=r}YEi(u|0,t|0,s|0)|0;a[u+s>>0]=0;s=b+24|0;u=a[f>>0]|0;if(!(u&1)){v=(u&255)>>>1;w=f+1|0}else{v=c[f+4>>2]|0;w=c[f+8>>2]|0}if(v>>>0>2147483631)ori(s);if(v>>>0<11){a[s>>0]=v<<1;x=s+1|0;YEi(x|0,w|0,v|0)|0;y=x+v|0;a[y>>0]=0;z=b+36|0;c[z>>2]=g;A=b+40|0;c[A>>2]=h;B=b+44|0;C=j&1;a[B>>0]=C;D=b+45|0;E=k&1;a[D>>0]=E;i=l;return}else{f=v+16&-16;c[n>>2]=58;c[m+0>>2]=c[n+0>>2];n=cOb(f,16,m,0,3653512,80)|0;c[b+32>>2]=n;c[s>>2]=f|1;c[b+28>>2]=v;x=n;YEi(x|0,w|0,v|0)|0;y=x+v|0;a[y>>0]=0;z=b+36|0;c[z>>2]=g;A=b+40|0;c[A>>2]=h;B=b+44|0;C=j&1;a[B>>0]=C;D=b+45|0;E=k&1;a[D>>0]=E;i=l;return}}function Ivd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=j;while(1){l=k+16|0;if(Jvd(e,l)|0){m=c[k>>2]|0;if(!m){n=k;o=k;p=4;break}else{k=m;continue}}if(!(Jvd(l,e)|0)){q=k;p=8;break}l=k+4|0;m=c[l>>2]|0;if(!m){r=l;s=k;p=7;break}else k=m}if((p|0)==4){c[g>>2]=o;t=n;u=o;break}else if((p|0)==7){c[g>>2]=s;t=r;u=s;break}else if((p|0)==8){c[g>>2]=q;t=g;u=q;break}}else{k=d+4|0;c[g>>2]=k;t=k;u=k}while(0);g=c[t>>2]|0;if(g){v=0;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}g=xCi(64)|0;Kvd(g+16|0,e);c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=u;c[t>>2]=g;u=c[c[d>>2]>>2]|0;if(!u)y=g;else{c[d>>2]=u;y=c[t>>2]|0}GN(c[h>>2]|0,y);y=d+8|0;c[y>>2]=(c[y>>2]|0)+1;v=1;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}function Jvd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;f=a[b+44>>0]|0;g=a[d+44>>0]|0;if(f<<24>>24!=g<<24>>24){h=(f&255)<(g&255);i=e;return h|0}g=b+24|0;f=d+24|0;j=a[g>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[b+28>>2]|0;m=a[f>>0]|0;n=(m&1)==0;if(n)o=(m&255)>>>1;else o=c[d+28>>2]|0;if((l|0)==(o|0)){if(k)p=g+1|0;else p=c[b+32>>2]|0;if(n)q=f+1|0;else q=c[d+32>>2]|0;if(k)r=(j&255)>>>1;else r=c[b+28>>2]|0;if(!(IEi(p,q,r)|0)){r=c[b+40>>2]|0;q=c[d+40>>2]|0;if((r|0)!=(q|0)){h=(r|0)<(q|0);i=e;return h|0}q=c[b+36>>2]|0;r=c[d+36>>2]|0;if((q|0)!=(r|0)){h=(q|0)<(r|0);i=e;return h|0}r=a[b>>0]|0;q=(r&1)==0;if(q)s=(r&255)>>>1;else s=c[b+4>>2]|0;r=a[d>>0]|0;p=(r&1)==0;if(p)t=(r&255)>>>1;else t=c[d+4>>2]|0;if(q)u=b+1|0;else u=c[b+8>>2]|0;if(p)v=d+1|0;else v=c[d+8>>2]|0;p=t>>>0<s>>>0;q=FEi(u,v,p?t:s)|0;if(!q)w=s>>>0<t>>>0?-1:p&1;else w=q;h=(w|0)<0;i=e;return h|0}}if(k)x=(j&255)>>>1;else x=c[b+28>>2]|0;if(n)y=(m&255)>>>1;else y=c[d+28>>2]|0;if(k)z=g+1|0;else z=c[b+32>>2]|0;if(n)A=f+1|0;else A=c[d+32>>2]|0;d=y>>>0<x>>>0;f=FEi(z,A,d?y:x)|0;if(!f)B=x>>>0<y>>>0?-1:d&1;else B=f;h=(B|0)<0;i=e;return h|0}function Kvd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+4|0;h=f;j=a[e>>0]|0;if(!(j&1)){k=(j&255)>>>1;l=e+1|0}else{k=c[e+4>>2]|0;l=c[e+8>>2]|0}if(k>>>0>2147483631)ori(d);if(k>>>0<11){a[d>>0]=k<<1;m=d+1|0}else{j=k+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];n=cOb(j,16,g,0,3653512,80)|0;c[d+8>>2]=n;c[d>>2]=j|1;c[d+4>>2]=k;m=n}YEi(m|0,l|0,k|0)|0;a[m+k>>0]=0;k=d+12|0;m=e+12|0;l=a[m>>0]|0;if(!(l&1)){o=(l&255)>>>1;p=m+1|0}else{o=c[e+16>>2]|0;p=c[e+20>>2]|0}if(o>>>0>2147483631)ori(k);if(o>>>0<11){a[k>>0]=o<<1;q=k+1|0}else{m=o+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];l=cOb(m,16,g,0,3653512,80)|0;c[d+20>>2]=l;c[k>>2]=m|1;c[d+16>>2]=o;q=l}YEi(q|0,p|0,o|0)|0;a[q+o>>0]=0;o=d+24|0;q=e+24|0;p=a[q>>0]|0;if(!(p&1)){r=(p&255)>>>1;s=q+1|0}else{r=c[e+28>>2]|0;s=c[e+32>>2]|0}if(r>>>0>2147483631)ori(o);if(r>>>0<11){a[o>>0]=r<<1;t=o+1|0;YEi(t|0,s|0,r|0)|0;u=t+r|0;a[u>>0]=0;v=d+36|0;w=e+36|0;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];b[v+8>>1]=b[w+8>>1]|0;i=f;return}else{q=r+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];h=cOb(q,16,g,0,3653512,80)|0;c[d+32>>2]=h;c[o>>2]=q|1;c[d+28>>2]=r;t=h;YEi(t|0,s|0,r|0)|0;u=t+r|0;a[u>>0]=0;v=d+36|0;w=e+36|0;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];b[v+8>>1]=b[w+8>>1]|0;i=f;return}}function Lvd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;j=i;i=i+64|0;k=j;l=j+48|0;m=j+32|0;n=j+16|0;o=j+8|0;p=j+4|0;if(!e?(q=c[d>>2]|0,r=d+4|0,s=c[r>>2]|0,(s|0)!=(q|0)):0)c[r>>2]=s+(~((s+-4-q|0)>>>2)<<2);c[o>>2]=c[153078];c[k+0>>2]=c[o+0>>2];o=bOb(112,k,0,16,3653512,73)|0;mtd(o);q=b+48|0;s=b+24|0;r=o+88|0;t=a[q>>0]|0;u=(t&1)==0;if(u)v=(t&255)>>>1;else v=c[b+52>>2]|0;a:do if(v){if(u)w=(t&255)>>>1;else w=c[b+52>>2]|0;x=a[s>>0]|0;y=(x&1)==0;if(y)z=(x&255)>>>1;else z=c[b+28>>2]|0;if((w|0)==(z|0)){if(u)A=q+1|0;else A=c[b+56>>2]|0;if(y)B=s+1|0;else B=c[b+32>>2]|0;if(u){if(w){y=w;x=A;C=B;while(1){if((a[x>>0]|0)!=(a[C>>0]|0)){D=26;break a}y=y+-1|0;if(!y)break;else{x=x+1|0;C=C+1|0}}}E=q+1|0}else{if(FEi(A,B,w)|0){D=26;break}E=c[b+56>>2]|0}c[k>>2]=E;Lsd(l,658440,k);Evd(f,l,0,1,0);xri(l)}else D=26}else D=26;while(0);if((D|0)==26)yri(r,q)|0;yri(o+76|0,b+36|0)|0;q=o+100|0;r=b+60|0;if((q|0)!=(r|0))Tvd(q,c[r>>2]|0,c[b+64>>2]|0);r=xCi(84)|0;c[r>>2]=575440;c[r+4>>2]=1;c[r>>2]=633304;q=r+12|0;c[q>>2]=0;c[r+16>>2]=0;c[r+8>>2]=q;q=r+24|0;c[q>>2]=0;c[r+28>>2]=0;c[r+20>>2]=q;q=r+36|0;c[q>>2]=0;c[r+40>>2]=0;c[r+32>>2]=q;q=r+48|0;c[q>>2]=0;E=r+52|0;c[E>>2]=0;w=r+44|0;c[w>>2]=q;B=r+60|0;c[B>>2]=0;c[r+64>>2]=0;c[r+56>>2]=B;B=r+72|0;c[B>>2]=0;c[r+76>>2]=0;c[r+68>>2]=B;c[r+80>>2]=0;B=b+4|0;A=c[b>>2]|0;b:do if((c[B>>2]|0)!=(A|0)){u=m+4|0;s=m+8|0;z=m+12|0;t=A;v=0;while(1){C=t+(v*76|0)|0;c[k>>2]=-1;if(!(a[C>>0]&1))F=C+1|0;else F=c[t+(v*76|0)+8>>2]|0;itd(k,F);c[l>>2]=c[k>>2];switch(c[t+(v*76|0)+36>>2]|0){case 4:{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;C=xCi(64)|0;fxd(C,t+(v*76|0)+60|0);c[n>>2]=C;jud(r,l,n,0);C=c[q>>2]|0;do if(C){x=c[l>>2]|0;y=C;while(1){G=c[y+16>>2]|0;if((x|0)<(G|0)){H=c[y>>2]|0;if(!H){I=y;J=y;D=45;break}else{y=H;continue}}if((G|0)>=(x|0)){K=y;D=49;break}G=y+4|0;H=c[G>>2]|0;if(!H){L=G;M=y;D=48;break}else y=H}if((D|0)==45){D=0;c[k>>2]=J;N=I;O=J;break}else if((D|0)==48){D=0;c[k>>2]=M;N=L;O=M;break}else if((D|0)==49){D=0;c[k>>2]=K;N=k;O=K;break}}else{c[k>>2]=q;N=q;O=q}while(0);C=c[N>>2]|0;if(!C){y=xCi(36)|0;c[y+16>>2]=c[l>>2];x=y+20|0;c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=O;c[N>>2]=y;x=c[c[w>>2]>>2]|0;if(!x)P=y;else{c[w>>2]=x;P=c[N>>2]|0}GN(c[q>>2]|0,P);c[E>>2]=(c[E>>2]|0)+1;Q=y}else Q=C;C=Q+20|0;c[C+0>>2]=c[n+0>>2];c[C+4>>2]=c[n+4>>2];c[C+8>>2]=c[n+8>>2];c[C+12>>2]=c[n+12>>2];break}case 3:case 2:{nud(r,l,ea(g[t+(v*76|0)+44>>2]));break}case 1:{D=39;break}case 0:{xud(r,l);D=39;break}default:{}}if((D|0)==39){D=0;g[m>>2]=ea(g[t+(v*76|0)+44>>2]);g[u>>2]=ea(g[t+(v*76|0)+48>>2]);g[s>>2]=ea(g[t+(v*76|0)+52>>2]);g[z>>2]=ea(g[t+(v*76|0)+56>>2]);oud(r,l,m)}v=v+1|0;t=c[b>>2]|0;if(v>>>0>=(((c[B>>2]|0)-t|0)/76|0)>>>0)break b}}while(0);c[o+72>>2]=r;r=b+16|0;B=b+12|0;m=(c[r>>2]|0)-(c[B>>2]|0)|0;l=m>>2;D=o+8|0;n=c[o>>2]|0;Q=n;if((c[D>>2]|0)-Q>>2>>>0<l>>>0){E=o+4|0;P=(c[E>>2]|0)-Q|0;if(!l)R=0;else R=xCi(m)|0;YEi(R|0,n|0,P|0)|0;c[o>>2]=R;c[E>>2]=R+(P>>2<<2);c[D>>2]=R+(l<<2);if(n)ACi(n)}n=c[B>>2]|0;if((c[r>>2]|0)==(n|0)){utd(o,b,h,d,e,f);wtd(o,d,e,f);i=j;return o|0}l=o+4|0;R=n;n=0;do{P=Mvd(c[R+(n<<2)>>2]|0,d,e,f,h)|0;c[p>>2]=P;do if(P){E=c[l>>2]|0;if((E|0)==(c[D>>2]|0)){ytd(o,p);break}if(!E)S=0;else{c[E>>2]=P;S=c[l>>2]|0}c[l>>2]=S+4}while(0);n=n+1|0;R=c[B>>2]|0}while(n>>>0<(c[r>>2]|0)-R>>2>>>0);utd(o,b,h,d,e,f);wtd(o,d,e,f);i=j;return o|0}function Mvd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;h=i;i=i+368|0;j=h+12|0;k=h+20|0;l=h+24|0;m=h+28|0;n=h;o=h+104|0;p=h+92|0;q=h+48|0;r=h+64|0;s=h+16|0;t=h+40|0;u=h+76|0;v=h+88|0;c[s>>2]=c[153078];c[j+0>>2]=c[s+0>>2];s=bOb(56,j,0,16,3653512,149)|0;Xwd(s);w=b+4|0;x=(c[w>>2]|0)-(c[b>>2]|0)|0;y=x>>2;z=s+12|0;A=c[z>>2]|0;do if((A&2147483647)>>>0<y>>>0)if((A|0)>-1){c[z>>2]=y;B=c[s>>2]|0;c[k>>2]=c[s+4>>2];c[j+0>>2]=c[k+0>>2];c[s>>2]=hOb(B,x,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[s+4>>2];c[j+0>>2]=c[k+0>>2];B=cOb(x,4,j,0,3653512,352)|0;YEi(B|0,c[s>>2]|0,c[s+8>>2]<<2|0)|0;c[z>>2]=y;c[s>>2]=B;break}while(0);y=c[b>>2]|0;a:do if((c[w>>2]|0)!=(y|0)){z=s+16|0;x=s+8|0;A=u+1|0;B=n+1|0;C=n+4|0;D=n+8|0;E=u+8|0;F=u+4|0;G=q+8|0;H=q+12|0;I=q+4|0;J=r+8|0;K=r+4|0;L=r+1|0;M=y;N=0;while(1){O=c[M+(N<<2)>>2]|0;P=c[O+4>>2]|0;if((P|0)==2){c[v>>2]=Ovd(O)|0;Uvd(s,v);c[z>>2]=(c[z>>2]|0)+1}else if((P|0)==1){Q=c[x>>2]|0;R=O+8|0;if(!(a[R>>0]&1))S=R+1|0;else S=c[O+16>>2]|0;rri(u,S,SEi(S|0)|0);R=a[u>>0]|0;T=(R&1)==0;U=T?A:c[E>>2]|0;V=0;W=U;while(1){X=a[W>>0]|0;if(!(X<<24>>24)){Y=V;break}else if(X<<24>>24==47)Z=W;else Z=V;V=Z;W=W+1|0}if((Y|0)==0|(Y|0)==(U|0)){c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;if(T)_=(R&255)>>>1;else _=c[F>>2]|0;Pri(n,658384,53,_+53|0);Gri(n,(a[u>>0]&1)==0?A:c[E>>2]|0,_)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;W=a[n>>0]|0;if(!(W&1)){$=(W&255)>>>1;aa=B}else{$=c[C>>2]|0;aa=c[D>>2]|0}Pri(m,aa,$,$+1|0);Fri(m,39);Evd(f,m,-1,0,0);xri(m);xri(n)}else{W=Y-U|0;UEi(o|0,U|0,W|0)|0;a[o+W>>0]=0;rri(p,o,SEi(o|0)|0);W=Ymd(p,d,e)|0;if(W){c[q>>2]=0;c[G>>2]=0;c[H>>2]=0;c[I>>2]=60;V=c[c[c[W+52>>2]>>2]>>2]|0;W=Y+1|0;X=SEi(W|0)|0;if(X>>>0>2147483631){ba=26;break}if(X>>>0<11){a[r>>0]=X<<1;ca=L}else{da=X+16&-16;c[k>>2]=58;c[j+0>>2]=c[k+0>>2];ea=cOb(da,16,j,0,3653512,80)|0;c[J>>2]=ea;c[r>>2]=da|1;c[K>>2]=X;ca=ea}YEi(ca|0,W|0,X|0)|0;a[ca+X>>0]=0;$wd(V,r,q);if(a[r>>0]&1){V=c[J>>2]|0;c[l>>2]=58;c[j+0>>2]=c[l+0>>2];eOb(V,j)}if(c[G>>2]|0){V=0;do{Uvd(s,(c[q>>2]|0)+(V<<2)|0);V=V+1|0}while(V>>>0<(c[G>>2]|0)>>>0)}if((c[H>>2]|0)>-1){V=c[q>>2]|0;c[k>>2]=c[I>>2];c[j+0>>2]=c[k+0>>2];eOb(V,j);c[q>>2]=0}}xri(p)}xri(u);V=c[x>>2]|0;c[z>>2]=V-Q+(c[z>>2]|0);if((V|0)==(Q|0))break}else if(!P){c[t>>2]=Nvd(O,0,g)|0;Uvd(s,t);c[z>>2]=(c[z>>2]|0)+1}N=N+1|0;M=c[b>>2]|0;if(N>>>0>=(c[w>>2]|0)-M>>2>>>0)break a}if((ba|0)==26)ori(r);M=c[153078]|0;if(s)_wd(s);c[k>>2]=M;c[j+0>>2]=c[k+0>>2];eOb(s,j);fa=0;i=h;return fa|0}while(0);r=s+20|0;ba=c[b+12>>2]|0;w=b+16|0;t=s+24|0;if((ba|0)!=(w|0)){g=s+28|0;u=ba;while(1){ba=u+16|0;p=c[ba>>2]|0;q=c[ba+4>>2]|0;ba=n;c[ba>>2]=p;c[ba+4>>2]=q;c[m>>2]=t;c[j+0>>2]=c[m+0>>2];ba=bvd(r,j,k,n)|0;if(!(c[ba>>2]|0)){l=xCi(24)|0;ca=l+16|0;c[ca>>2]=p;c[ca+4>>2]=q;q=c[k>>2]|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=q;c[ba>>2]=l;q=c[c[r>>2]>>2]|0;if(!q)ga=l;else{c[r>>2]=q;ga=c[ba>>2]|0}GN(c[t>>2]|0,ga);c[g>>2]=(c[g>>2]|0)+1}ba=c[u+4>>2]|0;if(!ba){q=u;while(1){l=c[q+8>>2]|0;if((c[l>>2]|0)==(q|0)){ha=l;break}else q=l}}else{q=ba;while(1){l=c[q>>2]|0;if(!l){ha=q;break}else q=l}}if((ha|0)==(w|0))break;else u=ha}}c[s+32>>2]=c[b+24>>2];fa=s;i=h;return fa|0}function Nvd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;d=i;i=i+80|0;f=d+32|0;h=d+16|0;j=d+36|0;l=d;m=d+28|0;n=d+20|0;o=d+24|0;p=d+12|0;q=d+68|0;r=d+40|0;s=d+44|0;t=d+48|0;u=d+52|0;v=d+56|0;w=d+60|0;x=d+64|0;y=d+8|0;c[y>>2]=c[153078];c[f+0>>2]=c[y+0>>2];y=bOb(696,f,0,16,3653512,354)|0;ztd(y,0);z=y+680|0;A=c[z>>2]|0;B=y+684|0;C=c[B>>2]|0;if((C|0)!=(A|0))c[B>>2]=C+(~((C+-4-A|0)>>>2)<<2);A=y+692|0;c[A>>2]=0;C=y+4|0;D=b+8|0;Pvd(C,D,z);E=y+592|0;F=0;do{a[E+F+8>>0]=c[b+(F<<2)+528>>2];F=F+1|0}while((F|0)!=28);c[y+596>>2]=c[b+644>>2];c[E>>2]=c[b+640>>2];E=y+664|0;F=c[b+648>>2]|0;G=b+652|0;H=y+668|0;if((F|0)!=(G|0)){I=y+672|0;J=F;while(1){F=J+16|0;K=c[F>>2]|0;L=c[F+4>>2]|0;F=l;c[F>>2]=K;c[F+4>>2]=L;c[j>>2]=H;c[f+0>>2]=c[j+0>>2];F=bvd(E,f,h,l)|0;if(!(c[F>>2]|0)){M=xCi(24)|0;N=M+16|0;c[N>>2]=K;c[N+4>>2]=L;L=c[h>>2]|0;c[M>>2]=0;c[M+4>>2]=0;c[M+8>>2]=L;c[F>>2]=M;L=c[c[E>>2]>>2]|0;if(!L)O=M;else{c[E>>2]=L;O=c[F>>2]|0}GN(c[H>>2]|0,O);c[I>>2]=(c[I>>2]|0)+1}F=c[J+4>>2]|0;if(!F){L=J;while(1){M=c[L+8>>2]|0;if((c[M>>2]|0)==(L|0)){P=M;break}else L=M}}else{L=F;while(1){M=c[L>>2]|0;if(!M){P=L;break}else L=M}}if((P|0)==(G|0))break;else J=P}}P=y+628|0;do if((P|0)!=(D|0)){J=a[D>>0]|0;if(!(J&1)){Q=(J&255)>>>1;R=D+1|0}else{Q=c[b+12>>2]|0;R=c[b+16>>2]|0}J=a[P>>0]|0;if(!(J&1)){S=10;T=J}else{J=c[P>>2]|0;S=(J&-2)+-1|0;T=J&255}J=(T&1)==0;if(Q>>>0>S>>>0){if(J)U=(T&255)>>>1;else U=c[y+632>>2]|0;eXb(P,S,Q-S|0,U,0,U,Q,R);break}if(J)V=y+629|0;else V=c[y+636>>2]|0;aFi(V|0,R|0,Q|0)|0;a[V+Q>>0]=0;if(!(a[P>>0]&1)){a[P>>0]=Q<<1;break}else{c[y+632>>2]=Q;break}}while(0);Q=b+520|0;P=0;do{V=c[b+(P<<2)+676>>2]|0;if((V|0)!=0?(R=Qvd(V,P,c[Q>>2]|0,z,e)|0,jwd(C,P,R,e),V=R+4|0,c[V>>2]=(c[V>>2]|0)+-1,!((c[V>>2]|0)!=0|(R|0)==0)):0)ko[c[(c[R>>2]|0)+4>>2]&4095](R);P=P+1|0}while((P|0)!=6);kwd(C,e);e=c[b+668>>2]|0;C=b+664|0;b=c[C>>2]|0;P=(e-b|0)/52|0;c[y+644>>2]=P;Q=zCi(P>>>0>82595524?-1:P*52|0)|0;R=(e|0)==(b|0);if(R){c[y+648>>2]=Q;i=d;return y|0}e=Q+(P*52|0)|0;V=Q;do{c[V+4>>2]=16842752;c[V+8>>2]=17104900;c[V>>2]=-1;c[V+44>>2]=-1;c[V+16>>2]=-1;g[V+12>>2]=ea(0.0);c[V+24>>2]=-1;g[V+20>>2]=ea(0.0);c[V+32>>2]=-1;g[V+28>>2]=ea(0.0);c[V+40>>2]=-1;g[V+36>>2]=ea(0.0);a[V+48>>0]=0;a[V+49>>0]=0;V=V+52|0}while((V|0)!=(e|0));e=y+648|0;c[e>>2]=Q;if(R){i=d;return y|0}R=b;b=Q;Q=0;while(1){V=R+(Q*52|0)|0;c[b+(Q*52|0)>>2]=c[V>>2];U=c[V>>2]|0;V=(U|0)!=-1;do if(!(V&U>>>0>1073741823|V^1)){c[o>>2]=U;S=c[z>>2]|0;T=c[B>>2]|0;D=T-S>>2;if(!D)W=S;else{J=S;S=D;while(1){D=(S|0)/2|0;if((c[J+(D<<2)>>2]|0)<(U|0)){X=J+(D+1<<2)|0;Y=S+-1-D|0}else{X=J;Y=D}if(!Y){W=X;break}else{J=X;S=Y}}}if((W|0)!=(T|0)?(U|0)>=(c[W>>2]|0):0)break;c[n>>2]=W;c[f+0>>2]=c[n+0>>2];drc(m,z,f,o);c[A>>2]=~~ea(ea((c[A>>2]|0)>>>0)+ea(12.0))>>>0}while(0);c[b+(Q*52|0)+4>>2]=c[R+(Q*52|0)+4>>2];c[b+(Q*52|0)+8>>2]=c[R+(Q*52|0)+8>>2];do if(a[R+(Q*52|0)+48>>0]|0){U=R+(Q*52|0)+44|0;V=c[U>>2]|0;if((V|0)==-1){S=c[R+(Q*52|0)+16>>2]|0;if((S|0)==-1){Z=ea(g[R+(Q*52|0)+12>>2]);_=(g[k>>2]=Z,c[k>>2]|0);$=0;aa=-1}else{_=0;$=0;aa=S}S=c[R+(Q*52|0)+24>>2]|0;if((S|0)==-1){Z=ea(g[R+(Q*52|0)+20>>2]);ba=(g[k>>2]=Z,c[k>>2]|0);ca=0;da=-1}else{ba=0;ca=0;da=S}S=c[R+(Q*52|0)+32>>2]|0;if((S|0)==-1){Z=ea(g[R+(Q*52|0)+28>>2]);fa=(g[k>>2]=Z,c[k>>2]|0);ga=0;ha=-1}else{fa=0;ga=0;ha=S}S=c[R+(Q*52|0)+40>>2]|0;if((S|0)==-1){Z=ea(g[R+(Q*52|0)+36>>2]);ia=(g[k>>2]=Z,c[k>>2]|0);ja=0;ka=-1}else{ia=0;ja=0;ka=S}la=0;ma=_;na=aa;oa=$;pa=0;qa=ba;ra=da;sa=ca;ta=0;ua=fa;va=ha;wa=ga;xa=0;ya=ia;za=ka;Aa=ja;Ba=-1}else{la=0;ma=0;na=-1;oa=0;pa=0;qa=0;ra=-1;sa=0;ta=0;ua=0;va=-1;wa=0;xa=0;ya=0;za=-1;Aa=0;Ba=V}V=b+(Q*52|0)+12|0;c[V>>2]=la|ma;c[V+4>>2]=na|oa;V=b+(Q*52|0)+20|0;c[V>>2]=pa|qa;c[V+4>>2]=ra|sa;V=b+(Q*52|0)+28|0;c[V>>2]=ta|ua;c[V+4>>2]=va|wa;V=b+(Q*52|0)+36|0;c[V>>2]=xa|ya;c[V+4>>2]=za|Aa;c[b+(Q*52|0)+44>>2]=Ba;a[b+(Q*52|0)+48>>0]=1;V=c[U>>2]|0;if((V|0)!=-1){if(V>>>0>1073741823)break;c[r>>2]=V;U=c[z>>2]|0;S=c[B>>2]|0;J=S-U>>2;if(!J)Ca=U;else{D=U;U=J;while(1){J=(U|0)/2|0;if((c[D+(J<<2)>>2]|0)<(V|0)){Da=D+(J+1<<2)|0;Ea=U+-1-J|0}else{Da=D;Ea=J}if(!Ea){Ca=Da;break}else{D=Da;U=Ea}}}if((Ca|0)!=(S|0)?(V|0)>=(c[Ca>>2]|0):0)break;c[q>>2]=Ca;c[f+0>>2]=c[q+0>>2];drc(p,z,f,r);c[A>>2]=~~ea(ea((c[A>>2]|0)>>>0)+ea(16.0))>>>0;break}U=c[R+(Q*52|0)+16>>2]|0;D=(U|0)!=-1;do if(!(D&U>>>0>1073741823|D^1)){c[o>>2]=U;T=c[z>>2]|0;J=c[B>>2]|0;G=J-T>>2;if(!G)Fa=T;else{I=T;T=G;while(1){G=(T|0)/2|0;if((c[I+(G<<2)>>2]|0)<(U|0)){Ga=I+(G+1<<2)|0;Ha=T+-1-G|0}else{Ga=I;Ha=G}if(!Ha){Fa=Ga;break}else{I=Ga;T=Ha}}}if((Fa|0)!=(J|0)?(U|0)>=(c[Fa>>2]|0):0)break;c[t>>2]=Fa;c[f+0>>2]=c[t+0>>2];drc(s,z,f,o);c[A>>2]=~~ea(ea((c[A>>2]|0)>>>0)+ea(4.0))>>>0}while(0);U=c[R+(Q*52|0)+24>>2]|0;D=(U|0)!=-1;do if(!(D&U>>>0>1073741823|D^1)){c[o>>2]=U;V=c[z>>2]|0;S=c[B>>2]|0;T=S-V>>2;if(!T)Ia=V;else{I=V;V=T;while(1){T=(V|0)/2|0;if((c[I+(T<<2)>>2]|0)<(U|0)){Ja=I+(T+1<<2)|0;Ka=V+-1-T|0}else{Ja=I;Ka=T}if(!Ka){Ia=Ja;break}else{I=Ja;V=Ka}}}if((Ia|0)!=(S|0)?(U|0)>=(c[Ia>>2]|0):0)break;c[v>>2]=Ia;c[f+0>>2]=c[v+0>>2];drc(u,z,f,o);c[A>>2]=~~ea(ea((c[A>>2]|0)>>>0)+ea(4.0))>>>0}while(0);U=c[R+(Q*52|0)+32>>2]|0;D=(U|0)!=-1;do if(!(D&U>>>0>1073741823|D^1)){c[o>>2]=U;V=c[z>>2]|0;I=c[B>>2]|0;J=I-V>>2;if(!J)La=V;else{T=V;V=J;while(1){J=(V|0)/2|0;if((c[T+(J<<2)>>2]|0)<(U|0)){Ma=T+(J+1<<2)|0;Na=V+-1-J|0}else{Ma=T;Na=J}if(!Na){La=Ma;break}else{T=Ma;V=Na}}}if((La|0)!=(I|0)?(U|0)>=(c[La>>2]|0):0)break;c[x>>2]=La;c[f+0>>2]=c[x+0>>2];drc(w,z,f,o);c[A>>2]=~~ea(ea((c[A>>2]|0)>>>0)+ea(4.0))>>>0}while(0);U=c[R+(Q*52|0)+40>>2]|0;D=(U|0)!=-1;if(!(D&U>>>0>1073741823|D^1)){c[l>>2]=U;D=c[z>>2]|0;V=c[B>>2]|0;T=V-D>>2;if(!T)Oa=D;else{S=D;D=T;while(1){T=(D|0)/2|0;if((c[S+(T<<2)>>2]|0)<(U|0)){Pa=S+(T+1<<2)|0;Qa=D+-1-T|0}else{Pa=S;Qa=T}if(!Qa){Oa=Pa;break}else{S=Pa;D=Qa}}}if((Oa|0)!=(V|0)?(U|0)>=(c[Oa>>2]|0):0)break;c[j>>2]=Oa;c[f+0>>2]=c[j+0>>2];drc(h,z,f,l);c[A>>2]=~~ea(ea((c[A>>2]|0)>>>0)+ea(4.0))>>>0}}while(0);a[b+(Q*52|0)+49>>0]=a[R+(Q*52|0)+49>>0]|0;D=Q+1|0;if(D>>>0>=P>>>0)break;R=c[C>>2]|0;b=c[e>>2]|0;Q=D}i=d;return y|0}function Ovd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d;j=d+8|0;c[j>>2]=c[153078];c[e+0>>2]=c[j+0>>2];j=bOb(696,e,0,16,3653512,401)|0;ztd(j,2);k=j+628|0;l=b+8|0;do if((k|0)!=(l|0)){m=a[l>>0]|0;if(!(m&1)){n=(m&255)>>>1;o=l+1|0}else{n=c[b+12>>2]|0;o=c[b+16>>2]|0}m=a[k>>0]|0;if(!(m&1)){p=10;q=m}else{m=c[k>>2]|0;p=(m&-2)+-1|0;q=m&255}m=(q&1)==0;if(n>>>0>p>>>0){if(m)r=(q&255)>>>1;else r=c[j+632>>2]|0;eXb(k,p,n-p|0,r,0,r,n,o);break}if(m)s=j+629|0;else s=c[j+636>>2]|0;aFi(s|0,o|0,n|0)|0;a[s+n>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=n<<1;break}else{c[j+632>>2]=n;break}}while(0);n=j+664|0;k=c[b+32>>2]|0;s=b+36|0;o=j+668|0;if((k|0)!=(s|0)){r=j+672|0;p=k;while(1){k=p+16|0;q=c[k>>2]|0;l=c[k+4>>2]|0;k=h;c[k>>2]=q;c[k+4>>2]=l;c[g>>2]=o;c[e+0>>2]=c[g+0>>2];k=bvd(n,e,f,h)|0;if(!(c[k>>2]|0)){m=xCi(24)|0;t=m+16|0;c[t>>2]=q;c[t+4>>2]=l;l=c[f>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=l;c[k>>2]=m;l=c[c[n>>2]>>2]|0;if(!l)u=m;else{c[n>>2]=l;u=c[k>>2]|0}GN(c[o>>2]|0,u);c[r>>2]=(c[r>>2]|0)+1}k=c[p+4>>2]|0;if(!k){l=p;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){v=m;break}else l=m}}else{l=k;while(1){m=c[l>>2]|0;if(!m){v=l;break}else l=m}}if((v|0)==(s|0))break;else p=v}}v=b+20|0;p=a[v>>0]|0;s=(p&1)==0;if(s)w=(p&255)>>>1;else w=c[b+24>>2]|0;if(!w){i=d;return j|0}if(s)x=v+1|0;else x=c[b+28>>2]|0;itd(j+676|0,x);i=d;return j|0}function Pvd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=Im,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=Im,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0;f=i;i=i+368|0;h=f+168|0;j=f+164|0;l=f+4|0;m=f+8|0;n=f+12|0;o=f+332|0;p=f+340|0;q=f+160|0;r=f+28|0;s=f+32|0;t=f+36|0;u=f+40|0;v=f+44|0;w=f+48|0;x=f+52|0;y=f+56|0;z=f+60|0;A=f+64|0;B=f+68|0;C=f+72|0;D=f+76|0;E=f+80|0;F=f+84|0;G=f+88|0;H=f+92|0;I=f+96|0;J=f+100|0;K=f+104|0;L=f+108|0;M=f+112|0;N=f+116|0;O=f+120|0;P=f+124|0;Q=f+128|0;R=f+132|0;S=f+136|0;T=f+140|0;U=f+304|0;V=f+312|0;W=f+320|0;X=f+328|0;Y=f+336|0;Z=f+344|0;_=f+348|0;$=f+180|0;aa=f+184|0;ba=f+188|0;ca=f+192|0;da=f+196|0;fa=f+200|0;ga=f+204|0;ha=f+208|0;ia=f+212|0;ja=f+216|0;ka=f+220|0;la=f+224|0;ma=f+228|0;na=f+232|0;oa=f+236|0;pa=f+240|0;qa=f+244|0;ra=f+248|0;sa=f+252|0;ta=f+256|0;ua=f+260|0;va=f+264|0;wa=f+268|0;xa=f+272|0;ya=f+276|0;za=f+280|0;Aa=f+284|0;Ba=f+288|0;Ca=f+292|0;Da=f+296|0;Ea=f+20|0;Fa=f;Ga=f+144|0;Ha=f+148|0;Ia=f+308|0;Ja=f+24|0;Ka=f+152|0;La=f+316|0;Ma=f+156|0;Na=f+324|0;Oa=f+300|0;Pa=f+16|0;Qa=d+48|0;Ra=c[Qa>>2]|0;if((Ra|0)==-1){Sa=ea(g[d+44>>2]);Ta=-1;Ua=0;Va=(g[k>>2]=Sa,c[k>>2]|0)}else{Ta=Ra;Ua=0;Va=0}Ra=b+24|0;c[Ra>>2]=Va;c[Ra+4>>2]=Ta|Ua;Ua=c[Qa>>2]|0;Qa=(Ua|0)!=-1;do if(!(Qa&Ua>>>0>1073741823|Qa^1)){c[j>>2]=Ua;Ta=c[e>>2]|0;Ra=c[e+4>>2]|0;Va=Ra-Ta>>2;if(!Va)Wa=Ta;else{Xa=Ta;Ta=Va;while(1){Va=(Ta|0)/2|0;if((c[Xa+(Va<<2)>>2]|0)<(Ua|0)){Ya=Xa+(Va+1<<2)|0;Za=Ta+-1-Va|0}else{Ya=Xa;Za=Va}if(!Za){Wa=Ya;break}else{Xa=Ya;Ta=Za}}}if((Wa|0)!=(Ra|0)?(Ua|0)>=(c[Wa>>2]|0):0)break;c[Na>>2]=Wa;c[h+0>>2]=c[Na+0>>2];drc(Ma,e,h,j);Ta=e+12|0;c[Ta>>2]=~~ea(ea((c[Ta>>2]|0)>>>0)+ea(4.0))>>>0}while(0);a[b+220>>0]=a[d+76>>0]|0;Ma=b+32|0;Na=d+176|0;Wa=c[Na>>2]|0;if((Wa|0)==-1){Ua=c[d+148>>2]|0;if((Ua|0)==-1){Sa=ea(g[d+144>>2]);_a=(g[k>>2]=Sa,c[k>>2]|0);$a=0;ab=-1}else{_a=0;$a=0;ab=Ua}Ua=c[d+156>>2]|0;if((Ua|0)==-1){Sa=ea(g[d+152>>2]);bb=(g[k>>2]=Sa,c[k>>2]|0);cb=0;db=-1}else{bb=0;cb=0;db=Ua}Ua=c[d+164>>2]|0;if((Ua|0)==-1){Sa=ea(g[d+160>>2]);eb=(g[k>>2]=Sa,c[k>>2]|0);fb=0;gb=-1}else{eb=0;fb=0;gb=Ua}Ua=c[d+172>>2]|0;if((Ua|0)==-1){Sa=ea(g[d+168>>2]);hb=(g[k>>2]=Sa,c[k>>2]|0);ib=0;jb=-1}else{hb=0;ib=0;jb=Ua}kb=0;lb=_a;mb=ab;nb=$a;ob=0;pb=bb;qb=db;rb=cb;sb=0;tb=eb;ub=gb;vb=fb;wb=0;xb=hb;yb=jb;zb=ib;Ab=-1}else{kb=0;lb=0;mb=-1;nb=0;ob=0;pb=0;qb=-1;rb=0;sb=0;tb=0;ub=-1;vb=0;wb=0;xb=0;yb=-1;zb=0;Ab=Wa}Wa=Ma;c[Wa>>2]=kb|lb;c[Wa+4>>2]=mb|nb;nb=b+40|0;c[nb>>2]=ob|pb;c[nb+4>>2]=qb|rb;rb=b+48|0;c[rb>>2]=sb|tb;c[rb+4>>2]=ub|vb;vb=b+56|0;c[vb>>2]=wb|xb;c[vb+4>>2]=yb|zb;c[b+64>>2]=Ab;Ab=c[Na>>2]|0;do if((Ab|0)==-1){Na=c[d+148>>2]|0;zb=(Na|0)!=-1;do if(!(zb&Na>>>0>1073741823|zb^1)){c[j>>2]=Na;yb=c[e>>2]|0;vb=c[e+4>>2]|0;xb=vb-yb>>2;if(!xb)Bb=yb;else{wb=yb;yb=xb;while(1){xb=(yb|0)/2|0;if((c[wb+(xb<<2)>>2]|0)<(Na|0)){Cb=wb+(xb+1<<2)|0;Db=yb+-1-xb|0}else{Cb=wb;Db=xb}if(!Db){Bb=Cb;break}else{wb=Cb;yb=Db}}}if((Bb|0)!=(vb|0)?(Na|0)>=(c[Bb>>2]|0):0)break;c[J>>2]=Bb;c[h+0>>2]=c[J+0>>2];drc(I,e,h,j);yb=e+12|0;c[yb>>2]=~~ea(ea((c[yb>>2]|0)>>>0)+ea(4.0))>>>0}while(0);Na=c[d+156>>2]|0;zb=(Na|0)!=-1;do if(!(zb&Na>>>0>1073741823|zb^1)){c[j>>2]=Na;Ra=c[e>>2]|0;yb=c[e+4>>2]|0;wb=yb-Ra>>2;if(!wb)Eb=Ra;else{xb=Ra;Ra=wb;while(1){wb=(Ra|0)/2|0;if((c[xb+(wb<<2)>>2]|0)<(Na|0)){Fb=xb+(wb+1<<2)|0;Gb=Ra+-1-wb|0}else{Fb=xb;Gb=wb}if(!Gb){Eb=Fb;break}else{xb=Fb;Ra=Gb}}}if((Eb|0)!=(yb|0)?(Na|0)>=(c[Eb>>2]|0):0)break;c[Ja>>2]=Eb;c[h+0>>2]=c[Ja+0>>2];drc(Ia,e,h,j);Ra=e+12|0;c[Ra>>2]=~~ea(ea((c[Ra>>2]|0)>>>0)+ea(4.0))>>>0}while(0);Na=c[d+164>>2]|0;zb=(Na|0)!=-1;do if(!(zb&Na>>>0>1073741823|zb^1)){c[j>>2]=Na;Ra=c[e>>2]|0;xb=c[e+4>>2]|0;vb=xb-Ra>>2;if(!vb)Hb=Ra;else{wb=Ra;Ra=vb;while(1){vb=(Ra|0)/2|0;if((c[wb+(vb<<2)>>2]|0)<(Na|0)){Ib=wb+(vb+1<<2)|0;Jb=Ra+-1-vb|0}else{Ib=wb;Jb=vb}if(!Jb){Hb=Ib;break}else{wb=Ib;Ra=Jb}}}if((Hb|0)!=(xb|0)?(Na|0)>=(c[Hb>>2]|0):0)break;c[La>>2]=Hb;c[h+0>>2]=c[La+0>>2];drc(Ka,e,h,j);Ra=e+12|0;c[Ra>>2]=~~ea(ea((c[Ra>>2]|0)>>>0)+ea(4.0))>>>0}while(0);Na=c[d+172>>2]|0;zb=(Na|0)!=-1;if(!(zb&Na>>>0>1073741823|zb^1)){c[P>>2]=Na;zb=c[e>>2]|0;Ra=c[e+4>>2]|0;wb=Ra-zb>>2;if(!wb)Kb=zb;else{yb=zb;zb=wb;while(1){wb=(zb|0)/2|0;if((c[yb+(wb<<2)>>2]|0)<(Na|0)){Lb=yb+(wb+1<<2)|0;Mb=zb+-1-wb|0}else{Lb=yb;Mb=wb}if(!Mb){Kb=Lb;break}else{yb=Lb;zb=Mb}}}if((Kb|0)!=(Ra|0)?(Na|0)>=(c[Kb>>2]|0):0)break;c[O>>2]=Kb;c[h+0>>2]=c[O+0>>2];drc(N,e,h,P);zb=e+12|0;c[zb>>2]=~~ea(ea((c[zb>>2]|0)>>>0)+ea(4.0))>>>0}}else if(Ab>>>0<=1073741823){c[M>>2]=Ab;zb=c[e>>2]|0;yb=c[e+4>>2]|0;wb=yb-zb>>2;if(!wb)Nb=zb;else{vb=zb;zb=wb;while(1){wb=(zb|0)/2|0;if((c[vb+(wb<<2)>>2]|0)<(Ab|0)){Ob=vb+(wb+1<<2)|0;Pb=zb+-1-wb|0}else{Ob=vb;Pb=wb}if(!Pb){Nb=Ob;break}else{vb=Ob;zb=Pb}}}if((Nb|0)!=(yb|0)?(Ab|0)>=(c[Nb>>2]|0):0)break;c[L>>2]=Nb;c[h+0>>2]=c[L+0>>2];drc(K,e,h,M);zb=e+12|0;c[zb>>2]=~~ea(ea((c[zb>>2]|0)>>>0)+ea(16.0))>>>0}while(0);M=b+68|0;K=d+212|0;L=c[K>>2]|0;if((L|0)==-1){Nb=c[d+184>>2]|0;if((Nb|0)==-1){Sa=ea(g[d+180>>2]);Qb=(g[k>>2]=Sa,c[k>>2]|0);Rb=0;Sb=-1}else{Qb=0;Rb=0;Sb=Nb}Nb=c[d+192>>2]|0;if((Nb|0)==-1){Sa=ea(g[d+188>>2]);Tb=(g[k>>2]=Sa,c[k>>2]|0);Ub=0;Vb=-1}else{Tb=0;Ub=0;Vb=Nb}Nb=c[d+200>>2]|0;if((Nb|0)==-1){Sa=ea(g[d+196>>2]);Wb=(g[k>>2]=Sa,c[k>>2]|0);Xb=0;Yb=-1}else{Wb=0;Xb=0;Yb=Nb}Nb=c[d+208>>2]|0;if((Nb|0)==-1){Sa=ea(g[d+204>>2]);Zb=(g[k>>2]=Sa,c[k>>2]|0);_b=0;$b=-1}else{Zb=0;_b=0;$b=Nb}ac=0;bc=Qb;cc=Sb;dc=Rb;ec=0;fc=Tb;gc=Vb;hc=Ub;ic=0;jc=Wb;kc=Yb;lc=Xb;mc=0;nc=Zb;oc=$b;pc=_b;qc=-1}else{ac=0;bc=0;cc=-1;dc=0;ec=0;fc=0;gc=-1;hc=0;ic=0;jc=0;kc=-1;lc=0;mc=0;nc=0;oc=-1;pc=0;qc=L}L=M;c[L>>2]=ac|bc;c[L+4>>2]=cc|dc;dc=b+76|0;c[dc>>2]=ec|fc;c[dc+4>>2]=gc|hc;hc=b+84|0;c[hc>>2]=ic|jc;c[hc+4>>2]=kc|lc;lc=b+92|0;c[lc>>2]=mc|nc;c[lc+4>>2]=oc|pc;c[b+100>>2]=qc;qc=c[K>>2]|0;do if((qc|0)==-1){K=c[d+184>>2]|0;pc=(K|0)!=-1;do if(!(pc&K>>>0>1073741823|pc^1)){c[j>>2]=K;oc=c[e>>2]|0;lc=c[e+4>>2]|0;nc=lc-oc>>2;if(!nc)rc=oc;else{mc=oc;oc=nc;while(1){nc=(oc|0)/2|0;if((c[mc+(nc<<2)>>2]|0)<(K|0)){sc=mc+(nc+1<<2)|0;tc=oc+-1-nc|0}else{sc=mc;tc=nc}if(!tc){rc=sc;break}else{mc=sc;oc=tc}}}if((rc|0)!=(lc|0)?(K|0)>=(c[rc>>2]|0):0)break;c[B>>2]=rc;c[h+0>>2]=c[B+0>>2];drc(A,e,h,j);oc=e+12|0;c[oc>>2]=~~ea(ea((c[oc>>2]|0)>>>0)+ea(4.0))>>>0}while(0);K=c[d+192>>2]|0;pc=(K|0)!=-1;do if(!(pc&K>>>0>1073741823|pc^1)){c[j>>2]=K;yb=c[e>>2]|0;oc=c[e+4>>2]|0;mc=oc-yb>>2;if(!mc)uc=yb;else{xb=yb;yb=mc;while(1){mc=(yb|0)/2|0;if((c[xb+(mc<<2)>>2]|0)<(K|0)){vc=xb+(mc+1<<2)|0;wc=yb+-1-mc|0}else{vc=xb;wc=mc}if(!wc){uc=vc;break}else{xb=vc;yb=wc}}}if((uc|0)!=(oc|0)?(K|0)>=(c[uc>>2]|0):0)break;c[Fa>>2]=uc;c[h+0>>2]=c[Fa+0>>2];drc(Ea,e,h,j);yb=e+12|0;c[yb>>2]=~~ea(ea((c[yb>>2]|0)>>>0)+ea(4.0))>>>0}while(0);K=c[d+200>>2]|0;pc=(K|0)!=-1;do if(!(pc&K>>>0>1073741823|pc^1)){c[j>>2]=K;yb=c[e>>2]|0;xb=c[e+4>>2]|0;lc=xb-yb>>2;if(!lc)xc=yb;else{mc=yb;yb=lc;while(1){lc=(yb|0)/2|0;if((c[mc+(lc<<2)>>2]|0)<(K|0)){yc=mc+(lc+1<<2)|0;zc=yb+-1-lc|0}else{yc=mc;zc=lc}if(!zc){xc=yc;break}else{mc=yc;yb=zc}}}if((xc|0)!=(xb|0)?(K|0)>=(c[xc>>2]|0):0)break;c[Ha>>2]=xc;c[h+0>>2]=c[Ha+0>>2];drc(Ga,e,h,j);yb=e+12|0;c[yb>>2]=~~ea(ea((c[yb>>2]|0)>>>0)+ea(4.0))>>>0}while(0);K=c[d+208>>2]|0;pc=(K|0)!=-1;if(!(pc&K>>>0>1073741823|pc^1)){c[H>>2]=K;pc=c[e>>2]|0;yb=c[e+4>>2]|0;mc=yb-pc>>2;if(!mc)Ac=pc;else{oc=pc;pc=mc;while(1){mc=(pc|0)/2|0;if((c[oc+(mc<<2)>>2]|0)<(K|0)){Bc=oc+(mc+1<<2)|0;Cc=pc+-1-mc|0}else{Bc=oc;Cc=mc}if(!Cc){Ac=Bc;break}else{oc=Bc;pc=Cc}}}if((Ac|0)!=(yb|0)?(K|0)>=(c[Ac>>2]|0):0)break;c[G>>2]=Ac;c[h+0>>2]=c[G+0>>2];drc(F,e,h,H);pc=e+12|0;c[pc>>2]=~~ea(ea((c[pc>>2]|0)>>>0)+ea(4.0))>>>0}}else if(qc>>>0<=1073741823){c[E>>2]=qc;pc=c[e>>2]|0;oc=c[e+4>>2]|0;mc=oc-pc>>2;if(!mc)Dc=pc;else{lc=pc;pc=mc;while(1){mc=(pc|0)/2|0;if((c[lc+(mc<<2)>>2]|0)<(qc|0)){Ec=lc+(mc+1<<2)|0;Fc=pc+-1-mc|0}else{Ec=lc;Fc=mc}if(!Fc){Dc=Ec;break}else{lc=Ec;pc=Fc}}}if((Dc|0)!=(oc|0)?(qc|0)>=(c[Dc>>2]|0):0)break;c[D>>2]=Dc;c[h+0>>2]=c[D+0>>2];drc(C,e,h,E);pc=e+12|0;c[pc>>2]=~~ea(ea((c[pc>>2]|0)>>>0)+ea(16.0))>>>0}while(0);E=b+104|0;C=d+248|0;D=c[C>>2]|0;if((D|0)==-1){Dc=c[d+220>>2]|0;if((Dc|0)==-1){Sa=ea(g[d+216>>2]);Gc=(g[k>>2]=Sa,c[k>>2]|0);Hc=0;Ic=-1}else{Gc=0;Hc=0;Ic=Dc}Dc=c[d+228>>2]|0;if((Dc|0)==-1){Sa=ea(g[d+224>>2]);Jc=(g[k>>2]=Sa,c[k>>2]|0);Kc=0;Lc=-1}else{Jc=0;Kc=0;Lc=Dc}Dc=c[d+236>>2]|0;if((Dc|0)==-1){Sa=ea(g[d+232>>2]);Mc=(g[k>>2]=Sa,c[k>>2]|0);Nc=0;Oc=-1}else{Mc=0;Nc=0;Oc=Dc}Dc=c[d+244>>2]|0;if((Dc|0)==-1){Sa=ea(g[d+240>>2]);Pc=(g[k>>2]=Sa,c[k>>2]|0);Qc=0;Rc=-1}else{Pc=0;Qc=0;Rc=Dc}Sc=0;Tc=Gc;Uc=Ic;Vc=Hc;Wc=0;Xc=Jc;Yc=Lc;Zc=Kc;_c=0;$c=Mc;ad=Oc;bd=Nc;cd=0;dd=Pc;ed=Rc;fd=Qc;gd=-1}else{Sc=0;Tc=0;Uc=-1;Vc=0;Wc=0;Xc=0;Yc=-1;Zc=0;_c=0;$c=0;ad=-1;bd=0;cd=0;dd=0;ed=-1;fd=0;gd=D}D=E;c[D>>2]=Sc|Tc;c[D+4>>2]=Uc|Vc;Vc=b+112|0;c[Vc>>2]=Wc|Xc;c[Vc+4>>2]=Yc|Zc;Zc=b+120|0;c[Zc>>2]=_c|$c;c[Zc+4>>2]=ad|bd;bd=b+128|0;c[bd>>2]=cd|dd;c[bd+4>>2]=ed|fd;c[b+136>>2]=gd;gd=c[C>>2]|0;do if((gd|0)==-1){C=c[d+220>>2]|0;fd=(C|0)!=-1;do if(!(fd&C>>>0>1073741823|fd^1)){c[j>>2]=C;ed=c[e>>2]|0;bd=c[e+4>>2]|0;dd=bd-ed>>2;if(!dd)hd=ed;else{cd=ed;ed=dd;while(1){dd=(ed|0)/2|0;if((c[cd+(dd<<2)>>2]|0)<(C|0)){id=cd+(dd+1<<2)|0;jd=ed+-1-dd|0}else{id=cd;jd=dd}if(!jd){hd=id;break}else{cd=id;ed=jd}}}if((hd|0)!=(bd|0)?(C|0)>=(c[hd>>2]|0):0)break;c[t>>2]=hd;c[h+0>>2]=c[t+0>>2];drc(s,e,h,j);ed=e+12|0;c[ed>>2]=~~ea(ea((c[ed>>2]|0)>>>0)+ea(4.0))>>>0}while(0);C=c[d+228>>2]|0;fd=(C|0)!=-1;do if(!(fd&C>>>0>1073741823|fd^1)){c[j>>2]=C;oc=c[e>>2]|0;ed=c[e+4>>2]|0;cd=ed-oc>>2;if(!cd)kd=oc;else{xb=oc;oc=cd;while(1){cd=(oc|0)/2|0;if((c[xb+(cd<<2)>>2]|0)<(C|0)){ld=xb+(cd+1<<2)|0;md=oc+-1-cd|0}else{ld=xb;md=cd}if(!md){kd=ld;break}else{xb=ld;oc=md}}}if((kd|0)!=(ed|0)?(C|0)>=(c[kd>>2]|0):0)break;c[Ba>>2]=kd;c[h+0>>2]=c[Ba+0>>2];drc(Aa,e,h,j);oc=e+12|0;c[oc>>2]=~~ea(ea((c[oc>>2]|0)>>>0)+ea(4.0))>>>0}while(0);C=c[d+236>>2]|0;fd=(C|0)!=-1;do if(!(fd&C>>>0>1073741823|fd^1)){c[j>>2]=C;oc=c[e>>2]|0;xb=c[e+4>>2]|0;bd=xb-oc>>2;if(!bd)nd=oc;else{cd=oc;oc=bd;while(1){bd=(oc|0)/2|0;if((c[cd+(bd<<2)>>2]|0)<(C|0)){od=cd+(bd+1<<2)|0;pd=oc+-1-bd|0}else{od=cd;pd=bd}if(!pd){nd=od;break}else{cd=od;oc=pd}}}if((nd|0)!=(xb|0)?(C|0)>=(c[nd>>2]|0):0)break;c[Da>>2]=nd;c[h+0>>2]=c[Da+0>>2];drc(Ca,e,h,j);oc=e+12|0;c[oc>>2]=~~ea(ea((c[oc>>2]|0)>>>0)+ea(4.0))>>>0}while(0);C=c[d+244>>2]|0;fd=(C|0)!=-1;if(!(fd&C>>>0>1073741823|fd^1)){c[z>>2]=C;fd=c[e>>2]|0;oc=c[e+4>>2]|0;cd=oc-fd>>2;if(!cd)qd=fd;else{ed=fd;fd=cd;while(1){cd=(fd|0)/2|0;if((c[ed+(cd<<2)>>2]|0)<(C|0)){rd=ed+(cd+1<<2)|0;sd=fd+-1-cd|0}else{rd=ed;sd=cd}if(!sd){qd=rd;break}else{ed=rd;fd=sd}}}if((qd|0)!=(oc|0)?(C|0)>=(c[qd>>2]|0):0)break;c[y>>2]=qd;c[h+0>>2]=c[y+0>>2];drc(x,e,h,z);fd=e+12|0;c[fd>>2]=~~ea(ea((c[fd>>2]|0)>>>0)+ea(4.0))>>>0}}else if(gd>>>0<=1073741823){c[w>>2]=gd;fd=c[e>>2]|0;ed=c[e+4>>2]|0;cd=ed-fd>>2;if(!cd)td=fd;else{bd=fd;fd=cd;while(1){cd=(fd|0)/2|0;if((c[bd+(cd<<2)>>2]|0)<(gd|0)){ud=bd+(cd+1<<2)|0;vd=fd+-1-cd|0}else{ud=bd;vd=cd}if(!vd){td=ud;break}else{bd=ud;fd=vd}}}if((td|0)!=(ed|0)?(gd|0)>=(c[td>>2]|0):0)break;c[v>>2]=td;c[h+0>>2]=c[v+0>>2];drc(u,e,h,w);fd=e+12|0;c[fd>>2]=~~ea(ea((c[fd>>2]|0)>>>0)+ea(16.0))>>>0}while(0);w=b+140|0;u=d+284|0;v=c[u>>2]|0;if((v|0)==-1){td=c[d+256>>2]|0;if((td|0)==-1){Sa=ea(g[d+252>>2]);wd=(g[k>>2]=Sa,c[k>>2]|0);xd=0;yd=-1}else{wd=0;xd=0;yd=td}td=c[d+264>>2]|0;if((td|0)==-1){Sa=ea(g[d+260>>2]);zd=(g[k>>2]=Sa,c[k>>2]|0);Ad=0;Bd=-1}else{zd=0;Ad=0;Bd=td}td=c[d+272>>2]|0;if((td|0)==-1){Sa=ea(g[d+268>>2]);Cd=(g[k>>2]=Sa,c[k>>2]|0);Dd=0;Ed=-1}else{Cd=0;Dd=0;Ed=td}td=c[d+280>>2]|0;if((td|0)==-1){Sa=ea(g[d+276>>2]);Fd=(g[k>>2]=Sa,c[k>>2]|0);Gd=0;Hd=-1}else{Fd=0;Gd=0;Hd=td}Id=0;Jd=wd;Kd=yd;Ld=xd;Md=0;Nd=zd;Od=Bd;Pd=Ad;Qd=0;Rd=Cd;Sd=Ed;Td=Dd;Ud=0;Vd=Fd;Wd=Hd;Xd=Gd;Yd=-1}else{Id=0;Jd=0;Kd=-1;Ld=0;Md=0;Nd=0;Od=-1;Pd=0;Qd=0;Rd=0;Sd=-1;Td=0;Ud=0;Vd=0;Wd=-1;Xd=0;Yd=v}v=w;c[v>>2]=Id|Jd;c[v+4>>2]=Kd|Ld;Ld=b+148|0;c[Ld>>2]=Md|Nd;c[Ld+4>>2]=Od|Pd;Pd=b+156|0;c[Pd>>2]=Qd|Rd;c[Pd+4>>2]=Sd|Td;Td=b+164|0;c[Td>>2]=Ud|Vd;c[Td+4>>2]=Wd|Xd;c[b+172>>2]=Yd;Yd=c[u>>2]|0;do if((Yd|0)==-1){u=c[d+256>>2]|0;Xd=(u|0)!=-1;do if(!(Xd&u>>>0>1073741823|Xd^1)){c[m>>2]=u;Wd=c[e>>2]|0;Td=c[e+4>>2]|0;Vd=Td-Wd>>2;if(!Vd)Zd=Wd;else{Ud=Wd;Wd=Vd;while(1){Vd=(Wd|0)/2|0;if((c[Ud+(Vd<<2)>>2]|0)<(u|0)){_d=Ud+(Vd+1<<2)|0;$d=Wd+-1-Vd|0}else{_d=Ud;$d=Vd}if(!$d){Zd=_d;break}else{Ud=_d;Wd=$d}}}if((Zd|0)!=(Td|0)?(u|0)>=(c[Zd>>2]|0):0)break;c[l>>2]=Zd;c[h+0>>2]=c[l+0>>2];drc(j,e,h,m);Wd=e+12|0;c[Wd>>2]=~~ea(ea((c[Wd>>2]|0)>>>0)+ea(4.0))>>>0}while(0);u=c[d+264>>2]|0;Xd=(u|0)!=-1;do if(!(Xd&u>>>0>1073741823|Xd^1)){c[m>>2]=u;ed=c[e>>2]|0;Wd=c[e+4>>2]|0;Ud=Wd-ed>>2;if(!Ud)ae=ed;else{xb=ed;ed=Ud;while(1){Ud=(ed|0)/2|0;if((c[xb+(Ud<<2)>>2]|0)<(u|0)){be=xb+(Ud+1<<2)|0;ce=ed+-1-Ud|0}else{be=xb;ce=Ud}if(!ce){ae=be;break}else{xb=be;ed=ce}}}if((ae|0)!=(Wd|0)?(u|0)>=(c[ae>>2]|0):0)break;c[xa>>2]=ae;c[h+0>>2]=c[xa+0>>2];drc(wa,e,h,m);ed=e+12|0;c[ed>>2]=~~ea(ea((c[ed>>2]|0)>>>0)+ea(4.0))>>>0}while(0);u=c[d+272>>2]|0;Xd=(u|0)!=-1;do if(!(Xd&u>>>0>1073741823|Xd^1)){c[m>>2]=u;ed=c[e>>2]|0;xb=c[e+4>>2]|0;Td=xb-ed>>2;if(!Td)de=ed;else{Ud=ed;ed=Td;while(1){Td=(ed|0)/2|0;if((c[Ud+(Td<<2)>>2]|0)<(u|0)){ee=Ud+(Td+1<<2)|0;fe=ed+-1-Td|0}else{ee=Ud;fe=Td}if(!fe){de=ee;break}else{Ud=ee;ed=fe}}}if((de|0)!=(xb|0)?(u|0)>=(c[de>>2]|0):0)break;c[za>>2]=de;c[h+0>>2]=c[za+0>>2];drc(ya,e,h,m);ed=e+12|0;c[ed>>2]=~~ea(ea((c[ed>>2]|0)>>>0)+ea(4.0))>>>0}while(0);u=c[d+280>>2]|0;Xd=(u|0)!=-1;if(!(Xd&u>>>0>1073741823|Xd^1)){c[r>>2]=u;Xd=c[e>>2]|0;ed=c[e+4>>2]|0;Ud=ed-Xd>>2;if(!Ud)ge=Xd;else{Wd=Xd;Xd=Ud;while(1){Ud=(Xd|0)/2|0;if((c[Wd+(Ud<<2)>>2]|0)<(u|0)){he=Wd+(Ud+1<<2)|0;ie=Xd+-1-Ud|0}else{he=Wd;ie=Ud}if(!ie){ge=he;break}else{Wd=he;Xd=ie}}}if((ge|0)!=(ed|0)?(u|0)>=(c[ge>>2]|0):0)break;c[q>>2]=ge;c[h+0>>2]=c[q+0>>2];drc(p,e,h,r);Xd=e+12|0;c[Xd>>2]=~~ea(ea((c[Xd>>2]|0)>>>0)+ea(4.0))>>>0}}else if(Yd>>>0<=1073741823){c[o>>2]=Yd;Xd=c[e>>2]|0;Wd=c[e+4>>2]|0;Ud=Wd-Xd>>2;if(!Ud)je=Xd;else{Td=Xd;Xd=Ud;while(1){Ud=(Xd|0)/2|0;if((c[Td+(Ud<<2)>>2]|0)<(Yd|0)){ke=Td+(Ud+1<<2)|0;le=Xd+-1-Ud|0}else{ke=Td;le=Ud}if(!le){je=ke;break}else{Td=ke;Xd=le}}}if((je|0)!=(Wd|0)?(Yd|0)>=(c[je>>2]|0):0)break;c[n>>2]=je;c[h+0>>2]=c[n+0>>2];drc(m,e,h,o);Xd=e+12|0;c[Xd>>2]=~~ea(ea((c[Xd>>2]|0)>>>0)+ea(16.0))>>>0}while(0);o=b+176|0;m=d+320|0;n=c[m>>2]|0;if((n|0)==-1){je=c[d+292>>2]|0;if((je|0)==-1){Sa=ea(g[d+288>>2]);me=(g[k>>2]=Sa,c[k>>2]|0);ne=0;oe=-1}else{me=0;ne=0;oe=je}je=c[d+300>>2]|0;if((je|0)==-1){Sa=ea(g[d+296>>2]);pe=(g[k>>2]=Sa,c[k>>2]|0);qe=0;re=-1}else{pe=0;qe=0;re=je}je=c[d+308>>2]|0;if((je|0)==-1){Sa=ea(g[d+304>>2]);se=(g[k>>2]=Sa,c[k>>2]|0);te=0;ue=-1}else{se=0;te=0;ue=je}je=c[d+316>>2]|0;if((je|0)==-1){Sa=ea(g[d+312>>2]);ve=(g[k>>2]=Sa,c[k>>2]|0);we=0;xe=-1}else{ve=0;we=0;xe=je}ye=0;ze=se;Ae=ue;Be=te;Ce=0;De=ve;Ee=xe;Fe=we;Ge=-1;He=0;Ie=me;Je=oe;Ke=ne;Le=0;Me=pe;Ne=re;Oe=qe}else{ye=0;ze=0;Ae=-1;Be=0;Ce=0;De=0;Ee=-1;Fe=0;Ge=n;He=0;Ie=0;Je=-1;Ke=0;Le=0;Me=0;Ne=-1;Oe=0}n=o;c[n>>2]=He|Ie;c[n+4>>2]=Je|Ke;Ke=b+184|0;c[Ke>>2]=Le|Me;c[Ke+4>>2]=Ne|Oe;Oe=b+192|0;c[Oe>>2]=ye|ze;c[Oe+4>>2]=Ae|Be;Be=b+200|0;c[Be>>2]=Ce|De;c[Be+4>>2]=Ee|Fe;c[b+208>>2]=Ge;Ge=c[m>>2]|0;do if((Ge|0)==-1){m=c[d+292>>2]|0;Fe=(m|0)!=-1;do if(!(Fe&m>>>0>1073741823|Fe^1)){c[Q>>2]=m;Ee=c[e>>2]|0;Be=c[e+4>>2]|0;De=Be-Ee>>2;if(!De)Pe=Ee;else{Ce=Ee;Ee=De;while(1){De=(Ee|0)/2|0;if((c[Ce+(De<<2)>>2]|0)<(m|0)){Qe=Ce+(De+1<<2)|0;Re=Ee+-1-De|0}else{Qe=Ce;Re=De}if(!Re){Pe=Qe;break}else{Ce=Qe;Ee=Re}}}if((Pe|0)!=(Be|0)?(m|0)>=(c[Pe>>2]|0):0)break;c[pa>>2]=Pe;c[h+0>>2]=c[pa+0>>2];drc(oa,e,h,Q);Ee=e+12|0;c[Ee>>2]=~~ea(ea((c[Ee>>2]|0)>>>0)+ea(4.0))>>>0}while(0);m=c[d+300>>2]|0;Fe=(m|0)!=-1;do if(!(Fe&m>>>0>1073741823|Fe^1)){c[Q>>2]=m;Wd=c[e>>2]|0;Ee=c[e+4>>2]|0;Ce=Ee-Wd>>2;if(!Ce)Se=Wd;else{xb=Wd;Wd=Ce;while(1){Ce=(Wd|0)/2|0;if((c[xb+(Ce<<2)>>2]|0)<(m|0)){Te=xb+(Ce+1<<2)|0;Ue=Wd+-1-Ce|0}else{Te=xb;Ue=Ce}if(!Ue){Se=Te;break}else{xb=Te;Wd=Ue}}}if((Se|0)!=(Ee|0)?(m|0)>=(c[Se>>2]|0):0)break;c[ta>>2]=Se;c[h+0>>2]=c[ta+0>>2];drc(sa,e,h,Q);Wd=e+12|0;c[Wd>>2]=~~ea(ea((c[Wd>>2]|0)>>>0)+ea(4.0))>>>0}while(0);m=c[d+308>>2]|0;Fe=(m|0)!=-1;do if(!(Fe&m>>>0>1073741823|Fe^1)){c[Q>>2]=m;Wd=c[e>>2]|0;xb=c[e+4>>2]|0;Be=xb-Wd>>2;if(!Be)Ve=Wd;else{Ce=Wd;Wd=Be;while(1){Be=(Wd|0)/2|0;if((c[Ce+(Be<<2)>>2]|0)<(m|0)){We=Ce+(Be+1<<2)|0;Xe=Wd+-1-Be|0}else{We=Ce;Xe=Be}if(!Xe){Ve=We;break}else{Ce=We;Wd=Xe}}}if((Ve|0)!=(xb|0)?(m|0)>=(c[Ve>>2]|0):0)break;c[va>>2]=Ve;c[h+0>>2]=c[va+0>>2];drc(ua,e,h,Q);Wd=e+12|0;c[Wd>>2]=~~ea(ea((c[Wd>>2]|0)>>>0)+ea(4.0))>>>0}while(0);m=c[d+316>>2]|0;Fe=(m|0)!=-1;if(!(Fe&m>>>0>1073741823|Fe^1)){c[ga>>2]=m;Fe=c[e>>2]|0;Wd=c[e+4>>2]|0;Ce=Wd-Fe>>2;if(!Ce)Ye=Fe;else{Ee=Fe;Fe=Ce;while(1){Ce=(Fe|0)/2|0;if((c[Ee+(Ce<<2)>>2]|0)<(m|0)){Ze=Ee+(Ce+1<<2)|0;_e=Fe+-1-Ce|0}else{Ze=Ee;_e=Ce}if(!_e){Ye=Ze;break}else{Ee=Ze;Fe=_e}}}if((Ye|0)!=(Wd|0)?(m|0)>=(c[Ye>>2]|0):0)break;c[fa>>2]=Ye;c[h+0>>2]=c[fa+0>>2];drc(da,e,h,ga);Fe=e+12|0;c[Fe>>2]=~~ea(ea((c[Fe>>2]|0)>>>0)+ea(4.0))>>>0}}else if(Ge>>>0<=1073741823){c[la>>2]=Ge;Fe=c[e>>2]|0;Ee=c[e+4>>2]|0;Ce=Ee-Fe>>2;if(!Ce)$e=Fe;else{Be=Fe;Fe=Ce;while(1){Ce=(Fe|0)/2|0;if((c[Be+(Ce<<2)>>2]|0)<(Ge|0)){af=Be+(Ce+1<<2)|0;bf=Fe+-1-Ce|0}else{af=Be;bf=Ce}if(!bf){$e=af;break}else{Be=af;Fe=bf}}}if(($e|0)!=(Ee|0)?(Ge|0)>=(c[$e>>2]|0):0)break;c[ka>>2]=$e;c[h+0>>2]=c[ka+0>>2];drc(ja,e,h,la);Fe=e+12|0;c[Fe>>2]=~~ea(ea((c[Fe>>2]|0)>>>0)+ea(16.0))>>>0}while(0);a[b+221>>0]=a[d+324>>0]|0;la=d+452|0;ja=c[la>>2]|0;if((ja|0)==-1){Sa=ea(g[d+448>>2]);cf=-1;df=0;ef=(g[k>>2]=Sa,c[k>>2]|0)}else{cf=ja;df=0;ef=0}ja=b+224|0;c[ja>>2]=ef;c[ja+4>>2]=cf|df;df=c[la>>2]|0;la=(df|0)!=-1;do if(!(la&df>>>0>1073741823|la^1)){c[Q>>2]=df;cf=c[e>>2]|0;ja=c[e+4>>2]|0;ef=ja-cf>>2;if(!ef)ff=cf;else{ka=cf;cf=ef;while(1){ef=(cf|0)/2|0;if((c[ka+(ef<<2)>>2]|0)<(df|0)){gf=ka+(ef+1<<2)|0;hf=cf+-1-ef|0}else{gf=ka;hf=ef}if(!hf){ff=gf;break}else{ka=gf;cf=hf}}}if((ff|0)!=(ja|0)?(df|0)>=(c[ff>>2]|0):0)break;c[ra>>2]=ff;c[h+0>>2]=c[ra+0>>2];drc(qa,e,h,Q);cf=e+12|0;c[cf>>2]=~~ea(ea((c[cf>>2]|0)>>>0)+ea(4.0))>>>0}while(0);qa=d+460|0;ra=c[qa>>2]|0;if((ra|0)==-1){Sa=ea(g[d+456>>2]);jf=-1;kf=0;lf=(g[k>>2]=Sa,c[k>>2]|0)}else{jf=ra;kf=0;lf=0}ra=b+232|0;c[ra>>2]=lf;c[ra+4>>2]=jf|kf;kf=c[qa>>2]|0;qa=(kf|0)!=-1;do if(!(qa&kf>>>0>1073741823|qa^1)){c[Q>>2]=kf;jf=c[e>>2]|0;ra=c[e+4>>2]|0;lf=ra-jf>>2;if(!lf)mf=jf;else{ff=jf;jf=lf;while(1){lf=(jf|0)/2|0;if((c[ff+(lf<<2)>>2]|0)<(kf|0)){nf=ff+(lf+1<<2)|0;of=jf+-1-lf|0}else{nf=ff;of=lf}if(!of){mf=nf;break}else{ff=nf;jf=of}}}if((mf|0)!=(ra|0)?(kf|0)>=(c[mf>>2]|0):0)break;c[na>>2]=mf;c[h+0>>2]=c[na+0>>2];drc(ma,e,h,Q);jf=e+12|0;c[jf>>2]=~~ea(ea((c[jf>>2]|0)>>>0)+ea(4.0))>>>0}while(0);ma=d+468|0;na=c[ma>>2]|0;if((na|0)==-1){Sa=ea(g[d+464>>2]);pf=-1;qf=0;rf=(g[k>>2]=Sa,c[k>>2]|0)}else{pf=na;qf=0;rf=0}na=b+240|0;c[na>>2]=rf;c[na+4>>2]=pf|qf;qf=c[ma>>2]|0;ma=(qf|0)!=-1;do if(!(ma&qf>>>0>1073741823|ma^1)){c[Q>>2]=qf;pf=c[e>>2]|0;na=c[e+4>>2]|0;rf=na-pf>>2;if(!rf)sf=pf;else{mf=pf;pf=rf;while(1){rf=(pf|0)/2|0;if((c[mf+(rf<<2)>>2]|0)<(qf|0)){tf=mf+(rf+1<<2)|0;uf=pf+-1-rf|0}else{tf=mf;uf=rf}if(!uf){sf=tf;break}else{mf=tf;pf=uf}}}if((sf|0)!=(na|0)?(qf|0)>=(c[sf>>2]|0):0)break;c[ia>>2]=sf;c[h+0>>2]=c[ia+0>>2];drc(ha,e,h,Q);pf=e+12|0;c[pf>>2]=~~ea(ea((c[pf>>2]|0)>>>0)+ea(4.0))>>>0}while(0);ha=b+248|0;ia=d+504|0;sf=c[ia>>2]|0;if((sf|0)==-1){qf=c[d+476>>2]|0;if((qf|0)==-1){Sa=ea(g[d+472>>2]);vf=(g[k>>2]=Sa,c[k>>2]|0);wf=0;xf=-1}else{vf=0;wf=0;xf=qf}qf=c[d+484>>2]|0;if((qf|0)==-1){Sa=ea(g[d+480>>2]);yf=(g[k>>2]=Sa,c[k>>2]|0);zf=0;Af=-1}else{yf=0;zf=0;Af=qf}qf=c[d+492>>2]|0;if((qf|0)==-1){Sa=ea(g[d+488>>2]);Bf=(g[k>>2]=Sa,c[k>>2]|0);Cf=0;Df=-1}else{Bf=0;Cf=0;Df=qf}qf=c[d+500>>2]|0;if((qf|0)==-1){Sa=ea(g[d+496>>2]);Ef=(g[k>>2]=Sa,c[k>>2]|0);Ff=0;Gf=-1}else{Ef=0;Ff=0;Gf=qf}Hf=0;If=vf;Jf=xf;Kf=wf;Lf=0;Mf=yf;Nf=Af;Of=zf;Pf=0;Qf=Bf;Rf=Df;Sf=Cf;Tf=0;Uf=Ef;Vf=Gf;Wf=Ff;Xf=-1}else{Hf=0;If=0;Jf=-1;Kf=0;Lf=0;Mf=0;Nf=-1;Of=0;Pf=0;Qf=0;Rf=-1;Sf=0;Tf=0;Uf=0;Vf=-1;Wf=0;Xf=sf}sf=ha;c[sf>>2]=Hf|If;c[sf+4>>2]=Jf|Kf;Kf=b+256|0;c[Kf>>2]=Lf|Mf;c[Kf+4>>2]=Nf|Of;Of=b+264|0;c[Of>>2]=Pf|Qf;c[Of+4>>2]=Rf|Sf;Sf=b+272|0;c[Sf>>2]=Tf|Uf;c[Sf+4>>2]=Vf|Wf;c[b+280>>2]=Xf;Xf=c[ia>>2]|0;do if((Xf|0)==-1){ia=c[d+476>>2]|0;Wf=(ia|0)!=-1;do if(!(Wf&ia>>>0>1073741823|Wf^1)){c[Q>>2]=ia;Vf=c[e>>2]|0;Sf=c[e+4>>2]|0;Uf=Sf-Vf>>2;if(!Uf)Yf=Vf;else{Tf=Vf;Vf=Uf;while(1){Uf=(Vf|0)/2|0;if((c[Tf+(Uf<<2)>>2]|0)<(ia|0)){Zf=Tf+(Uf+1<<2)|0;_f=Vf+-1-Uf|0}else{Zf=Tf;_f=Uf}if(!_f){Yf=Zf;break}else{Tf=Zf;Vf=_f}}}if((Yf|0)!=(Sf|0)?(ia|0)>=(c[Yf>>2]|0):0)break;c[X>>2]=Yf;c[h+0>>2]=c[X+0>>2];drc(W,e,h,Q);Vf=e+12|0;c[Vf>>2]=~~ea(ea((c[Vf>>2]|0)>>>0)+ea(4.0))>>>0}while(0);ia=c[d+484>>2]|0;Wf=(ia|0)!=-1;do if(!(Wf&ia>>>0>1073741823|Wf^1)){c[Q>>2]=ia;na=c[e>>2]|0;Vf=c[e+4>>2]|0;Tf=Vf-na>>2;if(!Tf)$f=na;else{xb=na;na=Tf;while(1){Tf=(na|0)/2|0;if((c[xb+(Tf<<2)>>2]|0)<(ia|0)){ag=xb+(Tf+1<<2)|0;bg=na+-1-Tf|0}else{ag=xb;bg=Tf}if(!bg){$f=ag;break}else{xb=ag;na=bg}}}if(($f|0)!=(Vf|0)?(ia|0)>=(c[$f>>2]|0):0)break;c[aa>>2]=$f;c[h+0>>2]=c[aa+0>>2];drc($,e,h,Q);na=e+12|0;c[na>>2]=~~ea(ea((c[na>>2]|0)>>>0)+ea(4.0))>>>0}while(0);ia=c[d+492>>2]|0;Wf=(ia|0)!=-1;do if(!(Wf&ia>>>0>1073741823|Wf^1)){c[Q>>2]=ia;na=c[e>>2]|0;xb=c[e+4>>2]|0;Sf=xb-na>>2;if(!Sf)cg=na;else{Tf=na;na=Sf;while(1){Sf=(na|0)/2|0;if((c[Tf+(Sf<<2)>>2]|0)<(ia|0)){dg=Tf+(Sf+1<<2)|0;eg=na+-1-Sf|0}else{dg=Tf;eg=Sf}if(!eg){cg=dg;break}else{Tf=dg;na=eg}}}if((cg|0)!=(xb|0)?(ia|0)>=(c[cg>>2]|0):0)break;c[ca>>2]=cg;c[h+0>>2]=c[ca+0>>2];drc(ba,e,h,Q);na=e+12|0;c[na>>2]=~~ea(ea((c[na>>2]|0)>>>0)+ea(4.0))>>>0}while(0);ia=c[d+500>>2]|0;Wf=(ia|0)!=-1;if(Wf&ia>>>0>1073741823|Wf^1)break;c[S>>2]=ia;Wf=c[e>>2]|0;na=c[e+4>>2]|0;Tf=na-Wf>>2;if(!Tf)fg=Wf;else{Vf=Wf;Wf=Tf;while(1){Tf=(Wf|0)/2|0;if((c[Vf+(Tf<<2)>>2]|0)<(ia|0)){gg=Vf+(Tf+1<<2)|0;hg=Wf+-1-Tf|0}else{gg=Vf;hg=Tf}if(!hg){fg=gg;break}else{Vf=gg;Wf=hg}}}if((fg|0)!=(na|0)?(ia|0)>=(c[fg>>2]|0):0)break;c[R>>2]=fg;c[h+0>>2]=c[R+0>>2];drc(Q,e,h,S);Wf=e+12|0;c[Wf>>2]=~~ea(ea((c[Wf>>2]|0)>>>0)+ea(4.0))>>>0}else{if(Xf>>>0>1073741823)break;c[V>>2]=Xf;Wf=c[e>>2]|0;Vf=c[e+4>>2]|0;Tf=Vf-Wf>>2;if(!Tf)ig=Wf;else{Sf=Wf;Wf=Tf;while(1){Tf=(Wf|0)/2|0;if((c[Sf+(Tf<<2)>>2]|0)<(Xf|0)){jg=Sf+(Tf+1<<2)|0;kg=Wf+-1-Tf|0}else{jg=Sf;kg=Tf}if(!kg){ig=jg;break}else{Sf=jg;Wf=kg}}}if((ig|0)!=(Vf|0)?(Xf|0)>=(c[ig>>2]|0):0)break;c[U>>2]=ig;c[h+0>>2]=c[U+0>>2];drc(T,e,h,V);Wf=e+12|0;c[Wf>>2]=~~ea(ea((c[Wf>>2]|0)>>>0)+ea(16.0))>>>0}while(0);c[b+284>>2]=c[d+508>>2];c[b+288>>2]=c[d+516>>2];V=d+40|0;T=c[V>>2]|0;if((T|0)==-1){Sa=ea(g[d+36>>2]);lg=-1;mg=0;ng=(g[k>>2]=Sa,c[k>>2]|0)}else{lg=T;mg=0;ng=0}T=b+16|0;c[T>>2]=ng;c[T+4>>2]=lg|mg;mg=c[V>>2]|0;V=(mg|0)!=-1;do if(!(V&mg>>>0>1073741823|V^1)){c[_>>2]=mg;lg=c[e>>2]|0;T=c[e+4>>2]|0;ng=T-lg>>2;if(!ng)og=lg;else{U=lg;lg=ng;while(1){ng=(lg|0)/2|0;if((c[U+(ng<<2)>>2]|0)<(mg|0)){pg=U+(ng+1<<2)|0;qg=lg+-1-ng|0}else{pg=U;qg=ng}if(!qg){og=pg;break}else{U=pg;lg=qg}}}if((og|0)!=(T|0)?(mg|0)>=(c[og>>2]|0):0)break;c[Z>>2]=og;c[h+0>>2]=c[Z+0>>2];drc(Y,e,h,_);lg=e+12|0;c[lg>>2]=~~ea(ea((c[lg>>2]|0)>>>0)+ea(4.0))>>>0}while(0);Y=c[d+56>>2]|0;if((Y|0)==-1){Sa=ea(g[d+52>>2]);rg=-1;sg=0;tg=(g[k>>2]=Sa,c[k>>2]|0)}else{rg=Y;sg=0;tg=0}Y=b+444|0;c[Y>>2]=tg;c[Y+4>>2]=rg|sg;sg=c[d+72>>2]|0;if((sg|0)==-1){Sa=ea(g[d+68>>2]);ug=-1;vg=0;wg=(g[k>>2]=Sa,c[k>>2]|0)}else{ug=sg;vg=0;wg=0}sg=b+452|0;c[sg>>2]=wg;c[sg+4>>2]=ug|vg;vg=c[d+64>>2]|0;Sa=(c[k>>2]=wg,ea(g[k>>2]));if((vg|0)==-1){xg=ea(g[d+60>>2]);yg=-1;zg=0;Ag=(g[k>>2]=xg,c[k>>2]|0)}else{yg=vg;zg=0;Ag=0}vg=b+460|0;c[vg>>2]=Ag;c[vg+4>>2]=yg|zg;xg=(c[k>>2]=Ag,ea(g[k>>2]));do if((ug|0)==-1){Ag=b+452|0;if(!(Sa==ea(1.0)&(yg|0)==-1))break;zg=b+460|0;if(!(xg==ea(1.0)))break;if(!(c[d+648>>2]|0))break;rri(h,659104,9);vg=vvd(h)|0;xri(h);rri(_,659136,12);wg=vvd(_)|0;xri(_);sg=c[d+644>>2]|0;rg=d+644|0;if(!sg)break;else{Bg=rg;Cg=sg}a:while(1){sg=Cg;while(1){if((c[sg+16>>2]|0)>=(vg|0)){Dg=sg;break}sg=c[sg+4>>2]|0;if(!sg){Eg=Bg;break a}}Cg=c[Dg>>2]|0;if(!Cg){Eg=Dg;break}else Bg=Dg}if((Eg|0)==(rg|0))break;if((vg|0)<(c[Eg+16>>2]|0))break;if((c[Eg+20>>2]|0)!=(wg|0))break;g[Ag>>2]=ea(0.0);g[zg>>2]=ea(0.0)}while(0);Eg=c[d+32>>2]|0;if((Eg|0)==-1){xg=ea(g[d+28>>2]);Fg=-1;Gg=0;Hg=(g[k>>2]=xg,c[k>>2]|0)}else{Fg=Eg;Gg=0;Hg=0}Eg=b+412|0;c[Eg>>2]=Hg;c[Eg+4>>2]=Fg|Gg;Gg=c[d+92>>2]|0;if((Gg|0)==-1){xg=ea(g[d+88>>2]);Ig=-1;Jg=0;Kg=(g[k>>2]=xg,c[k>>2]|0)}else{Ig=Gg;Jg=0;Kg=0}Gg=b+356|0;c[Gg>>2]=Kg;c[Gg+4>>2]=Ig|Jg;Jg=c[d+100>>2]|0;if((Jg|0)==-1){xg=ea(g[d+96>>2]);Lg=-1;Mg=0;Ng=(g[k>>2]=xg,c[k>>2]|0)}else{Lg=Jg;Mg=0;Ng=0}Jg=b+364|0;c[Jg>>2]=Ng;c[Jg+4>>2]=Lg|Mg;Mg=c[d+108>>2]|0;if((Mg|0)==-1){xg=ea(g[d+104>>2]);Og=-1;Pg=0;Qg=(g[k>>2]=xg,c[k>>2]|0)}else{Og=Mg;Pg=0;Qg=0}Mg=b+372|0;c[Mg>>2]=Qg;c[Mg+4>>2]=Og|Pg;Pg=c[d+116>>2]|0;if((Pg|0)==-1){xg=ea(g[d+112>>2]);Rg=-1;Sg=0;Tg=(g[k>>2]=xg,c[k>>2]|0)}else{Rg=Pg;Sg=0;Tg=0}Pg=b+380|0;c[Pg>>2]=Tg;c[Pg+4>>2]=Rg|Sg;Sg=c[d+140>>2]|0;if((Sg|0)==-1){xg=ea(g[d+136>>2]);Ug=-1;Vg=0;Wg=(g[k>>2]=xg,c[k>>2]|0)}else{Ug=Sg;Vg=0;Wg=0}Sg=b+404|0;c[Sg>>2]=Wg;c[Sg+4>>2]=Ug|Vg;Vg=c[d+84>>2]|0;if((Vg|0)==-1){xg=ea(g[d+80>>2]);Xg=-1;Yg=0;Zg=(g[k>>2]=xg,c[k>>2]|0)}else{Xg=Vg;Yg=0;Zg=0}Vg=b+420|0;c[Vg>>2]=Zg;c[Vg+4>>2]=Xg|Yg;Yg=c[d+124>>2]|0;if((Yg|0)==-1){xg=ea(g[d+120>>2]);_g=-1;$g=0;ah=(g[k>>2]=xg,c[k>>2]|0)}else{_g=Yg;$g=0;ah=0}Yg=b+388|0;c[Yg>>2]=ah;c[Yg+4>>2]=_g|$g;$g=c[d+132>>2]|0;if(($g|0)==-1){xg=ea(g[d+128>>2]);bh=-1;ch=0;dh=(g[k>>2]=xg,c[k>>2]|0)}else{bh=$g;ch=0;dh=0}$g=b+396|0;c[$g>>2]=dh;c[$g+4>>2]=bh|ch;ch=c[d+16>>2]|0;if((ch|0)==-1){xg=ea(g[d+12>>2]);eh=-1;fh=0;gh=(g[k>>2]=xg,c[k>>2]|0)}else{eh=ch;fh=0;gh=0}ch=b+436|0;c[ch>>2]=gh;c[ch+4>>2]=eh|fh;fh=c[d+24>>2]|0;if((fh|0)==-1){xg=ea(g[d+20>>2]);hh=-1;ih=0;jh=(g[k>>2]=xg,c[k>>2]|0)}else{hh=fh;ih=0;jh=0}fh=b+428|0;c[fh>>2]=jh;c[fh+4>>2]=hh|ih;ih=d+444|0;hh=c[ih>>2]|0;if((hh|0)==-1){xg=ea(g[d+440>>2]);kh=-1;lh=0;mh=(g[k>>2]=xg,c[k>>2]|0)}else{kh=hh;lh=0;mh=0}hh=b+212|0;c[hh>>2]=mh;c[hh+4>>2]=kh|lh;lh=c[ih>>2]|0;ih=(lh|0)!=-1;do if(!(ih&lh>>>0>1073741823|ih^1)){c[Pa>>2]=lh;kh=c[e>>2]|0;hh=c[e+4>>2]|0;mh=hh-kh>>2;if(!mh)nh=kh;else{fh=kh;kh=mh;while(1){mh=(kh|0)/2|0;if((c[fh+(mh<<2)>>2]|0)<(lh|0)){oh=fh+(mh+1<<2)|0;ph=kh+-1-mh|0}else{oh=fh;ph=mh}if(!ph){nh=oh;break}else{fh=oh;kh=ph}}}if((nh|0)!=(hh|0)?(lh|0)>=(c[nh>>2]|0):0)break;c[Oa>>2]=nh;c[h+0>>2]=c[Oa+0>>2];drc(_,e,h,Pa);kh=e+12|0;c[kh>>2]=~~ea(ea((c[kh>>2]|0)>>>0)+ea(4.0))>>>0}while(0);e=c[d+428>>2]|0;if((e|0)==-1){xg=ea(g[d+424>>2]);qh=-1;rh=0;sh=(g[k>>2]=xg,c[k>>2]|0)}else{qh=e;rh=0;sh=0}e=b+468|0;c[e>>2]=sh;c[e+4>>2]=qh|rh;rh=c[d+436>>2]|0;if((rh|0)==-1){xg=ea(g[d+432>>2]);th=-1;uh=0;vh=(g[k>>2]=xg,c[k>>2]|0)}else{th=rh;uh=0;vh=0}rh=b+476|0;c[rh>>2]=vh;c[rh+4>>2]=th|uh;uh=c[d+356>>2]|0;if((uh|0)==-1){xg=ea(g[d+352>>2]);wh=-1;xh=0;yh=(g[k>>2]=xg,c[k>>2]|0)}else{wh=uh;xh=0;yh=0}uh=b+484|0;c[uh>>2]=yh;c[uh+4>>2]=wh|xh;xh=c[d+332>>2]|0;if((xh|0)==-1){xg=ea(g[d+328>>2]);zh=-1;Ah=0;Bh=(g[k>>2]=xg,c[k>>2]|0)}else{zh=xh;Ah=0;Bh=0}xh=b+492|0;c[xh>>2]=Bh;c[xh+4>>2]=zh|Ah;Ah=c[d+340>>2]|0;if((Ah|0)==-1){xg=ea(g[d+336>>2]);Ch=-1;Dh=0;Eh=(g[k>>2]=xg,c[k>>2]|0)}else{Ch=Ah;Dh=0;Eh=0}Ah=b+500|0;c[Ah>>2]=Eh;c[Ah+4>>2]=Ch|Dh;Dh=c[d+348>>2]|0;if((Dh|0)==-1){xg=ea(g[d+344>>2]);Fh=-1;Gh=0;Hh=(g[k>>2]=xg,c[k>>2]|0)}else{Fh=Dh;Gh=0;Hh=0}Dh=b+508|0;c[Dh>>2]=Hh;c[Dh+4>>2]=Fh|Gh;Gh=c[d+388>>2]|0;if((Gh|0)==-1){xg=ea(g[d+384>>2]);Ih=-1;Jh=0;Kh=(g[k>>2]=xg,c[k>>2]|0)}else{Ih=Gh;Jh=0;Kh=0}Gh=b+516|0;c[Gh>>2]=Kh;c[Gh+4>>2]=Ih|Jh;Jh=c[d+364>>2]|0;if((Jh|0)==-1){xg=ea(g[d+360>>2]);Lh=-1;Mh=0;Nh=(g[k>>2]=xg,c[k>>2]|0)}else{Lh=Jh;Mh=0;Nh=0}Jh=b+524|0;c[Jh>>2]=Nh;c[Jh+4>>2]=Lh|Mh;Mh=c[d+372>>2]|0;if((Mh|0)==-1){xg=ea(g[d+368>>2]);Oh=-1;Ph=0;Qh=(g[k>>2]=xg,c[k>>2]|0)}else{Oh=Mh;Ph=0;Qh=0}Mh=b+532|0;c[Mh>>2]=Qh;c[Mh+4>>2]=Oh|Ph;Ph=c[d+380>>2]|0;if((Ph|0)==-1){xg=ea(g[d+376>>2]);Rh=-1;Sh=0;Th=(g[k>>2]=xg,c[k>>2]|0)}else{Rh=Ph;Sh=0;Th=0}Ph=b+540|0;c[Ph>>2]=Th;c[Ph+4>>2]=Rh|Sh;Sh=c[d+420>>2]|0;if((Sh|0)==-1){xg=ea(g[d+416>>2]);Uh=-1;Vh=0;Wh=(g[k>>2]=xg,c[k>>2]|0)}else{Uh=Sh;Vh=0;Wh=0}Sh=b+548|0;c[Sh>>2]=Wh;c[Sh+4>>2]=Uh|Vh;Vh=c[d+396>>2]|0;if((Vh|0)==-1){xg=ea(g[d+392>>2]);Xh=-1;Yh=0;Zh=(g[k>>2]=xg,c[k>>2]|0)}else{Xh=Vh;Yh=0;Zh=0}Vh=b+556|0;c[Vh>>2]=Zh;c[Vh+4>>2]=Xh|Yh;Yh=c[d+404>>2]|0;if((Yh|0)==-1){xg=ea(g[d+400>>2]);_h=-1;$h=0;ai=(g[k>>2]=xg,c[k>>2]|0)}else{_h=Yh;$h=0;ai=0}Yh=b+564|0;c[Yh>>2]=ai;c[Yh+4>>2]=_h|$h;$h=b+572|0;_h=c[d+412>>2]|0;if((_h|0)!=-1){bi=_h;ci=0;di=0;ei=bi|ci;fi=$h;gi=fi;c[gi>>2]=di;hi=fi+4|0;ii=hi;c[ii>>2]=ei;ji=d+512|0;ki=c[ji>>2]|0;li=b+584|0;c[li>>2]=ki;mi=c[158074]|0;ni=mi+20|0;hwd(b,0,ni,mi);i=f;return}xg=ea(g[d+408>>2]);bi=-1;ci=0;di=(g[k>>2]=xg,c[k>>2]|0);ei=bi|ci;fi=$h;gi=fi;c[gi>>2]=di;hi=fi+4|0;ii=hi;c[ii>>2]=ei;ji=d+512|0;ki=c[ji>>2]|0;li=b+584|0;c[li>>2]=ki;mi=c[158074]|0;ni=mi+20|0;hwd(b,0,ni,mi);i=f;return}function Qvd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;i=i+16|0;j=h;k=h+4|0;l=(c[b+4>>2]|0)-(c[b>>2]|0)>>2;m=c[(ync()|0)+5980>>2]|0;n=xCi(144)|0;Rtd(n,l,d);c[n+116>>2]=e;if(!l){i=h;return n|0}e=(g|0)==0;d=k+1|0;o=k+8|0;p=g+24|0;q=g+4|0;if((m|0)==4){m=0;do{r=c[(c[b>>2]|0)+(m<<2)>>2]|0;if(!(a[r>>0]&1))s=r+1|0;else s=c[r+8>>2]|0;t=Tqc(s)|0;if((t|0)==2){if(e){c[j>>2]=658312;Lsd(k,658192,j);u=0}else{v=c[p>>2]|0;if(!(a[v>>0]|0))w=mo[c[(c[g>>2]|0)+32>>2]&4095](g)|0;else w=v;c[j>>2]=w;Lsd(k,658192,j);u=c[q>>2]|0}Krd((a[k>>0]&1)==0?d:c[o>>2]|0,0,3653512,519,512,u,0,0);xri(k)}else if(!t){t=Rvd(r,f)|0;if(!m)Qtd(t);Utd(n,t)}m=m+1|0}while(m>>>0<l>>>0);i=h;return n|0}else x=0;do{m=c[(c[b>>2]|0)+(x<<2)>>2]|0;if(!((a[621166]|0)==0?(c[m+132>>2]&2048|0)!=0:0))y=5;do if((y|0)==5){y=0;if(!(a[m>>0]&1))z=m+1|0;else z=c[m+8>>2]|0;u=Tqc(z)|0;if(!u){w=Rvd(m,f)|0;if(!x)Qtd(w);Utd(n,w);break}else if((u|0)!=2)break;if(e){c[j>>2]=658312;Lsd(k,658192,j);A=0}else{u=c[p>>2]|0;if(!(a[u>>0]|0))B=mo[c[(c[g>>2]|0)+32>>2]&4095](g)|0;else B=u;c[j>>2]=B;Lsd(k,658192,j);A=c[q>>2]|0}Krd((a[k>>0]&1)==0?d:c[o>>2]|0,0,3653512,519,512,A,0,0);xri(k)}while(0);x=x+1|0}while(x>>>0<l>>>0);i=h;return n|0}function Rvd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+16|0;f=e+4|0;g=e;h=xCi(88)|0;Otd(h,b,d);j=h+44|0;k=b+132|0;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];if((c[(ync()|0)+5980>>2]|0)==15){i=e;return h|0}k=h+4|0;if(!(c[k>>2]|0)){j=0;do{a[k+j+8>>0]=c[b+(j<<2)+12>>2];j=j+1|0}while((j|0)!=28);c[h+8>>2]=c[b+128>>2];j=c[b+124>>2]|0;c[k>>2]=j;if(!j)inc(k,0,0)}Vvd(c[h>>2]|0,b+160|0,b+148|0,-1,d);k=b+196|0;j=c[k>>2]|0;l=c[b+200>>2]|0;if((j|0)!=(l|0)){m=(l-j|0)/40|0;j=c[h>>2]|0;l=j+60|0;n=j+64|0;j=c[n>>2]|0;o=c[l>>2]|0;p=(j-o|0)/28|0;if(m>>>0<=p>>>0){if(m>>>0<p>>>0?(q=o+(m*28|0)|0,(j|0)!=(q|0)):0){o=j;while(1){j=o+-28|0;c[n>>2]=j;if((c[o+-12>>2]|0)>-1){r=o+-24|0;s=c[r>>2]|0;c[g>>2]=c[o+-20>>2];c[f+0>>2]=c[g+0>>2];eOb(s,f);c[r>>2]=0;t=c[n>>2]|0}else t=j;if((t|0)==(q|0))break;else o=t}}}else Wvd(l,m-p|0);p=ync()|0;l=b+212|0;t=b+208|0;o=0;do{q=c[(c[h>>2]|0)+60>>2]|0;n=c[k>>2]|0;g=n+(o*40|0)|0;c[f>>2]=-1;if(!(a[g>>0]&1))u=g+1|0;else u=c[n+(o*40|0)+8>>2]|0;itd(f,u);n=c[f>>2]|0;c[q+(o*28|0)>>2]=n;g=c[k>>2]|0;j=(c[g+(o*40|0)+36>>2]|0)+15&-16;c[q+(o*28|0)+20>>2]=j;r=q+(o*28|0)+24|0;c[r>>2]=-1;q=c[l>>2]|0;s=c[t>>2]|0;if((q|0)!=(s|0)){v=0;do{w=s+(v<<4)|0;x=g+(o*40|0)|0;y=a[w>>0]|0;z=(y&1)==0;if(z)A=(y&255)>>>1;else A=c[s+(v<<4)+4>>2]|0;y=a[x>>0]|0;B=(y&1)==0;if(B)C=(y&255)>>>1;else C=c[g+(o*40|0)+4>>2]|0;a:do if((A|0)==(C|0)){if(z)D=w+1|0;else D=c[s+(v<<4)+8>>2]|0;if(B)E=x+1|0;else E=c[g+(o*40|0)+8>>2]|0;if(z){if(A){y=A;F=D;G=E;while(1){if((a[F>>0]|0)!=(a[G>>0]|0))break a;y=y+-1|0;if(!y)break;else{F=F+1|0;G=G+1|0}}}}else if(FEi(D,E,A)|0)break;c[r>>2]=c[s+(v<<4)+12>>2]}while(0);v=v+1|0}while(v>>>0<q-s>>4>>>0)}co[c[(c[p>>2]|0)+244>>2]&2047](p,n,j);s=c[k>>2]|0;Vvd(c[h>>2]|0,s+(o*40|0)+12|0,s+(o*40|0)+24|0,o,d);o=o+1|0}while(o>>>0<m>>>0)}Oqc(c[h>>2]|0);m=b+176|0;o=b+172|0;k=c[o>>2]|0;if((c[m>>2]|0)!=(k|0)){p=k;k=0;do{A=p+(k*24|0)|0;if(!(a[A>>0]&1))H=A+1|0;else H=c[p+(k*24|0)+8>>2]|0;Lqc(c[h>>2]|0,c[p+(k*24|0)+12>>2]|0,c[p+(k*24|0)+16>>2]|0,H,c[p+(k*24|0)+20>>2]|0,d);k=k+1|0;p=c[o>>2]|0}while(k>>>0<(((c[m>>2]|0)-p|0)/24|0)>>>0)}p=c[h+40>>2]|0;if((p|0)!=0?(m=c[h>>2]|0,((c[m+36>>2]|0)-(c[m+32>>2]|0)>>4|0)>(c[155253]|0)):0)a[p+8>>0]=1;p=b+188|0;m=b+184|0;b=c[m>>2]|0;if((c[p>>2]|0)==(b|0)){i=e;return h|0}else{I=b;J=0}do{b=I+(J<<4)|0;if(!(a[b>>0]&1))K=b+1|0;else K=c[I+(J<<4)+8>>2]|0;Mqc(c[h>>2]|0,c[I+(J<<4)+12>>2]|0,K,d);J=J+1|0;I=c[m>>2]|0}while(J>>>0<(c[p>>2]|0)-I>>4>>>0);i=e;return h|0}function Svd(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;i=i+32|0;m=l+16|0;n=l+12|0;o=l;Fvd(h);p=_vd(b,d,j,h)|0;if(!p){c[g>>2]=0;q=0;i=l;return q|0}c[g>>2]=p;if(Gvd(h)|0){q=0;i=l;return q|0}g=Lvd(p,e,f,h,k)|0;if(!g){q=0;i=l;return q|0}if((c[g>>2]|0)!=(c[g+4>>2]|0)){q=g;i=l;return q|0}if(!(a[p+72>>0]|0)){rri(o,658336,43);Evd(h,o,-1,1,0);xri(o)}o=c[153078]|0;ntd(g);c[n>>2]=o;c[m+0>>2]=c[n+0>>2];eOb(g,m);q=0;i=l;return q|0}function Tvd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b;g=(d-f|0)/24|0;h=a+8|0;j=c[a>>2]|0;k=j;if(g>>>0>(((c[h>>2]|0)-k|0)/24|0)>>>0){Xvd(a);if(g>>>0>178956970)vxi(a);l=((c[h>>2]|0)-(c[a>>2]|0)|0)/24|0;if(l>>>0<89478485){m=l<<1;l=m>>>0<g>>>0?g:m;if(l>>>0>178956970)vxi(a);else n=l}else n=178956970;l=xCi(n*24|0)|0;m=a+4|0;c[m>>2]=l;c[a>>2]=l;c[h>>2]=l+(n*24|0);if((b|0)==(d|0)){i=e;return}else{o=b;p=l}do{sri(p,o);sri(p+12|0,o+12|0);p=(c[m>>2]|0)+24|0;c[m>>2]=p;o=o+24|0}while((o|0)!=(d|0));i=e;return}o=a+4|0;a=((c[o>>2]|0)-k|0)/24|0;if(g>>>0>a>>>0){q=1;r=b+(a*24|0)|0}else{q=0;r=d}if((r|0)==(b|0))s=j;else{a=r+-24-f|0;f=b;b=j;while(1){yri(b,f)|0;yri(b+12|0,f+12|0)|0;f=f+24|0;if((f|0)==(r|0))break;else b=b+24|0}s=j+((((a>>>0)/24|0)+1|0)*24|0)|0}if(!q){while(1){q=c[o>>2]|0;if((q|0)==(s|0))break;a=q+-24|0;c[o>>2]=a;xri(q+-12|0);xri(a)}i=e;return}if((r|0)==(d|0)){i=e;return}s=r;r=c[o>>2]|0;do{if(!r)t=0;else{sri(r,s);sri(r+12|0,s+12|0);t=c[o>>2]|0}r=t+24|0;c[o>>2]=r;s=s+24|0}while((s|0)!=(d|0));i=e;return}function Uvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;b=a+8|0;h=(c[b>>2]|0)+1|0;c[b>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[b>>2]<<2|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[b>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}function Vvd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=e+4|0;k=c[e>>2]|0;if((c[j>>2]|0)!=(k|0)){l=k;k=0;do{m=l+(k*24|0)|0;if(!(a[m>>0]&1))n=m+1|0;else n=c[l+(k*24|0)+8>>2]|0;Jqc(b,c[l+(k*24|0)+16>>2]|0,c[l+(k*24|0)+12>>2]|0,c[l+(k*24|0)+20>>2]|0,n,f,g);k=k+1|0;l=c[e>>2]|0}while(k>>>0<(((c[j>>2]|0)-l|0)/24|0)>>>0)}l=d+4|0;j=c[d>>2]|0;if((c[l>>2]|0)==(j|0)){i=h;return}else{o=j;p=0}do{j=o+(p*24|0)|0;if(!(a[j>>0]&1))q=j+1|0;else q=c[o+(p*24|0)+8>>2]|0;Kqc(b,c[o+(p*24|0)+16>>2]|0,c[o+(p*24|0)+12>>2]|0,q,c[o+(p*24|0)+20>>2]|0,4,f,g);p=p+1|0;o=c[d>>2]|0}while(p>>>0<(((c[l>>2]|0)-o|0)/24|0)>>>0);i=h;return}function Wvd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/28|0)>>>0>=b>>>0){m=b;n=k;do{if(!n)o=0;else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+24>>2]=0;c[n>>2]=-1;c[n+4>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+8>>2]=60;o=c[j>>2]|0}n=o+28|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=d;return}m=c[a>>2]|0;n=((l-m|0)/28|0)+b|0;if(n>>>0>153391689)vxi(a);l=m;m=(h-l|0)/28|0;if(m>>>0<76695844){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/28|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=153391689;t=((c[j>>2]|0)-l|0)/28|0;u=10}if((u|0)==10){p=s;q=xCi(s*28|0)|0;r=t}t=q+(r*28|0)|0;r=b;b=t;while(1){if(!b)v=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b>>2]=-1;c[b+4>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+8>>2]=60;v=b}s=v+28|0;r=r+-1|0;if(!r){w=s;break}else b=s}b=q+(p*28|0)|0;p=c[a>>2]|0;q=c[j>>2]|0;if((q|0)!=(p|0)){r=q;q=t;while(1){v=r;r=r+-28|0;c[q+-28>>2]=c[r>>2];s=c[v+-20>>2]|0;c[q+-20>>2]=s;u=q+-16|0;c[u>>2]=0;l=q+-12|0;c[l>>2]=0;h=q+-24|0;c[h>>2]=0;m=c[v+-24>>2]|0;n=(c[v+-16>>2]|0)*20|0;o=(n|0)/20|0;c[u>>2]=o;if(!n){x=o;y=0}else{c[l>>2]=o;c[f>>2]=s;c[e+0>>2]=c[f+0>>2];s=hOb(0,n,4,e,0,3653512,370)|0;c[h>>2]=s;x=c[u>>2]|0;y=s}YEi(y|0,m|0,x*20|0)|0;m=v+-8|0;v=c[m+4>>2]|0;s=q+-8|0;c[s>>2]=c[m>>2];c[s+4>>2]=v;v=q+-28|0;if((r|0)==(p|0)){z=v;break}else q=v}q=c[a>>2]|0;r=c[j>>2]|0;c[a>>2]=z;c[j>>2]=w;c[g>>2]=b;if((r|0)==(q|0))A=q;else{z=r;do{if((c[z+-12>>2]|0)>-1){r=z+-24|0;x=c[r>>2]|0;c[f>>2]=c[z+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(x,e);c[r>>2]=0}z=z+-28|0}while((z|0)!=(q|0));A=q}}else{c[a>>2]=t;c[j>>2]=w;c[g>>2]=b;A=p}if(!A){i=d;return}ACi(A);i=d;return}function Xvd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}e=a+4|0;while(1){f=c[e>>2]|0;if((f|0)==(d|0))break;g=f+-24|0;c[e>>2]=g;xri(f+-12|0);xri(g)}ACi(c[a>>2]|0);c[a+8>>2]=0;c[e>>2]=0;c[a>>2]=0;i=b;return}function Yvd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;a:do if(!b)d=0;else switch(a|0){case 13:{e=(mCi(b,658560)|0)==0;i=c;return e|0}case 3:{d=(mCi(b,658544)|0)==0;break a;break}case 14:{d=(mCi(b,658528)|0)==0;break a;break}case 12:{d=(mCi(b,658552)|0)==0;break a;break}case 8:{d=(mCi(b,658504)|0)==0;break a;break}case 2:{d=(mCi(b,658536)|0)==0;break a;break}case 6:{d=(mCi(b,658520)|0)==0;break a;break}case 1:{d=(mCi(b,658512)|0)==0;break a;break}case 0:{d=(mCi(b,658496)|0)==0;break a;break}default:{d=0;break a}}while(0);i=c;return d|0}function Zvd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;g[b+52>>2]=ea(2.0);c[b+56>>2]=-1;g[b+28>>2]=ea(0.0);c[b+32>>2]=-1;g[b+36>>2]=ea(0.0);c[b+40>>2]=-1;g[b+44>>2]=ea(0.0);c[b+48>>2]=-1;c[b+516>>2]=0;a[b+76>>0]=0;g[b+80>>2]=ea(0.0);c[b+84>>2]=-1;g[b+144>>2]=ea(0.0);c[b+148>>2]=-1;g[b+152>>2]=ea(0.0);c[b+156>>2]=-1;g[b+160>>2]=ea(0.0);c[b+164>>2]=-1;g[b+168>>2]=ea(1.0);c[b+172>>2]=-1;c[b+176>>2]=-1;g[b+216>>2]=ea(0.0);c[b+220>>2]=-1;g[b+224>>2]=ea(0.0);c[b+228>>2]=-1;g[b+232>>2]=ea(0.0);c[b+236>>2]=-1;g[b+240>>2]=ea(1.0);c[b+244>>2]=-1;c[b+248>>2]=-1;g[b+180>>2]=ea(0.0);c[b+184>>2]=-1;g[b+188>>2]=ea(0.0);c[b+192>>2]=-1;g[b+196>>2]=ea(0.0);c[b+200>>2]=-1;g[b+204>>2]=ea(1.0);c[b+208>>2]=-1;c[b+212>>2]=-1;g[b+252>>2]=ea(0.0);c[b+256>>2]=-1;g[b+260>>2]=ea(0.0);c[b+264>>2]=-1;g[b+268>>2]=ea(0.0);c[b+272>>2]=-1;g[b+276>>2]=ea(1.0);c[b+280>>2]=-1;c[b+284>>2]=-1;g[b+288>>2]=ea(0.0);c[b+292>>2]=-1;g[b+296>>2]=ea(0.0);c[b+300>>2]=-1;g[b+304>>2]=ea(0.0);c[b+308>>2]=-1;g[b+312>>2]=ea(1.0);c[b+316>>2]=-1;c[b+320>>2]=-1;g[b+12>>2]=ea(4.0);c[b+16>>2]=-1;g[b+136>>2]=ea(15.0);c[b+140>>2]=-1;g[b+20>>2]=ea(1.0);c[b+24>>2]=-1;a[b+324>>0]=0;g[b+88>>2]=ea(1.0);c[b+92>>2]=-1;g[b+96>>2]=ea(0.0);c[b+100>>2]=-1;g[b+104>>2]=ea(1.0);c[b+108>>2]=-1;g[b+112>>2]=ea(0.0);c[b+116>>2]=-1;g[b+120>>2]=ea(0.0);c[b+124>>2]=-1;g[b+128>>2]=ea(0.0);c[b+132>>2]=-1;c[e>>2]=-1;itd(e,658568);c[b+504>>2]=c[e>>2];c[b+508>>2]=-1;c[e>>2]=-1;itd(e,658584);c[b+452>>2]=c[e>>2];c[e>>2]=-1;itd(e,658600);c[b+460>>2]=c[e>>2];c[e>>2]=-1;itd(e,658616);c[b+468>>2]=c[e>>2];g[b+60>>2]=ea(0.0);c[b+64>>2]=-1;g[b+68>>2]=ea(0.0);c[b+72>>2]=-1;c[b+512>>2]=-1;c[b+652>>2]=0;g[b+424>>2]=ea(255.0);c[b+428>>2]=-1;g[b+432>>2]=ea(255.0);c[b+436>>2]=-1;g[b+440>>2]=ea(0.0);c[b+444>>2]=-1;e=b+328|0;g[b+352>>2]=ea(8.0);c[b+356>>2]=-1;g[e>>2]=ea(0.0);c[b+332>>2]=-1;g[b+336>>2]=ea(0.0);c[b+340>>2]=-1;g[b+344>>2]=ea(0.0);c[b+348>>2]=-1;f=b+360|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];c[f+24>>2]=c[e+24>>2];c[f+28>>2]=c[e+28>>2];f=b+392|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];c[f+24>>2]=c[e+24>>2];c[f+28>>2]=c[e+28>>2];i=d;return}function _vd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=i;i=i+736|0;h=g;j=g+692|0;k=g+688|0;l=g+16|0;m=g+32|0;n=g+12|0;o=g+20|0;p=g+696|0;q=g+712|0;if(((d>>>0>2?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)?(a[b+2>>0]|0)==-65:0){r=b+3|0;s=d+-3|0}else{r=b;s=d}c[163376]=e;$vd(m);Zvd(m);zri(653480,658640)|0;e=c[163364]|0;d=c[163363]|0;if((e|0)==(d|0))t=0;else t=(e-d<<8)+-1|0;b=c[163366]|0;u=c[163367]|0;if((t-b|0)==(u|0)){rvd(653448);v=c[163367]|0;w=c[163366]|0;x=c[163364]|0;y=c[163363]|0}else{v=u;w=b;x=e;y=d}d=v+w|0;if((x|0)!=(y|0)?(x=(c[y+(d>>>10<<2)>>2]|0)+((d&1023)<<2)|0,(x|0)!=0):0)c[x>>2]=m;c[163367]=v+1;c[163374]=f;if(!(a[653480]&1)){a[653481]=0;a[653480]=0}else{a[c[163372]>>0]=0;c[163371]=0}c[n>>2]=c[153078];c[h+0>>2]=c[n+0>>2];n=bOb(76,h,0,16,3653512,160)|0;f=n+0|0;v=f+72|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(v|0));a[n+72>>0]=0;c[163368]=n;f=xCi(64)|0;pPb(f,32768,658744);c[164622]=f;Sud(r,s);s=Xud()|0;Tud();r=c[164622]|0;if(r)ko[c[(c[r>>2]|0)+4>>2]&4095](r);c[164622]=0;r=o+4|0;c[r>>2]=0;c[o+8>>2]=0;f=o+4|0;c[o>>2]=f;v=c[163374]|0;if((o|0)==(v|0)){z=o;A=0}else{c[k>>2]=c[v>>2];c[l>>2]=v+4;c[j+0>>2]=c[k+0>>2];c[h+0>>2]=c[l+0>>2];awd(o,j,h);v=c[163374]|0;z=v;A=c[v+4>>2]|0}fmd(z,A);c[z+8>>2]=0;A=z+4|0;c[z>>2]=A;c[A>>2]=0;A=c[163374]|0;if((A|0)!=(o|0)){c[k>>2]=c[o>>2];c[l>>2]=f;c[j+0>>2]=c[k+0>>2];c[h+0>>2]=c[l+0>>2];awd(A,j,h)}fmd(o,c[r>>2]|0);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[p+0>>2]=c[163370];c[p+4>>2]=c[163371];c[p+8>>2]=c[163372];c[163370]=c[h+0>>2];c[163371]=c[h+4>>2];c[163372]=c[h+8>>2];yri(653480,p)|0;xri(p);c[163368]=0;c[163374]=0;p=c[163367]|0;r=0-p|0;if(p>>>0>1){o=r;A=p;while(1){f=c[163366]|0;z=A+-1|0;v=f+z|0;x=c[163363]|0;d=c[(c[x+(v>>>10<<2)>>2]|0)+((v&1023)<<2)>>2]|0;c[163367]=z;z=c[163364]|0;if((z|0)==(x|0))B=0;else B=(z-x<<8)+-1|0;if((o+1+B-f|0)>>>0>2047){ACi(c[z+-4>>2]|0);c[163364]=(c[163364]|0)+-4}if(d){Ntd(d+640|0,c[d+644>>2]|0);if(a[d>>0]&1){z=c[d+8>>2]|0;c[k>>2]=58;c[h+0>>2]=c[k+0>>2];eOb(z,h)}ACi(d)}d=c[163367]|0;z=0-d|0;if(d>>>0>1){o=z;A=d}else{C=d;D=z;break}}}else{C=p;D=r}r=C+-1|0;c[163367]=r;C=c[163364]|0;p=c[163363]|0;if((C|0)==(p|0))E=0;else E=(C-p<<8)+-1|0;A=c[163366]|0;if((D+1+E-A|0)>>>0>2047){ACi(c[C+-4>>2]|0);E=(c[163364]|0)+-4|0;c[163364]=E;F=c[163363]|0;G=E;H=c[163366]|0;I=c[163367]|0}else{F=p;G=C;H=A;I=r};c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;r=c[163362]|0;c[163362]=0;c[q>>2]=r;c[163363]=0;c[q+4>>2]=F;c[163364]=0;c[q+8>>2]=G;G=c[163365]|0;c[163365]=0;c[q+12>>2]=G;c[163366]=0;c[q+16>>2]=H;c[163367]=0;c[q+20>>2]=I;pvd(q);if(!s)J=n;else{s=c[153078]|0;if(n)Lwd(n);c[j>>2]=s;c[h+0>>2]=c[j+0>>2];eOb(n,h);J=0}Ntd(m+640|0,c[m+644>>2]|0);if(!(a[m>>0]&1)){i=g;return J|0}n=c[m+8>>2]|0;c[l>>2]=58;c[h+0>>2]=c[l+0>>2];eOb(n,h);i=g;return J|0}function $vd(a){a=a|0;var b=0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=-1;g[a+20>>2]=ea(0.0);c[a+24>>2]=-1;g[a+28>>2]=ea(0.0);c[a+32>>2]=-1;g[a+36>>2]=ea(0.0);c[a+40>>2]=-1;g[a+44>>2]=ea(0.0);c[a+48>>2]=-1;g[a+52>>2]=ea(0.0);c[a+56>>2]=-1;g[a+60>>2]=ea(0.0);c[a+64>>2]=-1;g[a+68>>2]=ea(0.0);c[a+72>>2]=-1;g[a+80>>2]=ea(0.0);c[a+84>>2]=-1;g[a+88>>2]=ea(0.0);c[a+92>>2]=-1;g[a+96>>2]=ea(0.0);c[a+100>>2]=-1;g[a+104>>2]=ea(0.0);c[a+108>>2]=-1;g[a+112>>2]=ea(0.0);c[a+116>>2]=-1;g[a+120>>2]=ea(0.0);c[a+124>>2]=-1;g[a+128>>2]=ea(0.0);c[a+132>>2]=-1;g[a+136>>2]=ea(0.0);c[a+140>>2]=-1;g[a+144>>2]=ea(0.0);c[a+148>>2]=-1;g[a+152>>2]=ea(0.0);c[a+156>>2]=-1;g[a+160>>2]=ea(0.0);c[a+164>>2]=-1;g[a+168>>2]=ea(0.0);c[a+172>>2]=-1;c[a+176>>2]=-1;g[a+180>>2]=ea(0.0);c[a+184>>2]=-1;g[a+188>>2]=ea(0.0);c[a+192>>2]=-1;g[a+196>>2]=ea(0.0);c[a+200>>2]=-1;g[a+204>>2]=ea(0.0);c[a+208>>2]=-1;c[a+212>>2]=-1;g[a+216>>2]=ea(0.0);c[a+220>>2]=-1;g[a+224>>2]=ea(0.0);c[a+228>>2]=-1;g[a+232>>2]=ea(0.0);c[a+236>>2]=-1;g[a+240>>2]=ea(0.0);c[a+244>>2]=-1;c[a+248>>2]=-1;g[a+252>>2]=ea(0.0);c[a+256>>2]=-1;g[a+260>>2]=ea(0.0);c[a+264>>2]=-1;g[a+268>>2]=ea(0.0);c[a+272>>2]=-1;g[a+276>>2]=ea(0.0);c[a+280>>2]=-1;c[a+284>>2]=-1;g[a+288>>2]=ea(0.0);c[a+292>>2]=-1;g[a+296>>2]=ea(0.0);c[a+300>>2]=-1;g[a+304>>2]=ea(0.0);c[a+308>>2]=-1;g[a+312>>2]=ea(0.0);c[a+316>>2]=-1;c[a+320>>2]=-1;g[a+328>>2]=ea(0.0);c[a+332>>2]=-1;g[a+336>>2]=ea(0.0);c[a+340>>2]=-1;g[a+344>>2]=ea(0.0);c[a+348>>2]=-1;g[a+352>>2]=ea(0.0);c[a+356>>2]=-1;g[a+360>>2]=ea(0.0);c[a+364>>2]=-1;g[a+368>>2]=ea(0.0);c[a+372>>2]=-1;g[a+376>>2]=ea(0.0);c[a+380>>2]=-1;g[a+384>>2]=ea(0.0);c[a+388>>2]=-1;g[a+392>>2]=ea(0.0);c[a+396>>2]=-1;g[a+400>>2]=ea(0.0);c[a+404>>2]=-1;g[a+408>>2]=ea(0.0);c[a+412>>2]=-1;g[a+416>>2]=ea(0.0);c[a+420>>2]=-1;g[a+424>>2]=ea(0.0);c[a+428>>2]=-1;g[a+432>>2]=ea(0.0);c[a+436>>2]=-1;g[a+440>>2]=ea(0.0);c[a+444>>2]=-1;g[a+448>>2]=ea(0.0);c[a+452>>2]=-1;g[a+456>>2]=ea(0.0);c[a+460>>2]=-1;g[a+464>>2]=ea(0.0);c[a+468>>2]=-1;g[a+472>>2]=ea(0.0);c[a+476>>2]=-1;g[a+480>>2]=ea(0.0);c[a+484>>2]=-1;g[a+488>>2]=ea(0.0);c[a+492>>2]=-1;g[a+496>>2]=ea(0.0);c[a+500>>2]=-1;c[a+504>>2]=-1;Hwd(a+520|0);c[a+644>>2]=0;c[a+648>>2]=0;c[a+640>>2]=a+644;i=b;return}function awd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+16|0;f=e;g=a+8|0;a:do if((c[g>>2]|0)!=0?(h=c[a>>2]|0,j=a+4|0,c[a>>2]=j,c[(c[j>>2]|0)+8>>2]=0,c[j>>2]=0,c[g>>2]=0,k=c[h+4>>2]|0,l=(k|0)==0?h:k,(l|0)!=0):0){k=a+4|0;h=c[b>>2]|0;m=l;while(1){if((h|0)==(c[d>>2]|0)){n=m;break}l=m+16|0;bwd(l,h+16|0)|0;o=m+8|0;p=c[o>>2]|0;do if(p){q=c[p>>2]|0;if((q|0)==(m|0)){c[p>>2]=0;r=c[p+4>>2]|0;if(!r){s=p;break}else t=r;while(1){r=c[t>>2]|0;if(r){t=r;continue}r=c[t+4>>2]|0;if(!r){u=t;break}else t=r}s=u;break}else{c[p+4>>2]=0;if(!q){s=p;break}else v=q;while(1){r=c[v>>2]|0;if(r){v=r;continue}r=c[v+4>>2]|0;if(!r){w=v;break}else v=r}s=w;break}}else s=0;while(0);p=c[k>>2]|0;if(!p){x=j;y=j}else{q=p;while(1)if(Jvd(l,q+16|0)|0){p=c[q>>2]|0;if(!p){x=q;y=q;break}else{q=p;continue}}else{p=q+4|0;r=c[p>>2]|0;if(!r){x=p;y=q;break}else{q=r;continue}}}c[m>>2]=0;c[m+4>>2]=0;c[o>>2]=y;c[x>>2]=m;q=c[c[a>>2]>>2]|0;if(!q)z=m;else{c[a>>2]=q;z=c[x>>2]|0}GN(c[k>>2]|0,z);c[g>>2]=(c[g>>2]|0)+1;q=c[b>>2]|0;l=c[q+4>>2]|0;if(!l){r=q;while(1){q=c[r+8>>2]|0;if((c[q>>2]|0)==(r|0)){A=q;break}else r=q}}else{r=l;while(1){o=c[r>>2]|0;if(!o){A=r;break}else r=o}}c[b>>2]=A;if(!s)break a;else{h=A;m=s}}m=c[n+8>>2]|0;if(!m)B=n;else{h=m;while(1){m=c[h+8>>2]|0;if(!m){C=h;break}else h=m}B=C}fmd(a,B)}while(0);B=c[b>>2]|0;C=c[d>>2]|0;if((B|0)==(C|0)){i=e;return}else D=B;while(1){cwd(f,a,D+16|0);B=c[D+4>>2]|0;if(!B){d=D;while(1){n=c[d+8>>2]|0;if((c[n>>2]|0)==(d|0)){E=n;break}else d=n}}else{d=B;while(1){n=c[d>>2]|0;if(!n){E=d;break}else d=n}}c[b>>2]=E;if((E|0)==(C|0))break;else D=E}i=e;return}function bwd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;g=(d|0)==(e|0);do if(!g){h=a[e>>0]|0;if(!(h&1)){j=(h&255)>>>1;k=e+1|0}else{j=c[e+4>>2]|0;k=c[e+8>>2]|0}h=a[d>>0]|0;if(!(h&1)){l=10;m=h}else{h=c[d>>2]|0;l=(h&-2)+-1|0;m=h&255}h=(m&1)==0;do if(j>>>0<=l>>>0){if(h)n=d+1|0;else n=c[d+8>>2]|0;aFi(n|0,k|0,j|0)|0;a[n+j>>0]=0;if(!(a[d>>0]&1)){a[d>>0]=j<<1;break}else{c[d+4>>2]=j;break}}else{if(h)o=(m&255)>>>1;else o=c[d+4>>2]|0;eXb(d,l,j-l|0,o,0,o,j,k)}while(0);h=d+12|0;p=e+12|0;if(!g){q=a[p>>0]|0;if(!(q&1)){r=(q&255)>>>1;s=p+1|0}else{r=c[e+16>>2]|0;s=c[e+20>>2]|0}p=a[h>>0]|0;if(!(p&1)){t=10;u=p}else{p=c[h>>2]|0;t=(p&-2)+-1|0;u=p&255}p=(u&1)==0;do if(r>>>0<=t>>>0){if(p)v=h+1|0;else v=c[d+20>>2]|0;aFi(v|0,s|0,r|0)|0;a[v+r>>0]=0;if(!(a[h>>0]&1)){a[h>>0]=r<<1;break}else{c[d+16>>2]=r;break}}else{if(p)w=(u&255)>>>1;else w=c[d+16>>2]|0;eXb(h,t,r-t|0,w,0,w,r,s)}while(0);h=d+24|0;p=e+24|0;if(!g){q=a[p>>0]|0;if(!(q&1)){x=(q&255)>>>1;y=p+1|0}else{x=c[e+28>>2]|0;y=c[e+32>>2]|0}p=a[h>>0]|0;if(!(p&1)){z=10;A=p}else{p=c[h>>2]|0;z=(p&-2)+-1|0;A=p&255}p=(A&1)==0;if(x>>>0>z>>>0){if(p)B=(A&255)>>>1;else B=c[d+28>>2]|0;eXb(h,z,x-z|0,B,0,B,x,y);break}if(p)C=h+1|0;else C=c[d+32>>2]|0;aFi(C|0,y|0,x|0)|0;a[C+x>>0]=0;if(!(a[h>>0]&1)){a[h>>0]=x<<1;break}else{c[d+28>>2]=x;break}}}}while(0);x=d+36|0;C=e+36|0;c[x+0>>2]=c[C+0>>2];c[x+4>>2]=c[C+4>>2];b[x+8>>1]=b[C+8>>1]|0;i=f;return d|0}function cwd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=b+4|0;g=c[f>>2]|0;if(!g){h=b+4|0;j=h;k=h}else{h=g;while(1)if(Jvd(d,h+16|0)|0){g=c[h>>2]|0;if(!g){j=h;k=h;break}else{h=g;continue}}else{g=h+4|0;l=c[g>>2]|0;if(!l){j=g;k=h;break}else{h=l;continue}}}h=xCi(64)|0;Kvd(h+16|0,d);c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=k;c[j>>2]=h;k=c[c[b>>2]>>2]|0;if(!k)m=h;else{c[b>>2]=k;m=c[j>>2]|0}GN(c[f>>2]|0,m);m=b+8|0;c[m>>2]=(c[m>>2]|0)+1;c[a>>2]=h;i=e;return}function dwd(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;c[b>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=60;d=b+16|0;g[d>>2]=ea(0.0);e=b+20|0;c[e>>2]=-1;f=b+24|0;g[f>>2]=ea(0.0);h=b+28|0;c[h>>2]=-1;i=b+32|0;g[i>>2]=ea(0.0);j=b+36|0;c[j>>2]=-1;k=b+40|0;g[k>>2]=ea(0.0);l=b+44|0;c[l>>2]=-1;m=b+48|0;g[m>>2]=ea(0.0);n=b+52|0;c[n>>2]=-1;o=b+56|0;g[o>>2]=ea(0.0);p=b+60|0;c[p>>2]=-1;q=b+64|0;c[q>>2]=-1;r=b+68|0;g[r>>2]=ea(0.0);s=b+72|0;c[s>>2]=-1;t=b+76|0;g[t>>2]=ea(0.0);u=b+80|0;c[u>>2]=-1;v=b+84|0;g[v>>2]=ea(0.0);w=b+88|0;c[w>>2]=-1;x=b+92|0;g[x>>2]=ea(0.0);y=b+96|0;c[y>>2]=-1;z=b+100|0;c[z>>2]=-1;A=b+104|0;g[A>>2]=ea(0.0);B=b+108|0;c[B>>2]=-1;C=b+112|0;g[C>>2]=ea(0.0);D=b+116|0;c[D>>2]=-1;E=b+120|0;g[E>>2]=ea(0.0);F=b+124|0;c[F>>2]=-1;G=b+128|0;g[G>>2]=ea(0.0);H=b+132|0;c[H>>2]=-1;I=b+136|0;c[I>>2]=-1;J=b+140|0;g[J>>2]=ea(0.0);K=b+144|0;c[K>>2]=-1;L=b+148|0;g[L>>2]=ea(0.0);M=b+152|0;c[M>>2]=-1;N=b+156|0;g[N>>2]=ea(0.0);O=b+160|0;c[O>>2]=-1;P=b+164|0;g[P>>2]=ea(0.0);Q=b+168|0;c[Q>>2]=-1;R=b+172|0;c[R>>2]=-1;S=b+176|0;g[S>>2]=ea(0.0);T=b+180|0;c[T>>2]=-1;U=b+184|0;g[U>>2]=ea(0.0);V=b+188|0;c[V>>2]=-1;W=b+192|0;g[W>>2]=ea(0.0);X=b+196|0;c[X>>2]=-1;Y=b+200|0;g[Y>>2]=ea(0.0);Z=b+204|0;c[Z>>2]=-1;_=b+208|0;c[_>>2]=-1;$=b+212|0;g[$>>2]=ea(0.0);aa=b+216|0;c[aa>>2]=-1;ba=b+224|0;g[ba>>2]=ea(0.0);ca=b+228|0;c[ca>>2]=-1;da=b+232|0;g[da>>2]=ea(0.0);fa=b+236|0;c[fa>>2]=-1;ga=b+240|0;g[ga>>2]=ea(0.0);ha=b+244|0;c[ha>>2]=-1;ia=b+248|0;g[ia>>2]=ea(0.0);ja=b+252|0;c[ja>>2]=-1;ka=b+256|0;g[ka>>2]=ea(0.0);la=b+260|0;c[la>>2]=-1;ma=b+264|0;g[ma>>2]=ea(0.0);na=b+268|0;c[na>>2]=-1;oa=b+272|0;g[oa>>2]=ea(0.0);pa=b+276|0;c[pa>>2]=-1;qa=b+280|0;c[qa>>2]=-1;c[b+316>>2]=0;c[b+324>>2]=0;c[b+328>>2]=0;c[b+320>>2]=60;a[b+332>>0]=0;c[b+336>>2]=0;c[b+344>>2]=0;c[b+348>>2]=0;c[b+340>>2]=60;a[b+352>>0]=0;g[b+356>>2]=ea(0.0);c[b+360>>2]=-1;g[b+364>>2]=ea(0.0);c[b+368>>2]=-1;g[b+372>>2]=ea(0.0);c[b+376>>2]=-1;g[b+380>>2]=ea(0.0);c[b+384>>2]=-1;g[b+388>>2]=ea(0.0);c[b+392>>2]=-1;g[b+396>>2]=ea(0.0);c[b+400>>2]=-1;g[b+404>>2]=ea(0.0);c[b+408>>2]=-1;g[b+412>>2]=ea(0.0);c[b+416>>2]=-1;g[b+420>>2]=ea(0.0);c[b+424>>2]=-1;g[b+428>>2]=ea(0.0);c[b+432>>2]=-1;g[b+436>>2]=ea(0.0);c[b+440>>2]=-1;g[b+444>>2]=ea(0.0);c[b+448>>2]=-1;g[b+452>>2]=ea(0.0);c[b+456>>2]=-1;g[b+460>>2]=ea(0.0);c[b+464>>2]=-1;c[b+488>>2]=-1;g[b+484>>2]=ea(8.0);c[b+496>>2]=-1;g[b+492>>2]=ea(0.0);c[b+504>>2]=-1;g[b+500>>2]=ea(0.0);c[b+512>>2]=-1;g[b+508>>2]=ea(0.0);c[b+520>>2]=-1;g[b+516>>2]=ea(8.0);c[b+528>>2]=-1;g[b+524>>2]=ea(0.0);c[b+536>>2]=-1;g[b+532>>2]=ea(0.0);c[b+544>>2]=-1;g[b+540>>2]=ea(0.0);c[b+552>>2]=-1;g[b+548>>2]=ea(8.0);c[b+560>>2]=-1;g[b+556>>2]=ea(0.0);c[b+568>>2]=-1;g[b+564>>2]=ea(0.0);c[b+576>>2]=-1;g[b+572>>2]=ea(0.0);c[b+472>>2]=-1;g[b+468>>2]=ea(255.0);c[b+480>>2]=-1;g[b+476>>2]=ea(255.0);c[b+580>>2]=0;c[b+584>>2]=-1;ra=b+292|0;c[ra+0>>2]=0;c[ra+4>>2]=0;c[ra+8>>2]=0;c[ra+12>>2]=0;c[ra+16>>2]=0;c[ra+20>>2]=0;c[e>>2]=-1;g[d>>2]=ea(0.0);c[h>>2]=-1;g[f>>2]=ea(0.0);c[b+288>>2]=0;a[b+220>>0]=0;c[q>>2]=-1;c[j>>2]=-1;g[i>>2]=ea(0.0);c[l>>2]=-1;g[k>>2]=ea(0.0);c[n>>2]=-1;g[m>>2]=ea(0.0);c[p>>2]=-1;g[o>>2]=ea(1.0);c[I>>2]=-1;c[B>>2]=-1;g[A>>2]=ea(0.0);c[D>>2]=-1;g[C>>2]=ea(0.0);c[F>>2]=-1;g[E>>2]=ea(0.0);c[H>>2]=-1;g[G>>2]=ea(1.0);c[z>>2]=-1;c[s>>2]=-1;g[r>>2]=ea(0.0);c[u>>2]=-1;g[t>>2]=ea(0.0);c[w>>2]=-1;g[v>>2]=ea(0.0);c[y>>2]=-1;g[x>>2]=ea(1.0);c[R>>2]=-1;c[K>>2]=-1;g[J>>2]=ea(0.0);c[M>>2]=-1;g[L>>2]=ea(0.0);c[O>>2]=-1;g[N>>2]=ea(0.0);c[Q>>2]=-1;g[P>>2]=ea(1.0);c[_>>2]=-1;c[T>>2]=-1;g[S>>2]=ea(0.0);c[V>>2]=-1;g[U>>2]=ea(0.0);c[X>>2]=-1;g[W>>2]=ea(0.0);c[Z>>2]=-1;g[Y>>2]=ea(1.0);a[b+221>>0]=0;c[qa>>2]=-1;c[ja>>2]=-1;g[ia>>2]=ea(0.0);c[la>>2]=-1;g[ka>>2]=ea(0.0);c[na>>2]=-1;g[ma>>2]=ea(0.0);c[pa>>2]=-1;g[oa>>2]=ea(0.0);c[b+284>>2]=0;c[ca>>2]=-1;g[ba>>2]=ea(0.0);c[fa>>2]=-1;g[da>>2]=ea(1.0);c[ha>>2]=-1;g[ga>>2]=ea(1.0);c[aa>>2]=-1;g[$>>2]=ea(0.0);return}function ewd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=Im,F=0,G=0,H=0;h=i;i=i+16|0;j=h+8|0;k=h+4|0;l=h;m=c[b+4>>2]|0;if((m|0)==-1)n=b;else{c[l>>2]=m;c[j+0>>2]=c[l+0>>2];n=zvd(d,e,j,k)|0}m=~~ea(g[n>>2]);if((m|0)<0)o=0;else o=(m|0)>10?10:m&255;a[f+4>>0]=o;o=c[b+12>>2]|0;if((o|0)==-1)p=b+8|0;else{c[l>>2]=o;c[j+0>>2]=c[l+0>>2];p=zvd(d,e,j,k)|0}o=~~ea(g[p>>2]);if((o|0)<0)q=0;else q=(o|0)>10?10:o&255;a[f+5>>0]=q;q=c[b+20>>2]|0;if((q|0)==-1)r=b+16|0;else{c[l>>2]=q;c[j+0>>2]=c[l+0>>2];r=zvd(d,e,j,k)|0}q=~~ea(g[r>>2]);if((q|0)<0)s=0;else s=(q|0)>10?10:q&255;a[f+6>>0]=s;s=c[b+28>>2]|0;if((s|0)==-1)t=b+24|0;else{c[l>>2]=s;c[j+0>>2]=c[l+0>>2];t=zvd(d,e,j,k)|0}s=~~ea(g[t>>2]);if((s|0)<0)u=0;else u=(s|0)>10?10:s&255;a[f+7>>0]=u;u=c[b+36>>2]|0;if((u|0)==-1)v=b+32|0;else{c[l>>2]=u;c[j+0>>2]=c[l+0>>2];v=zvd(d,e,j,k)|0}u=~~ea(g[v>>2]);if((u|0)<0)w=0;else w=(u|0)>20?20:u&255;a[f+8>>0]=w;w=c[b+44>>2]|0;if((w|0)==-1)x=b+40|0;else{c[l>>2]=w;c[j+0>>2]=c[l+0>>2];x=zvd(d,e,j,k)|0}w=~~ea(g[x>>2]);if((w|0)<0)y=0;else y=(w|0)>20?20:w&255;a[f+9>>0]=y;y=c[b+52>>2]|0;if((y|0)==-1)z=b+48|0;else{c[l>>2]=y;c[j+0>>2]=c[l+0>>2];z=zvd(d,e,j,k)|0}y=~~ea(g[z>>2]);if((y|0)<0)A=0;else A=(y|0)>15?15:y;c[f>>2]=A;A=c[b+60>>2]|0;if((A|0)==-1)B=b+56|0;else{c[l>>2]=A;c[j+0>>2]=c[l+0>>2];B=zvd(d,e,j,k)|0}A=~~ea(g[B>>2]);if((A|0)<0)C=0;else C=(A|0)>8?8:A&255;a[f+10>>0]=C;C=c[b+68>>2]|0;if((C|0)==-1){D=b+64|0;E=ea(g[D>>2]);F=E!=ea(0.0);G=f+11|0;H=F&1;a[G>>0]=H;i=h;return}else{c[l>>2]=C;c[j+0>>2]=c[l+0>>2];D=zvd(d,e,j,k)|0;E=ea(g[D>>2]);F=E!=ea(0.0);G=f+11|0;H=F&1;a[G>>0]=H;i=h;return}}function fwd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;l=c[a+4>>2]|0;if((l|0)==-1)m=a;else{c[k>>2]=l;c[h+0>>2]=c[k+0>>2];m=zvd(b,d,h,j)|0}l=~~ea(g[m>>2]);if((l|0)<0)n=0;else n=(l|0)>2?2:l;c[e>>2]=n;n=c[a+12>>2]|0;if((n|0)==-1)o=a+8|0;else{c[k>>2]=n;c[h+0>>2]=c[k+0>>2];o=zvd(b,d,h,j)|0}c[e+4>>2]=~~ea(g[o>>2]);o=c[a+20>>2]|0;if((o|0)==-1){p=a+16|0;q=ea(g[p>>2]);r=e+8|0;g[r>>2]=q;i=f;return}else{c[k>>2]=o;c[h+0>>2]=c[k+0>>2];p=zvd(b,d,h,j)|0;q=ea(g[p>>2]);r=e+8|0;g[r>>2]=q;i=f;return}}function gwd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;n=c[b+4>>2]|0;if((n|0)==-1)o=b;else{c[m>>2]=n;c[k+0>>2]=c[m+0>>2];o=zvd(d,e,k,l)|0}a[h+1>>0]=~~ea(g[o>>2]);o=c[b+12>>2]|0;if((o|0)==-1)p=b+8|0;else{c[m>>2]=o;c[k+0>>2]=c[m+0>>2];p=zvd(d,e,k,l)|0}a[h+2>>0]=~~ea(g[p>>2]);p=b+48|0;o=b+80|0;n=b+16|0;if((((((((c[b+28>>2]|0)==-1?ea(g[b+24>>2])==ea(0.0):0)?(c[b+36>>2]|0)==-1:0)?ea(g[b+32>>2])==ea(0.0):0)?(c[b+44>>2]|0)==-1:0)?ea(g[b+40>>2])==ea(0.0):0)?(c[b+20>>2]|0)==-1:0)?ea(g[n>>2])==ea(8.0):0){q=o;r=p}else s=15;do if((s|0)==15){b=c[f>>2]|0;if(!b){q=n;r=n;break}else if((b|0)==1){q=n;r=p;break}else{q=o;r=n;break}}while(0);n=r+12|0;if(!((((((((c[n>>2]|0)==-1?ea(g[r+8>>2])==ea(0.0):0)?(c[r+20>>2]|0)==-1:0)?ea(g[r+16>>2])==ea(0.0):0)?(c[r+28>>2]|0)==-1:0)?ea(g[r+24>>2])==ea(0.0):0)?(c[r+4>>2]|0)==-1:0)?ea(g[r>>2])==ea(8.0):0)){o=c[r+4>>2]|0;if((o|0)==-1)t=r;else{c[m>>2]=o;c[k+0>>2]=c[m+0>>2];t=zvd(d,e,k,l)|0}o=~~ea(g[t>>2]);if((o|0)<0)u=0;else u=(o|0)>8?8:o&255;a[h+4>>0]=u;u=c[n>>2]|0;if((u|0)==-1)v=r+8|0;else{c[m>>2]=u;c[k+0>>2]=c[m+0>>2];v=zvd(d,e,k,l)|0}u=~~ea(g[v>>2]);if((u|0)<0)w=0;else w=(u|0)>7?7:u&255;a[h+5>>0]=w;w=c[r+20>>2]|0;if((w|0)==-1)x=r+16|0;else{c[m>>2]=w;c[k+0>>2]=c[m+0>>2];x=zvd(d,e,k,l)|0}w=~~ea(g[x>>2]);if((w|0)<0)y=0;else y=(w|0)>7?7:w&255;a[h+6>>0]=y;y=c[r+28>>2]|0;if((y|0)==-1)z=r+24|0;else{c[m>>2]=y;c[k+0>>2]=c[m+0>>2];z=zvd(d,e,k,l)|0}y=~~ea(g[z>>2]);if((y|0)<0)A=0;else A=(y|0)>7?7:y&255;a[h+7>>0]=A;a[h>>0]=1}A=q+12|0;if((((((((c[A>>2]|0)==-1?ea(g[q+8>>2])==ea(0.0):0)?(c[q+20>>2]|0)==-1:0)?ea(g[q+16>>2])==ea(0.0):0)?(c[q+28>>2]|0)==-1:0)?ea(g[q+24>>2])==ea(0.0):0)?(c[q+4>>2]|0)==-1:0)?ea(g[q>>2])==ea(8.0):0){i=j;return}y=c[q+4>>2]|0;if((y|0)==-1)B=q;else{c[m>>2]=y;c[k+0>>2]=c[m+0>>2];B=zvd(d,e,k,l)|0}y=~~ea(g[B>>2]);if((y|0)<0)C=0;else C=(y|0)>8?8:y&255;a[h+8>>0]=C;C=c[A>>2]|0;if((C|0)==-1)D=q+8|0;else{c[m>>2]=C;c[k+0>>2]=c[m+0>>2];D=zvd(d,e,k,l)|0}C=~~ea(g[D>>2]);if((C|0)<0)E=0;else E=(C|0)>7?7:C&255;a[h+9>>0]=E;E=c[q+20>>2]|0;if((E|0)==-1)F=q+16|0;else{c[m>>2]=E;c[k+0>>2]=c[m+0>>2];F=zvd(d,e,k,l)|0}E=~~ea(g[F>>2]);if((E|0)<0)G=0;else G=(E|0)>7?7:E&255;a[h+10>>0]=G;G=c[q+28>>2]|0;if((G|0)==-1)H=q+24|0;else{c[m>>2]=G;c[k+0>>2]=c[m+0>>2];H=zvd(d,e,k,l)|0}l=~~ea(g[H>>2]);if((l|0)<0)I=0;else I=(l|0)>7?7:l&255;a[h+11>>0]=I;a[h>>0]=1;i=j;return}function hwd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+64|0;j=h+24|0;k=h+32|0;l=h+28|0;m=h+36|0;n=h+48|0;o=h;p=h+12|0;q=b+8|0;r=c[q>>2]|0;a:do if(r){s=c[b>>2]|0;t=0;while(1){if((c[s+(t*20|0)>>2]|0)==(d|0))break;t=t+1|0;if((t|0)==(r|0))break a}i=h;return}while(0);t=r+1|0;c[q>>2]=t;r=b+12|0;s=c[r>>2]|0;u=s&2147483647;if(t>>>0>u>>>0){v=s<<1;w=(v|0)==0?1:v;do if(u>>>0<w>>>0)if((s|0)>-1){c[r>>2]=w;v=c[b>>2]|0;c[k>>2]=c[b+4>>2];c[j+0>>2]=c[k+0>>2];c[b>>2]=hOb(v,w*20|0,4,j,0,3653512,370)|0;break}else{c[k>>2]=c[b+4>>2];c[j+0>>2]=c[k+0>>2];v=cOb(w*20|0,4,j,0,3653512,352)|0;YEi(v|0,c[b>>2]|0,(c[q>>2]|0)*20|0)|0;c[r>>2]=w;c[b>>2]=v;break}while(0);x=c[q>>2]|0}else x=t;t=x+-1|0;x=c[b>>2]|0;c[x+(t*20|0)>>2]=d;d=ync()|0;c[m>>2]=15;a[m+4>>0]=1;a[m+5>>0]=0;a[m+6>>0]=1;q=m+7|0;a[q+0>>0]=0;a[q+1>>0]=0;a[q+2>>0]=0;a[q+3>>0]=0;a[q+4>>0]=0;ewd(b+356|0,e,f,m);a[n>>0]=1;q=n+1|0;a[q>>0]=2;w=c[b+432>>2]|0;if((w|0)==-1)y=b+428|0;else{c[l>>2]=w;c[j+0>>2]=c[l+0>>2];y=zvd(e,f,j,k)|0}a[n>>0]=ea(g[y>>2])!=ea(0.0)&1;y=c[b+440>>2]|0;if((y|0)==-1)z=b+436|0;else{c[l>>2]=y;c[j+0>>2]=c[l+0>>2];z=zvd(e,f,j,k)|0}k=~~ea(g[z>>2]);if((k|0)<0)A=0;else A=(k|0)>8?8:k&255;a[q>>0]=A;A=o;c[A>>2]=0;c[A+4>>2]=0;c[o>>2]=2;c[o+4>>2]=0;g[o+8>>2]=ea(0.0);fwd(b+444|0,e,f,o);a[p>>0]=0;a[p+1>>0]=-1;a[p+2>>0]=-1;a[p+4>>0]=8;a[p+5>>0]=0;a[p+6>>0]=0;a[p+7>>0]=0;a[p+8>>0]=8;a[p+9>>0]=0;a[p+10>>0]=0;a[p+11>>0]=0;gwd(b+468|0,e,f,o,p);c[x+(t*20|0)+4>>2]=_n[c[(c[d>>2]|0)+32>>2]&4095](d,m)|0;c[x+(t*20|0)+8>>2]=_n[c[(c[d>>2]|0)+36>>2]&4095](d,n)|0;c[x+(t*20|0)+12>>2]=_n[c[(c[d>>2]|0)+44>>2]&4095](d,o)|0;c[x+(t*20|0)+16>>2]=_n[c[(c[d>>2]|0)+40>>2]&4095](d,p)|0;i=h;return}function iwd(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+16|0;h=g+4|0;j=g;k=b+336|0;l=b+344|0;c[l>>2]=0;m=b+352|0;a[m>>0]=0;n=(qwd(e,k,b+412|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+356|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+364|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+372|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+380|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+404|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+420|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+388|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+396|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+428|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+436|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+444|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+452|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+460|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+468|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+476|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+484|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+492|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+500|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+508|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+516|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+524|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+532|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+540|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+548|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+556|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+564|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=(qwd(e,k,b+572|0)|0)&1;a[m>>0]=d[m>>0]|0|n;n=c[l>>2]|0;if(!n){i=g;return}l=f+8|0;m=f+12|0;b=f+4|0;e=c[f>>2]|0;o=0;while(1){p=c[l>>2]|0;q=e+(p<<2)|0;a:do if(!p){r=e;s=7}else{t=c[(c[k>>2]|0)+(o<<2)>>2]|0;u=e;while(1){if((c[u>>2]|0)==(t|0)){r=u;s=7;break a}u=u+4|0;if((u|0)==(q|0)){s=8;break}}}while(0);if((s|0)==7){s=0;if((r|0)==(q|0))s=8;else v=e}if((s|0)==8){s=0;u=c[(c[k>>2]|0)+(o<<2)>>2]|0;t=p+1|0;c[l>>2]=t;w=c[m>>2]|0;x=w&2147483647;if(t>>>0>x>>>0){y=w<<1;z=(y|0)==0?1:y;do if(x>>>0<z>>>0)if((w|0)>-1){c[m>>2]=z;c[j>>2]=c[b>>2];c[h+0>>2]=c[j+0>>2];y=hOb(e,z<<2,4,h,0,3653512,370)|0;c[f>>2]=y;A=y;break}else{c[j>>2]=c[b>>2];c[h+0>>2]=c[j+0>>2];y=cOb(z<<2,4,h,0,3653512,352)|0;YEi(y|0,c[f>>2]|0,c[l>>2]<<2|0)|0;c[m>>2]=z;c[f>>2]=y;A=y;break}else A=e;while(0);B=c[l>>2]|0;C=A}else{B=t;C=e}c[C+(B+-1<<2)>>2]=u;v=C}o=o+1|0;if((o|0)==(n|0))break;else e=v}i=g;return}function jwd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;if(!e){i=g;return}if(!(Ytd(e,f)|0)){a[b+332>>0]=1;i=g;return}f=c[e+132>>2]|0;if(f){h=b+316|0;j=c[e+124>>2]|0;rwd(h,(c[h>>2]|0)+(c[b+324>>2]<<4)|0,j,j+(f<<4)|0)|0}c[b+(d<<2)+292>>2]=e;d=e+4|0;c[d>>2]=(c[d>>2]|0)+1;Vtd(e);i=g;return}function kwd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+316|0;if(!(c[b+324>>2]|0)){i=e;return}g=b+332|0;h=b+292|0;j=c[h>>2]|0;if((j|0)!=0?(Xtd(j,f),!(Ytd(c[h>>2]|0,d)|0)):0)a[g>>0]=1;h=b+296|0;j=c[h>>2]|0;if((j|0)!=0?(Xtd(j,f),!(Ytd(c[h>>2]|0,d)|0)):0)a[g>>0]=1;h=b+300|0;j=c[h>>2]|0;if((j|0)!=0?(Xtd(j,f),!(Ytd(c[h>>2]|0,d)|0)):0)a[g>>0]=1;h=b+304|0;j=c[h>>2]|0;if((j|0)!=0?(Xtd(j,f),!(Ytd(c[h>>2]|0,d)|0)):0)a[g>>0]=1;h=b+308|0;j=c[h>>2]|0;if((j|0)!=0?(Xtd(j,f),!(Ytd(c[h>>2]|0,d)|0)):0)a[g>>0]=1;h=b+312|0;b=c[h>>2]|0;if(!b){i=e;return}Xtd(b,f);if(Ytd(c[h>>2]|0,d)|0){i=e;return}a[g>>0]=1;i=e;return}function lwd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=0;do{g=a+(f<<2)+292|0;h=c[g>>2]|0;if(h){j=h+4|0;c[j>>2]=(c[j>>2]|0)+-1;if(!(c[j>>2]|0))ko[c[(c[h>>2]|0)+4>>2]&4095](h);c[g>>2]=0}f=f+1|0}while((f|0)<6);if((c[a+348>>2]|0)>-1){f=a+336|0;g=c[f>>2]|0;c[e>>2]=c[a+340>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+328>>2]|0)>-1){f=a+316|0;g=c[f>>2]|0;c[e>>2]=c[a+320>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function mwd(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(a[d+332>>0]|0){i=e;return 0}f=c[(c[d>>2]|0)+4>>2]|0;d=a[f+4>>0]|0;g=a[f+5>>0]|0;h=a[f+8>>0]|0;j=a[f+9>>0]|0;if((d<<24>>24==3|d<<24>>24==6|g<<24>>24==2|g<<24>>24==4)&(a[621049]|0)==0){i=e;return 0}k=b[310525]|0;if(!((k&255)<<24>>24)){if(d<<24>>24!=(a[f+6>>0]|0)){i=e;return 0}if(!(h<<24>>24==j<<24>>24?g<<24>>24==(a[f+7>>0]|0):0)){i=e;return 0}}f=(k&65535)<256;if((h+-1<<24>>24&255)<2&f){i=e;return 0}if((j+-1<<24>>24&255)<2&f){i=e;return 0}f=b[310526]|0;k=(f&255)<<24>>24==0;if((h+-3<<24>>24&255)<2&k){i=e;return 0}if((j+-3<<24>>24&255)<2&k){i=e;return 0}else{i=e;return (f&65535)>255|(h+-5<<24>>24&255)>15|0}return 0}function nwd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=i;i=i+48|0;j=h+24|0;k=h+8|0;l=h;m=g+4|0;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;m=0;g=0;n=0;o=0;while(1){p=c[b+(g<<2)+292>>2]|0;if(p){c[l>>2]=0;c[f+(g<<2)>>2]=_td(p,d,e,j,k,l)|0;p=c[l>>2]|0;q=(p|0)==1|o;if((p|0)==2){p=b+292|0;r=c[p>>2]|0;if(r){Wtd(r,j);Wtd(c[p>>2]|0,k)}c[f>>2]=0;p=b+296|0;r=c[p>>2]|0;if(r){Wtd(r,j);Wtd(c[p>>2]|0,k)}c[f+4>>2]=0;p=b+300|0;r=c[p>>2]|0;if(r){Wtd(r,j);Wtd(c[p>>2]|0,k)}c[f+8>>2]=0;p=b+304|0;r=c[p>>2]|0;if(r){Wtd(r,j);Wtd(c[p>>2]|0,k)}c[f+12>>2]=0;p=b+308|0;r=c[p>>2]|0;if(r){Wtd(r,j);Wtd(c[p>>2]|0,k)}c[f+16>>2]=0;p=b+312|0;r=c[p>>2]|0;if(r){Wtd(r,j);Wtd(c[p>>2]|0,k)}c[f+20>>2]=0;p=n+1|0;if((p|0)<10){m=1;g=0;n=p;o=q;continue}else{s=1;t=p;u=1}}else{s=m;t=n;u=q}}else{c[f+(g<<2)>>2]=0;s=m;t=n;u=o}g=g+1|0;if((g|0)>=6){v=s;w=u;break}else{m=s;n=t;o=u}}if(v){u=b+316|0;o=b+324|0;t=c[b+292>>2]|0;if((t|0)!=0?(n=c[t+132>>2]|0,(n|0)!=0):0){s=c[t+124>>2]|0;rwd(u,(c[u>>2]|0)+(c[o>>2]<<4)|0,s,s+(n<<4)|0)|0}n=c[b+296>>2]|0;if((n|0)!=0?(s=c[n+132>>2]|0,(s|0)!=0):0){t=c[n+124>>2]|0;rwd(u,(c[u>>2]|0)+(c[o>>2]<<4)|0,t,t+(s<<4)|0)|0}s=c[b+300>>2]|0;if((s|0)!=0?(t=c[s+132>>2]|0,(t|0)!=0):0){n=c[s+124>>2]|0;rwd(u,(c[u>>2]|0)+(c[o>>2]<<4)|0,n,n+(t<<4)|0)|0}t=c[b+304>>2]|0;if((t|0)!=0?(n=c[t+132>>2]|0,(n|0)!=0):0){s=c[t+124>>2]|0;rwd(u,(c[u>>2]|0)+(c[o>>2]<<4)|0,s,s+(n<<4)|0)|0}n=c[b+308>>2]|0;if((n|0)!=0?(s=c[n+132>>2]|0,(s|0)!=0):0){t=c[n+124>>2]|0;rwd(u,(c[u>>2]|0)+(c[o>>2]<<4)|0,t,t+(s<<4)|0)|0}s=c[b+312>>2]|0;if((s|0)!=0?(t=c[s+132>>2]|0,(t|0)!=0):0){n=c[s+124>>2]|0;rwd(u,(c[u>>2]|0)+(c[o>>2]<<4)|0,n,n+(t<<4)|0)|0}kwd(b,d);if(!(w|(a[b+332>>0]|0)!=0))x=15}else if(!w)x=15;if((x|0)==15){if(c[f+4>>2]|0){i=h;return}x=c[f+8>>2]|0;if(!x){i=h;return}w=c[x+40>>2]|0;if(!w){i=h;return}if((c[w+4>>2]|0)!=6){i=h;return}}w=c[(Ald()|0)+52>>2]|0;x=c[c[c[(c[w>>2]|0)+(c[w+32>>2]<<2)>>2]>>2]>>2]|0;w=c[x+296>>2]|0;if(((w|0)!=0?(c[w+16>>2]|0)>0:0)?(b=c[c[w+8>>2]>>2]|0,(b|0)!=0):0){Qtd(b);y=b}else y=0;c[f>>2]=y;y=c[x+300>>2]|0;if(((y|0)!=0?(c[y+16>>2]|0)>0:0)?(b=c[c[y+8>>2]>>2]|0,(b|0)!=0):0){Qtd(b);z=b}else z=0;c[f+4>>2]=z;z=c[x+304>>2]|0;if(((z|0)!=0?(c[z+16>>2]|0)>0:0)?(b=c[c[z+8>>2]>>2]|0,(b|0)!=0):0){Qtd(b);A=b}else A=0;c[f+8>>2]=A;A=c[x+308>>2]|0;if(((A|0)!=0?(c[A+16>>2]|0)>0:0)?(b=c[c[A+8>>2]>>2]|0,(b|0)!=0):0){Qtd(b);B=b}else B=0;c[f+12>>2]=B;B=c[x+312>>2]|0;if(((B|0)!=0?(c[B+16>>2]|0)>0:0)?(b=c[c[B+8>>2]>>2]|0,(b|0)!=0):0){Qtd(b);C=b}else C=0;c[f+16>>2]=C;C=c[x+316>>2]|0;if(((C|0)!=0?(c[C+16>>2]|0)>0:0)?(x=c[c[C+8>>2]>>2]|0,(x|0)!=0):0){Qtd(x);D=x}else D=0;c[f+20>>2]=D;if(v){Vld(d);i=h;return}else{Uld(d);i=h;return}}function owd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+48|0;l=k+32|0;m=k+28|0;n=k+24|0;o=k;p=ync()|0;nwd(b,h,j,o,f);swd(p,o,e,f);j=c[o+4>>2]|0;if(!j){o=c[b+284>>2]|0;h=(o|0)==-1?c[164530]|0:o;if(!h)ko[c[(c[p>>2]|0)+172>>2]&4095](p);else Zvc(h,b+224|0,b+232|0,b+240|0,b+248|0,e,f);h=b+220|0;Dn[c[(c[p>>2]|0)+144>>2]&511](p,(a[h>>0]|0)!=0,(a[b+221>>0]|0)!=0,c[b+288>>2]|0);if(a[h>>0]|0)Xvc(b+104|0,b+68|0,b+140|0,b+176|0,b+24|0,e,f);Yvc(b+32|0,e,f);q=0}else q=j+4|0;if(!(a[b+352>>0]|0))r=d;else{d=Ltd(b+336|0,e,f)|0;hwd(b,d,e,f);r=d}d=c[b>>2]|0;j=c[b+8>>2]|0;h=d+(j*20|0)|0;a:do if(!j)s=d;else{o=d;while(1){if((c[o>>2]|0)==(r|0)){s=o;break a}o=o+20|0;if((o|0)==(h|0)){s=d;break}}}while(0);Wvc(c[s+4>>2]|0,b+16|0,e,f);In[c[(c[p>>2]|0)+60>>2]&4095](p,c[s+8>>2]|0);In[c[(c[p>>2]|0)+56>>2]&4095](p,c[s+12>>2]|0);if(!(a[658128]|0)){d=c[(c[p>>2]|0)+68>>2]|0;h=c[b+216>>2]|0;if((h|0)==-1)t=b+212|0;else{c[n>>2]=h;c[l+0>>2]=c[n+0>>2];t=zvd(e,f,l,m)|0}h=~~ea(g[t>>2]);In[d&4095](p,h);i=k;return q|0}else{h=c[(c[p>>2]|0)+64>>2]|0;d=c[s+16>>2]|0;s=c[b+216>>2]|0;if((s|0)==-1)u=b+212|0;else{c[n>>2]=s;c[l+0>>2]=c[n+0>>2];u=zvd(e,f,l,m)|0}m=~~ea(g[u>>2]);co[h&2047](p,d,m);i=k;return q|0}return 0}function pwd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=0;while(1){f=c[b+(e<<2)+292>>2]|0;if((f|0)!=0?(a[f+141>>0]|0)!=0:0){g=1;h=5;break}e=e+1|0;if((e|0)>=6){g=0;h=5;break}}if((h|0)==5){i=d;return g|0}return 0}function qwd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+4|0;g=e;h=d+4|0;d=c[h>>2]|0;j=(d|0)!=-1;if(j&d>>>0>1073741823|j^1){k=0;i=e;return k|0}j=c[b>>2]|0;l=b+8|0;m=c[l>>2]|0;n=j+(m<<2)|0;a:do if(!m){o=j;p=5}else{q=j;while(1){if((c[q>>2]|0)==(d|0)){o=q;p=5;break a}q=q+4|0;if((q|0)==(n|0)){p=6;break}}}while(0);if((p|0)==5?(o|0)==(n|0):0)p=6;if((p|0)==6){p=m+1|0;c[l>>2]=p;m=b+12|0;n=c[m>>2]|0;o=n&2147483647;if(p>>>0>o>>>0){q=n<<1;r=(q|0)==0?1:q;do if(o>>>0<r>>>0)if((n|0)>-1){c[m>>2]=r;c[g>>2]=c[b+4>>2];c[f+0>>2]=c[g+0>>2];q=hOb(j,r<<2,4,f,0,3653512,370)|0;c[b>>2]=q;s=q;break}else{c[g>>2]=c[b+4>>2];c[f+0>>2]=c[g+0>>2];q=cOb(r<<2,4,f,0,3653512,352)|0;YEi(q|0,c[b>>2]|0,c[l>>2]<<2|0)|0;c[m>>2]=r;c[b>>2]=q;s=q;break}else s=j;while(0);t=c[l>>2]|0;u=s}else{t=p;u=j}c[u+(t+-1<<2)>>2]=d}d=c[a+12>>2]|0;t=a+12|0;if(!d){k=1;i=e;return k|0}a=c[h>>2]|0;h=t;u=d;b:while(1){d=u;while(1){if((c[d+16>>2]|0)>=(a|0)){v=d;break}d=c[d+4>>2]|0;if(!d){w=h;break b}}u=c[v>>2]|0;if(!u){w=v;break}else h=v}if((w|0)==(t|0)){k=1;i=e;return k|0}k=(a|0)<(c[w+16>>2]|0);i=e;return k|0}function rwd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[a>>2]|0;k=b-j>>4;b=a+8|0;l=c[b>>2]|0;m=l-k|0;n=e-d|0;e=n>>4;o=l+e|0;c[b>>2]=o;l=a+12|0;p=c[l>>2]|0;q=p&2147483647;do if(q>>>0<o>>>0?(r=p<<1,s=r>>>0>o>>>0?r:o,q>>>0<s>>>0):0)if((p|0)>-1){c[l>>2]=s;c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];r=hOb(j,s<<4,4,g,0,3653512,370)|0;c[a>>2]=r;t=r;break}else{c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];r=cOb(s<<4,4,g,0,3653512,352)|0;YEi(r|0,c[a>>2]|0,c[b>>2]<<4|0)|0;c[l>>2]=s;c[a>>2]=r;t=r;break}else t=j;while(0);j=t+(k<<4)|0;aFi(t+(k+e<<4)|0,j|0,m<<4|0)|0;YEi(j|0,d|0,n|0)|0;i=f;return j|0}function swd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+96|0;h=g+88|0;j=g+64|0;k=g+56|0;l=g+32|0;m=g+8|0;n=g;if(!(a[b+5834>>0]|0)){Dn[c[(c[b>>2]|0)+228>>2]&511](b,d,e,f);i=g;return}o=0;do{p=j+(o<<2)|0;c[p>>2]=0;q=c[d+(o<<2)>>2]|0;if(q){r=c[q>>2]|0;if((c[r+160>>2]|0)!=2)Oqc(r);q=c[r+156>>2]|0;if((q|0)>0){c[k>>2]=c[153134];c[h+0>>2]=c[k+0>>2];s=cOb(q,16,h,0,3653512,58)|0;c[p>>2]=s;Rqc(r,e,f,s,0,0,0)|0}}o=o+1|0}while((o|0)!=6);o=c[d>>2]|0;f=(o|0)==0;if(f)t=0;else t=c[o+40>>2]|0;c[l>>2]=t;t=c[d+4>>2]|0;e=(t|0)==0;if(e)u=0;else u=c[t+40>>2]|0;c[l+4>>2]=u;u=c[d+8>>2]|0;k=(u|0)==0;if(k)v=0;else v=c[u+40>>2]|0;c[l+8>>2]=v;v=c[d+12>>2]|0;s=(v|0)==0;if(s)w=0;else w=c[v+40>>2]|0;c[l+12>>2]=w;w=c[d+16>>2]|0;r=(w|0)==0;if(r)x=0;else x=c[w+40>>2]|0;c[l+16>>2]=x;x=c[d+20>>2]|0;d=(x|0)==0;if(d)y=0;else y=c[x+40>>2]|0;c[l+20>>2]=y;if(f)z=0;else z=c[o>>2]|0;c[m>>2]=z;if(e)A=0;else A=c[t>>2]|0;c[m+4>>2]=A;if(k)B=0;else B=c[u>>2]|0;c[m+8>>2]=B;if(s)C=0;else C=c[v>>2]|0;c[m+12>>2]=C;if(r)D=0;else D=c[w>>2]|0;c[m+16>>2]=D;if(d)E=0;else E=c[x>>2]|0;c[m+20>>2]=E;Dn[c[(c[b>>2]|0)+800>>2]&511](b,l,m,j);m=c[j>>2]|0;if(m){c[n>>2]=c[153134];c[h+0>>2]=c[n+0>>2];eOb(m,h)}m=c[j+4>>2]|0;if(m){c[n>>2]=c[153134];c[h+0>>2]=c[n+0>>2];eOb(m,h)}m=c[j+8>>2]|0;if(m){c[n>>2]=c[153134];c[h+0>>2]=c[n+0>>2];eOb(m,h)}m=c[j+12>>2]|0;if(m){c[n>>2]=c[153134];c[h+0>>2]=c[n+0>>2];eOb(m,h)}m=c[j+16>>2]|0;if(m){c[n>>2]=c[153134];c[h+0>>2]=c[n+0>>2];eOb(m,h)}m=c[j+20>>2]|0;if(!m){i=g;return}c[n>>2]=c[153134];c[h+0>>2]=c[n+0>>2];eOb(m,h);i=g;return}function twd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=c[a>>2]|0;e=a+4|0;f=c[e>>2]|0;if((d|0)==(f|0)){g=d;h=d}else{j=f;f=d;while(1){d=c[f>>2]|0;if(!d)k=j;else{ujd(d);ACi(d);k=c[e>>2]|0}f=f+4|0;if((f|0)==(k|0)){l=k;break}else j=k}g=c[a>>2]|0;h=l}if(!g){i=b;return}if((h|0)!=(g|0))c[e>>2]=h+(~((h+-4-g|0)>>>2)<<2);ACi(g);i=b;return}function uwd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+132|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;f=d+4|0;g=c[d>>2]|0;if((c[f>>2]|0)==(g|0)){i=e;return}else{h=g;j=0}do{g=h+(j*12|0)|0;if(!(a[g>>0]&1))k=g+1|0;else k=c[h+(j*12|0)+8>>2]|0;g=xmd(k)|0;l=b+(g>>>5<<2)+132|0;c[l>>2]=1<<(g&31)|c[l>>2];j=j+1|0;h=c[d>>2]|0}while(j>>>0<(((c[f>>2]|0)-h|0)/12|0)>>>0);i=e;return}function vwd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+64|0;f=e+16|0;g=e;rri(g,b,SEi(b|0)|0);sri(f,g);b=f+12|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[f+36>>2]=d;d=a+200|0;b=c[d>>2]|0;if((b|0)==(c[a+204>>2]|0)){Pwd(a+196|0,f);yjd(f);xri(g);i=e;return}if(!b)h=0;else{Owd(b,f);h=c[d>>2]|0}c[d>>2]=h+40;yjd(f);xri(g);i=e;return}function wwd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e;rri(g,b,SEi(b|0)|0);sri(f,g);b=f+12|0;c[b>>2]=d;d=a+212|0;h=c[d>>2]|0;if((h|0)==(c[a+216>>2]|0)){zjd(a+208|0,f);xri(f);xri(g);i=e;return}if(!h)j=0;else{sri(h,f);c[h+12>>2]=c[b>>2];j=c[d>>2]|0}c[d>>2]=j+16;xri(f);xri(g);i=e;return}function xwd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g;j=c[a+200>>2]|0;k=(c[a+196>>2]|0)==(j|0)?a+148|0:j+-16|0;sri(h,f);f=h+12|0;c[f>>2]=b;c[h+16>>2]=d;c[h+20>>2]=e;e=k+4|0;d=c[e>>2]|0;if((d|0)==(c[k+8>>2]|0)){Qwd(k,h);xri(h);i=g;return}if(!d)l=0;else{sri(d,h);k=d+12|0;c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];l=c[e>>2]|0}c[e>>2]=l+24;xri(h);i=g;return}function ywd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g;j=c[a+200>>2]|0;k=(c[a+196>>2]|0)==(j|0)?a+160|0:j+-28|0;sri(h,e);e=h+12|0;c[e>>2]=b;c[h+16>>2]=d;c[h+20>>2]=f;f=k+4|0;d=c[f>>2]|0;if((d|0)==(c[k+8>>2]|0)){Rwd(k,h);xri(h);i=g;return}if(!d)l=0;else{sri(d,h);k=d+12|0;c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];l=c[f>>2]|0}c[f>>2]=l+24;xri(h);i=g;return}function zwd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+16|0;j=g;rri(j,d,SEi(d|0)|0);sri(h,j);d=h+12|0;c[d>>2]=b;c[h+16>>2]=f;c[h+20>>2]=e;e=a+176|0;f=c[e>>2]|0;if((f|0)==(c[a+180>>2]|0)){Swd(a+172|0,h);xri(h);xri(j);i=g;return}if(!f)k=0;else{sri(f,h);a=f+12|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];k=c[e>>2]|0}c[e>>2]=k+24;xri(h);xri(j);i=g;return}function Awd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);var h=0,j=0,k=0;h=i;i=i+80|0;j=h;Twd(j,b,d,2,e);g[j+44>>2]=f;e=a+4|0;d=c[e>>2]|0;if((d|0)==(c[a+8>>2]|0)){Uwd(a,j);_ud(j);i=h;return}if(!d)k=0;else{qvd(d,j);k=c[e>>2]|0}c[e>>2]=k+76;_ud(j);i=h;return}function Bwd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+80|0;h=g;Twd(h,b,d,1,e);e=h+44|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=a+4|0;e=c[f>>2]|0;if((e|0)==(c[a+8>>2]|0)){Uwd(a,h);_ud(h);i=g;return}if(!e)j=0;else{qvd(e,h);j=c[f>>2]|0}c[f>>2]=j+76;_ud(h);i=g;return}function Cwd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+80|0;h=g;Twd(h,b,d,0,e);e=h+44|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=a+4|0;e=c[f>>2]|0;if((e|0)==(c[a+8>>2]|0)){Uwd(a,h);_ud(h);i=g;return}if(!e)j=0;else{qvd(e,h);j=c[f>>2]|0}c[f>>2]=j+76;_ud(h);i=g;return}function Dwd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=ea(j);var k=0,l=0,m=0;k=i;i=i+80|0;l=k;Twd(l,b,d,3,e);g[l+44>>2]=f;g[l+48>>2]=h;g[l+52>>2]=j;e=a+4|0;d=c[e>>2]|0;if((d|0)==(c[a+8>>2]|0)){Uwd(a,l);_ud(l);i=k;return}if(!d)m=0;else{qvd(d,l);m=c[e>>2]|0}c[e>>2]=m+76;_ud(l);i=k;return}function Ewd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+80|0;h=g;Twd(h,b,d,4,e);yri(h+60|0,f)|0;c[h+72>>2]=c[f+12>>2];f=a+4|0;e=c[f>>2]|0;if((e|0)==(c[a+8>>2]|0)){Uwd(a,h);_ud(h);i=g;return}if(!e)j=0;else{qvd(e,h);j=c[f>>2]|0}c[f>>2]=j+76;_ud(h);i=g;return}function Fwd(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=5;return}function Gwd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=e+8|0;if((b|0)==-1|(b+-12|0)>>>0<16|(b|a|0)==0){h=1;i=e;return h|0}if((a|0)==1&(b|0)==2){h=1;i=e;return h|0}if((a|0)==2&(b|0)==1){h=1;i=e;return h|0}j=(b|0)>2;k=(b|0)<12;if((a+-3|0)>>>0<4&j&k){h=1;i=e;return h|0}if((a|0)==7&j&k){h=1;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=b;Lsd(g,659032,f);Evd(d,g,0,0,0);xri(g);h=0;i=e;return h|0}function Hwd(a){a=a|0;var b=0,d=0;b=i;c[a+112>>2]=0;c[a+116>>2]=0;d=a+0|0;a=d+112|0;do{c[d>>2]=-1;d=d+4|0}while((d|0)<(a|0));i=b;return}function Iwd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;if(e?!(Gwd(b,d,f)|0):0){i=g;return}if((d|0)!=-1){c[a+(d<<2)>>2]=b;f=a+112|0;c[f>>2]=c[f>>2]|1<<d}d=a+116|0;c[d>>2]=c[d>>2]|1<<b;i=g;return}function Jwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+116|0;f=a+112|0;g=0;do{h=c[b+(g<<2)>>2]|0;if((h|0)!=-1){c[a+(g<<2)>>2]=h;c[f>>2]=c[f>>2]|1<<g;c[e>>2]=c[e>>2]|1<<h}g=g+1|0}while((g|0)!=28);i=d;return}function Kwd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=a+4|0;f=c[e>>2]|0;if((d|0)!=(f|0)){g=f;f=d;while(1){d=c[f>>2]|0;if(!d)h=g;else{ko[c[(c[d>>2]|0)+4>>2]&4095](d);h=c[e>>2]|0}f=f+4|0;if((f|0)==(h|0))break;else g=h}}Ntd(a+12|0,c[a+16>>2]|0);h=c[a>>2]|0;if(!h){i=b;return}a=c[e>>2]|0;if((a|0)!=(h|0))c[e>>2]=a+(~((a+-4-h|0)>>>2)<<2);ACi(h);i=b;return}function Lwd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+12|0;e=c[d>>2]|0;f=a+16|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=g;g=e;while(1){e=c[g>>2]|0;if(!e)j=h;else{Kwd(e);ACi(e);j=c[f>>2]|0}g=g+4|0;if((g|0)==(j|0))break;else h=j}}j=a+60|0;h=c[j>>2]|0;if(h){g=a+64|0;while(1){e=c[g>>2]|0;if((e|0)==(h|0))break;k=e+-24|0;c[g>>2]=k;xri(e+-12|0);xri(k)}ACi(c[j>>2]|0)}xri(a+48|0);xri(a+36|0);xri(a+24|0);j=c[d>>2]|0;if(j){d=c[f>>2]|0;if((d|0)!=(j|0))c[f>>2]=d+(~((d+-4-j|0)>>>2)<<2);ACi(j)}j=c[a>>2]|0;if(!j){i=b;return}d=a+4|0;while(1){f=c[d>>2]|0;if((f|0)==(j|0))break;g=f+-76|0;c[d>>2]=g;_ud(g)}ACi(c[a>>2]|0);i=b;return}function Mwd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=659080;g=0;do{h=c[b+(g<<2)+676>>2]|0;if(h){twd(h);ACi(h)}g=g+1|0}while((g|0)<6);g=c[b+664>>2]|0;if(g){h=b+668|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~(((j+-52-g|0)>>>0)/52|0)*52|0);ACi(g)}Ntd(b+648|0,c[b+652>>2]|0);if(!(a[b+8>>0]&1)){i=d;return}g=c[b+16>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function Nwd(a){a=a|0;var b=0;b=i;Mwd(a);ACi(a);i=b;return}function Owd(a,b){a=a|0;b=b|0;var d=0;d=i;sri(a,b);Vwd(a+12|0,b+12|0);Wwd(a+24|0,b+24|0);c[a+36>>2]=c[b+36>>2];i=d;return}function Pwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/40|0)+1|0;if(g>>>0>107374182)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/40|0;if(k>>>0<53687091){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/40|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=107374182;r=(l-j|0)/40|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*40|0)|0;o=r;p=s}s=n+(o*40|0)|0;r=n+(m*40|0)|0;if(!s){u=p;v=f}else{Owd(s,b);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*40|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=u+-40|0;o=o+-40|0;Owd(s,o);if((o|0)==(v|0)){z=s;break}else u=s}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-40|0;yjd(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function Qwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/24|0)+1|0;if(g>>>0>178956970)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/24|0;if(k>>>0<89478485){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/24|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=178956970;r=(l-j|0)/24|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*24|0)|0;o=r;p=s}s=n+(o*24|0)|0;r=n+(m*24|0)|0;if(!s){u=p;v=f}else{sri(s,b);f=n+(o*24|0)+12|0;p=b+12|0;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];u=c[e>>2]|0;v=c[a>>2]|0}p=n+((o+1|0)*24|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=o;o=o+-24|0;sri(u+-24|0,o);n=u+-12|0;f=s+-12|0;c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];f=u+-24|0;if((o|0)==(v|0)){z=f;break}else u=f}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=p;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-24|0;xri(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function Rwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/24|0)+1|0;if(g>>>0>178956970)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/24|0;if(k>>>0<89478485){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/24|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=178956970;r=(l-j|0)/24|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*24|0)|0;o=r;p=s}s=n+(o*24|0)|0;r=n+(m*24|0)|0;if(!s){u=p;v=f}else{sri(s,b);f=n+(o*24|0)+12|0;p=b+12|0;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];u=c[e>>2]|0;v=c[a>>2]|0}p=n+((o+1|0)*24|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=o;o=o+-24|0;sri(u+-24|0,o);n=u+-12|0;f=s+-12|0;c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];f=u+-24|0;if((o|0)==(v|0)){z=f;break}else u=f}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=p;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-24|0;xri(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function Swd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/24|0)+1|0;if(g>>>0>178956970)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/24|0;if(k>>>0<89478485){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/24|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=178956970;r=(l-j|0)/24|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*24|0)|0;o=r;p=s}s=n+(o*24|0)|0;r=n+(m*24|0)|0;if(!s){u=p;v=f}else{sri(s,b);f=n+(o*24|0)+12|0;p=b+12|0;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];u=c[e>>2]|0;v=c[a>>2]|0}p=n+((o+1|0)*24|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=o;o=o+-24|0;sri(u+-24|0,o);n=u+-12|0;f=s+-12|0;c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];f=u+-24|0;if((o|0)==(v|0)){z=f;break}else u=f}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=p;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-24|0;xri(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function Twd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;rri(b,d,SEi(d|0)|0);rri(b+12|0,e,SEi(e|0)|0);e=b+24|0;c[e>>2]=0;d=b+28|0;c[d>>2]=0;j=b+32|0;c[j>>2]=0;c[b+36>>2]=f;f=b+40|0;c[f>>2]=0;k=b+60|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[b+72>>2]=5;k=g+4|0;Dmd(e,((c[k>>2]|0)-(c[g>>2]|0)|0)/12|0);l=c[g>>2]|0;if((c[k>>2]|0)==(l|0)){m=b+44|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;i=h;return}else{n=l;o=0}do{l=n+(o*12|0)|0;p=l+1|0;q=n+(o*12|0)+8|0;r=0;while(1){if(!(a[l>>0]&1))s=p;else s=c[q>>2]|0;if(!(Gsd(s,c[658976+(r<<2)>>2]|0)|0)){t=r;u=8;break}r=r+1|0;if((r|0)>=14){u=9;break}}do if((u|0)==8){u=0;c[f>>2]=c[f>>2]|1<<t}else if((u|0)==9){u=0;r=c[d>>2]|0;if((r|0)==(c[j>>2]|0)){nO(e,l);break}if(!r)v=0;else{sri(r,l);v=c[d>>2]|0}c[d>>2]=v+12}while(0);o=o+1|0;n=c[g>>2]|0}while(o>>>0<(((c[k>>2]|0)-n|0)/12|0)>>>0);m=b+44|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;i=h;return}function Uwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/76|0)+1|0;if(g>>>0>56512727)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/76|0;if(k>>>0<28256363){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/76|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=56512727;r=(l-j|0)/76|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*76|0)|0;o=r;p=s}s=n+(o*76|0)|0;r=n+(m*76|0)|0;if(!s){u=p;v=f}else{qvd(s,b);u=c[e>>2]|0;v=c[a>>2]|0}b=n+((o+1|0)*76|0)|0;if((u|0)==(v|0)){w=s;x=u;y=u}else{o=u;u=s;while(1){s=u+-76|0;o=o+-76|0;qvd(s,o);if((o|0)==(v|0)){z=s;break}else u=s}w=z;x=c[a>>2]|0;y=c[e>>2]|0}c[a>>2]=w;c[e>>2]=b;c[h>>2]=r;r=y;while(1){if((r|0)==(x|0))break;y=r+-76|0;_ud(y);r=y}if(!x){i=d;return}ACi(x);i=d;return}function Vwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=c[g>>2]|0;j=c[b>>2]|0;k=h-j|0;l=(k|0)/24|0;if((h|0)==(j|0)){i=d;return}if(l>>>0>178956970)vxi(a);j=xCi(k)|0;c[e>>2]=j;c[a>>2]=j;c[f>>2]=j+(l*24|0);l=c[b>>2]|0;b=c[g>>2]|0;if((l|0)==(b|0)){i=d;return}else{m=l;n=j}do{sri(n,m);j=n+12|0;l=m+12|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];n=(c[e>>2]|0)+24|0;c[e>>2]=n;m=m+24|0}while((m|0)!=(b|0));i=d;return}function Wwd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=c[g>>2]|0;j=c[b>>2]|0;k=h-j|0;l=(k|0)/24|0;if((h|0)==(j|0)){i=d;return}if(l>>>0>178956970)vxi(a);j=xCi(k)|0;c[e>>2]=j;c[a>>2]=j;c[f>>2]=j+(l*24|0);l=c[b>>2]|0;b=c[g>>2]|0;if((l|0)==(b|0)){i=d;return}else{m=l;n=j}do{sri(n,m);j=n+12|0;l=m+12|0;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];n=(c[e>>2]|0)+24|0;c[e>>2]=n;m=m+24|0}while((m|0)!=(b|0));i=d;return}function Xwd(b){b=b|0;var d=0;c[b>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+4>>2]=60;c[b+16>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+20>>2]=b+24;d=b+32|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;a[b+44>>0]=1;c[b+48>>2]=-1;c[b+52>>2]=-1;return}function Ywd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[153078];c[d+0>>2]=c[e+0>>2];e=bOb(56,d,0,16,3653512,45)|0;Zwd(e,a);i=b;return e|0}function Zwd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;k=c[d+4>>2]|0;c[b+4>>2]=k;l=b+8|0;c[l>>2]=0;m=b+12|0;c[m>>2]=0;c[b>>2]=0;n=c[d>>2]|0;o=d+8|0;p=c[o>>2]<<2;q=p>>2;c[l>>2]=q;if(!q){r=0;s=0}else{c[m>>2]=q;c[g>>2]=k;c[f+0>>2]=c[g+0>>2];k=hOb(0,p,4,f,0,3653512,370)|0;c[b>>2]=k;r=k;s=c[l>>2]<<2}YEi(r|0,n|0,s|0)|0;c[b+16>>2]=c[o>>2];o=b+20|0;s=b+24|0;c[s>>2]=0;n=b+28|0;c[n>>2]=0;r=b+24|0;c[o>>2]=r;k=c[d+20>>2]|0;p=d+24|0;if((k|0)!=(p|0)){q=k;while(1){k=q+16|0;m=c[k>>2]|0;t=c[k+4>>2]|0;k=j;c[k>>2]=m;c[k+4>>2]=t;c[h>>2]=r;c[f+0>>2]=c[h+0>>2];k=bvd(o,f,g,j)|0;if(!(c[k>>2]|0)){u=xCi(24)|0;v=u+16|0;c[v>>2]=m;c[v+4>>2]=t;t=c[g>>2]|0;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=t;c[k>>2]=u;t=c[c[o>>2]>>2]|0;if(!t)w=u;else{c[o>>2]=t;w=c[k>>2]|0}GN(c[s>>2]|0,w);c[n>>2]=(c[n>>2]|0)+1}k=c[q+4>>2]|0;if(!k){t=q;while(1){u=c[t+8>>2]|0;if((c[u>>2]|0)==(t|0)){x=u;break}else t=u}}else{t=k;while(1){u=c[t>>2]|0;if(!u){x=t;break}else t=u}}if((x|0)==(p|0))break;else q=x}}c[b+32>>2]=c[d+32>>2];x=b+36|0;c[x>>2]=0;c[x+4>>2]=0;a[b+44>>0]=a[d+44>>0]|0;c[b+48>>2]=c[d+48>>2];c[b+52>>2]=-1;if(!(c[l>>2]|0)){i=e;return}else y=0;do{Btd(c[(c[b>>2]|0)+(y<<2)>>2]|0);y=y+1|0}while(y>>>0<(c[l>>2]|0)>>>0);i=e;return}function _wd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;if(c[f>>2]|0){g=c[a>>2]|0;do{Ctd(c[g>>2]|0);g=g+4|0}while((g|0)!=((c[a>>2]|0)+(c[f>>2]<<2)|0))}Ntd(a+20|0,c[a+24>>2]|0);if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function $wd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[b+8>>2]|0;if(!j){i=f;return}k=d+1|0;l=e+8|0;m=e+12|0;n=e+4|0;o=d+8|0;p=d+4|0;q=0;do{r=c[(c[b>>2]|0)+(q<<2)>>2]|0;s=r+628|0;t=a[s>>0]|0;u=(t&1)==0;if(u)v=(t&255)>>>1;else v=c[r+632>>2]|0;w=a[d>>0]|0;x=(w&1)==0;if(x)y=(w&255)>>>1;else y=c[p>>2]|0;if((v|0)==(y|0)){if(u)z=s+1|0;else z=c[r+636>>2]|0;if(u)A=(t&255)>>>1;else A=c[r+632>>2]|0;if(!(IEi(z,x?k:c[o>>2]|0,A)|0)){x=(c[l>>2]|0)+1|0;c[l>>2]=x;t=c[m>>2]|0;u=t&2147483647;if(x>>>0>u>>>0){s=t<<1;w=(s|0)==0?1:s;do if(u>>>0<w>>>0)if((t|0)>-1){c[m>>2]=w;s=c[e>>2]|0;c[h>>2]=c[n>>2];c[g+0>>2]=c[h+0>>2];c[e>>2]=hOb(s,w<<2,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[n>>2];c[g+0>>2]=c[h+0>>2];s=cOb(w<<2,4,g,0,3653512,352)|0;YEi(s|0,c[e>>2]|0,c[l>>2]<<2|0)|0;c[m>>2]=w;c[e>>2]=s;break}while(0);B=c[l>>2]|0}else B=x;c[(c[e>>2]|0)+(B+-1<<2)>>2]=r;Btd(r)}}q=q+1|0}while((q|0)!=(j|0));i=f;return}function axd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+8|0;if(!(c[e>>2]|0)){i=d;return}f=c[a>>2]|0;do{Htd(c[f>>2]|0,b);f=f+4|0}while((f|0)!=((c[a>>2]|0)+(c[e>>2]<<2)|0));i=d;return}function bxd(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;g=i;i=i+80|0;h=g;j=g+44|0;k=g+56|0;l=g+68|0;m=g+20|0;n=g+8|0;o=g+32|0;if(!(a[659096]|0)){rri(j,659104,9);p=vvd(j)|0;xri(j);c[164772]=p;a[659096]=1}if(!(a[659128]|0)){rri(k,659136,12);p=vvd(k)|0;xri(k);c[164780]=p;a[659128]=1}if(!(a[659160]|0)){rri(l,659168,15);p=vvd(l)|0;xri(l);c[164788]=p;a[659160]=1}if(!(a[659192]|0)){rri(m,1068024,6);p=vvd(m)|0;xri(m);c[164796]=p;a[659192]=1}if(!(a[659208]|0)){rri(n,659216,8);p=vvd(n)|0;xri(n);c[164800]=p;a[659208]=1}if(!(a[659240]|0)){rri(o,659248,12);p=vvd(o)|0;xri(o);c[164808]=p;a[659240]=1}p=b+8|0;if(c[p>>2]|0){o=b+16|0;n=0;m=c[b>>2]|0;l=0;a:while(1){k=m;m=m+4|0;j=m;q=n;r=l;b:while(1){s=q;while(1){while(1){t=c[k>>2]|0;Jtd(t);u=c[164772]|0;v=c[164780]|0;w=c[164788]|0;x=t+668|0;y=c[x>>2]|0;z=t+668|0;if(y){A=z;B=y;c:while(1){y=B;while(1){if((c[y+16>>2]|0)>=(u|0)){C=y;break}y=c[y+4>>2]|0;if(!y){D=A;break c}}B=c[C>>2]|0;if(!B){D=C;break}else A=C}if((D|0)!=(z|0)?(c[D+16>>2]|0)<=(u|0):0){A=c[D+20>>2]|0;E=(A|0)==(v|0)|(A|0)==(w|0)}else E=0}else E=0;if(Itd(t,e)|0){F=E;G=s;H=r;I=27;break b}A=c[164772]|0;B=c[164780]|0;y=c[164788]|0;J=c[x>>2]|0;if(!J){K=t;break}else{L=z;M=J}d:while(1){N=M;while(1){if((c[N+16>>2]|0)>=(A|0)){O=N;break}N=c[N+4>>2]|0;if(!N){P=L;break d}}M=c[O>>2]|0;if(!M){P=O;break}else L=O}if(((P|0)!=(z|0)?(c[P+16>>2]|0)<=(A|0):0)?(x=c[P+20>>2]|0,(x|0)==(B|0)|(x|0)==(y|0)):0){Q=s;R=r;I=37;break b}x=c[164808]|0;w=z;v=J;e:while(1){u=v;while(1){if((c[u+16>>2]|0)>=(A|0)){S=u;break}u=c[u+4>>2]|0;if(!u){T=w;break e}}v=c[S>>2]|0;if(!v){T=S;break}else w=S}if((T|0)==(z|0)){U=t;V=z;W=A;X=J;Y=x;I=48;break}if((c[T+16>>2]|0)>(A|0)){U=t;V=z;W=A;X=J;Y=x;I=48;break}if((c[T+20>>2]|0)!=(x|0)){U=t;V=z;W=A;X=J;Y=x;I=48;break}Ctd(t);aFi(k|0,m|0,(c[b>>2]|0)+(c[p>>2]<<2)-j|0)|0;w=(c[p>>2]|0)+-1|0;c[p>>2]=w;c[o>>2]=(c[o>>2]|0)+-1;v=c[b>>2]|0;if((k|0)==(v+(w<<2)|0)){Z=v;_=w;$=s;aa=r;I=62;break a}}if((I|0)==48){I=0;w=c[164796]|0;v=c[164800]|0;y=V;B=X;f:while(1){u=B;while(1){if((c[u+16>>2]|0)>=(W|0)){ba=u;break}u=c[u+4>>2]|0;if(!u){ca=y;break f}}B=c[ba>>2]|0;if(!B){ca=ba;break}else y=ba}if(((ca|0)!=(V|0)?(c[ca+16>>2]|0)<=(W|0):0)?(y=c[ca+20>>2]|0,!((y|0)==(w|0)|(y|0)==(v|0)|(y|0)==(Y|0))):0){da=U;ea=s;break}else K=U}if(a[621044]|0){fa=0;I=85;break a}Ird(659312,h);y=K+628|0;if(!(a[y>>0]&1))ga=y+1|0;else ga=c[K+636>>2]|0;c[h>>2]=(a[653480]&1)==0?653481:c[163372]|0;c[h+4>>2]=ga;Ird(659336,h);Ctd(K);aFi(k|0,m|0,(c[b>>2]|0)+(c[p>>2]<<2)-j|0)|0;y=(c[p>>2]|0)+-1|0;c[p>>2]=y;c[o>>2]=(c[o>>2]|0)+-1;B=c[b>>2]|0;if((k|0)==(B+(y<<2)|0)){Z=B;_=y;$=1;aa=r;I=62;break a}else s=1}s=1<<c[659264+(c[da+584>>2]<<2)>>2]|r;Ctd(da);aFi(k|0,m|0,(c[b>>2]|0)+(c[p>>2]<<2)-j|0)|0;y=(c[p>>2]|0)+-1|0;c[p>>2]=y;c[o>>2]=(c[o>>2]|0)+-1;B=c[b>>2]|0;if((k|0)==(B+(y<<2)|0)){ha=B;ia=y;ja=ea;ka=s;I=63;break a}else{q=ea;r=s}}if((I|0)==27){I=0;la=G;ma=H;na=(d[f>>0]|F&1)&255}else if((I|0)==37){I=0;if(a[f>>0]|0){fa=0;I=85;break}c[o>>2]=(c[o>>2]|0)+-1;la=Q;ma=R;na=1}a[f>>0]=na;r=c[b>>2]|0;q=c[p>>2]|0;if((m|0)==(r+(q<<2)|0)){Z=r;_=q;$=la;aa=ma;I=62;break}else{n=la;l=ma}}if((I|0)==62)if(!aa){oa=_;pa=Z;qa=$}else{ha=Z;ia=_;ja=$;ka=aa;I=63}else if((I|0)==85){i=g;return fa|0}g:do if((I|0)==63)if(!ia){oa=ia;pa=ha;qa=ja}else{aa=b+16|0;$=ia;_=ha;Z=ha;while(1){ma=Z;Z=Z+4|0;l=Z;la=$;n=_;while(1){m=c[ma>>2]|0;if(!(1<<c[659264+(c[m+584>>2]<<2)>>2]&ka)){ra=la;sa=n;break}Ctd(m);aFi(ma|0,Z|0,(c[b>>2]|0)+(c[p>>2]<<2)-l|0)|0;m=(c[p>>2]|0)+-1|0;c[p>>2]=m;c[aa>>2]=(c[aa>>2]|0)+-1;na=c[b>>2]|0;if((ma|0)==(na+(m<<2)|0)){oa=m;pa=na;qa=ja;break g}else{la=m;n=na}}if((Z|0)==(sa+(ra<<2)|0)){oa=ra;pa=sa;qa=ja;break}else{$=ra;_=sa}}}while(0);if(oa){if(!qa){fa=1;i=g;return fa|0}h:do if(oa){qa=c[164772]|0;sa=c[164780]|0;ra=c[164788]|0;ja=pa;while(1){p=c[ja>>2]|0;ka=c[p+668>>2]|0;ha=p+668|0;if(!ka)break;else{ta=ha;ua=ka}i:while(1){ka=ua;while(1){if((c[ka+16>>2]|0)>=(qa|0)){va=ka;break}ka=c[ka+4>>2]|0;if(!ka){wa=ta;break i}}ua=c[va>>2]|0;if(!ua){wa=va;break}else ta=va}if((wa|0)==(ha|0))break;if((c[wa+16>>2]|0)>(qa|0))break;ka=c[wa+20>>2]|0;ja=ja+4|0;if(!((ka|0)==(sa|0)|(ka|0)==(ra|0)))break;if((ja|0)==(pa+(oa<<2)|0))break h}Ird(659312,h);c[h>>2]=(a[653480]&1)==0?653481:c[163372]|0;Ird(659416,h);fa=0;i=g;return fa|0}while(0);a[b+42>>0]=1;fa=1;i=g;return fa|0}}Ird(659312,h);c[h>>2]=(a[653480]&1)==0?653481:c[163372]|0;Ird(659376,h);fa=0;i=g;return fa|0}function cxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a>>2]|0;h=a+8|0;j=c[h>>2]|0;k=j+1|0;c[h>>2]=k;l=a+12|0;m=c[l>>2]|0;n=m&2147483647;do if(n>>>0<k>>>0?(o=m<<1,p=o>>>0>k>>>0?o:k,n>>>0<p>>>0):0)if((m|0)>-1){c[l>>2]=p;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];o=hOb(g,p<<2,4,e,0,3653512,370)|0;c[a>>2]=o;q=o;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];o=cOb(p<<2,4,e,0,3653512,352)|0;YEi(o|0,c[a>>2]|0,c[h>>2]<<2|0)|0;c[l>>2]=p;c[a>>2]=o;q=o;break}else q=g;while(0);aFi(q+4|0,q|0,j<<2|0)|0;c[q>>2]=b;Btd(b);b=a+16|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function dxd(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+112|0;f=e+84|0;g=e+48|0;h=e+12|0;j=e+24|0;k=e+96|0;l=e;m=e+36|0;n=e+72|0;o=e+60|0;p=c[b+8>>2]|0;q=b+36|0;c[q>>2]=0;r=b+43|0;a[r>>0]=0;s=b+41|0;a[s>>0]=0;if(!(a[659472]|0)){rri(h,659480,13);t=vvd(h)|0;xri(h);c[164866]=t;a[659472]=1}if(p){t=b+40|0;h=0;u=0;while(1){v=c[(c[b>>2]|0)+(u<<2)>>2]|0;w=c[v+584>>2]|0;if(!(1278>>>w&1))x=c[q>>2]|0;else{y=c[q>>2]|1<<c[659264+(w<<2)>>2];c[q>>2]=y;x=y}a[r>>0]=(x&13|0)!=0|d[r>>0];if((w|0)==5){a[t>>0]=1;y=(pwd(v+4|0)|0)&1;z=d[s>>0]|y;a[s>>0]=z;y=c[v+668>>2]|0;A=v+668|0;if(y){v=c[164866]|0;B=A;C=y;a:while(1){y=C;while(1){if((c[y+16>>2]|0)>=(v|0)){D=y;break}y=c[y+4>>2]|0;if(!y){E=B;break a}}C=c[D>>2]|0;if(!C){E=D;break}else B=D}if((E|0)!=(A|0)?(v|0)>=(c[E+16>>2]|0):0)F=E;else G=17}else G=17;if((G|0)==17){G=0;F=A}a[s>>0]=z|(F|0)!=(A|0);H=h}else if(!w)H=1;else H=h;u=u+1|0;if((u|0)==(p|0)){I=H;break}else h=H}if(!((c[q>>2]|0)!=0|I^1))c[q>>2]=5}if(!(a[659616]|0)){rri(f,659104,9);q=vvd(f)|0;xri(f);c[164902]=q;a[659616]=1}q=b+16|0;f=c[q>>2]|0;b:do if((f|0)>0){I=g+1|0;H=g+8|0;h=f;p=0;while(1){u=c[(c[b>>2]|0)+(p<<2)>>2]|0;F=c[u+668>>2]|0;s=u+668|0;if(F){u=c[164902]|0;G=s;E=F;c:while(1){F=E;while(1){if((c[F+16>>2]|0)>=(u|0)){J=F;break}F=c[F+4>>2]|0;if(!F){K=G;break c}}E=c[J>>2]|0;if(!E){K=J;break}else G=J}if((K|0)!=(s|0)?(u|0)>=(c[K+16>>2]|0):0){wvd(g,c[K+20>>2]|0);G=(Gsd((a[g>>0]&1)==0?I:c[H>>2]|0,659136)|0)==0;xri(g);if(G){L=p;break b}M=c[q>>2]|0}else M=h}else M=h;p=p+1|0;if((p|0)>=(M|0)){L=-1;break}else h=M}}else L=-1;while(0);c[b+48>>2]=L;if(!(a[659504]|0)){rri(j,659512,20);L=vvd(j)|0;xri(j);c[164874]=L;a[659504]=1}if(!(a[659544]|0)){rri(k,3655040,4);L=vvd(k)|0;xri(k);c[164884]=L;a[659544]=1}L=b+24|0;k=c[L>>2]|0;j=b+24|0;if(k){M=c[164874]|0;q=j;g=k;d:while(1){K=g;while(1){if((c[K+16>>2]|0)>=(M|0)){N=K;break}K=c[K+4>>2]|0;if(!K){O=q;break d}}g=c[N>>2]|0;if(!g){O=N;break}else q=N}if(((O|0)!=(j|0)?(M|0)>=(c[O+16>>2]|0):0)?(c[O+20>>2]|0)==(c[164884]|0):0)a[b+44>>0]=0}O=b+52|0;c[O>>2]=-1;if(!(a[659560]|0)){rri(l,659568,5);b=vvd(l)|0;xri(l);c[164888]=b;a[659560]=1;P=c[L>>2]|0}else P=k;if(!P){i=e;return}k=c[164888]|0;L=j;b=P;e:while(1){P=b;while(1){if((c[P+16>>2]|0)>=(k|0)){Q=P;break}P=c[P+4>>2]|0;if(!P){R=L;break e}}b=c[Q>>2]|0;if(!b){R=Q;break}else L=Q}if((R|0)==(j|0)){i=e;return}if((k|0)<(c[R+16>>2]|0)){i=e;return}wvd(m,c[R+20>>2]|0);if(!(ttd(m,O)|0)){c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;O=a[m>>0]|0;if(!(O&1))S=(O&255)>>>1;else S=c[m+4>>2]|0;Pri(o,659576,18,S+18|0);if(!(a[m>>0]&1))T=m+1|0;else T=c[m+8>>2]|0;Gri(o,T,S)|0;yO(n,o,659600);if(!(a[n>>0]&1))U=n+1|0;else U=c[n+8>>2]|0;Krd(U,0,3653512,356,1,0,0,0);xri(n);xri(o)}xri(m);i=e;return}function exd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+8|0;f=a+44|0;h=a+60|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[h>>2]=-1;c[h>>2]=c[b+60>>2];c[e>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];e=b+44|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];g[a+32>>2]=ea(g[b+32>>2]);g[a+36>>2]=ea(g[b+36>>2]);g[a+40>>2]=ea(g[b+40>>2]);e=c[b+16>>2]|0;if(!e){j=c[b>>2]|0;c[a>>2]=j;k=b+4|0;l=c[k>>2]|0;m=a+4|0;c[m>>2]=l;i=d;return}IDc(e,a);j=c[b>>2]|0;c[a>>2]=j;k=b+4|0;l=c[k>>2]|0;m=a+4|0;c[m>>2]=l;i=d;return}function fxd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;h=b+8|0;c[b+28>>2]=0;j=b+60|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j>>2]=-1;c[f>>2]=-1;if(!(a[d>>0]&1))k=d+1|0;else k=c[d+8>>2]|0;itd(f,k);c[j>>2]=c[f>>2];c[h>>2]=0;c[b+12>>2]=0;g[b+44>>2]=ea(1.0);g[b+48>>2]=ea(1.0);g[b+52>>2]=ea(0.0);g[b+56>>2]=ea(0.0);g[b+32>>2]=ea(1.0);g[b+36>>2]=ea(1.0);g[b+40>>2]=ea(0.0);h=c[d+12>>2]|0;c[b>>2]=h;c[b+4>>2]=h;i=e;return}function gxd(a){a=a|0;var b=0,d=0;b=i;d=c[a+16>>2]|0;if(!d){i=b;return}JDc(d,a,c[a+20>>2]|0);i=b;return}function hxd(a){a=a|0;var b=0,d=0;b=i;d=c[a+16>>2]|0;if(!d){i=b;return}JDc(d,a,c[a+20>>2]|0);i=b;return}function ixd(a,b,c){a=a|0;b=ea(b);c=ea(c);var d=0,e=Im,f=Im,h=Im;d=i;e=ea(b+ea(-1.0));if(e<ea(0.0))f=ea(-e);else f=e;if(f<=ea(9.99999997e-07)){f=ea(c+ea(-1.0));if(f<ea(0.0))h=ea(-f);else h=f;if(h<=ea(9.99999997e-07)){g[a+44>>2]=ea(1.0);g[a+48>>2]=ea(1.0);i=d;return}}g[a+44>>2]=b;g[a+48>>2]=c;i=d;return}function jxd(a,b,c){a=a|0;b=ea(b);c=ea(c);var d=0,e=Im,f=Im;d=i;if(b<ea(0.0))e=ea(-b);else e=b;if(e<=ea(9.99999997e-07)){if(c<ea(0.0))f=ea(-c);else f=c;if(f<=ea(9.99999997e-07)){g[a+52>>2]=ea(0.0);g[a+56>>2]=ea(0.0);i=d;return}}g[a+52>>2]=b;g[a+56>>2]=c;i=d;return}function kxd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+32|0;k=j;l=j+8|0;c[b+28>>2]=h;h=c[d>>2]|0;c[b+8>>2]=h;d=c[158074]|0;if(!h){m=b+60|0;n=c[m>>2]|0;do if((n|0)==-1)o=0;else{if(n>>>0<=1073741823){p=c[d+68>>2]|0;q=d+68|0;if(!p){o=0;break}else{r=q;s=p}a:while(1){p=s;while(1){if((c[p+16>>2]|0)>=(n|0)){t=p;break}p=c[p+4>>2]|0;if(!p){u=r;break a}}s=c[t>>2]|0;if(!s){u=t;break}else r=t}if((u|0)==(q|0)){o=0;break}if((n|0)<(c[u+16>>2]|0)){o=0;break}p=c[u+20>>2]|0;if(!p){o=0;break}else v=p}else{p=ync()|0;v=p+((c[m>>2]&1073741823)<<6)+3748|0}o=c[v+12>>2]|0}while(0);c[b+12>>2]=o}else c[b+12>>2]=h;c[b>>2]=e;e=b+32|0;g[e>>2]=ea(1.0);h=b+36|0;g[h>>2]=ea(1.0);o=b+40|0;g[o>>2]=ea(0.0);if(!f){i=j;return}g[e>>2]=ea(g[f+64>>2]);g[h>>2]=ea(g[f+68>>2]);g[o>>2]=ea(g[f+36>>2]);o=c[b+16>>2]|0;if((o|0)!=(f|0)){if(o)JDc(o,b,c[b+20>>2]|0);IDc(f,b)}o=mo[c[(c[f>>2]|0)+92>>2]&4095](f)|0;f=c[b+4>>2]|0;if((f|0)==5|(o|0)==(f|0)){i=j;return}b=c[659672+(f<<2)>>2]|0;c[k>>2]=c[659672+(o<<2)>>2];c[k+4>>2]=b;Lsd(l,659696,k);if(!(a[l>>0]&1))w=l+1|0;else w=c[l+8>>2]|0;Krd(w,0,3653512,116,1,0,0,0);xri(l);i=j;return}function lxd(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=ea(e);var f=0;f=i;c[a+12>>2]=c[b>>2];g[a+40>>2]=ea(0.0);b=c[a+16>>2]|0;if(b)JDc(b,a,c[a+20>>2]|0);g[a+32>>2]=d;g[a+36>>2]=e;c[a+28>>2]=0;i=f;return}function mxd(b,d){b=b|0;d=ea(d);var e=0,f=0;e=i;g[b+40>>2]=d;f=c[b+24>>2]|0;if(!f){i=e;return}b=c[f+80>>2]|0;if(!b){i=e;return}a[b+36>>0]=1;i=e;return}function nxd(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=Im,k=Im;f=i;g[b+32>>2]=d;g[b+36>>2]=e;h=c[b+28>>2]|0;if(h){j=ea(ea(g[b+44>>2])*d);d=ea(ea(g[b+48>>2])*e);e=ea(g[b+52>>2]);k=ea(g[b+56>>2]);g[h>>2]=j;g[h+4>>2]=d;g[h+8>>2]=e;g[h+12>>2]=k}h=c[b+24>>2]|0;if(!h){i=f;return}b=c[h+80>>2]|0;if(!b){i=f;return}a[b+36>>0]=1;i=f;return}function oxd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;f=b+12|0;h=c[f>>2]|0;if(!h){j=tvc(c[b+4>>2]|0)|0;c[f>>2]=j;f=c[b>>2]|0;if((f|0)==0|(f|0)==5){c[b>>2]=2;k=2;l=j}else{k=f;l=j}}else{k=c[b>>2]|0;l=h}c[d>>2]=l;g[d+4>>2]=ea(g[b+40>>2]);b=d+8|0;a[b>>0]=a[b>>0]&-16|k&15;i=e;return}function pxd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+8|0;n=j;if(!b){c[n>>2]=0;c[k+0>>2]=c[n+0>>2];kxd(a,k,0,0,0);i=j;return}c[l>>2]=c[b+44>>2];n=mo[c[(c[b>>2]|0)+92>>2]&4095](b)|0;c[k+0>>2]=c[l+0>>2];kxd(a,k,n,b,0);o=ea(g[b+72>>2]);p=ea(g[b+76>>2]);q=ea(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0);r=ea(mo[c[(c[b>>2]|0)+120>>2]&4095](b)|0);if(d){g[d>>2]=o;g[d+4>>2]=p;g[d+8>>2]=q;g[d+12>>2]=r}d=(e|0)!=-1;if(d){n=ync()|0;g[n+(e<<4)+4>>2]=o;g[n+(e<<4)+8>>2]=p;g[n+(e<<4)+12>>2]=q;g[n+(e<<4)+16>>2]=r}e=c[b+52>>2]|0;if((KLc()|0)==1)s=c[b+56>>2]|0;else s=0;qwc(m,e,s,ea(1.0));if(f){c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2]}if(!d){i=j;return}d=(ync()|0)+(h<<4)+4|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];i=j;return}function qxd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=a>>>8;c[d>>2]=a>>>16&3;c[e>>2]=a>>>18&63;c[d+4>>2]=a&3;c[e+4>>2]=a>>>2&63;c[f>>2]=a>>>24;if(!(g&128)){h=0;i=0;j=g&255}else{h=a>>>10&6|1;i=g&3;j=(g&96|0)==0?5:8}c[b>>2]=j;c[d+8>>2]=i;c[e+8>>2]=h;return}function rxd(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+24>>2]=0;return}function sxd(a){a=a|0;var b=0;b=i;txd(a)|0;i=b;return}function txd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+24|0;e=c[d>>2]|0;if(e){Jxd(e);ACi(e)}c[d>>2]=0;d=a+16|0;e=c[d>>2]|0;if(e){Jxd(e);ACi(e)}c[d>>2]=0;d=a+12|0;e=c[d>>2]|0;if(e){Jxd(e);ACi(e)}c[d>>2]=0;d=a+4|0;e=c[d>>2]|0;if(e)BCi(e);c[d>>2]=0;d=c[a>>2]|0;if(!d){c[a>>2]=0;i=b;return a|0}Cxd(d);ACi(d);c[a>>2]=0;i=b;return a|0}function uxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;txd(a)|0;e=xCi(20)|0;Axd(e);c[a>>2]=e;if(Bxd(e,c[b+8>>2]|0,c[b+4>>2]|0,c[b>>2]|0)|0){f=1;i=d;return f|0}b=c[a>>2]|0;if(b){Cxd(b);ACi(b)}c[a>>2]=0;f=0;i=d;return f|0}function vxd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e+84|0;g=e;if(!(c[b>>2]|0)){h=0;i=e;return h|0}j=xCi(12)|0;Ixd(j,4096);k=b+12|0;c[k>>2]=j;j=xCi(12)|0;Ixd(j,4096);l=b+16|0;c[l>>2]=j;j=c[b>>2]|0;m=j+12|0;n=zCi(c[m>>2]|0)|0;o=b+4|0;c[o>>2]=n;p=c[m>>2]|0;q=zCi(p>>>0>1073741823?-1:p<<2)|0;PEi(n|0,0,c[m>>2]|0)|0;PEi(q|0,0,c[m>>2]<<2|0)|0;if(c[m>>2]|0){n=c[j+16>>2]|0;j=0;do{if((c[n+(j*24|0)+12>>2]|0)!=-1){p=q+(j<<2)|0;c[p>>2]=(c[p>>2]|0)+1}if((c[n+(j*24|0)+16>>2]|0)!=-1){p=q+(j<<2)|0;c[p>>2]=(c[p>>2]|0)+1}if((c[n+(j*24|0)+20>>2]|0)!=-1){p=q+(j<<2)|0;c[p>>2]=(c[p>>2]|0)+1}j=j+1|0}while(j>>>0<(c[m>>2]|0)>>>0)}Mxd(f);m=c[(Oxd(f,q,c[(c[b>>2]|0)+12>>2]|0,1)|0)+12>>2]|0;YEi(q|0,m|0,c[(c[b>>2]|0)+12>>2]<<2|0)|0;Nxd(f);f=b+8|0;c[f>>2]=0;m=g+0|0;j=m+84|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(j|0));if(c[(c[b>>2]|0)+12>>2]|0){m=0;j=0;while(1){n=c[o>>2]|0;p=m;while(1){r=c[q+(p<<2)>>2]|0;if(!(a[n+r>>0]|0)){s=r;t=p;break}else p=p+1|0}p=(wxd(b,s,g)|0)+j|0;c[f>>2]=(c[f>>2]|0)+1;if((p|0)==(c[(c[b>>2]|0)+12>>2]|0))break;else{m=t;j=p}}}BCi(q);q=c[o>>2]|0;if(q)BCi(q);c[o>>2]=0;c[d>>2]=c[f>>2];c[d+4>>2]=Kxd(c[k>>2]|0,0)|0;c[d+8>>2]=Kxd(c[l>>2]|0,0)|0;xxd(b,d)|0;yxd(g);h=1;i=e;return h|0}function wxd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;f=i;i=i+80|0;g=f+60|0;h=f+48|0;j=f+36|0;k=f+24|0;l=f+12|0;m=f;n=c[b>>2]|0;o=c[n+16>>2]|0;p=c[o+(d*24|0)>>2]|0;c[l>>2]=p;q=c[o+(d*24|0)+4>>2]|0;c[m>>2]=q;r=c[o+(d*24|0)+8>>2]|0;c[l+4>>2]=r;c[m+4>>2]=p;c[l+8>>2]=q;c[m+8>>2]=r;r=e+72|0;q=e+76|0;p=b+4|0;o=n;n=0;while(1){s=e+(n*24|0)|0;t=c[o+12>>2]|0;u=t+5|0;v=e+(n*24|0)+4|0;w=c[v>>2]|0;x=c[s>>2]|0;y=w-x>>2;if(u>>>0<=y>>>0)if(u>>>0<y>>>0?(z=x+(u<<2)|0,(w|0)!=(z|0)):0){A=w+(~((w+-4-z|0)>>>2)<<2)|0;c[v>>2]=A;B=x;C=A;D=t}else{B=x;C=w;D=t}else{zxd(s,u-y|0);B=c[s>>2]|0;C=c[v>>2]|0;D=c[(c[b>>2]|0)+12>>2]|0}v=(B|0)==(C|0)?0:B;c[g+(n<<2)>>2]=v;s=e+(n*24|0)+12|0;y=D+2|0;u=e+(n*24|0)+16|0;t=c[u>>2]|0;w=c[s>>2]|0;x=t-w>>2;if(y>>>0<=x>>>0)if(y>>>0<x>>>0?(A=w+(y<<2)|0,(t|0)!=(A|0)):0){z=t+(~((t+-4-A|0)>>>2)<<2)|0;c[u>>2]=z;E=w;F=z;G=D}else{E=w;F=t;G=D}else{zxd(s,y-x|0);E=c[s>>2]|0;F=c[u>>2]|0;G=c[(c[b>>2]|0)+12>>2]|0}u=(E|0)==(F|0)?0:E;c[h+(n<<2)>>2]=u;PEi(v|0,-1,(G<<2)+20|0)|0;PEi(u|0,-1,(c[(c[b>>2]|0)+12>>2]<<2)+8|0)|0;s=c[(c[b>>2]|0)+12>>2]|0;x=c[q>>2]|0;y=c[r>>2]|0;t=x-y|0;if(s>>>0<=t>>>0)if(s>>>0<t>>>0?(w=y+s|0,(x|0)!=(w|0)):0){c[q>>2]=w;H=y;I=w;J=s}else{H=y;I=x;J=s}else{yJc(r,s-t|0);H=c[r>>2]|0;I=c[q>>2]|0;J=c[(c[b>>2]|0)+12>>2]|0}t=(H|0)==(I|0)?0:H;YEi(t|0,c[p>>2]|0,J|0)|0;s=c[l+(n<<2)>>2]|0;x=c[m+(n<<2)>>2]|0;c[v>>2]=s;c[v+4>>2]=x;y=d;w=s;s=x;x=u;z=0;A=1;K=2;a:while(1){L=t+y|0;M=w;N=s;O=x;P=z;Q=K;R=A;while(1){if(!R){S=Q;break a}T=P^1;U=Hxd((c[(c[b>>2]|0)+16>>2]|0)+(y*24|0)|0,M,N)|0;V=Q+1|0;c[v+(Q<<2)>>2]=U;W=O+4|0;c[O>>2]=y;a[L>>0]=1;X=(Fxd((c[(c[b>>2]|0)+16>>2]|0)+(y*24|0)|0,N,U)|0)&255;Y=c[(c[b>>2]|0)+16>>2]|0;Z=c[Y+(y*24|0)+(X<<2)+12>>2]|0;if((Z|0)==-1){X=N;N=U;O=W;P=T;Q=V;R=0;M=X}else{_=N;$=T;aa=U;ba=V;ca=W;da=Y;ea=Z;break}}N=ea&1073741823;M=Gxd(da+(N*24|0)|0,_,aa,$)|0;y=N;w=_;s=aa;x=ca;z=$;A=M<<24>>24!=-1&(a[t+N>>0]|0)==0;K=ba}K=j+(n<<2)|0;c[K>>2]=S;c[k+(n<<2)>>2]=S;if(S>>>0>1){A=S>>>1;z=0;x=0;while(1){s=v+(z+-1+S<<2)|0;w=v+(x<<2)|0;y=c[w>>2]^c[s>>2];c[w>>2]=y;N=c[s>>2]^y;c[s>>2]=N;c[w>>2]=c[w>>2]^N;N=x+1|0;if(N>>>0<A>>>0){z=~x;x=N}else break}}x=S+-2|0;if(x>>>0>1){z=x>>>1;A=0;N=0;while(1){w=u+(A+-3+S<<2)|0;s=u+(N<<2)|0;y=c[s>>2]^c[w>>2];c[s>>2]=y;M=c[w>>2]^y;c[w>>2]=M;c[s>>2]=c[s>>2]^M;M=N+1|0;if(M>>>0<z>>>0){A=~N;N=M}else break}}N=S+-3|0;A=d;z=c[v+(N<<2)>>2]|0;M=c[v+(x<<2)>>2]|0;s=u+(N<<2)|0;w=1;y=1;R=2;b:while(1){Q=t+A|0;P=z;O=M;L=s;Z=w;Y=y;W=R;while(1){if(!Y){fa=W;break b}V=Z^1;U=Hxd((c[(c[b>>2]|0)+16>>2]|0)+(A*24|0)|0,P,O)|0;T=W+1|0;c[v+(W+N<<2)>>2]=U;X=L+4|0;c[L>>2]=A;a[Q>>0]=1;ga=(Fxd((c[(c[b>>2]|0)+16>>2]|0)+(A*24|0)|0,O,U)|0)&255;ha=c[(c[b>>2]|0)+16>>2]|0;ia=c[ha+(A*24|0)+(ga<<2)+12>>2]|0;if((ia|0)==-1){ga=O;O=U;L=X;Z=V;Y=0;W=T;P=ga}else{ja=O;ka=V;la=U;ma=T;na=X;oa=ha;pa=ia;break}}O=pa&1073741823;P=Gxd(oa+(O*24|0)|0,ja,la,ka)|0;A=O;z=ja;M=la;s=na;w=ka;y=P<<24>>24!=-1&(a[t+O>>0]|0)==0;R=ma}c[K>>2]=fa+-3+(c[K>>2]|0);R=n+1|0;if((R|0)==3)break;o=c[b>>2]|0;n=R}n=c[j>>2]|0;o=c[j+4>>2]|0;fa=o>>>0>n>>>0;ma=fa?o:n;n=c[j+8>>2]|0;j=n>>>0>ma>>>0;o=j?n:ma;ma=j?2:fa&1;fa=o+-2|0;if(fa){j=c[h+(ma<<2)>>2]|0;h=c[p>>2]|0;p=0;do{a[h+(c[j+(p<<2)>>2]|0)>>0]=1;p=p+1|0}while(p>>>0<fa>>>0)}p=c[k+(ma<<2)>>2]|0;do if(p&1){if((o+-3|0)>>>0<2){k=c[g+(ma<<2)>>2]|0;j=k+8|0;h=c[j>>2]|0;n=k+4|0;c[j>>2]=c[n>>2];c[n>>2]=h;qa=o;break}h=o>>>1;if(h){n=c[g+(ma<<2)>>2]|0;j=0;do{k=n+(o-j+-1<<2)|0;ka=n+(j<<2)|0;na=c[ka>>2]^c[k>>2];c[ka>>2]=na;la=c[k>>2]^na;c[k>>2]=la;c[ka>>2]=c[ka>>2]^la;j=j+1|0}while(j>>>0<h>>>0)}if(o-p&1){if(o){h=c[g+(ma<<2)>>2]|0;j=0;do{n=o-j|0;c[h+(n<<2)>>2]=c[h+(n+-1<<2)>>2];j=j+1|0}while(o>>>0>j>>>0)}ra=o+1|0;sa=49}else{ra=o;sa=49}}else{ra=o;sa=49}while(0);if((sa|0)==49)if(!ra){ta=0;ua=b+12|0;va=c[ua>>2]|0;Lxd(va,ta)|0;i=f;return fa|0}else qa=ra;ra=b+16|0;sa=c[g+(ma<<2)>>2]|0;ma=0;do{Lxd(c[ra>>2]|0,c[sa+(ma<<2)>>2]|0)|0;ma=ma+1|0}while((ma|0)!=(qa|0));ta=qa;ua=b+12|0;va=c[ua>>2]|0;Lxd(va,ta)|0;i=f;return fa|0}function xxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=xCi(12)|0;Ixd(e,4096);f=a+24|0;c[f>>2]=e;g=a+20|0;c[g>>2]=0;a=b+8|0;if(!(c[b>>2]|0)){h=b+4|0;j=e;c[b>>2]=1;k=Kxd(j,0)|0;c[a>>2]=k;c[h>>2]=g;i=d;return 1}e=b+4|0;l=c[a>>2]|0;m=0;while(1){do if((m|0)!=0?(n=c[l>>2]|0,Lxd(Lxd(c[f>>2]|0,c[l+-4>>2]|0)|0,n)|0,o=(c[g>>2]|0)+2|0,c[g>>2]=o,(o&1|0)!=0):0){o=l+4|0;if((n|0)==(c[o>>2]|0)){p=(c[e>>2]|0)+(m<<2)|0;c[p>>2]=(c[p>>2]|0)+-1;q=o;break}else{Lxd(c[f>>2]|0,n)|0;c[g>>2]=(c[g>>2]|0)+1;q=l;break}}else q=l;while(0);if(!(c[(c[e>>2]|0)+(m<<2)>>2]|0))r=0;else{n=0;do{Lxd(c[f>>2]|0,c[q+(n<<2)>>2]|0)|0;n=n+1|0;o=c[(c[e>>2]|0)+(m<<2)>>2]|0}while(n>>>0<o>>>0);r=o}c[g>>2]=(c[g>>2]|0)+r;m=m+1|0;if(m>>>0>=(c[b>>2]|0)>>>0)break;else l=q+(r<<2)|0}h=e;j=c[f>>2]|0;c[b>>2]=1;k=Kxd(j,0)|0;c[a>>2]=k;c[h>>2]=g;i=d;return 1}function yxd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+72>>2]|0;if(d){e=a+76|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+60>>2]|0;if(d){e=a+64|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d)}d=c[a+48>>2]|0;if(d){f=a+52|0;e=c[f>>2]|0;if((e|0)!=(d|0))c[f>>2]=e+(~((e+-4-d|0)>>>2)<<2);ACi(d)}d=c[a+36>>2]|0;if(d){e=a+40|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d)}d=c[a+24>>2]|0;if(d){f=a+28|0;e=c[f>>2]|0;if((e|0)!=(d|0))c[f>>2]=e+(~((e+-4-d|0)>>>2)<<2);ACi(d)}d=c[a+12>>2]|0;if(d){e=a+16|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d)}d=c[a>>2]|0;if(!d){i=b;return}f=a+4|0;a=c[f>>2]|0;if((a|0)!=(d|0))c[f>>2]=a+(~((a+-4-d|0)>>>2)<<2);ACi(d);i=b;return}function zxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){k=b;l=h;while(1){if(l)c[l>>2]=0;k=k+-1|0;if(!k)break;else l=l+4|0}c[g>>2]=h+(b<<2);i=d;return}h=c[a>>2]|0;l=(j-h>>2)+b|0;if(l>>>0>1073741823)vxi(a);j=h;k=f-j|0;if(k>>2>>>0<536870911){f=k>>1;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j|0;l=f>>2;if(!k){m=0;n=0;o=l;p=f}else{q=k;r=l;s=f;t=11}}else{f=(c[g>>2]|0)-j|0;q=1073741823;r=f>>2;s=f;t=11}if((t|0)==11){m=q;n=xCi(q<<2)|0;o=r;p=s}s=b;r=n+(o<<2)|0;while(1){if(r)c[r>>2]=0;s=s+-1|0;if(!s)break;else r=r+4|0}YEi(n|0,h|0,p|0)|0;p=c[a>>2]|0;c[a>>2]=n;c[g>>2]=n+(o+b<<2);c[e>>2]=n+(m<<2);if(!p){i=d;return}ACi(p);i=d;return}function Axd(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;return}function Bxd(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a+12|0;c[h>>2]=f;j=a+16|0;c[j>>2]=zCi(f>>>0>178956970?-1:f*24|0)|0;k=f*3|0;l=a+8|0;c[l>>2]=zCi(k>>>0>357913941?-1:k*12|0)|0;if(!f){m=Dxd(a)|0;i=g;return m|0}f=a+4|0;if(!d){k=0;do{n=k*3|0;o=c[e+(n<<2)>>2]|0;p=c[e+(n+1<<2)>>2]|0;q=c[e+(n+2<<2)>>2]|0;n=c[j>>2]|0;c[n+((c[f>>2]|0)*24|0)>>2]=o;c[n+((c[f>>2]|0)*24|0)+4>>2]=p;c[n+((c[f>>2]|0)*24|0)+8>>2]=q;c[n+((c[f>>2]|0)*24|0)+12>>2]=-1;c[n+((c[f>>2]|0)*24|0)+16>>2]=-1;c[n+((c[f>>2]|0)*24|0)+20>>2]=-1;n=o>>>0<p>>>0;r=c[f>>2]|0;s=c[a>>2]|0;t=c[l>>2]|0;c[t+(s*12|0)>>2]=n?o:p;c[t+(s*12|0)+4>>2]=n?p:o;c[t+(s*12|0)+8>>2]=r;r=s+1|0;t=o>>>0<q>>>0;n=c[f>>2]|0;u=c[l>>2]|0;c[u+(r*12|0)>>2]=t?o:q;c[u+(r*12|0)+4>>2]=t?q:o;c[u+(r*12|0)+8>>2]=n;n=s+2|0;r=p>>>0<q>>>0;u=c[f>>2]|0;o=c[l>>2]|0;c[o+(n*12|0)>>2]=r?p:q;c[o+(n*12|0)+4>>2]=r?q:p;c[o+(n*12|0)+8>>2]=u;c[a>>2]=s+3;c[f>>2]=(c[f>>2]|0)+1;k=k+1|0}while(k>>>0<(c[h>>2]|0)>>>0);m=Dxd(a)|0;i=g;return m|0}else{k=0;do{e=k*3|0;s=b[d+(e<<1)>>1]|0;u=s&65535;n=b[d+(e+1<<1)>>1]|0;o=n&65535;p=b[d+(e+2<<1)>>1]|0;e=p&65535;q=c[j>>2]|0;c[q+((c[f>>2]|0)*24|0)>>2]=u;c[q+((c[f>>2]|0)*24|0)+4>>2]=o;c[q+((c[f>>2]|0)*24|0)+8>>2]=e;c[q+((c[f>>2]|0)*24|0)+12>>2]=-1;c[q+((c[f>>2]|0)*24|0)+16>>2]=-1;c[q+((c[f>>2]|0)*24|0)+20>>2]=-1;q=(s&65535)<(n&65535);r=c[f>>2]|0;t=c[a>>2]|0;v=c[l>>2]|0;c[v+(t*12|0)>>2]=q?u:o;c[v+(t*12|0)+4>>2]=q?o:u;c[v+(t*12|0)+8>>2]=r;r=t+1|0;v=(s&65535)<(p&65535);s=c[f>>2]|0;q=c[l>>2]|0;c[q+(r*12|0)>>2]=v?u:e;c[q+(r*12|0)+4>>2]=v?e:u;c[q+(r*12|0)+8>>2]=s;s=t+2|0;r=(n&65535)<(p&65535);p=c[f>>2]|0;n=c[l>>2]|0;c[n+(s*12|0)>>2]=r?o:e;c[n+(s*12|0)+4>>2]=r?e:o;c[n+(s*12|0)+8>>2]=p;c[a>>2]=t+3;c[f>>2]=(c[f>>2]|0)+1;k=k+1|0}while(k>>>0<(c[h>>2]|0)>>>0);m=Dxd(a)|0;i=g;return m|0}return 0}function Cxd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+8|0;e=c[d>>2]|0;if(e)BCi(e);c[d>>2]=0;d=a+16|0;a=c[d>>2]|0;if(!a){c[d>>2]=0;i=b;return}BCi(a);c[d>>2]=0;i=b;return}function Dxd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;b=i;i=i+32|0;d=b+12|0;e=b;Mxd(d);f=c[a>>2]|0;g=f>>>0>1073741823?-1:f<<2;h=zCi(g)|0;j=zCi(g)|0;k=zCi(g)|0;if(!f)l=0;else{g=c[a+8>>2]|0;m=0;do{c[h+(m<<2)>>2]=c[g+(m*12|0)+8>>2];c[j+(m<<2)>>2]=c[g+(m*12|0)>>2];c[k+(m<<2)>>2]=c[g+(m*12|0)+4>>2];m=m+1|0}while(m>>>0<f>>>0);l=f}f=Oxd(d,h,l,1)|0;l=Oxd(f,j,c[a>>2]|0,1)|0;f=c[(Oxd(l,k,c[a>>2]|0,1)|0)+12>>2]|0;l=c[f>>2]|0;m=c[j+(l<<2)>>2]|0;g=c[k+(l<<2)>>2]|0;n=c[a>>2]|0;do if(n){o=e+4|0;p=l;q=m;r=g;s=n;t=0;u=m;v=g;w=1;while(1){x=c[h+(p<<2)>>2]|0;if((q|0)==(u|0)&(r|0)==(v|0)){y=t+1|0;c[e+(t<<2)>>2]=x;if((y|0)==3){z=8;break}else{A=s;B=y}}else{if((t|0)==2){if(!(Exd(a,c[e>>2]|0,c[o>>2]|0,u,v)|0)){z=12;break}C=c[a>>2]|0}else C=s;c[e>>2]=x;A=C;B=1}if(w>>>0>=A>>>0){D=r;E=q;F=B;z=16;break}x=c[f+(w<<2)>>2]|0;y=r;G=q;p=x;q=c[j+(x<<2)>>2]|0;r=c[k+(x<<2)>>2]|0;s=A;t=B;w=w+1|0;v=y;u=G}if((z|0)==8){BCi(k);BCi(j);BCi(h);H=0;Nxd(d);i=b;return H|0}else if((z|0)==12){BCi(k);BCi(j);BCi(h);H=0;Nxd(d);i=b;return H|0}else if((z|0)==16){if((F|0)!=2){I=1;break}I=Exd(a,c[e>>2]|0,c[e+4>>2]|0,E,D)|0;break}}else I=1;while(0);BCi(k);BCi(j);BCi(h);h=a+8|0;a=c[h>>2]|0;if(a)BCi(a);c[h>>2]=0;H=I;Nxd(d);i=b;return H|0}function Exd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=c[a+16>>2]|0;a=c[h+(b*24|0)>>2]|0;j=(a|0)==(e|0);if(j?(c[h+(b*24|0)+4>>2]|0)==(f|0):0)k=0;else l=3;do if((l|0)==3){m=(a|0)==(f|0);if(m?(c[h+(b*24|0)+4>>2]|0)==(e|0):0){k=0;break}if(j?(c[h+(b*24|0)+8>>2]|0)==(f|0):0){k=1;break}if(m?(c[h+(b*24|0)+8>>2]|0)==(e|0):0){k=1;break}m=c[h+(b*24|0)+4>>2]|0;if((m|0)==(e|0)?(c[h+(b*24|0)+8>>2]|0)==(f|0):0){k=2;break}if((m|0)!=(f|0)){n=0;i=g;return n|0}if((c[h+(b*24|0)+8>>2]|0)==(e|0))k=2;else{n=0;i=g;return n|0}}while(0);j=c[h+(d*24|0)>>2]|0;a=(j|0)==(e|0);if(a?(c[h+(d*24|0)+4>>2]|0)==(f|0):0)o=0;else l=15;do if((l|0)==15){m=(j|0)==(f|0);if(m?(c[h+(d*24|0)+4>>2]|0)==(e|0):0){o=0;break}if(a?(c[h+(d*24|0)+8>>2]|0)==(f|0):0){o=1;break}if(m?(c[h+(d*24|0)+8>>2]|0)==(e|0):0){o=1;break}m=c[h+(d*24|0)+4>>2]|0;if((m|0)==(e|0)?(c[h+(d*24|0)+8>>2]|0)==(f|0):0){o=2;break}if((m|0)!=(f|0)){n=0;i=g;return n|0}if((c[h+(d*24|0)+8>>2]|0)==(e|0))o=2;else{n=0;i=g;return n|0}}while(0);c[h+(b*24|0)+(k<<2)+12>>2]=o<<30|d;c[h+(d*24|0)+(o<<2)+12>>2]=k<<30|b;n=1;i=g;return n|0}function Fxd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[a>>2]|0;g=(f|0)==(b|0);if(g?(c[a+4>>2]|0)==(d|0):0)h=0;else j=3;do if((j|0)==3){k=(f|0)==(d|0);if(k?(c[a+4>>2]|0)==(b|0):0){h=0;break}if(g?(c[a+8>>2]|0)==(d|0):0){h=1;break}if(k?(c[a+8>>2]|0)==(b|0):0){h=1;break}k=c[a+4>>2]|0;if((k|0)==(b|0)?(c[a+8>>2]|0)==(d|0):0){h=2;break}if((k|0)==(d|0)){i=e;return ((c[a+8>>2]|0)==(b|0)?2:-1)|0}else h=-1}while(0);i=e;return h|0}function Gxd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=e?d:b;h=e?b:d;d=c[a>>2]|0;if((d|0)==(g|0)?(c[a+4>>2]|0)==(h|0):0){j=0;i=f;return j|0}b=c[a+8>>2]|0;if((b|0)==(g|0)&(d|0)==(h|0)){j=1;i=f;return j|0}if((c[a+4>>2]|0)==(g|0)){i=f;return ((b|0)==(h|0)?2:-1)|0}else{j=-1;i=f;return j|0}return 0}function Hxd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a>>2]|0;g=(f|0)==(b|0);if(g?(c[a+4>>2]|0)==(d|0):0){h=c[a+8>>2]|0;i=e;return h|0}j=(f|0)==(d|0);if(j?(c[a+4>>2]|0)==(b|0):0){h=c[a+8>>2]|0;i=e;return h|0}if(g?(c[a+8>>2]|0)==(d|0):0){h=c[a+4>>2]|0;i=e;return h|0}if(j?(c[a+8>>2]|0)==(b|0):0){h=c[a+4>>2]|0;i=e;return h|0}j=c[a+4>>2]|0;if((j|0)==(b|0)?(c[a+8>>2]|0)==(d|0):0){h=f;i=e;return h|0}if((j|0)==(d|0)){i=e;return ((c[a+8>>2]|0)==(b|0)?f:-1)|0}else{h=-1;i=e;return h|0}return 0}function Ixd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+8>>2]=0;e=xCi(16)|0;c[e>>2]=0;c[e+12>>2]=b;c[e+4>>2]=zCi(b)|0;c[e+8>>2]=0;c[a>>2]=e;c[a+4>>2]=e;i=d;return}function Jxd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+8|0;e=c[d>>2]|0;if(e)BCi(e);c[d>>2]=0;d=c[a+4>>2]|0;if(!d){i=b;return}else f=d;do{d=f;f=c[f>>2]|0;a=c[d+4>>2]|0;if(a)BCi(a);ACi(d)}while((f|0)!=0);i=b;return}function Kxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=a+4|0;f=c[e>>2]|0;do if(!b){g=a+8|0;h=c[g>>2]|0;if(!h)j=f;else{BCi(h);j=c[e>>2]|0}c[g>>2]=0;h=0;k=j;while(1){l=k;k=c[k>>2]|0;m=(c[l+8>>2]|0)+h|0;if(!k){n=m;break}else h=m}if(n){h=zCi(n)|0;c[g>>2]=h;o=h;break}c[g>>2]=0;p=0;i=d;return p|0}else o=b;while(0);b=(c[f>>2]|0)==0;n=f+8|0;YEi(o|0,c[f+4>>2]|0,c[n>>2]|0)|0;if(b){p=o;i=d;return p|0}else{q=n;r=f;s=o}do{s=s+(c[q>>2]|0)|0;r=c[r>>2]|0;f=(c[r>>2]|0)==0;q=r+8|0;YEi(s|0,c[r+4>>2]|0,c[q>>2]|0)|0}while(!f);p=o;i=d;return p|0}function Lxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[a>>2]|0;f=e+12|0;do if(((c[e+8>>2]|0)+4|0)>>>0>(c[f>>2]|0)>>>0){g=xCi(16)|0;h=g+4|0;c[h>>2]=0;c[g>>2]=0;if(!e){c[g+12>>2]=0;c[h>>2]=zCi(0)|0;c[g+8>>2]=0;c[a>>2]=g;j=g;break}else{k=c[f>>2]<<1;c[g+12>>2]=k;c[h>>2]=zCi(k)|0;c[g+8>>2]=0;c[a>>2]=g;c[e>>2]=g;j=g;break}}else j=e;while(0);e=j+8|0;f=c[e>>2]|0;c[(c[j+4>>2]|0)+f>>2]=b;c[e>>2]=f+4;i=d;return a|0}function Mxd(a){a=a|0;var b=0;b=i;c[a+12>>2]=0;c[a+16>>2]=0;c[a+8>>2]=0;c[a>>2]=zCi(4096)|0;c[a+4>>2]=zCi(1024)|0;i=b;return}function Nxd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;e=c[d>>2]|0;if(e)BCi(e);c[d>>2]=0;d=c[a>>2]|0;if(d)BCi(d);c[a>>2]=0;d=a+16|0;e=c[d>>2]|0;if(e)BCi(e);c[d>>2]=0;d=a+12|0;a=c[d>>2]|0;if(!a){c[d>>2]=0;i=b;return}BCi(a);c[d>>2]=0;i=b;return}function Oxd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;h=a+8|0;if((c[h>>2]|0)>>>0<e>>>0){j=a+16|0;k=c[j>>2]|0;if(k)BCi(k);c[j>>2]=0;k=a+12|0;l=c[k>>2]|0;if(l)BCi(l);l=e>>>0>1073741823?-1:e<<2;m=zCi(l)|0;c[k>>2]=m;c[j>>2]=zCi(l)|0;c[h>>2]=e;if(!e)n=k;else{h=0;do{c[m+(h<<2)>>2]=h;h=h+1|0}while(h>>>0<e>>>0);n=k}}else n=a+12|0;PEi(c[a>>2]|0,0,4096)|0;k=c[n>>2]|0;h=b+(e<<2)|0;m=c[a>>2]|0;l=c[b+(c[k>>2]<<2)>>2]|0;j=(h|0)==(b|0);if(f){if(j){i=g;return a|0}else{o=l;p=1;q=k;r=l;s=b}while(1){t=q+4|0;u=(o|0)<(r|0)?0:p;v=m+((d[s>>0]|0)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;v=m+((d[s+1>>0]|0|256)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;v=m+((d[s+2>>0]|0|512)<<2)|0;c[v>>2]=(c[v>>2]|0)+1;v=s+4|0;w=m+((d[s+3>>0]|0|768)<<2)|0;c[w>>2]=(c[w>>2]|0)+1;if((v|0)==(h|0)){x=u;break}w=o;o=c[b+(c[t>>2]<<2)>>2]|0;p=u;q=t;s=v;r=w}if(x&1){i=g;return a|0}}else{if(j){i=g;return a|0}else{y=l;z=1;A=k;B=l;C=b}while(1){l=A+4|0;D=z&y>>>0>=B>>>0;j=m+((d[C>>0]|0)<<2)|0;c[j>>2]=(c[j>>2]|0)+1;j=m+((d[C+1>>0]|0|256)<<2)|0;c[j>>2]=(c[j>>2]|0)+1;j=m+((d[C+2>>0]|0|512)<<2)|0;c[j>>2]=(c[j>>2]|0)+1;j=C+4|0;x=m+((d[C+3>>0]|0|768)<<2)|0;c[x>>2]=(c[x>>2]|0)+1;if((j|0)==(h|0))break;x=y;y=c[b+(c[l>>2]<<2)>>2]|0;z=D;A=l;C=j;B=x}if(D){i=g;return a|0}}if(f){D=0;B=128;while(1){C=(c[m+(B+768<<2)>>2]|0)+D|0;B=B+1|0;if((B|0)==256){E=C;break}else D=C}D=a+4|0;B=a+16|0;if(f){f=k;C=0;while(1){A=C<<8;z=0;while(1){y=c[m+(z+A<<2)>>2]|0;if((y|0)==(e|0)){F=f;break}z=z+1|0;if(!((y|0)==0&z>>>0<256)){G=36;break}}if((G|0)==36){G=0;z=c[D>>2]|0;if((C|0)==3){c[z>>2]=E;y=E;h=1;do{y=(c[m+(h+-1+A<<2)>>2]|0)+y|0;c[z+(h<<2)>>2]=y;h=h+1|0}while((h|0)!=128);c[z+512>>2]=0;h=0;y=129;do{h=(c[m+(y+-1+A<<2)>>2]|0)+h|0;c[z+(y<<2)>>2]=h;y=y+1|0}while((y|0)!=256)}else{c[z>>2]=0;y=0;h=1;do{y=(c[m+(h+-1+A<<2)>>2]|0)+y|0;c[z+(h<<2)>>2]=y;h=h+1|0}while((h|0)!=256)}h=f+(e<<2)|0;y=c[B>>2]|0;if(e){A=f;do{x=c[A>>2]|0;A=A+4|0;j=z+((d[b+((x<<2)+C)>>0]|0)<<2)|0;l=c[j>>2]|0;c[j>>2]=l+1;c[y+(l<<2)>>2]=x}while((A|0)!=(h|0))}c[n>>2]=y;c[B>>2]=f;F=y}C=C+1|0;if((C|0)==4)break;else f=F}i=g;return a|0}else{H=B;I=D}}else{H=a+16|0;I=a+4|0}D=k;k=0;while(1){B=k<<8;F=0;while(1){f=c[m+(F+B<<2)>>2]|0;if((f|0)==(e|0)){J=D;break}F=F+1|0;if(!((f|0)==0&F>>>0<256)){G=26;break}}if((G|0)==26){G=0;F=c[I>>2]|0;c[F>>2]=0;y=0;f=1;do{y=(c[m+(f+-1+B<<2)>>2]|0)+y|0;c[F+(f<<2)>>2]=y;f=f+1|0}while((f|0)!=256);f=D+(e<<2)|0;if(!e)K=c[H>>2]|0;else{y=D;do{F=c[y>>2]|0;y=y+4|0;B=(c[I>>2]|0)+((d[b+((F<<2)+k)>>0]|0)<<2)|0;C=c[B>>2]|0;c[B>>2]=C+1;B=c[H>>2]|0;c[B+(C<<2)>>2]=F}while((y|0)!=(f|0));K=B}c[n>>2]=K;c[H>>2]=D;J=K}k=k+1|0;if((k|0)==4)break;else D=J}i=g;return a|0}function Pxd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=(c[a+8>>2]|0)+72|0;a=c[f>>2]|0;if(!a){g=0;h=Ecd(g)|0;i=b;return h|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);j=c[d>>2]|0;k=c[a+28>>2]|0;if((j|0)==-1){l=k+(c[a+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((l|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[l+4>>2]|0,(a|0)!=0):0)m=a;else n=10}else n=10;if((n|0)==10)m=hQb(c[f>>2]|0)|0;g=m;h=Ecd(g)|0;i=b;return h|0}function Qxd(b){b=b|0;a[(c[b+8>>2]|0)+76>>0]=0;return}function Rxd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d;Stc(e,b);if(!a){g=0;Orc(g)}b=Erc(a)|0;if(!b){g=a;Orc(g)}Vtc(f,e);e=wOc(b,f,c)|0;xri(f);if(!e){h=0;i=d;return h|0}h=Ecd(e)|0;i=d;return h|0}function Sxd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+24|0;g=e+12|0;h=e;Stc(f,b);c[g>>2]=0;b=g+4|0;c[b>>2]=0;c[g+8>>2]=0;if(!a){j=0;Orc(j)}k=Erc(a)|0;if(!k){j=a;Orc(j)}Vtc(h,f);xOc(k,h,d,g);xri(h);h=Xxd(g,0)|0;d=c[g>>2]|0;if(!d){i=e;return h|0}g=c[b>>2]|0;if((g|0)!=(d|0))c[b>>2]=g+(~((g+-4-d|0)>>>2)<<2);ACi(d);i=e;return h|0}function Txd(){var a=0;a=i;xrc(659776,3556);i=a;return}function Uxd(){var a=0;a=i;xrc(659832,3513);i=a;return}function Vxd(){var a=0;a=i;xrc(659904,1734);i=a;return}function Wxd(){var a=0;a=i;xrc(659952,1735);i=a;return}function Xxd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=Sbd(Xbd()|0,b)|0;b=a+4|0;f=Isc(e,4,(c[b>>2]|0)-(c[a>>2]|0)>>2)|0;e=yrc(f)|0;g=c[a>>2]|0;if((g|0)==(c[b>>2]|0))h=0;else{a=g;g=0;while(1){Qrc(f,g,Ecd(c[a>>2]|0)|0);j=g+1|0;a=a+4|0;if((a|0)==(c[b>>2]|0)){h=j;break}else g=j}}if((h|0)<(e|0))k=h;else{i=d;return f|0}do{c[(Gsc(f,k,4)|0)>>2]=0;k=k+1|0}while((k|0)!=(e|0));i=d;return f|0}function Yxd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=OWb(ZWb()|0,b)|0;b=a[e>>0]|0;if(!(b&1)){f=e+1|0;g=(b&255)>>>1}else{f=c[e+8>>2]|0;g=c[e+4>>2]|0}e=Esc(f,g)|0;i=d;return e|0}function Zxd(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+12|0;d=b;Stc(c,a);a=ZWb()|0;Vtc(d,c);c=NWb(a,d)|0;xri(d);i=b;return c|0}function _xd(){var a=0,b=0;a=i;if(rBc()|0)b=(c[155287]|0)>0&1;else b=0;i=a;return b|0}function $xd(a){a=a|0;var b=0,d=0;b=i;if(!a)d=0;else d=c[a+8>>2]|0;M8c(d);i=b;return}function ayd(a){a=a|0;var b=0;b=i;Ocd(a);i=b;return}function byd(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+12|0;d=b;Stc(c,a);Utc(d,c);c=Ncd(d)|0;xri(d);i=b;return c|0}function cyd(a){a=a|0;var b=0,c=0;b=i;c=Mcd(a)|0;i=b;return c|0}function dyd(){var a=0;a=i;xrc(660016,3557);i=a;return}function eyd(){var a=0;a=i;xrc(660056,3558);i=a;return}function fyd(){var a=0;a=i;xrc(660096,61);i=a;return}function gyd(){var a=0;a=i;xrc(660152,3514);i=a;return}function hyd(){var a=0;a=i;xrc(660192,3515);i=a;return}function iyd(){var a=0;a=i;xrc(660256,3559);i=a;return}function jyd(){var a=0;a=i;xrc(660304,3560);i=a;return}function kyd(){var a=0,b=0;a=i;b=vSc(rSc()|0)|0;i=a;return b|0}function lyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(!a)d=0;else d=Erc(a)|0;if(!b)e=0;else e=Erc(b)|0;D3b(d,e);i=c;return}function myd(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if((c|0)!=0?(g=Erc(c)|0,(g|0)!=0):0){if(!a)h=0;else h=Erc(a)|0;if(!b)j=0;else j=Erc(b)|0;F3b(h,j,g,d,e<<24>>24!=0,-1);i=f;return}Krd(660360,0,3653512,3647,1,0,0,0);i=f;return}function nyd(){var a=0,b=0,d=0;a=i;b=ECc()|0;d=mo[c[(c[b>>2]|0)+80>>2]&4095](b)|0;i=a;return d|0}function oyd(){var a=0,b=0,d=0;a=i;b=ECc()|0;d=mo[c[(c[b>>2]|0)+84>>2]&4095](b)|0;i=a;return d|0}function pyd(){var a=0;a=i;xrc(660392,62);i=a;return}function qyd(){var a=0;a=i;xrc(660448,3014);i=a;return}function ryd(){var a=0;a=i;xrc(660480,99);i=a;return}function syd(){var a=0;a=i;xrc(660528,63);i=a;return}function tyd(){var a=0;a=i;xrc(660560,64);i=a;return}function uyd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{a=mo[c[(c[d>>2]|0)+104>>2]&4095](d)|0;i=b;return a|0}}else e=0;Orc(e);return 0}function vyd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{a=mo[c[(c[d>>2]|0)+108>>2]&4095](d)|0;i=b;return a|0}}else e=0;Orc(e);return 0}function wyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{PDc(d,b);i=c;return}}else e=0;Orc(e)}function xyd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=c[153106];c[e+0>>2]=c[f+0>>2];f=bOb(172,e,1,16,3653512,1001)|0;c[g>>2]=c[153106];c[e+0>>2]=c[g+0>>2];BBc(f,e,0);e=pQb(f)|0;a[e+132>>0]=1;ko[c[(c[e>>2]|0)+24>>2]&4095](e);Fcd(b,e)|0;In[c[(c[e>>2]|0)+12>>2]&4095](e,4);i=d;return}function yyd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return c[d+100>>2]|0}}else e=0;Orc(e);return 0}function zyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{JBc(d,b);i=c;return}}else e=0;Orc(e)}function Ayd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return c[d+104>>2]|0}}else e=0;Orc(e);return 0}function Byd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{KBc(d,b);i=c;return}}else e=0;Orc(e)}function Cyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{HBc(d,b<<24>>24!=0);i=c;return}}else e=0;Orc(e)}function Dyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((b|0)<1)d=0;else d=(b|0)<17?1:2;if(a){b=Erc(a)|0;if(!b)e=a;else{LBc(b,d);i=c;return}}else e=0;Orc(e)}function Eyd(a,b){a=a|0;b=b|0;return}function Fyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{MBc(d,b);i=c;return}}else e=0;Orc(e)}function Gyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{FBc(d,b<<24>>24!=0);i=c;return}}else e=0;Orc(e)}function Hyd(a){a=a|0;var b=0,c=0,d=0;b=i;if(a){c=Erc(a)|0;if(!c)d=a;else{a=(uBc(c)|0)&1;i=b;return a|0}}else d=0;Orc(d);return 0}function Iyd(){var a=0;a=i;xrc(660592,3561);i=a;return}function Jyd(){var a=0;a=i;xrc(660632,3562);i=a;return}function Kyd(){var a=0;a=i;xrc(660672,3015);i=a;return}function Lyd(){var a=0;a=i;xrc(660712,3516);i=a;return}function Myd(){var a=0;a=i;xrc(660768,3563);i=a;return}function Nyd(){var a=0;a=i;xrc(660816,3016);i=a;return}function Oyd(){var a=0;a=i;xrc(660864,3564);i=a;return}function Pyd(){var a=0;a=i;xrc(660912,3017);i=a;return}function Qyd(){var a=0;a=i;xrc(660960,3018);i=a;return}function Ryd(){var a=0;a=i;xrc(661016,3019);i=a;return}function Syd(){var a=0;a=i;xrc(661056,3020);i=a;return}function Tyd(){var a=0;a=i;xrc(661104,3021);i=a;return}function Uyd(){var a=0;a=i;xrc(661144,3022);i=a;return}function Vyd(){var a=0;a=i;xrc(661192,3565);i=a;return}function Wyd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=Im,j=Im;c=i;i=i+16|0;d=c;if(!a){e=0;Orc(e)}f=Erc(a)|0;if(!f){e=a;Orc(e)}else{h=ea(g[b>>2]);j=ea(g[b+4>>2]);g[d>>2]=h;g[d+4>>2]=j;b=Ecd(dYb(f,d)|0)|0;i=c;return b|0}return 0}function Xyd(){var a=0;a=i;xrc(661240,2720);i=a;return}function Yyd(a){a=a|0;var b=0,d=0;b=i;d=xCi(68)|0;MLc(d);c[a+8>>2]=d;i=b;return}function Zyd(a){a=a|0;var b=0,d=0;b=i;if((a|0)!=0?(d=c[a+8>>2]|0,(d|0)!=0):0)ACi(d);i=b;return}function _yd(){var a=0;a=i;xrc(661288,3517);i=a;return}function $yd(){var a=0;a=i;xrc(661320,3518);i=a;return}function azd(a){a=a|0;var b=0;b=i;c[(rIc()|0)+64>>2]=a<<24>>24!=0&1;i=b;return}function bzd(){var a=0;a=i;xrc(661352,3519);i=a;return}function czd(a,b){a=a|0;b=b|0;var c=0;c=i;lJc(a,rIc()|0,b);i=c;return}function dzd(a,b){a=a|0;b=b|0;var c=0;c=i;kJc(rIc()|0,a,b);i=c;return}function ezd(){var a=0;a=i;xrc(661384,3023);i=a;return}function fzd(){var a=0;a=i;xrc(661440,3024);i=a;return}function gzd(a){a=a|0;var b=0,d=0;b=i;d=c[(ZIc(a)|0)+20>>2]|0;i=b;return d|0}function hzd(){return}function izd(){var a=0,b=0;a=i;b=c[(rIc()|0)+328>>2]|0;i=a;return b|0}function jzd(){var a=0;a=i;xrc(661504,3566);i=a;return}function kzd(){var a=0;a=i;xrc(661552,172);i=a;return}function lzd(){var a=0;a=i;xrc(661600,65);i=a;return}function mzd(a){a=a|0;var b=0,d=0;b=i;if((a|0)!=0?(d=c[a+8>>2]|0,(d|0)!=0):0)ACi(d);i=b;return}function nzd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){a=_8c(c[e>>2]|0,8388608)|0;i=b;return a|0}Mrc(791816,d);return 0}function ozd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im;d=i;i=i+16|0;e=d;if(!a)Mrc(791816,e);f=c[a+8>>2]|0;if(!f)Mrc(791816,e);else{h=ea(g[b>>2]);j=ea(g[b+4>>2]);k=ea(g[b+8>>2]);l=ea(g[b+12>>2]);g[f+4>>2]=h;g[f+8>>2]=j;g[f+12>>2]=k;g[f+16>>2]=l;i=d;return}}function pzd(a){a=a|0;var b=0,d=0;b=i;d=xCi(16)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[a+8>>2]=d;i=b;return}function qzd(a){a=a|0;var b=0,d=0;b=i;if((a|0)!=0?(d=c[a+8>>2]|0,(d|0)!=0):0)ACi(d);i=b;return}function rzd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return c[e>>2]|0}Mrc(791816,d);return 0}function szd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){c[f>>2]=b;i=d;return}Mrc(791816,e)}function tzd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return c[e+4>>2]|0}Mrc(791816,d);return 0}function uzd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){c[f+4>>2]=b;i=d;return}Mrc(791816,e)}function vzd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return c[e+8>>2]|0}Mrc(791816,d);return 0}function wzd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){c[f+8>>2]=b;i=d;return}Mrc(791816,e)}function xzd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return c[e+12>>2]|0}Mrc(791816,d);return 0}function yzd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){c[f+12>>2]=b;i=d;return}Mrc(791816,e)}function zzd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return (c[e+4>>2]|0)+(c[e>>2]|0)|0}Mrc(791816,d);return 0}function Azd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return (c[e+12>>2]|0)+(c[e+8>>2]|0)|0}Mrc(791816,d);return 0}function Bzd(a){a=a|0;var b=0,d=0;b=i;d=xCi(292)|0;MIc(d);c[a+8>>2]=d;i=b;return}function Czd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}g=c[b+8>>2]|0;if(!g){i=d;return}if(a[g>>0]&1){b=c[g+8>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(b,e)}ACi(g);i=d;return}function Dzd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;if(!b)Mrc(791816,e);f=c[b+8>>2]|0;if(!f)Mrc(791816,e);e=a[f>>0]|0;if(!(e&1)){g=f+1|0;h=(e&255)>>>1;j=Esc(g,h)|0;i=d;return j|0}else{g=c[f+8>>2]|0;h=c[f+4>>2]|0;j=Esc(g,h)|0;i=d;return j|0}return 0}function Ezd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+4|0;Stc(g,d);if(!b)Mrc(791816,f);d=c[b+8>>2]|0;if(!d)Mrc(791816,f);Utc(h,g);g=a[h>>0]|0;if(!(g&1)){j=(g&255)>>>1;k=h+1|0}else{j=c[h+4>>2]|0;k=c[h+8>>2]|0}g=a[d>>0]|0;if(!(g&1)){l=10;m=g}else{g=c[d>>2]|0;l=(g&-2)+-1|0;m=g&255}g=(m&1)==0;if(j>>>0>l>>>0){if(g)n=(m&255)>>>1;else n=c[d+4>>2]|0;eXb(d,l,j-l|0,n,0,n,j,k);xri(h);i=e;return}if(g)o=d+1|0;else o=c[d+8>>2]|0;aFi(o|0,k|0,j|0)|0;a[o+j>>0]=0;if(!(a[d>>0]&1)){a[d>>0]=j<<1;xri(h);i=e;return}else{c[d+4>>2]=j;xri(h);i=e;return}}function Fzd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){i=d;return f+12+(b*20|0)|0}Mrc(791816,e);return 0}function Gzd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){i=d;return f+172+(b<<4)|0}Mrc(791816,e);return 0}function Hzd(a){a=a|0;var b=0,d=0,e=0,f=Im;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){f=ea(g[e+272>>2]);i=b;return ea(f)}Mrc(791816,d);return ea(0.0)}function Izd(a){a=a|0;var b=0,d=0,e=0,f=Im;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){f=ea(g[e+276>>2]);i=b;return ea(f)}Mrc(791816,d);return ea(0.0)}function Jzd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((b|0)!=0?(f=c[b+8>>2]|0,(f|0)!=0):0){i=d;return a[f+288>>0]|0}Mrc(791816,e);return 0}function Kzd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=d<<24>>24!=0;if((b|0)!=0?(d=c[b+8>>2]|0,(d|0)!=0):0){a[d+288>>0]=g&1;i=e;return}Mrc(791816,f)}function Lzd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((b|0)!=0?(f=c[b+8>>2]|0,(f|0)!=0):0){i=d;return a[f+289>>0]|0}Mrc(791816,e);return 0}function Mzd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=d<<24>>24!=0;if((b|0)!=0?(d=c[b+8>>2]|0,(d|0)!=0):0){a[d+289>>0]=g&1;i=e;return}Mrc(791816,f)}function Nzd(a){a=a|0;var b=0,c=0;b=i;if(!a)c=0;else c=Erc(a)|0;OIc(c);i=b;return}function Ozd(){var a=0;a=i;xrc(661648,3520);i=a;return}function Pzd(){var a=0;a=i;xrc(661688,3567);i=a;return}function Qzd(){var a=0;a=i;xrc(661744,3025);i=a;return}function Rzd(){var a=0;a=i;xrc(661800,3521);i=a;return}function Szd(){var a=0;a=i;xrc(661832,3522);i=a;return}function Tzd(){var a=0;a=i;xrc(661864,3568);i=a;return}function Uzd(){var a=0;a=i;xrc(661904,3026);i=a;return}function Vzd(){var a=0;a=i;xrc(661944,3569);i=a;return}function Wzd(){var a=0;a=i;xrc(661984,3027);i=a;return}function Xzd(){var a=0;a=i;xrc(662024,3570);i=a;return}function Yzd(){var a=0;a=i;xrc(662056,3028);i=a;return}function Zzd(){var a=0;a=i;xrc(662088,3571);i=a;return}function _zd(){var a=0;a=i;xrc(662128,3029);i=a;return}function $zd(){var a=0;a=i;xrc(662168,3572);i=a;return}function aAd(){var a=0;a=i;xrc(662208,3573);i=a;return}function bAd(){var a=0;a=i;xrc(662248,3523);i=a;return}function cAd(){var a=0;a=i;xrc(662280,3524);i=a;return}function dAd(){var a=0;a=i;xrc(662312,3574);i=a;return}function eAd(){var a=0;a=i;xrc(662344,3030);i=a;return}function fAd(){var a=0;a=i;xrc(662376,2721);i=a;return}function gAd(){var a=0;a=i;xrc(662416,2722);i=a;return}function hAd(){var a=0;a=i;xrc(662456,213);i=a;return}function iAd(){var a=0;a=i;xrc(662496,214);i=a;return}function jAd(){var a=0;a=i;xrc(662536,3575);i=a;return}function kAd(){var a=0;a=i;xrc(662576,3031);i=a;return}function lAd(){var a=0;a=i;xrc(662616,3576);i=a;return}function mAd(){var a=0;a=i;xrc(662656,3032);i=a;return}function nAd(){var a=0;a=i;xrc(662696,3525);i=a;return}function oAd(a){a=a|0;var b=0,d=0,e=0;b=i;d=xCi(44)|0;e=d+4|0;c[d+40>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[a+8>>2]=d;UQc(d);i=b;return}function pAd(a){a=a|0;var b=0,d=0;b=i;if((a|0)!=0?(d=c[a+8>>2]|0,(d|0)!=0):0){TQc(d);ACi(d)}i=b;return}function qAd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=rIc()|0;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){a=tJc(e,f)|0;i=b;return a|0}Mrc(791816,d);return 0}function rAd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im;d=i;i=i+16|0;e=d;if(!a)Mrc(791816,e);f=c[a+8>>2]|0;if(!f)Mrc(791816,e);else{h=ea(g[f+4>>2]);j=ea(h);h=ea(g[f+8>>2]);k=ea(h);f=b;g[f>>2]=j;g[f+4>>2]=k;i=d;return}}function sAd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return c[e+24>>2]|0}Mrc(791816,d);return 0}function tAd(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){i=d;return b[f+36>>1]|0}Mrc(791816,e);return 0}function uAd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){a=c[e+40>>2]|0;e=ysc((a|0)==0?3653512:a)|0;i=b;return e|0}Mrc(791816,d);return 0}function vAd(a){a=a|0;var b=0,d=0,f=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(f=c[a+8>>2]|0,(f|0)!=0):0){i=b;return e[f+38>>1]|0|0}Mrc(791816,d);return 0}function wAd(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;BIc(rIc()|0,d);i=b;return}function xAd(){var a=0;a=i;xrc(662736,3526);i=a;return}function yAd(){var a=0;a=i;xrc(662760,3527);i=a;return}function zAd(){var a=0;a=i;xrc(662792,3577);i=a;return}function AAd(){var a=0;a=i;xrc(662824,3033);i=a;return}function BAd(){var a=0;a=i;xrc(662872,3578);i=a;return}function CAd(){var a=0;a=i;xrc(662912,3579);i=a;return}function DAd(){var a=0;a=i;xrc(662952,3580);i=a;return}function EAd(){var a=0;a=i;xrc(662992,3581);i=a;return}function FAd(){var a=0;a=i;xrc(663024,3528);i=a;return}function GAd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(-ea(g[b>>2]));d=ea(-ea(g[b+4>>2]));e=ea(-ea(g[b+8>>2]));f=ea(g[b+12>>2]);g[a>>2]=c;g[a+4>>2]=d;g[a+8>>2]=e;g[a+12>>2]=f;return}function HAd(a,b){a=a|0;b=b|0;var c=0;c=i;DMc(a,b);i=c;return}function IAd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+0|0;f=b+0|0;b=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(b|0));qMc(a,a)|0;i=d;return}function JAd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+0|0;f=b+0|0;b=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(b|0));sMc(a)|0;i=d;return}function KAd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(qMc(a,b)|0)&1;i=c;return d|0}function LAd(a){a=a|0;var b=0,c=0;b=i;c=(aMc(a,ea(g[150276]))|0)&1;i=b;return c|0}function MAd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;vMc(a,b,c,d);i=e;return}function NAd(a,b,c,d,e,f,g){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=ea(g);var h=0;h=i;oMc(a,b,c,d,e,f,g)|0;i=h;return}function OAd(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);var f=0;f=i;mMc(a,b,c,d,e)|0;i=f;return}function PAd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Tlc(a,b)|0)&1;i=c;return d|0}function QAd(a,b){a=a|0;b=b|0;var c=0,d=Im;c=i;d=ea(Qlc(b,a));i=c;return ea(d)}function RAd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=(imc(a,b,c)|0)&1;i=d;return e|0}function SAd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;i=i+16|0;g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0);Plc(c,b,a,d);i=d;return}function TAd(){var a=0;a=i;xrc(663072,3034);i=a;return}function UAd(){var a=0;a=i;xrc(663120,3035);i=a;return}function VAd(){var a=0;a=i;xrc(663184,3036);i=a;return}function WAd(){var a=0;a=i;xrc(663232,3037);i=a;return}function XAd(){var a=0;a=i;xrc(663280,2723);i=a;return}function YAd(){var a=0;a=i;xrc(663328,3582);i=a;return}function ZAd(){var a=0;a=i;xrc(663368,338);i=a;return}function _Ad(){var a=0;a=i;xrc(663416,1);i=a;return}function $Ad(){var a=0;a=i;xrc(663448,6);i=a;return}function aBd(){var a=0;a=i;xrc(663488,2724);i=a;return}function bBd(){var a=0;a=i;xrc(663544,47);i=a;return}function cBd(){var a=0;a=i;xrc(663600,1736);i=a;return}function dBd(){var a=0;a=i;xrc(663656,1822);i=a;return}function eBd(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+12|0;d=b;Stc(c,a);a=Xmd()|0;Vtc(d,c);c=Ecd(Nmd(a,d)|0)|0;xri(d);i=b;return c|0}function fBd(a){a=a|0;var b=0,c=0,d=0;b=i;if(a){c=Erc(a)|0;if(!c)d=a;else{a=(Nld(c)|0)&1;i=b;return a|0}}else d=0;Orc(d);return 0}function gBd(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;Stc(c,a);a=SQc(c)|0;i=b;return a|0}function hBd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!a){h=0;Orc(h)}j=Erc(a)|0;if(!j){h=a;Orc(h)}else{c[g>>2]=b;c[f+0>>2]=c[g+0>>2];lkd(j,f,d);i=e;return}}function iBd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!a){h=0;Orc(h)}j=Erc(a)|0;if(!j){h=a;Orc(h)}c[g>>2]=b;if(!d)k=0;else k=Erc(d)|0;c[f+0>>2]=c[g+0>>2];rkd(j,f,k);i=e;return}function jBd(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!a){h=0;Orc(h)}j=Erc(a)|0;if(!j){h=a;Orc(h)}else{c[g>>2]=b;c[f+0>>2]=c[g+0>>2];nkd(j,f,d);i=e;return}}function kBd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(b){d=Erc(b)|0;if(!d)e=b;else{Fcd(a,bkd(d,0,1)|0)|0;i=c;return}}else e=0;Orc(e)}function lBd(){var a=0;a=i;xrc(663720,3583);i=a;return}function mBd(){var a=0;a=i;xrc(663752,3584);i=a;return}function nBd(){var a=0;a=i;xrc(663792,3585);i=a;return}function oBd(){var a=0;a=i;xrc(663832,1823);i=a;return}function pBd(){var a=0;a=i;xrc(663880,1824);i=a;return}function qBd(){var a=0;a=i;xrc(663920,38);i=a;return}function rBd(){var a=0;a=i;xrc(663952,3038);i=a;return}function sBd(a){a=a|0;var b=0;b=i;MMc(a);i=b;return}function tBd(a,b){a=a|0;b=b|0;var c=0;c=i;QMc(b,a);i=c;return}function uBd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;RMc(c,a,b);i=d;return}function vBd(){var a=0;a=i;xrc(664e3,3529);i=a;return}function wBd(){var a=0;a=i;xrc(664072,3039);i=a;return}function xBd(){var a=0;a=i;xrc(664160,1825);i=a;return}function yBd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){IOc(e);i=b;return}Mrc(791816,d)}function zBd(){var a=0;a=i;xrc(664248,3530);i=a;return}function ABd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(a){e=Erc(a)|0;if(!e)f=a;else{In[c[(c[e>>2]|0)+120>>2]&4095](e,b<<24>>24!=0);i=d;return}}else f=0;Orc(f)}function BBd(){var a=0;a=i;xrc(664296,3040);i=a;return}function CBd(a){a=a|0;var b=0,c=0,d=0,e=Im;b=i;if(a){c=Erc(a)|0;if(!c)d=a;else{e=ea(g[c+456>>2]);i=b;return ea(e)}}else d=0;Orc(d);return ea(0.0)}function DBd(a){a=a|0;var b=0,c=0,d=0,e=Im;b=i;if(a){c=Erc(a)|0;if(!c)d=a;else{e=ea(g[c+460>>2]);i=b;return ea(e)}}else d=0;Orc(d);return ea(0.0)}function EBd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return c[d+412>>2]|0}}else e=0;Orc(e);return 0}function FBd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{G0b(d,b);i=c;return}}else e=0;Orc(e)}function GBd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return c[d+416>>2]|0}}else e=0;Orc(e);return 0}function HBd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!a){f=0;Orc(f)}g=Erc(a)|0;if(!g){f=a;Orc(f)}else{u$b(e,g,1);c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=d;return}}function IBd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;if(!a){f=0;Orc(f)}g=Erc(a)|0;if(!g){f=a;Orc(f)}f=g+292|0;g=c[f>>2]|0;if(!g){h=0;j=Ecd(h)|0;i=b;return j|0}c[e>>2]=g;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);a=c[d>>2]|0;k=c[g+28>>2]|0;if((a|0)==-1){l=k+(c[g+32>>2]<<3)|0;break}else{l=k+(a<<3)|0;break}}else l=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((l|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[l+4>>2]|0,(g|0)!=0):0)m=g;else n=13}else n=13;if((n|0)==13)m=hQb(c[f>>2]|0)|0;h=m;j=Ecd(h)|0;i=b;return j|0}function JBd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;if(a){e=Erc(a)|0;if(!e)f=a;else{v$b(d,e);i=b;return c[d+8>>2]|0}}else f=0;Orc(f);return 0}function KBd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;if(a){e=Erc(a)|0;if(!e)f=a;else{v$b(d,e);i=b;return c[d+12>>2]|0}}else f=0;Orc(f);return 0}function LBd(b){b=b|0;var c=0,d=0,e=0;c=i;if(!b){d=0;Orc(d)}e=Erc(b)|0;if(!e){d=b;Orc(d)}else{a[e+613>>0]=1;a[e+609>>0]=1;a[e+610>>0]=1;a[e+614>>0]=1;a[e+611>>0]=1;i=c;return}}function MBd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return c[d+376>>2]|0}}else e=0;Orc(e);return 0}function NBd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=Im,k=Im;d=i;i=i+16|0;e=d;if(!b){f=0;Orc(f)}h=Erc(b)|0;if(!h){f=b;Orc(f)}else{j=ea(g[c>>2]);k=ea(g[c+4>>2]);g[e>>2]=j;g[e+4>>2]=k;o0b(a,h,e);i=d;return}}function OBd(){var a=0,b=0;a=i;b=Ecd(iQc()|0)|0;i=a;return b|0}function PBd(){var a=0,b=0,d=0;a=i;b=c[(n8b()|0)+24>>2]|0;d=(c[(n8b()|0)+12>>2]|0)+b|0;i=a;return d|0}function QBd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;Prc(a);d=yrc(a)|0;e=c[(n8b()|0)+24>>2]|0;if((d|0)<((c[(n8b()|0)+12>>2]|0)+e|0))Nrc(664336,b);else{e=iCd(a,(n8b()|0)+4|0,0)|0;d=(iCd(a,(n8b()|0)+16|0,e)|0)+e|0;i=b;return d|0}return 0}function RBd(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0;e=i;i=i+80|0;f=e+48|0;h=e;j=zLc()|0;if((j|0)==0|d<ea(1.1920929e-07)){k=0;i=e;return k|0}l=ea(g[b+12>>2]);m=ea(l*l);n=ea(g[b+16>>2]);o=ea(m+ea(n*n));m=ea(g[b+20>>2]);p=ea(T(ea(o+ea(m*m))));if(p<=ea(g[150276])){k=0;i=e;return k|0}o=ea(l/p);l=ea(n/p);n=ea(m/p);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];g[f+12>>2]=o;g[f+16>>2]=l;g[f+20>>2]=n;g[h+32>>2]=ea(0.0);g[h+36>>2]=ea(0.0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;b=c[(c[j>>2]|0)+12>>2]|0;if(!a){q=0;Orc(q)}r=Erc(a)|0;if(!r){q=a;Orc(q)}q=c[r+412>>2]|0;r=Erc(a)|0;if(!r)Orc(a);if(!(ln[b&1](j,f,d,q&-3&c[r+416>>2],h)|0)){k=0;i=e;return k|0}r=_n[c[(c[j>>2]|0)+20>>2]&4095](j,h)|0;if(!r){k=0;i=e;return k|0}k=Ecd(r)|0;i=e;return k|0}function SBd(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=0;e=i;i=i+64|0;f=e+40|0;h=e;j=sLc()|0;if((j|0)==0|d<ea(1.1920929e-07)){k=0;i=e;return k|0}l=ea(g[b+12>>2]);m=ea(l*l);n=ea(g[b+16>>2]);o=ea(m+ea(n*n));m=ea(g[b+20>>2]);p=ea(T(ea(o+ea(m*m))));if(p<=ea(g[150276])){k=0;i=e;return k|0}o=ea(l/p);l=ea(n/p);n=ea(m/p);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];g[f+12>>2]=o;g[f+16>>2]=l;g[f+20>>2]=n;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;b=c[(c[j>>2]|0)+20>>2]|0;if(!a){q=0;Orc(q)}r=Erc(a)|0;if(!r){q=a;Orc(q)}q=c[r+412>>2]|0;r=Erc(a)|0;if(!r)Orc(a);if(!(ln[b&1](j,f,d,q&-3&c[r+416>>2],h)|0)){k=0;i=e;return k|0}r=_n[c[(c[j>>2]|0)+24>>2]&4095](j,h)|0;if(!r){k=0;i=e;return k|0}k=Ecd(r)|0;i=e;return k|0}function TBd(){var a=0;a=i;xrc(664472,215);i=a;return}function UBd(){var a=0;a=i;xrc(664512,216);i=a;return}function VBd(){var a=0;a=i;xrc(664552,3586);i=a;return}function WBd(){var a=0;a=i;xrc(664592,3041);i=a;return}function XBd(){var a=0;a=i;xrc(664632,3587);i=a;return}function YBd(){var a=0;a=i;xrc(664672,3042);i=a;return}function ZBd(){var a=0;a=i;xrc(664720,3588);i=a;return}function _Bd(){var a=0;a=i;xrc(664760,3589);i=a;return}function $Bd(){var a=0;a=i;xrc(664800,3590);i=a;return}function aCd(){var a=0;a=i;xrc(664840,3531);i=a;return}function bCd(){var a=0;a=i;xrc(664896,3591);i=a;return}function cCd(){var a=0;a=i;xrc(664936,1826);i=a;return}function dCd(){var a=0;a=i;xrc(664992,66);i=a;return}function eCd(){var a=0;a=i;xrc(665024,67);i=a;return}function fCd(){var a=0;a=i;xrc(665064,3592);i=a;return}function gCd(){var a=0;a=i;xrc(665104,4);i=a;return}function hCd(){var a=0;a=i;xrc(665152,5);i=a;return}function iCd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[b+8>>2]|0;j=yrc(a)|0;k=c[b+4>>2]|0;if((k|0)==(b|0))l=d;else{m=k;k=d;while(1){d=m+8|0;n=c[d>>2]|0;if(!n)o=0;else{c[g>>2]=n;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(f,n,g);p=c[f>>2]|0;q=c[n+28>>2]|0;if((p|0)==-1){r=q+(c[n+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((r|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[r+4>>2]|0,(n|0)!=0):0)s=n;else t=13}else t=13;if((t|0)==13){t=0;s=hQb(c[d>>2]|0)|0}o=s}Qrc(a,k,Ecd(o)|0);n=k+1|0;m=c[m+4>>2]|0;if((m|0)==(b|0)){l=n;break}else k=n}}if((l|0)<(j|0))u=l;else{i=e;return h|0}do{c[(Gsc(a,u,4)|0)>>2]=0;u=u+1|0}while((u|0)!=(j|0));i=e;return h|0}function jCd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f;Stc(g,d);Utc(h,g);if(!(a[h>>0]&1))j=h+1|0;else j=c[h+8>>2]|0;if(!b)k=17408;else k=(b|0)==1?16896:16640;Krd(j,0,665200,62,k,Grc(e)|0,0,0);xri(h);i=f;return}function kCd(){var a=0;a=i;xrc(665296,1827);i=a;return}function lCd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=ECc()|0;c[b>>2]=mo[c[(c[e>>2]|0)+80>>2]&4095](e)|0;e=ECc()|0;c[d>>2]=mo[c[(c[e>>2]|0)+84>>2]&4095](e)|0;i=a;return}function mCd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=ECc()|0;c[b>>2]=mo[c[(c[e>>2]|0)+80>>2]&4095](e)|0;e=ECc()|0;c[d>>2]=mo[c[(c[e>>2]|0)+84>>2]&4095](e)|0;i=a;return}function nCd(a,b,d){a=a|0;b=b|0;d=d|0;c[d+4>>2]=0;c[b+4>>2]=0;return}function oCd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;e=ECc()|0;f=c[(c[e>>2]|0)+8>>2]|0;g=ECc()|0;h=mo[c[(c[g>>2]|0)+92>>2]&4095](g)|0;En[f&127](e,b,d,h,0);i=a;return}function pCd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function qCd(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function rCd(){return 0}function sCd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function tCd(){var a=0;a=i;xrc(665328,1828);i=a;return}function uCd(){var a=0;a=i;xrc(665368,1829);i=a;return}function vCd(){var a=0;a=i;xrc(665416,1830);i=a;return}function wCd(){var a=0;a=i;xrc(665464,1831);i=a;return}function xCd(){var a=0;a=i;xrc(665512,339);i=a;return}function yCd(){var a=0;a=i;xrc(665560,100);i=a;return}function zCd(){var a=0;a=i;xrc(665600,68);i=a;return}function ACd(){var a=0;a=i;xrc(665648,250);i=a;return}function BCd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;if(a>>>0<7){d=fKc()|0;e=a+323|0;a=e>>>5;i=b;return ((c[(c[d+40>>2]|0)+(a<<2)>>2]|c[(c[d+56>>2]|0)+(a<<2)>>2])&1<<(e&31)|0)!=0|0}else Nrc(665696,b);return 0}function CCd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;if(a>>>0<7){d=a+323|0;a=(c[(c[(fKc()|0)+56>>2]|0)+(d>>>5<<2)>>2]&1<<(d&31)|0)!=0&1;i=b;return a|0}else Nrc(665696,b);return 0}function DCd(a){a=a|0;var b=0,c=0,d=Im,e=Im;b=i;c=fKc()|0;d=ea(g[c+100>>2]);e=ea(g[c+104>>2]);g[a>>2]=d;g[a+4>>2]=e;g[a+8>>2]=ea(0.0);i=b;return}function ECd(){var a=0;a=i;xrc(665728,3593);i=a;return}function FCd(){var a=0;a=i;xrc(665768,3594);i=a;return}function GCd(){var a=0;a=i;xrc(665808,3532);i=a;return}function HCd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!a)f=0;else f=Grc(a)|0;c[e>>2]=f;Lcd(e,b);i=d;return}function ICd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(!a)d=0;else d=Erc(a)|0;Kcd(d,b<<24>>24!=0);i=c;return}function JCd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{a=ysc(mo[c[(c[d>>2]|0)+32>>2]&4095](d)|0)|0;i=b;return a|0}}else e=0;Orc(e);return 0}function KCd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(a){e=Erc(a)|0;if(!e)f=a;else{In[c[(c[e>>2]|0)+44>>2]&4095](e,b);i=d;return}}else f=0;Orc(f)}function LCd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;if(!b)f=0;else f=Erc(b)|0;mQc(e,f);f=a[e>>0]|0;if(!(f&1)){g=e+1|0;h=(f&255)>>>1}else{g=c[e+8>>2]|0;h=c[e+4>>2]|0}f=Esc(g,h)|0;xri(e);i=d;return f|0}function MCd(){var a=0;a=i;xrc(665848,182);i=a;return}function NCd(){var a=0;a=i;xrc(665880,3043);i=a;return}function OCd(){var a=0;a=i;xrc(665920,3595);i=a;return}function PCd(){var a=0;a=i;xrc(665952,3044);i=a;return}function QCd(){var a=0;a=i;xrc(665992,3596);i=a;return}function RCd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;if(!a){d=0;Orc(d)}e=Erc(a)|0;if(!e){d=a;Orc(d)}d=c[e+24>>2]|0;if(!d)Lrc(666024,b);e=c[(c[d+24>>2]|0)+4>>2]|0;d=c[e+20>>2]|0;if(d){f=d;i=b;return f|0}f=Ecd(e)|0;i=b;return f|0}function SCd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{a=Ecd(c[d+24>>2]|0)|0;i=b;return a|0}}else e=0;Orc(e);return 0}function TCd(){var a=0;a=i;xrc(666080,3597);i=a;return}function UCd(){var a=0;a=i;xrc(666120,3598);i=a;return}function VCd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;if(!d){h=0;Orc(h)}j=Erc(d)|0;if(!j){h=d;Orc(h)}else{c[g>>2]=j;c[g+8>>2]=0;a[g+12>>0]=0;a[g+13>>0]=1;a[g+14>>0]=1;c[g+16>>2]=0;j=g+20|0;b[j+0>>1]=257;a[j+2>>0]=1;c[g+4>>2]=e;e=Abd(g)|0;i=f;return e|0}return 0}function WCd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+12|0;g=e;Stc(f,b);if(!a){h=0;Orc(h)}b=Erc(a)|0;if(!b){h=a;Orc(h)}else{Vtc(g,f);Jcd(b,g,c,d)|0;xri(g);i=e;return}}function XCd(){var a=0;a=i;xrc(666160,2725);i=a;return}function YCd(){var a=0;a=i;xrc(666200,340);i=a;return}function ZCd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!a){f=0;Orc(f)}g=Erc(a)|0;if(!g){f=a;Orc(f)}else{oGc(e,g);c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=d;return}}function _Cd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{xGc(d,b);i=c;return}}else e=0;Orc(e)}function $Cd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{aFi(b|0,d+28|0,16)|0;i=c;return}}else e=0;Orc(e)}function aDd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(a){d=Erc(a)|0;if(!d)e=a;else{vGc(d,b);i=c;return}}else e=0;Orc(e)}function bDd(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return c[d+148>>2]|0}}else e=0;Orc(e);return 0}function cDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!a){f=0;Orc(f)}g=Erc(a)|0;if(!g){f=a;Orc(f)}if((b|0)<=-1)Lrc(666240,e);if((c[g+148>>2]|0)>(b|0)){f=Ecd(c[(c[g+140>>2]|0)+(b<<2)>>2]|0)|0;i=d;return f|0}else Lrc(666240,e);return 0}function dDd(){var a=0;a=i;xrc(666272,3045);i=a;return}function eDd(){var a=0;a=i;xrc(666320,3046);i=a;return}function fDd(){var a=0;a=i;xrc(666368,3047);i=a;return}function gDd(){var a=0;a=i;xrc(666424,3048);i=a;return}function hDd(){var a=0;a=i;xrc(666480,3599);i=a;return}function iDd(){var a=0;a=i;xrc(666520,2726);i=a;return}function jDd(){g[166638]=ea(4.0);g[166639]=ea(4.0);g[166640]=ea(4.0);g[166641]=ea(4.0);g[166642]=ea(.03125);g[166643]=ea(.03125);g[166644]=ea(.03125);g[166645]=ea(.03125);g[166646]=ea(-31.5);g[166647]=ea(-31.5);g[166648]=ea(-31.5);g[166649]=ea(-31.5);g[166650]=ea(16.0);g[166651]=ea(16.0);g[166652]=ea(16.0);g[166653]=ea(16.0);g[166654]=ea(-.5);g[166655]=ea(-.5);g[166656]=ea(-.5);g[166657]=ea(-.5);g[166658]=ea(1.1920929e-07);g[166659]=ea(1.1920929e-07);g[166660]=ea(1.1920929e-07);g[166661]=ea(1.1920929e-07);g[166662]=ea(0.0);g[166663]=ea(1.0);g[166664]=ea(2.0);g[166665]=ea(3.0);g[166666]=ea(.0000152590219);g[166667]=ea(.0000152590219);g[166668]=ea(.0000152590219);g[166669]=ea(.0000152590219);c[166670]=65535;c[166671]=65535;c[166672]=65535;c[166673]=65535;g[166674]=ea(.0000152590219);g[166675]=ea(.0000152590219);g[166676]=ea(.0000152590219);g[166677]=ea(.0000152590219);return}function kDd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+56|0;j=d-b|0;d=j>>4;k=a+64|0;c[k>>2]=d;l=a+68|0;m=c[l>>2]|0;do if((m&2147483647)>>>0<d>>>0)if((m|0)>-1){c[l>>2]=d;n=c[h>>2]|0;c[g>>2]=c[a+60>>2];c[f+0>>2]=c[g+0>>2];o=hOb(n,j,4,f,0,3653512,370)|0;c[h>>2]=o;p=o;break}else{c[g>>2]=c[a+60>>2];c[f+0>>2]=c[g+0>>2];o=cOb(j,4,f,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,c[k>>2]<<4|0)|0;c[l>>2]=d;c[h>>2]=o;p=o;break}else p=c[h>>2]|0;while(0);YEi(p|0,b|0,c[k>>2]<<4|0)|0;SMc(a);i=e;return}function lDd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[166678]=0;c[166680]=60;c[166682]=32;c[d>>2]=60;c[b+0>>2]=c[d+0>>2];c[166678]=hOb(0,128,4,b,0,3653512,370)|0;i=a;return}function mDd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;if(!d){i=e;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(d<<1,16,f,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;a=g+(d<<1)|0;c[j>>2]=a;j=d;d=g;while(1){if(d)b[d>>1]=0;j=j+-1|0;if(!j)break;else d=d+2|0}c[h>>2]=a;i=e;return}function nDd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a>>2]|0)==(b|0))c[a>>2]=0;e=a+4|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+8|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+12|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+16|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+20|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+24|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+28|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+32|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+36|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+40|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+44|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+48|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+52|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+56|0;if((c[e>>2]|0)==(b|0))c[e>>2]=0;e=a+60|0;if((c[e>>2]|0)!=(b|0)){i=d;return}c[e>>2]=0;i=d;return}function oDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(f-k>>2>>>0>=b>>>0){l=b;m=j;while(1){if(m)g[m>>2]=ea(0.0);l=l+-1|0;if(!l)break;else m=m+4|0}c[h>>2]=j+(b<<2);i=d;return}j=c[a>>2]|0;m=(k-j>>2)+b|0;if(m>>>0>1073741823)vxi(a);k=j;l=f-k|0;if(l>>2>>>0<536870911){f=l>>1;l=f>>>0<m>>>0?m:f;f=(c[h>>2]|0)-k|0;m=f>>2;if(!l){n=0;o=0;p=m;q=f}else{r=l;s=m;t=f;u=11}}else{f=(c[h>>2]|0)-k|0;r=1073741823;s=f>>2;t=f;u=11}if((u|0)==11){n=r;o=xCi(r<<2)|0;p=s;q=t}t=b;s=o+(p<<2)|0;while(1){if(s)g[s>>2]=ea(0.0);t=t+-1|0;if(!t)break;else s=s+4|0}YEi(o|0,j|0,q|0)|0;q=c[a>>2]|0;c[a>>2]=o;c[h>>2]=o+(p+b<<2);c[e>>2]=o+(n<<2);if(!q){i=d;return}ACi(q);i=d;return}function pDd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+32|0;if((c[e>>2]|0)!=0?(qDd(a,a+68|0),(c[e>>2]|0)!=0):0)In[c[(c[a>>2]|0)+160>>2]&4095](a,-2147483645);qEd(a,b);i=d;return}function qDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;d=i;i=i+32|0;e=d+16|0;f=d;h=a+68|0;j=ea(g[b>>2]);if(!((!(j!=ea(g[h>>2]))?(j=ea(g[b+4>>2]),!(j!=ea(g[a+72>>2]))):0)?(j=ea(g[b+8>>2]),!(j!=ea(g[a+76>>2]))):0)){c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2]}b=a+32|0;h=c[b>>2]|0;if(!h){i=d;return}c[f>>2]=3;k=f+4|0;g[k>>2]=ea(0.0);l=f+8|0;g[l>>2]=ea(0.0);m=f+12|0;g[m>>2]=ea(0.0);_n[c[(c[h>>2]|0)+36>>2]&4095](h,f)|0;qGc(e,BTb(c[a+24>>2]|0)|0);j=ea(g[e>>2]);n=ea(j*ea(g[150288]));j=ea(g[e+4>>2]);o=ea(j*ea(g[150289]));j=ea(g[e+8>>2]);p=ea(j*ea(g[150290]));j=ea(n*ea(g[a+68>>2]));n=ea(o*ea(g[a+72>>2]));o=ea(j*ea(.5));j=ea(n*ea(.5));n=ea(ea(p*ea(g[a+76>>2]))*ea(.5));if(o<ea(0.0))q=ea(-o);else q=o;if(j<ea(0.0))r=ea(-j);else r=j;if(n<ea(0.0))s=ea(-n);else s=n;e=q>ea(1.1920929e-07);n=e?q:ea(1.1920929e-07);e=r>ea(1.1920929e-07);q=e?r:ea(1.1920929e-07);e=s>ea(1.1920929e-07);r=e?s:ea(1.1920929e-07);g[k>>2]=n;g[l>>2]=q;g[m>>2]=r;m=c[b>>2]|0;In[c[(c[m>>2]|0)+28>>2]&4095](m,f);sEd(a);i=d;return}function rDd(a){a=a|0;var b=0,d=0,e=0,f=0,h=Im,j=Im,k=Im;b=i;i=i+48|0;d=b+16|0;e=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;f=c[a+24>>2]|0;if((f|0)!=0?_lc(f,d)|0:0){h=ea(ea(g[d+12>>2])*ea(2.0));j=ea(ea(g[d+16>>2])*ea(2.0));k=ea(ea(g[d+20>>2])*ea(2.0));g[e>>2]=h;g[e+4>>2]=j;g[e+8>>2]=k;qDd(a,e);e=a+56|0;k=ea(g[d>>2]);if(!((!(k!=ea(g[e>>2]))?(k=ea(g[d+4>>2]),!(k!=ea(g[a+60>>2]))):0)?(k=ea(g[d+8>>2]),!(k!=ea(g[a+64>>2]))):0)){c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2]}if(!(c[a+32>>2]|0)){i=b;return}In[c[(c[a>>2]|0)+160>>2]&4095](a,-2147483645);i=b;return}qDd(a,601152);d=a+56|0;k=ea(g[150284]);if(!((!(k!=ea(g[d>>2]))?(k=ea(g[150285]),!(k!=ea(g[a+60>>2]))):0)?(k=ea(g[150286]),!(k!=ea(g[a+64>>2]))):0)){c[d+0>>2]=c[150284];c[d+4>>2]=c[150285];c[d+8>>2]=c[150286]}if(!(c[a+32>>2]|0)){i=b;return}In[c[(c[a>>2]|0)+160>>2]&4095](a,-2147483645);i=b;return}function sDd(a){a=a|0;var b=0;b=a+56|0;c[b+0>>2]=c[150284];c[b+4>>2]=c[150285];c[b+8>>2]=c[150286];b=a+68|0;c[b+0>>2]=c[150288];c[b+4>>2]=c[150289];c[b+8>>2]=c[150290];return}function tDd(a,b){a=a|0;b=b|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=0,o=Im,p=Im,q=0;e=i;i=i+32|0;f=e;h=e+16|0;if(c[a+32>>2]|0)ko[c[(c[a>>2]|0)+144>>2]&4095](a);j=a+24|0;qGc(f,BTb(c[j>>2]|0)|0);k=ea(g[f>>2]);l=ea(k*ea(g[150288]));k=ea(ea(l*ea(g[a+68>>2]))*ea(.5));if(k<ea(0.0))m=ea(-k);else m=k;n=m>ea(1.1920929e-07);k=n?m:ea(1.1920929e-07);qGc(f,BTb(c[j>>2]|0)|0);m=ea(g[f+4>>2]);l=ea(m*ea(g[150289]));m=ea(ea(l*ea(g[a+72>>2]))*ea(.5));if(m<ea(0.0))o=ea(-m);else o=m;n=o>ea(1.1920929e-07);m=n?o:ea(1.1920929e-07);qGc(f,BTb(c[j>>2]|0)|0);o=ea(g[f+8>>2]);l=ea(o*ea(g[150290]));o=ea(ea(l*ea(g[a+76>>2]))*ea(.5));if(o<ea(0.0))p=ea(-o);else p=o;n=p>ea(1.1920929e-07);o=n?p:ea(1.1920929e-07);c[h>>2]=3;g[h+4>>2]=k;g[h+8>>2]=m;g[h+12>>2]=o;n=d[a+36>>0]|0;q=c[j>>2]|0;j=mo[c[(c[q>>2]|0)+32>>2]&4095](q)|0;c[f>>2]=n;c[f+4>>2]=j;Ird(666912,f);BEd(a,h,b);i=e;return}function uDd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;b=i;i=i+32|0;d=b+16|0;e=b;c[e>>2]=3;f=e+4|0;g[f>>2]=ea(0.0);h=e+8|0;g[h>>2]=ea(0.0);j=e+12|0;g[j>>2]=ea(0.0);k=a+32|0;l=c[k>>2]|0;_n[c[(c[l>>2]|0)+36>>2]&4095](l,e)|0;qGc(d,BTb(c[a+24>>2]|0)|0);m=ea(g[d>>2]);n=ea(m*ea(g[150288]));m=ea(g[d+4>>2]);o=ea(m*ea(g[150289]));m=ea(g[d+8>>2]);p=ea(m*ea(g[150290]));m=ea(n*ea(g[a+68>>2]));n=ea(o*ea(g[a+72>>2]));o=ea(m*ea(.5));m=ea(n*ea(.5));n=ea(ea(p*ea(g[a+76>>2]))*ea(.5));if(o<ea(0.0))q=ea(-o);else q=o;if(m<ea(0.0))r=ea(-m);else r=m;if(n<ea(0.0))s=ea(-n);else s=n;a=q>ea(1.1920929e-07);n=a?q:ea(1.1920929e-07);a=r>ea(1.1920929e-07);q=a?r:ea(1.1920929e-07);a=s>ea(1.1920929e-07);r=a?s:ea(1.1920929e-07);g[f>>2]=n;g[h>>2]=q;g[j>>2]=r;j=c[k>>2]|0;In[c[(c[j>>2]|0)+28>>2]&4095](j,e);i=b;return}function vDd(a){a=a|0;var b=0;b=i;wEd(a,a+56|0);i=b;return}function wDd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;vEd(b,a+56|0,c);i=d;return}function xDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+64|0;e=d;IEd(a,b);f=a+32|0;g=c[f>>2]|0;if(!g){i=d;return}if(!(b&8))h=g;else{ko[c[(c[a>>2]|0)+140>>2]&4095](a);h=c[f>>2]|0}g=mo[c[(c[h>>2]|0)+64>>2]&4095](h)|0;h=c[g+8>>2]|0;if(!h){wEd(a,a+56|0);i=d;return}j=h+24|0;if(tEd(a,BTb(c[j>>2]|0)|0,e)|0)iEd(c[f>>2]|0,g,e);if((b&-2147483640|0)==0?(c[j>>2]|0)==(c[a+24>>2]|0):0){i=d;return}sEd(a);i=d;return}function yDd(){var a=0;a=i;QQb(65,173,0,0,0);i=a;return}function zDd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(56)|0))MEd();rri(b,666944,11);wQb(65,56,b,80,2727,0,1);xri(b);i=a;return}function ADd(a){a=a|0;return 65}function BDd(a,b){a=a|0;b=b|0;var c=0;c=i;IDd(b,a,792072,0);i=c;return}function CDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,666944,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else JDd(a,b);sdd(b);i=d;return}function DDd(a,b){a=a|0;b=b|0;var c=0;c=i;KDd(a,b);i=c;return}function EDd(a,b){a=a|0;b=b|0;var c=0;c=i;LDd(a,b);i=c;return}function FDd(a,b){a=a|0;b=b|0;var c=0;c=i;MDd(a,b);i=c;return}function GDd(a,b){a=a|0;b=b|0;var c=0;c=i;ZEd(a,b);i=c;return}function HDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(80,e,1,16,3653512,10)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];jEd(g,e,b);c[g>>2]=666744;b=g+56|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return g|0}function IDd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;add(a,d,666944,b,e);UEd(b,a);ddd(a,2);fdd(a);e=b+68|0;d=c[142310]|0;add(a,2462848,d,e,2048);g=a+16|0;h=c[($hd(g)|0)+20>>2]|2097152;j=a+12|0;k=a+20|0;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=h;h=c[142268]|0;add(a,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,3143224,h,b+72|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,2416480,h,b+76|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);e=b+56|0;add(a,2490904,d,e,0);d=c[($hd(g)|0)+20>>2]|2097152;c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]=d;add(a,3143216,h,e,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,3143224,h,b+60|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);add(a,2416480,h,b+64|0,0);c[(c[c[j>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(a);bdd(a);bdd(a);i=f;return}function JDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;VEd(a,b);rdd(b,2);h=vdd(b)|0;j=a+68|0;k=c[142310]|0;if(h){h=qdd(b,2462848,k,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](j,b)|0}else _6b(j,b);sdd(b)}}else{h=qdd(b,2427888,k,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](j,b)|0}else _6b(j,b);sdd(b)}g[j>>2]=ea(ea(g[j>>2])*ea(2.0));j=a+72|0;g[j>>2]=ea(ea(g[j>>2])*ea(2.0));j=a+76|0;g[j>>2]=ea(ea(g[j>>2])*ea(2.0))}j=a+56|0;a=qdd(b,2490904,k,f,1)|0;if(!a){i=d;return}if((a|0)<=0){a=c[f>>2]|0;if(a)_n[a&4095](j,b)|0}else _6b(j,b);sdd(b);i=d;return}function KDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;WEd(a,b);Ndd(b);e=a+68|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;k=b+20|0;b=c[k>>2]|0;if(j>>>0>b>>>0){Bid(f,e,4);l=c[f>>2]|0;m=c[k>>2]|0}else{g[e>>2]=ea(g[h>>2]);c[f>>2]=j;l=j;m=b}b=a+72|0;j=l+4|0;if(j>>>0>m>>>0){Bid(f,b,4);n=c[f>>2]|0;o=c[k>>2]|0}else{g[b>>2]=ea(g[l>>2]);c[f>>2]=j;n=j;o=m}m=a+76|0;j=n+4|0;if(j>>>0>o>>>0){Bid(f,m,4);p=c[f>>2]|0;q=c[k>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[f>>2]=j;p=j;q=o}o=a+56|0;j=p+4|0;if(j>>>0>q>>>0){Bid(f,o,4);r=c[f>>2]|0;s=c[k>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[f>>2]=j;r=j;s=q}q=a+60|0;j=r+4|0;if(j>>>0>s>>>0){Bid(f,q,4);t=c[f>>2]|0;u=c[k>>2]|0}else{g[q>>2]=ea(g[r>>2]);c[f>>2]=j;t=j;u=s}s=a+64|0;a=t+4|0;if(a>>>0>u>>>0){Bid(f,s,4);i=d;return}else{g[s>>2]=ea(g[t>>2]);c[f>>2]=a;i=d;return}}function LDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;XEd(a,b);Mdd(b);e=a+68|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;l=b+20|0;b=c[l>>2]|0;if(j>>>0>b>>>0){Bid(f,e,4);m=e;n=c[f>>2]|0;o=c[l>>2]|0;p=c[e>>2]|0}else{q=ea(g[h>>2]);g[e>>2]=q;c[f>>2]=j;m=e;n=j;o=b;p=(g[k>>2]=q,c[k>>2]|0)}c[m>>2]=XEi(p|0)|0;p=a+72|0;m=n+4|0;if(m>>>0>o>>>0){Bid(f,p,4);r=p;s=c[p>>2]|0;t=c[f>>2]|0;u=c[l>>2]|0}else{q=ea(g[n>>2]);g[p>>2]=q;c[f>>2]=m;r=p;s=(g[k>>2]=q,c[k>>2]|0);t=m;u=o}c[r>>2]=XEi(s|0)|0;s=a+76|0;r=t+4|0;if(r>>>0>u>>>0){Bid(f,s,4);v=s;w=c[s>>2]|0;x=c[f>>2]|0;y=c[l>>2]|0}else{q=ea(g[t>>2]);g[s>>2]=q;c[f>>2]=r;v=s;w=(g[k>>2]=q,c[k>>2]|0);x=r;y=u}c[v>>2]=XEi(w|0)|0;w=a+56|0;v=x+4|0;if(v>>>0>y>>>0){Bid(f,w,4);z=w;A=c[w>>2]|0;B=c[f>>2]|0;C=c[l>>2]|0}else{q=ea(g[x>>2]);g[w>>2]=q;c[f>>2]=v;z=w;A=(g[k>>2]=q,c[k>>2]|0);B=v;C=y}c[z>>2]=XEi(A|0)|0;A=a+60|0;z=B+4|0;if(z>>>0>C>>>0){Bid(f,A,4);D=A;E=c[A>>2]|0;F=c[f>>2]|0;G=c[l>>2]|0}else{q=ea(g[B>>2]);g[A>>2]=q;c[f>>2]=z;D=A;E=(g[k>>2]=q,c[k>>2]|0);F=z;G=C}c[D>>2]=XEi(E|0)|0;E=a+64|0;a=F+4|0;if(a>>>0>G>>>0){Bid(f,E,4);H=E;I=c[E>>2]|0;J=XEi(I|0)|0;c[H>>2]=J;i=d;return}else{q=ea(g[F>>2]);g[E>>2]=q;c[f>>2]=a;H=E;I=(g[k>>2]=q,c[k>>2]|0);J=XEi(I|0)|0;c[H>>2]=J;i=d;return}}function MDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;YEd(a,b);Tdd(b);e=a+68|0;f=b+12|0;h=c[f>>2]|0;j=h+4|0;k=b+20|0;b=c[k>>2]|0;if(j>>>0<b>>>0){g[h>>2]=ea(g[e>>2]);c[f>>2]=j;l=j;m=b}else{Gid(f,e,4);l=c[f>>2]|0;m=c[k>>2]|0}e=a+72|0;b=l+4|0;if(b>>>0<m>>>0){g[l>>2]=ea(g[e>>2]);c[f>>2]=b;n=b;o=m}else{Gid(f,e,4);n=c[f>>2]|0;o=c[k>>2]|0}e=a+76|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[e>>2]);c[f>>2]=m;p=m;q=o}else{Gid(f,e,4);p=c[f>>2]|0;q=c[k>>2]|0}e=a+56|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[e>>2]);c[f>>2]=o;r=o;s=q}else{Gid(f,e,4);r=c[f>>2]|0;s=c[k>>2]|0}e=a+60|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[e>>2]);c[f>>2]=q;t=q;u=s}else{Gid(f,e,4);t=c[f>>2]|0;u=c[k>>2]|0}k=a+64|0;a=t+4|0;if(a>>>0<u>>>0){g[t>>2]=ea(g[k>>2]);c[f>>2]=a;i=d;return}else{Gid(f,k,4);i=d;return}}function NDd(a){a=a|0;var b=0;b=i;c[a>>2]=666744;SDd(a);i=b;return}function ODd(a){a=a|0;var b=0;b=i;c[a>>2]=666744;SDd(a);ACi(a);i=b;return}function PDd(a){a=a|0;return 1}function QDd(a){a=a|0;return 1}function RDd(b){b=b|0;return (a[b+36>>0]|0)!=0|0}function SDd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=667152;d=c[a+40>>2]|0;if(!d){WUb(a);i=b;return}e=a+44|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d);WUb(a);i=b;return}function TDd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+8|0;f=d;h=a+60|0;if(ea(g[h>>2])!=b)g[h>>2]=b;h=a+32|0;j=c[h>>2]|0;if(!j){i=d;return}c[e>>2]=2;g[e+4>>2]=ea(0.0);k=e+8|0;g[k>>2]=ea(0.0);_n[c[(c[j>>2]|0)+44>>2]&4095](j,e)|0;UDd(f,a,601152);g[k>>2]=ea(ea(g[f+4>>2])*ea(.5));f=c[h>>2]|0;In[c[(c[f>>2]|0)+28>>2]&4095](f,e);sEd(a);i=d;return}function UDd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;e=i;i=i+48|0;f=e+28|0;h=e+16|0;j=e;qGc(h,BTb(c[b+24>>2]|0)|0);k=ea(g[h>>2]);l=ea(k*ea(g[d>>2]));k=ea(g[h+4>>2]);m=ea(k*ea(g[d+4>>2]));k=ea(g[h+8>>2]);n=ea(k*ea(g[d+8>>2]));g[f>>2]=l;g[f+4>>2]=m;g[f+8>>2]=n;g[j>>2]=l;g[j+4>>2]=m;g[j+8>>2]=n;g[j+12>>2]=l;l=ea(g[b+60>>2]);d=c[b+64>>2]|0;n=ea(l*ea(g[f+(d<<2)>>2]));if(n<ea(0.0))o=ea(-n);else o=n;f=o<ea(9.99999974e-06);n=f?ea(9.99999974e-06):o;o=ea(g[j+((d+1&3)<<2)>>2]);l=ea(g[j+((d+2&3)<<2)>>2]);if(o<ea(0.0))p=ea(-o);else p=o;if(l<ea(0.0))q=ea(-l);else q=l;l=ea(ea(g[b+56>>2])*(p<q?q:p));p=ea(n-ea(l*ea(2.0)));b=p<ea(9.99999974e-06);n=b?ea(9.99999974e-06):p;b=l<ea(9.99999974e-06);g[a>>2]=b?ea(9.99999974e-06):l;g[a+4>>2]=n;i=e;return}function VDd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;d=i;i=i+48|0;e=d+32|0;f=d+16|0;h=d;j=BTb(c[b+24>>2]|0)|0;AGc(e,j,b+68|0);oGc(h,j);j=c[b+64>>2]|0;if((j|0)==1){k=ea(ea(g[150300])*ea(-.707106769));l=ea(ea(g[150301])*ea(-.707106769));m=k;n=ea(.707106769);o=ea(ea(g[150302])*ea(-.707106769));p=l}else if((j|0)==2){l=ea(ea(g[150296])*ea(.707106769));k=ea(ea(g[150297])*ea(.707106769));m=l;n=ea(.707106769);o=ea(ea(g[150298])*ea(.707106769));p=k}else{m=ea(0.0);n=ea(1.0);o=ea(0.0);p=ea(0.0)}k=ea(g[h+12>>2]);l=ea(m*k);q=ea(g[h>>2]);r=ea(l+ea(n*q));l=ea(g[h+4>>2]);s=ea(r+ea(o*l));r=ea(g[h+8>>2]);t=ea(ea(ea(m*r)+ea(ea(p*k)+ea(n*l)))-ea(o*q));u=ea(ea(ea(p*q)+ea(ea(o*k)+ea(n*r)))-ea(m*l));v=ea(ea(ea(ea(n*k)-ea(m*q))-ea(p*l))-ea(o*r));g[f>>2]=ea(s-ea(p*r));g[f+4>>2]=t;g[f+8>>2]=u;g[f+12>>2]=v;uMc(a,e,f);i=d;return}function WDd(){var a=0;a=i;c[166740]=hT(LFd()|0)|0;i=a;return}function XDd(){var a=0,b=0;a=i;b=c[166740]|0;ko[c[c[b>>2]>>2]&4095](b);c[166740]=0;i=a;return}function YDd(){var a=0,b=0;a=i;b=c[166740]|0;if(!b){i=a;return}ko[c[c[b>>2]>>2]&4095](b);c[166740]=0;c[166740]=hT(LFd()|0)|0;i=a;return}function ZDd(b){b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=0,r=Im;d=i;i=i+32|0;e=d+8|0;f=d;h=b+32|0;j=ea(g[h>>2]);if(!(j<ea(0.0)))if(j>ea(1.0)){Krd(667016,0,3653512,677,1,0,0,0);k=ea(1.0)}else k=j;else{Krd(666968,0,3653512,676,1,0,0,0);k=ea(0.0)}g[h>>2]=k;h=b+204|0;l=c[h>>2]|0;if(l){co[c[(c[l>>2]|0)+264>>2]&2047](e,l,3);g[e>>2]=k;l=c[h>>2]|0;co[c[(c[l>>2]|0)+260>>2]&2047](l,3,e)}_Dd(b,ea(g[b+36>>2]));l=c[h>>2]|0;if(l){if(!(a[b+40>>0]|0))m=ea(0.0);else m=(a[b+319>>0]|0)!=0?ea(1.0):ea(0.0);g[f>>2]=m;g[f+4>>2]=ea(1.0);In[c[(c[l>>2]|0)+268>>2]&4095](l,f);f=c[h>>2]|0;if(f)co[c[(c[f>>2]|0)+44>>2]&2047](f,2,(a[b+41>>0]|0)==0)}f=b+44|0;m=ea(g[f>>2]);if(!(m<ea(0.0)))if(m>ea(1.0)){Krd(667016,0,3653512,720,1,0,0,0);n=ea(1.0)}else n=m;else{Krd(666968,0,3653512,719,1,0,0,0);n=ea(0.0)}g[f>>2]=n;f=c[h>>2]|0;if((f|0)!=0?(l=c[(c[f>>2]|0)+176>>2]|0,g[e>>2]=n,g[e+4>>2]=n,g[e+8>>2]=n,In[l&4095](f,e),e=c[h>>2]|0,(e|0)!=0):0){n=ea(g[b+76>>2]);Fn[c[(c[e>>2]|0)+172>>2]&255](e,n)}e=b+80|0;n=ea(g[e>>2]);if(!(n<ea(0.0)))if(n>ea(1.0)){Krd(667016,0,3653512,776,1,0,0,0);o=ea(1.0)}else o=n;else{Krd(666968,0,3653512,775,1,0,0,0);o=ea(0.0)}g[e>>2]=o;e=c[h>>2]|0;if(e)Fn[c[(c[e>>2]|0)+372>>2]&255](e,o);e=b+84|0;o=ea(g[e>>2]);if(o<ea(0.0)){Krd(666968,0,3653512,786,1,0,0,0);p=ea(0.0)}else p=o;g[e>>2]=p;e=c[h>>2]|0;if((e|0)!=0?(Fn[c[(c[e>>2]|0)+380>>2]&255](e,p),e=c[h>>2]|0,(e|0)!=0):0)co[c[(c[e>>2]|0)+104>>2]&2047](e,2,(a[b+88>>0]|0)!=0);$Dd(b,(a[b+89>>0]|0)!=0);e=b+116|0;f=c[e>>2]|0;if(!f){Krd(667096,0,3653512,827,1,0,0,0);q=1}else q=f;c[e>>2]=q;e=c[h>>2]|0;if(e){p=ea(q>>>0);Fn[c[(c[e>>2]|0)+128>>2]&255](e,p)}e=b+120|0;p=ea(g[e>>2]);if(p<ea(0.0)){Krd(666968,0,3653512,837,1,0,0,0);r=ea(0.0)}else r=p;g[e>>2]=r;e=c[h>>2]|0;if(!e){i=d;return}Fn[c[(c[e>>2]|0)+452>>2]&255](e,r);i=d;return}function _Dd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=Im,j=0;d=i;i=i+32|0;e=d+16|0;f=d;if(!(b<=ea(0.0)))if(b>ea(1.0)){Krd(667016,0,3653512,691,1,0,0,0);h=ea(1.0)}else h=b;else{Krd(667064,0,3653512,690,1,0,0,0);h=ea(0.0)}g[a+36>>2]=h;j=a+204|0;a=c[j>>2]|0;if(!a){i=d;return}co[c[(c[a>>2]|0)+264>>2]&2047](e,a,1);g[e>>2]=h;a=c[j>>2]|0;co[c[(c[a>>2]|0)+260>>2]&2047](a,1,e);a=c[j>>2]|0;co[c[(c[a>>2]|0)+264>>2]&2047](f,a,2);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];g[e>>2]=h;f=c[j>>2]|0;co[c[(c[f>>2]|0)+260>>2]&2047](f,2,e);i=d;return}function $Dd(b,d){b=b|0;d=d|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+32|0;h=f+16|0;j=f+12|0;k=f;a[b+89>>0]=d&1;l=b+204|0;m=c[l>>2]|0;if(!m){i=f;return}n=c[153134]|0;if(d){d=b+248|0;o=c[d>>2]|0;p=(o>>>0)/3|0;q=p<<2;if(!q){r=0;s=0;t=o}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];o=hOb(0,p<<4,4,h,0,3653512,370)|0;r=q;s=o;t=c[d>>2]|0}if(!t){u=r;v=0;w=s}else{d=b+240|0;b=0;o=r;r=s;s=0;while(1){q=e[(c[d>>2]|0)+(s<<1)>>1]|0;p=b|1;x=o&2147483647;do if(p>>>0>x>>>0?(y=o<<1,z=(y|0)==0?1:y,x>>>0<z>>>0):0)if((o|0)>-1){c[j>>2]=n;c[h+0>>2]=c[j+0>>2];A=hOb(r,z<<2,4,h,0,3653512,370)|0;B=z;break}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];y=cOb(z<<2,4,h,0,3653512,352)|0;YEi(y|0,r|0,p<<2|0)|0;A=y;B=z;break}else{A=r;B=o}while(0);c[A+(b<<2)>>2]=q;x=e[(c[d>>2]|0)+(s+1<<1)>>1]|0;z=b|2;y=B&2147483647;do if(z>>>0>y>>>0?(C=B<<1,D=(C|0)==0?1:C,y>>>0<D>>>0):0)if((B|0)>-1){c[j>>2]=n;c[h+0>>2]=c[j+0>>2];E=hOb(A,D<<2,4,h,0,3653512,370)|0;F=D;break}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];C=cOb(D<<2,4,h,0,3653512,352)|0;YEi(C|0,A|0,z<<2|0)|0;E=C;F=D;break}else{E=A;F=B}while(0);c[E+(p<<2)>>2]=x;y=e[(c[d>>2]|0)+(s+2<<1)>>1]|0;q=b|3;D=F&2147483647;do if(q>>>0>D>>>0?(C=F<<1,G=(C|0)==0?1:C,D>>>0<G>>>0):0)if((F|0)>-1){c[j>>2]=n;c[h+0>>2]=c[j+0>>2];H=hOb(E,G<<2,4,h,0,3653512,370)|0;I=G;break}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];C=cOb(G<<2,4,h,0,3653512,352)|0;YEi(C|0,E|0,q<<2|0)|0;H=C;I=G;break}else{H=E;I=F}while(0);c[H+(z<<2)>>2]=y;s=s+3|0;D=b+4|0;x=I&2147483647;do if(D>>>0>x>>>0?(p=I<<1,G=(p|0)==0?1:p,x>>>0<G>>>0):0)if((I|0)>-1){c[j>>2]=n;c[h+0>>2]=c[j+0>>2];J=G;K=hOb(H,G<<2,4,h,0,3653512,370)|0;break}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];p=cOb(G<<2,4,h,0,3653512,352)|0;YEi(p|0,H|0,D<<2|0)|0;J=G;K=p;break}else{J=I;K=H}while(0);c[K+(q<<2)>>2]=0;if(s>>>0>=t>>>0){u=J;v=D;w=K;break}else{b=D;o=J;r=K}}}L=c[l>>2]|0;M=v;N=w;O=u}else{L=m;M=0;N=0;O=0}g[k>>2]=ea(.333333343);g[k+4>>2]=ea(.333333343);g[k+8>>2]=ea(.333333343);En[c[(c[L>>2]|0)+352>>2]&127](L,M>>>2,N,1,k);if((O|0)<=-1){i=f;return}c[j>>2]=n;c[h+0>>2]=c[j+0>>2];eOb(N,h);i=f;return}function aEd(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=0;e=i;i=i+288|0;f=e+132|0;h=e+224|0;j=e+128|0;k=e+124|0;l=e+220|0;m=e+228|0;n=e+256|0;o=e+268|0;p=e+96|0;q=e+32|0;r=e+168|0;s=e+112|0;t=e;u=e+280|0;v=e+232|0;w=d+204|0;x=c[w>>2]|0;if(x){y=mo[c[(c[x>>2]|0)+84>>2]&4095](x)|0;x=c[w>>2]|0;ko[c[c[x>>2]>>2]&4095](x);ko[c[c[y>>2]>>2]&4095](y);c[w>>2]=0}y=d+24|0;x=c[y>>2]|0;if((x|0)!=0?(z=CTb(x,137)|0,(z|0)!=0):0)c[z+428>>2]=0;z=d+216|0;c[z>>2]=0;x=d+220|0;c[x>>2]=0;A=CTb(c[y>>2]|0,137)|0;c[A+428>>2]=d;if(!(Dcc(A)|0)){i=e;return}y=d+320|0;rGc(n,Icc(A)|0);c[y+0>>2]=c[n+0>>2];c[y+4>>2]=c[n+4>>2];c[y+8>>2]=c[n+8>>2];n=d+212|0;y=c[n>>2]|0;do if(y){c[m>>2]=y;B=c[137784]|0;if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(f,B,m);C=c[f>>2]|0;D=c[B+28>>2]|0;if((C|0)==-1){E=D+(c[B+32>>2]<<3)|0;break}else{E=D+(C<<3)|0;break}}else E=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);B=c[137784]|0;if(!((E|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(c[E+4>>2]|0)!=0:0))F=16}else F=16;if((F|0)==16?(hQb(c[n>>2]|0)|0)==0:0)break;B=Dcc(A)|0;C=c[n>>2]|0;if(!C)G=0;else{c[l>>2]=C;C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(f,C,l);D=c[f>>2]|0;H=c[C+28>>2]|0;if((D|0)==-1){I=H+(c[C+32>>2]<<3)|0;break}else{I=H+(D<<3)|0;break}}else I=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((I|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[I+4>>2]|0,(C|0)!=0):0)J=C;else F=26}else F=26;if((F|0)==26)J=hQb(c[n>>2]|0)|0;G=J}if((B|0)==(G|0)){if(!(c[x>>2]|0))break;c[k>>2]=c[n>>2];C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(f,C,k);D=c[f>>2]|0;H=c[C+28>>2]|0;if((D|0)==-1){K=H+(c[C+32>>2]<<3)|0;break}else{K=H+(D<<3)|0;break}}else K=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((K|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[K+4>>2]|0,(C|0)!=0):0)L=C;else F=38}else F=38;if((F|0)==38)L=hQb(c[n>>2]|0)|0;if((c[(c[L+28>>2]|0)+100>>2]|0)==(c[x>>2]|0))break}C=d+136|0;if((c[C>>2]|0)>-1){B=d+124|0;D=c[B>>2]|0;c[h>>2]=c[d+128>>2];c[f+0>>2]=c[h+0>>2];eOb(D,f);c[B>>2]=0}c[d+132>>2]=0;c[C>>2]=0}while(0);L=Dcc(A)|0;if(!L)M=0;else M=c[L+4>>2]|0;c[n>>2]=M;c[j>>2]=M;M=c[137784]|0;if(M){do if((c[M+36>>2]|0)!=(c[M+4>>2]|0)){fRb(f,M,j);L=c[f>>2]|0;K=c[M+28>>2]|0;if((L|0)==-1){N=K+(c[M+32>>2]<<3)|0;break}else{N=K+(L<<3)|0;break}}else N=(c[M+28>>2]|0)+(c[M+32>>2]<<3)|0;while(0);M=c[137784]|0;if((N|0)!=((c[M+28>>2]|0)+(c[M+32>>2]<<3)|0)?(M=c[N+4>>2]|0,(M|0)!=0):0)O=M;else F=53}else F=53;if((F|0)==53)O=hQb(c[n>>2]|0)|0;n=d+256|0;F=d+240|0;if(!(CId(O,n,F,d+224|0)|0)){i=e;return}O=d+264|0;c[z>>2]=c[O>>2];c[x>>2]=c[d+232>>2];x=d+248|0;M=c[x>>2]|0;a:do if(M){N=d+252|0;j=d+244|0;L=c[F>>2]|0;K=0;k=M;while(1){G=K;while(1){J=L+(G<<1)|0;I=b[J>>1]|0;l=L+(G+1<<1)|0;E=b[l>>1]|0;m=L+(G+2<<1)|0;if(I<<16>>16==E<<16>>16){P=J;Q=l;R=m;S=G;break}y=b[m>>1]|0;if(E<<16>>16==y<<16>>16?1:y<<16>>16==I<<16>>16){P=J;Q=l;R=m;S=G;break}G=G+3|0;if(G>>>0>=k>>>0)break a}G=k;k=k+-3|0;b[P>>1]=b[L+(k<<1)>>1]|0;b[Q>>1]=b[L+(G+-2<<1)>>1]|0;b[R>>1]=b[L+(G+-1<<1)>>1]|0;c[x>>2]=k;G=c[N>>2]|0;do if((G&2147483647)>>>0<k>>>0)if((G|0)>-1){c[N>>2]=k;c[h>>2]=c[j>>2];c[f+0>>2]=c[h+0>>2];m=hOb(L,k<<1,2,f,0,3653512,370)|0;c[F>>2]=m;T=m;break}else{c[h>>2]=c[j>>2];c[f+0>>2]=c[h+0>>2];m=cOb(k<<1,2,f,0,3653512,352)|0;YEi(m|0,c[F>>2]|0,c[x>>2]<<1|0)|0;c[N>>2]=k;c[F>>2]=m;T=m;break}else T=L;while(0);if(S>>>0>=k>>>0)break;else{L=T;K=S}}}while(0);bEd(d);S=PFd(nFd()|0)|0;T=d+208|0;c[T>>2]=S;In[c[(c[S>>2]|0)+252>>2]&4095](o,S);oGc(p,Icc(A)|0);U=ea(g[p>>2]);V=ea(-U);W=ea(g[p+4>>2]);X=ea(-W);Y=ea(g[p+8>>2]);Z=ea(g[p+12>>2]);_=ea(U*ea(-2.0));U=ea(W*ea(-2.0));W=ea(Y*ea(-2.0));$=ea(_*V);aa=ea(U*X);ba=ea(Y*W);Y=ea(U*V);ca=ea(W*V);V=ea(W*X);X=ea(_*Z);_=ea(U*Z);U=ea(Z*W);W=ea(ea(1.0)-ea(aa-ba));Z=ea(g[o>>2]);da=ea(Z*W);W=ea(Y-U);fa=ea(g[o+4>>2]);ga=ea(ea(W*fa)+da);da=ea(ca+_);W=ea(g[o+8>>2]);ha=ea(ea(da*W)+ga);ga=ea(ea(ea(V-X)*W)+ea(ea(Z*ea(Y+U))+ea(fa*ea(ea(1.0)-ea($-ba)))));ba=ea(ea(ea(Z*ea(ca-_))+ea(ea(V+X)*fa))+ea(ea(ea(1.0)-ea($+aa))*W));o=c[153134]|0;p=c[z>>2]|0;if(!p){ia=0;ja=0;ka=0}else{c[h>>2]=o;c[f+0>>2]=c[h+0>>2];S=hOb(0,p<<4,4,f,0,3653512,370)|0;ia=c[z>>2]|0;ja=S;ka=p}p=d+124|0;S=d+136|0;R=c[S>>2]|0;do if((R&2147483647)>>>0<ia>>>0)if((R|0)>-1){c[S>>2]=ia;Q=c[p>>2]|0;c[h>>2]=c[d+128>>2];c[f+0>>2]=c[h+0>>2];c[p>>2]=hOb(Q,ia<<3,4,f,0,3653512,370)|0;break}else{c[h>>2]=c[d+128>>2];c[f+0>>2]=c[h+0>>2];Q=cOb(ia<<3,4,f,0,3653512,352)|0;YEi(Q|0,c[p>>2]|0,c[d+132>>2]<<3|0)|0;c[S>>2]=ia;c[p>>2]=Q;break}while(0);S=d+132|0;R=c[S>>2]|0;if(R>>>0<ia>>>0?(Q=c[p>>2]|0,P=Q+(ia<<3)|0,(R|0)!=(ia|0)):0){M=Q+(R<<3)|0;do{if(M){R=M;c[R>>2]=2139095039;c[R+4>>2]=2139095039}M=M+8|0}while((M|0)!=(P|0))}c[S>>2]=ia;ia=d+319|0;a[ia>>0]=0;nGc(f,Icc(A)|0);_Lc(q,f);A=c[n>>2]|0;xMc(q,A,A,c[O>>2]|0);O=c[z>>2]|0;if(O){z=c[n>>2]|0;n=c[p>>2]|0;p=0;A=0;while(1){W=ea(g[z+(A*12|0)>>2]);aa=ea(g[z+(A*12|0)+4>>2]);$=ea(g[z+(A*12|0)+8>>2]);g[ja+(A<<4)>>2]=W;g[ja+(A<<4)+4>>2]=aa;g[ja+(A<<4)+8>>2]=$;q=ja+(A<<4)+12|0;if(ea(g[n+(A<<3)>>2])>ea(0.0)){g[q>>2]=ea(1.0);la=1}else{g[q>>2]=ea(0.0);a[ia>>0]=1;la=p}A=A+1|0;if(A>>>0>=O>>>0)break;else p=la}if(la){la=r+0|0;p=la+48|0;do{c[la>>2]=0;la=la+4|0}while((la|0)<(p|0));c[r+4>>2]=ja;c[r+8>>2]=O;c[r>>2]=16;c[r+16>>2]=ja+12;c[r+20>>2]=O;c[r+12>>2]=16;c[r+32>>2]=((c[x>>2]|0)>>>0)/3|0;c[r+28>>2]=c[F>>2];c[r+24>>2]=6;b[r+48>>1]=2;F=DFd()|0;g[s>>2]=ha;g[s+4>>2]=ga;g[s+8>>2]=ba;x=WT(F,r,s,1)|0;if(x){s=DFd()|0;r=c[(c[s>>2]|0)+120>>2]|0;g[t>>2]=ea(0.0);g[t+4>>2]=ea(0.0);g[t+8>>2]=ea(0.0);g[t+12>>2]=ea(1.0);g[t+16>>2]=ea(0.0);g[t+20>>2]=ea(0.0);g[t+24>>2]=ea(0.0);b[u>>1]=0;c[w>>2]=Bn[r&255](s,t,x,ja,u)|0;cEd(d);u=c[w>>2]|0;c[u+8>>2]=d;x=c[T>>2]|0;In[c[(c[x>>2]|0)+44>>2]&4095](x,u);c[d+288>>2]=0;c[d+292>>2]=0;c[d+296>>2]=0;u=c[w>>2]|0;go[c[(c[u>>2]|0)+40>>2]&63](v,u,ea(1.00999999));ba=ea(g[v>>2]);ga=ea(g[v+4>>2]);ha=ea(g[v+8>>2]);$=ea(g[v+12>>2]);aa=ea(g[v+16>>2]);W=ea(g[v+20>>2]);fa=ea(ea(ga+aa)*ea(.5));X=ea(ea(ha+W)*ea(.5));g[d+92>>2]=ea(ea(ba+$)*ea(.5));g[d+96>>2]=fa;g[d+100>>2]=X;X=ea(ea(aa-ga)*ea(.5));ga=ea(ea(W-ha)*ea(.5));g[d+104>>2]=ea(ea($-ba)*ea(.5));g[d+108>>2]=X;g[d+112>>2]=ga;ZDd(d)}}}if((ka|0)<=-1){i=e;return}c[h>>2]=o;c[f+0>>2]=c[h+0>>2];eOb(ja,f);i=e;return}function bEd(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=Im,B=Im;b=i;i=i+16|0;d=b+4|0;f=b;h=a+272|0;j=a+216|0;k=c[j>>2]|0;l=a+280|0;c[l>>2]=k;m=a+284|0;n=c[m>>2]|0;do if((n&2147483647)>>>0<k>>>0)if((n|0)>-1){c[m>>2]=k;o=c[h>>2]|0;c[f>>2]=c[a+276>>2];c[d+0>>2]=c[f+0>>2];c[h>>2]=hOb(o,k*12|0,4,d,0,3653512,370)|0;break}else{c[f>>2]=c[a+276>>2];c[d+0>>2]=c[f+0>>2];o=cOb(k*12|0,4,d,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,(c[l>>2]|0)*12|0)|0;c[m>>2]=k;c[h>>2]=o;break}while(0);if(!(c[j>>2]|0))p=0;else{k=0;do{m=(c[h>>2]|0)+(k*12|0)|0;c[m+0>>2]=c[150284];c[m+4>>2]=c[150285];c[m+8>>2]=c[150286];k=k+1|0;m=c[j>>2]|0}while(k>>>0<m>>>0);p=m}k=c[a+248>>2]|0;if(k){m=c[a+240>>2]|0;l=c[a+256>>2]|0;a=c[h>>2]|0;d=0;do{f=e[m+(d<<1)>>1]|0;n=e[m+(d+1<<1)>>1]|0;o=e[m+(d+2<<1)>>1]|0;q=ea(g[l+(f*12|0)>>2]);r=ea(g[l+(f*12|0)+4>>2]);s=ea(g[l+(f*12|0)+8>>2]);t=ea(ea(g[l+(n*12|0)>>2])-q);u=ea(ea(g[l+(n*12|0)+4>>2])-r);v=ea(ea(g[l+(n*12|0)+8>>2])-s);w=ea(ea(g[l+(o*12|0)>>2])-q);q=ea(ea(g[l+(o*12|0)+4>>2])-r);r=ea(ea(g[l+(o*12|0)+8>>2])-s);s=ea(ea(u*r)-ea(v*q));x=ea(ea(v*w)-ea(t*r));r=ea(ea(t*q)-ea(u*w));y=a+(f*12|0)|0;g[y>>2]=ea(ea(g[y>>2])+s);y=a+(f*12|0)+4|0;g[y>>2]=ea(x+ea(g[y>>2]));y=a+(f*12|0)+8|0;g[y>>2]=ea(r+ea(g[y>>2]));y=a+(n*12|0)|0;g[y>>2]=ea(s+ea(g[y>>2]));y=a+(n*12|0)+4|0;g[y>>2]=ea(x+ea(g[y>>2]));y=a+(n*12|0)+8|0;g[y>>2]=ea(r+ea(g[y>>2]));y=a+(o*12|0)|0;g[y>>2]=ea(s+ea(g[y>>2]));y=a+(o*12|0)+4|0;g[y>>2]=ea(x+ea(g[y>>2]));y=a+(o*12|0)+8|0;g[y>>2]=ea(r+ea(g[y>>2]));d=d+3|0}while(d>>>0<k>>>0)}if(!p){i=b;return}r=ea(g[150276]);p=0;do{k=c[h>>2]|0;d=k+(p*12|0)|0;x=ea(g[d>>2]);s=ea(x*x);a=k+(p*12|0)+4|0;w=ea(g[a>>2]);u=ea(s+ea(w*w));l=k+(p*12|0)+8|0;s=ea(g[l>>2]);q=ea(T(ea(u+ea(s*s))));if(q>r){z=ea(x/q);A=ea(w/q);B=ea(s/q)}else{q=ea(g[150284]);s=ea(g[150285]);z=q;A=s;B=ea(g[150286])}g[d>>2]=z;g[a>>2]=A;g[l>>2]=B;p=p+1|0}while(p>>>0<(c[j>>2]|0)>>>0);i=b;return}function cEd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;b=i;i=i+48|0;d=b+32|0;e=b+16|0;f=b+4|0;g=b+8|0;h=b+40|0;j=b;k=b+12|0;l=b+24|0;m=b+20|0;n=a+204|0;if(!(c[n>>2]|0)){i=b;return}o=c[153134]|0;p=a+172|0;q=a+180|0;c[q>>2]=0;r=a+184|0;s=c[r>>2]|0;t=a+164|0;u=a+148|0;v=(c[u>>2]|0)+(c[t>>2]|0)|0;w=v<<1;do if((s&2147483647)>>>0<w>>>0)if((s|0)>-1){c[r>>2]=w;x=c[p>>2]|0;c[e>>2]=c[a+176>>2];c[d+0>>2]=c[e+0>>2];y=hOb(x,v<<3,4,d,0,3653512,370)|0;c[p>>2]=y;z=y;break}else{c[e>>2]=c[a+176>>2];c[d+0>>2]=c[e+0>>2];y=cOb(v<<3,4,d,0,3653512,352)|0;YEi(y|0,c[p>>2]|0,c[q>>2]<<2|0)|0;c[r>>2]=w;c[p>>2]=y;z=y;break}else z=c[p>>2]|0;while(0);w=c[a+156>>2]|0;r=c[t>>2]|0;t=w+(r<<3)|0;a:do if(!r){A=0;B=0;C=0}else{v=z;s=0;y=0;x=0;D=z;E=w;while(1){F=c[E>>2]|0;c[l>>2]=F;G=c[E+4>>2]|0;c[m>>2]=G;H=D+(c[q>>2]<<2)|0;b:do if((z|0)==(H|0))I=z;else{J=z;while(1){if((c[J>>2]|0)==(F|0)){I=J;break b}J=J+4|0;if((J|0)==(H|0)){I=H;break}}}while(0);H=I-v>>2;do if(F){c[j>>2]=F;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(d,J,j);K=c[d>>2]|0;L=c[J+28>>2]|0;if((K|0)==-1){M=L+(c[J+32>>2]<<3)|0;break}else{M=L+(K<<3)|0;break}}else M=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if(!((M|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(c[M+4>>2]|0)!=0:0))N=21}else N=21;if((N|0)==21?(N=0,(hQb(F)|0)==0):0){O=F;break}if((H|0)==(c[q>>2]|0)){gEd(p,l);O=F}else O=F}else O=0;while(0);F=(c[p>>2]|0)+(c[q>>2]<<2)|0;c:do if((z|0)==(F|0))P=z;else{J=z;while(1){if((c[J>>2]|0)==(G|0)){P=J;break c}J=J+4|0;if((J|0)==(F|0)){P=F;break}}}while(0);F=P-v>>2;do if(G){c[h>>2]=G;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(d,J,h);K=c[d>>2]|0;L=c[J+28>>2]|0;if((K|0)==-1){Q=L+(c[J+32>>2]<<3)|0;break}else{Q=L+(K<<3)|0;break}}else Q=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if(!((Q|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(c[Q+4>>2]|0)!=0:0))N=36}else N=36;if((N|0)==36?(N=0,(hQb(G)|0)==0):0){R=G;break}if((F|0)==(c[q>>2]|0)){gEd(p,m);R=G}else R=G}else R=0;while(0);do if(!O){S=y;T=s;U=x}else{c[g>>2]=O;G=c[137784]|0;if(G){do if((c[G+36>>2]|0)!=(c[G+4>>2]|0)){fRb(d,G,g);J=c[d>>2]|0;K=c[G+28>>2]|0;if((J|0)==-1){V=K+(c[G+32>>2]<<3)|0;break}else{V=K+(J<<3)|0;break}}else V=(c[G+28>>2]|0)+(c[G+32>>2]<<3)|0;while(0);G=c[137784]|0;if((V|0)!=((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)?(c[V+4>>2]|0)!=0:0){if(!R){S=y;T=s;U=x;break}}else N=48}else N=48;if((N|0)==48?(N=0,(hQb(O)|0)==0|(R|0)==0):0){S=y;T=s;U=x;break}c[f>>2]=R;G=c[137784]|0;if(G){do if((c[G+36>>2]|0)!=(c[G+4>>2]|0)){fRb(d,G,f);J=c[d>>2]|0;K=c[G+28>>2]|0;if((J|0)==-1){W=K+(c[G+32>>2]<<3)|0;break}else{W=K+(J<<3)|0;break}}else W=(c[G+28>>2]|0)+(c[G+32>>2]<<3)|0;while(0);G=c[137784]|0;if((W|0)!=((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)?(c[W+4>>2]|0)!=0:0){if((O|0)==(R|0)){S=y;T=s;U=x;break}}else N=58}else N=58;if((N|0)==58?(N=0,(hQb(R)|0)==0|(O|0)==(R|0)):0){S=y;T=s;U=x;break}G=s+1|0;J=y&2147483647;do if(G>>>0>J>>>0?(K=y<<1,L=(K|0)==0?1:K,J>>>0<L>>>0):0)if((y|0)>-1){c[e>>2]=o;c[d+0>>2]=c[e+0>>2];X=hOb(x,L<<2,4,d,0,3653512,370)|0;Y=L;break}else{c[e>>2]=o;c[d+0>>2]=c[e+0>>2];K=cOb(L<<2,4,d,0,3653512,352)|0;YEi(K|0,x|0,G<<2|0)|0;X=K;Y=L;break}else{X=x;Y=y}while(0);c[X+(s<<2)>>2]=H;J=s+2|0;L=Y&2147483647;do if(J>>>0>L>>>0?(K=Y<<1,Z=(K|0)==0?1:K,L>>>0<Z>>>0):0)if((Y|0)>-1){c[e>>2]=o;c[d+0>>2]=c[e+0>>2];_=hOb(X,Z<<2,4,d,0,3653512,370)|0;$=Z;break}else{c[e>>2]=o;c[d+0>>2]=c[e+0>>2];K=cOb(Z<<2,4,d,0,3653512,352)|0;YEi(K|0,X|0,J<<2|0)|0;_=K;$=Z;break}else{_=X;$=Y}while(0);c[_+(G<<2)>>2]=F;S=$;T=J;U=_}while(0);F=E+8|0;if((F|0)==(t|0)){A=S;B=T;C=U;break a}s=T;y=S;x=U;D=c[p>>2]|0;E=F}}while(0);p=c[a+140>>2]|0;U=c[u>>2]|0;u=p+(U<<2)|0;if(!U){aa=A;ba=B;ca=C}else{U=B;B=A;A=C;C=p;p=c[q>>2]|0;while(1){q=c[C>>2]|0;do if(!q){da=B;ea=U;fa=A;ga=p}else{c[e>>2]=q;S=c[137784]|0;if(S){do if((c[S+36>>2]|0)!=(c[S+4>>2]|0)){fRb(d,S,e);T=c[d>>2]|0;t=c[S+28>>2]|0;if((T|0)==-1){ha=t+(c[S+32>>2]<<3)|0;break}else{ha=t+(T<<3)|0;break}}else ha=(c[S+28>>2]|0)+(c[S+32>>2]<<3)|0;while(0);S=c[137784]|0;if(!((ha|0)!=((c[S+28>>2]|0)+(c[S+32>>2]<<3)|0)?(c[ha+4>>2]|0)!=0:0))N=84}else N=84;if((N|0)==84?(N=0,(hQb(c[C>>2]|0)|0)==0):0){da=B;ea=U;fa=A;ga=p;break}S=U+1|0;T=B&2147483647;do if(S>>>0>T>>>0?(t=B<<1,_=(t|0)==0?1:t,T>>>0<_>>>0):0)if((B|0)>-1){c[k>>2]=o;c[d+0>>2]=c[k+0>>2];ia=hOb(A,_<<2,4,d,0,3653512,370)|0;ja=_;break}else{c[k>>2]=o;c[d+0>>2]=c[k+0>>2];t=cOb(_<<2,4,d,0,3653512,352)|0;YEi(t|0,A|0,S<<2|0)|0;ia=t;ja=_;break}else{ia=A;ja=B}while(0);c[ia+(U<<2)>>2]=p;T=p+1|0;_=p+2|0;t=U+2|0;$=ja&2147483647;do if(t>>>0>$>>>0?(Y=ja<<1,X=(Y|0)==0?1:Y,$>>>0<X>>>0):0)if((ja|0)>-1){c[k>>2]=o;c[d+0>>2]=c[k+0>>2];ka=hOb(ia,X<<2,4,d,0,3653512,370)|0;la=X;break}else{c[k>>2]=o;c[d+0>>2]=c[k+0>>2];Y=cOb(X<<2,4,d,0,3653512,352)|0;YEi(Y|0,ia|0,t<<2|0)|0;ka=Y;la=X;break}else{ka=ia;la=ja}while(0);c[ka+(S<<2)>>2]=T;da=la;ea=t;fa=ka;ga=_}while(0);C=C+4|0;if((C|0)==(u|0)){aa=da;ba=ea;ca=fa;break}else{U=ea;B=da;A=fa;p=ga}}}dEd(a);ga=c[n>>2]|0;co[c[(c[ga>>2]|0)+284>>2]&2047](ga,c[a+188>>2]|0,c[a+196>>2]|0);a=ba>>>1;if(a){ba=0;do{ga=c[n>>2]|0;p=ba<<1;co[c[(c[ga>>2]|0)+292>>2]&2047](ga,c[ca+(p<<2)>>2]|0,c[ca+((p|1)<<2)>>2]|0);ba=ba+1|0}while(ba>>>0<a>>>0)}if((aa|0)<=-1){i=b;return}c[k>>2]=o;c[d+0>>2]=c[k+0>>2];eOb(ca,d);i=b;return}function dEd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=0,W=0;b=i;i=i+272|0;d=b;e=b+152|0;f=b+240|0;h=b+64|0;j=b+244|0;k=b+256|0;l=b+144|0;m=b+176|0;n=b+160|0;o=b+128|0;p=a+188|0;c[a+196>>2]=0;PGc(h,Icc(CTb(c[a+24>>2]|0,137)|0)|0);q=c[a+172>>2]|0;r=c[a+180>>2]|0;s=q+(r<<2)|0;if(r){r=h+16|0;t=j+4|0;u=h+32|0;v=j+8|0;w=h+48|0;x=h+4|0;y=h+20|0;z=h+36|0;A=h+52|0;B=h+8|0;C=h+24|0;D=h+40|0;E=h+56|0;F=k+4|0;G=k+8|0;H=k+12|0;I=q;do{q=c[I>>2]|0;do if(q){c[e>>2]=q;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(d,J,e);K=c[d>>2]|0;L=c[J+28>>2]|0;if((K|0)==-1){M=L+(c[J+32>>2]<<3)|0;break}else{M=L+(K<<3)|0;break}}else M=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((M|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[M+4>>2]|0,(J|0)!=0):0)N=J;else O=12}else O=12;if((O|0)==12){O=0;J=hQb(c[I>>2]|0)|0;if(!J)break;else N=J}OHd(j,N);P=ea(g[h>>2]);Q=ea(g[j>>2]);R=ea(P*Q);P=ea(g[r>>2]);S=ea(g[t>>2]);T=ea(R+ea(P*S));P=ea(g[u>>2]);R=ea(g[v>>2]);U=ea(T+ea(P*R));P=ea(ea(g[w>>2])+U);U=ea(Q*ea(g[x>>2]));T=ea(U+ea(S*ea(g[y>>2])));U=ea(T+ea(R*ea(g[z>>2])));T=ea(ea(g[A>>2])+U);U=ea(Q*ea(g[B>>2]));Q=ea(U+ea(S*ea(g[C>>2])));S=ea(Q+ea(R*ea(g[D>>2])));R=ea(ea(g[E>>2])+S);S=ea(NHd(N,601152));g[k>>2]=P;g[F>>2]=T;g[G>>2]=R;g[H>>2]=S;hEd(p,k)}while(0);I=I+4|0}while((I|0)!=(s|0))}s=c[a+140>>2]|0;I=c[a+148>>2]|0;a=s+(I<<2)|0;if(!I){i=b;return}I=l+4|0;k=d+16|0;H=d+32|0;G=d+48|0;F=d+4|0;N=d+20|0;E=d+36|0;D=d+52|0;C=d+8|0;B=d+24|0;A=d+40|0;z=d+56|0;y=n+4|0;x=n+8|0;w=n+12|0;v=o+4|0;u=o+8|0;t=o+12|0;r=s;do{s=c[r>>2]|0;do if(s){c[f>>2]=s;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,f);M=c[d>>2]|0;e=c[j+28>>2]|0;if((M|0)==-1){V=e+(c[j+32>>2]<<3)|0;break}else{V=e+(M<<3)|0;break}}else V=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((V|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[V+4>>2]|0,(j|0)!=0):0)W=j;else O=26}else O=26;if((O|0)==26){O=0;j=hQb(c[r>>2]|0)|0;if(!j)break;else W=j}UDd(l,W,601152);S=ea(ea(g[I>>2])*ea(.5));j=d+0|0;M=h+0|0;e=j+64|0;do{c[j>>2]=c[M>>2];j=j+4|0;M=M+4|0}while((j|0)<(e|0));VDd(m,W);cMc(d,m)|0;R=ea(S*ea(g[d>>2]));T=ea(R+ea(ea(g[k>>2])*ea(0.0)));R=ea(T+ea(ea(g[H>>2])*ea(0.0)));T=ea(ea(g[G>>2])+R);R=ea(S*ea(g[F>>2]));P=ea(R+ea(ea(g[N>>2])*ea(0.0)));R=ea(P+ea(ea(g[E>>2])*ea(0.0)));P=ea(ea(g[D>>2])+R);R=ea(S*ea(g[C>>2]));Q=ea(R+ea(ea(g[B>>2])*ea(0.0)));R=ea(Q+ea(ea(g[A>>2])*ea(0.0)));Q=ea(ea(g[z>>2])+R);R=ea(g[l>>2]);g[n>>2]=T;g[y>>2]=P;g[x>>2]=Q;g[w>>2]=R;hEd(p,n);R=ea(-S);Q=ea(ea(g[d>>2])*R);P=ea(Q+ea(ea(g[k>>2])*ea(-0.0)));Q=ea(P+ea(ea(g[H>>2])*ea(-0.0)));P=ea(ea(g[G>>2])+Q);Q=ea(ea(g[F>>2])*R);T=ea(Q+ea(ea(g[N>>2])*ea(-0.0)));Q=ea(T+ea(ea(g[E>>2])*ea(-0.0)));T=ea(ea(g[D>>2])+Q);Q=ea(ea(g[C>>2])*R);R=ea(Q+ea(ea(g[B>>2])*ea(-0.0)));Q=ea(R+ea(ea(g[A>>2])*ea(-0.0)));R=ea(ea(g[z>>2])+Q);Q=ea(g[l>>2]);g[o>>2]=P;g[v>>2]=T;g[u>>2]=R;g[t>>2]=Q;hEd(p,o)}while(0);r=r+4|0}while((r|0)!=(a|0));i=b;return}function eEd(b,d,f,h,j){b=b|0;d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=0,K=0,L=Im,M=0,N=Im,O=0,P=0,Q=0,R=0,S=Im,U=Im,V=Im,W=0,X=Im,Y=0,Z=0,_=0,$=0,aa=0;h=i;i=i+64|0;k=h+32|0;l=h+52|0;m=h+56|0;n=h+60|0;o=h+28|0;p=h;q=h+40|0;r=CTb(c[b+24>>2]|0,137)|0;s=Dcc(r)|0;t=b+212|0;u=c[t>>2]|0;if(!u)v=0;else{c[o>>2]=u;u=c[137784]|0;if(u){do if((c[u+36>>2]|0)!=(c[u+4>>2]|0)){fRb(k,u,o);w=c[k>>2]|0;x=c[u+28>>2]|0;if((w|0)==-1){y=x+(c[u+32>>2]<<3)|0;break}else{y=x+(w<<3)|0;break}}else y=(c[u+28>>2]|0)+(c[u+32>>2]<<3)|0;while(0);u=c[137784]|0;if((y|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[y+4>>2]|0,(u|0)!=0):0)z=u;else A=10}else A=10;if((A|0)==10)z=hQb(c[t>>2]|0)|0;v=z}if((s|0)==(v|0)){c[n>>2]=c[t>>2];v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(k,v,n);s=c[k>>2]|0;z=c[v+28>>2]|0;if((s|0)==-1){B=z+(c[v+32>>2]<<3)|0;break}else{B=z+(s<<3)|0;break}}else B=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((B|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[B+4>>2]|0,(v|0)!=0):0)C=v;else A=21}else A=21;if((A|0)==21)C=hQb(c[t>>2]|0)|0;if((c[(c[C+28>>2]|0)+100>>2]|0)!=(c[b+220>>2]|0))A=23}else A=23;if((A|0)==23)aEd(b);C=b+204|0;if(!(c[C>>2]|0)){i=h;return}MGc(Icc(r)|0,p+16|0,p);v=c[C>>2]|0;In[c[(c[v>>2]|0)+116>>2]&4095](v,p);v=b+318|0;if((a[v>>0]|0)==0?oVb()|0:0)D=b+216|0;else{a[v>>0]=0;v=c[C>>2]|0;B=mo[c[(c[v>>2]|0)+96>>2]&4095](v)|0;v=c[153134]|0;n=c[B+4>>2]|0;s=b+216|0;z=c[s>>2]<<4;u=z>>4;if(!u){E=0;F=0}else{c[l>>2]=v;c[k+0>>2]=c[l+0>>2];E=hOb(0,z,4,k,0,3653512,370)|0;F=u}YEi(E|0,n|0,z|0)|0;z=c[b+220>>2]|0;if(z){n=c[b+224>>2]|0;u=0;do{y=e[n+(u<<1)>>1]|0;o=da(u,j)|0;G=ea(g[d+o>>2]);H=ea(g[d+(o+4)>>2]);I=ea(g[d+(o+8)>>2]);g[E+(y<<4)>>2]=G;g[E+(y<<4)+4>>2]=H;g[E+(y<<4)+8>>2]=I;u=u+1|0}while(u>>>0<z>>>0)}ko[c[(c[B>>2]|0)+4>>2]&4095](B);B=c[C>>2]|0;co[c[(c[B>>2]|0)+100>>2]&2047](B,E,E);B=c[C>>2]|0;In[c[(c[B>>2]|0)+120>>2]&4095](B,p);p=c[C>>2]|0;ko[c[(c[p>>2]|0)+256>>2]&4095](p);if((F|0)>-1){c[l>>2]=v;c[k+0>>2]=c[l+0>>2];eOb(E,k);D=s}else D=s}qGc(q,Icc(r)|0);I=ea(g[q>>2]);H=ea(I+ea(g[q+4>>2]));I=ea(ea(H+ea(g[q+8>>2]))/ea(3.0));q=c[153134]|0;r=c[D>>2]|0;if(!r){J=0;K=0}else{c[l>>2]=q;c[k+0>>2]=c[l+0>>2];J=hOb(0,r<<4,4,k,0,3653512,370)|0;K=r}r=b+220|0;s=c[r>>2]|0;if(s){E=c[b+224>>2]|0;v=c[b+124>>2]|0;F=0;p=0;while(1){B=e[E+(p<<1)>>1]|0;z=da(p,j)|0;H=ea(g[d+z>>2]);G=ea(g[d+(z+4)>>2]);L=ea(g[d+(z+8)>>2]);g[J+(B<<4)>>2]=H;g[J+(B<<4)+4>>2]=G;g[J+(B<<4)+8>>2]=L;L=ea(g[v+(B<<3)>>2]);if(L<ea(3402823469999999843913219.0e14)){M=1;N=ea(I*L)}else{M=F;N=L}g[J+(B<<4)+12>>2]=N;p=p+1|0;if(p>>>0>=s>>>0)break;else F=M}if(M)A=44;else A=43}else A=43;if((A|0)==43)if(!(ea(g[b+300>>2])!=ea(1.0))){M=c[C>>2]|0;if(mo[c[(c[M>>2]|0)+232>>2]&4095](M)|0){M=c[C>>2]|0;In[c[(c[M>>2]|0)+224>>2]&4095](M,0)}}else A=44;if((A|0)==44){M=c[C>>2]|0;In[c[(c[M>>2]|0)+224>>2]&4095](M,J)}if(f){c[l>>2]=c[t>>2];M=c[137784]|0;if(M){do if((c[M+36>>2]|0)!=(c[M+4>>2]|0)){fRb(k,M,l);F=c[k>>2]|0;s=c[M+28>>2]|0;if((F|0)==-1){O=s+(c[M+32>>2]<<3)|0;break}else{O=s+(F<<3)|0;break}}else O=(c[M+28>>2]|0)+(c[M+32>>2]<<3)|0;while(0);M=c[137784]|0;if((O|0)!=((c[M+28>>2]|0)+(c[M+32>>2]<<3)|0)?(M=c[O+4>>2]|0,(M|0)!=0):0)P=M;else A=56}else A=56;if((A|0)==56)P=hQb(c[t>>2]|0)|0;t=P+180|0;N=ea(g[t>>2]);L=ea(N*N);N=ea(g[t+4>>2]);G=ea(L+ea(N*N));N=ea(g[t+8>>2]);L=ea(T(ea(G+ea(N*N))));t=c[D>>2]|0;do if((K&2147483647)>>>0<t>>>0)if((K|0)>-1){c[m>>2]=q;c[k+0>>2]=c[m+0>>2];Q=hOb(J,t<<4,4,k,0,3653512,370)|0;R=t;break}else{D=t<<4;c[m>>2]=q;c[k+0>>2]=c[m+0>>2];P=cOb(D,4,k,0,3653512,352)|0;YEi(P|0,J|0,D|0)|0;Q=P;R=t;break}else{Q=J;R=K}while(0);t=c[r>>2]|0;if(t){r=c[b+224>>2]|0;P=c[b+124>>2]|0;D=0;M=0;while(1){O=e[r+(M<<1)>>1]|0;l=da(M,j)|0;N=ea(g[f+l>>2]);G=ea(g[f+(l+4)>>2]);H=ea(g[f+(l+8)>>2]);S=ea(ea(g[P+(O<<3)>>2])*ea(2.0));U=L<S?L:S;S=ea(ea(g[P+(O<<3)+4>>2])+U);V=ea(N*S);N=ea(G*S);G=ea(H*S);l=Q+(O<<4)|0;g[l>>2]=ea(ea(g[l>>2])-V);l=Q+(O<<4)+4|0;g[l>>2]=ea(ea(g[l>>2])-N);l=Q+(O<<4)+8|0;g[l>>2]=ea(ea(g[l>>2])-G);if(S<ea(3402823469999999843913219.0e14)){W=1;X=ea(I*U)}else{W=D;X=U}g[Q+(O<<4)+12>>2]=X;M=M+1|0;if(M>>>0>=t>>>0){Y=W;break}else D=W}if(Y&1){Y=c[C>>2]|0;In[c[(c[Y>>2]|0)+244>>2]&4095](Y,Q);Z=R;_=Q}else{$=Q;aa=R;A=68}}else{$=Q;aa=R;A=68}}else{$=J;aa=K;A=68}if((A|0)==68){A=c[C>>2]|0;if(!(mo[c[(c[A>>2]|0)+252>>2]&4095](A)|0)){Z=aa;_=$}else{A=c[C>>2]|0;In[c[(c[A>>2]|0)+244>>2]&4095](A,0);Z=aa;_=$}}c[b+288>>2]=d;c[b+292>>2]=f;c[b+296>>2]=j;dEd(b);j=c[b+196>>2]|0;if(j){f=c[C>>2]|0;co[c[(c[f>>2]|0)+284>>2]&2047](f,c[b+188>>2]|0,j)}if((Z|0)<=-1){i=h;return}c[m>>2]=q;c[k+0>>2]=c[m+0>>2];eOb(_,k);i=h;return}function fEd(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=0;b=i;i=i+32|0;d=b+28|0;f=b+24|0;h=b;j=a+288|0;if(!(c[j>>2]|0)){i=b;return}k=a+204|0;l=c[k>>2]|0;if(!l){i=b;return}m=mo[c[(c[l>>2]|0)+96>>2]&4095](l)|0;if(!m){i=b;return}l=c[m+4>>2]|0;n=a+300|0;if(ea(g[n>>2])!=ea(1.0)?(o=c[k>>2]|0,(mo[c[(c[o>>2]|0)+232>>2]&4095](o)|0)!=0):0){o=c[153134]|0;p=c[a+216>>2]|0;if(!p){q=0;r=0}else{c[f>>2]=o;c[d+0>>2]=c[f+0>>2];q=hOb(0,p<<4,4,d,0,3653512,370)|0;r=p}p=c[k>>2]|0;_n[c[(c[p>>2]|0)+228>>2]&4095](p,q)|0;p=a+220|0;if(c[p>>2]|0){s=a+224|0;t=a+296|0;u=a+256|0;v=0;do{w=(c[j>>2]|0)+(da(c[t>>2]|0,v)|0)|0;x=e[(c[s>>2]|0)+(v<<1)>>1]|0;y=c[u>>2]|0;z=y+(x*12|0)|0;A=ea(g[q+(x<<4)>>2]);B=ea(g[q+(x<<4)+4>>2]);C=ea(g[q+(x<<4)+8>>2]);D=ea(g[l+(x<<4)>>2]);E=ea(g[l+(x<<4)+4>>2]);F=ea(g[l+(x<<4)+8>>2]);G=ea(g[n>>2]);H=ea(ea(1.0)-G);I=ea(ea(E*G)+ea(B*H));B=ea(ea(F*G)+ea(C*H));g[z>>2]=ea(ea(D*G)+ea(A*H));g[y+(x*12|0)+4>>2]=I;g[y+(x*12|0)+8>>2]=B;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];v=v+1|0}while(v>>>0<(c[p>>2]|0)>>>0)}if((r|0)>-1){c[f>>2]=o;c[d+0>>2]=c[f+0>>2];eOb(q,d)}}else J=5;if((J|0)==5?(J=a+220|0,(c[J>>2]|0)!=0):0){d=a+224|0;q=a+296|0;f=a+256|0;o=0;do{r=(c[j>>2]|0)+(da(c[q>>2]|0,o)|0)|0;p=e[(c[d>>2]|0)+(o<<1)>>1]|0;v=c[f>>2]|0;n=v+(p*12|0)|0;B=ea(g[l+(p<<4)>>2]);I=ea(g[l+(p<<4)+4>>2]);H=ea(g[l+(p<<4)+8>>2]);g[n>>2]=B;g[v+(p*12|0)+4>>2]=I;g[v+(p*12|0)+8>>2]=H;c[r+0>>2]=c[n+0>>2];c[r+4>>2]=c[n+4>>2];c[r+8>>2]=c[n+8>>2];o=o+1|0}while(o>>>0<(c[J>>2]|0)>>>0)}J=a+292|0;if((c[J>>2]|0)!=0?(bEd(a),o=a+220|0,(c[o>>2]|0)!=0):0){l=a+224|0;f=a+296|0;d=a+272|0;q=0;do{j=(c[J>>2]|0)+(da(c[f>>2]|0,q)|0)|0;n=(c[d>>2]|0)+((e[(c[l>>2]|0)+(q<<1)>>1]|0)*12|0)|0;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];q=q+1|0}while(q>>>0<(c[o>>2]|0)>>>0)}ko[c[(c[m>>2]|0)+4>>2]&4095](m);m=c[k>>2]|0;go[c[(c[m>>2]|0)+40>>2]&63](h,m,ea(1.00999999));H=ea(g[h>>2]);I=ea(g[h+4>>2]);B=ea(g[h+8>>2]);A=ea(g[h+12>>2]);G=ea(g[h+16>>2]);D=ea(g[h+20>>2]);C=ea(ea(I+G)*ea(.5));F=ea(ea(B+D)*ea(.5));g[a+92>>2]=ea(ea(H+A)*ea(.5));g[a+96>>2]=C;g[a+100>>2]=F;F=ea(ea(G-I)*ea(.5));I=ea(ea(D-B)*ea(.5));g[a+104>>2]=ea(ea(A-H)*ea(.5));g[a+108>>2]=F;g[a+112>>2]=I;i=b;return}function gEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<2)|0;c[q>>2]=p;i=d;return}h=k<<1;r=(h|0)==0?1:h;do if(l>>>0<r>>>0)if((k|0)>-1){c[j>>2]=r;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(r<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<2|0)|0;c[j>>2]=r;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=c[b>>2]|0;q=o+(n<<2)|0;c[q>>2]=p;i=d;return}function hEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<4)|0;c[p+0>>2]=c[b+0>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<4,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<4,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[g>>2]<<4|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[g>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<4)|0;c[p+0>>2]=c[b+0>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];i=d;return}function iEd(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;h=i;i=i+64|0;j=h+32|0;k=h;l=h+48|0;m=c[(c[d>>2]|0)+68>>2]|0;HMc(f,j);n=ea(g[f+48>>2]);o=ea(g[f+52>>2]);p=ea(g[f+56>>2]);q=ea(g[j>>2]);r=ea(g[j+4>>2]);s=ea(g[j+8>>2]);t=ea(g[j+12>>2]);g[k>>2]=q;g[k+4>>2]=r;g[k+8>>2]=s;g[k+12>>2]=t;g[k+16>>2]=n;g[k+20>>2]=o;g[k+24>>2]=p;In[m&4095](d,k);k=(b[e+4>>1]|0)==5?e:0;if(!k){i=h;return}if(!(mo[c[(c[k>>2]|0)+28>>2]&4095](k)|0)){i=h;return}In[c[(c[k>>2]|0)+200>>2]&4095](l,k);if(a[l>>0]&1){i=h;return}ko[c[(c[k>>2]|0)+284>>2]&4095](k);i=h;return}function jEd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=0;f=i;i=i+16|0;h=f+4|0;j=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];bUb(b,h,e);c[b>>2]=667152;c[b+28>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+32>>2]=0;a[b+36>>0]=0;a[b+37>>0]=1;if(!(aGd()|0)){k=ea(0.0);l=b+52|0;g[l>>2]=k;i=f;return}k=ea(TFd(nFd()|0));l=b+52|0;g[l>>2]=k;i=f;return}function kEd(a){a=a|0;return}function lEd(b,e){b=b|0;e=e|0;var f=0,g=0;f=i;g=b+37|0;if((d[g>>0]|0|0)==(e&1|0)){i=f;return}a[g>>0]=e&1;ko[c[(c[b>>2]|0)+144>>2]&4095](b);ko[c[(c[b>>2]|0)+152>>2]&4095](b);i=f;return}function mEd(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+24>>2]|0;if(!f){i=e;return}if(!(vTb(f)|0)){i=e;return}if(!(a[b+37>>0]|0)){i=e;return}In[c[(c[b>>2]|0)+136>>2]&4095](b,d);i=e;return}function nEd(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+32>>2]|0;if(!d){e=0;i=b;return e|0}e=c[(mo[c[(c[d>>2]|0)+64>>2]&4095](d)|0)+8>>2]|0;i=b;return e|0}function oEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;ko[c[(c[a>>2]|0)+144>>2]&4095](a);d=c[a+40>>2]|0;e=a+44|0;if((d|0)==(c[e>>2]|0)){i=b;return}else f=d;do{d=c[f>>2]|0;if((d|0)!=(a|0)){g=c[d+40>>2]|0;h=d+44|0;d=c[h>>2]|0;j=d;k=g;l=j-k>>2;if(!l)m=g;else{n=g;o=l;while(1){l=(o|0)/2|0;if((c[n+(l<<2)>>2]|0)>>>0<a>>>0){p=n+(l+1<<2)|0;q=o+-1-l|0}else{p=n;q=l}if(!q){m=p;break}else{n=p;o=q}}}if(((m|0)!=(d|0)?(c[m>>2]|0)>>>0<=a>>>0:0)?(o=m-k>>2,n=g+(o+1<<2)|0,l=j-n|0,aFi(g+(o<<2)|0,n|0,l|0)|0,n=g+((l>>2)+o<<2)|0,o=c[h>>2]|0,(o|0)!=(n|0)):0)c[h>>2]=o+(~((o+-4-n|0)>>>2)<<2)}f=f+4|0}while((f|0)!=(c[e>>2]|0));i=b;return}function pEd(b){b=b|0;var d=0,e=0;d=i;if((((c[b+32>>2]|0)==0?(e=c[b+24>>2]|0,(e|0)!=0):0)?vTb(e)|0:0)?(a[b+37>>0]|0)!=0:0)In[c[(c[b>>2]|0)+136>>2]&4095](b,0);i=d;return}function qEd(b,d){b=b|0;d=d|0;var e=0,f=0;d=i;i=i+16|0;e=d;f=c[b+24>>2]|0;if(((f|0)!=0?vTb(f)|0:0)?(a[b+37>>0]|0)!=0:0){f=b+32|0;if(c[f>>2]|0){if(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0){c[e>>2]=c[b+28>>2];rEd(b,e)}In[c[(c[b>>2]|0)+120>>2]&4095](b,(a[b+36>>0]|0)!=0)}ko[c[(c[b>>2]|0)+152>>2]&4095](b);e=c[f>>2]|0;if(!e){i=d;return}f=c[(mo[c[(c[e>>2]|0)+64>>2]&4095](e)|0)+8>>2]|0;if(!f){i=d;return}EHd(f);i=d;return}ko[c[(c[b>>2]|0)+144>>2]&4095](b);i=d;return}function rEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+16|0;j=e+4|0;k=e;if(!(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0)){_ri(j,667504,GQb(b)|0);yO(h,j,3672776);if(!b)l=0;else l=c[b+4>>2]|0;if(!(a[h>>0]&1))m=h+1|0;else m=c[h+8>>2]|0;Krd(m,0,3653512,628,1,l,0,0);xri(h);xri(j)}j=b+28|0;h=c[j>>2]|0;l=c[d>>2]|0;if((h|0)==(l|0))n=h;else{c[j>>2]=l;n=l}l=b+32|0;if(!(c[l>>2]|0)){i=e;return}do if(n){c[g>>2]=n;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(f,b,g);h=c[f>>2]|0;d=c[b+28>>2]|0;if((h|0)==-1){o=d+(c[b+32>>2]<<3)|0;break}else{o=d+(h<<3)|0;break}}else o=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((o|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[o+4>>2]|0,(b|0)!=0):0)p=b;else q=20}else q=20;if((q|0)==20){b=hQb(c[j>>2]|0)|0;if(!b){q=21;break}else p=b}b=c[p+68>>2]|0;c[k>>2]=b;if(!b)q=23}else q=21;while(0);if((q|0)==21){c[k>>2]=0;q=23}if((q|0)==23){q=DFd()|0;kn[c[(c[q>>2]|0)+152>>2]&511](q,k,1,0)|0}q=c[l>>2]|0;co[c[(c[q>>2]|0)+96>>2]&2047](q,k,1);i=e;return}function sEd(a){a=a|0;var b=0,d=0;b=i;d=c[a+32>>2]|0;if(!d){i=b;return}a=c[(mo[c[(c[d>>2]|0)+64>>2]&4095](d)|0)+8>>2]|0;if(!a){i=b;return}EHd(a);i=b;return}function tEd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+128|0;f=e+64|0;g=e;h=c[(c[a>>2]|0)+156>>2]|0;j=BTb(c[a+24>>2]|0)|0;co[h&2047](a,j,f);PGc(g,b);dMc(g,f,d);if(((c[d>>2]&2139095040|0)!=2139095040?(c[d+4>>2]&2139095040|0)!=2139095040:0)&(c[d+8>>2]&2139095040|0)!=2139095040&(c[d+16>>2]&2139095040|0)!=2139095040&(c[d+20>>2]&2139095040|0)!=2139095040&(c[d+24>>2]&2139095040|0)!=2139095040&(c[d+32>>2]&2139095040|0)!=2139095040&(c[d+36>>2]&2139095040|0)!=2139095040&(c[d+40>>2]&2139095040|0)!=2139095040&(c[d+48>>2]&2139095040|0)!=2139095040&(c[d+52>>2]&2139095040|0)!=2139095040&(c[d+56>>2]&2139095040|0)!=2139095040&(c[d+60>>2]&2139095040|0)!=2139095040){k=1;i=e;return k|0}Krd(667320,0,3653512,152,1,c[a+4>>2]|0,0,0);k=0;i=e;return k|0}function uEd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=i;i=i+32|0;d=a+16|0;e=a;rGc(d,b);oGc(e,b);uMc(c,d,e);i=a;return}function vEd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;AGc(e,a,b);oGc(f,a);uMc(c,e,f);i=d;return}function wEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;h=d;j=BTb(c[a+24>>2]|0)|0;AGc(e,j,b);oGc(f,j);g[h>>2]=ea(g[f>>2]);g[h+4>>2]=ea(g[f+4>>2]);g[h+8>>2]=ea(g[f+8>>2]);g[h+12>>2]=ea(g[f+12>>2]);g[h+16>>2]=ea(g[e>>2]);g[h+20>>2]=ea(g[e+4>>2]);g[h+24>>2]=ea(g[e+8>>2]);e=c[a+32>>2]|0;a=mo[c[(c[e>>2]|0)+64>>2]&4095](e)|0;co[c[(c[a>>2]|0)+88>>2]&2047](a,h,1);i=d;return}function xEd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0;b=i;i=i+64|0;d=b+40|0;e=b+28|0;f=b;h=BTb(c[a+24>>2]|0)|0;g[e>>2]=ea(0.0);j=e+4|0;g[j>>2]=ea(0.0);k=e+8|0;g[k>>2]=ea(0.0);MGc(h,e,d);g[f>>2]=ea(g[d>>2]);g[f+4>>2]=ea(g[d+4>>2]);g[f+8>>2]=ea(g[d+8>>2]);g[f+12>>2]=ea(g[d+12>>2]);g[f+16>>2]=ea(g[e>>2]);g[f+20>>2]=ea(g[j>>2]);g[f+24>>2]=ea(g[k>>2]);k=c[a+32>>2]|0;a=mo[c[(c[k>>2]|0)+64>>2]&4095](k)|0;co[c[(c[a>>2]|0)+88>>2]&2047](a,f,1);i=b;return}function yEd(a,b){a=a|0;b=b|0;return a|0}function zEd(e,f,h,j,k){e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im;l=i;i=i+64|0;m=l+16|0;n=l+48|0;o=l+52|0;p=l+57|0;q=l+56|0;r=l;s=l+32|0;t=l+58|0;u=l+59|0;c[o>>2]=0;v=c[e+28>>2]|0;do if(!v)w=12;else{c[n>>2]=v;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(m,x,n);y=c[m>>2]|0;z=c[x+28>>2]|0;if((y|0)==-1){A=z+(c[x+32>>2]<<3)|0;break}else{A=z+(y<<3)|0;break}}else A=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((A|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[A+4>>2]|0,(x|0)!=0):0)B=x;else w=10}else w=10;if((w|0)==10){x=hQb(v)|0;if(!x){w=12;break}else B=x}c[o>>2]=c[B+68>>2]}while(0);if((w|0)==12){w=DFd()|0;kn[c[(c[w>>2]|0)+152>>2]&511](w,o,1,0)|0}w=DFd()|0;B=mo[c[(c[w>>2]|0)+12>>2]&4095](w)|0;In[c[(c[B>>2]|0)+8>>2]&4095](B,-1);B=c[(c[h>>2]|0)+92>>2]|0;a[p>>0]=11;w=Bn[B&255](h,f,o,1,p)|0;p=e+32|0;c[p>>2]=w;c[w+8>>2]=e;In[c[(c[w>>2]|0)+136>>2]&4095](q,w);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;if(!(a[e+36>>0]|0)){if(!((h|0)==0?1:(b[h+4>>1]|0)!=5)?(w=(c[f>>2]|0)+-5|0,In[c[(c[h>>2]|0)+200>>2]&4095](t,h),!(w>>>0>1|(a[t>>0]&1)!=0)):0){t=a[q>>0]&-2;a[q>>0]=t;C=t}else{t=(d[q>>0]|1)&255;a[q>>0]=t;C=t}a[q>>0]=(C&255|2)&255&-5}else a[q>>0]=a[q>>0]&-8&255|6;C=e;c[r+4>>2]=C;c[r+12>>2]=0;if(!j){c[r+8>>2]=0;D=0}else if((j|0)==1){c[r+8>>2]=4;D=4}else if((j|0)==2){c[r+8>>2]=12;D=12}else{c[r+8>>2]=0;D=0}j=(((h|0)==0?1:(b[h+4>>1]|0)!=5)?1:2)|D;c[r+8>>2]=k?j|16:j;j=c[h+8>>2]|0;h=c[e+24>>2]|0;if(!j)E=0;else E=c[(c[j+24>>2]|0)+52>>2]|0;j=E|c[h+52>>2];if(!(j&1))F=(j&3|0)==0?0:136192;else F=138240;j=c[h+40>>2]|F;c[r>>2]=j;c[s>>2]=j;c[s+4>>2]=C;c[s+12>>2]=0;C=c[p>>2]|0;In[c[(c[C>>2]|0)+76>>2]&4095](C,r);r=c[p>>2]|0;In[c[(c[r>>2]|0)+88>>2]&4095](r,s);s=c[p>>2]|0;r=c[(c[s>>2]|0)+132>>2]|0;a[u>>0]=a[q>>0]|0;In[r&4095](s,u);u=c[p>>2]|0;Fn[c[(c[u>>2]|0)+120>>2]&255](u,ea(0.0));u=c[p>>2]|0;G=ea(g[e+52>>2]);Fn[c[(c[u>>2]|0)+112>>2]&255](u,G);u=c[p>>2]|0;if(!u){i=l;return}In[c[(c[u>>2]|0)+80>>2]&4095](m,u);u=m+8|0;e=c[u>>2]|0;c[u>>2]=k?e|16:e&-17;e=c[p>>2]|0;In[c[(c[e>>2]|0)+76>>2]&4095](e,m);i=l;return}function AEd(a,b){a=a|0;b=b|0;c[a>>2]=c[b+28>>2];return}function BEd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;f=i;i=i+144|0;h=f+120|0;j=f+56|0;k=f+28|0;l=f+137|0;m=f+136|0;n=f;o=CEd(b,e)|0;if(!o){e=DFd()|0;p=c[(c[e>>2]|0)+104>>2]|0;g[n>>2]=ea(0.0);g[n+4>>2]=ea(0.0);g[n+8>>2]=ea(0.0);g[n+12>>2]=ea(1.0);g[n+16>>2]=ea(0.0);g[n+20>>2]=ea(0.0);g[n+24>>2]=ea(0.0);q=_n[p&4095](e,n)|0;if(q){c[q+8>>2]=0;zEd(b,d,q,0,0);ko[c[(c[b>>2]|0)+164>>2]&4095](b);n=LFd()|0;In[c[(c[n>>2]|0)+44>>2]&4095](n,q);In[c[(c[b>>2]|0)+96>>2]&4095](b,c[(c[b+24>>2]|0)+52>>2]|0);i=f;return}if(!b)r=0;else r=c[b+4>>2]|0;Krd(667408,0,3653512,413,1,r,0,0);i=f;return}xHd(o,1);r=c[o+40>>2]|0;if(!r){if(!b)s=0;else s=c[b+4>>2]|0;Krd(667408,0,3653512,386,1,s,0,0);i=f;return}s=o+76|0;co[c[(c[r>>2]|0)+192>>2]&2047](r,4,((c[s>>2]|0)+-1|0)>>>0<2);q=c[s>>2]|0;zEd(b,d,r,q,(MHd(o)|0)^1);if(tEd(b,BTb(c[o+24>>2]|0)|0,j)|0){q=c[b+32>>2]|0;d=c[(c[q>>2]|0)+68>>2]|0;HMc(j,h);t=ea(g[j+48>>2]);u=ea(g[j+52>>2]);v=ea(g[j+56>>2]);w=ea(g[h>>2]);x=ea(g[h+4>>2]);y=ea(g[h+8>>2]);z=ea(g[h+12>>2]);g[k>>2]=w;g[k+4>>2]=x;g[k+8>>2]=y;g[k+12>>2]=z;g[k+16>>2]=t;g[k+20>>2]=u;g[k+24>>2]=v;In[d&4095](q,k)}if(!(a[o+69>>0]|0)){i=f;return}k=c[b+32>>2]|0;In[c[(c[k>>2]|0)+136>>2]&4095](l,k);if(!(a[l>>0]&1)){i=f;return}In[c[(c[r>>2]|0)+200>>2]&4095](m,r);if(a[m>>0]&1){i=f;return}nU(r,ea(GHd(o)),0,0)|0;i=f;return}function CEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+24|0;a=ATb(c[e>>2]|0,54)|0;if(((a|0)!=0?(f=c[a+24>>2]|0,(f|0)!=0):0)?!((a|0)==(b|0)|(vTb(f)|0)^1):0){g=a;i=d;return g|0}a=c[(BTb(c[e>>2]|0)|0)+156>>2]|0;if(!a){g=0;i=d;return g|0}else h=a;while(1){a=c[h+24>>2]|0;if((((a|0)!=0?(e=ATb(a,54)|0,(e|0)!=0):0)?(a=c[e+24>>2]|0,(a|0)!=0):0)?!((e|0)==(b|0)|(vTb(a)|0)^1):0){g=e;j=10;break}h=c[h+156>>2]|0;if(!h){g=0;j=10;break}}if((j|0)==10){i=d;return g|0}return 0}function DEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=a+32|0;a=c[f>>2]|0;if(!a){i=d;return}if(c[(mo[c[(c[a>>2]|0)+64>>2]&4095](a)|0)+8>>2]|0){i=d;return}if(!(b&1))g=(b&3|0)==0?0:136192;else g=138240;b=c[f>>2]|0;In[c[(c[b>>2]|0)+80>>2]&4095](e,b);c[e>>2]=c[e>>2]&255|g;g=c[f>>2]|0;In[c[(c[g>>2]|0)+76>>2]&4095](g,e);i=d;return}function EEd(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g+4|0;j=g+3|0;k=g+2|0;l=g+1|0;m=g;n=e+36|0;if((d[n>>0]|0)==(f&1|0)){i=g;return}a[n>>0]=f&1;n=e+32|0;e=c[n>>2]|0;if(!e){i=g;return}o=c[(c[e>>2]|0)+136>>2]|0;if(f){In[o&4095](h,e);f=(a[h>>0]&-8&255|6)&255;a[h>>0]=f;h=c[n>>2]|0;p=c[(c[h>>2]|0)+132>>2]|0;a[j>>0]=f;In[p&4095](h,j)}else{In[o&4095](k,e);e=c[n>>2]|0;o=mo[c[(c[e>>2]|0)+24>>2]&4095](e)|0;e=c[n>>2]|0;j=mo[c[(c[e>>2]|0)+64>>2]&4095](e)|0;if(!((j|0)==0?1:(b[j+4>>1]|0)!=5)?(In[c[(c[j>>2]|0)+200>>2]&4095](l,j),!((o+-5|0)>>>0>1|(a[l>>0]&1)!=0)):0){l=a[k>>0]&-2;a[k>>0]=l;q=l}else{l=(d[k>>0]|1)&255;a[k>>0]=l;q=l}l=(q&255|2)&255&-5;a[k>>0]=l;k=c[n>>2]|0;q=c[(c[k>>2]|0)+132>>2]|0;a[m>>0]=l;In[q&4095](k,m)}m=c[n>>2]|0;if(!m){i=g;return}n=c[(mo[c[(c[m>>2]|0)+64>>2]&4095](m)|0)+8>>2]|0;if(!n){i=g;return}EHd(n);i=g;return}function FEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[b+32>>2]|0;if(!f){rGc(e,BTb(c[b+24>>2]|0)|0);b=a+12|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[b+0>>2]=c[150284];c[b+4>>2]=c[150285];c[b+8>>2]=c[150286];i=d;return}else{_Ed(a,f);i=d;return}}function GEd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+32|0;a=c[d>>2]|0;if(!a){i=b;return}e=mo[c[(c[a>>2]|0)+64>>2]&4095](a)|0;if(!(c[e+8>>2]|0))ko[c[c[e>>2]>>2]&4095](e);else co[c[(c[e>>2]|0)+100>>2]&2047](e,c[d>>2]|0,1);c[d>>2]=0;i=b;return}function HEd(a){a=a|0;var b=0;b=i;if(!(c[a+32>>2]|0)){i=b;return}ko[c[(c[a>>2]|0)+144>>2]&4095](a);In[c[(c[a>>2]|0)+136>>2]&4095](a,0);i=b;return}function IEd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+32>>2]|0;if((e|0)==0|(b&32|0)==0){i=d;return}b=c[(mo[c[(c[e>>2]|0)+64>>2]&4095](e)|0)+8>>2]|0;if((CEd(a,0)|0)==(b|0)){i=d;return}ko[c[(c[a>>2]|0)+148>>2]&4095](a);i=d;return}function JEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[a+40>>2]|0;f=c[a+44>>2]|0;a=f-e>>2;if(!a)g=e;else{h=e;e=a;while(1){a=(e|0)/2|0;if((c[h+(a<<2)>>2]|0)>>>0<b>>>0){j=h+(a+1<<2)|0;k=e+-1-a|0}else{j=h;k=a}if(!k){g=j;break}else{h=j;e=k}}}if((g|0)==(f|0)){l=0;i=d;return l|0}l=(c[g>>2]|0)>>>0<=b>>>0;i=d;return l|0}function KEd(){var a=0;a=i;QTb(56,554784,1832,0);QTb(56,555384,1833,0);QTb(56,554336,1834,1e5);i=a;return}function LEd(){var a=0;a=i;QQb(56,174,175,0,176);i=a;return}function MEd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(2)|0))uUb();rri(b,667576,8);wQb(56,2,b,56,2728,1,0);xri(b);i=a;return}function NEd(a){a=a|0;return 56}function OEd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,667576,a,0);UEd(a,b);bdd(b);i=c;return}function PEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,667576,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else VEd(a,b);sdd(b);i=d;return}function QEd(a,b){a=a|0;b=b|0;var c=0;c=i;WEd(a,b);i=c;return}function REd(a,b){a=a|0;b=b|0;var c=0;c=i;XEd(a,b);i=c;return}function SEd(a,b){a=a|0;b=b|0;var c=0;c=i;YEd(a,b);i=c;return}function TEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;mTb(b,d);if(!(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0)){f=c[b>>2]|0;g=f+116|0;h=c[g>>2]|0;mo[h&4095](b)|0;i=e;return}idd(d,2048);j=b+28|0;k=c[d+12>>2]|0;l=xo[c[c[k>>2]>>2]&2047](k,c[j>>2]|0,c[d+28>>2]|0)|0;if(a[d+32>>0]|0)c[j>>2]=l;jdd(d);f=c[b>>2]|0;g=f+116|0;h=c[g>>2]|0;mo[h&4095](b)|0;i=e;return}function UEd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;hTb(a,b);if(mo[c[(c[a>>2]|0)+112>>2]&4095](a)|0){f=a+28|0;add(b,1253096,668424,f,2048);g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;add(b,792256,c[142270]|0,f,1);f=b+12|0;e=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,g,1);c[(c[c[f>>2]>>2]|0)+((c[e>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b)}if(mo[c[(c[a>>2]|0)+116>>2]&4095](a)|0){e=c[142258]|0;add(b,667592,e,a+36|0,2048);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);j=g;k=f;l=e;m=a+37|0;add(b,667608,l,m,257);n=c[k>>2]|0;o=c[n>>2]|0;p=c[j>>2]|0;q=o+(p*24|0)+12|0;c[q>>2]=1;bdd(b);fdd(b);i=d;return}else{j=b+20|0;k=b+12|0;l=c[142258]|0;m=a+37|0;add(b,667608,l,m,257);n=c[k>>2]|0;o=c[n>>2]|0;p=c[j>>2]|0;q=o+(p*24|0)+12|0;c[q>>2]=1;bdd(b);fdd(b);i=d;return}}function VEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;iTb(b,d);if(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0?(j=b+28|0,k=qdd(d,1253096,668424,h,1)|0,(k|0)!=0):0){if((k|0)<=0){k=c[h>>2]|0;if(k)_n[k&4095](j,d)|0}else eFd(j,d);sdd(d)}if(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0){j=b+36|0;k=c[142258]|0;h=qdd(d,667592,k,g,0)|0;if(!h)l=k;else{do if((h|0)<=0){m=c[g>>2]|0;if(m)_n[m&4095](j,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=n+o|0;c[m>>2]=p;if((o|0)>=0?(n+(o+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[j>>0]=a[p>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,j,1)}while(0);sdd(d);l=k}}else l=c[142258]|0;k=b+37|0;b=qdd(d,667608,l,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](k,d)|0}else{l=d+12|0;j=c[d+16>>2]|0;g=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;h=j+g|0;c[l>>2]=h;if((g|0)>=0?(j+(g+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[k>>0]=a[h>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,k,1)}while(0);sdd(d);i=e;return}function WEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;jTb(b,d);if(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0)fFd(b+28|0,d);do if(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0){f=b+36|0;g=d+12|0;h=c[g>>2]|0;j=d+20|0;if((h+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(g,f,1);k=g;l=j;m=g;break}else{a[f>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1;k=g;l=j;m=g;break}}else{g=d+12|0;k=g;l=d+20|0;m=g}while(0);g=b+37|0;b=c[k>>2]|0;if((b+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(m,g,1);Ndd(d);i=e;return}else{a[g>>0]=a[b>>0]|0;c[k>>2]=(c[k>>2]|0)+1;Ndd(d);i=e;return}}function XEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;kTb(b,d);if(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0)gFd(b+28|0,d);do if(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0){f=b+36|0;g=d+12|0;h=c[g>>2]|0;j=d+20|0;if((h+1|0)>>>0>(c[j>>2]|0)>>>0){Bid(g,f,1);k=g;l=j;m=g;break}else{a[f>>0]=a[h>>0]|0;c[g>>2]=(c[g>>2]|0)+1;k=g;l=j;m=g;break}}else{g=d+12|0;k=g;l=d+20|0;m=g}while(0);g=b+37|0;b=c[k>>2]|0;if((b+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(m,g,1);Mdd(d);i=e;return}else{a[g>>0]=a[b>>0]|0;c[k>>2]=(c[k>>2]|0)+1;Mdd(d);i=e;return}}function YEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;lTb(b,d);if(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0)hFd(b+28|0,d);do if(mo[c[(c[b>>2]|0)+116>>2]&4095](b)|0){f=b+36|0;g=d+12|0;h=c[g>>2]|0;j=d+20|0;if((h+1|0)>>>0<(c[j>>2]|0)>>>0){a[h>>0]=a[f>>0]|0;c[g>>2]=(c[g>>2]|0)+1;k=g;l=j;m=g;break}else{Gid(g,f,1);k=g;l=j;m=g;break}}else{g=d+12|0;k=g;l=d+20|0;m=g}while(0);g=b+37|0;b=c[k>>2]|0;if((b+1|0)>>>0<(c[l>>2]|0)>>>0){a[b>>0]=a[g>>0]|0;c[k>>2]=(c[k>>2]|0)+1;Tdd(d);i=e;return}else{Gid(m,g,1);Tdd(d);i=e;return}}function ZEd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;mTb(b,d);if(!(mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0)){f=c[b>>2]|0;g=f+116|0;h=c[g>>2]|0;mo[h&4095](b)|0;i=e;return}idd(d,2048);j=b+28|0;k=c[d+12>>2]|0;l=xo[c[c[k>>2]>>2]&2047](k,c[j>>2]|0,c[d+28>>2]|0)|0;if(a[d+32>>0]|0)c[j>>2]=l;jdd(d);f=c[b>>2]|0;g=f+116|0;h=c[g>>2]|0;mo[h&4095](b)|0;i=e;return}function _Ed(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;d=i;i=i+160|0;e=d+124|0;f=d+96|0;h=d+56|0;j=d+24|0;k=d;l=mo[c[(c[b>>2]|0)+64>>2]&4095](b)|0;In[c[(c[b>>2]|0)+32>>2]&4095](h,b);In[c[(c[l>>2]|0)+84>>2]&4095](e,l);In[c[(c[b>>2]|0)+72>>2]&4095](f,b);m=ea(ea(g[f+16>>2])*ea(2.0));n=ea(ea(g[f+20>>2])*ea(2.0));o=ea(ea(g[f+24>>2])*ea(2.0));p=ea(g[e+12>>2]);q=ea(ea(p*p)+ea(-.5));r=ea(g[e>>2]);s=ea(m*r);t=ea(g[e+4>>2]);u=ea(s+ea(n*t));s=ea(g[e+8>>2]);v=ea(u+ea(o*s));u=ea(ea(r*v)+ea(ea(m*q)+ea(p*ea(ea(o*t)-ea(n*s)))));w=ea(ea(t*v)+ea(ea(n*q)+ea(p*ea(ea(m*s)-ea(o*r)))));x=ea(ea(ea(o*q)+ea(p*ea(ea(n*r)-ea(m*t))))+ea(s*v));v=ea(ea(g[e+16>>2])+u);u=ea(ea(g[e+20>>2])+w);w=ea(ea(g[e+24>>2])+x);x=ea(g[f>>2]);m=ea(p*x);n=ea(g[f+12>>2]);q=ea(m+ea(r*n));m=ea(g[f+8>>2]);o=ea(q+ea(t*m));q=ea(g[f+4>>2]);y=ea(ea(ea(s*x)+ea(ea(t*n)+ea(p*q)))-ea(r*m));z=ea(ea(ea(r*q)+ea(ea(s*n)+ea(p*m)))-ea(t*x));A=ea(ea(ea(ea(p*n)-ea(r*x))-ea(t*q))-ea(s*m));g[j>>2]=ea(o-ea(s*q));g[j+4>>2]=y;g[j+8>>2]=z;g[j+12>>2]=A;g[j+16>>2]=v;g[j+20>>2]=u;g[j+24>>2]=w;ALa(k,h,j,ea(1.00999999));c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;w=ea(g[k+12>>2]);u=ea(g[k>>2]);v=ea(w-u);A=ea(g[k+16>>2]);z=ea(g[k+4>>2]);y=ea(A-z);q=ea(g[k+20>>2]);s=ea(g[k+8>>2]);o=ea(y*ea(.5));y=ea(ea(q-s)*ea(.5));m=ea(ea(w+u)*ea(.5));u=ea(ea(A+z)*ea(.5));z=ea(ea(q+s)*ea(.5));g[a+12>>2]=ea(v*ea(.5));g[a+16>>2]=o;g[a+20>>2]=y;g[a>>2]=m;g[a+4>>2]=u;g[a+8>>2]=z;i=d;return}function $Ed(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+32|0;b=d+16|0;e=d;f=a+32|0;g=c[f>>2]|0;if(!g){i=d;return}In[c[(c[g>>2]|0)+80>>2]&4095](b,g);g=c[f>>2]|0;In[c[(c[g>>2]|0)+92>>2]&4095](e,g);g=c[(c[a+24>>2]|0)+40>>2]|c[b>>2]&-256;c[b>>2]=g;h=a;c[b+4>>2]=h;c[b+12>>2]=0;c[e>>2]=g;c[e+4>>2]=h;c[e+12>>2]=0;h=c[f>>2]|0;In[c[(c[h>>2]|0)+76>>2]&4095](h,b);b=c[f>>2]|0;In[c[(c[b>>2]|0)+88>>2]&4095](b,e);i=d;return}function aFd(b,d,e){b=b|0;d=d|0;e=e|0;e=i;d=c[b+24>>2]|0;if(((d|0)!=0?vTb(d)|0:0)?(a[b+37>>0]|0)!=0:0)In[c[(c[b>>2]|0)+136>>2]&4095](b,0);i=e;return}function bFd(a,b,d){a=a|0;b=b|0;d=d|0;b=i;In[c[(c[a>>2]|0)+160>>2]&4095](a,c[d+4>>2]|0);i=b;return}function cFd(){return}function dFd(a,b){a=a|0;b=b|0;return 0}function eFd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function fFd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function gFd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function hFd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function iFd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=667152;d=c[a+40>>2]|0;if(!d){WUb(a);ACi(a);i=b;return}e=a+44|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d);WUb(a);ACi(a);i=b;return}function jFd(a,b){a=a|0;b=b|0;c[a>>2]=c[b+60>>2];return}function kFd(a){a=a|0;var b=0,d=0,e=0,f=0,h=Im,j=Im;b=i;i=i+16|0;d=b;e=DFd()|0;kn[c[(c[e>>2]|0)+152>>2]&511](e,d,1,0)|0;e=c[d>>2]|0;if(!e){d=c[a+68>>2]|0;if(!d){i=b;return}else f=d}else f=e;h=ea(g[a+48>>2]);Fn[c[(c[f>>2]|0)+28>>2]&255](f,h);h=ea(g[a+52>>2]);Fn[c[(c[f>>2]|0)+36>>2]&255](f,h);h=ea(g[a+56>>2]);if(h<ea(0.0))j=ea(0.0);else{e=h>ea(1.0);j=e?ea(1.0):h}Fn[c[(c[f>>2]|0)+44>>2]&255](f,j);In[c[(c[f>>2]|0)+64>>2]&4095](f,c[a+40>>2]|0);In[c[(c[f>>2]|0)+72>>2]&4095](f,c[a+44>>2]|0);i=b;return}function lFd(a){a=a|0;var b=0,d=0;b=i;d=a+68|0;a=c[d>>2]|0;if(!a){i=b;return}ko[c[c[a>>2]>>2]&4095](a);c[d>>2]=0;i=b;return}function mFd(a,d,e,f,g,h,j,k){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=i;j=c[e>>2]|0;l=c[g>>2]|0;m=oFd(rVb(9)|0,j&255,l&255)|0;n=yEd(c[e+4>>2]|0,c[e+12>>2]|0)|0;o=yEd(c[g+4>>2]|0,c[g+12>>2]|0)|0;if((n|0)!=0&(o|0)!=0)p=JEd(n,o)|0;else p=0;o=c[e+8>>2]|0;if((o&16|0)==0?(e=c[g+8>>2]|0,!(m|p|(e&16|0)!=0)):0){p=(l|j)>>>8;b[h>>1]=p;if(!((f|d)&32))q=p|1025;else q=p&65515|20;b[h>>1]=(((e>>>2&o|e&o>>>2)&16371|0)==0?0:2049)|q&65535;b[a>>1]=0;i=k;return}b[a>>1]=2;i=k;return}function nFd(){var a=0,b=0;a=i;b=rVb(9)|0;i=a;return b|0}function oFd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=f+4|0;if(!((e|d|0)<0|(d|0)>31|(e|0)>31)){j=(c[(c[b+672>>2]|0)+(d<<2)>>2]&1<<e|0)==0;i=f;return j|0}c[g>>2]=31;Lsd(h,668208,g);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;Krd(k,0,3653512,2073,1,0,0,0);xri(h);j=0;i=f;return j|0}function pFd(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+8>>2]&4095](a);ko[c[(c[a>>2]|0)+28>>2]&4095](a);i=b;return}function qFd(b){b=ea(b);var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+192|0;e=d+32|0;f=d+132|0;g=d+136|0;h=d+168|0;j=d+16|0;k=d;l=d+120|0;m=c[166946]|0;n=c[166944]|0;o=m-n>>2;if(!o){p=n;q=m}else{m=k+8|0;r=j+8|0;s=h+8|0;t=n;n=0;while(1){u=c[t+(n<<2)>>2]|0;v=(c[166951]|0)+(u>>>5<<2)|0;w=c[v>>2]|0;x=1<<(u&31);if(!(w&x))y=t;else{c[v>>2]=w&~x;x=c[(c[166932]|0)+(u<<2)>>2]|0;w=c[x+104>>2]|0;v=mo[c[(c[w>>2]|0)+104>>2]&4095](w)|0;z=v>>>3;A=z<<3;B=v-A|0;if(z){C=(u<<16)+65536|0;D=0;do{kn[c[(c[w>>2]|0)+108>>2]&511](w,g,8,D<<3)|0;E=0;do{F=g+(E<<2)|0;G=c[F>>2]|0;In[c[(c[G>>2]|0)+92>>2]&4095](h,G);c[s>>2]=c[s>>2]&65535|C;G=c[F>>2]|0;In[c[(c[G>>2]|0)+88>>2]&4095](G,h);E=E+1|0}while((E|0)!=8);D=D+1|0}while(D>>>0<z>>>0)}if((v|0)!=(A|0)){kn[c[(c[w>>2]|0)+108>>2]&511](w,g,B,A)|0;z=(u<<16)+65536|0;D=0;do{C=g+(D<<2)|0;E=c[C>>2]|0;In[c[(c[E>>2]|0)+92>>2]&4095](j,E);c[r>>2]=c[r>>2]&65535|z;E=c[C>>2]|0;In[c[(c[E>>2]|0)+88>>2]&4095](E,j);D=D+1|0}while(D>>>0<B>>>0)}B=x+8|0;D=c[x+48>>2]|0;if(D){z=(u<<16)+65536|0;A=0;do{w=ZEa(B,A)|0;c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];c[k+8>>2]=c[w+8>>2];c[k+12>>2]=c[w+12>>2];c[m>>2]=c[m>>2]&65535|z;GEa(B,A,k);A=A+1|0}while((A|0)!=(D|0))}y=c[166944]|0}n=n+1|0;if((n|0)==(o|0)){H=y;break}else t=y}p=H;q=c[166946]|0}if((q|0)!=(p|0))c[166946]=q+(~((q+-4-p|0)>>>2)<<2);if(c[166952]|0)PEi(c[166951]|0,0,c[166953]<<2|0)|0;p=c[166954]|0;if((c[p+20>>2]|0)>>>0<0){c[f>>2]=c[153098];c[e+0>>2]=c[f+0>>2];eOb(p,e);p=c[166956]|0;ko[c[(c[p>>2]|0)+32>>2]&4095](p);p=32|0;q=(p*80|0)+24|0;c[f>>2]=c[153098];c[e+0>>2]=c[f+0>>2];f=cOb(q+(p<<6)|0,16,e,0,3653512,209)|0;H=f+8|0;c[H>>2]=203;y=f+12|0;c[y>>2]=0;t=f+16|0;c[t>>2]=0;c[f>>2]=f+24;o=f+4|0;c[o>>2]=f+q;q=f+20|0;c[q>>2]=p;c[166954]=f;p=c[166958]|0;n=c[q>>2]|0;q=e+72|0;k=e+36|0;m=k+36|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(m|0));c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;a[e+32>>0]=0;c[q>>2]=n;c[e+76>>2]=0;c[e+80>>2]=0;a[e+84>>0]=1;c[e+36>>2]=c[f>>2];c[e+40>>2]=c[o>>2];c[e+60>>2]=n;c[e+8>>2]=c[H>>2];c[e+16>>2]=c[y>>2];c[e+20>>2]=c[t>>2];c[166956]=_n[c[(c[p>>2]|0)+328>>2]&4095](p,e)|0}e=c[166932]|0;p=(c[166934]|0)-e>>2;if(!p){i=d;return}t=c[166954]|0;DEa(c[166956]|0,p,e,c[t+20>>2]|0,c[t>>2]|0,0);t=c[166938]|0;y=c[166958]|0;In[c[(c[y>>2]|0)+252>>2]&4095](l,y);AEa(b,l,c[166960]|0,p,e,t,0);i=d;return}function rFd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+16|0;g=f;if(!e){i=f;return}h=b+68|0;j=b+72|0;k=b+64|0;l=b+784|0;m=b+784|0;n=b+780|0;o=b+788|0;b=0;do{p=d+(b*24|0)|0;do if(a[d+(b*24|0)+20>>0]&3){q=c[p>>2]|0;r=c[d+(b*24|0)+8>>2]|0;s=c[l>>2]|0;if(s){t=m;u=s;a:while(1){v=u;while(1){w=c[v+16>>2]|0;if(w>>>0>=q>>>0){if(q>>>0<w>>>0){x=v;break}if((c[v+20>>2]|0)>>>0>=r>>>0){x=v;break}}v=c[v+4>>2]|0;if(!v){y=t;break a}}u=c[x>>2]|0;if(!u){y=x;break}else t=x}if((y|0)!=(m|0)?(t=c[y+16>>2]|0,q>>>0>=t>>>0):0){if(t>>>0>=q>>>0?r>>>0<(c[y+20>>2]|0)>>>0:0)break;t=c[y+4>>2]|0;if(!t){u=y;while(1){v=c[u+8>>2]|0;if((c[v>>2]|0)==(u|0)){z=v;break}else u=v}}else{u=t;while(1){r=c[u>>2]|0;if(!r){z=u;break}else u=r}}if((c[n>>2]|0)==(y|0))c[n>>2]=z;c[o>>2]=(c[o>>2]|0)+-1;tYb(s,y);ACi(y)}}}else{u=c[(c[p>>2]|0)+8>>2]|0;t=c[(c[d+(b*24|0)+8>>2]|0)+8>>2]|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;r=c[h>>2]|0;if((r|0)==(c[j>>2]|0)){mGd(k,g);A=c[h>>2]|0}else{if(!r)B=0;else{c[r+0>>2]=c[g+0>>2];c[r+4>>2]=c[g+4>>2];c[r+8>>2]=c[g+8>>2];B=c[h>>2]|0}r=B+12|0;c[h>>2]=r;A=r}c[A+-8>>2]=u;c[A+-4>>2]=t;c[A+-12>>2]=c[d+(b*24|0)+16>>2]}while(0);b=b+1|0}while((b|0)!=(e|0));i=f;return}function sFd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;rFd(a+-24|0,b,c);i=d;return}function tFd(a,d,f,h){a=a|0;d=d|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im;j=i;i=i+896|0;k=j+876|0;l=j+864|0;m=j+792|0;n=j+24|0;o=j;if(b[d+14>>1]&3){i=j;return}p=c[d>>2]|0;q=c[p+8>>2]|0;r=c[d+4>>2]|0;d=c[r+8>>2]|0;if(!h){i=j;return}s=m+60|0;t=m+64|0;u=m+68|0;v=a+80|0;w=a+84|0;x=a+76|0;a=m+60|0;y=p+4|0;z=r+4|0;A=l+4|0;B=l+8|0;C=k+4|0;D=k+8|0;E=o+12|0;F=0;do{G=f+(F<<5)|0;H=f+(F<<5)+20|0;if(!(b[H>>1]&3)){I=c[G>>2]|0;if(!I)J=0;else J=c[I+8>>2]|0;I=c[f+(F<<5)+4>>2]|0;if(!I)K=0;else K=c[I+8>>2]|0;I=m+0|0;L=I+68|0;do{c[I>>2]=0;I=I+4|0}while((I|0)<(L|0));c[s>>2]=s;c[t>>2]=s;c[u>>2]=0;M=c[v>>2]|0;if((M|0)==(c[w>>2]|0))nGd(x,m);else{if(M){I=M+0|0;N=m+0|0;L=I+60|0;do{c[I>>2]=c[N>>2];I=I+4|0;N=N+4|0}while((I|0)<(L|0));N=M+60|0;c[N>>2]=N;c[M+64>>2]=N;I=M+68|0;c[I>>2]=0;L=c[t>>2]|0;if((L|0)!=(s|0)){O=L;L=N;P=0;do{Q=L;L=xCi(40)|0;R=O+8|0;S=L+8|0;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];c[S+24>>2]=c[R+24>>2];c[S+28>>2]=c[R+28>>2];c[L+4>>2]=N;c[L>>2]=Q;c[Q+4>>2]=L;c[N>>2]=L;P=P+1|0;c[I>>2]=P;O=c[O+4>>2]|0}while((O|0)!=(s|0))}}c[v>>2]=(c[v>>2]|0)+72}if((c[u>>2]|0)!=0?(O=c[t>>2]|0,P=(c[a>>2]|0)+4|0,I=c[O>>2]|0,c[I+4>>2]=c[P>>2],c[c[P>>2]>>2]=I,c[u>>2]=0,(O|0)!=(a|0)):0){I=O;do{O=I;I=c[I+4>>2]|0;ACi(O)}while((I|0)!=(a|0))}I=c[v>>2]|0;c[I+-64>>2]=q;c[I+-60>>2]=d;c[I+-56>>2]=J;c[I+-52>>2]=K;c[I+-72>>2]=e[f+(F<<5)+22>>1];if((b[f+(F<<5)+16>>1]|0)!=0?(O=e[H>>1]|0,P=I+-12|0,L=(O&1|0)!=0?0:J,N=(O&2|0)!=0?0:K,M=oGd(G,n,16)|0,(M|0)!=0):0){Q=I+-4|0;if(!(O&32)){O=0;do{c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;R=n+(O*48|0)|0;c[o+0>>2]=c[R+0>>2];c[o+4>>2]=c[R+4>>2];c[o+8>>2]=c[R+8>>2];R=n+(O*48|0)+16|0;c[E+0>>2]=c[R+0>>2];c[E+4>>2]=c[R+4>>2];c[E+8>>2]=c[R+8>>2];R=xCi(40)|0;c[R+8>>2]=L;c[R+12>>2]=N;S=R+16|0;c[S+0>>2]=c[o+0>>2];c[S+4>>2]=c[o+4>>2];c[S+8>>2]=c[o+8>>2];c[S+12>>2]=c[o+12>>2];c[S+16>>2]=c[o+16>>2];c[S+20>>2]=c[o+20>>2];c[R+4>>2]=P;S=c[P>>2]|0;c[R>>2]=S;c[S+4>>2]=R;c[P>>2]=R;c[Q>>2]=(c[Q>>2]|0)+1;O=O+1|0}while((O|0)!=(M|0));T=ea(0.0);U=ea(0.0);V=ea(0.0)}else{W=ea(0.0);X=ea(0.0);Y=ea(0.0);O=0;while(1){c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;G=n+(O*48|0)|0;c[o+0>>2]=c[G+0>>2];c[o+4>>2]=c[G+4>>2];c[o+8>>2]=c[G+8>>2];G=n+(O*48|0)+16|0;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];G=xCi(40)|0;c[G+8>>2]=L;c[G+12>>2]=N;H=G+16|0;c[H+0>>2]=c[o+0>>2];c[H+4>>2]=c[o+4>>2];c[H+8>>2]=c[o+8>>2];c[H+12>>2]=c[o+12>>2];c[H+16>>2]=c[o+16>>2];c[H+20>>2]=c[o+20>>2];c[G+4>>2]=P;H=c[P>>2]|0;c[G>>2]=H;c[H+4>>2]=G;c[P>>2]=G;c[Q>>2]=(c[Q>>2]|0)+1;Z=ea(W+ea(g[n+(O*48|0)+32>>2]));_=ea(X+ea(g[n+(O*48|0)+36>>2]));$=ea(Y+ea(g[n+(O*48|0)+40>>2]));O=O+1|0;if((O|0)==(M|0)){T=Z;U=_;V=$;break}else{W=Z;X=_;Y=$}}}}else{T=ea(0.0);U=ea(0.0);V=ea(0.0)}g[I+-48>>2]=T;g[I+-44>>2]=U;g[I+-40>>2]=V;g[I+-36>>2]=ea(0.0);g[I+-32>>2]=ea(0.0);g[I+-28>>2]=ea(0.0);M=(b[y>>1]|0)==5?p:0;if(!M){aa=ea(0.0);ba=ea(0.0);ca=ea(0.0)}else{In[c[(c[M>>2]|0)+152>>2]&4095](k,M);Y=ea(g[k>>2]);X=ea(g[C>>2]);aa=Y;ba=X;ca=ea(g[D>>2])}M=(b[z>>1]|0)==5?r:0;if(!M){da=ea(0.0);fa=ea(0.0);ga=ea(0.0)}else{In[c[(c[M>>2]|0)+152>>2]&4095](l,M);X=ea(g[l>>2]);Y=ea(g[A>>2]);da=X;fa=Y;ga=ea(g[B>>2])}Y=ea(ba-fa);X=ea(ca-ga);g[I+-24>>2]=ea(aa-da);g[I+-20>>2]=Y;g[I+-16>>2]=X}F=F+1|0}while(F>>>0<h>>>0);i=j;return}function uFd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;tFd(a+-24|0,b,c,d);i=e;return}function vFd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;if(!d){i=e;return}g=f+8|0;h=f+8|0;j=f+4|0;k=a+92|0;l=a+96|0;m=a+88|0;a=0;do{c[g>>2]=0;n=c[(c[b+(a*12|0)+4>>2]|0)+8>>2]|0;if(!n)o=0;else o=c[n+4>>2]|0;c[h>>2]=o;do if(pGd(h)|0){n=c[b+(a*12|0)>>2]|0;co[c[(c[n>>2]|0)+60>>2]&2047](n,f,j);n=c[k>>2]|0;if((n|0)==(c[l>>2]|0)){qGd(m,f);break}if(!n)p=0;else{q=f;r=c[q+4>>2]|0;s=n;c[s>>2]=c[q>>2];c[s+4>>2]=r;c[n+8>>2]=c[g>>2];p=c[k>>2]|0}c[k>>2]=p+12}while(0);a=a+1|0}while((a|0)!=(d|0));i=e;return}function wFd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=a+-24|0;if(!d){i=e;return}a=f+8|0;h=f+8|0;j=f+4|0;k=g+92|0;l=g+96|0;m=g+88|0;g=0;do{c[a>>2]=0;n=c[(c[b+(g*12|0)+4>>2]|0)+8>>2]|0;if(!n)o=0;else o=c[n+4>>2]|0;c[h>>2]=o;do if(pGd(h)|0){n=c[b+(g*12|0)>>2]|0;co[c[(c[n>>2]|0)+60>>2]&2047](n,f,j);n=c[k>>2]|0;if((n|0)==(c[l>>2]|0)){qGd(m,f);break}if(!n)p=0;else{q=f;r=c[q+4>>2]|0;s=n;c[s>>2]=c[q>>2];c[s+4>>2]=r;c[n+8>>2]=c[a>>2];p=c[k>>2]|0}c[k>>2]=p+12}while(0);g=g+1|0}while((g|0)!=(d|0));i=e;return}function xFd(a,b,c){a=a|0;b=b|0;c=c|0;return}function yFd(a,b,c){a=a|0;b=b|0;c=c|0;return}function zFd(a,b,c){a=a|0;b=b|0;c=c|0;return}function AFd(a,b,c){a=a|0;b=b|0;c=c|0;return}function BFd(){var b=0,d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0;b=i;i=i+64|0;d=b+44|0;e=b;Ydd(668248,667848,667872);THd();f=oKa(50528512,667712,667704)|0;c[166974]=f;if(!f){Krd(667904,0,3653512,772,32785,0,0,0);h=c[166974]|0}else h=f;g[d>>2]=ea(1.0);g[d+4>>2]=ea(1.0e3);g[d+8>>2]=ea(10.0);f=RZ(50528512,h,d,0,0)|0;if(!f){c[166982]=0;Krd(667904,0,3653512,787,32785,0,0,0);j=c[166982]|0}else{SZ(f);TZ(f);UZ(f);VZ(f);c[166982]=f;j=f}if(!(jU(j)|0))Krd(667936,0,3653512,790,32785,0,0,0);k=ea(g[d>>2]);g[e+4>>2]=ea(k*ea(.0250000004));g[e+8>>2]=ea(k*ea(k*ea(.0599999987)));a[e+12>>0]=0;a[e+13>>0]=0;j=e+16|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[e+28>>2]=0;c[e+32>>2]=0;g[e+36>>2]=ea(0.0);g[e+40>>2]=ea(.550000012);c[e>>2]=0;c[166992]=fIa(50528512,c[166974]|0,e)|0;ADa(c[166982]|0,0)|0;CFd(0);WDd();c[141966]=177;c[141968]=178;c[141970]=179;c[141972]=180;c[141974]=181;e=kbc()|0;d=0;while(1){j=e+(d<<2)+128|0;d=d+1|0;if(!(c[j>>2]|0)){l=j;break}if((d|0)>=16){m=12;break}}if((m|0)==12){i=b;return}c[l>>2]=182;i=b;return}function CFd(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0;e=i;i=i+288|0;f=e+192|0;h=e+184|0;j=e+24|0;k=e+8|0;l=e+4|0;m=e;n=c[166982]|0;o=mo[c[(c[n>>2]|0)+32>>2]&4095](n)|0;n=j+80|0;p=j+0|0;q=p+80|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));r=ea(g[o>>2]);g[n>>2]=ea(r*ea(.00999999977));c[j+84>>2]=0;g[j+88>>2]=ea(r*ea(.0250000004));g[j+92>>2]=ea(ea(g[o+8>>2])*ea(.200000003));g[j+96>>2]=ea(r*ea(.0399999991));c[j+108>>2]=0;c[j+112>>2]=0;c[j+116>>2]=1;c[j+120>>2]=1;c[j+124>>2]=100;c[j+128>>2]=0;c[j+132>>2]=128;c[j+136>>2]=0;c[j+140>>2]=65536;c[j+144>>2]=8192;c[j+148>>2]=1;c[j+152>>2]=0;g[j+156>>2]=ea(.399999976);g[j>>2]=ea(0.0);g[j+4>>2]=ea(-9.81000041);g[j+8>>2]=ea(0.0);c[j+104>>2]=667720;c[j+32>>2]=24;b[j+100>>1]=d?20:4;d=c[166982]|0;c[166958]=_n[c[(c[d>>2]|0)+92>>2]&4095](d,j)|0;YDd();j=c[166958]|0;d=c[(c[j>>2]|0)+248>>2]|0;g[k>>2]=ea(0.0);g[k+4>>2]=ea(-9.81000041);g[k+8>>2]=ea(0.0);In[d&4095](j,k);c[166994]=0;k=c[166906]|0;if(!k){j=c[166982]|0;c[166906]=un[c[(c[j>>2]|0)+144>>2]&1](j,ea(1.0),ea(1.0),ea(.00999999977))|0}else{Fn[c[(c[k>>2]|0)+36>>2]&255](k,ea(1.0));k=c[166906]|0;Fn[c[(c[k>>2]|0)+28>>2]&255](k,ea(1.0));k=c[166906]|0;Fn[c[(c[k>>2]|0)+44>>2]&255](k,ea(.00999999977))}if(!(c[166908]|0)){k=c[166982]|0;j=un[c[(c[k>>2]|0)+144>>2]&1](k,ea(0.0),ea(0.0),ea(1.0))|0;c[166908]=j;co[c[(c[j>>2]|0)+52>>2]&2047](j,1,1)}else{j=c[166906]|0;Fn[c[(c[j>>2]|0)+36>>2]&255](j,ea(0.0));j=c[166906]|0;Fn[c[(c[j>>2]|0)+28>>2]&255](j,ea(0.0));j=c[166906]|0;Fn[c[(c[j>>2]|0)+44>>2]&255](j,ea(1.0));j=c[166908]|0;co[c[(c[j>>2]|0)+52>>2]&2047](j,1,1)}j=c[166932]|0;k=j;if((c[166936]|0)-k>>2>>>0<256?(d=(c[166934]|0)-k|0,k=xCi(1024)|0,YEi(k|0,j|0,d|0)|0,c[166932]=k,c[166934]=k+(d>>2<<2),c[166936]=k+1024,(j|0)!=0):0)ACi(j);j=c[166938]|0;k=j;if((c[166942]|0)-k>>3>>>0<256?(d=(c[166940]|0)-k|0,k=xCi(2048)|0,YEi(k|0,j|0,d|0)|0,c[166938]=k,c[166940]=k+(d>>3<<3),c[166942]=k+2048,(j|0)!=0):0)ACi(j);j=c[166944]|0;k=j;if((c[166948]|0)-k>>2>>>0<256?(d=(c[166946]|0)-k|0,k=xCi(1024)|0,YEi(k|0,j|0,d|0)|0,c[166944]=k,c[166946]=k+(d>>2<<2),c[166948]=k+1024,(j|0)!=0):0)ACi(j);mRb(667800,256,0);c[h>>2]=c[153098];c[f+0>>2]=c[h+0>>2];h=cOb(18456,16,f,0,3653512,209)|0;j=h+8|0;c[j>>2]=203;k=h+12|0;c[k>>2]=0;d=h+16|0;c[d>>2]=0;c[h>>2]=h+24;o=h+4|0;c[o>>2]=h+10264;n=h+20|0;c[n>>2]=128;c[166954]=h;s=c[166958]|0;t=c[n>>2]|0;n=f+72|0;p=f+36|0;q=p+36|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;a[f+32>>0]=0;c[n>>2]=t;c[f+76>>2]=0;c[f+80>>2]=0;a[f+84>>0]=1;c[f+36>>2]=c[h>>2];c[f+40>>2]=c[o>>2];c[f+60>>2]=t;c[f+8>>2]=c[j>>2];c[f+16>>2]=c[k>>2];c[f+20>>2]=c[d>>2];c[166956]=_n[c[(c[s>>2]|0)+328>>2]&4095](s,f)|0;f=aEa(1,1)|0;c[166960]=f;c[l>>2]=0;c[m>>2]=0;bEa(f,1,1,l,m);i=e;return}function DFd(){return c[166982]|0}function EFd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[166954]|0;c[d>>2]=c[153098];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[166954]=0;e=c[166956]|0;ko[c[(c[e>>2]|0)+32>>2]&4095](e);c[166956]=0;cEa(c[166960]|0);c[166960]=0;e=c[166934]|0;f=c[166932]|0;if((e|0)!=(f|0)){g=f;f=e;e=0;while(1){h=c[g+(e<<2)>>2]|0;if(!h){j=f;k=g}else{sDa(h);j=c[166934]|0;k=c[166932]|0}e=e+1|0;h=k;if(e>>>0>=j-h>>2>>>0){l=k;m=j;n=h;break}else{g=k;f=j}}if((m|0)!=(l|0))c[166934]=m+(~((m+-4-n|0)>>>2)<<2)}n=c[166938]|0;m=c[166940]|0;if((m|0)!=(n|0))c[166940]=m+(~((m+-8-n|0)>>>3)<<3);n=c[166944]|0;m=c[166946]|0;if((m|0)!=(n|0))c[166946]=m+(~((m+-4-n|0)>>>2)<<2);n=c[166951]|0;if(n){c[d>>2]=c[166950];c[b+0>>2]=c[d+0>>2];eOb(n,b);c[166951]=0;c[166952]=0;c[166953]=0}b=c[166994]|0;if(!b){o=c[166958]|0;p=c[o>>2]|0;q=p+8|0;r=c[q>>2]|0;ko[r&4095](o);c[166958]=0;i=a;return}xo[c[(c[b>>2]|0)+236>>2]&2047](b,0,0)|0;b=c[166994]|0;ko[c[(c[b>>2]|0)+8>>2]&4095](b);c[166994]=0;o=c[166958]|0;p=c[o>>2]|0;q=p+8|0;r=c[q>>2]|0;ko[r&4095](o);c[166958]=0;i=a;return}function FFd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a;UHd();if(!(c[166982]|0)){i=a;return}XDd();c[b>>2]=0;d=b+4|0;c[d>>2]=0;c[b+8>>2]=0;CQb(134,b,0)|0;e=c[b>>2]|0;if((c[d>>2]|0)!=(e|0)){f=e;e=0;do{lFd(c[f+(e<<2)>>2]|0);e=e+1|0;f=c[b>>2]|0}while(e>>>0<(c[d>>2]|0)-f>>2>>>0)}f=c[166958]|0;co[c[(c[f>>2]|0)+164>>2]&2047](f,0,0);EFd();f=c[166992]|0;ko[c[c[f>>2]>>2]&4095](f);c[166992]=0;kU();BDa(0);f=c[166982]|0;ko[c[(c[f>>2]|0)+8>>2]&4095](f);c[166982]=0;f=c[166974]|0;ko[c[c[f>>2]>>2]&4095](f);c[166974]=0;f=c[b>>2]|0;if(!f){i=a;return}b=c[d>>2]|0;if((b|0)!=(f|0))c[d>>2]=b+(~((b+-4-f|0)>>>2)<<2);ACi(f);i=a;return}function GFd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;j=f+8|0;k=f+4|0;l=f;c[k>>2]=c[d>>2];c[j+0>>2]=c[k+0>>2];jSb(b,j,e);e=b+24|0;c[b>>2]=667992;c[b+24>>2]=668120;k=b+28|0;g[k>>2]=ea(0.0);d=b+32|0;g[d>>2]=ea(0.0);m=b+36|0;g[m>>2]=ea(0.0);n=b+56|0;c[n>>2]=0;o=b+104|0;c[o>>2]=0;c[b+108>>2]=0;c[b+112>>2]=0;p=b+116|0;q=b+120|0;r=b+64|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));c[p>>2]=p;c[q>>2]=p;p=b+640|0;q=b+128|0;do{c[q>>2]=q;c[q+4>>2]=q;q=q+8|0}while((q|0)!=(p|0));p=b+640|0;c[p>>2]=p;c[b+644>>2]=p;c[b+648>>2]=0;c[b+652>>2]=0;c[b+656>>2]=0;c[b+664>>2]=0;c[b+668>>2]=0;c[b+660>>2]=60;p=b+672|0;q=b+684|0;t=b+744|0;u=b+748|0;v=b+756|0;w=b+760|0;x=b+768|0;y=b+772|0;z=b+780|0;c[b+784>>2]=0;c[b+788>>2]=0;A=b+784|0;r=p+0|0;s=r+108|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));c[z>>2]=A;A=b+792|0;z=b+796|0;r=b+800|0;s=b+804|0;B=b+808|0;C=b+812|0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;c[A+20>>2]=0;a[b+52>>0]=1;a[b+53>>0]=0;g[k>>2]=ea(0.0);g[d>>2]=ea(-9.81000041);g[m>>2]=ea(0.0);g[b+48>>2]=ea(2.0);c[l>>2]=-1;xGd(p,32,l);c[b+100>>2]=6;a[b+54>>0]=1;g[b+124>>2]=ea(0.0);h[b+816>>3]=0.0;g[b+40>>2]=ea(.00499999989);g[b+44>>2]=ea(.00999999977);HFd(q,16);q=c[u>>2]|0;l=c[t>>2]|0;p=(q-l|0)/48|0;if(p>>>0>=128){if(p>>>0>128?(m=l+6144|0,(q|0)!=(m|0)):0)c[u>>2]=q+(~(((q+-48-m|0)>>>0)/48|0)*48|0)}else yGd(t,128-p|0);p=c[w>>2]|0;t=c[v>>2]|0;m=p-t>>6;if(m>>>0>=128){if(m>>>0>128?(q=t+8192|0,(p|0)!=(q|0)):0)c[w>>2]=p+(~((p+-64-q|0)>>>6)<<6)}else zGd(v,128-m|0);m=c[y>>2]|0;v=c[x>>2]|0;q=m-v>>4;if(q>>>0>=128){if(q>>>0>128?(p=v+2048|0,(m|0)!=(p|0)):0)c[y>>2]=m+(~((m+-16-p|0)>>>4)<<4)}else AGd(x,128-q|0);q=c[A>>2]|0;x=q;if((c[r>>2]|0)-x>>2>>>0<128?(p=(c[z>>2]|0)-x|0,x=xCi(512)|0,YEi(x|0,q|0,p|0)|0,c[A>>2]=x,c[z>>2]=x+(p>>2<<2),c[r>>2]=x+512,(q|0)!=0):0)ACi(q);q=c[s>>2]|0;x=q;if((((c[C>>2]|0)-x|0)/44|0)>>>0<128?(r=(c[B>>2]|0)-x|0,x=(r|0)/44|0,p=xCi(5632)|0,z=p+((((r|0)/-44|0)+x|0)*44|0)|0,YEi(z|0,q|0,r|0)|0,c[s>>2]=z,c[B>>2]=p+(x*44|0),c[C>>2]=p+5632,(q|0)!=0):0)ACi(q);if(!(c[166982]|0)){i=f;return}q=BGd(n)|0;c[b+60>>2]=q;if(!q){n=c[166982]|0;kn[c[(c[n>>2]|0)+152>>2]&511](n,j,1,0)|0;n=c[j>>2]|0;Fn[c[(c[n>>2]|0)+28>>2]&255](n,ea(.600000024));n=c[j>>2]|0;Fn[c[(c[n>>2]|0)+36>>2]&255](n,ea(.600000024));n=c[j>>2]|0;Fn[c[(c[n>>2]|0)+44>>2]&255](n,ea(0.0))}else kFd(q);q=c[166958]|0;co[c[(c[q>>2]|0)+164>>2]&2047](q,0,0);q=c[166958]|0;co[c[(c[q>>2]|0)+164>>2]&2047](q,e,0);AQb(56,o,1);a[b+824>>0]=(xQb(54)|0)!=0&1;i=f;return}function HFd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[a>>2]|0;g=f;if((c[e>>2]|0)-g>>2>>>0<b>>>0){h=a+4|0;j=(c[h>>2]|0)-g|0;if(!b)k=0;else k=xCi(b<<2)|0;YEi(k|0,f|0,j|0)|0;c[a>>2]=k;c[h>>2]=k+(j>>2<<2);c[e>>2]=k+(b<<2);if(f)ACi(f)}f=a+20|0;k=a+12|0;e=c[k>>2]|0;j=e;if((c[f>>2]|0)-j>>2>>>0<b>>>0){h=a+16|0;g=(c[h>>2]|0)-j|0;if(!b)l=0;else l=xCi(b<<2)|0;YEi(l|0,e|0,g|0)|0;c[k>>2]=l;c[h>>2]=l+(g>>2<<2);c[f>>2]=l+(b<<2);if(e)ACi(e)}EGd(a+24|0,b);e=a+44|0;l=a+36|0;f=c[l>>2]|0;g=f;if((c[e>>2]|0)-g>>4>>>0<b>>>0){h=a+40|0;k=(c[h>>2]|0)-g|0;if(!b)m=0;else m=xCi(b<<4)|0;YEi(m|0,f|0,k|0)|0;c[l>>2]=m;c[h>>2]=m+(k>>4<<4);c[e>>2]=m+(b<<4);if(f)ACi(f)}f=b*36|0;b=a+56|0;m=a+48|0;e=c[m>>2]|0;k=e;if(((c[b>>2]|0)-k|0)>>>0>=f>>>0){i=d;return}h=a+52|0;a=(c[h>>2]|0)-k|0;if(!f)n=0;else n=xCi(f)|0;YEi(n|0,e|0,a|0)|0;c[m>>2]=n;c[h>>2]=n+a;c[b>>2]=n+f;if(!e){i=d;return}ACi(e);i=d;return}function IFd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;if(!(c[166982]|0)){i=b;return}g[a+28>>2]=ea(0.0);g[a+32>>2]=ea(-9.81000041);g[a+36>>2]=ea(0.0);g[a+48>>2]=ea(2.0);e=a+672|0;c[d>>2]=-1;f=a+676|0;h=c[f>>2]|0;j=c[e>>2]|0;k=h-j>>2;if(k>>>0>=32){if(k>>>0>32?(l=j+128|0,(h|0)!=(l|0)):0)c[f>>2]=h+(~((h+-4-l|0)>>>2)<<2)}else xGd(e,32-k|0,d);c[a+100>>2]=6;d=a+780|0;CGd(d,c[a+784>>2]|0);c[a+788>>2]=0;k=a+784|0;c[d>>2]=k;c[k>>2]=0;i=b;return}function JFd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+116|0;e=a+120|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{f=g+4|0;h=g;g=c[f>>2]|0;c[h>>2]=0;c[f>>2]=0}while((g|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;d=0;do{e=a+(d<<3)+128|0;g=a+(d<<3)+132|0;f=c[g>>2]|0;if((f|0)!=(e|0)){h=f;do{f=h+4|0;j=h;h=c[f>>2]|0;c[j>>2]=0;c[f>>2]=0}while((h|0)!=(e|0))}c[g>>2]=e;c[e>>2]=e;d=d+1|0}while((d|0)!=64);d=a+640|0;h=a+644|0;f=c[h>>2]|0;if((f|0)!=(d|0)){j=f;do{f=j+4|0;k=j;j=c[f>>2]|0;c[k>>2]=0;c[f>>2]=0}while((j|0)!=(d|0))}c[h>>2]=d;c[d>>2]=d;d=c[166958]|0;co[c[(c[d>>2]|0)+164>>2]&2047](d,0,0);fSb(a);i=b;return}function KFd(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+14|0;g=e+12|0;h=e;if(!(c[166982]|0)){i=e;return}j=d+780|0;CGd(j,c[d+784>>2]|0);c[d+788>>2]=0;k=d+784|0;c[j>>2]=k;c[k>>2]=0;k=c[166958]|0;xo[c[(c[k>>2]|0)+236>>2]&2047](k,1,0)|0;k=c[166958]|0;j=c[(c[k>>2]|0)+72>>2]|0;b[f>>1]=2;if(_n[j&4095](k,f)|0){i=e;return}f=c[166958]|0;k=c[(c[f>>2]|0)+72>>2]|0;b[g>>1]=1;if(_n[k&4095](f,g)|0){i=e;return}c[h>>2]=0;g=h+4|0;c[g>>2]=0;c[h+8>>2]=0;CQb(134,h,0)|0;f=c[h>>2]|0;if((c[g>>2]|0)!=(f|0)){k=f;f=0;do{lFd(c[k+(f<<2)>>2]|0);f=f+1|0;k=c[h>>2]|0}while(f>>>0<(c[g>>2]|0)-k>>2>>>0)}k=c[166958]|0;co[c[(c[k>>2]|0)+164>>2]&2047](k,0,0);EFd();CFd((a[d+53>>0]|0)!=0);k=c[166958]|0;co[c[(c[k>>2]|0)+164>>2]&2047](k,0,0);k=c[166958]|0;co[c[(c[k>>2]|0)+164>>2]&2047](k,d+24|0,0);d=c[h>>2]|0;if((c[g>>2]|0)!=(d|0)){k=d;d=0;do{f=c[k+(d<<2)>>2]|0;In[c[(c[f>>2]|0)+12>>2]&4095](f,0);d=d+1|0;k=c[h>>2]|0}while(d>>>0<(c[g>>2]|0)-k>>2>>>0)}k=rVb(9)|0;In[c[(c[k>>2]|0)+12>>2]&4095](k,0);k=c[h>>2]|0;if(!k){i=e;return}h=c[g>>2]|0;if((h|0)!=(k|0))c[g>>2]=h+(~((h+-4-k|0)>>>2)<<2);ACi(k);i=e;return}function LFd(){return c[166958]|0}function MFd(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e+14|0;k=e;l=e+12|0;if((oVb()|0?ea(g[(jLc()|0)+104>>2])>ea(0.0):0)?(m=mo[c[(c[d>>2]|0)+388>>2]&4095](d)|0,c[166922]=1,c[166921]=0,c[166920]=m,c[166924]=d,a[667692]=0,m=c[(c[d>>2]|0)+220>>2]|0,n=ea(g[(jLc()|0)+104>>2]),Vn[m&3](d,n,667672,0,0,1),ko[c[(c[667672>>2]|0)+20>>2]&4095](667672),(a[667692]|0)==0):0)do Qnd()|0;while((a[667692]|0)==0);xo[c[(c[d>>2]|0)+236>>2]&2047](d,1,0)|0;m=c[(c[d>>2]|0)+72>>2]|0;b[j>>1]=32;o=_n[m&4095](d,j)|0;j=(o<<2)+15|0;m=(o|0)!=0;if(j>>>0<2e3)if(m){p=i;i=i+((1*j|0)+15&-16)|0;q=0;r=p}else{q=0;r=0}else if(m){c[k>>2]=c[153134];c[f+0>>2]=c[k+0>>2];k=cOb(j,16,f,0,3653512,1433)|0;q=k;r=k}else{q=0;r=0}k=r+15&-16;r=c[(c[d>>2]|0)+76>>2]|0;b[l>>1]=32;Bn[r&255](d,l,k,o,0)|0;if((o|0)>0){l=0;do{fEd(c[(c[k+(l<<2)>>2]|0)+8>>2]|0);l=l+1|0}while((l|0)<(o|0))}if(!q){i=e;return}c[h>>2]=c[153134];c[f+0>>2]=c[h+0>>2];eOb(q,f);i=e;return}function NFd(d){d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im;e=i;i=i+96|0;f=e+80|0;j=e+64|0;k=e+52|0;l=e+24|0;m=e+12|0;n=e;o=ea(g[(jLc()|0)+40>>2]);p=d+640|0;q=d+644|0;r=c[q>>2]|0;if((r|0)==(p|0))s=r;else{t=r;do{r=c[t+8>>2]|0;u=c[r+4>>2]|0;if(!u)v=0;else v=c[u+4>>2]|0;Krd(c[r>>2]|0,0,3653512,1251,1,v,0,0);t=c[t+4>>2]|0}while((t|0)!=(p|0));s=c[q>>2]|0}if((s|0)!=(p|0)){t=s;do{s=t+4|0;v=t;t=c[s>>2]|0;c[v>>2]=0;c[s>>2]=0}while((t|0)!=(p|0))}c[q>>2]=p;c[p>>2]=p;if(!(c[166982]|0)){i=e;return}p=c[d+120>>2]|0;q=d+116|0;if((p|0)!=(q|0)){t=p;do{p=c[t+36>>2]|0;c[t+40>>2]=0;if((a[p+86>>0]|0)==1){s=t+8|0;IHd(f,p);c[s+0>>2]=c[f+0>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];s=t+20|0;KHd(j,p);c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2]}t=c[t+4>>2]|0}while((t|0)!=(q|0))}qFd(o);q=c[166958]|0;t=mo[c[(c[q>>2]|0)+388>>2]&4095](q)|0;c[166914]=1;c[166913]=0;c[166912]=t;c[166916]=q;a[667660]=0;q=c[166958]|0;Vn[c[(c[q>>2]|0)+220>>2]&3](q,o,667640,0,0,1);ko[c[(c[667640>>2]|0)+20>>2]&4095](667640);if(!(a[667660]|0))do Qnd()|0;while((a[667660]|0)==0);q=c[166958]|0;xo[c[(c[q>>2]|0)+236>>2]&2047](q,1,0)|0;q=d+816|0;h[q>>3]=+o+ +h[q>>3];q=d+108|0;t=d+104|0;if((c[q>>2]|0)!=(c[t>>2]|0)){j=0;do{f=UTb()|0;s=c[t>>2]|0;p=(da(c[f+28>>2]|0,c[138586]|0)|0)+(c[s+(j<<2)>>2]|0)|0;v=(c[f+4>>2]|0)+(p>>>5<<2)|0;c[v>>2]=c[v>>2]&~(1<<(p&31));j=j+1|0}while(j>>>0<(c[q>>2]|0)-s>>2>>>0)}j=d+54|0;a[j>>0]=0;c[k+8>>2]=0;s=k+4|0;c[s>>2]=0;c[k>>2]=0;p=l+16|0;v=n+4|0;f=n+8|0;r=m+4|0;u=m+8|0;w=m;x=0;do{y=c[d+(x<<3)+132>>2]|0;z=d+(x<<3)+128|0;if((y|0)!=(z|0)){A=y;do{y=c[A+8>>2]|0;B=c[y+40>>2]|0;C=(b[B+4>>1]|0)==5?B:0;if(!(mo[c[(c[C>>2]|0)+256>>2]&4095](C)|0)){if(c[y+72>>2]|0)FHd(y);if((c[y+88>>2]&1|0)==0?(B=c[y+24>>2]|0,y=BTb(B)|0,In[c[(c[C>>2]|0)+84>>2]&4095](l,C),BGc(y,p,l),(c[B+52>>2]&32|0)!=0):0){In[c[(c[C>>2]|0)+152>>2]&4095](n,C);o=ea(g[n>>2]);D=ea(g[v>>2]);E=ea(g[f>>2]);g[m>>2]=o;g[r>>2]=D;g[u>>2]=E;c[s>>2]=w;c[k>>2]=100005;LTb(B,556344,k)}}A=c[A+4>>2]|0}while((A|0)!=(z|0))}x=x+1|0}while((x|0)!=64);if((c[q>>2]|0)!=(c[t>>2]|0)){x=0;do{k=UTb()|0;w=c[t>>2]|0;s=(da(c[k+28>>2]|0,c[138586]|0)|0)+(c[w+(x<<2)>>2]|0)|0;u=(c[k+4>>2]|0)+(s>>>5<<2)|0;c[u>>2]=1<<(s&31)|c[u>>2];x=x+1|0}while(x>>>0<(c[q>>2]|0)-w>>2>>>0)}a[j>>0]=1;RQb(1);YFd(d);ZFd(d);_Fd(d);$Fd(d);RQb(0);i=e;return}function OFd(a){a=a|0;var d=0,e=0,f=0,h=0,j=Im,k=0,l=Im,m=Im,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;h=a+124|0;j=ea(g[h>>2]);k=j==ea(0.0);l=ea(g[(jLc()|0)+104>>2]);if(k)m=l;else m=ea(ea(j*ea(.990000009))+ea(l*ea(.00999999977)));g[h>>2]=m;do if(c[166994]|0){Kcc(0,a+656|0);h=c[166994]|0;k=c[(c[h>>2]|0)+72>>2]|0;b[e>>1]=32;n=(_n[k&4095](h,e)|0)==0;h=c[166994]|0;if(n){ko[c[(c[h>>2]|0)+8>>2]&4095](h);c[166994]=0;break}else{MFd(h);break}}while(0);h=a+648|0;if(c[h>>2]|0)Gnd(h);h=a+656|0;Lcc(h);n=a+668|0;if((c[n>>2]|0)<=-1){o=a+664|0;c[o>>2]=0;c[n>>2]=0;i=d;return}k=c[h>>2]|0;c[f>>2]=c[a+660>>2];c[e+0>>2]=c[f+0>>2];eOb(k,e);c[h>>2]=0;o=a+664|0;c[o>>2]=0;c[n>>2]=0;i=d;return}function PFd(a){a=a|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im;d=i;i=i+160|0;e=d;f=c[166994]|0;if(f){h=f;i=d;return h|0}f=c[166982]|0;j=mo[c[(c[f>>2]|0)+32>>2]&4095](f)|0;f=e+80|0;k=e+0|0;l=k+80|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));m=ea(g[j>>2]);g[f>>2]=ea(m*ea(.00999999977));c[e+84>>2]=0;g[e+88>>2]=ea(m*ea(.0250000004));g[e+92>>2]=ea(ea(g[j+8>>2])*ea(.200000003));g[e+96>>2]=ea(m*ea(.0399999991));b[e+100>>1]=0;c[e+108>>2]=0;c[e+112>>2]=0;c[e+116>>2]=1;c[e+120>>2]=1;c[e+124>>2]=100;c[e+128>>2]=0;c[e+132>>2]=128;c[e+136>>2]=0;c[e+140>>2]=65536;c[e+144>>2]=8192;c[e+148>>2]=1;c[e+152>>2]=0;g[e+156>>2]=ea(.399999976);c[e+104>>2]=667720;c[e+32>>2]=25;j=c[166982]|0;f=_n[c[(c[j>>2]|0)+92>>2]&4095](j,e)|0;c[166994]=f;In[c[(c[f>>2]|0)+248>>2]&4095](f,a+28|0);h=c[166994]|0;i=d;return h|0}function QFd(b){b=b|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,U=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im;e=i;i=i+128|0;f=e+96|0;j=e+52|0;k=e+12|0;l=e+24|0;m=e+112|0;n=e;o=e+40|0;p=e+80|0;q=e+64|0;if(!(a[b+824>>0]|0)){i=e;return}r=b+108|0;s=b+104|0;if((c[r>>2]|0)!=(c[s>>2]|0)){t=0;do{u=UTb()|0;v=c[s>>2]|0;w=(da(c[u+28>>2]|0,c[138586]|0)|0)+(c[v+(t<<2)>>2]|0)|0;x=(c[u+4>>2]|0)+(w>>>5<<2)|0;c[x>>2]=c[x>>2]&~(1<<(w&31));t=t+1|0}while(t>>>0<(c[r>>2]|0)-v>>2>>>0)}t=b+54|0;a[t>>0]=0;v=UTb()|0;w=(da(c[v+28>>2]|0,c[138586]|0)|0)+54|0;x=(c[v+4>>2]|0)+(w>>>5<<2)|0;c[x>>2]=c[x>>2]&~(1<<(w&31));y=ea(+h[(jLc()|0)+88>>3]);z=ea(g[(jLc()|0)+40>>2]);A=ea(y-ea(+h[(jLc()|0)+24>>3]));y=ea(A/z);if(y<ea(0.0))B=ea(0.0);else{w=y>ea(1.0);B=w?ea(1.0):y}w=c[b+120>>2]|0;x=b+116|0;if((w|0)!=(x|0)){b=j+4|0;v=j+8|0;u=k+4|0;C=k+8|0;y=ea(ea(1.0)-B);D=o+4|0;E=o+8|0;F=n+4|0;G=n+8|0;H=p+4|0;I=p+8|0;z=ea(g[150276]);J=q+12|0;K=q+8|0;L=q+4|0;M=f+4|0;N=f+8|0;O=f+12|0;P=w;do{w=c[P+36>>2]|0;do if((c[P+40>>2]|0)==0?!(LHd(w)|0):0){Q=BTb(c[w+24>>2]|0)|0;g[j>>2]=ea(0.0);g[b>>2]=ea(0.0);g[v>>2]=ea(0.0);R=d[w+86>>0]|0;if((R|0)==1){IHd(k,w);S=ea(B*ea(g[k>>2]));U=ea(B*ea(g[u>>2]));X=ea(B*ea(g[C>>2]));Y=ea(y*ea(g[P+8>>2]));Z=ea(y*ea(g[P+12>>2]));_=ea(U+Z);Z=ea(X+ea(y*ea(g[P+16>>2])));g[j>>2]=ea(S+Y);g[b>>2]=_;g[v>>2]=Z;KHd(m,w);CMc(l,P+20|0,m,B);c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];BGc(Q,j,f);break}else if((R|0)!=2)break;IHd(n,w);yHd(o,w);Z=ea(A*ea(g[o>>2]));_=ea(A*ea(g[D>>2]));Y=ea(A*ea(g[E>>2]));S=ea(Z+ea(g[n>>2]));Z=ea(_+ea(g[F>>2]));_=ea(Y+ea(g[G>>2]));g[j>>2]=S;g[b>>2]=Z;g[v>>2]=_;zHd(p,w);_=ea(g[p>>2]);Z=ea(_*_);S=ea(g[H>>2]);Y=ea(Z+ea(S*S));Z=ea(g[I>>2]);X=ea(T(ea(Y+ea(Z*Z))));if(X>z?(Y=ea(ea(A*X)*ea(.5)),U=ea(+V(+Y)),$=ea(ea(+W(+Y))/X),X=ea(_*$),_=ea(S*$),S=ea(Z*$),$=ea(T(ea(ea(U*U)+ea(ea(S*S)+ea(ea(X*X)+ea(_*_)))))),!($<z)):0){aa=ea(U/$);ba=ea(X/$);ca=ea(_/$);fa=ea(S/$)}else{aa=ea(1.0);ba=ea(0.0);ca=ea(0.0);fa=ea(0.0)}KHd(q,w);$=ea(g[q>>2]);S=ea(aa*$);_=ea(g[J>>2]);X=ea(S+ea(ba*_));S=ea(g[K>>2]);U=ea(X+ea(ca*S));X=ea(g[L>>2]);Z=ea(ea(ea(fa*$)+ea(ea(ca*_)+ea(aa*X)))-ea(ba*S));Y=ea(ea(ea(ea(fa*_)+ea(aa*S))+ea(ba*X))-ea(ca*$));ga=ea(ea(ea(ea(aa*_)-ea(ba*$))-ea(ca*X))-ea(fa*S));g[f>>2]=ea(U-ea(fa*X));g[M>>2]=Z;g[N>>2]=Y;g[O>>2]=ga;BGc(Q,j,f)}while(0);P=c[P+4>>2]|0}while((P|0)!=(x|0))}if((c[r>>2]|0)!=(c[s>>2]|0)){x=0;do{P=UTb()|0;f=c[s>>2]|0;j=(da(c[P+28>>2]|0,c[138586]|0)|0)+(c[f+(x<<2)>>2]|0)|0;O=(c[P+4>>2]|0)+(j>>>5<<2)|0;c[O>>2]=1<<(j&31)|c[O>>2];x=x+1|0}while(x>>>0<(c[r>>2]|0)-f>>2>>>0)}a[t>>0]=1;t=UTb()|0;r=(da(c[t+28>>2]|0,c[138586]|0)|0)+54|0;x=(c[t+4>>2]|0)+(r>>>5<<2)|0;c[x>>2]=1<<(r&31)|c[x>>2];i=e;return}function RFd(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im;b=i;i=i+16|0;d=b;if(!(c[166982]|0)){i=b;return}e=c[166958]|0;In[c[(c[e>>2]|0)+248>>2]&4095](e,a+28|0);e=c[166958]|0;f=ea(g[a+48>>2]);Fn[c[(c[e>>2]|0)+256>>2]&255](e,f);if(!(tVb(9)|0)){i=b;return}e=BGd(a+56|0)|0;c[a+60>>2]=e;if(!e){a=c[166982]|0;kn[c[(c[a>>2]|0)+152>>2]&511](a,d,1,0)|0;a=c[d>>2]|0;Fn[c[(c[a>>2]|0)+28>>2]&255](a,ea(.600000024));a=c[d>>2]|0;Fn[c[(c[a>>2]|0)+36>>2]&255](a,ea(.600000024));a=c[d>>2]|0;Fn[c[(c[a>>2]|0)+44>>2]&255](a,ea(0.0));i=b;return}else{kFd(e);i=b;return}}function SFd(a,b){a=a|0;b=b|0;var d=0;d=b+28|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];return}function TFd(a){a=a|0;var b=Im;b=ea(g[a+44>>2]);return ea(b)}function UFd(a){a=a|0;var b=Im;b=ea(g[a+40>>2]);return ea(b)}function VFd(d,e,f,h,j){d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0;d=i;i=i+144|0;k=d+56|0;l=d+36|0;m=d+140|0;n=d+16|0;o=d;p=f==ea(x);q=p?ea(3402823469999999843913219.0e14):f;c[n>>2]=668480;c[n+4>>2]=2;c[n+8>>2]=0;c[n+12>>2]=j;a[n+16>>0]=1;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;j=c[166958]|0;c[k+4>>2]=0;p=k+8|0;c[p>>2]=0;r=k+12|0;c[r>>2]=-1;b[k+16>>1]=0;s=k+20|0;t=k+44|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;c[s+20>>2]=0;g[t>>2]=ea(3402823469999999843913219.0e14);u=k+48|0;g[u>>2]=ea(0.0);v=k+52|0;g[v>>2]=ea(0.0);a[k+68>>0]=0;c[k+72>>2]=0;c[k+76>>2]=0;c[k+80>>2]=0;c[k>>2]=420192;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];b[l+16>>1]=15;a[l+18>>0]=0;o=c[(c[j>>2]|0)+348>>2]|0;b[m>>1]=15;Fo[o&1](j,e,e+12|0,q,k,m,l,n,0)|0;n=c[p>>2]|0;p=c[r>>2]|0;q=ea(g[s>>2]);f=ea(g[k+24>>2]);w=ea(g[k+28>>2]);y=ea(g[k+32>>2]);z=ea(g[k+36>>2]);A=ea(g[k+40>>2]);B=ea(g[t>>2]);C=ea(g[u>>2]);D=ea(g[v>>2]);if(!n){E=0;i=d;return E|0}c[h+40>>2]=c[n+8>>2];g[h>>2]=q;g[h+4>>2]=f;g[h+8>>2]=w;g[h+12>>2]=y;g[h+16>>2]=z;g[h+20>>2]=A;c[k>>2]=5;g[k+4>>2]=ea(1.0);g[k+8>>2]=ea(1.0);g[k+12>>2]=ea(1.0);g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);g[k+28>>2]=ea(1.0);v=k+32|0;c[v>>2]=0;c[v+4>>2]=0;if(_n[c[(c[n>>2]|0)+56>>2]&4095](n,k)|0){n=c[k+36>>2]|0;F=c[(mo[c[(c[n>>2]|0)+44>>2]&4095](n)|0)+(p<<2)>>2]|0}else F=-1;c[h+24>>2]=F;g[h+28>>2]=B;g[h+32>>2]=C;g[h+36>>2]=D;E=1;i=d;return E|0}function WFd(d,e,f,h){d=d|0;e=e|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im;j=i;i=i+160|0;k=j+132|0;l=j+112|0;m=j+24|0;n=j+12|0;o=j;p=j+152|0;q=d+804|0;r=c[q>>2]|0;s=d+808|0;t=c[s>>2]|0;if((t|0)!=(r|0))c[s>>2]=t+(~(((t+-44-r|0)>>>0)/44|0)*44|0);r=f==ea(x);u=r?ea(3402823469999999843913219.0e14):f;c[k>>2]=668480;c[k+4>>2]=1;c[k+8>>2]=0;c[k+12>>2]=h;a[k+16>>0]=0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;b[l+16>>1]=15;a[l+18>>0]=0;h=c[d+756>>2]|0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=-1;b[m+16>>1]=0;d=m+20|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;g[m+44>>2]=ea(3402823469999999843913219.0e14);g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(0.0);a[m+68>>0]=0;c[m+72>>2]=h;c[m+76>>2]=128;c[m+80>>2]=0;c[m>>2]=668456;c[m+84>>2]=q;h=c[166958]|0;d=c[(c[h>>2]|0)+348>>2]|0;f=ea(g[e>>2]);v=ea(g[e+4>>2]);w=ea(g[e+8>>2]);g[n>>2]=f;g[n+4>>2]=v;g[n+8>>2]=w;w=ea(g[e+12>>2]);v=ea(g[e+16>>2]);f=ea(g[e+20>>2]);g[o>>2]=w;g[o+4>>2]=v;g[o+8>>2]=f;b[p>>1]=15;Fo[d&1](h,n,o,u,m,p,l,k,0)|0;i=j;return q|0}function XFd(){return c[166992]|0}function YFd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=i;i=i+64|0;e=d+32|0;f=d+24|0;g=d+52|0;h=d;j=b+68|0;k=c[j>>2]|0;l=b+64|0;m=c[l>>2]|0;if((k|0)==(m|0)){i=d;return}n=f+4|0;o=h+4|0;p=h+8|0;q=h+12|0;r=h+16|0;s=b+780|0;t=b+784|0;u=b+784|0;v=b+780|0;w=b+788|0;b=k;k=0;x=m;m=0;while(1){y=x+(m*12|0)+8|0;z=x+(m*12|0)+4|0;A=c[(c[z>>2]|0)+32>>2]|0;B=c[(c[y>>2]|0)+32>>2]|0;c[f>>2]=A;c[n>>2]=B;if((A|0)==0|(B|0)==0){C=k;D=b;E=x}else{F=c[x+(m*12|0)>>2]|0;do if((F|0)==16){G=c[138454]|0;H=c[138455]|0;I=c[138456]|0;J=c[138457]|0;K=c[138458]|0;L=c[t>>2]|0;if(L){M=u;N=L;a:while(1){O=N;while(1){P=c[O+16>>2]|0;if(P>>>0>=A>>>0){if(A>>>0<P>>>0){Q=O;break}if((c[O+20>>2]|0)>>>0>=B>>>0){Q=O;break}}O=c[O+4>>2]|0;if(!O){R=M;break a}}N=c[Q>>2]|0;if(!N){R=Q;break}else M=Q}if((R|0)!=(u|0)?(M=c[R+16>>2]|0,A>>>0>=M>>>0):0){if(M>>>0>=A>>>0?B>>>0<(c[R+20>>2]|0)>>>0:0){S=G;T=H;U=I;V=J;W=K;break}M=c[R+4>>2]|0;if(!M){N=R;while(1){O=c[N+8>>2]|0;if((c[O>>2]|0)==(N|0)){X=O;break}else N=O}}else{N=M;while(1){O=c[N>>2]|0;if(!O){X=N;break}else N=O}}if((c[v>>2]|0)==(R|0))c[v>>2]=X;c[w>>2]=(c[w>>2]|0)+-1;tYb(L,R);ACi(R);S=G;T=H;U=I;V=J;W=K}else{S=G;T=H;U=I;V=J;W=K}}else{S=G;T=H;U=I;V=J;W=K}}else if((F|0)==4){N=c[138444]|0;M=c[138445]|0;O=c[138446]|0;P=c[138447]|0;Y=c[138448]|0;Z=FGd(s,f)|0;_=c[z>>2]|0;$=c[y>>2]|0;a[Z>>0]=1;aa=Z+1|0;a[aa+0>>0]=a[g+0>>0]|0;a[aa+1>>0]=a[g+1>>0]|0;a[aa+2>>0]=a[g+2>>0]|0;c[Z+4>>2]=_;c[Z+8>>2]=$;S=N;T=M;U=O;V=P;W=Y}else{S=0;T=0;U=-1;V=k;W=1}while(0);F=c[z>>2]|0;B=c[y>>2]|0;c[h>>2]=S;c[o>>2]=T;c[p>>2]=U;c[q>>2]=V;c[r>>2]=W;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];GGd(F,B,e);C=V;D=c[j>>2]|0;E=c[l>>2]|0}m=m+1|0;B=E;if(m>>>0>=((D-B|0)/12|0)>>>0){ba=E;ca=D;da=B;break}else{b=D;k=C;x=E}}if((ca|0)==(ba|0)){i=d;return}c[j>>2]=ca+(~(((ca+-12-da|0)>>>0)/12|0)*12|0);i=d;return}function ZFd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d;f=b+780|0;g=c[f>>2]|0;h=b+784|0;if((g|0)==(h|0)){i=d;return}j=b+788|0;k=b+784|0;b=g;while(1){g=b+24|0;if(a[g>>0]|0)a[g>>0]=0;g=c[b+28>>2]|0;l=c[g+32>>2]|0;m=c[b+32>>2]|0;n=c[m+32>>2]|0;a:do if((l|0)!=0&(n|0)!=0){if((l|0)==(c[b+16>>2]|0)?(n|0)==(c[b+20>>2]|0):0){c[e+0>>2]=c[138464];c[e+4>>2]=c[138465];c[e+8>>2]=c[138466];c[e+12>>2]=c[138467];c[e+16>>2]=c[138468];GGd(g,m,e);o=c[b+4>>2]|0;if(o){p=o;while(1){o=c[p>>2]|0;if(!o){q=p;break a}else p=o}}p=b;while(1){o=c[p+8>>2]|0;if((c[o>>2]|0)==(p|0)){q=o;break a}else p=o}}p=c[b+4>>2]|0;o=(p|0)==0;if(o){r=b;while(1){s=c[r+8>>2]|0;if((c[s>>2]|0)==(r|0)){t=s;break}else r=s}}else{r=p;while(1){s=c[r>>2]|0;if(!s){t=r;break}else r=s}}if(o){r=b;while(1){s=c[r+8>>2]|0;if((c[s>>2]|0)==(r|0)){u=s;break}else r=s}}else{r=p;while(1){o=c[r>>2]|0;if(!o){u=r;break}else r=o}}if((c[f>>2]|0)==(b|0))c[f>>2]=u;c[j>>2]=(c[j>>2]|0)+-1;tYb(c[k>>2]|0,b);ACi(b);q=t}else{r=c[b+4>>2]|0;p=(r|0)==0;if(p){o=b;while(1){s=c[o+8>>2]|0;if((c[s>>2]|0)==(o|0)){v=s;break}else o=s}}else{o=r;while(1){s=c[o>>2]|0;if(!s){v=o;break}else o=s}}if(p){o=b;while(1){s=c[o+8>>2]|0;if((c[s>>2]|0)==(o|0)){w=s;break}else o=s}}else{o=r;while(1){p=c[o>>2]|0;if(!p){w=o;break}else o=p}}if((c[f>>2]|0)==(b|0))c[f>>2]=w;c[j>>2]=(c[j>>2]|0)+-1;tYb(c[k>>2]|0,b);ACi(b);q=v}while(0);if((q|0)==(h|0))break;else b=q}i=d;return}function _Fd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;e=d;f=b+80|0;g=b+76|0;b=c[g>>2]|0;if((c[f>>2]|0)==(b|0)){i=d;return}h=e+8|0;j=e+4|0;k=e+8|0;l=e+4|0;m=e+8|0;n=e+4|0;o=e+8|0;p=e+4|0;q=e+8|0;r=e+4|0;s=e+8|0;t=e+4|0;u=b;b=0;while(1){v=u+(b*72|0)|0;w=u+(b*72|0)+8|0;x=u+(b*72|0)+12|0;y=u+(b*72|0)+16|0;z=u+(b*72|0)+20|0;A=c[v>>2]|0;if(!(A&4))B=A;else{A=u+(b*72|0)+4|0;a[A>>0]=0;C=c[w>>2]|0;if(!C)D=c[y>>2]|0;else D=C;c[q>>2]=0;C=v;c[r>>2]=C;c[e>>2]=100004;cUb(D,553896,e);a[A>>0]=1;A=c[x>>2]|0;if(!A)E=c[z>>2]|0;else E=A;c[s>>2]=0;c[t>>2]=C;c[e>>2]=100004;cUb(E,553896,e);B=c[v>>2]|0}if(!(B&16))F=B;else{C=u+(b*72|0)+4|0;a[C>>0]=0;A=c[w>>2]|0;if(!A)G=c[y>>2]|0;else G=A;c[m>>2]=0;A=v;c[n>>2]=A;c[e>>2]=100004;cUb(G,553944,e);a[C>>0]=1;C=c[x>>2]|0;if(!C)H=c[z>>2]|0;else H=C;c[o>>2]=0;c[p>>2]=A;c[e>>2]=100004;cUb(H,553944,e);F=c[v>>2]|0}if(F&8){A=u+(b*72|0)+4|0;a[A>>0]=0;C=c[w>>2]|0;if(!C)I=c[y>>2]|0;else I=C;c[h>>2]=0;C=v;c[j>>2]=C;c[e>>2]=100004;cUb(I,553984,e);a[A>>0]=1;A=c[x>>2]|0;if(!A)J=c[z>>2]|0;else J=A;c[k>>2]=0;c[l>>2]=C;c[e>>2]=100004;cUb(J,553984,e)}b=b+1|0;C=c[f>>2]|0;A=c[g>>2]|0;if(b>>>0>=((C-A|0)/72|0)>>>0){K=C;L=A;break}else u=A}if((K|0)==(L|0)){i=d;return}else M=K;while(1){K=M+-72|0;c[f>>2]=K;u=M+-12|0;b=M+-4|0;if((c[b>>2]|0)!=0?(g=c[M+-8>>2]|0,e=(c[u>>2]|0)+4|0,J=c[g>>2]|0,c[J+4>>2]=c[e>>2],c[c[e>>2]>>2]=J,c[b>>2]=0,(g|0)!=(u|0)):0){b=g;do{g=b;b=c[b+4>>2]|0;ACi(g)}while((b|0)!=(u|0));N=c[f>>2]|0}else N=K;if((N|0)==(L|0))break;else M=N}i=d;return}function $Fd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0;b=i;i=i+16|0;d=b;e=a+92|0;f=a+88|0;a=c[f>>2]|0;if((c[e>>2]|0)==(a|0)){i=b;return}h=d+8|0;j=d+4|0;k=a;a=0;while(1){l=k+(a*12|0)+8|0;m=pGd(l)|0;if(((m|0)!=0?(n=m+24|0,m=c[n>>2]|0,(m|0)!=0):0)?vTb(m)|0:0){m=c[n>>2]|0;o=ea(g[k+(a*12|0)>>2]);c[h>>2]=0;g[j>>2]=o;c[d>>2]=100002;LTb(m,554296,d)}m=pGd(l)|0;if((m|0)!=0?(c[m+24>>2]|0)!=0:0){RQb(0);lQc(m,1);RQb(1)}a=a+1|0;m=c[e>>2]|0;l=c[f>>2]|0;n=l;if(a>>>0>=((m-n|0)/12|0)>>>0){p=m;q=l;r=n;break}else k=l}if((p|0)==(q|0)){i=b;return}c[e>>2]=p+(~(((p+-12-r|0)>>>0)/12|0)*12|0);i=b;return}function aGd(){var a=0,b=0;a=i;b=tVb(9)|0;i=a;return b|0}function bGd(){var a=0;a=i;QQb(55,183,184,0,185);i=a;return}function cGd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,668248,14);wQb(55,6,b,832,2729,0,0);xri(b);i=a;return}function dGd(a){a=a|0;return 55}function eGd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,668248,a,0);JGd(a,b);bdd(b);i=c;return}function fGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,668248,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else KGd(a,b);sdd(b);i=d;return}function gGd(a,b){a=a|0;b=b|0;var c=0;c=i;LGd(a,b);i=c;return}function hGd(a,b){a=a|0;b=b|0;var c=0;c=i;MGd(a,b);i=c;return}function iGd(a,b){a=a|0;b=b|0;var c=0;c=i;NGd(a,b);i=c;return}function jGd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;PSb(b,d);idd(d,2048);f=b+56|0;b=c[d+12>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[f>>2]|0,c[d+28>>2]|0)|0;if(!(a[d+32>>0]|0)){jdd(d);i=e;return}c[f>>2]=g;jdd(d);i=e;return}function kGd(){b[333822]=-1;b[333823]=0;c[166912]=0;c[166910]=443968;c[166913]=0;c[166914]=0;c[166910]=668576;c[166916]=0;a[667660]=0;b[333838]=-1;b[333839]=0;c[166920]=0;c[166918]=443968;c[166921]=0;c[166922]=0;c[166918]=668576;c[166924]=0;a[667692]=0;c[166926]=668552;c[166928]=668528;c[166930]=668504;c[166932]=0;c[166934]=0;c[166936]=0;c[166938]=0;c[166940]=0;c[166942]=0;c[166944]=0;c[166946]=0;c[166948]=0;c[166950]=0;c[166952]=0;c[166953]=0;c[166951]=0;return}function lGd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;e=c[a+8>>2]|0;d=e&-65536;g=c[b+8>>2]|0;if(!((d|0)!=(g&-65536|0)|(d|0)==0)){i=f;return 0}d=c[b+4>>2]|0;h=c[b+12>>2]|0;j=yEd(d,h)|0;if(mo[c[(c[j>>2]|0)+116>>2]&4095](j)|0?mo[c[(c[j>>2]|0)+124>>2]&4095](j)|0:0){i=f;return 0}j=rVb(9)|0;k=oFd(j,c[a>>2]&255,c[b>>2]&255)|0;b=yEd(c[a+4>>2]|0,c[a+12>>2]|0)|0;a=yEd(d,h)|0;if((b|0)!=0&(a|0)!=0)l=JEd(b,a)|0;else l=0;if(e&16){m=1;n=k|l;o=n|m;p=o?0:2;i=f;return p|0}m=(g&16|0)!=0;n=k|l;o=n|m;p=o?0:2;i=f;return p|0}function mGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=357913941;r=(l|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2]}b=n+((((p|0)/-12|0)+o|0)*12|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*12|0);c[h>>2]=n+(m*12|0);if(!f){i=d;return}ACi(f);i=d;return}function nGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d;f=a+4|0;g=c[a>>2]|0;h=(((c[f>>2]|0)-g|0)/72|0)+1|0;if(h>>>0>59652323)vxi(a);j=g;g=((c[a+8>>2]|0)-j|0)/72|0;if(g>>>0<29826161){k=g<<1;l=k>>>0<h>>>0?h:k}else l=59652323;k=((c[f>>2]|0)-j|0)/72|0;j=e+12|0;c[j>>2]=0;c[e+16>>2]=a+8;if(!l)m=0;else m=xCi(l*72|0)|0;c[e>>2]=m;f=m+(k*72|0)|0;h=e+8|0;c[h>>2]=f;g=e+4|0;c[g>>2]=f;c[j>>2]=m+(l*72|0);if(f){l=f+0|0;f=b+0|0;j=l+60|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(j|0));f=m+(k*72|0)+60|0;l=b+60|0;c[f>>2]=f;c[m+(k*72|0)+64>>2]=f;j=m+(k*72|0)+68|0;c[j>>2]=0;n=c[b+64>>2]|0;if((n|0)!=(l|0)){b=n;n=f;o=0;do{p=n;n=xCi(40)|0;q=b+8|0;r=n+8|0;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];c[r+16>>2]=c[q+16>>2];c[r+20>>2]=c[q+20>>2];c[r+24>>2]=c[q+24>>2];c[r+28>>2]=c[q+28>>2];c[n+4>>2]=f;c[n>>2]=p;c[p+4>>2]=n;c[f>>2]=n;o=o+1|0;c[j>>2]=o;b=c[b+4>>2]|0}while((b|0)!=(l|0))}}c[h>>2]=m+((k+1|0)*72|0);mHd(a,e);a=c[g>>2]|0;g=c[h>>2]|0;if((g|0)!=(a|0)){k=~(((g+-72-a|0)>>>0)/72|0);m=g;do{l=m+-12|0;b=m+-4|0;if((c[b>>2]|0)!=0?(o=c[m+-8>>2]|0,j=(c[l>>2]|0)+4|0,n=c[o>>2]|0,c[n+4>>2]=c[j>>2],c[c[j>>2]>>2]=n,c[b>>2]=0,(o|0)!=(l|0)):0){b=o;do{o=b;b=c[b+4>>2]|0;ACi(o)}while((b|0)!=(l|0))}m=m+-72|0}while((m|0)!=(a|0));c[h>>2]=g+(k*72|0)}k=c[e>>2]|0;if(!k){i=d;return}ACi(k);i=d;return}function oGd(a,d,f){a=a|0;d=d|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=Im,N=Im,O=Im;h=i;j=c[a+8>>2]|0;if(!((b[a+16>>1]|0)!=0&(f|0)!=0)){k=0;i=h;return k|0}l=b[a+18>>1]|0;m=l&65535;if(l<<16>>16){l=e[j+2>>1]|0;n=l&2;o=(n|0)!=0;p=l&1;l=(p|0)!=0;q=j+(n<<3|4)|0;n=o?4:32;if(o){r=l;s=1;t=n;u=72;v=q}else{r=l;s=0;t=n;u=p<<3|16;v=q}}else{r=0;s=0;t=0;u=0;v=0}q=j+(m+15&131056)|0;p=e[a+20>>1]|0;a=j;if((v-a|0)>>>0>=m>>>0){k=0;i=h;return k|0}j=(p&64|0)==0;n=(p&32|0)==0;p=v;v=0;a:while(1){l=e[p>>1]|0;o=p;p=p+((da(l,u)|0)+t)|0;w=o+t|0;x=o+4|0;b:do if(j){o=0;y=w;z=v;while(1){if(o>>>0>=l>>>0){A=z;break b}g[d+(z*48|0)>>2]=ea(g[y>>2]);g[d+(z*48|0)+4>>2]=ea(g[y+4>>2]);g[d+(z*48|0)+8>>2]=ea(g[y+8>>2]);g[d+(z*48|0)+12>>2]=ea(g[y+12>>2]);B=s?y+24|0:x;C=ea(g[B>>2]);g[d+(z*48|0)+16>>2]=C;D=ea(g[B+4>>2]);g[d+(z*48|0)+20>>2]=D;E=ea(g[B+8>>2]);g[d+(z*48|0)+24>>2]=E;if(r){c[d+(z*48|0)+28>>2]=c[y+16>>2];F=c[y+20>>2]|0}else{c[d+(z*48|0)+28>>2]=-1;F=-1}c[d+(z*48|0)+44>>2]=F;if(n){G=ea(0.0);H=ea(0.0);I=ea(0.0)}else{J=ea(g[q+(z<<2)>>2]);G=ea(J*E);H=ea(J*D);I=ea(J*C)}g[d+(z*48|0)+32>>2]=I;g[d+(z*48|0)+36>>2]=H;g[d+(z*48|0)+40>>2]=G;z=z+1|0;if((z|0)==(f|0)){k=f;K=23;break a}else{o=o+1|0;y=y+u|0}}}else{y=0;o=w;z=v;while(1){if(y>>>0>=l>>>0){A=z;break b}g[d+(z*48|0)>>2]=ea(g[o>>2]);g[d+(z*48|0)+4>>2]=ea(g[o+4>>2]);g[d+(z*48|0)+8>>2]=ea(g[o+8>>2]);g[d+(z*48|0)+12>>2]=ea(g[o+12>>2]);B=s?o+24|0:x;C=ea(g[B>>2]);g[d+(z*48|0)+16>>2]=C;J=ea(g[B+4>>2]);g[d+(z*48|0)+20>>2]=J;D=ea(g[B+8>>2]);g[d+(z*48|0)+24>>2]=D;if(r){c[d+(z*48|0)+28>>2]=c[o+20>>2];L=c[o+16>>2]|0}else{c[d+(z*48|0)+28>>2]=-1;L=-1}c[d+(z*48|0)+44>>2]=L;if(n){M=ea(0.0);N=ea(0.0);O=ea(0.0)}else{E=ea(g[q+(z<<2)>>2]);M=ea(E*D);N=ea(E*J);O=ea(E*C)}g[d+(z*48|0)+32>>2]=O;g[d+(z*48|0)+36>>2]=N;g[d+(z*48|0)+40>>2]=M;z=z+1|0;if((z|0)==(f|0)){k=f;K=23;break a}else{y=y+1|0;o=o+u|0}}}while(0);if((p-a|0)>>>0>=m>>>0){k=A;K=23;break}else v=A}if((K|0)==23){i=h;return k|0}return 0}function pGd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=c[b>>2]|0;if(!e){f=0;i=d;return f|0}b=c[137784]|0;if(b){g=c[b+4>>2]|0;a:do if((c[b+36>>2]|0)==(g|0)){h=c[b+28>>2]|0;j=c[b+32>>2]|0;k=h;l=j;m=h+(j<<3)|0}else{j=c[b+32>>2]|0;h=j+-1|0;n=e+2127912214+(e<<12)|0;o=n^-949894596^n>>>19;n=o+374761393+(o<<5)|0;o=n+-744332180^n<<9;n=o+-42973499+(o<<3)|0;o=h&(n^-1252372727^n>>>16);n=c[b+28>>2]|0;p=c[b+20>>2]|0;q=c[n+(o<<3)>>2]|0;b:do if((p|0)!=(q|0)){r=b+12|0;c:do if(!(a[b+8>>0]|0)){s=q;t=o;u=0;while(1){if((s|0)==(e|0)){v=t;break c}u=u+1|0;t=u+t&h;s=c[n+(t<<3)>>2]|0;if((p|0)==(s|0))break b}}else{s=g;t=q;u=o;w=0;while(1){if(s)if((c[r>>2]|0)==(t|0))x=s;else{y=s;z=11}else{y=0;z=11}if((z|0)==11){z=0;if((t|0)==(e|0)){v=u;break c}else x=y}w=w+1|0;u=w+u&h;t=c[n+(u<<3)>>2]|0;if((p|0)==(t|0))break b;else s=x}}while(0);if((v|0)!=-1){k=n;l=j;m=n+(v<<3)|0;break a}}while(0);k=n;l=j;m=n+(j<<3)|0}while(0);if((m|0)!=(k+(l<<3)|0)?(l=c[m+4>>2]|0,(l|0)!=0):0)A=l;else z=18}else z=18;if((z|0)==18)A=hQb(e)|0;f=A;i=d;return f|0}function qGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=c[e>>2]|0;g=(l-j|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=c[e>>2]|0;q=357913941;r=(l-j|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;r=n+(m*12|0)|0;if(s){m=b;q=c[m+4>>2]|0;t=s;c[t>>2]=c[m>>2];c[t+4>>2]=q;c[n+(o*12|0)+8>>2]=c[b+8>>2]}b=n+((o+1|0)*12|0)|0;if((p|0)==(f|0)){u=s;v=f}else{q=o+-1-(((p+-12-j|0)>>>0)/12|0)|0;j=p;p=s;do{s=p;p=p+-12|0;o=j;j=j+-12|0;t=j;m=c[t+4>>2]|0;l=p;c[l>>2]=c[t>>2];c[l+4>>2]=m;c[s+-4>>2]=c[o+-4>>2]}while((j|0)!=(f|0));u=n+(q*12|0)|0;v=c[a>>2]|0}c[a>>2]=u;c[e>>2]=b;c[h>>2]=r;if(!v){i=d;return}ACi(v);i=d;return}function rGd(){var a=0;a=i;NFd(rVb(9)|0);i=a;return}function sGd(){var a=0;a=i;QFd(rVb(9)|0);i=a;return}function tGd(){return}function uGd(){var a=0;a=i;OFd(rVb(9)|0);i=a;return}function vGd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;i=i+32|0;b=a+16|0;d=a;e=rVb(9)|0;f=c[e+120>>2]|0;g=e+116|0;if((f|0)==(g|0)){i=a;return}else h=f;do{f=c[h+36>>2]|0;if(!(LHd(f)|0)){e=BTb(c[f+24>>2]|0)|0;IHd(b,f);KHd(d,f);sGc(e,b,d)}h=c[h+4>>2]|0}while((h|0)!=(g|0));i=a;return}function wGd(){var a=0;a=i;KFd(rVb(9)|0);i=a;return}function xGd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(g-k>>2>>>0>=b>>>0){l=b;m=j;while(1){if(m)c[m>>2]=c[d>>2];l=l+-1|0;if(!l)break;else m=m+4|0}c[h>>2]=j+(b<<2);i=e;return}j=c[a>>2]|0;m=(k-j>>2)+b|0;if(m>>>0>1073741823)vxi(a);k=j;l=g-k|0;if(l>>2>>>0<536870911){g=l>>1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k|0;m=g>>2;if(!l){n=0;o=0;p=m;q=g}else{r=l;s=m;t=g;u=11}}else{g=(c[h>>2]|0)-k|0;r=1073741823;s=g>>2;t=g;u=11}if((u|0)==11){n=r;o=xCi(r<<2)|0;p=s;q=t}t=b;s=o+(p<<2)|0;while(1){if(s)c[s>>2]=c[d>>2];t=t+-1|0;if(!t)break;else s=s+4|0}YEi(o|0,j|0,q|0)|0;q=c[a>>2]|0;c[a>>2]=o;c[h>>2]=o+(p+b<<2);c[f>>2]=o+(n<<2);if(!q){i=e;return}ACi(q);i=e;return}function yGd(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+8|0;h=c[f>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(((h-l|0)/48|0)>>>0>=d>>>0){m=d;n=k;do{if(!n)o=0;else{c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;k=n+16|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;g[n+40>>2]=ea(3402823469999999843913219.0e14);o=c[j>>2]|0}n=o+48|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=e;return}m=c[a>>2]|0;n=((l-m|0)/48|0)+d|0;if(n>>>0>89478485)vxi(a);l=m;m=(h-l|0)/48|0;if(m>>>0<44739242){h=m<<1;m=h>>>0<n>>>0?n:h;h=((c[j>>2]|0)-l|0)/48|0;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=89478485;t=((c[j>>2]|0)-l|0)/48|0;u=10}if((u|0)==10){p=s;q=xCi(s*48|0)|0;r=t}t=q+(r*48|0)|0;s=d;d=t;while(1){if(!d)v=0;else{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=-1;b[d+12>>1]=0;u=d+16|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;g[d+40>>2]=ea(3402823469999999843913219.0e14);v=d}u=v+48|0;s=s+-1|0;if(!s){w=u;break}else d=u}d=q+(p*48|0)|0;p=c[a>>2]|0;s=c[j>>2]|0;if((s|0)==(p|0)){x=t;y=p}else{v=r+-1-(((s+-48-p|0)>>>0)/48|0)|0;r=s;s=t;do{t=s;s=s+-48|0;u=r;r=r+-48|0;c[s+0>>2]=c[r+0>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];b[t+-36>>1]=b[u+-36>>1]|0;g[t+-32>>2]=ea(g[u+-32>>2]);g[t+-28>>2]=ea(g[u+-28>>2]);g[t+-24>>2]=ea(g[u+-24>>2]);g[t+-20>>2]=ea(g[u+-20>>2]);g[t+-16>>2]=ea(g[u+-16>>2]);g[t+-12>>2]=ea(g[u+-12>>2]);g[t+-8>>2]=ea(g[u+-8>>2]);c[t+-4>>2]=c[u+-4>>2]}while((r|0)!=(p|0));x=q+(v*48|0)|0;y=c[a>>2]|0}c[a>>2]=x;c[j>>2]=w;c[f>>2]=d;if(!y){i=e;return}ACi(y);i=e;return}function zGd(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+8|0;h=c[f>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>6>>>0>=d>>>0){m=d;n=k;do{if(!n)o=0;else{c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=-1;b[n+12>>1]=0;k=n+16|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;g[n+40>>2]=ea(3402823469999999843913219.0e14);g[n+44>>2]=ea(0.0);g[n+48>>2]=ea(0.0);o=c[j>>2]|0}n=o+64|0;c[j>>2]=n;m=m+-1|0}while((m|0)!=0);i=e;return}m=c[a>>2]|0;n=(l-m>>6)+d|0;if(n>>>0>67108863)vxi(a);l=m;m=h-l|0;if(m>>6>>>0<33554431){h=m>>5;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>6;if(!m){p=0;q=0;r=h}else{s=m;t=h;u=10}}else{s=67108863;t=(c[j>>2]|0)-l>>6;u=10}if((u|0)==10){p=s;q=xCi(s<<6)|0;r=t}t=q+(r<<6)|0;s=d;d=t;while(1){if(!d)v=0;else{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=-1;b[d+12>>1]=0;u=d+16|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;g[d+40>>2]=ea(3402823469999999843913219.0e14);g[d+44>>2]=ea(0.0);g[d+48>>2]=ea(0.0);v=d}u=v+64|0;s=s+-1|0;if(!s){w=u;break}else d=u}d=q+(p<<6)|0;p=c[a>>2]|0;s=c[j>>2]|0;if((s|0)==(p|0)){x=t;y=p}else{v=r+-1-((s+-64-p|0)>>>6)|0;r=s;s=t;do{t=s;s=s+-64|0;u=r;r=r+-64|0;c[s+0>>2]=c[r+0>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];b[t+-52>>1]=b[u+-52>>1]|0;g[t+-48>>2]=ea(g[u+-48>>2]);g[t+-44>>2]=ea(g[u+-44>>2]);g[t+-40>>2]=ea(g[u+-40>>2]);g[t+-36>>2]=ea(g[u+-36>>2]);g[t+-32>>2]=ea(g[u+-32>>2]);g[t+-28>>2]=ea(g[u+-28>>2]);g[t+-24>>2]=ea(g[u+-24>>2]);l=t+-20|0;t=u+-20|0;c[l+0>>2]=c[t+0>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[l+12>>2]=c[t+12>>2];c[l+16>>2]=c[t+16>>2]}while((r|0)!=(p|0));x=q+(v<<6)|0;y=c[a>>2]|0}c[a>>2]=x;c[j>>2]=w;c[f>>2]=d;if(!y){i=e;return}ACi(y);i=e;return}function AGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>4>>>0>=b>>>0){k=b;l=h;do{if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+8>>2]=-1;m=c[g>>2]|0}l=m+16|0;c[g>>2]=l;k=k+-1|0}while((k|0)!=0);i=d;return}k=c[a>>2]|0;l=(j-k>>4)+b|0;if(l>>>0>268435455)vxi(a);j=k;k=f-j|0;if(k>>4>>>0<134217727){f=k>>3;k=f>>>0<l>>>0?l:f;f=(c[g>>2]|0)-j>>4;if(!k){n=0;o=0;p=f}else{q=k;r=f;s=10}}else{q=268435455;r=(c[g>>2]|0)-j>>4;s=10}if((s|0)==10){n=q;o=xCi(q<<4)|0;p=r}r=b;b=o+(p<<4)|0;while(1){if(!b)t=0;else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+8>>2]=-1;t=b}q=t+16|0;r=r+-1|0;if(!r){u=q;break}else b=q}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;t=o+(p-(r>>4)<<4)|0;YEi(t|0,b|0,r|0)|0;c[a>>2]=t;c[g>>2]=u;c[e>>2]=o+(n<<4);if(!b){i=d;return}ACi(b);i=d;return}function BGd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=c[b>>2]|0;if(!e){f=0;i=d;return f|0}b=c[137784]|0;if(b){g=c[b+4>>2]|0;a:do if((c[b+36>>2]|0)==(g|0)){h=c[b+28>>2]|0;j=c[b+32>>2]|0;k=h;l=j;m=h+(j<<3)|0}else{j=c[b+32>>2]|0;h=j+-1|0;n=e+2127912214+(e<<12)|0;o=n^-949894596^n>>>19;n=o+374761393+(o<<5)|0;o=n+-744332180^n<<9;n=o+-42973499+(o<<3)|0;o=h&(n^-1252372727^n>>>16);n=c[b+28>>2]|0;p=c[b+20>>2]|0;q=c[n+(o<<3)>>2]|0;b:do if((p|0)!=(q|0)){r=b+12|0;c:do if(!(a[b+8>>0]|0)){s=q;t=o;u=0;while(1){if((s|0)==(e|0)){v=t;break c}u=u+1|0;t=u+t&h;s=c[n+(t<<3)>>2]|0;if((p|0)==(s|0))break b}}else{s=g;t=q;u=o;w=0;while(1){if(s)if((c[r>>2]|0)==(t|0))x=s;else{y=s;z=11}else{y=0;z=11}if((z|0)==11){z=0;if((t|0)==(e|0)){v=u;break c}else x=y}w=w+1|0;u=w+u&h;t=c[n+(u<<3)>>2]|0;if((p|0)==(t|0))break b;else s=x}}while(0);if((v|0)!=-1){k=n;l=j;m=n+(v<<3)|0;break a}}while(0);k=n;l=j;m=n+(j<<3)|0}while(0);if((m|0)!=(k+(l<<3)|0)?(l=c[m+4>>2]|0,(l|0)!=0):0)A=l;else z=18}else z=18;if((z|0)==18)A=hQb(e)|0;f=A;i=d;return f|0}function CGd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{CGd(a,c[b>>2]|0);CGd(a,c[b+4>>2]|0);ACi(b);i=d;return}}function DGd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+48>>2]|0;if(d){e=a+52|0;if((c[e>>2]|0)!=(d|0))c[e>>2]=d;ACi(d)}d=c[a+36>>2]|0;if(d){e=a+40|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-16-d|0)>>>4)<<4);ACi(d)}d=c[a+24>>2]|0;if(d){f=a+28|0;e=c[f>>2]|0;if((e|0)!=(d|0))c[f>>2]=e+(~(((e+-28-d|0)>>>0)/28|0)*28|0);ACi(d)}d=c[a+12>>2]|0;if(d){e=a+16|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d)}d=c[a>>2]|0;if(!d){i=b;return}f=a+4|0;a=c[f>>2]|0;if((a|0)!=(d|0))c[f>>2]=a+(~((a+-4-d|0)>>>2)<<2);ACi(d);i=b;return}function EGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=a+8|0;f=c[a>>2]|0;h=f;if((((c[e>>2]|0)-h|0)/28|0)>>>0>=b>>>0){i=d;return}j=a+4|0;k=c[j>>2]|0;l=(k-h|0)/28|0;if(!b)m=0;else m=xCi(b*28|0)|0;n=m+(l*28|0)|0;o=m+(b*28|0)|0;if((k|0)==(f|0)){p=n;q=f}else{b=k+-28-h|0;h=k;k=n;while(1){r=h;h=h+-28|0;g[k+-28>>2]=ea(g[h>>2]);g[k+-24>>2]=ea(g[r+-24>>2]);g[k+-20>>2]=ea(g[r+-20>>2]);g[k+-16>>2]=ea(g[r+-16>>2]);g[k+-12>>2]=ea(g[r+-12>>2]);g[k+-8>>2]=ea(g[r+-8>>2]);g[k+-4>>2]=ea(g[r+-4>>2]);if((h|0)==(f|0))break;else k=k+-28|0}p=m+((l+~((b>>>0)/28|0)|0)*28|0)|0;q=c[a>>2]|0}c[a>>2]=p;c[j>>2]=n;c[e>>2]=o;if(!q){i=d;return}ACi(q);i=d;return}function FGd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+16|0;f=e;g=b+4|0;h=c[g>>2]|0;do if(h){j=c[d>>2]|0;k=c[d+4>>2]|0;l=h;a:while(1){m=c[l+16>>2]|0;do if(j>>>0>=m>>>0){if(m>>>0>=j>>>0){n=c[l+20>>2]|0;if(k>>>0<n>>>0)break;if(n>>>0>=k>>>0){o=l;p=11;break a}}n=l+4|0;q=c[n>>2]|0;if(!q){r=n;s=l;p=10;break a}else{l=q;continue a}}while(0);m=c[l>>2]|0;if(!m){t=l;u=l;p=7;break}else l=m}if((p|0)==7){c[f>>2]=u;v=t;w=u;break}else if((p|0)==10){c[f>>2]=s;v=r;w=s;break}else if((p|0)==11){c[f>>2]=o;v=f;w=o;break}}else{l=b+4|0;c[f>>2]=l;v=l;w=l}while(0);f=c[v>>2]|0;if(f){x=f;y=x+24|0;i=e;return y|0}f=xCi(36)|0;o=d;d=c[o+4>>2]|0;p=f+16|0;c[p>>2]=c[o>>2];c[p+4>>2]=d;a[f+24>>0]=1;c[f+28>>2]=0;c[f+32>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=w;c[v>>2]=f;w=c[c[b>>2]>>2]|0;if(!w)z=f;else{c[b>>2]=w;z=c[v>>2]|0}GN(c[g>>2]|0,z);z=b+8|0;c[z>>2]=(c[z>>2]|0)+1;x=f;y=x+24|0;i=e;return y|0}function GGd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;h=(g|0)==0?b:g;g=mo[c[(c[a>>2]|0)+128>>2]&4095](a)|0;j=(g|0)==0?a:g;c[f+8>>2]=0;g=b;c[f+4>>2]=g;c[f>>2]=56;cUb(a,d,f);c[f+8>>2]=0;k=a;c[f+4>>2]=k;c[f>>2]=56;cUb(h,d,f);if((c[h+24>>2]|0)!=(c[b+24>>2]|0)?mo[c[(c[b>>2]|0)+124>>2]&4095](b)|0:0){c[f+8>>2]=0;c[f+4>>2]=k;c[f>>2]=56;cUb(b,d,f)}if((c[j+24>>2]|0)==(c[a+24>>2]|0)){i=e;return}c[f+8>>2]=0;c[f+4>>2]=g;c[f>>2]=56;cUb(j,d,f);i=e;return}function HGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function IGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(832,e,1,16,3653512,76)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];GFd(f,e,b);i=d;return f|0}function JGd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;KSb(a,b);f=a+28|0;add(b,668264,c[142310]|0,f,2048);g=c[($hd(b+16|0)|0)+20>>2]|2097152;h=b+12|0;j=b+20|0;c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+20>>2]=g;g=c[142268]|0;add(b,3143216,g,f,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,3143224,g,a+32|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2416480,g,a+36|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);bdd(b);f=a+56|0;add(b,723304,668424,f,2048);k=e+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;l=c[142270]|0;add(b,792256,l,f,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,k,1);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,667872,g,a+48|0,2048);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,668280,g,d+24|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,668304,g,d+20|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,668328,l,d+16|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);l=c[142258]|0;add(b,668352,l,a+52|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,668376,l,a+53|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,668400,c[142306]|0,a+672|0,1);$cd(b,2646336,2646336,e,0);add(b,3142592,c[142304]|0,d+28|0,0);c[(c[c[h>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);cdd(b);bdd(b);i=d;return}function KGd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;LSb(b,d);l=b+28|0;m=qdd(d,668264,c[142310]|0,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](l,d)|0}else _6b(l,d);sdd(d)}l=b+56|0;m=qdd(d,723304,668424,f,1)|0;if(m){if((m|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](l,d)|0}else eFd(l,d);sdd(d)}l=b+48|0;m=c[142268]|0;n=qdd(d,667872,m,f,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=o+p|0;c[n>>2]=q;if((p|0)>=0?(r=o+(p+4)|0,r>>>0<=(c[d+20>>2]|0)>>>0):0){g[l>>2]=ea(g[q>>2]);c[n>>2]=r}else Bid(n,l,4);if(c[d>>2]&512)c[l>>2]=XEi(c[l>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](l,d)|0}sdd(d)}l=qdd(d,668280,m,f,0)|0;if(l){if((l|0)>0){l=d+12|0;n=c[d+16>>2]|0;r=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=n+r|0;c[l>>2]=q;if((r|0)>=0?(p=n+(r+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[q>>2]);c[l>>2]=p}else Bid(l,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}sdd(d)}l=d+136|0;if(!((a[l>>0]|0)==0|(c[166982]|0)==0))g[b+40>>2]=ea(g[h>>2]);h=qdd(d,668304,m,f,0)|0;if(h){if((h|0)>0){h=d+12|0;m=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=m+p|0;c[h>>2]=q;if((p|0)>=0?(r=m+(p+4)|0,r>>>0<=(c[d+20>>2]|0)>>>0):0){g[j>>2]=ea(g[q>>2]);c[h>>2]=r}else Bid(h,j,4);if(c[d>>2]&512)c[j>>2]=XEi(c[j>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](j,d)|0}sdd(d)}do if((a[l>>0]|0)!=0?(s=ea(g[j>>2]),(c[166982]|0)!=0):0)if(!(s<=ea(0.0))){g[b+44>>2]=s;break}else{Krd(668152,0,3653512,1620,1,0,0,0);break}while(0);j=qdd(d,668328,c[142270]|0,f,0)|0;if(j){if((j|0)>0){j=d+12|0;h=c[d+16>>2]|0;r=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=h+r|0;c[j>>2]=q;if((r|0)>=0?(p=h+(r+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[k>>2]=c[q>>2];c[j>>2]=p}else Bid(j,k,4);if(c[d>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](k,d)|0}sdd(d)}if((a[l>>0]|0)!=0?(l=c[k>>2]|0,(c[166982]|0)!=0):0){if((l|0)<1)t=1;else t=(l|0)>100?100:l;c[b+100>>2]=t}t=b+52|0;l=c[142258]|0;k=qdd(d,668352,l,f,0)|0;if(k){do if((k|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](t,d)|0}else{j=d+12|0;p=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;r=p+q|0;c[j>>2]=r;if((q|0)>=0?(p+(q+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[t>>0]=a[r>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,t,1)}while(0);sdd(d)}t=b+53|0;k=qdd(d,668376,l,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](t,d)|0}else{l=d+12|0;j=c[d+16>>2]|0;r=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;q=j+r|0;c[l>>2]=q;if((r|0)>=0?(j+(r+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[t>>0]=a[q>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,t,1)}while(0);sdd(d)}t=b+672|0;b=qdd(d,668400,c[142306]|0,f,1)|0;if(!b){i=e;return}if((b|0)<=0){b=c[f>>2]|0;if(b)_n[b&4095](t,d)|0}else nHd(d,t,0);sdd(d);i=e;return}function LGd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;MSb(b,d);k=b+28|0;l=d+12|0;m=c[l>>2]|0;n=m+4|0;o=d+20|0;p=c[o>>2]|0;if(n>>>0>p>>>0){Bid(l,k,4);q=c[l>>2]|0;r=c[o>>2]|0}else{g[k>>2]=ea(g[m>>2]);c[l>>2]=n;q=n;r=p}p=b+32|0;n=q+4|0;if(n>>>0>r>>>0){Bid(l,p,4);s=c[l>>2]|0;t=c[o>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[l>>2]=n;s=n;t=r}r=b+36|0;n=s+4|0;if(n>>>0>t>>>0)Bid(l,r,4);else{g[r>>2]=ea(g[s>>2]);c[l>>2]=n}fFd(b+56|0,d);n=b+48|0;s=c[l>>2]|0;r=s+4|0;t=c[o>>2]|0;if(r>>>0>t>>>0){Bid(l,n,4);u=c[l>>2]|0;v=c[o>>2]|0}else{g[n>>2]=ea(g[s>>2]);c[l>>2]=r;u=r;v=t}t=u+4|0;if(t>>>0>v>>>0)Bid(l,f,4);else{g[f>>2]=ea(g[u>>2]);c[l>>2]=t}if(c[166982]|0)g[b+40>>2]=ea(g[f>>2]);f=c[l>>2]|0;t=f+4|0;if(t>>>0>(c[o>>2]|0)>>>0){Bid(l,h,4);w=ea(g[h>>2])}else{x=ea(g[f>>2]);g[h>>2]=x;c[l>>2]=t;w=x}do if(c[166982]|0)if(!(w<=ea(0.0))){g[b+44>>2]=w;break}else{Krd(668152,0,3653512,1620,1,0,0,0);break}while(0);t=c[l>>2]|0;h=t+4|0;if(h>>>0>(c[o>>2]|0)>>>0){Bid(l,j,4);y=c[j>>2]|0}else{f=c[t>>2]|0;c[j>>2]=f;c[l>>2]=h;y=f}if(c[166982]|0){if((y|0)<1)z=1;else z=(y|0)>100?100:y;c[b+100>>2]=z}z=b+52|0;y=c[l>>2]|0;if((y+1|0)>>>0>(c[o>>2]|0)>>>0){Bid(l,z,1);A=c[l>>2]|0}else{a[z>>0]=a[y>>0]|0;y=(c[l>>2]|0)+1|0;c[l>>2]=y;A=y}y=b+53|0;if((A+1|0)>>>0>(c[o>>2]|0)>>>0){Bid(l,y,1);Ndd(d);B=b+672|0;oHd(d,B,0);i=e;return}else{a[y>>0]=a[A>>0]|0;c[l>>2]=(c[l>>2]|0)+1;Ndd(d);B=b+672|0;oHd(d,B,0);i=e;return}}function MGd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;NSb(b,d);l=b+28|0;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;q=c[p>>2]|0;if(o>>>0>q>>>0){Bid(m,l,4);r=l;s=c[m>>2]|0;t=c[p>>2]|0;u=c[l>>2]|0}else{v=ea(g[n>>2]);g[l>>2]=v;c[m>>2]=o;r=l;s=o;t=q;u=(g[k>>2]=v,c[k>>2]|0)}c[r>>2]=XEi(u|0)|0;u=b+32|0;r=s+4|0;if(r>>>0>t>>>0){Bid(m,u,4);w=u;x=c[u>>2]|0;y=c[m>>2]|0;z=c[p>>2]|0}else{v=ea(g[s>>2]);g[u>>2]=v;c[m>>2]=r;w=u;x=(g[k>>2]=v,c[k>>2]|0);y=r;z=t}c[w>>2]=XEi(x|0)|0;x=b+36|0;w=y+4|0;if(w>>>0>z>>>0){Bid(m,x,4);A=x;B=c[x>>2]|0}else{v=ea(g[y>>2]);g[x>>2]=v;c[m>>2]=w;A=x;B=(g[k>>2]=v,c[k>>2]|0)}c[A>>2]=XEi(B|0)|0;gFd(b+56|0,d);B=b+48|0;A=c[m>>2]|0;x=A+4|0;w=c[p>>2]|0;if(x>>>0>w>>>0){Bid(m,B,4);C=B;D=c[B>>2]|0;E=c[m>>2]|0;F=c[p>>2]|0}else{v=ea(g[A>>2]);g[B>>2]=v;c[m>>2]=x;C=B;D=(g[k>>2]=v,c[k>>2]|0);E=x;F=w}c[C>>2]=XEi(D|0)|0;D=E+4|0;if(D>>>0>F>>>0){Bid(m,f,4);G=f;H=c[f>>2]|0}else{v=ea(g[E>>2]);g[f>>2]=v;c[m>>2]=D;G=f;H=(g[k>>2]=v,c[k>>2]|0)}f=XEi(H|0)|0;c[G>>2]=f;if(c[166982]|0)g[b+40>>2]=(c[k>>2]=f,ea(g[k>>2]));f=c[m>>2]|0;G=f+4|0;if(G>>>0>(c[p>>2]|0)>>>0){Bid(m,h,4);I=h;J=c[h>>2]|0}else{v=ea(g[f>>2]);g[h>>2]=v;c[m>>2]=G;I=h;J=(g[k>>2]=v,c[k>>2]|0)}h=XEi(J|0)|0;c[I>>2]=h;v=(c[k>>2]=h,ea(g[k>>2]));do if(c[166982]|0)if(!(v<=ea(0.0))){g[b+44>>2]=v;break}else{Krd(668152,0,3653512,1620,1,0,0,0);break}while(0);h=c[m>>2]|0;I=h+4|0;if(I>>>0>(c[p>>2]|0)>>>0){Bid(m,j,4);K=c[j>>2]|0}else{J=c[h>>2]|0;c[j>>2]=J;c[m>>2]=I;K=J}J=XEi(K|0)|0;c[j>>2]=J;if(c[166982]|0){if((J|0)<1)L=1;else L=(J|0)>100?100:J;c[b+100>>2]=L}L=b+52|0;J=c[m>>2]|0;if((J+1|0)>>>0>(c[p>>2]|0)>>>0){Bid(m,L,1);M=c[m>>2]|0}else{a[L>>0]=a[J>>0]|0;J=(c[m>>2]|0)+1|0;c[m>>2]=J;M=J}J=b+53|0;if((M+1|0)>>>0>(c[p>>2]|0)>>>0){Bid(m,J,1);Mdd(d);N=b+672|0;pHd(d,N,0);i=e;return}else{a[J>>0]=a[M>>0]|0;c[m>>2]=(c[m>>2]|0)+1;Mdd(d);N=b+672|0;pHd(d,N,0);i=e;return}}function NGd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;OSb(b,d);l=b+28|0;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;q=c[p>>2]|0;if(o>>>0<q>>>0){g[n>>2]=ea(g[l>>2]);c[m>>2]=o;r=o;s=q}else{Gid(m,l,4);r=c[m>>2]|0;s=c[p>>2]|0}l=b+32|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[l>>2]);c[m>>2]=q;t=q;u=s}else{Gid(m,l,4);t=c[m>>2]|0;u=c[p>>2]|0}l=b+36|0;s=t+4|0;if(s>>>0<u>>>0){g[t>>2]=ea(g[l>>2]);c[m>>2]=s}else Gid(m,l,4);hFd(b+56|0,d);l=b+48|0;s=c[m>>2]|0;t=s+4|0;u=c[p>>2]|0;if(t>>>0<u>>>0){g[s>>2]=ea(g[l>>2]);c[m>>2]=t;v=t;w=u}else{Gid(m,l,4);v=c[m>>2]|0;w=c[p>>2]|0}x=ea(g[b+40>>2]);g[h>>2]=x;l=v+4|0;if(l>>>0<w>>>0){g[v>>2]=x;c[m>>2]=l;y=l;z=w}else{Gid(m,h,4);y=c[m>>2]|0;z=c[p>>2]|0}x=ea(g[b+44>>2]);g[j>>2]=x;h=y+4|0;if(h>>>0<z>>>0){g[y>>2]=x;c[m>>2]=h;A=h;B=z}else{Gid(m,j,4);A=c[m>>2]|0;B=c[p>>2]|0}j=c[b+100>>2]|0;c[k>>2]=j;z=A+4|0;if(z>>>0<B>>>0){c[A>>2]=j;c[m>>2]=z;C=z;D=B}else{Gid(m,k,4);C=c[m>>2]|0;D=c[p>>2]|0}k=b+52|0;if((C+1|0)>>>0<D>>>0){a[C>>0]=a[k>>0]|0;C=(c[m>>2]|0)+1|0;c[m>>2]=C;E=C}else{Gid(m,k,1);E=c[m>>2]|0}k=b+53|0;if((E+1|0)>>>0<(c[p>>2]|0)>>>0){a[E>>0]=a[k>>0]|0;c[m>>2]=(c[m>>2]|0)+1}else Gid(m,k,1);Tdd(d);d=b+676|0;k=c[d>>2]|0;E=b+672|0;b=c[E>>2]|0;C=k-b>>2;c[f>>2]=C;D=c[m>>2]|0;B=D+4|0;if(B>>>0<(c[p>>2]|0)>>>0){c[D>>2]=C;c[m>>2]=B;F=b;G=k}else{Gid(m,f,4);F=c[E>>2]|0;G=c[d>>2]|0}if((F|0)==(G|0)){i=e;return}else H=F;do{F=c[m>>2]|0;d=F+4|0;if(d>>>0<(c[p>>2]|0)>>>0){c[F>>2]=c[H>>2];c[m>>2]=d}else Gid(m,H,4);H=H+4|0}while((H|0)!=(G|0));i=e;return}function OGd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=667992;c[a+24>>2]=668120;f=c[a+804>>2]|0;if(f){g=a+808|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~(((h+-44-f|0)>>>0)/44|0)*44|0);ACi(f)}f=c[a+792>>2]|0;if(f){h=a+796|0;g=c[h>>2]|0;if((g|0)!=(f|0))c[h>>2]=g+(~((g+-4-f|0)>>>2)<<2);ACi(f)}CGd(a+780|0,c[a+784>>2]|0);f=c[a+768>>2]|0;if(f){g=a+772|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~((h+-16-f|0)>>>4)<<4);ACi(f)}f=c[a+756>>2]|0;if(f){h=a+760|0;g=c[h>>2]|0;if((g|0)!=(f|0))c[h>>2]=g+(~((g+-64-f|0)>>>6)<<6);ACi(f)}f=c[a+744>>2]|0;if(f){g=a+748|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~(((h+-48-f|0)>>>0)/48|0)*48|0);ACi(f)}DGd(a+684|0);f=c[a+672>>2]|0;if(f){h=a+676|0;g=c[h>>2]|0;if((g|0)!=(f|0))c[h>>2]=g+(~((g+-4-f|0)>>>2)<<2);ACi(f)}if((c[a+668>>2]|0)>-1){f=a+656|0;g=c[f>>2]|0;c[e>>2]=c[a+660>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}c[a+644>>2]=0;c[a+640>>2]=0;f=a+128|0;d=a+640|0;do{c[d+-4>>2]=0;d=d+-8|0;c[d>>2]=0}while((d|0)!=(f|0));c[a+120>>2]=0;c[a+116>>2]=0;f=c[a+104>>2]|0;if(f){d=a+108|0;g=c[d>>2]|0;if((g|0)!=(f|0))c[d>>2]=g+(~((g+-4-f|0)>>>2)<<2);ACi(f)}f=c[a+88>>2]|0;if(f){g=a+92|0;d=c[g>>2]|0;if((d|0)!=(f|0))c[g>>2]=d+(~(((d+-12-f|0)>>>0)/12|0)*12|0);ACi(f)}f=a+76|0;d=c[f>>2]|0;if(d){g=a+80|0;e=c[g>>2]|0;if((e|0)==(d|0))j=d;else{h=e;while(1){e=h+-72|0;c[g>>2]=e;k=h+-12|0;l=h+-4|0;if((c[l>>2]|0)!=0?(m=c[h+-8>>2]|0,n=(c[k>>2]|0)+4|0,o=c[m>>2]|0,c[o+4>>2]=c[n>>2],c[c[n>>2]>>2]=o,c[l>>2]=0,(m|0)!=(k|0)):0){l=m;do{m=l;l=c[l+4>>2]|0;ACi(m)}while((l|0)!=(k|0));p=c[g>>2]|0}else p=e;if((p|0)==(d|0))break;else h=p}j=c[f>>2]|0}ACi(j)}j=c[a+64>>2]|0;if(!j){ZSb(a);i=b;return}f=a+68|0;p=c[f>>2]|0;if((p|0)!=(j|0))c[f>>2]=p+(~(((p+-12-j|0)>>>0)/12|0)*12|0);ACi(j);ZSb(a);i=b;return}function PGd(a){a=a|0;var b=0;b=i;OGd(a);ACi(a);i=b;return}function QGd(a){a=a|0;var b=0;b=i;OGd(a+-24|0);i=b;return}function RGd(a){a=a|0;var b=0,c=0;b=i;c=a+-24|0;OGd(c);ACi(c);i=b;return}function SGd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+96|0;f=e+48|0;h=e;j=a+84|0;a=c[j>>2]|0;k=a+4|0;l=c[a>>2]|0;m=l;n=(c[k>>2]|0)-m|0;o=(n|0)/44|0;p=o+d|0;q=a+8|0;if((((c[q>>2]|0)-m|0)/44|0)>>>0<p>>>0){if(!p)r=0;else r=xCi(p*44|0)|0;m=r+((((n|0)/-44|0)+o|0)*44|0)|0;YEi(m|0,l|0,n|0)|0;c[a>>2]=m;c[k>>2]=r+(o*44|0);c[q>>2]=r+(p*44|0);if(l)ACi(l)}l=h+32|0;g[l>>2]=ea(0.0);p=h+36|0;g[p>>2]=ea(0.0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;if(!d){i=e;return 1}r=h+40|0;q=h+12|0;o=f+4|0;k=f+8|0;m=f+12|0;a=f+16|0;n=f+20|0;s=f+24|0;t=f+28|0;u=f+32|0;v=f+36|0;w=h+24|0;x=h+28|0;y=0;do{z=c[b+(y<<6)+4>>2]|0;c[r>>2]=c[z+8>>2];A=b+(y<<6)+16|0;c[h+0>>2]=c[A+0>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];A=b+(y<<6)+28|0;c[q+0>>2]=c[A+0>>2];c[q+4>>2]=c[A+4>>2];c[q+8>>2]=c[A+8>>2];c[f>>2]=5;g[o>>2]=ea(1.0);g[k>>2]=ea(1.0);g[m>>2]=ea(1.0);g[a>>2]=ea(0.0);g[n>>2]=ea(0.0);g[s>>2]=ea(0.0);g[t>>2]=ea(1.0);A=u;c[A>>2]=0;c[A+4>>2]=0;if(_n[c[(c[z>>2]|0)+56>>2]&4095](z,f)|0){z=c[v>>2]|0;A=mo[c[(c[z>>2]|0)+44>>2]&4095](z)|0;B=c[A+(c[b+(y<<6)+8>>2]<<2)>>2]|0}else B=-1;c[w>>2]=B;g[x>>2]=ea(g[b+(y<<6)+40>>2]);g[l>>2]=ea(g[b+(y<<6)+44>>2]);g[p>>2]=ea(g[b+(y<<6)+48>>2]);A=c[j>>2]|0;z=A+4|0;C=c[z>>2]|0;if((C|0)==(c[A+8>>2]|0))qHd(A,h);else{if(!C)D=0;else{A=C+0|0;C=h+0|0;E=A+44|0;do{c[A>>2]=c[C>>2];A=A+4|0;C=C+4|0}while((A|0)<(E|0));D=c[z>>2]|0}c[z>>2]=D+44}y=y+1|0}while((y|0)!=(d|0));i=e;return 1}function TGd(a){a=a|0;return}function UGd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function VGd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+48|0;h=g+32|0;j=g+16|0;k=g;if((f|0)==(c[b+8>>2]|0)){l=0;i=g;return l|0}if((a[(rVb(9)|0)+52>>0]|0)==0?(In[c[(c[e>>2]|0)+136>>2]&4095](h,e),(a[h>>0]&4)!=0):0){l=0;i=g;return l|0}In[c[(c[e>>2]|0)+92>>2]&4095](j,e);h=yEd(c[d+4>>2]|0,c[d+12>>2]|0)|0;d=yEd(c[j+4>>2]|0,c[j+12>>2]|0)|0;if((h|0)!=0&(d|0)!=0)m=JEd(h,d)|0;else m=0;d=c[b+12>>2]|0;In[c[(c[e>>2]|0)+92>>2]&4095](k,e);if((1<<(c[k>>2]&255)&d|0)==0|m){l=0;i=g;return l|0}l=(a[b+16>>0]|0)!=0?2:1;i=g;return l|0}function WGd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;if(!(ea(g[d+40>>2])>ea(0.0))){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function XGd(a){a=a|0;return}function YGd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function ZGd(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d>>2]=0;c[d+4>>2]=0;Hnd(d,3533,b,1);Fnd(d);i=a;return}function _Gd(a){a=a|0;var b=0;a=i;b=Pnd()|0;i=a;return b|0}function $Gd(a){a=a|0;return}function aHd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bHd(a){a=a|0;return}function cHd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function dHd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;f=i;i=i+16|0;e=f+4|0;d=f;c[d>>2]=c[153098];c[e+0>>2]=c[d+0>>2];d=cOb(b,16,e,0,3653512,309)|0;i=f;return d|0}function eHd(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a+4|0;e=a;c[e>>2]=c[153098];c[d+0>>2]=c[e+0>>2];eOb(b,d);i=a;return}function fHd(a){a=a|0;return}function gHd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function hHd(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;if((b|0)==2|(b|0)==128){i=a;return}else if((b|0)==1)Krd(c,0,3653512,326,4,0,0,0);Krd(c,0,d,e,1,0,0,0);i=a;return}function iHd(a){a=a|0;c[a>>2]=443968;c[a+8>>2]=0;return}function jHd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function kHd(b){b=b|0;a[b+20>>0]=1;return}function lHd(a){a=a|0;return 668608}function mHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=c[a>>2]|0;f=a+4|0;g=c[f>>2]|0;h=b+4|0;j=c[h>>2]|0;if((g|0)==(e|0)){k=j;l=e}else{m=g;g=j;while(1){j=m;m=m+-72|0;n=g+-72+0|0;o=m+0|0;p=n+60|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));o=g+-12|0;n=j+-12|0;c[o>>2]=o;c[g+-8>>2]=o;p=g+-4|0;c[p>>2]=0;q=c[j+-8>>2]|0;if((q|0)!=(n|0)){r=q;q=o;s=0;do{t=q;q=xCi(40)|0;u=r+8|0;v=q+8|0;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];c[v+24>>2]=c[u+24>>2];c[v+28>>2]=c[u+28>>2];c[q+4>>2]=o;c[q>>2]=t;c[t+4>>2]=q;c[o>>2]=q;s=s+1|0;c[p>>2]=s;r=c[r+4>>2]|0}while((r|0)!=(n|0))}n=(c[h>>2]|0)+-72|0;c[h>>2]=n;if((m|0)==(e|0)){w=n;break}else g=n}k=w;l=c[a>>2]|0}c[a>>2]=k;c[h>>2]=l;l=b+8|0;k=c[f>>2]|0;c[f>>2]=c[l>>2];c[l>>2]=k;k=a+8|0;a=b+12|0;l=c[k>>2]|0;c[k>>2]=c[a>>2];c[a>>2]=l;c[b>>2]=c[h>>2];i=d;return}function nHd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b+4|0;c[e>>2]=(c[g>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,e)|0)){i=d;return}rHd(b,c[e>>2]|0);h=c[g>>2]|0;a:do if(c[e>>2]|0){g=qdd(a,3142592,c[142304]|0,0,0)|0;j=a+80|0;k=c[($hd(c[j>>2]|0)|0)+12>>2]|0;l=a+84|0;c[c[l>>2]>>2]=0;if((g|0)!=2){sdd(a);g=c[b>>2]|0;if((g|0)==(h|0))break;else m=g;while(1){sHd(a,m,3142592,0);m=m+4|0;if((m|0)==(h|0))break a}}g=c[j>>2]|0;n=c[g+12>>2]|0;o=c[b>>2]|0;b:do if((o|0)!=(h|0)){p=a+12|0;q=a+16|0;r=a+28|0;s=a+32|0;t=a+20|0;u=0;v=g;w=o;while(1){x=(da(u,k)|0)+n|0;c[v+20>>2]=x;c[v+12>>2]=x;cid(f,v);x=f;y=c[x+4>>2]|0;z=v+24|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=c[l>>2]|0;c[y>>2]=(c[y>>2]|0)+1;y=c[q>>2]|0;z=(c[(c[j>>2]|0)+12>>2]|0)-(da(c[s>>2]|0,c[r>>2]|0)|0)|0;x=y+z|0;c[p>>2]=x;if((z|0)>=0?(A=y+(z+4)|0,A>>>0<=(c[t>>2]|0)>>>0):0){c[w>>2]=c[x>>2];c[p>>2]=A}else Bid(p,w,4);if(c[a>>2]&512)c[w>>2]=XEi(c[w>>2]|0)|0;A=w+4|0;if((A|0)==(h|0))break b;u=c[c[l>>2]>>2]|0;v=c[j>>2]|0;w=A}}while(0);sdd(a)}while(0);udd(a);i=d;return}function oHd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}rHd(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p<<2);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function pHd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;a=c[m>>2]|0;n=l>>>0>a>>>0;if(c[j>>2]|0){if(n){Bid(h,f,4);o=c[f>>2]|0;p=c[h>>2]|0;q=c[m>>2]|0}else{r=c[k>>2]|0;c[f>>2]=r;c[h>>2]=l;o=r;p=l;q=a}a=XEi(o|0)|0;c[f>>2]=a;o=p+4|0;if(o>>>0>q>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[p>>2]|0;c[e>>2]=f;c[h>>2]=o;s=f;t=a}a=XEi(s|0)|0;c[e>>2]=a;zid(h,a,t<<2)|0;c[j>>2]=0;i=d;return}if(n){Bid(h,g,4);u=c[g>>2]|0}else{n=c[k>>2]|0;c[g>>2]=n;c[h>>2]=l;u=n}n=XEi(u|0)|0;c[g>>2]=n;rHd(b,n);n=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(n|0)){i=d;return}else v=g;do{g=c[h>>2]|0;b=g+4|0;if(b>>>0>(c[m>>2]|0)>>>0){Bid(h,v,4);w=c[v>>2]|0}else{u=c[g>>2]|0;c[v>>2]=u;c[h>>2]=b;w=u}c[v>>2]=XEi(w|0)|0;v=v+4|0}while((v|0)!=(n|0));i=d;return}function qHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/44|0)+1|0;if(g>>>0>97612893)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/44|0;if(k>>>0<48806446){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/44|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=97612893;r=(l|0)/44|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*44|0)|0;o=r;p=s}s=n+(o*44|0)|0;r=n+(m*44|0)|0;if(s){m=s+0|0;s=b+0|0;b=m+44|0;do{c[m>>2]=c[s>>2];m=m+4|0;s=s+4|0}while((m|0)<(b|0))}s=n+((((p|0)/-44|0)+o|0)*44|0)|0;YEi(s|0,f|0,p|0)|0;c[a>>2]=s;c[e>>2]=n+((o+1|0)*44|0);c[h>>2]=r;if(!f){i=d;return}ACi(f);i=d;return}function rHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d;l=a+4|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;p=m-o>>2;if(p>>>0>=b>>>0){if(p>>>0<=b>>>0){i=d;return}q=n+(b<<2)|0;c[k>>2]=0;r=k+4|0;c[r>>2]=0;s=k+8|0;c[s>>2]=0;t=b<<2;u=t>>2;if(u){if(u>>>0>1073741823)vxi(k);v=xCi(t)|0;c[r>>2]=v;c[k>>2]=v;w=v+(u<<2)|0;c[s>>2]=w;if(!b){x=v;y=v;z=w}else{u=t+-4|0;t=n;A=v;while(1){c[A>>2]=c[t>>2];t=t+4|0;if((t|0)==(q|0))break;else A=A+4|0}A=v+((u>>>2)+1<<2)|0;c[r>>2]=A;x=v;y=A;z=w}}else{x=0;y=0;z=0}w=c[a>>2]|0;c[k>>2]=w;c[a>>2]=x;x=c[l>>2]|0;c[r>>2]=x;c[l>>2]=y;y=a+8|0;c[s>>2]=c[y>>2];c[y>>2]=z;if(!w){i=d;return}if((x|0)!=(w|0))c[r>>2]=x+(~((x+-4-w|0)>>>2)<<2);ACi(w);i=d;return}w=a+8|0;if(((c[w>>2]|0)-o>>2|0)==(b|0)){zxd(a,b-p|0);i=d;return}c[g>>2]=0;p=g+4|0;c[p>>2]=0;o=g+8|0;c[o>>2]=0;if(b){x=xCi(b<<2)|0;c[g>>2]=x;c[p>>2]=x;c[o>>2]=x+(b<<2)}c[h>>2]=n;c[j>>2]=m;c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];tHd(g,f,e);e=c[p>>2]|0;f=c[g>>2]|0;j=e-f>>2;if(j>>>0>=b>>>0)if(j>>>0>b>>>0?(h=f+(b<<2)|0,(e|0)!=(h|0)):0){m=e+(~((e+-4-h|0)>>>2)<<2)|0;c[p>>2]=m;B=f;C=m}else{B=f;C=e}else{zxd(g,b-j|0);B=c[g>>2]|0;C=c[p>>2]|0}j=c[a>>2]|0;c[g>>2]=j;c[a>>2]=B;B=c[l>>2]|0;c[p>>2]=B;c[l>>2]=C;C=c[o>>2]|0;c[o>>2]=c[w>>2];c[w>>2]=C;if(!j){i=d;return}if((B|0)!=(j|0))c[p>>2]=B+(~((B+-4-j|0)>>>2)<<2);ACi(j);i=d;return}function sHd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=qdd(a,d,c[142304]|0,f,0)|0;if(!g){i=e;return}if((g|0)>0){g=a+12|0;d=c[a+16>>2]|0;h=(c[(c[a+80>>2]|0)+12>>2]|0)-(da(c[a+32>>2]|0,c[a+28>>2]|0)|0)|0;j=d+h|0;c[g>>2]=j;if((h|0)>=0?(k=d+(h+4)|0,k>>>0<=(c[a+20>>2]|0)>>>0):0){c[b>>2]=c[j>>2];c[g>>2]=k}else Bid(g,b,4);if(c[a>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{g=c[f>>2]|0;if(g)_n[g&4095](b,a)|0}sdd(a);i=e;return}function tHd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=c[b>>2]|0;b=c[d>>2]|0;d=f;g=b-d>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=j-l>>2>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=n>>2;if(g>>>0<=o>>>0){p=b-d|0;aFi(k|0,f|0,p|0)|0;q=k+(p>>2<<2)|0;p=c[m>>2]|0;if((p|0)==(q|0)){i=e;return}c[m>>2]=p+(~((p+-4-q|0)>>>2)<<2);i=e;return}q=f+(o<<2)|0;aFi(k|0,f|0,n|0)|0;if((q|0)==(b|0)){i=e;return}n=c[m>>2]|0;o=(b+-4-q|0)>>>2;p=n;r=q;while(1){if(p)c[p>>2]=c[r>>2];r=r+4|0;if((r|0)==(b|0))break;else p=p+4|0}c[m>>2]=n+(o+1<<2);i=e;return}if(!k)s=j;else{j=a+4|0;o=c[j>>2]|0;if((o|0)!=(k|0))c[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;s=0}if(g>>>0>1073741823)vxi(a);j=s-0|0;if(j>>2>>>0<536870911){s=j>>1;j=s>>>0<g>>>0?g:s;if(j>>>0>1073741823)vxi(a);else t=j}else t=1073741823;j=xCi(t<<2)|0;s=a+4|0;c[s>>2]=j;c[a>>2]=j;c[h>>2]=j+(t<<2);if((f|0)==(b|0)){i=e;return}t=(b+-4-d|0)>>>2;d=f;f=j;while(1){c[f>>2]=c[d>>2];d=d+4|0;if((d|0)==(b|0))break;else f=f+4|0}c[s>>2]=j+(t+1<<2);i=e;return}function uHd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+96|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;k=b+40|0;l=c[k>>2]|0;if(l){m=mo[c[(c[l>>2]|0)+104>>2]&4095](l)|0;l=(m<<2)+15|0;n=l>>>0<2e3;o=(m|0)!=0;if(n)if(o){p=i;i=i+((1*l|0)+15&-16)|0;q=0;r=p}else{q=0;r=0}else if(o){c[h>>2]=c[153134];c[f+0>>2]=c[h+0>>2];h=cOb(l,16,f,0,3653512,226)|0;q=h;r=h}else{q=0;r=0}h=r+15&-16;r=c[k>>2]|0;kn[c[(c[r>>2]|0)+108>>2]&511](r,h,m,0)|0;if(n)if(o){n=i;i=i+((1*l|0)+15&-16)|0;s=0;t=n;u=12}else{v=0;w=0;x=0}else if(o){c[j>>2]=c[153134];c[f+0>>2]=c[j+0>>2];j=cOb(l,16,f,0,3653512,230)|0;s=j;t=j;u=12}else{v=0;w=0;x=0}if((u|0)==12){u=t+15&-16;t=(m|0)>0;if(t){j=0;do{l=c[(c[h+(j<<2)>>2]|0)+8>>2]|0;c[u+(j<<2)>>2]=l;ko[c[(c[l>>2]|0)+144>>2]&4095](l);j=j+1|0}while((j|0)<(m|0));v=t;w=u;x=s}else{v=0;w=u;x=s}}s=b+44|0;u=c[s>>2]|0;a:do if((u|0)!=0?(t=c[u+48>>2]|0,(t|0)!=0):0){j=u;h=0;while(1){l=mFa(j+72|0,h)|0;c[f+(h<<2)>>2]=l;ko[c[(c[l>>2]|0)+144>>2]&4095](l);l=h+1|0;if(l>>>0>=t>>>0){y=t;break a}j=c[s>>2]|0;h=l}}else y=0;while(0);if(a[b+68>>0]|0){s=LFd()|0;co[c[(c[s>>2]|0)+52>>2]&2047](s,c[k>>2]|0,1)}s=c[k>>2]|0;ko[c[c[s>>2]>>2]&4095](s);c[k>>2]=0;if(d){if(v){v=0;do{mEd(c[w+(v<<2)>>2]|0,b);v=v+1|0}while((v|0)<(m|0))}if(y){m=0;do{PHd(c[f+(m<<2)>>2]|0,b);m=m+1|0}while(m>>>0<y>>>0)}}y=b+92|0;m=c[y>>2]|0;if(m){v=c[m>>2]|0;if(v){w=m+4|0;c[v+4>>2]=c[w>>2];c[c[w>>2]>>2]=v}ACi(m)}c[y>>2]=0;c[b+80>>2]=c[b+76>>2];a[b+85>>0]=a[b+84>>0]|0;if(x){c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];eOb(x,f)}if(q){c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];eOb(q,f)}}f=b+28|0;q=c[f>>2]|0;if(!q){i=e;return}g=b+32|0;c[q+4>>2]=c[g>>2];c[c[g>>2]>>2]=q;c[f>>2]=0;c[g>>2]=0;i=e;return}function vHd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+13|0;g=e;h=e+12|0;j=b+71|0;a[j>>0]=d&1;k=b+40|0;l=c[k>>2]|0;In[c[(c[l>>2]|0)+200>>2]&4095](f,l);if(!((a[f>>0]&1)!=0^d)){i=e;return}c[g+8>>2]=0;c[g+4>>2]=0;c[g>>2]=0;if(d){d=c[k>>2]|0;co[c[(c[d>>2]|0)+184>>2]&2047](d,1,1);if(a[b+68>>0]|0)KGc(BTb(c[b+24>>2]|0)|0,555384,g)}else{if(a[b+68>>0]|0)KGc(BTb(c[b+24>>2]|0)|0,555384,g);g=c[k>>2]|0;co[c[(c[g>>2]|0)+184>>2]&2047](g,1,0)}DHd(b);EHd(b);g=c[k>>2]|0;In[c[(c[g>>2]|0)+200>>2]&4095](h,g);g=a[h>>0]&1;a[j>>0]=g;h=b+88|0;c[h>>2]=c[h>>2]&-2;if(g<<24>>24){i=e;return}g=c[k>>2]|0;if(!(mo[c[(c[g>>2]|0)+28>>2]&4095](g)|0)){i=e;return}if(a[j>>0]|0){i=e;return}j=c[k>>2]|0;ko[c[(c[j>>2]|0)+284>>2]&4095](j);i=e;return}function wHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+80|0;if((c[h>>2]|0)==(b|0)){i=d;return}c[a+76>>2]=b;c[h>>2]=b;b=a+40|0;a=c[b>>2]|0;if(!a){i=d;return}h=mo[c[(c[a>>2]|0)+104>>2]&4095](a)|0;a=(h<<2)+15|0;j=(h|0)!=0;if(a>>>0<2e3)if(j){k=i;i=i+((1*a|0)+15&-16)|0;l=0;m=k}else{l=0;m=0}else if(j){c[g>>2]=c[153134];c[e+0>>2]=c[g+0>>2];g=cOb(a,16,e,0,3653512,1335)|0;l=g;m=g}else{l=0;m=0}g=m+15&-16;m=c[b>>2]|0;kn[c[(c[m>>2]|0)+108>>2]&511](m,g,h,0)|0;if((h|0)>0){m=0;do{b=c[(c[g+(m<<2)>>2]|0)+8>>2]|0;ko[c[(c[b>>2]|0)+148>>2]&4095](b);m=m+1|0}while((m|0)<(h|0))}if(!l){i=d;return}c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];eOb(l,e);i=d;return}function xHd(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;f=i;i=i+112|0;h=f+24|0;j=f+64|0;k=f+68|0;l=f+96|0;m=f+12|0;n=f;o=f+52|0;p=b+40|0;if((c[p>>2]|0)!=0?(d[b+68>>0]|0)==(e&1|0):0){i=f;return}q=nFd()|0;r=c[q+100>>2]|0;s=ea(UFd(q));q=DFd()|0;t=c[(c[q>>2]|0)+108>>2]|0;g[k>>2]=ea(0.0);g[k+4>>2]=ea(0.0);g[k+8>>2]=ea(0.0);g[k+12>>2]=ea(1.0);g[k+16>>2]=ea(0.0);g[k+20>>2]=ea(0.0);g[k+24>>2]=ea(0.0);u=_n[t&4095](q,k)|0;co[c[(c[u>>2]|0)+292>>2]&2047](u,r,1);Fn[c[(c[u>>2]|0)+260>>2]&255](u,s);c[u+8>>2]=b;r=c[p>>2]|0;if(!r){a[b+68>>0]=e&1;c[p>>2]=u;k=c[(c[u>>2]|0)+140>>2]|0;g[o>>2]=ea(1.0);g[o+4>>2]=ea(1.0);g[o+8>>2]=ea(1.0);In[k&4095](u,o);o=c[p>>2]|0;s=ea(g[b+56>>2]);Fn[c[(c[o>>2]|0)+128>>2]&255](o,s);o=c[p>>2]|0;s=ea(g[b+60>>2]);Fn[c[(c[o>>2]|0)+232>>2]&255](o,s);o=c[p>>2]|0;s=ea(g[b+64>>2]);Fn[c[(c[o>>2]|0)+240>>2]&255](o,s);o=c[p>>2]|0;co[c[(c[o>>2]|0)+44>>2]&2047](o,2,(a[b+70>>0]|0)==0);o=c[p>>2]|0;co[c[(c[o>>2]|0)+184>>2]&2047](o,1,(a[b+71>>0]|0)!=0)}else{In[c[(c[r>>2]|0)+124>>2]&4095](h,r);s=ea(g[h+16>>2]);v=ea(g[h+20>>2]);w=ea(g[h+24>>2]);r=c[p>>2]|0;In[c[(c[r>>2]|0)+124>>2]&4095](h,r);x=ea(g[h>>2]);y=ea(g[h+4>>2]);z=ea(g[h+8>>2]);A=ea(g[h+12>>2]);r=c[p>>2]|0;In[c[(c[r>>2]|0)+144>>2]&4095](h,r);B=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);g[l>>2]=B;r=l+4|0;g[r>>2]=C;o=l+8|0;g[o>>2]=D;k=c[p>>2]|0;In[c[(c[k>>2]|0)+152>>2]&4095](h,k);D=ea(g[h>>2]);C=ea(g[h+4>>2]);B=ea(g[h+8>>2]);g[m>>2]=D;g[m+4>>2]=C;g[m+8>>2]=B;k=c[p>>2]|0;In[c[(c[k>>2]|0)+160>>2]&4095](h,k);B=ea(g[h>>2]);C=ea(g[h+4>>2]);D=ea(g[h+8>>2]);g[n>>2]=B;g[n+4>>2]=C;g[n+8>>2]=D;k=c[p>>2]|0;co[c[(c[k>>2]|0)+296>>2]&2047](k,h,j);j=c[h>>2]|0;k=c[p>>2]|0;D=ea(Kn[c[(c[k>>2]|0)+264>>2]&255](k));uHd(b,1);a[b+68>>0]=e&1;c[p>>2]=u;k=b+69|0;do if(!(a[k>>0]|0)){In[c[(c[u>>2]|0)+124>>2]&4095](h,u);g[h+16>>2]=s;g[h+20>>2]=v;g[h+24>>2]=w;q=c[p>>2]|0;In[c[(c[q>>2]|0)+120>>2]&4095](q,h);a[k>>0]=0;q=b+44|0;t=c[q>>2]|0;if(t)QHd(b,t,ea(g[b+56>>2]));a[k>>0]=0;t=c[p>>2]|0;In[c[(c[t>>2]|0)+124>>2]&4095](h,t);g[h>>2]=x;g[h+4>>2]=y;g[h+8>>2]=z;g[h+12>>2]=A;t=c[p>>2]|0;In[c[(c[t>>2]|0)+120>>2]&4095](t,h);t=c[q>>2]|0;if(t)QHd(b,t,ea(g[b+56>>2]));a[k>>0]=0;t=ea(g[l>>2])>ea(1.1920929e-07);q=t&ea(g[r>>2])>ea(1.1920929e-07);if(q&ea(g[o>>2])>ea(1.1920929e-07)){q=c[p>>2]|0;In[c[(c[q>>2]|0)+140>>2]&4095](q,l);break}else{Krd(668624,0,3653512,702,1,c[b+4>>2]|0,0,0);break}}while(0);l=c[p>>2]|0;co[c[(c[l>>2]|0)+156>>2]&2047](l,m,1);m=c[p>>2]|0;co[c[(c[m>>2]|0)+164>>2]&2047](m,n,1);n=c[p>>2]|0;co[c[(c[n>>2]|0)+292>>2]&2047](n,j,1);j=c[p>>2]|0;Fn[c[(c[j>>2]|0)+260>>2]&255](j,D);j=b+71|0;vHd(b,(a[j>>0]|0)!=0);n=b+56|0;D=ea(g[n>>2]);if(D<ea(1.00000001e-07))E=ea(1.00000001e-07);else{m=D>ea(1.0e9);E=m?ea(1.0e9):D}g[n>>2]=E;if(!(a[k>>0]|0)){k=c[p>>2]|0;Fn[c[(c[k>>2]|0)+128>>2]&255](k,D)}else EHd(b);k=c[b+44>>2]|0;if(k)QHd(b,k,ea(g[n>>2]));D=ea(g[b+60>>2]);n=c[p>>2]|0;Fn[c[(c[n>>2]|0)+232>>2]&255](n,D);D=ea(g[b+64>>2]);n=c[p>>2]|0;Fn[c[(c[n>>2]|0)+240>>2]&255](n,D);n=b+70|0;k=a[n>>0]|0;m=k<<24>>24!=0;if((m?(l=c[p>>2]|0,(mo[c[(c[l>>2]|0)+28>>2]&4095](l)|0)!=0):0)?(a[j>>0]|0)==0:0){j=c[p>>2]|0;ko[c[(c[j>>2]|0)+284>>2]&4095](j)}j=c[p>>2]|0;co[c[(c[j>>2]|0)+44>>2]&2047](j,2,m^1);a[n>>0]=k;wHd(b,c[b+76>>2]|0);CHd(b,(a[b+84>>0]|0)!=0)}if(e){e=LFd()|0;In[c[(c[e>>2]|0)+44>>2]&4095](e,c[p>>2]|0);In[c[(c[b>>2]|0)+96>>2]&4095](b,c[(c[b+24>>2]|0)+52>>2]|0)}DHd(b);i=f;return}function yHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im;d=i;i=i+16|0;e=d;f=c[b+40>>2]|0;In[c[(c[f>>2]|0)+152>>2]&4095](e,f);h=ea(g[e>>2]);j=ea(g[e+4>>2]);k=ea(g[e+8>>2]);g[a>>2]=h;g[a+4>>2]=j;g[a+8>>2]=k;i=d;return}function zHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im;d=i;i=i+16|0;e=d;f=c[b+40>>2]|0;In[c[(c[f>>2]|0)+160>>2]&4095](e,f);h=ea(g[e>>2]);j=ea(g[e+4>>2]);k=ea(g[e+8>>2]);g[a>>2]=h;g[a+4>>2]=j;g[a+8>>2]=k;i=d;return}function AHd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+40>>2]|0;co[c[(c[e>>2]|0)+156>>2]&2047](e,b,1);i=d;return}function BHd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+40>>2]|0;co[c[(c[e>>2]|0)+164>>2]&2047](e,b,1);i=d;return}function CHd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=b+85|0;if((e&1|0)==(d[k>>0]|0|0)){i=f;return}l=e&1;a[b+84>>0]=l;a[k>>0]=l;l=b+40|0;b=c[l>>2]|0;if(!b){i=f;return}k=mo[c[(c[b>>2]|0)+104>>2]&4095](b)|0;b=(k<<2)+15|0;e=(k|0)!=0;if(b>>>0<2e3)if(e){m=i;i=i+((1*b|0)+15&-16)|0;n=0;o=m}else{n=0;o=0}else if(e){c[j>>2]=c[153134];c[g+0>>2]=c[j+0>>2];j=cOb(b,16,g,0,3653512,1360)|0;n=j;o=j}else{n=0;o=0}j=o+15&-16;o=c[l>>2]|0;kn[c[(c[o>>2]|0)+108>>2]&511](o,j,k,0)|0;if((k|0)>0){o=0;do{l=c[(c[j+(o<<2)>>2]|0)+8>>2]|0;ko[c[(c[l>>2]|0)+148>>2]&4095](l);o=o+1|0}while((o|0)<(k|0))}if(!n){i=f;return}c[h>>2]=c[153134];c[g+0>>2]=c[h+0>>2];eOb(n,g);i=f;return}function DHd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;if((a[b+86>>0]|0)!=0?(a[b+68>>0]|0)!=0:0){e=b+92|0;if(c[e>>2]|0){i=d;return}f=xCi(44)|0;h=f+0|0;j=h+40|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));c[e>>2]=f;c[f+36>>2]=b;c[f+40>>2]=1;h=f+8|0;c[h+0>>2]=c[150284];c[h+4>>2]=c[150285];c[h+8>>2]=c[150286];g[f+20>>2]=ea(0.0);g[f+24>>2]=ea(0.0);g[f+28>>2]=ea(0.0);g[f+32>>2]=ea(1.0);f=(nFd()|0)+116|0;h=c[e>>2]|0;if((h|0)==(f|0)){i=d;return}e=c[h>>2]|0;j=h+4|0;if(e){c[e+4>>2]=c[j>>2];c[c[j>>2]>>2]=e;c[h>>2]=0;c[j>>2]=0}e=c[f>>2]|0;c[h>>2]=e;c[j>>2]=f;c[e+4>>2]=h;c[c[j>>2]>>2]=h;i=d;return}h=b+92|0;b=c[h>>2]|0;if(b){j=c[b>>2]|0;if(j){e=b+4|0;c[j+4>>2]=c[e>>2];c[c[e>>2]>>2]=j}ACi(b)}c[h>>2]=0;i=d;return}function EHd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im;d=i;i=i+64|0;e=d+4|0;f=d+12|0;h=d+8|0;j=d+44|0;k=d;l=d+48|0;m=d+16|0;if(a[b+71>>0]|0){n=c[b+40>>2]|0;o=ea(g[b+56>>2]);Fn[c[(c[n>>2]|0)+128>>2]&255](n,o);i=d;return}if(a[b+69>>0]|0){n=b+40|0;p=c[n>>2]|0;q=mo[c[(c[p>>2]|0)+104>>2]&4095](p)|0;p=(q<<2)+15|0;r=(q|0)!=0;if(p>>>0<2e3)if(r){s=i;i=i+((1*p|0)+15&-16)|0;t=0;u=s}else{t=0;u=0}else if(r){c[k>>2]=c[153134];c[e+0>>2]=c[k+0>>2];k=cOb(p,16,e,0,3653512,590)|0;t=k;u=k}else{t=0;u=0}k=u+15&-16;u=c[n>>2]|0;kn[c[(c[u>>2]|0)+108>>2]&511](u,k,q,0)|0;a:do if((q|0)>0){u=0;while(1){p=c[k+(u<<2)>>2]|0;In[c[(c[p>>2]|0)+136>>2]&4095](l,p);u=u+1|0;if(!(a[l>>0]&4))break;if((u|0)>=(q|0))break a}u=b+56|0;nU(c[n>>2]|0,ea(g[u>>2]),0,0)|0;p=c[b+44>>2]|0;if(p)QHd(b,p,ea(g[u>>2]));if(!(c[b+72>>2]|0)){if(!t){i=d;return}c[h>>2]=c[153134];c[e+0>>2]=c[h+0>>2];eOb(t,e);i=d;return}else{FHd(b);if(!t){i=d;return}c[j>>2]=c[153134];c[e+0>>2]=c[j+0>>2];eOb(t,e);i=d;return}}while(0);j=c[n>>2]|0;o=ea(g[b+56>>2]);Fn[c[(c[j>>2]|0)+128>>2]&255](j,o);j=c[n>>2]|0;In[c[(c[j>>2]|0)+124>>2]&4095](m,j);o=ea(g[150284]);v=ea(g[150285]);w=ea(g[150286]);g[m+16>>2]=o;g[m+20>>2]=v;g[m+24>>2]=w;j=c[n>>2]|0;In[c[(c[j>>2]|0)+120>>2]&4095](j,m);m=c[n>>2]|0;In[c[(c[m>>2]|0)+140>>2]&4095](m,601152);if(c[b+72>>2]|0)FHd(b);if(t){c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];eOb(t,e)}}e=c[b+44>>2]|0;if(!e){i=d;return}QHd(b,e,ea(g[b+56>>2]));i=d;return}function FHd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=Im,J=0,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=0,$=Im,aa=0,ba=Im,ca=Im;d=i;i=i+176|0;e=d+124|0;f=d+72|0;h=d+16|0;j=d+32|0;k=d+152|0;l=d;m=d+60|0;n=d+112|0;o=d+84|0;p=c[b+72>>2]|0;q=BTb(c[b+24>>2]|0)|0;r=b+40|0;s=c[r>>2]|0;In[c[(c[s>>2]|0)+124>>2]&4095](e,s);rGc(f,q);t=ea(g[f>>2]);u=ea(g[f+4>>2]);v=ea(g[f+8>>2]);oGc(h,q);w=ea(g[h>>2]);x=ea(g[h+4>>2]);y=ea(g[h+8>>2]);z=ea(g[h+12>>2]);h=c[r>>2]|0;In[c[(c[h>>2]|0)+84>>2]&4095](j,h);h=e+16|0;A=ea(ea(g[h>>2])*ea(2.0));q=e+20|0;B=ea(ea(g[q>>2])*ea(2.0));f=e+24|0;C=ea(ea(g[f>>2])*ea(2.0));D=ea(ea(z*z)+ea(-.5));E=ea(ea(ea(w*A)+ea(x*B))+ea(y*C));F=ea(u+ea(ea(x*E)+ea(ea(D*B)+ea(z*ea(ea(y*A)-ea(w*C))))));u=ea(v+ea(ea(ea(D*C)+ea(z*ea(ea(w*B)-ea(x*A))))+ea(y*E)));v=ea(g[e>>2]);s=e+12|0;G=ea(g[s>>2]);H=e+8|0;I=ea(g[H>>2]);J=e+4|0;K=ea(g[J>>2]);L=ea(g[j+12>>2]);M=ea(ea(L*L)+ea(-.5));N=ea(g[j>>2]);O=ea(A*N);P=ea(g[j+4>>2]);Q=ea(O+ea(B*P));O=ea(g[j+8>>2]);R=ea(Q+ea(C*O));Q=ea(ea(N*R)+ea(ea(A*M)+ea(L*ea(ea(C*P)-ea(B*O)))));S=ea(ea(P*R)+ea(ea(B*M)+ea(L*ea(ea(A*O)-ea(C*N)))));T=ea(ea(ea(C*M)+ea(L*ea(ea(B*N)-ea(A*P))))+ea(O*R));R=ea(ea(g[j+16>>2])+Q);Q=ea(ea(g[j+20>>2])+S);S=ea(ea(g[j+24>>2])+T);T=ea(ea(ea(ea(v*L)+ea(G*N))+ea(I*P))-ea(K*O));M=ea(ea(ea(v*O)+ea(ea(K*L)+ea(G*P)))-ea(I*N));U=ea(ea(ea(K*N)+ea(ea(I*L)+ea(G*O)))-ea(v*P));V=ea(ea(ea(ea(G*L)-ea(v*N))-ea(K*P))-ea(I*O));j=c[r>>2]|0;In[c[(c[j>>2]|0)+152>>2]&4095](k,j);if(!(p&2))W=R;else{R=ea(t+ea(ea(w*E)+ea(ea(D*A)+ea(z*ea(ea(x*C)-ea(y*B))))));g[k>>2]=ea(0.0);W=R}if(!(p&4))X=Q;else{g[k+4>>2]=ea(0.0);X=F}if(!(p&8))Y=S;else{g[k+8>>2]=ea(0.0);Y=u}j=b+71|0;if(!(a[j>>0]|0)){b=c[r>>2]|0;co[c[(c[b>>2]|0)+156>>2]&2047](b,k,0)}do if(p&112){k=c[r>>2]|0;In[c[(c[k>>2]|0)+160>>2]&4095](l,k);u=ea(ea(g[l>>2])*ea(2.0));S=ea(ea(g[l+4>>2])*ea(2.0));F=ea(ea(g[l+8>>2])*ea(2.0));Q=ea(ea(V*V)+ea(-.5));R=ea(ea(ea(T*u)+ea(M*S))+ea(U*F));B=ea(ea(T*R)+ea(ea(Q*u)-ea(V*ea(ea(M*F)-ea(U*S)))));y=ea(ea(M*R)+ea(ea(Q*S)-ea(V*ea(ea(U*u)-ea(T*F)))));C=ea(ea(ea(Q*F)-ea(V*ea(ea(T*S)-ea(M*u))))+ea(U*R));k=c[r>>2]|0;In[c[(c[k>>2]|0)+144>>2]&4095](m,k);if((p&16|0)!=0?ea(g[m>>2])>ea(0.0):0){g[m>>2]=ea(0.0);Z=ea(0.0);_=1}else{Z=B;_=0}if((p&32|0)!=0?(k=m+4|0,ea(g[k>>2])>ea(0.0)):0){g[k>>2]=ea(0.0);$=ea(0.0);aa=1}else{$=y;aa=_}if((p&64|0)!=0?(k=m+8|0,ea(g[k>>2])>ea(0.0)):0){g[k>>2]=ea(0.0);ba=ea(0.0)}else if(aa)ba=C;else{ca=Q;break}k=c[r>>2]|0;In[c[(c[k>>2]|0)+140>>2]&4095](k,m);if(!(a[j>>0]|0)){k=c[r>>2]|0;b=c[(c[k>>2]|0)+164>>2]|0;C=ea(Z*ea(2.0));y=ea($*ea(2.0));B=ea(ba*ea(2.0));R=ea(ea(ea(T*C)+ea(M*y))+ea(U*B));u=ea(ea(M*R)+ea(ea(Q*y)+ea(V*ea(ea(U*C)-ea(T*B)))));S=ea(ea(ea(V*ea(ea(T*y)-ea(M*C)))+ea(Q*B))+ea(U*R));g[n>>2]=ea(ea(T*R)+ea(ea(Q*C)+ea(V*ea(ea(M*B)-ea(U*y)))));g[n+4>>2]=u;g[n+8>>2]=S;co[b&2047](k,n,1);ca=Q}else ca=Q}else ca=ea(ea(V*V)+ea(-.5));while(0);n=c[r>>2]|0;r=c[(c[n>>2]|0)+88>>2]|0;ba=ea(g[h>>2]);$=ea(g[q>>2]);Z=ea(ba*ea(-2.0));ba=ea($*ea(-2.0));$=ea(ea(g[f>>2])*ea(-2.0));Q=ea(g[s>>2]);S=ea(ea(Q*Q)+ea(-.5));u=ea(g[e>>2]);y=ea(Z*u);B=ea(g[J>>2]);C=ea(y+ea(ba*B));y=ea(g[H>>2]);R=ea(C+ea($*y));C=ea(-u);F=ea(-B);x=ea(-y);z=ea(ea(ea(u*R)+ea(ea(Z*S)-ea(Q*ea(ea($*B)-ea(ba*y)))))*ea(2.0));A=ea(ea(ea(B*R)+ea(ea(ba*S)-ea(Q*ea(ea(Z*y)-ea($*u)))))*ea(2.0));D=ea(ea(ea(ea($*S)-ea(Q*ea(ea(ba*u)-ea(Z*B))))+ea(y*R))*ea(2.0));R=ea(ea(U*D)+ea(ea(T*z)+ea(M*A)));y=ea(W+ea(ea(T*R)+ea(ea(ca*z)+ea(V*ea(ea(M*D)-ea(U*A))))));W=ea(X+ea(ea(M*R)+ea(ea(ca*A)+ea(V*ea(ea(U*z)-ea(T*D))))));X=ea(Y+ea(ea(ea(ca*D)+ea(V*ea(ea(T*A)-ea(M*z))))+ea(U*R)));R=ea(ea(ea(U*C)+ea(ea(M*Q)+ea(V*F)))-ea(T*x));z=ea(ea(ea(T*F)+ea(ea(U*Q)+ea(V*x)))-ea(M*C));A=ea(ea(ea(ea(V*Q)-ea(T*C))-ea(M*F))-ea(U*x));g[o>>2]=ea(ea(ea(ea(T*Q)+ea(V*C))+ea(M*x))-ea(U*F));g[o+4>>2]=R;g[o+8>>2]=z;g[o+12>>2]=A;g[o+16>>2]=y;g[o+20>>2]=W;g[o+24>>2]=X;co[r&2047](n,o,0);i=d;return}function GHd(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+40>>2]|0;e=ea(Kn[c[(c[d>>2]|0)+132>>2]&255](d));i=b;return ea(e)}function HHd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=Im;e=i;i=i+96|0;f=e+56|0;h=e+28|0;j=e;k=b+40|0;l=c[k>>2]|0;In[c[(c[l>>2]|0)+84>>2]&4095](j,l);m=ea(g[d>>2]);n=ea(g[d+4>>2]);o=ea(g[d+8>>2]);d=j+16|0;g[d>>2]=m;l=j+20|0;g[l>>2]=n;p=j+24|0;g[p>>2]=o;if(!(a[b+71>>0]|0)){q=c[b+92>>2]|0;if(!q){r=c[k>>2]|0;s=c[r>>2]|0;t=s+88|0;u=c[t>>2]|0;co[u&2047](r,j,1);i=e;return}c[q+40>>2]=1;r=c[k>>2]|0;s=c[r>>2]|0;t=s+88|0;u=c[t>>2]|0;co[u&2047](r,j,1);i=e;return}if(a[b+68>>0]|0){q=c[k>>2]|0;if(!(_n[c[(c[q>>2]|0)+228>>2]&4095](q,h)|0)){q=c[k>>2]|0;In[c[(c[q>>2]|0)+84>>2]&4095](f,q);o=ea(g[f>>2]);n=ea(g[f+4>>2]);m=ea(g[f+8>>2]);v=ea(g[f+12>>2]);g[h>>2]=o;g[h+4>>2]=n;g[h+8>>2]=m;g[h+12>>2]=v}g[h+16>>2]=ea(g[d>>2]);g[h+20>>2]=ea(g[l>>2]);g[h+24>>2]=ea(g[p>>2]);p=c[k>>2]|0;In[c[(c[p>>2]|0)+224>>2]&4095](p,h)}h=b+88|0;c[h>>2]=c[h>>2]&-2;r=c[k>>2]|0;s=c[r>>2]|0;t=s+88|0;u=c[t>>2]|0;co[u&2047](r,j,1);i=e;return}function IHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im;d=i;i=i+32|0;e=d;f=c[b+40>>2]|0;In[c[(c[f>>2]|0)+84>>2]&4095](e,f);h=ea(g[e+16>>2]);j=ea(g[e+20>>2]);k=ea(g[e+24>>2]);g[a>>2]=h;g[a+4>>2]=j;g[a+8>>2]=k;i=d;return}function JHd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0;e=i;i=i+96|0;f=e+56|0;h=e+28|0;j=e;l=b+40|0;m=c[l>>2]|0;In[c[(c[m>>2]|0)+84>>2]&4095](j,m);n=ea(g[d>>2]);o=ea(g[d+4>>2]);p=ea(g[d+8>>2]);q=ea(g[d+12>>2]);g[j>>2]=n;d=j+4|0;g[d>>2]=o;m=j+8|0;g[m>>2]=p;r=j+12|0;g[r>>2]=q;if(((g[k>>2]=n,c[k>>2]|0)&2139095040)>>>0<2139095040){if(((((g[k>>2]=o,c[k>>2]|0)&2139095040)>>>0<2139095040?((g[k>>2]=p,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?((g[k>>2]=q,c[k>>2]|0)&2139095040)>>>0<2139095040:0)?ea(S(ea(ea(T(ea(ea(q*q)+ea(ea(ea(n*n)+ea(o*o))+ea(p*p)))))+ea(-1.0))))<ea(.00999999977):0){if(!(a[b+71>>0]|0)){s=c[b+92>>2]|0;if(s)c[s+40>>2]=1}else{if(a[b+68>>0]|0){s=c[l>>2]|0;if(!(_n[c[(c[s>>2]|0)+228>>2]&4095](s,h)|0)){s=c[l>>2]|0;In[c[(c[s>>2]|0)+84>>2]&4095](f,s);p=ea(g[f+16>>2]);o=ea(g[f+20>>2]);n=ea(g[f+24>>2]);g[h+16>>2]=p;g[h+20>>2]=o;g[h+24>>2]=n}g[h>>2]=ea(g[j>>2]);g[h+4>>2]=ea(g[d>>2]);g[h+8>>2]=ea(g[m>>2]);g[h+12>>2]=ea(g[r>>2]);r=c[l>>2]|0;In[c[(c[r>>2]|0)+224>>2]&4095](r,h)}h=b+88|0;c[h>>2]=c[h>>2]&-2}h=c[l>>2]|0;co[c[(c[h>>2]|0)+88>>2]&2047](h,j,1);i=e;return}if(!b)t=0;else u=7}else u=7;if((u|0)==7)t=c[b+4>>2]|0;Krd(668688,0,3653512,1155,1,t,0,0);i=e;return}function KHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=Im;d=i;i=i+32|0;e=d;f=c[b+40>>2]|0;In[c[(c[f>>2]|0)+84>>2]&4095](e,f);h=ea(g[e>>2]);j=ea(g[e+4>>2]);k=ea(g[e+8>>2]);l=ea(g[e+12>>2]);g[a>>2]=h;g[a+4>>2]=j;g[a+8>>2]=k;g[a+12>>2]=l;i=d;return}function LHd(a){a=a|0;var b=0,d=0;b=i;d=c[a+40>>2]|0;a=mo[c[(c[d>>2]|0)+256>>2]&4095](d)|0;i=b;return a|0}function MHd(b){b=b|0;return (a[b+84>>0]|0)!=0|0}function NHd(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im;d=i;i=i+16|0;e=d;qGc(e,BTb(c[a+24>>2]|0)|0);f=ea(g[e>>2]);h=ea(f*ea(g[b>>2]));f=ea(g[e+4>>2]);j=ea(f*ea(g[b+4>>2]));f=ea(g[e+8>>2]);k=ea(f*ea(g[b+8>>2]));if(h<ea(0.0))l=ea(-h);else l=h;if(j<ea(0.0))m=ea(-j);else m=j;if(k<ea(0.0))n=ea(-k);else n=k;k=l<m?m:l;l=ea(ea(g[a+56>>2])*(k<n?n:k));if(!(l<ea(0.0))){o=l;p=o<ea(9.99999974e-06);q=p?ea(9.99999974e-06):o;i=d;return ea(q)}o=ea(-l);p=o<ea(9.99999974e-06);q=p?ea(9.99999974e-06):o;i=d;return ea(q)}function OHd(a,b){a=a|0;b=b|0;var d=0;d=i;AGc(a,BTb(c[b+24>>2]|0)|0,b+60|0);i=d;return}function PHd(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+24>>2]|0;if(!f){i=e;return}if(!(vTb(f)|0)){i=e;return}if(!(a[b+37>>0]|0)){i=e;return}In[c[(c[b>>2]|0)+136>>2]&4095](b,d);i=e;return}function QHd(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=Im,F=Im,G=Im,H=0,I=Im,J=Im,K=Im,L=Im,M=0,N=0;e=i;i=i+496|0;f=e+24|0;h=e+152|0;j=e+392|0;k=e+472|0;l=e+12|0;m=e;n=e+104|0;o=c[b+48>>2]|0;p=b+8|0;if(!o)q=0;else{r=b+72|0;b=f+4|0;s=f+4|0;t=f+4|0;u=k+4|0;v=k+8|0;w=0;x=0;while(1){if(_Ea(p,w)|0)y=x;else{z=mFa(r,w)|0;A=c[z+144>>2]|0;B=REa(p,A)|0;C=ea(g[z+80>>2]);D=z+24|0;qGc(f,BTb(c[D>>2]|0)|0);E=ea(g[z+84>>2]);F=ea(E*ea(g[b>>2]));if(F<ea(0.0))G=ea(-F);else G=F;H=G<ea(9.99999974e-06);F=H?ea(9.99999974e-06):G;qGc(f,BTb(c[D>>2]|0)|0);E=ea(g[z+68>>2]);I=ea(E*ea(g[s>>2]));if(I<ea(0.0))J=ea(-I);else J=I;H=J<ea(9.99999974e-06);I=H?ea(9.99999974e-06):J;qGc(f,BTb(c[D>>2]|0)|0);E=ea(g[z+88>>2]);K=ea(E*ea(g[t>>2]));if(K<ea(0.0))L=ea(-K);else L=K;D=L<ea(9.99999974e-06);RHd(z,a,B,C,F,D?ea(9.99999974e-06):L,I,k,l);WEa(p,A,k);UEa(p,A,l);SEa(p,A,l);g[h+(x*12|0)>>2]=ea(g[k>>2]);g[h+(x*12|0)+4>>2]=ea(g[u>>2]);g[h+(x*12|0)+8>>2]=ea(g[v>>2]);c[j+(x<<2)>>2]=A;y=x+1|0}w=w+1|0;if((w|0)==(o|0)){q=y;break}else x=y}}g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(0.0);nFa(q,h,m,d,1,f);m=(q|0)==0;if(m){i=e;return}else M=0;do{if(ea(g[f+(M<<2)>>2])<ea(0.0)){N=17;break}M=M+1|0}while(M>>>0<q>>>0);if((N|0)==17){L=ea(d/ea(q>>>0));N=0;do{g[f+(N<<2)>>2]=L;N=N+1|0}while((N|0)!=(q|0))}if(m){i=e;return}m=n+16|0;N=0;do{M=c[j+(N<<2)>>2]|0;L=ea(g[f+(N<<2)>>2]);h=n+0|0;y=(IEa(p,M)|0)+0|0;x=h+48|0;do{c[h>>2]=c[y>>2];h=h+4|0;y=y+4|0}while((h|0)<(x|0));y=L<ea(9.99999974e-06);g[m>>2]=y?ea(9.99999974e-06):L;JEa(p,M,n);N=N+1|0}while((N|0)!=(q|0));i=e;return}function RHd(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);h=ea(h);j=ea(j);k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;m=i;i=i+64|0;n=m+28|0;o=m;p=c[b+40>>2]|0;In[c[(c[p>>2]|0)+124>>2]&4095](n,p);SHd(o,a,0);q=ea(g[a+56>>2]);r=ea(g[a+60>>2]);s=ea(q*ea(2.0));q=ea(r*ea(2.0));r=ea(ea(g[a+64>>2])*ea(2.0));t=ea(g[o+12>>2]);u=ea(ea(t*t)+ea(-.5));v=ea(g[o>>2]);w=ea(s*v);x=ea(g[o+4>>2]);y=ea(w+ea(q*x));w=ea(g[o+8>>2]);z=ea(y+ea(r*w));y=ea(ea(v*z)+ea(ea(s*u)+ea(t*ea(ea(r*x)-ea(q*w)))));A=ea(ea(x*z)+ea(ea(q*u)+ea(t*ea(ea(s*w)-ea(r*v)))));B=ea(ea(ea(r*u)+ea(t*ea(ea(q*v)-ea(s*x))))+ea(w*z));z=ea(ea(g[o+16>>2])+y);y=ea(ea(g[o+20>>2])+A);A=ea(ea(g[o+24>>2])+B);B=ea(g[n+16>>2]);w=ea(g[n+20>>2]);x=ea(B*ea(-2.0));B=ea(w*ea(-2.0));w=ea(ea(g[n+24>>2])*ea(-2.0));s=ea(g[n+12>>2]);v=ea(ea(s*s)+ea(-.5));q=ea(g[n>>2]);t=ea(x*q);u=ea(g[n+4>>2]);r=ea(t+ea(B*u));t=ea(g[n+8>>2]);C=ea(r+ea(w*t));r=ea(-q);D=ea(-u);E=ea(-t);F=ea(z*ea(2.0));z=ea(y*ea(2.0));y=ea(A*ea(2.0));A=ea(ea(ea(F*r)+ea(z*D))+ea(y*E));G=ea(ea(ea(q*C)+ea(ea(x*v)-ea(s*ea(ea(w*u)-ea(B*t)))))+ea(ea(A*r)+ea(ea(F*v)+ea(s*ea(ea(y*D)-ea(z*E))))));H=ea(ea(ea(u*C)+ea(ea(B*v)-ea(s*ea(ea(x*t)-ea(w*q)))))+ea(ea(A*D)+ea(ea(z*v)+ea(s*ea(ea(F*E)-ea(y*r))))));I=ea(ea(ea(ea(w*v)-ea(s*ea(ea(B*q)-ea(x*u))))+ea(t*C))+ea(ea(ea(y*v)+ea(s*ea(ea(z*r)-ea(F*D))))+ea(A*E)));g[k>>2]=G;n=k+4|0;g[n>>2]=H;o=k+8|0;g[o>>2]=I;E=ea(ea(1.0)-e);e=ea(E*ea(g[d>>2]));a=d+4|0;A=ea(E*ea(g[a>>2]));p=d+8|0;D=ea(A*f);A=ea(ea(E*ea(g[p>>2]))*f);E=ea(ea(e*f)+G);g[k>>2]=E;G=ea(D+H);g[n>>2]=G;H=ea(A+I);g[o>>2]=H;I=ea(j-h);h=ea(I*ea(g[d>>2]));j=ea(I*ea(g[a>>2]));A=ea(j+G);G=ea(H+ea(I*ea(g[p>>2])));g[l>>2]=ea(h+E);g[l+4>>2]=A;g[l+8>>2]=G;i=m;return}function SHd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=0;e=i;g[a>>2]=ea(0.0);f=a+4|0;g[f>>2]=ea(0.0);h=a+8|0;g[h>>2]=ea(0.0);j=a+12|0;g[j>>2]=ea(1.0);k=a+16|0;g[k>>2]=ea(0.0);l=a+20|0;g[l>>2]=ea(0.0);m=a+24|0;g[m>>2]=ea(0.0);n=b+24|0;b=ATb(c[n>>2]|0,54)|0;if(((b|0)!=0?(o=c[b+24>>2]|0,(o|0)!=0):0)?!((b|0)==(d|0)|(vTb(o)|0)^1):0){i=e;return}o=BTb(c[n>>2]|0)|0;n=c[o+156>>2]|0;if(!n){i=e;return}else{p=ea(0.0);q=ea(0.0);r=ea(0.0);s=ea(0.0);t=ea(1.0);u=ea(0.0);v=ea(0.0);w=o;x=n}while(1){y=ea(g[w+44>>2]);z=ea(g[w+48>>2]);A=ea(g[w+52>>2]);B=ea(g[w+28>>2]);C=ea(g[w+32>>2]);D=ea(g[w+36>>2]);E=ea(g[w+40>>2]);F=ea(p*ea(2.0));G=ea(q*ea(2.0));H=ea(r*ea(2.0));I=ea(ea(E*E)+ea(-.5));J=ea(ea(ea(B*F)+ea(C*G))+ea(D*H));p=ea(y+ea(ea(B*J)+ea(ea(F*I)+ea(E*ea(ea(C*H)-ea(D*G))))));q=ea(z+ea(ea(C*J)+ea(ea(I*G)+ea(E*ea(ea(D*F)-ea(B*H))))));r=ea(A+ea(ea(ea(I*H)+ea(E*ea(ea(B*G)-ea(C*F))))+ea(D*J)));J=s;s=ea(ea(ea(ea(E*s)+ea(B*t))+ea(C*u))-ea(D*v));F=v;v=ea(ea(ea(D*J)+ea(ea(C*t)+ea(E*v)))-ea(B*u));G=u;u=ea(ea(ea(B*F)+ea(ea(D*t)+ea(E*u)))-ea(C*J));t=ea(ea(ea(ea(E*t)-ea(B*J))-ea(C*F))-ea(D*G));g[a>>2]=s;g[f>>2]=v;g[h>>2]=u;g[j>>2]=t;g[k>>2]=p;g[l>>2]=q;g[m>>2]=r;n=c[x+24>>2]|0;if((((n|0)!=0?(o=ATb(n,54)|0,(o|0)!=0):0)?(n=c[o+24>>2]|0,(n|0)!=0):0)?!((o|0)==(d|0)|(vTb(n)|0)^1):0){K=10;break}n=c[x+156>>2]|0;if(!n){K=10;break}else{o=x;x=n;w=o}}if((K|0)==10){i=e;return}}function THd(){var a=0,b=0;a=i;b=xCi(4)|0;c[b>>2]=668744;ALc(b);i=a;return}function UHd(){var a=0,b=0;a=i;b=zLc()|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);ALc(0);i=a;return}function VHd(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;var f=0;a=i;f=VFd(nFd()|0,b,c,e,d)|0;i=a;return f|0}function WHd(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;i=i+16|0;g=a+4|0;h=a;j=WFd(nFd()|0,b,d,e)|0;e=j+4|0;b=(c[e>>2]|0)-(c[j>>2]|0)|0;k=(b|0)/44|0;l=f+12|0;m=c[l>>2]|0;do if((m&2147483647)>>>0<k>>>0)if((m|0)>-1){c[l>>2]=k;n=c[f>>2]|0;c[h>>2]=c[f+4>>2];c[g+0>>2]=c[h+0>>2];c[f>>2]=hOb(n,b,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[f+4>>2];c[g+0>>2]=c[h+0>>2];n=cOb(b,4,g,0,3653512,352)|0;YEi(n|0,c[f>>2]|0,(c[f+8>>2]|0)*44|0)|0;c[l>>2]=k;c[f>>2]=n;break}while(0);k=c[j>>2]|0;if((c[e>>2]|0)==(k|0)){i=a;return}b=f+8|0;m=f+4|0;n=k;k=0;do{o=n+(k*44|0)|0;p=(c[b>>2]|0)+1|0;c[b>>2]=p;q=c[l>>2]|0;r=q&2147483647;if(p>>>0>r>>>0){s=q<<1;t=(s|0)==0?1:s;do if(r>>>0<t>>>0)if((q|0)>-1){c[l>>2]=t;s=c[f>>2]|0;c[h>>2]=c[m>>2];c[g+0>>2]=c[h+0>>2];c[f>>2]=hOb(s,t*44|0,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[m>>2];c[g+0>>2]=c[h+0>>2];s=cOb(t*44|0,4,g,0,3653512,352)|0;YEi(s|0,c[f>>2]|0,(c[b>>2]|0)*44|0)|0;c[l>>2]=t;c[f>>2]=s;break}while(0);u=c[b>>2]|0}else u=p;t=(c[f>>2]|0)+((u+-1|0)*44|0)+0|0;q=o+0|0;r=t+44|0;do{c[t>>2]=c[q>>2];t=t+4|0;q=q+4|0}while((t|0)<(r|0));k=k+1|0;n=c[j>>2]|0}while((k|0)!=(((c[e>>2]|0)-n|0)/44|0|0));i=a;return}function XHd(a,d,e,f,h,j,k){a=a|0;d=d|0;e=ea(e);f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=0;a=i;i=i+224|0;l=a+64|0;m=a+136|0;n=a+96|0;o=a+192|0;p=a+220|0;q=a+168|0;r=a;s=d+12|0;t=ea(ea(g[s>>2])*e);u=ea(ea(g[d+16>>2])*e);v=ea(t*ea(.5));t=ea(u*ea(.5));u=ea(ea(ea(g[d+20>>2])*e)*ea(.5));w=ea(v+ea(g[d>>2]));y=d+4|0;z=ea(t+ea(g[y>>2]));A=d+8|0;B=ea(u+ea(g[A>>2]));if(v<ea(0.0))C=ea(-v);else C=v;if(t<ea(0.0))D=ea(-t);else D=t;if(u<ea(0.0))E=ea(-u);else E=u;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;g[q>>2]=w;g[q+4>>2]=z;g[q+8>>2]=B;g[q+12>>2]=ea(C+ea(9.99999974e-06));g[q+16>>2]=ea(D+ea(9.99999974e-06));g[q+20>>2]=ea(E+ea(9.99999974e-06));if(!j){F=ea(x);G=F<ea(x);i=a;return G|0}H=r+4|0;I=r+8|0;J=r+12|0;K=r+16|0;L=r+40|0;M=r+44|0;N=r+48|0;O=m+16|0;P=m+20|0;Q=m+24|0;R=l+12|0;S=l+4|0;T=l+8|0;U=l+16|0;V=l+20|0;W=l+24|0;X=m+12|0;Y=m+8|0;Z=m+4|0;_=o+4|0;$=o+8|0;aa=o+12|0;ba=o+16|0;ca=o+20|0;da=o+24|0;fa=r+20|0;ga=r+24|0;ha=k+28|0;ia=k+32|0;ja=k+4|0;ka=k+8|0;la=k+12|0;ma=k+16|0;k=r+28|0;E=ea(x);na=0;while(1){do if((((lmc(q,h+(na*24|0)|0)|0?(oa=c[f+(na<<4)+4>>2]|0,(oa|0)!=0):0)?(pa=c[f+(na<<4)>>2]|0,c[r>>2]=0,c[H>>2]=0,c[I>>2]=-1,b[J>>1]=0,c[K+0>>2]=0,c[K+4>>2]=0,c[K+8>>2]=0,c[K+12>>2]=0,c[K+16>>2]=0,c[K+20>>2]=0,g[L>>2]=ea(3402823469999999843913219.0e14),g[M>>2]=ea(0.0),g[N>>2]=ea(0.0),In[c[(c[oa>>2]|0)+32>>2]&4095](n,oa),In[c[(c[pa>>2]|0)+84>>2]&4095](l,pa),In[c[(c[oa>>2]|0)+72>>2]&4095](m,oa),D=ea(ea(g[O>>2])*ea(2.0)),C=ea(ea(g[P>>2])*ea(2.0)),B=ea(ea(g[Q>>2])*ea(2.0)),z=ea(g[R>>2]),w=ea(ea(z*z)+ea(-.5)),u=ea(g[l>>2]),t=ea(D*u),v=ea(g[S>>2]),qa=ea(t+ea(C*v)),t=ea(g[T>>2]),ra=ea(qa+ea(B*t)),qa=ea(ea(u*ra)+ea(ea(D*w)+ea(z*ea(ea(B*v)-ea(C*t))))),sa=ea(ea(v*ra)+ea(ea(C*w)+ea(z*ea(ea(D*t)-ea(B*u))))),ta=ea(ea(ea(B*w)+ea(z*ea(ea(C*u)-ea(D*v))))+ea(t*ra)),ra=ea(ea(g[U>>2])+qa),qa=ea(ea(g[V>>2])+sa),sa=ea(ea(g[W>>2])+ta),ta=ea(g[m>>2]),D=ea(z*ta),C=ea(g[X>>2]),w=ea(D+ea(u*C)),D=ea(g[Y>>2]),B=ea(w+ea(v*D)),w=ea(g[Z>>2]),ua=ea(ea(ea(t*ta)+ea(ea(v*C)+ea(z*w)))-ea(u*D)),va=ea(ea(ea(u*w)+ea(ea(t*C)+ea(z*D)))-ea(v*ta)),wa=ea(ea(ea(ea(z*C)-ea(u*ta))-ea(v*w))-ea(t*D)),g[o>>2]=ea(B-ea(t*w)),g[_>>2]=ua,g[$>>2]=va,g[aa>>2]=wa,g[ba>>2]=ra,g[ca>>2]=qa,g[da>>2]=sa,b[p>>1]=3,(zLa(d,s,n,o,e,p,1,r,0)|0)!=0):0)?(sa=ea(g[K>>2]),qa=ea(g[fa>>2]),ra=ea(g[ga>>2]),wa=ea(ea(g[d>>2])-sa),va=ea(ea(g[y>>2])-qa),ua=ea(ea(g[A>>2])-ra),w=ea(ea(ea(wa*wa)+ea(va*va))+ea(ua*ua)),w<E):0)?(pa=c[oa+8>>2]|0,(pa|0)!=0):0){if(mo[c[(c[pa>>2]|0)+116>>2]&4095](pa)|0?mo[c[(c[pa>>2]|0)+124>>2]&4095](pa)|0:0){xa=E;break}oa=pa+4|0;c[ha>>2]=c[oa>>2];ya=mo[c[(c[pa>>2]|0)+128>>2]&4095](pa)|0;c[ia>>2]=c[((ya|0)==0?oa:ya+4|0)>>2];g[ja>>2]=sa;g[ka>>2]=qa;g[la>>2]=ra;c[ma+0>>2]=c[k+0>>2];c[ma+4>>2]=c[k+4>>2];c[ma+8>>2]=c[k+8>>2];xa=w}else xa=E;while(0);na=na+1|0;if((na|0)==(j|0)){F=xa;break}else E=xa}G=F<ea(x);i=a;return G|0}function YHd(e,f,h,j,k,l){e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=0,C=0;e=i;i=i+128|0;m=e+104|0;n=e+84|0;o=e+48|0;p=e+32|0;q=e;r=ea(g[j+12>>2]);s=ea(g[j>>2]);t=ea(r+s);u=ea(g[j+16>>2]);v=ea(g[j+4>>2]);w=ea(u+v);x=ea(g[j+20>>2]);y=ea(g[j+8>>2]);z=ea(t*ea(.5));t=ea(w*ea(.5));w=ea(ea(x+y)*ea(.5));A=ea(ea(r-s)*ea(.5));s=ea(ea(u-v)*ea(.5));v=ea(ea(x-y)*ea(.5));j=c[f>>2]|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;b[m+16>>1]=l?5:7;a[m+18>>0]=0;c[n>>2]=668480;c[n+4>>2]=1;c[n+8>>2]=0;c[n+12>>2]=k;a[n+16>>0]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=-1;k=o+20|0;a[k>>0]=0;c[o+24>>2]=j;c[o+28>>2]=256;j=o+32|0;c[j>>2]=0;c[o>>2]=420288;l=LFd()|0;B=c[(c[l>>2]|0)+356>>2]|0;c[p>>2]=3;g[p+4>>2]=A;g[p+8>>2]=s;g[p+12>>2]=v;g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(1.0);g[q+16>>2]=z;g[q+20>>2]=t;g[q+24>>2]=w;Km[B&127](l,p,q,o,m,n)|0;n=(d[k>>0]|0)+(c[j>>2]|0)|0;if(!n){C=0;i=e;return C|0}j=0;do{ZHd(0,(c[h>>2]|0)+(j*24|0)|0,(c[f>>2]|0)+(j<<4)|0);j=j+1|0}while((j|0)!=(n|0));C=n;i=e;return C|0}function ZHd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im;a=i;i=i+160|0;e=a+124|0;f=a+96|0;h=a+56|0;j=a+24|0;k=a;l=c[d+4>>2]|0;m=c[d>>2]|0;In[c[(c[l>>2]|0)+32>>2]&4095](h,l);In[c[(c[m>>2]|0)+84>>2]&4095](e,m);In[c[(c[l>>2]|0)+72>>2]&4095](f,l);n=ea(ea(g[f+16>>2])*ea(2.0));o=ea(ea(g[f+20>>2])*ea(2.0));p=ea(ea(g[f+24>>2])*ea(2.0));q=ea(g[e+12>>2]);r=ea(ea(q*q)+ea(-.5));s=ea(g[e>>2]);t=ea(n*s);u=ea(g[e+4>>2]);v=ea(t+ea(o*u));t=ea(g[e+8>>2]);w=ea(v+ea(p*t));v=ea(ea(s*w)+ea(ea(n*r)+ea(q*ea(ea(p*u)-ea(o*t)))));x=ea(ea(u*w)+ea(ea(o*r)+ea(q*ea(ea(n*t)-ea(p*s)))));y=ea(ea(ea(p*r)+ea(q*ea(ea(o*s)-ea(n*u))))+ea(t*w));w=ea(ea(g[e+16>>2])+v);v=ea(ea(g[e+20>>2])+x);x=ea(ea(g[e+24>>2])+y);y=ea(g[f>>2]);n=ea(q*y);o=ea(g[f+12>>2]);r=ea(n+ea(s*o));n=ea(g[f+8>>2]);p=ea(r+ea(u*n));r=ea(g[f+4>>2]);z=ea(ea(ea(t*y)+ea(ea(u*o)+ea(q*r)))-ea(s*n));A=ea(ea(ea(s*r)+ea(ea(t*o)+ea(q*n)))-ea(u*y));B=ea(ea(ea(ea(q*o)-ea(s*y))-ea(u*r))-ea(t*n));g[j>>2]=ea(p-ea(t*r));g[j+4>>2]=z;g[j+8>>2]=A;g[j+12>>2]=B;g[j+16>>2]=w;g[j+20>>2]=v;g[j+24>>2]=x;ALa(k,h,j,ea(1.00999999));x=ea(g[k>>2]);v=ea(g[k+12>>2]);w=ea(x+v);B=ea(g[k+4>>2]);A=ea(g[k+16>>2]);z=ea(B+A);r=ea(g[k+8>>2]);t=ea(g[k+20>>2]);p=ea(z*ea(.5));z=ea(ea(r+t)*ea(.5));n=ea(ea(v-x)*ea(.5));x=ea(ea(A-B)*ea(.5));B=ea(ea(t-r)*ea(.5));g[b>>2]=ea(w*ea(.5));g[b+4>>2]=p;g[b+8>>2]=z;g[b+12>>2]=ea(n+ea(9.99999974e-06));g[b+16>>2]=ea(x+ea(9.99999974e-06));g[b+20>>2]=ea(B+ea(9.99999974e-06));i=a;return}function _Hd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=0;h=i;i=i+160|0;j=h+28|0;k=h+80|0;l=h+32|0;m=h+88|0;n=h+144|0;o=h;p=h+56|0;q=h+104|0;yLc(l,b);g[l>>2]=ea(ea(g[l>>2])+ea(-9.99999974e-06));r=l+4|0;g[r>>2]=ea(ea(g[r>>2])+ea(-9.99999974e-06));r=l+8|0;g[r>>2]=ea(ea(g[r>>2])+ea(-9.99999974e-06));r=l+12|0;g[r>>2]=ea(ea(g[r>>2])+ea(9.99999974e-06));r=l+16|0;g[r>>2]=ea(ea(g[r>>2])+ea(9.99999974e-06));r=l+20|0;g[r>>2]=ea(ea(g[r>>2])+ea(9.99999974e-06));r=c[153134]|0;c[m+4>>2]=r;c[m+8>>2]=256;c[m+12>>2]=256;c[k>>2]=r;c[j+0>>2]=c[k+0>>2];s=cOb(4096,4,j,0,3653512,352)|0;c[m>>2]=s;t=c[153134]|0;c[n+4>>2]=t;c[n+8>>2]=256;c[n+12>>2]=256;c[k>>2]=t;c[j+0>>2]=c[k+0>>2];u=cOb(6144,4,j,0,3653512,352)|0;c[n>>2]=u;v=YHd(a,m,n,l,e,f)|0;if(!v){w=0;c[k>>2]=t;c[j+0>>2]=c[k+0>>2];eOb(u,j);c[k>>2]=r;c[j+0>>2]=c[k+0>>2];eOb(s,j);i=h;return w|0}f=b+8|0;if(!(c[f>>2]|0)){w=0;c[k>>2]=t;c[j+0>>2]=c[k+0>>2];eOb(u,j);c[k>>2]=r;c[j+0>>2]=c[k+0>>2];eOb(s,j);i=h;return w|0}e=o+4|0;l=o+16|0;n=o+20|0;m=o+8|0;a=o+24|0;x=o+12|0;y=p+12|0;z=p+16|0;A=p+20|0;B=q+4|0;C=0;D=0;while(1){E=(c[b>>2]|0)+(D*28|0)|0;c[o+0>>2]=c[E+0>>2];c[o+4>>2]=c[E+4>>2];c[o+8>>2]=c[E+8>>2];c[o+12>>2]=c[E+12>>2];c[o+16>>2]=c[E+16>>2];c[o+20>>2]=c[E+20>>2];c[o+24>>2]=c[E+24>>2];if((xLc(o,u,v)|0?(F=ea(g[l>>2]),G=ea(F-ea(g[e>>2])),F=ea(g[n>>2]),H=ea(F-ea(g[m>>2])),F=ea(g[a>>2]),I=ea(F-ea(g[x>>2])),F=ea(T(ea(ea(ea(G*G)+ea(H*H))+ea(I*I)))),!(F<=ea(9.99999997e-07))):0)?(J=ea(G/F),G=ea(H/F),H=ea(I/F),c[p+0>>2]=0,c[p+4>>2]=0,c[p+8>>2]=0,c[p+12>>2]=0,c[p+16>>2]=0,c[p+0>>2]=c[e+0>>2],c[p+4>>2]=c[e+4>>2],c[p+8>>2]=c[e+8>>2],g[y>>2]=J,g[z>>2]=G,g[A>>2]=H,c[q>>2]=D,c[B+0>>2]=0,c[B+4>>2]=0,c[B+8>>2]=0,c[B+12>>2]=0,c[B+16>>2]=0,c[B+20>>2]=0,XHd(0,p,F,s,u,v,q)|0):0){E=(c[d>>2]|0)+(C*36|0)+0|0;K=q+0|0;L=E+36|0;do{c[E>>2]=c[K>>2];E=E+4|0;K=K+4|0}while((E|0)<(L|0));M=C+1|0}else M=C;D=D+1|0;if(D>>>0>=(c[f>>2]|0)>>>0){w=M;break}else C=M}c[k>>2]=t;c[j+0>>2]=c[k+0>>2];eOb(u,j);c[k>>2]=r;c[j+0>>2]=c[k+0>>2];eOb(s,j);i=h;return w|0}function $Hd(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;d=c[b+40>>2]|0;if(!d){e=0;i=a;return e|0}b=mo[c[(c[d>>2]|0)+128>>2]&4095](d)|0;if(!b){e=c[d+24>>2]|0;i=a;return e|0}else{e=c[b+24>>2]|0;i=a;return e|0}return 0}function aId(a){a=a|0;return}function bId(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function cId(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=xbc()|0;d=0;do{e=b+(d<<2)+64|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}}while((d|0)<16);if((g|0)==4)c[f>>2]=186;f=xbc()|0;d=0;do{b=f+(d<<2)|0;d=d+1|0;if(!(c[b>>2]|0)){h=b;g=8;break}}while((d|0)<16);if((g|0)==8)c[h>>2]=187;h=xbc()|0;d=0;while(1){f=h+(d<<2)+128|0;d=d+1|0;if(!(c[f>>2]|0)){j=f;break}if((d|0)>=16){g=13;break}}if((g|0)==13){i=a;return}c[j>>2]=188;i=a;return}function dId(){return}function eId(){var a=0;a=i;gId();i=a;return}function fId(){var a=0;a=i;hId();i=a;return}function gId(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153098];c[b+0>>2]=c[d+0>>2];d=bOb(4,b,1,16,3653512,140)|0;c[d>>2]=668776;uLc(d);i=a;return}function hId(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=tLc()|0;c[d>>2]=c[153098];c[b+0>>2]=c[d+0>>2];eOb(e,b);uLc(0);i=a;return}function iId(a,b,c){a=a|0;b=b|0;c=c|0;a=i;HHd(b,c);JHd(b,c+12|0);AHd(b,c+28|0);BHd(b,c+40|0);i=a;return}function jId(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+64|0;e=a+40|0;f=a+24|0;g=a+12|0;h=a;IHd(e,b);c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];e=d+12|0;KHd(f,b);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=d+28|0;yHd(g,b);c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];g=d+40|0;zHd(h,b);c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];i=a;return}function kId(a,b,c){a=a|0;b=b|0;c=c|0;b=i;yHd(a,c);i=b;return}function lId(a,b){a=a|0;b=b|0;b=i;SFd(a,nFd()|0);i=b;return}function mId(a,b,c){a=a|0;b=b|0;c=ea(c);a=i;TDd(b,c);i=a;return}function nId(a,b){a=a|0;b=b|0;var c=0;a=i;c=_Qc(b)|0;i=a;return c|0}function oId(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;AEd(d,b);i=a;return c[d>>2]|0}function pId(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;jFd(d,b);i=a;return c[d>>2]|0}function qId(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=i;f=AId(b,c,d,e)|0;i=a;return f|0}function rId(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;BId(b,c,d,e);i=a;return}function sId(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a=i;eEd(b,c,d,e,f);if(!g){i=a;return}fEd(b);i=a;return}function tId(a,b){a=a|0;b=b|0;a=i;ko[c[c[b>>2]>>2]&4095](b);i=a;return}function uId(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;d=DFd()|0;e=_n[c[(c[d>>2]|0)+48>>2]&4095](d,b)|0;i=a;return e|0}function vId(a,b){a=a|0;b=b|0;a=i;ko[c[c[b>>2]>>2]&4095](b);i=a;return}function wId(a,b){a=a|0;b=b|0;a=i;ko[c[c[b>>2]>>2]&4095](b);i=a;return}function xId(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;i=i+32|0;f=a;DId(f,d,e);e=DFd()|0;if(b){g=_n[c[(c[e>>2]|0)+64>>2]&4095](e,f+4|0)|0;EId(f);i=a;return g|0}else{g=_n[c[(c[e>>2]|0)+36>>2]&4095](e,f+4|0)|0;EId(f);i=a;return g|0}return 0}function yId(a,b){a=a|0;b=b|0;a=i;if(b)ACi(b);i=a;return}function zId(a,d,e,f,h){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+192|0;k=j+72|0;l=j+144|0;m=j+152|0;n=j+168|0;o=j+56|0;p=j;q=j+104|0;r=c[153134]|0;c[m>>2]=0;s=m+4|0;c[s>>2]=r;t=m+8|0;c[t>>2]=0;u=m+12|0;c[u>>2]=0;c[n>>2]=0;v=n+4|0;c[v>>2]=r;w=n+8|0;c[w>>2]=0;x=n+12|0;c[x>>2]=0;c[o>>2]=0;y=o+4|0;c[y>>2]=r;c[o+8>>2]=0;z=o+12|0;c[z>>2]=0;do if(CId(a,m,n,o)|0){A=c[t>>2]|0;if(f){B=c[m>>2]|0;yMc(e,B,12,B,12,A)}if(d){B=p+50|0;C=p+0|0;D=C+48|0;do{c[C>>2]=0;C=C+4|0}while((C|0)<(D|0));b[B>>1]=256;b[p+48>>1]=4;c[p+8>>2]=A;c[p+4>>2]=c[m>>2];c[p>>2]=12;C=XFd()|0;E=kn[c[(c[C>>2]|0)+28>>2]&511](C,p,h,0)|0;break}else{c[q+28>>2]=0;c[q+32>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;b[k+24>>1]=0;c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];c[q+16>>2]=c[k+16>>2];c[q+20>>2]=c[k+20>>2];g[q+36>>2]=ea(.00100000005);c[q+8>>2]=A;c[q+4>>2]=c[m>>2];c[q>>2]=12;c[q+20>>2]=((c[w>>2]|0)>>>0)/3|0;c[q+16>>2]=c[n>>2];c[q+12>>2]=6;b[q+24>>1]=(f&4)>>>2|2;C=XFd()|0;E=xo[c[(c[C>>2]|0)+16>>2]&2047](C,q,h)|0;break}}else E=0;while(0);if((c[z>>2]|0)>-1){z=c[o>>2]|0;c[l>>2]=c[y>>2];c[k+0>>2]=c[l+0>>2];eOb(z,k);c[o>>2]=0}if((c[x>>2]|0)>-1){x=c[n>>2]|0;c[l>>2]=c[v>>2];c[k+0>>2]=c[l+0>>2];eOb(x,k);c[n>>2]=0}c[l>>2]=r;c[k+0>>2]=c[l+0>>2];eOb(0,k);if((c[u>>2]|0)<=-1){i=j;return E|0}u=c[m>>2]|0;c[l>>2]=c[s>>2];c[k+0>>2]=c[l+0>>2];eOb(u,k);c[m>>2]=0;i=j;return E|0}function AId(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;DId(g,0,0);do if(zId(a,b,d,e,g)|0){h=DFd()|0;if(b){j=_n[c[(c[h>>2]|0)+64>>2]&4095](h,g+4|0)|0;break}else{j=_n[c[(c[h>>2]|0)+36>>2]&4095](h,g+4|0)|0;break}}else j=0;while(0);EId(g);i=f;return j|0}function BId(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+192|0;g=f+184|0;h=f+180|0;j=f+136|0;k=f+92|0;l=f+64|0;m=XFd()|0;n=mo[c[(c[m>>2]|0)+8>>2]&4095](m)|0;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];c[j+16>>2]=c[n+16>>2];c[j+20>>2]=c[n+20>>2];c[j+24>>2]=c[n+24>>2];m=c[n+28>>2]|0;c[j+28>>2]=m;o=j+32|0;p=n+32|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[k+16>>2]=c[j+16>>2];c[k+20>>2]=c[j+20>>2];c[k+24>>2]=c[j+24>>2];c[k+28>>2]=m;m=k+32|0;c[m+0>>2]=c[o+0>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[k>>2]=d&1;d=XFd()|0;In[c[(c[d>>2]|0)+4>>2]&4095](d,k);DId(l,0,0);if(!(zId(a,b,f,0,l)|0)){b=e+12|0;if((c[b>>2]|0)>-1){a=c[e>>2]|0;c[h>>2]=c[e+4>>2];c[g+0>>2]=c[h+0>>2];eOb(a,g);c[e>>2]=0}c[e+8>>2]=0;c[b>>2]=0;q=XFd()|0;r=c[q>>2]|0;s=r+4|0;t=c[s>>2]|0;In[t&4095](q,j);EId(l);i=f;return}b=c[l+24>>2]|0;a=c[l+20>>2]|0;k=e+8|0;c[k>>2]=a;d=e+12|0;o=c[d>>2]|0;do if((o&2147483647)>>>0<a>>>0)if((o|0)>-1){c[d>>2]=a;m=c[e>>2]|0;c[h>>2]=c[e+4>>2];c[g+0>>2]=c[h+0>>2];p=hOb(m,a,1,g,0,3653512,370)|0;c[e>>2]=p;u=p;break}else{c[h>>2]=c[e+4>>2];c[g+0>>2]=c[h+0>>2];p=cOb(a,1,g,0,3653512,352)|0;YEi(p|0,c[e>>2]|0,c[k>>2]|0)|0;c[d>>2]=a;c[e>>2]=p;u=p;break}else u=c[e>>2]|0;while(0);YEi(u|0,b|0,c[k>>2]|0)|0;q=XFd()|0;r=c[q>>2]|0;s=r+4|0;t=c[s>>2]|0;In[t&4095](q,j);EId(l);i=f;return}function CId(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=i;i=i+32|0;h=g;j=g+28|0;k=g+16|0;l=g+4|0;m=c[b+28>>2]|0;n=c[m+100>>2]|0;if(!n){o=0;i=g;return o|0}if(!(c[m+92>>2]|0)){Krd(668848,0,3653512,17,1,c[b+4>>2]|0,0,0);o=0;i=g;return o|0}m=d+8|0;c[m>>2]=n;p=d+12|0;q=c[p>>2]|0;do if((q&2147483647)>>>0<n>>>0)if((q|0)>-1){c[p>>2]=n;r=c[d>>2]|0;c[j>>2]=c[d+4>>2];c[h+0>>2]=c[j+0>>2];s=hOb(r,n*12|0,4,h,0,3653512,370)|0;c[d>>2]=s;t=s;break}else{c[j>>2]=c[d+4>>2];c[h+0>>2]=c[j+0>>2];s=cOb(n*12|0,4,h,0,3653512,352)|0;YEi(s|0,c[d>>2]|0,(c[m>>2]|0)*12|0)|0;c[p>>2]=n;c[d>>2]=s;t=s;break}else t=c[d>>2]|0;while(0);Kdc(b,t);t=e+12|0;if((c[t>>2]|0)>-1){n=c[e>>2]|0;c[j>>2]=c[e+4>>2];c[h+0>>2]=c[j+0>>2];eOb(n,h);c[e>>2]=0}n=e+8|0;c[n>>2]=0;c[t>>2]=0;a:do if(iec(b)|0){p=b+44|0;m=e+4|0;q=0;while(1){if(q>>>0>=(iec(b)|0)>>>0){u=q;v=14;break}s=Tdc(b,q)|0;if(!s){w=q;v=19;break}r=c[p>>2]|0;x=c[r+(q*56|0)>>2]|0;if((x|0)==1){y=c[n>>2]|0;z=r+(q*56|0)+8|0;A=LHc(s,c[z>>2]|0)|0;B=(A*3|0)+y|0;c[n>>2]=B;C=c[t>>2]|0;do if((C&2147483647)>>>0<B>>>0)if((C|0)>-1){c[t>>2]=B;D=c[e>>2]|0;c[j>>2]=c[m>>2];c[h+0>>2]=c[j+0>>2];E=hOb(D,B<<1,2,h,0,3653512,370)|0;c[e>>2]=E;F=E;break}else{c[j>>2]=c[m>>2];c[h+0>>2]=c[j+0>>2];E=cOb(B<<1,2,h,0,3653512,352)|0;YEi(E|0,c[e>>2]|0,c[n>>2]<<1|0)|0;c[t>>2]=B;c[e>>2]=E;F=E;break}else F=c[e>>2]|0;while(0);MHc(s,c[z>>2]|0,F+(y<<1)|0,A)}else if(!x){B=c[e>>2]|0;C=c[n>>2]|0;E=C<<1>>1;D=C-E|0;G=c[r+(q*56|0)+8>>2]<<1;H=G>>1;I=H+C|0;c[n>>2]=I;C=c[t>>2]|0;J=C&2147483647;do if(J>>>0<I>>>0?(K=C<<1,L=K>>>0>I>>>0?K:I,J>>>0<L>>>0):0)if((C|0)>-1){c[t>>2]=L;c[j>>2]=c[m>>2];c[h+0>>2]=c[j+0>>2];K=hOb(B,L<<1,2,h,0,3653512,370)|0;c[e>>2]=K;M=K;break}else{c[j>>2]=c[m>>2];c[h+0>>2]=c[j+0>>2];K=cOb(L<<1,2,h,0,3653512,352)|0;YEi(K|0,c[e>>2]|0,c[n>>2]<<1|0)|0;c[t>>2]=L;c[e>>2]=K;M=K;break}else M=B;while(0);B=M+(E<<1)|0;aFi(M+(H+E<<1)|0,B|0,D<<1|0)|0;YEi(B|0,s|0,G|0)|0}else{v=36;break}q=q+1|0;if(q>>>0>=(iec(b)|0)>>>0)break a}if((v|0)==14){c[h>>2]=u;Lsd(k,668944,h);if(!(a[k>>0]&1))N=k+1|0;else N=c[k+8>>2]|0;Krd(N,0,3653512,29,1,c[b+4>>2]|0,0,0);xri(k);o=0;i=g;return o|0}else if((v|0)==19){c[h>>2]=w;Lsd(l,669008,h);if(!(a[l>>0]&1))O=l+1|0;else O=c[l+8>>2]|0;Krd(O,0,3653512,36,1,c[b+4>>2]|0,0,0);xri(l);o=0;i=g;return o|0}else if((v|0)==36){Krd(669064,0,3653512,54,1,c[b+4>>2]|0,0,0);o=0;i=g;return o|0}}while(0);YQc(d,e,f)|0;o=1;i=g;return o|0}function DId(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;c[b>>2]=669128;c[b+4>>2]=669152;if(!d){c[h>>2]=c[153112];c[g+0>>2]=c[h+0>>2];j=1;k=cOb(e,16,g,0,3653512,25)|0}else{j=0;k=d}c[b+24>>2]=k;a[b+8>>0]=j;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=e;i=f;return}function EId(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=669128;c[b+4>>2]=669152;if(!(a[b+8>>0]|0)){i=d;return}g=c[b+24>>2]|0;c[f>>2]=c[153112];c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function FId(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+-4|0;c[g>>2]=669128;c[g+4>>2]=669152;if(!(a[g+8>>0]|0)){i=d;return}b=c[g+24>>2]|0;c[f>>2]=c[153112];c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function GId(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=669128;c[b+4>>2]=669152;if(!(a[b+8>>0]|0)){ACi(b);i=d;return}g=c[b+24>>2]|0;c[f>>2]=c[153112];c[e+0>>2]=c[f+0>>2];eOb(g,e);ACi(b);i=d;return}function HId(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+-4|0;c[g>>2]=669128;c[g+4>>2]=669152;if(!(a[g+8>>0]|0)){ACi(g);i=d;return}b=c[g+24>>2]|0;c[f>>2]=c[153112];c[e+0>>2]=c[f+0>>2];eOb(b,e);ACi(g);i=d;return}function IId(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+12|0;g=c[f>>2]|0;h=c[a+20>>2]|0;j=(g+d|0)>>>0>h>>>0?h-g|0:d;YEi(b|0,(c[a+24>>2]|0)+g|0,j|0)|0;c[f>>2]=(c[f>>2]|0)+j;i=e;return j|0}function JId(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+-4|0;a=f+12|0;g=c[a>>2]|0;h=c[f+20>>2]|0;j=(g+d|0)>>>0>h>>>0?h-g|0:d;YEi(b|0,(c[f+24>>2]|0)+g|0,j|0)|0;c[a>>2]=(c[a>>2]|0)+j;i=e;return j|0}function KId(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=a+16|0;k=c[j>>2]|0;l=a+20|0;m=c[l>>2]|0;if((k+d|0)>>>0<m>>>0){n=c[a+24>>2]|0;o=k;p=n+o|0;YEi(p|0,b|0,d|0)|0;q=c[j>>2]|0;r=q+d|0;c[j>>2]=r;i=e;return d|0}else{k=d>>>0>4096?d<<1:4096;c[g>>2]=c[153112];c[f+0>>2]=c[g+0>>2];g=cOb(m+k|0,16,f,0,3653512,61)|0;m=a+24|0;YEi(g|0,c[m>>2]|0,c[j>>2]|0)|0;a=c[m>>2]|0;c[h>>2]=c[153112];c[f+0>>2]=c[h+0>>2];eOb(a,f);c[m>>2]=g;c[l>>2]=(c[l>>2]|0)+k;n=g;o=c[j>>2]|0;p=n+o|0;YEi(p|0,b|0,d|0)|0;q=c[j>>2]|0;r=q+d|0;c[j>>2]=r;i=e;return d|0}return 0}function LId(a){a=a|0;var b=0,d=0,e=0;b=i;if(((c[a+60>>2]|0)!=0?(d=c[(c[c[a+52>>2]>>2]|0)+8>>2]|0,(d|0)!=0):0)?(c[d>>2]|0)!=0:0)e=c[d+148>>2]|0;else e=0;i=b;return e|0}function MId(a){a=a|0;var b=0,d=0;b=i;if(!(c[a+60>>2]|0)){d=0;i=b;return d|0}d=c[(c[c[a+52>>2]>>2]|0)+8>>2]|0;i=b;return d|0}function NId(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+160|0;e=d+80|0;f=d+72|0;g=d;c[b>>2]=669176;c[b+8>>2]=0;h=b+12|0;a[h>>0]=0;j=b+16|0;k=b+80|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;l=b+160|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;l=b+180|0;c[l>>2]=32;c[b+184>>2]=0;c[b+192>>2]=16;c[b+188>>2]=6;a[b+196>>0]=0;c[b+200>>2]=0;c[b+208>>2]=0;c[b+212>>2]=0;c[b+204>>2]=60;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;k=g+56|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;a[b+13>>0]=1;k=b+96|0;m=k;c[m>>2]=0;c[m+4>>2]=0;m=b+104|0;n=g+0|0;g=m+72|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(g|0));c[f>>2]=57;c[e+0>>2]=c[f+0>>2];f=cOb(2560,16,e,0,3653512,80)|0;c[b+176>>2]=f;o=f+((c[l>>2]|0)*80|0)|0;if((f|0)!=(o|0)){l=f;do{if(l){m=l+0|0;n=k+0|0;g=m+80|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(g|0))}l=l+80|0}while((l|0)!=(o|0))}c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;o=e+56|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;RId(b+4|0);a[h>>0]=1;h=j;c[h>>2]=-1;c[h+4>>2]=-1;m=b+24|0;n=e+0|0;g=m+72|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(g|0));i=d;return}function OId(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im;e=i;i=i+16|0;f=e+8|0;h=e;j=d+48|0;k=d+52|0;l=c[(c[j>>2]|0)+40>>2]|0;m=c[(c[k>>2]|0)+40>>2]|0;n=(c[l+4>>2]|0)>(c[m+4>>2]|0);c[h>>2]=n?m:l;c[h+4>>2]=n?l:m;do if((c[b+184>>2]|0)!=(c[b+8>>2]|0)){SId(f,b+4|0,h);n=c[f>>2]|0;o=c[b+176>>2]|0;if((n|0)==-1){p=o+((c[b+180>>2]|0)*80|0)|0;break}else{p=o+(n*80|0)|0;break}}else p=(c[b+176>>2]|0)+((c[b+180>>2]|0)*80|0)|0;while(0);iJd(d);a[p+79>>0]=(c[d+4>>2]|0)>>>2&1;b=c[p+72>>2]|0;if(!((b|0)==4|(b|0)==3|(b|0)==1)){i=e;return}c[p+24>>2]=c[d+124>>2];b=c[j>>2]|0;j=c[k>>2]|0;q=ea(g[(c[b+12>>2]|0)+8>>2]);lJd(p+32|0,d+64|0,(c[b+8>>2]|0)+12|0,q,(c[j+8>>2]|0)+12|0,ea(g[(c[j+12>>2]|0)+8>>2]));if(!l)r=0;else r=LId(l)|0;if(!m)s=0;else s=LId(m)|0;if(!r)t=_Id()|0;else t=c[r+64>>2]|0;if(!s)u=_Id()|0;else u=c[s+64>>2]|0;q=ea(g[t+72>>2]);v=ea(g[p+40>>2]);w=ea(v-ea(g[t+44>>2]));x=ea(g[p+44>>2]);y=ea(q*ea(x-ea(g[t+48>>2])));z=ea(q*w);w=ea(ea(g[t+64>>2])-y);y=ea(z+ea(g[t+68>>2]));z=ea(g[u+72>>2]);q=ea(v-ea(g[u+44>>2]));v=ea(z*ea(x-ea(g[u+48>>2])));x=ea(z*q);q=ea(ea(g[u+64>>2])-v);v=ea(ea(x+ea(g[u+68>>2]))-y);g[p+64>>2]=ea(q-w);g[p+68>>2]=v;i=e;return}function PId(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+192|0;f=e+176|0;g=e+8|0;h=e+104|0;j=e+88|0;k=e;gJd(d);l=c[d+4>>2]&4;m=c[d+48>>2]|0;n=c[d+52>>2]|0;d=c[m+40>>2]|0;o=c[n+40>>2]|0;p=(c[d+4>>2]|0)>(c[o+4>>2]|0);c[k>>2]=p?o:d;c[k+4>>2]=p?d:o;p=b+4|0;q=b+184|0;r=b+8|0;do if((c[q>>2]|0)!=(c[r>>2]|0)){SId(f,p,k);s=c[f>>2]|0;t=c[b+176>>2]|0;if((s|0)==-1){u=c[b+180>>2]|0;v=t;w=u;x=t+(u*80|0)|0;break}else{v=t;w=c[b+180>>2]|0;x=t+(s*80|0)|0;break}}else{s=c[b+176>>2]|0;t=c[b+180>>2]|0;v=s;w=t;x=s+(t*80|0)|0}while(0);t=b+176|0;s=b+180|0;do if((x|0)==(v+(w*80|0)|0)){do if((c[q>>2]|0)!=(c[r>>2]|0)){SId(f,p,k);b=c[f>>2]|0;u=c[t>>2]|0;if((b|0)==-1){y=c[s>>2]|0;z=u;A=y;B=u+(y*80|0)|0;break}else{z=u;A=c[s>>2]|0;B=u+(b*80|0)|0;break}}else{z=v;A=w;B=x}while(0);if((B|0)==(z+(A*80|0)|0)){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;b=h+56|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;b=k;u=c[b+4>>2]|0;y=g;c[y>>2]=c[b>>2];c[y+4>>2]=u;u=g+8|0;y=h+0|0;b=u+72|0;do{c[u>>2]=c[y>>2];u=u+4|0;y=y+4|0}while((u|0)<(b|0));TId(j,p,g);C=c[j+4>>2]|0;D=0}else{C=B;D=0}}else{a[x+79>>0]=l>>>2;y=c[x+72>>2]|0;if((y|0)==4){C=x;D=1;break}else if((y|0)!=1?(y|0)!=3:0){C=x;D=0;break}y=x+28|0;c[y>>2]=(c[y>>2]|0)+1;i=e;return}while(0);if(!d)E=0;else E=LId(d)|0;if(!o)F=0;else F=LId(o)|0;if(!D)a[C+78>>0]=0;a[C+79>>0]=l>>>2;c[C+28>>2]=1;c[C+8>>2]=E;c[C+12>>2]=F;c[C+16>>2]=d;c[C+20>>2]=o;a[C+76>>0]=0;c[C+72>>2]=D?3:1;if(!(a[m+38>>0]|0))G=a[n+38>>0]|0;else G=1;a[C+77>>0]=G;c[C+24>>2]=0;G=601088;n=c[G+4>>2]|0;m=C+64|0;c[m>>2]=c[G>>2];c[m+4>>2]=n;i=e;return}function QId(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+8|0;g=e;jJd(d);h=d+4|0;c[h>>2]=c[h>>2]|4;h=c[(c[d+48>>2]|0)+40>>2]|0;j=c[(c[d+52>>2]|0)+40>>2]|0;d=(c[h+4>>2]|0)>(c[j+4>>2]|0);c[g>>2]=d?j:h;c[g+4>>2]=d?h:j;d=b+8|0;do if((c[b+184>>2]|0)!=(c[d>>2]|0)){SId(f,b+4|0,g);k=c[f>>2]|0;l=c[b+176>>2]|0;if((k|0)==-1){m=l+((c[b+180>>2]|0)*80|0)|0;break}else{m=l+(k*80|0)|0;break}}else m=(c[b+176>>2]|0)+((c[b+180>>2]|0)*80|0)|0;while(0);f=m+28|0;g=(c[f>>2]|0)+-1|0;c[f>>2]=g;if(g){i=e;return}g=m+72|0;f=c[h+24>>2]|0;if((((((f|0)!=0?vTb(f)|0:0)?(a[h+28>>0]|0)!=0:0)?(h=c[j+24>>2]|0,(h|0)!=0):0)?vTb(h)|0:0)?(a[j+28>>0]|0)!=0:0){j=c[g>>2]|0;if((j|0)==0|(j|0)==4){i=e;return}if(a[m+78>>0]|0){c[g>>2]=2;i=e;return}if((m|0)==((c[b+176>>2]|0)+((c[b+180>>2]|0)*80|0)|0)){i=e;return}if(((a[b+12>>0]|0)!=0?(c[d>>2]|0)!=0:0)?(c[b+16>>2]|0)==(c[m>>2]|0):0){j=(c[b+20>>2]|0)==(c[m+4>>2]|0);n=m+0|0;o=b+16|0;p=n+80|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));if(j){i=e;return}}else{n=m+0|0;o=b+16|0;p=n+80|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0))}c[d>>2]=(c[d>>2]|0)+1;a[b+196>>0]=1;i=e;return}c[g>>2]=0;i=e;return}function RId(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im;e=i;i=i+288|0;f=e+200|0;g=e+196|0;h=e;j=d+4|0;if(!(c[j>>2]|0)){i=e;return}k=h+4|0;c[k>>2]=0;l=h+8|0;m=d+8|0;a[l>>0]=a[m>>0]|0;n=h+9|0;o=d+9|0;a[n>>0]=a[o>>0]|0;p=h+12|0;q=d+12|0;r=p+0|0;s=q+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));u=h+92|0;v=d+92|0;r=u+0|0;s=v+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));w=h+172|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;a[w+20>>0]=0;XId(h,d,0);x=c[j>>2]|0;c[j>>2]=c[k>>2];c[k>>2]=x;x=a[m>>0]|0;k=b[l>>1]|0;a[m>>0]=k;a[l>>0]=x;x=a[o>>0]|0;a[o>>0]=(k&65535)>>>8;a[n>>0]=x;r=f+0|0;s=q+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=q+0|0;s=p+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=p+0|0;s=f+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=f+0|0;s=v+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=v+0|0;s=u+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));r=u+0|0;s=f+0|0;t=r+80|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));s=d+172|0;r=c[s>>2]|0;c[s>>2]=c[w>>2];c[w>>2]=r;w=d+176|0;s=h+176|0;t=c[w>>2]|0;u=c[s>>2]|0;c[w>>2]=u;c[s>>2]=t;s=d+180|0;w=h+180|0;v=c[s>>2]|0;c[s>>2]=c[w>>2];c[w>>2]=v;y=ea(u>>>0);c[d+188>>2]=~~ea(y*ea(.5))>>>0;c[d+184>>2]=~~ea(y*ea(.200000003))>>>0;a[d+192>>0]=0;y=ea(t>>>0);c[h+188>>2]=~~ea(y*ea(.5))>>>0;c[h+184>>2]=~~ea(y*ea(.200000003))>>>0;a[h+192>>0]=0;if(!r){i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(r,f);i=e;return}function SId(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=(c[d+176>>2]|0)+-1|0;h=c[e>>2]|0;j=c[h+4>>2]|0;k=c[e+4>>2]|0;e=j+2127912214+(j<<12)|0;j=e^-949894596^c[k+4>>2]^e>>>19;e=j+374761393+(j<<5)|0;j=c[d+172>>2]|0;l=c[d+92>>2]|0;m=d+96|0;n=d+8|0;o=d+4|0;p=d+12|0;q=d+16|0;d=e+-744332180^e<<9;e=-1;r=0;while(1){s=d&g;t=c[j+(s*80|0)>>2]|0;if((l|0)==(t|0)?(c[m>>2]|0)==(c[j+(s*80|0)+4>>2]|0):0){u=e;v=s;break}if((((a[n>>0]|0)!=0?(c[o>>2]|0)!=0:0)?(c[p>>2]|0)==(t|0):0)?(c[q>>2]|0)==(c[j+(s*80|0)+4>>2]|0):0)w=(e|0)==-1?s:e;else if((h|0)==(t|0)?(k|0)==(c[j+(s*80|0)+4>>2]|0):0){x=s;y=14;break}else w=e;t=r+1|0;d=t+s|0;e=w;r=t}if((y|0)==14){c[b>>2]=x;c[b+4>>2]=-1;i=f;return}c[b>>2]=-1;x=b+4|0;if((u|0)==-1){c[x>>2]=v;i=f;return}else{c[x>>2]=u;i=f;return}}function TId(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;YId(d,1,0);SId(g,d,e);h=c[g>>2]|0;if((h|0)!=-1){j=c[d+172>>2]|0;k=j+((c[d+176>>2]|0)*80|0)|0;c[b>>2]=d;c[b+4>>2]=j+(h*80|0);c[b+8>>2]=k;a[b+12>>0]=0;i=f;return}k=c[g+4>>2]|0;if((((a[d+8>>0]|0)!=0?(g=d+4|0,h=c[g>>2]|0,(h|0)!=0):0)?(j=c[d+172>>2]|0,(c[d+12>>2]|0)==(c[j+(k*80|0)>>2]|0)):0)?(c[d+16>>2]|0)==(c[j+(k*80|0)+4>>2]|0):0){c[g>>2]=h+-1;l=j}else{j=d+180|0;c[j>>2]=(c[j>>2]|0)+1;l=c[d+172>>2]|0}j=l+(k*80|0)|0;if(!j)m=l;else{l=d+172|0;h=j+0|0;j=e+0|0;e=h+80|0;do{c[h>>2]=c[j>>2];h=h+4|0;j=j+4|0}while((h|0)<(e|0));m=c[l>>2]|0}l=m+((c[d+176>>2]|0)*80|0)|0;c[b>>2]=d;c[b+4>>2]=m+(k*80|0);c[b+8>>2]=l;a[b+12>>0]=1;i=f;return}function UId(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=669176;if((c[a+212>>2]|0)>-1){f=a+200|0;g=c[f>>2]|0;c[e>>2]=c[a+204>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=c[a+176>>2]|0;if(!f){i=b;return}c[e>>2]=57;c[d+0>>2]=c[e+0>>2];eOb(f,d);i=b;return}function VId(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=669176;if((c[a+212>>2]|0)>-1){f=a+200|0;g=c[f>>2]|0;c[e>>2]=c[a+204>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=c[a+176>>2]|0;if(!f){ACi(a);i=b;return}c[e>>2]=57;c[d+0>>2]=c[e+0>>2];eOb(f,d);ACi(a);i=b;return}function WId(a,b,c){a=a|0;b=b|0;c=c|0;return}function XId(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+172|0;k=b+176|0;c[k>>2]=32;l=b+188|0;c[l>>2]=16;m=b+184|0;c[m>>2]=6;n=b+192|0;a[n>>0]=0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];o=cOb(2560,16,g,0,3653512,80)|0;p=c[j>>2]|0;if(p){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(p,g)}c[j>>2]=o;p=o+((c[k>>2]|0)*80|0)|0;if((o|0)!=(p|0)){q=b+92|0;r=o;do{if(r){s=r+0|0;t=q+0|0;u=s+80|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0))}r=r+80|0}while((r|0)!=(p|0))}p=b+180|0;c[p>>2]=0;c[b+4>>2]=0;r=d+4|0;v=ea(((c[d+180>>2]|0)-(c[r>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=e>>>0?(w=ea(q>>>0),x=ea(w*ea(.5)),!(v>=x)):0){y=w;z=x;A=q;break}q=q<<1}q=c[k>>2]|0;if(A>>>0>q>>>0){c[h>>2]=57;c[g+0>>2]=c[h+0>>2];e=cOb(A*80|0,16,g,0,3653512,80)|0;o=c[j>>2]|0;B=c[k>>2]|0;C=B>>>0>A>>>0?A:B;D=o+(C*80|0)|0;if(!C)E=B;else{B=e;C=o;while(1){if(B){s=B+0|0;t=C+0|0;u=s+80|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0))}C=C+80|0;if((C|0)==(D|0))break;else B=B+80|0}E=c[k>>2]|0}B=e+(A*80|0)|0;if((E|0)!=(A|0)){D=b+92|0;C=e+(E*80|0)|0;do{if(C){s=C+0|0;t=D+0|0;u=s+80|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0))}C=C+80|0}while((C|0)!=(B|0))}B=c[j>>2]|0;c[h>>2]=57;c[g+0>>2]=c[h+0>>2];eOb(B,g);c[j>>2]=e;c[k>>2]=A;c[l>>2]=~~z>>>0;c[m>>2]=~~ea(y*ea(.200000003))>>>0;a[n>>0]=0;F=A}else F=q;q=d+172|0;A=c[q>>2]|0;n=d+176|0;m=c[n>>2]|0;l=A+(m*80|0)|0;a:do if(!m)G=A;else{e=c[d+92>>2]|0;g=c[d+96>>2]|0;B=c[d+12>>2]|0;h=c[d+16>>2]|0;if((c[r>>2]|0)!=0&(a[d+8>>0]|0)!=0)H=A;else{C=A;do{if((e|0)!=(c[C>>2]|0)){G=C;break a}if((g|0)!=(c[C+4>>2]|0)){G=C;break a}C=C+80|0}while((C|0)!=(l|0));i=f;return}do{C=c[H>>2]|0;if(!((e|0)==(C|0)?(g|0)==(c[H+4>>2]|0):0)){if((B|0)!=(C|0)){G=H;break a}if((h|0)!=(c[H+4>>2]|0)){G=H;break a}}H=H+80|0}while((H|0)!=(l|0));i=f;return}while(0);if((G|0)==(l|0)){i=f;return}H=b+96|0;A=b+92|0;b=d+92|0;m=d+96|0;h=d+12|0;B=d+16|0;g=d+8|0;d=F;F=G;while(1){G=d+-1|0;e=c[(c[F>>2]|0)+4>>2]|0;C=e+2127912214+(e<<12)|0;e=C^-949894596^c[(c[F+4>>2]|0)+4>>2]^C>>>19;C=e+374761393+(e<<5)|0;e=c[j>>2]|0;D=c[A>>2]|0;E=c[H>>2]|0;o=C+-744332180^C<<9;C=0;while(1){I=o&G;if((D|0)==(c[e+(I*80|0)>>2]|0)?(E|0)==(c[e+(I*80|0)+4>>2]|0):0){J=I;break}K=C+1|0;o=K+I|0;C=K}C=e+(J*80|0)|0;if(C){s=C+0|0;t=F+0|0;u=s+80|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0))}c[p>>2]=(c[p>>2]|0)+1;e=F+80|0;b:do if((e|0)==(l|0))L=l;else{C=c[b>>2]|0;o=c[m>>2]|0;E=c[h>>2]|0;D=c[B>>2]|0;if((c[r>>2]|0)!=0&(a[g>>0]|0)!=0){M=F;N=e}else{G=F;K=e;while(1){if((C|0)!=(c[G+80>>2]|0)){L=K;break b}if((o|0)!=(c[K+4>>2]|0)){L=K;break b}I=G+160|0;if((I|0)==(l|0)){L=l;break b}else{O=K;K=I;G=O}}}while(1){G=c[M+80>>2]|0;if(!((C|0)==(G|0)?(o|0)==(c[N+4>>2]|0):0)){if((E|0)!=(G|0)){L=N;break b}if((D|0)!=(c[M+84>>2]|0)){L=N;break b}}G=M+160|0;if((G|0)==(l|0)){L=l;break}else{K=N;N=G;M=K}}}while(0);if((L|0)==((c[q>>2]|0)+((c[n>>2]|0)*80|0)|0))break;d=c[k>>2]|0;F=L}i=f;return}function YId(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+288|0;h=g+200|0;j=g+196|0;k=g;l=d+192|0;if(a[l>>0]|0)ZId(d);m=d+176|0;n=c[m>>2]|0;o=c[d+180>>2]|0;if(n>>>0>f>>>0?(o+e|0)>>>0<=(c[d+188>>2]|0)>>>0:0){i=g;return}p=d+180|0;q=o+e|0;r=ea(q>>>0);e=32;while(1){if(e>>>0>=f>>>0?!(r>=ea(ea(e>>>0)*ea(.5))):0){s=e;break}e=e<<1}if(s>>>0<=n>>>0){i=g;return}n=d+4|0;r=ea((q-(c[n>>2]|0)|0)>>>0);q=32;while(1){if(q>>>0>=f>>>0?!(r>=ea(ea(q>>>0)*ea(.5))):0){t=q;break}q=q<<1}q=k+4|0;c[q>>2]=0;f=k+8|0;s=d+8|0;a[f>>0]=a[s>>0]|0;e=k+9|0;o=d+9|0;a[e>>0]=a[o>>0]|0;u=k+12|0;v=d+12|0;w=u+0|0;x=v+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));z=k+92|0;A=d+92|0;w=z+0|0;x=A+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));B=k+172|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[B+16>>2]=0;a[B+20>>0]=0;XId(k,d,t);t=c[n>>2]|0;c[n>>2]=c[q>>2];c[q>>2]=t;t=a[s>>0]|0;q=b[f>>1]|0;a[s>>0]=q;a[f>>0]=t;t=a[o>>0]|0;a[o>>0]=(q&65535)>>>8;a[e>>0]=t;w=h+0|0;x=v+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));w=v+0|0;x=u+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));w=u+0|0;x=h+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));w=h+0|0;x=A+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));w=A+0|0;x=z+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));w=z+0|0;x=h+0|0;y=w+80|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));x=d+172|0;w=c[x>>2]|0;c[x>>2]=c[B>>2];c[B>>2]=w;B=k+176|0;x=c[m>>2]|0;y=c[B>>2]|0;c[m>>2]=y;c[B>>2]=x;B=k+180|0;m=c[p>>2]|0;c[p>>2]=c[B>>2];c[B>>2]=m;r=ea(y>>>0);c[d+188>>2]=~~ea(r*ea(.5))>>>0;c[d+184>>2]=~~ea(r*ea(.200000003))>>>0;a[l>>0]=0;r=ea(x>>>0);c[k+188>>2]=~~ea(r*ea(.5))>>>0;c[k+184>>2]=~~ea(r*ea(.200000003))>>>0;a[k+192>>0]=0;if(!w){i=g;return}c[j>>2]=57;c[h+0>>2]=c[j+0>>2];eOb(w,h);i=g;return}function ZId(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+288|0;f=e+200|0;g=e+196|0;h=e;j=d+180|0;k=d+4|0;l=(c[j>>2]|0)-(c[k>>2]|0)|0;m=d+184|0;if(l>>>0>=(c[m>>2]|0)>>>0){n=d+192|0;a[n>>0]=0;i=e;return}o=d+176|0;p=c[o>>2]|0;if(p>>>0<=32){n=d+192|0;a[n>>0]=0;i=e;return}q=ea(l>>>0);l=p;while(1){p=l>>>1;if(l>>>0<66){r=p;break}if(q<ea(ea(p>>>0)*ea(.200000003)))l=p;else{r=p;break}}l=h+4|0;c[l>>2]=0;p=h+8|0;s=d+8|0;a[p>>0]=a[s>>0]|0;t=h+9|0;u=d+9|0;a[t>>0]=a[u>>0]|0;v=h+12|0;w=d+12|0;x=v+0|0;y=w+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));A=h+92|0;B=d+92|0;x=A+0|0;y=B+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));C=h+172|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[C+16>>2]=0;a[C+20>>0]=0;XId(h,d,r);r=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=r;r=a[s>>0]|0;l=b[p>>1]|0;a[s>>0]=l;a[p>>0]=r;r=a[u>>0]|0;a[u>>0]=(l&65535)>>>8;a[t>>0]=r;x=f+0|0;y=w+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));x=w+0|0;y=v+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));x=v+0|0;y=f+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));x=f+0|0;y=B+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));x=B+0|0;y=A+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));x=A+0|0;y=f+0|0;z=x+80|0;do{c[x>>2]=c[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));y=d+172|0;x=c[y>>2]|0;c[y>>2]=c[C>>2];c[C>>2]=x;C=h+176|0;y=c[o>>2]|0;z=c[C>>2]|0;c[o>>2]=z;c[C>>2]=y;C=h+180|0;o=c[j>>2]|0;c[j>>2]=c[C>>2];c[C>>2]=o;q=ea(z>>>0);c[d+188>>2]=~~ea(q*ea(.5))>>>0;c[m>>2]=~~ea(q*ea(.200000003))>>>0;a[d+192>>0]=0;q=ea(y>>>0);c[h+188>>2]=~~ea(q*ea(.5))>>>0;c[h+184>>2]=~~ea(q*ea(.200000003))>>>0;a[h+192>>0]=0;if(!x){n=d+192|0;a[n>>0]=0;i=e;return}c[g>>2]=57;c[f+0>>2]=c[g+0>>2];eOb(x,f);n=d+192|0;a[n>>0]=0;i=e;return}function _Id(){return c[167302]|0}function $Id(){var a=0;a=i;c[167300]=0;c[167301]=0;c[167302]=0;NId(669212|0);c[167357]=669440;i=a;return}function aJd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=(c[d+40>>2]|0)+-1|0;h=c[e>>2]|0;j=c[h+4>>2]|0;k=c[e+4>>2]|0;e=j+2127912214+(j<<12)|0;j=e^-949894596^c[k+4>>2]^e>>>19;e=j+374761393+(j<<5)|0;j=c[d+36>>2]|0;l=c[d+24>>2]|0;m=d+28|0;n=d+8|0;o=d+4|0;p=d+12|0;q=d+16|0;d=e+-744332180^e<<9;e=-1;r=0;while(1){s=d&g;t=c[j+(s*12|0)>>2]|0;if((l|0)==(t|0)?(c[m>>2]|0)==(c[j+(s*12|0)+4>>2]|0):0){u=e;v=s;break}if((((a[n>>0]|0)!=0?(c[o>>2]|0)!=0:0)?(c[p>>2]|0)==(t|0):0)?(c[q>>2]|0)==(c[j+(s*12|0)+4>>2]|0):0)w=(e|0)==-1?s:e;else if((h|0)==(t|0)?(k|0)==(c[j+(s*12|0)+4>>2]|0):0){x=s;y=14;break}else w=e;t=r+1|0;d=t+s|0;e=w;r=t}if((y|0)==14){c[b>>2]=x;c[b+4>>2]=-1;i=f;return}c[b>>2]=-1;x=b+4|0;if((u|0)==-1){c[x>>2]=v;i=f;return}else{c[x>>2]=u;i=f;return}}function bJd(a){a=a|0;return}function cJd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function dJd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;f=b+8|0;g=b;if((((c[c[d+8>>2]>>2]|0)!=2?(c[c[e+8>>2]>>2]|0)!=2:0)?(a[d+38>>0]|0)==0:0)?(a[e+38>>0]|0)==0:0){h=0;i=b;return h|0}j=c[d+40>>2]|0;d=c[e+40>>2]|0;if(!(a[j+28>>0]|0)){h=0;i=b;return h|0}if(!(a[d+28>>0]|0)){h=0;i=b;return h|0}if((a[j+45>>0]|0)==0?(a[d+45>>0]|0)==0:0){e=c[(c[j+24>>2]|0)+40>>2]|0;k=c[(c[d+24>>2]|0)+40>>2]|0;if(eJd(fJd()|0,e,k)|0){h=0;i=b;return h|0}}else l=9;if((l|0)==9?!(kJd(j,d)|0):0){h=0;i=b;return h|0}l=c[167300]|0;if((j|0)==0|(d|0)==0|(j|0)==(d|0)){h=1;i=b;return h|0}k=(c[j+4>>2]|0)>(c[d+4>>2]|0);c[g>>2]=k?d:j;c[g+4>>2]=k?j:d;do if((c[l+48>>2]|0)!=(c[l+8>>2]|0)){aJd(f,l+4|0,g);d=c[f>>2]|0;j=c[l+40>>2]|0;k=c[l+44>>2]|0;if((d|0)==-1){m=j;n=k;o=j+(k*12|0)|0;break}else{m=j;n=k;o=j+(d*12|0)|0;break}}else{d=c[l+40>>2]|0;j=c[l+44>>2]|0;m=d;n=j;o=d+(j*12|0)|0}while(0);h=(o|0)==(m+(n*12|0)|0);i=b;return h|0}function eJd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=f+4|0;if(!((e|d|0)<0|(d|0)>31|(e|0)>31)){j=(c[(c[b+24>>2]|0)+(d<<2)>>2]&1<<e|0)==0;i=f;return j|0}c[g>>2]=31;Lsd(h,669456,g);if(!(a[h>>0]&1))k=h+1|0;else k=c[h+8>>2]|0;Krd(k,0,3653512,308,1,0,0,0);xri(h);j=0;i=f;return j|0}function fJd(){var a=0,b=0;a=i;b=rVb(14)|0;i=a;return b|0}function gJd(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[(c[a+48>>2]|0)+40>>2]|0;e=c[(c[a+52>>2]|0)+40>>2]|0;hJd(0,d,e,a);hJd(1,e,d,a);i=b;return}function hJd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g;if(!(a[d+45>>0]|0)){i=g;return}l=c[d+144>>2]|0;if(!l){i=g;return}a[k+36>>0]=b&1^1;c[k+32>>2]=f;c[k+4>>2]=d;c[k>>2]=MId(d)|0;c[k+20>>2]=e;c[k+16>>2]=MId(e)|0;if(b){c[k+8>>2]=c[f+52>>2];c[k+12>>2]=c[f+60>>2];m=f+48|0;n=f+56|0}else{c[k+8>>2]=c[f+48>>2];c[k+12>>2]=c[f+56>>2];m=f+52|0;n=f+60|0}c[k+24>>2]=c[m>>2];c[k+28>>2]=c[n>>2];if(mo[c[(c[l>>2]|0)+144>>2]&4095](l)|0){n=l+32|0;m=l+40|0;f=(c[m>>2]|0)+1|0;c[m>>2]=f;b=l+44|0;e=c[b>>2]|0;d=e&2147483647;if(f>>>0>d>>>0){o=e<<1;p=(o|0)==0?1:o;do if(d>>>0<p>>>0)if((e|0)>-1){c[b>>2]=p;o=c[n>>2]|0;c[j>>2]=c[l+36>>2];c[h+0>>2]=c[j+0>>2];c[n>>2]=hOb(o,p*40|0,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[l+36>>2];c[h+0>>2]=c[j+0>>2];o=cOb(p*40|0,4,h,0,3653512,352)|0;YEi(o|0,c[n>>2]|0,(c[m>>2]|0)*40|0)|0;c[b>>2]=p;c[n>>2]=o;break}while(0);q=c[m>>2]|0}else q=f;f=(c[n>>2]|0)+((q+-1|0)*40|0)|0;q=f+0|0;n=k+0|0;m=q+36|0;do{c[q>>2]=c[n>>2];q=q+4|0;n=n+4|0}while((q|0)<(m|0));a[f+36>>0]=a[k+36>>0]|0}In[c[(c[l>>2]|0)+132>>2]&4095](l,k);i=g;return}function iJd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=b+48|0;g=c[(c[f>>2]|0)+40>>2]|0;h=b+52|0;j=c[(c[h>>2]|0)+40>>2]|0;if((a[g+45>>0]|0)!=0?(k=c[g+144>>2]|0,(k|0)!=0):0){a[e+36>>0]=1;c[e+32>>2]=b;c[e+4>>2]=g;c[e>>2]=MId(g)|0;c[e+20>>2]=j;c[e+16>>2]=MId(j)|0;c[e+8>>2]=c[f>>2];c[e+12>>2]=c[b+56>>2];c[e+24>>2]=c[h>>2];c[e+28>>2]=c[b+60>>2];In[c[(c[k>>2]|0)+136>>2]&4095](k,e)}if(!(a[j+45>>0]|0)){i=d;return}k=c[j+144>>2]|0;if(!k){i=d;return}a[e+36>>0]=0;c[e+32>>2]=b;c[e+4>>2]=j;c[e>>2]=MId(j)|0;c[e+20>>2]=g;c[e+16>>2]=MId(g)|0;c[e+8>>2]=c[h>>2];c[e+12>>2]=c[b+60>>2];c[e+24>>2]=c[f>>2];c[e+28>>2]=c[b+56>>2];In[c[(c[k>>2]|0)+136>>2]&4095](k,e);i=d;return}function jJd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[(c[a+52>>2]|0)+40>>2]|0;e=c[(c[(c[a+48>>2]|0)+40>>2]|0)+144>>2]|0;a:do if(e){f=c[e+32>>2]|0;g=e+40|0;h=f+((c[g>>2]|0)*40|0)|0;j=f;while(1){if((j|0)==(h|0))break a;f=j+40|0;if((c[j+32>>2]|0)==(a|0)){k=f;l=j;break}else j=f}aFi(l|0,k|0,h-k|0)|0;c[g>>2]=(c[g>>2]|0)+-1}while(0);k=c[d+144>>2]|0;if(!k){i=b;return}d=c[k+32>>2]|0;l=k+40|0;k=d+((c[l>>2]|0)*40|0)|0;e=d;while(1){if((e|0)==(k|0)){m=11;break}d=e+40|0;if((c[e+32>>2]|0)==(a|0)){n=d;o=e;break}else e=d}if((m|0)==11){i=b;return}aFi(o|0,n|0,k-n|0)|0;c[l>>2]=(c[l>>2]|0)+-1;i=b;return}function kJd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;do if((a[b+28>>0]|0)!=0?(a[d+28>>0]|0)!=0:0){if(a[b+45>>0]|0){f=c[b+144>>2]|0;if(!f){g=0;break}if(mo[c[(c[f>>2]|0)+148>>2]&4095](f)|0){g=0;break}if(!(1<<c[(c[d+24>>2]|0)+40>>2]&c[f+48>>2])){g=0;break}if(!(c[(MId(d)|0)>>2]|0)){g=0;break}}if(a[d+45>>0]|0){f=c[d+144>>2]|0;if(((f|0)!=0?!(mo[c[(c[f>>2]|0)+148>>2]&4095](f)|0):0)?(1<<c[(c[b+24>>2]|0)+40>>2]&c[f+48>>2]|0)!=0:0)g=(c[(MId(b)|0)>>2]|0)!=0;else g=0}else g=1}else g=0;while(0);i=e;return g|0}function lJd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;h=ea(h);var j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=0,A=0,B=Im,C=0,D=Im,E=Im,F=Im,G=Im;j=i;k=b+60|0;if(!(c[k>>2]|0)){i=j;return}l=c[b+56>>2]|0;if(!l){g[a>>2]=ea(1.0);m=a+4|0;g[m>>2]=ea(0.0);n=ea(g[d+12>>2]);o=ea(g[b+48>>2]);p=ea(n*o);q=ea(g[d+8>>2]);r=ea(g[b+52>>2]);s=ea(p-ea(q*r));p=ea(ea(g[d>>2])+s);s=ea(ea(o*q)+ea(n*r));r=ea(s+ea(g[d+4>>2]));s=ea(g[f+12>>2]);n=ea(g[b>>2]);q=ea(s*n);o=ea(g[f+8>>2]);t=ea(g[b+4>>2]);u=ea(q-ea(o*t));q=ea(ea(g[f>>2])+u);u=ea(ea(n*o)+ea(s*t));t=ea(u+ea(g[f+4>>2]));u=ea(p-q);s=ea(r-t);if(ea(ea(u*u)+ea(s*s))>ea(1.42108547e-14)){s=ea(q-p);u=ea(t-r);o=ea(s);n=ea(u);v=a;g[v>>2]=o;g[v+4>>2]=n;n=ea(T(ea(ea(s*s)+ea(u*u))));if(n<ea(1.1920929e-07)){w=s;x=u}else{o=ea(ea(1.0)/n);n=ea(s*o);g[a>>2]=n;s=ea(u*o);g[m>>2]=s;w=n;x=s}}else{w=ea(1.0);x=ea(0.0)}s=ea(p+ea(w*e));p=ea(r+ea(x*e));r=ea(q-ea(w*h));q=ea(t-ea(x*h));t=ea(ea(s+r)*ea(.5));n=ea(ea(p+q)*ea(.5));o=ea(t);t=ea(n);m=a+8|0;g[m>>2]=o;g[m+4>>2]=t;g[a+24>>2]=ea(ea(w*ea(r-s))+ea(x*ea(q-p)));i=j;return}else if((l|0)==1){m=d+12|0;p=ea(g[m>>2]);q=ea(g[b+40>>2]);x=ea(p*q);v=d+8|0;s=ea(g[v>>2]);r=ea(g[b+44>>2]);w=ea(x-ea(s*r));x=ea(ea(q*s)+ea(p*r));r=ea(w);p=ea(x);y=a;g[y>>2]=r;g[y+4>>2]=p;p=ea(g[m>>2]);r=ea(g[b+48>>2]);s=ea(p*r);q=ea(g[v>>2]);t=ea(g[b+52>>2]);o=ea(s-ea(q*t));s=ea(ea(g[d>>2])+o);o=ea(ea(r*q)+ea(p*t));t=ea(o+ea(g[d+4>>2]));if((c[k>>2]|0)<=0){i=j;return}v=f+12|0;m=f+8|0;y=f+4|0;z=a+4|0;o=w;w=x;A=0;while(1){x=ea(g[v>>2]);p=ea(g[b+(A*20|0)>>2]);q=ea(x*p);r=ea(g[m>>2]);n=ea(g[b+(A*20|0)+4>>2]);u=ea(q-ea(r*n));q=ea(ea(g[f>>2])+u);u=ea(ea(p*r)+ea(x*n));n=ea(u+ea(g[y>>2]));u=ea(e-ea(ea(o*ea(q-s))+ea(ea(n-t)*w)));x=ea(q+ea(o*u));r=ea(n+ea(w*u));u=ea(q-ea(o*h));q=ea(n-ea(w*h));n=ea(ea(u+x)*ea(.5));p=ea(ea(q+r)*ea(.5));B=ea(n);n=ea(p);C=a+(A<<3)+8|0;g[C>>2]=B;g[C+4>>2]=n;n=ea(u-x);x=ea(q-r);r=ea(ea(g[a>>2])*n);g[a+(A<<2)+24>>2]=ea(r+ea(ea(g[z>>2])*x));C=A+1|0;if((C|0)>=(c[k>>2]|0))break;x=ea(g[a>>2]);o=x;w=ea(g[z>>2]);A=C}i=j;return}else if((l|0)==2){l=f+12|0;w=ea(g[l>>2]);o=ea(g[b+40>>2]);t=ea(w*o);A=f+8|0;s=ea(g[A>>2]);x=ea(g[b+44>>2]);r=ea(t-ea(s*x));t=ea(ea(o*s)+ea(w*x));x=ea(r);w=ea(t);z=a;g[z>>2]=x;g[z+4>>2]=w;w=ea(g[l>>2]);x=ea(g[b+48>>2]);s=ea(w*x);o=ea(g[A>>2]);n=ea(g[b+52>>2]);q=ea(s-ea(o*n));s=ea(ea(g[f>>2])+q);q=ea(ea(x*o)+ea(w*n));n=ea(q+ea(g[f+4>>2]));if((c[k>>2]|0)>0){f=d+12|0;A=d+8|0;l=d+4|0;z=a+4|0;q=r;w=t;y=0;while(1){o=ea(g[f>>2]);x=ea(g[b+(y*20|0)>>2]);u=ea(o*x);B=ea(g[A>>2]);p=ea(g[b+(y*20|0)+4>>2]);D=ea(u-ea(B*p));u=ea(ea(g[d>>2])+D);D=ea(ea(x*B)+ea(o*p));p=ea(D+ea(g[l>>2]));D=ea(h-ea(ea(q*ea(u-s))+ea(ea(p-n)*w)));o=ea(u+ea(q*D));B=ea(p+ea(w*D));D=ea(u-ea(q*e));u=ea(p-ea(w*e));p=ea(ea(D+o)*ea(.5));x=ea(ea(u+B)*ea(.5));E=ea(p);p=ea(x);m=a+(y<<3)+8|0;g[m>>2]=E;g[m+4>>2]=p;p=ea(D-o);o=ea(u-B);B=ea(ea(g[a>>2])*p);g[a+(y<<2)+24>>2]=ea(B+ea(ea(g[z>>2])*o));y=y+1|0;o=ea(g[a>>2]);B=ea(g[z>>2]);if((y|0)>=(c[k>>2]|0)){F=o;G=B;break}else{q=o;w=B}}}else{F=r;G=t}t=ea(-F);F=ea(-G);G=ea(t);t=ea(F);k=a;g[k>>2]=G;g[k+4>>2]=t;i=j;return}else{i=j;return}}function mJd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b[d>>1]|0;d=a+8|0;j=(c[d>>2]|0)+1|0;c[d>>2]=j;k=a+12|0;l=c[k>>2]|0;m=l&2147483647;if(j>>>0<=m>>>0){n=j;o=n+-1|0;p=c[a>>2]|0;q=p+(o<<1)|0;b[q>>1]=h;i=e;return}j=l<<1;r=(j|0)==0?1:j;do if(m>>>0<r>>>0)if((l|0)>-1){c[k>>2]=r;j=c[a>>2]|0;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];c[a>>2]=hOb(j,r<<1,2,f,0,3653512,370)|0;break}else{c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];j=cOb(r<<1,2,f,0,3653512,352)|0;YEi(j|0,c[a>>2]|0,c[d>>2]<<1|0)|0;c[k>>2]=r;c[a>>2]=j;break}while(0);n=c[d>>2]|0;o=n+-1|0;p=c[a>>2]|0;q=p+(o<<1)|0;b[q>>1]=h;i=e;return}function nJd(){var a=0;a=i;QQb(180,189,0,0,0);i=a;return}function oJd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,669528,14);wQb(180,8,b,32,2730,1,0);xri(b);i=a;return}function pJd(a){a=a|0;return 180}function qJd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];bUb(b,g,e);a[b+28>>0]=1;a[b+29>>0]=0;c[b>>2]=669552;i=f;return}function rJd(a,b){a=a|0;b=b|0;return 0}function sJd(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);i=b;return}function tJd(a){a=a|0;var b=0;b=i;c[a>>2]=577608;WUb(a);ACi(a);i=b;return}function uJd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,j=0;b=i;if(!a){g=37;i=b;return g|0}ko[c[(c[a>>2]|0)+20>>2]&4095](a);if(!(mo[c[(c[a>>2]|0)+12>>2]&4095](a)|0)){ko[c[(c[a>>2]|0)+24>>2]&4095](a);g=54;i=b;return g|0}else{h=1.0/+ea(Kn[c[(c[a>>2]|0)+32>>2]&255](a));j=~~(h*+((mo[c[(c[a>>2]|0)+12>>2]&4095](a)|0)>>>0))>>>0;c[d>>2]=j;d=xCi(16)|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=j;c[d+4>>2]=a;c[f>>2]=d;c[e>>2]=a;ko[c[(c[a>>2]|0)+24>>2]&4095](a);g=0;i=b;return g|0}return 0}function vJd(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(a)if(!b)d=0;else{ACi(b);d=0}else d=37;i=c;return d|0}function wJd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(!a){h=37;i=g;return h|0}a=f+4|0;j=c[a>>2]|0;ko[c[(c[j>>2]|0)+20>>2]&4095](j);j=c[a>>2]|0;k=mo[c[(c[j>>2]|0)+4>>2]&4095](j)|0;j=c[a>>2]|0;l=mo[c[(c[j>>2]|0)+12>>2]&4095](j)|0;j=f+8|0;f=c[j>>2]|0;if(l>>>0>=f>>>0){m=l-f|0;f=m>>>0<d>>>0?m:d;c[e>>2]=f;YEi(b|0,k+(c[j>>2]|0)|0,f|0)|0;c[j>>2]=(c[e>>2]|0)+(c[j>>2]|0);j=c[a>>2]|0;ko[c[(c[j>>2]|0)+24>>2]&4095](j);i=g;return ((c[e>>2]|0)>>>0<d>>>0?22:0)|0}d=c[a>>2]|0;ko[c[(c[d>>2]|0)+24>>2]&4095](d);h=54;i=g;return h|0}function xJd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!a){f=37;i=e;return f|0}a=d+4|0;g=c[a>>2]|0;ko[c[(c[g>>2]|0)+20>>2]&4095](g);g=c[a>>2]|0;if((mo[c[(c[g>>2]|0)+12>>2]&4095](g)|0)>>>0>=b>>>0?(c[d+12>>2]|0)>>>0>=b>>>0:0){c[d+8>>2]=b;b=c[a>>2]|0;ko[c[(c[b>>2]|0)+24>>2]&4095](b);f=0;i=e;return f|0}b=c[a>>2]|0;ko[c[(c[b>>2]|0)+24>>2]&4095](b);f=20;i=e;return f|0}function yJd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+16|0;k=f+4|0;c[h>>2]=d;c[j>>2]=0;gTd(b,j)|0;b=c[j>>2]|0;if(!b){l=23;i=f;return l|0}if(!(c[b+120>>2]|0)){c[g>>2]=669688;Lsd(k,671192,g);if(!(a[k>>0]&1))m=k+1|0;else m=c[k+8>>2]|0;Krd(m,0,3653512,180,1,c[b+4>>2]|0,0,0);xri(k)}k=$Jd(b,h,e)|0;l=k?0:54;i=f;return l|0}function zJd(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+256|0;h=g+200|0;j=g+216|0;k=g+224|0;l=g+220|0;m=g+236|0;n=g;o=g+208|0;p=g+240|0;gTd(b,j)|0;b=c[j>>2]|0;if(!b){q=22;i=g;return q|0}j=c[b>>2]|0;if(!(a[669976]|0)){r=-1;s=0;t=0;while(1){if(!(r&1))u=t;else u=1<<31-s|t;s=s+1|0;if((s|0)==32){v=u;w=684656;break}else{r=r>>>1;t=u}}while(1){u=c[572464+((d[w>>0]^v&255)<<2)>>2]^v>>>8;w=w+1|0;if((w|0)==684744){x=u;break}else v=u}v=~x;c[167492]=v;x=669976;c[x>>2]=1;c[x+4>>2]=0;y=v}else y=c[167492]|0;if((j|0)==(y|0))z=c[b+4>>2]|0;else z=0;b=MOd(z)|0;if(!b){q=22;i=g;return q|0}z=b+120|0;if(!(c[z>>2]|0)){c[h>>2]=669768;Lsd(k,671192,h);if(!(a[k>>0]&1))A=k+1|0;else A=c[k+8>>2]|0;Krd(A,0,3653512,214,1,c[b+4>>2]|0,0,0);xri(k)}k=RLd(aMd()|0)|0;c[l>>2]=0;iNd(k,f>>>2,l);k=Ecd(b)|0;b=(c[z>>2]|0)+56|0;z=c[b+4>>2]|0;A=o;c[A>>2]=c[b>>2];c[A+4>>2]=z;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];jbd(n,h);ebd(n+32|0,c[l>>2]|0);c[n+12>>2]=k;qbd(n,m)|0;n=c[m>>2]|0;if(!n){YEi(e|0,Gsc(c[l>>2]|0,0,4)|0,f|0)|0;q=0;i=g;return q|0}else{f=Grc(k)|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Rcd(n,f,p);xri(p);q=0;i=g;return q|0}return 0}function AJd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+256|0;e=g+208|0;h=g+228|0;j=g+232|0;k=g+244|0;l=g+8|0;m=g;n=g+216|0;gTd(b,h)|0;b=c[h>>2]|0;if(!b){o=20;i=g;return o|0}h=c[b>>2]|0;if(!(a[669976]|0)){p=-1;q=0;r=0;while(1){if(!(p&1))s=r;else s=1<<31-q|r;q=q+1|0;if((q|0)==32){t=s;u=684656;break}else{p=p>>>1;r=s}}while(1){s=c[572464+((d[u>>0]^t&255)<<2)>>2]^t>>>8;u=u+1|0;if((u|0)==684744){v=s;break}else t=s}t=~v;c[167492]=t;v=669976;c[v>>2]=1;c[v+4>>2]=0;w=t}else w=c[167492]|0;if((h|0)==(w|0))x=c[b+4>>2]|0;else x=0;b=MOd(x)|0;if(!b){o=20;i=g;return o|0}x=b+120|0;if(!(c[x>>2]|0)){c[e>>2]=669856;Lsd(j,671192,e);if(!(a[j>>0]&1))y=j+1|0;else y=c[j+8>>2]|0;Krd(y,0,3653512,270,1,c[b+4>>2]|0,0,0);xri(j)}j=Ecd(b)|0;b=(c[x>>2]|0)+64|0;x=c[b+4>>2]|0;y=m;c[y>>2]=c[b>>2];c[y+4>>2]=x;c[e+0>>2]=c[m+0>>2];c[e+4>>2]=c[m+4>>2];jbd(l,e);$ad(l+32|0,f);c[l+12>>2]=j;qbd(l,k)|0;l=c[k>>2]|0;if(!l){o=0;i=g;return o|0}k=Grc(j)|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Rcd(l,k,n);xri(n);o=0;i=g;return o|0}function BJd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+100|0;e=c[d>>2]|0;if(!e){i=b;return}f=a+104|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0;i=b;return}function CJd(b){b=b|0;var c=0,d=0,e=0;c=i;d=b+116|0;if(a[d>>0]|0){e=0;i=c;return e|0}if(a[b+60>>0]|0){e=0;i=c;return e|0}a[d>>0]=1;DJd(b);KOd(rOd()|0,b);e=1;i=c;return e|0}function DJd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;if((a[b+60>>0]|0)==0?(a[b+116>>0]|0)==0:0){i=d;return}l=b+64|0;m=a[l>>0]|0;if(!(m&1))n=(m&255)>>>1;else n=c[b+68>>2]|0;if(!n){i=d;return}n=b+96|0;m=(c[n>>2]&-2|0)==4?50:82;if(a[b+40>>0]|0){o=m|16384;p=b+48|0;q=(c[p>>2]|0)==1?2:0;if(!(a[b+61>>0]|0)){r=p;s=q;t=o}else{if(!b)u=0;else u=c[b+4>>2]|0;Krd(670552,0,3653512,183,1,u,0,0);r=p;s=q;t=o}}else{r=b+48|0;s=0;t=(a[b+61>>0]|0)==0?m:m|65536}m=c[r>>2]|0;if((c[b+32>>2]|0)>2?(c[n>>2]|0)!=0:0)v=(m|0)==1?2:m;else v=m;if(!v){m=rOd()|0;n=c[b+56>>2]|0;if(!b)w=0;else w=c[b+4>>2]|0;c[f>>2]=w;wOd(e,m,l,n,t|256,s,f,0);xOd(b+52|0,e);BOd(e);i=d;return}else if((v|0)==1){e=rOd()|0;f=c[b+56>>2]|0;if(!b)x=0;else x=c[b+4>>2]|0;c[h>>2]=x;wOd(g,e,l,f,t|512,s,h,0);xOd(b+52|0,g);BOd(g);i=d;return}else if((v|0)==2){v=rOd()|0;g=c[b+56>>2]|0;if(!b)y=0;else y=c[b+4>>2]|0;c[k>>2]=y;wOd(j,v,l,g,t|128,2,k,0);xOd(b+52|0,j);BOd(j);i=d;return}else{i=d;return}}function EJd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(a[b+60>>0]|0){Krd(670088,0,3653512,101,1,c[b+4>>2]|0,0,0);e=0;i=d;return e|0}f=b+116|0;if(!(a[f>>0]|0)){e=0;i=d;return e|0}g=b+52|0;h=c[g>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)!=0:0){h=c[g>>2]|0;if(!h)j=0;else j=c[h+12>>2]|0;if((vOd(j)|0)!=3){j=c[g>>2]|0;if(!j)k=0;else k=c[j+12>>2]|0;if((vOd(k)|0)!=4){if(!b)l=0;else l=c[b+4>>2]|0;Krd(670176,0,3653512,113,512,l,0,0)}}}a[f>>0]=0;LOd(rOd()|0,b);e=1;i=d;return e|0}function FJd(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+52>>2]|0;if(!d)e=0;else e=c[d+12>>2]|0;d=vOd(e)|0;i=b;return d|0}function GJd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=b+52|0;j=c[h>>2]|0;if(!((j|0)!=0?(c[j+12>>2]|0)!=0:0))DJd(b);DOd(a,h,d);d=c[a>>2]|0;if(!d){i=g;return}if(!((c[d+12>>2]|0)!=0&((e|0)!=0|(f|0)!=0))){i=g;return}d=c[a>>2]|0;if(!d)k=0;else k=c[d+12>>2]|0;nKd(_Nd(k,1,f,e)|0,670384,139,670448)|0;i=g;return}function HJd(a){a=a|0;return c[a+96>>2]|0}function IJd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,670768,10);wQb(271,130,b,120,2731,0,0);xri(b);i=a;return}function JJd(a){a=a|0;return 271}function KJd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,670768,a,0);xWb(a,b);bdd(b);i=c;return}function LJd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,670768,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else yWb(a,b);sdd(b);i=d;return}function MJd(a,b){a=a|0;b=b|0;var c=0;c=i;zWb(a,b);i=c;return}function NJd(a,b){a=a|0;b=b|0;var c=0;c=i;AWb(a,b);i=c;return}function OJd(a,b){a=a|0;b=b|0;var c=0;c=i;BWb(a,b);i=c;return}function PJd(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function QJd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0;f=i;i=i+16|0;h=f+4|0;j=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];mWb(b,h,e);c[b>>2]=669992;e=b+28|0;g[b+44>>2]=ea(0.0);c[b+48>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;a[e+12>>0]=0;yOd(b+52|0);c[b+56>>2]=0;a[b+60>>0]=1;a[b+61>>0]=0;a[b+62>>0]=0;e=b+64|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=b+80|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[b+108>>2]=b;c[b+112>>2]=0;a[b+116>>0]=0;c[b>>2]=670792;a[b+117>>0]=1;c[b+120>>2]=0;i=f;return}function RJd(){return}function SJd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+120|0;if(c[e>>2]|0){i=d;return}b=xCi(80)|0;f=b+0|0;g=f+80|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[e>>2]=b;c[b>>2]=0;c[b+4>>2]=0;a[b+20>>0]=0;c[b+24>>2]=0;a[b+28>>0]=1;c[b+32>>2]=0;a[b+36>>0]=0;c[b+40>>2]=0;c[b+44>>2]=3;c[b+48>>2]=0;c[b+52>>2]=0;e=b+56|0;c[e+0>>2]=c[146758];a[e+4>>0]=a[587036]|0;e=b+64|0;c[e+0>>2]=c[146758];a[e+4>>0]=a[587036]|0;c[b+72>>2]=0;a[b+76>>0]=0;i=d;return}function TJd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;j=i;i=i+80|0;k=j;l=j+40|0;m=j+44|0;n=j+56|0;o=j+16|0;p=j+4|0;q=j+28|0;r=b+120|0;s=c[r>>2]|0;if(!s){t=xCi(80)|0;u=t+0|0;v=u+80|0;do{c[u>>2]=0;u=u+4|0}while((u|0)<(v|0));c[r>>2]=t;c[t>>2]=0;c[t+4>>2]=0;a[t+20>>0]=0;c[t+24>>2]=0;a[t+28>>0]=1;c[t+32>>2]=0;a[t+36>>0]=0;c[t+40>>2]=0;c[t+44>>2]=3;c[t+48>>2]=0;c[t+52>>2]=0;u=t+56|0;c[u+0>>2]=c[146758];a[u+4>>0]=a[587036]|0;u=t+64|0;c[u+0>>2]=c[146758];a[u+4>>0]=a[587036]|0;c[t+72>>2]=0;a[t+76>>0]=0;w=t}else w=s;do if(!d)x=w;else{s=mo[c[(c[d>>2]|0)+48>>2]&4095](d)|0;rri(o,s,SEi(s|0)|0);gsd(n,o);sri(m,n);s=a[m>>0]|0;if(!(s&1)){t=m+1|0;y=t;z=t;A=m+8|0}else{t=m+8|0;y=c[t>>2]|0;z=m+1|0;A=t}t=m+4|0;u=s;s=y;while(1){if(!(u&1)){B=z;C=(u&255)>>>1}else{B=c[A>>2]|0;C=c[t>>2]|0}if((s|0)==(B+C|0))break;v=a[s>>0]|0;D=v<<24>>24;a[s>>0]=(v+-65<<24>>24&255)<26?D+32|0:D;u=a[m>>0]|0;s=s+1|0}xri(n);xri(o);if(!h){s=UJd(m)|0;u=c[r>>2]|0;c[u>>2]=s;E=s;F=u}else{u=c[r>>2]|0;c[u>>2]=h;E=h;F=u}if(!E){c[k>>2]=mo[c[(c[d>>2]|0)+48>>2]&4095](d)|0;Lsd(p,670888,k);if(!b)G=0;else G=c[b+4>>2]|0;if(!(a[p>>0]&1))H=p+1|0;else H=c[p+8>>2]|0;Krd(H,0,3653512,309,1,G,0,0);xri(p);xri(m);I=0;i=j;return I|0}a:do if(!f){if((E|0)!=14)J=29}else{switch(E|0){case 14:{break a;break}case 17:case 12:case 10:case 21:break;default:{J=29;break a}}if(!b)K=0;else K=c[b+4>>2]|0;Krd(670968,0,3653512,319,1,K,0,0);xri(m);I=0;i=j;return I|0}while(0);if((J|0)==29){c[F+32>>2]=d;c[d+16>>2]=b;ncc(d);u=c[r>>2]|0;a[u+36>>0]=1;a[u+76>>0]=f&1;a[u+77>>0]=g&1;s=u+16|0;t=u+8|0;D=c[t>>2]|0;if(((c[s>>2]|0)-D|0)>>>0<65536?(v=u+12|0,u=(c[v>>2]|0)-D|0,c[l>>2]=20,c[k+0>>2]=c[l+0>>2],D=cOb(65536,16,k,0,3653512,80)|0,L=c[t>>2]|0,M=(c[v>>2]|0)-L|0,N=D+(u-M)|0,YEi(N|0,L|0,M|0)|0,M=c[t>>2]|0,c[t>>2]=N,c[v>>2]=D+u,c[s>>2]=D+65536,(M|0)!=0):0){c[l>>2]=20;c[k+0>>2]=c[l+0>>2];eOb(M,k)}VJd(b)|0;xri(m);x=c[r>>2]|0;break}if(!(a[m>>0]&1))O=m+1|0;else O=c[m+8>>2]|0;c[k>>2]=O;Lsd(q,671080,k);if(!b)P=0;else P=c[b+4>>2]|0;if(!(a[q>>0]&1))Q=q+1|0;else Q=c[q+8>>2]|0;Krd(Q,0,3653512,340,1,P,0,0);xri(q);xri(m);I=0;i=j;return I|0}while(0);c[x+40>>2]=e;if(!e){I=1;i=j;return I|0}a[x+36>>0]=1;VJd(b)|0;I=1;i=j;return I|0}function UJd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;sri(e,b);b=a[e>>0]|0;if(!(b&1)){f=e+1|0;g=f;h=f;j=e+8|0}else{f=e+8|0;g=c[f>>2]|0;h=e+1|0;j=f}f=e+4|0;k=g;g=b;while(1){if(!(g&1)){l=h;m=(g&255)>>>1}else{l=c[j>>2]|0;m=c[f>>2]|0}if((k|0)==(l+m|0))break;b=a[k>>0]|0;n=b<<24>>24;a[k>>0]=(b+-65<<24>>24&255)<26?n+32|0:n;k=k+1|0;g=a[e>>0]|0}if(Ori(e,671136)|0)if((Ori(e,671144)|0)!=0?(Ori(e,671152)|0)!=0:0)if(Ori(e,671160)|0)if(Ori(e,671168)|0)if(Ori(e,671176)|0)if(!(Ori(e,671184)|0))o=17;else{g=(Ori(e,2749440)|0)==0;o=g?12:0}else o=21;else o=10;else o=20;else o=13;else o=14;xri(e);i=d;return o|0}function VJd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=a+52|0;COd(e);XJd(d,a);xOd(e,d);BOd(d);d=c[e>>2]|0;if((d|0)!=0?(c[d+12>>2]|0)!=0:0){d=c[a+120>>2]|0;if(!d)f=1;else{c[d+44>>2]=0;f=1}}else f=0;i=b;return f|0}function WJd(a){a=a|0;var b=0;b=i;COd(a+52|0);i=b;return}function XJd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+160|0;f=e+148|0;g=e+144|0;h=e+8|0;j=e;k=d+120|0;l=c[k>>2]|0;do if(!l)m=18;else{if(!(a[l+36>>0]|0)){if(!(a[l+20>>0]|0)){m=18;break}PEi(h|0,0,136)|0;c[h>>2]=136;c[h+72>>2]=c[l>>2];c[h+20>>2]=c[l+4>>2];c[h+16>>2]=c[d+28>>2];n=c[d+32>>2]|0;c[h+12>>2]=n;c[h+4>>2]=da(c[l+24>>2]<<2,n)|0;c[h+44>>2]=1737;c[h+48>>2]=251;n=(a[l+28>>0]|0)!=0?1234:1362;o=rOd()|0;p=mo[c[(c[d>>2]|0)+32>>2]&4095](d)|0;if(!d)q=0;else q=c[d+4>>2]|0;c[j>>2]=q;nKd(JOd(o,p,n,h,d+52|0,0,j)|0,670384,779,671304)|0;break}n=c[l+32>>2]|0;if(!n){if(!(c[l+40>>2]|0))break;p=rOd()|0;o=ALd(aMd()|0,d)|0;if(!d)r=0;else r=c[d+4>>2]|0;c[g>>2]=r;IOd(b,p,o,0,g);i=e;return}if((a[l+76>>0]|0)==0?ea(Kn[c[(c[n>>2]|0)+32>>2]&255](n))!=ea(1.0):0){yOd(b);i=e;return}n=rOd()|0;o=aMd()|0;p=c[k>>2]|0;s=zLd(o,c[p+32>>2]|0,c[p>>2]|0,c[p+4>>2]|0,c[d+28>>2]|0,c[d+32>>2]|0,(a[p+76>>0]|0)!=0,(a[p+77>>0]|0)!=0,d)|0;if(!d)t=0;else t=c[d+4>>2]|0;c[f>>2]=t;IOd(b,n,s,0,f);i=e;return}while(0);if((m|0)==18)DJd(d);zOd(b,d+52|0);i=e;return}function YJd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;COd(a+52|0);d=c[a+120>>2]|0;if((d|0)!=0?(e=c[d+32>>2]|0,(e|0)!=0):0){c[e+16>>2]=0;occ(e)}e=a+100|0;d=c[e>>2]|0;if(!d){i=b;return}f=a+104|0;c[d+4>>2]=c[f>>2];c[c[f>>2]>>2]=d;c[e>>2]=0;c[f>>2]=0;i=b;return}function ZJd(a){a=a|0;var b=0,c=0,d=0;b=i;c=UJd(a)|0;if((c|0)==13|(c|0)==0){d=0;i=b;return d|0}d=1;i=b;return d|0}function _Jd(){return}function $Jd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=f+4|0;j=b+120|0;k=c[j>>2]|0;if(!k){c[g>>2]=671240;Lsd(h,671192,g);if(!(a[h>>0]&1))l=h+1|0;else l=c[h+8>>2]|0;Krd(l,0,3653512,623,1,c[b+4>>2]|0,0,0);xri(h);m=c[j>>2]|0}else m=k;k=c[m+8>>2]|0;if(((c[m+12>>2]|0)-k|0)>>>0<e>>>0){n=0;i=f;return n|0}YEi(c[d>>2]|0,k|0,e|0)|0;k=c[j>>2]|0;j=c[k+8>>2]|0;if(!e){n=1;i=f;return n|0}d=j+e|0;e=k+12|0;k=(c[e>>2]|0)-d|0;aFi(j|0,d|0,k|0)|0;d=j+k|0;if((c[e>>2]|0)==(d|0)){n=1;i=f;return n|0}c[e>>2]=d;n=1;i=f;return n|0}function aKd(a){a=a|0;var b=0,d=0;b=c[a+120>>2]|0;if(!b)d=0;else d=c[b+40>>2]|0;return d|0}function bKd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+100|0;e=c[d>>2]|0;if(e){f=a+104|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}Xed(kfd()|0,a)|0;i=b;return}function cKd(a){a=a|0;return}function dKd(a,b){a=a|0;b=b|0;var c=0;c=i;if(!(b&32))VJd(a)|0;i=c;return}function eKd(){var a=0;a=i;QQb(83,190,191,0,192);i=a;return}function fKd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(271)|0))IJd();rri(b,2466248,9);wQb(83,271,b,128,2732,0,0);xri(b);i=a;return}function gKd(a){a=a|0;return 83}function hKd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2466248,a,0);qKd(a,b);bdd(b);i=c;return}function iKd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2466248,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else rKd(a,b);sdd(b);i=d;return}function jKd(a,b){a=a|0;b=b|0;var c=0;c=i;sKd(a,b);i=c;return}function kKd(a,b){a=a|0;b=b|0;var c=0;c=i;tKd(a,b);i=c;return}function lKd(a,b){a=a|0;b=b|0;var c=0;c=i;uKd(a,b);i=c;return}function mKd(a,b){a=a|0;b=b|0;var c=0;c=i;CWb(a,b);i=c;return}function nKd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g;j=g+16|0;do switch(b|0){case 13:{k=685512;break}case 92:{k=686176;break}case 86:{k=686600;break}case 29:{k=687696;break}case 20:{k=687120;break}case 90:{k=686920;break}case 50:{k=689424;break}case 51:{k=689472;break}case 52:{k=689568;break}case 15:{k=685712;break}case 44:{k=688568;break}case 45:{k=688696;break}case 95:{k=688752;break}case 23:{k=687368;break}case 65:{k=690664;break}case 66:{k=690728;break}case 67:{k=690792;break}case 68:{k=690888;break}case 14:{k=685568;break}case 19:{k=687096;break}case 39:{k=688248;break}case 40:{k=688336;break}case 56:{k=689896;break}case 57:{k=689936;break}case 58:{k=690072;break}case 35:{k=688040;break}case 36:{k=688096;break}case 91:{k=686424;break}case 3:{k=684952;break}case 2:{k=684816;break}case 88:{k=686872;break}case 32:{k=687824;break}case 5:{k=685064;break}case 25:{k=687424;break}case 30:{k=687728;break}case 0:{i=g;return b|0}case 22:{k=687272;break}case 11:{k=685296;break}case 18:{k=686072;break}case 1:{k=684752;break}case 31:{k=687760;break}case 94:{k=688816;break}case 93:{k=688864;break}case 46:{k=688944;break}case 59:{k=690192;break}case 60:{k=690296;break}case 61:{k=690336;break}case 33:{k=687872;break}case 34:{k=687936;break}case 4:{k=685e3;break}case 17:{k=685880;break}case 24:{k=687392;break}case 27:{k=687552;break}case 72:{k=691616;break}case 73:{k=691768;break}case 74:{k=691888;break}case 76:{k=692024;break}case 77:{k=692088;break}case 8:{k=685176;break}case 9:{k=685224;break}case 78:{k=692240;break}case 79:{k=692320;break}case 80:{k=692400;break}case 81:{k=692512;break}case 82:{k=692560;break}case 84:{k=686472;break}case 10:{k=685256;break}case 6:{k=685104;break}case 7:{k=685144;break}case 37:{k=688136;break}case 38:{k=688192;break}case 89:{k=687008;break}case 12:{k=685360;break}case 26:{k=687464;break}case 53:{k=689616;break}case 54:{k=689688;break}case 55:{k=689776;break}case 47:{k=689024;break}case 48:{k=689104;break}case 49:{k=689232;break}case 85:{k=686528;break}case 28:{k=687624;break}case 21:{k=687232;break}case 69:{k=691008;break}case 70:{k=691120;break}case 71:{k=691184;break}case 75:{k=691328;break}case 87:{k=686704;break}case 62:{k=690440;break}case 63:{k=690536;break}case 64:{k=690592;break}case 83:{k=686312;break}case 41:{k=688392;break}case 42:{k=688456;break}case 43:{k=688528;break}case 16:{k=685816;break}default:k=692640}while(0);c[h>>2]=d;c[h+4>>2]=e;c[h+8>>2]=f;c[h+12>>2]=k;Lsd(j,692656,h);if(!(a[j>>0]&1))l=j+1|0;else l=c[j+8>>2]|0;Krd(l,0,3653512,16,1,0,0,0);xri(j);i=g;return b|0}function oKd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;k=c[b>>2]|0;c[j>>2]=k;c[f+0>>2]=c[j+0>>2];j=bOb(120,f,1,16,3653512,79)|0;c[h>>2]=k;c[f+0>>2]=c[h+0>>2];mWb(j,f,d);c[j>>2]=669992;d=j+28|0;g[j+44>>2]=ea(0.0);c[j+48>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;a[d+12>>0]=0;yOd(j+52|0);c[j+56>>2]=0;a[j+60>>0]=1;a[j+61>>0]=0;a[j+62>>0]=0;d=j+64|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;d=j+80|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[j+108>>2]=j;c[j+112>>2]=0;a[j+116>>0]=0;i=e;return j|0}function pKd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;k=c[b>>2]|0;c[j>>2]=k;c[f+0>>2]=c[j+0>>2];j=bOb(128,f,1,16,3653512,157)|0;c[h>>2]=k;c[f+0>>2]=c[h+0>>2];mWb(j,f,d);c[j>>2]=669992;d=j+28|0;g[j+44>>2]=ea(0.0);c[j+48>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;a[d+12>>0]=0;yOd(j+52|0);c[j+56>>2]=0;a[j+60>>0]=1;a[j+61>>0]=0;a[j+62>>0]=0;d=j+64|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;d=j+80|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[j+108>>2]=j;c[j+112>>2]=0;a[j+116>>0]=0;c[j>>2]=670792;a[j+117>>0]=1;c[j+120>>2]=0;i=e;return j|0}function qKd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;xWb(a,b);e=c[142270]|0;add(b,671384,e,a+48|0,0);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,671400,e,a+32|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,671416,e,a+28|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,671432,e,a+36|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2487568,c[142268]|0,a+44|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);h=c[142258]|0;add(b,671448,h,a+40|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,671472,e,a+56|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,671488,h,a+60|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,671512,h,a+61|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,671536,h,a+62|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);h=a+64|0;add(b,671552,671592,h,0);$sd(h,b);bdd(b);add(b,671568,c[142270]|0,a+96|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);fdd(b);i=d;return}function rKd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;yWb(b,d);h=b+48|0;j=c[142270]|0;k=qdd(d,671384,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[k>>2]=o}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+32|0;k=qdd(d,671400,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[k>>2]=m;if((n|0)>=0?(l=o+(n+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[m>>2];c[k>>2]=l}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+28|0;k=qdd(d,671416,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[k>>2]=o}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+36|0;k=qdd(d,671432,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[k>>2]=m;if((n|0)>=0?(l=o+(n+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[m>>2];c[k>>2]=l}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+44|0;k=qdd(d,2487568,c[142268]|0,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[n>>2]);c[k>>2]=o}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+40|0;k=c[142258]|0;o=qdd(d,671448,k,f,0)|0;if(o){do if((o|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}else{n=d+12|0;m=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=m+l|0;c[n>>2]=p;if((l|0)>=0?(m+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[p>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break}Bid(n,h,1)}while(0);sdd(d)}h=b+56|0;o=qdd(d,671472,j,f,0)|0;if(o){if((o|0)>0){o=d+12|0;n=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+p|0;c[o>>2]=l;if((p|0)>=0?(m=n+(p+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[o>>2]=m}else Bid(o,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}sdd(d)}h=b+60|0;o=qdd(d,671488,k,f,0)|0;if(o){do if((o|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+p|0;c[m>>2]=n;if((p|0)>=0?(l+(p+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+61|0;o=qdd(d,671512,k,f,0)|0;if(o){do if((o|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}else{m=d+12|0;n=c[d+16>>2]|0;p=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+p|0;c[m>>2]=l;if((p|0)>=0?(n+(p+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[l>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,h,1)}while(0);sdd(d)}h=b+62|0;o=qdd(d,671536,k,f,0)|0;if(o){do if((o|0)<=0){k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}else{k=d+12|0;m=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=m+l|0;c[k>>2]=p;if((l|0)>=0?(m+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[p>>0]|0;c[k>>2]=(c[k>>2]|0)+1;break}Bid(k,h,1)}while(0);sdd(d)}h=b+64|0;o=qdd(d,671552,671592,f,1)|0;if(o){if((o|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](h,d)|0}else atd(h,d);sdd(d)}h=b+96|0;b=qdd(d,671568,j,f,0)|0;if(!b){i=e;return}if((b|0)>0){b=d+12|0;j=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;k=j+o|0;c[b>>2]=k;if((o|0)>=0?(p=j+(o+4)|0,p>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[k>>2];c[b>>2]=p}else Bid(b,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{b=c[f>>2]|0;if(b)_n[b&4095](h,d)|0}sdd(d);i=e;return}function sKd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;zWb(b,d);f=b+48|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0>m>>>0){Bid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}else{c[f>>2]=c[j>>2];c[h>>2]=k;n=k;o=m}m=b+32|0;k=n+4|0;if(k>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{c[m>>2]=c[n>>2];c[h>>2]=k;p=k;q=o}o=b+28|0;k=p+4|0;if(k>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{c[o>>2]=c[p>>2];c[h>>2]=k;r=k;s=q}q=b+36|0;k=r+4|0;if(k>>>0>s>>>0){Bid(h,q,4);t=c[h>>2]|0;u=c[l>>2]|0}else{c[q>>2]=c[r>>2];c[h>>2]=k;t=k;u=s}s=b+44|0;k=t+4|0;if(k>>>0>u>>>0){Bid(h,s,4);v=c[h>>2]|0;w=c[l>>2]|0}else{g[s>>2]=ea(g[t>>2]);c[h>>2]=k;v=k;w=u}u=b+40|0;if((v+1|0)>>>0>w>>>0)Bid(h,u,1);else{a[u>>0]=a[v>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);v=b+56|0;u=c[h>>2]|0;w=u+4|0;k=c[l>>2]|0;if(w>>>0>k>>>0){Bid(h,v,4);x=c[h>>2]|0;y=c[l>>2]|0}else{c[v>>2]=c[u>>2];c[h>>2]=w;x=w;y=k}k=b+60|0;if((x+1|0)>>>0>y>>>0){Bid(h,k,1);z=c[h>>2]|0}else{a[k>>0]=a[x>>0]|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;z=x}x=b+61|0;if((z+1|0)>>>0>(c[l>>2]|0)>>>0){Bid(h,x,1);A=c[h>>2]|0}else{a[x>>0]=a[z>>0]|0;z=(c[h>>2]|0)+1|0;c[h>>2]=z;A=z}z=b+62|0;if((A+1|0)>>>0>(c[l>>2]|0)>>>0)Bid(h,z,1);else{a[z>>0]=a[A>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Ndd(d);btd(b+64|0,d);A=b+96|0;b=c[h>>2]|0;z=b+4|0;if(z>>>0>(c[l>>2]|0)>>>0){Bid(h,A,4);Ndd(d);i=e;return}else{c[A>>2]=c[b>>2];c[h>>2]=z;Ndd(d);i=e;return}}function tKd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;AWb(b,d);f=b+48|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(h,f,4);o=c[h>>2]|0;p=c[m>>2]|0;q=c[f>>2]|0}else{r=c[j>>2]|0;c[f>>2]=r;c[h>>2]=l;o=l;p=n;q=r}c[f>>2]=XEi(q|0)|0;q=b+32|0;f=o+4|0;if(f>>>0>p>>>0){Bid(h,q,4);s=c[q>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{r=c[o>>2]|0;c[q>>2]=r;c[h>>2]=f;s=r;t=f;u=p}c[q>>2]=XEi(s|0)|0;s=b+28|0;q=t+4|0;if(q>>>0>u>>>0){Bid(h,s,4);v=c[s>>2]|0;w=c[h>>2]|0;x=c[m>>2]|0}else{p=c[t>>2]|0;c[s>>2]=p;c[h>>2]=q;v=p;w=q;x=u}c[s>>2]=XEi(v|0)|0;v=b+36|0;s=w+4|0;if(s>>>0>x>>>0){Bid(h,v,4);y=c[v>>2]|0;z=c[h>>2]|0;A=c[m>>2]|0}else{u=c[w>>2]|0;c[v>>2]=u;c[h>>2]=s;y=u;z=s;A=x}c[v>>2]=XEi(y|0)|0;y=b+44|0;v=z+4|0;if(v>>>0>A>>>0){Bid(h,y,4);B=y;C=c[y>>2]|0;D=c[h>>2]|0;E=c[m>>2]|0}else{F=ea(g[z>>2]);g[y>>2]=F;c[h>>2]=v;B=y;C=(g[k>>2]=F,c[k>>2]|0);D=v;E=A}c[B>>2]=XEi(C|0)|0;C=b+40|0;if((D+1|0)>>>0>E>>>0)Bid(h,C,1);else{a[C>>0]=a[D>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);D=b+56|0;C=c[h>>2]|0;E=C+4|0;B=c[m>>2]|0;if(E>>>0>B>>>0){Bid(h,D,4);G=c[D>>2]|0;H=c[h>>2]|0;I=c[m>>2]|0}else{A=c[C>>2]|0;c[D>>2]=A;c[h>>2]=E;G=A;H=E;I=B}c[D>>2]=XEi(G|0)|0;G=b+60|0;if((H+1|0)>>>0>I>>>0){Bid(h,G,1);J=c[h>>2]|0}else{a[G>>0]=a[H>>0]|0;H=(c[h>>2]|0)+1|0;c[h>>2]=H;J=H}H=b+61|0;if((J+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(h,H,1);K=c[h>>2]|0}else{a[H>>0]=a[J>>0]|0;J=(c[h>>2]|0)+1|0;c[h>>2]=J;K=J}J=b+62|0;if((K+1|0)>>>0>(c[m>>2]|0)>>>0)Bid(h,J,1);else{a[J>>0]=a[K>>0]|0;c[h>>2]=(c[h>>2]|0)+1}Mdd(d);ctd(b+64|0,d);K=b+96|0;b=c[h>>2]|0;J=b+4|0;if(J>>>0>(c[m>>2]|0)>>>0){Bid(h,K,4);L=c[K>>2]|0;M=XEi(L|0)|0;c[K>>2]=M;Mdd(d);i=e;return}else{m=c[b>>2]|0;c[K>>2]=m;c[h>>2]=J;L=m;M=XEi(L|0)|0;c[K>>2]=M;Mdd(d);i=e;return}}function uKd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;BWb(b,d);f=b+48|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){c[j>>2]=c[f>>2];c[h>>2]=k;n=k;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=b+32|0;m=n+4|0;if(m>>>0<o>>>0){c[n>>2]=c[f>>2];c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=b+28|0;o=p+4|0;if(o>>>0<q>>>0){c[p>>2]=c[f>>2];c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=b+36|0;q=r+4|0;if(q>>>0<s>>>0){c[r>>2]=c[f>>2];c[h>>2]=q;t=q;u=s}else{Gid(h,f,4);t=c[h>>2]|0;u=c[l>>2]|0}f=b+44|0;s=t+4|0;if(s>>>0<u>>>0){g[t>>2]=ea(g[f>>2]);c[h>>2]=s;v=s;w=u}else{Gid(h,f,4);v=c[h>>2]|0;w=c[l>>2]|0}f=b+40|0;if((v+1|0)>>>0<w>>>0){a[v>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);f=b+56|0;v=c[h>>2]|0;w=v+4|0;u=c[l>>2]|0;if(w>>>0<u>>>0){c[v>>2]=c[f>>2];c[h>>2]=w;x=w;y=u}else{Gid(h,f,4);x=c[h>>2]|0;y=c[l>>2]|0}f=b+60|0;if((x+1|0)>>>0<y>>>0){a[x>>0]=a[f>>0]|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;z=x}else{Gid(h,f,1);z=c[h>>2]|0}f=b+61|0;if((z+1|0)>>>0<(c[l>>2]|0)>>>0){a[z>>0]=a[f>>0]|0;z=(c[h>>2]|0)+1|0;c[h>>2]=z;A=z}else{Gid(h,f,1);A=c[h>>2]|0}f=b+62|0;if((A+1|0)>>>0<(c[l>>2]|0)>>>0){a[A>>0]=a[f>>0]|0;c[h>>2]=(c[h>>2]|0)+1}else Gid(h,f,1);Tdd(d);dtd(b+64|0,d);f=b+96|0;b=c[h>>2]|0;A=b+4|0;if(A>>>0<(c[l>>2]|0)>>>0){c[b>>2]=c[f>>2];c[h>>2]=A;Tdd(d);i=e;return}else{Gid(h,f,4);Tdd(d);i=e;return}}function vKd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[b>>2]=669992;if(a[b+64>>0]&1){g=c[b+72>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(g,e)}BOd(b+52|0);EWb(b);i=d;return}function wKd(a){a=a|0;var b=0;b=i;vKd(a);ACi(a);i=b;return}function xKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=670792;f=c[a+120>>2]|0;if(!f){vKd(a);i=b;return}g=c[f+8>>2]|0;if(g){h=f+12|0;if((c[h>>2]|0)!=(g|0))c[h>>2]=g;c[e>>2]=20;c[d+0>>2]=c[e+0>>2];eOb(g,d)}ACi(f);vKd(a);i=b;return}function yKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=670792;f=c[a+120>>2]|0;if(!f){vKd(a);ACi(a);i=b;return}g=c[f+8>>2]|0;if(g){h=f+12|0;if((c[h>>2]|0)!=(g|0))c[h>>2]=g;c[e>>2]=20;c[d+0>>2]=c[e+0>>2];eOb(g,d)}ACi(f);vKd(a);ACi(a);i=b;return}function zKd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im;d=i;c[a+200>>2]=0;e=a+0|0;f=e+92|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=a+96|0;h=b+0|0;f=e+104|0;do{c[e>>2]=c[h>>2];e=e+4|0;h=h+4|0}while((e|0)<(f|0));h=b+32|0;UEi(a|0,h|0,32)|0;UEi(a+128|0,h|0,32)|0;h=b+20|0;e=c[h>>2]|0;c[a+60>>2]=e;f=e*48|0;j=zCi(e>>>0>89478485?-1:f)|0;k=a+64|0;c[k>>2]=j;PEi(j|0,0,f|0)|0;c[a+40>>2]=3600;c[a+44>>2]=3601;c[a+48>>2]=3602;c[a+52>>2]=110;c[a+56>>2]=2733;c[a+68>>2]=2;c[a+72>>2]=252;f=e*56|0;l=zCi(e>>>0>76695844?-1:f)|0;m=a+180|0;c[m>>2]=l;a=b+84|0;b=c[a>>2]|0;YEi(l|0,b|0,f|0)|0;if(!e){i=d;return}else{n=b;o=j;p=l;q=0}while(1){r=ea(g[n+(q*56|0)+44>>2]);g[o+(q*48|0)+8>>2]=r;g[p+(q*56|0)+44>>2]=r;l=n+(q*56|0)+32|0;j=(SEi(c[l>>2]|0)|0)+1|0;b=zCi(j)|0;c[o+(q*48|0)+44>>2]=b;UEi(b|0,c[l>>2]|0,j|0)|0;UEi((c[k>>2]|0)+(q*48|0)+28|0,(c[a>>2]|0)+(q*56|0)+16|0,16)|0;j=c[a>>2]|0;r=ea(g[j+(q*56|0)+36>>2]);l=c[k>>2]|0;g[l+(q*48|0)>>2]=r;g[l+(q*48|0)+4>>2]=ea(g[j+(q*56|0)+40>>2]);UEi(l+(q*48|0)+12|0,j+(q*56|0)|0,16)|0;j=q+1|0;if(j>>>0>=(c[h>>2]|0)>>>0)break;n=c[a>>2]|0;o=c[k>>2]|0;p=c[m>>2]|0;q=j}i=d;return}function AKd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[b>>2]=0;a[b+4>>0]=0;a[b+5>>0]=1;c[b+8>>2]=0;l=b+12|0;c[l>>2]=0;if(e){c[j>>2]=c[153086];c[g+0>>2]=c[j+0>>2];j=bOb(80,g,0,16,3653512,285)|0;c[j+72>>2]=0;c[l>>2]=j;c[j>>2]=0;c[j+64>>2]=j;c[j+68>>2]=j}c[k>>2]=c[153086];c[g+0>>2]=c[k+0>>2];k=bOb(208,g,0,16,3653512,291)|0;zKd(k,d);if(k){d=k+200|0;c[d>>2]=(c[d>>2]|0)+1}d=c[b>>2]|0;if(!d){c[b>>2]=k;i=f;return}j=d+200|0;l=(c[j>>2]|0)+-1|0;c[j>>2]=l;if(l){c[b>>2]=k;i=f;return}l=d+60|0;j=c[l>>2]|0;e=d+64|0;m=c[e>>2]|0;if((j|0)>0){n=m;o=j;j=0;while(1){p=c[n+(j*48|0)+44>>2]|0;if(!p){q=o;r=n}else{BCi(p);q=c[l>>2]|0;r=c[e>>2]|0}j=j+1|0;if((j|0)>=(q|0)){s=r;break}else{n=r;o=q}}}else s=m;if(s)BCi(s);s=c[d+180>>2]|0;if(s)BCi(s);c[h>>2]=c[153086];c[g+0>>2]=c[h+0>>2];eOb(d,g);c[b>>2]=k;i=f;return}function BKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+12|0;h=c[g>>2]|0;if(h){j=h;k=c[h+68>>2]|0;while(1){if((k|0)==(j|0)){l=j;break}h=c[k+68>>2]|0;HSd(c[k+76>>2]|0)|0;j=c[g>>2]|0;k=h}k=c[153086]|0;if(l){j=l+72|0;h=c[j>>2]|0;if((h|0)!=0?(m=h+200|0,n=(c[m>>2]|0)+-1|0,c[m>>2]=n,(n|0)==0):0){n=h+60|0;m=c[n>>2]|0;o=h+64|0;p=c[o>>2]|0;if((m|0)>0){q=p;r=m;m=0;while(1){s=c[q+(m*48|0)+44>>2]|0;if(!s){t=r;u=q}else{BCi(s);t=c[n>>2]|0;u=c[o>>2]|0}m=m+1|0;if((m|0)>=(t|0)){v=u;break}else{q=u;r=t}}}else v=p;if(v)BCi(v);v=c[h+180>>2]|0;if(v)BCi(v);c[e>>2]=c[153086];c[d+0>>2]=c[e+0>>2];eOb(h,d)}c[j>>2]=0}c[f>>2]=k;c[d+0>>2]=c[f+0>>2];eOb(l,d);c[g>>2]=0}g=c[a>>2]|0;if(!g){c[a>>2]=0;i=b;return}l=g+200|0;f=(c[l>>2]|0)+-1|0;c[l>>2]=f;if(f){c[a>>2]=0;i=b;return}f=g+60|0;l=c[f>>2]|0;k=g+64|0;j=c[k>>2]|0;if((l|0)>0){h=j;v=l;l=0;while(1){p=c[h+(l*48|0)+44>>2]|0;if(!p){w=v;x=h}else{BCi(p);w=c[f>>2]|0;x=c[k>>2]|0}l=l+1|0;if((l|0)>=(w|0)){y=x;break}else{h=x;v=w}}}else y=j;if(y)BCi(y);y=c[g+180>>2]|0;if(y)BCi(y);c[e>>2]=c[153086];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[a>>2]=0;i=b;return}function CKd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[k>>2]=0;m=c[a+8>>2]|0;if(m){n=(ETd(b,m,k)|0)==0;i=f;return (n?c[k>>2]|0:0)|0}c[l>>2]=c[153086];c[g+0>>2]=c[l+0>>2];l=bOb(80,g,0,16,3653512,314)|0;n=l+72|0;m=l+0|0;o=m+80|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(o|0));c[l>>2]=64;c[l+28>>2]=d;d=c[a>>2]|0;if(d){m=d+200|0;c[m>>2]=(c[m>>2]|0)+1}c[n>>2]=d;c[l+24>>2]=e;c[l+36>>2]=671664;e=c[a>>2]|0;if(!(0==0?(c[e+120>>2]&1|0)==0:0)){d=l+32|0;c[d>>2]=c[d>>2]|8}d=c[a+12>>2]|0;if(!d){c[l+64>>2]=l;c[l+68>>2]=l}else{a=d+64|0;c[l+64>>2]=c[a>>2];c[l+68>>2]=d;c[(c[a>>2]|0)+68>>2]=l;c[a>>2]=l}c[e+88>>2]=l;a=l+76|0;do if(DTd(b,e,a)|0){d=c[153086]|0;if(!l){p=d;q=j}else{r=j;s=d;t=13}}else{d=c[a>>2]|0;if(!d){r=j;s=c[153086]|0;t=13;break}c[k>>2]=d;u=d;i=f;return u|0}while(0);if((t|0)==13){t=c[n>>2]|0;if((t|0)!=0?(k=t+200|0,a=(c[k>>2]|0)+-1|0,c[k>>2]=a,(a|0)==0):0){a=t+60|0;k=c[a>>2]|0;e=t+64|0;b=c[e>>2]|0;if((k|0)>0){d=b;m=k;k=0;while(1){o=c[d+(k*48|0)+44>>2]|0;if(!o){v=m;w=d}else{BCi(o);v=c[a>>2]|0;w=c[e>>2]|0}k=k+1|0;if((k|0)>=(v|0)){x=w;break}else{d=w;m=v}}}else x=b;if(x)BCi(x);x=c[t+180>>2]|0;if(x)BCi(x);c[h>>2]=c[153086];c[g+0>>2]=c[h+0>>2];eOb(t,g)}c[n>>2]=0;p=s;q=r}c[j>>2]=p;c[g+0>>2]=c[j+0>>2];eOb(l,g);u=0;i=f;return u|0}function DKd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!(a[671712]|0)){c[167920]=0;c[167924]=0;c[167926]=0;c[167922]=60;a[671712]=1}g=c[167926]|0;do if(!(g&2147483647))if((g|0)>-1){c[167926]=1024;h=c[167920]|0;c[f>>2]=c[167922];c[e+0>>2]=c[f+0>>2];c[167920]=hOb(h,4096,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[167922];c[e+0>>2]=c[f+0>>2];h=cOb(4096,4,e,0,3653512,352)|0;YEi(h|0,c[167920]|0,c[167924]<<2|0)|0;c[167926]=1024;c[167920]=h;break}while(0);g=c[167924]|0;if(g){h=c[167920]|0;j=0;do{k=c[h+(j<<2)>>2]|0;a[k+5>>0]=(c[k+8>>2]|0)!=0&1;j=j+1|0}while(j>>>0<g>>>0);if(g){j=g;g=0;while(1){h=c[(c[167920]|0)+(g<<2)>>2]|0;if(!(a[h+5>>0]|0)){k=c[153086]|0;if(h)BKd(h);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(h,e);c[(c[167920]|0)+(g<<2)>>2]=0;h=(c[167924]|0)+-1|0;k=c[167920]|0;c[k+(g<<2)>>2]=c[k+(h<<2)>>2];c[167924]=h;l=h;m=g+-1|0}else{l=j;m=g}g=m+1|0;if(g>>>0>=l>>>0){n=l;break}else j=l}}else n=0}else n=0;if(!b){o=n;p=(o|0)==0;q=c[167920]|0;r=p?0:q;i=d;return r|0}c[b>>2]=n;o=c[167924]|0;p=(o|0)==0;q=c[167920]|0;r=p?0:q;i=d;return r|0}function EKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=WSd(c[a>>2]|0,d)|0;if(e){f=e;i=b;return f|0}e=c[d>>2]|0;if(!e){f=36;i=b;return f|0}g=c[e+72>>2]|0;h=c[e+36>>2]|0;j=e+32|0;c[j>>2]=c[h+8>>2]&3|c[j>>2]&-4;j=h;k=c[j+4>>2]|0;l=e+8|0;c[l>>2]=c[j>>2];c[l+4>>2]=k;c[e+4>>2]=c[h+12>>2];h=c[g+160>>2]|0;if(!h){m=e;n=0}else{g=(mo[h&4095](e)|0)==0;m=c[d>>2]|0;n=g?0:80}c[a+4>>2]=m;f=n;i=b;return f|0}function FKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[g>>2]=0;h=c[a>>2]|0;a=WSd(h,g)|0;if(a){j=a;i=b;return j|0}a=c[g>>2]|0;if(!a){j=36;i=b;return j|0}k=c[a+72>>2]|0;VSd(h,0)|0;h=c[k+164>>2]|0;if(!h)l=0;else{k=(mo[h&4095](c[g>>2]|0)|0)==0;l=k?0:80}k=c[g>>2]|0;c[(c[k+64>>2]|0)+68>>2]=c[k+68>>2];k=c[g>>2]|0;c[(c[k+68>>2]|0)+64>>2]=c[k+64>>2];k=c[g>>2]|0;h=c[153086]|0;if(k){a=k+72|0;m=c[a>>2]|0;if((m|0)!=0?(n=m+200|0,o=(c[n>>2]|0)+-1|0,c[n>>2]=o,(o|0)==0):0){o=m+60|0;n=c[o>>2]|0;p=m+64|0;q=c[p>>2]|0;if((n|0)>0){r=q;s=n;n=0;while(1){t=c[r+(n*48|0)+44>>2]|0;if(!t){u=s;v=r}else{BCi(t);u=c[o>>2]|0;v=c[p>>2]|0}n=n+1|0;if((n|0)>=(u|0)){w=v;break}else{r=v;s=u}}}else w=q;if(w)BCi(w);w=c[m+180>>2]|0;if(w)BCi(w);c[e>>2]=c[153086];c[d+0>>2]=c[e+0>>2];eOb(m,d)}c[a>>2]=0}c[f>>2]=h;c[d+0>>2]=c[f+0>>2];eOb(k,d);c[g>>2]=0;j=l;i=b;return j|0}function GKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=WSd(c[a>>2]|0,d)|0;if(!e){a=c[d>>2]|0;if(a){d=c[(c[a+72>>2]|0)+168>>2]|0;if(!d)f=0;else{g=(mo[d&4095](a)|0)==0;f=g?0:80}}else f=36}else f=e;i=b;return f|0}function HKd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+16|0;j=h;c[j>>2]=0;k=WSd(c[a>>2]|0,j)|0;if(k){l=k;i=h;return l|0}k=c[j>>2]|0;if(!k){l=36;i=h;return l|0}a=c[k+72>>2]|0;m=c[k+36>>2]|0;n=k+32|0;o=c[n>>2]|0;c[n>>2]=c[m+8>>2]&3|o&-4;n=m;p=c[n>>2]|0;q=c[n+4>>2]|0;n=k+8|0;c[n>>2]=p;c[n+4>>2]=q;c[k+4>>2]=c[m+12>>2];m=c[k+24>>2]|0;if(!((m|0)==0|(o&8|0)==0)){o=k+16|0;k=ZEi(p|0,q|0,c[o>>2]|0,c[o+4>>2]|0)|0;if((k|0)==(e|0)&(H|0)==0)r=1;else{PEi(m|0,0,da(e<<2,f)|0)|0;r=0}}else r=0;m=c[a+172>>2]|0;if(!m)s=0;else{a=(Km[m&127](c[j>>2]|0,b,d,e,f,g)|0)==0;s=a?0:80}a=c[j>>2]|0;j=a+8|0;g=c[j+4>>2]|0;d=a+16|0;c[d>>2]=c[j>>2];c[d+4>>2]=g;if(!r){l=s;i=h;return l|0}PEi(c[a+24>>2]|0,0,da(e<<2,f)|0)|0;l=s;i=h;return l|0}function IKd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[e>>2]=0;f=WSd(c[a>>2]|0,e)|0;if(!f){a=c[e>>2]|0;if(a){e=c[(c[a+72>>2]|0)+176>>2]|0;if(!e)g=0;else{h=(_n[e&4095](a,b)|0)==0;g=h?0:80}}else g=36}else g=f;i=d;return g|0}function JKd(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;c[f>>2]=0;g=WSd(c[a>>2]|0,f)|0;if(!g){a=c[f>>2]|0;if(a){f=c[(c[a+72>>2]|0)+184>>2]|0;if(!f)h=0;else{j=(Ao[f&3](a,b,d)|0)==0;h=j?0:80}}else h=36}else h=g;i=e;return h|0}function KKd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;c[g>>2]=0;h=WSd(c[a>>2]|0,g)|0;if(h){j=h;i=f;return j|0}h=c[g>>2]|0;if(!h){j=36;i=f;return j|0}g=c[(c[h+72>>2]|0)+188>>2]|0;if(!g){j=0;i=f;return j|0}a=(kn[g&511](h,b,d,e)|0)==0;j=a?0:80;i=f;return j|0}function LKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=c[a+24>>2]|0;if(!d){i=b;return}a=d+32|0;e=c[a>>2]|0;if((e|0)<=0){i=b;return}f=d+24|0;d=e;e=0;while(1){g=c[(c[f>>2]|0)+(e<<3)+4>>2]|0;h=(da(c[137788]|0,(c[g+8>>2]|0)>>>21)|0)+181|0;j=h>>5;if((g|0)==0?1:(1<<h-(j<<5)&c[(c[137786]|0)+(j<<2)>>2]|0)==0)k=d;else{YMd(g);k=c[a>>2]|0}e=e+1|0;if((e|0)>=(k|0))break;else d=k}i=b;return}function MKd(a){a=a|0;var b=0;b=i;OLd(aMd()|0,a);i=b;return}function NKd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=a+32|0;rGc(d,BTb(c[a+24>>2]|0)|0);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];NLd(aMd()|0,a);OKd(a);i=b;return}function OKd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+4|0;h=c[b+24>>2]|0;j=h+32|0;if((c[j>>2]|0)<=0){i=d;return}k=h+24|0;h=g+1|0;l=g+8|0;m=b+4|0;n=0;do{o=c[(c[k>>2]|0)+(n<<3)+4>>2]|0;if((((o|0)!=0?(p=(da(c[137788]|0,(c[o+8>>2]|0)>>>21)|0)+181|0,q=p>>5,(1<<p-(q<<5)&c[(c[137786]|0)+(q<<2)>>2]|0)!=0):0)?(a[(NOc()|0)+94>>0]|0)!=0:0)?(q=ZMd(o)|0,(q|0)!=0):0){r=q;s=10}else s=7;if((((s|0)==7?(s=0,q=c[(c[k>>2]|0)+(n<<3)+4>>2]|0,(q|0)!=0):0)?(o=(da(c[137788]|0,(c[q+8>>2]|0)>>>21)|0)+114|0,p=o>>5,(1<<o-(p<<5)&c[(c[137786]|0)+(p<<2)>>2]|0)!=0):0)?(p=p9c(q)|0,(p|0)!=0):0){r=p;s=10}a:do if((s|0)==10){s=0;c[f>>2]=0;WSd(r,f)|0;p=c[f>>2]|0;do if(p)if(!(c[p+16>>2]|0)){c[p+20>>2]=b;break}else{Lsd(g,676984,e);Krd((a[g>>0]&1)==0?h:c[l>>2]|0,0,3653512,139,512,c[m>>2]|0,0,0);xri(g);break a}while(0);nKd(LSd(r)|0,671864,146,677712)|0;nKd(ESd(c[(aMd()|0)+100>>2]|0,r,0)|0,671864,147,671928)|0}while(0);n=n+1|0}while((n|0)<(c[j>>2]|0));i=d;return}function PKd(a,b){a=a|0;b=b|0;var c=0;c=i;okc(a,b);i=c;return}function QKd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im;b=i;i=i+96|0;d=b+12|0;e=b+48|0;f=b+24|0;h=b+60|0;j=b+84|0;k=b;l=b+36|0;m=b+72|0;n=BTb(c[a+24>>2]|0)|0;rGc(d,n);o=a+32|0;p=ea(g[d>>2]);q=ea(p-ea(g[o>>2]));p=ea(g[d+4>>2]);r=ea(p-ea(g[a+36>>2]));p=ea(g[d+8>>2]);s=ea(p-ea(g[a+40>>2]));p=ea(g[(jLc()|0)+116>>2]);t=ea(r*p);r=ea(s*p);g[e>>2]=ea(q*p);g[e+4>>2]=t;g[e+8>>2]=r;a=aMd()|0;g[j>>2]=ea(0.0);g[j+4>>2]=ea(1.0);g[j+8>>2]=ea(0.0);TGc(h,n,j);r=ea(g[h>>2]);t=ea(r*r);r=ea(g[h+4>>2]);p=ea(t+ea(r*r));r=ea(g[h+8>>2]);t=ea(T(ea(p+ea(r*r))));r=ea(g[150276]);if(t>r){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];g[f>>2]=ea(ea(g[f>>2])/t);h=f+4|0;g[h>>2]=ea(ea(g[h>>2])/t);h=f+8|0;g[h>>2]=ea(ea(g[h>>2])/t)}else{c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286]}g[m>>2]=ea(0.0);g[m+4>>2]=ea(0.0);g[m+8>>2]=ea(1.0);TGc(l,n,m);t=ea(g[l>>2]);p=ea(t*t);t=ea(g[l+4>>2]);q=ea(p+ea(t*t));t=ea(g[l+8>>2]);p=ea(T(ea(q+ea(t*t))));if(p>r){c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];g[k>>2]=ea(ea(g[k>>2])/p);l=k+4|0;g[l>>2]=ea(ea(g[l>>2])/p);l=k+8|0;g[l>>2]=ea(ea(g[l>>2])/p);BLd(a,d,e,f,k);c[o+0>>2]=c[d+0>>2];c[o+4>>2]=c[d+4>>2];c[o+8>>2]=c[d+8>>2];i=b;return}else{c[k+0>>2]=c[150284];c[k+4>>2]=c[150285];c[k+8>>2]=c[150286];BLd(a,d,e,f,k);c[o+0>>2]=c[d+0>>2];c[o+4>>2]=c[d+4>>2];c[o+8>>2]=c[d+8>>2];i=b;return}}function RKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+44|0;e=c[d>>2]|0;if(!e){f=aMd()|0;g=CLd(f,c[a+24>>2]|0)|0;c[d>>2]=g;h=g}else h=e;if((h|0)!=2){i=b;return}QKd(a);i=b;return}function SKd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+44|0;e=c[d>>2]|0;if(!e){f=aMd()|0;g=CLd(f,c[a+24>>2]|0)|0;c[d>>2]=g;h=g}else h=e;if((h|0)!=1){i=b;return}QKd(a);i=b;return}function TKd(){var a=0;a=i;QTb(81,554872,1835,0);i=a;return}function UKd(){return}function VKd(){var a=0;a=i;QQb(81,193,194,0,195);i=a;return}function WKd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(180)|0))oJd();rri(b,672e3,13);wQb(81,180,b,64,2734,0,0);xri(b);i=a;return}function XKd(a){a=a|0;return 81}function YKd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,672e3,a,0);Hkc(a,b);bdd(b);i=c;return}function ZKd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,672e3,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else Ikc(a,b);sdd(b);i=d;return}function _Kd(a,b){a=a|0;b=b|0;var c=0;c=i;Jkc(a,b);i=c;return}function $Kd(a,b){a=a|0;b=b|0;var c=0;c=i;Kkc(a,b);i=c;return}function aLd(a,b){a=a|0;b=b|0;var c=0;c=i;Lkc(a,b);i=c;return}function bLd(a,b){a=a|0;b=b|0;var c=0;c=i;Mkc(a,b);i=c;return}function cLd(a,b,c){a=a|0;b=b|0;c=c|0;c=i;OKd(a);i=c;return}function dLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];g=bOb(64,e,1,16,3653512,16)|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];qJd(g,e,b);c[g>>2]=671728;b=g+32|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[g+60>>2]=g;i=d;return g|0}function eLd(a){a=a|0;var b=0;b=i;c[a>>2]=671728;sJd(a);i=b;return}function fLd(a){a=a|0;var b=0;b=i;c[a>>2]=671728;sJd(a);ACi(a);i=b;return}function gLd(a){a=a|0;return a+40|0}function hLd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;e=f;g=f+16|0;h=f+4|0;if(d){j=0;i=f;return j|0}d=jTd(b,g)|0;if(!((d|0)==0&(c[g>>2]|0)!=0)){j=d;i=f;return j|0}d=lTd(b,0)|0;do switch(d|0){case 7:{k=685144;break}case 4:{k=685e3;break}case 6:{k=685104;break}case 3:{k=684952;break}case 90:{k=686920;break}case 86:{k=686600;break}case 27:{k=687552;break}case 28:{k=687624;break}case 18:{k=686072;break}case 33:{k=687872;break}case 34:{k=687936;break}case 89:{k=687008;break}case 14:{k=685568;break}case 66:{k=690728;break}case 67:{k=690792;break}case 68:{k=690888;break}case 69:{k=691008;break}case 87:{k=686704;break}case 60:{k=690296;break}case 61:{k=690336;break}case 62:{k=690440;break}case 19:{k=687096;break}case 20:{k=687120;break}case 15:{k=685712;break}case 84:{k=686472;break}case 57:{k=689936;break}case 58:{k=690072;break}case 59:{k=690192;break}case 35:{k=688040;break}case 36:{k=688096;break}case 70:{k=691120;break}case 71:{k=691184;break}case 75:{k=691328;break}case 72:{k=691616;break}case 73:{k=691768;break}case 74:{k=691888;break}case 76:{k=692024;break}case 77:{k=692088;break}case 17:{k=685880;break}case 85:{k=686528;break}case 93:{k=688864;break}case 46:{k=688944;break}case 47:{k=689024;break}case 8:{k=685176;break}case 5:{k=685064;break}case 12:{k=685360;break}case 11:{k=685296;break}case 37:{k=688136;break}case 38:{k=688192;break}case 13:{k=685512;break}case 83:{k=686312;break}case 92:{k=686176;break}case 10:{k=685256;break}case 21:{k=687232;break}case 22:{k=687272;break}case 91:{k=686424;break}case 51:{k=689472;break}case 52:{k=689568;break}case 53:{k=689616;break}case 29:{k=687696;break}case 30:{k=687728;break}case 45:{k=688696;break}case 95:{k=688752;break}case 94:{k=688816;break}case 88:{k=686872;break}case 2:{k=684816;break}case 39:{k=688248;break}case 40:{k=688336;break}case 23:{k=687368;break}case 24:{k=687392;break}case 63:{k=690536;break}case 64:{k=690592;break}case 65:{k=690664;break}case 48:{k=689104;break}case 49:{k=689232;break}case 50:{k=689424;break}case 25:{k=687424;break}case 26:{k=687464;break}case 82:{k=692560;break}case 1:{k=684752;break}case 78:{k=692240;break}case 79:{k=692320;break}case 80:{k=692400;break}case 81:{k=692512;break}case 31:{k=687760;break}case 32:{k=687824;break}case 54:{k=689688;break}case 55:{k=689776;break}case 56:{k=689896;break}case 43:{k=688528;break}case 44:{k=688568;break}case 9:{k=685224;break}case 16:{k=685816;break}case 41:{k=688392;break}case 42:{k=688456;break}case 0:{j=0;i=f;return j|0}default:k=692640}while(0);c[e>>2]=k;Lsd(h,672016,e);if(!(a[h>>0]&1))l=h+1|0;else l=c[h+8>>2]|0;Krd(l,0,3653512,26,1,0,0,0);xri(h);j=d;i=f;return j|0}function iLd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b&65535;if((g|0)==4)h=612368;else if((g|0)==8)h=612376;else if((g|0)==2|(g|0)==1)h=612360;else h=612352;c[f>>2]=c[h>>2];c[e+0>>2]=c[f+0>>2];f=cOb(a,16,e,0,3653512,171)|0;i=d;return f|0}function jLd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=d&65535;if((h|0)==2|(h|0)==1)j=612360;else if((h|0)==4)j=612368;else if((h|0)==8)j=612376;else j=612352;c[g>>2]=c[j>>2];c[f+0>>2]=c[g+0>>2];g=hOb(a,b,16,f,0,3653512,225)|0;i=e;return g|0}function kLd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b&65535;if((g|0)==4)h=612368;else if((g|0)==8)h=612376;else if((g|0)==2|(g|0)==1)h=612360;else h=612352;c[f>>2]=c[h>>2];c[e+0>>2]=c[f+0>>2];eOb(a,e);i=d;return}function lLd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+1104|0;d=g+1088|0;h=g+1084|0;j=g+1080|0;k=g+24|0;l=g+12|0;m=g;c[j>>2]=c[153086];c[d+0>>2]=c[j+0>>2];j=bOb(1064,d,0,16,3653512,270)|0;uod(j);if(!j){n=43;i=g;return n|0}rri(m,b,SEi(b|0)|0);sqd(l,m);if(!(a[l>>0]&1))o=l+1|0;else o=c[l+8>>2]|0;god(k,o);xri(l);xri(m);if(mod(j,k,0,0)|0){if(e){m=lod(k)|0;c[e>>2]=m}if(!f)p=0;else{c[f>>2]=j;p=0}}else{f=c[153086]|0;ko[c[c[j>>2]>>2]&4095](j);c[h>>2]=f;c[d+0>>2]=c[h+0>>2];eOb(j,d);p=23}Bod(k);n=p;i=g;return n|0}function mLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;if(!a){f=c[153086]|0;g=e;h=19}else{j=qod(a)|0;k=c[153086]|0;ko[c[c[a>>2]>>2]&4095](a);f=k;g=e;h=j?0:19}c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return h|0}function nLd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;f=i;i=i+16|0;g=f;if(!a){h=33;i=f;return h|0}j=g;c[j>>2]=0;c[j+4>>2]=0;if(!(ood(a,d,0,b,g)|0)){h=19;i=f;return h|0}b=g;g=c[b>>2]|0;a=c[b+4>>2]|0;if(e)c[e>>2]=g;h=a>>>0<0|(a|0)==0&g>>>0<d>>>0?22:0;i=f;return h|0}function oLd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!a)d=33;else{e=zod(a,b,0,1)|0;d=e?0:19}i=c;return d|0}function pLd(a,b){a=ea(a);b=ea(b);var c=0,d=Im,e=Im;c=i;if(b<=ea(0.0)){d=ea(1.0);i=c;return ea(d)}e=ea(ea(1.0)/b);d=ea(ea(1.0)-ea(SDi(ea(e*ea(bEi(ea(ea(1.0)-a)))))));i=c;return ea(d)}function qLd(){return}function rLd(){return}function sLd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+84|0;e=a+88|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{f=g+4|0;h=g;g=c[f>>2]|0;c[h>>2]=0;c[f>>2]=0}while((g|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;d=a+40|0;e=a+44|0;g=c[e>>2]|0;if((g|0)!=(d|0)){f=g;do{g=f+4|0;h=f;f=c[g>>2]|0;c[h>>2]=0;c[g>>2]=0}while((f|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;d=a+48|0;e=a+52|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{f=g+4|0;h=g;g=c[f>>2]|0;c[h>>2]=0;c[f>>2]=0}while((g|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;d=a+56|0;e=a+60|0;g=c[e>>2]|0;if((g|0)!=(d|0)){f=g;do{g=f+4|0;h=f;f=c[g>>2]|0;c[h>>2]=0;c[g>>2]=0}while((f|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;d=a+64|0;e=a+68|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{f=g+4|0;h=g;g=c[f>>2]|0;c[h>>2]=0;c[f>>2]=0}while((g|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;d=a+72|0;e=a+76|0;g=c[e>>2]|0;if((g|0)!=(d|0)){f=g;do{g=f+4|0;h=f;f=c[g>>2]|0;c[h>>2]=0;c[g>>2]=0}while((f|0)!=(d|0))}c[e>>2]=d;c[d>>2]=d;tLd(a);d=a+92|0;hTd(c[d>>2]|0)|0;c[d>>2]=0;d=a+208|0;e=c[d>>2]|0;if(!e){fSb(a);i=b;return}ACi(e);c[d>>2]=0;fSb(a);i=b;return}function tLd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+128|0;e=d;f=d+20|0;g=d+48|0;h=d+36|0;j=d+60|0;k=d+16|0;l=d+24|0;m=d+72|0;n=d+84|0;o=d+96|0;p=d+108|0;q=b+92|0;if(!(c[q>>2]|0)){i=d;return}c[j>>2]=0;r=j+4|0;c[r>>2]=0;c[j+8>>2]=0;CQb(114,j,0)|0;s=c[j>>2]|0;if((s|0)!=(c[r>>2]|0)){t=g+1|0;u=g+8|0;v=h+1|0;w=h+8|0;x=s;do{s=q9c(c[x>>2]|0)|0;do if(s){c[k>>2]=0;y=WSd(s,k)|0;if(y){z=bMd(y)|0;c[e>>2]=672784;c[e+4>>2]=1035;c[e+8>>2]=673448;c[e+12>>2]=z;Lsd(h,692656,e);Krd((a[h>>0]&1)==0?v:c[w>>2]|0,0,3653512,16,1,0,0,0);xri(h);break}z=SSd(s,(c[k>>2]|0)+13|0)|0;if(z){y=bMd(z)|0;c[e>>2]=672784;c[e+4>>2]=1037;c[e+8>>2]=673952;c[e+12>>2]=y;Lsd(g,692656,e);Krd((a[g>>0]&1)==0?t:c[u>>2]|0,0,3653512,16,1,0,0,0);xri(g)}}while(0);x=x+4|0}while((x|0)!=(c[r>>2]|0))}c[l>>2]=0;x=l+4|0;c[x>>2]=0;c[l+8>>2]=0;CQb(82,l,0)|0;g=c[l>>2]|0;if((g|0)!=(c[x>>2]|0)){u=g;do{LMd(c[u>>2]|0);u=u+4|0}while((u|0)!=(c[x>>2]|0))}c[m>>2]=0;u=m+4|0;c[u>>2]=0;c[m+8>>2]=0;CQb(81,m,0)|0;g=c[m>>2]|0;if((g|0)!=(c[u>>2]|0)){t=g;do{LKd(c[t>>2]|0);t=t+4|0}while((t|0)!=(c[u>>2]|0))}c[n>>2]=0;t=n+4|0;c[t>>2]=0;c[n+8>>2]=0;CQb(167,n,0)|0;g=c[n>>2]|0;if((g|0)!=(c[t>>2]|0)){k=g;do{lMd(c[k>>2]|0);k=k+4|0}while((k|0)!=(c[t>>2]|0))}c[o>>2]=0;k=o+4|0;c[k>>2]=0;c[o+8>>2]=0;CQb(240,o,0)|0;g=c[o>>2]|0;if((g|0)!=(c[k>>2]|0)){h=g;do{jNd(c[h>>2]|0);h=h+4|0}while((h|0)!=(c[k>>2]|0))}h=b+100|0;g=c[h>>2]|0;if(g){uSd(g)|0;c[h>>2]=0}h=b+108|0;g=c[h>>2]|0;if(g){uSd(g)|0;c[h>>2]=0}h=b+104|0;g=c[h>>2]|0;if(g){uSd(g)|0;c[h>>2]=0}h=b+112|0;g=c[h>>2]|0;if(g){uSd(g)|0;c[h>>2]=0}c[b+96>>2]=0;c[p>>2]=0;h=p+4|0;c[h>>2]=0;c[p+8>>2]=0;CQb(83,p,0)|0;g=c[p>>2]|0;if((g|0)!=(c[h>>2]|0)){w=g;do{WJd(c[w>>2]|0);w=w+4|0}while((w|0)!=(c[h>>2]|0))}w=b+200|0;b=c[w>>2]|0;if(b){g=c[153086]|0;GOd(b);c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(b,e);c[w>>2]=0}wTd(c[q>>2]|0)|0;q=c[p>>2]|0;if(q){p=c[h>>2]|0;if((p|0)!=(q|0))c[h>>2]=p+(~((p+-4-q|0)>>>2)<<2);ACi(q)}q=c[o>>2]|0;if(q){o=c[k>>2]|0;if((o|0)!=(q|0))c[k>>2]=o+(~((o+-4-q|0)>>>2)<<2);ACi(q)}q=c[n>>2]|0;if(q){n=c[t>>2]|0;if((n|0)!=(q|0))c[t>>2]=n+(~((n+-4-q|0)>>>2)<<2);ACi(q)}q=c[m>>2]|0;if(q){m=c[u>>2]|0;if((m|0)!=(q|0))c[u>>2]=m+(~((m+-4-q|0)>>>2)<<2);ACi(q)}q=c[l>>2]|0;if(q){l=c[x>>2]|0;if((l|0)!=(q|0))c[x>>2]=l+(~((l+-4-q|0)>>>2)<<2);ACi(q)}q=c[j>>2]|0;if(!q){i=d;return}j=c[r>>2]|0;if((j|0)!=(q|0))c[r>>2]=j+(~((j+-4-q|0)>>>2)<<2);ACi(q);i=d;return}function uLd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+12|0;h=f;if(!d){j=1;i=f;return j|0}k=b+164|0;zri(k,bMd(d)|0)|0;c[b+176>>2]=d;rri(h,e,SEi(e|0)|0);c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=a[h>>0]|0;d=(e&1)==0;if(d)l=(e&255)>>>1;else l=c[h+4>>2]|0;e=a[k>>0]|0;if(!(e&1))m=(e&255)>>>1;else m=c[b+168>>2]|0;if(d)n=h+1|0;else n=c[h+8>>2]|0;Pri(g,n,l,m+l|0);if(!(a[k>>0]&1))o=k+1|0;else o=c[b+172>>2]|0;Gri(g,o,m)|0;if(!(a[g>>0]&1))p=g+1|0;else p=c[g+8>>2]|0;Krd(p,0,3653512,472,1,0,0,0);xri(g);xri(h);j=0;i=f;return j|0}function vLd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+192|0;e=d+104|0;f=d+144|0;g=d+156|0;h=d+132|0;j=d+120|0;k=d+128|0;l=d+124|0;m=d;n=d+168|0;o=d+184|0;rri(h,672576,14);wrd(g,h);xri(h);h=a[g>>0]|0;p=(h&1)==0;if(p)q=(h&255)>>>1;else q=c[g+4>>2]|0;if(q){if(p)r=g+1|0;else r=c[g+8>>2]|0;wEi(r)|0}r=b+92|0;do if(!(c[r>>2]|0))if(uLd(b,qPd(r)|0,672592)|0){sTd(c[r>>2]|0,204,2735,205,1738,0,0,-1)|0;break}else{s=0;xri(g);i=d;return s|0}while(0);if(!(wLd(b)|0)){s=0;xri(g);i=d;return s|0}if(!(uLd(b,BTd(c[r>>2]|0,64e3,8)|0,672592)|0)){s=0;xri(g);i=d;return s|0}if(!(uLd(b,uTd(c[r>>2]|0,253)|0,672624)|0)){s=0;xri(g);i=d;return s|0}if(!(uLd(b,ATd(c[r>>2]|0,7)|0,672672)|0)){s=0;xri(g);i=d;return s|0}p=b+96|0;if(!(uLd(b,JTd(c[r>>2]|0,p)|0,672720)|0)){s=0;xri(g);i=d;return s|0}c[j>>2]=0;pTd(c[r>>2]|0,j,0,0,0,0,0)|0;c[167919]=c[j>>2];KTd(c[r>>2]|0,l,k)|0;j=c[l>>2]|0;l=671664;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=m+0|0;l=j+104|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(l|0));j=m+32|0;k=672768|0;l=j+10|0;do{a[j>>0]=a[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));c[m>>2]=104;c[m+4>>2]=56;c[m+76>>2]=111;AKd(n,m,0);m=CKd(n,c[r>>2]|0,671664,0)|0;k=ESd(c[p>>2]|0,m,0)|0;if(k){m=bMd(k)|0;c[e>>2]=672784;c[e+4>>2]=616;c[e+8>>2]=672848;c[e+12>>2]=m;Lsd(f,692656,e);if(!(a[f>>0]&1))t=f+1|0;else t=c[f+8>>2]|0;Krd(t,0,3653512,16,1,0,0,0);xri(f)}f=b+100|0;if(((((((uLd(b,FTd(c[r>>2]|0,672904,f)|0,672720)|0?(t=b+104|0,uLd(b,FTd(c[r>>2]|0,672920,t)|0,672720)|0):0)?(m=b+108|0,uLd(b,FTd(c[r>>2]|0,672936,m)|0,672720)|0):0)?(k=b+112|0,uLd(b,FTd(c[r>>2]|0,672952,k)|0,672720)|0):0)?uLd(b,zSd(c[p>>2]|0,c[f>>2]|0)|0,672720)|0:0)?uLd(b,zSd(c[f>>2]|0,c[t>>2]|0)|0,672720)|0:0)?uLd(b,zSd(c[p>>2]|0,c[m>>2]|0)|0,672720)|0:0)?uLd(b,zSd(c[m>>2]|0,c[k>>2]|0)|0,672720)|0:0){xLd(b);c[b+148>>2]=c[b+128>>2];c[b+152>>2]=c[b+132>>2];c[b+144>>2]=c[b+124>>2];c[b+156>>2]=c[b+136>>2];c[b+160>>2]=c[b+140>>2];c[o>>2]=c[153086];c[e+0>>2]=c[o+0>>2];o=bOb(56,e,0,16,3653512,660)|0;EOd(o);c[b+200>>2]=o;u=1}else u=0;BKd(n);s=u;xri(g);i=d;return s|0}function wLd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+28|0;h=d+16|0;j=d+32|0;k=d+4|0;l=d+12|0;m=d+44|0;n=b+92|0;if(!(uLd(b,jTd(c[n>>2]|0,f)|0,673608)|0)){o=0;i=d;return o|0}if((c[f>>2]|0)==0?!(uLd(b,iTd(c[n>>2]|0,2)|0,673656)|0):0){o=0;i=d;return o|0}mTd(c[n>>2]|0,g)|0;f=b+120|0;if(!(uLd(b,kTd(c[n>>2]|0,c[g>>2]|0,b+116|0,0,f)|0,673704)|0)){o=0;i=d;return o|0}g=b+148|0;c[g>>2]=c[b+128>>2];p=b+132|0;c[b+152>>2]=c[p>>2];q=c[b+124>>2]|0;r=b+144|0;c[r>>2]=q;s=b+136|0;c[b+156>>2]=c[s>>2];t=b+140|0;c[b+160>>2]=c[t>>2];u=c[f>>2]|0;if(!((u|0)>=(q|0)|(q|0)==7))c[r>>2]=u;rri(h,673752,12);u=srd(h)|0;xri(h);h=u?32:0;if(!(tTd(c[n>>2]|0,c[r>>2]|0)|0))v=0;else{Lsd(j,673768,e);if(!(a[j>>0]&1))w=j+1|0;else w=c[j+8>>2]|0;Krd(w,0,3653512,968,512,0,0,0);xri(j);v=tTd(c[n>>2]|0,2)|0}if(!(uLd(b,v,673872)|0)){o=0;i=d;return o|0}v=c[p>>2]|0;if((v|0)!=0?!(uLd(b,qTd(c[n>>2]|0,v,4)|0,673912)|0):0){o=0;i=d;return o|0}if(!(uLd(b,pTd(c[n>>2]|0,k,l,0,0,m,0)|0,673704)|0)){o=0;i=d;return o|0}v=c[g>>2]|0;g=oTd(c[n>>2]|0,(v|0)==0?c[k>>2]|0:v,c[l>>2]|0,0,8,c[m>>2]|0)|0;if((g|0)==37)x=oTd(c[n>>2]|0,c[k>>2]|0,c[l>>2]|0,0,8,c[m>>2]|0)|0;else x=g;if(!(uLd(b,x,673704)|0)){o=0;i=d;return o|0}nTd(c[n>>2]|0,c[t>>2]|0)|0;t=vTd(c[n>>2]|0,c[s>>2]|0,h,0)|0;if((t|0)==51){y=0;z=vTd(c[n>>2]|0,c[s>>2]|0,0,0)|0}else{y=h;z=t}if(!(uLd(b,z,672592)|0)){o=0;i=d;return o|0}a[b+37>>0]=y>>>5;o=1;i=d;return o|0}function xLd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+144|0;e=d;f=d+20|0;g=d+48|0;h=d+36|0;j=d+64|0;k=d+16|0;l=d+32|0;m=d+72|0;n=d+60|0;o=d+68|0;xTd(c[b+92>>2]|0)|0;c[j>>2]=0;p=DSd(c[b+96>>2]|0,j)|0;if(p){b=bMd(p)|0;c[e>>2]=672784;c[e+4>>2]=673;c[e+8>>2]=672968;c[e+12>>2]=b;Lsd(f,692656,e);if(!(a[f>>0]&1))q=f+1|0;else q=c[f+8>>2]|0;Krd(q,0,3653512,16,1,0,0,0);xri(f)}q=c[j>>2]|0;if(!q){i=d;return}c[k>>2]=0;b=OSd(q,0,k,0)|0;if(b){q=bMd(b)|0;c[e>>2]=672784;c[e+4>>2]=678;c[e+8>>2]=673024;c[e+12>>2]=q;Lsd(f,692656,e);if(!(a[f>>0]&1))r=f+1|0;else r=c[f+8>>2]|0;Krd(r,0,3653512,16,1,0,0,0);xri(f)}if(!(c[k>>2]|0)){i=d;return}c[l>>2]=0;r=NSd(c[j>>2]|0,0,l,0)|0;if(r){j=bMd(r)|0;c[e>>2]=672784;c[e+4>>2]=683;c[e+8>>2]=673072;c[e+12>>2]=j;Lsd(f,692656,e);if(!(a[f>>0]&1))s=f+1|0;else s=c[f+8>>2]|0;Krd(s,0,3653512,16,1,0,0,0);xri(f)}s=c[l>>2]|0;if(!s){i=d;return}j=NSd(s,0,l,0)|0;if(j){s=bMd(j)|0;c[e>>2]=672784;c[e+4>>2]=686;c[e+8>>2]=673120;c[e+12>>2]=s;Lsd(f,692656,e);if(!(a[f>>0]&1))t=f+1|0;else t=c[f+8>>2]|0;Krd(t,0,3653512,16,1,0,0,0);xri(f)}if(!(c[l>>2]|0)){i=d;return}c[n>>2]=0;t=MSd(c[k>>2]|0,n)|0;if(t){s=bMd(t)|0;c[e>>2]=672784;c[e+4>>2]=692;c[e+8>>2]=673168;c[e+12>>2]=s;Lsd(h,692656,e);if(!(a[h>>0]&1))u=h+1|0;else u=c[h+8>>2]|0;Krd(u,0,3653512,16,1,0,0,0);xri(h)}if((c[n>>2]|0)<=0){i=d;return}h=f+1|0;u=f+8|0;s=g+1|0;t=g+8|0;j=g+1|0;r=g+8|0;q=g+1|0;b=g+8|0;p=0;do{c[o>>2]=0;v=NSd(c[k>>2]|0,p,o,0)|0;if(v){w=bMd(v)|0;c[e>>2]=672784;c[e+4>>2]=696;c[e+8>>2]=673216;c[e+12>>2]=w;Lsd(g,692656,e);Krd((a[g>>0]&1)==0?q:c[b>>2]|0,0,3653512,16,1,0,0,0);xri(g)}w=c[o>>2]|0;if(w){v=USd(w,m,0,0,0,0)|0;if(v){w=bMd(v)|0;c[e>>2]=672784;c[e+4>>2]=699;c[e+8>>2]=673272;c[e+12>>2]=w;Lsd(g,692656,e);Krd((a[g>>0]&1)==0?j:c[r>>2]|0,0,3653512,16,1,0,0,0);xri(g)}if(!(FEi(m,673336,11)|0)){w=KSd(c[o>>2]|0,0,1)|0;if(w){v=bMd(w)|0;c[e>>2]=672784;c[e+4>>2]=702;c[e+8>>2]=673352;c[e+12>>2]=v;Lsd(g,692656,e);Krd((a[g>>0]&1)==0?s:c[t>>2]|0,0,3653512,16,1,0,0,0);xri(g)}v=JSd(c[l>>2]|0,c[o>>2]|0,0)|0;if(v){w=bMd(v)|0;c[e>>2]=672784;c[e+4>>2]=703;c[e+8>>2]=673400;c[e+12>>2]=w;Lsd(f,692656,e);Krd((a[f>>0]&1)==0?h:c[u>>2]|0,0,3653512,16,1,0,0,0);xri(f)}}}p=p+1|0}while((p|0)<(c[n>>2]|0));i=d;return}function yLd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+96|0;e=d;f=d+28|0;g=d+64|0;h=d+52|0;j=d+76|0;k=d+16|0;l=d+40|0;m=d+88|0;tLd(b);vLd(b)|0;c[j>>2]=0;n=j+4|0;c[n>>2]=0;c[j+8>>2]=0;CQb(83,j,0)|0;o=c[j>>2]|0;if((o|0)!=(c[n>>2]|0)){p=o;do{bKd(c[p>>2]|0);p=p+4|0}while((p|0)!=(c[n>>2]|0))}c[k>>2]=0;p=k+4|0;c[p>>2]=0;c[k+8>>2]=0;CQb(82,k,0)|0;o=c[k>>2]|0;if((o|0)!=(c[p>>2]|0)){q=o;do{o=c[q>>2]|0;In[c[(c[o>>2]|0)+12>>2]&4095](o,0);q=q+4|0}while((q|0)!=(c[p>>2]|0))}q=c[b+60>>2]|0;o=b+56|0;if((q|0)!=(o|0)){r=q;do{OKd(c[r+8>>2]|0);r=c[r+4>>2]|0}while((r|0)!=(o|0))}c[l>>2]=0;o=l+4|0;c[o>>2]=0;c[l+8>>2]=0;CQb(114,l,0)|0;r=c[l>>2]|0;if((r|0)!=(c[o>>2]|0)){q=g+1|0;s=g+8|0;t=f+1|0;u=h+1|0;v=h+8|0;w=f+8|0;x=r;do{r=c[x>>2]|0;y=p9c(r)|0;do if(y){c[m>>2]=0;z=WSd(y,m)|0;if(!z){A=RSd(y,(a[(c[m>>2]|0)+13>>0]|0)!=0)|0;if(!A)break;B=bMd(A)|0;c[e>>2]=672784;c[e+4>>2]=755;c[e+8>>2]=673504;c[e+12>>2]=B;Lsd(g,692656,e);Krd((a[g>>0]&1)==0?q:c[s>>2]|0,0,3653512,16,1,0,0,0);xri(g);break}else{B=bMd(z)|0;c[e>>2]=672784;c[e+4>>2]=753;c[e+8>>2]=673448;c[e+12>>2]=B;Lsd(f,692656,e);Krd((a[f>>0]&1)==0?t:c[w>>2]|0,0,3653512,16,1,0,0,0);xri(f);B=RSd(y,(a[r+28>>0]|0)==0)|0;if(!B)break;z=bMd(B)|0;c[e>>2]=672784;c[e+4>>2]=757;c[e+8>>2]=673560;c[e+12>>2]=z;Lsd(h,692656,e);Krd((a[h>>0]&1)==0?u:c[v>>2]|0,0,3653512,16,1,0,0,0);xri(h);break}}while(0);x=x+4|0}while((x|0)!=(c[o>>2]|0))}x=c[b+88>>2]|0;h=b+84|0;if((x|0)!=(h|0)){b=x;do{mMd(c[b+8>>2]|0);b=c[b+4>>2]|0}while((b|0)!=(h|0))}h=c[l>>2]|0;if(h){l=c[o>>2]|0;if((l|0)!=(h|0))c[o>>2]=l+(~((l+-4-h|0)>>>2)<<2);ACi(h)}h=c[k>>2]|0;if(h){k=c[p>>2]|0;if((k|0)!=(h|0))c[p>>2]=k+(~((k+-4-h|0)>>>2)<<2);ACi(h)}h=c[j>>2]|0;if(!h){i=d;return}j=c[n>>2]|0;if((j|0)!=(h|0))c[n>>2]=j+(~((j+-4-h|0)>>>2)<<2);ACi(h);i=d;return}function zLd(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=i;i=i+144|0;l=k+136|0;m=k;n=c[a+92>>2]|0;if(!n){o=0;i=k;return o|0}c[l>>2]=0;PEi(m|0,0,136)|0;c[m>>2]=136;c[m+24>>2]=16384;c[m+72>>2]=d;c[m+20>>2]=e;c[m+16>>2]=f;c[m+12>>2]=g;c[m+76>>2]=206;c[m+80>>2]=2736;c[m+84>>2]=207;c[m+88>>2]=1739;c[m+68>>2]=b;g=(d|0)==13?32850:33554514;if(h)p=g|128;else p=(j?512:256)|g;g=CTd(n,b,(d|0)==16?p|4096:p,m,l)|0;if(!g){dTd(c[l>>2]|0,1)|0;o=c[l>>2]|0;i=k;return o|0}else{zri(a+164|0,bMd(g)|0)|0;c[a+176>>2]=g;o=0;i=k;return o|0}return 0}function ALd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+144|0;e=d+136|0;f=d;g=a+92|0;if(!(c[g>>2]|0)){h=0;i=d;return h|0}c[e>>2]=0;PEi(f|0,0,136)|0;c[f>>2]=136;c[f+4>>2]=-1;c[f+24>>2]=4096;c[f+20>>2]=2;c[f+16>>2]=22050;c[f+12>>2]=1;c[f+44>>2]=1740;c[f+68>>2]=b;b=CTd(c[g>>2]|0,0,33555666,f,e)|0;if(!b){dTd(c[e>>2]|0,1)|0;h=c[e>>2]|0;i=d;return h|0}else{zri(a+164|0,bMd(b)|0)|0;c[a+176>>2]=b;h=0;i=d;return h|0}return 0}function BLd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=c[a+92>>2]|0;if(!h){i=g;return}zTd(h,0,b,d,f,e)|0;i=g;return}function CLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;if(ATb(b,54)|0){d=1;i=a;return d|0}e=c[(BTb(b)|0)+156>>2]|0;if(!e){d=2;i=a;return d|0}else f=e;while(1){e=c[f+24>>2]|0;if((e|0)!=0?(ATb(e,54)|0)!=0:0){d=1;g=6;break}f=c[f+156>>2]|0;if(!f){d=2;g=6;break}}if((g|0)==6){i=a;return d|0}return 0}function DLd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+36|0;if((d[j>>0]|0)==(e&1|0)){i=f;return}a[j>>0]=e&1;KTd(c[b+92>>2]|0,h,g)|0;e=c[h>>2]|0;h=c[g>>2]|0;g=b+192|0;if(!(a[j>>0]|0)){j=g;k=ZEi(h|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=H;l=b+184|0;m=l;n=_Ei(c[m>>2]|0,c[m+4>>2]|0,k|0,j|0)|0;m=l;c[m>>2]=n;c[m+4>>2]=H;m=c[b+52>>2]|0;n=b+48|0;if((m|0)!=(n|0)){l=m;do{m=l;l=c[l+4>>2]|0;o=c[m+8>>2]|0;FMd(o,0.0);if((a[o+475>>0]|a[o+474>>0])<<24>>24)CMd(o,k,j)}while((l|0)!=(n|0))}n=c[b+44>>2]|0;l=b+40|0;if((n|0)==(l|0)){i=f;return}else p=n;do{n=p;p=c[p+4>>2]|0;KMd(c[n+8>>2]|0)}while((p|0)!=(l|0));i=f;return}l=g;c[l>>2]=h;c[l+4>>2]=e;e=c[b+44>>2]|0;l=b+40|0;if((e|0)==(l|0)){i=f;return}h=b+48|0;b=e;do{e=b;b=c[b+4>>2]|0;g=c[e+8>>2]|0;if(MMd(g)|0?(IMd(g),e=g+420|0,(e|0)!=(h|0)):0){p=c[e>>2]|0;n=g+424|0;if(p){c[p+4>>2]=c[n>>2];c[c[n>>2]>>2]=p;c[e>>2]=0;c[n>>2]=0}p=c[h>>2]|0;c[e>>2]=p;c[n>>2]=h;c[p+4>>2]=e;c[c[n>>2]>>2]=e}JMd(g)}while((b|0)!=(l|0));i=f;return}function ELd(a){a=a|0;var b=0,d=0,e=Im,f=Im,h=0,j=Im,k=Im,l=0,m=0,n=0,o=0,p=0;b=i;d=a+24|0;e=ea(g[d>>2]);if(e<ea(0.0))f=ea(0.0);else{h=e>ea(1.0);f=h?ea(1.0):e}g[d>>2]=f;d=a+32|0;f=ea(g[d>>2]);if(f<ea(0.0))j=ea(0.0);else{h=f>ea(10.0);j=h?ea(10.0):f}g[d>>2]=j;d=a+80|0;j=ea(g[d>>2]);if(j<ea(0.0))k=ea(0.0);else{h=j>ea(10.0);k=h?ea(10.0):j}g[d>>2]=k;d=a+124|0;h=c[d>>2]|0;if((h|0)<1)l=1;else l=(h|0)>7?7:h;c[d>>2]=l;l=a+128|0;d=c[l>>2]|0;if((d|0)<0)m=0;else m=(d|0)>96e3?96e3:d;c[l>>2]=m;m=a+132|0;l=c[m>>2]|0;if((l|0)<0)n=0;else n=(l|0)>8192?8192:l;c[m>>2]=n;n=a+136|0;m=c[n>>2]|0;if((m|0)<1)o=1;else o=(m|0)>4095?4095:m;c[n>>2]=o;o=a+140|0;a=c[o>>2]|0;if((a|0)<1){p=1;c[o>>2]=p;i=b;return}p=(a|0)>255?255:a;c[o>>2]=p;i=b;return}function FLd(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im;d=i;e=b+92|0;if((c[e>>2]|0)==0?(vLd(b)|0,a[b+36>>0]=0,(c[e>>2]|0)==0):0){i=d;return}if(!(((((c[b+148>>2]|0)==(c[b+128>>2]|0)?(c[b+152>>2]|0)==(c[b+132>>2]|0):0)?(c[b+144>>2]|0)==(c[b+124>>2]|0):0)?(c[b+156>>2]|0)==(c[b+136>>2]|0):0)?(c[b+160>>2]|0)==(c[b+140>>2]|0):0))f=8;if((f|0)==8?(yLd(b),(c[e>>2]|0)==0):0){i=d;return}h=ea(g[b+24>>2]);f=b+28|0;g[f>>2]=h;wSd(c[b+104>>2]|0,h)|0;wSd(c[b+112>>2]|0,ea(g[f>>2]))|0;h=ea(g[b+80>>2]);yTd(c[e>>2]|0,h,ea(1.0),ea(g[b+32>>2]))|0;i=d;return}function GLd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;j=b+92|0;KTd(c[j>>2]|0,e,f)|0;k=b+64|0;l=b+68|0;m=c[l>>2]|0;if((m|0)==(k|0))n=m;else{o=b+184|0;p=b+36|0;q=b+48|0;r=b+40|0;b=m;do{m=c[b+8>>2]|0;s=b+16|0;if(+h[s>>3]!=0.0){pTd(c[j>>2]|0,g,0,0,0,0,0)|0;t=+h[s>>3];if(t>0.0){u=t*+(c[g>>2]|0);s=+S(u)>=1.0?(u>0.0?(ha(+R(u/4294967296.0),4294967295.0)|0)>>>0:~~+ca((u-+(~~u>>>0))/4294967296.0)>>>0):0;v=o;w=_Ei(~~u>>>0|0,s|0,c[v>>2]|0,c[v+4>>2]|0)|0;v=c[m+432>>2]|0;if(!v)x=0;else x=c[v+12>>2]|0;_Nd(x,1,H,w)|0}else{u=-(t*+(c[g>>2]|0));w=_Ei(~~u>>>0|0,(+S(u)>=1.0?(u>0.0?(ha(+R(u/4294967296.0),4294967295.0)|0)>>>0:~~+ca((u-+(~~u>>>0))/4294967296.0)>>>0):0)|0,c[f>>2]|0,c[e>>2]|0)|0;v=c[m+432>>2]|0;if(!v)y=0;else y=c[v+12>>2]|0;_Nd(y,1,H,w)|0}a[m+474>>0]=1}if(!(a[m+496>>0]|0))if(!(a[p>>0]|0))z=0;else z=(a[m+401>>0]|0)==0;else z=1;w=c[(c[m+432>>2]|0)+12>>2]|0;a[w+232>>0]=z&1;jOd(w);w=m+420|0;if(z){if((w|0)!=(q|0)){v=c[w>>2]|0;s=m+424|0;if(v){c[v+4>>2]=c[s>>2];c[c[s>>2]>>2]=v;c[w>>2]=0;c[s>>2]=0}v=c[q>>2]|0;c[w>>2]=v;c[s>>2]=q;c[v+4>>2]=w;c[c[s>>2]>>2]=w}}else if((w|0)!=(r|0)){s=c[w>>2]|0;v=m+424|0;if(s){c[s+4>>2]=c[v>>2];c[c[v>>2]>>2]=s;c[w>>2]=0;c[v>>2]=0}s=c[r>>2]|0;c[w>>2]=s;c[v>>2]=r;c[s+4>>2]=w;c[c[v>>2]>>2]=w}b=c[b+4>>2]|0}while((b|0)!=(k|0));n=c[l>>2]|0}if((n|0)==(k|0)){c[l>>2]=k;c[k>>2]=k;i=d;return}else A=n;do{n=A+4|0;b=A;A=c[n>>2]|0;c[b>>2]=0;c[n>>2]=0}while((A|0)!=(k|0));c[l>>2]=k;c[k>>2]=k;i=d;return}function HLd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(d){d=a+48|0;f=b+420|0;if((f|0)==(d|0)){i=e;return}g=c[f>>2]|0;h=b+424|0;if(g){c[g+4>>2]=c[h>>2];c[c[h>>2]>>2]=g;c[f>>2]=0;c[h>>2]=0}g=c[d>>2]|0;c[f>>2]=g;c[h>>2]=d;c[g+4>>2]=f;c[c[h>>2]>>2]=f;i=e;return}else{f=a+40|0;a=b+420|0;if((a|0)==(f|0)){i=e;return}h=c[a>>2]|0;g=b+424|0;if(h){c[h+4>>2]=c[g>>2];c[c[g>>2]>>2]=h;c[a>>2]=0;c[g>>2]=0}h=c[f>>2]|0;c[a>>2]=h;c[g>>2]=f;c[h+4>>2]=a;c[c[g>>2]>>2]=a;i=e;return}}function ILd(a){a=a|0;var b=0,d=0,e=0,f=Im,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=a+92|0;if(!(c[e>>2]|0)){i=b;return}f=ea(g[(jLc()|0)+104>>2]);h=a+72|0;j=c[a+76>>2]|0;if((j|0)!=(h|0)){k=j;do{pNd(c[k+8>>2]|0,f);k=c[k+4>>2]|0}while((k|0)!=(h|0))}GLd(a);h=c[a+60>>2]|0;k=a+56|0;if((h|0)!=(k|0)){j=h;do{h=c[j+8>>2]|0;ko[c[(c[h>>2]|0)+108>>2]&4095](h);j=c[j+4>>2]|0}while((j|0)!=(k|0))}k=c[a+44>>2]|0;j=a+40|0;if((k|0)!=(j|0)){h=k;do{k=c[h+8>>2]|0;ko[c[(c[k>>2]|0)+108>>2]&4095](k);h=c[h+4>>2]|0}while((h|0)!=(j|0))}j=c[a+88>>2]|0;h=a+84|0;if((j|0)!=(h|0)){a=j;do{j=c[a+8>>2]|0;ko[c[(c[j>>2]|0)+108>>2]&4095](j);a=c[a+4>>2]|0}while((a|0)!=(h|0))}c[d>>2]=0;pTd(c[e>>2]|0,d,0,0,0,0,0)|0;c[167919]=c[d>>2];d=c[167918]&-4;h=(fRc()|0)!=0;c[167918]=d|(h?2:0)|1;xTd(c[e>>2]|0)|0;i=b;return}function JLd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;if(!(c[a+92>>2]|0)){i=b;return}d=c[a+60>>2]|0;e=a+56|0;if((d|0)!=(e|0)){f=d;do{d=c[f+8>>2]|0;ko[c[(c[d>>2]|0)+112>>2]&4095](d);f=c[f+4>>2]|0}while((f|0)!=(e|0))}e=c[a+44>>2]|0;f=a+40|0;if((e|0)==(f|0)){i=b;return}else g=e;do{e=c[g+8>>2]|0;ko[c[(c[e>>2]|0)+112>>2]&4095](e);g=c[g+4>>2]|0}while((g|0)!=(f|0));i=b;return}function KLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=b+440|0;e=c[d>>2]|0;if(e){f=b+444|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0}f=b+420|0;d=c[f>>2]|0;if(!d){i=a;return}e=b+424|0;c[d+4>>2]=c[e>>2];c[c[e>>2]>>2]=d;c[f>>2]=0;c[e>>2]=0;i=a;return}function LLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=b+440|0;e=c[d>>2]|0;if(!e){i=a;return}f=b+444|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0;i=a;return}function MLd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+40|0;e=c[a+44>>2]|0;if((e|0)!=(d|0)){f=e;do{rMd(c[f+8>>2]|0);f=c[f+4>>2]|0}while((f|0)!=(d|0))}d=a+48|0;f=c[a+52>>2]|0;if((f|0)!=(d|0)){e=f;do{rMd(c[e+8>>2]|0);e=c[e+4>>2]|0}while((e|0)!=(d|0))}d=a+72|0;e=c[a+76>>2]|0;if((e|0)==(d|0)){i=b;return}else g=e;do{mNd(c[g+8>>2]|0);g=c[g+4>>2]|0}while((g|0)!=(d|0));i=b;return}function NLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;a=b+52|0;if((a|0)==(e|0)){i=d;return}f=c[a>>2]|0;g=b+56|0;if(f){c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[a>>2]=0;c[g>>2]=0}f=c[e>>2]|0;c[a>>2]=f;c[g>>2]=e;c[f+4>>2]=a;c[c[g>>2]>>2]=a;i=d;return}function OLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=b+52|0;e=c[d>>2]|0;if(!e){i=a;return}f=b+56|0;c[e+4>>2]=c[f>>2];c[c[f>>2]>>2]=e;c[d>>2]=0;c[f>>2]=0;i=a;return}function PLd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+56|0;if((c[a+60>>2]|0)==(d|0)){e=0;i=b;return e|0}e=c[(c[d>>2]|0)+8>>2]|0;i=b;return e|0}function QLd(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0;e=i;f=b+440|0;g=c[f>>2]|0;if(g){j=b+444|0;c[g+4>>2]=c[j>>2];c[c[j>>2]>>2]=g;c[f>>2]=0;c[j>>2]=0}h[b+456>>3]=d;j=a+64|0;if((f|0)==(j|0)){i=e;return}a=b+444|0;b=c[j>>2]|0;c[f>>2]=b;c[a>>2]=j;c[b+4>>2]=f;c[c[a>>2]>>2]=f;i=e;return}function RLd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+208|0;a=c[d>>2]|0;if(a){e=a;i=b;return e|0}a=xCi(28)|0;fNd(a);c[d>>2]=a;e=a;i=b;return e|0}function SLd(a){a=a|0;return c[a+200>>2]|0}function TLd(){var a=0;a=i;QQb(11,196,197,0,198);i=a;return}function ULd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(6)|0))oSb();rri(b,674016,12);wQb(11,6,b,216,2737,0,0);xri(b);i=a;return}function VLd(a){a=a|0;return 11}function WLd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,674016,a,0);dMd(a,b);bdd(b);i=c;return}function XLd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,674016,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else eMd(a,b);sdd(b);i=d;return}function YLd(a,b){a=a|0;b=b|0;var c=0;c=i;fMd(a,b);i=c;return}function ZLd(a,b){a=a|0;b=b|0;var c=0;c=i;gMd(a,b);i=c;return}function _Ld(a,b){a=a|0;b=b|0;var c=0;c=i;hMd(a,b);i=c;return}function $Ld(a,b){a=a|0;b=b|0;var c=0;c=i;PSb(a,b);i=c;return}function aMd(){var a=0,b=0;a=i;b=rVb(3)|0;i=a;return b|0}function bMd(a){a=a|0;var b=0,c=0;b=i;do switch(a|0){case 92:{c=686176;break}case 9:{c=685224;break}case 11:{c=685296;break}case 2:{c=684816;break}case 16:{c=685816;break}case 83:{c=686312;break}case 4:{c=685e3;break}case 15:{c=685712;break}case 6:{c=685104;break}case 14:{c=685568;break}case 91:{c=686424;break}case 13:{c=685512;break}case 3:{c=684952;break}case 17:{c=685880;break}case 18:{c=686072;break}case 8:{c=685176;break}case 85:{c=686528;break}case 12:{c=685360;break}case 87:{c=686704;break}case 88:{c=686872;break}case 10:{c=685256;break}case 90:{c=686920;break}case 89:{c=687008;break}case 86:{c=686600;break}case 5:{c=685064;break}case 84:{c=686472;break}case 7:{c=685144;break}case 19:{c=687096;break}case 20:{c=687120;break}case 21:{c=687232;break}case 22:{c=687272;break}case 23:{c=687368;break}case 24:{c=687392;break}case 25:{c=687424;break}case 26:{c=687464;break}case 27:{c=687552;break}case 28:{c=687624;break}case 29:{c=687696;break}case 30:{c=687728;break}case 31:{c=687760;break}case 32:{c=687824;break}case 33:{c=687872;break}case 34:{c=687936;break}case 35:{c=688040;break}case 36:{c=688096;break}case 37:{c=688136;break}case 38:{c=688192;break}case 39:{c=688248;break}case 40:{c=688336;break}case 41:{c=688392;break}case 42:{c=688456;break}case 43:{c=688528;break}case 44:{c=688568;break}case 45:{c=688696;break}case 95:{c=688752;break}case 94:{c=688816;break}case 93:{c=688864;break}case 46:{c=688944;break}case 47:{c=689024;break}case 48:{c=689104;break}case 49:{c=689232;break}case 50:{c=689424;break}case 51:{c=689472;break}case 52:{c=689568;break}case 53:{c=689616;break}case 54:{c=689688;break}case 55:{c=689776;break}case 56:{c=689896;break}case 57:{c=689936;break}case 58:{c=690072;break}case 59:{c=690192;break}case 60:{c=690296;break}case 61:{c=690336;break}case 62:{c=690440;break}case 63:{c=690536;break}case 64:{c=690592;break}case 65:{c=690664;break}case 66:{c=690728;break}case 67:{c=690792;break}case 68:{c=690888;break}case 69:{c=691008;break}case 70:{c=691120;break}case 71:{c=691184;break}case 75:{c=691328;break}case 72:{c=691616;break}case 73:{c=691768;break}case 74:{c=691888;break}case 76:{c=692024;break}case 77:{c=692088;break}case 78:{c=692240;break}case 79:{c=692320;break}case 80:{c=692400;break}case 81:{c=692512;break}case 82:{c=692560;break}case 0:{c=692624;break}case 1:{c=684752;break}default:c=692640}while(0);i=b;return c|0}function cMd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;k=c[b>>2]|0;c[j>>2]=k;c[f+0>>2]=c[j+0>>2];j=bOb(216,f,1,16,3653512,48)|0;c[h>>2]=k;c[f+0>>2]=c[h+0>>2];jSb(j,f,d);c[j>>2]=672464;g[j+24>>2]=ea(1.0);g[j+28>>2]=ea(1.0);g[j+32>>2]=ea(1.0);a[j+36>>0]=0;d=j+40|0;c[d>>2]=d;c[j+44>>2]=d;d=j+48|0;c[d>>2]=d;c[j+52>>2]=d;d=j+56|0;c[d>>2]=d;c[j+60>>2]=d;d=j+64|0;c[d>>2]=d;c[j+68>>2]=d;d=j+72|0;c[d>>2]=d;c[j+76>>2]=d;g[j+80>>2]=ea(1.0);d=j+84|0;c[d>>2]=d;c[j+88>>2]=d;d=j+92|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[j+120>>2]=2;c[j+124>>2]=2;c[j+128>>2]=0;c[j+132>>2]=0;c[j+136>>2]=512;c[j+140>>2]=32;c[j+144>>2]=2;c[j+148>>2]=0;c[j+152>>2]=0;c[j+156>>2]=512;c[j+160>>2]=32;d=j+164|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;d=j+184|0;c[j+208>>2]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;a[d+20>>0]=0;c[168142]=j;i=e;return j|0}function dMd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;KSb(a,b);e=c[142268]|0;add(b,674032,e,a+24|0,2048);f=b+12|0;g=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674048,e,a+32|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674064,e,a+80|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);e=c[142270]|0;add(b,674080,e,a+124|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674104,e,a+128|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674120,e,a+132|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674136,e,a+136|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674160,e,a+140|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,674184,c[142258]|0,a+204|0,0);c[(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function eMd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;LSb(b,d);h=b+24|0;j=c[142268]|0;k=qdd(d,674032,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[n>>2]);c[k>>2]=o}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+32|0;k=qdd(d,674048,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[k>>2]=m;if((n|0)>=0?(l=o+(n+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[m>>2]);c[k>>2]=l}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+80|0;k=qdd(d,674064,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;j=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=j+l|0;c[k>>2]=m;if((l|0)>=0?(n=j+(l+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[m>>2]);c[k>>2]=n}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+124|0;k=c[142270]|0;n=qdd(d,674080,k,f,0)|0;if(n){if((n|0)>0){n=d+12|0;m=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=m+l|0;c[n>>2]=j;if((l|0)>=0?(o=m+(l+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[j>>2];c[n>>2]=o}else Bid(n,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}sdd(d)}h=b+128|0;n=qdd(d,674104,k,f,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=o+j|0;c[n>>2]=l;if((j|0)>=0?(m=o+(j+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[n>>2]=m}else Bid(n,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}sdd(d)}h=b+132|0;n=qdd(d,674120,k,f,0)|0;if(n){if((n|0)>0){n=d+12|0;m=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=m+l|0;c[n>>2]=j;if((l|0)>=0?(o=m+(l+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[j>>2];c[n>>2]=o}else Bid(n,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}sdd(d)}h=b+136|0;n=qdd(d,674136,k,f,0)|0;if(n){if((n|0)>0){n=d+12|0;o=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=o+j|0;c[n>>2]=l;if((j|0)>=0?(m=o+(j+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[n>>2]=m}else Bid(n,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}sdd(d)}h=b+140|0;n=qdd(d,674160,k,f,0)|0;if(n){if((n|0)>0){n=d+12|0;k=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=k+m|0;c[n>>2]=l;if((m|0)>=0?(j=k+(m+4)|0,j>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[l>>2];c[n>>2]=j}else Bid(n,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}sdd(d)}h=b+204|0;b=qdd(d,674184,c[142258]|0,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](h,d)|0}else{n=d+12|0;j=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=j+l|0;c[n>>2]=m;if((l|0)>=0?(j+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[m>>0]|0;c[n>>2]=(c[n>>2]|0)+1;break}Bid(n,h,1)}while(0);sdd(d);i=e;return}function fMd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;MSb(b,d);f=b+24|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0>m>>>0){Bid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}else{g[f>>2]=ea(g[j>>2]);c[h>>2]=k;n=k;o=m}m=b+32|0;k=n+4|0;if(k>>>0>o>>>0){Bid(h,m,4);p=c[h>>2]|0;q=c[l>>2]|0}else{g[m>>2]=ea(g[n>>2]);c[h>>2]=k;p=k;q=o}o=b+80|0;k=p+4|0;if(k>>>0>q>>>0){Bid(h,o,4);r=c[h>>2]|0;s=c[l>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[h>>2]=k;r=k;s=q}q=b+124|0;k=r+4|0;if(k>>>0>s>>>0){Bid(h,q,4);t=c[h>>2]|0;u=c[l>>2]|0}else{c[q>>2]=c[r>>2];c[h>>2]=k;t=k;u=s}s=b+128|0;k=t+4|0;if(k>>>0>u>>>0){Bid(h,s,4);v=c[h>>2]|0;w=c[l>>2]|0}else{c[s>>2]=c[t>>2];c[h>>2]=k;v=k;w=u}u=b+132|0;k=v+4|0;if(k>>>0>w>>>0){Bid(h,u,4);x=c[h>>2]|0;y=c[l>>2]|0}else{c[u>>2]=c[v>>2];c[h>>2]=k;x=k;y=w}w=b+136|0;k=x+4|0;if(k>>>0>y>>>0){Bid(h,w,4);z=c[h>>2]|0;A=c[l>>2]|0}else{c[w>>2]=c[x>>2];c[h>>2]=k;z=k;A=y}y=b+140|0;k=z+4|0;if(k>>>0>A>>>0){Bid(h,y,4);B=c[h>>2]|0;C=c[l>>2]|0}else{c[y>>2]=c[z>>2];c[h>>2]=k;B=k;C=A}A=b+204|0;if((B+1|0)>>>0>C>>>0){Bid(h,A,1);Ndd(d);i=e;return}else{a[A>>0]=a[B>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Ndd(d);i=e;return}}function gMd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=i;NSb(b,d);f=b+24|0;h=d+12|0;j=c[h>>2]|0;l=j+4|0;m=d+20|0;n=c[m>>2]|0;if(l>>>0>n>>>0){Bid(h,f,4);o=f;p=c[h>>2]|0;q=c[m>>2]|0;r=c[f>>2]|0}else{s=ea(g[j>>2]);g[f>>2]=s;c[h>>2]=l;o=f;p=l;q=n;r=(g[k>>2]=s,c[k>>2]|0)}c[o>>2]=XEi(r|0)|0;r=b+32|0;o=p+4|0;if(o>>>0>q>>>0){Bid(h,r,4);t=r;u=c[r>>2]|0;v=c[h>>2]|0;w=c[m>>2]|0}else{s=ea(g[p>>2]);g[r>>2]=s;c[h>>2]=o;t=r;u=(g[k>>2]=s,c[k>>2]|0);v=o;w=q}c[t>>2]=XEi(u|0)|0;u=b+80|0;t=v+4|0;if(t>>>0>w>>>0){Bid(h,u,4);x=u;y=c[u>>2]|0;z=c[h>>2]|0;A=c[m>>2]|0}else{s=ea(g[v>>2]);g[u>>2]=s;c[h>>2]=t;x=u;y=(g[k>>2]=s,c[k>>2]|0);z=t;A=w}c[x>>2]=XEi(y|0)|0;y=b+124|0;x=z+4|0;if(x>>>0>A>>>0){Bid(h,y,4);B=c[y>>2]|0;C=c[h>>2]|0;D=c[m>>2]|0}else{w=c[z>>2]|0;c[y>>2]=w;c[h>>2]=x;B=w;C=x;D=A}c[y>>2]=XEi(B|0)|0;B=b+128|0;y=C+4|0;if(y>>>0>D>>>0){Bid(h,B,4);E=c[B>>2]|0;F=c[h>>2]|0;G=c[m>>2]|0}else{A=c[C>>2]|0;c[B>>2]=A;c[h>>2]=y;E=A;F=y;G=D}c[B>>2]=XEi(E|0)|0;E=b+132|0;B=F+4|0;if(B>>>0>G>>>0){Bid(h,E,4);H=c[E>>2]|0;I=c[h>>2]|0;J=c[m>>2]|0}else{D=c[F>>2]|0;c[E>>2]=D;c[h>>2]=B;H=D;I=B;J=G}c[E>>2]=XEi(H|0)|0;H=b+136|0;E=I+4|0;if(E>>>0>J>>>0){Bid(h,H,4);K=c[H>>2]|0;L=c[h>>2]|0;M=c[m>>2]|0}else{G=c[I>>2]|0;c[H>>2]=G;c[h>>2]=E;K=G;L=E;M=J}c[H>>2]=XEi(K|0)|0;K=b+140|0;H=L+4|0;if(H>>>0>M>>>0){Bid(h,K,4);N=c[K>>2]|0;O=c[h>>2]|0;P=c[m>>2]|0}else{m=c[L>>2]|0;c[K>>2]=m;c[h>>2]=H;N=m;O=H;P=M}c[K>>2]=XEi(N|0)|0;N=b+204|0;if((O+1|0)>>>0>P>>>0){Bid(h,N,1);Mdd(d);i=e;return}else{a[N>>0]=a[O>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Mdd(d);i=e;return}}function hMd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;OSb(b,d);f=b+24|0;h=d+12|0;j=c[h>>2]|0;k=j+4|0;l=d+20|0;m=c[l>>2]|0;if(k>>>0<m>>>0){g[j>>2]=ea(g[f>>2]);c[h>>2]=k;n=k;o=m}else{Gid(h,f,4);n=c[h>>2]|0;o=c[l>>2]|0}f=b+32|0;m=n+4|0;if(m>>>0<o>>>0){g[n>>2]=ea(g[f>>2]);c[h>>2]=m;p=m;q=o}else{Gid(h,f,4);p=c[h>>2]|0;q=c[l>>2]|0}f=b+80|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[f>>2]);c[h>>2]=o;r=o;s=q}else{Gid(h,f,4);r=c[h>>2]|0;s=c[l>>2]|0}f=b+124|0;q=r+4|0;if(q>>>0<s>>>0){c[r>>2]=c[f>>2];c[h>>2]=q;t=q;u=s}else{Gid(h,f,4);t=c[h>>2]|0;u=c[l>>2]|0}f=b+128|0;s=t+4|0;if(s>>>0<u>>>0){c[t>>2]=c[f>>2];c[h>>2]=s;v=s;w=u}else{Gid(h,f,4);v=c[h>>2]|0;w=c[l>>2]|0}f=b+132|0;u=v+4|0;if(u>>>0<w>>>0){c[v>>2]=c[f>>2];c[h>>2]=u;x=u;y=w}else{Gid(h,f,4);x=c[h>>2]|0;y=c[l>>2]|0}f=b+136|0;w=x+4|0;if(w>>>0<y>>>0){c[x>>2]=c[f>>2];c[h>>2]=w;z=w;A=y}else{Gid(h,f,4);z=c[h>>2]|0;A=c[l>>2]|0}f=b+140|0;y=z+4|0;if(y>>>0<A>>>0){c[z>>2]=c[f>>2];c[h>>2]=y;B=y;C=A}else{Gid(h,f,4);B=c[h>>2]|0;C=c[l>>2]|0}l=b+204|0;if((B+1|0)>>>0<C>>>0){a[B>>0]=a[l>>0]|0;c[h>>2]=(c[h>>2]|0)+1;Tdd(d);i=e;return}else{Gid(h,l,1);Tdd(d);i=e;return}}function iMd(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=672464;xri(a+164|0);c[a+88>>2]=0;c[a+84>>2]=0;d=a+40|0;e=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));ZSb(a);i=b;return}function jMd(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=672464;xri(a+164|0);c[a+88>>2]=0;c[a+84>>2]=0;d=a+40|0;e=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));ZSb(a);ACi(a);i=b;return}function kMd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;a=671664;h=_Ei(c[a>>2]|0,c[a+4>>2]|0,e|0,0)|0;a=671664;c[a>>2]=h;c[a+4>>2]=H;YEi(d|0,b|0,da(e<<2,f)|0)|0;i=g;return 0}function lMd(a){a=a|0;var b=0,d=0;b=i;d=a+112|0;a=c[d>>2]|0;if(!a){i=b;return}XSd(a)|0;c[d>>2]=0;i=b;return}function mMd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+112|0;a:do if(!(c[d>>2]|0)){do switch(GTd(c[(aMd()|0)+92>>2]|0,d)|0){case 2:{e=684816;break}case 17:{e=685880;break}case 9:{e=685224;break}case 18:{e=686072;break}case 6:{e=685104;break}case 91:{e=686424;break}case 5:{e=685064;break}case 16:{e=685816;break}case 8:{e=685176;break}case 11:{e=685296;break}case 92:{e=686176;break}case 7:{e=685144;break}case 4:{e=685e3;break}case 14:{e=685568;break}case 83:{e=686312;break}case 3:{e=684952;break}case 10:{e=685256;break}case 84:{e=686472;break}case 12:{e=685360;break}case 86:{e=686600;break}case 87:{e=686704;break}case 85:{e=686528;break}case 15:{e=685712;break}case 13:{e=685512;break}case 88:{e=686872;break}case 90:{e=686920;break}case 89:{e=687008;break}case 19:{e=687096;break}case 20:{e=687120;break}case 21:{e=687232;break}case 22:{e=687272;break}case 23:{e=687368;break}case 24:{e=687392;break}case 25:{e=687424;break}case 26:{e=687464;break}case 27:{e=687552;break}case 28:{e=687624;break}case 29:{e=687696;break}case 30:{e=687728;break}case 31:{e=687760;break}case 32:{e=687824;break}case 33:{e=687872;break}case 34:{e=687936;break}case 35:{e=688040;break}case 36:{e=688096;break}case 37:{e=688136;break}case 38:{e=688192;break}case 39:{e=688248;break}case 40:{e=688336;break}case 41:{e=688392;break}case 42:{e=688456;break}case 43:{e=688528;break}case 44:{e=688568;break}case 45:{e=688696;break}case 95:{e=688752;break}case 94:{e=688816;break}case 93:{e=688864;break}case 46:{e=688944;break}case 47:{e=689024;break}case 48:{e=689104;break}case 49:{e=689232;break}case 50:{e=689424;break}case 51:{e=689472;break}case 52:{e=689568;break}case 53:{e=689616;break}case 54:{e=689688;break}case 55:{e=689776;break}case 56:{e=689896;break}case 57:{e=689936;break}case 58:{e=690072;break}case 59:{e=690192;break}case 60:{e=690296;break}case 61:{e=690336;break}case 62:{e=690440;break}case 63:{e=690536;break}case 64:{e=690592;break}case 65:{e=690664;break}case 66:{e=690728;break}case 67:{e=690792;break}case 68:{e=690888;break}case 69:{e=691008;break}case 70:{e=691120;break}case 71:{e=691184;break}case 75:{e=691328;break}case 72:{e=691616;break}case 73:{e=691768;break}case 74:{e=691888;break}case 76:{e=692024;break}case 77:{e=692088;break}case 78:{e=692240;break}case 79:{e=692320;break}case 80:{e=692400;break}case 81:{e=692512;break}case 82:{e=692560;break}case 1:{e=684752;break}case 0:{break a;break}default:e=692640}while(0);Krd(e,0,3653512,109,1,0,0,0)}while(0);_Sd(c[d>>2]|0,1)|0;xLd(aMd()|0);nMd(a);xTd(c[(aMd()|0)+92>>2]|0)|0;i=b;return}function nMd(a){a=a|0;var b=0,d=0,e=0,f=0,h=Im,j=0,k=0,l=0;b=i;i=i+96|0;d=b+80|0;e=b;f=a+112|0;if(!(c[f>>2]|0)){i=b;return}rGc(d,BTb(c[a+24>>2]|0)|0);h=ea(g[a+44>>2]);YSd(c[f>>2]|0,d,h,ea(g[a+48>>2]))|0;d=c[a+52>>2]|0;if((d|0)<27){j=e+0|0;k=674216+(d*80|0)|0;l=j+80|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0))}else{j=e+0|0;k=676376|0;l=j+80|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));c[e+12>>2]=c[a+56>>2];c[e+16>>2]=c[a+60>>2];g[e+24>>2]=ea(g[a+68>>2]);g[e+28>>2]=ea(g[a+72>>2]);c[e+36>>2]=c[a+76>>2];g[e+40>>2]=ea(g[a+80>>2]);c[e+44>>2]=c[a+84>>2];g[e+48>>2]=ea(g[a+88>>2]);g[e+60>>2]=ea(g[a+92>>2]);g[e+68>>2]=ea(g[a+104>>2]);g[e+72>>2]=ea(g[a+108>>2]);c[e+20>>2]=c[a+64>>2];g[e+64>>2]=ea(g[a+96>>2])}ZSd(c[f>>2]|0,e)|0;i=b;return}function oMd(a,b){a=a|0;b=ea(b);var c=0,d=Im,e=Im,f=Im,h=0,j=Im,k=Im,l=Im,m=0;c=i;d=ea(g[(aMd()|0)+32>>2]);e=ea(OMd(a));f=ea(NMd(a));h=PMd(a)|0;if((h|0)==1){j=ea(e-f);if(!(j<=ea(0.0)))k=ea(ea(e-b)/j);else k=ea(1.0)}else if(!h){if(f<b&d!=ea(1.0))l=ea(f+ea(d*ea(b-f)));else l=b;m=l<ea(9.99999997e-07);k=ea(f/(m?ea(9.99999997e-07):l))}else if((h|0)==2?e>ea(0.0):0)k=ea(UMc(QMd(a)|0,ea(b/e)));else k=ea(1.0);a=k<ea(0.0);e=a?ea(0.0):k;a=e>ea(1.0);k=a?ea(1.0):e;i=c;return ea(k)}function pMd(b,e){b=b|0;e=ea(e);var f=0,g=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+16|0;g=f;c[g>>2]=0;tSd(b,g)|0;b=c[g>>2]|0;if(!b){h=ea(1.0);i=f;return ea(h)}g=c[b>>2]|0;j=a[674208]|0;if(!(j<<24>>24)){k=-1;l=0;m=0;while(1){if(!(k&1))n=m;else n=1<<31-l|m;l=l+1|0;if((l|0)==32){o=n;p=684064;break}else{k=k>>>1;m=n}}while(1){n=c[572464+(((d[p>>0]|0)^o&255)<<2)>>2]^o>>>8;p=p+1|0;if((p|0)==(684151|0)){q=n;break}else o=n}o=~q;c[168550]=o;q=674208;c[q>>2]=1;c[q+4>>2]=0;r=o;s=1}else{r=c[168550]|0;s=j}if((g|0)!=(r|0)){h=ea(1.0);i=f;return ea(h)}r=b+4|0;b=c[r>>2]|0;if(!b){h=ea(1.0);i=f;return ea(h)}if(!(s<<24>>24)){s=-1;g=0;j=0;while(1){if(!(s&1))t=j;else t=1<<31-g|j;g=g+1|0;if((g|0)==32){u=t;v=684064;break}else{s=s>>>1;j=t}}while(1){t=c[572464+(((d[v>>0]|0)^u&255)<<2)>>2]^u>>>8;v=v+1|0;if((v|0)==(684151|0)){w=t;break}else u=t}c[168550]=~w;w=674208;c[w>>2]=1;c[w+4>>2]=0;x=c[r>>2]|0}else x=b;b=c[x+236>>2]|0;if(!b){h=ea(1.0);i=f;return ea(h)}h=ea(oMd(b,e));i=f;return ea(h)}function qMd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;rMd(b);sMd(b,ea(g[b+356>>2]));tMd(b,ea(g[b+352>>2]));uMd(b,ea(g[b+360>>2]));vMd(b,ea(g[b+368>>2]));wMd(b,ea(g[b+384>>2]));xMd(b,c[b+364>>2]|0);yMd(b,ea(g[b+372>>2]));zMd(b,ea(g[b+376>>2]));AMd(b,ea(g[b+380>>2]));BMd(b,ea(g[b+388>>2]));e=b+396|0;f=a[e>>0]|0;h=f<<24>>24!=0;j=b+432|0;k=c[j>>2]|0;if((k|0)!=0?(c[k+12>>2]|0)!=0:0){k=c[j>>2]|0;if(!k)l=0;else l=c[k+12>>2]|0;fOd(l,h)|0}h=b+408|0;l=c[h>>2]|0;k=b+404|0;if((l|0)!=(k|0)){m=l;do{l=c[(c[m+8>>2]|0)+12>>2]|0;if(!l)n=0;else n=c[l+12>>2]|0;fOd(n,0)|0;m=c[m+4>>2]|0}while((m|0)!=(k|0))}a[e>>0]=f;f=(a[b+397>>0]|0)!=0;b=c[j>>2]|0;if((b|0)!=0?(c[b+12>>2]|0)!=0:0){b=c[j>>2]|0;if(!b)o=0;else o=c[b+12>>2]|0;$Nd(o,f)|0}o=c[h>>2]|0;if((o|0)==(k|0)){i=d;return}else p=o;do{o=c[(c[p+8>>2]|0)+12>>2]|0;if(!o)q=0;else q=c[o+12>>2]|0;$Nd(q,f)|0;p=c[p+4>>2]|0}while((p|0)!=(k|0));i=d;return}function rMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+80|0;e=d;f=d+28|0;g=d+40|0;h=d+52|0;j=d+20|0;k=d+16|0;l=d+24|0;m=d+64|0;n=d+68|0;o=d+72|0;p=b+464|0;if(!(c[p>>2]|0)){i=d;return}q=b+468|0;if(!(c[q>>2]|0)){i=d;return}r=b+416|0;s=c[r>>2]|0;do if(s){c[m>>2]=s;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(e,t,m);u=c[e>>2]|0;v=c[t+28>>2]|0;if((u|0)==-1){w=v+(c[t+32>>2]<<3)|0;break}else{w=v+(u<<3)|0;break}}else w=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((w|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(c[w+4>>2]|0)!=0:0)x=t;else y=12}else y=12;if((y|0)==12){if(!(hQb(c[r>>2]|0)|0)){y=42;break}x=c[137784]|0}c[l>>2]=c[r>>2];if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(e,x,l);t=c[e>>2]|0;u=c[x+28>>2]|0;if((t|0)==-1){z=u+(c[x+32>>2]<<3)|0;break}else{z=u+(t<<3)|0;break}}else z=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);t=c[137784]|0;if((z|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(u=c[z+4>>2]|0,(u|0)!=0):0){A=t;B=u}else y=22}else y=22;if((y|0)==22){u=hQb(c[r>>2]|0)|0;A=c[137784]|0;B=u}u=c[B+44>>2]|0;c[k>>2]=u;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(e,A,k);t=c[e>>2]|0;v=c[A+28>>2]|0;if((t|0)==-1){C=v+(c[A+32>>2]<<3)|0;break}else{C=v+(t<<3)|0;break}}else C=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);t=c[137784]|0;if((C|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(v=c[C+4>>2]|0,(v|0)!=0):0){D=t;E=v}else y=31}else y=31;if((y|0)==31){v=hQb(u)|0;D=c[137784]|0;E=v}c[j>>2]=c[r>>2];if(D){do if((c[D+36>>2]|0)!=(c[D+4>>2]|0)){fRb(e,D,j);v=c[e>>2]|0;t=c[D+28>>2]|0;if((v|0)==-1){F=t+(c[D+32>>2]<<3)|0;break}else{F=t+(v<<3)|0;break}}else F=(c[D+28>>2]|0)+(c[D+32>>2]<<3)|0;while(0);u=c[137784]|0;if((F|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[F+4>>2]|0,(u|0)!=0):0)G=u;else y=40}else y=40;if((y|0)==40)G=hQb(c[r>>2]|0)|0;u=nNd(E,G+48|0)|0;if(u)H=u;else y=42}else y=42;while(0);do if((y|0)==42){G=(a[b+399>>0]|0)==0;E=(a[b+472>>0]|0)!=0;r=aMd()|0;if(G)if(E){H=c[r+100>>2]|0;break}else{H=c[r+104>>2]|0;break}else if(E){H=c[r+108>>2]|0;break}else{H=c[r+112>>2]|0;break}}while(0);y=b+398|0;r=c[p>>2]|0;if(!(a[y>>0]|0)){E=CSd(r,o)|0;if(E){G=SMd(E)|0;c[e>>2]=676472;c[e+4>>2]=358;c[e+8>>2]=676728;c[e+12>>2]=G;Lsd(f,692656,e);if(!(a[f>>0]&1))I=f+1|0;else I=c[f+8>>2]|0;Krd(I,0,3653512,16,1,0,0,0);xri(f)}I=c[q>>2]|0;if((c[o>>2]|0)!=(I|0)?(G=zSd(I,c[p>>2]|0)|0,(G|0)!=0):0){I=SMd(G)|0;c[e>>2]=676472;c[e+4>>2]=361;c[e+8>>2]=676816;c[e+12>>2]=I;Lsd(g,692656,e);if(!(a[g>>0]&1))J=g+1|0;else J=c[g+8>>2]|0;Krd(J,0,3653512,16,1,0,0,0);xri(g)}g=CSd(c[q>>2]|0,o)|0;if(g){J=SMd(g)|0;c[e>>2]=676472;c[e+4>>2]=363;c[e+8>>2]=676856;c[e+12>>2]=J;Lsd(f,692656,e);if(!(a[f>>0]&1))K=f+1|0;else K=c[f+8>>2]|0;Krd(K,0,3653512,16,1,0,0,0);xri(f)}if((c[o>>2]|0)!=(H|0)?(o=zSd(H,c[q>>2]|0)|0,(o|0)!=0):0){q=SMd(o)|0;c[e>>2]=676472;c[e+4>>2]=366;c[e+8>>2]=676904;c[e+12>>2]=q;Lsd(h,692656,e);if(!(a[h>>0]&1))L=h+1|0;else L=c[h+8>>2]|0;Krd(L,0,3653512,16,1,0,0,0);xri(h)}}else{h=CSd(r,n)|0;if(h){r=SMd(h)|0;c[e>>2]=676472;c[e+4>>2]=347;c[e+8>>2]=676728;c[e+12>>2]=r;Lsd(f,692656,e);if(!(a[f>>0]&1))M=f+1|0;else M=c[f+8>>2]|0;Krd(M,0,3653512,16,1,0,0,0);xri(f)}if((c[n>>2]|0)!=(H|0)?(n=zSd(H,c[p>>2]|0)|0,(n|0)!=0):0){p=SMd(n)|0;c[e>>2]=676472;c[e+4>>2]=350;c[e+8>>2]=676776;c[e+12>>2]=p;Lsd(f,692656,e);if(!(a[f>>0]&1))N=f+1|0;else N=c[f+8>>2]|0;Krd(N,0,3653512,16,1,0,0,0);xri(f)}}f=c[b+24>>2]|0;if(!f){i=d;return}b=f+32|0;N=c[b>>2]|0;if((N|0)<=0){i=d;return}e=f+24|0;f=N;N=0;while(1){p=c[(c[e>>2]|0)+(N<<3)+4>>2]|0;n=(da(c[137788]|0,(c[p+8>>2]|0)>>>21)|0)+181|0;H=n>>5;if((p|0)==0?1:(1<<n-(H<<5)&c[(c[137786]|0)+(H<<2)>>2]|0)==0)O=f;else{H=ZMd(p)|0;PSd(H,(a[y>>0]|0)==0)|0;O=c[b>>2]|0}N=N+1|0;if((N|0)>=(O|0))break;else f=O}i=d;return}function sMd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0;d=i;e=a+356|0;g[e>>2]=b;f=a+432|0;h=c[f>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)!=0:0){h=c[f>>2]|0;if(!h)j=0;else j=c[h+12>>2]|0;b=ea(g[a+352>>2]);k=ea(g[e>>2]);UNd(j,b,k,ea(g[a+360>>2]))|0}j=c[a+408>>2]|0;h=a+404|0;if((j|0)==(h|0)){i=d;return}f=a+352|0;l=a+360|0;a=j;do{j=c[(c[a+8>>2]|0)+12>>2]|0;if(!j)m=0;else m=c[j+12>>2]|0;k=ea(g[f>>2]);b=ea(g[e>>2]);UNd(m,k,b,ea(g[l>>2]))|0;a=c[a+4>>2]|0}while((a|0)!=(h|0));i=d;return}function tMd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=Im,l=0,m=0;d=i;e=a+352|0;g[e>>2]=b;f=a+432|0;h=c[f>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)!=0:0){h=c[f>>2]|0;if(!h)j=0;else j=c[h+12>>2]|0;b=ea(g[e>>2]);k=ea(g[a+356>>2]);UNd(j,b,k,ea(g[a+360>>2]))|0}j=c[a+408>>2]|0;h=a+404|0;if((j|0)==(h|0)){i=d;return}f=a+356|0;l=a+360|0;a=j;do{j=c[(c[a+8>>2]|0)+12>>2]|0;if(!j)m=0;else m=c[j+12>>2]|0;k=ea(g[e>>2]);b=ea(g[f>>2]);UNd(m,k,b,ea(g[l>>2]))|0;a=c[a+4>>2]|0}while((a|0)!=(h|0));i=d;return}function uMd(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=0,h=0,j=0,k=0,l=0,m=0;d=i;if(b<ea(0.0))e=ea(0.0);else{f=b>ea(1.0);e=f?ea(1.0):b}f=a+360|0;g[f>>2]=e;h=a+432|0;j=c[h>>2]|0;if((j|0)!=0?(c[j+12>>2]|0)!=0:0){j=c[h>>2]|0;if(!j)k=0;else k=c[j+12>>2]|0;e=ea(g[a+352>>2]);b=ea(g[a+356>>2]);UNd(k,e,b,ea(g[f>>2]))|0}k=c[a+408>>2]|0;j=a+404|0;if((k|0)==(j|0)){i=d;return}h=a+352|0;l=a+356|0;a=k;do{k=c[(c[a+8>>2]|0)+12>>2]|0;if(!k)m=0;else m=c[k+12>>2]|0;b=ea(g[h>>2]);e=ea(g[l>>2]);UNd(m,b,e,ea(g[f>>2]))|0;a=c[a+4>>2]|0}while((a|0)!=(j|0));i=d;return}function vMd(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=0,h=0,j=0,k=0,l=0,m=0;d=i;if(b<ea(0.0))e=ea(0.0);else{f=b>ea(5.0);e=f?ea(5.0):b}f=a+368|0;g[f>>2]=e;h=a+432|0;j=c[h>>2]|0;if((j|0)!=0?(c[j+12>>2]|0)!=0:0){j=c[h>>2]|0;if(!j)k=0;else k=c[j+12>>2]|0;VNd(k,ea(g[f>>2]))|0}k=c[a+408>>2]|0;j=a+404|0;if((k|0)==(j|0)){i=d;return}else l=k;do{k=c[(c[l+8>>2]|0)+12>>2]|0;if(!k)m=0;else m=c[k+12>>2]|0;VNd(m,ea(g[f>>2]))|0;l=c[l+4>>2]|0}while((l|0)!=(j|0));i=d;return}function wMd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;h=d+4|0;j=d;l=(g[k>>2]=b,c[k>>2]|0);m=a+412|0;n=c[m>>2]|0;if(!n)o=0;else{c[h>>2]=n;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(e,n,h);p=c[e>>2]|0;q=c[n+28>>2]|0;if((p|0)==-1){r=q+(c[n+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((r|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[r+4>>2]|0,(n|0)!=0):0)s=n;else t=10}else t=10;if((t|0)==10)s=hQb(c[m>>2]|0)|0;o=s}if((l&2139095040|0)==2139095040){if(!a)u=0;else u=c[a+4>>2]|0;Krd(677728,0,3653512,896,512,u,0,0);i=d;return}if((l&2147483647)>>>0>2139095040){if(!a)v=0;else v=c[a+4>>2]|0;Krd(677808,0,3653512,901,512,v,0,0);i=d;return}if(o){v=b<ea(0.0);if((v?(HJd(o)|0)!=0:0)?(c[o+48>>2]|0)!=0:0){if(!a)w=0;else w=c[a+4>>2]|0;Krd(677880,0,3653512,908,512,w,0,0);i=d;return}w=c[o+120>>2]|0;if(w){o=(c[w+40>>2]|0)==0;if(o|v)x=o?l:0;else{o=b>ea(3.0);x=o?1077936128:l}}else x=l}else x=l;l=x|0;c[a+384>>2]=l;x=a+432|0;o=c[x>>2]|0;if((o|0)!=0?(c[o+12>>2]|0)!=0:0){o=c[x>>2]|0;if(!o)y=0;else y=c[o+12>>2]|0;c[y+224>>2]=l;iOd(y)}y=c[a+408>>2]|0;o=a+404|0;if((y|0)==(o|0)){i=d;return}a=y;do{TMd(j,(c[a+8>>2]|0)+12|0);y=c[j>>2]|0;if(y){x=y+12|0;if(c[x>>2]|0){v=c[x>>2]|0;c[v+224>>2]=l;iOd(v)}v=c[y+8>>2]|0;x=y+4|0;c[x>>2]=(c[x>>2]|0)+-1;if(!(c[x>>2]|0)){ko[c[c[y>>2]>>2]&4095](y);c[f>>2]=v;c[e+0>>2]=c[f+0>>2];eOb(y,e)}c[j>>2]=0}a=c[a+4>>2]|0}while((a|0)!=(o|0));i=d;return}function xMd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if((b|0)<0)e=0;else e=(b|0)>256?256:b;b=a+364|0;c[b>>2]=e;e=a+432|0;f=c[e>>2]|0;if((f|0)!=0?(c[f+12>>2]|0)!=0:0){f=c[e>>2]|0;if(!f)g=0;else g=c[f+12>>2]|0;bOd(g,c[b>>2]|0)|0}g=c[a+408>>2]|0;f=a+404|0;if((g|0)==(f|0)){i=d;return}else h=g;do{g=c[(c[h+8>>2]|0)+12>>2]|0;if(!g)j=0;else j=c[g+12>>2]|0;bOd(j,c[b>>2]|0)|0;h=c[h+4>>2]|0}while((h|0)!=(f|0));i=d;return}function yMd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0;d=i;e=b<ea(0.0);f=a+372|0;g[f>>2]=e?ea(0.0):b;e=a+432|0;h=c[e>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)!=0:0){h=c[e>>2]|0;if(!h)j=0;else j=c[h+12>>2]|0;b=ea(g[f>>2]);WNd(j,b,ea(g[a+376>>2]))|0}j=c[a+408>>2]|0;h=a+404|0;if((j|0)==(h|0)){i=d;return}e=a+376|0;a=j;do{j=c[(c[a+8>>2]|0)+12>>2]|0;if(!j)k=0;else k=c[j+12>>2]|0;b=ea(g[f>>2]);WNd(k,b,ea(g[e>>2]))|0;a=c[a+4>>2]|0}while((a|0)!=(h|0));i=d;return}function zMd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=Im,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+372|0;f=ea(g[e>>2]);h=a+376|0;g[h>>2]=f>b?f:b;j=a+432|0;k=c[j>>2]|0;if((k|0)!=0?(c[k+12>>2]|0)!=0:0){k=c[j>>2]|0;if(!k)l=0;else l=c[k+12>>2]|0;b=ea(g[e>>2]);WNd(l,b,ea(g[h>>2]))|0}l=c[a+408>>2]|0;k=a+404|0;if((l|0)==(k|0)){i=d;return}else m=l;do{l=c[(c[m+8>>2]|0)+12>>2]|0;if(!l)n=0;else n=c[l+12>>2]|0;b=ea(g[e>>2]);WNd(n,b,ea(g[h>>2]))|0;m=c[m+4>>2]|0}while((m|0)!=(k|0));i=d;return}function AMd(a,b){a=a|0;b=ea(b);var d=0,e=Im,f=0,h=0,j=0,k=0,l=0,m=0;d=i;if(b<ea(-1.0))e=ea(-1.0);else{f=b>ea(1.0);e=f?ea(1.0):b}f=a+380|0;g[f>>2]=e;h=a+432|0;j=c[h>>2]|0;if((j|0)!=0?(c[j+12>>2]|0)!=0:0){j=c[h>>2]|0;if(!j)k=0;else k=c[j+12>>2]|0;aOd(k,ea(g[f>>2]))|0}k=c[a+408>>2]|0;j=a+404|0;if((k|0)==(j|0)){i=d;return}else l=k;do{k=c[(c[l+8>>2]|0)+12>>2]|0;if(!k)m=0;else m=c[k+12>>2]|0;aOd(m,ea(g[f>>2]))|0;l=c[l+4>>2]|0}while((l|0)!=(j|0));i=d;return}function BMd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;h=d;if(b<ea(0.0))j=ea(0.0);else{k=b>ea(1.0);j=k?ea(1.0):b}k=a+388|0;g[k>>2]=j;l=a+432|0;m=c[l>>2]|0;if((m|0)!=0?(c[m+12>>2]|0)!=0:0){m=c[l>>2]|0;if(!m)n=0;else n=c[m+12>>2]|0;g[n+216>>2]=ea(g[k>>2]);hOd(n)}n=c[a+408>>2]|0;m=a+404|0;if((n|0)==(m|0)){i=d;return}a=n;do{TMd(h,(c[a+8>>2]|0)+12|0);n=c[h>>2]|0;if(n){l=n+12|0;if(c[l>>2]|0){o=c[l>>2]|0;g[o+216>>2]=ea(g[k>>2]);hOd(o)}o=c[n+8>>2]|0;l=n+4|0;c[l>>2]=(c[l>>2]|0)+-1;if(!(c[l>>2]|0)){ko[c[c[n>>2]>>2]&4095](n);c[f>>2]=o;c[e+0>>2]=c[f+0>>2];eOb(n,e)}c[h>>2]=0}a=c[a+4>>2]|0}while((a|0)!=(m|0));i=d;return}function CMd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+4|0;h=f;j=b+432|0;k=c[j>>2]|0;if(!k){i=f;return}if(!(c[k+12>>2]|0)){i=f;return}if(a[b+474>>0]|0){k=c[j>>2]|0;if(!k)l=0;else l=c[k+12>>2]|0;QNd(l,1,g,h)|0;l=c[h>>2]|0;c[g>>2]=(c[g>>2]|0)+e+((l+d|0)>>>0<l>>>0&1);c[h>>2]=l+d;l=c[j>>2]|0;if(!l)m=0;else m=c[l+12>>2]|0;_Nd(m,1,c[g>>2]|0,c[h>>2]|0)|0}if(!(a[b+475>>0]|0)){i=f;return}b=c[j>>2]|0;if(!b)n=0;else n=c[b+12>>2]|0;QNd(n,2,g,h)|0;n=c[h>>2]|0;c[g>>2]=(c[g>>2]|0)+e+((n+d|0)>>>0<n>>>0&1);c[h>>2]=n+d;d=c[j>>2]|0;if(!d)o=0;else o=c[d+12>>2]|0;_Nd(o,2,c[g>>2]|0,c[h>>2]|0)|0;i=f;return}function DMd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e;g=e+44|0;h=e+32|0;j=e+28|0;k=e+16|0;a[b+474>>0]=0;a[b+475>>0]=0;l=b+432|0;m=c[l>>2]|0;do if(m){if(c[m+12>>2]|0){n=c[l>>2]|0;if(!n)o=0;else o=c[n+12>>2]|0;kOd(o);n=c[l>>2]|0;if(!n)break;else p=n}else p=m;c[p+12>>2]=0;n=c[p+8>>2]|0;q=p+4|0;c[q>>2]=(c[q>>2]|0)+-1;if(!(c[q>>2]|0)){ko[c[c[p>>2]>>2]&4095](p);c[g>>2]=n;c[f+0>>2]=c[g+0>>2];eOb(p,f)}c[l>>2]=0}while(0);if(d){d=b+404|0;l=b+408|0;p=c[l>>2]|0;if((p|0)!=(d|0)){m=p;o=0;while(1){n=o+1|0;m=c[m+4>>2]|0;if((m|0)==(d|0)){r=n;break}else o=n}if((r|0)<1){s=0;t=p}else{c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];p=cOb(r<<2,16,f,0,3653512,338)|0;s=p;t=c[l>>2]|0}if((t|0)==(d|0)){u=0;v=s}else{l=t;t=0;while(1){p=(c[l+8>>2]|0)+12|0;a:do if((t|0)>0){r=0;while(1){if((c[s+(r<<2)>>2]|0)==(p|0)){w=t;break a}r=r+1|0;if((r|0)>=(t|0)){x=19;break}}}else x=19;while(0);if((x|0)==19){x=0;c[s+(t<<2)>>2]=p;w=t+1|0}l=c[l+4>>2]|0;if((l|0)==(d|0)){u=w;v=s;break}else t=w}}}else{u=0;v=0}if((u|0)>0){w=0;do{t=c[c[v+(w<<2)>>2]>>2]|0;if(!t)y=0;else y=c[t+12>>2]|0;kOd(y);w=w+1|0}while((w|0)!=(u|0))}c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];eOb(v,f)}v=b+500|0;u=c[v>>2]|0;if((u|0)!=0?(w=LSd(u)|0,(w|0)!=0):0){u=SMd(w)|0;c[f>>2]=676472;c[f+4>>2]=605;c[f+8>>2]=677320;c[f+12>>2]=u;Lsd(h,692656,f);if(!(a[h>>0]&1))z=h+1|0;else z=c[h+8>>2]|0;Krd(z,0,3653512,16,1,0,0,0);xri(h)}c[j>>2]=0;h=c[v>>2]|0;if(h){z=WSd(h,j)|0;if(z){h=SMd(z)|0;c[f>>2]=676472;c[f+4>>2]=609;c[f+8>>2]=677664;c[f+12>>2]=h;Lsd(g,692656,f);if(!(a[g>>0]&1))A=g+1|0;else A=c[g+8>>2]|0;Krd(A,0,3653512,16,1,0,0,0);xri(g)}A=c[j>>2]|0;if(A)c[A+16>>2]=0}c[v>>2]=0;if((c[b+408>>2]|0)!=(b+404|0)){i=e;return}c[k>>2]=0;v=k+4|0;c[v>>2]=0;c[k+8>>2]=0;if(GMd(b,k,0)|0?(A=c[k>>2]|0,(A|0)!=(c[v>>2]|0)):0){j=g+1|0;h=g+8|0;z=A;while(1){A=LSd(c[z>>2]|0)|0;if(A){u=SMd(A)|0;c[f>>2]=676472;c[f+4>>2]=624;c[f+8>>2]=677712;c[f+12>>2]=u;Lsd(g,692656,f);Krd((a[g>>0]&1)==0?j:c[h>>2]|0,0,3653512,16,1,0,0,0);xri(g)}u=z+4|0;if((u|0)==(c[v>>2]|0)){B=u;C=z;break}else z=u}z=c[k>>2]|0;if((B|0)!=(z|0))c[v>>2]=C+(0-((C-z|0)>>>2)<<2)}KLd(aMd()|0,b);b=c[k>>2]|0;if(!b){i=e;return}k=c[v>>2]|0;if((k|0)!=(b|0))c[v>>2]=k+(~((k+-4-b|0)>>>2)<<2);ACi(b);i=e;return}function EMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+48|0;e=d;f=d+28|0;g=d+16|0;h=b+464|0;if((c[h>>2]|0)==0?(j=FTd(c[(aMd()|0)+92>>2]|0,676456,h)|0,(j|0)!=0):0){h=SMd(j)|0;c[e>>2]=676472;c[e+4>>2]=297;c[e+8>>2]=676536;c[e+12>>2]=h;Lsd(g,692656,e);if(!(a[g>>0]&1))k=g+1|0;else k=c[g+8>>2]|0;Krd(k,0,3653512,16,1,0,0,0);xri(g)}g=b+468|0;if(c[g>>2]|0){rMd(b);i=d;return}k=FTd(c[(aMd()|0)+92>>2]|0,676624,g)|0;if(!k){rMd(b);i=d;return}g=SMd(k)|0;c[e>>2]=676472;c[e+4>>2]=304;c[e+8>>2]=676640;c[e+12>>2]=g;Lsd(f,692656,e);if(!(a[f>>0]&1))l=f+1|0;else l=c[f+8>>2]|0;Krd(l,0,3653512,16,1,0,0,0);xri(f);rMd(b);i=d;return}function FMd(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0;e=i;i=i+128|0;f=e;g=e+60|0;h=e+16|0;j=e+36|0;k=e+24|0;l=e+28|0;m=e+32|0;n=e+20|0;o=e+40|0;p=e+44|0;q=e+56|0;r=e+72|0;s=e+84|0;t=e+88|0;u=e+100|0;v=e+104|0;w=e+108|0;x=e+112|0;y=e+124|0;if(a[(aMd()|0)+204>>0]|0){i=e;return}if(!(a[b+29>>0]|0)){if(!b)z=0;else z=c[b+4>>2]|0;Krd(676944,0,3653512,388,512,z,0,0);i=e;return}EMd(b);z=b+416|0;A=c[z>>2]|0;do if(A){c[n>>2]=A;B=c[137784]|0;if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(f,B,n);C=c[f>>2]|0;D=c[B+28>>2]|0;if((C|0)==-1){E=D+(c[B+32>>2]<<3)|0;break}else{E=D+(C<<3)|0;break}}else E=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);B=c[137784]|0;if((E|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(c[E+4>>2]|0)!=0:0)F=B;else G=15}else G=15;if((G|0)==15){if(!(hQb(c[z>>2]|0)|0))break;F=c[137784]|0}c[m>>2]=c[z>>2];if(F){do if((c[F+36>>2]|0)!=(c[F+4>>2]|0)){fRb(f,F,m);B=c[f>>2]|0;C=c[F+28>>2]|0;if((B|0)==-1){H=C+(c[F+32>>2]<<3)|0;break}else{H=C+(B<<3)|0;break}}else H=(c[F+28>>2]|0)+(c[F+32>>2]<<3)|0;while(0);B=c[137784]|0;if((H|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(B=c[H+4>>2]|0,(B|0)!=0):0)I=B;else G=25}else G=25;if((G|0)==25)I=hQb(c[z>>2]|0)|0;B=c[I+44>>2]|0;if(B){c[l>>2]=B;C=c[137784]|0;if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(f,C,l);D=c[f>>2]|0;J=c[C+28>>2]|0;if((D|0)==-1){K=J+(c[C+32>>2]<<3)|0;break}else{K=J+(D<<3)|0;break}}else K=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);C=c[137784]|0;if((K|0)!=((c[C+28>>2]|0)+(c[C+32>>2]<<3)|0)?(C=c[K+4>>2]|0,(C|0)!=0):0)L=C;else G=35}else G=35;if((G|0)==35){C=hQb(B)|0;if(!C)break;else L=C}oNd(L)}}while(0);L=b+412|0;K=c[L>>2]|0;do if(K){c[k>>2]=K;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,k);I=c[f>>2]|0;z=c[l+28>>2]|0;if((I|0)==-1){M=z+(c[l+32>>2]<<3)|0;break}else{M=z+(I<<3)|0;break}}else M=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((M|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[M+4>>2]|0,(l|0)!=0):0)N=l;else G=46}else G=46;if((G|0)==46){l=hQb(c[L>>2]|0)|0;if(!l){O=0;P=0;break}else N=l}if(!(mo[c[(c[N>>2]|0)+92>>2]&4095](N)|0)){CJd(N)|0;O=N;P=1}else{O=N;P=1}}else{O=0;P=0}while(0);N=b+432|0;L=c[N>>2]|0;a:do if(L){do if(!(c[L+12>>2]|0))Q=L;else{M=c[N>>2]|0;if(!M)R=0;else R=c[M+12>>2]|0;ZNd(R,c[b+464>>2]|0)|0;if(!(a[(c[(c[N>>2]|0)+12>>2]|0)+232>>0]|0)){DMd(b,0);M=c[N>>2]|0;if(!M){G=61;break a}else{Q=M;break}}qMd(b);if(!(a[(aMd()|0)+36>>0]|0))S=0;else S=(a[b+401>>0]|0)==0;M=c[N>>2]|0;if(!M)T=0;else T=c[M+12>>2]|0;a[T+232>>0]=S&1;jOd(T);HLd(aMd()|0,b,S);i=e;return}while(0);if(!(c[Q+12>>2]|0))G=61}else G=61;while(0);do if((G|0)==61){if(P){GJd(o,O,1,0,0);Q=c[o>>2]|0;if(Q){S=Q+4|0;c[S>>2]=(c[S>>2]|0)+1}S=c[N>>2]|0;if((S|0)!=0?(Q=c[S+8>>2]|0,T=S+4|0,c[T>>2]=(c[T>>2]|0)+-1,(c[T>>2]|0)==0):0){ko[c[c[S>>2]>>2]&4095](S);c[j>>2]=Q;c[f+0>>2]=c[j+0>>2];eOb(S,f)}S=c[o>>2]|0;c[N>>2]=S;if(!S){i=e;return}Q=c[S+8>>2]|0;T=S+4|0;c[T>>2]=(c[T>>2]|0)+-1;if(!(c[T>>2]|0)){ko[c[c[S>>2]>>2]&4095](S);c[g>>2]=Q;c[f+0>>2]=c[g+0>>2];eOb(S,f)}c[o>>2]=0;S=c[N>>2]|0;if(!S){i=e;return}if(!(c[S+12>>2]|0))break;S=O+112|0;c[S>>2]=(c[S>>2]|0)+1;c[(c[(c[N>>2]|0)+12>>2]|0)+236>>2]=b;break}c[p>>2]=0;S=p+4|0;c[S>>2]=0;c[p+8>>2]=0;do if(GMd(b,p,1)|0){c[q>>2]=0;WSd(c[c[p>>2]>>2]|0,q)|0;Q=c[q>>2]|0;if(!Q){T=c[b+24>>2]|0;if(!T)U=3653512;else U=mo[c[(c[T>>2]|0)+32>>2]&4095](T)|0;c[f>>2]=U;Lsd(x,677512,f);if(!(a[x>>0]&1))V=x+1|0;else V=c[x+8>>2]|0;Krd(V,0,3653512,479,512,0,0,0);xri(x);break}if(c[Q+20>>2]|0){Lsd(r,676984,f);if(!b)W=0;else W=c[b+4>>2]|0;if(!(a[r>>0]&1))X=r+1|0;else X=c[r+8>>2]|0;Krd(X,0,3653512,449,512,W,0,0);xri(r);T=c[p>>2]|0;if(!T){i=e;return}R=c[S>>2]|0;if((R|0)!=(T|0))c[S>>2]=R+(~((R+-4-T|0)>>>2)<<2);ACi(T);i=e;return}c[Q+16>>2]=b;Q=c[c[p>>2]>>2]|0;c[b+500>>2]=Q;T=LSd(Q)|0;if(T){Q=SMd(T)|0;c[f>>2]=676472;c[f+4>>2]=454;c[f+8>>2]=677320;c[f+12>>2]=Q;Lsd(g,692656,f);if(!(a[g>>0]&1))Y=g+1|0;else Y=c[g+8>>2]|0;Krd(Y,0,3653512,16,1,0,0,0);xri(g)}Q=c[(aMd()|0)+92>>2]|0;T=ITd(Q,-1,c[c[p>>2]>>2]|0,1,s)|0;if((T|0)==10){if(!b)Z=0;else Z=c[b+4>>2]|0;Krd(684424,0,3653512,458,512,Z,0,0);break}else if(!T){Q=rSd(c[s>>2]|0,82)|0;if(Q){R=SMd(Q)|0;c[f>>2]=676472;c[f+4>>2]=464;c[f+8>>2]=677344;c[f+12>>2]=R;Lsd(g,692656,f);if(!(a[g>>0]&1))_=g+1|0;else _=c[g+8>>2]|0;Krd(_,0,3653512,16,1,0,0,0);xri(g)}R=pTd(c[(aMd()|0)+92>>2]|0,u,0,0,0,0,0)|0;if(R){Q=SMd(R)|0;c[f>>2]=676472;c[f+4>>2]=467;c[f+8>>2]=677376;c[f+12>>2]=Q;Lsd(g,692656,f);if(!(a[g>>0]&1))$=g+1|0;else $=c[g+8>>2]|0;Krd($,0,3653512,16,1,0,0,0);xri(g)}Q=_Rd(c[s>>2]|0,ea(c[u>>2]|0))|0;if(Q){R=SMd(Q)|0;c[f>>2]=676472;c[f+4>>2]=468;c[f+8>>2]=677472;c[f+12>>2]=R;Lsd(g,692656,f);if(!(a[g>>0]&1))aa=g+1|0;else aa=c[g+8>>2]|0;Krd(aa,0,3653512,16,1,0,0,0);xri(g)}yOd(w);UMd(v,w,1);R=c[v>>2]|0;if(R){Q=R+4|0;c[Q>>2]=(c[Q>>2]|0)+1}Q=c[N>>2]|0;if((Q|0)!=0?(R=c[Q+8>>2]|0,L=Q+4|0,c[L>>2]=(c[L>>2]|0)+-1,(c[L>>2]|0)==0):0){ko[c[c[Q>>2]>>2]&4095](Q);c[h>>2]=R;c[f+0>>2]=c[h+0>>2];eOb(Q,f)}Q=c[v>>2]|0;c[N>>2]=Q;if(Q){R=c[Q+8>>2]|0;L=Q+4|0;c[L>>2]=(c[L>>2]|0)+-1;if(!(c[L>>2]|0)){ko[c[c[Q>>2]>>2]&4095](Q);c[g>>2]=R;c[f+0>>2]=c[g+0>>2];eOb(Q,f)}c[v>>2]=0}BOd(w);Q=c[N>>2]|0;if(!Q)break;if(!(c[Q+12>>2]|0))break;Q=c[N>>2]|0;if(!Q)ba=0;else ba=c[Q+12>>2]|0;ONd(ba,c[s>>2]|0);c[(c[(c[N>>2]|0)+12>>2]|0)+236>>2]=b;break}else{c[f>>2]=SMd(T)|0;Lsd(t,684480,f);if(!b)ca=0;else ca=c[b+4>>2]|0;if(!(a[t>>0]&1))da=t+1|0;else da=c[t+8>>2]|0;Krd(da,0,3653512,460,1,ca,0,0);xri(t);break}}while(0);T=c[p>>2]|0;if(T){Q=c[S>>2]|0;if((Q|0)!=(T|0))c[S>>2]=Q+(~((Q+-4-T|0)>>>2)<<2);ACi(T)}}while(0);p=c[N>>2]|0;if(!p){i=e;return}if(!(c[p+12>>2]|0)){i=e;return}p=c[N>>2]|0;if(!p)fa=0;else fa=c[p+12>>2]|0;ZNd(fa,c[b+464>>2]|0)|0;HMd(b);qMd(b);TMd(y,N);VMd(b,y)|0;fa=c[y>>2]|0;if(fa){p=c[fa+8>>2]|0;t=fa+4|0;c[t>>2]=(c[t>>2]|0)+-1;if(!(c[t>>2]|0)){ko[c[c[fa>>2]>>2]&4095](fa);c[g>>2]=p;c[f+0>>2]=c[g+0>>2];eOb(fa,f)}c[y>>2]=0}y=c[N>>2]|0;if(!y)ga=0;else ga=c[y+12>>2]|0;eOd(ga,c[b+492>>2]|0)|0;QLd(aMd()|0,b,d);a[b+496>>0]=0;if(!(a[(aMd()|0)+36>>0]|0))ha=0;else ha=(a[b+401>>0]|0)==0;HLd(aMd()|0,b,ha);i=e;return}function GMd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f;h=c[b+24>>2]|0;if(!h){j=0;i=f;return j|0}b=h+32|0;if((c[b>>2]|0)>0){k=h+24|0;h=d+4|0;l=d+8|0;m=0;do{c[g>>2]=0;n=c[(c[k>>2]|0)+(m<<3)+4>>2]|0;o=(da(c[137788]|0,(c[n+8>>2]|0)>>>21)|0)+181|0;p=o>>5;if((!((n|0)==0?1:(1<<o-(p<<5)&c[(c[137786]|0)+(p<<2)>>2]|0)==0)?(a[(NOc()|0)+94>>0]|0)!=0:0)?(p=ZMd(n)|0,c[g>>2]=p,(p|0)!=0):0){q=p;r=13}else r=8;if((r|0)==8?(r=0,p=c[(c[k>>2]|0)+(m<<3)+4>>2]|0,n=(da(c[137788]|0,(c[p+8>>2]|0)>>>21)|0)+114|0,o=n>>5,!((p|0)==0?1:(1<<n-(o<<5)&c[(c[137786]|0)+(o<<2)>>2]|0)==0)):0){if(e)s=p9c(p)|0;else s=q9c(p)|0;c[g>>2]=s;if(s){q=s;r=13}}do if((r|0)==13){r=0;p=c[h>>2]|0;if((p|0)==(c[l>>2]|0)){WMd(d,g);break}if(!p)t=0;else{c[p>>2]=q;t=c[h>>2]|0}c[h>>2]=t+4}while(0);m=m+1|0}while((m|0)<(c[b>>2]|0));u=h}else u=d+4|0;j=(c[d>>2]|0)!=(c[u>>2]|0);i=f;return j|0}function HMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d;f=d+40|0;g=d+28|0;h=d+16|0;j=b+468|0;if(!(c[j>>2]|0)){i=d;return}c[h>>2]=0;k=h+4|0;c[k>>2]=0;c[h+8>>2]=0;GMd(b,h,1)|0;l=c[h>>2]|0;if((l|0)==(c[k>>2]|0)){m=l;n=l}else{o=b+500|0;b=g+1|0;p=g+8|0;q=f+1|0;r=f+8|0;s=l;while(1){l=c[s>>2]|0;if((l|0)!=(c[o>>2]|0)){t=LSd(l)|0;if(t){u=SMd(t)|0;c[e>>2]=676472;c[e+4>>2]=1375;c[e+8>>2]=677712;c[e+12>>2]=u;Lsd(f,692656,e);Krd((a[f>>0]&1)==0?q:c[r>>2]|0,0,3653512,16,1,0,0,0);xri(f)}u=ESd(c[j>>2]|0,l,0)|0;if(u){l=SMd(u)|0;c[e>>2]=676472;c[e+4>>2]=1376;c[e+8>>2]=678080;c[e+12>>2]=l;Lsd(g,692656,e);Krd((a[g>>0]&1)==0?b:c[p>>2]|0,0,3653512,16,1,0,0,0);xri(g)}}l=s+4|0;if((l|0)==(c[k>>2]|0)){v=l;break}else s=l}m=c[h>>2]|0;n=v}if(!m){i=d;return}if((n|0)!=(m|0))c[k>>2]=n+(~((n+-4-m|0)>>>2)<<2);ACi(m);i=d;return}function IMd(b){b=b|0;var d=0,e=0;d=i;a[b+496>>0]=1;e=b+432|0;b=c[e>>2]|0;if(!b){i=d;return}if(!(c[b+12>>2]|0)){i=d;return}b=c[(c[e>>2]|0)+12>>2]|0;a[b+232>>0]=1;jOd(b);i=d;return}function JMd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+408>>2]|0;f=b+404|0;if((e|0)==(f|0)){i=d;return}else g=e;do{e=c[(c[(c[g+8>>2]|0)+12>>2]|0)+12>>2]|0;a[e+232>>0]=1;jOd(e);g=c[g+4>>2]|0}while((g|0)!=(f|0));i=d;return}function KMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[b+408>>2]|0;f=b+404|0;if((e|0)==(f|0)){i=d;return}g=b+401|0;b=e;do{e=c[(c[b+8>>2]|0)+12>>2]|0;if(!e)h=0;else h=c[e+12>>2]|0;if(!(a[(aMd()|0)+36>>0]|0))j=0;else j=a[g>>0]^1;a[h+232>>0]=j;jOd(h);b=c[b+4>>2]|0}while((b|0)!=(f|0));i=d;return}function LMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+16|0;DMd(b,1);g=c[b+24>>2]|0;if((g|0)!=0?(h=g+32|0,(c[h>>2]|0)>0):0){j=g+24|0;g=0;do{k=c[(c[j>>2]|0)+(g<<3)+4>>2]|0;do if(k){l=(da(c[137788]|0,(c[k+8>>2]|0)>>>21)|0)+181|0;m=l>>5;if(1<<l-(m<<5)&c[(c[137786]|0)+(m<<2)>>2]){YMd(k);break}m=(da(c[137788]|0,(c[k+8>>2]|0)>>>21)|0)+114|0;l=m>>5;if((1<<m-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0?(l=c[k+132>>2]|0,(l|0)!=0):0)aNd(l)}while(0);g=g+1|0}while((g|0)<(c[h>>2]|0))}h=b+464|0;g=c[h>>2]|0;if(g){j=uSd(g)|0;if(j){g=SMd(j)|0;c[e>>2]=676472;c[e+4>>2]=576;c[e+8>>2]=677616;c[e+12>>2]=g;Lsd(f,692656,e);if(!(a[f>>0]&1))n=f+1|0;else n=c[f+8>>2]|0;Krd(n,0,3653512,16,1,0,0,0);xri(f)}c[h>>2]=0}h=b+468|0;b=c[h>>2]|0;if(!b){i=d;return}n=uSd(b)|0;if(n){b=SMd(n)|0;c[e>>2]=676472;c[e+4>>2]=582;c[e+8>>2]=677640;c[e+12>>2]=b;Lsd(f,692656,e);if(!(a[f>>0]&1))o=f+1|0;else o=c[f+8>>2]|0;Krd(o,0,3653512,16,1,0,0,0);xri(f)}c[h>>2]=0;i=d;return}function MMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=b+432|0;g=c[f>>2]|0;if((g|0)!=0?(c[g+12>>2]|0)!=0:0){g=c[f>>2]|0;if(!g)h=0;else h=c[g+12>>2]|0;if(!(RNd(h,e)|0))if(a[b+496>>0]|0)if(!(a[e>>0]|0))j=0;else j=(a[(c[(c[f>>2]|0)+12>>2]|0)+232>>0]|0)==0;else j=1;else j=0}else j=0;i=d;return j|0}function NMd(a){a=a|0;var b=Im;b=ea(g[a+372>>2]);return ea(b)}function OMd(a){a=a|0;var b=Im;b=ea(g[a+376>>2]);return ea(b)}function PMd(a){a=a|0;return c[a+392>>2]|0}function QMd(a){a=a|0;return a+272|0}function RMd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+432|0;k=c[j>>2]|0;if(!((k|0)==0?1:(k|0)!=(c[d>>2]|0))){c[k+12>>2]=0;l=c[k+8>>2]|0;m=k+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0)){ko[c[c[k>>2]>>2]&4095](k);c[g>>2]=l;c[f+0>>2]=c[g+0>>2];eOb(k,f)}c[j>>2]=0}a[b+474>>0]=0;a[b+475>>0]=0;LLd(aMd()|0,b);j=c[b+408>>2]|0;k=b+404|0;if((j|0)==(k|0)){i=e;return}b=j;do{j=b;b=c[b+4>>2]|0;l=c[j+8>>2]|0;j=l+12|0;m=c[j>>2]|0;if((m|0)==(c[d>>2]|0)){n=c[153086]|0;o=c[l>>2]|0;if(o){p=l+4|0;c[o+4>>2]=c[p>>2];c[c[p>>2]>>2]=o;c[l>>2]=0;c[p>>2]=0}if(m){p=c[m+8>>2]|0;o=m+4|0;c[o>>2]=(c[o>>2]|0)+-1;if(!(c[o>>2]|0)){ko[c[c[m>>2]>>2]&4095](m);c[g>>2]=p;c[f+0>>2]=c[g+0>>2];eOb(m,f)}c[j>>2]=0}c[h>>2]=n;c[f+0>>2]=c[h+0>>2];eOb(l,f)}}while((b|0)!=(k|0));i=e;return}function SMd(a){a=a|0;var b=0,c=0;b=i;do switch(a|0){case 12:{c=685360;break}case 85:{c=686528;break}case 84:{c=686472;break}case 54:{c=689688;break}case 55:{c=689776;break}case 56:{c=689896;break}case 28:{c=687624;break}case 89:{c=687008;break}case 90:{c=686920;break}case 60:{c=690296;break}case 61:{c=690336;break}case 62:{c=690440;break}case 2:{c=684816;break}case 33:{c=687872;break}case 34:{c=687936;break}case 25:{c=687424;break}case 51:{c=689472;break}case 52:{c=689568;break}case 53:{c=689616;break}case 45:{c=688696;break}case 95:{c=688752;break}case 94:{c=688816;break}case 24:{c=687392;break}case 76:{c=692024;break}case 77:{c=692088;break}case 78:{c=692240;break}case 79:{c=692320;break}case 14:{c=685568;break}case 19:{c=687096;break}case 39:{c=688248;break}case 40:{c=688336;break}case 66:{c=690728;break}case 67:{c=690792;break}case 68:{c=690888;break}case 18:{c=686072;break}case 16:{c=685816;break}case 32:{c=687824;break}case 88:{c=686872;break}case 30:{c=687728;break}case 5:{c=685064;break}case 26:{c=687464;break}case 31:{c=687760;break}case 23:{c=687368;break}case 17:{c=685880;break}case 1:{c=684752;break}case 92:{c=686176;break}case 48:{c=689104;break}case 49:{c=689232;break}case 50:{c=689424;break}case 43:{c=688528;break}case 44:{c=688568;break}case 8:{c=685176;break}case 10:{c=685256;break}case 27:{c=687552;break}case 20:{c=687120;break}case 75:{c=691328;break}case 72:{c=691616;break}case 73:{c=691768;break}case 74:{c=691888;break}case 3:{c=684952;break}case 6:{c=685104;break}case 35:{c=688040;break}case 36:{c=688096;break}case 41:{c=688392;break}case 42:{c=688456;break}case 83:{c=686312;break}case 9:{c=685224;break}case 7:{c=685144;break}case 11:{c=685296;break}case 37:{c=688136;break}case 38:{c=688192;break}case 13:{c=685512;break}case 29:{c=687696;break}case 4:{c=685e3;break}case 63:{c=690536;break}case 64:{c=690592;break}case 65:{c=690664;break}case 57:{c=689936;break}case 58:{c=690072;break}case 59:{c=690192;break}case 86:{c=686600;break}case 21:{c=687232;break}case 22:{c=687272;break}case 80:{c=692400;break}case 81:{c=692512;break}case 82:{c=692560;break}case 0:{c=692624;break}case 91:{c=686424;break}case 69:{c=691008;break}case 70:{c=691120;break}case 71:{c=691184;break}case 87:{c=686704;break}case 93:{c=688864;break}case 46:{c=688944;break}case 47:{c=689024;break}case 15:{c=685712;break}default:c=692640}while(0);i=b;return c|0}function TMd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;g=c[b>>2]|0;if(((g|0)!=0?(h=g+4|0,c[h>>2]=(c[h>>2]|0)+1,h=c[a>>2]|0,(h|0)!=0):0)?(g=c[h+8>>2]|0,j=h+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[a>>2]=c[b>>2];i=d;return}function UMd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=c[153086];c[f+0>>2]=c[g+0>>2];g=bOb(248,f,0,16,3653512,307)|0;zOd(h,b);LNd(g,h,d);XMd(a,g);BOd(h);i=e;return}function VMd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=Im,I=0,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=Im;e=i;i=i+160|0;f=e+32|0;h=e+48|0;j=e+148|0;k=e;l=e+88|0;m=e+112|0;n=e+124|0;o=e+136|0;p=e+16|0;q=e+64|0;r=e+40|0;s=e+72|0;t=e+56|0;u=e+104|0;a[j>>0]=0;v=c[d>>2]|0;if(!v){w=0;i=e;return w|0}if(!(c[v+12>>2]|0)){w=0;i=e;return w|0}v=c[d>>2]|0;if(!v)x=0;else x=c[v+12>>2]|0;if((RNd(x,j)|0)==36){w=0;i=e;return w|0}j=b+24|0;rGc(k,BTb(c[j>>2]|0)|0);g[l>>2]=ea(0.0);x=l+4|0;g[x>>2]=ea(0.0);v=l+8|0;g[v>>2]=ea(0.0);y=ATb(c[j>>2]|0,54)|0;if(!y){z=ea(g[k>>2]);A=ea(z-ea(g[b+480>>2]));z=ea(g[k+4>>2]);B=ea(z-ea(g[b+484>>2]));z=ea(g[k+8>>2]);C=ea(z-ea(g[b+488>>2]));z=ea(g[(jLc()|0)+116>>2]);D=ea(B*z);B=ea(C*z);g[l>>2]=ea(A*z);g[x>>2]=D;g[v>>2]=B}else{v=tLc()|0;co[c[(c[v>>2]|0)+8>>2]&2047](m,v,y);c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2]}oGc(p,BTb(c[j>>2]|0)|0);EMc(o,p);B=ea(g[o>>2]);D=ea(B*B);B=ea(g[o+4>>2]);z=ea(D+ea(B*B));B=ea(g[o+8>>2]);D=ea(T(ea(z+ea(B*B))));if(D>ea(g[150276])){c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];g[n>>2]=ea(ea(g[n>>2])/D);o=n+4|0;g[o>>2]=ea(ea(g[o>>2])/D);o=n+8|0;g[o>>2]=ea(ea(g[o>>2])/D)}else{c[n+0>>2]=c[150284];c[n+4>>2]=c[150285];c[n+8>>2]=c[150286]}o=c[d>>2]|0;if(!o)E=0;else E=c[o+12>>2]|0;TNd(E,n)|0;n=c[d>>2]|0;if(!n)F=0;else F=c[n+12>>2]|0;SNd(F,k,l)|0;l=PLd(aMd()|0)|0;if(l){D=ea(g[k>>2]);B=ea(D-ea(g[l+32>>2]));D=ea(g[k+4>>2]);z=ea(D-ea(g[l+36>>2]));D=ea(g[k+8>>2]);A=ea(D-ea(g[l+40>>2]));D=ea(T(ea(ea(ea(B*B)+ea(z*z))+ea(A*A))));l=b+32|0;if((c[b+96>>2]|0)==1){F=c[d>>2]|0;if(!F)G=0;else G=c[F+12>>2]|0;XNd(G,ea(g[(c[b+88>>2]|0)+4>>2]))|0}else{TMc(q,l);A=ea(D/ea(g[b+376>>2]));z=ea(g[q>>2]);if(A<z)H=z;else{z=ea(g[q+4>>2]);H=A>z?z:A}A=ea(UMc(l,H));l=c[d>>2]|0;if(!l)I=0;else I=c[l+12>>2]|0;XNd(I,A)|0}I=b+112|0;if((c[b+176>>2]|0)==1)J=ea(g[(c[b+168>>2]|0)+4>>2]);else{TMc(r,I);A=ea(D/ea(g[b+376>>2]));H=ea(g[r>>2]);if(A<H)K=H;else{H=ea(g[r+4>>2]);K=A>H?H:A}J=ea(UMc(I,K))}K=(a[b+400>>0]|0)==0?J:ea(0.0);I=c[d>>2]|0;if(!I)L=0;else L=c[I+12>>2]|0;dOd(L,s)|0;do if(!(K>ea(1.0)))if(K>ea(0.0)){c[s+4>>2]=~~ea(ea(aEi(K))*ea(2.0e3));break}else{c[s+4>>2]=-1e4;break}else c[s+4>>2]=~~ea(ea(K+ea(-1.0))*ea(1.0e4));while(0);L=c[d>>2]|0;if(!L)M=0;else M=c[L+12>>2]|0;cOd(M,s)|0;s=b+412|0;M=c[s>>2]|0;do if(M){c[h>>2]=M;L=c[137784]|0;do if(L){do if((c[L+36>>2]|0)!=(c[L+4>>2]|0)){fRb(f,L,h);I=c[f>>2]|0;r=c[L+28>>2]|0;if((I|0)==-1){N=r+(c[L+32>>2]<<3)|0;break}else{N=r+(I<<3)|0;break}}else N=(c[L+28>>2]|0)+(c[L+32>>2]<<3)|0;while(0);I=c[137784]|0;if((N|0)==((c[I+28>>2]|0)+(c[I+32>>2]<<3)|0)){O=49;break}if(!(c[N+4>>2]|0))O=49}else O=49;while(0);if((O|0)==49?(hQb(c[s>>2]|0)|0)==0:0)break;L=b+192|0;if((c[b+256>>2]|0)==1){I=c[d>>2]|0;if(!I)P=0;else P=c[I+12>>2]|0;YNd(P,ea(ea(g[(c[b+248>>2]|0)+4>>2])*ea(360.0)))|0;break}TMc(t,L);K=ea(D/ea(g[b+376>>2]));J=ea(g[t>>2]);if(K<J)Q=J;else{J=ea(g[t+4>>2]);Q=K>J?J:K}K=ea(UMc(L,Q));L=c[d>>2]|0;if(!L)R=0;else R=c[L+12>>2]|0;YNd(R,ea(K*ea(360.0)))|0}while(0);R=CTb(c[j>>2]|0,169)|0;if((R|0)!=0?(j=gLd(R)|0,(c[j+64>>2]|0)>1):0){TMc(u,j);Q=ea(D/ea(g[b+376>>2]));D=ea(g[u>>2]);if(Q<D)S=D;else{D=ea(g[u+4>>2]);S=Q>D?D:Q}g[R+120>>2]=ea(ea(22.0e3)-ea(ea(UMc(j,S))*ea(21990.0)));ko[c[(c[R>>2]|0)+108>>2]&4095](R)}}R=b+480|0;c[R+0>>2]=c[k+0>>2];c[R+4>>2]=c[k+4>>2];c[R+8>>2]=c[k+8>>2];w=1;i=e;return w|0}function WMd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function XMd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;if(!b){i=d;return}g=b+244|0;b=c[g>>2]|0;if(((b|0)!=0?(h=b+4|0,c[h>>2]=(c[h>>2]|0)+1,h=c[a>>2]|0,(h|0)!=0):0)?(b=c[h+8>>2]|0,j=h+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=b;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[a>>2]=c[g>>2];i=d;return}function YMd(a){a=a|0;var b=0,d=0;b=i;d=a+36|0;a=c[d>>2]|0;if(!a){i=b;return}HSd(a)|0;c[d>>2]=0;i=b;return}function ZMd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+36|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}f=b+32|0;if((c[f>>2]|0)==65536){g=0;i=d;return g|0}h=c[(aMd()|0)+92>>2]|0;ETd(h,c[f>>2]|0,e)|0;RSd(c[e>>2]|0,(a[b+28>>0]|0)==0)|0;g=c[e>>2]|0;i=d;return g|0}function _Md(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+96|0;f=e;c[b>>2]=678288;g=b+4|0;c[g>>2]=0;c[b+8>>2]=d;a[b+12>>0]=0;a[b+13>>0]=0;c[b+16>>2]=0;c[b+20>>2]=0;d=f+52|0;h=f+0|0;j=h+88|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));c[d>>2]=112;c[f+88>>2]=b;nKd(DTd(c[(aMd()|0)+92>>2]|0,f,g)|0,678296,68,678368)|0;RSd(c[g>>2]|0,1)|0;i=e;return}function $Md(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=678288;d=a+4|0;e=c[d>>2]|0;if(!e){i=b;return}f=c[a+16>>2]|0;if(!f)g=e;else{DMd(f,1);g=c[d>>2]|0}nKd(HSd(g)|0,678296,89,678432)|0;c[d>>2]=0;i=b;return}function aNd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;e=c[d>>2]|0;if(!e){i=b;return}f=c[a+16>>2]|0;if(!f)g=e;else{DMd(f,1);g=c[d>>2]|0}nKd(HSd(g)|0,678296,89,678432)|0;c[d>>2]=0;i=b;return}function bNd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=678288;d=a+4|0;e=c[d>>2]|0;if(!e){ACi(a);i=b;return}f=c[a+16>>2]|0;if(!f)g=e;else{DMd(f,1);g=c[d>>2]|0}nKd(HSd(g)|0,678296,89,678432)|0;ACi(a);i=b;return}function cNd(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function dNd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+96|0;d=b;e=a+4|0;f=c[e>>2]|0;if(f){g=f;i=b;return g|0}f=d+52|0;h=d+0|0;j=h+88|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));c[f>>2]=112;c[d+88>>2]=a;nKd(DTd(c[(aMd()|0)+92>>2]|0,d,e)|0,678296,68,678368)|0;RSd(c[e>>2]|0,1)|0;g=c[e>>2]|0;i=b;return g|0}function eNd(a){a=a|0;return c[a+4>>2]|0}function fNd(a){a=a|0;var b=0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;gNd(a);i=b;return}function gNd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[(aMd()|0)+92>>2]|0;rTd(g,d,0)|0;pTd(g,0,0,e,f,0,0)|0;g=c[e>>2]|0;e=c[f>>2]|0;f=da((g|0)<(e|0)?e:g,c[d>>2]|0)|0;d=a+8|0;c[d>>2]=4096;g=c[(Xbd()|0)+212>>2]|0;e=Isc(g,4,c[d>>2]|0)|0;c[a>>2]=e;c[a+4>>2]=Bsc(e)|0;c[a+20>>2]=f;e=Isc(g,4,f)|0;c[a+12>>2]=e;c[a+16>>2]=Bsc(e)|0;i=b;return}function hNd(a){a=a|0;return}function iNd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((yrc(c[a>>2]|0)|0)==(b|0)){f=c[a>>2]|0;c[d>>2]=f;i=e;return}else{g=c[(Xbd()|0)+212>>2]|0;h=Gsc(c[a>>2]|0,0,4)|0;a=(h|0)==0?0:b;b=Isc(g,4,a)|0;YEi(Gsc(b,0,4)|0,h|0,a<<2|0)|0;f=b;c[d>>2]=f;i=e;return}}function jNd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+64|0;e=c[d>>2]|0;if(!e){i=b;return}f=c[a+60>>2]|0;uNd(e,f,c[(aMd()|0)+92>>2]|0,a+28|0);c[d>>2]=0;i=b;return}function kNd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+64|0;if(c[e>>2]|0){f=1;i=d;return f|0}g=b+60|0;h=c[g>>2]|0;if(!h){j=mo[c[(c[b>>2]|0)+128>>2]&4095](b)|0;c[g>>2]=j;if(!j){f=0;i=d;return f|0}else k=j}else k=h;h=c[(aMd()|0)+92>>2]|0;j=mo[c[(c[b>>2]|0)+112>>2]&4095](b)|0;l=sNd(k,h,b+28|0,j,(a[b+88>>0]|0)!=0)|0;c[e>>2]=l;if(!l){f=0;i=d;return f|0}ko[c[(c[b>>2]|0)+116>>2]&4095](b);lNd(b);yNd(c[g>>2]|0,c[e>>2]|0);f=1;i=d;return f|0}function lNd(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=b+60|0;g=c[f>>2]|0;h=g+4|0;j=h+(c[h>>2]|0)|0;c[g+8>>2]=j;h=c[g>>2]|0;if(h){k=0;l=0;while(1){m=(d[j+(l<<4)+13>>0]|k&1|0)!=0;l=l+1|0;if(l>>>0>=h>>>0){n=m;break}else k=m}if(h){h=b+64|0;if(n){n=g;b=0;do{k=b;while(1){l=(a[j+(k<<4)+13>>0]|0)==0;if(!l){o=l;break}k=c[j+(k<<4)>>2]|0;if((k|0)<=-1){o=l;break}}zNd(n,c[h>>2]|0,b,o);n=c[f>>2]|0;b=b+1|0}while(b>>>0<(c[n>>2]|0)>>>0)}else{n=g;g=0;do{b=g;while(1){o=a[j+(b<<4)+12>>0]|0;if(o<<24>>24){p=o;break}b=c[j+(b<<4)>>2]|0;if((b|0)<=-1){p=o;break}}zNd(n,c[h>>2]|0,g,p<<24>>24!=0);n=c[f>>2]|0;g=g+1|0}while(g>>>0<(c[n>>2]|0)>>>0)}}}MLd(aMd()|0);i=e;return}function mNd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+48|0;e=d;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+8|0;if(!(kNd(b)|0)){Krd(678456,0,3653512,209,1,0,0,0);i=d;return}l=c[(aMd()|0)+104>>2]|0;m=b+80|0;n=c[m>>2]|0;do if(!n)o=l;else{c[j>>2]=n;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,j);q=c[e>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(c[s+4>>2]|0)!=0:0)t=p;else u=12}else u=12;if((u|0)==12){if(!(hQb(c[m>>2]|0)|0)){o=l;break}t=c[137784]|0}c[h>>2]=c[m>>2];if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(e,t,h);p=c[e>>2]|0;q=c[t+28>>2]|0;if((p|0)==-1){v=q+(c[t+32>>2]<<3)|0;break}else{v=q+(p<<3)|0;break}}else v=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);p=c[137784]|0;if((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(q=c[v+4>>2]|0,(q|0)!=0):0){w=p;x=q}else u=22}else u=22;if((u|0)==22){q=hQb(c[m>>2]|0)|0;w=c[137784]|0;x=q}q=c[x+44>>2]|0;c[g>>2]=q;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(e,w,g);p=c[e>>2]|0;r=c[w+28>>2]|0;if((p|0)==-1){y=r+(c[w+32>>2]<<3)|0;break}else{y=r+(p<<3)|0;break}}else y=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);p=c[137784]|0;if((y|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(r=c[y+4>>2]|0,(r|0)!=0):0){z=p;A=r}else u=31}else u=31;if((u|0)==31){r=hQb(q)|0;z=c[137784]|0;A=r}c[f>>2]=c[m>>2];if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(e,z,f);r=c[e>>2]|0;p=c[z+28>>2]|0;if((r|0)==-1){B=p+(c[z+32>>2]<<3)|0;break}else{B=p+(r<<3)|0;break}}else B=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);q=c[137784]|0;if((B|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[B+4>>2]|0,(q|0)!=0):0)C=q;else u=40}else u=40;if((u|0)==40)C=hQb(c[m>>2]|0)|0;if(kNd(A)|0){q=wNd(c[A+60>>2]|0,c[A+64>>2]|0,C+48|0)|0;if(q){o=q;break}}else Krd(678456,0,3653512,382,1,0,0,0);c[e>>2]=mo[c[(c[b>>2]|0)+32>>2]&4095](b)|0;Lsd(k,678488,e);if(!(a[k>>0]&1))D=k+1|0;else D=c[k+8>>2]|0;Krd(D,0,3653512,221,1,0,0,0);xri(k);o=l}while(0);xNd(c[b+60>>2]|0,c[b+64>>2]|0,o);i=d;return}function nNd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(kNd(a)|0){e=wNd(c[a+60>>2]|0,c[a+64>>2]|0,b)|0;i=d;return e|0}else{Krd(678456,0,3653512,382,1,0,0,0);e=0;i=d;return e|0}return 0}function oNd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b+4|0;g=b;if(!(kNd(a)|0)){Krd(678456,0,3653512,232,1,0,0,0);i=b;return}vNd(c[a+64>>2]|0,0);h=a+80|0;a=c[h>>2]|0;if(!a){i=b;return}c[g>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,g);j=c[d>>2]|0;k=c[a+28>>2]|0;if((j|0)==-1){l=k+(c[a+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((l|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0)m=a;else n=12}else n=12;do if((n|0)==12)if(!(hQb(c[h>>2]|0)|0)){i=b;return}else{m=c[137784]|0;break}while(0);c[f>>2]=c[h>>2];if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(d,m,f);a=c[d>>2]|0;l=c[m+28>>2]|0;if((a|0)==-1){o=l+(c[m+32>>2]<<3)|0;break}else{o=l+(a<<3)|0;break}}else o=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((o|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(f=c[o+4>>2]|0,(f|0)!=0):0){p=m;q=f}else n=22}else n=22;if((n|0)==22){f=hQb(c[h>>2]|0)|0;p=c[137784]|0;q=f}f=c[q+44>>2]|0;c[e>>2]=f;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(d,p,e);q=c[d>>2]|0;h=c[p+28>>2]|0;if((q|0)==-1){r=h+(c[p+32>>2]<<3)|0;break}else{r=h+(q<<3)|0;break}}else r=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((r|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[r+4>>2]|0,(p|0)!=0):0)s=p;else n=31}else n=31;if((n|0)==31)s=hQb(f)|0;oNd(s);i=b;return}function pNd(b,d){b=b|0;d=ea(d);var e=0,f=Im,h=Im,j=0,k=0,l=0;e=i;if(kNd(b)|0){f=ea(ea(g[b+84>>2])*ea(.100000001));h=ea(SDi(ea(ea(bEi(ea(10.0)))*f)));j=c[b+60>>2]|0;k=c[b+64>>2]|0;l=c[(aMd()|0)+92>>2]|0;tNd(j,k,d,l,(a[b+88>>0]|0)!=0?h:ea(0.0));i=e;return}else{Krd(678456,0,3653512,311,1,0,0,0);i=e;return}}function qNd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[g>>2]=c[a+4>>2];c[f+0>>2]=c[g+0>>2];g=cOb(b,d,f,0,3653512,395)|0;i=e;return g|0}function rNd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function sNd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;j=i;i=i+288|0;k=j+104|0;l=j+220|0;m=j+224|0;n=j+160|0;o=j+164|0;p=j+216|0;q=j+156|0;r=j;s=j+232|0;t=j+168|0;u=j+184|0;v=j+200|0;w=j+144|0;y=j+132|0;z=j+120|0;A=j+248|0;B=j+264|0;C=j+280|0;D=j+284|0;E=(c[b+48>>2]|0)+-1|0;if((f|0)<0)F=0;else F=(E|0)<(f|0)?E:f;f=b+52|0;E=f;G=c[(c[f>>2]|0)+E+4>>2]|0;H=xo[c[c[e>>2]>>2]&2047](e,80,4)|0;I=c[b>>2]|0;if(I){J=xo[c[c[e>>2]>>2]&2047](e,I<<8,4)|0;I=c[b>>2]|0;K=H+8|0;c[K>>2]=J;if(I){J=xo[c[c[e>>2]>>2]&2047](e,I<<8,4)|0;I=c[b>>2]|0;L=H+12|0;c[L>>2]=J;if(I){J=xo[c[c[e>>2]>>2]&2047](e,I<<2,4)|0;I=c[b>>2]|0;c[H>>2]=J;if(!I){M=0;N=H;O=0;P=K;Q=L}else{J=xo[c[c[e>>2]>>2]&2047](e,I<<2,4)|0;M=J;N=H;O=c[b>>2]<<2;P=K;Q=L}}else{R=L;S=K;T=8}}else{U=K;T=6}}else{K=H+8|0;c[K>>2]=0;U=K;T=6}if((T|0)==6){K=H+12|0;c[K>>2]=0;R=K;S=U;T=8}if((T|0)==8){c[H>>2]=0;M=0;N=H;O=0;P=S;Q=R}R=H+4|0;c[R>>2]=M;PEi(M|0,0,O|0)|0;PEi(c[P>>2]|0,0,c[b>>2]<<8|0)|0;PEi(c[Q>>2]|0,0,c[b>>2]<<8|0)|0;O=b+20|0;M=c[O>>2]|0;if(!M){V=0;W=0}else{S=xo[c[c[e>>2]>>2]&2047](e,M<<5,4)|0;V=S;W=c[O>>2]<<5}S=H+16|0;c[S>>2]=V;PEi(V|0,0,W|0)|0;W=c[b>>2]|0;if(!W){X=0;Y=0}else{V=xo[c[c[e>>2]>>2]&2047](e,W,1)|0;X=V;Y=c[b>>2]|0}c[H+64>>2]=X;PEi(X|0,0,Y|0)|0;c[H+76>>2]=b;Y=H+68|0;X=FTd(d,678592,Y)|0;if(X){V=ANd(X)|0;c[k>>2]=678648;c[k+4>>2]=210;c[k+8>>2]=V;c[k+12>>2]=X;Ird(678608,k)}X=ySd(c[Y>>2]|0,1)|0;if(X){V=ANd(X)|0;c[k>>2]=678648;c[k+4>>2]=211;c[k+8>>2]=V;c[k+12>>2]=X;Ird(678608,k)}c[n>>2]=48e3;c[o>>2]=8;X=pTd(d,n,0,o,0,0,0)|0;if(X){V=ANd(X)|0;c[k>>2]=678648;c[k+4>>2]=215;c[k+8>>2]=V;c[k+12>>2]=X;Ird(678608,k)}c[p>>2]=0;X=rTd(d,p,0)|0;if(X){V=ANd(X)|0;c[k>>2]=678648;c[k+4>>2]=218;c[k+8>>2]=V;c[k+12>>2]=X;Ird(678608,k)}X=b+72|0;if(c[b>>2]|0){V=0;W=(c[X>>2]|0)+X|0;do{c[q>>2]=0;X=(c[Q>>2]|0)+(V<<8)+28|0;c[X>>2]=c[X>>2]|1;X=FTd(d,W,q)|0;if(X){M=ANd(X)|0;c[k>>2]=678648;c[k+4>>2]=237;c[k+8>>2]=M;c[k+12>>2]=X;Ird(678608,k)}c[(c[N>>2]|0)+(V<<2)>>2]=c[q>>2];W=W+((SEi(W|0)|0)+1)|0;V=V+1|0}while(V>>>0<(c[b>>2]|0)>>>0)}V=zSd(c[Y>>2]|0,c[c[N>>2]>>2]|0)|0;if(V){Y=ANd(V)|0;c[k>>2]=678648;c[k+4>>2]=243;c[k+8>>2]=Y;c[k+12>>2]=V;Ird(678608,k)}if((c[b>>2]|0)>>>0>1){V=b+4|0;Y=V;W=1;do{q=c[N>>2]|0;X=zSd(c[q+(c[(c[V>>2]|0)+Y+(W<<4)>>2]<<2)>>2]|0,c[q+(W<<2)>>2]|0)|0;if(X){q=ANd(X)|0;c[k>>2]=678648;c[k+4>>2]=249;c[k+8>>2]=q;c[k+12>>2]=X;Ird(678608,k)}W=W+1|0}while(W>>>0<(c[b>>2]|0)>>>0)}W=da(c[o>>2]|0,c[p>>2]|0)|0;p=b+40|0;o=c[p>>2]|0;Y=da(W,o)|0;if(!Y){Z=0;_=o}else{o=xo[c[c[e>>2]>>2]&2047](e,Y<<2,4)|0;Z=o;_=c[p>>2]|0}p=H+72|0;c[p>>2]=Z;PEi(Z|0,0,da(W<<2,_)|0)|0;if(c[O>>2]|0){_=b+24|0;Z=_;o=b+96|0;Y=o;V=0;X=c[p>>2]|0;while(1){p=c[(c[_>>2]|0)+Z+(V*36|0)>>2]|0;a:do if((p+5|0)>>>0>=2)if((p|0)>=0?(p|0)>999|(p|0)==0:0){q=p+-1e3|0;M=(c[o>>2]|0)+Y|0;if(!q)$=M;else{U=q;q=M;while(1){M=q+((SEi(q|0)|0)+1)|0;U=U+-1|0;if(!U){$=M;break}else q=M}}c[m>>2]=0;q=DKd(m)|0;U=c[m>>2]|0;if((U|0)>0)aa=0;else{ba=X;break}while(1){M=c[q+(aa<<2)>>2]|0;aa=aa+1|0;if(!(HEi((c[M>>2]|0)+128|0,$)|0)){ca=M;fa=M;break}if((aa|0)>=(U|0)){ba=X;break a}}if(!ca){ba=X;break}if(!(0==0?(c[(c[fa>>2]|0)+120>>2]&1|0)==0:0))T=51;else ba=X}else ba=X;else T=51;while(0);if((T|0)==51){T=0;c[(c[S>>2]|0)+(V<<5)+16>>2]=X;ba=X+(W<<2)|0}V=V+1|0;p=c[O>>2]|0;if(V>>>0>=p>>>0){ga=p;break}else X=ba}if(ga){ga=b+24|0;ba=ga;X=b+96|0;V=X;W=w+1|0;fa=w+8|0;ca=y+1|0;aa=y+8|0;$=z+1|0;m=z+8|0;Y=A+1|0;o=A+8|0;Z=r+32|0;_=r+4|0;p=r+76|0;U=r+32|0;q=r+4|0;M=r+24|0;K=r+76|0;L=r+32|0;J=r+4|0;I=r+24|0;ha=r+64|0;ia=r+68|0;ja=r+88|0;ka=r+96|0;la=r+20|0;ma=r+84|0;na=r+76|0;oa=r+32|0;pa=r+4|0;qa=r+76|0;ra=0;while(1){sa=(c[ga>>2]|0)+ba|0;ta=sa+(ra*36|0)|0;ua=c[ta>>2]|0;if((ua|0)<0)va=1;else va=(ua|0)>999?0:ua;wa=c[S>>2]|0;xa=wa+(ra<<5)|0;c[xa>>2]=0;b:do if((ua|0)==-3){ya=c[(c[N>>2]|0)+(c[sa+(ra*36|0)+4>>2]<<2)>>2]|0;za=c[sa+(ra*36|0)+8>>2]|0;if((za|0)!=-1?(c[wa+(za<<5)+16>>2]|0)!=0:0){Aa=r+0|0;Ba=Aa+104|0;do{c[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(Ba|0));a[Z+0>>0]=a[678728]|0;a[Z+1>>0]=a[678729]|0;a[Z+2>>0]=a[678730]|0;a[Z+3>>0]=a[678731]|0;a[Z+4>>0]=a[678732]|0;Ca=c[S>>2]|0;c[Ca+(ra<<5)+16>>2]=c[Ca+(za<<5)+16>>2];c[r>>2]=104;c[_>>2]=56;c[p>>2]=113;AKd(s,r,0);Ca=c[S>>2]|0;Da=CKd(s,d,Ca+(ra<<5)|0,c[Ca+(ra<<5)+16>>2]|0)|0;c[(c[S>>2]|0)+(ra<<5)>>2]=Da;Ca=RSd(Da,1)|0;if(Ca){Da=ANd(Ca)|0;c[k>>2]=678648;c[k+4>>2]=305;c[k+8>>2]=Da;c[k+12>>2]=Ca;Ird(678608,k)}Ca=ESd(ya,c[(c[S>>2]|0)+(ra<<5)>>2]|0,0)|0;if(Ca){Da=ANd(Ca)|0;c[k>>2]=678648;c[k+4>>2]=307;c[k+8>>2]=Da;c[k+12>>2]=Ca;Ird(678608,k)}BKd(s);T=98}}else if((ua|0)==-4){Ca=c[(c[N>>2]|0)+(c[sa+(ra*36|0)+4>>2]<<2)>>2]|0;Aa=r+0|0;Ba=Aa+104|0;do{c[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(Ba|0));ya=U;c[ya>>2]=1701012818;c[ya+4>>2]=6649449;c[r>>2]=104;c[q>>2]=56;ya=M;c[ya>>2]=1;c[ya+4>>2]=0;c[K>>2]=114;AKd(t,r,0);ya=c[S>>2]|0;za=CKd(t,d,ya+(ra<<5)|0,c[ya+(ra<<5)+16>>2]|0)|0;c[(c[S>>2]|0)+(ra<<5)>>2]=za;ya=RSd(za,1)|0;if(ya){za=ANd(ya)|0;c[k>>2]=678648;c[k+4>>2]=333;c[k+8>>2]=za;c[k+12>>2]=ya;Ird(678608,k)}ya=ESd(Ca,c[(c[S>>2]|0)+(ra<<5)>>2]|0,0)|0;if(ya){za=ANd(ya)|0;c[k>>2]=678648;c[k+4>>2]=335;c[k+8>>2]=za;c[k+12>>2]=ya;Ird(678608,k)}BKd(t);T=98}else if((ua|0)==-5){ya=c[(c[N>>2]|0)+(c[sa+(ra*36|0)+4>>2]<<2)>>2]|0;Aa=r+0|0;Ba=Aa+104|0;do{c[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(Ba|0));Aa=L+0|0;Ea=678736|0;Ba=Aa+12|0;do{a[Aa>>0]=a[Ea>>0]|0;Aa=Aa+1|0;Ea=Ea+1|0}while((Aa|0)<(Ba|0));Ca=I;c[Ca>>2]=1;c[Ca+4>>2]=0;c[r>>2]=104;c[J>>2]=56;c[ha>>2]=3603;c[ia>>2]=3604;c[ja>>2]=3;c[ka>>2]=254;c[la>>2]=7;c[ma>>2]=678752;c[na>>2]=115;AKd(u,r,0);Ca=c[S>>2]|0;za=CKd(u,d,Ca+(ra<<5)|0,c[Ca+(ra<<5)+16>>2]|0)|0;c[(c[S>>2]|0)+(ra<<5)>>2]=za;Ca=RSd(za,1)|0;if(Ca){za=ANd(Ca)|0;c[k>>2]=678648;c[k+4>>2]=379;c[k+8>>2]=za;c[k+12>>2]=Ca;Ird(678608,k)}Ca=ESd(ya,c[(c[S>>2]|0)+(ra<<5)>>2]|0,0)|0;if(Ca){za=ANd(Ca)|0;c[k>>2]=678648;c[k+4>>2]=381;c[k+8>>2]=za;c[k+12>>2]=Ca;Ird(678608,k)}BKd(u);T=98}else if((ua|0)==-2){Ca=sa+(ra*36|0)+4|0;za=c[(c[N>>2]|0)+(c[Ca>>2]<<2)>>2]|0;Aa=r+0|0;Ba=Aa+104|0;do{c[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(Ba|0));Aa=oa+0|0;Ea=679472|0;Ba=Aa+14|0;do{a[Aa>>0]=a[Ea>>0]|0;Aa=Aa+1|0;Ea=Ea+1|0}while((Aa|0)<(Ba|0));c[r>>2]=104;c[pa>>2]=56;c[qa>>2]=116;AKd(v,r,0);ya=CKd(v,d,(c[P>>2]|0)+(c[Ca>>2]<<8)|0,0)|0;c[(c[S>>2]|0)+(ra<<5)>>2]=ya;ya=c[Ca>>2]|0;Da=c[P>>2]|0;Fa=ea(c[n>>2]|0);g[Da+(ya<<8)+8>>2]=ea(pLd(ea(.990000009),ea(Fa*ea(.300000012))));g[Da+(ya<<8)+12>>2]=ea(ea(1.0)-ea(pLd(ea(.899999976),ea(Fa*ea(1.70000005)))));Ga=ea(ea(-.5)/Fa);g[Da+(ya<<8)+16>>2]=ea(SDi(ea(Ga*ea(bEi(ea(10.0))))));c[Da+(ya<<8)+24>>2]=~~ea(Fa*ea(2.0));ya=c[Ca>>2]|0;Da=(c[P>>2]|0)+(ya<<8)+28|0;c[Da>>2]=c[Da>>2]|1;Da=(c[Q>>2]|0)+(ya<<8)+28|0;c[Da>>2]=c[Da>>2]&-2;Da=RSd(c[(c[S>>2]|0)+(ra<<5)>>2]|0,1)|0;if(Da){ya=ANd(Da)|0;c[k>>2]=678648;c[k+4>>2]=408;c[k+8>>2]=ya;c[k+12>>2]=Da;Ird(678608,k)}Da=ESd(za,c[(c[S>>2]|0)+(ra<<5)>>2]|0,0)|0;if(Da){ya=ANd(Da)|0;c[k>>2]=678648;c[k+4>>2]=410;c[k+8>>2]=ya;c[k+12>>2]=Da;Ird(678608,k)}BKd(v);T=98}else{if(va){if(ETd(d,va,xa)|0){Lsd(z,679656,k);Krd((a[z>>0]&1)==0?$:c[m>>2]|0,0,3653512,438,1,0,0,0);xri(z);T=98;break}Da=ESd(c[(c[N>>2]|0)+(c[sa+(ra*36|0)+4>>2]<<2)>>2]|0,c[(c[S>>2]|0)+(ra<<5)>>2]|0,0)|0;if(!Da){T=98;break}ya=ANd(Da)|0;c[k>>2]=678648;c[k+4>>2]=434;c[k+8>>2]=ya;c[k+12>>2]=Da;Ird(678608,k);T=98;break}Da=ua+-1e3|0;ya=(c[X>>2]|0)+V|0;if(!Da)Ha=ya;else{Ia=Da;Da=ya;while(1){ya=Da+((SEi(Da|0)|0)+1)|0;Ia=Ia+-1|0;if(!Ia){Ha=ya;break}else Da=ya}}c[l>>2]=0;Da=DKd(l)|0;Ia=c[l>>2]|0;c:do if((Ia|0)>0){za=0;while(1){Ca=c[Da+(za<<2)>>2]|0;za=za+1|0;if(!(HEi((c[Ca>>2]|0)+128|0,Ha)|0)){Ja=Ca;Ka=Ca;break}if((za|0)>=(Ia|0))break c}if(!Ja)break;za=CKd(Ja,d,0,c[(c[S>>2]|0)+(ra<<5)+16>>2]|0)|0;c[(c[S>>2]|0)+(ra<<5)>>2]=za;if(!za){c[k>>2]=(c[Ka>>2]|0)+128;Lsd(y,679488,k);Krd((a[y>>0]&1)==0?ca:c[aa>>2]|0,0,3653512,428,1,0,0,0);xri(y);T=98;break b}Ca=ESd(c[(c[N>>2]|0)+(c[sa+(ra*36|0)+4>>2]<<2)>>2]|0,za,0)|0;if(!Ca){T=98;break b}za=ANd(Ca)|0;c[k>>2]=678648;c[k+4>>2]=424;c[k+8>>2]=za;c[k+12>>2]=Ca;Ird(678608,k);T=98;break b}while(0);Ia=(c[ta>>2]|0)+-1e3|0;Da=(c[X>>2]|0)+V|0;if(!Ia)La=Da;else{Ca=Ia;Ia=Da;while(1){Da=Ia+((SEi(Ia|0)|0)+1)|0;Ca=Ca+-1|0;if(!Ca){La=Da;break}else Ia=Da}}c[k>>2]=La;Lsd(w,679488,k);Krd((a[w>>0]&1)==0?W:c[fa>>2]|0,0,3653512,417,1,0,0,0);xri(w)}while(0);if((T|0)==98?(T=0,(c[(c[S>>2]|0)+(ra<<5)>>2]|0)==0):0){c[k>>2]=va;Lsd(A,679704,k);Krd((a[A>>0]&1)==0?Y:c[o>>2]|0,0,3653512,443,1,0,0,0);xri(A)}ra=ra+1|0;ta=c[O>>2]|0;if(ra>>>0>=ta>>>0){Ma=ta;break}}}else Ma=0}else Ma=0;ra=c[b>>2]|0;if(!ra)Na=Ma;else{Ma=r+32|0;A=r+4|0;o=r+76|0;Y=ra;ra=0;while(1){if(!(c[(c[Q>>2]|0)+(ra<<8)+28>>2]&3))Oa=Y;else{va=c[(c[N>>2]|0)+(ra<<2)>>2]|0;Aa=r+0|0;Ba=Aa+104|0;do{c[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(Ba|0));T=Ma;c[T>>2]=1631999318;c[T+4>>2]=7497060;c[r>>2]=104;c[A>>2]=56;c[o>>2]=116;AKd(B,r,0);T=CKd(B,d,(c[Q>>2]|0)+(ra<<8)|0,0)|0;c[(c[R>>2]|0)+(ra<<2)>>2]=T;T=RSd(c[(c[R>>2]|0)+(ra<<2)>>2]|0,1)|0;if(T){w=ANd(T)|0;c[k>>2]=678648;c[k+4>>2]=471;c[k+8>>2]=w;c[k+12>>2]=T;Ird(678608,k)}T=ESd(va,c[(c[R>>2]|0)+(ra<<2)>>2]|0,0)|0;if(T){w=ANd(T)|0;c[k>>2]=678648;c[k+4>>2]=473;c[k+8>>2]=w;c[k+12>>2]=T;Ird(678608,k)}BKd(B);Oa=c[b>>2]|0}ra=ra+1|0;if(ra>>>0>=Oa>>>0)break;else Y=Oa}Na=c[O>>2]|0}if(Na){Na=b+24|0;Oa=Na;Y=0;do{ra=c[S>>2]|0;c[ra+(Y<<5)+4>>2]=0;c[ra+(Y<<5)+8>>2]=0;g[ra+(Y<<5)+12>>2]=(c[ra+(Y<<5)>>2]|0)!=0?ea(1.0):ea(0.0);c[C>>2]=0;c[D>>2]=0;ra=(c[Na>>2]|0)+Oa|0;do if(((c[ra+(Y*36|0)>>2]|0)+5|0)>>>0>=3?(B=c[(c[S>>2]|0)+(Y<<5)>>2]|0,(B|0)!=0):0){if((c[ra+(Y*36|0)+12>>2]|0)==-1)break;r=NSd(B,0,C,0)|0;if(r){B=ANd(r)|0;c[k>>2]=678648;c[k+4>>2]=495;c[k+8>>2]=B;c[k+12>>2]=r;Ird(678608,k)}r=c[S>>2]|0;B=OSd(c[r+(Y<<5)>>2]|0,0,D,r+(Y<<5)+4|0)|0;if(B){r=ANd(B)|0;c[k>>2]=678648;c[k+4>>2]=496;c[k+8>>2]=r;c[k+12>>2]=B;Ird(678608,k)}B=JSd(c[D>>2]|0,c[C>>2]|0,(c[S>>2]|0)+(Y<<5)+8|0)|0;if(!B)break;r=ANd(B)|0;c[k>>2]=678648;c[k+4>>2]=497;c[k+8>>2]=r;c[k+12>>2]=B;Ird(678608,k)}while(0);Y=Y+1|0}while(Y>>>0<(c[O>>2]|0)>>>0)}c[H+60>>2]=F;F=H+20|0;c[F>>2]=G;if(!G){Y=H+24|0;c[Y+0>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;c[Y+12>>2]=0;Pa=0;Qa=H+32|0;Ra=Y}else{Y=G<<2;C=H+24|0;c[C>>2]=xo[c[c[e>>2]>>2]&2047](e,Y,4)|0;D=H+32|0;c[D>>2]=xo[c[c[e>>2]>>2]&2047](e,Y,4)|0;c[H+28>>2]=xo[c[c[e>>2]>>2]&2047](e,Y,4)|0;c[H+36>>2]=xo[c[c[e>>2]>>2]&2047](e,G,1)|0;Pa=xo[c[c[e>>2]>>2]&2047](e,Y,4)|0;Qa=D;Ra=C}c[H+52>>2]=Pa;Pa=c[(c[f>>2]|0)+E+4>>2]|0;if(Pa){C=c[Qa>>2]|0;Qa=0;do{g[C+(Qa<<2)>>2]=ea(-x);Qa=Qa+1|0}while(Qa>>>0<Pa>>>0)}Pa=b+104|0;Qa=c[Pa>>2]|0;if(Qa){C=xo[c[c[e>>2]>>2]&2047](e,Qa<<2,4)|0;Qa=c[Pa>>2]|0;c[H+40>>2]=C;if(Qa){Pa=0;do{g[C+(Pa<<2)>>2]=ea(-x);Pa=Pa+1|0}while(Pa>>>0<Qa>>>0)}}else c[H+40>>2]=0;g[H+44>>2]=ea(1.0);g[H+48>>2]=ea(0.0);a[H+56>>0]=0;Qa=c[Ra>>2]|0;Ra=(c[f>>2]|0)+E|0;E=Ra+8|0;f=E+(c[E>>2]|0)|0;c[Ra+12>>2]=f;YEi(Qa|0,f|0,c[F>>2]<<2|0)|0;if(c[O>>2]|0){F=0;do{f=c[(c[S>>2]|0)+(F<<5)>>2]|0;do if(f){Qa=RSd(f,0)|0;if(!Qa)break;Ra=ANd(Qa)|0;c[k>>2]=678648;c[k+4>>2]=527;c[k+8>>2]=Ra;c[k+12>>2]=Qa;Ird(678608,k)}while(0);F=F+1|0}while(F>>>0<(c[O>>2]|0)>>>0)}if(c[b>>2]|0){O=0;do{F=c[(c[R>>2]|0)+(O<<2)>>2]|0;do if(F){S=RSd(F,0)|0;if(!S)break;f=ANd(S)|0;c[k>>2]=678648;c[k+4>>2]=531;c[k+8>>2]=f;c[k+12>>2]=S;Ird(678608,k)}while(0);O=O+1|0}while(O>>>0<(c[b>>2]|0)>>>0)}if(!h){tNd(b,H,ea(0.0),d,ea(1.0e4));i=j;return H|0}h=(c[Q>>2]|0)+28|0;c[h>>2]=c[h>>2]|4;tNd(b,H,ea(0.0),d,ea(1.0e4));i=j;return H|0}function tNd(b,e,f,h,j){b=b|0;e=e|0;f=ea(f);h=h|0;j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=0,s=Im,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=Im,U=0,V=0;k=i;i=i+32|0;l=k;m=k+16|0;n=k+20|0;o=e+20|0;p=ea(g[e+48>>2]);if(!(p<=ea(0.0))){q=ea(f/p);r=e+44|0;p=ea(q+ea(g[r>>2]));g[r>>2]=p;s=p}else{g[e+44>>2]=ea(1.0);s=ea(1.0)}p=ea(VDi(ea(1.0),s));g[e+44>>2]=p;a:do if(!(a[e+56>>0]|0)){r=c[e+60>>2]|0;t=b+52|0;u=(c[t>>2]|0)+t|0;t=c[u+(r*40|0)+16>>2]|0;v=c[e+24>>2]|0;w=u+(r*40|0)+8|0;y=w+(c[w>>2]|0)|0;c[u+(r*40|0)+12>>2]=y;w=c[e+28>>2]|0;z=c[o>>2]|0;if(z){A=p<ea(0.0);B=p>ea(1.0);s=B?ea(1.0):p;q=ea(p*p);B=p>ea(9.99999971e-10);C=p<ea(1.0);f=A?ea(0.0):s;s=ea(ea(f*ea(f*ea(3.0)))+ea(f*ea(f*ea(f*ea(-2.0)))));f=ea(s+ea(ea(ea(1.0)-s)*ea(0.0)));A=0;do{s=ea(g[v+(A<<2)>>2]);D=ea(g[y+(A<<2)>>2]);b:do if(s==D)E=D;else switch(t|0){case 0:{E=ea(s+ea(p*ea(D-s)));break b;break}case 1:{E=ea(s+ea(f*ea(D-s)));break b;break}case 2:{E=ea(s+ea(q*ea(D-s)));break b;break}case 3:{E=ea(s+ea(ea(D-s)*ea(T(ea(p)))));break b;break}case 4:{E=B?D:s;break b;break}case 5:{E=C?s:D;break b;break}default:{E=ea(0.0);break b}}while(0);g[w+(A<<2)>>2]=E;A=A+1|0}while((A|0)!=(z|0))}A=c[u+(r*40|0)+20>>2]|0;if(A){C=u+(r*40|0)+32|0;B=(c[C>>2]|0)+C|0;C=u+(r*40|0)+24|0;t=C;F=p<ea(0.0);G=p>ea(1.0);q=G?ea(1.0):p;f=ea(p*p);G=p>ea(9.99999971e-10);H=p<ea(1.0);D=F?ea(0.0):q;q=ea(ea(D*ea(D*ea(3.0)))+ea(D*ea(D*ea(D*ea(-2.0)))));D=ea(q+ea(ea(ea(1.0)-q)*ea(0.0)));if(H){H=0;while(1){F=c[B+(H<<2)>>2]|0;q=ea(g[v+(F<<2)>>2]);s=ea(g[y+(F<<2)>>2]);c:do if(q==s)I=s;else switch(c[(c[C>>2]|0)+t+(H<<2)>>2]|0){case 5:{I=q;break c;break}case 4:{I=G?s:q;break c;break}case 3:{I=ea(q+ea(ea(s-q)*ea(T(ea(p)))));break c;break}case 2:{I=ea(q+ea(f*ea(s-q)));break c;break}case 1:{I=ea(q+ea(D*ea(s-q)));break c;break}case 0:{I=ea(q+ea(p*ea(s-q)));break c;break}default:{I=ea(0.0);break c}}while(0);g[w+(F<<2)>>2]=I;H=H+1|0;if((H|0)==(A|0)){J=w;K=z;break a}}}if(G){H=0;while(1){r=c[B+(H<<2)>>2]|0;q=ea(g[v+(r<<2)>>2]);s=ea(g[y+(r<<2)>>2]);d:do if(q==s)L=s;else switch(c[(c[C>>2]|0)+t+(H<<2)>>2]|0){case 5:{L=s;break d;break}case 4:{L=s;break d;break}case 3:{L=ea(q+ea(ea(s-q)*ea(T(ea(p)))));break d;break}case 2:{L=ea(q+ea(f*ea(s-q)));break d;break}case 1:{L=ea(q+ea(D*ea(s-q)));break d;break}case 0:{L=ea(q+ea(p*ea(s-q)));break d;break}default:{L=ea(0.0);break d}}while(0);g[w+(r<<2)>>2]=L;H=H+1|0;if((H|0)==(A|0)){J=w;K=z;break}}}else{H=0;while(1){G=c[B+(H<<2)>>2]|0;q=ea(g[v+(G<<2)>>2]);s=ea(g[y+(G<<2)>>2]);e:do if(q==s)M=s;else switch(c[(c[C>>2]|0)+t+(H<<2)>>2]|0){case 3:{M=ea(q+ea(ea(s-q)*ea(T(ea(p)))));break e;break}case 4:{M=q;break e;break}case 5:{M=s;break e;break}case 0:{M=ea(q+ea(p*ea(s-q)));break e;break}case 1:{M=ea(q+ea(D*ea(s-q)));break e;break}case 2:{M=ea(q+ea(f*ea(s-q)));break e;break}default:{M=ea(0.0);break e}}while(0);g[w+(G<<2)>>2]=M;H=H+1|0;if((H|0)==(A|0)){J=w;K=z;break}}}}else{J=w;K=z}}else{A=c[e+24>>2]|0;H=c[e+52>>2]|0;t=c[e+28>>2]|0;C=c[o>>2]|0;if(!C){J=t;K=0}else{y=0;do{f=ea(g[A+(y<<2)>>2]);D=ea(g[H+(y<<2)>>2]);if(f==D)N=D;else N=ea(f+ea(p*ea(D-f)));g[t+(y<<2)>>2]=N;y=y+1|0}while((y|0)!=(C|0));J=t;K=C}}while(0);o=c[e+40>>2]|0;C=c[b+104>>2]|0;if(C){t=b+116|0;y=(c[t>>2]|0)+t|0;t=0;do{N=ea(g[o+(t<<2)>>2]);if(!(N==ea(-x)))g[J+(c[y+(t<<2)>>2]<<2)>>2]=N;t=t+1|0}while((t|0)!=(C|0))}C=c[e+32>>2]|0;t=c[e+36>>2]|0;if(K){y=0;do{N=ea(g[J+(y<<2)>>2]);a[t+y>>0]=ea(g[C+(y<<2)>>2])!=N&1;y=y+1|0}while((y|0)!=(K|0))}c[m>>2]=48e3;K=pTd(h,m,0,0,0,0,0)|0;if(K){h=ANd(K)|0;c[l>>2]=678648;c[l+4>>2]=720;c[l+8>>2]=h;c[l+12>>2]=K;Ird(678608,l)}if(c[b>>2]|0){K=b+4|0;h=K;y=e+12|0;o=e+8|0;H=0;do{A=(c[K>>2]|0)+h|0;z=c[A+(H<<4)+4>>2]|0;if(a[t+z>>0]|0){N=ea(g[J+(z<<2)>>2]);if(!(N<=ea(-80.0))){p=ea(N*ea(.0500000007));O=ea(SDi(ea(p*ea(bEi(ea(10.0))))))}else O=ea(0.0);z=c[y>>2]|0;if((c[z+(H<<8)+28>>2]&1|0)!=0?(g[z+(H<<8)>>2]=O,z=vSd(c[(c[e>>2]|0)+(H<<2)>>2]|0,O)|0,(z|0)!=0):0){w=ANd(z)|0;c[l>>2]=678648;c[l+4>>2]=733;c[l+8>>2]=w;c[l+12>>2]=z;Ird(678608,l)}z=c[o>>2]|0;if((c[z+(H<<8)+28>>2]&1|0)!=0?(g[z+(H<<8)>>2]=O,z=vSd(c[(c[e>>2]|0)+(H<<2)>>2]|0,O)|0,(z|0)!=0):0){w=ANd(z)|0;c[l>>2]=678648;c[l+4>>2]=738;c[l+8>>2]=w;c[l+12>>2]=z;Ird(678608,l)}}z=c[A+(H<<4)+8>>2]|0;if(a[t+z>>0]|0)xSd(c[(c[e>>2]|0)+(H<<2)>>2]|0,ea(g[J+(z<<2)>>2]))|0;H=H+1|0}while(H>>>0<(c[b>>2]|0)>>>0)}H=b+20|0;if(c[H>>2]|0){o=b+24|0;y=o;h=e+16|0;K=b+4|0;b=K;z=0;do{A=(c[o>>2]|0)+y|0;w=c[h>>2]|0;v=w+(z<<5)|0;B=c[A+(z*36|0)+12>>2]|0;if(((B|0)!=-1?(a[t+B>>0]|0)!=0:0)?(c[v>>2]|0)!=0:0){O=ea(g[J+(B<<2)>>2]);if(!(O<=ea(-80.0))){p=ea(O*ea(.0500000007));P=ea(SDi(ea(p*ea(bEi(ea(10.0))))))}else P=ea(0.0);g[w+(z<<5)+12>>2]=P;B=c[w+(z<<5)+4>>2]|0;if((B|0)!=0?(Ch(B|0,+P)|0,B=c[w+(z<<5)+8>>2]|0,(B|0)!=0):0){w=c[A+(z*36|0)+16>>2]|0;if((w|0)!=-1?(r=c[h>>2]|0,(c[r+(w<<5)+8>>2]|0)!=0):0){p=ea(g[r+(w<<5)+12>>2]);if(!(p<=ea(-80.0))){Q=p;R=85}else S=ea(0.0)}else{Q=ea(0.0);R=85}if((R|0)==85){R=0;p=ea(Q*ea(.0500000007));S=ea(SDi(ea(p*ea(bEi(ea(10.0))))))}Ch(B|0,+ea(ea(ea(1.0)-P)*S))|0}B=P==ea(0.0);if(!B?(a[(c[K>>2]|0)+b+(c[A+(z*36|0)+4>>2]<<4)+14>>0]|0)==0:0)U=(a[A+(z*36|0)+20>>0]|0)!=0;else U=1;w=c[A+(z*36|0)>>2]|0;r=(w|0)>-1;F=U&(r|B^1?r:(w|0)==-3);w=SSd(c[v>>2]|0,n)|0;if(w){r=ANd(w)|0;c[l>>2]=678648;c[l+4>>2]=796;c[l+8>>2]=r;c[l+12>>2]=w;Ird(678608,l)}if((F&1|0)!=(d[n>>0]|0)?(w=RSd(c[v>>2]|0,F)|0,(w|0)!=0):0){F=ANd(w)|0;c[l>>2]=678648;c[l+4>>2]=798;c[l+8>>2]=F;c[l+12>>2]=w;Ird(678608,l)}}w=A+(z*36|0)+24|0;if(c[w>>2]|0){F=A+(z*36|0)+28|0;A=F;r=0;do{B=c[(c[F>>2]|0)+A+(r<<2)>>2]|0;if(((a[t+B>>0]|0)!=0?(u=c[v>>2]|0,(u|0)!=0):0)?(V=TSd(u,r,ea(g[J+(B<<2)>>2]))|0,(V|0)!=0):0){B=ANd(V)|0;c[l>>2]=678648;c[l+4>>2]=805;c[l+8>>2]=B;c[l+12>>2]=V;Ird(678608,l)}r=r+1|0}while(r>>>0<(c[w>>2]|0)>>>0)}z=z+1|0}while(z>>>0<(c[H>>2]|0)>>>0)}YEi(C|0,J|0,c[e+20>>2]<<2|0)|0;if(BNd(c[c[e>>2]>>2]|0)|0){vNd(e,0);i=k;return}J=c[e+12>>2]|0;if(!(c[J+28>>2]&4)){i=k;return}if(!(ea(g[J+20>>2])<j)){i=k;return}C=J+32|0;if(c[C>>2]|0){i=k;return}c[C>>2]=-1;c[l>>2]=0;DSd(c[c[e>>2]>>2]|0,l)|0;e=c[l>>2]|0;if(!e){i=k;return}a[m>>0]=0;QSd(e,m)|0;PSd(c[l>>2]|0,0)|0;i=k;return}function uNd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;if(!a){i=f;return}h=b+20|0;if(c[h>>2]|0){j=a+16|0;k=0;do{l=c[(c[j>>2]|0)+(k<<5)>>2]|0;if((l|0)!=0?(m=HSd(l)|0,(m|0)!=0):0){l=ANd(m)|0;c[g>>2]=678648;c[g+4>>2]=552;c[g+8>>2]=l;c[g+12>>2]=m;Ird(678608,g)}k=k+1|0}while(k>>>0<(c[h>>2]|0)>>>0)}if(c[b>>2]|0){h=a+4|0;k=0;do{j=c[(c[h>>2]|0)+(k<<2)>>2]|0;if((j|0)!=0?(m=HSd(j)|0,(m|0)!=0):0){j=ANd(m)|0;c[g>>2]=678648;c[g+4>>2]=557;c[g+8>>2]=j;c[g+12>>2]=m;Ird(678608,g)}m=uSd(c[(c[a>>2]|0)+(k<<2)>>2]|0)|0;if(m){j=ANd(m)|0;c[g>>2]=678648;c[g+4>>2]=558;c[g+8>>2]=j;c[g+12>>2]=m;Ird(678608,g)}k=k+1|0}while(k>>>0<(c[b>>2]|0)>>>0)}b=uSd(c[a+68>>2]|0)|0;if(b){k=ANd(b)|0;c[g>>2]=678648;c[g+4>>2]=561;c[g+8>>2]=k;c[g+12>>2]=b;Ird(678608,g)}b=xTd(d)|0;if(b){d=ANd(b)|0;c[g>>2]=678648;c[g+4>>2]=563;c[g+8>>2]=d;c[g+12>>2]=b;Ird(678608,g)}In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+64>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+12>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+8>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+4>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+16>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+24>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+28>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+32>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+36>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+52>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+40>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,c[a+72>>2]|0);In[c[(c[e>>2]|0)+4>>2]&4095](e,a);i=f;return}function vNd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+12|0;h=e+4|0;j=e;c[f>>2]=0;DSd(c[c[b>>2]>>2]|0,f)|0;k=c[f>>2]|0;if(!k){i=e;return}a[g>>0]=0;QSd(k,g)|0;if(!((a[g>>0]|0)==0|d)){c[h>>2]=0;ISd(c[f>>2]|0,h)|0;pTd(c[h>>2]|0,j,0,0,0,0,0)|0;c[(c[b+12>>2]|0)+32>>2]=c[j>>2]}PSd(c[f>>2]|0,d^1)|0;i=e;return}function wNd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[b>>2]|0;if(!g){h=0;i=f;return h|0}j=b+12|0;b=(c[j>>2]|0)+j|0;j=c[e>>2]|0;k=c[e+4>>2]|0;l=c[e+8>>2]|0;m=c[e+12>>2]|0;e=0;while(1){if((((c[b+(e<<4)>>2]|0)==(j|0)?(c[b+(e<<4)+4>>2]|0)==(k|0):0)?(c[b+(e<<4)+8>>2]|0)==(l|0):0)?(c[b+(e<<4)+12>>2]|0)==(m|0):0){n=e;break}e=e+1|0;if(e>>>0>=g>>>0){h=0;o=13;break}}if((o|0)==13){i=f;return h|0}if((n|0)==-1){h=0;i=f;return h|0}o=c[d+64>>2]|0;if((o|0)!=0?(a[o+n>>0]|0)!=0:0){h=c[d+68>>2]|0;i=f;return h|0}h=c[(c[d>>2]|0)+(n<<2)>>2]|0;i=f;return h|0}function xNd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;i=i+16|0;e=a;f=zSd(d,c[c[b>>2]>>2]|0)|0;if(!f){i=a;return}b=ANd(f)|0;c[e>>2]=678648;c[e+4>>2]=1083;c[e+8>>2]=b;c[e+12>>2]=f;Ird(678608,e);i=a;return}function yNd(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+32|0;h=f;j=f+16|0;k=b+20|0;if(!(c[k>>2]|0)){i=f;return}l=b+24|0;m=l;n=b+28|0;o=e+16|0;e=b+4|0;p=e;q=b+8|0;b=0;do{r=(c[l>>2]|0)+m|0;c[n>>2]=r;s=c[o>>2]|0;t=ea(g[s+(b<<5)+12>>2])==ea(0.0);if(!t?(u=c[r+(b*36|0)+4>>2]|0,v=(c[e>>2]|0)+p|0,c[q>>2]=v,(a[v+(u<<4)+14>>0]|0)==0):0)w=(a[r+(b*36|0)+20>>0]|0)!=0;else w=1;u=c[r+(b*36|0)>>2]|0;r=(u|0)>-1;v=w&(r|t^1?r:(u|0)==-3);u=s+(b<<5)|0;s=c[u>>2]|0;if(s){r=SSd(s,j)|0;if(r){s=ANd(r)|0;c[h>>2]=678648;c[h+4>>2]=1165;c[h+8>>2]=s;c[h+12>>2]=r;Ird(678608,h)}if((v&1|0)!=(d[j>>0]|0)?(r=RSd(c[u>>2]|0,v)|0,(r|0)!=0):0){v=ANd(r)|0;c[h>>2]=678648;c[h+4>>2]=1167;c[h+8>>2]=v;c[h+12>>2]=r;Ird(678608,h)}}b=b+1|0}while(b>>>0<(c[k>>2]|0)>>>0);i=f;return}function zNd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;a[(c[d+64>>2]|0)+e>>0]=f&1;j=b+20|0;if(!(c[j>>2]|0)){i=g;return}k=b+24|0;b=k;l=d+16|0;d=0;do{m=(c[k>>2]|0)+b|0;if((((c[m+(d*36|0)+4>>2]|0)==(e|0)?(c[m+(d*36|0)>>2]|0)>-1:0)?(c[h>>2]=0,m=c[(c[l>>2]|0)+(d<<5)>>2]|0,(m|0)!=0):0)?(n=(WSd(m,h)|0)==0,m=c[h>>2]|0,n&(m|0)!=0):0){n=m+32|0;m=c[n>>2]|0;c[n>>2]=f?m|4:m&-5}d=d+1|0}while(d>>>0<(c[j>>2]|0)>>>0);i=g;return}function ANd(a){a=a|0;var b=0,c=0;b=i;do switch(a|0){case 20:{c=687120;break}case 26:{c=687464;break}case 89:{c=687008;break}case 11:{c=685296;break}case 91:{c=686424;break}case 43:{c=688528;break}case 33:{c=687872;break}case 27:{c=687552;break}case 18:{c=686072;break}case 83:{c=686312;break}case 4:{c=685e3;break}case 41:{c=688392;break}case 28:{c=687624;break}case 82:{c=692560;break}case 67:{c=690792;break}case 14:{c=685568;break}case 8:{c=685176;break}case 29:{c=687696;break}case 24:{c=687392;break}case 31:{c=687760;break}case 92:{c=686176;break}case 84:{c=686472;break}case 95:{c=688752;break}case 79:{c=692320;break}case 44:{c=688568;break}case 78:{c=692240;break}case 2:{c=684816;break}case 63:{c=690536;break}case 17:{c=685880;break}case 1:{c=684752;break}case 77:{c=692088;break}case 30:{c=687728;break}case 15:{c=685712;break}case 9:{c=685224;break}case 40:{c=688336;break}case 81:{c=692512;break}case 85:{c=686528;break}case 65:{c=690664;break}case 60:{c=690296;break}case 56:{c=689896;break}case 61:{c=690336;break}case 54:{c=689688;break}case 59:{c=690192;break}case 10:{c=685256;break}case 62:{c=690440;break}case 58:{c=690072;break}case 57:{c=689936;break}case 74:{c=691888;break}case 32:{c=687824;break}case 37:{c=688136;break}case 90:{c=686920;break}case 21:{c=687232;break}case 80:{c=692400;break}case 36:{c=688096;break}case 52:{c=689568;break}case 55:{c=689776;break}case 68:{c=690888;break}case 72:{c=691616;break}case 53:{c=689616;break}case 87:{c=686704;break}case 76:{c=692024;break}case 51:{c=689472;break}case 50:{c=689424;break}case 75:{c=691328;break}case 66:{c=690728;break}case 49:{c=689232;break}case 48:{c=689104;break}case 7:{c=685144;break}case 25:{c=687424;break}case 69:{c=691008;break}case 16:{c=685816;break}case 86:{c=686600;break}case 64:{c=690592;break}case 71:{c=691184;break}case 70:{c=691120;break}case 73:{c=691768;break}case 5:{c=685064;break}case 42:{c=688456;break}case 19:{c=687096;break}case 38:{c=688192;break}case 6:{c=685104;break}case 12:{c=685360;break}case 39:{c=688248;break}case 45:{c=688696;break}case 22:{c=687272;break}case 47:{c=689024;break}case 0:{c=692624;break}case 46:{c=688944;break}case 93:{c=688864;break}case 35:{c=688040;break}case 34:{c=687936;break}case 3:{c=684952;break}case 13:{c=685512;break}case 88:{c=686872;break}case 94:{c=688816;break}case 23:{c=687368;break}default:c=692640}while(0);i=b;return c|0}function BNd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+12|0;f=d+8|0;g=d+16|0;h=d+4|0;j=d;c[e>>2]=0;k=(FSd(b,e)|0)==0;a:do if(k&(c[e>>2]|0)>0){l=0;while(1){c[f>>2]=0;if((GSd(b,l,f)|0)==0?(a[g>>0]=0,m=(qSd(c[f>>2]|0,g)|0)!=0,!(m|(a[g>>0]|0)==0)):0){n=1;break}l=l+1|0;if((l|0)>=(c[e>>2]|0))break a}i=d;return n|0}while(0);c[h>>2]=0;e=(ASd(b,h)|0)==0;if(e&(c[h>>2]|0)>0)o=0;else{n=0;i=d;return n|0}while(1){if((BSd(b,o,j)|0)==0?BNd(c[j>>2]|0)|0:0){n=1;p=9;break}o=o+1|0;if((o|0)>=(c[h>>2]|0)){n=0;p=9;break}}if((p|0)==9){i=d;return n|0}return 0}function CNd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im,R=0,T=0,U=Im;f=i;j=c[a+28>>2]|0;a=j+28|0;k=c[a>>2]|0;if((k&1|0)!=0?(l=ea(g[j>>2]),ea(S(ea(l+ea(-1.0))))>=ea(.00100000005)):0){m=j+4|0;n=ea(g[m>>2]);o=ea(ea(l-n)/ea(e>>>0));if(!e)p=n;else{q=(h|0)>0;r=d;l=n;s=0;t=b;while(1){if(q){u=r+(h<<2)|0;v=r;w=0;x=t;while(1){g[v>>2]=ea(l*ea(g[x>>2]));w=w+1|0;if((w|0)==(h|0))break;else{v=v+4|0;x=x+4|0}}y=u;z=t+(h<<2)|0}else{y=r;z=t}n=ea(o+l);s=s+1|0;if((s|0)==(e|0)){p=n;break}else{r=y;l=n;t=z}}}g[m>>2]=p;A=k}else if((d|0)==(b|0))A=k;else{YEi(d|0,b|0,da(e<<2,h)|0)|0;A=c[a>>2]|0}if(!(A&2))B=A;else{A=(e|0)==0;a:do if(!A){b=(h|0)>0;k=j+236|0;m=j+240|0;z=j+36|0;t=j+8|0;y=j+24|0;r=j+16|0;s=0;q=d;while(1){if(b){p=ea(0.0);l=ea(0.0);x=0;v=q;while(1){o=ea(g[v>>2]);v=v+4|0;n=ea(o*o);w=z+(x*24|0)+8|0;o=ea(g[w>>2]);C=ea(n-o);n=ea(o+ea(ea(C*ea(g[t>>2]))+ea(1.00000002e-16)));g[w>>2]=n;w=z+(x*24|0)+12|0;C=ea(g[w>>2]);if(!(n>C)){D=z+(x*24|0)+20|0;E=c[D>>2]|0;c[D>>2]=E+-1;if((E|0)<1){o=ea(ea(C*ea(g[r>>2]))+ea(1.00000002e-16));g[w>>2]=o;F=o}else F=C}else{g[w>>2]=n;c[z+(x*24|0)+20>>2]=c[y>>2];F=n}C=ea(UDi(p,n));n=ea(UDi(l,F));x=x+1|0;if((x|0)==(h|0)){G=C;H=n;break}else{p=C;l=n}}I=G;J=H;K=q+(h<<2)|0}else{I=ea(0.0);J=ea(0.0);K=q}g[k>>2]=I;g[m>>2]=J;s=s+1|0;if((s|0)==(e|0))break;else q=K}if(!A){q=j+228|0;s=j+232|0;m=j+36|0;k=j+12|0;y=j+24|0;z=j+16|0;if((h|0)>0){L=0;M=d}else{r=0;while(1){g[q>>2]=ea(0.0);g[s>>2]=ea(0.0);r=r+1|0;if((r|0)==(e|0))break a}}while(1){l=ea(0.0);p=ea(0.0);r=0;t=M;while(1){n=ea(S(ea(g[t>>2])));t=t+4|0;b=m+(r*24|0)|0;C=ea(g[b>>2]);if(!(n>=C))N=ea(ea(C*ea(g[k>>2]))+ea(1.00000002e-16));else N=n;g[b>>2]=N;b=m+(r*24|0)+4|0;n=ea(g[b>>2]);if(!(N>n)){u=m+(r*24|0)+16|0;x=c[u>>2]|0;c[u>>2]=x+-1;if((x|0)<1){C=ea(ea(n*ea(g[z>>2]))+ea(1.00000002e-16));g[b>>2]=C;O=C}else O=n}else{g[b>>2]=N;c[m+(r*24|0)+16>>2]=c[y>>2];O=N}n=ea(UDi(l,N));C=ea(UDi(p,O));r=r+1|0;if((r|0)==(h|0)){P=n;Q=C;break}else{l=n;p=C}}g[q>>2]=P;g[s>>2]=Q;L=L+1|0;if((L|0)==(e|0))break;else M=M+(h<<2)|0}}}while(0);B=c[a>>2]|0}if(!(B&4)){i=f;return 0}b:do if(e){B=j+20|0;a=j+8|0;if((h|0)>0){R=0;T=d}else{M=0;while(1){Q=ea(g[B>>2]);P=ea(ea(0.0)-Q);g[B>>2]=ea(Q+ea(ea(P*ea(g[a>>2]))+ea(1.00000002e-16)));M=M+1|0;if((M|0)==(e|0))break b}}while(1){M=0;P=ea(0.0);L=T;while(1){Q=ea(UDi(P,ea(S(ea(g[L>>2])))));M=M+1|0;if((M|0)==(h|0)){U=Q;break}else{P=Q;L=L+4|0}}P=ea(U*U);Q=ea(g[B>>2]);O=ea(P-Q);g[B>>2]=ea(Q+ea(ea(O*ea(g[a>>2]))+ea(1.00000002e-16)));R=R+1|0;if((R|0)==(e|0))break;else T=T+(h<<2)|0}}while(0);h=j+32|0;j=c[h>>2]|0;if((j|0)>0){T=j-e|0;c[h>>2]=(T|0)<0?0:T;i=f;return 0}else{i=f;return 0}return 0}function DNd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[153086];c[e+0>>2]=c[f+0>>2];f=bOb(64,e,0,16,3653512,66)|0;c[b+28>>2]=f;b=f+0|0;f=b+64|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(f|0));i=d;return 0}function ENd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+28|0;a=c[f>>2]|0;c[e>>2]=c[153086];c[d+0>>2]=c[e+0>>2];eOb(a,d);c[f>>2]=0;i=b;return 0}function FNd(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0;e=i;f=c[a+28>>2]|0;a:do if(f)switch(b|0){case 1:{g[f+12>>2]=d;break a;break}case 3:{g[f+20>>2]=d;break a;break}case 6:{g[f+32>>2]=d;break a;break}case 4:{g[f+24>>2]=d;break a;break}case 2:{g[f+16>>2]=d;break a;break}case 5:{g[f+28>>2]=d;break a;break}case 0:{g[f+8>>2]=d;break a;break}default:break a}while(0);i=e;return 0}function GNd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=c[a+28>>2]|0;g[d>>2]=ea(ea(aEi(ea(g[b>>2])))*ea(10.0));g[d+4>>2]=ea(ea(aEi(ea(g[b+4>>2])))*ea(20.0));i=e;return 0}function HNd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=Im,z=Im;h=i;j=c[a+28>>2]|0;k=c[a+24>>2]|0;l=ea(g[j+16>>2]);m=ea((c[a+4>>2]|0)>>>0);n=ea(f|0);o=ea(n*ea(l*m));if(!(o<=ea(0.0)))p=ea(ea(1.0)-ea(+U(.00999999046,+ea(ea(1.0)/o))));else p=ea(1.0);o=ea(n*ea(ea(g[j+20>>2])*m));if(!(o<=ea(0.0)))q=ea(ea(1.0)-ea(+U(.00999999046,+ea(ea(1.0)/o))));else q=ea(1.0);o=ea(+U(10.0,+ea(ea(g[j+24>>2])*ea(.0500000007))));m=ea(ea(ea(ea(1.0)/ea(g[j+12>>2]))+ea(-1.0))*ea(.5));n=ea(m*ea(.0250000004));a=j+28|0;l=ea(g[a>>2]);r=l>ea(0.0);s=ea(n/(r?l:ea(1.0)));n=ea(+U(10.0,+ea(ea(g[j+8>>2])*ea(-.100000001))));t=ea(+U(10.0,+ea(l*ea(-.100000001))));l=ea(ea(1.0)/t);r=da(f,e)|0;if(!r){i=h;return 0}e=j+32|0;f=j+4|0;u=0;do{v=ea(g[b+(u<<2)>>2]);w=ea(ea(g[k+(u<<2)>>2])-v);x=ea(v+ea(w*ea(g[e>>2])));w=ea(ea(x*x)+ea(9.99999996e-12));x=ea(g[j>>2]);y=ea(x+ea(ea(ea(w-x)*(w>x?p:q))+ea(1.00000002e-16)));g[j>>2]=y;x=ea(n*y);do if(x>=t)if(x<l){y=ea(ea(aEi(x))*ea(10.0));w=ea(y+ea(g[a>>2]));z=ea(o*ea(+U(10.0,+ea(w*ea(s*w)))));break}else{z=ea(o*ea(+U(+x,+m)));break}else z=o;while(0);g[f>>2]=z;g[d+(u<<2)>>2]=ea(v*z);u=u+1|0}while((u|0)!=(r|0));i=h;return 0}function INd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=Im;h=i;j=c[a+24>>2]|0;a=da(f,e)|0;if(!a){i=h;return 0}else k=0;do{l=ea(g[b+(k<<2)>>2]);g[d+(k<<2)>>2]=ea(l+ea(g[j+(k<<2)>>2]));k=k+1|0}while((k|0)!=(a|0));i=h;return 0}function JNd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=Im,k=0,l=0,m=Im,n=Im;h=i;j=ea(g[(c[a+28>>2]|0)+12>>2]);k=c[a+24>>2]|0;a=da(f,e)|0;if(!a){i=h;return 0}else l=0;do{m=ea(g[b+(l<<2)>>2]);g[d+(l<<2)>>2]=m;n=ea(j*m);e=k+(l<<2)|0;g[e>>2]=ea(ea(g[e>>2])+n);l=l+1|0}while((l|0)!=(a|0));i=h;return 0}function KNd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+16|0;f=g+8|0;h=g+4|0;j=g;c[h>>2]=0;nKd(tSd(b,h)|0,679936,20,680008)|0;k=c[h>>2]|0;h=c[k>>2]|0;if(!(a[674208]|0)){l=-1;m=0;n=0;while(1){if(!(l&1))o=n;else o=1<<31-m|n;m=m+1|0;if((m|0)==32){p=o;q=684064;break}else{l=l>>>1;n=o}}while(1){o=c[572464+((d[q>>0]^p&255)<<2)>>2]^p>>>8;q=q+1|0;if((q|0)==684151){r=o;break}else p=o}p=~r;c[168550]=p;r=674208;c[r>>2]=1;c[r+4>>2]=0;s=p}else s=c[168550]|0;if((h|0)!=(s|0)){i=g;return 0}s=c[k+4>>2]|0;if(!((s|0)!=0&(e|0)==0)){i=g;return 0}nKd(sSd(b,0)|0,679936,32,680056)|0;ko[c[c[s>>2]>>2]&4095](s);c[j>>2]=c[153086];c[f+0>>2]=c[j+0>>2];eOb(s,f);i=g;return 0}function LNd(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+16|0;j=h+8|0;k=h+4|0;l=h;c[b>>2]=680096;PEi(b+4|0,0,148)|0;if(!(a[674208]|0)){m=-1;n=0;o=0;while(1){if(!(m&1))p=o;else p=1<<31-n|o;n=n+1|0;if((n|0)==32){q=p;r=684064;break}else{m=m>>>1;o=p}}while(1){p=c[572464+((d[r>>0]^q&255)<<2)>>2]^q>>>8;r=r+1|0;if((r|0)==684151){s=p;break}else q=p}q=~s;c[168550]=q;s=674208;c[s>>2]=1;c[s+4>>2]=0;t=q}else t=c[168550]|0;c[b+152>>2]=t;c[b+156>>2]=b;c[b+160>>2]=684064;c[b+164>>2]=0;zOd(b+168|0,e);c[b+172>>2]=0;c[b+176>>2]=0;c[b+180>>2]=b;c[b+184>>2]=0;c[b+188>>2]=0;c[b+192>>2]=b;e=b+196|0;c[e>>2]=0;t=b+200|0;c[t>>2]=0;c[b+204>>2]=b;g[b+208>>2]=ea(1.0);g[b+212>>2]=ea(1.0);g[b+216>>2]=ea(1.0);g[b+220>>2]=ea(1.0);g[b+224>>2]=ea(1.0);g[b+228>>2]=ea(1.0);a[b+232>>0]=f&1;f=b+244|0;q=b+233|0;s=q+11|0;do{a[q>>0]=0;q=q+1|0}while((q|0)<(s|0));q=c[153086]|0;if(!b)c[f>>2]=0;else{c[l>>2]=q;c[j+0>>2]=c[l+0>>2];l=bOb(16,j,0,16,3653512,73)|0;c[k>>2]=q;c[j+0>>2]=c[k+0>>2];Bsd(l,j);c[l>>2]=684048;c[l+12>>2]=b;c[f>>2]=l}l=rOd()|0;if((e|0)==(l|0)){i=h;return}f=c[e>>2]|0;if(f){c[f+4>>2]=c[t>>2];c[c[t>>2]>>2]=f;c[e>>2]=0;c[t>>2]=0}f=c[l>>2]|0;c[e>>2]=f;c[t>>2]=l;c[f+4>>2]=e;c[c[t>>2]>>2]=e;i=h;return}function MNd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=680096;f=c[a+236>>2]|0;if(f)RMd(f,a+244|0);f=a+172|0;g=c[f>>2]|0;if(g){h=a+176|0;c[g+4>>2]=c[h>>2];c[c[h>>2]>>2]=g;c[f>>2]=0;c[h>>2]=0}h=a+184|0;f=c[h>>2]|0;if(f){g=a+188|0;c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[h>>2]=0;c[g>>2]=0}g=a+196|0;h=c[g>>2]|0;if(h){f=a+200|0;c[h+4>>2]=c[f>>2];c[c[f>>2]>>2]=h;c[g>>2]=0;c[f>>2]=0}f=a+244|0;g=c[f>>2]|0;if(!g){j=a+168|0;BOd(j);i=b;return}c[g+12>>2]=0;h=c[g+8>>2]|0;k=g+4|0;c[k>>2]=(c[k>>2]|0)+-1;if(!(c[k>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(g,d)}c[f>>2]=0;j=a+168|0;BOd(j);i=b;return}function NNd(a){a=a|0;var b=0;b=i;MNd(a);ACi(a);i=b;return}function ONd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}c[a+164>>2]=b;if(!b){i=d;return}nKd(sSd(b,a+152|0)|0,679936,105,680288)|0;nKd(iSd(b,255)|0,679936,106,680328)|0;nKd($Rd(b,a+228|0)|0,679936,107,680376)|0;PNd(a);i=d;return}function PNd(b){b=b|0;var d=0,e=0,f=0,h=Im,j=Im,k=Im,l=0;d=i;if(!b){i=d;return}e=b+164|0;f=c[e>>2]|0;if(!f){i=d;return}gOd(b+4|0,f);f=c[e>>2]|0;if(f){h=ea(g[b+216>>2]);j=ea(h*ea(g[b+208>>2]));h=ea(j*ea(g[b+212>>2]));if(!(c[b+240>>2]&1))k=h;else k=ea(h*ea(g[b+220>>2]));nKd(ZRd(f,k)|0,679936,472,682656)|0}f=c[e>>2]|0;if(f){k=ea(g[b+224>>2]);nKd(_Rd(f,ea(k*ea(g[b+228>>2])))|0,679936,485,682744)|0}f=c[e>>2]|0;if(!f){i=d;return}if(!(a[b+232>>0]|0))l=(a[b+233>>0]|0)!=0;else l=1;nKd(YRd(f,l)|0,679936,500,682848)|0;i=d;return}function QNd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!a){g=36;i=f;return g|0}c[d>>2]=c[a+(b<<2)+80>>2];c[e>>2]=c[a+(b<<2)+96>>2];g=0;i=f;return g|0}function RNd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;do if(b){f=c[b+164>>2]|0;if(!f){a[d>>0]=0;g=0;break}else{g=nKd(qSd(f,d)|0,679936,154,680576)|0;break}}else g=36;while(0);i=e;return g|0}function SNd(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!a){g=36;i=f;return g|0}if(d){h=(c[a+164>>2]|0)==0;j=a+4|0;k=a+148|0;l=b[k>>1]|0;b[k>>1]=(((l&65535)>>>15&65535|h&1)&65535)<<15&65535|l&32767;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];j=a+146|0;b[j>>1]=b[j>>1]&-2|h&1}h=c[a+164>>2]|0;if(e){j=(h|0)==0;l=a+148|0;k=b[l>>1]|0;b[l>>1]=(((k&65535)>>>15&65535|j&1)&65535)<<15&65535|k&32767;k=a+16|0;c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];k=a+146|0;b[k>>1]=(j&1)<<1&65535|b[k>>1]&-3}if(!h){g=0;i=f;return g|0}g=nKd(jSd(h,d,e)|0,679936,166,680712)|0;i=f;return g|0}function TNd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!a){f=36;i=e;return f|0}g=c[a+164>>2]|0;if(d){h=(g|0)==0;j=a+148|0;k=b[j>>1]|0;b[j>>1]=(((k&65535)>>>15&65535|h&1)&65535)<<15&65535|k&32767;k=a+28|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];k=a+146|0;b[k>>1]=(h&1)<<2&65535|b[k>>1]&-5}if(!g){f=0;i=e;return f|0}f=nKd(mSd(g,d)|0,679936,177,680832)|0;i=e;return f|0}function UNd(a,d,e,f){a=a|0;d=ea(d);e=ea(e);f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;if(!a){j=36;i=h;return j|0}k=c[a+164>>2]|0;l=(k|0)==0;m=a+148|0;n=b[m>>1]|0;g[a+40>>2]=d;o=a+146|0;p=l&1;q=b[o>>1]|0;g[a+44>>2]=e;b[m>>1]=(((n&65535)>>>15&65535|l&1)&65535)<<15&65535|n&32767;g[a+48>>2]=f;b[o>>1]=p<<5&65535|(p<<4&65535|(p<<3&65535|q&-57));if(l){j=0;i=h;return j|0}j=nKd(lSd(k,d,e,f)|0,679936,190,680968)|0;i=h;return j|0}function VNd(a,d){a=a|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0;e=i;if(!a){f=36;i=e;return f|0}h=c[a+164>>2]|0;j=(h|0)==0;k=a+148|0;l=b[k>>1]|0;b[k>>1]=(((l&65535)>>>15&65535|j&1)&65535)<<15&65535|l&32767;g[a+52>>2]=d;l=a+146|0;b[l>>1]=(j&1)<<6&65535|b[l>>1]&-65;if(j){f=0;i=e;return f|0}f=nKd(pSd(h,d)|0,679936,201,681120)|0;i=e;return f|0}function WNd(a,d,e){a=a|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if(!a){h=36;i=f;return h|0}j=c[a+164>>2]|0;k=(j|0)==0;l=a+148|0;m=b[l>>1]|0;g[a+56>>2]=d;n=a+146|0;o=k&1;p=b[n>>1]|0;b[l>>1]=(((m&65535)>>>15&65535|k&1)&65535)<<15&65535|m&32767;g[a+60>>2]=e;b[n>>1]=o<<8&65535|(o<<7&65535|p&-385);if(k){h=0;i=f;return h|0}h=nKd(kSd(j,d,e)|0,679936,213,681240)|0;i=f;return h|0}function XNd(a,d){a=a|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=Im;e=i;if(!a){f=36;i=e;return f|0}h=c[a+164>>2]|0;j=(h|0)==0;k=a+148|0;l=b[k>>1]|0;b[k>>1]=(((l&65535)>>>15&65535|j&1)&65535)<<15&65535|l&32767;g[a+64>>2]=d;l=a+146|0;b[l>>1]=(j&1)<<9&65535|b[l>>1]&-513;if(j){f=0;i=e;return f|0}if(d<ea(0.0))m=ea(0.0);else{j=d>ea(1.0);m=j?ea(1.0):d}f=nKd(oSd(h,m)|0,679936,224,681352)|0;i=e;return f|0}function YNd(a,d){a=a|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0;e=i;if(!a){f=36;i=e;return f|0}h=c[a+164>>2]|0;j=(h|0)==0;k=a+148|0;l=b[k>>1]|0;b[k>>1]=(((l&65535)>>>15&65535|j&1)&65535)<<15&65535|l&32767;g[a+68>>2]=d;l=a+146|0;b[l>>1]=(j&1)<<10&65535|b[l>>1]&-1025;if(j){f=0;i=e;return f|0}f=nKd(nSd(h,d)|0,679936,235,681472)|0;i=e;return f|0}function ZNd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!a){f=36;i=e;return f|0}g=c[a+164>>2]|0;h=(g|0)==0;j=a+148|0;k=b[j>>1]|0;b[j>>1]=(((k&65535)>>>15&65535|h&1)&65535)<<15&65535|k&32767;c[a+76>>2]=d;k=a+146|0;b[k>>1]=(h&1)<<12&65535|b[k>>1]&-4097;if(h){f=0;i=e;return f|0}f=nKd(hSd(g,d)|0,679936,257,681584)|0;i=e;return f|0}function _Nd(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;if(!a){h=36;i=g;return h|0}j=a+164|0;k=a+148|0;l=b[k>>1]|0;b[k>>1]=(((l&65535)>>>15&65535|(c[j>>2]|0)==0)&65535)<<15&65535|l&32767;c[a+(d<<2)+80>>2]=e;l=(c[j>>2]|0)==0;m=b[k>>1]|0;n=m&15;o=1<<d;if(l)p=n|o;else p=n&~o;b[k>>1]=((l&1|(m&65535)>>>15&65535)&65535)<<15&65535|(m&32752|p&15);c[a+(d<<2)+96>>2]=f;a=c[j>>2]|0;j=b[k>>1]|0;p=(j&65535)>>>4&15;if(!a){b[k>>1]=((p|o)&65535)<<4&240|j&-241;h=0;i=g;return h|0}else{b[k>>1]=(p&(o^2063)&65535)<<4&65535|j&-241;h=nKd(bSd(a,d,e,f)|0,679936,269,681712)|0;i=g;return h|0}return 0}function $Nd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!d){g=36;i=f;return g|0}h=c[d+164>>2]|0;j=(h|0)==0;k=d+148|0;l=b[k>>1]|0;a[d+144>>0]=e&1;b[k>>1]=(j&1)<<13&65535|((((l&65535)>>>15&65535|j&1)&65535)<<15&65535|l&24575);if(j){g=0;i=f;return g|0}g=nKd(cSd(h,e)|0,679936,280,681816)|0;i=f;return g|0}function aOd(a,d){a=a|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0;e=i;if(!a){f=36;i=e;return f|0}h=c[a+164>>2]|0;j=(h|0)==0;k=a+148|0;l=b[k>>1]|0;g[a+112>>2]=d;b[k>>1]=(j&1)<<8&65535|((((l&65535)>>>15&65535|j&1)&65535)<<15&65535|l&32511);if(j){f=0;i=e;return f|0}f=nKd(aSd(h,d)|0,679936,291,681896)|0;i=e;return f|0}function bOd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!a){f=36;i=e;return f|0}g=c[a+164>>2]|0;h=(g|0)==0;j=a+148|0;k=b[j>>1]|0;c[a+124>>2]=d;b[j>>1]=(h&1)<<11&65535|((((k&65535)>>>15&65535|h&1)&65535)<<15&65535|k&30719);if(h){f=0;i=e;return f|0}f=nKd(dSd(g,d)|0,679936,302,681984)|0;i=e;return f|0}function cOd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!a){f=36;i=e;return f|0}g=c[a+164>>2]|0;if(d){h=(g|0)==0;j=a+148|0;k=b[j>>1]|0;l=(((k&65535)>>>15&65535|h&1)&65535)<<15&65535|k&32767;b[j>>1]=l;k=a+128|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];b[j>>1]=(h&1)<<12&65535|l&-4097}if(!g){f=0;i=e;return f|0}f=nKd(fSd(g,d)|0,679936,313,682112)|0;i=e;return f|0}function dOd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!a){e=36;i=d;return e|0}if(b){f=a+128|0;c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2]}f=c[a+164>>2]|0;if(!f){e=0;i=d;return e|0}e=nKd(gSd(f,b)|0,679936,324,682256)|0;i=d;return e|0}function eOd(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!a){f=36;i=e;return f|0}g=a+148|0;h=b[g>>1]|0;j=c[a+164>>2]|0;k=(j|0)==0;c[a+116>>2]=d;b[g>>1]=(k&1)<<9&65535|(((k&1|(h&65535)>>>15&65535)&65535)<<15&65535|h&31231);if(k){f=0;i=e;return f|0}k=eSd(j,d,2)|0;if(!k){f=0;i=e;return f|0}else if((k|0)==54){b[g>>1]=b[g>>1]|-32256;f=0;i=e;return f|0}else{nKd(k,679936,374,3141920)|0;f=0;i=e;return f|0}return 0}function fOd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!d){g=36;i=f;return g|0}h=c[d+164>>2]|0;j=(h|0)==0;k=d+148|0;l=b[k>>1]|0;a[d+145>>0]=e&1;b[k>>1]=(j&1)<<14&65535|((((l&65535)>>>15&65535|j&1)&65535)<<15&65535|l&16383);if(j){g=0;i=f;return g|0}g=nKd(rSd(h,e?2:1)|0,679936,411,682424)|0;i=f;return g|0}function gOd(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=0,C=0,D=0;f=i;h=d+144|0;j=b[h>>1]|0;if(j<<16>>16>=0){i=f;return}k=j&32767;b[h>>1]=k;if(!(j&8192))l=k;else{nKd(cSd(e,(a[d+140>>0]|0)!=0)|0,679936,522,682960)|0;k=b[h>>1]&-8193;b[h>>1]=k;l=k}k=d+142|0;if(!(b[k>>1]&2048))m=l;else{nKd(iSd(e,c[d+68>>2]|0)|0,679936,523,682984)|0;b[k>>1]=b[k>>1]&-2049;m=b[h>>1]|0}if(!(m&16384))n=m;else{rSd(e,(a[d+141>>0]|0)!=0?2:1)|0;m=b[h>>1]&-16385;b[h>>1]=m;n=m}if(!(n&512))o=n;else{nKd(eSd(e,c[d+112>>2]|0,2)|0,679936,525,683016)|0;n=b[h>>1]&-513;b[h>>1]=n;o=n}if(!(o&1024))p=o;else{nKd(eSd(e,c[d+116>>2]|0,1)|0,679936,526,683072)|0;o=b[h>>1]&-1025;b[h>>1]=o;p=o}if(!(b[k>>1]&4096))q=p;else{nKd(hSd(e,c[d+72>>2]|0)|0,679936,527,683128)|0;b[k>>1]=b[k>>1]&-4097;q=b[h>>1]|0}if(!(q&2048))r=q;else{nKd(dSd(e,c[d+120>>2]|0)|0,679936,528,683160)|0;q=b[h>>1]&-2049;b[h>>1]=q;r=q}if(!(r&4096))s=r;else{nKd(fSd(e,d+124|0)|0,679936,529,683192)|0;r=b[h>>1]&-4097;b[h>>1]=r;s=r}if(!(s&2))t=s;else{nKd(bSd(e,1,c[d+80>>2]|0,c[d+96>>2]|0)|0,679936,530,683240)|0;s=b[h>>1]&-35;b[h>>1]=s;t=s}if(!(t&4))u=t;else{nKd(bSd(e,2,c[d+84>>2]|0,c[d+100>>2]|0)|0,679936,531,683376)|0;t=b[h>>1]&-69;b[h>>1]=t;u=t}if(!(u&8))v=u;else{nKd(bSd(e,3,c[d+88>>2]|0,c[d+104>>2]|0)|0,679936,532,683504)|0;u=b[h>>1]&-137;b[h>>1]=u;v=u}if(v&256){nKd(aSd(e,ea(g[d+108>>2]))|0,679936,533,683640)|0;b[h>>1]=b[h>>1]&-257}h=b[k>>1]|0;if(!(h&1))w=h;else{nKd(jSd(e,d,d+12|0)|0,679936,535,683664)|0;h=b[k>>1]&-4;b[k>>1]=h;w=h}if(!(w&4))x=w;else{nKd(mSd(e,d+24|0)|0,679936,536,683704)|0;w=b[k>>1]&-5;b[k>>1]=w;x=w}if(!(x&8))y=x;else{z=ea(g[d+36>>2]);A=ea(g[d+40>>2]);nKd(lSd(e,z,A,ea(g[d+44>>2]))|0,679936,537,683752)|0;x=b[k>>1]&-57;b[k>>1]=x;y=x}if(!(y&64))B=y;else{nKd(pSd(e,ea(g[d+48>>2]))|0,679936,538,683832)|0;y=b[k>>1]&-65;b[k>>1]=y;B=y}if(!(B&128))C=B;else{A=ea(g[d+52>>2]);nKd(kSd(e,A,ea(g[d+56>>2]))|0,679936,539,683880)|0;B=b[k>>1]&-385;b[k>>1]=B;C=B}if(!(C&512))D=C;else{nKd(oSd(e,ea(g[d+60>>2]))|0,679936,540,683928)|0;C=b[k>>1]&-513;b[k>>1]=C;D=C}if(!(D&1024)){i=f;return}nKd(nSd(e,ea(g[d+64>>2]))|0,679936,541,683968)|0;b[k>>1]=b[k>>1]&-1025;i=f;return}function hOd(a){a=a|0;var b=0,d=0,e=Im,f=Im,h=Im;b=i;if(!a){i=b;return}d=c[a+164>>2]|0;if(!d){i=b;return}e=ea(g[a+216>>2]);f=ea(e*ea(g[a+208>>2]));e=ea(f*ea(g[a+212>>2]));if(!(c[a+240>>2]&1))h=e;else h=ea(e*ea(g[a+220>>2]));nKd(ZRd(d,h)|0,679936,472,682656)|0;i=b;return}function iOd(a){a=a|0;var b=0,d=0,e=Im;b=i;if(!a){i=b;return}d=c[a+164>>2]|0;if(!d){i=b;return}e=ea(g[a+224>>2]);nKd(_Rd(d,ea(e*ea(g[a+228>>2])))|0,679936,485,682744)|0;i=b;return}function jOd(b){b=b|0;var d=0,e=0,f=0;d=i;if(!b){i=d;return}e=c[b+164>>2]|0;if(!e){i=d;return}if(!(a[b+232>>0]|0))f=(a[b+233>>0]|0)!=0;else f=1;nKd(YRd(e,f)|0,679936,500,682848)|0;i=d;return}function kOd(b){b=b|0;var d=0,e=0;d=i;if(!b){i=d;return}if(c[b+184>>2]|0)a[b+235>>0]=1;e=c[b+164>>2]|0;if(!e){i=d;return}nKd(XRd(e)|0,679936,454,682584)|0;i=d;return}function lOd(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+164|0;f=c[e>>2]|0;if(!f){i=d;return}g=a+148|0;h=b[g>>1]|0;if(h&512){j=(eSd(f,c[a+116>>2]|0,2)|0)==0;f=b[g>>1]|0;if(j){j=f&-513;b[g>>1]=j;k=j}else k=f}else k=h;if(!(k&1024)){i=d;return}if(eSd(c[e>>2]|0,c[a+120>>2]|0,1)|0){i=d;return}b[g>>1]=b[g>>1]&-1025;i=d;return}function mOd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function nOd(a){a=a|0;return c[a+12>>2]|0}function oOd(a){a=a|0;return}function pOd(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=b;if(!(a[669976]|0)){j=-1;k=0;l=0;while(1){if(!(j&1))m=l;else m=1<<31-k|l;k=k+1|0;if((k|0)==32){n=m;o=684656;break}else{j=j>>>1;l=m}}while(1){m=c[572464+((d[o>>0]^n&255)<<2)>>2]^n>>>8;o=o+1|0;if((o|0)==684744){p=m;break}else n=m}n=~p;c[167492]=n;p=669976;c[p>>2]=1;c[p+4>>2]=0;q=n}else q=c[167492]|0;c[b+12>>2]=q;c[b+16>>2]=b;c[b+20>>2]=684656;c[b+24>>2]=-1;q=b+28|0;c[q>>2]=q;c[b+32>>2]=q;q=b+80|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;q=b+96|0;n=b+100|0;p=b+36|0;o=p+40|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(o|0));c[q>>2]=q;c[n>>2]=q;c[b+104>>2]=b;c[b+108>>2]=b;c[b+112>>2]=0;a[b+116>>0]=0;q=b+120|0;n=c[153086]|0;if(!b){c[q>>2]=0;i=e;return}else{c[h>>2]=n;c[f+0>>2]=c[h+0>>2];h=bOb(16,f,0,16,3653512,73)|0;c[g>>2]=n;c[f+0>>2]=c[g+0>>2];Bsd(h,f);c[h>>2]=684640;c[h+12>>2]=b;c[q>>2]=h;i=e;return}}function qOd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+64|0;e=d+8|0;f=d+48|0;g=d+36|0;j=d+24|0;k=d;h[k>>3]=+Ype();l=b+28|0;m=b+32|0;while(1){if((c[m>>2]|0)==(l|0))break;NOd(k,684152,113);kOd(c[(c[m>>2]|0)+8>>2]|0)}k=b+120|0;n=c[k>>2]|0;if(n){c[n+12>>2]=0;o=c[n+8>>2]|0;p=n+4|0;c[p>>2]=(c[p>>2]|0)+-1;if(!(c[p>>2]|0)){ko[c[c[n>>2]>>2]&4095](n);c[f>>2]=o;c[e+0>>2]=c[f+0>>2];eOb(n,e)}c[k>>2]=0}n=b+108|0;o=c[b+104>>2]|0;c[o+108>>2]=c[n>>2];c[(c[n>>2]|0)+104>>2]=o;o=c[b+36>>2]|0;if(!o){n=c[b+40>>2]|0;if((n|0)!=0?(p=$Sd(n)|0,(p|0)!=0):0){n=OOd(p)|0;c[e>>2]=684152;c[e+4>>2]=127;c[e+8>>2]=684248;c[e+12>>2]=n;Lsd(g,692656,e);if(!(a[g>>0]&1))q=g+1|0;else q=c[g+8>>2]|0;Krd(q,0,3653512,16,1,0,0,0);xri(g)}}else{g=$Sd(o)|0;if(g){o=OOd(g)|0;c[e>>2]=684152;c[e+4>>2]=125;c[e+8>>2]=684224;c[e+12>>2]=o;Lsd(j,692656,e);if(!(a[j>>0]&1))r=j+1|0;else r=c[j+8>>2]|0;Krd(r,0,3653512,16,1,0,0,0);xri(j)}}j=c[b>>2]|0;if(j){r=b+4|0;c[j+4>>2]=c[r>>2];c[c[r>>2]>>2]=j;c[b>>2]=0;c[r>>2]=0}r=c[m>>2]|0;if((r|0)!=(l|0)){j=r;do{r=j+4|0;o=j;j=c[r>>2]|0;c[o>>2]=0;c[r>>2]=0}while((j|0)!=(l|0))}c[m>>2]=l;c[l>>2]=l;j=b+96|0;r=b+100|0;o=c[r>>2]|0;if((o|0)!=(j|0)){g=o;do{o=g+4|0;q=g;g=c[o>>2]|0;c[q>>2]=0;c[o>>2]=0}while((g|0)!=(j|0))}c[r>>2]=j;c[j>>2]=j;g=c[k>>2]|0;if(g){o=c[g+8>>2]|0;q=g+4|0;c[q>>2]=(c[q>>2]|0)+-1;if(!(c[q>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[f>>2]=o;c[e+0>>2]=c[f+0>>2];eOb(g,e)}c[k>>2]=0}c[r>>2]=0;c[j>>2]=0;if(!(a[b+64>>0]&1)){c[m>>2]=0;c[l>>2]=0;i=d;return}j=c[b+72>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(j,e);c[m>>2]=0;c[l>>2]=0;i=d;return}function rOd(){var a=0,b=0;a=i;b=SLd(aMd()|0)|0;i=a;return b|0}function sOd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;j=d+8|0;h[g>>3]=+Ype();AOd(j,b);k=b+28|0;l=c[b+32>>2]|0;while(1){if((l|0)==(k|0))break;NOd(g,684152,165);m=c[l+4>>2]|0;kOd(c[l+8>>2]|0);l=m}l=b+120|0;g=c[l>>2]|0;if(g){c[g+12>>2]=0;k=c[g+8>>2]|0;m=g+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(g,e)}c[l>>2]=0}l=b+108|0;e=b+104|0;g=c[e>>2]|0;c[g+108>>2]=c[l>>2];c[(c[l>>2]|0)+104>>2]=g;c[e>>2]=b;c[l>>2]=b;l=SLd(aMd()|0)|0;e=b+116|0;if(a[e>>0]|0){BOd(j);i=d;return}g=l+24|0;if((b|0)!=(g|0)){l=c[b>>2]|0;f=b+4|0;if(l){c[l+4>>2]=c[f>>2];c[c[f>>2]>>2]=l;c[b>>2]=0;c[f>>2]=0}l=c[g>>2]|0;c[b>>2]=l;c[f>>2]=g;c[l+4>>2]=b;c[c[f>>2]>>2]=b}a[e>>0]=1;BOd(j);i=d;return}function tOd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+48|0;e=d;f=d+20|0;g=d+16|0;h=d+36|0;j=d+40|0;k=d+41|0;l=d+32|0;m=b+44|0;n=c[m>>2]|0;if((n|0)==1){o=b+36|0;if(cTd(c[o>>2]|0,g,h,j,k)|0){i=d;return}p=c[g>>2]|0;if(!p){q=fTd(c[o>>2]|0,b+12|0)|0;if(q){r=OOd(q)|0;c[e>>2]=684152;c[e+4>>2]=205;c[e+8>>2]=684272;c[e+12>>2]=r;Lsd(f,692656,e);if(!(a[f>>0]&1))s=f+1|0;else s=c[f+8>>2]|0;Krd(s,0,3653512,16,1,0,0,0);xri(f)}c[l>>2]=0;s=bTd(c[o>>2]|0,l)|0;if(s){r=OOd(s)|0;c[e>>2]=684152;c[e+4>>2]=207;c[e+8>>2]=684304;c[e+12>>2]=r;Lsd(f,692656,e);if(!(a[f>>0]&1))t=f+1|0;else t=c[f+8>>2]|0;Krd(t,0,3653512,16,1,0,0,0);xri(f)}if((c[l>>2]|0)<=0){c[m>>2]=3;c[b+40>>2]=c[o>>2];c[o>>2]=0;i=d;return}if(aTd(c[o>>2]|0,c[b+24>>2]|0,b+40|0)|0){i=d;return}c[m>>2]=2;i=d;return}else if((p|0)==2){c[m>>2]=4;i=d;return}else{i=d;return}}else if((n|0)==2){n=b+40|0;if(cTd(c[n>>2]|0,g,h,j,k)|0){i=d;return}k=c[g>>2]|0;if((k|0)==2){c[m>>2]=4;i=d;return}else if(!k){k=fTd(c[n>>2]|0,b+12|0)|0;if(k){b=OOd(k)|0;c[e>>2]=684152;c[e+4>>2]=241;c[e+8>>2]=684344;c[e+12>>2]=b;Lsd(f,692656,e);if(!(a[f>>0]&1))u=f+1|0;else u=c[f+8>>2]|0;Krd(u,0,3653512,16,1,0,0,0);xri(f)}c[m>>2]=3;i=d;return}else{i=d;return}}else{i=d;return}}function uOd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=i;i=i+80|0;h=g;j=g+16|0;k=g+28|0;l=g+8|0;m=g+32|0;n=g+20|0;o=g+24|0;p=g+12|0;q=g+36|0;r=g+40|0;s=g+44|0;t=g+48|0;u=g+52|0;v=g+56|0;w=g+68|0;x=g+72|0;y=(d|0)==0;if(!y?(c[d+44>>2]|0)==4:0){c[b>>2]=0;i=g;return}if(a[d+116>>0]|0){Krd(684384,0,3653512,262,1,0,0,0);c[b>>2]=0;i=g;return}z=d+60|0;if((c[z>>2]&2|0)!=0?(c[d+32>>2]|0)!=(d+28|0):0){A=SLd(aMd()|0)|0;B=c[d+24>>2]|0;C=c[d+48>>2]|0;D=c[z>>2]|0;c[p>>2]=c[d+52>>2];wOd(o,A,d+64|0,B,C,D,p,1);p=c[o>>2]|0;do if((p|0)!=0?(D=c[p+12>>2]|0,C=p+12|0,(D|0)!=0):0){c[D+104>>2]=d;B=d+108|0;c[D+108>>2]=c[B>>2];c[(c[B>>2]|0)+104>>2]=D;c[B>>2]=D;if((c[D+44>>2]|0)==4){B=SLd(aMd()|0)|0;A=D+116|0;if(!(a[A>>0]|0)){z=B+24|0;if((D|0)!=(z|0)){B=c[D>>2]|0;E=D+4|0;if(B){c[B+4>>2]=c[E>>2];c[c[E>>2]>>2]=B;c[D>>2]=0;c[E>>2]=0}B=c[z>>2]|0;c[D>>2]=B;c[E>>2]=z;c[B+4>>2]=D;c[c[E>>2]>>2]=D}a[A>>0]=1}c[b>>2]=0;break}xOd(e,o);A=c[C>>2]|0;if((A|0)!=0?(c[A+44>>2]|0)==3:0){uOd(b,D,e,f);break}zOd(r,o);UMd(q,r,f);BOd(r);A=c[q>>2]|0;C=(A|0)==0;if(C)F=0;else F=c[A+12>>2]|0;E=D+96|0;B=F+184|0;if((B|0)!=(E|0)){z=c[B>>2]|0;G=F+188|0;if(z){c[z+4>>2]=c[G>>2];c[c[G>>2]>>2]=z;c[B>>2]=0;c[G>>2]=0}z=c[E>>2]|0;c[B>>2]=z;c[G>>2]=E;c[z+4>>2]=B;c[c[G>>2]>>2]=B}if(C)H=0;else H=c[A+12>>2]|0;B=D+28|0;D=H+172|0;if((D|0)!=(B|0)){G=c[D>>2]|0;z=H+176|0;if(G){c[G+4>>2]=c[z>>2];c[c[z>>2]>>2]=G;c[D>>2]=0;c[z>>2]=0}G=c[B>>2]|0;c[D>>2]=G;c[z>>2]=B;c[G+4>>2]=D;c[c[z>>2]>>2]=D}TMd(b,q);if(!C){C=c[A+8>>2]|0;D=A+4|0;c[D>>2]=(c[D>>2]|0)+-1;if(!(c[D>>2]|0)){ko[c[c[A>>2]>>2]&4095](A);c[j>>2]=C;c[h+0>>2]=c[j+0>>2];eOb(A,h)}c[q>>2]=0}}else I=10;while(0);if((I|0)==10)c[b>>2]=0;BOd(o);i=g;return}if(!y?(c[d+44>>2]|0)==3:0){zOd(t,e);UMd(s,t,f);BOd(t);c[u>>2]=0;t=c[(aMd()|0)+92>>2]|0;y=HTd(t,-1,c[d+40>>2]|0,1,u)|0;t=c[u>>2]|0;if((y|0)!=0|(t|0)==0){if((y|0)==10){u=d+52|0;o=c[u>>2]|0;do if(!o)J=0;else{c[l>>2]=o;q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(h,q,l);H=c[h>>2]|0;F=c[q+28>>2]|0;if((H|0)==-1){K=F+(c[q+32>>2]<<3)|0;break}else{K=F+(H<<3)|0;break}}else K=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if(!((K|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(c[K+4>>2]|0)!=0:0))I=52}else I=52;if((I|0)==52?(hQb(c[u>>2]|0)|0)==0:0){J=0;break}c[k>>2]=c[u>>2];q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(h,q,k);H=c[h>>2]|0;F=c[q+28>>2]|0;if((H|0)==-1){L=F+(c[q+32>>2]<<3)|0;break}else{L=F+(H<<3)|0;break}}else L=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((L|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[L+4>>2]|0,(q|0)!=0):0)M=q;else I=61}else I=61;if((I|0)==61)M=hQb(c[u>>2]|0)|0;J=c[M+4>>2]|0}while(0);Krd(684424,0,3653512,301,512,J,0,0)}else{c[h>>2]=OOd(y)|0;Lsd(v,684480,h);y=d+52|0;J=c[y>>2]|0;do if(!J)N=0;else{c[j>>2]=J;M=c[137784]|0;if(M){do if((c[M+36>>2]|0)!=(c[M+4>>2]|0)){fRb(h,M,j);u=c[h>>2]|0;L=c[M+28>>2]|0;if((u|0)==-1){O=L+(c[M+32>>2]<<3)|0;break}else{O=L+(u<<3)|0;break}}else O=(c[M+28>>2]|0)+(c[M+32>>2]<<3)|0;while(0);M=c[137784]|0;if(!((O|0)!=((c[M+28>>2]|0)+(c[M+32>>2]<<3)|0)?(c[O+4>>2]|0)!=0:0))I=73}else I=73;if((I|0)==73?(hQb(c[y>>2]|0)|0)==0:0){N=0;break}c[m>>2]=c[y>>2];M=c[137784]|0;if(M){do if((c[M+36>>2]|0)!=(c[M+4>>2]|0)){fRb(h,M,m);u=c[h>>2]|0;L=c[M+28>>2]|0;if((u|0)==-1){P=L+(c[M+32>>2]<<3)|0;break}else{P=L+(u<<3)|0;break}}else P=(c[M+28>>2]|0)+(c[M+32>>2]<<3)|0;while(0);M=c[137784]|0;if((P|0)!=((c[M+28>>2]|0)+(c[M+32>>2]<<3)|0)?(M=c[P+4>>2]|0,(M|0)!=0):0)Q=M;else I=82}else I=82;if((I|0)==82)Q=hQb(c[y>>2]|0)|0;N=c[Q+4>>2]|0}while(0);if(!(a[v>>0]&1))R=v+1|0;else R=c[v+8>>2]|0;Krd(R,0,3653512,303,1,N,0,0);xri(v)}c[b>>2]=0;S=c[s>>2]|0}else{v=c[s>>2]|0;if(!v){ONd(0,t);T=0}else{ONd(c[v+12>>2]|0,t);T=c[v+12>>2]|0}t=d+28|0;N=T+172|0;if((N|0)!=(t|0)){R=c[N>>2]|0;Q=T+176|0;if(R){c[R+4>>2]=c[Q>>2];c[c[Q>>2]>>2]=R;c[N>>2]=0;c[Q>>2]=0}R=c[t>>2]|0;c[N>>2]=R;c[Q>>2]=t;c[R+4>>2]=N;c[c[Q>>2]>>2]=N}TMd(b,s);S=v}if(!S){i=g;return}v=c[S+8>>2]|0;N=S+4|0;c[N>>2]=(c[N>>2]|0)+-1;if(!(c[N>>2]|0)){ko[c[c[S>>2]>>2]&4095](S);c[n>>2]=v;c[h+0>>2]=c[n+0>>2];eOb(S,h)}c[s>>2]=0;i=g;return}zOd(x,e);UMd(w,x,f);BOd(x);x=c[w>>2]|0;f=(x|0)==0;if(f)U=0;else U=c[x+12>>2]|0;e=d+96|0;s=U+184|0;if((s|0)!=(e|0)){S=c[s>>2]|0;n=U+188|0;if(S){c[S+4>>2]=c[n>>2];c[c[n>>2]>>2]=S;c[s>>2]=0;c[n>>2]=0}S=c[e>>2]|0;c[s>>2]=S;c[n>>2]=e;c[S+4>>2]=s;c[c[n>>2]>>2]=s}if(f)V=0;else V=c[x+12>>2]|0;s=d+28|0;d=V+172|0;if((d|0)!=(s|0)){n=c[d>>2]|0;S=V+176|0;if(n){c[n+4>>2]=c[S>>2];c[c[S>>2]>>2]=n;c[d>>2]=0;c[S>>2]=0}n=c[s>>2]|0;c[d>>2]=n;c[S>>2]=s;c[n+4>>2]=d;c[c[S>>2]>>2]=d}TMd(b,w);if(f){i=g;return}f=c[x+8>>2]|0;b=x+4|0;c[b>>2]=(c[b>>2]|0)+-1;if(!(c[b>>2]|0)){ko[c[c[x>>2]>>2]&4095](x);c[j>>2]=f;c[h+0>>2]=c[j+0>>2];eOb(x,h)}c[w>>2]=0;i=g;return}function vOd(a){a=a|0;var b=0;if(!a)b=0;else b=c[a+44>>2]|0;return b|0}function wOd(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;m=i;i=i+192|0;n=m;o=m+172|0;p=m+176|0;q=m+8|0;r=m+168|0;s=m+32|0;t=m+16|0;a:do if(!l?(h[q>>3]=+Ype(),u=c[d+20>>2]|0,v=d+16|0,(u|0)!=(v|0)):0){w=u;while(1){NOd(q,684152,784);u=c[w+8>>2]|0;if(((_sd(u+64|0,e)|0?(c[u+24>>2]|0)==(f|0):0)?(c[u+48>>2]|0)==(g|0):0)?(c[u+60>>2]&1|0)!=0:0){x=u;break}w=c[w+4>>2]|0;if((w|0)==(v|0))break a}AOd(b,x);i=m;return}while(0);c[r>>2]=c[153086];c[n+0>>2]=c[r+0>>2];r=bOb(128,n,0,16,3653512,798)|0;pOd(r);c[r+24>>2]=f;c[r+44>>2]=1;f=r+48|0;c[f>>2]=g;c[r+60>>2]=j;j=r+64|0;do if((j|0)!=(e|0)){x=a[e>>0]|0;if(!(x&1)){y=(x&255)>>>1;z=e+1|0}else{y=c[e+4>>2]|0;z=c[e+8>>2]|0}x=a[j>>0]|0;if(!(x&1)){A=10;B=x}else{x=c[j>>2]|0;A=(x&-2)+-1|0;B=x&255}x=(B&1)==0;if(y>>>0>A>>>0){if(x)C=(B&255)>>>1;else C=c[r+68>>2]|0;eXb(j,A,y-A|0,C,0,C,y,z);break}if(x)D=r+65|0;else D=c[r+72>>2]|0;aFi(D|0,z|0,y|0)|0;a[D+y>>0]=0;if(!(a[j>>0]&1)){a[j>>0]=y<<1;break}else{c[r+68>>2]=y;break}}while(0);y=r+80|0;j=e+16|0;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[y+12>>2]=c[j+12>>2];c[r+52>>2]=c[k>>2];y=c[k>>2]|0;if(!y)E=0;else{c[o>>2]=y;y=c[137784]|0;if(y){do if((c[y+36>>2]|0)!=(c[y+4>>2]|0)){fRb(n,y,o);D=c[n>>2]|0;z=c[y+28>>2]|0;if((D|0)==-1){F=z+(c[y+32>>2]<<3)|0;break}else{F=z+(D<<3)|0;break}}else F=(c[y+28>>2]|0)+(c[y+32>>2]<<3)|0;while(0);y=c[137784]|0;if((F|0)!=((c[y+28>>2]|0)+(c[y+32>>2]<<3)|0)?(y=c[F+4>>2]|0,(y|0)!=0):0)G=y;else H=35}else H=35;if((H|0)==35)G=hQb(c[k>>2]|0)|0;E=G}c[r+56>>2]=E;E=d+8|0;if((r|0)!=(E|0)){d=c[r>>2]|0;G=r+4|0;if(d){c[d+4>>2]=c[G>>2];c[c[G>>2]>>2]=d;c[r>>2]=0;c[G>>2]=0}d=c[E>>2]|0;c[r>>2]=d;c[G>>2]=E;c[d+4>>2]=r;c[c[G>>2]>>2]=r}PEi(s|0,0,136)|0;c[s>>2]=136;if(!(g&65536))c[s+72>>2]=8;c[s+68>>2]=r+12;c[s+8>>2]=c[j>>2];c[s+4>>2]=c[e+24>>2];j=c[(aMd()|0)+92>>2]|0;if(!(a[e>>0]&1))I=e+1|0;else I=c[e+8>>2]|0;g=r+36|0;G=CTd(j,I,c[f>>2]|0,s,g)|0;if((G|0)==25){c[s+72>>2]=0;I=c[(aMd()|0)+92>>2]|0;if(!(a[e>>0]&1))J=e+1|0;else J=c[e+8>>2]|0;K=CTd(I,J,c[f>>2]|0,s,g)|0}else K=G;if(!K){AOd(b,r);i=m;return}if(!(a[e>>0]&1))L=e+1|0;else L=c[e+8>>2]|0;e=OOd(K)|0;c[n>>2]=L;c[n+4>>2]=e;Lsd(t,684528,n);if(!(a[t>>0]&1))M=t+1|0;else M=c[t+8>>2]|0;Krd(M,0,3653512,835,1,0,0,0);xri(t);t=c[153086]|0;if(r)qOd(r);c[p>>2]=t;c[n+0>>2]=c[p+0>>2];eOb(r,n);c[b>>2]=0;i=m;return}function xOd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=c[d>>2]|0;if((h|0)==(j|0)){i=e;return}if(!h)k=0;else k=c[h+12>>2]|0;if(!j)l=h;else{h=j+4|0;c[h>>2]=(c[h>>2]|0)+1;l=c[b>>2]|0}if((l|0)!=0?(h=c[l+8>>2]|0,j=l+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[l>>2]>>2]&4095](l);c[g>>2]=h;c[f+0>>2]=c[g+0>>2];eOb(l,f)}c[b>>2]=c[d>>2];if(!k){i=e;return}d=c[k+120>>2]|0;if(!d){i=e;return}if((c[d+4>>2]|0)!=1){i=e;return}if(((c[k+44>>2]|0)+-3|0)>>>0>=2){i=e;return}d=SLd(aMd()|0)|0;b=k+116|0;if(a[b>>0]|0){i=e;return}f=d+24|0;if((k|0)!=(f|0)){d=c[k>>2]|0;l=k+4|0;if(d){c[d+4>>2]=c[l>>2];c[c[l>>2]>>2]=d;c[k>>2]=0;c[l>>2]=0}d=c[f>>2]|0;c[k>>2]=d;c[l>>2]=f;c[d+4>>2]=k;c[c[l>>2]>>2]=k}a[b>>0]=1;i=e;return}function yOd(a){a=a|0;c[a>>2]=0;return}function zOd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;g=c[b>>2]|0;if(((g|0)!=0?(h=g+4|0,c[h>>2]=(c[h>>2]|0)+1,h=c[a>>2]|0,(h|0)!=0):0)?(g=c[h+8>>2]|0,j=h+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=g;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[a>>2]=c[b>>2];i=d;return}function AOd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;if(!b){i=d;return}g=b+120|0;b=c[g>>2]|0;if(((b|0)!=0?(h=b+4|0,c[h>>2]=(c[h>>2]|0)+1,h=c[a>>2]|0,(h|0)!=0):0)?(b=c[h+8>>2]|0,j=h+4|0,c[j>>2]=(c[j>>2]|0)+-1,(c[j>>2]|0)==0):0){ko[c[c[h>>2]>>2]&4095](h);c[f>>2]=b;c[e+0>>2]=c[f+0>>2];eOb(h,e)}c[a>>2]=c[g>>2];i=d;return}function BOd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;if(!g){i=d;return}h=c[g+12>>2]|0;j=c[g+8>>2]|0;k=g+4|0;c[k>>2]=(c[k>>2]|0)+-1;if(!(c[k>>2]|0)){ko[c[c[g>>2]>>2]&4095](g);c[f>>2]=j;c[e+0>>2]=c[f+0>>2];eOb(g,e)}c[b>>2]=0;if(!h){i=d;return}g=c[h+120>>2]|0;if((((g|0)!=0?(c[g+4>>2]|0)==1:0)?((c[h+44>>2]|0)+-3|0)>>>0<2:0)?(g=SLd(aMd()|0)|0,j=h+116|0,(a[j>>0]|0)==0):0){k=g+24|0;if((h|0)!=(k|0)){g=c[h>>2]|0;l=h+4|0;if(g){c[g+4>>2]=c[l>>2];c[c[l>>2]>>2]=g;c[h>>2]=0;c[l>>2]=0}g=c[k>>2]|0;c[h>>2]=g;c[l>>2]=k;c[g+4>>2]=h;c[c[l>>2]>>2]=h}a[j>>0]=1}j=c[b>>2]|0;if(!j){i=d;return}h=c[j+8>>2]|0;l=j+4|0;c[l>>2]=(c[l>>2]|0)+-1;if(!(c[l>>2]|0)){ko[c[c[j>>2]>>2]&4095](j);c[f>>2]=h;c[e+0>>2]=c[f+0>>2];eOb(j,e)}c[b>>2]=0;i=d;return}function COd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=0;xOd(a,d);BOd(d);i=b;return}function DOd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;if((f|0)!=0?(g=c[f+12>>2]|0,(g|0)!=0):0)if((c[g+44>>2]|0)==4){c[a>>2]=0;i=e;return}else{uOd(a,g,b,d);i=e;return}c[a>>2]=0;i=e;return}function EOd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=a;c[a+4>>2]=a;d=a+8|0;c[d>>2]=d;c[a+12>>2]=d;d=a+16|0;c[d>>2]=d;c[a+20>>2]=d;d=a+24|0;c[d>>2]=d;c[a+28>>2]=d;d=a+32|0;e=a+48|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[e>>2]=e;c[a+52>>2]=e;e=kbc()|0;a=0;while(1){d=e+(a<<2)+896|0;a=a+1|0;if(!(c[d>>2]|0)){f=d;break}if((a|0)>=16){g=5;break}}if((g|0)==5){i=b;return}c[f>>2]=199;i=b;return}function FOd(){var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+16|0;d=b;e=SLd(aMd()|0)|0;h[d>>3]=+Ype();f=c[e+52>>2]|0;g=e+48|0;if((f|0)==(g|0)){i=b;return}else j=f;do{NOd(d,684152,1160);f=j;j=c[j+4>>2]|0;e=c[f+8>>2]|0;if((a[e+60>>0]|0)==0?(a[e+116>>0]|0)!=0:0)EJd(e)|0;else bKd(e)}while((j|0)!=(g|0));i=b;return}function GOd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;h[f>>3]=+Ype();nDd((kbc()|0)+896|0,199);g=b+12|0;j=b+8|0;while(1){if((c[g>>2]|0)==(j|0))break;NOd(f,684152,752);HOd(b);xTd(c[(aMd()|0)+92>>2]|0)|0}j=c[b+20>>2]|0;g=b+16|0;if((j|0)!=(g|0)){k=b+24|0;l=j;do{NOd(f,684152,761);j=l;l=c[l+4>>2]|0;m=c[j+8>>2]|0;j=m+116|0;if(!(a[j>>0]|0)){if((m|0)!=(k|0)){n=c[m>>2]|0;o=m+4|0;if(n){c[n+4>>2]=c[o>>2];c[c[o>>2]>>2]=n;c[m>>2]=0;c[o>>2]=0}n=c[k>>2]|0;c[m>>2]=n;c[o>>2]=k;c[n+4>>2]=m;c[c[o>>2]>>2]=m}a[j>>0]=1}}while((l|0)!=(g|0))}h[e>>3]=+Ype();g=b+28|0;l=b+24|0;if((c[g>>2]|0)!=(l|0))do{NOd(e,684152,1081);HOd(b);xTd(c[(aMd()|0)+92>>2]|0)|0}while((c[g>>2]|0)!=(l|0));l=b+4|0;g=c[l>>2]|0;if((g|0)!=(b|0)){e=g;do{g=e+4|0;k=e;e=c[g>>2]|0;c[k>>2]=0;c[g>>2]=0}while((e|0)!=(b|0))}c[l>>2]=b;c[b>>2]=b;l=b+48|0;e=b+52|0;g=c[e>>2]|0;if((g|0)==(l|0)){c[e>>2]=0;c[l>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;i=d;return}else p=g;do{g=p+4|0;k=p;p=c[g>>2]|0;c[k>>2]=0;c[g>>2]=0}while((p|0)!=(l|0));c[e>>2]=0;c[l>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;i=d;return}function HOd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;d=i;i=i+64|0;e=d;f=d+32|0;g=d+28|0;j=d+20|0;k=d+24|0;l=d+16|0;m=d+8|0;n=d+36|0;o=d+40|0;p=c[b+4>>2]|0;if((p|0)!=(b|0)){q=p;do{p=q;q=c[q+4>>2]|0;lOd(c[p+8>>2]|0)}while((q|0)!=(b|0))}h[m>>3]=+Ype();q=c[b+12>>2]|0;p=b+8|0;if((q|0)==(p|0))r=0;else{s=b+16|0;t=o+1|0;u=o+8|0;v=q;q=0;while(1){NOd(m,684152,943);w=q+1|0;x=v;v=c[v+4>>2]|0;y=c[x+8>>2]|0;x=y+112|0;c[x>>2]=(c[x>>2]|0)+1;tOd(y);do if(y){x=c[y+44>>2]|0;if((x|0)==4){z=SLd(aMd()|0)|0;A=y+116|0;if(a[A>>0]|0)break;B=z+24|0;if((y|0)!=(B|0)){z=c[y>>2]|0;C=y+4|0;if(z){c[z+4>>2]=c[C>>2];c[c[C>>2]>>2]=z;c[y>>2]=0;c[C>>2]=0}z=c[B>>2]|0;c[y>>2]=z;c[C>>2]=B;c[z+4>>2]=y;c[c[C>>2]>>2]=y}a[A>>0]=1;break}else if((x|0)!=3)break;x=c[y+100>>2]|0;A=y+96|0;if((x|0)==(A|0))D=y;else{C=y+40|0;z=y+52|0;B=y+116|0;E=y+4|0;F=x;do{NOd(m,684152,953);x=F+4|0;G=F;F=c[x>>2]|0;c[n>>2]=0;H=G+8|0;I=(a[(c[H>>2]|0)+235>>0]|0)==0;J=aMd()|0;do if(I){K=HTd(c[J+92>>2]|0,-1,c[C>>2]|0,1,n)|0;L=c[n>>2]|0;if(!((K|0)!=0|(L|0)==0)){ONd(c[H>>2]|0,L);PNd(c[H>>2]|0);hOd(c[H>>2]|0);jOd(c[H>>2]|0);break}if((K|0)==10){L=c[z>>2]|0;do if(!L)M=0;else{c[f>>2]=L;N=c[137784]|0;if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,f);O=c[e>>2]|0;P=c[N+28>>2]|0;if((O|0)==-1){Q=P+(c[N+32>>2]<<3)|0;break}else{Q=P+(O<<3)|0;break}}else Q=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);N=c[137784]|0;if(!((Q|0)!=((c[N+28>>2]|0)+(c[N+32>>2]<<3)|0)?(c[Q+4>>2]|0)!=0:0))R=28}else R=28;if((R|0)==28?(R=0,(hQb(c[z>>2]|0)|0)==0):0){M=0;break}c[g>>2]=c[z>>2];N=c[137784]|0;do if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,g);O=c[e>>2]|0;P=c[N+28>>2]|0;if((O|0)==-1){S=P+(c[N+32>>2]<<3)|0;break}else{S=P+(O<<3)|0;break}}else S=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);O=c[137784]|0;if((S|0)==((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)){R=37;break}O=c[S+4>>2]|0;if(O)T=O;else R=37}else R=37;while(0);if((R|0)==37){R=0;T=hQb(c[z>>2]|0)|0}M=c[T+4>>2]|0}while(0);Krd(684424,0,3653512,966,512,M,0,0);break}else{c[e>>2]=OOd(K)|0;Lsd(o,684480,e);L=c[z>>2]|0;do if(!L)U=0;else{c[j>>2]=L;N=c[137784]|0;if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,j);O=c[e>>2]|0;P=c[N+28>>2]|0;if((O|0)==-1){V=P+(c[N+32>>2]<<3)|0;break}else{V=P+(O<<3)|0;break}}else V=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);N=c[137784]|0;if(!((V|0)!=((c[N+28>>2]|0)+(c[N+32>>2]<<3)|0)?(c[V+4>>2]|0)!=0:0))R=49}else R=49;if((R|0)==49?(R=0,(hQb(c[z>>2]|0)|0)==0):0){U=0;break}c[k>>2]=c[z>>2];N=c[137784]|0;do if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,k);O=c[e>>2]|0;P=c[N+28>>2]|0;if((O|0)==-1){W=P+(c[N+32>>2]<<3)|0;break}else{W=P+(O<<3)|0;break}}else W=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);O=c[137784]|0;if((W|0)==((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)){R=58;break}O=c[W+4>>2]|0;if(O)X=O;else R=58}else R=58;while(0);if((R|0)==58){R=0;X=hQb(c[z>>2]|0)|0}U=c[X+4>>2]|0}while(0);Krd((a[o>>0]&1)==0?t:c[u>>2]|0,0,3653512,968,1,U,0,0);xri(o);break}}else{L=SLd(J)|0;if(!(a[B>>0]|0)){K=L+24|0;if((y|0)!=(K|0)){L=c[y>>2]|0;if(L){c[L+4>>2]=c[E>>2];c[c[E>>2]>>2]=L;c[y>>2]=0;c[E>>2]=0}L=c[K>>2]|0;c[y>>2]=L;c[E>>2]=K;c[L+4>>2]=y;c[c[E>>2]>>2]=y}a[B>>0]=1}}while(0);J=c[G>>2]|0;if(J){c[J+4>>2]=c[x>>2];c[c[x>>2]>>2]=J;c[G>>2]=0;c[x>>2]=0}}while((F|0)!=(A|0));D=y}if((D|0)!=(s|0)){A=c[y>>2]|0;F=y+4|0;if(A){c[A+4>>2]=c[F>>2];c[c[F>>2]>>2]=A;c[y>>2]=0;c[F>>2]=0}A=c[s>>2]|0;c[y>>2]=A;c[F>>2]=s;c[A+4>>2]=D;c[c[F>>2]>>2]=D}}while(0);if((v|0)==(p|0)){r=w;break}else q=w}}q=b+24|0;p=b+28|0;v=c[p>>2]|0;a:do if((v|0)==(q|0)){Y=0;Z=0}else{D=v;s=0;o=0;while(1){U=D;u=s;while(1){NOd(m,684152,994);t=u+1|0;X=U;U=c[U+4>>2]|0;R=c[X+8>>2]|0;if(((c[R+44>>2]|0)+-3|0)>>>0>=2){_=t;$=U;break}X=c[153086]|0;qOd(R);c[l>>2]=X;c[e+0>>2]=c[l+0>>2];eOb(R,e);if((U|0)==(q|0)){Y=t;Z=o;break a}else u=t}u=o+1|0;if(($|0)==(q|0)){Y=_;Z=u;break}else{D=$;s=_;o=u}}}while(0);_=b+16|0;$=c[b+20>>2]|0;if(($|0)==(_|0))aa=0;else{e=$;$=0;while(1){l=$+1|0;e=c[e+4>>2]|0;if((e|0)==(_|0)){aa=l;break}else $=l}}c[b+36>>2]=aa;c[b+32>>2]=r;c[b+40>>2]=Y;c[b+44>>2]=Z;Z=c[p>>2]|0;if((Z|0)==(q|0)){c[p>>2]=q;c[q>>2]=q;i=d;return}else ba=Z;do{Z=ba+4|0;b=ba;ba=c[Z>>2]|0;c[b>>2]=0;c[Z>>2]=0}while((ba|0)!=(q|0));c[p>>2]=q;c[q>>2]=q;i=d;return}function IOd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+48|0;k=j+8|0;l=j+40|0;m=j+28|0;n=j;o=j+24|0;if(!e){c[b>>2]=0;i=j;return}h[n>>3]=+Ype();p=d+16|0;q=c[d+20>>2]|0;a:do if((q|0)!=(p|0)){d=q;while(1){NOd(n,684152,861);r=c[d+8>>2]|0;if((c[r+44>>2]|0)==3?(c[r+40>>2]|0)==(e|0):0){s=r;break}d=c[d+4>>2]|0;if((d|0)==(p|0))break a}AOd(b,s);i=j;return}while(0);c[o>>2]=c[153086];c[k+0>>2]=c[o+0>>2];o=bOb(128,k,0,16,3653512,867)|0;pOd(o);c[o+40>>2]=e;c[o+44>>2]=3;c[o+60>>2]=f;c[o+52>>2]=c[g>>2];f=c[g>>2]|0;if(!f)t=0;else{c[l>>2]=f;f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(k,f,l);s=c[k>>2]|0;n=c[f+28>>2]|0;if((s|0)==-1){u=n+(c[f+32>>2]<<3)|0;break}else{u=n+(s<<3)|0;break}}else u=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if((u|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(f=c[u+4>>2]|0,(f|0)!=0):0)v=f;else w=17}else w=17;if((w|0)==17)v=hQb(c[g>>2]|0)|0;t=v}c[o+56>>2]=t;t=eTd(e,o+48|0)|0;if(t){e=OOd(t)|0;c[k>>2]=684152;c[k+4>>2]=873;c[k+8>>2]=684592;c[k+12>>2]=e;Lsd(m,692656,k);if(!(a[m>>0]&1))x=m+1|0;else x=c[m+8>>2]|0;Krd(x,0,3653512,16,1,0,0,0);xri(m)}if((o|0)!=(p|0)){m=c[o>>2]|0;x=o+4|0;if(m){c[m+4>>2]=c[x>>2];c[c[x>>2]>>2]=m;c[o>>2]=0;c[x>>2]=0}m=c[p>>2]|0;c[o>>2]=m;c[x>>2]=p;c[m+4>>2]=o;c[c[x>>2]>>2]=o}AOd(b,o);i=j;return}function JOd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+32|0;k=j+16|0;l=j+12|0;m=j+8|0;n=j+4|0;o=j;c[m>>2]=c[153086];c[k+0>>2]=c[m+0>>2];m=bOb(128,k,0,16,3653512,882)|0;pOd(m);c[m+44>>2]=3;c[m+60>>2]=g;c[m+52>>2]=c[h>>2];g=c[h>>2]|0;if(!g)p=0;else{c[l>>2]=g;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(k,g,l);q=c[k>>2]|0;r=c[g+28>>2]|0;if((q|0)==-1){s=r+(c[g+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((s|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[s+4>>2]|0,(g|0)!=0):0)t=g;else u=10}else u=10;if((u|0)==10)t=hQb(c[h>>2]|0)|0;p=t}c[m+56>>2]=p;c[m+48>>2]=d;p=a+8|0;if((m|0)!=(p|0)){a=c[m>>2]|0;t=m+4|0;if(a){c[a+4>>2]=c[t>>2];c[c[t>>2]>>2]=a;c[m>>2]=0;c[t>>2]=0}a=c[p>>2]|0;c[m>>2]=a;c[t>>2]=p;c[a+4>>2]=m;c[c[t>>2]>>2]=m}if(e)c[e+68>>2]=m+12;t=CTd(c[(aMd()|0)+92>>2]|0,b,d,e,m+40|0)|0;if(!t){AOd(o,m);xOd(f,o);BOd(o);i=j;return t|0}else{c[n>>2]=0;xOd(f,n);BOd(n);i=j;return t|0}return 0}function KOd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+48|0;a=b+100|0;if((a|0)==(e|0)){i=d;return}f=c[a>>2]|0;g=b+104|0;if(f){c[f+4>>2]=c[g>>2];c[c[g>>2]>>2]=f;c[a>>2]=0;c[g>>2]=0}f=c[e>>2]|0;c[a>>2]=f;c[g>>2]=e;c[f+4>>2]=a;c[c[g>>2]>>2]=a;i=d;return}function LOd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a;if(!b){i=a;return}e=c[b+52>>2]|0;if((e|0)!=0?(f=c[e+12>>2]|0,(f|0)!=0):0){h[d>>3]=+Ype();e=f;do{NOd(d,684152,1136);f=e;e=c[e+108>>2]|0;sOd(f)}while((f|0)!=(e|0))}e=b+100|0;d=c[e>>2]|0;if(!d){i=a;return}f=b+104|0;c[d+4>>2]=c[f>>2];c[c[f>>2]>>2]=d;c[e>>2]=0;c[f>>2]=0;i=a;return}function MOd(a){a=a|0;return c[a+56>>2]|0}function NOd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0;f=i;i=i+32|0;g=f;j=f+8|0;k=+Ype();if(!(k-+h[b>>3]>15.0)){i=f;return}c[g>>2]=d;c[g+4>>2]=e;Ird(692696,g);c[g>>2]=d;c[g+4>>2]=e;Lsd(j,692696,g);if(!(a[j>>0]&1))l=j+1|0;else l=c[j+8>>2]|0;Krd(l,0,3653512,29,1,0,0,0);xri(j);rl(1)}function OOd(a){a=a|0;var b=0,c=0;b=i;do switch(a|0){case 26:{c=687464;break}case 90:{c=686920;break}case 24:{c=687392;break}case 16:{c=685816;break}case 5:{c=685064;break}case 89:{c=687008;break}case 28:{c=687624;break}case 2:{c=684816;break}case 25:{c=687424;break}case 7:{c=685144;break}case 85:{c=686528;break}case 4:{c=685e3;break}case 11:{c=685296;break}case 13:{c=685512;break}case 17:{c=685880;break}case 23:{c=687368;break}case 32:{c=687824;break}case 18:{c=686072;break}case 83:{c=686312;break}case 22:{c=687272;break}case 27:{c=687552;break}case 84:{c=686472;break}case 34:{c=687936;break}case 6:{c=685104;break}case 87:{c=686704;break}case 19:{c=687096;break}case 86:{c=686600;break}case 21:{c=687232;break}case 10:{c=685256;break}case 12:{c=685360;break}case 88:{c=686872;break}case 3:{c=684952;break}case 91:{c=686424;break}case 29:{c=687696;break}case 15:{c=685712;break}case 14:{c=685568;break}case 31:{c=687760;break}case 9:{c=685224;break}case 92:{c=686176;break}case 33:{c=687872;break}case 30:{c=687728;break}case 20:{c=687120;break}case 8:{c=685176;break}case 47:{c=689024;break}case 48:{c=689104;break}case 49:{c=689232;break}case 50:{c=689424;break}case 51:{c=689472;break}case 52:{c=689568;break}case 53:{c=689616;break}case 54:{c=689688;break}case 55:{c=689776;break}case 40:{c=688336;break}case 41:{c=688392;break}case 42:{c=688456;break}case 43:{c=688528;break}case 35:{c=688040;break}case 36:{c=688096;break}case 56:{c=689896;break}case 57:{c=689936;break}case 58:{c=690072;break}case 59:{c=690192;break}case 60:{c=690296;break}case 61:{c=690336;break}case 62:{c=690440;break}case 63:{c=690536;break}case 64:{c=690592;break}case 65:{c=690664;break}case 66:{c=690728;break}case 67:{c=690792;break}case 68:{c=690888;break}case 69:{c=691008;break}case 70:{c=691120;break}case 71:{c=691184;break}case 75:{c=691328;break}case 72:{c=691616;break}case 73:{c=691768;break}case 74:{c=691888;break}case 76:{c=692024;break}case 77:{c=692088;break}case 78:{c=692240;break}case 79:{c=692320;break}case 80:{c=692400;break}case 81:{c=692512;break}case 82:{c=692560;break}case 0:{c=692624;break}case 1:{c=684752;break}case 44:{c=688568;break}case 45:{c=688696;break}case 95:{c=688752;break}case 94:{c=688816;break}case 93:{c=688864;break}case 46:{c=688944;break}case 37:{c=688136;break}case 38:{c=688192;break}case 39:{c=688248;break}default:c=692640}while(0);i=b;return c|0}function POd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function QOd(a){a=a|0;return c[a+12>>2]|0}function ROd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=xbc()|0;d=0;do{e=b+(d<<2)+64|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}}while((d|0)<16);if((g|0)==4)c[f>>2]=200;f=xbc()|0;d=0;do{b=f+(d<<2)|0;d=d+1|0;if(!(c[b>>2]|0)){h=b;g=8;break}}while((d|0)<16);if((g|0)==8)c[h>>2]=201;h=xbc()|0;d=0;while(1){f=h+(d<<2)+128|0;d=d+1|0;if(!(c[f>>2]|0)){j=f;break}if((d|0)>=16){g=13;break}}if((g|0)==13){i=a;return}c[j>>2]=202;i=a;return}function SOd(){return}function TOd(){var a=0;a=i;VOd();i=a;return}function UOd(){var a=0;a=i;WOd();i=a;return}function VOd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153086];c[b+0>>2]=c[d+0>>2];d=bOb(4,b,1,16,3653512,144)|0;c[d>>2]=692736;FLc(d);i=a;return}function WOd(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=ELc()|0;c[d>>2]=c[153086];c[b+0>>2]=c[d+0>>2];eOb(e,b);FLc(0);i=a;return}function XOd(a,b){a=a|0;b=b|0;a=i;DLd(aMd()|0,b);i=a;return}function YOd(a){a=a|0;a=i;JLd(aMd()|0);i=a;return}function ZOd(a){a=a|0;a=i;ILd(aMd()|0);HOd(rOd()|0);i=a;return}function _Od(a){a=a|0;a=i;nPd();i=a;return}function $Od(a){a=a|0;a=i;lPd();i=a;return}function aPd(a){a=a|0;a=i;mPd();i=a;return}function bPd(a){a=a|0;a=i;oPd();i=a;return}function cPd(a){a=a|0;a=i;pPd();i=a;return}function dPd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+16|0;h=b+8|0;j=b+4|0;k=b;c[j>>2]=c[153106];c[h+0>>2]=c[j+0>>2];j=bOb(128,h,1,16,3653512,65)|0;c[k>>2]=c[153106];c[h+0>>2]=c[k+0>>2];QJd(j,h,0);h=pQb(j)|0;if((mo[c[(c[d>>2]|0)+64>>2]&4095](d)|0)!=1)a[h+117>>0]=0;if(!(mcc(d)|0)){Krd(692800,0,3653512,75,1,0,0,0);l=0;i=b;return l|0}SJd(h);ko[c[(c[h>>2]|0)+24>>2]&4095](h);if(TJd(h,d,0,e,f,g)|0){l=h;i=b;return l|0}kQb(h);l=0;i=b;return l|0}function ePd(a,b){a=a|0;b=b|0;var c=0;a=i;i=i+16|0;c=a;rri(c,b,SEi(b|0)|0);b=ZJd(c)|0;xri(c);i=a;return b|0}function fPd(a,b){a=a|0;b=b|0;var c=0;a=i;c=dNd(b)|0;i=a;return c|0}function gPd(a,b){a=a|0;b=b|0;var c=0;a=i;c=xCi(24)|0;_Md(c,b);i=a;return c|0}function hPd(a,b){a=a|0;b=b|0;a=i;if(!b){i=a;return}ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=a;return}function iPd(a,b){a=a|0;b=b|0;var c=0;a=i;c=eNd(b)|0;i=a;return c|0}function jPd(a,b,c){a=a|0;b=b|0;c=c|0;a=i;RSd(b,c)|0;i=a;return}function kPd(a,b){a=a|0;b=b|0;var d=0;a=i;d=aMd()|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,b);i=a;return}function lPd(){var b=0,d=0,e=0,f=0,g=0;b=i;if(!0){i=b;return}else{d=0;e=0}while(1){f=c[e>>2]|0;a[f+129>>0]=0;if(!(a[f+128>>0]|0))g=d;else{ko[c[(c[f>>2]|0)+156>>2]&4095](f);g=0}e=e+4|0;if((e|0)==(g|0))break;else d=g}i=b;return}function mPd(){var a=0,b=0,d=0;a=i;if(!0){i=a;return}else b=0;do{d=c[b>>2]|0;ko[c[(c[d>>2]|0)+164>>2]&4095](d);b=b+4|0}while((b|0)!=0);i=a;return}function nPd(){var a=0,b=0,d=0;a=i;if(!0){i=a;return}else b=0;do{d=c[b>>2]|0;ko[c[(c[d>>2]|0)+168>>2]&4095](d);d=c[b>>2]|0;In[c[(c[d>>2]|0)+136>>2]&4095](d,0);d=c[b>>2]|0;ko[c[(c[d>>2]|0)+140>>2]&4095](d);b=b+4|0}while((b|0)!=0);i=a;return}function oPd(){var a=0,b=0,d=0;a=i;if(!0){i=a;return}else b=0;do{d=c[b>>2]|0;ko[c[(c[d>>2]|0)+176>>2]&4095](d);b=b+4|0}while((b|0)!=0);i=a;return}function pPd(){var a=0,b=0,d=0;a=i;if(!0){i=a;return}else b=0;do{d=c[b>>2]|0;ko[c[(c[d>>2]|0)+180>>2]&4095](d);b=b+4|0}while((b|0)!=0);i=a;return}function qPd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=xCi(344)|0;e=(c[173236]|0)+1|0;c[173236]=e;uPd(d,e);e=c[173236]|0;c[692952+(e<<2)>>2]=d;c[d+8>>2]=e;f=c[d+12>>2]&65535|e<<28;c[d+20>>2]=f;c[a>>2]=f;i=b;return 0}function rPd(a){a=a|0;return 0}function sPd(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function tPd(a){a=a|0;return c[692952+(a>>>28<<2)>>2]|0}function uPd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=0;e=b+24|0;c[e>>2]=b;c[b+28>>2]=e;c[b+32>>2]=e;c[b+36>>2]=0;e=b+40|0;c[e>>2]=0;c[b+44>>2]=1024;c[b+48>>2]=2;f=b+52|0;c[f>>2]=0;c[b+56>>2]=f;c[b+60>>2]=f;f=b+64|0;c[f>>2]=b;g=b+68|0;h=b+80|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[b+84>>2]=h;c[b+88>>2]=h;h=b+92|0;c[h>>2]=0;c[b+96>>2]=h;c[b+100>>2]=h;c[b+104>>2]=0;c[b+108>>2]=0;vRd(f,1024);f=b+112|0;c[f>>2]=b;h=b+116|0;g=b+128|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[b+132>>2]=g;c[b+136>>2]=g;g=b+140|0;c[g>>2]=0;c[b+144>>2]=g;c[b+148>>2]=g;c[b+152>>2]=0;c[b+156>>2]=0;BRd(f,512);f=b+160|0;c[f>>2]=b;g=b+164|0;h=b+176|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[b+180>>2]=h;c[b+184>>2]=h;h=b+188|0;c[h>>2]=0;c[b+192>>2]=h;c[b+196>>2]=h;c[b+200>>2]=0;c[b+204>>2]=0;HRd(f,4096);f=b+208|0;c[f>>2]=b;h=b+212|0;g=b+224|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[b+228>>2]=g;c[b+232>>2]=g;g=b+236|0;c[g>>2]=0;c[b+240>>2]=g;c[b+244>>2]=g;c[b+248>>2]=0;c[b+252>>2]=0;NRd(f,1024);f=b+256|0;c[f>>2]=b;g=b+260|0;h=b+272|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[b+276>>2]=h;c[b+280>>2]=h;h=b+284|0;c[h>>2]=0;c[b+288>>2]=h;c[b+292>>2]=h;c[b+296>>2]=0;c[b+300>>2]=0;SRd(f,1024);f=b+304|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[e>>2]=32;i=d;return}function vPd(a,b){a=a|0;b=b|0;c[a+40>>2]=b;return 0}function wPd(b,d){b=b|0;d=d|0;c[b>>2]=d;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=0;d=b+24|0;c[d>>2]=b;c[b+28>>2]=d;c[b+32>>2]=d;c[b+36>>2]=0;c[b+40>>2]=0;d=b+44|0;c[d>>2]=0;c[b+48>>2]=d;c[b+52>>2]=d;c[b+320>>2]=0;return}function xPd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+320>>2]|0;if(d)yh(d|0)|0;d=a+44|0;e=a+52|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=a+48|0;h=c[g>>2]|0;c[h+8>>2]=f;c[(c[e>>2]|0)+4>>2]=h;c[g>>2]=d;c[e>>2]=d}d=a+24|0;e=a+32|0;g=c[e>>2]|0;if((g|0)==(d|0)){i=b;return}h=a+28|0;a=c[h>>2]|0;c[a+8>>2]=g;c[(c[e>>2]|0)+4>>2]=a;c[h>>2]=d;c[e>>2]=d;i=b;return}function yPd(a){a=a|0;var b=0;b=i;Vf(c[a+120>>2]|0);APd(a);i=b;return 0}function zPd(a){a=a|0;var b=0;b=i;APd(a);i=b;return}function APd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+20|0;e=c[d>>2]|0;f=tPd(e)|0;if(!f)g=0;else g=yRd(f+64|0,e)|0;if((g|0)!=(a|0)){i=b;return}g=a+40|0;e=a+48|0;f=a+44|0;h=c[f>>2]|0;c[h+8>>2]=c[e>>2];c[(c[e>>2]|0)+4>>2]=h;c[f>>2]=g;c[e>>2]=g;g=a+52|0;e=a+60|0;f=a+56|0;h=c[f>>2]|0;c[h+8>>2]=c[e>>2];c[(c[e>>2]|0)+4>>2]=h;c[f>>2]=g;c[e>>2]=g;g=c[a>>2]|0;e=g+36|0;c[e>>2]=(c[e>>2]|0)+-1;e=a+64|0;f=c[e>>2]|0;if(f){h=f+36|0;c[h>>2]=(c[h>>2]|0)+-1;c[e>>2]=0}e=c[a+124>>2]|0;if(!e)j=g;else{kn[e&511](c[d>>2]|0,0,0,0)|0;j=c[a>>2]|0}ARd(j+64|0,a)|0;i=b;return}function BPd(b,d){b=b|0;d=d|0;var e=0;e=i;c[b>>2]=d;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=0;d=b+24|0;c[d>>2]=b;c[b+28>>2]=d;c[b+32>>2]=d;d=b+40|0;c[d>>2]=b;c[b+44>>2]=d;c[b+48>>2]=d;d=b+52|0;c[d>>2]=b;c[b+56>>2]=d;c[b+60>>2]=d;c[b+64>>2]=0;c[b+68>>2]=0;c[b+72>>2]=0;d=b+88|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;g[b+104>>2]=ea(1.0);g[b+108>>2]=ea(48.0e3);g[b+112>>2]=ea(1.0);a[b+116>>0]=0;a[b+117>>0]=0;a[b+118>>0]=0;c[b+124>>2]=0;g[b+76>>2]=ea(0.0);g[b+80>>2]=ea(0.0);g[b+84>>2]=ea(0.0);c[b+120>>2]=aj(3534,b|0)|0;g[b+36>>2]=ea(ea((mEi()|0)%1e3|0|0)*ea(.00100000005));i=e;return}function CPd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+120>>2]|0;if(d)yh(d|0)|0;d=a+52|0;e=a+60|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=a+56|0;h=c[g>>2]|0;c[h+8>>2]=f;c[(c[e>>2]|0)+4>>2]=h;c[g>>2]=d;c[e>>2]=d}d=a+40|0;e=a+48|0;g=c[e>>2]|0;if((g|0)!=(d|0)){h=a+44|0;f=c[h>>2]|0;c[f+8>>2]=g;c[(c[e>>2]|0)+4>>2]=f;c[h>>2]=d;c[e>>2]=d}d=a+24|0;e=a+32|0;h=c[e>>2]|0;if((h|0)==(d|0)){i=b;return}f=a+28|0;a=c[f>>2]|0;c[a+8>>2]=h;c[(c[e>>2]|0)+4>>2]=a;c[f>>2]=d;c[e>>2]=d;i=b;return}function DPd(b,d){b=b|0;d=d|0;c[b>>2]=d;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=0;d=b+24|0;c[d>>2]=b;c[b+28>>2]=d;c[b+32>>2]=d;g[b+40>>2]=ea(1.0);c[b+44>>2]=0;d=b+48|0;c[d>>2]=b;c[b+52>>2]=d;c[b+56>>2]=d;d=b+60|0;c[d>>2]=0;c[b+64>>2]=d;c[b+68>>2]=d;d=b+72|0;c[d>>2]=0;c[b+76>>2]=d;c[b+80>>2]=d;return}function EPd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+72|0;e=a+80|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=a+76|0;h=c[g>>2]|0;c[h+8>>2]=f;c[(c[e>>2]|0)+4>>2]=h;c[g>>2]=d;c[e>>2]=d}d=a+60|0;e=a+68|0;g=c[e>>2]|0;if((g|0)!=(d|0)){h=a+64|0;f=c[h>>2]|0;c[f+8>>2]=g;c[(c[e>>2]|0)+4>>2]=f;c[h>>2]=d;c[e>>2]=d}d=a+48|0;e=a+56|0;h=c[e>>2]|0;if((h|0)!=(d|0)){f=a+52|0;g=c[f>>2]|0;c[g+8>>2]=h;c[(c[e>>2]|0)+4>>2]=g;c[f>>2]=d;c[e>>2]=d}d=a+24|0;e=a+32|0;f=c[e>>2]|0;if((f|0)==(d|0)){i=b;return}g=a+28|0;a=c[g>>2]|0;c[a+8>>2]=f;c[(c[e>>2]|0)+4>>2]=a;c[g>>2]=d;c[e>>2]=d;i=b;return}function FPd(b,d){b=b|0;d=d|0;c[b>>2]=d;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=0;d=b+24|0;c[d>>2]=b;c[b+28>>2]=d;c[b+32>>2]=d;return}function GPd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+24|0;e=a+32|0;f=c[e>>2]|0;if((f|0)==(d|0)){i=b;return}g=a+28|0;a=c[g>>2]|0;c[a+8>>2]=f;c[(c[e>>2]|0)+4>>2]=a;c[g>>2]=d;c[e>>2]=d;i=b;return}function HPd(b,d){b=b|0;d=d|0;c[b>>2]=d;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;a[b+16>>0]=1;c[b+20>>2]=0;d=b+24|0;c[d>>2]=b;c[b+28>>2]=d;c[b+32>>2]=d;return}function IPd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+24|0;e=a+32|0;f=c[e>>2]|0;if((f|0)==(d|0)){i=b;return}g=a+28|0;a=c[g>>2]|0;c[a+8>>2]=f;c[(c[e>>2]|0)+4>>2]=a;c[g>>2]=d;c[e>>2]=d;i=b;return}function JPd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function KPd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=tPd(b)|0;if(!e){i=d;return 0}f=ERd(e+112|0,b)|0;if(!f){i=d;return 0}b=f+48|0;e=f+56|0;g=f+52|0;f=c[g>>2]|0;c[f+8>>2]=c[e>>2];c[(c[e>>2]|0)+4>>2]=f;c[g>>2]=b;f=a+64|0;c[g>>2]=c[f>>2];c[e>>2]=a+60;c[(c[f>>2]|0)+8>>2]=b;c[f>>2]=b;i=d;return 0}function LPd(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=78;c[b+4>>2]=694016;gl(692968,b|0)|0;i=d;return 78}function MPd(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function NPd(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=78;c[b+4>>2]=693968;gl(692968,b|0)|0;i=d;return 78}function OPd(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function PPd(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function QPd(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a+44>>2]|0;if(!d)e=0;else e=c[d+20>>2]|0;c[b>>2]=e;return 0}function RPd(a){a=a|0;var b=0;b=i;GRd((c[a>>2]|0)+112|0,a)|0;i=b;return 0}function SPd(a,b){a=a|0;b=ea(b);return 0}function TPd(a,b){a=a|0;b=b|0;return 0}function UPd(a,b){a=a|0;b=ea(b);return 0}function VPd(a,b){a=a|0;b=ea(b);g[a+40>>2]=b;return 0}function WPd(a,b){a=a|0;b=b|0;g[b>>2]=ea(g[a+108>>2]);return 0}function XPd(a,b){a=a|0;b=b|0;return 0}function YPd(a,b){a=a|0;b=b|0;c[b>>2]=c[a+4>>2];return 0}function ZPd(b,d){b=b|0;d=d|0;var e=0;if(!(c[b+64>>2]|0))e=0;else e=a[b+117>>0]^1;a[d>>0]=e;return 0}function _Pd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0.0,j=0.0,k=Im,l=Im,m=0,n=0,o=0.0,p=0,q=Im,r=0,s=Im,t=0.0,u=Im,v=Im,w=Im,x=Im;e=i;if(b){f=a+76|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];h=+ea(g[b>>2]);j=+ea(g[b+4>>2]);rf(c[a+120>>2]|0,+h,+j,+(+ea(g[b+8>>2])))}if(d){j=+ea(g[d>>2]);h=+ea(g[d+4>>2]);gm(c[a+120>>2]|0,+j,+h,+(+ea(g[d+8>>2])))}k=ea(g[a+104>>2]);d=c[a>>2]|0;b=c[d+320>>2]|0;if(!b){l=k;m=a+120|0;n=c[m>>2]|0;o=+l;ii(n|0,+o);p=a+108|0;q=ea(g[p>>2]);r=c[m>>2]|0;s=ea(q/ea(48.0e3));t=+s;om(r|0,+t);i=e;return 0}u=ea(g[a+76>>2]);v=ea(u-ea(g[d+308>>2]));u=ea(g[a+80>>2]);w=ea(u-ea(g[d+312>>2]));u=ea(g[a+84>>2]);x=ea(u-ea(g[d+316>>2]));u=ea(T(ea(ea(ea(v*v)+ea(w*w))+ea(x*x))));x=ea(ea(Sm[b&7](c[a+20>>2]|0,u))+ea(-1.0));l=ea(k*ea(ea(x*ea(g[a+112>>2]))+ea(1.0)));m=a+120|0;n=c[m>>2]|0;o=+l;ii(n|0,+o);p=a+108|0;q=ea(g[p>>2]);r=c[m>>2]|0;s=ea(q/ea(48.0e3));t=+s;om(r|0,+t);i=e;return 0}function $Pd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=Im,j=0,k=0,l=0.0,m=Im,n=Im,o=Im,p=Im;d=i;g[a+104>>2]=b;e=c[a>>2]|0;f=c[e+320>>2]|0;if(!f){h=b;j=a+120|0;k=c[j>>2]|0;l=+h;ii(k|0,+l);i=d;return 0}m=ea(g[a+76>>2]);n=ea(m-ea(g[e+308>>2]));m=ea(g[a+80>>2]);o=ea(m-ea(g[e+312>>2]));m=ea(g[a+84>>2]);p=ea(m-ea(g[e+316>>2]));m=ea(T(ea(ea(ea(n*n)+ea(o*o))+ea(p*p))));p=ea(ea(Sm[f&7](c[a+20>>2]|0,m))+ea(-1.0));h=ea(ea(ea(p*ea(g[a+112>>2]))+ea(1.0))*b);j=a+120|0;k=c[j>>2]|0;l=+h;ii(k|0,+l);i=d;return 0}function aQd(a,b){a=a|0;b=ea(b);var d=0;d=i;g[a+108>>2]=b;om(c[a+120>>2]|0,+(+ea(b/ea(48.0e3))));i=d;return 0}function bQd(a,b){a=a|0;b=b|0;return 0}function cQd(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);return 0}function dQd(a,b){a=a|0;b=ea(b);return 0}function eQd(a,b,c){a=a|0;b=ea(b);c=ea(c);return 0}function fQd(a,b){a=a|0;b=ea(b);var d=0;d=i;of(c[a+120>>2]|0,b>ea(0.0)|0);g[a+112>>2]=b;i=d;return 0}function gQd(a,b){a=a|0;b=ea(b);return 0}function hQd(a,b){a=a|0;b=b|0;c[a+124>>2]=b;return 0}function iQd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=tPd(b)|0;if(!e)f=0;else f=ERd(e+112|0,b)|0;c[a+68>>2]=f;i=d;return 0}function jQd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function kQd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b&3;if(!e){i=d;return 0}f=a+72|0;c[f>>2]=c[f>>2]&-4|e;yj(c[a+120>>2]|0,(b&2|0)!=0|0);i=d;return 0}function lQd(b,c){b=b|0;c=c|0;a[b+116>>0]=c&1;return 0}function mQd(a,b){a=a|0;b=ea(b);return 0}function nQd(b,d){b=b|0;d=d|0;var e=0;e=i;a[b+117>>0]=d&1;ij(c[b+120>>2]|0,d|0);i=e;return 0}function oQd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e;if((d|0)==1){g=+Ki()*1.0e6;h=Ycd(~~g>>>0,+S(g)>=1.0?(g>0.0?(ha(+R(g/4294967296.0),4294967295.0)|0)>>>0:~~+ca((g-+(~~g>>>0))/4294967296.0)>>>0):0)|0;g=+(h>>>0)+4294967296.0*+(H>>>0)-+(b>>>0)*48.0;h=+S(g)>=1.0?(g>0.0?(ha(+R(g/4294967296.0),4294967295.0)|0)>>>0:~~+ca((g-+(~~g>>>0))/4294967296.0)>>>0):0;j=a+88|0;c[j>>2]=~~g>>>0;c[j+4>>2]=h;k=0;i=e;return k|0}else if((d|0)==2){d=a+96|0;h=c[d>>2]|0;j=c[d+4>>2]|0;g=+Ki()*1.0e6;d=Ycd(~~g>>>0,+S(g)>=1.0?(g>0.0?(ha(+R(g/4294967296.0),4294967295.0)|0)>>>0:~~+ca((g-+(~~g>>>0))/4294967296.0)>>>0):0)|0;l=ZEi(d|0,H|0,(0>j>>>0|0==(j|0)&b>>>0>h>>>0?h:b)|0,0)|0;b=a+88|0;c[b>>2]=l;c[b+4>>2]=H;k=0;i=e;return k|0}else{c[f>>2]=693560;c[f+4>>2]=746;gl(693040,f|0)|0;c[f>>2]=37;c[f+4>>2]=693560;gl(693096,f|0)|0;k=37;i=e;return k|0}return 0}function pQd(a,b){a=a|0;b=b|0;return 0}function qQd(a,b){a=a|0;b=b|0;return 0}function rQd(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return 0}function sQd(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=78;c[b+4>>2]=694032;gl(692968,b|0)|0;i=d;return 78}function tQd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function uQd(b,c){b=b|0;c=c|0;a[c>>0]=0;return 0}function vQd(b,c){b=b|0;c=c|0;a[c>>0]=0;return 0}function wQd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=i;i=i+16|0;f=g;c[f>>2]=78;c[f+4>>2]=694200;gl(692968,f|0)|0;i=g;return 78}function xQd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[d>>2]=78;c[d+4>>2]=694088;gl(692968,d|0)|0;i=e;return 78}function yQd(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=78;c[a+4>>2]=694072;gl(692968,a|0)|0;i=b;return 78}function zQd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[d>>2]=78;c[d+4>>2]=694104;gl(692968,d|0)|0;i=e;return 78}function AQd(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=78;c[a+4>>2]=693376;gl(692968,a|0)|0;i=b;return 78}function BQd(a,b){a=a|0;b=b|0;c[b>>2]=c[a+4>>2];return 0}function CQd(a){a=a|0;var b=0;b=i;RRd((c[a>>2]|0)+208|0,a)|0;i=b;return 0}function DQd(a){a=a|0;return 0}function EQd(a,b){a=a|0;b=b|0;return 0}function FQd(a,b){a=a|0;b=b|0;return 0}function GQd(a,b,c){a=a|0;b=b|0;c=ea(c);return 0}function HQd(a,b){a=a|0;b=b|0;b=i;i=i+16|0;a=b;c[a>>2]=78;c[a+4>>2]=693856;gl(692968,a|0)|0;i=b;return 78}function IQd(a){a=a|0;var b=0;b=i;WRd((c[a>>2]|0)+256|0,a)|0;i=b;return 0}function JQd(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=ea(d);return 0}function KQd(a,b){a=a|0;b=b|0;return 0}function LQd(a,b){a=a|0;b=b|0;return 0}function MQd(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function NQd(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function OQd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;if(d)c[d>>2]=Xl(c[b+320>>2]|0)|0;if(e)c[e>>2]=100;if(f)a[f>>0]=0;if(!g){i=h;return 0}a[g>>0]=0;i=h;return 0}function PQd(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;b=d;c[b>>2]=78;c[b+4>>2]=694224;gl(692968,b|0)|0;i=d;return 78}function QQd(a,b){a=a|0;b=b|0;c[b>>2]=c[a+4>>2];return 0}function RQd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+44|0;e=a+52|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{f=c[g>>2]|0;Vf(c[f+120>>2]|0);APd(f);g=c[e>>2]|0}while((g|0)!=(d|0))}d=a+320|0;g=c[d>>2]|0;if(g)yh(g|0)|0;c[d>>2]=0;MRd((c[a>>2]|0)+160|0,a)|0;i=b;return 0}function SQd(a,b){a=a|0;b=b|0;c[a+40>>2]=b;return 0}function TQd(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return 0}function UQd(a){a=a|0;return 0}function VQd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b;f=DRd(a+112|0,-1)|0;if(!f){c[e>>2]=36;c[e+4>>2]=694664;gl(693304,e|0)|0;g=36;i=b;return g|0}else{c[d>>2]=c[f+20>>2];g=0;i=b;return g|0}return 0}function WQd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b;f=ORd(a+208|0,-1)|0;if(!f){c[e>>2]=37;c[e+4>>2]=694632;gl(693096,e|0)|0;g=37;i=b;return g|0}else{c[d>>2]=c[f+20>>2];g=0;i=b;return g|0}return 0}function XQd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b;f=ORd(a+208|0,-1)|0;if(!f){c[e>>2]=37;c[e+4>>2]=694648;gl(693096,e|0)|0;g=37;i=b;return g|0}else{c[d>>2]=c[f+20>>2];g=0;i=b;return g|0}return 0}function YQd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=TRd(a+256|0,-1)|0;if(!f){c[e>>2]=36;c[e+4>>2]=694688;gl(693304,e|0)|0;g=36;i=d;return g|0}else{c[b>>2]=c[f+20>>2];g=0;i=d;return g|0}return 0}function ZQd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;j=i;i=i+48|0;k=j;l=j+12|0;m=j+24|0;n=j+20|0;o=j+28|0;p=j+8|0;q=j+16|0;r=j+32|0;s=j+36|0;t=j+40|0;u=j+44|0;v=JRd(b+160|0,-1)|0;if(!v){c[k>>2]=36;c[k+4>>2]=694616;gl(693304,k|0)|0;w=36;i=j;return w|0}c[h>>2]=c[v+20>>2];c[v+4>>2]=c[f+68>>2];do if(!(e&2048)){if((e&256|0)!=0?(x=f+44|0,(c[x>>2]|0)!=0):0){y=f+4|0;z=c[y>>2]|0;c[l>>2]=c[153134];c[k+0>>2]=c[l+0>>2];A=cOb(z,16,k,0,3653512,1374)|0;z=c[y>>2]|0;if(!z){B=0;C=f+12|0}else{D=f+48|0;E=f+12|0;F=z;z=16384;G=0;while(1){H=F-G|0;z=H>>>0<z>>>0?H:z;xo[c[x>>2]&2047](c[h>>2]|0,A+G|0,z)|0;G=z+G|0;kn[c[D>>2]&511](c[h>>2]|0,0,(G>>>0)/(c[E>>2]<<2>>>0)|0,2)|0;H=c[y>>2]|0;if(H>>>0<=G>>>0){B=H;C=E;break}else F=H}}c[m>>2]=c[153134];c[k+0>>2]=c[m+0>>2];F=cOb(B,16,k,0,3653512,1383)|0;E=c[C>>2]|0;G=((c[y>>2]|0)>>>0)/(E<<2>>>0)|0;a:do if((E|0)>0){if(!G){D=0;while(1){D=D+1|0;if((D|0)>=(E|0))break a}}else I=0;do{D=da(I,G)|0;z=0;do{g[F+(z+D<<2)>>2]=ea(g[A+((da(E,z)|0)+I<<2)>>2]);z=z+1|0}while(z>>>0<G>>>0);I=I+1|0}while((I|0)<(E|0))}while(0);c[v+320>>2]=Uk(E|0,G|0,c[f+16>>2]|0,F|0)|0;c[n>>2]=c[153134];c[k+0>>2]=c[n+0>>2];eOb(A,k);c[o>>2]=c[153134];c[k+0>>2]=c[o+0>>2];eOb(F,k);bFi(v+56|0,d|0)|0;break}y=c[f+76>>2]|0;if(!y)J=Bn[c[b+328>>2]&255](d,0,r,p,q)|0;else J=Bn[y&255](d,0,r,p,q)|0;if(J){w=0;i=j;return w|0}y=c[f+4>>2]|0;if(y)c[r>>2]=y;y=c[f+88>>2]|0;if(!y)K=xo[c[b+340>>2]&2047](c[p>>2]|0,c[f+8>>2]|0,c[q>>2]|0)|0;else K=xo[y&2047](c[p>>2]|0,c[f+8>>2]|0,c[q>>2]|0)|0;if(K){w=0;i=j;return w|0}y=c[r>>2]|0;c[s>>2]=c[153134];c[k+0>>2]=c[s+0>>2];z=cOb(y,16,k,0,3653512,1421)|0;y=c[r>>2]|0;b:do if(y){D=f+84|0;x=b+336|0;H=y;L=0;while(1){M=c[D>>2]|0;if(!M)N=Bn[c[x>>2]&255](c[p>>2]|0,z+L|0,H-L|0,t,c[q>>2]|0)|0;else N=Bn[M&255](c[p>>2]|0,z+L|0,H-L|0,t,c[q>>2]|0)|0;if(N){w=0;break}L=(c[t>>2]|0)+L|0;H=c[r>>2]|0;if(H>>>0<=L>>>0)break b}i=j;return w|0}while(0);y=c[f+80>>2]|0;if(!y)O=_n[c[b+332>>2]&4095](c[p>>2]|0,c[q>>2]|0)|0;else O=_n[y&4095](c[p>>2]|0,c[q>>2]|0)|0;if(!O){c[v+320>>2]=Tk(z|0,c[r>>2]|0)|0;c[u>>2]=c[153134];c[k+0>>2]=c[u+0>>2];eOb(z,k);bFi(v+56|0,d|0)|0;break}else{w=0;i=j;return w|0}}else{c[v+320>>2]=Tk(d|0,c[f+4>>2]|0)|0;a[v+56>>0]=0}while(0);f=v+312|0;c[f>>2]=96e3;c[f+4>>2]=0;w=0;i=j;return w|0}function _Qd(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function $Qd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=2;return 0}function aRd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(b)c[b>>2]=c[a+44>>2];if(!d){i=e;return 0}c[d>>2]=c[a+48>>2];i=e;return 0}function bRd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0;a=i;e=+Ki()*1.0e6;f=Ycd(~~e>>>0,+S(e)>=1.0?(e>0.0?(ha(+R(e/4294967296.0),4294967295.0)|0)>>>0:~~+ca((e-+(~~e>>>0))/4294967296.0)>>>0):0)|0;c[b>>2]=H;c[d>>2]=f;i=a;return 0}function cRd(a,b){a=a|0;b=b|0;c[b>>2]=c[(c[a+304>>2]|0)+20>>2];return 0}function dRd(a,b){a=a|0;b=b|0;c[b>>2]=1;return 0}function eRd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;h=i;if(b)c[b>>2]=44100;if(e)c[e>>2]=2;if(!f){i=h;return 0}c[f>>2]=2;i=h;return 0}function fRd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;d=e;Pi();vRd(a+64|0,b);b=DRd(a+112|0,-1)|0;c[a+304>>2]=b;if(b){f=0;i=e;return f|0}c[d>>2]=33;c[d+4>>2]=694504;gl(693168,d|0)|0;f=33;i=e;return f|0}function gRd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0.0,k=0;e=i;i=i+16|0;b=e;g=tPd(d)|0;if((g|0)!=0?(PRd(g+208|0,d)|0)!=0:0){d=xRd(a+64|0,-1)|0;if(!d){c[b>>2]=10;c[b+4>>2]=694720;gl(693232,b|0)|0;h=10;i=e;return h|0}else{c[f>>2]=c[d+20>>2];c[d+64>>2]=0;c[d+68>>2]=0;f=d+96|0;c[f>>2]=48e3;c[f+4>>2]=0;j=+Ki()*1.0e6;f=Ycd(~~j>>>0,+S(j)>=1.0?(j>0.0?(ha(+R(j/4294967296.0),4294967295.0)|0)>>>0:~~+ca((j-+(~~j>>>0))/4294967296.0)>>>0):0)|0;g=d+88|0;c[g>>2]=f;c[g+4>>2]=H;g=d+52|0;f=d+60|0;k=d+56|0;d=c[k>>2]|0;c[d+8>>2]=c[f>>2];c[(c[f>>2]|0)+4>>2]=d;c[k>>2]=g;d=a+56|0;c[k>>2]=c[d>>2];c[f>>2]=a+52;c[(c[d>>2]|0)+8>>2]=g;c[d>>2]=g;g=a+36|0;c[g>>2]=(c[g>>2]|0)+1;h=0;i=e;return h|0}}c[b>>2]=36;c[b+4>>2]=694720;gl(693304,b|0)|0;h=36;i=e;return h|0}function hRd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0.0;e=i;i=i+16|0;b=e;g=tPd(d)|0;if((g|0)!=0?(h=KRd(g+160|0,d)|0,(h|0)!=0):0){d=xRd(a+64|0,-1)|0;if(!d){c[b>>2]=10;c[b+4>>2]=694704;gl(693232,b|0)|0;j=10;i=e;return j|0}else{c[f>>2]=c[d+20>>2];f=d+40|0;g=d+48|0;k=d+44|0;l=c[k>>2]|0;c[l+8>>2]=c[g>>2];c[(c[g>>2]|0)+4>>2]=l;c[k>>2]=f;l=h+48|0;c[k>>2]=c[l>>2];c[g>>2]=h+44;c[(c[l>>2]|0)+8>>2]=f;c[l>>2]=f;f=h+36|0;c[f>>2]=(c[f>>2]|0)+1;Qe(c[h+320>>2]|0,c[d+120>>2]|0);c[d+64>>2]=h;c[d+68>>2]=0;f=h+312|0;h=c[f+4>>2]|0;l=d+96|0;c[l>>2]=c[f>>2];c[l+4>>2]=h;m=+Ki()*1.0e6;h=Ycd(~~m>>>0,+S(m)>=1.0?(m>0.0?(ha(+R(m/4294967296.0),4294967295.0)|0)>>>0:~~+ca((m-+(~~m>>>0))/4294967296.0)>>>0):0)|0;l=d+88|0;c[l>>2]=h;c[l+4>>2]=H;l=d+52|0;h=d+60|0;f=d+56|0;d=c[f>>2]|0;c[d+8>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=d;c[f>>2]=l;d=a+56|0;c[f>>2]=c[d>>2];c[h>>2]=a+52;c[(c[d>>2]|0)+8>>2]=l;c[d>>2]=l;l=a+36|0;c[l>>2]=(c[l>>2]|0)+1;j=0;i=e;return j|0}}c[b>>2]=36;c[b+4>>2]=694704;gl(693304,b|0)|0;j=36;i=e;return j|0}function iRd(a){a=a|0;return 0}function jRd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;b=i;j=a+308|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];k=+ea(g[d>>2]);l=+ea(g[d+4>>2]);Ze(+k,+l,+(+ea(g[d+8>>2])));l=+ea(g[e>>2]);k=+ea(g[e+4>>2]);Xc(+l,+k,+(+ea(g[e+8>>2])));k=+ea(g[f>>2]);l=+ea(g[f+4>>2]);m=+ea(g[f+8>>2]);n=+ea(g[h>>2]);o=+ea(g[h+4>>2]);fd(+k,+l,+m,+n,+o,+(+ea(g[h+8>>2])));i=b;return 0}function kRd(a,b){a=a|0;b=b|0;c[a+320>>2]=b;return 0}function lRd(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);return 0}function mRd(a,b){a=a|0;b=b|0;c[a+324>>2]=b;return 0}function nRd(a,b){a=a|0;b=b|0;return 0}function oRd(a,b,d){a=a|0;b=b|0;d=d|0;c[a+44>>2]=b;c[a+48>>2]=d;return 0}function pRd(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[a+328>>2]=b;c[a+332>>2]=d;c[a+336>>2]=e;c[a+340>>2]=f;return 0}function qRd(a,b){a=a|0;b=b|0;return 0}function rRd(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function sRd(a,b){a=a|0;b=b|0;return 0}function tRd(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function uRd(a){a=a|0;return 0}function vRd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+44|0;f=c[e>>2]|0;g=a+40|0;h=c[g>>2]|0;if(!f)j=h;else{k=f;f=h;h=0;while(1){l=c[f+(h<<2)>>2]|0;if(!l){m=k;n=f}else{CPd(l);ACi(l);m=c[e>>2]|0;n=c[g>>2]|0}h=h+1|0;if(h>>>0>=m>>>0){j=n;break}else{k=m;f=n}}}if(j)BCi(j);j=zCi(b>>>0>1073741823?-1:b<<2)|0;c[g>>2]=j;c[e>>2]=b;a:do if((b|0)>0){e=j;n=0;while(1){c[e+(n<<2)>>2]=0;f=n+1|0;if((f|0)==(b|0))break a;e=c[g>>2]|0;n=f}}while(0);g=a+28|0;c[a+32>>2]=g;c[a+36>>2]=g;g=a+16|0;c[a+20>>2]=g;c[a+24>>2]=g;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function wRd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+44|0;e=c[d>>2]|0;f=a+40|0;g=c[f>>2]|0;if(!e)h=g;else{j=e;e=g;g=0;while(1){k=c[e+(g<<2)>>2]|0;if(!k){l=j;m=e}else{CPd(k);ACi(k);l=c[d>>2]|0;m=c[f>>2]|0}g=g+1|0;if(g>>>0>=l>>>0){h=m;break}else{j=l;e=m}}}if(h)BCi(h);h=a+28|0;m=a+36|0;e=c[m>>2]|0;if((e|0)!=(h|0)){l=a+32|0;j=c[l>>2]|0;c[j+8>>2]=e;c[(c[m>>2]|0)+4>>2]=j;c[l>>2]=h;c[m>>2]=h}h=a+16|0;m=a+24|0;l=c[m>>2]|0;if((l|0)==(h|0)){i=b;return}j=a+20|0;a=c[j>>2]|0;c[a+8>>2]=l;c[(c[m>>2]|0)+4>>2]=a;c[j>>2]=h;c[m>>2]=h;i=b;return}function xRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=-1){f=c[(c[b+40>>2]|0)+(d<<2)>>2]|0;if(!f){g=0;i=e;return g|0}else h=f}else{f=c[b+24>>2]|0;if((f|0)!=(b+16|0)?(d=c[f>>2]|0,(d|0)!=0):0){f=b+8|0;c[f>>2]=(c[f>>2]|0)+-1;j=d}else k=5;do if((k|0)==5){d=b+4|0;if((c[d>>2]|0)>>>0<(c[b+44>>2]|0)>>>0){f=xCi(128)|0;BPd(f,c[b>>2]|0);l=c[d>>2]|0;c[f+8>>2]=l;c[d>>2]=l+1;c[(c[b+40>>2]|0)+(l<<2)>>2]=f;j=f;break}else{g=0;i=e;return g|0}}while(0);k=b+12|0;c[k>>2]=(c[k>>2]|0)+1;k=j+24|0;f=j+32|0;l=j+28|0;d=c[l>>2]|0;c[d+8>>2]=c[f>>2];c[(c[f>>2]|0)+4>>2]=d;c[l>>2]=k;d=b+32|0;c[l>>2]=c[d>>2];c[f>>2]=b+28;c[(c[d>>2]|0)+8>>2]=k;c[d>>2]=k;h=j}a[h+16>>0]=0;j=c[(c[b>>2]|0)+8>>2]|0;b=c[h+8>>2]|0;k=h+12|0;d=(c[k>>2]|0)+1|0;c[k>>2]=d;c[h+20>>2]=b<<16&268369920|j<<28|d&65535;g=h;i=e;return g|0}function yRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=tPd(d)|0;if(!e){f=0;i=b;return f|0}g=d;d=c[(c[e+104>>2]|0)+((g>>>16&4095)<<2)>>2]|0;if(!d){f=0;i=b;return f|0}if(a[d+16>>0]|0){f=0;i=b;return f|0}f=(c[d+12>>2]|0)==(g&65535|0)?d:0;i=b;return f|0}function zRd(a){a=a|0;return}function ARd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!d){c[f>>2]=36;c[f+4>>2]=3107792;gl(693304,f|0)|0;g=36;i=e;return g|0}else{f=c[(c[b+40>>2]|0)+(c[d+8>>2]<<2)>>2]|0;d=f+12|0;c[d>>2]=(c[d>>2]|0)+1;a[f+16>>0]=1;d=f+24|0;h=f+32|0;j=f+28|0;f=c[j>>2]|0;c[f+8>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=f;c[j>>2]=d;f=b+20|0;c[j>>2]=c[f>>2];c[h>>2]=b+16;c[(c[f>>2]|0)+8>>2]=d;c[f>>2]=d;d=b+12|0;c[d>>2]=(c[d>>2]|0)+-1;d=b+8|0;c[d>>2]=(c[d>>2]|0)+1;g=0;i=e;return g|0}return 0}function BRd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+44|0;f=c[e>>2]|0;g=a+40|0;h=c[g>>2]|0;if(!f)j=h;else{k=f;f=h;h=0;while(1){l=c[f+(h<<2)>>2]|0;if(!l){m=k;n=f}else{EPd(l);ACi(l);m=c[e>>2]|0;n=c[g>>2]|0}h=h+1|0;if(h>>>0>=m>>>0){j=n;break}else{k=m;f=n}}}if(j)BCi(j);j=zCi(b>>>0>1073741823?-1:b<<2)|0;c[g>>2]=j;c[e>>2]=b;a:do if((b|0)>0){e=j;n=0;while(1){c[e+(n<<2)>>2]=0;f=n+1|0;if((f|0)==(b|0))break a;e=c[g>>2]|0;n=f}}while(0);g=a+28|0;c[a+32>>2]=g;c[a+36>>2]=g;g=a+16|0;c[a+20>>2]=g;c[a+24>>2]=g;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function CRd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+44|0;e=c[d>>2]|0;f=a+40|0;g=c[f>>2]|0;if(!e)h=g;else{j=e;e=g;g=0;while(1){k=c[e+(g<<2)>>2]|0;if(!k){l=j;m=e}else{EPd(k);ACi(k);l=c[d>>2]|0;m=c[f>>2]|0}g=g+1|0;if(g>>>0>=l>>>0){h=m;break}else{j=l;e=m}}}if(h)BCi(h);h=a+28|0;m=a+36|0;e=c[m>>2]|0;if((e|0)!=(h|0)){l=a+32|0;j=c[l>>2]|0;c[j+8>>2]=e;c[(c[m>>2]|0)+4>>2]=j;c[l>>2]=h;c[m>>2]=h}h=a+16|0;m=a+24|0;l=c[m>>2]|0;if((l|0)==(h|0)){i=b;return}j=a+20|0;a=c[j>>2]|0;c[a+8>>2]=l;c[(c[m>>2]|0)+4>>2]=a;c[j>>2]=h;c[m>>2]=h;i=b;return}function DRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=-1){f=c[(c[b+40>>2]|0)+(d<<2)>>2]|0;if(!f){g=0;i=e;return g|0}else h=f}else{f=c[b+24>>2]|0;if((f|0)!=(b+16|0)?(d=c[f>>2]|0,(d|0)!=0):0){f=b+8|0;c[f>>2]=(c[f>>2]|0)+-1;j=d}else k=5;do if((k|0)==5){d=b+4|0;if((c[d>>2]|0)>>>0<(c[b+44>>2]|0)>>>0){f=xCi(84)|0;DPd(f,c[b>>2]|0);l=c[d>>2]|0;c[f+8>>2]=l;c[d>>2]=l+1;c[(c[b+40>>2]|0)+(l<<2)>>2]=f;j=f;break}else{g=0;i=e;return g|0}}while(0);k=b+12|0;c[k>>2]=(c[k>>2]|0)+1;k=j+24|0;f=j+32|0;l=j+28|0;d=c[l>>2]|0;c[d+8>>2]=c[f>>2];c[(c[f>>2]|0)+4>>2]=d;c[l>>2]=k;d=b+32|0;c[l>>2]=c[d>>2];c[f>>2]=b+28;c[(c[d>>2]|0)+8>>2]=k;c[d>>2]=k;h=j}a[h+16>>0]=0;j=c[(c[b>>2]|0)+8>>2]|0;b=c[h+8>>2]|0;k=h+12|0;d=(c[k>>2]|0)+1|0;c[k>>2]=d;c[h+20>>2]=b<<16&268369920|j<<28|d&65535;g=h;i=e;return g|0}function ERd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=tPd(d)|0;if(!e){f=0;i=b;return f|0}g=d;d=c[(c[e+152>>2]|0)+((g>>>16&4095)<<2)>>2]|0;if(!d){f=0;i=b;return f|0}if(a[d+16>>0]|0){f=0;i=b;return f|0}f=(c[d+12>>2]|0)==(g&65535|0)?d:0;i=b;return f|0}function FRd(a){a=a|0;return}function GRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!d){c[f>>2]=36;c[f+4>>2]=3107792;gl(693304,f|0)|0;g=36;i=e;return g|0}else{f=c[(c[b+40>>2]|0)+(c[d+8>>2]<<2)>>2]|0;d=f+12|0;c[d>>2]=(c[d>>2]|0)+1;a[f+16>>0]=1;d=f+24|0;h=f+32|0;j=f+28|0;f=c[j>>2]|0;c[f+8>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=f;c[j>>2]=d;f=b+20|0;c[j>>2]=c[f>>2];c[h>>2]=b+16;c[(c[f>>2]|0)+8>>2]=d;c[f>>2]=d;d=b+12|0;c[d>>2]=(c[d>>2]|0)+-1;d=b+8|0;c[d>>2]=(c[d>>2]|0)+1;g=0;i=e;return g|0}return 0}function HRd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+44|0;f=c[e>>2]|0;g=a+40|0;h=c[g>>2]|0;if(!f)j=h;else{k=f;f=h;h=0;while(1){l=c[f+(h<<2)>>2]|0;if(!l){m=k;n=f}else{xPd(l);ACi(l);m=c[e>>2]|0;n=c[g>>2]|0}h=h+1|0;if(h>>>0>=m>>>0){j=n;break}else{k=m;f=n}}}if(j)BCi(j);j=zCi(b>>>0>1073741823?-1:b<<2)|0;c[g>>2]=j;c[e>>2]=b;a:do if((b|0)>0){e=j;n=0;while(1){c[e+(n<<2)>>2]=0;f=n+1|0;if((f|0)==(b|0))break a;e=c[g>>2]|0;n=f}}while(0);g=a+28|0;c[a+32>>2]=g;c[a+36>>2]=g;g=a+16|0;c[a+20>>2]=g;c[a+24>>2]=g;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function IRd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+44|0;e=c[d>>2]|0;f=a+40|0;g=c[f>>2]|0;if(!e)h=g;else{j=e;e=g;g=0;while(1){k=c[e+(g<<2)>>2]|0;if(!k){l=j;m=e}else{xPd(k);ACi(k);l=c[d>>2]|0;m=c[f>>2]|0}g=g+1|0;if(g>>>0>=l>>>0){h=m;break}else{j=l;e=m}}}if(h)BCi(h);h=a+28|0;m=a+36|0;e=c[m>>2]|0;if((e|0)!=(h|0)){l=a+32|0;j=c[l>>2]|0;c[j+8>>2]=e;c[(c[m>>2]|0)+4>>2]=j;c[l>>2]=h;c[m>>2]=h}h=a+16|0;m=a+24|0;l=c[m>>2]|0;if((l|0)==(h|0)){i=b;return}j=a+20|0;a=c[j>>2]|0;c[a+8>>2]=l;c[(c[m>>2]|0)+4>>2]=a;c[j>>2]=h;c[m>>2]=h;i=b;return}function JRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=-1){f=c[(c[b+40>>2]|0)+(d<<2)>>2]|0;if(!f){g=0;i=e;return g|0}else h=f}else{f=c[b+24>>2]|0;if((f|0)!=(b+16|0)?(d=c[f>>2]|0,(d|0)!=0):0){f=b+8|0;c[f>>2]=(c[f>>2]|0)+-1;j=d}else k=5;do if((k|0)==5){d=b+4|0;if((c[d>>2]|0)>>>0<(c[b+44>>2]|0)>>>0){f=xCi(328)|0;wPd(f,c[b>>2]|0);l=c[d>>2]|0;c[f+8>>2]=l;c[d>>2]=l+1;c[(c[b+40>>2]|0)+(l<<2)>>2]=f;j=f;break}else{g=0;i=e;return g|0}}while(0);k=b+12|0;c[k>>2]=(c[k>>2]|0)+1;k=j+24|0;f=j+32|0;l=j+28|0;d=c[l>>2]|0;c[d+8>>2]=c[f>>2];c[(c[f>>2]|0)+4>>2]=d;c[l>>2]=k;d=b+32|0;c[l>>2]=c[d>>2];c[f>>2]=b+28;c[(c[d>>2]|0)+8>>2]=k;c[d>>2]=k;h=j}a[h+16>>0]=0;j=c[(c[b>>2]|0)+8>>2]|0;b=c[h+8>>2]|0;k=h+12|0;d=(c[k>>2]|0)+1|0;c[k>>2]=d;c[h+20>>2]=b<<16&268369920|j<<28|d&65535;g=h;i=e;return g|0}function KRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=tPd(d)|0;if(!e){f=0;i=b;return f|0}g=d;d=c[(c[e+200>>2]|0)+((g>>>16&4095)<<2)>>2]|0;if(!d){f=0;i=b;return f|0}if(a[d+16>>0]|0){f=0;i=b;return f|0}f=(c[d+12>>2]|0)==(g&65535|0)?d:0;i=b;return f|0}function LRd(a){a=a|0;return}function MRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!d){c[f>>2]=36;c[f+4>>2]=3107792;gl(693304,f|0)|0;g=36;i=e;return g|0}else{f=c[(c[b+40>>2]|0)+(c[d+8>>2]<<2)>>2]|0;d=f+12|0;c[d>>2]=(c[d>>2]|0)+1;a[f+16>>0]=1;d=f+24|0;h=f+32|0;j=f+28|0;f=c[j>>2]|0;c[f+8>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=f;c[j>>2]=d;f=b+20|0;c[j>>2]=c[f>>2];c[h>>2]=b+16;c[(c[f>>2]|0)+8>>2]=d;c[f>>2]=d;d=b+12|0;c[d>>2]=(c[d>>2]|0)+-1;d=b+8|0;c[d>>2]=(c[d>>2]|0)+1;g=0;i=e;return g|0}return 0}function NRd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+44|0;f=c[e>>2]|0;g=a+40|0;h=c[g>>2]|0;if(!f)j=h;else{k=f;f=h;h=0;while(1){l=c[f+(h<<2)>>2]|0;if(!l){m=k;n=f}else{GPd(l);ACi(l);m=c[e>>2]|0;n=c[g>>2]|0}h=h+1|0;if(h>>>0>=m>>>0){j=n;break}else{k=m;f=n}}}if(j)BCi(j);j=zCi(b>>>0>1073741823?-1:b<<2)|0;c[g>>2]=j;c[e>>2]=b;a:do if((b|0)>0){e=j;n=0;while(1){c[e+(n<<2)>>2]=0;f=n+1|0;if((f|0)==(b|0))break a;e=c[g>>2]|0;n=f}}while(0);g=a+28|0;c[a+32>>2]=g;c[a+36>>2]=g;g=a+16|0;c[a+20>>2]=g;c[a+24>>2]=g;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function ORd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=-1){f=c[(c[b+40>>2]|0)+(d<<2)>>2]|0;if(!f){g=0;i=e;return g|0}else h=f}else{f=c[b+24>>2]|0;if((f|0)!=(b+16|0)?(d=c[f>>2]|0,(d|0)!=0):0){f=b+8|0;c[f>>2]=(c[f>>2]|0)+-1;j=d}else k=5;do if((k|0)==5){d=b+4|0;if((c[d>>2]|0)>>>0<(c[b+44>>2]|0)>>>0){f=xCi(36)|0;FPd(f,c[b>>2]|0);l=c[d>>2]|0;c[f+8>>2]=l;c[d>>2]=l+1;c[(c[b+40>>2]|0)+(l<<2)>>2]=f;j=f;break}else{g=0;i=e;return g|0}}while(0);k=b+12|0;c[k>>2]=(c[k>>2]|0)+1;k=j+24|0;f=j+32|0;l=j+28|0;d=c[l>>2]|0;c[d+8>>2]=c[f>>2];c[(c[f>>2]|0)+4>>2]=d;c[l>>2]=k;d=b+32|0;c[l>>2]=c[d>>2];c[f>>2]=b+28;c[(c[d>>2]|0)+8>>2]=k;c[d>>2]=k;h=j}a[h+16>>0]=0;j=c[(c[b>>2]|0)+8>>2]|0;b=c[h+8>>2]|0;k=h+12|0;d=(c[k>>2]|0)+1|0;c[k>>2]=d;c[h+20>>2]=b<<16&268369920|j<<28|d&65535;g=h;i=e;return g|0}function PRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=tPd(d)|0;if(!e){f=0;i=b;return f|0}g=d;d=c[(c[e+248>>2]|0)+((g>>>16&4095)<<2)>>2]|0;if(!d){f=0;i=b;return f|0}if(a[d+16>>0]|0){f=0;i=b;return f|0}f=(c[d+12>>2]|0)==(g&65535|0)?d:0;i=b;return f|0}function QRd(a){a=a|0;return}function RRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!d){c[f>>2]=36;c[f+4>>2]=3107792;gl(693304,f|0)|0;g=36;i=e;return g|0}else{f=c[(c[b+40>>2]|0)+(c[d+8>>2]<<2)>>2]|0;d=f+12|0;c[d>>2]=(c[d>>2]|0)+1;a[f+16>>0]=1;d=f+24|0;h=f+32|0;j=f+28|0;f=c[j>>2]|0;c[f+8>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=f;c[j>>2]=d;f=b+20|0;c[j>>2]=c[f>>2];c[h>>2]=b+16;c[(c[f>>2]|0)+8>>2]=d;c[f>>2]=d;d=b+12|0;c[d>>2]=(c[d>>2]|0)+-1;d=b+8|0;c[d>>2]=(c[d>>2]|0)+1;g=0;i=e;return g|0}return 0}function SRd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+44|0;f=c[e>>2]|0;g=a+40|0;h=c[g>>2]|0;if(!f)j=h;else{k=f;f=h;h=0;while(1){l=c[f+(h<<2)>>2]|0;if(!l){m=k;n=f}else{IPd(l);ACi(l);m=c[e>>2]|0;n=c[g>>2]|0}h=h+1|0;if(h>>>0>=m>>>0){j=n;break}else{k=m;f=n}}}if(j)BCi(j);j=zCi(b>>>0>1073741823?-1:b<<2)|0;c[g>>2]=j;c[e>>2]=b;a:do if((b|0)>0){e=j;n=0;while(1){c[e+(n<<2)>>2]=0;f=n+1|0;if((f|0)==(b|0))break a;e=c[g>>2]|0;n=f}}while(0);g=a+28|0;c[a+32>>2]=g;c[a+36>>2]=g;g=a+16|0;c[a+20>>2]=g;c[a+24>>2]=g;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function TRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)!=-1){f=c[(c[b+40>>2]|0)+(d<<2)>>2]|0;if(!f){g=0;i=e;return g|0}else h=f}else{f=c[b+24>>2]|0;if((f|0)!=(b+16|0)?(d=c[f>>2]|0,(d|0)!=0):0){f=b+8|0;c[f>>2]=(c[f>>2]|0)+-1;j=d}else k=5;do if((k|0)==5){d=b+4|0;if((c[d>>2]|0)>>>0<(c[b+44>>2]|0)>>>0){f=xCi(36)|0;HPd(f,c[b>>2]|0);l=c[d>>2]|0;c[f+8>>2]=l;c[d>>2]=l+1;c[(c[b+40>>2]|0)+(l<<2)>>2]=f;j=f;break}else{g=0;i=e;return g|0}}while(0);k=b+12|0;c[k>>2]=(c[k>>2]|0)+1;k=j+24|0;f=j+32|0;l=j+28|0;d=c[l>>2]|0;c[d+8>>2]=c[f>>2];c[(c[f>>2]|0)+4>>2]=d;c[l>>2]=k;d=b+32|0;c[l>>2]=c[d>>2];c[f>>2]=b+28;c[(c[d>>2]|0)+8>>2]=k;c[d>>2]=k;h=j}a[h+16>>0]=0;j=c[(c[b>>2]|0)+8>>2]|0;b=c[h+8>>2]|0;k=h+12|0;d=(c[k>>2]|0)+1|0;c[k>>2]=d;c[h+20>>2]=b<<16&268369920|j<<28|d&65535;g=h;i=e;return g|0}function URd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=tPd(d)|0;if(!e){f=0;i=b;return f|0}g=d;d=c[(c[e+296>>2]|0)+((g>>>16&4095)<<2)>>2]|0;if(!d){f=0;i=b;return f|0}if(a[d+16>>0]|0){f=0;i=b;return f|0}f=(c[d+12>>2]|0)==(g&65535|0)?d:0;i=b;return f|0}function VRd(a){a=a|0;return}function WRd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!d){c[f>>2]=36;c[f+4>>2]=3107792;gl(693304,f|0)|0;g=36;i=e;return g|0}else{f=c[(c[b+40>>2]|0)+(c[d+8>>2]<<2)>>2]|0;d=f+12|0;c[d>>2]=(c[d>>2]|0)+1;a[f+16>>0]=1;d=f+24|0;h=f+32|0;j=f+28|0;f=c[j>>2]|0;c[f+8>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=f;c[j>>2]=d;f=b+20|0;c[j>>2]=c[f>>2];c[h>>2]=b+16;c[(c[f>>2]|0)+8>>2]=d;c[f>>2]=d;d=b+12|0;c[d>>2]=(c[d>>2]|0)+-1;d=b+8|0;c[d>>2]=(c[d>>2]|0)+1;g=0;i=e;return g|0}return 0}function XRd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(f=yRd(e+64|0,a)|0,(f|0)!=0):0){a=yPd(f)|0;if(!a){g=0;i=b;return g|0}c[d>>2]=a;c[d+4>>2]=693440;gl(693392,d|0)|0;g=a;i=b;return g|0}c[d>>2]=36;c[d+4>>2]=693440;gl(693304,d|0)|0;g=36;i=b;return g|0}function YRd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=nQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693448;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693448;gl(693304,e|0)|0;h=36;i=d;return h|0}function ZRd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=$Pd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693464;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693464;gl(693304,e|0)|0;h=36;i=d;return h|0}function _Rd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=aQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693480;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693480;gl(693304,e|0)|0;h=36;i=d;return h|0}function $Rd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=WPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693496;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693496;gl(693304,e|0)|0;h=36;i=d;return h|0}function aSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=mQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693512;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693512;gl(693304,e|0)|0;h=36;i=d;return h|0}function bSd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(j=yRd(h+64|0,a)|0,(j|0)!=0):0){a=jQd(j,b,d,e)|0;if(!a){k=0;i=f;return k|0}c[g>>2]=a;c[g+4>>2]=693520;gl(693392,g|0)|0;k=a;i=f;return k|0}c[g>>2]=36;c[g+4>>2]=693520;gl(693304,g|0)|0;k=36;i=f;return k|0}function cSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=lQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693536;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693536;gl(693304,e|0)|0;h=36;i=d;return h|0}function dSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=pQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693544;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693544;gl(693304,e|0)|0;h=36;i=d;return h|0}function eSd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=yRd(g+64|0,a)|0,(h|0)!=0):0){a=oQd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=693560;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=693560;gl(693304,f|0)|0;j=36;i=e;return j|0}function fSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=qQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693576;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693576;gl(693304,e|0)|0;h=36;i=d;return h|0}function gSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=XPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693600;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693600;gl(693304,e|0)|0;h=36;i=d;return h|0}function hSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=iQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693624;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693624;gl(693304,e|0)|0;h=36;i=d;return h|0}function iSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=hQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693640;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693640;gl(693304,e|0)|0;h=36;i=d;return h|0}function jSd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=yRd(g+64|0,a)|0,(h|0)!=0):0){a=_Pd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=693656;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=693656;gl(693304,f|0)|0;j=36;i=e;return j|0}function kSd(a,b,d){a=a|0;b=ea(b);d=ea(d);var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=yRd(g+64|0,a)|0,(h|0)!=0):0){a=eQd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=693672;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=693672;gl(693304,f|0)|0;j=36;i=e;return j|0}function lSd(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=ea(e);var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(j=yRd(h+64|0,a)|0,(j|0)!=0):0){a=cQd(j,b,d,e)|0;if(!a){k=0;i=f;return k|0}c[g>>2]=a;c[g+4>>2]=693696;gl(693392,g|0)|0;k=a;i=f;return k|0}c[g>>2]=36;c[g+4>>2]=693696;gl(693304,g|0)|0;k=36;i=f;return k|0}function mSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=bQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693720;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693720;gl(693304,e|0)|0;h=36;i=d;return h|0}function nSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=gQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693744;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693744;gl(693304,e|0)|0;h=36;i=d;return h|0}function oSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=fQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693760;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693760;gl(693304,e|0)|0;h=36;i=d;return h|0}function pSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=dQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693776;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693776;gl(693304,e|0)|0;h=36;i=d;return h|0}function qSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=ZPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693824;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693824;gl(693304,e|0)|0;h=36;i=d;return h|0}function rSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=kQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693840;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693840;gl(693304,e|0)|0;h=36;i=d;return h|0}function sSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=rQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693856;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693856;gl(693304,e|0)|0;h=36;i=d;return h|0}function tSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=yRd(f+64|0,a)|0,(g|0)!=0):0){a=YPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693872;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693872;gl(693304,e|0)|0;h=36;i=d;return h|0}function uSd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(f=ERd(e+112|0,a)|0,(f|0)!=0):0){a=RPd(f)|0;if(!a){g=0;i=b;return g|0}c[d>>2]=a;c[d+4>>2]=693888;gl(693392,d|0)|0;g=a;i=b;return g|0}c[d>>2]=36;c[d+4>>2]=693888;gl(693304,d|0)|0;g=36;i=b;return g|0}function vSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=SPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693896;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693896;gl(693304,e|0)|0;h=36;i=d;return h|0}function wSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=VPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693464;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693464;gl(693304,e|0)|0;h=36;i=d;return h|0}function xSd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=UPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693920;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693920;gl(693304,e|0)|0;h=36;i=d;return h|0}function ySd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=TPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693536;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693536;gl(693304,e|0)|0;h=36;i=d;return h|0}function zSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=KPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693936;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693936;gl(693304,e|0)|0;h=36;i=d;return h|0}function ASd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=PPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693952;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693952;gl(693304,e|0)|0;h=36;i=d;return h|0}function BSd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=ERd(g+112|0,a)|0,(h|0)!=0):0){a=NPd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=693968;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=693968;gl(693304,f|0)|0;j=36;i=e;return j|0}function CSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=QPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693984;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693984;gl(693304,e|0)|0;h=36;i=d;return h|0}function DSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=MPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693800;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693800;gl(693304,e|0)|0;h=36;i=d;return h|0}function ESd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=ERd(g+112|0,a)|0,(h|0)!=0):0){a=JPd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=693816;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=693816;gl(693304,f|0)|0;j=36;i=e;return j|0}function FSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=ERd(f+112|0,a)|0,(g|0)!=0):0){a=OPd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694e3;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694e3;gl(693304,e|0)|0;h=36;i=d;return h|0}function GSd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=ERd(g+112|0,a)|0,(h|0)!=0):0){a=LPd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=694016;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=694016;gl(693304,f|0)|0;j=36;i=e;return j|0}function HSd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(f=PRd(e+208|0,a)|0,(f|0)!=0):0){a=CQd(f)|0;if(!a){g=0;i=b;return g|0}c[d>>2]=a;c[d+4>>2]=693888;gl(693392,d|0)|0;g=a;i=b;return g|0}c[d>>2]=36;c[d+4>>2]=693888;gl(693304,d|0)|0;g=36;i=b;return g|0}function ISd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=AQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693376;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693376;gl(693304,e|0)|0;h=36;i=d;return h|0}function JSd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=PRd(g+208|0,a)|0,(h|0)!=0):0){a=sQd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=694032;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=694032;gl(693304,f|0)|0;j=36;i=e;return j|0}function KSd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=PRd(g+208|0,a)|0,(h|0)!=0):0){a=tQd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=694048;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=694048;gl(693304,f|0)|0;j=36;i=e;return j|0}function LSd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(f=PRd(e+208|0,a)|0,(f|0)!=0):0){a=DQd(f)|0;if(!a){g=0;i=b;return g|0}c[d>>2]=a;c[d+4>>2]=694064;gl(693392,d|0)|0;g=a;i=b;return g|0}c[d>>2]=36;c[d+4>>2]=694064;gl(693304,d|0)|0;g=36;i=b;return g|0}function MSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=yQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694072;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694072;gl(693304,e|0)|0;h=36;i=d;return h|0}function NSd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(j=PRd(h+208|0,a)|0,(j|0)!=0):0){a=xQd(j,b,d,e)|0;if(!a){k=0;i=f;return k|0}c[g>>2]=a;c[g+4>>2]=694088;gl(693392,g|0)|0;k=a;i=f;return k|0}c[g>>2]=36;c[g+4>>2]=694088;gl(693304,g|0)|0;k=36;i=f;return k|0}function OSd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(j=PRd(h+208|0,a)|0,(j|0)!=0):0){a=zQd(j,b,d,e)|0;if(!a){k=0;i=f;return k|0}c[g>>2]=a;c[g+4>>2]=694104;gl(693392,g|0)|0;k=a;i=f;return k|0}c[g>>2]=36;c[g+4>>2]=694104;gl(693304,g|0)|0;k=36;i=f;return k|0}function PSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=EQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694120;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694120;gl(693304,e|0)|0;h=36;i=d;return h|0}function QSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=uQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694136;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694136;gl(693304,e|0)|0;h=36;i=d;return h|0}function RSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=FQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694152;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694152;gl(693304,e|0)|0;h=36;i=d;return h|0}function SSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=vQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694168;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694168;gl(693304,e|0)|0;h=36;i=d;return h|0}function TSd(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=PRd(g+208|0,a)|0,(h|0)!=0):0){a=GQd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=694184;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=694184;gl(693304,f|0)|0;j=36;i=e;return j|0}function USd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+16|0;j=h;k=tPd(a)|0;if((k|0)!=0?(l=PRd(k+208|0,a)|0,(l|0)!=0):0){a=wQd(l,b,d,e,f,g)|0;if(!a){m=0;i=h;return m|0}c[j>>2]=a;c[j+4>>2]=694200;gl(693392,j|0)|0;m=a;i=h;return m|0}c[j>>2]=36;c[j+4>>2]=694200;gl(693304,j|0)|0;m=36;i=h;return m|0}function VSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=HQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693856;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693856;gl(693304,e|0)|0;h=36;i=d;return h|0}function WSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=PRd(f+208|0,a)|0,(g|0)!=0):0){a=BQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693872;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693872;gl(693304,e|0)|0;h=36;i=d;return h|0}function XSd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(f=URd(e+256|0,a)|0,(f|0)!=0):0){a=IQd(f)|0;if(!a){g=0;i=b;return g|0}c[d>>2]=a;c[d+4>>2]=693888;gl(693392,d|0)|0;g=a;i=b;return g|0}c[d>>2]=36;c[d+4>>2]=693888;gl(693304,d|0)|0;g=36;i=b;return g|0}function YSd(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=ea(e);var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(j=URd(h+256|0,a)|0,(j|0)!=0):0){a=JQd(j,b,d,e)|0;if(!a){k=0;i=f;return k|0}c[g>>2]=a;c[g+4>>2]=693656;gl(693392,g|0)|0;k=a;i=f;return k|0}c[g>>2]=36;c[g+4>>2]=693656;gl(693304,g|0)|0;k=36;i=f;return k|0}function ZSd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=URd(f+256|0,a)|0,(g|0)!=0):0){a=LQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694208;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694208;gl(693304,e|0)|0;h=36;i=d;return h|0}function _Sd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=URd(f+256|0,a)|0,(g|0)!=0):0){a=KQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694120;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694120;gl(693304,e|0)|0;h=36;i=d;return h|0}function $Sd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(f=KRd(e+160|0,a)|0,(f|0)!=0):0){a=RQd(f)|0;if(!a){g=0;i=b;return g|0}c[d>>2]=a;c[d+4>>2]=693888;gl(693392,d|0)|0;g=a;i=b;return g|0}c[d>>2]=36;c[d+4>>2]=693888;gl(693304,d|0)|0;g=36;i=b;return g|0}function aTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(h=KRd(g+160|0,a)|0,(h|0)!=0):0){a=PQd(h,b,d)|0;if(!a){j=0;i=e;return j|0}c[f>>2]=a;c[f+4>>2]=694224;gl(693392,f|0)|0;j=a;i=e;return j|0}c[f>>2]=36;c[f+4>>2]=694224;gl(693304,f|0)|0;j=36;i=e;return j|0}function bTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=KRd(f+160|0,a)|0,(g|0)!=0):0){a=NQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=694240;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=694240;gl(693304,e|0)|0;h=36;i=d;return h|0}function cTd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=tPd(a)|0;if((j|0)!=0?(k=KRd(j+160|0,a)|0,(k|0)!=0):0){a=OQd(k,b,d,e,f)|0;if(!a){l=0;i=g;return l|0}c[h>>2]=a;c[h+4>>2]=694256;gl(693392,h|0)|0;l=a;i=g;return l|0}c[h>>2]=36;c[h+4>>2]=694256;gl(693304,h|0)|0;l=36;i=g;return l|0}function dTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=KRd(f+160|0,a)|0,(g|0)!=0):0){a=SQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693840;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693840;gl(693304,e|0)|0;h=36;i=d;return h|0}function eTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=KRd(f+160|0,a)|0,(g|0)!=0):0){a=MQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693848;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693848;gl(693304,e|0)|0;h=36;i=d;return h|0}function fTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=KRd(f+160|0,a)|0,(g|0)!=0):0){a=TQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693856;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693856;gl(693304,e|0)|0;h=36;i=d;return h|0}function gTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(g=KRd(f+160|0,a)|0,(g|0)!=0):0){a=QQd(g,b)|0;if(!a){h=0;i=d;return h|0}c[e>>2]=a;c[e+4>>2]=693872;gl(693392,e|0)|0;h=a;i=d;return h|0}c[e>>2]=36;c[e+4>>2]=693872;gl(693304,e|0)|0;h=36;i=d;return h|0}function hTd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(c[e+12>>2]|0)==(a&65535|0):0){a=iRd(e)|0;if(!a){f=0;i=b;return f|0}c[d>>2]=a;c[d+4>>2]=693888;gl(693392,d|0)|0;f=a;i=b;return f|0}c[d>>2]=36;c[d+4>>2]=693888;gl(693304,d|0)|0;f=36;i=b;return f|0}function iTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=qRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694272;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694272;gl(693304,e|0)|0;g=36;i=d;return g|0}function jTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=dRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694288;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694288;gl(693304,e|0)|0;g=36;i=d;return g|0}function kTd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=tPd(a)|0;if((j|0)!=0?(c[j+12>>2]|0)==(a&65535|0):0){a=$Qd(j,b,d,e,f)|0;if(!a){k=0;i=g;return k|0}c[h>>2]=a;c[h+4>>2]=694304;gl(693392,h|0)|0;k=a;i=g;return k|0}c[h>>2]=36;c[h+4>>2]=694304;gl(693304,h|0)|0;k=36;i=g;return k|0}function lTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=nRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694320;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694320;gl(693304,e|0)|0;g=36;i=d;return g|0}function mTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=_Qd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694336;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694336;gl(693304,e|0)|0;g=36;i=d;return g|0}function nTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=vPd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694352;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694352;gl(693304,e|0)|0;g=36;i=d;return g|0}function oTd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;k=tPd(a)|0;if((k|0)!=0?(c[k+12>>2]|0)==(a&65535|0):0){a=rRd(k,b,d,e,f,g)|0;if(!a){l=0;i=h;return l|0}c[j>>2]=a;c[j+4>>2]=694376;gl(693392,j|0)|0;l=a;i=h;return l|0}c[j>>2]=36;c[j+4>>2]=694376;gl(693304,j|0)|0;l=36;i=h;return l|0}function pTd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j;l=tPd(a)|0;if((l|0)!=0?(c[l+12>>2]|0)==(a&65535|0):0){a=eRd(l,b,d,e,f,g,h)|0;if(!a){m=0;i=j;return m|0}c[k>>2]=a;c[k+4>>2]=694400;gl(693392,k|0)|0;m=a;i=j;return m|0}c[k>>2]=36;c[k+4>>2]=694400;gl(693304,k|0)|0;m=36;i=j;return m|0}function qTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=oRd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694424;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694424;gl(693304,f|0)|0;h=36;i=e;return h|0}function rTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=aRd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694448;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694448;gl(693304,f|0)|0;h=36;i=e;return h|0}function sTd(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;i=i+16|0;l=k;m=tPd(a)|0;if((m|0)!=0?(c[m+12>>2]|0)==(a&65535|0):0){a=pRd(m,b,d,e,f,g,h,j)|0;if(!a){n=0;i=k;return n|0}c[l>>2]=a;c[l+4>>2]=694472;gl(693392,l|0)|0;n=a;i=k;return n|0}c[l>>2]=36;c[l+4>>2]=694472;gl(693304,l|0)|0;n=36;i=k;return n|0}function tTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=sRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694488;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694488;gl(693304,e|0)|0;g=36;i=d;return g|0}function uTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=mRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=693640;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=693640;gl(693304,e|0)|0;g=36;i=d;return g|0}function vTd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(c[h+12>>2]|0)==(a&65535|0):0){a=fRd(h,b,d,e)|0;if(!a){j=0;i=f;return j|0}c[g>>2]=a;c[g+4>>2]=694504;gl(693392,g|0)|0;j=a;i=f;return j|0}c[g>>2]=36;c[g+4>>2]=694504;gl(693304,g|0)|0;j=36;i=f;return j|0}function wTd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(c[e+12>>2]|0)==(a&65535|0):0){a=UQd(e)|0;if(!a){f=0;i=b;return f|0}c[d>>2]=a;c[d+4>>2]=694512;gl(693392,d|0)|0;f=a;i=b;return f|0}c[d>>2]=36;c[d+4>>2]=694512;gl(693304,d|0)|0;f=36;i=b;return f|0}function xTd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=tPd(a)|0;if((e|0)!=0?(c[e+12>>2]|0)==(a&65535|0):0){a=uRd(e)|0;if(!a){f=0;i=b;return f|0}c[d>>2]=a;c[d+4>>2]=694520;gl(693392,d|0)|0;f=a;i=b;return f|0}c[d>>2]=36;c[d+4>>2]=694520;gl(693304,d|0)|0;f=36;i=b;return f|0}function yTd(a,b,d,e){a=a|0;b=ea(b);d=ea(d);e=ea(e);var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=tPd(a)|0;if((h|0)!=0?(c[h+12>>2]|0)==(a&65535|0):0){a=lRd(h,b,d,e)|0;if(!a){j=0;i=f;return j|0}c[g>>2]=a;c[g+4>>2]=694528;gl(693392,g|0)|0;j=a;i=f;return j|0}c[g>>2]=36;c[g+4>>2]=694528;gl(693304,g|0)|0;j=36;i=f;return j|0}function zTd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;k=tPd(a)|0;if((k|0)!=0?(c[k+12>>2]|0)==(a&65535|0):0){a=jRd(k,b,d,e,f,g)|0;if(!a){l=0;i=h;return l|0}c[j>>2]=a;c[j+4>>2]=694544;gl(693392,j|0)|0;l=a;i=h;return l|0}c[j>>2]=36;c[j+4>>2]=694544;gl(693304,j|0)|0;l=36;i=h;return l|0}function ATd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=kRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694568;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694568;gl(693304,e|0)|0;g=36;i=d;return g|0}function BTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=tRd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694592;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694592;gl(693304,f|0)|0;h=36;i=e;return h|0}function CTd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=tPd(a)|0;if((j|0)!=0?(c[j+12>>2]|0)==(a&65535|0):0){a=ZQd(j,b,d,e,f)|0;if(!a){k=0;i=g;return k|0}c[h>>2]=a;c[h+4>>2]=694616;gl(693392,h|0)|0;k=a;i=g;return k|0}c[h>>2]=36;c[h+4>>2]=694616;gl(693304,h|0)|0;k=36;i=g;return k|0}function DTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=WQd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694632;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694632;gl(693304,f|0)|0;h=36;i=e;return h|0}function ETd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=XQd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694648;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694648;gl(693304,f|0)|0;h=36;i=e;return h|0}function FTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=VQd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694664;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694664;gl(693304,f|0)|0;h=36;i=e;return h|0}function GTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=YQd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694688;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694688;gl(693304,e|0)|0;g=36;i=d;return g|0}function HTd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=tPd(a)|0;if((j|0)!=0?(c[j+12>>2]|0)==(a&65535|0):0){a=hRd(j,b,d,e,f)|0;if(!a){k=0;i=g;return k|0}c[h>>2]=a;c[h+4>>2]=694704;gl(693392,h|0)|0;k=a;i=g;return k|0}c[h>>2]=36;c[h+4>>2]=694704;gl(693304,h|0)|0;k=36;i=g;return k|0}function ITd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=tPd(a)|0;if((j|0)!=0?(c[j+12>>2]|0)==(a&65535|0):0){a=gRd(j,b,d,e,f)|0;if(!a){k=0;i=g;return k|0}c[h>>2]=a;c[h+4>>2]=694720;gl(693392,h|0)|0;k=a;i=g;return k|0}c[h>>2]=36;c[h+4>>2]=694720;gl(693304,h|0)|0;k=36;i=g;return k|0}function JTd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=tPd(a)|0;if((f|0)!=0?(c[f+12>>2]|0)==(a&65535|0):0){a=cRd(f,b)|0;if(!a){g=0;i=d;return g|0}c[e>>2]=a;c[e+4>>2]=694728;gl(693392,e|0)|0;g=a;i=d;return g|0}c[e>>2]=36;c[e+4>>2]=694728;gl(693304,e|0)|0;g=36;i=d;return g|0}function KTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=tPd(a)|0;if((g|0)!=0?(c[g+12>>2]|0)==(a&65535|0):0){a=bRd(g,b,d)|0;if(!a){h=0;i=e;return h|0}c[f>>2]=a;c[f+4>>2]=694752;gl(693392,f|0)|0;h=a;i=e;return h|0}c[f>>2]=36;c[f+4>>2]=694752;gl(693304,f|0)|0;h=36;i=e;return h|0}function LTd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=xbc()|0;d=0;do{e=b+(d<<2)+64|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}}while((d|0)<16);if((g|0)==4)c[f>>2]=203;f=xbc()|0;d=0;do{b=f+(d<<2)|0;d=d+1|0;if(!(c[b>>2]|0)){h=b;g=8;break}}while((d|0)<16);if((g|0)==8)c[h>>2]=204;h=xbc()|0;d=0;while(1){f=h+(d<<2)+128|0;d=d+1|0;if(!(c[f>>2]|0)){j=f;break}if((d|0)>=16){g=13;break}}if((g|0)==13){i=a;return}c[j>>2]=205;i=a;return}function MTd(){return}function NTd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[150158]=3535;c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];d=bOb(4,b,1,16,3653512,19)|0;c[d>>2]=697424;qLc(d);i=a;return}function OTd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[150158]=0;e=pLc()|0;f=c[153084]|0;if(e)ko[c[(c[e>>2]|0)+12>>2]&4095](e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);qLc(0);i=a;return}function PTd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;g=a+4|0;if((f|0)!=(g|0)){h=f;while(1){f=h+20|0;j=c[f>>2]|0;k=c[153128]|0;if(j)ogd(j);c[e>>2]=k;c[d+0>>2]=c[e+0>>2];eOb(j,d);c[f>>2]=0;f=c[h+4>>2]|0;if(!f){j=h;while(1){k=c[j+8>>2]|0;if((c[k>>2]|0)==(j|0)){l=k;break}else j=k}}else{j=f;while(1){k=c[j>>2]|0;if(!k){l=j;break}else j=k}}if((l|0)==(g|0))break;else h=l}}STd(a,c[a+4>>2]|0);i=b;return}function QTd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,625)|0;b=d+4|0;c[b>>2]=0;c[d+8>>2]=0;c[d>>2]=b;c[173692]=d;i=a;return}function RTd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[173692]|0;f=c[153084]|0;if(e)PTd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[173692]=0;i=a;return}function STd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{STd(a,c[b>>2]|0);STd(a,c[b+4>>2]|0);ACi(b);i=d;return}}function TTd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;l=(c[e>>2]|0)+e|0;m=l;c[e+4>>2]=m;n=d+8|0;o=(c[n>>2]|0)+1|0;c[n>>2]=o;p=d+12|0;q=c[p>>2]|0;r=q&2147483647;if(o>>>0>r>>>0){s=q<<1;t=(s|0)==0?1:s;do if(r>>>0<t>>>0)if((q|0)>-1){c[p>>2]=t;s=c[d>>2]|0;c[j>>2]=c[d+4>>2];c[h+0>>2]=c[j+0>>2];c[d>>2]=hOb(s,t*12|0,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[d+4>>2];c[h+0>>2]=c[j+0>>2];s=cOb(t*12|0,4,h,0,3653512,352)|0;YEi(s|0,c[d>>2]|0,(c[n>>2]|0)*12|0)|0;c[p>>2]=t;c[d>>2]=s;break}while(0);u=c[n>>2]|0}else u=o;o=u+-1|0;u=c[d>>2]|0;n=~c[b>>2];c[u+(o*12|0)>>2]=n;c[u+(o*12|0)+4>>2]=a;if(f){if(!l)v=-1;else v=u$d(m,n)|0;c[u+(o*12|0)+8>>2]=v}else{v=c[e+24>>2]|0;m=e+28|0;l=m;t=0;while(1){if((t|0)>=(v|0)){w=-1;break}if((c[(c[m>>2]|0)+l+(t<<2)>>2]|0)==(n|0)){w=t;break}else t=t+1|0}c[u+(o*12|0)+8>>2]=w}w=c[a+140>>2]|0;o=c[a+148>>2]|0;a=w+(o<<2)|0;if(!o){i=g;return}else x=w;do{w=c[x>>2]|0;YXd(k,b,mo[c[(c[w>>2]|0)+32>>2]&4095](w)|0);TTd(w,k,d,e,f);x=x+4|0}while((x|0)!=(a|0));i=g;return}function UTd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;l=xo[c[c[j>>2]>>2]&2047](j,28,4)|0;if(!l)m=0;else{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;m=l}c[m+16>>2]=h;c[m+20>>2]=b;c[m+24>>2]=d;d=c[h>>2]|0;if((d|0)!=0?(l=c[d+h>>2]|0,(l|0)>0):0){d=xo[c[c[j>>2]>>2]&2047](j,l*12|0,4)|0;if(!d)n=0;else{o=d+(l*12|0)|0;l=d;do{c[l>>2]=-1;c[l+4>>2]=-1;c[l+8>>2]=-1;l=l+12|0}while((l|0)!=(o|0));n=d}c[m+8>>2]=n}n=l_d(e,f,j)|0;c[m>>2]=n;c[m+4>>2]=u_d(n,j)|0;n=c[b>>2]|0;if(!n)p=0;else p=xo[c[c[j>>2]>>2]&2047](j,n,1)|0;c[m+12>>2]=p;n=c[h+68>>2]|0;if((n|0)==-1)q=0;else{j=(c[h>>2]|0)+h+12|0;q=c[j+(c[j>>2]|0)+(n<<2)>>2]|0}n=c[b>>2]|0;if(!n){i=k;return m|0}j=b+4|0;b=(c[j>>2]|0)+j|0;j=0;do{h=b+(j<<3)|0;f=h+(c[h>>2]|0)+16|0;h=f+(c[f>>2]|0)|0;f=c[h>>2]|0;a:do if(!f)r=1;else{e=h+4|0;d=(c[e>>2]|0)+e|0;e=0;while(1){if((c[d+(e<<3)>>2]|0)==(q|0)){s=e;break}e=e+1|0;if(e>>>0>=f>>>0){r=0;break a}}r=ea(g[d+(s<<3)+4>>2])>ea(0.0)&1}while(0);a[p+j>>0]=r;j=j+1|0}while((j|0)!=(n|0));i=k;return m|0}function VTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)!=2){i=e;return}d=c[a+4>>2]|0;f=c[a>>2]|0;if((f|0)>0){g=0;do{h=d+(g<<2)|0;if((c[h>>2]|0)==(b|0))c[h>>2]=0;g=g+1|0}while((g|0)!=(f|0))}f=c[a+16>>2]|0;if(!f){i=e;return}g=c[a+20>>2]|0;a=0;do{d=g+(a*12|0)|0;if((c[d>>2]|0)==(b|0))c[d>>2]=0;a=a+1|0}while((a|0)!=(f|0));i=e;return}function WTd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;e=c[a>>2]|0;if((e|0)>0){f=0;do{g=d+(f<<2)|0;h=c[g>>2]|0;if((h|0)!=0?!(NQb(h,1836,a)|0):0)LQb(c[g>>2]|0,1836,a);f=f+1|0}while((f|0)!=(e|0))}e=a+16|0;if(!(c[e>>2]|0)){i=b;return}f=a+20|0;d=0;do{g=c[(c[f>>2]|0)+(d*12|0)>>2]|0;if((g|0)!=0?!(NQb(g,1836,a)|0):0)LQb(c[(c[f>>2]|0)+(d*12|0)>>2]|0,1836,a);d=d+1|0}while(d>>>0<(c[e>>2]|0)>>>0);i=b;return}function XTd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+4>>2]|0;e=c[a>>2]|0;if((e|0)>0){f=0;do{g=c[d+(f<<2)>>2]|0;if(g)MQb(g,1836,a);f=f+1|0}while((f|0)!=(e|0))}e=a+16|0;f=c[e>>2]|0;if(!f){i=b;return}d=a+20|0;g=f;f=0;while(1){h=c[(c[d>>2]|0)+(f*12|0)>>2]|0;if(!h)j=g;else{MQb(h,1836,a);j=c[e>>2]|0}f=f+1|0;if(f>>>0>=j>>>0)break;else g=j}i=b;return}function YTd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+4>>2]|0;e=c[a>>2]|0;if((e|0)>0){f=0;do{g=c[d+(f<<4)+12>>2]|0;if(g)MQb(g,1837,a);f=f+1|0}while((f|0)!=(e|0))}e=c[a+12>>2]|0;f=c[a+8>>2]|0;if((f|0)>0){d=0;do{g=c[e+(d<<4)+12>>2]|0;if(g)MQb(g,1837,a);d=d+1|0}while((d|0)!=(f|0))}f=c[a+20>>2]|0;d=c[a+16>>2]|0;if((d|0)<=0){i=b;return}e=0;do{g=c[f+(e<<4)+12>>2]|0;if(g)MQb(g,1837,a);e=e+1|0}while((e|0)!=(d|0));i=b;return}function ZTd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+8|0;j=e;k=c[153134]|0;c[h>>2]=0;l=h+4|0;c[l>>2]=k;k=h+8|0;c[k>>2]=0;m=h+12|0;c[m>>2]=0;n=(c[b>>2]|0)+b|0;o=n;c[b+4>>2]=o;p=-1;q=0;r=0;while(1){if(!(p&1))s=r;else s=1<<31-q|r;q=q+1|0;if((q|0)==32){t=s;break}else{p=p>>>1;r=s}}c[j>>2]=t;TTd(a,j,h,b,1);j=xo[c[c[d>>2]>>2]&2047](d,24,4)|0;c[j+16>>2]=0;c[j+20>>2]=0;t=c[a+24>>2]|0;if(!t)u=0;else u=c[t+4>>2]|0;c[j+12>>2]=u;a:do if(n){u=c[o>>2]|0;c[j>>2]=u;if(u){t=xo[c[c[d>>2]>>2]&2047](d,u<<2,4)|0;u=c[j>>2]|0;a=j+4|0;c[a>>2]=t;if((u|0)!=0?(PEi(t|0,0,u<<2|0)|0,u=c[b+44>>2]|0,(u|0)!=0):0){t=b+48|0;s=(c[t>>2]|0)+t|0;t=c[s>>2]|0;r=c[a>>2]|0;if((t|0)==-1){v=-1;w=1}else{p=o+4|0;q=(c[p>>2]|0)+p|0;p=t;do{c[r+(p<<2)>>2]=-1;p=c[q+(p<<3)>>2]|0}while((p|0)!=-1);v=t;w=1}while(1){if((v|0)!=-1)c[(c[a>>2]|0)+(v<<2)>>2]=-1;if(w>>>0>=u>>>0){x=j;y=a;break a}v=c[s+(w<<2)>>2]|0;w=w+1|0}}else{x=j;y=a}}else{z=j;A=11}}else{c[j>>2]=0;z=j;A=11}while(0);if((A|0)==11){A=j+4|0;c[A>>2]=0;x=z;y=A}A=c[k>>2]|0;if(!A)B=0;else{k=c[h>>2]|0;z=0;w=0;while(1){v=c[k+(z*12|0)+8>>2]|0;if((v|0)!=-1?(o=(c[y>>2]|0)+(v<<2)|0,(c[o>>2]|0)==(-1|0)):0){c[o>>2]=c[k+(z*12|0)+4>>2];C=w|3}else C=w;z=z+1|0;if(z>>>0>=A>>>0){B=C;break}else w=C}}C=c[x>>2]|0;if(C){x=0;do{w=(c[y>>2]|0)+(x<<2)|0;if((c[w>>2]|0)==(-1|0))c[w>>2]=0;x=x+1|0}while(x>>>0<C>>>0)}c[j+8>>2]=B;WTd(j);if((c[m>>2]|0)<=-1){i=e;return j|0}m=c[h>>2]|0;c[g>>2]=c[l>>2];c[f+0>>2]=c[g+0>>2];eOb(m,f);c[h>>2]=0;i=e;return j|0}function _Td(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+8|0;k=e;l=c[153134]|0;c[j>>2]=0;m=j+4|0;c[m>>2]=l;l=j+8|0;c[l>>2]=0;n=j+12|0;c[n>>2]=0;o=-1;p=0;q=0;while(1){if(!(o&1))r=q;else r=1<<31-p|q;p=p+1|0;if((p|0)==32){s=r;break}else{o=o>>>1;q=r}}c[k>>2]=s;TTd(a,k,j,b,0);k=(c[b>>2]|0)+b|0;s=k;c[b+4>>2]=s;b=xo[c[c[d>>2]>>2]&2047](d,24,4)|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;r=c[l>>2]|0;l=c[153134]|0;c[g>>2]=l;c[f+0>>2]=c[g+0>>2];q=cOb(r*12|0,4,f,0,3653512,352)|0;a:do if((r|0)>0){o=c[j>>2]|0;if(!k){p=0;t=0;while(1){u=c[o+(t*12|0)+4>>2]|0;if((c[u+156>>2]|0)==(a|0)){c[q+(p*12|0)>>2]=u;v=q+(p*12|0)+4|0;c[v>>2]=-1;w=q+(p*12|0)+8|0;c[w>>2]=-1;x=c[o+(t*12|0)+8>>2]|0;if((x|0)!=-1){c[v>>2]=x;c[w>>2]=x}x=CTb(c[u+24>>2]|0,137)|0;if(x)Dcc(x)|0;y=((c[w>>2]|0)!=-1&1)+p|0}else y=p;t=t+1|0;if((t|0)>=(r|0)){z=y;break}else p=y}}else{p=0;t=0;while(1){w=c[o+(t*12|0)+4>>2]|0;if((c[w+156>>2]|0)==(a|0)){c[q+(p*12|0)>>2]=w;x=q+(p*12|0)+4|0;c[x>>2]=-1;u=q+(p*12|0)+8|0;c[u>>2]=-1;v=c[o+(t*12|0)+8>>2]|0;if((v|0)!=-1){c[x>>2]=v;c[u>>2]=v}v=CTb(c[w+24>>2]|0,137)|0;if((((v|0)!=0?(w=Dcc(v)|0,(w|0)!=0):0)?(v=c[w+132>>2]|0,(v|0)!=0):0)?(w=u$d(s,v)|0,(w|0)!=-1):0)c[u>>2]=w;A=((c[u>>2]|0)!=-1&1)+p|0}else A=p;t=t+1|0;if((t|0)>=(r|0)){z=A;break}else p=A}}c[b+16>>2]=z;if(z){p=xo[c[c[d>>2]>>2]&2047](d,z*12|0,4)|0;t=b+20|0;c[t>>2]=p;if((z|0)>0){o=p;p=0;while(1){u=o+(p*12|0)|0;w=q+(p*12|0)|0;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];w=p+1|0;if((w|0)==(z|0))break a;o=c[t>>2]|0;p=w}}}else B=27}else{c[b+16>>2]=0;B=27}while(0);if((B|0)==27)c[b+20>>2]=0;WTd(b);if((r|0)>-1){c[g>>2]=l;c[f+0>>2]=c[g+0>>2];eOb(q,f)}if((c[n>>2]|0)<=-1){i=e;return b|0}n=c[j>>2]|0;c[h>>2]=c[m>>2];c[f+0>>2]=c[h+0>>2];eOb(n,f);c[j>>2]=0;i=e;return b|0}function $Td(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(!a){i=d;return}e=a+4|0;f=c[e>>2]|0;g=c[a>>2]|0;if((g|0)>0){h=0;do{j=c[f+(h<<2)>>2]|0;if(j)MQb(j,1836,a);h=h+1|0}while((h|0)!=(g|0))}g=a+16|0;h=c[g>>2]|0;f=a+20|0;if(h){j=h;h=0;while(1){k=c[(c[f>>2]|0)+(h*12|0)>>2]|0;if(!k)l=j;else{MQb(k,1836,a);l=c[g>>2]|0}h=h+1|0;if(h>>>0>=l>>>0)break;else j=l}}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[e>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[f>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function aUd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;k=i;i=i+64|0;l=k+48|0;m=k;n=k+44|0;o=k+40|0;p=k+24|0;q=k+16|0;r=qUd()|0;c[e+4>>2]=(c[e>>2]|0)+e;s=c[153134]|0;c[p>>2]=0;t=p+4|0;c[t>>2]=s;u=p+8|0;c[u>>2]=0;v=p+12|0;c[v>>2]=0;w=-1;x=0;y=0;while(1){if(!(w&1))z=y;else z=1<<31-x|y;x=x+1|0;if((x|0)==32){A=z;break}else{w=w>>>1;y=z}}c[q>>2]=A;TTd(d,q,p,e,1);q=b+20|0;A=c[q>>2]|0;if(A){c[m>>2]=s;c[l+0>>2]=c[m+0>>2];z=hOb(0,A<<2,4,l,0,3653512,370)|0;if(!(c[q>>2]|0)){B=A;C=0;D=z}else{y=c[b+24>>2]|0;w=c[u>>2]|0;x=(w|0)==0;E=c[p>>2]|0;F=0;while(1){G=c[y+(F<<3)>>2]|0;a:do if(x)H=-1;else{I=0;while(1){if((c[E+(I*12|0)>>2]|0)==(G|0)){H=I;break a}I=I+1|0;if(I>>>0>=w>>>0){H=-1;break}}}while(0);c[z+(F<<2)>>2]=H;F=F+1|0;G=c[q>>2]|0;if(F>>>0>=G>>>0){B=A;C=G;D=z;break}}}}else{B=0;C=0;D=0}if(h){z=c[b+16>>2]|0;if(z>>>0<C>>>0){A=b+24|0;F=b+32|0;H=c[p>>2]|0;w=0;E=z;x=z;while(1){y=(c[A>>2]|0)+(x<<3)+4|0;G=MUd(c[y>>2]|0)|0;I=c[D+(x<<2)>>2]|0;if((I|0)!=-1){J=c[H+(I*12|0)+4>>2]|0;I=c[y>>2]|0;if((I|0)==3){y=J+56|0;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2]}else if((I|0)==1){y=J+44|0;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2]}else if((I|0)==2){I=J+28|0;c[m+0>>2]=c[I+0>>2];c[m+4>>2]=c[I+4>>2];c[m+8>>2]=c[I+8>>2];c[m+12>>2]=c[I+12>>2]}if((G|0)>0){I=c[F>>2]|0;J=x+1|0;y=w;K=E;L=0;while(1){M=ea(g[I+(y<<2)>>2]);N=ea(M-ea(g[m+(L<<2)>>2]));if(N<ea(0.0))O=ea(-N);else O=N;P=O<=ea(9.99999974e-06);Q=P?K:J;L=L+1|0;if((L|0)==(G|0)){R=Q;break}else{y=y+1|0;K=Q}}S=G+w|0;T=R}else{S=w;T=E}}else{S=G+w|0;T=E}x=x+1|0;K=c[q>>2]|0;if(x>>>0>=K>>>0){U=T;V=K;break}else{w=S;E=T}}}else{U=z;V=C}}else{U=C;V=C}C=b+36|0;z=(c[c[(c[C>>2]|0)+24>>2]>>2]|0)+U-V|0;if(h)W=(U|0)==(c[b+16>>2]|0)&1;else W=0;h=xo[c[c[j>>2]>>2]&2047](j,52,4)|0;c[h>>2]=U;if((U|0)!=0?(V=xo[c[c[j>>2]>>2]&2047](j,U<<4,4)|0,(V|0)!=0):0){T=V+(U<<4)|0;E=V;do{c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;E=E+16|0}while((E|0)!=(T|0));X=V}else X=0;V=h+4|0;c[V>>2]=X;X=h+40|0;c[X>>2]=-1;T=h+44|0;c[T>>2]=-1;E=h+48|0;c[E>>2]=-1;S=c[b>>2]|0;w=h+8|0;c[w>>2]=S;if((S|0)!=0?(x=xo[c[c[j>>2]>>2]&2047](j,S<<4,4)|0,(x|0)!=0):0){q=x+(S<<4)|0;S=x;do{c[S+0>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;c[S+12>>2]=0;S=S+16|0}while((S|0)!=(q|0));Y=x}else Y=0;x=h+12|0;c[x>>2]=Y;Y=c[b+8>>2]|0;q=h+16|0;c[q>>2]=Y;if((Y|0)!=0?(S=xo[c[c[j>>2]>>2]&2047](j,Y<<4,4)|0,(S|0)!=0):0){R=S+(Y<<4)|0;Y=S;do{c[Y+0>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;c[Y+12>>2]=0;Y=Y+16|0}while((Y|0)!=(R|0));Z=S}else Z=0;S=h+20|0;c[S>>2]=Z;a[h+36>>0]=W;W=h+28|0;a[W>>0]=0;Z=c[h>>2]|0;if(!Z)_=0;else{R=c[p>>2]|0;Y=c[b+24>>2]|0;m=c[V>>2]|0;F=0;H=0;A=0;K=0;y=0;L=0;while(1){J=c[D+(H<<2)>>2]|0;I=c[Y+(H<<3)+4>>2]|0;c[m+(H<<4)+4>>2]=I;if((J|0)==-1){c[m+(H<<4)+12>>2]=0;$=0;aa=F;ba=L}else{Q=c[R+(J*12|0)+4>>2]|0;c[m+(H<<4)+12>>2]=Q;J=((c[Q+8>>2]&-2097152|0)==469762048|F&255)&255;a[W>>0]=J;$=(Q|0)==(d|0);aa=J;ba=((I|0)==3?11:3)|L}if((I|0)==3){if($)c[E>>2]=y;ca=A;da=K;fa=y+1|0}else if((I|0)==1){if($)c[X>>2]=A;ca=A+1|0;da=K;fa=y}else if((I|0)==2){if($)c[T>>2]=K;ca=A;da=K+1|0;fa=y}else{ca=A;da=K;fa=y}H=H+1|0;if(H>>>0>=Z>>>0){_=ba;break}else{F=aa;A=ca;K=da;y=fa;L=ba}}}c[h+24>>2]=_;_=c[w>>2]|0;if(_){ba=b+4|0;L=c[u>>2]|0;fa=(L|0)==0;y=c[p>>2]|0;da=_;_=0;while(1){K=c[x>>2]|0;c[K+(_<<4)+12>>2]=0;c[K+(_<<4)+4>>2]=0;ca=c[ba>>2]|0;A=c[ca+(_<<4)>>2]|0;b:do if(!fa){aa=0;while(1){if((c[y+(aa*12|0)>>2]|0)==(A|0)){ga=aa;break}aa=aa+1|0;if(aa>>>0>=L>>>0){ha=da;break b}}if((ga|0)!=-1){xUd(r,ca+(_<<4)|0,c[y+(ga*12|0)+4>>2]|0,K+(_<<4)|0)|0;ha=c[w>>2]|0}else ha=da}else ha=da;while(0);_=_+1|0;if(_>>>0>=ha>>>0)break;else da=ha}}ha=c[q>>2]|0;if(ha){da=b+12|0;_=c[u>>2]|0;u=(_|0)==0;ga=c[p>>2]|0;y=ha;ha=0;while(1){L=c[S>>2]|0;c[L+(ha<<4)+12>>2]=0;c[L+(ha<<4)+4>>2]=0;fa=c[da>>2]|0;ba=c[fa+(ha<<4)>>2]|0;c:do if(!u){K=0;while(1){if((c[ga+(K*12|0)>>2]|0)==(ba|0)){ia=K;break}K=K+1|0;if(K>>>0>=_>>>0){ja=y;break c}}if((ia|0)!=-1){vUd(r,fa+(ha<<4)|0,c[ga+(ia*12|0)+4>>2]|0,L+(ha<<4)|0)|0;ja=c[q>>2]|0}else ja=y}else ja=y;while(0);ha=ha+1|0;if(ha>>>0>=ja>>>0)break;else y=ja}}ja=c[C>>2]|0;C=UTd(f,ja,c[ja+24>>2]|0,z,e,j)|0;j=h+32|0;c[j>>2]=C;z=c[p>>2]|0;ja=c[C+8>>2]|0;if((ja|0)!=0&(U|0)>0){C=c[b+24>>2]|0;b=-1;f=-1;y=-1;ha=0;while(1){ia=c[C+(ha<<3)+4>>2]|0;ga=(ia|0)==3;do if(!ga)if((ia|0)==1){ka=b+1|0;la=f;ma=y;break}else if((ia|0)==2){ka=b;la=f+1|0;ma=y;break}else{ka=b;la=f;ma=y;break}else{ka=b;la=f;ma=y+1|0}while(0);r=c[D+(ha<<2)>>2]|0;do if((r|0)!=-1?(_=c[z+(r*12|0)+8>>2]|0,(_|0)!=-1):0){if(ga){c[ja+(_*12|0)+8>>2]=ma;break}if((ia|0)==1){c[ja+(_*12|0)>>2]=ka;break}else if((ia|0)==2){c[ja+(_*12|0)+4>>2]=la;break}else break}while(0);ha=ha+1|0;if((ha|0)==(U|0))break;else{b=ka;f=la;y=ma}}}ma=c[V>>2]|0;V=c[h>>2]|0;if((V|0)>0){y=0;do{la=ma+(y<<4)+12|0;f=c[la>>2]|0;if((f|0)!=0?!(NQb(f,1837,h)|0):0)LQb(c[la>>2]|0,1837,h);y=y+1|0}while((y|0)!=(V|0))}V=c[x>>2]|0;x=c[w>>2]|0;if((x|0)>0){w=0;do{y=V+(w<<4)+12|0;ma=c[y>>2]|0;if((ma|0)!=0?!(NQb(ma,1837,h)|0):0)LQb(c[y>>2]|0,1837,h);w=w+1|0}while((w|0)!=(x|0))}x=c[S>>2]|0;S=c[q>>2]|0;if((S|0)>0){q=0;do{w=x+(q<<4)+12|0;V=c[w>>2]|0;if((V|0)!=0?!(NQb(V,1837,h)|0):0)LQb(c[w>>2]|0,1837,h);q=q+1|0}while((q|0)!=(S|0))}mUd(h,e,1,c[j>>2]|0);if((B|0)>-1){c[n>>2]=s;c[l+0>>2]=c[n+0>>2];eOb(D,l)}if((c[v>>2]|0)<=-1){i=k;return h|0}c[o>>2]=c[t>>2];c[l+0>>2]=c[o+0>>2];eOb(z,l);c[p>>2]=0;i=k;return h|0}
function bUd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;k=i;i=i+48|0;l=k+44|0;m=k;n=k+40|0;o=k+24|0;p=k+16|0;q=qUd()|0;r=e;s=(c[e>>2]|0)+r|0;t=e+4|0;c[t>>2]=s;u=c[153134]|0;c[o>>2]=0;v=o+4|0;c[v>>2]=u;u=o+8|0;c[u>>2]=0;w=o+12|0;c[w>>2]=0;x=-1;y=0;z=0;while(1){if(!(x&1))A=z;else A=1<<31-y|z;y=y+1|0;if((y|0)==32){B=A;break}else{x=x>>>1;z=A}}c[p>>2]=B;TTd(d,p,o,e,0);if(h){p=(c[e>>2]|0)+r|0;c[t>>2]=p;t=e+8|0;r=(c[t>>2]|0)+t|0;c[e+12>>2]=r;t=c[b+16>>2]|0;d=b+20|0;B=c[d>>2]|0;if(t>>>0<B>>>0){A=b+24|0;z=r+4|0;r=z;x=m+4|0;y=m+8|0;C=m+12|0;D=b+32|0;E=0;F=t;G=t;while(1){H=c[A>>2]|0;I=H+(G<<3)+4|0;J=MUd(c[I>>2]|0)|0;K=u$d(p,c[H+(G<<3)>>2]|0)|0;if((K|0)!=-1){H=(c[z>>2]|0)+r|0;L=c[I>>2]|0;if((L|0)==3){g[m>>2]=ea(g[H+(K*48|0)+32>>2]);g[x>>2]=ea(g[H+(K*48|0)+36>>2]);g[y>>2]=ea(g[H+(K*48|0)+40>>2]);g[C>>2]=ea(g[H+(K*48|0)+44>>2])}else if((L|0)==1){g[m>>2]=ea(g[H+(K*48|0)>>2]);g[x>>2]=ea(g[H+(K*48|0)+4>>2]);g[y>>2]=ea(g[H+(K*48|0)+8>>2]);g[C>>2]=ea(g[H+(K*48|0)+12>>2])}else if((L|0)==2){g[m>>2]=ea(g[H+(K*48|0)+16>>2]);g[x>>2]=ea(g[H+(K*48|0)+20>>2]);g[y>>2]=ea(g[H+(K*48|0)+24>>2]);g[C>>2]=ea(g[H+(K*48|0)+28>>2])}if((J|0)>0){K=c[D>>2]|0;H=G+1|0;L=E;I=F;M=0;while(1){N=ea(g[K+(L<<2)>>2]);O=ea(N-ea(g[m+(M<<2)>>2]));if(O<ea(0.0))P=ea(-O);else P=O;Q=P<=ea(9.99999974e-06);R=Q?I:H;M=M+1|0;if((M|0)==(J|0)){S=R;break}else{L=L+1|0;I=R}}T=J+E|0;U=S}else{T=E;U=F}}else{T=J+E|0;U=F}G=G+1|0;I=c[d>>2]|0;if(G>>>0>=I>>>0){V=U;W=I;break}else{E=T;F=U}}}else{V=t;W=B}}else{B=c[b+20>>2]|0;V=B;W=B}B=b+36|0;t=(c[c[(c[B>>2]|0)+24>>2]>>2]|0)+V-W|0;if(h)X=(V|0)==(c[b+16>>2]|0)&1;else X=0;h=xo[c[c[j>>2]>>2]&2047](j,52,4)|0;c[h>>2]=0;W=h+4|0;c[W>>2]=0;c[h+40>>2]=-1;c[h+44>>2]=-1;c[h+48>>2]=-1;U=c[b>>2]|0;F=h+8|0;c[F>>2]=U;if((U|0)!=0?(T=xo[c[c[j>>2]>>2]&2047](j,U<<4,4)|0,(T|0)!=0):0){E=T+(U<<4)|0;U=T;do{c[U+0>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;c[U+12>>2]=0;U=U+16|0}while((U|0)!=(E|0));Y=T}else Y=0;T=h+12|0;c[T>>2]=Y;Y=c[b+8>>2]|0;E=h+16|0;c[E>>2]=Y;if((Y|0)!=0?(U=xo[c[c[j>>2]>>2]&2047](j,Y<<4,4)|0,(U|0)!=0):0){G=U+(Y<<4)|0;Y=U;do{c[Y+0>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;c[Y+12>>2]=0;Y=Y+16|0}while((Y|0)!=(G|0));Z=U}else Z=0;U=h+20|0;c[U>>2]=Z;a[h+36>>0]=X;a[h+28>>0]=0;if(c[F>>2]|0){X=b+4|0;Z=c[u>>2]|0;G=(Z|0)==0;Y=c[o>>2]|0;d=0;do{S=c[T>>2]|0;c[S+(d<<4)+12>>2]=0;c[S+(d<<4)+4>>2]=0;S=u$d(s,c[(c[X>>2]|0)+(d<<4)>>2]|0)|0;a:do if(!G){m=0;while(1){if((c[Y+(m*12|0)+8>>2]|0)==(S|0)){_=m;break}m=m+1|0;if(m>>>0>=Z>>>0)break a}if((_|0)!=-1)xUd(q,(c[X>>2]|0)+(d<<4)|0,c[Y+(_*12|0)+4>>2]|0,(c[T>>2]|0)+(d<<4)|0)|0}while(0);d=d+1|0}while(d>>>0<(c[F>>2]|0)>>>0)}if(c[E>>2]|0){d=b+12|0;_=c[u>>2]|0;u=(_|0)==0;Y=c[o>>2]|0;X=0;do{Z=c[U>>2]|0;c[Z+(X<<4)+12>>2]=0;c[Z+(X<<4)+4>>2]=0;Z=u$d(s,c[(c[d>>2]|0)+(X<<4)>>2]|0)|0;b:do if(!u){G=0;while(1){if((c[Y+(G*12|0)+8>>2]|0)==(Z|0)){$=G;break}G=G+1|0;if(G>>>0>=_>>>0)break b}if(($|0)!=-1)vUd(q,(c[d>>2]|0)+(X<<4)|0,c[Y+($*12|0)+4>>2]|0,(c[U>>2]|0)+(X<<4)|0)|0}while(0);X=X+1|0}while(X>>>0<(c[E>>2]|0)>>>0)}X=c[B>>2]|0;B=UTd(f,X,c[X+24>>2]|0,t,e,j)|0;j=h+32|0;c[j>>2]=B;t=B+8|0;if((c[t>>2]|0)!=0&(V|0)>0){B=b+24|0;b=-1;X=-1;f=-1;$=0;while(1){Y=c[B>>2]|0;d=c[Y+($<<3)+4>>2]|0;q=(d|0)==3;do if(!q)if((d|0)==2){aa=b;ba=X+1|0;ca=f;break}else if((d|0)==1){aa=b+1|0;ba=X;ca=f;break}else{aa=b;ba=X;ca=f;break}else{aa=b;ba=X;ca=f+1|0}while(0);_=u$d(s,c[Y+($<<3)>>2]|0)|0;do if((_|0)!=-1){if(q){c[(c[t>>2]|0)+(_*12|0)+8>>2]=ca;break}if((d|0)==2){c[(c[t>>2]|0)+(_*12|0)+4>>2]=ba;break}else if((d|0)==1){c[(c[t>>2]|0)+(_*12|0)>>2]=aa;break}else break}while(0);$=$+1|0;if(($|0)==(V|0))break;else{b=aa;X=ba;f=ca}}}ca=c[W>>2]|0;W=c[h>>2]|0;if((W|0)>0){f=0;do{ba=ca+(f<<4)+12|0;X=c[ba>>2]|0;if((X|0)!=0?!(NQb(X,1837,h)|0):0)LQb(c[ba>>2]|0,1837,h);f=f+1|0}while((f|0)!=(W|0))}W=c[T>>2]|0;T=c[F>>2]|0;if((T|0)>0){F=0;do{f=W+(F<<4)+12|0;ca=c[f>>2]|0;if((ca|0)!=0?!(NQb(ca,1837,h)|0):0)LQb(c[f>>2]|0,1837,h);F=F+1|0}while((F|0)!=(T|0))}T=c[U>>2]|0;U=c[E>>2]|0;if((U|0)>0){E=0;do{F=T+(E<<4)+12|0;W=c[F>>2]|0;if((W|0)!=0?!(NQb(W,1837,h)|0):0)LQb(c[F>>2]|0,1837,h);E=E+1|0}while((E|0)!=(U|0))}mUd(h,e,0,c[j>>2]|0);if((c[w>>2]|0)<=-1){i=k;return h|0}w=c[o>>2]|0;c[n>>2]=c[v>>2];c[l+0>>2]=c[n+0>>2];eOb(w,l);c[o>>2]=0;i=k;return h|0}function cUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!a){i=d;return}YTd(a);e=c[a+32>>2]|0;if(!e)f=b;else{v_d(c[e+4>>2]|0,b);m_d(c[e>>2]|0,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[e+8>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[e+12>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,e);f=b}In[c[(c[f>>2]|0)+4>>2]&4095](b,c[a+20>>2]|0);In[c[(c[f>>2]|0)+4>>2]&4095](b,c[a+4>>2]|0);In[c[(c[f>>2]|0)+4>>2]&4095](b,c[a+12>>2]|0);In[c[(c[f>>2]|0)+4>>2]&4095](b,a);i=d;return}function dUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+16|0;if(!(c[e>>2]|0)){i=d;return}f=a+20|0;a=b+16|0;b=a;g=0;h=0;while(1){j=c[f>>2]|0;if(((c[j+(h<<4)+4>>2]|0)!=0?AUd(j+(h<<4)|0,c[(c[a>>2]|0)+b+(h<<2)>>2]|0)|0:0)?(k=j+(h<<4)+12|0,j=c[k>>2]|0,(g|0)!=(j|0)):0)if(!g)l=j;else{DUd(g);l=c[k>>2]|0}else l=g;h=h+1|0;if((h|0)==(c[e>>2]|0)){m=l;break}else g=l}if(!m){i=d;return}DUd(m);i=d;return}function eUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;if(!(c[e>>2]|0)){i=d;return}f=a+12|0;a=b+28|0;b=a;h=0;j=0;while(1){k=c[f>>2]|0;if(((c[k+(j<<4)+4>>2]|0)!=0?BUd(k+(j<<4)|0,ea(g[(c[a>>2]|0)+b+(j<<2)>>2]))|0:0)?(l=k+(j<<4)+12|0,k=c[l>>2]|0,(h|0)!=(k|0)):0)if(!h)m=k;else{DUd(h);m=c[l>>2]|0}else m=h;j=j+1|0;if((j|0)==(c[e>>2]|0)){n=m;break}else h=m}if(!n){i=d;return}DUd(n);i=d;return}function fUd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(!(c[d+8>>2]|c[b+24>>2])){i=e;return}JGc(a);i=e;return}function gUd(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;h=c[b>>2]|0;if((h|0)<=1){i=f;return}j=b+4|0;b=e+4|0;e=b;k=1;do{l=c[(c[j>>2]|0)+(k<<2)>>2]|0;if(l){m=(c[b>>2]|0)+e|0;n=ea(g[m+(k*48|0)>>2]);o=ea(g[m+(k*48|0)+4>>2]);p=ea(g[m+(k*48|0)+8>>2]);g[l+44>>2]=n;g[l+48>>2]=o;g[l+52>>2]=p;m=l+135|0;q=d[m>>0]|0;r=(c[b>>2]|0)+e|0;p=ea(g[r+(k*48|0)+16>>2]);o=ea(p*p);n=ea(g[r+(k*48|0)+20>>2]);s=ea(n*n);t=ea(g[r+(k*48|0)+24>>2]);u=ea(t*t);v=ea(g[r+(k*48|0)+28>>2]);w=ea(ea(1.0)/ea(T(ea(ea(o+s)+ea(u+ea(v*v))))));u=ea(n*w);n=ea(t*w);t=ea(v*w);g[l+28>>2]=ea(p*w);g[l+32>>2]=u;g[l+36>>2]=n;g[l+40>>2]=t;a[m>>0]=q|3}k=k+1|0}while((k|0)!=(h|0));i=f;return}function hUd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;i=i+32|0;e=d+16|0;f=d;h=a+16|0;j=c[h>>2]|0;if(!j){i=d;return}k=a+20|0;a=b+4|0;b=a;l=e+4|0;m=e+8|0;n=f+4|0;o=f+8|0;p=f+12|0;q=j;j=0;while(1){r=c[k>>2]|0;s=c[r+(j*12|0)>>2]|0;if(!s)t=q;else{u=c[r+(j*12|0)+8>>2]|0;r=(c[a>>2]|0)+b|0;v=ea(g[r+(u*48|0)>>2]);w=ea(g[r+(u*48|0)+4>>2]);x=ea(g[r+(u*48|0)+8>>2]);g[e>>2]=v;g[l>>2]=w;g[m>>2]=x;x=ea(g[r+(u*48|0)+16>>2]);w=ea(x*x);v=ea(g[r+(u*48|0)+20>>2]);y=ea(v*v);z=ea(g[r+(u*48|0)+24>>2]);A=ea(z*z);B=ea(g[r+(u*48|0)+28>>2]);C=ea(ea(1.0)/ea(T(ea(ea(w+y)+ea(A+ea(B*B))))));A=ea(v*C);v=ea(z*C);z=ea(B*C);g[f>>2]=ea(x*C);g[n>>2]=A;g[o>>2]=v;g[p>>2]=z;BGc(s,e,f);t=c[h>>2]|0}j=j+1|0;if(j>>>0>=t>>>0)break;else q=t}i=d;return}function iUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b)if((c[a+40>>2]|0)==-1?(c[a+44>>2]|0)==-1:0)e=4;else f=1;else e=4;if((e|0)==4)f=(c[a+48>>2]|0)!=-1;i=d;return f|0}function jUd(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;j=i;i=i+48|0;k=j+32|0;l=j+16|0;m=j;if(!(a[b+28>>0]|0)){if(!h){n=c[b+40>>2]|0;if((n|0)!=-1){o=e+40|0;p=(c[o>>2]|0)+o|0;q=ea(g[p+(n<<4)>>2]);r=ea(g[p+(n<<4)+4>>2]);s=ea(g[p+(n<<4)+8>>2]);g[f+44>>2]=q;g[f+48>>2]=r;g[f+52>>2]=s;n=f+135|0;a[n>>0]=d[n>>0]|1}n=c[b+44>>2]|0;if((n|0)!=-1){p=e+52|0;o=(c[p>>2]|0)+p|0;s=ea(g[o+(n<<4)>>2]);r=ea(g[o+(n<<4)+4>>2]);q=ea(g[o+(n<<4)+8>>2]);t=ea(g[o+(n<<4)+12>>2]);u=ea(ea(1.0)/ea(T(ea(ea(ea(s*s)+ea(r*r))+ea(ea(q*q)+ea(t*t))))));v=ea(r*u);r=ea(q*u);q=ea(t*u);g[f+28>>2]=ea(s*u);g[f+32>>2]=v;g[f+36>>2]=r;g[f+40>>2]=q;n=f+135|0;a[n>>0]=d[n>>0]|2}}n=c[b+48>>2]|0;if((n|0)==-1){JGc(f);i=j;return}o=e+64|0;p=(c[o>>2]|0)+o|0;q=ea(g[p+(n<<4)>>2]);r=ea(g[p+(n<<4)+4>>2]);v=ea(g[p+(n<<4)+8>>2]);g[f+56>>2]=q;g[f+60>>2]=r;g[f+64>>2]=v;n=f+135|0;a[n>>0]=d[n>>0]|8;gGc(f);JGc(f);i=j;return}else{if(!h){h=c[b+40>>2]|0;if((h|0)!=-1){n=e+40|0;p=(c[n>>2]|0)+n|0;v=ea(g[p+(h<<4)>>2]);r=ea(g[p+(h<<4)+4>>2]);q=ea(g[p+(h<<4)+8>>2]);g[k>>2]=v;g[k+4>>2]=r;g[k+8>>2]=q;EGc(f,k)}k=c[b+44>>2]|0;if((k|0)!=-1){h=e+52|0;p=(c[h>>2]|0)+h|0;q=ea(g[p+(k<<4)>>2]);r=ea(g[p+(k<<4)+4>>2]);v=ea(g[p+(k<<4)+8>>2]);u=ea(g[p+(k<<4)+12>>2]);s=ea(ea(1.0)/ea(T(ea(ea(ea(q*q)+ea(r*r))+ea(ea(v*v)+ea(u*u))))));t=ea(r*s);r=ea(v*s);v=ea(u*s);g[l>>2]=ea(q*s);g[l+4>>2]=t;g[l+8>>2]=r;g[l+12>>2]=v;FGc(f,l)}}l=c[b+48>>2]|0;if((l|0)==-1){JGc(f);i=j;return}b=e+64|0;e=(c[b>>2]|0)+b|0;v=ea(g[e+(l<<4)>>2]);r=ea(g[e+(l<<4)+4>>2]);t=ea(g[e+(l<<4)+8>>2]);g[m>>2]=v;g[m+4>>2]=r;g[m+8>>2]=t;GGc(f,m);JGc(f);i=j;return}}function kUd(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=i;i=i+48|0;j=h+24|0;k=h+12|0;l=h;m=(c[b>>2]|0)==0;if(!(a[b+28>>0]|0)){if(m){i=h;return}n=b+4|0;o=e+52|0;p=o;q=e+40|0;r=q;s=e+64|0;t=s;u=0;v=0;w=0;x=0;while(1){y=c[n>>2]|0;z=c[y+(u<<4)+4>>2]|0;A=c[y+(u<<4)+12>>2]|0;if((z|0)==2){if(!((A|0)==0|(A|0)==(f|0))){y=(c[o>>2]|0)+p|0;B=ea(g[y+(w<<4)>>2]);C=ea(g[y+(w<<4)+4>>2]);D=ea(g[y+(w<<4)+8>>2]);E=ea(g[y+(w<<4)+12>>2]);F=ea(ea(1.0)/ea(T(ea(ea(ea(B*B)+ea(C*C))+ea(ea(D*D)+ea(E*E))))));G=ea(C*F);C=ea(D*F);D=ea(E*F);g[A+28>>2]=ea(B*F);g[A+32>>2]=G;g[A+36>>2]=C;g[A+40>>2]=D;y=A+135|0;a[y>>0]=d[y>>0]|2}H=v;I=w+1|0;J=x}else if((z|0)==3){if(!((A|0)==0|(A|0)==(f|0))){y=(c[s>>2]|0)+t|0;D=ea(g[y+(x<<4)>>2]);C=ea(g[y+(x<<4)+4>>2]);G=ea(g[y+(x<<4)+8>>2]);g[A+56>>2]=D;g[A+60>>2]=C;g[A+64>>2]=G;y=A+135|0;a[y>>0]=d[y>>0]|8;gGc(A)}H=v;I=w;J=x+1|0}else if((z|0)==1){if(!((A|0)==0|(A|0)==(f|0))){z=(c[q>>2]|0)+r|0;G=ea(g[z+(v<<4)>>2]);C=ea(g[z+(v<<4)+4>>2]);D=ea(g[z+(v<<4)+8>>2]);g[A+44>>2]=G;g[A+48>>2]=C;g[A+52>>2]=D;z=A+135|0;a[z>>0]=d[z>>0]|1}H=v+1|0;I=w;J=x}else{H=v;I=w;J=x}u=u+1|0;if((u|0)==(c[b>>2]|0))break;else{v=H;w=I;x=J}}i=h;return}else{if(m){i=h;return}m=b+4|0;J=e+52|0;x=J;I=j+4|0;w=j+8|0;H=j+12|0;v=e+40|0;u=v;r=k+4|0;q=k+8|0;t=e+64|0;e=t;s=l+4|0;p=l+8|0;o=0;n=0;z=0;A=0;while(1){y=c[m>>2]|0;K=c[y+(o<<4)+4>>2]|0;L=c[y+(o<<4)+12>>2]|0;if((K|0)==1){if(!((L|0)==0|(L|0)==(f|0))){y=(c[v>>2]|0)+u|0;D=ea(g[y+(n<<4)>>2]);C=ea(g[y+(n<<4)+4>>2]);G=ea(g[y+(n<<4)+8>>2]);g[k>>2]=D;g[r>>2]=C;g[q>>2]=G;EGc(L,k)}M=n+1|0;N=z;O=A}else if((K|0)==3){if(!((L|0)==0|(L|0)==(f|0))){y=(c[t>>2]|0)+e|0;G=ea(g[y+(A<<4)>>2]);C=ea(g[y+(A<<4)+4>>2]);D=ea(g[y+(A<<4)+8>>2]);g[l>>2]=G;g[s>>2]=C;g[p>>2]=D;GGc(L,l)}M=n;N=z;O=A+1|0}else if((K|0)==2){if(!((L|0)==0|(L|0)==(f|0))){K=(c[J>>2]|0)+x|0;D=ea(g[K+(z<<4)>>2]);C=ea(g[K+(z<<4)+4>>2]);G=ea(g[K+(z<<4)+8>>2]);F=ea(g[K+(z<<4)+12>>2]);B=ea(ea(1.0)/ea(T(ea(ea(ea(D*D)+ea(C*C))+ea(ea(G*G)+ea(F*F))))));E=ea(C*B);C=ea(G*B);G=ea(F*B);g[j>>2]=ea(D*B);g[I>>2]=E;g[w>>2]=C;g[H>>2]=G;FGc(L,j)}M=n;N=z+1|0;O=A}else{M=n;N=z;O=A}o=o+1|0;if((o|0)==(c[b>>2]|0))break;else{n=M;z=N;A=O}}i=h;return}}function lUd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;if((d|0)!=2){i=e;return}d=c[a+4>>2]|0;g=c[a>>2]|0;if((g|0)>0){h=0;do{if((c[d+(h<<4)+12>>2]|0)==(b|0)){j=d+(h<<4)|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}h=h+1|0}while((h|0)!=(g|0))}g=c[a+12>>2]|0;h=c[a+8>>2]|0;if((h|0)>0){d=0;do{if((c[g+(d<<4)+12>>2]|0)==(b|0)){j=g+(d<<4)|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}d=d+1|0}while((d|0)!=(h|0))}h=c[a+20>>2]|0;d=c[a+16>>2]|0;if((d|0)>0)k=0;else{i=e;return}do{if((c[h+(k<<4)+12>>2]|0)==(b|0)){a=h+(k<<4)|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2]}k=k+1|0}while((k|0)!=(d|0));i=e;return}function mUd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0;f=i;h=(c[b>>2]|0)+b|0;j=h;c[b+4>>2]=j;k=b+8|0;l=(c[k>>2]|0)+k|0;k=l;c[b+12>>2]=k;b=c[e+24>>2]|0;do if(d){m=c[a+4>>2]|0;n=c[a>>2]|0;o=e+4|0;p=c[o>>2]|0;if(!n)q=o;else{r=p+40|0;s=r;t=p+44|0;u=p+52|0;v=u;w=p+56|0;x=p+64|0;y=x;z=p+68|0;p=0;A=0;B=0;C=0;while(1){D=c[m+(p<<4)+12>>2]|0;E=c[m+(p<<4)+4>>2]|0;if((E|0)==2){if(D){F=ea(g[D+28>>2]);G=ea(g[D+32>>2]);H=ea(g[D+36>>2]);I=ea(g[D+40>>2]);J=(c[u>>2]|0)+v|0;c[w>>2]=J;g[J+(B<<4)>>2]=F;g[J+(B<<4)+4>>2]=G;g[J+(B<<4)+8>>2]=H;g[J+(B<<4)+12>>2]=I}K=A;L=B+1|0;M=C}else if((E|0)==3){if(D){I=ea(g[D+56>>2]);H=ea(g[D+60>>2]);G=ea(g[D+64>>2]);J=(c[x>>2]|0)+y|0;c[z>>2]=J;g[J+(C<<4)>>2]=I;g[J+(C<<4)+4>>2]=H;g[J+(C<<4)+8>>2]=G;g[J+(C<<4)+12>>2]=ea(1.0)}K=A;L=B;M=C+1|0}else if((E|0)==1){if(D){G=ea(g[D+44>>2]);H=ea(g[D+48>>2]);I=ea(g[D+52>>2]);D=(c[r>>2]|0)+s|0;c[t>>2]=D;g[D+(A<<4)>>2]=G;g[D+(A<<4)+4>>2]=H;g[D+(A<<4)+8>>2]=I;g[D+(A<<4)+12>>2]=ea(0.0)}K=A+1|0;L=B;M=C}else{K=A;L=B;M=C}p=p+1|0;if((p|0)==(n|0)){q=o;break}else{A=K;B=L;C=M}}}}else if((h|0)!=0&(l|0)!=0){C=e+4|0;XYd(j,k,c[e+8>>2]|0,c[C>>2]|0);q=C;break}else{q=e+4|0;break}while(0);k=c[q>>2]|0;j=a+8|0;l=c[j>>2]|0;if(!l)N=k;else{h=a+12|0;M=k+28|0;L=M;K=k+32|0;k=l;l=0;while(1){d=c[h>>2]|0;if(!(c[d+(l<<4)+4>>2]|0))O=k;else{I=ea(CUd(d+(l<<4)|0));d=(c[M>>2]|0)+L|0;c[K>>2]=d;g[d+(l<<2)>>2]=I;O=c[j>>2]|0}l=l+1|0;if(l>>>0>=O>>>0)break;else k=O}N=c[q>>2]|0}O=a+16|0;k=c[O>>2]|0;if(!k){P=N;Q=e+20|0;R=c[Q>>2]|0;S=R+24|0;T=S;U=c[S>>2]|0;V=T+U|0;W=V;X=R+28|0;c[X>>2]=W;Y=R+32|0;Z=Y;_=c[Y>>2]|0;$=_+Z|0;aa=$;ba=R+36|0;c[ba>>2]=aa;ca=c[e>>2]|0;da=b+20|0;fa=c[da>>2]|0;y_d(W,aa,ca,P,fa);i=f;return}l=a+20|0;a=N+16|0;j=a;K=N+20|0;N=k;k=0;while(1){L=c[l>>2]|0;if(!(c[L+(k<<4)+4>>2]|0))ga=N;else{M=zUd(L+(k<<4)|0)|0;L=(c[a>>2]|0)+j|0;c[K>>2]=L;c[L+(k<<2)>>2]=M;ga=c[O>>2]|0}k=k+1|0;if(k>>>0>=ga>>>0)break;else N=ga}P=c[q>>2]|0;Q=e+20|0;R=c[Q>>2]|0;S=R+24|0;T=S;U=c[S>>2]|0;V=T+U|0;W=V;X=R+28|0;c[X>>2]=W;Y=R+32|0;Z=Y;_=c[Y>>2]|0;$=_+Z|0;aa=$;ba=R+36|0;c[ba>>2]=aa;ca=c[e>>2]|0;da=b+20|0;fa=c[da>>2]|0;y_d(W,aa,ca,P,fa);i=f;return}function nUd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[173694]|0;if(!f){i=a;return}g=f+48|0;h=f+56|0;if(c[h>>2]|0){j=0;do{k=c[(c[g>>2]|0)+(j<<2)>>2]|0;c[e>>2]=c[153084];c[b+0>>2]=c[e+0>>2];eOb(k,b);j=j+1|0}while(j>>>0<(c[h>>2]|0)>>>0)}j=f+60|0;if((c[j>>2]|0)>-1){e=c[g>>2]|0;c[d>>2]=c[f+52>>2];c[b+0>>2]=c[d+0>>2];eOb(e,b);c[g>>2]=0}c[h>>2]=0;c[j>>2]=0;i=a;return}function oUd(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;EUd();c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];d=bOb(68,b,1,16,3653512,401)|0;rUd(d);c[173694]=d;d=kbc()|0;b=0;while(1){e=d+(b<<2)+64|0;b=b+1|0;if(!(c[e>>2]|0)){f=e;break}if((b|0)>=16){g=5;break}}if((g|0)==5){i=a;return}c[f>>2]=206;i=a;return}function pUd(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[173694]|0;f=c[153084]|0;if(e)sUd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[173694]=0;nDd((kbc()|0)+64|0,206);i=a;return}function qUd(){return c[173694]|0}function rUd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+4>>2]=60;f=a+16|0;c[f>>2]=0;g=a+24|0;c[g>>2]=0;h=a+28|0;c[h>>2]=0;j=a+20|0;c[j>>2]=60;k=a+32|0;c[k>>2]=0;l=a+40|0;c[l>>2]=0;m=a+44|0;c[m>>2]=0;c[a+36>>2]=60;c[a+48>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;c[a+52>>2]=60;n=-1;o=0;p=0;while(1){if(!(n&1))q=p;else q=1<<31-o|p;o=o+1|0;if((o|0)==32){r=q;break}else{n=n>>>1;p=q}}q=c[572464+((r&255^109)<<2)>>2]^r>>>8;r=c[572464+((q&255^95)<<2)>>2]^q>>>8;q=c[572464+((r&255^73)<<2)>>2]^r>>>8;r=c[572464+((q&255^115)<<2)>>2]^q>>>8;q=c[572464+((r&255^65)<<2)>>2]^r>>>8;r=c[572464+((q&255^99)<<2)>>2]^q>>>8;q=c[572464+((r&255^116)<<2)>>2]^r>>>8;r=c[572464+((q&255^105)<<2)>>2]^q>>>8;q=c[572464+((r&255^118)<<2)>>2]^r>>>8;c[a+64>>2]=~(c[572464+((q&255^101)<<2)>>2]^q>>>8);c[m>>2]=301;c[e>>2]=60;c[d+0>>2]=c[e+0>>2];m=hOb(0,1204,4,d,0,3653512,370)|0;c[k>>2]=m;k=c[l>>2]|0;if(k>>>0<301){q=m+1204|0;a=m+(k<<2)|0;do{if(a)c[a>>2]=0;a=a+4|0}while((a|0)!=(q|0))}c[l>>2]=301;l=c[h>>2]|0;do if((l&2147483647)>>>0<25)if((l|0)>-1){c[h>>2]=25;q=c[f>>2]|0;c[e>>2]=c[j>>2];c[d+0>>2]=c[e+0>>2];c[f>>2]=hOb(q,100,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[j>>2];c[d+0>>2]=c[e+0>>2];q=cOb(100,4,d,0,3653512,352)|0;YEi(q|0,c[f>>2]|0,c[g>>2]<<2|0)|0;c[h>>2]=25;c[f>>2]=q;break}while(0);h=c[g>>2]|0;if(h>>>0>=25){c[g>>2]=25;i=b;return}d=c[f>>2]|0;f=d+100|0;e=d+(h<<2)|0;do{if(e)c[e>>2]=0;e=e+4|0}while((e|0)!=(f|0));c[g>>2]=25;i=b;return}function sUd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+32|0;h=a+40|0;if(c[h>>2]|0){j=0;do{k=c[(c[g>>2]|0)+(j<<2)>>2]|0;c[f>>2]=c[153084];c[d+0>>2]=c[f+0>>2];eOb(k,d);j=j+1|0}while(j>>>0<(c[h>>2]|0)>>>0)}j=a+44|0;if((c[j>>2]|0)>-1){k=c[g>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[g>>2]=0}c[h>>2]=0;c[j>>2]=0;h=a+48|0;k=a+56|0;if(c[k>>2]|0){l=0;do{m=c[(c[h>>2]|0)+(l<<2)>>2]|0;c[f>>2]=c[153084];c[d+0>>2]=c[f+0>>2];eOb(m,d);l=l+1|0}while(l>>>0<(c[k>>2]|0)>>>0)}l=a+60|0;if((c[l>>2]|0)>-1){f=c[h>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[h>>2]=0}c[k>>2]=0;c[l>>2]=0;l=c[h>>2]|0;c[e>>2]=c[a+52>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[h>>2]=0;if((c[j>>2]|0)>-1){j=c[g>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[g>>2]=0}if((c[a+28>>2]|0)>-1){g=a+16|0;j=c[g>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[g>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}g=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[a>>2]=0;i=b;return}function tUd(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;i=i+16|0;j=h+8|0;k=h+4|0;l=h;m=c[d+8>>2]|0;do if(m){c[k>>2]=m;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(j,n,k);o=c[j>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[q+4>>2]|0,(n|0)!=0):0)r=n;else s=10}else s=10;if((s|0)==10){n=hQb(m)|0;if(!n){s=12;break}else r=n}n=(da(c[137788]|0,(c[r+8>>2]|0)>>>21)|0)+115|0;o=n>>5;if(1<<n-(o<<5)&c[(c[137786]|0)+(o<<2)>>2])t=r;else s=12}else s=12;while(0);if((s|0)==12)t=0;r=jQc(c[f+24>>2]|0,114,t)|0;if((r|0)!=0?(t=c[r+20>>2]|0,(t|0)!=0):0){f=m9c(r)|0;m=b+48|0;q=b+56|0;k=c[q>>2]|0;a:do if(k){o=c[m>>2]|0;n=0;while(1){p=c[o+(n<<2)>>2]|0;n=n+1|0;if((c[p>>2]|0)==(f|0)){u=p;break}if(n>>>0>=k>>>0){s=22;break a}}if(u){v=r;w=u}else s=22}else s=22;while(0);if((s|0)==22){s=FUd(e[d+12>>1]|0,t,f,r)|0;f=(c[q>>2]|0)+1|0;c[q>>2]=f;u=b+60|0;k=c[u>>2]|0;n=k&2147483647;if(f>>>0>n>>>0){o=k<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((k|0)>-1){c[u>>2]=p;o=c[m>>2]|0;c[l>>2]=c[b+52>>2];c[j+0>>2]=c[l+0>>2];c[m>>2]=hOb(o,p<<2,4,j,0,3653512,370)|0;break}else{c[l>>2]=c[b+52>>2];c[j+0>>2]=c[l+0>>2];o=cOb(p<<2,4,j,0,3653512,352)|0;YEi(o|0,c[m>>2]|0,c[q>>2]<<2|0)|0;c[u>>2]=p;c[m>>2]=o;break}while(0);x=c[q>>2]|0}else x=f;c[(c[m>>2]|0)+(x+-1<<2)>>2]=s;v=r;w=s}s=c[w+8>>2]|0;r=c[w+12>>2]|0;w=c[d+4>>2]|0;x=a[d+15>>0]|0;d=r;m=s<<4>>4;b:while(1){f=m;while(1){if(!f){y=d;break b}q=(f|0)/2|0;if((c[d+(q<<4)>>2]|0)>>>0<w>>>0){z=q;A=f;break}else f=q}d=d+(z+1<<4)|0;m=A+-1-z|0}if((y|0)!=(r+(s<<4)|0)?!((y|0)==0?1:(c[y>>2]|0)>>>0>w>>>0):0){w=g+12|0;c[w>>2]=v;c[g>>2]=t+(c[y+4>>2]|0);t=c[y+8>>2]|0;v=g+4|0;c[v>>2]=t;do if(x<<24>>24){if((t|0)==9){B=c[y+12>>2]|0;i=h;return B|0}}else{if((t|0)==6){B=100001;i=h;return B|0}else if((t|0)!=5)break;B=100002;i=h;return B|0}while(0);c[w>>2]=0;c[g>>2]=0;c[v>>2]=0;B=-1;i=h;return B|0}c[g+4>>2]=0;B=-1;i=h;return B|0}c[g+4>>2]=0;B=-1;i=h;return B|0}function uUd(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;j=d+12|0;k=CTb(c[f+24>>2]|0,e[j>>1]|0)|0;if(!k){l=-1;i=h;return l|0}f=e[j>>1]|0;m=b+32|0;b=c[(c[m>>2]|0)+(f<<2)>>2]|0;if(!b){n=FUd(f,0,0,k)|0;f=e[j>>1]|0;c[(c[m>>2]|0)+(f<<2)>>2]=n;o=c[(c[m>>2]|0)+(f<<2)>>2]|0}else o=b;b=c[o+8>>2]|0;f=c[o+12>>2]|0;o=c[d+4>>2]|0;m=a[d+15>>0]|0;d=f;n=b<<4>>4;a:while(1){j=n;while(1){if(!j){p=d;break a}q=(j|0)/2|0;if((c[d+(q<<4)>>2]|0)>>>0<o>>>0){r=q;s=j;break}else j=q}d=d+(r+1<<4)|0;n=s+-1-r|0}if((p|0)!=(f+(b<<4)|0)?!((p|0)==0?1:(c[p>>2]|0)>>>0>o>>>0):0){o=g+12|0;c[o>>2]=k;c[g>>2]=k+(c[p+4>>2]|0);k=c[p+8>>2]|0;b=g+4|0;c[b>>2]=k;do if(m<<24>>24){if((k|0)==9){l=c[p+12>>2]|0;i=h;return l|0}}else{if((k|0)==6){l=100001;i=h;return l|0}else if((k|0)!=5)break;l=100002;i=h;return l|0}while(0);c[o>>2]=0;c[g>>2]=0;c[b>>2]=0;l=-1;i=h;return l|0}c[g+4>>2]=0;l=-1;i=h;return l|0}function vUd(c,d,e,f){c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if(a[d+14>>0]|0){h=wUd(c,d,e,f)|0;i=g;return h|0}if((b[d+12>>1]|0)!=114){h=-1;i=g;return h|0}h=tUd(c,d,e,f)|0;i=g;return h|0}function wUd(a,e,f,g){a=a|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=h+24|0;k=h+16|0;l=h;m=b[e+12>>1]|0;if(m<<16>>16==114){n=c[e+8>>2]|0;do if(n){c[k>>2]=n;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(j,o,k);p=c[j>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[r+4>>2]|0,(o|0)!=0):0)s=o;else t=11}else t=11;if((t|0)==11){o=hQb(n)|0;if(!o){t=13;break}else s=o}o=(da(c[137788]|0,(c[s+8>>2]|0)>>>21)|0)+115|0;p=o>>5;if(1<<o-(p<<5)&c[(c[137786]|0)+(p<<2)>>2])u=s;else t=13}else t=13;while(0);if((t|0)==13)u=0;v=jQc(c[f+24>>2]|0,114,u)|0}else v=CTb(c[f+24>>2]|0,m&65535)|0;m=d[e+14>>0]|0;f=c[(c[a+16>>2]|0)+(m<<2)>>2]|0;if(!((f|0)!=0&(v|0)!=0)){w=-1;i=h;return w|0};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+4>>2]=m;c[l+8>>2]=f;c[l+12>>2]=v;m=kn[c[(c[f>>2]|0)+20>>2]&511](f,v,e,l)|0;if((m|0)==-1){w=-1;i=h;return w|0};c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];w=m;i=h;return w|0}function xUd(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;if(a[e+14>>0]|0){j=wUd(d,e,f,g)|0;i=h;return j|0}k=b[e+12>>1]|0;if(k<<16>>16==114){j=tUd(d,e,f,g)|0;i=h;return j|0}else if(k<<16>>16==95){j=100002;i=h;return j|0}else if(k<<16>>16==1){if((c[e+4>>2]|0)!=(c[d+64>>2]|0)){j=-1;i=h;return j|0}if(!(c[e>>2]|0)){j=-1;i=h;return j|0}c[g>>2]=0;c[g+4>>2]=7;c[g+12>>2]=c[f+24>>2];j=100001;i=h;return j|0}else{j=uUd(d,e,f,g)|0;i=h;return j|0}return 0}function yUd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f+4|0;h=f;j=a+8|0;k=(c[j>>2]|0)+1|0;c[j>>2]=k;l=a+12|0;m=c[l>>2]|0;n=m&2147483647;if(k>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[l>>2]=p;o=c[a>>2]|0;c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];c[a>>2]=hOb(o,p<<3,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[a+4>>2];c[g+0>>2]=c[h+0>>2];o=cOb(p<<3,4,g,0,3653512,352)|0;YEi(o|0,c[a>>2]|0,c[j>>2]<<3|0)|0;c[l>>2]=p;c[a>>2]=o;break}while(0);q=c[j>>2]|0}else q=k;k=(c[a>>2]|0)+(q+-1<<3)|0;c[k>>2]=b;c[k+4>>2]=d;c[(c[a+16>>2]|0)+(d<<2)>>2]=e;i=f;return}function zUd(a){a=a|0;var b=0,d=0,e=0;b=i;if((c[a+4>>2]|0)==9){d=Grc(c[c[a>>2]>>2]|0)|0;i=b;return d|0}else{e=c[a+8>>2]|0;d=_n[c[(c[e>>2]|0)+12>>2]&4095](e,a)|0;i=b;return d|0}return 0}function AUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d;if((c[a+4>>2]|0)!=9){g=c[a+8>>2]|0;co[c[(c[g>>2]|0)+8>>2]&2047](g,a,b);h=0;i=d;return h|0}do if(!b)j=0;else{c[f>>2]=b;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(e,g,f);k=c[e>>2]|0;l=c[g+28>>2]|0;if((k|0)==-1){m=l+(c[g+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((m|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[m+4>>2]|0,(g|0)!=0):0){j=g;break}}j=hQb(b)|0}while(0);b=Ecd(j)|0;j=c[a>>2]|0;a=(c[j>>2]|0)!=(b|0);c[j>>2]=b;h=a;i=d;return h|0}function BUd(b,e){b=b|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0;f=i;h=c[b+4>>2]|0;if((h|0)==7){if(e>ea(.00100000005))j=1;else j=e<ea(-.00100000005);HTb(c[b+12>>2]|0,j);k=0;i=f;return k|0}else if((h|0)==6){j=c[b>>2]|0;if(e>ea(.00100000005))l=1;else l=e<ea(-.00100000005);m=(d[j>>0]|0|0)!=(l&1|0);a[j>>0]=l&1;k=m;i=f;return k|0}else if((h|0)==5){h=c[b>>2]|0;m=ea(g[h>>2])!=e;g[h>>2]=e;k=m;i=f;return k|0}else{m=c[b+8>>2]|0;go[c[(c[m>>2]|0)+4>>2]&63](m,b,e);k=0;i=f;return k|0}return 0}function CUd(b){b=b|0;var d=0,e=0,f=Im;d=i;e=c[b+4>>2]|0;if((e|0)==6)f=(a[c[b>>2]>>0]|0)!=0?ea(1.0):ea(0.0);else if((e|0)==7)f=(a[(c[b+12>>2]|0)+46>>0]|0)!=0?ea(1.0):ea(0.0);else if((e|0)==5)f=ea(g[c[b>>2]>>2]);else{e=c[b+8>>2]|0;f=ea(Um[c[c[e>>2]>>2]&63](e,b))}i=d;return ea(f)}function DUd(a){a=a|0;var b=0;b=i;In[c[(c[a>>2]|0)+12>>2]&4095](a,16);i=b;return}function EUd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;b=0;do{d=b<<24>>24<0?159529838:0;e=((b&64)!=0?d^79764919:d)<<1;d=(b&32)!=0?e^79764919:e;e=(b&16)==0?d:d^-2147483648;d=e<<1;f=(e|0)<0?d^79764919:d;d=(b&8)==0?f:f^-2147483648;f=d<<1;e=(d|0)<0?f^79764919:f;f=(b&4)==0?e:e^-2147483648;e=f<<1;d=(f|0)<0?e^79764919:e;e=(b&2)==0?d:d^-2147483648;d=e<<1;f=(e|0)<0?d^79764919:d;d=(b&1)==0?f:f^-2147483648;f=d<<1;e=(d|0)<0?f^79764919:f;f=0;d=0;while(1){if(!(e&1))g=d;else g=1<<31-f|d;f=f+1|0;if((f|0)==32){h=g;break}else{e=e>>>1;d=g}}c[572464+(((GUd(b)|0)&255)<<2)>>2]=h;b=b+1<<24>>24}while(b<<24>>24!=0);i=a;return}function FUd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+112|0;g=f+16|0;h=f+24|0;j=f+40|0;k=f+88|0;l=f+8|0;m=f+32|0;n=f;o=f+20|0;hid(j);Vhd(e,j,0);e=c[153134]|0;c[k>>2]=0;p=k+4|0;c[p>>2]=e;e=k+8|0;c[e>>2]=0;q=k+12|0;c[q>>2]=0;c[m>>2]=j;c[m+4>>2]=0;cid(l,m);if(!(c[l>>2]|0)){r=0;s=0}else{m=-1;t=0;u=0;while(1){if(!(m&1))v=u;else v=1<<31-t|u;w=t+1|0;if((w|0)!=32){m=m>>>1;t=w;u=v;continue}HUd(l,b,v,k);did(n,l);w=n;x=c[w>>2]|0;y=c[w+4>>2]|0;w=l;c[w>>2]=x;c[w+4>>2]=y;if(!x)break;else{m=-1;t=0;u=0}}r=c[k>>2]|0;s=c[e>>2]|0}IUd(r,r+(s<<4)|0,g);e=s<<4;u=e+16|0;c[o>>2]=c[153084];c[g+0>>2]=c[o+0>>2];o=cOb(u,16,g,0,3653512,379)|0;t=o;m=(0-t&3)+t|0;t=m+16|0;l=o+u|0;u=t>>>0>l>>>0;n=u?0:m;c[n+4>>2]=a;c[n>>2]=d;c[n+8>>2]=s;if(!s)z=0;else{s=u?o:t;t=(0-s&3)+s|0;s=(t+e|0)>>>0>l>>>0?0:t;YEi(s|0,r|0,e|0)|0;z=s}c[n+12>>2]=z;if((c[q>>2]|0)<=-1){ogd(j);i=f;return n|0}c[h>>2]=c[p>>2];c[g+0>>2]=c[h+0>>2];eOb(r,g);c[k>>2]=0;ogd(j);i=f;return n|0}function GUd(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;c=a<<7&255;if(!(a&2))d=c;else d=(c&255|64)&255;if(!(a&4))e=d;else e=(d&255|32)&255;if(!(a&8))f=e;else f=(e&255|16)&255;if(!(a&16))g=f;else g=(f&255|8)&255;if(!(a&32))h=g;else h=(g&255|4)&255;if(!(a&64))j=h;else j=(h&255|2)&255;if(a<<24>>24>-1){k=j;i=b;return k|0}k=(j&255|1)&255;i=b;return k|0}function HUd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+48|0;h=g+32|0;j=g+24|0;k=g+16|0;l=g+8|0;m=g;if((e|0)==-1)n=-1;else n=c[572464+((e&255^46)<<2)>>2]^e>>>8;e=aid(a)|0;o=SEi(aid(a)|0)|0;p=e+o|0;if((o|0)>0){o=n;q=e;while(1){e=c[572464+(((d[q>>0]|0)^o&255)<<2)>>2]^o>>>8;q=q+1|0;if((q|0)==(p|0)){r=e;break}else o=e}}else r=n;n=gid(a)|0;o=(b|0)!=0;a:do if((n>>>31|0)==(o&1|0)){do if(o){p=JUd(a)|0;if((p+-5|0)>>>0<2)if((n|0)==-1)break a;else{s=n&2147483647;t=p;u=-1;break}eid(h,a);if(!(c[h>>2]|0))break a;eid(j,a);eid(k,j);if(c[k>>2]|0)break a;p=vsc(b)|0;q=Tsc(p,aid(a)|0)|0;if(!q)break a;p=Osc(q)|0;if((Psc(p)|0)!=18)break a;e=Qcd($sc(p)|0)|0;if((e|0)==114|(e|0)==0|(e|0)==-1)break a;p=Nsc(q)|0;if((p|0)==-1)break a;else{s=p;t=9;u=e}}else{if((n|0)==-1)break a;e=JUd(a)|0;if(!e)break a;else{s=n&2147483647;t=e;u=-1}}while(0);e=f+8|0;p=(c[e>>2]|0)+1|0;c[e>>2]=p;q=f+12|0;v=c[q>>2]|0;w=v&2147483647;if(p>>>0>w>>>0){x=v<<1;y=(x|0)==0?1:x;do if(w>>>0<y>>>0)if((v|0)>-1){c[q>>2]=y;x=c[f>>2]|0;c[j>>2]=c[f+4>>2];c[h+0>>2]=c[j+0>>2];c[f>>2]=hOb(x,y<<4,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[f+4>>2];c[h+0>>2]=c[j+0>>2];x=cOb(y<<4,4,h,0,3653512,352)|0;YEi(x|0,c[f>>2]|0,c[e>>2]<<4|0)|0;c[q>>2]=y;c[f>>2]=x;break}while(0);z=c[e>>2]|0}else z=p;y=z+-1|0;q=c[f>>2]|0;c[q+(y<<4)>>2]=~r;c[q+(y<<4)+4>>2]=s;c[q+(y<<4)+8>>2]=t;c[q+(y<<4)+12>>2]=u}while(0);cid(l,a);if(!(c[l>>2]|0)){i=g;return}do{HUd(l,b,r,f);did(m,l);a=m;u=c[a>>2]|0;t=c[a+4>>2]|0;a=l;c[a>>2]=u;c[a+4>>2]=t}while((u|0)!=0);i=g;return}function IUd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=i;i=i+32|0;f=e+16|0;g=e;h=a;a=b;a:while(1){b=a;j=a+-16|0;k=h;b:while(1){l=k;m=b-l|0;n=m>>4;switch(n|0){case 2:{o=k;p=j;q=j;r=4;break a;break}case 3:{s=k;t=j;u=j;r=6;break a;break}case 4:{v=k;w=j;r=14;break a;break}case 5:{x=k;y=j;z=j;r=15;break a;break}case 1:case 0:{r=84;break a;break}default:{}}if((m|0)<496){A=k;B=a;r=21;break a}C=(n|0)/2|0;D=k+(C<<4)|0;do if((m|0)>15984){E=(n|0)/4|0;F=k+(E<<4)|0;G=k+(E+C<<4)|0;E=KUd(k,F,D,G,d)|0;if((c[j>>2]|0)>>>0>=(c[G>>2]|0)>>>0){H=D;I=E;break};c[f+0>>2]=c[G+0>>2];c[f+4>>2]=c[G+4>>2];c[f+8>>2]=c[G+8>>2];c[f+12>>2]=c[G+12>>2];c[G+0>>2]=c[j+0>>2];c[G+4>>2]=c[j+4>>2];c[G+8>>2]=c[j+8>>2];c[G+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];J=E+1|0;if((c[G>>2]|0)>>>0<(c[D>>2]|0)>>>0){c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];c[D+12>>2]=c[G+12>>2];c[G+0>>2]=c[f+0>>2];c[G+4>>2]=c[f+4>>2];c[G+8>>2]=c[f+8>>2];c[G+12>>2]=c[f+12>>2];G=E+2|0;if((c[D>>2]|0)>>>0<(c[F>>2]|0)>>>0){c[f+0>>2]=c[F+0>>2];c[f+4>>2]=c[F+4>>2];c[f+8>>2]=c[F+8>>2];c[f+12>>2]=c[F+12>>2];c[F+0>>2]=c[D+0>>2];c[F+4>>2]=c[D+4>>2];c[F+8>>2]=c[D+8>>2];c[F+12>>2]=c[D+12>>2];c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];if((c[F>>2]|0)>>>0<(c[k>>2]|0)>>>0){c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[F+0>>2];c[k+4>>2]=c[F+4>>2];c[k+8>>2]=c[F+8>>2];c[k+12>>2]=c[F+12>>2];c[F+0>>2]=c[f+0>>2];c[F+4>>2]=c[f+4>>2];c[F+8>>2]=c[f+8>>2];c[F+12>>2]=c[f+12>>2];H=D;I=E+4|0}else{H=D;I=E+3|0}}else{H=D;I=G}}else{H=D;I=J}}else{J=c[D>>2]|0;G=(c[j>>2]|0)>>>0<J>>>0;if(J>>>0>=(c[k>>2]|0)>>>0){if(!G){H=D;I=0;break};c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];c[D+0>>2]=c[j+0>>2];c[D+4>>2]=c[j+4>>2];c[D+8>>2]=c[j+8>>2];c[D+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];if((c[D>>2]|0)>>>0>=(c[k>>2]|0)>>>0){H=D;I=1;break};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];H=D;I=2;break}if(G){c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];H=D;I=1;break};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[D+0>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];c[D+0>>2]=c[f+0>>2];c[D+4>>2]=c[f+4>>2];c[D+8>>2]=c[f+8>>2];c[D+12>>2]=c[f+12>>2];if((c[j>>2]|0)>>>0<(c[D>>2]|0)>>>0){c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];c[D+0>>2]=c[j+0>>2];c[D+4>>2]=c[j+4>>2];c[D+8>>2]=c[j+8>>2];c[D+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];H=D;I=2}else{H=D;I=1}}while(0);C=c[k>>2]|0;n=c[H>>2]|0;do if(C>>>0<n>>>0){K=j;L=I}else{m=a;G=j;while(1){J=m+-32|0;if((k|0)==(J|0))break;if((c[J>>2]|0)>>>0<n>>>0){M=J;r=66;break}else{E=G;G=J;m=E}}if((r|0)==66){r=0;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[M+0>>2];c[k+4>>2]=c[M+4>>2];c[k+8>>2]=c[M+8>>2];c[k+12>>2]=c[M+12>>2];c[M+0>>2]=c[f+0>>2];c[M+4>>2]=c[f+4>>2];c[M+8>>2]=c[f+8>>2];c[M+12>>2]=c[f+12>>2];K=M;L=I+1|0;break}m=k+16|0;if(C>>>0<(c[j>>2]|0)>>>0)N=m;else{if((m|0)==(j|0)){r=84;break a}else{O=k;P=m}while(1){m=O+32|0;if(C>>>0<(c[P>>2]|0)>>>0){Q=P;break}if((m|0)==(j|0)){r=84;break a}else{G=P;P=m;O=G}}c[f+0>>2]=c[Q+0>>2];c[f+4>>2]=c[Q+4>>2];c[f+8>>2]=c[Q+8>>2];c[f+12>>2]=c[Q+12>>2];c[Q+0>>2]=c[j+0>>2];c[Q+4>>2]=c[j+4>>2];c[Q+8>>2]=c[j+8>>2];c[Q+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];N=Q+16|0}if((N|0)==(j|0)){r=84;break a}else{R=N;S=j}while(1){G=c[k>>2]|0;m=R;while(1){E=m+16|0;if(G>>>0<(c[m>>2]|0)>>>0){T=E;U=m;break}else m=E}m=S;while(1){E=m+-16|0;if(G>>>0<(c[E>>2]|0)>>>0)m=E;else{V=E;break}}if(U>>>0>=V>>>0){k=U;continue b};c[f+0>>2]=c[U+0>>2];c[f+4>>2]=c[U+4>>2];c[f+8>>2]=c[U+8>>2];c[f+12>>2]=c[U+12>>2];c[U+0>>2]=c[V+0>>2];c[U+4>>2]=c[V+4>>2];c[U+8>>2]=c[V+8>>2];c[U+12>>2]=c[V+12>>2];c[V+0>>2]=c[f+0>>2];c[V+4>>2]=c[f+4>>2];c[V+8>>2]=c[f+8>>2];c[V+12>>2]=c[f+12>>2];R=T;S=V}}while(0);C=k+16|0;c:do if(C>>>0<K>>>0){n=C;m=K;G=D;E=L;while(1){J=c[G>>2]|0;F=n;while(1){W=F+16|0;if((c[F>>2]|0)>>>0<J>>>0)F=W;else{X=W;Y=F;break}}F=m;while(1){W=F+-16|0;if((c[W>>2]|0)>>>0<J>>>0){Z=W;break}else F=W}if(Y>>>0>Z>>>0){_=Y;$=G;aa=E;break c};c[f+0>>2]=c[Y+0>>2];c[f+4>>2]=c[Y+4>>2];c[f+8>>2]=c[Y+8>>2];c[f+12>>2]=c[Y+12>>2];c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];c[Z+0>>2]=c[f+0>>2];c[Z+4>>2]=c[f+4>>2];c[Z+8>>2]=c[f+8>>2];c[Z+12>>2]=c[f+12>>2];n=X;m=Z;G=(G|0)==(Y|0)?Z:G;E=E+1|0}}else{_=C;$=D;aa=L}while(0);if((_|0)!=($|0)?(c[$>>2]|0)>>>0<(c[_>>2]|0)>>>0:0){c[f+0>>2]=c[_+0>>2];c[f+4>>2]=c[_+4>>2];c[f+8>>2]=c[_+8>>2];c[f+12>>2]=c[_+12>>2];c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];c[$+0>>2]=c[f+0>>2];c[$+4>>2]=c[f+4>>2];c[$+8>>2]=c[f+8>>2];c[$+12>>2]=c[f+12>>2];ba=aa+1|0}else ba=aa;if(!ba){ca=LUd(k,_,d)|0;D=_+16|0;if(LUd(D,a,d)|0){r=79;break}if(ca){k=D;continue}}D=_;if((D-l|0)>=(b-D|0)){da=k;ea=_;r=83;break}IUd(k,_,d);k=_+16|0}if((r|0)==79){r=0;if(ca){r=84;break}else{h=k;a=_;continue}}else if((r|0)==83){r=0;IUd(ea+16|0,a,d);h=da;a=ea;continue}}if((r|0)==4){if((c[p>>2]|0)>>>0>=(c[o>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];i=e;return}else if((r|0)==6){q=s+16|0;o=c[q>>2]|0;p=(c[t>>2]|0)>>>0<o>>>0;if(o>>>0>=(c[s>>2]|0)>>>0){if(!p){i=e;return};c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];c[q+0>>2]=c[u+0>>2];c[q+4>>2]=c[u+4>>2];c[q+8>>2]=c[u+8>>2];c[q+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];if((c[q>>2]|0)>>>0>=(c[s>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];c[s+12>>2]=c[q+12>>2];c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];i=e;return}if(p){c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];i=e;return};c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];c[s+12>>2]=c[q+12>>2];c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];if((c[t>>2]|0)>>>0>=(c[q>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];c[q+0>>2]=c[u+0>>2];c[q+4>>2]=c[u+4>>2];c[q+8>>2]=c[u+8>>2];c[q+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];i=e;return}else if((r|0)==14){KUd(v,v+16|0,v+32|0,w,d)|0;i=e;return}else if((r|0)==15){w=x+16|0;v=x+32|0;u=x+48|0;KUd(x,w,v,u,d)|0;if((c[y>>2]|0)>>>0>=(c[u>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[f+12>>2]=c[u+12>>2];c[u+0>>2]=c[z+0>>2];c[u+4>>2]=c[z+4>>2];c[u+8>>2]=c[z+8>>2];c[u+12>>2]=c[z+12>>2];c[z+0>>2]=c[f+0>>2];c[z+4>>2]=c[f+4>>2];c[z+8>>2]=c[f+8>>2];c[z+12>>2]=c[f+12>>2];if((c[u>>2]|0)>>>0>=(c[v>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];if((c[v>>2]|0)>>>0>=(c[w>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[w+0>>2]=c[v+0>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[v+0>>2]=c[f+0>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];if((c[w>>2]|0)>>>0>=(c[x>>2]|0)>>>0){i=e;return};c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[x+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];i=e;return}else if((r|0)==21){w=A+32|0;x=A+16|0;v=c[x>>2]|0;u=c[A>>2]|0;z=c[w>>2]|0;y=z>>>0<v>>>0;do if(v>>>0<u>>>0){if(y){c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];c[A+0>>2]=c[w+0>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];c[A+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2];c[x+0>>2]=c[f+0>>2];c[x+4>>2]=c[f+4>>2];c[x+8>>2]=c[f+8>>2];c[x+12>>2]=c[f+12>>2];if(z>>>0<(c[x>>2]|0)>>>0){c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[x+12>>2]=c[w+12>>2];c[w+0>>2]=c[f+0>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2]}}else if(y?(c[f+0>>2]=c[x+0>>2],c[f+4>>2]=c[x+4>>2],c[f+8>>2]=c[x+8>>2],c[f+12>>2]=c[x+12>>2],c[x+0>>2]=c[w+0>>2],c[x+4>>2]=c[w+4>>2],c[x+8>>2]=c[w+8>>2],c[x+12>>2]=c[w+12>>2],c[w+0>>2]=c[f+0>>2],c[w+4>>2]=c[f+4>>2],c[w+8>>2]=c[f+8>>2],c[w+12>>2]=c[f+12>>2],(c[x>>2]|0)>>>0<u>>>0):0){c[f+0>>2]=c[A+0>>2];c[f+4>>2]=c[A+4>>2];c[f+8>>2]=c[A+8>>2];c[f+12>>2]=c[A+12>>2];c[A+0>>2]=c[x+0>>2];c[A+4>>2]=c[x+4>>2];c[A+8>>2]=c[x+8>>2];c[A+12>>2]=c[x+12>>2];c[x+0>>2]=c[f+0>>2];c[x+4>>2]=c[f+4>>2];c[x+8>>2]=c[f+8>>2];c[x+12>>2]=c[f+12>>2]}while(0);f=A+48|0;if((f|0)==(B|0)){i=e;return}else{fa=f;ga=w}while(1){w=c[fa>>2]|0;if(w>>>0<(c[ga>>2]|0)>>>0){f=fa+4|0;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];f=fa;x=ga;while(1){c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];if((x|0)==(A|0)){ha=A;break}u=x+-16|0;if(w>>>0<(c[u>>2]|0)>>>0){y=x;x=u;f=y}else{ha=x;break}}c[ha>>2]=w;x=ha+4|0;c[x+0>>2]=c[g+0>>2];c[x+4>>2]=c[g+4>>2];c[x+8>>2]=c[g+8>>2]}x=fa+16|0;if((x|0)==(B|0))break;else{f=fa;fa=x;ga=f}}i=e;return}else if((r|0)==84){i=e;return}}function JUd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if(c[($hd(a)|0)+20>>2]&8388608){d=0;i=b;return d|0}e=bid(a)|0;f=c[142268]|0;do if(f)if(e){g=c[142254]|0;h=c[142256]|0;if(g>>>0<=e>>>0&h>>>0>e>>>0?g>>>0<=f>>>0&h>>>0>f>>>0:0){if((e|0)==(f|0))d=5;else break;i=b;return d|0}if(!(HEi(f,e)|0)){d=5;i=b;return d|0}}else{j=0;k=4}else{j=e;k=4}while(0);if((k|0)==4?(j|0)==(f|0):0){d=5;i=b;return d|0}f=bid(a)|0;j=c[142258]|0;do if(j)if(f){e=c[142254]|0;h=c[142256]|0;if(e>>>0<=f>>>0&h>>>0>f>>>0?e>>>0<=j>>>0&h>>>0>j>>>0:0){if((f|0)==(j|0))d=6;else break;i=b;return d|0}if(!(HEi(j,f)|0)){d=6;i=b;return d|0}}else{l=0;k=11}else{l=f;k=11}while(0);if((k|0)==11?(l|0)==(j|0):0){d=6;i=b;return d|0}j=bid(a)|0;l=c[142302]|0;do if(l)if(j){f=c[142254]|0;h=c[142256]|0;if(f>>>0<=j>>>0&h>>>0>j>>>0?f>>>0<=l>>>0&h>>>0>l>>>0:0)if((j|0)==(l|0)){k=23;break}else break;if(!(HEi(l,j)|0))k=23}else{m=0;k=18}else{m=j;k=18}while(0);if((k|0)==18?(m|0)==(l|0):0)k=23;if((k|0)==23?(c[($hd(a)|0)+20>>2]&256|0)!=0:0){d=6;i=b;return d|0}d=0;i=b;return d|0}function KUd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=c[b>>2]|0;j=(c[d>>2]|0)>>>0<h>>>0;do if(h>>>0<(c[a>>2]|0)>>>0){if(j){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];k=1;break};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];if((c[d>>2]|0)>>>0<(c[b>>2]|0)>>>0){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];k=2}else k=1}else if(j){c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];if((c[b>>2]|0)>>>0<(c[a>>2]|0)>>>0){c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];k=2}else k=1}else k=0;while(0);if((c[e>>2]|0)>>>0>=(c[d>>2]|0)>>>0){l=k;i=f;return l|0};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if((c[d>>2]|0)>>>0>=(c[b>>2]|0)>>>0){l=k+1|0;i=f;return l|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];if((c[b>>2]|0)>>>0>=(c[a>>2]|0)>>>0){l=k+2|0;i=f;return l|0};c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];l=k+3|0;i=f;return l|0}function LUd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+16|0;g=e;switch(b-a>>4|0){case 4:{KUd(a,a+16|0,a+32|0,b+-16|0,d)|0;h=1;i=e;return h|0}case 5:{j=a+16|0;k=a+32|0;l=a+48|0;m=b+-16|0;KUd(a,j,k,l,d)|0;if((c[m>>2]|0)>>>0>=(c[l>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];if((c[l>>2]|0)>>>0>=(c[k>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];if((c[k>>2]|0)>>>0>=(c[j>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];if((c[j>>2]|0)>>>0>=(c[a>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];h=1;i=e;return h|0}case 2:{j=b+-16|0;if((c[j>>2]|0)>>>0>=(c[a>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];h=1;i=e;return h|0}case 3:{j=a+16|0;k=b+-16|0;l=c[j>>2]|0;m=(c[k>>2]|0)>>>0<l>>>0;if(l>>>0>=(c[a>>2]|0)>>>0){if(!m){h=1;i=e;return h|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];if((c[j>>2]|0)>>>0>=(c[a>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];h=1;i=e;return h|0}if(m){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];h=1;i=e;return h|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];if((c[k>>2]|0)>>>0>=(c[j>>2]|0)>>>0){h=1;i=e;return h|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];h=1;i=e;return h|0}case 1:case 0:{h=1;i=e;return h|0}default:{k=a+32|0;j=a+16|0;m=c[j>>2]|0;l=c[a>>2]|0;d=c[k>>2]|0;n=d>>>0<m>>>0;do if(m>>>0<l>>>0){if(n){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];if(d>>>0<(c[j>>2]|0)>>>0){c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2]}}else if(n?(c[f+0>>2]=c[j+0>>2],c[f+4>>2]=c[j+4>>2],c[f+8>>2]=c[j+8>>2],c[f+12>>2]=c[j+12>>2],c[j+0>>2]=c[k+0>>2],c[j+4>>2]=c[k+4>>2],c[j+8>>2]=c[k+8>>2],c[j+12>>2]=c[k+12>>2],c[k+0>>2]=c[f+0>>2],c[k+4>>2]=c[f+4>>2],c[k+8>>2]=c[f+8>>2],c[k+12>>2]=c[f+12>>2],(c[j>>2]|0)>>>0<l>>>0):0){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}while(0);f=a+48|0;if((f|0)==(b|0)){h=1;i=e;return h|0}j=0;l=f;f=k;while(1){k=c[l>>2]|0;if(k>>>0<(c[f>>2]|0)>>>0){n=l+4|0;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=l;d=f;while(1){c[n+0>>2]=c[d+0>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[d+12>>2];if((d|0)==(a|0)){o=a;break}m=d+-16|0;if(k>>>0<(c[m>>2]|0)>>>0){p=d;d=m;n=p}else{o=d;break}}c[o>>2]=k;d=o+4|0;c[d+0>>2]=c[g+0>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];d=j+1|0;if((d|0)==8){q=l;break}else r=d}else r=j;d=l+16|0;if((d|0)==(b|0)){h=1;s=35;break}else{n=l;j=r;l=d;f=n}}if((s|0)==35){i=e;return h|0}h=(q+16|0)==(b|0);i=e;return h|0}}return 0}function MUd(a){a=a|0;var b=0;if((a|0)==2)b=4;else b=(a&-3|0)==1?3:1;return b|0}function NUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function OUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function PUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function QUd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function RUd(a){a=a|0;return (c[a+156>>2]|0)!=(c[a+152>>2]|0)|0}function SUd(a,b,d,e,f,h,j){a=a|0;b=ea(b);d=ea(d);e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=0,t=0;k=i;if(b==d){i=k;return}l=a+152|0;m=c[l>>2]|0;n=(c[a+156>>2]|0)-m|0;a=(n|0)/56|0;o=(n|0)>0;if(b<d){if(!o){i=k;return}if(j)p=0;else{j=0;do{n=c[l>>2]|0;q=ea(g[n+(j*56|0)>>2]);if(!(!(q>b)|!(q<=d)))VUd(n+(j*56|0)|0,e,0,f,h)|0;j=j+1|0}while((j|0)<(a|0));i=k;return}do{j=c[l>>2]|0;q=ea(g[j+(p*56|0)>>2]);if(!(!(q>=b)|!(q<=d)?!(q>b)|!(q<=d):0))VUd(j+(p*56|0)|0,e,0,f,h)|0;p=p+1|0}while((p|0)<(a|0));i=k;return}else{if(o){r=m;s=0}else{i=k;return}while(1){m=r+(s*56|0)|0;if(ea(g[m>>2])>b)VUd(m,e,0,f,h)|0;m=s+1|0;if((m|0)>=(a|0))break;r=c[l>>2]|0;s=m}if(o)t=0;else{i=k;return}do{o=(c[l>>2]|0)+(t*56|0)|0;if(ea(g[o>>2])<d)VUd(o,e,0,f,h)|0;t=t+1|0}while((t|0)<(a|0));i=k;return}}function TUd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=a+8|0;if((c[j>>2]|0)==0?(k=a+20|0,l=(c[k>>2]|0)+27|0,c[g>>2]=18,c[f+0>>2]=c[g+0>>2],g=cOb(l,16,f,0,3653512,514)|0,(g|0)!=0):0){c[j>>2]=g;c[a+12>>2]=g;c[g>>2]=0;c[g+8>>2]=c[k>>2];k=g+12|0;j=(0-k&15)+k|0;c[g+4>>2]=j;c[a+16>>2]=j}j=b+-1+d|0;g=a+16|0;k=c[g>>2]|0;l=a+12|0;m=c[l>>2]|0;do if((k+j|0)>>>0>((c[m+4>>2]|0)+(c[m+8>>2]|0)|0)>>>0){n=a+20|0;o=c[n>>2]|0;c[h>>2]=18;c[f+0>>2]=c[h+0>>2];p=cOb((o>>>0<b>>>0?b:o)+27|0,16,f,0,3653512,596)|0;if(!p){q=0;i=e;return q|0}else{c[c[l>>2]>>2]=p;c[l>>2]=p;c[p>>2]=0;o=c[n>>2]|0;c[p+8>>2]=j>>>0>o>>>0?j:o;o=p+12|0;n=(0-o&15)+o|0;c[p+4>>2]=n;c[g>>2]=n;r=n;break}}else r=k;while(0);k=r;r=(d+-1&0-k)+k|0;c[g>>2]=r+b;q=r;i=e;return q|0}function UUd(a,b){a=a|0;b=b|0;return}function VUd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0;j=i;i=i+368|0;k=j+24|0;l=j+256|0;m=j+40|0;n=j+48|0;o=j+272|0;p=j;q=j+56|0;r=j+16|0;s=j+288|0;t=j+276|0;u=j+8|0;v=j+260|0;w=j+32|0;x=c[d+24>>2]|0;if(!(vTb(x)|0)){y=0;i=j;return y|0}d=x+32|0;if((c[d>>2]|0)<=0){y=1;i=j;return y|0}z=x+24|0;x=b+4|0;A=x+1|0;B=s+36|0;C=b+44|0;D=b+48|0;E=b+52|0;F=q+32|0;G=q+12|0;H=q+25|0;I=q+16|0;J=v+1|0;K=t+1|0;L=v+8|0;M=t+8|0;N=b+32|0;O=b+36|0;P=b+16|0;Q=P+1|0;R=b+24|0;S=b+28|0;T=b+12|0;U=0;while(1){V=c[z>>2]|0;a:do if(((c[V+(U<<3)>>2]|0)==114?(W=c[V+(U<<3)+4>>2]|0,X=c[W+20>>2]|0,(X|0)!=0):0)?(v9c(p,W,(a[x>>0]&1)==0?A:c[T>>2]|0),(c[p>>2]|0)!=0):0){Y=p;Z=c[Y+4>>2]|0;_=r;c[_>>2]=c[Y>>2];c[_+4>>2]=Z;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];jbd(q,k);c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[B+16>>2]=0;c[B+20>>2]=0;c[B+24>>2]=0;c[C>>2]=e;c[D>>2]=f;c[E>>2]=h;WUd(b,s);Z=p;_=c[Z>>2]|0;Y=c[Z+4>>2]&255;Z=m;c[Z>>2]=_;c[Z+4>>2]=Y;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];Z=_rc(k)|0;b:do if(Z){do if((Z|0)<=1){$=n;c[$>>2]=_;c[$+4>>2]=Y;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];$=$sc($rc(k,0)|0)|0;aa=Xbd()|0;if(($|0)==(c[aa+212>>2]|0)){abd(F,ea(g[N>>2]));break b}if(($|0)==(c[aa+204>>2]|0)){$ad(F,c[O>>2]|0);break b}if(($|0)==(c[aa+208>>2]|0)){bbd(F,(a[P>>0]&1)==0?Q:c[R>>2]|0);break b}if(($|0)==(c[aa+480>>2]|0)){ba=ds(c[(Xbd()|0)+480>>2]|0)|0;ca=ba+8|0;da=s+0|0;fa=ca+72|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(fa|0));cbd(F,ba);break b}if(!(msc($,c[aa+288>>2]|0)|0)){if(!(jsc($)|0))break;$ad(F,c[O>>2]|0);break b}da=c[S>>2]|0;c:do if(!da)ga=0;else{c[l>>2]=da;ca=c[137784]|0;do if(ca){do if((c[ca+36>>2]|0)!=(c[ca+4>>2]|0)){fRb(k,ca,l);fa=c[k>>2]|0;ha=c[ca+28>>2]|0;if((fa|0)==-1){ia=ha+(c[ca+32>>2]<<3)|0;break}else{ia=ha+(fa<<3)|0;break}}else ia=(c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0;while(0);fa=c[137784]|0;if((ia|0)==((c[fa+28>>2]|0)+(c[fa+32>>2]<<3)|0))break;fa=c[ia+4>>2]|0;if(fa){ga=fa;break c}}while(0);ga=hQb(c[S>>2]|0)|0}while(0);cbd(F,Ecd(ga)|0);break b}while(0);da=p;$=c[da+4>>2]|0;aa=u;c[aa>>2]=c[da>>2];c[aa+4>>2]=$;c[k+0>>2]=c[u+0>>2];c[k+4>>2]=c[u+4>>2];$=asc(k)|0;A9c(v,W);aa=(a[v>>0]&1)==0?J:c[L>>2]|0;c[k>>2]=$;c[k+4>>2]=aa;Lsd(t,694800,k);Krd((a[t>>0]&1)==0?K:c[M>>2]|0,0,3653512,106,1,c[W+4>>2]|0,0,0);xri(t);if(!(a[v>>0]&1))break a;aa=c[L>>2]|0;c[o>>2]=58;c[k+0>>2]=c[o+0>>2];eOb(aa,k);break a}while(0);Y=SQb()|0;RQb(1);c[G>>2]=X;a[H>>0]=1;c[I>>2]=c[W+4>>2];_=nbd(q)|0;RQb(Y);if(_){Y=p;Z=c[Y+4>>2]|0;aa=w;c[aa>>2]=c[Y>>2];c[aa+4>>2]=Z;c[k+0>>2]=c[w+0>>2];c[k+4>>2]=c[w+4>>2];y9c(W,k,_)|0}c[C>>2]=0;c[D>>2]=0;c[E>>2]=0}while(0);U=U+1|0;if((U|0)>=(c[d>>2]|0)){y=1;break}}i=j;return y|0}function WUd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+8|0;h=e;g[d>>2]=ea(g[b>>2]);j=b+4|0;k=a[j>>0]|0;if(!(k&1)){l=j+1|0;m=(k&255)>>>1}else{l=c[b+12>>2]|0;m=c[b+8>>2]|0}c[d+4>>2]=Esc(l,m)|0;m=b+16|0;l=a[m>>0]|0;if(!(l&1)){n=m+1|0;o=(l&255)>>>1}else{n=c[b+24>>2]|0;o=c[b+20>>2]|0}c[d+8>>2]=Esc(n,o)|0;o=b+28|0;n=c[o>>2]|0;do if(!n)p=0;else{c[h>>2]=n;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,h);m=c[f>>2]|0;k=c[l+28>>2]|0;if((m|0)==-1){q=k+(c[l+32>>2]<<3)|0;break}else{q=k+(m<<3)|0;break}}else q=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((q|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[q+4>>2]|0,(l|0)!=0):0){p=l;break}}p=hQb(c[o>>2]|0)|0}while(0);c[d+12>>2]=Ecd(p)|0;g[d+16>>2]=ea(g[b+32>>2]);c[d+20>>2]=c[b+36>>2];c[d+24>>2]=c[b+40>>2];p=c[b+44>>2]|0;if(!p)r=(c[b+52>>2]|0)!=0?2:0;else r=1;c[d+28>>2]=r;c[d+32>>2]=Scd(p,c[(Xbd()|0)+112>>2]|0)|0;p=c[b+48>>2]|0;if(p){r=d+36|0;c[r+0>>2]=c[p+0>>2];c[r+4>>2]=c[p+4>>2];c[r+8>>2]=c[p+8>>2];c[r+12>>2]=c[p+12>>2];c[r+16>>2]=c[p+16>>2];c[r+20>>2]=c[p+20>>2];c[r+24>>2]=c[p+24>>2]}p=c[b+52>>2]|0;if(!p){i=e;return}CXd(p,d+64|0);i=e;return}function XUd(a){a=a|0;return c[a+52>>2]|0}function YUd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+52>>2]|0;if(!d){e=0;i=b;return e|0}a=d+36|0;d=c[a>>2]|0;if(!d){e=0;i=b;return e|0}f=d+a+48|0;e=(c[(c[f>>2]|0)+f>>2]|0)!=0;i=b;return e|0}function ZUd(){var a=0;a=i;_Ud();$Ud();i=a;return}function _Ud(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;b=i;i=i+96|0;d=b+76|0;e=b+40|0;f=b;g=b+68|0;h=b+72|0;j=b+80|0;k=b+28|0;l=b+56|0;m=b+44|0;n=b+16|0;o=b+4|0;p=xCi(12)|0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[173746]=p;PXb(p,92);p=k+1|0;q=j+8|0;r=j+4|0;s=j+1|0;t=k+8|0;u=m+1|0;v=l+8|0;w=l+4|0;x=l+1|0;y=m+8|0;z=o+1|0;A=n+8|0;B=n+4|0;C=n+1|0;D=o+8|0;E=0;a:while(1){do if((E|0)>=52){F=c[173746]|0;if((E|0)<72){bVd(m,E+-52|0,1);G=(a[m>>0]&1)==0?u:c[y>>2]|0;H=SEi(G|0)|0;if(H>>>0>2147483631){I=26;break a}if(H>>>0<11){a[l>>0]=H<<1;J=x}else{K=H+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];L=cOb(K,16,d,0,3653512,80)|0;c[v>>2]=L;c[l>>2]=K|1;c[w>>2]=H;J=L}YEi(J|0,G|0,H|0)|0;a[J+H>>0]=0;H=F+4|0;M=c[H>>2]|0;if((M|0)==(c[F+8>>2]|0))wXb(F,l);else{if(!M)N=0;else{G=a[l>>0]|0;if(!(G&1)){O=(G&255)>>>1;P=x}else{O=c[w>>2]|0;P=c[v>>2]|0}if(O>>>0>2147483631){I=36;break a}if(O>>>0<11){a[M>>0]=O<<1;Q=M+1|0}else{G=O+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];L=cOb(G,16,d,0,3653512,80)|0;c[M+8>>2]=L;c[M>>2]=G|1;c[M+4>>2]=O;Q=L}YEi(Q|0,P|0,O|0)|0;a[Q+O>>0]=0;N=c[H>>2]|0}c[H>>2]=N+12}if(a[l>>0]&1){H=c[v>>2]|0;c[g>>2]=58;c[d+0>>2]=c[g+0>>2];eOb(H,d)}xri(m);break}else{bVd(o,E+-72|0,0);H=(a[o>>0]&1)==0?z:c[D>>2]|0;L=SEi(H|0)|0;if(L>>>0>2147483631){I=47;break a}if(L>>>0<11){a[n>>0]=L<<1;R=C}else{G=L+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];K=cOb(G,16,d,0,3653512,80)|0;c[A>>2]=K;c[n>>2]=G|1;c[B>>2]=L;R=K}YEi(R|0,H|0,L|0)|0;a[R+L>>0]=0;L=F+4|0;S=c[L>>2]|0;if((S|0)==(c[F+8>>2]|0))wXb(F,n);else{if(!S)T=0;else{F=a[n>>0]|0;if(!(F&1)){U=(F&255)>>>1;V=C}else{U=c[B>>2]|0;V=c[A>>2]|0}if(U>>>0>2147483631){I=57;break a}if(U>>>0<11){a[S>>0]=U<<1;W=S+1|0}else{F=U+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];H=cOb(F,16,d,0,3653512,80)|0;c[S+8>>2]=H;c[S>>2]=F|1;c[S+4>>2]=U;W=H}YEi(W|0,V|0,U|0)|0;a[W+U>>0]=0;T=c[L>>2]|0}c[L>>2]=T+12}if(a[n>>0]&1){L=c[A>>2]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];eOb(L,d)}xri(o);break}}else{L=c[173746]|0;H=N_d(E)|0;rri(k,H,SEi(H|0)|0);H=(a[k>>0]&1)==0?p:c[t>>2]|0;F=SEi(H|0)|0;if(F>>>0>2147483631){I=4;break a}if(F>>>0<11){a[j>>0]=F<<1;X=s}else{K=F+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];G=cOb(K,16,d,0,3653512,80)|0;c[q>>2]=G;c[j>>2]=K|1;c[r>>2]=F;X=G}YEi(X|0,H|0,F|0)|0;a[X+F>>0]=0;F=L+4|0;Y=c[F>>2]|0;if((Y|0)==(c[L+8>>2]|0))wXb(L,j);else{if(!Y)Z=0;else{L=a[j>>0]|0;if(!(L&1)){_=(L&255)>>>1;$=s}else{_=c[r>>2]|0;$=c[q>>2]|0}if(_>>>0>2147483631){I=14;break a}if(_>>>0<11){a[Y>>0]=_<<1;aa=Y+1|0}else{L=_+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];H=cOb(L,16,d,0,3653512,80)|0;c[Y+8>>2]=H;c[Y>>2]=L|1;c[Y+4>>2]=_;aa=H}YEi(aa|0,$|0,_|0)|0;a[aa+_>>0]=0;Z=c[F>>2]|0}c[F>>2]=Z+12}if(a[j>>0]&1){F=c[q>>2]|0;c[h>>2]=58;c[d+0>>2]=c[h+0>>2];eOb(F,d)}xri(k)}while(0);E=E+1|0;if((E|0)>=92){I=68;break}}if((I|0)==4)ori(j);else if((I|0)==14)ori(Y);else if((I|0)==26)ori(l);else if((I|0)==36)ori(M);else if((I|0)==47)ori(n);else if((I|0)==57)ori(S);else if((I|0)==68){i=b;return}}function $Ud(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;b=i;i=i+96|0;d=b+76|0;e=b+40|0;f=b;g=b+68|0;h=b+72|0;j=b+80|0;k=b+28|0;l=b+56|0;m=b+44|0;n=b+16|0;o=b+4|0;p=xCi(12)|0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[173748]=p;PXb(p,54);p=k+1|0;q=j+8|0;r=j+4|0;s=j+1|0;t=k+8|0;u=m+1|0;v=l+8|0;w=l+4|0;x=l+1|0;y=m+8|0;z=o+1|0;A=n+8|0;B=n+4|0;C=n+1|0;D=o+8|0;E=0;a:while(1){do if((E|0)>=24){F=c[173748]|0;if((E|0)<39){cVd(m,E+-24|0,1);G=(a[m>>0]&1)==0?u:c[y>>2]|0;H=SEi(G|0)|0;if(H>>>0>2147483631){I=26;break a}if(H>>>0<11){a[l>>0]=H<<1;J=x}else{K=H+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];L=cOb(K,16,d,0,3653512,80)|0;c[v>>2]=L;c[l>>2]=K|1;c[w>>2]=H;J=L}YEi(J|0,G|0,H|0)|0;a[J+H>>0]=0;H=F+4|0;M=c[H>>2]|0;if((M|0)==(c[F+8>>2]|0))wXb(F,l);else{if(!M)N=0;else{G=a[l>>0]|0;if(!(G&1)){O=(G&255)>>>1;P=x}else{O=c[w>>2]|0;P=c[v>>2]|0}if(O>>>0>2147483631){I=36;break a}if(O>>>0<11){a[M>>0]=O<<1;Q=M+1|0}else{G=O+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];L=cOb(G,16,d,0,3653512,80)|0;c[M+8>>2]=L;c[M>>2]=G|1;c[M+4>>2]=O;Q=L}YEi(Q|0,P|0,O|0)|0;a[Q+O>>0]=0;N=c[H>>2]|0}c[H>>2]=N+12}if(a[l>>0]&1){H=c[v>>2]|0;c[g>>2]=58;c[d+0>>2]=c[g+0>>2];eOb(H,d)}xri(m);break}else{cVd(o,E+-39|0,0);H=(a[o>>0]&1)==0?z:c[D>>2]|0;L=SEi(H|0)|0;if(L>>>0>2147483631){I=47;break a}if(L>>>0<11){a[n>>0]=L<<1;R=C}else{G=L+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];K=cOb(G,16,d,0,3653512,80)|0;c[A>>2]=K;c[n>>2]=G|1;c[B>>2]=L;R=K}YEi(R|0,H|0,L|0)|0;a[R+L>>0]=0;L=F+4|0;S=c[L>>2]|0;if((S|0)==(c[F+8>>2]|0))wXb(F,n);else{if(!S)T=0;else{F=a[n>>0]|0;if(!(F&1)){U=(F&255)>>>1;V=C}else{U=c[B>>2]|0;V=c[A>>2]|0}if(U>>>0>2147483631){I=57;break a}if(U>>>0<11){a[S>>0]=U<<1;W=S+1|0}else{F=U+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];H=cOb(F,16,d,0,3653512,80)|0;c[S+8>>2]=H;c[S>>2]=F|1;c[S+4>>2]=U;W=H}YEi(W|0,V|0,U|0)|0;a[W+U>>0]=0;T=c[L>>2]|0}c[L>>2]=T+12}if(a[n>>0]&1){L=c[A>>2]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];eOb(L,d)}xri(o);break}}else{L=c[173748]|0;H=M_d(E)|0;rri(k,H,SEi(H|0)|0);H=(a[k>>0]&1)==0?p:c[t>>2]|0;F=SEi(H|0)|0;if(F>>>0>2147483631){I=4;break a}if(F>>>0<11){a[j>>0]=F<<1;X=s}else{K=F+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];G=cOb(K,16,d,0,3653512,80)|0;c[q>>2]=G;c[j>>2]=K|1;c[r>>2]=F;X=G}YEi(X|0,H|0,F|0)|0;a[X+F>>0]=0;F=L+4|0;Y=c[F>>2]|0;if((Y|0)==(c[L+8>>2]|0))wXb(L,j);else{if(!Y)Z=0;else{L=a[j>>0]|0;if(!(L&1)){_=(L&255)>>>1;$=s}else{_=c[r>>2]|0;$=c[q>>2]|0}if(_>>>0>2147483631){I=14;break a}if(_>>>0<11){a[Y>>0]=_<<1;aa=Y+1|0}else{L=_+16&-16;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];H=cOb(L,16,d,0,3653512,80)|0;c[Y+8>>2]=H;c[Y>>2]=L|1;c[Y+4>>2]=_;aa=H}YEi(aa|0,$|0,_|0)|0;a[aa+_>>0]=0;Z=c[F>>2]|0}c[F>>2]=Z+12}if(a[j>>0]&1){F=c[q>>2]|0;c[h>>2]=58;c[d+0>>2]=c[h+0>>2];eOb(F,d)}xri(k)}while(0);E=E+1|0;if((E|0)>=54){I=68;break}}if((I|0)==4)ori(j);else if((I|0)==14)ori(Y);else if((I|0)==26)ori(l);else if((I|0)==36)ori(M);else if((I|0)==47)ori(n);else if((I|0)==57)ori(S);else if((I|0)==68){i=b;return}}function aVd(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[173746]|0;if(g){h=c[g>>2]|0;if(h){j=g+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-12|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-4>>2]|0;c[f>>2]=58;c[d+0>>2]=c[f+0>>2];eOb(k,d);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[g>>2]|0}ACi(l)}ACi(g)}c[173746]=0;g=c[173748]|0;if(!g){c[173748]=0;i=b;return}l=c[g>>2]|0;if(l){n=g+4|0;m=c[n>>2]|0;if((m|0)==(l|0))o=l;else{h=m;while(1){m=h+-12|0;c[n>>2]=m;if(!(a[m>>0]&1))p=m;else{m=c[h+-4>>2]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];eOb(m,d);p=c[n>>2]|0}if((p|0)==(l|0))break;else h=p}o=c[g>>2]|0}ACi(o)}ACi(g);c[173748]=0;i=b;return}function bVd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;rri(a,c?695e3:695008,c?5:6);if(b>>>0>=20){i=d;return}Eri(a,G_d((b|0)/4|0)|0)|0;Eri(a,1076904)|0;Eri(a,I_d((b|0)%4|0)|0)|0;i=d;return}function cVd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;rri(a,c?695e3:695008,c?5:6);if(b>>>0>=15){i=d;return}Eri(a,G_d((b|0)/3|0)|0)|0;Eri(a,1076904)|0;Eri(a,H_d((b|0)%3|0)|0)|0;i=d;return}function dVd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;d=a+28|0;e=c[d>>2]|0;f=a+40|0;g=c[f>>2]|0;h=e+(g>>>8<<2)|0;j=a+32|0;k=c[j>>2]|0;if((k|0)==(e|0)){l=0;m=a+44|0;n=0}else{o=a+44|0;p=(c[o>>2]|0)+g|0;l=(c[e+(p>>>8<<2)>>2]|0)+((p&255)<<4)|0;m=o;n=(c[h>>2]|0)+((g&255)<<4)|0}g=n;n=h;a:while(1){h=g;do{if((h|0)==(l|0))break a;h=h+16|0}while((h-(c[n>>2]|0)|0)!=4096);h=n+4|0;g=c[h>>2]|0;n=h}c[m>>2]=0;m=k-e>>2;if(m>>>0>2){k=e;do{ACi(c[k>>2]|0);k=(c[d>>2]|0)+4|0;c[d>>2]=k;e=(c[j>>2]|0)-k>>2}while(e>>>0>2);q=e}else q=m;if((q|0)==1)c[f>>2]=128;else if((q|0)==2)c[f>>2]=256;f=c[d>>2]|0;q=c[j>>2]|0;if((f|0)!=(q|0)){m=f;do{ACi(c[m>>2]|0);m=m+4|0}while((m|0)!=(q|0));q=c[d>>2]|0;d=c[j>>2]|0;if((d|0)!=(q|0))c[j>>2]=d+(~((d+-4-q|0)>>>2)<<2)}q=c[a+24>>2]|0;if(!q){i=b;return}ACi(q);i=b;return}function eVd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=d+16|0;if(!(a[b>>0]|0)){e=d+12|0;f=c[e>>2]|0;g=(0-f&3)+f|0;f=(0-g&3)+g|0;g=f+4+(0-f&3)|0;f=(0-g&3)+g|0;g=f+4+(0-f&3)|0;f=(0-g&3)+g|0;g=f+4+(0-f&3)|0;f=(0-g&3)+g|0;g=f+4+(0-f&3)|0;f=(0-g&3)+g|0;c[e>>2]=f;h=f}else{a[b>>0]=0;h=c[d+12>>2]|0}b=(0-h&3)+h|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=(0-h&3)+h|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;h=(0-b&3)+b|0;b=h+4+(0-h&3)|0;c[d+12>>2]=(0-b&3)+b;return}function fVd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;f=(a[b+20>>0]|0)!=0;if(f)jjd(b,4,e,4);h=b+44|0;j=b+40|0;k=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);n=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;m=c[(c[l>>2]|0)+(n>>>8<<2)>>2]|0;o=n&255;n=(c[c[b+12>>2]>>2]|0)+((c[m+(o<<4)+4>>2]|0)+(c[m+(o<<4)>>2]|0))|0;o=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;a[n>>0]=o;a[n+1>>0]=o>>8;a[n+2>>0]=o>>16;a[n+3>>0]=o>>24;if(a[b+23>>0]|0)c[n>>2]=XEi(o|0)|0;o=c[j>>2]|0;j=(c[h>>2]|0)+-1+o|0;n=c[l>>2]|0;l=(c[n+(j>>>8<<2)>>2]|0)+((j&255)<<4)+4|0;c[l>>2]=(c[l>>2]|0)+4;if(!f){i=g;return}f=c[h>>2]|0;c[h>>2]=f+-1;h=b+32|0;b=c[h>>2]|0;if((b|0)==(n|0))p=0;else p=(b-n<<6)+-1|0;if((1-f+p-o|0)>>>0<=511){i=g;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=g;return}function gVd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[c[d+4>>2]>>2]|0)!=0,e,4);jVd(f+12|0,d,0,b);njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function hVd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;f=(a[b+20>>0]|0)!=0;if(f)jjd(b,4,e,4);h=b+44|0;j=b+40|0;k=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);n=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;m=c[(c[l>>2]|0)+(n>>>8<<2)>>2]|0;o=n&255;n=(c[c[b+12>>2]>>2]|0)+((c[m+(o<<4)+4>>2]|0)+(c[m+(o<<4)>>2]|0))|0;o=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;a[n>>0]=o;a[n+1>>0]=o>>8;a[n+2>>0]=o>>16;a[n+3>>0]=o>>24;if(a[b+23>>0]|0)c[n>>2]=XEi(o|0)|0;o=c[j>>2]|0;j=(c[h>>2]|0)+-1+o|0;n=c[l>>2]|0;l=(c[n+(j>>>8<<2)>>2]|0)+((j&255)<<4)+4|0;c[l>>2]=(c[l>>2]|0)+4;if(!f){i=g;return}f=c[h>>2]|0;c[h>>2]=f+-1;h=b+32|0;b=c[h>>2]|0;if((b|0)==(n|0))p=0;else p=(b-n<<6)+-1|0;if((1-f+p-o|0)>>>0<=511){i=g;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=g;return}function iVd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;eVd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);kVd(b,d,3068392,0);kVd(b,d+16|0,2473736,0);kVd(b,d+32|0,3143208,0);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function jVd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;d=i;a=b+4|0;if(!(c[c[a>>2]>>2]|0)){i=d;return}f=c[b>>2]|0;c[f+4>>2]=(c[f>>2]|0)+f;f=c[c[a>>2]>>2]<<2;g=c[b>>2]|0;h=(c[g>>2]|0)+g|0;c[g+4>>2]=h;jjd(e,f,h,4);h=c[b>>2]|0;f=(c[h>>2]|0)+h|0;c[h+4>>2]=f;h=f+(c[c[a>>2]>>2]<<2)|0;a=c[b>>2]|0;b=(c[a>>2]|0)+a|0;c[a+4>>2]=b;if((b|0)!=(h|0)){a=b;do{hVd(e,a,3142592,0);a=a+4|0}while((a|0)!=(h|0))}h=e+44|0;a=c[h>>2]|0;c[h>>2]=a+-1;h=e+32|0;b=c[h>>2]|0;f=c[e+28>>2]|0;if((b|0)==(f|0))j=0;else j=(b-f<<6)+-1|0;if((1-a+j-(c[e+40>>2]|0)|0)>>>0<=511){i=d;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=d;return}function kVd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=0;f=i;i=i+16|0;e=f;h=(a[b+20>>0]|0)!=0;if(h)jjd(b,16,d,4);j=b+44|0;k=b+40|0;l=(c[j>>2]|0)+-1+(c[k>>2]|0)|0;m=b+28|0;n=c[(c[m>>2]|0)+(l>>>8<<2)>>2]|0;o=l&255;l=n+(o<<4)+4|0;p=c[l>>2]|0;c[l>>2]=p+(0-(p+(c[n+(o<<4)>>2]|0))&3);g[e>>2]=ea(g[d>>2]);o=e+4|0;n=d+4|0;g[o>>2]=ea(g[n>>2]);p=e+8|0;l=d+8|0;g[p>>2]=ea(g[l>>2]);q=e+12|0;r=d+12|0;g[q>>2]=ea(g[r>>2]);lVd(b,e,3143216,0);lVd(b,o,3143224,0);lVd(b,p,2416480,0);lVd(b,q,2419736,0);s=ea(g[e>>2]);t=ea(g[o>>2]);u=ea(g[p>>2]);v=ea(g[q>>2]);g[d>>2]=s;g[n>>2]=t;g[l>>2]=u;g[r>>2]=v;if(!h){i=f;return}h=c[j>>2]|0;c[j>>2]=h+-1;j=b+32|0;b=c[j>>2]|0;r=c[m>>2]|0;if((b|0)==(r|0))w=0;else w=(b-r<<6)+-1|0;if((1-h+w-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function lVd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;f=(a[b+20>>0]|0)!=0;if(f)jjd(b,4,e,4);h=b+44|0;j=b+40|0;k=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);n=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;m=c[(c[l>>2]|0)+(n>>>8<<2)>>2]|0;o=n&255;n=(c[c[b+12>>2]>>2]|0)+((c[m+(o<<4)+4>>2]|0)+(c[m+(o<<4)>>2]|0))|0;o=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;a[n>>0]=o;a[n+1>>0]=o>>8;a[n+2>>0]=o>>16;a[n+3>>0]=o>>24;if(a[b+23>>0]|0)c[n>>2]=XEi(o|0)|0;o=c[j>>2]|0;j=(c[h>>2]|0)+-1+o|0;n=c[l>>2]|0;l=(c[n+(j>>>8<<2)>>2]|0)+((j&255)<<4)+4|0;c[l>>2]=(c[l>>2]|0)+4;if(!f){i=g;return}f=c[h>>2]|0;c[h>>2]=f+-1;h=b+32|0;b=c[h>>2]|0;if((b|0)==(n|0))p=0;else p=(b-n<<6)+-1|0;if((1-f+p-o|0)>>>0<=511){i=g;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=g;return}function mVd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;e=(a[b+20>>0]|0)!=0;if(e)jjd(b,1,d,1);g=b+44|0;h=b+40|0;j=(c[g>>2]|0)+-1+(c[h>>2]|0)|0;k=b+28|0;l=c[(c[k>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;a[(c[c[b+12>>2]>>2]|0)+((c[l+(m<<4)+4>>2]|0)+(c[l+(m<<4)>>2]|0))>>0]=a[d>>0]|0;d=c[h>>2]|0;h=(c[g>>2]|0)+-1+d|0;m=c[k>>2]|0;k=(c[m+(h>>>8<<2)>>2]|0)+((h&255)<<4)+4|0;c[k>>2]=(c[k>>2]|0)+1;if(!e){i=f;return}e=c[g>>2]|0;c[g>>2]=e+-1;g=b+32|0;b=c[g>>2]|0;if((b|0)==(m|0))n=0;else n=(b-m<<6)+-1|0;if((1-e+n-d|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[g>>2]=(c[g>>2]|0)+-4;i=f;return}function nVd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];bUb(b,h,e);a[b+28>>0]=1;a[b+29>>0]=0;c[b>>2]=695024;c[b+32>>2]=695184;c[b+36>>2]=-1;c[b+40>>2]=-1;a[b+44>>0]=0;e=b+48|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;e=c[153084]|0;c[b+64>>2]=678584;c[b+68>>2]=e;e=b+72|0;j=e+0|0;l=j+44|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(l|0));a[e+44>>0]=0;c[b+120>>2]=0;c[b+124>>2]=0;c[b+128>>2]=694792;c[b+136>>2]=0;c[b+140>>2]=0;c[b+148>>2]=262144;c[b+132>>2]=0;e=b+152|0;j=e+0|0;l=j+44|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(l|0));a[e+44>>0]=0;e=b+200|0;c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];g[b+212>>2]=ea(0.0);g[b+216>>2]=ea(0.0);g[b+220>>2]=ea(0.0);g[b+224>>2]=ea(1.0);e=b+228|0;c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];e=b+240|0;c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];e=b+252|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;g[b+292>>2]=ea(-1.0);c[b+296>>2]=-1;e=b+300|0;c[e+0>>2]=c[150284];c[e+4>>2]=c[150285];c[e+8>>2]=c[150286];g[b+312>>2]=ea(0.0);g[b+316>>2]=ea(0.0);g[b+320>>2]=ea(0.0);g[b+324>>2]=ea(1.0);aFi(b+328|0,601152,12)|0;g[b+340>>2]=ea(0.0);a[b+344>>0]=0;a[b+345>>0]=0;a[b+346>>0]=0;g[b+348>>2]=ea(1.0);a[b+352>>0]=1;a[b+353>>0]=1;c[b+356>>2]=0;c[b+364>>2]=0;c[b+368>>2]=0;c[b+360>>2]=60;c[b+372>>2]=0;c[b+380>>2]=0;c[b+384>>2]=0;c[b+376>>2]=60;a[b+388>>0]=1;c[b+392>>2]=b;c[b+396>>2]=0;c[b+400>>2]=-1;c[b+404>>2]=b;c[b+408>>2]=0;c[b+412>>2]=-1;c[k>>2]=c[d>>2];c[h+0>>2]=c[k+0>>2];QXd(b+416|0,h);c[b+456>>2]=0;g[b+460>>2]=ea(0.0);g[b+464>>2]=ea(0.0);a[b+468>>0]=1;a[b+469>>0]=1;c[b+472>>2]=0;c[b+480>>2]=0;c[b+484>>2]=0;c[b+476>>2]=60;i=f;return}function oVd(a){a=a|0;var b=0;b=i;$Qc(a+392|0);$Qc(a+404|0);i=b;return}function pVd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;okc(b,d);d=c[b+52>>2]|0;if((d|0)==1)f=4;else if((d|0)==2|(d|0)==0){if((c[b+36>>2]|0)==-1)if((d|0)==1)f=4;else f=5}else f=5;if((f|0)==4?(c[b+40>>2]|0)==-1:0)f=5;if((f|0)==5)ko[c[(c[b>>2]|0)+128>>2]&4095](b);JVd(b);DVd(b);if(!(c[b+60>>2]|0))g=0;else g=(a[b+29>>0]|0)!=0;if((c[b+36>>2]|0)==-1)h=(c[b+40>>2]|0)!=-1;else h=1;if(!(g|h^1)){ko[c[(c[b>>2]|0)+128>>2]&4095](b);i=e;return}if(h|g^1){i=e;return}ko[c[(c[b>>2]|0)+124>>2]&4095](b);i=e;return}function qVd(a){a=a|0;return}function rVd(b){b=b|0;c[b+48>>2]=0;a[b+345>>0]=0;c[b+52>>2]=0;a[b+469>>0]=1;return}function sVd(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2490224,a,0);rWd(a,b);bdd(b);i=c;return}function tVd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2490224,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else sWd(a,b);sdd(b);i=d;return}function uVd(a,b){a=a|0;b=b|0;var c=0;c=i;tWd(a,b);i=c;return}function vVd(a,b){a=a|0;b=b|0;var c=0;c=i;uWd(a,b);i=c;return}function wVd(a,b){a=a|0;b=b|0;var c=0;c=i;vWd(a,b);i=c;return}function xVd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;Mkc(b,d);f=b+56|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;k=b+60|0;b=c[g>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[k>>2]|0,c[j>>2]|0)|0;if(!(a[h>>0]|0)){i=e;return}c[k>>2]=g;i=e;return}function yVd(){var a=0;a=i;QQb(95,207,208,0,209);i=a;return}function zVd(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,2490224,8);wQb(95,8,b,488,2738,0,0);xri(b);i=a;return}function AVd(){var a=0;a=i;QTb(95,554336,1838,1e5);QTb(95,556240,1839,0);QTb(95,556296,1840,0);QTb(95,556392,1841,0);QTb(95,554872,1842,2);JXd();yYd();nYd();$$d();EUd();bZd();ZUd();i=a;return}function BVd(){var a=0;a=i;KXd();aVd();i=a;return}function CVd(a){a=a|0;return 95}function DVd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+24|0;h=c[g>>2]|0;if(!h){i=d;return}if(!(vTb(h)|0)){i=d;return}h=b+356|0;j=c[h>>2]|0;k=b+364|0;l=c[k>>2]|0;m=j+(l<<2)|0;if(l){l=j;do{MQb(c[l>>2]|0,1843,b);l=l+4|0}while((l|0)!=(m|0))}m=b+368|0;if((c[m>>2]|0)>-1){l=c[h>>2]|0;c[f>>2]=c[b+360>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);c[h>>2]=0}c[k>>2]=0;c[m>>2]=0;if(!(c[b+48>>2]|0)){a[b+44>>0]=1;i=d;return}hWd(b,BTb(c[g>>2]|0)|0);if(c[k>>2]|0){i=d;return}a[b+44>>0]=0;i=d;return}function EVd(a){a=a|0;var b=0;b=i;HXd(LXd()|0,a);i=b;return}function FVd(a){a=a|0;var b=0;b=i;IXd(LXd()|0,a);i=b;return}function GVd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;pkc(a,b);HVd(a);b=a+356|0;g=c[b>>2]|0;h=a+364|0;j=c[h>>2]|0;k=g+(j<<2)|0;if(j){j=g;do{MQb(c[j>>2]|0,1843,a);j=j+4|0}while((j|0)!=(k|0))}k=a+368|0;if((c[k>>2]|0)<=-1){c[h>>2]=0;c[k>>2]=0;i=d;return}j=c[b>>2]|0;c[f>>2]=c[a+360>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[b>>2]=0;c[h>>2]=0;c[k>>2]=0;i=d;return}function HVd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+484|0;if((c[g>>2]|0)>-1){h=b+472|0;j=c[h>>2]|0;c[f>>2]=c[b+476>>2];c[e+0>>2]=c[f+0>>2];eOb(j,e);c[h>>2]=0}c[b+480>>2]=0;c[g>>2]=0;OQb(b,3);g=b+120|0;if(c[g>>2]|0)Gnd(g);g=b+64|0;mYd(c[b+96>>2]|0,g);cUd(c[b+100>>2]|0,g);$Td(c[b+104>>2]|0,g);h=b+88|0;j=c[h>>2]|0;if(j)DYd(c[j+24>>2]|0,g);j=b+80|0;xYd(c[j>>2]|0,g);k=b+76|0;rYd(c[k>>2]|0,g);l=b+84|0;if(((c[b+112>>2]|0)==0?(m=c[l>>2]|0,(m|0)!=0):0)?(n=c[m>>2]|0,(n|0)!=0):0){o=n+m|0;c[m+4>>2]=o;AYd(o,g)}tYd(c[l>>2]|0,g);vYd(c[h>>2]|0,g);o=b+116|0;m=b+72|0;if(a[o>>0]|0){pYd(c[m>>2]|0,g);a[o>>0]=0}c[m>>2]=0;c[l>>2]=0;c[k>>2]=0;c[j>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;$Qc(b+404|0);$Qc(b+392|0);h=b+152|0;j=c[b+184>>2]|0;if(j)XTd(j);j=c[b+180>>2]|0;if(j)YTd(j);j=h+0|0;k=j+44|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));a[h+44>>0]=0;h=b+136|0;j=c[h>>2]|0;if(!j){c[h>>2]=0;p=b+140|0;c[p>>2]=0;q=b+144|0;c[q>>2]=0;_Vd(b);i=d;return}k=j;do{j=k;k=c[k>>2]|0;c[f>>2]=c[153084];c[e+0>>2]=c[f+0>>2];eOb(j,e)}while((k|0)!=0);c[h>>2]=0;p=b+140|0;c[p>>2]=0;q=b+144|0;c[q>>2]=0;_Vd(b);i=d;return}function IVd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im;d=i;i=i+48|0;e=d+32|0;f=d+16|0;h=d;j=a+84|0;if(!(c[j>>2]|0)){i=d;return}k=BTb(c[a+24>>2]|0)|0;if((b&1|0)!=0?(rGc(e,k),a=c[j>>2]|0,(a|0)!=0):0){l=ea(g[e>>2]);m=ea(g[e+4>>2]);n=ea(g[e+8>>2]);g[a+8>>2]=l;g[a+12>>2]=m;g[a+16>>2]=n;g[a+20>>2]=ea(0.0)}if((b&2|0)!=0?(oGc(f,k),a=c[j>>2]|0,(a|0)!=0):0){n=ea(g[f>>2]);m=ea(g[f+4>>2]);l=ea(g[f+8>>2]);o=ea(g[f+12>>2]);g[a+24>>2]=n;g[a+28>>2]=m;g[a+32>>2]=l;g[a+36>>2]=o}if(!(b&8)){i=d;return}qGc(h,k);k=c[j>>2]|0;if(!k){i=d;return}o=ea(g[h>>2]);l=ea(g[h+4>>2]);m=ea(g[h+8>>2]);g[k+40>>2]=o;g[k+44>>2]=l;g[k+48>>2]=m;g[k+52>>2]=ea(1.0);i=d;return}function JVd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=i;i=i+48|0;d=b+8|0;e=b+24|0;f=b+16|0;g=b+28|0;h=b+36|0;j=b;k=b+20|0;l=b+32|0;m=c[a+24>>2]|0;if(!m){i=b;return}if(!(vTb(m)|0)){i=b;return}HVd(a);m=a+56|0;n=c[m>>2]|0;do if(!n)o=0;else{c[l>>2]=n;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(d,p,l);q=c[d>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(c[s+4>>2]|0)!=0:0)t=p;else u=12}else u=12;if((u|0)==12){if(!(hQb(c[m>>2]|0)|0)){o=0;break}t=c[137784]|0}c[k>>2]=c[m>>2];if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(d,t,k);p=c[d>>2]|0;q=c[t+28>>2]|0;if((p|0)==-1){v=q+(c[t+32>>2]<<3)|0;break}else{v=q+(p<<3)|0;break}}else v=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);p=c[137784]|0;if((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[v+4>>2]|0,(p|0)!=0):0)w=p;else u=22}else u=22;if((u|0)==22)w=hQb(c[m>>2]|0)|0;p=XUd(w)|0;c[j>>2]=c[m>>2];q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(d,q,j);r=c[d>>2]|0;x=c[q+28>>2]|0;if((r|0)==-1){y=x+(c[q+32>>2]<<3)|0;break}else{y=x+(r<<3)|0;break}}else y=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((y|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[y+4>>2]|0,(q|0)!=0):0)z=q;else u=31}else u=31;if((u|0)==31)z=hQb(c[m>>2]|0)|0;aRc(z+72|0,a+392|0);o=p}while(0);z=a+64|0;m=a+72|0;LVd(a,o,z,m);o=a+60|0;y=c[o>>2]|0;if(!y){i=b;return}c[h>>2]=y;y=c[137784]|0;if(y){do if((c[y+36>>2]|0)!=(c[y+4>>2]|0)){fRb(d,y,h);j=c[d>>2]|0;w=c[y+28>>2]|0;if((j|0)==-1){A=w+(c[y+32>>2]<<3)|0;break}else{A=w+(j<<3)|0;break}}else A=(c[y+28>>2]|0)+(c[y+32>>2]<<3)|0;while(0);y=c[137784]|0;if((A|0)!=((c[y+28>>2]|0)+(c[y+32>>2]<<3)|0)?(c[A+4>>2]|0)!=0:0)B=y;else u=42}else u=42;do if((u|0)==42)if(!(hQb(c[o>>2]|0)|0)){i=b;return}else{B=c[137784]|0;break}while(0);c[g>>2]=c[o>>2];if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(d,B,g);y=c[d>>2]|0;A=c[B+28>>2]|0;if((y|0)==-1){C=A+(c[B+32>>2]<<3)|0;break}else{C=A+(y<<3)|0;break}}else C=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);B=c[137784]|0;if((C|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(B=c[C+4>>2]|0,(B|0)!=0):0)D=B;else u=52}else u=52;if((u|0)==52)D=hQb(c[o>>2]|0)|0;aRc(D+28|0,a+404|0);c[f>>2]=c[o>>2];D=c[137784]|0;if(D){do if((c[D+36>>2]|0)!=(c[D+4>>2]|0)){fRb(d,D,f);B=c[d>>2]|0;C=c[D+28>>2]|0;if((B|0)==-1){E=C+(c[D+32>>2]<<3)|0;break}else{E=C+(B<<3)|0;break}}else E=(c[D+28>>2]|0)+(c[D+32>>2]<<3)|0;while(0);D=c[137784]|0;if((E|0)!=((c[D+28>>2]|0)+(c[D+32>>2]<<3)|0)?(D=c[E+4>>2]|0,(D|0)!=0):0)F=D;else u=61}else u=61;if((u|0)==61)F=hQb(c[o>>2]|0)|0;D=mo[c[(c[F>>2]|0)+92>>2]&4095](F)|0;c[e>>2]=c[o>>2];F=c[137784]|0;if(F){do if((c[F+36>>2]|0)!=(c[F+4>>2]|0)){fRb(d,F,e);E=c[d>>2]|0;f=c[F+28>>2]|0;if((E|0)==-1){G=f+(c[F+32>>2]<<3)|0;break}else{G=f+(E<<3)|0;break}}else G=(c[F+28>>2]|0)+(c[F+32>>2]<<3)|0;while(0);F=c[137784]|0;if((G|0)!=((c[F+28>>2]|0)+(c[F+32>>2]<<3)|0)?(F=c[G+4>>2]|0,(F|0)!=0):0)H=F;else u=70}else u=70;if((u|0)==70)H=hQb(c[o>>2]|0)|0;o=mo[c[(c[H>>2]|0)+96>>2]&4095](H)|0;if(!o){i=b;return}MVd(a,D,o,z,m);$Vd(a);ZVd(a);i=b;return}function KVd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+24|0;h=c[b+56>>2]|0;if(h)XTd(h);h=c[b+52>>2]|0;if(h)YTd(h);h=g+0|0;j=h+44|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));a[g+44>>0]=0;g=b+8|0;h=c[g>>2]|0;if(!h){k=b+12|0;l=b+16|0;c[b>>2]=694792;c[g>>2]=0;c[k>>2]=0;c[l>>2]=0;i=d;return}j=h;do{h=j;j=c[j>>2]|0;c[f>>2]=c[153084];c[e+0>>2]=c[f+0>>2];eOb(h,e)}while((j|0)!=0);k=b+12|0;l=b+16|0;c[b>>2]=694792;c[g>>2]=0;c[k>>2]=0;c[l>>2]=0;i=d;return}function LVd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im;h=i;i=i+96|0;j=h+48|0;k=h+32|0;l=h+16|0;m=h;c[f>>2]=d;if(!d){a[f+44>>0]=1;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;g[j+28>>2]=ea(1.0);g[j+32>>2]=ea(1.0);g[j+36>>2]=ea(1.0);g[j+40>>2]=ea(1.0);g[j+44>>2]=ea(1.0);n=oYd(0,0,0,0,0,-1,j,e)|0;c[f>>2]=n;o=n}else o=d;c[f+40>>2]=0;d=f+12|0;c[d>>2]=sYd(o,e)|0;c[f+4>>2]=qYd(c[f>>2]|0,e)|0;c[f+16>>2]=uYd(c[f>>2]|0,e)|0;o=b+469|0;c[f+8>>2]=wYd(c[f>>2]|0,(a[o>>0]|0)!=0,(a[b+345>>0]|0)!=0,e)|0;n=iWd(b)|0;j=c[f>>2]|0;if(!(a[o>>0]|0))p=_Td(n,j,e)|0;else p=ZTd(n,j,e)|0;c[f+32>>2]=p;p=BTb(c[b+24>>2]|0)|0;b=c[d>>2]|0;rGc(k,p);q=ea(g[k>>2]);r=ea(g[k+4>>2]);s=ea(g[k+8>>2]);g[b+8>>2]=q;g[b+12>>2]=r;g[b+16>>2]=s;g[b+20>>2]=ea(0.0);b=c[d>>2]|0;oGc(l,p);s=ea(g[l>>2]);r=ea(g[l+4>>2]);q=ea(g[l+8>>2]);t=ea(g[l+12>>2]);g[b+24>>2]=s;g[b+28>>2]=r;g[b+32>>2]=q;g[b+36>>2]=t;b=c[d>>2]|0;qGc(m,p);t=ea(g[m>>2]);q=ea(g[m+4>>2]);r=ea(g[m+8>>2]);g[b+40>>2]=t;g[b+44>>2]=q;g[b+48>>2]=r;g[b+52>>2]=ea(1.0);i=h;return}function MVd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=g+20|0;c[j>>2]=d;c[g+36>>2]=e;d=iWd(b)|0;k=c[g>>2]|0;l=c[j>>2]|0;m=(a[b+468>>0]|0)!=0;if(!(a[b+469>>0]|0))n=bUd(e,d,k,l,m,f)|0;else n=aUd(e,d,k,l,m,f)|0;m=g+28|0;c[m>>2]=n;l=c[c[n+32>>2]>>2]|0;n=g+12|0;k=c[n>>2]|0;d=e+36|0;e=b+345|0;b=zYd(c[j>>2]|0,c[g>>2]|0,c[d>>2]|0,l,(a[e>>0]|0)!=0,f)|0;if(!b)o=0;else o=b-k|0;c[k>>2]=o;c[k+4>>2]=b;c[g+24>>2]=lYd(c[d>>2]|0,(a[(c[m>>2]|0)+36>>0]|0)!=0,f)|0;b=CYd(c[j>>2]|0,c[g>>2]|0,c[d>>2]|0,l,(a[e>>0]|0)!=0,f)|0;c[(c[g+16>>2]|0)+24>>2]=b;b=u_d(l,f)|0;l=g+8|0;c[c[l>>2]>>2]=b;b=c[c[j>>2]>>2]|0;if((b|0)!=0?(e=xo[c[c[f>>2]>>2]&2047](f,b*20|0,4)|0,(e|0)!=0):0){f=e+(b*20|0)|0;b=e;do{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;b=b+20|0}while((b|0)!=(f|0));p=e}else p=0;c[c[g+4>>2]>>2]=p;w_d(c[(c[(c[m>>2]|0)+32>>2]|0)+4>>2]|0,c[c[l>>2]>>2]|0);if(!(c[c[j>>2]>>2]|0)){i=h;return}else q=0;do{l=c[(c[(c[m>>2]|0)+32>>2]|0)+4>>2]|0;p=c[n>>2]|0;g=(c[p>>2]|0)+p|0;c[p+4>>2]=g;p=g+24|0;e=p+(c[p>>2]|0)|0;c[g+28>>2]=e;g=e+(q*36|0)|0;p=g+(c[g>>2]|0)|0;c[e+(q*36|0)+4>>2]=p;w_d(l,p);q=q+1|0}while(q>>>0<(c[c[j>>2]>>2]|0)>>>0);i=h;return}function NVd(b,e,f,h,j,k){b=b|0;e=e|0;f=ea(f);h=h|0;j=j|0;k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=Im;l=i;i=i+48|0;m=l+36|0;n=l+24|0;o=l+20|0;p=l+8|0;q=l+4|0;r=l;if(h){h=c[153134]|0;if(e){c[n>>2]=h;c[m+0>>2]=c[n+0>>2];s=0;t=e;u=hOb(0,e<<2,4,m,0,3653512,370)|0;v=0;while(1){w=c[b+(v<<2)>>2]|0;if(!(mo[c[(c[w>>2]|0)+136>>2]&4095](w)|0))JVd(w);do if(mo[c[(c[w>>2]|0)+136>>2]&4095](w)|0){if(((c[w+48>>2]|0)==2?(a[(c[w+84>>2]|0)+172>>0]|0)==0:0)?(a[w+44>>0]|0)==0:0){x=t;y=s;z=u;break}A=s+1|0;B=t&2147483647;do if(A>>>0>B>>>0?(C=t<<1,D=(C|0)==0?1:C,B>>>0<D>>>0):0)if((t|0)>-1){c[n>>2]=h;c[m+0>>2]=c[n+0>>2];E=hOb(u,D<<2,4,m,0,3653512,370)|0;F=D;break}else{c[n>>2]=h;c[m+0>>2]=c[n+0>>2];C=cOb(D<<2,4,m,0,3653512,352)|0;YEi(C|0,u|0,A<<2|0)|0;E=C;F=D;break}else{E=u;F=t}while(0);c[E+(s<<2)>>2]=w;x=F;y=A;z=E}else{x=t;y=s;z=u}while(0);v=v+1|0;if(v>>>0>=e>>>0){G=x;H=y;I=z;break}else{s=y;t=x;u=z}}z=(H|0)==0;if(!z){u=0;do{x=c[I+(u<<2)>>2]|0;if((c[x+52>>2]|0)==2?oVb()|0:0)J=k;else J=f;t=x+456|0;y=c[t>>2]|0;s=x+348|0;K=ea(g[s>>2]);if((y|0)==2&K<ea(0.0)){L=ea(VXd(x+416|0));TVd(x,ea(L+ea(J*ea(g[s>>2]))));M=c[t>>2]|0}else{L=ea(J*K);g[(c[x+76>>2]|0)+4>>2]=L;M=y}if((M|0)==2){if(ea(g[s>>2])<ea(0.0))N=28}else if((M|0)==1)N=28;if((N|0)==28){N=0;s=x+460|0;L=ea(g[s>>2]);g[(c[x+76>>2]|0)+4>>2]=L;g[s>>2]=ea(0.0)}s=x+84|0;y=c[s>>2]|0;t=(c[y>>2]|0)+y|0;v=y+4|0;c[v>>2]=t;E=t+48|0;if(!((c[E>>2]|0)!=0|J==ea(0.0))){c[v>>2]=t;c[E>>2]=1}E=c[x+76>>2]|0;a[E+22>>0]=a[x+345>>0]|0;a[E+23>>0]=a[x+346>>0]|0;E=x+120|0;if(!(c[E>>2]|0))O=y;else{Gnd(E);O=c[s>>2]|0}a[O+173>>0]=0;u=u+1|0}while(u>>>0<H>>>0);if(!z){u=0;do{O=c[I+(u<<2)>>2]|0;if(!(a[O+388>>0]|0)){gYd(p,O+32|0);N=c[O+76>>2]|0;c[N+24>>2]=p;FYd(c[O+72>>2]|0,N,c[O+80>>2]|0,c[O+84>>2]|0,c[O+88>>2]|0,c[O+92>>2]|0,c[(c[O+108>>2]|0)+36>>2]|0)}u=u+1|0}while(u>>>0<H>>>0);if(!z){u=0;do{p=c[I+(u<<2)>>2]|0;if(mo[c[(c[p>>2]|0)+136>>2]&4095](p)|0)UVd(p);u=u+1|0}while(u>>>0<H>>>0);P=G;Q=H;R=I;S=z}else{P=G;Q=0;R=I;S=1}}else{P=G;Q=0;R=I;S=1}}else{P=G;Q=0;R=I;S=1}}else{P=0;Q=0;R=0;S=1}I=SQb()|0;RQb(1);if(!S){G=0;do{z=c[R+(G<<2)>>2]|0;if(mo[c[(c[z>>2]|0)+136>>2]&4095](z)|0)OVd(z);if(mo[c[(c[z>>2]|0)+136>>2]&4095](z)|0)PVd(z,7)|0;G=G+1|0}while(G>>>0<Q>>>0);RQb(I);if(!S){S=0;do{G=c[R+(S<<2)>>2]|0;if(mo[c[(c[G>>2]|0)+136>>2]&4095](G)|0?(QVd(G),z=c[G+84>>2]|0,G=(c[z>>2]|0)+z|0,H=z+4|0,c[H>>2]=G,z=G+48|0,(c[z>>2]|0)==1):0){c[H>>2]=G;c[z>>2]=2}S=S+1|0}while(S>>>0<Q>>>0)}}else RQb(I);if((P|0)>-1){c[n>>2]=h;c[m+0>>2]=c[n+0>>2];eOb(R,m)}}if(!j){i=l;return}j=c[153134]|0;if(e){R=e<<2;c[n>>2]=j;c[m+0>>2]=c[n+0>>2];h=hOb(0,R,4,m,0,3653512,370)|0;P=c[153134]|0;c[n>>2]=P;c[m+0>>2]=c[n+0>>2];I=0;Q=h;h=0;S=e;z=hOb(0,R,4,m,0,3653512,370)|0;R=0;G=e;H=0;while(1){u=c[b+(R<<2)>>2]|0;if(!(mo[c[(c[u>>2]|0)+136>>2]&4095](u)|0))JVd(u);if(mo[c[(c[u>>2]|0)+136>>2]&4095](u)|0?(a[u+44>>0]|0)!=0:0){if(mo[c[(c[u>>2]|0)+136>>2]&4095](u)|0)T=c[c[u+92>>2]>>2]|0;else T=0;if((T|0)>(H|0))if(mo[c[(c[u>>2]|0)+136>>2]&4095](u)|0)U=c[c[u+92>>2]>>2]|0;else U=0;else U=H;p=I+1|0;O=G&2147483647;do if(p>>>0>O>>>0?(N=G<<1,M=(N|0)==0?1:N,O>>>0<M>>>0):0)if((G|0)>-1){c[n>>2]=j;c[m+0>>2]=c[n+0>>2];V=hOb(Q,M<<2,4,m,0,3653512,370)|0;W=M;break}else{c[n>>2]=j;c[m+0>>2]=c[n+0>>2];N=cOb(M<<2,4,m,0,3653512,352)|0;YEi(N|0,Q|0,p<<2|0)|0;V=N;W=M;break}else{V=Q;W=G}while(0);c[V+(I<<2)>>2]=u;if(RVd(u)|0){O=h+1|0;M=S&2147483647;do if(O>>>0>M>>>0?(N=S<<1,s=(N|0)==0?1:N,M>>>0<s>>>0):0)if((S|0)>-1){c[n>>2]=P;c[m+0>>2]=c[n+0>>2];X=hOb(z,s<<2,4,m,0,3653512,370)|0;Y=s;break}else{c[n>>2]=P;c[m+0>>2]=c[n+0>>2];N=cOb(s<<2,4,m,0,3653512,352)|0;YEi(N|0,z|0,O<<2|0)|0;X=N;Y=s;break}else{X=z;Y=S}while(0);c[X+(h<<2)>>2]=u;M=c[(c[u+88>>2]|0)+24>>2]|0;a[M+88>>0]=1;a[M+89>>0]=1;Z=M;_=Y;$=O;aa=X}else{Z=c[(c[u+88>>2]|0)+24>>2]|0;_=S;$=h;aa=z}a[Z+90>>0]=1;ba=p;ca=V;da=_;fa=$;ga=aa;ha=W;ia=U}else{ba=I;ca=Q;da=S;fa=h;ga=z;ha=G;ia=H}R=R+1|0;if(R>>>0>=e>>>0){ja=ba;ka=ca;la=da;ma=fa;na=ga;oa=ha;pa=ia;break}else{I=ba;Q=ca;h=fa;S=da;z=ga;G=ha;H=ia}}ia=(ma|0)==0;if(!ia){H=0;do{ha=c[na+(H<<2)>>2]|0;if(mo[c[(c[ha>>2]|0)+136>>2]&4095](ha)|0)TYd(c[ha+72>>2]|0,c[ha+76>>2]|0,c[ha+80>>2]|0,c[ha+84>>2]|0,c[ha+88>>2]|0,c[ha+92>>2]|0);H=H+1|0}while(H>>>0<ma>>>0);if(!ia){H=0;do{ha=c[na+(H<<2)>>2]|0;if(mo[c[(c[ha>>2]|0)+136>>2]&4095](ha)|0?(G=ha+88|0,ga=c[G>>2]|0,z=c[ga+24>>2]|0,(a[z+89>>0]|0)!=0):0){da=ha+72|0;S=ha+76|0;fa=ha+80|0;h=ha+84|0;ca=ha+92|0;UYd(c[da>>2]|0,c[S>>2]|0,c[fa>>2]|0,c[h>>2]|0,ga,c[ca>>2]|0,(a[z+88>>0]|0)!=0);VYd(c[da>>2]|0,c[S>>2]|0,c[fa>>2]|0,c[h>>2]|0,c[G>>2]|0,c[ca>>2]|0)}H=H+1|0}while(H>>>0<ma>>>0);if(!ia){H=0;do{ca=c[na+(H<<2)>>2]|0;if(mo[c[(c[ca>>2]|0)+136>>2]&4095](ca)|0)WVd(ca);H=H+1|0}while(H>>>0<ma>>>0);qa=ma;ra=ia}else{qa=0;ra=1}}else{qa=0;ra=1}}else{qa=0;ra=1}if((pa|0)>0){ia=n+8|0;ma=n+4|0;H=0;do{if(!ra){ca=0;do{G=c[na+(ca<<2)>>2]|0;if(mo[c[(c[G>>2]|0)+136>>2]&4095](G)|0){h=c[G+92>>2]|0;if((c[h>>2]|0)>(H|0)?(fa=h+4|0,h=(c[fa>>2]|0)+fa+(H<<3)|0,(a[h+(c[h>>2]|0)+36>>0]|0)!=0):0){if(c[(c[G+24>>2]|0)+52>>2]&128){c[ia>>2]=0;c[ma>>2]=H;c[n>>2]=1e5;cUb(G,555344,n)}h=SQb()|0;RQb(1);PVd(G,16)|0;RQb(h);sa=1}else sa=0;h=c[(c[G+88>>2]|0)+24>>2]|0;a[h+88>>0]=0;a[h+89>>0]=sa;a[h+90>>0]=sa}ca=ca+1|0}while(ca>>>0<qa>>>0);if(!ra){ca=0;do{p=c[na+(ca<<2)>>2]|0;if(mo[c[(c[p>>2]|0)+136>>2]&4095](p)|0?(u=p+88|0,O=c[u>>2]|0,h=c[O+24>>2]|0,(a[h+89>>0]|0)!=0):0){G=p+72|0;fa=p+76|0;S=p+80|0;da=p+84|0;z=p+92|0;UYd(c[G>>2]|0,c[fa>>2]|0,c[S>>2]|0,c[da>>2]|0,O,c[z>>2]|0,(a[h+88>>0]|0)!=0);VYd(c[G>>2]|0,c[fa>>2]|0,c[S>>2]|0,c[da>>2]|0,c[u>>2]|0,c[z>>2]|0)}ca=ca+1|0}while(ca>>>0<qa>>>0);if(!ra){ca=0;do{z=c[na+(ca<<2)>>2]|0;if(mo[c[(c[z>>2]|0)+136>>2]&4095](z)|0)WVd(z);ca=ca+1|0}while(ca>>>0<qa>>>0)}}}H=H+1|0}while((H|0)<(pa|0))}pa=(ja|0)==0;if(pa){ta=ka;ua=la;va=na;wa=0;xa=P;ya=1;za=oa}else{H=0;do{qa=c[ka+(H<<2)>>2]|0;if(mo[c[(c[qa>>2]|0)+136>>2]&4095](qa)|0)WVd(qa);H=H+1|0}while(H>>>0<ja>>>0);ta=ka;ua=la;va=na;wa=ja;xa=P;ya=pa;za=oa}}else{ta=0;ua=0;va=0;wa=0;xa=j;ya=1;za=0}oa=SQb()|0;RQb(1);if(!ya){ya=f==ea(0.0)&1;pa=0;do{P=c[ta+(pa<<2)>>2]|0;ja=P+24|0;na=c[ja>>2]|0;if((na|0)!=0?vTb(na)|0:0){if(!(a[P+469>>0]|0)){c[r>>2]=0;na=SVd(P,r)|0;if((na|0)!=0?(la=c[P+72>>2]|0,(la|0)!=0):0)hUd(c[P+104>>2]|0,na,la)}else{la=BTb(c[ja>>2]|0)|0;fUd(la,c[P+100>>2]|0,c[P+104>>2]|0)}la=P+100|0;ja=P+80|0;eUd(c[la>>2]|0,c[c[ja>>2]>>2]|0);dUd(c[la>>2]|0,c[c[ja>>2]>>2]|0);if((c[P+52>>2]|0)==2?oVb()|0:0)Aa=k;else Aa=f;if((c[P+456>>2]|0)==2?(J=ea(g[P+348>>2]),J>=ea(0.0)):0){L=ea(Aa*J);UXd(P+416|0,L,c[P+84>>2]|0)}ja=(c[P+84>>2]|0)+172|0;a[ja>>0]=d[ja>>0]&ya}pa=pa+1|0}while(pa>>>0<wa>>>0)}RQb(oa);if((ua|0)>-1){c[o>>2]=xa;c[m+0>>2]=c[o+0>>2];eOb(va,m)}if((za|0)<=-1){i=l;return}c[q>>2]=j;c[m+0>>2]=c[q+0>>2];eOb(ta,m);i=l;return}function OVd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im;d=i;i=i+48|0;e=d+8|0;f=d;if(!(a[b+353>>0]|0)){i=d;return}if(!(c[b+480>>2]|0))ZVd(b);h=b+88|0;if(!(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0)){i=d;return}j=b+472|0;k=e+8|0;l=f+4|0;m=0;while(1){n=c[(c[h>>2]|0)+24>>2]|0;if((m|0)>=(c[n+56>>2]|0)){o=18;break}p=c[n+60>>2]|0;n=c[(c[j>>2]|0)+(c[p+(m<<5)>>2]<<2)>>2]|0;if(RUd(n)|0){c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;q=c[p+(m<<5)+4>>2]|0;r=c[p+(m<<5)+24>>2]|0;jWd(b,q,0,e)|0;if((c[k>>2]|0)!=(r|0)?(jWd(b,q,1,e)|0,(c[k>>2]|0)!=(r|0)):0)jWd(b,q,2,e)|0;c[f>>2]=0;g[l>>2]=ea(0.0);if(!n)s=0;else s=c[n+4>>2]|0;c[f>>2]=s;g[l>>2]=ea(g[p+(m<<5)+8>>2]);if(ea(g[p+(m<<5)+20>>2])<ea(0.0)){t=p+(m<<5)+16|0;u=p+(m<<5)+12|0}else{t=p+(m<<5)+12|0;u=p+(m<<5)+16|0}v=ea(g[t>>2]);w=ea(g[u>>2]);SUd(n,v,w,b,e,f,(a[p+(m<<5)+28>>0]|0)!=0)}if(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0)m=m+1|0;else{o=18;break}}if((o|0)==18){i=d;return}}function PVd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+80|0;e=d+56|0;f=d+28|0;g=d;if(!(c[a+380>>2]|0)){h=0;i=d;return h|0}j=c[a+84>>2]|0;k=(c[j>>2]|0)+j|0;c[j+4>>2]=k;if(!(c[k+48>>2]|0)){h=0;i=d;return h|0}gYd(e,a+32|0);k=a+92|0;j=c[k>>2]|0;if(!(c[j+12>>2]|0)){h=0;i=d;return h|0}l=a+88|0;m=g+8|0;n=f+8|0;o=j;j=0;p=0;while(1){q=c[(c[(c[(c[l>>2]|0)+24>>2]|0)+4>>2]|0)+(j<<2)>>2]|0;if(!(c[o>>2]|0)){r=o;s=p}else{t=q+20|0;u=q+44|0;v=q+40|0;w=q+16|0;q=o;x=0;y=p;while(1){z=q+4|0;A=(c[z>>2]|0)+z+(x<<3)|0;do if((c[A+(c[A>>2]|0)>>2]|0)==(j|0)){z=c[t>>2]&b;do if(!z)B=y;else{c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;C=c[w>>2]|0;jWd(a,x,0,f)|0;if(((c[n>>2]|0)!=(C|0)?(jWd(a,x,1,f)|0,(c[n>>2]|0)!=(C|0)):0)?(jWd(a,x,2,f)|0,(c[n>>2]|0)!=(C|0)):0){B=y;break}B=y|(jYd(e,f,x,z)|0)}while(0);z=c[u>>2]&b;if(!z)D=B;else{c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;C=c[v>>2]|0;jWd(a,x,0,g)|0;if(((c[m>>2]|0)!=(C|0)?(jWd(a,x,1,g)|0,(c[m>>2]|0)!=(C|0)):0)?(jWd(a,x,2,g)|0,(c[m>>2]|0)!=(C|0)):0){D=B;break}D=B|(jYd(e,g,x,z)|0)}}else D=y;while(0);x=x+1|0;A=c[k>>2]|0;if(x>>>0>=(c[A>>2]|0)>>>0){r=A;s=D;break}else{q=A;y=D}}}j=j+1|0;if(j>>>0>=(c[r+12>>2]|0)>>>0){h=s;break}else{o=r;p=s}}i=d;return h|0}function QVd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0;d=i;i=i+80|0;e=d+60|0;f=d+48|0;h=d+32|0;j=d+16|0;k=d;l=b+24|0;m=BTb(c[l>>2]|0)|0;n=c[b+456>>2]|0;if((n|0)==1)o=14;else if((n|0)==2?ea(g[b+348>>2])<ea(0.0):0)o=14;if((o|0)==14){o=b+345|0;if(!(a[o>>0]|0))p=0;else{n=c[b+84>>2]|0;if(!n){g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+8>>2]=ea(0.0);q=ea(1.0);r=ea(0.0);s=ea(0.0);t=ea(0.0)}else{u=ea(g[n+8>>2]);v=ea(g[n+12>>2]);w=ea(g[n+16>>2]);g[j>>2]=u;g[j+4>>2]=v;g[j+8>>2]=w;w=ea(g[n+24>>2]);v=ea(w*w);u=ea(g[n+28>>2]);x=ea(u*u);y=ea(g[n+32>>2]);z=ea(y*y);A=ea(g[n+36>>2]);B=ea(ea(1.0)/ea(T(ea(ea(v+x)+ea(z+ea(A*A))))));q=ea(A*B);r=ea(y*B);s=ea(u*B);t=ea(w*B)}g[k>>2]=t;g[k+4>>2]=s;g[k+8>>2]=r;g[k+12>>2]=q;BGc(m,j,k);p=(a[o>>0]|0)!=0}k=b+100|0;if(!(iUd(c[k>>2]|0,p)|0)){i=d;return}jUd(c[k>>2]|0,c[c[b+80>>2]>>2]|0,m,(a[o>>0]|0)!=0);i=d;return}if(!(c[(c[l>>2]|0)+52>>2]&64))C=0;else{c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;cUb(b,555256,e);C=1}e=SQb()|0;RQb(1);l=((PVd(b,8)|0)&1|C|0)==0;RQb(e);if(l){l=b+345|0;if(!(a[l>>0]|0))D=0;else{YVd(b);D=(a[l>>0]|0)!=0}e=b+100|0;if(iUd(c[e>>2]|0,D)|0)jUd(c[e>>2]|0,c[c[b+80>>2]>>2]|0,m,(a[l>>0]|0)!=0)}rGc(f,m);l=b+84|0;b=c[l>>2]|0;if(b){q=ea(g[f>>2]);r=ea(g[f+4>>2]);s=ea(g[f+8>>2]);g[b+8>>2]=q;g[b+12>>2]=r;g[b+16>>2]=s;g[b+20>>2]=ea(0.0)}oGc(h,m);m=c[l>>2]|0;if(!m){i=d;return}s=ea(g[h>>2]);r=ea(g[h+4>>2]);q=ea(g[h+8>>2]);t=ea(g[h+12>>2]);g[m+24>>2]=s;g[m+28>>2]=r;g[m+32>>2]=q;g[m+36>>2]=t;i=d;return}function RVd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+56|0;a=c[g>>2]|0;if(!a){h=0;i=b;return h|0}c[f>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,f);j=c[d>>2]|0;k=c[a+28>>2]|0;if((j|0)==-1){l=k+(c[a+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((l|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0)m=a;else n=10}else n=10;do if((n|0)==10)if(!(hQb(c[g>>2]|0)|0)){h=0;i=b;return h|0}else{m=c[137784]|0;break}while(0);c[e>>2]=c[g>>2];if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(d,m,e);a=c[d>>2]|0;l=c[m+28>>2]|0;if((a|0)==-1){o=l+(c[m+32>>2]<<3)|0;break}else{o=l+(a<<3)|0;break}}else o=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((o|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[o+4>>2]|0,(m|0)!=0):0)p=m;else n=20}else n=20;if((n|0)==20)p=hQb(c[g>>2]|0)|0;h=YUd(p)|0;i=b;return h|0}function SVd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im;e=i;i=i+16|0;f=e;h=c[(c[b+80>>2]|0)+4>>2]|0;if(!h){c[d>>2]=0;j=0;i=e;return j|0}k=c[b+72>>2]|0;l=b+84|0;if(!(a[(c[l>>2]|0)+173>>0]|0)){b=c[153134]|0;c[f>>2]=678584;c[f+4>>2]=b;b=k;m=(c[k>>2]|0)+b|0;n=k+4|0;c[n>>2]=m;o=q$d(m,f)|0;f=k+16|0;m=(c[f>>2]|0)+f|0;c[k+20>>2]=m;s$d(m,o);m=o+4|0;f=(c[m>>2]|0)+m|0;c[o+8>>2]=f;m=c[l>>2]|0;p=ea(g[m+8>>2]);q=ea(g[m+12>>2]);r=ea(g[m+16>>2]);s=ea(g[m+20>>2]);g[f>>2]=p;g[f+4>>2]=q;g[f+8>>2]=r;g[f+12>>2]=s;s=ea(g[m+24>>2]);r=ea(g[m+28>>2]);q=ea(g[m+32>>2]);p=ea(g[m+36>>2]);g[f+16>>2]=s;g[f+20>>2]=r;g[f+24>>2]=q;g[f+28>>2]=p;p=ea(g[m+40>>2]);q=ea(g[m+44>>2]);r=ea(g[m+48>>2]);s=ea(g[m+52>>2]);g[f+32>>2]=p;g[f+36>>2]=q;g[f+40>>2]=r;g[f+44>>2]=s;f=(c[k>>2]|0)+b|0;c[n>>2]=f;x$d(f,o,o);c[d>>2]=o;j=o;i=e;return j|0}else{c[d>>2]=0;j=h;i=e;return j|0}return 0}function TVd(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;h=d+32|0;j=d+16|0;k=d;g[h>>2]=ea(0.0);l=TXd(a+416|0,b,h)|0;if(!l){g[a+460>>2]=ea(0.0);g[a+464>>2]=ea(0.0);i=d;return}m=a+84|0;n=c[m>>2]|0;o=a+112|0;if(n)if(!(c[o>>2]|0)){p=a+64|0;c[m>>2]=CWd(n,p,o)|0;tYd(n,p);q=c[m>>2]|0}else q=n;else q=0;n=a+464|0;g[n>>2]=b;p=c[o>>2]|0;c[j>>2]=697072;c[j+4>>2]=q;c[j+8>>2]=q;c[j+12>>2]=p;p=CWd(l,j,o)|0;if(!p){tYd(c[m>>2]|0,a+64|0);j=c[o>>2]|0;c[f>>2]=c[a+68>>2];c[e+0>>2]=c[f+0>>2];f=cOb(j,4,e,0,3653512,395)|0;e=c[o>>2]|0;c[k>>2]=697072;c[k+4>>2]=f;c[k+8>>2]=f;c[k+12>>2]=e;e=CWd(l,k,o)|0;c[m>>2]=e;if(!e){g[a+460>>2]=ea(0.0);g[n>>2]=ea(0.0);i=d;return}}else c[m>>2]=p;g[a+460>>2]=ea(b-ea(g[h>>2]));i=d;return}function UVd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;h=d+16|0;j=d;k=b+200|0;c[k+0>>2]=c[150284];c[k+4>>2]=c[150285];c[k+8>>2]=c[150286];k=b+212|0;g[k>>2]=ea(0.0);l=b+216|0;g[l>>2]=ea(0.0);m=b+220|0;g[m>>2]=ea(0.0);n=b+224|0;g[n>>2]=ea(1.0);o=b+228|0;c[o+0>>2]=c[150284];c[o+4>>2]=c[150285];c[o+8>>2]=c[150286];o=b+240|0;c[o+0>>2]=c[150284];c[o+4>>2]=c[150285];c[o+8>>2]=c[150286];if(!(a[b+388>>0]|0)){p=b+80|0;q=b+84|0;r=b+88|0;s=b+72|0;t=b+76|0}else{o=b+72|0;u=b+76|0;v=b+80|0;w=b+84|0;x=b+88|0;FYd(c[o>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0,c[b+92>>2]|0,c[(c[b+108>>2]|0)+36>>2]|0);p=v;q=w;r=x;s=o;t=u}RYd(c[(c[b+100>>2]|0)+32>>2]|0,c[t>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[b+96>>2]|0);u=c[s>>2]|0;o=u+36|0;x=c[o>>2]|0;if((x|0)!=0?(w=o+x|0,x=w+48|0,(c[(c[x>>2]|0)+x>>2]|0)!=0):0){x=c[(c[p>>2]|0)+8>>2]|0;y=ea(g[w+392>>2]);w=x+372|0;z=ea(y*ea(g[w>>2]));o=x+376|0;A=ea(y*ea(g[o>>2]));v=x+380|0;B=ea(y*ea(g[v>>2]));C=x+384|0;D=ea(y*ea(g[C>>2]));g[w>>2]=z;g[o>>2]=A;g[v>>2]=B;g[C>>2]=D;VVd(b);a[b+344>>0]=0;C=c[q>>2]|0;if(!C){E=ea(1.0);F=ea(0.0);G=ea(0.0);H=ea(0.0)}else{D=ea(g[C+24>>2]);B=ea(D*D);A=ea(g[C+28>>2]);z=ea(A*A);y=ea(g[C+32>>2]);I=ea(y*y);J=ea(g[C+36>>2]);K=ea(ea(1.0)/ea(T(ea(ea(B+z)+ea(I+ea(J*J))))));E=ea(J*K);F=ea(y*K);G=ea(A*K);H=ea(D*K)}gZd(e,c[(c[p>>2]|0)+8>>2]|0);C=c[q>>2]|0;K=ea(g[e>>2]);D=ea(K*ea(g[C+40>>2]));K=ea(g[e+4>>2]);A=ea(K*ea(g[C+44>>2]));K=ea(g[e+8>>2]);y=ea(K*ea(g[C+48>>2]));C=(c[s>>2]|0)+36|0;K=ea(g[C+(c[C>>2]|0)+392>>2]);J=ea(D*K);D=ea(A*K);A=ea(y*K);K=ea(H*ea(2.0));y=ea(G*ea(2.0));I=ea(F*ea(2.0));z=ea(H*K);B=ea(G*y);L=ea(F*I);F=ea(H*y);M=ea(H*I);H=ea(G*I);G=ea(K*E);K=ea(y*E);y=ea(E*I);I=ea(ea(ea(H-G)*A)+ea(ea(ea(F+y)*J)+ea(ea(ea(1.0)-ea(z+L))*D)));E=ea(ea(ea(ea(1.0)-ea(z+B))*A)+ea(ea(ea(M-K)*J)+ea(ea(H+G)*D)));g[b+200>>2]=ea(ea(ea(M+K)*A)+ea(ea(ea(F-y)*D)+ea(ea(ea(1.0)-ea(B+L))*J)));g[b+204>>2]=I;g[b+208>>2]=E;hZd(f,c[(c[p>>2]|0)+8>>2]|0);E=ea(g[f>>2]);I=ea(E*E);J=ea(g[f+4>>2]);L=ea(J*J);B=ea(g[f+8>>2]);D=ea(B*B);y=ea(g[f+12>>2]);F=ea(ea(1.0)/ea(T(ea(ea(I+L)+ea(D+ea(y*y))))));D=ea(J*F);J=ea(B*F);B=ea(y*F);g[k>>2]=ea(E*F);g[l>>2]=D;g[m>>2]=J;g[n>>2]=B;f=c[q>>2]|0;C=(f|0)==0;if(C){N=ea(1.0);O=ea(0.0);P=ea(0.0);Q=ea(0.0)}else{B=ea(g[f+24>>2]);J=ea(B*B);D=ea(g[f+28>>2]);F=ea(D*D);E=ea(g[f+32>>2]);y=ea(E*E);L=ea(g[f+36>>2]);I=ea(ea(1.0)/ea(T(ea(ea(J+F)+ea(y+ea(L*L))))));N=ea(L*I);O=ea(E*I);P=ea(D*I);Q=ea(B*I)}e=(c[p>>2]|0)+8|0;v=c[e>>2]|0;I=ea(g[v+4>>2]);B=ea(I*ea(g[f+40>>2]));I=ea(g[v+8>>2]);D=ea(I*ea(g[f+44>>2]));I=ea(g[v+12>>2]);E=ea(I*ea(g[f+48>>2]));v=c[s>>2]|0;o=v+36|0;I=ea(g[o+(c[o>>2]|0)+392>>2]);L=ea(B*I);B=ea(D*I);D=ea(E*I);I=ea(Q*ea(2.0));E=ea(P*ea(2.0));y=ea(O*ea(2.0));F=ea(Q*I);J=ea(P*E);A=ea(O*y);O=ea(Q*E);K=ea(Q*y);Q=ea(P*y);P=ea(I*N);I=ea(E*N);E=ea(N*y);y=ea(ea(ea(Q-P)*D)+ea(ea(ea(O+E)*L)+ea(ea(ea(1.0)-ea(F+A))*B)));N=ea(ea(ea(ea(1.0)-ea(F+J))*D)+ea(ea(ea(K-I)*L)+ea(ea(Q+P)*B)));g[b+228>>2]=ea(ea(ea(K+I)*D)+ea(ea(ea(O-E)*B)+ea(ea(ea(1.0)-ea(J+A))*L)));g[b+232>>2]=y;g[b+236>>2]=N;if(C){R=ea(1.0);S=ea(0.0);U=ea(0.0);V=ea(0.0)}else{N=ea(g[f+24>>2]);y=ea(N*N);L=ea(g[f+28>>2]);A=ea(L*L);J=ea(g[f+32>>2]);B=ea(J*J);E=ea(g[f+36>>2]);O=ea(ea(1.0)/ea(T(ea(ea(y+A)+ea(B+ea(E*E))))));R=ea(E*O);S=ea(J*O);U=ea(L*O);V=ea(N*O)}f=c[e>>2]|0;O=ea(g[f+20>>2]);N=ea(g[f+24>>2]);L=ea(g[f+28>>2]);J=ea(V*ea(2.0));E=ea(U*ea(2.0));B=ea(S*ea(2.0));A=ea(V*J);y=ea(U*E);D=ea(S*B);S=ea(V*E);I=ea(V*B);V=ea(U*B);U=ea(J*R);J=ea(E*R);E=ea(R*B);B=ea(ea(ea(ea(S+E)*O)+ea(ea(ea(1.0)-ea(A+D))*N))+ea(ea(V-U)*L));R=ea(ea(ea(ea(I-J)*O)+ea(ea(V+U)*N))+ea(ea(ea(1.0)-ea(A+y))*L));g[b+240>>2]=ea(ea(ea(I+J)*L)+ea(ea(O*ea(ea(1.0)-ea(y+D)))+ea(ea(S-E)*N)));g[b+244>>2]=B;g[b+248>>2]=R;W=v}else X=13;do if((X|0)==13){if((c[u+68>>2]|0)==-1?(a[(c[t>>2]|0)+22>>0]|0)==0:0){W=u;break}v=c[q>>2]|0;if(!v){Y=ea(1.0);Z=ea(0.0);_=ea(0.0);$=ea(0.0)}else{R=ea(g[v+24>>2]);B=ea(R*R);N=ea(g[v+28>>2]);E=ea(N*N);S=ea(g[v+32>>2]);D=ea(S*S);y=ea(g[v+36>>2]);O=ea(ea(1.0)/ea(T(ea(ea(B+E)+ea(D+ea(y*y))))));Y=ea(y*O);Z=ea(S*O);_=ea(N*O);$=ea(R*O)}gZd(h,c[(c[p>>2]|0)+8>>2]|0);v=c[q>>2]|0;O=ea(g[h>>2]);R=ea(O*ea(g[v+40>>2]));O=ea(g[h+4>>2]);N=ea(O*ea(g[v+44>>2]));O=ea(g[h+8>>2]);S=ea(O*ea(g[v+48>>2]));O=ea($*ea(2.0));y=ea(_*ea(2.0));D=ea(Z*ea(2.0));E=ea($*O);B=ea(_*y);L=ea(Z*D);J=ea($*y);I=ea($*D);A=ea(_*D);U=ea(O*Y);O=ea(y*Y);y=ea(Y*D);D=ea(ea(ea(ea(J+y)*R)+ea(ea(ea(1.0)-ea(E+L))*N))+ea(ea(A-U)*S));V=ea(ea(ea(ea(I-O)*R)+ea(ea(A+U)*N))+ea(ea(ea(1.0)-ea(E+B))*S));g[b+200>>2]=ea(ea(ea(ea(ea(1.0)-ea(B+L))*R)+ea(ea(J-y)*N))+ea(ea(I+O)*S));g[b+204>>2]=D;g[b+208>>2]=V;hZd(j,c[(c[p>>2]|0)+8>>2]|0);V=ea(g[j>>2]);D=ea(V*V);S=ea(g[j+4>>2]);O=ea(S*S);I=ea(g[j+8>>2]);N=ea(I*I);y=ea(g[j+12>>2]);J=ea(ea(1.0)/ea(T(ea(ea(D+O)+ea(N+ea(y*y))))));N=ea(S*J);S=ea(I*J);I=ea(y*J);g[k>>2]=ea(V*J);g[l>>2]=N;g[m>>2]=S;g[n>>2]=I;v=c[q>>2]|0;f=(v|0)==0;if(f){aa=ea(1.0);ba=ea(0.0);ca=ea(0.0);da=ea(0.0)}else{I=ea(g[v+24>>2]);S=ea(I*I);N=ea(g[v+28>>2]);J=ea(N*N);V=ea(g[v+32>>2]);y=ea(V*V);O=ea(g[v+36>>2]);D=ea(ea(1.0)/ea(T(ea(ea(S+J)+ea(y+ea(O*O))))));aa=ea(O*D);ba=ea(V*D);ca=ea(N*D);da=ea(I*D)}e=(c[p>>2]|0)+8|0;C=c[e>>2]|0;D=ea(g[C+4>>2]);I=ea(D*ea(g[v+40>>2]));D=ea(g[C+8>>2]);N=ea(D*ea(g[v+44>>2]));D=ea(g[C+12>>2]);V=ea(D*ea(g[v+48>>2]));D=ea(da*ea(2.0));O=ea(ca*ea(2.0));y=ea(ba*ea(2.0));J=ea(da*D);S=ea(ca*O);R=ea(ba*y);L=ea(da*O);B=ea(da*y);E=ea(ca*y);U=ea(D*aa);D=ea(O*aa);O=ea(aa*y);y=ea(ea(ea(ea(L+O)*I)+ea(ea(ea(1.0)-ea(J+R))*N))+ea(ea(E-U)*V));A=ea(ea(ea(ea(B-D)*I)+ea(ea(E+U)*N))+ea(ea(ea(1.0)-ea(J+S))*V));g[b+228>>2]=ea(ea(ea(ea(ea(1.0)-ea(S+R))*I)+ea(ea(L-O)*N))+ea(ea(B+D)*V));g[b+232>>2]=y;g[b+236>>2]=A;if(f){fa=ea(1.0);ga=ea(0.0);ha=ea(0.0);ia=ea(0.0)}else{A=ea(g[v+24>>2]);y=ea(A*A);V=ea(g[v+28>>2]);D=ea(V*V);B=ea(g[v+32>>2]);N=ea(B*B);O=ea(g[v+36>>2]);L=ea(ea(1.0)/ea(T(ea(ea(y+D)+ea(N+ea(O*O))))));fa=ea(O*L);ga=ea(B*L);ha=ea(V*L);ia=ea(A*L)}v=c[e>>2]|0;L=ea(g[v+20>>2]);A=ea(g[v+24>>2]);V=ea(g[v+28>>2]);B=ea(ia*ea(2.0));O=ea(ha*ea(2.0));N=ea(ga*ea(2.0));D=ea(ia*B);y=ea(ha*O);I=ea(ga*N);R=ea(ia*O);S=ea(ia*N);J=ea(ha*N);U=ea(B*fa);B=ea(O*fa);O=ea(fa*N);N=ea(ea(ea(ea(R+O)*L)+ea(ea(ea(1.0)-ea(D+I))*A))+ea(ea(J-U)*V));E=ea(ea(ea(ea(S-B)*L)+ea(ea(J+U)*A))+ea(ea(ea(1.0)-ea(D+y))*V));g[b+240>>2]=ea(ea(ea(S+B)*V)+ea(ea(L*ea(ea(1.0)-ea(y+I)))+ea(ea(R-O)*A)));g[b+244>>2]=N;g[b+248>>2]=E;W=c[s>>2]|0}while(0);n=W+36|0;m=c[n>>2]|0;if((m|0)!=0?(l=n+m+48|0,(c[(c[l>>2]|0)+l>>2]|0)!=0):0)X=26;else if((c[W+68>>2]|0)==-1?(a[(c[t>>2]|0)+22>>0]|0)==0:0){ja=m;ka=W}else X=26;if((X|0)==26){SYd(W,c[t>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0);r=c[s>>2]|0;ja=c[r+36>>2]|0;ka=r}if(!ja){i=d;return}r=ka+36+ja+48|0;if(!(c[(c[r>>2]|0)+r>>2]|0)){i=d;return}r=c[q>>2]|0;ja=(c[p>>2]|0)+8|0;p=c[ja>>2]|0;fa=ea(g[p+372>>2]);ha=ea(fa*ea(g[r+40>>2]));fa=ea(g[p+376>>2]);ia=ea(fa*ea(g[r+44>>2]));fa=ea(g[p+380>>2]);ga=ea(fa*ea(g[r+48>>2]));fa=ea(ha+ha);aa=ea(ia+ia);ca=ea(ga+ga);p=r+24|0;da=ea(g[p>>2]);ba=ea(aa*da);ka=r+28|0;Y=ea(g[ka>>2]);_=ea(ca*Y);t=r+32|0;$=ea(g[t>>2]);Z=ea(fa*$);W=r+36|0;E=ea(g[W>>2]);N=ea(ba-ea(fa*Y));fa=ea(_-ea(aa*$));aa=ea(Z-ea(da*ca));ca=ea(ea(ha+ea(E*fa))+ea(ea(Y*N)-ea($*aa)));ha=ea(ea(ia+ea(E*aa))+ea(ea($*fa)-ea(da*N)));$=ea(ea(ga+ea(N*E))+ea(ea(da*aa)-ea(Y*fa)));fa=ea(ea(g[r+8>>2])+ca);ca=ea(ea(g[r+12>>2])+ha);ha=ea(ea(g[r+16>>2])+$);g[b+264>>2]=fa;g[b+268>>2]=ca;g[b+272>>2]=ha;r=c[ja>>2]|0;ha=ea(g[ka>>2]);ca=ea(g[r+388>>2]);fa=ea(ha*ca);$=ea(g[W>>2]);Y=ea(g[r+400>>2]);aa=ea($*Y);da=ea(g[t>>2]);E=ea(g[r+392>>2]);N=ea(da*E);ga=ea(g[p>>2]);ia=ea(g[r+396>>2]);Z=ea(ea(ea(fa-ea($*ia))-ea(Y*da))-ea(E*ga));fa=ea(ea(ea(aa-ea(ca*ga))-ea(da*ia))-ea(ha*E));aa=ea(ea(ea(N-ea(ha*ia))-ea(ca*$))-ea(Y*ga));N=ea(ea(ea(ea(ga*ia)-ea(ca*da))-ea($*E))-ea(ha*Y));Y=ea(ea(1.0)/ea(T(ea(ea(ea(aa*aa)+ea(N*N))+ea(ea(fa*fa)+ea(Z*Z))))));ha=ea(Y*aa);aa=ea(Y*N);N=ea(Y*Z);Z=ea(Y*fa);fa=ea(ea(1.0)/ea(T(ea(ea(ea(ha*ha)+ea(aa*aa))+ea(ea(Z*Z)+ea(N*N))))));Y=ea(-ea(fa*aa));aa=ea(-ea(fa*N));N=ea(Z*fa);g[b+276>>2]=ea(-ea(fa*ha));g[b+280>>2]=Y;g[b+284>>2]=aa;g[b+288>>2]=N;r=c[q>>2]|0;q=(c[s>>2]|0)+36|0;N=ea(g[q+(c[q>>2]|0)+392>>2]);aa=ea(N*ea(g[r+152>>2]));Y=ea(N*ea(g[r+156>>2]));ha=ea(N*ea(g[r+160>>2]));N=ea(aa*ea(g[r+40>>2]));aa=ea(Y*ea(g[r+44>>2]));Y=ea(ha*ea(g[r+48>>2]));ha=ea(N+N);fa=ea(aa+aa);Z=ea(Y+Y);E=ea(g[r+24>>2]);$=ea(fa*E);da=ea(g[r+28>>2]);ca=ea(Z*da);ia=ea(g[r+32>>2]);ga=ea(ha*ia);_=ea(g[r+36>>2]);ba=ea($-ea(ha*da));ha=ea(ca-ea(fa*ia));fa=ea(ga-ea(E*Z));Z=ea(ea(N+ea(_*ha))+ea(ea(da*ba)-ea(ia*fa)));N=ea(ea(aa+ea(_*fa))+ea(ea(ia*ha)-ea(E*ba)));ia=ea(ea(Y+ea(ba*_))+ea(ea(E*fa)-ea(da*ha)));ha=ea(ea(g[r+8>>2])+Z);Z=ea(ea(g[r+12>>2])+N);N=ea(ea(g[r+16>>2])+ia);g[b+252>>2]=ha;g[b+256>>2]=Z;g[b+260>>2]=N;i=d;return}function VVd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im;d=i;i=i+304|0;e=d+64|0;f=d+160|0;h=d+208|0;j=d+256|0;l=d+48|0;m=d;n=d+112|0;o=b+292|0;do if(ea(g[o>>2])>=ea(0.0)){p=(c[b+92>>2]|0)+4|0;q=p+(c[p>>2]|0)|0;p=c[q+(c[q>>2]|0)>>2]|0;if(!((p|0)!=-1?(q=c[b+84>>2]|0,r=(c[q>>2]|0)+q|0,c[q+4>>2]=r,q=r+4|0,s=q+(c[q>>2]|0)|0,c[r+8>>2]=s,r=s+(p<<3)|0,q=r+(c[r>>2]|0)|0,c[s+(p<<3)+4>>2]=q,(a[q+73>>0]|0)!=0):0))t=4;if((t|0)==4?kWd(b)|0:0)break;a[b+344>>0]=1}while(0);if(!(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0)){i=d;return}if(!(ea(g[o>>2])>=ea(0.0))){i=d;return}q=b+84|0;p=c[q>>2]|0;u=ea(g[p+8>>2]);v=ea(g[p+12>>2]);w=ea(g[p+16>>2]);x=ea(g[p+20>>2]);g[e>>2]=u;s=e+4|0;g[s>>2]=v;r=e+8|0;g[r>>2]=w;y=e+12|0;g[y>>2]=x;x=ea(g[p+24>>2]);w=ea(g[p+28>>2]);v=ea(g[p+32>>2]);u=ea(g[p+36>>2]);z=e+16|0;g[z>>2]=x;A=e+20|0;g[A>>2]=w;B=e+24|0;g[B>>2]=v;C=e+28|0;g[C>>2]=u;u=ea(g[p+40>>2]);v=ea(g[p+44>>2]);w=ea(g[p+48>>2]);x=ea(g[p+52>>2]);p=e+32|0;g[p>>2]=u;D=e+36|0;g[D>>2]=v;E=e+40|0;g[E>>2]=w;F=e+44|0;g[F>>2]=x;G=(c[b+72>>2]|0)+36|0;x=ea(g[G+(c[G>>2]|0)+392>>2]);G=b+80|0;iZd(f,c[(c[G>>2]|0)+8>>2]|0);w=ea(g[f>>2]);v=ea(g[f+4>>2]);u=ea(g[f+8>>2]);H=ea(g[f+12>>2]);I=h+4|0;J=h+8|0;K=h+12|0;L=ea(g[f+16>>2]);M=ea(g[f+20>>2]);N=ea(g[f+24>>2]);O=ea(g[f+28>>2]);P=h+16|0;g[P>>2]=L;Q=h+20|0;g[Q>>2]=M;R=h+24|0;g[R>>2]=N;S=h+28|0;g[S>>2]=O;O=ea(g[f+32>>2]);N=ea(g[f+36>>2]);M=ea(g[f+40>>2]);L=ea(g[f+44>>2]);U=h+32|0;g[U>>2]=O;V=h+36|0;g[V>>2]=N;W=h+40|0;g[W>>2]=M;X=h+44|0;g[X>>2]=L;L=ea(x*v);v=ea(x*u);u=ea(x*H);g[h>>2]=ea(x*w);g[I>>2]=L;g[J>>2]=v;g[K>>2]=u;DWd(j,e,h);u=ea(g[j>>2]);v=ea(g[j+4>>2]);L=ea(g[j+8>>2]);w=ea(g[j+12>>2]);g[e>>2]=u;g[s>>2]=v;g[r>>2]=L;g[y>>2]=w;H=ea(g[j+16>>2]);M=ea(g[j+20>>2]);N=ea(g[j+24>>2]);O=ea(g[j+28>>2]);g[z>>2]=H;g[A>>2]=M;g[B>>2]=N;g[C>>2]=O;Y=ea(g[j+32>>2]);Z=ea(g[j+36>>2]);_=ea(g[j+40>>2]);$=ea(g[j+44>>2]);g[p>>2]=Y;g[D>>2]=Z;g[E>>2]=_;g[F>>2]=$;F=c[b+92>>2]|0;if(!(c[F>>2]|0)){aa=ea(1.0);ba=ea(0.0)}else{E=F+4|0;F=(c[E>>2]|0)+E|0;E=c[(c[F>>2]|0)+F>>2]|0;F=c[q>>2]|0;q=(c[F>>2]|0)+F|0;c[F+4>>2]=q;F=q+4|0;D=F+(c[F>>2]|0)|0;c[q+8>>2]=D;q=D+(E<<3)|0;F=q+(c[q>>2]|0)|0;c[D+(E<<3)+4>>2]=F;ca=ea(g[F+36>>2]);aa=ea(g[F+44>>2]);ba=ca}if(!(ba>=ea(g[o>>2]))){i=d;return}F=c[b+76>>2]|0;ca=ea(ea(g[F+12>>2])-ba);E=ca>ea(0.0);ba=E?ca:ea(0.0);if(ba!=ea(0.0))da=ea(ea(ea(g[F+4>>2])/aa)/ba);else da=ea(1.0);E=c[G>>2]|0;D=c[E+8>>2]|0;ba=ea(g[D+372>>2]);aa=ea(g[D+376>>2]);ca=ea(g[D+380>>2]);fa=ea(g[D+384>>2]);ga=ea(g[D+388>>2]);ha=ea(g[D+392>>2]);ia=ea(g[D+396>>2]);ja=ea(g[D+400>>2]);D=c[F+8>>2]|0;do if(!(a[b+344>>0]|0)){ka=ea(VDi(ea(1.0),ea(UDi(ea(0.0),da))));F=D+-2|0;if(F>>>0<4){la=F;ma=ha;na=ja;oa=ia;pa=ga;qa=ba;ra=aa;sa=ca;ta=fa;ua=ka;t=19}else{va=ba;wa=aa;xa=ca;ya=fa;za=ga;Aa=ja;Ba=ha;Ca=ia;Da=ka}}else{if((D|0)==1){F=c[E+16>>2]|0;ka=ea(g[F>>2]);Ea=ea(g[F+4>>2]);Fa=ea(g[F+8>>2]);Ga=ea(g[F+12>>2]);Ha=ea(g[F+16>>2]);Ia=ea(g[F+20>>2]);Ja=ea(g[F+24>>2]);va=ka;wa=Ea;xa=Fa;ya=Ga;za=Ha;Aa=ea(g[F+28>>2]);Ba=Ia;Ca=Ja;Da=ea(1.0);break}else if(!D){va=ea(0.0);wa=ea(0.0);xa=ea(0.0);ya=ea(0.0);za=ea(0.0);Aa=ea(1.0);Ba=ea(0.0);Ca=ea(0.0);Da=ea(1.0);break}F=D+-2|0;if(F>>>0<4){q=c[E+16>>2]|0;Ja=ea(g[q+(F*76|0)+80>>2]);Ia=ea(g[q+(F*76|0)+84>>2]);Ha=ea(g[q+(F*76|0)+88>>2]);Ga=ea(g[q+(F*76|0)+92>>2]);Fa=ea(g[q+(F*76|0)+96>>2]);Ea=ea(g[q+(F*76|0)+100>>2]);ka=ea(g[q+(F*76|0)+104>>2]);la=F;ma=Ea;na=ea(g[q+(F*76|0)+108>>2]);oa=ka;pa=Fa;qa=Ja;ra=Ia;sa=Ha;ta=Ga;ua=ea(1.0);t=19}else{va=ba;wa=aa;xa=ca;ya=fa;za=ga;Aa=ja;Ba=ha;Ca=ia;Da=ea(1.0)}}while(0);if((t|0)==19){W_d(l,la);ia=ea(g[l>>2]);ha=ea(ma*ia);ja=ea(g[l+12>>2]);ga=ea(na*ja);fa=ea(g[l+4>>2]);ca=ea(oa*fa);aa=ea(g[l+8>>2]);ba=ea(ea(ea(ha-ea(na*aa))-ea(oa*ja))-ea(pa*fa));ha=ea(ea(ea(ga-ea(pa*ia))-ea(oa*aa))-ea(ma*fa));ga=ea(ea(ea(ca-ea(ma*aa))-ea(na*ia))-ea(pa*ja));ca=ea(ea(ea(ea(pa*aa)-ea(oa*ia))-ea(na*fa))-ea(ma*ja));ja=ea(ea(1.0)/ea(T(ea(ea(ea(ga*ga)+ea(ca*ca))+ea(ea(ha*ha)+ea(ba*ba))))));va=qa;wa=ra;xa=sa;ya=ta;za=ea(-ea(ja*ga));Aa=ea(ja*ha);Ba=ea(-ea(ja*ca));Ca=ea(-ea(ja*ba));Da=ua}ua=ea(g[b+300>>2]);ba=ea(g[b+304>>2]);ja=ea(g[b+308>>2]);ca=ea(g[b+312>>2]);ha=ea(g[b+316>>2]);ga=ea(g[b+320>>2]);ta=ea(g[b+324>>2]);sa=ea(-H);H=ea(-M);M=ea(-N);N=ea(ua-u);u=ea(ba-v);v=ea(ja-L);L=ea(N+N);ja=ea(u+u);ba=ea(v+v);ua=ea(O*ea(0.0));ra=ea(ea(ja*sa)-ea(L*H));qa=ea(ea(ba*H)-ea(ja*M));ja=ea(ea(L*M)-ea(ba*sa));ba=ea(O*ea(ua-ua));ua=ea(ea(ea(N+ea(O*qa))+ea(ea(ra*H)-ea(ja*M)))/Y);Y=ea(ea(ea(u+ea(O*ja))+ea(ea(qa*M)-ea(ra*sa)))/Z);Z=ea(ea(ea(v+ea(O*ra))+ea(ea(ja*sa)-ea(qa*H)))/_);_=ea(ea(ea(ba-ba)+ea(ba+ea(ea(0.0)-w)))/$);$=ea(ea(ea(ea(ca*H)-ea(ga*O))-ea(ta*M))-ea(ha*sa));w=ea(ea(ea(ea(ta*O)-ea(ca*sa))-ea(ga*M))-ea(ha*H));ba=ea(ea(ea(ea(ha*M)-ea(ga*H))-ea(ca*O))-ea(ta*sa));qa=ea(ea(ea(ea(ga*sa)-ea(ca*M))-ea(ha*O))-ea(ta*H));H=ea(ea(1.0)/ea(T(ea(ea(ea(ba*ba)+ea(qa*qa))+ea(ea(w*w)+ea($*$))))));ta=ea(ba*H);ba=ea(qa*H);qa=ea($*H);$=ea(w*H);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;g[m+44>>2]=ea(1.0);g[m+40>>2]=ea(1.0);g[m+36>>2]=ea(1.0);g[m+32>>2]=ea(1.0);H=ea(ea(1.0)/x);x=ea(H*ea(ua-va));va=ea(H*ea(Y-wa));wa=ea(H*ea(Z-xa));xa=ea(H*ea(_-ya));ya=ea(ea(ea(Aa*qa)+ea(ea(za*ba)+ea(Ca*$)))-ea(Ba*ta));_=ea(ea(ea(ea(Aa*$)-ea(za*ta))-ea(Ca*qa))-ea(Ba*ba));H=ea(ea(Aa*ta)+ea(ea(za*$)+ea(ea(Ba*qa)-ea(Ca*ba))));Z=ea(ea(Aa*ba)+ea(ea(Ba*$)+ea(ea(Ca*ta)-ea(za*qa))));qa=ea(-H);za=ea(-Z);ta=ea(-ya);Ca=ea(Da*ea(g[b+328>>2]));$=ea(Da*ea(g[b+332>>2]));Ba=ea($*va);va=ea(ea(Da*ea(g[b+336>>2]))*wa);wa=ea(xa*ea(0.0));g[m>>2]=ea(Ca*x);g[m+4>>2]=Ba;g[m+8>>2]=va;g[m+12>>2]=wa;wa=ea(Da*ea(g[b+340>>2]));va=ea(ea(ea(H*ea(-0.0))+ea(Z*ea(-0.0)))+ea(ea(ya*ea(-0.0))+_));l=(g[k>>2]=qa,c[k>>2]|0);la=(g[k>>2]=va,c[k>>2]|0)&-2147483648;va=(c[k>>2]=la^l,ea(g[k>>2]));qa=(c[k>>2]=la^(g[k>>2]=za,c[k>>2]|0),ea(g[k>>2]));za=(c[k>>2]=la^(g[k>>2]=ta,c[k>>2]|0),ea(g[k>>2]));ta=ea(ea(wa*va)+ea(0.0));va=ea(ea(wa*qa)+ea(0.0));qa=ea(ea(wa*za)+ea(0.0));za=ea(ea(wa*ea((c[k>>2]=la^(g[k>>2]=_,c[k>>2]|0),ea(g[k>>2]))+ea(-1.0)))+ea(1.0));_=ea(ea(1.0)/ea(T(ea(ea(ea(ta*ta)+ea(va*va))+ea(ea(qa*qa)+ea(za*za))))));wa=ea(_*va);va=ea(_*qa);qa=ea(_*za);g[m+16>>2]=ea(_*ta);g[m+20>>2]=wa;g[m+24>>2]=va;g[m+28>>2]=qa;DWd(n,f,m);qa=ea(g[n>>2]);va=ea(g[n+4>>2]);wa=ea(g[n+8>>2]);ta=ea(g[n+12>>2]);g[h>>2]=qa;g[I>>2]=va;g[J>>2]=wa;g[K>>2]=ta;ta=ea(g[n+16>>2]);wa=ea(g[n+20>>2]);va=ea(g[n+24>>2]);qa=ea(g[n+28>>2]);g[P>>2]=ta;g[Q>>2]=wa;g[R>>2]=va;g[S>>2]=qa;qa=ea(g[n+32>>2]);va=ea(g[n+36>>2]);wa=ea(g[n+40>>2]);ta=ea(g[n+44>>2]);g[U>>2]=qa;g[V>>2]=va;g[W>>2]=wa;g[X>>2]=ta;kZd(c[(c[G>>2]|0)+8>>2]|0,h);if(!(Da>=ea(1.0))){i=d;return}g[o>>2]=ea(-1.0);c[b+296>>2]=-1;i=d;return}function WVd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im;d=i;e=(c[(c[b+88>>2]|0)+24>>2]|0)+90|0;if(!(a[e>>0]|0)){i=d;return}a[e>>0]=0;e=b+72|0;f=c[e>>2]|0;if(a[b+469>>0]|0){h=f+36|0;j=c[h>>2]|0;if((j|0)!=0?(k=j+h+48|0,(c[(c[k>>2]|0)+k>>2]|0)!=0):0)gUd(c[b+104>>2]|0,c[(c[b+80>>2]|0)+4>>2]|0);k=c[b+100>>2]|0;h=c[c[b+80>>2]>>2]|0;kUd(k,h,BTb(c[b+24>>2]|0)|0);i=d;return}h=(c[f>>2]|0)+f|0;if(!(c[h>>2]|0)){i=d;return}c[f+4>>2]=h;k=f+8|0;j=k+(c[k>>2]|0)|0;c[f+12>>2]=j;k=b+80|0;l=c[k>>2]|0;m=c[l>>2]|0;n=c[(c[(c[b+100>>2]|0)+32>>2]|0)+8>>2]|0;o=c[l+4>>2]|0;l=f+36|0;p=c[l>>2]|0;if((p|0)!=0?(q=l+p+48|0,(c[(c[q>>2]|0)+q>>2]|0)!=0):0){q=f+60|0;p=q+(c[q>>2]|0)|0;c[f+64>>2]=p;r=p}else r=0;WYd(h,j,m,n,o,r,1);r=c[e>>2]|0;e=r+36|0;o=c[e>>2]|0;if((o|0)!=0?(n=e+o+48|0,(c[(c[n>>2]|0)+n>>2]|0)!=0):0){s=b+84|0;t=c[(c[k>>2]|0)+4>>2]|0}else{n=c[(c[k>>2]|0)+4>>2]|0;k=n+4|0;o=k+(c[k>>2]|0)|0;c[n+8>>2]=o;k=b+84|0;b=c[k>>2]|0;u=ea(g[b+8>>2]);v=ea(g[b+12>>2]);w=ea(g[b+16>>2]);x=ea(g[b+20>>2]);g[o>>2]=u;g[o+4>>2]=v;g[o+8>>2]=w;g[o+12>>2]=x;x=ea(g[b+24>>2]);w=ea(g[b+28>>2]);v=ea(g[b+32>>2]);u=ea(g[b+36>>2]);g[o+16>>2]=x;g[o+20>>2]=w;g[o+24>>2]=v;g[o+28>>2]=u;u=ea(g[b+40>>2]);v=ea(g[b+44>>2]);w=ea(g[b+48>>2]);x=ea(g[b+52>>2]);g[o+32>>2]=u;g[o+36>>2]=v;g[o+40>>2]=w;g[o+44>>2]=x;s=k;t=n}n=(c[r>>2]|0)+r|0;c[r+4>>2]=n;x$d(n,t,t);a[(c[s>>2]|0)+173>>0]=1;i=d;return}function XVd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if(!a){i=b;return}e=c[153134]|0;c[d>>2]=678584;c[d+4>>2]=e;r$d(a,d);i=b;return}function YVd(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im;d=i;i=i+64|0;e=d+48|0;f=d+12|0;h=d;j=b+200|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=f+12|0;k=b+84|0;l=c[k>>2]|0;m=(l|0)==0;if(m){n=ea(1.0);o=ea(0.0);p=ea(0.0);q=ea(0.0)}else{r=ea(g[l+24>>2]);s=ea(r*r);t=ea(g[l+28>>2]);u=ea(t*t);v=ea(g[l+32>>2]);w=ea(v*v);x=ea(g[l+36>>2]);y=ea(ea(1.0)/ea(T(ea(ea(s+u)+ea(w+ea(x*x))))));n=ea(x*y);o=ea(v*y);p=ea(t*y);q=ea(r*y)}g[f+12>>2]=q;g[f+16>>2]=p;g[f+20>>2]=o;g[f+24>>2]=n;if((!m?(m=c[b+80>>2]|0,(m|0)!=0):0)?(l=c[m+8>>2]|0,(l|0)!=0):0)z=ea(g[l+420>>2]);else z=ea(0.0);g[f+28>>2]=z;l=f+32|0;a[l>>0]=0;c[e+8>>2]=0;c[e+4>>2]=f;c[e>>2]=100006;cUb(b,555296,e);if(a[l>>0]|0){i=d;return}l=BTb(c[b+24>>2]|0)|0;b=c[k>>2]|0;if(!b){A=ea(0.0);B=ea(0.0);C=ea(0.0)}else{z=ea(g[b+8>>2]);n=ea(g[b+12>>2]);A=ea(g[b+16>>2]);B=n;C=z}g[h>>2]=C;g[h+4>>2]=B;g[h+8>>2]=A;BGc(l,h,j);i=d;return}function ZVd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b+4|0;g=b;h=a+60|0;j=c[h>>2]|0;if(!j){i=b;return}c[g>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,g);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(c[m+4>>2]|0)!=0:0)n=j;else o=10}else o=10;do if((o|0)==10)if(!(hQb(c[h>>2]|0)|0)){i=b;return}else{n=c[137784]|0;break}while(0);c[f>>2]=c[h>>2];if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,f);j=c[d>>2]|0;m=c[n+28>>2]|0;if((j|0)==-1){p=m+(c[n+32>>2]<<3)|0;break}else{p=m+(j<<3)|0;break}}else p=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((p|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[p+4>>2]|0,(n|0)!=0):0)q=n;else o=20}else o=20;if((o|0)==20)q=hQb(c[h>>2]|0)|0;h=mo[c[(c[q>>2]|0)+100>>2]&4095](q)|0;q=a+472|0;n=h+8|0;p=c[n>>2]|0;f=a+480|0;c[f>>2]=p;j=a+484|0;m=c[j>>2]|0;do if((m&2147483647)>>>0<p>>>0)if((m|0)>-1){c[j>>2]=p;g=c[q>>2]|0;c[e>>2]=c[a+476>>2];c[d+0>>2]=c[e+0>>2];c[q>>2]=hOb(g,p<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+476>>2];c[d+0>>2]=c[e+0>>2];g=cOb(p<<2,4,d,0,3653512,352)|0;YEi(g|0,c[q>>2]|0,c[f>>2]<<2|0)|0;c[j>>2]=p;c[q>>2]=g;break}while(0);p=c[n>>2]|0;if(!p){i=b;return}j=p;p=0;while(1){f=(c[h>>2]|0)+(p<<2)|0;a=c[f>>2]|0;if(!a){r=0;s=j}else{c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);m=c[d>>2]|0;g=c[a+28>>2]|0;if((m|0)==-1){t=g+(c[a+32>>2]<<3)|0;break}else{t=g+(m<<3)|0;break}}else t=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((t|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[t+4>>2]|0,(a|0)!=0):0)u=a;else o=36}else o=36;if((o|0)==36){o=0;u=hQb(c[f>>2]|0)|0}r=u;s=c[n>>2]|0}c[(c[q>>2]|0)+(p<<2)>>2]=r;p=p+1|0;if(p>>>0>=s>>>0)break;else j=s}i=b;return}function _Vd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;j=a+372|0;k=c[j>>2]|0;l=a+380|0;if(!(c[l>>2]|0))m=k;else{n=k;do{k=c[n>>2]|0;do if(k){c[f>>2]=k;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(d,o,f);p=c[d>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(c[r+4>>2]|0)!=0:0)s=o;else t=12}else t=12;if((t|0)==12){t=0;if(!(hQb(k)|0))break;s=c[137784]|0}c[e>>2]=k;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(d,s,e);o=c[d>>2]|0;p=c[s+28>>2]|0;if((o|0)==-1){u=p+(c[s+32>>2]<<3)|0;break}else{u=p+(o<<3)|0;break}}else u=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);o=c[137784]|0;if((u|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[u+4>>2]|0,(o|0)!=0):0)v=o;else t=22}else t=22;if((t|0)==22){t=0;v=hQb(k)|0}o=m9c(v)|0;if((o|0)!=0?!(btc(o,c[(Xbd()|0)+592>>2]|0)|0):0){c[g>>2]=k;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(d,o,g);p=c[d>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){w=q+(c[o+32>>2]<<3)|0;break}else{w=q+(p<<3)|0;break}}else w=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((w|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[w+4>>2]|0,(o|0)!=0):0)x=o;else t=33}else t=33;if((t|0)==33){t=0;x=hQb(k)|0}lQc(x,0)}}while(0);n=n+4|0;k=c[j>>2]|0}while((n|0)!=(k+(c[l>>2]<<2)|0));m=k}n=a+384|0;if((c[n>>2]|0)<=-1){c[l>>2]=0;c[n>>2]=0;i=b;return}c[h>>2]=c[a+376>>2];c[d+0>>2]=c[h+0>>2];eOb(m,d);c[j>>2]=0;c[l>>2]=0;c[n>>2]=0;i=b;return}function $Vd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+32|0;e=d+8|0;f=d+20|0;g=d+24|0;h=d+28|0;j=d+4|0;k=d;l=d+16|0;m=b+372|0;n=b+60|0;c[l>>2]=c[n>>2];o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(e,o,l);p=c[e>>2]|0;q=c[o+28>>2]|0;if((p|0)==-1){r=q+(c[o+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((r|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[r+4>>2]|0,(o|0)!=0):0)s=o;else t=9}else t=9;if((t|0)==9)s=hQb(c[n>>2]|0)|0;o=mo[c[(c[s>>2]|0)+108>>2]&4095](s)|0;if((o|0)!=(m|0)){s=c[o>>2]|0;r=c[o+8>>2]<<2;o=r>>2;l=b+380|0;c[l>>2]=o;p=b+384|0;q=c[p>>2]|0;do if((q&2147483647)>>>0<o>>>0)if((q|0)>-1){c[p>>2]=o;u=c[m>>2]|0;c[f>>2]=c[b+376>>2];c[e+0>>2]=c[f+0>>2];v=hOb(u,r,4,e,0,3653512,370)|0;c[m>>2]=v;w=v;break}else{c[f>>2]=c[b+376>>2];c[e+0>>2]=c[f+0>>2];v=cOb(r,4,e,0,3653512,352)|0;YEi(v|0,c[m>>2]|0,c[l>>2]<<2|0)|0;c[p>>2]=o;c[m>>2]=v;w=v;break}else w=c[m>>2]|0;while(0);YEi(w|0,s|0,c[l>>2]<<2|0)|0}c[k>>2]=c[n>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,k);s=c[e>>2]|0;w=c[l+28>>2]|0;if((s|0)==-1){x=w+(c[l+32>>2]<<3)|0;break}else{x=w+(s<<3)|0;break}}else x=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((x|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[x+4>>2]|0,(l|0)!=0):0)y=l;else t=25}else t=25;if((t|0)==25)y=hQb(c[n>>2]|0)|0;a[b+388>>0]=(mo[c[(c[y>>2]|0)+116>>2]&4095](y)|0)&1;y=b+380|0;if(!(c[y>>2]|0)){i=d;return}b=c[m>>2]|0;do{n=c[b>>2]|0;do if(n){c[j>>2]=n;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,j);x=c[e>>2]|0;k=c[l+28>>2]|0;if((x|0)==-1){z=k+(c[l+32>>2]<<3)|0;break}else{z=k+(x<<3)|0;break}}else z=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((z|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(c[z+4>>2]|0)!=0:0)A=l;else t=37}else t=37;if((t|0)==37){t=0;if(!(hQb(n)|0))break;A=c[137784]|0}c[h>>2]=n;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(e,A,h);l=c[e>>2]|0;x=c[A+28>>2]|0;if((l|0)==-1){B=x+(c[A+32>>2]<<3)|0;break}else{B=x+(l<<3)|0;break}}else B=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);l=c[137784]|0;if((B|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[B+4>>2]|0,(l|0)!=0):0)C=l;else t=47}else t=47;if((t|0)==47){t=0;C=hQb(n)|0}l=m9c(C)|0;if((l|0)!=0?!(btc(l,c[(Xbd()|0)+592>>2]|0)|0):0){c[g>>2]=n;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,g);x=c[e>>2]|0;k=c[l+28>>2]|0;if((x|0)==-1){D=k+(c[l+32>>2]<<3)|0;break}else{D=k+(x<<3)|0;break}}else D=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((D|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[D+4>>2]|0,(l|0)!=0):0)E=l;else t=58}else t=58;if((t|0)==58){t=0;E=hQb(n)|0}l=vlc(E)|0;x=(da(c[137788]|0,(c[l+8>>2]|0)>>>21)|0)+114|0;k=x>>5;if(!(1<<x-(k<<5)&c[(c[137786]|0)+(k<<2)>>2]))F=0;else F=c[l+4>>2]|0;c[b>>2]=F;c[f>>2]=F;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,f);k=c[e>>2]|0;x=c[l+28>>2]|0;if((k|0)==-1){G=x+(c[l+32>>2]<<3)|0;break}else{G=x+(k<<3)|0;break}}else G=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((G|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[G+4>>2]|0,(l|0)!=0):0)H=l;else t=69}else t=69;if((t|0)==69){t=0;H=hQb(c[b>>2]|0)|0}In[c[(c[H>>2]|0)+44>>2]&4095](H,61)}}while(0);b=b+4|0}while((b|0)!=((c[m>>2]|0)+(c[y>>2]<<2)|0));i=d;return}function aWd(a){a=a|0;var b=0,d=0;b=c[a+84>>2]|0;if(!b)d=0;else d=(c[b>>2]|0)!=0;return d|0}function bWd(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+-32+84>>2]|0;if(!d){e=0;i=b;return e|0}e=(c[d>>2]|0)!=0;i=b;return e|0}function cWd(a){a=a|0;return (c[a+60>>2]|0)!=0|0}function dWd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+56|0;a=c[f>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0)l=a;else m=10}else m=10;if((m|0)==10)l=hQb(c[f>>2]|0)|0;g=l;i=b;return g|0}function eWd(a){a=a|0;var b=0;b=i;if(!(c[a+84>>2]|0))JVd(a);i=b;return c[a+72>>2]|0}function fWd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=0,m=0;e=i;i=i+16|0;f=e;h=b+44|0;if(d)j=(a[h>>0]|0)!=0;else j=1;a[h>>0]=d&1;if(j|(oVb()|0)^1){i=e;return}k=ea(g[(jLc()|0)+104>>2]);if((c[b+36>>2]|0)==-1)l=(c[b+40>>2]|0)==-1;else l=0;if(k==ea(0.0)|l){i=e;return}if(!(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0))JVd(b);if(!(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0)){i=e;return}c[f>>2]=b;l=c[b+84>>2]|0;if((c[b+48>>2]|0)==2)m=1;else m=(a[l+172>>0]|0)!=0;a[l+172>>0]=1;a[l+173>>0]=0;NVd(f,1,k,m,1,ea(0.0));i=e;return}function gWd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;if((d|0)==1){f=c[a+356>>2]|0;g=c[a+364>>2]|0;h=f+(g<<2)|0;a:do if(!g)j=0;else{k=f;while(1){if(dAc(c[k>>2]|0)|0){j=1;break a}k=k+4|0;if((k|0)==(h|0)){j=0;break}}}while(0);fWd(a,j);i=e;return}else if(!d){fWd(a,1);i=e;return}else if((d|0)==2){d=a+364|0;j=c[d>>2]|0;b:do if(j){h=a+356|0;f=c[h>>2]|0;g=0;while(1){k=f+(g<<2)|0;g=g+1|0;if((c[k>>2]|0)==(b|0)){l=k;m=11;break}if(g>>>0>=j>>>0){n=f;o=j;break}}if((m|0)==11){g=j+-1|0;c[l>>2]=c[f+(g<<2)>>2];c[d>>2]=g;n=c[h>>2]|0;o=g}g=n+(o<<2)|0;if(o){k=n;while(1){if(dAc(c[k>>2]|0)|0){p=1;break b}k=k+4|0;if((k|0)==(g|0)){p=0;break}}}else p=0}else p=0;while(0);fWd(a,p);i=e;return}else{i=e;return}}function hWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=CTb(c[b+24>>2]|0,25)|0;if(g){h=a+356|0;j=a+364|0;k=(c[j>>2]|0)+1|0;c[j>>2]=k;l=a+368|0;m=c[l>>2]|0;n=m&2147483647;if(k>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[l>>2]=p;o=c[h>>2]|0;c[f>>2]=c[a+360>>2];c[e+0>>2]=c[f+0>>2];c[h>>2]=hOb(o,p<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+360>>2];c[e+0>>2]=c[f+0>>2];o=cOb(p<<2,4,e,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,c[j>>2]<<2|0)|0;c[l>>2]=p;c[h>>2]=o;break}while(0);q=c[j>>2]|0}else q=k;c[(c[h>>2]|0)+(q+-1<<2)>>2]=g;LQb(g,1843,a)}g=c[b+140>>2]|0;q=c[b+148>>2]|0;b=g+(q<<2)|0;if(!q){i=d;return}else r=g;do{hWd(a,c[r>>2]|0);r=r+4|0}while((r|0)!=(b|0));i=d;return}function iWd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;l=BTb(c[b+24>>2]|0)|0;m=b+56|0;n=c[m>>2]|0;if(!n){i=d;return l|0}c[j>>2]=n;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(e,n,j);o=c[e>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(c[q+4>>2]|0)!=0:0)r=n;else s=10}else s=10;do if((s|0)==10)if(!(hQb(c[m>>2]|0)|0)){i=d;return l|0}else{r=c[137784]|0;break}while(0);c[h>>2]=c[m>>2];if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(e,r,h);n=c[e>>2]|0;q=c[r+28>>2]|0;if((n|0)==-1){t=q+(c[r+32>>2]<<3)|0;break}else{t=q+(n<<3)|0;break}}else t=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((t|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[t+4>>2]|0,(r|0)!=0):0)u=r;else s=20}else s=20;if((s|0)==20)u=hQb(c[m>>2]|0)|0;if(!(XUd(u)|0)){v=0;w=(v|0)==0;x=w?l:v;i=d;return x|0}c[g>>2]=c[m>>2];u=c[137784]|0;if(u){do if((c[u+36>>2]|0)!=(c[u+4>>2]|0)){fRb(e,u,g);r=c[e>>2]|0;t=c[u+28>>2]|0;if((r|0)==-1){y=t+(c[u+32>>2]<<3)|0;break}else{y=t+(r<<3)|0;break}}else y=(c[u+28>>2]|0)+(c[u+32>>2]<<3)|0;while(0);u=c[137784]|0;if((y|0)!=((c[u+28>>2]|0)+(c[u+32>>2]<<3)|0)?(u=c[y+4>>2]|0,(u|0)!=0):0)z=u;else s=30}else s=30;if((s|0)==30)z=hQb(c[m>>2]|0)|0;u=XUd(z)|0;z=(c[u>>2]|0)+u|0;c[u+4>>2]=z;if(!z){v=0;w=(v|0)==0;x=w?l:v;i=d;return x|0}c[f>>2]=c[m>>2];z=c[137784]|0;if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(e,z,f);u=c[e>>2]|0;y=c[z+28>>2]|0;if((u|0)==-1){A=y+(c[z+32>>2]<<3)|0;break}else{A=y+(u<<3)|0;break}}else A=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);z=c[137784]|0;if((A|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(z=c[A+4>>2]|0,(z|0)!=0):0)B=z;else s=40}else s=40;if((s|0)==40)B=hQb(c[m>>2]|0)|0;z=XUd(B)|0;B=(c[z>>2]|0)+z|0;c[z+4>>2]=B;c[k>>2]=c[m>>2];z=c[137784]|0;if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(e,z,k);A=c[e>>2]|0;f=c[z+28>>2]|0;if((A|0)==-1){C=f+(c[z+32>>2]<<3)|0;break}else{C=f+(A<<3)|0;break}}else C=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);z=c[137784]|0;if((C|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(z=c[C+4>>2]|0,(z|0)!=0):0)D=z;else s=49}else s=49;if((s|0)==49)D=hQb(c[m>>2]|0)|0;m=XUd(D)|0;D=m+28|0;s=D+(c[D>>2]|0)|0;c[m+32>>2]=s;v=$Xd(B,s,l,(a[b+469>>0]|0)!=0)|0;w=(v|0)==0;x=w?l:v;i=d;return x|0}function jWd(b,e,f,h){b=b|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im;j=i;if(!(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0)){k=0;i=j;return k|0}if((e|0)>=0){if(mo[c[(c[b>>2]|0)+136>>2]&4095](b)|0)l=c[c[b+92>>2]>>2]|0;else l=0;if((l|0)>(e|0)){l=c[b+92>>2]|0;m=l+4|0;n=m+(c[m>>2]|0)+(e<<3)|0;e=c[n+(c[n>>2]|0)>>2]|0;if((e|0)==-1){Krd(695224,0,3653512,3121,1,0,0,0);k=0;i=j;return k|0}n=l+16|0;l=(c[n>>2]|0)+n+(e<<3)|0;n=l+(c[l>>2]|0)|0;l=c[b+84>>2]|0;b=(c[l>>2]|0)+l|0;c[l+4>>2]=b;l=b+4|0;m=l+(c[l>>2]|0)|0;c[b+8>>2]=m;b=m+(e<<3)|0;l=b+(c[b>>2]|0)|0;c[m+(e<<3)+4>>2]=l;do if(!f)o=l+12|0;else if((f|0)==1)if(!(a[l+73>>0]|0)){k=0;i=j;return k|0}else{o=l+16|0;break}else if((f|0)==2)o=l+20|0;else{k=0;i=j;return k|0}while(0);e=c[o>>2]|0;if(e>>>0>=(c[n>>2]|0)>>>0){k=0;i=j;return k|0}o=n+4|0;n=(c[o>>2]|0)+o+(e<<3)|0;e=n+(c[n>>2]|0)|0;c[h>>2]=c[e+44>>2];c[h+4>>2]=c[e+48>>2];c[h+8>>2]=c[e+52>>2];if((f|0)==1){g[h+12>>2]=ea(g[l+40>>2]);p=ea(g[l+48>>2])}else if((f|0)==2){g[h+12>>2]=ea(1.0);p=ea(g[l+52>>2])}else if(!f){g[h+12>>2]=ea(g[l+36>>2]);p=ea(g[l+44>>2])}else{g[h+12>>2]=ea(0.0);p=ea(0.0)}g[h+16>>2]=p;c[h+20>>2]=c[e+56>>2];c[h+24>>2]=d[e+70>>0];k=1;i=j;return k|0}}Krd(695200,0,3653512,3115,1,0,0,0);k=0;i=j;return k|0}function kWd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;if(!(mo[c[(c[a>>2]|0)+136>>2]&4095](a)|0)){d=0;i=b;return d|0}if(!(mo[c[(c[a>>2]|0)+136>>2]&4095](a)|0)){d=0;i=b;return d|0}if(mo[c[(c[a>>2]|0)+136>>2]&4095](a)|0?(e=c[a+92>>2]|0,(c[e>>2]|0)>0):0){f=e+4|0;g=f+(c[f>>2]|0)|0;f=c[g+(c[g>>2]|0)>>2]|0;if((f|0)==-1){Krd(695224,0,3653512,3121,1,0,0,0);d=0;i=b;return d|0}g=e+16|0;e=(c[g>>2]|0)+g|0;g=e+(f<<3)|0;h=g+(c[g>>2]|0)|0;c[e+(f<<3)+4>>2]=h;if(!(c[h>>2]|0)){d=0;i=b;return d|0}e=c[a+84>>2]|0;g=(c[e>>2]|0)+e|0;c[e+4>>2]=g;e=g+4|0;j=e+(c[e>>2]|0)|0;c[g+8>>2]=j;g=j+(f<<3)|0;e=g+(c[g>>2]|0)|0;c[j+(f<<3)+4>>2]=e;f=h+4|0;h=c[e+12>>2]|0;e=(c[f>>2]|0)+f|0;f=e+(h<<3)|0;j=f+(c[f>>2]|0)|0;c[e+(h<<3)+4>>2]=j;h=c[a+296>>2]|0;if((c[j+52>>2]|0)==(h|0)){d=1;i=b;return d|0}if((c[j+48>>2]|0)==(h|0)){d=1;i=b;return d|0}d=(c[j+44>>2]|0)==(h|0);i=b;return d|0}Krd(695200,0,3653512,3115,1,0,0,0);d=0;i=b;return d|0}function lWd(a){a=a|0;return a+372|0}function mWd(a){a=a|0;return a+-32+372|0}function nWd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+60|0;a=c[g>>2]|0;if(!a){h=0;i=b;return h|0}c[f>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,f);j=c[d>>2]|0;k=c[a+28>>2]|0;if((j|0)==-1){l=k+(c[a+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((l|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0)m=a;else n=10}else n=10;do if((n|0)==10)if(!(hQb(c[g>>2]|0)|0)){h=0;i=b;return h|0}else{m=c[137784]|0;break}while(0);c[e>>2]=c[g>>2];if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(d,m,e);a=c[d>>2]|0;l=c[m+28>>2]|0;if((a|0)==-1){o=l+(c[m+32>>2]<<3)|0;break}else{o=l+(a<<3)|0;break}}else o=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((o|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[o+4>>2]|0,(m|0)!=0):0)p=m;else n=20}else n=20;if((n|0)==20)p=hQb(c[g>>2]|0)|0;h=mo[c[(c[p>>2]|0)+112>>2]&4095](p)|0;i=b;return h|0}function oWd(a){a=a|0;var b=0,c=0;b=i;c=nWd(a+-32|0)|0;i=b;return c|0}function pWd(a){a=a|0;return a|0}function qWd(a){a=a|0;return a+-32|0}function rWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;ddd(b,3);Hkc(a,b);f=a+56|0;add(b,696808,697048,f,0);g=e+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;h=c[142270]|0;add(b,792256,h,f,1);f=b+12|0;j=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142290]|0;add(b,792272,k,g,1);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);g=a+60|0;add(b,696824,697016,g,0);l=e+8|0;m=l;c[m>>2]=0;c[m+4>>2]=0;c[e>>2]=0;add(b,792256,h,g,1);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,k,l,1);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,696840,h,a+48|0,0);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,696856,h,a+52|0,0);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=4;bdd(b);h=c[142258]|0;add(b,696872,h,a+345|0,8388608);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,696896,h,a+346|0,8388608);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,696952,h,a+469|0,8388608);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,696976,h,a+468|0,0);c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function sWd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+4|0;rdd(d,3);Ikc(b,d);h=b+56|0;j=qdd(d,696808,697048,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else IWd(h,d);sdd(d)}h=b+60|0;j=qdd(d,696824,697016,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else PUd(h,d);sdd(d)}h=b+48|0;j=c[142270]|0;k=qdd(d,696840,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;l=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+m|0;c[k>>2]=n;if((m|0)>=0?(o=l+(m+4)|0,o>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[k>>2]=o}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}h=b+52|0;k=qdd(d,696856,j,f,0)|0;if(k){if((k|0)>0){k=d+12|0;j=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=j+o|0;c[k>>2]=n;if((o|0)>=0?(m=j+(o+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[n>>2];c[k>>2]=m}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d)}k=b+345|0;m=c[142258]|0;n=qdd(d,696872,m,f,0)|0;if(n){do if((n|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](k,d)|0}else{o=d+12|0;j=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;p=j+l|0;c[o>>2]=p;if((l|0)>=0?(j+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[k>>0]=a[p>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break}Bid(o,k,1)}while(0);sdd(d)}k=b+346|0;n=qdd(d,696896,m,f,0)|0;if(n){do if((n|0)<=0){o=c[f>>2]|0;if(o)_n[o&4095](k,d)|0}else{o=d+12|0;p=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=p+l|0;c[o>>2]=j;if((l|0)>=0?(p+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[k>>0]=a[j>>0]|0;c[o>>2]=(c[o>>2]|0)+1;break}Bid(o,k,1)}while(0);sdd(d)}if(xdd(d,2)|0){a[g>>0]=0;k=qdd(d,696928,m,f,0)|0;if(!k)q=0;else{do if((k|0)<=0){n=c[f>>2]|0;if(n)_n[n&4095](g,d)|0}else{n=d+12|0;o=c[d+16>>2]|0;j=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=o+j|0;c[n>>2]=l;if((j|0)>=0?(o+(j+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[g>>0]=a[l>>0]|0;c[n>>2]=o+(j+1);break}Bid(n,g,1)}while(0);sdd(d);q=a[g>>0]|0}c[h>>2]=q&255}q=b+469|0;h=qdd(d,696952,m,f,0)|0;if(h){do if((h|0)<=0){g=c[f>>2]|0;if(g)_n[g&4095](q,d)|0}else{g=d+12|0;k=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=k+n|0;c[g>>2]=j;if((n|0)>=0?(k+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[q>>0]=a[j>>0]|0;c[g>>2]=(c[g>>2]|0)+1;break}Bid(g,q,1)}while(0);sdd(d)}q=b+468|0;b=qdd(d,696976,m,f,0)|0;if(!b){i=e;return}do if((b|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](q,d)|0}else{m=d+12|0;h=c[d+16>>2]|0;g=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=h+g|0;c[m>>2]=j;if((g|0)>=0?(h+(g+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[q>>0]=a[j>>0]|0;c[m>>2]=(c[m>>2]|0)+1;break}Bid(m,q,1)}while(0);sdd(d);i=e;return}function tWd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;Jkc(b,d);JWd(b+56|0,d);NUd(b+60|0,d);f=b+48|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,f,4);m=c[g>>2]|0;n=c[k>>2]|0}else{c[f>>2]=c[h>>2];c[g>>2]=j;m=j;n=l}l=b+52|0;j=m+4|0;if(j>>>0>n>>>0){Bid(g,l,4);o=c[g>>2]|0;p=c[k>>2]|0}else{c[l>>2]=c[m>>2];c[g>>2]=j;o=j;p=n}n=b+345|0;if((o+1|0)>>>0>p>>>0){Bid(g,n,1);q=c[g>>2]|0}else{a[n>>0]=a[o>>0]|0;o=(c[g>>2]|0)+1|0;c[g>>2]=o;q=o}o=b+346|0;if((q+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,o,1);else{a[o>>0]=a[q>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Ndd(d);q=b+469|0;o=c[g>>2]|0;if((o+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,q,1);r=c[g>>2]|0}else{a[q>>0]=a[o>>0]|0;o=(c[g>>2]|0)+1|0;c[g>>2]=o;r=o}o=b+468|0;if((r+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,o,1);Ndd(d);i=e;return}else{a[o>>0]=a[r>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Ndd(d);i=e;return}}function uWd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;Kkc(b,d);KWd(b+56|0,d);OUd(b+60|0,d);f=b+48|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,f,4);m=c[f>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{p=c[h>>2]|0;c[f>>2]=p;c[g>>2]=j;m=p;n=j;o=l}c[f>>2]=XEi(m|0)|0;m=b+52|0;f=n+4|0;if(f>>>0>o>>>0){Bid(g,m,4);q=c[m>>2]|0;r=c[g>>2]|0;s=c[k>>2]|0}else{l=c[n>>2]|0;c[m>>2]=l;c[g>>2]=f;q=l;r=f;s=o}c[m>>2]=XEi(q|0)|0;q=b+345|0;if((r+1|0)>>>0>s>>>0){Bid(g,q,1);t=c[g>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[g>>2]|0)+1|0;c[g>>2]=r;t=r}r=b+346|0;if((t+1|0)>>>0>(c[k>>2]|0)>>>0)Bid(g,r,1);else{a[r>>0]=a[t>>0]|0;c[g>>2]=(c[g>>2]|0)+1}Mdd(d);t=b+469|0;r=c[g>>2]|0;if((r+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,t,1);u=c[g>>2]|0}else{a[t>>0]=a[r>>0]|0;r=(c[g>>2]|0)+1|0;c[g>>2]=r;u=r}r=b+468|0;if((u+1|0)>>>0>(c[k>>2]|0)>>>0){Bid(g,r,1);Mdd(d);i=e;return}else{a[r>>0]=a[u>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Mdd(d);i=e;return}}function vWd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;Lkc(b,d);LWd(b+56|0,d);QUd(b+60|0,d);f=b+48|0;g=d+12|0;h=c[g>>2]|0;j=h+4|0;k=d+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[f>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,f,4);m=c[g>>2]|0;n=c[k>>2]|0}f=b+52|0;l=m+4|0;if(l>>>0<n>>>0){c[m>>2]=c[f>>2];c[g>>2]=l;o=l;p=n}else{Gid(g,f,4);o=c[g>>2]|0;p=c[k>>2]|0}f=b+345|0;if((o+1|0)>>>0<p>>>0){a[o>>0]=a[f>>0]|0;o=(c[g>>2]|0)+1|0;c[g>>2]=o;q=o}else{Gid(g,f,1);q=c[g>>2]|0}f=b+346|0;if((q+1|0)>>>0<(c[k>>2]|0)>>>0){a[q>>0]=a[f>>0]|0;c[g>>2]=(c[g>>2]|0)+1}else Gid(g,f,1);Tdd(d);f=b+469|0;q=c[g>>2]|0;if((q+1|0)>>>0<(c[k>>2]|0)>>>0){a[q>>0]=a[f>>0]|0;q=(c[g>>2]|0)+1|0;c[g>>2]=q;r=q}else{Gid(g,f,1);r=c[g>>2]|0}f=b+468|0;if((r+1|0)>>>0<(c[k>>2]|0)>>>0){a[r>>0]=a[f>>0]|0;c[g>>2]=(c[g>>2]|0)+1;Tdd(d);i=e;return}else{Gid(g,f,1);Tdd(d);i=e;return}}function wWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(488,e,1,16,3653512,97)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];nVd(f,e,b);i=d;return f|0}function xWd(a,b,d){a=a|0;b=b|0;d=d|0;b=i;In[c[(c[a>>2]|0)+132>>2]&4095](a,c[d+4>>2]|0);i=b;return}function yWd(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HVd(a);i=c;return}function zWd(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HVd(a);i=c;return}function AWd(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HVd(a);i=c;return}function BWd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;e=c[d+4>>2]|0;if(!e){i=b;return}d=(da(c[137788]|0,(c[e+8>>2]|0)>>>21)|0)+25|0;e=d>>5;if(!(1<<d-(e<<5)&c[(c[137786]|0)+(e<<2)>>2])){i=b;return}DVd(a);i=b;return}function CWd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+80|0;g=f+24|0;h=f+16|0;j=f;c[j>>2]=0;k=j+8|0;c[k>>2]=0;l=j+12|0;c[l>>2]=0;m=j+4|0;c[m>>2]=60;ijd(g,j,0,-2);a[g+21>>0]=0;MWd(g,b,792072,0);b=xo[c[c[d>>2]>>2]&2047](d,c[k>>2]|0,16)|0;if(b)YEi(b|0,c[j>>2]|0,c[k>>2]|0)|0;c[e>>2]=c[k>>2];dVd(g);if((c[l>>2]|0)<=-1){i=f;return b|0}l=c[j>>2]|0;c[h>>2]=c[m>>2];c[g+0>>2]=c[h+0>>2];eOb(l,g);c[j>>2]=0;i=f;return b|0}function DWd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=0,f=Im,h=0,i=Im,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(g[c>>2]);e=b+32|0;f=ea(d*ea(g[e>>2]));d=ea(g[c+4>>2]);h=b+36|0;i=ea(d*ea(g[h>>2]));d=ea(g[c+8>>2]);j=b+40|0;k=ea(d*ea(g[j>>2]));d=ea(g[c+12>>2]);l=b+44|0;m=ea(d*ea(g[l>>2]));d=ea(f+f);n=ea(i+i);o=ea(k+k);p=ea(g[b+16>>2]);q=ea(n*p);r=ea(g[b+20>>2]);s=ea(o*r);t=ea(g[b+24>>2]);u=ea(d*t);v=ea(g[b+28>>2]);w=ea(v*ea(0.0));x=ea(q-ea(d*r));d=ea(s-ea(n*t));n=ea(u-ea(o*p));o=ea(v*ea(w-w));w=ea(ea(f+ea(v*d))+ea(ea(r*x)-ea(t*n)));f=ea(ea(i+ea(v*n))+ea(ea(t*d)-ea(p*x)));i=ea(ea(k+ea(x*v))+ea(ea(p*n)-ea(r*d)));d=ea(ea(m+o)+ea(o-o));o=ea(ea(g[b>>2])+w);w=ea(ea(g[b+4>>2])+f);f=ea(ea(g[b+8>>2])+i);i=ea(ea(g[b+12>>2])+d);d=ea(g[c+16>>2]);m=ea(r*d);n=ea(g[c+28>>2]);x=ea(v*n);k=ea(g[c+20>>2]);u=ea(t*k);s=ea(g[c+24>>2]);q=ea(ea(ea(m-ea(v*s))-ea(n*t))-ea(k*p));m=ea(ea(ea(x-ea(d*p))-ea(t*s))-ea(r*k));x=ea(ea(ea(u-ea(r*s))-ea(d*v))-ea(n*p));u=ea(ea(ea(ea(p*s)-ea(d*t))-ea(v*k))-ea(r*n));n=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(u*u))+ea(ea(m*m)+ea(q*q))))));r=ea(-ea(n*x));x=ea(-ea(n*u));u=ea(-ea(n*q));q=ea(n*m);m=ea(g[e>>2]);n=ea(m*ea(g[c+32>>2]));m=ea(g[h>>2]);k=ea(m*ea(g[c+36>>2]));m=ea(g[j>>2]);v=ea(m*ea(g[c+40>>2]));m=ea(g[l>>2]);t=ea(m*ea(g[c+44>>2]));g[a>>2]=o;g[a+4>>2]=w;g[a+8>>2]=f;g[a+12>>2]=i;g[a+16>>2]=r;g[a+20>>2]=x;g[a+24>>2]=u;g[a+28>>2]=q;g[a+32>>2]=n;g[a+36>>2]=k;g[a+40>>2]=v;g[a+44>>2]=t;return}function EWd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=695024;c[a+32>>2]=695184;if((c[a+484>>2]|0)>-1){f=a+472|0;g=c[f>>2]|0;c[e>>2]=c[a+476>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}RXd(a+416|0);if((c[a+384>>2]|0)>-1){f=a+372|0;g=c[f>>2]|0;c[e>>2]=c[a+376>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+368>>2]|0)<=-1){h=a+128|0;KVd(h);c[a>>2]=577608;WUb(a);i=b;return}f=a+356|0;g=c[f>>2]|0;c[e>>2]=c[a+360>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;h=a+128|0;KVd(h);c[a>>2]=577608;WUb(a);i=b;return}function FWd(a){a=a|0;var b=0;b=i;EWd(a);ACi(a);i=b;return}function GWd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+4|0;g=c[f>>2]|0;h=(d+-1&0-g)+g|0;g=h+b|0;if(g>>>0>((c[a+8>>2]|0)+(c[a+12>>2]|0)|0)>>>0){j=0;i=e;return j|0}c[f>>2]=g;j=h;i=e;return j|0}function HWd(a,b){a=a|0;b=b|0;return}function IWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function JWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function KWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function LWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function MWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;NWd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);OWd(b,d,695272,0);iVd(b,d+8|0,695296,0);iVd(b,d+56|0,695312,0);iVd(b,d+104|0,695328,0);kVd(b,d+152|0,695344,0);lVd(b,d+168|0,695352,0);PWd(b,d+172|0,695368,0);PWd(b,d+173|0,695384,0);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function NWd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=d+16|0;if(!(a[f>>0]|0)){g=d+12|0;h=c[g>>2]|0;j=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;c[g>>2]=j;if(!(a[d+17>>0]|0))k=j;else{h=j+4|0;c[g>>2]=h;k=h}h=(0-k&3)+k|0;c[g>>2]=h;l=h}else{a[f>>0]=0;l=c[d+12>>2]|0}h=d+12|0;c[h>>2]=(0-l&3)+l;eVd(b+8|0,d);l=c[h>>2]|0;g=(0-l&3)+l|0;c[h>>2]=g;if(!(a[f>>0]|0)){h=d+12|0;c[h>>2]=(0-g&3)+g;eVd(b+56|0,d);l=c[h>>2]|0;k=(0-l&3)+l|0;c[h>>2]=k;if(!(a[f>>0]|0)){m=k;n=10}else{a[f>>0]=0;o=k}}else{a[f>>0]=0;m=g;n=10}if((n|0)==10){n=d+12|0;c[n>>2]=(0-m&3)+m;eVd(b+104|0,d);b=c[n>>2]|0;m=(0-b&3)+b|0;c[n>>2]=m;if(!(a[f>>0]|0))o=m;else{a[f>>0]=0;p=m;q=0-p|0;r=q&3;s=r+p|0;t=s+4|0;u=0-s|0;v=u&3;w=t+v|0;x=d+12|0;y=w+2|0;c[x>>2]=y;i=e;return}}m=(0-o&3)+o|0;o=(0-m&3)+m|0;m=o+4+(0-o&3)|0;o=(0-m&3)+m|0;m=o+4+(0-o&3)|0;o=(0-m&3)+m|0;m=o+4+(0-o&3)|0;o=(0-m&3)+m|0;m=o+4+(0-o&3)|0;o=(0-m&3)+m|0;c[d+12>>2]=o;p=o;q=0-p|0;r=q&3;s=r+p|0;t=s+4|0;u=0-s|0;v=u&3;w=t+v|0;x=d+12|0;y=w+2|0;c[x>>2]=y;i=e;return}function OWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[d>>2]|0)!=0,e,4);n=c[d>>2]|0;if(n){m=n+d|0;c[d+4>>2]=m;QWd(b,m,3142592,0)}njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function PWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;e=(a[b+20>>0]|0)!=0;if(e)jjd(b,1,d,1);g=b+44|0;h=b+40|0;j=(c[g>>2]|0)+-1+(c[h>>2]|0)|0;k=b+28|0;l=c[(c[k>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;a[(c[c[b+12>>2]>>2]|0)+((c[l+(m<<4)+4>>2]|0)+(c[l+(m<<4)>>2]|0))>>0]=a[d>>0]|0;d=c[h>>2]|0;h=(c[g>>2]|0)+-1+d|0;m=c[k>>2]|0;k=(c[m+(h>>>8<<2)>>2]|0)+((h&255)<<4)+4|0;c[k>>2]=(c[k>>2]|0)+1;if(!e){i=f;return}e=c[g>>2]|0;c[g>>2]=e+-1;g=b+32|0;b=c[g>>2]|0;if((b|0)==(m|0))n=0;else n=(b-m<<6)+-1|0;if((1-e+n-d|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[g>>2]=(c[g>>2]|0)+-4;i=f;return}function QWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;RWd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);SWd(d,b);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function RWd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;b=d+16|0;if(!(a[b>>0]|0)){e=d+12|0;f=c[e>>2]|0;g=(0-f&3)+f|0;f=g+4+(0-g&3)|0;c[e>>2]=f;h=f}else{a[b>>0]=0;h=c[d+12>>2]|0}f=d+12|0;e=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;c[f>>2]=e;if(!(a[d+17>>0]|0))i=e;else{h=e+4|0;c[f>>2]=h;i=h}a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=a[d+18>>0]|0;f=a[d+17>>0]|0;e=(0-h&3)+h+(i<<24>>24!=0?8:4)|0;h=f<<24>>24==0?e:e+4|0;a[b>>0]=0;e=(0-h&3)+h|0;c[d+12>>2]=e;h=(0-e&3)+e+(i<<24>>24!=0?8:4)|0;e=f<<24>>24==0?h:h+4|0;a[b>>0]=0;h=(0-e&3)+e|0;c[d+12>>2]=h;e=(0-h&3)+h+(i<<24>>24!=0?8:4)|0;h=f<<24>>24==0?e:e+4|0;a[b>>0]=0;b=(0-h&3)+h|0;c[d+12>>2]=b;h=(0-b&3)+b+(i<<24>>24!=0?8:4)|0;i=f<<24>>24==0?h:h+4|0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;c[d+12>>2]=i+4+(0-i&3);return}function SWd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;fVd(b,a,695416,0);f=b+4|0;g=c[f>>2]|0;c[e>>2]=a+4;c[e+4>>2]=a;c[e+8>>2]=g;TWd(b,e,695440,0);g=a+12|0;fVd(b,g,697616,0);h=c[f>>2]|0;c[e>>2]=a+16;c[e+4>>2]=g;c[e+8>>2]=h;UWd(b,e,695464,0);h=c[f>>2]|0;c[e>>2]=a+24;c[e+4>>2]=g;c[e+8>>2]=h;UWd(b,e,695512,0);h=c[f>>2]|0;c[e>>2]=a+32;c[e+4>>2]=g;c[e+8>>2]=h;VWd(b,e,695536,0);WWd(b,a+40|0,695552,0);hVd(b,a+48|0,695368,0);i=d;return}function TWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[c[d+4>>2]>>2]|0)!=0,e,4);XWd(f+12|0,d,0,b);njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function UWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[c[d+4>>2]>>2]|0)!=0,e,4);YWd(f+12|0,d,0,b);njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function VWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[c[d+4>>2]>>2]|0)!=0,e,4);ZWd(f+12|0,d,0,b);njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function WWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[d>>2]|0)!=0,e,4);n=c[d>>2]|0;if(n){m=n+d|0;c[d+4>>2]=m;_Wd(b,m,3142592,0)}njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function XWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;e=i;b=d+4|0;if(!(c[c[b>>2]>>2]|0)){i=e;return}g=c[d>>2]|0;c[g+4>>2]=(c[g>>2]|0)+g;g=ljd(f)|0;h=(a[f+22>>0]|0)!=0?8:4;j=da(g?h+4|0:h,c[c[b>>2]>>2]|0)|0;h=c[d>>2]|0;g=(c[h>>2]|0)+h|0;c[h+4>>2]=g;jjd(f,j,g,4);g=c[d>>2]|0;j=(c[g>>2]|0)+g|0;c[g+4>>2]=j;g=j+(c[c[b>>2]>>2]<<3)|0;b=c[d>>2]|0;d=(c[b>>2]|0)+b|0;c[b+4>>2]=d;if((d|0)!=(g|0)){b=d;do{$Wd(f,b,3142592,0);b=b+8|0}while((b|0)!=(g|0))}g=f+44|0;b=c[g>>2]|0;c[g>>2]=b+-1;g=f+32|0;d=c[g>>2]|0;j=c[f+28>>2]|0;if((d|0)==(j|0))k=0;else k=(d-j<<6)+-1|0;if((1-b+k-(c[f+40>>2]|0)|0)>>>0<=511){i=e;return}ACi(c[d+-4>>2]|0);c[g>>2]=(c[g>>2]|0)+-4;i=e;return}function YWd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;e=i;b=d+4|0;if(!(c[c[b>>2]>>2]|0)){i=e;return}g=c[d>>2]|0;c[g+4>>2]=(c[g>>2]|0)+g;g=ljd(f)|0;h=(a[f+22>>0]|0)!=0?8:4;j=(g?h+4|0:h)+h|0;k=g?j+4|0:j;j=0-k&3|k;k=j+h+(0-j&3)|0;j=g?k+4|0:k;k=(0-j&3)+j|0;j=k+h+(0-k&3)|0;k=g?j+4|0:j;j=(0-k&3)+k|0;k=(0-j&3)+j|0;j=k+4+(0-k&3)|0;k=da((0-j&3)+j|0,c[c[b>>2]>>2]|0)|0;j=c[d>>2]|0;g=(c[j>>2]|0)+j|0;c[j+4>>2]=g;jjd(f,k,g,4);g=c[d>>2]|0;k=(c[g>>2]|0)+g|0;c[g+4>>2]=k;g=k+((c[c[b>>2]>>2]|0)*36|0)|0;b=c[d>>2]|0;d=(c[b>>2]|0)+b|0;c[b+4>>2]=d;if((d|0)!=(g|0)){b=d;do{aXd(f,b,3142592,0);b=b+36|0}while((b|0)!=(g|0))}g=f+44|0;b=c[g>>2]|0;c[g>>2]=b+-1;g=f+32|0;d=c[g>>2]|0;k=c[f+28>>2]|0;if((d|0)==(k|0))l=0;else l=(d-k<<6)+-1|0;if((1-b+l-(c[f+40>>2]|0)|0)>>>0<=511){i=e;return}ACi(c[d+-4>>2]|0);c[g>>2]=(c[g>>2]|0)+-4;i=e;return}function ZWd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;d=i;a=b+4|0;if(!(c[c[a>>2]>>2]|0)){i=d;return}f=c[b>>2]|0;c[f+4>>2]=(c[f>>2]|0)+f;f=c[c[a>>2]>>2]<<2;g=c[b>>2]|0;h=(c[g>>2]|0)+g|0;c[g+4>>2]=h;jjd(e,f,h,4);h=c[b>>2]|0;f=(c[h>>2]|0)+h|0;c[h+4>>2]=f;h=f+(c[c[a>>2]>>2]<<2)|0;a=c[b>>2]|0;b=(c[a>>2]|0)+a|0;c[a+4>>2]=b;if((b|0)!=(h|0)){a=b;do{lVd(e,a,3142592,0);a=a+4|0}while((a|0)!=(h|0))}h=e+44|0;a=c[h>>2]|0;c[h>>2]=a+-1;h=e+32|0;b=c[h>>2]|0;f=c[e+28>>2]|0;if((b|0)==(f|0))j=0;else j=(b-f<<6)+-1|0;if((1-a+j-(c[e+40>>2]|0)|0)>>>0<=511){i=d;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=d;return}function _Wd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;bXd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);cXd(d,b);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function $Wd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[d>>2]|0)!=0,e,4);n=c[d>>2]|0;if(n){m=n+d|0;c[d+4>>2]=m;dXd(b,m,3142592,0)}njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function aXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;e=(a[b+20>>0]|0)!=0;if(e){g=ljd(b)|0;h=(a[b+22>>0]|0)!=0?8:4;j=(g?h+4|0:h)+h|0;k=g?j+4|0:j;j=0-k&3|k;k=j+h+(0-j&3)|0;j=g?k+4|0:k;k=(0-j&3)+j|0;j=k+h+(0-k&3)|0;k=g?j+4|0:j;j=(0-k&3)+k|0;k=(0-j&3)+j|0;j=k+4+(0-k&3)|0;jjd(b,(0-j&3)+j|0,d,4)}j=b+44|0;k=b+40|0;g=(c[j>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(g>>>8<<2)>>2]|0;m=g&255;g=l+(m<<4)+4|0;n=c[g>>2]|0;c[g>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);WWd(b,d,695784,0);eXd(b,d+8|0,695808,0);fXd(b,d+16|0,695840,0);gXd(b,d+24|0,695864,0);lVd(b,d+32|0,695888,0);if(!e){i=f;return}e=c[j>>2]|0;c[j>>2]=e+-1;j=b+32|0;b=c[j>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-e+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function bXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;b=d+16|0;if(!(a[b>>0]|0)){e=d+12|0;f=c[e>>2]|0;g=(0-f&3)+f|0;f=g+4+(0-g&3)|0;c[e>>2]=f;h=f}else{a[b>>0]=0;h=c[d+12>>2]|0}f=d+12|0;e=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;c[f>>2]=e;if(!(a[d+17>>0]|0))i=e;else{h=e+4|0;c[f>>2]=h;i=h}a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;h=(a[d+17>>0]|0)==0?i:i+4|0;a[b>>0]=0;i=(0-h&3)+h|0;h=(0-i&3)+i|0;i=h+4+(0-h&3)|0;c[d+12>>2]=i;h=(0-i&3)+i+((a[d+18>>0]|0)!=0?8:4)|0;i=(a[d+17>>0]|0)==0?h:h+4|0;a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;h=(a[d+17>>0]|0)==0?i:i+4|0;a[b>>0]=0;i=(0-h&3)+h|0;h=(0-i&3)+i|0;i=h+4+(0-h&3)|0;c[d+12>>2]=i;h=(0-i&3)+i+((a[d+18>>0]|0)!=0?8:4)|0;i=(a[d+17>>0]|0)==0?h:h+4|0;a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;h=(a[d+17>>0]|0)==0?i:i+4|0;a[b>>0]=0;c[d+12>>2]=(0-h&3)+h;return}function cXd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;fVd(b,a,695568,0);f=b+4|0;g=c[f>>2]|0;c[e>>2]=a+4;c[e+4>>2]=a;c[e+8>>2]=g;hXd(b,e,695584,0);g=a+12|0;fVd(b,g,695600,0);h=c[f>>2]|0;c[e>>2]=a+16;c[e+4>>2]=g;c[e+8>>2]=h;gVd(b,e,695616,0);h=a+24|0;fVd(b,h,695632,0);g=c[f>>2]|0;c[e>>2]=a+28;c[e+4>>2]=h;c[e+8>>2]=g;VWd(b,e,695648,0);g=a+36|0;fVd(b,g,695664,0);h=c[f>>2]|0;c[e>>2]=a+40;c[e+4>>2]=g;c[e+8>>2]=h;iXd(b,e,695680,0);h=a+48|0;fVd(b,h,695704,0);g=c[f>>2]|0;c[e>>2]=a+52;c[e+4>>2]=h;c[e+8>>2]=g;iXd(b,e,695728,0);g=a+60|0;fVd(b,g,695752,0);h=c[f>>2]|0;c[e>>2]=a+64;c[e+4>>2]=g;c[e+8>>2]=h;iXd(b,e,695768,0);i=d;return}function dXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;jXd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);kXd(d,b);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function eXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[d>>2]|0)!=0,e,4);n=c[d>>2]|0;if(n){m=n+d|0;c[d+4>>2]=m;lXd(b,m,3142592,0)}njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function fXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[d>>2]|0)!=0,e,4);n=c[d>>2]|0;if(n){m=n+d|0;c[d+4>>2]=m;mXd(b,m,3142592,0)}njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function gXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[d>>2]|0)!=0,e,4);n=c[d>>2]|0;if(n){m=n+d|0;c[d+4>>2]=m;nXd(b,m,3142592,0)}njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function hXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[c[d+4>>2]>>2]|0)!=0,e,1);oXd(f+12|0,d,0,b);njd(b,e,1);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function iXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=(a[b+22>>0]|0)!=0?8:4;jjd(b,h?j+4|0:j,d,4)}j=b+44|0;h=b+40|0;k=(c[j>>2]|0)+-1+(c[h>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);kjd(b,(c[c[d+4>>2]>>2]|0)!=0,e,4);pXd(f+12|0,d,0,b);njd(b,e,4);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[h>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function jXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;b=d+16|0;if(!(a[b>>0]|0)){e=d+12|0;f=c[e>>2]|0;g=(0-f&3)+f|0;f=g+4+(0-g&3)|0;c[e>>2]=f;h=f}else{a[b>>0]=0;h=c[d+12>>2]|0}f=d+12|0;e=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;c[f>>2]=e;if(!(a[d+17>>0]|0))i=e;else{h=e+4|0;c[f>>2]=h;i=h}a[b>>0]=0;b=(0-i&3)+i|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;b=i+4+(0-i&3)|0;i=(0-b&3)+b|0;c[d+12>>2]=i+4+(0-i&3)+4;return}function kXd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;fVd(b,a,696304,0);f=c[b+4>>2]|0;c[e>>2]=a+4;c[e+4>>2]=a;c[e+8>>2]=f;VWd(b,e,696328,0);fVd(b,a+12|0,696360,0);fVd(b,a+16|0,696384,0);fVd(b,a+20|0,696408,0);hVd(b,a+24|0,696432,0);hVd(b,a+28|0,696456,0);fVd(b,a+32|0,2488896,0);lVd(b,a+36|0,696488,0);lVd(b,a+40|0,696520,0);lVd(b,a+44|0,696544,0);lVd(b,a+48|0,696568,0);lVd(b,a+52|0,696592,0);lVd(b,a+56|0,696616,0);lVd(b,a+60|0,696640,0);lVd(b,a+64|0,696664,0);lVd(b,a+68|0,696688,0);mVd(b,a+72|0,696712,0);mVd(b,a+73|0,696744,0);mVd(b,a+74|0,696760,0);mVd(b,a+75|0,696784,0);i=d;return}function lXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;qXd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);rXd(d,b);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function mXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;sXd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);tXd(d,b);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function nXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;uXd(d,e);j=c[k>>2]|0;jjd(b,(0-j&3)+j|0,d,4)}j=b+44|0;k=b+40|0;h=(c[j>>2]|0)+-1+(c[k>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(h>>>8<<2)>>2]|0;n=h&255;h=m+(n<<4)+4|0;o=c[h>>2]|0;c[h>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);iVd(b,d,695904,0);kVd(b,d+48|0,695912,0);kVd(b,d+64|0,695936,0);c[e>>2]=4;c[e+4>>2]=d+80;vXd(b,e,695952,0);wXd(b,d+384|0,695968,0);wXd(b,d+528|0,695984,0);c[e>>2]=52;c[e+4>>2]=d+672;xXd(b,e,696e3,0);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;e=c[l>>2]|0;if((b|0)==(e|0))p=0;else p=(b-e<<6)+-1|0;if((1-g+p-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function oXd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;d=i;a=b+4|0;if(!(c[c[a>>2]>>2]|0)){i=d;return}f=c[b>>2]|0;c[f+4>>2]=(c[f>>2]|0)+f;f=c[c[a>>2]>>2]|0;g=c[b>>2]|0;h=(c[g>>2]|0)+g|0;c[g+4>>2]=h;jjd(e,f,h,1);h=c[b>>2]|0;f=(c[h>>2]|0)+h|0;c[h+4>>2]=f;h=f+(c[c[a>>2]>>2]|0)|0;a=c[b>>2]|0;b=(c[a>>2]|0)+a|0;c[a+4>>2]=b;if((b|0)!=(h|0)){a=b;do{mVd(e,a,3142592,0);a=a+1|0}while((a|0)!=(h|0))}h=e+44|0;a=c[h>>2]|0;c[h>>2]=a+-1;h=e+32|0;b=c[h>>2]|0;f=c[e+28>>2]|0;if((b|0)==(f|0))j=0;else j=(b-f<<6)+-1|0;if((1-a+j-(c[e+40>>2]|0)|0)>>>0<=511){i=d;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=d;return}function pXd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;d=i;a=b+4|0;if(!(c[c[a>>2]>>2]|0)){i=d;return}f=c[b>>2]|0;c[f+4>>2]=(c[f>>2]|0)+f;f=c[c[a>>2]>>2]<<4;g=c[b>>2]|0;h=(c[g>>2]|0)+g|0;c[g+4>>2]=h;jjd(e,f,h,4);h=c[b>>2]|0;f=(c[h>>2]|0)+h|0;c[h+4>>2]=f;h=f+(c[c[a>>2]>>2]<<4)|0;a=c[b>>2]|0;b=(c[a>>2]|0)+a|0;c[a+4>>2]=b;if((b|0)!=(h|0)){a=b;do{kVd(e,a,3142592,0);a=a+16|0}while((a|0)!=(h|0))}h=e+44|0;a=c[h>>2]|0;c[h>>2]=a+-1;h=e+32|0;b=c[h>>2]|0;f=c[e+28>>2]|0;if((b|0)==(f|0))j=0;else j=(b-f<<6)+-1|0;if((1-a+j-(c[e+40>>2]|0)|0)>>>0<=511){i=d;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=d;return}function qXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;b=d+16|0;if(!(a[b>>0]|0)){e=d+12|0;f=c[e>>2]|0;g=(0-f&3)+f|0;f=g+4+(0-g&3)|0;c[e>>2]=f;h=f}else{a[b>>0]=0;h=c[d+12>>2]|0}f=d+12|0;e=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;c[f>>2]=e;if(!(a[d+17>>0]|0))i=e;else{h=e+4|0;c[f>>2]=h;i=h}a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;h=(a[d+17>>0]|0)==0?i:i+4|0;a[b>>0]=0;i=(0-h&3)+h|0;h=(0-i&3)+i|0;i=h+4+(0-h&3)|0;c[d+12>>2]=i;h=(0-i&3)+i+((a[d+18>>0]|0)!=0?8:4)|0;i=(a[d+17>>0]|0)==0?h:h+4|0;a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;h=(a[d+17>>0]|0)==0?i:i+4|0;a[b>>0]=0;i=(0-h&3)+h|0;h=(0-i&3)+i|0;i=h+4+(0-h&3)|0;c[d+12>>2]=i;h=(0-i&3)+i+((a[d+18>>0]|0)!=0?8:4)|0;i=(a[d+17>>0]|0)==0?h:h+4|0;a[b>>0]=0;h=(0-i&3)+i|0;i=(0-h&3)+h|0;h=i+4+(0-i&3)|0;c[d+12>>2]=h;i=(0-h&3)+h+((a[d+18>>0]|0)!=0?8:4)|0;h=(a[d+17>>0]|0)==0?i:i+4|0;a[b>>0]=0;c[d+12>>2]=(0-h&3)+h;return}function rXd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;fVd(b,a,695568,0);f=b+4|0;g=c[f>>2]|0;c[e>>2]=a+4;c[e+4>>2]=a;c[e+8>>2]=g;hXd(b,e,695584,0);g=a+12|0;fVd(b,g,695600,0);h=c[f>>2]|0;c[e>>2]=a+16;c[e+4>>2]=g;c[e+8>>2]=h;hXd(b,e,695616,0);h=a+24|0;fVd(b,h,695632,0);g=c[f>>2]|0;c[e>>2]=a+28;c[e+4>>2]=h;c[e+8>>2]=g;hXd(b,e,695648,0);g=a+36|0;fVd(b,g,695664,0);h=c[f>>2]|0;c[e>>2]=a+40;c[e+4>>2]=g;c[e+8>>2]=h;hXd(b,e,695680,0);h=a+48|0;fVd(b,h,695704,0);g=c[f>>2]|0;c[e>>2]=a+52;c[e+4>>2]=h;c[e+8>>2]=g;hXd(b,e,695728,0);g=a+60|0;fVd(b,g,695752,0);h=c[f>>2]|0;c[e>>2]=a+64;c[e+4>>2]=g;c[e+8>>2]=h;hXd(b,e,695768,0);i=d;return}function sXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=d+16|0;if(!(a[f>>0]|0)){g=d+12|0;h=c[g>>2]|0;j=(0-h&3)+h|0;h=j+4+(0-j&3)|0;c[g>>2]=h;k=h}else{a[f>>0]=0;k=c[d+12>>2]|0}h=(0-k&3)+k|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=(0-k&3)+k|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=k+4+(0-k&3)|0;k=(0-h&3)+h|0;h=d+12|0;c[h>>2]=(0-k&3)+k;eVd(b+36|0,d);k=c[h>>2]|0;g=(0-k&3)+k|0;c[h>>2]=g;if(!(a[f>>0]|0)){h=d+12|0;c[h>>2]=(0-g&3)+g;eVd(b+84|0,d);k=c[h>>2]|0;j=(0-k&3)+k|0;c[h>>2]=j;if(!(a[f>>0]|0)){l=j;m=8}else{a[f>>0]=0;n=j;m=10}}else{a[f>>0]=0;l=g;m=8}if((m|0)==8){g=d+12|0;c[g>>2]=(0-l&3)+l;eVd(b+132|0,d);l=c[g>>2]|0;j=(0-l&3)+l|0;c[g>>2]=j;if(!(a[f>>0]|0)){n=j;m=10}else{a[f>>0]=0;o=j;m=12}}if((m|0)==10){j=d+12|0;c[j>>2]=(0-n&3)+n;eVd(b+180|0,d);n=c[j>>2]|0;g=(0-n&3)+n|0;c[j>>2]=g;if(!(a[f>>0]|0)){o=g;m=12}else{a[f>>0]=0;p=g;m=14}}if((m|0)==12){g=d+12|0;c[g>>2]=(0-o&3)+o;eVd(b+228|0,d);o=c[g>>2]|0;j=(0-o&3)+o|0;c[g>>2]=j;if(!(a[f>>0]|0)){p=j;m=14}else{a[f>>0]=0;q=j;m=16}}if((m|0)==14){j=d+12|0;c[j>>2]=(0-p&3)+p;eVd(b+276|0,d);p=c[j>>2]|0;g=(0-p&3)+p|0;c[j>>2]=g;if(!(a[f>>0]|0)){q=g;m=16}else{a[f>>0]=0;r=g;m=18}}if((m|0)==16){g=d+12|0;c[g>>2]=(0-q&3)+q;eVd(b+324|0,d);q=c[g>>2]|0;j=(0-q&3)+q|0;c[g>>2]=j;if(!(a[f>>0]|0)){r=j;m=18}else{a[f>>0]=0;s=j}}if((m|0)==18){m=d+12|0;c[m>>2]=(0-r&3)+r;eVd(b+372|0,d);b=c[m>>2]|0;r=(0-b&3)+b|0;c[m>>2]=r;if(!(a[f>>0]|0))s=r;else{a[f>>0]=0;i=e;return}}f=(0-s&3)+s|0;c[d+12>>2]=f+4+(0-f&3);i=e;return}function tXd(a,b){a=a|0;b=b|0;var c=0;c=i;lVd(b,a,696136,0);kVd(b,a+4|0,2462808,0);kVd(b,a+20|0,2462920,0);iVd(b,a+36|0,696152,0);iVd(b,a+84|0,696168,0);iVd(b,a+132|0,696184,0);iVd(b,a+180|0,696200,0);iVd(b,a+228|0,696216,0);iVd(b,a+276|0,696232,0);iVd(b,a+324|0,696248,0);iVd(b,a+372|0,696272,0);lVd(b,a+420|0,696288,0);i=c;return}function uXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d+16|0;if(!(a[f>>0]|0)){g=d+12|0;h=c[g>>2]|0;c[g>>2]=(0-h&3)+h;eVd(b,d);h=c[g>>2]|0;j=(0-h&3)+h|0;c[g>>2]=j;if(!(a[f>>0]|0)){k=j;l=5}else{a[f>>0]=0;m=j}}else{a[f>>0]=0;k=c[d+12>>2]|0;l=5}if((l|0)==5){l=(0-k&3)+k|0;k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;c[d+12>>2]=k;m=k}k=(0-m&3)+m|0;m=(0-k&3)+k|0;k=m+4+(0-m&3)|0;m=(0-k&3)+k|0;k=m+4+(0-m&3)|0;m=(0-k&3)+k|0;k=m+4+(0-m&3)|0;m=(0-k&3)+k|0;k=m+4+(0-m&3)|0;m=(0-k&3)+k|0;k=(0-m&3)+m|0;m=k+304+(0-k&3)|0;k=(0-m&3)+m|0;m=d+12|0;c[m>>2]=(0-k&3)+k;yXd(b+384|0,d);k=c[m>>2]|0;l=(0-k&3)+k|0;c[m>>2]=l;if(!(a[f>>0]|0)){m=d+12|0;c[m>>2]=(0-l&3)+l;yXd(b+528|0,d);b=c[m>>2]|0;k=(0-b&3)+b|0;c[m>>2]=k;if(!(a[f>>0]|0))n=k;else{a[f>>0]=0;i=e;return}}else{a[f>>0]=0;n=l}l=(0-n&3)+n|0;n=l+208+(0-l&3)|0;c[d+12>>2]=(0-n&3)+n;i=e;return}function vXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;e=(a[b+20>>0]|0)!=0;if(e){jjd(b,(c[d>>2]|0)*76|0,d,4);g=d}else g=d;h=b+44|0;j=b+40|0;k=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);n=c[g>>2]|0;g=c[d+4>>2]|0;d=g+(n*76|0)|0;if(n){n=g;do{zXd(b,n,3142592,0);n=n+76|0}while((n|0)!=(d|0))}if(!e){i=f;return}e=c[h>>2]|0;c[h>>2]=e+-1;h=b+32|0;b=c[h>>2]|0;d=c[l>>2]|0;if((b|0)==(d|0))p=0;else p=(b-d<<6)+-1|0;if((1-e+p-(c[j>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=f;return}function wXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;yXd(d,e);j=c[k>>2]|0;jjd(b,(0-j&3)+j|0,d,4)}j=b+44|0;k=b+40|0;h=(c[j>>2]|0)+-1+(c[k>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(h>>>8<<2)>>2]|0;n=h&255;h=m+(n<<4)+4|0;o=c[h>>2]|0;c[h>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);iVd(b,d,696016,0);c[e>>2]=20;c[e+4>>2]=d+48;AXd(b,e,696e3,0);lVd(b,d+128|0,696024,0);lVd(b,d+132|0,696040,0);lVd(b,d+136|0,696056,0);lVd(b,d+140|0,696064,0);if(!g){i=f;return}g=c[j>>2]|0;c[j>>2]=g+-1;j=b+32|0;b=c[j>>2]|0;d=c[l>>2]|0;if((b|0)==(d|0))p=0;else p=(b-d<<6)+-1|0;if((1-g+p-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[j>>2]=(c[j>>2]|0)+-4;i=f;return}function xXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;e=(a[b+20>>0]|0)!=0;if(e){jjd(b,c[d>>2]<<2,d,4);g=d}else g=d;h=b+44|0;j=b+40|0;k=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);n=c[g>>2]|0;g=c[d+4>>2]|0;d=g+(n<<2)|0;if(n){n=g;do{lVd(b,n,3142592,0);n=n+4|0}while((n|0)!=(d|0))}if(!e){i=f;return}e=c[h>>2]|0;c[h>>2]=e+-1;h=b+32|0;b=c[h>>2]|0;d=c[l>>2]|0;if((b|0)==(d|0))p=0;else p=(b-d<<6)+-1|0;if((1-e+p-(c[j>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=f;return}function yXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d+16|0;if(!(a[f>>0]|0)){g=d+12|0;h=c[g>>2]|0;c[g>>2]=(0-h&3)+h;eVd(b,d);b=c[g>>2]|0;h=(0-b&3)+b|0;c[g>>2]=h;if(!(a[f>>0]|0)){j=h;k=5}else{a[f>>0]=0;l=h}}else{a[f>>0]=0;j=c[d+12>>2]|0;k=5}if((k|0)==5){k=(0-j&3)+j|0;j=k+80+(0-k&3)|0;k=(0-j&3)+j|0;c[d+12>>2]=k;l=k}k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;l=k+4+(0-k&3)|0;k=(0-l&3)+l|0;c[d+12>>2]=k+4+(0-k&3);i=e;return}function zXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;e=f;g=(a[b+20>>0]|0)!=0;if(g){h=ljd(b)|0;j=a[b+22>>0]|0;c[e>>2]=0;c[e+4>>2]=0;k=e+12|0;a[e+16>>0]=0;a[e+17>>0]=h&1;a[e+18>>0]=j;c[k>>2]=0;BXd(d,e);e=c[k>>2]|0;jjd(b,(0-e&3)+e|0,d,4)}e=b+44|0;k=b+40|0;j=(c[e>>2]|0)+-1+(c[k>>2]|0)|0;h=b+28|0;l=c[(c[h>>2]|0)+(j>>>8<<2)>>2]|0;m=j&255;j=l+(m<<4)+4|0;n=c[j>>2]|0;c[j>>2]=n+(0-(n+(c[l+(m<<4)>>2]|0))&3);iVd(b,d,696072,0);lVd(b,d+48|0,696080,0);lVd(b,d+52|0,696096,0);kVd(b,d+56|0,696112,0);lVd(b,d+72|0,696120,0);if(!g){i=f;return}g=c[e>>2]|0;c[e>>2]=g+-1;e=b+32|0;b=c[e>>2]|0;d=c[h>>2]|0;if((b|0)==(d|0))o=0;else o=(b-d<<6)+-1|0;if((1-g+o-(c[k>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[e>>2]=(c[e>>2]|0)+-4;i=f;return}function AXd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;e=(a[b+20>>0]|0)!=0;if(e){jjd(b,c[d>>2]<<2,d,4);g=d}else g=d;h=b+44|0;j=b+40|0;k=(c[h>>2]|0)+-1+(c[j>>2]|0)|0;l=b+28|0;m=c[(c[l>>2]|0)+(k>>>8<<2)>>2]|0;n=k&255;k=m+(n<<4)+4|0;o=c[k>>2]|0;c[k>>2]=o+(0-(o+(c[m+(n<<4)>>2]|0))&3);n=c[g>>2]|0;g=c[d+4>>2]|0;d=g+(n<<2)|0;if(n){n=g;do{lVd(b,n,3142592,0);n=n+4|0}while((n|0)!=(d|0))}if(!e){i=f;return}e=c[h>>2]|0;c[h>>2]=e+-1;h=b+32|0;b=c[h>>2]|0;d=c[l>>2]|0;if((b|0)==(d|0))p=0;else p=(b-d<<6)+-1|0;if((1-e+p-(c[j>>2]|0)|0)>>>0<=511){i=f;return}ACi(c[b+-4>>2]|0);c[h>>2]=(c[h>>2]|0)+-4;i=f;return}function BXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d+16|0;if(!(a[f>>0]|0)){g=d+12|0;h=c[g>>2]|0;c[g>>2]=(0-h&3)+h;eVd(b,d);b=c[g>>2]|0;h=(0-b&3)+b|0;c[g>>2]=h;if(!(a[f>>0]|0)){j=h;k=5}else{a[f>>0]=0;l=h}}else{a[f>>0]=0;j=c[d+12>>2]|0;k=5}if((k|0)==5){k=(0-j&3)+j|0;j=k+4+(0-k&3)|0;c[d+12>>2]=j;l=j}j=(0-l&3)+l|0;l=j+4+(0-j&3)|0;j=(0-l&3)+l|0;l=(0-j&3)+j|0;j=l+4+(0-l&3)|0;l=(0-j&3)+j|0;j=l+4+(0-l&3)|0;l=(0-j&3)+j|0;j=l+4+(0-l&3)|0;l=(0-j&3)+j|0;j=l+4+(0-l&3)|0;l=(0-j&3)+j|0;j=(0-l&3)+l|0;c[d+12>>2]=j+4+(0-j&3);i=e;return}function CXd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+8|0;f=d;h=c[a>>2]|0;do if(!h)j=0;else{c[f>>2]=h;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(e,k,f);l=c[e>>2]|0;m=c[k+28>>2]|0;if((l|0)==-1){n=m+(c[k+32>>2]<<3)|0;break}else{n=m+(l<<3)|0;break}}else n=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if(!((n|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(c[n+4>>2]|0)!=0:0))o=10}else o=10;if((o|0)==10?(hQb(c[a>>2]|0)|0)==0:0){j=0;break}j=c[a>>2]|0}while(0);c[b>>2]=j;g[b+4>>2]=ea(g[a+4>>2]);i=d;return}function DXd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+28|0;if(!(c[d>>2]|0)){i=b;return}if(!(ea(g[(jLc()|0)+40>>2])!=ea(0.0))){i=b;return}e=c[a+20>>2]|0;a=c[d>>2]|0;NVd(e,a,ea(g[(jLc()|0)+40>>2]),1,0,ea(0.0));i=b;return}function EXd(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+28|0;if(!(c[d>>2]|0)){i=b;return}if(!(ea(g[(jLc()|0)+40>>2])!=ea(0.0))){i=b;return}e=c[a+20>>2]|0;a=c[d>>2]|0;NVd(e,a,ea(g[(jLc()|0)+40>>2]),0,1,ea(0.0));i=b;return}function FXd(a){a=a|0;var b=0,d=0,e=Im,f=Im,j=0;b=i;d=a+12|0;if(!(c[d>>2]|0)){i=b;return}if(!(ea(g[(jLc()|0)+104>>2])>ea(0.0))){e=ea(g[(jLc()|0)+188>>2]);if(e<ea(0.0))f=ea(-e);else f=e;if(!(f<=ea(9.99999997e-07))){i=b;return}if(!(+h[(jLc()|0)+176>>3]>0.0)){i=b;return}}j=c[a+4>>2]|0;a=c[d>>2]|0;f=ea(g[(jLc()|0)+104>>2]);NVd(j,a,f,1,0,ea(+h[(jLc()|0)+176>>3]));i=b;return}function GXd(a){a=a|0;var b=0,d=0,e=Im,f=Im,j=0;b=i;d=a+12|0;if(!(c[d>>2]|0)){i=b;return}if(!(ea(g[(jLc()|0)+104>>2])>ea(0.0))){e=ea(g[(jLc()|0)+188>>2]);if(e<ea(0.0))f=ea(-e);else f=e;if(!(f<=ea(9.99999997e-07))){i=b;return}if(!(+h[(jLc()|0)+176>>3]>0.0)){i=b;return}}j=c[a+4>>2]|0;a=c[d>>2]|0;f=ea(g[(jLc()|0)+104>>2]);NVd(j,a,f,0,1,ea(+h[(jLc()|0)+176>>3]));i=b;return}function HXd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(a[d+28>>0]|0)){i=e;return}h=c[d+24>>2]|0;if(!h){i=e;return}if(!(vTb(h)|0)){i=e;return}if(!(cWd(d)|0)){i=e;return}if((c[d+52>>2]|0)==1){h=b+20|0;j=b+28|0;k=c[j>>2]|0;c[d+40>>2]=k;l=k+1|0;c[j>>2]=l;k=b+32|0;m=c[k>>2]|0;n=m&2147483647;if(l>>>0>n>>>0){o=m<<1;p=(o|0)==0?1:o;do if(n>>>0<p>>>0)if((m|0)>-1){c[k>>2]=p;o=c[h>>2]|0;c[g>>2]=c[b+24>>2];c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(o,p<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[b+24>>2];c[f+0>>2]=c[g+0>>2];o=cOb(p<<2,4,f,0,3653512,352)|0;YEi(o|0,c[h>>2]|0,c[j>>2]<<2|0)|0;c[k>>2]=p;c[h>>2]=o;break}while(0);q=c[j>>2]|0}else q=l;c[(c[h>>2]|0)+(q+-1<<2)>>2]=d;i=e;return}else{q=b+4|0;h=b+12|0;l=c[h>>2]|0;c[d+36>>2]=l;j=l+1|0;c[h>>2]=j;l=b+16|0;p=c[l>>2]|0;k=p&2147483647;if(j>>>0>k>>>0){m=p<<1;n=(m|0)==0?1:m;do if(k>>>0<n>>>0)if((p|0)>-1){c[l>>2]=n;m=c[q>>2]|0;c[g>>2]=c[b+8>>2];c[f+0>>2]=c[g+0>>2];c[q>>2]=hOb(m,n<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[b+8>>2];c[f+0>>2]=c[g+0>>2];m=cOb(n<<2,4,f,0,3653512,352)|0;YEi(m|0,c[q>>2]|0,c[h>>2]<<2|0)|0;c[l>>2]=n;c[q>>2]=m;break}while(0);r=c[h>>2]|0}else r=j;c[(c[q>>2]|0)+(r+-1<<2)>>2]=d;i=e;return}}function IXd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+36|0;f=c[e>>2]|0;if((f|0)!=-1){g=a+12|0;h=(c[g>>2]|0)+-1|0;j=c[a+4>>2]|0;k=c[j+(h<<2)>>2]|0;c[j+(f<<2)>>2]=k;c[k+36>>2]=f;c[e>>2]=-1;c[g>>2]=h}h=b+40|0;b=c[h>>2]|0;if((b|0)==-1){i=d;return}g=a+28|0;e=(c[g>>2]|0)+-1|0;f=c[a+20>>2]|0;a=c[f+(e<<2)>>2]|0;c[f+(b<<2)>>2]=a;c[a+40>>2]=b;c[h>>2]=-1;c[g>>2]=e;i=d;return}function JXd(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153084];c[b+0>>2]=c[d+0>>2];d=bOb(36,b,1,16,3653512,95)|0;c[d>>2]=697096;c[d+4>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+8>>2]=60;c[d+20>>2]=0;c[d+28>>2]=0;c[d+32>>2]=0;c[d+24>>2]=60;c[174270]=d;c[141958]=210;c[141960]=211;c[141962]=212;c[141964]=213;i=a;return}function KXd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=c[174270]|0;g=c[153084]|0;if(f){c[f>>2]=697096;if((c[f+32>>2]|0)>-1){h=f+20|0;j=c[h>>2]|0;c[d>>2]=c[f+24>>2];c[b+0>>2]=c[d+0>>2];eOb(j,b);c[h>>2]=0}if((c[f+16>>2]|0)>-1){h=f+4|0;j=c[h>>2]|0;c[d>>2]=c[f+8>>2];c[b+0>>2]=c[d+0>>2];eOb(j,b);c[h>>2]=0}}c[e>>2]=g;c[b+0>>2]=c[e+0>>2];eOb(f,b);c[174270]=0;i=a;return}function LXd(){return c[174270]|0}function MXd(){var a=0,b=0;a=i;b=c[174270]|0;ko[c[(c[b>>2]|0)+4>>2]&4095](b);i=a;return}function NXd(){var a=0,b=0;a=i;b=c[174270]|0;ko[c[(c[b>>2]|0)+12>>2]&4095](b);i=a;return}function OXd(){var a=0,b=0;a=i;b=c[174270]|0;ko[c[(c[b>>2]|0)+8>>2]&4095](b);i=a;return}function PXd(){var a=0,b=0;a=i;b=c[174270]|0;ko[c[c[b>>2]>>2]&4095](b);i=a;return}function QXd(a,b){a=a|0;b=b|0;var d=0;c[a>>2]=697120;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;d=a+16|0;c[d+0>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;d=c[b>>2]|0;c[a+32>>2]=678584;c[a+36>>2]=d;return}function RXd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;c[a>>2]=697120;d=a+8|0;e=c[d>>2]|0;f=a+4|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=a+32|0;a=g;g=0;while(1){tYd(c[a+(g<<3)>>2]|0,h);g=g+1|0;j=c[d>>2]|0;k=c[f>>2]|0;l=k;if(g>>>0>=j-l>>3>>>0){m=j;n=k;o=l;break}else a=k}if((m|0)==(n|0)){p=m;q=m}else{a=m+(~((m+-8-o|0)>>>3)<<3)|0;c[d>>2]=a;p=n;q=a}}else{p=e;q=e}if(!p){i=b;return}if((q|0)!=(p|0))c[d>>2]=q+(~((q+-8-p|0)>>>3)<<3);ACi(p);i=b;return}function SXd(a){a=a|0;var b=0;b=i;RXd(a);ACi(a);i=b;return}function TXd(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[a+24>>2]|0;h=c[a+20>>2]|0;if((h|0)==-1){j=0;i=e;return j|0}k=c[a+16>>2]|0;l=f+1|0;if((k|0)>0){m=(l|0)%(k|0)|0;n=c[a+4>>2]|0;o=f;p=h;q=h;while(1){r=ea(g[n+(p<<3)+4>>2])>b;s=r?q:o;t=(p+1|0)%(k|0)|0;if((t|0)==(m|0)|r){u=n;v=s;break}else{r=p;o=s;p=t;q=r}}}else{q=c[a+4>>2]|0;p=f;f=h;o=h;while(1){h=ea(g[q+(f<<3)+4>>2])>b;n=h?o:p;m=f+1|0;if((m|0)==(l|0)|h){u=q;v=n;break}else{h=f;p=n;f=m;o=h}}}g[d>>2]=ea(g[u+(v<<3)+4>>2]);c[a+28>>2]=v;j=c[u+(v<<3)>>2]|0;i=e;return j|0}function UXd(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;h=e+8|0;j=a+16|0;if((c[j>>2]|0)==-1){Krd(697128,0,3653512,93,512,0,0,0);i=e;return}c[f>>2]=0;k=f+4|0;g[k>>2]=ea(0.0);l=a+20|0;m=a+28|0;if((c[l>>2]|0)!=-1)g[k>>2]=ea(ea(g[(c[a+4>>2]|0)+(c[m>>2]<<3)+4>>2])+b);c[h>>2]=0;k=a+32|0;c[f>>2]=CWd(d,k,h)|0;h=c[j>>2]|0;j=(h|0)>0;d=(c[m>>2]|0)+1|0;if(j)n=(d|0)%(h|0)|0;else n=d;c[m>>2]=n;d=c[l>>2]|0;if((d|0)==(n|0)|(d|0)==-1){o=d+1|0;if(j)p=(o|0)%(h|0)|0;else p=o;c[l>>2]=p}c[a+24>>2]=n;p=a+4|0;if(j){tYd(c[(c[p>>2]|0)+(n<<3)>>2]|0,k);k=f;n=c[k+4>>2]|0;j=(c[p>>2]|0)+(c[m>>2]<<3)|0;c[j>>2]=c[k>>2];c[j+4>>2]=n;i=e;return}n=a+8|0;j=c[n>>2]|0;if((j|0)==(c[a+12>>2]|0)){XXd(p,f);i=e;return}if(!j)q=0;else{p=f;f=c[p+4>>2]|0;a=j;c[a>>2]=c[p>>2];c[a+4>>2]=f;q=c[n>>2]|0}c[n>>2]=q+8;i=e;return}function VXd(a){a=a|0;var b=0,d=0,e=Im;b=i;d=c[a+28>>2]|0;if((d|0)==-1){e=ea(-1.0);i=b;return ea(e)}e=ea(g[(c[a+4>>2]|0)+(d<<3)+4>>2]);i=b;return ea(e)}function WXd(a){a=a|0;var b=0,d=Im;b=i;if((c[a+28>>2]|0)==-1){d=ea(-1.0);i=b;return ea(d)}d=ea(g[(c[a+4>>2]|0)+(c[a+24>>2]<<3)+4>>2]);i=b;return ea(d)}function XXd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>3)+1|0;if(g>>>0>536870911)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>3>>>0<268435455){l=k>>2;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>3;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=536870911;r=l>>3;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<3)|0;o=r;p=s}s=n+(o<<3)|0;if(s){r=b;b=c[r+4>>2]|0;q=s;c[q>>2]=c[r>>2];c[q+4>>2]=b}YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<3);c[h>>2]=n+(m<<3);if(!f){i=d;return}ACi(f);i=d;return}function YXd(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[b>>2]|0;c[a>>2]=g;if((g|0)==-1)h=-1;else{b=c[572464+((g&255^47)<<2)>>2]^g>>>8;c[a>>2]=b;h=b}b=SEi(e|0)|0;g=e+b|0;if((b|0)>0){j=h;k=e}else{i=f;return}do{j=c[572464+(((d[k>>0]|0)^j&255)<<2)>>2]^j>>>8;c[a>>2]=j;k=k+1|0}while((k|0)!=(g|0));i=f;return}function ZXd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;i=i+16|0;h=g;if((c[b>>2]|0)>>>0<=e>>>0){j=0;i=g;return j|0}k=b+4|0;l=k;m=b+12|0;n=m;o=a+148|0;p=a+140|0;a=0;q=0;r=e;while(1){a:do if((c[(c[k>>2]|0)+l+(r<<3)>>2]|0)==(e|0)){s=-1;t=0;u=0;while(1){if(!(s&1))v=u;else v=1<<31-t|u;t=t+1|0;if((t|0)==32){w=v;break}else{s=s>>>1;u=v}}c[h>>2]=w;u=c[(c[m>>2]|0)+n+(r<<2)>>2]|0;s=c[o>>2]|0;if((s|0)>0){t=0;while(1){x=(t+a|0)%(s|0)|0;y=c[(c[p>>2]|0)+(x<<2)>>2]|0;z=mo[c[(c[y>>2]|0)+32>>2]&4095](y)|0;y=c[f>>2]|0;if((y|0)==-1)A=-1;else A=c[572464+((y&255^47)<<2)>>2]^y>>>8;y=SEi(z|0)|0;B=z+y|0;if((y|0)>0){y=A;C=z;while(1){z=c[572464+(((d[C>>0]|0)^y&255)<<2)>>2]^y>>>8;C=C+1|0;if((C|0)==(B|0)){D=z;break}else y=z}}else D=A;t=t+1|0;if((u|0)==(~D|0)){E=x;F=D;break}if((t|0)>=(s|0)){G=a;H=q;break a}}c[h>>2]=F;s=c[(c[p>>2]|0)+(E<<2)>>2]|0;if(s){G=a+1|0;H=q+1+(ZXd(s,b,r,h)|0)|0}else{G=a;H=q}}else{G=a;H=q}}else{G=a;H=q}while(0);r=r+1|0;if(r>>>0>=(c[b>>2]|0)>>>0){j=H;break}else{a=G;q=H}}i=g;return j|0}function _Xd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+8|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;j=b+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0>l>>>0){m=k<<1;n=(m|0)==0?1:m;do if(l>>>0<n>>>0)if((k|0)>-1){c[j>>2]=n;m=c[b>>2]|0;c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];c[b>>2]=hOb(m,n<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+4>>2];c[e+0>>2]=c[f+0>>2];m=cOb(n<<2,4,e,0,3653512,352)|0;YEi(m|0,c[b>>2]|0,c[g>>2]<<2|0)|0;c[j>>2]=n;c[b>>2]=m;break}while(0);o=c[g>>2]|0}else o=h;c[(c[b>>2]|0)+(o+-1<<2)>>2]=a;o=c[a+148>>2]|0;if((o|0)<=0){i=d;return}h=a+140|0;a=0;do{_Xd(c[(c[h>>2]|0)+(a<<2)>>2]|0,b);a=a+1|0}while((a|0)!=(o|0));i=d;return}function $Xd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+8|0;l=g;m=c[153134]|0;c[k>>2]=0;n=k+4|0;c[n>>2]=m;o=k+8|0;c[o>>2]=0;p=k+12|0;c[p>>2]=0;q=c[a>>2]|0;r=q<<1;if(r){c[p>>2]=r;c[j>>2]=m;c[h+0>>2]=c[j+0>>2];c[k>>2]=hOb(0,q<<3,4,h,0,3653512,370)|0}_Xd(e,k);e=c[o>>2]|0;if((e|0)>0){o=c[k>>2]|0;q=0;m=0;r=0;while(1){s=o+(r<<2)|0;t=c[s>>2]|0;if(!f){u=t+140|0;v=t+148|0;w=c[v>>2]|0;if(!w)x=0;else{y=c[u>>2]|0;z=c[a>>2]|0;A=w;w=y;B=0;C=y;while(1){if(!z){D=w;E=A;F=0;G=B}else{y=0;H=B;while(1){I=c[b+(y<<2)>>2]|0;J=c[C>>2]|0;K=mo[c[(c[J>>2]|0)+32>>2]&4095](J)|0;J=-1;L=0;M=0;while(1){if(!(J&1))N=M;else N=1<<31-L|M;L=L+1|0;if((L|0)==32){O=N;break}else{J=J>>>1;M=N}}M=SEi(K|0)|0;J=K+M|0;if((M|0)>0){M=O;L=K;while(1){P=c[572464+(((d[L>>0]|0)^M&255)<<2)>>2]^M>>>8;L=L+1|0;if((L|0)==(J|0)){Q=P;break}else M=P}}else Q=O;M=((I|0)==(~Q|0)&1)+H|0;y=y+1|0;J=c[a>>2]|0;if(y>>>0>=J>>>0){R=J;S=M;break}else H=M}D=c[u>>2]|0;E=c[v>>2]|0;F=R;G=S}C=C+4|0;if((C|0)==(D+(E<<2)|0)){x=G;break}else{z=F;A=E;w=D;B=G}}}}else{B=-1;w=0;A=0;while(1){if(!(B&1))T=A;else T=1<<31-w|A;w=w+1|0;if((w|0)==32){U=T;break}else{B=B>>>1;A=T}}c[l>>2]=U;x=ZXd(t,a,0,l)|0}if((x|0)>(m|0)){V=c[s>>2]|0;W=x}else{V=q;W=m}A=r;r=r+1|0;if(!(W>>>0<(e+~A|0)>>>0&(r|0)<(e|0))){X=V;break}else{q=V;m=W}}}else X=0;if((c[p>>2]|0)<=-1){i=g;return X|0}p=c[k>>2]|0;c[j>>2]=c[n>>2];c[h+0>>2]=c[j+0>>2];eOb(p,h);c[k>>2]=0;i=g;return X|0}function aYd(a){a=a|0;var b=0,d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0;b=i;i=i+112|0;d=b+96|0;f=b+80|0;h=b+68|0;j=b+64|0;k=b;l=c[a>>2]|0;c[j>>2]=0;m=SVd(l,j)|0;if(!m){Krd(697184,0,3653512,46,1,0,0,0);l=a+12|0;if((c[l>>2]|0)>0){n=a+20|0;o=0;do{ZLc((c[n>>2]|0)+(o<<6)|0)|0;o=o+1|0}while((o|0)<(c[l>>2]|0))}}else{l=m+4|0;m=c[a+8>>2]|0;o=l;n=(c[l>>2]|0)+o|0;p=ea(g[n+(m*48|0)>>2]);q=ea(g[n+(m*48|0)+4>>2]);r=ea(g[n+(m*48|0)+8>>2]);s=ea(g[n+(m*48|0)+16>>2]);t=ea(g[n+(m*48|0)+20>>2]);u=ea(g[n+(m*48|0)+24>>2]);v=ea(g[n+(m*48|0)+28>>2]);w=ea(-s);x=ea(-t);y=ea(-u);z=ea(ea(0.0)-p);p=ea(ea(0.0)-q);q=ea(ea(0.0)-r);r=ea(z+z);A=ea(p+p);B=ea(q+q);C=ea(v*ea(0.0));D=ea(ea(A*w)-ea(r*x));E=ea(ea(B*x)-ea(A*y));A=ea(ea(r*y)-ea(B*w));B=ea(ea(p+ea(v*A))+ea(ea(E*y)-ea(D*w)));p=ea(ea(q+ea(v*D))+ea(ea(A*w)-ea(E*x)));w=ea(t*ea(-0.0));q=ea(u*ea(-0.0));r=ea(s*ea(-0.0));F=ea(ea(u+ea(w-C))-r);u=ea(ea(ea(v-r)-q)-w);G=ea(s+ea(ea(q-w)-C));w=ea(t+ea(ea(r-q)-C));C=ea(ea(1.0)/ea(T(ea(ea(ea(G*G)+ea(w*w))+ea(ea(u*u)+ea(F*F))))));q=ea(C*G);G=ea(C*w);w=ea(C*F);F=ea(C*u);g[d>>2]=ea(ea(z+ea(v*E))+ea(ea(D*x)-ea(A*y)));g[d+4>>2]=B;g[d+8>>2]=p;p=ea(ea(1.0)/ea(T(ea(ea(ea(q*q)+ea(G*G))+ea(ea(F*F)+ea(w*w))))));B=ea(-ea(G*p));G=ea(-ea(w*p));w=ea(F*p);g[f>>2]=ea(-ea(q*p));g[f+4>>2]=B;g[f+8>>2]=G;g[f+12>>2]=w;g[h>>2]=ea(1.0);g[h+4>>2]=ea(1.0);g[h+8>>2]=ea(1.0);vMc(k,d,f,h);m=a+12|0;if((c[m>>2]|0)>0){n=a+4|0;H=a+20|0;I=d+4|0;J=d+8|0;K=f+4|0;L=f+8|0;M=f+12|0;N=h+4|0;O=h+8|0;P=0;do{Q=e[(c[n>>2]|0)+(P<<1)>>1]|0;R=(c[l>>2]|0)+o|0;S=(c[H>>2]|0)+(P<<6)|0;w=ea(g[R+(Q*48|0)>>2]);G=ea(g[R+(Q*48|0)+4>>2]);B=ea(g[R+(Q*48|0)+8>>2]);g[d>>2]=w;g[I>>2]=G;g[J>>2]=B;B=ea(g[R+(Q*48|0)+16>>2]);G=ea(B*B);w=ea(g[R+(Q*48|0)+20>>2]);p=ea(w*w);q=ea(g[R+(Q*48|0)+24>>2]);F=ea(q*q);y=ea(g[R+(Q*48|0)+28>>2]);A=ea(ea(1.0)/ea(T(ea(ea(G+p)+ea(F+ea(y*y))))));F=ea(w*A);w=ea(q*A);q=ea(y*A);g[f>>2]=ea(B*A);g[K>>2]=F;g[L>>2]=w;g[M>>2]=q;q=ea(g[R+(Q*48|0)+32>>2]);w=ea(g[R+(Q*48|0)+36>>2]);F=ea(g[R+(Q*48|0)+40>>2]);g[h>>2]=q;g[N>>2]=w;g[O>>2]=F;vMc(S,d,f,h);P=P+1|0}while((P|0)<(c[m>>2]|0))}}XVd(c[j>>2]|0);j=a+16|0;m=c[j>>2]|0;if(!m){U=c[153136]|0;c[h>>2]=U;c[d+0>>2]=c[h+0>>2];eOb(a,d);i=b;return}P=c[a+20>>2]|0;BMc(k,P,c[m+120>>2]|0,P,c[a+12>>2]|0);P=c[j>>2]|0;j=c[153074]|0;m=P+4|0;c[m>>2]=(c[m>>2]|0)+-1;if(c[m>>2]|0){U=c[153136]|0;c[h>>2]=U;c[d+0>>2]=c[h+0>>2];eOb(a,d);i=b;return}ko[c[c[P>>2]>>2]&4095](P);c[f>>2]=j;c[d+0>>2]=c[f+0>>2];eOb(P,d);U=c[153136]|0;c[h>>2]=U;c[d+0>>2]=c[h+0>>2];eOb(a,d);i=b;return}function bYd(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;j=d;k=d+4|0;if(a[e+469>>0]|0){l=0;i=d;return l|0}m=eWd(e)|0;if(!m){l=0;i=d;return l|0}n=(c[m>>2]|0)+m|0;o=n;c[m+4>>2]=o;if(!n){l=0;i=d;return l|0}if(!g){l=1;i=d;return l|0}else p=0;do{n=u$d(o,c[f+(p<<2)>>2]|0)|0;q=(n|0)!=-1;b[h+(p<<1)>>1]=n;p=p+1|0}while(!(p>>>0>=g>>>0|q^1));if(q){l=1;i=d;return l|0}q=dWd(e)|0;e=(q|0)!=0;if(e)r=mo[c[(c[q>>2]|0)+32>>2]&4095](q)|0;else r=697224;c[j>>2]=r;Lsd(k,697232,j);if(!(a[k>>0]&1))s=k+1|0;else s=c[k+8>>2]|0;if(e)t=c[q+4>>2]|0;else t=0;Krd(s,0,3653512,45,1,t,0,0);xri(k);l=0;i=d;return l|0}function cYd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;yUd(qUd()|0,b,c,d);i=a;return}function dYd(a,b){a=a|0;b=b|0;return b+120|0}function eYd(a){a=a|0;return}function fYd(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function gYd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+8|0;c[e>>2]=b;c[a+4>>2]=mo[c[(c[b>>2]|0)+4>>2]&4095](b)|0;b=c[e>>2]|0;c[a>>2]=mo[c[(c[b>>2]|0)+8>>2]&4095](b)|0;i=d;return}function hYd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=i;i=i+256|0;h=g+8|0;j=g+232|0;k=g+236|0;l=g+16|0;m=g;n=g+228|0;o=g+216|0;p=c[b>>2]|0;q=c[p+4>>2]|0;r=c[p+8>>2]|0;p=r-q>>4;if(!p)s=q;else{t=c[d>>2]|0;u=c[d+4>>2]|0;v=q;q=p;while(1){p=(q|0)/2|0;w=c[v+(p<<4)>>2]|0;if((w|0)==(t|0))if((c[v+(p<<4)+4>>2]|0)<(u|0))x=6;else{y=v;z=p}else if(w>>>0<t>>>0)x=6;else{y=v;z=p}if((x|0)==6){x=0;y=v+(p+1<<4)|0;z=q+-1-p|0}if(!z){s=y;break}else{v=y;q=z}}}do if((s|0)==(r|0)){A=0;B=0}else{z=c[d>>2]|0;q=c[s>>2]|0;if((z|0)==(q|0)){if((c[d+4>>2]|0)<(c[s+4>>2]|0)){A=0;B=0;break}}else if(z>>>0<q>>>0){A=0;B=0;break}q=s+8|0;A=c[q>>2]|0;B=c[q+4>>2]|0}while(0);s=A+B|0;if(A>>>0>=s>>>0){C=0;i=g;return C|0}B=b+8|0;d=b+4|0;r=k+1|0;q=k+8|0;z=l+32|0;y=l+12|0;v=l+25|0;t=l+16|0;u=A;A=0;while(1){p=c[B>>2]|0;if(!(mo[c[c[p>>2]>>2]&4095](p)|0)){C=A;x=44;break}p=c[(c[(c[b>>2]|0)+16>>2]|0)+(u<<2)>>2]|0;w=c[d>>2]|0;a:do if(p>>>0<(c[w+8>>2]|0)>>>0?(D=(c[w>>2]|0)+(p<<2)|0,E=c[D>>2]|0,(E|0)!=0):0){c[j>>2]=E;E=c[137784]|0;if(E){do if((c[E+36>>2]|0)!=(c[E+4>>2]|0)){fRb(h,E,j);F=c[h>>2]|0;G=c[E+28>>2]|0;if((F|0)==-1){H=G+(c[E+32>>2]<<3)|0;break}else{H=G+(F<<3)|0;break}}else H=(c[E+28>>2]|0)+(c[E+32>>2]<<3)|0;while(0);E=c[137784]|0;if((H|0)!=((c[E+28>>2]|0)+(c[E+32>>2]<<3)|0)?(E=c[H+4>>2]|0,(E|0)!=0):0)I=E;else x=26}else x=26;if((x|0)==26){x=0;E=hQb(c[D>>2]|0)|0;if(!E){J=A;break}else I=E}E=I+20|0;if((c[E>>2]|0)!=0?(a[I+28>>0]|0)!=0:0){switch(f|0){case 2:{K=20;break}case 4:{K=21;break}case 8:{K=22;break}case 16:{K=23;break}case 32:{K=24;break}case 64:{K=25;break}case 1:{K=19;break}default:{c[h>>2]=f;Lsd(k,697448,h);F=c[B>>2]|0;if(!(mo[c[(c[F>>2]|0)+12>>2]&4095](F)|0))L=0;else{F=c[B>>2]|0;L=c[(mo[c[(c[F>>2]|0)+12>>2]&4095](F)|0)+4>>2]|0}Krd((a[k>>0]&1)==0?r:c[q>>2]|0,0,3653512,58,512,L,0,0);xri(k);J=A;break a}}F=(c[I+52>>2]|0)+(K<<3)|0;G=c[F>>2]|0;M=c[F+4>>2]|0;if(G){F=m;c[F>>2]=G;c[F+4>>2]=M;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];jbd(l,h);c[n>>2]=0;YEi(z|0,e|0,164)|0;c[y>>2]=c[E>>2];a[v>>0]=0;c[t>>2]=c[I+4>>2];qbd(l,n)|0;M=c[n>>2]|0;if(!M)N=1;else{F=Grc(c[E>>2]|0)|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Rcd(M,F,o);xri(o);N=(c[n>>2]|0)==0}J=A|N}else J=A}else J=A}else J=A;while(0);u=u+1|0;if(u>>>0>=s>>>0){C=J;x=44;break}else A=J}if((x|0)==44){i=g;return C|0}return 0}function iYd(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;a=mo[c[c[d>>2]>>2]&4095](d)|0;i=b;return a|0}function jYd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+176|0;g=f;h=f+168|0;Zad(g);j=c[a+8>>2]|0;cbd(g,Ecd(mo[c[(c[j>>2]|0)+12>>2]&4095](j)|0)|0);dbd(g,b);$ad(g,d);c[h>>2]=c[b+8>>2];c[h+4>>2]=d;d=hYd(a,h,g,e)|0;i=f;return d|0}function kYd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+176|0;f=e;g=e+168|0;Zad(f);h=c[a+8>>2]|0;cbd(f,Ecd(mo[c[(c[h>>2]|0)+12>>2]&4095](h)|0)|0);$ad(f,b);c[g>>2]=b;c[g+4>>2]=0;b=hYd(a,g,f,d)|0;i=e;return b|0}function lYd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=xo[c[c[d>>2]>>2]&2047](d,12,4)|0;if(!f)g=0;else{c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;g=f}f=c[a+8>>2]|0;c[g>>2]=f;if(f){h=xo[c[c[d>>2]>>2]&2047](d,f<<2,4)|0;f=c[g>>2]|0;j=g+4|0;c[j>>2]=h;if(f){h=a+12|0;if(b){b=0;a=f;k=0;while(1){l=c[h>>2]|0;m=c[l+(k*36|0)>>2]|0;if(!m){c[(c[j>>2]|0)+(k<<2)>>2]=0;n=a;o=b}else{p=c[l+(k*36|0)+8>>2]|0;l=m+1040|0;q=(c[l>>2]|0)+l|0;c[m+1044>>2]=q;m=YZd(q,p,d)|0;c[(c[j>>2]|0)+(k<<2)>>2]=m;n=c[g>>2]|0;o=b>>>0<p>>>0?p:b}k=k+1|0;if(k>>>0>=n>>>0){r=o;break}else{b=o;a=n}}}else{n=0;a=f;f=0;while(1){o=c[(c[h>>2]|0)+(f*36|0)>>2]|0;if(!o){c[(c[j>>2]|0)+(f<<2)>>2]=0;s=a;t=n}else{b=zZd(o)|0;k=o+1040|0;p=(c[k>>2]|0)+k|0;c[o+1044>>2]=p;o=YZd(p,b,d)|0;c[(c[j>>2]|0)+(f<<2)>>2]=o;s=c[g>>2]|0;t=n>>>0<b>>>0?b:n}f=f+1|0;if(f>>>0>=s>>>0){r=t;break}else{n=t;a=s}}}}else r=0}else{c[g+4>>2]=0;r=0}c[g+8>>2]=_Zd(r,d)|0;i=e;return g|0}function mYd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!a){i=d;return}e=a+4|0;if(c[a>>2]|0){f=0;do{ZZd(c[(c[e>>2]|0)+(f<<2)>>2]|0,b);f=f+1|0}while(f>>>0<(c[a>>2]|0)>>>0)}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[e>>2]|0);$Zd(c[a+8>>2]|0,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function nYd(){var a=0;a=i;Ydd(697472,697488,697504);Ydd(697472,697528,697544);i=a;return}function oYd(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0;l=i;m=xo[c[c[k>>2]>>2]&2047](k,148,4)|0;if(!m)n=0;else{o=m+68|0;p=m+0|0;q=p+68|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));c[o>>2]=-1;o=m+72|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;g[m+100>>2]=ea(1.0);g[m+104>>2]=ea(1.0);g[m+108>>2]=ea(1.0);g[m+112>>2]=ea(1.0);g[m+116>>2]=ea(1.0);o=m+120|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;n=m}if(!a)r=0;else r=a-n|0;c[n>>2]=r;r=n+4|0;c[r>>2]=a;m=n+8|0;if(!b)s=0;else s=b-m|0;c[m>>2]=s;c[n+12>>2]=b;b=n+16|0;if(!d)t=0;else t=d-b|0;c[b>>2]=t;c[n+20>>2]=d;d=n+36|0;t=(e|0)==0;if(t)u=0;else u=e-d|0;c[d>>2]=u;c[n+40>>2]=e;u=n+120|0;if(!f)v=0;else v=f-u|0;c[u>>2]=v;v=n+124|0;c[v>>2]=f;c[n+68>>2]=h;w=ea(g[j>>2]);x=ea(g[j+4>>2]);y=ea(g[j+8>>2]);z=ea(g[j+12>>2]);g[n+72>>2]=w;g[n+76>>2]=x;g[n+80>>2]=y;g[n+84>>2]=z;z=ea(g[j+16>>2]);y=ea(g[j+20>>2]);x=ea(g[j+24>>2]);w=ea(g[j+28>>2]);g[n+88>>2]=z;g[n+92>>2]=y;g[n+96>>2]=x;g[n+100>>2]=w;w=ea(g[j+32>>2]);x=ea(g[j+36>>2]);y=ea(g[j+40>>2]);z=ea(g[j+44>>2]);g[n+104>>2]=w;g[n+108>>2]=x;g[n+112>>2]=y;g[n+116>>2]=z;if(t){if((h|0)==-1){i=l;return n|0}h=c[f>>2]|0;c[n+136>>2]=h;f=n+140|0;if((h|0)!=0?(t=xo[c[c[k>>2]>>2]&2047](k,h<<2,4)|0,(t|0)!=0):0)A=t-f|0;else A=0;c[f>>2]=A;t=A+f|0;c[n+144>>2]=t;f=(c[u>>2]|0)+u|0;c[v>>2]=f;v$d(t,f,a);i=l;return n|0}f=e+48|0;t=f;v=(c[f>>2]|0)+t|0;u=e+52|0;c[u>>2]=v;e=c[v>>2]|0;c[n+44>>2]=e;v=n+48|0;if((e|0)!=0?(A=xo[c[c[k>>2]>>2]&2047](k,e<<2,4)|0,(A|0)!=0):0)B=A-v|0;else B=0;c[v>>2]=B;A=n+52|0;e=v;h=B+e|0;c[A>>2]=h;B=(c[f>>2]|0)+t|0;c[u>>2]=B;v$d(h,B,a);B=(c[n>>2]|0)+n|0;c[r>>2]=B;r=c[B>>2]|0;c[n+56>>2]=r;B=n+60|0;if((r|0)!=0?(h=xo[c[c[k>>2]>>2]&2047](k,r<<2,4)|0,(h|0)!=0):0)C=h-B|0;else C=0;c[B>>2]=C;h=C+B|0;c[n+64>>2]=h;B=(c[v>>2]|0)+e|0;c[A>>2]=B;A=(c[f>>2]|0)+t|0;c[u>>2]=A;w$d(h,B,A,a);i=l;return n|0}function pYd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+48|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+52>>2]=h;In[g&4095](b,h)}h=a+60|0;g=c[h>>2]|0;if(g){e=c[(c[b>>2]|0)+4>>2]|0;f=g+h|0;c[a+64>>2]=f;In[e&4095](b,f)}f=a+140|0;e=c[f>>2]|0;if(e){h=c[(c[b>>2]|0)+4>>2]|0;g=e+f|0;c[a+144>>2]=g;In[h&4095](b,g)}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function qYd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0;b=i;e=xo[c[c[d>>2]>>2]&2047](d,28,4)|0;if(!e){f=0;i=b;return f|0}c[e>>2]=0;g[e+4>>2]=ea(0.0);c[e+8>>2]=-1;g[e+12>>2]=ea(1.0);g[e+16>>2]=ea(1.0);d=e+20|0;h=d;a[h>>0]=0;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;h=d+4|0;a[h>>0]=0;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;f=e;i=b;return f|0}function rYd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function sYd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;b=i;e=xo[c[c[d>>2]>>2]&2047](d,176,4)|0;if(!e){f=0;i=b;return f|0}d=e+36|0;h=e+0|0;j=h+36|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));g[d>>2]=ea(1.0);g[e+40>>2]=ea(1.0);g[e+44>>2]=ea(1.0);g[e+48>>2]=ea(1.0);g[e+52>>2]=ea(1.0);d=e+56|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[e+84>>2]=ea(1.0);g[e+88>>2]=ea(1.0);g[e+92>>2]=ea(1.0);g[e+96>>2]=ea(1.0);g[e+100>>2]=ea(1.0);d=e+104|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[e+132>>2]=ea(1.0);g[e+136>>2]=ea(1.0);g[e+140>>2]=ea(1.0);g[e+144>>2]=ea(1.0);g[e+148>>2]=ea(1.0);d=e+152|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;g[e+168>>2]=ea(.5);a[e+172>>0]=1;a[e+173>>0]=0;f=e;i=b;return f|0}function tYd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function uYd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=xo[c[c[d>>2]>>2]&2047](d,96,4)|0;if(!f)h=0;else{j=f+56|0;k=f+0|0;l=k+56|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));g[j>>2]=ea(1.0);g[f+72>>2]=ea(1.0);g[f+68>>2]=ea(1.0);g[f+64>>2]=ea(1.0);g[f+60>>2]=ea(1.0);j=f+76|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;a[j+16>>0]=0;h=f}f=b+36|0;j=c[f>>2]|0;if((j|0)!=0?(k=f,l=j+k|0,j=l+48|0,m=(c[j>>2]|0)+j|0,(c[m>>2]|0)!=0):0){if(!(c[b>>2]|0)){i=e;return h|0}c[l+52>>2]=m;c[h>>2]=q$d(m,d)|0;m=(c[f>>2]|0)+k|0;l=m+48|0;j=l+(c[l>>2]|0)|0;c[m+52>>2]=j;c[h+4>>2]=q$d(j,d)|0;j=(c[f>>2]|0)+k|0;k=j+48|0;f=k+(c[k>>2]|0)|0;c[j+52>>2]=f;c[h+8>>2]=q$d(f,d)|0;f=xo[c[c[d>>2]>>2]&2047](d,880,4)|0;if(!f)n=0;else{Q_d(f);n=f}c[h+20>>2]=n;i=e;return h|0}if((c[b+68>>2]|0)==-1){i=e;return h|0}n=b+120|0;f=c[n>>2]|0;if(!f){i=e;return h|0}j=n;k=f+j|0;f=b+124|0;c[f>>2]=k;c[h+12>>2]=q$d(k,d)|0;k=(c[n>>2]|0)+j|0;c[f>>2]=k;c[h+16>>2]=q$d(k,d)|0;i=e;return h|0}function vYd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}r$d(c[a+8>>2]|0,b);r$d(c[a+4>>2]|0,b);r$d(c[a>>2]|0,b);r$d(c[a+16>>2]|0,b);r$d(c[a+12>>2]|0,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+20>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function wYd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=xo[c[c[e>>2]>>2]&2047](e,20,4)|0;if(!g)h=0;else{c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;h=g}if(b){if(((c[a+36>>2]|0)!=0?(b=c[a>>2]|0,(b|0)!=0):0)?(g=b+a|0,(c[g>>2]|0)!=0):0){c[a+4>>2]=g;c[h+4>>2]=q$d(g,e)|0}}else{g=c[a>>2]|0;if((g|0)!=0?(b=g+a|0,(c[b>>2]|0)!=0):0){c[a+4>>2]=b;c[h+4>>2]=q$d(b,e)|0}}b=a+36|0;if((c[b>>2]|0)==0?!((c[a+68>>2]|0)!=-1|d):0){i=f;return h|0}c[h+8>>2]=YYd(e,4)|0;if(!(c[b>>2]|0)){i=f;return h|0}b=xo[c[c[e>>2]>>2]&2047](e,880,4)|0;if(!b)j=0;else{Q_d(b);j=b}c[h+12>>2]=j;j=xo[c[c[e>>2]>>2]&2047](e,880,4)|0;if(!j)k=0;else{Q_d(j);k=j}c[h+16>>2]=k;i=f;return h|0}function xYd(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!a){i=d;return}e=c[a>>2]|0;if(e)v_d(e,b);r$d(c[a+4>>2]|0,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+8>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+16>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+12>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function yYd(){var a=0;a=i;Ydd(697568,697592,697616);Ydd(697568,697632,697656);i=a;return}function zYd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=i;j=xo[c[c[h>>2]>>2]&2047](h,52,4)|0;if(!j)k=0;else{l=j+0|0;m=l+52|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));k=j}j=k+12|0;c[j>>2]=c[a>>2];n=c[a+12>>2]|0;c[k>>2]=n;o=k+4|0;if((n|0)!=0?(p=xo[c[c[h>>2]>>2]&2047](h,n<<3,4)|0,(p|0)!=0):0){q=p+(n<<3)|0;n=p;do{c[n>>2]=0;c[n+4>>2]=0;n=n+8|0}while((n|0)!=(q|0));r=p;s=p-o|0}else{r=0;s=0}c[o>>2]=s;s=k+8|0;c[s>>2]=r;r=k+16|0;p=c[j>>2]|0;if((p|0)!=0?(q=xo[c[c[h>>2]>>2]&2047](h,p*36|0,4)|0,(q|0)!=0):0){n=q+(p*36|0)|0;p=q;do{l=p+0|0;m=l+36|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));p=p+36|0}while((p|0)!=(n|0));t=q;u=q-r|0}else{t=0;u=0}c[r>>2]=u;u=k+20|0;c[u>>2]=t;t=k+24|0;q=c[j>>2]|0;if((q|0)!=0?(n=xo[c[c[h>>2]>>2]&2047](h,q*36|0,4)|0,(n|0)!=0):0){p=n+(q*36|0)|0;q=n;do{l=q+0|0;m=l+36|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));q=q+36|0}while((q|0)!=(p|0));v=n;w=n-t|0}else{v=0;w=0}c[t>>2]=w;w=k+28|0;c[w>>2]=v;v=k+32|0;n=c[j>>2]|0;if((n|0)!=0?(j=xo[c[c[h>>2]>>2]&2047](h,n<<2,4)|0,(j|0)!=0):0){x=j;y=j-v|0}else{x=0;y=0}c[v>>2]=y;y=k+36|0;c[y>>2]=x;x=k+40|0;j=a+24|0;n=(c[j>>2]|0)+j|0;c[a+28>>2]=n;j=u_d(n,h)|0;if(!j){z=x;A=0}else{n=x;z=n;A=j-n|0}c[x>>2]=A;x=a+32|0;n=(c[x>>2]|0)+x|0;c[a+36>>2]=n;x=A+z|0;c[k+44>>2]=x;w_d(n,x);if(c[a>>2]|0){x=a+4|0;n=x;z=v;A=r;j=t;p=b+36|0;q=b+68|0;b=p;l=0;do{m=(c[x>>2]|0)+n+(l<<3)|0;B=ea(g[m+(c[m>>2]|0)+32>>2]);m=(c[v>>2]|0)+z|0;c[y>>2]=m;g[m+(l<<2)>>2]=B;m=(c[r>>2]|0)+A|0;c[u>>2]=m;C=u_d(e,h)|0;D=m+(l*36|0)|0;if(!C)E=0;else E=C-D|0;c[D>>2]=E;c[m+(l*36|0)+4>>2]=C;C=(c[r>>2]|0)+A|0;c[u>>2]=C;m=s_d(e,h)|0;D=C+(l*36|0)+8|0;if(!m)F=0;else F=m-D|0;c[D>>2]=F;c[C+(l*36|0)+12>>2]=m;m=(c[t>>2]|0)+j|0;c[w>>2]=m;C=u_d(e,h)|0;D=m+(l*36|0)|0;if(!C)G=0;else G=C-D|0;c[D>>2]=G;c[m+(l*36|0)+4>>2]=C;C=(c[t>>2]|0)+j|0;c[w>>2]=C;m=s_d(e,h)|0;D=C+(l*36|0)+8|0;if(!m)H=0;else H=m-D|0;c[D>>2]=H;c[C+(l*36|0)+12>>2]=m;m=c[p>>2]|0;if((m|0)!=0?(C=m+b+48|0,(c[(c[C>>2]|0)+C>>2]|0)!=0):0){C=(c[r>>2]|0)+A|0;c[u>>2]=C;m=YYd(h,4)|0;D=C+(l*36|0)+16|0;if(!m)I=0;else I=m-D|0;c[D>>2]=I;c[C+(l*36|0)+20>>2]=m;m=(c[r>>2]|0)+A|0;c[u>>2]=m;C=xo[c[c[h>>2]>>2]&2047](h,880,4)|0;if(!C){J=0;K=0}else{Q_d(C);J=C-(m+(l*36|0)+24)|0;K=C}c[m+(l*36|0)+24>>2]=J;c[m+(l*36|0)+28>>2]=K;m=(c[t>>2]|0)+j|0;c[w>>2]=m;C=YYd(h,4)|0;D=m+(l*36|0)+16|0;if(!C)L=0;else L=C-D|0;c[D>>2]=L;c[m+(l*36|0)+20>>2]=C;C=(c[t>>2]|0)+j|0;c[w>>2]=C;m=xo[c[c[h>>2]>>2]&2047](h,880,4)|0;if(!m){M=0;N=0}else{Q_d(m);M=m-(C+(l*36|0)+24)|0;N=m}c[C+(l*36|0)+24>>2]=M;c[C+(l*36|0)+28>>2]=N}else O=47;do if((O|0)==47){O=0;C=(c[q>>2]|0)!=-1|f;m=(c[r>>2]|0)+A|0;c[u>>2]=m;if(!C){c[m+(l*36|0)+16>>2]=0;c[m+(l*36|0)+20>>2]=0;c[u>>2]=m;c[m+(l*36|0)+24>>2]=0;c[m+(l*36|0)+28>>2]=0;C=(c[t>>2]|0)+j|0;c[C+(l*36|0)+16>>2]=0;c[C+(l*36|0)+20>>2]=0;c[w>>2]=C;c[C+(l*36|0)+24>>2]=0;c[C+(l*36|0)+28>>2]=0;break}C=YYd(h,4)|0;D=m+(l*36|0)+16|0;if(!C)P=0;else P=C-D|0;c[D>>2]=P;c[m+(l*36|0)+20>>2]=C;C=(c[r>>2]|0)+A|0;c[u>>2]=C;c[C+(l*36|0)+24>>2]=0;c[C+(l*36|0)+28>>2]=0;C=(c[t>>2]|0)+j|0;c[w>>2]=C;m=YYd(h,4)|0;D=C+(l*36|0)+16|0;if(!m)Q=0;else Q=m-D|0;c[D>>2]=Q;c[C+(l*36|0)+20>>2]=m;m=(c[t>>2]|0)+j|0;c[w>>2]=m;c[m+(l*36|0)+24>>2]=0;c[m+(l*36|0)+28>>2]=0}while(0);l=l+1|0}while(l>>>0<(c[a>>2]|0)>>>0)}if(!(c[k>>2]|0)){i=d;return k|0}l=o;w=a+16|0;a=w;j=0;do{t=(c[o>>2]|0)+l|0;c[s>>2]=t;Q=t+(j<<3)|0;u=(c[w>>2]|0)+a|0;A=u+(j<<3)|0;r=A+(c[A>>2]|0)|0;c[u+(j<<3)+4>>2]=r;u=O$d(r,h)|0;if(!u)R=0;else R=u-Q|0;c[Q>>2]=R;c[t+(j<<3)+4>>2]=u;j=j+1|0}while(j>>>0<(c[k>>2]|0)>>>0);i=d;return k|0}function AYd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;if(!a){i=d;return}e=a+12|0;if(c[e>>2]|0){f=a+16|0;g=f;h=a+20|0;j=a+24|0;k=j;l=a+28|0;m=0;do{n=c[f>>2]|0;o=n+g|0;c[h>>2]=o;p=c[o+(m*36|0)>>2]|0;if(!p)q=n;else{c[h>>2]=o;n=o+(m*36|0)+p|0;c[o+(m*36|0)+4>>2]=n;v_d(n,b);q=c[f>>2]|0}n=q+g|0;c[h>>2]=n;o=c[n+(m*36|0)+8>>2]|0;if(!o)r=q;else{c[h>>2]=n;p=n+(m*36|0)+8+o|0;c[n+(m*36|0)+12>>2]=p;t_d(p,b);r=c[f>>2]|0}p=r+g|0;c[h>>2]=p;n=c[p+(m*36|0)+16>>2]|0;if(!n)s=r;else{o=c[(c[b>>2]|0)+4>>2]|0;c[h>>2]=p;t=p+(m*36|0)+16+n|0;c[p+(m*36|0)+20>>2]=t;In[o&4095](b,t);s=c[f>>2]|0}t=s+g|0;c[h>>2]=t;o=c[t+(m*36|0)+24>>2]|0;if(o){p=c[(c[b>>2]|0)+4>>2]|0;c[h>>2]=t;n=t+(m*36|0)+24+o|0;c[t+(m*36|0)+28>>2]=n;In[p&4095](b,n)}n=c[j>>2]|0;p=n+k|0;c[l>>2]=p;t=c[p+(m*36|0)>>2]|0;if(!t)u=n;else{c[l>>2]=p;n=p+(m*36|0)+t|0;c[p+(m*36|0)+4>>2]=n;v_d(n,b);u=c[j>>2]|0}n=u+k|0;c[l>>2]=n;p=c[n+(m*36|0)+8>>2]|0;if(!p)v=u;else{c[l>>2]=n;t=n+(m*36|0)+8+p|0;c[n+(m*36|0)+12>>2]=t;t_d(t,b);v=c[j>>2]|0}t=v+k|0;c[l>>2]=t;n=c[t+(m*36|0)+16>>2]|0;if(!n)w=v;else{p=c[(c[b>>2]|0)+4>>2]|0;c[l>>2]=t;o=t+(m*36|0)+16+n|0;c[t+(m*36|0)+20>>2]=o;In[p&4095](b,o);w=c[j>>2]|0}o=w+k|0;c[l>>2]=o;p=c[o+(m*36|0)+24>>2]|0;if(p){t=c[(c[b>>2]|0)+4>>2]|0;c[l>>2]=o;n=o+(m*36|0)+24+p|0;c[o+(m*36|0)+28>>2]=n;In[t&4095](b,n)}m=m+1|0}while(m>>>0<(c[e>>2]|0)>>>0)}if(c[a>>2]|0){e=a+4|0;m=e;l=a+8|0;k=0;do{w=(c[e>>2]|0)+m|0;c[l>>2]=w;j=w+(k<<3)|0;v=j+(c[j>>2]|0)|0;c[w+(k<<3)+4>>2]=v;P$d(v,b);k=k+1|0}while(k>>>0<(c[a>>2]|0)>>>0)}k=a+40|0;l=(c[k>>2]|0)+k|0;c[a+44>>2]=l;v_d(l,b);l=a+32|0;k=c[l>>2]|0;if(k){m=c[(c[b>>2]|0)+4>>2]|0;e=k+l|0;c[a+36>>2]=e;In[m&4095](b,e)}e=a+16|0;m=c[e>>2]|0;if(m){l=c[(c[b>>2]|0)+4>>2]|0;k=m+e|0;c[a+20>>2]=k;In[l&4095](b,k)}k=a+24|0;l=c[k>>2]|0;if(l){e=c[(c[b>>2]|0)+4>>2]|0;m=l+k|0;c[a+28>>2]=m;In[e&4095](b,m)}m=a+4|0;e=c[m>>2]|0;if(e){k=c[(c[b>>2]|0)+4>>2]|0;l=e+m|0;c[a+8>>2]=l;In[k&4095](b,l)}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function BYd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;if(!a){i=d;return}e=a+16|0;if(!(c[e>>2]|0)){f=a;g=a+4|0;h=a+8|0;j=b}else{k=a+4|0;l=a+8|0;m=0;do{v_d(c[(c[a>>2]|0)+(m<<2)>>2]|0,b);n=c[k>>2]|0;if(n)In[c[(c[b>>2]|0)+4>>2]&4095](b,c[n+(m<<2)>>2]|0);n=c[l>>2]|0;if(n)In[c[(c[b>>2]|0)+4>>2]&4095](b,c[n+(m<<2)>>2]|0);m=m+1|0}while(m>>>0<(c[e>>2]|0)>>>0);f=a;g=k;h=l;j=b}In[c[(c[j>>2]|0)+4>>2]&4095](b,c[f>>2]|0);In[c[(c[j>>2]|0)+4>>2]&4095](b,c[g>>2]|0);In[c[(c[j>>2]|0)+4>>2]&4095](b,c[h>>2]|0);In[c[(c[j>>2]|0)+4>>2]&4095](b,c[a+12>>2]|0);In[c[(c[j>>2]|0)+4>>2]&4095](b,a);i=d;return}function CYd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=i;l=(c[d+68>>2]|0)!=-1|h;h=d+36|0;d=c[h>>2]|0;if(!d)m=0;else{n=d+h+48|0;m=(c[(c[n>>2]|0)+n>>2]|0)!=0}n=xo[c[c[j>>2]>>2]&2047](j,92,4)|0;if(!n)o=0;else{c[n>>2]=0;c[n+4>>2]=0;a[n+88>>0]=0;a[n+89>>0]=0;a[n+90>>0]=0;h=n+16|0;d=h+68|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(d|0));o=n}n=b+12|0;h=c[n>>2]|0;if(h){d=xo[c[c[j>>2]>>2]&2047](j,h<<2,4)|0;h=c[n>>2]|0;p=o+4|0;c[p>>2]=d;if(h){d=xo[c[c[j>>2]>>2]&2047](j,h<<2,4)|0;h=c[n>>2]|0;c[o>>2]=d;d=o+8|0;c[d>>2]=h;if(h){n=b+16|0;q=n;r=c[n>>2]|0;n=0;s=0;while(1){t=r+q+(s<<3)|0;u=c[t+(c[t>>2]|0)+40>>2]|0;t=n>>>0<u>>>0?u:n;s=s+1|0;if(s>>>0>=h>>>0){v=t;break}else n=t}if(v){n=v<<2;w=xo[c[c[j>>2]>>2]&2047](j,n,4)|0;x=n;y=d;z=p;A=o}else{w=0;x=0;y=d;z=p;A=o}}else{w=0;x=0;y=d;z=p;A=o}}else{B=p;C=9}}else{p=o+4|0;c[p>>2]=0;B=p;C=9}if((C|0)==9){c[o>>2]=0;C=o+8|0;c[C>>2]=0;w=0;x=0;y=C;z=B;A=o}c[o+12>>2]=w;PEi(w|0,0,x|0)|0;if(!(c[y>>2]|0))D=e;else{x=b+16|0;w=x;B=0;do{C=(c[x>>2]|0)+w|0;p=C+(B<<3)|0;d=p+(c[p>>2]|0)|0;c[C+(B<<3)+4>>2]=d;C=S$d(d,c[e>>2]|0,j)|0;c[(c[z>>2]|0)+(B<<2)>>2]=C;C=(c[x>>2]|0)+w|0;d=C+(B<<3)|0;p=d+(c[d>>2]|0)|0;c[C+(B<<3)+4>>2]=p;C=Q$d(p,c[e>>2]|0,j)|0;c[(c[A>>2]|0)+(B<<2)>>2]=C;B=B+1|0}while(B>>>0<(c[y>>2]|0)>>>0);D=e}e=c[D>>2]|0;y=xo[c[c[j>>2]>>2]&2047](j,20,4)|0;if(!y)E=0;else{c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;E=y}y=(e|0)==0;if(y){c[E>>2]=0;F=0;G=0;H=0}else{B=e<<2;c[E>>2]=xo[c[c[j>>2]>>2]&2047](j,B,4)|0;A=xo[c[c[j>>2]>>2]&2047](j,B,4)|0;F=A;G=B;H=c[E>>2]|0}B=E+12|0;c[B>>2]=F;PEi(H|0,0,G|0)|0;PEi(c[B>>2]|0,0,G|0)|0;if(l|m){if(y)I=0;else I=xo[c[c[j>>2]>>2]&2047](j,G,4)|0;c[E+4>>2]=I;PEi(I|0,0,G|0)|0}if(m){if(y)J=0;else J=xo[c[c[j>>2]>>2]&2047](j,G,4)|0;c[E+8>>2]=J;PEi(J|0,0,G|0)|0}c[E+16>>2]=e;e=o+16|0;c[e>>2]=E;if(!y)if(!m)if(l){y=0;do{E=u_d(f,j)|0;c[(c[c[e>>2]>>2]|0)+(y<<2)>>2]=E;E=YYd(j,4)|0;c[(c[(c[e>>2]|0)+4>>2]|0)+(y<<2)>>2]=E;y=y+1|0}while(y>>>0<(c[(c[e>>2]|0)+16>>2]|0)>>>0)}else{y=0;do{E=u_d(f,j)|0;c[(c[c[e>>2]>>2]|0)+(y<<2)>>2]=E;y=y+1|0}while(y>>>0<(c[(c[e>>2]|0)+16>>2]|0)>>>0)}else{y=0;do{E=u_d(f,j)|0;c[(c[c[e>>2]>>2]|0)+(y<<2)>>2]=E;E=YYd(j,4)|0;c[(c[(c[e>>2]|0)+4>>2]|0)+(y<<2)>>2]=E;E=xo[c[c[j>>2]>>2]&2047](j,880,4)|0;if(!E)K=0;else{Q_d(E);K=E}c[(c[(c[e>>2]|0)+8>>2]|0)+(y<<2)>>2]=K;y=y+1|0}while(y>>>0<(c[(c[e>>2]|0)+16>>2]|0)>>>0)}e=u_d(f,j)|0;y=o+20|0;if(!e)L=0;else L=e-y|0;c[y>>2]=L;c[o+24>>2]=e;if(!m){if(l){l=YYd(j,4)|0;m=o+36|0;if(!l)M=0;else M=l-m|0;c[m>>2]=M;c[o+40>>2]=l}}else{l=YYd(j,4)|0;M=o+36|0;if(!l)N=0;else N=l-M|0;c[M>>2]=N;c[o+40>>2]=l;l=xo[c[c[j>>2]>>2]&2047](j,880,4)|0;if(!l){O=0;P=0}else{Q_d(l);O=l-(o+44)|0;P=l}c[o+44>>2]=O;c[o+48>>2]=P}c[o+64>>2]=u_d(f,j)|0;c[o+68>>2]=u_d(f,j)|0;P=da(c[D>>2]|0,c[b>>2]|0)|0;if((P|0)!=0?(D=xo[c[c[j>>2]>>2]&2047](j,P<<5,4)|0,(D|0)!=0):0){O=D+(P<<5)|0;P=D;do{c[P>>2]=-1;c[P+4>>2]=-1;g[P+8>>2]=ea(0.0);g[P+12>>2]=ea(0.0);g[P+16>>2]=ea(0.0);g[P+20>>2]=ea(1.0);c[P+24>>2]=0;a[P+28>>0]=0;P=P+32|0}while((P|0)!=(O|0));Q=D}else Q=0;c[o+60>>2]=Q;c[o+72>>2]=s_d(f,j)|0;c[o+76>>2]=s_d(f,j)|0;c[o+80>>2]=s_d(f,j)|0;f=b+24|0;b=(c[f>>2]|0)+f|0;f=c[b>>2]|0;if(!f){R=0;S=o+84|0;c[S>>2]=R;i=k;return o|0}Q=b+4|0;b=c[Q>>2]|0;D=0;O=0;while(1){P=c[b+Q+(O<<4)+8>>2]|0;if((P|0)==9|(P|0)==4)T=D+1|0;else T=D;O=O+1|0;if(O>>>0>=f>>>0){U=T;break}else D=T}if(!U){R=0;S=o+84|0;c[S>>2]=R;i=k;return o|0}R=xo[c[c[j>>2]>>2]&2047](j,U,1)|0;S=o+84|0;c[S>>2]=R;i=k;return o|0}function DYd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+8|0;if(c[e>>2]|0){f=a+4|0;g=0;do{T$d(c[(c[f>>2]|0)+(g<<2)>>2]|0,b);R$d(c[(c[a>>2]|0)+(g<<2)>>2]|0,b);g=g+1|0}while(g>>>0<(c[e>>2]|0)>>>0)}BYd(c[a+16>>2]|0,b);e=a+20|0;g=(c[e>>2]|0)+e|0;c[a+24>>2]=g;v_d(g,b);g=a+36|0;e=c[g>>2]|0;if(e){f=c[(c[b>>2]|0)+4>>2]|0;h=e+g|0;c[a+40>>2]=h;In[f&4095](b,h)}h=a+44|0;f=c[h>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;e=f+h|0;c[a+48>>2]=e;In[g&4095](b,e)}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+60>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+12>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+4>>2]|0);v_d(c[a+64>>2]|0,b);v_d(c[a+68>>2]|0,b);t_d(c[a+72>>2]|0,b);t_d(c[a+76>>2]|0,b);t_d(c[a+80>>2]|0,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+84>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function EYd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=0,s=Im,t=Im,u=Im,v=Im,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=0,R=Im,U=Im,V=Im,W=Im,X=Im,Y=0,Z=Im,$=Im,aa=Im,ba=Im;k=i;i=i+240|0;l=k+192|0;m=k+144|0;n=k+96|0;o=k+48|0;p=k;q=ea(g[e+4>>2]);r=(a[e+20>>0]|0)==0;s=ea(g[f+8>>2]);t=ea(g[f+12>>2]);u=ea(g[f+16>>2]);v=ea(g[f+20>>2]);g[l>>2]=s;g[l+4>>2]=t;g[l+8>>2]=u;g[l+12>>2]=v;v=ea(g[f+24>>2]);u=ea(g[f+28>>2]);t=ea(g[f+32>>2]);s=ea(g[f+36>>2]);g[l+16>>2]=v;g[l+20>>2]=u;g[l+24>>2]=t;g[l+28>>2]=s;s=ea(g[f+40>>2]);t=ea(g[f+44>>2]);u=ea(g[f+48>>2]);v=ea(g[f+52>>2]);e=l+32|0;g[e>>2]=s;w=l+36|0;g[w>>2]=t;x=l+40|0;g[x>>2]=u;y=l+44|0;g[y>>2]=v;z=d+36|0;ZYd(m,l,h+28|0);A=ea(g[m>>2]);B=ea(A*A);A=ea(g[m+4>>2]);C=ea(A*A);A=ea(g[m+8>>2]);D=ea(A*A);A=ea(g[m+12>>2]);E=ea(ea(T(ea(ea(B+C)+ea(D+ea(A*A)))))/q);A=ea(g[m+28>>2]);l=A==ea(0.0);D=l?ea(9.99999997e-07):A;A=ea(ea(g[m+16>>2])/D);C=ea(ea(g[m+20>>2])/D);B=ea(ea(+_(+A))*ea(2.0));A=ea(ea(+_(+C))*ea(2.0));C=ea(ea(+_(+ea(ea(g[m+24>>2])/D)))*ea(2.0));D=ea(ea(+_(0.0))*ea(2.0));F=ea(D*D);D=ea(ea(T(ea(ea(ea(B*B)+ea(A*A))+ea(ea(C*C)+F))))/q);m=b&1^1;l=j+16|0;j=c[l>>2]|0;g[j+(m*76|0)+128>>2]=ea(1.0);g[j+(m*76|0)+132>>2]=ea(1.0);if(!r?(a[f+172>>0]|0)==0:0){C=ea(g[(b?h+76|0:h+84|0)>>2]);A=ea(E+C);C=ea(D+ea(g[(b?h+80|0:h+88|0)>>2]));h=b?f+56|0:f+104|0;D=ea(g[j+(m*76|0)+80>>2]);E=ea(g[j+(m*76|0)+84>>2]);B=ea(g[j+(m*76|0)+88>>2]);G=ea(g[j+(m*76|0)+92>>2]);H=ea(g[j+(m*76|0)+96>>2]);I=ea(g[j+(m*76|0)+100>>2]);J=ea(g[j+(m*76|0)+104>>2]);K=ea(g[j+(m*76|0)+108>>2]);L=ea(g[j+(m*76|0)+112>>2]);M=ea(g[j+(m*76|0)+116>>2]);N=ea(g[j+(m*76|0)+120>>2]);O=ea(g[j+(m*76|0)+124>>2]);g[n>>2]=D;g[n+4>>2]=E;g[n+8>>2]=B;g[n+12>>2]=G;g[n+16>>2]=H;g[n+20>>2]=I;g[n+24>>2]=J;g[n+28>>2]=K;g[n+32>>2]=L;g[n+36>>2]=M;g[n+40>>2]=N;g[n+44>>2]=O;ZYd(o,h,n);O=ea(g[o>>2]);N=ea(O*O);n=o+4|0;M=ea(g[n>>2]);L=ea(M*M);f=o+8|0;K=ea(g[f>>2]);J=ea(K*K);r=o+12|0;I=ea(g[r>>2]);H=ea(T(ea(ea(N+L)+ea(J+ea(I*I)))));if(H>ea(0.0)){J=ea(H/q);d=A>ea(.100000001);H=d?A:ea(0.0);if(H>ea(1.0))P=ea(H*ea(2.0));else P=H;H=ea((P<J?P:J)/J);J=ea(H*M);M=ea(H*K);K=ea(H*I);g[o>>2]=ea(H*O);g[n>>2]=J;g[f>>2]=M;g[r>>2]=K}r=o+28|0;K=ea(g[r>>2]);f=K==ea(0.0);M=f?ea(9.99999997e-07):K;f=o+16|0;K=ea(ea(g[f>>2])/M);n=o+20|0;J=ea(ea(g[n>>2])/M);d=o+24|0;O=ea(ea(+_(+K))*ea(2.0));K=ea(ea(+_(+J))*ea(2.0));J=ea(ea(+_(+ea(ea(g[d>>2])/M)))*ea(2.0));M=ea(T(ea(ea(ea(O*O)+ea(K*K))+ea(F+ea(J*J)))));if(M>ea(0.0)){F=ea(M/q);Q=C>ea(.17453292);q=Q?C:ea(0.0);if(q>ea(1.74532926))R=ea(q*ea(2.0));else R=q;q=ea((R<F?R:F)/F);F=ea(O*q);O=ea(K*q);K=ea(J*q);q=ea(ea(ea(ea(S(ea(O)))*ea(.5))+ea(1.57079637))+ea(-1.57079637));J=ea(ea(ea(ea(S(ea(K)))*ea(.5))+ea(1.57079637))+ea(-1.57079637));R=ea(PDi(ea(ea(ea(ea(S(ea(F)))*ea(.5))+ea(1.57079637))+ea(-1.57079637)),F));F=ea(PDi(q,O));O=ea(PDi(J,K));K=ea(VDi(ea(UDi(R,ea(-1.57079542))),ea(1.57079732)));R=ea(VDi(ea(UDi(F,ea(-1.57079542))),ea(1.57079732)));F=ea(K*ea(.159154937));K=ea(R*ea(.159154937));R=ea(ea(VDi(ea(UDi(O,ea(-1.57079542))),ea(1.57079732)))*ea(.159154937));O=ea(eEi(F));J=ea(eEi(K));q=ea(ea(.25)-ea(S(ea(F-O))));O=ea(ea(.25)-ea(S(ea(K-J))));J=ea(ea(.25)-ea(S(ea(R-ea(eEi(R))))));C=ea(q*q);M=ea(O*O);H=ea(J*J);I=ea(q*ea(ea(ea(C*ea(-41.2831841))+ea(6.28318548))+ea(ea(C*C)*ea(76.0354614))));C=ea(O*ea(ea(ea(M*ea(-41.2831841))+ea(6.28318548))+ea(ea(M*M)*ea(76.0354614))));M=ea(J*ea(ea(ea(H*ea(-41.2831841))+ea(6.28318548))+ea(ea(H*H)*ea(76.0354614))));H=ea(F+ea(-.25));F=ea(K+ea(-.25));K=ea(R+ea(-.25));R=ea(eEi(H));J=ea(eEi(F));O=ea(ea(.25)-ea(S(ea(H-R))));R=ea(ea(.25)-ea(S(ea(F-J))));J=ea(ea(.25)-ea(S(ea(K-ea(eEi(K))))));K=ea(O*O);F=ea(R*R);H=ea(J*J);q=ea(ea(O*ea(ea(ea(K*ea(-41.2831841))+ea(6.28318548))+ea(ea(K*K)*ea(76.0354614))))/I);I=ea(ea(R*ea(ea(ea(F*ea(-41.2831841))+ea(6.28318548))+ea(ea(F*F)*ea(76.0354614))))/C);C=ea(ea(J*ea(ea(ea(H*ea(-41.2831841))+ea(6.28318548))+ea(ea(H*H)*ea(76.0354614))))/M);M=ea(ea(1.0)/ea(T(ea(ea(ea(q*q)+ea(I*I))+ea(ea(C*C)+ea(1.0))))));H=ea(I*M);I=ea(C*M);g[f>>2]=ea(q*M);g[n>>2]=H;g[d>>2]=I;g[r>>2]=M;M=ea(g[e>>2]);I=ea(g[w>>2]);H=ea(g[x>>2]);U=M;V=I;W=H;X=ea(g[y>>2])}else{U=s;V=t;W=u;X=v}_Yd(p,h,o);H=ea(g[p>>2]);I=ea(g[p+4>>2]);M=ea(g[p+8>>2]);q=ea(g[p+12>>2]);g[h>>2]=H;g[h+4>>2]=I;g[h+8>>2]=M;g[h+12>>2]=q;C=ea(g[p+16>>2]);J=ea(g[p+20>>2]);F=ea(g[p+24>>2]);R=ea(g[p+28>>2]);o=h+16|0;g[o>>2]=C;y=h+20|0;g[y>>2]=J;x=h+24|0;g[x>>2]=F;w=h+28|0;g[w>>2]=R;R=ea(g[p+32>>2]);F=ea(g[p+36>>2]);J=ea(g[p+40>>2]);C=ea(g[p+44>>2]);p=h+32|0;g[p>>2]=R;e=h+36|0;g[e>>2]=F;r=h+40|0;g[r>>2]=J;d=h+44|0;g[d>>2]=C;h=c[l>>2]|0;g[h+(m*76|0)+80>>2]=H;g[h+(m*76|0)+84>>2]=I;g[h+(m*76|0)+88>>2]=M;g[h+(m*76|0)+92>>2]=q;q=ea(g[o>>2]);M=ea(g[y>>2]);I=ea(g[x>>2]);H=ea(g[w>>2]);g[h+(m*76|0)+96>>2]=q;g[h+(m*76|0)+100>>2]=M;g[h+(m*76|0)+104>>2]=I;g[h+(m*76|0)+108>>2]=H;H=ea(g[p>>2]);I=ea(g[e>>2]);M=ea(g[r>>2]);q=ea(g[d>>2]);g[h+(m*76|0)+112>>2]=H;g[h+(m*76|0)+116>>2]=I;g[h+(m*76|0)+120>>2]=M;g[h+(m*76|0)+124>>2]=q;Y=h;Z=U;$=V;aa=W;ba=X}else{Y=j;Z=s;$=t;aa=u;ba=v}v=b?ea(-1.0):ea(1.0);b=(c[z>>2]|0)+z|0;u=ea(v*ea(g[b+392>>2]));v=ea(u*ea(g[b+420>>2]));u=ea(v+v);t=ea(g[Y+(m*76|0)+96>>2]);s=ea(t*ea(0.0));X=ea(g[Y+(m*76|0)+100>>2]);W=ea(u*X);V=ea(g[Y+(m*76|0)+104>>2]);U=ea(V*ea(0.0));q=ea(g[Y+(m*76|0)+108>>2]);M=ea(q*ea(0.0));I=ea(s-ea(X*ea(0.0)));s=ea(W-U);W=ea(U-ea(t*u));u=ea(q*ea(M-M));M=ea(Z*ea(ea(ea(q*s)+ea(0.0))+ea(ea(X*I)-ea(V*W))));V=ea($*ea(0.0));$=ea(aa*ea(ea(v+ea(I*q))+ea(ea(t*W)-ea(X*s))));s=ea(ba*ea(ea(u+ea(0.0))+ea(u-u)));b=Y+(m*76|0)+80|0;u=ea(ea(g[b>>2])+M);z=Y+(m*76|0)+84|0;M=ea(V+ea(g[z>>2]));j=Y+(m*76|0)+88|0;V=ea($+ea(g[j>>2]));h=Y+(m*76|0)+92|0;$=ea(s+ea(g[h>>2]));g[b>>2]=u;g[z>>2]=M;g[j>>2]=V;g[h>>2]=$;i=k;return}function FYd(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im;e=i;i=i+32|0;b=e;if(!j){i=e;return}l=h+92|0;a[l>>0]=0;m=c[j>>2]|0;n=c[j+12>>2]|0;o=h+24|0;h=c[(c[o>>2]|0)+84>>2]|0;p=f;q=(c[f>>2]|0)+p|0;r=f+4|0;c[r>>2]=q;s=q+40|0;t=s+(c[s>>2]|0)|0;c[q+44>>2]=t;PEi(h|0,0,c[t>>2]|0)|0;a:do if(n){t=b+4|0;h=b+16|0;q=b+20|0;s=b+8|0;u=(m|0)==0;v=j+16|0;w=v;x=d+4|0;y=d+24|0;z=j+24|0;A=z;B=j+28|0;C=j+4|0;D=C;E=b+12|0;F=0;while(1){c[t>>2]=0;c[h>>2]=0;c[q>>2]=0;G=c[o>>2]|0;H=c[G+12>>2]|0;c[s>>2]=H;if(!u){I=(c[C>>2]|0)+D|0;J=0;do{K=I+(J<<3)|0;L=K+(c[K>>2]|0)|0;K=c[L>>2]|0;M=c[L+4>>2]|0;b:do if((K|0)!=-1&(F|0)==(K|0)){N=(M|0)==0;do if(!N)if((a[L+37>>0]|0)!=0|N){O=(c[f>>2]|0)+p|0;c[r>>2]=O;P=O+32|0;Q=P+(c[P>>2]|0)|0;c[O+36>>2]=Q;R=ea(g[Q+(J<<2)>>2]);break}else{g[H+(M<<2)>>2]=ea(0.0);break b}else{c[E>>2]=(c[d>>2]|0)+(J*20|0);R=ea(1.0)}while(0);g[H+(M<<2)>>2]=R}while(0);J=J+1|0}while((J|0)!=(m|0))}J=(c[v>>2]|0)+w+(F<<3)|0;H=J+(c[J>>2]|0)|0;g[b>>2]=ea(g[x>>2]);J=(c[f>>2]|0)+p|0;c[h>>2]=c[J+48>>2];c[q>>2]=c[y>>2];c[r>>2]=J;I=J+40|0;M=I+(c[I>>2]|0)|0;c[J+44>>2]=M;c[t>>2]=M;M=(c[G>>2]|0)+(F<<2)|0;I=c[M>>2]|0;L=(c[z>>2]|0)+A|0;c[B>>2]=L;c[I+4>>2]=L;c[(c[M>>2]|0)+8>>2]=G+84;M=c[(c[G+4>>2]|0)+(F<<2)>>2]|0;c[r>>2]=J;L=J+4|0;K=L+(c[L>>2]|0)|0;c[J+8>>2]=K;J=K+(F<<3)|0;L=J+(c[J>>2]|0)|0;c[K+(F<<3)+4>>2]=L;_$d(H,b,M,L,I,k);if(L$d(b)|0)break;a[l>>0]=a[l>>0]|a[M+24>>0]|a[M+48>>0];F=F+1|0;if(F>>>0>=n>>>0)break a}i=e;return}while(0);n=(c[f>>2]|0)+p|0;c[r>>2]=n;p=n+40|0;f=p+(c[p>>2]|0)|0;p=n+44|0;c[p>>2]=f;l=c[f>>2]|0;if(!l){i=e;return}b=c[(c[o>>2]|0)+84>>2]|0;o=0;do{if(a[b+o>>0]|0){c[p>>2]=f;k=f+4|0;m=k+(c[k>>2]|0)|0;c[f+8>>2]=m;a[m+o>>0]=0}o=o+1|0;c[p>>2]=f}while(o>>>0<l>>>0);c[r>>2]=n;i=e;return}function GYd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im;h=i;j=c[a+16>>2]|0;k=j+120|0;l=k;m=l+(c[k>>2]|0)|0;n=c[m>>2]|0;o=n+-1|0;p=j+124|0;c[p>>2]=m;q=j+8|0;r=(c[q>>2]|0)+q|0;c[j+12>>2]=r;q=a+8|0;a=c[q>>2]|0;s=j+140|0;t=s;u=(c[s>>2]|0)+t|0;v=j+144|0;c[v>>2]=u;HYd(m,r,d,a,u,e,o,0);u=(c[k>>2]|0)+l|0;c[p>>2]=u;x$d(u,e,f);u=e+4|0;a=u;r=(c[u>>2]|0)+a|0;m=e+8|0;c[m>>2]=r;w=ea(g[b>>2]);x=ea(g[b+4>>2]);y=ea(g[b+8>>2]);z=ea(g[b+12>>2]);g[r>>2]=w;g[r+4>>2]=x;g[r+8>>2]=y;g[r+12>>2]=z;z=ea(g[b+16>>2]);y=ea(g[b+20>>2]);x=ea(g[b+24>>2]);w=ea(g[b+28>>2]);g[r+16>>2]=z;g[r+20>>2]=y;g[r+24>>2]=x;g[r+28>>2]=w;w=ea(g[b+32>>2]);x=ea(g[b+36>>2]);y=ea(g[b+40>>2]);z=ea(g[b+44>>2]);g[r+32>>2]=w;g[r+36>>2]=x;g[r+40>>2]=y;g[r+44>>2]=z;if((c[j+68>>2]|0)>0){j=(c[k>>2]|0)+l|0;c[p>>2]=j;y$d(j,e,f,n+-2|0,0)}n=(c[k>>2]|0)+l|0;c[p>>2]=n;A$d(n,f,e,o,o);f=(c[u>>2]|0)+a|0;a=f;c[m>>2]=a;m=f;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m+24>>2]=0;g[a+28>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);a=(c[k>>2]|0)+l|0;c[p>>2]=a;p=c[q>>2]|0;q=(c[s>>2]|0)+t|0;c[v>>2]=q;IYd(a,e,p,q,d,o,0);i=h;return}function HYd(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=0,y=0,z=0,A=0,B=Im;l=i;if((j|0)==-1|(j|0)==(k|0)){i=l;return}m=a+4|0;HYd(a,b,d,e,f,h,c[(c[m>>2]|0)+m+(j<<3)>>2]|0,k);k=c[f+(j<<2)>>2]|0;f=c[e+(k*12|0)>>2]|0;m=h+4|0;a=m;n=(c[m>>2]|0)+a|0;o=h+8|0;c[o>>2]=n;if((f|0)==-1){h=b+4|0;p=(c[h>>2]|0)+h|0;q=p+(k*48|0)+12|0;r=p+(k*48|0)+4|0;s=p+(k*48|0)|0;t=p+(k*48|0)+8|0}else{p=d+40|0;h=(c[p>>2]|0)+p|0;q=h+(f<<4)+12|0;r=h+(f<<4)+4|0;s=h+(f<<4)|0;t=h+(f<<4)+8|0}u=ea(g[q>>2]);v=ea(g[t>>2]);w=ea(g[r>>2]);g[n+(j*48|0)>>2]=ea(g[s>>2]);g[n+(j*48|0)+4>>2]=w;g[n+(j*48|0)+8>>2]=v;g[n+(j*48|0)+12>>2]=u;n=c[e+(k*12|0)+4>>2]|0;s=(c[m>>2]|0)+a|0;c[o>>2]=s;if((n|0)==-1){r=b+4|0;t=(c[r>>2]|0)+r|0;x=t+(k*48|0)+28|0;y=t+(k*48|0)+24|0;z=t+(k*48|0)+20|0;A=t+(k*48|0)+16|0}else{t=d+52|0;r=(c[t>>2]|0)+t|0;x=r+(n<<4)+12|0;y=r+(n<<4)+8|0;z=r+(n<<4)+4|0;A=r+(n<<4)|0}u=ea(g[x>>2]);v=ea(g[y>>2]);w=ea(g[z>>2]);g[s+(j*48|0)+16>>2]=ea(g[A>>2]);g[s+(j*48|0)+20>>2]=w;g[s+(j*48|0)+24>>2]=v;g[s+(j*48|0)+28>>2]=u;s=c[e+(k*12|0)+8>>2]|0;e=(c[m>>2]|0)+a|0;c[o>>2]=e;o=e+(j*48|0)+32|0;if((s|0)==-1){a=b+4|0;b=(c[a>>2]|0)+a|0;u=ea(g[b+(k*48|0)+32>>2]);v=ea(g[b+(k*48|0)+36>>2]);w=ea(g[b+(k*48|0)+40>>2]);B=ea(g[b+(k*48|0)+44>>2]);g[o>>2]=u;g[e+(j*48|0)+36>>2]=v;g[e+(j*48|0)+40>>2]=w;g[e+(j*48|0)+44>>2]=B;i=l;return}else{k=d+64|0;d=(c[k>>2]|0)+k|0;B=ea(g[d+(s<<4)>>2]);w=ea(g[d+(s<<4)+4>>2]);v=ea(g[d+(s<<4)+8>>2]);u=ea(g[d+(s<<4)+12>>2]);g[o>>2]=B;g[e+(j*48|0)+36>>2]=w;g[e+(j*48|0)+40>>2]=v;g[e+(j*48|0)+44>>2]=u;i=l;return}}function IYd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im;k=i;if((h|0)==-1|(h|0)==(j|0)){i=k;return}l=a+4|0;IYd(a,b,d,e,f,c[(c[l>>2]|0)+l+(h<<3)>>2]|0,j);j=c[e+(h<<2)>>2]|0;e=c[d+(j*12|0)>>2]|0;if((e|0)!=-1){l=b+4|0;a=(c[l>>2]|0)+l|0;l=f+40|0;m=(c[l>>2]|0)+l|0;c[f+44>>2]=m;n=ea(g[a+(h*48|0)>>2]);o=ea(g[a+(h*48|0)+4>>2]);p=ea(g[a+(h*48|0)+8>>2]);q=ea(g[a+(h*48|0)+12>>2]);g[m+(e<<4)>>2]=n;g[m+(e<<4)+4>>2]=o;g[m+(e<<4)+8>>2]=p;g[m+(e<<4)+12>>2]=q}e=c[d+(j*12|0)+4>>2]|0;if((e|0)!=-1){m=b+4|0;a=(c[m>>2]|0)+m|0;m=f+52|0;l=(c[m>>2]|0)+m|0;c[f+56>>2]=l;q=ea(g[a+(h*48|0)+16>>2]);p=ea(g[a+(h*48|0)+20>>2]);o=ea(g[a+(h*48|0)+24>>2]);n=ea(g[a+(h*48|0)+28>>2]);g[l+(e<<4)>>2]=q;g[l+(e<<4)+4>>2]=p;g[l+(e<<4)+8>>2]=o;g[l+(e<<4)+12>>2]=n}e=c[d+(j*12|0)+8>>2]|0;if((e|0)==-1){i=k;return}j=b+4|0;b=(c[j>>2]|0)+j|0;j=f+64|0;d=(c[j>>2]|0)+j|0;c[f+68>>2]=d;n=ea(g[b+(h*48|0)+32>>2]);o=ea(g[b+(h*48|0)+36>>2]);p=ea(g[b+(h*48|0)+40>>2]);q=ea(g[b+(h*48|0)+44>>2]);g[d+(e<<4)>>2]=n;g[d+(e<<4)+4>>2]=o;g[d+(e<<4)+8>>2]=p;g[d+(e<<4)+12>>2]=q;i=k;return}function JYd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(c[a>>2]|0)+a|0;c[a+4>>2]=h;j=(c[b>>2]|0)+b|0;c[b+4>>2]=j;w_d(h,j);j=b+8|0;h=(c[j>>2]|0)+j|0;c[b+12>>2]=h;j=a+8|0;k=(c[j>>2]|0)+j|0;c[a+12>>2]=k;o_d(h,k);if(d|e){k=b+16|0;h=(c[k>>2]|0)+k|0;c[b+20>>2]=h;k=a+16|0;j=(c[k>>2]|0)+k|0;c[a+20>>2]=j;dZd(h,j,d,e,f)}if(!e){i=g;return}e=b+24|0;f=(c[e>>2]|0)+e|0;c[b+28>>2]=f;b=a+24|0;e=(c[b>>2]|0)+b|0;c[a+28>>2]=e;Z_d(f,e,0);i=g;return}function KYd(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;n=j;o=c[d+16>>2]|0;p=c[d+20>>2]|0;d=o+36|0;q=c[d>>2]|0;if((q|0)!=0?(r=q+d+48|0,(c[(c[r>>2]|0)+r>>2]|0)!=0):0){s=0;t=1}else if((c[o+68>>2]|0)==-1){s=(a[e+22>>0]|0)!=0;t=0}else{s=1;t=0}e=k+24|0;k=c[(c[e>>2]|0)+16>>2]|0;o=(l|0)!=0&(c[h>>2]|0)==0;r=(c[b>>2]|0)+b|0;c[b+4>>2]=r;if(o)w_d(r,c[l>>2]|0);else w_d(r,c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]|0);r=c[(c[e>>2]|0)+72>>2]|0;l=b+8|0;o=(c[l>>2]|0)+l|0;c[b+12>>2]=o;o_d(r,o);if(s|t){o=p+4|0;p=(c[o>>2]|0)+o+(f<<3)|0;f=p+(c[p>>2]|0)+8|0;p=c[f+4>>2]|0;o=n;c[o>>2]=c[f>>2];c[o+4>>2]=p;p=c[(c[k+4>>2]|0)+(c[h>>2]<<2)>>2]|0;o=b+16|0;f=(c[o>>2]|0)+o|0;c[b+20>>2]=f;dZd(p,f,s,t,n)}n=c[e>>2]|0;p_d(c[n+76>>2]|0,c[n+72>>2]|0);if(!t){u=c[h>>2]|0;v=k+12|0;w=c[v>>2]|0;x=w+(u<<2)|0;g[x>>2]=m;y=u+1|0;c[h>>2]=y;i=j;return}t=c[(c[k+8>>2]|0)+(c[h>>2]<<2)>>2]|0;n=b+24|0;e=(c[n>>2]|0)+n|0;c[b+28>>2]=e;Z_d(t,e,0);u=c[h>>2]|0;v=k+12|0;w=c[v>>2]|0;x=w+(u<<2)|0;g[x>>2]=m;y=u+1|0;c[h>>2]=y;i=j;return}function LYd(b,e,f,h,j,k,l,m,n,o,p,q){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=Im,jb=0,kb=Im,lb=0,mb=Im,nb=0,ob=Im,pb=Im,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=Im,Cb=Im,Db=Im,Eb=0;r=i;i=i+368|0;s=r+288|0;t=r+152|0;u=r;v=r+256|0;w=r+260|0;x=r+320|0;y=r+104|0;z=r+208|0;A=r+160|0;B=r+56|0;C=r+8|0;D=c[b+16>>2]|0;E=c[b+20>>2]|0;F=c[b+24>>2]|0;G=D+36|0;H=c[G>>2]|0;if((H|0)!=0?(I=H+G+48|0,(c[(c[I>>2]|0)+I>>2]|0)!=0):0){J=0;K=1}else if((c[D+68>>2]|0)==-1){J=(a[e+22>>0]|0)!=0;K=0}else{J=1;K=0}I=l+24|0;G=(c[I>>2]|0)+I|0;c[l+28>>2]=G;I=G+(f*36|0)|0;H=E+4|0;E=(c[H>>2]|0)+H+(f<<3)|0;H=E+(c[E>>2]|0)|0;E=c[H>>2]|0;if((E|0)==-1){i=r;return}L=c[H+4>>2]|0;H=l+4|0;M=(c[H>>2]|0)+H|0;c[l+8>>2]=M;H=M+(E<<3)|0;N=H+(c[H>>2]|0)|0;c[M+(E<<3)+4>>2]=N;M=m+24|0;H=c[M>>2]|0;O=c[(c[H+4>>2]|0)+(E<<2)>>2]|0;E=j?O+4|0:O+28|0;O=c[o+8>>2]|0;j=c[E>>2]|0;P=j+(L*24|0)|0;Q=c[P>>2]|0;if(!Q)R=E+21|0;else{S=j+(L*24|0)+4|0;U=F+12|0;V=J|K;W=s+4|0;X=s+8|0;Y=s+12|0;Z=s+16|0;$=s+20|0;aa=s+24|0;ba=E+4|0;ca=E+8|0;da=j+(L*24|0)+16|0;fa=j+(L*24|0)+20|0;ga=j+(L*24|0)+12|0;ha=o+4|0;o=(n|0)!=0;ia=E+21|0;ja=I;ka=G+(f*36|0)+4|0;G=F+36|0;la=w+4|0;ma=w+8|0;na=w+12|0;oa=w+16|0;pa=w+20|0;qa=w+24|0;ra=e+8|0;sa=e+12|0;ta=m+20|0;ua=x+4|0;va=x+8|0;wa=x+12|0;xa=x+16|0;ya=x+20|0;za=x+24|0;Aa=x+28|0;Ba=x+32|0;Ca=x+36|0;Da=x+40|0;Ea=x+44|0;Fa=e+20|0;Ga=m+76|0;Ha=z+4|0;Ia=z+8|0;Ja=z+12|0;Ka=m+80|0;La=z+28|0;Ma=z+16|0;Na=z+20|0;Oa=z+24|0;Pa=m+84|0;Qa=B+4|0;Ra=B+8|0;Sa=B+12|0;Ta=m+88|0;Ua=B+28|0;Va=B+16|0;Wa=B+20|0;Xa=B+24|0;Ya=F+32|0;F=D+68|0;D=e+23|0;Za=m+12|0;_a=m+16|0;$a=j+(L*24|0)+8|0;L=E+12|0;j=l+48|0;l=E+16|0;E=N+56|0;ab=N+64|0;N=b+4|0;bb=H;H=0;while(1){cb=c[(c[S>>2]|0)+(H<<2)>>2]|0;db=c[U>>2]|0;eb=c[db+(cb*36|0)>>2]|0;if(!eb)fb=bb;else{do if(V){c[X>>2]=0;g[Y>>2]=ea(1.0);g[Z>>2]=ea(1.0);a[$>>0]=0;g[aa>>2]=ea(0.0);g[s>>2]=ea(g[ba>>2]);g[W>>2]=ea(g[ca>>2]);a[$>>0]=a[(c[da>>2]|0)+H>>0]|0;g[aa>>2]=ea(g[(c[fa>>2]|0)+(H<<2)>>2]);g[Z>>2]=ea(g[(c[ga>>2]|0)+(H<<2)>>2]);gb=c[(c[(c[bb+16>>2]|0)+4>>2]|0)+(c[k>>2]<<2)>>2]|0;if(K){xZd(eb,s,gb,c[(c[ha>>2]|0)+(cb<<2)>>2]|0);break}if(J)wZd(eb,s,gb,c[(c[ha>>2]|0)+(cb<<2)>>2]|0)}while(0);gb=c[k>>2]|0;if(o&(gb|0)==0)hb=n;else hb=(c[c[(c[M>>2]|0)+16>>2]>>2]|0)+(gb<<2)|0;gb=c[hb>>2]|0;g[v>>2]=ea(0.0);ib=ea(g[ba>>2]);jb=eb+1048|0;kb=ea(g[jb>>2]);lb=eb+1052|0;mb=ea(g[lb>>2]);nb=eb+1064|0;ob=ea(g[nb>>2]);pb=ea(ob+ea(g[(c[fa>>2]|0)+(H<<2)>>2]));qb=eb+1621|0;g[t>>2]=ea(lZd(ib,kb,mb,pb,(a[qb>>0]|0)!=0,ea(g[(c[ga>>2]|0)+(H<<2)>>2])<ea(0.0),v,u));rb=c[M>>2]|0;sb=c[rb+72>>2]|0;tb=c[rb+76>>2]|0;rb=eb+1040|0;ub=(c[rb>>2]|0)+rb|0;c[eb+1044>>2]=ub;b_d(ub,t,c[(c[ha>>2]|0)+(cb<<2)>>2]|0,O);ub=(a[ia>>0]|0)==0;if(ub){rb=(c[I>>2]|0)+ja|0;c[ka>>2]=rb;vb=rb}else vb=c[N>>2]|0;rb=db+(cb*36|0)+12|0;MYd(vb,0,O,rb,c[G>>2]|0,gb,sb,ub);p_d(tb,sb);if(!h){if((a[qb>>0]|0)!=0?(a[eb+1622>>0]|0)!=0:0)wb=23}else wb=23;if((wb|0)==23){wb=0;tb=c[M>>2]|0;NYd(eb,rb,sb,c[tb+64>>2]|0,c[tb+68>>2]|0)}if(V){c[ma>>2]=0;g[na>>2]=ea(1.0);g[oa>>2]=ea(1.0);a[pa>>0]=0;g[qa>>2]=ea(0.0);g[w>>2]=ea(g[ba>>2]);g[la>>2]=ea(g[ca>>2]);tb=c[k>>2]|0;rb=c[M>>2]|0;ub=c[rb+16>>2]|0;xb=c[(c[ub+4>>2]|0)+(tb<<2)>>2]|0;do if(K){yb=c[ra>>2]|0;g[na>>2]=ea(g[sa>>2]);zb=(yb|0)>0?yb:0;c[ma>>2]=(zb|0)<5?zb:5;a[pa>>0]=a[(c[da>>2]|0)+H>>0]|0;g[qa>>2]=ea(g[(c[fa>>2]|0)+(H<<2)>>2]);g[oa>>2]=ea(g[(c[ga>>2]|0)+(H<<2)>>2]);zb=c[(c[ub+8>>2]|0)+(tb<<2)>>2]|0;yZd(eb,w,c[O>>2]|0,xb,zb,c[(c[ha>>2]|0)+(cb<<2)>>2]|0);if(h){yb=eb+1612|0;Ab=(c[yb>>2]|0)+yb|0;c[eb+1616>>2]=Ab;tZd(eb,Ab,c[ta>>2]|0);if(a[eb+1620>>0]|0){Ab=c[ta>>2]|0;c$d(Ab,Ab)}_Yd(x,xb+84|0,zb);pb=ea(g[x>>2]);mb=ea(g[ua>>2]);kb=ea(g[va>>2]);ib=ea(g[wa>>2]);g[zb>>2]=pb;g[zb+4>>2]=mb;g[zb+8>>2]=kb;g[zb+12>>2]=ib;ib=ea(g[xa>>2]);kb=ea(g[ya>>2]);mb=ea(g[za>>2]);pb=ea(g[Aa>>2]);g[zb+16>>2]=ib;g[zb+20>>2]=kb;g[zb+24>>2]=mb;g[zb+28>>2]=pb;pb=ea(g[Ba>>2]);mb=ea(g[Ca>>2]);kb=ea(g[Da>>2]);ib=ea(g[Ea>>2]);g[zb+32>>2]=pb;g[zb+36>>2]=mb;g[zb+40>>2]=kb;g[zb+44>>2]=ib;a$d(zb,zb,c[ta>>2]|0);Ab=zb+80|0;c[Ab+0>>2]=0;c[Ab+4>>2]=0;c[Ab+8>>2]=0;c[Ab+12>>2]=0;c[Ab+16>>2]=0;c[Ab+20>>2]=0;c[Ab+24>>2]=0;g[zb+108>>2]=ea(1.0);g[zb+112>>2]=ea(1.0);g[zb+116>>2]=ea(1.0);g[zb+120>>2]=ea(1.0);g[zb+124>>2]=ea(1.0);Ab=zb+156|0;c[Ab+0>>2]=0;c[Ab+4>>2]=0;c[Ab+8>>2]=0;c[Ab+12>>2]=0;c[Ab+16>>2]=0;c[Ab+20>>2]=0;c[Ab+24>>2]=0;g[zb+184>>2]=ea(1.0);g[zb+188>>2]=ea(1.0);g[zb+192>>2]=ea(1.0);g[zb+196>>2]=ea(1.0);g[zb+200>>2]=ea(1.0);Ab=zb+232|0;c[Ab+0>>2]=0;c[Ab+4>>2]=0;c[Ab+8>>2]=0;c[Ab+12>>2]=0;c[Ab+16>>2]=0;c[Ab+20>>2]=0;c[Ab+24>>2]=0;g[zb+260>>2]=ea(1.0);g[zb+264>>2]=ea(1.0);g[zb+268>>2]=ea(1.0);g[zb+272>>2]=ea(1.0);g[zb+276>>2]=ea(1.0);Ab=zb+308|0;c[Ab+0>>2]=0;c[Ab+4>>2]=0;c[Ab+8>>2]=0;c[Ab+12>>2]=0;c[Ab+16>>2]=0;c[Ab+20>>2]=0;c[Ab+24>>2]=0;g[zb+336>>2]=ea(1.0);g[zb+340>>2]=ea(1.0);g[zb+344>>2]=ea(1.0);g[zb+348>>2]=ea(1.0);g[zb+352>>2]=ea(1.0);cZd(xb)}if((a[Fa>>0]|0)!=0?ea(g[xb>>2])!=ea(0.0):0){iZd(y,xb);_Yd(A,y,zb+80|0);$Yd(z,xb+276|0,A);_Yd(C,y,zb+156|0);$Yd(B,xb+324|0,C);ib=ea(g[Ga>>2]);kb=ea(g[z>>2]);mb=ea(kb*kb);kb=ea(g[Ha>>2]);pb=ea(kb*kb);kb=ea(g[Ia>>2]);ob=ea(kb*kb);kb=ea(g[Ja>>2]);Bb=ea(T(ea(ea(mb+pb)+ea(ob+ea(kb*kb)))));kb=ea(g[xb>>2]);ob=ea(Bb/kb);g[Ga>>2]=ib<ob?ob:ib;ib=ea(g[Ka>>2]);ob=ea(g[La>>2]);zb=ob==ea(0.0);Bb=zb?ea(9.99999997e-07):ob;ob=ea(ea(g[Ma>>2])/Bb);pb=ea(ea(g[Na>>2])/Bb);mb=ea(ea(+_(+ob))*ea(2.0));ob=ea(ea(+_(+pb))*ea(2.0));pb=ea(ea(+_(+ea(ea(g[Oa>>2])/Bb)))*ea(2.0));Bb=ea(ea(+_(0.0))*ea(2.0));Cb=ea(Bb*Bb);Bb=ea(ea(T(ea(ea(ea(mb*mb)+ea(ob*ob))+ea(ea(pb*pb)+Cb))))/kb);g[Ka>>2]=ib<Bb?Bb:ib;ib=ea(g[Pa>>2]);Bb=ea(g[B>>2]);pb=ea(Bb*Bb);Bb=ea(g[Qa>>2]);ob=ea(Bb*Bb);Bb=ea(g[Ra>>2]);mb=ea(Bb*Bb);Bb=ea(g[Sa>>2]);Db=ea(ea(T(ea(ea(pb+ob)+ea(mb+ea(Bb*Bb)))))/kb);g[Pa>>2]=ib<Db?Db:ib;ib=ea(g[Ta>>2]);Db=ea(g[Ua>>2]);zb=Db==ea(0.0);Bb=zb?ea(9.99999997e-07):Db;Db=ea(ea(g[Va>>2])/Bb);mb=ea(ea(g[Wa>>2])/Bb);ob=ea(ea(+_(+Db))*ea(2.0));Db=ea(ea(+_(+mb))*ea(2.0));mb=ea(ea(+_(+ea(ea(g[Xa>>2])/Bb)))*ea(2.0));Bb=ea(ea(T(ea(ea(ea(ob*ob)+ea(Db*Db))+ea(Cb+ea(mb*mb)))))/kb);g[Ta>>2]=ib<Bb?Bb:ib}}else if((c[F>>2]|0)!=-1)if(h){cZd(xb);break}else{GYd(b,xb+132|0,c[rb+64>>2]|0,c[Za>>2]|0,c[_a>>2]|0);GYd(b,xb+180|0,c[(c[M>>2]|0)+68>>2]|0,c[Za>>2]|0,c[_a>>2]|0);GYd(b,xb+84|0,gb,c[Za>>2]|0,c[_a>>2]|0);break}while(0);rb=c[Ya>>2]|0;if((rb|0)!=-1?(tb=sb+28|0,ub=(c[tb>>2]|0)+tb|0,c[sb+32>>2]=ub,(a[ub+rb>>0]|0)!=0):0){ub=gb+28|0;g[xb+420>>2]=ea(g[(c[ub>>2]|0)+ub+(rb<<2)>>2])}else wb=40;do if((wb|0)==40){wb=0;if(!K?(c[F>>2]|0)==-1:0){g[xb+420>>2]=ea(1.0);break}g[xb+420>>2]=ea(d[eb+1624>>0]|0)}while(0);if(!(a[D>>0]|0)){ib=ea(g[xb>>2]);rb=xb+4|0;Bb=ea(ib*ea(g[rb>>2]));ub=xb+8|0;kb=ea(ib*ea(g[ub>>2]));tb=xb+12|0;mb=ea(ib*ea(g[tb>>2]));zb=xb+16|0;Cb=ea(ib*ea(g[zb>>2]));g[rb>>2]=Bb;g[ub>>2]=kb;g[tb>>2]=mb;g[zb>>2]=Cb;zb=xb+20|0;Cb=ea(ib*ea(g[zb>>2]));tb=xb+24|0;mb=ea(ib*ea(g[tb>>2]));ub=xb+28|0;kb=ea(ib*ea(g[ub>>2]));rb=xb+32|0;Bb=ea(ib*ea(g[rb>>2]));g[zb>>2]=Cb;g[tb>>2]=mb;g[ub>>2]=kb;g[rb>>2]=Bb}}if(h)D_d(c[(c[M>>2]|0)+64>>2]|0,gb,sb);rb=a[qb>>0]|0;if(rb<<24>>24)if(!(a[eb+1622>>0]|0))Eb=rb;else{rb=c[M>>2]|0;E_d(c[rb+64>>2]|0,c[rb+68>>2]|0,gb,ea(g[v>>2]),sb);Eb=a[qb>>0]|0}else Eb=0;Bb=ea(ea(g[(c[$a>>2]|0)+(H<<2)>>2])*q);g[p+(c[k>>2]<<2)>>2]=Bb;rb=c[M>>2]|0;ub=c[rb+56>>2]|0;tb=c[rb+60>>2]|0;c[tb+(ub<<5)>>2]=c[db+(cb*36|0)+4>>2];c[tb+(ub<<5)+24>>2]=c[L>>2];c[tb+(ub<<5)+4>>2]=f;g[tb+(ub<<5)+8>>2]=ea(g[p+(c[k>>2]<<2)>>2]);a[tb+(ub<<5)+28>>0]=(c[j>>2]|0)==1&1;Bb=ea(g[ca>>2]);kb=ea(g[jb>>2]);mb=ea(g[lb>>2]);Cb=ea(g[nb>>2]);rb=tb+(ub<<5)+12|0;g[rb>>2]=ea(lZd(Bb,kb,mb,Cb,Eb<<24>>24!=0,ea(g[(c[ga>>2]|0)+(H<<2)>>2])<ea(0.0),v,u));Cb=ea(g[t>>2]);zb=tb+(ub<<5)+16|0;g[zb>>2]=Cb;Ab=c[l>>2]|0;if((Ab&1|0)!=0?(a[qb>>0]|0)==0&Cb==ea(0.0):0){Cb=ea(g[ca>>2]);mb=ea(g[jb>>2]);kb=ea(g[lb>>2]);Bb=ea(g[nb>>2]);g[rb>>2]=ea(lZd(Cb,mb,kb,Bb,1,ea(g[(c[ga>>2]|0)+(H<<2)>>2])<ea(0.0),v,u))}else wb=54;if((((wb|0)==54?(wb=0,(Ab&2|0)!=0):0)?(a[qb>>0]|0)!=0:0)?(Bb=ea(g[E>>2]),kb=ea(g[jb>>2]),mb=ea(g[lb>>2]),Cb=ea(g[nb>>2]),ib=ea(lZd(Bb,kb,mb,Cb,1,ea(g[(c[ga>>2]|0)+(H<<2)>>2])<ea(0.0),v,u)),Cb=ea(ib+ea(g[ab>>2])),Cb<=ea(g[lb>>2])):0)g[zb>>2]=Cb;g[tb+(ub<<5)+20>>2]=ea(g[(c[ga>>2]|0)+(H<<2)>>2]);ub=c[M>>2]|0;tb=ub+56|0;c[tb>>2]=(c[tb>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+1;fb=ub}H=H+1|0;if((H|0)==(Q|0)){R=ia;break}else bb=fb}}if(a[R>>0]|0){i=r;return}if(!((c[P>>2]|0)==0&q>ea(0.0))){i=r;return}KYd(I,b,e,f,k,0,m,n,q);i=r;return}function MYd(d,e,f,h,j,k,l,m){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=0,C=0,D=0,E=0,F=0;e=i;n=c[f>>2]|0;f=k+40|0;o=(c[f>>2]|0)+f|0;f=k+44|0;c[f>>2]=o;p=l+40|0;q=(c[p>>2]|0)+p|0;c[l+44>>2]=q;p=c[k+36>>2]|0;if(p){r=c[h>>2]|0;s=d+40|0;t=(c[s>>2]|0)+s|0;s=m&1;u=0;do{v=b[r+(u<<1)>>1]|0;w=v<<16>>16;if(v<<16>>16==-1){c[f>>2]=o;x=ea(g[t+(u<<4)>>2]);y=ea(g[t+(u<<4)+4>>2]);z=ea(g[t+(u<<4)+8>>2]);A=ea(g[t+(u<<4)+12>>2]);g[o+(u<<4)>>2]=x;g[o+(u<<4)+4>>2]=y;g[o+(u<<4)+8>>2]=z;g[o+(u<<4)+12>>2]=A;B=s}else{v=o+(u<<4)|0;g[v>>2]=ea(g[n+(w<<2)>>2]);g[v+4>>2]=ea(g[n+(w+1<<2)>>2]);g[v+8>>2]=ea(g[n+(w+2<<2)>>2]);g[v+12>>2]=ea(0.0);B=1}a[q+u>>0]=B;u=u+1|0}while(u>>>0<p>>>0)}p=k+52|0;u=(c[p>>2]|0)+p|0;p=k+56|0;c[p>>2]=u;B=l+52|0;q=(c[B>>2]|0)+B|0;c[l+56>>2]=q;B=c[k+48>>2]|0;if(B){o=c[h+4>>2]|0;s=d+52|0;t=(c[s>>2]|0)+s|0;s=m&1;f=0;do{r=b[o+(f<<1)>>1]|0;v=r<<16>>16;if(r<<16>>16==-1){c[p>>2]=u;A=ea(g[t+(f<<4)>>2]);z=ea(g[t+(f<<4)+4>>2]);y=ea(g[t+(f<<4)+8>>2]);x=ea(g[t+(f<<4)+12>>2]);g[u+(f<<4)>>2]=A;g[u+(f<<4)+4>>2]=z;g[u+(f<<4)+8>>2]=y;g[u+(f<<4)+12>>2]=x;C=s}else{r=u+(f<<4)|0;g[r>>2]=ea(g[n+(v<<2)>>2]);g[r+4>>2]=ea(g[n+(v+1<<2)>>2]);g[r+8>>2]=ea(g[n+(v+2<<2)>>2]);g[r+12>>2]=ea(g[n+(v+3<<2)>>2]);C=1}a[q+f>>0]=C;f=f+1|0}while(f>>>0<B>>>0)}B=k+64|0;f=(c[B>>2]|0)+B|0;B=k+68|0;c[B>>2]=f;C=l+64|0;q=(c[C>>2]|0)+C|0;c[l+68>>2]=q;C=c[k+60>>2]|0;if(C){u=c[h+8>>2]|0;s=d+64|0;t=(c[s>>2]|0)+s|0;s=m&1;p=0;do{o=b[u+(p<<1)>>1]|0;v=o<<16>>16;if(o<<16>>16==-1){c[B>>2]=f;x=ea(g[t+(p<<4)>>2]);y=ea(g[t+(p<<4)+4>>2]);z=ea(g[t+(p<<4)+8>>2]);A=ea(g[t+(p<<4)+12>>2]);g[f+(p<<4)>>2]=x;g[f+(p<<4)+4>>2]=y;g[f+(p<<4)+8>>2]=z;g[f+(p<<4)+12>>2]=A;D=s}else{o=f+(p<<4)|0;g[o>>2]=ea(g[n+(v<<2)>>2]);g[o+4>>2]=ea(g[n+(v+1<<2)>>2]);g[o+8>>2]=ea(g[n+(v+2<<2)>>2]);g[o+12>>2]=ea(1.0);D=1}a[q+p>>0]=D;p=p+1|0}while(p>>>0<C>>>0)}C=k+28|0;p=(c[C>>2]|0)+C|0;C=k+32|0;c[C>>2]=p;D=l+28|0;q=(c[D>>2]|0)+D|0;c[l+32>>2]=q;D=c[k+24>>2]|0;if(D){f=c[h+12>>2]|0;s=d+28|0;t=(c[s>>2]|0)+s|0;s=m&1;B=0;do{u=b[f+(B<<1)>>1]|0;if(u<<16>>16==-1){A=ea(g[t+(B<<2)>>2]);c[C>>2]=p;g[p+(B<<2)>>2]=A;E=s}else{g[p+(B<<2)>>2]=ea(g[n+(u<<16>>16<<2)>>2]);E=1}a[q+B>>0]=E;B=B+1|0}while(B>>>0<D>>>0)}D=l+16|0;B=(c[D>>2]|0)+D|0;c[l+20>>2]=B;l=k+12|0;if(!(c[l>>2]|0)){i=e;return}D=c[h+16>>2]|0;E=d+16|0;d=E;q=k+16|0;p=q;s=k+20|0;k=m&1;m=c[h+20>>2]|0;h=0;do{C=b[D+(h<<1)>>1]|0;if(C<<16>>16==-1){t=c[(c[E>>2]|0)+d+(h<<2)>>2]|0;f=(c[q>>2]|0)+p|0;c[s>>2]=f;c[f+(h<<2)>>2]=t;F=k}else{t=c[m+(da(~~ea(g[n+(C<<16>>16<<2)>>2])>>>0,j)|0)>>2]|0;C=(c[q>>2]|0)+p|0;c[s>>2]=C;c[C+(h<<2)>>2]=t;F=1}a[B+h>>0]=F;h=h+1|0}while(h>>>0<(c[l>>2]|0)>>>0);i=e;return}function NYd(d,e,f,h,j){d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=Im,B=Im,C=Im,D=0,E=Im,F=Im;k=i;l=c[h+36>>2]|0;if(l){m=f+40|0;n=(c[m>>2]|0)+m|0;m=c[e>>2]|0;o=d+1612|0;p=(c[o>>2]|0)+o|0;o=h+40|0;q=(c[o>>2]|0)+o|0;o=h+44|0;r=j+40|0;s=(c[r>>2]|0)+r|0;r=j+44|0;t=0;do{if(a[n+t>>0]|0){u=b[m+(t<<1)>>1]|0;v=ea(g[p+(u<<3)>>2]);w=u+1|0;x=ea(g[p+(w<<3)>>2]);y=u+2|0;z=ea(g[p+(y<<3)>>2]);A=ea(g[p+(u<<3)+4>>2]);B=ea(g[p+(w<<3)+4>>2]);C=ea(g[p+(y<<3)+4>>2]);c[o>>2]=q;g[q+(t<<4)>>2]=v;g[q+(t<<4)+4>>2]=x;g[q+(t<<4)+8>>2]=z;g[q+(t<<4)+12>>2]=ea(0.0);c[r>>2]=s;g[s+(t<<4)>>2]=A;g[s+(t<<4)+4>>2]=B;g[s+(t<<4)+8>>2]=C;g[s+(t<<4)+12>>2]=ea(0.0)}t=t+1|0}while(t>>>0<l>>>0)}l=c[h+48>>2]|0;if(l){t=f+52|0;s=(c[t>>2]|0)+t|0;t=c[e+4>>2]|0;r=d+1612|0;q=(c[r>>2]|0)+r|0;r=h+52|0;o=(c[r>>2]|0)+r|0;r=h+56|0;p=j+52|0;m=(c[p>>2]|0)+p|0;p=j+56|0;n=0;do{if(a[s+n>>0]|0){y=b[t+(n<<1)>>1]|0;C=ea(g[q+(y<<3)>>2]);w=y+1|0;B=ea(g[q+(w<<3)>>2]);u=y+2|0;A=ea(g[q+(u<<3)>>2]);D=y+3|0;z=ea(g[q+(D<<3)>>2]);x=ea(g[q+(y<<3)+4>>2]);v=ea(g[q+(w<<3)+4>>2]);E=ea(g[q+(u<<3)+4>>2]);F=ea(g[q+(D<<3)+4>>2]);c[r>>2]=o;g[o+(n<<4)>>2]=C;g[o+(n<<4)+4>>2]=B;g[o+(n<<4)+8>>2]=A;g[o+(n<<4)+12>>2]=z;c[p>>2]=m;g[m+(n<<4)>>2]=x;g[m+(n<<4)+4>>2]=v;g[m+(n<<4)+8>>2]=E;g[m+(n<<4)+12>>2]=F}n=n+1|0}while(n>>>0<l>>>0)}l=c[h+60>>2]|0;if(l){n=f+64|0;m=(c[n>>2]|0)+n|0;n=c[e+8>>2]|0;p=d+1612|0;o=(c[p>>2]|0)+p|0;p=h+64|0;r=(c[p>>2]|0)+p|0;p=h+68|0;q=j+64|0;t=(c[q>>2]|0)+q|0;q=j+68|0;s=0;do{if(a[m+s>>0]|0){D=b[n+(s<<1)>>1]|0;F=ea(g[o+(D<<3)>>2]);u=D+1|0;E=ea(g[o+(u<<3)>>2]);w=D+2|0;v=ea(g[o+(w<<3)>>2]);x=ea(g[o+(D<<3)+4>>2]);z=ea(g[o+(u<<3)+4>>2]);A=ea(g[o+(w<<3)+4>>2]);c[p>>2]=r;g[r+(s<<4)>>2]=F;g[r+(s<<4)+4>>2]=E;g[r+(s<<4)+8>>2]=v;g[r+(s<<4)+12>>2]=ea(1.0);c[q>>2]=t;g[t+(s<<4)>>2]=x;g[t+(s<<4)+4>>2]=z;g[t+(s<<4)+8>>2]=A;g[t+(s<<4)+12>>2]=ea(1.0)}s=s+1|0}while(s>>>0<l>>>0)}l=c[h+24>>2]|0;if(!l){i=k;return}s=f+28|0;f=(c[s>>2]|0)+s|0;s=c[e+12>>2]|0;e=d+1612|0;d=(c[e>>2]|0)+e|0;e=h+28|0;t=(c[e>>2]|0)+e|0;e=h+32|0;h=j+28|0;q=(c[h>>2]|0)+h|0;h=j+32|0;j=0;do{if(a[f+j>>0]|0){r=b[s+(j<<1)>>1]|0;A=ea(g[d+(r<<3)>>2]);c[e>>2]=t;g[t+(j<<2)>>2]=A;A=ea(g[d+(r<<3)+4>>2]);c[h>>2]=q;g[q+(j<<2)>>2]=A}j=j+1|0}while(j>>>0<l>>>0);i=k;return}function OYd(a,b,d,e,f,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=Im,q=Im,r=0,s=0;n=i;do if((f|0)<=0)if(!f){z_d(a,h,b);o=0}else o=0;else{if((f|0)==1){p=ea(ea(g[e>>2])+ea(-1.0));if(p<ea(0.0))q=ea(-p);else q=p;if(q<=ea(9.99999997e-07)){if(l){o=1;break}z_d(c[d>>2]|0,h,b);o=0;break}}r=c[d>>2]|0;if(!l)s=r;else s=c[l>>2]|0;c[d>>2]=s;B_d(m?0:a,h,d,e,f,b);c[d>>2]=r;o=0}while(0);if(!j){i=n;return o|0}A_d(a,j,b);if(o)z_d(c[l>>2]|0,j,b);else z_d(h,j,b);n_d(k,1);i=n;return o|0}function PYd(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im;n=i;i=i+16|0;o=n+8|0;p=n;q=c[b+16>>2]|0;r=c[b+20>>2]|0;s=q+36|0;t=c[s>>2]|0;if((t|0)!=0?(u=t+s+48|0,(c[(c[u>>2]|0)+u>>2]|0)!=0):0){v=0;w=1}else if((c[q+68>>2]|0)==-1){v=(a[d+22>>0]|0)!=0;w=0}else{v=1;w=0}q=r+4|0;r=q;u=(c[q>>2]|0)+r+(e<<3)|0;s=u+(c[u>>2]|0)|0;u=(c[s+28>>2]|0)==1;t=c[s>>2]|0;x=c[s+4>>2]|0;s=h;y=(c[h>>2]|0)+s|0;z=h+4|0;c[z>>2]=y;A=y+4|0;B=A+(c[A>>2]|0)|0;c[y+8>>2]=B;A=B+(t<<3)|0;C=A+(c[A>>2]|0)|0;c[B+(t<<3)+4>>2]=C;B=j+24|0;A=c[B>>2]|0;D=c[(c[A+4>>2]|0)+(t<<2)>>2]|0;t=c[A+16>>2]|0;E=y+16|0;F=E+(c[E>>2]|0)|0;c[y+20>>2]=F;E=F+(e*36|0)|0;c[z>>2]=y;F=y+24|0;G=F+(c[F>>2]|0)|0;c[y+28>>2]=G;y=G+(e*36|0)|0;c[o>>2]=0;n_d(c[A+76>>2]|0,0);if(a[D+56>>0]|0){A=(c[q>>2]|0)+r+(e<<3)|0;JYd(y,E,v,w,A+(c[A>>2]|0)+8|0)}A=C+72|0;if(!(a[A>>0]|0)){if((a[D+49>>0]|0)!=0?(c[(c[D+28>>2]|0)+(x*24|0)>>2]|0)==0:0)H=ea(1.0);else H=ea(ea(1.0)-ea(g[D>>2]));C=(c[h>>2]|0)+s|0;c[z>>2]=C;LYd(b,d,e,u,1,o,C,j,k,l,c[t+12>>2]|0,H)}else{H=ea(ea(1.0)-ea(g[D>>2]));c[z>>2]=(c[h>>2]|0)+s;KYd(E,b,d,e,o,0,j,k,H)}if(((a[D+25>>0]|0)!=0?(c[(c[D+4>>2]|0)+(x*24|0)>>2]|0)==0:0)?(a[A>>0]|0)==0:0)I=ea(1.0);else I=ea(g[D>>2]);D=(c[h>>2]|0)+s|0;c[z>>2]=D;z=t+12|0;LYd(b,d,e,u,0,o,D,j,k,l,c[z>>2]|0,I);l=c[b+4>>2]|0;b=c[(c[B>>2]|0)+76>>2]|0;B=c[t>>2]|0;j=c[z>>2]|0;D=c[o>>2]|0;o=(c[f>>2]|0)+f|0;c[f+4>>2]=o;d=(c[y>>2]|0)+y|0;c[G+(e*36|0)+4>>2]=d;y=G+(e*36|0)+8|0;s=(c[y>>2]|0)+y|0;c[G+(e*36|0)+12>>2]=s;a[m>>0]=(OYd(l,b,B,j,D,o,d,s,k,u)|0)&1;if(v|w){u=(c[q>>2]|0)+r+(e<<3)|0;r=u+(c[u>>2]|0)+8|0;u=c[r+4>>2]|0;q=p;c[q>>2]=c[r>>2];c[q+4>>2]=u;u=c[t+4>>2]|0;q=c[z>>2]|0;r=f+16|0;k=(c[r>>2]|0)+r|0;c[f+20>>2]=k;r=G+(e*36|0)+16|0;s=(c[r>>2]|0)+r|0;r=s;c[G+(e*36|0)+20>>2]=r;do if((D|0)>0){if((D|0)==1){I=ea(ea(g[q>>2])+ea(-1.0));if(I<ea(0.0))J=ea(-I);else J=I;if(J<=ea(9.99999997e-07)){dZd(k,c[u>>2]|0,v,w,p);break}}eZd(k,u,q,D,v,w,p)}while(0);if(s)dZd(r,k,v,w,p)}if(!w){i=n;return D|0}w=c[t+8>>2]|0;t=c[z>>2]|0;z=f+24|0;p=(c[z>>2]|0)+z|0;c[f+28>>2]=p;f=G+(e*36|0)+24|0;z=(c[f>>2]|0)+f|0;f=z;c[G+(e*36|0)+28>>2]=f;do if((D|0)>0){if((D|0)==1){J=ea(ea(g[t>>2])+ea(-1.0));if(J<ea(0.0))K=ea(-J);else K=J;if(K<=ea(9.99999997e-07)){Z_d(p,c[w>>2]|0,0);break}}d$d(p,w,t,D)}while(0);if(!z){i=n;return D|0}Z_d(f,p,0);i=n;return D|0}function QYd(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=i;i=i+16|0;m=l+8|0;n=l;if(!f){__d(k,d,e);__d(j,d,e);i=l;return}if(!(g>ea(0.0))){i=l;return}f=e;e=c[f>>2]|0;o=c[f+4>>2]|0;if(h){h=m;c[h>>2]=e;c[h+4>>2]=o;h=m+4|0;if((o&33554432|0)!=0?(a[b+424>>0]|0)!=0:0)p=o|33554432;else p=o&-33554433;c[h>>2]=p;if((p&67108864|0)!=0?(a[b+425>>0]|0)!=0:0)q=p|67108864;else q=p&-67108865;c[h>>2]=q;f$d(j,d,g,m);if(!(c[m>>2]&1)){i=l;return}f$d(k,d,g,m);i=l;return}else{m=n;c[m>>2]=e;c[m+4>>2]=o;m=n+4|0;if((o&33554432|0)!=0?(a[b+424>>0]|0)!=0:0)r=o|33554432;else r=o&-33554433;c[m>>2]=r;if((r&67108864|0)!=0?(a[b+425>>0]|0)!=0:0)s=r|67108864;else s=r&-67108865;c[m>>2]=s;e$d(j,d,g,n);if(!(c[n>>2]&1)){i=l;return}e$d(k,d,g,n);i=l;return}}function RYd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=Im,Z=0,_=0,$=0,aa=0,ba=Im,ca=0,da=0,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im;k=i;i=i+496|0;l=k+480|0;m=k+192|0;n=k+48|0;o=k+96|0;p=k+384|0;q=k+432|0;r=k+144|0;s=k+288|0;t=k+240|0;u=k+336|0;v=k;w=c[b+16>>2]|0;x=c[b+20>>2]|0;y=c[b+24>>2]|0;z=w+36|0;A=c[z>>2]|0;if((A|0)!=0?(B=A+z+48|0,(c[(c[B>>2]|0)+B>>2]|0)!=0):0){C=0;D=1}else if((c[w+68>>2]|0)==-1){C=(a[d+22>>0]|0)!=0;D=0}else{C=1;D=0}B=h+24|0;n_d(c[(c[B>>2]|0)+80>>2]|0,1);c[(c[B>>2]|0)+56>>2]=0;A=C|D;if(A)cZd(c[e+8>>2]|0);if(D){E=h+76|0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0}if((x|0)!=0?(E=f,F=(c[f>>2]|0)+E|0,G=f+4|0,c[G>>2]=F,(c[F+4>>2]|0)!=0):0){if(!(c[x>>2]|0)){H=e;I=b+4|0}else{F=x+4|0;J=F;K=y+28|0;L=b+4|0;M=e+8|0;N=b+12|0;O=e+16|0;P=e+12|0;Q=z;R=w+40|0;w=0;do{S=c[B>>2]|0;U=S+20|0;V=(c[F>>2]|0)+J+(w<<3)|0;W=V+(c[V>>2]|0)|0;V=c[W>>2]|0;do if((V|0)!=-1){X=(w|0)==0;if(X)Y=ea(1.0);else{Z=c[W+4>>2]|0;_=(c[f>>2]|0)+E|0;$=_+32|0;aa=$+(c[$>>2]|0)|0;c[_+36>>2]=aa;ba=ea(g[aa+(w<<2)>>2]);c[G>>2]=_;aa=_+4|0;$=aa+(c[aa>>2]|0)|0;c[_+8>>2]=$;_=$+(V<<3)|0;aa=_+(c[_>>2]|0)|0;c[$+(V<<3)+4>>2]=aa;$=aa+4|0;_=$+(c[$>>2]|0)|0;c[aa+8>>2]=_;Y=ea(ba*ea(g[_+(Z<<2)>>2]))}Z=(c[W+28>>2]|0)==1;a[l>>0]=0;_=PYd(b,d,w,U,f,h,X?e:0,j,l)|0;q_d(c[(c[B>>2]|0)+76>>2]|0,c[(c[K>>2]|0)+(w<<2)>>2]|0);if(!(a[l>>0]|0)){aa=c[L>>2]|0;$=(c[U>>2]|0)+U|0;c[S+24>>2]=$;ca=c[B>>2]|0;C_d(aa,$,c[ca+76>>2]|0,Y,Z,c[e>>2]|0,c[ca+80>>2]|0)}else{ca=c[B>>2]|0;o_d(c[ca+80>>2]|0,c[ca+76>>2]|0);r_d(c[(c[B>>2]|0)+80>>2]|0)}do if(A){if(!(_|w)){cZd(c[M>>2]|0);break}if(C)da=(a[(c[N>>2]|0)+w>>0]|0)!=0;else da=0;ca=S+36|0;$=(c[ca>>2]|0)+ca|0;c[S+40>>2]=$;ca=c[M>>2]|0;aa=(c[F>>2]|0)+J+(w<<3)|0;fa=aa+(c[aa>>2]|0)+8|0;if(X){aZd(ca,$)|0;break}if(!(!(Y>ea(0.0))|Z))fZd(ca,$,Y,da,D,fa)}while(0);if(D)if(!(_|w)){Y_d(c[O>>2]|0);Y_d(c[P>>2]|0);break}else{X=(c[z>>2]|0)+Q|0;c[R>>2]=X;fa=S+44|0;$=(c[fa>>2]|0)+fa|0;c[S+48>>2]=$;fa=(c[F>>2]|0)+J+(w<<3)|0;QYd(X,$,fa+(c[fa>>2]|0)+8|0,w,Y,Z,c[O>>2]|0,c[P>>2]|0);break}}while(0);w=w+1|0}while(w>>>0<(c[x>>2]|0)>>>0);H=e;I=L}z_d(c[I>>2]|0,c[H>>2]|0,c[(c[B>>2]|0)+80>>2]|0);B=c[b>>2]|0;b=c[H>>2]|0;H=x+24|0;I=(c[H>>2]|0)+H|0;c[x+28>>2]=I;x=(c[f>>2]|0)+E|0;c[G>>2]=x;G=x+40|0;E=G+(c[G>>2]|0)|0;c[x+44>>2]=E;x_d(B,b,I,E,c[y+20>>2]|0)}do if(A?(Y=ea(g[d+4>>2]),y=c[e+8>>2]|0,g[y>>2]=Y,(a[d+23>>0]|0)==0):0){E=y+4|0;if(Y!=ea(0.0)){ba=ea(ea(g[E>>2])/Y);I=y+8|0;ga=ea(ea(g[I>>2])/Y);b=y+12|0;ha=ea(ea(g[b>>2])/Y);B=y+16|0;ia=ea(ea(g[B>>2])/Y);g[E>>2]=ba;g[I>>2]=ga;g[b>>2]=ha;g[B>>2]=ia;B=y+20|0;ia=ea(ea(g[B>>2])/Y);b=y+24|0;ha=ea(ea(g[b>>2])/Y);I=y+28|0;ga=ea(ea(g[I>>2])/Y);x=y+32|0;ba=ea(ea(g[x>>2])/Y);g[B>>2]=ia;g[b>>2]=ha;g[I>>2]=ga;g[x>>2]=ba;break}else{c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;c[E+16>>2]=0;c[E+20>>2]=0;c[E+24>>2]=0;c[E+28>>2]=0;break}}while(0);if(!D){i=k;return}D=e+8|0;iZd(m,c[D>>2]|0);A=c[D>>2]|0;ba=ea(g[A+276>>2]);ga=ea(g[A+280>>2]);ha=ea(g[A+284>>2]);ia=ea(g[A+288>>2]);g[n>>2]=ba;g[n+4>>2]=ga;E=n+8|0;g[E>>2]=ha;x=n+12|0;g[x>>2]=ia;ia=ea(g[A+292>>2]);ha=ea(g[A+296>>2]);ga=ea(g[A+300>>2]);ba=ea(g[A+304>>2]);g[n+16>>2]=ia;g[n+20>>2]=ha;g[n+24>>2]=ga;g[n+28>>2]=ba;ba=ea(g[A+308>>2]);ga=ea(g[A+312>>2]);ha=ea(g[A+316>>2]);ia=ea(g[A+320>>2]);g[n+32>>2]=ba;g[n+36>>2]=ga;g[n+40>>2]=ha;g[n+44>>2]=ia;ia=ea(g[A+324>>2]);ha=ea(g[A+328>>2]);ga=ea(g[A+332>>2]);ba=ea(g[A+336>>2]);g[o>>2]=ia;g[o+4>>2]=ha;I=o+8|0;g[I>>2]=ga;b=o+12|0;g[b>>2]=ba;ba=ea(g[A+340>>2]);ga=ea(g[A+344>>2]);ha=ea(g[A+348>>2]);ia=ea(g[A+352>>2]);g[o+16>>2]=ba;g[o+20>>2]=ga;g[o+24>>2]=ha;g[o+28>>2]=ia;ia=ea(g[A+356>>2]);ha=ea(g[A+360>>2]);ga=ea(g[A+364>>2]);ba=ea(g[A+368>>2]);g[o+32>>2]=ia;g[o+36>>2]=ha;g[o+40>>2]=ga;g[o+44>>2]=ba;A=c[e+16>>2]|0;ba=ea(g[A+80>>2]);ga=ea(g[A+84>>2]);ha=ea(g[A+88>>2]);ia=ea(g[A+92>>2]);g[p>>2]=ba;e=p+4|0;g[e>>2]=ga;B=p+8|0;g[B>>2]=ha;y=p+12|0;g[y>>2]=ia;ia=ea(g[A+96>>2]);ha=ea(g[A+100>>2]);ga=ea(g[A+104>>2]);ba=ea(g[A+108>>2]);g[p+16>>2]=ia;g[p+20>>2]=ha;g[p+24>>2]=ga;g[p+28>>2]=ba;ba=ea(g[A+112>>2]);ga=ea(g[A+116>>2]);ha=ea(g[A+120>>2]);ia=ea(g[A+124>>2]);g[p+32>>2]=ba;g[p+36>>2]=ga;g[p+40>>2]=ha;g[p+44>>2]=ia;ia=ea(g[A+156>>2]);ha=ea(g[A+160>>2]);ga=ea(g[A+164>>2]);ba=ea(g[A+168>>2]);g[q>>2]=ia;G=q+4|0;g[G>>2]=ha;H=q+8|0;g[H>>2]=ga;L=q+12|0;g[L>>2]=ba;ba=ea(g[A+172>>2]);ga=ea(g[A+176>>2]);ha=ea(g[A+180>>2]);ia=ea(g[A+184>>2]);g[q+16>>2]=ba;g[q+20>>2]=ga;g[q+24>>2]=ha;g[q+28>>2]=ia;ia=ea(g[A+188>>2]);ha=ea(g[A+192>>2]);ga=ea(g[A+196>>2]);ba=ea(g[A+200>>2]);g[q+32>>2]=ia;g[q+36>>2]=ha;g[q+40>>2]=ga;g[q+44>>2]=ba;_Yd(s,m,p);$Yd(r,n,s);_Yd(u,m,q);$Yd(t,o,u);ba=ea(g[c[D>>2]>>2]);if(ba!=ea(0.0)){ga=ea(g[r>>2]);ha=ea(ga*ga);ga=ea(g[r+4>>2]);ia=ea(ga*ga);ga=ea(g[r+8>>2]);Y=ea(ga*ga);ga=ea(g[r+12>>2]);ja=ea(ea(T(ea(ea(ha+ia)+ea(Y+ea(ga*ga)))))/ba);ga=ea(g[t>>2]);Y=ea(ga*ga);ga=ea(g[t+4>>2]);ia=ea(ga*ga);ga=ea(g[t+8>>2]);ha=ea(ga*ga);ga=ea(g[t+12>>2]);ka=ja;la=ea(ea(T(ea(ea(Y+ia)+ea(ha+ea(ga*ga)))))/ba)}else{ka=ea(0.0);la=ea(0.0)}if(!(a[f+172>>0]|0)){ba=ea(g[f+168>>2]);ga=ea(g[o>>2]);ha=ea(g[n>>2]);ia=ea(ga-ha);ga=ea(g[I>>2]);Y=ea(g[E>>2]);ja=ea(ga-Y);ga=ea(g[b>>2]);ma=ea(g[x>>2]);na=ea(ha+ea(ba*ia));ia=ea(Y+ea(ba*ja));ja=ea(ma+ea(ba*ea(ga-ma)));ma=ea(ea(g[f+152>>2])-na);na=ea(ea(g[f+160>>2])-ia);ia=ea(ea(g[f+164>>2])-ja);ja=ea(g[d+16>>2]);ga=ea(ma*ja);ma=ea(na*ja);na=ea(ia*ja);ja=ea(ga*ea(g[m+32>>2]));ga=ea(ea(g[m+36>>2])*ea(0.0));ia=ea(ma*ea(g[m+40>>2]));ma=ea(na*ea(g[m+44>>2]));na=ea(ja+ja);ba=ea(ga+ga);Y=ea(ia+ia);ha=ea(g[m+16>>2]);oa=ea(ba*ha);pa=ea(g[m+20>>2]);qa=ea(Y*pa);ra=ea(g[m+24>>2]);sa=ea(na*ra);ta=ea(g[m+28>>2]);ua=ea(ta*ea(0.0));va=ea(oa-ea(na*pa));na=ea(qa-ea(ba*ra));ba=ea(sa-ea(Y*ha));Y=ea(ta*ea(ua-ua));ua=ea(ea(ja+ea(ta*na))+ea(ea(pa*va)-ea(ra*ba)));ja=ea(ea(ga+ea(ta*ba))+ea(ea(ra*na)-ea(ha*va)));ra=ea(ea(ia+ea(va*ta))+ea(ea(ha*ba)-ea(pa*na)));na=ea(ea(ma+Y)+ea(Y-Y));Y=ea(ea(g[m>>2])+ua);d=m+4|0;ua=ea(ea(g[d>>2])+ja);x=m+8|0;ja=ea(ea(g[x>>2])+ra);b=m+12|0;ra=ea(ea(g[b>>2])+na);g[m>>2]=Y;g[d>>2]=ua;g[x>>2]=ja;g[b>>2]=ra;jZd(c[D>>2]|0,m)}ra=ea(la+ka);if(ra>ea(0.0))wa=ea(VDi(ea(1.0),ea(UDi(ea(0.0),ea(ka/ra)))));else wa=ea(.5);g[f+168>>2]=wa;ra=ea(g[q>>2]);ka=ea(g[p>>2]);la=ea(ra-ka);ra=ea(g[G>>2]);ja=ea(g[e>>2]);ua=ea(ra-ja);ra=ea(g[H>>2]);Y=ea(g[B>>2]);na=ea(ra-Y);ra=ea(g[L>>2]);ma=ea(g[y>>2]);pa=ea(ja+ea(wa*ua));ua=ea(Y+ea(wa*na));na=ea(ma+ea(wa*ea(ra-ma)));g[f+152>>2]=ea(ka+ea(wa*la));g[f+156>>2]=pa;g[f+160>>2]=ua;g[f+164>>2]=na;y=c[z>>2]|0;if((y|0)!=0?(L=y+z|0,z=L+48|0,(c[(c[z>>2]|0)+z>>2]|0)!=0):0)xa=ea(g[L+392>>2]);else xa=ea(1.0);L=h+28|0;na=ea(g[f+8>>2]);ua=ea(g[f+12>>2]);pa=ea(g[f+16>>2]);la=ea(g[f+20>>2]);g[L>>2]=na;z=h+32|0;g[z>>2]=ua;y=h+36|0;g[y>>2]=pa;B=h+40|0;g[B>>2]=la;la=ea(g[f+24>>2]);pa=ea(g[f+28>>2]);ua=ea(g[f+32>>2]);na=ea(g[f+36>>2]);H=h+44|0;g[H>>2]=la;e=h+48|0;g[e>>2]=pa;G=h+52|0;g[G>>2]=ua;p=h+56|0;g[p>>2]=na;na=ea(g[f+40>>2]);ua=ea(g[f+44>>2]);pa=ea(g[f+48>>2]);la=ea(g[f+52>>2]);f=h+60|0;g[f>>2]=na;q=h+64|0;g[q>>2]=ua;D=h+68|0;g[D>>2]=pa;b=h+72|0;g[b>>2]=la;la=ea(xa*ea(g[m>>2]));h=m+4|0;pa=ea(xa*ea(g[h>>2]));x=m+8|0;ua=ea(xa*ea(g[x>>2]));d=m+12|0;na=ea(xa*ea(g[d>>2]));g[m>>2]=la;g[h>>2]=pa;g[x>>2]=ua;g[d>>2]=na;_Yd(v,L,m);na=ea(g[v>>2]);ua=ea(g[v+4>>2]);pa=ea(g[v+8>>2]);la=ea(g[v+12>>2]);g[L>>2]=na;g[z>>2]=ua;g[y>>2]=pa;g[B>>2]=la;la=ea(g[v+16>>2]);pa=ea(g[v+20>>2]);ua=ea(g[v+24>>2]);na=ea(g[v+28>>2]);g[H>>2]=la;g[e>>2]=pa;g[G>>2]=ua;g[p>>2]=na;na=ea(g[v+32>>2]);ua=ea(g[v+36>>2]);pa=ea(g[v+40>>2]);la=ea(g[v+44>>2]);g[f>>2]=na;g[q>>2]=ua;g[D>>2]=pa;g[b>>2]=la;i=k;return}function SYd(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im;h=i;i=i+96|0;j=h+48|0;k=h;l=b+36|0;m=c[l>>2]|0;if(!m)n=0;else{o=m+l+48|0;n=(c[(c[o>>2]|0)+o>>2]|0)!=0}if(!(n|(c[b+68>>2]|0)!=-1)?(a[d+22>>0]|0)==0:0){i=h;return}iZd(j,c[e+8>>2]|0);if(n){p=ea(g[(c[l>>2]|0)+l+392>>2]);q=ea(p*ea(g[j>>2]));l=j+4|0;r=ea(p*ea(g[l>>2]));n=j+8|0;s=ea(p*ea(g[n>>2]));e=j+12|0;t=ea(p*ea(g[e>>2]));g[j>>2]=q;g[l>>2]=r;g[n>>2]=s;g[e>>2]=t}e=f+8|0;_Yd(k,e,j);t=ea(g[k>>2]);s=ea(g[k+4>>2]);r=ea(g[k+8>>2]);q=ea(g[k+12>>2]);g[e>>2]=t;g[f+12>>2]=s;g[f+16>>2]=r;g[f+20>>2]=q;q=ea(g[k+16>>2]);r=ea(g[k+20>>2]);s=ea(g[k+24>>2]);t=ea(g[k+28>>2]);g[f+24>>2]=q;g[f+28>>2]=r;g[f+32>>2]=s;g[f+36>>2]=t;t=ea(g[k+32>>2]);s=ea(g[k+36>>2]);r=ea(g[k+40>>2]);q=ea(g[k+44>>2]);g[f+40>>2]=t;g[f+44>>2]=s;g[f+48>>2]=r;g[f+52>>2]=q;i=h;return}function TYd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0;k=i;i=i+928|0;l=k+880|0;m=k;if(!j){i=k;return}n=b+36|0;o=c[n>>2]|0;if(!o){i=k;return}p=n;q=o+p+48|0;if(!(c[(c[q>>2]|0)+q>>2]|0)){i=k;return}r=ea(g[f+8>>2]);s=ea(g[f+12>>2]);t=ea(g[f+16>>2]);u=ea(g[f+20>>2]);g[l>>2]=r;g[l+4>>2]=s;g[l+8>>2]=t;g[l+12>>2]=u;u=ea(g[f+24>>2]);t=ea(g[f+28>>2]);s=ea(g[f+32>>2]);r=ea(g[f+36>>2]);g[l+16>>2]=u;g[l+20>>2]=t;g[l+24>>2]=s;g[l+28>>2]=r;r=ea(g[f+40>>2]);s=ea(g[f+44>>2]);t=ea(g[f+48>>2]);u=ea(g[f+52>>2]);g[l+32>>2]=r;g[l+36>>2]=s;g[l+40>>2]=t;g[l+44>>2]=u;Q_d(m);if(!(a[d+21>>0]|0)){q=e+16|0;if((c[j>>2]|0)>>>0>1){Z_d(m,c[q>>2]|0,0);v=q;w=m}else{v=q;w=0}}else{q=e+16|0;Z_d(c[e+12>>2]|0,c[q>>2]|0,0);v=q;w=0}q=(c[n>>2]|0)+p|0;c[b+40>>2]=q;j$d(q,c[e+12>>2]|0,w,l,c[v>>2]|0,c[h>>2]|0,c[h+4>>2]|0);l=c[v>>2]|0;g[l+128>>2]=ea(0.0);g[l+132>>2]=ea(0.0);g[l+152>>2]=ea(0.0);g[l+204>>2]=ea(0.0);g[l+208>>2]=ea(0.0);g[l+228>>2]=ea(0.0);g[l+280>>2]=ea(0.0);g[l+284>>2]=ea(0.0);g[l+304>>2]=ea(0.0);g[l+356>>2]=ea(0.0);g[l+360>>2]=ea(0.0);g[l+380>>2]=ea(0.0);v=l+64|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;if(!(a[h+92>>0]|0)){i=k;return}EYd(1,b,d,f,h,e);EYd(0,b,d,f,h,e);i=k;return}function UYd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=i;i=i+16|0;k=b;if(!h){i=b;return}h=a+36|0;l=c[h>>2]|0;if(!l){i=b;return}m=h;n=l+m|0;l=n+48|0;o=(c[l>>2]|0)+l|0;if(!(c[o>>2]|0)){i=b;return}l=d+16|0;d=c[l>>2]|0;p=ea(g[d+64>>2])>ea(0.0);q=ea(g[d+68>>2])>ea(0.0);r=ea(g[d+72>>2])>ea(0.0);a:do if(q|p|r|ea(g[d+76>>2])>ea(0.0))s=1;else{t=0;u=0;while(1){if(ea(g[d+(t*76|0)+128>>2])>ea(0.0)){s=1;break a}if(ea(g[d+(t*76|0)+132>>2])>ea(0.0)){s=1;break a}v=u|ea(g[d+(t*76|0)+152>>2])>ea(0.0);t=t+1|0;if(!(t>>>0<4&(v^1))){s=v;break}else u=v}}while(0);r=c[f>>2]|0;p=r+4|0;q=p+(c[p>>2]|0)|0;c[r+8>>2]=q;w=ea(g[d>>2]);x=ea(g[d+4>>2]);y=ea(g[d+8>>2]);z=ea(g[d+12>>2]);g[q>>2]=w;g[q+4>>2]=x;g[q+8>>2]=y;g[q+12>>2]=z;z=ea(g[d+16>>2]);y=ea(g[d+20>>2]);x=ea(g[d+24>>2]);w=ea(g[d+28>>2]);g[q+16>>2]=z;g[q+20>>2]=y;g[q+24>>2]=x;g[q+28>>2]=w;w=ea(g[d+32>>2]);x=ea(g[d+36>>2]);y=ea(g[d+40>>2]);z=ea(g[d+44>>2]);g[q+32>>2]=w;g[q+36>>2]=x;g[q+40>>2]=y;g[q+44>>2]=z;if(s){c[n+52>>2]=o;n=f+4|0;x$d(o,r,c[n>>2]|0);r=(c[h>>2]|0)+m|0;c[a+40>>2]=r;l$d(r,c[l>>2]|0,c[f>>2]|0,c[n>>2]|0,c[f+8>>2]|0);A=c[l>>2]|0}else A=d;z=ea(g[A+80>>2]);y=ea(g[A+84>>2]);x=ea(g[A+88>>2]);w=ea(g[A+92>>2]);g[e+56>>2]=z;g[e+60>>2]=y;g[e+64>>2]=x;g[e+68>>2]=w;w=ea(g[A+96>>2]);x=ea(g[A+100>>2]);y=ea(g[A+104>>2]);z=ea(g[A+108>>2]);g[e+72>>2]=w;g[e+76>>2]=x;g[e+80>>2]=y;g[e+84>>2]=z;z=ea(g[A+112>>2]);y=ea(g[A+116>>2]);x=ea(g[A+120>>2]);w=ea(g[A+124>>2]);g[e+88>>2]=z;g[e+92>>2]=y;g[e+96>>2]=x;g[e+100>>2]=w;w=ea(g[A+156>>2]);x=ea(g[A+160>>2]);y=ea(g[A+164>>2]);z=ea(g[A+168>>2]);g[e+104>>2]=w;g[e+108>>2]=x;g[e+112>>2]=y;g[e+116>>2]=z;z=ea(g[A+172>>2]);y=ea(g[A+176>>2]);x=ea(g[A+180>>2]);w=ea(g[A+184>>2]);g[e+120>>2]=z;g[e+124>>2]=y;g[e+128>>2]=x;g[e+132>>2]=w;w=ea(g[A+188>>2]);x=ea(g[A+192>>2]);y=ea(g[A+196>>2]);z=ea(g[A+200>>2]);g[e+136>>2]=w;g[e+140>>2]=x;g[e+144>>2]=y;g[e+148>>2]=z;if(j){e=(c[h>>2]|0)+m|0;A=e+48|0;d=A+(c[A>>2]|0)|0;c[e+52>>2]=d;e=f+4|0;x$d(d,c[f>>2]|0,c[e>>2]|0);d=a+40|0;A=k+4|0;n=k+8|0;r=k+12|0;o=c[l>>2]|0;s=(c[h>>2]|0)+m|0;c[d>>2]=s;X_d(k,s,c[e>>2]|0,0);z=ea(g[k>>2]);y=ea(g[A>>2]);x=ea(g[n>>2]);w=ea(g[r>>2]);g[o+136>>2]=z;g[o+140>>2]=y;g[o+144>>2]=x;g[o+148>>2]=w;B=e;C=d;D=k;E=A;F=n;G=r}else{B=f+4|0;C=a+40|0;D=k;E=k+4|0;F=k+8|0;G=k+12|0}a=c[l>>2]|0;g[a+128>>2]=ea(0.0);g[a+132>>2]=ea(0.0);g[a+152>>2]=ea(0.0);if(j){j=(c[h>>2]|0)+m|0;c[C>>2]=j;X_d(k,j,c[B>>2]|0,1);w=ea(g[D>>2]);x=ea(g[E>>2]);y=ea(g[F>>2]);z=ea(g[G>>2]);g[a+212>>2]=w;g[a+216>>2]=x;g[a+220>>2]=y;g[a+224>>2]=z;j=c[l>>2]|0;g[j+204>>2]=ea(0.0);g[j+208>>2]=ea(0.0);g[j+228>>2]=ea(0.0);f=(c[h>>2]|0)+m|0;c[C>>2]=f;X_d(k,f,c[B>>2]|0,2);z=ea(g[D>>2]);y=ea(g[E>>2]);x=ea(g[F>>2]);w=ea(g[G>>2]);g[j+288>>2]=z;g[j+292>>2]=y;g[j+296>>2]=x;g[j+300>>2]=w;j=c[l>>2]|0;g[j+280>>2]=ea(0.0);g[j+284>>2]=ea(0.0);g[j+304>>2]=ea(0.0);f=(c[h>>2]|0)+m|0;c[C>>2]=f;X_d(k,f,c[B>>2]|0,3);w=ea(g[D>>2]);x=ea(g[E>>2]);y=ea(g[F>>2]);z=ea(g[G>>2]);g[j+364>>2]=w;g[j+368>>2]=x;g[j+372>>2]=y;g[j+376>>2]=z;H=c[l>>2]|0}else{g[a+204>>2]=ea(0.0);g[a+208>>2]=ea(0.0);g[a+228>>2]=ea(0.0);g[a+280>>2]=ea(0.0);g[a+284>>2]=ea(0.0);g[a+304>>2]=ea(0.0);H=a}g[H+356>>2]=ea(0.0);g[H+360>>2]=ea(0.0);g[H+380>>2]=ea(0.0);a=H+64|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=b;return}function VYd(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=0,v=0;h=i;b=a+36|0;j=c[b>>2]|0;if(!j){i=h;return}k=b;l=j+k+48|0;if(!(c[(c[l>>2]|0)+l>>2]|0)){i=h;return}l=a+48|0;j=l;m=c[(c[l>>2]|0)+j>>2]|0;n=f+4|0;s$d(c[f>>2]|0,c[n>>2]|0);o=(c[b>>2]|0)+k|0;c[a+40>>2]=o;m$d(o,c[n>>2]|0,c[f+8>>2]|0);f=a+8|0;o=(c[f>>2]|0)+f|0;c[a+12>>2]=o;f=d+4|0;s$d(o,c[f>>2]|0);o=c[f>>2]|0;d=o+4|0;p=d+(c[d>>2]|0)|0;c[o+8>>2]=p;q=ea(g[e+8>>2]);r=ea(g[e+12>>2]);s=ea(g[e+16>>2]);t=ea(g[e+20>>2]);g[p>>2]=q;g[p+4>>2]=r;g[p+8>>2]=s;g[p+12>>2]=t;t=ea(g[e+24>>2]);s=ea(g[e+28>>2]);r=ea(g[e+32>>2]);q=ea(g[e+36>>2]);g[p+16>>2]=t;g[p+20>>2]=s;g[p+24>>2]=r;g[p+28>>2]=q;q=ea(g[e+40>>2]);r=ea(g[e+44>>2]);s=ea(g[e+48>>2]);t=ea(g[e+52>>2]);g[p+32>>2]=q;g[p+36>>2]=r;g[p+40>>2]=s;g[p+44>>2]=t;p=a;e=(c[a>>2]|0)+p|0;d=a+4|0;c[d>>2]=e;y$d(e,o,o,m,0);o=(c[b>>2]|0)+k|0;e=o+48|0;u=e+(c[e>>2]|0)|0;c[o+52>>2]=u;o=c[n>>2]|0;y$d(u,o,o,1,1);o=c[n>>2]|0;u=o+4|0;e=u+(c[u>>2]|0)|0;c[o+8>>2]=e;o=c[f>>2]|0;u=o+4|0;v=u+(c[u>>2]|0)|0;c[o+8>>2]=v;t=ea(g[v+(m*48|0)>>2]);s=ea(g[v+(m*48|0)+4>>2]);r=ea(g[v+(m*48|0)+8>>2]);q=ea(g[v+(m*48|0)+12>>2]);g[e>>2]=t;g[e+4>>2]=s;g[e+8>>2]=r;g[e+12>>2]=q;q=ea(g[v+(m*48|0)+16>>2]);r=ea(g[v+(m*48|0)+20>>2]);s=ea(g[v+(m*48|0)+24>>2]);t=ea(g[v+(m*48|0)+28>>2]);g[e+16>>2]=q;g[e+20>>2]=r;g[e+24>>2]=s;g[e+28>>2]=t;t=ea(g[v+(m*48|0)+32>>2]);s=ea(g[v+(m*48|0)+36>>2]);r=ea(g[v+(m*48|0)+40>>2]);q=ea(g[v+(m*48|0)+44>>2]);g[e+32>>2]=t;g[e+36>>2]=s;g[e+40>>2]=r;g[e+44>>2]=q;e=(c[a>>2]|0)+p|0;c[d>>2]=e;A$d(e,o,o,m,0);o=(c[b>>2]|0)+k|0;k=o+48|0;b=k+(c[k>>2]|0)|0;c[o+52>>2]=b;o=c[n>>2]|0;A$d(b,o,o,1,1);o=c[n>>2]|0;n=o+4|0;b=n+(c[n>>2]|0)|0;c[o+8>>2]=b;n=c[f>>2]|0;f=n+4|0;k=f+(c[f>>2]|0)|0;c[n+8>>2]=k;q=ea(g[k+(m*48|0)>>2]);r=ea(g[k+(m*48|0)+4>>2]);s=ea(g[k+(m*48|0)+8>>2]);t=ea(g[k+(m*48|0)+12>>2]);g[b>>2]=q;g[b+4>>2]=r;g[b+8>>2]=s;g[b+12>>2]=t;t=ea(g[k+(m*48|0)+16>>2]);s=ea(g[k+(m*48|0)+20>>2]);r=ea(g[k+(m*48|0)+24>>2]);q=ea(g[k+(m*48|0)+28>>2]);g[b+16>>2]=t;g[b+20>>2]=s;g[b+24>>2]=r;g[b+28>>2]=q;q=ea(g[k+(m*48|0)+32>>2]);r=ea(g[k+(m*48|0)+36>>2]);s=ea(g[k+(m*48|0)+40>>2]);t=ea(g[k+(m*48|0)+44>>2]);g[b+32>>2]=q;g[b+36>>2]=r;g[b+40>>2]=s;g[b+44>>2]=t;b=c[a+44>>2]|0;m=(c[l>>2]|0)+j|0;c[a+52>>2]=m;t$d(o,n,b,m);i=h;return}function WYd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=0,J=0,K=Im;k=i;l=j&1;if(l>>>0>=(c[a>>2]|0)>>>0){i=k;return}j=(h|0)==0;m=f+4|0;n=m;o=f+8|0;f=b+4|0;b=f;p=d+64|0;q=p;r=d+52|0;s=r;t=d+40|0;d=t;u=l;do{if(!(!j?(c[h+(u<<2)>>2]|0)!=-1:0))v=5;do if((v|0)==5){v=0;l=c[e+(u*12|0)>>2]|0;w=(c[m>>2]|0)+n|0;c[o>>2]=w;if((l|0)==-1){x=(c[f>>2]|0)+b|0;y=x+(u*48|0)+12|0;z=x+(u*48|0)+8|0;A=x+(u*48|0)+4|0;B=x+(u*48|0)|0}else{x=(c[t>>2]|0)+d|0;y=x+(l<<4)+12|0;z=x+(l<<4)+8|0;A=x+(l<<4)+4|0;B=x+(l<<4)|0}C=ea(g[y>>2]);D=ea(g[z>>2]);E=ea(g[A>>2]);g[w+(u*48|0)>>2]=ea(g[B>>2]);g[w+(u*48|0)+4>>2]=E;g[w+(u*48|0)+8>>2]=D;g[w+(u*48|0)+12>>2]=C;w=c[e+(u*12|0)+4>>2]|0;l=(c[m>>2]|0)+n|0;c[o>>2]=l;if((w|0)==-1){x=(c[f>>2]|0)+b|0;F=x+(u*48|0)+28|0;G=x+(u*48|0)+24|0;H=x+(u*48|0)+20|0;I=x+(u*48|0)+16|0}else{x=(c[r>>2]|0)+s|0;F=x+(w<<4)+12|0;G=x+(w<<4)+8|0;H=x+(w<<4)+4|0;I=x+(w<<4)|0}C=ea(g[F>>2]);D=ea(g[G>>2]);E=ea(g[H>>2]);g[l+(u*48|0)+16>>2]=ea(g[I>>2]);g[l+(u*48|0)+20>>2]=E;g[l+(u*48|0)+24>>2]=D;g[l+(u*48|0)+28>>2]=C;l=c[e+(u*12|0)+8>>2]|0;w=(c[m>>2]|0)+n|0;c[o>>2]=w;x=w+(u*48|0)+32|0;if((l|0)==-1){J=(c[f>>2]|0)+b|0;C=ea(g[J+(u*48|0)+32>>2]);D=ea(g[J+(u*48|0)+36>>2]);E=ea(g[J+(u*48|0)+40>>2]);K=ea(g[J+(u*48|0)+44>>2]);g[x>>2]=C;g[w+(u*48|0)+36>>2]=D;g[w+(u*48|0)+40>>2]=E;g[w+(u*48|0)+44>>2]=K;break}else{J=(c[p>>2]|0)+q|0;K=ea(g[J+(l<<4)>>2]);E=ea(g[J+(l<<4)+4>>2]);D=ea(g[J+(l<<4)+8>>2]);C=ea(g[J+(l<<4)+12>>2]);g[x>>2]=K;g[w+(u*48|0)+36>>2]=E;g[w+(u*48|0)+40>>2]=D;g[w+(u*48|0)+44>>2]=C;break}}while(0);u=u+1|0}while(u>>>0<(c[a>>2]|0)>>>0);i=k;return}function XYd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im;f=i;h=c[a>>2]|0;if(!h){i=f;return}a=b+4|0;b=(c[a>>2]|0)+a|0;a=e+64|0;j=(c[a>>2]|0)+a|0;a=e+68|0;k=e+52|0;l=(c[k>>2]|0)+k|0;k=e+56|0;m=e+40|0;n=(c[m>>2]|0)+m|0;m=e+44|0;e=0;do{o=c[d+(e*12|0)>>2]|0;if((o|0)!=-1){c[m>>2]=n;p=ea(g[b+(e*48|0)>>2]);q=ea(g[b+(e*48|0)+4>>2]);r=ea(g[b+(e*48|0)+8>>2]);s=ea(g[b+(e*48|0)+12>>2]);g[n+(o<<4)>>2]=p;g[n+(o<<4)+4>>2]=q;g[n+(o<<4)+8>>2]=r;g[n+(o<<4)+12>>2]=s}o=c[d+(e*12|0)+4>>2]|0;if((o|0)!=-1){c[k>>2]=l;s=ea(g[b+(e*48|0)+16>>2]);r=ea(g[b+(e*48|0)+20>>2]);q=ea(g[b+(e*48|0)+24>>2]);p=ea(g[b+(e*48|0)+28>>2]);g[l+(o<<4)>>2]=s;g[l+(o<<4)+4>>2]=r;g[l+(o<<4)+8>>2]=q;g[l+(o<<4)+12>>2]=p}o=c[d+(e*12|0)+8>>2]|0;if((o|0)!=-1){c[a>>2]=j;p=ea(g[b+(e*48|0)+32>>2]);q=ea(g[b+(e*48|0)+36>>2]);r=ea(g[b+(e*48|0)+40>>2]);s=ea(g[b+(e*48|0)+44>>2]);g[j+(o<<4)>>2]=p;g[j+(o<<4)+4>>2]=q;g[j+(o<<4)+8>>2]=r;g[j+(o<<4)+12>>2]=s}e=e+1|0}while(e>>>0<h>>>0);i=f;return}function YYd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=xo[c[c[a>>2]>>2]&2047](a,424,b)|0;if(!e){f=0;i=d;return f|0}g[e>>2]=ea(0.0);b=e+36|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+64>>2]=ea(1.0);g[e+68>>2]=ea(1.0);g[e+72>>2]=ea(1.0);g[e+76>>2]=ea(1.0);g[e+80>>2]=ea(1.0);b=e+84|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+112>>2]=ea(1.0);g[e+116>>2]=ea(1.0);g[e+120>>2]=ea(1.0);g[e+124>>2]=ea(1.0);g[e+128>>2]=ea(1.0);b=e+132|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+160>>2]=ea(1.0);g[e+164>>2]=ea(1.0);g[e+168>>2]=ea(1.0);g[e+172>>2]=ea(1.0);g[e+176>>2]=ea(1.0);b=e+180|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+208>>2]=ea(1.0);g[e+212>>2]=ea(1.0);g[e+216>>2]=ea(1.0);g[e+220>>2]=ea(1.0);g[e+224>>2]=ea(1.0);b=e+228|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+256>>2]=ea(1.0);g[e+260>>2]=ea(1.0);g[e+264>>2]=ea(1.0);g[e+268>>2]=ea(1.0);g[e+272>>2]=ea(1.0);b=e+276|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+304>>2]=ea(1.0);g[e+308>>2]=ea(1.0);g[e+312>>2]=ea(1.0);g[e+316>>2]=ea(1.0);g[e+320>>2]=ea(1.0);b=e+324|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+352>>2]=ea(1.0);g[e+356>>2]=ea(1.0);g[e+360>>2]=ea(1.0);g[e+364>>2]=ea(1.0);g[e+368>>2]=ea(1.0);b=e+372|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;g[e+400>>2]=ea(1.0);g[e+404>>2]=ea(1.0);g[e+408>>2]=ea(1.0);g[e+412>>2]=ea(1.0);g[e+416>>2]=ea(1.0);g[e+420>>2]=ea(0.0);b=e+4|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;f=e;i=d;return f|0}function ZYd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;d=ea(-ea(g[b+16>>2]));e=ea(-ea(g[b+20>>2]));f=ea(-ea(g[b+24>>2]));h=ea(g[b+28>>2]);i=ea(g[c>>2]);j=ea(i-ea(g[b>>2]));i=ea(g[c+4>>2]);k=ea(i-ea(g[b+4>>2]));i=ea(g[c+8>>2]);l=ea(i-ea(g[b+8>>2]));i=ea(g[c+12>>2]);m=ea(j+j);n=ea(k+k);o=ea(l+l);p=ea(h*ea(0.0));q=ea(ea(n*d)-ea(m*e));r=ea(ea(o*e)-ea(n*f));n=ea(ea(m*f)-ea(o*d));o=ea(h*ea(p-p));p=ea(ea(j+ea(h*r))+ea(ea(q*e)-ea(n*f)));j=ea(ea(k+ea(h*n))+ea(ea(r*f)-ea(q*d)));k=ea(ea(l+ea(h*q))+ea(ea(n*d)-ea(r*e)));r=ea(ea(o-o)+ea(o+ea(i-ea(g[b+12>>2]))));i=ea(g[c+16>>2]);o=ea(i*e);n=ea(g[c+28>>2]);q=ea(h*n);l=ea(g[c+20>>2]);m=ea(l*f);s=ea(g[c+24>>2]);t=ea(ea(ea(o-ea(h*s))-ea(n*f))-ea(l*d));o=ea(ea(ea(q-ea(i*d))-ea(s*f))-ea(l*e));q=ea(ea(ea(m-ea(s*e))-ea(h*i))-ea(n*d));m=ea(ea(ea(ea(s*d)-ea(i*f))-ea(h*l))-ea(n*e));e=ea(ea(1.0)/ea(T(ea(ea(ea(q*q)+ea(m*m))+ea(ea(o*o)+ea(t*t))))));n=ea(-ea(e*q));q=ea(-ea(e*m));m=ea(-ea(e*t));t=ea(e*o);g[a>>2]=p;g[a+4>>2]=j;g[a+8>>2]=k;g[a+12>>2]=r;g[a+16>>2]=n;g[a+20>>2]=q;g[a+24>>2]=m;g[a+28>>2]=t;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);return}function _Yd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=0,f=Im,h=0,i=Im,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(g[c>>2]);e=b+32|0;f=ea(d*ea(g[e>>2]));d=ea(g[c+4>>2]);h=b+36|0;i=ea(d*ea(g[h>>2]));d=ea(g[c+8>>2]);j=b+40|0;k=ea(d*ea(g[j>>2]));d=ea(g[c+12>>2]);l=b+44|0;m=ea(d*ea(g[l>>2]));d=ea(f+f);n=ea(i+i);o=ea(k+k);p=ea(g[b+16>>2]);q=ea(n*p);r=ea(g[b+20>>2]);s=ea(o*r);t=ea(g[b+24>>2]);u=ea(d*t);v=ea(g[b+28>>2]);w=ea(v*ea(0.0));x=ea(q-ea(d*r));d=ea(s-ea(n*t));n=ea(u-ea(o*p));o=ea(v*ea(w-w));w=ea(ea(f+ea(v*d))+ea(ea(r*x)-ea(t*n)));f=ea(ea(i+ea(v*n))+ea(ea(t*d)-ea(p*x)));i=ea(ea(k+ea(x*v))+ea(ea(p*n)-ea(r*d)));d=ea(ea(m+o)+ea(o-o));o=ea(ea(g[b>>2])+w);w=ea(ea(g[b+4>>2])+f);f=ea(ea(g[b+8>>2])+i);i=ea(ea(g[b+12>>2])+d);d=ea(g[c+16>>2]);m=ea(r*d);n=ea(g[c+28>>2]);x=ea(v*n);k=ea(g[c+20>>2]);u=ea(t*k);s=ea(g[c+24>>2]);q=ea(ea(ea(m-ea(v*s))-ea(n*t))-ea(k*p));m=ea(ea(ea(x-ea(d*p))-ea(t*s))-ea(r*k));x=ea(ea(ea(u-ea(r*s))-ea(d*v))-ea(n*p));u=ea(ea(ea(ea(p*s)-ea(d*t))-ea(v*k))-ea(r*n));n=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(u*u))+ea(ea(m*m)+ea(q*q))))));r=ea(-ea(n*x));x=ea(-ea(n*u));u=ea(-ea(n*q));q=ea(n*m);m=ea(g[e>>2]);n=ea(m*ea(g[c+32>>2]));m=ea(g[h>>2]);k=ea(m*ea(g[c+36>>2]));m=ea(g[j>>2]);v=ea(m*ea(g[c+40>>2]));m=ea(g[l>>2]);t=ea(m*ea(g[c+44>>2]));g[a>>2]=o;g[a+4>>2]=w;g[a+8>>2]=f;g[a+12>>2]=i;g[a+16>>2]=r;g[a+20>>2]=x;g[a+24>>2]=u;g[a+28>>2]=q;g[a+32>>2]=n;g[a+36>>2]=k;g[a+40>>2]=v;g[a+44>>2]=t;return}function $Yd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(-ea(g[b+16>>2]));e=ea(-ea(g[b+20>>2]));f=ea(-ea(g[b+24>>2]));h=ea(g[b+28>>2]);i=ea(g[c>>2]);j=ea(i-ea(g[b>>2]));i=ea(g[c+4>>2]);k=ea(i-ea(g[b+4>>2]));i=ea(g[c+8>>2]);l=ea(i-ea(g[b+8>>2]));i=ea(g[c+12>>2]);m=ea(j+j);n=ea(k+k);o=ea(l+l);p=ea(h*ea(0.0));q=ea(ea(n*d)-ea(m*e));r=ea(ea(o*e)-ea(n*f));n=ea(ea(m*f)-ea(o*d));o=ea(h*ea(p-p));p=ea(ea(j+ea(h*r))+ea(ea(q*e)-ea(n*f)));j=ea(ea(k+ea(h*n))+ea(ea(r*f)-ea(q*d)));k=ea(ea(l+ea(h*q))+ea(ea(n*d)-ea(r*e)));r=ea(ea(o-o)+ea(o+ea(i-ea(g[b+12>>2]))));i=ea(g[b+32>>2]);o=ea(p/i);p=ea(g[b+36>>2]);n=ea(j/p);j=ea(g[b+40>>2]);q=ea(k/j);k=ea(g[b+44>>2]);l=ea(r/k);r=ea(g[c+16>>2]);m=ea(r*e);s=ea(g[c+28>>2]);t=ea(h*s);u=ea(g[c+20>>2]);v=ea(u*f);w=ea(g[c+24>>2]);x=ea(ea(ea(m-ea(h*w))-ea(s*f))-ea(u*d));m=ea(ea(ea(t-ea(r*d))-ea(w*f))-ea(u*e));t=ea(ea(ea(v-ea(w*e))-ea(h*r))-ea(s*d));v=ea(ea(ea(ea(w*d)-ea(r*f))-ea(h*u))-ea(s*e));e=ea(ea(1.0)/ea(T(ea(ea(ea(t*t)+ea(v*v))+ea(ea(m*m)+ea(x*x))))));s=ea(-ea(e*t));t=ea(-ea(e*v));v=ea(-ea(e*x));x=ea(e*m);m=ea(ea(g[c+32>>2])/i);i=ea(ea(g[c+36>>2])/p);p=ea(ea(g[c+40>>2])/j);j=ea(ea(g[c+44>>2])/k);g[a>>2]=o;g[a+4>>2]=n;g[a+8>>2]=q;g[a+12>>2]=l;g[a+16>>2]=s;g[a+20>>2]=t;g[a+24>>2]=v;g[a+28>>2]=x;g[a+32>>2]=m;g[a+36>>2]=i;g[a+40>>2]=p;g[a+44>>2]=j;return}function aZd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;g[a>>2]=ea(g[b>>2]);c=ea(g[b+4>>2]);d=ea(g[b+8>>2]);e=ea(g[b+12>>2]);f=ea(g[b+16>>2]);g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=e;g[a+16>>2]=f;f=ea(g[b+20>>2]);e=ea(g[b+24>>2]);d=ea(g[b+28>>2]);c=ea(g[b+32>>2]);g[a+20>>2]=f;g[a+24>>2]=e;g[a+28>>2]=d;g[a+32>>2]=c;c=ea(g[b+36>>2]);d=ea(g[b+40>>2]);e=ea(g[b+44>>2]);f=ea(g[b+48>>2]);g[a+36>>2]=c;g[a+40>>2]=d;g[a+44>>2]=e;g[a+48>>2]=f;f=ea(g[b+52>>2]);e=ea(g[b+56>>2]);d=ea(g[b+60>>2]);c=ea(g[b+64>>2]);g[a+52>>2]=f;g[a+56>>2]=e;g[a+60>>2]=d;g[a+64>>2]=c;c=ea(g[b+68>>2]);d=ea(g[b+72>>2]);e=ea(g[b+76>>2]);f=ea(g[b+80>>2]);g[a+68>>2]=c;g[a+72>>2]=d;g[a+76>>2]=e;g[a+80>>2]=f;f=ea(g[b+84>>2]);e=ea(g[b+88>>2]);d=ea(g[b+92>>2]);c=ea(g[b+96>>2]);g[a+84>>2]=f;g[a+88>>2]=e;g[a+92>>2]=d;g[a+96>>2]=c;c=ea(g[b+100>>2]);d=ea(g[b+104>>2]);e=ea(g[b+108>>2]);f=ea(g[b+112>>2]);g[a+100>>2]=c;g[a+104>>2]=d;g[a+108>>2]=e;g[a+112>>2]=f;f=ea(g[b+116>>2]);e=ea(g[b+120>>2]);d=ea(g[b+124>>2]);c=ea(g[b+128>>2]);g[a+116>>2]=f;g[a+120>>2]=e;g[a+124>>2]=d;g[a+128>>2]=c;c=ea(g[b+132>>2]);d=ea(g[b+136>>2]);e=ea(g[b+140>>2]);f=ea(g[b+144>>2]);g[a+132>>2]=c;g[a+136>>2]=d;g[a+140>>2]=e;g[a+144>>2]=f;f=ea(g[b+148>>2]);e=ea(g[b+152>>2]);d=ea(g[b+156>>2]);c=ea(g[b+160>>2]);g[a+148>>2]=f;g[a+152>>2]=e;g[a+156>>2]=d;g[a+160>>2]=c;c=ea(g[b+164>>2]);d=ea(g[b+168>>2]);e=ea(g[b+172>>2]);f=ea(g[b+176>>2]);g[a+164>>2]=c;g[a+168>>2]=d;g[a+172>>2]=e;g[a+176>>2]=f;f=ea(g[b+180>>2]);e=ea(g[b+184>>2]);d=ea(g[b+188>>2]);c=ea(g[b+192>>2]);g[a+180>>2]=f;g[a+184>>2]=e;g[a+188>>2]=d;g[a+192>>2]=c;c=ea(g[b+196>>2]);d=ea(g[b+200>>2]);e=ea(g[b+204>>2]);f=ea(g[b+208>>2]);g[a+196>>2]=c;g[a+200>>2]=d;g[a+204>>2]=e;g[a+208>>2]=f;f=ea(g[b+212>>2]);e=ea(g[b+216>>2]);d=ea(g[b+220>>2]);c=ea(g[b+224>>2]);g[a+212>>2]=f;g[a+216>>2]=e;g[a+220>>2]=d;g[a+224>>2]=c;c=ea(g[b+228>>2]);d=ea(g[b+232>>2]);e=ea(g[b+236>>2]);f=ea(g[b+240>>2]);g[a+228>>2]=c;g[a+232>>2]=d;g[a+236>>2]=e;g[a+240>>2]=f;f=ea(g[b+244>>2]);e=ea(g[b+248>>2]);d=ea(g[b+252>>2]);c=ea(g[b+256>>2]);g[a+244>>2]=f;g[a+248>>2]=e;g[a+252>>2]=d;g[a+256>>2]=c;c=ea(g[b+260>>2]);d=ea(g[b+264>>2]);e=ea(g[b+268>>2]);f=ea(g[b+272>>2]);g[a+260>>2]=c;g[a+264>>2]=d;g[a+268>>2]=e;g[a+272>>2]=f;f=ea(g[b+276>>2]);e=ea(g[b+280>>2]);d=ea(g[b+284>>2]);c=ea(g[b+288>>2]);g[a+276>>2]=f;g[a+280>>2]=e;g[a+284>>2]=d;g[a+288>>2]=c;c=ea(g[b+292>>2]);d=ea(g[b+296>>2]);e=ea(g[b+300>>2]);f=ea(g[b+304>>2]);g[a+292>>2]=c;g[a+296>>2]=d;g[a+300>>2]=e;g[a+304>>2]=f;f=ea(g[b+308>>2]);e=ea(g[b+312>>2]);d=ea(g[b+316>>2]);c=ea(g[b+320>>2]);g[a+308>>2]=f;g[a+312>>2]=e;g[a+316>>2]=d;g[a+320>>2]=c;c=ea(g[b+324>>2]);d=ea(g[b+328>>2]);e=ea(g[b+332>>2]);f=ea(g[b+336>>2]);g[a+324>>2]=c;g[a+328>>2]=d;g[a+332>>2]=e;g[a+336>>2]=f;f=ea(g[b+340>>2]);e=ea(g[b+344>>2]);d=ea(g[b+348>>2]);c=ea(g[b+352>>2]);g[a+340>>2]=f;g[a+344>>2]=e;g[a+348>>2]=d;g[a+352>>2]=c;c=ea(g[b+356>>2]);d=ea(g[b+360>>2]);e=ea(g[b+364>>2]);f=ea(g[b+368>>2]);g[a+356>>2]=c;g[a+360>>2]=d;g[a+364>>2]=e;g[a+368>>2]=f;f=ea(g[b+372>>2]);e=ea(g[b+376>>2]);d=ea(g[b+380>>2]);c=ea(g[b+384>>2]);g[a+372>>2]=f;g[a+376>>2]=e;g[a+380>>2]=d;g[a+384>>2]=c;c=ea(g[b+388>>2]);d=ea(g[b+392>>2]);e=ea(g[b+396>>2]);f=ea(g[b+400>>2]);g[a+388>>2]=c;g[a+392>>2]=d;g[a+396>>2]=e;g[a+400>>2]=f;f=ea(g[b+404>>2]);e=ea(g[b+408>>2]);d=ea(g[b+412>>2]);c=ea(g[b+416>>2]);g[a+404>>2]=f;g[a+408>>2]=e;g[a+412>>2]=d;g[a+416>>2]=c;g[a+420>>2]=ea(g[b+420>>2]);return a|0}function bZd(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+1152|0;e=b;f=b+768|0;g=b+640|0;h=b+256|0;j=b+512|0;k=b+128|0;l=b+384|0;m=b+896|0;n=b+1024|0;UEi(697672,715896,128)|0;a[697799]=0;UEi(697800|0,715912,128)|0;a[697927]=0;UEi(697928|0,715928,128)|0;a[698055]=0;UEi(698056|0,715944,128)|0;a[698183]=0;UEi(698184|0,715960,128)|0;a[698311]=0;UEi(698312|0,715976,128)|0;a[698439]=0;UEi(698440|0,715992,128)|0;a[698567]=0;UEi(698568|0,716008,128)|0;a[698695]=0;UEi(698696|0,716016,128)|0;a[698823]=0;UEi(698824|0,716024,128)|0;a[698951]=0;UEi(698952|0,716032,128)|0;a[699079]=0;UEi(699080|0,716040,128)|0;a[699207]=0;UEi(699208|0,716048,128)|0;a[699335]=0;UEi(699336|0,716056,128)|0;a[699463]=0;o=e+127|0;p=f+127|0;q=g+127|0;r=h+127|0;s=j+127|0;t=k+127|0;u=l+127|0;v=m+127|0;w=n+127|0;x=14;y=0;while(1){z=c[718536+(y<<4)>>2]|0;UEi(e|0,M_d(z)|0,128)|0;a[o>>0]=0;kCi(e,3132880,128-(SEi(e|0)|0)|0)|0;a[o>>0]=0;UEi(f|0,e|0,128)|0;a[p>>0]=0;kCi(f,716064,128-(SEi(f|0)|0)|0)|0;a[p>>0]=0;UEi(g|0,e|0,128)|0;a[q>>0]=0;kCi(g,716072,128-(SEi(g|0)|0)|0)|0;a[q>>0]=0;UEi(h|0,e|0,128)|0;a[r>>0]=0;kCi(h,716080,128-(SEi(h|0)|0)|0)|0;a[r>>0]=0;UEi(j|0,M_d(z)|0,128)|0;a[s>>0]=0;kCi(j,2968544,128-(SEi(j|0)|0)|0)|0;a[s>>0]=0;UEi(k|0,j|0,128)|0;a[t>>0]=0;kCi(k,716064,128-(SEi(k|0)|0)|0)|0;a[t>>0]=0;UEi(l|0,j|0,128)|0;a[u>>0]=0;kCi(l,716072,128-(SEi(l|0)|0)|0)|0;a[u>>0]=0;UEi(m|0,j|0,128)|0;a[v>>0]=0;kCi(m,716080,128-(SEi(m|0)|0)|0)|0;a[v>>0]=0;UEi(n|0,j|0,128)|0;a[w>>0]=0;kCi(n,716088,128-(SEi(n|0)|0)|0)|0;a[w>>0]=0;z=x+1|0;UEi(697672+(x<<7)|0,f|0,128)|0;a[697799+(x<<7)>>0]=0;A=x+2|0;UEi(697672+(z<<7)|0,g|0,128)|0;a[697799+(z<<7)>>0]=0;z=x+3|0;UEi(697672+(A<<7)|0,h|0,128)|0;a[697799+(A<<7)>>0]=0;A=x+4|0;UEi(697672+(z<<7)|0,k|0,128)|0;a[697799+(z<<7)>>0]=0;z=x+5|0;UEi(697672+(A<<7)|0,l|0,128)|0;a[697799+(A<<7)>>0]=0;A=x+6|0;UEi(697672+(z<<7)|0,m|0,128)|0;a[697799+(z<<7)>>0]=0;UEi(697672+(A<<7)|0,n|0,128)|0;a[697799+(A<<7)>>0]=0;y=y+1|0;if((y|0)==4){B=42;C=0;break}else x=x+7|0}while(1){UEi(697672+(B<<7)|0,N_d(C)|0,128)|0;a[697799+(B<<7)>>0]=0;C=C+1|0;if((C|0)==52)break;else B=B+1|0}B=e+127|0;C=0;x=94;while(1){y=0;n=x;while(1){UEi(e|0,716096,128)|0;a[B>>0]=0;m=G_d(C)|0;kCi(e,m,128-(SEi(e|0)|0)|0)|0;a[B>>0]=0;kCi(e,3672776,128-(SEi(e|0)|0)|0)|0;a[B>>0]=0;m=I_d(y)|0;kCi(e,m,128-(SEi(e|0)|0)|0)|0;a[B>>0]=0;UEi(697672+(n<<7)|0,e|0,128)|0;a[697799+(n<<7)>>0]=0;y=y+1|0;if((y|0)==4)break;else n=n+1|0}C=C+1|0;if((C|0)==5)break;else x=x+4|0}x=e+127|0;C=0;B=114;while(1){n=0;y=B;while(1){UEi(e|0,716112,128)|0;a[x>>0]=0;m=G_d(C)|0;kCi(e,m,128-(SEi(e|0)|0)|0)|0;a[x>>0]=0;kCi(e,3672776,128-(SEi(e|0)|0)|0)|0;a[x>>0]=0;m=I_d(n)|0;kCi(e,m,128-(SEi(e|0)|0)|0)|0;a[x>>0]=0;UEi(697672+(y<<7)|0,e|0,128)|0;a[697799+(y<<7)>>0]=0;n=n+1|0;if((n|0)==4)break;else y=y+1|0}C=C+1|0;if((C|0)==5){D=0;break}else B=B+4|0}do{c[714824+(D<<3)>>2]=D;B=-1;C=0;x=0;while(1){if(!(B&1))E=x;else E=1<<31-C|x;C=C+1|0;if((C|0)==32){F=E;break}else{B=B>>>1;x=E}}x=697672+(D<<7)|0;B=SEi(x|0)|0;C=697672+(D<<7)+B|0;if((B|0)>0){B=F;y=x;while(1){x=c[572464+(((d[y>>0]|0)^B&255)<<2)>>2]^B>>>8;y=y+1|0;if((y|0)==(C|0)){G=x;break}else B=x}}else G=F;c[714828+(D<<3)>>2]=~G;D=D+1|0}while((D|0)!=134);c[e>>2]=2739;CZd(714824,715896|0,e);i=b;return}function cZd(a){a=a|0;var b=0,d=0,e=0,f=0,h=0;b=i;d=a+84|0;e=a+112|0;f=a+0|0;h=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[e>>2]=ea(1.0);g[a+116>>2]=ea(1.0);g[a+120>>2]=ea(1.0);g[a+124>>2]=ea(1.0);g[a+128>>2]=ea(1.0);e=a+132|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[a+160>>2]=ea(1.0);g[a+164>>2]=ea(1.0);g[a+168>>2]=ea(1.0);g[a+172>>2]=ea(1.0);g[a+176>>2]=ea(1.0);e=a+180|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[a+208>>2]=ea(1.0);g[a+212>>2]=ea(1.0);g[a+216>>2]=ea(1.0);g[a+220>>2]=ea(1.0);g[a+224>>2]=ea(1.0);e=a+228|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[a+256>>2]=ea(1.0);g[a+260>>2]=ea(1.0);g[a+264>>2]=ea(1.0);g[a+268>>2]=ea(1.0);g[a+272>>2]=ea(1.0);e=a+276|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[a+304>>2]=ea(1.0);g[a+308>>2]=ea(1.0);g[a+312>>2]=ea(1.0);g[a+316>>2]=ea(1.0);g[a+320>>2]=ea(1.0);e=a+324|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[a+352>>2]=ea(1.0);g[a+356>>2]=ea(1.0);g[a+360>>2]=ea(1.0);g[a+364>>2]=ea(1.0);g[a+368>>2]=ea(1.0);e=a+372|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[a+400>>2]=ea(1.0);g[a+404>>2]=ea(1.0);g[a+408>>2]=ea(1.0);g[a+412>>2]=ea(1.0);g[a+416>>2]=ea(1.0);g[a+420>>2]=ea(0.0);i=b;return}function dZd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=Im,l=Im,m=Im,n=Im;h=i;do if(!d)if(e)if(!(c[f>>2]&1))break;else{j=4;break}else{i=h;return}else j=4;while(0);if((j|0)==4){k=ea(g[b+4>>2]);l=ea(g[b+8>>2]);m=ea(g[b+12>>2]);n=ea(g[b+16>>2]);g[a+4>>2]=k;g[a+8>>2]=l;g[a+12>>2]=m;g[a+16>>2]=n;n=ea(g[b+20>>2]);m=ea(g[b+24>>2]);l=ea(g[b+28>>2]);k=ea(g[b+32>>2]);g[a+20>>2]=n;g[a+24>>2]=m;g[a+28>>2]=l;g[a+32>>2]=k;g[a+420>>2]=ea(g[b+420>>2])}if(d){k=ea(g[b+84>>2]);l=ea(g[b+88>>2]);m=ea(g[b+92>>2]);n=ea(g[b+96>>2]);g[a+84>>2]=k;g[a+88>>2]=l;g[a+92>>2]=m;g[a+96>>2]=n;n=ea(g[b+100>>2]);m=ea(g[b+104>>2]);l=ea(g[b+108>>2]);k=ea(g[b+112>>2]);g[a+100>>2]=n;g[a+104>>2]=m;g[a+108>>2]=l;g[a+112>>2]=k;k=ea(g[b+116>>2]);l=ea(g[b+120>>2]);m=ea(g[b+124>>2]);n=ea(g[b+128>>2]);g[a+116>>2]=k;g[a+120>>2]=l;g[a+124>>2]=m;g[a+128>>2]=n;n=ea(g[b+132>>2]);m=ea(g[b+136>>2]);l=ea(g[b+140>>2]);k=ea(g[b+144>>2]);g[a+132>>2]=n;g[a+136>>2]=m;g[a+140>>2]=l;g[a+144>>2]=k;k=ea(g[b+148>>2]);l=ea(g[b+152>>2]);m=ea(g[b+156>>2]);n=ea(g[b+160>>2]);g[a+148>>2]=k;g[a+152>>2]=l;g[a+156>>2]=m;g[a+160>>2]=n;n=ea(g[b+164>>2]);m=ea(g[b+168>>2]);l=ea(g[b+172>>2]);k=ea(g[b+176>>2]);g[a+164>>2]=n;g[a+168>>2]=m;g[a+172>>2]=l;g[a+176>>2]=k;k=ea(g[b+180>>2]);l=ea(g[b+184>>2]);m=ea(g[b+188>>2]);n=ea(g[b+192>>2]);g[a+180>>2]=k;g[a+184>>2]=l;g[a+188>>2]=m;g[a+192>>2]=n;n=ea(g[b+196>>2]);m=ea(g[b+200>>2]);l=ea(g[b+204>>2]);k=ea(g[b+208>>2]);g[a+196>>2]=n;g[a+200>>2]=m;g[a+204>>2]=l;g[a+208>>2]=k;k=ea(g[b+212>>2]);l=ea(g[b+216>>2]);m=ea(g[b+220>>2]);n=ea(g[b+224>>2]);g[a+212>>2]=k;g[a+216>>2]=l;g[a+220>>2]=m;g[a+224>>2]=n}if(!e){i=h;return}if(c[f>>2]&1){n=ea(g[b+228>>2]);m=ea(g[b+232>>2]);l=ea(g[b+236>>2]);k=ea(g[b+240>>2]);g[a+228>>2]=n;g[a+232>>2]=m;g[a+236>>2]=l;g[a+240>>2]=k;k=ea(g[b+244>>2]);l=ea(g[b+248>>2]);m=ea(g[b+252>>2]);n=ea(g[b+256>>2]);g[a+244>>2]=k;g[a+248>>2]=l;g[a+252>>2]=m;g[a+256>>2]=n;n=ea(g[b+260>>2]);m=ea(g[b+264>>2]);l=ea(g[b+268>>2]);k=ea(g[b+272>>2]);g[a+260>>2]=n;g[a+264>>2]=m;g[a+268>>2]=l;g[a+272>>2]=k;k=ea(g[b+372>>2]);l=ea(g[b+376>>2]);m=ea(g[b+380>>2]);n=ea(g[b+384>>2]);g[a+372>>2]=k;g[a+376>>2]=l;g[a+380>>2]=m;g[a+384>>2]=n;n=ea(g[b+388>>2]);m=ea(g[b+392>>2]);l=ea(g[b+396>>2]);k=ea(g[b+400>>2]);g[a+388>>2]=n;g[a+392>>2]=m;g[a+396>>2]=l;g[a+400>>2]=k;k=ea(g[b+404>>2]);l=ea(g[b+408>>2]);m=ea(g[b+412>>2]);n=ea(g[b+416>>2]);g[a+404>>2]=k;g[a+408>>2]=l;g[a+412>>2]=m;g[a+416>>2]=n}if(O_d(f)|0){n=ea(g[b+276>>2]);m=ea(g[b+280>>2]);l=ea(g[b+284>>2]);k=ea(g[b+288>>2]);g[a+276>>2]=n;g[a+280>>2]=m;g[a+284>>2]=l;g[a+288>>2]=k;k=ea(g[b+292>>2]);l=ea(g[b+296>>2]);m=ea(g[b+300>>2]);n=ea(g[b+304>>2]);g[a+292>>2]=k;g[a+296>>2]=l;g[a+300>>2]=m;g[a+304>>2]=n;n=ea(g[b+308>>2]);m=ea(g[b+312>>2]);l=ea(g[b+316>>2]);k=ea(g[b+320>>2]);g[a+308>>2]=n;g[a+312>>2]=m;g[a+316>>2]=l;g[a+320>>2]=k}if(!(P_d(f)|0)){i=h;return}k=ea(g[b+324>>2]);l=ea(g[b+328>>2]);m=ea(g[b+332>>2]);n=ea(g[b+336>>2]);g[a+324>>2]=k;g[a+328>>2]=l;g[a+332>>2]=m;g[a+336>>2]=n;n=ea(g[b+340>>2]);m=ea(g[b+344>>2]);l=ea(g[b+348>>2]);k=ea(g[b+352>>2]);g[a+340>>2]=n;g[a+344>>2]=m;g[a+348>>2]=l;g[a+352>>2]=k;k=ea(g[b+356>>2]);l=ea(g[b+360>>2]);m=ea(g[b+364>>2]);n=ea(g[b+368>>2]);g[a+356>>2]=k;g[a+360>>2]=l;g[a+364>>2]=m;g[a+368>>2]=n;i=h;return}function eZd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=0,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=0,Ta=0,Ua=0,Va=Im,Wa=0;l=i;m=a+4|0;n=a+8|0;o=a+12|0;p=a+16|0;q=a+20|0;r=a+24|0;s=a+28|0;t=a+32|0;u=a+84|0;v=a+88|0;w=a+92|0;x=a+96|0;y=a+100|0;z=a+104|0;A=a+108|0;B=a+112|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m+24>>2]=0;c[m+28>>2]=0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;c[u+24>>2]=0;c[u+28>>2]=0;g[a+116>>2]=ea(1.0);g[a+120>>2]=ea(1.0);g[a+124>>2]=ea(1.0);g[a+128>>2]=ea(1.0);C=a+132|0;D=a+136|0;E=a+140|0;F=a+144|0;G=a+148|0;H=a+152|0;I=a+156|0;J=a+160|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[C+16>>2]=0;c[C+20>>2]=0;c[C+24>>2]=0;c[C+28>>2]=0;g[a+164>>2]=ea(1.0);g[a+168>>2]=ea(1.0);g[a+172>>2]=ea(1.0);g[a+176>>2]=ea(1.0);K=a+180|0;L=a+184|0;M=a+188|0;N=a+192|0;O=a+196|0;P=a+200|0;Q=a+204|0;R=a+208|0;c[K+0>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;c[K+12>>2]=0;c[K+16>>2]=0;c[K+20>>2]=0;c[K+24>>2]=0;c[K+28>>2]=0;g[a+212>>2]=ea(1.0);g[a+216>>2]=ea(1.0);g[a+220>>2]=ea(1.0);g[a+224>>2]=ea(1.0);S=a+228|0;U=a+232|0;V=a+236|0;W=a+240|0;X=a+244|0;Y=a+248|0;Z=a+252|0;_=a+256|0;c[S+0>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;c[S+12>>2]=0;c[S+16>>2]=0;c[S+20>>2]=0;c[S+24>>2]=0;c[S+28>>2]=0;g[a+260>>2]=ea(1.0);g[a+264>>2]=ea(1.0);g[a+268>>2]=ea(1.0);g[a+272>>2]=ea(1.0);$=a+276|0;aa=a+280|0;ba=a+284|0;ca=a+288|0;da=a+292|0;fa=a+296|0;ga=a+300|0;ha=a+304|0;c[$+0>>2]=0;c[$+4>>2]=0;c[$+8>>2]=0;c[$+12>>2]=0;c[$+16>>2]=0;c[$+20>>2]=0;c[$+24>>2]=0;c[$+28>>2]=0;g[a+308>>2]=ea(1.0);g[a+312>>2]=ea(1.0);g[a+316>>2]=ea(1.0);g[a+320>>2]=ea(1.0);ia=a+324|0;ja=a+328|0;ka=a+332|0;la=a+336|0;ma=a+340|0;na=a+344|0;oa=a+348|0;pa=a+352|0;c[ia+0>>2]=0;c[ia+4>>2]=0;c[ia+8>>2]=0;c[ia+12>>2]=0;c[ia+16>>2]=0;c[ia+20>>2]=0;c[ia+24>>2]=0;c[ia+28>>2]=0;g[a+356>>2]=ea(1.0);g[a+360>>2]=ea(1.0);g[a+364>>2]=ea(1.0);g[a+368>>2]=ea(1.0);qa=a+372|0;ra=a+376|0;sa=a+380|0;ta=a+384|0;ua=a+388|0;va=a+392|0;wa=a+396|0;xa=a+400|0;c[qa+0>>2]=0;c[qa+4>>2]=0;c[qa+8>>2]=0;c[qa+12>>2]=0;c[qa+16>>2]=0;c[qa+20>>2]=0;c[qa+24>>2]=0;c[qa+28>>2]=0;g[a+404>>2]=ea(1.0);g[a+408>>2]=ea(1.0);g[a+412>>2]=ea(1.0);g[a+416>>2]=ea(1.0);ya=a+420|0;g[ya>>2]=ea(0.0);a:do if(!e)za=ea(0.0);else{if(f){a=0;Aa=ea(0.0);while(1){Ba=ea(g[d+(a<<2)>>2]);Ca=ea(Aa+Ba);Da=c[b+(a<<2)>>2]|0;Ea=ea(Ba*ea(g[Da+4>>2]));Fa=ea(Ba*ea(g[Da+8>>2]));Ga=ea(Ba*ea(g[Da+12>>2]));Ha=ea(Ba*ea(g[Da+16>>2]));Ia=ea(Ea+ea(g[m>>2]));Ea=ea(Fa+ea(g[n>>2]));Fa=ea(Ga+ea(g[o>>2]));Ga=ea(Ha+ea(g[p>>2]));g[m>>2]=Ia;g[n>>2]=Ea;g[o>>2]=Fa;g[p>>2]=Ga;Ga=ea(Ba*ea(g[Da+20>>2]));Fa=ea(Ba*ea(g[Da+24>>2]));Ea=ea(Ba*ea(g[Da+28>>2]));Ia=ea(Ba*ea(g[Da+32>>2]));Ha=ea(Ga+ea(g[q>>2]));Ga=ea(Fa+ea(g[r>>2]));Fa=ea(Ea+ea(g[s>>2]));Ea=ea(Ia+ea(g[t>>2]));g[q>>2]=Ha;g[r>>2]=Ga;g[s>>2]=Fa;g[t>>2]=Ea;Ea=ea(Ba*ea(g[Da+420>>2]));g[ya>>2]=ea(ea(g[ya>>2])+Ea);Da=b+(a<<2)|0;Ja=c[Da>>2]|0;Ea=ea(Ba*ea(g[Ja+84>>2]));Fa=ea(Ba*ea(g[Ja+88>>2]));Ga=ea(Ba*ea(g[Ja+92>>2]));Ha=ea(Ba*ea(g[Ja+96>>2]));Ia=ea(Ea+ea(g[u>>2]));Ea=ea(Fa+ea(g[v>>2]));Fa=ea(Ga+ea(g[w>>2]));Ga=ea(Ha+ea(g[x>>2]));g[u>>2]=Ia;g[v>>2]=Ea;g[w>>2]=Fa;g[x>>2]=Ga;Ga=ea(g[Ja+100>>2]);Fa=ea(Ba*Ga);Ea=ea(g[Ja+104>>2]);Ia=ea(Ba*Ea);Ha=ea(g[Ja+108>>2]);Ka=ea(Ba*Ha);La=ea(g[Ja+112>>2]);Ma=ea(Ba*La);Na=ea(g[y>>2]);Oa=ea(Na*Ga);Ga=ea(g[z>>2]);Pa=ea(Ga*Ea);Ea=ea(g[A>>2]);Qa=ea(Ea*Ha);Ha=ea(g[B>>2]);Ra=ea(ea(Oa+Pa)+ea(Qa+ea(Ha*La)));Sa=(g[k>>2]=Fa,c[k>>2]|0);Ta=(g[k>>2]=Ra,c[k>>2]|0)&-2147483648;Ra=(c[k>>2]=Ta^Sa,ea(g[k>>2]));Fa=(c[k>>2]=Ta^(g[k>>2]=Ia,c[k>>2]|0),ea(g[k>>2]));Ia=(c[k>>2]=Ta^(g[k>>2]=Ka,c[k>>2]|0),ea(g[k>>2]));Ka=ea(Ga+Fa);Fa=ea(Ea+Ia);Ia=ea(Ha+(c[k>>2]=Ta^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2])));g[y>>2]=ea(Na+Ra);g[z>>2]=Ka;g[A>>2]=Fa;g[B>>2]=Ia;Ia=ea(Ba*ea(g[Ja+132>>2]));Fa=ea(Ba*ea(g[Ja+136>>2]));Ka=ea(Ba*ea(g[Ja+140>>2]));Ra=ea(Ba*ea(g[Ja+144>>2]));Na=ea(Ia+ea(g[C>>2]));Ia=ea(Fa+ea(g[D>>2]));Fa=ea(Ka+ea(g[E>>2]));Ka=ea(Ra+ea(g[F>>2]));g[C>>2]=Na;g[D>>2]=Ia;g[E>>2]=Fa;g[F>>2]=Ka;Ka=ea(g[Ja+148>>2]);Fa=ea(Ba*Ka);Ia=ea(g[Ja+152>>2]);Na=ea(Ba*Ia);Ra=ea(g[Ja+156>>2]);Ma=ea(Ba*Ra);Ha=ea(g[Ja+160>>2]);Ea=ea(Ba*Ha);Ga=ea(g[G>>2]);La=ea(Ga*Ka);Ka=ea(g[H>>2]);Qa=ea(Ka*Ia);Ia=ea(g[I>>2]);Pa=ea(Ia*Ra);Ra=ea(g[J>>2]);Oa=ea(ea(La+Qa)+ea(Pa+ea(Ra*Ha)));Ja=(g[k>>2]=Fa,c[k>>2]|0);Ta=(g[k>>2]=Oa,c[k>>2]|0)&-2147483648;Oa=(c[k>>2]=Ta^Ja,ea(g[k>>2]));Fa=(c[k>>2]=Ta^(g[k>>2]=Na,c[k>>2]|0),ea(g[k>>2]));Na=(c[k>>2]=Ta^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2]));Ma=ea(Ka+Fa);Fa=ea(Ia+Na);Na=ea(Ra+(c[k>>2]=Ta^(g[k>>2]=Ea,c[k>>2]|0),ea(g[k>>2])));g[G>>2]=ea(Ga+Oa);g[H>>2]=Ma;g[I>>2]=Fa;g[J>>2]=Na;Ta=c[Da>>2]|0;Na=ea(Ba*ea(g[Ta+180>>2]));Fa=ea(Ba*ea(g[Ta+184>>2]));Ma=ea(Ba*ea(g[Ta+188>>2]));Oa=ea(Ba*ea(g[Ta+192>>2]));Ga=ea(Na+ea(g[K>>2]));Na=ea(Fa+ea(g[L>>2]));Fa=ea(Ma+ea(g[M>>2]));Ma=ea(Oa+ea(g[N>>2]));g[K>>2]=Ga;g[L>>2]=Na;g[M>>2]=Fa;g[N>>2]=Ma;Ma=ea(g[Ta+196>>2]);Fa=ea(Ba*Ma);Na=ea(g[Ta+200>>2]);Ga=ea(Ba*Na);Oa=ea(g[Ta+204>>2]);Ea=ea(Ba*Oa);Ra=ea(g[Ta+208>>2]);Ia=ea(Ba*Ra);Ka=ea(g[O>>2]);Ha=ea(Ka*Ma);Ma=ea(g[P>>2]);Pa=ea(Ma*Na);Na=ea(g[Q>>2]);Qa=ea(Na*Oa);Oa=ea(g[R>>2]);La=ea(ea(Ha+Pa)+ea(Qa+ea(Oa*Ra)));Ta=(g[k>>2]=Fa,c[k>>2]|0);Da=(g[k>>2]=La,c[k>>2]|0)&-2147483648;La=(c[k>>2]=Da^Ta,ea(g[k>>2]));Fa=(c[k>>2]=Da^(g[k>>2]=Ga,c[k>>2]|0),ea(g[k>>2]));Ga=(c[k>>2]=Da^(g[k>>2]=Ea,c[k>>2]|0),ea(g[k>>2]));Ea=ea(Ma+Fa);Fa=ea(Na+Ga);Ga=ea(Oa+(c[k>>2]=Da^(g[k>>2]=Ia,c[k>>2]|0),ea(g[k>>2])));g[O>>2]=ea(Ka+La);g[P>>2]=Ea;g[Q>>2]=Fa;g[R>>2]=Ga;if(h){if(c[j>>2]&1){Da=c[b+(a<<2)>>2]|0;Ga=ea(Ba*ea(g[Da+228>>2]));Fa=ea(Ba*ea(g[Da+232>>2]));Ea=ea(Ba*ea(g[Da+236>>2]));La=ea(Ba*ea(g[Da+240>>2]));Ka=ea(Ga+ea(g[S>>2]));Ga=ea(Fa+ea(g[U>>2]));Fa=ea(Ea+ea(g[V>>2]));Ea=ea(La+ea(g[W>>2]));g[S>>2]=Ka;g[U>>2]=Ga;g[V>>2]=Fa;g[W>>2]=Ea;Ea=ea(g[Da+244>>2]);Fa=ea(Ba*Ea);Ga=ea(g[Da+248>>2]);Ka=ea(Ba*Ga);La=ea(g[Da+252>>2]);Ia=ea(Ba*La);Oa=ea(g[Da+256>>2]);Na=ea(Ba*Oa);Ma=ea(g[X>>2]);Ra=ea(Ma*Ea);Ea=ea(g[Y>>2]);Qa=ea(Ea*Ga);Ga=ea(g[Z>>2]);Pa=ea(Ga*La);La=ea(g[_>>2]);Ha=ea(ea(Ra+Qa)+ea(Pa+ea(La*Oa)));Ta=(g[k>>2]=Fa,c[k>>2]|0);Ja=(g[k>>2]=Ha,c[k>>2]|0)&-2147483648;Ha=(c[k>>2]=Ja^Ta,ea(g[k>>2]));Fa=(c[k>>2]=Ja^(g[k>>2]=Ka,c[k>>2]|0),ea(g[k>>2]));Ka=(c[k>>2]=Ja^(g[k>>2]=Ia,c[k>>2]|0),ea(g[k>>2]));Ia=ea(Ea+Fa);Fa=ea(Ga+Ka);Ka=ea(La+(c[k>>2]=Ja^(g[k>>2]=Na,c[k>>2]|0),ea(g[k>>2])));g[X>>2]=ea(Ma+Ha);g[Y>>2]=Ia;g[Z>>2]=Fa;g[_>>2]=Ka;Ka=ea(Ba*ea(g[Da+372>>2]));Fa=ea(Ba*ea(g[Da+376>>2]));Ia=ea(Ba*ea(g[Da+380>>2]));Ha=ea(Ba*ea(g[Da+384>>2]));Ma=ea(Ka+ea(g[qa>>2]));Ka=ea(Fa+ea(g[ra>>2]));Fa=ea(Ia+ea(g[sa>>2]));Ia=ea(Ha+ea(g[ta>>2]));g[qa>>2]=Ma;g[ra>>2]=Ka;g[sa>>2]=Fa;g[ta>>2]=Ia;Ia=ea(g[Da+388>>2]);Fa=ea(Ba*Ia);Ka=ea(g[Da+392>>2]);Ma=ea(Ba*Ka);Ha=ea(g[Da+396>>2]);Na=ea(Ba*Ha);La=ea(g[Da+400>>2]);Ga=ea(Ba*La);Ea=ea(g[ua>>2]);Oa=ea(Ea*Ia);Ia=ea(g[va>>2]);Pa=ea(Ia*Ka);Ka=ea(g[wa>>2]);Qa=ea(Ka*Ha);Ha=ea(g[xa>>2]);Ra=ea(ea(Oa+Pa)+ea(Qa+ea(Ha*La)));Da=(g[k>>2]=Fa,c[k>>2]|0);Ja=(g[k>>2]=Ra,c[k>>2]|0)&-2147483648;Ra=(c[k>>2]=Ja^Da,ea(g[k>>2]));Fa=(c[k>>2]=Ja^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2]));Ma=(c[k>>2]=Ja^(g[k>>2]=Na,c[k>>2]|0),ea(g[k>>2]));Na=ea(Ia+Fa);Fa=ea(Ka+Ma);Ma=ea(Ha+(c[k>>2]=Ja^(g[k>>2]=Ga,c[k>>2]|0),ea(g[k>>2])));g[ua>>2]=ea(Ea+Ra);g[va>>2]=Na;g[wa>>2]=Fa;g[xa>>2]=Ma}if(O_d(j)|0){Ja=c[b+(a<<2)>>2]|0;Ma=ea(Ba*ea(g[Ja+276>>2]));Fa=ea(Ba*ea(g[Ja+280>>2]));Na=ea(Ba*ea(g[Ja+284>>2]));Ra=ea(Ba*ea(g[Ja+288>>2]));Ea=ea(Ma+ea(g[$>>2]));Ma=ea(Fa+ea(g[aa>>2]));Fa=ea(Na+ea(g[ba>>2]));Na=ea(Ra+ea(g[ca>>2]));g[$>>2]=Ea;g[aa>>2]=Ma;g[ba>>2]=Fa;g[ca>>2]=Na;Na=ea(g[Ja+292>>2]);Fa=ea(Ba*Na);Ma=ea(g[Ja+296>>2]);Ea=ea(Ba*Ma);Ra=ea(g[Ja+300>>2]);Ga=ea(Ba*Ra);Ha=ea(g[Ja+304>>2]);Ka=ea(Ba*Ha);Ia=ea(g[da>>2]);La=ea(Ia*Na);Na=ea(g[fa>>2]);Qa=ea(Na*Ma);Ma=ea(g[ga>>2]);Pa=ea(Ma*Ra);Ra=ea(g[ha>>2]);Oa=ea(ea(La+Qa)+ea(Pa+ea(Ra*Ha)));Ja=(g[k>>2]=Fa,c[k>>2]|0);Da=(g[k>>2]=Oa,c[k>>2]|0)&-2147483648;Oa=(c[k>>2]=Da^Ja,ea(g[k>>2]));Fa=(c[k>>2]=Da^(g[k>>2]=Ea,c[k>>2]|0),ea(g[k>>2]));Ea=(c[k>>2]=Da^(g[k>>2]=Ga,c[k>>2]|0),ea(g[k>>2]));Ga=ea(Na+Fa);Fa=ea(Ma+Ea);Ea=ea(Ra+(c[k>>2]=Da^(g[k>>2]=Ka,c[k>>2]|0),ea(g[k>>2])));g[da>>2]=ea(Ia+Oa);g[fa>>2]=Ga;g[ga>>2]=Fa;g[ha>>2]=Ea}if(P_d(j)|0){Da=c[b+(a<<2)>>2]|0;Ea=ea(Ba*ea(g[Da+324>>2]));Fa=ea(Ba*ea(g[Da+328>>2]));Ga=ea(Ba*ea(g[Da+332>>2]));Oa=ea(Ba*ea(g[Da+336>>2]));Ia=ea(Ea+ea(g[ia>>2]));Ea=ea(Fa+ea(g[ja>>2]));Fa=ea(Ga+ea(g[ka>>2]));Ga=ea(Oa+ea(g[la>>2]));g[ia>>2]=Ia;g[ja>>2]=Ea;g[ka>>2]=Fa;g[la>>2]=Ga;Ga=ea(g[Da+340>>2]);Fa=ea(Ba*Ga);Ea=ea(g[Da+344>>2]);Ia=ea(Ba*Ea);Oa=ea(g[Da+348>>2]);Ka=ea(Ba*Oa);Ra=ea(g[Da+352>>2]);Ma=ea(Ba*Ra);Ba=ea(g[ma>>2]);Na=ea(Ba*Ga);Ga=ea(g[na>>2]);Ha=ea(Ga*Ea);Ea=ea(g[oa>>2]);Pa=ea(Ea*Oa);Oa=ea(g[pa>>2]);Qa=ea(ea(Na+Ha)+ea(Pa+ea(Oa*Ra)));Da=(g[k>>2]=Fa,c[k>>2]|0);Ja=(g[k>>2]=Qa,c[k>>2]|0)&-2147483648;Qa=(c[k>>2]=Ja^Da,ea(g[k>>2]));Fa=(c[k>>2]=Ja^(g[k>>2]=Ia,c[k>>2]|0),ea(g[k>>2]));Ia=(c[k>>2]=Ja^(g[k>>2]=Ka,c[k>>2]|0),ea(g[k>>2]));Ka=ea(Ga+Fa);Fa=ea(Ea+Ia);Ia=ea(Oa+(c[k>>2]=Ja^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2])));g[ma>>2]=ea(Ba+Qa);g[na>>2]=Ka;g[oa>>2]=Fa;g[pa>>2]=Ia}}a=a+1|0;if((a|0)==(e|0)){za=Ca;break a}else Aa=Ca}}else{Ua=0;Va=ea(0.0)}while(1){Aa=ea(g[d+(Ua<<2)>>2]);Ca=ea(Va+Aa);do if(h){if((c[j>>2]&1|0)!=0?(a=c[b+(Ua<<2)>>2]|0,Ia=ea(Aa*ea(g[a+4>>2])),Fa=ea(Aa*ea(g[a+8>>2])),Ka=ea(Aa*ea(g[a+12>>2])),Qa=ea(Aa*ea(g[a+16>>2])),Ba=ea(Ia+ea(g[m>>2])),Ia=ea(Fa+ea(g[n>>2])),Fa=ea(Ka+ea(g[o>>2])),Ka=ea(Qa+ea(g[p>>2])),g[m>>2]=Ba,g[n>>2]=Ia,g[o>>2]=Fa,g[p>>2]=Ka,Ka=ea(Aa*ea(g[a+20>>2])),Fa=ea(Aa*ea(g[a+24>>2])),Ia=ea(Aa*ea(g[a+28>>2])),Ba=ea(Aa*ea(g[a+32>>2])),Qa=ea(Ka+ea(g[q>>2])),Ka=ea(Fa+ea(g[r>>2])),Fa=ea(Ia+ea(g[s>>2])),Ia=ea(Ba+ea(g[t>>2])),g[q>>2]=Qa,g[r>>2]=Ka,g[s>>2]=Fa,g[t>>2]=Ia,Ia=ea(Aa*ea(g[a+420>>2])),g[ya>>2]=ea(ea(g[ya>>2])+Ia),!h):0)break;if(c[j>>2]&1){a=c[b+(Ua<<2)>>2]|0;Ia=ea(Aa*ea(g[a+228>>2]));Fa=ea(Aa*ea(g[a+232>>2]));Ka=ea(Aa*ea(g[a+236>>2]));Qa=ea(Aa*ea(g[a+240>>2]));Ba=ea(Ia+ea(g[S>>2]));Ia=ea(Fa+ea(g[U>>2]));Fa=ea(Ka+ea(g[V>>2]));Ka=ea(Qa+ea(g[W>>2]));g[S>>2]=Ba;g[U>>2]=Ia;g[V>>2]=Fa;g[W>>2]=Ka;Ka=ea(g[a+244>>2]);Fa=ea(Aa*Ka);Ia=ea(g[a+248>>2]);Ba=ea(Aa*Ia);Qa=ea(g[a+252>>2]);Ma=ea(Aa*Qa);Oa=ea(g[a+256>>2]);Ea=ea(Aa*Oa);Ga=ea(g[X>>2]);Ra=ea(Ga*Ka);Ka=ea(g[Y>>2]);Pa=ea(Ka*Ia);Ia=ea(g[Z>>2]);Ha=ea(Ia*Qa);Qa=ea(g[_>>2]);Na=ea(ea(Ra+Pa)+ea(Ha+ea(Qa*Oa)));Ja=(g[k>>2]=Fa,c[k>>2]|0);Da=(g[k>>2]=Na,c[k>>2]|0)&-2147483648;Na=(c[k>>2]=Da^Ja,ea(g[k>>2]));Fa=(c[k>>2]=Da^(g[k>>2]=Ba,c[k>>2]|0),ea(g[k>>2]));Ba=(c[k>>2]=Da^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2]));Ma=ea(Ka+Fa);Fa=ea(Ia+Ba);Ba=ea(Qa+(c[k>>2]=Da^(g[k>>2]=Ea,c[k>>2]|0),ea(g[k>>2])));g[X>>2]=ea(Ga+Na);g[Y>>2]=Ma;g[Z>>2]=Fa;g[_>>2]=Ba;Ba=ea(Aa*ea(g[a+372>>2]));Fa=ea(Aa*ea(g[a+376>>2]));Ma=ea(Aa*ea(g[a+380>>2]));Na=ea(Aa*ea(g[a+384>>2]));Ga=ea(Ba+ea(g[qa>>2]));Ba=ea(Fa+ea(g[ra>>2]));Fa=ea(Ma+ea(g[sa>>2]));Ma=ea(Na+ea(g[ta>>2]));g[qa>>2]=Ga;g[ra>>2]=Ba;g[sa>>2]=Fa;g[ta>>2]=Ma;Ma=ea(g[a+388>>2]);Fa=ea(Aa*Ma);Ba=ea(g[a+392>>2]);Ga=ea(Aa*Ba);Na=ea(g[a+396>>2]);Ea=ea(Aa*Na);Qa=ea(g[a+400>>2]);Ia=ea(Aa*Qa);Ka=ea(g[ua>>2]);Oa=ea(Ka*Ma);Ma=ea(g[va>>2]);Ha=ea(Ma*Ba);Ba=ea(g[wa>>2]);Pa=ea(Ba*Na);Na=ea(g[xa>>2]);Ra=ea(ea(Oa+Ha)+ea(Pa+ea(Na*Qa)));a=(g[k>>2]=Fa,c[k>>2]|0);Da=(g[k>>2]=Ra,c[k>>2]|0)&-2147483648;Ra=(c[k>>2]=Da^a,ea(g[k>>2]));Fa=(c[k>>2]=Da^(g[k>>2]=Ga,c[k>>2]|0),ea(g[k>>2]));Ga=(c[k>>2]=Da^(g[k>>2]=Ea,c[k>>2]|0),ea(g[k>>2]));Ea=ea(Ma+Fa);Fa=ea(Ba+Ga);Ga=ea(Na+(c[k>>2]=Da^(g[k>>2]=Ia,c[k>>2]|0),ea(g[k>>2])));g[ua>>2]=ea(Ka+Ra);g[va>>2]=Ea;g[wa>>2]=Fa;g[xa>>2]=Ga}if(O_d(j)|0){Da=c[b+(Ua<<2)>>2]|0;Ga=ea(Aa*ea(g[Da+276>>2]));Fa=ea(Aa*ea(g[Da+280>>2]));Ea=ea(Aa*ea(g[Da+284>>2]));Ra=ea(Aa*ea(g[Da+288>>2]));Ka=ea(Ga+ea(g[$>>2]));Ga=ea(Fa+ea(g[aa>>2]));Fa=ea(Ea+ea(g[ba>>2]));Ea=ea(Ra+ea(g[ca>>2]));g[$>>2]=Ka;g[aa>>2]=Ga;g[ba>>2]=Fa;g[ca>>2]=Ea;Ea=ea(g[Da+292>>2]);Fa=ea(Aa*Ea);Ga=ea(g[Da+296>>2]);Ka=ea(Aa*Ga);Ra=ea(g[Da+300>>2]);Ia=ea(Aa*Ra);Na=ea(g[Da+304>>2]);Ba=ea(Aa*Na);Ma=ea(g[da>>2]);Qa=ea(Ma*Ea);Ea=ea(g[fa>>2]);Pa=ea(Ea*Ga);Ga=ea(g[ga>>2]);Ha=ea(Ga*Ra);Ra=ea(g[ha>>2]);Oa=ea(ea(Qa+Pa)+ea(Ha+ea(Ra*Na)));Da=(g[k>>2]=Fa,c[k>>2]|0);a=(g[k>>2]=Oa,c[k>>2]|0)&-2147483648;Oa=(c[k>>2]=a^Da,ea(g[k>>2]));Fa=(c[k>>2]=a^(g[k>>2]=Ka,c[k>>2]|0),ea(g[k>>2]));Ka=(c[k>>2]=a^(g[k>>2]=Ia,c[k>>2]|0),ea(g[k>>2]));Ia=ea(Ea+Fa);Fa=ea(Ga+Ka);Ka=ea(Ra+(c[k>>2]=a^(g[k>>2]=Ba,c[k>>2]|0),ea(g[k>>2])));g[da>>2]=ea(Ma+Oa);g[fa>>2]=Ia;g[ga>>2]=Fa;g[ha>>2]=Ka}if(P_d(j)|0){a=c[b+(Ua<<2)>>2]|0;Ka=ea(Aa*ea(g[a+324>>2]));Fa=ea(Aa*ea(g[a+328>>2]));Ia=ea(Aa*ea(g[a+332>>2]));Oa=ea(Aa*ea(g[a+336>>2]));Ma=ea(Ka+ea(g[ia>>2]));Ka=ea(Fa+ea(g[ja>>2]));Fa=ea(Ia+ea(g[ka>>2]));Ia=ea(Oa+ea(g[la>>2]));g[ia>>2]=Ma;g[ja>>2]=Ka;g[ka>>2]=Fa;g[la>>2]=Ia;Ia=ea(g[a+340>>2]);Fa=ea(Aa*Ia);Ka=ea(g[a+344>>2]);Ma=ea(Aa*Ka);Oa=ea(g[a+348>>2]);Ba=ea(Aa*Oa);Ra=ea(g[a+352>>2]);Ga=ea(Aa*Ra);Ea=ea(g[ma>>2]);Na=ea(Ea*Ia);Ia=ea(g[na>>2]);Ha=ea(Ia*Ka);Ka=ea(g[oa>>2]);Pa=ea(Ka*Oa);Oa=ea(g[pa>>2]);Qa=ea(ea(Na+Ha)+ea(Pa+ea(Oa*Ra)));a=(g[k>>2]=Fa,c[k>>2]|0);Da=(g[k>>2]=Qa,c[k>>2]|0)&-2147483648;Qa=(c[k>>2]=Da^a,ea(g[k>>2]));Fa=(c[k>>2]=Da^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2]));Ma=(c[k>>2]=Da^(g[k>>2]=Ba,c[k>>2]|0),ea(g[k>>2]));Ba=ea(Ia+Fa);Fa=ea(Ka+Ma);Ma=ea(Oa+(c[k>>2]=Da^(g[k>>2]=Ga,c[k>>2]|0),ea(g[k>>2])));g[ma>>2]=ea(Ea+Qa);g[na>>2]=Ba;g[oa>>2]=Fa;g[pa>>2]=Ma}}while(0);Ua=Ua+1|0;if((Ua|0)==(e|0)){za=Ca;break}else Va=Ca}}while(0);if(f){if(za>ea(0.0))Wa=25}else if(h?(c[j>>2]&1|0)!=0&za>ea(0.0):0)Wa=25;if((Wa|0)==25)g[ya>>2]=ea(ea(g[ya>>2])/za);Va=ea(VDi(ea(1.0),ea(UDi(ea(0.0),ea(ea(1.0)-za)))));if(f){za=ea(ea(g[y>>2])+ea(0.0));Aa=ea(ea(g[z>>2])+ea(0.0));Ma=ea(ea(g[A>>2])+ea(0.0));Fa=ea(Va+ea(g[B>>2]));Ba=ea(ea(1.0)/ea(T(ea(ea(ea(za*za)+ea(Aa*Aa))+ea(ea(Ma*Ma)+ea(Fa*Fa))))));Qa=ea(Aa*Ba);Aa=ea(Ma*Ba);Ma=ea(Fa*Ba);g[y>>2]=ea(za*Ba);g[z>>2]=Qa;g[A>>2]=Aa;g[B>>2]=Ma;Ma=ea(ea(g[G>>2])+ea(0.0));Aa=ea(ea(g[H>>2])+ea(0.0));Qa=ea(ea(g[I>>2])+ea(0.0));Ba=ea(Va+ea(g[J>>2]));za=ea(ea(1.0)/ea(T(ea(ea(ea(Ma*Ma)+ea(Aa*Aa))+ea(ea(Qa*Qa)+ea(Ba*Ba))))));Fa=ea(Aa*za);Aa=ea(Qa*za);Qa=ea(Ba*za);g[G>>2]=ea(Ma*za);g[H>>2]=Fa;g[I>>2]=Aa;g[J>>2]=Qa;Qa=ea(ea(g[O>>2])+ea(0.0));Aa=ea(ea(g[P>>2])+ea(0.0));Fa=ea(ea(g[Q>>2])+ea(0.0));za=ea(Va+ea(g[R>>2]));Ma=ea(ea(1.0)/ea(T(ea(ea(ea(Qa*Qa)+ea(Aa*Aa))+ea(ea(Fa*Fa)+ea(za*za))))));Ba=ea(Aa*Ma);Aa=ea(Fa*Ma);Fa=ea(za*Ma);g[O>>2]=ea(Qa*Ma);g[P>>2]=Ba;g[Q>>2]=Aa;g[R>>2]=Fa}if(!h){i=l;return}if(c[j>>2]&1){Fa=ea(ea(g[X>>2])+ea(0.0));Aa=ea(ea(g[Y>>2])+ea(0.0));Ba=ea(ea(g[Z>>2])+ea(0.0));Ma=ea(Va+ea(g[_>>2]));Qa=ea(ea(1.0)/ea(T(ea(ea(ea(Fa*Fa)+ea(Aa*Aa))+ea(ea(Ba*Ba)+ea(Ma*Ma))))));za=ea(Aa*Qa);Aa=ea(Ba*Qa);Ba=ea(Ma*Qa);g[X>>2]=ea(Fa*Qa);g[Y>>2]=za;g[Z>>2]=Aa;g[_>>2]=Ba;Ba=ea(ea(g[ua>>2])+ea(0.0));Aa=ea(ea(g[va>>2])+ea(0.0));za=ea(ea(g[wa>>2])+ea(0.0));Qa=ea(Va+ea(g[xa>>2]));Fa=ea(ea(1.0)/ea(T(ea(ea(ea(Ba*Ba)+ea(Aa*Aa))+ea(ea(za*za)+ea(Qa*Qa))))));Ma=ea(Aa*Fa);Aa=ea(za*Fa);za=ea(Qa*Fa);g[ua>>2]=ea(Ba*Fa);g[va>>2]=Ma;g[wa>>2]=Aa;g[xa>>2]=za}if(O_d(j)|0){za=ea(ea(g[da>>2])+ea(0.0));Aa=ea(ea(g[fa>>2])+ea(0.0));Ma=ea(ea(g[ga>>2])+ea(0.0));Fa=ea(Va+ea(g[ha>>2]));Ba=ea(ea(1.0)/ea(T(ea(ea(ea(za*za)+ea(Aa*Aa))+ea(ea(Ma*Ma)+ea(Fa*Fa))))));Qa=ea(Aa*Ba);Aa=ea(Ma*Ba);Ma=ea(Fa*Ba);g[da>>2]=ea(za*Ba);g[fa>>2]=Qa;g[ga>>2]=Aa;g[ha>>2]=Ma}if(!(P_d(j)|0)){i=l;return}Ma=ea(ea(g[ma>>2])+ea(0.0));Aa=ea(ea(g[na>>2])+ea(0.0));Qa=ea(ea(g[oa>>2])+ea(0.0));Ba=ea(Va+ea(g[pa>>2]));Va=ea(ea(1.0)/ea(T(ea(ea(ea(Ma*Ma)+ea(Aa*Aa))+ea(ea(Qa*Qa)+ea(Ba*Ba))))));za=ea(Aa*Va);Aa=ea(Qa*Va);Qa=ea(Ba*Va);g[ma>>2]=ea(Ma*Va);g[na>>2]=za;g[oa>>2]=Aa;g[pa>>2]=Qa;i=l;return}function fZd(a,b,d,e,f,h){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;h=h|0;var j=0,l=0,m=Im,n=Im,o=Im,p=0,q=Im,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=0,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=Im;j=i;if(!(d<ea(1.0))){dZd(a,b,e,f,h);i=j;return}do if(!e)if(f)if(!(c[h>>2]&1))break;else{l=5;break}else{i=j;return}else l=5;while(0);if((l|0)==5){m=ea(g[b+4>>2]);l=a+4|0;n=ea(g[l>>2]);o=ea(m-n);m=ea(g[b+8>>2]);p=a+8|0;q=ea(g[p>>2]);r=ea(m-q);m=ea(g[b+12>>2]);s=a+12|0;t=ea(g[s>>2]);u=ea(m-t);m=ea(g[b+16>>2]);v=a+16|0;w=ea(g[v>>2]);x=ea(q+ea(r*d));r=ea(t+ea(u*d));u=ea(w+ea(ea(m-w)*d));g[l>>2]=ea(n+ea(o*d));g[p>>2]=x;g[s>>2]=r;g[v>>2]=u;u=ea(g[b+20>>2]);v=a+20|0;r=ea(g[v>>2]);x=ea(u-r);u=ea(g[b+24>>2]);s=a+24|0;o=ea(g[s>>2]);n=ea(u-o);u=ea(g[b+28>>2]);p=a+28|0;w=ea(g[p>>2]);m=ea(u-w);u=ea(g[b+32>>2]);l=a+32|0;t=ea(g[l>>2]);q=ea(o+ea(n*d));n=ea(w+ea(m*d));m=ea(t+ea(ea(u-t)*d));g[v>>2]=ea(r+ea(x*d));g[s>>2]=q;g[p>>2]=n;g[l>>2]=m;l=a+420|0;m=ea(g[l>>2]);g[l>>2]=ea(m+ea(ea(ea(g[b+420>>2])-m)*d))}if(e){m=ea(g[b+84>>2]);e=a+84|0;n=ea(g[e>>2]);q=ea(m-n);m=ea(g[b+88>>2]);l=a+88|0;x=ea(g[l>>2]);r=ea(m-x);m=ea(g[b+92>>2]);p=a+92|0;t=ea(g[p>>2]);u=ea(m-t);m=ea(g[b+96>>2]);s=a+96|0;w=ea(g[s>>2]);o=ea(n+ea(q*d));q=ea(x+ea(r*d));r=ea(t+ea(u*d));u=ea(w+ea(ea(m-w)*d));v=a+100|0;w=ea(g[v>>2]);m=ea(g[b+100>>2]);t=ea(w*m);y=a+104|0;x=ea(g[y>>2]);n=ea(g[b+104>>2]);z=ea(x*n);A=a+108|0;B=ea(g[A>>2]);C=ea(g[b+108>>2]);D=ea(B*C);E=a+112|0;F=ea(g[E>>2]);G=ea(g[b+112>>2]);H=ea(ea(t+z)+ea(D+ea(F*G)));I=(g[k>>2]=m,c[k>>2]|0);J=(g[k>>2]=H,c[k>>2]|0)&-2147483648;H=(c[k>>2]=J^I,ea(g[k>>2]));m=(c[k>>2]=J^(g[k>>2]=n,c[k>>2]|0),ea(g[k>>2]));n=(c[k>>2]=J^(g[k>>2]=C,c[k>>2]|0),ea(g[k>>2]));C=ea(w+ea(ea(H-w)*d));w=ea(x+ea(ea(m-x)*d));x=ea(B+ea(ea(n-B)*d));B=ea(F+ea(ea((c[k>>2]=J^(g[k>>2]=G,c[k>>2]|0),ea(g[k>>2]))-F)*d));F=ea(ea(1.0)/ea(T(ea(ea(ea(C*C)+ea(w*w))+ea(ea(x*x)+ea(B*B))))));G=ea(F*C);C=ea(F*w);w=ea(F*x);x=ea(F*B);B=ea(g[b+116>>2]);J=a+116|0;F=ea(g[J>>2]);n=ea(B-F);B=ea(g[b+120>>2]);I=a+120|0;m=ea(g[I>>2]);H=ea(B-m);B=ea(g[b+124>>2]);K=a+124|0;D=ea(g[K>>2]);z=ea(B-D);B=ea(g[b+128>>2]);L=a+128|0;t=ea(g[L>>2]);M=ea(F+ea(n*d));n=ea(m+ea(H*d));H=ea(D+ea(z*d));z=ea(t+ea(ea(B-t)*d));g[e>>2]=o;g[l>>2]=q;g[p>>2]=r;g[s>>2]=u;g[v>>2]=G;g[y>>2]=C;g[A>>2]=w;g[E>>2]=x;g[J>>2]=M;g[I>>2]=n;g[K>>2]=H;g[L>>2]=z;z=ea(g[b+132>>2]);L=a+132|0;H=ea(g[L>>2]);n=ea(z-H);z=ea(g[b+136>>2]);K=a+136|0;M=ea(g[K>>2]);x=ea(z-M);z=ea(g[b+140>>2]);I=a+140|0;w=ea(g[I>>2]);C=ea(z-w);z=ea(g[b+144>>2]);J=a+144|0;G=ea(g[J>>2]);u=ea(H+ea(n*d));n=ea(M+ea(x*d));x=ea(w+ea(C*d));C=ea(G+ea(ea(z-G)*d));E=a+148|0;G=ea(g[E>>2]);z=ea(g[b+148>>2]);w=ea(G*z);A=a+152|0;M=ea(g[A>>2]);H=ea(g[b+152>>2]);r=ea(M*H);y=a+156|0;q=ea(g[y>>2]);o=ea(g[b+156>>2]);t=ea(q*o);v=a+160|0;B=ea(g[v>>2]);D=ea(g[b+160>>2]);m=ea(ea(w+r)+ea(t+ea(B*D)));s=(g[k>>2]=z,c[k>>2]|0);p=(g[k>>2]=m,c[k>>2]|0)&-2147483648;m=(c[k>>2]=p^s,ea(g[k>>2]));z=(c[k>>2]=p^(g[k>>2]=H,c[k>>2]|0),ea(g[k>>2]));H=(c[k>>2]=p^(g[k>>2]=o,c[k>>2]|0),ea(g[k>>2]));o=ea(G+ea(ea(m-G)*d));G=ea(M+ea(ea(z-M)*d));M=ea(q+ea(ea(H-q)*d));q=ea(B+ea(ea((c[k>>2]=p^(g[k>>2]=D,c[k>>2]|0),ea(g[k>>2]))-B)*d));B=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(G*G))+ea(ea(M*M)+ea(q*q))))));D=ea(B*o);o=ea(B*G);G=ea(B*M);M=ea(B*q);q=ea(g[b+164>>2]);p=a+164|0;B=ea(g[p>>2]);H=ea(q-B);q=ea(g[b+168>>2]);s=a+168|0;z=ea(g[s>>2]);m=ea(q-z);q=ea(g[b+172>>2]);l=a+172|0;t=ea(g[l>>2]);r=ea(q-t);q=ea(g[b+176>>2]);e=a+176|0;w=ea(g[e>>2]);F=ea(B+ea(H*d));H=ea(z+ea(m*d));m=ea(t+ea(r*d));r=ea(w+ea(ea(q-w)*d));g[L>>2]=u;g[K>>2]=n;g[I>>2]=x;g[J>>2]=C;g[E>>2]=D;g[A>>2]=o;g[y>>2]=G;g[v>>2]=M;g[p>>2]=F;g[s>>2]=H;g[l>>2]=m;g[e>>2]=r;r=ea(g[b+180>>2]);e=a+180|0;m=ea(g[e>>2]);H=ea(r-m);r=ea(g[b+184>>2]);l=a+184|0;F=ea(g[l>>2]);M=ea(r-F);r=ea(g[b+188>>2]);s=a+188|0;G=ea(g[s>>2]);o=ea(r-G);r=ea(g[b+192>>2]);p=a+192|0;D=ea(g[p>>2]);C=ea(m+ea(H*d));H=ea(F+ea(M*d));M=ea(G+ea(o*d));o=ea(D+ea(ea(r-D)*d));v=a+196|0;D=ea(g[v>>2]);r=ea(g[b+196>>2]);G=ea(D*r);y=a+200|0;F=ea(g[y>>2]);m=ea(g[b+200>>2]);x=ea(F*m);A=a+204|0;n=ea(g[A>>2]);u=ea(g[b+204>>2]);w=ea(n*u);E=a+208|0;q=ea(g[E>>2]);t=ea(g[b+208>>2]);z=ea(ea(G+x)+ea(w+ea(q*t)));J=(g[k>>2]=r,c[k>>2]|0);I=(g[k>>2]=z,c[k>>2]|0)&-2147483648;z=(c[k>>2]=I^J,ea(g[k>>2]));r=(c[k>>2]=I^(g[k>>2]=m,c[k>>2]|0),ea(g[k>>2]));m=(c[k>>2]=I^(g[k>>2]=u,c[k>>2]|0),ea(g[k>>2]));u=ea(D+ea(ea(z-D)*d));D=ea(F+ea(ea(r-F)*d));F=ea(n+ea(ea(m-n)*d));n=ea(q+ea(ea((c[k>>2]=I^(g[k>>2]=t,c[k>>2]|0),ea(g[k>>2]))-q)*d));q=ea(ea(1.0)/ea(T(ea(ea(ea(u*u)+ea(D*D))+ea(ea(F*F)+ea(n*n))))));t=ea(q*u);u=ea(q*D);D=ea(q*F);F=ea(q*n);n=ea(g[b+212>>2]);I=a+212|0;q=ea(g[I>>2]);m=ea(n-q);n=ea(g[b+216>>2]);J=a+216|0;r=ea(g[J>>2]);z=ea(n-r);n=ea(g[b+220>>2]);K=a+220|0;w=ea(g[K>>2]);x=ea(n-w);n=ea(g[b+224>>2]);L=a+224|0;G=ea(g[L>>2]);B=ea(q+ea(m*d));m=ea(r+ea(z*d));z=ea(w+ea(x*d));x=ea(G+ea(ea(n-G)*d));g[e>>2]=C;g[l>>2]=H;g[s>>2]=M;g[p>>2]=o;g[v>>2]=t;g[y>>2]=u;g[A>>2]=D;g[E>>2]=F;g[I>>2]=B;g[J>>2]=m;g[K>>2]=z;g[L>>2]=x}if(!f){i=j;return}if(c[h>>2]&1){x=ea(g[b+228>>2]);f=a+228|0;z=ea(g[f>>2]);m=ea(x-z);x=ea(g[b+232>>2]);L=a+232|0;B=ea(g[L>>2]);F=ea(x-B);x=ea(g[b+236>>2]);K=a+236|0;D=ea(g[K>>2]);u=ea(x-D);x=ea(g[b+240>>2]);J=a+240|0;t=ea(g[J>>2]);o=ea(z+ea(m*d));m=ea(B+ea(F*d));F=ea(D+ea(u*d));u=ea(t+ea(ea(x-t)*d));I=a+244|0;t=ea(g[I>>2]);x=ea(g[b+244>>2]);D=ea(t*x);E=a+248|0;B=ea(g[E>>2]);z=ea(g[b+248>>2]);M=ea(B*z);A=a+252|0;H=ea(g[A>>2]);C=ea(g[b+252>>2]);G=ea(H*C);y=a+256|0;n=ea(g[y>>2]);w=ea(g[b+256>>2]);r=ea(ea(D+M)+ea(G+ea(n*w)));v=(g[k>>2]=x,c[k>>2]|0);p=(g[k>>2]=r,c[k>>2]|0)&-2147483648;r=(c[k>>2]=p^v,ea(g[k>>2]));x=(c[k>>2]=p^(g[k>>2]=z,c[k>>2]|0),ea(g[k>>2]));z=(c[k>>2]=p^(g[k>>2]=C,c[k>>2]|0),ea(g[k>>2]));C=ea(t+ea(ea(r-t)*d));t=ea(B+ea(ea(x-B)*d));B=ea(H+ea(ea(z-H)*d));H=ea(n+ea(ea((c[k>>2]=p^(g[k>>2]=w,c[k>>2]|0),ea(g[k>>2]))-n)*d));n=ea(ea(1.0)/ea(T(ea(ea(ea(C*C)+ea(t*t))+ea(ea(B*B)+ea(H*H))))));w=ea(n*C);C=ea(n*t);t=ea(n*B);B=ea(n*H);H=ea(g[b+260>>2]);p=a+260|0;n=ea(g[p>>2]);z=ea(H-n);H=ea(g[b+264>>2]);v=a+264|0;x=ea(g[v>>2]);r=ea(H-x);H=ea(g[b+268>>2]);s=a+268|0;G=ea(g[s>>2]);M=ea(H-G);H=ea(g[b+272>>2]);l=a+272|0;D=ea(g[l>>2]);q=ea(n+ea(z*d));z=ea(x+ea(r*d));r=ea(G+ea(M*d));M=ea(D+ea(ea(H-D)*d));g[f>>2]=o;g[L>>2]=m;g[K>>2]=F;g[J>>2]=u;g[I>>2]=w;g[E>>2]=C;g[A>>2]=t;g[y>>2]=B;g[p>>2]=q;g[v>>2]=z;g[s>>2]=r;g[l>>2]=M;M=ea(g[b+372>>2]);l=a+372|0;r=ea(g[l>>2]);z=ea(M-r);M=ea(g[b+376>>2]);s=a+376|0;q=ea(g[s>>2]);B=ea(M-q);M=ea(g[b+380>>2]);v=a+380|0;t=ea(g[v>>2]);C=ea(M-t);M=ea(g[b+384>>2]);p=a+384|0;w=ea(g[p>>2]);u=ea(r+ea(z*d));z=ea(q+ea(B*d));B=ea(t+ea(C*d));C=ea(w+ea(ea(M-w)*d));y=a+388|0;w=ea(g[y>>2]);M=ea(g[b+388>>2]);t=ea(w*M);A=a+392|0;q=ea(g[A>>2]);r=ea(g[b+392>>2]);F=ea(q*r);E=a+396|0;m=ea(g[E>>2]);o=ea(g[b+396>>2]);D=ea(m*o);I=a+400|0;H=ea(g[I>>2]);G=ea(g[b+400>>2]);x=ea(ea(t+F)+ea(D+ea(H*G)));J=(g[k>>2]=M,c[k>>2]|0);K=(g[k>>2]=x,c[k>>2]|0)&-2147483648;x=(c[k>>2]=K^J,ea(g[k>>2]));M=(c[k>>2]=K^(g[k>>2]=r,c[k>>2]|0),ea(g[k>>2]));r=(c[k>>2]=K^(g[k>>2]=o,c[k>>2]|0),ea(g[k>>2]));o=ea(w+ea(ea(x-w)*d));w=ea(q+ea(ea(M-q)*d));q=ea(m+ea(ea(r-m)*d));m=ea(H+ea(ea((c[k>>2]=K^(g[k>>2]=G,c[k>>2]|0),ea(g[k>>2]))-H)*d));H=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(w*w))+ea(ea(q*q)+ea(m*m))))));G=ea(H*o);o=ea(H*w);w=ea(H*q);q=ea(H*m);m=ea(g[b+404>>2]);K=a+404|0;H=ea(g[K>>2]);r=ea(m-H);m=ea(g[b+408>>2]);J=a+408|0;M=ea(g[J>>2]);x=ea(m-M);m=ea(g[b+412>>2]);L=a+412|0;D=ea(g[L>>2]);F=ea(m-D);m=ea(g[b+416>>2]);f=a+416|0;t=ea(g[f>>2]);n=ea(H+ea(r*d));r=ea(M+ea(x*d));x=ea(D+ea(F*d));F=ea(t+ea(ea(m-t)*d));g[l>>2]=u;g[s>>2]=z;g[v>>2]=B;g[p>>2]=C;g[y>>2]=G;g[A>>2]=o;g[E>>2]=w;g[I>>2]=q;g[K>>2]=n;g[J>>2]=r;g[L>>2]=x;g[f>>2]=F}if(O_d(h)|0){F=ea(g[b+276>>2]);f=a+276|0;x=ea(g[f>>2]);r=ea(F-x);F=ea(g[b+280>>2]);L=a+280|0;n=ea(g[L>>2]);q=ea(F-n);F=ea(g[b+284>>2]);J=a+284|0;w=ea(g[J>>2]);o=ea(F-w);F=ea(g[b+288>>2]);K=a+288|0;G=ea(g[K>>2]);C=ea(x+ea(r*d));r=ea(n+ea(q*d));q=ea(w+ea(o*d));o=ea(G+ea(ea(F-G)*d));I=a+292|0;G=ea(g[I>>2]);F=ea(g[b+292>>2]);w=ea(G*F);E=a+296|0;n=ea(g[E>>2]);x=ea(g[b+296>>2]);B=ea(n*x);A=a+300|0;z=ea(g[A>>2]);u=ea(g[b+300>>2]);t=ea(z*u);y=a+304|0;m=ea(g[y>>2]);D=ea(g[b+304>>2]);M=ea(ea(w+B)+ea(t+ea(m*D)));p=(g[k>>2]=F,c[k>>2]|0);v=(g[k>>2]=M,c[k>>2]|0)&-2147483648;M=(c[k>>2]=v^p,ea(g[k>>2]));F=(c[k>>2]=v^(g[k>>2]=x,c[k>>2]|0),ea(g[k>>2]));x=(c[k>>2]=v^(g[k>>2]=u,c[k>>2]|0),ea(g[k>>2]));u=ea(G+ea(ea(M-G)*d));G=ea(n+ea(ea(F-n)*d));n=ea(z+ea(ea(x-z)*d));z=ea(m+ea(ea((c[k>>2]=v^(g[k>>2]=D,c[k>>2]|0),ea(g[k>>2]))-m)*d));m=ea(ea(1.0)/ea(T(ea(ea(ea(u*u)+ea(G*G))+ea(ea(n*n)+ea(z*z))))));D=ea(m*u);u=ea(m*G);G=ea(m*n);n=ea(m*z);z=ea(g[b+308>>2]);v=a+308|0;m=ea(g[v>>2]);x=ea(z-m);z=ea(g[b+312>>2]);p=a+312|0;F=ea(g[p>>2]);M=ea(z-F);z=ea(g[b+316>>2]);s=a+316|0;t=ea(g[s>>2]);B=ea(z-t);z=ea(g[b+320>>2]);l=a+320|0;w=ea(g[l>>2]);H=ea(m+ea(x*d));x=ea(F+ea(M*d));M=ea(t+ea(B*d));B=ea(w+ea(ea(z-w)*d));g[f>>2]=C;g[L>>2]=r;g[J>>2]=q;g[K>>2]=o;g[I>>2]=D;g[E>>2]=u;g[A>>2]=G;g[y>>2]=n;g[v>>2]=H;g[p>>2]=x;g[s>>2]=M;g[l>>2]=B}if(!(P_d(h)|0)){i=j;return}B=ea(g[b+324>>2]);h=a+324|0;M=ea(g[h>>2]);x=ea(B-M);B=ea(g[b+328>>2]);l=a+328|0;H=ea(g[l>>2]);n=ea(B-H);B=ea(g[b+332>>2]);s=a+332|0;G=ea(g[s>>2]);u=ea(B-G);B=ea(g[b+336>>2]);p=a+336|0;D=ea(g[p>>2]);o=ea(M+ea(x*d));x=ea(H+ea(n*d));n=ea(G+ea(u*d));u=ea(D+ea(ea(B-D)*d));v=a+340|0;D=ea(g[v>>2]);B=ea(g[b+340>>2]);G=ea(D*B);y=a+344|0;H=ea(g[y>>2]);M=ea(g[b+344>>2]);q=ea(H*M);A=a+348|0;r=ea(g[A>>2]);C=ea(g[b+348>>2]);w=ea(r*C);E=a+352|0;z=ea(g[E>>2]);t=ea(g[b+352>>2]);F=ea(ea(G+q)+ea(w+ea(z*t)));I=(g[k>>2]=B,c[k>>2]|0);K=(g[k>>2]=F,c[k>>2]|0)&-2147483648;F=(c[k>>2]=K^I,ea(g[k>>2]));B=(c[k>>2]=K^(g[k>>2]=M,c[k>>2]|0),ea(g[k>>2]));M=(c[k>>2]=K^(g[k>>2]=C,c[k>>2]|0),ea(g[k>>2]));C=ea(D+ea(ea(F-D)*d));D=ea(H+ea(ea(B-H)*d));H=ea(r+ea(ea(M-r)*d));r=ea(z+ea(ea((c[k>>2]=K^(g[k>>2]=t,c[k>>2]|0),ea(g[k>>2]))-z)*d));z=ea(ea(1.0)/ea(T(ea(ea(ea(C*C)+ea(D*D))+ea(ea(H*H)+ea(r*r))))));t=ea(z*C);C=ea(z*D);D=ea(z*H);H=ea(z*r);r=ea(g[b+356>>2]);K=a+356|0;z=ea(g[K>>2]);M=ea(r-z);r=ea(g[b+360>>2]);I=a+360|0;B=ea(g[I>>2]);F=ea(r-B);r=ea(g[b+364>>2]);J=a+364|0;w=ea(g[J>>2]);q=ea(r-w);r=ea(g[b+368>>2]);b=a+368|0;G=ea(g[b>>2]);m=ea(z+ea(M*d));M=ea(B+ea(F*d));F=ea(w+ea(q*d));q=ea(G+ea(ea(r-G)*d));g[h>>2]=o;g[l>>2]=x;g[s>>2]=n;g[p>>2]=u;g[v>>2]=t;g[y>>2]=C;g[A>>2]=D;g[E>>2]=H;g[K>>2]=m;g[I>>2]=M;g[J>>2]=F;g[b>>2]=q;i=j;return}function gZd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im;c=ea(g[b>>2]);d=ea(c*ea(g[b+4>>2]));e=ea(c*ea(g[b+8>>2]));f=ea(c*ea(g[b+12>>2]));h=ea(c*ea(g[b+16>>2]));g[a>>2]=d;g[a+4>>2]=e;g[a+8>>2]=f;g[a+12>>2]=h;return}function hZd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im;c=ea(g[b>>2]);d=ea(c*ea(g[b+20>>2]));e=ea(c*ea(g[b+24>>2]));f=ea(c*ea(g[b+28>>2]));h=ea(c*ea(g[b+32>>2]));c=ea(T(ea(ea(ea(d*d)+ea(e*e))+ea(ea(f*f)+ea(h*h)))));h=ea(c*ea(.5));i=ea(+W(+h));j=ea(+V(+h));h=ea(ea(d*i)/c);d=ea(ea(e*i)/c);e=ea(ea(f*i)/c);b=c==ea(0.0);c=b?ea(0.0):h;h=b?ea(0.0):d;d=b?ea(0.0):e;e=b?ea(1.0):j;g[a>>2]=c;g[a+4>>2]=h;g[a+8>>2]=d;g[a+12>>2]=e;return}function iZd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im;c=ea(g[b>>2]);d=ea(c*ea(g[b+4>>2]));e=ea(c*ea(g[b+8>>2]));f=ea(c*ea(g[b+12>>2]));h=ea(c*ea(g[b+16>>2]));i=ea(c*ea(g[b+20>>2]));j=ea(c*ea(g[b+24>>2]));k=ea(c*ea(g[b+28>>2]));l=ea(c*ea(g[b+32>>2]));c=ea(T(ea(ea(ea(i*i)+ea(j*j))+ea(ea(k*k)+ea(l*l)))));l=ea(c*ea(.5));m=ea(+W(+l));n=ea(+V(+l));l=ea(ea(i*m)/c);i=ea(ea(j*m)/c);j=ea(ea(k*m)/c);b=c==ea(0.0);c=b?ea(0.0):l;l=b?ea(0.0):i;i=b?ea(0.0):j;j=b?ea(1.0):n;g[a>>2]=d;g[a+4>>2]=e;g[a+8>>2]=f;g[a+12>>2]=h;g[a+16>>2]=c;g[a+20>>2]=l;g[a+24>>2]=i;g[a+28>>2]=j;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);return}function jZd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im;c=ea(g[a>>2]);d=ea(ea(g[b>>2])/c);e=ea(ea(g[b+4>>2])/c);f=ea(ea(g[b+8>>2])/c);h=ea(ea(g[b+12>>2])/c);b=c!=ea(0.0);c=b?d:ea(0.0);d=b?e:ea(0.0);e=b?f:ea(0.0);f=b?h:ea(0.0);g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=e;g[a+16>>2]=f;return}function kZd(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im,i=0,j=Im,k=Im,l=Im,m=Im;c=ea(g[a>>2]);d=ea(ea(g[b>>2])/c);e=ea(ea(g[b+4>>2])/c);f=ea(ea(g[b+8>>2])/c);h=ea(ea(g[b+12>>2])/c);i=c!=ea(0.0);j=i?d:ea(0.0);d=i?e:ea(0.0);e=i?f:ea(0.0);f=i?h:ea(0.0);g[a+4>>2]=j;g[a+8>>2]=d;g[a+12>>2]=e;g[a+16>>2]=f;f=ea(g[b+16>>2]);e=ea(f*f);d=ea(g[b+20>>2]);j=ea(d*d);h=ea(g[b+24>>2]);k=ea(h*h);l=ea(g[b+28>>2]);m=ea(ea(1.0)/ea(T(ea(ea(e+j)+ea(k+ea(l*l))))));l=ea(f*m);f=ea(d*m);d=ea(h*m);m=ea(T(ea(ea(ea(l*l)+ea(f*f))+ea(ea(d*d)+ea(0.0)))));h=ea(ea(+Z(+m))*ea(2.0));k=ea(ea(l*h)/m);l=ea(ea(f*h)/m);f=ea(ea(d*h)/m);b=m!=ea(0.0);m=b?k:ea(0.0);k=b?l:ea(0.0);l=ea(m/c);m=ea(k/c);k=ea((b?f:ea(0.0))/c);f=ea(ea(0.0)/c);c=i?l:ea(0.0);l=i?m:ea(0.0);m=i?k:ea(0.0);k=i?f:ea(0.0);g[a+20>>2]=c;g[a+24>>2]=l;g[a+28>>2]=m;g[a+32>>2]=k;return}function lZd(a,b,d,e,f,h,j,l){a=ea(a);b=ea(b);d=ea(d);e=ea(e);f=f|0;h=h|0;j=j|0;l=l|0;var m=0,n=Im,o=Im;m=i;n=ea(VDi(ea(1.0),ea(UDi(ea(0.0),a))));o=ea(cEi(ea(a+e),l));e=f?o:n;n=ea(ea(1.0)-e);f=(g[k>>2]=n,c[k>>2]|0);n=(c[k>>2]=(h?f:0)|(g[k>>2]=e,c[k>>2]|0)&0-(h&1^1),ea(g[k>>2]));g[j>>2]=n;e=ea(ea(ea(d-b)*n)+b);i=m;return ea(e)}function mZd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=Im,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0;f=i;i=i+16|0;h=f;j=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[j>>2]=ea(1.0);g[a+44>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[h>>2]=e;k=c[b+1072>>2]|0;if((k|0)==-1)l=ea(0.0);else{m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;l=ea(a_d(n,h,d,k))}k=c[b+1076>>2]|0;if((k|0)==-1)o=ea(0.0);else{n=b+1040|0;m=(c[n>>2]|0)+n|0;c[b+1044>>2]=m;o=ea(a_d(m,h,d,k))}k=c[b+1080>>2]|0;if((k|0)==-1)p=ea(0.0);else{m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;p=ea(a_d(n,h,d,k))}g[a>>2]=l;g[a+4>>2]=o;g[a+8>>2]=p;g[a+12>>2]=ea(0.0);k=c[b+1084>>2]|0;if((k|0)==-1)q=ea(0.0);else{n=b+1040|0;m=(c[n>>2]|0)+n|0;c[b+1044>>2]=m;q=ea(a_d(m,h,d,k))}k=c[b+1088>>2]|0;if((k|0)==-1)r=ea(0.0);else{m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;r=ea(a_d(n,h,d,k))}k=c[b+1092>>2]|0;if((k|0)==-1)s=ea(0.0);else{n=b+1040|0;m=(c[n>>2]|0)+n|0;c[b+1044>>2]=m;s=ea(a_d(m,h,d,k))}k=c[b+1096>>2]|0;if((k|0)==-1){t=ea(1.0);u=ea(q*q);v=ea(r*r);w=ea(s*s);x=ea(t*t);y=ea(u+v);z=ea(w+x);A=ea(y+z);B=ea(T(ea(A)));C=ea(ea(1.0)/B);D=ea(q*C);E=ea(r*C);F=ea(s*C);G=ea(t*C);H=a+16|0;g[H>>2]=D;I=a+20|0;g[I>>2]=E;J=a+24|0;g[J>>2]=F;g[j>>2]=G;i=f;return}m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;t=ea(a_d(n,h,d,k));u=ea(q*q);v=ea(r*r);w=ea(s*s);x=ea(t*t);y=ea(u+v);z=ea(w+x);A=ea(y+z);B=ea(T(ea(A)));C=ea(ea(1.0)/B);D=ea(q*C);E=ea(r*C);F=ea(s*C);G=ea(t*C);H=a+16|0;g[H>>2]=D;I=a+20|0;g[I>>2]=E;J=a+24|0;g[J>>2]=F;g[j>>2]=G;i=f;return}function nZd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=Im,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0;f=i;i=i+16|0;h=f;j=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[j>>2]=ea(1.0);g[a+44>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[h>>2]=e;k=c[b+1100>>2]|0;if((k|0)==-1)l=ea(0.0);else{m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;l=ea(a_d(n,h,d,k))}k=c[b+1104>>2]|0;if((k|0)==-1)o=ea(0.0);else{n=b+1040|0;m=(c[n>>2]|0)+n|0;c[b+1044>>2]=m;o=ea(a_d(m,h,d,k))}k=c[b+1108>>2]|0;if((k|0)==-1)p=ea(0.0);else{m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;p=ea(a_d(n,h,d,k))}g[a>>2]=l;g[a+4>>2]=o;g[a+8>>2]=p;g[a+12>>2]=ea(0.0);k=c[b+1112>>2]|0;if((k|0)==-1)q=ea(0.0);else{n=b+1040|0;m=(c[n>>2]|0)+n|0;c[b+1044>>2]=m;q=ea(a_d(m,h,d,k))}k=c[b+1116>>2]|0;if((k|0)==-1)r=ea(0.0);else{m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;r=ea(a_d(n,h,d,k))}k=c[b+1120>>2]|0;if((k|0)==-1)s=ea(0.0);else{n=b+1040|0;m=(c[n>>2]|0)+n|0;c[b+1044>>2]=m;s=ea(a_d(m,h,d,k))}k=c[b+1124>>2]|0;if((k|0)==-1){t=ea(1.0);u=ea(q*q);v=ea(r*r);w=ea(s*s);x=ea(t*t);y=ea(u+v);z=ea(w+x);A=ea(y+z);B=ea(T(ea(A)));C=ea(ea(1.0)/B);D=ea(q*C);E=ea(r*C);F=ea(s*C);G=ea(t*C);H=a+16|0;g[H>>2]=D;I=a+20|0;g[I>>2]=E;J=a+24|0;g[J>>2]=F;g[j>>2]=G;i=f;return}m=b+1040|0;n=(c[m>>2]|0)+m|0;c[b+1044>>2]=n;t=ea(a_d(n,h,d,k));u=ea(q*q);v=ea(r*r);w=ea(s*s);x=ea(t*t);y=ea(u+v);z=ea(w+x);A=ea(y+z);B=ea(T(ea(A)));C=ea(ea(1.0)/B);D=ea(q*C);E=ea(r*C);F=ea(s*C);G=ea(t*C);H=a+16|0;g[H>>2]=D;I=a+20|0;g[I>>2]=E;J=a+24|0;g[J>>2]=F;g[j>>2]=G;i=f;return}function oZd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0;h=i;i=i+16|0;j=h;k=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[k>>2]=ea(1.0);g[a+44>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+32>>2]=ea(1.0);l=f*7|0;g[j>>2]=e;f=b+(l+14<<2)+1072|0;if((c[f>>2]|0)==-1)m=ea(0.0);else{n=b+1040|0;o=(c[n>>2]|0)+n|0;c[b+1044>>2]=o;m=ea(a_d(o,j,d,c[f>>2]|0))}f=b+(l+15<<2)+1072|0;if((c[f>>2]|0)==-1)p=ea(0.0);else{o=b+1040|0;n=(c[o>>2]|0)+o|0;c[b+1044>>2]=n;p=ea(a_d(n,j,d,c[f>>2]|0))}f=b+(l+16<<2)+1072|0;if((c[f>>2]|0)==-1)q=ea(0.0);else{n=b+1040|0;o=(c[n>>2]|0)+n|0;c[b+1044>>2]=o;q=ea(a_d(o,j,d,c[f>>2]|0))}g[a>>2]=m;g[a+4>>2]=p;g[a+8>>2]=q;g[a+12>>2]=ea(0.0);f=b+(l+17<<2)+1072|0;if((c[f>>2]|0)==-1)r=ea(0.0);else{o=b+1040|0;n=(c[o>>2]|0)+o|0;c[b+1044>>2]=n;r=ea(a_d(n,j,d,c[f>>2]|0))}f=b+(l+18<<2)+1072|0;if((c[f>>2]|0)==-1)s=ea(0.0);else{n=b+1040|0;o=(c[n>>2]|0)+n|0;c[b+1044>>2]=o;s=ea(a_d(o,j,d,c[f>>2]|0))}f=b+(l+19<<2)+1072|0;if((c[f>>2]|0)==-1)t=ea(0.0);else{o=b+1040|0;n=(c[o>>2]|0)+o|0;c[b+1044>>2]=n;t=ea(a_d(n,j,d,c[f>>2]|0))}f=b+(l+20<<2)+1072|0;if((c[f>>2]|0)==-1){u=ea(1.0);v=ea(r*r);w=ea(s*s);x=ea(t*t);y=ea(u*u);z=ea(v+w);A=ea(x+y);B=ea(z+A);C=ea(T(ea(B)));D=ea(ea(1.0)/C);E=ea(r*D);F=ea(s*D);G=ea(t*D);H=ea(u*D);I=a+16|0;g[I>>2]=E;J=a+20|0;g[J>>2]=F;K=a+24|0;g[K>>2]=G;g[k>>2]=H;i=h;return}l=b+1040|0;n=(c[l>>2]|0)+l|0;c[b+1044>>2]=n;u=ea(a_d(n,j,d,c[f>>2]|0));v=ea(r*r);w=ea(s*s);x=ea(t*t);y=ea(u*u);z=ea(v+w);A=ea(x+y);B=ea(z+A);C=ea(T(ea(B)));D=ea(ea(1.0)/C);E=ea(r*D);F=ea(s*D);G=ea(t*D);H=ea(u*D);I=a+16|0;g[I>>2]=E;J=a+20|0;g[J>>2]=F;K=a+24|0;g[K>>2]=G;g[k>>2]=H;i=h;return}function pZd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;d=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[d>>2]=ea(1.0);e=a+44|0;g[e>>2]=ea(1.0);f=a+40|0;g[f>>2]=ea(1.0);h=a+36|0;g[h>>2]=ea(1.0);i=a+32|0;g[i>>2]=ea(1.0);j=c[b+1072>>2]|0;if((j|0)==-1)k=ea(0.0);else{l=b+1612|0;k=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1076>>2]|0;if((j|0)==-1)m=ea(0.0);else{l=b+1612|0;m=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1080>>2]|0;if((j|0)==-1)n=ea(0.0);else{l=b+1612|0;n=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}g[a>>2]=k;g[a+4>>2]=m;g[a+8>>2]=n;g[a+12>>2]=ea(0.0);j=c[b+1084>>2]|0;if((j|0)==-1)o=ea(0.0);else{l=b+1612|0;o=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1088>>2]|0;if((j|0)==-1)p=ea(0.0);else{l=b+1612|0;p=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1092>>2]|0;if((j|0)==-1)q=ea(0.0);else{l=b+1612|0;q=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1096>>2]|0;if((j|0)==-1)r=ea(1.0);else{l=b+1612|0;r=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}n=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(p*p))+ea(ea(q*q)+ea(r*r))))));m=ea(p*n);p=ea(q*n);q=ea(r*n);g[a+16>>2]=ea(o*n);g[a+20>>2]=m;g[a+24>>2]=p;g[d>>2]=q;g[i>>2]=ea(1.0);g[h>>2]=ea(1.0);g[f>>2]=ea(1.0);g[e>>2]=ea(1.0);return}function qZd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;d=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[d>>2]=ea(1.0);e=a+44|0;g[e>>2]=ea(1.0);f=a+40|0;g[f>>2]=ea(1.0);h=a+36|0;g[h>>2]=ea(1.0);i=a+32|0;g[i>>2]=ea(1.0);j=c[b+1072>>2]|0;if((j|0)==-1)k=ea(0.0);else{l=b+1612|0;k=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1076>>2]|0;if((j|0)==-1)m=ea(0.0);else{l=b+1612|0;m=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1080>>2]|0;if((j|0)==-1)n=ea(0.0);else{l=b+1612|0;n=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}g[a>>2]=k;g[a+4>>2]=m;g[a+8>>2]=n;g[a+12>>2]=ea(0.0);j=c[b+1084>>2]|0;if((j|0)==-1)o=ea(0.0);else{l=b+1612|0;o=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1088>>2]|0;if((j|0)==-1)p=ea(0.0);else{l=b+1612|0;p=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1092>>2]|0;if((j|0)==-1)q=ea(0.0);else{l=b+1612|0;q=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1096>>2]|0;if((j|0)==-1)r=ea(1.0);else{l=b+1612|0;r=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}n=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(p*p))+ea(ea(q*q)+ea(r*r))))));m=ea(p*n);p=ea(q*n);q=ea(r*n);g[a+16>>2]=ea(o*n);g[a+20>>2]=m;g[a+24>>2]=p;g[d>>2]=q;g[i>>2]=ea(1.0);g[h>>2]=ea(1.0);g[f>>2]=ea(1.0);g[e>>2]=ea(1.0);return}function rZd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;d=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[d>>2]=ea(1.0);e=a+44|0;g[e>>2]=ea(1.0);f=a+40|0;g[f>>2]=ea(1.0);h=a+36|0;g[h>>2]=ea(1.0);i=a+32|0;g[i>>2]=ea(1.0);j=c[b+1100>>2]|0;if((j|0)==-1)k=ea(0.0);else{l=b+1612|0;k=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1104>>2]|0;if((j|0)==-1)m=ea(0.0);else{l=b+1612|0;m=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1108>>2]|0;if((j|0)==-1)n=ea(0.0);else{l=b+1612|0;n=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}g[a>>2]=k;g[a+4>>2]=m;g[a+8>>2]=n;g[a+12>>2]=ea(0.0);j=c[b+1112>>2]|0;if((j|0)==-1)o=ea(0.0);else{l=b+1612|0;o=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1116>>2]|0;if((j|0)==-1)p=ea(0.0);else{l=b+1612|0;p=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1120>>2]|0;if((j|0)==-1)q=ea(0.0);else{l=b+1612|0;q=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}j=c[b+1124>>2]|0;if((j|0)==-1)r=ea(1.0);else{l=b+1612|0;r=ea(g[(c[l>>2]|0)+l+(j<<3)>>2])}n=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(p*p))+ea(ea(q*q)+ea(r*r))))));m=ea(p*n);p=ea(q*n);q=ea(r*n);g[a+16>>2]=ea(o*n);g[a+20>>2]=m;g[a+24>>2]=p;g[d>>2]=q;g[i>>2]=ea(1.0);g[h>>2]=ea(1.0);g[f>>2]=ea(1.0);g[e>>2]=ea(1.0);return}function sZd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;d=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[d>>2]=ea(1.0);e=a+44|0;g[e>>2]=ea(1.0);f=a+40|0;g[f>>2]=ea(1.0);h=a+36|0;g[h>>2]=ea(1.0);i=a+32|0;g[i>>2]=ea(1.0);j=c[b+1100>>2]|0;if((j|0)==-1)k=ea(0.0);else{l=b+1612|0;k=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1104>>2]|0;if((j|0)==-1)m=ea(0.0);else{l=b+1612|0;m=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1108>>2]|0;if((j|0)==-1)n=ea(0.0);else{l=b+1612|0;n=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}g[a>>2]=k;g[a+4>>2]=m;g[a+8>>2]=n;g[a+12>>2]=ea(0.0);j=c[b+1112>>2]|0;if((j|0)==-1)o=ea(0.0);else{l=b+1612|0;o=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1116>>2]|0;if((j|0)==-1)p=ea(0.0);else{l=b+1612|0;p=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1120>>2]|0;if((j|0)==-1)q=ea(0.0);else{l=b+1612|0;q=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}j=c[b+1124>>2]|0;if((j|0)==-1)r=ea(1.0);else{l=b+1612|0;r=ea(g[(c[l>>2]|0)+l+(j<<3)+4>>2])}n=ea(ea(1.0)/ea(T(ea(ea(ea(o*o)+ea(p*p))+ea(ea(q*q)+ea(r*r))))));m=ea(p*n);p=ea(q*n);q=ea(r*n);g[a+16>>2]=ea(o*n);g[a+20>>2]=m;g[a+24>>2]=p;g[d>>2]=q;g[i>>2]=ea(1.0);g[h>>2]=ea(1.0);g[f>>2]=ea(1.0);g[e>>2]=ea(1.0);return}function tZd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;EZd(a,b,c);i=d;return}function uZd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im;e=i;i=i+48|0;f=e;h=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[h>>2]=ea(1.0);j=a+32|0;g[j>>2]=ea(1.0);k=a+36|0;g[k>>2]=ea(1.0);l=a+40|0;g[l>>2]=ea(1.0);m=a+44|0;g[m>>2]=ea(1.0);if((d|0)<=0){i=e;return}n=b+4|0;o=b+8|0;p=b+12|0;q=f+4|0;r=f+8|0;s=f+12|0;t=b+16|0;u=b+20|0;v=b+24|0;w=b+28|0;x=f+16|0;y=f+20|0;z=f+24|0;A=f+28|0;B=b+32|0;C=b+36|0;D=b+40|0;E=b+44|0;F=f+32|0;G=f+36|0;H=f+40|0;I=f+44|0;J=a+4|0;K=a+8|0;L=a+12|0;M=a+16|0;N=a+20|0;O=a+24|0;P=0;do{if(!P){Q=ea(g[b>>2]);R=ea(g[n>>2]);S=ea(g[o>>2]);T=ea(g[p>>2]);g[f>>2]=Q;g[q>>2]=R;g[r>>2]=S;g[s>>2]=T;U=ea(g[t>>2]);V=ea(g[u>>2]);W=ea(g[v>>2]);X=ea(g[w>>2]);g[x>>2]=U;g[y>>2]=V;g[z>>2]=W;g[A>>2]=X;Y=ea(g[B>>2]);Z=ea(g[C>>2]);_=ea(g[D>>2]);$=ea(g[E>>2]);g[F>>2]=Y;g[G>>2]=Z;g[H>>2]=_;g[I>>2]=$;aa=Q;ba=R;ca=S;da=T;fa=U;ga=V;ha=W;ia=X;ja=Y;ka=Z;la=_;ma=$}else{FZd(f,a,a);$=ea(g[f>>2]);_=ea(g[q>>2]);Z=ea(g[r>>2]);Y=ea(g[s>>2]);X=ea(g[x>>2]);W=ea(g[y>>2]);V=ea(g[z>>2]);U=ea(g[A>>2]);T=ea(g[F>>2]);S=ea(g[G>>2]);R=ea(g[H>>2]);aa=$;ba=_;ca=Z;da=Y;fa=X;ga=W;ha=V;ia=U;ja=T;ka=S;la=R;ma=ea(g[I>>2])}g[a>>2]=aa;g[J>>2]=ba;g[K>>2]=ca;g[L>>2]=da;g[M>>2]=fa;g[N>>2]=ga;g[O>>2]=ha;g[h>>2]=ia;g[j>>2]=ja;g[k>>2]=ka;g[l>>2]=la;g[m>>2]=ma;P=P+1|0}while((P|0)!=(d|0));i=e;return}function vZd(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;h=i;i=i+336|0;j=h+96|0;k=h+192|0;l=h+240|0;m=h+288|0;n=h+48|0;o=h;p=h+144|0;if((f|0)==1){GZd(k,d,b);FZd(j,e,k);GZd(a,c,j);i=h;return}else if(!f){GZd(a,c,b);i=h;return}else{GZd(o,d,e);uZd(n,o,f);GZd(p,d,b);q=ea(g[p>>2]);r=ea(q+q);s=ea(g[p+4>>2]);t=ea(s+s);u=ea(g[p+8>>2]);v=ea(u+u);w=ea(g[p+12>>2]);x=ea(g[n+16>>2]);y=ea(t*x);z=ea(g[n+20>>2]);A=ea(v*z);B=ea(g[n+24>>2]);C=ea(r*B);D=ea(g[n+28>>2]);E=ea(D*ea(0.0));F=ea(y-ea(r*z));r=ea(A-ea(t*B));t=ea(C-ea(v*x));v=ea(D*ea(E-E));E=ea(ea(q+ea(D*r))+ea(ea(z*F)-ea(B*t)));q=ea(ea(s+ea(D*t))+ea(ea(B*r)-ea(x*F)));s=ea(ea(u+ea(F*D))+ea(ea(x*t)-ea(z*r)));r=ea(ea(w+v)+ea(v-v));v=ea(ea(g[n>>2])+E);E=ea(ea(g[n+4>>2])+q);q=ea(ea(g[n+8>>2])+s);s=ea(ea(g[n+12>>2])+r);r=ea(g[p+16>>2]);w=ea(z*r);t=ea(g[p+28>>2]);F=ea(D*t);u=ea(g[p+20>>2]);C=ea(B*u);A=ea(g[p+24>>2]);y=ea(ea(ea(w-ea(D*A))-ea(B*t))-ea(x*u));w=ea(ea(ea(F-ea(x*r))-ea(B*A))-ea(z*u));F=ea(ea(ea(C-ea(z*A))-ea(D*r))-ea(x*t));C=ea(ea(ea(ea(x*A)-ea(B*r))-ea(D*u))-ea(z*t));t=ea(ea(1.0)/ea(T(ea(ea(ea(F*F)+ea(C*C))+ea(ea(w*w)+ea(y*y))))));z=ea(-ea(t*F));F=ea(-ea(t*C));C=ea(-ea(t*y));y=ea(t*w);g[m>>2]=v;g[m+4>>2]=E;g[m+8>>2]=q;g[m+12>>2]=s;g[m+16>>2]=z;g[m+20>>2]=F;g[m+24>>2]=C;g[m+28>>2]=y;g[m+32>>2]=ea(1.0);g[m+36>>2]=ea(1.0);g[m+40>>2]=ea(1.0);g[m+44>>2]=ea(1.0);FZd(l,e,m);GZd(a,c,l);i=h;return}}function wZd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=Im,Y=Im,_=0,$=0,aa=Im,ba=0,ca=Im,da=0,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=Im,Za=Im,_a=Im,$a=Im,ab=Im,bb=Im,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=Im,Bb=Im,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=Im,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=Im,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im;h=i;i=i+640|0;j=h+584|0;l=h+528|0;m=h+288|0;n=h+240|0;o=h+144|0;p=h+480|0;q=h+536|0;r=h+592|0;s=h+336|0;t=h+96|0;u=h+48|0;v=h+384|0;w=h;x=h+192|0;y=h+432|0;if((((((c[b+1072>>2]|0)==-1?(c[b+1076>>2]|0)==-1:0)?(c[b+1080>>2]|0)==-1:0)?(c[b+1084>>2]|0)==-1:0)?(c[b+1088>>2]|0)==-1:0)?(c[b+1092>>2]|0)==-1:0)z=(c[b+1096>>2]|0)!=-1;else z=1;if((((((c[b+1100>>2]|0)==-1?(c[b+1104>>2]|0)==-1:0)?(c[b+1108>>2]|0)==-1:0)?(c[b+1112>>2]|0)==-1:0)?(c[b+1116>>2]|0)==-1:0)?(c[b+1120>>2]|0)==-1:0)A=(c[b+1124>>2]|0)!=-1;else A=1;B=e+4|0;C=e+8|0;D=e+12|0;E=e+16|0;F=e+20|0;G=e+24|0;H=e+28|0;I=e+32|0;J=e+84|0;K=e+88|0;L=e+92|0;M=e+96|0;N=e+100|0;O=e+104|0;P=e+108|0;Q=e+112|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[B+16>>2]=0;c[B+20>>2]=0;c[B+24>>2]=0;c[B+28>>2]=0;c[J+0>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;c[J+12>>2]=0;c[J+16>>2]=0;c[J+20>>2]=0;c[J+24>>2]=0;g[Q>>2]=ea(1.0);R=e+116|0;g[R>>2]=ea(1.0);U=e+120|0;g[U>>2]=ea(1.0);V=e+124|0;g[V>>2]=ea(1.0);W=e+128|0;g[W>>2]=ea(1.0);if(!(z|A)){i=h;return}X=ea(g[b+1064>>2]);Y=ea(X+ea(g[d+24>>2]));_=d+4|0;X=ea(g[_>>2]);$=b+1048|0;aa=ea(g[$>>2]);ba=b+1052|0;ca=ea(g[ba>>2]);da=b+1621|0;fa=(a[da>>0]|0)!=0;ga=d+16|0;ha=ea(g[ga>>2])<ea(0.0);ia=ea(VDi(ea(1.0),ea(UDi(ea(0.0),X))));ja=ea(cEi(ea(X+Y),j));X=fa?ja:ia;ia=ea(ea(1.0)-X);fa=(g[k>>2]=ia,c[k>>2]|0);ia=ea(aa+ea(ea(ca-aa)*(c[k>>2]=(ha?fa:0)|(g[k>>2]=X,c[k>>2]|0)&0-(ha&1^1),ea(g[k>>2]))));X=ea(g[d>>2]);aa=ea(g[$>>2]);ca=ea(g[ba>>2]);ha=(a[da>>0]|0)!=0;fa=ea(g[ga>>2])<ea(0.0);ja=ea(VDi(ea(1.0),ea(UDi(ea(0.0),X))));ka=ea(cEi(ea(Y+X),l));X=ha?ka:ja;ja=ea(ea(1.0)-X);ha=(g[k>>2]=ja,c[k>>2]|0);ja=ea(aa+ea(ea(ca-aa)*(c[k>>2]=(fa?ha:0)|(g[k>>2]=X,c[k>>2]|0)&0-(fa&1^1),ea(g[k>>2]))));fa=m+28|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m+24>>2]=0;g[fa>>2]=ea(1.0);ha=m+44|0;g[ha>>2]=ea(1.0);la=m+40|0;g[la>>2]=ea(1.0);ma=m+36|0;g[ma>>2]=ea(1.0);na=m+32|0;g[na>>2]=ea(1.0);oa=n+28|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+24>>2]=0;g[oa>>2]=ea(1.0);pa=n+44|0;g[pa>>2]=ea(1.0);qa=n+40|0;g[qa>>2]=ea(1.0);ra=n+36|0;g[ra>>2]=ea(1.0);sa=n+32|0;g[sa>>2]=ea(1.0);ta=o+28|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;g[ta>>2]=ea(1.0);ua=o+44|0;g[ua>>2]=ea(1.0);va=o+40|0;g[va>>2]=ea(1.0);wa=o+36|0;g[wa>>2]=ea(1.0);xa=o+32|0;g[xa>>2]=ea(1.0);ya=p+28|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=0;g[ya>>2]=ea(1.0);za=p+44|0;g[za>>2]=ea(1.0);Aa=p+40|0;g[Aa>>2]=ea(1.0);Ba=p+36|0;g[Ba>>2]=ea(1.0);Ca=p+32|0;g[Ca>>2]=ea(1.0);do if(!z){if(!A){Da=p+4|0;Ea=p+8|0;Fa=p+12|0;Ga=p+16|0;Ha=p+20|0;Ia=p+24|0;Ja=m;Ka=m+4|0;La=m+8|0;Ma=m+12|0;Na=m+16|0;Oa=m+20|0;Pa=m+24|0;Qa=n;Ra=n+4|0;Sa=n+8|0;Ta=n+12|0;Ua=n+16|0;Va=n+20|0;Wa=n+24|0;Xa=p;Ya=ea(0.0);Za=ea(0.0);_a=ea(0.0);$a=ea(0.0);ab=ea(0.0);bb=ea(1.0);break}rZd(u,b);X=ea(g[u>>2]);aa=ea(g[u+4>>2]);ca=ea(g[u+8>>2]);ka=ea(g[u+12>>2]);g[m>>2]=X;cb=m+4|0;g[cb>>2]=aa;db=m+8|0;g[db>>2]=ca;eb=m+12|0;g[eb>>2]=ka;ka=ea(g[u+16>>2]);ca=ea(g[u+20>>2]);aa=ea(g[u+24>>2]);X=ea(g[u+28>>2]);fb=m+16|0;g[fb>>2]=ka;gb=m+20|0;g[gb>>2]=ca;hb=m+24|0;g[hb>>2]=aa;g[fa>>2]=X;X=ea(g[u+32>>2]);aa=ea(g[u+36>>2]);ca=ea(g[u+40>>2]);ka=ea(g[u+44>>2]);g[na>>2]=X;g[ma>>2]=aa;g[la>>2]=ca;g[ha>>2]=ka;sZd(v,b);ka=ea(g[v>>2]);ca=ea(g[v+4>>2]);aa=ea(g[v+8>>2]);X=ea(g[v+12>>2]);g[n>>2]=ka;ib=n+4|0;g[ib>>2]=ca;jb=n+8|0;g[jb>>2]=aa;kb=n+12|0;g[kb>>2]=X;X=ea(g[v+16>>2]);aa=ea(g[v+20>>2]);ca=ea(g[v+24>>2]);ka=ea(g[v+28>>2]);lb=n+16|0;g[lb>>2]=X;mb=n+20|0;g[mb>>2]=aa;nb=n+24|0;g[nb>>2]=ca;g[oa>>2]=ka;ka=ea(g[v+32>>2]);ca=ea(g[v+36>>2]);aa=ea(g[v+40>>2]);X=ea(g[v+44>>2]);g[sa>>2]=ka;g[ra>>2]=ca;g[qa>>2]=aa;g[pa>>2]=X;nZd(w,b,f,ia);X=ea(g[w>>2]);aa=ea(g[w+4>>2]);ca=ea(g[w+8>>2]);ka=ea(g[w+12>>2]);g[o>>2]=X;ob=o+4|0;g[ob>>2]=aa;pb=o+8|0;g[pb>>2]=ca;qb=o+12|0;g[qb>>2]=ka;ka=ea(g[w+16>>2]);ca=ea(g[w+20>>2]);aa=ea(g[w+24>>2]);X=ea(g[w+28>>2]);rb=o+16|0;g[rb>>2]=ka;sb=o+20|0;g[sb>>2]=ca;tb=o+24|0;g[tb>>2]=aa;g[ta>>2]=X;X=ea(g[w+32>>2]);aa=ea(g[w+36>>2]);ca=ea(g[w+40>>2]);ka=ea(g[w+44>>2]);g[xa>>2]=X;g[wa>>2]=aa;g[va>>2]=ca;g[ua>>2]=ka;nZd(x,b,f,ja);ka=ea(g[x>>2]);ca=ea(g[x+4>>2]);aa=ea(g[x+8>>2]);X=ea(g[x+12>>2]);g[p>>2]=ka;ub=p+4|0;g[ub>>2]=ca;vb=p+8|0;g[vb>>2]=aa;wb=p+12|0;g[wb>>2]=X;X=ea(g[x+16>>2]);aa=ea(g[x+20>>2]);ca=ea(g[x+24>>2]);ka=ea(g[x+28>>2]);xb=p+16|0;g[xb>>2]=X;yb=p+20|0;g[yb>>2]=aa;zb=p+24|0;g[zb>>2]=ca;g[ya>>2]=ka;ka=ea(g[x+32>>2]);ca=ea(g[x+36>>2]);aa=ea(g[x+40>>2]);X=ea(g[x+44>>2]);g[Ca>>2]=ka;g[Ba>>2]=ca;g[Aa>>2]=aa;g[za>>2]=X;X=ea(g[fa>>2]);aa=ea(g[fb>>2]);ca=ea(X*aa);ka=ea(g[gb>>2]);Y=ea(X*ka);Ab=ea(g[hb>>2]);Bb=ea(ea(aa*ka)-ea(X*Ab));Cb=ea(ea(ea(X*X)+ea(-.5))+ea(ka*ka));Db=ea(ca+ea(ka*Ab));ca=ea(Y-Y);Y=ea(Bb+Bb);Bb=ea(Cb+Cb);Cb=ea(Db+Db);Db=ea(ca+ca);ca=ea(Bb*ea(0.0));Eb=ea(Cb*ea(0.0));Fb=ea(Y*ea(0.0));Gb=ea(Y-ca);Hb=ea(ca-Cb);ca=ea(Eb-Fb);Ib=ea(ea(T(ea(ea(ea(Bb*Bb)+ea(Y*Y))+ea(ea(Db*Db)+ea(Cb*Cb)))))+ea(ea(Bb+Fb)+ea(ea(Db*ea(0.0))+Eb)));Eb=ea(ea(ea(ea(X*Ib)-ea(aa*Hb))-ea(Ab*Gb))-ea(ka*ca));Db=ea(ea(ea(ea(Ab*Hb)-ea(aa*Gb))-ea(ka*Ib))-ea(X*ca));Fb=ea(ea(ea(ea(ea(ka*Gb)-ea(Ab*ca))-ea(aa*Ib))-ea(X*Hb))*ea(-0.0));Bb=ea(ea(ea(ea(ea(aa*ca)-ea(Ab*Ib))-ea(X*Gb))-ea(ka*Hb))*ea(-0.0));Hb=ea(ea(1.0)/ea(T(ea(ea(ea(Db*Db)+ea(Fb*Fb))+ea(ea(Eb*Eb)+ea(Bb*Bb))))));ka=ea(-ea(Hb*Db));Db=ea(Hb*Bb);Bb=ea(Hb*Eb);g[fb>>2]=ea(Hb*Fb);g[gb>>2]=ka;g[hb>>2]=Db;g[fa>>2]=Bb;Bb=ea(g[oa>>2]);Db=ea(g[lb>>2]);ka=ea(Bb*Db);Fb=ea(g[mb>>2]);Hb=ea(Bb*Fb);Eb=ea(g[nb>>2]);Gb=ea(ea(Db*Fb)-ea(Bb*Eb));X=ea(ea(ea(Bb*Bb)+ea(-.5))+ea(Fb*Fb));Ib=ea(ka+ea(Fb*Eb));ka=ea(Hb-Hb);Hb=ea(Gb+Gb);Gb=ea(X+X);X=ea(Ib+Ib);Ib=ea(ka+ka);ka=ea(Gb*ea(0.0));Ab=ea(X*ea(0.0));ca=ea(Hb*ea(0.0));aa=ea(Hb-ka);Cb=ea(ka-X);ka=ea(Ab-ca);Y=ea(ea(T(ea(ea(ea(Gb*Gb)+ea(Hb*Hb))+ea(ea(Ib*Ib)+ea(X*X)))))+ea(ea(Gb+ca)+ea(ea(Ib*ea(0.0))+Ab)));Ab=ea(ea(ea(ea(Bb*Y)-ea(Db*Cb))-ea(Eb*aa))-ea(Fb*ka));Ib=ea(ea(ea(ea(Eb*Cb)-ea(Db*aa))-ea(Fb*Y))-ea(Bb*ka));ca=ea(ea(ea(ea(ea(Fb*aa)-ea(Eb*ka))-ea(Db*Y))-ea(Bb*Cb))*ea(-0.0));Gb=ea(ea(ea(ea(ea(Db*ka)-ea(Eb*Y))-ea(Bb*aa))-ea(Fb*Cb))*ea(-0.0));Cb=ea(ea(1.0)/ea(T(ea(ea(ea(Ib*Ib)+ea(ca*ca))+ea(ea(Ab*Ab)+ea(Gb*Gb))))));Fb=ea(-ea(Cb*Ib));Ib=ea(Cb*Gb);Gb=ea(Cb*Ab);g[lb>>2]=ea(Cb*ca);g[mb>>2]=Fb;g[nb>>2]=Ib;g[oa>>2]=Gb;Gb=ea(g[ta>>2]);Ib=ea(g[rb>>2]);Fb=ea(Gb*Ib);ca=ea(g[sb>>2]);Cb=ea(Gb*ca);Ab=ea(g[tb>>2]);aa=ea(ea(Ib*ca)-ea(Gb*Ab));Bb=ea(ea(ea(Gb*Gb)+ea(-.5))+ea(ca*ca));Y=ea(Fb+ea(ca*Ab));Fb=ea(Cb-Cb);Cb=ea(aa+aa);aa=ea(Bb+Bb);Bb=ea(Y+Y);Y=ea(Fb+Fb);Fb=ea(aa*ea(0.0));Eb=ea(Bb*ea(0.0));ka=ea(Cb*ea(0.0));Db=ea(Cb-Fb);X=ea(Fb-Bb);Fb=ea(Eb-ka);Hb=ea(ea(T(ea(ea(ea(aa*aa)+ea(Cb*Cb))+ea(ea(Y*Y)+ea(Bb*Bb)))))+ea(ea(aa+ka)+ea(ea(Y*ea(0.0))+Eb)));Eb=ea(ea(ea(ea(Gb*Hb)-ea(Ib*X))-ea(Ab*Db))-ea(ca*Fb));Y=ea(ea(ea(ea(Ab*X)-ea(Ib*Db))-ea(ca*Hb))-ea(Gb*Fb));ka=ea(ea(ea(ea(ea(ca*Db)-ea(Ab*Fb))-ea(Ib*Hb))-ea(Gb*X))*ea(-0.0));aa=ea(ea(ea(ea(ea(Ib*Fb)-ea(Ab*Hb))-ea(Gb*Db))-ea(ca*X))*ea(-0.0));X=ea(ea(1.0)/ea(T(ea(ea(ea(Y*Y)+ea(ka*ka))+ea(ea(Eb*Eb)+ea(aa*aa))))));ca=ea(-ea(X*Y));Y=ea(X*aa);aa=ea(X*Eb);g[rb>>2]=ea(X*ka);g[sb>>2]=ca;g[tb>>2]=Y;g[ta>>2]=aa;aa=ea(g[ya>>2]);Y=ea(g[xb>>2]);ca=ea(aa*Y);ka=ea(g[yb>>2]);X=ea(aa*ka);Eb=ea(g[zb>>2]);Db=ea(ea(Y*ka)-ea(aa*Eb));Gb=ea(ea(ea(aa*aa)+ea(-.5))+ea(ka*ka));Hb=ea(ca+ea(ka*Eb));ca=ea(X-X);X=ea(Db+Db);Db=ea(Gb+Gb);Gb=ea(Hb+Hb);Hb=ea(ca+ca);ca=ea(Db*ea(0.0));Ab=ea(Gb*ea(0.0));Fb=ea(X*ea(0.0));Ib=ea(X-ca);Bb=ea(ca-Gb);ca=ea(Ab-Fb);Cb=ea(ea(T(ea(ea(ea(Db*Db)+ea(X*X))+ea(ea(Hb*Hb)+ea(Gb*Gb)))))+ea(ea(Db+Fb)+ea(ea(Hb*ea(0.0))+Ab)));Ab=ea(ea(ea(ea(aa*Cb)-ea(Y*Bb))-ea(Eb*Ib))-ea(ka*ca));Hb=ea(ea(ea(ea(Eb*Bb)-ea(Y*Ib))-ea(ka*Cb))-ea(aa*ca));Fb=ea(ea(ea(ea(ea(ka*Ib)-ea(Eb*ca))-ea(Y*Cb))-ea(aa*Bb))*ea(-0.0));Db=ea(ea(ea(ea(ea(Y*ca)-ea(Eb*Cb))-ea(aa*Ib))-ea(ka*Bb))*ea(-0.0));Bb=ea(ea(1.0)/ea(T(ea(ea(ea(Hb*Hb)+ea(Fb*Fb))+ea(ea(Ab*Ab)+ea(Db*Db))))));ka=ea(-ea(Bb*Hb));Hb=ea(Bb*Db);Db=ea(Bb*Ab);g[xb>>2]=ea(Bb*Fb);g[yb>>2]=ka;g[zb>>2]=Hb;g[ya>>2]=Db;Db=ea(g[b+1060>>2]);Hb=ea(ea(g[b+1056>>2])*ea(.0174532924));ka=ea(ea(VDi(ea(UDi(ea(ea((Hb>ea(0.0)&1)-(Hb<ea(0.0)&1)|0)*ea(ea(+ea(ea(S(ea(Hb)))*ea(.5))+1.5707963267948966)+ea(-1.57079637))),ea(-1.57079542))),ea(1.57079542)))*ea(.159154937));Hb=ea(ka+ea(-.25));Fb=ea(ka+ea(0.0));ka=ea(eEi(Hb));Bb=ea(ea(.25)-ea(S(ea(Hb-ka))));ka=ea(ea(.25)-ea(S(ea(Fb-ea(eEi(Fb))))));Fb=ea(Bb*Bb);Hb=ea(ka*ka);Ab=ea(ea(Bb*ea(ea(ea(Fb*ea(-41.2831841))+ea(6.28318548))+ea(ea(Fb*Fb)*ea(76.0354614))))/ea(ka*ea(ea(ea(Hb*ea(-41.2831841))+ea(6.28318548))+ea(ea(Hb*Hb)*ea(76.0354614)))));Hb=ea(ea(1.0)/ea(T(ea(ea(ea(Ab*Ab)+ea(0.0))+ea(1.0)))));ka=ea(Hb*ea(0.0));Fb=ea(Ab*Hb);if(!(a[b+1627>>0]|0))Jb=Db;else Jb=ea(Db-ea(g[cb>>2]));if(!(a[b+1628>>0]|0)){Kb=ea(0.0);Lb=ea(0.0)}else{Db=ea(ea(0.0)-ea(g[m>>2]));Kb=Db;Lb=ea(ea(0.0)-ea(g[db>>2]))}Db=ea(g[fb>>2]);if(!(a[b+1626>>0]|0)){Ab=ea(g[fa>>2]);Bb=ea(g[gb>>2]);Mb=Fb;Nb=Hb;Ob=Ab;Pb=ka;Qb=Bb;Rb=ka;Sb=ea(g[hb>>2])}else{Bb=ea(-Db);Ab=ea(g[gb>>2]);Ib=ea(-Ab);aa=ea(g[hb>>2]);Cb=ea(-aa);Eb=ea(g[fa>>2]);ca=ea(ka*Ib);Y=ea(ka*Cb);Gb=ea(ka*Bb);X=ea(ka*Eb);ka=ea(ea(ea(ea(Fb*Bb)-ea(Hb*Cb))-X)-ca);Tb=ea(ea(ea(ea(Hb*Eb)-Gb)-Y)-ea(Fb*Ib));Ub=ea(ea(ea(ca-ea(Fb*Cb))-ea(Hb*Bb))-X);X=ea(ea(ea(Y-Gb)-ea(Hb*Ib))-ea(Fb*Eb));Fb=ea(ea(1.0)/ea(T(ea(ea(ea(Ub*Ub)+ea(X*X))+ea(ea(ka*ka)+ea(Tb*Tb))))));Mb=ea(-ea(Fb*X));Nb=ea(Fb*Tb);Ob=Eb;Pb=ea(-ea(Fb*ka));Qb=Ab;Rb=ea(-ea(Fb*Ub));Sb=aa}aa=ea(Kb+ea(g[m>>2]));Ub=ea(Jb+ea(g[cb>>2]));Fb=ea(Lb+ea(g[db>>2]));Ab=ea(ea(g[eb>>2])+ea(0.0));g[m>>2]=aa;g[cb>>2]=Ub;g[db>>2]=Fb;g[eb>>2]=Ab;Ab=ea(Kb+ea(g[n>>2]));Fb=ea(Jb+ea(g[ib>>2]));Ub=ea(Lb+ea(g[jb>>2]));aa=ea(ea(g[kb>>2])+ea(0.0));g[n>>2]=Ab;g[ib>>2]=Fb;g[jb>>2]=Ub;g[kb>>2]=aa;aa=ea(Kb+ea(g[o>>2]));Ub=ea(Jb+ea(g[ob>>2]));Fb=ea(Lb+ea(g[pb>>2]));Ab=ea(ea(g[qb>>2])+ea(0.0));g[o>>2]=aa;g[ob>>2]=Ub;g[pb>>2]=Fb;g[qb>>2]=Ab;Ab=ea(Kb+ea(g[p>>2]));Fb=ea(Jb+ea(g[ub>>2]));Ub=ea(Lb+ea(g[vb>>2]));aa=ea(ea(g[wb>>2])+ea(0.0));g[p>>2]=Ab;g[ub>>2]=Fb;g[vb>>2]=Ub;g[wb>>2]=aa;aa=ea(ea(ea(ea(Mb*Db)-ea(Nb*Sb))-ea(Pb*Ob))-ea(Rb*Qb));Ub=ea(ea(ea(ea(Nb*Ob)-ea(Rb*Db))-ea(Pb*Sb))-ea(Mb*Qb));Fb=ea(ea(ea(ea(Pb*Qb)-ea(Mb*Sb))-ea(Nb*Db))-ea(Rb*Ob));Ab=ea(ea(ea(ea(Rb*Sb)-ea(Pb*Db))-ea(Nb*Qb))-ea(Mb*Ob));Db=ea(ea(1.0)/ea(T(ea(ea(ea(Fb*Fb)+ea(Ab*Ab))+ea(ea(Ub*Ub)+ea(aa*aa))))));ka=ea(-ea(Db*Ab));Ab=ea(-ea(Db*aa));aa=ea(Db*Ub);g[fb>>2]=ea(-ea(Db*Fb));g[gb>>2]=ka;g[hb>>2]=Ab;g[fa>>2]=aa;aa=ea(g[lb>>2]);Ab=ea(Mb*aa);ka=ea(g[oa>>2]);Fb=ea(Nb*ka);Db=ea(g[mb>>2]);Ub=ea(Pb*Db);Eb=ea(g[nb>>2]);Tb=ea(ea(ea(Ab-ea(Nb*Eb))-ea(Pb*ka))-ea(Rb*Db));Ab=ea(ea(ea(Fb-ea(Rb*aa))-ea(Pb*Eb))-ea(Mb*Db));Fb=ea(ea(ea(Ub-ea(Mb*Eb))-ea(Nb*aa))-ea(Rb*ka));Ub=ea(ea(ea(ea(Rb*Eb)-ea(Pb*aa))-ea(Nb*Db))-ea(Mb*ka));ka=ea(ea(1.0)/ea(T(ea(ea(ea(Fb*Fb)+ea(Ub*Ub))+ea(ea(Ab*Ab)+ea(Tb*Tb))))));Db=ea(-ea(ka*Ub));Ub=ea(-ea(ka*Tb));Tb=ea(ka*Ab);g[lb>>2]=ea(-ea(ka*Fb));g[mb>>2]=Db;g[nb>>2]=Ub;g[oa>>2]=Tb;Tb=ea(g[rb>>2]);Ub=ea(Mb*Tb);Db=ea(g[ta>>2]);Fb=ea(Nb*Db);ka=ea(g[sb>>2]);Ab=ea(Pb*ka);aa=ea(g[tb>>2]);Eb=ea(ea(ea(Ub-ea(Nb*aa))-ea(Pb*Db))-ea(Rb*ka));Ub=ea(ea(ea(Fb-ea(Rb*Tb))-ea(Pb*aa))-ea(Mb*ka));Fb=ea(ea(ea(Ab-ea(Mb*aa))-ea(Nb*Tb))-ea(Rb*Db));Ab=ea(ea(ea(ea(Rb*aa)-ea(Pb*Tb))-ea(Nb*ka))-ea(Mb*Db));Db=ea(ea(1.0)/ea(T(ea(ea(ea(Fb*Fb)+ea(Ab*Ab))+ea(ea(Ub*Ub)+ea(Eb*Eb))))));ka=ea(-ea(Db*Ab));Ab=ea(-ea(Db*Eb));Eb=ea(Db*Ub);g[rb>>2]=ea(-ea(Db*Fb));g[sb>>2]=ka;g[tb>>2]=Ab;g[ta>>2]=Eb;Eb=ea(g[xb>>2]);Ab=ea(Mb*Eb);ka=ea(g[ya>>2]);Fb=ea(Nb*ka);Db=ea(g[yb>>2]);Ub=ea(Pb*Db);Tb=ea(g[zb>>2]);aa=ea(ea(ea(Ab-ea(Nb*Tb))-ea(Pb*ka))-ea(Rb*Db));Ab=ea(ea(ea(Fb-ea(Rb*Eb))-ea(Pb*Tb))-ea(Mb*Db));Fb=ea(ea(ea(Ub-ea(Mb*Tb))-ea(Nb*Eb))-ea(Rb*ka));Ub=ea(ea(ea(ea(Rb*Tb)-ea(Pb*Eb))-ea(Nb*Db))-ea(Mb*ka));ka=ea(ea(1.0)/ea(T(ea(ea(ea(Fb*Fb)+ea(Ub*Ub))+ea(ea(Ab*Ab)+ea(aa*aa))))));Db=ea(-ea(ka*Fb));Fb=ea(-ea(ka*Ub));Ub=ea(-ea(ka*aa));aa=ea(ka*Ab);g[xb>>2]=Db;g[yb>>2]=Fb;g[zb>>2]=Ub;g[ya>>2]=aa;if(!(a[b+1623>>0]|0)){Vb=aa;Wb=Ub;Xb=Fb;Yb=Db}else{Db=ea(g[fb>>2]);Fb=ea(g[gb>>2]);Ub=ea(g[hb>>2]);aa=ea(g[fa>>2]);g[lb>>2]=Db;g[mb>>2]=Fb;g[nb>>2]=Ub;g[oa>>2]=aa;g[rb>>2]=Db;g[sb>>2]=Fb;g[tb>>2]=Ub;g[ta>>2]=aa;g[xb>>2]=Db;g[yb>>2]=Fb;g[zb>>2]=Ub;g[ya>>2]=aa;Vb=aa;Wb=Ub;Xb=Fb;Yb=Db}if(a[b+1624>>0]|0){Db=ea(g[cb>>2]);g[ib>>2]=Db;g[ob>>2]=Db;g[ub>>2]=Db}if(!(a[b+1625>>0]|0)){Db=ea(g[p>>2]);Da=ub;Ea=vb;Fa=wb;Ga=xb;Ha=yb;Ia=zb;Ja=m;Ka=cb;La=db;Ma=eb;Na=fb;Oa=gb;Pa=hb;Qa=n;Ra=ib;Sa=jb;Ta=kb;Ua=lb;Va=mb;Wa=nb;Xa=p;Ya=Db;Za=ea(g[vb>>2]);_a=Yb;$a=Xb;ab=Wb;bb=Vb;break}else{Db=ea(g[m>>2]);g[n>>2]=Db;g[o>>2]=Db;g[p>>2]=Db;Fb=ea(g[db>>2]);g[jb>>2]=Fb;g[pb>>2]=Fb;g[vb>>2]=Fb;Da=ub;Ea=vb;Fa=wb;Ga=xb;Ha=yb;Ia=zb;Ja=m;Ka=cb;La=db;Ma=eb;Na=fb;Oa=gb;Pa=hb;Qa=n;Ra=ib;Sa=jb;Ta=kb;Ua=lb;Va=mb;Wa=nb;Xa=p;Ya=Db;Za=Fb;_a=Yb;$a=Xb;ab=Wb;bb=Vb;break}}else{pZd(q,b);Fb=ea(g[q>>2]);Db=ea(g[q+4>>2]);Ub=ea(g[q+8>>2]);aa=ea(g[q+12>>2]);g[m>>2]=Fb;nb=m+4|0;g[nb>>2]=Db;mb=m+8|0;g[mb>>2]=Ub;lb=m+12|0;g[lb>>2]=aa;aa=ea(g[q+16>>2]);Ub=ea(g[q+20>>2]);Db=ea(g[q+24>>2]);Fb=ea(g[q+28>>2]);kb=m+16|0;g[kb>>2]=aa;jb=m+20|0;g[jb>>2]=Ub;ib=m+24|0;g[ib>>2]=Db;g[fa>>2]=Fb;Fb=ea(g[q+32>>2]);Db=ea(g[q+36>>2]);Ub=ea(g[q+40>>2]);aa=ea(g[q+44>>2]);g[na>>2]=Fb;g[ma>>2]=Db;g[la>>2]=Ub;g[ha>>2]=aa;qZd(r,b);aa=ea(g[r>>2]);Ub=ea(g[r+4>>2]);Db=ea(g[r+8>>2]);Fb=ea(g[r+12>>2]);g[n>>2]=aa;hb=n+4|0;g[hb>>2]=Ub;gb=n+8|0;g[gb>>2]=Db;fb=n+12|0;g[fb>>2]=Fb;Fb=ea(g[r+16>>2]);Db=ea(g[r+20>>2]);Ub=ea(g[r+24>>2]);aa=ea(g[r+28>>2]);eb=n+16|0;g[eb>>2]=Fb;db=n+20|0;g[db>>2]=Db;cb=n+24|0;g[cb>>2]=Ub;g[oa>>2]=aa;aa=ea(g[r+32>>2]);Ub=ea(g[r+36>>2]);Db=ea(g[r+40>>2]);Fb=ea(g[r+44>>2]);g[sa>>2]=aa;g[ra>>2]=Ub;g[qa>>2]=Db;g[pa>>2]=Fb;mZd(s,b,f,ia);Fb=ea(g[s>>2]);Db=ea(g[s+4>>2]);Ub=ea(g[s+8>>2]);aa=ea(g[s+12>>2]);g[o>>2]=Fb;g[o+4>>2]=Db;g[o+8>>2]=Ub;g[o+12>>2]=aa;aa=ea(g[s+16>>2]);Ub=ea(g[s+20>>2]);Db=ea(g[s+24>>2]);Fb=ea(g[s+28>>2]);g[o+16>>2]=aa;g[o+20>>2]=Ub;g[o+24>>2]=Db;g[ta>>2]=Fb;Fb=ea(g[s+32>>2]);Db=ea(g[s+36>>2]);Ub=ea(g[s+40>>2]);aa=ea(g[s+44>>2]);g[xa>>2]=Fb;g[wa>>2]=Db;g[va>>2]=Ub;g[ua>>2]=aa;mZd(t,b,f,ja);aa=ea(g[t>>2]);Ub=ea(g[t+4>>2]);Db=ea(g[t+8>>2]);Fb=ea(g[t+12>>2]);g[p>>2]=aa;zb=p+4|0;g[zb>>2]=Ub;yb=p+8|0;g[yb>>2]=Db;xb=p+12|0;g[xb>>2]=Fb;Fb=ea(g[t+16>>2]);Ub=ea(g[t+20>>2]);Ab=ea(g[t+24>>2]);ka=ea(g[t+28>>2]);wb=p+16|0;g[wb>>2]=Fb;vb=p+20|0;g[vb>>2]=Ub;ub=p+24|0;g[ub>>2]=Ab;g[ya>>2]=ka;Eb=ea(g[t+32>>2]);Tb=ea(g[t+36>>2]);X=ea(g[t+40>>2]);Ib=ea(g[t+44>>2]);g[Ca>>2]=Eb;g[Ba>>2]=Tb;g[Aa>>2]=X;g[za>>2]=Ib;Da=zb;Ea=yb;Fa=xb;Ga=wb;Ha=vb;Ia=ub;Ja=m;Ka=nb;La=mb;Ma=lb;Na=kb;Oa=jb;Pa=ib;Qa=n;Ra=hb;Sa=gb;Ta=fb;Ua=eb;Va=db;Wa=cb;Xa=p;Ya=aa;Za=Db;_a=Fb;$a=Ub;ab=Ab;bb=ka}while(0);ja=ea(g[Da>>2]);ia=ea(g[Fa>>2]);g[J>>2]=Ya;g[K>>2]=ja;g[L>>2]=Za;g[M>>2]=ia;g[N>>2]=_a;g[O>>2]=$a;g[P>>2]=ab;g[Q>>2]=bb;bb=ea(g[Ca>>2]);ab=ea(g[Ba>>2]);$a=ea(g[Aa>>2]);_a=ea(g[za>>2]);g[R>>2]=bb;g[U>>2]=ab;g[V>>2]=$a;g[W>>2]=_a;_a=ea(g[Ja>>2]);$a=ea(g[Ka>>2]);ab=ea(g[La>>2]);bb=ea(g[Ma>>2]);g[e+132>>2]=_a;g[e+136>>2]=$a;g[e+140>>2]=ab;g[e+144>>2]=bb;ia=ea(g[Na>>2]);Za=ea(g[Oa>>2]);ja=ea(g[Pa>>2]);Ya=ea(g[fa>>2]);g[e+148>>2]=ia;g[e+152>>2]=Za;g[e+156>>2]=ja;g[e+160>>2]=Ya;Vb=ea(g[na>>2]);Wb=ea(g[ma>>2]);Xb=ea(g[la>>2]);Yb=ea(g[ha>>2]);g[e+164>>2]=Vb;g[e+168>>2]=Wb;g[e+172>>2]=Xb;g[e+176>>2]=Yb;Mb=ea(g[Qa>>2]);Nb=ea(g[Ra>>2]);Pb=ea(g[Sa>>2]);Rb=ea(g[Ta>>2]);g[e+180>>2]=Mb;g[e+184>>2]=Nb;g[e+188>>2]=Pb;g[e+192>>2]=Rb;Ob=ea(g[Ua>>2]);Qb=ea(g[Va>>2]);Sb=ea(g[Wa>>2]);Lb=ea(g[oa>>2]);g[e+196>>2]=Ob;g[e+200>>2]=Qb;g[e+204>>2]=Sb;g[e+208>>2]=Lb;Jb=ea(g[sa>>2]);Kb=ea(g[ra>>2]);ka=ea(g[qa>>2]);Ab=ea(g[pa>>2]);g[e+212>>2]=Jb;g[e+216>>2]=Kb;g[e+220>>2]=ka;g[e+224>>2]=Ab;if(!(a[da>>0]|0)){Ub=ea(g[_>>2]);if(Ub!=ea(g[d>>2])){Ub=ea(-ea(g[o+16>>2]));Fb=ea(-ea(g[o+20>>2]));Db=ea(-ea(g[o+24>>2]));aa=ea(g[ta>>2]);Ib=ea(g[Xa>>2]);X=ea(Ib-ea(g[o>>2]));Ib=ea(g[Da>>2]);Tb=ea(Ib-ea(g[o+4>>2]));Ib=ea(g[Ea>>2]);Eb=ea(Ib-ea(g[o+8>>2]));Ib=ea(g[Fa>>2]);Hb=ea(X+X);Gb=ea(Tb+Tb);Y=ea(Eb+Eb);Bb=ea(aa*ea(0.0));Cb=ea(ea(Gb*Ub)-ea(Hb*Fb));ca=ea(ea(Y*Fb)-ea(Gb*Db));Gb=ea(ea(Hb*Db)-ea(Y*Ub));Y=ea(aa*ea(Bb-Bb));Bb=ea(ea(X+ea(aa*ca))+ea(ea(Cb*Fb)-ea(Gb*Db)));X=ea(ea(Tb+ea(aa*Gb))+ea(ea(ca*Db)-ea(Cb*Ub)));Tb=ea(ea(Eb+ea(aa*Cb))+ea(ea(Gb*Ub)-ea(ca*Fb)));ca=ea(ea(Y-Y)+ea(Y+ea(Ib-ea(g[o+12>>2]))));Ib=ea(g[Ga>>2]);Y=ea(Ib*Fb);Gb=ea(g[ya>>2]);Cb=ea(aa*Gb);Eb=ea(g[Ha>>2]);Hb=ea(Eb*Db);Zb=ea(g[Ia>>2]);_b=ea(ea(ea(Y-ea(aa*Zb))-ea(Gb*Db))-ea(Eb*Ub));Y=ea(ea(ea(Cb-ea(Ib*Ub))-ea(Zb*Db))-ea(Eb*Fb));Cb=ea(ea(ea(Hb-ea(Zb*Fb))-ea(aa*Ib))-ea(Gb*Ub));Hb=ea(ea(ea(ea(Zb*Ub)-ea(Ib*Db))-ea(aa*Eb))-ea(Gb*Fb));Fb=ea(ea(1.0)/ea(T(ea(ea(ea(Cb*Cb)+ea(Hb*Hb))+ea(ea(Y*Y)+ea(_b*_b))))));$b=ea(Fb*Y);ac=ea(-ea(Fb*Cb));bc=ea(-ea(Fb*Hb));cc=ea(-ea(Fb*_b));dc=X;ec=Tb;fc=Bb;gc=ca}else{$b=ea(1.0);ac=ea(0.0);bc=ea(0.0);cc=ea(0.0);dc=ea(0.0);ec=ea(0.0);fc=ea(0.0);gc=ea(0.0)}}else{ca=ea(g[l>>2]);Bb=ea(ca-ea(g[j>>2]));j=Bb<ea(0.0);if(j^ea(g[ga>>2])<ea(0.0)){g[Ja>>2]=Mb;g[Ka>>2]=Nb;g[La>>2]=Pb;g[Ma>>2]=Rb;g[Na>>2]=Ob;g[Oa>>2]=Qb;g[Pa>>2]=Sb;g[fa>>2]=Lb;g[na>>2]=Jb;g[ma>>2]=Kb;g[la>>2]=ka;g[ha>>2]=Ab;g[Qa>>2]=_a;g[Ra>>2]=$a;g[Sa>>2]=ab;g[Ta>>2]=bb;g[Ua>>2]=ia;g[Va>>2]=Za;g[Wa>>2]=ja;g[oa>>2]=Ya;g[sa>>2]=Vb;g[ra>>2]=Wb;g[qa>>2]=Xb;g[pa>>2]=Yb}vZd(y,p,o,m,n,~~ea(S(ea(Bb))));Bb=ea(g[y>>2]);Yb=ea(g[y+4>>2]);Xb=ea(g[y+8>>2]);Wb=ea(g[y+12>>2]);Vb=ea(g[y+16>>2]);Ya=ea(g[y+20>>2]);ja=ea(g[y+24>>2]);$b=ea(g[y+28>>2]);ac=Vb;bc=Ya;cc=ja;dc=Yb;ec=Xb;fc=Bb;gc=Wb}y=$b==ea(0.0);Wb=y?ea(9.99999997e-07):$b;$b=ea(ac/Wb);ac=ea(bc/Wb);bc=ea(cc/Wb);if(A){Wb=(a[b+1624>>0]|0)==0?dc:ea(0.0);A=(a[b+1625>>0]|0)==0;cc=A?ec:ea(0.0);Bb=A?fc:ea(0.0);hc=ea(0.0);ic=(a[b+1623>>0]|0)==0?ac:ea(0.0);jc=ea(0.0);kc=Bb;lc=Wb;mc=cc}else{hc=$b;ic=ac;jc=bc;kc=fc;lc=dc;mc=ec}ec=ea(ea(1.0)/ea(T(ea(ea(ea(jc*jc)+ea(1.0))+ea(ea(ic*ic)+ea(hc*hc))))));dc=ea(hc*ec);hc=ea(ic*ec);ic=ea(jc*ec);jc=ea(g[ga>>2]);if(jc!=ea(0.0)){fc=ea(g[d>>2]);bc=ea(fc-ea(g[_>>2]));fc=ea(g[ba>>2]);nc=ea(ea(bc*ea(fc-ea(g[$>>2])))/ea(S(ea(jc))))}else nc=ea(0.0);g[e>>2]=nc;jc=ea(kc/nc);kc=ea(lc/nc);lc=ea(mc/nc);mc=ea(gc/nc);e=nc!=ea(0.0);gc=e?jc:ea(0.0);jc=e?kc:ea(0.0);kc=e?lc:ea(0.0);lc=e?mc:ea(0.0);g[B>>2]=gc;g[C>>2]=jc;g[D>>2]=kc;g[E>>2]=lc;lc=ea(ea(1.0)/ea(T(ea(ea(ea(dc*dc)+ea(hc*hc))+ea(ea(ec*ec)+ea(ic*ic))))));ec=ea(dc*lc);dc=ea(hc*lc);hc=ea(ic*lc);lc=ea(T(ea(ea(ea(ec*ec)+ea(dc*dc))+ea(ea(hc*hc)+ea(0.0)))));ic=ea(ea(+Z(+lc))*ea(2.0));kc=ea(ea(ec*ic)/lc);ec=ea(ea(dc*ic)/lc);dc=ea(ea(hc*ic)/lc);E=lc!=ea(0.0);lc=E?kc:ea(0.0);kc=E?ec:ea(0.0);ec=ea(lc/nc);lc=ea(kc/nc);kc=ea((E?dc:ea(0.0))/nc);dc=ea(ea(0.0)/nc);nc=e?ec:ea(0.0);ec=e?lc:ea(0.0);lc=e?kc:ea(0.0);kc=e?dc:ea(0.0);g[F>>2]=nc;g[G>>2]=ec;g[H>>2]=lc;g[I>>2]=kc;i=h;return}function xZd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=Im;h=i;i=i+208|0;j=h+144|0;l=h+96|0;m=h+48|0;n=h;o=ea(g[d+4>>2]);p=ea(g[b+1048>>2]);q=ea(g[b+1052>>2]);r=ea(g[b+1064>>2]);s=ea(r+ea(g[d+24>>2]));t=(a[b+1621>>0]|0)!=0;u=ea(g[d+16>>2])<ea(0.0);r=ea(VDi(ea(1.0),ea(UDi(ea(0.0),o))));v=ea(cEi(ea(o+s),h+192|0));s=t?v:r;r=ea(ea(1.0)-s);t=(g[k>>2]=r,c[k>>2]|0);r=ea(p+ea(ea(q-p)*(c[k>>2]=(u?t:0)|(g[k>>2]=s,c[k>>2]|0)&0-(u&1^1),ea(g[k>>2]))));mZd(j,b,f,r);s=ea(g[j>>2]);p=ea(g[j+4>>2]);q=ea(g[j+8>>2]);v=ea(g[j+12>>2]);g[e+36>>2]=s;g[e+40>>2]=p;g[e+44>>2]=q;g[e+48>>2]=v;v=ea(g[j+16>>2]);q=ea(g[j+20>>2]);p=ea(g[j+24>>2]);s=ea(g[j+28>>2]);g[e+52>>2]=v;g[e+56>>2]=q;g[e+60>>2]=p;g[e+64>>2]=s;s=ea(g[j+32>>2]);p=ea(g[j+36>>2]);q=ea(g[j+40>>2]);v=ea(g[j+44>>2]);g[e+68>>2]=s;g[e+72>>2]=p;g[e+76>>2]=q;g[e+80>>2]=v;nZd(l,b,f,r);v=ea(g[l>>2]);q=ea(g[l+4>>2]);p=ea(g[l+8>>2]);s=ea(g[l+12>>2]);g[e+228>>2]=v;g[e+232>>2]=q;g[e+236>>2]=p;g[e+240>>2]=s;s=ea(g[l+16>>2]);p=ea(g[l+20>>2]);q=ea(g[l+24>>2]);v=ea(g[l+28>>2]);g[e+244>>2]=s;g[e+248>>2]=p;g[e+252>>2]=q;g[e+256>>2]=v;v=ea(g[l+32>>2]);q=ea(g[l+36>>2]);p=ea(g[l+40>>2]);s=ea(g[l+44>>2]);g[e+260>>2]=v;g[e+264>>2]=q;g[e+268>>2]=p;g[e+272>>2]=s;oZd(m,b,f,r,0);s=ea(g[m>>2]);p=ea(g[m+4>>2]);q=ea(g[m+8>>2]);v=ea(g[m+12>>2]);g[e+276>>2]=s;g[e+280>>2]=p;g[e+284>>2]=q;g[e+288>>2]=v;v=ea(g[m+16>>2]);q=ea(g[m+20>>2]);p=ea(g[m+24>>2]);s=ea(g[m+28>>2]);g[e+292>>2]=v;g[e+296>>2]=q;g[e+300>>2]=p;g[e+304>>2]=s;s=ea(g[m+32>>2]);p=ea(g[m+36>>2]);q=ea(g[m+40>>2]);v=ea(g[m+44>>2]);g[e+308>>2]=s;g[e+312>>2]=p;g[e+316>>2]=q;g[e+320>>2]=v;oZd(n,b,f,r,1);r=ea(g[n>>2]);v=ea(g[n+4>>2]);q=ea(g[n+8>>2]);p=ea(g[n+12>>2]);g[e+324>>2]=r;g[e+328>>2]=v;g[e+332>>2]=q;g[e+336>>2]=p;p=ea(g[n+16>>2]);q=ea(g[n+20>>2]);v=ea(g[n+24>>2]);r=ea(g[n+28>>2]);g[e+340>>2]=p;g[e+344>>2]=q;g[e+348>>2]=v;g[e+352>>2]=r;r=ea(g[n+32>>2]);v=ea(g[n+36>>2]);q=ea(g[n+40>>2]);p=ea(g[n+44>>2]);g[e+356>>2]=r;g[e+360>>2]=v;g[e+364>>2]=q;g[e+368>>2]=p;i=h;return}function yZd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=Im,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=Im,cd=Im,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=Im,md=Im,nd=Im,od=Im,pd=Im,qd=Im,rd=Im,sd=Im,td=Im,ud=Im,vd=Im,wd=Im,xd=Im,yd=Im,zd=Im,Ad=Im,Bd=Im,Cd=Im,Dd=Im,Ed=Im,Fd=Im,Gd=0,Hd=0,Id=Im,Jd=Im,Kd=Im,Ld=Im,Md=Im,Nd=Im,Od=Im,Pd=Im,Qd=Im,Rd=Im,Sd=Im,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=Im,le=Im,me=Im,ne=Im,oe=Im,pe=Im,qe=Im,re=Im,se=Im,te=Im,ue=Im,ve=Im,we=Im,xe=Im,ye=Im,ze=Im,Ae=Im,Be=0,Ce=Im,De=Im,Ee=Im,Fe=Im,Ge=Im,He=Im,Ie=Im,Je=Im,Ke=0,Le=Im,Me=Im,Ne=Im,Oe=Im,Pe=0,Qe=0,Re=0,Se=0,Te=Im,Ue=Im,Ve=Im,We=Im,Xe=Im,Ye=Im,Ze=Im,_e=Im,$e=Im,af=Im,bf=Im,cf=Im,df=Im,ef=Im,ff=Im,gf=Im,hf=Im,jf=Im,kf=Im,lf=Im,mf=Im,nf=Im,of=Im,pf=Im,qf=Im,rf=Im,sf=Im,tf=0,uf=Im,vf=Im,wf=Im,xf=Im,yf=Im,zf=Im,Af=Im,Bf=Im,Cf=Im,Df=Im,Ef=Im,Ff=0,Gf=0,Hf=0,If=0;l=i;i=i+3312|0;m=l+1168|0;n=l+1112|0;o=l+2776|0;p=l+144|0;q=l+2968|0;r=l+3160|0;s=l+240|0;t=l+288|0;u=l+336|0;v=l+384|0;w=l+432|0;x=l+480|0;y=l+528|0;z=l+576|0;A=l+624|0;B=l+672|0;C=l+720|0;D=l+768|0;E=l+816|0;F=l+864|0;G=l+912|0;H=l+960|0;I=l+2824|0;J=l+2920|0;K=l+3016|0;L=l+3112|0;M=l+3208|0;N=l+3256|0;O=l+1176|0;P=l+1224|0;Q=l+2104|0;R=l+2152|0;U=l+2200|0;V=l+2248|0;W=l+2296|0;X=l+2344|0;Y=l+2392|0;_=l+2440|0;$=l+2488|0;aa=l+2536|0;ba=l+2584|0;ca=l+2632|0;da=l+2680|0;fa=l+2728|0;ga=l+192|0;ha=l+48|0;ia=l+96|0;ja=l;ka=l+968|0;la=l+1016|0;ma=l+2872|0;na=l+1064|0;oa=l+3064|0;pa=l+1120|0;qa=ea(g[b+1064>>2]);ra=ea(qa+ea(g[d+24>>2]));sa=d+4|0;qa=ea(g[sa>>2]);ta=b+1048|0;ua=b+1052|0;va=b+1621|0;wa=(a[va>>0]|0)!=0;xa=d+16|0;ya=ea(g[xa>>2])<ea(0.0);za=ea(VDi(ea(1.0),ea(UDi(ea(0.0),qa))));Aa=ea(cEi(ea(qa+ra),m));qa=wa?Aa:za;za=ea(ea(1.0)-qa);wa=(g[k>>2]=za,c[k>>2]|0);za=(c[k>>2]=(ya?wa:0)|(g[k>>2]=qa,c[k>>2]|0)&0-(ya&1^1),ea(g[k>>2]));qa=ea(g[d>>2]);Aa=ea(g[ta>>2]);Ba=ea(g[ua>>2]);ya=(a[va>>0]|0)!=0;wa=ea(g[xa>>2])<ea(0.0);Ca=ea(VDi(ea(1.0),ea(UDi(ea(0.0),qa))));Da=ea(cEi(ea(ra+qa),n));qa=ya?Da:Ca;Ca=ea(ea(1.0)-qa);ya=(g[k>>2]=Ca,c[k>>2]|0);Ca=(c[k>>2]=(wa?ya:0)|(g[k>>2]=qa,c[k>>2]|0)&0-(wa&1^1),ea(g[k>>2]));qa=ea(Aa+ea(ea(Ba-Aa)*Ca));if((((((c[b+1072>>2]|0)==-1?(c[b+1076>>2]|0)==-1:0)?(c[b+1080>>2]|0)==-1:0)?(c[b+1084>>2]|0)==-1:0)?(c[b+1088>>2]|0)==-1:0)?(c[b+1092>>2]|0)==-1:0)Ea=(c[b+1096>>2]|0)!=-1;else Ea=1;wa=(a[d+20>>0]|0)==0;ya=(a[b+1620>>0]|0)==0?wa^1:wa;wa=b+880|0;HZd(o,wa,b);Aa=ea(g[f+228>>2]);Ba=ea(g[f+232>>2]);Da=ea(g[f+236>>2]);Fa=ea(g[f+240>>2]);g[p>>2]=Aa;Ga=p+4|0;g[Ga>>2]=Ba;Ha=p+8|0;g[Ha>>2]=Da;Ia=p+12|0;g[Ia>>2]=Fa;Fa=ea(g[f+244>>2]);Da=ea(g[f+248>>2]);Ba=ea(g[f+252>>2]);Aa=ea(g[f+256>>2]);Ja=p+16|0;g[Ja>>2]=Fa;Ka=p+20|0;g[Ka>>2]=Da;La=p+24|0;g[La>>2]=Ba;Ma=p+28|0;g[Ma>>2]=Aa;Aa=ea(g[f+260>>2]);Ba=ea(g[f+264>>2]);Da=ea(g[f+268>>2]);Fa=ea(g[f+272>>2]);Na=p+32|0;g[Na>>2]=Aa;Oa=p+36|0;g[Oa>>2]=Ba;Pa=p+40|0;g[Pa>>2]=Da;Qa=p+44|0;g[Qa>>2]=Fa;Ra=f+276|0;Fa=ea(g[Ra>>2]);Sa=f+280|0;Da=ea(g[Sa>>2]);Ta=f+284|0;Ba=ea(g[Ta>>2]);Ua=f+288|0;Aa=ea(g[Ua>>2]);g[q>>2]=Fa;Va=q+4|0;g[Va>>2]=Da;Wa=q+8|0;g[Wa>>2]=Ba;Xa=q+12|0;g[Xa>>2]=Aa;Ya=f+292|0;Aa=ea(g[Ya>>2]);Za=f+296|0;Ba=ea(g[Za>>2]);_a=f+300|0;Da=ea(g[_a>>2]);$a=f+304|0;Fa=ea(g[$a>>2]);ab=q+16|0;g[ab>>2]=Aa;bb=q+20|0;g[bb>>2]=Ba;cb=q+24|0;g[cb>>2]=Da;db=q+28|0;g[db>>2]=Fa;eb=f+308|0;Fa=ea(g[eb>>2]);fb=f+312|0;Da=ea(g[fb>>2]);gb=f+316|0;Ba=ea(g[gb>>2]);hb=f+320|0;Aa=ea(g[hb>>2]);ib=q+32|0;g[ib>>2]=Fa;jb=q+36|0;g[jb>>2]=Da;kb=q+40|0;g[kb>>2]=Ba;lb=q+44|0;g[lb>>2]=Aa;mb=f+324|0;Aa=ea(g[mb>>2]);nb=f+328|0;Ba=ea(g[nb>>2]);ob=f+332|0;Da=ea(g[ob>>2]);pb=f+336|0;Fa=ea(g[pb>>2]);g[r>>2]=Aa;qb=r+4|0;g[qb>>2]=Ba;rb=r+8|0;g[rb>>2]=Da;sb=r+12|0;g[sb>>2]=Fa;tb=f+340|0;Fa=ea(g[tb>>2]);ub=f+344|0;Da=ea(g[ub>>2]);vb=f+348|0;Ba=ea(g[vb>>2]);wb=f+352|0;Aa=ea(g[wb>>2]);xb=r+16|0;g[xb>>2]=Fa;yb=r+20|0;g[yb>>2]=Da;zb=r+24|0;g[zb>>2]=Ba;Ab=r+28|0;g[Ab>>2]=Aa;Bb=f+356|0;Aa=ea(g[Bb>>2]);Cb=f+360|0;Ba=ea(g[Cb>>2]);Db=f+364|0;Da=ea(g[Db>>2]);Eb=f+368|0;Fa=ea(g[Eb>>2]);Fb=r+32|0;g[Fb>>2]=Aa;Gb=r+36|0;g[Gb>>2]=Ba;Hb=r+40|0;g[Hb>>2]=Da;Ib=r+44|0;g[Ib>>2]=Fa;DZd(b,e,h);Fa=ea(g[h>>2]);e=h+4|0;Da=ea(g[e>>2]);Jb=h+8|0;Ba=ea(g[Jb>>2]);Kb=h+12|0;Aa=ea(g[Kb>>2]);g[s>>2]=Fa;Lb=s+4|0;g[Lb>>2]=Da;Mb=s+8|0;g[Mb>>2]=Ba;Nb=s+12|0;g[Nb>>2]=Aa;Ob=h+16|0;Aa=ea(g[Ob>>2]);Pb=h+20|0;Ba=ea(g[Pb>>2]);Qb=h+24|0;Da=ea(g[Qb>>2]);Rb=h+28|0;Fa=ea(g[Rb>>2]);Sb=s+16|0;g[Sb>>2]=Aa;Tb=s+20|0;g[Tb>>2]=Ba;Ub=s+24|0;g[Ub>>2]=Da;Vb=s+28|0;g[Vb>>2]=Fa;Wb=h+32|0;Fa=ea(g[Wb>>2]);Xb=h+36|0;Da=ea(g[Xb>>2]);Yb=h+40|0;Ba=ea(g[Yb>>2]);Zb=h+44|0;Aa=ea(g[Zb>>2]);_b=s+32|0;g[_b>>2]=Fa;$b=s+36|0;g[$b>>2]=Da;ac=s+40|0;g[ac>>2]=Ba;bc=s+44|0;g[bc>>2]=Aa;cc=t+28|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t+20>>2]=0;c[t+24>>2]=0;g[cc>>2]=ea(1.0);dc=t+44|0;g[dc>>2]=ea(1.0);ec=t+40|0;g[ec>>2]=ea(1.0);fc=t+36|0;g[fc>>2]=ea(1.0);gc=t+32|0;g[gc>>2]=ea(1.0);hc=u+28|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;c[u+24>>2]=0;g[hc>>2]=ea(1.0);ic=u+44|0;g[ic>>2]=ea(1.0);jc=u+40|0;g[jc>>2]=ea(1.0);kc=u+36|0;g[kc>>2]=ea(1.0);lc=u+32|0;g[lc>>2]=ea(1.0);mc=v+28|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v+20>>2]=0;c[v+24>>2]=0;g[mc>>2]=ea(1.0);nc=v+44|0;g[nc>>2]=ea(1.0);oc=v+40|0;g[oc>>2]=ea(1.0);pc=v+36|0;g[pc>>2]=ea(1.0);qc=v+32|0;g[qc>>2]=ea(1.0);rc=w+28|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;c[w+24>>2]=0;g[rc>>2]=ea(1.0);sc=w+44|0;g[sc>>2]=ea(1.0);tc=w+40|0;g[tc>>2]=ea(1.0);uc=w+36|0;g[uc>>2]=ea(1.0);vc=w+32|0;g[vc>>2]=ea(1.0);if(!Ea){Aa=ea(g[b+908>>2]);Ba=ea(g[b+896>>2]);Da=ea(Aa*Ba);Fa=ea(g[b+900>>2]);wc=ea(Aa*Fa);xc=ea(g[b+904>>2]);yc=ea(ea(Ba*Fa)-ea(Aa*xc));zc=ea(ea(ea(Aa*Aa)+ea(-.5))+ea(Fa*Fa));Ac=ea(Da+ea(Fa*xc));Da=ea(wc-wc);wc=ea(yc+yc);yc=ea(zc+zc);zc=ea(Ac+Ac);Ac=ea(Da+Da);Da=ea(yc*ea(0.0));Bc=ea(zc*ea(0.0));Cc=ea(wc*ea(0.0));Dc=ea(wc-Da);Ec=ea(Da-zc);Da=ea(Bc-Cc);Fc=ea(ea(T(ea(ea(ea(yc*yc)+ea(wc*wc))+ea(ea(Ac*Ac)+ea(zc*zc)))))+ea(ea(yc+Cc)+ea(ea(Ac*ea(0.0))+Bc)));Bc=ea(ea(ea(ea(Aa*Fc)-ea(Ba*Ec))-ea(xc*Dc))-ea(Fa*Da));Ac=ea(ea(ea(ea(xc*Ec)-ea(Ba*Dc))-ea(Fa*Fc))-ea(Aa*Da));Cc=ea(ea(ea(ea(ea(Fa*Dc)-ea(xc*Da))-ea(Ba*Fc))-ea(Aa*Ec))*ea(-0.0));yc=ea(ea(ea(ea(ea(Ba*Da)-ea(xc*Fc))-ea(Aa*Dc))-ea(Fa*Ec))*ea(-0.0));Ec=ea(ea(1.0)/ea(T(ea(ea(ea(Ac*Ac)+ea(Cc*Cc))+ea(ea(Bc*Bc)+ea(yc*yc))))));Fa=ea(Ec*Cc);Cc=ea(-ea(Ec*Ac));Ac=ea(Ec*yc);yc=ea(Ec*Bc);Bc=ea(g[wa>>2]);Ec=ea(g[b+884>>2]);Dc=ea(g[b+888>>2]);Aa=ea(g[b+892>>2]);Fc=ea(g[b+912>>2]);xc=ea(g[b+916>>2]);Da=ea(g[b+920>>2]);Ba=ea(g[b+924>>2]);g[t>>2]=Bc;g[t+4>>2]=Ec;g[t+8>>2]=Dc;g[t+12>>2]=Aa;g[t+16>>2]=Fa;g[t+20>>2]=Cc;g[t+24>>2]=Ac;g[cc>>2]=yc;g[gc>>2]=Fc;g[fc>>2]=xc;g[ec>>2]=Da;g[dc>>2]=Ba;Gc=o+28|0;Ba=ea(g[Gc>>2]);Hc=o+16|0;Da=ea(g[Hc>>2]);xc=ea(Ba*Da);Ic=o+20|0;Fc=ea(g[Ic>>2]);yc=ea(Ba*Fc);Jc=o+24|0;Ac=ea(g[Jc>>2]);Cc=ea(ea(Da*Fc)-ea(Ba*Ac));Fa=ea(ea(ea(Ba*Ba)+ea(-.5))+ea(Fc*Fc));Aa=ea(xc+ea(Fc*Ac));xc=ea(yc-yc);yc=ea(Cc+Cc);Cc=ea(Fa+Fa);Fa=ea(Aa+Aa);Aa=ea(xc+xc);xc=ea(Cc*ea(0.0));Dc=ea(Fa*ea(0.0));Ec=ea(yc*ea(0.0));Bc=ea(yc-xc);zc=ea(xc-Fa);xc=ea(Dc-Ec);wc=ea(ea(T(ea(ea(ea(Cc*Cc)+ea(yc*yc))+ea(ea(Aa*Aa)+ea(Fa*Fa)))))+ea(ea(Cc+Ec)+ea(ea(Aa*ea(0.0))+Dc)));Dc=ea(ea(ea(ea(Ba*wc)-ea(Da*zc))-ea(Ac*Bc))-ea(Fc*xc));Aa=ea(ea(ea(ea(Ac*zc)-ea(Da*Bc))-ea(Fc*wc))-ea(Ba*xc));Ec=ea(ea(ea(ea(ea(Fc*Bc)-ea(Ac*xc))-ea(Da*wc))-ea(Ba*zc))*ea(-0.0));Cc=ea(ea(ea(ea(ea(Da*xc)-ea(Ac*wc))-ea(Ba*Bc))-ea(Fc*zc))*ea(-0.0));zc=ea(ea(1.0)/ea(T(ea(ea(ea(Aa*Aa)+ea(Ec*Ec))+ea(ea(Dc*Dc)+ea(Cc*Cc))))));Fc=ea(zc*Ec);Ec=ea(-ea(zc*Aa));Aa=ea(zc*Cc);Cc=ea(zc*Dc);Dc=ea(g[o>>2]);Kc=o+4|0;zc=ea(g[Kc>>2]);Lc=o+8|0;Bc=ea(g[Lc>>2]);Mc=o+12|0;Ba=ea(g[Mc>>2]);Nc=o+32|0;wc=ea(g[Nc>>2]);Oc=o+36|0;Ac=ea(g[Oc>>2]);Pc=o+40|0;xc=ea(g[Pc>>2]);Qc=o+44|0;Da=ea(g[Qc>>2]);g[u>>2]=Dc;g[u+4>>2]=zc;g[u+8>>2]=Bc;g[u+12>>2]=Ba;g[u+16>>2]=Fc;g[u+20>>2]=Ec;g[u+24>>2]=Aa;g[hc>>2]=Cc;g[lc>>2]=wc;g[kc>>2]=Ac;g[jc>>2]=xc;g[ic>>2]=Da;Da=ea(g[Ma>>2]);xc=ea(g[Ja>>2]);Ac=ea(Da*xc);wc=ea(g[Ka>>2]);Cc=ea(Da*wc);Aa=ea(g[La>>2]);Ec=ea(ea(xc*wc)-ea(Da*Aa));Fc=ea(ea(ea(Da*Da)+ea(-.5))+ea(wc*wc));Ba=ea(Ac+ea(wc*Aa));Ac=ea(Cc-Cc);Cc=ea(Ec+Ec);Ec=ea(Fc+Fc);Fc=ea(Ba+Ba);Ba=ea(Ac+Ac);Ac=ea(Ec*ea(0.0));Bc=ea(Fc*ea(0.0));zc=ea(Cc*ea(0.0));Dc=ea(Cc-Ac);Fa=ea(Ac-Fc);Ac=ea(Bc-zc);yc=ea(ea(T(ea(ea(ea(Ec*Ec)+ea(Cc*Cc))+ea(ea(Ba*Ba)+ea(Fc*Fc)))))+ea(ea(Ec+zc)+ea(ea(Ba*ea(0.0))+Bc)));Bc=ea(ea(ea(ea(Da*yc)-ea(xc*Fa))-ea(Aa*Dc))-ea(wc*Ac));Ba=ea(ea(ea(ea(Aa*Fa)-ea(xc*Dc))-ea(wc*yc))-ea(Da*Ac));zc=ea(ea(ea(ea(ea(wc*Dc)-ea(Aa*Ac))-ea(xc*yc))-ea(Da*Fa))*ea(-0.0));Ec=ea(ea(ea(ea(ea(xc*Ac)-ea(Aa*yc))-ea(Da*Dc))-ea(wc*Fa))*ea(-0.0));Fa=ea(ea(1.0)/ea(T(ea(ea(ea(Ba*Ba)+ea(zc*zc))+ea(ea(Bc*Bc)+ea(Ec*Ec))))));wc=ea(Fa*zc);zc=ea(-ea(Fa*Ba));Ba=ea(Fa*Ec);Ec=ea(Fa*Bc);Bc=ea(g[p>>2]);Fa=ea(g[Ga>>2]);Dc=ea(g[Ha>>2]);Da=ea(g[Ia>>2]);yc=ea(g[Na>>2]);Aa=ea(g[Oa>>2]);Ac=ea(g[Pa>>2]);xc=ea(g[Qa>>2]);g[v>>2]=Bc;g[v+4>>2]=Fa;g[v+8>>2]=Dc;g[v+12>>2]=Da;g[v+16>>2]=wc;g[v+20>>2]=zc;g[v+24>>2]=Ba;g[mc>>2]=Ec;g[qc>>2]=yc;g[pc>>2]=Aa;g[oc>>2]=Ac;g[nc>>2]=xc;xc=ea(g[Vb>>2]);Ac=ea(g[Sb>>2]);Aa=ea(xc*Ac);yc=ea(g[Tb>>2]);Ec=ea(xc*yc);Ba=ea(g[Ub>>2]);zc=ea(ea(Ac*yc)-ea(xc*Ba));wc=ea(ea(ea(xc*xc)+ea(-.5))+ea(yc*yc));Da=ea(Aa+ea(yc*Ba));Aa=ea(Ec-Ec);Ec=ea(zc+zc);zc=ea(wc+wc);wc=ea(Da+Da);Da=ea(Aa+Aa);Aa=ea(zc*ea(0.0));Dc=ea(wc*ea(0.0));Fa=ea(Ec*ea(0.0));Bc=ea(Ec-Aa);Fc=ea(Aa-wc);Aa=ea(Dc-Fa);Cc=ea(ea(T(ea(ea(ea(zc*zc)+ea(Ec*Ec))+ea(ea(Da*Da)+ea(wc*wc)))))+ea(ea(zc+Fa)+ea(ea(Da*ea(0.0))+Dc)));Dc=ea(ea(ea(ea(xc*Cc)-ea(Ac*Fc))-ea(Ba*Bc))-ea(yc*Aa));Da=ea(ea(ea(ea(Ba*Fc)-ea(Ac*Bc))-ea(yc*Cc))-ea(xc*Aa));Fa=ea(ea(ea(ea(ea(yc*Bc)-ea(Ba*Aa))-ea(Ac*Cc))-ea(xc*Fc))*ea(-0.0));zc=ea(ea(ea(ea(ea(Ac*Aa)-ea(Ba*Cc))-ea(xc*Bc))-ea(yc*Fc))*ea(-0.0));Fc=ea(ea(1.0)/ea(T(ea(ea(ea(Da*Da)+ea(Fa*Fa))+ea(ea(Dc*Dc)+ea(zc*zc))))));yc=ea(Fc*Fa);Fa=ea(-ea(Fc*Da));Da=ea(Fc*zc);zc=ea(Fc*Dc);Dc=ea(g[s>>2]);Fc=ea(g[Lb>>2]);Bc=ea(g[Mb>>2]);xc=ea(g[Nb>>2]);Cc=ea(g[_b>>2]);Ba=ea(g[$b>>2]);Aa=ea(g[ac>>2]);Ac=ea(g[bc>>2]);g[w>>2]=Dc;g[w+4>>2]=Fc;g[w+8>>2]=Bc;g[w+12>>2]=xc;g[w+16>>2]=yc;g[w+20>>2]=Fa;g[w+24>>2]=Da;g[rc>>2]=zc;g[vc>>2]=Cc;g[uc>>2]=Ba;g[tc>>2]=Aa;g[sc>>2]=Ac;if(!(a[b+1629>>0]|0)){Rc=Kc;Sc=Lc;Tc=Mc;Uc=Hc;Vc=Ic;Wc=Jc;Xc=Gc;Yc=Nc;Zc=Oc;_c=Pc;$c=Qc;ad=o;bd=ea(0.0);cd=ea(0.0)}else{HZd(B,b+928|0,b+80|0);IZd(A,o,B);Ac=ea(g[A+4>>2]);HZd(D,b+976|0,b+156|0);IZd(C,o,D);Rc=Kc;Sc=Lc;Tc=Mc;Uc=Hc;Vc=Ic;Wc=Jc;Xc=Gc;Yc=Nc;Zc=Oc;_c=Pc;$c=Qc;ad=o;bd=Ac;cd=ea(g[C+4>>2])}}else{pZd(x,b);Ac=ea(g[x>>2]);Aa=ea(g[x+4>>2]);Ba=ea(g[x+8>>2]);Cc=ea(g[x+12>>2]);g[t>>2]=Ac;g[t+4>>2]=Aa;g[t+8>>2]=Ba;g[t+12>>2]=Cc;Cc=ea(g[x+16>>2]);Ba=ea(g[x+20>>2]);Aa=ea(g[x+24>>2]);Ac=ea(g[x+28>>2]);g[t+16>>2]=Cc;g[t+20>>2]=Ba;g[t+24>>2]=Aa;g[cc>>2]=Ac;Ac=ea(g[x+32>>2]);Aa=ea(g[x+36>>2]);Ba=ea(g[x+40>>2]);Cc=ea(g[x+44>>2]);g[gc>>2]=Ac;g[fc>>2]=Aa;g[ec>>2]=Ba;g[dc>>2]=Cc;qZd(y,b);Cc=ea(g[y>>2]);Ba=ea(g[y+4>>2]);Aa=ea(g[y+8>>2]);Ac=ea(g[y+12>>2]);g[u>>2]=Cc;g[u+4>>2]=Ba;g[u+8>>2]=Aa;g[u+12>>2]=Ac;Ac=ea(g[y+16>>2]);Aa=ea(g[y+20>>2]);Ba=ea(g[y+24>>2]);Cc=ea(g[y+28>>2]);g[u+16>>2]=Ac;g[u+20>>2]=Aa;g[u+24>>2]=Ba;g[hc>>2]=Cc;Cc=ea(g[y+32>>2]);Ba=ea(g[y+36>>2]);Aa=ea(g[y+40>>2]);Ac=ea(g[y+44>>2]);g[lc>>2]=Cc;g[kc>>2]=Ba;g[jc>>2]=Aa;g[ic>>2]=Ac;Ac=ea(g[f+36>>2]);Aa=ea(g[f+40>>2]);Ba=ea(g[f+44>>2]);Cc=ea(g[f+48>>2]);g[v>>2]=Ac;g[v+4>>2]=Aa;g[v+8>>2]=Ba;g[v+12>>2]=Cc;Cc=ea(g[f+52>>2]);Ba=ea(g[f+56>>2]);Aa=ea(g[f+60>>2]);Ac=ea(g[f+64>>2]);g[v+16>>2]=Cc;g[v+20>>2]=Ba;g[v+24>>2]=Aa;g[mc>>2]=Ac;Ac=ea(g[f+68>>2]);Aa=ea(g[f+72>>2]);Ba=ea(g[f+76>>2]);Cc=ea(g[f+80>>2]);g[qc>>2]=Ac;g[pc>>2]=Aa;g[oc>>2]=Ba;g[nc>>2]=Cc;mZd(z,b,j,qa);qa=ea(g[z>>2]);Cc=ea(g[z+4>>2]);Ba=ea(g[z+8>>2]);Aa=ea(g[z+12>>2]);g[w>>2]=qa;g[w+4>>2]=Cc;g[w+8>>2]=Ba;g[w+12>>2]=Aa;Aa=ea(g[z+16>>2]);Ba=ea(g[z+20>>2]);Cc=ea(g[z+24>>2]);qa=ea(g[z+28>>2]);g[w+16>>2]=Aa;g[w+20>>2]=Ba;g[w+24>>2]=Cc;g[rc>>2]=qa;qa=ea(g[z+32>>2]);Cc=ea(g[z+36>>2]);Ba=ea(g[z+40>>2]);Aa=ea(g[z+44>>2]);g[vc>>2]=qa;g[uc>>2]=Cc;g[tc>>2]=Ba;g[sc>>2]=Aa;Rc=o+4|0;Sc=o+8|0;Tc=o+12|0;Uc=o+16|0;Vc=o+20|0;Wc=o+24|0;Xc=o+28|0;Yc=o+32|0;Zc=o+36|0;_c=o+40|0;$c=o+44|0;ad=o;bd=ea(0.0);cd=ea(0.0)}Aa=ea(g[ua>>2]);Ba=ea(g[ad>>2]);Cc=ea(g[Rc>>2]);qa=ea(g[Sc>>2]);Ac=ea(g[Tc>>2]);g[E>>2]=Ba;o=E+4|0;g[o>>2]=Cc;z=E+8|0;g[z>>2]=qa;nc=E+12|0;g[nc>>2]=Ac;Ac=ea(g[Uc>>2]);qa=ea(g[Vc>>2]);Cc=ea(g[Wc>>2]);Ba=ea(g[Xc>>2]);oc=E+16|0;g[oc>>2]=Ac;pc=E+20|0;g[pc>>2]=qa;qc=E+24|0;g[qc>>2]=Cc;y=E+28|0;g[y>>2]=Ba;Ba=ea(g[Yc>>2]);Cc=ea(g[Zc>>2]);qa=ea(g[_c>>2]);Ac=ea(g[$c>>2]);$c=E+32|0;g[$c>>2]=Ba;_c=E+36|0;g[_c>>2]=Cc;Zc=E+40|0;g[Zc>>2]=qa;Yc=E+44|0;g[Yc>>2]=Ac;Ac=ea(g[u>>2]);x=u+4|0;qa=ea(g[x>>2]);C=u+8|0;Cc=ea(g[C>>2]);Qc=u+12|0;Ba=ea(g[Qc>>2]);g[F>>2]=Ac;Pc=F+4|0;g[Pc>>2]=qa;Oc=F+8|0;g[Oc>>2]=Cc;Nc=F+12|0;g[Nc>>2]=Ba;Gc=u+16|0;zc=ea(g[Gc>>2]);Jc=u+20|0;Da=ea(g[Jc>>2]);Ic=u+24|0;Fa=ea(g[Ic>>2]);yc=ea(g[hc>>2]);Hc=F+16|0;g[Hc>>2]=zc;Mc=F+20|0;g[Mc>>2]=Da;Lc=F+24|0;g[Lc>>2]=Fa;Kc=F+28|0;g[Kc>>2]=yc;yc=ea(g[lc>>2]);Fa=ea(g[kc>>2]);Da=ea(g[jc>>2]);zc=ea(g[ic>>2]);D=F+32|0;g[D>>2]=yc;A=F+36|0;g[A>>2]=Fa;B=F+40|0;g[B>>2]=Da;dd=F+44|0;g[dd>>2]=zc;ed=G+28|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;c[G+16>>2]=0;c[G+20>>2]=0;c[G+24>>2]=0;g[ed>>2]=ea(1.0);fd=G+32|0;g[fd>>2]=ea(1.0);gd=G+36|0;g[gd>>2]=ea(1.0);hd=G+40|0;g[hd>>2]=ea(1.0);id=G+44|0;g[id>>2]=ea(1.0);g[H>>2]=ea(0.0);zc=ea(g[d+12>>2]);do if(zc!=ea(1.0)){Da=ea(g[ta>>2]);Fa=ea(g[ua>>2]);jd=(a[va>>0]|0)!=0;kd=ea(g[xa>>2])<ea(0.0);yc=ea(VDi(ea(1.0),ea(UDi(ea(0.0),zc))));xc=ea(cEi(ea(ra+zc),H));Bc=jd?xc:yc;yc=ea(ea(1.0)-Bc);jd=(g[k>>2]=yc,c[k>>2]|0);yc=(c[k>>2]=(kd?jd:0)|(g[k>>2]=Bc,c[k>>2]|0)&0-(kd&1^1),ea(g[k>>2]));Bc=ea(Da+ea(ea(Fa-Da)*yc));nZd(I,b,j,Bc);Da=ea(g[I>>2]);Fa=ea(g[I+4>>2]);xc=ea(g[I+8>>2]);Fc=ea(g[I+12>>2]);g[E>>2]=Da;g[o>>2]=Fa;g[z>>2]=xc;g[nc>>2]=Fc;Fc=ea(g[I+16>>2]);xc=ea(g[I+20>>2]);Fa=ea(g[I+24>>2]);Da=ea(g[I+28>>2]);g[oc>>2]=Fc;g[pc>>2]=xc;g[qc>>2]=Fa;g[y>>2]=Da;Dc=ea(g[I+32>>2]);wc=ea(g[I+36>>2]);Ec=ea(g[I+40>>2]);ld=ea(g[I+44>>2]);g[$c>>2]=Dc;g[_c>>2]=wc;g[Zc>>2]=Ec;g[Yc>>2]=ld;oZd(K,b,j,Bc,0);IZd(J,E,K);md=ea(g[J+4>>2]);oZd(M,b,j,Bc,1);IZd(L,E,M);nd=ea(g[L+4>>2]);if(Ea){mZd(N,b,j,Bc);od=ea(g[N>>2]);pd=ea(g[N+4>>2]);qd=ea(g[N+8>>2]);rd=ea(g[N+12>>2]);g[F>>2]=od;g[Pc>>2]=pd;g[Oc>>2]=qd;g[Nc>>2]=rd;sd=ea(g[N+16>>2]);td=ea(g[N+20>>2]);ud=ea(g[N+24>>2]);vd=ea(g[N+28>>2]);g[Hc>>2]=sd;g[Mc>>2]=td;g[Lc>>2]=ud;g[Kc>>2]=vd;vd=ea(g[N+32>>2]);ud=ea(g[N+36>>2]);td=ea(g[N+40>>2]);sd=ea(g[N+44>>2]);g[D>>2]=vd;g[A>>2]=ud;g[B>>2]=td;g[dd>>2]=sd;wd=md;xd=nd;yd=pd;zd=od;Ad=qd;Bd=rd;Cd=yc;Dd=Bc;break}else{rd=ea(Da*xc);qd=ea(ea(Fc*xc)-ea(Da*Fa));od=ea(ea(ea(Da*Da)+ea(-.5))+ea(xc*xc));pd=ea(ea(Da*Fc)+ea(xc*Fa));sd=ea(rd-rd);rd=ea(qd+qd);qd=ea(od+od);od=ea(pd+pd);pd=ea(sd+sd);sd=ea(qd*ea(0.0));td=ea(od*ea(0.0));ud=ea(rd*ea(0.0));vd=ea(rd-sd);Ed=ea(sd-od);sd=ea(td-ud);Fd=ea(ea(T(ea(ea(ea(qd*qd)+ea(rd*rd))+ea(ea(pd*pd)+ea(od*od)))))+ea(ea(qd+ud)+ea(ea(pd*ea(0.0))+td)));td=ea(ea(ea(ea(Da*Fd)-ea(Fc*Ed))-ea(Fa*vd))-ea(xc*sd));pd=ea(ea(ea(ea(Fa*Ed)-ea(Fc*vd))-ea(xc*Fd))-ea(Da*sd));ud=ea(ea(ea(ea(ea(xc*vd)-ea(Fa*sd))-ea(Fc*Fd))-ea(Da*Ed))*ea(-0.0));qd=ea(ea(ea(ea(ea(Fc*sd)-ea(Fa*Fd))-ea(Da*vd))-ea(xc*Ed))*ea(-0.0));Ed=ea(ea(1.0)/ea(T(ea(ea(ea(pd*pd)+ea(ud*ud))+ea(ea(td*td)+ea(qd*qd))))));xc=ea(Ed*ud);ud=ea(-ea(Ed*pd));pd=ea(Ed*qd);qd=ea(Ed*td);td=ea(g[E>>2]);Ed=ea(g[o>>2]);vd=ea(g[z>>2]);Da=ea(g[nc>>2]);g[F>>2]=td;g[Pc>>2]=Ed;g[Oc>>2]=vd;g[Nc>>2]=Da;g[Hc>>2]=xc;g[Mc>>2]=ud;g[Lc>>2]=pd;g[Kc>>2]=qd;g[D>>2]=Dc;g[A>>2]=wc;g[B>>2]=Ec;g[dd>>2]=ld;wd=md;xd=nd;yd=Ed;zd=td;Ad=vd;Bd=Da;Cd=yc;Dd=Bc;break}}else{wd=bd;xd=bd;yd=qa;zd=Ac;Ad=Cc;Bd=Ba;Cd=ea(1.0);Dd=Aa}while(0);N=d+8|0;L=c[N>>2]|0;M=L+-2|0;if((M|0)>-1){if(ya)Gd=((M<<1|-3)^2)+L|0;else Gd=M;oZd(O,b,j,Dd,Gd);Dd=ea(g[O>>2]);Aa=ea(g[O+4>>2]);Ba=ea(g[O+8>>2]);Cc=ea(g[O+12>>2]);g[G>>2]=Dd;g[G+4>>2]=Aa;g[G+8>>2]=Ba;g[G+12>>2]=Cc;Cc=ea(g[O+16>>2]);Ba=ea(g[O+20>>2]);Aa=ea(g[O+24>>2]);Dd=ea(g[O+28>>2]);g[G+16>>2]=Cc;g[G+20>>2]=Ba;g[G+24>>2]=Aa;g[ed>>2]=Dd;Dd=ea(g[O+32>>2]);Aa=ea(g[O+36>>2]);Ba=ea(g[O+40>>2]);Cc=ea(g[O+44>>2]);g[fd>>2]=Dd;g[gd>>2]=Aa;g[hd>>2]=Ba;g[id>>2]=Cc;Hd=Gd}else Hd=M;if(!Ea){if(!(a[b+1629>>0]|0))Id=yd;else{IZd(P,wa,b+928|0);IZd(Q,wa,b+976|0);IZd(R,p,q);IZd(U,p,r);IZd(V,s,h+80|0);IZd(W,s,h+156|0);Cc=ea(g[P+4>>2]);Ba=ea(g[Q+4>>2]);Aa=Cc<Ba?Cc:Ba;M=t+4|0;Ba=ea(g[M>>2]);g[M>>2]=Ba<Aa?Ba:Aa;Aa=bd<cd?bd:cd;cd=ea(g[x>>2]);g[x>>2]=cd<Aa?cd:Aa;Aa=ea(g[R+4>>2]);cd=ea(g[U+4>>2]);bd=Aa<cd?Aa:cd;M=v+4|0;cd=ea(g[M>>2]);g[M>>2]=cd<bd?cd:bd;bd=ea(g[V+4>>2]);cd=ea(g[W+4>>2]);Aa=bd<cd?bd:cd;W=w+4|0;cd=ea(g[W>>2]);g[W>>2]=cd<Aa?cd:Aa;Aa=wd>xd?wd:xd;xd=yd<Aa?yd:Aa;g[Pc>>2]=xd;Id=xd}xd=ea(g[b+1060>>2]);Aa=ea(ea(g[b+1056>>2])*ea(.0174532924));yd=ea(ea(VDi(ea(UDi(ea(ea((Aa>ea(0.0)&1)-(Aa<ea(0.0)&1)|0)*ea(ea(+ea(ea(S(ea(Aa)))*ea(.5))+1.5707963267948966)+ea(-1.57079637))),ea(-1.57079542))),ea(1.57079542)))*ea(.159154937));Aa=ea(yd+ea(-.25));wd=ea(yd+ea(0.0));yd=ea(eEi(Aa));cd=ea(ea(.25)-ea(S(ea(Aa-yd))));yd=ea(ea(.25)-ea(S(ea(wd-ea(eEi(wd))))));wd=ea(cd*cd);Aa=ea(yd*yd);bd=ea(ea(cd*ea(ea(ea(wd*ea(-41.2831841))+ea(6.28318548))+ea(ea(wd*wd)*ea(76.0354614))))/ea(yd*ea(ea(ea(Aa*ea(-41.2831841))+ea(6.28318548))+ea(ea(Aa*Aa)*ea(76.0354614)))));Aa=ea(ea(1.0)/ea(T(ea(ea(ea(bd*bd)+ea(0.0))+ea(1.0)))));yd=ea(Aa*ea(0.0));wd=ea(bd*Aa);if(!(a[b+1627>>0]|0))Jd=xd;else Jd=ea(xd-ea(g[t+4>>2]));if(!(a[b+1628>>0]|0)){Kd=ea(0.0);Ld=ea(0.0)}else{xd=ea(ea(0.0)-ea(g[t>>2]));Kd=xd;Ld=ea(ea(0.0)-ea(g[t+8>>2]))}xd=ea(g[t+16>>2]);if(!(a[b+1626>>0]|0)){bd=ea(g[cc>>2]);cd=ea(g[t+20>>2]);Md=wd;Nd=Aa;Od=bd;Pd=yd;Qd=cd;Rd=yd;Sd=ea(g[t+24>>2])}else{cd=ea(-xd);bd=ea(g[t+20>>2]);Ba=ea(-bd);Cc=ea(g[t+24>>2]);Dd=ea(-Cc);Ac=ea(g[cc>>2]);qa=ea(yd*Ba);zc=ea(yd*Dd);ra=ea(yd*cd);Bc=ea(yd*Ac);yd=ea(ea(ea(ea(wd*cd)-ea(Aa*Dd))-Bc)-qa);yc=ea(ea(ea(ea(Aa*Ac)-ra)-zc)-ea(wd*Ba));Da=ea(ea(ea(qa-ea(wd*Dd))-ea(Aa*cd))-Bc);Bc=ea(ea(ea(zc-ra)-ea(Aa*Ba))-ea(wd*Ac));wd=ea(ea(1.0)/ea(T(ea(ea(ea(Da*Da)+ea(Bc*Bc))+ea(ea(yd*yd)+ea(yc*yc))))));Md=ea(-ea(wd*Bc));Nd=ea(wd*yc);Od=Ac;Pd=ea(-ea(wd*yd));Qd=bd;Rd=ea(-ea(wd*Da));Sd=Cc}Cc=ea(Kd+ea(g[t>>2]));W=t+4|0;Da=ea(Jd+ea(g[W>>2]));V=t+8|0;wd=ea(Ld+ea(g[V>>2]));M=t+12|0;bd=ea(ea(g[M>>2])+ea(0.0));g[t>>2]=Cc;g[W>>2]=Da;g[V>>2]=wd;g[M>>2]=bd;bd=ea(Kd+ea(g[u>>2]));wd=ea(Jd+ea(g[x>>2]));Da=ea(Ld+ea(g[C>>2]));Cc=ea(ea(g[Qc>>2])+ea(0.0));g[u>>2]=bd;g[x>>2]=wd;g[C>>2]=Da;g[Qc>>2]=Cc;Cc=ea(Kd+ea(g[v>>2]));M=v+4|0;Da=ea(Jd+ea(g[M>>2]));Gd=v+8|0;wd=ea(Ld+ea(g[Gd>>2]));O=v+12|0;bd=ea(ea(g[O>>2])+ea(0.0));g[v>>2]=Cc;g[M>>2]=Da;g[Gd>>2]=wd;g[O>>2]=bd;bd=ea(Kd+ea(g[w>>2]));j=w+4|0;wd=ea(Jd+ea(g[j>>2]));L=w+8|0;Da=ea(Ld+ea(g[L>>2]));J=w+12|0;Cc=ea(ea(g[J>>2])+ea(0.0));g[w>>2]=bd;g[j>>2]=wd;g[L>>2]=Da;g[J>>2]=Cc;Cc=ea(Jd+Id);Id=ea(Ld+Ad);Ad=ea(Bd+ea(0.0));g[F>>2]=ea(Kd+zd);g[Pc>>2]=Cc;g[Oc>>2]=Id;g[Nc>>2]=Ad;K=t+16|0;I=t+20|0;kd=t+24|0;Ad=ea(ea(ea(ea(Md*xd)-ea(Nd*Sd))-ea(Pd*Od))-ea(Rd*Qd));Id=ea(ea(ea(ea(Nd*Od)-ea(Rd*xd))-ea(Pd*Sd))-ea(Md*Qd));Cc=ea(ea(ea(ea(Pd*Qd)-ea(Md*Sd))-ea(Nd*xd))-ea(Rd*Od));zd=ea(ea(ea(ea(Rd*Sd)-ea(Pd*xd))-ea(Nd*Qd))-ea(Md*Od));Od=ea(ea(1.0)/ea(T(ea(ea(ea(Cc*Cc)+ea(zd*zd))+ea(ea(Id*Id)+ea(Ad*Ad))))));Qd=ea(-ea(Od*zd));zd=ea(-ea(Od*Ad));Ad=ea(Od*Id);g[K>>2]=ea(-ea(Od*Cc));g[I>>2]=Qd;g[kd>>2]=zd;g[cc>>2]=Ad;Ad=ea(g[Gc>>2]);zd=ea(Md*Ad);Qd=ea(g[hc>>2]);Cc=ea(Nd*Qd);Od=ea(g[Jc>>2]);Id=ea(Pd*Od);xd=ea(g[Ic>>2]);Sd=ea(ea(ea(zd-ea(Nd*xd))-ea(Pd*Qd))-ea(Rd*Od));zd=ea(ea(ea(Cc-ea(Rd*Ad))-ea(Pd*xd))-ea(Md*Od));Cc=ea(ea(ea(Id-ea(Md*xd))-ea(Nd*Ad))-ea(Rd*Qd));Id=ea(ea(ea(ea(Rd*xd)-ea(Pd*Ad))-ea(Nd*Od))-ea(Md*Qd));Qd=ea(ea(1.0)/ea(T(ea(ea(ea(Cc*Cc)+ea(Id*Id))+ea(ea(zd*zd)+ea(Sd*Sd))))));Od=ea(-ea(Qd*Id));Id=ea(-ea(Qd*Sd));Sd=ea(Qd*zd);g[Gc>>2]=ea(-ea(Qd*Cc));g[Jc>>2]=Od;g[Ic>>2]=Id;g[hc>>2]=Sd;jd=v+16|0;Sd=ea(g[jd>>2]);Id=ea(Md*Sd);Od=ea(g[mc>>2]);Cc=ea(Nd*Od);Td=v+20|0;Qd=ea(g[Td>>2]);zd=ea(Pd*Qd);Ud=v+24|0;Ad=ea(g[Ud>>2]);xd=ea(ea(ea(Id-ea(Nd*Ad))-ea(Pd*Od))-ea(Rd*Qd));Id=ea(ea(ea(Cc-ea(Rd*Sd))-ea(Pd*Ad))-ea(Md*Qd));Cc=ea(ea(ea(zd-ea(Md*Ad))-ea(Nd*Sd))-ea(Rd*Od));zd=ea(ea(ea(ea(Rd*Ad)-ea(Pd*Sd))-ea(Nd*Qd))-ea(Md*Od));Od=ea(ea(1.0)/ea(T(ea(ea(ea(Cc*Cc)+ea(zd*zd))+ea(ea(Id*Id)+ea(xd*xd))))));Qd=ea(-ea(Od*zd));zd=ea(-ea(Od*xd));xd=ea(Od*Id);g[jd>>2]=ea(-ea(Od*Cc));g[Td>>2]=Qd;g[Ud>>2]=zd;g[mc>>2]=xd;Vd=w+16|0;xd=ea(g[Vd>>2]);zd=ea(Md*xd);Qd=ea(g[rc>>2]);Cc=ea(Nd*Qd);Wd=w+20|0;Od=ea(g[Wd>>2]);Id=ea(Pd*Od);Xd=w+24|0;Sd=ea(g[Xd>>2]);Ad=ea(ea(ea(zd-ea(Nd*Sd))-ea(Pd*Qd))-ea(Rd*Od));zd=ea(ea(ea(Cc-ea(Rd*xd))-ea(Pd*Sd))-ea(Md*Od));Cc=ea(ea(ea(Id-ea(Md*Sd))-ea(Nd*xd))-ea(Rd*Qd));Id=ea(ea(ea(ea(Rd*Sd)-ea(Pd*xd))-ea(Nd*Od))-ea(Md*Qd));Qd=ea(ea(1.0)/ea(T(ea(ea(ea(Cc*Cc)+ea(Id*Id))+ea(ea(zd*zd)+ea(Ad*Ad))))));Od=ea(-ea(Qd*Id));Id=ea(-ea(Qd*Ad));Ad=ea(Qd*zd);g[Vd>>2]=ea(-ea(Qd*Cc));g[Wd>>2]=Od;g[Xd>>2]=Id;g[rc>>2]=Ad;Ad=ea(g[Hc>>2]);Id=ea(Md*Ad);Od=ea(g[Kc>>2]);Cc=ea(Nd*Od);Qd=ea(g[Mc>>2]);zd=ea(Pd*Qd);xd=ea(g[Lc>>2]);Sd=ea(ea(ea(Id-ea(Nd*xd))-ea(Pd*Od))-ea(Rd*Qd));Id=ea(ea(ea(Cc-ea(Rd*Ad))-ea(Pd*xd))-ea(Md*Qd));Cc=ea(ea(ea(zd-ea(Md*xd))-ea(Nd*Ad))-ea(Rd*Od));zd=ea(ea(ea(ea(Rd*xd)-ea(Pd*Ad))-ea(Nd*Qd))-ea(Md*Od));Od=ea(ea(1.0)/ea(T(ea(ea(ea(Cc*Cc)+ea(zd*zd))+ea(ea(Id*Id)+ea(Sd*Sd))))));Md=ea(-ea(Od*zd));zd=ea(-ea(Od*Sd));Sd=ea(Od*Id);g[Hc>>2]=ea(-ea(Od*Cc));g[Mc>>2]=Md;g[Lc>>2]=zd;g[Kc>>2]=Sd;if(a[b+1623>>0]|0){Sd=ea(g[K>>2]);zd=ea(g[I>>2]);Md=ea(g[kd>>2]);Cc=ea(g[cc>>2]);g[Gc>>2]=Sd;g[Jc>>2]=zd;g[Ic>>2]=Md;g[hc>>2]=Cc;g[jd>>2]=Sd;g[Td>>2]=zd;g[Ud>>2]=Md;g[mc>>2]=Cc;g[Vd>>2]=Sd;g[Wd>>2]=zd;g[Xd>>2]=Md;g[rc>>2]=Cc;g[Hc>>2]=Sd;g[Mc>>2]=zd;g[Lc>>2]=Md;g[Kc>>2]=Cc}if(a[b+1624>>0]|0){Cc=ea(g[W>>2]);g[x>>2]=Cc;g[M>>2]=Cc;g[j>>2]=Cc;g[Pc>>2]=Cc}if(!(a[b+1625>>0]|0)){Yd=jd;Zd=Td;_d=Ud;$d=v;ae=M;be=Gd;ce=O;de=Vd;ee=Wd;fe=Xd;ge=w;he=j;ie=L;je=J}else{Cc=ea(g[t>>2]);g[u>>2]=Cc;g[v>>2]=Cc;g[w>>2]=Cc;g[F>>2]=Cc;Cc=ea(g[V>>2]);g[C>>2]=Cc;g[Gd>>2]=Cc;g[L>>2]=Cc;g[Oc>>2]=Cc;Yd=jd;Zd=Td;_d=Ud;$d=v;ae=M;be=Gd;ce=O;de=Vd;ee=Wd;fe=Xd;ge=w;he=j;ie=L;je=J}}else{Yd=v+16|0;Zd=v+20|0;_d=v+24|0;$d=v;ae=v+4|0;be=v+8|0;ce=v+12|0;de=w+16|0;ee=w+20|0;fe=w+24|0;ge=w;he=w+4|0;ie=w+8|0;je=w+12|0}Cc=ea(-ea(g[Yd>>2]));Md=ea(-ea(g[Zd>>2]));zd=ea(-ea(g[_d>>2]));Sd=ea(g[mc>>2]);Od=ea(g[p>>2]);Id=ea(Od-ea(g[$d>>2]));Od=ea(g[Ga>>2]);Qd=ea(Od-ea(g[ae>>2]));Od=ea(g[Ha>>2]);Nd=ea(Od-ea(g[be>>2]));Od=ea(g[Ia>>2]);Ad=ea(Id+Id);Pd=ea(Qd+Qd);xd=ea(Nd+Nd);Rd=ea(Sd*ea(0.0));Kd=ea(ea(Pd*Cc)-ea(Ad*Md));Bd=ea(ea(xd*Md)-ea(Pd*zd));Pd=ea(ea(Ad*zd)-ea(xd*Cc));xd=ea(Sd*ea(Rd-Rd));Rd=ea(ea(Id+ea(Sd*Bd))+ea(ea(Kd*Md)-ea(Pd*zd)));Id=ea(ea(Qd+ea(Sd*Pd))+ea(ea(Bd*zd)-ea(Kd*Cc)));Qd=ea(ea(Nd+ea(Sd*Kd))+ea(ea(Pd*Cc)-ea(Bd*Md)));Bd=ea(ea(xd-xd)+ea(xd+ea(Od-ea(g[ce>>2]))));Od=ea(g[Ja>>2]);xd=ea(Od*Md);Pd=ea(g[Ma>>2]);Kd=ea(Sd*Pd);Nd=ea(g[Ka>>2]);Ad=ea(Nd*zd);Ld=ea(g[La>>2]);Jd=ea(ea(ea(xd-ea(Sd*Ld))-ea(Pd*zd))-ea(Nd*Cc));xd=ea(ea(ea(Kd-ea(Od*Cc))-ea(Ld*zd))-ea(Nd*Md));Kd=ea(ea(ea(Ad-ea(Ld*Md))-ea(Sd*Od))-ea(Pd*Cc));Ad=ea(ea(ea(ea(Ld*Cc)-ea(Od*zd))-ea(Sd*Nd))-ea(Pd*Md));Md=ea(ea(1.0)/ea(T(ea(ea(ea(Kd*Kd)+ea(Ad*Ad))+ea(ea(xd*xd)+ea(Jd*Jd))))));Pd=ea(-ea(Md*Kd));Kd=ea(-ea(Md*Ad));Ad=ea(-ea(Md*Jd));Jd=ea(Md*xd);g[p>>2]=Rd;g[Ga>>2]=Id;g[Ha>>2]=Qd;g[Ia>>2]=Bd;g[Ja>>2]=Pd;g[Ka>>2]=Kd;g[La>>2]=Ad;g[Ma>>2]=Jd;g[Na>>2]=ea(1.0);g[Oa>>2]=ea(1.0);g[Pa>>2]=ea(1.0);g[Qa>>2]=ea(1.0);Jd=ea(-ea(g[de>>2]));Ad=ea(-ea(g[ee>>2]));Kd=ea(-ea(g[fe>>2]));Pd=ea(g[rc>>2]);Bd=ea(g[s>>2]);Qd=ea(Bd-ea(g[ge>>2]));Bd=ea(g[Lb>>2]);Id=ea(Bd-ea(g[he>>2]));Bd=ea(g[Mb>>2]);Rd=ea(Bd-ea(g[ie>>2]));Bd=ea(g[Nb>>2]);xd=ea(Qd+Qd);Md=ea(Id+Id);Nd=ea(Rd+Rd);Sd=ea(Pd*ea(0.0));zd=ea(ea(Md*Jd)-ea(xd*Ad));Od=ea(ea(Nd*Ad)-ea(Md*Kd));Md=ea(ea(xd*Kd)-ea(Nd*Jd));Nd=ea(Pd*ea(Sd-Sd));Sd=ea(ea(Qd+ea(Pd*Od))+ea(ea(zd*Ad)-ea(Md*Kd)));Qd=ea(ea(Id+ea(Pd*Md))+ea(ea(Od*Kd)-ea(zd*Jd)));Id=ea(ea(Rd+ea(Pd*zd))+ea(ea(Md*Jd)-ea(Od*Ad)));Od=ea(ea(Nd-Nd)+ea(Nd+ea(Bd-ea(g[je>>2]))));Bd=ea(g[Sb>>2]);Nd=ea(Bd*Ad);Md=ea(g[Vb>>2]);zd=ea(Pd*Md);Rd=ea(g[Tb>>2]);xd=ea(Rd*Kd);Cc=ea(g[Ub>>2]);Ld=ea(ea(ea(Nd-ea(Pd*Cc))-ea(Md*Kd))-ea(Rd*Jd));Nd=ea(ea(ea(zd-ea(Bd*Jd))-ea(Cc*Kd))-ea(Rd*Ad));zd=ea(ea(ea(xd-ea(Cc*Ad))-ea(Pd*Bd))-ea(Md*Jd));xd=ea(ea(ea(ea(Cc*Jd)-ea(Bd*Kd))-ea(Pd*Rd))-ea(Md*Ad));Ad=ea(ea(1.0)/ea(T(ea(ea(ea(zd*zd)+ea(xd*xd))+ea(ea(Nd*Nd)+ea(Ld*Ld))))));Md=ea(-ea(Ad*zd));zd=ea(-ea(Ad*xd));xd=ea(-ea(Ad*Ld));Ld=ea(Ad*Nd);g[s>>2]=Sd;g[Lb>>2]=Qd;g[Mb>>2]=Id;g[Nb>>2]=Od;g[Sb>>2]=Md;g[Tb>>2]=zd;g[Ub>>2]=xd;g[Vb>>2]=Ld;g[_b>>2]=ea(1.0);g[$b>>2]=ea(1.0);g[ac>>2]=ea(1.0);g[bc>>2]=ea(1.0);Ld=ea(-ea(g[Hc>>2]));xd=ea(-ea(g[Mc>>2]));zd=ea(-ea(g[Lc>>2]));Md=ea(g[Kc>>2]);Od=ea(g[E>>2]);Id=ea(Od-ea(g[F>>2]));Od=ea(g[o>>2]);Qd=ea(Od-ea(g[Pc>>2]));Od=ea(g[z>>2]);Sd=ea(Od-ea(g[Oc>>2]));Od=ea(g[nc>>2]);Nd=ea(Id+Id);Ad=ea(Qd+Qd);Rd=ea(Sd+Sd);Pd=ea(Md*ea(0.0));Kd=ea(ea(Ad*Ld)-ea(Nd*xd));Bd=ea(ea(Rd*xd)-ea(Ad*zd));Ad=ea(ea(Nd*zd)-ea(Rd*Ld));Rd=ea(Md*ea(Pd-Pd));Pd=ea(ea(Id+ea(Md*Bd))+ea(ea(Kd*xd)-ea(Ad*zd)));Id=ea(ea(Qd+ea(Md*Ad))+ea(ea(Bd*zd)-ea(Kd*Ld)));Qd=ea(ea(Sd+ea(Md*Kd))+ea(ea(Ad*Ld)-ea(Bd*xd)));Bd=ea(ea(Rd-Rd)+ea(Rd+ea(Od-ea(g[Nc>>2]))));Od=ea(g[oc>>2]);Rd=ea(Od*xd);Ad=ea(g[y>>2]);Kd=ea(Md*Ad);Sd=ea(g[pc>>2]);Nd=ea(Sd*zd);Jd=ea(g[qc>>2]);Cc=ea(ea(ea(Rd-ea(Md*Jd))-ea(Ad*zd))-ea(Sd*Ld));Rd=ea(ea(ea(Kd-ea(Od*Ld))-ea(Jd*zd))-ea(Sd*xd));Kd=ea(ea(ea(Nd-ea(Jd*xd))-ea(Md*Od))-ea(Ad*Ld));Nd=ea(ea(ea(ea(Jd*Ld)-ea(Od*zd))-ea(Md*Sd))-ea(Ad*xd));xd=ea(ea(1.0)/ea(T(ea(ea(ea(Kd*Kd)+ea(Nd*Nd))+ea(ea(Rd*Rd)+ea(Cc*Cc))))));Ad=ea(-ea(xd*Kd));Kd=ea(-ea(xd*Nd));Nd=ea(-ea(xd*Cc));Cc=ea(xd*Rd);g[E>>2]=Pd;g[o>>2]=Id;g[z>>2]=Qd;g[nc>>2]=Bd;g[oc>>2]=Ad;g[pc>>2]=Kd;g[qc>>2]=Nd;g[y>>2]=Cc;g[$c>>2]=ea(1.0);g[_c>>2]=ea(1.0);g[Zc>>2]=ea(1.0);g[Yc>>2]=ea(1.0);if(((a[va>>0]|0)!=0?(a[b+1622>>0]|0)!=0:0)?(Q_d(P),b$d(P,b,Ca),$_d(h,h,P),Cc=ea(za*ea(g[b+80>>2])),Nd=ea(za*ea(g[b+84>>2])),Kd=ea(za*ea(g[b+88>>2])),Ad=ea(za*ea(g[b+92>>2])),Bd=ea(za*ea(g[b+96>>2])),Qd=ea(za*ea(g[b+100>>2])),Id=ea(za*ea(g[b+104>>2])),Pd=ea(g[b+108>>2]),Rd=ea(ea(1.0)/ea(T(ea(ea(ea(Bd*Bd)+ea(Qd*Qd))+ea(ea(Id*Id)+ea(Pd*Pd)))))),xd=ea(Bd*Rd),Bd=ea(Qd*Rd),Qd=ea(Id*Rd),Id=ea(Pd*Rd),g[Y>>2]=Cc,g[Y+4>>2]=Nd,g[Y+8>>2]=Kd,g[Y+12>>2]=Ad,g[Y+16>>2]=xd,g[Y+20>>2]=Bd,g[Y+24>>2]=Qd,g[Y+28>>2]=Id,g[Y+32>>2]=ea(1.0),g[Y+36>>2]=ea(1.0),g[Y+40>>2]=ea(1.0),g[Y+44>>2]=ea(1.0),IZd(X,q,Y),Id=ea(g[X>>2]),Qd=ea(g[X+4>>2]),Bd=ea(g[X+8>>2]),xd=ea(g[X+12>>2]),g[q>>2]=Id,g[Va>>2]=Qd,g[Wa>>2]=Bd,g[Xa>>2]=xd,xd=ea(g[X+16>>2]),Bd=ea(g[X+20>>2]),Qd=ea(g[X+24>>2]),Id=ea(g[X+28>>2]),g[ab>>2]=xd,g[bb>>2]=Bd,g[cb>>2]=Qd,g[db>>2]=Id,Id=ea(g[X+32>>2]),Qd=ea(g[X+36>>2]),Bd=ea(g[X+40>>2]),xd=ea(g[X+44>>2]),g[ib>>2]=Id,g[jb>>2]=Qd,g[kb>>2]=Bd,g[lb>>2]=xd,xd=ea(za*ea(g[b+156>>2])),Bd=ea(za*ea(g[b+160>>2])),Qd=ea(za*ea(g[b+164>>2])),Id=ea(za*ea(g[b+168>>2])),Ad=ea(za*ea(g[b+172>>2])),Kd=ea(za*ea(g[b+176>>2])),Nd=ea(za*ea(g[b+180>>2])),Cc=ea(g[b+184>>2]),Rd=ea(ea(1.0)/ea(T(ea(ea(ea(Ad*Ad)+ea(Kd*Kd))+ea(ea(Nd*Nd)+ea(Cc*Cc)))))),Pd=ea(Ad*Rd),Ad=ea(Kd*Rd),Kd=ea(Nd*Rd),Nd=ea(Cc*Rd),g[$>>2]=xd,g[$+4>>2]=Bd,g[$+8>>2]=Qd,g[$+12>>2]=Id,g[$+16>>2]=Pd,g[$+20>>2]=Ad,g[$+24>>2]=Kd,g[$+28>>2]=Nd,g[$+32>>2]=ea(1.0),g[$+36>>2]=ea(1.0),g[$+40>>2]=ea(1.0),g[$+44>>2]=ea(1.0),IZd(_,r,$),Nd=ea(g[_>>2]),Kd=ea(g[_+4>>2]),Ad=ea(g[_+8>>2]),Pd=ea(g[_+12>>2]),g[r>>2]=Nd,g[qb>>2]=Kd,g[rb>>2]=Ad,g[sb>>2]=Pd,Pd=ea(g[_+16>>2]),Ad=ea(g[_+20>>2]),Kd=ea(g[_+24>>2]),Nd=ea(g[_+28>>2]),g[xb>>2]=Pd,g[yb>>2]=Ad,g[zb>>2]=Kd,g[Ab>>2]=Nd,Nd=ea(g[_+32>>2]),Kd=ea(g[_+36>>2]),Ad=ea(g[_+40>>2]),Pd=ea(g[_+44>>2]),g[Fb>>2]=Nd,g[Gb>>2]=Kd,g[Hb>>2]=Ad,g[Ib>>2]=Pd,Pd=ea(-ea(g[Gc>>2])),Ad=ea(-ea(g[Jc>>2])),Kd=ea(-ea(g[Ic>>2])),Nd=ea(g[hc>>2]),Id=ea(g[ad>>2]),Qd=ea(Id-ea(g[u>>2])),Id=ea(g[Rc>>2]),Bd=ea(Id-ea(g[x>>2])),Id=ea(g[Sc>>2]),xd=ea(Id-ea(g[C>>2])),Id=ea(g[Tc>>2]),Rd=ea(Qd+Qd),Cc=ea(Bd+Bd),Sd=ea(xd+xd),Md=ea(Nd*ea(0.0)),zd=ea(ea(Cc*Pd)-ea(Rd*Ad)),Od=ea(ea(Sd*Ad)-ea(Cc*Kd)),Cc=ea(ea(Rd*Kd)-ea(Sd*Pd)),Sd=ea(Nd*ea(Md-Md)),Md=ea(ea(Qd+ea(Nd*Od))+ea(ea(zd*Ad)-ea(Cc*Kd))),Qd=ea(ea(Bd+ea(Nd*Cc))+ea(ea(Od*Kd)-ea(zd*Pd))),Bd=ea(ea(xd+ea(Nd*zd))+ea(ea(Cc*Pd)-ea(Od*Ad))),Od=ea(ea(Sd-Sd)+ea(Sd+ea(Id-ea(g[Qc>>2])))),Id=ea(g[Uc>>2]),Sd=ea(Id*Ad),Cc=ea(g[Xc>>2]),zd=ea(Nd*Cc),xd=ea(g[Vc>>2]),Rd=ea(xd*Kd),Ld=ea(g[Wc>>2]),Jd=ea(ea(ea(Sd-ea(Nd*Ld))-ea(Cc*Kd))-ea(xd*Pd)),Sd=ea(ea(ea(zd-ea(Id*Pd))-ea(Ld*Kd))-ea(xd*Ad)),zd=ea(ea(ea(Rd-ea(Ld*Ad))-ea(Nd*Id))-ea(Cc*Pd)),Rd=ea(ea(ea(ea(Ld*Pd)-ea(Id*Kd))-ea(Nd*xd))-ea(Cc*Ad)),Ad=ea(ea(1.0)/ea(T(ea(ea(ea(zd*zd)+ea(Rd*Rd))+ea(ea(Sd*Sd)+ea(Jd*Jd)))))),Cc=ea(Ad*zd),zd=ea(Ad*Rd),Rd=ea(Ad*Jd),Jd=ea(Ad*Sd),GZd(aa,t,wa),Sd=ea(ea(g[aa>>2])-Md),Md=ea(ea(g[aa+4>>2])-Qd),Qd=ea(ea(g[aa+8>>2])-Bd),Bd=ea(Sd+Sd),Ad=ea(Md+Md),xd=ea(Qd+Qd),Nd=ea(Jd*ea(0.0)),Kd=ea(ea(Cc*Ad)-ea(zd*Bd)),Id=ea(ea(zd*xd)-ea(Rd*Ad)),Ad=ea(ea(Rd*Bd)-ea(Cc*xd)),xd=ea(Jd*ea(Nd-Nd)),Nd=ea(ea(Sd+ea(Jd*Id))+ea(ea(zd*Kd)-ea(Rd*Ad))),Sd=ea(ea(Md+ea(Jd*Ad))+ea(ea(Rd*Id)-ea(Cc*Kd))),Md=ea(ea(Qd+ea(Jd*Kd))+ea(ea(Cc*Ad)-ea(zd*Id))),Id=ea(ea(xd-xd)+ea(xd+ea(ea(g[aa+12>>2])-Od))),Od=ea(g[aa+16>>2]),xd=ea(zd*Od),Ad=ea(g[aa+28>>2]),Kd=ea(Jd*Ad),Qd=ea(g[aa+20>>2]),Bd=ea(Rd*Qd),Pd=ea(g[aa+24>>2]),Ld=ea(ea(ea(xd-ea(Jd*Pd))-ea(Rd*Ad))-ea(Cc*Qd)),xd=ea(ea(ea(Kd-ea(Cc*Od))-ea(Rd*Pd))-ea(zd*Qd)),Kd=ea(ea(ea(Bd-ea(zd*Pd))-ea(Jd*Od))-ea(Cc*Ad)),Bd=ea(ea(ea(ea(Cc*Pd)-ea(Rd*Od))-ea(Jd*Qd))-ea(zd*Ad)),Ad=ea(ea(1.0)/ea(T(ea(ea(ea(Kd*Kd)+ea(Bd*Bd))+ea(ea(xd*xd)+ea(Ld*Ld)))))),zd=ea(-ea(Ad*Kd)),Kd=ea(-ea(Ad*Bd)),Bd=ea(-ea(Ad*Ld)),Ld=ea(Ad*xd),g[Q>>2]=Nd,aa=Q+4|0,g[aa>>2]=Sd,wa=Q+8|0,g[wa>>2]=Md,Wc=Q+12|0,g[Wc>>2]=Id,Vc=Q+16|0,g[Vc>>2]=zd,Xc=Q+20|0,g[Xc>>2]=Kd,Uc=Q+24|0,g[Uc>>2]=Bd,Tc=Q+28|0,g[Tc>>2]=Ld,Sc=Q+32|0,g[Sc>>2]=ea(1.0),Rc=Q+36|0,g[Rc>>2]=ea(1.0),ad=Q+40|0,g[ad>>2]=ea(1.0),Ib=Q+44|0,g[Ib>>2]=ea(1.0),xd=ea(za*Nd),Ad=ea(za*Sd),Qd=ea(za*Md),Jd=ea(za*Id),Od=ea(za*zd),Rd=ea(za*Kd),Pd=ea(za*Bd),za=ea(Ld*Ld),Cc=ea(ea(1.0)/ea(T(ea(ea(ea(Od*Od)+ea(Rd*Rd))+ea(ea(Pd*Pd)+za))))),Da=ea(Od*Cc),Od=ea(Rd*Cc),Rd=ea(Pd*Cc),Pd=ea(Ld*Cc),g[R>>2]=xd,g[R+4>>2]=Ad,g[R+8>>2]=Qd,g[R+12>>2]=Jd,g[R+16>>2]=Da,g[R+20>>2]=Od,g[R+24>>2]=Rd,g[R+28>>2]=Pd,g[R+32>>2]=ea(1.0),g[R+36>>2]=ea(1.0),g[R+40>>2]=ea(1.0),g[R+44>>2]=ea(1.0),g[U>>2]=xd,g[U+4>>2]=Ad,g[U+8>>2]=Qd,g[U+12>>2]=Jd,g[U+16>>2]=Da,g[U+20>>2]=Od,g[U+24>>2]=Rd,g[U+28>>2]=Pd,g[U+32>>2]=ea(1.0),g[U+36>>2]=ea(1.0),g[U+40>>2]=ea(1.0),g[U+44>>2]=ea(1.0),Pd=ea(Ca*Sd),Sd=ea(Ca*Md),Md=ea(Ca*Id),Id=ea(Ca*zd),zd=ea(Ca*Kd),Kd=ea(Ca*Bd),Bd=ea(ea(1.0)/ea(T(ea(ea(ea(Id*Id)+ea(zd*zd))+ea(ea(Kd*Kd)+za))))),za=ea(Id*Bd),Id=ea(zd*Bd),zd=ea(Kd*Bd),Kd=ea(Ld*Bd),g[Q>>2]=ea(Ca*Nd),g[aa>>2]=Pd,g[wa>>2]=Sd,g[Wc>>2]=Md,g[Vc>>2]=za,g[Xc>>2]=Id,g[Uc>>2]=zd,g[Tc>>2]=Kd,g[Sc>>2]=ea(1.0),g[Rc>>2]=ea(1.0),g[ad>>2]=ea(1.0),g[Ib>>2]=ea(1.0),IZd(ba,p,R),Kd=ea(g[ba>>2]),zd=ea(g[ba+4>>2]),Id=ea(g[ba+8>>2]),za=ea(g[ba+12>>2]),g[p>>2]=Kd,g[Ga>>2]=zd,g[Ha>>2]=Id,g[Ia>>2]=za,za=ea(g[ba+16>>2]),Id=ea(g[ba+20>>2]),zd=ea(g[ba+24>>2]),Kd=ea(g[ba+28>>2]),g[Ja>>2]=za,g[Ka>>2]=Id,g[La>>2]=zd,g[Ma>>2]=Kd,Kd=ea(g[ba+32>>2]),zd=ea(g[ba+36>>2]),Id=ea(g[ba+40>>2]),za=ea(g[ba+44>>2]),g[Na>>2]=Kd,g[Oa>>2]=zd,g[Pa>>2]=Id,g[Qa>>2]=za,IZd(ca,s,Q),za=ea(g[ca>>2]),Id=ea(g[ca+4>>2]),zd=ea(g[ca+8>>2]),Kd=ea(g[ca+12>>2]),g[s>>2]=za,g[Lb>>2]=Id,g[Mb>>2]=zd,g[Nb>>2]=Kd,Kd=ea(g[ca+16>>2]),zd=ea(g[ca+20>>2]),Id=ea(g[ca+24>>2]),za=ea(g[ca+28>>2]),g[Sb>>2]=Kd,g[Tb>>2]=zd,g[Ub>>2]=Id,g[Vb>>2]=za,za=ea(g[ca+32>>2]),Id=ea(g[ca+36>>2]),zd=ea(g[ca+40>>2]),Kd=ea(g[ca+44>>2]),g[_b>>2]=za,g[$b>>2]=Id,g[ac>>2]=zd,g[bc>>2]=Kd,IZd(da,E,U),Kd=ea(g[da>>2]),zd=ea(g[da+4>>2]),Id=ea(g[da+8>>2]),za=ea(g[da+12>>2]),g[E>>2]=Kd,g[o>>2]=zd,g[z>>2]=Id,g[nc>>2]=za,za=ea(g[da+16>>2]),Id=ea(g[da+20>>2]),zd=ea(g[da+24>>2]),Kd=ea(g[da+28>>2]),g[oc>>2]=za,g[pc>>2]=Id,g[qc>>2]=zd,g[y>>2]=Kd,Kd=ea(g[da+32>>2]),zd=ea(g[da+36>>2]),Id=ea(g[da+40>>2]),za=ea(g[da+44>>2]),g[$c>>2]=Kd,g[_c>>2]=zd,g[Zc>>2]=Id,g[Yc>>2]=za,za=ea(-ea(g[t+16>>2])),Id=ea(-ea(g[t+20>>2])),zd=ea(-ea(g[t+24>>2])),Kd=ea(g[cc>>2]),Md=ea(g[u>>2]),Sd=ea(Md-ea(g[t>>2])),Md=ea(g[x>>2]),Pd=ea(Md-ea(g[t+4>>2])),Md=ea(g[C>>2]),Nd=ea(Md-ea(g[t+8>>2])),Md=ea(g[Qc>>2]),Ca=ea(Sd+Sd),Bd=ea(Pd+Pd),Ld=ea(Nd+Nd),Rd=ea(Kd*ea(0.0)),Od=ea(ea(Bd*za)-ea(Ca*Id)),Da=ea(ea(Ld*Id)-ea(Bd*zd)),Bd=ea(ea(Ca*zd)-ea(Ld*za)),Ld=ea(Kd*ea(Rd-Rd)),Rd=ea(ea(Sd+ea(Kd*Da))+ea(ea(Od*Id)-ea(Bd*zd))),Sd=ea(ea(Pd+ea(Kd*Bd))+ea(ea(Da*zd)-ea(Od*za))),Pd=ea(ea(Nd+ea(Kd*Od))+ea(ea(Bd*za)-ea(Da*Id))),Da=ea(ea(Ld-Ld)+ea(Ld+ea(Md-ea(g[t+12>>2])))),Md=ea(g[Gc>>2]),Ld=ea(Md*Id),Bd=ea(g[hc>>2]),Od=ea(Kd*Bd),Nd=ea(g[Jc>>2]),Ca=ea(Nd*zd),Jd=ea(g[Ic>>2]),Qd=ea(ea(ea(Ld-ea(Kd*Jd))-ea(Bd*zd))-ea(Nd*za)),Ld=ea(ea(ea(Od-ea(Md*za))-ea(Jd*zd))-ea(Nd*Id)),Od=ea(ea(ea(Ca-ea(Jd*Id))-ea(Kd*Md))-ea(Bd*za)),Ca=ea(ea(ea(ea(Jd*za)-ea(Md*zd))-ea(Kd*Nd))-ea(Bd*Id)),Id=ea(ea(1.0)/ea(T(ea(ea(ea(Od*Od)+ea(Ca*Ca))+ea(ea(Ld*Ld)+ea(Qd*Qd)))))),Bd=ea(-ea(Id*Od)),Od=ea(-ea(Id*Ca)),Ca=ea(-ea(Id*Qd)),Qd=ea(Id*Ld),g[ha>>2]=Rd,g[ha+4>>2]=Sd,g[ha+8>>2]=Pd,g[ha+12>>2]=Da,g[ha+16>>2]=Bd,g[ha+20>>2]=Od,g[ha+24>>2]=Ca,g[ha+28>>2]=Qd,g[ha+32>>2]=ea(1.0),g[ha+36>>2]=ea(1.0),g[ha+40>>2]=ea(1.0),g[ha+44>>2]=ea(1.0),Qd=ea(g[H>>2]),uZd(ga,ha,~~ea(Qd-ea(g[n>>2]))),IZd(fa,F,ga),Qd=ea(g[fa>>2]),Ca=ea(g[fa+4>>2]),Od=ea(g[fa+8>>2]),Bd=ea(g[fa+12>>2]),g[F>>2]=Qd,g[Pc>>2]=Ca,g[Oc>>2]=Od,g[Nc>>2]=Bd,Bd=ea(g[fa+16>>2]),Od=ea(g[fa+20>>2]),Ca=ea(g[fa+24>>2]),Qd=ea(g[fa+28>>2]),g[Hc>>2]=Bd,g[Mc>>2]=Od,g[Lc>>2]=Ca,g[Kc>>2]=Qd,Qd=ea(g[fa+32>>2]),Ca=ea(g[fa+36>>2]),Od=ea(g[fa+40>>2]),Bd=ea(g[fa+44>>2]),g[D>>2]=Qd,g[A>>2]=Ca,g[B>>2]=Od,g[dd>>2]=Bd,(Hd|0)>-1):0){Bd=ea(Cd*ea(g[b+(Hd*76|0)+80>>2]));Od=ea(Cd*ea(g[b+(Hd*76|0)+84>>2]));Ca=ea(Cd*ea(g[b+(Hd*76|0)+88>>2]));Qd=ea(Cd*ea(g[b+(Hd*76|0)+92>>2]));Da=ea(Cd*ea(g[b+(Hd*76|0)+96>>2]));Pd=ea(Cd*ea(g[b+(Hd*76|0)+100>>2]));Sd=ea(Cd*ea(g[b+(Hd*76|0)+104>>2]));Cd=ea(g[b+(Hd*76|0)+108>>2]);Rd=ea(ea(1.0)/ea(T(ea(ea(ea(Da*Da)+ea(Pd*Pd))+ea(ea(Sd*Sd)+ea(Cd*Cd))))));Ld=ea(Da*Rd);Da=ea(Pd*Rd);Pd=ea(Sd*Rd);Sd=ea(Cd*Rd);g[ja>>2]=Bd;g[ja+4>>2]=Od;g[ja+8>>2]=Ca;g[ja+12>>2]=Qd;g[ja+16>>2]=Ld;g[ja+20>>2]=Da;g[ja+24>>2]=Pd;g[ja+28>>2]=Sd;g[ja+32>>2]=ea(1.0);g[ja+36>>2]=ea(1.0);g[ja+40>>2]=ea(1.0);g[ja+44>>2]=ea(1.0);IZd(ia,G,ja);Sd=ea(g[ia>>2]);Pd=ea(g[ia+4>>2]);Da=ea(g[ia+8>>2]);Ld=ea(g[ia+12>>2]);g[G>>2]=Sd;g[G+4>>2]=Pd;g[G+8>>2]=Da;g[G+12>>2]=Ld;Ld=ea(g[ia+16>>2]);Da=ea(g[ia+20>>2]);Pd=ea(g[ia+24>>2]);Sd=ea(g[ia+28>>2]);g[G+16>>2]=Ld;g[G+20>>2]=Da;g[G+24>>2]=Pd;g[ed>>2]=Sd;Sd=ea(g[ia+32>>2]);Pd=ea(g[ia+36>>2]);Da=ea(g[ia+40>>2]);Ld=ea(g[ia+44>>2]);g[fd>>2]=Sd;g[gd>>2]=Pd;g[hd>>2]=Da;g[id>>2]=Ld}Ld=ea(g[s>>2]);Da=ea(g[Lb>>2]);Pd=ea(g[Mb>>2]);Sd=ea(g[Nb>>2]);g[h>>2]=Ld;g[e>>2]=Da;g[Jb>>2]=Pd;g[Kb>>2]=Sd;Sd=ea(g[Sb>>2]);Pd=ea(g[Tb>>2]);Da=ea(g[Ub>>2]);Ld=ea(g[Vb>>2]);g[Ob>>2]=Sd;g[Pb>>2]=Pd;g[Qb>>2]=Da;g[Rb>>2]=Ld;Ld=ea(g[_b>>2]);Da=ea(g[$b>>2]);Pd=ea(g[ac>>2]);Sd=ea(g[bc>>2]);g[Wb>>2]=Ld;g[Xb>>2]=Da;g[Yb>>2]=Pd;g[Zb>>2]=Sd;Zb=ka+4|0;Yb=ka+8|0;Xb=ka+12|0;Wb=ka+16|0;bc=ka+20|0;ac=ka+24|0;$b=ka+28|0;_b=ka+32|0;Rb=ka+36|0;Qb=ka+40|0;Pb=ka+44|0;Ob=0;do{Vb=h+(Ob*76|0)+80|0;IZd(ka,s,Vb);Sd=ea(g[ka>>2]);Pd=ea(g[Zb>>2]);Da=ea(g[Yb>>2]);Ld=ea(g[Xb>>2]);g[Vb>>2]=Sd;g[h+(Ob*76|0)+84>>2]=Pd;g[h+(Ob*76|0)+88>>2]=Da;g[h+(Ob*76|0)+92>>2]=Ld;Ld=ea(g[Wb>>2]);Da=ea(g[bc>>2]);Pd=ea(g[ac>>2]);Sd=ea(g[$b>>2]);g[h+(Ob*76|0)+96>>2]=Ld;g[h+(Ob*76|0)+100>>2]=Da;g[h+(Ob*76|0)+104>>2]=Pd;g[h+(Ob*76|0)+108>>2]=Sd;Sd=ea(g[_b>>2]);Pd=ea(g[Rb>>2]);Da=ea(g[Qb>>2]);Ld=ea(g[Pb>>2]);g[h+(Ob*76|0)+112>>2]=Sd;g[h+(Ob*76|0)+116>>2]=Pd;g[h+(Ob*76|0)+120>>2]=Da;g[h+(Ob*76|0)+124>>2]=Ld;Ob=Ob+1|0}while((Ob|0)!=4);IZd(la,p,q);Ld=ea(g[la>>2]);Da=ea(g[la+4>>2]);Pd=ea(g[la+8>>2]);Sd=ea(g[la+12>>2]);g[Ra>>2]=Ld;g[Sa>>2]=Da;g[Ta>>2]=Pd;g[Ua>>2]=Sd;Sd=ea(g[la+16>>2]);Pd=ea(g[la+20>>2]);Da=ea(g[la+24>>2]);Ld=ea(g[la+28>>2]);g[Ya>>2]=Sd;g[Za>>2]=Pd;g[_a>>2]=Da;g[$a>>2]=Ld;Ld=ea(g[la+32>>2]);Da=ea(g[la+36>>2]);Pd=ea(g[la+40>>2]);Sd=ea(g[la+44>>2]);g[eb>>2]=Ld;g[fb>>2]=Da;g[gb>>2]=Pd;g[hb>>2]=Sd;IZd(ma,p,r);Sd=ea(g[ma>>2]);Pd=ea(g[ma+4>>2]);Da=ea(g[ma+8>>2]);Ld=ea(g[ma+12>>2]);g[mb>>2]=Sd;g[nb>>2]=Pd;g[ob>>2]=Da;g[pb>>2]=Ld;Ld=ea(g[ma+16>>2]);Da=ea(g[ma+20>>2]);Pd=ea(g[ma+24>>2]);Sd=ea(g[ma+28>>2]);g[tb>>2]=Ld;g[ub>>2]=Da;g[vb>>2]=Pd;g[wb>>2]=Sd;Sd=ea(g[ma+32>>2]);Pd=ea(g[ma+36>>2]);Da=ea(g[ma+40>>2]);Ld=ea(g[ma+44>>2]);g[Bb>>2]=Sd;g[Cb>>2]=Pd;g[Db>>2]=Da;g[Eb>>2]=Ld;if(!(a[va>>0]|0)){Ld=ea(g[sa>>2]);if(Ld!=ea(g[d>>2])){Ld=ea(-ea(g[Yd>>2]));Da=ea(-ea(g[Zd>>2]));Pd=ea(-ea(g[_d>>2]));Sd=ea(g[mc>>2]);Qd=ea(g[ge>>2]);Ca=ea(Qd-ea(g[$d>>2]));Qd=ea(g[he>>2]);Od=ea(Qd-ea(g[ae>>2]));Qd=ea(g[ie>>2]);Bd=ea(Qd-ea(g[be>>2]));Qd=ea(g[je>>2]);Rd=ea(Ca+Ca);Cd=ea(Od+Od);Id=ea(Bd+Bd);Nd=ea(Sd*ea(0.0));Kd=ea(ea(Cd*Ld)-ea(Rd*Da));zd=ea(ea(Id*Da)-ea(Cd*Pd));Cd=ea(ea(Rd*Pd)-ea(Id*Ld));Id=ea(Sd*ea(Nd-Nd));Nd=ea(ea(Ca+ea(Sd*zd))+ea(ea(Kd*Da)-ea(Cd*Pd)));Ca=ea(ea(Od+ea(Sd*Cd))+ea(ea(zd*Pd)-ea(Kd*Ld)));Od=ea(ea(Bd+ea(Sd*Kd))+ea(ea(Cd*Ld)-ea(zd*Da)));zd=ea(ea(Id-Id)+ea(Id+ea(Qd-ea(g[ce>>2]))));Qd=ea(g[de>>2]);Id=ea(Qd*Da);Cd=ea(g[rc>>2]);Kd=ea(Sd*Cd);Bd=ea(g[ee>>2]);Rd=ea(Bd*Pd);Md=ea(g[fe>>2]);za=ea(ea(ea(Id-ea(Sd*Md))-ea(Cd*Pd))-ea(Bd*Ld));Id=ea(ea(ea(Kd-ea(Qd*Ld))-ea(Md*Pd))-ea(Bd*Da));Kd=ea(ea(ea(Rd-ea(Md*Da))-ea(Sd*Qd))-ea(Cd*Ld));Rd=ea(ea(ea(ea(Md*Ld)-ea(Qd*Pd))-ea(Sd*Bd))-ea(Cd*Da));Da=ea(ea(1.0)/ea(T(ea(ea(ea(Kd*Kd)+ea(Rd*Rd))+ea(ea(Id*Id)+ea(za*za))))));ke=ea(Da*Id);le=ea(-ea(Da*Kd));me=ea(-ea(Da*Rd));ne=ea(-ea(Da*za));oe=Ca;pe=Od;qe=Nd;re=zd}else{ke=ea(1.0);le=ea(0.0);me=ea(0.0);ne=ea(0.0);oe=ea(0.0);pe=ea(0.0);qe=ea(0.0);re=ea(0.0)}}else{zd=ea(g[n>>2]);Nd=ea(zd-ea(g[m>>2]));m=Nd<ea(0.0);if(m^ea(g[xa>>2])<ea(0.0)){zd=ea(g[t>>2]);m=t+4|0;Od=ea(g[m>>2]);n=t+8|0;Ca=ea(g[n>>2]);ce=t+12|0;za=ea(g[ce>>2]);be=t+16|0;Da=ea(g[be>>2]);ae=t+20|0;Rd=ea(g[ae>>2]);$d=t+24|0;Kd=ea(g[$d>>2]);Id=ea(g[cc>>2]);Cd=ea(g[gc>>2]);Bd=ea(g[fc>>2]);Sd=ea(g[ec>>2]);Pd=ea(g[dc>>2]);Qd=ea(g[u>>2]);Ld=ea(g[x>>2]);Md=ea(g[C>>2]);Jd=ea(g[Qc>>2]);g[t>>2]=Qd;g[m>>2]=Ld;g[n>>2]=Md;g[ce>>2]=Jd;Jd=ea(g[Gc>>2]);Md=ea(g[Jc>>2]);Ld=ea(g[Ic>>2]);Qd=ea(g[hc>>2]);g[be>>2]=Jd;g[ae>>2]=Md;g[$d>>2]=Ld;g[cc>>2]=Qd;Qd=ea(g[lc>>2]);Ld=ea(g[kc>>2]);Md=ea(g[jc>>2]);Jd=ea(g[ic>>2]);g[gc>>2]=Qd;g[fc>>2]=Ld;g[ec>>2]=Md;g[dc>>2]=Jd;g[u>>2]=zd;g[x>>2]=Od;g[C>>2]=Ca;g[Qc>>2]=za;g[Gc>>2]=Da;g[Jc>>2]=Rd;g[Ic>>2]=Kd;g[hc>>2]=Id;g[lc>>2]=Cd;g[kc>>2]=Bd;g[jc>>2]=Sd;g[ic>>2]=Pd}vZd(na,w,v,t,u,~~ea(S(ea(Nd))));Nd=ea(g[na>>2]);Pd=ea(g[na+4>>2]);Sd=ea(g[na+8>>2]);Bd=ea(g[na+12>>2]);Cd=ea(g[na+16>>2]);Id=ea(g[na+20>>2]);Kd=ea(g[na+24>>2]);ke=ea(g[na+28>>2]);le=Cd;me=Id;ne=Kd;oe=Pd;pe=Sd;qe=Nd;re=Bd}na=ke==ea(0.0);Bd=na?ea(9.99999997e-07):ke;ke=ea(le/Bd);le=ea(me/Bd);me=ea(ne/Bd);if(Ea){se=ke;te=le;ue=me;ve=qe;we=oe;xe=pe}else{me=(a[b+1624>>0]|0)==0?oe:ea(0.0);Ea=(a[b+1625>>0]|0)==0;oe=Ea?pe:ea(0.0);pe=Ea?qe:ea(0.0);se=ea(0.0);te=(a[b+1623>>0]|0)==0?le:ea(0.0);ue=ea(0.0);ve=pe;we=me;xe=oe}oe=ea(ea(1.0)/ea(T(ea(ea(ea(ue*ue)+ea(1.0))+ea(ea(te*te)+ea(se*se))))));me=ea(se*oe);se=ea(te*oe);te=ea(ue*oe);b=f+372|0;ue=ea(-ea(g[de>>2]));pe=ea(-ea(g[ee>>2]));le=ea(-ea(g[fe>>2]));qe=ea(g[rc>>2]);ke=ea(g[F>>2]);Bd=ea(ke-ea(g[ge>>2]));ke=ea(g[Pc>>2]);ne=ea(ke-ea(g[he>>2]));ke=ea(g[Oc>>2]);Nd=ea(ke-ea(g[ie>>2]));ke=ea(g[Nc>>2]);Sd=ea(Bd+Bd);Pd=ea(ne+ne);Kd=ea(Nd+Nd);Id=ea(qe*ea(0.0));Cd=ea(ea(Pd*ue)-ea(Sd*pe));Rd=ea(ea(Kd*pe)-ea(Pd*le));Pd=ea(ea(Sd*le)-ea(Kd*ue));Kd=ea(qe*ea(Id-Id));Id=ea(ea(Bd+ea(qe*Rd))+ea(ea(Cd*pe)-ea(Pd*le)));Bd=ea(ea(ne+ea(qe*Pd))+ea(ea(Rd*le)-ea(Cd*ue)));ne=ea(ea(Nd+ea(qe*Cd))+ea(ea(Pd*ue)-ea(Rd*pe)));Rd=ea(ea(Kd-Kd)+ea(Kd+ea(ke-ea(g[je>>2]))));ke=ea(g[Hc>>2]);Kd=ea(ke*pe);Pd=ea(g[Kc>>2]);Cd=ea(qe*Pd);Nd=ea(g[Mc>>2]);Sd=ea(Nd*le);Da=ea(g[Lc>>2]);za=ea(ea(ea(Kd-ea(qe*Da))-ea(Pd*le))-ea(Nd*ue));Kd=ea(ea(ea(Cd-ea(ke*ue))-ea(Da*le))-ea(Nd*pe));Cd=ea(ea(ea(Sd-ea(Da*pe))-ea(qe*ke))-ea(Pd*ue));Sd=ea(ea(ea(ea(Da*ue)-ea(ke*le))-ea(qe*Nd))-ea(Pd*pe));pe=ea(ea(1.0)/ea(T(ea(ea(ea(Cd*Cd)+ea(Sd*Sd))+ea(ea(Kd*Kd)+ea(za*za))))));Pd=ea(-ea(pe*Cd));Cd=ea(-ea(pe*Sd));Sd=ea(-ea(pe*za));za=ea(pe*Kd);g[b>>2]=Id;Lc=f+376|0;g[Lc>>2]=Bd;Mc=f+380|0;g[Mc>>2]=ne;Kc=f+384|0;g[Kc>>2]=Rd;Hc=f+388|0;g[Hc>>2]=Pd;Nc=f+392|0;g[Nc>>2]=Cd;Oc=f+396|0;g[Oc>>2]=Sd;Pc=f+400|0;g[Pc>>2]=za;F=f+404|0;g[F>>2]=ea(1.0);Ea=f+408|0;g[Ea>>2]=ea(1.0);na=f+412|0;g[na>>2]=ea(1.0);u=f+416|0;g[u>>2]=ea(1.0);if(ya){c$d(h,h);za=ea(-ve);Sd=ea(-se);Cd=ea(-te);Pd=ea(g[Ra>>2]);Rd=ea(g[Sa>>2]);ne=ea(g[Ta>>2]);Bd=ea(g[Ua>>2]);Id=ea(g[Ya>>2]);Kd=ea(g[Za>>2]);pe=ea(g[_a>>2]);Nd=ea(g[$a>>2]);qe=ea(g[eb>>2]);le=ea(g[fb>>2]);ke=ea(g[gb>>2]);ue=ea(g[hb>>2]);Da=ea(-Pd);Pd=ea(-pe);Ca=ea(g[mb>>2]);Od=ea(g[nb>>2]);zd=ea(g[ob>>2]);Jd=ea(g[pb>>2]);Md=ea(g[tb>>2]);Ld=ea(g[ub>>2]);Qd=ea(g[vb>>2]);Ad=ea(g[wb>>2]);xd=ea(g[Bb>>2]);Cc=ea(g[Cb>>2]);wd=ea(g[Db>>2]);bd=ea(g[Eb>>2]);yd=ea(-Qd);g[Ra>>2]=ea(-Ca);g[Sa>>2]=Od;g[Ta>>2]=zd;g[Ua>>2]=Jd;g[eb>>2]=xd;g[fb>>2]=Cc;g[gb>>2]=wd;g[hb>>2]=bd;g[mb>>2]=Da;g[nb>>2]=Rd;g[ob>>2]=ne;g[pb>>2]=Bd;g[Bb>>2]=qe;g[Cb>>2]=le;g[Db>>2]=ke;g[Eb>>2]=ue;ue=ea(Ld*ea(-0.0));ke=ea(Ad*ea(0.0));le=ea(Md*ea(0.0));qe=ea(Qd*ea(-0.0));Qd=ea(ea(ea(ue-ke)-qe)-Md);Md=ea(ea(ea(ke-le)-qe)+Ld);Ld=ea(ea(ea(yd-ue)-ke)-le);ke=ea(ea(ea(le-qe)-Ad)-ue);ue=ea(ea(1.0)/ea(T(ea(ea(ea(Ld*Ld)+ea(ke*ke))+ea(ea(Qd*Qd)+ea(Md*Md))))));Ad=ea(-ea(ue*ke));ke=ea(-ea(Qd*ue));Qd=ea(ue*Md);g[Ya>>2]=ea(-ea(Ld*ue));g[Za>>2]=Ad;g[_a>>2]=ke;g[$a>>2]=Qd;Qd=ea(Kd*ea(-0.0));ke=ea(Nd*ea(0.0));Ad=ea(Id*ea(0.0));ue=ea(pe*ea(-0.0));pe=ea(ea(ea(Qd-ke)-ue)-Id);Id=ea(ea(ea(ke-Ad)-ue)+Kd);Kd=ea(ea(ea(Pd-Qd)-ke)-Ad);ke=ea(ea(ea(Ad-ue)-Nd)-Qd);Qd=ea(ea(1.0)/ea(T(ea(ea(ea(Kd*Kd)+ea(ke*ke))+ea(ea(pe*pe)+ea(Id*Id))))));Nd=ea(-ea(Qd*ke));ke=ea(-ea(pe*Qd));pe=ea(Qd*Id);g[tb>>2]=ea(-ea(Kd*Qd));g[ub>>2]=Nd;g[vb>>2]=ke;g[wb>>2]=pe;pe=ea(g[b>>2]);ke=ea(g[Nc>>2]);Nd=ea(-ke);ke=ea(-ea(g[Oc>>2]));g[b>>2]=ea(-pe);g[Nc>>2]=Nd;g[Oc>>2]=ke;wb=c[N>>2]|0;if((wb|0)>0){ke=ea(g[E>>2]);Nd=ea(g[pc>>2]);pe=ea(-Nd);Nd=ea(-ea(g[qc>>2]));g[E>>2]=ea(-ke);g[pc>>2]=pe;g[qc>>2]=Nd;if((wb|0)>1){Nd=ea(g[G>>2]);qc=G+16|0;pe=ea(g[qc>>2]);pc=G+20|0;ke=ea(g[pc>>2]);vb=G+24|0;Qd=ea(g[vb>>2]);Kd=ea(g[ed>>2]);Id=ea(-ke);ue=ea(-Qd);g[G>>2]=ea(-Nd);ub=(wb|0)>3;Nd=ub?ea(0.0):ea(1.0);Ad=ub?ea(1.0):ea(0.0);Pd=ea(ke*ea(-0.0));ke=ea(Kd*ea(0.0));Ld=ea(pe*ea(0.0));Md=ea(Qd*ea(-0.0));Qd=ea(ea(ea(Pd-ea(Ad*Kd))-Md)-ea(Nd*pe));qe=ea(ea(ea(ke-Ld)-ea(Ad*ue))-ea(Nd*Id));le=ea(ea(ea(ea(Nd*ue)-ea(Ad*Id))-ke)-Ld);Ld=ea(ea(ea(ea(Ad*pe)-Md)-ea(Kd*Nd))-Pd);Pd=ea(ea(1.0)/ea(T(ea(ea(ea(le*le)+ea(Ld*Ld))+ea(ea(Qd*Qd)+ea(qe*qe))))));Nd=ea(-ea(Pd*Ld));Ld=ea(-ea(Qd*Pd));Qd=ea(Pd*qe);g[qc>>2]=ea(-ea(Pd*le));g[pc>>2]=Nd;g[vb>>2]=Ld;g[ed>>2]=Qd;ye=za;ze=Sd;Ae=Cd;Be=56}else{ye=za;ze=Sd;Ae=Cd;Be=56}}else{Ce=za;De=Sd;Ee=Cd}}else if((c[N>>2]|0)>0){ye=ve;ze=se;Ae=te;Be=56}else{Ce=ve;De=se;Ee=te}if((Be|0)==56){IZd(oa,b,E);te=ea(g[oa>>2]);se=ea(g[oa+4>>2]);ve=ea(g[oa+8>>2]);Cd=ea(g[oa+12>>2]);g[b>>2]=te;g[Lc>>2]=se;g[Mc>>2]=ve;g[Kc>>2]=Cd;Cd=ea(g[oa+16>>2]);ve=ea(g[oa+20>>2]);se=ea(g[oa+24>>2]);te=ea(g[oa+28>>2]);g[Hc>>2]=Cd;g[Nc>>2]=ve;g[Oc>>2]=se;g[Pc>>2]=te;te=ea(g[oa+32>>2]);se=ea(g[oa+36>>2]);ve=ea(g[oa+40>>2]);Cd=ea(g[oa+44>>2]);g[F>>2]=te;g[Ea>>2]=se;g[na>>2]=ve;g[u>>2]=Cd;if((c[N>>2]|0)>1){IZd(pa,b,G);Cd=ea(g[pa>>2]);ve=ea(g[pa+4>>2]);se=ea(g[pa+8>>2]);te=ea(g[pa+12>>2]);g[b>>2]=Cd;g[Lc>>2]=ve;g[Mc>>2]=se;g[Kc>>2]=te;te=ea(g[pa+16>>2]);se=ea(g[pa+20>>2]);ve=ea(g[pa+24>>2]);Cd=ea(g[pa+28>>2]);g[Hc>>2]=te;g[Nc>>2]=se;g[Oc>>2]=ve;g[Pc>>2]=Cd;Cd=ea(g[pa+32>>2]);ve=ea(g[pa+36>>2]);se=ea(g[pa+40>>2]);te=ea(g[pa+44>>2]);g[F>>2]=Cd;g[Ea>>2]=ve;g[na>>2]=se;g[u>>2]=te;Ce=ye;De=ze;Ee=Ae}else{Ce=ye;De=ze;Ee=Ae}}Ae=ea(g[ge>>2]);ze=ea(g[he>>2]);ye=ea(g[ie>>2]);te=ea(g[je>>2]);g[f+84>>2]=Ae;g[f+88>>2]=ze;g[f+92>>2]=ye;g[f+96>>2]=te;te=ea(g[de>>2]);ye=ea(g[ee>>2]);ze=ea(g[fe>>2]);Ae=ea(g[rc>>2]);g[f+100>>2]=te;g[f+104>>2]=ye;g[f+108>>2]=ze;g[f+112>>2]=Ae;Ae=ea(g[vc>>2]);ze=ea(g[uc>>2]);ye=ea(g[tc>>2]);te=ea(g[sc>>2]);g[f+116>>2]=Ae;g[f+120>>2]=ze;g[f+124>>2]=ye;g[f+128>>2]=te;te=ea(g[xa>>2]);if(!(te!=ea(0.0))){Fe=ea(0.0);g[f>>2]=Fe;Ge=ea(Ce/Fe);He=ea(we/Fe);Ie=ea(xe/Fe);Je=ea(re/Fe);Ke=Fe!=ea(0.0);Le=Ke?Ge:ea(0.0);Me=Ke?He:ea(0.0);Ne=Ke?Ie:ea(0.0);Oe=Ke?Je:ea(0.0);Pe=f+4|0;g[Pe>>2]=Le;Qe=f+8|0;g[Qe>>2]=Me;Re=f+12|0;g[Re>>2]=Ne;Se=f+16|0;g[Se>>2]=Oe;Te=ea(me*me);Ue=ea(De*De);Ve=ea(Ee*Ee);We=ea(oe*oe);Xe=ea(Te+Ue);Ye=ea(We+Ve);Ze=ea(Xe+Ye);_e=ea(T(ea(Ze)));$e=ea(ea(1.0)/_e);af=ea(me*$e);bf=ea(De*$e);cf=ea(Ee*$e);df=ea(af*af);ef=ea(bf*bf);ff=ea(cf*cf);gf=ea(df+ef);hf=ea(ff+ea(0.0));jf=ea(gf+hf);kf=ea(T(ea(jf)));lf=ea(+Z(+kf));mf=ea(lf*ea(2.0));nf=ea(af*mf);of=ea(nf/kf);pf=ea(bf*mf);qf=ea(pf/kf);rf=ea(cf*mf);sf=ea(rf/kf);tf=kf!=ea(0.0);uf=tf?of:ea(0.0);vf=tf?qf:ea(0.0);wf=tf?sf:ea(0.0);xf=ea(uf/Fe);yf=ea(vf/Fe);zf=ea(wf/Fe);Af=ea(ea(0.0)/Fe);Bf=Ke?xf:ea(0.0);Cf=Ke?yf:ea(0.0);Df=Ke?zf:ea(0.0);Ef=Ke?Af:ea(0.0);Ff=f+20|0;g[Ff>>2]=Bf;Gf=f+24|0;g[Gf>>2]=Cf;Hf=f+28|0;g[Hf>>2]=Df;If=f+32|0;g[If>>2]=Ef;i=l;return}ye=ea(g[d>>2]);ze=ea(ye-ea(g[sa>>2]));ye=ea(g[ua>>2]);Fe=ea(ea(ze*ea(ye-ea(g[ta>>2])))/ea(S(ea(te))));g[f>>2]=Fe;Ge=ea(Ce/Fe);He=ea(we/Fe);Ie=ea(xe/Fe);Je=ea(re/Fe);Ke=Fe!=ea(0.0);Le=Ke?Ge:ea(0.0);Me=Ke?He:ea(0.0);Ne=Ke?Ie:ea(0.0);Oe=Ke?Je:ea(0.0);Pe=f+4|0;g[Pe>>2]=Le;Qe=f+8|0;g[Qe>>2]=Me;Re=f+12|0;g[Re>>2]=Ne;Se=f+16|0;g[Se>>2]=Oe;Te=ea(me*me);Ue=ea(De*De);Ve=ea(Ee*Ee);We=ea(oe*oe);Xe=ea(Te+Ue);Ye=ea(We+Ve);Ze=ea(Xe+Ye);_e=ea(T(ea(Ze)));$e=ea(ea(1.0)/_e);af=ea(me*$e);bf=ea(De*$e);cf=ea(Ee*$e);df=ea(af*af);ef=ea(bf*bf);ff=ea(cf*cf);gf=ea(df+ef);hf=ea(ff+ea(0.0));jf=ea(gf+hf);kf=ea(T(ea(jf)));lf=ea(+Z(+kf));mf=ea(lf*ea(2.0));nf=ea(af*mf);of=ea(nf/kf);pf=ea(bf*mf);qf=ea(pf/kf);rf=ea(cf*mf);sf=ea(rf/kf);tf=kf!=ea(0.0);uf=tf?of:ea(0.0);vf=tf?qf:ea(0.0);wf=tf?sf:ea(0.0);xf=ea(uf/Fe);yf=ea(vf/Fe);zf=ea(wf/Fe);Af=ea(ea(0.0)/Fe);Bf=Ke?xf:ea(0.0);Cf=Ke?yf:ea(0.0);Df=Ke?zf:ea(0.0);Ef=Ke?Af:ea(0.0);Ff=f+20|0;g[Ff>>2]=Bf;Gf=f+24|0;g[Gf>>2]=Cf;Hf=f+28|0;g[Hf>>2]=Df;If=f+32|0;g[If>>2]=Ef;i=l;return}function zZd(a){a=a|0;var b=0;b=a+1040|0;a=(c[b>>2]|0)+b|0;return (c[a+20>>2]|0)+(c[a+12>>2]|0)+(c[a+44>>2]|0)|0}function AZd(){var b=0,c=0;b=i;c=697672;do{a[c>>0]=0;c=c+128|0}while((c|0)!=(714824|0));i=b;return}function BZd(a,b){a=a|0;b=b|0;return (c[a+4>>2]|0)>>>0<(c[b+4>>2]|0)>>>0|0}function CZd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;e=i;i=i+256|0;f=e+248|0;g=e+240|0;h=e+88|0;j=e+104|0;k=e+96|0;l=e+32|0;m=e+40|0;n=e+48|0;o=e+56|0;p=e+64|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+112|0;w=e+232|0;x=e+128|0;y=e+136|0;z=e+144|0;A=e+24|0;B=e+16|0;C=e+152|0;D=e+72|0;E=e;F=e+8|0;G=e+80|0;H=e+168|0;I=e+184|0;J=e+216|0;K=e+120|0;L=e+200|0;M=a;a=b;a:while(1){b=a;N=a+-8|0;O=M;b:while(1){P=O;Q=b-P|0;R=Q>>3;switch(R|0){case 2:{S=O;T=N;U=4;break a;break}case 3:{V=O;W=N;U=6;break a;break}case 5:{X=O;Y=N;U=11;break a;break}case 4:{Z=O;_=N;U=7;break a;break}case 1:case 0:{U=56;break a;break}default:{}}if((Q|0)<248){$=O;aa=a;U=13;break a}ba=(R|0)/2|0;ca=O+(ba<<3)|0;if((Q|0)>7992){Q=(R|0)/4|0;da=KZd(O,O+(Q<<3)|0,ca,O+(Q+ba<<3)|0,N,d)|0}else da=JZd(O,ca,N,d)|0;ba=c[d>>2]|0;Q=O;R=c[Q+4>>2]|0;ea=u;c[ea>>2]=c[Q>>2];c[ea+4>>2]=R;R=ca;ea=c[R+4>>2]|0;Q=v;c[Q>>2]=c[R>>2];c[Q+4>>2]=ea;c[g+0>>2]=c[u+0>>2];c[g+4>>2]=c[u+4>>2];c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];do if(_n[ba&4095](g,f)|0){fa=N;ga=da}else{ea=a;Q=N;while(1){R=ea+-16|0;if((O|0)==(R|0))break;ha=c[d>>2]|0;ia=R;ja=c[ia+4>>2]|0;ka=E;c[ka>>2]=c[ia>>2];c[ka+4>>2]=ja;ja=ca;ka=c[ja+4>>2]|0;ia=F;c[ia>>2]=c[ja>>2];c[ia+4>>2]=ka;c[g+0>>2]=c[E+0>>2];c[g+4>>2]=c[E+4>>2];c[f+0>>2]=c[F+0>>2];c[f+4>>2]=c[F+4>>2];if(_n[ha&4095](g,f)|0){la=R;ma=R;U=38;break}else{ha=Q;Q=R;ea=ha}}if((U|0)==38){U=0;ea=O;Q=c[ea>>2]|0;ha=c[ea+4>>2]|0;ea=ma;R=c[ea+4>>2]|0;ka=O;c[ka>>2]=c[ea>>2];c[ka+4>>2]=R;R=ma;c[R>>2]=Q;c[R+4>>2]=ha;fa=la;ga=da+1|0;break}ha=O+8|0;R=c[d>>2]|0;Q=O;ka=c[Q+4>>2]|0;ea=w;c[ea>>2]=c[Q>>2];c[ea+4>>2]=ka;ka=N;ea=c[ka+4>>2]|0;Q=x;c[Q>>2]=c[ka>>2];c[Q+4>>2]=ea;c[g+0>>2]=c[w+0>>2];c[g+4>>2]=c[w+4>>2];c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];if(_n[R&4095](g,f)|0)na=ha;else{if((ha|0)==(N|0)){U=56;break a}else{oa=O;pa=ha}while(1){ha=c[d>>2]|0;R=O;ea=c[R+4>>2]|0;Q=y;c[Q>>2]=c[R>>2];c[Q+4>>2]=ea;ea=pa;Q=c[ea+4>>2]|0;R=z;c[R>>2]=c[ea>>2];c[R+4>>2]=Q;c[g+0>>2]=c[y+0>>2];c[g+4>>2]=c[y+4>>2];c[f+0>>2]=c[z+0>>2];c[f+4>>2]=c[z+4>>2];Q=oa+16|0;if(_n[ha&4095](g,f)|0){qa=pa;ra=pa;break}if((Q|0)==(N|0)){U=56;break a}else{ha=pa;pa=Q;oa=ha}}ha=qa;Q=c[ha>>2]|0;R=c[ha+4>>2]|0;ha=N;ea=c[ha+4>>2]|0;ka=qa;c[ka>>2]=c[ha>>2];c[ka+4>>2]=ea;ea=N;c[ea>>2]=Q;c[ea+4>>2]=R;na=ra+8|0}if((na|0)==(N|0)){U=56;break a}else{sa=na;ta=N}while(1){R=sa;while(1){ea=c[d>>2]|0;Q=O;ka=c[Q+4>>2]|0;ha=A;c[ha>>2]=c[Q>>2];c[ha+4>>2]=ka;ka=R;ha=c[ka+4>>2]|0;Q=B;c[Q>>2]=c[ka>>2];c[Q+4>>2]=ha;c[g+0>>2]=c[A+0>>2];c[g+4>>2]=c[A+4>>2];c[f+0>>2]=c[B+0>>2];c[f+4>>2]=c[B+4>>2];ha=R+8|0;if(_n[ea&4095](g,f)|0){ua=R;va=ha;wa=R;break}else R=ha}R=ta;while(1){ha=c[d>>2]|0;ea=O;Q=c[ea+4>>2]|0;ka=C;c[ka>>2]=c[ea>>2];c[ka+4>>2]=Q;Q=R+-8|0;ka=Q;ea=c[ka+4>>2]|0;ia=D;c[ia>>2]=c[ka>>2];c[ia+4>>2]=ea;c[g+0>>2]=c[C+0>>2];c[g+4>>2]=c[C+4>>2];c[f+0>>2]=c[D+0>>2];c[f+4>>2]=c[D+4>>2];if(_n[ha&4095](g,f)|0)R=Q;else{xa=Q;ya=Q;break}}if(wa>>>0>=xa>>>0){O=wa;continue b}R=ua;Q=c[R>>2]|0;ha=c[R+4>>2]|0;R=ya;ea=c[R+4>>2]|0;ia=ua;c[ia>>2]=c[R>>2];c[ia+4>>2]=ea;ea=ya;c[ea>>2]=Q;c[ea+4>>2]=ha;sa=va;ta=xa}}while(0);ba=O+8|0;c:do if(ba>>>0<fa>>>0){ha=ba;ea=fa;Q=ca;ia=ga;while(1){R=ha;while(1){ka=c[d>>2]|0;ja=R;za=c[ja+4>>2]|0;Aa=G;c[Aa>>2]=c[ja>>2];c[Aa+4>>2]=za;za=Q;Aa=c[za+4>>2]|0;ja=H;c[ja>>2]=c[za>>2];c[ja+4>>2]=Aa;c[g+0>>2]=c[G+0>>2];c[g+4>>2]=c[G+4>>2];c[f+0>>2]=c[H+0>>2];c[f+4>>2]=c[H+4>>2];Aa=R+8|0;if(_n[ka&4095](g,f)|0)R=Aa;else{Ba=R;Ca=Aa;Da=R;break}}R=ea;while(1){Aa=c[d>>2]|0;ka=R+-8|0;ja=ka;za=c[ja+4>>2]|0;Ea=I;c[Ea>>2]=c[ja>>2];c[Ea+4>>2]=za;za=Q;Ea=c[za+4>>2]|0;ja=J;c[ja>>2]=c[za>>2];c[ja+4>>2]=Ea;c[g+0>>2]=c[I+0>>2];c[g+4>>2]=c[I+4>>2];c[f+0>>2]=c[J+0>>2];c[f+4>>2]=c[J+4>>2];if(_n[Aa&4095](g,f)|0){Fa=ka;Ga=ka;break}else R=ka}if(Da>>>0>Fa>>>0){Ha=Da;Ia=Q;Ja=ia;break c}R=Ba;ka=c[R>>2]|0;Aa=c[R+4>>2]|0;R=Ga;Ea=c[R+4>>2]|0;ja=Ba;c[ja>>2]=c[R>>2];c[ja+4>>2]=Ea;Ea=Ga;c[Ea>>2]=ka;c[Ea+4>>2]=Aa;ha=Ca;ea=Fa;Q=(Q|0)==(Da|0)?Fa:Q;ia=ia+1|0}}else{Ha=ba;Ia=ca;Ja=ga}while(0);if((Ha|0)!=(Ia|0)?(ca=c[d>>2]|0,ba=Ia,ia=c[ba+4>>2]|0,Q=K,c[Q>>2]=c[ba>>2],c[Q+4>>2]=ia,ia=Ha,Q=c[ia+4>>2]|0,ba=L,c[ba>>2]=c[ia>>2],c[ba+4>>2]=Q,c[g+0>>2]=c[K+0>>2],c[g+4>>2]=c[K+4>>2],c[f+0>>2]=c[L+0>>2],c[f+4>>2]=c[L+4>>2],_n[ca&4095](g,f)|0):0){ca=Ha;Q=c[ca>>2]|0;ba=c[ca+4>>2]|0;ca=Ia;ia=c[ca+4>>2]|0;ea=Ha;c[ea>>2]=c[ca>>2];c[ea+4>>2]=ia;ia=Ia;c[ia>>2]=Q;c[ia+4>>2]=ba;Ka=Ja+1|0}else Ka=Ja;if(!Ka){La=LZd(O,Ha,d)|0;ba=Ha+8|0;if(LZd(ba,a,d)|0){U=51;break}if(La){O=ba;continue}}ba=Ha;if((ba-P|0)>=(b-ba|0)){Ma=O;Na=Ha;U=55;break}CZd(O,Ha,d);O=Ha+8|0}if((U|0)==51){U=0;if(La){U=56;break}else{M=O;a=Ha;continue}}else if((U|0)==55){U=0;CZd(Na+8|0,a,d);M=Ma;a=Na;continue}}if((U|0)==4){Na=c[d>>2]|0;a=T;Ma=c[a+4>>2]|0;M=s;c[M>>2]=c[a>>2];c[M+4>>2]=Ma;Ma=S;M=c[Ma+4>>2]|0;a=t;c[a>>2]=c[Ma>>2];c[a+4>>2]=M;c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];if(!(_n[Na&4095](g,f)|0)){i=e;return}Na=S;t=c[Na>>2]|0;s=c[Na+4>>2]|0;Na=T;M=c[Na+4>>2]|0;a=S;c[a>>2]=c[Na>>2];c[a+4>>2]=M;M=T;c[M>>2]=t;c[M+4>>2]=s;i=e;return}else if((U|0)==6){JZd(V,V+8|0,W,d)|0;i=e;return}else if((U|0)==7){W=Z+8|0;V=Z+16|0;JZd(Z,W,V,d)|0;s=c[d>>2]|0;M=_;t=c[M+4>>2]|0;T=m;c[T>>2]=c[M>>2];c[T+4>>2]=t;t=V;T=c[t+4>>2]|0;M=n;c[M>>2]=c[t>>2];c[M+4>>2]=T;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];if(!(_n[s&4095](g,f)|0)){i=e;return}s=V;n=c[s>>2]|0;m=c[s+4>>2]|0;s=_;T=c[s+4>>2]|0;M=V;c[M>>2]=c[s>>2];c[M+4>>2]=T;T=_;c[T>>2]=n;c[T+4>>2]=m;m=c[d>>2]|0;T=V;n=c[T+4>>2]|0;_=o;c[_>>2]=c[T>>2];c[_+4>>2]=n;n=W;_=c[n+4>>2]|0;T=p;c[T>>2]=c[n>>2];c[T+4>>2]=_;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];if(!(_n[m&4095](g,f)|0)){i=e;return}m=W;p=c[m>>2]|0;o=c[m+4>>2]|0;m=V;_=c[m>>2]|0;T=c[m+4>>2]|0;m=W;c[m>>2]=_;c[m+4>>2]=T;m=V;c[m>>2]=p;c[m+4>>2]=o;o=c[d>>2]|0;m=q;c[m>>2]=_;c[m+4>>2]=T;T=Z;m=c[T+4>>2]|0;_=r;c[_>>2]=c[T>>2];c[_+4>>2]=m;c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];if(!(_n[o&4095](g,f)|0)){i=e;return}o=Z;r=c[o>>2]|0;q=c[o+4>>2]|0;o=W;m=c[o+4>>2]|0;_=Z;c[_>>2]=c[o>>2];c[_+4>>2]=m;m=W;c[m>>2]=r;c[m+4>>2]=q;i=e;return}else if((U|0)==11){KZd(X,X+8|0,X+16|0,X+24|0,Y,d)|0;i=e;return}else if((U|0)==13){Y=$+16|0;JZd($,$+8|0,Y,d)|0;X=$+24|0;if((X|0)==(aa|0)){i=e;return}else{Oa=X;Pa=Y}while(1){Y=c[d>>2]|0;X=Oa;q=c[X+4>>2]|0;m=h;c[m>>2]=c[X>>2];c[m+4>>2]=q;q=Pa;m=c[q+4>>2]|0;X=j;c[X>>2]=c[q>>2];c[X+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];if(_n[Y&4095](g,f)|0){Y=Oa;m=c[Y>>2]|0;X=c[Y+4>>2]|0;Y=Oa;q=Pa;while(1){r=q;W=c[r+4>>2]|0;_=Y;c[_>>2]=c[r>>2];c[_+4>>2]=W;if((q|0)==($|0)){Qa=q;break}W=c[d>>2]|0;_=k;c[_>>2]=m;c[_+4>>2]=X;_=q+-8|0;r=_;o=c[r+4>>2]|0;Z=l;c[Z>>2]=c[r>>2];c[Z+4>>2]=o;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];if(_n[W&4095](g,f)|0){W=q;q=_;Y=W}else{Qa=q;break}}q=Qa;c[q>>2]=m;c[q+4>>2]=X}q=Oa+8|0;if((q|0)==(aa|0))break;else{Y=Oa;Oa=q;Pa=Y}}i=e;return}else if((U|0)==56){i=e;return}}function DZd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=0,C=0,D=Im,E=0,F=0,G=Im;e=i;f=c[a+1100>>2]|0;if((f|0)==-1)h=ea(0.0);else h=ea(g[b+(f<<2)>>2]);f=c[a+1104>>2]|0;if((f|0)==-1)j=ea(0.0);else j=ea(g[b+(f<<2)>>2]);f=c[a+1108>>2]|0;if((f|0)==-1)k=ea(0.0);else k=ea(g[b+(f<<2)>>2]);g[d>>2]=h;g[d+4>>2]=j;g[d+8>>2]=k;g[d+12>>2]=ea(0.0);f=c[a+1112>>2]|0;if((f|0)==-1)l=ea(0.0);else l=ea(g[b+(f<<2)>>2]);f=c[a+1116>>2]|0;if((f|0)==-1)m=ea(0.0);else m=ea(g[b+(f<<2)>>2]);f=c[a+1120>>2]|0;if((f|0)==-1)n=ea(0.0);else n=ea(g[b+(f<<2)>>2]);f=c[a+1124>>2]|0;if((f|0)==-1)o=ea(1.0);else o=ea(g[b+(f<<2)>>2]);k=ea(ea(1.0)/ea(T(ea(ea(ea(l*l)+ea(m*m))+ea(ea(n*n)+ea(o*o))))));j=ea(m*k);m=ea(n*k);n=ea(o*k);g[d+16>>2]=ea(l*k);g[d+20>>2]=j;g[d+24>>2]=m;g[d+28>>2]=n;g[d+32>>2]=ea(1.0);g[d+36>>2]=ea(1.0);g[d+40>>2]=ea(1.0);g[d+44>>2]=ea(1.0);f=14;p=0;while(1){q=c[a+(f<<2)+1072>>2]|0;if((q|0)==-1)r=ea(0.0);else r=ea(g[b+(q<<2)>>2]);q=c[a+(f+1<<2)+1072>>2]|0;if((q|0)==-1)s=ea(0.0);else s=ea(g[b+(q<<2)>>2]);q=c[a+(f+2<<2)+1072>>2]|0;if((q|0)==-1)t=ea(0.0);else t=ea(g[b+(q<<2)>>2]);g[d+(p*76|0)+80>>2]=r;g[d+(p*76|0)+84>>2]=s;g[d+(p*76|0)+88>>2]=t;g[d+(p*76|0)+92>>2]=ea(0.0);q=c[a+(f+3<<2)+1072>>2]|0;if((q|0)==-1)u=ea(0.0);else u=ea(g[b+(q<<2)>>2]);q=c[a+(f+4<<2)+1072>>2]|0;if((q|0)==-1)v=ea(0.0);else v=ea(g[b+(q<<2)>>2]);q=c[a+(f+5<<2)+1072>>2]|0;if((q|0)==-1)w=ea(0.0);else w=ea(g[b+(q<<2)>>2]);q=c[a+(f+6<<2)+1072>>2]|0;if((q|0)==-1)x=ea(1.0);else x=ea(g[b+(q<<2)>>2]);n=ea(ea(1.0)/ea(T(ea(ea(ea(u*u)+ea(v*v))+ea(ea(x*x)+ea(w*w))))));m=ea(v*n);j=ea(w*n);k=ea(x*n);g[d+(p*76|0)+96>>2]=ea(u*n);g[d+(p*76|0)+100>>2]=m;g[d+(p*76|0)+104>>2]=j;g[d+(p*76|0)+108>>2]=k;p=p+1|0;if((p|0)==4){y=42;z=0;break}else f=f+7|0}while(1){f=c[a+(y<<2)+1072>>2]|0;if((f|0)==-1)A=ea(0.0);else A=ea(g[b+(f<<2)>>2]);g[d+(z<<2)+672>>2]=A;z=z+1|0;if((z|0)==52){B=94;C=0;break}else y=y+1|0}while(1){y=c[a+(B<<2)+1072>>2]|0;if((y|0)==-1)D=ea(0.0);else D=ea(g[b+(y<<2)>>2]);g[d+(C<<2)+432>>2]=D;C=C+1|0;if((C|0)==20){E=114;F=0;break}else B=B+1|0}while(1){B=c[a+(E<<2)+1072>>2]|0;if((B|0)==-1)G=ea(0.0);else G=ea(g[b+(B<<2)>>2]);g[d+(F<<2)+576>>2]=G;F=F+1|0;if((F|0)==20)break;else E=E+1|0}i=e;return}function EZd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0,A=Im,B=0,C=0,D=Im,E=0,F=0,G=Im;e=i;f=c[a+1100>>2]|0;if((f|0)==-1)h=ea(0.0);else h=ea(g[b+(f<<3)>>2]);f=c[a+1104>>2]|0;if((f|0)==-1)j=ea(0.0);else j=ea(g[b+(f<<3)>>2]);f=c[a+1108>>2]|0;if((f|0)==-1)k=ea(0.0);else k=ea(g[b+(f<<3)>>2]);g[d>>2]=h;g[d+4>>2]=j;g[d+8>>2]=k;g[d+12>>2]=ea(0.0);f=c[a+1112>>2]|0;if((f|0)==-1)l=ea(0.0);else l=ea(g[b+(f<<3)>>2]);f=c[a+1116>>2]|0;if((f|0)==-1)m=ea(0.0);else m=ea(g[b+(f<<3)>>2]);f=c[a+1120>>2]|0;if((f|0)==-1)n=ea(0.0);else n=ea(g[b+(f<<3)>>2]);f=c[a+1124>>2]|0;if((f|0)==-1)o=ea(1.0);else o=ea(g[b+(f<<3)>>2]);k=ea(ea(1.0)/ea(T(ea(ea(ea(l*l)+ea(m*m))+ea(ea(n*n)+ea(o*o))))));j=ea(m*k);m=ea(n*k);n=ea(o*k);g[d+16>>2]=ea(l*k);g[d+20>>2]=j;g[d+24>>2]=m;g[d+28>>2]=n;g[d+32>>2]=ea(1.0);g[d+36>>2]=ea(1.0);g[d+40>>2]=ea(1.0);g[d+44>>2]=ea(1.0);f=14;p=0;while(1){q=c[a+(f<<2)+1072>>2]|0;if((q|0)==-1)r=ea(0.0);else r=ea(g[b+(q<<3)>>2]);q=c[a+(f+1<<2)+1072>>2]|0;if((q|0)==-1)s=ea(0.0);else s=ea(g[b+(q<<3)>>2]);q=c[a+(f+2<<2)+1072>>2]|0;if((q|0)==-1)t=ea(0.0);else t=ea(g[b+(q<<3)>>2]);g[d+(p*76|0)+80>>2]=r;g[d+(p*76|0)+84>>2]=s;g[d+(p*76|0)+88>>2]=t;g[d+(p*76|0)+92>>2]=ea(0.0);q=c[a+(f+3<<2)+1072>>2]|0;if((q|0)==-1)u=ea(0.0);else u=ea(g[b+(q<<3)>>2]);q=c[a+(f+4<<2)+1072>>2]|0;if((q|0)==-1)v=ea(0.0);else v=ea(g[b+(q<<3)>>2]);q=c[a+(f+5<<2)+1072>>2]|0;if((q|0)==-1)w=ea(0.0);else w=ea(g[b+(q<<3)>>2]);q=c[a+(f+6<<2)+1072>>2]|0;if((q|0)==-1)x=ea(1.0);else x=ea(g[b+(q<<3)>>2]);n=ea(ea(1.0)/ea(T(ea(ea(ea(u*u)+ea(v*v))+ea(ea(x*x)+ea(w*w))))));m=ea(v*n);j=ea(w*n);k=ea(x*n);g[d+(p*76|0)+96>>2]=ea(u*n);g[d+(p*76|0)+100>>2]=m;g[d+(p*76|0)+104>>2]=j;g[d+(p*76|0)+108>>2]=k;p=p+1|0;if((p|0)==4){y=42;z=0;break}else f=f+7|0}while(1){f=c[a+(y<<2)+1072>>2]|0;if((f|0)==-1)A=ea(0.0);else A=ea(g[b+(f<<3)>>2]);g[d+(z<<2)+672>>2]=A;z=z+1|0;if((z|0)==52){B=94;C=0;break}else y=y+1|0}while(1){y=c[a+(B<<2)+1072>>2]|0;if((y|0)==-1)D=ea(0.0);else D=ea(g[b+(y<<3)>>2]);g[d+(C<<2)+432>>2]=D;C=C+1|0;if((C|0)==20){E=114;F=0;break}else B=B+1|0}while(1){B=c[a+(E<<2)+1072>>2]|0;if((B|0)==-1)G=ea(0.0);else G=ea(g[b+(B<<3)>>2]);g[d+(F<<2)+576>>2]=G;F=F+1|0;if((F|0)==20)break;else E=E+1|0}i=e;return}function FZd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;d=ea(g[c>>2]);e=ea(d+d);f=ea(g[c+4>>2]);h=ea(f+f);i=ea(g[c+8>>2]);j=ea(i+i);k=ea(g[c+12>>2]);l=ea(g[b+16>>2]);m=ea(h*l);n=ea(g[b+20>>2]);o=ea(j*n);p=ea(g[b+24>>2]);q=ea(e*p);r=ea(g[b+28>>2]);s=ea(r*ea(0.0));t=ea(m-ea(e*n));e=ea(o-ea(h*p));h=ea(q-ea(j*l));j=ea(r*ea(s-s));s=ea(ea(d+ea(r*e))+ea(ea(n*t)-ea(p*h)));d=ea(ea(f+ea(r*h))+ea(ea(p*e)-ea(l*t)));f=ea(ea(i+ea(t*r))+ea(ea(l*h)-ea(n*e)));e=ea(ea(k+j)+ea(j-j));j=ea(ea(g[b>>2])+s);s=ea(ea(g[b+4>>2])+d);d=ea(ea(g[b+8>>2])+f);f=ea(ea(g[b+12>>2])+e);e=ea(g[c+16>>2]);k=ea(n*e);h=ea(g[c+28>>2]);t=ea(r*h);i=ea(g[c+20>>2]);q=ea(p*i);o=ea(g[c+24>>2]);m=ea(ea(ea(k-ea(r*o))-ea(h*p))-ea(i*l));k=ea(ea(ea(t-ea(e*l))-ea(p*o))-ea(n*i));t=ea(ea(ea(q-ea(n*o))-ea(e*r))-ea(h*l));q=ea(ea(ea(ea(l*o)-ea(e*p))-ea(r*i))-ea(n*h));h=ea(ea(1.0)/ea(T(ea(ea(ea(t*t)+ea(q*q))+ea(ea(k*k)+ea(m*m))))));n=ea(-ea(h*t));t=ea(-ea(h*q));q=ea(-ea(h*m));m=ea(h*k);g[a>>2]=j;g[a+4>>2]=s;g[a+8>>2]=d;g[a+12>>2]=f;g[a+16>>2]=n;g[a+20>>2]=t;g[a+24>>2]=q;g[a+28>>2]=m;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);return}function GZd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;d=ea(-ea(g[b+16>>2]));e=ea(-ea(g[b+20>>2]));f=ea(-ea(g[b+24>>2]));h=ea(g[b+28>>2]);i=ea(g[c>>2]);j=ea(i-ea(g[b>>2]));i=ea(g[c+4>>2]);k=ea(i-ea(g[b+4>>2]));i=ea(g[c+8>>2]);l=ea(i-ea(g[b+8>>2]));i=ea(g[c+12>>2]);m=ea(j+j);n=ea(k+k);o=ea(l+l);p=ea(h*ea(0.0));q=ea(ea(n*d)-ea(m*e));r=ea(ea(o*e)-ea(n*f));n=ea(ea(m*f)-ea(o*d));o=ea(h*ea(p-p));p=ea(ea(j+ea(h*r))+ea(ea(q*e)-ea(n*f)));j=ea(ea(k+ea(h*n))+ea(ea(r*f)-ea(q*d)));k=ea(ea(l+ea(h*q))+ea(ea(n*d)-ea(r*e)));r=ea(ea(o-o)+ea(o+ea(i-ea(g[b+12>>2]))));i=ea(g[c+16>>2]);o=ea(i*e);n=ea(g[c+28>>2]);q=ea(h*n);l=ea(g[c+20>>2]);m=ea(l*f);s=ea(g[c+24>>2]);t=ea(ea(ea(o-ea(h*s))-ea(n*f))-ea(l*d));o=ea(ea(ea(q-ea(i*d))-ea(s*f))-ea(l*e));q=ea(ea(ea(m-ea(s*e))-ea(h*i))-ea(n*d));m=ea(ea(ea(ea(s*d)-ea(i*f))-ea(h*l))-ea(n*e));e=ea(ea(1.0)/ea(T(ea(ea(ea(q*q)+ea(m*m))+ea(ea(o*o)+ea(t*t))))));n=ea(-ea(e*q));q=ea(-ea(e*m));m=ea(-ea(e*t));t=ea(e*o);g[a>>2]=p;g[a+4>>2]=j;g[a+8>>2]=k;g[a+12>>2]=r;g[a+16>>2]=n;g[a+20>>2]=q;g[a+24>>2]=m;g[a+28>>2]=t;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);return}function HZd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;d=ea(-ea(g[c+16>>2]));e=ea(-ea(g[c+20>>2]));f=ea(-ea(g[c+24>>2]));h=ea(g[c+28>>2]);i=ea(ea(1.0)/ea(g[c+32>>2]));j=ea(ea(1.0)/ea(g[c+36>>2]));k=ea(ea(1.0)/ea(g[c+40>>2]));l=ea(ea(1.0)/ea(g[c+44>>2]));m=ea(g[c>>2]);n=ea(-m);o=ea(g[c+4>>2]);p=ea(-o);q=ea(g[c+8>>2]);r=ea(-q);s=ea(n-m);n=ea(p-o);p=ea(r-q);r=ea(h*ea(0.0));t=ea(ea(n*d)-ea(s*e));u=ea(ea(p*e)-ea(n*f));n=ea(ea(s*f)-ea(p*d));p=ea(h*ea(r-r));r=ea(i*ea(ea(ea(h*u)-m)+ea(ea(t*e)-ea(n*f))));m=ea(j*ea(ea(ea(h*n)-o)+ea(ea(u*f)-ea(t*d))));o=ea(k*ea(ea(ea(h*t)-q)+ea(ea(n*d)-ea(u*e))));u=ea(l*ea(ea(p-p)+ea(p-ea(g[c+12>>2]))));c=b+32|0;p=ea(ea(g[c>>2])*r);v=b+36|0;r=ea(ea(g[v>>2])*m);w=b+40|0;m=ea(ea(g[w>>2])*o);x=b+44|0;o=ea(u*ea(g[x>>2]));u=ea(p+p);n=ea(r+r);q=ea(m+m);t=ea(g[b+16>>2]);s=ea(t*n);y=ea(g[b+20>>2]);z=ea(y*q);A=ea(g[b+24>>2]);B=ea(A*u);C=ea(g[b+28>>2]);D=ea(C*ea(0.0));E=ea(s-ea(y*u));u=ea(z-ea(A*n));n=ea(B-ea(t*q));q=ea(C*ea(D-D));D=ea(ea(p+ea(C*u))+ea(ea(y*E)-ea(A*n)));p=ea(ea(r+ea(C*n))+ea(ea(A*u)-ea(t*E)));r=ea(ea(m+ea(C*E))+ea(ea(t*n)-ea(y*u)));u=ea(ea(o+q)+ea(q-q));q=ea(ea(g[b>>2])+D);D=ea(ea(g[b+4>>2])+p);p=ea(ea(g[b+8>>2])+r);r=ea(ea(g[b+12>>2])+u);u=ea(ea(ea(ea(y*d)-ea(C*f))-ea(h*A))-ea(t*e));o=ea(ea(ea(ea(h*C)-ea(t*d))-ea(A*f))-ea(y*e));n=ea(ea(ea(ea(A*e)-ea(y*f))-ea(C*d))-ea(h*t));E=ea(ea(ea(ea(t*f)-ea(A*d))-ea(C*e))-ea(h*y));y=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(E*E))+ea(ea(u*u)+ea(o*o))))));h=ea(-ea(y*n));n=ea(-ea(y*E));E=ea(-ea(u*y));u=ea(y*o);o=ea(i*ea(g[c>>2]));i=ea(j*ea(g[v>>2]));j=ea(k*ea(g[w>>2]));k=ea(l*ea(g[x>>2]));g[a>>2]=q;g[a+4>>2]=D;g[a+8>>2]=p;g[a+12>>2]=r;g[a+16>>2]=h;g[a+20>>2]=n;g[a+24>>2]=E;g[a+28>>2]=u;g[a+32>>2]=o;g[a+36>>2]=i;g[a+40>>2]=j;g[a+44>>2]=k;return}function IZd(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=0,f=Im,h=0,i=Im,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(g[c>>2]);e=b+32|0;f=ea(d*ea(g[e>>2]));d=ea(g[c+4>>2]);h=b+36|0;i=ea(d*ea(g[h>>2]));d=ea(g[c+8>>2]);j=b+40|0;k=ea(d*ea(g[j>>2]));d=ea(g[c+12>>2]);l=b+44|0;m=ea(d*ea(g[l>>2]));d=ea(f+f);n=ea(i+i);o=ea(k+k);p=ea(g[b+16>>2]);q=ea(n*p);r=ea(g[b+20>>2]);s=ea(o*r);t=ea(g[b+24>>2]);u=ea(d*t);v=ea(g[b+28>>2]);w=ea(v*ea(0.0));x=ea(q-ea(d*r));d=ea(s-ea(n*t));n=ea(u-ea(o*p));o=ea(v*ea(w-w));w=ea(ea(f+ea(v*d))+ea(ea(r*x)-ea(t*n)));f=ea(ea(i+ea(v*n))+ea(ea(t*d)-ea(p*x)));i=ea(ea(k+ea(x*v))+ea(ea(p*n)-ea(r*d)));d=ea(ea(m+o)+ea(o-o));o=ea(ea(g[b>>2])+w);w=ea(ea(g[b+4>>2])+f);f=ea(ea(g[b+8>>2])+i);i=ea(ea(g[b+12>>2])+d);d=ea(g[c+16>>2]);m=ea(r*d);n=ea(g[c+28>>2]);x=ea(v*n);k=ea(g[c+20>>2]);u=ea(t*k);s=ea(g[c+24>>2]);q=ea(ea(ea(m-ea(v*s))-ea(n*t))-ea(k*p));m=ea(ea(ea(x-ea(d*p))-ea(t*s))-ea(r*k));x=ea(ea(ea(u-ea(r*s))-ea(d*v))-ea(n*p));u=ea(ea(ea(ea(p*s)-ea(d*t))-ea(v*k))-ea(r*n));n=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(u*u))+ea(ea(m*m)+ea(q*q))))));r=ea(-ea(n*x));x=ea(-ea(n*u));u=ea(-ea(n*q));q=ea(n*m);m=ea(g[e>>2]);n=ea(m*ea(g[c+32>>2]));m=ea(g[h>>2]);k=ea(m*ea(g[c+36>>2]));m=ea(g[j>>2]);v=ea(m*ea(g[c+40>>2]));m=ea(g[l>>2]);t=ea(m*ea(g[c+44>>2]));g[a>>2]=o;g[a+4>>2]=w;g[a+8>>2]=f;g[a+12>>2]=i;g[a+16>>2]=r;g[a+20>>2]=x;g[a+24>>2]=u;g[a+28>>2]=q;g[a+32>>2]=n;g[a+36>>2]=k;g[a+40>>2]=v;g[a+44>>2]=t;return}function JZd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+96|0;g=f+88|0;h=f+80|0;j=f+8|0;k=f+16|0;l=f+64|0;m=f;n=f+72|0;o=f+48|0;p=f+40|0;q=f+56|0;r=f+24|0;s=f+32|0;t=c[e>>2]|0;u=b;v=c[u+4>>2]|0;w=j;c[w>>2]=c[u>>2];c[w+4>>2]=v;v=a;w=c[v+4>>2]|0;u=k;c[u>>2]=c[v>>2];c[u+4>>2]=w;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];k=_n[t&4095](h,g)|0;t=c[e>>2]|0;if(!k){k=d;j=c[k+4>>2]|0;w=l;c[w>>2]=c[k>>2];c[w+4>>2]=j;j=b;w=c[j+4>>2]|0;k=m;c[k>>2]=c[j>>2];c[k+4>>2]=w;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];if(!(_n[t&4095](h,g)|0)){x=0;i=f;return x|0}m=b;l=c[m>>2]|0;w=c[m+4>>2]|0;m=d;k=c[m+4>>2]|0;j=b;c[j>>2]=c[m>>2];c[j+4>>2]=k;k=d;c[k>>2]=l;c[k+4>>2]=w;w=c[e>>2]|0;k=b;l=c[k+4>>2]|0;j=n;c[j>>2]=c[k>>2];c[j+4>>2]=l;l=a;j=c[l+4>>2]|0;k=o;c[k>>2]=c[l>>2];c[k+4>>2]=j;c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];if(!(_n[w&4095](h,g)|0)){x=1;i=f;return x|0}w=a;o=c[w>>2]|0;n=c[w+4>>2]|0;w=b;j=c[w+4>>2]|0;k=a;c[k>>2]=c[w>>2];c[k+4>>2]=j;j=b;c[j>>2]=o;c[j+4>>2]=n;x=2;i=f;return x|0}n=d;j=c[n+4>>2]|0;o=p;c[o>>2]=c[n>>2];c[o+4>>2]=j;j=b;o=c[j+4>>2]|0;n=q;c[n>>2]=c[j>>2];c[n+4>>2]=o;c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];q=_n[t&4095](h,g)|0;t=a;p=c[t>>2]|0;o=c[t+4>>2]|0;if(q){q=d;t=c[q+4>>2]|0;n=a;c[n>>2]=c[q>>2];c[n+4>>2]=t;t=d;c[t>>2]=p;c[t+4>>2]=o;x=1;i=f;return x|0}t=b;n=c[t+4>>2]|0;q=a;c[q>>2]=c[t>>2];c[q+4>>2]=n;n=b;c[n>>2]=p;c[n+4>>2]=o;n=c[e>>2]|0;e=d;q=c[e+4>>2]|0;t=r;c[t>>2]=c[e>>2];c[t+4>>2]=q;q=s;c[q>>2]=p;c[q+4>>2]=o;c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];if(!(_n[n&4095](h,g)|0)){x=1;i=f;return x|0}g=b;h=c[g>>2]|0;n=c[g+4>>2]|0;g=d;s=c[g+4>>2]|0;r=b;c[r>>2]=c[g>>2];c[r+4>>2]=s;s=d;c[s>>2]=h;c[s+4>>2]=n;x=2;i=f;return x|0}function KZd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+128|0;j=h+120|0;k=h+112|0;l=h+8|0;m=h+32|0;n=h+64|0;o=h+80|0;p=h+96|0;q=h+48|0;r=h+104|0;s=h+16|0;t=h+24|0;u=h+56|0;v=h;w=h+88|0;x=h+40|0;y=h+72|0;z=JZd(a,b,d,g)|0;A=c[g>>2]|0;B=e;C=c[B+4>>2]|0;D=l;c[D>>2]=c[B>>2];c[D+4>>2]=C;C=d;D=c[C+4>>2]|0;B=m;c[B>>2]=c[C>>2];c[B+4>>2]=D;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];if(_n[A&4095](k,j)|0){A=d;m=c[A>>2]|0;l=c[A+4>>2]|0;A=e;D=c[A+4>>2]|0;B=d;c[B>>2]=c[A>>2];c[B+4>>2]=D;D=e;c[D>>2]=m;c[D+4>>2]=l;l=z+1|0;D=c[g>>2]|0;m=d;B=c[m+4>>2]|0;A=n;c[A>>2]=c[m>>2];c[A+4>>2]=B;B=b;A=c[B+4>>2]|0;m=o;c[m>>2]=c[B>>2];c[m+4>>2]=A;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];if(_n[D&4095](k,j)|0){D=b;o=c[D>>2]|0;n=c[D+4>>2]|0;D=d;A=c[D+4>>2]|0;m=b;c[m>>2]=c[D>>2];c[m+4>>2]=A;A=d;c[A>>2]=o;c[A+4>>2]=n;n=c[g>>2]|0;A=b;o=c[A+4>>2]|0;m=p;c[m>>2]=c[A>>2];c[m+4>>2]=o;o=a;m=c[o+4>>2]|0;A=q;c[A>>2]=c[o>>2];c[A+4>>2]=m;c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];if(_n[n&4095](k,j)|0){n=a;q=c[n>>2]|0;p=c[n+4>>2]|0;n=b;m=c[n+4>>2]|0;A=a;c[A>>2]=c[n>>2];c[A+4>>2]=m;m=b;c[m>>2]=q;c[m+4>>2]=p;E=z+3|0}else E=z+2|0}else E=l}else E=z;z=c[g>>2]|0;l=f;p=c[l+4>>2]|0;m=r;c[m>>2]=c[l>>2];c[m+4>>2]=p;p=e;m=c[p+4>>2]|0;l=s;c[l>>2]=c[p>>2];c[l+4>>2]=m;c[k+0>>2]=c[r+0>>2];c[k+4>>2]=c[r+4>>2];c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];if(!(_n[z&4095](k,j)|0)){F=E;i=h;return F|0}z=e;s=c[z>>2]|0;r=c[z+4>>2]|0;z=f;m=c[z+4>>2]|0;l=e;c[l>>2]=c[z>>2];c[l+4>>2]=m;m=f;c[m>>2]=s;c[m+4>>2]=r;r=c[g>>2]|0;m=e;s=c[m+4>>2]|0;f=t;c[f>>2]=c[m>>2];c[f+4>>2]=s;s=d;f=c[s+4>>2]|0;m=u;c[m>>2]=c[s>>2];c[m+4>>2]=f;c[k+0>>2]=c[t+0>>2];c[k+4>>2]=c[t+4>>2];c[j+0>>2]=c[u+0>>2];c[j+4>>2]=c[u+4>>2];if(!(_n[r&4095](k,j)|0)){F=E+1|0;i=h;return F|0}r=d;u=c[r>>2]|0;t=c[r+4>>2]|0;r=e;f=c[r+4>>2]|0;m=d;c[m>>2]=c[r>>2];c[m+4>>2]=f;f=e;c[f>>2]=u;c[f+4>>2]=t;t=c[g>>2]|0;f=d;u=c[f+4>>2]|0;e=v;c[e>>2]=c[f>>2];c[e+4>>2]=u;u=b;e=c[u+4>>2]|0;f=w;c[f>>2]=c[u>>2];c[f+4>>2]=e;c[k+0>>2]=c[v+0>>2];c[k+4>>2]=c[v+4>>2];c[j+0>>2]=c[w+0>>2];c[j+4>>2]=c[w+4>>2];if(!(_n[t&4095](k,j)|0)){F=E+2|0;i=h;return F|0}t=b;w=c[t>>2]|0;v=c[t+4>>2]|0;t=d;e=c[t+4>>2]|0;f=b;c[f>>2]=c[t>>2];c[f+4>>2]=e;e=d;c[e>>2]=w;c[e+4>>2]=v;v=c[g>>2]|0;g=b;e=c[g+4>>2]|0;w=x;c[w>>2]=c[g>>2];c[w+4>>2]=e;e=a;w=c[e+4>>2]|0;g=y;c[g>>2]=c[e>>2];c[g+4>>2]=w;c[k+0>>2]=c[x+0>>2];c[k+4>>2]=c[x+4>>2];c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];if(!(_n[v&4095](k,j)|0)){F=E+3|0;i=h;return F|0}j=a;k=c[j>>2]|0;v=c[j+4>>2]|0;j=b;y=c[j+4>>2]|0;x=a;c[x>>2]=c[j>>2];c[x+4>>2]=y;y=b;c[y>>2]=k;c[y+4>>2]=v;F=E+4|0;i=h;return F|0}function LZd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+112|0;f=e+104|0;g=e+96|0;h=e+32|0;j=e+56|0;k=e+64|0;l=e+80|0;m=e+8|0;n=e+88|0;o=e+40|0;p=e+16|0;q=e+24|0;r=e+72|0;s=e+48|0;t=e;switch(b-a>>3|0){case 4:{u=a+8|0;v=a+16|0;w=b+-8|0;JZd(a,u,v,d)|0;x=c[d>>2]|0;y=w;z=c[y+4>>2]|0;A=h;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=v;A=c[z+4>>2]|0;y=j;c[y>>2]=c[z>>2];c[y+4>>2]=A;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];if(!(_n[x&4095](g,f)|0)){B=1;i=e;return B|0}x=v;j=c[x>>2]|0;h=c[x+4>>2]|0;x=w;A=c[x+4>>2]|0;y=v;c[y>>2]=c[x>>2];c[y+4>>2]=A;A=w;c[A>>2]=j;c[A+4>>2]=h;h=c[d>>2]|0;A=v;j=c[A+4>>2]|0;w=k;c[w>>2]=c[A>>2];c[w+4>>2]=j;j=u;w=c[j+4>>2]|0;A=l;c[A>>2]=c[j>>2];c[A+4>>2]=w;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];if(!(_n[h&4095](g,f)|0)){B=1;i=e;return B|0}h=u;l=c[h>>2]|0;k=c[h+4>>2]|0;h=v;w=c[h>>2]|0;A=c[h+4>>2]|0;h=u;c[h>>2]=w;c[h+4>>2]=A;h=v;c[h>>2]=l;c[h+4>>2]=k;k=c[d>>2]|0;h=m;c[h>>2]=w;c[h+4>>2]=A;A=a;h=c[A+4>>2]|0;w=n;c[w>>2]=c[A>>2];c[w+4>>2]=h;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];if(!(_n[k&4095](g,f)|0)){B=1;i=e;return B|0}k=a;n=c[k>>2]|0;m=c[k+4>>2]|0;k=u;h=c[k+4>>2]|0;w=a;c[w>>2]=c[k>>2];c[w+4>>2]=h;h=u;c[h>>2]=n;c[h+4>>2]=m;B=1;i=e;return B|0}case 1:case 0:{B=1;i=e;return B|0}case 3:{JZd(a,a+8|0,b+-8|0,d)|0;B=1;i=e;return B|0}case 2:{m=c[d>>2]|0;h=b+-8|0;n=h;u=c[n+4>>2]|0;w=o;c[w>>2]=c[n>>2];c[w+4>>2]=u;u=a;w=c[u+4>>2]|0;n=p;c[n>>2]=c[u>>2];c[n+4>>2]=w;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];if(!(_n[m&4095](g,f)|0)){B=1;i=e;return B|0}m=a;p=c[m>>2]|0;o=c[m+4>>2]|0;m=h;w=c[m+4>>2]|0;n=a;c[n>>2]=c[m>>2];c[n+4>>2]=w;w=h;c[w>>2]=p;c[w+4>>2]=o;B=1;i=e;return B|0}case 5:{KZd(a,a+8|0,a+16|0,a+24|0,b+-8|0,d)|0;B=1;i=e;return B|0}default:{o=a+16|0;JZd(a,a+8|0,o,d)|0;w=a+24|0;if((w|0)==(b|0)){B=1;i=e;return B|0}else{C=0;D=w;E=o}while(1){o=c[d>>2]|0;w=D;p=c[w+4>>2]|0;h=q;c[h>>2]=c[w>>2];c[h+4>>2]=p;p=E;h=c[p+4>>2]|0;w=r;c[w>>2]=c[p>>2];c[w+4>>2]=h;c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];if(_n[o&4095](g,f)|0){o=D;h=c[o>>2]|0;w=c[o+4>>2]|0;o=D;p=E;while(1){n=p;m=c[n+4>>2]|0;u=o;c[u>>2]=c[n>>2];c[u+4>>2]=m;if((p|0)==(a|0)){F=p;break}m=c[d>>2]|0;u=s;c[u>>2]=h;c[u+4>>2]=w;u=p+-8|0;n=u;k=c[n+4>>2]|0;A=t;c[A>>2]=c[n>>2];c[A+4>>2]=k;c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];if(_n[m&4095](g,f)|0){m=p;p=u;o=m}else{F=p;break}}p=F;c[p>>2]=h;c[p+4>>2]=w;p=C+1|0;if((p|0)==8){G=D;break}else H=p}else H=C;p=D+8|0;if((p|0)==(b|0)){B=1;I=18;break}else{o=D;C=H;D=p;E=o}}if((I|0)==18){i=e;return B|0}B=(G+8|0)==(b|0);i=e;return B|0}}return 0}function MZd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=Im,C=0,D=0,E=0,F=Im,G=0,H=0,I=Im,J=Im,K=0,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=Im,W=Im,X=Im,Z=0,_=Im,$=Im,aa=0,ba=0;k=i;l=a+4|0;m=l;n=(c[l>>2]|0)+m|0;c[a+8>>2]=n;o=c[a>>2]|0;p=a+16|0;q=(c[p>>2]|0)+p|0;c[a+20>>2]=q;p=a+52|0;r=(c[p>>2]|0)+p|0;c[a+56>>2]=r;s=ea(T(ea(ea(f*f)+ea(h*h))));t=ea(g[150272]);p=(o|0)==0;a:do if(t==f&ea(g[150273])==h){if(!p){u=0;do{v=ea(s-ea(g[q+(u<<2)>>2]));w=ea(v);x=e+(u<<3)|0;c[x>>2]=0;g[x+4>>2]=w;u=u+1|0}while((u|0)!=(o|0))}}else if(!p){w=t;u=0;while(1){v=ea(g[n+(u<<3)>>2]);y=ea(g[n+(u<<3)+4>>2]);if(v==w&y==ea(g[150273])){z=ea(s-ea(g[q+(u<<2)>>2]));A=ea(z);x=e+(u<<3)|0;c[x>>2]=0;g[x+4>>2]=A}else{A=ea(ea(ea(v*f)+ea(y*h))/ea(s*ea(T(ea(ea(v*v)+ea(y*y))))));x=A>ea(-1.0);z=x?A:ea(-1.0);x=z<ea(1.0);A=ea(+Y(+(x?z:ea(1.0))));if(ea(ea(v*h)-ea(y*f))<ea(0.0))B=ea(-A);else B=A;A=ea(s-ea(g[q+(u<<2)>>2]));y=ea(B);v=ea(A);x=e+(u<<3)|0;g[x>>2]=y;g[x+4>>2]=v}x=u+1|0;if((x|0)==(o|0))break a;w=ea(g[150272]);u=x}}while(0);q=(o|0)==0;if(j){if(q){i=k;return}j=a+28|0;n=j;p=a+40|0;u=p;x=0;do{C=~~ea(g[e+(x<<3)>>2]);D=d+(x<<2)|0;c[D>>2]=-1;E=e+(x<<3)|0;B=ea(ea(1.0)-ea(ea(((C|0)>-1?C:0-C|0)|0)*ea(.318309873)));C=0;while(1){if((x|0)==(C|0))F=B;else{G=(da(c[a>>2]|0,C)|0)+x|0;H=(c[j>>2]|0)+n+(G<<3)|0;s=ea(g[H>>2]);t=ea(g[H+4>>2]);H=E;w=ea(g[H>>2]);v=ea(g[H+4>>2]);y=ea(ea(g[(c[p>>2]|0)+u+(G<<2)>>2])*v);G=(c[l>>2]|0)+m|0;v=ea(g[G+(x<<3)>>2]);A=ea(g[150272]);if(v==A?(v=ea(g[G+(x<<3)+4>>2]),v==ea(g[150273])):0){I=ea(g[e+(C<<3)>>2]);J=w}else K=20;do if((K|0)==20){K=0;if(ea(g[G+(C<<3)>>2])==A?(v=ea(g[G+(C<<3)+4>>2]),v==ea(g[150273])):0){I=w;J=w;break}if(!(s==ea(0.0))?!(A==f&ea(g[150273])==h):0){I=s;J=w;break}I=s;J=s}while(0);s=ea(ea(1.0)-ea(ea(ea(t*y)+ea(I*J))/ea(ea(t*t)+ea(I*I))));if(s<=ea(0.0)){K=27;break}G=s<B;if(G)c[D>>2]=C;F=G?s:B}C=C+1|0;if(C>>>0>=o>>>0)break;else B=F}if((K|0)==27){K=0;c[D>>2]=-1}x=x+1|0}while((x|0)!=(o|0));i=k;return}if(q){i=k;return}x=a+28|0;u=x;p=a+40|0;n=p;j=0;do{d=~~ea(g[e+(j<<3)>>2]);F=ea(ea(1.0)-ea(ea(((d|0)>-1?d:0-d|0)|0)*ea(.318309873)));d=c[r+(j*12|0)>>2]|0;b:do if(!d)L=F;else{C=r+(j*12|0)+4|0;E=(c[C>>2]|0)+C|0;C=c[a>>2]|0;G=(c[x>>2]|0)+u|0;H=e+(j<<3)|0;I=ea(g[H>>2]);J=ea(g[H+4>>2]);H=(c[p>>2]|0)+n|0;M=(c[l>>2]|0)+m|0;B=ea(g[M+(j<<3)>>2]);s=ea(g[150272]);N=B==s;O=M+(j<<3)+4|0;B=ea(g[150273]);P=s==f&B==h;w=F;Q=0;while(1){R=c[E+(Q<<2)>>2]|0;S=(da(C,R)|0)+j|0;U=G+(S<<3)|0;A=ea(g[U>>2]);v=ea(g[U+4>>2]);z=ea(ea(g[H+(S<<2)>>2])*J);if(N?ea(g[O>>2])==B:0){V=ea(g[e+(R<<3)>>2]);W=I}else K=40;do if((K|0)==40){K=0;if(ea(g[M+(R<<3)>>2])==s?ea(g[M+(R<<3)+4>>2])==B:0){V=I;W=I;break}S=A==ea(0.0)|P;V=A;W=S?A:I}while(0);A=ea(ea(1.0)-ea(ea(ea(v*z)+ea(V*W))/ea(ea(v*v)+ea(V*V))));if(A<=ea(0.0)){L=ea(0.0);break b}X=A<w?A:w;Q=Q+1|0;if(Q>>>0>=d>>>0){L=X;break}else w=X}}while(0);g[b+(j<<2)>>2]=L;j=j+1|0}while((j|0)!=(o|0));if(q){i=k;return}else{Z=0;_=ea(0.0)}while(1){L=ea(_+ea(g[b+(Z<<2)>>2]));Z=Z+1|0;if((Z|0)==(o|0)){$=L;break}else _=L}if($>ea(0.0)){_=ea(ea(1.0)/$);if(q){i=k;return}else aa=0;do{Z=b+(aa<<2)|0;g[Z>>2]=ea(_*ea(g[Z>>2]));aa=aa+1|0}while((aa|0)!=(o|0));i=k;return}else{_=ea(ea(1.0)/ea(o>>>0));if(q){i=k;return}else ba=0;do{g[b+(ba<<2)>>2]=_;ba=ba+1|0}while((ba|0)!=(o|0));i=k;return}}function NZd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=Im,C=0,D=0,E=Im,F=0,G=0,H=Im,I=Im,J=0;k=i;l=a+4|0;m=(c[l>>2]|0)+l|0;c[a+8>>2]=m;l=c[a>>2]|0;n=a+52|0;o=(c[n>>2]|0)+n|0;c[a+56>>2]=o;n=(l|0)==0;if(!n){p=0;do{q=ea(f-ea(g[m+(p<<3)>>2]));r=ea(h-ea(g[m+(p<<3)+4>>2]));s=ea(q);q=ea(r);t=e+(p<<3)|0;g[t>>2]=s;g[t+4>>2]=q;p=p+1|0}while((p|0)!=(l|0))}if(j){if(n){i=k;return}j=a+28|0;p=j;m=a+40|0;t=m;u=0;do{v=d+(u<<2)|0;c[v>>2]=-1;w=e+(u<<3)|0;h=ea(g[w>>2]);f=ea(g[w+4>>2]);q=ea(1.0);w=0;while(1){if((u|0)==(w|0))x=q;else{y=(da(c[a>>2]|0,w)|0)+u|0;z=(c[j>>2]|0)+p+(y<<3)|0;s=ea(g[z>>2]);r=ea(ea(h*s)+ea(f*ea(g[z+4>>2])));s=ea(ea(1.0)-ea(ea(g[(c[m>>2]|0)+t+(y<<2)>>2])*r));if(s<=ea(0.0)){A=11;break}y=s<q;if(y)c[v>>2]=w;x=y?s:q}w=w+1|0;if(w>>>0>=l>>>0)break;else q=x}if((A|0)==11){A=0;c[v>>2]=-1}u=u+1|0}while((u|0)!=(l|0));i=k;return}if(n){i=k;return}u=a+28|0;A=u;t=a+40|0;m=t;p=0;do{j=e+(p<<3)|0;x=ea(g[j>>2]);q=ea(g[j+4>>2]);j=c[o+(p*12|0)>>2]|0;a:do if(!j)B=ea(1.0);else{d=o+(p*12|0)+4|0;w=(c[d>>2]|0)+d|0;d=c[a>>2]|0;y=(c[u>>2]|0)+A|0;z=(c[t>>2]|0)+m|0;f=ea(1.0);C=0;while(1){D=c[w+(C<<2)>>2]|0;if((p|0)==(D|0))E=f;else{F=(da(d,D)|0)+p|0;D=y+(F<<3)|0;h=ea(g[D>>2]);s=ea(ea(x*h)+ea(q*ea(g[D+4>>2])));h=ea(ea(1.0)-ea(ea(g[z+(F<<2)>>2])*s));if(h<ea(0.0)){B=ea(0.0);break a}E=h<f?h:f}C=C+1|0;if(C>>>0>=j>>>0){B=E;break}else f=E}}while(0);g[b+(p<<2)>>2]=B;p=p+1|0}while((p|0)!=(l|0));if(n){i=k;return}else{G=0;H=ea(0.0)}while(1){B=ea(H+ea(g[b+(G<<2)>>2]));G=G+1|0;if((G|0)==(l|0)){I=B;break}else H=B}H=ea(ea(1.0)/I);if(n){i=k;return}else J=0;do{n=b+(J<<2)|0;g[n>>2]=ea(H*ea(g[n>>2]));J=J+1|0}while((J|0)!=(l|0));i=k;return}function OZd(a){a=a|0;var b=0,d=0,e=0;b=i;d=xo[c[c[a>>2]>>2]&2047](a,8,4)|0;if(!d){e=0;i=b;return e|0}c[d+4>>2]=0;e=d;i=b;return e|0}function PZd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function QZd(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;f=xo[c[c[d>>2]>>2]&2047](d,12,4)|0;if(!f)h=0;else{c[f+4>>2]=0;g[f+8>>2]=ea(0.0);h=f}c[h+4>>2]=b;if(!b){j=0;c[h>>2]=j;i=e;return h|0}f=xo[c[c[d>>2]>>2]&2047](d,b*20|0,4)|0;if(!f){j=0;c[h>>2]=j;i=e;return h|0}d=f+(b*20|0)|0;b=f;do{g[b>>2]=ea(0.0);c[b+4>>2]=0;g[b+8>>2]=ea(1.0);a[b+12>>0]=0;g[b+16>>2]=ea(0.0);b=b+20|0}while((b|0)!=(d|0));j=f;c[h>>2]=j;i=e;return h|0}function RZd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function SZd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;e=xo[c[c[b>>2]>>2]&2047](b,16,4)|0;if(!e)f=0;else{c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;f=e}if(!a){c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;h=0;j=f+12|0;c[j>>2]=h;i=d;return f|0}e=a<<2;c[f>>2]=xo[c[c[b>>2]>>2]&2047](b,e,4)|0;c[f+4>>2]=xo[c[c[b>>2]>>2]&2047](b,e,4)|0;c[f+8>>2]=xo[c[c[b>>2]>>2]&2047](b,e,4)|0;e=xo[c[c[b>>2]>>2]&2047](b,a<<3,4)|0;if(!e){h=0;j=f+12|0;c[j>>2]=h;i=d;return f|0}b=e+(a<<3)|0;a=e;do{g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);a=a+8|0}while((a|0)!=(b|0));h=e;j=f+12|0;c[j>>2]=h;i=d;return f|0}function TZd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+4>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+8>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a+12>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function UZd(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=ea(f);h=ea(h);j=j|0;var k=0,l=Im,m=Im,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=Im,K=Im,L=Im,M=Im;j=i;e=a+4|0;d=(c[e>>2]|0)+e|0;e=d;c[a+8>>2]=e;k=c[a>>2]|0;if((b|0)==0|(d|0)==0){i=j;return}d=(k|0)==0;if(d){i=j;return}PEi(b|0,0,k<<2|0)|0;if(k>>>0<2){g[b>>2]=ea(1.0);i=j;return}l=ea(g[150272]);m=ea(g[150273]);if(l==f&m==h){a=0;do{if(ea(g[e+(a<<3)>>2])==l?ea(g[e+(a<<3)+4>>2])==m:0){n=a;o=8;break}a=a+1|0}while(a>>>0<k>>>0);if((o|0)==8){g[b+(n<<2)>>2]=ea(1.0);i=j;return}p=ea(ea(1.0)/ea(k>>>0));if(d){i=j;return}else q=0;do{g[b+(q<<2)>>2]=p;q=q+1|0}while((q|0)!=(k|0));i=j;return}else{r=0;s=-1;t=-1;u=-1;v=ea(-1.0e5);w=ea(-1.0e5)}a:while(1){q=e+(r<<3)|0;p=ea(g[q>>2]);x=ea(g[e+(r<<3)+4>>2]);do if(p==l&x==m)if((u|0)>-1){o=31;break a}else{y=s;z=t;A=r;B=v;C=w}else{D=ea(T(ea(ea(p*p)+ea(x*x))));n=q;E=ea(ea(g[n>>2])/D);F=ea(ea(g[n+4>>2])/D);D=ea(ea(E*f)+ea(F*h));if(ea(ea(E*h)-ea(F*f))>ea(0.0)){if(!(D>w)){y=s;z=t;A=u;B=v;C=w;break}y=r;z=t;A=u;B=v;C=D;break}else{if(!(D>v)){y=s;z=t;A=u;B=v;C=w;break}y=s;z=r;A=u;B=D;C=w;break}}while(0);r=r+1|0;if(r>>>0>=k>>>0){G=y;H=z;I=A;break}else{s=y;t=z;u=A;v=B;w=C}}if((o|0)==31){i=j;return}if((G|H|0)<0)J=ea(1.0);else{C=ea(g[e+(G<<3)>>2]);w=ea(g[e+(G<<3)+4>>2]);B=ea(g[e+(H<<3)>>2]);v=ea(g[e+(H<<3)+4>>2]);m=ea(ea(C*v)-ea(w*B));l=ea(ea(ea(v*f)-ea(B*h))/m);B=ea(ea(ea(C*h)-ea(w*f))/m);m=ea(ea(ea(1.0)-l)-B);if(!(m<ea(0.0)))if(m>ea(1.0)){K=ea(1.0);L=ea(0.0);M=ea(0.0)}else{K=m;L=l;M=B}else{m=ea(l+B);K=ea(0.0);L=ea(l/m);M=ea(B/m)}g[b+(G<<2)>>2]=L;g[b+(H<<2)>>2]=M;J=K}if((I|0)>-1){g[b+(I<<2)>>2]=J;i=j;return}if(d){i=j;return}K=ea(J*ea(ea(1.0)/ea(k>>>0)));d=0;do{I=b+(d<<2)|0;g[I>>2]=ea(K+ea(g[I>>2]));d=d+1|0}while((d|0)!=(k|0));i=j;return}function VZd(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=0,o=Im,p=0;e=i;f=a+4|0;h=(c[f>>2]|0)+f|0;j=ea(g[h>>2]);f=c[a>>2]|0;k=ea(g[h+(f+-1<<2)>>2]);l=ea(VDi(ea(UDi(d,j)),k));if(!f){i=e;return}else{m=j;n=0}while(1){if(!(m<=l))if(n){j=ea(g[h+(n+-1<<2)>>2]);if(!(j>l)){k=ea(m-j);if(k!=ea(0.0))o=ea(ea(l-j)/k);else o=m}else o=ea(0.0)}else o=ea(1.0);else{p=n+1|0;if((p|0)!=(f|0)){k=ea(g[h+(p<<2)>>2]);if(!(k<l)){j=ea(m-k);if(j!=ea(0.0))o=ea(ea(l-k)/j);else o=m}else o=ea(0.0)}else o=ea(1.0)}g[b+(n<<2)>>2]=o;p=n+1|0;if(p>>>0>=f>>>0)break;m=ea(g[h+(p<<2)>>2]);n=p}c[a+8>>2]=h;i=e;return}function WZd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);var g=0,h=0,j=0;g=i;switch(c[a>>2]|0){case 2:{h=a+32|0;j=(c[h>>2]|0)+h|0;c[a+36>>2]=j;MZd(j,d,c[b+8>>2]|0,c[b+12>>2]|0,e,f,0);i=g;return}case 1:{j=a+32|0;h=(c[j>>2]|0)+j|0;c[a+36>>2]=h;UZd(h,d,0,0,e,f,0);i=g;return}case 0:{h=a+24|0;j=(c[h>>2]|0)+h|0;c[a+28>>2]=j;VZd(j,d,e);i=g;return}case 4:{j=a+40|0;h=(c[j>>2]|0)+j|0;c[a+44>>2]=h;j=c[h>>2]|0;if(!j){i=g;return}PEi(d|0,0,(j>>>0>1?j<<2:4)|0)|0;i=g;return}case 3:{j=a+32|0;h=(c[j>>2]|0)+j|0;c[a+36>>2]=h;NZd(h,d,c[b+8>>2]|0,c[b+12>>2]|0,e,f,0);i=g;return}default:{i=g;return}}}function XZd(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=Im,K=0,L=0,M=Im,N=Im,O=0,P=0,Q=Im,R=Im,T=Im,U=0,V=Im,W=Im;k=i;l=c[e+4>>2]|0;if(l){m=c[e>>2]|0;n=0;do{c[m+(n*20|0)+4>>2]=-1;n=n+1|0}while(n>>>0<l>>>0)}l=e+8|0;g[l>>2]=ea(0.0);g[c[f>>2]>>2]=ea(1.0);n=c[b>>2]|0;if(n){m=b+4|0;o=m;p=d+4|0;q=f+4|0;r=h+12|0;h=n;n=0;s=ea(0.0);t=0;u=0;while(1){v=(c[m>>2]|0)+o|0;w=v+(t<<3)|0;x=w+(c[w>>2]|0)|0;c[v+(t<<3)+4>>2]=x;v=c[x+48>>2]|0;if((v|0)==-1){w=x+12|0;if(!(c[w>>2]|0)){y=h;z=n;A=s;B=u}else{C=c[x>>2]|0;do if(!C){D=F_d(c[d>>2]|0,c[x+4>>2]|0)|0;if((D|0)!=-1){E=(c[d>>2]|0)+4|0;F=(c[p>>2]|0)+28|0;G=ea(g[(c[F>>2]|0)+F+(c[E+(c[E>>2]|0)+(D<<4)+12>>2]<<2)>>2]);WZd(x,f,c[q>>2]|0,G,ea(0.0))}}else{if(C>>>0<4){D=F_d(c[d>>2]|0,c[x+4>>2]|0)|0;E=F_d(c[d>>2]|0,c[x+8>>2]|0)|0;if(!((D|0)!=-1&(E|0)!=-1))break;F=(c[d>>2]|0)+4|0;H=F+(c[F>>2]|0)|0;F=(c[p>>2]|0)+28|0;I=(c[F>>2]|0)+F|0;G=ea(g[I+(c[H+(D<<4)+12>>2]<<2)>>2]);J=ea(g[I+(c[H+(E<<4)+12>>2]<<2)>>2]);WZd(x,f,c[q>>2]|0,G,J);break}if((C|0)==4?(E=x+40|0,H=E,I=(c[E>>2]|0)+H|0,(c[I>>2]|0)!=0):0){D=I;I=0;J=ea(0.0);while(1){F=D+4|0;K=c[(c[F>>2]|0)+F+(I<<2)>>2]|0;if((K|0)!=-1?(F=F_d(c[d>>2]|0,K)|0,(F|0)!=-1):0){K=(c[d>>2]|0)+4|0;L=(c[p>>2]|0)+28|0;M=ea(g[(c[L>>2]|0)+L+(c[K+(c[K>>2]|0)+(F<<4)+12>>2]<<2)>>2])}else M=ea(0.0);g[(c[q>>2]|0)+(I<<2)>>2]=M;G=ea(J+M);I=I+1|0;F=c[E>>2]|0;K=F+H|0;if(I>>>0>=(c[K>>2]|0)>>>0){N=G;O=F;P=K;break}else{D=K;J=G}}if((a[P+12>>0]|0)!=0&N>ea(1.0)?(D=c[O+H>>2]|0,(D|0)!=0):0){I=c[q>>2]|0;E=0;do{K=I+(E<<2)|0;g[K>>2]=ea(ea(g[K>>2])/N);E=E+1|0}while(E>>>0<D>>>0)}}}while(0);C=c[w>>2]|0;if(C){D=c[q>>2]|0;E=c[f>>2]|0;I=E+(t<<2)|0;H=x+16|0;K=(c[H>>2]|0)+H|0;H=0;do{J=ea(g[D+(H<<2)>>2]);G=ea(J*ea(g[I>>2]));g[E+(c[K+(H<<2)>>2]<<2)>>2]=G;H=H+1|0}while(H>>>0<C>>>0)}y=c[b>>2]|0;z=n;A=s;B=u}}else{C=(c[f>>2]|0)+(t<<2)|0;G=ea(g[C>>2]);if(G>ea(0.0)){H=c[(c[r>>2]|0)+((u+j|0)*36|0)>>2]|0;if(!H)Q=ea(0.0);else{J=ea(g[H+1052>>2]);Q=ea(J-ea(g[H+1048>>2]))}J=ea(g[x+52>>2]);R=ea(Q*J);H=c[e>>2]|0;c[H+(n*20|0)+4>>2]=v;g[H+(n*20|0)>>2]=G;if(J!=ea(0.0))T=ea(ea(1.0)/J);else T=ea(1.0);g[H+(n*20|0)+8>>2]=T;g[H+(n*20|0)+16>>2]=ea(g[x+56>>2]);a[H+(n*20|0)+12>>0]=a[x+60>>0]|0;J=ea(S(ea(R)));R=ea(J*ea(g[C>>2]));g[l>>2]=ea(ea(g[l>>2])+R);U=n+1|0;V=ea(s+ea(g[C>>2]))}else{U=n;V=s}y=h;z=U;A=V;B=u+1|0}t=t+1|0;if(t>>>0>=y>>>0){W=A;break}else{h=y;n=z;s=A;u=B}}if(!(W==ea(0.0))){if(!(W<ea(1.0))){i=k;return}g[l>>2]=ea(ea(g[l>>2])/W);i=k;return}}g[l>>2]=ea(1.0);i=k;return}function YZd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[c[d>>2]>>2]&2047](d,20,4)|0;c[f+16>>2]=b-(c[a+12>>2]|0)-(c[a+20>>2]|0);h_d(a,f,d);i=e;return f|0}function ZZd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}i_d(a,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function _Zd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=xo[c[c[b>>2]>>2]&2047](b,4,4)|0;if(!a){f=0;c[e>>2]=f;i=d;return e|0}f=xo[c[c[b>>2]>>2]&2047](b,a<<2,4)|0;c[e>>2]=f;i=d;return e|0}function $Zd(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function a_d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;h=c[a+12>>2]|0;if(h>>>0>e>>>0){j=ea(g_d(a,d,e,ea(g[b>>2])));i=f;return ea(j)}d=e-h|0;h=c[a+20>>2]|0;if(d>>>0<h>>>0){j=ea(d_d(a+16|0,d,ea(g[b>>2])));i=f;return ea(j)}else{j=ea(k_d(a+44|0,d-h|0));i=f;return ea(j)}return ea(0.0)}function b_d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;h=c[e>>2]|0;e=a+12|0;if(!(c[e>>2]|0))j=h;else{f_d(a,d,ea(g[b>>2]),h);j=h+(c[e>>2]<<2)|0}e=a+20|0;if(!(c[e>>2]|0))k=j;else{c_d(a+16|0,ea(g[b>>2]),j);k=j+(c[e>>2]<<2)|0}e=c[d+16>>2]|0;if(!e){i=f;return}j_d(a+44|0,e,k);i=f;return}function c_d(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;h=ea(b-ea(g[a+12>>2]));b=ea(cEi(ea(h*ea(g[a+8>>2])),f));j=~~ea(g[f>>2]);f=j+1|0;k=(j|0)>0?j:0;j=(c[a>>2]|0)+-1|0;l=(f|0)>0?f:0;f=a+20|0;m=c[a+4>>2]|0;a=da((k|0)<(j|0)?k:j,m)|0;k=(c[f>>2]|0)+f|0;f=da((l|0)<(j|0)?l:j,m)|0;if(!m){i=e;return}else n=0;do{h=ea(g[k+(n+a<<2)>>2]);g[d+(n<<2)>>2]=ea(h+ea(b*ea(ea(g[k+(n+f<<2)>>2])-h)));n=n+1|0}while((n|0)!=(m|0));i=e;return}function d_d(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=Im;e=i;i=i+16|0;f=e;h=ea(d-ea(g[a+12>>2]));d=ea(cEi(ea(h*ea(g[a+8>>2])),f));j=~~ea(g[f>>2]);f=j+1|0;k=(j|0)>0?j:0;j=(c[a>>2]|0)+-1|0;l=(f|0)>0?f:0;f=a+20|0;m=c[a+4>>2]|0;a=da((k|0)<(j|0)?k:j,m)|0;k=(c[f>>2]|0)+f|0;f=da((l|0)<(j|0)?l:j,m)|0;h=ea(g[k+(a+b<<2)>>2]);n=ea(h+ea(d*ea(ea(g[k+(f+b<<2)>>2])-h)));i=e;return ea(n)}function e_d(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=Im,z=Im,A=Im;e=i;f=b+8|0;h=ea(g[f>>2]);if(h==d){i=e;return}if(h>d){g[f>>2]=ea(-x);c[b+12>>2]=0;j=0}else j=c[b+12>>2]|0;k=a+4|0;l=(c[k>>2]|0)+k|0;c[a+8>>2]=l;a=l;l=b+12|0;h=ea(g[a+j>>2]);if(!(h<=d))m=j;else{k=c[b>>2]|0;n=h;b=j;while(1){j=b+8|0;o=a+j|0;p=c[a+(b+4)>>2]|0;q=a+(b+12)|0;r=a+(b+16)|0;s=a+(b+20)|0;t=a+(b+24)|0;u=o;v=1;while(1){w=c[u>>2]|0;h=ea(g[q>>2]);y=ea(g[t>>2]);z=ea(g[s>>2]);A=ea(g[r>>2]);g[k+(w*20|0)>>2]=n;g[k+(w*20|0)+4>>2]=h;g[k+(w*20|0)+8>>2]=A;g[k+(w*20|0)+12>>2]=z;g[k+(w*20|0)+16>>2]=y;if((v|0)>=(p|0))break;q=o+(v*20|0)+4|0;r=o+(v*20|0)+8|0;s=o+(v*20|0)+12|0;t=o+(v*20|0)+16|0;u=o+(v*20|0)|0;v=v+1|0}v=(p*20|0)+j|0;n=ea(g[a+v>>2]);if(!(n<=d)){m=v;break}else b=v}}g[f>>2]=d;c[l>>2]=m;i=e;return}function f_d(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0;f=i;e_d(a,b,d);a=c[b>>2]|0;h=c[b+4>>2]|0;if((h|0)<4){j=a;k=0}else{b=4;l=a;m=0;while(1){n=ea(g[l>>2]);o=ea(g[l+20>>2]);p=ea(g[l+40>>2]);q=ea(d-n);n=ea(d-o);o=ea(d-p);p=ea(d-ea(g[l+60>>2]));r=ea(g[l+4>>2]);s=ea(g[l+24>>2]);t=ea(g[l+44>>2]);u=ea(g[l+64>>2]);v=ea(g[l+8>>2]);w=ea(g[l+28>>2]);x=ea(g[l+48>>2]);y=ea(g[l+68>>2]);z=ea(g[l+12>>2]);A=ea(g[l+32>>2]);B=ea(g[l+52>>2]);C=ea(g[l+72>>2]);D=ea(g[l+16>>2]);E=ea(g[l+36>>2]);F=ea(g[l+56>>2]);G=ea(ea(n*ea(ea(n*ea(ea(n*s)+w))+A))+E);E=ea(ea(o*ea(ea(o*ea(ea(o*t)+x))+B))+F);F=ea(ea(p*ea(ea(p*ea(ea(p*u)+y))+C))+ea(g[l+76>>2]));g[e+(m<<2)>>2]=ea(ea(q*ea(ea(q*ea(ea(q*r)+v))+z))+D);g[e+((m|1)<<2)>>2]=G;g[e+((m|2)<<2)>>2]=E;g[e+((m|3)<<2)>>2]=F;H=b+4|0;if((H|0)>(h|0))break;else{I=b;b=H;l=l+80|0;m=I}}m=h&-4;j=a+(m*20|0)|0;k=m}if((k|0)<(h|0)){J=j;K=k}else{i=f;return}while(1){F=ea(d-ea(g[J>>2]));E=ea(F*ea(g[J+4>>2]));G=ea(F*ea(E+ea(g[J+8>>2])));E=ea(F*ea(ea(g[J+12>>2])+G));g[e+(K<<2)>>2]=ea(ea(g[J+16>>2])+E);K=K+1|0;if((K|0)==(h|0))break;else J=J+20|0}i=f;return}function g_d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=Im,j=Im;f=i;e_d(a,b,e);a=c[b>>2]|0;h=ea(e-ea(g[a+(d*20|0)>>2]));e=ea(h*ea(g[a+(d*20|0)+4>>2]));j=ea(h*ea(e+ea(g[a+(d*20|0)+8>>2])));e=ea(h*ea(ea(g[a+(d*20|0)+12>>2])+j));j=ea(ea(g[a+(d*20|0)+16>>2])+e);i=f;return ea(j)}function h_d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;f=a+12|0;a=c[f>>2]|0;if(!a){h=0;j=0}else{k=xo[c[c[d>>2]>>2]&2047](d,a*20|0,4)|0;h=k;j=c[f>>2]|0}c[b>>2]=h;c[b+4>>2]=j;g[b+8>>2]=ea(-x);c[b+12>>2]=0;i=e;return}function i_d(a,b){a=a|0;b=b|0;var d=0;d=i;In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);i=d;return}function j_d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+4|0;g=(c[f>>2]|0)+f|0;c[a+8>>2]=g;YEi(d|0,g|0,b<<2|0)|0;i=e;return}function k_d(a,b){a=a|0;b=b|0;var d=0,e=Im;d=a+4|0;e=ea(g[(c[d>>2]|0)+d+(b<<2)>>2]);return ea(e)}function l_d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=xo[c[c[d>>2]>>2]&2047](d,12,4)|0;if(!f)g=0;else{c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;g=f}c[g>>2]=b;f=a+4|0;h=(c[f>>2]|0)+f|0;c[a+8>>2]=h;if((b|0)!=0?(a=b<<4,b=xo[c[c[d>>2]>>2]&2047](d,a,4)|0,YEi(b|0,h|0,a|0)|0,(b|0)!=0):0){j=b;k=b-(g+4)|0}else{j=0;k=0}c[g+4>>2]=k;c[g+8>>2]=j;i=e;return g|0}function m_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+4|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+8>>2]=h;In[g&4095](b,h)}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function n_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+36>>2]|0;if(e){f=a+40|0;g=(c[f>>2]|0)+f|0;PEi(g|0,b&1|0,(e>>>0>1?e:1)|0)|0;c[a+44>>2]=g}g=c[a+48>>2]|0;if(g){e=a+52|0;f=(c[e>>2]|0)+e|0;PEi(f|0,b&1|0,(g>>>0>1?g:1)|0)|0;c[a+56>>2]=f}f=c[a+60>>2]|0;if(f){g=a+64|0;e=(c[g>>2]|0)+g|0;PEi(e|0,b&1|0,(f>>>0>1?f:1)|0)|0;c[a+68>>2]=e}e=c[a+24>>2]|0;if(e){f=a+28|0;g=(c[f>>2]|0)+f|0;PEi(g|0,b&1|0,(e>>>0>1?e:1)|0)|0;c[a+32>>2]=g}g=c[a+12>>2]|0;if(!g){i=d;return}e=a+16|0;f=(c[e>>2]|0)+e|0;PEi(f|0,b&1|0,(g>>>0>1?g:1)|0)|0;c[a+20>>2]=f;i=d;return}function o_d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[b+36>>2]|0;if(f){g=d+40|0;h=(c[g>>2]|0)+g|0;g=b+40|0;j=(c[g>>2]|0)+g|0;g=0;do{a[j+g>>0]=a[h+g>>0]|0;g=g+1|0}while(g>>>0<f>>>0);c[b+44>>2]=j}j=c[b+48>>2]|0;if(j){f=d+52|0;g=(c[f>>2]|0)+f|0;f=b+52|0;h=(c[f>>2]|0)+f|0;f=0;do{a[h+f>>0]=a[g+f>>0]|0;f=f+1|0}while(f>>>0<j>>>0);c[b+56>>2]=h}h=c[b+60>>2]|0;if(h){j=d+64|0;f=(c[j>>2]|0)+j|0;j=b+64|0;g=(c[j>>2]|0)+j|0;j=0;do{a[g+j>>0]=a[f+j>>0]|0;j=j+1|0}while(j>>>0<h>>>0);c[b+68>>2]=g}g=c[b+24>>2]|0;if(g){h=d+28|0;j=(c[h>>2]|0)+h|0;h=b+28|0;f=(c[h>>2]|0)+h|0;h=0;do{a[f+h>>0]=a[j+h>>0]|0;h=h+1|0}while(h>>>0<g>>>0);c[b+32>>2]=f}f=c[b+12>>2]|0;if(!f){i=e;return}g=d+16|0;d=(c[g>>2]|0)+g|0;g=b+16|0;h=(c[g>>2]|0)+g|0;g=0;do{a[h+g>>0]=a[d+g>>0]|0;g=g+1|0}while(g>>>0<f>>>0);c[b+20>>2]=h;i=e;return}function p_d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[b+36>>2]|0;if(f){g=b+40|0;h=(c[g>>2]|0)+g|0;g=d+40|0;j=g;k=0;do{l=h+k|0;if(!(a[l>>0]|0))m=a[(c[g>>2]|0)+j+k>>0]|0;else m=1;a[l>>0]=m;k=k+1|0}while(k>>>0<f>>>0);c[b+44>>2]=h}h=c[b+48>>2]|0;if(h){f=b+52|0;k=(c[f>>2]|0)+f|0;f=d+52|0;m=f;j=0;do{g=k+j|0;if(!(a[g>>0]|0))n=a[(c[f>>2]|0)+m+j>>0]|0;else n=1;a[g>>0]=n;j=j+1|0}while(j>>>0<h>>>0);c[b+56>>2]=k}k=c[b+60>>2]|0;if(k){h=b+64|0;j=(c[h>>2]|0)+h|0;h=d+64|0;n=h;m=0;do{f=j+m|0;if(!(a[f>>0]|0))o=a[(c[h>>2]|0)+n+m>>0]|0;else o=1;a[f>>0]=o;m=m+1|0}while(m>>>0<k>>>0);c[b+68>>2]=j}j=c[b+24>>2]|0;if(j){k=b+28|0;m=(c[k>>2]|0)+k|0;k=d+28|0;o=k;n=0;do{h=m+n|0;if(!(a[h>>0]|0))p=a[(c[k>>2]|0)+o+n>>0]|0;else p=1;a[h>>0]=p;n=n+1|0}while(n>>>0<j>>>0);c[b+32>>2]=m}m=c[b+12>>2]|0;if(!m){i=e;return}j=b+16|0;n=(c[j>>2]|0)+j|0;j=d+16|0;d=j;p=0;do{o=n+p|0;if(!(a[o>>0]|0))q=a[(c[j>>2]|0)+d+p>>0]|0;else q=1;a[o>>0]=q;p=p+1|0}while(p>>>0<m>>>0);c[b+20>>2]=n;i=e;return}function q_d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[b+36>>2]|0;if(f){g=b+40|0;h=(c[g>>2]|0)+g|0;g=d+40|0;j=g;k=0;do{l=h+k|0;if(!(a[l>>0]|0))m=0;else m=a[(c[g>>2]|0)+j+k>>0]|0;a[l>>0]=m;k=k+1|0}while(k>>>0<f>>>0);c[b+44>>2]=h}h=c[b+48>>2]|0;if(h){f=b+52|0;k=(c[f>>2]|0)+f|0;f=d+52|0;m=f;j=0;do{g=k+j|0;if(!(a[g>>0]|0))n=0;else n=a[(c[f>>2]|0)+m+j>>0]|0;a[g>>0]=n;j=j+1|0}while(j>>>0<h>>>0);c[b+56>>2]=k}k=c[b+60>>2]|0;if(k){h=b+64|0;j=(c[h>>2]|0)+h|0;h=d+64|0;n=h;m=0;do{f=j+m|0;if(!(a[f>>0]|0))o=0;else o=a[(c[h>>2]|0)+n+m>>0]|0;a[f>>0]=o;m=m+1|0}while(m>>>0<k>>>0);c[b+68>>2]=j}j=c[b+24>>2]|0;if(j){k=b+28|0;m=(c[k>>2]|0)+k|0;k=d+28|0;o=k;n=0;do{h=m+n|0;if(!(a[h>>0]|0))p=0;else p=a[(c[k>>2]|0)+o+n>>0]|0;a[h>>0]=p;n=n+1|0}while(n>>>0<j>>>0);c[b+32>>2]=m}m=c[b+12>>2]|0;if(!m){i=e;return}j=b+16|0;n=(c[j>>2]|0)+j|0;j=d+16|0;d=j;p=0;do{o=n+p|0;if(!(a[o>>0]|0))q=0;else q=a[(c[j>>2]|0)+d+p>>0]|0;a[o>>0]=q;p=p+1|0}while(p>>>0<m>>>0);c[b+20>>2]=n;i=e;return}function r_d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b+36>>2]|0;if(e){f=b+40|0;g=(c[f>>2]|0)+f|0;f=0;do{h=g+f|0;a[h>>0]=a[h>>0]^1;f=f+1|0}while(f>>>0<e>>>0);c[b+44>>2]=g}g=c[b+48>>2]|0;if(g){e=b+52|0;f=(c[e>>2]|0)+e|0;e=0;do{h=f+e|0;a[h>>0]=a[h>>0]^1;e=e+1|0}while(e>>>0<g>>>0);c[b+56>>2]=f}f=c[b+60>>2]|0;if(f){g=b+64|0;e=(c[g>>2]|0)+g|0;g=0;do{h=e+g|0;a[h>>0]=a[h>>0]^1;g=g+1|0}while(g>>>0<f>>>0);c[b+68>>2]=e}e=c[b+24>>2]|0;if(e){f=b+28|0;g=(c[f>>2]|0)+f|0;f=0;do{h=g+f|0;a[h>>0]=a[h>>0]^1;f=f+1|0}while(f>>>0<e>>>0);c[b+32>>2]=g}g=c[b+12>>2]|0;if(!g){i=d;return}e=b+16|0;f=(c[e>>2]|0)+e|0;e=0;do{h=f+e|0;a[h>>0]=a[h>>0]^1;e=e+1|0}while(e>>>0<g>>>0);c[b+20>>2]=f;i=d;return}function s_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;e=xo[c[c[b>>2]>>2]&2047](b,72,4)|0;if(!e)f=0;else{g=e+0|0;h=g+72|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f=e}e=c[a>>2]|0;a:do if(!e)j=f+12|0;else{g=a+4|0;h=(c[g>>2]|0)+g|0;g=f+36|0;k=f+48|0;l=f+60|0;m=f+24|0;n=f+12|0;o=0;while(1){switch(c[h+(o<<4)+8>>2]|0){case 6:{c[g>>2]=(c[g>>2]|0)+1;break}case 7:{c[k>>2]=(c[k>>2]|0)+1;break}case 8:{c[l>>2]=(c[l>>2]|0)+1;break}case 3:{c[n>>2]=(c[n>>2]|0)+1;break}case 1:{c[m>>2]=(c[m>>2]|0)+1;break}default:{}}o=o+1|0;if(o>>>0>=e>>>0){j=n;break a}}}while(0);e=c[j>>2]|0;if(e){a=xo[c[c[b>>2]>>2]&2047](b,e,1)|0;e=f+16|0;if(!a){p=0;q=e;r=0}else{p=a;q=e;r=a-e|0}}else{p=0;q=f+16|0;r=0}e=f+16|0;c[e>>2]=r;r=f+20|0;c[r>>2]=p;p=f+24|0;a=c[p>>2]|0;if(a){n=xo[c[c[b>>2]>>2]&2047](b,a,1)|0;a=f+28|0;if(!n){s=0;t=a;u=0}else{s=n;t=a;u=n-a|0}}else{s=0;t=f+28|0;u=0}a=f+28|0;c[a>>2]=u;u=f+32|0;c[u>>2]=s;s=f+36|0;n=c[s>>2]|0;if(n){o=xo[c[c[b>>2]>>2]&2047](b,n,1)|0;n=f+40|0;if(!o){v=0;w=n;x=0}else{v=o;w=n;x=o-n|0}}else{v=0;w=f+40|0;x=0}n=f+40|0;c[n>>2]=x;x=f+44|0;c[x>>2]=v;v=f+48|0;o=c[v>>2]|0;if(o){m=xo[c[c[b>>2]>>2]&2047](b,o,1)|0;o=f+52|0;if(!m){y=0;z=o;A=0}else{y=m;z=o;A=m-o|0}}else{y=0;z=f+52|0;A=0}o=f+52|0;c[o>>2]=A;A=f+56|0;c[A>>2]=y;y=f+60|0;m=c[y>>2]|0;if(m){l=xo[c[c[b>>2]>>2]&2047](b,m,1)|0;m=f+64|0;if(!l){B=0;C=0;D=m}else{B=l;C=l-m|0;D=m}}else{B=0;C=0;D=f+64|0}m=f+64|0;c[m>>2]=C;C=f+68|0;c[C>>2]=B;B=c[s>>2]|0;if(B){s=(c[n>>2]|0)+w|0;PEi(s|0,0,(B>>>0>1?B:1)|0)|0;c[x>>2]=s}s=c[v>>2]|0;if(s){v=(c[o>>2]|0)+z|0;PEi(v|0,0,(s>>>0>1?s:1)|0)|0;c[A>>2]=v}v=c[y>>2]|0;if(v){y=(c[m>>2]|0)+D|0;PEi(y|0,0,(v>>>0>1?v:1)|0)|0;c[C>>2]=y}y=c[p>>2]|0;if(y){p=(c[a>>2]|0)+t|0;PEi(p|0,0,(y>>>0>1?y:1)|0)|0;c[u>>2]=p}p=c[j>>2]|0;if(!p){i=d;return f|0}j=(c[e>>2]|0)+q|0;PEi(j|0,0,(p>>>0>1?p:1)|0)|0;c[r>>2]=j;i=d;return f|0}function t_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+16|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+20>>2]=h;In[g&4095](b,h)}h=a+28|0;g=c[h>>2]|0;if(g){e=c[(c[b>>2]|0)+4>>2]|0;f=g+h|0;c[a+32>>2]=f;In[e&4095](b,f)}f=a+40|0;e=c[f>>2]|0;if(e){h=c[(c[b>>2]|0)+4>>2]|0;g=e+f|0;c[a+44>>2]=g;In[h&4095](b,g)}g=a+52|0;h=c[g>>2]|0;if(h){f=c[(c[b>>2]|0)+4>>2]|0;e=h+g|0;c[a+56>>2]=e;In[f&4095](b,e)}e=a+64|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+68>>2]=h;In[g&4095](b,h)}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function u_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=xo[c[c[b>>2]>>2]&2047](b,72,4)|0;if(!e)f=0;else{h=e+0|0;j=h+72|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));f=e}e=c[a>>2]|0;a:do if(!e)k=f;else{h=a+4|0;j=(c[h>>2]|0)+h|0;h=f+36|0;l=f+48|0;m=f+60|0;n=f+24|0;o=f+12|0;p=0;while(1){switch(c[j+(p<<4)+8>>2]|0){case 6:{c[h>>2]=(c[h>>2]|0)+1;break}case 8:{c[m>>2]=(c[m>>2]|0)+1;break}case 4:case 9:{c[f>>2]=(c[f>>2]|0)+1;break}case 7:{c[l>>2]=(c[l>>2]|0)+1;break}case 3:{c[o>>2]=(c[o>>2]|0)+1;break}case 1:{c[n>>2]=(c[n>>2]|0)+1;break}default:{}}p=p+1|0;if(p>>>0>=e>>>0){k=f;break a}}}while(0);e=f+4|0;a=c[k>>2]|0;if((a|0)!=0?(p=xo[c[c[b>>2]>>2]&2047](b,a,1)|0,(p|0)!=0):0){q=p;r=p-e|0}else{q=0;r=0}c[e>>2]=r;r=f+8|0;c[r>>2]=q;q=f+16|0;p=f+12|0;a=c[p>>2]|0;if((a|0)!=0?(n=xo[c[c[b>>2]>>2]&2047](b,a<<2,4)|0,(n|0)!=0):0){s=n;t=n-q|0}else{s=0;t=0}c[q>>2]=t;t=f+20|0;c[t>>2]=s;s=f+28|0;n=f+24|0;a=c[n>>2]|0;if((a|0)!=0?(o=xo[c[c[b>>2]>>2]&2047](b,a<<2,4)|0,(o|0)!=0):0){u=o;v=o-s|0}else{u=0;v=0}c[s>>2]=v;v=f+32|0;c[v>>2]=u;u=f+40|0;o=f+36|0;a=c[o>>2]|0;if((a|0)!=0?(l=xo[c[c[b>>2]>>2]&2047](b,a<<4,4)|0,(l|0)!=0):0){w=l-u|0;x=l}else{w=0;x=0}c[u>>2]=w;w=f+44|0;c[w>>2]=x;x=f+52|0;l=f+48|0;a=c[l>>2]|0;if((a|0)!=0?(m=xo[c[c[b>>2]>>2]&2047](b,a<<4,4)|0,(m|0)!=0):0){y=m-x|0;z=m}else{y=0;z=0}c[x>>2]=y;y=f+56|0;c[y>>2]=z;z=f+64|0;m=f+60|0;a=c[m>>2]|0;if((a|0)!=0?(h=xo[c[c[b>>2]>>2]&2047](b,a<<4,4)|0,(h|0)!=0):0){A=h-z|0;B=h}else{A=0;B=0}c[z>>2]=A;A=f+68|0;c[A>>2]=B;B=c[k>>2]|0;if(B){k=(c[e>>2]|0)+e|0;PEi(k|0,0,(B>>>0>1?B:1)|0)|0;c[r>>2]=k}if(c[p>>2]|0){k=q;r=0;do{B=(c[q>>2]|0)+k|0;c[B+(r<<2)>>2]=0;r=r+1|0}while(r>>>0<(c[p>>2]|0)>>>0);C=B;c[t>>2]=C}C=c[n>>2]|0;if(C){n=(c[s>>2]|0)+s|0;PEi(n|0,0,(C>>>0>1?C<<2:4)|0)|0;c[v>>2]=n}n=c[o>>2]|0;if(n){o=(c[u>>2]|0)+u|0;u=0;do{v=o+(u<<4)|0;u=u+1|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0}while(u>>>0<n>>>0);c[w>>2]=o}o=c[l>>2]|0;if(o){l=(c[x>>2]|0)+x|0;x=0;do{g[l+(x<<4)>>2]=ea(0.0);g[l+(x<<4)+4>>2]=ea(0.0);g[l+(x<<4)+8>>2]=ea(0.0);g[l+(x<<4)+12>>2]=ea(1.0);x=x+1|0}while(x>>>0<o>>>0);c[y>>2]=l}l=c[m>>2]|0;if(!l){i=d;return f|0}m=(c[z>>2]|0)+z|0;z=0;do{g[m+(z<<4)>>2]=ea(1.0);g[m+(z<<4)+4>>2]=ea(1.0);g[m+(z<<4)+8>>2]=ea(1.0);g[m+(z<<4)+12>>2]=ea(1.0);z=z+1|0}while(z>>>0<l>>>0);c[A>>2]=m;i=d;return f|0}function v_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(!a){i=d;return}e=a+4|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+8>>2]=h;In[g&4095](b,h)}h=a+16|0;g=c[h>>2]|0;if(g){e=c[(c[b>>2]|0)+4>>2]|0;f=g+h|0;c[a+20>>2]=f;In[e&4095](b,f)}f=a+28|0;e=c[f>>2]|0;if(e){h=c[(c[b>>2]|0)+4>>2]|0;g=e+f|0;c[a+32>>2]=g;In[h&4095](b,g)}g=a+40|0;h=c[g>>2]|0;if(h){f=h+g|0;c[a+44>>2]=f;In[c[(c[b>>2]|0)+4>>2]&4095](b,f)}f=a+52|0;g=c[f>>2]|0;if(g){h=g+f|0;c[a+56>>2]=h;In[c[(c[b>>2]|0)+4>>2]&4095](b,h)}h=a+64|0;f=c[h>>2]|0;if(!f)j=b;else{g=f+h|0;c[a+68>>2]=g;In[c[(c[b>>2]|0)+4>>2]&4095](b,g);j=b}In[c[(c[j>>2]|0)+4>>2]&4095](b,a);i=d;return}function w_d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im;e=i;f=b+4|0;h=(c[f>>2]|0)+f|0;c[b+8>>2]=h;f=d+4|0;j=(c[f>>2]|0)+f|0;c[d+8>>2]=j;f=c[b>>2]|0;k=c[d>>2]|0;if((f>>>0<k>>>0?f:k)|0){l=~k;k=~f;f=~(l>>>0>k>>>0?l:k);k=0;do{a[j+k>>0]=a[h+k>>0]|0;k=k+1|0}while((k|0)!=(f|0))}f=b+16|0;k=(c[f>>2]|0)+f|0;c[b+20>>2]=k;f=d+16|0;h=(c[f>>2]|0)+f|0;c[d+20>>2]=h;f=c[b+12>>2]|0;j=c[d+12>>2]|0;if((f>>>0<j>>>0?f:j)|0){l=~j;j=~f;f=~(l>>>0>j>>>0?l:j);j=0;do{c[h+(j<<2)>>2]=c[k+(j<<2)>>2];j=j+1|0}while((j|0)!=(f|0))}f=b+28|0;j=(c[f>>2]|0)+f|0;c[b+32>>2]=j;f=d+28|0;k=(c[f>>2]|0)+f|0;c[d+32>>2]=k;f=c[b+24>>2]|0;h=c[d+24>>2]|0;if((f>>>0<h>>>0?f:h)|0){l=~h;h=~f;f=~(l>>>0>h>>>0?l:h);h=0;do{g[k+(h<<2)>>2]=ea(g[j+(h<<2)>>2]);h=h+1|0}while((h|0)!=(f|0))}f=b+40|0;h=(c[f>>2]|0)+f|0;c[b+44>>2]=h;f=d+40|0;j=(c[f>>2]|0)+f|0;c[d+44>>2]=j;f=c[b+36>>2]|0;k=c[d+36>>2]|0;if((f>>>0<k>>>0?f:k)|0){l=~k;k=~f;f=~(l>>>0>k>>>0?l:k);k=0;do{m=ea(g[h+(k<<4)>>2]);n=ea(g[h+(k<<4)+4>>2]);o=ea(g[h+(k<<4)+8>>2]);p=ea(g[h+(k<<4)+12>>2]);g[j+(k<<4)>>2]=m;g[j+(k<<4)+4>>2]=n;g[j+(k<<4)+8>>2]=o;g[j+(k<<4)+12>>2]=p;k=k+1|0}while((k|0)!=(f|0))}f=b+52|0;k=(c[f>>2]|0)+f|0;c[b+56>>2]=k;f=d+52|0;j=(c[f>>2]|0)+f|0;c[d+56>>2]=j;f=c[b+48>>2]|0;h=c[d+48>>2]|0;if((f>>>0<h>>>0?f:h)|0){l=~h;h=~f;f=~(l>>>0>h>>>0?l:h);h=0;do{p=ea(g[k+(h<<4)>>2]);o=ea(g[k+(h<<4)+4>>2]);n=ea(g[k+(h<<4)+8>>2]);m=ea(g[k+(h<<4)+12>>2]);g[j+(h<<4)>>2]=p;g[j+(h<<4)+4>>2]=o;g[j+(h<<4)+8>>2]=n;g[j+(h<<4)+12>>2]=m;h=h+1|0}while((h|0)!=(f|0))}f=b+64|0;h=(c[f>>2]|0)+f|0;c[b+68>>2]=h;f=d+64|0;j=(c[f>>2]|0)+f|0;c[d+68>>2]=j;f=c[b+60>>2]|0;b=c[d+60>>2]|0;if(!((f>>>0<b>>>0?f:b)|0)){i=e;return}d=~b;b=~f;f=~(d>>>0>b>>>0?d:b);b=0;do{m=ea(g[h+(b<<4)>>2]);n=ea(g[h+(b<<4)+4>>2]);o=ea(g[h+(b<<4)+8>>2]);p=ea(g[h+(b<<4)+12>>2]);g[j+(b<<4)>>2]=m;g[j+(b<<4)+4>>2]=n;g[j+(b<<4)+8>>2]=o;g[j+(b<<4)+12>>2]=p;b=b+1|0}while((b|0)!=(f|0));i=e;return}function x_d(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im;j=i;k=c[e>>2]|0;if((k|0)<=0){i=j;return}l=b+4|0;b=l;m=e+4|0;e=m;n=d+40|0;o=n;p=f+40|0;q=p;r=f+44|0;s=d+52|0;t=s;u=f+52|0;v=u;w=f+56|0;x=d+64|0;y=x;z=f+64|0;A=z;B=f+68|0;C=d+28|0;D=C;E=f+28|0;F=E;G=f+32|0;H=d+16|0;I=H;J=f+16|0;K=J;L=f+20|0;M=d+4|0;d=M;N=f+4|0;O=N;P=f+8|0;f=0;do{Q=c[h+(f<<2)>>2]|0;a:do if((Q|0)!=-1?(R=(c[l>>2]|0)+b|0,S=c[R+(Q<<4)+8>>2]|0,T=(c[m>>2]|0)+e|0,(S|0)==(c[T+(f<<4)+8>>2]|0)):0)switch(S|0){case 4:case 9:{S=a[(c[M>>2]|0)+d+(c[R+(Q<<4)+12>>2]|0)>>0]|0;U=c[T+(f<<4)+12>>2]|0;V=(c[N>>2]|0)+O|0;c[P>>2]=V;a[V+U>>0]=S;break a;break}case 6:{S=c[R+(Q<<4)+12>>2]|0;U=(c[n>>2]|0)+o|0;W=ea(g[U+(S<<4)>>2]);X=ea(g[U+(S<<4)+4>>2]);Y=ea(g[U+(S<<4)+8>>2]);Z=ea(g[U+(S<<4)+12>>2]);S=c[T+(f<<4)+12>>2]|0;U=(c[p>>2]|0)+q|0;c[r>>2]=U;g[U+(S<<4)>>2]=W;g[U+(S<<4)+4>>2]=X;g[U+(S<<4)+8>>2]=Y;g[U+(S<<4)+12>>2]=Z;break a;break}case 7:{S=c[R+(Q<<4)+12>>2]|0;U=(c[s>>2]|0)+t|0;Z=ea(g[U+(S<<4)>>2]);Y=ea(g[U+(S<<4)+4>>2]);X=ea(g[U+(S<<4)+8>>2]);W=ea(g[U+(S<<4)+12>>2]);S=c[T+(f<<4)+12>>2]|0;U=(c[u>>2]|0)+v|0;c[w>>2]=U;g[U+(S<<4)>>2]=Z;g[U+(S<<4)+4>>2]=Y;g[U+(S<<4)+8>>2]=X;g[U+(S<<4)+12>>2]=W;break a;break}case 8:{S=c[R+(Q<<4)+12>>2]|0;U=(c[x>>2]|0)+y|0;W=ea(g[U+(S<<4)>>2]);X=ea(g[U+(S<<4)+4>>2]);Y=ea(g[U+(S<<4)+8>>2]);Z=ea(g[U+(S<<4)+12>>2]);S=c[T+(f<<4)+12>>2]|0;U=(c[z>>2]|0)+A|0;c[B>>2]=U;g[U+(S<<4)>>2]=W;g[U+(S<<4)+4>>2]=X;g[U+(S<<4)+8>>2]=Y;g[U+(S<<4)+12>>2]=Z;break a;break}case 3:{S=c[(c[H>>2]|0)+I+(c[R+(Q<<4)+12>>2]<<2)>>2]|0;U=c[T+(f<<4)+12>>2]|0;V=(c[J>>2]|0)+K|0;c[L>>2]=V;c[V+(U<<2)>>2]=S;break a;break}case 1:{Z=ea(g[(c[C>>2]|0)+D+(c[R+(Q<<4)+12>>2]<<2)>>2]);R=c[T+(f<<4)+12>>2]|0;T=(c[E>>2]|0)+F|0;c[G>>2]=T;g[T+(R<<2)>>2]=Z;break a;break}default:break a}while(0);f=f+1|0}while((f|0)!=(k|0));i=j;return}function y_d(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=Im,V=0,W=Im,X=Im,Y=Im,Z=0;j=i;k=c[b>>2]|0;if((k|0)<=0){i=j;return}l=b+4|0;b=l;m=e+4|0;e=m;n=d+40|0;o=n;p=f+40|0;q=p;r=f+44|0;s=d+52|0;t=s;u=f+52|0;v=u;w=f+56|0;x=d+64|0;y=x;z=f+64|0;A=z;B=f+68|0;C=d+28|0;D=C;E=f+28|0;F=E;G=f+32|0;H=d+16|0;I=H;J=f+16|0;K=J;L=f+20|0;M=d+4|0;d=M;N=f+4|0;O=N;P=f+8|0;f=0;do{Q=c[h+(f<<2)>>2]|0;a:do if((Q|0)!=-1?(R=(c[l>>2]|0)+b|0,S=c[R+(f<<4)+8>>2]|0,T=(c[m>>2]|0)+e|0,(S|0)==(c[T+(Q<<4)+8>>2]|0)):0)switch(S|0){case 1:{U=ea(g[(c[C>>2]|0)+D+(c[R+(f<<4)+12>>2]<<2)>>2]);S=c[T+(Q<<4)+12>>2]|0;V=(c[E>>2]|0)+F|0;c[G>>2]=V;g[V+(S<<2)>>2]=U;break a;break}case 7:{S=c[R+(f<<4)+12>>2]|0;V=(c[s>>2]|0)+t|0;U=ea(g[V+(S<<4)>>2]);W=ea(g[V+(S<<4)+4>>2]);X=ea(g[V+(S<<4)+8>>2]);Y=ea(g[V+(S<<4)+12>>2]);S=c[T+(Q<<4)+12>>2]|0;V=(c[u>>2]|0)+v|0;c[w>>2]=V;g[V+(S<<4)>>2]=U;g[V+(S<<4)+4>>2]=W;g[V+(S<<4)+8>>2]=X;g[V+(S<<4)+12>>2]=Y;break a;break}case 6:{S=c[R+(f<<4)+12>>2]|0;V=(c[n>>2]|0)+o|0;Y=ea(g[V+(S<<4)>>2]);X=ea(g[V+(S<<4)+4>>2]);W=ea(g[V+(S<<4)+8>>2]);U=ea(g[V+(S<<4)+12>>2]);S=c[T+(Q<<4)+12>>2]|0;V=(c[p>>2]|0)+q|0;c[r>>2]=V;g[V+(S<<4)>>2]=Y;g[V+(S<<4)+4>>2]=X;g[V+(S<<4)+8>>2]=W;g[V+(S<<4)+12>>2]=U;break a;break}case 3:{S=c[(c[H>>2]|0)+I+(c[R+(f<<4)+12>>2]<<2)>>2]|0;V=c[T+(Q<<4)+12>>2]|0;Z=(c[J>>2]|0)+K|0;c[L>>2]=Z;c[Z+(V<<2)>>2]=S;break a;break}case 4:case 9:{S=a[(c[M>>2]|0)+d+(c[R+(f<<4)+12>>2]|0)>>0]|0;V=c[T+(Q<<4)+12>>2]|0;Z=(c[N>>2]|0)+O|0;c[P>>2]=Z;a[Z+V>>0]=S;break a;break}case 8:{S=c[R+(f<<4)+12>>2]|0;R=(c[x>>2]|0)+y|0;U=ea(g[R+(S<<4)>>2]);W=ea(g[R+(S<<4)+4>>2]);X=ea(g[R+(S<<4)+8>>2]);Y=ea(g[R+(S<<4)+12>>2]);S=c[T+(Q<<4)+12>>2]|0;T=(c[z>>2]|0)+A|0;c[B>>2]=T;g[T+(S<<4)>>2]=U;g[T+(S<<4)+4>>2]=W;g[T+(S<<4)+8>>2]=X;g[T+(S<<4)+12>>2]=Y;break a;break}default:break a}while(0);f=f+1|0}while((f|0)!=(k|0));i=j;return}function z_d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0;f=i;h=b+40|0;j=(c[h>>2]|0)+h|0;c[b+44>>2]=j;h=d+40|0;k=(c[h>>2]|0)+h|0;c[d+44>>2]=k;h=e+40|0;l=(c[h>>2]|0)+h|0;c[e+44>>2]=l;h=c[d+36>>2]|0;if(h){m=0;do{if(a[l+m>>0]|0){n=ea(g[j+(m<<4)>>2]);o=ea(g[j+(m<<4)+4>>2]);p=ea(g[j+(m<<4)+8>>2]);q=ea(g[j+(m<<4)+12>>2]);g[k+(m<<4)>>2]=n;g[k+(m<<4)+4>>2]=o;g[k+(m<<4)+8>>2]=p;g[k+(m<<4)+12>>2]=q}m=m+1|0}while((m|0)!=(h|0))}h=b+52|0;m=(c[h>>2]|0)+h|0;c[b+56>>2]=m;h=d+52|0;k=(c[h>>2]|0)+h|0;c[d+56>>2]=k;h=e+52|0;j=(c[h>>2]|0)+h|0;c[e+56>>2]=j;h=c[d+48>>2]|0;if(h){l=0;do{if(a[j+l>>0]|0){q=ea(g[m+(l<<4)>>2]);p=ea(g[m+(l<<4)+4>>2]);o=ea(g[m+(l<<4)+8>>2]);n=ea(g[m+(l<<4)+12>>2]);g[k+(l<<4)>>2]=q;g[k+(l<<4)+4>>2]=p;g[k+(l<<4)+8>>2]=o;g[k+(l<<4)+12>>2]=n}l=l+1|0}while((l|0)!=(h|0))}h=b+64|0;l=(c[h>>2]|0)+h|0;c[b+68>>2]=l;h=d+64|0;k=(c[h>>2]|0)+h|0;c[d+68>>2]=k;h=e+64|0;m=(c[h>>2]|0)+h|0;c[e+68>>2]=m;h=c[d+60>>2]|0;if(h){j=0;do{if(a[m+j>>0]|0){n=ea(g[l+(j<<4)>>2]);o=ea(g[l+(j<<4)+4>>2]);p=ea(g[l+(j<<4)+8>>2]);q=ea(g[l+(j<<4)+12>>2]);g[k+(j<<4)>>2]=n;g[k+(j<<4)+4>>2]=o;g[k+(j<<4)+8>>2]=p;g[k+(j<<4)+12>>2]=q}j=j+1|0}while((j|0)!=(h|0))}h=b+28|0;j=(c[h>>2]|0)+h|0;c[b+32>>2]=j;h=d+28|0;k=(c[h>>2]|0)+h|0;c[d+32>>2]=k;h=e+28|0;l=(c[h>>2]|0)+h|0;c[e+32>>2]=l;h=c[d+24>>2]|0;if(h){m=0;do{if(a[l+m>>0]|0)g[k+(m<<2)>>2]=ea(g[j+(m<<2)>>2]);m=m+1|0}while((m|0)!=(h|0))}h=b+16|0;m=(c[h>>2]|0)+h|0;c[b+20>>2]=m;h=d+16|0;j=(c[h>>2]|0)+h|0;c[d+20>>2]=j;h=e+16|0;k=(c[h>>2]|0)+h|0;c[e+20>>2]=k;h=c[d+12>>2]|0;if(h){l=0;do{if(a[k+l>>0]|0)c[j+(l<<2)>>2]=c[m+(l<<2)>>2];l=l+1|0}while((l|0)!=(h|0))}h=b+4|0;l=(c[h>>2]|0)+h|0;c[b+8>>2]=l;b=d+4|0;h=(c[b>>2]|0)+b|0;c[d+8>>2]=h;b=e+4|0;m=(c[b>>2]|0)+b|0;c[e+8>>2]=m;e=c[d>>2]|0;if(!e){i=f;return}else r=0;do{if(a[m+r>>0]|0)a[h+r>>0]=a[l+r>>0]|0;r=r+1|0}while((r|0)!=(e|0));i=f;return}function A_d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=0;f=i;h=b+40|0;j=(c[h>>2]|0)+h|0;c[b+44>>2]=j;h=d+40|0;k=(c[h>>2]|0)+h|0;c[d+44>>2]=k;h=e+40|0;l=(c[h>>2]|0)+h|0;c[e+44>>2]=l;h=c[d+36>>2]|0;if(h){m=0;do{if(!(a[l+m>>0]|0)){n=ea(g[j+(m<<4)>>2]);o=ea(g[j+(m<<4)+4>>2]);p=ea(g[j+(m<<4)+8>>2]);q=ea(g[j+(m<<4)+12>>2]);g[k+(m<<4)>>2]=n;g[k+(m<<4)+4>>2]=o;g[k+(m<<4)+8>>2]=p;g[k+(m<<4)+12>>2]=q}m=m+1|0}while((m|0)!=(h|0))}h=b+52|0;m=(c[h>>2]|0)+h|0;c[b+56>>2]=m;h=d+52|0;k=(c[h>>2]|0)+h|0;c[d+56>>2]=k;h=e+52|0;j=(c[h>>2]|0)+h|0;c[e+56>>2]=j;h=c[d+48>>2]|0;if(h){l=0;do{if(!(a[j+l>>0]|0)){q=ea(g[m+(l<<4)>>2]);p=ea(g[m+(l<<4)+4>>2]);o=ea(g[m+(l<<4)+8>>2]);n=ea(g[m+(l<<4)+12>>2]);g[k+(l<<4)>>2]=q;g[k+(l<<4)+4>>2]=p;g[k+(l<<4)+8>>2]=o;g[k+(l<<4)+12>>2]=n}l=l+1|0}while((l|0)!=(h|0))}h=b+64|0;l=(c[h>>2]|0)+h|0;c[b+68>>2]=l;h=d+64|0;k=(c[h>>2]|0)+h|0;c[d+68>>2]=k;h=e+64|0;m=(c[h>>2]|0)+h|0;c[e+68>>2]=m;h=c[d+60>>2]|0;if(h){j=0;do{if(!(a[m+j>>0]|0)){n=ea(g[l+(j<<4)>>2]);o=ea(g[l+(j<<4)+4>>2]);p=ea(g[l+(j<<4)+8>>2]);q=ea(g[l+(j<<4)+12>>2]);g[k+(j<<4)>>2]=n;g[k+(j<<4)+4>>2]=o;g[k+(j<<4)+8>>2]=p;g[k+(j<<4)+12>>2]=q}j=j+1|0}while((j|0)!=(h|0))}h=b+28|0;j=(c[h>>2]|0)+h|0;c[b+32>>2]=j;h=d+28|0;k=(c[h>>2]|0)+h|0;c[d+32>>2]=k;h=e+28|0;l=(c[h>>2]|0)+h|0;c[e+32>>2]=l;h=c[d+24>>2]|0;if(h){m=0;do{if(!(a[l+m>>0]|0))g[k+(m<<2)>>2]=ea(g[j+(m<<2)>>2]);m=m+1|0}while((m|0)!=(h|0))}h=b+16|0;m=(c[h>>2]|0)+h|0;c[b+20>>2]=m;h=d+16|0;j=(c[h>>2]|0)+h|0;c[d+20>>2]=j;h=e+16|0;k=(c[h>>2]|0)+h|0;c[e+20>>2]=k;h=c[d+12>>2]|0;if(h){l=0;do{if(!(a[k+l>>0]|0))c[j+(l<<2)>>2]=c[m+(l<<2)>>2];l=l+1|0}while((l|0)!=(h|0))}h=b+4|0;l=(c[h>>2]|0)+h|0;c[b+8>>2]=l;b=d+4|0;h=(c[b>>2]|0)+b|0;c[d+8>>2]=h;b=e+4|0;m=(c[b>>2]|0)+b|0;c[e+8>>2]=m;e=c[d>>2]|0;if(!e){i=f;return}else r=0;do{if(!(a[m+r>>0]|0))a[h+r>>0]=a[l+r>>0]|0;r=r+1|0}while((r|0)!=(e|0));i=f;return}function B_d(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=0,L=0,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=0,ra=Im,sa=0,ta=Im,ua=0,va=0;l=i;m=(b|0)!=0;n=c[d+36>>2]|0;if(n){o=j+40|0;p=o;q=(h|0)==0;r=b+40|0;s=r;t=d+40|0;u=t;v=d+44|0;w=c[o>>2]|0;o=0;do{if(a[w+p+o>>0]|0){if(q){x=ea(0.0);y=ea(0.0);z=ea(0.0);A=ea(0.0);B=ea(0.0)}else{C=ea(0.0);D=ea(0.0);E=ea(0.0);F=ea(0.0);G=0;H=ea(0.0);while(1){I=ea(g[f+(G<<2)>>2]);J=ea(H+I);K=(c[e+(G<<2)>>2]|0)+40|0;L=K+(c[K>>2]|0)|0;M=ea(g[L+(o<<4)>>2]);N=ea(g[L+(o<<4)+4>>2]);O=ea(g[L+(o<<4)+8>>2]);P=ea(C+ea(I*M));M=ea(D+ea(I*N));N=ea(E+ea(I*O));O=ea(F+ea(I*ea(g[L+(o<<4)+12>>2])));G=G+1|0;if((G|0)==(h|0)){x=O;y=N;z=M;A=P;B=J;break}else{C=P;D=M;E=N;F=O;H=J}}}if(m&B<ea(1.0)){H=ea(ea(1.0)-B);G=(c[r>>2]|0)+s|0;F=ea(g[G+(o<<4)>>2]);E=ea(g[G+(o<<4)+4>>2]);D=ea(g[G+(o<<4)+8>>2]);Q=ea(A+ea(H*F));R=ea(z+ea(H*E));S=ea(y+ea(H*D));U=ea(x+ea(H*ea(g[G+(o<<4)+12>>2])))}else{Q=A;R=z;S=y;U=x}G=(c[t>>2]|0)+u|0;c[v>>2]=G;g[G+(o<<4)>>2]=Q;g[G+(o<<4)+4>>2]=R;g[G+(o<<4)+8>>2]=S;g[G+(o<<4)+12>>2]=U}o=o+1|0}while(o>>>0<n>>>0)}n=c[d+48>>2]|0;if(n){o=j+52|0;v=o;u=(h|0)==0;t=b+52|0;s=t;r=d+52|0;q=r;p=d+56|0;w=c[o>>2]|0;o=0;do{if(a[w+v+o>>0]|0){if(u){V=ea(0.0);W=ea(0.0);X=ea(0.0);Y=ea(0.0);Z=ea(0.0)}else{U=ea(0.0);S=ea(0.0);R=ea(0.0);Q=ea(0.0);G=0;x=ea(0.0);while(1){y=ea(g[f+(G<<2)>>2]);z=ea(x+y);L=(c[e+(G<<2)>>2]|0)+52|0;K=L+(c[L>>2]|0)|0;A=ea(g[K+(o<<4)>>2]);B=ea(g[K+(o<<4)+4>>2]);H=ea(g[K+(o<<4)+8>>2]);D=ea(g[K+(o<<4)+12>>2]);E=ea(y*A);F=ea(y*B);C=ea(y*H);J=ea(y*D);y=ea(ea(ea(U*A)+ea(S*B))+ea(ea(R*H)+ea(Q*D)));K=(g[k>>2]=E,c[k>>2]|0);L=(g[k>>2]=y,c[k>>2]|0)&-2147483648;y=(c[k>>2]=L^K,ea(g[k>>2]));E=(c[k>>2]=L^(g[k>>2]=F,c[k>>2]|0),ea(g[k>>2]));F=(c[k>>2]=L^(g[k>>2]=C,c[k>>2]|0),ea(g[k>>2]));C=ea(U+y);y=ea(S+E);E=ea(R+F);F=ea(Q+(c[k>>2]=L^(g[k>>2]=J,c[k>>2]|0),ea(g[k>>2])));G=G+1|0;if((G|0)==(h|0)){V=F;W=E;X=y;Y=C;Z=z;break}else{U=C;S=y;R=E;Q=F;x=z}}}if(m&Z<ea(1.0)){x=ea(ea(1.0)-Z);G=(c[t>>2]|0)+s|0;Q=ea(g[G+(o<<4)>>2]);R=ea(g[G+(o<<4)+4>>2]);S=ea(g[G+(o<<4)+8>>2]);U=ea(g[G+(o<<4)+12>>2]);z=ea(x*Q);F=ea(x*R);E=ea(x*S);y=ea(x*U);x=ea(ea(ea(V*U)+ea(W*S))+ea(ea(X*R)+ea(Y*Q)));G=(g[k>>2]=z,c[k>>2]|0);L=(g[k>>2]=x,c[k>>2]|0)&-2147483648;x=(c[k>>2]=L^G,ea(g[k>>2]));z=(c[k>>2]=L^(g[k>>2]=F,c[k>>2]|0),ea(g[k>>2]));F=(c[k>>2]=L^(g[k>>2]=E,c[k>>2]|0),ea(g[k>>2]));_=ea(Y+x);$=ea(X+z);aa=ea(W+F);ba=ea(V+(c[k>>2]=L^(g[k>>2]=y,c[k>>2]|0),ea(g[k>>2])))}else{_=Y;$=X;aa=W;ba=V}y=ea(ea(1.0)/ea(T(ea(ea(ea(ba*ba)+ea(aa*aa))+ea(ea($*$)+ea(_*_))))));F=ea(_*y);z=ea($*y);x=ea(aa*y);E=ea(ba*y);L=(c[r>>2]|0)+q|0;c[p>>2]=L;g[L+(o<<4)>>2]=F;g[L+(o<<4)+4>>2]=z;g[L+(o<<4)+8>>2]=x;g[L+(o<<4)+12>>2]=E}o=o+1|0}while(o>>>0<n>>>0)}n=c[d+60>>2]|0;if(n){o=j+64|0;p=o;q=(h|0)==0;r=b+64|0;s=r;t=d+64|0;u=t;v=d+68|0;w=c[o>>2]|0;o=0;do{if(a[w+p+o>>0]|0){if(q){ca=ea(0.0);da=ea(0.0);fa=ea(0.0);ga=ea(0.0);ha=ea(0.0)}else{ba=ea(0.0);aa=ea(0.0);$=ea(0.0);_=ea(0.0);L=0;V=ea(0.0);while(1){W=ea(g[f+(L<<2)>>2]);X=ea(V+W);G=(c[e+(L<<2)>>2]|0)+64|0;K=G+(c[G>>2]|0)|0;Y=ea(g[K+(o<<4)>>2]);Z=ea(g[K+(o<<4)+4>>2]);E=ea(g[K+(o<<4)+8>>2]);x=ea(ba+ea(W*Y));Y=ea(aa+ea(W*Z));Z=ea($+ea(W*E));E=ea(_+ea(W*ea(g[K+(o<<4)+12>>2])));L=L+1|0;if((L|0)==(h|0)){ca=E;da=Z;fa=Y;ga=x;ha=X;break}else{ba=x;aa=Y;$=Z;_=E;V=X}}}if(m&ha<ea(1.0)){V=ea(ea(1.0)-ha);L=(c[r>>2]|0)+s|0;_=ea(g[L+(o<<4)>>2]);$=ea(g[L+(o<<4)+4>>2]);aa=ea(g[L+(o<<4)+8>>2]);ia=ea(ga+ea(V*_));ja=ea(fa+ea(V*$));ka=ea(da+ea(V*aa));la=ea(ca+ea(V*ea(g[L+(o<<4)+12>>2])))}else{ia=ga;ja=fa;ka=da;la=ca}L=(c[t>>2]|0)+u|0;c[v>>2]=L;g[L+(o<<4)>>2]=ia;g[L+(o<<4)+4>>2]=ja;g[L+(o<<4)+8>>2]=ka;g[L+(o<<4)+12>>2]=la}o=o+1|0}while(o>>>0<n>>>0)}n=c[d+24>>2]|0;a:do if(n){o=j+28|0;v=(c[o>>2]|0)+o|0;o=(h|0)!=0;u=b+28|0;t=u;s=d+28|0;r=s;q=d+32|0;if(m){p=0;while(1){if(a[v+p>>0]|0){if(o){la=ea(0.0);w=0;ka=ea(0.0);while(1){ja=ea(g[f+(w<<2)>>2]);ia=ea(ka+ja);L=(c[e+(w<<2)>>2]|0)+28|0;ca=ea(la+ea(ja*ea(g[L+(c[L>>2]|0)+(p<<2)>>2])));w=w+1|0;if((w|0)==(h|0)){ma=ia;na=ca;break}else{la=ca;ka=ia}}if(ma<ea(1.0)){oa=na;pa=ma;qa=26}else ra=na}else{oa=ea(0.0);pa=ea(0.0);qa=26}if((qa|0)==26){qa=0;ka=ea(ea(1.0)-pa);ra=ea(oa+ea(ka*ea(g[(c[u>>2]|0)+t+(p<<2)>>2])))}w=(c[s>>2]|0)+r|0;c[q>>2]=w;g[w+(p<<2)>>2]=ra}p=p+1|0;if(p>>>0>=n>>>0)break a}}if(o)sa=0;else{p=0;while(1){if(a[v+p>>0]|0){t=(c[s>>2]|0)+r|0;c[q>>2]=t;g[t+(p<<2)>>2]=ea(0.0)}p=p+1|0;if(p>>>0>=n>>>0)break a}}do{if(a[v+sa>>0]|0){ka=ea(0.0);p=0;while(1){la=ea(g[f+(p<<2)>>2]);o=(c[e+(p<<2)>>2]|0)+28|0;ia=ea(ka+ea(la*ea(g[o+(c[o>>2]|0)+(sa<<2)>>2])));p=p+1|0;if((p|0)==(h|0)){ta=ia;break}else ka=ia}p=(c[s>>2]|0)+r|0;c[q>>2]=p;g[p+(sa<<2)>>2]=ta}sa=sa+1|0}while(sa>>>0<n>>>0)}while(0);if(h>>>0>1){n=1;sa=0;ta=ea(g[f>>2]);while(1){ra=ea(g[f+(n<<2)>>2]);qa=ra>ta;m=qa?n:sa;n=n+1|0;if((n|0)==(h|0)){ua=m;break}else{sa=m;ta=qa?ra:ta}}}else ua=0;sa=d+12|0;h=c[sa>>2]|0;if(!h){i=l;return}n=j+16|0;j=n;f=e+(ua<<2)|0;ua=d+16|0;e=ua;qa=d+20|0;d=h;h=0;while(1){if(!(a[(c[n>>2]|0)+j+h>>0]|0))va=d;else{m=(c[f>>2]|0)+16|0;b=c[m+(c[m>>2]|0)+(h<<2)>>2]|0;m=(c[ua>>2]|0)+e|0;c[qa>>2]=m;c[m+(h<<2)>>2]=b;va=c[sa>>2]|0}h=h+1|0;if(h>>>0>=va>>>0)break;else d=va}i=l;return}function C_d(b,d,e,f,h,j,l){b=b|0;d=d|0;e=e|0;f=ea(f);h=h|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=0,S=0,U=Im,V=Im,W=Im,X=Im,Y=0,Z=0,_=Im,$=Im,aa=Im,ba=Im,ca=0,da=0,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0;m=i;n=c[d+36>>2]|0;if(n){o=e+40|0;p=o;q=d+40|0;r=q;s=l+40|0;t=s;u=l+44|0;v=j+40|0;w=v;x=b+40|0;y=x;z=j+44|0;A=f<ea(1.0);B=c[o>>2]|0;o=0;do{if(a[B+p+o>>0]|0){C=(c[q>>2]|0)+r|0;D=ea(g[C+(o<<4)>>2]);E=ea(g[C+(o<<4)+4>>2]);F=ea(g[C+(o<<4)+8>>2]);G=ea(g[C+(o<<4)+12>>2]);C=c[s>>2]|0;if(!h)if(A){H=C+t|0;c[u>>2]=H;if(!(a[H+o>>0]|0))I=(c[v>>2]|0)+w|0;else I=(c[x>>2]|0)+y|0;H=I;J=ea(g[H+(o<<4)>>2]);K=ea(g[H+(o<<4)+4>>2]);L=ea(g[H+(o<<4)+8>>2]);M=ea(g[H+(o<<4)+12>>2]);N=ea(J+ea(ea(D-J)*f));O=ea(K+ea(ea(E-K)*f));P=ea(L+ea(ea(F-L)*f));Q=ea(M+ea(ea(G-M)*f))}else{N=D;O=E;P=F;Q=G}else{H=C+t|0;c[u>>2]=H;if(!(a[H+o>>0]|0))R=(c[v>>2]|0)+w|0;else R=(c[x>>2]|0)+y|0;H=R;M=ea(g[H+(o<<4)>>2]);L=ea(g[H+(o<<4)+4>>2]);K=ea(g[H+(o<<4)+8>>2]);N=ea(ea(D*f)+M);O=ea(ea(E*f)+L);P=ea(ea(F*f)+K);Q=ea(ea(G*f)+ea(g[H+(o<<4)+12>>2]))}H=(c[v>>2]|0)+w|0;c[z>>2]=H;g[H+(o<<4)>>2]=N;g[H+(o<<4)+4>>2]=O;g[H+(o<<4)+8>>2]=P;g[H+(o<<4)+12>>2]=Q;H=C+t|0;c[u>>2]=H;a[H+o>>0]=0}o=o+1|0}while(o>>>0<n>>>0)}n=c[d+48>>2]|0;if(n){o=e+52|0;u=o;t=d+52|0;z=t;w=l+52|0;v=w;R=l+56|0;y=j+52|0;x=y;I=b+52|0;A=I;s=j+56|0;r=f<ea(1.0);q=c[o>>2]|0;o=0;do{if(a[q+u+o>>0]|0){p=(c[t>>2]|0)+z|0;Q=ea(g[p+(o<<4)>>2]);P=ea(g[p+(o<<4)+4>>2]);O=ea(g[p+(o<<4)+8>>2]);N=ea(g[p+(o<<4)+12>>2]);p=c[w>>2]|0;if(!h)if(r){B=p+v|0;c[R>>2]=B;if(!(a[B+o>>0]|0))S=(c[y>>2]|0)+x|0;else S=(c[I>>2]|0)+A|0;B=S;G=ea(g[B+(o<<4)>>2]);K=ea(g[B+(o<<4)+4>>2]);F=ea(g[B+(o<<4)+8>>2]);L=ea(g[B+(o<<4)+12>>2]);E=ea(ea(ea(Q*G)+ea(P*K))+ea(ea(O*F)+ea(N*L)));B=(g[k>>2]=Q,c[k>>2]|0);H=(g[k>>2]=E,c[k>>2]|0)&-2147483648;E=(c[k>>2]=H^B,ea(g[k>>2]));M=(c[k>>2]=H^(g[k>>2]=P,c[k>>2]|0),ea(g[k>>2]));D=(c[k>>2]=H^(g[k>>2]=O,c[k>>2]|0),ea(g[k>>2]));J=ea(G+ea(ea(E-G)*f));G=ea(K+ea(ea(M-K)*f));K=ea(F+ea(ea(D-F)*f));F=ea(L+ea(ea((c[k>>2]=H^(g[k>>2]=N,c[k>>2]|0),ea(g[k>>2]))-L)*f));L=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(G*G))+ea(ea(K*K)+ea(F*F))))));U=ea(L*J);V=ea(L*G);W=ea(L*K);X=ea(L*F)}else{U=Q;V=P;W=O;X=N}else{H=p+v|0;c[R>>2]=H;if(!(a[H+o>>0]|0))Y=(c[y>>2]|0)+x|0;else Y=(c[I>>2]|0)+A|0;H=Y;F=ea(g[H+(o<<4)>>2]);L=ea(g[H+(o<<4)+4>>2]);K=ea(g[H+(o<<4)+8>>2]);G=ea(g[H+(o<<4)+12>>2]);J=ea(Q*f);Q=ea(P*f);P=ea(O*f);O=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(Q*Q))+ea(ea(P*P)+ea(N*N))))));D=ea(J*O);J=ea(Q*O);Q=ea(P*O);P=ea(N*O);U=ea(-ea(ea(ea(ea(K*J)-ea(L*Q))-ea(G*D))-ea(F*P)));V=ea(-ea(ea(ea(ea(F*Q)-ea(K*D))-ea(G*J))-ea(L*P)));W=ea(-ea(ea(ea(ea(L*D)-ea(G*Q))-ea(K*P))-ea(F*J)));X=ea(ea(ea(ea(G*P)-ea(F*D))-ea(K*Q))-ea(L*J))}H=(c[y>>2]|0)+x|0;c[s>>2]=H;g[H+(o<<4)>>2]=U;g[H+(o<<4)+4>>2]=V;g[H+(o<<4)+8>>2]=W;g[H+(o<<4)+12>>2]=X;H=p+v|0;c[R>>2]=H;a[H+o>>0]=0}o=o+1|0}while(o>>>0<n>>>0)}n=c[d+60>>2]|0;if(n){o=e+64|0;R=o;v=d+64|0;s=v;x=l+64|0;y=x;Y=l+68|0;A=j+64|0;I=A;S=b+64|0;r=S;w=j+68|0;z=f<ea(1.0);t=c[o>>2]|0;o=0;do{if(a[t+R+o>>0]|0){u=(c[v>>2]|0)+s|0;X=ea(g[u+(o<<4)>>2]);W=ea(g[u+(o<<4)+4>>2]);V=ea(g[u+(o<<4)+8>>2]);U=ea(g[u+(o<<4)+12>>2]);u=c[x>>2]|0;if(!h)if(z){q=u+y|0;c[Y>>2]=q;if(!(a[q+o>>0]|0))Z=(c[A>>2]|0)+I|0;else Z=(c[S>>2]|0)+r|0;q=Z;J=ea(g[q+(o<<4)>>2]);L=ea(g[q+(o<<4)+4>>2]);Q=ea(g[q+(o<<4)+8>>2]);K=ea(g[q+(o<<4)+12>>2]);_=ea(J+ea(ea(X-J)*f));$=ea(L+ea(ea(W-L)*f));aa=ea(Q+ea(ea(V-Q)*f));ba=ea(K+ea(ea(U-K)*f))}else{_=X;$=W;aa=V;ba=U}else{q=u+y|0;c[Y>>2]=q;if(!(a[q+o>>0]|0))ca=(c[A>>2]|0)+I|0;else ca=(c[S>>2]|0)+r|0;q=ca;K=ea(g[q+(o<<4)>>2]);Q=ea(g[q+(o<<4)+4>>2]);L=ea(g[q+(o<<4)+8>>2]);_=ea(ea(X*f)+K);$=ea(ea(W*f)+Q);aa=ea(ea(V*f)+L);ba=ea(ea(U*f)+ea(g[q+(o<<4)+12>>2]))}q=(c[A>>2]|0)+I|0;c[w>>2]=q;g[q+(o<<4)>>2]=_;g[q+(o<<4)+4>>2]=$;g[q+(o<<4)+8>>2]=aa;g[q+(o<<4)+12>>2]=ba;q=u+y|0;c[Y>>2]=q;a[q+o>>0]=0}o=o+1|0}while(o>>>0<n>>>0)}n=c[d+24>>2]|0;if(n){o=e+28|0;Y=o;y=d+28|0;w=y;I=l+28|0;A=I;ca=l+32|0;r=j+28|0;S=r;Z=b+28|0;z=Z;x=j+32|0;s=f<ea(1.0);ba=ea(ea(1.0)-f);v=c[o>>2]|0;o=0;do{if(a[v+Y+o>>0]|0){aa=ea(g[(c[y>>2]|0)+w+(o<<2)>>2]);R=c[I>>2]|0;if(!h)if(s){t=R+A|0;c[ca>>2]=t;if(!(a[t+o>>0]|0))da=(c[r>>2]|0)+S|0;else da=(c[Z>>2]|0)+z|0;fa=ea(ea(aa*f)+ea(ba*ea(g[da+(o<<2)>>2])))}else fa=aa;else{t=R+A|0;c[ca>>2]=t;if(!(a[t+o>>0]|0))ga=(c[r>>2]|0)+S|0;else ga=(c[Z>>2]|0)+z|0;fa=ea(ea(aa*f)+ea(g[ga+(o<<2)>>2]))}t=(c[r>>2]|0)+S|0;c[x>>2]=t;g[t+(o<<2)>>2]=fa;t=R+A|0;c[ca>>2]=t;a[t+o>>0]=0}o=o+1|0}while(o>>>0<n>>>0)}n=f>ea(.5);o=d+12|0;ca=c[o>>2]|0;A=(ca|0)==0;if(n){if(A){i=m;return}n=e+16|0;x=n;S=d+16|0;d=S;r=j+16|0;ga=r;z=j+20|0;Z=l+16|0;da=Z;s=l+20|0;h=ca;I=0;while(1){if(!(a[(c[n>>2]|0)+x+I>>0]|0))ha=h;else{w=c[(c[S>>2]|0)+d+(I<<2)>>2]|0;y=(c[r>>2]|0)+ga|0;c[z>>2]=y;c[y+(I<<2)>>2]=w;w=(c[Z>>2]|0)+da|0;c[s>>2]=w;a[w+I>>0]=0;ha=c[o>>2]|0}I=I+1|0;if(I>>>0>=ha>>>0)break;else h=ha}i=m;return}if(A){i=m;return}A=e+16|0;e=A;ha=l+16|0;h=ha;I=l+20|0;l=j+16|0;s=l;da=j+20|0;j=b+16|0;b=j;Z=ca;ca=0;while(1){if(!(a[(c[A>>2]|0)+e+ca>>0]|0))ia=Z;else{z=(c[ha>>2]|0)+h|0;c[I>>2]=z;if(!(a[z+ca>>0]|0)){z=c[l>>2]|0;ja=z+s|0;ka=z}else{ja=(c[j>>2]|0)+b|0;ka=c[l>>2]|0}z=c[ja+(ca<<2)>>2]|0;ga=ka+s|0;c[da>>2]=ga;c[ga+(ca<<2)>>2]=z;z=(c[ha>>2]|0)+h|0;c[I>>2]=z;a[z+ca>>0]=0;ia=c[o>>2]|0}ca=ca+1|0;if(ca>>>0>=ia>>>0)break;else Z=ia}i=m;return}function D_d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;f=i;h=c[d+36>>2]|0;if(h){j=e+40|0;k=j;l=d+40|0;m=l;n=b+40|0;o=n;p=d+44|0;q=c[j>>2]|0;j=0;do{if(a[q+k+j>>0]|0){r=(c[l>>2]|0)+m|0;s=r+(j<<4)|0;t=ea(g[s>>2]);u=r+(j<<4)+4|0;v=ea(g[u>>2]);w=r+(j<<4)+8|0;x=ea(g[w>>2]);y=r+(j<<4)+12|0;z=ea(g[y>>2]);A=(c[n>>2]|0)+o|0;B=ea(g[A+(j<<4)>>2]);C=ea(g[A+(j<<4)+4>>2]);D=ea(g[A+(j<<4)+8>>2]);E=ea(t-B);B=ea(v-C);C=ea(x-D);D=ea(z-ea(g[A+(j<<4)+12>>2]));c[p>>2]=r;g[s>>2]=E;g[u>>2]=B;g[w>>2]=C;g[y>>2]=D}j=j+1|0}while(j>>>0<h>>>0)}h=c[d+48>>2]|0;if(h){j=e+52|0;p=j;o=d+52|0;n=o;m=b+52|0;l=m;k=d+56|0;q=c[j>>2]|0;j=0;do{if(a[q+p+j>>0]|0){y=(c[o>>2]|0)+n|0;w=y+(j<<4)|0;D=ea(g[w>>2]);u=y+(j<<4)+4|0;C=ea(g[u>>2]);s=y+(j<<4)+8|0;B=ea(g[s>>2]);r=y+(j<<4)+12|0;E=ea(g[r>>2]);A=(c[m>>2]|0)+l|0;z=ea(g[A+(j<<4)>>2]);x=ea(g[A+(j<<4)+4>>2]);v=ea(g[A+(j<<4)+8>>2]);t=ea(g[A+(j<<4)+12>>2]);F=ea(-z);z=ea(-x);x=ea(-v);v=ea(ea(ea(ea(D*z)-ea(B*t))-ea(E*x))-ea(C*F));G=ea(ea(ea(ea(E*t)-ea(D*F))-ea(B*x))-ea(C*z));H=ea(ea(ea(ea(C*x)-ea(B*z))-ea(D*t))-ea(E*F));I=ea(ea(ea(ea(B*F)-ea(D*x))-ea(C*t))-ea(E*z));z=ea(ea(1.0)/ea(T(ea(ea(ea(H*H)+ea(I*I))+ea(ea(v*v)+ea(G*G))))));E=ea(-ea(z*H));H=ea(-ea(z*I));I=ea(-ea(z*v));v=ea(z*G);c[k>>2]=y;g[w>>2]=E;g[u>>2]=H;g[s>>2]=I;g[r>>2]=v}j=j+1|0}while(j>>>0<h>>>0)}h=c[d+60>>2]|0;if(h){j=e+64|0;k=j;l=d+64|0;m=l;n=b+64|0;o=n;p=d+68|0;q=c[j>>2]|0;j=0;do{if(a[q+k+j>>0]|0){r=(c[l>>2]|0)+m|0;s=r+(j<<4)|0;v=ea(g[s>>2]);u=r+(j<<4)+4|0;I=ea(g[u>>2]);w=r+(j<<4)+8|0;H=ea(g[w>>2]);y=r+(j<<4)+12|0;E=ea(g[y>>2]);A=(c[n>>2]|0)+o|0;G=ea(g[A+(j<<4)>>2]);z=ea(g[A+(j<<4)+4>>2]);t=ea(g[A+(j<<4)+8>>2]);C=ea(v-G);G=ea(I-z);z=ea(H-t);t=ea(E-ea(g[A+(j<<4)+12>>2]));c[p>>2]=r;g[s>>2]=C;g[u>>2]=G;g[w>>2]=z;g[y>>2]=t}j=j+1|0}while(j>>>0<h>>>0)}h=c[d+24>>2]|0;if(!h){i=f;return}j=e+28|0;e=(c[j>>2]|0)+j|0;j=d+28|0;p=(c[j>>2]|0)+j|0;j=b+28|0;b=(c[j>>2]|0)+j|0;j=d+32|0;d=0;do{if(a[e+d>>0]|0){o=p+(d<<2)|0;t=ea(g[o>>2]);z=ea(t-ea(g[b+(d<<2)>>2]));c[j>>2]=p;g[o>>2]=z}d=d+1|0}while(d>>>0<h>>>0);i=f;return}function E_d(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=ea(f);h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=Im,Q=Im,R=Im,S=Im;j=i;k=c[e+36>>2]|0;if(k){l=h+40|0;m=l;n=e+40|0;o=n;p=b+40|0;q=p;r=d+40|0;s=r;t=e+44|0;u=c[l>>2]|0;l=0;do{if(a[u+m+l>>0]|0){v=(c[n>>2]|0)+o|0;w=v+(l<<4)|0;x=ea(g[w>>2]);y=v+(l<<4)+4|0;z=ea(g[y>>2]);A=v+(l<<4)+8|0;B=ea(g[A>>2]);C=v+(l<<4)+12|0;D=ea(g[C>>2]);E=(c[p>>2]|0)+q|0;F=ea(g[E+(l<<4)>>2]);G=ea(g[E+(l<<4)+4>>2]);H=ea(g[E+(l<<4)+8>>2]);I=ea(g[E+(l<<4)+12>>2]);E=(c[r>>2]|0)+s|0;J=ea(g[E+(l<<4)>>2]);K=ea(g[E+(l<<4)+4>>2]);L=ea(g[E+(l<<4)+8>>2]);M=ea(x+ea(ea(F-J)*f));J=ea(z+ea(ea(G-K)*f));K=ea(B+ea(ea(H-L)*f));L=ea(D+ea(ea(I-ea(g[E+(l<<4)+12>>2]))*f));c[t>>2]=v;g[w>>2]=M;g[y>>2]=J;g[A>>2]=K;g[C>>2]=L}l=l+1|0}while(l>>>0<k>>>0)}k=e+48|0;l=c[k>>2]|0;if(l){t=h+52|0;s=t;r=e+52|0;q=r;p=b+52|0;o=p;n=d+52|0;m=n;u=e+56|0;C=l;l=0;while(1){if(!(a[(c[t>>2]|0)+s+l>>0]|0))N=C;else{A=(c[r>>2]|0)+q|0;y=A+(l<<4)|0;L=ea(g[y>>2]);w=A+(l<<4)+4|0;K=ea(g[w>>2]);v=A+(l<<4)+8|0;J=ea(g[v>>2]);E=A+(l<<4)+12|0;M=ea(g[E>>2]);O=(c[p>>2]|0)+o|0;I=ea(g[O+(l<<4)>>2]);D=ea(g[O+(l<<4)+4>>2]);H=ea(g[O+(l<<4)+8>>2]);B=ea(g[O+(l<<4)+12>>2]);O=(c[n>>2]|0)+m|0;G=ea(g[O+(l<<4)>>2]);z=ea(g[O+(l<<4)+4>>2]);F=ea(g[O+(l<<4)+8>>2]);x=ea(g[O+(l<<4)+12>>2]);P=ea(-G);G=ea(-z);z=ea(-F);F=ea(ea(ea(ea(B*x)-ea(I*P))-ea(H*z))-ea(D*G));Q=ea(ea(ea(ea(ea(D*z)-ea(H*G))-ea(I*x))-ea(B*P))*f);R=ea(ea(ea(ea(ea(H*P)-ea(I*z))-ea(D*x))-ea(B*G))*f);S=ea(ea(ea(ea(ea(I*G)-ea(H*x))-ea(B*z))-ea(D*P))*f);P=ea(ea(1.0)/ea(T(ea(ea(ea(Q*Q)+ea(R*R))+ea(ea(F*F)+ea(S*S))))));D=ea(-ea(P*Q));Q=ea(-ea(P*R));R=ea(-ea(P*S));S=ea(P*F);F=ea(ea(ea(ea(K*D)-ea(M*R))-ea(J*S))-ea(L*Q));P=ea(ea(ea(ea(M*S)-ea(L*D))-ea(J*R))-ea(K*Q));z=ea(ea(ea(ea(J*Q)-ea(K*R))-ea(M*D))-ea(L*S));B=ea(ea(ea(ea(L*R)-ea(J*D))-ea(M*Q))-ea(K*S));S=ea(ea(1.0)/ea(T(ea(ea(ea(z*z)+ea(B*B))+ea(ea(F*F)+ea(P*P))))));K=ea(-ea(S*z));z=ea(-ea(S*B));B=ea(-ea(S*F));F=ea(S*P);c[u>>2]=A;g[y>>2]=K;g[w>>2]=z;g[v>>2]=B;g[E>>2]=F;N=c[k>>2]|0}l=l+1|0;if(l>>>0>=N>>>0)break;else C=N}}N=c[e+60>>2]|0;if(N){C=h+64|0;l=C;k=e+64|0;u=k;m=b+64|0;n=m;o=d+64|0;p=o;q=e+68|0;r=c[C>>2]|0;C=0;do{if(a[r+l+C>>0]|0){s=(c[k>>2]|0)+u|0;t=s+(C<<4)|0;F=ea(g[t>>2]);E=s+(C<<4)+4|0;B=ea(g[E>>2]);v=s+(C<<4)+8|0;z=ea(g[v>>2]);w=s+(C<<4)+12|0;K=ea(g[w>>2]);y=(c[m>>2]|0)+n|0;P=ea(g[y+(C<<4)>>2]);S=ea(g[y+(C<<4)+4>>2]);Q=ea(g[y+(C<<4)+8>>2]);M=ea(g[y+(C<<4)+12>>2]);y=(c[o>>2]|0)+p|0;D=ea(g[y+(C<<4)>>2]);J=ea(g[y+(C<<4)+4>>2]);R=ea(g[y+(C<<4)+8>>2]);L=ea(F+ea(ea(P-D)*f));D=ea(B+ea(ea(S-J)*f));J=ea(z+ea(ea(Q-R)*f));R=ea(K+ea(ea(M-ea(g[y+(C<<4)+12>>2]))*f));c[q>>2]=s;g[t>>2]=L;g[E>>2]=D;g[v>>2]=J;g[w>>2]=R}C=C+1|0}while(C>>>0<N>>>0)}N=c[e+24>>2]|0;if(!N){i=j;return}C=h+28|0;h=(c[C>>2]|0)+C|0;C=e+28|0;q=(c[C>>2]|0)+C|0;C=b+28|0;b=(c[C>>2]|0)+C|0;C=d+28|0;d=(c[C>>2]|0)+C|0;C=e+32|0;e=0;do{if(a[h+e>>0]|0){p=q+(e<<2)|0;R=ea(g[p>>2]);J=ea(g[b+(e<<2)>>2]);D=ea(R+ea(ea(J-ea(g[d+(e<<2)>>2]))*f));c[C>>2]=q;g[p>>2]=D}e=e+1|0}while(e>>>0<N>>>0);i=j;return}function F_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;a:do if((a|0)!=0?(e=a+4|0,f=c[a>>2]|0,(f|0)!=0):0){g=(c[e>>2]|0)+e|0;e=0;while(1){if((c[g+(e<<4)>>2]|0)==(b|0)){h=e;break a}e=e+1|0;if(e>>>0>=f>>>0){h=-1;break}}}else h=-1;while(0);i=d;return h|0}function G_d(a){a=a|0;return c[716128+(a<<2)>>2]|0}function H_d(a){a=a|0;return c[716184+(a<<2)>>2]|0}function I_d(a){a=a|0;return c[716240+(a<<2)>>2]|0}function J_d(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0;b=i;d=a+28|0;e=a+44|0;f=a+40|0;h=a+36|0;j=a+32|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;k=a+48|0;a=k+96|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(a|0));g[d>>2]=ea(1.0);g[j>>2]=ea(1.0);g[h>>2]=ea(1.0);g[f>>2]=ea(1.0);g[e>>2]=ea(1.0);i=b;return}function K_d(a,b){a=a|0;b=b|0;g[b+48>>2]=ea(g[a+48>>2]);g[b+52>>2]=ea(g[a+52>>2]);g[b+56>>2]=ea(g[a+56>>2]);g[b+60>>2]=ea(g[a+60>>2]);g[b+64>>2]=ea(g[a+64>>2]);g[b+68>>2]=ea(g[a+68>>2]);g[b+72>>2]=ea(g[a+72>>2]);g[b+76>>2]=ea(g[a+76>>2]);g[b+80>>2]=ea(g[a+80>>2]);g[b+84>>2]=ea(g[a+84>>2]);g[b+88>>2]=ea(g[a+88>>2]);g[b+92>>2]=ea(g[a+92>>2]);g[b+96>>2]=ea(g[a+96>>2]);g[b+100>>2]=ea(g[a+100>>2]);g[b+104>>2]=ea(g[a+104>>2]);g[b+108>>2]=ea(g[a+108>>2]);g[b+112>>2]=ea(g[a+112>>2]);g[b+116>>2]=ea(g[a+116>>2]);g[b+120>>2]=ea(g[a+120>>2]);g[b+124>>2]=ea(g[a+124>>2]);return}function L_d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im;f=i;i=i+16|0;h=f;j=h+4|0;k=h+8|0;l=h+12|0;m=0;do{n=m*3|0;o=m<<2;p=c[a+(n<<2)>>2]|0;if((p|0)>-1){q=ea(g[d+((o|1)<<2)+48>>2]);r=ea(g[d+(o<<2)+48>>2]);g[h>>2]=ea(0.0);g[j>>2]=q;g[k>>2]=r;g[l>>2]=ea(0.0);D$d(b,e,h,p)}p=c[a+(n+1<<2)>>2]|0;if((p|0)>-1){r=ea(g[d+((o|2)<<2)+48>>2]);g[h>>2]=ea(0.0);g[j>>2]=ea(0.0);g[k>>2]=r;g[l>>2]=ea(0.0);D$d(b,e,h,p)}p=c[a+(n+2<<2)>>2]|0;if((p|0)>-1){r=ea(g[d+((o|3)<<2)+48>>2]);g[h>>2]=ea(0.0);g[j>>2]=ea(0.0);g[k>>2]=r;g[l>>2]=ea(0.0);D$d(b,e,h,p)}m=m+1|0}while((m|0)!=5);i=f;return}function M_d(a){a=a|0;return c[716312+(a<<2)>>2]|0}function N_d(a){a=a|0;return c[716736+(a<<2)>>2]|0}function O_d(a){a=a|0;return (c[a+4>>2]&2097152|0)!=0|0}function P_d(a){a=a|0;return (c[a+4>>2]&4194304|0)!=0|0}function Q_d(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[a+28>>2]=ea(1.0);g[a+44>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+32>>2]=ea(1.0);d=a+80|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[a+108>>2]=ea(1.0);g[a+124>>2]=ea(1.0);g[a+120>>2]=ea(1.0);g[a+116>>2]=ea(1.0);g[a+112>>2]=ea(1.0);d=a+184|0;e=a+128|0;f=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[d>>2]=ea(1.0);g[a+200>>2]=ea(1.0);g[a+196>>2]=ea(1.0);g[a+192>>2]=ea(1.0);g[a+188>>2]=ea(1.0);d=a+260|0;e=a+204|0;f=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[d>>2]=ea(1.0);g[a+276>>2]=ea(1.0);g[a+272>>2]=ea(1.0);g[a+268>>2]=ea(1.0);g[a+264>>2]=ea(1.0);d=a+336|0;e=a+280|0;f=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));g[d>>2]=ea(1.0);g[a+352>>2]=ea(1.0);g[a+348>>2]=ea(1.0);g[a+344>>2]=ea(1.0);g[a+340>>2]=ea(1.0);d=a+356|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;J_d(a+384|0);J_d(a+528|0);PEi(a+672|0,0,208)|0;d=a+48|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;i=b;return}function R_d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=f+4|0;k=f+8|0;l=f+12|0;m=ea(0.0);n=ea(0.0);o=ea(0.0);p=ea(0.0);q=0;r=ea(0.0);while(1){if((c[b+(q<<2)+104>>2]|0)>-1){s=ea(g[b+(q<<2)+200>>2]);U_d(f,b,d,q);t=ea(s*ea(g[f>>2]));u=ea(s*ea(g[j>>2]));v=ea(s*ea(g[k>>2]));w=ea(p+ea(s*ea(g[l>>2])));x=ea(o+v);y=ea(n+u);z=ea(m+t);A=ea(r+s)}else{w=p;x=o;y=n;z=m;A=r}q=q+1|0;if((q|0)==24){B=w;C=x;D=y;E=z;F=A;break}else{m=z;n=y;o=x;p=w;r=A}}A=ea(E/F);E=ea(D/F);D=ea(C/F);C=ea(B/F);V_d(h,b,d);g[a>>2]=A;g[a+4>>2]=E;g[a+8>>2]=D;g[a+12>>2]=C;C=ea(g[h>>2]);D=ea(g[h+4>>2]);E=ea(g[h+8>>2]);A=ea(g[h+12>>2]);g[a+16>>2]=C;g[a+20>>2]=D;g[a+24>>2]=E;g[a+28>>2]=A;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);i=e;return}function S_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=0;d=i;if((c[a+140>>2]|0)<0){e=b+696|0;f=ea(g[e>>2]);h=b+708|0;g[h>>2]=ea(f+ea(g[h>>2]));g[e>>2]=ea(0.0);e=b+700|0;f=ea(g[e>>2]);h=b+712|0;g[h>>2]=ea(f+ea(g[h>>2]));g[e>>2]=ea(0.0);e=b+704|0;f=ea(g[e>>2]);h=b+716|0;g[h>>2]=ea(f+ea(g[h>>2]));g[e>>2]=ea(0.0)}if((c[a+136>>2]|0)<0){e=b+684|0;f=ea(g[e>>2]);h=b+672|0;g[h>>2]=ea(f+ea(g[h>>2]));g[e>>2]=ea(0.0);e=b+688|0;f=ea(g[e>>2]);h=b+676|0;g[h>>2]=ea(f+ea(g[h>>2]));g[e>>2]=ea(0.0);e=b+692|0;f=ea(g[e>>2]);h=b+680|0;g[h>>2]=ea(f+ea(g[h>>2]));g[e>>2]=ea(0.0)}if((c[a+148>>2]|0)<0){e=b+808|0;f=ea(ea(g[e>>2])*ea(.150000006));h=b+816|0;g[h>>2]=ea(ea(g[h>>2])+f);g[e>>2]=ea(0.0);e=b+812|0;f=ea(ea(g[e>>2])*ea(.28125));h=b+820|0;g[h>>2]=ea(ea(g[h>>2])+f);g[e>>2]=ea(0.0)}if((c[a+152>>2]|0)>=0){i=d;return}a=b+844|0;f=ea(ea(g[a>>2])*ea(.150000006));e=b+852|0;g[e>>2]=ea(ea(g[e>>2])+f);g[a>>2]=ea(0.0);a=b+848|0;f=ea(ea(g[a>>2])*ea(.28125));e=b+856|0;g[e>>2]=ea(ea(g[e>>2])+f);g[a>>2]=ea(0.0);i=d;return}function T_d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=0;f=i;i=i+16|0;h=f;j=h+4|0;l=h+8|0;m=h+12|0;n=b+48|0;o=n;p=b+52|0;q=1;do{r=b+(q<<2)+104|0;if((c[r>>2]|0)!=-1){s=ea(g[d+(c[718256+(q*12|0)>>2]<<2)+672>>2]);t=ea(g[d+(c[718252+(q*12|0)>>2]<<2)+672>>2]);u=ea(g[d+(c[718248+(q*12|0)>>2]<<2)+672>>2]);v=(g[k>>2]=s,c[k>>2]|0)&0-(124830>>>q&1)|0;w=(g[k>>2]=t,c[k>>2]|0)&0-(15106022>>>q&1)|0;c[h>>2]=v;c[j>>2]=w;g[l>>2]=u;g[m>>2]=ea(0.0);w=(c[n>>2]|0)+o|0;c[p>>2]=w;D$d(w,e,h,c[r>>2]|0)}q=q+1|0}while((q|0)!=24);if(a[b+424>>0]|0){q=b+64|0;h=(c[q>>2]|0)+q|0;c[b+68>>2]=h;q=(c[n>>2]|0)+o|0;c[p>>2]=q;L_d(h,q,d+384|0,e)}if(!(a[b+425>>0]|0)){i=f;return}q=b+72|0;h=(c[q>>2]|0)+q|0;c[b+76>>2]=h;b=(c[n>>2]|0)+o|0;c[p>>2]=b;L_d(h,b,d+528|0,e);i=f;return}function U_d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;f=i;h=a+12|0;j=a+8|0;k=a+4|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;do switch(e|0){case 8:{l=c[b+140>>2]|0;if(((l|0)>-1?(m=c[b+148>>2]|0,(m|0)>-1):0)?(n=c[b+152>>2]|0,(n|0)>-1):0){o=d+4|0;p=c[b+136>>2]|0;q=(c[o>>2]|0)+o|0;r=ea(g[q+(p*48|0)>>2]);s=ea(r+ea(g[q+(l*48|0)>>2]));r=ea(g[q+(p*48|0)+4>>2]);t=ea(r+ea(g[q+(l*48|0)+4>>2]));r=ea(g[q+(p*48|0)+8>>2]);u=ea(r+ea(g[q+(l*48|0)+8>>2]));r=ea(g[q+(p*48|0)+12>>2]);v=ea(r+ea(g[q+(l*48|0)+12>>2]));r=ea(s+ea(g[q+(m*48|0)>>2]));s=ea(t+ea(g[q+(m*48|0)+4>>2]));t=ea(u+ea(g[q+(m*48|0)+8>>2]));u=ea(v+ea(g[q+(m*48|0)+12>>2]));v=ea(r+ea(g[q+(n*48|0)>>2]));r=ea(s+ea(g[q+(n*48|0)+4>>2]));s=ea(t+ea(g[q+(n*48|0)+8>>2]));t=ea(r*ea(.25));r=ea(s*ea(.25));s=ea(ea(u+ea(g[q+(n*48|0)+12>>2]))*ea(.25));g[a>>2]=ea(v*ea(.25));g[k>>2]=t;g[j>>2]=r;g[h>>2]=s;i=f;return}n=d+4|0;q=c[b+136>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+156>>2]|0;s=ea(ea(g[m+(q*48|0)>>2])+ea(g[m+(n*48|0)>>2]));r=ea(ea(g[m+(q*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));t=ea(ea(g[m+(q*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]));v=ea(ea(g[m+(q*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]));n=c[b+160>>2]|0;u=ea(s+ea(g[m+(n*48|0)>>2]));s=ea(ea(r+ea(g[m+(n*48|0)+4>>2]))*ea(.333333343));r=ea(ea(t+ea(g[m+(n*48|0)+8>>2]))*ea(.333333343));t=ea(ea(v+ea(g[m+(n*48|0)+12>>2]))*ea(.333333343));g[a>>2]=ea(u*ea(.333333343));g[k>>2]=s;g[j>>2]=r;g[h>>2]=t;i=f;return}case 9:{n=d+4|0;m=c[b+140>>2]|0;q=(c[n>>2]|0)+n|0;n=c[b+144>>2]|0;t=ea(ea(g[q+(m*48|0)>>2])+ea(g[q+(n*48|0)>>2]));r=ea(ea(g[q+(m*48|0)+4>>2])+ea(g[q+(n*48|0)+4>>2]));s=ea(r*ea(.5));r=ea(ea(ea(g[q+(m*48|0)+8>>2])+ea(g[q+(n*48|0)+8>>2]))*ea(.5));u=ea(ea(ea(g[q+(m*48|0)+12>>2])+ea(g[q+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(t*ea(.5));g[k>>2]=s;g[j>>2]=r;g[h>>2]=u;i=f;return}case 7:{n=c[b+136>>2]|0;q=d+4|0;m=c[b+132>>2]|0;l=(c[q>>2]|0)+q|0;u=ea(g[l+(m*48|0)>>2]);r=ea(g[l+(m*48|0)+4>>2]);s=ea(g[l+(m*48|0)+8>>2]);if((n|0)>-1){t=ea(u+ea(g[l+(n*48|0)>>2]));v=ea(r+ea(g[l+(n*48|0)+4>>2]));w=ea(s+ea(g[l+(n*48|0)+8>>2]));x=ea(g[l+(m*48|0)+12>>2]);y=ea(v*ea(.5));v=ea(w*ea(.5));w=ea(ea(x+ea(g[l+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(t*ea(.5));g[k>>2]=y;g[j>>2]=v;g[h>>2]=w;i=f;return}else{w=ea(u*ea(.100000001));u=ea(r*ea(.100000001));r=ea(s*ea(.100000001));s=ea(ea(g[l+(m*48|0)+12>>2])*ea(.100000001));m=c[b+156>>2]|0;n=c[b+160>>2]|0;v=ea(g[l+(m*48|0)>>2]);y=ea(v+ea(g[l+(n*48|0)>>2]));v=ea(g[l+(m*48|0)+4>>2]);t=ea(v+ea(g[l+(n*48|0)+4>>2]));v=ea(g[l+(m*48|0)+8>>2]);x=ea(v+ea(g[l+(n*48|0)+8>>2]));v=ea(g[l+(m*48|0)+12>>2]);z=ea(u+ea(t*ea(.449999988)));t=ea(r+ea(x*ea(.449999988)));x=ea(s+ea(ea(v+ea(g[l+(n*48|0)+12>>2]))*ea(.449999988)));g[a>>2]=ea(w+ea(y*ea(.449999988)));g[k>>2]=z;g[j>>2]=t;g[h>>2]=x;i=f;return}break}case 11:{n=d+4|0;l=c[b+148>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+156>>2]|0;x=ea(ea(g[m+(l*48|0)>>2])+ea(g[m+(n*48|0)>>2]));t=ea(ea(g[m+(l*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));z=ea(t*ea(.5));t=ea(ea(ea(g[m+(l*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]))*ea(.5));y=ea(ea(ea(g[m+(l*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(x*ea(.5));g[k>>2]=z;g[j>>2]=t;g[h>>2]=y;i=f;return}case 1:{n=d+4|0;m=c[b+108>>2]|0;l=(c[n>>2]|0)+n|0;n=c[b+116>>2]|0;y=ea(ea(g[l+(m*48|0)>>2])+ea(g[l+(n*48|0)>>2]));t=ea(ea(g[l+(m*48|0)+4>>2])+ea(g[l+(n*48|0)+4>>2]));z=ea(t*ea(.5));t=ea(ea(ea(g[l+(m*48|0)+8>>2])+ea(g[l+(n*48|0)+8>>2]))*ea(.5));x=ea(ea(ea(g[l+(m*48|0)+12>>2])+ea(g[l+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(y*ea(.5));g[k>>2]=z;g[j>>2]=t;g[h>>2]=x;i=f;return}case 3:{n=d+4|0;l=c[b+116>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+124>>2]|0;x=ea(ea(g[m+(l*48|0)>>2])+ea(g[m+(n*48|0)>>2]));t=ea(ea(g[m+(l*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));z=ea(t*ea(.5));t=ea(ea(ea(g[m+(l*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]))*ea(.5));y=ea(ea(ea(g[m+(l*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(x*ea(.5));g[k>>2]=z;g[j>>2]=t;g[h>>2]=y;i=f;return}case 0:{n=d+4|0;m=c[b+108>>2]|0;l=(c[n>>2]|0)+n|0;n=c[b+112>>2]|0;y=ea(ea(g[l+(m*48|0)>>2])+ea(g[l+(n*48|0)>>2]));t=ea(ea(g[l+(m*48|0)+4>>2])+ea(g[l+(n*48|0)+4>>2]));z=ea(ea(g[l+(m*48|0)+8>>2])+ea(g[l+(n*48|0)+8>>2]));x=ea(ea(g[l+(m*48|0)+12>>2])+ea(g[l+(n*48|0)+12>>2]));n=c[b+132>>2]|0;w=ea(y+ea(g[l+(n*48|0)>>2]));y=ea(ea(t+ea(g[l+(n*48|0)+4>>2]))*ea(.333333343));t=ea(ea(z+ea(g[l+(n*48|0)+8>>2]))*ea(.333333343));z=ea(ea(x+ea(g[l+(n*48|0)+12>>2]))*ea(.333333343));g[a>>2]=ea(w*ea(.333333343));g[k>>2]=y;g[j>>2]=t;g[h>>2]=z;i=f;return}case 12:{n=d+4|0;l=c[b+152>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+160>>2]|0;z=ea(ea(g[m+(l*48|0)>>2])+ea(g[m+(n*48|0)>>2]));t=ea(ea(g[m+(l*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[m+(l*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]))*ea(.5));w=ea(ea(ea(g[m+(l*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(z*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=w;i=f;return}case 14:{n=d+4|0;m=c[b+160>>2]|0;l=(c[n>>2]|0)+n|0;n=c[b+168>>2]|0;w=ea(ea(g[l+(m*48|0)>>2])+ea(g[l+(n*48|0)>>2]));t=ea(ea(g[l+(m*48|0)+4>>2])+ea(g[l+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[l+(m*48|0)+8>>2])+ea(g[l+(n*48|0)+8>>2]))*ea(.5));z=ea(ea(ea(g[l+(m*48|0)+12>>2])+ea(g[l+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(w*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=z;i=f;return}case 16:{n=d+4|0;l=c[b+168>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+176>>2]|0;z=ea(ea(g[m+(l*48|0)>>2])+ea(g[m+(n*48|0)>>2]));t=ea(ea(g[m+(l*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[m+(l*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]))*ea(.5));w=ea(ea(ea(g[m+(l*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(z*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=w;i=f;return}case 4:{n=d+4|0;m=c[b+120>>2]|0;l=(c[n>>2]|0)+n|0;n=c[b+128>>2]|0;w=ea(ea(g[l+(m*48|0)>>2])+ea(g[l+(n*48|0)>>2]));t=ea(ea(g[l+(m*48|0)+4>>2])+ea(g[l+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[l+(m*48|0)+8>>2])+ea(g[l+(n*48|0)+8>>2]))*ea(.5));z=ea(ea(ea(g[l+(m*48|0)+12>>2])+ea(g[l+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(w*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=z;i=f;return}case 15:{n=d+4|0;l=c[b+156>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+172>>2]|0;z=ea(ea(g[m+(l*48|0)>>2])+ea(g[m+(n*48|0)>>2]));t=ea(ea(g[m+(l*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[m+(l*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]))*ea(.5));w=ea(ea(ea(g[m+(l*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(z*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=w;i=f;return}case 2:{n=d+4|0;m=c[b+112>>2]|0;l=(c[n>>2]|0)+n|0;n=c[b+120>>2]|0;w=ea(ea(g[l+(m*48|0)>>2])+ea(g[l+(n*48|0)>>2]));t=ea(ea(g[l+(m*48|0)+4>>2])+ea(g[l+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[l+(m*48|0)+8>>2])+ea(g[l+(n*48|0)+8>>2]))*ea(.5));z=ea(ea(ea(g[l+(m*48|0)+12>>2])+ea(g[l+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(w*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=z;i=f;return}case 13:{n=d+4|0;l=c[b+156>>2]|0;m=(c[n>>2]|0)+n|0;n=c[b+164>>2]|0;z=ea(ea(g[m+(l*48|0)>>2])+ea(g[m+(n*48|0)>>2]));t=ea(ea(g[m+(l*48|0)+4>>2])+ea(g[m+(n*48|0)+4>>2]));y=ea(t*ea(.5));t=ea(ea(ea(g[m+(l*48|0)+8>>2])+ea(g[m+(n*48|0)+8>>2]))*ea(.5));w=ea(ea(ea(g[m+(l*48|0)+12>>2])+ea(g[m+(n*48|0)+12>>2]))*ea(.5));g[a>>2]=ea(z*ea(.5));g[k>>2]=y;g[j>>2]=t;g[h>>2]=w;i=f;return}default:{n=d+4|0;m=c[b+(e<<2)+104>>2]|0;l=(c[n>>2]|0)+n|0;w=ea(g[l+(m*48|0)>>2]);t=ea(g[l+(m*48|0)+4>>2]);y=ea(g[l+(m*48|0)+8>>2]);z=ea(g[l+(m*48|0)+12>>2]);g[a>>2]=w;g[k>>2]=t;g[j>>2]=y;g[h>>2]=z;i=f;return}}while(0)}function V_d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im;e=i;f=c[b+108>>2]|0;h=c[b+112>>2]|0;j=c[b+156>>2]|0;k=c[b+160>>2]|0;l=d+4|0;d=(c[l>>2]|0)+l|0;m=ea(g[d+(f*48|0)>>2]);n=ea(g[d+(h*48|0)>>2]);o=ea(m+n);p=ea(g[d+(f*48|0)+4>>2]);q=ea(g[d+(h*48|0)+4>>2]);r=ea(p+q);s=ea(g[d+(f*48|0)+8>>2]);t=ea(g[d+(h*48|0)+8>>2]);u=ea(s+t);v=ea(g[d+(f*48|0)+12>>2]);w=ea(g[d+(h*48|0)+12>>2]);x=ea(o*ea(.5));o=ea(r*ea(.5));r=ea(u*ea(.5));u=ea(ea(v+w)*ea(.5));y=ea(g[d+(j*48|0)>>2]);z=ea(g[d+(k*48|0)>>2]);A=ea(y+z);B=ea(g[d+(j*48|0)+4>>2]);C=ea(g[d+(k*48|0)+4>>2]);D=ea(B+C);E=ea(g[d+(j*48|0)+8>>2]);F=ea(g[d+(k*48|0)+8>>2]);G=ea(E+F);H=ea(g[d+(j*48|0)+12>>2]);I=ea(g[d+(k*48|0)+12>>2]);J=ea(ea(A*ea(.5))-x);x=ea(ea(D*ea(.5))-o);o=ea(ea(G*ea(.5))-r);r=ea(ea(ea(H+I)*ea(.5))-u);u=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(x*x))+ea(ea(o*o)+ea(r*r))))));r=ea(J*u);J=ea(x*u);x=ea(o*u);u=ea(ea(n-m)+ea(z-y));y=ea(ea(q-p)+ea(C-B));B=ea(ea(t-s)+ea(F-E));E=ea(ea(w-v)+ea(I-H));H=ea(ea(1.0)/ea(T(ea(ea(ea(u*u)+ea(y*y))+ea(ea(B*B)+ea(E*E))))));E=ea(u*H);u=ea(y*H);y=ea(B*H);H=ea(ea(J*E)-ea(r*u));B=ea(ea(x*u)-ea(J*y));u=ea(ea(r*y)-ea(x*E));E=ea(ea(r*u)-ea(J*B));y=ea(ea(J*H)-ea(x*u));I=ea(ea(x*B)-ea(r*H));do if(!(y>=ea(0.0))){v=ea(J-H);if(!(v>=ea(0.0))){K=ea(B+E);L=ea(x+u);M=ea(ea(ea(1.0)-y)-v);N=ea(I-r);break}else{K=ea(r+I);L=ea(v+ea(ea(1.0)-y));M=ea(x+u);N=ea(B-E);break}}else{v=ea(J+H);if(!(v>=ea(0.0))){K=ea(ea(y+ea(1.0))-v);L=ea(r+I);M=ea(B+E);N=ea(x-u);break}else{K=ea(x-u);L=ea(B-E);M=ea(I-r);N=ea(v+ea(y+ea(1.0)));break}}while(0);y=ea(ea(1.0)/ea(T(ea(ea(ea(N*N)+ea(M*M))+ea(ea(L*L)+ea(K*K))))));r=ea(K*y);K=ea(L*y);L=ea(M*y);M=ea(N*y);y=ea(-ea(g[b+16>>2]));N=ea(-ea(g[b+20>>2]));I=ea(-ea(g[b+24>>2]));E=ea(g[b+28>>2]);B=ea(ea(ea(ea(K*y)-ea(M*I))-ea(L*E))-ea(r*N));u=ea(ea(ea(ea(M*E)-ea(r*y))-ea(L*I))-ea(K*N));x=ea(ea(ea(ea(L*N)-ea(K*I))-ea(M*y))-ea(r*E));H=ea(ea(ea(ea(r*I)-ea(L*y))-ea(M*N))-ea(K*E));E=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(H*H))+ea(ea(B*B)+ea(u*u))))));K=ea(-ea(E*H));H=ea(-ea(E*B));B=ea(E*u);g[a>>2]=ea(-ea(E*x));g[a+4>>2]=K;g[a+8>>2]=H;g[a+12>>2]=B;i=e;return}function W_d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+64|0;e=d;g[e>>2]=ea(.5);g[e+4>>2]=ea(-.5);g[e+8>>2]=ea(.5);g[e+12>>2]=ea(.5);g[e+16>>2]=ea(.5);g[e+20>>2]=ea(-.5);g[e+24>>2]=ea(.5);g[e+28>>2]=ea(.5);g[e+32>>2]=ea(.707107007);g[e+36>>2]=ea(0.0);g[e+40>>2]=ea(.707107007);g[e+44>>2]=ea(0.0);g[e+48>>2]=ea(0.0);g[e+52>>2]=ea(.707107007);g[e+56>>2]=ea(0.0);g[e+60>>2]=ea(.707107007);f=e+(b<<4)|0;c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function X_d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=d+4|0;d=(c[f>>2]|0)+f+((c[b+(c[718544+(e<<4)>>2]<<2)+104>>2]|0)*48|0)|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function Y_d(a){a=a|0;var b=0,d=0,e=0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[a+28>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);d=a+80|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[a+108>>2]=ea(1.0);g[a+112>>2]=ea(1.0);g[a+116>>2]=ea(1.0);g[a+120>>2]=ea(1.0);g[a+124>>2]=ea(1.0);d=a+156|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[a+184>>2]=ea(1.0);g[a+188>>2]=ea(1.0);g[a+192>>2]=ea(1.0);g[a+196>>2]=ea(1.0);g[a+200>>2]=ea(1.0);d=a+232|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[a+260>>2]=ea(1.0);g[a+264>>2]=ea(1.0);g[a+268>>2]=ea(1.0);g[a+272>>2]=ea(1.0);g[a+276>>2]=ea(1.0);d=a+308|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;g[a+336>>2]=ea(1.0);g[a+340>>2]=ea(1.0);g[a+344>>2]=ea(1.0);g[a+348>>2]=ea(1.0);g[a+352>>2]=ea(1.0);PEi(a+672|0,0,208)|0;d=a+576|0;e=a+432|0;a=e+80|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));e=d+0|0;a=e+80|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));i=b;return}function Z_d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=Im,h=Im,j=Im,k=Im;d=i;if(c)e=0;else{f=ea(g[b>>2]);h=ea(g[b+4>>2]);j=ea(g[b+8>>2]);k=ea(g[b+12>>2]);g[a>>2]=f;g[a+4>>2]=h;g[a+8>>2]=j;g[a+12>>2]=k;k=ea(g[b+16>>2]);j=ea(g[b+20>>2]);h=ea(g[b+24>>2]);f=ea(g[b+28>>2]);g[a+16>>2]=k;g[a+20>>2]=j;g[a+24>>2]=h;g[a+28>>2]=f;f=ea(g[b+32>>2]);h=ea(g[b+36>>2]);j=ea(g[b+40>>2]);k=ea(g[b+44>>2]);g[a+32>>2]=f;g[a+36>>2]=h;g[a+40>>2]=j;g[a+44>>2]=k;c=0;do{k=ea(g[b+(c*76|0)+80>>2]);j=ea(g[b+(c*76|0)+84>>2]);h=ea(g[b+(c*76|0)+88>>2]);f=ea(g[b+(c*76|0)+92>>2]);g[a+(c*76|0)+80>>2]=k;g[a+(c*76|0)+84>>2]=j;g[a+(c*76|0)+88>>2]=h;g[a+(c*76|0)+92>>2]=f;f=ea(g[b+(c*76|0)+96>>2]);h=ea(g[b+(c*76|0)+100>>2]);j=ea(g[b+(c*76|0)+104>>2]);k=ea(g[b+(c*76|0)+108>>2]);g[a+(c*76|0)+96>>2]=f;g[a+(c*76|0)+100>>2]=h;g[a+(c*76|0)+104>>2]=j;g[a+(c*76|0)+108>>2]=k;k=ea(g[b+(c*76|0)+112>>2]);j=ea(g[b+(c*76|0)+116>>2]);h=ea(g[b+(c*76|0)+120>>2]);f=ea(g[b+(c*76|0)+124>>2]);g[a+(c*76|0)+112>>2]=k;g[a+(c*76|0)+116>>2]=j;g[a+(c*76|0)+120>>2]=h;g[a+(c*76|0)+124>>2]=f;c=c+1|0}while((c|0)!=4);e=0}do{g[a+(e<<2)+672>>2]=ea(g[b+(e<<2)+672>>2]);e=e+1|0}while((e|0)!=52);K_d(b+384|0,a+384|0);K_d(b+528|0,a+528|0);i=d;return}function __d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im;e=i;i=i+16|0;f=e;c[f>>2]=-1;c[f+4>>2]=134217727;h=134217727;j=1;while(1){if((c[d+(j<<2)>>2]|0)!=(h|0)){k=0;break}l=j+-1|0;if((j|0)<=0){m=5;break}h=c[f+(l<<2)>>2]|0;j=l}if((m|0)==5){Z_d(a,b,0);i=e;return}do{m=k;k=k+1|0;if(!(c[d+(k>>>5<<2)>>2]&1<<(k&31)))g[a+(m<<2)+672>>2]=ea(0.0);else g[a+(m<<2)+672>>2]=ea(g[b+(m<<2)+672>>2])}while((k|0)!=52);k=d+4|0;m=c[k>>2]|0;if(!(m&33554432)){n=a+432|0;o=n+80|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));p=c[k>>2]|0}else{g[a+432>>2]=ea(g[b+432>>2]);g[a+436>>2]=ea(g[b+436>>2]);g[a+440>>2]=ea(g[b+440>>2]);g[a+444>>2]=ea(g[b+444>>2]);g[a+448>>2]=ea(g[b+448>>2]);g[a+452>>2]=ea(g[b+452>>2]);g[a+456>>2]=ea(g[b+456>>2]);g[a+460>>2]=ea(g[b+460>>2]);g[a+464>>2]=ea(g[b+464>>2]);g[a+468>>2]=ea(g[b+468>>2]);g[a+472>>2]=ea(g[b+472>>2]);g[a+476>>2]=ea(g[b+476>>2]);g[a+480>>2]=ea(g[b+480>>2]);g[a+484>>2]=ea(g[b+484>>2]);g[a+488>>2]=ea(g[b+488>>2]);g[a+492>>2]=ea(g[b+492>>2]);g[a+496>>2]=ea(g[b+496>>2]);g[a+500>>2]=ea(g[b+500>>2]);g[a+504>>2]=ea(g[b+504>>2]);g[a+508>>2]=ea(g[b+508>>2]);p=m}if(!(p&67108864)){n=a+576|0;o=n+80|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));q=0}else{g[a+576>>2]=ea(g[b+576>>2]);g[a+580>>2]=ea(g[b+580>>2]);g[a+584>>2]=ea(g[b+584>>2]);g[a+588>>2]=ea(g[b+588>>2]);g[a+592>>2]=ea(g[b+592>>2]);g[a+596>>2]=ea(g[b+596>>2]);g[a+600>>2]=ea(g[b+600>>2]);g[a+604>>2]=ea(g[b+604>>2]);g[a+608>>2]=ea(g[b+608>>2]);g[a+612>>2]=ea(g[b+612>>2]);g[a+616>>2]=ea(g[b+616>>2]);g[a+620>>2]=ea(g[b+620>>2]);g[a+624>>2]=ea(g[b+624>>2]);g[a+628>>2]=ea(g[b+628>>2]);g[a+632>>2]=ea(g[b+632>>2]);g[a+636>>2]=ea(g[b+636>>2]);g[a+640>>2]=ea(g[b+640>>2]);g[a+644>>2]=ea(g[b+644>>2]);g[a+648>>2]=ea(g[b+648>>2]);g[a+652>>2]=ea(g[b+652>>2]);q=0}do{n=q+53|0;if(!(c[d+(n>>>5<<2)>>2]&1<<(n&31))){n=a+(q*76|0)+80|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+24>>2]=0;g[a+(q*76|0)+108>>2]=ea(1.0);g[a+(q*76|0)+112>>2]=ea(1.0);g[a+(q*76|0)+116>>2]=ea(1.0);g[a+(q*76|0)+120>>2]=ea(1.0);g[a+(q*76|0)+124>>2]=ea(1.0)}else{r=ea(g[b+(q*76|0)+80>>2]);s=ea(g[b+(q*76|0)+84>>2]);t=ea(g[b+(q*76|0)+88>>2]);u=ea(g[b+(q*76|0)+92>>2]);g[a+(q*76|0)+80>>2]=r;g[a+(q*76|0)+84>>2]=s;g[a+(q*76|0)+88>>2]=t;g[a+(q*76|0)+92>>2]=u;u=ea(g[b+(q*76|0)+96>>2]);t=ea(g[b+(q*76|0)+100>>2]);s=ea(g[b+(q*76|0)+104>>2]);r=ea(g[b+(q*76|0)+108>>2]);g[a+(q*76|0)+96>>2]=u;g[a+(q*76|0)+100>>2]=t;g[a+(q*76|0)+104>>2]=s;g[a+(q*76|0)+108>>2]=r;r=ea(g[b+(q*76|0)+112>>2]);s=ea(g[b+(q*76|0)+116>>2]);t=ea(g[b+(q*76|0)+120>>2]);u=ea(g[b+(q*76|0)+124>>2]);g[a+(q*76|0)+112>>2]=r;g[a+(q*76|0)+116>>2]=s;g[a+(q*76|0)+120>>2]=t;g[a+(q*76|0)+124>>2]=u}q=q+1|0}while((q|0)!=4);if(!(c[d>>2]&1)){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;g[a+28>>2]=ea(1.0);g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);i=e;return}else{u=ea(g[b>>2]);t=ea(g[b+4>>2]);s=ea(g[b+8>>2]);r=ea(g[b+12>>2]);g[a>>2]=u;g[a+4>>2]=t;g[a+8>>2]=s;g[a+12>>2]=r;r=ea(g[b+16>>2]);s=ea(g[b+20>>2]);t=ea(g[b+24>>2]);u=ea(g[b+28>>2]);g[a+16>>2]=r;g[a+20>>2]=s;g[a+24>>2]=t;g[a+28>>2]=u;u=ea(g[b+32>>2]);t=ea(g[b+36>>2]);s=ea(g[b+40>>2]);r=ea(g[b+44>>2]);g[a+32>>2]=u;g[a+36>>2]=t;g[a+40>>2]=s;g[a+44>>2]=r;i=e;return}}function $_d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=0;d=i;i=i+96|0;e=d+48|0;f=d;h=e+4|0;j=e+8|0;k=e+12|0;l=e+16|0;m=e+20|0;n=e+24|0;o=e+28|0;p=e+32|0;q=e+36|0;r=e+40|0;s=e+44|0;t=0;do{n$d(e,b+(t*76|0)+80|0,c+(t*76|0)+80|0);u=ea(g[e>>2]);v=ea(g[h>>2]);w=ea(g[j>>2]);x=ea(g[k>>2]);g[a+(t*76|0)+80>>2]=u;g[a+(t*76|0)+84>>2]=v;g[a+(t*76|0)+88>>2]=w;g[a+(t*76|0)+92>>2]=x;x=ea(g[l>>2]);w=ea(g[m>>2]);v=ea(g[n>>2]);u=ea(g[o>>2]);g[a+(t*76|0)+96>>2]=x;g[a+(t*76|0)+100>>2]=w;g[a+(t*76|0)+104>>2]=v;g[a+(t*76|0)+108>>2]=u;u=ea(g[p>>2]);v=ea(g[q>>2]);w=ea(g[r>>2]);x=ea(g[s>>2]);g[a+(t*76|0)+112>>2]=u;g[a+(t*76|0)+116>>2]=v;g[a+(t*76|0)+120>>2]=w;g[a+(t*76|0)+124>>2]=x;t=t+1|0}while((t|0)!=4);y=0;do{x=ea(g[b+(y<<2)+672>>2]);g[a+(y<<2)+672>>2]=ea(x+ea(g[c+(y<<2)+672>>2]));y=y+1|0}while((y|0)!=52);z=0;do{x=ea(g[b+(z<<2)+432>>2]);g[a+(z<<2)+432>>2]=ea(x+ea(g[c+(z<<2)+432>>2]));x=ea(g[b+(z<<2)+576>>2]);g[a+(z<<2)+576>>2]=ea(x+ea(g[c+(z<<2)+576>>2]));z=z+1|0}while((z|0)!=20);n$d(f,b,c);x=ea(g[f>>2]);w=ea(g[f+4>>2]);v=ea(g[f+8>>2]);u=ea(g[f+12>>2]);g[a>>2]=x;g[a+4>>2]=w;g[a+8>>2]=v;g[a+12>>2]=u;u=ea(g[f+16>>2]);v=ea(g[f+20>>2]);w=ea(g[f+24>>2]);x=ea(g[f+28>>2]);g[a+16>>2]=u;g[a+20>>2]=v;g[a+24>>2]=w;g[a+28>>2]=x;x=ea(g[f+32>>2]);w=ea(g[f+36>>2]);v=ea(g[f+40>>2]);u=ea(g[f+44>>2]);g[a+32>>2]=x;g[a+36>>2]=w;g[a+40>>2]=v;g[a+44>>2]=u;i=d;return}function a$d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=0;d=i;i=i+96|0;e=d+48|0;f=d;h=e+4|0;j=e+8|0;k=e+12|0;l=e+16|0;m=e+20|0;n=e+24|0;o=e+28|0;p=e+32|0;q=e+36|0;r=e+40|0;s=e+44|0;t=0;do{o$d(e,c+(t*76|0)+80|0,b+(t*76|0)+80|0);u=ea(g[e>>2]);v=ea(g[h>>2]);w=ea(g[j>>2]);x=ea(g[k>>2]);g[a+(t*76|0)+80>>2]=u;g[a+(t*76|0)+84>>2]=v;g[a+(t*76|0)+88>>2]=w;g[a+(t*76|0)+92>>2]=x;x=ea(g[l>>2]);w=ea(g[m>>2]);v=ea(g[n>>2]);u=ea(g[o>>2]);g[a+(t*76|0)+96>>2]=x;g[a+(t*76|0)+100>>2]=w;g[a+(t*76|0)+104>>2]=v;g[a+(t*76|0)+108>>2]=u;u=ea(g[p>>2]);v=ea(g[q>>2]);w=ea(g[r>>2]);x=ea(g[s>>2]);g[a+(t*76|0)+112>>2]=u;g[a+(t*76|0)+116>>2]=v;g[a+(t*76|0)+120>>2]=w;g[a+(t*76|0)+124>>2]=x;t=t+1|0}while((t|0)!=4);y=0;do{x=ea(g[b+(y<<2)+672>>2]);g[a+(y<<2)+672>>2]=ea(x-ea(g[c+(y<<2)+672>>2]));y=y+1|0}while((y|0)!=52);z=0;do{x=ea(g[b+(z<<2)+432>>2]);g[a+(z<<2)+432>>2]=ea(x-ea(g[c+(z<<2)+432>>2]));x=ea(g[b+(z<<2)+576>>2]);g[a+(z<<2)+576>>2]=ea(x-ea(g[c+(z<<2)+576>>2]));z=z+1|0}while((z|0)!=20);o$d(f,c,b);x=ea(g[f>>2]);w=ea(g[f+4>>2]);v=ea(g[f+8>>2]);u=ea(g[f+12>>2]);g[a>>2]=x;g[a+4>>2]=w;g[a+8>>2]=v;g[a+12>>2]=u;u=ea(g[f+16>>2]);v=ea(g[f+20>>2]);w=ea(g[f+24>>2]);x=ea(g[f+28>>2]);g[a+16>>2]=u;g[a+20>>2]=v;g[a+24>>2]=w;g[a+28>>2]=x;x=ea(g[f+32>>2]);w=ea(g[f+36>>2]);v=ea(g[f+40>>2]);u=ea(g[f+44>>2]);g[a+32>>2]=x;g[a+36>>2]=w;g[a+40>>2]=v;g[a+44>>2]=u;i=d;return}function b$d(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0,e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=0,s=0;d=i;e=0;do{f=ea(ea(g[b+(e*76|0)+80>>2])*c);h=ea(ea(g[b+(e*76|0)+84>>2])*c);j=ea(ea(g[b+(e*76|0)+88>>2])*c);k=ea(ea(g[b+(e*76|0)+92>>2])*c);l=ea(ea(g[b+(e*76|0)+96>>2])*c);m=ea(ea(g[b+(e*76|0)+100>>2])*c);n=ea(ea(g[b+(e*76|0)+104>>2])*c);o=ea(g[b+(e*76|0)+108>>2]);p=ea(ea(1.0)/ea(T(ea(ea(ea(l*l)+ea(m*m))+ea(ea(n*n)+ea(o*o))))));q=ea(l*p);l=ea(m*p);m=ea(n*p);n=ea(o*p);g[a+(e*76|0)+80>>2]=f;g[a+(e*76|0)+84>>2]=h;g[a+(e*76|0)+88>>2]=j;g[a+(e*76|0)+92>>2]=k;g[a+(e*76|0)+96>>2]=q;g[a+(e*76|0)+100>>2]=l;g[a+(e*76|0)+104>>2]=m;g[a+(e*76|0)+108>>2]=n;g[a+(e*76|0)+112>>2]=ea(1.0);g[a+(e*76|0)+116>>2]=ea(1.0);g[a+(e*76|0)+120>>2]=ea(1.0);g[a+(e*76|0)+124>>2]=ea(1.0);e=e+1|0}while((e|0)!=4);r=0;do{g[a+(r<<2)+672>>2]=ea(ea(g[b+(r<<2)+672>>2])*c);r=r+1|0}while((r|0)!=52);s=0;do{g[a+(s<<2)+432>>2]=ea(ea(g[b+(s<<2)+432>>2])*c);g[a+(s<<2)+576>>2]=ea(ea(g[b+(s<<2)+576>>2])*c);s=s+1|0}while((s|0)!=20);n=ea(ea(g[b>>2])*c);m=ea(ea(g[b+4>>2])*c);l=ea(ea(g[b+8>>2])*c);q=ea(ea(g[b+12>>2])*c);k=ea(ea(g[b+16>>2])*c);j=ea(ea(g[b+20>>2])*c);h=ea(ea(g[b+24>>2])*c);c=ea(g[b+28>>2]);f=ea(ea(1.0)/ea(T(ea(ea(ea(k*k)+ea(j*j))+ea(ea(h*h)+ea(c*c))))));p=ea(k*f);k=ea(j*f);j=ea(h*f);h=ea(c*f);g[a>>2]=n;g[a+4>>2]=m;g[a+8>>2]=l;g[a+12>>2]=q;g[a+16>>2]=p;g[a+20>>2]=k;g[a+24>>2]=j;g[a+28>>2]=h;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);i=d;return}function c$d(a,b){a=a|0;b=b|0;var c=0,d=Im,e=0,f=Im,h=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=0,J=Im,K=0,L=0,M=0,N=Im,O=0,P=Im,Q=0,R=Im,S=0,U=Im,V=0,W=Im,X=0,Y=Im,Z=0,_=0,$=0,aa=0;b=i;c=a+676|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+680|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+688|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+692|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+700|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+704|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+712|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+716|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+724|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+732|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+740|0;g[c>>2]=ea(-ea(g[c>>2]));c=a+808|0;d=ea(g[c>>2]);e=a+844|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+812|0;d=ea(g[e>>2]);c=a+848|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+816|0;d=ea(g[c>>2]);e=a+852|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+820|0;d=ea(g[e>>2]);c=a+856|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+824|0;d=ea(g[c>>2]);e=a+860|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+828|0;d=ea(g[e>>2]);c=a+864|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+832|0;d=ea(g[c>>2]);e=a+868|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+836|0;d=ea(g[e>>2]);c=a+872|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+840|0;d=ea(g[c>>2]);e=a+876|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+744|0;d=ea(g[e>>2]);c=a+776|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+748|0;d=ea(g[c>>2]);e=a+780|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+752|0;d=ea(g[e>>2]);c=a+784|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+756|0;d=ea(g[c>>2]);e=a+788|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+760|0;d=ea(g[e>>2]);c=a+792|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+764|0;d=ea(g[c>>2]);e=a+796|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+768|0;d=ea(g[e>>2]);c=a+800|0;g[e>>2]=ea(g[c>>2]);g[c>>2]=d;c=a+772|0;d=ea(g[c>>2]);e=a+804|0;g[c>>2]=ea(g[e>>2]);g[e>>2]=d;e=a+80|0;d=ea(g[e>>2]);c=a+84|0;f=ea(g[c>>2]);h=a+88|0;j=ea(g[h>>2]);k=a+92|0;l=ea(g[k>>2]);m=a+96|0;n=ea(g[m>>2]);o=a+100|0;p=ea(g[o>>2]);q=a+104|0;r=ea(g[q>>2]);s=a+108|0;t=ea(g[s>>2]);u=a+112|0;v=ea(g[u>>2]);w=a+116|0;x=ea(g[w>>2]);y=a+120|0;z=ea(g[y>>2]);A=a+124|0;B=ea(g[A>>2]);C=a+156|0;D=ea(g[C>>2]);E=a+160|0;F=ea(g[E>>2]);G=a+164|0;H=ea(g[G>>2]);I=a+168|0;J=ea(g[I>>2]);g[e>>2]=D;g[c>>2]=F;g[h>>2]=H;g[k>>2]=J;k=a+172|0;J=ea(g[k>>2]);h=a+176|0;H=ea(g[h>>2]);c=a+180|0;F=ea(g[c>>2]);e=a+184|0;D=ea(g[e>>2]);g[m>>2]=J;g[o>>2]=H;g[q>>2]=F;g[s>>2]=D;K=a+188|0;H=ea(g[K>>2]);L=a+192|0;J=ea(g[L>>2]);M=a+196|0;N=ea(g[M>>2]);O=a+200|0;P=ea(g[O>>2]);g[u>>2]=H;g[w>>2]=J;g[y>>2]=N;g[A>>2]=P;g[C>>2]=d;g[E>>2]=f;g[G>>2]=j;g[I>>2]=l;g[k>>2]=n;g[h>>2]=p;g[c>>2]=r;g[e>>2]=t;g[K>>2]=v;g[L>>2]=x;g[M>>2]=z;g[O>>2]=B;O=a+232|0;B=ea(g[O>>2]);M=a+236|0;z=ea(g[M>>2]);L=a+240|0;x=ea(g[L>>2]);K=a+244|0;v=ea(g[K>>2]);I=a+248|0;t=ea(g[I>>2]);G=a+252|0;r=ea(g[G>>2]);E=a+256|0;p=ea(g[E>>2]);C=a+260|0;n=ea(g[C>>2]);A=a+264|0;l=ea(g[A>>2]);y=a+268|0;j=ea(g[y>>2]);w=a+272|0;f=ea(g[w>>2]);u=a+276|0;d=ea(g[u>>2]);Q=a+308|0;R=ea(g[Q>>2]);S=a+312|0;U=ea(g[S>>2]);V=a+316|0;W=ea(g[V>>2]);X=a+320|0;Y=ea(g[X>>2]);g[O>>2]=R;g[M>>2]=U;g[L>>2]=W;g[K>>2]=Y;K=a+324|0;Y=ea(g[K>>2]);L=a+328|0;W=ea(g[L>>2]);M=a+332|0;U=ea(g[M>>2]);O=a+336|0;R=ea(g[O>>2]);g[I>>2]=Y;g[G>>2]=W;g[E>>2]=U;g[C>>2]=R;Z=a+340|0;R=ea(g[Z>>2]);_=a+344|0;U=ea(g[_>>2]);$=a+348|0;W=ea(g[$>>2]);aa=a+352|0;Y=ea(g[aa>>2]);g[A>>2]=R;g[y>>2]=U;g[w>>2]=W;g[u>>2]=Y;g[Q>>2]=B;g[S>>2]=z;g[V>>2]=x;g[X>>2]=v;g[K>>2]=t;g[L>>2]=r;g[M>>2]=p;g[O>>2]=n;g[Z>>2]=l;g[_>>2]=j;g[$>>2]=f;g[aa>>2]=d;d=F;F=D;D=H;H=J;J=N;N=P;aa=0;while(1){$=a+(aa*76|0)+80|0;P=ea(g[$>>2]);_=a+(aa*76|0)+100|0;f=ea(-ea(g[_>>2]));j=ea(-d);g[$>>2]=ea(-P);g[_>>2]=f;g[a+(aa*76|0)+104>>2]=j;g[a+(aa*76|0)+108>>2]=F;g[a+(aa*76|0)+112>>2]=D;g[a+(aa*76|0)+116>>2]=H;g[a+(aa*76|0)+120>>2]=J;g[a+(aa*76|0)+124>>2]=N;_=aa+1|0;if((_|0)==4)break;j=ea(g[a+(_*76|0)+104>>2]);f=ea(g[a+(_*76|0)+108>>2]);P=ea(g[a+(_*76|0)+112>>2]);l=ea(g[a+(_*76|0)+116>>2]);n=ea(g[a+(_*76|0)+120>>2]);d=j;F=f;D=P;H=l;J=n;N=ea(g[a+(_*76|0)+124>>2]);aa=_}N=ea(g[o>>2]);J=ea(N*ea(0.0));H=ea(g[s>>2]);D=ea(H*ea(0.0));F=ea(g[q>>2]);d=ea(g[m>>2]);n=ea(d*ea(0.0));l=ea(F*ea(0.0));P=ea(ea(ea(J-D)-l)-d);d=ea(ea(ea(D-n)-l)-N);N=ea(ea(ea(F-J)-D)-n);D=ea(ea(ea(n-l)-H)-J);J=ea(ea(1.0)/ea(T(ea(ea(ea(N*N)+ea(D*D))+ea(ea(P*P)+ea(d*d))))));H=ea(-ea(J*D));D=ea(-ea(P*J));P=ea(J*d);g[m>>2]=ea(-ea(N*J));g[o>>2]=H;g[q>>2]=D;g[s>>2]=P;P=ea(g[h>>2]);D=ea(P*ea(0.0));H=ea(g[e>>2]);J=ea(H*ea(0.0));N=ea(g[c>>2]);d=ea(g[k>>2]);l=ea(d*ea(0.0));n=ea(N*ea(0.0));F=ea(ea(ea(D-J)-n)-d);d=ea(ea(ea(J-l)-n)-P);P=ea(ea(ea(N-D)-J)-l);J=ea(ea(ea(l-n)-H)-D);D=ea(ea(1.0)/ea(T(ea(ea(ea(P*P)+ea(J*J))+ea(ea(F*F)+ea(d*d))))));H=ea(-ea(D*J));J=ea(-ea(F*D));F=ea(D*d);g[k>>2]=ea(-ea(P*D));g[h>>2]=H;g[c>>2]=J;g[e>>2]=F;F=ea(g[G>>2]);J=ea(F*ea(0.0));H=ea(g[C>>2]);D=ea(H*ea(0.0));P=ea(g[E>>2]);d=ea(P*ea(0.0));n=ea(g[I>>2]);l=ea(n*ea(0.0));N=ea(ea(ea(J-H)-d)-l);H=ea(ea(ea(D-l)-P)-J);P=ea(ea(ea(d-F)-D)-l);l=ea(ea(ea(n-d)-D)-J);J=ea(ea(1.0)/ea(T(ea(ea(ea(P*P)+ea(l*l))+ea(ea(N*N)+ea(H*H))))));D=ea(-ea(J*l));l=ea(-ea(N*J));N=ea(J*H);g[I>>2]=ea(-ea(J*P));g[G>>2]=D;g[E>>2]=l;g[C>>2]=N;N=ea(g[L>>2]);l=ea(N*ea(0.0));D=ea(g[O>>2]);P=ea(D*ea(0.0));J=ea(g[M>>2]);H=ea(J*ea(0.0));d=ea(g[K>>2]);n=ea(d*ea(0.0));F=ea(ea(ea(l-D)-H)-n);D=ea(ea(ea(P-n)-J)-l);J=ea(ea(ea(H-N)-P)-n);n=ea(ea(ea(d-H)-P)-l);l=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(n*n))+ea(ea(F*F)+ea(D*D))))));P=ea(-ea(l*n));n=ea(-ea(F*l));F=ea(l*D);g[K>>2]=ea(-ea(l*J));g[L>>2]=P;g[M>>2]=n;g[O>>2]=F;F=ea(g[a>>2]);O=a+20|0;n=ea(g[O>>2]);M=a+24|0;P=ea(-n);n=ea(-ea(g[M>>2]));g[a>>2]=ea(-F);g[O>>2]=P;g[M>>2]=n;M=0;do{O=a+(M<<2)+432|0;n=ea(g[O>>2]);L=a+(M<<2)+576|0;g[O>>2]=ea(g[L>>2]);g[L>>2]=n;M=M+1|0}while((M|0)!=20);i=b;return}function d$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=0,U=Im,V=Im,W=0,X=0,Y=Im,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=0,qa=0,ra=Im,sa=Im;f=i;PEi(a+672|0,0,208)|0;h=a+576|0;j=a+80|0;l=a+100|0;m=a+104|0;n=a+108|0;o=a+112|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;j=a+432|0;p=j+80|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(p|0));j=h+0|0;p=j+80|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(p|0));g[o>>2]=ea(1.0);g[a+116>>2]=ea(1.0);g[a+120>>2]=ea(1.0);g[a+124>>2]=ea(1.0);o=a+156|0;j=a+176|0;p=a+180|0;h=a+184|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[o+28>>2]=0;g[a+188>>2]=ea(1.0);g[a+192>>2]=ea(1.0);g[a+196>>2]=ea(1.0);g[a+200>>2]=ea(1.0);o=a+232|0;q=a+252|0;r=a+256|0;s=a+260|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[o+28>>2]=0;g[a+264>>2]=ea(1.0);g[a+268>>2]=ea(1.0);g[a+272>>2]=ea(1.0);g[a+276>>2]=ea(1.0);o=a+308|0;t=a+328|0;u=a+332|0;v=a+336|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[o+28>>2]=0;g[a+340>>2]=ea(1.0);g[a+344>>2]=ea(1.0);g[a+348>>2]=ea(1.0);g[a+352>>2]=ea(1.0);o=a+4|0;w=a+8|0;x=a+12|0;y=a+16|0;z=a+20|0;A=a+24|0;B=a+28|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);if(!e){C=a+172|0;D=a+248|0;E=a+324|0;F=ea(0.0);G=ea(0.0);H=ea(0.0);I=ea(0.0);J=ea(0.0);K=ea(0.0);L=ea(0.0);M=ea(0.0);N=ea(0.0);O=ea(0.0);P=ea(0.0);Q=ea(0.0);R=ea(0.0)}else{S=0;U=ea(0.0);while(1){V=ea(g[d+(S<<2)>>2]);W=c[b+(S<<2)>>2]|0;X=0;do{Y=ea(V*ea(g[W+(X<<2)+672>>2]));Z=a+(X<<2)+672|0;g[Z>>2]=ea(ea(g[Z>>2])+Y);X=X+1|0}while((X|0)!=52);_=0;do{Y=ea(V*ea(g[W+(_<<2)+432>>2]));X=a+(_<<2)+432|0;g[X>>2]=ea(ea(g[X>>2])+Y);Y=ea(V*ea(g[W+(_<<2)+576>>2]));X=a+(_<<2)+576|0;g[X>>2]=ea(ea(g[X>>2])+Y);_=_+1|0}while((_|0)!=20);$=0;do{Y=ea(V*ea(g[W+($*76|0)+80>>2]));aa=ea(V*ea(g[W+($*76|0)+84>>2]));ba=ea(V*ea(g[W+($*76|0)+88>>2]));ca=ea(V*ea(g[W+($*76|0)+92>>2]));X=a+($*76|0)+80|0;da=ea(Y+ea(g[X>>2]));Z=a+($*76|0)+84|0;Y=ea(aa+ea(g[Z>>2]));fa=a+($*76|0)+88|0;aa=ea(ba+ea(g[fa>>2]));ga=a+($*76|0)+92|0;ba=ea(ca+ea(g[ga>>2]));g[X>>2]=da;g[Z>>2]=Y;g[fa>>2]=aa;g[ga>>2]=ba;ba=ea(g[W+($*76|0)+96>>2]);aa=ea(V*ba);Y=ea(g[W+($*76|0)+100>>2]);da=ea(V*Y);ca=ea(g[W+($*76|0)+104>>2]);ha=ea(V*ca);ia=ea(g[W+($*76|0)+108>>2]);ja=ea(V*ia);ga=a+($*76|0)+96|0;ka=ea(g[ga>>2]);la=ea(ka*ba);fa=a+($*76|0)+100|0;ba=ea(g[fa>>2]);ma=ea(ba*Y);Z=a+($*76|0)+104|0;Y=ea(g[Z>>2]);na=ea(Y*ca);X=a+($*76|0)+108|0;ca=ea(g[X>>2]);oa=ea(ea(la+ma)+ea(na+ea(ca*ia)));pa=(g[k>>2]=aa,c[k>>2]|0);qa=(g[k>>2]=oa,c[k>>2]|0)&-2147483648;oa=(c[k>>2]=qa^pa,ea(g[k>>2]));aa=(c[k>>2]=qa^(g[k>>2]=da,c[k>>2]|0),ea(g[k>>2]));da=(c[k>>2]=qa^(g[k>>2]=ha,c[k>>2]|0),ea(g[k>>2]));ha=ea(ba+aa);aa=ea(Y+da);da=ea(ca+(c[k>>2]=qa^(g[k>>2]=ja,c[k>>2]|0),ea(g[k>>2])));g[ga>>2]=ea(ka+oa);g[fa>>2]=ha;g[Z>>2]=aa;g[X>>2]=da;$=$+1|0}while(($|0)!=4);da=ea(U+V);aa=ea(V*ea(g[W>>2]));ha=ea(V*ea(g[W+4>>2]));oa=ea(V*ea(g[W+8>>2]));ka=ea(V*ea(g[W+12>>2]));ja=ea(aa+ea(g[a>>2]));aa=ea(ha+ea(g[o>>2]));ha=ea(oa+ea(g[w>>2]));oa=ea(ka+ea(g[x>>2]));g[a>>2]=ja;g[o>>2]=aa;g[w>>2]=ha;g[x>>2]=oa;oa=ea(g[W+16>>2]);ha=ea(V*oa);aa=ea(g[W+20>>2]);ja=ea(V*aa);ka=ea(g[W+24>>2]);ca=ea(V*ka);Y=ea(g[W+28>>2]);ba=ea(V*Y);ia=ea(g[y>>2]);na=ea(ia*oa);oa=ea(g[z>>2]);ma=ea(oa*aa);aa=ea(g[A>>2]);la=ea(aa*ka);ka=ea(g[B>>2]);ra=ea(ea(na+ma)+ea(la+ea(ka*Y)));X=(g[k>>2]=ha,c[k>>2]|0);Z=(g[k>>2]=ra,c[k>>2]|0)&-2147483648;ra=(c[k>>2]=Z^X,ea(g[k>>2]));ha=(c[k>>2]=Z^(g[k>>2]=ja,c[k>>2]|0),ea(g[k>>2]));ja=(c[k>>2]=Z^(g[k>>2]=ca,c[k>>2]|0),ea(g[k>>2]));ca=ea(oa+ha);ha=ea(aa+ja);ja=ea(ka+(c[k>>2]=Z^(g[k>>2]=ba,c[k>>2]|0),ea(g[k>>2])));g[y>>2]=ea(ia+ra);g[z>>2]=ca;g[A>>2]=ha;g[B>>2]=ja;S=S+1|0;if((S|0)==(e|0)){sa=da;break}else U=da}e=a+172|0;U=ea(g[e>>2]);da=ea(g[j>>2]);ja=ea(g[p>>2]);ha=ea(g[h>>2]);S=a+248|0;ca=ea(g[S>>2]);ra=ea(g[q>>2]);ia=ea(g[r>>2]);ba=ea(g[s>>2]);x=a+324|0;ka=ea(g[x>>2]);aa=ea(g[t>>2]);oa=ea(g[u>>2]);C=e;D=S;E=x;F=ha;G=ea(U+ea(0.0));H=ea(da+ea(0.0));I=ea(ja+ea(0.0));J=ba;K=ea(ca+ea(0.0));L=ea(ra+ea(0.0));M=ea(ia+ea(0.0));N=ea(g[v>>2]);O=ea(ka+ea(0.0));P=ea(aa+ea(0.0));Q=ea(oa+ea(0.0));R=sa}sa=ea(VDi(ea(1.0),ea(UDi(ea(0.0),ea(ea(1.0)-R)))));x=a+96|0;R=ea(ea(g[x>>2])+ea(0.0));oa=ea(ea(g[l>>2])+ea(0.0));aa=ea(ea(g[m>>2])+ea(0.0));ka=ea(sa+ea(g[n>>2]));ia=ea(ea(1.0)/ea(T(ea(ea(ea(R*R)+ea(oa*oa))+ea(ea(aa*aa)+ea(ka*ka))))));ra=ea(oa*ia);oa=ea(aa*ia);aa=ea(ka*ia);g[x>>2]=ea(R*ia);g[l>>2]=ra;g[m>>2]=oa;g[n>>2]=aa;aa=ea(sa+F);F=ea(ea(1.0)/ea(T(ea(ea(ea(G*G)+ea(H*H))+ea(ea(I*I)+ea(aa*aa))))));oa=ea(H*F);H=ea(I*F);I=ea(aa*F);g[C>>2]=ea(G*F);g[j>>2]=oa;g[p>>2]=H;g[h>>2]=I;I=ea(sa+J);J=ea(ea(1.0)/ea(T(ea(ea(ea(K*K)+ea(L*L))+ea(ea(M*M)+ea(I*I))))));H=ea(L*J);L=ea(M*J);M=ea(I*J);g[D>>2]=ea(K*J);g[q>>2]=H;g[r>>2]=L;g[s>>2]=M;M=ea(sa+N);N=ea(ea(1.0)/ea(T(ea(ea(ea(O*O)+ea(P*P))+ea(ea(Q*Q)+ea(M*M))))));L=ea(P*N);P=ea(Q*N);Q=ea(M*N);g[E>>2]=ea(O*N);g[t>>2]=L;g[u>>2]=P;g[v>>2]=Q;Q=ea(ea(g[y>>2])+ea(0.0));P=ea(ea(g[z>>2])+ea(0.0));L=ea(ea(g[A>>2])+ea(0.0));N=ea(sa+ea(g[B>>2]));sa=ea(ea(1.0)/ea(T(ea(ea(ea(Q*Q)+ea(P*P))+ea(ea(L*L)+ea(N*N))))));O=ea(P*sa);P=ea(L*sa);L=ea(N*sa);g[y>>2]=ea(Q*sa);g[z>>2]=O;g[A>>2]=P;g[B>>2]=L;i=f;return}function e$d(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,h=Im,j=0,l=0,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=0,w=Im,x=Im,y=0,z=0,A=Im,B=0,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im;f=i;if(!(d>ea(0.0))){i=f;return}h=ea(ea(1.0)-d);j=d<ea(1.0);l=0;do{m=l;l=l+1|0;do if(c[e+(l>>>5<<2)>>2]&1<<(l&31)){n=ea(g[b+(m<<2)+672>>2]);o=a+(m<<2)+672|0;if(j){g[o>>2]=ea(ea(h*ea(g[o>>2]))+ea(n*d));break}else{g[o>>2]=n;break}}while(0)}while((l|0)!=52);l=c[e+4>>2]|0;do if(l&33554432)if(j){m=0;do{o=a+(m<<2)+432|0;n=ea(h*ea(g[o>>2]));g[o>>2]=ea(n+ea(ea(g[b+(m<<2)+432>>2])*d));m=m+1|0}while((m|0)!=20)}else{g[a+432>>2]=ea(g[b+432>>2]);g[a+436>>2]=ea(g[b+436>>2]);g[a+440>>2]=ea(g[b+440>>2]);g[a+444>>2]=ea(g[b+444>>2]);g[a+448>>2]=ea(g[b+448>>2]);g[a+452>>2]=ea(g[b+452>>2]);g[a+456>>2]=ea(g[b+456>>2]);g[a+460>>2]=ea(g[b+460>>2]);g[a+464>>2]=ea(g[b+464>>2]);g[a+468>>2]=ea(g[b+468>>2]);g[a+472>>2]=ea(g[b+472>>2]);g[a+476>>2]=ea(g[b+476>>2]);g[a+480>>2]=ea(g[b+480>>2]);g[a+484>>2]=ea(g[b+484>>2]);g[a+488>>2]=ea(g[b+488>>2]);g[a+492>>2]=ea(g[b+492>>2]);g[a+496>>2]=ea(g[b+496>>2]);g[a+500>>2]=ea(g[b+500>>2]);g[a+504>>2]=ea(g[b+504>>2]);g[a+508>>2]=ea(g[b+508>>2]);break}while(0);do if(l&67108864)if(j){m=0;do{o=a+(m<<2)+576|0;n=ea(h*ea(g[o>>2]));g[o>>2]=ea(n+ea(ea(g[b+(m<<2)+576>>2])*d));m=m+1|0}while((m|0)!=20)}else{g[a+576>>2]=ea(g[b+576>>2]);g[a+580>>2]=ea(g[b+580>>2]);g[a+584>>2]=ea(g[b+584>>2]);g[a+588>>2]=ea(g[b+588>>2]);g[a+592>>2]=ea(g[b+592>>2]);g[a+596>>2]=ea(g[b+596>>2]);g[a+600>>2]=ea(g[b+600>>2]);g[a+604>>2]=ea(g[b+604>>2]);g[a+608>>2]=ea(g[b+608>>2]);g[a+612>>2]=ea(g[b+612>>2]);g[a+616>>2]=ea(g[b+616>>2]);g[a+620>>2]=ea(g[b+620>>2]);g[a+624>>2]=ea(g[b+624>>2]);g[a+628>>2]=ea(g[b+628>>2]);g[a+632>>2]=ea(g[b+632>>2]);g[a+636>>2]=ea(g[b+636>>2]);g[a+640>>2]=ea(g[b+640>>2]);g[a+644>>2]=ea(g[b+644>>2]);g[a+648>>2]=ea(g[b+648>>2]);g[a+652>>2]=ea(g[b+652>>2]);break}while(0);if(j){l=0;do{m=l+53|0;if(c[e+(m>>>5<<2)>>2]&1<<(m&31)){h=ea(g[b+(l*76|0)+80>>2]);m=a+(l*76|0)+80|0;n=ea(g[m>>2]);p=ea(h-n);h=ea(g[b+(l*76|0)+84>>2]);o=a+(l*76|0)+84|0;q=ea(g[o>>2]);r=ea(h-q);h=ea(g[b+(l*76|0)+88>>2]);s=a+(l*76|0)+88|0;t=ea(g[s>>2]);u=ea(h-t);h=ea(g[b+(l*76|0)+92>>2]);v=a+(l*76|0)+92|0;w=ea(g[v>>2]);x=ea(n+ea(p*d));p=ea(q+ea(r*d));r=ea(t+ea(u*d));u=ea(w+ea(ea(h-w)*d));y=a+(l*76|0)+96|0;w=ea(g[y>>2]);h=ea(g[b+(l*76|0)+96>>2]);t=ea(w*h);z=a+(l*76|0)+100|0;q=ea(g[z>>2]);n=ea(g[b+(l*76|0)+100>>2]);A=ea(q*n);B=a+(l*76|0)+104|0;C=ea(g[B>>2]);D=ea(g[b+(l*76|0)+104>>2]);E=ea(C*D);F=a+(l*76|0)+108|0;G=ea(g[F>>2]);H=ea(g[b+(l*76|0)+108>>2]);I=ea(ea(t+A)+ea(E+ea(G*H)));J=(g[k>>2]=h,c[k>>2]|0);K=(g[k>>2]=I,c[k>>2]|0)&-2147483648;I=(c[k>>2]=K^J,ea(g[k>>2]));h=(c[k>>2]=K^(g[k>>2]=n,c[k>>2]|0),ea(g[k>>2]));n=(c[k>>2]=K^(g[k>>2]=D,c[k>>2]|0),ea(g[k>>2]));D=ea(w+ea(ea(I-w)*d));w=ea(q+ea(ea(h-q)*d));q=ea(C+ea(ea(n-C)*d));C=ea(G+ea(ea((c[k>>2]=K^(g[k>>2]=H,c[k>>2]|0),ea(g[k>>2]))-G)*d));G=ea(ea(1.0)/ea(T(ea(ea(ea(D*D)+ea(w*w))+ea(ea(q*q)+ea(C*C))))));H=ea(G*D);D=ea(G*w);w=ea(G*q);q=ea(G*C);C=ea(g[b+(l*76|0)+112>>2]);K=a+(l*76|0)+112|0;G=ea(g[K>>2]);n=ea(C-G);C=ea(g[b+(l*76|0)+116>>2]);J=a+(l*76|0)+116|0;h=ea(g[J>>2]);I=ea(C-h);C=ea(g[b+(l*76|0)+120>>2]);L=a+(l*76|0)+120|0;E=ea(g[L>>2]);A=ea(C-E);C=ea(g[b+(l*76|0)+124>>2]);M=a+(l*76|0)+124|0;t=ea(g[M>>2]);N=ea(G+ea(n*d));n=ea(h+ea(I*d));I=ea(E+ea(A*d));A=ea(t+ea(ea(C-t)*d));g[m>>2]=x;g[o>>2]=p;g[s>>2]=r;g[v>>2]=u;g[y>>2]=H;g[z>>2]=D;g[B>>2]=w;g[F>>2]=q;g[K>>2]=N;g[J>>2]=n;g[L>>2]=I;g[M>>2]=A}l=l+1|0}while((l|0)!=4)}else{l=0;do{M=l+53|0;if(c[e+(M>>>5<<2)>>2]&1<<(M&31)){A=ea(g[b+(l*76|0)+80>>2]);I=ea(g[b+(l*76|0)+84>>2]);n=ea(g[b+(l*76|0)+88>>2]);N=ea(g[b+(l*76|0)+92>>2]);g[a+(l*76|0)+80>>2]=A;g[a+(l*76|0)+84>>2]=I;g[a+(l*76|0)+88>>2]=n;g[a+(l*76|0)+92>>2]=N;N=ea(g[b+(l*76|0)+96>>2]);n=ea(g[b+(l*76|0)+100>>2]);I=ea(g[b+(l*76|0)+104>>2]);A=ea(g[b+(l*76|0)+108>>2]);g[a+(l*76|0)+96>>2]=N;g[a+(l*76|0)+100>>2]=n;g[a+(l*76|0)+104>>2]=I;g[a+(l*76|0)+108>>2]=A;A=ea(g[b+(l*76|0)+112>>2]);I=ea(g[b+(l*76|0)+116>>2]);n=ea(g[b+(l*76|0)+120>>2]);N=ea(g[b+(l*76|0)+124>>2]);g[a+(l*76|0)+112>>2]=A;g[a+(l*76|0)+116>>2]=I;g[a+(l*76|0)+120>>2]=n;g[a+(l*76|0)+124>>2]=N}l=l+1|0}while((l|0)!=4)}if(!(c[e>>2]&1)){i=f;return}N=ea(g[b>>2]);n=ea(g[b+4>>2]);I=ea(g[b+8>>2]);if(j){A=ea(g[a>>2]);q=ea(N-A);j=a+4|0;w=ea(g[j>>2]);D=ea(n-w);e=a+8|0;H=ea(g[e>>2]);u=ea(I-H);r=ea(g[b+12>>2]);l=a+12|0;p=ea(g[l>>2]);x=ea(A+ea(q*d));q=ea(w+ea(D*d));D=ea(H+ea(u*d));u=ea(p+ea(ea(r-p)*d));M=a+16|0;p=ea(g[M>>2]);r=ea(g[b+16>>2]);H=ea(p*r);L=a+20|0;w=ea(g[L>>2]);A=ea(g[b+20>>2]);t=ea(w*A);J=a+24|0;C=ea(g[J>>2]);E=ea(g[b+24>>2]);h=ea(C*E);K=a+28|0;G=ea(g[K>>2]);O=ea(g[b+28>>2]);P=ea(ea(H+t)+ea(h+ea(G*O)));F=(g[k>>2]=r,c[k>>2]|0);B=(g[k>>2]=P,c[k>>2]|0)&-2147483648;P=(c[k>>2]=B^F,ea(g[k>>2]));r=(c[k>>2]=B^(g[k>>2]=A,c[k>>2]|0),ea(g[k>>2]));A=(c[k>>2]=B^(g[k>>2]=E,c[k>>2]|0),ea(g[k>>2]));E=ea(p+ea(ea(P-p)*d));p=ea(w+ea(ea(r-w)*d));w=ea(C+ea(ea(A-C)*d));C=ea(G+ea(ea((c[k>>2]=B^(g[k>>2]=O,c[k>>2]|0),ea(g[k>>2]))-G)*d));G=ea(ea(1.0)/ea(T(ea(ea(ea(E*E)+ea(p*p))+ea(ea(w*w)+ea(C*C))))));O=ea(G*E);E=ea(G*p);p=ea(G*w);w=ea(G*C);C=ea(g[b+32>>2]);B=a+32|0;G=ea(g[B>>2]);A=ea(C-G);C=ea(g[b+36>>2]);F=a+36|0;r=ea(g[F>>2]);P=ea(C-r);C=ea(g[b+40>>2]);z=a+40|0;h=ea(g[z>>2]);t=ea(C-h);C=ea(g[b+44>>2]);y=a+44|0;H=ea(g[y>>2]);Q=ea(G+ea(A*d));A=ea(r+ea(P*d));P=ea(h+ea(t*d));t=ea(H+ea(ea(C-H)*d));g[a>>2]=x;g[j>>2]=q;g[e>>2]=D;g[l>>2]=u;g[M>>2]=O;g[L>>2]=E;g[J>>2]=p;g[K>>2]=w;g[B>>2]=Q;g[F>>2]=A;g[z>>2]=P;g[y>>2]=t;i=f;return}else{t=ea(g[b+12>>2]);g[a>>2]=N;g[a+4>>2]=n;g[a+8>>2]=I;g[a+12>>2]=t;t=ea(g[b+16>>2]);I=ea(g[b+20>>2]);n=ea(g[b+24>>2]);N=ea(g[b+28>>2]);g[a+16>>2]=t;g[a+20>>2]=I;g[a+24>>2]=n;g[a+28>>2]=N;N=ea(g[b+32>>2]);n=ea(g[b+36>>2]);I=ea(g[b+40>>2]);t=ea(g[b+44>>2]);g[a+32>>2]=N;g[a+36>>2]=n;g[a+40>>2]=I;g[a+44>>2]=t;i=f;return}}function f$d(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,U=Im;f=i;i=i+192|0;h=f+144|0;j=f+96|0;k=f+48|0;l=f;if(d>ea(0.0))m=0;else{i=f;return}do{n=m;m=m+1|0;if(c[e+(m>>>5<<2)>>2]&1<<(m&31)){o=ea(ea(g[b+(n<<2)+672>>2])*d);p=a+(n<<2)+672|0;g[p>>2]=ea(ea(g[p>>2])+o)}}while((m|0)!=52);m=c[e+4>>2]|0;if(m&33554432){p=0;do{o=ea(ea(g[b+(p<<2)+432>>2])*d);n=a+(p<<2)+432|0;g[n>>2]=ea(ea(g[n>>2])+o);p=p+1|0}while((p|0)!=20)}if(m&67108864){m=0;do{o=ea(ea(g[b+(m<<2)+576>>2])*d);p=a+(m<<2)+576|0;g[p>>2]=ea(ea(g[p>>2])+o);m=m+1|0}while((m|0)!=20)}m=j+4|0;p=j+8|0;n=j+12|0;q=j+16|0;r=j+20|0;s=j+24|0;t=j+28|0;u=j+32|0;v=j+36|0;w=j+40|0;x=j+44|0;y=h+4|0;z=h+8|0;A=h+12|0;B=h+16|0;C=h+20|0;D=h+24|0;E=h+28|0;F=h+32|0;G=h+36|0;H=h+40|0;I=h+44|0;J=0;do{K=J+53|0;if(c[e+(K>>>5<<2)>>2]&1<<(K&31)){K=a+(J*76|0)+80|0;o=ea(ea(g[b+(J*76|0)+80>>2])*d);L=ea(ea(g[b+(J*76|0)+84>>2])*d);M=ea(ea(g[b+(J*76|0)+88>>2])*d);N=ea(ea(g[b+(J*76|0)+92>>2])*d);O=ea(ea(g[b+(J*76|0)+96>>2])*d);P=ea(ea(g[b+(J*76|0)+100>>2])*d);Q=ea(ea(g[b+(J*76|0)+104>>2])*d);R=ea(g[b+(J*76|0)+108>>2]);S=ea(ea(1.0)/ea(T(ea(ea(ea(O*O)+ea(P*P))+ea(ea(Q*Q)+ea(R*R))))));U=ea(O*S);O=ea(P*S);P=ea(Q*S);Q=ea(R*S);g[j>>2]=o;g[m>>2]=L;g[p>>2]=M;g[n>>2]=N;g[q>>2]=U;g[r>>2]=O;g[s>>2]=P;g[t>>2]=Q;g[u>>2]=ea(1.0);g[v>>2]=ea(1.0);g[w>>2]=ea(1.0);g[x>>2]=ea(1.0);n$d(h,K,j);Q=ea(g[h>>2]);P=ea(g[y>>2]);O=ea(g[z>>2]);U=ea(g[A>>2]);g[K>>2]=Q;g[a+(J*76|0)+84>>2]=P;g[a+(J*76|0)+88>>2]=O;g[a+(J*76|0)+92>>2]=U;U=ea(g[B>>2]);O=ea(g[C>>2]);P=ea(g[D>>2]);Q=ea(g[E>>2]);g[a+(J*76|0)+96>>2]=U;g[a+(J*76|0)+100>>2]=O;g[a+(J*76|0)+104>>2]=P;g[a+(J*76|0)+108>>2]=Q;Q=ea(g[F>>2]);P=ea(g[G>>2]);O=ea(g[H>>2]);U=ea(g[I>>2]);g[a+(J*76|0)+112>>2]=Q;g[a+(J*76|0)+116>>2]=P;g[a+(J*76|0)+120>>2]=O;g[a+(J*76|0)+124>>2]=U}J=J+1|0}while((J|0)!=4);if(!(c[e>>2]&1)){i=f;return}U=ea(ea(g[b>>2])*d);O=ea(ea(g[b+4>>2])*d);P=ea(ea(g[b+8>>2])*d);Q=ea(ea(g[b+12>>2])*d);N=ea(ea(g[b+16>>2])*d);M=ea(ea(g[b+20>>2])*d);L=ea(ea(g[b+24>>2])*d);d=ea(g[b+28>>2]);o=ea(ea(1.0)/ea(T(ea(ea(ea(N*N)+ea(M*M))+ea(ea(L*L)+ea(d*d))))));S=ea(N*o);N=ea(M*o);M=ea(L*o);L=ea(d*o);g[l>>2]=U;g[l+4>>2]=O;g[l+8>>2]=P;g[l+12>>2]=Q;g[l+16>>2]=S;g[l+20>>2]=N;g[l+24>>2]=M;g[l+28>>2]=L;g[l+32>>2]=ea(1.0);g[l+36>>2]=ea(1.0);g[l+40>>2]=ea(1.0);g[l+44>>2]=ea(1.0);n$d(k,a,l);L=ea(g[k>>2]);M=ea(g[k+4>>2]);N=ea(g[k+8>>2]);S=ea(g[k+12>>2]);g[a>>2]=L;g[a+4>>2]=M;g[a+8>>2]=N;g[a+12>>2]=S;S=ea(g[k+16>>2]);N=ea(g[k+20>>2]);M=ea(g[k+24>>2]);L=ea(g[k+28>>2]);g[a+16>>2]=S;g[a+20>>2]=N;g[a+24>>2]=M;g[a+28>>2]=L;L=ea(g[k+32>>2]);M=ea(g[k+36>>2]);N=ea(g[k+40>>2]);S=ea(g[k+44>>2]);g[a+32>>2]=L;g[a+36>>2]=M;g[a+40>>2]=N;g[a+44>>2]=S;i=f;return}function g$d(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=0,W=0,X=0,Y=0,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=Im,va=Im,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=Im,Sa=Im,Ta=Im;j=i;i=i+112|0;l=j+32|0;m=j+64|0;n=j+80|0;o=j+96|0;p=j+16|0;q=j;r=j+48|0;s=c[a+(e<<2)+104>>2]|0;e=c[a+(f<<2)+104>>2]|0;f=a+48|0;t=f;u=(c[f>>2]|0)+t|0;v=u+4|0;w=v+(c[v>>2]|0)|0;v=c[w+(s<<3)>>2]|0;x=u+24|0;y=c[w+(s<<3)+4>>2]|0;w=(c[x>>2]|0)+x|0;z=ea(g[w+(y*88|0)>>2]);A=ea(g[w+(y*88|0)+4>>2]);B=ea(g[w+(y*88|0)+8>>2]);C=ea(g[w+(y*88|0)+12>>2]);D=ea(g[w+(y*88|0)+16>>2]);E=ea(g[w+(y*88|0)+20>>2]);F=ea(g[w+(y*88|0)+24>>2]);G=ea(g[w+(y*88|0)+28>>2]);H=ea(g[w+(y*88|0)+32>>2]);I=ea(g[w+(y*88|0)+36>>2]);J=ea(g[w+(y*88|0)+40>>2]);K=ea(g[w+(y*88|0)+44>>2]);L=ea(g[w+(y*88|0)+48>>2]);M=ea(g[w+(y*88|0)+52>>2]);N=ea(g[w+(y*88|0)+56>>2]);O=ea(g[w+(y*88|0)+60>>2]);P=ea(g[w+(y*88|0)+64>>2]);Q=ea(g[w+(y*88|0)+68>>2]);R=ea(g[w+(y*88|0)+72>>2]);U=ea(g[w+(y*88|0)+76>>2]);x=c[w+(y*88|0)+84>>2]|0;y=d+4|0;w=y;V=(c[y>>2]|0)+w|0;W=d+8|0;c[W>>2]=V;g[V+(v*48|0)+16>>2]=ea(0.0);g[V+(v*48|0)+20>>2]=ea(0.0);g[V+(v*48|0)+24>>2]=ea(0.0);g[V+(v*48|0)+28>>2]=ea(1.0);v=a+52|0;c[v>>2]=u;z$d(u,b,d,e,s);u=b+4|0;a=u;V=(c[u>>2]|0)+a|0;X=b+8|0;c[X>>2]=V;Y=V+(s*48|0)+16|0;c[r+0>>2]=c[Y+0>>2];c[r+4>>2]=c[Y+4>>2];c[r+8>>2]=c[Y+8>>2];c[r+12>>2]=c[Y+12>>2];Y=(c[y>>2]|0)+w|0;c[W>>2]=Y;aa=ea(g[Y+(e*48|0)+16>>2]);ba=ea(g[Y+(e*48|0)+20>>2]);ca=ea(g[Y+(e*48|0)+24>>2]);da=ea(g[Y+(e*48|0)+28>>2]);c[X>>2]=V;fa=ea(g[V+(s*48|0)+20>>2]);ga=ea(D*fa);ha=ea(g[V+(s*48|0)+28>>2]);ia=ea(G*ha);ja=ea(g[V+(s*48|0)+24>>2]);ka=ea(E*ja);la=ea(g[V+(s*48|0)+16>>2]);ma=ea(ea(ea(ga-ea(F*ha))-ea(G*ja))-ea(E*la));ga=ea(ea(ea(ia-ea(D*la))-ea(F*ja))-ea(E*fa));ia=ea(ea(ea(ka-ea(F*fa))-ea(D*ha))-ea(G*la));ka=ea(ea(ea(ea(F*la)-ea(D*ja))-ea(E*ha))-ea(G*fa));fa=ea(ea(ea(B*ga)+ea(ea(C*ma)+ea(A*ia)))-ea(z*ka));ha=ea(ea(ea(ea(C*ga)-ea(z*ia))-ea(B*ma))-ea(A*ka));ja=ea(ea(z*ga)+ea(ea(C*ia)+ea(ea(B*ka)-ea(A*ma))));la=ea(ea(A*ga)+ea(ea(C*ka)+ea(ea(z*ma)-ea(B*ia))));ia=ea(ea(1.0)/ea(T(ea(ea(ea(la*la)+ea(ja*ja))+ea(ea(fa*fa)+ea(ha*ha))))));ma=ea(ia*ja);ja=ea(-ma);ka=ea(ia*la);la=ea(-ka);ga=ea(ia*fa);fa=ea(-ga);na=ea(ia*ha);if((x|0)==2){V=na==ea(0.0);ha=V?ea(9.99999997e-07):na;ia=ea(ja/ha);oa=ea(la/ha);pa=ea(fa/ha);ha=ea(ea(ia*ia)+ea(1.0));qa=ea(ea(oa+ea(ia*pa))/ha);ra=ea(ea(pa-ea(ia*oa))/ha);V=(g[k>>2]=ia,c[k>>2]|0);ia=(c[k>>2]=V^(g[k>>2]=H,c[k>>2]|0)&-2147483648,ea(g[k>>2]));V=(g[k>>2]=qa,c[k>>2]|0);qa=(c[k>>2]=V^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));V=(g[k>>2]=ra,c[k>>2]|0);ra=(c[k>>2]=V^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ha=ea(ea(+_(+ia))*ea(2.0));ia=ea(ea(+_(+qa))*ea(2.0));qa=ea(ea(+_(+ra))*ea(2.0));ra=ea(ea(+_(+(c[k>>2]=(g[k>>2]=K,c[k>>2]|0)&-2147483648,ea(g[k>>2]))))*ea(2.0));V=L>ea(0.0);Y=M>ea(0.0);sa=N>ea(0.0);ta=O>ea(0.0);oa=ea(ea(-ha)/L);pa=ea(ea(-ia)/M);ua=ea(ea(-qa)/N);va=ea(ea(-ra)/O);wa=L<ea(0.0);xa=M<ea(0.0);ya=N<ea(0.0);za=O<ea(0.0);Aa=(g[k>>2]=ha,c[k>>2]|0);Ba=wa?(g[k>>2]=oa,c[k>>2]|0):V?Aa:0;V=(g[k>>2]=ia,c[k>>2]|0);wa=xa?(g[k>>2]=pa,c[k>>2]|0):Y?V:0;Y=(g[k>>2]=qa,c[k>>2]|0);xa=ya?(g[k>>2]=ua,c[k>>2]|0):sa?Y:0;sa=(g[k>>2]=ra,c[k>>2]|0);ya=za?(g[k>>2]=va,c[k>>2]|0):ta?sa:0;ta=P<ea(0.0);za=Q<ea(0.0);Ca=R<ea(0.0);Da=U<ea(0.0);va=ea(ha/P);ua=ea(ia/Q);pa=ea(qa/R);oa=ea(ra/U);Ea=P>ea(0.0);Fa=Q>ea(0.0);Ga=R>ea(0.0);Ha=U>ea(0.0);Ia=Ea?(g[k>>2]=va,c[k>>2]|0):ta?Aa:0;Aa=Fa?(g[k>>2]=ua,c[k>>2]|0):za?V:0;V=Ga?(g[k>>2]=pa,c[k>>2]|0):Ca?Y:0;Y=ha<ea(0.0);Ca=ia<ea(0.0);Ga=qa<ea(0.0);za=ra<ea(0.0);Ja=Ga?xa:V;Ka=Ca?wa:Aa;La=Y?Ba:Ia;Ma=(c[k>>2]=za?ya:Ha?(g[k>>2]=oa,c[k>>2]|0):Da?sa:0,ea(g[k>>2]))}else if((x|0)==3){oa=ea(ma*ma);ra=ea(ka*ma);qa=ea(ga*ma);ma=ea(na*ja);ia=ea(ka*ka);ha=ea(ga*ka);ka=ea(na*la);pa=ea(qa-ka);do if(!(pa>=ea(.499998987))){ua=ea(na*fa);va=ea(ea(na*na)+ea(-.5));if(!(pa<=ea(-.499998987))){Na=ea(+$(+ea(ha+ma),+ea(ea(ga*ga)+va)));Oa=ea(-ea(+Z(+ea(pa+pa))));Pa=ea(+$(+ea(ra+ua),+ea(oa+va)));break}else{Na=ea(+$(+ea(ra-ua),+ea(ia+va)));Oa=ea(1.57079637);Pa=ea(0.0);break}}else{Na=ea(+$(+ea(ma-ha),+ea(ea(-qa)-ka)));Oa=ea(-1.57079637);Pa=ea(0.0)}while(0);sa=L>ea(0.0);Da=M>ea(0.0);Ha=N>ea(0.0);ka=ea(ea(-Na)/L);qa=ea(ea(-Oa)/M);ha=ea(ea(-Pa)/N);ya=L<ea(0.0);za=M<ea(0.0);Ia=N<ea(0.0);Ba=(g[k>>2]=Na,c[k>>2]|0);Y=ya?(g[k>>2]=ka,c[k>>2]|0):sa?Ba:0;sa=(g[k>>2]=Oa,c[k>>2]|0);ya=za?(g[k>>2]=qa,c[k>>2]|0):Da?sa:0;Da=(g[k>>2]=Pa,c[k>>2]|0);za=Ia?(g[k>>2]=ha,c[k>>2]|0):Ha?Da:0;Ha=P<ea(0.0);Ia=Q<ea(0.0);Aa=R<ea(0.0);ha=ea(Na/P);qa=ea(Oa/Q);ka=ea(Pa/R);ma=ea(ea(0.0)/U);wa=P>ea(0.0);Ca=Q>ea(0.0);V=R>ea(0.0);xa=U>ea(0.0);Ga=wa?(g[k>>2]=ha,c[k>>2]|0):Ha?Ba:0;Ba=Ca?(g[k>>2]=qa,c[k>>2]|0):Ia?sa:0;sa=Na<ea(0.0);Ia=Oa<ea(0.0);Ca=Pa<ea(0.0);Ja=Ca?za:V?(g[k>>2]=ka,c[k>>2]|0):Aa?Da:0;Ka=Ia?ya:Ba;La=sa?Y:Ga;Ma=xa?ma:ea(0.0)}else if((x|0)==1){xa=na==ea(0.0);ma=xa?ea(9.99999997e-07):na;ka=ea(ja/ma);Pa=ea(la/ma);Oa=ea(fa/ma);ma=ea(ea(ka*ka)+ea(1.0));Na=ea(ea(Pa-ea(ka*Oa))/ma);qa=ea(ea(ea(ka*Pa)+Oa)/ma);xa=(g[k>>2]=ka,c[k>>2]|0);ka=(c[k>>2]=xa^(g[k>>2]=H,c[k>>2]|0)&-2147483648,ea(g[k>>2]));xa=(g[k>>2]=Na,c[k>>2]|0);Na=(c[k>>2]=xa^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));xa=(g[k>>2]=qa,c[k>>2]|0);qa=(c[k>>2]=xa^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ma=ea(ea(+_(+ka))*ea(2.0));ka=ea(ea(+_(+Na))*ea(2.0));Na=ea(ea(+_(+qa))*ea(2.0));qa=ea(ea(+_(+(c[k>>2]=(g[k>>2]=K,c[k>>2]|0)&-2147483648,ea(g[k>>2]))))*ea(2.0));xa=L>ea(0.0);Ga=M>ea(0.0);Y=N>ea(0.0);sa=O>ea(0.0);Oa=ea(ea(-ma)/L);Pa=ea(ea(-ka)/M);ha=ea(ea(-Na)/N);ia=ea(ea(-qa)/O);Ba=L<ea(0.0);ya=M<ea(0.0);Ia=N<ea(0.0);Da=O<ea(0.0);Aa=(g[k>>2]=ma,c[k>>2]|0);V=Ba?(g[k>>2]=Oa,c[k>>2]|0):xa?Aa:0;xa=(g[k>>2]=ka,c[k>>2]|0);Ba=ya?(g[k>>2]=Pa,c[k>>2]|0):Ga?xa:0;Ga=(g[k>>2]=Na,c[k>>2]|0);ya=Ia?(g[k>>2]=ha,c[k>>2]|0):Y?Ga:0;Y=(g[k>>2]=qa,c[k>>2]|0);Ia=Da?(g[k>>2]=ia,c[k>>2]|0):sa?Y:0;sa=P<ea(0.0);Da=Q<ea(0.0);za=R<ea(0.0);Ca=U<ea(0.0);ia=ea(ma/P);ha=ea(ka/Q);Pa=ea(Na/R);Oa=ea(qa/U);Ha=P>ea(0.0);wa=Q>ea(0.0);Fa=R>ea(0.0);ta=U>ea(0.0);Ea=Ha?(g[k>>2]=ia,c[k>>2]|0):sa?Aa:0;Aa=wa?(g[k>>2]=ha,c[k>>2]|0):Da?xa:0;xa=Fa?(g[k>>2]=Pa,c[k>>2]|0):za?Ga:0;Ga=ma<ea(0.0);za=ka<ea(0.0);Fa=Na<ea(0.0);Da=qa<ea(0.0);Ja=Fa?ya:xa;Ka=za?Ba:Aa;La=Ga?V:Ea;Ma=(c[k>>2]=Da?Ia:ta?(g[k>>2]=Oa,c[k>>2]|0):Ca?Y:0,ea(g[k>>2]))}else{Y=na==ea(0.0);Oa=Y?ea(9.99999997e-07):na;na=ea(ja/Oa);ja=ea(la/Oa);la=ea(fa/Oa);Y=(g[k>>2]=na,c[k>>2]|0);na=(c[k>>2]=Y^(g[k>>2]=H,c[k>>2]|0)&-2147483648,ea(g[k>>2]));Y=(g[k>>2]=ja,c[k>>2]|0);ja=(c[k>>2]=Y^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));Y=(g[k>>2]=la,c[k>>2]|0);la=(c[k>>2]=Y^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));Oa=ea(ea(+_(+na))*ea(2.0));na=ea(ea(+_(+ja))*ea(2.0));ja=ea(ea(+_(+la))*ea(2.0));la=ea(ea(+_(+(c[k>>2]=(g[k>>2]=K,c[k>>2]|0)&-2147483648,ea(g[k>>2]))))*ea(2.0));Y=L>ea(0.0);Ca=M>ea(0.0);ta=N>ea(0.0);Ia=O>ea(0.0);K=ea(ea(-Oa)/L);fa=ea(ea(-na)/M);qa=ea(ea(-ja)/N);Na=ea(ea(-la)/O);Da=L<ea(0.0);Ea=M<ea(0.0);V=N<ea(0.0);Ga=O<ea(0.0);Aa=(g[k>>2]=Oa,c[k>>2]|0);Ba=Da?(g[k>>2]=K,c[k>>2]|0):Y?Aa:0;Y=(g[k>>2]=na,c[k>>2]|0);Da=Ea?(g[k>>2]=fa,c[k>>2]|0):Ca?Y:0;Ca=(g[k>>2]=ja,c[k>>2]|0);Ea=V?(g[k>>2]=qa,c[k>>2]|0):ta?Ca:0;ta=(g[k>>2]=la,c[k>>2]|0);V=Ga?(g[k>>2]=Na,c[k>>2]|0):Ia?ta:0;Ia=P<ea(0.0);Ga=Q<ea(0.0);za=R<ea(0.0);xa=U<ea(0.0);Na=ea(Oa/P);qa=ea(na/Q);fa=ea(ja/R);K=ea(la/U);ya=P>ea(0.0);Fa=Q>ea(0.0);wa=R>ea(0.0);sa=U>ea(0.0);Ha=ya?(g[k>>2]=Na,c[k>>2]|0):Ia?Aa:0;Aa=Fa?(g[k>>2]=qa,c[k>>2]|0):Ga?Y:0;Y=wa?(g[k>>2]=fa,c[k>>2]|0):za?Ca:0;Ca=Oa<ea(0.0);za=na<ea(0.0);wa=ja<ea(0.0);Ga=la<ea(0.0);Ja=wa?Ea:Y;Ka=za?Da:Aa;La=Ca?Ba:Ha;Ma=(c[k>>2]=Ga?V:sa?(g[k>>2]=K,c[k>>2]|0):xa?ta:0,ea(g[k>>2]))}K=(c[k>>2]=La,ea(g[k>>2]));la=(c[k>>2]=Ka,ea(g[k>>2]));ja=(c[k>>2]=Ja,ea(g[k>>2]));na=ea(K*ea(g[h>>2]));h=(c[u>>2]|0)+a|0;c[X>>2]=h;if((x|0)==3){K=ea(ea(na*ea(.5))*ea(.159154937));Oa=ea(ea(la*ea(.5))*ea(.159154937));fa=ea(ea(ja*ea(.5))*ea(.159154937));qa=ea(eEi(K));Na=ea(eEi(Oa));ka=ea(ea(.25)-ea(S(ea(K-qa))));qa=ea(ea(.25)-ea(S(ea(Oa-Na))));Na=ea(ea(.25)-ea(S(ea(fa-ea(eEi(fa))))));ma=ea(ka*ka);Pa=ea(qa*qa);ha=ea(Na*Na);ia=ea(ka*ea(ea(ea(ma*ea(-41.2831841))+ea(6.28318548))+ea(ea(ma*ma)*ea(76.0354614))));ma=ea(qa*ea(ea(ea(Pa*ea(-41.2831841))+ea(6.28318548))+ea(ea(Pa*Pa)*ea(76.0354614))));Pa=ea(Na*ea(ea(ea(ha*ea(-41.2831841))+ea(6.28318548))+ea(ea(ha*ha)*ea(76.0354614))));ha=ea(K+ea(-.25));K=ea(Oa+ea(-.25));Oa=ea(fa+ea(-.25));fa=ea(eEi(ha));Na=ea(eEi(K));qa=ea(ea(.25)-ea(S(ea(ha-fa))));fa=ea(ea(.25)-ea(S(ea(K-Na))));Na=ea(ea(.25)-ea(S(ea(Oa-ea(eEi(Oa))))));Oa=ea(qa*qa);K=ea(fa*fa);ha=ea(Na*Na);ka=ea(qa*ea(ea(ea(Oa*ea(-41.2831841))+ea(6.28318548))+ea(ea(Oa*Oa)*ea(76.0354614))));Oa=ea(fa*ea(ea(ea(K*ea(-41.2831841))+ea(6.28318548))+ea(ea(K*K)*ea(76.0354614))));K=ea(Na*ea(ea(ea(ha*ea(-41.2831841))+ea(6.28318548))+ea(ea(ha*ha)*ea(76.0354614))));ha=ea(Pa*ka);Na=ea(ka*K);ka=ea(ia*K);K=ea(ia*Pa);Pa=ea(-Oa);Qa=ea(ea(K*Oa)+ea(ma*Na));Ra=ea(ea(ma*K)+ea(Oa*Na));Sa=ea(ea(ha*Pa)+ea(ma*ka));Ta=ea(ea(ma*ha)+ea(ka*Pa))}else if((x|0)==2){La=L>ea(0.0);ta=M>ea(0.0);xa=N>ea(0.0);sa=O>ea(0.0);Pa=ea(-ea(L*na));ka=ea(-ea(M*la));ha=ea(-ea(N*ja));ma=ea(-ea(O*Ma));V=L<ea(0.0);Ga=M<ea(0.0);Ha=N<ea(0.0);Ba=O<ea(0.0);Ca=(g[k>>2]=na,c[k>>2]|0);Aa=V?(g[k>>2]=Pa,c[k>>2]|0):La?Ca:0;La=Ga?(g[k>>2]=ka,c[k>>2]|0):ta?Ka:0;ta=Ha?(g[k>>2]=ha,c[k>>2]|0):xa?Ja:0;xa=(g[k>>2]=Ma,c[k>>2]|0);Ha=Ba?(g[k>>2]=ma,c[k>>2]|0):sa?xa:0;sa=P<ea(0.0);Ba=Q<ea(0.0);Ga=R<ea(0.0);V=U<ea(0.0);ma=ea(P*na);ha=ea(Q*la);ka=ea(R*ja);Pa=ea(U*Ma);Da=P>ea(0.0);za=Q>ea(0.0);Y=R>ea(0.0);Ea=U>ea(0.0);wa=Da?(g[k>>2]=ma,c[k>>2]|0):sa?Ca:0;Ca=za?(g[k>>2]=ha,c[k>>2]|0):Ba?Ka:0;Ba=Y?(g[k>>2]=ka,c[k>>2]|0):Ga?Ja:0;Ga=Ea?(g[k>>2]=Pa,c[k>>2]|0):V?xa:0;xa=na<ea(0.0);V=la<ea(0.0);Ea=ja<ea(0.0);Y=Ma<ea(0.0);za=(xa?Aa:wa)|0;wa=(V?La:Ca)|0;Ca=(Ea?ta:Ba)|0;Ba=(Y?Ha:Ga)|0;c[o>>2]=za;c[o+4>>2]=wa;c[o+8>>2]=Ca;c[o+12>>2]=Ba;p$d(n,o);Pa=ea(g[n>>2]);o=(g[k>>2]=Pa,c[k>>2]|0);Pa=(c[k>>2]=o^(g[k>>2]=H,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ka=ea(g[n+4>>2]);o=(g[k>>2]=ka,c[k>>2]|0);ka=(c[k>>2]=o^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ha=ea(g[n+8>>2]);n=(g[k>>2]=ha,c[k>>2]|0);ha=(c[k>>2]=n^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ma=ea(ka-ea(Pa*ha));Na=ea(ea(Pa*ka)+ha);ha=ea(ea(1.0)/ea(T(ea(ea(ea(Na*Na)+ea(1.0))+ea(ea(Pa*Pa)+ea(ma*ma))))));Qa=ea(ha*ma);Ra=ha;Sa=ea(ha*Na);Ta=ea(Pa*ha)}else if((x|0)==1){x=L>ea(0.0);n=M>ea(0.0);o=N>ea(0.0);Ba=O>ea(0.0);ha=ea(-ea(L*na));Pa=ea(-ea(M*la));Na=ea(-ea(N*ja));ma=ea(-ea(O*Ma));Ca=L<ea(0.0);wa=M<ea(0.0);za=N<ea(0.0);Ga=O<ea(0.0);Ha=(g[k>>2]=na,c[k>>2]|0);Y=Ca?(g[k>>2]=ha,c[k>>2]|0):x?Ha:0;x=wa?(g[k>>2]=Pa,c[k>>2]|0):n?Ka:0;n=za?(g[k>>2]=Na,c[k>>2]|0):o?Ja:0;o=(g[k>>2]=Ma,c[k>>2]|0);za=Ga?(g[k>>2]=ma,c[k>>2]|0):Ba?o:0;Ba=P<ea(0.0);Ga=Q<ea(0.0);wa=R<ea(0.0);Ca=U<ea(0.0);ma=ea(P*na);Na=ea(Q*la);Pa=ea(R*ja);ha=ea(U*Ma);ta=P>ea(0.0);Ea=Q>ea(0.0);La=R>ea(0.0);V=U>ea(0.0);Aa=ta?(g[k>>2]=ma,c[k>>2]|0):Ba?Ha:0;Ha=Ea?(g[k>>2]=Na,c[k>>2]|0):Ga?Ka:0;Ga=La?(g[k>>2]=Pa,c[k>>2]|0):wa?Ja:0;wa=V?(g[k>>2]=ha,c[k>>2]|0):Ca?o:0;o=na<ea(0.0);Ca=la<ea(0.0);V=ja<ea(0.0);La=Ma<ea(0.0);Ea=(o?Y:Aa)|0;Aa=(Ca?x:Ha)|0;Ha=(V?n:Ga)|0;Ga=(La?za:wa)|0;c[m>>2]=Ea;c[m+4>>2]=Aa;c[m+8>>2]=Ha;c[m+12>>2]=Ga;p$d(l,m);ha=ea(g[l>>2]);m=(g[k>>2]=ha,c[k>>2]|0);ha=(c[k>>2]=m^(g[k>>2]=H,c[k>>2]|0)&-2147483648,ea(g[k>>2]));Pa=ea(g[l+4>>2]);m=(g[k>>2]=Pa,c[k>>2]|0);Pa=(c[k>>2]=m^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));Na=ea(g[l+8>>2]);l=(g[k>>2]=Na,c[k>>2]|0);Na=(c[k>>2]=l^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ma=ea(Pa+ea(ha*Na));ka=ea(Na-ea(ha*Pa));Pa=ea(ea(1.0)/ea(T(ea(ea(ea(ka*ka)+ea(1.0))+ea(ea(ha*ha)+ea(ma*ma))))));Qa=ea(Pa*ma);Ra=Pa;Sa=ea(Pa*ka);Ta=ea(ha*Pa)}else{l=L>ea(0.0);m=M>ea(0.0);Ga=N>ea(0.0);Ha=O>ea(0.0);Pa=ea(-ea(L*na));ha=ea(-ea(M*la));ka=ea(-ea(N*ja));ma=ea(-ea(O*Ma));Aa=L<ea(0.0);Ea=M<ea(0.0);wa=N<ea(0.0);za=O<ea(0.0);La=(g[k>>2]=na,c[k>>2]|0);n=Aa?(g[k>>2]=Pa,c[k>>2]|0):l?La:0;l=Ea?(g[k>>2]=ha,c[k>>2]|0):m?Ka:0;m=wa?(g[k>>2]=ka,c[k>>2]|0):Ga?Ja:0;Ga=(g[k>>2]=Ma,c[k>>2]|0);wa=za?(g[k>>2]=ma,c[k>>2]|0):Ha?Ga:0;Ha=P<ea(0.0);za=Q<ea(0.0);Ea=R<ea(0.0);Aa=U<ea(0.0);ma=ea(P*na);ka=ea(Q*la);ha=ea(R*ja);Pa=ea(U*Ma);V=P>ea(0.0);x=Q>ea(0.0);Ca=R>ea(0.0);Y=U>ea(0.0);o=V?(g[k>>2]=ma,c[k>>2]|0):Ha?La:0;La=x?(g[k>>2]=ka,c[k>>2]|0):za?Ka:0;Ka=Ca?(g[k>>2]=ha,c[k>>2]|0):Ea?Ja:0;Ja=Y?(g[k>>2]=Pa,c[k>>2]|0):Aa?Ga:0;Ga=na<ea(0.0);Aa=la<ea(0.0);Y=ja<ea(0.0);Ea=Ma<ea(0.0);Ca=(Ga?n:o)|0;o=(Aa?l:La)|0;La=(Y?m:Ka)|0;Ka=(Ea?wa:Ja)|0;c[q>>2]=Ca;c[q+4>>2]=o;c[q+8>>2]=La;c[q+12>>2]=Ka;p$d(p,q);Ma=ea(g[p>>2]);q=(g[k>>2]=Ma,c[k>>2]|0);Ma=(c[k>>2]=q^(g[k>>2]=H,c[k>>2]|0)&-2147483648,ea(g[k>>2]));H=ea(g[p+4>>2]);q=(g[k>>2]=H,c[k>>2]|0);H=(c[k>>2]=q^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));I=ea(g[p+8>>2]);p=(g[k>>2]=I,c[k>>2]|0);I=(c[k>>2]=p^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));J=ea(ea(1.0)/ea(T(ea(ea(ea(Ma*Ma)+ea(H*H))+ea(ea(I*I)+ea(1.0))))));Qa=ea(H*J);Ra=J;Sa=ea(J*I);Ta=ea(Ma*J)}J=ea(-D);D=ea(-E);E=ea(-F);F=ea(ea(ea(ea(G*Ra)-ea(Ta*J))-ea(Sa*E))-ea(Qa*D));Ma=ea(-ea(ea(ea(ea(Sa*D)-ea(Qa*E))-ea(Ra*J))-ea(G*Ta)));I=ea(-ea(ea(ea(ea(Ta*E)-ea(Sa*J))-ea(Ra*D))-ea(G*Qa)));H=ea(-ea(ea(ea(ea(Qa*J)-ea(Ra*E))-ea(G*Sa))-ea(Ta*D)));D=ea(ea(ea(ea(A*Ma)-ea(C*H))-ea(B*F))-ea(z*I));Ta=ea(ea(ea(ea(C*F)-ea(z*Ma))-ea(B*H))-ea(A*I));Sa=ea(ea(ea(ea(B*I)-ea(A*H))-ea(C*Ma))-ea(z*F));G=ea(ea(ea(ea(z*H)-ea(B*Ma))-ea(C*I))-ea(A*F));F=ea(ea(1.0)/ea(T(ea(ea(ea(D*D)+ea(Ta*Ta))+ea(ea(G*G)+ea(Sa*Sa))))));A=ea(-ea(F*G));G=ea(-ea(F*D));D=ea(F*Ta);g[h+(s*48|0)+16>>2]=ea(-ea(F*Sa));g[h+(s*48|0)+20>>2]=A;g[h+(s*48|0)+24>>2]=G;g[h+(s*48|0)+28>>2]=D;h=(c[f>>2]|0)+t|0;c[v>>2]=h;p=(c[u>>2]|0)+a|0;c[X>>2]=p;E$d(h,r,p+(s*48|0)+16|0,s);p=(c[f>>2]|0)+t|0;c[v>>2]=p;z$d(p,b,d,e,s);s=(c[y>>2]|0)+w|0;c[W>>2]=s;g[s+(e*48|0)+16>>2]=aa;g[s+(e*48|0)+20>>2]=ba;g[s+(e*48|0)+24>>2]=ca;g[s+(e*48|0)+28>>2]=da;s=(c[f>>2]|0)+t|0;c[v>>2]=s;B$d(s,d,b,e,e);i=j;return}function h$d(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=0,ha=0,ia=0,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=0,Ga=Im,Ha=0;l=i;i=i+112|0;m=l+32|0;n=l+64|0;o=l+80|0;p=l+96|0;q=l+16|0;r=l;s=l+48|0;t=c[a+(e<<2)+104>>2]|0;e=c[a+(f<<2)+104>>2]|0;f=a+48|0;u=f;v=(c[f>>2]|0)+u|0;w=v+4|0;x=w+(c[w>>2]|0)|0;w=c[x+(t<<3)>>2]|0;y=v+24|0;v=c[x+(t<<3)+4>>2]|0;z=(c[y>>2]|0)+y|0;A=ea(g[z+(v*88|0)>>2]);B=ea(g[z+(v*88|0)+4>>2]);C=ea(g[z+(v*88|0)+8>>2]);D=ea(g[z+(v*88|0)+12>>2]);E=ea(g[z+(v*88|0)+16>>2]);F=ea(g[z+(v*88|0)+20>>2]);G=ea(g[z+(v*88|0)+24>>2]);H=ea(g[z+(v*88|0)+28>>2]);I=ea(g[z+(v*88|0)+32>>2]);J=ea(g[z+(v*88|0)+36>>2]);K=ea(g[z+(v*88|0)+40>>2]);L=ea(g[z+(v*88|0)+64>>2]);M=ea(g[z+(v*88|0)+68>>2]);N=ea(g[z+(v*88|0)+72>>2]);O=ea(g[z+(v*88|0)+76>>2]);y=c[z+(v*88|0)+84>>2]|0;v=c[x+(e<<3)+4>>2]|0;P=ea(g[z+(v*88|0)>>2]);Q=ea(g[z+(v*88|0)+4>>2]);R=ea(g[z+(v*88|0)+8>>2]);U=ea(g[z+(v*88|0)+12>>2]);V=ea(g[z+(v*88|0)+16>>2]);W=ea(g[z+(v*88|0)+20>>2]);X=ea(g[z+(v*88|0)+24>>2]);Y=ea(g[z+(v*88|0)+28>>2]);Z=ea(g[z+(v*88|0)+32>>2]);$=ea(g[z+(v*88|0)+36>>2]);aa=ea(g[z+(v*88|0)+40>>2]);ba=ea(g[z+(v*88|0)+64>>2]);ca=ea(g[z+(v*88|0)+68>>2]);da=ea(g[z+(v*88|0)+72>>2]);fa=ea(g[z+(v*88|0)+76>>2]);x=c[z+(v*88|0)+84>>2]|0;v=d+4|0;z=v;ga=(c[v>>2]|0)+z|0;ha=d+8|0;c[ha>>2]=ga;g[ga+(w*48|0)+16>>2]=ea(0.0);g[ga+(w*48|0)+20>>2]=ea(0.0);g[ga+(w*48|0)+24>>2]=ea(0.0);g[ga+(w*48|0)+28>>2]=ea(1.0);w=(c[f>>2]|0)+u|0;ga=a+52|0;c[ga>>2]=w;z$d(w,b,d,e,t);w=b+4|0;a=w;ia=(c[w>>2]|0)+a|0;ja=b+8|0;c[ja>>2]=ia;ka=ia+(t*48|0)+16|0;c[s+0>>2]=c[ka+0>>2];c[s+4>>2]=c[ka+4>>2];c[s+8>>2]=c[ka+8>>2];c[s+12>>2]=c[ka+12>>2];ka=(c[v>>2]|0)+z|0;c[ha>>2]=ka;la=ea(g[ka+(e*48|0)+16>>2]);ma=ea(g[ka+(e*48|0)+20>>2]);na=ea(g[ka+(e*48|0)+24>>2]);oa=ea(g[ka+(e*48|0)+28>>2]);if((y|0)==1){pa=ea(L*ea(0.0));qa=ea(M*ea(0.0));ra=ea(N*ea(0.0));sa=ea(O*ea(0.0));ka=L>ea(0.0);ia=M>ea(0.0);ta=N>ea(0.0);ua=O>ea(0.0);va=ka?pa:ea(0.0);pa=ia?qa:ea(0.0);qa=ta?ra:ea(0.0);ra=ua?sa:ea(0.0);g[n>>2]=va;g[n+4>>2]=pa;g[n+8>>2]=qa;g[n+12>>2]=ra;p$d(m,n);ra=ea(g[m>>2]);ua=(g[k>>2]=ra,c[k>>2]|0);ra=(c[k>>2]=ua^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));qa=ea(g[m+4>>2]);ua=(g[k>>2]=qa,c[k>>2]|0);qa=(c[k>>2]=ua^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));pa=ea(g[m+8>>2]);ua=(g[k>>2]=pa,c[k>>2]|0);pa=(c[k>>2]=ua^(g[k>>2]=K,c[k>>2]|0)&-2147483648,ea(g[k>>2]));va=ea(qa+ea(ra*pa));sa=ea(pa-ea(ra*qa));qa=ea(ea(1.0)/ea(T(ea(ea(ea(sa*sa)+ea(1.0))+ea(ea(ra*ra)+ea(va*va))))));wa=ea(qa*va);xa=qa;ya=ea(qa*sa);za=ea(ra*qa)}else if((y|0)==2){qa=ea(L*ea(0.0));ra=ea(M*ea(0.0));sa=ea(N*ea(0.0));va=ea(O*ea(0.0));ua=L>ea(0.0);ta=M>ea(0.0);ia=N>ea(0.0);ka=O>ea(0.0);pa=ua?qa:ea(0.0);qa=ta?ra:ea(0.0);ra=ia?sa:ea(0.0);sa=ka?va:ea(0.0);g[p>>2]=pa;g[p+4>>2]=qa;g[p+8>>2]=ra;g[p+12>>2]=sa;p$d(o,p);sa=ea(g[o>>2]);ka=(g[k>>2]=sa,c[k>>2]|0);sa=(c[k>>2]=ka^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));ra=ea(g[o+4>>2]);ka=(g[k>>2]=ra,c[k>>2]|0);ra=(c[k>>2]=ka^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));qa=ea(g[o+8>>2]);ka=(g[k>>2]=qa,c[k>>2]|0);qa=(c[k>>2]=ka^(g[k>>2]=K,c[k>>2]|0)&-2147483648,ea(g[k>>2]));pa=ea(ra-ea(sa*qa));va=ea(ea(sa*ra)+qa);qa=ea(ea(1.0)/ea(T(ea(ea(ea(va*va)+ea(1.0))+ea(ea(sa*sa)+ea(pa*pa))))));wa=ea(qa*pa);xa=qa;ya=ea(qa*va);za=ea(sa*qa)}else if((y|0)==3){qa=ea(ea(.25)-ea(S(ea(ea(0.0)-ea(eEi(ea(0.0)))))));sa=ea(qa*qa);va=ea(qa*ea(ea(ea(sa*ea(-41.2831841))+ea(6.28318548))+ea(ea(sa*sa)*ea(76.0354614))));sa=ea(ea(.25)-ea(S(ea(ea(-.25)-ea(eEi(ea(-.25)))))));qa=ea(sa*sa);pa=ea(sa*ea(ea(ea(qa*ea(-41.2831841))+ea(6.28318548))+ea(ea(qa*qa)*ea(76.0354614))));qa=ea(va*pa);sa=ea(pa*pa);ra=ea(va*va);Aa=ea(ea(va*qa)-ea(pa*qa));wa=ea(ea(ra*pa)+ea(va*sa));xa=ea(ea(va*ra)+ea(pa*sa));ya=Aa;za=Aa}else{Aa=ea(L*ea(0.0));sa=ea(M*ea(0.0));pa=ea(N*ea(0.0));ra=ea(O*ea(0.0));y=L>ea(0.0);ka=M>ea(0.0);ia=N>ea(0.0);ta=O>ea(0.0);O=y?Aa:ea(0.0);Aa=ka?sa:ea(0.0);sa=ia?pa:ea(0.0);pa=ta?ra:ea(0.0);g[r>>2]=O;g[r+4>>2]=Aa;g[r+8>>2]=sa;g[r+12>>2]=pa;p$d(q,r);pa=ea(g[q>>2]);ta=(g[k>>2]=pa,c[k>>2]|0);pa=(c[k>>2]=ta^(g[k>>2]=I,c[k>>2]|0)&-2147483648,ea(g[k>>2]));I=ea(g[q+4>>2]);ta=(g[k>>2]=I,c[k>>2]|0);I=(c[k>>2]=ta^(g[k>>2]=J,c[k>>2]|0)&-2147483648,ea(g[k>>2]));J=ea(g[q+8>>2]);ta=(g[k>>2]=J,c[k>>2]|0);J=(c[k>>2]=ta^(g[k>>2]=K,c[k>>2]|0)&-2147483648,ea(g[k>>2]));K=ea(ea(1.0)/ea(T(ea(ea(ea(pa*pa)+ea(I*I))+ea(ea(J*J)+ea(1.0))))));wa=ea(I*K);xa=K;ya=ea(K*J);za=ea(pa*K)}K=ea(-E);E=ea(-F);F=ea(-G);G=ea(ea(ea(ea(H*xa)-ea(za*K))-ea(ya*F))-ea(wa*E));pa=ea(-ea(ea(ea(ea(ya*E)-ea(wa*F))-ea(xa*K))-ea(H*za)));J=ea(-ea(ea(ea(ea(za*F)-ea(ya*K))-ea(xa*E))-ea(H*wa)));I=ea(-ea(ea(ea(ea(wa*K)-ea(xa*F))-ea(H*ya))-ea(za*E)));E=ea(ea(ea(ea(B*pa)-ea(D*I))-ea(C*G))-ea(A*J));za=ea(ea(ea(ea(D*G)-ea(A*pa))-ea(C*I))-ea(B*J));ya=ea(ea(ea(ea(C*J)-ea(B*I))-ea(D*pa))-ea(A*G));H=ea(ea(ea(ea(A*I)-ea(C*pa))-ea(D*J))-ea(B*G));G=ea(ea(1.0)/ea(T(ea(ea(ea(E*E)+ea(za*za))+ea(ea(H*H)+ea(ya*ya))))));B=ea(-ea(G*ya));ya=ea(-ea(G*H));H=ea(-ea(G*E));E=ea(G*za);if((x|0)==3){za=ea(ea(.25)-ea(S(ea(ea(0.0)-ea(eEi(ea(0.0)))))));G=ea(za*za);J=ea(za*ea(ea(ea(G*ea(-41.2831841))+ea(6.28318548))+ea(ea(G*G)*ea(76.0354614))));G=ea(ea(.25)-ea(S(ea(ea(-.25)-ea(eEi(ea(-.25)))))));za=ea(G*G);D=ea(G*ea(ea(ea(za*ea(-41.2831841))+ea(6.28318548))+ea(ea(za*za)*ea(76.0354614))));za=ea(J*D);G=ea(D*D);pa=ea(J*J);C=ea(ea(J*za)-ea(D*za));Ba=ea(ea(pa*D)+ea(J*G));Ca=ea(ea(J*pa)+ea(D*G));Da=C;Ea=C}else if((x|0)==1){C=ea(ba*ea(0.0));G=ea(ca*ea(0.0));D=ea(da*ea(0.0));pa=ea(fa*ea(0.0));ta=ba>ea(0.0);ia=ca>ea(0.0);ka=da>ea(0.0);y=fa>ea(0.0);J=ta?C:ea(0.0);C=ia?G:ea(0.0);G=ka?D:ea(0.0);D=y?pa:ea(0.0);g[n>>2]=J;g[n+4>>2]=C;g[n+8>>2]=G;g[n+12>>2]=D;p$d(m,n);D=ea(g[m>>2]);n=(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=n^(g[k>>2]=Z,c[k>>2]|0)&-2147483648,ea(g[k>>2]));G=ea(g[m+4>>2]);n=(g[k>>2]=G,c[k>>2]|0);G=(c[k>>2]=n^(g[k>>2]=$,c[k>>2]|0)&-2147483648,ea(g[k>>2]));C=ea(g[m+8>>2]);m=(g[k>>2]=C,c[k>>2]|0);C=(c[k>>2]=m^(g[k>>2]=aa,c[k>>2]|0)&-2147483648,ea(g[k>>2]));J=ea(G+ea(D*C));pa=ea(C-ea(D*G));G=ea(ea(1.0)/ea(T(ea(ea(ea(pa*pa)+ea(1.0))+ea(ea(D*D)+ea(J*J))))));Ba=ea(G*J);Ca=G;Da=ea(G*pa);Ea=ea(D*G)}else if((x|0)==2){G=ea(ba*ea(0.0));D=ea(ca*ea(0.0));pa=ea(da*ea(0.0));J=ea(fa*ea(0.0));x=ba>ea(0.0);m=ca>ea(0.0);n=da>ea(0.0);y=fa>ea(0.0);C=x?G:ea(0.0);G=m?D:ea(0.0);D=n?pa:ea(0.0);pa=y?J:ea(0.0);g[p>>2]=C;g[p+4>>2]=G;g[p+8>>2]=D;g[p+12>>2]=pa;p$d(o,p);pa=ea(g[o>>2]);p=(g[k>>2]=pa,c[k>>2]|0);pa=(c[k>>2]=p^(g[k>>2]=Z,c[k>>2]|0)&-2147483648,ea(g[k>>2]));D=ea(g[o+4>>2]);p=(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=p^(g[k>>2]=$,c[k>>2]|0)&-2147483648,ea(g[k>>2]));G=ea(g[o+8>>2]);o=(g[k>>2]=G,c[k>>2]|0);G=(c[k>>2]=o^(g[k>>2]=aa,c[k>>2]|0)&-2147483648,ea(g[k>>2]));C=ea(D-ea(pa*G));J=ea(ea(pa*D)+G);G=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(1.0))+ea(ea(pa*pa)+ea(C*C))))));Ba=ea(G*C);Ca=G;Da=ea(G*J);Ea=ea(pa*G)}else{G=ea(ba*ea(0.0));pa=ea(ca*ea(0.0));J=ea(da*ea(0.0));C=ea(fa*ea(0.0));o=ba>ea(0.0);p=ca>ea(0.0);y=da>ea(0.0);n=fa>ea(0.0);fa=o?G:ea(0.0);G=p?pa:ea(0.0);pa=y?J:ea(0.0);J=n?C:ea(0.0);g[r>>2]=fa;g[r+4>>2]=G;g[r+8>>2]=pa;g[r+12>>2]=J;p$d(q,r);J=ea(g[q>>2]);r=(g[k>>2]=J,c[k>>2]|0);J=(c[k>>2]=r^(g[k>>2]=Z,c[k>>2]|0)&-2147483648,ea(g[k>>2]));Z=ea(g[q+4>>2]);r=(g[k>>2]=Z,c[k>>2]|0);Z=(c[k>>2]=r^(g[k>>2]=$,c[k>>2]|0)&-2147483648,ea(g[k>>2]));$=ea(g[q+8>>2]);q=(g[k>>2]=$,c[k>>2]|0);$=(c[k>>2]=q^(g[k>>2]=aa,c[k>>2]|0)&-2147483648,ea(g[k>>2]));aa=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(Z*Z))+ea(ea($*$)+ea(1.0))))));Ba=ea(Z*aa);Ca=aa;Da=ea(aa*$);Ea=ea(J*aa)}aa=ea(-V);J=ea(-W);$=ea(-X);Z=ea(ea(ea(ea(Y*Ca)-ea(Ea*aa))-ea(Da*$))-ea(Ba*J));pa=ea(-ea(ea(ea(ea(Da*J)-ea(Ba*$))-ea(Ca*aa))-ea(Y*Ea)));G=ea(-ea(ea(ea(ea(Ea*$)-ea(Da*aa))-ea(Ca*J))-ea(Y*Ba)));fa=ea(-ea(ea(ea(ea(Ba*aa)-ea(Ca*$))-ea(Y*Da))-ea(Ea*J)));Ea=ea(ea(ea(ea(Q*pa)-ea(U*fa))-ea(R*Z))-ea(P*G));Da=ea(ea(ea(ea(U*Z)-ea(P*pa))-ea(R*fa))-ea(Q*G));Ca=ea(ea(ea(ea(R*G)-ea(Q*fa))-ea(U*pa))-ea(P*Z));Ba=ea(ea(ea(ea(P*fa)-ea(R*pa))-ea(U*G))-ea(Q*Z));Z=ea(ea(1.0)/ea(T(ea(ea(ea(Ea*Ea)+ea(Da*Da))+ea(ea(Ba*Ba)+ea(Ca*Ca))))));G=ea(-ea(Z*Ca));Ca=ea(-ea(Z*Ba));Ba=ea(-ea(Z*Ea));Ea=ea(Z*Da);if((j|0)>0){Fa=0;Ga=ea(360.0)}else{i=l;return}while(1){q=(c[w>>2]|0)+a|0;r=q+(e*48|0)+20|0;Da=ea(g[r>>2]);Z=ea(V*Da);n=q+(e*48|0)+28|0;pa=ea(g[n>>2]);fa=ea(Y*pa);y=q+(e*48|0)+24|0;C=ea(g[y>>2]);da=ea(W*C);p=q+(e*48|0)+16|0;ca=ea(g[p>>2]);ba=ea(ea(ea(Z-ea(X*pa))-ea(Y*C))-ea(W*ca));Z=ea(ea(ea(fa-ea(V*ca))-ea(X*C))-ea(W*Da));fa=ea(ea(ea(da-ea(X*Da))-ea(V*pa))-ea(Y*ca));da=ea(ea(ea(ea(X*ca)-ea(V*C))-ea(W*pa))-ea(Y*Da));Da=ea(ea(ea(R*Z)+ea(ea(U*ba)+ea(Q*fa)))-ea(P*da));pa=ea(ea(ea(ea(U*Z)-ea(P*fa))-ea(R*ba))-ea(Q*da));C=ea(ea(P*Z)+ea(ea(U*fa)+ea(ea(R*da)-ea(Q*ba))));ca=ea(ea(Q*Z)+ea(ea(U*da)+ea(ea(P*ba)-ea(R*fa))));fa=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(C*C))+ea(ea(Da*Da)+ea(pa*pa))))));ba=ea(-ea(fa*C));C=ea(fa*pa);o=C==ea(0.0);pa=o?ea(9.99999997e-07):C;C=ea(ba/pa);ba=Ga;Ga=ea(S(ea(ea(ea(+_(+C))*ea(2.0))*ea(57.2957802))));c[ja>>2]=q;if(Ga<h|(Fa|0)>1&Ga>ba){Ha=17;break}ba=ea(ea(-ea(fa*ca))/pa);ca=ea(ea(-ea(fa*Da))/pa);pa=ea(ea(C*C)+ea(1.0));Da=ea(ea(ba-ea(C*ca))/pa);fa=ea(ea(ea(C*ba)+ca)/pa);if(!Fa){g[q+(t*48|0)+16>>2]=B;g[q+(t*48|0)+20>>2]=ya;g[q+(t*48|0)+24>>2]=H;g[q+(t*48|0)+28>>2]=E;c[ja>>2]=q;g[p>>2]=G;g[r>>2]=Ca;g[y>>2]=Ba;g[n>>2]=Ea;o=(c[f>>2]|0)+u|0;c[ga>>2]=o;z$d(o,b,d,e,t)}else{pa=ea(Da+ea(fa*ea(0.0)));ca=ea(fa-ea(Da*ea(0.0)));Da=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(1.0))+ea(ea(pa*pa)+ea(0.0))))));fa=ea(Da*ea(0.0));ba=ea(pa*Da);pa=ea(ca*Da);c[ja>>2]=q;ca=ea(ea(ea(ea(Y*Da)-ea(fa*aa))-ea(pa*$))-ea(ba*J));C=ea(-ea(ea(ea(ea(pa*J)-ea(ba*$))-ea(Da*aa))-ea(Y*fa)));da=ea(-ea(ea(ea(ea(fa*$)-ea(pa*aa))-ea(Da*J))-ea(Y*ba)));Z=ea(-ea(ea(ea(ea(ba*aa)-ea(Da*$))-ea(Y*pa))-ea(fa*J)));fa=ea(ea(ea(ea(Q*C)-ea(U*Z))-ea(R*ca))-ea(P*da));pa=ea(ea(ea(ea(U*ca)-ea(P*C))-ea(R*Z))-ea(Q*da));Da=ea(ea(ea(ea(R*da)-ea(Q*Z))-ea(U*C))-ea(P*ca));ba=ea(ea(ea(ea(P*Z)-ea(R*C))-ea(U*da))-ea(Q*ca));ca=ea(ea(1.0)/ea(T(ea(ea(ea(fa*fa)+ea(pa*pa))+ea(ea(ba*ba)+ea(Da*Da))))));da=ea(-ea(ca*ba));ba=ea(-ea(ca*fa));fa=ea(ca*pa);g[p>>2]=ea(-ea(ca*Da));g[r>>2]=da;g[y>>2]=ba;g[n>>2]=fa;n=(c[f>>2]|0)+u|0;c[ga>>2]=n;z$d(n,b,d,e,e)}n=(c[v>>2]|0)+z|0;c[ha>>2]=n;fa=ea(-ea(g[n+(e*48|0)+16>>2]));ba=ea(-ea(g[n+(e*48|0)+20>>2]));da=ea(-ea(g[n+(e*48|0)+24>>2]));Da=ea(g[n+(e*48|0)+28>>2]);ca=ea(ea(ea(ea(oa*Da)-ea(la*fa))-ea(na*da))-ea(ma*ba));pa=ea(-ea(ea(ea(ea(na*ba)-ea(ma*da))-ea(oa*fa))-ea(la*Da)));C=ea(-ea(ea(ea(ea(la*da)-ea(na*fa))-ea(oa*ba))-ea(ma*Da)));Z=ea(-ea(ea(ea(ea(ma*fa)-ea(oa*da))-ea(na*Da))-ea(la*ba)));n=(c[w>>2]|0)+a|0;y=n+(t*48|0)+16|0;ba=ea(g[y>>2]);Da=ea(ba*C);r=n+(t*48|0)+28|0;da=ea(g[r>>2]);fa=ea(ca*da);p=n+(t*48|0)+20|0;D=ea(g[p>>2]);za=ea(D*Z);q=n+(t*48|0)+24|0;I=ea(g[q>>2]);A=ea(ea(ea(Da-ea(ca*I))-ea(da*Z))-ea(D*pa));Da=ea(ea(ea(fa-ea(ba*pa))-ea(I*Z))-ea(D*C));fa=ea(ea(ea(za-ea(I*C))-ea(ba*ca))-ea(da*pa));za=ea(ea(ea(ea(I*pa)-ea(ba*Z))-ea(ca*D))-ea(da*C));C=ea(ea(1.0)/ea(T(ea(ea(ea(fa*fa)+ea(za*za))+ea(ea(Da*Da)+ea(A*A))))));da=ea(-ea(C*za));za=ea(-ea(C*A));A=ea(C*Da);g[y>>2]=ea(-ea(C*fa));g[p>>2]=da;g[q>>2]=za;g[r>>2]=A;r=(c[f>>2]|0)+u|0;c[ga>>2]=r;c[ja>>2]=n;E$d(r,s,n+(t*48|0)+16|0,t);n=(c[f>>2]|0)+u|0;c[ga>>2]=n;z$d(n,b,d,e,t);n=(c[v>>2]|0)+z|0;c[ha>>2]=n;g[n+(e*48|0)+16>>2]=la;g[n+(e*48|0)+20>>2]=ma;g[n+(e*48|0)+24>>2]=na;g[n+(e*48|0)+28>>2]=oa;n=(c[f>>2]|0)+u|0;c[ga>>2]=n;B$d(n,d,b,e,e);Fa=Fa+1|0;if((Fa|0)>=(j|0)){Ha=17;break}}if((Ha|0)==17){i=l;return}}function i$d(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;j=i;k=c[a+(c[718536+(d<<4)>>2]<<2)+104>>2]|0;l=a+48|0;m=(c[l>>2]|0)+l+4|0;l=c[m+(c[m>>2]|0)+(k<<3)>>2]|0;m=e+4|0;n=(c[m>>2]|0)+m|0;c[e+8>>2]=n;m=f+4|0;o=(c[m>>2]|0)+m|0;c[f+8>>2]=o;p=ea(-ea(g[o+(l*48|0)+16>>2]));q=ea(-ea(g[o+(l*48|0)+20>>2]));r=ea(-ea(g[o+(l*48|0)+24>>2]));s=ea(g[o+(l*48|0)+28>>2]);t=ea(g[b>>2]);u=ea(t*q);v=ea(g[b+12>>2]);w=ea(s*v);x=ea(g[b+4>>2]);y=ea(x*r);z=ea(g[b+8>>2]);A=ea(ea(ea(u-ea(s*z))-ea(v*r))-ea(x*p));u=ea(ea(ea(w-ea(t*p))-ea(z*r))-ea(x*q));w=ea(ea(ea(y-ea(z*q))-ea(s*t))-ea(v*p));y=ea(ea(ea(ea(z*p)-ea(t*r))-ea(s*x))-ea(v*q));q=ea(ea(1.0)/ea(T(ea(ea(ea(w*w)+ea(y*y))+ea(ea(u*u)+ea(A*A))))));v=ea(-ea(q*y));y=ea(-ea(q*A));A=ea(q*u);g[n+(k*48|0)+16>>2]=ea(-ea(q*w));g[n+(k*48|0)+20>>2]=v;g[n+(k*48|0)+24>>2]=y;g[n+(k*48|0)+28>>2]=A;h$d(a,e,h,c[718544+(d<<4)>>2]|0,c[718548+(d<<4)>>2]|0,ea(.0500000007),1);i=j;return}function j$d(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=0,ta=0,ua=0,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0,Ba=0,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;k=i;i=i+192|0;l=k+144|0;m=k+96|0;n=k+48|0;o=k;p=c[a+104>>2]|0;q=ea(g[a+392>>2]);Z_d(f,b,0);r=ea(q*ea(g[f>>2]));s=f+4|0;t=ea(q*ea(g[s>>2]));u=f+8|0;v=ea(q*ea(g[u>>2]));w=f+12|0;x=ea(q*ea(g[w>>2]));g[f>>2]=r;g[s>>2]=t;g[u>>2]=v;g[w>>2]=x;n$d(l,e,f);x=ea(g[l>>2]);v=ea(g[l+4>>2]);t=ea(g[l+8>>2]);r=ea(g[l+12>>2]);g[f>>2]=x;g[s>>2]=v;g[u>>2]=t;g[w>>2]=r;r=ea(g[l+16>>2]);t=ea(g[l+20>>2]);v=ea(g[l+24>>2]);x=ea(g[l+28>>2]);y=f+16|0;g[y>>2]=r;z=f+20|0;g[z>>2]=t;A=f+24|0;g[A>>2]=v;B=f+28|0;g[B>>2]=x;x=ea(g[l+32>>2]);v=ea(g[l+36>>2]);t=ea(g[l+40>>2]);r=ea(g[l+44>>2]);l=f+32|0;g[l>>2]=x;C=f+36|0;g[C>>2]=v;D=f+40|0;g[D>>2]=t;E=f+44|0;g[E>>2]=r;F=(d|0)!=0?d:b;b=m+4|0;G=m+8|0;H=m+12|0;I=m+16|0;J=m+20|0;K=m+24|0;L=m+28|0;M=m+32|0;N=m+36|0;O=m+40|0;P=m+44|0;Q=a+48|0;R=Q;S=0;do{T=f+(S*76|0)+80|0;r=ea(g[F+(S*76|0)+80>>2]);t=ea(g[F+(S*76|0)+84>>2]);v=ea(g[F+(S*76|0)+88>>2]);x=ea(g[F+(S*76|0)+92>>2]);U=f+(S*76|0)+84|0;V=f+(S*76|0)+88|0;W=f+(S*76|0)+92|0;X=ea(g[F+(S*76|0)+96>>2]);Y=ea(g[F+(S*76|0)+100>>2]);Z=ea(g[F+(S*76|0)+104>>2]);_=ea(g[F+(S*76|0)+108>>2]);$=f+(S*76|0)+96|0;g[$>>2]=X;aa=f+(S*76|0)+100|0;g[aa>>2]=Y;ba=f+(S*76|0)+104|0;g[ba>>2]=Z;ca=f+(S*76|0)+108|0;g[ca>>2]=_;_=ea(g[F+(S*76|0)+112>>2]);Z=ea(g[F+(S*76|0)+116>>2]);Y=ea(g[F+(S*76|0)+120>>2]);X=ea(g[F+(S*76|0)+124>>2]);da=f+(S*76|0)+112|0;g[da>>2]=_;fa=f+(S*76|0)+116|0;g[fa>>2]=Z;ga=f+(S*76|0)+120|0;g[ga>>2]=Y;ha=f+(S*76|0)+124|0;g[ha>>2]=X;X=ea(q*t);t=ea(q*v);v=ea(q*x);g[T>>2]=ea(q*r);g[U>>2]=X;g[V>>2]=t;g[W>>2]=v;n$d(m,e,T);v=ea(g[m>>2]);t=ea(g[b>>2]);X=ea(g[G>>2]);r=ea(g[H>>2]);g[T>>2]=v;g[U>>2]=t;g[V>>2]=X;g[W>>2]=r;x=ea(g[I>>2]);Y=ea(g[J>>2]);Z=ea(g[K>>2]);_=ea(g[L>>2]);g[$>>2]=x;g[aa>>2]=Y;g[ba>>2]=Z;g[ca>>2]=_;ia=ea(g[M>>2]);ja=ea(g[N>>2]);ka=ea(g[O>>2]);la=ea(g[P>>2]);g[da>>2]=ia;g[fa>>2]=ja;g[ga>>2]=ka;g[ha>>2]=la;if((S|0)<2){ha=(c[Q>>2]|0)+R|0;ga=ha+24|0;fa=ha+4|0;ma=ea(ea(g[(c[ga>>2]|0)+ga+((c[fa+(c[fa>>2]|0)+(c[a+(((S|0)==0?5:6)<<2)+104>>2]<<3)+4>>2]|0)*88|0)+80>>2])*ia);ia=ea(ja*ea(-0.0));ja=ea(ka*ea(-0.0));ka=ea(ea(-ma)-ma);na=ea(ia+ia);oa=ea(ja+ja);pa=ea(_*ea(0.0));qa=ea(ea(na*x)-ea(ka*Y));ra=ea(ea(oa*Y)-ea(na*Z));na=ea(ea(ka*Z)-ea(x*oa));oa=ea(_*ea(pa-pa));pa=ea(t+ea(ea(ia+ea(_*na))+ea(ea(Z*ra)-ea(x*qa))));ia=ea(X+ea(ea(ja+ea(qa*_))+ea(ea(x*na)-ea(Y*ra))));x=ea(r+ea(ea(ea(la*ea(-0.0))+oa)+ea(oa-oa)));g[T>>2]=ea(v+ea(ea(ea(_*ra)-ma)+ea(ea(Y*qa)-ea(Z*na))));g[U>>2]=pa;g[V>>2]=ia;g[W>>2]=x}S=S+1|0}while((S|0)!=4);S=a+56|0;P=(c[S>>2]|0)+S|0;c[a+60>>2]=P;s$d(P,h);S_d(a,f);T_d(a,f,h);P=(c[Q>>2]|0)+R|0;c[a+52>>2]=P;x$d(P,h,j);R_d(n,a,j);P=h+4|0;R=P;Q=(c[P>>2]|0)+R|0;S=h+8|0;c[S>>2]=Q;O=j+4|0;N=O;M=(c[O>>2]|0)+N|0;L=j+8|0;c[L>>2]=M;o$d(o,n,M+(p*48|0)|0);q=ea(g[o>>2]);x=ea(g[o+4>>2]);ia=ea(g[o+8>>2]);pa=ea(g[o+12>>2]);g[Q+(p*48|0)>>2]=q;g[Q+(p*48|0)+4>>2]=x;g[Q+(p*48|0)+8>>2]=ia;g[Q+(p*48|0)+12>>2]=pa;pa=ea(g[o+16>>2]);ia=ea(g[o+20>>2]);x=ea(g[o+24>>2]);q=ea(g[o+28>>2]);g[Q+(p*48|0)+16>>2]=pa;g[Q+(p*48|0)+20>>2]=ia;g[Q+(p*48|0)+24>>2]=x;g[Q+(p*48|0)+28>>2]=q;q=ea(g[o+32>>2]);x=ea(g[o+36>>2]);ia=ea(g[o+40>>2]);pa=ea(g[o+44>>2]);g[Q+(p*48|0)+32>>2]=q;g[Q+(p*48|0)+36>>2]=x;g[Q+(p*48|0)+40>>2]=ia;g[Q+(p*48|0)+44>>2]=pa;Q=c[P>>2]|0;o=Q+R|0;c[S>>2]=o;M=(c[O>>2]|0)+N|0;c[L>>2]=M;pa=ea(g[M+(p*48|0)+32>>2]);ia=ea(g[M+(p*48|0)+36>>2]);x=ea(g[M+(p*48|0)+40>>2]);q=ea(g[M+(p*48|0)+44>>2]);g[o+(p*48|0)+32>>2]=pa;g[o+(p*48|0)+36>>2]=ia;g[o+(p*48|0)+40>>2]=x;g[o+(p*48|0)+44>>2]=q;if(!d){sa=Q;ta=sa+R|0;ua=ta;c[S>>2]=ua;va=ea(g[f>>2]);wa=ea(g[s>>2]);xa=ea(g[u>>2]);ya=ea(g[w>>2]);g[ua>>2]=va;za=ua+4|0;g[za>>2]=wa;Aa=ua+8|0;g[Aa>>2]=xa;Ba=ua+12|0;g[Ba>>2]=ya;Ca=ea(g[y>>2]);Da=ea(g[z>>2]);Ea=ea(g[A>>2]);Fa=ea(g[B>>2]);Ga=ua+16|0;g[Ga>>2]=Ca;Ha=ua+20|0;g[Ha>>2]=Da;Ia=ua+24|0;g[Ia>>2]=Ea;Ja=ua+28|0;g[Ja>>2]=Fa;Ka=ea(g[l>>2]);La=ea(g[C>>2]);Ma=ea(g[D>>2]);Na=ea(g[E>>2]);Oa=ua+32|0;g[Oa>>2]=Ka;Pa=ua+36|0;g[Pa>>2]=La;Qa=ua+40|0;g[Qa>>2]=Ma;Ra=ua+44|0;g[Ra>>2]=Na;i=k;return}else Sa=0;do{g[f+(Sa<<2)+672>>2]=ea(g[d+(Sa<<2)+672>>2]);Sa=Sa+1|0}while((Sa|0)!=52);K_d(d+384|0,f+384|0);K_d(d+528|0,f+528|0);S_d(a,f);T_d(a,f,h);sa=c[P>>2]|0;ta=sa+R|0;ua=ta;c[S>>2]=ua;va=ea(g[f>>2]);wa=ea(g[s>>2]);xa=ea(g[u>>2]);ya=ea(g[w>>2]);g[ua>>2]=va;za=ua+4|0;g[za>>2]=wa;Aa=ua+8|0;g[Aa>>2]=xa;Ba=ua+12|0;g[Ba>>2]=ya;Ca=ea(g[y>>2]);Da=ea(g[z>>2]);Ea=ea(g[A>>2]);Fa=ea(g[B>>2]);Ga=ua+16|0;g[Ga>>2]=Ca;Ha=ua+20|0;g[Ha>>2]=Da;Ia=ua+24|0;g[Ia>>2]=Ea;Ja=ua+28|0;g[Ja>>2]=Fa;Ka=ea(g[l>>2]);La=ea(g[C>>2]);Ma=ea(g[D>>2]);Na=ea(g[E>>2]);Oa=ua+32|0;g[Oa>>2]=Ka;Pa=ua+36|0;g[Pa>>2]=La;Qa=ua+40|0;g[Qa>>2]=Ma;Ra=ua+44|0;g[Ra>>2]=Na;i=k;return}function k$d(a,b,c,d,e,f,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;i=ea(g[f>>2]);j=ea(g[c>>2]);k=ea(i-j);l=ea(g[f+4>>2]);m=ea(g[c+4>>2]);n=ea(l-m);o=ea(g[f+8>>2]);p=ea(g[c+8>>2]);q=ea(o-p);r=ea(g[f+12>>2]);s=ea(g[c+12>>2]);t=ea(r-s);u=ea(T(ea(ea(ea(k*k)+ea(n*n))+ea(ea(q*q)+ea(t*t)))));t=ea(g[b>>2]);q=ea(i-t);i=ea(g[b+4>>2]);n=ea(l-i);l=ea(g[b+8>>2]);k=ea(o-l);o=ea(g[b+12>>2]);v=ea(r-o);r=ea(u*ea(g[e>>2]));w=ea(u*ea(g[e+4>>2]));x=ea(u*ea(g[e+8>>2]));y=ea(u*ea(g[e+12>>2]));u=ea(r+r);z=ea(w+w);A=ea(x+x);B=ea(g[d>>2]);C=ea(z*B);D=ea(g[d+4>>2]);E=ea(A*D);F=ea(g[d+8>>2]);G=ea(u*F);H=ea(g[d+12>>2]);I=ea(H*ea(0.0));J=ea(C-ea(u*D));u=ea(E-ea(z*F));z=ea(G-ea(A*B));A=ea(H*ea(I-I));I=ea(ea(j-ea(ea(r+ea(H*u))+ea(ea(D*J)-ea(F*z))))-t);t=ea(ea(m-ea(ea(w+ea(H*z))+ea(ea(F*u)-ea(B*J))))-i);i=ea(ea(p-ea(ea(x+ea(J*H))+ea(ea(B*z)-ea(D*u))))-l);l=ea(ea(s-ea(ea(y+A)+ea(A-A)))-o);o=ea(ea(n*I)-ea(q*t));A=ea(ea(k*t)-ea(n*i));y=ea(ea(q*i)-ea(k*I));s=ea(ea(T(ea(ea(ea(ea(q*q)+ea(n*n))+ea(ea(k*k)+ea(v*v)))*ea(ea(ea(I*I)+ea(t*t))+ea(ea(i*i)+ea(l*l))))))+ea(ea(ea(q*I)+ea(n*t))+ea(ea(k*i)+ea(v*l))));l=ea(ea(1.0)/ea(T(ea(ea(ea(A*A)+ea(y*y))+ea(ea(o*o)+ea(s*s))))));v=ea(l*A);A=ea(l*y);y=ea(l*o);o=ea(l*s);s=ea(g[h>>2]);l=ea(s*v);v=ea(s*A);A=ea(s*y);y=ea(ea(1.0)/ea(T(ea(ea(ea(l*l)+ea(v*v))+ea(ea(A*A)+ea(o*o))))));s=ea(y*v);v=ea(y*A);A=ea(y*o);g[a>>2]=ea(y*l);g[a+4>>2]=s;g[a+8>>2]=v;g[a+12>>2]=A;return}function l$d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,W=0,X=0,Y=0,Z=0,_=Im,$=0,aa=Im,ba=Im,ca=Im,da=Im,fa=0,ga=Im,ha=Im,ia=0,ja=0,ka=0,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=Im,Ka=Im,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;h=i;i=i+464|0;j=h+456|0;l=h+400|0;m=h+176|0;n=h+212|0;o=h+216|0;p=h+64|0;q=h+80|0;r=h+96|0;s=h+112|0;t=h+128|0;u=h+144|0;v=h+160|0;w=h+352|0;x=h+384|0;y=h+408|0;z=h+440|0;A=h+460|0;B=h+232|0;C=h+248|0;D=h+264|0;E=h+280|0;F=h+296|0;G=h+304|0;H=h+48|0;I=h+16|0;J=h;K=h+32|0;L=h+320|0;M=h+336|0;N=h+192|0;O=h+368|0;P=h+208|0;Q=h+424|0;R=c[a+104>>2]|0;S=c[a+136>>2]|0;U=c[a+132>>2]|0;W=c[a+140>>2]|0;X=c[a+144>>2]|0;Y=c[a+188>>2]|0;Z=c[a+192>>2]|0;_=ea(g[b+64>>2]);$=_<ea(0.0);aa=$?ea(0.0):_;_=ea(g[b+68>>2]);$=_<ea(0.0);ba=$?ea(0.0):_;_=ea(g[b+72>>2]);$=_<ea(0.0);ca=$?ea(0.0):_;_=ea(g[b+76>>2]);$=_<ea(0.0);da=$?ea(0.0):_;$=aa>ea(1.0);_=$?ea(1.0):aa;$=ba>ea(1.0);aa=$?ea(1.0):ba;$=ca>ea(1.0);ba=$?ea(1.0):ca;$=da>ea(1.0);ca=$?ea(1.0):da;g[j>>2]=aa;g[l>>2]=ca;$=b+48|0;c[m+0>>2]=c[$+0>>2];c[m+4>>2]=c[$+4>>2];c[m+8>>2]=c[$+8>>2];c[m+12>>2]=c[$+12>>2];if(_>ea(0.0)){$=e+4|0;fa=(c[$>>2]|0)+$|0;$=e+8|0;c[$>>2]=fa;ca=ea(g[fa+(X*48|0)>>2]);da=ea(g[fa+(X*48|0)+4>>2]);ga=ea(g[fa+(X*48|0)+8>>2]);ha=ea(g[fa+(X*48|0)+12>>2]);c[$>>2]=fa;ia=a+48|0;ja=(c[ia>>2]|0)+ia|0;ia=ja+24|0;ka=ja+4|0;ja=c[ka+(c[ka>>2]|0)+(X<<3)+4>>2]|0;ka=ia+(c[ia>>2]|0)|0;la=ea(g[ka+(ja*88|0)+16>>2]);ma=ea(g[ka+(ja*88|0)+20>>2]);na=ea(g[ka+(ja*88|0)+24>>2]);oa=ea(g[ka+(ja*88|0)+28>>2]);pa=ea(g[fa+(X*48|0)+20>>2]);qa=ea(la*pa);ra=ea(g[fa+(X*48|0)+28>>2]);sa=ea(oa*ra);ta=ea(g[fa+(X*48|0)+24>>2]);ua=ea(ma*ta);va=ea(g[fa+(X*48|0)+16>>2]);wa=ea(ea(ea(qa-ea(na*ra))-ea(oa*ta))-ea(ma*va));qa=ea(ea(ea(sa-ea(la*va))-ea(na*ta))-ea(ma*pa));sa=ea(ea(ea(ua-ea(na*pa))-ea(la*ra))-ea(oa*va));ua=ea(ea(ea(ea(na*va)-ea(la*ta))-ea(ma*ra))-ea(oa*pa));oa=ea(ea(1.0)/ea(T(ea(ea(ea(sa*sa)+ea(ua*ua))+ea(ea(wa*wa)+ea(qa*qa))))));ma=ea(oa*sa);sa=ea(-ma);la=ea(oa*ua);ua=ea(-la);na=ea(wa*oa);wa=ea(-na);xa=ea(oa*qa);if((Y|0)!=-1&(Z|0)!=-1){c[$>>2]=fa;$=a+56|0;ja=(c[$>>2]|0)+$+4|0;$=ja+(c[ja>>2]|0)|0;qa=ea(g[$+(Y*48|0)>>2]);oa=ea(qa+ea(g[$+(Z*48|0)>>2]));qa=ea(g[$+(Y*48|0)+4>>2]);ya=ea(qa+ea(g[$+(Z*48|0)+4>>2]));qa=ea(g[$+(Y*48|0)+8>>2]);za=ea(qa+ea(g[$+(Z*48|0)+8>>2]));qa=ea(g[$+(Y*48|0)+12>>2]);Aa=ea(oa*ea(.5));oa=ea(ya*ea(.5));ya=ea(za*ea(.5));za=ea(ea(qa+ea(g[$+(Z*48|0)+12>>2]))*ea(.5));qa=ea(Aa*ea(g[fa+(X*48|0)+32>>2]));Aa=ea(oa*ea(g[fa+(X*48|0)+36>>2]));oa=ea(ya*ea(g[fa+(X*48|0)+40>>2]));ya=ea(qa+qa);Ba=ea(Aa+Aa);Ca=ea(oa+oa);Da=ea(ra*ea(0.0));Ea=ea(ea(Ba*va)-ea(ya*pa));Fa=ea(ea(Ca*pa)-ea(Ba*ta));Ba=ea(ea(ya*ta)-ea(Ca*va));Ca=ea(ra*ea(Da-Da));Ga=ea(ca+ea(ea(qa+ea(ra*Fa))+ea(ea(pa*Ea)-ea(ta*Ba))));Ha=ea(da+ea(ea(Aa+ea(ra*Ba))+ea(ea(ta*Fa)-ea(va*Ea))));Ia=ea(ga+ea(ea(oa+ea(Ea*ra))+ea(ea(va*Ba)-ea(pa*Fa))));Ja=ea(ha+ea(ea(ea(za*ea(g[fa+(X*48|0)+44>>2]))+Ca)+ea(Ca-Ca)))}else{Ga=ca;Ha=da;Ia=ga;Ja=ha}ha=ea(ea(g[m>>2])-Ga);fa=m+4|0;ga=ea(ea(g[fa>>2])-Ha);$=m+8|0;da=ea(ea(g[$>>2])-Ia);ja=m+12|0;ca=ea(ea(g[ja>>2])-Ja);Ca=ea(ea(ea(ha*ha)+ea(ga*ga))+ea(ea(da*da)+ea(ca*ca)));za=ea(T(ea(Ca)));Fa=ea(ea(-za)-za);pa=ea(la*ea(-0.0));la=ea(xa*ea(0.0));Ba=ea(ea(Fa*sa)-pa);va=ea(pa-ea(Fa*wa));Fa=ea(ea(na*ea(-0.0))-ea(ma*ea(-0.0)));ma=ea(xa*ea(la-la));la=ea(ea(ea(xa*va)+ea(0.0))+ea(ea(Ba*ua)-ea(Fa*wa)));na=ea(ea(ea(xa*Fa)-za)+ea(ea(va*wa)-ea(Ba*sa)));wa=ea(ea(ea(xa*Ba)+ea(0.0))+ea(ea(Fa*sa)-ea(va*ua)));ua=ea(ea(ma+ea(0.0))+ea(ma-ma));ma=ea(ea(ga*la)-ea(ha*na));va=ea(ea(da*na)-ea(ga*wa));sa=ea(ea(ha*wa)-ea(da*la));Fa=ea(ea(T(ea(Ca*ea(ea(ea(la*la)+ea(na*na))+ea(ea(ua*ua)+ea(wa*wa))))))+ea(ea(ea(ha*la)+ea(ga*na))+ea(ea(ua*ca)+ea(da*wa))));da=ea(ea(1.0)/ea(T(ea(ea(ea(va*va)+ea(sa*sa))+ea(ea(ma*ma)+ea(Fa*Fa))))));ca=ea(da*va);va=ea(da*sa);sa=ea(da*ma);ma=ea(da*Fa);Fa=ea(+V(+ea(ea(ea(ea(ea(1.0)-_)*ea(180.0))*ea(.0174532924))*ea(.5))));_=ea(ea(1.0)/ea(T(ea(ea(ea(ca*ca)+ea(va*va))+ea(ea(sa*sa)+ea(ma*ma))))));da=ea(_*ca);ga=ea(_*va);ha=ea(_*sa);Ca=ea(_*ma);_=ea(-Ca);ka=Ca<ea(0.0);Ba=ka?_:Ca;if(Ba<Fa){Ca=ea(-ha);_=ea(-ga);xa=ea(-da);za=ea(ea(Fa-Ba)/Fa);Ba=ea(ea(1.0)-za);Ka=ea((ka?xa:da)*Ba);La=ea((ka?_:ga)*Ba);Ma=ea((ka?Ca:ha)*Ba);Na=ea(Fa+ea(ea(ea(1.0)-Fa)*za))}else{Ka=ca;La=va;Ma=sa;Na=ma}ma=ea(la+la);sa=ea(na+na);va=ea(wa+wa);ca=ea(Na*ea(0.0));za=ea(ea(sa*Ka)-ea(ma*La));Fa=ea(ea(va*La)-ea(sa*Ma));sa=ea(ea(ma*Ma)-ea(va*Ka));va=ea(Na*ea(ca-ca));ca=ea(Ha+ea(ea(na+ea(Na*sa))+ea(ea(Ma*Fa)-ea(Ka*za))));na=ea(Ia+ea(ea(wa+ea(Na*za))+ea(ea(Ka*sa)-ea(La*Fa))));Ka=ea(Ja+ea(ea(ua+va)+ea(va-va)));g[m>>2]=ea(Ga+ea(ea(la+ea(Na*Fa))+ea(ea(La*za)-ea(Ma*sa))));g[fa>>2]=ca;g[$>>2]=na;g[ja>>2]=Ka;Oa=ea(g[j>>2])}else Oa=aa;if(Oa>ea(0.0)?(aa=ea(Oa*ea(.5)),ja=(S|0)!=-1,g[n>>2]=ja?aa:Oa,$=e+4|0,fa=$,ka=(c[$>>2]|0)+fa|0,ia=e+8|0,c[ia>>2]=ka,Pa=ka+(X*48|0)|0,c[o+0>>2]=c[Pa+0>>2],c[o+4>>2]=c[Pa+4>>2],c[o+8>>2]=c[Pa+8>>2],c[o+12>>2]=c[Pa+12>>2],c[ia>>2]=ka,Pa=a+48|0,Qa=Pa,Ra=(c[Pa>>2]|0)+Qa|0,Sa=Ra+24|0,Ta=Ra+4|0,Ra=c[Ta+(c[Ta>>2]|0)+(X<<3)+4>>2]|0,Ta=Sa+(c[Sa>>2]|0)|0,Oa=ea(g[Ta+(Ra*88|0)+16>>2]),aa=ea(g[Ta+(Ra*88|0)+20>>2]),Ka=ea(g[Ta+(Ra*88|0)+24>>2]),na=ea(g[Ta+(Ra*88|0)+28>>2]),ca=ea(g[ka+(X*48|0)+20>>2]),sa=ea(Oa*ca),Ma=ea(g[ka+(X*48|0)+28>>2]),za=ea(na*Ma),La=ea(g[ka+(X*48|0)+24>>2]),Fa=ea(aa*La),Na=ea(g[ka+(X*48|0)+16>>2]),la=ea(ea(ea(sa-ea(Ka*Ma))-ea(na*La))-ea(aa*Na)),sa=ea(ea(ea(za-ea(Oa*Na))-ea(Ka*La))-ea(aa*ca)),za=ea(ea(ea(Fa-ea(Ka*ca))-ea(Oa*Ma))-ea(na*Na)),Fa=ea(ea(ea(ea(Ka*Na)-ea(Oa*La))-ea(aa*Ma))-ea(na*ca)),ca=ea(ea(1.0)/ea(T(ea(ea(ea(za*za)+ea(Fa*Fa))+ea(ea(la*la)+ea(sa*sa)))))),na=ea(-ea(ca*Fa)),Fa=ea(-ea(la*ca)),la=ea(ca*sa),g[p>>2]=ea(-ea(ca*za)),g[p+4>>2]=na,g[p+8>>2]=Fa,g[p+12>>2]=la,c[ia>>2]=ka,g[r>>2]=ea(0.0),g[r+4>>2]=ea(1.0),g[r+8>>2]=ea(0.0),g[r+12>>2]=ea(0.0),k$d(q,ka+(U*48|0)|0,o,p,r,m,n),n=(c[$>>2]|0)+fa|0,c[ia>>2]=n,la=ea(g[q+4>>2]),r=n+(U*48|0)+16|0,Fa=ea(g[r>>2]),na=ea(la*Fa),za=ea(g[q+12>>2]),p=n+(U*48|0)+28|0,ca=ea(g[p>>2]),sa=ea(za*ca),Ma=ea(g[q+8>>2]),o=n+(U*48|0)+20|0,aa=ea(g[o>>2]),La=ea(Ma*aa),Oa=ea(g[q>>2]),q=n+(U*48|0)+24|0,Na=ea(g[q>>2]),Ka=ea(ea(ea(na-ea(za*Na))-ea(ca*Ma))-ea(aa*Oa)),na=ea(ea(ea(sa-ea(Fa*Oa))-ea(Ma*Na))-ea(la*aa)),sa=ea(ea(ea(La-ea(la*Na))-ea(Fa*za))-ea(ca*Oa)),La=ea(ea(ea(ea(Oa*Na)-ea(Fa*Ma))-ea(za*aa))-ea(la*ca)),ca=ea(ea(1.0)/ea(T(ea(ea(ea(sa*sa)+ea(La*La))+ea(ea(na*na)+ea(Ka*Ka)))))),la=ea(-ea(ca*La)),La=ea(-ea(ca*Ka)),Ka=ea(ca*na),g[r>>2]=ea(-ea(ca*sa)),g[o>>2]=la,g[q>>2]=La,g[p>>2]=Ka,p=(c[Pa>>2]|0)+Qa|0,q=a+52|0,c[q>>2]=p,B$d(p,e,d,U,U),ja):0){ja=(c[Pa>>2]|0)+Qa|0;c[q>>2]=ja;y$d(ja,d,e,X,U);ja=(c[$>>2]|0)+fa|0;c[ia>>2]=ja;p=ja+(X*48|0)|0;c[s+0>>2]=c[p+0>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2];c[s+12>>2]=c[p+12>>2];c[ia>>2]=ja;p=(c[Pa>>2]|0)+Qa|0;o=p+24|0;r=p+4|0;p=c[r+(c[r>>2]|0)+(X<<3)+4>>2]|0;r=o+(c[o>>2]|0)|0;Ka=ea(g[r+(p*88|0)+16>>2]);La=ea(g[r+(p*88|0)+20>>2]);la=ea(g[r+(p*88|0)+24>>2]);sa=ea(g[r+(p*88|0)+28>>2]);ca=ea(g[ja+(X*48|0)+20>>2]);na=ea(Ka*ca);aa=ea(g[ja+(X*48|0)+28>>2]);za=ea(sa*aa);Ma=ea(g[ja+(X*48|0)+24>>2]);Fa=ea(La*Ma);Na=ea(g[ja+(X*48|0)+16>>2]);Oa=ea(ea(ea(na-ea(la*aa))-ea(sa*Ma))-ea(La*Na));na=ea(ea(ea(za-ea(Ka*Na))-ea(la*Ma))-ea(La*ca));za=ea(ea(ea(Fa-ea(la*ca))-ea(Ka*aa))-ea(sa*Na));Fa=ea(ea(ea(ea(la*Na)-ea(Ka*Ma))-ea(La*aa))-ea(sa*ca));ca=ea(ea(1.0)/ea(T(ea(ea(ea(za*za)+ea(Fa*Fa))+ea(ea(Oa*Oa)+ea(na*na))))));sa=ea(-ea(ca*Fa));Fa=ea(-ea(Oa*ca));Oa=ea(ca*na);g[t>>2]=ea(-ea(ca*za));g[t+4>>2]=sa;g[t+8>>2]=Fa;g[t+12>>2]=Oa;c[ia>>2]=ja;g[v>>2]=ea(0.0);g[v+4>>2]=ea(1.0);g[v+8>>2]=ea(0.0);g[v+12>>2]=ea(0.0);k$d(u,ja+(S*48|0)|0,s,t,v,m,j);j=(c[$>>2]|0)+fa|0;c[ia>>2]=j;Oa=ea(g[u+4>>2]);ia=j+(S*48|0)+16|0;Fa=ea(g[ia>>2]);sa=ea(Oa*Fa);za=ea(g[u+12>>2]);fa=j+(S*48|0)+28|0;ca=ea(g[fa>>2]);na=ea(za*ca);aa=ea(g[u+8>>2]);$=j+(S*48|0)+20|0;La=ea(g[$>>2]);Ma=ea(aa*La);Ka=ea(g[u>>2]);u=j+(S*48|0)+24|0;Na=ea(g[u>>2]);la=ea(ea(ea(sa-ea(za*Na))-ea(ca*aa))-ea(La*Ka));sa=ea(ea(ea(na-ea(Fa*Ka))-ea(aa*Na))-ea(Oa*La));na=ea(ea(ea(Ma-ea(Oa*Na))-ea(Fa*za))-ea(ca*Ka));Ma=ea(ea(ea(ea(Ka*Na)-ea(Fa*aa))-ea(za*La))-ea(Oa*ca));ca=ea(ea(1.0)/ea(T(ea(ea(ea(na*na)+ea(Ma*Ma))+ea(ea(sa*sa)+ea(la*la))))));Oa=ea(-ea(ca*Ma));Ma=ea(-ea(ca*la));la=ea(ca*sa);g[ia>>2]=ea(-ea(ca*na));g[$>>2]=Oa;g[u>>2]=Ma;g[fa>>2]=la;fa=(c[Pa>>2]|0)+Qa|0;c[q>>2]=fa;B$d(fa,e,d,S,S)}if(ba>ea(0.0)){S=a+48|0;fa=S;q=(c[S>>2]|0)+fa|0;Qa=a+52|0;c[Qa>>2]=q;y$d(q,d,e,X,U);q=e+4|0;Pa=q;if((W|0)==-1)Ua=e+8|0;else{u=c[q>>2]|0;$=u+Pa|0;ia=e+8|0;c[ia>>2]=$;j=$+(X*48|0)|0;c[w+0>>2]=c[j+0>>2];c[w+4>>2]=c[j+4>>2];c[w+8>>2]=c[j+8>>2];c[w+12>>2]=c[j+12>>2];c[ia>>2]=$;j=(c[S>>2]|0)+fa|0;v=j+24|0;t=j+4|0;j=c[t+(c[t>>2]|0)+(X<<3)+4>>2]|0;t=v+(c[v>>2]|0)|0;la=ea(g[t+(j*88|0)+16>>2]);Ma=ea(g[t+(j*88|0)+20>>2]);Oa=ea(g[t+(j*88|0)+24>>2]);na=ea(g[t+(j*88|0)+28>>2]);j=$+(X*48|0)+20|0;ca=ea(g[j>>2]);sa=ea(la*ca);t=$+(X*48|0)+28|0;La=ea(g[t>>2]);za=ea(na*La);v=$+(X*48|0)+24|0;aa=ea(g[v>>2]);Fa=ea(Ma*aa);s=$+(X*48|0)+16|0;Na=ea(g[s>>2]);Ka=ea(ea(ea(sa-ea(Oa*La))-ea(na*aa))-ea(Ma*Na));sa=ea(ea(ea(za-ea(la*Na))-ea(Oa*aa))-ea(Ma*ca));za=ea(ea(ea(Fa-ea(Oa*ca))-ea(la*La))-ea(na*Na));Fa=ea(ea(ea(ea(Oa*Na)-ea(la*aa))-ea(Ma*La))-ea(na*ca));ca=ea(ea(1.0)/ea(T(ea(ea(ea(za*za)+ea(Fa*Fa))+ea(ea(Ka*Ka)+ea(sa*sa))))));na=ea(-ea(ca*Fa));Fa=ea(-ea(Ka*ca));Ka=ea(ca*sa);g[x>>2]=ea(-ea(ca*za));g[x+4>>2]=na;g[x+8>>2]=Fa;g[x+12>>2]=Ka;if((Y|0)!=-1&(Z|0)!=-1){c[ia>>2]=$;ja=a+56|0;p=(c[ja>>2]|0)+ja+4|0;ja=p+(c[p>>2]|0)|0;Ka=ea(g[ja+(Y*48|0)>>2]);Fa=ea(Ka+ea(g[ja+(Z*48|0)>>2]));Ka=ea(g[ja+(Y*48|0)+4>>2]);na=ea(Ka+ea(g[ja+(Z*48|0)+4>>2]));Ka=ea(g[ja+(Y*48|0)+8>>2]);za=ea(Ka+ea(g[ja+(Z*48|0)+8>>2]));Ka=ea(g[ja+(Y*48|0)+12>>2]);ca=ea(Fa*ea(.5));Fa=ea(na*ea(.5));na=ea(za*ea(.5));za=ea(ea(Ka+ea(g[ja+(Z*48|0)+12>>2]))*ea(.5));Ka=ea(ca*ea(g[$+(X*48|0)+32>>2]));ca=ea(Fa*ea(g[$+(X*48|0)+36>>2]));Fa=ea(na*ea(g[$+(X*48|0)+40>>2]));na=ea(za*ea(g[$+(X*48|0)+44>>2]));za=ea(Ka+Ka);sa=ea(ca+ca);La=ea(Fa+Fa);Ma=ea(g[s>>2]);aa=ea(sa*Ma);la=ea(g[j>>2]);Na=ea(La*la);Oa=ea(g[v>>2]);Ga=ea(za*Oa);va=ea(g[t>>2]);ua=ea(va*ea(0.0));Ja=ea(aa-ea(za*la));za=ea(Na-ea(sa*Oa));sa=ea(Ga-ea(La*Ma));La=ea(va*ea(ua-ua));ua=ea(ea(Ka+ea(va*za))+ea(ea(la*Ja)-ea(Oa*sa)));Ka=ea(ea(ca+ea(va*sa))+ea(ea(Oa*za)-ea(Ma*Ja)));Oa=ea(ea(Fa+ea(Ja*va))+ea(ea(Ma*sa)-ea(la*za)));za=ea(ea(na+La)+ea(La-La));La=ea(ea(g[$+(X*48|0)>>2])+ua);ua=ea(ea(g[$+(X*48|0)+4>>2])+Ka);Ka=ea(ea(g[$+(X*48|0)+8>>2])+Oa);Oa=ea(ea(g[$+(X*48|0)+12>>2])+za);g[w>>2]=La;g[w+4>>2]=ua;g[w+8>>2]=Ka;g[w+12>>2]=Oa;Va=c[q>>2]|0}else Va=u;u=Va+Pa|0;c[ia>>2]=u;g[z>>2]=ea(0.0);g[z+4>>2]=ea(1.0);g[z+8>>2]=ea(0.0);g[z+12>>2]=ea(0.0);g[A>>2]=ea(ba*ea(.5));k$d(y,u+(W*48|0)|0,w,x,z,m,A);A=(c[q>>2]|0)+Pa|0;c[ia>>2]=A;Oa=ea(g[y+4>>2]);z=A+(W*48|0)+16|0;Ka=ea(g[z>>2]);ua=ea(Oa*Ka);La=ea(g[y+12>>2]);x=A+(W*48|0)+28|0;za=ea(g[x>>2]);na=ea(La*za);la=ea(g[y+8>>2]);w=A+(W*48|0)+20|0;sa=ea(g[w>>2]);Ma=ea(la*sa);va=ea(g[y>>2]);y=A+(W*48|0)+24|0;Ja=ea(g[y>>2]);Fa=ea(ea(ea(ua-ea(La*Ja))-ea(za*la))-ea(sa*va));ua=ea(ea(ea(na-ea(Ka*va))-ea(la*Ja))-ea(Oa*sa));na=ea(ea(ea(Ma-ea(Oa*Ja))-ea(Ka*La))-ea(za*va));Ma=ea(ea(ea(ea(va*Ja)-ea(Ka*la))-ea(La*sa))-ea(Oa*za));za=ea(ea(1.0)/ea(T(ea(ea(ea(na*na)+ea(Ma*Ma))+ea(ea(ua*ua)+ea(Fa*Fa))))));Oa=ea(-ea(za*Ma));Ma=ea(-ea(za*Fa));Fa=ea(za*ua);g[z>>2]=ea(-ea(za*na));g[w>>2]=Oa;g[y>>2]=Ma;g[x>>2]=Fa;x=(c[S>>2]|0)+fa|0;c[Qa>>2]=x;B$d(x,e,d,W,W);Ua=ia}ia=C+4|0;W=C+8|0;x=C+12|0;y=(Y|0)!=-1&(Z|0)!=-1;w=a+56|0;z=w;A=B+4|0;u=B+8|0;Va=B+12|0;$=E+4|0;t=E+8|0;v=E+12|0;Fa=ea(ba*ba);j=D+4|0;s=D+12|0;ja=D+8|0;p=0;do{r=c[q>>2]|0;o=r+Pa|0;c[Ua>>2]=o;n=o+(X*48|0)|0;c[B+0>>2]=c[n+0>>2];c[B+4>>2]=c[n+4>>2];c[B+8>>2]=c[n+8>>2];c[B+12>>2]=c[n+12>>2];c[Ua>>2]=o;n=(c[S>>2]|0)+fa|0;ka=n+24|0;Ra=n+4|0;n=c[Ra+(c[Ra>>2]|0)+(X<<3)+4>>2]|0;Ra=ka+(c[ka>>2]|0)|0;ba=ea(g[Ra+(n*88|0)+16>>2]);Ma=ea(g[Ra+(n*88|0)+20>>2]);Oa=ea(g[Ra+(n*88|0)+24>>2]);na=ea(g[Ra+(n*88|0)+28>>2]);n=o+(X*48|0)+20|0;za=ea(g[n>>2]);ua=ea(ba*za);Ra=o+(X*48|0)+28|0;sa=ea(g[Ra>>2]);La=ea(na*sa);ka=o+(X*48|0)+24|0;la=ea(g[ka>>2]);Ka=ea(Ma*la);Ta=o+(X*48|0)+16|0;Ja=ea(g[Ta>>2]);va=ea(ea(ea(ua-ea(Oa*sa))-ea(na*la))-ea(Ma*Ja));ua=ea(ea(ea(La-ea(ba*Ja))-ea(Oa*la))-ea(Ma*za));La=ea(ea(ea(Ka-ea(Oa*za))-ea(ba*sa))-ea(na*Ja));Ka=ea(ea(ea(ea(Oa*Ja)-ea(ba*la))-ea(Ma*sa))-ea(na*za));za=ea(ea(1.0)/ea(T(ea(ea(ea(La*La)+ea(Ka*Ka))+ea(ea(va*va)+ea(ua*ua))))));na=ea(-ea(za*Ka));Ka=ea(-ea(va*za));va=ea(za*ua);g[C>>2]=ea(-ea(za*La));g[ia>>2]=na;g[W>>2]=Ka;g[x>>2]=va;if(y){c[Ua>>2]=o;Sa=(c[w>>2]|0)+z+4|0;Wa=Sa+(c[Sa>>2]|0)|0;va=ea(g[Wa+(Y*48|0)>>2]);Ka=ea(va+ea(g[Wa+(Z*48|0)>>2]));va=ea(g[Wa+(Y*48|0)+4>>2]);na=ea(va+ea(g[Wa+(Z*48|0)+4>>2]));va=ea(g[Wa+(Y*48|0)+8>>2]);La=ea(va+ea(g[Wa+(Z*48|0)+8>>2]));va=ea(g[Wa+(Y*48|0)+12>>2]);za=ea(Ka*ea(.5));Ka=ea(na*ea(.5));na=ea(La*ea(.5));La=ea(ea(va+ea(g[Wa+(Z*48|0)+12>>2]))*ea(.5));va=ea(za*ea(g[o+(X*48|0)+32>>2]));za=ea(Ka*ea(g[o+(X*48|0)+36>>2]));Ka=ea(na*ea(g[o+(X*48|0)+40>>2]));na=ea(La*ea(g[o+(X*48|0)+44>>2]));La=ea(va+va);ua=ea(za+za);sa=ea(Ka+Ka);Ma=ea(g[Ta>>2]);la=ea(ua*Ma);ba=ea(g[n>>2]);Ja=ea(sa*ba);Oa=ea(g[ka>>2]);ca=ea(La*Oa);Ga=ea(g[Ra>>2]);Na=ea(Ga*ea(0.0));aa=ea(la-ea(La*ba));La=ea(Ja-ea(ua*Oa));ua=ea(ca-ea(sa*Ma));sa=ea(Ga*ea(Na-Na));Na=ea(ea(va+ea(Ga*La))+ea(ea(ba*aa)-ea(Oa*ua)));va=ea(ea(za+ea(Ga*ua))+ea(ea(Oa*La)-ea(Ma*aa)));Oa=ea(ea(Ka+ea(aa*Ga))+ea(ea(Ma*ua)-ea(ba*La)));La=ea(ea(na+sa)+ea(sa-sa));sa=ea(ea(g[o+(X*48|0)>>2])+Na);Na=ea(ea(g[o+(X*48|0)+4>>2])+va);va=ea(ea(g[o+(X*48|0)+8>>2])+Oa);Oa=ea(ea(g[o+(X*48|0)+12>>2])+La);g[B>>2]=sa;g[A>>2]=Na;g[u>>2]=va;g[Va>>2]=Oa;Xa=c[q>>2]|0}else Xa=r;r=Xa+Pa|0;c[Ua>>2]=r;g[E>>2]=ea(0.0);g[$>>2]=ea(1.0);g[t>>2]=ea(0.0);g[v>>2]=ea(0.0);g[F>>2]=Fa;k$d(D,r+(X*48|0)|0,B,C,E,m,F);r=(c[q>>2]|0)+Pa|0;c[Ua>>2]=r;Oa=ea(g[j>>2]);o=r+(X*48|0)+16|0;va=ea(g[o>>2]);Na=ea(Oa*va);sa=ea(g[s>>2]);Ra=r+(X*48|0)+28|0;La=ea(g[Ra>>2]);na=ea(sa*La);ba=ea(g[ja>>2]);ka=r+(X*48|0)+20|0;ua=ea(g[ka>>2]);Ma=ea(ba*ua);Ga=ea(g[D>>2]);n=r+(X*48|0)+24|0;aa=ea(g[n>>2]);Ka=ea(ea(ea(Na-ea(sa*aa))-ea(La*ba))-ea(ua*Ga));Na=ea(ea(ea(na-ea(va*Ga))-ea(ba*aa))-ea(Oa*ua));na=ea(ea(ea(Ma-ea(Oa*aa))-ea(va*sa))-ea(La*Ga));Ma=ea(ea(ea(ea(Ga*aa)-ea(va*ba))-ea(sa*ua))-ea(Oa*La));La=ea(ea(1.0)/ea(T(ea(ea(ea(na*na)+ea(Ma*Ma))+ea(ea(Na*Na)+ea(Ka*Ka))))));Oa=ea(-ea(La*Ma));Ma=ea(-ea(La*Ka));Ka=ea(La*Na);g[o>>2]=ea(-ea(La*na));g[ka>>2]=Oa;g[n>>2]=Ma;g[Ra>>2]=Ka;Ra=(c[S>>2]|0)+fa|0;c[Qa>>2]=Ra;B$d(Ra,e,d,X,X);Ra=(c[S>>2]|0)+fa|0;c[Qa>>2]=Ra;y$d(Ra,d,e,X,X);p=p+1|0}while((p|0)!=3)}if(ea(g[l>>2])>ea(0.0)){if((Y|0)!=-1){p=a+48|0;X=p;Qa=(c[p>>2]|0)+X|0;fa=a+52|0;c[fa>>2]=Qa;y$d(Qa,d,e,Y,U);Qa=e+4|0;S=Qa;D=(c[Qa>>2]|0)+S|0;ja=e+8|0;c[ja>>2]=D;s=D+(Y*48|0)|0;c[G+0>>2]=c[s+0>>2];c[G+4>>2]=c[s+4>>2];c[G+8>>2]=c[s+8>>2];c[G+12>>2]=c[s+12>>2];c[ja>>2]=D;j=(c[p>>2]|0)+X|0;Ua=j+24|0;Pa=j+4|0;j=c[Pa+(c[Pa>>2]|0)+(Y<<3)+4>>2]|0;Pa=Ua+(c[Ua>>2]|0)|0;Fa=ea(g[Pa+(j*88|0)+16>>2]);Ka=ea(g[Pa+(j*88|0)+20>>2]);Ma=ea(g[Pa+(j*88|0)+24>>2]);Oa=ea(g[Pa+(j*88|0)+28>>2]);na=ea(g[D+(Y*48|0)+20>>2]);La=ea(Fa*na);Na=ea(g[D+(Y*48|0)+28>>2]);ua=ea(Oa*Na);sa=ea(g[D+(Y*48|0)+24>>2]);ba=ea(Ka*sa);va=ea(g[D+(Y*48|0)+16>>2]);aa=ea(ea(ea(La-ea(Ma*Na))-ea(Oa*sa))-ea(Ka*va));La=ea(ea(ea(ua-ea(Fa*va))-ea(Ma*sa))-ea(Ka*na));ua=ea(ea(ea(ba-ea(Ma*na))-ea(Fa*Na))-ea(Oa*va));ba=ea(ea(ea(ea(Ma*va)-ea(Fa*sa))-ea(Ka*Na))-ea(Oa*na));na=ea(ea(1.0)/ea(T(ea(ea(ea(ua*ua)+ea(ba*ba))+ea(ea(aa*aa)+ea(La*La))))));Oa=ea(-ea(na*ba));ba=ea(-ea(aa*na));aa=ea(na*La);g[H>>2]=ea(-ea(na*ua));g[H+4>>2]=Oa;g[H+8>>2]=ba;g[H+12>>2]=aa;c[ja>>2]=D;g[J>>2]=ea(-1.0);g[J+4>>2]=ea(0.0);g[J+8>>2]=ea(0.0);g[J+12>>2]=ea(0.0);k$d(I,s,G,H,J,m,l);J=(c[Qa>>2]|0)+S|0;c[ja>>2]=J;aa=ea(g[I+4>>2]);ja=J+(Y*48|0)+16|0;ba=ea(g[ja>>2]);Oa=ea(aa*ba);ua=ea(g[I+12>>2]);S=J+(Y*48|0)+28|0;na=ea(g[S>>2]);La=ea(ua*na);Na=ea(g[I+8>>2]);Qa=J+(Y*48|0)+20|0;Ka=ea(g[Qa>>2]);sa=ea(Na*Ka);Fa=ea(g[I>>2]);I=J+(Y*48|0)+24|0;va=ea(g[I>>2]);Ma=ea(ea(ea(Oa-ea(ua*va))-ea(na*Na))-ea(Ka*Fa));Oa=ea(ea(ea(La-ea(ba*Fa))-ea(Na*va))-ea(aa*Ka));La=ea(ea(ea(sa-ea(aa*va))-ea(ba*ua))-ea(na*Fa));sa=ea(ea(ea(ea(Fa*va)-ea(ba*Na))-ea(ua*Ka))-ea(aa*na));na=ea(ea(1.0)/ea(T(ea(ea(ea(La*La)+ea(sa*sa))+ea(ea(Oa*Oa)+ea(Ma*Ma))))));aa=ea(-ea(na*sa));sa=ea(-ea(na*Ma));Ma=ea(na*Oa);g[ja>>2]=ea(-ea(na*La));g[Qa>>2]=aa;g[I>>2]=sa;g[S>>2]=Ma;S=(c[p>>2]|0)+X|0;c[fa>>2]=S;B$d(S,e,d,Y,Y)}if((Z|0)!=-1){Y=a+48|0;S=Y;fa=(c[Y>>2]|0)+S|0;X=a+52|0;c[X>>2]=fa;y$d(fa,d,e,Z,U);U=e+4|0;fa=U;p=(c[U>>2]|0)+fa|0;I=e+8|0;c[I>>2]=p;Qa=p+(Z*48|0)|0;c[K+0>>2]=c[Qa+0>>2];c[K+4>>2]=c[Qa+4>>2];c[K+8>>2]=c[Qa+8>>2];c[K+12>>2]=c[Qa+12>>2];c[I>>2]=p;ja=(c[Y>>2]|0)+S|0;J=ja+24|0;H=ja+4|0;ja=c[H+(c[H>>2]|0)+(Z<<3)+4>>2]|0;H=J+(c[J>>2]|0)|0;Ma=ea(g[H+(ja*88|0)+16>>2]);sa=ea(g[H+(ja*88|0)+20>>2]);aa=ea(g[H+(ja*88|0)+24>>2]);La=ea(g[H+(ja*88|0)+28>>2]);na=ea(g[p+(Z*48|0)+20>>2]);Oa=ea(Ma*na);Ka=ea(g[p+(Z*48|0)+28>>2]);ua=ea(La*Ka);Na=ea(g[p+(Z*48|0)+24>>2]);ba=ea(sa*Na);va=ea(g[p+(Z*48|0)+16>>2]);Fa=ea(ea(ea(Oa-ea(aa*Ka))-ea(La*Na))-ea(sa*va));Oa=ea(ea(ea(ua-ea(Ma*va))-ea(aa*Na))-ea(sa*na));ua=ea(ea(ea(ba-ea(aa*na))-ea(Ma*Ka))-ea(La*va));ba=ea(ea(ea(ea(aa*va)-ea(Ma*Na))-ea(sa*Ka))-ea(La*na));na=ea(ea(1.0)/ea(T(ea(ea(ea(ua*ua)+ea(ba*ba))+ea(ea(Fa*Fa)+ea(Oa*Oa))))));La=ea(-ea(na*ba));ba=ea(-ea(Fa*na));Fa=ea(na*Oa);g[L>>2]=ea(-ea(na*ua));g[L+4>>2]=La;g[L+8>>2]=ba;g[L+12>>2]=Fa;c[I>>2]=p;g[N>>2]=ea(-1.0);g[N+4>>2]=ea(0.0);g[N+8>>2]=ea(0.0);g[N+12>>2]=ea(0.0);k$d(M,Qa,K,L,N,m,l);l=(c[U>>2]|0)+fa|0;c[I>>2]=l;Fa=ea(g[M+4>>2]);I=l+(Z*48|0)+16|0;ba=ea(g[I>>2]);La=ea(Fa*ba);ua=ea(g[M+12>>2]);fa=l+(Z*48|0)+28|0;na=ea(g[fa>>2]);Oa=ea(ua*na);Ka=ea(g[M+8>>2]);U=l+(Z*48|0)+20|0;sa=ea(g[U>>2]);Na=ea(Ka*sa);Ma=ea(g[M>>2]);M=l+(Z*48|0)+24|0;va=ea(g[M>>2]);aa=ea(ea(ea(La-ea(ua*va))-ea(na*Ka))-ea(sa*Ma));La=ea(ea(ea(Oa-ea(ba*Ma))-ea(Ka*va))-ea(Fa*sa));Oa=ea(ea(ea(Na-ea(Fa*va))-ea(ba*ua))-ea(na*Ma));Na=ea(ea(ea(ea(Ma*va)-ea(ba*Ka))-ea(ua*sa))-ea(Fa*na));na=ea(ea(1.0)/ea(T(ea(ea(ea(Oa*Oa)+ea(Na*Na))+ea(ea(La*La)+ea(aa*aa))))));Fa=ea(-ea(na*Na));Na=ea(-ea(na*aa));aa=ea(na*La);g[I>>2]=ea(-ea(na*Oa));g[U>>2]=Fa;g[M>>2]=Na;g[fa>>2]=aa;fa=(c[Y>>2]|0)+S|0;c[X>>2]=fa;B$d(fa,e,d,Z,Z)}}Z=a+48|0;fa=Z;X=a+52|0;S=e+4|0;Y=S;M=e+8|0;U=O+4|0;I=O+8|0;l=O+12|0;m=a+416|0;N=a+412|0;L=0;do{K=c[a+(c[718540+(L<<4)>>2]<<2)+104>>2]|0;Qa=c[a+(c[718544+(L<<4)>>2]<<2)+104>>2]|0;p=c[a+(c[718548+(L<<4)>>2]<<2)+104>>2]|0;aa=ea(g[b+(L*76|0)+128>>2]);if(aa>ea(0.0)){Na=ea(VDi(ea(1.0),ea(UDi(ea(0.0),aa))));ja=(c[Z>>2]|0)+fa|0;c[X>>2]=ja;y$d(ja,d,e,p,R);ja=(c[S>>2]|0)+Y|0;c[M>>2]=ja;H=b+(L*76|0)+80|0;aa=ea(g[H>>2]);Fa=ea(g[ja+(p*48|0)>>2]);Oa=ea(aa-Fa);aa=ea(g[b+(L*76|0)+84>>2]);na=ea(g[ja+(p*48|0)+4>>2]);La=ea(aa-na);aa=ea(g[b+(L*76|0)+88>>2]);sa=ea(g[ja+(p*48|0)+8>>2]);ua=ea(aa-sa);aa=ea(g[b+(L*76|0)+92>>2]);Ka=ea(g[ja+(p*48|0)+12>>2]);ba=ea(na+ea(Na*La));La=ea(sa+ea(Na*ua));ua=ea(Ka+ea(Na*ea(aa-Ka)));g[O>>2]=ea(Fa+ea(Na*Oa));g[U>>2]=ba;g[I>>2]=La;g[l>>2]=ua;ja=(c[Z>>2]|0)+fa|0;c[X>>2]=ja;g[P>>2]=ea(Na*ea(g[((L|0)<2?m:N)>>2]));F$d(ja,K,Qa,p,O,P,d,e);ja=(c[Z>>2]|0)+fa|0;c[X>>2]=ja;y$d(ja,d,e,p,K);ja=(c[Z>>2]|0)+fa|0;c[X>>2]=ja;G$d(ja,K,Qa,p,H,Na,d,e)}Na=ea(g[b+(L*76|0)+152>>2]);if(Na>ea(0.0)){ua=ea(VDi(ea(1.0),ea(UDi(ea(0.0),Na))));H=(c[Z>>2]|0)+fa|0;c[X>>2]=H;y$d(H,d,e,p,K);H=(c[Z>>2]|0)+fa|0;c[X>>2]=H;H$d(H,K,Qa,p,b+(L*76|0)+136|0,ua,d,e,ea(.0500000007))}L=L+1|0}while((L|0)!=4);L=Q+4|0;P=Q+8|0;O=Q+12|0;N=0;do{ua=ea(g[b+(N*76|0)+132>>2]);if(ua>ea(0.0)){m=c[a+(c[718548+(N<<4)>>2]<<2)+104>>2]|0;Na=ea(VDi(ea(1.0),ea(UDi(ea(0.0),ua))));l=(c[Z>>2]|0)+fa|0;c[X>>2]=l;y$d(l,d,e,m,R);m=c[a+(c[718536+(N<<4)>>2]<<2)+104>>2]|0;l=(c[S>>2]|0)+Y|0;c[M>>2]=l;I=(c[Z>>2]|0)+fa|0;U=I+24|0;p=I+4|0;I=c[p+(c[p>>2]|0)+(m<<3)+4>>2]|0;p=U+(c[U>>2]|0)|0;ua=ea(g[p+(I*88|0)+16>>2]);La=ea(g[p+(I*88|0)+20>>2]);ba=ea(g[p+(I*88|0)+24>>2]);Oa=ea(g[p+(I*88|0)+28>>2]);Fa=ea(g[l+(m*48|0)+20>>2]);Ka=ea(ua*Fa);aa=ea(g[l+(m*48|0)+28>>2]);sa=ea(Oa*aa);na=ea(g[l+(m*48|0)+24>>2]);va=ea(La*na);Ma=ea(g[l+(m*48|0)+16>>2]);Ga=ea(ea(ea(Ka-ea(ba*aa))-ea(Oa*na))-ea(La*Ma));Ka=ea(ea(ea(sa-ea(ua*Ma))-ea(ba*na))-ea(La*Fa));sa=ea(ea(ea(va-ea(ba*Fa))-ea(ua*aa))-ea(Oa*Ma));va=ea(ea(ea(ea(ba*Ma)-ea(ua*na))-ea(La*aa))-ea(Oa*Fa));Fa=ea(ea(1.0)/ea(T(ea(ea(ea(sa*sa)+ea(va*va))+ea(ea(Ga*Ga)+ea(Ka*Ka))))));Oa=ea(Fa*sa);sa=ea(Fa*va);va=ea(Ga*Fa);Ga=ea(Fa*Ka);Ka=ea(g[b+(N*76|0)+96>>2]);Fa=ea(Oa*Ka);aa=ea(g[b+(N*76|0)+100>>2]);La=ea(-ea(sa*aa));na=ea(g[b+(N*76|0)+104>>2]);ua=ea(va*na);Ma=ea(g[b+(N*76|0)+108>>2]);ba=ea(ea(La-Fa)+ea(ea(Ga*Ma)-ua));l=(g[k>>2]=Ka,c[k>>2]|0);I=(g[k>>2]=ba,c[k>>2]|0)&-2147483648;ba=(c[k>>2]=I^l,ea(g[k>>2]));Ka=(c[k>>2]=I^(g[k>>2]=aa,c[k>>2]|0),ea(g[k>>2]));aa=(c[k>>2]=I^(g[k>>2]=na,c[k>>2]|0),ea(g[k>>2]));na=ea(ea(Na*ea(ba+Oa))-Oa);Oa=ea(ea(Na*ea(Ka+sa))-sa);sa=ea(ea(Na*ea(aa+va))-va);va=ea(Ga+ea(Na*ea((c[k>>2]=I^(g[k>>2]=Ma,c[k>>2]|0),ea(g[k>>2]))-Ga)));Ga=ea(ea(1.0)/ea(T(ea(ea(ea(na*na)+ea(Oa*Oa))+ea(ea(sa*sa)+ea(va*va))))));Ma=ea(Ga*na);na=ea(Ga*Oa);Oa=ea(Ga*sa);sa=ea(Ga*va);g[Q>>2]=Ma;g[L>>2]=na;g[P>>2]=Oa;g[O>>2]=sa;I=(c[Z>>2]|0)+fa|0;l=I+24|0;p=I+4|0;I=c[p+(c[p>>2]|0)+(m<<3)+4>>2]|0;m=l+(c[l>>2]|0)|0;va=ea(g[m+(I*88|0)+16>>2]);Ga=ea(g[m+(I*88|0)+20>>2]);Na=ea(g[m+(I*88|0)+24>>2]);aa=ea(g[m+(I*88|0)+28>>2]);Ka=ea(-va);va=ea(-Ga);Ga=ea(-Na);Na=ea(ea(ea(ea(na*Ka)-ea(sa*Ga))-ea(aa*Oa))-ea(Ma*va));ba=ea(ea(ea(ea(aa*sa)-ea(Ma*Ka))-ea(Oa*Ga))-ea(na*va));ua=ea(ea(ea(ea(Oa*va)-ea(na*Ga))-ea(sa*Ka))-ea(aa*Ma));Fa=ea(ea(ea(ea(Ma*Ga)-ea(Oa*Ka))-ea(sa*va))-ea(aa*na));na=ea(ea(1.0)/ea(T(ea(ea(ea(ua*ua)+ea(Fa*Fa))+ea(ea(Na*Na)+ea(ba*ba))))));aa=ea(-ea(na*Fa));Fa=ea(-ea(Na*na));Na=ea(na*ba);g[Q>>2]=ea(-ea(na*ua));g[L>>2]=aa;g[P>>2]=Fa;g[O>>2]=Na;i$d(a,Q,N,d,e,f)}N=N+1|0}while((N|0)!=4);i=h;return}function m$d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d+4|0;j=d;g[e>>2]=ea(g[a+400>>2]);g[f>>2]=ea(g[a+396>>2]);g[h>>2]=ea(g[a+408>>2]);g[j>>2]=ea(g[a+404>>2]);g$d(a,b,c,15,17,e);g$d(a,b,c,13,15,f);g$d(a,b,c,16,18,e);g$d(a,b,c,14,16,f);g$d(a,b,c,3,5,h);g$d(a,b,c,1,3,j);g$d(a,b,c,4,6,h);g$d(a,b,c,2,4,j);i=d;return}function n$d(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=0,f=Im,h=0,i=Im,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(g[c>>2]);e=b+32|0;f=ea(d*ea(g[e>>2]));d=ea(g[c+4>>2]);h=b+36|0;i=ea(d*ea(g[h>>2]));d=ea(g[c+8>>2]);j=b+40|0;k=ea(d*ea(g[j>>2]));d=ea(g[c+12>>2]);l=b+44|0;m=ea(d*ea(g[l>>2]));d=ea(f+f);n=ea(i+i);o=ea(k+k);p=ea(g[b+16>>2]);q=ea(n*p);r=ea(g[b+20>>2]);s=ea(o*r);t=ea(g[b+24>>2]);u=ea(d*t);v=ea(g[b+28>>2]);w=ea(v*ea(0.0));x=ea(q-ea(d*r));d=ea(s-ea(n*t));n=ea(u-ea(o*p));o=ea(v*ea(w-w));w=ea(ea(f+ea(v*d))+ea(ea(r*x)-ea(t*n)));f=ea(ea(i+ea(v*n))+ea(ea(t*d)-ea(p*x)));i=ea(ea(k+ea(x*v))+ea(ea(p*n)-ea(r*d)));d=ea(ea(m+o)+ea(o-o));o=ea(ea(g[b>>2])+w);w=ea(ea(g[b+4>>2])+f);f=ea(ea(g[b+8>>2])+i);i=ea(ea(g[b+12>>2])+d);d=ea(g[c+16>>2]);m=ea(r*d);n=ea(g[c+28>>2]);x=ea(v*n);k=ea(g[c+20>>2]);u=ea(t*k);s=ea(g[c+24>>2]);q=ea(ea(ea(m-ea(v*s))-ea(n*t))-ea(k*p));m=ea(ea(ea(x-ea(d*p))-ea(t*s))-ea(r*k));x=ea(ea(ea(u-ea(r*s))-ea(d*v))-ea(n*p));u=ea(ea(ea(ea(p*s)-ea(d*t))-ea(v*k))-ea(r*n));n=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(u*u))+ea(ea(m*m)+ea(q*q))))));r=ea(-ea(n*x));x=ea(-ea(n*u));u=ea(-ea(n*q));q=ea(n*m);m=ea(g[e>>2]);n=ea(m*ea(g[c+32>>2]));m=ea(g[h>>2]);k=ea(m*ea(g[c+36>>2]));m=ea(g[j>>2]);v=ea(m*ea(g[c+40>>2]));m=ea(g[l>>2]);t=ea(m*ea(g[c+44>>2]));g[a>>2]=o;g[a+4>>2]=w;g[a+8>>2]=f;g[a+12>>2]=i;g[a+16>>2]=r;g[a+20>>2]=x;g[a+24>>2]=u;g[a+28>>2]=q;g[a+32>>2]=n;g[a+36>>2]=k;g[a+40>>2]=v;g[a+44>>2]=t;return}function o$d(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im;d=ea(-ea(g[b+16>>2]));e=ea(-ea(g[b+20>>2]));f=ea(-ea(g[b+24>>2]));h=ea(g[b+28>>2]);i=ea(g[c>>2]);j=ea(i-ea(g[b>>2]));i=ea(g[c+4>>2]);k=ea(i-ea(g[b+4>>2]));i=ea(g[c+8>>2]);l=ea(i-ea(g[b+8>>2]));i=ea(g[c+12>>2]);m=ea(j+j);n=ea(k+k);o=ea(l+l);p=ea(h*ea(0.0));q=ea(ea(n*d)-ea(m*e));r=ea(ea(o*e)-ea(n*f));n=ea(ea(m*f)-ea(o*d));o=ea(h*ea(p-p));p=ea(ea(j+ea(h*r))+ea(ea(q*e)-ea(n*f)));j=ea(ea(k+ea(h*n))+ea(ea(r*f)-ea(q*d)));k=ea(ea(l+ea(h*q))+ea(ea(n*d)-ea(r*e)));r=ea(ea(o-o)+ea(o+ea(i-ea(g[b+12>>2]))));i=ea(g[c+16>>2]);o=ea(i*e);n=ea(g[c+28>>2]);q=ea(h*n);l=ea(g[c+20>>2]);m=ea(l*f);s=ea(g[c+24>>2]);t=ea(ea(ea(o-ea(h*s))-ea(n*f))-ea(l*d));o=ea(ea(ea(q-ea(i*d))-ea(s*f))-ea(l*e));q=ea(ea(ea(m-ea(s*e))-ea(h*i))-ea(n*d));m=ea(ea(ea(ea(s*d)-ea(i*f))-ea(h*l))-ea(n*e));e=ea(ea(1.0)/ea(T(ea(ea(ea(q*q)+ea(m*m))+ea(ea(o*o)+ea(t*t))))));n=ea(-ea(e*q));q=ea(-ea(e*m));m=ea(-ea(e*t));t=ea(e*o);g[a>>2]=p;g[a+4>>2]=j;g[a+8>>2]=k;g[a+12>>2]=r;g[a+16>>2]=n;g[a+20>>2]=q;g[a+24>>2]=m;g[a+28>>2]=t;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(1.0);g[a+44>>2]=ea(1.0);return}function p$d(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;c=i;d=ea(g[b>>2]);e=ea(S(ea(d)));f=ea(g[b+4>>2]);h=ea(S(ea(f)));j=ea(g[b+8>>2]);k=ea(S(ea(j)));l=ea(g[b+12>>2]);m=ea(ea(ea(h*ea(.5))+ea(1.57079637))+ea(-1.57079637));h=ea(ea(ea(k*ea(.5))+ea(1.57079637))+ea(-1.57079637));k=ea(ea(ea(ea(S(ea(l)))*ea(.5))+ea(1.57079637))+ea(-1.57079637));n=ea(PDi(ea(ea(ea(e*ea(.5))+ea(1.57079637))+ea(-1.57079637)),d));d=ea(PDi(m,f));f=ea(PDi(h,j));j=ea(PDi(k,l));l=ea(VDi(ea(UDi(n,ea(-1.57079542))),ea(1.57079732)));n=ea(VDi(ea(UDi(d,ea(-1.57079542))),ea(1.57079732)));d=ea(VDi(ea(UDi(f,ea(-1.57079542))),ea(1.57079732)));f=ea(l*ea(.159154937));l=ea(n*ea(.159154937));n=ea(d*ea(.159154937));d=ea(ea(VDi(ea(UDi(j,ea(-1.57079542))),ea(1.57079732)))*ea(.159154937));j=ea(eEi(f));k=ea(eEi(l));h=ea(eEi(n));m=ea(ea(.25)-ea(S(ea(f-j))));j=ea(ea(.25)-ea(S(ea(l-k))));k=ea(ea(.25)-ea(S(ea(n-h))));h=ea(ea(.25)-ea(S(ea(d-ea(eEi(d))))));e=ea(m*m);o=ea(j*j);p=ea(k*k);q=ea(h*h);r=ea(m*ea(ea(ea(e*ea(-41.2831841))+ea(6.28318548))+ea(ea(e*e)*ea(76.0354614))));e=ea(j*ea(ea(ea(o*ea(-41.2831841))+ea(6.28318548))+ea(ea(o*o)*ea(76.0354614))));o=ea(k*ea(ea(ea(p*ea(-41.2831841))+ea(6.28318548))+ea(ea(p*p)*ea(76.0354614))));p=ea(h*ea(ea(ea(q*ea(-41.2831841))+ea(6.28318548))+ea(ea(q*q)*ea(76.0354614))));q=ea(f+ea(-.25));f=ea(l+ea(-.25));l=ea(n+ea(-.25));n=ea(d+ea(-.25));d=ea(eEi(q));h=ea(eEi(f));k=ea(eEi(l));j=ea(ea(.25)-ea(S(ea(q-d))));d=ea(ea(.25)-ea(S(ea(f-h))));h=ea(ea(.25)-ea(S(ea(l-k))));k=ea(ea(.25)-ea(S(ea(n-ea(eEi(n))))));n=ea(j*j);l=ea(d*d);f=ea(h*h);q=ea(k*k);m=ea(ea(d*ea(ea(ea(l*ea(-41.2831841))+ea(6.28318548))+ea(ea(l*l)*ea(76.0354614))))/e);e=ea(ea(h*ea(ea(ea(f*ea(-41.2831841))+ea(6.28318548))+ea(ea(f*f)*ea(76.0354614))))/o);o=ea(ea(k*ea(ea(ea(q*ea(-41.2831841))+ea(6.28318548))+ea(ea(q*q)*ea(76.0354614))))/p);g[a>>2]=ea(ea(j*ea(ea(ea(n*ea(-41.2831841))+ea(6.28318548))+ea(ea(n*n)*ea(76.0354614))))/r);g[a+4>>2]=m;g[a+8>>2]=e;g[a+12>>2]=o;i=c;return}function q$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=xo[c[c[b>>2]>>2]&2047](b,12,4)|0;if(!e)f=0;else{c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;f=e}e=c[a>>2]|0;c[f>>2]=e;a=f+4|0;if(!e){h=0;j=0;c[a>>2]=j;k=f+8|0;c[k>>2]=h;i=d;return f|0}l=xo[c[c[b>>2]>>2]&2047](b,e*48|0,4)|0;if(!l){h=0;j=0;c[a>>2]=j;k=f+8|0;c[k>>2]=h;i=d;return f|0}b=l+(e*48|0)|0;e=l;do{c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;g[e+28>>2]=ea(1.0);g[e+44>>2]=ea(1.0);g[e+40>>2]=ea(1.0);g[e+36>>2]=ea(1.0);g[e+32>>2]=ea(1.0);e=e+48|0}while((e|0)!=(b|0));h=l;j=l-a|0;c[a>>2]=j;k=f+8|0;c[k>>2]=h;i=d;return f|0}function r$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+4|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+8>>2]=h;In[g&4095](b,h)}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function s$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b>>2]|0;f=c[a>>2]|0;g=b+4|0;h=(c[g>>2]|0)+g|0;c[b+8>>2]=h;b=a+4|0;YEi(h|0,(c[b>>2]|0)+b|0,(e>>>0<f>>>0?e:f)*48|0)|0;i=d;return}function t$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im;f=i;if(!d){i=f;return}h=b+4|0;j=(c[h>>2]|0)+h|0;h=a+4|0;a=(c[h>>2]|0)+h|0;h=0;do{k=c[e+(h<<2)>>2]|0;l=ea(g[a+(h*48|0)>>2]);m=ea(g[a+(h*48|0)+4>>2]);n=ea(g[a+(h*48|0)+8>>2]);o=ea(g[a+(h*48|0)+12>>2]);g[j+(k*48|0)>>2]=l;g[j+(k*48|0)+4>>2]=m;g[j+(k*48|0)+8>>2]=n;g[j+(k*48|0)+12>>2]=o;o=ea(g[a+(h*48|0)+16>>2]);n=ea(g[a+(h*48|0)+20>>2]);m=ea(g[a+(h*48|0)+24>>2]);l=ea(g[a+(h*48|0)+28>>2]);g[j+(k*48|0)+16>>2]=o;g[j+(k*48|0)+20>>2]=n;g[j+(k*48|0)+24>>2]=m;g[j+(k*48|0)+28>>2]=l;l=ea(g[a+(h*48|0)+32>>2]);m=ea(g[a+(h*48|0)+36>>2]);n=ea(g[a+(h*48|0)+40>>2]);o=ea(g[a+(h*48|0)+44>>2]);g[j+(k*48|0)+32>>2]=l;g[j+(k*48|0)+36>>2]=m;g[j+(k*48|0)+40>>2]=n;g[j+(k*48|0)+44>>2]=o;h=h+1|0}while((h|0)!=(d|0));c[b+8>>2]=j;i=f;return}function u$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a>>2]|0;f=a+12|0;a=f;g=0;while(1){if((g|0)>=(e|0)){h=-1;j=4;break}if((g|0)==-1?1:(c[(c[f>>2]|0)+a+(g<<2)>>2]|0)!=(b|0))g=g+1|0;else{h=g;j=4;break}}if((j|0)==4){i=d;return h|0}return 0}function v$d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;if(!(c[b>>2]|0)){i=e;return}f=b+12|0;g=f;h=d+12|0;j=h;k=0;do{l=c[(c[f>>2]|0)+g+(k<<2)>>2]|0;m=c[d>>2]|0;n=0;while(1){if((n|0)>=(m|0)){o=-1;break}if((c[(c[h>>2]|0)+j+(n<<2)>>2]|0)==(l|0)){o=n;break}else n=n+1|0}c[a+(k<<2)>>2]=o;k=k+1|0}while(k>>>0<(c[b>>2]|0)>>>0);i=e;return}function w$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(c[e>>2]|0){g=0;do{c[a+(g<<2)>>2]=-1;g=g+1|0}while(g>>>0<(c[e>>2]|0)>>>0)}e=c[d>>2]|0;if(!e){i=f;return}else{h=e;j=0}while(1){e=c[b+(j<<2)>>2]|0;if((e|0)==-1)k=h;else{c[a+(e<<2)>>2]=j;k=c[d>>2]|0}j=j+1|0;if(j>>>0>=k>>>0)break;else h=k}i=f;return}function x$d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+48|0;f=e;h=d+4|0;j=h;k=c[h>>2]|0;l=k+j|0;m=d+8|0;c[m>>2]=l;d=b+4|0;b=d;n=c[d>>2]|0;o=n+b|0;p=ea(g[o>>2]);q=ea(g[o+4>>2]);r=ea(g[o+8>>2]);s=ea(g[o+12>>2]);g[l>>2]=p;g[l+4>>2]=q;g[l+8>>2]=r;g[l+12>>2]=s;s=ea(g[o+16>>2]);r=ea(g[o+20>>2]);q=ea(g[o+24>>2]);p=ea(g[o+28>>2]);g[l+16>>2]=s;g[l+20>>2]=r;g[l+24>>2]=q;g[l+28>>2]=p;p=ea(g[o+32>>2]);q=ea(g[o+36>>2]);r=ea(g[o+40>>2]);s=ea(g[o+44>>2]);g[l+32>>2]=p;g[l+36>>2]=q;g[l+40>>2]=r;g[l+44>>2]=s;if((c[a>>2]|0)>>>0<=1){i=e;return}l=a+4|0;o=l;t=f+4|0;u=f+8|0;v=f+12|0;w=f+16|0;x=f+20|0;y=f+24|0;z=f+28|0;A=f+32|0;B=f+36|0;C=f+40|0;D=f+44|0;E=k;k=n;n=1;while(1){F=E+j|0;G=c[(c[l>>2]|0)+o+(n<<3)>>2]|0;c[m>>2]=F;I$d(f,F+(G*48|0)|0,k+b+(n*48|0)|0);s=ea(g[f>>2]);r=ea(g[t>>2]);q=ea(g[u>>2]);p=ea(g[v>>2]);g[F+(n*48|0)>>2]=s;g[F+(n*48|0)+4>>2]=r;g[F+(n*48|0)+8>>2]=q;g[F+(n*48|0)+12>>2]=p;p=ea(g[w>>2]);q=ea(g[x>>2]);r=ea(g[y>>2]);s=ea(g[z>>2]);g[F+(n*48|0)+16>>2]=p;g[F+(n*48|0)+20>>2]=q;g[F+(n*48|0)+24>>2]=r;g[F+(n*48|0)+28>>2]=s;s=ea(g[A>>2]);r=ea(g[B>>2]);q=ea(g[C>>2]);p=ea(g[D>>2]);g[F+(n*48|0)+32>>2]=s;g[F+(n*48|0)+36>>2]=r;g[F+(n*48|0)+40>>2]=q;g[F+(n*48|0)+44>>2]=p;F=n+1|0;if(F>>>0>=(c[a>>2]|0)>>>0)break;E=c[h>>2]|0;k=c[d>>2]|0;n=F}i=e;return}function y$d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im;h=i;i=i+48|0;j=h;k=a+4|0;l=c[(c[k>>2]|0)+k+(e<<3)>>2]|0;if((l|0)==-1){k=d+4|0;m=(c[k>>2]|0)+k|0;c[d+8>>2]=m;k=b+4|0;n=(c[k>>2]|0)+k|0;o=ea(g[n+(e*48|0)>>2]);p=ea(g[n+(e*48|0)+4>>2]);q=ea(g[n+(e*48|0)+8>>2]);r=ea(g[n+(e*48|0)+12>>2]);g[m+(e*48|0)>>2]=o;g[m+(e*48|0)+4>>2]=p;g[m+(e*48|0)+8>>2]=q;g[m+(e*48|0)+12>>2]=r;r=ea(g[n+(e*48|0)+16>>2]);q=ea(g[n+(e*48|0)+20>>2]);p=ea(g[n+(e*48|0)+24>>2]);o=ea(g[n+(e*48|0)+28>>2]);g[m+(e*48|0)+16>>2]=r;g[m+(e*48|0)+20>>2]=q;g[m+(e*48|0)+24>>2]=p;g[m+(e*48|0)+28>>2]=o;o=ea(g[n+(e*48|0)+32>>2]);p=ea(g[n+(e*48|0)+36>>2]);q=ea(g[n+(e*48|0)+40>>2]);r=ea(g[n+(e*48|0)+44>>2]);g[m+(e*48|0)+32>>2]=o;g[m+(e*48|0)+36>>2]=p;g[m+(e*48|0)+40>>2]=q;g[m+(e*48|0)+44>>2]=r;i=h;return}if((e|0)!=(f|0))y$d(a,b,d,l,f);f=d+4|0;a=(c[f>>2]|0)+f|0;c[d+8>>2]=a;d=b+4|0;I$d(j,a+(l*48|0)|0,(c[d>>2]|0)+d+(e*48|0)|0);r=ea(g[j>>2]);q=ea(g[j+4>>2]);p=ea(g[j+8>>2]);o=ea(g[j+12>>2]);g[a+(e*48|0)>>2]=r;g[a+(e*48|0)+4>>2]=q;g[a+(e*48|0)+8>>2]=p;g[a+(e*48|0)+12>>2]=o;o=ea(g[j+16>>2]);p=ea(g[j+20>>2]);q=ea(g[j+24>>2]);r=ea(g[j+28>>2]);g[a+(e*48|0)+16>>2]=o;g[a+(e*48|0)+20>>2]=p;g[a+(e*48|0)+24>>2]=q;g[a+(e*48|0)+28>>2]=r;r=ea(g[j+32>>2]);q=ea(g[j+36>>2]);p=ea(g[j+40>>2]);o=ea(g[j+44>>2]);g[a+(e*48|0)+32>>2]=r;g[a+(e*48|0)+36>>2]=q;g[a+(e*48|0)+40>>2]=p;g[a+(e*48|0)+44>>2]=o;i=h;return}function z$d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im;h=i;j=a+4|0;k=c[(c[j>>2]|0)+j+(e<<3)>>2]|0;if((k|0)==-1){j=d+4|0;l=(c[j>>2]|0)+j|0;c[d+8>>2]=l;j=b+4|0;m=(c[j>>2]|0)+j|0;n=ea(g[m+(e*48|0)+16>>2]);o=ea(g[m+(e*48|0)+20>>2]);p=ea(g[m+(e*48|0)+24>>2]);q=ea(g[m+(e*48|0)+28>>2]);g[l+(e*48|0)+16>>2]=n;g[l+(e*48|0)+20>>2]=o;g[l+(e*48|0)+24>>2]=p;g[l+(e*48|0)+28>>2]=q;i=h;return}if((e|0)!=(f|0))z$d(a,b,d,k,f);f=d+4|0;a=(c[f>>2]|0)+f|0;c[d+8>>2]=a;d=b+4|0;b=(c[d>>2]|0)+d|0;q=ea(g[a+(k*48|0)+20>>2]);p=ea(g[b+(e*48|0)+16>>2]);o=ea(q*p);n=ea(g[a+(k*48|0)+28>>2]);r=ea(g[b+(e*48|0)+28>>2]);s=ea(n*r);t=ea(g[a+(k*48|0)+24>>2]);u=ea(g[b+(e*48|0)+20>>2]);v=ea(t*u);w=ea(g[a+(k*48|0)+16>>2]);x=ea(g[b+(e*48|0)+24>>2]);y=ea(ea(ea(o-ea(n*x))-ea(r*t))-ea(u*w));o=ea(ea(ea(s-ea(p*w))-ea(t*x))-ea(q*u));s=ea(ea(ea(v-ea(q*x))-ea(p*n))-ea(r*w));v=ea(ea(ea(ea(w*x)-ea(p*t))-ea(n*u))-ea(q*r));r=ea(ea(1.0)/ea(T(ea(ea(ea(s*s)+ea(v*v))+ea(ea(o*o)+ea(y*y))))));q=ea(-ea(r*v));v=ea(-ea(r*y));y=ea(r*o);g[a+(e*48|0)+16>>2]=ea(-ea(r*s));g[a+(e*48|0)+20>>2]=q;g[a+(e*48|0)+24>>2]=v;g[a+(e*48|0)+28>>2]=y;i=h;return}function A$d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im;h=i;i=i+48|0;j=h;k=a+4|0;l=c[(c[k>>2]|0)+k+(e<<3)>>2]|0;k=d+4|0;m=(c[k>>2]|0)+k|0;c[d+8>>2]=m;k=m+(e*48|0)|0;n=b+4|0;o=(c[n>>2]|0)+n|0;if((l|0)==-1){p=ea(g[o+(e*48|0)>>2]);q=ea(g[o+(e*48|0)+4>>2]);r=ea(g[o+(e*48|0)+8>>2]);s=ea(g[o+(e*48|0)+12>>2]);g[k>>2]=p;g[m+(e*48|0)+4>>2]=q;g[m+(e*48|0)+8>>2]=r;g[m+(e*48|0)+12>>2]=s;s=ea(g[o+(e*48|0)+16>>2]);r=ea(g[o+(e*48|0)+20>>2]);q=ea(g[o+(e*48|0)+24>>2]);p=ea(g[o+(e*48|0)+28>>2]);g[m+(e*48|0)+16>>2]=s;g[m+(e*48|0)+20>>2]=r;g[m+(e*48|0)+24>>2]=q;g[m+(e*48|0)+28>>2]=p;p=ea(g[o+(e*48|0)+32>>2]);q=ea(g[o+(e*48|0)+36>>2]);r=ea(g[o+(e*48|0)+40>>2]);s=ea(g[o+(e*48|0)+44>>2]);g[m+(e*48|0)+32>>2]=p;g[m+(e*48|0)+36>>2]=q;g[m+(e*48|0)+40>>2]=r;g[m+(e*48|0)+44>>2]=s;i=h;return}J$d(j,o+(l*48|0)|0,o+(e*48|0)|0);s=ea(g[j>>2]);r=ea(g[j+4>>2]);q=ea(g[j+8>>2]);p=ea(g[j+12>>2]);g[k>>2]=s;g[m+(e*48|0)+4>>2]=r;g[m+(e*48|0)+8>>2]=q;g[m+(e*48|0)+12>>2]=p;p=ea(g[j+16>>2]);q=ea(g[j+20>>2]);r=ea(g[j+24>>2]);s=ea(g[j+28>>2]);g[m+(e*48|0)+16>>2]=p;g[m+(e*48|0)+20>>2]=q;g[m+(e*48|0)+24>>2]=r;g[m+(e*48|0)+28>>2]=s;s=ea(g[j+32>>2]);r=ea(g[j+36>>2]);q=ea(g[j+40>>2]);p=ea(g[j+44>>2]);g[m+(e*48|0)+32>>2]=s;g[m+(e*48|0)+36>>2]=r;g[m+(e*48|0)+40>>2]=q;g[m+(e*48|0)+44>>2]=p;if((e|0)==(f|0)){i=h;return}A$d(a,b,d,l,f);i=h;return}function B$d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im;h=i;j=a+4|0;a=(c[j>>2]|0)+j|0;j=d+4|0;k=(c[j>>2]|0)+j|0;j=d+8|0;d=b+4|0;b=(c[d>>2]|0)+d|0;d=e;while(1){e=d;d=c[a+(d<<3)>>2]|0;l=k+(e*48|0)+16|0;if((d|0)==-1){m=l;n=e;o=4;break}p=ea(-ea(g[b+(d*48|0)+16>>2]));q=ea(-ea(g[b+(d*48|0)+20>>2]));r=ea(-ea(g[b+(d*48|0)+24>>2]));s=ea(g[b+(d*48|0)+28>>2]);t=ea(g[b+(e*48|0)+16>>2]);u=ea(t*q);v=ea(g[b+(e*48|0)+28>>2]);w=ea(s*v);x=ea(g[b+(e*48|0)+20>>2]);y=ea(x*r);z=ea(g[b+(e*48|0)+24>>2]);A=ea(ea(ea(u-ea(s*z))-ea(v*r))-ea(x*p));u=ea(ea(ea(w-ea(t*p))-ea(z*r))-ea(x*q));w=ea(ea(ea(y-ea(z*q))-ea(s*t))-ea(v*p));y=ea(ea(ea(ea(z*p)-ea(t*r))-ea(s*x))-ea(v*q));q=ea(ea(1.0)/ea(T(ea(ea(ea(w*w)+ea(y*y))+ea(ea(u*u)+ea(A*A))))));v=ea(-ea(q*y));y=ea(-ea(q*A));A=ea(q*u);g[l>>2]=ea(-ea(q*w));g[k+(e*48|0)+20>>2]=v;g[k+(e*48|0)+24>>2]=y;g[k+(e*48|0)+28>>2]=A;if((e|0)==(f|0)){o=5;break}}if((o|0)==4){c[j>>2]=k;A=ea(g[b+(n*48|0)+16>>2]);y=ea(g[b+(n*48|0)+20>>2]);v=ea(g[b+(n*48|0)+24>>2]);w=ea(g[b+(n*48|0)+28>>2]);g[m>>2]=A;g[k+(n*48|0)+20>>2]=y;g[k+(n*48|0)+24>>2]=v;g[k+(n*48|0)+28>>2]=w;i=h;return}else if((o|0)==5){c[j>>2]=k;i=h;return}}function C$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0,W=0,X=Im,Y=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0;f=i;h=b+4|0;j=c[(c[h>>2]|0)+h+(e<<3)+4>>2]|0;h=d+4|0;d=(c[h>>2]|0)+h|0;l=ea(g[d+(e*48|0)+28>>2]);h=l==ea(0.0);m=h?ea(9.99999997e-07):l;n=ea(g[d+(e*48|0)+16>>2]);o=ea(n/m);p=ea(g[d+(e*48|0)+20>>2]);q=ea(p/m);r=ea(g[d+(e*48|0)+24>>2]);s=ea(r/m);e=b+24|0;b=(c[e>>2]|0)+e|0;m=ea(g[b+(j*88|0)>>2]);t=ea(g[b+(j*88|0)+4>>2]);u=ea(g[b+(j*88|0)+8>>2]);v=ea(g[b+(j*88|0)+12>>2]);w=ea(g[b+(j*88|0)+16>>2]);x=ea(p*w);y=ea(g[b+(j*88|0)+28>>2]);z=ea(l*y);A=ea(g[b+(j*88|0)+20>>2]);B=ea(r*A);C=ea(g[b+(j*88|0)+24>>2]);D=ea(ea(ea(x-ea(l*C))-ea(r*y))-ea(n*A));x=ea(ea(ea(z-ea(n*w))-ea(r*C))-ea(p*A));z=ea(ea(ea(B-ea(p*C))-ea(l*w))-ea(n*y));B=ea(ea(ea(ea(n*C)-ea(r*w))-ea(l*A))-ea(p*y));y=ea(ea(ea(u*x)+ea(ea(t*z)+ea(v*D)))-ea(m*B));p=ea(ea(ea(ea(v*x)-ea(m*z))-ea(u*D))-ea(t*B));A=ea(ea(m*x)+ea(ea(v*z)+ea(ea(u*B)-ea(t*D))));l=ea(ea(t*x)+ea(ea(v*B)+ea(ea(m*D)-ea(u*z))));z=ea(ea(1.0)/ea(T(ea(ea(ea(A*A)+ea(l*l))+ea(ea(y*y)+ea(p*p))))));u=ea(z*A);A=ea(-u);D=ea(z*l);l=ea(-D);m=ea(z*y);y=ea(-m);B=ea(z*p);e=c[b+(j*88|0)+84>>2]|0;if((e|0)==3){p=ea(u*u);z=ea(u*D);v=ea(u*m);u=ea(B*A);x=ea(D*D);t=ea(m*D);D=ea(B*l);w=ea(v-D);do if(!(w>=ea(.499998987))){r=ea(B*y);C=ea(ea(B*B)+ea(-.5));if(!(w<=ea(-.499998987))){E=ea(+$(+ea(t+u),+ea(ea(m*m)+C)));F=ea(-ea(+Z(+ea(w+w))));G=ea(+$(+ea(z+r),+ea(p+C)));break}else{E=ea(+$(+ea(z-r),+ea(x+C)));F=ea(1.57079637);G=ea(0.0);break}}else{E=ea(+$(+ea(u-t),+ea(ea(-v)-D)));F=ea(-1.57079637);G=ea(0.0)}while(0);D=ea(g[b+(j*88|0)+48>>2]);d=D>ea(0.0);v=ea(g[b+(j*88|0)+52>>2]);h=v>ea(0.0);t=ea(g[b+(j*88|0)+56>>2]);H=t>ea(0.0);u=ea(ea(-E)/D);x=ea(ea(-F)/v);z=ea(ea(-G)/t);I=D<ea(0.0);J=v<ea(0.0);K=t<ea(0.0);L=(g[k>>2]=E,c[k>>2]|0);M=I?(g[k>>2]=u,c[k>>2]|0):d?L:0;d=(g[k>>2]=F,c[k>>2]|0);I=J?(g[k>>2]=x,c[k>>2]|0):h?d:0;h=(g[k>>2]=G,c[k>>2]|0);J=K?(g[k>>2]=z,c[k>>2]|0):H?h:0;z=ea(g[b+(j*88|0)+64>>2]);H=z<ea(0.0);x=ea(g[b+(j*88|0)+68>>2]);K=x<ea(0.0);u=ea(g[b+(j*88|0)+72>>2]);N=u<ea(0.0);t=ea(g[b+(j*88|0)+76>>2]);v=ea(E/z);D=ea(F/x);p=ea(G/u);w=ea(ea(0.0)/t);O=z>ea(0.0);P=x>ea(0.0);Q=u>ea(0.0);R=t>ea(0.0);S=O?(g[k>>2]=v,c[k>>2]|0):H?L:0;L=P?(g[k>>2]=D,c[k>>2]|0):K?d:0;d=E<ea(0.0);K=F<ea(0.0);P=G<ea(0.0);U=P?J:Q?(g[k>>2]=p,c[k>>2]|0):N?h:0;V=K?I:L;W=d?M:S;X=R?w:ea(0.0);Y=(j|0)!=-1;aa=(g[k>>2]=o,c[k>>2]|0);ba=Y?W:aa;ca=ba|0;da=(g[k>>2]=q,c[k>>2]|0);fa=Y?V:da;ga=fa|0;ha=(g[k>>2]=s,c[k>>2]|0);ia=Y?U:ha;ja=ia|0;ka=Y?X:ea(0.0);c[a>>2]=ca;la=a+4|0;c[la>>2]=ga;ma=a+8|0;c[ma>>2]=ja;na=a+12|0;g[na>>2]=ka;i=f;return}else if((e|0)==2){R=B==ea(0.0);w=R?ea(9.99999997e-07):B;p=ea(A/w);G=ea(l/w);F=ea(y/w);w=ea(ea(p*p)+ea(1.0));E=ea(ea(G+ea(p*F))/w);D=ea(ea(F-ea(p*G))/w);w=ea(g[b+(j*88|0)+32>>2]);R=(g[k>>2]=p,c[k>>2]|0);p=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^R,ea(g[k>>2]));w=ea(g[b+(j*88|0)+36>>2]);R=(g[k>>2]=E,c[k>>2]|0);E=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^R,ea(g[k>>2]));w=ea(g[b+(j*88|0)+40>>2]);R=(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^R,ea(g[k>>2]));w=ea(g[b+(j*88|0)+44>>2]);G=ea(ea(+_(+p))*ea(2.0));p=ea(ea(+_(+E))*ea(2.0));E=ea(ea(+_(+D))*ea(2.0));D=ea(ea(+_(+(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648,ea(g[k>>2]))))*ea(2.0));w=ea(g[b+(j*88|0)+48>>2]);R=w>ea(0.0);F=ea(g[b+(j*88|0)+52>>2]);S=F>ea(0.0);v=ea(g[b+(j*88|0)+56>>2]);M=v>ea(0.0);t=ea(g[b+(j*88|0)+60>>2]);d=t>ea(0.0);u=ea(ea(-G)/w);x=ea(ea(-p)/F);z=ea(ea(-E)/v);m=ea(ea(-D)/t);L=w<ea(0.0);I=F<ea(0.0);K=v<ea(0.0);h=t<ea(0.0);N=(g[k>>2]=G,c[k>>2]|0);Q=L?(g[k>>2]=u,c[k>>2]|0):R?N:0;R=(g[k>>2]=p,c[k>>2]|0);L=I?(g[k>>2]=x,c[k>>2]|0):S?R:0;S=(g[k>>2]=E,c[k>>2]|0);I=K?(g[k>>2]=z,c[k>>2]|0):M?S:0;M=(g[k>>2]=D,c[k>>2]|0);K=h?(g[k>>2]=m,c[k>>2]|0):d?M:0;m=ea(g[b+(j*88|0)+64>>2]);d=m<ea(0.0);z=ea(g[b+(j*88|0)+68>>2]);h=z<ea(0.0);x=ea(g[b+(j*88|0)+72>>2]);J=x<ea(0.0);u=ea(g[b+(j*88|0)+76>>2]);P=u<ea(0.0);t=ea(G/m);v=ea(p/z);F=ea(E/x);w=ea(D/u);H=m>ea(0.0);O=z>ea(0.0);oa=x>ea(0.0);pa=u>ea(0.0);qa=H?(g[k>>2]=t,c[k>>2]|0):d?N:0;N=O?(g[k>>2]=v,c[k>>2]|0):h?R:0;R=oa?(g[k>>2]=F,c[k>>2]|0):J?S:0;S=G<ea(0.0);J=p<ea(0.0);oa=E<ea(0.0);h=D<ea(0.0);U=oa?I:R;V=J?L:N;W=S?Q:qa;X=(c[k>>2]=h?K:pa?(g[k>>2]=w,c[k>>2]|0):P?M:0,ea(g[k>>2]));Y=(j|0)!=-1;aa=(g[k>>2]=o,c[k>>2]|0);ba=Y?W:aa;ca=ba|0;da=(g[k>>2]=q,c[k>>2]|0);fa=Y?V:da;ga=fa|0;ha=(g[k>>2]=s,c[k>>2]|0);ia=Y?U:ha;ja=ia|0;ka=Y?X:ea(0.0);c[a>>2]=ca;la=a+4|0;c[la>>2]=ga;ma=a+8|0;c[ma>>2]=ja;na=a+12|0;g[na>>2]=ka;i=f;return}else if((e|0)==1){e=B==ea(0.0);w=e?ea(9.99999997e-07):B;D=ea(A/w);E=ea(l/w);p=ea(y/w);w=ea(ea(D*D)+ea(1.0));G=ea(ea(E-ea(D*p))/w);F=ea(ea(ea(D*E)+p)/w);w=ea(g[b+(j*88|0)+32>>2]);e=(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^e,ea(g[k>>2]));w=ea(g[b+(j*88|0)+36>>2]);e=(g[k>>2]=G,c[k>>2]|0);G=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^e,ea(g[k>>2]));w=ea(g[b+(j*88|0)+40>>2]);e=(g[k>>2]=F,c[k>>2]|0);F=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^e,ea(g[k>>2]));w=ea(g[b+(j*88|0)+44>>2]);p=ea(ea(+_(+D))*ea(2.0));D=ea(ea(+_(+G))*ea(2.0));G=ea(ea(+_(+F))*ea(2.0));F=ea(ea(+_(+(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648,ea(g[k>>2]))))*ea(2.0));w=ea(g[b+(j*88|0)+48>>2]);e=w>ea(0.0);E=ea(g[b+(j*88|0)+52>>2]);M=E>ea(0.0);v=ea(g[b+(j*88|0)+56>>2]);P=v>ea(0.0);t=ea(g[b+(j*88|0)+60>>2]);pa=t>ea(0.0);u=ea(ea(-p)/w);x=ea(ea(-D)/E);z=ea(ea(-G)/v);m=ea(ea(-F)/t);K=w<ea(0.0);h=E<ea(0.0);qa=v<ea(0.0);Q=t<ea(0.0);S=(g[k>>2]=p,c[k>>2]|0);N=K?(g[k>>2]=u,c[k>>2]|0):e?S:0;e=(g[k>>2]=D,c[k>>2]|0);K=h?(g[k>>2]=x,c[k>>2]|0):M?e:0;M=(g[k>>2]=G,c[k>>2]|0);h=qa?(g[k>>2]=z,c[k>>2]|0):P?M:0;P=(g[k>>2]=F,c[k>>2]|0);qa=Q?(g[k>>2]=m,c[k>>2]|0):pa?P:0;m=ea(g[b+(j*88|0)+64>>2]);pa=m<ea(0.0);z=ea(g[b+(j*88|0)+68>>2]);Q=z<ea(0.0);x=ea(g[b+(j*88|0)+72>>2]);L=x<ea(0.0);u=ea(g[b+(j*88|0)+76>>2]);J=u<ea(0.0);t=ea(p/m);v=ea(D/z);E=ea(G/x);w=ea(F/u);R=m>ea(0.0);I=z>ea(0.0);oa=x>ea(0.0);O=u>ea(0.0);d=R?(g[k>>2]=t,c[k>>2]|0):pa?S:0;S=I?(g[k>>2]=v,c[k>>2]|0):Q?e:0;e=oa?(g[k>>2]=E,c[k>>2]|0):L?M:0;M=p<ea(0.0);L=D<ea(0.0);oa=G<ea(0.0);Q=F<ea(0.0);U=oa?h:e;V=L?K:S;W=M?N:d;X=(c[k>>2]=Q?qa:O?(g[k>>2]=w,c[k>>2]|0):J?P:0,ea(g[k>>2]));Y=(j|0)!=-1;aa=(g[k>>2]=o,c[k>>2]|0);ba=Y?W:aa;ca=ba|0;da=(g[k>>2]=q,c[k>>2]|0);fa=Y?V:da;ga=fa|0;ha=(g[k>>2]=s,c[k>>2]|0);ia=Y?U:ha;ja=ia|0;ka=Y?X:ea(0.0);c[a>>2]=ca;la=a+4|0;c[la>>2]=ga;ma=a+8|0;c[ma>>2]=ja;na=a+12|0;g[na>>2]=ka;i=f;return}else{P=B==ea(0.0);w=P?ea(9.99999997e-07):B;B=ea(A/w);A=ea(l/w);l=ea(y/w);w=ea(g[b+(j*88|0)+32>>2]);P=(g[k>>2]=B,c[k>>2]|0);B=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^P,ea(g[k>>2]));w=ea(g[b+(j*88|0)+36>>2]);P=(g[k>>2]=A,c[k>>2]|0);A=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^P,ea(g[k>>2]));w=ea(g[b+(j*88|0)+40>>2]);P=(g[k>>2]=l,c[k>>2]|0);l=(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648^P,ea(g[k>>2]));w=ea(g[b+(j*88|0)+44>>2]);y=ea(ea(+_(+B))*ea(2.0));B=ea(ea(+_(+A))*ea(2.0));A=ea(ea(+_(+l))*ea(2.0));l=ea(ea(+_(+(c[k>>2]=(g[k>>2]=w,c[k>>2]|0)&-2147483648,ea(g[k>>2]))))*ea(2.0));w=ea(g[b+(j*88|0)+48>>2]);P=w>ea(0.0);F=ea(g[b+(j*88|0)+52>>2]);J=F>ea(0.0);G=ea(g[b+(j*88|0)+56>>2]);O=G>ea(0.0);D=ea(g[b+(j*88|0)+60>>2]);qa=D>ea(0.0);p=ea(ea(-y)/w);E=ea(ea(-B)/F);v=ea(ea(-A)/G);t=ea(ea(-l)/D);Q=w<ea(0.0);d=F<ea(0.0);N=G<ea(0.0);M=D<ea(0.0);S=(g[k>>2]=y,c[k>>2]|0);K=Q?(g[k>>2]=p,c[k>>2]|0):P?S:0;P=(g[k>>2]=B,c[k>>2]|0);Q=d?(g[k>>2]=E,c[k>>2]|0):J?P:0;J=(g[k>>2]=A,c[k>>2]|0);d=N?(g[k>>2]=v,c[k>>2]|0):O?J:0;O=(g[k>>2]=l,c[k>>2]|0);N=M?(g[k>>2]=t,c[k>>2]|0):qa?O:0;t=ea(g[b+(j*88|0)+64>>2]);qa=t<ea(0.0);v=ea(g[b+(j*88|0)+68>>2]);M=v<ea(0.0);E=ea(g[b+(j*88|0)+72>>2]);L=E<ea(0.0);p=ea(g[b+(j*88|0)+76>>2]);b=p<ea(0.0);D=ea(y/t);G=ea(B/v);F=ea(A/E);w=ea(l/p);e=t>ea(0.0);h=v>ea(0.0);oa=E>ea(0.0);I=p>ea(0.0);pa=e?(g[k>>2]=D,c[k>>2]|0):qa?S:0;S=h?(g[k>>2]=G,c[k>>2]|0):M?P:0;P=oa?(g[k>>2]=F,c[k>>2]|0):L?J:0;J=y<ea(0.0);L=B<ea(0.0);oa=A<ea(0.0);M=l<ea(0.0);U=oa?d:P;V=L?Q:S;W=J?K:pa;X=(c[k>>2]=M?N:I?(g[k>>2]=w,c[k>>2]|0):b?O:0,ea(g[k>>2]));Y=(j|0)!=-1;aa=(g[k>>2]=o,c[k>>2]|0);ba=Y?W:aa;ca=ba|0;da=(g[k>>2]=q,c[k>>2]|0);fa=Y?V:da;ga=fa|0;ha=(g[k>>2]=s,c[k>>2]|0);ia=Y?U:ha;ja=ia|0;ka=Y?X:ea(0.0);c[a>>2]=ca;la=a+4|0;c[la>>2]=ga;ma=a+8|0;c[ma>>2]=ja;na=a+12|0;g[na>>2]=ka;i=f;return}}function D$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;f=i;i=i+96|0;h=f+80|0;j=f+64|0;l=f+48|0;m=f+32|0;n=f+16|0;o=f;p=a+4|0;q=c[(c[p>>2]|0)+p+(e<<3)+4>>2]|0;p=b+4|0;r=(c[p>>2]|0)+p|0;c[b+8>>2]=r;s=ea(g[d>>2]);t=ea(g[d+4>>2]);u=ea(g[d+8>>2]);v=ea(ea(1.0)/ea(T(ea(ea(ea(s*s)+ea(t*t))+ea(ea(u*u)+ea(1.0))))));w=ea(s*v);x=ea(t*v);y=ea(u*v);b=a+24|0;a=(c[b>>2]|0)+b|0;b=c[a+(q*88|0)+84>>2]|0;if((b|0)==3){z=ea(ea(s*ea(.5))*ea(.159154937));A=ea(ea(t*ea(.5))*ea(.159154937));B=ea(ea(u*ea(.5))*ea(.159154937));C=ea(eEi(z));D=ea(eEi(A));E=ea(ea(.25)-ea(S(ea(z-C))));C=ea(ea(.25)-ea(S(ea(A-D))));D=ea(ea(.25)-ea(S(ea(B-ea(eEi(B))))));F=ea(E*E);G=ea(C*C);H=ea(D*D);I=ea(E*ea(ea(ea(F*ea(-41.2831841))+ea(6.28318548))+ea(ea(F*F)*ea(76.0354614))));F=ea(C*ea(ea(ea(G*ea(-41.2831841))+ea(6.28318548))+ea(ea(G*G)*ea(76.0354614))));G=ea(D*ea(ea(ea(H*ea(-41.2831841))+ea(6.28318548))+ea(ea(H*H)*ea(76.0354614))));H=ea(z+ea(-.25));z=ea(A+ea(-.25));A=ea(B+ea(-.25));B=ea(eEi(H));D=ea(eEi(z));C=ea(ea(.25)-ea(S(ea(H-B))));B=ea(ea(.25)-ea(S(ea(z-D))));D=ea(ea(.25)-ea(S(ea(A-ea(eEi(A))))));A=ea(C*C);z=ea(B*B);H=ea(D*D);E=ea(C*ea(ea(ea(A*ea(-41.2831841))+ea(6.28318548))+ea(ea(A*A)*ea(76.0354614))));A=ea(B*ea(ea(ea(z*ea(-41.2831841))+ea(6.28318548))+ea(ea(z*z)*ea(76.0354614))));z=ea(D*ea(ea(ea(H*ea(-41.2831841))+ea(6.28318548))+ea(ea(H*H)*ea(76.0354614))));H=ea(G*E);D=ea(E*z);E=ea(I*z);z=ea(I*G);G=ea(-A);J=ea(ea(z*A)+ea(F*D));K=ea(ea(F*z)+ea(A*D));L=ea(ea(H*G)+ea(F*E));M=ea(ea(F*H)+ea(E*G))}else if((b|0)==1){G=ea(g[a+(q*88|0)+48>>2]);p=G>ea(0.0);E=ea(g[a+(q*88|0)+52>>2]);N=E>ea(0.0);H=ea(g[a+(q*88|0)+56>>2]);O=H>ea(0.0);F=ea(g[a+(q*88|0)+60>>2]);P=F>ea(0.0);D=ea(g[d+12>>2]);A=ea(-ea(G*s));z=ea(-ea(E*t));I=ea(-ea(H*u));B=ea(-ea(F*D));Q=G<ea(0.0);R=E<ea(0.0);U=H<ea(0.0);V=F<ea(0.0);W=(g[k>>2]=s,c[k>>2]|0);X=Q?(g[k>>2]=A,c[k>>2]|0):p?W:0;p=(g[k>>2]=t,c[k>>2]|0);Q=R?(g[k>>2]=z,c[k>>2]|0):N?p:0;N=(g[k>>2]=u,c[k>>2]|0);R=U?(g[k>>2]=I,c[k>>2]|0):O?N:0;O=(g[k>>2]=D,c[k>>2]|0);U=V?(g[k>>2]=B,c[k>>2]|0):P?O:0;B=ea(g[a+(q*88|0)+64>>2]);P=B<ea(0.0);I=ea(g[a+(q*88|0)+68>>2]);V=I<ea(0.0);z=ea(g[a+(q*88|0)+72>>2]);Y=z<ea(0.0);A=ea(g[a+(q*88|0)+76>>2]);Z=A<ea(0.0);F=ea(s*B);H=ea(t*I);E=ea(u*z);G=ea(D*A);_=B>ea(0.0);$=I>ea(0.0);aa=z>ea(0.0);ba=A>ea(0.0);ca=_?(g[k>>2]=F,c[k>>2]|0):P?W:0;W=$?(g[k>>2]=H,c[k>>2]|0):V?p:0;p=aa?(g[k>>2]=E,c[k>>2]|0):Y?N:0;N=ba?(g[k>>2]=G,c[k>>2]|0):Z?O:0;O=s<ea(0.0);Z=t<ea(0.0);ba=u<ea(0.0);Y=D<ea(0.0);aa=(O?X:ca)|0;ca=(Z?Q:W)|0;W=(ba?R:p)|0;p=(Y?U:N)|0;c[j>>2]=aa;c[j+4>>2]=ca;c[j+8>>2]=W;c[j+12>>2]=p;K$d(h,j);D=ea(g[h>>2]);G=ea(g[a+(q*88|0)+32>>2]);j=(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=(g[k>>2]=G,c[k>>2]|0)&-2147483648^j,ea(g[k>>2]));G=ea(g[h+4>>2]);E=ea(g[a+(q*88|0)+36>>2]);j=(g[k>>2]=G,c[k>>2]|0);G=(c[k>>2]=(g[k>>2]=E,c[k>>2]|0)&-2147483648^j,ea(g[k>>2]));E=ea(g[h+8>>2]);H=ea(g[a+(q*88|0)+40>>2]);h=(g[k>>2]=E,c[k>>2]|0);E=(c[k>>2]=(g[k>>2]=H,c[k>>2]|0)&-2147483648^h,ea(g[k>>2]));H=ea(G+ea(D*E));F=ea(E-ea(D*G));G=ea(ea(1.0)/ea(T(ea(ea(ea(F*F)+ea(1.0))+ea(ea(D*D)+ea(H*H))))));J=ea(G*H);K=G;L=ea(G*F);M=ea(D*G)}else if((b|0)==2){G=ea(g[a+(q*88|0)+48>>2]);b=G>ea(0.0);D=ea(g[a+(q*88|0)+52>>2]);h=D>ea(0.0);F=ea(g[a+(q*88|0)+56>>2]);j=F>ea(0.0);H=ea(g[a+(q*88|0)+60>>2]);p=H>ea(0.0);E=ea(g[d+12>>2]);A=ea(-ea(G*s));z=ea(-ea(D*t));I=ea(-ea(F*u));B=ea(-ea(H*E));W=G<ea(0.0);ca=D<ea(0.0);aa=F<ea(0.0);N=H<ea(0.0);U=(g[k>>2]=s,c[k>>2]|0);Y=W?(g[k>>2]=A,c[k>>2]|0):b?U:0;b=(g[k>>2]=t,c[k>>2]|0);W=ca?(g[k>>2]=z,c[k>>2]|0):h?b:0;h=(g[k>>2]=u,c[k>>2]|0);ca=aa?(g[k>>2]=I,c[k>>2]|0):j?h:0;j=(g[k>>2]=E,c[k>>2]|0);aa=N?(g[k>>2]=B,c[k>>2]|0):p?j:0;B=ea(g[a+(q*88|0)+64>>2]);p=B<ea(0.0);I=ea(g[a+(q*88|0)+68>>2]);N=I<ea(0.0);z=ea(g[a+(q*88|0)+72>>2]);R=z<ea(0.0);A=ea(g[a+(q*88|0)+76>>2]);ba=A<ea(0.0);H=ea(s*B);F=ea(t*I);D=ea(u*z);G=ea(E*A);Q=B>ea(0.0);Z=I>ea(0.0);X=z>ea(0.0);O=A>ea(0.0);V=Q?(g[k>>2]=H,c[k>>2]|0):p?U:0;U=Z?(g[k>>2]=F,c[k>>2]|0):N?b:0;b=X?(g[k>>2]=D,c[k>>2]|0):R?h:0;h=O?(g[k>>2]=G,c[k>>2]|0):ba?j:0;j=s<ea(0.0);ba=t<ea(0.0);O=u<ea(0.0);R=E<ea(0.0);X=(j?Y:V)|0;V=(ba?W:U)|0;U=(O?ca:b)|0;b=(R?aa:h)|0;c[m>>2]=X;c[m+4>>2]=V;c[m+8>>2]=U;c[m+12>>2]=b;K$d(l,m);E=ea(g[l>>2]);G=ea(g[a+(q*88|0)+32>>2]);m=(g[k>>2]=E,c[k>>2]|0);E=(c[k>>2]=(g[k>>2]=G,c[k>>2]|0)&-2147483648^m,ea(g[k>>2]));G=ea(g[l+4>>2]);D=ea(g[a+(q*88|0)+36>>2]);m=(g[k>>2]=G,c[k>>2]|0);G=(c[k>>2]=(g[k>>2]=D,c[k>>2]|0)&-2147483648^m,ea(g[k>>2]));D=ea(g[l+8>>2]);F=ea(g[a+(q*88|0)+40>>2]);l=(g[k>>2]=D,c[k>>2]|0);D=(c[k>>2]=(g[k>>2]=F,c[k>>2]|0)&-2147483648^l,ea(g[k>>2]));F=ea(G-ea(E*D));H=ea(ea(E*G)+D);D=ea(ea(1.0)/ea(T(ea(ea(ea(H*H)+ea(1.0))+ea(ea(E*E)+ea(F*F))))));J=ea(D*F);K=D;L=ea(D*H);M=ea(E*D)}else{D=ea(g[a+(q*88|0)+48>>2]);l=D>ea(0.0);E=ea(g[a+(q*88|0)+52>>2]);m=E>ea(0.0);H=ea(g[a+(q*88|0)+56>>2]);b=H>ea(0.0);F=ea(g[a+(q*88|0)+60>>2]);U=F>ea(0.0);G=ea(g[d+12>>2]);A=ea(-ea(D*s));z=ea(-ea(E*t));I=ea(-ea(H*u));B=ea(-ea(F*G));d=D<ea(0.0);V=E<ea(0.0);X=H<ea(0.0);h=F<ea(0.0);aa=(g[k>>2]=s,c[k>>2]|0);R=d?(g[k>>2]=A,c[k>>2]|0):l?aa:0;l=(g[k>>2]=t,c[k>>2]|0);d=V?(g[k>>2]=z,c[k>>2]|0):m?l:0;m=(g[k>>2]=u,c[k>>2]|0);V=X?(g[k>>2]=I,c[k>>2]|0):b?m:0;b=(g[k>>2]=G,c[k>>2]|0);X=h?(g[k>>2]=B,c[k>>2]|0):U?b:0;B=ea(g[a+(q*88|0)+64>>2]);U=B<ea(0.0);I=ea(g[a+(q*88|0)+68>>2]);h=I<ea(0.0);z=ea(g[a+(q*88|0)+72>>2]);ca=z<ea(0.0);A=ea(g[a+(q*88|0)+76>>2]);O=A<ea(0.0);F=ea(s*B);H=ea(t*I);E=ea(u*z);D=ea(G*A);W=B>ea(0.0);ba=I>ea(0.0);Y=z>ea(0.0);j=A>ea(0.0);N=W?(g[k>>2]=F,c[k>>2]|0):U?aa:0;aa=ba?(g[k>>2]=H,c[k>>2]|0):h?l:0;l=Y?(g[k>>2]=E,c[k>>2]|0):ca?m:0;m=j?(g[k>>2]=D,c[k>>2]|0):O?b:0;b=s<ea(0.0);O=t<ea(0.0);j=u<ea(0.0);ca=G<ea(0.0);Y=(b?R:N)|0;N=(O?d:aa)|0;aa=(j?V:l)|0;l=(ca?X:m)|0;c[o>>2]=Y;c[o+4>>2]=N;c[o+8>>2]=aa;c[o+12>>2]=l;K$d(n,o);G=ea(g[n>>2]);u=ea(g[a+(q*88|0)+32>>2]);o=(g[k>>2]=G,c[k>>2]|0);G=(c[k>>2]=(g[k>>2]=u,c[k>>2]|0)&-2147483648^o,ea(g[k>>2]));u=ea(g[n+4>>2]);t=ea(g[a+(q*88|0)+36>>2]);o=(g[k>>2]=u,c[k>>2]|0);u=(c[k>>2]=(g[k>>2]=t,c[k>>2]|0)&-2147483648^o,ea(g[k>>2]));t=ea(g[n+8>>2]);s=ea(g[a+(q*88|0)+40>>2]);n=(g[k>>2]=t,c[k>>2]|0);t=(c[k>>2]=(g[k>>2]=s,c[k>>2]|0)&-2147483648^n,ea(g[k>>2]));s=ea(ea(1.0)/ea(T(ea(ea(ea(G*G)+ea(u*u))+ea(ea(t*t)+ea(1.0))))));J=ea(u*s);K=s;L=ea(s*t);M=ea(G*s)}s=ea(-ea(g[a+(q*88|0)+16>>2]));G=ea(-ea(g[a+(q*88|0)+20>>2]));t=ea(-ea(g[a+(q*88|0)+24>>2]));u=ea(g[a+(q*88|0)+28>>2]);D=ea(ea(ea(ea(K*u)-ea(M*s))-ea(L*t))-ea(J*G));E=ea(-ea(ea(ea(ea(L*G)-ea(J*t))-ea(K*s))-ea(M*u)));H=ea(-ea(ea(ea(ea(M*t)-ea(L*s))-ea(K*G))-ea(J*u)));F=ea(-ea(ea(ea(ea(J*s)-ea(K*t))-ea(L*u))-ea(M*G)));G=ea(g[a+(q*88|0)+4>>2]);M=ea(G*E);u=ea(g[a+(q*88|0)+12>>2]);L=ea(u*D);t=ea(g[a+(q*88|0)+8>>2]);K=ea(t*H);s=ea(g[a+(q*88|0)>>2]);J=ea(ea(ea(M-ea(u*F))-ea(t*D))-ea(s*H));M=ea(ea(ea(L-ea(s*E))-ea(t*F))-ea(G*H));L=ea(ea(ea(K-ea(G*F))-ea(u*E))-ea(s*D));K=ea(ea(ea(ea(s*F)-ea(t*E))-ea(u*H))-ea(G*D));D=ea(ea(1.0)/ea(T(ea(ea(ea(J*J)+ea(M*M))+ea(ea(K*K)+ea(L*L))))));G=ea(-ea(D*L));L=ea(-ea(D*K));K=ea(-ea(D*J));J=ea(D*M);a=(q|0)!=-1;g[r+(e*48|0)+16>>2]=a?G:w;g[r+(e*48|0)+20>>2]=a?L:x;g[r+(e*48|0)+24>>2]=a?K:y;g[r+(e*48|0)+28>>2]=a?J:v;i=f;return}function E$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;f=i;h=a+4|0;j=c[(c[h>>2]|0)+h+(e<<3)+4>>2]|0;if((j|0)==-1){i=f;return}e=a+24|0;a=(c[e>>2]|0)+e|0;k=ea(g[a+(j*88|0)+16>>2]);l=ea(g[a+(j*88|0)+20>>2]);m=ea(g[a+(j*88|0)+24>>2]);n=ea(g[a+(j*88|0)+28>>2]);o=ea(g[b+4>>2]);p=ea(k*o);q=ea(g[b+12>>2]);r=ea(n*q);s=ea(g[b+8>>2]);t=ea(l*s);u=ea(g[b>>2]);v=ea(ea(ea(p-ea(m*q))-ea(n*s))-ea(l*u));p=ea(ea(ea(r-ea(k*u))-ea(m*s))-ea(l*o));r=ea(ea(ea(t-ea(m*o))-ea(k*q))-ea(n*u));t=ea(ea(ea(ea(m*u)-ea(k*s))-ea(l*q))-ea(n*o));o=ea(ea(1.0)/ea(T(ea(ea(ea(r*r)+ea(t*t))+ea(ea(v*v)+ea(p*p))))));q=ea(o*r);r=ea(o*t);t=ea(v*o);v=ea(o*p);p=ea(q*v);o=ea(ea(q*q)+ea(ea(v*v)+ea(-.5)));s=ea(ea(q*r)-ea(t*v));u=ea(ea(t*q)+ea(r*v));v=ea(p-p);p=ea(o+o);o=ea(s+s);s=ea(u+u);u=ea(v+v);b=d+4|0;v=ea(g[b>>2]);r=ea(k*v);j=d+12|0;q=ea(g[j>>2]);t=ea(n*q);a=d+8|0;w=ea(g[a>>2]);x=ea(l*w);y=ea(g[d>>2]);z=ea(ea(ea(r-ea(m*q))-ea(n*w))-ea(l*y));r=ea(ea(ea(t-ea(k*y))-ea(m*w))-ea(l*v));t=ea(ea(ea(x-ea(m*v))-ea(k*q))-ea(n*y));x=ea(ea(ea(ea(m*y)-ea(k*w))-ea(l*q))-ea(n*v));n=ea(ea(1.0)/ea(T(ea(ea(ea(t*t)+ea(x*x))+ea(ea(z*z)+ea(r*r))))));l=ea(n*t);t=ea(n*x);x=ea(z*n);z=ea(n*r);r=ea(l*z);n=ea(ea(l*l)+ea(ea(z*z)+ea(-.5)));k=ea(ea(l*t)-ea(x*z));m=ea(ea(x*l)+ea(t*z));z=ea(r-r);r=ea(n+n);n=ea(k+k);k=ea(m+m);m=ea(z+z);z=ea(ea(o*r)-ea(p*n));t=ea(ea(s*n)-ea(o*k));l=ea(ea(p*k)-ea(s*r));x=ea(ea(T(ea(ea(ea(ea(s*s)+ea(u*u))+ea(ea(o*o)+ea(p*p)))*ea(ea(ea(k*k)+ea(m*m))+ea(ea(n*n)+ea(r*r))))))+ea(ea(ea(s*k)+ea(u*m))+ea(ea(o*n)+ea(p*r))));r=ea(ea(ea(ea(y*l)-ea(w*x))-ea(q*z))-ea(v*t));p=ea(ea(ea(ea(q*x)-ea(y*t))-ea(w*z))-ea(v*l));n=ea(ea(ea(ea(v*z)-ea(w*l))-ea(y*x))-ea(q*t));o=ea(ea(ea(ea(w*t)-ea(y*z))-ea(v*x))-ea(q*l));l=ea(ea(1.0)/ea(T(ea(ea(ea(n*n)+ea(o*o))+ea(ea(r*r)+ea(p*p))))));q=ea(-ea(l*o));o=ea(-ea(l*r));r=ea(l*p);g[d>>2]=ea(-ea(l*n));g[b>>2]=q;g[a>>2]=o;g[j>>2]=r;i=f;return}function F$d(a,b,d,e,f,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im;a=i;l=k+4|0;m=(c[l>>2]|0)+l|0;n=ea(g[m+(d*48|0)>>2]);o=ea(g[m+(b*48|0)>>2]);p=ea(n-o);q=ea(g[m+(d*48|0)+4>>2]);r=ea(g[m+(b*48|0)+4>>2]);s=ea(q-r);t=ea(g[m+(d*48|0)+8>>2]);u=ea(g[m+(b*48|0)+8>>2]);v=ea(t-u);w=ea(g[m+(d*48|0)+12>>2]);x=ea(g[m+(b*48|0)+12>>2]);y=ea(w-x);z=ea(ea(g[m+(e*48|0)>>2])-n);n=ea(ea(g[m+(e*48|0)+4>>2])-q);q=ea(ea(g[m+(e*48|0)+8>>2])-t);t=ea(ea(g[m+(e*48|0)+12>>2])-w);c[k+8>>2]=m;w=ea(ea(g[f>>2])-o);o=ea(ea(g[f+4>>2])-r);r=ea(ea(g[f+8>>2])-u);u=ea(ea(g[f+12>>2])-x);x=ea(ea(T(ea(ea(ea(w*w)+ea(o*o))+ea(ea(r*r)+ea(u*u)))))/ea(ea(T(ea(ea(ea(p*p)+ea(s*s))+ea(ea(v*v)+ea(y*y)))))+ea(T(ea(ea(ea(z*z)+ea(n*n))+ea(ea(q*q)+ea(t*t)))))));t=ea(g[h>>2]);q=ea(ea(1.0)-t);if(!(x>q)){i=a;return}n=ea(VDi(ea(1.0),ea(UDi(ea(0.0),ea(ea(x-q)/ea(t*ea(2.0)))))));q=ea(ea(n*ea(t*n))+ea(1.0));h=j+4|0;f=(c[h>>2]|0)+h|0;h=f+(d*48|0)|0;n=ea(ea(g[h>>2])*q);m=f+(d*48|0)+4|0;t=ea(ea(g[m>>2])*q);k=f+(d*48|0)+8|0;x=ea(q*ea(g[k>>2]));b=f+(d*48|0)+12|0;z=ea(q*ea(g[b>>2]));g[h>>2]=n;g[m>>2]=t;g[k>>2]=x;g[b>>2]=z;c[j+8>>2]=f;j=f+(e*48|0)|0;z=ea(q*ea(g[j>>2]));b=f+(e*48|0)+4|0;x=ea(q*ea(g[b>>2]));k=f+(e*48|0)+8|0;t=ea(q*ea(g[k>>2]));m=f+(e*48|0)+12|0;n=ea(q*ea(g[m>>2]));g[j>>2]=z;g[b>>2]=x;g[k>>2]=t;g[m>>2]=n;i=a;return}function G$d(a,b,d,e,f,h,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,U=Im,V=Im,W=Im,X=0,Z=0,_=0,$=0;m=i;i=i+32|0;n=m+16|0;o=m;p=j+4|0;q=p;r=(c[p>>2]|0)+q|0;s=j+8|0;c[s>>2]=r;t=ea(g[r+(b*48|0)+16>>2]);u=ea(g[r+(b*48|0)+20>>2]);v=ea(g[r+(b*48|0)+24>>2]);w=ea(g[r+(b*48|0)+28>>2]);c[s>>2]=r;x=ea(g[r+(d*48|0)+16>>2]);y=ea(g[r+(d*48|0)+20>>2]);z=ea(g[r+(d*48|0)+24>>2]);A=ea(g[r+(d*48|0)+28>>2]);C$d(o,a,j,d);B=ea(g[o>>2]);C=ea(ea(g[o+4>>2])*ea(0.0));D=ea(ea(g[o+8>>2])*ea(.899999976));E=ea(ea(g[o+12>>2])*ea(0.0));g[n>>2]=B;g[n+4>>2]=C;g[n+8>>2]=D;g[n+12>>2]=E;D$d(a,j,n,d);y$d(a,j,l,e,d);n=l+4|0;o=n;r=(c[n>>2]|0)+o|0;F=l+8|0;E=ea(g[r+(d*48|0)>>2]);D=ea(g[r+(b*48|0)>>2]);C=ea(E-D);B=ea(g[r+(d*48|0)+4>>2]);G=ea(g[r+(b*48|0)+4>>2]);H=ea(B-G);I=ea(g[r+(d*48|0)+8>>2]);J=ea(g[r+(b*48|0)+8>>2]);K=ea(I-J);L=ea(g[r+(d*48|0)+12>>2]);M=ea(g[r+(b*48|0)+12>>2]);N=ea(L-M);O=ea(g[r+(e*48|0)>>2]);P=ea(O-E);E=ea(g[r+(e*48|0)+4>>2]);Q=ea(E-B);B=ea(g[r+(e*48|0)+8>>2]);R=ea(B-I);I=ea(g[r+(e*48|0)+12>>2]);U=ea(I-L);L=ea(O-D);O=ea(E-G);E=ea(B-J);B=ea(I-M);c[F>>2]=r;I=ea(ea(g[f>>2])-D);D=ea(ea(g[f+4>>2])-G);G=ea(ea(g[f+8>>2])-J);J=ea(ea(g[f+12>>2])-M);M=ea(T(ea(ea(ea(C*C)+ea(H*H))+ea(ea(K*K)+ea(N*N)))));V=ea(T(ea(ea(ea(P*P)+ea(Q*Q))+ea(ea(R*R)+ea(U*U)))));W=ea(T(ea(ea(ea(L*L)+ea(O*O))+ea(ea(E*E)+ea(B*B)))));B=ea(ea(ea(I*I)+ea(D*D))+ea(ea(G*G)+ea(J*J)));E=ea(T(ea(B)));O=ea(ea(M*M)+ea(V*V));L=ea(M*V);V=ea(+Y(+ea(VDi(ea(UDi(ea(ea(ea(O-ea(W*W))/L)*ea(.5)),ea(-1.0))),ea(1.0)))));W=ea(N*U);U=ea(ea(C*Q)-ea(H*P));N=ea(ea(H*R)-ea(K*Q));Q=ea(ea(K*P)-ea(C*R));R=ea(W-W);W=ea(ea(1.0)/ea(T(ea(ea(ea(N*N)+ea(Q*Q))+ea(ea(U*U)+ea(R*R))))));C=ea(ea(N*W)+ea(0.0));N=ea(ea(Q*W)+ea(0.0));Q=ea(ea(U*W)+ea(0.0));U=ea(ea(R*W)+ea(1.0));W=ea(ea(ea(V-ea(+Y(+ea(VDi(ea(UDi(ea(ea(ea(O-ea(E*E))/L)*ea(.5)),ea(-1.0))),ea(1.0))))))*ea(.5))*ea(.159154937));L=ea(W+ea(-.25));E=ea(W+ea(0.0));W=ea(eEi(L));O=ea(ea(.25)-ea(S(ea(L-W))));W=ea(ea(.25)-ea(S(ea(E-ea(eEi(E))))));E=ea(O*O);L=ea(W*W);V=ea(O*ea(ea(ea(E*ea(-41.2831841))+ea(6.28318548))+ea(ea(E*E)*ea(76.0354614))));E=ea(C*V);C=ea(N*V);N=ea(Q*V);V=ea(U*ea(W*ea(ea(ea(L*ea(-41.2831841))+ea(6.28318548))+ea(ea(L*L)*ea(76.0354614)))));f=(c[n>>2]|0)+o|0;c[F>>2]=f;r=f+(d*48|0)+16|0;L=ea(g[r>>2]);W=ea(L*C);X=f+(d*48|0)+28|0;U=ea(g[X>>2]);Q=ea(U*V);Z=f+(d*48|0)+20|0;O=ea(g[Z>>2]);R=ea(O*N);_=f+(d*48|0)+24|0;P=ea(g[_>>2]);K=ea(ea(ea(W-ea(P*V))-ea(U*N))-ea(O*E));W=ea(ea(ea(Q-ea(L*E))-ea(N*P))-ea(O*C));Q=ea(ea(ea(R-ea(P*C))-ea(L*V))-ea(U*E));R=ea(ea(ea(ea(E*P)-ea(L*N))-ea(O*V))-ea(U*C));C=ea(ea(1.0)/ea(T(ea(ea(ea(Q*Q)+ea(R*R))+ea(ea(K*K)+ea(W*W))))));U=ea(-ea(C*R));R=ea(-ea(C*K));K=ea(C*W);g[r>>2]=ea(-ea(C*Q));g[Z>>2]=U;g[_>>2]=R;g[X>>2]=K;A$d(a,l,j,d,d);X=(c[p>>2]|0)+q|0;c[s>>2]=X;_=X+(d*48|0)+16|0;K=ea(g[_>>2]);R=ea(x*K);Z=X+(d*48|0)+20|0;U=ea(g[Z>>2]);Q=ea(y*U);r=X+(d*48|0)+24|0;C=ea(g[r>>2]);W=ea(z*C);f=X+(d*48|0)+28|0;V=ea(g[f>>2]);O=ea(ea(R+Q)+ea(W+ea(A*V)));X=(g[k>>2]=K,c[k>>2]|0);$=(g[k>>2]=O,c[k>>2]|0)&-2147483648;O=(c[k>>2]=$^X,ea(g[k>>2]));K=(c[k>>2]=$^(g[k>>2]=U,c[k>>2]|0),ea(g[k>>2]));U=(c[k>>2]=$^(g[k>>2]=C,c[k>>2]|0),ea(g[k>>2]));C=ea(x+ea(ea(O-x)*h));x=ea(y+ea(ea(K-y)*h));y=ea(z+ea(ea(U-z)*h));z=ea(A+ea(ea((c[k>>2]=$^(g[k>>2]=V,c[k>>2]|0),ea(g[k>>2]))-A)*h));A=ea(ea(1.0)/ea(T(ea(ea(ea(C*C)+ea(x*x))+ea(ea(y*y)+ea(z*z))))));V=ea(A*x);x=ea(A*y);y=ea(A*z);g[_>>2]=ea(A*C);g[Z>>2]=V;g[r>>2]=x;g[f>>2]=y;y$d(a,j,l,e,d);d=(c[n>>2]|0)+o|0;y=ea(g[d+(e*48|0)>>2]);x=ea(y-ea(g[d+(b*48|0)>>2]));y=ea(g[d+(e*48|0)+4>>2]);V=ea(y-ea(g[d+(b*48|0)+4>>2]));y=ea(g[d+(e*48|0)+8>>2]);C=ea(y-ea(g[d+(b*48|0)+8>>2]));y=ea(g[d+(e*48|0)+12>>2]);A=ea(y-ea(g[d+(b*48|0)+12>>2]));y=ea(ea(D*x)-ea(I*V));z=ea(ea(G*V)-ea(D*C));U=ea(ea(I*C)-ea(G*x));K=ea(ea(T(ea(B*ea(ea(ea(x*x)+ea(V*V))+ea(ea(C*C)+ea(A*A))))))+ea(ea(ea(I*x)+ea(D*V))+ea(ea(G*C)+ea(J*A))));A=ea(ea(1.0)/ea(T(ea(ea(ea(z*z)+ea(U*U))+ea(ea(y*y)+ea(K*K))))));J=ea(z*A);z=ea(U*A);U=ea(y*A);y=ea(A*K);c[F>>2]=d;F=d+(b*48|0)+16|0;K=ea(g[F>>2]);A=ea(z*K);e=d+(b*48|0)+28|0;C=ea(g[e>>2]);G=ea(y*C);o=d+(b*48|0)+20|0;V=ea(g[o>>2]);D=ea(U*V);n=d+(b*48|0)+24|0;x=ea(g[n>>2]);I=ea(ea(ea(A-ea(y*x))-ea(U*C))-ea(J*V));A=ea(ea(ea(G-ea(J*K))-ea(U*x))-ea(z*V));G=ea(ea(ea(D-ea(z*x))-ea(y*K))-ea(J*C));D=ea(ea(ea(ea(J*x)-ea(U*K))-ea(y*V))-ea(z*C));C=ea(ea(1.0)/ea(T(ea(ea(ea(G*G)+ea(D*D))+ea(ea(A*A)+ea(I*I))))));z=ea(-ea(C*D));D=ea(-ea(C*I));I=ea(C*A);g[F>>2]=ea(-ea(C*G));g[o>>2]=z;g[n>>2]=D;g[e>>2]=I;A$d(a,l,j,b,b);j=(c[p>>2]|0)+q|0;c[s>>2]=j;I=ea(SDi(ea(ea(bEi(ea(ea(1.0)-h)))*ea(4.0))));s=j+(b*48|0)+16|0;h=ea(g[s>>2]);D=ea(t*h);q=j+(b*48|0)+20|0;z=ea(g[q>>2]);G=ea(u*z);p=j+(b*48|0)+24|0;C=ea(g[p>>2]);A=ea(v*C);l=j+(b*48|0)+28|0;V=ea(g[l>>2]);y=ea(ea(D+G)+ea(A+ea(w*V)));b=(g[k>>2]=t,c[k>>2]|0);j=(g[k>>2]=y,c[k>>2]|0)&-2147483648;y=(c[k>>2]=j^b,ea(g[k>>2]));t=(c[k>>2]=j^(g[k>>2]=u,c[k>>2]|0),ea(g[k>>2]));u=(c[k>>2]=j^(g[k>>2]=v,c[k>>2]|0),ea(g[k>>2]));v=ea(h+ea(I*ea(y-h)));h=ea(z+ea(I*ea(t-z)));z=ea(C+ea(I*ea(u-C)));C=ea(V+ea(I*ea((c[k>>2]=j^(g[k>>2]=w,c[k>>2]|0),ea(g[k>>2]))-V)));V=ea(ea(1.0)/ea(T(ea(ea(ea(v*v)+ea(h*h))+ea(ea(z*z)+ea(C*C))))));w=ea(V*h);h=ea(V*z);z=ea(V*C);g[s>>2]=ea(V*v);g[q>>2]=w;g[p>>2]=h;g[l>>2]=z;i=m;return}function H$d(a,b,d,e,f,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=ea(l);var m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im;m=i;n=k+4|0;o=(c[n>>2]|0)+n|0;n=k+8|0;c[n>>2]=o;p=ea(g[o+(b*48|0)>>2]);q=ea(g[o+(b*48|0)+4>>2]);r=ea(g[o+(b*48|0)+8>>2]);s=ea(g[o+(b*48|0)+12>>2]);c[n>>2]=o;t=ea(g[o+(d*48|0)>>2]);u=ea(g[o+(d*48|0)+4>>2]);v=ea(g[o+(d*48|0)+8>>2]);w=ea(g[o+(d*48|0)+12>>2]);c[n>>2]=o;x=ea(g[o+(e*48|0)>>2]);y=ea(g[o+(e*48|0)+4>>2]);z=ea(g[o+(e*48|0)+8>>2]);A=ea(g[o+(e*48|0)+12>>2]);B=ea(x-p);C=ea(y-q);D=ea(z-r);E=ea(A-s);F=ea(T(ea(ea(ea(B*B)+ea(C*C))+ea(ea(D*D)+ea(E*E)))));if(!(F>ea(0.0))){i=m;return}G=ea(B/F);B=ea(C/F);C=ea(D/F);D=ea(E/F);F=ea(t-p);E=ea(u-q);H=ea(v-r);I=ea(w-s);J=ea(ea(g[f>>2])-p);p=ea(ea(g[f+4>>2])-q);q=ea(ea(g[f+8>>2])-r);r=ea(ea(g[f+12>>2])-s);s=ea(ea(ea(F*G)+ea(E*B))+ea(ea(H*C)+ea(I*D)));K=ea(ea(ea(G*J)+ea(B*p))+ea(ea(C*q)+ea(D*r)));L=ea(F-ea(G*s));M=ea(E-ea(B*s));N=ea(H-ea(C*s));O=ea(I-ea(D*s));s=ea(J-ea(G*K));G=ea(p-ea(B*K));B=ea(q-ea(C*K));C=ea(r-ea(D*K));K=ea(ea(ea(L*L)+ea(M*M))+ea(ea(N*N)+ea(O*O)));D=ea(T(ea(K)));r=ea(ea(ea(s*s)+ea(G*G))+ea(ea(B*B)+ea(C*C)));if(!(D>ea(0.0)&ea(T(ea(r)))>ea(0.0))){i=m;return}q=ea(x-t);t=ea(y-u);u=ea(z-v);v=ea(A-w);w=ea(ea(ea(T(ea(ea(ea(F*F)+ea(E*E))+ea(ea(H*H)+ea(I*I)))))+ea(T(ea(ea(ea(q*q)+ea(t*t))+ea(ea(u*u)+ea(v*v))))))*l);if(!(D>w)){i=m;return}l=ea(w*ea(2.0));v=ea(ea(1.0)-ea(ea(l-D)/ea(l-w)));w=ea(ea(ea(ea(L*s)+ea(M*G))+ea(ea(N*B)+ea(O*C)))+ea(T(ea(K*r))));r=ea((D>l?ea(1.0):v)*h);h=ea(ea(ea(M*B)-ea(N*G))*r);v=ea(ea(ea(N*s)-ea(L*B))*r);B=ea(ea(ea(L*G)-ea(M*s))*r);c[n>>2]=o;n=o+(b*48|0)+16|0;r=ea(g[n>>2]);s=ea(v*r);f=o+(b*48|0)+28|0;M=ea(g[f>>2]);G=ea(w*M);e=o+(b*48|0)+20|0;L=ea(g[e>>2]);N=ea(B*L);d=o+(b*48|0)+24|0;l=ea(g[d>>2]);D=ea(ea(ea(s-ea(w*l))-ea(B*M))-ea(h*L));s=ea(ea(ea(G-ea(r*h))-ea(B*l))-ea(v*L));G=ea(ea(ea(N-ea(v*l))-ea(w*r))-ea(h*M));N=ea(ea(ea(ea(h*l)-ea(r*B))-ea(w*L))-ea(v*M));M=ea(ea(1.0)/ea(T(ea(ea(ea(G*G)+ea(N*N))+ea(ea(s*s)+ea(D*D))))));v=ea(-ea(M*N));N=ea(-ea(M*D));D=ea(M*s);g[n>>2]=ea(-ea(M*G));g[e>>2]=v;g[d>>2]=N;g[f>>2]=D;A$d(a,k,j,b,b);i=m;return}function I$d(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=0,f=Im,h=0,i=Im,j=0,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(g[c>>2]);e=b+32|0;f=ea(d*ea(g[e>>2]));d=ea(g[c+4>>2]);h=b+36|0;i=ea(d*ea(g[h>>2]));d=ea(g[c+8>>2]);j=b+40|0;k=ea(d*ea(g[j>>2]));d=ea(g[c+12>>2]);l=b+44|0;m=ea(d*ea(g[l>>2]));d=ea(f+f);n=ea(i+i);o=ea(k+k);p=ea(g[b+16>>2]);q=ea(n*p);r=ea(g[b+20>>2]);s=ea(o*r);t=ea(g[b+24>>2]);u=ea(d*t);v=ea(g[b+28>>2]);w=ea(v*ea(0.0));x=ea(q-ea(d*r));d=ea(s-ea(n*t));n=ea(u-ea(o*p));o=ea(v*ea(w-w));w=ea(ea(f+ea(v*d))+ea(ea(r*x)-ea(t*n)));f=ea(ea(i+ea(v*n))+ea(ea(t*d)-ea(p*x)));i=ea(ea(k+ea(x*v))+ea(ea(p*n)-ea(r*d)));d=ea(ea(m+o)+ea(o-o));o=ea(ea(g[b>>2])+w);w=ea(ea(g[b+4>>2])+f);f=ea(ea(g[b+8>>2])+i);i=ea(ea(g[b+12>>2])+d);d=ea(g[c+16>>2]);m=ea(r*d);n=ea(g[c+28>>2]);x=ea(v*n);k=ea(g[c+20>>2]);u=ea(t*k);s=ea(g[c+24>>2]);q=ea(ea(ea(m-ea(v*s))-ea(n*t))-ea(k*p));m=ea(ea(ea(x-ea(d*p))-ea(t*s))-ea(r*k));x=ea(ea(ea(u-ea(r*s))-ea(d*v))-ea(n*p));u=ea(ea(ea(ea(p*s)-ea(d*t))-ea(v*k))-ea(r*n));n=ea(ea(1.0)/ea(T(ea(ea(ea(x*x)+ea(u*u))+ea(ea(m*m)+ea(q*q))))));r=ea(-ea(n*x));x=ea(-ea(n*u));u=ea(-ea(n*q));q=ea(n*m);m=ea(g[e>>2]);n=ea(m*ea(g[c+32>>2]));m=ea(g[h>>2]);k=ea(m*ea(g[c+36>>2]));m=ea(g[j>>2]);v=ea(m*ea(g[c+40>>2]));m=ea(g[l>>2]);t=ea(m*ea(g[c+44>>2]));g[a>>2]=o;g[a+4>>2]=w;g[a+8>>2]=f;g[a+12>>2]=i;g[a+16>>2]=r;g[a+20>>2]=x;g[a+24>>2]=u;g[a+28>>2]=q;g[a+32>>2]=n;g[a+36>>2]=k;g[a+40>>2]=v;g[a+44>>2]=t;return}function J$d(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;d=ea(-ea(g[b+16>>2]));e=ea(-ea(g[b+20>>2]));f=ea(-ea(g[b+24>>2]));h=ea(g[b+28>>2]);i=ea(g[c>>2]);j=ea(i-ea(g[b>>2]));i=ea(g[c+4>>2]);k=ea(i-ea(g[b+4>>2]));i=ea(g[c+8>>2]);l=ea(i-ea(g[b+8>>2]));i=ea(g[c+12>>2]);m=ea(j+j);n=ea(k+k);o=ea(l+l);p=ea(h*ea(0.0));q=ea(ea(n*d)-ea(m*e));r=ea(ea(o*e)-ea(n*f));n=ea(ea(m*f)-ea(o*d));o=ea(h*ea(p-p));p=ea(ea(j+ea(h*r))+ea(ea(q*e)-ea(n*f)));j=ea(ea(k+ea(h*n))+ea(ea(r*f)-ea(q*d)));k=ea(ea(l+ea(h*q))+ea(ea(n*d)-ea(r*e)));r=ea(ea(o-o)+ea(o+ea(i-ea(g[b+12>>2]))));i=ea(g[b+32>>2]);o=ea(p/i);p=ea(g[b+36>>2]);n=ea(j/p);j=ea(g[b+40>>2]);q=ea(k/j);k=ea(g[b+44>>2]);l=ea(r/k);r=ea(g[c+16>>2]);m=ea(r*e);s=ea(g[c+28>>2]);t=ea(h*s);u=ea(g[c+20>>2]);v=ea(u*f);w=ea(g[c+24>>2]);x=ea(ea(ea(m-ea(h*w))-ea(s*f))-ea(u*d));m=ea(ea(ea(t-ea(r*d))-ea(w*f))-ea(u*e));t=ea(ea(ea(v-ea(w*e))-ea(h*r))-ea(s*d));v=ea(ea(ea(ea(w*d)-ea(r*f))-ea(h*u))-ea(s*e));e=ea(ea(1.0)/ea(T(ea(ea(ea(t*t)+ea(v*v))+ea(ea(m*m)+ea(x*x))))));s=ea(-ea(e*t));t=ea(-ea(e*v));v=ea(-ea(e*x));x=ea(e*m);m=ea(ea(g[c+32>>2])/i);i=ea(ea(g[c+36>>2])/p);p=ea(ea(g[c+40>>2])/j);j=ea(ea(g[c+44>>2])/k);g[a>>2]=o;g[a+4>>2]=n;g[a+8>>2]=q;g[a+12>>2]=l;g[a+16>>2]=s;g[a+20>>2]=t;g[a+24>>2]=v;g[a+28>>2]=x;g[a+32>>2]=m;g[a+36>>2]=i;g[a+40>>2]=p;g[a+44>>2]=j;return}function K$d(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im;c=i;d=ea(g[b>>2]);e=ea(S(ea(d)));f=ea(g[b+4>>2]);h=ea(S(ea(f)));j=ea(g[b+8>>2]);k=ea(S(ea(j)));l=ea(g[b+12>>2]);m=ea(ea(ea(h*ea(.5))+ea(1.57079637))+ea(-1.57079637));h=ea(ea(ea(k*ea(.5))+ea(1.57079637))+ea(-1.57079637));k=ea(ea(ea(ea(S(ea(l)))*ea(.5))+ea(1.57079637))+ea(-1.57079637));n=ea(PDi(ea(ea(ea(e*ea(.5))+ea(1.57079637))+ea(-1.57079637)),d));d=ea(PDi(m,f));f=ea(PDi(h,j));j=ea(PDi(k,l));l=ea(VDi(ea(UDi(n,ea(-1.57079542))),ea(1.57079732)));n=ea(VDi(ea(UDi(d,ea(-1.57079542))),ea(1.57079732)));d=ea(VDi(ea(UDi(f,ea(-1.57079542))),ea(1.57079732)));f=ea(l*ea(.159154937));l=ea(n*ea(.159154937));n=ea(d*ea(.159154937));d=ea(ea(VDi(ea(UDi(j,ea(-1.57079542))),ea(1.57079732)))*ea(.159154937));j=ea(eEi(f));k=ea(eEi(l));h=ea(eEi(n));m=ea(ea(.25)-ea(S(ea(f-j))));j=ea(ea(.25)-ea(S(ea(l-k))));k=ea(ea(.25)-ea(S(ea(n-h))));h=ea(ea(.25)-ea(S(ea(d-ea(eEi(d))))));e=ea(m*m);o=ea(j*j);p=ea(k*k);q=ea(h*h);r=ea(m*ea(ea(ea(e*ea(-41.2831841))+ea(6.28318548))+ea(ea(e*e)*ea(76.0354614))));e=ea(j*ea(ea(ea(o*ea(-41.2831841))+ea(6.28318548))+ea(ea(o*o)*ea(76.0354614))));o=ea(k*ea(ea(ea(p*ea(-41.2831841))+ea(6.28318548))+ea(ea(p*p)*ea(76.0354614))));p=ea(h*ea(ea(ea(q*ea(-41.2831841))+ea(6.28318548))+ea(ea(q*q)*ea(76.0354614))));q=ea(f+ea(-.25));f=ea(l+ea(-.25));l=ea(n+ea(-.25));n=ea(d+ea(-.25));d=ea(eEi(q));h=ea(eEi(f));k=ea(eEi(l));j=ea(ea(.25)-ea(S(ea(q-d))));d=ea(ea(.25)-ea(S(ea(f-h))));h=ea(ea(.25)-ea(S(ea(l-k))));k=ea(ea(.25)-ea(S(ea(n-ea(eEi(n))))));n=ea(j*j);l=ea(d*d);f=ea(h*h);q=ea(k*k);m=ea(ea(d*ea(ea(ea(l*ea(-41.2831841))+ea(6.28318548))+ea(ea(l*l)*ea(76.0354614))))/e);e=ea(ea(h*ea(ea(ea(f*ea(-41.2831841))+ea(6.28318548))+ea(ea(f*f)*ea(76.0354614))))/o);o=ea(ea(k*ea(ea(ea(q*ea(-41.2831841))+ea(6.28318548))+ea(ea(q*q)*ea(76.0354614))))/p);g[a>>2]=ea(ea(j*ea(ea(ea(n*ea(-41.2831841))+ea(6.28318548))+ea(ea(n*n)*ea(76.0354614))))/r);g[a+4>>2]=m;g[a+8>>2]=e;g[a+12>>2]=o;i=c;return}function L$d(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+20>>2]|0;if(!d){e=0;i=b;return e|0}e=(iYd(d)|0)^1;i=b;return e|0}function M$d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=xo[c[c[e>>2]>>2]&2047](e,16,4)|0;if(!g)h=0;else{c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;h=g}if(!a){c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=a;i=f;return h|0}g=a<<2;c[h>>2]=xo[c[c[e>>2]>>2]&2047](e,g,4)|0;j=h+4|0;c[j>>2]=xo[c[c[e>>2]>>2]&2047](e,g,4)|0;k=h+8|0;c[k>>2]=xo[c[c[e>>2]>>2]&2047](e,g,4)|0;g=h+12|0;c[g>>2]=a;a=0;do{l=OZd(e)|0;c[(c[h>>2]|0)+(a<<2)>>2]=l;l=QZd(d,e)|0;c[(c[j>>2]|0)+(a<<2)>>2]=l;l=SZd(b,e)|0;c[(c[k>>2]|0)+(a<<2)>>2]=l;a=a+1|0}while(a>>>0<(c[g>>2]|0)>>>0);i=f;return h|0}function N$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+12|0;f=a+4|0;g=a+8|0;if(c[e>>2]|0){h=0;do{PZd(c[(c[a>>2]|0)+(h<<2)>>2]|0,b);RZd(c[(c[f>>2]|0)+(h<<2)>>2]|0,b);TZd(c[(c[g>>2]|0)+(h<<2)>>2]|0,b);h=h+1|0}while(h>>>0<(c[e>>2]|0)>>>0)}In[c[(c[b>>2]|0)+4>>2]&4095](b,c[a>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[f>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[g>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function O$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=xo[c[c[b>>2]>>2]&2047](b,76,4)|0;if(!e)f=0;else{c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=-1;c[e+28>>2]=-1;c[e+32>>2]=1;g=e+36|0;h=g+40|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f=e}c[f+12>>2]=c[a+36>>2];e=a+40|0;a=c[e>>2]|0;if((a|0)!=0?(g=xo[c[c[b>>2]>>2]&2047](b,a<<2,4)|0,(g|0)!=0):0){j=g;k=g-(f+4)|0}else{j=0;k=0}c[f+4>>2]=k;c[f+8>>2]=j;c[f>>2]=c[e>>2];i=d;return f|0}function P$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=a+4|0;f=c[e>>2]|0;if(f){g=c[(c[b>>2]|0)+4>>2]|0;h=f+e|0;c[a+8>>2]=h;In[g&4095](b,h)}In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function Q$d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e;g=xo[c[c[d>>2]>>2]&2047](d,12,4)|0;if(!g)h=0;else{c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;h=g}c[f>>2]=0;g=c[a>>2]|0;j=a+40|0;if(!g){k=c[j>>2]|0;l=0;m=M$d(k,l,b,d)|0;c[h>>2]=m;i=e;return h|0}n=a+4|0;a=n;o=c[j>>2]|0;j=o;p=0;while(1){if(!j)q=0;else{r=c[n>>2]|0;s=0;do{t=r+a|0;u=t+(p<<3)|0;v=u+(c[u>>2]|0)|0;c[t+(p<<3)+4>>2]=v;t=v+16|0;u=c[t+(c[t>>2]|0)+(s<<2)>>2]|0;if((u|0)!=-1?(t=v+36|0,v=(c[t>>2]|0)+t|0,t=v+(u<<3)|0,w=t+(c[t>>2]|0)|0,t=w,c[v+(u<<3)+4>>2]=t,(w|0)!=0):0){w=c[f>>2]|0;u=c[t>>2]|0;c[f>>2]=w>>>0<u>>>0?u:w}s=s+1|0}while(s>>>0<o>>>0);q=o}p=p+1|0;if(p>>>0>=g>>>0){x=q;break}else j=q}k=x;l=c[f>>2]|0;m=M$d(k,l,b,d)|0;c[h>>2]=m;i=e;return h|0}function R$d(a,b){a=a|0;b=b|0;var d=0;d=i;if(!a){i=d;return}N$d(c[a>>2]|0,b);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function S$d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=xo[c[c[e>>2]>>2]&2047](e,60,4)|0;if(!g)h=0;else{c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=128;a[g+24>>0]=0;a[g+25>>0]=1;j=g+28|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[g+44>>2]=128;a[g+48>>0]=0;a[g+49>>0]=1;c[g+52>>2]=0;a[g+56>>0]=0;h=g}g=b+40|0;b=c[g>>2]|0;c[h+52>>2]=b;if((b|0)!=0?(j=xo[c[c[e>>2]>>2]&2047](e,b*24|0,4)|0,(j|0)!=0):0){k=j+(b*24|0)|0;b=j;do{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;b=b+24|0}while((b|0)!=(k|0));l=j}else l=0;j=h+4|0;c[j>>2]=l;l=c[g>>2]|0;if((l|0)!=0?(k=xo[c[c[e>>2]>>2]&2047](e,l*24|0,4)|0,(k|0)!=0):0){b=k+(l*24|0)|0;l=k;do{c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;l=l+24|0}while((l|0)!=(b|0));m=k}else m=0;k=h+28|0;c[k>>2]=m;b=c[g>>2]|0;if(!b){i=f;return h|0}l=d<<2;if(!d){n=0;do{o=(c[j>>2]|0)+(n*24|0)+4|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;o=m+(n*24|0)+4|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[m+(n*24|0)+20>>2]=0;n=n+1|0}while(n>>>0<b>>>0);i=f;return h|0}else{b=0;do{n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[j>>2]|0)+(b*24|0)+8>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[j>>2]|0)+(b*24|0)+4>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[j>>2]|0)+(b*24|0)+12>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,d,1)|0;c[(c[j>>2]|0)+(b*24|0)+16>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[j>>2]|0)+(b*24|0)+20>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[k>>2]|0)+(b*24|0)+8>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[k>>2]|0)+(b*24|0)+4>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;c[(c[k>>2]|0)+(b*24|0)+12>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,d,1)|0;c[(c[k>>2]|0)+(b*24|0)+16>>2]=n;n=xo[c[c[e>>2]>>2]&2047](e,l,4)|0;m=c[g>>2]|0;c[(c[k>>2]|0)+(b*24|0)+20>>2]=n;b=b+1|0}while(b>>>0<m>>>0);i=f;return h|0}return 0}function T$d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;if(!a){i=d;return}e=a+52|0;f=c[(c[b>>2]|0)+4>>2]|0;if(!(c[e>>2]|0)){g=f;h=a+28|0;j=a+4|0}else{k=a+28|0;l=a+4|0;m=f;f=0;while(1){In[m&4095](b,c[(c[k>>2]|0)+(f*24|0)+8>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[k>>2]|0)+(f*24|0)+4>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[k>>2]|0)+(f*24|0)+12>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[k>>2]|0)+(f*24|0)+16>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[k>>2]|0)+(f*24|0)+20>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[l>>2]|0)+(f*24|0)+8>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[l>>2]|0)+(f*24|0)+4>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[l>>2]|0)+(f*24|0)+12>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[l>>2]|0)+(f*24|0)+16>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[(c[l>>2]|0)+(f*24|0)+20>>2]|0);f=f+1|0;n=c[(c[b>>2]|0)+4>>2]|0;if(f>>>0>=(c[e>>2]|0)>>>0){g=n;h=k;j=l;break}else m=n}}In[g&4095](b,c[j>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,c[h>>2]|0);In[c[(c[b>>2]|0)+4>>2]&4095](b,a);i=d;return}function U$d(b,d,e,f,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=Im,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=0,_=0,$=Im;j=i;m=b+12|0;n=c[m>>2]|0;if(!n){o=ea(0.0);i=j;return ea(o)}p=b+16|0;q=p;r=b+36|0;s=r;t=h+4|0;u=e+4|0;v=e+8|0;w=b+24|0;x=w;y=h+8|0;h=d+4|0;d=b+60|0;z=b+71|0;A=b+64|0;b=n;B=ea(0.0);n=0;while(1){C=c[(c[p>>2]|0)+q+(n<<2)>>2]|0;if((C|0)!=-1?(D=(c[r>>2]|0)+s|0,E=D+(C<<3)|0,F=E+(c[E>>2]|0)|0,E=F,c[D+(C<<3)+4>>2]=E,(F|0)!=0):0){F=(c[e>>2]|0)+(n<<2)|0;c[(c[F>>2]|0)+4>>2]=c[t>>2];c[c[F>>2]>>2]=f;XZd(E,c[F>>2]|0,c[(c[u>>2]|0)+(n<<2)>>2]|0,c[(c[v>>2]|0)+(n<<2)>>2]|0,l,c[(c[w>>2]|0)+x+(n<<4)+12>>2]|0);F=(c[u>>2]|0)+(n<<2)|0;E=c[F>>2]|0;a:do if(c[E+4>>2]|0){C=c[h>>2]|0;D=c[E>>2]|0;G=0;H=0;while(1){I=c[D+(G*20|0)+4>>2]|0;if((I|0)==-1)break a;J=ea(ea(g[D+(G*20|0)>>2])*k);K=c[C>>2]|0;L=K+(n*24|0)|0;M=c[L>>2]|0;g[(c[K+(n*24|0)+8>>2]|0)+(M<<2)>>2]=J;J=ea(g[D+(G*20|0)+8>>2]);N=ea(J*ea(g[d>>2]));g[(c[K+(n*24|0)+12>>2]|0)+(M<<2)>>2]=N;O=a[z>>0]|0;a[(c[K+(n*24|0)+16>>2]|0)+M>>0]=(a[D+(G*20|0)+12>>0]|0)==0?O:O^1;N=ea(g[D+(G*20|0)+16>>2]);J=ea(N+ea(g[A>>2]));g[(c[K+(n*24|0)+20>>2]|0)+(M<<2)>>2]=J;O=(c[w>>2]|0)+x|0;P=c[O+(n<<4)>>2]|0;b:do if(H>>>0<P>>>0){Q=O+(n<<4)+4|0;R=c[Q>>2]|0;S=H;while(1){T=S+1|0;if((I|0)==(c[R+Q+(S<<2)>>2]|0)){U=T;V=S;break}if(T>>>0<P>>>0)S=T;else{W=T;break b}}c[(c[K+(n*24|0)+4>>2]|0)+(M<<2)>>2]=(c[O+(n<<4)+12>>2]|0)+V;c[L>>2]=(c[L>>2]|0)+1;W=U}else W=H;while(0);G=G+1|0;if(G>>>0>=(c[E+4>>2]|0)>>>0)break;else H=W}}while(0);E=c[m>>2]|0;H=E+-1|0;G=n+1|0;c:do if((H|0)<(G|0)){X=c[y>>2]|0;Y=ea(1.0)}else{D=(c[p>>2]|0)+q|0;C=(c[r>>2]|0)+s|0;L=c[y>>2]|0;J=ea(1.0);O=H;while(1){M=O;while(1){K=c[D+(M<<2)>>2]|0;if((K|0)!=-1?(P=C+(K<<3)|0,I=P+(c[P>>2]|0)|0,c[C+(K<<3)+4>>2]=I,(I|0)!=0):0){Z=M;break}M=M+-1|0;if((M|0)<(G|0)){X=L;Y=J;break c}}N=ea(J-ea(J*ea(g[L+(Z<<2)>>2])));O=Z+-1|0;if((O|0)<(G|0)){X=L;Y=N;break}else J=N}}while(0);J=ea(g[(c[F>>2]|0)+8>>2]);_=E;$=ea(B+ea(Y*ea(J*ea(g[X+(n<<2)>>2]))))}else{_=b;$=B}n=n+1|0;if(n>>>0>=_>>>0){o=$;break}else{b=_;B=$}}i=j;return ea(o)}function V$d(b,d,e,f,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=0;n=i;o=c[d+12>>2]|0;p=c[h+4>>2]|0;if(o){q=c[p>>2]|0;r=0;do{c[q+(r*24|0)>>2]=0;r=r+1|0}while(r>>>0<o>>>0)}o=h+4|0;a[p+20>>0]=a[d+68>>0]|0;a[p+21>>0]=a[d+69>>0]|0;s=ea(g[e>>2]);t=ea(S(ea(g[d+60>>2])));u=ea(ea(U$d(d,h,j,b,e,0,ea(1.0),l))/t);g[h>>2]=u;h=u!=ea(0.0);t=h?u:ea(1.0);v=ea(s/t);h=f+75|0;if((a[h>>0]|0)!=0?(l=c[e+12>>2]|0,(c[l>>2]|0)==0):0){s=ea(g[l+4>>2]);b=l+16|0;w=ea(s+ea(ea(g[b>>2])/t));l=c[o>>2]|0;g[l+4>>2]=w;g[l+8>>2]=ea(w-v);a[h>>0]=0;g[b>>2]=ea(0.0);x=w;y=l}else z=7;do if((z|0)==7)if(m){w=ea(g[f+40>>2]);l=c[o>>2]|0;g[l+4>>2]=w;g[l+8>>2]=ea(w-v);x=w;y=l;break}else{w=ea(g[(k?f+36|0:f+40|0)>>2]);t=ea(v+w);l=c[o>>2]|0;g[l+4>>2]=t;g[l+8>>2]=w;x=t;y=l;break}while(0);if(k){g[f+36>>2]=x;g[f+44>>2]=u}else{g[f+40>>2]=x;g[f+48>>2]=u}c[y+12>>2]=c[d+52>>2];d=y+16|0;if(!(c[d>>2]&128)){i=n;return}c[d>>2]=(c[e+16>>2]|0)==1?25:28;i=n;return}function W$d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im;f=i;switch(c[b>>2]|0){case 7:case 6:case 4:case 3:case 2:case 1:break;default:{h=0;i=f;return h|0}}j=F_d(d,c[b+4>>2]|0)|0;if((j|0)<=-1){h=0;i=f;return h|0}k=d+4|0;d=(c[k>>2]|0)+k|0;k=c[d+(j<<4)+8>>2]|0;if((k|0)==9|(k|0)==4){l=c[b>>2]|0;if((l+-1|0)>>>0<2){m=e+4|0;h=(a[(c[m>>2]|0)+m+(c[d+(j<<4)+12>>2]|0)>>0]|0)!=0^(l|0)!=1;i=f;return h|0}else n=l}else{l=c[b>>2]|0;if((k|0)==3&(l&-2|0)==6){m=e+16|0;o=ea(c[(c[m>>2]|0)+m+(c[d+(j<<4)+12>>2]<<2)>>2]|0);p=ea(g[b+8>>2]);if((l|0)==6){h=o==p;i=f;return h|0}else{h=o!=p;i=f;return h|0}}else n=l}if((n+-3|0)>>>0>=2){h=0;i=f;return h|0}if((k|0)==3){l=e+16|0;p=ea(c[(c[l>>2]|0)+l+(c[d+(j<<4)+12>>2]<<2)>>2]|0);o=ea(g[b+8>>2]);if((n|0)==3){h=p>o;i=f;return h|0}else{h=p<o;i=f;return h|0}}else if((k|0)==1){k=e+28|0;o=ea(g[(c[k>>2]|0)+k+(c[d+(j<<4)+12>>2]<<2)>>2]);p=ea(g[b+8>>2]);if((n|0)==3){h=o>p;i=f;return h|0}else{h=o<p;i=f;return h|0}}else{h=0;i=f;return h|0}return 0}function X$d(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=Im,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0;h=i;j=c[b>>2]|0;k=(j|0)!=0;a[e>>0]=k&1;l=e+4|0;g[l>>2]=ea(0.0);do if(!(a[b+40>>0]|0)){if(!k){i=h;return}}else{a[e>>0]=0;m=ea(g[b+36>>2]);n=!(m<=ea(1.0));o=ea(g[d+16>>2]);if(n){if(!(o<m)){i=h;return}p=ea(g[d+12>>2]);if(!(p>=m)){i=h;return}else{a[e>>0]=1;g[l>>2]=ea(p-m);break}}p=ea(o-ea(jEi(o)));o=ea(g[d+12>>2]);q=ea(o-ea(jEi(o)));if(p>q){r=ea(q+ea(1.0));s=ea(p+ea(-1.0))}else{r=q;s=p}if(!(!(s<m)|!(q>=m))){a[e>>0]=1;g[l>>2]=ea(q-m);break}if(!(p<m)|!(r>=m)){i=h;return}else{a[e>>0]=1;g[l>>2]=ea(r-m);break}}while(0);l=b+4|0;k=l;n=j;j=0;while(1){if(j>>>0>=n>>>0){t=17;break}u=(c[l>>2]|0)+k|0;v=u+(j<<3)|0;w=v+(c[v>>2]|0)|0;c[u+(j<<3)+4>>2]=w;u=W$d(w,c[f>>2]|0,c[d>>2]|0)|0;a[e>>0]=u&1;if(!u){t=17;break}n=c[b>>2]|0;j=j+1|0}if((t|0)==17){i=h;return}}function Y$d(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=i;l=g+20|0;g=b+28|0;b=g;m=h+32|0;h=d+4|0;n=h;o=j+8|0;j=f;a:while(1){f=c[l>>2]|0;if(!f)p=0;else p=(iYd(f)|0)^1;if(p|(j|0)==-1){q=0;r=23;break}if(j>>>0<3e4){q=j;r=23;break}f=j+-3e4|0;s=(c[g>>2]|0)+b|0;t=s+(f<<3)|0;u=t+(c[t>>2]|0)|0;c[s+(f<<3)+4>>2]=u;f=a[u+16>>0]|0;c[m>>2]=(f<<24>>24==0?4:2)|c[m>>2];s=c[l>>2]|0;if(((s|0)!=0?(kYd(s,c[u+12>>2]|0,f<<24>>24!=0?32:64)|0,f=c[l>>2]|0,(f|0)!=0):0)?!(iYd(f)|0):0){q=0;r=23;break}if(!(c[u>>2]|0)){q=0;r=23;break}f=u+4|0;s=f;t=0;b:while(1){v=(c[f>>2]|0)+s|0;w=v+(t<<3)|0;x=w+(c[w>>2]|0)|0;c[v+(t<<3)+4>>2]=x;v=x+4|0;if(!(c[v>>2]|0)){y=x;break}w=x+8|0;z=w;A=0;while(1){B=(c[w>>2]|0)+z|0;C=B+(A<<3)|0;D=C+(c[C>>2]|0)|0;c[B+(A<<3)+4>>2]=D;A=A+1|0;if(!(W$d(D,d,e)|0))break;D=c[v>>2]|0;if(A>>>0>=D>>>0){E=D;F=x;G=z;H=w;r=15;break b}}t=t+1|0;if(t>>>0>=(c[u>>2]|0)>>>0){q=0;r=23;break a}}if((r|0)==15){r=0;if(!E)y=F;else{u=0;do{t=(c[H>>2]|0)+G|0;s=t+(u<<3)|0;f=s+(c[s>>2]|0)|0;c[t+(u<<3)+4>>2]=f;if(((c[f>>2]|0)==1?(t=F_d(d,c[f+4>>2]|0)|0,(t|0)>-1):0)?(f=(c[h>>2]|0)+n|0,(c[f+(t<<4)+8>>2]|0)==9):0)a[(c[c[o>>2]>>2]|0)+(c[f+(t<<4)+12>>2]|0)>>0]=1;u=u+1|0}while((u|0)!=(E|0));y=F}}j=c[y>>2]|0}if((r|0)==23){i=k;return q|0}return 0}function Z$d(b,d,e,f,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=Im,Q=Im;p=i;if(!d){q=0;i=p;return q|0}r=b;s=m+73|0;t=h+4|0;u=m+12|0;v=n+8|0;w=0;a:while(1){y=(c[b>>2]|0)+r|0;z=y+(w<<3)|0;A=z+(c[z>>2]|0)|0;c[y+(w<<3)+4>>2]=A;a[t>>0]=a[s>>0]|0;X$d(A,e,f,h,0);y=a[f>>0]|0;do if(y<<24>>24){if(((a[A+49>>0]|0)==0?(a[s>>0]|0)==0:0)?(c[A+12>>2]|0)==(c[u>>2]|0):0){a[f>>0]=0;break}z=A+4|0;B=c[A>>2]|0;C=c[h>>2]|0;if(!B)D=y;else{E=z;F=C+4|0;G=F;H=0;do{I=(c[z>>2]|0)+E|0;J=I+(H<<3)|0;K=J+(c[J>>2]|0)|0;c[I+(H<<3)+4>>2]=K;if(((c[K>>2]|0)==1?(I=F_d(C,c[K+4>>2]|0)|0,(I|0)>-1):0)?(K=(c[F>>2]|0)+G|0,(c[K+(I<<4)+8>>2]|0)==9):0)a[(c[c[v>>2]>>2]|0)+(c[K+(I<<4)+12>>2]|0)>>0]=1;H=H+1|0}while((H|0)!=(B|0));D=a[f>>0]|0}if(D<<24>>24){L=A;M=w;break a}}while(0);w=w+1|0;if(w>>>0>=d>>>0){q=0;N=22;break}}if((N|0)==22){i=p;return q|0}a[m+72>>0]=a[s>>0]|0;a[s>>0]=1;c[m+32>>2]=1;s=Y$d(j,c[n+4>>2]|0,c[k+4>>2]|0,c[L+12>>2]|0,k,m,n)|0;n=m+16|0;c[n>>2]=s;N=c[k+20>>2]|0;do if(N)if(iYd(N)|0){O=c[n>>2]|0;break}else{q=0;i=p;return q|0}else O=s;while(0);c[m+24>>2]=M;c[m+28>>2]=o;g[m+64>>2]=ea(g[L+28>>2]);P=ea(g[L+32>>2]);g[m+68>>2]=P;g[m+60>>2]=ea(0.0);g[m+56>>2]=ea(g[((a[L+40>>0]|0)==0?e+12|0:L+36|0)>>2]);a[m+75>>0]=1;L=c[k+12>>2]|0;c[L>>2]=0;g[L+4>>2]=P;P=ea(g[f+4>>2]);Q=ea(g[m+44>>2]);m=Q==ea(x);g[L+16>>2]=ea(P*(m?ea(0.0):Q));m=j+4|0;j=(c[m>>2]|0)+m+(O<<3)|0;c[l+40>>2]=c[j+(c[j>>2]|0)+52>>2];c[l+44>>2]=25;q=1;i=p;return q|0}function _$d(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=Im,qa=Im;k=i;i=i+64|0;l=k+48|0;m=k+24|0;n=k+16|0;o=k+8|0;p=k;g[e>>2]=ea(0.0);q=e+56|0;a[q>>0]=0;r=b+40|0;s=c[r>>2]|0;if(!s)t=0;else{u=c[e+28>>2]|0;v=c[e+4>>2]|0;w=0;do{c[u+(w*24|0)>>2]=0;c[v+(w*24|0)>>2]=0;w=w+1|0}while(w>>>0<s>>>0);t=s}if(!(c[b>>2]|0)){if(!t){i=k;return}s=f+4|0;w=(c[s>>2]|0)+s|0;PEi(w|0,0,(t>>>0>1?t<<2:4)|0)|0;c[f+8>>2]=w;i=k;return}w=e+4|0;t=e+20|0;c[t>>2]=128;s=e+28|0;v=e+44|0;c[v>>2]=128;x=ea(g[d>>2]);u=f+12|0;y=b+4|0;z=y;A=(c[y>>2]|0)+z+(c[u>>2]<<3)|0;B=A+(c[A>>2]|0)|0;A=c[h>>2]|0;g[l>>2]=ea(0.0);C=l+4|0;c[C>>2]=w;D=h+4|0;V$d(c[D>>2]|0,B,d,f,l,A,1,j,0);c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m>>2]=c[d+4>>2];A=f+36|0;g[m+4>>2]=ea(g[A>>2]);g[m+8>>2]=ea(g[l>>2]);B=c[C>>2]|0;g[m+12>>2]=ea(g[B+4>>2]);g[m+16>>2]=ea(g[B+8>>2]);a[n>>0]=0;C=n+4|0;g[C>>2]=ea(0.0);a[o+4>>0]=0;c[o>>2]=c[D>>2];E=f+73|0;F=a[E>>0]|0;G=c[r>>2]|0;if(G){H=c[B>>2]|0;B=f+4|0;I=(c[B>>2]|0)+B|0;B=0;do{g[I+(B<<2)>>2]=ea((c[H+(B*24|0)>>2]|0)!=0|0);B=B+1|0}while(B>>>0<G>>>0);c[f+8>>2]=I}I=f+75|0;a:do if((a[I>>0]|0)!=0?(G=c[d+12>>2]|0,B=c[G>>2]|0,H=c[b>>2]|0,(H|0)!=0):0){J=(c[y>>2]|0)+z|0;K=0;while(1){L=J+(K<<3)|0;M=L+(c[L>>2]|0)|0;c[J+(K<<3)+4>>2]=M;if((c[M+52>>2]|0)==(B|0)){N=K;break}if((c[M+48>>2]|0)==(B|0)){N=K;break}if((c[M+44>>2]|0)==(B|0)){N=K;break}K=K+1|0;if(K>>>0>=H>>>0){O=F;P=0;break a}}if((N|0)!=-1){a[I>>0]=0;a[E>>0]=1;a[f+74>>0]=1;c[f+16>>2]=N;c[f+24>>2]=-1;c[f+28>>2]=-1;g[f+64>>2]=ea(g[G+8>>2]);Q=ea(g[G+4>>2]);g[f+68>>2]=Q;R=ea(g[G+12>>2]);g[f+60>>2]=R;g[f+40>>2]=ea(R+Q);a[f+72>>0]=F;a[q>>0]=F;c[e+40>>2]=B;c[v>>2]=25;O=1;P=1}else{O=F;P=0}}else{O=F;P=0}while(0);v=f+24|0;N=c[v>>2]|0;I=f+28|0;do if((N|0)!=-1){H=c[I>>2]|0;if((H|0)==-1){K=b+16|0;J=(c[K>>2]|0)+K|0;K=J+(N<<3)|0;M=K+(c[K>>2]|0)|0;c[J+(N<<3)+4>>2]=M;S=M}else{M=(c[y>>2]|0)+z+(H<<3)|0;H=M+(c[M>>2]|0)+4|0;M=H+(c[H>>2]|0)|0;H=M+(N<<3)|0;J=H+(c[H>>2]|0)|0;c[M+(N<<3)+4>>2]=J;S=J}if(S){J=c[S+44>>2]|0;if((J|0)==3|(J|0)==4){T=S;U=3;V=1;break}else if((J|0)==2|(J|0)==1){T=S;U=2;V=1;break}else{T=S;U=0;V=1;break}}else{T=0;U=2;V=0}}else{T=0;U=2;V=0}while(0);S=c[I>>2]|0;do if((S|0)!=-1){N=(S|0)==(c[u>>2]|0);J=N?1:2;if(V){M=c[T+44>>2]|0;if((M|0)==4){if(!N){W=2;X=1;break}W=1;X=N?2:-1;break}else if((M|0)==3){if(N){W=1;X=1;break}W=J;X=N?-1:2;break}else if((M|0)==2){W=J;X=N?-1:1;break}else if((M|0)==1){W=J;X=N?1:-1;break}else{W=J;X=-1;break}}else{W=J;X=0}}else{W=0;X=0}while(0);S=f+74|0;J=a[S>>0]|0;do if((U|0)!=0&((J<<24>>24!=0|P)^1)){N=T+44|0;M=b+16|0;H=b+12|0;K=F<<24>>24!=0&V;L=T+48|0;Y=(W|0)!=2;Z=d+20|0;_=f+16|0;$=0;while(1){b:do if(V){aa=c[N>>2]|0;if(!$){ba=M;ca=H;da=0}else switch(aa|0){case 4:{fa=($|0)==1?2:1;ga=45;break b;break}case 3:{fa=($|0)==1?1:2;ga=45;break b;break}case 2:case 1:case 0:{fa=aa;ga=45;break b;break}default:{ba=M;ca=H;da=0;break b}}}else{fa=($|0)!=0&1;ga=45}while(0);do if((ga|0)==45){ga=0;if((fa|0)==2){aa=(c[y>>2]|0)+z+(c[_>>2]<<3)|0;ha=aa+(c[aa>>2]|0)|0;ba=ha+4|0;ca=ha;da=2;break}else if((fa|0)==1){ha=(c[y>>2]|0)+z+(c[u>>2]<<3)|0;aa=ha+(c[ha>>2]|0)|0;ba=aa+4|0;ca=aa;da=1;break}else{ba=M;ca=H;da=fa;break}}while(0);aa=c[ca>>2]|0;if(K?(a[L>>0]|0)!=0:0)if($>>>0>X>>>0)ia=0;else ia=(X|0)==($|0)&Y?c[v>>2]|0:aa;else ia=aa;if((da|0)==2)ja=c[_>>2]|0;else if((da|0)==1)ja=c[u>>2]|0;else ja=-1;aa=Z$d(ba,ia,m,n,o,b,d,e,f,h,ja)|0;ha=c[Z>>2]|0;if((ha|0)!=0?!(iYd(ha)|0):0){ga=72;break}a[q>>0]=aa?F:0;$=$+1|0;ha=a[S>>0]|0;if(!($>>>0<U>>>0&((ha<<24>>24!=0|aa)^1))){ka=ha;la=aa;ga=58;break}}if((ga|0)==58){ma=a[E>>0]|0;na=ka;oa=la;break}else if((ga|0)==72){i=k;return}}else{ma=O;na=J;oa=P}while(0);if(!(ma<<24>>24)){i=k;return}ma=f+16|0;P=(c[y>>2]|0)+z+(c[ma>>2]<<3)|0;z=P+(c[P>>2]|0)|0;P=c[h>>2]|0;Q=ea(g[l>>2]);R=ea(g[f+64>>2]);if(R==ea(0.0))pa=ea(1.0);else{l=Q!=ea(0.0);qa=ea(x/(l?Q:ea(1.0)));pa=ea(ea(qa-ea(g[C>>2]))/R)}C=f+60|0;R=ea(pa+ea(g[C>>2]));g[C>>2]=R;g[e>>2]=ea(VDi(ea(1.0),ea(UDi(ea(0.0),R))));g[p>>2]=ea(0.0);c[p+4>>2]=s;V$d(c[D>>2]|0,z,d,f,p,P,0,j,oa&na<<24>>24!=0);na=c[r>>2]|0;if(na){r=c[w>>2]|0;w=c[s>>2]|0;s=f+4|0;oa=(c[s>>2]|0)+s|0;s=f+8|0;j=0;do{P=(c[w+(j*24|0)>>2]|0)==0;if(!(c[r+(j*24|0)>>2]|0)){if(!P){R=ea(g[e>>2]);c[s>>2]=oa;g[oa+(j<<2)>>2]=R}}else if(P){R=ea(ea(1.0)-ea(g[e>>2]));c[s>>2]=oa;g[oa+(j<<2)>>2]=R}j=j+1|0}while(j>>>0<na>>>0)}if(!(ea(g[C>>2])>=ea(1.0))){i=k;return}c[f+20>>2]=c[u>>2];na=f+44|0;g[f+52>>2]=ea(g[na>>2]);c[t>>2]=26;a[E>>0]=0;g[C>>2]=ea(0.0);c[I>>2]=-1;c[v>>2]=-1;g[f+68>>2]=ea(0.0);c[u>>2]=c[ma>>2];a[f+72>>0]=0;a[S>>0]=0;g[A>>2]=ea(g[f+40>>2]);g[na>>2]=ea(g[f+48>>2]);g[e>>2]=ea(1.0);i=k;return}function $$d(){var a=0;a=i;Ydd(718600,718616,792272);i=a;return}function a0d(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;if(!a){i=b;return}f=c[a+8>>2]|0;if(!f){i=b;return}if((c[f+68>>2]|0)>-1){a=c[f+56>>2]|0;c[e>>2]=c[f+60>>2];c[d+0>>2]=c[e+0>>2];eOb(a,d)}ACi(f);i=b;return}function b0d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=Gsc(b,0,16)|0;if(!a)Mrc(791816,e);g=a+8|0;a=c[g>>2]|0;if(!a)Mrc(791816,e);kDd(a,f,f+((yrc(b)|0)<<4)|0);b=c[g>>2]|0;if(!b)Mrc(791816,e);else{g=c[b+56>>2]|0;f0d(g,g+(c[b+64>>2]<<4)|0,e);SMc(b);i=d;return}}function c0d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=xCi(80)|0;g[e+4>>2]=ea(x);c[e>>2]=0;f=e+8|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;g[e+32>>2]=ea(x);c[e+28>>2]=0;f=e+36|0;c[e+64>>2]=0;c[e+68>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[e+60>>2]=60;c[e+76>>2]=2;c[e+72>>2]=2;c[a+8>>2]=e;if(!b){i=d;return}b0d(a,b);i=d;return}function d0d(){var a=0;a=i;xrc(718624,3536);i=a;return}function e0d(){var a=0;a=i;xrc(718664,3049);i=a;return}function f0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=Im,J=0,K=0,L=0,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;e=i;i=i+32|0;f=e+16|0;h=e;j=a;a=b;a:while(1){b=a;k=a+-16|0;l=j;b:while(1){m=l;n=b-m|0;o=n>>4;switch(o|0){case 2:{p=l;q=k;r=k;s=4;break a;break}case 1:case 0:{s=84;break a;break}case 4:{t=l;u=k;s=14;break a;break}case 3:{v=l;w=k;x=k;s=6;break a;break}case 5:{y=l;z=k;A=k;s=15;break a;break}default:{}}if((n|0)<496){B=l;C=a;s=21;break a}D=(o|0)/2|0;E=l+(D<<4)|0;do if((n|0)>15984){F=(o|0)/4|0;G=l+(F<<4)|0;H=l+(F+D<<4)|0;F=g0d(l,G,E,H,d)|0;I=ea(g[k>>2]);if(!(I<ea(g[H>>2]))){J=E;K=F;break};c[f+0>>2]=c[H+0>>2];c[f+4>>2]=c[H+4>>2];c[f+8>>2]=c[H+8>>2];c[f+12>>2]=c[H+12>>2];c[H+0>>2]=c[k+0>>2];c[H+4>>2]=c[k+4>>2];c[H+8>>2]=c[k+8>>2];c[H+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];L=F+1|0;I=ea(g[H>>2]);if(I<ea(g[E>>2])){c[f+0>>2]=c[E+0>>2];c[f+4>>2]=c[E+4>>2];c[f+8>>2]=c[E+8>>2];c[f+12>>2]=c[E+12>>2];c[E+0>>2]=c[H+0>>2];c[E+4>>2]=c[H+4>>2];c[E+8>>2]=c[H+8>>2];c[E+12>>2]=c[H+12>>2];c[H+0>>2]=c[f+0>>2];c[H+4>>2]=c[f+4>>2];c[H+8>>2]=c[f+8>>2];c[H+12>>2]=c[f+12>>2];H=F+2|0;I=ea(g[E>>2]);if(I<ea(g[G>>2])){c[f+0>>2]=c[G+0>>2];c[f+4>>2]=c[G+4>>2];c[f+8>>2]=c[G+8>>2];c[f+12>>2]=c[G+12>>2];c[G+0>>2]=c[E+0>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];c[G+12>>2]=c[E+12>>2];c[E+0>>2]=c[f+0>>2];c[E+4>>2]=c[f+4>>2];c[E+8>>2]=c[f+8>>2];c[E+12>>2]=c[f+12>>2];I=ea(g[G>>2]);if(I<ea(g[l>>2])){c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[G+0>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];c[l+12>>2]=c[G+12>>2];c[G+0>>2]=c[f+0>>2];c[G+4>>2]=c[f+4>>2];c[G+8>>2]=c[f+8>>2];c[G+12>>2]=c[f+12>>2];J=E;K=F+4|0}else{J=E;K=F+3|0}}else{J=E;K=H}}else{J=E;K=L}}else{I=ea(g[E>>2]);L=I<ea(g[l>>2]);H=ea(g[k>>2])<I;if(!L){if(!H){J=E;K=0;break};c[f+0>>2]=c[E+0>>2];c[f+4>>2]=c[E+4>>2];c[f+8>>2]=c[E+8>>2];c[f+12>>2]=c[E+12>>2];c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[E+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];I=ea(g[E>>2]);if(!(I<ea(g[l>>2]))){J=E;K=1;break};c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[E+0>>2];c[l+4>>2]=c[E+4>>2];c[l+8>>2]=c[E+8>>2];c[l+12>>2]=c[E+12>>2];c[E+0>>2]=c[f+0>>2];c[E+4>>2]=c[f+4>>2];c[E+8>>2]=c[f+8>>2];c[E+12>>2]=c[f+12>>2];J=E;K=2;break}if(H){c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];J=E;K=1;break};c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[E+0>>2];c[l+4>>2]=c[E+4>>2];c[l+8>>2]=c[E+8>>2];c[l+12>>2]=c[E+12>>2];c[E+0>>2]=c[f+0>>2];c[E+4>>2]=c[f+4>>2];c[E+8>>2]=c[f+8>>2];c[E+12>>2]=c[f+12>>2];I=ea(g[k>>2]);if(I<ea(g[E>>2])){c[f+0>>2]=c[E+0>>2];c[f+4>>2]=c[E+4>>2];c[f+8>>2]=c[E+8>>2];c[f+12>>2]=c[E+12>>2];c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[E+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];J=E;K=2}else{J=E;K=1}}while(0);I=ea(g[l>>2]);M=ea(g[J>>2]);do if(I<M){N=k;O=K}else{D=a;o=k;while(1){n=D+-32|0;if((l|0)==(n|0))break;if(ea(g[n>>2])<M){P=n;s=66;break}else{H=o;o=n;D=H}}if((s|0)==66){s=0;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[P+0>>2];c[l+4>>2]=c[P+4>>2];c[l+8>>2]=c[P+8>>2];c[l+12>>2]=c[P+12>>2];c[P+0>>2]=c[f+0>>2];c[P+4>>2]=c[f+4>>2];c[P+8>>2]=c[f+8>>2];c[P+12>>2]=c[f+12>>2];N=P;O=K+1|0;break}D=l+16|0;if(I<ea(g[k>>2]))Q=D;else{if((D|0)==(k|0)){s=84;break a}else{R=l;S=D}while(1){D=R+32|0;if(I<ea(g[S>>2])){T=S;break}if((D|0)==(k|0)){s=84;break a}else{o=S;S=D;R=o}}c[f+0>>2]=c[T+0>>2];c[f+4>>2]=c[T+4>>2];c[f+8>>2]=c[T+8>>2];c[f+12>>2]=c[T+12>>2];c[T+0>>2]=c[k+0>>2];c[T+4>>2]=c[k+4>>2];c[T+8>>2]=c[k+8>>2];c[T+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];Q=T+16|0}if((Q|0)==(k|0)){s=84;break a}else{U=Q;V=k}while(1){W=ea(g[l>>2]);o=U;while(1){D=o+16|0;if(W<ea(g[o>>2])){X=D;Y=o;break}else o=D}o=V;while(1){D=o+-16|0;if(W<ea(g[D>>2]))o=D;else{Z=D;break}}if(Y>>>0>=Z>>>0){l=Y;continue b};c[f+0>>2]=c[Y+0>>2];c[f+4>>2]=c[Y+4>>2];c[f+8>>2]=c[Y+8>>2];c[f+12>>2]=c[Y+12>>2];c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];c[Z+0>>2]=c[f+0>>2];c[Z+4>>2]=c[f+4>>2];c[Z+8>>2]=c[f+8>>2];c[Z+12>>2]=c[f+12>>2];U=X;V=Z}}while(0);o=l+16|0;c:do if(o>>>0<N>>>0){D=o;H=N;n=E;L=O;while(1){I=ea(g[n>>2]);F=D;while(1){G=F+16|0;if(ea(g[F>>2])<I)F=G;else{_=G;$=F;break}}F=H;while(1){G=F+-16|0;if(ea(g[G>>2])<I){aa=G;break}else F=G}if($>>>0>aa>>>0){ba=$;ca=n;da=L;break c};c[f+0>>2]=c[$+0>>2];c[f+4>>2]=c[$+4>>2];c[f+8>>2]=c[$+8>>2];c[f+12>>2]=c[$+12>>2];c[$+0>>2]=c[aa+0>>2];c[$+4>>2]=c[aa+4>>2];c[$+8>>2]=c[aa+8>>2];c[$+12>>2]=c[aa+12>>2];c[aa+0>>2]=c[f+0>>2];c[aa+4>>2]=c[f+4>>2];c[aa+8>>2]=c[f+8>>2];c[aa+12>>2]=c[f+12>>2];D=_;H=aa;n=(n|0)==($|0)?aa:n;L=L+1|0}}else{ba=o;ca=E;da=O}while(0);if((ba|0)!=(ca|0)?(I=ea(g[ca>>2]),I<ea(g[ba>>2])):0){c[f+0>>2]=c[ba+0>>2];c[f+4>>2]=c[ba+4>>2];c[f+8>>2]=c[ba+8>>2];c[f+12>>2]=c[ba+12>>2];c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];c[ca+0>>2]=c[f+0>>2];c[ca+4>>2]=c[f+4>>2];c[ca+8>>2]=c[f+8>>2];c[ca+12>>2]=c[f+12>>2];fa=da+1|0}else fa=da;if(!fa){ga=h0d(l,ba,d)|0;E=ba+16|0;if(h0d(E,a,d)|0){s=79;break}if(ga){l=E;continue}}E=ba;if((E-m|0)>=(b-E|0)){ha=l;ia=ba;s=83;break}f0d(l,ba,d);l=ba+16|0}if((s|0)==79){s=0;if(ga){s=84;break}else{j=l;a=ba;continue}}else if((s|0)==83){s=0;f0d(ia+16|0,a,d);j=ha;a=ia;continue}}if((s|0)==4){I=ea(g[q>>2]);if(!(I<ea(g[p>>2]))){i=e;return};c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[p+0>>2]=c[r+0>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];c[r+0>>2]=c[f+0>>2];c[r+4>>2]=c[f+4>>2];c[r+8>>2]=c[f+8>>2];c[r+12>>2]=c[f+12>>2];i=e;return}else if((s|0)==6){r=v+16|0;I=ea(g[r>>2]);p=I<ea(g[v>>2]);q=ea(g[w>>2])<I;if(!p){if(!q){i=e;return};c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[r+0>>2]=c[x+0>>2];c[r+4>>2]=c[x+4>>2];c[r+8>>2]=c[x+8>>2];c[r+12>>2]=c[x+12>>2];c[x+0>>2]=c[f+0>>2];c[x+4>>2]=c[f+4>>2];c[x+8>>2]=c[f+8>>2];c[x+12>>2]=c[f+12>>2];I=ea(g[r>>2]);if(!(I<ea(g[v>>2]))){i=e;return};c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[r+0>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];c[v+12>>2]=c[r+12>>2];c[r+0>>2]=c[f+0>>2];c[r+4>>2]=c[f+4>>2];c[r+8>>2]=c[f+8>>2];c[r+12>>2]=c[f+12>>2];i=e;return}if(q){c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[x+0>>2]=c[f+0>>2];c[x+4>>2]=c[f+4>>2];c[x+8>>2]=c[f+8>>2];c[x+12>>2]=c[f+12>>2];i=e;return};c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[v+0>>2]=c[r+0>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];c[v+12>>2]=c[r+12>>2];c[r+0>>2]=c[f+0>>2];c[r+4>>2]=c[f+4>>2];c[r+8>>2]=c[f+8>>2];c[r+12>>2]=c[f+12>>2];I=ea(g[w>>2]);if(!(I<ea(g[r>>2]))){i=e;return};c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[r+0>>2]=c[x+0>>2];c[r+4>>2]=c[x+4>>2];c[r+8>>2]=c[x+8>>2];c[r+12>>2]=c[x+12>>2];c[x+0>>2]=c[f+0>>2];c[x+4>>2]=c[f+4>>2];c[x+8>>2]=c[f+8>>2];c[x+12>>2]=c[f+12>>2];i=e;return}else if((s|0)==14){g0d(t,t+16|0,t+32|0,u,d)|0;i=e;return}else if((s|0)==15){u=y+16|0;t=y+32|0;x=y+48|0;g0d(y,u,t,x,d)|0;I=ea(g[z>>2]);if(!(I<ea(g[x>>2]))){i=e;return};c[f+0>>2]=c[x+0>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[A+0>>2]=c[f+0>>2];c[A+4>>2]=c[f+4>>2];c[A+8>>2]=c[f+8>>2];c[A+12>>2]=c[f+12>>2];I=ea(g[x>>2]);if(!(I<ea(g[t>>2]))){i=e;return};c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[t+12>>2]=c[x+12>>2];c[x+0>>2]=c[f+0>>2];c[x+4>>2]=c[f+4>>2];c[x+8>>2]=c[f+8>>2];c[x+12>>2]=c[f+12>>2];I=ea(g[t>>2]);if(!(I<ea(g[u>>2]))){i=e;return};c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[f+12>>2]=c[u+12>>2];c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];c[u+12>>2]=c[t+12>>2];c[t+0>>2]=c[f+0>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];I=ea(g[u>>2]);if(!(I<ea(g[y>>2]))){i=e;return};c[f+0>>2]=c[y+0>>2];c[f+4>>2]=c[y+4>>2];c[f+8>>2]=c[y+8>>2];c[f+12>>2]=c[y+12>>2];c[y+0>>2]=c[u+0>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];c[y+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];i=e;return}else if((s|0)==21){u=B+32|0;y=B+16|0;I=ea(g[y>>2]);M=ea(g[B>>2]);W=ea(g[u>>2]);t=W<I;do if(I<M){if(t){c[f+0>>2]=c[B+0>>2];c[f+4>>2]=c[B+4>>2];c[f+8>>2]=c[B+8>>2];c[f+12>>2]=c[B+12>>2];c[B+0>>2]=c[u+0>>2];c[B+4>>2]=c[u+4>>2];c[B+8>>2]=c[u+8>>2];c[B+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[B+0>>2];c[f+4>>2]=c[B+4>>2];c[f+8>>2]=c[B+8>>2];c[f+12>>2]=c[B+12>>2];c[B+0>>2]=c[y+0>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];c[B+12>>2]=c[y+12>>2];c[y+0>>2]=c[f+0>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];c[y+12>>2]=c[f+12>>2];if(W<ea(g[y>>2])){c[f+0>>2]=c[y+0>>2];c[f+4>>2]=c[y+4>>2];c[f+8>>2]=c[y+8>>2];c[f+12>>2]=c[y+12>>2];c[y+0>>2]=c[u+0>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];c[y+12>>2]=c[u+12>>2];c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2]}}else if(t?(c[f+0>>2]=c[y+0>>2],c[f+4>>2]=c[y+4>>2],c[f+8>>2]=c[y+8>>2],c[f+12>>2]=c[y+12>>2],c[y+0>>2]=c[u+0>>2],c[y+4>>2]=c[u+4>>2],c[y+8>>2]=c[u+8>>2],c[y+12>>2]=c[u+12>>2],c[u+0>>2]=c[f+0>>2],c[u+4>>2]=c[f+4>>2],c[u+8>>2]=c[f+8>>2],c[u+12>>2]=c[f+12>>2],ea(g[y>>2])<M):0){c[f+0>>2]=c[B+0>>2];c[f+4>>2]=c[B+4>>2];c[f+8>>2]=c[B+8>>2];c[f+12>>2]=c[B+12>>2];c[B+0>>2]=c[y+0>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];c[B+12>>2]=c[y+12>>2];c[y+0>>2]=c[f+0>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];c[y+12>>2]=c[f+12>>2]}while(0);f=B+48|0;if((f|0)==(C|0)){i=e;return}else{ja=f;ka=u}while(1){M=ea(g[ja>>2]);if(M<ea(g[ka>>2])){u=ja+4|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];u=ja;f=ka;while(1){c[u+0>>2]=c[f+0>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];if((f|0)==(B|0)){la=B;break}y=f+-16|0;if(M<ea(g[y>>2])){t=f;f=y;u=t}else{la=f;break}}g[la>>2]=M;f=la+4|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2]}f=ja+16|0;if((f|0)==(C|0))break;else{u=ja;ja=f;ka=u}}i=e;return}else if((s|0)==84){i=e;return}}function g0d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=Im,k=0,l=0,m=0,n=0;f=i;i=i+16|0;h=f;j=ea(g[b>>2]);k=j<ea(g[a>>2]);l=ea(g[d>>2])<j;do if(k){if(l){c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];m=1;break};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];j=ea(g[d>>2]);if(j<ea(g[b>>2])){c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];m=2}else m=1}else if(l){c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];j=ea(g[b>>2]);if(j<ea(g[a>>2])){c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];m=2}else m=1}else m=0;while(0);j=ea(g[e>>2]);if(!(j<ea(g[d>>2]))){n=m;i=f;return n|0};c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];j=ea(g[d>>2]);if(!(j<ea(g[b>>2]))){n=m+1|0;i=f;return n|0};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];j=ea(g[b>>2]);if(!(j<ea(g[a>>2]))){n=m+2|0;i=f;return n|0};c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];n=m+3|0;i=f;return n|0}function h0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e+16|0;h=e;switch(b-a>>4|0){case 5:{j=a+16|0;k=a+32|0;l=a+48|0;m=b+-16|0;g0d(a,j,k,l,d)|0;if(!(ea(g[m>>2])<ea(g[l>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];if(!(ea(g[l>>2])<ea(g[k>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];if(!(ea(g[k>>2])<ea(g[j>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];if(!(ea(g[j>>2])<ea(g[a>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];n=1;i=e;return n|0}case 4:{g0d(a,a+16|0,a+32|0,b+-16|0,d)|0;n=1;i=e;return n|0}case 2:{d=b+-16|0;if(!(ea(g[d>>2])<ea(g[a>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];n=1;i=e;return n|0}case 3:{d=a+16|0;j=b+-16|0;o=ea(g[d>>2]);k=o<ea(g[a>>2]);l=ea(g[j>>2])<o;if(!k){if(!l){n=1;i=e;return n|0};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];o=ea(g[d>>2]);if(!(o<ea(g[a>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];n=1;i=e;return n|0}if(l){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];n=1;i=e;return n|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];if(!(ea(g[j>>2])<ea(g[d>>2]))){n=1;i=e;return n|0};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];n=1;i=e;return n|0}case 1:case 0:{n=1;i=e;return n|0}default:{j=a+32|0;d=a+16|0;o=ea(g[d>>2]);p=ea(g[a>>2]);q=ea(g[j>>2]);l=q<o;do if(o<p){if(l){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];break};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];if(q<ea(g[d>>2])){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2]}}else if(l?(c[f+0>>2]=c[d+0>>2],c[f+4>>2]=c[d+4>>2],c[f+8>>2]=c[d+8>>2],c[f+12>>2]=c[d+12>>2],c[d+0>>2]=c[j+0>>2],c[d+4>>2]=c[j+4>>2],c[d+8>>2]=c[j+8>>2],c[d+12>>2]=c[j+12>>2],c[j+0>>2]=c[f+0>>2],c[j+4>>2]=c[f+4>>2],c[j+8>>2]=c[f+8>>2],c[j+12>>2]=c[f+12>>2],ea(g[d>>2])<p):0){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2]}while(0);f=a+48|0;if((f|0)==(b|0)){n=1;i=e;return n|0}d=0;l=f;f=j;while(1){p=ea(g[l>>2]);if(p<ea(g[f>>2])){j=l+4|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];j=l;k=f;while(1){c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];if((k|0)==(a|0)){r=a;break}m=k+-16|0;if(p<ea(g[m>>2])){s=k;k=m;j=s}else{r=k;break}}g[r>>2]=p;k=r+4|0;c[k+0>>2]=c[h+0>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];k=d+1|0;if((k|0)==8){t=l;break}else u=k}else u=d;k=l+16|0;if((k|0)==(b|0)){n=1;v=35;break}else{j=l;d=u;l=k;f=j}}if((v|0)==35){i=e;return n|0}n=(t+16|0)==(b|0);i=e;return n|0}}return 0}function i0d(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;Stc(c,a);a=k0d(c)|0;i=b;return a|0}function j0d(){var a=0;a=i;xrc(718704,3605);i=a;return}function k0d(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;if(Ttc(b)|0){g=0;i=e;return g|0}Utc(f,b);if(!(a[f>>0]&1))h=f+1|0;else h=c[f+8>>2]|0;b=-1;j=0;k=0;while(1){if(!(b&1))l=k;else l=1<<31-j|k;j=j+1|0;if((j|0)==32){m=l;break}else{b=b>>>1;k=l}}l=SEi(h|0)|0;k=h+l|0;if((l|0)>0){l=m;b=h;while(1){h=c[572464+(((d[b>>0]|0)^l&255)<<2)>>2]^l>>>8;b=b+1|0;if((b|0)==(k|0)){n=h;break}else l=h}}else n=m;xri(f);g=~n;i=e;return g|0}function l0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(da(c[a+36>>2]|0,d)|0)+b|0;b=c[a+4>>2]|0;return (c[b+(e*52|0)+40>>2]|0)==(c[b+(e*52|0)+44>>2]|0)|0}function m0d(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+32|0;e=d+8|0;f=d+16|0;h=d+20|0;j=d+24|0;k=d+4|0;l=d;m=d+12|0;n=b+20|0;o=c[n>>2]|0;p=b+16|0;q=c[p>>2]|0;r=(((o-q|0)/136|0)<<2)+15|0;s=(o|0)!=(q|0);if(r>>>0<2e3)if(s){q=i;i=i+((1*r|0)+15&-16)|0;t=0;u=q}else{t=0;u=0}else if(s){c[j>>2]=c[153134];c[e+0>>2]=c[j+0>>2];j=cOb(r,16,e,0,3653512,575)|0;t=j;u=j}else{t=0;u=0}j=u+15&-16;n0d(b,j);u=b+56|0;r=c[u>>2]|0;if(r)if(!(c[r+4>>2]|0)){pQb(r)|0;ODc(c[u>>2]|0,1);r=b+116|0;s=c[r>>2]|0;q=c[n>>2]|0;o=c[p>>2]|0;if((q|0)!=(o|0)){v=(q-o|0)/136|0;q=0;do{w=ea(g[s+(q<<4)>>2]);x=ea(g[s+(q<<4)+4>>2]);y=ea(g[s+(q<<4)+8>>2]);z=ea(g[s+(q<<4)+12>>2]);A=c[o+(q*136|0)+104>>2]|0;B=c[o+(q*136|0)+100>>2]|0;if((A|0)!=(B|0)){C=A-B>>3;A=0;do{D=B+(A<<3)|0;g[D>>2]=ea(w+ea(y*ea(g[D>>2])));D=B+(A<<3)+4|0;g[D>>2]=ea(x+ea(z*ea(g[D>>2])));A=A+1|0}while(A>>>0<C>>>0)}q=q+1|0}while(q>>>0<v>>>0)}c[k>>2]=c[153082];c[e+0>>2]=c[k+0>>2];eOb(s,e);c[r>>2]=0;wmc(c[u>>2]|0,0)}else E=16;else{c[l>>2]=c[153106];c[e+0>>2]=c[l+0>>2];l=xvc(4,e)|0;c[u>>2]=l;gn[c[(c[l>>2]|0)+148>>2]&127](l,2,2,5,1,1,0)|0;l=c[u>>2]|0;In[c[(c[l>>2]|0)+44>>2]&4095](l,61);ODc(c[u>>2]|0,1);E=16}if((E|0)==16){l=c[n>>2]|0;r=c[p>>2]|0;s=((l-r|0)/136|0)<<4|15;k=(l|0)!=(r|0);if(s>>>0<2e3)if(k){v=i;i=i+((1*s|0)+15&-16)|0;F=l;G=r;H=0;I=v}else{F=l;G=l;H=0;I=0}else if(k){c[m>>2]=c[153134];c[e+0>>2]=c[m+0>>2];m=cOb(s,16,e,0,3653512,606)|0;F=c[n>>2]|0;G=c[p>>2]|0;H=m;I=m}else{F=l;G=l;H=0;I=0}l=I+15&-16;I=F-G|0;G=(I|0)/136|0;F=c[u>>2]|0;a:do if((I|0)>0){m=0;while(1){s=c[j+(m<<2)>>2]|0;if((s|0)!=0?(c[s+56>>2]|0)!=0:0)break;m=m+1|0;if((m|0)>=(G|0)){E=26;break a}}NDc(F,1)}else E=26;while(0);if((E|0)==26)NDc(F,0);xmc(c[u>>2]|0,2048,G,j,l,0,1,0)|0;j=c[n>>2]|0;n=c[p>>2]|0;if((j|0)!=(n|0)){p=(j-n|0)/136|0;j=0;do{z=ea(g[l+(j<<4)>>2]);x=ea(g[l+(j<<4)+4>>2]);y=ea(g[l+(j<<4)+8>>2]);w=ea(g[l+(j<<4)+12>>2]);G=c[n+(j*136|0)+104>>2]|0;u=c[n+(j*136|0)+100>>2]|0;if((G|0)!=(u|0)){F=G-u>>3;G=0;do{E=u+(G<<3)|0;g[E>>2]=ea(z+ea(y*ea(g[E>>2])));E=u+(G<<3)+4|0;g[E>>2]=ea(x+ea(w*ea(g[E>>2])));G=G+1|0}while(G>>>0<F>>>0)}j=j+1|0}while(j>>>0<p>>>0)}if(H){c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];eOb(H,e)}}a[b>>0]=0;if(!t){i=d;return}c[h>>2]=c[153134];c[e+0>>2]=c[h+0>>2];eOb(t,e);i=d;return}function n0d(e,f){e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0;h=i;i=i+416|0;j=h+120|0;k=h+304|0;l=h+12|0;m=h+112|0;n=h+116|0;o=h+16|0;p=h+36|0;q=h+40|0;r=h+44|0;s=h+48|0;t=h+52|0;u=h+56|0;v=h+60|0;w=h+64|0;x=h+68|0;y=h+72|0;z=h+236|0;A=h+252|0;B=h+296|0;C=h+352|0;D=h+376|0;E=h+388|0;F=h+128|0;G=h+144|0;H=h+152|0;I=h+160|0;J=h+172|0;K=h+176|0;L=h+184|0;M=h+192|0;N=h+208|0;O=h+216|0;P=h+20|0;Q=h+224|0;R=h+76|0;S=h+32|0;T=h+80|0;U=h+248|0;V=h+96|0;W=h+264|0;X=h+392|0;Y=h+364|0;Z=h;_=e+20|0;$=e+16|0;e=c[$>>2]|0;if((c[_>>2]|0)==(e|0)){i=h;return}aa=k+4|0;ba=k+8|0;ca=k+12|0;fa=k+16|0;ga=k+20|0;ha=k+24|0;ia=k+28|0;ja=k+32|0;ka=k+36|0;la=k+40|0;ma=k+44|0;na=V+4|0;oa=V+8|0;pa=V+12|0;qa=W+4|0;ra=W+8|0;sa=W+12|0;ta=W+16|0;ua=W+20|0;va=W+24|0;wa=W+28|0;xa=k+48|0;ya=V+16|0;za=W+32|0;Aa=X+12|0;Ba=G+4|0;Ca=H+4|0;Da=M+4|0;Ea=M+8|0;Fa=N+4|0;Ga=O+4|0;Ha=Q+4|0;Ia=Q+8|0;Ja=K+4|0;Ka=L+4|0;La=e;e=0;do{Ma=f+(e<<2)|0;c[Ma>>2]=0;Na=La+(e*136|0)|0;Oa=c[Na>>2]|0;a:do if(!Oa)if(!(c[La+(e*136|0)+72>>2]|0))Pa=226;else Pa=248;else{c[y>>2]=Oa;Qa=c[137784]|0;if(Qa){do if((c[Qa+36>>2]|0)!=(c[Qa+4>>2]|0)){fRb(j,Qa,y);Ra=c[j>>2]|0;Sa=c[Qa+28>>2]|0;if((Ra|0)==-1){Ta=Sa+(c[Qa+32>>2]<<3)|0;break}else{Ta=Sa+(Ra<<3)|0;break}}else Ta=(c[Qa+28>>2]|0)+(c[Qa+32>>2]<<3)|0;while(0);Qa=c[137784]|0;if((Ta|0)!=((c[Qa+28>>2]|0)+(c[Qa+32>>2]<<3)|0)?(Qa=c[Ta+4>>2]|0,(Qa|0)!=0):0)Ua=Qa;else Pa=13}else Pa=13;if((Pa|0)==13){Pa=0;Ua=hQb(c[Na>>2]|0)|0}Qa=(c[La+(e*136|0)+72>>2]|0)!=0;if(!(Qa&(Ua|0)!=0))if(Qa){Pa=248;break}else{Pa=226;break}Qa=CTb(Ua,25)|0;if(!Qa){Nsd(z,718752,mo[c[(c[Ua>>2]|0)+32>>2]&4095](Ua)|0);Ra=c[La+(e*136|0)+76>>2]|0;Sa=La+(e*136|0)+80|0;Va=c[Sa>>2]|0;if((Va|0)!=(Ra|0))c[Sa>>2]=Va+(~(((Va+-12-Ra|0)>>>0)/12|0)*12|0);Ra=c[La+(e*136|0)+100>>2]|0;Va=La+(e*136|0)+104|0;Sa=c[Va>>2]|0;if((Sa|0)!=(Ra|0))c[Va>>2]=Sa+(~((Sa+-8-Ra|0)>>>3)<<3);Ra=c[La+(e*136|0)+112>>2]|0;Sa=La+(e*136|0)+116|0;Va=c[Sa>>2]|0;if((Va|0)!=(Ra|0))c[Sa>>2]=Va+(~((Va+-4-Ra|0)>>>2)<<2);Ra=c[La+(e*136|0)+124>>2]|0;Va=La+(e*136|0)+128|0;Sa=c[Va>>2]|0;if((Sa|0)!=(Ra|0))c[Va>>2]=Sa+(~((Sa+-2-Ra|0)>>>1)<<1);xri(z);break}if((mo[c[(c[Qa>>2]|0)+128>>2]&4095](Qa)|0)!=1){c[x>>2]=c[Na>>2];Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(j,Ra,x);Sa=c[j>>2]|0;Va=c[Ra+28>>2]|0;if((Sa|0)==-1){Wa=Va+(c[Ra+32>>2]<<3)|0;break}else{Wa=Va+(Sa<<3)|0;break}}else Wa=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if((Wa|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(Ra=c[Wa+4>>2]|0,(Ra|0)!=0):0)Xa=Ra;else Pa=34}else Pa=34;if((Pa|0)==34){Pa=0;Xa=hQb(c[Na>>2]|0)|0}Nsd(A,mo[c[(c[Xa>>2]|0)+32>>2]&4095](Xa)|0,718776);Ra=c[La+(e*136|0)+76>>2]|0;Sa=La+(e*136|0)+80|0;Va=c[Sa>>2]|0;if((Va|0)!=(Ra|0))c[Sa>>2]=Va+(~(((Va+-12-Ra|0)>>>0)/12|0)*12|0);Ra=c[La+(e*136|0)+100>>2]|0;Va=La+(e*136|0)+104|0;Sa=c[Va>>2]|0;if((Sa|0)!=(Ra|0))c[Va>>2]=Sa+(~((Sa+-8-Ra|0)>>>3)<<3);Ra=c[La+(e*136|0)+112>>2]|0;Sa=La+(e*136|0)+116|0;Va=c[Sa>>2]|0;if((Va|0)!=(Ra|0))c[Sa>>2]=Va+(~((Va+-4-Ra|0)>>>2)<<2);Ra=c[La+(e*136|0)+124>>2]|0;Va=La+(e*136|0)+128|0;Sa=c[Va>>2]|0;if((Sa|0)!=(Ra|0))c[Va>>2]=Sa+(~((Sa+-2-Ra|0)>>>1)<<1);xri(A);break}co[c[(c[Qa>>2]|0)+132>>2]&2047](B,Qa,0);Ra=c[B>>2]|0;do if(Ra){c[w>>2]=Ra;Sa=c[137784]|0;if(Sa){do if((c[Sa+36>>2]|0)!=(c[Sa+4>>2]|0)){fRb(j,Sa,w);Va=c[j>>2]|0;Ya=c[Sa+28>>2]|0;if((Va|0)==-1){Za=Ya+(c[Sa+32>>2]<<3)|0;break}else{Za=Ya+(Va<<3)|0;break}}else Za=(c[Sa+28>>2]|0)+(c[Sa+32>>2]<<3)|0;while(0);Sa=c[137784]|0;if((Za|0)!=((c[Sa+28>>2]|0)+(c[Sa+32>>2]<<3)|0)?(Sa=c[Za+4>>2]|0,(Sa|0)!=0):0)_a=Sa;else Pa=53}else Pa=53;if((Pa|0)==53){Pa=0;Sa=hQb(c[B>>2]|0)|0;if(!Sa)break;else _a=Sa}Sa=CTb(Ua,33)|0;if(!Sa){c[u>>2]=c[Na>>2];Va=c[137784]|0;if(Va){do if((c[Va+36>>2]|0)!=(c[Va+4>>2]|0)){fRb(j,Va,u);Ya=c[j>>2]|0;$a=c[Va+28>>2]|0;if((Ya|0)==-1){ab=$a+(c[Va+32>>2]<<3)|0;break}else{ab=$a+(Ya<<3)|0;break}}else ab=(c[Va+28>>2]|0)+(c[Va+32>>2]<<3)|0;while(0);Va=c[137784]|0;if((ab|0)!=((c[Va+28>>2]|0)+(c[Va+32>>2]<<3)|0)?(Va=c[ab+4>>2]|0,(Va|0)!=0):0)bb=Va;else Pa=81}else Pa=81;if((Pa|0)==81){Pa=0;bb=hQb(c[Na>>2]|0)|0}Nsd(D,718840,mo[c[(c[bb>>2]|0)+32>>2]&4095](bb)|0);Va=c[La+(e*136|0)+76>>2]|0;Ya=La+(e*136|0)+80|0;$a=c[Ya>>2]|0;if(($a|0)!=(Va|0))c[Ya>>2]=$a+(~((($a+-12-Va|0)>>>0)/12|0)*12|0);Va=c[La+(e*136|0)+100>>2]|0;$a=La+(e*136|0)+104|0;Ya=c[$a>>2]|0;if((Ya|0)!=(Va|0))c[$a>>2]=Ya+(~((Ya+-8-Va|0)>>>3)<<3);Va=c[La+(e*136|0)+112>>2]|0;Ya=La+(e*136|0)+116|0;$a=c[Ya>>2]|0;if(($a|0)!=(Va|0))c[Ya>>2]=$a+(~(($a+-4-Va|0)>>>2)<<2);Va=c[La+(e*136|0)+124>>2]|0;$a=La+(e*136|0)+128|0;Ya=c[$a>>2]|0;if((Ya|0)!=(Va|0))c[$a>>2]=Ya+(~((Ya+-2-Va|0)>>>1)<<1);xri(D);break a}Xgc(E,Sa);Va=c[E>>2]|0;do if(Va){c[t>>2]=Va;Ya=c[137784]|0;if(Ya){do if((c[Ya+36>>2]|0)!=(c[Ya+4>>2]|0)){fRb(j,Ya,t);$a=c[j>>2]|0;cb=c[Ya+28>>2]|0;if(($a|0)==-1){db=cb+(c[Ya+32>>2]<<3)|0;break}else{db=cb+($a<<3)|0;break}}else db=(c[Ya+28>>2]|0)+(c[Ya+32>>2]<<3)|0;while(0);Ya=c[137784]|0;if((db|0)!=((c[Ya+28>>2]|0)+(c[Ya+32>>2]<<3)|0)?(Ya=c[db+4>>2]|0,(Ya|0)!=0):0)eb=Ya;else Pa=100}else Pa=100;if((Pa|0)==100){Pa=0;Ya=hQb(c[E>>2]|0)|0;if(!Ya)break;else eb=Ya}Ya=La+(e*136|0)+76|0;$a=eb+28|0;cb=c[$a>>2]|0;fb=a[cb+11>>0]|0;gb=(a[cb+10>>0]|0)!=0|(fb&255)<3;do if(!gb){hb=c[cb+92>>2]|0;if(!((hb|0)==0|fb<<24>>24==0)){ib=d[cb+8>>0]|0;jb=d[cb+(ib*12|0)+50>>0]|0;c[G>>2]=hb+((d[cb+9>>0]|0)+(c[cb+(ib*12|0)+44>>2]|0));c[Ba>>2]=jb;if(gb){Pa=124;break}}else{c[G>>2]=0;c[Ba>>2]=1}jb=c[cb+92>>2]|0;if((jb|0)==0|fb<<24>>24==0){c[H>>2]=0;c[Ca>>2]=1;break}else{ib=d[cb+8>>0]|0;hb=d[cb+(ib*12|0)+50>>0]|0;c[H>>2]=jb+((da(hb,c[cb+100>>2]|0)|0)+(c[cb+(ib*12|0)+44>>2]|0)+(d[cb+9>>0]|0));c[Ca>>2]=hb;break}}else{c[G>>2]=0;c[Ba>>2]=0;Pa=124}while(0);if((Pa|0)==124){Pa=0;c[H>>2]=0;c[Ca>>2]=0}u0d(Ya,G,H);cb=La+(e*136|0)+80|0;if((c[Ya>>2]|0)==(c[cb>>2]|0)){Nsd(I,718880,mo[c[(c[Ua>>2]|0)+32>>2]&4095](Ua)|0);fb=c[La+(e*136|0)+76>>2]|0;gb=c[cb>>2]|0;if((gb|0)!=(fb|0))c[cb>>2]=gb+(~(((gb+-12-fb|0)>>>0)/12|0)*12|0);fb=c[La+(e*136|0)+100>>2]|0;gb=La+(e*136|0)+104|0;hb=c[gb>>2]|0;if((hb|0)!=(fb|0))c[gb>>2]=hb+(~((hb+-8-fb|0)>>>3)<<3);fb=c[La+(e*136|0)+112>>2]|0;hb=La+(e*136|0)+116|0;gb=c[hb>>2]|0;if((gb|0)!=(fb|0))c[hb>>2]=gb+(~((gb+-4-fb|0)>>>2)<<2);fb=c[La+(e*136|0)+124>>2]|0;gb=La+(e*136|0)+128|0;hb=c[gb>>2]|0;if((hb|0)!=(fb|0))c[gb>>2]=hb+(~((hb+-2-fb|0)>>>1)<<1);xri(I);break a}fb=c[$a>>2]|0;hb=La+(e*136|0)+112|0;do if(!(a[fb+19>>0]|0)){gb=c[hb>>2]|0;ib=La+(e*136|0)+116|0;jb=c[ib>>2]|0;kb=gb;if((jb|0)==(gb|0))lb=gb;else{mb=jb+(~((jb+-4-kb|0)>>>2)<<2)|0;c[ib>>2]=mb;lb=mb}mb=c[fb+100>>2]|0;c[J>>2]=-1;jb=lb-kb>>2;if(mb>>>0>jb>>>0){w0d(hb,mb-jb|0,J);break}if(mb>>>0>=jb>>>0)break;jb=gb+(mb<<2)|0;if((lb|0)==(jb|0))break;c[ib>>2]=lb+(~((lb+-4-jb|0)>>>2)<<2)}else{jb=c[fb+100>>2]|0;ib=La+(e*136|0)+116|0;mb=c[ib>>2]|0;gb=c[hb>>2]|0;kb=mb-gb>>2;do if(jb>>>0>kb>>>0){v0d(hb,jb-kb|0);nb=c[hb>>2]|0}else{if(jb>>>0>=kb>>>0){nb=gb;break}ob=gb+(jb<<2)|0;if((mb|0)==(ob|0)){nb=gb;break}c[ib>>2]=mb+(~((mb+-4-ob|0)>>>2)<<2);nb=gb}while(0);Ldc(eb,nb)}while(0);hb=c[$a>>2]|0;fb=a[hb+15>>0]|0;Ya=La+(e*136|0)+88|0;do if(!(fb<<24>>24)){gb=c[Ya>>2]|0;mb=La+(e*136|0)+92|0;ib=c[mb>>2]|0;jb=gb;if((ib|0)==(gb|0))pb=gb;else{kb=ib+(~(((ib+-12-jb|0)>>>0)/12|0)*12|0)|0;c[mb>>2]=kb;pb=kb}kb=c[hb+100>>2]|0;g[M>>2]=ea(0.0);g[Da>>2]=ea(1.0);g[Ea>>2]=ea(0.0);ib=(pb-jb|0)/12|0;if(kb>>>0>ib>>>0){x0d(Ya,kb-ib|0,M);break}if(kb>>>0>=ib>>>0)break;ib=gb+(kb*12|0)|0;if((pb|0)==(ib|0))break;c[mb>>2]=pb+(~(((pb+-12-ib|0)>>>0)/12|0)*12|0)}else{ib=(a[hb+14>>0]|0)!=0|(fb&255)<3;do if(!ib){mb=c[hb+92>>2]|0;if(mb){kb=d[hb+12>>0]|0;gb=d[hb+(kb*12|0)+50>>0]|0;c[K>>2]=mb+((d[hb+13>>0]|0)+(c[hb+(kb*12|0)+44>>2]|0));c[Ja>>2]=gb;if(ib){Pa=158;break}}else{c[K>>2]=0;c[Ja>>2]=1}gb=c[hb+92>>2]|0;if(!gb){c[L>>2]=0;c[Ka>>2]=1;break}else{kb=d[hb+12>>0]|0;mb=d[hb+(kb*12|0)+50>>0]|0;c[L>>2]=gb+((da(mb,c[hb+100>>2]|0)|0)+(c[hb+(kb*12|0)+44>>2]|0)+(d[hb+13>>0]|0));c[Ka>>2]=mb;break}}else{c[K>>2]=0;c[Ja>>2]=0;Pa=158}while(0);if((Pa|0)==158){Pa=0;c[L>>2]=0;c[Ka>>2]=0}u0d(Ya,K,L)}while(0);Ya=c[$a>>2]|0;hb=a[Ya+23>>0]|0;if(!(hb<<24>>24)){c[l>>2]=c[Na>>2];fb=c[137784]|0;do if(fb){do if((c[fb+36>>2]|0)!=(c[fb+4>>2]|0)){fRb(j,fb,l);ib=c[j>>2]|0;mb=c[fb+28>>2]|0;if((ib|0)==-1){qb=mb+(c[fb+32>>2]<<3)|0;break}else{qb=mb+(ib<<3)|0;break}}else qb=(c[fb+28>>2]|0)+(c[fb+32>>2]<<3)|0;while(0);ib=c[137784]|0;if((qb|0)==((c[ib+28>>2]|0)+(c[ib+32>>2]<<3)|0)){Pa=189;break}ib=c[qb+4>>2]|0;if(ib)rb=ib;else Pa=189}else Pa=189;while(0);if((Pa|0)==189){Pa=0;rb=hQb(c[Na>>2]|0)|0}Nsd(P,718904,mo[c[(c[rb>>2]|0)+32>>2]&4095](rb)|0);fb=c[La+(e*136|0)+76>>2]|0;$a=c[cb>>2]|0;if(($a|0)!=(fb|0))c[cb>>2]=$a+(~((($a+-12-fb|0)>>>0)/12|0)*12|0);fb=c[La+(e*136|0)+100>>2]|0;$a=La+(e*136|0)+104|0;ib=c[$a>>2]|0;if((ib|0)!=(fb|0))c[$a>>2]=ib+(~((ib+-8-fb|0)>>>3)<<3);fb=c[La+(e*136|0)+112>>2]|0;ib=La+(e*136|0)+116|0;$a=c[ib>>2]|0;if(($a|0)!=(fb|0))c[ib>>2]=$a+(~(($a+-4-fb|0)>>>2)<<2);fb=c[La+(e*136|0)+124>>2]|0;$a=La+(e*136|0)+128|0;ib=c[$a>>2]|0;if((ib|0)!=(fb|0))c[$a>>2]=ib+(~((ib+-2-fb|0)>>>1)<<1);xri(P);break a}fb=La+(e*136|0)+100|0;ib=(a[Ya+22>>0]|0)!=0|(hb&255)<2;do if(!ib){$a=c[Ya+92>>2]|0;if($a){mb=d[Ya+20>>0]|0;kb=d[Ya+(mb*12|0)+50>>0]|0;c[N>>2]=$a+((d[Ya+21>>0]|0)+(c[Ya+(mb*12|0)+44>>2]|0));c[Fa>>2]=kb;if(ib){Pa=176;break}}else{c[N>>2]=0;c[Fa>>2]=1}kb=c[Ya+92>>2]|0;if(!kb){c[O>>2]=0;c[Ga>>2]=1;break}else{mb=d[Ya+20>>0]|0;$a=d[Ya+(mb*12|0)+50>>0]|0;c[O>>2]=kb+((da($a,c[Ya+100>>2]|0)|0)+(c[Ya+(mb*12|0)+44>>2]|0)+(d[Ya+21>>0]|0));c[Ga>>2]=$a;break}}else{c[N>>2]=0;c[Fa>>2]=0;Pa=176}while(0);if((Pa|0)==176){Pa=0;c[O>>2]=0;c[Ga>>2]=0}y0d(fb,N,O);c[Q>>2]=0;c[Ha>>2]=0;c[Ia>>2]=0;hec(eb,Q);Ya=La+(e*136|0)+124|0;c[R>>2]=c[Q>>2];c[S>>2]=c[Ha>>2];c[k+0>>2]=c[R+0>>2];c[j+0>>2]=c[S+0>>2];z0d(Ya,k,j);ib=La+(e*136|0)+128|0;if((c[Ya>>2]|0)==(c[ib>>2]|0)){c[m>>2]=c[Na>>2];Ya=c[137784]|0;do if(Ya){do if((c[Ya+36>>2]|0)!=(c[Ya+4>>2]|0)){fRb(j,Ya,m);hb=c[j>>2]|0;$a=c[Ya+28>>2]|0;if((hb|0)==-1){sb=$a+(c[Ya+32>>2]<<3)|0;break}else{sb=$a+(hb<<3)|0;break}}else sb=(c[Ya+28>>2]|0)+(c[Ya+32>>2]<<3)|0;while(0);hb=c[137784]|0;if((sb|0)==((c[hb+28>>2]|0)+(c[hb+32>>2]<<3)|0)){Pa=207;break}hb=c[sb+4>>2]|0;if(hb)tb=hb;else Pa=207}else Pa=207;while(0);if((Pa|0)==207){Pa=0;tb=hQb(c[Na>>2]|0)|0}Nsd(T,718928,mo[c[(c[tb>>2]|0)+32>>2]&4095](tb)|0);Ya=c[La+(e*136|0)+76>>2]|0;fb=c[cb>>2]|0;if((fb|0)!=(Ya|0))c[cb>>2]=fb+(~(((fb+-12-Ya|0)>>>0)/12|0)*12|0);Ya=c[La+(e*136|0)+100>>2]|0;fb=La+(e*136|0)+104|0;hb=c[fb>>2]|0;if((hb|0)!=(Ya|0))c[fb>>2]=hb+(~((hb+-8-Ya|0)>>>3)<<3);Ya=c[La+(e*136|0)+112>>2]|0;hb=La+(e*136|0)+116|0;fb=c[hb>>2]|0;if((fb|0)!=(Ya|0))c[hb>>2]=fb+(~((fb+-4-Ya|0)>>>2)<<2);Ya=c[La+(e*136|0)+124>>2]|0;fb=c[ib>>2]|0;if((fb|0)!=(Ya|0))c[ib>>2]=fb+(~((fb+-2-Ya|0)>>>1)<<1);xri(T)}else{c[U>>2]=c[179686];c[j+0>>2]=c[U+0>>2];Ya=skd(_a,j)|0;if((Ya|0)!=0?(fb=(da(c[137788]|0,(c[Ya+8>>2]|0)>>>21)|0)+28|0,hb=fb>>5,(1<<fb-(hb<<5)&c[(c[137786]|0)+(hb<<2)>>2]|0)!=0):0)ub=Ya;else ub=0;c[Ma>>2]=ub}Ya=c[Q>>2]|0;if(!Ya)break a;hb=c[Ha>>2]|0;if((hb|0)!=(Ya|0))c[Ha>>2]=hb+(~((hb+-4-Ya|0)>>>2)<<2);c[n>>2]=89;c[j+0>>2]=c[n+0>>2];eOb(Ya,j);break a}while(0);c[s>>2]=c[Na>>2];Va=c[137784]|0;if(Va){do if((c[Va+36>>2]|0)!=(c[Va+4>>2]|0)){fRb(j,Va,s);Sa=c[j>>2]|0;Ya=c[Va+28>>2]|0;if((Sa|0)==-1){vb=Ya+(c[Va+32>>2]<<3)|0;break}else{vb=Ya+(Sa<<3)|0;break}}else vb=(c[Va+28>>2]|0)+(c[Va+32>>2]<<3)|0;while(0);Va=c[137784]|0;if((vb|0)!=((c[Va+28>>2]|0)+(c[Va+32>>2]<<3)|0)?(Va=c[vb+4>>2]|0,(Va|0)!=0):0)wb=Va;else Pa=109}else Pa=109;if((Pa|0)==109){Pa=0;wb=hQb(c[Na>>2]|0)|0}Nsd(F,718864,mo[c[(c[wb>>2]|0)+32>>2]&4095](wb)|0);Va=c[La+(e*136|0)+76>>2]|0;Sa=La+(e*136|0)+80|0;Ya=c[Sa>>2]|0;if((Ya|0)!=(Va|0))c[Sa>>2]=Ya+(~(((Ya+-12-Va|0)>>>0)/12|0)*12|0);Va=c[La+(e*136|0)+100>>2]|0;Ya=La+(e*136|0)+104|0;Sa=c[Ya>>2]|0;if((Sa|0)!=(Va|0))c[Ya>>2]=Sa+(~((Sa+-8-Va|0)>>>3)<<3);Va=c[La+(e*136|0)+112>>2]|0;Sa=La+(e*136|0)+116|0;Ya=c[Sa>>2]|0;if((Ya|0)!=(Va|0))c[Sa>>2]=Ya+(~((Ya+-4-Va|0)>>>2)<<2);Va=c[La+(e*136|0)+124>>2]|0;Ya=La+(e*136|0)+128|0;Sa=c[Ya>>2]|0;if((Sa|0)!=(Va|0))c[Ya>>2]=Sa+(~((Sa+-2-Va|0)>>>1)<<1);xri(F);break a}while(0);c[v>>2]=c[Na>>2];Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(j,Ra,v);Qa=c[j>>2]|0;Va=c[Ra+28>>2]|0;if((Qa|0)==-1){xb=Va+(c[Ra+32>>2]<<3)|0;break}else{xb=Va+(Qa<<3)|0;break}}else xb=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if((xb|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(Ra=c[xb+4>>2]|0,(Ra|0)!=0):0)yb=Ra;else Pa=62}else Pa=62;if((Pa|0)==62){Pa=0;yb=hQb(c[Na>>2]|0)|0}Nsd(C,718816,mo[c[(c[yb>>2]|0)+32>>2]&4095](yb)|0);Ra=c[La+(e*136|0)+76>>2]|0;Qa=La+(e*136|0)+80|0;Va=c[Qa>>2]|0;if((Va|0)!=(Ra|0))c[Qa>>2]=Va+(~(((Va+-12-Ra|0)>>>0)/12|0)*12|0);Ra=c[La+(e*136|0)+100>>2]|0;Va=La+(e*136|0)+104|0;Qa=c[Va>>2]|0;if((Qa|0)!=(Ra|0))c[Va>>2]=Qa+(~((Qa+-8-Ra|0)>>>3)<<3);Ra=c[La+(e*136|0)+112>>2]|0;Qa=La+(e*136|0)+116|0;Va=c[Qa>>2]|0;if((Va|0)!=(Ra|0))c[Qa>>2]=Va+(~((Va+-4-Ra|0)>>>2)<<2);Ra=c[La+(e*136|0)+124>>2]|0;Va=La+(e*136|0)+128|0;Qa=c[Va>>2]|0;if((Qa|0)!=(Ra|0))c[Va>>2]=Qa+(~((Qa+-2-Ra|0)>>>1)<<1);xri(C)}while(0);do if((Pa|0)==226){Pa=0;Oa=La+(e*136|0)+4|0;Ra=c[Oa>>2]|0;if(!Ra)Pa=248;else{c[o>>2]=Ra;Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(j,Ra,o);Qa=c[j>>2]|0;Va=c[Ra+28>>2]|0;if((Qa|0)==-1){zb=Va+(c[Ra+32>>2]<<3)|0;break}else{zb=Va+(Qa<<3)|0;break}}else zb=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if(!((zb|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(c[zb+4>>2]|0)!=0:0))Pa=235}else Pa=235;if((Pa|0)==235?(Pa=0,(hQb(c[Oa>>2]|0)|0)==0):0){Pa=248;break}g[k>>2]=ea(-.5);g[aa>>2]=ea(0.0);g[ba>>2]=ea(0.0);g[ca>>2]=ea(-.5);g[fa>>2]=ea(1.0);g[ga>>2]=ea(0.0);g[ha>>2]=ea(.5);g[ia>>2]=ea(1.0);g[ja>>2]=ea(0.0);g[ka>>2]=ea(.5);g[la>>2]=ea(0.0);g[ma>>2]=ea(0.0);c[V>>2]=10526880;c[na>>2]=-1;c[oa>>2]=-1;c[pa>>2]=10526880;g[W>>2]=ea(0.0);g[qa>>2]=ea(0.0);g[ra>>2]=ea(0.0);g[sa>>2]=ea(1.0);g[ta>>2]=ea(1.0);g[ua>>2]=ea(1.0);g[va>>2]=ea(1.0);g[wa>>2]=ea(0.0);b[X+0>>1]=b[359476]|0;b[X+2>>1]=b[359477]|0;b[X+4>>1]=b[359478]|0;b[X+6>>1]=b[359479]|0;b[X+8>>1]=b[359480]|0;b[X+10>>1]=b[359481]|0;A0d(La+(e*136|0)+76|0,k,xa);B0d(La+(e*136|0)+112|0,V,ya);C0d(La+(e*136|0)+100|0,W,za);D0d(La+(e*136|0)+124|0,X,Aa);Ra=c[Oa>>2]|0;if(!Ra)Ab=0;else{c[p>>2]=Ra;Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(j,Ra,p);Qa=c[j>>2]|0;Va=c[Ra+28>>2]|0;if((Qa|0)==-1){Bb=Va+(c[Ra+32>>2]<<3)|0;break}else{Bb=Va+(Qa<<3)|0;break}}else Bb=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if((Bb|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(Ra=c[Bb+4>>2]|0,(Ra|0)!=0):0)Cb=Ra;else Pa=245}else Pa=245;if((Pa|0)==245){Pa=0;Cb=hQb(c[Oa>>2]|0)|0}Ab=Cb}c[Ma>>2]=Ab}}while(0);b:do if((Pa|0)==248){Pa=0;Ma=c[Na>>2]|0;do if(Ma){c[q>>2]=Ma;Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(j,Ra,q);Qa=c[j>>2]|0;Va=c[Ra+28>>2]|0;if((Qa|0)==-1){Db=Va+(c[Ra+32>>2]<<3)|0;break}else{Db=Va+(Qa<<3)|0;break}}else Db=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if(!((Db|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(c[Db+4>>2]|0)!=0:0))Pa=257}else Pa=257;if((Pa|0)==257?(Pa=0,(hQb(c[Na>>2]|0)|0)==0):0)break;c[r>>2]=c[Na>>2];Ra=c[137784]|0;if(Ra){do if((c[Ra+36>>2]|0)!=(c[Ra+4>>2]|0)){fRb(j,Ra,r);Qa=c[j>>2]|0;Va=c[Ra+28>>2]|0;if((Qa|0)==-1){Eb=Va+(c[Ra+32>>2]<<3)|0;break}else{Eb=Va+(Qa<<3)|0;break}}else Eb=(c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0;while(0);Ra=c[137784]|0;if((Eb|0)!=((c[Ra+28>>2]|0)+(c[Ra+32>>2]<<3)|0)?(Ra=c[Eb+4>>2]|0,(Ra|0)!=0):0)Fb=Ra;else Pa=266}else Pa=266;if((Pa|0)==266){Pa=0;Fb=hQb(c[Na>>2]|0)|0}Nsd(Y,718968,mo[c[(c[Fb>>2]|0)+32>>2]&4095](Fb)|0);Ra=c[La+(e*136|0)+76>>2]|0;Qa=La+(e*136|0)+80|0;Va=c[Qa>>2]|0;if((Va|0)!=(Ra|0))c[Qa>>2]=Va+(~(((Va+-12-Ra|0)>>>0)/12|0)*12|0);Ra=c[La+(e*136|0)+100>>2]|0;Va=La+(e*136|0)+104|0;Qa=c[Va>>2]|0;if((Qa|0)!=(Ra|0))c[Va>>2]=Qa+(~((Qa+-8-Ra|0)>>>3)<<3);Ra=c[La+(e*136|0)+112>>2]|0;Qa=La+(e*136|0)+116|0;Va=c[Qa>>2]|0;if((Va|0)!=(Ra|0))c[Qa>>2]=Va+(~((Va+-4-Ra|0)>>>2)<<2);Ra=c[La+(e*136|0)+124>>2]|0;Va=La+(e*136|0)+128|0;Qa=c[Va>>2]|0;if((Qa|0)!=(Ra|0))c[Va>>2]=Qa+(~((Qa+-2-Ra|0)>>>1)<<1);xri(Y);break b}while(0);rri(Z,718992,17);Ma=c[La+(e*136|0)+76>>2]|0;Oa=La+(e*136|0)+80|0;Ra=c[Oa>>2]|0;if((Ra|0)!=(Ma|0))c[Oa>>2]=Ra+(~(((Ra+-12-Ma|0)>>>0)/12|0)*12|0);Ma=c[La+(e*136|0)+100>>2]|0;Ra=La+(e*136|0)+104|0;Oa=c[Ra>>2]|0;if((Oa|0)!=(Ma|0))c[Ra>>2]=Oa+(~((Oa+-8-Ma|0)>>>3)<<3);Ma=c[La+(e*136|0)+112>>2]|0;Oa=La+(e*136|0)+116|0;Ra=c[Oa>>2]|0;if((Ra|0)!=(Ma|0))c[Oa>>2]=Ra+(~((Ra+-4-Ma|0)>>>2)<<2);Ma=c[La+(e*136|0)+124>>2]|0;Ra=La+(e*136|0)+128|0;Oa=c[Ra>>2]|0;if((Oa|0)!=(Ma|0))c[Ra>>2]=Oa+(~((Oa+-2-Ma|0)>>>1)<<1);xri(Z)}while(0);e=e+1|0;La=c[$>>2]|0}while(e>>>0<(((c[_>>2]|0)-La|0)/136|0)>>>0);i=h;return}function o0d(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=ea(g);var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;o=(da(c[a+36>>2]|0,d)|0)+b|0;p0d(a,(c[a+4>>2]|0)+(o*52|0)|0,f,g,l,k);o=c[k>>2]|0;k=c[l>>2]|0;if((o|0)==0|(k|0)==0){p=0;i=h;return p|0}c[m>>2]=c[153106];c[j+0>>2]=c[m+0>>2];m=bOb(280,j,1,16,3653512,794)|0;c[n>>2]=c[153106];c[j+0>>2]=c[n+0>>2];Fdc(m,j,0);n=pQb(m)|0;ko[c[(c[n>>2]|0)+24>>2]&4095](n);In[c[(c[n>>2]|0)+12>>2]&4095](n,4);In[c[(c[n>>2]|0)+44>>2]&4095](n,61);c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];q0d(a,n,b,d,j,f,g,k,o);p=n;i=h;return p|0}function p0d(b,e,f,h,j,k){b=b|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=0,H=0,I=0;l=i;c[k>>2]=0;c[j>>2]=0;m=c[b+40>>2]|0;n=c[e+32>>2]|0;o=c[e+28>>2]|0;if((n|0)==(o|0)){i=l;return}p=(m|0)>0;q=e+40|0;e=c[b+16>>2]|0;b=0;r=0;while(1){s=d[o+r>>0]|0;if((c[e+(s*136|0)+68>>2]|0)==(f|0)?(t=c[e+(s*136|0)+76>>2]|0,u=c[e+(s*136|0)+80>>2]|0,(t|0)!=(u|0)):0){if(p){v=da(r,m)|0;w=c[q>>2]|0;x=0;y=0;while(1){z=da(y+v|0,m)|0;A=y&7;B=x;C=0;while(1){D=a[w+(z+C)>>0]|0;if(!(D<<24>>24))E=B;else{F=ea(ea(D&255|0)*h);E=~~ea(F+ea(ea(ea(g[719016+((C<<3&56|A)<<2)>>2])+ea(-.5))*ea(.015625)))+B|0}C=C+1|0;if((C|0)==(m|0)){G=E;break}else B=E}y=y+1|0;if((y|0)==(m|0)){H=G;break}else x=G}}else H=0;x=(u-t|0)/12|0;y=((5e4-b|0)>>>0)/(x>>>0)|0;w=(H|0)<(y|0)?H:y;y=da((c[e+(s*136|0)+128>>2]|0)-(c[e+(s*136|0)+124>>2]|0)>>1,w)|0;c[k>>2]=y+(c[k>>2]|0);y=da(x,w)|0;w=(c[j>>2]|0)+y|0;c[j>>2]=w;I=w}else I=b;r=r+1|0;if(r>>>0>=(n-o|0)>>>0)break;else b=I}i=l;return}function q0d(f,h,j,k,l,m,n,o,p){f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=Im,Oa=Im,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=Im,ib=Im,jb=Im,kb=0,lb=Im,mb=Im,nb=0,ob=Im,pb=0,qb=0,rb=Im,sb=Im,tb=Im,ub=0,vb=0,wb=Im,xb=0,yb=Im,zb=Im,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=Im,Ib=Im,Jb=Im,Kb=Im,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=Im,Vb=0,Wb=0,Xb=Im,Yb=Im,Zb=Im,_b=Im,$b=Im,ac=Im,bc=Im,cc=Im,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=Im,kc=Im,lc=0,mc=0,nc=0,oc=0,pc=0,qc=Im,rc=Im,sc=0,tc=0,uc=Im,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=0,Dc=Im,Ec=Im,Fc=0,Gc=0,Hc=Im,Ic=Im,Jc=0,Kc=0,Lc=Im,Mc=Im,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0;q=i;i=i+240|0;r=q+220|0;s=q+132|0;t=q+68|0;u=q+80|0;v=q+20|0;w=q+128|0;x=q+144|0;y=q+216|0;z=q+224|0;A=q+16|0;B=q+12|0;C=q+104|0;D=q;E=q+24|0;F=q+112|0;G=q+56|0;H=q+152|0;I=f+36|0;J=(da(c[I>>2]|0,k)|0)+j|0;K=c[f+4>>2]|0;L=(o*12|0)+15|0;M=L>>>0<2e3;N=(o|0)!=0;if(M)if(N){O=i;i=i+((1*L|0)+15&-16)|0;P=0;Q=O}else{P=0;Q=0}else if(N){c[w>>2]=c[153134];c[r+0>>2]=c[w+0>>2];w=cOb(L,16,r,0,3653512,826)|0;P=w;Q=w}else{P=0;Q=0}w=Q+15&-16;Q=(o<<3)+15|0;if(Q>>>0<2e3)if(N){O=i;i=i+((1*Q|0)+15&-16)|0;R=i;i=i+((1*Q|0)+15&-16)|0;S=O+15&-16;T=0;U=0;X=R}else{S=0;T=0;U=0;X=0}else if(N){c[x>>2]=c[153134];c[r+0>>2]=c[x+0>>2];x=cOb(Q,16,r,0,3653512,829)|0;c[y>>2]=c[153134];c[r+0>>2]=c[y+0>>2];y=cOb(Q,16,r,0,3653512,834)|0;S=x+15&-16;T=y;U=x;X=y}else{S=0;T=0;U=0;X=0}y=X+15&-16;X=(m|0)==0;x=X?o:0;Q=x<<4|15;R=(x|0)!=0;if(Q>>>0<2e3)if(R){x=i;i=i+((1*Q|0)+15&-16)|0;Y=0;Z=x}else{Y=0;Z=0}else if(R){c[z>>2]=c[153134];c[r+0>>2]=c[z+0>>2];z=cOb(Q,16,r,0,3653512,841)|0;Y=z;Z=z}else{Y=0;Z=0}z=Z+15&-16;Z=(o<<2)+15|0;if(Z>>>0<2e3)if(N){o=i;i=i+((1*Z|0)+15&-16)|0;_=0;$=o}else{_=0;$=0}else if(N){c[A>>2]=c[153134];c[r+0>>2]=c[A+0>>2];A=cOb(Z,16,r,0,3653512,844)|0;_=A;$=A}else{_=0;$=0}A=$+15&-16;if(M)if(N){M=i;i=i+((1*L|0)+15&-16)|0;aa=0;ba=M}else{aa=0;ba=0}else if(N){c[B>>2]=c[153134];c[r+0>>2]=c[B+0>>2];B=cOb(L,16,r,0,3653512,848)|0;aa=B;ba=B}else{aa=0;ba=0}B=ba+15&-16;ba=B;L=(p<<1)+15|0;N=(p|0)!=0;if(L>>>0<2e3)if(N){p=i;i=i+((1*L|0)+15&-16)|0;ca=0;fa=p}else{ca=0;fa=0}else if(N){c[C>>2]=c[153134];c[r+0>>2]=c[C+0>>2];C=cOb(L,16,r,0,3653512,851)|0;ca=C;fa=C}else{ca=0;fa=0}C=fa+15&-16;fa=C;L=C;C=c[f+40>>2]|0;ga=ea(ea(1.0)/ea(da(c[I>>2]|0,C)|0));N=(c[f+28>>2]|0)+232|0;p=K+(J*52|0)+32|0;M=K+(J*52|0)+28|0;$=c[M>>2]|0;if((c[p>>2]|0)==($|0)){ha=ea(0.0);ia=ea(0.0);ja=0;ka=0}else{Z=f+16|0;o=(C|0)>0;Q=K+(J*52|0)+40|0;la=ea(j|0);ma=ea(k|0);J=f+88|0;K=f+92|0;R=f+96|0;x=f+100|0;f=D+4|0;O=D+8|0;na=l+8|0;oa=E+4|0;pa=E+8|0;qa=E+12|0;ra=E+16|0;sa=E+20|0;ta=E+24|0;ua=E+28|0;va=F+12|0;wa=F+4|0;xa=F+8|0;ya=G+4|0;za=G+8|0;Aa=H+16|0;Ba=H+32|0;Ca=H+48|0;Da=H+4|0;Ea=H+20|0;Fa=H+36|0;Ga=H+52|0;Ha=H+8|0;Ia=H+24|0;Ja=H+40|0;Ka=H+56|0;La=(m|0)==2;Ma=(B|0)==0;B=$;Na=ea(0.0);Oa=ea(0.0);$=0;Pa=0;Qa=0;while(1){Ra=d[B+$>>0]|0;Sa=c[Z>>2]|0;if(((c[Sa+(Ra*136|0)+68>>2]|0)==(m|0)?(Ta=c[Sa+(Ra*136|0)+80>>2]|0,Ua=c[Sa+(Ra*136|0)+76>>2]|0,Va=(Ta|0)==(Ua|0),Wa=Va?0:Ua,Xa=c[Sa+(Ra*136|0)+88>>2]|0,Ya=(c[Sa+(Ra*136|0)+92>>2]|0)==(Xa|0)?0:Xa,Xa=c[Sa+(Ra*136|0)+100>>2]|0,Za=(c[Sa+(Ra*136|0)+104>>2]|0)==(Xa|0)?0:Xa,Xa=c[Sa+(Ra*136|0)+112>>2]|0,_a=(c[Sa+(Ra*136|0)+116>>2]|0)==(Xa|0)?0:Xa,Xa=c[Sa+(Ra*136|0)+128>>2]|0,$a=c[Sa+(Ra*136|0)+124>>2]|0,ab=(Xa|0)==($a|0)?0:$a,bb=ea(g[Sa+(Ra*136|0)+24>>2]),cb=ea(g[Sa+(Ra*136|0)+48>>2]),db=ea(g[Sa+(Ra*136|0)+52>>2]),eb=ea(g[Sa+(Ra*136|0)+56>>2]),fb=ea(g[Sa+(Ra*136|0)+60>>2]),gb=ea(g[Sa+(Ra*136|0)+32>>2]),hb=ea(g[Sa+(Ra*136|0)+36>>2]),ib=ea(g[Sa+(Ra*136|0)+40>>2]),jb=ea(g[Sa+(Ra*136|0)+44>>2]),kb=Sa+(Ra*136|0)+8|0,lb=ea(g[kb>>2]),mb=ea(lb*ea(.5)),nb=Sa+(Ra*136|0)+12|0,ob=ea(ea(ea(g[nb>>2])-lb)*ea(.5)),pb=Sa+(Ra*136|0)+16|0,lb=ea(g[pb>>2]),qb=Sa+(Ra*136|0)+20|0,rb=ea(ea(g[qb>>2])-lb),Ra=Xa-$a|0,$a=Ra>>1,Xa=Ta-Ua|0,Ua=(Xa|0)/12|0,!Va):0)?o:0){Va=da($,C)|0;Ta=(Xa|0)>0;Xa=(Ra|0)>0;sb=Na;tb=Oa;Ra=Pa;Sa=Qa;ub=0;while(1){vb=da(ub+Va|0,C)|0;wb=ea(ub|0);xb=ub&7;yb=sb;zb=tb;Ab=Ra;Bb=Sa;Cb=0;while(1){Db=vb+Cb|0;Eb=a[(c[Q>>2]|0)+Db>>0]|0;Fb=Eb&255;a:do if(Eb<<24>>24!=0?(Gb=c[I>>2]|0,Hb=ea(Gb|0),Ib=ea(da(Gb,C)|0),Jb=ea(ea(la/Hb)+ea(ea(Cb|0)/Ib)),Kb=ea(ea(ma/Hb)+ea(wb/Ib)),Lb=(((da(Gb,j)|0)+k|0)*1013|0)+Db|0,c[J>>2]=Lb,Gb=(da(Lb,1812433253)|0)+1|0,c[K>>2]=Gb,Mb=(da(Gb,1812433253)|0)+1|0,c[R>>2]=Mb,Nb=(da(Mb,1812433253)|0)+1|0,c[x>>2]=Nb,Ob=(5e4-Bb|0)/(Ua|0)|0,Ib=ea(ea(((Fb|0)<(Ob|0)?Fb:Ob)|0)*n),Ob=~~ea(ea(ea(ea(g[719016+((Cb<<3&56|xb)<<2)>>2])+ea(-.5))*ea(.015625))+Ib),(Ob|0)>0):0){Pb=Lb;Lb=Nb;Nb=Gb;Gb=Mb;Ib=zb;Hb=yb;Mb=1;Qb=Ab;Rb=Bb;while(1){Sb=Pb<<11^Pb;Tb=Sb>>>8^Sb^Lb;Sb=Tb^Lb>>>19;Ub=ea(Jb+ea(ga*ea(ea((Sb&8388607)>>>0)*ea(1.19209304e-07))));Vb=Nb<<11^Nb;c[J>>2]=Gb;c[K>>2]=Lb;c[R>>2]=Sb;Wb=Vb>>>8^Vb^Sb^Tb>>>19;c[x>>2]=Wb;Xb=ea(Kb+ea(ga*ea(ea((Wb&8388607)>>>0)*ea(1.19209304e-07))));g[D>>2]=ea(0.0);g[f>>2]=ea(0.0);g[O>>2]=ea(0.0);g[f>>2]=ea(_0d(N,Ub,Xb));Yb=ea(Ub*ea(g[l>>2]));g[D>>2]=Yb;Zb=ea(Xb*ea(g[na>>2]));g[O>>2]=Zb;_b=ea(ea(ea(Cbc(ea(bb*Yb),ea(bb*Zb)))+ea(.689999997))/ea(1.48300004));Zb=ea(ea(1.0)-_b);Yb=ea(ea(gb*_b)+ea(cb*Zb));$b=ea(ea(hb*_b)+ea(db*Zb));ac=ea(ea(ib*_b)+ea(eb*Zb));bc=ea(ea(jb*_b)+ea(fb*Zb));Wb=Yb<ea(0.0);cc=Wb?ea(0.0):Yb;Wb=cc>ea(1.0);Tb=~~ea(ea(cc*ea(255.0))+ea(.5))>>>0&255;Sb=Wb?-1:Tb;Tb=$b<ea(0.0);cc=Tb?ea(0.0):$b;Tb=cc>ea(1.0);Wb=~~ea(ea(cc*ea(255.0))+ea(.5))>>>0;Vb=ac<ea(0.0);cc=Vb?ea(0.0):ac;Vb=cc>ea(1.0);dc=~~ea(ea(cc*ea(255.0))+ea(.5))>>>0&255;ec=Vb?-1:dc;dc=bc<ea(0.0);cc=dc?ea(0.0):bc;dc=cc>ea(1.0);Vb=~~ea(ea(cc*ea(255.0))+ea(.5))>>>0&255;fc=dc?-1:Vb;Vb=(a[621175]|0)==0;dc=Vb?Sb:ec;gc=(Vb?ec:Sb)&255;Sb=Tb?255:Wb&255;if(Ta){cc=ea(Ub);bc=ea(Xb);Wb=0;do{Tb=y+(Wb+Rb<<3)|0;g[Tb>>2]=cc;g[Tb+4>>2]=bc;Wb=Wb+1|0}while((Wb|0)!=(Ua|0))}do if(X){bc=ea(mb+ea(ob*_b));cc=ea(lb+ea(rb*_b));ac=Ib<bc?bc:Ib;$b=Hb<cc?cc:Hb;Yb=ea(-bc);g[E>>2]=Yb;g[oa>>2]=ea(0.0);g[pa>>2]=Yb;g[qa>>2]=cc;g[ra>>2]=bc;g[sa>>2]=cc;g[ta>>2]=bc;g[ua>>2]=ea(0.0);bc=ea(g[D>>2]);cc=ea(g[f>>2]);Yb=ea(g[O>>2]);do if(Ta){Wb=0;do{Tb=Wb+Rb|0;g[w+(Tb*12|0)>>2]=bc;g[w+(Tb*12|0)+4>>2]=cc;g[w+(Tb*12|0)+8>>2]=Yb;Wb=Wb+1|0}while((Wb|0)!=(Ua|0));hc=0;do{Wb=Za+(hc<<3)|0;Tb=c[Wb+4>>2]|0;ec=S+(hc+Rb<<3)|0;c[ec>>2]=c[Wb>>2];c[ec+4>>2]=Tb;hc=hc+1|0}while((hc|0)!=(Ua|0));ic=0;do{jc=ea(g[E+(ic<<3)>>2]);kc=ea(g[E+(ic<<3)+4>>2]);Tb=ic+Rb|0;g[z+(Tb<<4)>>2]=jc;g[z+(Tb<<4)+4>>2]=kc;ic=ic+1|0}while((ic|0)!=(Ua|0));Tb=(dc&255)+1|0;ec=Sb+1|0;Wb=gc+1|0;Vb=(fc&255)+1|0;lc=0;do{mc=c[_a+(lc<<2)>>2]|0;nc=mc>>>8;c[A+(lc+Rb<<2)>>2]=(da(nc&255,ec)|0)&65280|(da(nc&16711680,Vb)|0)&-16777216|(da(mc&255,Tb)|0)>>>8&255|(da(mc&16711680,Wb)|0)>>>8&16711680;lc=lc+1|0}while((lc|0)!=(Ua|0));$0d(s,N,Ub,Xb);if(Ta)oc=0;else break;do{lc=ba+((oc+Rb|0)*12|0)|0;c[lc+0>>2]=c[s+0>>2];c[lc+4>>2]=c[s+4>>2];c[lc+8>>2]=c[s+8>>2];oc=oc+1|0}while((oc|0)!=(Ua|0))}else $0d(s,N,Ub,Xb);while(0);if(Xa)pc=0;else{qc=ac;rc=$b;break}do{b[L+(pc+Qb<<1)>>1]=(e[ab+(pc<<1)>>1]|0)+Rb;pc=pc+1|0}while((pc|0)<($a|0));qc=ac;rc=$b}else{lc=c[J>>2]|0;Wb=lc<<11^lc;c[J>>2]=c[K>>2];c[K>>2]=c[R>>2];lc=c[x>>2]|0;c[R>>2]=lc;Tb=Wb>>>8^Wb^lc^lc>>>19;c[x>>2]=Tb;$b=ea(ea(ea(ea((Tb&8388607)>>>0)*ea(1.19209304e-07))*ea(6.283185))*ea(.5));ac=ea(+W(+$b));g[va>>2]=ea(+V(+$b));$b=ea(ac*ea(0.0));g[F>>2]=$b;g[wa>>2]=ac;g[xa>>2]=$b;$b=ea(g[kb>>2]);ac=ea(ea(Zb*$b)+ea(_b*ea(g[nb>>2])));$b=ea(g[pb>>2]);Yb=ea(ea(Zb*$b)+ea(_b*ea(g[qb>>2])));g[G>>2]=ac;g[ya>>2]=Yb;g[za>>2]=ac;vMc(H,D,F,G);if(Ta){Tb=0;do{lc=Tb+Rb|0;ac=ea(g[H>>2]);Yb=ea(g[Wa+(Tb*12|0)>>2]);$b=ea(ac*Yb);ac=ea(g[Aa>>2]);cc=ea(g[Wa+(Tb*12|0)+4>>2]);bc=ea($b+ea(ac*cc));ac=ea(g[Ba>>2]);$b=ea(g[Wa+(Tb*12|0)+8>>2]);kc=ea(bc+ea(ac*$b));ac=ea(ea(g[Ca>>2])+kc);kc=ea(Yb*ea(g[Da>>2]));bc=ea(kc+ea(cc*ea(g[Ea>>2])));kc=ea(bc+ea($b*ea(g[Fa>>2])));bc=ea(ea(g[Ga>>2])+kc);kc=ea(Yb*ea(g[Ha>>2]));Yb=ea(kc+ea(cc*ea(g[Ia>>2])));cc=ea(Yb+ea($b*ea(g[Ja>>2])));$b=ea(ea(g[Ka>>2])+cc);g[w+(lc*12|0)>>2]=ac;g[w+(lc*12|0)+4>>2]=bc;g[w+(lc*12|0)+8>>2]=$b;Tb=Tb+1|0}while((Tb|0)!=(Ua|0));sc=0;do{Tb=Za+(sc<<3)|0;lc=c[Tb+4>>2]|0;Wb=S+(sc+Rb<<3)|0;c[Wb>>2]=c[Tb>>2];c[Wb+4>>2]=lc;sc=sc+1|0}while((sc|0)!=(Ua|0));lc=(dc&255)+1|0;Wb=Sb+1|0;Tb=gc+1|0;Vb=(fc&255)+1|0;ec=0;do{mc=c[_a+(ec<<2)>>2]|0;nc=mc>>>8;c[A+(ec+Rb<<2)>>2]=(da(nc&255,Wb)|0)&65280|(da(nc&16711680,Vb)|0)&-16777216|(da(mc&255,lc)|0)>>>8&255|(da(mc&16711680,Tb)|0)>>>8&16711680;ec=ec+1|0}while((ec|0)!=(Ua|0))}do if(La){$0d(t,N,Ub,Xb);if(Ta)tc=0;else break;do{ec=ba+((tc+Rb|0)*12|0)|0;c[ec+0>>2]=c[t+0>>2];c[ec+4>>2]=c[t+4>>2];c[ec+8>>2]=c[t+8>>2];tc=tc+1|0}while((tc|0)!=(Ua|0))}else{if(Ma)break;$b=ea(g[F>>2]);bc=ea(g[wa>>2]);ac=ea(g[xa>>2]);cc=ea(g[va>>2]);if(!Ta)break;Yb=ea($b*ea(2.0));kc=ea(bc*ea(2.0));jc=ea(ac*ea(2.0));uc=ea($b*Yb);vc=ea(bc*kc);wc=ea(ac*jc);ac=ea($b*kc);xc=ea($b*jc);$b=ea(bc*jc);bc=ea(Yb*cc);Yb=ea(kc*cc);kc=ea(cc*jc);jc=ea(ea(1.0)-ea(vc+wc));cc=ea(ac-kc);yc=ea(xc+Yb);zc=ea(ac+kc);kc=ea(ea(1.0)-ea(uc+wc));wc=ea($b-bc);ac=ea(xc-Yb);Yb=ea($b+bc);bc=ea(ea(1.0)-ea(uc+vc));ec=0;do{Tb=ec+Rb|0;vc=ea(g[Ya+(ec*12|0)>>2]);uc=ea(jc*vc);$b=ea(g[Ya+(ec*12|0)+4>>2]);xc=ea(uc+ea(cc*$b));uc=ea(g[Ya+(ec*12|0)+8>>2]);Ac=ea(ea(wc*uc)+ea(ea(zc*vc)+ea(kc*$b)));Bc=ea(ea(ea(ac*vc)+ea(Yb*$b))+ea(bc*uc));g[ba+(Tb*12|0)>>2]=ea(ea(yc*uc)+xc);g[ba+(Tb*12|0)+4>>2]=Ac;g[ba+(Tb*12|0)+8>>2]=Bc;ec=ec+1|0}while((ec|0)!=(Ua|0))}while(0);if(Xa)Cc=0;else{qc=Ib;rc=Hb;break}do{b[L+(Cc+Qb<<1)>>1]=(e[ab+(Cc<<1)>>1]|0)+Rb;Cc=Cc+1|0}while((Cc|0)<($a|0));qc=Ib;rc=Hb}while(0);fc=Qb+$a|0;gc=Rb+Ua|0;if((Mb|0)>=(Ob|0)){Dc=qc;Ec=rc;Fc=fc;Gc=gc;break a}Pb=c[J>>2]|0;Lb=c[x>>2]|0;Nb=c[K>>2]|0;Gb=c[R>>2]|0;Ib=qc;Hb=rc;Mb=Mb+1|0;Qb=fc;Rb=gc}}else{Dc=zb;Ec=yb;Fc=Ab;Gc=Bb}while(0);Cb=Cb+1|0;if((Cb|0)>=(C|0)){Hc=Dc;Ic=Ec;Jc=Fc;Kc=Gc;break}else{yb=Ec;zb=Dc;Ab=Fc;Bb=Gc}}ub=ub+1|0;if((ub|0)>=(C|0)){Lc=Hc;Mc=Ic;Nc=Jc;Oc=Kc;break}else{sb=Ic;tb=Hc;Ra=Jc;Sa=Kc}}}else{Lc=Oa;Mc=Na;Nc=Pa;Oc=Qa}$=$+1|0;B=c[M>>2]|0;if($>>>0>=((c[p>>2]|0)-B|0)>>>0){ha=Lc;ia=Mc;ja=Nc;ka=Oc;break}else{Na=Mc;Oa=Lc;Pa=Nc;Qa=Oc}}}Vdc(h,1);Odc(h,ka,X?159:31);Oc=h+28|0;Qa=c[Oc>>2]|0;Nc=a[Qa+11>>0]|0;if(!((a[Qa+10>>0]|0)!=0|(Nc&255)<3)){Pa=c[Qa+92>>2]|0;if((Pa|0)==0|Nc<<24>>24==0){Pc=1;Qc=0}else{Nc=d[Qa+8>>0]|0;Pc=d[Qa+(Nc*12|0)+50>>0]|0;Qc=Pa+((d[Qa+9>>0]|0)+(c[Qa+(Nc*12|0)+44>>2]|0))|0}}else{Pc=0;Qc=0}Nc=w+(ka*12|0)|0;Pa=(ka|0)==0;if(Pa)Rc=Qa;else{Qa=w;w=Qc;while(1){c[w+0>>2]=c[Qa+0>>2];c[w+4>>2]=c[Qa+4>>2];c[w+8>>2]=c[Qa+8>>2];Qa=Qa+12|0;if((Qa|0)==(Nc|0))break;else w=w+Pc|0}Rc=c[Oc>>2]|0}Pc=a[Rc+19>>0]|0;if(!((a[Rc+18>>0]|0)!=2|(Pc&255)<4)){w=c[Rc+92>>2]|0;if((w|0)==0|Pc<<24>>24==0){Sc=1;Tc=0}else{Pc=d[Rc+16>>0]|0;Sc=d[Rc+(Pc*12|0)+50>>0]|0;Tc=w+((d[Rc+17>>0]|0)+(c[Rc+(Pc*12|0)+44>>2]|0))|0}}else{Sc=0;Tc=0}Pc=A+(ka<<2)|0;if(!Pa){w=A;A=Tc;while(1){c[A>>2]=c[w>>2];w=w+4|0;if((w|0)==(Pc|0))break;else A=A+Sc|0}}Sc=a[Rc+15>>0]|0;if(!((a[Rc+14>>0]|0)!=0|(Sc&255)<3)){A=c[Rc+92>>2]|0;if((A|0)==0|Sc<<24>>24==0){Uc=1;Vc=0}else{Sc=d[Rc+12>>0]|0;Uc=d[Rc+(Sc*12|0)+50>>0]|0;Vc=A+((d[Rc+13>>0]|0)+(c[Rc+(Sc*12|0)+44>>2]|0))|0}}else{Uc=0;Vc=0}Sc=ba+(ka*12|0)|0;if(Pa)Wc=Rc;else{Rc=ba;ba=Vc;while(1){c[ba+0>>2]=c[Rc+0>>2];c[ba+4>>2]=c[Rc+4>>2];c[ba+8>>2]=c[Rc+8>>2];Rc=Rc+12|0;if((Rc|0)==(Sc|0))break;else ba=ba+Uc|0}Wc=c[Oc>>2]|0}Uc=a[Wc+23>>0]|0;if(!((a[Wc+22>>0]|0)!=0|(Uc&255)<2)){ba=c[Wc+92>>2]|0;if((ba|0)==0|Uc<<24>>24==0){Xc=1;Yc=0}else{Uc=d[Wc+20>>0]|0;Xc=d[Wc+(Uc*12|0)+50>>0]|0;Yc=ba+((d[Wc+21>>0]|0)+(c[Wc+(Uc*12|0)+44>>2]|0))|0}}else{Xc=0;Yc=0}Uc=S+(ka<<3)|0;if(Pa)Zc=Wc;else{Wc=S;S=Yc;while(1){Yc=Wc;ba=c[Yc+4>>2]|0;Sc=S;c[Sc>>2]=c[Yc>>2];c[Sc+4>>2]=ba;Wc=Wc+8|0;if((Wc|0)==(Uc|0))break;else S=S+Xc|0}Zc=c[Oc>>2]|0}Xc=a[Zc+27>>0]|0;if(!((a[Zc+26>>0]|0)!=0|(Xc&255)<2)){S=c[Zc+92>>2]|0;if((S|0)==0|Xc<<24>>24==0){_c=1;$c=0}else{Xc=d[Zc+24>>0]|0;_c=d[Zc+(Xc*12|0)+50>>0]|0;$c=S+((d[Zc+25>>0]|0)+(c[Zc+(Xc*12|0)+44>>2]|0))|0}}else{_c=0;$c=0}Xc=y+(ka<<3)|0;if(!Pa){Zc=y;y=$c;while(1){$c=Zc;S=c[$c+4>>2]|0;Uc=y;c[Uc>>2]=c[$c>>2];c[Uc+4>>2]=S;Zc=Zc+8|0;if((Zc|0)==(Xc|0))break;else y=y+_c|0}}do if(X){_c=c[Oc>>2]|0;y=a[_c+39>>0]|0;do if((a[_c+38>>0]|0)!=0|(y&255)<4){ad=0;bd=0}else{Xc=c[_c+92>>2]|0;if((Xc|0)==0|y<<24>>24==0){ad=1;bd=0;break}Zc=d[_c+36>>0]|0;ad=d[_c+(Zc*12|0)+50>>0]|0;bd=Xc+((d[_c+37>>0]|0)+(c[_c+(Zc*12|0)+44>>2]|0))|0}while(0);_c=z+(ka<<4)|0;if(!Pa){y=z;Zc=bd;while(1){c[Zc+0>>2]=c[y+0>>2];c[Zc+4>>2]=c[y+4>>2];c[Zc+8>>2]=c[y+8>>2];c[Zc+12>>2]=c[y+12>>2];y=y+16|0;if((y|0)==(_c|0))break;else Zc=Zc+ad|0}}lec(h,fa,ja,0,0,1)|0;Xdc(h,c[(c[Oc>>2]|0)+96>>2]|0,1);Udc(h);if(!X)break;Zc=h+168|0;c[u+0>>2]=c[Zc+0>>2];c[u+4>>2]=c[Zc+4>>2];c[u+8>>2]=c[Zc+8>>2];c[u+12>>2]=c[Zc+12>>2];c[u+16>>2]=c[Zc+16>>2];c[u+20>>2]=c[Zc+20>>2];Lc=ha<ia?ia:ha;Oa=ea(ia*ea(.5));Zc=u+12|0;g[Zc>>2]=ea(Lc+ea(g[Zc>>2]));Zc=u+16|0;g[Zc>>2]=ea(Oa+ea(g[Zc>>2]));Zc=u+20|0;g[Zc>>2]=ea(Lc+ea(g[Zc>>2]));g[u>>2]=ea(ea(g[u>>2])+ea(0.0));Zc=u+4|0;g[Zc>>2]=ea(Oa+ea(g[Zc>>2]));Zc=u+8|0;g[Zc>>2]=ea(ea(g[Zc>>2])+ea(0.0));oec(h,u)}else{lec(h,fa,ja,0,0,1)|0;Xdc(h,c[(c[Oc>>2]|0)+96>>2]|0,1);Udc(h)}while(0);if(ca){c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(ca,r)}if(aa){c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(aa,r)}if(_){c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(_,r)}if(Y){c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(Y,r)}if(T){c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(T,r)}if(U){c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(U,r)}if(!P){i=q;return}c[v>>2]=c[153134];c[r+0>>2]=c[v+0>>2];eOb(P,r);i=q;return}function r0d(b){b=b|0;var c=0;c=i;if(!(a[b>>0]|0)){i=c;return}m0d(b);i=c;return}function s0d(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,791824);c[179686]=c[b>>2];i=a;return}function t0d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[a>>2]|0;do if(f){c[e>>2]=f;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0)l=g;else m=10}else m=10;if((m|0)==10){g=hQb(c[a>>2]|0)|0;if(!g)break;else l=g}g=(da(c[137788]|0,(c[l+8>>2]|0)>>>21)|0)+28|0;h=g>>5;if(1<<g-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]){n=l;i=b;return n|0}}while(0);n=0;i=b;return n|0}function u0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[b>>2]|0;g=b+4|0;h=c[d>>2]|0;j=c[d+4>>2]|0;k=((h-f|0)>>>0)/(j>>>0)|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>((m-o|0)/12|0)>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~(((q+-12-o|0)>>>0)/12|0)*12|0);ACi(n);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if(k>>>0>357913941)vxi(a);m=(p-0|0)/12|0;if(m>>>0<178956970){p=m<<1;m=p>>>0<k>>>0?k:p;if(m>>>0>357913941)vxi(a);else r=m}else r=357913941;m=xCi(r*12|0)|0;p=a+4|0;c[p>>2]=m;c[a>>2]=m;c[l>>2]=m+(r*12|0);r=c[b>>2]|0;b=c[g>>2]|0;l=c[d>>2]|0;if((r|0)==(l|0)){i=e;return}else{s=m;t=r}do{c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];s=(c[p>>2]|0)+12|0;c[p>>2]=s;t=t+b|0}while((t|0)!=(l|0));i=e;return}l=a+4|0;a=((c[l>>2]|0)-o|0)/12|0;o=c[g>>2]|0;if(k>>>0>a>>>0){u=f+(da(o,a)|0)|0;v=o;w=1}else{u=h;v=j;w=0}if((f|0)==(u|0))x=n;else{j=n;n=f;while(1){c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];n=n+o|0;f=j+12|0;if((n|0)==(u|0)){x=f;break}else j=f}}if(!w){w=c[l>>2]|0;if((w|0)==(x|0)){i=e;return}c[l>>2]=w+(~(((w+-12-x|0)>>>0)/12|0)*12|0);i=e;return}x=c[d>>2]|0;if((u|0)==(x|0)){i=e;return}d=c[l>>2]|0;w=u;do{if(!d)y=0;else{c[d+0>>2]=c[w+0>>2];c[d+4>>2]=c[w+4>>2];c[d+8>>2]=c[w+8>>2];y=c[l>>2]|0}d=y+12|0;c[l>>2]=d;w=w+v|0}while((w|0)!=(x|0));i=e;return}function v0d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+8|0;f=c[e>>2]|0;g=a+4|0;h=c[g>>2]|0;j=h;if(f-j>>2>>>0>=b>>>0){c[g>>2]=h+(b<<2);i=d;return}h=c[a>>2]|0;k=(j-h>>2)+b|0;if(k>>>0>1073741823)vxi(a);j=h;l=f-j|0;if(l>>2>>>0<536870911){f=l>>1;l=f>>>0<k>>>0?k:f;f=(c[g>>2]|0)-j|0;k=f>>2;if(!l){m=0;n=0;o=k;p=f}else{q=l;r=k;s=f;t=8}}else{f=(c[g>>2]|0)-j|0;q=1073741823;r=f>>2;s=f;t=8}if((t|0)==8){m=q;n=xCi(q<<2)|0;o=r;p=s}YEi(n|0,h|0,p|0)|0;c[a>>2]=n;c[g>>2]=n+(o+b<<2);c[e>>2]=n+(m<<2);if(!h){i=d;return}ACi(h);i=d;return}function w0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(g-k>>2>>>0>=b>>>0){l=b;m=j;do{if(!m)n=0;else{c[m>>2]=c[d>>2];n=c[h>>2]|0}m=n+4|0;c[h>>2]=m;l=l+-1|0}while((l|0)!=0);i=e;return}l=c[a>>2]|0;m=(k-l>>2)+b|0;if(m>>>0>1073741823)vxi(a);k=l;l=g-k|0;if(l>>2>>>0<536870911){g=l>>1;l=g>>>0<m>>>0?m:g;g=(c[h>>2]|0)-k>>2;if(!l){o=0;p=0;q=g}else{r=l;s=g;t=11}}else{r=1073741823;s=(c[h>>2]|0)-k>>2;t=11}if((t|0)==11){o=r;p=xCi(r<<2)|0;q=s}s=b;b=p+(q<<2)|0;while(1){if(!b)u=0;else{c[b>>2]=c[d>>2];u=b}r=u+4|0;s=s+-1|0;if(!s){v=r;break}else b=r}b=c[a>>2]|0;s=(c[h>>2]|0)-b|0;u=p+(q-(s>>2)<<2)|0;YEi(u|0,b|0,s|0)|0;c[a>>2]=u;c[h>>2]=v;c[f>>2]=p+(o<<2);if(!b){i=e;return}ACi(b);i=e;return}function x0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8|0;g=c[f>>2]|0;h=a+4|0;j=c[h>>2]|0;k=j;if(((g-k|0)/12|0)>>>0>=b>>>0){l=b;m=j;do{if(!m)n=0;else{c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];n=c[h>>2]|0}m=n+12|0;c[h>>2]=m;l=l+-1|0}while((l|0)!=0);i=e;return}l=c[a>>2]|0;m=((k-l|0)/12|0)+b|0;if(m>>>0>357913941)vxi(a);k=l;l=(g-k|0)/12|0;if(l>>>0<178956970){g=l<<1;l=g>>>0<m>>>0?m:g;g=((c[h>>2]|0)-k|0)/12|0;if(!l){o=0;p=0;q=g}else{r=l;s=g;t=11}}else{r=357913941;s=((c[h>>2]|0)-k|0)/12|0;t=11}if((t|0)==11){o=r;p=xCi(r*12|0)|0;q=s}s=b;b=p+(q*12|0)|0;while(1){if(!b)u=0;else{c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];u=b}r=u+12|0;s=s+-1|0;if(!s){v=r;break}else b=r}b=c[a>>2]|0;s=(c[h>>2]|0)-b|0;u=p+((((s|0)/-12|0)+q|0)*12|0)|0;YEi(u|0,b|0,s|0)|0;c[a>>2]=u;c[h>>2]=v;c[f>>2]=p+(o*12|0);if(!b){i=e;return}ACi(b);i=e;return}function y0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[b>>2]|0;g=b+4|0;h=c[d>>2]|0;j=c[d+4>>2]|0;k=((h-f|0)>>>0)/(j>>>0)|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>m-o>>3>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~((q+-8-o|0)>>>3)<<3);ACi(n);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if(k>>>0>536870911)vxi(a);m=p-0|0;if(m>>3>>>0<268435455){p=m>>2;m=p>>>0<k>>>0?k:p;if(m>>>0>536870911)vxi(a);else r=m}else r=536870911;m=xCi(r<<3)|0;p=a+4|0;c[p>>2]=m;c[a>>2]=m;c[l>>2]=m+(r<<3);r=c[b>>2]|0;b=c[g>>2]|0;l=c[d>>2]|0;if((r|0)==(l|0)){i=e;return}else{s=m;t=r}do{r=t;m=c[r+4>>2]|0;q=s;c[q>>2]=c[r>>2];c[q+4>>2]=m;s=(c[p>>2]|0)+8|0;c[p>>2]=s;t=t+b|0}while((t|0)!=(l|0));i=e;return}l=a+4|0;a=(c[l>>2]|0)-o>>3;o=c[g>>2]|0;if(k>>>0>a>>>0){u=f+(da(o,a)|0)|0;v=o;w=1}else{u=h;v=j;w=0}if((f|0)==(u|0))x=n;else{j=n;n=f;while(1){f=n;h=c[f+4>>2]|0;a=j;c[a>>2]=c[f>>2];c[a+4>>2]=h;n=n+o|0;h=j+8|0;if((n|0)==(u|0)){x=h;break}else j=h}}if(!w){w=c[l>>2]|0;if((w|0)==(x|0)){i=e;return}c[l>>2]=w+(~((w+-8-x|0)>>>3)<<3);i=e;return}x=c[d>>2]|0;if((u|0)==(x|0)){i=e;return}d=c[l>>2]|0;w=u;do{if(!d)y=0;else{u=w;j=c[u+4>>2]|0;n=d;c[n>>2]=c[u>>2];c[n+4>>2]=j;y=c[l>>2]|0}d=y+8|0;c[l>>2]=d;w=w+v|0}while((w|0)!=(x|0));i=e;return}function z0d(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;g=c[d>>2]|0;d=c[e>>2]|0;e=g;h=d-e|0;j=h>>2;k=a+8|0;l=c[k>>2]|0;m=c[a>>2]|0;n=m;if(j>>>0>l-n>>1>>>0){if(!m)o=l;else{l=a+4|0;p=c[l>>2]|0;if((p|0)!=(m|0))c[l>>2]=p+(~((p+-2-n|0)>>>1)<<1);ACi(m);c[k>>2]=0;c[l>>2]=0;c[a>>2]=0;o=0}if((h|0)<0)vxi(a);h=o-0|0;if(h>>1>>>0<1073741823){o=h>>>0<j>>>0?j:h;if((o|0)<0)vxi(a);else q=o}else q=2147483647;o=xCi(q<<1)|0;h=a+4|0;c[h>>2]=o;c[a>>2]=o;c[k>>2]=o+(q<<1);if((g|0)==(d|0)){i=f;return}q=(d+-4-e|0)>>>2;k=g;l=o;while(1){b[l>>1]=c[k>>2];k=k+4|0;if((k|0)==(d|0))break;else l=l+2|0}c[h>>2]=o+(q+1<<1);i=f;return}q=a+4|0;a=c[q>>2]|0;o=a-n>>1;if(j>>>0>o>>>0){r=g+(o<<2)|0;s=1}else{r=d;s=0}if((g|0)==(r|0))t=m;else{o=r+-4-e|0;e=g;g=m;while(1){b[g>>1]=c[e>>2];e=e+4|0;if((e|0)==(r|0))break;else g=g+2|0}t=m+((o>>>2)+1<<1)|0}if(!s){if((a|0)==(t|0)){i=f;return}c[q>>2]=a+(~((a+-2-t|0)>>>1)<<1);i=f;return}if((r|0)==(d|0)){i=f;return}t=(d+-4-r|0)>>>2;s=a;o=r;while(1){if(s)b[s>>1]=c[o>>2];o=o+4|0;if((o|0)==(d|0))break;else s=s+2|0}c[q>>2]=a+(t+1<<1);i=f;return}function A0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=b;g=(d-f|0)/12|0;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=((j-l|0)/12|0)>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=(n|0)/12|0;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;f=k+(((p|0)/12|0)*12|0)|0;p=c[m>>2]|0;if((p|0)==(f|0)){i=e;return}c[m>>2]=p+(~(((p+-12-f|0)>>>0)/12|0)*12|0);i=e;return}f=b+(o*12|0)|0;aFi(k|0,b|0,n|0)|0;if((f|0)==(d|0)){i=e;return}n=f;f=c[m>>2]|0;do{if(!f)q=0;else{c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];q=c[m>>2]|0}f=q+12|0;c[m>>2]=f;n=n+12|0}while((n|0)!=(d|0));i=e;return}if(!k)r=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~(((n+-12-l|0)>>>0)/12|0)*12|0);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;r=0}if(g>>>0>357913941)vxi(a);j=(r-0|0)/12|0;if(j>>>0<178956970){r=j<<1;j=r>>>0<g>>>0?g:r;if(j>>>0>357913941)vxi(a);else s=j}else s=357913941;j=xCi(s*12|0)|0;r=a+4|0;c[r>>2]=j;c[a>>2]=j;c[h>>2]=j+(s*12|0);if((b|0)==(d|0)){i=e;return}else{t=b;u=j}do{c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];u=(c[r>>2]|0)+12|0;c[r>>2]=u;t=t+12|0}while((t|0)!=(d|0));i=e;return}function B0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=b;g=d-f>>2;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0>j-l>>2>>>0){if(!k)m=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-4-l|0)>>>2)<<2);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;m=0}if(g>>>0>1073741823)vxi(a);j=m-0|0;if(j>>2>>>0<536870911){m=j>>1;j=m>>>0<g>>>0?g:m;if(j>>>0>1073741823)vxi(a);else o=j}else o=1073741823;j=xCi(o<<2)|0;m=a+4|0;c[m>>2]=j;c[a>>2]=j;c[h>>2]=j+(o<<2);if((b|0)==(d|0)){i=e;return}else{p=b;q=j}do{c[q>>2]=c[p>>2];q=(c[m>>2]|0)+4|0;c[m>>2]=q;p=p+4|0}while((p|0)!=(d|0));i=e;return}p=a+4|0;a=c[p>>2]|0;q=a-l>>2;if(g>>>0>q>>>0){r=1;s=b+(q<<2)|0}else{r=0;s=d}if((s|0)==(b|0))t=k;else{q=s+-4-f|0;f=b;b=k;while(1){c[b>>2]=c[f>>2];f=f+4|0;if((f|0)==(s|0))break;else b=b+4|0}t=k+((q>>>2)+1<<2)|0}if(!r){if((a|0)==(t|0)){i=e;return}c[p>>2]=a+(~((a+-4-t|0)>>>2)<<2);i=e;return}if((s|0)==(d|0)){i=e;return}else{u=s;v=a}do{if(!v)w=0;else{c[v>>2]=c[u>>2];w=c[p>>2]|0}v=w+4|0;c[p>>2]=v;u=u+4|0}while((u|0)!=(d|0));i=e;return}function C0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=b;g=d-f>>3;h=a+8|0;j=c[h>>2]|0;k=c[a>>2]|0;l=k;if(g>>>0<=j-l>>3>>>0){m=a+4|0;n=(c[m>>2]|0)-l|0;o=n>>3;if(g>>>0<=o>>>0){p=d-f|0;aFi(k|0,b|0,p|0)|0;f=k+(p>>3<<3)|0;p=c[m>>2]|0;if((p|0)==(f|0)){i=e;return}c[m>>2]=p+(~((p+-8-f|0)>>>3)<<3);i=e;return}f=b+(o<<3)|0;aFi(k|0,b|0,n|0)|0;if((f|0)==(d|0)){i=e;return}n=f;f=c[m>>2]|0;do{if(!f)q=0;else{o=n;p=c[o+4>>2]|0;r=f;c[r>>2]=c[o>>2];c[r+4>>2]=p;q=c[m>>2]|0}f=q+8|0;c[m>>2]=f;n=n+8|0}while((n|0)!=(d|0));i=e;return}if(!k)s=j;else{j=a+4|0;n=c[j>>2]|0;if((n|0)!=(k|0))c[j>>2]=n+(~((n+-8-l|0)>>>3)<<3);ACi(k);c[h>>2]=0;c[j>>2]=0;c[a>>2]=0;s=0}if(g>>>0>536870911)vxi(a);j=s-0|0;if(j>>3>>>0<268435455){s=j>>2;j=s>>>0<g>>>0?g:s;if(j>>>0>536870911)vxi(a);else t=j}else t=536870911;j=xCi(t<<3)|0;s=a+4|0;c[s>>2]=j;c[a>>2]=j;c[h>>2]=j+(t<<3);if((b|0)==(d|0)){i=e;return}else{u=b;v=j}do{j=u;b=c[j+4>>2]|0;t=v;c[t>>2]=c[j>>2];c[t+4>>2]=b;v=(c[s>>2]|0)+8|0;c[s>>2]=v;u=u+8|0}while((u|0)!=(d|0));i=e;return}function D0d(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=d;h=e-g|0;j=h>>1;k=a+8|0;l=c[k>>2]|0;m=c[a>>2]|0;n=m;if(j>>>0<=l-n>>1>>>0){o=a+4|0;p=(c[o>>2]|0)-n|0;q=p>>1;if(j>>>0<=q>>>0){r=e-g|0;aFi(m|0,d|0,r|0)|0;s=m+(r>>1<<1)|0;r=c[o>>2]|0;if((r|0)==(s|0)){i=f;return}c[o>>2]=r+(~((r+-2-s|0)>>>1)<<1);i=f;return}s=d+(q<<1)|0;aFi(m|0,d|0,p|0)|0;if((s|0)==(e|0)){i=f;return}p=c[o>>2]|0;q=(e+-2-s|0)>>>1;r=s;s=p;while(1){if(s)b[s>>1]=b[r>>1]|0;r=r+2|0;if((r|0)==(e|0))break;else s=s+2|0}c[o>>2]=p+(q+1<<1);i=f;return}if(!m)t=l;else{l=a+4|0;q=c[l>>2]|0;if((q|0)!=(m|0))c[l>>2]=q+(~((q+-2-n|0)>>>1)<<1);ACi(m);c[k>>2]=0;c[l>>2]=0;c[a>>2]=0;t=0}if((h|0)<0)vxi(a);h=t-0|0;if(h>>1>>>0<1073741823){t=h>>>0<j>>>0?j:h;if((t|0)<0)vxi(a);else u=t}else u=2147483647;t=xCi(u<<1)|0;h=a+4|0;c[h>>2]=t;c[a>>2]=t;c[k>>2]=t+(u<<1);if((d|0)==(e|0)){i=f;return}u=(e+-2-g|0)>>>1;g=d;d=t;while(1){b[d>>1]=b[g>>1]|0;g=g+2|0;if((g|0)==(e|0))break;else d=d+2|0}c[h>>2]=t+(u+1<<1);i=f;return}function E0d(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;h=f+28|0;j=f+16|0;k=f+4|0;l=f;m=a+12|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[a+68>>2]=0;c[a+72>>2]=0;c[a+64>>2]=a+68;c[a+80>>2]=0;c[a+84>>2]=0;c[a+76>>2]=a+80;c[a+92>>2]=0;c[a+96>>2]=0;c[a+88>>2]=a+92;n=a+100|0;g[n>>2]=ea(0.0);g[a+104>>2]=ea(0.0);g[a+108>>2]=ea(0.0);c[m>>2]=c[d>>2];c[n+0>>2]=c[e+0>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];e=a+28|0;b[e+2>>1]=255;b[e>>1]=255;g[a+32>>2]=ea(1.0);g[a+36>>2]=ea(1.0);g[a+40>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+48>>2]=ea(1.0);g[a+52>>2]=ea(1.0);g[a+56>>2]=ea(0.0);g[a+60>>2]=ea(0.0);e=Xmd()|0;n=0;d=0;while(1){m=c[719592+(n<<2)>>2]|0;rri(j,m,SEi(m|0)|0);m=Nmd(e,j)|0;xri(j);if(!m){rri(k,722224,7);o=Nmd(e,k)|0;xri(k);p=o;q=1}else{p=m;q=d}m=bkd(p,61,0)|0;c[a+(n<<2)>>2]=m;c[l>>2]=c[179818];c[h+0>>2]=c[l+0>>2];nkd(m,h,ea(.375));n=n+1|0;if((n|0)>=3)break;else d=q}if(!q){r=a+112|0;c[r>>2]=0;s=a+116|0;g[s>>2]=ea(0.0);i=f;return}Krd(722104,0,3653512,65,1,0,0,0);r=a+112|0;c[r>>2]=0;s=a+116|0;g[s>>2]=ea(0.0);i=f;return}function F0d(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=ea(g);var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+32|0;j=h+12|0;k=h+8|0;l=h+4|0;m=h;n=b+(f*12|0)+64|0;o=b+12|0;c[l>>2]=c[o>>2];p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(j,p,l);q=c[j>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[s+4>>2]|0,(p|0)!=0):0)t=p;else u=9}else u=9;if((u|0)==9)t=hQb(c[o>>2]|0)|0;c[m>>2]=(da(c[t+148>>2]|0,e)|0)+d;t=L0d(n,m)|0;m=t+6|0;if(a[m>>0]|0){v=b+112|0;w=c[v>>2]|0;x=t+8|0;c[x>>2]=w;i=h;return t|0}c[k>>2]=c[o>>2];n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(j,n,k);p=c[j>>2]|0;s=c[n+28>>2]|0;if((p|0)==-1){y=s+(c[n+32>>2]<<3)|0;break}else{y=s+(p<<3)|0;break}}else y=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((y|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[y+4>>2]|0,(n|0)!=0):0)z=n;else u=19}else u=19;if((u|0)==19)z=hQb(c[o>>2]|0)|0;o=b+16|0;c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];o=o0d(z+112|0,d,e,j,f,g)|0;c[t>>2]=o;a[t+5>>0]=(o|0)==0&1;c[t+12>>2]=d;c[t+16>>2]=e;a[m>>0]=1;v=b+112|0;w=c[v>>2]|0;x=t+8|0;c[x>>2]=w;i=h;return t|0}function G0d(d,e,f,h,j,k){d=d|0;e=e|0;f=ea(f);h=h|0;j=ea(j);k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=Im,S=0,U=0,V=0,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0,ba=0,da=0,fa=0,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;l=i;i=i+416|0;m=l+384|0;n=l;o=l+4|0;p=l+96|0;q=l+284|0;r=l+40|0;s=l+52|0;t=l+56|0;u=l+256|0;v=l+272|0;w=l+288|0;x=l+392|0;y=l+160|0;z=l+184|0;A=l+196|0;B=l+8|0;C=l+208|0;D=l+60|0;E=l+244|0;F=l+24|0;G=l+72|0;H=l+268|0;I=l+88|0;if(j<ea(0.0))J=ea(0.0);else{K=j>ea(1.0);J=K?ea(1.0):j}K=d+12|0;c[q>>2]=c[K>>2];L=c[137784]|0;if(L){do if((c[L+36>>2]|0)!=(c[L+4>>2]|0)){fRb(m,L,q);M=c[m>>2]|0;N=c[L+28>>2]|0;if((M|0)==-1){O=N+(c[L+32>>2]<<3)|0;break}else{O=N+(M<<3)|0;break}}else O=(c[L+28>>2]|0)+(c[L+32>>2]<<3)|0;while(0);L=c[137784]|0;if((O|0)!=((c[L+28>>2]|0)+(c[L+32>>2]<<3)|0)?(L=c[O+4>>2]|0,(L|0)!=0):0)P=L;else Q=11}else Q=11;if((Q|0)==11)P=hQb(c[K>>2]|0)|0;L=P+112|0;if(oVb()|0){j=ea(g[(jLc()|0)+104>>2]);R=ea(ea(j*ea(g[L+76>>2]))*ea(.0500000007))}else R=ea(0.0);P=d+116|0;g[P>>2]=ea(R+ea(g[P>>2]));O=d+112|0;c[O>>2]=(c[O>>2]|0)+1;q=d+16|0;c[o>>2]=c[K>>2];M=c[137784]|0;if(M){do if((c[M+36>>2]|0)!=(c[M+4>>2]|0)){fRb(m,M,o);N=c[m>>2]|0;S=c[M+28>>2]|0;if((N|0)==-1){U=S+(c[M+32>>2]<<3)|0;break}else{U=S+(N<<3)|0;break}}else U=(c[M+28>>2]|0)+(c[M+32>>2]<<3)|0;while(0);M=c[137784]|0;if((U|0)!=((c[M+28>>2]|0)+(c[M+32>>2]<<3)|0)?(M=c[U+4>>2]|0,(M|0)!=0):0)V=M;else Q=22}else Q=22;if((Q|0)==22)V=hQb(c[K>>2]|0)|0;X0d(r,V+232|0);c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];r=c[L+36>>2]|0;if(!r){i=l;return}r0d(L);V=L+56|0;K=c[d>>2]|0;c[s>>2]=c[179822];c[m+0>>2]=c[s+0>>2];if(pkd(K,m)|0){K=c[d>>2]|0;c[t>>2]=c[179822];Q=c[V>>2]|0;c[m+0>>2]=c[t+0>>2];rkd(K,m,Q)}Q=d+4|0;K=c[Q>>2]|0;c[s>>2]=c[179822];c[m+0>>2]=c[s+0>>2];if(pkd(K,m)|0){K=c[Q>>2]|0;c[t>>2]=c[179822];Q=c[V>>2]|0;c[m+0>>2]=c[t+0>>2];rkd(K,m,Q)}Q=d+8|0;K=c[Q>>2]|0;c[s>>2]=c[179822];c[m+0>>2]=c[s+0>>2];if(pkd(K,m)|0){K=c[Q>>2]|0;c[t>>2]=c[179822];Q=c[V>>2]|0;c[m+0>>2]=c[t+0>>2];rkd(K,m,Q)}Q=BTb(c[e+24>>2]|0)|0;rGc(v,Q);K=d+100|0;R=ea(g[v>>2]);j=ea(R-ea(g[K>>2]));R=ea(g[v+4>>2]);t=d+104|0;W=ea(R-ea(g[t>>2]));R=ea(g[v+8>>2]);v=d+108|0;X=ea(R-ea(g[v>>2]));g[u>>2]=j;V=u+4|0;g[V>>2]=W;s=u+8|0;g[s>>2]=X;W=ea(r|0);R=ea(W*j);j=ea(g[q>>2]);Y=ea(ea(R/j)+ea(.5));if(!(Y>=ea(0.0)))Z=ea(Y+ea(-.99999994));else Z=Y;q=~~Z;Z=ea(W*X);X=ea(g[d+24>>2]);Y=ea(ea(Z/X)+ea(.5));if(!(Y>=ea(0.0)))_=ea(Y+ea(-.99999994));else _=Y;M=~~_;_=ea(W*f);U=~~ea(ea(ca(ea(_/j)))+ea(1.0));o=~~ea(ea(ca(ea(_/X)))+ea(1.0));N=q-U|0;S=(N|0)<0?0:N;N=r+-1|0;$=M-o|0;aa=($|0)<0?0:$;$=U+q|0;q=($|0)<0?0:$;$=o+M|0;M=($|0)<0?0:$;$=(M|0)>(N|0)?N:M;g[w>>2]=ea(0.0);g[w+4>>2]=ea(0.0);g[w+8>>2]=ea(0.0);g[w+16>>2]=ea(0.0);g[w+20>>2]=ea(0.0);g[w+24>>2]=ea(0.0);g[w+32>>2]=ea(0.0);g[w+36>>2]=ea(0.0);g[w+40>>2]=ea(0.0);g[w+48>>2]=ea(0.0);g[w+52>>2]=ea(0.0);g[w+56>>2]=ea(0.0);g[w+64>>2]=ea(0.0);g[w+68>>2]=ea(0.0);g[w+72>>2]=ea(0.0);g[w+80>>2]=ea(0.0);g[w+84>>2]=ea(0.0);g[w+88>>2]=ea(0.0);M=(S|0)>(N|0)?N:S;S=(aa|0)>(N|0)?N:aa;aa=(q|0)>(N|0)?N:q;X=ea(f*f);r1b(N$b(e)|0,w);q=Nld(hkd(c[d>>2]|0)|0)|0;if(k){if((S|0)<=($|0)){N=(M|0)>(aa|0);o=x+4|0;U=x+8|0;ba=S;while(1){if(!N){S=M;while(1){do if(!(l0d(L,S,ba)|0)){if(!q){da=F0d(d,S,ba,1,J)|0;do if(!(a[da+5>>0]|0)){fa=(c[da>>2]|0)+168|0;c[x+0>>2]=c[fa+0>>2];c[x+4>>2]=c[fa+4>>2];c[x+8>>2]=c[fa+8>>2];c[x+12>>2]=c[fa+12>>2];c[x+16>>2]=c[fa+16>>2];c[x+20>>2]=c[fa+20>>2];fa=da+4|0;a[fa>>0]=1;if(ea(Qlc(u,x))>X){a[fa>>0]=0;break}f=ea(g[K>>2]);g[x>>2]=ea(f+ea(g[x>>2]));f=ea(g[t>>2]);g[o>>2]=ea(f+ea(g[o>>2]));f=ea(g[v>>2]);g[U>>2]=ea(f+ea(g[U>>2]));if(pmc(x,w)|0)break;a[fa>>0]=0}else a[da+4>>0]=0;while(0);da=F0d(d,S,ba,2,J)|0;if(a[da+5>>0]|0){a[da+4>>0]=0;break}fa=(c[da>>2]|0)+168|0;c[x+0>>2]=c[fa+0>>2];c[x+4>>2]=c[fa+4>>2];c[x+8>>2]=c[fa+8>>2];c[x+12>>2]=c[fa+12>>2];c[x+16>>2]=c[fa+16>>2];c[x+20>>2]=c[fa+20>>2];fa=da+4|0;a[fa>>0]=1;if(ea(Qlc(u,x))>X){a[fa>>0]=0;break}f=ea(g[K>>2]);g[x>>2]=ea(f+ea(g[x>>2]));f=ea(g[t>>2]);g[o>>2]=ea(f+ea(g[o>>2]));f=ea(g[v>>2]);g[U>>2]=ea(f+ea(g[U>>2]));if(pmc(x,w)|0)break;a[fa>>0]=0;break}fa=F0d(d,S,ba,0,J)|0;do if(!(a[fa+5>>0]|0)){da=(c[fa>>2]|0)+168|0;c[x+0>>2]=c[da+0>>2];c[x+4>>2]=c[da+4>>2];c[x+8>>2]=c[da+8>>2];c[x+12>>2]=c[da+12>>2];c[x+16>>2]=c[da+16>>2];c[x+20>>2]=c[da+20>>2];da=fa+4|0;a[da>>0]=1;if(ea(Qlc(u,x))>X){a[da>>0]=0;break}f=ea(g[K>>2]);g[x>>2]=ea(f+ea(g[x>>2]));f=ea(g[t>>2]);g[o>>2]=ea(f+ea(g[o>>2]));f=ea(g[v>>2]);g[U>>2]=ea(f+ea(g[U>>2]));if(pmc(x,w)|0)break;a[da>>0]=0}else a[fa+4>>0]=0;while(0);fa=F0d(d,S,ba,1,J)|0;do if(!(a[fa+5>>0]|0)){da=(c[fa>>2]|0)+168|0;c[x+0>>2]=c[da+0>>2];c[x+4>>2]=c[da+4>>2];c[x+8>>2]=c[da+8>>2];c[x+12>>2]=c[da+12>>2];c[x+16>>2]=c[da+16>>2];c[x+20>>2]=c[da+20>>2];da=fa+4|0;a[da>>0]=1;if(ea(Qlc(u,x))>X){a[da>>0]=0;break}f=ea(g[K>>2]);g[x>>2]=ea(f+ea(g[x>>2]));f=ea(g[t>>2]);g[o>>2]=ea(f+ea(g[o>>2]));f=ea(g[v>>2]);g[U>>2]=ea(f+ea(g[U>>2]));if(pmc(x,w)|0)break;a[da>>0]=0}else a[fa+4>>0]=0;while(0);fa=F0d(d,S,ba,2,J)|0;if(a[fa+5>>0]|0){a[fa+4>>0]=0;break}da=(c[fa>>2]|0)+168|0;c[x+0>>2]=c[da+0>>2];c[x+4>>2]=c[da+4>>2];c[x+8>>2]=c[da+8>>2];c[x+12>>2]=c[da+12>>2];c[x+16>>2]=c[da+16>>2];c[x+20>>2]=c[da+20>>2];da=fa+4|0;a[da>>0]=1;if(ea(Qlc(u,x))>X){a[da>>0]=0;break}f=ea(g[K>>2]);g[x>>2]=ea(f+ea(g[x>>2]));f=ea(g[t>>2]);g[o>>2]=ea(f+ea(g[o>>2]));f=ea(g[v>>2]);g[U>>2]=ea(f+ea(g[U>>2]));if(pmc(x,w)|0)break;a[da>>0]=0}while(0);if((S|0)<(aa|0))S=S+1|0;else break}}if((ba|0)<($|0))ba=ba+1|0;else break}}}else if((r|0)>0){ba=y+4|0;x=y+8|0;U=0;do{o=(U|0)>($|0);M=0;do{do if(!(l0d(L,M,U)|0)){N=(M|0)>(aa|0)|o;do if(q){S=F0d(d,M,U,0,J)|0;if(N){a[S+4>>0]=0;break}if(a[S+5>>0]|0){a[S+4>>0]=0;break}da=(c[S>>2]|0)+168|0;c[y+0>>2]=c[da+0>>2];c[y+4>>2]=c[da+4>>2];c[y+8>>2]=c[da+8>>2];c[y+12>>2]=c[da+12>>2];c[y+16>>2]=c[da+16>>2];c[y+20>>2]=c[da+20>>2];da=S+4|0;a[da>>0]=1;if(ea(Qlc(u,y))>X){a[da>>0]=0;break}f=ea(g[K>>2]);g[y>>2]=ea(f+ea(g[y>>2]));f=ea(g[t>>2]);g[ba>>2]=ea(f+ea(g[ba>>2]));f=ea(g[v>>2]);g[x>>2]=ea(f+ea(g[x>>2]));if(pmc(y,w)|0)break;a[da>>0]=0}while(0);da=F0d(d,M,U,1,J)|0;do if(N)a[da+4>>0]=0;else{if(a[da+5>>0]|0){a[da+4>>0]=0;break}S=(c[da>>2]|0)+168|0;c[y+0>>2]=c[S+0>>2];c[y+4>>2]=c[S+4>>2];c[y+8>>2]=c[S+8>>2];c[y+12>>2]=c[S+12>>2];c[y+16>>2]=c[S+16>>2];c[y+20>>2]=c[S+20>>2];S=da+4|0;a[S>>0]=1;if(ea(Qlc(u,y))>X){a[S>>0]=0;break}f=ea(g[K>>2]);g[y>>2]=ea(f+ea(g[y>>2]));f=ea(g[t>>2]);g[ba>>2]=ea(f+ea(g[ba>>2]));f=ea(g[v>>2]);g[x>>2]=ea(f+ea(g[x>>2]));if(pmc(y,w)|0)break;a[S>>0]=0}while(0);da=F0d(d,M,U,2,J)|0;if(N){a[da+4>>0]=0;break}if(a[da+5>>0]|0){a[da+4>>0]=0;break}S=(c[da>>2]|0)+168|0;c[y+0>>2]=c[S+0>>2];c[y+4>>2]=c[S+4>>2];c[y+8>>2]=c[S+8>>2];c[y+12>>2]=c[S+12>>2];c[y+16>>2]=c[S+16>>2];c[y+20>>2]=c[S+20>>2];S=da+4|0;a[S>>0]=1;if(ea(Qlc(u,y))>X){a[S>>0]=0;break}f=ea(g[K>>2]);g[y>>2]=ea(f+ea(g[y>>2]));f=ea(g[t>>2]);g[ba>>2]=ea(f+ea(g[ba>>2]));f=ea(g[v>>2]);g[x>>2]=ea(f+ea(g[x>>2]));if(pmc(y,w)|0)break;a[S>>0]=0}while(0);M=M+1|0}while((M|0)!=(r|0));U=U+1|0}while((U|0)!=(r|0))}g[A>>2]=ea(0.0);g[A+4>>2]=ea(1.0);g[A+8>>2]=ea(0.0);LGc(z,Q,A);A=z+8|0;g[A>>2]=ea(0.0);TGc(B,Q,z);c[z+0>>2]=c[B+0>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];J=ea(g[z>>2]);f=ea(J*J);B=z+4|0;_=ea(g[B>>2]);j=ea(f+ea(_*_));f=ea(g[A>>2]);W=ea(T(ea(j+ea(f*f))));j=ea(g[150276]);if(W>j){ga=ea(J/W);ha=ea(_/W);ia=ea(f/W)}else{W=ea(g[150284]);f=ea(g[150285]);ga=W;ha=f;ia=ea(g[150286])}g[z>>2]=ga;g[B>>2]=ha;g[A>>2]=ia;r=c[153134]|0;c[C>>2]=0;U=C+4|0;c[U>>2]=r;w=C+8|0;c[w>>2]=0;y=C+12|0;c[y>>2]=0;x=C+16|0;c[x>>2]=0;v=C+20|0;c[v>>2]=r;r=C+24|0;c[r>>2]=0;ba=C+28|0;c[ba>>2]=0;t=C+32|0;q=c[155410]|0;c[t>>2]=q;g[E>>2]=ea(0.0);g[E+4>>2]=ea(0.0);g[E+8>>2]=ea(-1.0);TGc(D,Q,E);ia=ea(g[D+4>>2]);ha=ea(g[A>>2]);ga=ea(ia*ha);f=ea(g[D+8>>2]);W=ea(g[B>>2]);_=ea(ga-ea(f*W));ga=ea(g[z>>2]);J=ea(f*ga);f=ea(g[D>>2]);Y=ea(J-ea(ha*f));ha=ea(ea(W*f)-ea(ia*ga));ga=ea(T(ea(ea(ha*ha)+ea(ea(_*_)+ea(Y*Y)))));if(ga>j){ja=ea(_/ga);ka=ea(Y/ga);la=ea(ha/ga)}else{ga=ea(g[150284]);ha=ea(g[150285]);ja=ga;ka=ha;la=ea(g[150286])}kMc(p,K)|0;K=F+4|0;D=F+8|0;ha=ea(ea(1.0)/X);E=F+12|0;Q=L+84|0;aa=L+60|0;$=d+28|0;M=L+80|0;L=0;do{o=c[d+(L<<2)>>2]|0;c[w>>2]=0;c[r>>2]=0;c[t>>2]=q;nld(C,719296,X);g[F>>2]=ea(g[u>>2]);g[K>>2]=ea(g[V>>2]);g[D>>2]=ea(g[s>>2]);g[E>>2]=ha;old(C,719320,F);g[F>>2]=ea(g[P>>2]);g[K>>2]=ea(ea(g[Q>>2])*ea(.400000006));if((L|0)==1)ma=ea(0.0);else ma=ea(ea(g[M>>2])*ea(6.0));g[D>>2]=ma;g[E>>2]=X;old(C,719344,F);c[G+0>>2]=c[aa+0>>2];c[G+4>>2]=c[aa+4>>2];c[G+8>>2]=c[aa+8>>2];c[G+12>>2]=c[aa+12>>2];pld(C,719376,G);g[F>>2]=ja;g[K>>2]=ka;g[D>>2]=la;g[E>>2]=ea(0.0);old(C,719400,F);g[F>>2]=ea(g[z>>2]);g[K>>2]=ea(g[B>>2]);g[D>>2]=ea(g[A>>2]);g[E>>2]=ea(0.0);old(C,719424,F);S=c[d+(L*12|0)+64>>2]|0;da=d+(L*12|0)+68|0;if((S|0)!=(da|0)){fa=(o|0)==0;na=o+4|0;o=S;while(1){if(a[o+24>>0]|0){S=c[o+20>>2]|0;if(fa)oa=0;else oa=c[na>>2]|0;c[H>>2]=oa;pa=e4b(p,S,H,h,0,1,0,e)|0;S=pa+204|0;if((S|0)!=(C|0)){qa=c[C>>2]|0;ra=c[w>>2]<<4;sa=ra>>4;ta=pa+212|0;c[ta>>2]=sa;ua=pa+216|0;va=c[ua>>2]|0;do if((va&2147483647)>>>0<sa>>>0)if((va|0)>-1){c[ua>>2]=sa;wa=c[S>>2]|0;c[n>>2]=c[pa+208>>2];c[m+0>>2]=c[n+0>>2];xa=hOb(wa,ra,4,m,0,3653512,370)|0;c[S>>2]=xa;ya=xa;break}else{c[n>>2]=c[pa+208>>2];c[m+0>>2]=c[n+0>>2];xa=cOb(ra,4,m,0,3653512,352)|0;YEi(xa|0,c[S>>2]|0,c[ta>>2]<<4|0)|0;c[ua>>2]=sa;c[S>>2]=xa;ya=xa;break}else ya=c[S>>2]|0;while(0);YEi(ya|0,qa|0,c[ta>>2]<<4|0)|0;sa=pa+220|0;ua=c[x>>2]|0;ra=c[r>>2]<<2;va=ra>>2;xa=pa+228|0;c[xa>>2]=va;wa=pa+232|0;za=c[wa>>2]|0;do if((za&2147483647)>>>0<va>>>0)if((za|0)>-1){c[wa>>2]=va;Aa=c[sa>>2]|0;c[n>>2]=c[pa+224>>2];c[m+0>>2]=c[n+0>>2];Ba=hOb(Aa,ra,4,m,0,3653512,370)|0;c[sa>>2]=Ba;Ca=Ba;break}else{c[n>>2]=c[pa+224>>2];c[m+0>>2]=c[n+0>>2];Ba=cOb(ra,4,m,0,3653512,352)|0;YEi(Ba|0,c[sa>>2]|0,c[xa>>2]<<2|0)|0;c[wa>>2]=va;c[sa>>2]=Ba;Ca=Ba;break}else Ca=c[sa>>2]|0;while(0);YEi(Ca|0,ua|0,c[xa>>2]<<2|0)|0}c[pa+236>>2]=c[t>>2];xld(S);c[pa+168>>2]=S;sa=0;do{va=b[$+(sa<<1)>>1]|0;__b(pa,va<<16>>16==255?-1:va&65535,sa);$_b(pa,d+(sa<<4)+32|0,sa);sa=sa+1|0}while((sa|0)<2)}sa=c[o+4>>2]|0;if(!sa){pa=o;while(1){S=c[pa+8>>2]|0;if((c[S>>2]|0)==(pa|0)){Da=S;break}else pa=S}}else{pa=sa;while(1){S=c[pa>>2]|0;if(!S){Da=pa;break}else pa=S}}if((Da|0)==(da|0))break;else o=Da}}L=L+1|0}while((L|0)<3);if(k){k=0;do{L=d+(k*12|0)+64|0;Da=c[L>>2]|0;$=d+(k*12|0)+68|0;if((Da|0)!=($|0)){t=Da;while(1){Da=c[t+4>>2]|0;if(!Da){Ca=t;while(1){r=c[Ca+8>>2]|0;if((c[r>>2]|0)==(Ca|0)){Ea=r;break}else Ca=r}}else{Ca=Da;while(1){r=c[Ca>>2]|0;if(!r){Ea=Ca;break}else Ca=r}}if((c[t+28>>2]|0)<(c[O>>2]|0)){c[n>>2]=t;c[m+0>>2]=c[n+0>>2];M0d(I,L,m)}if((Ea|0)==($|0))break;else t=Ea}}k=k+1|0}while((k|0)<3)}if((c[ba>>2]|0)>-1){ba=c[x>>2]|0;c[p>>2]=c[v>>2];c[m+0>>2]=c[p+0>>2];eOb(ba,m);c[x>>2]=0}if((c[y>>2]|0)<=-1){i=l;return}y=c[C>>2]|0;c[p>>2]=c[U>>2];c[m+0>>2]=c[p+0>>2];eOb(y,m);c[C>>2]=0;i=l;return}function H0d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;kQb(c[b>>2]|0);e=c[b+64>>2]|0;f=b+68|0;if((e|0)!=(f|0)){g=e;while(1){a[g+26>>0]=0;e=g+20|0;kQb(c[e>>2]|0);c[e>>2]=0;e=c[g+4>>2]|0;if(!e){h=g;while(1){j=c[h+8>>2]|0;if((c[j>>2]|0)==(h|0)){k=j;break}else h=j}}else{h=e;while(1){j=c[h>>2]|0;if(!j){k=h;break}else h=j}}if((k|0)==(f|0))break;else g=k}}kQb(c[b+4>>2]|0);k=c[b+76>>2]|0;g=b+80|0;if((k|0)!=(g|0)){f=k;while(1){a[f+26>>0]=0;k=f+20|0;kQb(c[k>>2]|0);c[k>>2]=0;k=c[f+4>>2]|0;if(!k){h=f;while(1){e=c[h+8>>2]|0;if((c[e>>2]|0)==(h|0)){l=e;break}else h=e}}else{h=k;while(1){e=c[h>>2]|0;if(!e){l=h;break}else h=e}}if((l|0)==(g|0))break;else f=l}}kQb(c[b+8>>2]|0);l=c[b+88>>2]|0;f=b+92|0;if((l|0)==(f|0)){i=d;return}else m=l;while(1){a[m+26>>0]=0;l=m+20|0;kQb(c[l>>2]|0);c[l>>2]=0;l=c[m+4>>2]|0;if(!l){b=m;while(1){g=c[b+8>>2]|0;if((c[g>>2]|0)==(b|0)){n=g;break}else b=g}}else{b=l;while(1){g=c[b>>2]|0;if(!g){n=b;break}else b=g}}if((n|0)==(f|0))break;else m=n}i=d;return}function I0d(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+64|0;K0d(d,c[a+68>>2]|0);c[a+72>>2]=0;e=a+68|0;c[d>>2]=e;c[e>>2]=0;e=a+76|0;K0d(e,c[a+80>>2]|0);c[a+84>>2]=0;d=a+80|0;c[e>>2]=d;c[d>>2]=0;d=a+88|0;K0d(d,c[a+92>>2]|0);c[a+96>>2]=0;e=a+92|0;c[d>>2]=e;c[e>>2]=0;i=b;return}function J0d(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,719280);c[179818]=c[b>>2];c[b>>2]=-1;itd(b,791824);c[179822]=c[b>>2];c[b>>2]=-1;itd(b,719304);c[179824]=c[b>>2];c[b>>2]=-1;itd(b,719328);c[179830]=c[b>>2];c[b>>2]=-1;itd(b,719352);c[179836]=c[b>>2];c[b>>2]=-1;itd(b,719384);c[179844]=c[b>>2];c[b>>2]=-1;itd(b,719408);c[179850]=c[b>>2];c[b>>2]=-1;itd(b,719432);c[179856]=c[b>>2];i=a;return}function K0d(b,d){b=b|0;d=d|0;var e=0;e=i;if(!d){i=e;return}K0d(b,c[d>>2]|0);K0d(b,c[d+4>>2]|0);kQb(c[d+20>>2]|0);if(!(a[719616]|0)){N0d(719608,40);b=719616;c[b>>2]=1;c[b+4>>2]=0}dsd(c[179902]|0,d);i=e;return}function L0d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e;g=b+4|0;h=c[g>>2]|0;do if(h){j=c[d>>2]|0;k=h;while(1){l=c[k+16>>2]|0;if(j>>>0<l>>>0){m=c[k>>2]|0;if(!m){n=k;o=k;p=5;break}else{k=m;continue}}if(l>>>0>=j>>>0){q=k;p=9;break}l=k+4|0;m=c[l>>2]|0;if(!m){r=l;s=k;p=8;break}else k=m}if((p|0)==5){c[f>>2]=o;t=n;u=o;break}else if((p|0)==8){c[f>>2]=s;t=r;u=s;break}else if((p|0)==9){c[f>>2]=q;t=f;u=q;break}}else{k=b+4|0;c[f>>2]=k;t=k;u=k}while(0);f=c[t>>2]|0;if(f){v=f;w=v+20|0;i=e;return w|0}if(!(a[719616]|0)){N0d(719608,40);f=719616;c[f>>2]=1;c[f+4>>2]=0}f=csd(c[179902]|0,40)|0;c[f+16>>2]=c[d>>2];a[f+26>>0]=0;c[f+20>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=u;c[t>>2]=f;u=c[c[b>>2]>>2]|0;if(!u)x=f;else{c[b>>2]=u;x=c[t>>2]|0}GN(c[g>>2]|0,x);x=b+8|0;c[x>>2]=(c[x>>2]|0)+1;v=f;w=v+20|0;i=e;return w|0}function M0d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[e>>2]|0;c[b>>2]=g;e=c[g+4>>2]|0;if(!e){h=g;while(1){j=c[h+8>>2]|0;if((c[j>>2]|0)==(h|0)){k=j;break}else h=j}}else{h=e;while(1){e=c[h>>2]|0;if(!e){k=h;break}else h=e}}c[b>>2]=k;if((c[d>>2]|0)==(g|0))c[d>>2]=k;k=d+8|0;c[k>>2]=(c[k>>2]|0)+-1;tYb(c[d+4>>2]|0,g);kQb(c[g+20>>2]|0);if(a[719616]|0){l=c[179902]|0;dsd(l,g);i=f;return}N0d(719608,40);d=719616;c[d>>2]=1;c[d+4>>2]=0;l=c[179902]|0;dsd(l,g);i=f;return}function N0d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=c[153126];c[e+0>>2]=c[f+0>>2];f=bOb(44,e,0,16,3653512,142)|0;c[g>>2]=c[153126];c[e+0>>2]=c[g+0>>2];_rd(f,1,719624,b,32768,e,16);c[a>>2]=f;Zrd(f);i=d;return}function O0d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im;e=i;i=i+48|0;f=e;h=e+40|0;j=e+36|0;k=e+24|0;l=e+8|0;c[b>>2]=d;d=b+4|0;c[d>>2]=0;m=b+8|0;c[m>>2]=0;c[b+12>>2]=0;g[b+32>>2]=ea(x);g[b+36>>2]=ea(x);n=b+40|0;a[n>>0]=1;c[b+44>>2]=0;o=b+48|0;c[o>>2]=256;p=b+52|0;c[p>>2]=2048;q=b+56|0;r=601008;s=q+64|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));mBc(1);if(!(rBc()|0)){mBc(0);r=b+16|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;a[r+12>>0]=0;i=e;return}a[b+28>>0]=1;r=c[b>>2]|0;q=r+32|0;s=c[q>>2]|0;t=r+28|0;r=c[t>>2]|0;u=s-r>>7;v=c[m>>2]|0;w=c[d>>2]|0;y=v-w>>4;if(u>>>0<=y>>>0)if(u>>>0<y>>>0?(z=w+(u<<4)|0,(v|0)!=(z|0)):0){c[m>>2]=v+(~((v+-16-z|0)>>>4)<<4);A=s;B=r}else{A=s;B=r}else{Dmc(d,u-y|0);A=c[q>>2]|0;B=c[t>>2]|0}if((A|0)==(B|0)){C=B;D=ea(0.0)}else{E=ea(c[o>>2]|0);t=A-B>>7;q=0;F=ea(0.0);while(1){G=ea(g[B+(q<<7)+96>>2]);y=G<ea(1.0);H=ea(F+ea(ea(E*(y?G:ea(1.0)))+ea(1.0)));q=q+1|0;if(q>>>0>=t>>>0){C=A;D=H;break}else F=H}}A=~~ea(D+ea(.5))>>>0;t=A+-1|0;q=t>>>16|t;t=q>>>8|q;q=t>>>4|t;t=q>>>2|q;q=(t>>>1|t)+1|0;t=q>>>1;y=(A-t|0)>>>0<(q-A|0)>>>0?t:q;q=c[p>>2]|0;p=(y|0)<(q|0)?y:q;F=ea(ea(1.0)/ea(p|0));q=c[o>>2]|0;if((C|0)!=(B|0)){E=ea(q|0);o=c[d>>2]|0;d=C-B>>7;C=0;H=ea(0.0);do{G=ea(g[B+(C<<7)+96>>2]);y=G<ea(1.0);I=ea(ea(E*(y?G:ea(1.0)))/D);G=ea(ea(I-F)-F);g[o+(C<<4)>>2]=ea(F+H);g[o+(C<<4)+8>>2]=G;g[o+(C<<4)+4>>2]=ea(0.0);g[o+(C<<4)+12>>2]=ea(1.0);H=ea(H+I);C=C+1|0}while(C>>>0<d>>>0)}d=b+20|0;c[d>>2]=0;c[h>>2]=c[153106];c[f+0>>2]=c[h+0>>2];h=bOb(172,f,1,16,3653512,35)|0;c[j>>2]=c[153106];c[f+0>>2]=c[j+0>>2];BBc(h,f,0);j=pQb(h)|0;ko[c[(c[j>>2]|0)+24>>2]&4095](j);In[c[(c[j>>2]|0)+44>>2]&4095](j,61);In[c[(c[j>>2]|0)+36>>2]&4095](j,719664);JBc(j,p);KBc(j,q);MBc(j,0);LBc(j,1);FBc(j,1);QDc(j,ea(-1.0));HBc(j,0);In[c[(c[j>>2]|0)+12>>2]&4095](j,4);q=b+24|0;c[q>>2]=j;rri(k,719640,15);c[f>>2]=0;j=eQc(k,1,61,2449160,f)|0;xri(k);k=ATb(j,20)|0;j=b+16|0;c[j>>2]=k;z0b(k,c[((a[n>>0]|0)==0?d:q)>>2]|0);F0b(c[j>>2]|0,2);q=c[j>>2]|0;g[l>>2]=ea(.200000003);g[l+4>>2]=ea(.200000003);g[l+8>>2]=ea(.200000003);g[l+12>>2]=ea(0.0);E0b(q,l);D0b(c[j>>2]|0,1);G0b(c[j>>2]|0,0);l=c[j>>2]|0;In[c[(c[l>>2]|0)+120>>2]&4095](l,0);mBc(0);i=e;return}function P0d(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+16>>2]|0;if(d)lQc(c[d+24>>2]|0,0);d=c[a+20>>2]|0;if(d)kQb(d);d=c[a+24>>2]|0;if(d)kQb(d);d=c[a+4>>2]|0;if(!d){i=b;return}e=a+8|0;a=c[e>>2]|0;if((a|0)!=(d|0))c[e>>2]=a+(~((a+-16-d|0)>>>4)<<4);ACi(d);i=b;return}function Q0d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0,y=0,z=0;e=i;i=i+144|0;f=e+80|0;h=e+104|0;j=e+108|0;k=e+120|0;l=e+64|0;m=e;n=e+88|0;if(!(a[(ync()|0)+5832>>0]|0)){o=ync()|0;ko[c[(c[o>>2]|0)+500>>2]&4095](o)}o=b+44|0;if((c[o>>2]|0)>15?(p=b+40|0,(a[p>>0]|0)!=1):0){a[p>>0]=1;z0b(c[b+16>>2]|0,c[b+24>>2]|0);q=1}else q=0;oGc(k,BTb(c[d+24>>2]|0)|0);EMc(j,k);do if(!q){k=c[((a[b+40>>0]|0)==0?b+20|0:b+24|0)>>2]|0;if((c[k+140>>2]|0)==0?(c[k+148>>2]|0)==0:0)break;r=ea(g[b+32>>2]);if(r!=ea(x)){s=ea(ea(g[j>>2])-r);r=ea(s-ea(ea(R(ea(s/ea(6.28318548))))*ea(6.28318548)));if(r>ea(3.14159274))t=ea(r+ea(-6.28318548));else t=r;if(ea(S(ea(t)))<ea(.00174532924)?(r=ea(g[b+36>>2]),r!=ea(x)):0){s=ea(ea(g[j+4>>2])-r);r=ea(s-ea(ea(R(ea(s/ea(6.28318548))))*ea(6.28318548)));if(r>ea(3.14159274))u=ea(r+ea(-6.28318548));else u=r;if(ea(S(ea(u)))<ea(.00174532924)){c[o>>2]=(c[o>>2]|0)+1;i=e;return q|0}}}}while(0);g[b+32>>2]=ea(g[j>>2]);o=j+4|0;g[b+36>>2]=ea(g[o>>2]);k=b+16|0;d=BTb(c[(c[k>>2]|0)+24>>2]|0)|0;u=ea(g[j>>2]);t=ea(ea(g[o>>2])*ea(57.2957763));g[l>>2]=ea(u*ea(57.2957763));g[l+4>>2]=t;g[l+8>>2]=ea(0.0);uGc(d,l);L$b(m,c[k>>2]|0);l=b+56|0;d=m+0|0;m=l+64|0;do{c[l>>2]=c[d>>2];l=l+4|0;d=d+4|0}while((l|0)<(m|0));d=n8b()|0;c[h>>2]=c[d>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,h);m=c[f>>2]|0;o=c[l+28>>2]|0;if((m|0)==-1){v=o+(c[l+32>>2]<<3)|0;break}else{v=o+(m<<3)|0;break}}else v=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((v|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[v+4>>2]|0,(l|0)!=0):0)w=l;else y=26}else y=26;if((y|0)==26)w=hQb(c[d>>2]|0)|0;d=c[k>>2]|0;g[n>>2]=ea(0.0);g[n+8>>2]=ea(1.0);g[n+4>>2]=ea(0.0);g[n+12>>2]=ea(1.0);w$b(d,n);F0b(c[k>>2]|0,2);n=n8b()|0;d=c[k>>2]|0;if(!d)z=0;else z=c[d+4>>2]|0;c[n>>2]=z;y$b(c[k>>2]|0,c[158074]|0,2);J$b(c[k>>2]|0,0);D8b(X8b()|0);k=c[b>>2]|0;z=k+32|0;n=k+28|0;k=c[n>>2]|0;if((c[z>>2]|0)!=(k|0)){d=b+4|0;y=k;k=0;do{R0d(b,(c[d>>2]|0)+(k<<4)|0,y+(k<<7)|0);k=k+1|0;y=c[n>>2]|0}while(k>>>0<(c[z>>2]|0)-y>>7>>>0)}i0b(w,c[158074]|0);i=e;return q|0}function R0d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im,A=Im,B=Im,C=0,D=0;e=i;i=i+112|0;f=e+80|0;h=e+40|0;j=e+12|0;k=e+16|0;l=e+88|0;m=e;n=e+28|0;o=e+64|0;p=e+48|0;q=d+76|0;if(!(c[q>>2]|0)){i=e;return}r=d+16|0;s=c[r>>2]|0;if(!s){i=e;return}c[h>>2]=s;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(f,s,h);t=c[f>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if(!((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(c[v+4>>2]|0)!=0:0))w=11}else w=11;if((w|0)==11?(hQb(c[r>>2]|0)|0)==0:0){i=e;return}v=a+16|0;a=BTb(c[(c[v>>2]|0)+24>>2]|0)|0;x=ea(g[d+88>>2]);s=d+84|0;y=ea(x-ea(ea(g[s>>2])*ea(.5)));g[k>>2]=ea(0.0);g[k+4>>2]=y;g[k+8>>2]=ea(0.0);yGc(a,k);rGc(m,a);y=ea(g[150300]);x=ea(g[150301]);z=ea(g[150302]);A=ea(g[s>>2]);k=d+92|0;B=ea(A+ea(g[k>>2]));A=ea(ea(x*B)*ea(-2.0));x=ea(ea(z*B)*ea(-2.0));g[o>>2]=ea(ea(y*B)*ea(-2.0));g[o+4>>2]=A;g[o+8>>2]=x;TGc(n,a,o);x=ea(g[m>>2]);A=ea(x+ea(g[n>>2]));x=ea(g[m+4>>2]);B=ea(x+ea(g[n+4>>2]));x=ea(g[m+8>>2]);y=ea(x+ea(g[n+8>>2]));g[l>>2]=A;g[l+4>>2]=B;g[l+8>>2]=y;yGc(a,l);F0b(c[v>>2]|0,4);w$b(c[v>>2]|0,b);y=ea(g[d+96>>2]);b=y<ea(1.0);v0b(c[v>>2]|0,b?y:ea(1.0));y=ea(g[s>>2]);B=ea(g[k>>2]);C0b(c[v>>2]|0,ea((y<B?B:y)*ea(.5)));y$b(c[v>>2]|0,c[158074]|0,2);c[f>>2]=-1;itd(f,719656);v=c[158074]|0;if(!(c[q>>2]|0)){i=e;return}k=d+68|0;d=p+4|0;s=p+8|0;b=p+12|0;l=0;do{a=c[(c[k>>2]|0)+(l<<2)>>2]|0;if((kkd(a)|0)>0){n=0;do{if(v8b(n,a)|0?(m=dkd(a,n,v,0,1)|0,(m|0)!=0):0){c[j>>2]=c[r>>2];o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(f,o,j);h=c[f>>2]|0;t=c[o+28>>2]|0;if((h|0)==-1){C=t+(c[o+32>>2]<<3)|0;break}else{C=t+(h<<3)|0;break}}else C=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((C|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[C+4>>2]|0,(o|0)!=0):0)D=o;else w=25}else w=25;if((w|0)==25){w=0;D=hQb(c[r>>2]|0)|0}g[p>>2]=ea(0.0);g[d>>2]=ea(0.0);g[s>>2]=ea(0.0);g[b>>2]=ea(1.0);Zuc(m,D,601136,p,l)}n=n+1|0}while((n|0)<(kkd(a)|0))}l=l+1|0}while(l>>>0<(c[q>>2]|0)>>>0);i=e;return}function S0d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=0,k=Im,l=Im;d=i;e=ea(ea(ea(ea(g[a+32>>2])*ea(.5))/ea(3.14159274))*ea(360.0));if(!(e<=ea(90.0)))f=ea(e+ea(-360.0));else f=e;g[b>>2]=ea(ea(1.0)-ea(+V(+ea(ea(ea(f/ea(360.0))*ea(2.0))*ea(3.14159274)))));e=ea(S(ea(f)));if(e<ea(40.0)){h=ea(0.0);j=h>ea(.100000001);k=j?h:ea(.100000001);g[c>>2]=k;i=d;return}f=ea(ea(e+ea(-40.0))/ea(50.0));if(f<ea(0.0))l=ea(0.0);else{b=f>ea(1.0);l=b?ea(1.0):f}f=ea(ea(l*ea(l*ea(3.0)))+ea(l*ea(l*ea(l*ea(-2.0)))));h=ea(f+ea(ea(ea(1.0)-f)*ea(0.0)));j=h>ea(.100000001);k=j?h:ea(.100000001);g[c>>2]=k;i=d;return}function T0d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[a+72>>2]|0;if((e|0)>0){a=0;h=0;while(1){j=g-a|0;k=(1<<j<<j)+h|0;a=a+1|0;if((a|0)==(e|0)){l=k;break}else h=k}}else l=0;i=f;return l+b+(d<<g-e)|0}function U0d(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;f=i;h=a+4|0;j=a+8|0;k=c+-1|0;l=d+-1|0;m=ea(V0d(b,k,l,e));n=ea(ea(ea(V0d(b,k,d,e))*ea(-2.0))-m);o=d+1|0;m=ea(n-ea(V0d(b,k,o,e)));p=c+1|0;n=ea(ea(V0d(b,p,l,e))+m);m=ea(n+ea(ea(V0d(b,p,d,e))*ea(2.0)));n=ea(ea(V0d(b,p,o,e))+m);m=ea(n/ea(g[b+80>>2]));n=ea(V0d(b,k,l,e));q=ea(ea(ea(V0d(b,c,l,e))*ea(-2.0))-n);n=ea(q-ea(V0d(b,p,l,e)));q=ea(ea(V0d(b,k,o,e))+n);n=ea(q+ea(ea(V0d(b,c,o,e))*ea(2.0)));q=ea(ea(V0d(b,p,o,e))+n);n=ea(q/ea(g[b+88>>2]));q=ea(-m);g[a>>2]=q;g[h>>2]=ea(8.0);r=ea(-n);g[j>>2]=r;s=ea(ea(n*n)+ea(ea(m*m)+ea(64.0)));if(s==ea(0.0)){t=s;u=ea(t*q);v=ea(t*ea(8.0));w=ea(t*r);g[a>>2]=u;g[h>>2]=v;g[j>>2]=w;i=f;return}t=ea(ea(1.0)/ea(T(ea(s))));u=ea(t*q);v=ea(t*ea(8.0));w=ea(t*r);g[a>>2]=u;g[h>>2]=v;g[j>>2]=w;i=f;return}function V0d(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=Im,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=Im,ha=Im;h=i;i=i+48|0;j=h+32|0;k=h+16|0;l=h+4|0;m=h+8|0;n=h+40|0;o=h;p=h+12|0;q=h+24|0;r=h+20|0;do if(((d|0)<0&(f|0)!=0?(s=f+12|0,t=c[s>>2]|0,(t|0)!=0):0)?(u=c[t+104>>2]|0,(u|0)!=0):0){c[q>>2]=u;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(j,t,q);v=c[j>>2]|0;w=c[t+28>>2]|0;if((v|0)==-1){x=w+(c[t+32>>2]<<3)|0;break}else{x=w+(v<<3)|0;break}}else x=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if(!((x|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(c[x+4>>2]|0)!=0:0))y=12}else y=12;if((y|0)==12?(hQb(u)|0)==0:0){z=f;A=d;B=a;break}t=c[s>>2]|0;v=c[t+104>>2]|0;c[p>>2]=v;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(j,w,p);C=c[j>>2]|0;D=c[w+28>>2]|0;if((C|0)==-1){E=D+(c[w+32>>2]<<3)|0;break}else{E=D+(C<<3)|0;break}}else E=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((E|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[E+4>>2]|0,(w|0)!=0):0)F=w;else y=21}else y=21;if((y|0)==21)F=hQb(v)|0;w=F+232|0;z=t;A=d+-1+(c[w+64>>2]|0)|0;B=w}else{z=f;A=d;B=a}while(0);a=B+64|0;do if((((z|0)!=0?(A|0)>=(c[a>>2]|0):0)?(d=z+4|0,f=c[d>>2]|0,(f|0)!=0):0)?(F=c[f+104>>2]|0,(F|0)!=0):0){c[o>>2]=F;f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(j,f,o);E=c[j>>2]|0;p=c[f+28>>2]|0;if((E|0)==-1){G=p+(c[f+32>>2]<<3)|0;break}else{G=p+(E<<3)|0;break}}else G=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if(!((G|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(c[G+4>>2]|0)!=0:0))y=34}else y=34;if((y|0)==34?(hQb(F)|0)==0:0){H=z;I=A;J=B;break}f=A+1-(c[a>>2]|0)|0;t=c[d>>2]|0;v=c[t+104>>2]|0;c[n>>2]=v;E=c[137784]|0;if(E){do if((c[E+36>>2]|0)!=(c[E+4>>2]|0)){fRb(j,E,n);p=c[j>>2]|0;x=c[E+28>>2]|0;if((p|0)==-1){K=x+(c[E+32>>2]<<3)|0;break}else{K=x+(p<<3)|0;break}}else K=(c[E+28>>2]|0)+(c[E+32>>2]<<3)|0;while(0);E=c[137784]|0;if((K|0)!=((c[E+28>>2]|0)+(c[E+32>>2]<<3)|0)?(E=c[K+4>>2]|0,(E|0)!=0):0)L=E;else y=43}else y=43;if((y|0)==43)L=hQb(v)|0;H=t;I=f;J=L+232|0}else{H=z;I=A;J=B}while(0);do if(((e|0)<0&(H|0)!=0?(B=H+8|0,A=c[B>>2]|0,(A|0)!=0):0)?(z=c[A+104>>2]|0,(z|0)!=0):0){c[l>>2]=z;A=c[137784]|0;if(A){do if((c[A+36>>2]|0)!=(c[A+4>>2]|0)){fRb(j,A,l);L=c[j>>2]|0;K=c[A+28>>2]|0;if((L|0)==-1){M=K+(c[A+32>>2]<<3)|0;break}else{M=K+(L<<3)|0;break}}else M=(c[A+28>>2]|0)+(c[A+32>>2]<<3)|0;while(0);A=c[137784]|0;if(!((M|0)!=((c[A+28>>2]|0)+(c[A+32>>2]<<3)|0)?(c[M+4>>2]|0)!=0:0))y=56}else y=56;if((y|0)==56?(hQb(z)|0)==0:0){N=e;O=H;P=J;break}A=c[B>>2]|0;f=c[A+104>>2]|0;c[k>>2]=f;t=c[137784]|0;if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(j,t,k);v=c[j>>2]|0;L=c[t+28>>2]|0;if((v|0)==-1){Q=L+(c[t+32>>2]<<3)|0;break}else{Q=L+(v<<3)|0;break}}else Q=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);t=c[137784]|0;if((Q|0)!=((c[t+28>>2]|0)+(c[t+32>>2]<<3)|0)?(t=c[Q+4>>2]|0,(t|0)!=0):0)R=t;else y=65}else y=65;if((y|0)==65)R=hQb(f)|0;t=R+232|0;N=e+-1+(c[t+68>>2]|0)|0;O=A;P=t}else{N=e;O=H;P=J}while(0);J=P+68|0;do if((((O|0)!=0?(N|0)>=(c[J>>2]|0):0)?(H=c[O>>2]|0,(H|0)!=0):0)?(e=c[H+104>>2]|0,(e|0)!=0):0){c[m>>2]=e;H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(j,H,m);R=c[j>>2]|0;Q=c[H+28>>2]|0;if((R|0)==-1){S=Q+(c[H+32>>2]<<3)|0;break}else{S=Q+(R<<3)|0;break}}else S=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if(!((S|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(c[S+4>>2]|0)!=0:0))y=78}else y=78;if((y|0)==78?(hQb(e)|0)==0:0){T=N;U=P;break}H=N+1-(c[J>>2]|0)|0;A=c[(c[O>>2]|0)+104>>2]|0;c[r>>2]=A;f=c[137784]|0;if(f){do if((c[f+36>>2]|0)!=(c[f+4>>2]|0)){fRb(j,f,r);R=c[j>>2]|0;Q=c[f+28>>2]|0;if((R|0)==-1){V=Q+(c[f+32>>2]<<3)|0;break}else{V=Q+(R<<3)|0;break}}else V=(c[f+28>>2]|0)+(c[f+32>>2]<<3)|0;while(0);f=c[137784]|0;if((V|0)!=((c[f+28>>2]|0)+(c[f+32>>2]<<3)|0)?(f=c[V+4>>2]|0,(f|0)!=0):0)W=f;else y=87}else y=87;if((y|0)==87)W=hQb(A)|0;T=H;U=W+232|0}else{T=N;U=P}while(0);P=c[U+68>>2]|0;X=ea(ea(g[U+84>>2])/ea(32766.0));N=(c[U+64>>2]|0)+-1|0;if((I|0)<0)Y=0;else Y=(N|0)<(I|0)?N:I;I=P+-1|0;if((T|0)<0){Z=0;_=da(Y,P)|0;$=Z+_|0;aa=U+8|0;ba=c[aa>>2]|0;ca=ba+($<<1)|0;fa=b[ca>>1]|0;ga=ea(fa<<16>>16);ha=ea(X*ga);i=h;return ea(ha)}Z=(I|0)<(T|0)?I:T;_=da(Y,P)|0;$=Z+_|0;aa=U+8|0;ba=c[aa>>2]|0;ca=ba+($<<1)|0;fa=b[ca>>1]|0;ga=ea(fa<<16>>16);ha=ea(X*ga);i=h;return ea(ha)}function W0d(a,d,e,f,h,j,k){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=Im,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=Im,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=0,aa=0;l=i;m=d+-1|0;n=e+-1|0;o=ea(g[k+4>>2]);p=f+-1|0;f=(d|0)<1;if(f)q=0;else q=(p|0)<(m|0)?p:m;r=h+-1|0;s=(e|0)<1;if(s)t=0;else t=(r|0)<(n|0)?r:n;u=t+(da(q,h)|0)|0;q=c[j>>2]|0;v=ea(o*ea(b[q+(u<<1)>>1]|0));if(f)w=0;else w=(p|0)<(m|0)?p:m;u=(e|0)<0;if(u)x=0;else x=(r|0)<(e|0)?r:e;y=ea(ea(ea(o*ea(b[q+(x+(da(w,h)|0)<<1)>>1]|0))*ea(-2.0))-v);w=e+1|0;if(f)z=0;else z=(p|0)<(m|0)?p:m;x=(w|0)<0;if(x)A=0;else A=(r|0)<(w|0)?r:w;v=ea(y-ea(o*ea(b[q+(A+(da(z,h)|0)<<1)>>1]|0)));z=d+1|0;A=(z|0)<0;if(A)B=0;else B=(p|0)<(z|0)?p:z;if(s)C=0;else C=(r|0)<(n|0)?r:n;y=ea(v+ea(o*ea(b[q+(C+(da(B,h)|0)<<1)>>1]|0)));if(A)D=0;else D=(p|0)<(z|0)?p:z;if(u)E=0;else E=(r|0)<(e|0)?r:e;v=ea(y+ea(ea(o*ea(b[q+(E+(da(D,h)|0)<<1)>>1]|0))*ea(2.0)));if(A)F=0;else F=(p|0)<(z|0)?p:z;if(x)G=0;else G=(r|0)<(w|0)?r:w;y=ea(v+ea(o*ea(b[q+(G+(da(F,h)|0)<<1)>>1]|0)));v=ea(y/ea(g[k>>2]));if(f)H=0;else H=(p|0)<(m|0)?p:m;if(s)I=0;else I=(r|0)<(n|0)?r:n;y=ea(o*ea(b[q+(I+(da(H,h)|0)<<1)>>1]|0));H=(d|0)<0;if(H)J=0;else J=(p|0)<(d|0)?p:d;if(s)K=0;else K=(r|0)<(n|0)?r:n;L=ea(ea(ea(o*ea(b[q+(K+(da(J,h)|0)<<1)>>1]|0))*ea(-2.0))-y);if(A)M=0;else M=(p|0)<(z|0)?p:z;if(s)N=0;else N=(r|0)<(n|0)?r:n;y=ea(L-ea(o*ea(b[q+(N+(da(M,h)|0)<<1)>>1]|0)));if(f)O=0;else O=(p|0)<(m|0)?p:m;if(x)P=0;else P=(r|0)<(w|0)?r:w;L=ea(y+ea(o*ea(b[q+(P+(da(O,h)|0)<<1)>>1]|0)));if(H)Q=0;else Q=(p|0)<(d|0)?p:d;if(x)R=0;else R=(r|0)<(w|0)?r:w;y=ea(L+ea(ea(o*ea(b[q+(R+(da(Q,h)|0)<<1)>>1]|0))*ea(2.0)));if(A)S=0;else S=(p|0)<(z|0)?p:z;if(x)U=0;else U=(r|0)<(w|0)?r:w;L=ea(y+ea(o*ea(b[q+(U+(da(S,h)|0)<<1)>>1]|0)));o=ea(L/ea(g[k+8>>2]));L=ea(ea(ea(v*v)+ea(64.0))+ea(o*o));if(L==ea(0.0)){V=L;W=ea(v*V);X=ea(-W);Y=ea(V*ea(8.0));Z=ea(o*V);_=ea(-Z);g[a>>2]=X;$=a+4|0;g[$>>2]=Y;aa=a+8|0;g[aa>>2]=_;i=l;return}V=ea(ea(1.0)/ea(T(ea(L))));W=ea(v*V);X=ea(-W);Y=ea(V*ea(8.0));Z=ea(o*V);_=ea(-Z);g[a>>2]=X;$=a+4|0;g[$>>2]=Y;aa=a+8|0;g[aa>>2]=_;i=l;return}function X0d(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=Im;d=ea(g[b+80>>2]);e=ea(d*ea((c[b+64>>2]|0)+-1|0));d=ea(g[b+84>>2]);f=ea(g[b+88>>2]);h=ea(f*ea((c[b+68>>2]|0)+-1|0));g[a>>2]=e;g[a+4>>2]=d;g[a+8>>2]=h;return}function Y0d(a){a=a|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+32|0;f=d;h=tLc()|0;if(!h){i=d;return}j=a+92|0;k=c[j>>2]|0;if(k){ko[c[c[k>>2]>>2]&4095](k);c[j>>2]=0}k=f+16|0;c[f+8>>2]=1;b[f+28>>1]=0;l=c[a+64>>2]|0;m=c[a+68>>2]|0;n=ADi(da(l<<2,m)|0)|0;c[f>>2]=l;c[f+4>>2]=m;c[f+12>>2]=4;c[k>>2]=n;g[f+20>>2]=ea(-ea(g[a+76>>2]));g[f+24>>2]=ea(4.0);if((l|0)>0&(m|0)>0){o=c[a+8>>2]|0;a=0;do{p=da(a,m)|0;q=0;do{r=q+p|0;s=n+(r<<2)|0;t=e[o+(r<<1)>>1]|0|8388608;b[s>>1]=t;b[s+2>>1]=t>>>16;q=q+1|0}while((q|0)!=(m|0));a=a+1|0}while((a|0)!=(l|0))}c[j>>2]=_n[c[(c[h>>2]|0)+48>>2]&4095](h,f)|0;BDi(c[k>>2]|0);i=d;return}function Z0d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im;f=i;h=c[a+72>>2]|0;if((e|0)>0){j=0;k=0;while(1){l=h-j|0;m=(1<<l<<l)+k|0;j=j+1|0;if((j|0)==(e|0)){n=m;break}else k=m}}else n=0;o=ea(g[(c[a+24>>2]|0)+((d<<h-e)+b+n<<2)>>2]);i=f;return ea(o)}function _0d(a,d,e){a=a|0;d=ea(d);e=ea(e);var f=0,h=0,j=Im,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=Im,x=0,y=0,z=Im,A=0,B=0,C=0,D=0;f=i;h=(c[a+64>>2]|0)+-1|0;j=ea(ea(h|0)*d);k=c[a+68>>2]|0;l=k+-1|0;d=ea(ea(l|0)*e);m=~~j;n=~~d;e=ea(j-ea(m|0));j=ea(d-ea(n|0));d=ea(ea(g[a+84>>2])/ea(32766.0));o=(m|0)<0;if(o)p=0;else p=(h|0)<(m|0)?h:m;q=(n|0)<0;if(q)r=0;else r=(l|0)<(n|0)?l:n;s=r+(da(p,k)|0)|0;p=c[a+8>>2]|0;t=ea(d*ea(b[p+(s<<1)>>1]|0));if(e>j){s=m+1|0;a=(s|0)<0;if(a)u=0;else u=(h|0)<(s|0)?h:s;if(q)v=0;else v=(l|0)<(n|0)?l:n;w=ea(d*ea(b[p+(v+(da(u,k)|0)<<1)>>1]|0));u=n+1|0;if(a)x=0;else x=(h|0)<(s|0)?h:s;if((u|0)<0)y=0;else y=(l|0)<(u|0)?l:u;z=ea(ea(t+ea(e*ea(w-t)))+ea(j*ea(ea(d*ea(b[p+(y+(da(x,k)|0)<<1)>>1]|0))-w)));i=f;return ea(z)}else{x=n+1|0;if(o)A=0;else A=(h|0)<(m|0)?h:m;o=(x|0)<0;if(o)B=0;else B=(l|0)<(x|0)?l:x;w=ea(d*ea(b[p+(B+(da(A,k)|0)<<1)>>1]|0));A=m+1|0;if((A|0)<0)C=0;else C=(h|0)<(A|0)?h:A;if(o)D=0;else D=(l|0)<(x|0)?l:x;z=ea(ea(j*ea(w-t))+ea(t+ea(e*ea(ea(d*ea(b[p+(D+(da(C,k)|0)<<1)>>1]|0))-w))));i=f;return ea(z)}return ea(0.0)}function $0d(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=0,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im;f=i;i=i+64|0;h=f+48|0;j=f+36|0;k=f+24|0;l=f+12|0;m=f;n=b+64|0;o=c[n>>2]|0;p=ea(ea(o+-1|0)*d);q=b+68|0;r=c[q>>2]|0;d=ea(ea(r+-1|0)*e);s=~~p;t=~~d;u=b+80|0;e=ea(g[u>>2]);v=b+84|0;w=ea(ea(g[v>>2])/ea(32766.0));x=b+88|0;y=ea(g[x>>2]);g[h>>2]=e;g[h+4>>2]=w;g[h+8>>2]=y;z=b+8|0;W0d(j,s,t,o,r,z,h);r=s+1|0;y=ea(g[u>>2]);w=ea(ea(g[v>>2])/ea(32766.0));e=ea(g[x>>2]);g[h>>2]=y;g[h+4>>2]=w;g[h+8>>2]=e;W0d(k,r,t,c[n>>2]|0,c[q>>2]|0,z,h);o=t+1|0;e=ea(g[u>>2]);w=ea(ea(g[v>>2])/ea(32766.0));y=ea(g[x>>2]);g[h>>2]=e;g[h+4>>2]=w;g[h+8>>2]=y;W0d(l,s,o,c[n>>2]|0,c[q>>2]|0,z,h);y=ea(g[u>>2]);w=ea(ea(g[v>>2])/ea(32766.0));e=ea(g[x>>2]);g[h>>2]=y;g[h+4>>2]=w;g[h+8>>2]=e;W0d(m,r,o,c[n>>2]|0,c[q>>2]|0,z,h);e=ea(p-ea(s|0));p=ea(d-ea(t|0));d=ea(e*ea(g[k>>2]));w=ea(e*ea(g[k+4>>2]));y=ea(e*ea(g[k+8>>2]));A=ea(ea(1.0)-e);B=ea(A*ea(g[j>>2]));C=ea(A*ea(g[j+4>>2]));D=ea(d+B);B=ea(w+C);C=ea(y+ea(A*ea(g[j+8>>2])));y=ea(e*ea(g[m>>2]));w=ea(e*ea(g[m+4>>2]));d=ea(e*ea(g[m+8>>2]));e=ea(A*ea(g[l>>2]));E=ea(A*ea(g[l+4>>2]));F=ea(ea(1.0)-p);G=ea(ea(F*D)+ea(p*ea(y+e)));e=ea(ea(F*B)+ea(p*ea(w+E)));E=ea(ea(F*C)+ea(p*ea(d+ea(A*ea(g[l+8>>2])))));g[a>>2]=G;l=a+4|0;g[l>>2]=e;m=a+8|0;g[m>>2]=E;A=ea(ea(ea(G*G)+ea(e*e))+ea(E*E));if(A==ea(0.0)){H=A;I=ea(G*H);J=ea(e*H);K=ea(E*H);g[a>>2]=I;g[l>>2]=J;g[m>>2]=K;i=f;return}H=ea(ea(1.0)/ea(T(ea(A))));I=ea(G*H);J=ea(e*H);K=ea(E*H);g[a>>2]=I;g[l>>2]=J;g[m>>2]=K;i=f;return}function a1d(a,d,e,f,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=0,v=Im,w=Im,x=Im,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=0,H=0,I=0,J=0,K=Im,L=0;m=i;i=i+16|0;n=m;o=ea(g[a+80>>2]);p=ea(g[a+84>>2]);q=ea(g[a+88>>2]);r=ea(1<<k|0);s=ea(p/ea(32766.0));p=ea((c[a+64>>2]|0)+-1|0);t=ea(r*ea(ea(1.0)/p));u=a+68|0;v=ea((c[u>>2]|0)+-1|0);w=ea(r*ea(ea(1.0)/v));x=ea(ea(h<<k<<4|0)/p);p=ea(ea(j<<k<<4|0)/v);y=h<<4;h=j<<4;j=c[d>>2]|0;z=c[d+4>>2]|0;d=c[e>>2]|0;A=c[e+4>>2]|0;e=c[f>>2]|0;B=c[f+4>>2]|0;f=a+8|0;C=0;do{D=C+y|0;E=C*17|0;v=ea(r*ea(o*ea(D|0)));F=ea(x+ea(t*ea(C|0)));G=D<<k;H=0;do{I=H+h|0;J=(da(c[u>>2]|0,D)|0)+I<<k;K=ea(s*ea(b[(c[f>>2]|0)+(J<<1)>>1]|0));J=H+E|0;L=da(J,z)|0;g[j+L>>2]=v;g[j+(L+4)>>2]=K;g[j+(L+8)>>2]=ea(r*ea(q*ea(I|0)));L=da(J,B)|0;g[e+L>>2]=F;g[e+(L+4)>>2]=ea(p+ea(w*ea(H|0)));U0d(n,a,G,I<<k,l);I=d+(da(J,A)|0)|0;c[I+0>>2]=c[n+0>>2];c[I+4>>2]=c[n+4>>2];c[I+8>>2]=c[n+8>>2];H=H+1|0}while((H|0)!=17);C=C+1|0}while((C|0)!=17);i=m;return}function b1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im;d=i;e=c[b+72>>2]|0;if((e|0)>0){f=0;h=0;while(1){j=e-f|0;k=(1<<j<<j)+h|0;f=f+1|0;if((f|0)==(e|0)){l=k;break}else h=k}m=l<<1}else m=0;l=c[b+40>>2]|0;n=ea(g[l+(m<<2)>>2]);o=ea(g[l+((m|1)<<2)>>2]);p=ea(g[b+80>>2]);q=ea(p*ea(0.0));r=ea(g[b+88>>2]);s=ea(r*ea(0.0));t=ea(g[b+84>>2]);u=ea(n*t);n=ea(16<<e|0);v=ea(n*p);p=ea(n*r);r=ea(o*t);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;t=ea(ea(r+u)*ea(.5));o=ea(ea(p+s)*ea(.5));g[a>>2]=ea(ea(v+q)*ea(.5));g[a+4>>2]=t;g[a+8>>2]=o;o=ea(ea(r-u)*ea(.5));u=ea(ea(p-s)*ea(.5));g[a+12>>2]=ea(ea(v-q)*ea(.5));g[a+16>>2]=o;g[a+20>>2]=u;i=d;return}function c1d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im;h=i;j=c[b+72>>2]|0;if((f|0)>0){k=0;l=0;while(1){m=j-k|0;n=(1<<m<<m)+l|0;k=k+1|0;if((k|0)==(f|0)){o=n;break}else l=n}}else o=0;l=(e<<j-f)+d+o<<1;o=c[b+40>>2]|0;p=ea(g[o+(l<<2)>>2]);q=ea(g[o+((l|1)<<2)>>2]);r=ea(d<<f<<4|0);s=ea(g[b+80>>2]);t=ea(r*s);r=ea(e<<f<<4|0);u=ea(g[b+88>>2]);v=ea(r*u);r=ea(g[b+84>>2]);w=ea(p*r);p=ea(ea(d+1<<f<<4|0)*s);s=ea(ea(e+1<<f<<4|0)*u);u=ea(q*r);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;r=ea(ea(u+w)*ea(.5));q=ea(ea(s+v)*ea(.5));g[a>>2]=ea(ea(p+t)*ea(.5));g[a+4>>2]=r;g[a+8>>2]=q;q=ea(ea(u-w)*ea(.5));w=ea(ea(s-v)*ea(.5));g[a+12>>2]=ea(ea(p-t)*ea(.5));g[a+16>>2]=q;g[a+20>>2]=w;i=h;return}function d1d(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+92|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}Y0d(a);f=c[d>>2]|0;i=b;return f|0}function e1d(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;c[d>>2]=c[153126];c[b+0>>2]=c[d+0>>2];d=bOb(44,b,0,16,3653512,16)|0;c[e>>2]=c[153116];c[b+0>>2]=c[e+0>>2];_rd(d,1,719696,252,6200,b,16);c[179922]=d;i=a;return}function f1d(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[179922]|0;f=c[153126]|0;if(e)$rd(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[179922]=0;i=a;return}function g1d(a){a=a|0;var b=0;b=i;K3b(a);c[a>>2]=719728;c[a+244>>2]=0;c[a+248>>2]=0;i=b;return}function h1d(a,b,d){a=a|0;b=b|0;d=d|0;c[a+244>>2]=b;c[a+248>>2]=d;return}function i1d(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;b[a+36+(f<<1)>>1]=d;d=a+(f<<4)+4|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];return}function j1d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;if(!(c[d+4>>2]&4)){k1d(a,d,0);i=b;return}else{_nc(e,ync()|0,289);k1d(a,d,e);i=b;return}}function k1d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+16|0;h=f;j=b+244|0;if(!(c[j>>2]|0)){i=f;return}k=b+248|0;l=c[k>>2]|0;if(!l){i=f;return}m=b+168|0;if(!(c[m>>2]|0))n=l;else{l=ync()|0;In[c[(c[l>>2]|0)+220>>2]&4095](l,c[m>>2]|0);n=c[k>>2]|0}m=n+12|0;l=n+4|0;if(!(((a[n+120>>0]&2)==0?(b=c[l>>2]|0,(b|0)!=0):0)?!(mo[c[(c[b>>2]|0)+8>>2]&4095](b)|0):0)){b=c[l>>2]|0;if(b)H2d(c[j>>2]|0,b);b=c[k>>2]|0;G2d(g,c[j>>2]|0,c[b+84>>2]|0,c[b+88>>2]|0,c[b+92>>2]|0,n+32|0);b=g;g=c[b+4>>2]|0;o=l;c[o>>2]=c[b>>2];c[o+4>>2]=g;c[n+28>>2]=0;g=(c[k>>2]|0)+120|0;a[g>>0]=a[g>>0]&-3}g=c[k>>2]|0;if(!((a[g+120>>0]&4)==0?(c[g>>2]|0)!=0:0)){o=F2d(c[j>>2]|0,c[g+68>>2]|0,n+20|0)|0;g=c[k>>2]|0;c[g>>2]=o;c[n+16>>2]=0;c[m>>2]=0;n=g+120|0;a[n>>0]=a[n>>0]&-5}n=l;l=c[n+4>>2]|0;g=h;c[g>>2]=c[n>>2];c[g+4>>2]=l;c[h+8>>2]=0;c[h+12>>2]=0;l=(e|0)!=0;if(l){g=e;e=c[g+4>>2]|0;n=h+8|0;c[n>>2]=c[g>>2];c[n+4>>2]=e}e=ync()|0;n=c[(c[e>>2]|0)+304>>2]|0;g=c[c[k>>2]>>2]|0;k=I2d(c[j>>2]|0)|0;j=qic(k,c[d+4>>2]|0,0)|0;Nn[n&31](e,g,h,l?2:1,m,1,j,d);i=f;return}function l1d(a){a=a|0;var b=0;b=i;M3b(a);dsd(c[179922]|0,a);i=b;return}function m1d(a){a=a|0;return}function n1d(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=Im,M=Im,N=Im,O=0,P=0,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;f=i;i=i+80|0;h=f;j=f+24|0;k=f+28|0;l=f+32|0;m=f+8|0;n=f+4|0;o=f+12|0;p=f+36|0;q=f+40|0;r=f+56|0;a:do if(e){s=c[b>>2]|0;t=(c[b+4>>2]|0)-s|0;u=(t|0)/24|0;b:do if((t|0)>0){c[l>>2]=c[s>>2];if(!(t0d(l)|0)){i=f;return}else v=1;while(1){if((v|0)>=(u|0))break b;c[l>>2]=c[(c[b>>2]|0)+(v*24|0)>>2];if(!(t0d(l)|0))break;else v=v+1|0}i=f;return}while(0);u=b+16|0;s=b+12|0;t=c[s>>2]|0;if((c[u>>2]|0)!=(t|0)){w=t;t=0;while(1){c[k>>2]=c[w+(t<<2)>>2];t=t+1|0;if(!(t0d(k)|0))break;w=c[s>>2]|0;if(t>>>0>=(c[u>>2]|0)-w>>2>>>0)break a}i=f;return}}while(0);k=c[b+36>>2]|0;v=b+24|0;l=c[v>>2]|0;do if(!l){c[m>>2]=c[153106];c[h+0>>2]=c[m+0>>2];w=bOb(136,h,1,16,3653512,100)|0;c[n>>2]=c[153106];c[h+0>>2]=c[n+0>>2];oEc(w,h,1);u=mQb(w)|0;c[v>>2]=u;ko[c[(c[u>>2]|0)+24>>2]&4095](u);u=c[v>>2]|0;if(!(gn[c[(c[u>>2]|0)+148>>2]&127](u,k,k,4,1,1,0)|0)){u=c[b+28>>2]|0;if(!u)x=0;else x=c[u+4>>2]|0;Krd(719816,0,3653512,112,1,x,0,0);i=f;return}}else{if(((((mo[c[(c[l>>2]|0)+104>>2]&4095](l)|0)==(k|0)?(u=c[v>>2]|0,(mo[c[(c[u>>2]|0)+108>>2]&4095](u)|0)==(k|0)):0)?(u=c[v>>2]|0,w=c[u+48>>2]|0,(w|0)!=0):0)?(c[w+32>>2]|0)==4:0)?mo[c[(c[u>>2]|0)+124>>2]&4095](u)|0:0)break;if(!(hFc(c[v>>2]|0,k,k,4,1)|0)){u=c[b+28>>2]|0;if(!u)y=0;else y=c[u+4>>2]|0;Krd(719816,0,3653512,124,1,y,0,0);i=f;return}}while(0);y=b+28|0;X0d(o,(c[y>>2]|0)+232|0);l=c[b+4>>2]|0;x=c[b>>2]|0;n=l-x|0;m=(n|0)/24|0;u=zCi(m>>>0>107374182?-1:m*40|0)|0;w=(n|0)>0;if(w){n=q+1|0;t=q+8|0;s=o+8|0;z=ea(k|0);A=x;B=0;C=0;while(1){c[p>>2]=c[A+(B*24|0)>>2];D=t0d(p)|0;if(!D){c[h>>2]=B;Lsd(q,719848,h);E=c[y>>2]|0;if(!E)F=0;else F=c[E+4>>2]|0;Krd((a[q>>0]&1)==0?n:c[t>>2]|0,0,3653512,172,1,F,0,0);xri(q);E=zCi(4)|0;c[u+(B*40|0)+36>>2]=E;c[E>>2]=-1;c[u+(B*40|0)+32>>2]=1;E=u+(B*40|0)|0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;c[E+16>>2]=0;c[E+20>>2]=0;G=C}else{E=C|(c[D+56>>2]|0)!=0;H=mo[c[(c[D>>2]|0)+104>>2]&4095](D)|0;I=mo[c[(c[D>>2]|0)+108>>2]&4095](D)|0;J=ea(g[o>>2]);K=c[b>>2]|0;L=ea(J/ea(g[K+(B*24|0)+8>>2]));M=ea(g[s>>2]);N=ea(M/ea(g[K+(B*24|0)+12>>2]));O=~~ea(z/L);P=~~ea(z/N);Q=ea((da(I,H)|0)/(da((P|0)<1?1:P,(O|0)<1?1:O)|0)|0|0);R=ea(L*ea(ea(g[K+(B*24|0)+16>>2])/J));J=ea(N*ea(ea(g[K+(B*24|0)+20>>2])/M));K=~~ea(ea(bEi(Q))*ea(.5));O=(yEc(D)|0)+-1|0;if((K|0)<0)S=0;else S=(K|0)>(O|0)?O:K;K=c[D+48>>2]|0;if(!K)T=5;else T=c[K+32>>2]|0;K=YFc(T)|0;O=H>>S;H=(O|0)<(K|0)?K:O;O=I>>S;I=(O|0)<(K|0)?K:O;O=da(H,I)|0;K=zCi(O>>>0>1073741823?-1:O<<2)|0;P=u+(B*40|0)+36|0;c[P>>2]=K;if(!(fFc(D,S,K,O)|0)){PEi(c[P>>2]|0,0,O<<2|0)|0;O=c[y>>2]|0;if(!O)U=0;else U=c[O+4>>2]|0;Krd(719880,0,3653512,213,1,U,0,0)}c[u+(B*40|0)+32>>2]=H;c[u+(B*40|0)>>2]=(H<<16)+-1;O=(I<<16)+-1|0;c[u+(B*40|0)+4>>2]=O;Q=ea(H|0);c[u+(B*40|0)+8>>2]=~~ea(ea(ea(L*Q)/z)*ea(65536.0));L=ea(I|0);I=~~ea(ea(ea(N*L)/z)*ea(65536.0));c[u+(B*40|0)+12>>2]=I;c[u+(B*40|0)+24>>2]=~~ea(ea(R*Q)*ea(65536.0));H=~~ea(ea(J*L)*ea(65536.0));c[u+(B*40|0)+16>>2]=0;c[u+(B*40|0)+20>>2]=((I|0)/2|0)+H&O;G=E}E=B+1|0;if((E|0)>=(m|0))break;A=c[b>>2]|0;B=E;C=G}C=c[v>>2]|0;if(G)NDc(C,1);else{V=C;W=44}}else{V=c[v>>2]|0;W=44}if((W|0)==44)NDc(V,0);c[r>>2]=0;c[r+8>>2]=0;V=r+12|0;c[V>>2]=0;C=r+4|0;c[C>>2]=60;o1d(b,r,0);G=c[v>>2]|0;zEc(G);B=c[G+48>>2]|0;if(!B)X=0;else X=c[B+8>>2]|0;B=b+32|0;G=c[B>>2]|0;A=(G<<16|0)/(k|0)|0;c:do if((k|0)>0){U=c[r>>2]|0;y=k<<2;S=G;T=0;s=0;o=1;while(1){q=da(S,T>>16)|0;if(w){F=0;do{c[u+(F*40|0)+16>>2]=(c[u+(F*40|0)+24>>2]|0)+((c[u+(F*40|0)+8>>2]|0)/2|0)&c[u+(F*40|0)>>2];c[u+(F*40|0)+28>>2]=da(c[u+(F*40|0)+20>>2]>>16,c[u+(F*40|0)+32>>2]|0)|0;F=F+1|0}while((F|0)<(m|0));if(w){F=0;t=s;n=0;while(1){p=da((F>>16)+q|0,m)|0;E=0;O=0;while(1){H=u+(O*40|0)+16|0;I=c[H>>2]|0;P=c[(c[u+(O*40|0)+36>>2]|0)+((I>>16)+(c[u+(O*40|0)+28>>2]|0)<<2)>>2]|0;K=d[U+(O+p)>>0]|0;D=((da(K,P&16711935)|0)>>>8&16711935|(da(K,P>>>8&16711935)|0)&65280)+E|0;c[H>>2]=(c[u+(O*40|0)+8>>2]|0)+I&c[u+(O*40|0)>>2];O=O+1|0;if((O|0)>=(m|0)){Y=D;break}else E=D}c[X+(t<<2)>>2]=Y;n=n+1|0;if((n|0)==(k|0))break;else{F=F+A|0;t=t+1|0}}}else W=51}else W=51;if((W|0)==51){W=0;PEi(X+(s<<2)|0,0,y|0)|0;t=0;do t=t+1|0;while((t|0)!=(k|0))}t=k+s|0;if(w){F=0;do{n=u+(F*40|0)+20|0;c[n>>2]=(c[u+(F*40|0)+12>>2]|0)+(c[n>>2]|0)&c[u+(F*40|0)+4>>2];F=F+1|0}while((F|0)<(m|0))}if((o|0)==(k|0))break c;S=c[B>>2]|0;T=T+A|0;s=t;o=o+1|0}}while(0);if((l|0)==(x|0)){x=da(k,k)|0;k=c[(c[v>>2]|0)+48>>2]|0;if(!k)Z=5;else Z=c[k+32>>2]|0;PEi(X|0,-1,da(x,TFc(Z)|0)|0)|0}Z=c[v>>2]|0;ko[c[(c[Z>>2]|0)+160>>2]&4095](Z);if(!e){e=c[v>>2]|0;if(!(c[e+4>>2]|0)){pQb(e)|0;Z=c[v>>2]|0;In[c[(c[Z>>2]|0)+44>>2]&4095](Z,61);ODc(c[v>>2]|0,1);_=c[v>>2]|0}else _=e;In[c[(c[_>>2]|0)+12>>2]&4095](_,0)}if(w){w=0;do{_=c[u+(w*40|0)+36>>2]|0;if(_)BCi(_);w=w+1|0}while((w|0)<(m|0))}BCi(u);a[b+40>>0]=0;if((c[V>>2]|0)<=-1){i=f;return}V=c[r>>2]|0;c[j>>2]=c[C>>2];c[h+0>>2]=c[j+0>>2];eOb(V,h);c[r>>2]=0;i=f;return}function o1d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+80|0;f=e;g=e+48|0;h=e+44|0;j=e+16|0;k=e+32|0;l=e+4|0;m=e+28|0;n=e+52|0;o=e+56|0;p=b+16|0;q=b+12|0;r=c[q>>2]|0;if((c[p>>2]|0)==(r|0))s=b+32|0;else{t=b+28|0;u=j+1|0;v=j+8|0;w=b+32|0;x=k+1|0;y=k+8|0;z=l+1|0;A=l+8|0;B=r;r=0;do{c[h>>2]=c[B+(r<<2)>>2];C=t0d(h)|0;do if(C){D=mo[c[(c[C>>2]|0)+104>>2]&4095](C)|0;if((D|0)!=(c[w>>2]|0))if(!r){c[f>>2]=0;Lsd(k,719960,f);D=c[t>>2]|0;if(!D)E=0;else E=c[D+4>>2]|0;Krd((a[k>>0]&1)==0?x:c[y>>2]|0,0,3653512,404,512,E,0,0);xri(k);c[w>>2]=mo[c[(c[C>>2]|0)+104>>2]&4095](C)|0;break}else{c[f>>2]=r;Lsd(l,720080,f);D=c[t>>2]|0;if(!D)F=0;else F=c[D+4>>2]|0;Krd((a[l>>0]&1)==0?z:c[A>>2]|0,0,3653512,409,1,F,0,0);xri(l);break}}else{c[f>>2]=r;Lsd(j,719920,f);D=c[t>>2]|0;if(!D)G=0;else G=c[D+4>>2]|0;Krd((a[j>>0]&1)==0?u:c[v>>2]|0,0,3653512,396,1,G,0,0);xri(j)}while(0);r=r+1|0;B=c[q>>2]|0}while(r>>>0<(c[p>>2]|0)-B>>2>>>0);s=w}w=c[s>>2]|0;s=da(w,w)|0;B=((c[b+4>>2]|0)-(c[b>>2]|0)|0)/24|0;r=da(B,s)|0;j=d+8|0;c[j>>2]=r;G=d+12|0;v=c[G>>2]|0;do if((v&2147483647)>>>0<r>>>0)if((v|0)>-1){c[G>>2]=r;u=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(u,r,1,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];u=cOb(r,1,f,0,3653512,352)|0;YEi(u|0,c[d>>2]|0,c[j>>2]|0)|0;c[G>>2]=r;c[d>>2]=u;break}while(0);r=s<<2;G=r+15|0;j=(s|0)!=0;if(G>>>0<2e3)if(j){v=i;i=i+((1*G|0)+15&-16)|0;H=0;I=v}else{H=0;I=0}else if(j){c[m>>2]=c[153134];c[f+0>>2]=c[m+0>>2];m=cOb(G,16,f,0,3653512,421)|0;H=m;I=m}else{H=0;I=0}m=I+15&-16;I=m;G=m;m=c[q>>2]|0;if((c[p>>2]|0)!=(m|0)){j=b+28|0;b=o+1|0;v=o+8|0;u=(s|0)==0;t=m;m=~B;l=0;while(1){F=(m|0)>-5?~m:4;A=l<<2;z=B-A|0;c[n>>2]=c[t+(l<<2)>>2];k=t0d(n)|0;if(((k|0)!=0?(mo[c[(c[k>>2]|0)+104>>2]&4095](k)|0)==(w|0):0)?(mo[c[(c[k>>2]|0)+108>>2]&4095](k)|0)==(w|0):0)fFc(k,0,G,s)|0;else{c[f>>2]=l;Lsd(o,720168,f);k=c[j>>2]|0;if(!k)J=0;else J=c[k+4>>2]|0;Krd((a[o>>0]&1)==0?b:c[v>>2]|0,0,3653512,434,1,J,0,0);xri(o);PEi(I|0,0,r|0)|0}a:do if(!u){if((z|0)>0){K=A;L=0}else{k=0;while(1){k=k+1|0;if((k|0)>=(s|0))break a}}while(1){k=G+(L<<2)|0;E=0;do{a[(c[d>>2]|0)+(E+K)>>0]=a[k+E>>0]|0;E=E+1|0}while((E|0)!=(F|0));L=L+1|0;if((L|0)>=(s|0))break;else K=K+B|0}}while(0);l=l+1|0;t=c[q>>2]|0;if(l>>>0>=(c[p>>2]|0)-t>>2>>>0)break;else m=m+4|0}}if(!H){i=e;return}c[g>>2]=c[153134];c[f+0>>2]=c[g+0>>2];eOb(H,f);i=e;return}function p1d(b){b=b|0;var c=0;c=i;if(!(a[b+40>>0]|0)){i=c;return}n1d(b,0);i=c;return}function q1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d;g=(c[a+12>>2]|0)+(b<<2)|0;b=c[g>>2]|0;if(!b){h=0;i=d;return h|0}c[f>>2]=b;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,f);a=c[e>>2]|0;j=c[b+28>>2]|0;if((a|0)==-1){k=j+(c[b+32>>2]<<3)|0;break}else{k=j+(a<<3)|0;break}}else k=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((k|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[k+4>>2]|0,(b|0)!=0):0)l=b;else m=10}else m=10;if((m|0)==10)l=hQb(c[g>>2]|0)|0;h=l;i=d;return h|0}function r1d(a){a=a|0;return c[a+24>>2]|0}function s1d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=c[b>>2];c[a+4>>2]=c[d>>2];b=a+8|0;f=b+48|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(f|0));t1d(a);u1d(a,d);i=e;return}function t1d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+4|0;g=c[f>>2]|0;if(!g){h=0;j=a+8|0;B1d(h,j);i=b;return}c[e>>2]=g;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);k=c[d>>2]|0;l=c[g+28>>2]|0;if((k|0)==-1){m=l+(c[g+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((m|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[m+4>>2]|0,(g|0)!=0):0)n=g;else o=10}else o=10;if((o|0)==10)n=hQb(c[f>>2]|0)|0;h=n;j=a+8|0;B1d(h,j);i=b;return}function u1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+4|0;f=c[b>>2]|0;if((c[e>>2]|0)==(f|0)){x1d(a);y1d(a);i=d;return}c[e>>2]=f;t1d(a);f=a+20|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+24|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+28|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+32|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+36|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+40|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+44|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+48|0;kQb(c[f>>2]|0);c[f>>2]=0;f=a+52|0;kQb(c[f>>2]|0);c[f>>2]=0;x1d(a);y1d(a);i=d;return}function v1d(a){a=a|0;var b=0,d=0;b=i;d=a+20|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+24|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+28|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+32|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+36|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+40|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+44|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+48|0;kQb(c[d>>2]|0);c[d>>2]=0;d=a+52|0;kQb(c[d>>2]|0);c[d>>2]=0;i=b;return}function w1d(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;if((c[a>>2]|0)==(e|0)){i=d;return}c[a>>2]=e;u1d(a,a+4|0);i=d;return}function x1d(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;b=i;i=i+160|0;d=b+72|0;e=b+68|0;f=b+52|0;h=b+132|0;j=b+124|0;k=b+24|0;l=b+28|0;m=b+32|0;n=b+36|0;o=b+40|0;p=b+44|0;q=b+112|0;r=b+120|0;s=b+128|0;t=b+144|0;u=b+148|0;v=b+84|0;w=b+88|0;x=b+92|0;y=b+96|0;z=b+100|0;A=b+104|0;B=b+16|0;C=b+8|0;D=b;E=b+4|0;F=b+108|0;G=b+48|0;H=b+116|0;I=b+64|0;J=c[a>>2]|0;if(!J)K=0;else{c[I>>2]=J;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(d,J,I);L=c[d>>2]|0;M=c[J+28>>2]|0;if((L|0)==-1){N=M+(c[J+32>>2]<<3)|0;break}else{N=M+(L<<3)|0;break}}else N=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((N|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[N+4>>2]|0,(J|0)!=0):0)O=J;else P=10}else P=10;if((P|0)==10)O=hQb(c[a>>2]|0)|0;K=O}O=a+4|0;J=c[O>>2]|0;if(!J)Q=0;else{c[H>>2]=J;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(d,J,H);N=c[d>>2]|0;I=c[J+28>>2]|0;if((N|0)==-1){R=I+(c[J+32>>2]<<3)|0;break}else{R=I+(N<<3)|0;break}}else R=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((R|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[R+4>>2]|0,(J|0)!=0):0)S=J;else P=21}else P=21;if((P|0)==21)S=hQb(c[O>>2]|0)|0;Q=S}S=(K|0)==0;O=K+44|0;if(S){T=K+40|0;U=1}else{J=K+40|0;R=(c[O>>2]|0)-(c[J>>2]|0)>>2;T=J;U=(R|0)<1?1:R}R=(Q|0)==0;J=K+28|0;H=K+232|0;N=K+32|0;K=u+8|0;I=B+4|0;L=C+4|0;M=Q+108|0;V=0;do{W=a+(V<<2)+20|0;X=c[W>>2]|0;do if((V|0)<(U|0)){if(!X){Y=bkd(c[a+(((V|0)==0?1:2)<<2)+8>>2]|0,61,0)|0;Bkd(Y,(Rjd(Y)|0)+V|0);c[W>>2]=Y;Z=Y}else Z=X;if(!R){vkd(Z,Q);Akd(Z,M)}Y=c[180090]|0;if(S){c[k>>2]=Y;c[d+0>>2]=c[k+0>>2];if(pkd(Z,d)|0){c[l>>2]=c[180090];c[d+0>>2]=c[l+0>>2];rkd(Z,d,0)}c[m>>2]=c[180052];c[d+0>>2]=c[m+0>>2];if(pkd(Z,d)|0){c[n>>2]=c[180052];c[d+0>>2]=c[n+0>>2];rkd(Z,d,0)}c[o>>2]=c[180058];c[d+0>>2]=c[o+0>>2];if(pkd(Z,d)|0){c[p>>2]=c[180058];c[d+0>>2]=c[p+0>>2];rkd(Z,d,0)}c[q>>2]=c[180070];c[d+0>>2]=c[q+0>>2];if(pkd(Z,d)|0){c[r>>2]=c[180070];c[d+0>>2]=c[r+0>>2];rkd(Z,d,0)}c[o>>2]=c[180059];c[d+0>>2]=c[o+0>>2];if(pkd(Z,d)|0){c[p>>2]=c[180059];c[d+0>>2]=c[p+0>>2];rkd(Z,d,0)}c[q>>2]=c[180071];c[d+0>>2]=c[q+0>>2];if(pkd(Z,d)|0){c[r>>2]=c[180071];c[d+0>>2]=c[r+0>>2];rkd(Z,d,0)}c[o>>2]=c[180060];c[d+0>>2]=c[o+0>>2];if(pkd(Z,d)|0){c[p>>2]=c[180060];c[d+0>>2]=c[p+0>>2];rkd(Z,d,0)}c[q>>2]=c[180072];c[d+0>>2]=c[q+0>>2];if(pkd(Z,d)|0){c[r>>2]=c[180072];c[d+0>>2]=c[r+0>>2];rkd(Z,d,0)}c[o>>2]=c[180061];c[d+0>>2]=c[o+0>>2];if(pkd(Z,d)|0){c[p>>2]=c[180061];c[d+0>>2]=c[p+0>>2];rkd(Z,d,0)}c[q>>2]=c[180073];c[d+0>>2]=c[q+0>>2];if(!(pkd(Z,d)|0))break;c[r>>2]=c[180073];c[d+0>>2]=c[r+0>>2];rkd(Z,d,0);break}c[s>>2]=Y;c[d+0>>2]=c[s+0>>2];if(pkd(Z,d)|0){c[t>>2]=c[180090];Y=r1d(J)|0;c[d+0>>2]=c[t+0>>2];rkd(Z,d,Y)}rri(f,720504,10);rri(h,3653512,0);ikd(d,Z,f,0,h);Y=(Ori(d,720520)|0)==0;xri(d);xri(h);xri(f);if(Y){X0d(u,H);Y=c[O>>2]|0;_=c[T>>2]|0;$=((c[N>>2]|0)-(c[J>>2]|0)|0)/24|0;c[v>>2]=c[180052];c[d+0>>2]=c[v+0>>2];if(pkd(Z,d)|0){c[w>>2]=c[180052];if((Y-_>>2|0)>(V|0))aa=q1d(J,V)|0;else aa=0;c[d+0>>2]=c[w+0>>2];rkd(Z,d,aa)}_=V<<2;Y=0;do{ba=Y+_|0;ca=720232+(Y<<2)|0;c[x>>2]=c[ca>>2];c[d+0>>2]=c[x+0>>2];da=pkd(Z,d)|0;fa=720280+(Y<<2)|0;c[y>>2]=c[fa>>2];c[d+0>>2]=c[y+0>>2];ga=pkd(Z,d)|0;if((ba|0)<($|0)){ha=c[J>>2]|0;if(da){ia=ea(g[u>>2]);ja=ea(ia/ea(g[ha+(ba*24|0)+8>>2]));ka=ea(g[K>>2]);la=ea(ka/ea(g[ha+(ba*24|0)+12>>2]));g[B>>2]=ja;g[I>>2]=la;ma=ea(ja*ea(ea(g[ha+(ba*24|0)+16>>2])/ia));ia=ea(la*ea(ea(g[ha+(ba*24|0)+20>>2])/ka));g[C>>2]=ma;g[L>>2]=ia;c[D>>2]=c[ca>>2];na=ha+(ba*24|0)|0;oa=c[na>>2]|0;if(!oa)pa=0;else{c[e>>2]=oa;oa=c[137784]|0;do if(oa){do if((c[oa+36>>2]|0)!=(c[oa+4>>2]|0)){fRb(d,oa,e);qa=c[d>>2]|0;ra=c[oa+28>>2]|0;if((qa|0)==-1){sa=ra+(c[oa+32>>2]<<3)|0;break}else{sa=ra+(qa<<3)|0;break}}else sa=(c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0;while(0);qa=c[137784]|0;if((sa|0)==((c[qa+28>>2]|0)+(c[qa+32>>2]<<3)|0)){P=66;break}qa=c[sa+4>>2]|0;if(qa)ta=qa;else P=66}else P=66;while(0);if((P|0)==66){P=0;ta=hQb(c[na>>2]|0)|0}pa=ta};c[d+0>>2]=c[D+0>>2];rkd(Z,d,pa);c[E>>2]=c[ca>>2];c[d+0>>2]=c[E+0>>2];ukd(Z,d,B);c[F>>2]=c[ca>>2];c[d+0>>2]=c[F+0>>2];tkd(Z,d,C)}if(ga){c[G>>2]=c[fa>>2];oa=ha+(ba*24|0)+4|0;qa=c[oa>>2]|0;if(!qa)ua=0;else{c[j>>2]=qa;qa=c[137784]|0;do if(qa){do if((c[qa+36>>2]|0)!=(c[qa+4>>2]|0)){fRb(d,qa,j);ra=c[d>>2]|0;va=c[qa+28>>2]|0;if((ra|0)==-1){wa=va+(c[qa+32>>2]<<3)|0;break}else{wa=va+(ra<<3)|0;break}}else wa=(c[qa+28>>2]|0)+(c[qa+32>>2]<<3)|0;while(0);ra=c[137784]|0;if((wa|0)==((c[ra+28>>2]|0)+(c[ra+32>>2]<<3)|0)){P=79;break}ra=c[wa+4>>2]|0;if(ra)xa=ra;else P=79}else P=79;while(0);if((P|0)==79){P=0;xa=hQb(c[oa>>2]|0)|0}ua=xa};c[d+0>>2]=c[G+0>>2];rkd(Z,d,ua)}}else{if(da){c[z>>2]=c[ca>>2];c[d+0>>2]=c[z+0>>2];rkd(Z,d,0)}if(ga){c[A>>2]=c[fa>>2];c[d+0>>2]=c[A+0>>2];rkd(Z,d,0)}}Y=Y+1|0}while((Y|0)!=4)}}else{kQb(X);c[W>>2]=0}while(0);V=V+1|0}while((V|0)<8);i=b;return}function y1d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b+4|0;g=b;h=c[a>>2]|0;if(h){c[f>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,f);j=c[d>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[l+4>>2]|0,(h|0)!=0):0)m=h;else n=10}else n=10;if((n|0)==10)m=hQb(c[a>>2]|0)|0;h=a+8|0;if(!((c[h>>2]|0)==0|(m|0)==0)){l=r1d(m+28|0)|0;m=a+52|0;if(!(c[m>>2]|0))c[m>>2]=bkd(c[h>>2]|0,61,0)|0;h=a+4|0;f=c[h>>2]|0;do if(f){c[e>>2]=f;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;o=c[j+28>>2]|0;if((k|0)==-1){p=o+(c[j+32>>2]<<3)|0;break}else{p=o+(k<<3)|0;break}}else p=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((p|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[p+4>>2]|0,(j|0)!=0):0)q=j;else n=24}else n=24;if((n|0)==24){j=hQb(c[h>>2]|0)|0;if(!j)break;else q=j}vkd(c[m>>2]|0,q);ynd((c[m>>2]|0)+72|0,720360)|0;Akd(c[m>>2]|0,q+108|0)}while(0);q=c[m>>2]|0;c[g>>2]=c[180090];c[d+0>>2]=c[g+0>>2];rkd(q,d,l);i=b;return}}l=a+52|0;kQb(c[l>>2]|0);c[l>>2]=0;i=b;return}function z1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+8|0;h=b+12|0;j=b+4|0;k=0;while(1){l=c[a+(k<<2)+20>>2]|0;if(!l){m=10;break}n=(c[g>>2]|0)+1|0;c[g>>2]=n;o=c[h>>2]|0;p=o&2147483647;if(n>>>0>p>>>0){q=o<<1;r=(q|0)==0?1:q;do if(p>>>0<r>>>0)if((o|0)>-1){c[h>>2]=r;q=c[b>>2]|0;c[f>>2]=c[j>>2];c[e+0>>2]=c[f+0>>2];c[b>>2]=hOb(q,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[j>>2];c[e+0>>2]=c[f+0>>2];q=cOb(r<<2,4,e,0,3653512,352)|0;YEi(q|0,c[b>>2]|0,c[g>>2]<<2|0)|0;c[h>>2]=r;c[b>>2]=q;break}while(0);s=c[g>>2]|0}else s=n;c[(c[b>>2]|0)+(s+-1<<2)>>2]=l;k=k+1|0;if((k|0)>=8){m=10;break}}if((m|0)==10){i=d;return}}function A1d(a){a=a|0;return c[a+52>>2]|0}function B1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+80|0;e=d+60|0;f=d+48|0;g=d+36|0;h=d+24|0;j=d+12|0;k=d;if(a){l=hkd(a)|0;a=b+4|0;c[a>>2]=l;if(!l){m=a;n=5}else{rri(e,720368,13);o=b+8|0;c[o>>2]=Pld(l,e)|0;xri(e);rri(f,720384,13);c[b>>2]=Pld(l,f)|0;xri(f);p=a;q=o}}else{o=b+4|0;c[o>>2]=0;m=o;n=5}if((n|0)==5){n=b+8|0;c[n>>2]=0;c[b>>2]=0;p=m;q=n}n=Xmd()|0;if(!(c[b>>2]|0)){rri(g,722224,7);c[b>>2]=Nmd(n,g)|0;xri(g)}if(!(c[p>>2]|0)){rri(h,720400,48);c[p>>2]=Nmd(n,h)|0;xri(h)}if(!(c[q>>2]|0)){rri(j,720456,46);c[q>>2]=Nmd(n,j)|0;xri(j);r=0;s=0}else{r=0;s=0}while(1){j=b+(r<<2)|0;if(!(c[j>>2]|0)){rri(k,722224,7);c[j>>2]=Nmd(n,k)|0;xri(k);t=1}else t=s;r=r+1|0;if((r|0)>=3)break;else s=t}if(!t){i=d;return}Krd(722104,0,3653512,229,1,0,0,0);i=d;return}function C1d(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,720216);c[180052]=c[b>>2];c[b>>2]=-1;itd(b,720248);c[180058]=c[b>>2];c[b>>2]=-1;itd(b,720256);c[180059]=c[b>>2];c[b>>2]=-1;itd(b,720264);c[180060]=c[b>>2];c[b>>2]=-1;itd(b,720272);c[180061]=c[b>>2];c[b>>2]=-1;itd(b,720296);c[180070]=c[b>>2];c[b>>2]=-1;itd(b,720312);c[180071]=c[b>>2];c[b>>2]=-1;itd(b,720328);c[180072]=c[b>>2];c[b>>2]=-1;itd(b,720344);c[180073]=c[b>>2];c[b>>2]=-1;itd(b,791824);c[180090]=c[b>>2];i=a;return}function D1d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[h>>2]=c[d>>2];c[g+0>>2]=c[h+0>>2];bUb(b,g,e);a[b+28>>0]=1;a[b+29>>0]=0;c[b>>2]=720536;a[b+30>>0]=0;e=b+32|0;c[b+88>>2]=0;c[b+92>>2]=0;g=b+168|0;c[b+196>>2]=0;c[b+204>>2]=0;c[b+208>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[b+200>>2]=60;E1d(b);i=f;return}function E1d(d){d=d|0;var e=0,f=0,h=0;e=i;g[d+48>>2]=ea(5.0);c[d+52>>2]=0;g[d+56>>2]=ea(1.0e3);g[d+60>>2]=ea(5.0e3);g[d+64>>2]=ea(50.0);g[d+68>>2]=ea(5.0);c[d+72>>2]=50;g[d+76>>2]=ea(80.0);g[d+80>>2]=ea(1.0);f=d+84|0;h=d+172|0;a[f>>0]=1;a[f+1>>0]=1;a[f+2>>0]=1;a[f+3>>0]=1;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+188>>2]=7;h=d+128|0;b[h+2>>1]=255;b[h>>1]=255;g[d+96>>2]=ea(1.0);g[d+100>>2]=ea(1.0);g[d+104>>2]=ea(0.0);g[d+108>>2]=ea(0.0);g[d+112>>2]=ea(1.0);g[d+116>>2]=ea(1.0);g[d+120>>2]=ea(0.0);g[d+124>>2]=ea(0.0);g[d+132>>2]=ea(1.0);g[d+136>>2]=ea(1.0);g[d+140>>2]=ea(0.0);g[d+144>>2]=ea(0.0);g[d+148>>2]=ea(1.0);g[d+152>>2]=ea(1.0);g[d+156>>2]=ea(0.0);g[d+160>>2]=ea(0.0);a[d+164>>0]=1;h=d+168|0;kQb(c[h>>2]|0);c[h>>2]=0;i=e;return}function F1d(d){d=d|0;var e=0,f=0,h=0;e=i;g[d+48>>2]=ea(5.0);c[d+52>>2]=0;g[d+56>>2]=ea(1.0e3);g[d+60>>2]=ea(5.0e3);g[d+64>>2]=ea(50.0);g[d+68>>2]=ea(5.0);c[d+72>>2]=50;g[d+76>>2]=ea(80.0);g[d+80>>2]=ea(1.0);f=d+84|0;h=d+172|0;a[f>>0]=1;a[f+1>>0]=1;a[f+2>>0]=1;a[f+3>>0]=1;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+188>>2]=7;h=d+128|0;b[h+2>>1]=255;b[h>>1]=255;g[d+96>>2]=ea(1.0);g[d+100>>2]=ea(1.0);g[d+104>>2]=ea(0.0);g[d+108>>2]=ea(0.0);g[d+112>>2]=ea(1.0);g[d+116>>2]=ea(1.0);g[d+120>>2]=ea(0.0);g[d+124>>2]=ea(0.0);g[d+132>>2]=ea(1.0);g[d+136>>2]=ea(1.0);g[d+140>>2]=ea(0.0);g[d+144>>2]=ea(0.0);g[d+148>>2]=ea(1.0);g[d+152>>2]=ea(1.0);g[d+156>>2]=ea(0.0);g[d+160>>2]=ea(0.0);a[d+164>>0]=1;h=d+168|0;kQb(c[h>>2]|0);c[h>>2]=0;i=e;return}function G1d(d){d=d|0;var e=0,f=0,h=0;e=i;g[d+48>>2]=ea(5.0);c[d+52>>2]=0;g[d+56>>2]=ea(1.0e3);g[d+60>>2]=ea(5.0e3);g[d+64>>2]=ea(50.0);g[d+68>>2]=ea(5.0);c[d+72>>2]=50;g[d+76>>2]=ea(80.0);g[d+80>>2]=ea(1.0);f=d+84|0;h=d+172|0;a[f>>0]=1;a[f+1>>0]=1;a[f+2>>0]=1;a[f+3>>0]=1;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[d+188>>2]=7;h=d+128|0;b[h+2>>1]=255;b[h>>1]=255;g[d+96>>2]=ea(1.0);g[d+100>>2]=ea(1.0);g[d+104>>2]=ea(0.0);g[d+108>>2]=ea(0.0);g[d+112>>2]=ea(1.0);g[d+116>>2]=ea(1.0);g[d+120>>2]=ea(0.0);g[d+124>>2]=ea(0.0);g[d+132>>2]=ea(1.0);g[d+136>>2]=ea(1.0);g[d+140>>2]=ea(0.0);g[d+144>>2]=ea(0.0);g[d+148>>2]=ea(1.0);g[d+152>>2]=ea(1.0);g[d+156>>2]=ea(0.0);g[d+160>>2]=ea(0.0);a[d+164>>0]=1;h=d+168|0;kQb(c[h>>2]|0);c[h>>2]=0;i=e;return}function H1d(){return}function I1d(){return}function J1d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d+4|0;h=d;j=BLc()|0;In[c[(c[j>>2]|0)+28>>2]&4095](j,b);a[b+30>>0]=1;c[h>>2]=c[153116];c[e+0>>2]=c[h+0>>2];h=bOb(56,e,0,16,3653512,111)|0;j=b+44|0;s1d(h,j,b+88|0);c[b+92>>2]=h;h=c[j>>2]|0;if(!h){i=d;return}c[g>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(e,h,g);k=c[e>>2]|0;l=c[h+28>>2]|0;if((k|0)==-1){m=l+(c[h+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((m|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(c[m+4>>2]|0)!=0:0)n=h;else o=10}else o=10;do if((o|0)==10)if(!(hQb(c[j>>2]|0)|0)){i=d;return}else{n=c[137784]|0;break}while(0);c[f>>2]=c[j>>2];if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(e,n,f);h=c[e>>2]|0;m=c[n+28>>2]|0;if((h|0)==-1){p=m+(c[n+32>>2]<<3)|0;break}else{p=m+(h<<3)|0;break}}else p=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((p|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[p+4>>2]|0,(n|0)!=0):0)q=n;else o=20}else o=20;if((o|0)==20)q=hQb(c[j>>2]|0)|0;t2d(q,c[b+24>>2]|0);i=d;return}function K1d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d+4|0;h=d;j=BLc()|0;In[c[(c[j>>2]|0)+32>>2]&4095](j,b);a[b+30>>0]=0;j=b+44|0;k=c[j>>2]|0;do if(k){c[h>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,h);m=c[e>>2]|0;n=c[l+28>>2]|0;if((m|0)==-1){o=n+(c[l+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((o|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(c[o+4>>2]|0)!=0:0)p=l;else q=10}else q=10;if((q|0)==10){if(!(hQb(c[j>>2]|0)|0))break;p=c[137784]|0}c[g>>2]=c[j>>2];if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,g);l=c[e>>2]|0;m=c[p+28>>2]|0;if((l|0)==-1){r=m+(c[p+32>>2]<<3)|0;break}else{r=m+(l<<3)|0;break}}else r=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);l=c[137784]|0;if((r|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[r+4>>2]|0,(l|0)!=0):0)s=l;else q=20}else q=20;if((q|0)==20)s=hQb(c[j>>2]|0)|0;u2d(s,c[b+24>>2]|0)}while(0);s=b+92|0;j=c[s>>2]|0;q=c[153116]|0;if(!j){c[f>>2]=q;c[e+0>>2]=c[f+0>>2];eOb(j,e);c[s>>2]=0;L1d(b);i=d;return}v1d(j);c[f>>2]=q;c[e+0>>2]=c[f+0>>2];eOb(j,e);c[s>>2]=0;L1d(b);i=d;return}function L1d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+196|0;g=c[f>>2]|0;h=a+204|0;if(!(c[h>>2]|0))j=g;else{k=g;do{g=k+8|0;l=c[g>>2]|0;m=c[153116]|0;if(l)m4d(l);c[e>>2]=m;c[d+0>>2]=c[e+0>>2];eOb(l,d);c[g>>2]=0;g=k+4|0;l=c[g>>2]|0;m=c[153116]|0;if(l)D2d(l);c[e>>2]=m;c[d+0>>2]=c[e+0>>2];eOb(l,d);c[g>>2]=0;g=k+12|0;l=c[g>>2]|0;m=c[153116]|0;if(l)k2d(l);c[e>>2]=m;c[d+0>>2]=c[e+0>>2];eOb(l,d);c[g>>2]=0;k=k+20|0;g=c[f>>2]|0}while((k|0)!=(g+((c[h>>2]|0)*20|0)|0));j=g}k=a+208|0;if((c[k>>2]|0)<=-1){c[h>>2]=0;c[k>>2]=0;i=b;return}c[e>>2]=c[a+200>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[f>>2]=0;c[h>>2]=0;c[k>>2]=0;i=b;return}function M1d(a){a=a|0;var b=0,d=0;b=i;d=a+168|0;kQb(c[d>>2]|0);c[d>>2]=0;i=b;return}function N1d(a,b){a=a|0;b=b|0;var d=0;d=i;rGc(a,BTb(c[b+24>>2]|0)|0);i=d;return}
function O1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im;d=i;i=i+64|0;e=d+48|0;f=d+40|0;h=d+16|0;j=d;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;k=b+44|0;l=c[k>>2]|0;do if(!l){m=ea(0.0);n=ea(0.0);o=ea(0.0)}else{c[f>>2]=l;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,f);q=c[e>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[s+4>>2]|0,(p|0)!=0):0)t=p;else u=10}else u=10;if((u|0)==10){p=hQb(c[k>>2]|0)|0;if(!p){m=ea(0.0);n=ea(0.0);o=ea(0.0);break}else t=p}b1d(h,t+232|0);c[a+0>>2]=c[h+0>>2];c[a+4>>2]=c[h+4>>2];c[a+8>>2]=c[h+8>>2];c[a+12>>2]=c[h+12>>2];c[a+16>>2]=c[h+16>>2];c[a+20>>2]=c[h+20>>2];v=ea(g[a>>2]);w=ea(g[a+4>>2]);m=v;n=w;o=ea(g[a+8>>2])}while(0);rGc(j,BTb(c[b+24>>2]|0)|0);g[a>>2]=ea(ea(g[j>>2])+m);g[a+4>>2]=ea(ea(g[j+4>>2])+n);g[a+8>>2]=ea(ea(g[j+8>>2])+o);i=d;return}function P1d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=b+44|0;m=c[l>>2]|0;n=c[d>>2]|0;if((m|0)==(n|0)){i=e;return}if(!(a[b+30>>0]|0))o=n;else{n=c[b+24>>2]|0;do if(m){c[j>>2]=m;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,j);q=c[f>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(c[s+4>>2]|0)!=0:0)t=p;else u=12}else u=12;if((u|0)==12){if(!(hQb(c[l>>2]|0)|0))break;t=c[137784]|0}c[h>>2]=c[l>>2];if(t){do if((c[t+36>>2]|0)!=(c[t+4>>2]|0)){fRb(f,t,h);p=c[f>>2]|0;q=c[t+28>>2]|0;if((p|0)==-1){v=q+(c[t+32>>2]<<3)|0;break}else{v=q+(p<<3)|0;break}}else v=(c[t+28>>2]|0)+(c[t+32>>2]<<3)|0;while(0);p=c[137784]|0;if((v|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[v+4>>2]|0,(p|0)!=0):0)w=p;else u=22}else u=22;if((u|0)==22)w=hQb(c[l>>2]|0)|0;u2d(w,n)}while(0);w=c[d>>2]|0;do if(w){c[g>>2]=w;v=c[137784]|0;if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(f,v,g);t=c[f>>2]|0;h=c[v+28>>2]|0;if((t|0)==-1){x=h+(c[v+32>>2]<<3)|0;break}else{x=h+(t<<3)|0;break}}else x=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);v=c[137784]|0;if((x|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(c[x+4>>2]|0)!=0:0)y=v;else u=33}else u=33;if((u|0)==33){if(!(hQb(c[d>>2]|0)|0))break;y=c[137784]|0}c[k>>2]=c[d>>2];if(y){do if((c[y+36>>2]|0)!=(c[y+4>>2]|0)){fRb(f,y,k);v=c[f>>2]|0;t=c[y+28>>2]|0;if((v|0)==-1){z=t+(c[y+32>>2]<<3)|0;break}else{z=t+(v<<3)|0;break}}else z=(c[y+28>>2]|0)+(c[y+32>>2]<<3)|0;while(0);v=c[137784]|0;if((z|0)!=((c[v+28>>2]|0)+(c[v+32>>2]<<3)|0)?(v=c[z+4>>2]|0,(v|0)!=0):0)A=v;else u=43}else u=43;if((u|0)==43)A=hQb(c[d>>2]|0)|0;t2d(A,n)}while(0);w1d(c[b+92>>2]|0,d);o=c[d>>2]|0}c[l>>2]=o;L1d(b);i=e;return}function Q1d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[(jLc()|0)+128>>2]|0;g=a+196|0;h=a+204|0;a=c[h>>2]|0;if(!a){i=b;return}j=c[g>>2]|0;k=a;a=j;l=j;a:while(1){j=l+16|0;m=l+8|0;n=l+4|0;o=l+12|0;p=l+20|0;q=p;r=k;s=a;while(1){if((f-(c[j>>2]|0)|0)>>>0<=100?(c[l>>2]|0)!=0:0){t=r;u=s;break}v=c[m>>2]|0;w=c[153116]|0;if(v)m4d(v);c[e>>2]=w;c[d+0>>2]=c[e+0>>2];eOb(v,d);c[m>>2]=0;v=c[n>>2]|0;w=c[153116]|0;if(v)D2d(v);c[e>>2]=w;c[d+0>>2]=c[e+0>>2];eOb(v,d);c[n>>2]=0;v=c[o>>2]|0;w=c[153116]|0;if(v)k2d(v);c[e>>2]=w;c[d+0>>2]=c[e+0>>2];eOb(v,d);c[o>>2]=0;aFi(l|0,p|0,(c[g>>2]|0)+((c[h>>2]|0)*20|0)-q|0)|0;r=(c[h>>2]|0)+-1|0;c[h>>2]=r;s=c[g>>2]|0;if((l|0)==(s+(r*20|0)|0)){x=14;break a}}if((p|0)==(u+(t*20|0)|0)){x=14;break}else{k=t;a=u;l=p}}if((x|0)==14){i=b;return}}function R1d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+44|0;g=c[f>>2]|0;do if(g){c[e>>2]=g;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(d,h,e);j=c[d>>2]|0;k=c[h+28>>2]|0;if((j|0)==-1){l=k+(c[h+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((l|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0)break}if(!(hQb(c[f>>2]|0)|0))m=11}else m=11;while(0);if((m|0)==11)L1d(a);m=a+192|0;f=c[m>>2]|0;l=(f&1|0)==0;d=(f&3|0)==0;if((f&4|0)!=0?(f=a+196|0,e=a+204|0,(c[e>>2]|0)!=0):0){g=c[f>>2]|0;do{Z2d(c[g+4>>2]|0);g=g+20|0}while((g|0)!=((c[f>>2]|0)+((c[e>>2]|0)*20|0)|0))}if(!d?(d=a+196|0,e=a+204|0,(c[e>>2]|0)!=0):0){f=c[d>>2]|0;do{q4d(c[f+8>>2]|0);f=f+20|0}while((f|0)!=((c[d>>2]|0)+((c[e>>2]|0)*20|0)|0))}if(!l?(l=a+196|0,e=a+204|0,(c[e>>2]|0)!=0):0){d=c[l>>2]|0;do{I0d(c[d+12>>2]|0);d=d+20|0}while((d|0)!=((c[l>>2]|0)+((c[e>>2]|0)*20|0)|0))}if((c[m>>2]&1|0)!=0?(e=a+196|0,l=a+204|0,(c[l>>2]|0)!=0):0){d=c[e>>2]|0;do{V2d(c[d+4>>2]|0);d=d+20|0}while((d|0)!=((c[e>>2]|0)+((c[l>>2]|0)*20|0)|0))}l=c[a+92>>2]|0;if(!l){c[m>>2]=0;i=b;return}u1d(l,a+88|0);c[m>>2]=0;i=b;return}function S1d(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im;b=i;i=i+64|0;d=b;e=b+24|0;f=b+36|0;h=b+12|0;j=b+40|0;k=b+52|0;l=b+20|0;m=b+32|0;n=b+28|0;o=b+16|0;p=n8b()|0;c[h>>2]=c[p>>2];q=c[137784]|0;if(q){do if((c[q+36>>2]|0)!=(c[q+4>>2]|0)){fRb(d,q,h);r=c[d>>2]|0;s=c[q+28>>2]|0;if((r|0)==-1){t=s+(c[q+32>>2]<<3)|0;break}else{t=s+(r<<3)|0;break}}else t=(c[q+28>>2]|0)+(c[q+32>>2]<<3)|0;while(0);q=c[137784]|0;if((t|0)!=((c[q+28>>2]|0)+(c[q+32>>2]<<3)|0)?(q=c[t+4>>2]|0,(q|0)!=0):0)u=q;else v=9}else v=9;if((v|0)==9)u=hQb(c[p>>2]|0)|0;p=a+24|0;if(!(1<<c[(c[p>>2]|0)+40>>2]&c[u+412>>2])){w=0;i=b;return w|0}q=c[(jLc()|0)+128>>2]|0;t=a+196|0;h=a+204|0;r=c[h>>2]|0;a:do if(r){s=c[t>>2]|0;x=s;while(1){if((c[x>>2]|0)==(u|0)){y=x;break}x=x+20|0;if((x|0)==(s+(r*20|0)|0))break a}c[y+16>>2]=q;w=y;i=b;return w|0}while(0);y=a+44|0;r=c[y>>2]|0;if(!r){w=0;i=b;return w|0}c[e>>2]=r;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(d,r,e);s=c[d>>2]|0;x=c[r+28>>2]|0;if((s|0)==-1){z=x+(c[r+32>>2]<<3)|0;break}else{z=x+(s<<3)|0;break}}else z=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if(!((z|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(c[z+4>>2]|0)!=0:0))v=25}else v=25;if((v|0)==25?(hQb(c[y>>2]|0)|0)==0:0){w=0;i=b;return w|0}rGc(j,BTb(c[p>>2]|0)|0);z=(c[h>>2]|0)+1|0;c[h>>2]=z;r=a+208|0;e=c[r>>2]|0;do if((e&2147483647)>>>0<z>>>0)if((e|0)>-1){c[r>>2]=z;s=c[t>>2]|0;c[f>>2]=c[a+200>>2];c[d+0>>2]=c[f+0>>2];x=hOb(s,z*20|0,4,d,0,3653512,370)|0;c[t>>2]=x;A=x;break}else{c[f>>2]=c[a+200>>2];c[d+0>>2]=c[f+0>>2];x=cOb(z*20|0,4,d,0,3653512,352)|0;YEi(x|0,c[t>>2]|0,(c[h>>2]|0)*20|0)|0;c[r>>2]=z;c[t>>2]=x;A=x;break}else A=c[t>>2]|0;while(0);t=(c[h>>2]|0)+-1|0;h=A+(t*20|0)|0;c[h>>2]=u;c[k>>2]=c[153116];c[d+0>>2]=c[k+0>>2];k=bOb(328,d,0,16,3653512,298)|0;u=c[(c[p>>2]|0)+4>>2]|0;c[l>>2]=c[y>>2];B2d(k,u,l,j);l=A+(t*20|0)+4|0;c[l>>2]=k;c[m>>2]=c[153116];c[d+0>>2]=c[m+0>>2];m=bOb(288,d,0,16,3653512,299)|0;c[f>>2]=c[y>>2];k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(d,k,f);u=c[d>>2]|0;p=c[k+28>>2]|0;if((u|0)==-1){B=p+(c[k+32>>2]<<3)|0;break}else{B=p+(u<<3)|0;break}}else B=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((B|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[B+4>>2]|0,(k|0)!=0):0)C=k;else v=39}else v=39;if((v|0)==39)C=hQb(c[y>>2]|0)|0;k4d(m,C+72|0,j);c[A+(t*20|0)+8>>2]=m;c[n>>2]=c[153116];c[d+0>>2]=c[n+0>>2];n=bOb(120,d,0,16,3653512,300)|0;c[o>>2]=c[y>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];E0d(n,o,d);d=A+(t*20|0)+12|0;c[d>>2]=n;n=a+128|0;c[(c[l>>2]|0)+140>>2]=c[n>>2];c[(c[d>>2]|0)+28>>2]=c[n>>2];D=ea(g[a+96>>2]);E=ea(g[a+100>>2]);n=a+104|0;o=c[n>>2]|0;j=c[n+4>>2]|0;n=c[l>>2]|0;g[n+108>>2]=D;g[n+112>>2]=E;y=n+116|0;c[y>>2]=o;c[y+4>>2]=j;y=c[d>>2]|0;g[y+32>>2]=D;g[y+36>>2]=E;n=y+40|0;c[n>>2]=o;c[n+4>>2]=j;E=ea(g[a+112>>2]);D=ea(g[a+116>>2]);j=a+120|0;F=ea(g[j+4>>2]);G=ea(g[j>>2]);H=ea(E*ea(g[a+132>>2]));I=ea(D*ea(g[a+136>>2]));J=ea(G+ea(E*ea(g[a+140>>2])));E=ea(J);J=ea(F+ea(D*ea(g[a+144>>2])));D=ea(J);a=c[l>>2]|0;g[a+124>>2]=H;g[a+128>>2]=I;l=a+132|0;g[l>>2]=E;g[l+4>>2]=D;l=c[d>>2]|0;g[l+48>>2]=H;g[l+52>>2]=I;d=l+56|0;g[d>>2]=E;g[d+4>>2]=D;c[A+(t*20|0)+16>>2]=q;w=h;i=b;return w|0}function T1d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b;f=n8b()|0;c[e>>2]=c[f>>2];g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0)l=g;else m=9}else m=9;if((m|0)==9)l=hQb(c[f>>2]|0)|0;if(!(1<<c[(c[a+24>>2]|0)+40>>2]&c[l+412>>2])){n=0;i=b;return n|0}f=c[a+204>>2]|0;if(!f){n=0;i=b;return n|0}g=c[a+196>>2]|0;a=g;while(1){if((c[a>>2]|0)==(l|0)){o=a;break}a=a+20|0;if((a|0)==(g+(f*20|0)|0)){n=0;m=16;break}}if((m|0)==16){i=b;return n|0}n=c[o+4>>2]|0;i=b;return n|0}function U1d(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+92>>2]|0;if(!d){e=0;i=b;return e|0}e=A1d(d)|0;i=b;return e|0}function V1d(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g;j=g+4|0;k=d+128|0;l=k+(f<<1)|0;f=b[l>>1]|0;do if((e|0)==-1){b[l>>1]=255;m=255}else{if(e>>>0<=255){n=e&65535;b[l>>1]=n;m=n;break}b[l>>1]=255;c[h>>2]=255;Lsd(j,721176,h);if(!(a[j>>0]&1))o=j+1|0;else o=c[j+8>>2]|0;Krd(o,0,3653512,60,1,0,0,0);xri(j);m=b[l>>1]|0}while(0);if(m<<16>>16==f<<16>>16){i=g;return}f=d+196|0;m=d+204|0;if(!(c[m>>2]|0)){i=g;return}d=c[f>>2]|0;do{c[(c[d+4>>2]|0)+140>>2]=c[k>>2];c[(c[d+12>>2]|0)+28>>2]=c[k>>2];d=d+20|0}while((d|0)!=((c[f>>2]|0)+((c[m>>2]|0)*20|0)|0));i=g;return}function W1d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;e=i;f=a+(d<<4)+96|0;h=ea(g[b>>2]);if(h==ea(g[f>>2])){h=ea(g[b+4>>2]);j=a+(d<<4)+100|0;if((h==ea(g[j>>2])?(h=ea(g[b+8>>2]),h==ea(g[a+(d<<4)+104>>2])):0)?(h=ea(g[b+12>>2]),h==ea(g[a+(d<<4)+108>>2])):0){i=e;return}else l=j}else l=a+(d<<4)+100|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];h=ea(g[a+(d<<4)+96>>2]);m=ea(g[l>>2]);l=a+(d<<4)+104|0;b=c[l>>2]|0;n=ea(g[l+4>>2]);if((d|0)==1){o=(c[k>>2]=b,ea(g[k>>2]));p=ea(h*ea(g[a+132>>2]));q=ea(m*ea(g[a+136>>2]));r=ea(o+ea(h*ea(g[a+140>>2])));s=ea(n+ea(m*ea(g[a+144>>2])));t=p;u=q;v=(g[k>>2]=r,c[k>>2]|0)}else{s=n;t=h;u=m;v=b}b=a+196|0;l=a+204|0;if(!(c[l>>2]|0)){i=e;return}m=ea(s);a=c[b>>2]|0;do{f=c[a+4>>2]|0;g[f+(d<<4)+108>>2]=t;g[f+(d<<4)+112>>2]=u;j=f+(d<<4)+116|0;c[j>>2]=v;g[j+4>>2]=m;j=c[a+12>>2]|0;g[j+(d<<4)+32>>2]=t;g[j+(d<<4)+36>>2]=u;f=j+(d<<4)+40|0;c[f>>2]=v;g[f+4>>2]=m;a=a+20|0}while((a|0)!=((c[b>>2]|0)+((c[l>>2]|0)*20|0)|0));i=e;return}function X1d(a,c){a=a|0;c=c|0;var d=0,e=0;d=i;e=b[a+128>>1]|0;V1d(a,(e<<16>>16==255?-1:e&65535)+c|0,0);i=d;return}function Y1d(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2492024,a,0);f2d(a,b);bdd(b);i=c;return}function Z1d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2492024,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else g2d(a,b);sdd(b);i=d;return}function _1d(a,b){a=a|0;b=b|0;var c=0;c=i;h2d(a,b);i=c;return}function $1d(a,b){a=a|0;b=b|0;var c=0;c=i;i2d(a,b);i=c;return}function a2d(a,b){a=a|0;b=b|0;var c=0;c=i;j2d(a,b);i=c;return}function b2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Mkc(a,b);e=b+12|0;f=c[e>>2]|0;g=b+28|0;xo[c[c[f>>2]>>2]&2047](f,c[a+44>>2]|0,c[g>>2]|0)|0;f=c[e>>2]|0;xo[c[c[f>>2]>>2]&2047](f,c[a+88>>2]|0,c[g>>2]|0)|0;i=d;return}function c2d(){var a=0;a=i;QQb(218,214,215,0,216);i=a;return}function d2d(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,2492024,7);wQb(218,8,b,212,2740,0,0);xri(b);i=a;return}function e2d(a){a=a|0;return 218}function f2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;Hkc(a,b);ddd(b,2);c[f>>2]=0;add(b,720672,721152,f,0);h=e+8|0;j=h;c[j>>2]=0;c[j+4>>2]=0;c[e>>2]=0;j=c[142270]|0;add(b,792256,j,f,1);f=b+12|0;k=b+20|0;c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,h,1);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);h=c[142268]|0;add(b,720688,h,a+60|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720704,h,a+64|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720728,h,a+68|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720752,j,a+72|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720784,h,a+76|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720808,h,a+80|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720832,h,a+48|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,720856,h,a+56|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);h=c[142270]|0;add(b,720880,h,a+52|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);j=c[142258]|0;add(b,720904,j,a+84|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,720920,j,a+85|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,720936,j,a+86|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);c[g>>2]=0;add(b,720960,723624,g,0);l=e+8|0;m=l;c[m>>2]=0;c[m+4>>2]=0;c[e>>2]=0;add(b,792256,h,g,1);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,l,1);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);l=a+128|0;g=c[142296]|0;add(b,720984,g,l,8388609);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=2;bdd(b);add(b,721e3,g,l+2|0,8388609);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=2;bdd(b);l=a+96|0;g=c[142312]|0;add(b,721024,g,l,8388609);ljc(l,b);bdd(b);l=a+112|0;add(b,721048,g,l,8388609);ljc(l,b);bdd(b);add(b,721080,j,a+164|0,0);c[(c[c[f>>2]>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);k=a+132|0;add(b,721112,g,k,8388609);ljc(k,b);bdd(b);k=a+148|0;add(b,721128,g,k,8388609);ljc(k,b);bdd(b);i=d;return}function g2d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+32|0;h=f;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;Ikc(d,e);rdd(e,2);c[k>>2]=0;n=qdd(e,720672,721152,h,1)|0;if(n){if((n|0)<=0){n=c[h>>2]|0;if(n)_n[n&4095](k,e)|0}else m2d(k,e);sdd(e)}n=e+136|0;if(a[n>>0]|0)P1d(d,k);k=d+60|0;o=c[142268]|0;p=qdd(e,720688,o,h,0)|0;if(p){if((p|0)>0){p=e+12|0;q=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;s=q+r|0;c[p>>2]=s;if((r|0)>=0?(t=q+(r+4)|0,t>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[s>>2]);c[p>>2]=t}else Bid(p,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{p=c[h>>2]|0;if(p)_n[p&4095](k,e)|0}sdd(e)}k=d+64|0;p=qdd(e,720704,o,h,0)|0;if(p){if((p|0)>0){p=e+12|0;t=c[e+16>>2]|0;s=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=t+s|0;c[p>>2]=r;if((s|0)>=0?(q=t+(s+4)|0,q>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[r>>2]);c[p>>2]=q}else Bid(p,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{p=c[h>>2]|0;if(p)_n[p&4095](k,e)|0}sdd(e)}k=d+68|0;p=qdd(e,720728,o,h,0)|0;if(p){if((p|0)>0){p=e+12|0;q=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;s=q+r|0;c[p>>2]=s;if((r|0)>=0?(t=q+(r+4)|0,t>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[s>>2]);c[p>>2]=t}else Bid(p,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{p=c[h>>2]|0;if(p)_n[p&4095](k,e)|0}sdd(e)}k=d+72|0;p=c[142270]|0;t=qdd(e,720752,p,h,0)|0;if(t){if((t|0)>0){t=e+12|0;s=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;q=s+r|0;c[t>>2]=q;if((r|0)>=0?(u=s+(r+4)|0,u>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[q>>2];c[t>>2]=u}else Bid(t,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{t=c[h>>2]|0;if(t)_n[t&4095](k,e)|0}sdd(e)}k=d+76|0;t=qdd(e,720784,o,h,0)|0;if(t){if((t|0)>0){t=e+12|0;u=c[e+16>>2]|0;q=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=u+q|0;c[t>>2]=r;if((q|0)>=0?(s=u+(q+4)|0,s>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[r>>2]);c[t>>2]=s}else Bid(t,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{t=c[h>>2]|0;if(t)_n[t&4095](k,e)|0}sdd(e)}k=d+80|0;t=qdd(e,720808,o,h,0)|0;if(t){if((t|0)>0){t=e+12|0;s=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;q=s+r|0;c[t>>2]=q;if((r|0)>=0?(u=s+(r+4)|0,u>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[q>>2]);c[t>>2]=u}else Bid(t,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{t=c[h>>2]|0;if(t)_n[t&4095](k,e)|0}sdd(e)}k=d+48|0;t=qdd(e,720832,o,h,0)|0;if(t){if((t|0)>0){t=e+12|0;u=c[e+16>>2]|0;q=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=u+q|0;c[t>>2]=r;if((q|0)>=0?(s=u+(q+4)|0,s>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[r>>2]);c[t>>2]=s}else Bid(t,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{t=c[h>>2]|0;if(t)_n[t&4095](k,e)|0}sdd(e)}k=d+56|0;t=qdd(e,720856,o,h,0)|0;if(t){if((t|0)>0){t=e+12|0;o=c[e+16>>2]|0;s=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=o+s|0;c[t>>2]=r;if((s|0)>=0?(q=o+(s+4)|0,q>>>0<=(c[e+20>>2]|0)>>>0):0){g[k>>2]=ea(g[r>>2]);c[t>>2]=q}else Bid(t,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{t=c[h>>2]|0;if(t)_n[t&4095](k,e)|0}sdd(e)}k=d+52|0;t=qdd(e,720880,p,h,0)|0;if(t){if((t|0)>0){t=e+12|0;q=c[e+16>>2]|0;r=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;s=q+r|0;c[t>>2]=s;if((r|0)>=0?(o=q+(r+4)|0,o>>>0<=(c[e+20>>2]|0)>>>0):0){c[k>>2]=c[s>>2];c[t>>2]=o}else Bid(t,k,4);if(c[e>>2]&512)c[k>>2]=XEi(c[k>>2]|0)|0}else{t=c[h>>2]|0;if(t)_n[t&4095](k,e)|0}sdd(e)}k=d+84|0;t=c[142258]|0;o=qdd(e,720904,t,h,0)|0;if(o){do if((o|0)<=0){s=c[h>>2]|0;if(s)_n[s&4095](k,e)|0}else{s=e+12|0;r=c[e+16>>2]|0;q=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;u=r+q|0;c[s>>2]=u;if((q|0)>=0?(r+(q+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){a[k>>0]=a[u>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break}Bid(s,k,1)}while(0);sdd(e)}k=d+85|0;o=qdd(e,720920,t,h,0)|0;if(o){do if((o|0)<=0){s=c[h>>2]|0;if(s)_n[s&4095](k,e)|0}else{s=e+12|0;u=c[e+16>>2]|0;q=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;r=u+q|0;c[s>>2]=r;if((q|0)>=0?(u+(q+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){a[k>>0]=a[r>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break}Bid(s,k,1)}while(0);sdd(e)}k=d+86|0;o=qdd(e,720936,t,h,0)|0;if(o){do if((o|0)<=0){s=c[h>>2]|0;if(s)_n[s&4095](k,e)|0}else{s=e+12|0;r=c[e+16>>2]|0;q=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;u=r+q|0;c[s>>2]=u;if((q|0)>=0?(r+(q+1)|0)>>>0<=(c[e+20>>2]|0)>>>0:0){a[k>>0]=a[u>>0]|0;c[s>>2]=(c[s>>2]|0)+1;break}Bid(s,k,1)}while(0);sdd(e)}c[l>>2]=0;k=qdd(e,720960,723624,h,1)|0;if(k){if((k|0)<=0){k=c[h>>2]|0;if(k)_n[k&4095](l,e)|0}else g7b(l,e);sdd(e)}if(((a[n>>0]|0)!=0?(n=d+88|0,k=c[l>>2]|0,(c[n>>2]|0)!=(k|0)):0)?(c[n>>2]=k,k=c[d+92>>2]|0,(k|0)!=0):0)u1d(k,l);l=d+128|0;do if(xdd(e,1)|0){k=b[l>>1]|0;c[m>>2]=k<<16>>16==255?-1:k&65535;k=qdd(e,720984,p,h,0)|0;if(k){do if((k|0)>0){n=e+12|0;o=c[e+16>>2]|0;s=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;u=o+s|0;c[n>>2]=u;do if((s|0)<0)v=151;else{q=o+(s+4)|0;if(q>>>0>(c[e+20>>2]|0)>>>0){v=151;break}c[m>>2]=c[u>>2];c[n>>2]=q}while(0);if((v|0)==151)Bid(n,m,4);if(!(c[e>>2]&512))break;c[m>>2]=XEi(c[m>>2]|0)|0}else{u=c[h>>2]|0;if(!u)break;_n[u&4095](m,e)|0}while(0);sdd(e)}k=c[m>>2]|0;if((k|0)==-1){b[l>>1]=255;break}if(k>>>0<=255){b[l>>1]=k;break}b[l>>1]=255;c[h>>2]=255;Lsd(j,721176,h);if(!(a[j>>0]&1))w=j+1|0;else w=c[j+8>>2]|0;Krd(w,0,3653512,60,1,0,0,0);xri(j)}else AUb(e,l,720984,8388609);while(0);AUb(e,l+2|0,721e3,8388609);l=d+96|0;j=c[142312]|0;w=qdd(e,721024,j,h,1)|0;if(w){do if((w|0)>0)igc(l,e);else{m=c[h>>2]|0;if(!m)break;_n[m&4095](l,e)|0}while(0);sdd(e)}l=d+112|0;w=qdd(e,721048,j,h,1)|0;if(w){do if((w|0)>0)igc(l,e);else{m=c[h>>2]|0;if(!m)break;_n[m&4095](l,e)|0}while(0);sdd(e)}l=d+164|0;w=qdd(e,721080,t,h,0)|0;if(w){a:do if((w|0)>0){t=e+12|0;m=c[e+16>>2]|0;v=(c[(c[e+80>>2]|0)+12>>2]|0)-(da(c[e+32>>2]|0,c[e+28>>2]|0)|0)|0;p=m+v|0;c[t>>2]=p;do if((v|0)>=0){if((m+(v+1)|0)>>>0>(c[e+20>>2]|0)>>>0)break;a[l>>0]=a[p>>0]|0;c[t>>2]=(c[t>>2]|0)+1;break a}while(0);Bid(t,l,1)}else{p=c[h>>2]|0;if(!p)break;_n[p&4095](l,e)|0}while(0);sdd(e)}l=d+132|0;w=qdd(e,721112,j,h,1)|0;if(w){do if((w|0)>0)igc(l,e);else{p=c[h>>2]|0;if(!p)break;_n[p&4095](l,e)|0}while(0);sdd(e)}l=d+148|0;d=qdd(e,721128,j,h,1)|0;if(!d){i=f;return}do if((d|0)>0)igc(l,e);else{j=c[h>>2]|0;if(!j)break;_n[j&4095](l,e)|0}while(0);sdd(e);i=f;return}function h2d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;h=f+4|0;j=f;Jkc(d,e);c[h>>2]=0;n2d(h,e);P1d(d,h);h=d+60|0;k=e+12|0;l=c[k>>2]|0;m=l+4|0;n=e+20|0;o=c[n>>2]|0;if(m>>>0>o>>>0){Bid(k,h,4);p=c[k>>2]|0;q=c[n>>2]|0}else{g[h>>2]=ea(g[l>>2]);c[k>>2]=m;p=m;q=o}o=d+64|0;m=p+4|0;if(m>>>0>q>>>0){Bid(k,o,4);r=c[k>>2]|0;s=c[n>>2]|0}else{g[o>>2]=ea(g[p>>2]);c[k>>2]=m;r=m;s=q}q=d+68|0;m=r+4|0;if(m>>>0>s>>>0){Bid(k,q,4);t=c[k>>2]|0;u=c[n>>2]|0}else{g[q>>2]=ea(g[r>>2]);c[k>>2]=m;t=m;u=s}s=d+72|0;m=t+4|0;if(m>>>0>u>>>0){Bid(k,s,4);v=c[k>>2]|0;w=c[n>>2]|0}else{c[s>>2]=c[t>>2];c[k>>2]=m;v=m;w=u}u=d+76|0;m=v+4|0;if(m>>>0>w>>>0){Bid(k,u,4);x=c[k>>2]|0;y=c[n>>2]|0}else{g[u>>2]=ea(g[v>>2]);c[k>>2]=m;x=m;y=w}w=d+80|0;m=x+4|0;if(m>>>0>y>>>0){Bid(k,w,4);z=c[k>>2]|0;A=c[n>>2]|0}else{g[w>>2]=ea(g[x>>2]);c[k>>2]=m;z=m;A=y}y=d+48|0;m=z+4|0;if(m>>>0>A>>>0){Bid(k,y,4);B=c[k>>2]|0;C=c[n>>2]|0}else{g[y>>2]=ea(g[z>>2]);c[k>>2]=m;B=m;C=A}A=d+56|0;m=B+4|0;if(m>>>0>C>>>0){Bid(k,A,4);D=c[k>>2]|0;E=c[n>>2]|0}else{g[A>>2]=ea(g[B>>2]);c[k>>2]=m;D=m;E=C}C=d+52|0;m=D+4|0;if(m>>>0>E>>>0){Bid(k,C,4);F=c[k>>2]|0;G=c[n>>2]|0}else{c[C>>2]=c[D>>2];c[k>>2]=m;F=m;G=E}E=d+84|0;if((F+1|0)>>>0>G>>>0)Bid(k,E,1);else{a[E>>0]=a[F>>0]|0;c[k>>2]=(c[k>>2]|0)+1}Ndd(e);F=d+85|0;E=c[k>>2]|0;if((E+1|0)>>>0>(c[n>>2]|0)>>>0){Bid(k,F,1);H=c[k>>2]|0}else{a[F>>0]=a[E>>0]|0;E=(c[k>>2]|0)+1|0;c[k>>2]=E;H=E}E=d+86|0;if((H+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(k,E,1);else{a[E>>0]=a[H>>0]|0;c[k>>2]=(c[k>>2]|0)+1}Ndd(e);c[j>>2]=0;h7b(j,e);H=d+88|0;E=c[j>>2]|0;if((c[H>>2]|0)!=(E|0)?(c[H>>2]=E,E=c[d+92>>2]|0,(E|0)!=0):0)u1d(E,j);j=d+128|0;E=c[k>>2]|0;H=E+2|0;F=c[n>>2]|0;if(H>>>0>F>>>0){Bid(k,j,2);I=c[k>>2]|0;J=c[n>>2]|0}else{b[j>>1]=b[E>>1]|0;c[k>>2]=H;I=H;J=F}F=j+2|0;j=I+2|0;if(j>>>0>J>>>0)Bid(k,F,2);else{b[F>>1]=b[I>>1]|0;c[k>>2]=j}Qxc(e,d+96|0,721024,8388609);Qxc(e,d+112|0,721048,8388609);j=d+164|0;I=c[k>>2]|0;if((I+1|0)>>>0>(c[n>>2]|0)>>>0){Bid(k,j,1);Ndd(e);K=d+132|0;Qxc(e,K,721112,8388609);L=d+148|0;Qxc(e,L,721128,8388609);i=f;return}else{a[j>>0]=a[I>>0]|0;c[k>>2]=(c[k>>2]|0)+1;Ndd(e);K=d+132|0;Qxc(e,K,721112,8388609);L=d+148|0;Qxc(e,L,721128,8388609);i=f;return}}function i2d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;f=i;i=i+16|0;h=f+4|0;j=f;Kkc(d,e);c[h>>2]=0;o2d(h,e);P1d(d,h);h=d+60|0;l=e+12|0;m=c[l>>2]|0;n=m+4|0;o=e+20|0;p=c[o>>2]|0;if(n>>>0>p>>>0){Bid(l,h,4);q=h;r=c[l>>2]|0;s=c[o>>2]|0;t=c[h>>2]|0}else{u=ea(g[m>>2]);g[h>>2]=u;c[l>>2]=n;q=h;r=n;s=p;t=(g[k>>2]=u,c[k>>2]|0)}c[q>>2]=XEi(t|0)|0;t=d+64|0;q=r+4|0;if(q>>>0>s>>>0){Bid(l,t,4);v=t;w=c[t>>2]|0;x=c[l>>2]|0;y=c[o>>2]|0}else{u=ea(g[r>>2]);g[t>>2]=u;c[l>>2]=q;v=t;w=(g[k>>2]=u,c[k>>2]|0);x=q;y=s}c[v>>2]=XEi(w|0)|0;w=d+68|0;v=x+4|0;if(v>>>0>y>>>0){Bid(l,w,4);z=w;A=c[w>>2]|0;B=c[l>>2]|0;C=c[o>>2]|0}else{u=ea(g[x>>2]);g[w>>2]=u;c[l>>2]=v;z=w;A=(g[k>>2]=u,c[k>>2]|0);B=v;C=y}c[z>>2]=XEi(A|0)|0;A=d+72|0;z=B+4|0;if(z>>>0>C>>>0){Bid(l,A,4);D=c[A>>2]|0;E=c[l>>2]|0;F=c[o>>2]|0}else{y=c[B>>2]|0;c[A>>2]=y;c[l>>2]=z;D=y;E=z;F=C}c[A>>2]=XEi(D|0)|0;D=d+76|0;A=E+4|0;if(A>>>0>F>>>0){Bid(l,D,4);G=D;H=c[D>>2]|0;I=c[l>>2]|0;J=c[o>>2]|0}else{u=ea(g[E>>2]);g[D>>2]=u;c[l>>2]=A;G=D;H=(g[k>>2]=u,c[k>>2]|0);I=A;J=F}c[G>>2]=XEi(H|0)|0;H=d+80|0;G=I+4|0;if(G>>>0>J>>>0){Bid(l,H,4);K=H;L=c[H>>2]|0;M=c[l>>2]|0;N=c[o>>2]|0}else{u=ea(g[I>>2]);g[H>>2]=u;c[l>>2]=G;K=H;L=(g[k>>2]=u,c[k>>2]|0);M=G;N=J}c[K>>2]=XEi(L|0)|0;L=d+48|0;K=M+4|0;if(K>>>0>N>>>0){Bid(l,L,4);O=L;P=c[L>>2]|0;Q=c[l>>2]|0;R=c[o>>2]|0}else{u=ea(g[M>>2]);g[L>>2]=u;c[l>>2]=K;O=L;P=(g[k>>2]=u,c[k>>2]|0);Q=K;R=N}c[O>>2]=XEi(P|0)|0;P=d+56|0;O=Q+4|0;if(O>>>0>R>>>0){Bid(l,P,4);S=P;T=c[P>>2]|0;U=c[l>>2]|0;V=c[o>>2]|0}else{u=ea(g[Q>>2]);g[P>>2]=u;c[l>>2]=O;S=P;T=(g[k>>2]=u,c[k>>2]|0);U=O;V=R}c[S>>2]=XEi(T|0)|0;T=d+52|0;S=U+4|0;if(S>>>0>V>>>0){Bid(l,T,4);W=c[T>>2]|0;X=c[l>>2]|0;Y=c[o>>2]|0}else{R=c[U>>2]|0;c[T>>2]=R;c[l>>2]=S;W=R;X=S;Y=V}c[T>>2]=XEi(W|0)|0;W=d+84|0;if((X+1|0)>>>0>Y>>>0)Bid(l,W,1);else{a[W>>0]=a[X>>0]|0;c[l>>2]=(c[l>>2]|0)+1}Mdd(e);X=d+85|0;W=c[l>>2]|0;if((W+1|0)>>>0>(c[o>>2]|0)>>>0){Bid(l,X,1);Z=c[l>>2]|0}else{a[X>>0]=a[W>>0]|0;W=(c[l>>2]|0)+1|0;c[l>>2]=W;Z=W}W=d+86|0;if((Z+1|0)>>>0>(c[o>>2]|0)>>>0)Bid(l,W,1);else{a[W>>0]=a[Z>>0]|0;c[l>>2]=(c[l>>2]|0)+1}Mdd(e);c[j>>2]=0;i7b(j,e);Z=d+88|0;W=c[j>>2]|0;if((c[Z>>2]|0)!=(W|0)?(c[Z>>2]=W,W=c[d+92>>2]|0,(W|0)!=0):0)u1d(W,j);j=d+128|0;W=c[l>>2]|0;Z=W+2|0;X=c[o>>2]|0;if(Z>>>0>X>>>0){Bid(l,j,2);_=b[j>>1]|0;$=c[l>>2]|0;aa=c[o>>2]|0}else{Y=b[W>>1]|0;b[j>>1]=Y;c[l>>2]=Z;_=Y;$=Z;aa=X}X=_&65535;b[j>>1]=X<<8|X>>>8;X=j+2|0;j=$+2|0;if(j>>>0>aa>>>0){Bid(l,X,2);ba=b[X>>1]|0}else{aa=b[$>>1]|0;b[X>>1]=aa;c[l>>2]=j;ba=aa}aa=ba&65535;b[X>>1]=aa<<8|aa>>>8;ojc(d+96|0,e);ojc(d+112|0,e);aa=d+164|0;X=c[l>>2]|0;if((X+1|0)>>>0>(c[o>>2]|0)>>>0){Bid(l,aa,1);Mdd(e);ca=d+132|0;ojc(ca,e);da=d+148|0;ojc(da,e);i=f;return}else{a[aa>>0]=a[X>>0]|0;c[l>>2]=(c[l>>2]|0)+1;Mdd(e);ca=d+132|0;ojc(ca,e);da=d+148|0;ojc(da,e);i=f;return}}function j2d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;h=f+4|0;j=f;Lkc(d,e);c[h>>2]=c[d+44>>2];p2d(h,e);h=d+60|0;k=e+12|0;l=c[k>>2]|0;m=l+4|0;n=e+20|0;o=c[n>>2]|0;if(m>>>0<o>>>0){g[l>>2]=ea(g[h>>2]);c[k>>2]=m;p=m;q=o}else{Gid(k,h,4);p=c[k>>2]|0;q=c[n>>2]|0}h=d+64|0;o=p+4|0;if(o>>>0<q>>>0){g[p>>2]=ea(g[h>>2]);c[k>>2]=o;r=o;s=q}else{Gid(k,h,4);r=c[k>>2]|0;s=c[n>>2]|0}h=d+68|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[h>>2]);c[k>>2]=q;t=q;u=s}else{Gid(k,h,4);t=c[k>>2]|0;u=c[n>>2]|0}h=d+72|0;s=t+4|0;if(s>>>0<u>>>0){c[t>>2]=c[h>>2];c[k>>2]=s;v=s;w=u}else{Gid(k,h,4);v=c[k>>2]|0;w=c[n>>2]|0}h=d+76|0;u=v+4|0;if(u>>>0<w>>>0){g[v>>2]=ea(g[h>>2]);c[k>>2]=u;x=u;y=w}else{Gid(k,h,4);x=c[k>>2]|0;y=c[n>>2]|0}h=d+80|0;w=x+4|0;if(w>>>0<y>>>0){g[x>>2]=ea(g[h>>2]);c[k>>2]=w;z=w;A=y}else{Gid(k,h,4);z=c[k>>2]|0;A=c[n>>2]|0}h=d+48|0;y=z+4|0;if(y>>>0<A>>>0){g[z>>2]=ea(g[h>>2]);c[k>>2]=y;B=y;C=A}else{Gid(k,h,4);B=c[k>>2]|0;C=c[n>>2]|0}h=d+56|0;A=B+4|0;if(A>>>0<C>>>0){g[B>>2]=ea(g[h>>2]);c[k>>2]=A;D=A;E=C}else{Gid(k,h,4);D=c[k>>2]|0;E=c[n>>2]|0}h=d+52|0;C=D+4|0;if(C>>>0<E>>>0){c[D>>2]=c[h>>2];c[k>>2]=C;F=C;G=E}else{Gid(k,h,4);F=c[k>>2]|0;G=c[n>>2]|0}h=d+84|0;if((F+1|0)>>>0<G>>>0){a[F>>0]=a[h>>0]|0;c[k>>2]=(c[k>>2]|0)+1}else Gid(k,h,1);Tdd(e);h=d+85|0;F=c[k>>2]|0;if((F+1|0)>>>0<(c[n>>2]|0)>>>0){a[F>>0]=a[h>>0]|0;F=(c[k>>2]|0)+1|0;c[k>>2]=F;H=F}else{Gid(k,h,1);H=c[k>>2]|0}h=d+86|0;if((H+1|0)>>>0<(c[n>>2]|0)>>>0){a[H>>0]=a[h>>0]|0;c[k>>2]=(c[k>>2]|0)+1}else Gid(k,h,1);Tdd(e);c[j>>2]=c[d+88>>2];j7b(j,e);j=d+128|0;h=c[k>>2]|0;H=h+2|0;F=c[n>>2]|0;if(H>>>0<F>>>0){b[h>>1]=b[j>>1]|0;c[k>>2]=H;I=H;J=F}else{Gid(k,j,2);I=c[k>>2]|0;J=c[n>>2]|0}F=j+2|0;j=I+2|0;if(j>>>0<J>>>0){b[I>>1]=b[F>>1]|0;c[k>>2]=j}else Gid(k,F,2);mjc(e,d+96|0,721024,8388609);mjc(e,d+112|0,721048,8388609);F=d+164|0;j=c[k>>2]|0;if((j+1|0)>>>0<(c[n>>2]|0)>>>0){a[j>>0]=a[F>>0]|0;c[k>>2]=(c[k>>2]|0)+1;Tdd(e);K=d+132|0;mjc(e,K,721112,8388609);L=d+148|0;mjc(e,L,721128,8388609);i=f;return}else{Gid(k,F,1);Tdd(e);K=d+132|0;mjc(e,K,721112,8388609);L=d+148|0;mjc(e,L,721128,8388609);i=f;return}}function k2d(a){a=a|0;var b=0;b=i;H0d(a);K0d(a+88|0,c[a+92>>2]|0);K0d(a+76|0,c[a+80>>2]|0);K0d(a+64|0,c[a+68>>2]|0);i=b;return}function l2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(212,e,1,16,3653512,35)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];D1d(f,e,b);i=d;return f|0}function m2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function n2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function o2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function p2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function q2d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=720536;if((c[a+208>>2]|0)<=-1){c[a>>2]=577608;WUb(a);i=b;return}f=a+196|0;g=c[f>>2]|0;c[e>>2]=c[a+200>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;c[a>>2]=577608;WUb(a);i=b;return}function r2d(a){a=a|0;var b=0;b=i;q2d(a);ACi(a);i=b;return}function s2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;if(!b)e=0;else e=c[b+4>>2]|0;b=c[a+328>>2]|0;f=c[a+332>>2]|0;a=f-b>>2;if(!a)g=b;else{h=b;b=a;while(1){a=(b|0)/2|0;if((c[h+(a<<2)>>2]|0)<(e|0)){j=h+(a+1<<2)|0;k=b+-1-a|0}else{j=h;k=a}if(!k){g=j;break}else{h=j;b=k}}}if((g|0)==(f|0)){l=f;m=(l|0)!=(f|0);i=d;return m|0}l=(e|0)<(c[g>>2]|0)?f:g;m=(l|0)!=(f|0);i=d;return m|0}function t2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;j=a+328|0;if(!b)k=0;else k=c[b+4>>2]|0;c[h>>2]=k;b=c[j>>2]|0;l=c[a+332>>2]|0;a=l-b>>2;if(!a)m=b;else{n=b;b=a;while(1){a=(b|0)/2|0;if((c[n+(a<<2)>>2]|0)<(k|0)){o=n+(a+1<<2)|0;p=b+-1-a|0}else{o=n;p=a}if(!p){m=o;break}else{n=o;b=p}}}if((m|0)!=(l|0)?(k|0)>=(c[m>>2]|0):0){i=d;return}c[g>>2]=m;c[e+0>>2]=c[g+0>>2];v2d(f,j,e,h);i=d;return}function u2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;if(!b)e=0;else e=c[b+4>>2]|0;b=c[a+328>>2]|0;f=a+332|0;a=c[f>>2]|0;g=b;h=a-g>>2;if(!h)j=b;else{k=b;l=h;while(1){h=(l|0)/2|0;if((c[k+(h<<2)>>2]|0)<(e|0)){m=k+(h+1<<2)|0;n=l+-1-h|0}else{m=k;n=h}if(!n){j=m;break}else{k=m;l=n}}}if((j|0)==(a|0)){i=d;return}if((e|0)<(c[j>>2]|0)){i=d;return}e=j-g>>2;g=b+(e<<2)|0;j=e+1|0;e=b+(j<<2)|0;if((e|0)==(a|0))o=g;else{n=e;l=g;while(1){c[l>>2]=c[n>>2];n=n+4|0;if((n|0)==(a|0))break;else l=l+4|0}o=b+(((a+-4-e|0)>>>2)+j<<2)|0}if((a|0)==(o|0)){i=d;return}c[f>>2]=a+(~((a+-4-o|0)>>>2)<<2);i=d;return}function v2d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[b>>2]|0;l=k;m=(c[d>>2]|0)-l>>2;d=k+(m<<2)|0;n=b+4|0;o=c[n>>2]|0;p=b+8|0;q=c[p>>2]|0;if(o>>>0<q>>>0){if((d|0)==(o|0)){if(d)c[d>>2]=c[e>>2];c[n>>2]=k+(m+1<<2);r=d;c[a>>2]=r;i=f;return}s=o-(k+(m+1<<2))>>2;t=k+(s+m<<2)|0;if(t>>>0<o>>>0){u=(o+(0-s<<2)+~d|0)>>>2;v=o;w=t;while(1){if(v)c[v>>2]=c[w>>2];w=w+4|0;if(w>>>0>=o>>>0)break;else v=v+4|0}v=o+(u+1<<2)|0;c[n>>2]=v;x=v}else x=o;if(s){s=t;t=o;do{t=t+-4|0;s=s+-4|0;c[t>>2]=c[s>>2]}while((s|0)!=(d|0))}if(d>>>0>e>>>0)y=e;else y=x>>>0>e>>>0?e+4|0:e;c[d>>2]=c[y>>2];r=d;c[a>>2]=r;i=f;return}y=(o-l>>2)+1|0;if((y|0)<0)vxi(b);l=k;o=q-l|0;if(o>>2>>>0<1073741823){q=o>>1;o=q>>>0<y>>>0?y:q;q=d;y=q-l>>2;if(!o){z=0;A=q;B=0;C=y}else{D=o;E=y;F=q;G=22}}else{q=d;D=2147483647;E=q-l>>2;F=q;G=22}if((G|0)==22){c[h>>2]=54;c[g+0>>2]=c[h+0>>2];z=D;A=F;B=cOb(D<<2,16,g,0,3653512,80)|0;C=E}E=B+(C<<2)|0;D=B+(z<<2)|0;do if((C|0)==(z|0)){if((C|0)>0){H=D;I=B+(((C+1|0)/-2|0)+C<<2)|0;break}F=(C|0)==0?1:C<<1;c[h>>2]=54;c[g+0>>2]=c[h+0>>2];G=cOb(F<<2,16,g,0,3653512,80)|0;q=G+(F>>>2<<2)|0;l=G+(F<<2)|0;if(!B){H=l;I=q}else{c[h>>2]=54;c[g+0>>2]=c[h+0>>2];eOb(B,g);H=l;I=q}}else{H=D;I=E}while(0);if(I)c[I>>2]=c[e>>2];e=I+4|0;E=c[b>>2]|0;if((E|0)==(d|0))J=I;else{D=k+(m+-1<<2)-E|0;m=d;k=I;while(1){m=m+-4|0;c[k+-4>>2]=c[m>>2];if((m|0)==(E|0))break;else k=k+-4|0}J=I+(~(D>>>2)<<2)|0}D=c[n>>2]|0;if((D|0)==(d|0))K=e;else{k=D+-4-A|0;A=d;d=I;E=e;while(1){c[d+4>>2]=c[A>>2];A=A+4|0;if((A|0)==(D|0))break;else{e=E;E=d+8|0;d=e}}K=I+((k>>>2)+2<<2)|0}k=c[b>>2]|0;c[b>>2]=J;c[n>>2]=K;c[p>>2]=H;if(!k){r=I;c[a>>2]=r;i=f;return}c[j>>2]=54;c[g+0>>2]=c[j+0>>2];eOb(k,g);r=I;c[a>>2]=r;i=f;return}function w2d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[153074];c[e+0>>2]=c[f+0>>2];f=cOb(6936,16,e,0,3653512,47)|0;if(!(a&1)){e=0;g=2;while(1){c[f+(e<<2)>>2]=g+17;c[f+(e+1<<2)>>2]=g;h=(g|1)+17|0;c[f+(e+2<<2)>>2]=h;c[f+(e+3<<2)>>2]=g;j=g;g=g+2|0;c[f+(e+4<<2)>>2]=g;c[f+(e+5<<2)>>2]=h;c[f+(e+6<<2)>>2]=g;c[f+(e+7<<2)>>2]=j+19;c[f+(e+8<<2)>>2]=h;if((g|0)>=14){k=54;l=1;break}else e=e+9|0}}else{k=0;l=0}if(!(a&2)){e=k;g=2;while(1){c[f+(e<<2)>>2]=g+255;h=(g|1)+255|0;c[f+(e+1<<2)>>2]=h;j=g+272|0;c[f+(e+2<<2)>>2]=j;c[f+(e+3<<2)>>2]=j;c[f+(e+4<<2)>>2]=h;j=g+274|0;c[f+(e+5<<2)>>2]=j;c[f+(e+6<<2)>>2]=j;c[f+(e+7<<2)>>2]=h;c[f+(e+8<<2)>>2]=g+257;g=g+2|0;if((g|0)>=14)break;else e=e+9|0}m=k+54|0;n=15}else{m=k;n=16}if(!(a&4)){k=m;e=2;while(1){g=e*17|0;h=g+16|0;c[f+(k<<2)>>2]=h;j=((e|1)*17|0)+15|0;c[f+(k+1<<2)>>2]=j;c[f+(k+2<<2)>>2]=g+15;c[f+(k+3<<2)>>2]=j;c[f+(k+4<<2)>>2]=h;h=g+50|0;c[f+(k+5<<2)>>2]=h;c[f+(k+6<<2)>>2]=h;c[f+(k+7<<2)>>2]=g+49;c[f+(k+8<<2)>>2]=j;e=e+2|0;if((e|0)>=14)break;else k=k+9|0}o=m+54|0;p=15}else{o=m;p=16}if(!(a&8)){m=o;k=2;while(1){e=k*17|0;c[f+(m<<2)>>2]=e;c[f+(m+1<<2)>>2]=e|1;j=((k|1)*17|0)+1|0;c[f+(m+2<<2)>>2]=j;c[f+(m+3<<2)>>2]=j;g=e+34|0;c[f+(m+4<<2)>>2]=g;c[f+(m+5<<2)>>2]=e;c[f+(m+6<<2)>>2]=g;c[f+(m+7<<2)>>2]=j;c[f+(m+8<<2)>>2]=e+35;k=k+2|0;if((k|0)>=14)break;else m=m+9|0}q=o+54|0;r=1}else{q=o;r=0}if((a&5|0)==5)s=q;else s=y2d(f,q,0,a)|0;if((a&6|0)==6)t=s;else t=y2d(f,s,1,a)|0;if((a&9|0)==9)u=t;else u=y2d(f,t,2,a)|0;if((a&10|0)==10)v=u;else v=y2d(f,u,3,a)|0;if(l>>>0>=n>>>0){a=r;do a=a+1|0;while((a|0)<(p|0));w=v;c[b>>2]=w;i=d;return f|0}a=l+1|0;u=((n>>>0>a>>>0?n:a)*6|0)-(0-l&6)|0;a=v;v=r;while(1){r=v;v=v+1|0;t=a;s=l;while(1){q=s*17|0;o=q+r|0;c[f+(t<<2)>>2]=o;c[f+(t+1<<2)>>2]=q+v;s=s+1|0;q=s*17|0;m=q+v|0;c[f+(t+2<<2)>>2]=m;c[f+(t+3<<2)>>2]=o;c[f+(t+4<<2)>>2]=m;c[f+(t+5<<2)>>2]=q+r;if((s|0)>=(n|0))break;else t=t+6|0}t=u+a|0;if((v|0)>=(p|0)){w=t;break}else a=t}c[b>>2]=w;i=d;return f|0}function x2d(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+8|0;j=e+4|0;k=e;l=a&15;a=721216+(l<<2)|0;if(c[(c[a>>2]|0)+4>>2]|0){m=c[a>>2]|0;n=c[m>>2]|0;c[d>>2]=n;o=m+4|0;p=c[o>>2]|0;i=e;return p|0}q=w2d(l,d,0)|0;c[h>>2]=0;l=h+4|0;c[l>>2]=0;c[h+8>>2]=0;KHc(q,c[d>>2]|0,h)|0;c[j>>2]=c[153074];c[f+0>>2]=c[j+0>>2];eOb(q,f);q=(c[l>>2]|0)-(c[h>>2]|0)|0;c[d>>2]=q>>2;c[k>>2]=c[153074];c[f+0>>2]=c[k+0>>2];k=cOb(q>>1,16,f,0,3653512,119)|0;q=c[d>>2]|0;j=c[h>>2]|0;if(!q)r=0;else{h=0;do{b[k+(h<<1)>>1]=c[j+(h<<2)>>2];h=h+1|0}while(h>>>0<q>>>0);r=q}q=c[a>>2]|0;c[q>>2]=r;c[q+4>>2]=k;if(!j){m=c[a>>2]|0;n=c[m>>2]|0;c[d>>2]=n;o=m+4|0;p=c[o>>2]|0;i=e;return p|0}k=c[l>>2]|0;if((k|0)!=(j|0))c[l>>2]=k+(~((k+-4-j|0)>>>2)<<2);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(j,f);m=c[a>>2]|0;n=c[m>>2]|0;c[d>>2]=n;o=m+4|0;p=c[o>>2]|0;i=e;return p|0}function y2d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;if(!d){g=1;h=1;j=1;k=-1;l=4;m=1;n=15}else if((d|0)==2){g=0;h=1;j=1;k=1;l=8;m=1;n=1}else if((d|0)==3){g=1;h=2;j=-1;k=1;l=8;m=15;n=1}else{g=0;h=2;j=-1;k=-1;l=4;m=15;n=15}d=(h&e|0)!=0&1;h=(l&e|0)==0?d:d|2;if((h|0)==1){d=(m*17|0)+n|0;e=a+(b<<2)|0;c[e>>2]=d;l=(m-j|0)*17|0;o=n-k|0;p=l+o|0;q=a+(b+1<<2)|0;c[q>>2]=p;c[a+(b+2<<2)>>2]=l+n;l=(j+m|0)*17|0;r=l+o|0;o=a+(b+3<<2)|0;c[o>>2]=r;s=a+(b+4<<2)|0;c[s>>2]=d;c[a+(b+5<<2)>>2]=l+n;l=a+(b+6<<2)|0;c[l>>2]=d;t=a+(b+7<<2)|0;c[t>>2]=r;u=b+9|0;c[a+(b+8<<2)>>2]=p;if(!g){v=u;i=f;return v|0}c[e>>2]=p;c[q>>2]=d;c[o>>2]=d;c[s>>2]=r;c[l>>2]=r;c[t>>2]=d;v=u;i=f;return v|0}u=m*17|0;if((h|0)==2){h=k+n|0;d=h+u|0;t=a+(b<<2)|0;c[t>>2]=d;r=u+n|0;l=a+(b+1<<2)|0;c[l>>2]=r;s=(m-j|0)*17|0;o=s+h|0;c[a+(b+2<<2)>>2]=o;h=a+(b+3<<2)|0;c[h>>2]=r;q=n-k|0;p=s+q|0;s=a+(b+4<<2)|0;c[s>>2]=p;c[a+(b+5<<2)>>2]=o;o=a+(b+6<<2)|0;c[o>>2]=p;e=a+(b+7<<2)|0;c[e>>2]=r;w=b+9|0;c[a+(b+8<<2)>>2]=q+u;if(!g){v=w;i=f;return v|0}c[t>>2]=r;c[l>>2]=d;c[h>>2]=p;c[s>>2]=r;c[o>>2]=r;c[e>>2]=p;v=w;i=f;return v|0}else{w=u+n|0;p=a+(b<<2)|0;c[p>>2]=w;e=(m-j|0)*17|0;r=k+n|0;o=e+r|0;s=a+(b+1<<2)|0;c[s>>2]=o;c[a+(b+2<<2)>>2]=r+u;u=(j+m|0)*17|0;m=n-k|0;k=u+m|0;j=a+(b+3<<2)|0;c[j>>2]=k;r=a+(b+4<<2)|0;c[r>>2]=w;c[a+(b+5<<2)>>2]=u+n;n=a+(b+6<<2)|0;c[n>>2]=w;u=e+m|0;m=a+(b+7<<2)|0;c[m>>2]=u;c[a+(b+8<<2)>>2]=o;e=a+(b+9<<2)|0;c[e>>2]=w;h=a+(b+10<<2)|0;c[h>>2]=k;d=b+12|0;c[a+(b+11<<2)>>2]=u;if(!g){v=d;i=f;return v|0}c[p>>2]=o;c[s>>2]=w;c[j>>2]=w;c[r>>2]=k;c[n>>2]=u;c[m>>2]=w;c[e>>2]=k;c[h>>2]=w;v=d;i=f;return v|0}return 0}function z2d(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=0;do{c[d>>2]=0;c[b+0>>2]=c[d+0>>2];f=bOb(8,b,0,16,3653512,31)|0;c[f>>2]=0;c[f+4>>2]=0;c[721216+(e<<2)>>2]=f;e=e+1|0}while((e|0)!=16);i=a;return}function A2d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;f=0;do{g=721216+(f<<2)|0;h=c[g>>2]|0;if((h|0)!=0?(j=c[h+4>>2]|0,(j|0)!=0):0){c[d>>2]=c[153074];c[b+0>>2]=c[d+0>>2];eOb(j,b)}c[e>>2]=0;c[b+0>>2]=c[e+0>>2];eOb(h,b);c[g>>2]=0;f=f+1|0}while((f|0)!=16);i=a;return}function B2d(d,e,f,h){d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;j=e+8|0;k=e+4|0;l=e;m=d+16|0;n=d+44|0;g[n>>2]=ea(0.0);g[d+48>>2]=ea(0.0);g[d+52>>2]=ea(0.0);g[d+60>>2]=ea(0.0);g[d+64>>2]=ea(0.0);g[d+68>>2]=ea(0.0);o=d+104|0;c[o>>2]=0;p=d+0|0;q=p+40|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));r=c[153116]|0;c[d+144>>2]=0;c[d+148>>2]=r;c[d+152>>2]=0;c[d+156>>2]=0;p=d+288|0;q=p+36|0;do{a[p>>0]=0;p=p+1|0}while((p|0)<(q|0));c[k>>2]=c[f>>2];r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(j,r,k);s=c[j>>2]|0;t=c[r+28>>2]|0;if((s|0)==-1){u=t+(c[r+32>>2]<<3)|0;break}else{u=t+(s<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[u+4>>2]|0,(r|0)!=0):0)v=r;else w=9}else w=9;if((w|0)==9)v=hQb(c[f>>2]|0)|0;r=v+312|0;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=c[f>>2];r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(j,r,l);m=c[j>>2]|0;v=c[r+28>>2]|0;if((m|0)==-1){x=v+(c[r+32>>2]<<3)|0;break}else{x=v+(m<<3)|0;break}}else x=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((x|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[x+4>>2]|0,(r|0)!=0):0)y=r;else w=18}else w=18;if((w|0)==18)y=hQb(c[f>>2]|0)|0;c[d+40>>2]=c[y+304>>2];c[o>>2]=c[f>>2];c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];h=d+140|0;b[h+2>>1]=255;b[h>>1]=255;g[d+108>>2]=ea(1.0);g[d+112>>2]=ea(1.0);g[d+116>>2]=ea(0.0);g[d+120>>2]=ea(0.0);g[d+124>>2]=ea(1.0);g[d+128>>2]=ea(1.0);g[d+132>>2]=ea(0.0);g[d+136>>2]=ea(0.0);p=d+160|0;q=p+128|0;do{c[p>>2]=0;p=p+4|0}while((p|0)<(q|0));p=a[575993]|0;q=da(Xic(a[575992]|0)|0,p&255)|0;p=a[575995]|0;h=(da(Xic(a[575994]|0)|0,p&255)|0)+q|0;p=a[575999]|0;n=(da(Xic(a[575998]|0)|0,p&255)|0)+h|0;a[d+290>>0]=a[575992]|0;a[d+291>>0]=a[575993]|0;a[d+294>>0]=a[575994]|0;a[d+295>>0]=a[575995]|0;a[d+293>>0]=q;a[d+302>>0]=a[575998]|0;a[d+303>>0]=a[575999]|0;a[d+301>>0]=h;c[d+304>>2]=c[d+300>>2];c[d+324>>2]=n&255;C2d(d);i=e;return}function C2d(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=0,C=0;b=i;i=i+48|0;d=b+32|0;e=b+24|0;f=b;h=a+104|0;c[e>>2]=c[h>>2];j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(d,j,e);k=c[d>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=9}else o=9;if((o|0)==9)n=hQb(c[h>>2]|0)|0;h=n+232|0;n=(T0d(h,0,0,c[h+72>>2]|0)|0)+1|0;o=a+28|0;j=a+32|0;m=c[j>>2]|0;d=c[o>>2]|0;e=(m-d|0)/124|0;if(n>>>0<=e>>>0){if(n>>>0<e>>>0?(k=d+(n*124|0)|0,(m|0)!=(k|0)):0)c[j>>2]=m+(~(((m+-124-k|0)>>>0)/124|0)*124|0)}else d3d(o,n-e|0);e=a+40|0;n=c[e>>2]|0;if((n|0)<0){i=b;return}k=a+44|0;m=a+48|0;j=a+52|0;a=n;n=0;while(1){if((a-n|0)==31)p=a;else{d=(n|0)>0;l=a;q=0;while(1){r=l-n|0;a:do if((r|0)==31)s=l;else{if(d){t=l;u=r;v=0}else{w=r;x=0;while(1){y=(q<<w)+x|0;z=c[o>>2]|0;c[z+(y*124|0)+84>>2]=x;c[z+(y*124|0)+88>>2]=q;c[z+(y*124|0)+92>>2]=n;A=ea(Z0d(h,x,q,n));z=c[o>>2]|0;g[z+(y*124|0)+72>>2]=A;B=z+(y*124|0)+96|0;c1d(f,h,x,q,n);c[B+0>>2]=c[f+0>>2];c[B+4>>2]=c[f+4>>2];c[B+8>>2]=c[f+8>>2];c[B+12>>2]=c[f+12>>2];c[B+16>>2]=c[f+16>>2];c[B+20>>2]=c[f+20>>2];B=c[o>>2]|0;A=ea(g[k>>2]);z=B+(y*124|0)+96|0;g[z>>2]=ea(A+ea(g[z>>2]));A=ea(g[m>>2]);z=B+(y*124|0)+100|0;g[z>>2]=ea(A+ea(g[z>>2]));A=ea(g[j>>2]);z=B+(y*124|0)+104|0;g[z>>2]=ea(A+ea(g[z>>2]));x=x+1|0;z=c[e>>2]|0;w=z-n|0;if((x|0)>=(1<<w|0)){s=z;break a}}}while(1){w=0;x=0;while(1){z=t-w|0;y=(1<<z<<z)+x|0;w=w+1|0;if((w|0)==(n|0)){C=y;break}else x=y}x=(q<<u)+v+C|0;w=c[o>>2]|0;c[w+(x*124|0)+84>>2]=v;c[w+(x*124|0)+88>>2]=q;c[w+(x*124|0)+92>>2]=n;A=ea(Z0d(h,v,q,n));w=c[o>>2]|0;g[w+(x*124|0)+72>>2]=A;y=w+(x*124|0)+96|0;c1d(f,h,v,q,n);c[y+0>>2]=c[f+0>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];c[y+12>>2]=c[f+12>>2];c[y+16>>2]=c[f+16>>2];c[y+20>>2]=c[f+20>>2];y=c[o>>2]|0;A=ea(g[k>>2]);w=y+(x*124|0)+96|0;g[w>>2]=ea(A+ea(g[w>>2]));A=ea(g[m>>2]);w=y+(x*124|0)+100|0;g[w>>2]=ea(A+ea(g[w>>2]));A=ea(g[j>>2]);w=y+(x*124|0)+104|0;g[w>>2]=ea(A+ea(g[w>>2]));v=v+1|0;w=c[e>>2]|0;u=w-n|0;if((v|0)>=(1<<u|0)){s=w;break}else t=w}}while(0);q=q+1|0;if((q|0)>=(1<<s-n|0)){p=s;break}else l=s}}if((n|0)<(p|0)){a=p;n=n+1|0}else break}i=b;return}function D2d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+28|0;h=c[g>>2]|0;j=b+32|0;k=c[j>>2]|0;if((h|0)!=(k|0)){l=h;do{h=l+4|0;m=c[h>>2]|0;if(m){H2d(b,m);c[l>>2]=0;c[h>>2]=0;c[l+8>>2]=0}h=l+120|0;a[h>>0]=a[h>>0]&-7;l=l+124|0}while((l|0)!=(k|0))}k=b+144|0;l=b+152|0;if(!(c[l>>2]|0))n=0;else{h=0;do{m=ync()|0;In[c[(c[m>>2]|0)+296>>2]&4095](m,c[(c[k>>2]|0)+(h<<2)>>2]|0);h=h+1|0}while(h>>>0<(c[l>>2]|0)>>>0);n=0}do{l=b+(n<<3)+164|0;if(c[l>>2]|0){h=ync()|0;In[c[(c[h>>2]|0)+276>>2]&4095](h,c[l>>2]|0)}n=n+1|0}while((n|0)<16);if((c[b+156>>2]|0)>-1){n=c[k>>2]|0;c[f>>2]=c[b+148>>2];c[e+0>>2]=c[f+0>>2];eOb(n,e);c[k>>2]=0}k=c[g>>2]|0;if(!k){i=d;return}g=c[j>>2]|0;if((g|0)!=(k|0))c[j>>2]=g+(~(((g+-124-k|0)>>>0)/124|0)*124|0);ACi(k);i=d;return}function E2d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[a>>2]=d;c[a+4>>2]=e;c[a+8>>2]=f;c[a+12>>2]=b;return}function F2d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e;k=a+(b<<3)+160|0;l=a+(b<<3)+164|0;if((c[l>>2]|0)==0?(a=x2d(b,h)|0,c[j>>2]=0,b=j+4|0,c[b>>2]=0,c[j+8>>2]=0,NHc(a,c[h>>2]|0,j),h=ync()|0,a=mo[c[(c[h>>2]|0)+260>>2]&4095](h)|0,h=ync()|0,m=c[j>>2]|0,Wn[c[(c[h>>2]|0)+264>>2]&127](h,a,0,0,(c[b>>2]|0)-m|0,m,0),m=c[b>>2]|0,h=c[j>>2]|0,j=h,c[k>>2]=m-j>>1,c[l>>2]=a,(h|0)!=0):0){if((m|0)!=(h|0))c[b>>2]=m+(~((m+-2-j|0)>>>1)<<1);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(h,f)}if(!d){n=c[l>>2]|0;i=e;return n|0}c[d>>2]=c[k>>2];n=c[l>>2]|0;i=e;return n|0}function G2d(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+48|0;k=j+16|0;l=j+32|0;m=j+36|0;n=j+40|0;o=j+8|0;p=j;q=j+24|0;r=b+152|0;s=c[r>>2]|0;if(!s){t=ync()|0;u=mo[c[(c[t>>2]|0)+280>>2]&4095](t)|0}else{t=c[b+144>>2]|0;v=c[t>>2]|0;aFi(t|0,t+4|0,(s<<2)+-4|0)|0;c[r>>2]=(c[r>>2]|0)+-1;u=v}v=b+324|0;r=(c[v>>2]|0)*289|0;s=r+31|0;if(s>>>0<2e3)if(!r){w=0;x=0}else{t=i;i=i+((1*s|0)+15&-16)|0;w=0;x=t}else{c[n>>2]=c[153134];c[k+0>>2]=c[n+0>>2];n=cOb(s,16,k,0,3653512,143)|0;w=n;x=n}n=x+31&-32;x=b+104|0;c[l>>2]=c[x>>2];s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(k,s,l);t=c[k>>2]|0;y=c[s+28>>2]|0;if((t|0)==-1){z=y+(c[s+32>>2]<<3)|0;break}else{z=y+(t<<3)|0;break}}else z=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((z|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[z+4>>2]|0,(s|0)!=0):0)A=s;else B=16}else B=16;if((B|0)==16)A=hQb(c[x>>2]|0)|0;x=d[b+293>>0]|0;B=d[b+301>>0]|0;s=c[v>>2]|0;c[o>>2]=n;c[o+4>>2]=s;c[p>>2]=n+x;c[p+4>>2]=s;c[q>>2]=n+B;c[q+4>>2]=s;a1d(A+232|0,o,p,q,e,f,g,b);b=ync()|0;Wn[c[(c[b>>2]|0)+284>>2]&127](b,u,1,0,r,n,0);if(h)c[h>>2]=289;c[a>>2]=u;c[a+4>>2]=c[v>>2];if(!w){i=j;return}c[m>>2]=c[153134];c[k+0>>2]=c[m+0>>2];eOb(w,k);i=j;return}function H2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+144|0;h=a+152|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;k=a+156|0;l=c[k>>2]|0;m=l&2147483647;if(j>>>0<=m>>>0){n=j;o=n+-1|0;p=c[g>>2]|0;q=p+(o<<2)|0;c[q>>2]=b;i=d;return}j=l<<1;r=(j|0)==0?1:j;do if(m>>>0<r>>>0)if((l|0)>-1){c[k>>2]=r;j=c[g>>2]|0;c[f>>2]=c[a+148>>2];c[e+0>>2]=c[f+0>>2];c[g>>2]=hOb(j,r<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+148>>2];c[e+0>>2]=c[f+0>>2];j=cOb(r<<2,4,e,0,3653512,352)|0;YEi(j|0,c[g>>2]|0,c[h>>2]<<2|0)|0;c[k>>2]=r;c[g>>2]=j;break}while(0);n=c[h>>2]|0;o=n+-1|0;p=c[g>>2]|0;q=p+(o<<2)|0;c[q>>2]=b;i=d;return}function I2d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b;e=a+320|0;f=c[e>>2]|0;if(f){g=f;i=b;return g|0}f=uic()|0;Hic(d,a+288|0);a=sic(f,d)|0;c[e>>2]=a;g=a;i=b;return g|0}function J2d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;if((e|0)<0){g=0;i=f;return g|0}else{h=a;j=b;k=d}a:while(1){d=(j|0)==-1;b:do if((j|0)<0){b=h;a=k;while(1){l=c[b+40>>2]|0;if((l|0)<(e|0)){g=0;m=28;break a}n=1<<l-e;if(d?(l=c[b+12>>2]|0,(l|0)!=0):0){o=n;p=l;q=a;break b}if((n|0)==(j|0)?(l=c[b+4>>2]|0,(l|0)!=0):0){h=l;j=0;k=a;continue a}if((n|0)==(a|0)?(l=c[b>>2]|0,(l|0)!=0):0){b=l;a=0;continue}if((a|0)!=-1){g=0;m=28;break a}l=c[b+8>>2]|0;if(!l){g=0;m=28;break a}b=l;a=n+-1|0}}else{a=h;b=k;while(1){n=c[a+40>>2]|0;if((n|0)<(e|0)){g=0;m=28;break a}l=n-e|0;r=1<<l;if((b|0)>-1&(r|0)>(j|0)&(r|0)>(b|0)){s=l;t=n;u=a;v=j;w=b;m=25;break a}if(d?(n=c[a+12>>2]|0,(n|0)!=0):0){o=r;p=n;q=b;break b}if((r|0)==(j|0)?(n=c[a+4>>2]|0,(n|0)!=0):0){h=n;j=0;k=b;continue a}if((r|0)==(b|0)?(n=c[a>>2]|0,(n|0)!=0):0){a=n;b=0;continue}if((b|0)!=-1){g=0;m=28;break a}n=c[a+8>>2]|0;if(!n){g=0;m=28;break a}a=n;b=r+-1|0}}while(0);h=p;j=o+-1|0;k=q}if((m|0)==25){if((e|0)>0){q=0;k=0;while(1){o=t-q|0;j=(1<<o<<o)+k|0;q=q+1|0;if((q|0)==(e|0)){x=j;break}else k=j}}else x=0;g=(c[u+28>>2]|0)+(((w<<s)+v+x|0)*124|0)|0;i=f;return g|0}else if((m|0)==28){i=f;return g|0}return 0}function K2d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((e|0)>=0?(h=c[a+40>>2]|0,(h|0)>=(e|0)):0){j=h-e|0;k=1<<j;if((b|0)>=0?(d|0)>-1&(k|0)>(b|0)&(k|0)>(d|0):0){c[f>>2]=a;if((e|0)>0){l=0;m=0;while(1){n=h-l|0;o=(1<<n<<n)+m|0;l=l+1|0;if((l|0)==(e|0)){p=o;break}else m=o}}else p=0;q=(c[a+28>>2]|0)+(((d<<j)+b+p|0)*124|0)|0;i=g;return q|0}if((b|0)==-1?(p=a+12|0,j=c[p>>2]|0,(j|0)!=0):0){c[f>>2]=j;q=J2d(c[p>>2]|0,k+-1|0,d,e)|0;i=g;return q|0}if((k|0)==(b|0)?(p=a+4|0,j=c[p>>2]|0,(j|0)!=0):0){c[f>>2]=j;q=J2d(c[p>>2]|0,0,d,e)|0;i=g;return q|0}if((k|0)==(d|0)?(p=c[a>>2]|0,(p|0)!=0):0){c[f>>2]=p;q=J2d(c[a>>2]|0,b,0,e)|0;i=g;return q|0}if((d|0)==-1?(d=a+8|0,a=c[d>>2]|0,(a|0)!=0):0){c[f>>2]=a;q=J2d(c[d>>2]|0,b,k+-1|0,e)|0;i=g;return q|0}c[f>>2]=0;q=0;i=g;return q|0}c[f>>2]=0;q=0;i=g;return q|0}function L2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=M2d(a,b,0)|0;if(!e)f=1;else f=((c[e+76>>2]|0)+-1|0)>>>0<2&1;e=M2d(a,b,1)|0;if(!e)g=f|2;else g=((c[e+76>>2]|0)+-1|0)>>>0<2?f|2:f;f=M2d(a,b,2)|0;if(!f)h=g|4;else h=((c[f+76>>2]|0)+-1|0)>>>0<2?g|4:g;g=M2d(a,b,3)|0;if(!g){i=d;return h|8|0}else{i=d;return (((c[g+76>>2]|0)+-1|0)>>>0<2?h|8:h)|0}return 0}function M2d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((d|0)==3){f=J2d(a,c[b+84>>2]|0,(c[b+88>>2]|0)+-1|0,c[b+92>>2]|0)|0;i=e;return f|0}else if((d|0)!=2){g=c[b+84>>2]|0;h=c[b+88>>2]|0;j=c[b+92>>2]|0;if(!d){f=J2d(a,g+-1|0,h,j)|0;i=e;return f|0}else{f=J2d(a,g+1|0,h,j)|0;i=e;return f|0}}else{f=J2d(a,c[b+84>>2]|0,(c[b+88>>2]|0)+1|0,c[b+92>>2]|0)|0;i=e;return f|0}return 0}function N2d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)==3){g=K2d(a,c[b+84>>2]|0,(c[b+88>>2]|0)+-1|0,c[b+92>>2]|0,e)|0;i=f;return g|0}else if((d|0)!=2){h=c[b+84>>2]|0;j=c[b+88>>2]|0;k=c[b+92>>2]|0;if(!d){g=K2d(a,h+-1|0,j,k,e)|0;i=f;return g|0}else{g=K2d(a,h+1|0,j,k,e)|0;i=f;return g|0}}else{g=K2d(a,c[b+84>>2]|0,(c[b+88>>2]|0)+1|0,c[b+92>>2]|0,e)|0;i=f;return g|0}return 0}function O2d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((d|0)==1){f=J2d(a,c[b+84>>2]<<1|1,c[b+88>>2]<<1,(c[b+92>>2]|0)+-1|0)|0;i=e;return f|0}else if(d){g=c[b+84>>2]<<1;h=c[b+88>>2]|0;j=c[b+92>>2]|0;if((d|0)==2){f=J2d(a,g,h<<1|1,j+-1|0)|0;i=e;return f|0}else{f=J2d(a,g|1,h<<1|1,j+-1|0)|0;i=e;return f|0}}else{f=J2d(a,c[b+84>>2]<<1,c[b+88>>2]<<1,(c[b+92>>2]|0)+-1|0)|0;i=e;return f|0}return 0}function P2d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=ea(f);var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im;h=i;i=i+32|0;j=h+16|0;k=h;if((d|0)<0)l=0;else{m=c[a+40>>2]|0;l=(m|0)<(d|0)?m:d}n=ea(g[b+456>>2]);o=ea(n*ea(+X(+ea(ea(ea(ea(ea(g[b+452>>2])*ea(.5))/ea(360.0))*ea(2.0))*ea(3.14159274)))));u$b(j,b,1);p=ea(ea(n/ea(S(ea(o))))/ea(ea(e*ea(2.0))/ea(g[j+12>>2])));j=(c[a+32>>2]|0)+-124|0;d=a+60|0;rGc(k,BTb(c[b+24>>2]|0)|0);c[d+0>>2]=c[k+0>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[a+72>>2]=l;g[a+76>>2]=p;g[a+80>>2]=ea(f*f);Q2d(a,j);i=h;return}function Q2d(b,d){b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=0,m=Im,n=Im,o=Im,p=Im,q=0;e=i;f=ea(g[b+60>>2]);h=ea(f-ea(g[d+96>>2]));f=ea(g[b+64>>2]);j=ea(f-ea(g[d+100>>2]));f=ea(g[b+68>>2]);k=ea(f-ea(g[d+104>>2]));l=d+108|0;f=ea(g[l>>2]);if(!(h<ea(-f)))if(h>f){m=ea(h-f);n=ea(ea(m*m)+ea(0.0))}else n=ea(0.0);else{m=ea(h+f);n=ea(ea(m*m)+ea(0.0))}m=ea(g[l+4>>2]);if(!(j<ea(-m)))if(j>m){f=ea(j-m);o=ea(n+ea(f*f))}else o=n;else{f=ea(j+m);o=ea(n+ea(f*f))}f=ea(g[l+8>>2]);if(!(k<ea(-f)))if(k>f){n=ea(k-f);p=ea(o+ea(n*n))}else p=o;else{n=ea(k+f);p=ea(o+ea(n*n))}n=ea(g[b+76>>2]);o=ea(n*ea(g[d+72>>2]));if(!(p>ea(o*o))?(c[d+92>>2]|0)!=(c[b+72>>2]|0):0){c[d+76>>2]=1;Q2d(b,O2d(b,d,0)|0);Q2d(b,O2d(b,d,1)|0);Q2d(b,O2d(b,d,2)|0);Q2d(b,O2d(b,d,3)|0);i=e;return}c[d+76>>2]=2;l=d+120|0;q=p<ea(g[b+80>>2])&1;a[l>>0]=a[l>>0]&-2|q;Y2d(b,d,0);i=e;return}function R2d(a){a=a|0;var b=0;b=i;S2d(a,(c[a+32>>2]|0)+-124|0);i=b;return}function S2d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[b+76>>2]|0;if((f|0)==2){g=N2d(a,b,0,e)|0;if((((g|0)!=0?(c[g+76>>2]|0)==0:0)?(h=c[e>>2]|0,j=c[g+92>>2]|0,(j|0)!=(c[(c[h+32>>2]|0)+-32>>2]|0)):0)?(k=J2d(h,(c[g+84>>2]|0)/2|0,(c[g+88>>2]|0)/2|0,j+1|0)|0,(c[k+76>>2]|0)==0):0)_2d(h,k);k=N2d(a,b,1,e)|0;if((((k|0)!=0?(c[k+76>>2]|0)==0:0)?(h=c[e>>2]|0,j=c[k+92>>2]|0,(j|0)!=(c[(c[h+32>>2]|0)+-32>>2]|0)):0)?(g=J2d(h,(c[k+84>>2]|0)/2|0,(c[k+88>>2]|0)/2|0,j+1|0)|0,(c[g+76>>2]|0)==0):0)_2d(h,g);g=N2d(a,b,2,e)|0;if((((g|0)!=0?(c[g+76>>2]|0)==0:0)?(h=c[e>>2]|0,j=c[g+92>>2]|0,(j|0)!=(c[(c[h+32>>2]|0)+-32>>2]|0)):0)?(k=J2d(h,(c[g+84>>2]|0)/2|0,(c[g+88>>2]|0)/2|0,j+1|0)|0,(c[k+76>>2]|0)==0):0)_2d(h,k);k=N2d(a,b,3,e)|0;if(!k){i=d;return}if(c[k+76>>2]|0){i=d;return}h=c[e>>2]|0;e=c[k+92>>2]|0;if((e|0)==(c[(c[h+32>>2]|0)+-32>>2]|0)){i=d;return}j=J2d(h,(c[k+84>>2]|0)/2|0,(c[k+88>>2]|0)/2|0,e+1|0)|0;if(c[j+76>>2]|0){i=d;return}_2d(h,j);i=d;return}else if(!f){i=d;return}else{S2d(a,O2d(a,b,0)|0);S2d(a,O2d(a,b,1)|0);S2d(a,O2d(a,b,2)|0);S2d(a,O2d(a,b,3)|0);i=d;return}}function T2d(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+16|0;l=k+8|0;m=k;n=(c[b+32>>2]|0)+-124|0;c[b+84>>2]=e;c[b+88>>2]=d;a[b+56>>0]=f&1;c[b+100>>2]=g;c[b+96>>2]=h;c[b+92>>2]=j;j=b+104|0;c[m>>2]=c[j>>2];h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(l,h,m);g=c[l>>2]|0;f=c[h+28>>2]|0;if((g|0)==-1){o=f+(c[h+32>>2]<<3)|0;break}else{o=f+(g<<3)|0;break}}else o=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((o|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[o+4>>2]|0,(h|0)!=0):0){p=h;q=p+232|0;U2d(b,n,q);i=k;return}}p=hQb(c[j>>2]|0)|0;q=p+232|0;U2d(b,n,q);i=k;return}function U2d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;h=d+76|0;j=c[h>>2]|0;if((j|0)==2){k=d+80|0;if((c[k>>2]|0)==2)l=ea(g[d+72>>2])==ea(x);else l=1;c3d(b,d,l,L2d(b,d)|0);a3d(b,d);if((c[k>>2]|0)!=1){m=c[h>>2]|0;n=d+80|0;c[n>>2]=m;i=f;return}$2d(b,O2d(b,d,0)|0);$2d(b,O2d(b,d,1)|0);$2d(b,O2d(b,d,2)|0);$2d(b,O2d(b,d,3)|0);m=c[h>>2]|0;n=d+80|0;c[n>>2]=m;i=f;return}k=c[d+80>>2]|0;if((j|0)==1){if((k|0)==2){j=d+4|0;l=c[j>>2]|0;if(l){H2d(b,l);c[d>>2]=0;c[j>>2]=0;c[d+8>>2]=0}j=d+120|0;a[j>>0]=a[j>>0]&-7}U2d(b,O2d(b,d,0)|0,e);U2d(b,O2d(b,d,1)|0,e);U2d(b,O2d(b,d,2)|0,e);U2d(b,O2d(b,d,3)|0,e);m=c[h>>2]|0;n=d+80|0;c[n>>2]=m;i=f;return}if((k|0)==1){$2d(b,O2d(b,d,0)|0);$2d(b,O2d(b,d,1)|0);$2d(b,O2d(b,d,2)|0);$2d(b,O2d(b,d,3)|0);m=c[h>>2]|0;n=d+80|0;c[n>>2]=m;i=f;return}else if((k|0)==2){k=d+4|0;e=c[k>>2]|0;if(e){H2d(b,e);c[d>>2]=0;c[k>>2]=0;c[d+8>>2]=0}k=d+120|0;a[k>>0]=a[k>>0]&-7;m=c[h>>2]|0;n=d+80|0;c[n>>2]=m;i=f;return}else{m=c[h>>2]|0;n=d+80|0;c[n>>2]=m;i=f;return}}function V2d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b+28>>2]|0;j=b+32|0;k=c[j>>2]|0;if((h|0)!=(k|0)){l=h;h=k;while(1){k=l+76|0;if((c[k>>2]|0)==2){m=l+4|0;n=c[m>>2]|0;if(n){H2d(b,n);c[l>>2]=0;c[m>>2]=0;c[l+8>>2]=0}m=l+120|0;a[m>>0]=a[m>>0]&-7;o=c[j>>2]|0}else o=h;c[k>>2]=0;c[l+80>>2]=0;l=l+124|0;if((l|0)==(o|0))break;else h=o}}o=b+16|0;h=b+104|0;c[g>>2]=c[h>>2];l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,g);j=c[e>>2]|0;k=c[l+28>>2]|0;if((j|0)==-1){p=k+(c[l+32>>2]<<3)|0;break}else{p=k+(j<<3)|0;break}}else p=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((p|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[p+4>>2]|0,(l|0)!=0):0)q=l;else r=15}else r=15;if((r|0)==15)q=hQb(c[h>>2]|0)|0;r=q+312|0;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[f>>2]=c[h>>2];r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(e,r,f);o=c[e>>2]|0;q=c[r+28>>2]|0;if((o|0)==-1){s=q+(c[r+32>>2]<<3)|0;break}else{s=q+(o<<3)|0;break}}else s=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((s|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[s+4>>2]|0,(r|0)!=0):0){t=r;u=t+232|0;v=u+72|0;w=c[v>>2]|0;x=b+40|0;c[x>>2]=w;C2d(b);i=d;return}}t=hQb(c[h>>2]|0)|0;u=t+232|0;v=u+72|0;w=c[v>>2]|0;x=b+40|0;c[x>>2]=w;C2d(b);i=d;return}function W2d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b+28>>2]|0;h=b+32|0;if((g|0)!=(c[h>>2]|0)){j=g;do{g=j+4|0;k=c[g>>2]|0;if(k){H2d(b,k);c[j>>2]=0;c[g>>2]=0;c[j+8>>2]=0}g=j+120|0;a[g>>0]=a[g>>0]|6;j=j+124|0}while((j|0)!=(c[h>>2]|0))}h=b+144|0;j=b+152|0;if(c[j>>2]|0){g=0;do{k=ync()|0;In[c[(c[k>>2]|0)+296>>2]&4095](k,c[(c[h>>2]|0)+(g<<2)>>2]|0);g=g+1|0}while(g>>>0<(c[j>>2]|0)>>>0)}g=b+156|0;if((c[g>>2]|0)>-1){k=c[h>>2]|0;c[f>>2]=c[b+148>>2];c[e+0>>2]=c[f+0>>2];eOb(k,e);c[h>>2]=0}c[j>>2]=0;c[g>>2]=0;g=0;do{j=b+(g<<3)+164|0;if(c[j>>2]|0){h=ync()|0;In[c[(c[h>>2]|0)+276>>2]&4095](h,c[j>>2]|0)}c[j>>2]=0;g=g+1|0}while((g|0)!=16);c[b+320>>2]=0;i=d;return}function X2d(a){a=a|0;return}function Y2d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!(c[b+92>>2]|0)){i=e;return}f=O2d(a,b,0)|0;g=f+76|0;if((c[g>>2]|0)!=(d|0)){c[g>>2]=d;Y2d(a,f,d)}f=O2d(a,b,1)|0;g=f+76|0;if((c[g>>2]|0)!=(d|0)){c[g>>2]=d;Y2d(a,f,d)}f=O2d(a,b,2)|0;g=f+76|0;if((c[g>>2]|0)!=(d|0)){c[g>>2]=d;Y2d(a,f,d)}f=O2d(a,b,3)|0;b=f+76|0;if((c[b>>2]|0)==(d|0)){i=e;return}c[b>>2]=d;Y2d(a,f,d);i=e;return}function Z2d(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+8|0;f=d;h=b+104|0;c[f>>2]=c[h>>2];j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(e,j,f);k=c[e>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=9}else o=9;if((o|0)==9)n=hQb(c[h>>2]|0)|0;h=n+232|0;n=c[b+28>>2]|0;o=b+32|0;if((n|0)==(c[o>>2]|0)){i=d;return}else p=n;do{g[p+72>>2]=ea(Z0d(h,c[p+84>>2]|0,c[p+88>>2]|0,c[p+92>>2]|0));n=p+120|0;a[n>>0]=a[n>>0]|2;p=p+124|0}while((p|0)!=(c[o>>2]|0));i=d;return}function _2d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=0;e=i;f=J2d(b,(c[d+84>>2]|0)/2|0,(c[d+88>>2]|0)/2|0,(c[d+92>>2]|0)+1|0)|0;d=f+76|0;h=c[d>>2]|0;if(!h){_2d(b,f);j=c[d>>2]|0}else j=h;if((j|0)!=2){i=e;return}j=b+60|0;h=b+64|0;k=b+68|0;l=b+80|0;m=0;do{n=O2d(b,f,m)|0;c[n+76>>2]=2;o=ea(g[j>>2]);p=ea(o-ea(g[n+96>>2]));o=ea(g[h>>2]);q=ea(o-ea(g[n+100>>2]));o=ea(g[k>>2]);r=ea(o-ea(g[n+104>>2]));s=n+108|0;o=ea(g[s>>2]);if(!(p<ea(-o)))if(p>o){t=ea(p-o);u=ea(ea(t*t)+ea(0.0))}else u=ea(0.0);else{t=ea(p+o);u=ea(ea(t*t)+ea(0.0))}t=ea(g[s+4>>2]);if(!(q<ea(-t)))if(q>t){o=ea(q-t);v=ea(u+ea(o*o))}else v=u;else{o=ea(q+t);v=ea(u+ea(o*o))}o=ea(g[s+8>>2]);if(!(r<ea(-o)))if(r>o){t=ea(r-o);w=ea(v+ea(t*t))}else w=v;else{t=ea(r+o);w=ea(v+ea(t*t))}s=n+120|0;x=w<ea(g[l>>2])&1;a[s>>0]=a[s>>0]&-2|x;Y2d(b,n,0);m=m+1|0}while((m|0)!=4);S2d(b,O2d(b,f,0)|0);S2d(b,O2d(b,f,1)|0);S2d(b,O2d(b,f,2)|0);S2d(b,O2d(b,f,3)|0);c[d>>2]=1;i=e;return}function $2d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d+80|0;g=c[f>>2]|0;if(!g){i=e;return}else if((g|0)==1){$2d(b,O2d(b,d,0)|0);$2d(b,O2d(b,d,1)|0);$2d(b,O2d(b,d,2)|0);$2d(b,O2d(b,d,3)|0)}else if((g|0)==2){g=d+4|0;h=c[g>>2]|0;if(h){H2d(b,h);c[d>>2]=0;c[g>>2]=0;c[d+8>>2]=0}g=d+120|0;a[g>>0]=a[g>>0]&-7}c[f>>2]=0;i=e;return}function a3d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=0,l=0;e=i;i=i+80|0;f=e+64|0;h=e;c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286];j=ea(g[b+44>>2]);g[f>>2]=ea(j+ea(g[f>>2]));j=ea(g[b+48>>2]);k=f+4|0;g[k>>2]=ea(j+ea(g[k>>2]));j=ea(g[b+52>>2]);k=f+8|0;g[k>>2]=ea(j+ea(g[k>>2]));kMc(h,f)|0;if(!(a[d+120>>0]&1)){b3d(b,d,h,c[b+92>>2]|0);i=e;return}f=c[b+96>>2]|0;if((f|0)<=0){i=e;return}k=b+100|0;l=0;do{b3d(b,d,h,c[(c[k>>2]|0)+(l<<2)>>2]|0);l=l+1|0}while((l|0)!=(f|0));i=e;return}function b3d(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;k=csd(c[179922]|0,252)|0;g1d(k);if(!g)l=0;else l=c[g+4>>2]|0;c[j>>2]=l;L3b(k,f,e+44|0,j,c[d+84>>2]|0,(a[d+56>>0]|0)!=0?2:0,1);h1d(k,d,e);e=d+140|0;i1d(k,b[e>>1]|0,d+108|0,0);i1d(k,b[e+2>>1]|0,d+124|0,1);g4b(k,c[d+88>>2]|0);i=h;return}function c3d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;h=g+32|0;j=g+24|0;k=g;if(e){e=d+44|0;l=b+104|0;c[j>>2]=c[l>>2];b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(h,b,j);m=c[h>>2]|0;n=c[b+28>>2]|0;if((m|0)==-1){o=n+(c[b+32>>2]<<3)|0;break}else{o=n+(m<<3)|0;break}}else o=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((o|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[o+4>>2]|0,(b|0)!=0):0)p=b;else q=10}else q=10;if((q|0)==10)p=hQb(c[l>>2]|0)|0;c1d(k,p+232|0,c[d+84>>2]|0,c[d+88>>2]|0,c[d+92>>2]|0);c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[e+16>>2]=c[k+16>>2];c[e+20>>2]=c[k+20>>2];k=d+120|0;a[k>>0]=a[k>>0]|2}k=d+68|0;if((c[k>>2]|0)==(f|0)){i=g;return}c[k>>2]=f;f=d+120|0;a[f>>0]=a[f>>0]|4;i=g;return}function d3d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+32|0;f=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/124|0)>>>0>=d>>>0){n=f+12|0;o=d;p=l;do{if(!p)q=0;else{l=p+44|0;r=p+12|0;s=r+56|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286];c[n+0>>2]=c[150284];c[n+4>>2]=c[150285];c[n+8>>2]=c[150286];c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[l+16>>2]=c[f+16>>2];c[l+20>>2]=c[f+20>>2];t=p+96|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t+20>>2]=0;c[p+68>>2]=-1;g[p+72>>2]=ea(1.0);c[p+76>>2]=0;c[p+80>>2]=0;t=p+120|0;a[t>>0]=a[t>>0]&-7;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;q=c[k>>2]|0}p=q+124|0;c[k>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((m-o|0)/124|0)+d|0;if(p>>>0>34636833)vxi(b);m=o;o=(j-m|0)/124|0;if(o>>>0<17318416){j=o<<1;o=j>>>0<p>>>0?p:j;j=((c[k>>2]|0)-m|0)/124|0;if(!o){u=0;v=0;w=j}else{x=o;y=j;z=11}}else{x=34636833;y=((c[k>>2]|0)-m|0)/124|0;z=11}if((z|0)==11){u=x;v=xCi(x*124|0)|0;w=y}y=v+(w*124|0)|0;x=f+12|0;z=d;d=y;while(1){if(!d)A=0;else{m=d+44|0;r=d+12|0;s=r+56|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));c[f+0>>2]=c[150284];c[f+4>>2]=c[150285];c[f+8>>2]=c[150286];c[x+0>>2]=c[150284];c[x+4>>2]=c[150285];c[x+8>>2]=c[150286];c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];c[m+16>>2]=c[f+16>>2];c[m+20>>2]=c[f+20>>2];l=d+96|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[d+68>>2]=-1;g[d+72>>2]=ea(1.0);c[d+76>>2]=0;c[d+80>>2]=0;l=d+120|0;a[l>>0]=a[l>>0]&-7;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;A=d}l=A+124|0;z=z+-1|0;if(!z){B=l;break}else d=l}d=v+(u*124|0)|0;u=c[b>>2]|0;z=c[k>>2]|0;if((z|0)==(u|0)){C=y;D=u}else{A=w+-1-(((z+-124-u|0)>>>0)/124|0)|0;w=z;z=y;do{z=z+-124|0;w=w+-124|0;r=z+0|0;y=w+0|0;s=r+124|0;do{c[r>>2]=c[y>>2];r=r+4|0;y=y+4|0}while((r|0)<(s|0))}while((w|0)!=(u|0));C=v+(A*124|0)|0;D=c[b>>2]|0}c[b>>2]=C;c[k>>2]=B;c[h>>2]=d;if(!D){i=e;return}ACi(D);i=e;return}function e3d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=721288;d=a+4|0;c[d>>2]=d;c[a+8>>2]=d;c[a+12>>2]=0;d=a+16|0;c[d>>2]=d;c[a+20>>2]=d;c[a+24>>2]=0;d=c[153116]|0;c[a+28>>2]=0;c[a+32>>2]=d;c[a+36>>2]=0;c[a+40>>2]=0;a=kbc()|0;d=0;while(1){e=a+(d<<2)+1024|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;break}if((d|0)>=16){g=5;break}}if((g|0)==5){i=b;return}c[f>>2]=3050;i=b;return}function f3d(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BLc()|0;C4d(a+48|0,c[b+52>>2]|0,e+28|0);i=d;return}function g3d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[a>>2]=721288;Rac((kbc()|0)+1024|0,3050);if((c[a+40>>2]|0)>-1){g=a+28|0;h=c[g>>2]|0;c[e>>2]=c[a+32>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}g=a+16|0;h=a+24|0;a:do if(c[h>>2]|0){j=c[a+20>>2]|0;k=(c[g>>2]|0)+4|0;l=c[j>>2]|0;c[l+4>>2]=c[k>>2];c[c[k>>2]>>2]=l;c[h>>2]=0;l=j;while(1){if((l|0)==(g|0))break a;j=c[l+4>>2]|0;c[f>>2]=44;c[d+0>>2]=c[f+0>>2];eOb(l,d);l=j}}while(0);f=a+4|0;g=a+12|0;if(!(c[g>>2]|0)){i=b;return}h=c[a+8>>2]|0;a=(c[f>>2]|0)+4|0;l=c[h>>2]|0;c[l+4>>2]=c[a>>2];c[c[a>>2]>>2]=l;c[g>>2]=0;g=h;while(1){if((g|0)==(f|0))break;h=c[g+4>>2]|0;c[e>>2]=44;c[d+0>>2]=c[e+0>>2];eOb(g,d);g=h}i=b;return}function h3d(a){a=a|0;var b=0;b=i;g3d(a);ACi(a);i=b;return}function i3d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im;a=i;i=i+16|0;h=a;if(!b){j=0;i=a;return j|0}k=(da(c[137788]|0,(c[b+8>>2]|0)>>>21)|0)+156|0;l=k>>5;if(!(1<<k-(l<<5)&c[(c[137786]|0)+(l<<2)>>2])){j=0;i=a;return j|0}l=b+232|0;X0d(h,l);m=ea(g[e>>2]);n=ea(m-ea(g[d>>2]));m=ea(g[d+4>>2]);o=ea(g[e+8>>2]);p=ea(o-ea(g[d+8>>2]));o=ea(ea(1.0)/ea(g[h>>2]));q=ea(n*o);o=ea(p*ea(ea(1.0)/ea(g[h+8>>2])));if(q>ea(1.0)|q<ea(0.0)){j=0;i=a;return j|0}if(o>ea(1.0)|o<ea(0.0)){j=0;i=a;return j|0}g[f>>2]=ea(m+ea(_0d(l,q,o)));j=1;i=a;return j|0}function j3d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=Im,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im;e=i;i=i+144|0;f=e+48|0;h=e;j=e+16|0;k=e+24|0;l=e+36|0;m=e+28|0;n=e+32|0;o=e+20|0;p=e+40|0;q=e+128|0;r=e+56|0;s=e+80|0;t=e+84|0;u=e+88|0;v=e+96|0;w=e+100|0;x=e+104|0;y=e+116|0;z=e+64|0;A=b+4|0;B=b+12|0;a:do if(c[B>>2]|0){C=c[b+8>>2]|0;D=(c[A>>2]|0)+4|0;E=c[C>>2]|0;c[E+4>>2]=c[D>>2];c[c[D>>2]>>2]=E;c[B>>2]=0;E=C;while(1){if((E|0)==(A|0))break a;C=c[E+4>>2]|0;c[w>>2]=44;c[f+0>>2]=c[w+0>>2];eOb(E,f);E=C}}while(0);w=b+16|0;E=c[b+20>>2]|0;if((E|0)==(w|0))F=A;else{C=x+4|0;D=x+8|0;G=E;do{E=G+8|0;H=c[E>>2]|0;if(1<<c[(c[H+24>>2]|0)+40>>2]&d){c[h>>2]=44;c[f+0>>2]=c[h+0>>2];I=cOb(12,16,f,0,3653512,80)|0;c[I+8>>2]=c[E>>2];c[I+4>>2]=A;E=c[A>>2]|0;c[I>>2]=E;c[E+4>>2]=I;c[A>>2]=I;c[B>>2]=(c[B>>2]|0)+1;N1d(x,H);I=H+32|0;J=ea(g[x>>2]);if(!((!(J!=ea(g[I>>2]))?(J=ea(g[C>>2]),!(J!=ea(g[H+36>>2]))):0)?(J=ea(g[D>>2]),!(J!=ea(g[H+40>>2]))):0)){c[I+0>>2]=c[x+0>>2];c[I+4>>2]=c[x+4>>2];c[I+8>>2]=c[x+8>>2];L1d(H)}Q1d(H);R1d(H);I=S1d(H)|0;if(I){E=H+44|0;c[r>>2]=c[E>>2];K=c[137784]|0;if(K){do if((c[K+36>>2]|0)!=(c[K+4>>2]|0)){fRb(f,K,r);L=c[f>>2]|0;M=c[K+28>>2]|0;if((L|0)==-1){N=M+(c[K+32>>2]<<3)|0;break}else{N=M+(L<<3)|0;break}}else N=(c[K+28>>2]|0)+(c[K+32>>2]<<3)|0;while(0);K=c[137784]|0;if((N|0)!=((c[K+28>>2]|0)+(c[K+32>>2]<<3)|0)?(K=c[N+4>>2]|0,(K|0)!=0):0)O=K;else P=22}else P=22;if((P|0)==22){P=0;O=hQb(c[E>>2]|0)|0}p1d(O+28|0);K=c[H+188>>2]|0;if((K&1|0)!=0?(a[H+85>>0]|0)!=0:0){if((K|0)==1)Q=ea(3402823469999999843913219.0e14);else Q=ea(g[H+56>>2]);P2d(c[I+4>>2]|0,c[I>>2]|0,c[H+52>>2]|0,ea(g[H+48>>2]),Q)}}}G=c[G+4>>2]|0}while((G|0)!=(w|0));F=A}A=b+8|0;b=c[A>>2]|0;if((b|0)==(F|0))R=b;else{w=b;do{b=c[w+8>>2]|0;G=T1d(b)|0;if(((G|0)!=0?(c[b+188>>2]&1|0)!=0:0)?(a[b+85>>0]|0)!=0:0){O=b+172|0;N=c[O>>2]|0;do if(!N)S=0;else{c[q>>2]=N;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(f,r,q);x=c[f>>2]|0;D=c[r+28>>2]|0;if((x|0)==-1){T=D+(c[r+32>>2]<<3)|0;break}else{T=D+(x<<3)|0;break}}else T=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if((T|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(c[T+4>>2]|0)!=0:0)U=r;else P=45}else P=45;if((P|0)==45){P=0;if(!(hQb(c[O>>2]|0)|0)){S=0;break}U=c[137784]|0}c[p>>2]=c[O>>2];if(U){do if((c[U+36>>2]|0)!=(c[U+4>>2]|0)){fRb(f,U,p);r=c[f>>2]|0;x=c[U+28>>2]|0;if((r|0)==-1){V=x+(c[U+32>>2]<<3)|0;break}else{V=x+(r<<3)|0;break}}else V=(c[U+28>>2]|0)+(c[U+32>>2]<<3)|0;while(0);r=c[137784]|0;if((V|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(r=c[V+4>>2]|0,(r|0)!=0):0)W=r;else P=55}else P=55;if((P|0)==55){P=0;W=hQb(c[O>>2]|0)|0}S=T1d(W)|0}while(0);O=b+176|0;N=c[O>>2]|0;do if(!N)X=0;else{c[o>>2]=N;H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(f,H,o);I=c[f>>2]|0;E=c[H+28>>2]|0;if((I|0)==-1){Y=E+(c[H+32>>2]<<3)|0;break}else{Y=E+(I<<3)|0;break}}else Y=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if((Y|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(c[Y+4>>2]|0)!=0:0)Z=H;else P=66}else P=66;if((P|0)==66){P=0;if(!(hQb(c[O>>2]|0)|0)){X=0;break}Z=c[137784]|0}c[n>>2]=c[O>>2];if(Z){do if((c[Z+36>>2]|0)!=(c[Z+4>>2]|0)){fRb(f,Z,n);H=c[f>>2]|0;I=c[Z+28>>2]|0;if((H|0)==-1){_=I+(c[Z+32>>2]<<3)|0;break}else{_=I+(H<<3)|0;break}}else _=(c[Z+28>>2]|0)+(c[Z+32>>2]<<3)|0;while(0);H=c[137784]|0;if((_|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(H=c[_+4>>2]|0,(H|0)!=0):0)$=H;else P=76}else P=76;if((P|0)==76){P=0;$=hQb(c[O>>2]|0)|0}X=T1d($)|0}while(0);O=b+184|0;N=c[O>>2]|0;do if(!N)aa=0;else{c[m>>2]=N;H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(f,H,m);I=c[f>>2]|0;E=c[H+28>>2]|0;if((I|0)==-1){ba=E+(c[H+32>>2]<<3)|0;break}else{ba=E+(I<<3)|0;break}}else ba=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if((ba|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(c[ba+4>>2]|0)!=0:0)ca=H;else P=87}else P=87;if((P|0)==87){P=0;if(!(hQb(c[O>>2]|0)|0)){aa=0;break}ca=c[137784]|0}c[l>>2]=c[O>>2];if(ca){do if((c[ca+36>>2]|0)!=(c[ca+4>>2]|0)){fRb(f,ca,l);H=c[f>>2]|0;I=c[ca+28>>2]|0;if((H|0)==-1){da=I+(c[ca+32>>2]<<3)|0;break}else{da=I+(H<<3)|0;break}}else da=(c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0;while(0);H=c[137784]|0;if((da|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(H=c[da+4>>2]|0,(H|0)!=0):0)fa=H;else P=97}else P=97;if((P|0)==97){P=0;fa=hQb(c[O>>2]|0)|0}aa=T1d(fa)|0}while(0);O=b+180|0;N=c[O>>2]|0;do if(!N)ga=0;else{c[k>>2]=N;H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(f,H,k);I=c[f>>2]|0;E=c[H+28>>2]|0;if((I|0)==-1){ha=E+(c[H+32>>2]<<3)|0;break}else{ha=E+(I<<3)|0;break}}else ha=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if((ha|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(c[ha+4>>2]|0)!=0:0)ia=H;else P=108}else P=108;if((P|0)==108){P=0;if(!(hQb(c[O>>2]|0)|0)){ga=0;break}ia=c[137784]|0}c[j>>2]=c[O>>2];if(ia){do if((c[ia+36>>2]|0)!=(c[ia+4>>2]|0)){fRb(f,ia,j);H=c[f>>2]|0;I=c[ia+28>>2]|0;if((H|0)==-1){ja=I+(c[ia+32>>2]<<3)|0;break}else{ja=I+(H<<3)|0;break}}else ja=(c[ia+28>>2]|0)+(c[ia+32>>2]<<3)|0;while(0);H=c[137784]|0;if((ja|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(H=c[ja+4>>2]|0,(H|0)!=0):0)ka=H;else P=118}else P=118;if((P|0)==118){P=0;ka=hQb(c[O>>2]|0)|0}ga=T1d(ka)|0}while(0);E2d(G,S,aa,X,ga)}w=c[w+4>>2]|0}while((w|0)!=(F|0));R=c[A>>2]|0}if((R|0)==(F|0)){i=e;return}else la=R;do{R=c[la+8>>2]|0;w=T1d(R)|0;if(((w|0)!=0?(c[R+188>>2]&1|0)!=0:0)?(a[R+85>>0]|0)!=0:0)R2d(w);la=c[la+4>>2]|0}while((la|0)!=(F|0));la=c[A>>2]|0;if((la|0)==(F|0)){i=e;return}A=y+4|0;w=u+4|0;R=z+4|0;ga=z+8|0;X=z+12|0;aa=la;do{la=c[aa+8>>2]|0;S=S1d(la)|0;if(S){ka=c[(c[la+24>>2]|0)+40>>2]|0;H5b(y,z5b()|0,1,ka);ja=la+188|0;if(((c[ja>>2]&1|0)!=0?(a[la+85>>0]|0)!=0:0)?(ia=c[153134]|0,c[z>>2]=0,c[R>>2]=ia,c[ga>>2]=0,c[X>>2]=0,ia=la+92|0,z1d(c[ia>>2]|0,z),j=A1d(c[ia>>2]|0)|0,T2d(c[S+4>>2]|0,c[S>>2]|0,ka,(a[la+84>>0]|0)!=0,c[z>>2]|0,c[ga>>2]|0,j),(c[X>>2]|0)>-1):0){j=c[z>>2]|0;c[h>>2]=c[R>>2];c[f+0>>2]=c[h+0>>2];eOb(j,f);c[z>>2]=0}j=c[ja>>2]|0;if(((j&4|0)!=0?(a[la+86>>0]|0)!=0:0)?(Q=ea(g[la+76>>2]),+Q>.001):0){J=ea(g[la+80>>2]);G0d(c[S+12>>2]|0,c[S>>2]|0,Q,ka,J,(a[la+87>>0]|0)!=0);ma=c[ja>>2]|0}else ma=j;if(((ma&2|0)!=0?(a[la+86>>0]|0)!=0:0)?(j=la+60|0,+ea(g[j>>2])>.001):0){ja=S+8|0;ia=c[ja>>2]|0;ha=la+164|0;do if((a[ha>>0]|0)!=0?(k=la+44|0,fa=c[k>>2]|0,(fa|0)!=0):0){c[s>>2]=fa;da=c[137784]|0;do if(da){do if((c[da+36>>2]|0)!=(c[da+4>>2]|0)){fRb(f,da,s);ca=c[f>>2]|0;l=c[da+28>>2]|0;if((ca|0)==-1){na=l+(c[da+32>>2]<<3)|0;break}else{na=l+(ca<<3)|0;break}}else na=(c[da+28>>2]|0)+(c[da+32>>2]<<3)|0;while(0);ca=c[137784]|0;if((na|0)==((c[ca+28>>2]|0)+(c[ca+32>>2]<<3)|0)){P=151;break}if(!(c[na+4>>2]|0))P=151}else P=151;while(0);if((P|0)==151?(P=0,(hQb(fa)|0)==0):0){oa=-1;break}if((Cwc(Vwc()|0)|0)!=0?(da=zwc(Vwc()|0)|0,ca=la+4|0,avc(h,da,c[ca>>2]|0),Z5b(u,Cwc(Vwc()|0)|0,h),(c[u>>2]|0)!=-1):0){da=c[w>>2]|0;l=c[k>>2]|0;c[t>>2]=l;ba=c[137784]|0;do if(ba){do if((c[ba+36>>2]|0)!=(c[ba+4>>2]|0)){fRb(f,ba,t);m=c[f>>2]|0;$=c[ba+28>>2]|0;if((m|0)==-1){pa=$+(c[ba+32>>2]<<3)|0;break}else{pa=$+(m<<3)|0;break}}else pa=(c[ba+28>>2]|0)+(c[ba+32>>2]<<3)|0;while(0);m=c[137784]|0;if((pa|0)==((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)){P=162;break}m=c[pa+4>>2]|0;if(m)qa=m;else P=162}else P=162;while(0);if((P|0)==162){P=0;qa=hQb(l)|0}ba=qa+88|0;if((da|0)==(((c[ba+4>>2]|0)-(c[ba>>2]|0)|0)/40|0|0)){oa=c[u>>2]|0;break}else{Krd(721376,0,3653512,75,1,c[ca>>2]|0,0,0);a[ha>>0]=0;oa=-1;break}}else oa=-1}else oa=-1;while(0);y4d(ia,oa);J=ea(g[j>>2]);Q=ea(g[la+64>>2]);ra=ea(g[la+68>>2]);s4d(c[ja>>2]|0,c[S>>2]|0,y,J,Q,ra,c[la+72>>2]|0,ka)}ha=c[y>>2]|0;if(ha){G=c[A>>2]|0;if((G|0)!=(ha|0))c[A>>2]=G+(~((G+-4-ha|0)>>>2)<<2);c[v>>2]=44;c[f+0>>2]=c[v+0>>2];eOb(ha,f)}}aa=c[aa+4>>2]|0}while((aa|0)!=(F|0));i=e;return}function k3d(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a=i;i=i+48|0;b=a+32|0;d=a+16|0;e=a;c[b>>2]=0;f=b+4|0;c[f>>2]=0;c[b+8>>2]=0;CQb(218,b,0)|0;h=c[f>>2]|0;j=c[b>>2]|0;if((h|0)==(j|0)){k=h;l=h}else{m=d+4|0;n=d+8|0;o=d+12|0;p=e+4|0;q=e+8|0;r=e+12|0;s=j;j=h;h=0;while(1){t=c[s+(h<<2)>>2]|0;if(!(c[t+8>>2]&1048576)){V1d(t,-1,0);V1d(t,-1,1);g[d>>2]=ea(1.0);g[m>>2]=ea(1.0);g[n>>2]=ea(0.0);g[o>>2]=ea(0.0);W1d(t,d,0);g[e>>2]=ea(1.0);g[p>>2]=ea(1.0);g[q>>2]=ea(0.0);g[r>>2]=ea(0.0);W1d(t,e,1);u=c[f>>2]|0;v=c[b>>2]|0}else{u=j;v=s}h=h+1|0;if(h>>>0>=u-v>>2>>>0){k=v;l=u;break}else{s=v;j=u}}}if(!k){i=a;return}if((l|0)!=(k|0))c[f>>2]=l+(~((l+-4-k|0)>>>2)<<2);ACi(k);i=a;return}function l3d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+32|0;d=a;e=a+12|0;f=a+8|0;rri(e,2492024,7);c[d>>2]=2492024;c[d+4>>2]=0;g=dQc(e,2462344,d)|0;xri(e);e=CTb(g,218)|0;if(!b)h=0;else h=c[b+4>>2]|0;c[f>>2]=h;P1d(e,f);if(!(DLc()|0)){i=a;return g|0}f=DLc()|0;co[c[c[f>>2]>>2]&2047](f,g,b);i=a;return g|0}function m3d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b;c[h>>2]=0;j=h+4|0;c[j>>2]=0;k=h+8|0;c[k>>2]=0;l=a+16|0;m=c[a+20>>2]|0;if((m|0)==(l|0)){i=b;return}else{n=m;o=0;p=0}while(1){m=n+8|0;if((o|0)==(p|0))z3d(h,m);else{if(!o)q=0;else{c[o>>2]=c[m>>2];q=c[j>>2]|0}c[j>>2]=q+4}m=c[n+4>>2]|0;a=c[j>>2]|0;if((m|0)==(l|0)){r=a;break}n=m;o=a;p=c[k>>2]|0}k=c[h>>2]|0;if((r|0)==(k|0)){s=k;t=k}else{r=k;k=0;while(1){p=c[r+(k<<2)>>2]|0;o=p+44|0;n=c[o>>2]|0;do if(n){c[e>>2]=n;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(d,l,e);q=c[d>>2]|0;a=c[l+28>>2]|0;if((q|0)==-1){u=a+(c[l+32>>2]<<3)|0;break}else{u=a+(q<<3)|0;break}}else u=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((u|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(c[u+4>>2]|0)!=0:0)v=l;else w=20}else w=20;if((w|0)==20){w=0;if(!(hQb(c[o>>2]|0)|0))break;v=c[137784]|0}c[f>>2]=c[o>>2];if(v){do if((c[v+36>>2]|0)!=(c[v+4>>2]|0)){fRb(d,v,f);l=c[d>>2]|0;q=c[v+28>>2]|0;if((l|0)==-1){x=q+(c[v+32>>2]<<3)|0;break}else{x=q+(l<<3)|0;break}}else x=(c[v+28>>2]|0)+(c[v+32>>2]<<3)|0;while(0);l=c[137784]|0;if((x|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[x+4>>2]|0,(l|0)!=0):0)y=l;else w=30}else w=30;if((w|0)==30){w=0;y=hQb(c[o>>2]|0)|0}if(!(s2d(y,c[p+24>>2]|0)|0)){ko[c[(c[p>>2]|0)+128>>2]&4095](p);ko[c[(c[p>>2]|0)+124>>2]&4095](p)}}while(0);k=k+1|0;p=c[j>>2]|0;o=c[h>>2]|0;if(k>>>0>=p-o>>2>>>0){s=o;t=p;break}else r=o}}if(!s){i=b;return}if((t|0)!=(s|0))c[j>>2]=t+(~((t+-4-s|0)>>>2)<<2);c[g>>2]=89;c[d+0>>2]=c[g+0>>2];eOb(s,d);i=b;return}function n3d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+16|0;h=c[a+20>>2]|0;a:do if((h|0)==(g|0)){j=h;k=4}else{l=h;do{if((c[l+8>>2]|0)==(b|0)){j=l;k=4;break a}l=c[l+4>>2]|0}while((l|0)!=(g|0))}while(0);if((k|0)==4?(j|0)!=(g|0):0){i=d;return}c[f>>2]=44;c[e+0>>2]=c[f+0>>2];f=cOb(12,16,e,0,3653512,80)|0;c[f+8>>2]=b;c[f+4>>2]=g;b=c[g>>2]|0;c[f>>2]=b;c[b+4>>2]=f;c[g>>2]=f;f=a+24|0;c[f>>2]=(c[f>>2]|0)+1;i=d;return}function o3d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+16|0;h=c[a+20>>2]|0;a:do if((h|0)==(g|0))j=h;else{k=h;do{if((c[k+8>>2]|0)==(b|0)){j=k;break a}k=c[k+4>>2]|0}while((k|0)!=(g|0));i=d;return}while(0);if((j|0)==(g|0)){i=d;return}g=j+4|0;b=c[j>>2]|0;c[b+4>>2]=c[g>>2];c[c[g>>2]>>2]=b;b=a+24|0;c[b>>2]=(c[b>>2]|0)+-1;c[f>>2]=44;c[e+0>>2]=c[f+0>>2];eOb(j,e);i=d;return}function p3d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+16|0;e=c[a+20>>2]|0;if((e|0)==(d|0)){i=b;return}else f=e;do{e=c[f+8>>2]|0;a=e+204|0;if(c[a>>2]|0){g=e+196|0;e=0;do{W2d(c[(c[g>>2]|0)+(e*20|0)+4>>2]|0);e=e+1|0}while(e>>>0<(c[a>>2]|0)>>>0)}f=c[f+4>>2]|0}while((f|0)!=(d|0));i=b;return}function q3d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+16|0;e=c[a+20>>2]|0;if((e|0)==(d|0)){i=b;return}else f=e;do{e=c[f+8>>2]|0;a=e+204|0;if(c[a>>2]|0){g=e+196|0;e=0;do{X2d(c[(c[g>>2]|0)+(e*20|0)+4>>2]|0);e=e+1|0}while(e>>>0<(c[a>>2]|0)>>>0)}f=c[f+4>>2]|0}while((f|0)!=(d|0));i=b;return}function r3d(a,b){a=a|0;b=b|0;var c=0;a=i;c=d1d(b)|0;i=a;return c|0}function s3d(a,b,c){a=a|0;b=b|0;c=c|0;b=i;X0d(a,c);i=b;return}function t3d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;h=f+4|0;j=f;k=b+16|0;l=c[b+20>>2]|0;if((l|0)!=(k|0)){m=l;do{l=c[m+8>>2]|0;if(((((c[l+188>>2]&2|0)!=0?(a[l+86>>0]|0)!=0:0)?+ea(g[l+60>>2])>.001:0)?(n=S1d(l)|0,(n|0)!=0):0)?(l=c[n+8>>2]|0,(l|0)!=0):0)z4d(l,d,e);m=c[m+4>>2]|0}while((m|0)!=(k|0))}k=b+28|0;m=b+36|0;c[m>>2]=0;e=b+40|0;l=c[e>>2]|0;n=c[d+8>>2]|0;do if((l&2147483647)>>>0<n>>>0)if((l|0)>-1){c[e>>2]=n;d=c[k>>2]|0;c[j>>2]=c[b+32>>2];c[h+0>>2]=c[j+0>>2];c[k>>2]=hOb(d,n,1,h,0,3653512,370)|0;break}else{c[j>>2]=c[b+32>>2];c[h+0>>2]=c[j+0>>2];d=cOb(n,1,h,0,3653512,352)|0;YEi(d|0,c[k>>2]|0,c[m>>2]|0)|0;c[e>>2]=n;c[k>>2]=d;break}while(0);e=c[m>>2]|0;if(e>>>0>=n>>>0){c[m>>2]=n;i=f;return}h=c[k>>2]|0;k=h+n|0;if((e|0)==(n|0)){c[m>>2]=n;i=f;return}j=h+e|0;do{if(j)a[j>>0]=0;j=j+1|0}while((j|0)!=(k|0));c[m>>2]=n;i=f;return}function u3d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;h=b+16|0;j=c[b+20>>2]|0;if((j|0)==(h|0)){i=f;return}else k=j;do{j=c[k+8>>2]|0;if((((((c[j+188>>2]&2|0)!=0?(a[j+86>>0]|0)!=0:0)?+ea(g[j+60>>2])>.001:0)?(b=S1d(j)|0,(b|0)!=0):0)?(j=c[b+8>>2]|0,(j|0)!=0):0)?(b=j+192|0,j=c[b>>2]|0,(j|0)<(e|0)):0)c[d+(j<<2)>>2]=b;k=c[k+4>>2]|0}while((k|0)!=(h|0));i=f;return}function v3d(a,b){a=a|0;b=b|0;var c=0;a=i;c=U1d(b)|0;i=a;return c|0}function w3d(a){a=a|0;return 720360}function x3d(a,b,c){a=a|0;b=b|0;c=c|0;b=i;O1d(a,c);i=b;return}function y3d(a,b){a=a|0;b=b|0;return 0}function z3d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>2)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>2>>>0<1073741823){m=h>>1;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>2;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>2;s=6}if((s|0)==6){c[f>>2]=89;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<2,16,e,0,3653512,80)|0;p=r}r=o+(p<<2)|0;if(r)c[r>>2]=c[b>>2];b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>2)<<2)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<2);c[k>>2]=o+(n<<2);if(!r){i=d;return}c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function A3d(a){a=a|0;var b=0,d=0;b=i;if(!(c[a+24>>2]|0)){d=0;i=b;return d|0}d=c[(c[a+20>>2]|0)+8>>2]|0;i=b;return d|0}function B3d(a){a=a|0;return a+16|0}function C3d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=xbc()|0;d=0;do{e=b+(d<<2)+64|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}}while((d|0)<16);if((g|0)==4)c[f>>2]=217;f=xbc()|0;d=0;do{b=f+(d<<2)|0;d=d+1|0;if(!(c[b>>2]|0)){h=b;g=8;break}}while((d|0)<16);if((g|0)==8)c[h>>2]=218;h=xbc()|0;d=0;while(1){f=h+(d<<2)+128|0;d=d+1|0;if(!(c[f>>2]|0)){j=f;break}if((d|0)>=16){g=13;break}}if((g|0)==13){i=a;return}c[j>>2]=219;i=a;return}function D3d(){return}function E3d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a+4|0;d=a;e=kbc()|0;f=0;do{g=e+(f<<2)+256|0;f=f+1|0;if(!(c[g>>2]|0)){h=g;j=4;break}}while((f|0)<16);if((j|0)==4)c[h>>2]=1844;c[d>>2]=c[153116];c[b+0>>2]=c[d+0>>2];d=bOb(44,b,1,16,3653512,52)|0;e3d(d);CLc(d);i=a;return}function F3d(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=BLc()|0;f=c[153116]|0;if(e)ko[c[c[e>>2]>>2]&4095](e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);CLc(0);i=a;return}function G3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;e=a+8|0;f=a;if(!((d|0)==1|(d|0)==5)){i=a;return}d=CVc(b)|0;if(!d){i=a;return}if(!(c[d+76>>2]|0)){i=a;return}d=c[(Vwc()|0)+76>>2]|0;if(!d){i=a;return}g=b+88|0;if(!(c[g>>2]|0)){i=a;return}h=b+80|0;b=0;do{c[f>>2]=c[(c[h>>2]|0)+(b*12|0)+4>>2];j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(e,j,f);k=c[e>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if(((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)?(k=(da(c[137788]|0,(c[j+8>>2]|0)>>>21)|0)+218|0,l=k>>5,(1<<k-(l<<5)&c[(c[137786]|0)+(l<<2)>>2]|0)!=0):0)X1d(j,d)}b=b+1|0}while(b>>>0<(c[g>>2]|0)>>>0);i=a;return}function H3d(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,722344);c[b>>2]=-1;itd(b,721464);i=a;return}function I3d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=0;f=i;i=i+32|0;h=f+16|0;j=f;k=ea(g[e+12>>2]);l=ea(g[e+16>>2]);g[h>>2]=k;g[h+4>>2]=l;g[h+8>>2]=k;if((c[a+4>>2]|0)==2){k=ea(ea(g[e+20>>2])*ea(.5));l=ea(+W(+k));g[j+12>>2]=ea(+V(+k));g[j>>2]=ea(l*ea(g[150296]));g[j+4>>2]=ea(l*ea(g[150297]));m=ea(l*ea(g[150298]));n=j+8|0;g[n>>2]=m;vMc(b,d,j,h);i=f;return}else{g[j>>2]=ea(0.0);g[j+4>>2]=ea(0.0);g[j+12>>2]=ea(1.0);m=ea(0.0);n=j+8|0;g[n>>2]=m;vMc(b,d,j,h);i=f;return}}function J3d(a,b,c){a=a|0;b=b|0;c=c|0;a=i;Lmc(b,c);i=a;return}function K3d(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;K3b(a);c[a+244>>2]=0;c[a+248>>2]=b;c[a+252>>2]=d;c[a>>2]=721496;c[a+260>>2]=f;c[k>>2]=0;L3b(a,g,h,k,0,1,1);c[a+256>>2]=e;c[a+168>>2]=a+204;i=j;return}function L3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+168|0;if(c[f>>2]|0){g=ync()|0;In[c[(c[g>>2]|0)+220>>2]&4095](g,c[f>>2]|0)}Xuc(d,c[a+256>>2]|0,b,0,0);i=e;return}function M3d(b,c){b=b|0;c=c|0;var d=0;d=c&1;a[b+41>>0]=d;a[b+42>>0]=d;return}function N3d(b,e,f,h,j,k){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;l=i;i=i+32|0;m=l+16|0;n=l+12|0;o=l+8|0;p=l+4|0;q=l;K3b(b);c[b+244>>2]=1;c[b+248>>2]=e;c[b+252>>2]=f;c[b>>2]=721592;f=b+260|0;c[f>>2]=h+220;c[b+264>>2]=k;a[b+268>>0]=0;c[b+176>>2]=c[h+204>>2];c[b+44>>2]=c[h+72>>2];Ohc(p,h);k=c[p>>2]|0;if(!k)r=0;else{c[n>>2]=k;k=c[137784]|0;if(k){do if((c[k+36>>2]|0)!=(c[k+4>>2]|0)){fRb(m,k,n);e=c[m>>2]|0;s=c[k+28>>2]|0;if((e|0)==-1){t=s+(c[k+32>>2]<<3)|0;break}else{t=s+(e<<3)|0;break}}else t=(c[k+28>>2]|0)+(c[k+32>>2]<<3)|0;while(0);k=c[137784]|0;if((t|0)!=((c[k+28>>2]|0)+(c[k+32>>2]<<3)|0)?(k=c[t+4>>2]|0,(k|0)!=0):0)u=k;else v=10}else v=10;if((v|0)==10)u=hQb(c[p>>2]|0)|0;r=u}c[b+256>>2]=r;c[q>>2]=0;L3b(b,j,r+168|0,q,0,d[h+69>>0]|0,(a[h+70>>0]|0)!=0);h=c[f>>2]|0;if(!(c[h+8>>2]|0)){w=1;x=b+269|0;a[x>>0]=w;i=l;return}f=c[h>>2]|0;h=c[f>>2]|0;if(!h){w=1;x=b+269|0;a[x>>0]=w;i=l;return}c[o>>2]=h;h=c[137784]|0;if(h){do if((c[h+36>>2]|0)!=(c[h+4>>2]|0)){fRb(m,h,o);q=c[m>>2]|0;r=c[h+28>>2]|0;if((q|0)==-1){y=r+(c[h+32>>2]<<3)|0;break}else{y=r+(q<<3)|0;break}}else y=(c[h+28>>2]|0)+(c[h+32>>2]<<3)|0;while(0);h=c[137784]|0;if((y|0)!=((c[h+28>>2]|0)+(c[h+32>>2]<<3)|0)?(h=c[y+4>>2]|0,(h|0)!=0):0)z=h;else v=22}else v=22;if((v|0)==22){v=hQb(c[f>>2]|0)|0;if(!v){w=1;x=b+269|0;a[x>>0]=w;i=l;return}else z=v}v=z+88|0;z=c[v>>2]|0;if(!z){w=1;x=b+269|0;a[x>>0]=w;i=l;return}f=c[180364]|0;h=v;y=z;a:while(1){z=y;while(1){if((c[z+16>>2]|0)>=(f|0)){A=z;break}z=c[z+4>>2]|0;if(!z){B=h;break a}}y=c[A>>2]|0;if(!y){B=A;break}else h=A}if((B|0)==(v|0)){w=1;x=b+269|0;a[x>>0]=w;i=l;return}if((f|0)<(c[B+16>>2]|0)){w=1;x=b+269|0;a[x>>0]=w;i=l;return}w=ea(g[B+20>>2])==ea(0.0)&1;x=b+269|0;a[x>>0]=w;i=l;return}function O3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+168|0;if(c[f>>2]|0){g=ync()|0;In[c[(c[g>>2]|0)+220>>2]&4095](g,c[f>>2]|0)}Xuc(d,c[a+256>>2]|0,b,0,0);i=e;return}function P3d(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!(a[b+269>>0]|0))f=c[b+264>>2]|0;else f=-1;D4d(e,c[b+248>>2]|0,f,0);c[b+168>>2]=c[e>>2];a[b+268>>0]=a[e+4>>0]|0;i=d;return}function Q3d(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0;k=i;K3b(b);c[b+244>>2]=2;c[b+248>>2]=d;c[b+252>>2]=e;c[b>>2]=721688;c[b+260>>2]=h;c[b+264>>2]=f;g[b+268>>2]=ea(0.0);c[b+176>>2]=j&1;c[b+168>>2]=(pjc()|0)+60;a[b+272>>0]=1;i=k;return}function R3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=Im,v=Im,w=0,x=0;e=i;i=i+64|0;f=e+56|0;h=e+52|0;j=e+16|0;k=e;l=(pjc()|0)+60|0;m=ync()|0;In[c[(c[m>>2]|0)+220>>2]&4095](m,l);m=a+168|0;if((c[m>>2]|0)!=(l|0)){l=ync()|0;In[c[(c[l>>2]|0)+220>>2]&4095](l,c[m>>2]|0)}m=c[a+252>>2]|0;l=c[(c[c[a+248>>2]>>2]|0)+16>>2]|0;n=c[153134]|0;c[j>>2]=0;o=j+4|0;c[o>>2]=n;c[j+8>>2]=0;p=j+12|0;c[p>>2]=0;q=j+16|0;c[q>>2]=0;r=j+20|0;c[r>>2]=n;c[j+24>>2]=0;n=j+28|0;c[n>>2]=0;c[j+32>>2]=c[155410];s=ea(g[l+(m*40|0)+12>>2]);t=ea(g[l+(m*40|0)+16>>2]);u=ea(g[l+(m*40|0)+20>>2]);v=ea(g[a+268>>2]);g[k>>2]=s;g[k+4>>2]=t;g[k+8>>2]=u;g[k+12>>2]=v;old(j,577360,k);k=ync()|0;In[c[(c[k>>2]|0)+220>>2]&4095](k,j);if((c[n>>2]|0)>-1){n=c[q>>2]|0;c[h>>2]=c[r>>2];c[f+0>>2]=c[h+0>>2];eOb(n,f);c[q>>2]=0}if((c[p>>2]|0)<=-1){w=a+256|0;x=c[w>>2]|0;Xuc(d,x,b,0,0);i=e;return}p=c[j>>2]|0;c[h>>2]=c[o>>2];c[f+0>>2]=c[h+0>>2];eOb(p,f);c[j>>2]=0;w=a+256|0;x=c[w>>2]|0;Xuc(d,x,b,0,0);i=e;return}function S3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;e=ync()|0;f=(pjc()|0)+60|0;In[c[(c[e>>2]|0)+220>>2]&4095](e,f);g=c[b>>2]|0;h=c[(c[g+64>>2]|0)+168>>2]|0;if((h|0)==(f|0))j=g;else{In[c[(c[e>>2]|0)+220>>2]&4095](e,h);j=c[b>>2]|0}h=c[b+4>>2]|0;b=j+(h*76|0)|0;if(!h){i=a;return}e=((((h*76|0)+-76|0)>>>0)/76|0)+1|0;h=j;g=0;f=0;k=j;while(1){l=c[k+64>>2]|0;m=c[(mo[c[(c[l>>2]|0)+68>>2]&4095](l)|0)+44>>2]|0;l=m+20|0;n=c[l>>2]|0;o=m+8|0;if((n+f|0)>>>0<=65535?(m=c[o>>2]|0,(m+g|0)>>>0<=32e3):0){p=n;q=m;r=h;s=g;t=f}else{W3d(d,h,k);p=c[l>>2]|0;q=c[o>>2]|0;r=k;s=0;t=0}k=k+76|0;if((k|0)==(b|0)){u=r;break}else{h=r;g=q+s|0;f=p+t|0}}t=j+(e*76|0)|0;if(t>>>0<=u>>>0){i=a;return}W3d(d,u,t);i=a;return}function T3d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;h=b+200|0;if(d){c[h>>2]=c[d+4>>2];c[b+256>>2]=e;j=c[d+88>>2]|0;k=d+88|0;if(j){d=c[180364]|0;l=k;m=j;a:while(1){j=m;while(1){if((c[j+16>>2]|0)>=(d|0)){n=j;break}j=c[j+4>>2]|0;if(!j){o=l;break a}}m=c[n>>2]|0;if(!m){o=n;break}else l=n}if((o|0)!=(k|0)?(d|0)>=(c[o+16>>2]|0):0)p=ea(g[o+20>>2])==ea(0.0)&1;else p=1}else p=1}else{c[h>>2]=0;c[b+256>>2]=e;p=1}a[b+272>>0]=p;i=f;return}function U3d(b){b=b|0;var d=0,e=0,f=0,h=0;d=i;i=i+16|0;e=d;if(!(a[b+272>>0]|0))f=c[b+264>>2]|0;else f=-1;D4d(e,c[b+248>>2]|0,f,1);f=c[e>>2]|0;if(!f)h=(pjc()|0)+60|0;else h=f;c[b+168>>2]=h;g[b+268>>2]=ea(g[e+8>>2]);i=d;return}function V3d(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,721464);c[180364]=c[b>>2];i=a;return}function W3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im;e=i;i=i+32|0;f=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e;m=c[b+64>>2]|0;co[c[(c[m>>2]|0)+40>>2]&2047](j,m,0);m=c[j>>2]|0;if(!m)n=0;else{c[h>>2]=m;m=c[137784]|0;if(m){do if((c[m+36>>2]|0)!=(c[m+4>>2]|0)){fRb(f,m,h);o=c[f>>2]|0;p=c[m+28>>2]|0;if((o|0)==-1){q=p+(c[m+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[m+28>>2]|0)+(c[m+32>>2]<<3)|0;while(0);m=c[137784]|0;if((q|0)!=((c[m+28>>2]|0)+(c[m+32>>2]<<3)|0)?(m=c[q+4>>2]|0,(m|0)!=0):0)r=m;else s=10}else s=10;if((s|0)==10)r=hQb(c[j>>2]|0)|0;n=r}Bjc(pjc()|0,n,a)|0;if(b>>>0>=d>>>0){t=pjc()|0;Djc(t);i=e;return}a=l+4|0;n=l+8|0;r=b;do{b=c[r+64>>2]|0;j=c[b+252>>2]|0;s=c[(c[c[b+248>>2]>>2]|0)+16>>2]|0;m=pjc()|0;c[k>>2]=c[b+260>>2];u=ea(g[r+48>>2]);v=ea(g[r+52>>2]);w=ea(g[r+56>>2]);g[l>>2]=u;g[a>>2]=v;g[n>>2]=w;w=ea(g[s+(j*40|0)+12>>2]);v=ea(g[s+(j*40|0)+16>>2]);u=ea(g[s+(j*40|0)+20>>2]);Cjc(m,k,l,w,v,u,ea(g[b+268>>2]));r=r+76|0}while(r>>>0<d>>>0);t=pjc()|0;Djc(t);i=e;return}function X3d(a){a=a|0;var b=0;b=i;M3b(a);i=b;return}function Y3d(a){a=a|0;return (c[a+256>>2]|0)!=0|0}function Z3d(a){a=a|0;return c[(c[a+248>>2]|0)+56>>2]|0}function _3d(a){a=a|0;return c[(c[a+260>>2]|0)+8>>2]|0}function $3d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=c[(c[c[b+260>>2]>>2]|0)+(d<<2)>>2]|0;if(!e)f=0;else f=c[e+4>>2]|0;c[a>>2]=f;return}function a4d(a,b){a=a|0;b=b|0;return b|0}function b4d(a){a=a|0;return 1<<c[(c[a+248>>2]|0)+56>>2]|0}function c4d(a){a=a|0;return c[a+256>>2]|0}function d4d(a){a=a|0;return}function e4d(a){a=a|0;var b=0;b=i;M3b(a);i=b;return}function f4d(b){b=b|0;var d=0,e=0;d=i;if(a[b+268>>0]|0){e=0;i=d;return e|0}e=(c[b+256>>2]|0)!=0;i=d;return e|0}function g4d(a){a=a|0;return c[(c[a+260>>2]|0)+8>>2]|0}function h4d(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=c[(c[c[b+260>>2]>>2]|0)+(d<<2)>>2];return}function i4d(a,b){a=a|0;b=b|0;return b|0}function j4d(a){a=a|0;var b=0;b=i;M3b(a);i=b;return}function k4d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+64|0;h=f+4|0;j=f+24|0;k=f+8|0;l=f+28|0;m=f+44|0;n=f;o=f+20|0;p=f+40|0;c[b>>2]=0;q=b+4|0;c[q>>2]=0;r=c[153116]|0;c[b+8>>2]=0;c[b+12>>2]=r;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=r;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=c[155410];r=b+44|0;g[r>>2]=ea(0.0);g[b+48>>2]=ea(0.0);g[b+52>>2]=ea(0.0);c[b+56>>2]=-1;s=b+60|0;t=b+72|0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;u=c[153116]|0;c[b+80>>2]=0;c[b+84>>2]=u;c[b+88>>2]=0;c[b+92>>2]=0;u=c[153116]|0;c[b+96>>2]=0;c[b+100>>2]=u;c[b+104>>2]=0;c[b+108>>2]=0;u=b+112|0;c[u>>2]=0;v=b+116|0;w=c[153116]|0;c[v>>2]=v;c[b+120>>2]=v;c[b+124>>2]=0;c[b+128>>2]=8192;c[b+132>>2]=w;a[b+136>>0]=0;w=c[153116]|0;c[b+140>>2]=0;c[b+144>>2]=w;c[b+148>>2]=0;c[b+152>>2]=0;w=c[153116]|0;c[b+156>>2]=0;c[b+160>>2]=w;c[b+164>>2]=0;c[b+168>>2]=0;w=c[153116]|0;c[b+172>>2]=0;c[b+176>>2]=w;c[b+180>>2]=0;c[b+184>>2]=0;c[b+188>>2]=-1;c[j>>2]=c[153116];c[h+0>>2]=c[j+0>>2];duc(b+192|0,h);j=b+220|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;j=c[153116]|0;c[b+244>>2]=0;c[b+248>>2]=j;c[b+252>>2]=0;c[b+256>>2]=0;j=c[153116]|0;c[b+260>>2]=0;c[b+264>>2]=j;c[b+268>>2]=0;c[b+272>>2]=0;j=b+276|0;c[j>>2]=j;c[b+280>>2]=j;c[b+284>>2]=0;j=d+28|0;w=c[j>>2]|0;v=d+32|0;x=(c[v>>2]|0)-w>>7;if(!x){i=f;return}else y=0;while(1){if(c[w+(y<<7)+4>>2]|0)break;y=y+1|0;if(y>>>0>=x>>>0){z=14;break}}if((z|0)==14){i=f;return}c[b>>2]=d;X0d(k,(c[d>>2]|0)+232|0);c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];c[s+0>>2]=c[e+0>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];e=xCi(120)|0;O0d(e,d);k=c[u>>2]|0;if(!((k|0)==(e|0)|(k|0)==0)){P0d(k);ACi(k)}c[u>>2]=e;e=Xmd()|0;rri(l,722064,34);k=Nmd(e,l)|0;xri(l);if(!k){Krd(722104,0,3653512,321,1,0,0,0);l=Xmd()|0;rri(m,722224,7);e=Nmd(l,m)|0;xri(m);A=e}else A=k;k=bkd(A,61,0)|0;c[q>>2]=k;c[h>>2]=-1;itd(h,791824);c[n>>2]=c[h>>2];c[h+0>>2]=c[n+0>>2];if(pkd(k,h)|0){k=c[q>>2]|0;c[h>>2]=-1;itd(h,791824);c[o>>2]=c[h>>2];q=c[u>>2]|0;u=c[((a[q+40>>0]|0)==0?q+20|0:q+24|0)>>2]|0;c[h+0>>2]=c[o+0>>2];rkd(k,h,u)}if((c[j>>2]|0)==(c[v>>2]|0)){i=f;return}F4d(p,d,s,r,500);r=c[p>>2]|0;c[p>>2]=0;p=c[t>>2]|0;if(!((p|0)==(r|0)|(p|0)==0)){G4d(p);ACi(p)}c[t>>2]=r;l4d(b);i=f;return}function l4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;b=i;i=i+64|0;d=b+8|0;e=b+24|0;f=b+16|0;g=b+28|0;h=b+60|0;j=b;k=b+20|0;l=b+32|0;m=c[a>>2]|0;n=m+28|0;o=c[n>>2]|0;p=m+32|0;m=(c[p>>2]|0)-o>>7;if(!m){i=b;return}else q=0;while(1){if(c[o+(q<<7)+4>>2]|0)break;q=q+1|0;if(q>>>0>=m>>>0){r=74;break}}if((r|0)==74){i=b;return}A4d(a);m=c[n>>2]|0;if((c[p>>2]|0)!=(m|0)){q=a+276|0;o=l+12|0;s=l+16|0;t=l+20|0;u=l+24|0;v=m;m=0;do{w=v+(m<<7)+12|0;x=c[w>>2]|0;do if(x){c[h>>2]=x;y=c[137784]|0;if(y){do if((c[y+36>>2]|0)!=(c[y+4>>2]|0)){fRb(d,y,h);z=c[d>>2]|0;A=c[y+28>>2]|0;if((z|0)==-1){B=A+(c[y+32>>2]<<3)|0;break}else{B=A+(z<<3)|0;break}}else B=(c[y+28>>2]|0)+(c[y+32>>2]<<3)|0;while(0);y=c[137784]|0;if((B|0)!=((c[y+28>>2]|0)+(c[y+32>>2]<<3)|0)?(c[B+4>>2]|0)!=0:0)C=y;else r=15}else r=15;if((r|0)==15){r=0;if(!(hQb(c[w>>2]|0)|0))break;C=c[137784]|0}y=(c[n>>2]|0)+(m<<7)+12|0;c[g>>2]=c[y>>2];if(C){do if((c[C+36>>2]|0)!=(c[C+4>>2]|0)){fRb(d,C,g);z=c[d>>2]|0;A=c[C+28>>2]|0;if((z|0)==-1){D=A+(c[C+32>>2]<<3)|0;break}else{D=A+(z<<3)|0;break}}else D=(c[C+28>>2]|0)+(c[C+32>>2]<<3)|0;while(0);z=c[137784]|0;if((D|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(z=c[D+4>>2]|0,(z|0)!=0):0)E=z;else r=25}else r=25;if((r|0)==25){r=0;E=hQb(c[y>>2]|0)|0}z=c[E+284>>2]|0;c[k>>2]=z;if(z){c[f>>2]=z;z=c[137784]|0;if(z){do if((c[z+36>>2]|0)!=(c[z+4>>2]|0)){fRb(d,z,f);A=c[d>>2]|0;F=c[z+28>>2]|0;if((A|0)==-1){G=F+(c[z+32>>2]<<3)|0;break}else{G=F+(A<<3)|0;break}}else G=(c[z+28>>2]|0)+(c[z+32>>2]<<3)|0;while(0);z=c[137784]|0;if(!((G|0)!=((c[z+28>>2]|0)+(c[z+32>>2]<<3)|0)?(c[G+4>>2]|0)!=0:0))r=35}else r=35;if((r|0)==35?(r=0,(hQb(c[k>>2]|0)|0)==0):0)break;tjc(pjc()|0,k);c[l>>2]=0;z=c[153116]|0;c[o>>2]=0;c[s>>2]=z;c[t>>2]=0;c[u>>2]=0;L4d(q,l);c[e>>2]=z;c[d+0>>2]=c[e+0>>2];eOb(0,d);c[o>>2]=0;z=c[q>>2]|0;c[z+8>>2]=c[k>>2];y=zjc(pjc()|0,k)|0;if(!y)H=0;else H=c[y+4>>2]|0;c[z+12>>2]=H;y=Ajc(pjc()|0,k)|0;if(!y)I=0;else I=c[y+4>>2]|0;c[z+16>>2]=I}}while(0);m=m+1|0;v=c[n>>2]|0}while(m>>>0<(c[p>>2]|0)-v>>7>>>0)}v=c[a>>2]|0;p=v+20|0;m=v+16|0;kuc(a+192|0,(((c[p>>2]|0)-(c[m>>2]|0)|0)/40|0)+1|0);v=a+140|0;n=((c[p>>2]|0)-(c[m>>2]|0)|0)/40|0;I=a+148|0;c[I>>2]=n;k=a+152|0;H=c[k>>2]|0;do if((H&2147483647)>>>0<n>>>0)if((H|0)>-1){c[k>>2]=n;q=c[v>>2]|0;c[e>>2]=c[a+144>>2];c[d+0>>2]=c[e+0>>2];c[v>>2]=hOb(q,n<<2,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+144>>2];c[d+0>>2]=c[e+0>>2];q=cOb(n<<2,4,d,0,3653512,352)|0;YEi(q|0,c[v>>2]|0,c[I>>2]<<2|0)|0;c[k>>2]=n;c[v>>2]=q;break}while(0);v=c[m>>2]|0;if((c[p>>2]|0)==(v|0)){i=b;return}n=v;v=0;do{k=c[n+(v*40|0)+32>>2]|0;I=c[(c[a>>2]|0)+28>>2]|0;H=I+(k<<7)+4|0;q=c[H>>2]|0;do if((q|0)==2){o=c[I+(k<<7)+8>>2]|0;if(o){c[e>>2]=o;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(d,l,e);u=c[d>>2]|0;t=c[l+28>>2]|0;if((u|0)==-1){J=t+(c[l+32>>2]<<3)|0;break}else{J=t+(u<<3)|0;break}}else J=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if(!((J|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(c[J+4>>2]|0)!=0:0))r=58}else r=58;if((r|0)==58?(r=0,(hQb(o)|0)==0):0){K=c[H>>2]|0;r=61;break}o4d(a,v)}}else{K=q;r=61}while(0);do if(((r|0)==61?(r=0,(K|0)==1):0)?(q=c[I+(k<<7)+16>>2]|0,(q|0)!=0):0){c[j>>2]=q;H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(d,H,j);l=c[d>>2]|0;u=c[H+28>>2]|0;if((l|0)==-1){L=u+(c[H+32>>2]<<3)|0;break}else{L=u+(l<<3)|0;break}}else L=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if(!((L|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(c[L+4>>2]|0)!=0:0))r=71}else r=71;if((r|0)==71?(r=0,(hQb(q)|0)==0):0)break;p4d(a,v)}while(0);v=v+1|0;n=c[m>>2]|0}while(v>>>0<(((c[p>>2]|0)-n|0)/40|0)>>>0);i=b;return}function m4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;n4d(a);g=a+96|0;h=a+104|0;j=c[h>>2]|0;if(j){k=j;j=0;while(1){l=c[(c[g>>2]|0)+(j<<2)>>2]|0;m=l+56|0;if(!(c[m>>2]|0))n=k;else{o=l+44|0;kQb(c[o>>2]|0);c[o>>2]=0;c[m>>2]=0;n=c[h>>2]|0}j=j+1|0;if(j>>>0>=n>>>0)break;else k=n}}n=a+108|0;if((c[n>>2]|0)>-1){k=c[g>>2]|0;c[e>>2]=c[a+100>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[g>>2]=0}c[h>>2]=0;c[n>>2]=0;h=a+76|0;kQb(c[h>>2]|0);c[h>>2]=0;h=a+4|0;kQb(c[h>>2]|0);c[h>>2]=0;H4d(a+276|0);if((c[a+272>>2]|0)>-1){h=a+260|0;k=c[h>>2]|0;c[e>>2]=c[a+264>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[h>>2]=0}if((c[a+256>>2]|0)>-1){h=a+244|0;k=c[h>>2]|0;c[e>>2]=c[a+248>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[h>>2]=0}h=a+232|0;k=c[h>>2]|0;if(k){j=a+236|0;while(1){m=c[j>>2]|0;if((m|0)==(k|0))break;o=m+-148|0;c[j>>2]=o;I4d(o)}j=c[h>>2]|0;c[f>>2]=54;c[d+0>>2]=c[f+0>>2];eOb(j,d)}J4d(a+220|0);euc(a+192|0);if((c[a+184>>2]|0)>-1){j=a+172|0;f=c[j>>2]|0;c[e>>2]=c[a+176>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[j>>2]=0}if((c[a+168>>2]|0)>-1){j=a+156|0;f=c[j>>2]|0;c[e>>2]=c[a+160>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[j>>2]=0}if((c[a+152>>2]|0)>-1){j=a+140|0;f=c[j>>2]|0;c[e>>2]=c[a+144>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[j>>2]=0}K4d(a+116|0);j=c[a+112>>2]|0;if(j){P0d(j);ACi(j)}if((c[n>>2]|0)>-1){n=c[g>>2]|0;c[e>>2]=c[a+100>>2];c[d+0>>2]=c[e+0>>2];eOb(n,d);c[g>>2]=0}if((c[a+92>>2]|0)>-1){g=a+80|0;n=c[g>>2]|0;c[e>>2]=c[a+84>>2];c[d+0>>2]=c[e+0>>2];eOb(n,d);c[g>>2]=0}g=c[a+72>>2]|0;if(g){G4d(g);ACi(g)}g=a+8|0;if((c[a+36>>2]|0)>-1){n=a+24|0;j=c[n>>2]|0;c[e>>2]=c[a+28>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[n>>2]=0}if((c[a+20>>2]|0)<=-1){i=b;return}n=c[g>>2]|0;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];eOb(n,d);c[g>>2]=0;i=b;return}function n4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+152|0;if((c[f>>2]|0)>-1){g=a+140|0;h=c[g>>2]|0;c[e>>2]=c[a+144>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}c[a+148>>2]=0;c[f>>2]=0;f=a+116|0;c[180370]=f;g=a+156|0;h=a+164|0;j=c[h>>2]|0;if(j){k=j;j=0;while(1){l=c[(c[g>>2]|0)+(j*24|0)>>2]|0;if(!l)m=k;else{ko[c[(c[l>>2]|0)+4>>2]&4095](l);m=c[h>>2]|0}j=j+1|0;if(j>>>0>=m>>>0)break;else k=m}}m=a+168|0;if((c[m>>2]|0)>-1){k=c[g>>2]|0;c[e>>2]=c[a+160>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[g>>2]=0}c[h>>2]=0;c[m>>2]=0;m=a+184|0;if((c[m>>2]|0)>-1){h=a+172|0;g=c[h>>2]|0;c[e>>2]=c[a+176>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[h>>2]=0}c[a+180>>2]=0;c[m>>2]=0;luc(a+192|0);c[180370]=f;m=a+244|0;h=a+252|0;g=c[h>>2]|0;if(g){k=g;g=0;while(1){j=c[(c[m>>2]|0)+(g*24|0)>>2]|0;if(!j)n=k;else{ko[c[(c[j>>2]|0)+4>>2]&4095](j);n=c[h>>2]|0}g=g+1|0;if(g>>>0>=n>>>0)break;else k=n}}n=a+256|0;if((c[n>>2]|0)>-1){k=c[m>>2]|0;c[e>>2]=c[a+248>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[m>>2]=0}c[h>>2]=0;c[n>>2]=0;n=a+272|0;if((c[n>>2]|0)>-1){h=a+260|0;m=c[h>>2]|0;c[e>>2]=c[a+264>>2];c[d+0>>2]=c[e+0>>2];eOb(m,d);c[h>>2]=0}c[a+268>>2]=0;c[n>>2]=0;n=a+276|0;h=c[a+280>>2]|0;if((h|0)!=(n|0)){m=h;do{vjc(pjc()|0,m+8|0);h=m+32|0;if((c[h>>2]|0)>-1){k=m+20|0;g=c[k>>2]|0;c[e>>2]=c[m+24>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[k>>2]=0}c[m+28>>2]=0;c[h>>2]=0;m=c[m+4>>2]|0}while((m|0)!=(n|0))}H4d(n);n=c[a+232>>2]|0;m=a+236|0;while(1){h=c[m>>2]|0;if((h|0)==(n|0))break;k=h+-148|0;c[m>>2]=k;I4d(k)}m=c[a+220>>2]|0;n=a+224|0;a=c[n>>2]|0;if((a|0)==(m|0)){M4d(f,0);i=b;return}k=a;while(1){a=k+-40|0;c[n>>2]=a;h=c[k+-36>>2]|0;if(!h)o=a;else{a=k+-32|0;g=c[a>>2]|0;if((g|0)!=(h|0))c[a>>2]=g+(~(((g+-72-h|0)>>>0)/72|0)*72|0);c[e>>2]=54;c[d+0>>2]=c[e+0>>2];eOb(h,d);o=c[n>>2]|0}if((o|0)==(m|0))break;else k=o}M4d(f,0);i=b;return}function o4d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=Im,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;f=i;i=i+368|0;h=f+184|0;j=f+176|0;k=f+340|0;l=f+356|0;m=f+80|0;n=f+336|0;o=f+344|0;p=f+352|0;q=f+360|0;r=f+364|0;s=f+76|0;t=f+64|0;u=f;v=f+332|0;w=f+88|0;x=f+152|0;y=f+348|0;z=f+180|0;A=c[d>>2]|0;B=c[A+16>>2]|0;C=B+(e*40|0)|0;D=B+(e*40|0)+32|0;E=c[D>>2]|0;F=c[A+28>>2]|0;A=F+(E<<7)|0;G=c[d+220>>2]|0;H=F+(E<<7)+8|0;c[s>>2]=c[H>>2];I=c[137784]|0;if(I){do if((c[I+36>>2]|0)!=(c[I+4>>2]|0)){fRb(h,I,s);J=c[h>>2]|0;K=c[I+28>>2]|0;if((J|0)==-1){L=K+(c[I+32>>2]<<3)|0;break}else{L=K+(J<<3)|0;break}}else L=(c[I+28>>2]|0)+(c[I+32>>2]<<3)|0;while(0);I=c[137784]|0;if((L|0)!=((c[I+28>>2]|0)+(c[I+32>>2]<<3)|0)?(I=c[L+4>>2]|0,(I|0)!=0):0)M=I;else N=9}else N=9;if((N|0)==9)M=hQb(c[H>>2]|0)|0;H=d+244|0;I=d+252|0;c[(c[d+140>>2]|0)+(e<<2)>>2]=c[I>>2];O=ea(g[C>>2]);P=ea(O*ea(g[d+44>>2]));O=ea(g[B+(e*40|0)+4>>2]);Q=ea(O*ea(g[d+48>>2]));O=ea(g[B+(e*40|0)+8>>2]);R=ea(O*ea(g[d+52>>2]));O=ea(P+ea(g[d+60>>2]));P=ea(Q+ea(g[d+64>>2]));Q=ea(R+ea(g[d+68>>2]));g[t>>2]=O;g[t+4>>2]=P;g[t+8>>2]=Q;I3d(A,u,t,C);C=B+(e*40|0)+12|0;A=B+(e*40|0)+16|0;if(ea(g[C>>2])==ea(0.0))S=1;else S=ea(g[A>>2])==ea(0.0)&1;B=F+(E<<7)+12|0;L=c[B>>2]|0;do if(L){c[p>>2]=L;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(h,s,p);J=c[h>>2]|0;K=c[s+28>>2]|0;if((J|0)==-1){T=K+(c[s+32>>2]<<3)|0;break}else{T=K+(J<<3)|0;break}}else T=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((T|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(c[T+4>>2]|0)!=0:0)U=s;else N=21}else N=21;if((N|0)==21){if(!(hQb(c[B>>2]|0)|0)){V=0;W=0;break}U=c[137784]|0}c[o>>2]=c[B>>2];if(U){do if((c[U+36>>2]|0)!=(c[U+4>>2]|0)){fRb(h,U,o);s=c[h>>2]|0;J=c[U+28>>2]|0;if((s|0)==-1){X=J+(c[U+32>>2]<<3)|0;break}else{X=J+(s<<3)|0;break}}else X=(c[U+28>>2]|0)+(c[U+32>>2]<<3)|0;while(0);s=c[137784]|0;if((X|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[X+4>>2]|0,(s|0)!=0):0)Y=s;else N=31}else N=31;if((N|0)==31)Y=hQb(c[B>>2]|0)|0;s=Y+284|0;J=c[s>>2]|0;if(!J){V=-1;W=0}else{c[n>>2]=J;J=c[137784]|0;if(J){do if((c[J+36>>2]|0)!=(c[J+4>>2]|0)){fRb(h,J,n);K=c[h>>2]|0;Z=c[J+28>>2]|0;if((K|0)==-1){_=Z+(c[J+32>>2]<<3)|0;break}else{_=Z+(K<<3)|0;break}}else _=(c[J+28>>2]|0)+(c[J+32>>2]<<3)|0;while(0);J=c[137784]|0;if((_|0)!=((c[J+28>>2]|0)+(c[J+32>>2]<<3)|0)?(J=c[_+4>>2]|0,(J|0)!=0):0)$=J;else N=41}else N=41;if((N|0)==41)$=hQb(c[s>>2]|0)|0;V=-1;W=($|0)!=0}}else{V=0;W=0}while(0);$=M+48|0;_=M+44|0;n=(((c[$>>2]|0)-(c[_>>2]|0)|0)/28|0)+V|0;if(!(c[G+(E*40|0)+16>>2]|0))aa=-1;else{V=d+232|0;Y=d+236|0;X=((c[Y>>2]|0)-(c[V>>2]|0)|0)/148|0;U=h+4|0;c[U+0>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;c[U+12>>2]=0;c[U+16>>2]=0;c[U+20>>2]=0;Lbc(h+32|0);o=c[153116]|0;c[h+76>>2]=0;c[h+80>>2]=o;c[h+84>>2]=0;c[h+88>>2]=0;c[h+92>>2]=0;c[h+96>>2]=o;c[h+100>>2]=0;c[h+104>>2]=0;T=c[155410]|0;c[h+108>>2]=T;c[h+112>>2]=0;c[h+116>>2]=o;c[h+120>>2]=0;c[h+124>>2]=0;c[h+128>>2]=0;c[h+132>>2]=o;c[h+136>>2]=0;c[h+140>>2]=0;c[h+144>>2]=T;b[h>>1]=0;b[h+2>>1]=c[D>>2];Wlc(F+(E<<7)+100|0,u,U);c[h+28>>2]=c[G+(E*40|0)+20>>2];U=c[Y>>2]|0;if((U|0)==(c[d+240>>2]|0))O4d(V,h);else{if(!U)ba=0;else{V=U+0|0;F=h+0|0;T=V+76|0;do{b[V>>1]=b[F>>1]|0;V=V+2|0;F=F+2|0}while((V|0)<(T|0));N4d(U+76|0,h+76|0);N4d(U+112|0,h+112|0);ba=c[Y>>2]|0}c[Y>>2]=ba+148}if((n|0)>0)Rbc((c[Y>>2]|0)+-72|0,0);if(W)Rbc((c[Y>>2]|0)+-36|0,1);I4d(h);aa=X}Q=ea(g[C>>2]);P=ea(g[A>>2]);O=ea(g[G+(E*40|0)+28>>2]);R=ea(g[G+(E*40|0)+36>>2]);ca=ea(Q*(O<R?R:O));O=ea(P*ea(g[G+(E*40|0)+32>>2]));X=d+192|0;Y=iuc(X,M,t,ea(ea(g[M+40>>2])*(ca<O?O:ca)))|0;if((n|0)>0){ba=G+(E*40|0)+4|0;U=G+(E*40|0)+8|0;E=d+116|0;G=d+188|0;F=Y&65535;V=d+260|0;T=0;do{o=Ytc(M,T)|0;p=o+20|0;if(c[p>>2]|0){L=o+12|0;o=0;do{J=c[(c[L>>2]|0)+(o<<2)>>2]|0;do if(J){c[l>>2]=J;K=c[137784]|0;if(K){do if((c[K+36>>2]|0)!=(c[K+4>>2]|0)){fRb(h,K,l);Z=c[h>>2]|0;fa=c[K+28>>2]|0;if((Z|0)==-1){ga=fa+(c[K+32>>2]<<3)|0;break}else{ga=fa+(Z<<3)|0;break}}else ga=(c[K+28>>2]|0)+(c[K+32>>2]<<3)|0;while(0);K=c[137784]|0;if((ga|0)!=((c[K+28>>2]|0)+(c[K+32>>2]<<3)|0)?(K=c[ga+4>>2]|0,(K|0)!=0):0)ha=K;else N=67}else N=67;if((N|0)==67){N=0;K=hQb(J)|0;if(!K)break;else ha=K}K=(da(c[137788]|0,(c[ha+8>>2]|0)>>>21)|0)+23|0;Z=K>>5;if(!((ha|0)==0?1:(1<<K-(Z<<5)&c[(c[137786]|0)+(Z<<2)>>2]|0)==0)?(Ohc(v,ha),Z=c[v>>2]|0,(Z|0)!=0):0){c[k>>2]=Z;Z=c[137784]|0;if(Z){do if((c[Z+36>>2]|0)!=(c[Z+4>>2]|0)){fRb(h,Z,k);K=c[h>>2]|0;fa=c[Z+28>>2]|0;if((K|0)==-1){ia=fa+(c[Z+32>>2]<<3)|0;break}else{ia=fa+(K<<3)|0;break}}else ia=(c[Z+28>>2]|0)+(c[Z+32>>2]<<3)|0;while(0);Z=c[137784]|0;if(!((ia|0)!=((c[Z+28>>2]|0)+(c[Z+32>>2]<<3)|0)?(c[ia+4>>2]|0)!=0:0))N=78}else N=78;if((N|0)==78?(N=0,(hQb(c[v>>2]|0)|0)==0):0)break;Z=c[ba>>2]|0;K=c[U>>2]|0;if((K|0)==(Z|0))ja=Z;else{fa=Z;ka=(K-Z|0)/72|0;while(1){Z=(ka|0)/2|0;if((c[fa+(Z*72|0)>>2]|0)<(J|0)){la=fa+((Z+1|0)*72|0)|0;ma=ka+-1-Z|0}else{la=fa;ma=Z}if(!ma){ja=la;break}else{fa=la;ka=ma}}}if((ja|0)==(K|0))na=K;else na=(J|0)<(c[ja>>2]|0)?K:ja;dMc(u,na+4|0,h);c[180370]=E;ka=P4d(E,272,4)|0;N3d(ka,d,e,ha,h,aa);fa=c[G>>2]|0;do if((fa|0)!=-1){Z=ka+176|0;if(!(c[Z>>2]|0))break;c[Z>>2]=2;c[ka+180>>2]=(c[ka+252>>2]|0)+fa}while(0);fa=Q4d(H)|0;c[fa>>2]=ka;c[fa+4>>2]=mo[c[(c[ka>>2]|0)+28>>2]&4095](ka)|0;b[fa+12>>1]=c[X>>2];b[fa+14>>1]=F;c[fa+16>>2]=c[na+68>>2];a[fa+22>>0]=S;Y_b(ka,R4d(V)|0)}}while(0);o=o+1|0}while(o>>>0<(c[p>>2]|0)>>>0)}T=T+1|0}while((T|0)<(n|0))}if(!W){i=f;return}c[j>>2]=c[B>>2];W=c[137784]|0;if(W){do if((c[W+36>>2]|0)!=(c[W+4>>2]|0)){fRb(h,W,j);n=c[h>>2]|0;T=c[W+28>>2]|0;if((n|0)==-1){oa=T+(c[W+32>>2]<<3)|0;break}else{oa=T+(n<<3)|0;break}}else oa=(c[W+28>>2]|0)+(c[W+32>>2]<<3)|0;while(0);W=c[137784]|0;if((oa|0)!=((c[W+28>>2]|0)+(c[W+32>>2]<<3)|0)?(W=c[oa+4>>2]|0,(W|0)!=0):0)pa=W;else N=101}else N=101;if((N|0)==101)pa=hQb(c[B>>2]|0)|0;W=c[pa+284>>2]|0;pa=d+276|0;oa=d+280|0;while(1){j=c[oa>>2]|0;if((j|0)!=(pa|0)?(c[j+8>>2]|0)!=(W|0):0)oa=j+4|0;else{qa=j;break}}oa=d+116|0;c[180370]=oa;pa=P4d(oa,276,4)|0;c[m>>2]=c[B>>2];oa=c[137784]|0;if(oa){do if((c[oa+36>>2]|0)!=(c[oa+4>>2]|0)){fRb(h,oa,m);j=c[h>>2]|0;n=c[oa+28>>2]|0;if((j|0)==-1){ra=n+(c[oa+32>>2]<<3)|0;break}else{ra=n+(j<<3)|0;break}}else ra=(c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0;while(0);oa=c[137784]|0;if((ra|0)!=((c[oa+28>>2]|0)+(c[oa+32>>2]<<3)|0)?(oa=c[ra+4>>2]|0,(oa|0)!=0):0)sa=oa;else N=112}else N=112;if((N|0)==112)sa=hQb(c[B>>2]|0)|0;Q3d(pa,d,e,aa,W,(c[sa+204>>2]|0)==1);kMc(w,t)|0;t=(c[(c[d>>2]|0)+28>>2]|0)+(c[D>>2]<<7)+100|0;c[x+0>>2]=c[t+0>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];c[x+12>>2]=c[t+12>>2];c[x+16>>2]=c[t+16>>2];c[x+20>>2]=c[t+20>>2];ca=ea(g[C>>2]);O=ea(g[A>>2]);P=ea(ca*ea(g[x>>2]));A=x+4|0;R=ea(O*ea(g[A>>2]));C=x+8|0;Q=ea(ca*ea(g[C>>2]));g[x>>2]=P;g[A>>2]=R;g[C>>2]=Q;C=x+12|0;Q=ea(ca*ea(g[C>>2]));A=x+16|0;R=ea(O*ea(g[A>>2]));t=x+20|0;O=ea(ca*ea(g[t>>2]));g[C>>2]=Q;g[A>>2]=R;g[t>>2]=O;c[y>>2]=0;L3b(pa,w,x,y,0,0,0);y=qa+12|0;x=c[y>>2]|0;do if(x){c[q>>2]=x;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(h,w,q);t=c[h>>2]|0;A=c[w+28>>2]|0;if((t|0)==-1){ta=A+(c[w+32>>2]<<3)|0;break}else{ta=A+(t<<3)|0;break}}else ta=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((ta|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[ta+4>>2]|0,(w|0)!=0):0)ua=w;else N=122}else N=122;if((N|0)==122){w=hQb(x)|0;if(!w){N=124;break}else ua=w}w=(da(c[137788]|0,(c[ua+8>>2]|0)>>>21)|0)+21|0;t=w>>5;if(1<<w-(t<<5)&c[(c[137786]|0)+(t<<2)>>2])va=ua;else N=124}else N=124;while(0);if((N|0)==124)va=0;ua=qa+16|0;x=c[ua>>2]|0;do if(x){c[r>>2]=x;ta=c[137784]|0;if(ta){do if((c[ta+36>>2]|0)!=(c[ta+4>>2]|0)){fRb(h,ta,r);q=c[h>>2]|0;t=c[ta+28>>2]|0;if((q|0)==-1){wa=t+(c[ta+32>>2]<<3)|0;break}else{wa=t+(q<<3)|0;break}}else wa=(c[ta+28>>2]|0)+(c[ta+32>>2]<<3)|0;while(0);ta=c[137784]|0;if((wa|0)!=((c[ta+28>>2]|0)+(c[ta+32>>2]<<3)|0)?(ta=c[wa+4>>2]|0,(ta|0)!=0):0)xa=ta;else N=134}else N=134;if((N|0)==134){ta=hQb(x)|0;if(!ta){N=136;break}else xa=ta}ta=(da(c[137788]|0,(c[xa+8>>2]|0)>>>21)|0)+43|0;q=ta>>5;if(1<<ta-(q<<5)&c[(c[137786]|0)+(q<<2)>>2])ya=xa;else N=136}else N=136;while(0);if((N|0)==136)ya=0;T3d(pa,va,ya);ya=c[d+188>>2]|0;if((ya|0)!=-1?(va=pa+176|0,(c[va>>2]|0)!=0):0){c[va>>2]=2;c[pa+180>>2]=(c[pa+252>>2]|0)+ya}c[z>>2]=c[I>>2];S4d(qa+20|0,z);z=Q4d(H)|0;c[z>>2]=pa;if(!(c[y>>2]|0))za=1;else za=(c[ua>>2]|0)==0&1;ua=z+22|0;a[ua>>0]=za;c[z+4>>2]=mo[c[(c[pa>>2]|0)+28>>2]&4095](pa)|0;b[z+12>>1]=c[X>>2];b[z+14>>1]=Y;c[z+16>>2]=1<<(((c[$>>2]|0)-(c[_>>2]|0)|0)/28|0)+-1;a[ua>>0]=S;Y_b(pa,R4d(d+260|0)|0);i=f;return}function p4d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=0,F=0,G=0,H=0;e=i;i=i+128|0;f=e+112|0;h=e+104|0;j=e+40|0;k=e+24|0;l=e;m=c[b>>2]|0;n=c[m+16>>2]|0;o=n+(d*40|0)+32|0;p=c[o>>2]|0;q=c[m+28>>2]|0;m=b+156|0;c[(c[b+140>>2]|0)+(d<<2)>>2]=c[b+164>>2];r=ea(g[n+(d*40|0)>>2]);s=ea(r*ea(g[b+44>>2]));r=ea(g[n+(d*40|0)+4>>2]);t=ea(r*ea(g[b+48>>2]));r=ea(g[n+(d*40|0)+8>>2]);u=ea(r*ea(g[b+52>>2]));r=ea(s+ea(g[b+60>>2]));s=ea(t+ea(g[b+64>>2]));t=ea(u+ea(g[b+68>>2]));g[k>>2]=r;g[k+4>>2]=s;g[k+8>>2]=t;kMc(j,k)|0;k=b+116|0;c[180370]=k;v=P4d(k,264,4)|0;if((c[q+(p<<7)+4>>2]|0)==1?(k=c[q+(p<<7)+16>>2]|0,(k|0)!=0):0){c[h>>2]=k;w=c[137784]|0;if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(f,w,h);x=c[f>>2]|0;y=c[w+28>>2]|0;if((x|0)==-1){z=y+(c[w+32>>2]<<3)|0;break}else{z=y+(x<<3)|0;break}}else z=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);w=c[137784]|0;if((z|0)!=((c[w+28>>2]|0)+(c[w+32>>2]<<3)|0)?(w=c[z+4>>2]|0,(w|0)!=0):0)A=w;else B=11}else B=11;if((B|0)==11)A=hQb(k)|0;C=A}else C=0;A=(c[(c[b>>2]|0)+28>>2]|0)+(c[o>>2]<<7)+100|0;c[l+0>>2]=c[A+0>>2];c[l+4>>2]=c[A+4>>2];c[l+8>>2]=c[A+8>>2];c[l+12>>2]=c[A+12>>2];c[l+16>>2]=c[A+16>>2];c[l+20>>2]=c[A+20>>2];A=n+(d*40|0)+12|0;t=ea(g[A>>2]);o=n+(d*40|0)+16|0;s=ea(g[o>>2]);r=ea(t*ea(g[l>>2]));n=l+4|0;u=ea(s*ea(g[n>>2]));k=l+8|0;D=ea(t*ea(g[k>>2]));g[l>>2]=r;g[n>>2]=u;g[k>>2]=D;k=l+12|0;D=ea(t*ea(g[k>>2]));n=l+16|0;u=ea(s*ea(g[n>>2]));B=l+20|0;s=ea(t*ea(g[B>>2]));g[k>>2]=D;g[n>>2]=u;g[B>>2]=s;K3d(v,b,d,C,q+(p<<7)+36|0,j,l);l=Q4d(m)|0;c[l>>2]=v;c[l+4>>2]=mo[c[(c[v>>2]|0)+28>>2]&4095](v)|0;if(ea(g[A>>2])==ea(0.0)){E=1;F=l+22|0;a[F>>0]=E;G=b+172|0;H=R4d(G)|0;Y_b(v,H);i=e;return}E=ea(g[o>>2])==ea(0.0)&1;F=l+22|0;a[F>>0]=E;G=b+172|0;H=R4d(G)|0;Y_b(v,H);i=e;return}function q4d(a){a=a|0;var b=0;b=i;r4d(a,500);i=b;return}function r4d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[b>>2]|0;if(j){F4d(h,j,b+60|0,b+44|0,d);d=c[h>>2]|0;c[h>>2]=0;h=b+72|0;j=c[h>>2]|0;if(!((j|0)==(d|0)|(j|0)==0)){G4d(j);ACi(j)}c[h>>2]=d;d=b+108|0;if((c[d>>2]|0)>-1){h=b+96|0;j=c[h>>2]|0;c[g>>2]=c[b+100>>2];c[f+0>>2]=c[g+0>>2];eOb(j,f);c[h>>2]=0}c[b+104>>2]=0;c[d>>2]=0}d=b+92|0;if((c[d>>2]|0)<=-1){k=b+88|0;c[k>>2]=0;c[d>>2]=0;l=b+136|0;a[l>>0]=1;i=e;return}h=b+80|0;j=c[h>>2]|0;c[g>>2]=c[b+84>>2];c[f+0>>2]=c[g+0>>2];eOb(j,f);c[h>>2]=0;k=b+88|0;c[k>>2]=0;c[d>>2]=0;l=b+136|0;a[l>>0]=1;i=e;return}function s4d(b,d,e,f,j,k,l,m){b=b|0;d=d|0;e=e|0;f=ea(f);j=ea(j);k=ea(k);l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=Im,ca=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=Im,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=Im,ya=Im,za=Im,Aa=Im,Ba=Im,Ca=Im,Da=Im,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=0,db=Im,eb=0,fb=0,gb=0,hb=0,ib=Im,jb=Im,kb=Im,lb=Im;l=i;i=i+528|0;n=l;o=l+312|0;p=l+184|0;q=l+168|0;r=l+64|0;s=l+352|0;t=l+196|0;u=l+208|0;v=l+224|0;w=l+240|0;x=l+256|0;y=l+272|0;z=l+288|0;A=l+304|0;B=l+308|0;C=l+160|0;D=l+328|0;E=l+332|0;F=l+336|0;G=l+340|0;H=l+344|0;I=l+348|0;J=l+356|0;K=l+360|0;L=l+368|0;M=l+392|0;N=l+408|0;O=l+472|0;P=l+488|0;Q=l+504|0;R=c[158074]|0;if(!(c[b>>2]|0)){i=l;return}S=b+136|0;if(!(a[S>>0]|0))t4d(b);else{n4d(b);l4d(b);a[S>>0]=0}u4d(b,0,m);c[b+56>>2]=m;g[r>>2]=ea(0.0);g[r+4>>2]=ea(0.0);g[r+8>>2]=ea(0.0);g[r+16>>2]=ea(0.0);g[r+20>>2]=ea(0.0);g[r+24>>2]=ea(0.0);g[r+32>>2]=ea(0.0);g[r+36>>2]=ea(0.0);g[r+40>>2]=ea(0.0);g[r+48>>2]=ea(0.0);g[r+52>>2]=ea(0.0);g[r+56>>2]=ea(0.0);g[r+64>>2]=ea(0.0);g[r+68>>2]=ea(0.0);g[r+72>>2]=ea(0.0);g[r+80>>2]=ea(0.0);g[r+84>>2]=ea(0.0);g[r+88>>2]=ea(0.0);r1b(N$b(d)|0,r);S=b+72|0;if(!(c[S>>2]|0)){U=b+92|0;if((c[U>>2]|0)>-1){X=b+80|0;Y=c[X>>2]|0;c[o>>2]=c[b+84>>2];c[n+0>>2]=c[o+0>>2];eOb(Y,n);c[X>>2]=0}c[b+88>>2]=0;c[U>>2]=0;i=l;return}mBc(1);U=rBc()|0;X=b+112|0;Y=a[(c[X>>2]|0)+28>>0]|0;if(U^Y<<24>>24!=0){U=xCi(120)|0;O0d(U,c[b>>2]|0);Z=c[X>>2]|0;if(!((Z|0)==(U|0)|(Z|0)==0)){P0d(Z);ACi(Z)}c[X>>2]=U;U=c[b+4>>2]|0;c[n>>2]=-1;itd(n,791824);c[s>>2]=c[n>>2];Z=c[X>>2]|0;_=c[((a[Z+40>>0]|0)==0?Z+20|0:Z+24|0)>>2]|0;c[n+0>>2]=c[s+0>>2];rkd(U,n,_);$=a[(c[X>>2]|0)+28>>0]|0}else $=Y;if($<<24>>24){aa=f<j?f:j;ba=ea(f-aa);if(k<ea(0.0)){ca=ea(0.0);fa=aa;ga=f}else{ha=aa;ia=ba;ja=k;ka=f;la=16}}else{ha=j;ia=ea(j-j);ja=ea(0.0);ka=j;la=16}if((la|0)==16){ca=ja>ia?ia:ja;fa=ha;ga=ka}ka=ea(ga*ga);ga=ea(fa+ca);fa=ea(ga*ga);$=BTb(c[d+24>>2]|0)|0;rGc(t,$);TGc(u,$,601200);$=b+100|0;Y=c[$>>2]|0;_=b+96|0;U=c[_>>2]|0;s=b+104|0;Z=c[s>>2]|0;ma=Z<<2;na=ma>>2;oa=(na|0)==0;if(oa){pa=0;qa=0}else{c[o>>2]=Y;c[n+0>>2]=c[o+0>>2];ra=hOb(0,ma,4,n,0,3653512,370)|0;YEi(ra|0,U|0,ma|0)|0;ma=Z<<2>>2;Z=0;do{U=(c[ra+(Z<<2)>>2]|0)+56|0;if((c[U>>2]|0)==1)c[U>>2]=-1;Z=Z+1|0}while((Z|0)!=(ma|0));pa=ra;qa=na}ra=b+108|0;if((c[ra>>2]|0)>-1){ma=c[_>>2]|0;c[o>>2]=c[$>>2];c[n+0>>2]=c[o+0>>2];eOb(ma,n);c[_>>2]=0}c[s>>2]=0;c[ra>>2]=0;ra=b+88|0;c[ra>>2]=0;ma=c[153134]|0;c[v>>2]=0;$=v+4|0;c[$>>2]=ma;ma=v+8|0;c[ma>>2]=0;Z=v+12|0;c[Z>>2]=0;v4d(b,c[S>>2]|0,r,v,t,fa,ka);if(!oa){oa=0;do{t=c[pa+(oa<<2)>>2]|0;r=t+56|0;if((c[r>>2]|0)==-1){S=t+44|0;kQb(c[S>>2]|0);c[S>>2]=0;c[r>>2]=0}oa=oa+1|0}while(oa>>>0<na>>>0)}na=c[v>>2]|0;oa=na+(c[ma>>2]<<2)|0;c[n>>2]=(c[b>>2]|0)+16;T4d(na,oa,n);oa=c[e>>2]|0;na=(c[e+4>>2]|0)-oa>>2;r=(na|0)>4?4:na;if((r|0)>0){na=w+4|0;S=w+8|0;t=w+12|0;U=R+20|0;sa=x+4|0;ta=x+8|0;ua=x+12|0;va=oa;oa=0;while(1){wa=c[va+(oa<<2)>>2]|0;oGc(w,BTb(c[wa+24>>2]|0)|0);ha=ea(g[w>>2]);ja=ea(-ha);ia=ea(g[na>>2]);j=ea(-ia);f=ea(g[S>>2]);k=ea(-ea(g[t>>2]));ba=ea(ha*ea(-2.0));ha=ea(ia*ea(-2.0));ia=ea(f*ea(-2.0));aa=ea(ba*ja);xa=ea(ha*j);ya=ea(f*ia);f=ea(ha*ja);za=ea(ia*ja);ja=ea(ia*j);j=ea(ba*k);ba=ea(ha*k);ha=ea(ia*k);k=ea(ea(1.0)-ea(xa-ya));ia=ea(g[150300]);Aa=ea(ia*k);k=ea(f-ha);Ba=ea(g[150301]);Ca=ea(ea(Ba*k)+Aa);Aa=ea(za+ba);k=ea(g[150302]);Da=ea(-ea(ea(ea(ja-j)*k)+ea(ea(ia*ea(f+ha))+ea(Ba*ea(ea(1.0)-ea(aa-ya))))));ya=ea(-ea(ea(ea(ea(1.0)-ea(aa+xa))*k)+ea(ea(ia*ea(za-ba))+ea(Ba*ea(ja+j)))));g[x>>2]=ea(-ea(ea(Aa*k)+Ca));g[sa>>2]=Da;g[ta>>2]=ya;g[ua>>2]=ea(0.0);oud(U,721776+(oa<<2)|0,x);Ea=wa+152|0;c[y+0>>2]=c[Ea+0>>2];c[y+4>>2]=c[Ea+4>>2];c[y+8>>2]=c[Ea+8>>2];c[y+12>>2]=c[Ea+12>>2];oud(U,721920+(oa<<2)|0,y);Ea=oa+1|0;if((Ea|0)>=(r|0))break;va=c[e>>2]|0;oa=Ea}if((r|0)<4)la=31}else la=31;if((la|0)==31){oa=R+20|0;R=r;do{c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;oud(oa,721920+(R<<2)|0,z);R=R+1|0}while((R|0)<4)}R=c[X>>2]|0;if(((a[R+28>>0]|0)!=0?Q0d(R,d)|0:0)?(R=b+4|0,z=c[R>>2]|0,c[n>>2]=-1,itd(n,791824),c[A>>2]=c[n>>2],c[n+0>>2]=c[A+0>>2],pkd(z,n)|0):0){z=c[R>>2]|0;c[n>>2]=-1;itd(n,791824);c[B>>2]=c[n>>2];R=c[X>>2]|0;A=c[((a[R+40>>0]|0)==0?R+20|0:R+24|0)>>2]|0;c[n+0>>2]=c[B+0>>2];rkd(z,n,A)}w4d(b,d,ka);if(c[s>>2]|0){A=b+4|0;z=b+8|0;B=0;do{R=c[(c[(c[_>>2]|0)+(B<<2)>>2]|0)+44>>2]|0;oa=c[A>>2]|0;ZLc(n)|0;c[o>>2]=c[oa+4>>2];c[(e4b(n,R,o,m,1,1,0,d)|0)+168>>2]=z;B=B+1|0}while(B>>>0<(c[s>>2]|0)>>>0)}if(!((c[ma>>2]|0)==0?1:(a[(c[X>>2]|0)+28>>0]|0)==0)){ma=b+76|0;s=c[ma>>2]|0;if(!s){c[C>>2]=c[153106];c[n+0>>2]=c[C+0>>2];C=_jc(4,n)|0;c[ma>>2]=C;In[c[(c[C>>2]|0)+44>>2]&4095](C,61);Eec(c[ma>>2]|0);Fa=c[ma>>2]|0}else Fa=s;x4d(b,Fa,v,1);Fa=c[ma>>2]|0;ma=c[b+4>>2]|0;ZLc(n)|0;c[o>>2]=c[ma+4>>2];c[(e4b(n,Fa,o,m,1,1,0,d)|0)+168>>2]=b+8}d=jLc()|0;ka=ea(+h[d+88>>3]+ +h[d+160>>3]);c[n>>2]=-1;itd(n,722232);c[D>>2]=c[n>>2];c[n>>2]=-1;itd(n,722256);c[E>>2]=c[n>>2];c[n>>2]=-1;itd(n,722280);c[F>>2]=c[n>>2];c[n>>2]=-1;itd(n,722304);c[G>>2]=c[n>>2];c[n>>2]=-1;itd(n,722328);c[H>>2]=c[n>>2];c[n>>2]=-1;itd(n,722344);c[I>>2]=c[n>>2];g[J>>2]=ea(1.0);d=c[X>>2]|0;if(a[d+28>>0]|0)S0d(d,K,J);K=b+140|0;d=c[b>>2]|0;X=d+16|0;Fa=b+80|0;ma=c[Fa>>2]|0;s=c[ra>>2]|0;C=ma+(s<<2)|0;a:do if(!s){Ga=ma;la=53}else{B=c[K>>2]|0;z=ma;while(1){A=c[z>>2]|0;if((c[B+(A<<2)>>2]|0)==-1){Ga=z;la=53;break a}if(ea(g[(c[X>>2]|0)+(A*40|0)+36>>2])>=fa){Ga=z;la=53;break a}z=z+4|0;if((z|0)==(C|0)){Ha=C;break}}}while(0);b:do if((la|0)==53)if((Ga|0)!=(C|0)){s=Ga+4|0;if((s|0)==(C|0))Ha=Ga;else{z=c[K>>2]|0;B=Ga;A=s;while(1){s=A;while(1){_=c[s>>2]|0;if((c[z+(_<<2)>>2]|0)!=-1?!(ea(g[(c[X>>2]|0)+(_*40|0)+36>>2])>=fa):0){Ia=s;Ja=_;break}s=s+4|0;if((s|0)==(C|0)){Ha=B;break b}}c[B>>2]=Ja;s=B+4|0;A=Ia+4|0;if((A|0)==(C|0)){Ha=s;break}else B=s}}}else Ha=C;while(0);C=c[ra>>2]|0;Ia=ma+(C<<2)-Ha>>2;c[ra>>2]=C-Ia;Ha=c[153134]|0;c:do if((C|0)!=(Ia|0)){Ja=b+156|0;X=ca<ea(0.0);fa=ea(-ca);Ga=b+60|0;la=b+64|0;B=b+68|0;A=b+44|0;z=b+48|0;s=b+52|0;_=L+4|0;R=L+8|0;oa=L+12|0;r=L+16|0;e=L+20|0;va=M+4|0;y=M+8|0;U=M+12|0;x=n+8|0;ya=ea(ka*ea(4.69999981));Da=ea(ka*ea(4.30000019));ua=n+12|0;ta=p+4|0;sa=p+8|0;t=o+12|0;S=o+8|0;na=o+4|0;w=q+4|0;Ea=q+8|0;wa=q+12|0;Ka=u+4|0;La=u+8|0;Ma=c[155410]|0;Na=P+4|0;Oa=P+8|0;Pa=P+12|0;Qa=Q+4|0;Ra=Q+8|0;Sa=Q+12|0;Ta=ma;Ua=d;Va=0;while(1){Wa=c[Ta+(Va<<2)>>2]|0;Xa=c[Ua+16>>2]|0;Ya=c[(c[K>>2]|0)+(Wa<<2)>>2]|0;Za=c[Ja>>2]|0;_a=c[Za+(Ya*24|0)>>2]|0;$a=c[Xa+(Wa*40|0)+32>>2]|0;ab=c[Ua+28>>2]|0;if(!((X?fa:ca)<=ea(9.99999997e-07))){Ca=ea(ea(ga-ea(T(ea(g[Xa+(Wa*40|0)+36>>2]))))/ca);if(Ca<ea(0.0))bb=ea(0.0);else{cb=Ca>ea(1.0);bb=cb?ea(1.0):Ca}Ca=ea(ea(bb*ea(bb*ea(3.0)))+ea(bb*ea(bb*ea(bb*ea(-2.0)))));db=ea(Ca+ea(ea(ea(1.0)-Ca)*ea(0.0)))}else db=ea(1.0);Ca=ea(db+ea(ea(ea(1.0)-db)*ea(.0399999991)));cb=db>=ea(1.0);c[L+0>>2]=0;c[L+4>>2]=0;c[L+8>>2]=0;c[L+12>>2]=0;c[L+16>>2]=0;c[L+20>>2]=0;k=ea(g[Ga>>2]);Aa=ea(g[la>>2]);j=ea(g[B>>2]);ja=ea(g[A>>2]);Ba=ea(g[z>>2]);ba=ea(g[s>>2]);za=ea(ja*ea(g[Xa+(Wa*40|0)>>2]));ja=ea(Ba*ea(g[Xa+(Wa*40|0)+4>>2]));Ba=ea(k+za);za=ea(Aa+ja);ja=ea(j+ea(ba*ea(g[Xa+(Wa*40|0)+8>>2])));eb=Xa+(Wa*40|0)+12|0;ba=ea(g[eb>>2]);fb=Xa+(Wa*40|0)+16|0;j=ea(g[fb>>2]);Aa=ea(ba*ea(g[ab+($a<<7)+112>>2]));k=ea(j*ea(g[ab+($a<<7)+116>>2]));j=ea(ba*ea(g[ab+($a<<7)+120>>2]));g[L>>2]=Ba;g[_>>2]=za;g[R>>2]=ja;g[oa>>2]=Aa;g[r>>2]=k;g[e>>2]=j;gb=c[Xa+(Wa*40|0)+24>>2]|0;hb=c[Xa+(Wa*40|0)+28>>2]|0;Wa=gb>>>8;j=ea(ea((da((hb>>>8&255)+1|0,Wa&255)|0)>>>8&255|0)/ea(255.0));k=ea(ea((da((hb>>>16&255)+1|0,gb&16711680)|0)>>>24|0)/ea(255.0));Aa=ea(ea((da((hb>>>24)+1|0,Wa&16711680)|0)>>>24|0)/ea(255.0));g[M>>2]=ea(ea((da((hb&255)+1|0,gb&255)|0)>>>8&255|0)/ea(255.0));g[va>>2]=j;g[y>>2]=k;g[U>>2]=Aa;Aa=ea(db*ea(g[ab+($a<<7)+124>>2]));ecc(n,acc()|0,L);k=ea(g[x>>2]);j=ea(g[n>>2]);ja=ea(T(ea(ea(ea(k*k)+ea(0.0))+ea(j*j))));if(ja>ea(9.99999974e-06)){ib=ea(k/ja);jb=ea(ea(0.0)/ja);kb=ea(ea(-j)/ja);lb=ja}else{ib=k;jb=ea(0.0);kb=ea(1.0);lb=ea(0.0)}k=ea(g[L>>2]);ja=ea(Cbc(ea(ea(k*ea(.219999999))-ya),ea(k*ea(9.00500011))));k=ea(g[R>>2]);j=ea(ea(ea(ja+ea(.689999997))/ea(1.48300004))*ea(.699999988));ja=ea(ea(ea(ea(Cbc(ea(ea(k*ea(.219999999))-Da),ea(k*ea(9.00500011))))+ea(.689999997))/ea(1.48300004))*ea(.5));k=ea(Aa*ea(.0174532924));za=ea(k*ea(g[ua>>2]));k=ea(za*ea(0.0));Ba=ea(ja*za);g[p>>2]=ea(j*za);g[ta>>2]=k;g[sa>>2]=Ba;DMc(o,p);Ba=ea(ea(ea(ea(Aa*ea(7.0))*ea(.0174532924))*lb)*ea(.5));Aa=ea(+W(+Ba));k=ea(+V(+Ba));Ba=ea(ib*Aa);za=ea(jb*Aa);j=ea(kb*Aa);Aa=ea(g[o>>2]);ja=ea(k*Aa);ba=ea(g[t>>2]);ia=ea(ja+ea(Ba*ba));ja=ea(g[S>>2]);xa=ea(ia+ea(za*ja));ia=ea(g[na>>2]);aa=ea(ea(ea(j*Aa)+ea(ea(za*ba)+ea(k*ia)))-ea(Ba*ja));ha=ea(ea(ea(ea(j*ba)+ea(k*ja))+ea(Ba*ia))-ea(za*Aa));f=ea(ea(ea(ea(k*ba)-ea(Ba*Aa))-ea(za*ia))-ea(j*ja));g[q>>2]=ea(xa-ea(j*ia));g[w>>2]=aa;g[Ea>>2]=ha;g[wa>>2]=f;vMc(N,601136,q,601152);c[O+0>>2]=c[n+0>>2];c[O+4>>2]=c[n+4>>2];c[O+8>>2]=c[n+8>>2];c[O+12>>2]=c[n+12>>2];f=ea(g[ab+($a<<7)+92>>2]);ha=ea(ea(f*ea(g[eb>>2]))*ea(.5));f=ea(g[u>>2]);aa=ea(g[Ka>>2]);ia=ea(g[La>>2]);$a=_a+204|0;c[$a+8>>2]=0;c[$a+24>>2]=0;c[$a+32>>2]=Ma;qld($a,D,N);old($a,E,M);j=ea(g[eb>>2]);xa=ea(g[fb>>2]);g[P>>2]=j;g[Na>>2]=xa;g[Oa>>2]=j;g[Pa>>2]=ea(1.0);old($a,F,P);j=ea(ha*ea(g[J>>2]));g[Q>>2]=f;g[Qa>>2]=aa;g[Ra>>2]=ia;g[Sa>>2]=j;old($a,G,Q);nld($a,H,Ca);old($a,I,O);xld($a);M3d(_a,cb);c[Za+(Ya*24|0)+4>>2]=m;Ya=Va+1|0;if(Ya>>>0>=(c[ra>>2]|0)>>>0)break c;Ta=c[Fa>>2]|0;Ua=c[b>>2]|0;Va=Ya}}while(0);c[o>>2]=Ha;c[n+0>>2]=c[o+0>>2];eOb(0,n);c[o>>2]=Ha;c[n+0>>2]=c[o+0>>2];eOb(0,n);if((c[Z>>2]|0)>-1){Z=c[v>>2]|0;c[o>>2]=c[$>>2];c[n+0>>2]=c[o+0>>2];eOb(Z,n);c[v>>2]=0}if((qa|0)>-1){c[o>>2]=Y;c[n+0>>2]=c[o+0>>2];eOb(pa,n)}mBc(0);i=l;return}function t4d(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b+8|0;f=b;g=a+224|0;h=a+220|0;j=c[h>>2]|0;if((c[g>>2]|0)==(j|0)){i=b;return}k=j;j=0;l=0;while(1){m=k+(l*40|0)+16|0;n=c[m>>2]|0;if(!n){o=0;p=k}else{c[f>>2]=n;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(d,n,f);q=c[d>>2]|0;r=c[n+28>>2]|0;if((q|0)==-1){s=r+(c[n+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((s|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[s+4>>2]|0,(n|0)!=0):0)t=n;else u=12}else u=12;if((u|0)==12){u=0;t=hQb(c[m>>2]|0)|0}o=t;p=c[h>>2]|0}n=p+(l*40|0)+20|0;if((c[n>>2]|0)==(o|0))v=j;else{c[n>>2]=o;v=1}l=l+1|0;if(l>>>0>=(((c[g>>2]|0)-p|0)/40|0)>>>0)break;else{k=p;j=v}}if(!v){i=b;return}v=c[a+236>>2]|0;j=c[a+232>>2]|0;if((v|0)==(j|0)){i=b;return}a=(v-j|0)/148|0;v=0;do{c[j+(v*148|0)+28>>2]=c[p+((e[j+(v*148|0)+2>>1]|0)*40|0)+20>>2];v=v+1|0}while(v>>>0<a>>>0);i=b;return}function u4d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;g[b+212>>2]=ea(g[($tc()|0)+20>>2]);c[b+216>>2]=c[($tc()|0)+24>>2];if((c[b+56>>2]|0)!=(e|0)?(f=c[b+252>>2]|0,(f|0)!=0):0){h=c[b+244>>2]|0;j=0;do{c[h+(j*24|0)+4>>2]=e;j=j+1|0}while(j>>>0<f>>>0)}f=b+276|0;j=c[b+280>>2]|0;if((j|0)==(f|0)){i=d;return}e=b+244|0;b=j;do{j=b+8|0;h=zjc(pjc()|0,j)|0;k=Ajc(pjc()|0,j)|0;if(!h)l=0;else l=c[h+4>>2]|0;if(!k)m=0;else m=c[k+4>>2]|0;j=b+12|0;n=b+16|0;if(!((l|0)==(c[j>>2]|0)?(m|0)==(c[n>>2]|0):0)){c[j>>2]=l;c[n>>2]=m;if(!l)o=1;else o=(m|0)==0&1;n=b+28|0;if(c[n>>2]|0){j=b+20|0;p=0;do{q=c[(c[j>>2]|0)+(p<<2)>>2]|0;r=c[e>>2]|0;a[r+(q*24|0)+22>>0]=o;T3d(c[r+(q*24|0)>>2]|0,h,k);p=p+1|0}while(p>>>0<(c[n>>2]|0)>>>0)}}b=c[b+4>>2]|0}while((b|0)!=(f|0));i=d;return}function v4d(a,d,e,f,h,j,k){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=ea(k);var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=Im,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=0,$=Im,aa=Im,ba=Im,ca=Im,da=0,fa=0;l=i;i=i+64|0;m=l+48|0;n=l+44|0;o=l+40|0;p=l+28|0;q=l+24|0;r=l;if(!d){i=l;return}s=d+20|0;t=ea(g[h>>2]);u=h+8|0;v=ea(g[u>>2]);w=ea(t-ea(g[s>>2]));x=d+28|0;y=ea(v-ea(g[x>>2]));z=d+32|0;A=ea(g[z>>2]);B=d+40|0;C=ea(g[B>>2]);if(!(w<ea(-A)))if(w>A){D=ea(w-A);E=ea(ea(D*D)+ea(0.0))}else E=ea(0.0);else{D=ea(w+A);E=ea(ea(D*D)+ea(0.0))}if(!(y<ea(-C)))if(y>C){D=ea(y-C);F=ea(ea(D*D)+E)}else F=E;else{D=ea(y+C);F=ea(ea(D*D)+E)}if(F>k){i=l;return}G=d+12|0;if(!(c[G>>2]|0)){E=ea(ea(g[d+60>>2])*t);D=ea(g[d+64>>2]);C=ea(E+ea(D*ea(g[h+4>>2])));D=ea(C+ea(ea(g[d+68>>2])*v));if(ea(ea(g[d+72>>2])+D)>ea(0.0)){v4d(a,c[d+80>>2]|0,e,f,h,j,k);v4d(a,c[d+76>>2]|0,e,f,h,j,k);i=l;return}else{v4d(a,c[d+76>>2]|0,e,f,h,j,k);v4d(a,c[d+80>>2]|0,e,f,h,j,k);i=l;return}}if(!(F>j)){H=d+4|0;I=a+44|0;J=a+48|0;K=a+52|0;L=a+60|0;M=a+64|0;N=a+68|0;O=r+4|0;P=r+8|0;Q=r+12|0;R=r+16|0;S=r+20|0;T=a+80|0;F=t;t=v;U=0;while(1){V=c[(c[H>>2]|0)+(U<<2)>>2]|0;c[q>>2]=V;W=c[a>>2]|0;X=c[W+16>>2]|0;v=ea(g[X+(V*40|0)>>2]);D=ea(v*ea(g[I>>2]));v=ea(g[X+(V*40|0)+4>>2]);C=ea(g[J>>2]);E=ea(g[X+(V*40|0)+8>>2]);y=ea(E*ea(g[K>>2]));E=ea(D+ea(g[L>>2]));D=ea(g[M>>2]);A=ea(y+ea(g[N>>2]));y=ea(E-F);w=ea(A-t);Y=ea(ea(ea(y*y)+ea(0.0))+ea(w*w));g[X+(V*40|0)+36>>2]=Y;do if(!(Y>=k)){w=ea(ea(v*C)+D);y=ea(g[X+(V*40|0)+12>>2]);Z=ea(g[X+(V*40|0)+16>>2]);_=(c[W+28>>2]|0)+(c[X+(V*40|0)+32>>2]<<7)+100|0;c[r+0>>2]=c[_+0>>2];c[r+4>>2]=c[_+4>>2];c[r+8>>2]=c[_+8>>2];c[r+12>>2]=c[_+12>>2];c[r+16>>2]=c[_+16>>2];c[r+20>>2]=c[_+20>>2];$=ea(y*ea(g[r>>2]));aa=ea(Z*ea(g[O>>2]));ba=ea(E+$);$=ea(w+aa);aa=ea(A+ea(y*ea(g[P>>2])));w=ea(y*ea(g[Q>>2]));ca=ea(Z*ea(g[R>>2]));Z=ea(y*ea(g[S>>2]));g[r>>2]=ba;g[O>>2]=$;g[P>>2]=aa;g[Q>>2]=w;g[R>>2]=ca;g[S>>2]=Z;if(Y>=j?pmc(r,e)|0:0){S4d(f,q);break}S4d(T,q)}while(0);V=U+1|0;if(V>>>0>=(c[G>>2]|0)>>>0)break;Y=ea(g[h>>2]);F=Y;t=ea(g[u>>2]);U=V}i=l;return}if(!(pmc(s,e)|0)){i=l;return}t=ea(g[h>>2]);F=ea(g[u>>2]);j=ea(g[s>>2]);k=ea(g[z>>2]);Y=ea(g[x>>2]);A=ea(g[B>>2]);E=ea(Y-A);D=ea(Y+A);if(!(ea(j+k)<t))if(ea(j-k)<t)da=1;else da=0;else da=2;do if(!(D<F))if(E<F){fa=da+3|0;break}else{fa=da+6|0;break}else fa=da;while(0);da=d+52|0;c[da>>2]=fa;B4d(a,d,ea(0.0));a=c[da>>2]|0;da=d+48|0;if((a|0)==(c[da>>2]|0)){i=l;return}c[da>>2]=a;da=c[d>>2]|0;fa=c[G>>2]|0;G=c[153134]|0;c[n>>2]=G;c[m+0>>2]=c[n+0>>2];B=cOb(fa<<3,4,m,0,3653512,352)|0;x=(fa|0)==0;if(!x){z=0;do{c[B+(z<<3)>>2]=z;z=z+1|0}while((z|0)!=(fa|0))}if((a|0)!=4){if(!x){z=c[d+4>>2]|0;s=c[da+16>>2]|0;F=ea(g[722352+(a*12|0)>>2]);E=ea(g[722356+(a*12|0)>>2]);D=ea(g[722360+(a*12|0)>>2]);a=0;do{da=c[z+(a<<2)>>2]|0;t=ea(F*ea(g[s+(da*40|0)>>2]));k=ea(t+ea(E*ea(g[s+(da*40|0)+4>>2])));g[B+(a<<3)+4>>2]=ea(k+ea(D*ea(g[s+(da*40|0)+8>>2])));a=a+1|0}while((a|0)!=(fa|0))}U4d(B,B+(fa<<3)|0)}mDd(p,fa*6|0);a=c[p>>2]|0;if(!x){x=0;do{s=x*6|0;z=c[B+(x<<3)>>2]<<2;b[a+(s<<1)>>1]=z;da=(z|1)&65535;b[a+((s|1)<<1)>>1]=da;u=(z|2)&65535;b[a+(s+2<<1)>>1]=u;b[a+(s+3<<1)>>1]=u;b[a+(s+4<<1)>>1]=da;b[a+(s+5<<1)>>1]=z|3;x=x+1|0}while((x|0)!=(fa|0))}x=p+4|0;z=c[x>>2]|0;lec(c[d+44>>2]|0,(a|0)==(z|0)?0:a,z-a>>1,0,0,17)|0;a=c[p>>2]|0;if(a){p=c[x>>2]|0;if((p|0)!=(a|0))c[x>>2]=p+(~((p+-2-a|0)>>>1)<<1);c[n>>2]=89;c[m+0>>2]=c[n+0>>2];eOb(a,m)}if((fa|0)<=-1){i=l;return}c[o>>2]=G;c[m+0>>2]=c[o+0>>2];eOb(B,m);i=l;return}function w4d(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im;f=i;i=i+144|0;h=f+76|0;j=f+64|0;k=f+112|0;l=f+88|0;m=f+84|0;n=f+96|0;o=f+116|0;p=f+120|0;q=f+24|0;r=f+8|0;s=f+80|0;t=f+32|0;u=f;v=f+48|0;rGc(j,BTb(c[d+24>>2]|0)|0);d=c[b+112>>2]|0;if(!(a[d+28>>0]|0)){i=f;return}w=ea(g[d+96>>2]);x=ea(g[d+92>>2]);y=ea(g[d+88>>2]);z=ea(g[d+80>>2]);A=ea(g[d+76>>2]);B=ea(g[d+72>>2]);C=ea(g[d+64>>2]);D=ea(g[d+60>>2]);E=ea(g[d+56>>2]);S0d(d,k,l);d=b+8|0;c[b+16>>2]=0;c[b+32>>2]=0;c[b+40>>2]=c[155410];c[h>>2]=-1;itd(h,722480);c[m>>2]=c[h>>2];g[n>>2]=E;g[n+4>>2]=D;g[n+8>>2]=C;g[n+12>>2]=ea(0.0);old(d,m,n);c[h>>2]=-1;itd(h,722512);c[o>>2]=c[h>>2];C=ea(g[l>>2]);g[p>>2]=B;g[p+4>>2]=A;g[p+8>>2]=z;g[p+12>>2]=C;old(d,o,p);c[h>>2]=-1;itd(h,722536);c[q>>2]=c[h>>2];g[r>>2]=y;g[r+4>>2]=x;g[r+8>>2]=w;g[r+12>>2]=ea(0.0);old(d,q,r);c[h>>2]=-1;itd(h,722568);c[s>>2]=c[h>>2];w=ea(g[j>>2]);x=ea(g[j+4>>2]);y=ea(g[j+8>>2]);C=ea(g[k>>2]);g[t>>2]=w;g[t+4>>2]=x;g[t+8>>2]=y;g[t+12>>2]=C;old(d,s,t);c[h>>2]=-1;itd(h,722592);c[u>>2]=c[h>>2];g[v>>2]=e;g[v+4>>2]=ea(0.0);g[v+8>>2]=ea(0.0);g[v+12>>2]=ea(0.0);old(d,u,v);i=f;return}function x4d(e,f,h,j){e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=Im,U=Im,V=Im,W=Im,X=Im,Y=Im,Z=Im,_=Im,$=Im,aa=Im,ba=Im,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;k=i;i=i+80|0;l=k+68|0;m=k+64|0;n=k+40|0;o=k+24|0;p=k+12|0;q=k;r=c[e>>2]|0;s=h+8|0;t=c[s>>2]|0;Odc(f,t<<2,29);u=f+28|0;v=c[(c[u>>2]|0)+92>>2]|0;w=a[f+276>>0]|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;if(t){x=r+16|0;r=e+44|0;y=e+48|0;z=e+52|0;A=e+60|0;B=e+64|0;C=e+68|0;D=e+112|0;E=n+4|0;F=n+8|0;G=n+12|0;H=n+16|0;I=n+20|0;J=o+4|0;K=o+8|0;L=p+4|0;M=p+8|0;if(!(w<<24>>24)){w=0;do{N=c[(c[h>>2]|0)+(w<<2)>>2]|0;O=c[x>>2]|0;P=O+(N*40|0)+32|0;Q=c[P>>2]|0;R=c[(c[e>>2]|0)+28>>2]|0;S=ea(g[O+(N*40|0)>>2]);T=ea(S*ea(g[r>>2]));S=ea(g[O+(N*40|0)+4>>2]);U=ea(S*ea(g[y>>2]));S=ea(g[O+(N*40|0)+8>>2]);V=ea(S*ea(g[z>>2]));S=ea(T+ea(g[A>>2]));T=ea(U+ea(g[B>>2]));U=ea(V+ea(g[C>>2]));V=ea(ea(d[O+(N*40|0)+24>>0]|0|0)/ea(255.0));W=ea(ea(d[O+(N*40|0)+25>>0]|0|0)/ea(255.0));X=ea(ea(d[O+(N*40|0)+26>>0]|0|0)/ea(255.0));Y=ea(ea(d[O+(N*40|0)+27>>0]|0|0)/ea(255.0));Z=ea(ea(d[O+(N*40|0)+28>>0]|0|0)/ea(255.0));_=ea(ea(d[O+(N*40|0)+29>>0]|0|0)/ea(255.0));$=ea(ea(d[O+(N*40|0)+30>>0]|0|0)/ea(255.0));aa=ea(V*Z);Z=ea(W*_);_=ea(X*$);$=ea(Y*ea(ea(d[O+(N*40|0)+31>>0]|0|0)/ea(255.0)));Y=ea(g[R+(Q<<7)+92>>2]);X=ea(g[O+(N*40|0)+12>>2]);W=ea(ea(Y*X)*ea(.5));V=ea(g[R+(Q<<7)+84>>2]);ba=ea(g[O+(N*40|0)+16>>2]);ca=ea(ea(V*ba)*ea(.5));da=ea(g[R+(Q<<7)+88>>2]);fa=ea(ba*ea(da-ea(V*ea(.5))));ga=V<Y?Y:V;Y=ea(ea(ga-V)*ea(.5));ha=ea(ba*ea(da+Y));ia=ea(ba*ea(ea(V-da)+Y));Y=ea(ea(X*ga)*ea(.5));Q=w<<2;g[v+(Q<<5)>>2]=S;g[v+(Q<<5)+4>>2]=T;g[v+(Q<<5)+8>>2]=U;R=Q|1;g[v+(R<<5)>>2]=S;g[v+(R<<5)+4>>2]=T;g[v+(R<<5)+8>>2]=U;N=Q|2;g[v+(N<<5)>>2]=S;g[v+(N<<5)+4>>2]=T;g[v+(N<<5)+8>>2]=U;O=Q|3;g[v+(O<<5)>>2]=S;g[v+(O<<5)+4>>2]=T;g[v+(O<<5)+8>>2]=U;ja=c[P>>2]|0;P=c[(c[D>>2]|0)+4>>2]|0;ga=ea(g[P+(ja<<4)>>2]);X=ea(-Y);g[v+(Q<<5)+16>>2]=ga;g[v+(Q<<5)+20>>2]=X;da=ea(ga+ea(g[P+(ja<<4)+8>>2]));g[v+(R<<5)+16>>2]=da;g[v+(R<<5)+20>>2]=X;g[v+(N<<5)+16>>2]=ga;g[v+(N<<5)+20>>2]=Y;g[v+(O<<5)+16>>2]=da;g[v+(O<<5)+20>>2]=Y;Y=ea(-W);da=ea(-ia);g[v+(Q<<5)+24>>2]=Y;g[v+(Q<<5)+28>>2]=da;g[v+(R<<5)+24>>2]=W;g[v+(R<<5)+28>>2]=da;g[v+(N<<5)+24>>2]=Y;g[v+(N<<5)+28>>2]=ha;g[v+(O<<5)+24>>2]=W;g[v+(O<<5)+28>>2]=ha;ja=aa<ea(0.0);ha=ja?ea(0.0):aa;ja=ha>ea(1.0);P=~~ea(ea(ha*ea(255.0))+ea(.5))>>>0;ka=Z<ea(0.0);ha=ka?ea(0.0):Z;ka=ha>ea(1.0);la=~~ea(ea(ha*ea(255.0))+ea(.5))>>>0;ma=_<ea(0.0);ha=ma?ea(0.0):_;ma=ha>ea(1.0);na=~~ea(ea(ha*ea(255.0))+ea(.5))>>>0;oa=$<ea(0.0);ha=oa?ea(0.0):$;oa=ha>ea(1.0);pa=~~ea(ea(ha*ea(255.0))+ea(.5))>>>0<<24;qa=(oa?-16777216:pa)|(ka?65280:la<<8&65280)|(ja?255:P&255)|(ma?16711680:na<<16&16711680);c[v+(O<<5)+12>>2]=qa;c[v+(N<<5)+12>>2]=qa;c[v+(R<<5)+12>>2]=qa;c[v+(Q<<5)+12>>2]=qa;ha=ea(S+ea(0.0));S=ea(T+fa);fa=ea(U+ea(0.0));if(!w){g[n>>2]=ha;g[E>>2]=S;g[F>>2]=fa;g[G>>2]=W;g[H>>2]=ca;g[I>>2]=W}else{U=ea(ca+S);T=ea(fa+W);g[o>>2]=ea(ha+W);g[J>>2]=U;g[K>>2]=T;Ulc(n,o);T=ea(S-ca);ca=ea(fa-W);g[p>>2]=ea(ha-W);g[L>>2]=T;g[M>>2]=ca;Ulc(n,p)}w=w+1|0}while((w|0)!=(t|0))}else{w=0;do{qa=c[(c[h>>2]|0)+(w<<2)>>2]|0;Q=c[x>>2]|0;R=Q+(qa*40|0)+32|0;N=c[R>>2]|0;O=c[(c[e>>2]|0)+28>>2]|0;ca=ea(g[Q+(qa*40|0)>>2]);T=ea(ca*ea(g[r>>2]));ca=ea(g[Q+(qa*40|0)+4>>2]);W=ea(ca*ea(g[y>>2]));ca=ea(g[Q+(qa*40|0)+8>>2]);ha=ea(ca*ea(g[z>>2]));ca=ea(T+ea(g[A>>2]));T=ea(W+ea(g[B>>2]));W=ea(ha+ea(g[C>>2]));ha=ea(ea(d[Q+(qa*40|0)+24>>0]|0|0)/ea(255.0));fa=ea(ea(d[Q+(qa*40|0)+25>>0]|0|0)/ea(255.0));S=ea(ea(d[Q+(qa*40|0)+26>>0]|0|0)/ea(255.0));U=ea(ea(d[Q+(qa*40|0)+27>>0]|0|0)/ea(255.0));$=ea(ea(d[Q+(qa*40|0)+28>>0]|0|0)/ea(255.0));_=ea(ea(d[Q+(qa*40|0)+29>>0]|0|0)/ea(255.0));Z=ea(ea(d[Q+(qa*40|0)+30>>0]|0|0)/ea(255.0));aa=ea(ha*$);$=ea(fa*_);_=ea(S*Z);Z=ea(U*ea(ea(d[Q+(qa*40|0)+31>>0]|0|0)/ea(255.0)));U=ea(g[O+(N<<7)+92>>2]);S=ea(g[Q+(qa*40|0)+12>>2]);fa=ea(ea(U*S)*ea(.5));ha=ea(g[O+(N<<7)+84>>2]);Y=ea(g[Q+(qa*40|0)+16>>2]);da=ea(ea(ha*Y)*ea(.5));ia=ea(g[O+(N<<7)+88>>2]);ga=ea(Y*ea(ia-ea(ha*ea(.5))));X=ha<U?U:ha;U=ea(ea(X-ha)*ea(.5));V=ea(Y*ea(ia+U));ba=ea(Y*ea(ea(ha-ia)+U));U=ea(ea(S*X)*ea(.5));N=w<<2;g[v+(N<<5)>>2]=ca;g[v+(N<<5)+4>>2]=T;g[v+(N<<5)+8>>2]=W;O=N|1;g[v+(O<<5)>>2]=ca;g[v+(O<<5)+4>>2]=T;g[v+(O<<5)+8>>2]=W;qa=N|2;g[v+(qa<<5)>>2]=ca;g[v+(qa<<5)+4>>2]=T;g[v+(qa<<5)+8>>2]=W;Q=N|3;g[v+(Q<<5)>>2]=ca;g[v+(Q<<5)+4>>2]=T;g[v+(Q<<5)+8>>2]=W;na=c[R>>2]|0;R=c[(c[D>>2]|0)+4>>2]|0;X=ea(g[R+(na<<4)>>2]);S=ea(-U);g[v+(N<<5)+16>>2]=X;g[v+(N<<5)+20>>2]=S;ia=ea(X+ea(g[R+(na<<4)+8>>2]));g[v+(O<<5)+16>>2]=ia;g[v+(O<<5)+20>>2]=S;g[v+(qa<<5)+16>>2]=X;g[v+(qa<<5)+20>>2]=U;g[v+(Q<<5)+16>>2]=ia;g[v+(Q<<5)+20>>2]=U;U=ea(-fa);ia=ea(-ba);g[v+(N<<5)+24>>2]=U;g[v+(N<<5)+28>>2]=ia;g[v+(O<<5)+24>>2]=fa;g[v+(O<<5)+28>>2]=ia;g[v+(qa<<5)+24>>2]=U;g[v+(qa<<5)+28>>2]=V;g[v+(Q<<5)+24>>2]=fa;g[v+(Q<<5)+28>>2]=V;na=aa<ea(0.0);V=na?ea(0.0):aa;na=V>ea(1.0);R=~~ea(ea(V*ea(255.0))+ea(.5))>>>0;ma=$<ea(0.0);V=ma?ea(0.0):$;ma=V>ea(1.0);P=~~ea(ea(V*ea(255.0))+ea(.5))>>>0;ja=_<ea(0.0);V=ja?ea(0.0):_;ja=V>ea(1.0);la=~~ea(ea(V*ea(255.0))+ea(.5))>>>0;ka=Z<ea(0.0);V=ka?ea(0.0):Z;ka=V>ea(1.0);pa=~~ea(ea(V*ea(255.0))+ea(.5))>>>0<<24;oa=(ka?-16777216:pa)|(ma?65280:P<<8&65280)|(ja?255:la&255)|(na?16711680:R<<16&16711680);c[v+(Q<<5)+12>>2]=oa;c[v+(qa<<5)+12>>2]=oa;c[v+(O<<5)+12>>2]=oa;c[v+(N<<5)+12>>2]=oa;V=ea(ca+ea(0.0));ca=ea(T+ga);ga=ea(W+ea(0.0));if(!w){g[n>>2]=V;g[E>>2]=ca;g[F>>2]=ga;g[G>>2]=fa;g[H>>2]=da;g[I>>2]=fa}else{W=ea(da+ca);T=ea(ga+fa);g[o>>2]=ea(V+fa);g[J>>2]=W;g[K>>2]=T;Ulc(n,o);T=ea(ca-da);da=ea(ga-fa);g[p>>2]=ea(V-fa);g[L>>2]=T;g[M>>2]=da;Ulc(n,p)}w=w+1|0}while((w|0)!=(t|0))}}oec(f,n);Xdc(f,c[(c[u>>2]|0)+96>>2]|0,0);if(!j){i=k;return}mDd(q,(c[s>>2]|0)*6|0);j=c[s>>2]|0;s=c[q>>2]|0;if(j){u=0;do{n=u*6|0;t=u<<2;b[s+(n<<1)>>1]=t;w=(t|1)&65535;b[s+((n|1)<<1)>>1]=w;p=(t|2)&65535;b[s+(n+2<<1)>>1]=p;b[s+(n+3<<1)>>1]=p;b[s+(n+4<<1)>>1]=w;b[s+(n+5<<1)>>1]=t|3;u=u+1|0}while(u>>>0<j>>>0)}j=q+4|0;u=c[j>>2]|0;lec(f,(s|0)==(u|0)?0:s,u-s>>1,0,0,17)|0;s=c[q>>2]|0;if(!s){i=k;return}q=c[j>>2]|0;if((q|0)!=(s|0))c[j>>2]=q+(~((q+-2-s|0)>>>1)<<1);c[m>>2]=89;c[l+0>>2]=c[m+0>>2];eOb(s,l);i=k;return}function y4d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a+188|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;e=c[a+164>>2]|0;f=(e|0)==0;if((b|0)==-1){if(!f){g=c[a+156>>2]|0;h=0;do{j=c[g+(h*24|0)>>2]|0;k=j+176|0;if(c[k>>2]|0){c[k>>2]=1;c[j+180>>2]=-1}h=h+1|0}while(h>>>0<e>>>0)}h=c[a+252>>2]|0;if(!h){i=d;return}g=c[a+244>>2]|0;j=0;do{k=c[g+(j*24|0)>>2]|0;l=k+176|0;if(c[l>>2]|0){c[l>>2]=1;c[k+180>>2]=-1}j=j+1|0}while(j>>>0<h>>>0);i=d;return}else{if(!f){f=c[a+156>>2]|0;h=0;do{j=c[f+(h*24|0)>>2]|0;g=j+176|0;if(c[g>>2]|0){c[g>>2]=2;c[j+180>>2]=(c[j+252>>2]|0)+b}h=h+1|0}while(h>>>0<e>>>0)}e=c[a+252>>2]|0;if(!e){i=d;return}h=c[a+244>>2]|0;a=0;do{f=c[h+(a*24|0)>>2]|0;j=f+176|0;if(c[j>>2]|0){c[j>>2]=2;c[f+180>>2]=(c[f+252>>2]|0)+b}a=a+1|0}while(a>>>0<e>>>0);i=d;return}}function z4d(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g+4|0;j=g;k=d+88|0;l=d+252|0;m=e+8|0;n=c[m>>2]|0;o=(c[l>>2]|0)+(c[k>>2]|0)+n|0;c[m>>2]=o;p=e+12|0;q=c[p>>2]|0;do if((q&2147483647)>>>0<o>>>0)if((q|0)>-1){c[p>>2]=o;r=c[e>>2]|0;c[j>>2]=c[e+4>>2];c[h+0>>2]=c[j+0>>2];c[e>>2]=hOb(r,o*24|0,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[e+4>>2];c[h+0>>2]=c[j+0>>2];r=cOb(o*24|0,4,h,0,3653512,352)|0;YEi(r|0,c[e>>2]|0,(c[m>>2]|0)*24|0)|0;c[p>>2]=o;c[e>>2]=r;break}while(0);p=f+8|0;c[p>>2]=o;m=f+12|0;q=c[m>>2]|0;do if((q&2147483647)>>>0<o>>>0)if((q|0)>-1){c[m>>2]=o;r=c[f>>2]|0;c[j>>2]=c[f+4>>2];c[h+0>>2]=c[j+0>>2];c[f>>2]=hOb(r,o*24|0,4,h,0,3653512,370)|0;break}else{c[j>>2]=c[f+4>>2];c[h+0>>2]=c[j+0>>2];r=cOb(o*24|0,4,h,0,3653512,352)|0;YEi(r|0,c[f>>2]|0,(c[p>>2]|0)*24|0)|0;c[m>>2]=o;c[f>>2]=r;break}while(0);if(!(c[k>>2]|0)){s=f;t=e;u=n}else{o=d+80|0;m=d+140|0;p=d+156|0;h=d+172|0;j=0;q=n;while(1){n=c[(c[m>>2]|0)+(c[(c[o>>2]|0)+(j<<2)>>2]<<2)>>2]|0;r=(c[e>>2]|0)+(q*24|0)|0;v=(c[p>>2]|0)+(n*24|0)|0;c[r+0>>2]=c[v+0>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];c[r+12>>2]=c[v+12>>2];c[r+16>>2]=c[v+16>>2];b[r+20>>1]=b[v+20>>1]|0;a[r+22>>0]=a[v+22>>0]|0;v=(c[f>>2]|0)+(q*24|0)|0;r=(c[h>>2]|0)+(n*24|0)|0;c[v+0>>2]=c[r+0>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];c[v+12>>2]=c[r+12>>2];c[v+16>>2]=c[r+16>>2];c[v+20>>2]=c[r+20>>2];r=q+1|0;j=j+1|0;if(j>>>0>=(c[k>>2]|0)>>>0){s=f;t=e;u=r;break}else q=r}}q=(c[s>>2]|0)+(u*24|0)|0;YEi((c[t>>2]|0)+(u*24|0)|0,c[d+244>>2]|0,(c[l>>2]|0)*24|0)|0;YEi(q|0,c[d+260>>2]|0,(c[d+268>>2]|0)*24|0)|0;q=c[d+236>>2]|0;l=c[d+232>>2]|0;if((q|0)==(l|0)){i=g;return}d=(q-l|0)/148|0;q=0;do{b[l+(q*148|0)>>1]=0;q=q+1|0}while(q>>>0<d>>>0);i=g;return}function A4d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;d=i;i=i+240|0;e=d+16|0;f=d+124|0;g=d+220|0;h=d+228|0;j=d+200|0;k=d+216|0;l=d+224|0;m=d+232|0;n=d+236|0;o=d+12|0;p=d+128|0;q=d+24|0;r=d;s=d+96|0;t=d+204|0;u=d+112|0;v=c[b>>2]|0;w=b+220|0;x=c[w>>2]|0;y=b+224|0;b=c[y>>2]|0;if((b|0)==(x|0))z=x;else{A=b;while(1){b=A+-40|0;c[y>>2]=b;B=c[A+-36>>2]|0;if(!B)C=b;else{b=A+-32|0;D=c[b>>2]|0;if((D|0)!=(B|0))c[b>>2]=D+(~(((D+-72-B|0)>>>0)/72|0)*72|0);c[n>>2]=54;c[e+0>>2]=c[n+0>>2];eOb(B,e);C=c[y>>2]|0}if((C|0)==(x|0))break;else A=C}z=c[w>>2]|0}C=v+32|0;A=v+28|0;v=(c[C>>2]|0)-(c[A>>2]|0)>>7;n=(x-z|0)/40|0;if(v>>>0<=n>>>0){if(v>>>0<n>>>0?(B=z+(v*40|0)|0,(x|0)!=(B|0)):0){z=x;while(1){x=z+-40|0;c[y>>2]=x;D=c[z+-36>>2]|0;if(!D)E=x;else{x=z+-32|0;b=c[x>>2]|0;if((b|0)!=(D|0))c[x>>2]=b+(~(((b+-72-D|0)>>>0)/72|0)*72|0);c[m>>2]=54;c[e+0>>2]=c[m+0>>2];eOb(D,e);E=c[y>>2]|0}if((E|0)==(B|0))break;else z=E}}}else V4d(w,v-n|0);n=c[A>>2]|0;if((c[C>>2]|0)==(n|0)){i=d;return}v=p+4|0;E=n;n=0;do{do if((c[E+(n<<7)+4>>2]|0)==2?(z=c[E+(n<<7)+8>>2]|0,(z|0)!=0):0){c[l>>2]=z;B=c[137784]|0;if(B){do if((c[B+36>>2]|0)!=(c[B+4>>2]|0)){fRb(e,B,l);y=c[e>>2]|0;m=c[B+28>>2]|0;if((y|0)==-1){F=m+(c[B+32>>2]<<3)|0;break}else{F=m+(y<<3)|0;break}}else F=(c[B+28>>2]|0)+(c[B+32>>2]<<3)|0;while(0);B=c[137784]|0;if((F|0)!=((c[B+28>>2]|0)+(c[B+32>>2]<<3)|0)?(B=c[F+4>>2]|0,(B|0)!=0):0)G=B;else H=31}else H=31;if((H|0)==31){H=0;B=hQb(z)|0;if(!B)break;else G=B}B=c[w>>2]|0;y=G+48|0;m=G+44|0;if(((c[y>>2]|0)-(c[m>>2]|0)|0)>0){D=B+(n*40|0)+4|0;b=B+(n*40|0)+8|0;x=B+(n*40|0)+4|0;I=0;do{J=Ytc(G,I)|0;K=1<<I;L=J+20|0;if(c[L>>2]|0){M=J+12|0;J=0;do{N=c[(c[M>>2]|0)+(J<<2)>>2]|0;do if(N){c[h>>2]=N;O=c[137784]|0;if(O){do if((c[O+36>>2]|0)!=(c[O+4>>2]|0)){fRb(e,O,h);P=c[e>>2]|0;Q=c[O+28>>2]|0;if((P|0)==-1){R=Q+(c[O+32>>2]<<3)|0;break}else{R=Q+(P<<3)|0;break}}else R=(c[O+28>>2]|0)+(c[O+32>>2]<<3)|0;while(0);O=c[137784]|0;if((R|0)!=((c[O+28>>2]|0)+(c[O+32>>2]<<3)|0)?(O=c[R+4>>2]|0,(O|0)!=0):0)S=O;else H=45}else H=45;if((H|0)==45){H=0;O=hQb(N)|0;if(!O)break;else S=O}O=(da(c[137788]|0,(c[S+8>>2]|0)>>>21)|0)+23|0;P=O>>5;if(!((S|0)==0?1:(1<<O-(P<<5)&c[(c[137786]|0)+(P<<2)>>2]|0)==0)){P=q+0|0;O=P+68|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));c[p>>2]=N;P=v+0|0;Q=q+0|0;O=P+68|0;do{c[P>>2]=c[Q>>2];P=P+4|0;Q=Q+4|0}while((P|0)<(O|0));T=c[D>>2]|0;U=c[b>>2]|0;if((U|0)==(T|0))V=T;else{W=T;X=(U-T|0)/72|0;while(1){T=(X|0)/2|0;if((c[W+(T*72|0)>>2]|0)<(N|0)){Y=W+((T+1|0)*72|0)|0;Z=X+-1-T|0}else{Y=W;Z=T}if(!Z){V=Y;break}else{W=Y;X=Z}}}if((V|0)!=(U|0)?(N|0)>=(c[V>>2]|0):0)_=V;else H=54;do if((H|0)==54){H=0;c[g>>2]=V;c[e+0>>2]=c[g+0>>2];W4d(f,x,e,p);X=c[f>>2]|0;c[X+68>>2]=0;W=BTb(c[S+24>>2]|0)|0;T=X+4|0;if(!W){P=T+0|0;Q=601008|0;O=P+64|0;do{c[P>>2]=c[Q>>2];P=P+4|0;Q=Q+4|0}while((P|0)<(O|0));_=X;break}else{$=W+44|0;c[r+0>>2]=c[$+0>>2];c[r+4>>2]=c[$+4>>2];c[r+8>>2]=c[$+8>>2];$=W+28|0;c[s+0>>2]=c[$+0>>2];c[s+4>>2]=c[$+4>>2];c[s+8>>2]=c[$+8>>2];c[s+12>>2]=c[$+12>>2];$=W+56|0;c[t+0>>2]=c[$+0>>2];c[t+4>>2]=c[$+4>>2];c[t+8>>2]=c[$+8>>2];vMc(T,r,s,t);_=X;break}}while(0);Q=_+68|0;c[Q>>2]=c[Q>>2]|K}}while(0);J=J+1|0}while(J>>>0<(c[L>>2]|0)>>>0)}I=I+1|0}while((I|0)<(((c[y>>2]|0)-(c[m>>2]|0)|0)/28|0|0))}m=B+(n*40|0)+16|0;y=c[A>>2]|0;I=c[y+(n<<7)+8>>2]|0;a:do if(!((I|0)==0?1:(c[y+(n<<7)+4>>2]|0)!=2)){c[k>>2]=I;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(e,x,k);b=c[e>>2]|0;D=c[x+28>>2]|0;if((b|0)==-1){aa=D+(c[x+32>>2]<<3)|0;break}else{aa=D+(b<<3)|0;break}}else aa=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((aa|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(x=c[aa+4>>2]|0,(x|0)!=0):0)ba=x;else H=69}else H=69;if((H|0)==69){H=0;x=hQb(I)|0;if(!x){H=86;break}else ba=x}x=ba+48|0;b=ba+44|0;if(((c[x>>2]|0)-(c[b>>2]|0)|0)>0){D=0;b:while(1){z=Ytc(ba,D)|0;L=z+20|0;c:do if(c[L>>2]|0){J=z+12|0;K=0;while(1){M=(c[J>>2]|0)+(K<<2)|0;c[j>>2]=c[M>>2];N=c[137784]|0;do if(N){do if((c[N+36>>2]|0)!=(c[N+4>>2]|0)){fRb(e,N,j);Q=c[e>>2]|0;P=c[N+28>>2]|0;if((Q|0)==-1){ca=P+(c[N+32>>2]<<3)|0;break}else{ca=P+(Q<<3)|0;break}}else ca=(c[N+28>>2]|0)+(c[N+32>>2]<<3)|0;while(0);Q=c[137784]|0;if((ca|0)==((c[Q+28>>2]|0)+(c[Q+32>>2]<<3)|0)){H=83;break}Q=c[ca+4>>2]|0;if(Q)ea=Q;else H=83}else H=83;while(0);if((H|0)==83){H=0;ea=hQb(c[M>>2]|0)|0}N=ATb(c[ea+24>>2]|0,193)|0;K=K+1|0;if(N){fa=N;break}if(K>>>0>=(c[L>>2]|0)>>>0)break c}K=c[fa+28>>2]|0;if(K){ga=K;break b}}while(0);D=D+1|0;if((D|0)>=(((c[x>>2]|0)-(c[b>>2]|0)|0)/28|0|0)){H=86;break a}}c[m>>2]=ga;c[o>>2]=ga;b=c[137784]|0;if(b){do if((c[b+36>>2]|0)!=(c[b+4>>2]|0)){fRb(e,b,o);x=c[e>>2]|0;D=c[b+28>>2]|0;if((x|0)==-1){ha=D+(c[b+32>>2]<<3)|0;break}else{ha=D+(x<<3)|0;break}}else ha=(c[b+28>>2]|0)+(c[b+32>>2]<<3)|0;while(0);b=c[137784]|0;if((ha|0)!=((c[b+28>>2]|0)+(c[b+32>>2]<<3)|0)?(b=c[ha+4>>2]|0,(b|0)!=0):0)ia=b;else H=95}else H=95;if((H|0)==95){H=0;ia=hQb(c[m>>2]|0)|0}ja=ia}else H=86}else H=86;while(0);if((H|0)==86){H=0;c[m>>2]=0;ja=0}c[B+(n*40|0)+20>>2]=ja;a[B+(n*40|0)+24>>0]=1;I=B+(n*40|0)+28|0;qGc(u,BTb(c[G+24>>2]|0)|0);c[I+0>>2]=c[u+0>>2];c[I+4>>2]=c[u+4>>2];c[I+8>>2]=c[u+8>>2]}while(0);n=n+1|0;E=c[A>>2]|0}while(n>>>0<(c[C>>2]|0)-E>>7>>>0);i=d;return}function B4d(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+56|0;if(!(c[j>>2]|0)){k=b+44|0;kQb(c[k>>2]|0);c[k>>2]=0;c[h>>2]=c[153106];c[f+0>>2]=c[h+0>>2];h=_jc(4,f)|0;c[k>>2]=h;In[c[(c[h>>2]|0)+44>>2]&4095](h,61);h=c[k>>2]|0;In[c[(c[h>>2]|0)+36>>2]&4095](h,722464);x4d(a,c[k>>2]|0,b+4|0,0);c[b+48>>2]=-1}c[j>>2]=1;j=a+96|0;k=a+104|0;h=(c[k>>2]|0)+1|0;c[k>>2]=h;l=a+108|0;m=c[l>>2]|0;n=m&2147483647;if(h>>>0<=n>>>0){o=h;p=o+-1|0;q=c[j>>2]|0;r=q+(p<<2)|0;c[r>>2]=b;i=e;return}h=m<<1;s=(h|0)==0?1:h;do if(n>>>0<s>>>0)if((m|0)>-1){c[l>>2]=s;h=c[j>>2]|0;c[g>>2]=c[a+100>>2];c[f+0>>2]=c[g+0>>2];c[j>>2]=hOb(h,s<<2,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[a+100>>2];c[f+0>>2]=c[g+0>>2];h=cOb(s<<2,4,f,0,3653512,352)|0;YEi(h|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[l>>2]=s;c[j>>2]=h;break}while(0);o=c[k>>2]|0;p=o+-1|0;q=c[j>>2]|0;r=q+(p<<2)|0;c[r>>2]=b;i=e;return}function C4d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=b+4|0;h=c[g>>2]|0;if((h|0)<=0){i=f;return}j=h;h=c[e>>2]|0;k=0;while(1){l=c[(c[b>>2]|0)+(k<<2)>>2]|0;if(!(a[h+l>>0]|0)){m=c[d+(l*24|0)>>2]|0;n=c[m+244>>2]|0;if((n|0)==2)U3d(m);else if((n|0)==1)P3d(m);m=c[e>>2]|0;a[m+l>>0]=1;o=c[g>>2]|0;p=m}else{o=j;p=h}k=k+1|0;if((k|0)>=(o|0))break;else{j=o;h=p}}i=f;return}function D4d(d,f,h,j){d=d|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;if((h|0)<=-1){i=k;return}l=c[f+232>>2]|0;f=l+(h*148|0)|0;if(!f){i=k;return}m=l+(h*148|0)+28|0;if(!(c[m>>2]|0)){i=k;return}if(!(b[f>>1]&1)){n=Nbc()|0;o=l+(h*148|0)+32|0;p=Pbc(n,o,l+(h*148|0)+4|0,c[m>>2]|0)|0;m=b[f>>1]|0;if(!p)q=m;else{n=(m&65535|2)&65535;b[f>>1]=n;q=n}b[f>>1]=q&65535|1;if(c[l+(h*148|0)+84>>2]|0)Sbc(l+(h*148|0)+76|0,1,0,p,o);if(c[l+(h*148|0)+120>>2]|0)Sbc(l+(h*148|0)+112|0,1,1,p,o)}c[d>>2]=j?l+(h*148|0)+112|0:l+(h*148|0)+76|0;a[d+4>>0]=(e[f>>1]|0)>>>1&1;g[d+8>>2]=ea(g[l+(h*148|0)+36>>2]);i=k;return}function E4d(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,721792);c[180444]=c[b>>2];c[b>>2]=-1;itd(b,721824);c[180445]=c[b>>2];c[b>>2]=-1;itd(b,721856);c[180446]=c[b>>2];c[b>>2]=-1;itd(b,721888);c[180447]=c[b>>2];c[b>>2]=-1;itd(b,721936);c[180480]=c[b>>2];c[b>>2]=-1;itd(b,721968);c[180481]=c[b>>2];c[b>>2]=-1;itd(b,722e3);c[180482]=c[b>>2];c[b>>2]=-1;itd(b,722032);c[180483]=c[b>>2];g[180588]=ea(-1.0);g[180589]=ea(0.0);g[180590]=ea(1.0);g[180591]=ea(0.0);g[180592]=ea(0.0);g[180593]=ea(1.0);g[180594]=ea(1.0);g[180595]=ea(0.0);g[180596]=ea(1.0);g[180597]=ea(-1.0);c[180598]=0;c[180599]=0;c[180600]=0;c[180601]=0;c[180602]=0;g[180603]=ea(1.0);g[180604]=ea(0.0);g[180605]=ea(0.0);g[180606]=ea(-1.0);g[180607]=ea(0.0);g[180608]=ea(-1.0);g[180609]=ea(0.0);g[180610]=ea(0.0);g[180611]=ea(-1.0);g[180612]=ea(1.0);g[180613]=ea(0.0);g[180614]=ea(-1.0);i=a;return}function F4d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g;c[k>>2]=0;l=k+8|0;c[l>>2]=0;m=k+12|0;c[m>>2]=0;n=k+4|0;c[n>>2]=60;o=b+20|0;p=c[o>>2]|0;q=b+16|0;r=c[q>>2]|0;if((p|0)!=(r|0)){s=b+28|0;t=r;r=0;u=p;p=0;while(1){if((c[(c[s>>2]|0)+(c[t+(p*40|0)+32>>2]<<7)+4>>2]|0)==1){v=(c[l>>2]|0)+1|0;c[l>>2]=v;w=c[m>>2]|0;x=w&2147483647;if(v>>>0>x>>>0){y=w<<1;z=(y|0)==0?1:y;do if(x>>>0<z>>>0)if((w|0)>-1){c[m>>2]=z;c[j>>2]=c[n>>2];c[h+0>>2]=c[j+0>>2];y=hOb(r,z<<2,4,h,0,3653512,370)|0;c[k>>2]=y;A=y;break}else{c[j>>2]=c[n>>2];c[h+0>>2]=c[j+0>>2];y=cOb(z<<2,4,h,0,3653512,352)|0;YEi(y|0,c[k>>2]|0,c[l>>2]<<2|0)|0;c[m>>2]=z;c[k>>2]=y;A=y;break}else A=r;while(0);B=c[o>>2]|0;C=c[q>>2]|0;D=c[l>>2]|0;E=A}else{B=u;C=t;D=v;E=r}c[E+(D+-1<<2)>>2]=p;F=B;G=C;H=E}else{F=u;G=t;H=r}p=p+1|0;if(p>>>0>=((F-G|0)/40|0)>>>0){I=H;break}else{t=G;r=H;u=F}}F=c[l>>2]|0;if(F){l=xCi(84)|0;c[l>>2]=b;b=c[153116]|0;u=l+4|0;c[u>>2]=0;c[l+8>>2]=b;H=l+12|0;c[l+76>>2]=0;c[l+80>>2]=0;r=H+0|0;G=r+60|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(G|0));if((k|0)!=(u|0)){r=F<<2;F=r>>2;c[H>>2]=F;if(!F){J=0;K=0}else{c[l+16>>2]=F;c[j>>2]=b;c[h+0>>2]=c[j+0>>2];b=hOb(0,r,4,h,0,3653512,370)|0;c[u>>2]=b;J=b;K=c[H>>2]<<2}YEi(J|0,I|0,K|0)|0}X4d(l,d,e,f);c[a>>2]=l}else L=13}else L=13;if((L|0)==13)c[a>>2]=0;if((c[m>>2]|0)<=-1){i=g;return}m=c[k>>2]|0;c[j>>2]=c[n>>2];c[h+0>>2]=c[j+0>>2];eOb(m,h);c[k>>2]=0;i=g;return}function G4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;kQb(c[a+44>>2]|0);f=c[a+80>>2]|0;if(f){G4d(f);ACi(f)}f=c[a+76>>2]|0;if(f){G4d(f);ACi(f)}if((c[a+16>>2]|0)<=-1){i=b;return}f=a+4|0;g=c[f>>2]|0;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function H4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+8|0;if(!(c[g>>2]|0)){i=b;return}h=c[a+4>>2]|0;j=(c[a>>2]|0)+4|0;k=c[h>>2]|0;c[k+4>>2]=c[j>>2];c[c[j>>2]>>2]=k;c[g>>2]=0;g=h;while(1){if((g|0)==(a|0))break;h=c[g+4>>2]|0;if((c[g+32>>2]|0)>-1){k=g+20|0;j=c[k>>2]|0;c[e>>2]=c[g+24>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[k>>2]=0}c[f>>2]=54;c[d+0>>2]=c[f+0>>2];eOb(g,d);g=h}i=b;return}function I4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+112|0;if((c[a+140>>2]|0)>-1){g=a+128|0;h=c[g>>2]|0;c[e>>2]=c[a+132>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}if((c[a+124>>2]|0)>-1){g=c[f>>2]|0;c[e>>2]=c[a+116>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=a+76|0;if((c[a+104>>2]|0)>-1){g=a+92|0;h=c[g>>2]|0;c[e>>2]=c[a+96>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0}if((c[a+88>>2]|0)<=-1){i=b;return}g=c[f>>2]|0;c[e>>2]=c[a+80>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function J4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a>>2]|0;if(!g){i=b;return}h=a+4|0;j=c[h>>2]|0;if((j|0)==(g|0))k=g;else{l=j;while(1){j=l+-40|0;c[h>>2]=j;m=c[l+-36>>2]|0;if(!m)n=j;else{j=l+-32|0;o=c[j>>2]|0;if((o|0)!=(m|0))c[j>>2]=o+(~(((o+-72-m|0)>>>0)/72|0)*72|0);c[e>>2]=54;c[d+0>>2]=c[e+0>>2];eOb(m,d);n=c[h>>2]|0}if((n|0)==(g|0))break;else l=n}k=c[a>>2]|0}c[f>>2]=54;c[d+0>>2]=c[f+0>>2];eOb(k,d);i=b;return}function K4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+8|0;if(!(c[g>>2]|0)){i=b;return}h=a+4|0;j=c[h>>2]|0;a:do if((j|0)!=(a|0)){k=j;do{l=c[k+8>>2]|0;c[e>>2]=c[k+20>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);k=c[k+4>>2]|0}while((k|0)!=(a|0));k=(c[a>>2]|0)+4|0;l=c[j>>2]|0;c[l+4>>2]=c[k>>2];c[c[k>>2]>>2]=l;l=j;while(1){if((l|0)==(a|0))break a;k=c[l+4>>2]|0;c[g>>2]=(c[g>>2]|0)+-1;c[f>>2]=64;c[d+0>>2]=c[f+0>>2];eOb(l,d);l=k}}while(0);if(!(c[g>>2]|0)){i=b;return}f=c[h>>2]|0;h=(c[a>>2]|0)+4|0;j=c[f>>2]|0;c[j+4>>2]=c[h>>2];c[c[h>>2]>>2]=j;c[g>>2]=0;g=f;while(1){if((g|0)==(a|0))break;f=c[g+4>>2]|0;c[e>>2]=64;c[d+0>>2]=c[e+0>>2];eOb(g,d);g=f}i=b;return}function L4d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=54;c[e+0>>2]=c[f+0>>2];g=cOb(36,16,e,0,3653512,80)|0;c[g+8>>2]=c[b>>2];h=b+4|0;j=c[h+4>>2]|0;k=g+12|0;c[k>>2]=c[h>>2];c[k+4>>2]=j;j=c[b+16>>2]|0;c[g+24>>2]=j;k=g+28|0;c[k>>2]=0;h=g+32|0;c[h>>2]=0;l=g+20|0;c[l>>2]=0;m=c[b+12>>2]|0;n=c[b+20>>2]<<2;b=n>>2;c[k>>2]=b;if(!b){o=0;p=0}else{c[h>>2]=b;c[f>>2]=j;c[e+0>>2]=c[f+0>>2];f=hOb(0,n,4,e,0,3653512,370)|0;c[l>>2]=f;o=f;p=c[k>>2]<<2}YEi(o|0,m|0,p|0)|0;c[g+4>>2]=a;p=c[a>>2]|0;c[g>>2]=p;c[p+4>>2]=g;c[a>>2]=g;g=a+8|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function M4d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;if(!(c[g>>2]|0)){i=d;return}h=c[a+4>>2]|0;if(b)j=h;else j=c[h+4>>2]|0;h=(j|0)==(a|0);a:do if(!h){k=j;do{l=c[k+8>>2]|0;c[f>>2]=c[k+20>>2];c[e+0>>2]=c[f+0>>2];eOb(l,e);k=c[k+4>>2]|0}while((k|0)!=(a|0));if(!h){k=(c[a>>2]|0)+4|0;l=c[j>>2]|0;c[l+4>>2]=c[k>>2];c[c[k>>2]>>2]=l;l=j;while(1){if((l|0)==(a|0))break a;k=c[l+4>>2]|0;c[g>>2]=(c[g>>2]|0)+-1;c[f>>2]=64;c[e+0>>2]=c[f+0>>2];eOb(l,e);l=k}}}while(0);if(b){i=d;return}b=c[a>>2]|0;c[b+12>>2]=c[b+8>>2];i=d;return}function N4d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b+4>>2]|0;c[a+4>>2]=g;h=a+8|0;c[h>>2]=0;j=a+12|0;c[j>>2]=0;c[a>>2]=0;k=c[b>>2]|0;l=c[b+8>>2]<<4;m=l>>4;c[h>>2]=m;if(!m){n=0;o=0}else{c[j>>2]=m;c[f>>2]=g;c[e+0>>2]=c[f+0>>2];g=hOb(0,l,4,e,0,3653512,370)|0;c[a>>2]=g;n=g;o=c[h>>2]<<4}YEi(n|0,k|0,o|0)|0;o=c[b+20>>2]|0;c[a+20>>2]=o;k=a+24|0;c[k>>2]=0;n=a+28|0;c[n>>2]=0;h=a+16|0;c[h>>2]=0;g=c[b+16>>2]|0;l=c[b+24>>2]<<2;m=l>>2;c[k>>2]=m;if(!m){p=0;q=0;YEi(p|0,g|0,q|0)|0;r=a+32|0;s=b+32|0;t=c[s>>2]|0;c[r>>2]=t;i=d;return}c[n>>2]=m;c[f>>2]=o;c[e+0>>2]=c[f+0>>2];f=hOb(0,l,4,e,0,3653512,370)|0;c[h>>2]=f;p=f;q=c[k>>2]<<2;YEi(p|0,g|0,q|0)|0;r=a+32|0;s=b+32|0;t=c[s>>2]|0;c[r>>2]=t;i=d;return}function O4d(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=a+4|0;k=c[a>>2]|0;l=(((c[j>>2]|0)-k|0)/148|0)+1|0;if((l|0)<0)vxi(a);m=k;k=((c[a+8>>2]|0)-m|0)/148|0;if(k>>>0<1073741823){n=k<<1;o=n>>>0<l>>>0?l:n}else o=2147483647;n=((c[j>>2]|0)-m|0)/148|0;m=h+12|0;c[m>>2]=0;c[h+16>>2]=a+8;if(!o)p=0;else{c[g>>2]=54;c[f+0>>2]=c[g+0>>2];p=cOb(o*148|0,16,f,0,3653512,80)|0}c[h>>2]=p;j=p+(n*148|0)|0;l=h+8|0;c[l>>2]=j;k=h+4|0;c[k>>2]=j;c[m>>2]=p+(o*148|0);if(!j)q=0;else{o=j+0|0;j=d+0|0;m=o+76|0;do{b[o>>1]=b[j>>1]|0;o=o+2|0;j=j+2|0}while((o|0)<(m|0));N4d(p+(n*148|0)+76|0,d+76|0);N4d(p+(n*148|0)+112|0,d+112|0);q=c[l>>2]|0}c[l>>2]=q+148;Z4d(a,h);a=c[k>>2]|0;k=c[l>>2]|0;while(1){if((k|0)==(a|0))break;q=k+-148|0;c[l>>2]=q;I4d(q);k=q}k=c[h>>2]|0;if(!k){i=e;return}c[g>>2]=54;c[f+0>>2]=c[g+0>>2];eOb(k,f);i=e;return}function P4d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;j=a+8|0;if(!(c[j>>2]|0)){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[g>>2]=64;c[f+0>>2]=c[g+0>>2];k=cOb(24,16,f,0,3653512,80)|0;l=k+8|0;c[l+0>>2]=c[h+0>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];c[k+4>>2]=a;m=c[a>>2]|0;c[k>>2]=m;c[m+4>>2]=k;c[a>>2]=k;c[j>>2]=(c[j>>2]|0)+1;m=c[a+12>>2]|0;n=m>>>0<b>>>0?b:m;m=c[a+16>>2]|0;c[k+20>>2]=m;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];m=cOb(n,16,f,0,3653512,34)|0;c[l>>2]=m;c[k+12>>2]=m;c[k+16>>2]=n;o=a}else o=a;n=c[o>>2]|0;k=c[n+12>>2]|0;m=k;l=(m+-1|d+-1)+(1-m)|0;d=l+b|0;if(d>>>0<=((c[n+16>>2]|0)-m+(c[n+8>>2]|0)|0)>>>0){p=n;q=k;r=p+12|0;s=q+d|0;c[r>>2]=s;t=q;u=t+l|0;v=u;i=e;return v|0};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[g>>2]=64;c[f+0>>2]=c[g+0>>2];k=cOb(24,16,f,0,3653512,80)|0;n=k+8|0;c[n+0>>2]=c[h+0>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];c[n+12>>2]=c[h+12>>2];c[k+4>>2]=a;h=c[o>>2]|0;c[k>>2]=h;c[h+4>>2]=k;c[o>>2]=k;c[j>>2]=(c[j>>2]|0)+1;j=c[a+12>>2]|0;h=j>>>0<b>>>0?b:j;j=c[a+16>>2]|0;c[k+20>>2]=j;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];g=cOb(h,16,f,0,3653512,34)|0;c[n>>2]=g;c[k+12>>2]=g;c[k+16>>2]=h;h=c[o>>2]|0;p=h;q=c[h+12>>2]|0;r=p+12|0;s=q+d|0;c[r>>2]=s;t=q;u=t+l|0;v=u;i=e;return v|0}function Q4d(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e+4|0;g=e;h=d+8|0;j=(c[h>>2]|0)+1|0;c[h>>2]=j;k=d+12|0;l=c[k>>2]|0;m=l&2147483647;do if(j>>>0>m>>>0?(n=l<<1,o=(n|0)==0?1:n,m>>>0<o>>>0):0)if((l|0)>-1){c[k>>2]=o;n=c[d>>2]|0;c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];c[d>>2]=hOb(n,o*24|0,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[d+4>>2];c[f+0>>2]=c[g+0>>2];n=cOb(o*24|0,4,f,0,3653512,352)|0;YEi(n|0,c[d>>2]|0,(c[h>>2]|0)*24|0)|0;c[k>>2]=o;c[d>>2]=n;break}while(0);k=(c[h>>2]|0)+-1|0;h=c[d>>2]|0;d=h+(k*24|0)|0;c[d>>2]=0;c[h+(k*24|0)+4>>2]=0;c[h+(k*24|0)+8>>2]=-1;f=h+(k*24|0)+12|0;b[f+0>>1]=0;b[f+2>>1]=0;b[f+4>>1]=0;b[f+6>>1]=0;b[f+8>>1]=0;a[f+10>>0]=0;i=e;return d|0}function R4d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+8|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;h=a+12|0;j=c[h>>2]|0;k=j&2147483647;do if(g>>>0>k>>>0?(l=j<<1,m=(l|0)==0?1:l,k>>>0<m>>>0):0)if((j|0)>-1){c[h>>2]=m;l=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];c[a>>2]=hOb(l,m*24|0,4,d,0,3653512,370)|0;break}else{c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];l=cOb(m*24|0,4,d,0,3653512,352)|0;YEi(l|0,c[a>>2]|0,(c[f>>2]|0)*24|0)|0;c[h>>2]=m;c[a>>2]=l;break}while(0);i=b;return (c[a>>2]|0)+(((c[f>>2]|0)+-1|0)*24|0)|0}function S4d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;b=a+8|0;h=(c[b>>2]|0)+1|0;c[b>>2]=h;j=a+12|0;k=c[j>>2]|0;l=k&2147483647;if(h>>>0<=l>>>0){m=h;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}h=k<<1;q=(h|0)==0?1:h;do if(l>>>0<q>>>0)if((k|0)>-1){c[j>>2]=q;h=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(h,q<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];h=cOb(q<<2,4,e,0,3653512,352)|0;YEi(h|0,c[a>>2]|0,c[b>>2]<<2|0)|0;c[j>>2]=q;c[a>>2]=h;break}while(0);m=c[b>>2]|0;n=m+-1|0;o=c[a>>2]|0;p=o+(n<<2)|0;c[p>>2]=g;i=d;return}function T4d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=0,I=0,J=0,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=Im,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=i;f=a;a=b;a:while(1){b=a;h=a+-4|0;j=f;b:while(1){k=j;l=b-k|0;m=l>>2;switch(m|0){case 2:{n=j;o=h;p=4;break a;break}case 3:{q=j;r=h;p=6;break a;break}case 4:{s=j;t=h;p=14;break a;break}case 5:{u=j;v=h;p=15;break a;break}case 1:case 0:{p=83;break a;break}default:{}}if((l|0)<124){w=j;x=a;p=21;break a}y=(m|0)/2|0;z=j+(y<<2)|0;do if((l|0)>3996){A=(m|0)/4|0;B=j+(A<<2)|0;C=j+(A+y<<2)|0;A=_4d(j,B,z,C,d)|0;D=c[h>>2]|0;E=c[C>>2]|0;F=c[c[d>>2]>>2]|0;G=ea(g[F+(D*40|0)+36>>2]);if(G>ea(g[F+(E*40|0)+36>>2])){c[C>>2]=D;c[h>>2]=E;E=A+1|0;D=c[C>>2]|0;H=c[z>>2]|0;G=ea(g[F+(D*40|0)+36>>2]);if(G>ea(g[F+(H*40|0)+36>>2])){c[z>>2]=D;c[C>>2]=H;H=A+2|0;C=c[z>>2]|0;D=c[B>>2]|0;G=ea(g[F+(C*40|0)+36>>2]);if(G>ea(g[F+(D*40|0)+36>>2])){c[B>>2]=C;c[z>>2]=D;D=c[B>>2]|0;C=c[j>>2]|0;G=ea(g[F+(D*40|0)+36>>2]);if(G>ea(g[F+(C*40|0)+36>>2])){c[j>>2]=D;c[B>>2]=C;I=F;J=A+4|0}else{I=F;J=A+3|0}}else{I=F;J=H}}else{I=F;J=E}}else{I=F;J=A}}else{A=c[z>>2]|0;F=c[j>>2]|0;E=c[c[d>>2]>>2]|0;G=ea(g[E+(A*40|0)+36>>2]);K=ea(g[E+(F*40|0)+36>>2]);H=c[h>>2]|0;C=ea(g[E+(H*40|0)+36>>2])>G;if(!(G>K)){if(!C){I=E;J=0;break}c[z>>2]=H;c[h>>2]=A;B=c[z>>2]|0;D=c[j>>2]|0;G=ea(g[E+(B*40|0)+36>>2]);if(!(G>ea(g[E+(D*40|0)+36>>2]))){I=E;J=1;break}c[j>>2]=B;c[z>>2]=D;I=E;J=2;break}if(C){c[j>>2]=H;c[h>>2]=F;I=E;J=1;break}c[j>>2]=A;c[z>>2]=F;A=c[h>>2]|0;if(ea(g[E+(A*40|0)+36>>2])>K){c[z>>2]=A;c[h>>2]=F;I=E;J=2}else{I=E;J=1}}while(0);y=c[j>>2]|0;K=ea(g[I+(y*40|0)+36>>2]);G=ea(g[I+((c[z>>2]|0)*40|0)+36>>2]);do if(K>G){L=h;M=J}else{m=a;l=h;while(1){E=m+-8|0;if((j|0)==(E|0))break;F=c[E>>2]|0;if(ea(g[I+(F*40|0)+36>>2])>G){N=F;O=E;p=65;break}else{F=l;l=E;m=F}}if((p|0)==65){p=0;c[j>>2]=N;c[O>>2]=y;L=O;M=J+1|0;break}m=j+4|0;l=c[h>>2]|0;if(K>ea(g[I+(l*40|0)+36>>2]))P=m;else{if((m|0)==(h|0)){p=83;break a}else{Q=j;R=m}while(1){m=c[R>>2]|0;F=Q+8|0;if(K>ea(g[I+(m*40|0)+36>>2])){S=m;T=R;break}if((F|0)==(h|0)){p=83;break a}else{m=R;R=F;Q=m}}c[T>>2]=l;c[h>>2]=S;P=T+4|0}if((P|0)==(h|0)){p=83;break a}else{U=P;V=h}while(1){W=ea(g[I+((c[j>>2]|0)*40|0)+36>>2]);m=U;while(1){F=c[m>>2]|0;E=m+4|0;if(W>ea(g[I+(F*40|0)+36>>2])){X=F;Y=E;Z=m;break}else m=E}m=V;while(1){E=m+-4|0;F=c[E>>2]|0;if(W>ea(g[I+(F*40|0)+36>>2]))m=E;else{_=E;$=F;break}}if(Z>>>0>=_>>>0){j=Z;continue b}c[Z>>2]=$;c[_>>2]=X;U=Y;V=_}}while(0);y=j+4|0;c:do if(y>>>0<L>>>0){l=y;m=L;F=z;E=M;while(1){K=ea(g[I+((c[F>>2]|0)*40|0)+36>>2]);A=l;while(1){H=c[A>>2]|0;C=A+4|0;if(ea(g[I+(H*40|0)+36>>2])>K)A=C;else{aa=H;ba=C;ca=A;break}}A=m;while(1){C=A+-4|0;H=c[C>>2]|0;if(ea(g[I+(H*40|0)+36>>2])>K){da=C;fa=H;break}else A=C}if(ca>>>0>da>>>0){ga=ca;ha=F;ia=E;break c}c[ca>>2]=fa;c[da>>2]=aa;l=ba;m=da;F=(F|0)==(ca|0)?da:F;E=E+1|0}}else{ga=y;ha=z;ia=M}while(0);if((ga|0)!=(ha|0)?(z=c[ha>>2]|0,y=c[ga>>2]|0,K=ea(g[I+(z*40|0)+36>>2]),K>ea(g[I+(y*40|0)+36>>2])):0){c[ga>>2]=z;c[ha>>2]=y;ja=ia+1|0}else ja=ia;if(!ja){ka=$4d(j,ga,d)|0;y=ga+4|0;if($4d(y,a,d)|0){p=78;break}if(ka){j=y;continue}}y=ga;if((y-k|0)>=(b-y|0)){la=j;ma=ga;p=82;break}T4d(j,ga,d);j=ga+4|0}if((p|0)==78){p=0;if(ka){p=83;break}else{f=j;a=ga;continue}}else if((p|0)==82){p=0;T4d(ma+4|0,a,d);f=la;a=ma;continue}}if((p|0)==4){ma=c[o>>2]|0;a=c[n>>2]|0;la=c[c[d>>2]>>2]|0;K=ea(g[la+(ma*40|0)+36>>2]);if(!(K>ea(g[la+(a*40|0)+36>>2]))){i=e;return}c[n>>2]=ma;c[o>>2]=a;i=e;return}else if((p|0)==6){a=q+4|0;o=c[a>>2]|0;ma=c[q>>2]|0;n=c[c[d>>2]>>2]|0;K=ea(g[n+(o*40|0)+36>>2]);G=ea(g[n+(ma*40|0)+36>>2]);la=c[r>>2]|0;f=ea(g[n+(la*40|0)+36>>2])>K;if(!(K>G)){if(!f){i=e;return}c[a>>2]=la;c[r>>2]=o;ga=c[a>>2]|0;ka=c[q>>2]|0;K=ea(g[n+(ga*40|0)+36>>2]);if(!(K>ea(g[n+(ka*40|0)+36>>2]))){i=e;return}c[q>>2]=ga;c[a>>2]=ka;i=e;return}if(f){c[q>>2]=la;c[r>>2]=ma;i=e;return}c[q>>2]=o;c[a>>2]=ma;o=c[r>>2]|0;if(!(ea(g[n+(o*40|0)+36>>2])>G)){i=e;return}c[a>>2]=o;c[r>>2]=ma;i=e;return}else if((p|0)==14){_4d(s,s+4|0,s+8|0,t,d)|0;i=e;return}else if((p|0)==15){t=u+4|0;s=u+8|0;ma=u+12|0;_4d(u,t,s,ma,d)|0;r=c[v>>2]|0;o=c[ma>>2]|0;a=c[c[d>>2]>>2]|0;G=ea(g[a+(r*40|0)+36>>2]);if(!(G>ea(g[a+(o*40|0)+36>>2]))){i=e;return}c[ma>>2]=r;c[v>>2]=o;o=c[ma>>2]|0;v=c[s>>2]|0;G=ea(g[a+(o*40|0)+36>>2]);if(!(G>ea(g[a+(v*40|0)+36>>2]))){i=e;return}c[s>>2]=o;c[ma>>2]=v;v=c[t>>2]|0;if(!(G>ea(g[a+(v*40|0)+36>>2]))){i=e;return}c[t>>2]=o;c[s>>2]=v;v=c[u>>2]|0;if(!(G>ea(g[a+(v*40|0)+36>>2]))){i=e;return}c[u>>2]=o;c[t>>2]=v;i=e;return}else if((p|0)==21){v=w+8|0;t=w+4|0;o=c[t>>2]|0;u=c[w>>2]|0;a=c[c[d>>2]>>2]|0;G=ea(g[a+(o*40|0)+36>>2]);K=ea(g[a+(u*40|0)+36>>2]);d=c[v>>2]|0;W=ea(g[a+(d*40|0)+36>>2]);s=W>G;do if(G>K){if(s){c[w>>2]=d;c[v>>2]=u;na=u;break}c[w>>2]=o;c[t>>2]=u;if(W>K){c[t>>2]=d;c[v>>2]=u;na=u}else na=d}else if(s){c[t>>2]=d;c[v>>2]=o;if(W>K){c[w>>2]=d;c[t>>2]=u;na=o}else na=o}else na=d;while(0);d=w+12|0;if((d|0)==(x|0)){i=e;return}else{oa=na;pa=d;qa=v}while(1){v=c[pa>>2]|0;K=ea(g[a+(v*40|0)+36>>2]);if(K>ea(g[a+(oa*40|0)+36>>2])){d=oa;na=pa;o=qa;while(1){c[na>>2]=d;if((o|0)==(w|0)){ra=w;break}u=o+-4|0;d=c[u>>2]|0;if(!(K>ea(g[a+(d*40|0)+36>>2]))){ra=o;break}else{t=o;o=u;na=t}}c[ra>>2]=v}na=pa+4|0;if((na|0)==(x|0))break;o=pa;oa=c[pa>>2]|0;pa=na;qa=o}i=e;return}else if((p|0)==83){i=e;return}}function U4d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=Im,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;d=i;e=a;a=b;a:while(1){b=a;f=a+-8|0;h=a+-4|0;j=e;b:while(1){l=j;m=b-l|0;n=m>>3;switch(n|0){case 5:{o=j;p=f;q=h;r=15;break a;break}case 2:{s=j;t=f;u=h;r=4;break a;break}case 3:{v=j;w=f;x=h;r=6;break a;break}case 4:{y=j;z=f;r=14;break a;break}case 1:case 0:{r=84;break a;break}default:{}}if((m|0)<248){A=j;B=a;r=21;break a}C=(n|0)/2|0;D=j+(C<<3)|0;do if((m|0)>7992){E=(n|0)/4|0;F=j+(E<<3)|0;G=E+C|0;H=j+(G<<3)|0;I=a5d(j,F,D,H)|0;J=ea(g[h>>2]);K=j+(G<<3)+4|0;if(!(J<ea(g[K>>2]))){L=j+(C<<3)+4|0;M=I;break}G=H;N=c[G>>2]|0;O=c[G+4>>2]|0;G=f;P=c[G+4>>2]|0;Q=H;c[Q>>2]=c[G>>2];c[Q+4>>2]=P;P=f;c[P>>2]=N;c[P+4>>2]=O;O=I+1|0;J=ea(g[K>>2]);K=j+(C<<3)+4|0;if(J<ea(g[K>>2])){P=D;N=c[P>>2]|0;Q=c[P+4>>2]|0;P=H;G=c[P+4>>2]|0;R=D;c[R>>2]=c[P>>2];c[R+4>>2]=G;G=H;c[G>>2]=N;c[G+4>>2]=Q;Q=I+2|0;J=ea(g[K>>2]);G=j+(E<<3)+4|0;if(J<ea(g[G>>2])){E=F;N=c[E>>2]|0;H=c[E+4>>2]|0;E=D;R=c[E+4>>2]|0;P=F;c[P>>2]=c[E>>2];c[P+4>>2]=R;R=D;c[R>>2]=N;c[R+4>>2]=H;J=ea(g[G>>2]);if(J<ea(g[j+4>>2])){G=j;H=c[G>>2]|0;R=c[G+4>>2]|0;G=F;N=c[G+4>>2]|0;P=j;c[P>>2]=c[G>>2];c[P+4>>2]=N;N=F;c[N>>2]=H;c[N+4>>2]=R;L=K;M=I+4|0}else{L=K;M=I+3|0}}else{L=K;M=Q}}else{L=K;M=O}}else{O=j+(C<<3)+4|0;J=ea(g[O>>2]);K=j+4|0;Q=J<ea(g[K>>2]);I=ea(g[h>>2])<J;if(!Q){if(!I){L=O;M=0;break}Q=D;R=c[Q>>2]|0;N=c[Q+4>>2]|0;Q=f;H=c[Q+4>>2]|0;F=D;c[F>>2]=c[Q>>2];c[F+4>>2]=H;H=f;c[H>>2]=R;c[H+4>>2]=N;J=ea(g[O>>2]);if(!(J<ea(g[K>>2]))){L=O;M=1;break}K=j;N=c[K>>2]|0;H=c[K+4>>2]|0;K=D;R=c[K+4>>2]|0;F=j;c[F>>2]=c[K>>2];c[F+4>>2]=R;R=D;c[R>>2]=N;c[R+4>>2]=H;L=O;M=2;break}H=j;R=c[H>>2]|0;N=c[H+4>>2]|0;if(I){I=f;H=c[I+4>>2]|0;F=j;c[F>>2]=c[I>>2];c[F+4>>2]=H;H=f;c[H>>2]=R;c[H+4>>2]=N;L=O;M=1;break}H=D;F=c[H+4>>2]|0;I=j;c[I>>2]=c[H>>2];c[I+4>>2]=F;F=D;c[F>>2]=R;c[F+4>>2]=N;J=ea(g[h>>2]);if(J<(c[k>>2]=N,ea(g[k>>2]))){F=f;I=c[F+4>>2]|0;H=D;c[H>>2]=c[F>>2];c[H+4>>2]=I;I=f;c[I>>2]=R;c[I+4>>2]=N;L=O;M=2}else{L=O;M=1}}while(0);C=j+4|0;J=ea(g[C>>2]);S=ea(g[L>>2]);do if(J<S){T=f;U=M}else{n=a;m=f;while(1){O=n+-16|0;if((j|0)==(O|0))break;if(ea(g[n+-12>>2])<S){V=O;r=66;break}else{N=m;m=O;n=N}}if((r|0)==66){r=0;n=j;m=c[n>>2]|0;N=c[n+4>>2]|0;n=V;O=c[n+4>>2]|0;I=j;c[I>>2]=c[n>>2];c[I+4>>2]=O;O=V;c[O>>2]=m;c[O+4>>2]=N;T=V;U=M+1|0;break}N=j+8|0;if(J<ea(g[h>>2]))W=N;else{if((N|0)==(f|0)){r=84;break a}else{X=j;Y=N}while(1){N=X+16|0;if(J<ea(g[Y+4>>2])){Z=Y;break}if((N|0)==(f|0)){r=84;break a}else{O=Y;Y=N;X=O}}O=Z;N=c[O>>2]|0;m=c[O+4>>2]|0;O=f;I=c[O+4>>2]|0;n=Z;c[n>>2]=c[O>>2];c[n+4>>2]=I;I=f;c[I>>2]=N;c[I+4>>2]=m;W=Z+8|0}if((W|0)==(f|0)){r=84;break a}else{_=W;$=f}while(1){aa=ea(g[C>>2]);m=_;while(1){I=m+8|0;if(aa<ea(g[m+4>>2])){ba=I;ca=m;break}else m=I}m=$;while(1){I=m+-8|0;if(aa<ea(g[m+-4>>2]))m=I;else{da=I;break}}if(ca>>>0>=da>>>0){j=ca;continue b}m=ca;I=c[m>>2]|0;N=c[m+4>>2]|0;m=da;n=c[m+4>>2]|0;O=ca;c[O>>2]=c[m>>2];c[O+4>>2]=n;n=da;c[n>>2]=I;c[n+4>>2]=N;_=ba;$=da}}while(0);C=j+8|0;c:do if(C>>>0<T>>>0){N=C;n=T;I=D;O=U;while(1){J=ea(g[I+4>>2]);m=N;while(1){R=m+8|0;if(ea(g[m+4>>2])<J)m=R;else{fa=R;ga=m;break}}m=n;while(1){R=m+-8|0;if(ea(g[m+-4>>2])<J){ha=R;break}else m=R}if(ga>>>0>ha>>>0){ia=ga;ja=I;ka=O;break c}m=ga;R=c[m>>2]|0;H=c[m+4>>2]|0;m=ha;F=c[m+4>>2]|0;K=ga;c[K>>2]=c[m>>2];c[K+4>>2]=F;F=ha;c[F>>2]=R;c[F+4>>2]=H;N=fa;n=ha;I=(I|0)==(ga|0)?ha:I;O=O+1|0}}else{ia=C;ja=D;ka=U}while(0);if((ia|0)!=(ja|0)?(J=ea(g[ja+4>>2]),J<ea(g[ia+4>>2])):0){D=ia;C=c[D>>2]|0;O=c[D+4>>2]|0;D=ja;I=c[D+4>>2]|0;n=ia;c[n>>2]=c[D>>2];c[n+4>>2]=I;I=ja;c[I>>2]=C;c[I+4>>2]=O;la=ka+1|0}else la=ka;if(!la){ma=b5d(j,ia)|0;O=ia+8|0;if(b5d(O,a)|0){r=79;break}if(ma){j=O;continue}}O=ia;if((O-l|0)>=(b-O|0)){na=j;oa=ia;r=83;break}U4d(j,ia);j=ia+8|0}if((r|0)==79){r=0;if(ma){r=84;break}else{e=j;a=ia;continue}}else if((r|0)==83){r=0;U4d(oa+8|0,a);e=na;a=oa;continue}}if((r|0)==4){J=ea(g[u>>2]);if(!(J<ea(g[s+4>>2]))){i=d;return}u=s;oa=c[u>>2]|0;a=c[u+4>>2]|0;u=t;na=c[u+4>>2]|0;e=s;c[e>>2]=c[u>>2];c[e+4>>2]=na;na=t;c[na>>2]=oa;c[na+4>>2]=a;i=d;return}else if((r|0)==6){a=v+8|0;na=v+12|0;J=ea(g[na>>2]);oa=v+4|0;t=J<ea(g[oa>>2]);e=ea(g[x>>2])<J;if(!t){if(!e){i=d;return}t=a;u=c[t>>2]|0;s=c[t+4>>2]|0;t=w;ia=c[t+4>>2]|0;ma=a;c[ma>>2]=c[t>>2];c[ma+4>>2]=ia;ia=w;c[ia>>2]=u;c[ia+4>>2]=s;J=ea(g[na>>2]);if(!(J<ea(g[oa>>2]))){i=d;return}oa=v;na=c[oa>>2]|0;s=c[oa+4>>2]|0;oa=a;ia=c[oa+4>>2]|0;u=v;c[u>>2]=c[oa>>2];c[u+4>>2]=ia;ia=a;c[ia>>2]=na;c[ia+4>>2]=s;i=d;return}s=v;ia=c[s>>2]|0;na=c[s+4>>2]|0;if(e){e=w;s=c[e+4>>2]|0;u=v;c[u>>2]=c[e>>2];c[u+4>>2]=s;s=w;c[s>>2]=ia;c[s+4>>2]=na;i=d;return}s=a;u=c[s+4>>2]|0;e=v;c[e>>2]=c[s>>2];c[e+4>>2]=u;u=a;c[u>>2]=ia;c[u+4>>2]=na;J=ea(g[x>>2]);if(!(J<(c[k>>2]=na,ea(g[k>>2])))){i=d;return}x=w;u=c[x+4>>2]|0;e=a;c[e>>2]=c[x>>2];c[e+4>>2]=u;u=w;c[u>>2]=ia;c[u+4>>2]=na;i=d;return}else if((r|0)==14){a5d(y,y+8|0,y+16|0,z)|0;i=d;return}else if((r|0)==15){z=o+8|0;y=o+16|0;na=o+24|0;a5d(o,z,y,na)|0;J=ea(g[q>>2]);q=o+28|0;if(!(J<ea(g[q>>2]))){i=d;return}u=na;ia=c[u>>2]|0;w=c[u+4>>2]|0;u=p;e=c[u+4>>2]|0;x=na;c[x>>2]=c[u>>2];c[x+4>>2]=e;e=p;c[e>>2]=ia;c[e+4>>2]=w;J=ea(g[q>>2]);if(!(J<ea(g[o+20>>2]))){i=d;return}q=y;w=c[q>>2]|0;e=c[q+4>>2]|0;q=na;ia=c[q>>2]|0;p=c[q+4>>2]|0;q=y;c[q>>2]=ia;c[q+4>>2]=p;q=na;c[q>>2]=w;c[q+4>>2]=e;J=(c[k>>2]=p,ea(g[k>>2]));if(!(J<ea(g[o+12>>2]))){i=d;return}e=z;q=c[e>>2]|0;w=c[e+4>>2]|0;e=z;c[e>>2]=ia;c[e+4>>2]=p;e=y;c[e>>2]=q;c[e+4>>2]=w;if(!(J<ea(g[o+4>>2]))){i=d;return}w=o;e=c[w>>2]|0;q=c[w+4>>2]|0;w=o;c[w>>2]=ia;c[w+4>>2]=p;p=z;c[p>>2]=e;c[p+4>>2]=q;i=d;return}else if((r|0)==21){q=A+16|0;p=A+8|0;J=ea(g[A+12>>2]);S=ea(g[A+4>>2]);aa=ea(g[A+20>>2]);e=aa<J;do if(J<S){z=A;w=c[z>>2]|0;ia=c[z+4>>2]|0;if(e){z=q;o=c[z+4>>2]|0;y=A;c[y>>2]=c[z>>2];c[y+4>>2]=o;o=q;c[o>>2]=w;c[o+4>>2]=ia;break}o=p;y=c[o+4>>2]|0;z=A;c[z>>2]=c[o>>2];c[z+4>>2]=y;y=p;c[y>>2]=w;c[y+4>>2]=ia;if(aa<(c[k>>2]=ia,ea(g[k>>2]))){y=q;z=c[y+4>>2]|0;o=p;c[o>>2]=c[y>>2];c[o+4>>2]=z;z=q;c[z>>2]=w;c[z+4>>2]=ia}}else if(e?(ia=p,z=c[ia>>2]|0,w=c[ia+4>>2]|0,ia=q,o=c[ia>>2]|0,y=c[ia+4>>2]|0,ia=p,c[ia>>2]=o,c[ia+4>>2]=y,ia=q,c[ia>>2]=z,c[ia+4>>2]=w,(c[k>>2]=y,ea(g[k>>2]))<S):0){w=A;ia=c[w>>2]|0;z=c[w+4>>2]|0;w=A;c[w>>2]=o;c[w+4>>2]=y;y=p;c[y>>2]=ia;c[y+4>>2]=z}while(0);p=A+24|0;if((p|0)==(B|0)){i=d;return}else{pa=p;qa=q}while(1){S=ea(g[pa+4>>2]);if(S<ea(g[qa+4>>2])){q=pa;p=c[q>>2]|0;e=c[q+4>>2]|0;S=(c[k>>2]=e,ea(g[k>>2]));q=pa;z=qa;while(1){y=z;ia=c[y+4>>2]|0;w=q;c[w>>2]=c[y>>2];c[w+4>>2]=ia;if((z|0)==(A|0)){ra=z;break}if(S<ea(g[z+-4>>2])){ia=z;z=z+-8|0;q=ia}else{ra=z;break}}z=ra;c[z>>2]=p;c[z+4>>2]=e}z=pa+8|0;if((z|0)==(B|0))break;else{q=pa;pa=z;qa=q}}i=d;return}else if((r|0)==84){i=d;return}}function V4d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e;j=b+8|0;k=c[j>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/40|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{m=p+4|0;r=p+28|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;a[m+20>>0]=0;c[r+0>>2]=c[150288];c[r+4>>2]=c[150289];c[r+8>>2]=c[150290];q=c[l>>2]|0}p=q+40|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/40|0)+d|0;if((p|0)<0)vxi(b);n=o;o=(k-n|0)/40|0;if(o>>>0<1073741823){k=o<<1;s=k>>>0<p>>>0?p:k}else s=2147483647;k=((c[l>>2]|0)-n|0)/40|0;n=h+12|0;c[n>>2]=0;c[h+16>>2]=b+8;if(!s)t=0;else{c[g>>2]=54;c[f+0>>2]=c[g+0>>2];t=cOb(s*40|0,16,f,0,3653512,80)|0}c[h>>2]=t;f=t+(k*40|0)|0;k=h+8|0;c[k>>2]=f;g=h+4|0;c[g>>2]=f;c[n>>2]=t+(s*40|0);s=d;d=f;while(1){if(!d)u=0;else{f=d+4|0;t=d+28|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;a[f+20>>0]=0;c[t+0>>2]=c[150288];c[t+4>>2]=c[150289];c[t+8>>2]=c[150290];u=c[k>>2]|0}t=u+40|0;c[k>>2]=t;s=s+-1|0;if(!s){v=t;break}else d=t}d=c[b>>2]|0;s=c[l>>2]|0;u=c[g>>2]|0;if((s|0)==(d|0)){w=u;x=d;y=d}else{t=s;s=u;while(1){u=t;t=t+-40|0;a[s+-40>>0]=a[t>>0]|0;c5d(s+-36|0,u+-36|0);c[s+-24>>2]=c[u+-24>>2];f=s+-20|0;p=u+-20|0;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];p=s+-40|0;c[g>>2]=p;if((t|0)==(d|0)){z=p;break}else s=p}w=z;x=c[b>>2]|0;y=c[l>>2]|0}c[b>>2]=w;c[g>>2]=x;c[l>>2]=v;c[k>>2]=y;y=c[j>>2]|0;c[j>>2]=c[n>>2];c[n>>2]=y;c[h>>2]=x;d5d(h);i=e;return}function W4d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[b>>2]|0;l=k;m=((c[d>>2]|0)-l|0)/72|0;d=k+(m*72|0)|0;n=b+4|0;o=c[n>>2]|0;p=b+8|0;q=c[p>>2]|0;if(o>>>0<q>>>0){if((d|0)==(o|0)){if(!d)r=0;else{s=d+0|0;t=e+0|0;u=s+72|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));r=c[n>>2]|0}c[n>>2]=r+72;v=d;c[a>>2]=v;i=f;return}r=k+((m+1|0)*72|0)|0;w=k+((((o-r|0)/72|0)+m|0)*72|0)|0;if(w>>>0<o>>>0){x=o;y=w;do{if(!x)z=0;else{s=x+0|0;t=y+0|0;u=s+72|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));z=c[n>>2]|0}y=y+72|0;x=z+72|0;c[n>>2]=x}while(y>>>0<o>>>0)}if((o|0)!=(r|0)){r=w;w=o;do{y=w;w=w+-72|0;x=r;r=r+-72|0;c[w>>2]=c[r>>2];s=y+-68+0|0;t=x+-68+0|0;u=s+68|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0))}while((r|0)!=(d|0))}if(d>>>0>e>>>0)A=e;else A=(c[n>>2]|0)>>>0>e>>>0?e+72|0:e;c[d>>2]=c[A>>2];s=k+(m*72|0)+4|0;t=A+4|0;u=s+68|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));v=d;c[a>>2]=v;i=f;return}A=((o-l|0)/72|0)+1|0;if((A|0)<0)vxi(b);l=k;k=(q-l|0)/72|0;if(k>>>0<1073741823){q=k<<1;k=q>>>0<A>>>0?A:q;q=d;A=(q-l|0)/72|0;if(!k){B=0;C=0;D=A;E=q}else{F=k;G=A;H=q;I=20}}else{q=d;F=2147483647;G=(q-l|0)/72|0;H=q;I=20}if((I|0)==20){c[h>>2]=54;c[g+0>>2]=c[h+0>>2];B=F;C=cOb(F*72|0,16,g,0,3653512,80)|0;D=G;E=H}H=C+(D*72|0)|0;G=C+(B*72|0)|0;do if((D|0)==(B|0)){F=(D*72|0)/72|0;if((D|0)>0){J=G;K=C+((((F+1|0)/-2|0)+D|0)*72|0)|0;break}I=F<<1;F=(I|0)==0?1:I;c[h>>2]=54;c[g+0>>2]=c[h+0>>2];I=cOb(F*72|0,16,g,0,3653512,80)|0;q=I+((F>>>2)*72|0)|0;l=I+(F*72|0)|0;if(!C){J=l;K=q}else{c[h>>2]=54;c[g+0>>2]=c[h+0>>2];eOb(C,g);J=l;K=q}}else{J=G;K=H}while(0);if(!K)L=0;else{s=K+0|0;t=e+0|0;u=s+72|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));L=K}t=c[b>>2]|0;s=E-t|0;u=K+(((s|0)/-72|0)*72|0)|0;YEi(u|0,t|0,s|0)|0;s=(c[n>>2]|0)-E|0;YEi(L+72|0,d|0,s|0)|0;d=c[b>>2]|0;c[b>>2]=u;c[n>>2]=L+((((s|0)/72|0)+1|0)*72|0);c[p>>2]=J;if(!d){v=K;c[a>>2]=v;i=f;return}c[j>>2]=54;c[g+0>>2]=c[j+0>>2];eOb(d,g);v=K;c[a>>2]=v;i=f;return}function X4d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=Im,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;f=i;i=i+64|0;h=f+56|0;j=f+52|0;k=f+48|0;l=f+24|0;m=f;n=c[a>>2]|0;o=n+16|0;p=a+20|0;q=a+4|0;Y4d(l,o,q,n+28|0,b,d);c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];c[p+12>>2]=c[l+12>>2];c[p+16>>2]=c[l+16>>2];c[p+20>>2]=c[l+20>>2];l=a+12|0;if((c[l>>2]|0)<=(e|0)){i=f;return}e5d(m,o,q,b,d);r=ea(g[m+12>>2]);if(r<ea(0.0))s=ea(-r);else s=r;p=!(s<=ea(9.99999997e-07));s=ea(g[m+20>>2]);if(!p){if(s<ea(0.0))t=ea(-s);else t=s;if(t<=ea(9.99999997e-07)){i=f;return}}p=a+60|0;n=r>s?601168:601200;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];s=ea(g[n>>2]);r=ea(s*ea(g[m>>2]));s=ea(g[n+4>>2]);t=ea(r+ea(s*ea(g[m+4>>2])));s=ea(g[n+8>>2]);r=ea(-ea(t+ea(s*ea(g[m+8>>2]))));m=a+72|0;g[m>>2]=r;n=c[153116]|0;if(c[l>>2]|0){u=d+4|0;v=d+8|0;w=b+4|0;x=b+8|0;y=a+64|0;z=a+68|0;A=0;B=0;C=0;s=r;D=0;E=0;F=0;G=0;while(1){H=c[(c[q>>2]|0)+(G<<2)>>2]|0;I=c[o>>2]|0;r=ea(g[I+(H*40|0)>>2]);t=ea(r*ea(g[d>>2]));r=ea(g[I+(H*40|0)+4>>2]);J=ea(r*ea(g[u>>2]));r=ea(g[I+(H*40|0)+8>>2]);K=ea(r*ea(g[v>>2]));r=ea(t+ea(g[b>>2]));t=ea(J+ea(g[w>>2]));J=ea(K+ea(g[x>>2]));K=ea(r*ea(g[p>>2]));r=ea(K+ea(t*ea(g[y>>2])));if(ea(s+ea(r+ea(J*ea(g[z>>2]))))>ea(0.0)){I=D+1|0;L=E&2147483647;do if(I>>>0>L>>>0?(M=E<<1,N=(M|0)==0?1:M,L>>>0<N>>>0):0)if((E|0)>-1){c[j>>2]=n;c[h+0>>2]=c[j+0>>2];O=N;P=hOb(F,N<<2,4,h,0,3653512,370)|0;break}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];M=cOb(N<<2,4,h,0,3653512,352)|0;YEi(M|0,F|0,I<<2|0)|0;O=N;P=M;break}else{O=E;P=F}while(0);c[P+(D<<2)>>2]=H;Q=O;R=I;S=P;T=B;U=A;V=C}else{L=A+1|0;M=B&2147483647;do if(L>>>0>M>>>0?(N=B<<1,W=(N|0)==0?1:N,M>>>0<W>>>0):0)if((B|0)>-1){c[j>>2]=n;c[h+0>>2]=c[j+0>>2];X=hOb(C,W<<2,4,h,0,3653512,370)|0;Y=W;break}else{c[j>>2]=n;c[h+0>>2]=c[j+0>>2];N=cOb(W<<2,4,h,0,3653512,352)|0;YEi(N|0,C|0,L<<2|0)|0;X=N;Y=W;break}else{X=C;Y=B}while(0);c[X+(A<<2)>>2]=H;Q=E;R=D;S=F;T=Y;U=L;V=X}M=G+1|0;if(M>>>0>=(c[l>>2]|0)>>>0){Z=Q;_=R;$=S;aa=T;ba=U;ca=V;break}A=U;B=T;C=V;s=ea(g[m>>2]);D=R;E=Q;F=S;G=M}if((_|0)==0|(ba|0)==0){da=aa;fa=Z;ga=n;ha=$;ia=n;ja=ca}else{G=a+16|0;if((c[G>>2]|0)>-1){S=c[q>>2]|0;c[j>>2]=c[a+8>>2];c[h+0>>2]=c[j+0>>2];eOb(S,h);c[q>>2]=0}c[l>>2]=0;c[G>>2]=0;G=xCi(84)|0;c[G>>2]=c[a>>2];l=c[153116]|0;c[G+4>>2]=0;c[G+8>>2]=l;c[G+76>>2]=0;c[G+80>>2]=0;l=G+12|0;q=l+60|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(q|0));S=a+76|0;F=c[S>>2]|0;if(!((F|0)==(G|0)|(F|0)==0)){G4d(F);ACi(F)}c[S>>2]=G;F=xCi(84)|0;c[F>>2]=c[a>>2];Q=c[153116]|0;c[F+4>>2]=0;c[F+8>>2]=Q;c[F+76>>2]=0;c[F+80>>2]=0;l=F+12|0;q=l+60|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(q|0));l=a+80|0;a=c[l>>2]|0;if((a|0)==(F|0)|(a|0)==0)ka=G;else{G4d(a);ACi(a);ka=c[S>>2]|0}c[l>>2]=F;F=ka+4|0;a=c[F>>2]|0;c[F>>2]=$;c[ka+12>>2]=_;_=ka+16|0;$=c[_>>2]|0;c[_>>2]=Z;Z=ka+8|0;ka=c[Z>>2]|0;c[Z>>2]=n;Z=c[l>>2]|0;_=Z+4|0;F=c[_>>2]|0;c[_>>2]=ca;c[Z+12>>2]=ba;ba=Z+16|0;ca=c[ba>>2]|0;c[ba>>2]=aa;aa=Z+8|0;Z=c[aa>>2]|0;c[aa>>2]=n;X4d(c[S>>2]|0,b,d,e);X4d(c[l>>2]|0,b,d,e);da=ca;fa=$;ga=ka;ha=a;ia=Z;ja=F}if((da|0)>-1){la=ia;ma=ja;na=ha;oa=ga;pa=fa;qa=34}else{ra=fa;sa=ga;ta=ha}}else{la=n;ma=0;na=0;oa=n;pa=0;qa=34}if((qa|0)==34){c[j>>2]=la;c[h+0>>2]=c[j+0>>2];eOb(ma,h);ra=pa;sa=oa;ta=na}if((ra|0)<=-1){i=f;return}c[k>>2]=sa;c[h+0>>2]=c[k+0>>2];eOb(ta,h);i=f;return}function Y4d(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=Im,r=Im,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=Im,K=0,L=0,M=Im,N=0,O=Im,P=0,Q=0,R=Im,S=0,T=0,U=Im;j=i;i=i+32|0;k=j+12|0;l=j;m=c[d>>2]|0;n=c[m>>2]|0;o=c[b>>2]|0;p=ea(g[o+(n*40|0)>>2]);q=ea(g[h>>2]);r=ea(p*q);p=ea(g[o+(n*40|0)+4>>2]);s=h+4|0;t=ea(g[s>>2]);u=ea(p*t);p=ea(g[o+(n*40|0)+8>>2]);n=h+8|0;v=ea(g[n>>2]);w=ea(p*v);p=ea(g[f>>2]);x=ea(r+p);y=f+4|0;r=ea(g[y>>2]);z=ea(u+r);A=f+8|0;u=ea(g[A>>2]);B=ea(w+u);C=a+12|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=x;g[a+4>>2]=z;g[a+8>>2]=B;c[C+0>>2]=c[150284];c[C+4>>2]=c[150285];c[C+8>>2]=c[150286];C=d+8|0;if(!(c[C>>2]|0)){i=j;return}D=k+4|0;E=k+8|0;F=l+4|0;G=l+8|0;H=m;m=o;B=q;q=t;t=v;v=p;p=r;r=u;o=0;while(1){I=c[H+(o<<2)>>2]|0;u=ea(ea(g[m+(I*40|0)>>2])*B);z=ea(ea(g[m+(I*40|0)+4>>2])*q);x=ea(u+v);u=ea(z+p);z=ea(ea(ea(g[m+(I*40|0)+8>>2])*t)+r);w=ea(g[m+(I*40|0)+12>>2]);J=ea(g[m+(I*40|0)+16>>2]);K=c[m+(I*40|0)+32>>2]|0;I=c[e>>2]|0;L=I+(K<<7)+100|0;M=ea(g[L>>2]);N=I+(K<<7)+112|0;O=ea(M-ea(g[N>>2]));P=I+(K<<7)+104|0;M=ea(g[P>>2]);Q=I+(K<<7)+116|0;R=ea(M-ea(g[Q>>2]));S=I+(K<<7)+108|0;M=ea(g[S>>2]);T=I+(K<<7)+120|0;U=ea(u+ea(J*R));R=ea(z+ea(w*ea(M-ea(g[T>>2]))));g[k>>2]=ea(x+ea(w*O));g[D>>2]=U;g[E>>2]=R;Ulc(a,k);R=ea(g[L>>2]);U=ea(R+ea(g[N>>2]));R=ea(g[P>>2]);O=ea(R+ea(g[Q>>2]));R=ea(g[S>>2]);M=ea(u+ea(J*O));O=ea(z+ea(w*ea(R+ea(g[T>>2]))));g[l>>2]=ea(x+ea(w*U));g[F>>2]=M;g[G>>2]=O;Ulc(a,l);T=o+1|0;if(T>>>0>=(c[C>>2]|0)>>>0)break;O=ea(g[h>>2]);M=ea(g[s>>2]);U=ea(g[n>>2]);w=ea(g[f>>2]);x=ea(g[y>>2]);H=c[d>>2]|0;m=c[b>>2]|0;B=O;q=M;t=U;v=w;p=x;r=ea(g[A>>2]);o=T}i=j;return}function Z4d(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[a>>2]|0;g=a+4|0;h=c[g>>2]|0;j=d+4|0;k=c[j>>2]|0;if((h|0)==(f|0)){l=k;m=f}else{n=h;h=k;while(1){k=n;n=n+-148|0;o=h+-148+0|0;p=n+0|0;q=o+76|0;do{b[o>>1]=b[p>>1]|0;o=o+2|0;p=p+2|0}while((o|0)<(q|0));N4d(h+-72|0,k+-72|0);N4d(h+-36|0,k+-36|0);p=(c[j>>2]|0)+-148|0;c[j>>2]=p;if((n|0)==(f|0)){r=p;break}else h=p}l=r;m=c[a>>2]|0}c[a>>2]=l;c[j>>2]=m;m=d+8|0;l=c[g>>2]|0;c[g>>2]=c[m>>2];c[m>>2]=l;l=a+8|0;a=d+12|0;m=c[l>>2]|0;c[l>>2]=c[a>>2];c[a>>2]=m;c[d>>2]=c[j>>2];i=e;return}function _4d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0,t=Im,u=0;h=i;j=c[b>>2]|0;k=c[a>>2]|0;l=c[c[f>>2]>>2]|0;m=ea(g[l+(j*40|0)+36>>2]);n=ea(g[l+(k*40|0)+36>>2]);f=c[d>>2]|0;o=ea(g[l+(f*40|0)+36>>2])>m;do if(m>n){if(o){c[a>>2]=f;c[d>>2]=k;p=1;q=k;break}c[a>>2]=j;c[b>>2]=k;r=c[d>>2]|0;if(ea(g[l+(r*40|0)+36>>2])>n){c[b>>2]=r;c[d>>2]=k;p=2;q=k}else{p=1;q=r}}else if(o){c[b>>2]=f;c[d>>2]=j;r=c[b>>2]|0;s=c[a>>2]|0;t=ea(g[l+(r*40|0)+36>>2]);if(t>ea(g[l+(s*40|0)+36>>2])){c[a>>2]=r;c[b>>2]=s;p=2;q=c[d>>2]|0}else{p=1;q=j}}else{p=0;q=f}while(0);f=c[e>>2]|0;n=ea(g[l+(f*40|0)+36>>2]);if(!(n>ea(g[l+(q*40|0)+36>>2]))){u=p;i=h;return u|0}c[d>>2]=f;c[e>>2]=q;q=c[d>>2]|0;e=c[b>>2]|0;n=ea(g[l+(q*40|0)+36>>2]);if(!(n>ea(g[l+(e*40|0)+36>>2]))){u=p+1|0;i=h;return u|0}c[b>>2]=q;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;n=ea(g[l+(e*40|0)+36>>2]);if(!(n>ea(g[l+(d*40|0)+36>>2]))){u=p+2|0;i=h;return u|0}c[a>>2]=e;c[b>>2]=d;u=p+3|0;i=h;return u|0}function $4d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=0,p=0,q=0,r=0,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;switch(b-a>>2|0){case 3:{f=a+4|0;h=b+-4|0;j=c[f>>2]|0;k=c[a>>2]|0;l=c[c[d>>2]>>2]|0;m=ea(g[l+(j*40|0)+36>>2]);n=ea(g[l+(k*40|0)+36>>2]);o=c[h>>2]|0;p=ea(g[l+(o*40|0)+36>>2])>m;if(!(m>n)){if(!p){q=1;i=e;return q|0}c[f>>2]=o;c[h>>2]=j;r=c[f>>2]|0;s=c[a>>2]|0;m=ea(g[l+(r*40|0)+36>>2]);if(!(m>ea(g[l+(s*40|0)+36>>2]))){q=1;i=e;return q|0}c[a>>2]=r;c[f>>2]=s;q=1;i=e;return q|0}if(p){c[a>>2]=o;c[h>>2]=k;q=1;i=e;return q|0}c[a>>2]=j;c[f>>2]=k;j=c[h>>2]|0;if(!(ea(g[l+(j*40|0)+36>>2])>n)){q=1;i=e;return q|0}c[f>>2]=j;c[h>>2]=k;q=1;i=e;return q|0}case 4:{_4d(a,a+4|0,a+8|0,b+-4|0,d)|0;q=1;i=e;return q|0}case 2:{k=b+-4|0;h=c[k>>2]|0;j=c[a>>2]|0;f=c[c[d>>2]>>2]|0;if(!(ea(g[f+(h*40|0)+36>>2])>ea(g[f+(j*40|0)+36>>2]))){q=1;i=e;return q|0}c[a>>2]=h;c[k>>2]=j;q=1;i=e;return q|0}case 5:{j=a+4|0;k=a+8|0;h=a+12|0;f=b+-4|0;_4d(a,j,k,h,d)|0;l=c[f>>2]|0;o=c[h>>2]|0;p=c[c[d>>2]>>2]|0;if(!(ea(g[p+(l*40|0)+36>>2])>ea(g[p+(o*40|0)+36>>2]))){q=1;i=e;return q|0}c[h>>2]=l;c[f>>2]=o;o=c[h>>2]|0;f=c[k>>2]|0;n=ea(g[p+(o*40|0)+36>>2]);if(!(n>ea(g[p+(f*40|0)+36>>2]))){q=1;i=e;return q|0}c[k>>2]=o;c[h>>2]=f;f=c[j>>2]|0;if(!(n>ea(g[p+(f*40|0)+36>>2]))){q=1;i=e;return q|0}c[j>>2]=o;c[k>>2]=f;f=c[a>>2]|0;if(!(n>ea(g[p+(f*40|0)+36>>2]))){q=1;i=e;return q|0}c[a>>2]=o;c[j>>2]=f;q=1;i=e;return q|0}case 1:case 0:{q=1;i=e;return q|0}default:{f=a+8|0;j=a+4|0;o=c[j>>2]|0;p=c[a>>2]|0;k=c[c[d>>2]>>2]|0;n=ea(g[k+(o*40|0)+36>>2]);m=ea(g[k+(p*40|0)+36>>2]);d=c[f>>2]|0;t=ea(g[k+(d*40|0)+36>>2]);h=t>n;do if(n>m){if(h){c[a>>2]=d;c[f>>2]=p;u=p;break}c[a>>2]=o;c[j>>2]=p;if(t>m){c[j>>2]=d;c[f>>2]=p;u=p}else u=d}else if(h){c[j>>2]=d;c[f>>2]=o;if(t>m){c[a>>2]=d;c[j>>2]=p;u=o}else u=o}else u=d;while(0);d=a+12|0;if((d|0)==(b|0)){q=1;i=e;return q|0}else{v=u;w=0;x=d;y=f}while(1){f=c[x>>2]|0;m=ea(g[k+(f*40|0)+36>>2]);if(m>ea(g[k+(v*40|0)+36>>2])){d=v;u=x;o=y;while(1){c[u>>2]=d;if((o|0)==(a|0)){z=a;break}p=o+-4|0;d=c[p>>2]|0;if(!(m>ea(g[k+(d*40|0)+36>>2]))){z=o;break}else{j=o;o=p;u=j}}c[z>>2]=f;u=w+1|0;if((u|0)==8){A=x;break}else B=u}else B=w;u=x+4|0;if((u|0)==(b|0)){q=1;C=34;break}o=x;v=c[x>>2]|0;w=B;x=u;y=o}if((C|0)==34){i=e;return q|0}q=(A+4|0)==(b|0);i=e;return q|0}}return 0}function a5d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=0;f=i;h=b+4|0;j=ea(g[h>>2]);l=a+4|0;m=j<ea(g[l>>2]);n=d+4|0;o=ea(g[n>>2]);p=o<j;do if(m){q=a;r=c[q>>2]|0;s=c[q+4>>2]|0;if(p){q=d;t=c[q+4>>2]|0;u=a;c[u>>2]=c[q>>2];c[u+4>>2]=t;t=d;c[t>>2]=r;c[t+4>>2]=s;v=1;w=(c[k>>2]=s,ea(g[k>>2]));break}t=b;u=c[t+4>>2]|0;q=a;c[q>>2]=c[t>>2];c[q+4>>2]=u;u=b;c[u>>2]=r;c[u+4>>2]=s;j=ea(g[n>>2]);x=(c[k>>2]=s,ea(g[k>>2]));if(j<x){u=d;q=c[u+4>>2]|0;t=b;c[t>>2]=c[u>>2];c[t+4>>2]=q;q=d;c[q>>2]=r;c[q+4>>2]=s;v=2;w=x}else{v=1;w=j}}else if(p){s=b;q=c[s>>2]|0;r=c[s+4>>2]|0;s=d;t=c[s+4>>2]|0;u=b;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=d;c[t>>2]=q;c[t+4>>2]=r;j=ea(g[h>>2]);t=j<ea(g[l>>2]);j=(c[k>>2]=r,ea(g[k>>2]));if(t){t=a;r=c[t>>2]|0;q=c[t+4>>2]|0;t=b;u=c[t+4>>2]|0;s=a;c[s>>2]=c[t>>2];c[s+4>>2]=u;u=b;c[u>>2]=r;c[u+4>>2]=q;v=2;w=ea(g[n>>2])}else{v=1;w=j}}else{v=0;w=o}while(0);if(!(ea(g[e+4>>2])<w)){y=v;i=f;return y|0}p=d;m=c[p>>2]|0;q=c[p+4>>2]|0;p=e;u=c[p+4>>2]|0;r=d;c[r>>2]=c[p>>2];c[r+4>>2]=u;u=e;c[u>>2]=m;c[u+4>>2]=q;w=ea(g[n>>2]);if(!(w<ea(g[h>>2]))){y=v+1|0;i=f;return y|0}n=b;q=c[n>>2]|0;u=c[n+4>>2]|0;n=d;m=c[n+4>>2]|0;e=b;c[e>>2]=c[n>>2];c[e+4>>2]=m;m=d;c[m>>2]=q;c[m+4>>2]=u;w=ea(g[h>>2]);if(!(w<ea(g[l>>2]))){y=v+2|0;i=f;return y|0}l=a;h=c[l>>2]|0;u=c[l+4>>2]|0;l=b;m=c[l+4>>2]|0;q=a;c[q>>2]=c[l>>2];c[q+4>>2]=m;m=b;c[m>>2]=h;c[m+4>>2]=u;y=v+3|0;i=f;return y|0}function b5d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;switch(b-a>>3|0){case 5:{e=a+8|0;f=a+16|0;h=a+24|0;a5d(a,e,f,h)|0;j=a+28|0;if(!(ea(g[b+-4>>2])<ea(g[j>>2]))){l=1;i=d;return l|0}m=b+-8|0;n=h;o=c[n>>2]|0;p=c[n+4>>2]|0;n=m;q=c[n+4>>2]|0;r=h;c[r>>2]=c[n>>2];c[r+4>>2]=q;q=m;c[q>>2]=o;c[q+4>>2]=p;if(!(ea(g[j>>2])<ea(g[a+20>>2]))){l=1;i=d;return l|0}j=f;p=c[j>>2]|0;q=c[j+4>>2]|0;j=h;o=c[j>>2]|0;m=c[j+4>>2]|0;j=f;c[j>>2]=o;c[j+4>>2]=m;j=h;c[j>>2]=p;c[j+4>>2]=q;s=(c[k>>2]=m,ea(g[k>>2]));if(!(s<ea(g[a+12>>2]))){l=1;i=d;return l|0}q=e;j=c[q>>2]|0;p=c[q+4>>2]|0;q=e;c[q>>2]=o;c[q+4>>2]=m;q=f;c[q>>2]=j;c[q+4>>2]=p;if(!(s<ea(g[a+4>>2]))){l=1;i=d;return l|0}p=a;q=c[p>>2]|0;j=c[p+4>>2]|0;p=a;c[p>>2]=o;c[p+4>>2]=m;m=e;c[m>>2]=q;c[m+4>>2]=j;l=1;i=d;return l|0}case 4:{a5d(a,a+8|0,a+16|0,b+-8|0)|0;l=1;i=d;return l|0}case 3:{j=a+8|0;m=b+-8|0;q=a+12|0;s=ea(g[q>>2]);e=a+4|0;p=s<ea(g[e>>2]);o=b+-4|0;f=ea(g[o>>2])<s;if(!p){if(!f){l=1;i=d;return l|0}p=j;h=c[p>>2]|0;r=c[p+4>>2]|0;p=m;n=c[p+4>>2]|0;t=j;c[t>>2]=c[p>>2];c[t+4>>2]=n;n=m;c[n>>2]=h;c[n+4>>2]=r;s=ea(g[q>>2]);if(!(s<ea(g[e>>2]))){l=1;i=d;return l|0}e=a;q=c[e>>2]|0;r=c[e+4>>2]|0;e=j;n=c[e+4>>2]|0;h=a;c[h>>2]=c[e>>2];c[h+4>>2]=n;n=j;c[n>>2]=q;c[n+4>>2]=r;l=1;i=d;return l|0}r=a;n=c[r>>2]|0;q=c[r+4>>2]|0;if(f){f=m;r=c[f+4>>2]|0;h=a;c[h>>2]=c[f>>2];c[h+4>>2]=r;r=m;c[r>>2]=n;c[r+4>>2]=q;l=1;i=d;return l|0}r=j;h=c[r+4>>2]|0;f=a;c[f>>2]=c[r>>2];c[f+4>>2]=h;h=j;c[h>>2]=n;c[h+4>>2]=q;if(!(ea(g[o>>2])<(c[k>>2]=q,ea(g[k>>2])))){l=1;i=d;return l|0}o=m;h=c[o+4>>2]|0;f=j;c[f>>2]=c[o>>2];c[f+4>>2]=h;h=m;c[h>>2]=n;c[h+4>>2]=q;l=1;i=d;return l|0}case 2:{if(!(ea(g[b+-4>>2])<ea(g[a+4>>2]))){l=1;i=d;return l|0}q=b+-8|0;h=a;n=c[h>>2]|0;m=c[h+4>>2]|0;h=q;f=c[h+4>>2]|0;o=a;c[o>>2]=c[h>>2];c[o+4>>2]=f;f=q;c[f>>2]=n;c[f+4>>2]=m;l=1;i=d;return l|0}case 1:case 0:{l=1;i=d;return l|0}default:{m=a+16|0;f=a+8|0;s=ea(g[a+12>>2]);u=ea(g[a+4>>2]);v=ea(g[a+20>>2]);n=v<s;do if(s<u){q=a;o=c[q>>2]|0;h=c[q+4>>2]|0;if(n){q=m;j=c[q+4>>2]|0;r=a;c[r>>2]=c[q>>2];c[r+4>>2]=j;j=m;c[j>>2]=o;c[j+4>>2]=h;break}j=f;r=c[j+4>>2]|0;q=a;c[q>>2]=c[j>>2];c[q+4>>2]=r;r=f;c[r>>2]=o;c[r+4>>2]=h;if(v<(c[k>>2]=h,ea(g[k>>2]))){r=m;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;q=m;c[q>>2]=o;c[q+4>>2]=h}}else if(n?(h=f,q=c[h>>2]|0,o=c[h+4>>2]|0,h=m,j=c[h>>2]|0,r=c[h+4>>2]|0,h=f,c[h>>2]=j,c[h+4>>2]=r,h=m,c[h>>2]=q,c[h+4>>2]=o,(c[k>>2]=r,ea(g[k>>2]))<u):0){o=a;h=c[o>>2]|0;q=c[o+4>>2]|0;o=a;c[o>>2]=j;c[o+4>>2]=r;r=f;c[r>>2]=h;c[r+4>>2]=q}while(0);f=a+24|0;if((f|0)==(b|0)){l=1;i=d;return l|0}else{w=0;x=f;y=m}while(1){u=ea(g[x+4>>2]);if(u<ea(g[y+4>>2])){m=x;f=c[m>>2]|0;n=c[m+4>>2]|0;u=(c[k>>2]=n,ea(g[k>>2]));m=x;q=y;while(1){r=q;h=c[r+4>>2]|0;o=m;c[o>>2]=c[r>>2];c[o+4>>2]=h;if((q|0)==(a|0)){z=q;break}if(u<ea(g[q+-4>>2])){h=q;q=q+-8|0;m=h}else{z=q;break}}q=z;c[q>>2]=f;c[q+4>>2]=n;q=w+1|0;if((q|0)==8){A=x;break}else B=q}else B=w;q=x+8|0;if((q|0)==(b|0)){l=1;C=34;break}else{m=x;w=B;x=q;y=m}}if((C|0)==34){i=d;return l|0}l=(A+8|0)==(b|0);i=d;return l|0}}return 0}function c5d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d+4|0;f=d;c[a>>2]=0;g=a+4|0;c[g>>2]=0;h=a+8|0;c[h>>2]=0;j=b+4|0;k=c[j>>2]|0;l=c[b>>2]|0;m=k-l|0;if((k|0)==(l|0)){i=d;return}if((m|0)<0)vxi(a);c[f>>2]=54;c[e+0>>2]=c[f+0>>2];f=cOb(m,16,e,0,3653512,80)|0;c[g>>2]=f;c[a>>2]=f;c[h>>2]=f+(((m|0)/72|0)*72|0);m=c[b>>2]|0;b=c[j>>2]|0;if((m|0)==(b|0)){i=d;return}else{n=m;o=f}do{if(!o)p=0;else{f=o+0|0;m=n+0|0;j=f+72|0;do{c[f>>2]=c[m>>2];f=f+4|0;m=m+4|0}while((f|0)<(j|0));p=c[g>>2]|0}o=p+72|0;c[g>>2]=o;n=n+72|0}while((n|0)!=(b|0));i=d;return}function d5d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a+4>>2]|0;h=a+8|0;j=c[h>>2]|0;if((j|0)!=(g|0)){k=j;while(1){j=k+-40|0;c[h>>2]=j;l=c[k+-36>>2]|0;if(!l)m=j;else{j=k+-32|0;n=c[j>>2]|0;if((n|0)!=(l|0))c[j>>2]=n+(~(((n+-72-l|0)>>>0)/72|0)*72|0);c[f>>2]=54;c[d+0>>2]=c[f+0>>2];eOb(l,d);m=c[h>>2]|0}if((m|0)==(g|0))break;else k=m}}m=c[a>>2]|0;if(!m){i=b;return}c[e>>2]=54;c[d+0>>2]=c[e+0>>2];eOb(m,d);i=b;return}function e5d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=Im;h=i;i=i+16|0;j=h;k=c[d>>2]|0;l=c[k>>2]|0;m=c[b>>2]|0;n=ea(g[m+(l*40|0)>>2]);o=ea(g[f>>2]);p=ea(n*o);n=ea(g[m+(l*40|0)+4>>2]);q=f+4|0;r=ea(g[q>>2]);s=ea(n*r);n=ea(g[m+(l*40|0)+8>>2]);l=f+8|0;t=ea(g[l>>2]);u=ea(n*t);n=ea(g[e>>2]);v=ea(p+n);w=e+4|0;p=ea(g[w>>2]);x=ea(s+p);y=e+8|0;s=ea(g[y>>2]);z=ea(u+s);A=a+12|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=v;g[a+4>>2]=x;g[a+8>>2]=z;c[A+0>>2]=c[150284];c[A+4>>2]=c[150285];c[A+8>>2]=c[150286];A=d+8|0;if(!(c[A>>2]|0)){i=h;return}B=j+4|0;C=j+8|0;D=k;k=m;z=o;o=r;r=t;t=n;n=p;p=s;m=0;while(1){E=c[D+(m<<2)>>2]|0;s=ea(ea(g[k+(E*40|0)>>2])*z);x=ea(ea(g[k+(E*40|0)+4>>2])*o);v=ea(x+n);x=ea(ea(ea(g[k+(E*40|0)+8>>2])*r)+p);g[j>>2]=ea(s+t);g[B>>2]=v;g[C>>2]=x;Ulc(a,j);E=m+1|0;if(E>>>0>=(c[A>>2]|0)>>>0)break;x=ea(g[f>>2]);v=ea(g[q>>2]);s=ea(g[l>>2]);u=ea(g[e>>2]);F=ea(g[w>>2]);D=c[d>>2]|0;k=c[b>>2]|0;z=x;o=v;r=s;t=u;n=F;p=ea(g[y>>2]);m=E}i=h;return}function f5d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153096];c[b+0>>2]=c[d+0>>2];d=bOb(4,b,1,16,3653512,46)|0;c[d>>2]=722624;wLc(d);c[141988]=220;d=kbc()|0;b=0;while(1){e=d+(b<<2)+320|0;b=b+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}if((b|0)>=16){h=0;break}}if((g|0)==4){c[f>>2]=221;h=0}while(1){f=584840+(h<<2)|0;h=h+1|0;if(!(c[f>>2]|0)){j=f;g=7;break}if((h|0)>=16){k=0;break}}if((g|0)==7){c[j>>2]=222;k=0}while(1){j=584776+(k<<2)|0;k=k+1|0;if(!(c[j>>2]|0)){l=j;break}if((k|0)>=16){g=11;break}}if((g|0)==11){i=a;return}c[l>>2]=223;i=a;return}function g5d(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=vLc()|0;c[d>>2]=c[153096];c[b+0>>2]=c[d+0>>2];eOb(e,b);wLc(0);z8d();i=a;return}function h5d(){var a=0;a=i;y8d();i=a;return}function i5d(){var a=0;a=i;z8d();i=a;return}function j5d(a,b,d,e,f,g,h,j,k,l,m,n,o){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=ea(h);j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a=i;i=i+16|0;p=a+4|0;q=a;c[q>>2]=c[m>>2];c[p+0>>2]=c[q+0>>2];q=u8d(b,d,e,f,g,h,j,k,l,p,n,o)|0;i=a;return q|0}function k5d(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;w8d(a,c,d,e);i=b;return}function l5d(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=i;e=x8d(b,c,d)|0;i=a;return e|0}function m5d(a){a=a|0;a=i;z8d();i=a;return}function n5d(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;var g=0;a=i;g=c6d(b,c,d,e,f)|0;i=a;return g|0}function o5d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=xbc()|0;d=0;do{e=b+(d<<2)+64|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}}while((d|0)<16);if((g|0)==4)c[f>>2]=224;f=xbc()|0;d=0;do{b=f+(d<<2)|0;d=d+1|0;if(!(c[b>>2]|0)){h=b;g=8;break}}while((d|0)<16);if((g|0)==8)c[h>>2]=225;h=xbc()|0;d=0;while(1){f=h+(d<<2)+128|0;d=d+1|0;if(!(c[f>>2]|0)){j=f;break}if((d|0)>=16){g=13;break}}if((g|0)==13){i=a;return}c[j>>2]=226;i=a;return}function p5d(){return}function q5d(){var a=0;a=i;f5d();i=a;return}function r5d(){var a=0;a=i;g5d();i=a;return}function s5d(a){a=a|0;c[a+4>>2]=0;c[a+8>>2]=0;c[a>>2]=a+4;c[a+12>>2]=0;return}function t5d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;e=a+4|0;if((d|0)!=(e|0)){f=d;while(1){F9d(c[f+32>>2]|0)|0;d=c[f+4>>2]|0;if(!d){g=f;while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){j=h;break}else g=h}}else{g=d;while(1){h=c[g>>2]|0;if(!h){j=g;break}else g=h}}if((j|0)==(e|0))break;else f=j}}j=c[a+12>>2]|0;if(j)ko[c[(c[j>>2]|0)+4>>2]&4095](j);F5d(a,c[a+4>>2]|0);i=b;return}function u5d(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+16|0;m=k+4|0;n=k+28|0;o=k;ksd(l,b);hsd(m,l);xri(l);a[n>>0]=0;if(T7d(m,d,e,f,g,h,j,n)|0){p=a[n>>0]|0;q=p<<24>>24!=0;xri(m);i=k;return q|0}if(!(a[b>>0]&1))r=b+1|0;else r=c[b+8>>2]|0;if(y9d(c[180664]|0,r,h,o)|0){p=a[n>>0]|0;q=p<<24>>24!=0;xri(m);i=k;return q|0}h=c[o>>2]|0;c[j>>2]=c[h>>2];j=c[h+20>>2]|0;if(!j)s=h;else{zri(d,j)|0;j=c[(c[o>>2]|0)+24>>2]|0;zri(e,(j|0)==0?3653512:j)|0;j=c[o>>2]|0;c[f>>2]=c[j+12>>2];c[g>>2]=c[j+8>>2];a[n>>0]=1;s=j}F9d(s)|0;p=a[n>>0]|0;q=p<<24>>24!=0;xri(m);i=k;return q|0}function v5d(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=i;i=i+128|0;d=b+12|0;e=b+48|0;f=b+100|0;g=b;h=b+88|0;j=b+112|0;k=b+116|0;l=b+72|0;m=b+56|0;n=b+16|0;o=b+32|0;p=b+76|0;c[e>>2]=c[153096];c[d+0>>2]=c[e+0>>2];e=bOb(12,d,0,16,3653512,63)|0;d=e+4|0;c[d>>2]=0;c[e+8>>2]=0;c[e>>2]=d;c[180662]=e;c[f>>2]=0;e=f+4|0;c[e>>2]=0;c[f+8>>2]=0;S7d(f);d=c[e>>2]|0;q=c[f>>2]|0;if((d|0)==(q|0)){r=d;s=d}else{d=g+1|0;t=m+12|0;u=o+12|0;v=o+1|0;w=o+8|0;x=o+4|0;y=h+1|0;z=h+8|0;A=g+8|0;B=q;q=0;while(1){C=B+(q*12|0)|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[l>>2]=1;D=0;do{if(u5d(C,g,h,j,k,D,l)|0?(c[k>>2]&1|0)!=0:0){E=(a[g>>0]&1)==0?d:c[A>>2]|0;rri(n,E,SEi(E|0)|0);E=c[j>>2]|0;sri(m,n);c[t>>2]=E>>>1&1|E<<1&2;xri(n);sri(p,C);sri(o,p);c[u>>2]=D;xri(p);E=c[180662]|0;F=c[E+4>>2]|0;G=E+4|0;a:do if(F){H=G;I=F;b:while(1){J=I;while(1){if(!(H5d(J+16|0,m)|0)){K=J;break}J=c[J+4>>2]|0;if(!J){L=H;break b}}I=c[K>>2]|0;if(!I){L=K;break}else H=K}if((L|0)!=(G|0)?!(H5d(m,L+16|0)|0|(L|0)==(G|0)):0){H=L+32|0;c:do if((c[L+44>>2]|0)==(c[u>>2]|0)){I=a[H>>0]|0;J=(I&1)==0;if(J)M=(I&255)>>>1;else M=c[L+36>>2]|0;I=a[o>>0]|0;N=(I&1)==0;if(N)O=(I&255)>>>1;else O=c[x>>2]|0;if((M|0)==(O|0)){if(J)P=H+1|0;else P=c[L+40>>2]|0;I=N?v:c[w>>2]|0;if(!J)if(!(FEi(P,I,M)|0))break a;else break;if(!M)break a;else{Q=M;R=P;S=I}while(1){if((a[R>>0]|0)!=(a[S>>0]|0))break c;Q=Q+-1|0;if(!Q)break a;else{R=R+1|0;S=S+1|0}}}}while(0);H=(a[h>>0]&1)==0?y:c[z>>2]|0;I=c[t>>2]|0;if((I|0)==3){if(HEi(H,722856)|0)break}else if(!I){if(HEi(H,726880)|0)break}else if((I|0)==2){if(HEi(H,2390872)|0)break}else if(!((I|0)==1?(HEi(H,2390840)|0)==0:0))break;H=I5d(E,m)|0;yri(H,o)|0;c[H+12>>2]=c[u>>2]}else T=35}else T=35;while(0);if((T|0)==35){T=0;G=I5d(E,m)|0;yri(G,o)|0;c[G+12>>2]=c[u>>2]}xri(o);xri(m)}D=D+1|0}while((D|0)<(c[l>>2]|0));xri(h);xri(g);q=q+1|0;D=c[e>>2]|0;C=c[f>>2]|0;if(q>>>0>=((D-C|0)/12|0)>>>0){r=C;s=D;break}else B=C}}if(!r){i=b;return}else U=s;while(1){if((U|0)==(r|0))break;s=U+-12|0;c[e>>2]=s;xri(s);U=c[e>>2]|0}ACi(c[f>>2]|0);i=b;return}function w5d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;i=i+48|0;g=f+32|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f;m=c[b+4>>2]|0;n=b+4|0;if(m){o=n;p=m;a:while(1){m=p;while(1){if(!(H5d(m+16|0,d)|0)){q=m;break}m=c[m+4>>2]|0;if(!m){r=o;break a}}p=c[q>>2]|0;if(!p){r=q;break}else o=q}if((r|0)!=(n|0)?!(H5d(d,r+16|0)|0):0){s=r;t=s+32|0;u=c[t>>2]|0;i=f;return u|0}}r=c[e>>2]|0;n=e+4|0;b:do if((r|0)!=(c[n>>2]|0)){e=r;c:while(1){q=c[e>>2]|0;do if(q){c[k>>2]=q;o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(g,o,k);p=c[g>>2]|0;m=c[o+28>>2]|0;if((p|0)==-1){v=m+(c[o+32>>2]<<3)|0;break}else{v=m+(p<<3)|0;break}}else v=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((v|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(c[v+4>>2]|0)!=0:0)w=o;else x=19}else x=19;if((x|0)==19){x=0;if(!(hQb(c[e>>2]|0)|0))break;w=c[137784]|0}c[j>>2]=c[e>>2];if(w){do if((c[w+36>>2]|0)!=(c[w+4>>2]|0)){fRb(g,w,j);o=c[g>>2]|0;p=c[w+28>>2]|0;if((o|0)==-1){y=p+(c[w+32>>2]<<3)|0;break}else{y=p+(o<<3)|0;break}}else y=(c[w+28>>2]|0)+(c[w+32>>2]<<3)|0;while(0);o=c[137784]|0;if((y|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[y+4>>2]|0,(o|0)!=0):0)z=o;else x=29}else x=29;if((x|0)==29){x=0;z=hQb(c[e>>2]|0)|0}o=c[z+216>>2]|0;p=c[o+4>>2]|0;m=o+4|0;if(p){o=m;A=p;d:while(1){p=A;while(1){if(!(H5d(p+16|0,d)|0)){B=p;break}p=c[p+4>>2]|0;if(!p){C=o;break d}}A=c[B>>2]|0;if(!A){C=B;break}else o=B}if((C|0)!=(m|0)?!(H5d(d,C+16|0)|0):0)D=C;else x=37}else x=37;if((x|0)==37){x=0;D=m}c[h>>2]=c[e>>2];o=c[137784]|0;if(o){do if((c[o+36>>2]|0)!=(c[o+4>>2]|0)){fRb(g,o,h);A=c[g>>2]|0;p=c[o+28>>2]|0;if((A|0)==-1){E=p+(c[o+32>>2]<<3)|0;break}else{E=p+(A<<3)|0;break}}else E=(c[o+28>>2]|0)+(c[o+32>>2]<<3)|0;while(0);o=c[137784]|0;if((E|0)!=((c[o+28>>2]|0)+(c[o+32>>2]<<3)|0)?(o=c[E+4>>2]|0,(o|0)!=0):0)F=o;else x=46}else x=46;if((x|0)==46){x=0;F=hQb(c[e>>2]|0)|0}if((D|0)!=((c[F+216>>2]|0)+4|0)){s=D;break c}}while(0);e=e+4|0;if((e|0)==(c[n>>2]|0))break b}t=s+32|0;u=c[t>>2]|0;i=f;return u|0}while(0);u=c[180662]|0;if(!u){v5d();G=c[180662]|0}else G=u;u=c[G+4>>2]|0;t=G+4|0;if(u){G=t;s=u;e:while(1){u=s;while(1){if(!(H5d(u+16|0,d)|0)){H=u;break}u=c[u+4>>2]|0;if(!u){I=G;break e}}s=c[H>>2]|0;if(!s){I=H;break}else G=H}if((I|0)!=(t|0)?!(H5d(d,I+16|0)|0):0){sri(l,I+32|0);t=c[I+44>>2]|0;c[l+12>>2]=t;I=a[l>>0]|0;if(!(I&1)){J=l;K=I;L=l;M=t;x=61}else{N=l;O=c[l+4>>2]|0;P=l;Q=t}}else x=58}else x=58;if((x|0)==58){c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;J=l;K=0;L=l;M=0;x=61}if((x|0)==61){N=J;O=(K&255)>>>1;P=L;Q=M}if(!O){R=0;xri(N);i=f;return R|0}O=c[180664]|0;if(!(a[P>>0]&1))S=l+1|0;else S=c[l+8>>2]|0;y9d(O,S,Q,J5d(b,d)|0)|0;R=c[(J5d(b,d)|0)>>2]|0;xri(N);i=f;return R|0}function x5d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=w5d(a,b,d)|0;if((h|0)!=0?(x9d(h,e)|0)!=0:0){j=h;i=f;return j|0}if(!(c[b+12>>2]|0)){j=0;i=f;return j|0}sri(g,b);c[g+12>>2]=0;b=w5d(a,g,d)|0;if((b|0)!=0?(x9d(b,e)|0)!=0:0){xri(g);j=b;i=f;return j|0}xri(g);j=0;i=f;return j|0}function y5d(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;h=i;i=i+160|0;j=h+124|0;k=h+56|0;l=h;m=h+100|0;n=h+112|0;o=h+136|0;p=h+40|0;q=h+88|0;r=h+72|0;s=h+24|0;t=h+12|0;u=c[d>>2]|0;v=d+4|0;a:do if((u|0)==(c[v>>2]|0))w=0;else{d=k+12|0;x=j+1|0;y=r+12|0;z=p+1|0;A=q+1|0;B=q+8|0;C=p+8|0;D=q+4|0;E=p+4|0;F=j+8|0;G=j+4|0;H=m+1|0;I=n+1|0;J=f|1;K=n+8|0;L=m+8|0;M=n+4|0;N=m+4|0;O=0;P=u;while(1){Q=a[P>>0]|0;if(!(Q&1)){R=P+1|0;S=(Q&255)>>>1}else{R=c[P+8>>2]|0;S=c[P+4>>2]|0}rri(j,R,S);sri(k,j);c[d>>2]=f;Q=x5d(b,k,e,g)|0;if(!Q){T=a[j>>0]|0;if(!(T&1)){U=(T&255)>>>1;V=x}else{U=c[G>>2]|0;V=c[F>>2]|0}b:do if((U>>>0>=5?(W=V+U|0,X=V,(U|0)>=5):0)?(Y=U+-4|0,Z=V+Y|0,(Y|0)!=0):0){Y=V;c:while(1){if((a[Y>>0]|0)==32){_=Y;$=722664;do{$=$+1|0;if(($|0)==722669){aa=Y;break c}_=_+1|0}while((a[_>>0]|0)==(a[$>>0]|0))}Y=Y+1|0;if((Y|0)==(Z|0)){ba=T;ca=f;break b}}if((aa|0)!=(W|0)?(Z=aa-X|0,(Z|0)!=-1):0){vri(m,j,0,Z,j);vri(n,j,Z+5|0,-1,j);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Z=a[m>>0]|0;Y=(Z&1)==0;if(Y)da=(Z&255)>>>1;else da=c[N>>2]|0;Z=a[n>>0]|0;if(!(Z&1))ea=(Z&255)>>>1;else ea=c[M>>2]|0;Pri(l,Y?H:c[L>>2]|0,da,ea+da|0);Gri(l,(a[n>>0]&1)==0?I:c[K>>2]|0,ea)|0;yri(j,l)|0;xri(l);xri(n);xri(m);ba=a[j>>0]|0;ca=J}else{ba=T;ca=f}}else{ba=T;ca=f}while(0);if(!(ba&1)){fa=(ba&255)>>>1;ga=x}else{fa=c[G>>2]|0;ga=c[F>>2]|0}d:do if((fa>>>0>=7?(T=ga+fa|0,Y=ga,(fa|0)>=7):0)?(Z=fa+-6|0,$=ga+Z|0,(Z|0)!=0):0){Z=ga;e:while(1){if((a[Z>>0]|0)==32){_=Z;ha=722672;do{ha=ha+1|0;if((ha|0)==722679){ia=Z;break e}_=_+1|0}while((a[_>>0]|0)==(a[ha>>0]|0))}Z=Z+1|0;if((Z|0)==($|0)){ja=ca;break d}}if((ia|0)!=(T|0)?($=ia-Y|0,($|0)!=-1):0){vri(p,j,0,$,j);vri(q,j,$+7|0,-1,j);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;$=a[p>>0]|0;Z=($&1)==0;if(Z)ka=($&255)>>>1;else ka=c[E>>2]|0;$=a[q>>0]|0;if(!($&1))la=($&255)>>>1;else la=c[D>>2]|0;Pri(o,Z?z:c[C>>2]|0,ka,la+ka|0);Gri(o,(a[q>>0]&1)==0?A:c[B>>2]|0,la)|0;yri(j,o)|0;xri(o);xri(q);xri(p);ja=ca|2}else ja=ca}else ja=ca;while(0);sri(r,j);c[y>>2]=ja;yri(k,r)|0;c[d>>2]=c[y>>2];xri(r);Z=x5d(b,k,e,g)|0;$=(Z|0)==0;ma=$&1^1;na=$?O:Z}else{ma=1;na=Q}xri(k);xri(j);P=P+12|0;if((ma|0)==1){oa=na;break}if((P|0)==(c[v>>2]|0)){w=na;break a}else O=na}i=h;return oa|0}while(0);na=R7d()|0;v=c[na>>2]|0;ma=na+4|0;if((v|0)==(c[ma>>2]|0)){oa=0;i=h;return oa|0}na=s+12|0;j=w;w=v;while(1){v=a[w>>0]|0;if(!(v&1)){pa=w+1|0;qa=(v&255)>>>1}else{pa=c[w+8>>2]|0;qa=c[w+4>>2]|0}rri(t,pa,qa);sri(s,t);c[na>>2]=f;xri(t);v=x5d(b,s,e,g)|0;k=(v|0)==0;j=k?j:v;xri(s);w=w+12|0;if(!k){oa=j;ra=55;break}if((w|0)==(c[ma>>2]|0)){oa=0;ra=55;break}}if((ra|0)==55){i=h;return oa|0}return 0}function z5d(a,b){a=a|0;b=b|0;return b>>>0>31|0}function A5d(e,f,h,j,k,l,m,n,o){e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=0,A=Im,B=Im,C=Im;p=i;i=i+32|0;q=p+16|0;r=p;if(!n)s=c[e+32>>2]|0;else s=n;n=y5d(c[e+216>>2]|0,e+132|0,e+144|0,o,m)|0;if(!n){rri(q,724424,9);t=nUc(mUc()|0,128,q)|0;xri(q);if(!t){u=0;i=p;return u|0}q=y5d(c[t+216>>2]|0,t+132|0,t+144|0,o,m)|0;if(!q){u=0;i=p;return u|0}else v=q}else v=n;n=c[v+12>>2]|0;c[r>>2]=(n&2|0)!=0|(o&1|0)==0?65536:81920;c[r+4>>2]=(n&1|0)!=0|(o&2|0)==0?0:16384;c[r+12>>2]=65536;c[r+8>>2]=0;u9d(v,r,0);L9d(v,0,~~ea(ea(s|0)*ea(64.0)),72,72)|0;s=x9d(v,m)|0;if(!s){u=0;i=p;return u|0}m=c[e+212>>2]|0;if((m|0)==1)w=0;else if((m|0)==3|(m|0)==0)w=2;else if((m|0)==2)w=131072;else{Krd(722680,0,3653512,355,1,0,0,0);w=2}if(v9d(v,s,w)|0){u=0;i=p;return u|0}s=v+84|0;v=c[s>>2]|0;do if((c[v+72>>2]|0)!=1651078259)if(!(w9d(v,w>>>16)|0)){x=c[s>>2]|0;break}else{u=0;i=p;return u|0}else x=v;while(0);v=x+76|0;if((a[x+94>>0]|0)!=2){if(!(a[722712]|0)){D8d(722720);a[722712]=1}F8d(c[180664]|0,v,722720,4)|0;x=b[361368]|0;if(x<<16>>16!=256?(y=ea(ea(ea(1.0)/ea((x<<16>>16)+-1|0))*ea(255.0)),(da(c[180680]|0,c[180682]|0)|0)>0):0){x=0;do{w=(c[180683]|0)+x|0;a[w>>0]=~~ea(y*ea(d[w>>0]|0));x=x+1|0}while((x|0)<(da(c[180680]|0,c[180682]|0)|0));z=722720}else z=722720}else z=v;v=z+4|0;c[f>>2]=c[v>>2];c[h>>2]=c[z>>2];c[j>>2]=c[z+8>>2];j=c[s>>2]|0;y=ea(c[j+100>>2]|0);A=ea(c[j+104>>2]|0);B=ea(A-ea(g[e+208>>2]));A=ea((c[f>>2]|0)>>>0);C=ea(-ea((c[h>>2]|0)>>>0));g[k>>2]=y;g[k+4>>2]=B;g[k+8>>2]=A;g[k+12>>2]=C;g[l>>2]=ea(+R(+(+(c[(c[s>>2]|0)+40>>2]|0)*.015625+.5)));if(!(da(c[z>>2]|0,c[v>>2]|0)|0)){u=0;i=p;return u|0}u=c[z+12>>2]|0;i=p;return u|0}function B5d(d,f,h,j,k,l){d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=Im,z=Im;m=i;i=i+32|0;n=m+16|0;o=m;p=c[f>>2]|0;q=f+4|0;if((p|0)==(c[q>>2]|0)){r=0;i=m;return r|0}f=n+12|0;s=p;while(1){p=a[s>>0]|0;if(!(p&1)){t=s+1|0;u=(p&255)>>>1}else{t=c[s+8>>2]|0;u=c[s+4>>2]|0}rri(o,t,u);sri(n,o);c[f>>2]=0;xri(o);p=w5d(d,n,j)|0;if(p){v=p;break}xri(n);s=s+12|0;if((s|0)==(c[q>>2]|0)){r=0;w=9;break}}if((w|0)==9){i=m;return r|0}M9d(v,h,0)|0;x=ea(b[v+70>>1]|0);y=ea(e[(c[v+88>>2]|0)+14>>1]|0);z=ea(x*y);x=ea(e[v+68>>1]|0);g[k>>2]=ea(z/x);g[l>>2]=ea(ea(ea(b[v+74>>1]|0)*y)/x);xri(n);r=1;i=m;return r|0}function C5d(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+112|0;e=d+56|0;f=d+52|0;h=d+92|0;j=d+84|0;k=d+80|0;l=d+88|0;m=d+96|0;n=d+100|0;o=d+16|0;p=d+12|0;q=d+64|0;r=d+28|0;s=d;t=d+40|0;u=b+120|0;v=c[u>>2]|0;w=b+124|0;x=c[w>>2]|0;do if((v|0)!=(x|0)?(y=b+216|0,(c[(c[y>>2]|0)+8>>2]|0)==0):0){c[m>>2]=0;if(A9d(c[180664]|0,v,x-v|0,0,m)|0){Krd(722744,0,3653512,480,1,0,0,0);break}z=(c[m>>2]|0)+20|0;if(!(c[z>>2]|0))c[z>>2]=722776;z=b+132|0;A=c[z>>2]|0;if(!(a[A>>0]&1))B=A+1|0;else B=c[A+8>>2]|0;C=c[(c[m>>2]|0)+20>>2]|0;if(HEi(B,C)|0){c[n>>2]=A;A=SEi(C|0)|0;if(A>>>0>2147483631)ori(o);if(A>>>0<11){a[o>>0]=A<<1;D=o+1|0}else{E=A+16&-16;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];F=cOb(E,16,e,0,3653512,80)|0;c[o+8>>2]=F;c[o>>2]=E|1;c[o+4>>2]=A;D=F}YEi(D|0,C|0,A|0)|0;a[D+A>>0]=0;c[e+0>>2]=c[n+0>>2];K5d(p,z,e,o);if(a[o>>0]&1){z=c[o+8>>2]|0;c[l>>2]=58;c[e+0>>2]=c[l+0>>2];eOb(z,e)}}z=c[(c[m>>2]|0)+20>>2]|0;rri(r,z,SEi(z|0)|0);z=c[(c[m>>2]|0)+12>>2]|0;sri(q,r);A=q+12|0;c[A>>2]=z>>>1&1|z<<1&2;xri(r);z=c[m>>2]|0;c[(J5d(c[y>>2]|0,q)|0)>>2]=z;if((c[A>>2]|0)!=0?(c[A>>2]=0,A=c[u>>2]|0,(A9d(c[180664]|0,A,(c[w>>2]|0)-A|0,0,m)|0)==0):0){A=c[m>>2]|0;c[(J5d(c[y>>2]|0,q)|0)>>2]=A}xri(q)}while(0);q=b+208|0;if(!(ea(g[q>>2])==ea(0.0))){i=d;return}m=b+216|0;w=c[m>>2]|0;L5d(s,b+132|0);u=b+32|0;r=b+144|0;l=b+28|0;b=B5d(w,s,c[u>>2]|0,r,q,l)|0;w=c[s>>2]|0;if(w){o=s+4|0;p=c[o>>2]|0;if((p|0)==(w|0))G=w;else{n=p;while(1){p=n+-12|0;c[o>>2]=p;if(!(a[p>>0]&1))H=p;else{p=c[n+-4>>2]|0;c[j>>2]=58;c[e+0>>2]=c[j+0>>2];eOb(p,e);H=c[o>>2]|0}if((H|0)==(w|0))break;else n=H}G=c[s>>2]|0}c[k>>2]=27;c[e+0>>2]=c[k+0>>2];eOb(G,e)}if(b){i=d;return}b=c[m>>2]|0;L5d(t,R7d()|0);B5d(b,t,c[u>>2]|0,r,q,l)|0;l=c[t>>2]|0;if(!l){i=d;return}q=t+4|0;r=c[q>>2]|0;if((r|0)==(l|0))I=l;else{u=r;while(1){r=u+-12|0;c[q>>2]=r;if(!(a[r>>0]&1))J=r;else{r=c[u+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(r,e);J=c[q>>2]|0}if((J|0)==(l|0))break;else u=J}I=c[t>>2]|0}c[h>>2]=27;c[e+0>>2]=c[h+0>>2];eOb(I,e);i=d;return}function D5d(){var b=0,d=0;b=i;i=i+16|0;d=b;P7d();c[d+0>>2]=c[180700];c[d+4>>2]=c[180701];c[d+8>>2]=c[180702];c[d+12>>2]=c[180703];if(!(N7d(722656,d)|0)){a[722848]=1;i=b;return}Krd(722816,0,3653512,517,1,0,0,0);a[722848]=1;i=b;return}function E5d(){var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if(a[722712]|0){G8d(c[180664]|0,722720)|0;a[722712]=0}if(a[722848]|0){O7d(c[180664]|0)|0;a[722848]=0}f=c[180662]|0;g=c[153096]|0;if(f)G5d(f,c[f+4>>2]|0);c[e>>2]=g;c[d+0>>2]=c[e+0>>2];eOb(f,d);c[180662]=0;Q7d();i=b;return}function F5d(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}F5d(a,c[b>>2]|0);F5d(a,c[b+4>>2]|0);xri(b+16|0);ACi(b);i=d;return}function G5d(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}G5d(a,c[b>>2]|0);G5d(a,c[b+4>>2]|0);xri(b+32|0);xri(b+16|0);ACi(b);i=d;return}function H5d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=a[b>>0]|0;g=(f&1)==0;if(g)h=(f&255)>>>1;else h=c[b+4>>2]|0;j=a[d>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[d+4>>2]|0;if(g)m=b+1|0;else m=c[b+8>>2]|0;if(k)n=d+1|0;else n=c[d+8>>2]|0;o=FEi(m,n,l>>>0<h>>>0?l:h)|0;if(!o){if(h>>>0<l>>>0){p=1;i=e;return p|0}}else if((o|0)<0){p=1;i=e;return p|0}if(k)q=(j&255)>>>1;else q=c[d+4>>2]|0;if(g)r=(f&255)>>>1;else r=c[b+4>>2]|0;if(k)s=d+1|0;else s=c[d+8>>2]|0;if(g)t=b+1|0;else t=c[b+8>>2]|0;g=FEi(s,t,r>>>0<q>>>0?r:q)|0;if(!g){if(q>>>0<r>>>0){p=0;i=e;return p|0}}else if((g|0)<0){p=0;i=e;return p|0}p=(c[b+12>>2]|0)>>>0<(c[d+12>>2]|0)>>>0;i=e;return p|0}function I5d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=g;while(1){j=h+16|0;if(H5d(b,j)|0){k=c[h>>2]|0;if(!k){l=h;m=h;n=4;break}else{h=k;continue}}if(!(H5d(j,b)|0)){o=h;n=8;break}j=h+4|0;k=c[j>>2]|0;if(!k){p=j;q=h;n=7;break}else h=k}if((n|0)==4){c[e>>2]=m;r=l;s=m;break}else if((n|0)==7){c[e>>2]=q;r=p;s=q;break}else if((n|0)==8){c[e>>2]=o;r=e;s=o;break}}else{h=a+4|0;c[e>>2]=h;r=h;s=h}while(0);e=c[r>>2]|0;if(e){t=e;u=t+32|0;i=d;return u|0}e=xCi(48)|0;sri(e+16|0,b);c[e+28>>2]=c[b+12>>2];b=e+32|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=s;c[r>>2]=e;s=c[c[a>>2]>>2]|0;if(!s)v=e;else{c[a>>2]=s;v=c[r>>2]|0}GN(c[f>>2]|0,v);v=a+8|0;c[v>>2]=(c[v>>2]|0)+1;t=e;u=t+32|0;i=d;return u|0}function J5d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=g;while(1){j=h+16|0;if(H5d(b,j)|0){k=c[h>>2]|0;if(!k){l=h;m=h;n=4;break}else{h=k;continue}}if(!(H5d(j,b)|0)){o=h;n=8;break}j=h+4|0;k=c[j>>2]|0;if(!k){p=j;q=h;n=7;break}else h=k}if((n|0)==4){c[e>>2]=m;r=l;s=m;break}else if((n|0)==7){c[e>>2]=q;r=p;s=q;break}else if((n|0)==8){c[e>>2]=o;r=e;s=o;break}}else{h=a+4|0;c[e>>2]=h;r=h;s=h}while(0);e=c[r>>2]|0;if(e){t=e;u=t+32|0;i=d;return u|0}e=xCi(36)|0;sri(e+16|0,b);c[e+28>>2]=c[b+12>>2];c[e+32>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=s;c[r>>2]=e;s=c[c[a>>2]>>2]|0;if(!s)v=e;else{c[a>>2]=s;v=c[r>>2]|0}GN(c[f>>2]|0,v);v=a+8|0;c[v>>2]=(c[v>>2]|0)+1;t=e;u=t+32|0;i=d;return u|0}function K5d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g;n=c[d>>2]|0;o=n;p=((c[e>>2]|0)-o|0)/12|0;e=n+(p*12|0)|0;q=d+4|0;r=c[q>>2]|0;s=c[d+8>>2]|0;if(r>>>0>=s>>>0){t=((r-o|0)/12|0)+1|0;if((t|0)<0)vxi(d);o=n;u=(s-o|0)/12|0;if(u>>>0<1073741823){s=u<<1;v=s>>>0<t>>>0?t:s}else v=2147483647;s=e-o|0;o=(s|0)/12|0;t=m+12|0;c[t>>2]=0;c[m+16>>2]=d+8;if(!v)w=0;else{c[j>>2]=27;c[h+0>>2]=c[j+0>>2];w=cOb(v*12|0,16,h,0,3653512,80)|0}c[m>>2]=w;u=w+(o*12|0)|0;x=m+8|0;c[x>>2]=u;y=m+4|0;c[y>>2]=u;c[t>>2]=w+(v*12|0);do if((o|0)==(v|0)){z=(s|0)/12|0;if((s|0)>0){A=w+((o+((z+1|0)/-2|0)|0)*12|0)|0;c[x>>2]=A;c[y>>2]=A;B=A;break}A=z<<1;z=(A|0)==0?1:A;c[j>>2]=27;c[h+0>>2]=c[j+0>>2];A=cOb(z*12|0,16,h,0,3653512,80)|0;C=A+((z>>>2)*12|0)|0;c[m>>2]=A;c[y>>2]=C;c[x>>2]=C;c[t>>2]=A+(z*12|0);if(!w)B=C;else{c[j>>2]=27;c[h+0>>2]=c[j+0>>2];eOb(w,h);B=C}}else B=u;while(0);if(!B)D=0;else{u=a[f>>0]|0;if(!(u&1)){E=(u&255)>>>1;F=f+1|0}else{E=c[f+4>>2]|0;F=c[f+8>>2]|0}if(E>>>0>2147483631)ori(B);if(E>>>0<11){a[B>>0]=E<<1;G=B+1|0}else{u=E+16&-16;c[k>>2]=58;c[h+0>>2]=c[k+0>>2];w=cOb(u,16,h,0,3653512,80)|0;c[B+8>>2]=w;c[B>>2]=u|1;c[B+4>>2]=E;G=w}YEi(G|0,F|0,E|0)|0;a[G+E>>0]=0;D=c[x>>2]|0}c[x>>2]=D+12;D=O5d(d,m,e)|0;E=c[y>>2]|0;y=c[x>>2]|0;if((y|0)!=(E|0)){G=y;do{y=G;G=G+-12|0;c[x>>2]=G;if(a[G>>0]&1){F=c[y+-4>>2]|0;c[l>>2]=58;c[h+0>>2]=c[l+0>>2];eOb(F,h)}}while((G|0)!=(E|0))}E=c[m>>2]|0;if(!E){H=D;c[b>>2]=H;i=g;return}c[k>>2]=27;c[h+0>>2]=c[k+0>>2];eOb(E,h);H=D;c[b>>2]=H;i=g;return}if((e|0)==(r|0)){if(!e)I=0;else{D=a[f>>0]|0;if(!(D&1)){J=(D&255)>>>1;K=f+1|0}else{J=c[f+4>>2]|0;K=c[f+8>>2]|0}if(J>>>0>2147483631)ori(e);if(J>>>0<11){a[e>>0]=J<<1;L=e+1|0}else{D=J+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];j=cOb(D,16,h,0,3653512,80)|0;c[n+(p*12|0)+8>>2]=j;c[e>>2]=D|1;c[n+(p*12|0)+4>>2]=J;L=j}YEi(L|0,K|0,J|0)|0;a[L+J>>0]=0;I=c[q>>2]|0}c[q>>2]=I+12;H=e;c[b>>2]=H;i=g;return}N5d(d,e,r,n+((p+1|0)*12|0)|0);if(e>>>0>f>>>0)M=f;else M=(c[q>>2]|0)>>>0>f>>>0?f+12|0:f;if((e|0)==(M|0)){H=e;c[b>>2]=H;i=g;return}f=a[M>>0]|0;if(!(f&1)){N=(f&255)>>>1;O=M+1|0}else{N=c[M+4>>2]|0;O=c[M+8>>2]|0}M=a[e>>0]|0;if(!(M&1)){P=10;Q=M}else{M=c[e>>2]|0;P=(M&-2)+-1|0;Q=M&255}M=(Q&1)==0;if(N>>>0>P>>>0){if(M)R=(Q&255)>>>1;else R=c[n+(p*12|0)+4>>2]|0;eXb(e,P,N-P|0,R,0,R,N,O);H=e;c[b>>2]=H;i=g;return}if(M)S=e+1|0;else S=c[n+(p*12|0)+8>>2]|0;aFi(S|0,O|0,N|0)|0;a[S+N>>0]=0;if(!(a[e>>0]&1)){a[e>>0]=N<<1;H=e;c[b>>2]=H;i=g;return}else{c[n+(p*12|0)+4>>2]=N;H=e;c[b>>2]=H;i=g;return}}function L5d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e;c[b>>2]=0;h=b+4|0;c[h>>2]=0;j=b+8|0;c[j>>2]=0;k=d+4|0;l=c[k>>2]|0;m=c[d>>2]|0;n=l-m|0;if((l|0)==(m|0)){i=e;return}if((n|0)<0)vxi(b);c[g>>2]=27;c[f+0>>2]=c[g+0>>2];m=cOb(n,16,f,0,3653512,80)|0;c[h>>2]=m;c[b>>2]=m;c[j>>2]=m+(((n|0)/12|0)*12|0);n=c[d>>2]|0;d=c[k>>2]|0;if((n|0)==(d|0)){i=e;return}k=n;n=m;while(1){if(!n)o=0;else{m=a[k>>0]|0;if(!(m&1)){p=(m&255)>>>1;q=k+1|0}else{p=c[k+4>>2]|0;q=c[k+8>>2]|0}if(p>>>0>2147483631){r=11;break}if(p>>>0<11){a[n>>0]=p<<1;s=n+1|0}else{m=p+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];j=cOb(m,16,f,0,3653512,80)|0;c[n+8>>2]=j;c[n>>2]=m|1;c[n+4>>2]=p;s=j}YEi(s|0,q|0,p|0)|0;a[s+p>>0]=0;o=c[h>>2]|0}j=o+12|0;c[h>>2]=j;k=k+12|0;if((k|0)==(d|0)){r=17;break}else n=j}if((r|0)==11)ori(n);else if((r|0)==17){i=e;return}}function M5d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=b+4|0;l=c[b>>2]|0;m=(((c[k>>2]|0)-l|0)/12|0)+1|0;if((m|0)<0)vxi(b);n=l;l=((c[b+8>>2]|0)-n|0)/12|0;if(l>>>0<1073741823){o=l<<1;p=o>>>0<m>>>0?m:o}else p=2147483647;o=((c[k>>2]|0)-n|0)/12|0;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!p)q=0;else{c[g>>2]=27;c[f+0>>2]=c[g+0>>2];q=cOb(p*12|0,16,f,0,3653512,80)|0}c[j>>2]=q;k=q+(o*12|0)|0;m=j+8|0;c[m>>2]=k;l=j+4|0;c[l>>2]=k;c[n>>2]=q+(p*12|0);if(!k)r=0;else{p=a[d>>0]|0;if(!(p&1)){s=(p&255)>>>1;t=d+1|0}else{s=c[d+4>>2]|0;t=c[d+8>>2]|0}if(s>>>0>2147483631)ori(k);if(s>>>0<11){a[k>>0]=s<<1;u=k+1|0}else{d=s+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];p=cOb(d,16,f,0,3653512,80)|0;c[q+(o*12|0)+8>>2]=p;c[k>>2]=d|1;c[q+(o*12|0)+4>>2]=s;u=p}YEi(u|0,t|0,s|0)|0;a[u+s>>0]=0;r=c[m>>2]|0}c[m>>2]=r+12;P5d(b,j);b=c[l>>2]|0;l=c[m>>2]|0;if((l|0)!=(b|0)){r=l;do{l=r;r=r+-12|0;c[m>>2]=r;if(a[r>>0]&1){s=c[l+-4>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(s,f)}}while((r|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function N5d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+16|0;h=g+4|0;j=g;k=b+4|0;b=c[k>>2]|0;l=d+(((b-f|0)/12|0)*12|0)|0;a:do if(l>>>0<e>>>0){m=b;n=l;while(1){if(!m)o=0;else{p=a[n>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=n+1|0}else{q=c[n+4>>2]|0;r=c[n+8>>2]|0}if(q>>>0>2147483631)break;if(q>>>0<11){a[m>>0]=q<<1;s=m+1|0}else{p=q+16&-16;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];t=cOb(p,16,h,0,3653512,80)|0;c[m+8>>2]=t;c[m>>2]=p|1;c[m+4>>2]=q;s=t}YEi(s|0,r|0,q|0)|0;a[s+q>>0]=0;o=c[k>>2]|0}n=n+12|0;t=o+12|0;c[k>>2]=t;if(n>>>0>=e>>>0)break a;else m=t}ori(m)}while(0);if((b|0)==(f|0)){i=g;return}else{u=l;v=b}do{b=v;v=v+-12|0;l=u;u=u+-12|0;do if((b|0)!=(l|0)){f=a[u>>0]|0;if(!(f&1)){w=(f&255)>>>1;x=u+1|0}else{w=c[l+-8>>2]|0;x=c[l+-4>>2]|0}f=a[v>>0]|0;if(!(f&1)){y=10;z=f}else{f=c[v>>2]|0;y=(f&-2)+-1|0;z=f&255}f=(z&1)==0;if(w>>>0>y>>>0){if(f)A=(z&255)>>>1;else A=c[b+-8>>2]|0;eXb(v,y,w-y|0,A,0,A,w,x);break}if(f)B=v+1|0;else B=c[b+-4>>2]|0;aFi(B|0,x|0,w|0)|0;a[B+w>>0]=0;if(!(a[v>>0]&1)){a[v>>0]=w<<1;break}else{c[b+-8>>2]=w;break}}while(0)}while((u|0)!=(d|0));i=g;return}function O5d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+16|0;g=f+4|0;h=f;j=d+4|0;k=c[j>>2]|0;l=c[b>>2]|0;a:do if((l|0)==(e|0))m=k;else{n=e;o=k;while(1){p=o+-12|0;q=n;n=n+-12|0;r=a[n>>0]|0;if(!(r&1)){s=(r&255)>>>1;t=n+1|0}else{s=c[q+-8>>2]|0;t=c[q+-4>>2]|0}if(s>>>0>2147483631)break;if(s>>>0<11){a[p>>0]=s<<1;u=p+1|0}else{q=s+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];r=cOb(q,16,g,0,3653512,80)|0;c[o+-4>>2]=r;c[p>>2]=q|1;c[o+-8>>2]=s;u=r}YEi(u|0,t|0,s|0)|0;a[u+s>>0]=0;r=(c[j>>2]|0)+-12|0;c[j>>2]=r;if((n|0)==(l|0)){m=r;break a}else o=r}ori(p)}while(0);p=b+4|0;l=c[p>>2]|0;s=d+8|0;if((l|0)==(e|0)){v=m;w=c[b>>2]|0;c[b>>2]=v;c[j>>2]=w;x=c[p>>2]|0;y=c[s>>2]|0;c[p>>2]=y;c[s>>2]=x;z=b+8|0;A=d+12|0;B=c[z>>2]|0;C=c[A>>2]|0;c[z>>2]=C;c[A>>2]=B;D=c[j>>2]|0;c[d>>2]=D;i=f;return k|0}m=e;e=c[s>>2]|0;while(1){if(!e)E=0;else{u=a[m>>0]|0;if(!(u&1)){F=(u&255)>>>1;G=m+1|0}else{F=c[m+4>>2]|0;G=c[m+8>>2]|0}if(F>>>0>2147483631){H=19;break}if(F>>>0<11){a[e>>0]=F<<1;I=e+1|0}else{u=F+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];t=cOb(u,16,g,0,3653512,80)|0;c[e+8>>2]=t;c[e>>2]=u|1;c[e+4>>2]=F;I=t}YEi(I|0,G|0,F|0)|0;a[I+F>>0]=0;E=c[s>>2]|0}m=m+12|0;t=E+12|0;c[s>>2]=t;if((m|0)==(l|0))break;else e=t}if((H|0)==19)ori(e);v=c[j>>2]|0;w=c[b>>2]|0;c[b>>2]=v;c[j>>2]=w;x=c[p>>2]|0;y=c[s>>2]|0;c[p>>2]=y;c[s>>2]=x;z=b+8|0;A=d+12|0;B=c[z>>2]|0;C=c[A>>2]|0;c[z>>2]=C;c[A>>2]=B;D=c[j>>2]|0;c[d>>2]=D;i=f;return k|0}function P5d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;j=b+4|0;k=c[j>>2]|0;l=d+4|0;do if((k|0)!=(h|0)){m=k;n=c[l>>2]|0;while(1){o=n+-12|0;p=m;m=m+-12|0;q=a[m>>0]|0;if(!(q&1)){r=(q&255)>>>1;s=m+1|0}else{r=c[p+-8>>2]|0;s=c[p+-4>>2]|0}if(r>>>0>2147483631){t=8;break}if(r>>>0<11){a[o>>0]=r<<1;u=o+1|0}else{p=r+16&-16;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];q=cOb(p,16,f,0,3653512,80)|0;c[n+-4>>2]=q;c[o>>2]=p|1;c[n+-8>>2]=r;u=q}YEi(u|0,s|0,r|0)|0;a[u+r>>0]=0;q=(c[l>>2]|0)+-12|0;c[l>>2]=q;if((m|0)==(h|0)){v=q;t=13;break}else n=q}if((t|0)==8)ori(o);else if((t|0)==13){w=v;x=c[b>>2]|0;break}}else{w=c[l>>2]|0;x=h}while(0);c[b>>2]=w;c[l>>2]=x;x=d+8|0;w=c[j>>2]|0;c[j>>2]=c[x>>2];c[x>>2]=w;w=b+8|0;b=d+12|0;x=c[w>>2]|0;c[w>>2]=c[b>>2];c[b>>2]=x;c[d>>2]=c[l>>2];i=e;return}function Q5d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;h=e+16|0;j=e+8|0;k=e;c[h>>2]=c[b>>2];c[f+0>>2]=c[h+0>>2];mWb(a,f,d);c[a+36>>2]=0;c[a+40>>2]=0;c[a>>2]=722880;c[a+48>>2]=0;c[a+52>>2]=0;c[a+56>>2]=0;d=a+108|0;h=a+168|0;c[a+172>>2]=0;c[a+176>>2]=0;b=a+172|0;l=a+84|0;m=l+84|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));c[h>>2]=b;c[a+184>>2]=256;c[a+188>>2]=256;c[a+196>>2]=1;c[a+64>>2]=1;c[a+68>>2]=0;c[a+32>>2]=0;g[a+208>>2]=ea(0.0);c[a+204>>2]=0;c[a+212>>2]=0;g[a+80>>2]=ea(.100000001);m6d(d,256);c[j>>2]=0;c[j+4>>2]=0;n6d(f,h,j);c[a+180>>2]=c[h>>2];c[k>>2]=c[153096];c[f+0>>2]=c[k+0>>2];k=bOb(16,f,0,16,3653512,57)|0;s5d(k);c[a+216>>2]=k;i=e;return}function R5d(a){a=a|0;g[a+60>>2]=ea(1.0);g[a+28>>2]=ea(.100000001);c[a+72>>2]=0;c[a+76>>2]=0;return}function S5d(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;l=c[b+76>>2]|0;if((l|0)==2){m=d<<24>>24;n=((((d&255)+-65<<24>>24&255)<26?m+32|0:m)<<24>>24)-(c[b+72>>2]|0)|0}else if((l|0)==1){m=d<<24>>24;n=((((d&255)+-97<<24>>24&255)<26?m+224|0:m)<<24>>24)-(c[b+72>>2]|0)|0}else n=d-(c[b+72>>2]|0)|0;d=(c[b+32>>2]|0)==(e|0)?0:e;if((l|0)==-2|(d|f|0)==0){o=f;p=d}else{Krd(724480,0,3653512,98,1,0,0,0);o=0;p=0}if(n>>>0<256&(p|0)==0&(o|0)==0){d=b+108|0;f=(c[d>>2]|0)+(n*56|0)+20|0;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];f=(c[d>>2]|0)+(n*56|0)+4|0;c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];q=a[(c[d>>2]|0)+(n*56|0)+52>>0]|0;a[j>>0]=q;i=k;return}d=c[b+96>>2]|0;f=c[b+100>>2]|0;if((f|0)==(d|0))r=d;else{b=d;l=(f-d|0)/56|0;while(1){d=(l|0)/2|0;e=c[b+(d*56|0)>>2]|0;if((e|0)==(n|0)){m=c[b+(d*56|0)+40>>2]|0;if((m|0)>=(p|0))if((m|0)<=(p|0)?(c[b+(d*56|0)+44>>2]|0)>>>0<o>>>0:0)s=16;else{t=b;u=d}else s=16}else if(e>>>0<n>>>0)s=16;else{t=b;u=d}if((s|0)==16){s=0;t=b+((d+1|0)*56|0)|0;u=l+-1-d|0}if(!u){r=t;break}else{b=t;l=u}}}a:do if((r|0)!=(f|0)){u=c[r>>2]|0;do if((n|0)==(u|0)){l=c[r+40>>2]|0;if((p|0)<(l|0))break a;if((p|0)>(l|0))if((r|0)==(f|0))break a;else break;else if((r|0)==(f|0)?1:o>>>0<(c[r+44>>2]|0)>>>0)break a;else break}else if(n>>>0<u>>>0|(r|0)==(f|0))break a;while(0);u=r+20|0;c[g+0>>2]=c[u+0>>2];c[g+4>>2]=c[u+4>>2];c[g+8>>2]=c[u+8>>2];c[g+12>>2]=c[u+12>>2];u=r+4|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];q=a[r+52>>0]|0;a[j>>0]=q;i=k;return}while(0);c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;q=0;a[j>>0]=q;i=k;return}function T5d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;h=c[a+76>>2]|0;if((h|0)==2){j=b<<24>>24;k=((((b&255)+-65<<24>>24&255)<26?j+32|0:j)<<24>>24)-(c[a+72>>2]|0)|0}else if((h|0)==1){j=b<<24>>24;k=((((b&255)+-97<<24>>24&255)<26?j+224|0:j)<<24>>24)-(c[a+72>>2]|0)|0}else k=b-(c[a+72>>2]|0)|0;b=(c[a+32>>2]|0)==(d|0)?0:d;if((h|0)==-2|(b|e|0)==0){l=e;m=b}else{Krd(724480,0,3653512,140,1,0,0,0);l=0;m=0}if(k>>>0<256&(m|0)==0&(l|0)==0?(b=a+108|0,ea(g[(c[b>>2]|0)+(k*56|0)+36>>2])!=ea(0.0)):0){e=c[(jLc()|0)+128>>2]|0;c[(c[b>>2]|0)+(k*56|0)+48>>2]=e;n=1;i=f;return n|0}e=c[a+96>>2]|0;b=c[a+100>>2]|0;if((b|0)==(e|0))o=e;else{a=e;h=(b-e|0)/56|0;while(1){e=(h|0)/2|0;d=c[a+(e*56|0)>>2]|0;if((d|0)==(k|0)){j=c[a+(e*56|0)+40>>2]|0;if((j|0)>=(m|0))if((j|0)<=(m|0)?(c[a+(e*56|0)+44>>2]|0)>>>0<l>>>0:0)p=17;else{q=a;r=e}else p=17}else if(d>>>0<k>>>0)p=17;else{q=a;r=e}if((p|0)==17){p=0;q=a+((e+1|0)*56|0)|0;r=h+-1-e|0}if(!r){o=q;break}else{a=q;h=r}}}if((o|0)==(b|0)){n=0;i=f;return n|0}r=c[o>>2]|0;do if((k|0)==(r|0)){h=c[o+40>>2]|0;if((m|0)<(h|0)){n=0;i=f;return n|0}if((m|0)>(h|0)){if((o|0)==(b|0))n=0;else break;i=f;return n|0}else{if((o|0)==(b|0)?1:l>>>0<(c[o+44>>2]|0)>>>0)n=0;else break;i=f;return n|0}}else if(k>>>0<r>>>0|(o|0)==(b|0)){n=0;i=f;return n|0}while(0);c[o+48>>2]=c[(jLc()|0)+128>>2];n=1;i=f;return n|0}function U5d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=0,r=0,s=0,t=0;f=i;h=(c[a+32>>2]|0)==(d|0)?0:d;d=a+76|0;j=c[d>>2]|0;if((j|0)==-2|(h|e|0)==0){k=e;l=h;m=j}else{Krd(724480,0,3653512,183,1,0,0,0);k=0;l=0;m=c[d>>2]|0}if((m|0)==2){d=b<<24>>24;n=((((b&255)+-65<<24>>24&255)<26?d+32|0:d)<<24>>24)-(c[a+72>>2]|0)|0}else if((m|0)==1){m=b<<24>>24;n=((((b&255)+-97<<24>>24&255)<26?m+224|0:m)<<24>>24)-(c[a+72>>2]|0)|0}else n=b-(c[a+72>>2]|0)|0;if(n>>>0<256&(l|0)==0&(k|0)==0){o=ea(g[(c[a+108>>2]|0)+(n*56|0)+36>>2]);p=ea(o*ea(g[a+60>>2]));i=f;return ea(p)}b=c[a+96>>2]|0;m=c[a+100>>2]|0;if((m|0)==(b|0))q=b;else{d=b;j=(m-b|0)/56|0;while(1){b=(j|0)/2|0;h=c[d+(b*56|0)>>2]|0;if((h|0)==(n|0)){e=c[d+(b*56|0)+40>>2]|0;if((e|0)>=(l|0))if((e|0)<=(l|0)?(c[d+(b*56|0)+44>>2]|0)>>>0<k>>>0:0)r=16;else{s=d;t=b}else r=16}else if(h>>>0<n>>>0)r=16;else{s=d;t=b}if((r|0)==16){r=0;s=d+((b+1|0)*56|0)|0;t=j+-1-b|0}if(!t){q=s;break}else{d=s;j=t}}}if((q|0)==(m|0)){p=ea(0.0);i=f;return ea(p)}t=c[q>>2]|0;do if((n|0)==(t|0)){j=c[q+40>>2]|0;if((l|0)<(j|0)){p=ea(0.0);i=f;return ea(p)}if((l|0)>(j|0)){if((q|0)==(m|0))p=ea(0.0);else break;i=f;return ea(p)}else{if((q|0)==(m|0)?1:k>>>0<(c[q+44>>2]|0)>>>0)p=ea(0.0);else break;i=f;return ea(p)}}else if(n>>>0<t>>>0|(q|0)==(m|0)){p=ea(0.0);i=f;return ea(p)}while(0);o=ea(g[q+36>>2]);p=ea(o*ea(g[a+60>>2]));i=f;return ea(p)}function V5d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;b=a;z8d();c[b>>2]=0;d=b+4|0;c[d>>2]=0;c[b+8>>2]=0;CQb(102,b,0)|0;e=c[d>>2]|0;f=c[b>>2]|0;if((e|0)==(f|0)){g=e;h=e}else{e=f;f=0;while(1){t8d(c[e+(f<<2)>>2]|0);f=f+1|0;j=c[d>>2]|0;k=c[b>>2]|0;if(f>>>0>=j-k>>2>>>0){g=k;h=j;break}else e=k}}if(!g){i=a;return}if((h|0)!=(g|0))c[d>>2]=h+(~((h+-4-g|0)>>>2)<<2);ACi(g);i=a;return}function W5d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;i=i+32|0;b=a+16|0;d=a+12|0;e=a;c[e>>2]=0;f=e+4|0;c[f>>2]=0;c[e+8>>2]=0;BQb(128,e,0)|0;g=c[e>>2]|0;h=(c[f>>2]|0)-g>>2;a:do if(h){j=g;k=0;while(1){l=c[j+(k<<2)>>2]|0;if(!l)m=0;else{c[d>>2]=l;n=c[137784]|0;if(n){do if((c[n+36>>2]|0)!=(c[n+4>>2]|0)){fRb(b,n,d);o=c[b>>2]|0;p=c[n+28>>2]|0;if((o|0)==-1){q=p+(c[n+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[n+28>>2]|0)+(c[n+32>>2]<<3)|0;while(0);n=c[137784]|0;if((q|0)!=((c[n+28>>2]|0)+(c[n+32>>2]<<3)|0)?(n=c[q+4>>2]|0,(n|0)!=0):0)r=n;else s=12}else s=12;if((s|0)==12){s=0;r=hQb(l)|0}m=r}X5d(m)|0;n=k+1|0;if((n|0)==(h|0))break a;j=c[e>>2]|0;k=n}}while(0);V5d();h=c[e>>2]|0;if(!h){i=a;return}e=c[f>>2]|0;if((e|0)!=(h|0))c[f>>2]=e+(~((e+-4-h|0)>>>2)<<2);ACi(h);i=a;return}function X5d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+80|0;e=d+24|0;f=d+56|0;g=d+64|0;h=d+68|0;j=d+20|0;k=d;l=d+32|0;if((c[b+76>>2]|0)!=-2){m=1;i=d;return m|0}n=c[b+84>>2]|0;o=b+88|0;p=c[o>>2]|0;if((p|0)!=(n|0))c[o>>2]=p+(~(((p+-56-n|0)>>>0)/56|0)*56|0);Z5d(b);n=c[155256]|0;p=n>>>0>4096?4096:n;n=b+184|0;o=b+188|0;if((c[n>>2]|0)>>>0<=p>>>0?(c[o>>2]|0)>>>0<=p>>>0:0){q=b+40|0;r=c[q>>2]|0;if(!r){m=0;i=d;return m|0}c[g>>2]=r;r=c[137784]|0;if(r){do if((c[r+36>>2]|0)!=(c[r+4>>2]|0)){fRb(e,r,g);s=c[e>>2]|0;t=c[r+28>>2]|0;if((s|0)==-1){u=t+(c[r+32>>2]<<3)|0;break}else{u=t+(s<<3)|0;break}}else u=(c[r+28>>2]|0)+(c[r+32>>2]<<3)|0;while(0);r=c[137784]|0;if(!((u|0)!=((c[r+28>>2]|0)+(c[r+32>>2]<<3)|0)?(c[u+4>>2]|0)!=0:0))v=16}else v=16;if((v|0)==16?(hQb(c[q>>2]|0)|0)==0:0){m=0;i=d;return m|0}u=p6d(q)|0;if(!(a[621176]|0))a[u+129>>0]=1;else a[u+127>>0]=1;q=mo[c[(c[u>>2]|0)+104>>2]&4095](u)|0;if((q|0)==(c[n>>2]|0)){q=mo[c[(c[u>>2]|0)+108>>2]&4095](u)|0;r=c[o>>2]|0;if((q|0)==(r|0))if(!(a[u+125>>0]|0)){w=q;v=24}else x=q;else{w=r;v=24}}else{w=c[o>>2]|0;v=24}do if((v|0)==24)if(gn[c[(c[u>>2]|0)+148>>2]&127](u,c[n>>2]|0,w,1,0,1,0)|0){ko[c[(c[u>>2]|0)+152>>2]&4095](u);x=c[o>>2]|0;break}else{m=0;i=d;return m|0}while(0);w=c[n>>2]|0;r=da(x,w)|0;q=r+15|0;if(q>>>0<2e3)if(!r){y=x;z=w;A=0;B=0}else{r=i;i=i+((1*q|0)+15&-16)|0;y=x;z=w;A=0;B=r}else{c[h>>2]=c[153134];c[e+0>>2]=c[h+0>>2];h=cOb(q,16,e,0,3653512,550)|0;y=c[o>>2]|0;z=c[n>>2]|0;A=h;B=h}h=B+15&-16;PEi(h|0,0,da(y,z)|0)|0;z=da(c[o>>2]|0,c[n>>2]|0)|0;if(!(a[621176]|0)){y=ync()|0;B=c[(c[y>>2]|0)+472>>2]|0;c[j>>2]=c[u+44>>2];q=c[n>>2]|0;r=c[o>>2]|0;if((KLc()|0)==1)C=c[u+56>>2]|0;else C=0;c[e+0>>2]=c[j+0>>2];Mm[B&3](y,e,h,z,0,0,0,q,r,1,C);if(a[621176]|0)v=34}else v=34;if((v|0)==34){c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;if(DEc(u,k,0,0)|0){v=c[n>>2]|0;iwc(l,v,c[o>>2]|0,v,1,h);hwc(k,l,0)}if(a[621176]|0)ko[c[(c[u>>2]|0)+152>>2]&4095](u)}if(A){c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];eOb(A,e)}A=b+168|0;o6d(A,c[b+172>>2]|0);c[b+176>>2]=0;u=b+172|0;c[A>>2]=u;c[u>>2]=0;u=c[b+156>>2]|0;l=b+160|0;k=c[l>>2]|0;if((k|0)!=(u|0))c[l>>2]=k+(~((k+-16-u|0)>>>4)<<4);c[f>>2]=0;c[f+4>>2]=0;n6d(e,A,f);c[b+180>>2]=c[A>>2];c[b+200>>2]=0;A=b+196|0;f=(c[b+32>>2]<<3)+-1|0;b=f>>>16|f;f=b>>>8|b;b=f>>>4|f;f=b>>>2|b;b=(f>>>1|f)+1|0;f=c[A>>2]|0;e=f>>>0<b>>>0?b:f;f=c[n>>2]|0;c[A>>2]=f>>>0<e>>>0?f:e;m=1;i=d;return m|0}Krd(723016,0,3653512,520,1,0,0,0);c[n>>2]=p;c[o>>2]=p;m=0;i=d;return m|0}function Y5d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=0,z=0;e=i;i=i+240|0;f=e+232|0;h=e+8|0;j=e;k=e+224|0;l=e+220|0;m=e+208|0;n=b+80|0;if(ea(g[n>>2])<ea(0.0)){$Ic(l,b);o=c[l>>2]|0;do if(!o)p=ea(1.0);else{c[k>>2]=o;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(f,l,k);q=c[f>>2]|0;r=c[l+28>>2]|0;if((q|0)==-1){s=r+(c[l+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((s|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[s+4>>2]|0,(l|0)!=0):0)t=l;else u=11}else u=11;if((u|0)==11){l=hQb(o)|0;if(!l){p=ea(1.0);break}else t=l}v=ea(-ea(g[n>>2]));p=ea(v/ea(mo[c[(c[t>>2]|0)+104>>2]&4095](t)|0))}while(0);g[n>>2]=p;t=b+88|0;o=b+84|0;s=c[o>>2]|0;if((c[t>>2]|0)==(s|0))w=p;else{v=p;k=s;s=0;while(1){p=ea(ea(1.0)/v);x=ea(ea(-1.0)/v);g[k+(s*56|0)+20>>2]=ea(0.0);g[k+(s*56|0)+24>>2]=ea(0.0);g[k+(s*56|0)+28>>2]=p;g[k+(s*56|0)+32>>2]=x;x=ea(g[n>>2]);l=k+(s*56|0)+36|0;g[l>>2]=ea(ea(g[l>>2])/x);s=s+1|0;k=c[o>>2]|0;if(s>>>0>=(((c[t>>2]|0)-k|0)/56|0)>>>0){w=x;break}else v=x}}k=b+28|0;g[k>>2]=ea(ea(g[k>>2])/w)}Z5d(b);if((c[b+76>>2]|0)==-2){k=b+132|0;t=b+136|0;do if((c[k>>2]|0)==(c[t>>2]|0)){Krd(722976,0,3653512,401,1,0,0,0);a[m>>0]=10;s=m+1|0;a[s+0>>0]=a[723720]|0;a[s+1>>0]=a[723721]|0;a[s+2>>0]=a[723722]|0;a[s+3>>0]=a[723723]|0;a[s+4>>0]=a[723724]|0;a[m+6>>0]=0;o=c[t>>2]|0;if((o|0)==(c[b+140>>2]|0)){M5d(k,m);break}if(!o)y=0;else{a[o>>0]=10;n=o+1|0;a[n+0>>0]=a[s+0>>0]|0;a[n+1>>0]=a[s+1>>0]|0;a[n+2>>0]=a[s+2>>0]|0;a[n+3>>0]=a[s+3>>0]|0;a[n+4>>0]=a[s+4>>0]|0;a[o+6>>0]=0;y=c[t>>2]|0}c[t>>2]=y+12}while(0);C5d(b);X5d(b)|0;y=d&1;if(y){t=Ecd(b)|0;if(!t){z=y;u=27}else{b=(Xbd()|0)+236|0;m=c[b+4>>2]|0;k=j;c[k>>2]=c[b>>2];c[k+4>>2]=m;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];jbd(h,f);cbd(h+32|0,t);nbd(h)|0;z=y;u=27}}}else{z=d&1;u=27}if((u|0)==27?(z|0)!=0:0){i=e;return}V5d();i=e;return}function Z5d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+112|0;j=c[h>>2]|0;k=g;if((j|0)==(g|0))l=g;else{m=j+(~(((j+-56-k|0)>>>0)/56|0)*56|0)|0;c[h>>2]=m;l=m}m=(l-k|0)/56|0;if(m>>>0>=256){if(m>>>0>256?(k=g+14336|0,(l|0)!=(k|0)):0)c[h>>2]=l+(~(((l+-56-k|0)>>>0)/56|0)*56|0)}else m6d(f,256-m|0);m=c[b+96>>2]|0;f=b+100|0;k=c[f>>2]|0;if((k|0)!=(m|0))c[f>>2]=k+(~(((k+-56-m|0)>>>0)/56|0)*56|0);m=b+88|0;k=b+84|0;f=c[k>>2]|0;if((c[m>>2]|0)==(f|0)){i=d;return}l=b+108|0;h=b+96|0;b=f;f=0;do{g=b+(f*56|0)|0;j=c[g>>2]|0;if((j|0)==-1){c[g>>2]=f;n=f}else n=j;if((n>>>0<256?(c[b+(f*56|0)+40>>2]|0)==0:0)?(c[b+(f*56|0)+44>>2]|0)==0:0){j=(c[l>>2]|0)+(n*56|0)|0;o=j+0|0;p=g+0|0;q=o+52|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));a[j+52>>0]=a[g+52>>0]|0}else q6d(e,h,g);f=f+1|0;b=c[k>>2]|0}while(f>>>0<(((c[m>>2]|0)-b|0)/56|0)>>>0);i=d;return}function _5d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=0;h=i;i=i+240|0;j=h+216|0;k=h+176|0;l=h+80|0;m=h+136|0;n=h+40|0;o=h+172|0;p=h+184|0;q=h+208|0;r=h+224|0;s=h+24|0;t=h+8|0;u=h+144|0;v=h;w=h+56|0;x=h+152|0;y=h+60|0;z=h+188|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;g[r>>2]=ea(0.0);A=A5d(b,o,p,q,n,r,d,e,c[b+204>>2]|f)|0;c[s>>2]=0;B=s+4|0;c[B>>2]=0;c[s+8>>2]=0;if(!A){C=c[p>>2]|0;D=c[o>>2]|0;if(!(da(D,C)|0)){E=D;F=C;G=5}else{c[o>>2]=0;c[p>>2]=0;g[r>>2]=ea(0.0);H=0;I=0;G=14}}else{E=c[o>>2]|0;F=c[p>>2]|0;G=5}if((G|0)==5)if(E>>>0>F>>>0){C=da(F,E)|0;if(!C)J=E;else{j5c(s,C);J=c[o>>2]|0}C=c[p>>2]|0;if(!J){K=C;L=0}else{D=C;C=J;J=0;while(1){if(!D){M=0;N=C}else{O=~J;P=C;Q=D;R=0;while(1){S=a[A+((da(c[q>>2]|0,R)|0)+J)>>0]|0;T=Q+~R+(da(P+O|0,Q)|0)|0;a[(c[s>>2]|0)+T>>0]=S;R=R+1|0;S=c[p>>2]|0;T=c[o>>2]|0;if(R>>>0>=S>>>0){M=S;N=T;break}else{P=T;Q=S}}}J=J+1|0;if(J>>>0>=N>>>0){K=M;L=N;break}else{D=M;C=N}}}N=c[s>>2]|0;c[q>>2]=K;c[p>>2]=L;c[o>>2]=K;U=N;V=1}else{H=E;I=F;G=14}if((G|0)==14)if((c[q>>2]|0)>>>0>H>>>0){F=da(I,H)|0;if(!F)W=H;else{j5c(s,F);W=c[o>>2]|0}if(!W)X=0;else{F=W;W=c[p>>2]|0;H=0;while(1){if(!W){Y=0;Z=F}else{I=F;E=0;while(1){N=a[A+((da(c[q>>2]|0,E)|0)+H)>>0]|0;K=(da(I,E)|0)+H|0;a[(c[s>>2]|0)+K>>0]=N;E=E+1|0;N=c[p>>2]|0;K=c[o>>2]|0;if(E>>>0>=N>>>0){Y=N;Z=K;break}else I=K}}H=H+1|0;if(H>>>0>=Z>>>0){X=Z;break}else{F=Z;W=Y}}}Y=c[s>>2]|0;c[q>>2]=X;U=Y;V=0}else{U=A;V=0}A=b+68|0;Y=c[A>>2]|0;_=ea(Y|0);g[n>>2]=ea(ea(g[n>>2])-_);X=n+4|0;g[X>>2]=ea(ea(g[X>>2])+_);_=ea(Y<<1|0);Y=n+8|0;g[Y>>2]=ea(ea(g[Y>>2])+_);Y=n+12|0;g[Y>>2]=ea(ea(g[Y>>2])-_);Y=b+180|0;X=b+168|0;W=b+172|0;Z=b+200|0;F=b+184|0;H=b+196|0;I=b+188|0;E=b+172|0;K=b+176|0;N=b+156|0;L=b+160|0;C=k+4|0;M=b+64|0;D=t+4|0;J=t+8|0;Q=t+12|0;P=c[Y>>2]|0;a:while(1){if((P|0)!=(W|0)){R=c[M>>2]|0;O=c[A>>2]<<1;S=P;while(1){T=c[S+16>>2]|0;$=c[S+20>>2]|0;aa=R+(c[o>>2]|0)+O|0;ba=(c[p>>2]|0)+R+O|0;c[t>>2]=T;c[D>>2]=$;c[J>>2]=aa;c[Q>>2]=ba;b:do if(((T|$|0)>=0?(ca=aa+T|0,fa=c[H>>2]|0,(ca|0)<=(fa|0)):0)?(ga=$+ba|0,(ga|0)<=(fa|0)):0){ha=c[N>>2]|0;ia=c[L>>2]|0;ja=(ha|0)==(ia|0);if(ja){ka=T;la=aa;ma=fa;na=$;oa=ga;pa=ia;qa=ba;ra=S;sa=ja;ta=ha;G=33;break a}else ua=ha;while(1){va=c[ua>>2]|0;if(((c[ua+8>>2]|0)+va|0)>(T|0)?(wa=c[ua+4>>2]|0,((va|0)<(ca|0)?((c[ua+12>>2]|0)+wa|0)>($|0):0)&(wa|0)<(ga|0)):0)break b;ua=ua+16|0;if((ua|0)==(ia|0)){ka=T;la=aa;ma=fa;na=$;oa=ga;pa=ia;qa=ba;ra=S;sa=ja;ta=ha;G=33;break a}}}while(0);ba=c[S+4>>2]|0;if(!ba){$=S;while(1){aa=c[$+8>>2]|0;if((c[aa>>2]|0)==($|0)){xa=aa;break}else $=aa}}else{$=ba;while(1){aa=c[$>>2]|0;if(!aa){xa=$;break}else $=aa}}if((xa|0)==(W|0))break;else S=xa}}S=c[X>>2]|0;if((P|0)!=(S|0)){c[Y>>2]=S;P=S;continue}S=(c[Z>>2]|0)+1|0;O=c[H>>2]|0;if(S>>>0>=(da(((c[I>>2]|0)>>>0)/(O>>>0)|0,((c[F>>2]|0)>>>0)/(O>>>0)|0)|0)>>>0){ya=0;break}c[Z>>2]=S;o6d(X,c[E>>2]|0);c[K>>2]=0;c[X>>2]=W;c[W>>2]=0;S=c[N>>2]|0;O=c[L>>2]|0;if((O|0)!=(S|0))c[L>>2]=O+(~((O+-16-S|0)>>>4)<<4);c[k>>2]=0;c[C>>2]=0;n6d(j,X,k);S=c[X>>2]|0;c[Y>>2]=S;P=S}do if((G|0)==33){c:do if((ka|0)<1){za=ka;Aa=ta}else{P=ka;while(1){C=P+-1|0;N=C+la|0;if((N|0)>(ma|0)){za=P;Aa=ta;break c}if(!sa){W=ta;do{xa=c[W>>2]|0;if(((c[W+8>>2]|0)+xa|0)>(C|0)?(ua=c[W+4>>2]|0,((xa|0)<(N|0)?((c[W+12>>2]|0)+ua|0)>(na|0):0)&(ua|0)<(oa|0)):0){za=P;Aa=ta;break c}W=W+16|0}while((W|0)!=(pa|0))}if((C|0)<=0){za=P;Aa=ta;break c}c[t>>2]=C;c[D>>2]=na;c[J>>2]=la;c[Q>>2]=qa;if((P|0)<2){za=C;Aa=ta;break}else P=C}}while(0);d:do if(!((za|0)<0|(na|0)<1)){P=la+za|0;W=na;do{N=W;W=W+-1|0;if((P|0)>(ma|0))break d;ua=W+qa|0;if((ua|0)>(ma|0))break d;if(!sa){xa=Aa;do{M=c[xa>>2]|0;if(((c[xa+8>>2]|0)+M|0)>(za|0)?(S=c[xa+4>>2]|0,((M|0)<(P|0)?((c[xa+12>>2]|0)+S|0)>(W|0):0)&(S|0)<(ua|0)):0)break d;xa=xa+16|0}while((xa|0)!=(pa|0))}if((W|0)<=0)break d;c[t>>2]=za;c[D>>2]=W;c[J>>2]=la;c[Q>>2]=qa}while((N|0)>=2)}while(0);if((pa|0)==(c[b+164>>2]|0))s6d(b+156|0,t);else{if(!pa)Ba=0;else{c[pa+0>>2]=c[t+0>>2];c[pa+4>>2]=c[t+4>>2];c[pa+8>>2]=c[t+8>>2];c[pa+12>>2]=c[t+12>>2];Ba=c[L>>2]|0}c[L>>2]=Ba+16}c[Y>>2]=ra;W=c[ra+4>>2]|0;P=(W|0)==0;if(P){xa=ra;while(1){ua=c[xa+8>>2]|0;if((c[ua>>2]|0)==(xa|0)){Ca=ua;break}else xa=ua}}else{xa=W;while(1){ua=c[xa>>2]|0;if(!ua){Ca=xa;break}else xa=ua}}c[Y>>2]=Ca;if(P){xa=ra;while(1){ua=c[xa+8>>2]|0;if((c[ua>>2]|0)==(xa|0)){Da=ua;break}else xa=ua}}else{xa=W;while(1){P=c[xa>>2]|0;if(!P){Da=xa;break}else xa=P}}if((c[X>>2]|0)==(ra|0))c[X>>2]=Da;c[K>>2]=(c[K>>2]|0)+-1;tYb(c[E>>2]|0,ra);c[k>>2]=27;c[j+0>>2]=c[k+0>>2];eOb(ra,j);xa=c[t>>2]|0;W=c[D>>2]|0;c[u>>2]=(c[J>>2]|0)+xa;c[u+4>>2]=W;n6d(j,X,u);P=(c[Q>>2]|0)+W|0;c[v>>2]=xa;c[v+4>>2]=P;n6d(j,X,v);P=c[H>>2]|0;ua=da(P,c[Z>>2]|0)|0;C=c[F>>2]|0;S=xa+((ua>>>0)%(C>>>0)|0)|0;c[t>>2]=S;xa=W+(da(P,(ua>>>0)/(C>>>0)|0)|0)|0;c[D>>2]=xa;do if(U){C=da(c[p>>2]|0,c[q>>2]|0)|0;ua=p6d(b+40|0)|0;if(!(a[621176]|0)){P=ync()|0;W=c[(c[P>>2]|0)+472>>2]|0;c[w>>2]=c[ua+44>>2];M=c[A>>2]|0;O=c[q>>2]|0;R=c[p>>2]|0;if((KLc()|0)==1)Ea=c[ua+56>>2]|0;else Ea=0;c[j+0>>2]=c[w+0>>2];Mm[W&3](P,j,U,C,0,M+S|0,xa+M|0,O,R,1,Ea);if(!(a[621176]|0))break};c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;c[x+12>>2]=0;c[x+16>>2]=0;if(DEc(ua,x,0,0)|0){lwc(y,x,S,xa,c[q>>2]|0,c[p>>2]|0);ua=c[q>>2]|0;iwc(z,ua,c[p>>2]|0,ua,1,U);hwc(y,z,0)}}while(0);_=ea((c[F>>2]|0)>>>0);Fa=ea((c[I>>2]|0)>>>0);Ga=ea(ea(S|0)/_);ua=c[p>>2]|0;R=c[A>>2]<<1;Ha=ea(ea((ua+xa+R|0)>>>0)/Fa);Ia=ea(ea(((c[o>>2]|0)+R|0)>>>0)/_);_=ea(-ea(ea((R+ua|0)>>>0)/Fa));Fa=ea(g[r>>2]);ua=d-(c[b+72>>2]|0)|0;R=l+4|0;O=R+0|0;M=O+48|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(M|0));g[R>>2]=Ga;g[l+8>>2]=Ha;g[l+12>>2]=Ia;g[l+16>>2]=_;xa=l+20|0;c[xa+0>>2]=c[n+0>>2];c[xa+4>>2]=c[n+4>>2];c[xa+8>>2]=c[n+8>>2];c[xa+12>>2]=c[n+12>>2];g[l+36>>2]=Fa;c[l>>2]=ua;xa=l+40|0;c[xa>>2]=(c[b+32>>2]|0)==(e|0)?0:e;S=l+44|0;c[S>>2]=f;c[l+48>>2]=c[(jLc()|0)+128>>2];a[l+52>>0]=V;C=b+88|0;P=c[C>>2]|0;if((P|0)==(c[b+92>>2]|0))r6d(b+84|0,l);else{if(!P)Ja=0;else{O=P+0|0;Ka=l+0|0;M=O+56|0;do{c[O>>2]=c[Ka>>2];O=O+4|0;Ka=Ka+4|0}while((O|0)<(M|0));Ja=c[C>>2]|0}c[C>>2]=Ja+56}ua=c[l>>2]|0;if(ua>>>0<256&(c[xa>>2]|0)==0&(c[S>>2]|0)==0){R=(c[b+108>>2]|0)+(ua*56|0)|0;O=R+0|0;Ka=l+0|0;M=O+52|0;do{c[O>>2]=c[Ka>>2];O=O+4|0;Ka=Ka+4|0}while((O|0)<(M|0));a[R+52>>0]=a[l+52>>0]|0;ya=1;break}else{q6d(k,b+96|0,l);ya=1;break}}while(0);l=c[s>>2]|0;if(!l){i=h;return ya|0}if((c[B>>2]|0)!=(l|0))c[B>>2]=l;c[m>>2]=89;c[j+0>>2]=c[m+0>>2];eOb(l,j);i=h;return ya|0}function $5d(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=a+108|0;k=c[j>>2]|0;l=a+112|0;if((k|0)==(c[l>>2]|0))m=0;else{n=k;k=0;while(1){o=c[n+48>>2]|0;p=((o|0)==(c[(jLc()|0)+128>>2]|0)&1)+k|0;n=n+56|0;if((n|0)==(c[l>>2]|0)){m=p;break}else k=p}}k=a+96|0;n=c[k>>2]|0;p=a+100|0;if((n|0)==(c[p>>2]|0))q=m;else{a=n;n=m;while(1){m=c[a+48>>2]|0;o=((m|0)==(c[(jLc()|0)+128>>2]|0)&1)+n|0;a=a+56|0;if((a|0)==(c[p>>2]|0)){q=o;break}else n=o}}n=c[e>>2]|0;a=n+q|0;q=zCi(a>>>0>2147483647?-1:a<<1)|0;o=a>>>0>1073741823?-1:a<<2;c[f>>2]=zCi(o)|0;a=zCi(o)|0;c[g>>2]=a;if((n|0)>0){n=c[f>>2]|0;o=0;do{b[q+(o<<1)>>1]=b[d+(o<<1)>>1]|0;c[n+(o<<2)>>2]=-1;c[a+(o<<2)>>2]=-1;o=o+1|0}while((o|0)<(c[e>>2]|0))}o=c[j>>2]|0;if((o|0)!=(c[l>>2]|0)){j=o;do{o=c[j+48>>2]|0;if((o|0)==(c[(jLc()|0)+128>>2]|0)){o=c[e>>2]|0;b[q+(o<<1)>>1]=c[j>>2];c[(c[f>>2]|0)+(o<<2)>>2]=c[j+40>>2];c[(c[g>>2]|0)+(c[e>>2]<<2)>>2]=c[j+44>>2];c[e>>2]=(c[e>>2]|0)+1}j=j+56|0}while((j|0)!=(c[l>>2]|0))}l=c[k>>2]|0;if((l|0)==(c[p>>2]|0)){i=h;return q|0}else r=l;do{l=c[r+48>>2]|0;if((l|0)==(c[(jLc()|0)+128>>2]|0)){l=c[e>>2]|0;b[q+(l<<1)>>1]=c[r>>2];c[(c[f>>2]|0)+(l<<2)>>2]=c[r+40>>2];c[(c[g>>2]|0)+(c[e>>2]<<2)>>2]=c[r+44>>2];c[e>>2]=(c[e>>2]|0)+1}r=r+56|0}while((r|0)!=(c[p>>2]|0));i=h;return q|0}function a6d(b,d,f,h,j,k){b=b|0;d=d|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;l=i;i=i+272|0;m=l+216|0;n=l+8|0;o=l;p=l+252|0;q=l+268|0;r=l+208|0;s=l+248|0;t=l+256|0;c[q>>2]=f;if((c[b+76>>2]|0)!=-2){u=1;i=l;return u|0}v=b+40|0;w=c[v>>2]|0;do if(w){c[p>>2]=w;x=c[137784]|0;if(x){do if((c[x+36>>2]|0)!=(c[x+4>>2]|0)){fRb(m,x,p);y=c[m>>2]|0;z=c[x+28>>2]|0;if((y|0)==-1){A=z+(c[x+32>>2]<<3)|0;break}else{A=z+(y<<3)|0;break}}else A=(c[x+28>>2]|0)+(c[x+32>>2]<<3)|0;while(0);x=c[137784]|0;if((A|0)!=((c[x+28>>2]|0)+(c[x+32>>2]<<3)|0)?(c[A+4>>2]|0)!=0:0)break}if(!(hQb(c[v>>2]|0)|0))B=12}else B=12;while(0);if((B|0)==12?!(X5d(b)|0):0){u=0;i=l;return u|0}c[r>>2]=0;c[s>>2]=0;A=t+4|0;p=t+8|0;w=m+4|0;x=m+8|0;y=m+12|0;z=m+16|0;C=m+24|0;D=m+20|0;E=m+28|0;F=k+4|0;G=b+32|0;H=b+88|0;I=b+84|0;J=b+184|0;K=b+188|0;L=b+196|0;M=d;d=f;f=0;N=0;while(1){c[t>>2]=0;c[A>>2]=0;c[p>>2]=0;c[m>>2]=0;c[w>>2]=-1;c[x>>2]=0;c[y>>2]=0;g[z>>2]=ea(0.0);g[C>>2]=ea(1.0);g[D>>2]=ea(0.0);g[E>>2]=ea(1.0);t6d(t,m);O=c[A>>2]|0;c[O+-28>>2]=-1;c[O+-24>>2]=h;c[O+-32>>2]=j;a:do if((d|0)>0){O=c[r>>2]|0;P=(O|0)==0;Q=c[s>>2]|0;R=f;S=0;T=0;U=N;while(1){V=c[k>>2]|0;b:do if(S>>>0<(((c[F>>2]|0)-V|0)/44|0)>>>0){W=V;X=S;Y=T;while(1){if((Y|0)<(c[W+(X*44|0)>>2]|0)){Z=X;_=Y;break b}$=c[W+(X*44|0)+4>>2]|0;aa=W+(X*44|0)+40|0;ba=c[A>>2]|0;ca=ba+-32|0;if(!(c[aa>>2]&32768)){if((ba|0)==(c[p>>2]|0))t6d(t,ca);else{if(!ba)da=0;else{c[ba+0>>2]=c[ca+0>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];c[ba+12>>2]=c[ca+12>>2];c[ba+16>>2]=c[ca+16>>2];c[ba+20>>2]=c[ca+20>>2];c[ba+24>>2]=c[ca+24>>2];c[ba+28>>2]=c[ca+28>>2];da=ba}c[A>>2]=da+32}ba=c[aa>>2]|0;if(ba&1){fa=(c[A>>2]|0)+-32|0;c[fa>>2]=c[fa>>2]|1}if(ba&2){fa=(c[A>>2]|0)+-32|0;c[fa>>2]=c[fa>>2]|2}if(!(ba&4))ga=ba;else{c[(c[A>>2]|0)+-28>>2]=c[W+(X*44|0)+12>>2];ga=c[aa>>2]|0}if(ga&8)c[(c[A>>2]|0)+-24>>2]=c[W+(X*44|0)+16>>2];if(ga&16)c[(c[A>>2]|0)+-20>>2]=c[W+(X*44|0)+20>>2]}else c[A>>2]=ca;ca=$+Y|0;$=X+1|0;W=c[k>>2]|0;if($>>>0>=(((c[F>>2]|0)-W|0)/44|0)>>>0){Z=$;_=ca;break}else{X=$;Y=ca}}}else{Z=S;_=T}while(0);if((_|0)>=(d|0)){ha=M;ia=d;ja=R;ka=0;la=U;B=57;break a}V=c[A>>2]|0;Y=c[V+-24>>2]|0;X=c[V+-32>>2]|0;if(!P?(V=c[O+(_<<2)>>2]|0,(V|0)!=-1):0){ma=V;na=c[Q+(_<<2)>>2]|0}else{ma=Y;na=X}if(!ma)oa=c[G>>2]|0;else oa=ma;X=(oa|0)>(U|0)?oa:U;Y=M+(_<<1)|0;V=e[Y>>1]|0;if(z5d(b,V)|0?!(T5d(b,e[Y>>1]|0,oa,na)|0):0)if(_5d(b,V,oa,na)|0)pa=1;else{qa=R;ra=X;break}else pa=R;T=_+1|0;if((T|0)>=(d|0)){ha=M;ia=d;ja=pa;ka=0;la=X;B=57;break a}else{R=pa;S=Z;U=X}}if(P){U=$5d(b,M,q,r,s)|0;S=c[q>>2]|0;if(+(S|0)>+((((c[H>>2]|0)-(c[I>>2]|0)|0)/56|0)>>>0)*.8){R=c[J>>2]|0;T=c[K>>2]|0;if(R>>>0<T>>>0){Q=R<<1;c[J>>2]=Q;sa=Q}else{c[K>>2]=T<<1;sa=R}R=(ra<<2)+-1|0;T=R>>>16|R;R=T>>>8|T;T=R>>>4|R;R=T>>>2|T;T=(R>>>1|R)+1|0;R=c[L>>2]|0;Q=R>>>0<T>>>0?T:R;c[L>>2]=sa>>>0<Q>>>0?sa:Q;ta=U;ua=S}else{ta=U;ua=S}}else{S=c[J>>2]|0;U=c[K>>2]|0;if(S>>>0<U>>>0){Q=S<<1;c[J>>2]=Q;va=Q}else{c[K>>2]=U<<1;va=S}S=(ra<<2)+-1|0;U=S>>>16|S;S=U>>>8|U;U=S>>>4|S;S=U>>>2|U;U=(S>>>1|S)+1|0;S=c[L>>2]|0;Q=S>>>0<U>>>0?U:S;c[L>>2]=va>>>0<Q>>>0?va:Q;ta=M;ua=d}if(X5d(b)|0){ha=ta;ia=ua;ja=qa;ka=1;la=ra;B=57}else{wa=1;xa=ta;ya=ua;za=qa;Aa=1;Ba=ra}}else{ha=M;ia=d;ja=f;ka=0;la=N;B=57}while(0);if((B|0)==57){B=0;wa=0;xa=ha;ya=ia;za=ja;Aa=ka;Ba=la}Q=c[t>>2]|0;if(Q){S=c[A>>2]|0;if((S|0)!=(Q|0))c[A>>2]=S+(~((S+-32-Q|0)>>>5)<<5);ACi(Q)}if(wa){u=0;B=74;break}if(Aa){M=xa;d=ya;f=za;N=Ba}else{Ca=xa;Da=za;break}}if((B|0)==74){i=l;return u|0}if(!((a[621176]|0)==0|Da^1)){Da=p6d(v)|0;ko[c[(c[Da>>2]|0)+152>>2]&4095](Da)}Da=c[r>>2]|0;if(!Da){u=1;i=l;return u|0}if(Ca)BCi(Ca);BCi(Da);Da=c[s>>2]|0;if(Da)BCi(Da);c[180794]=(c[180794]|0)+1;V5d();Da=(c[180794]|0)+-1|0;c[180794]=Da;if(Da){u=1;i=l;return u|0}Da=Ecd(b)|0;if(!Da){u=1;i=l;return u|0}b=(Xbd()|0)+236|0;s=c[b+4>>2]|0;Ca=o;c[Ca>>2]=c[b>>2];c[Ca+4>>2]=s;c[m+0>>2]=c[o+0>>2];c[m+4>>2]=c[o+4>>2];jbd(n,m);cbd(n+32|0,Da);nbd(n)|0;u=1;i=l;return u|0}function b6d(a,b){a=a|0;b=ea(b);var d=Im;d=ea(ea(c[a+32>>2]|0)*b);b=ea(d/ea(g[a+28>>2]));return ea(b)}function c6d(a,b,d,f,g){a=a|0;b=b|0;d=ea(d);f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0;h=i;i=i+16|0;j=h;k=c[b>>2]|0;l=b+4|0;m=c[l>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;a6d(a,k,m,0,0,j)|0;j=c[l>>2]|0;if(!j){n=0;i=h;return n|0}else{o=ea(0.0);p=0}while(1){q=ea(U5d(a,e[(c[b>>2]|0)+(p<<1)>>1]|0,f,g));if(q==ea(0.0)){n=-1;r=5;break}o=ea(o+q);l=p;p=p+1|0;if(o>d){n=l;r=5;break}if(p>>>0>=j>>>0){n=j;r=5;break}}if((r|0)==5){i=h;return n|0}return 0}function d6d(){var a=0;a=i;QQb(128,227,228,0,229);i=a;return}function e6d(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(130)|0))pWb();rri(b,2497152,4);wQb(128,130,b,220,2741,0,0);xri(b);i=a;return}function f6d(a){a=a|0;return 128}function g6d(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2497152,a,0);v6d(a,b);bdd(b);i=c;return}function h6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2497152,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else w6d(a,b);sdd(b);i=d;return}function i6d(a,b){a=a|0;b=b|0;var c=0;c=i;x6d(a,b);i=c;return}function j6d(a,b){a=a|0;b=b|0;var c=0;c=i;y6d(a,b);i=c;return}function k6d(a,b){a=a|0;b=b|0;var c=0;c=i;z6d(a,b);i=c;return}function l6d(a,b){a=a|0;b=b|0;var c=0;c=i;A6d(a,b);i=c;return}function m6d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/56|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{c[o>>2]=-1;l=o+4|0;q=l+0|0;r=q+48|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));a[l+48>>0]=0;p=c[k>>2]|0}o=p+56|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=((m-n|0)/56|0)+d|0;if((o|0)<0)vxi(b);m=n;n=(j-m|0)/56|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=((c[k>>2]|0)-m|0)/56|0;if(!n){s=0;t=0;u=j}else{v=n;w=j;x=10}}else{v=2147483647;w=((c[k>>2]|0)-m|0)/56|0;x=10}if((x|0)==10){c[g>>2]=27;c[f+0>>2]=c[g+0>>2];s=v;t=cOb(v*56|0,16,f,0,3653512,80)|0;u=w}w=d;d=t+(u*56|0)|0;while(1){if(!d)y=0;else{c[d>>2]=-1;v=d+4|0;q=v+0|0;r=q+48|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));a[v+48>>0]=0;y=d}l=y+56|0;w=w+-1|0;if(!w){z=l;break}else d=l}d=c[b>>2]|0;w=(c[k>>2]|0)-d|0;y=t+((((w|0)/-56|0)+u|0)*56|0)|0;YEi(y|0,d|0,w|0)|0;w=c[b>>2]|0;c[b>>2]=y;c[k>>2]=z;c[h>>2]=t+(s*56|0);if(!w){i=e;return}c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(w,f);i=e;return}function n6d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=d+4|0;l=c[k>>2]|0;do if(l){m=c[e>>2]|0;n=(c[e+4>>2]|0)+m|0;o=l;while(1){p=c[o+16>>2]|0;q=(c[o+20>>2]|0)+p|0;r=(n|0)==(q|0);if(r?(m|0)<(p|0):(n|0)<(q|0)){s=c[o>>2]|0;if(!s){t=o;u=o;v=5;break}else{o=s;continue}}if(!(r?(p|0)<(m|0):(q|0)<(n|0))){w=o;v=9;break}q=o+4|0;p=c[q>>2]|0;if(!p){x=q;y=o;v=8;break}else o=p}if((v|0)==5){c[j>>2]=u;z=t;A=u;break}else if((v|0)==8){c[j>>2]=y;z=x;A=y;break}else if((v|0)==9){c[j>>2]=w;z=j;A=w;break}}else{o=d+4|0;c[j>>2]=o;z=o;A=o}while(0);j=c[z>>2]|0;if(j){B=0;C=j;c[b>>2]=C;D=b+4|0;a[D>>0]=B;i=f;return}c[h>>2]=27;c[g+0>>2]=c[h+0>>2];h=cOb(24,16,g,0,3653512,80)|0;g=e;e=c[g+4>>2]|0;j=h+16|0;c[j>>2]=c[g>>2];c[j+4>>2]=e;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=A;c[z>>2]=h;A=c[c[d>>2]>>2]|0;if(!A)E=h;else{c[d>>2]=A;E=c[z>>2]|0}GN(c[k>>2]|0,E);E=d+8|0;c[E>>2]=(c[E>>2]|0)+1;B=1;C=h;c[b>>2]=C;D=b+4|0;a[D>>0]=B;i=f;return}function o6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!b){i=d;return}o6d(a,c[b>>2]|0);o6d(a,c[b+4>>2]|0);c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function p6d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[a>>2]|0;do if(f){c[e>>2]=f;g=c[137784]|0;if(g){do if((c[g+36>>2]|0)!=(c[g+4>>2]|0)){fRb(d,g,e);h=c[d>>2]|0;j=c[g+28>>2]|0;if((h|0)==-1){k=j+(c[g+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[g+28>>2]|0)+(c[g+32>>2]<<3)|0;while(0);g=c[137784]|0;if((k|0)!=((c[g+28>>2]|0)+(c[g+32>>2]<<3)|0)?(g=c[k+4>>2]|0,(g|0)!=0):0)l=g;else m=10}else m=10;if((m|0)==10){g=hQb(c[a>>2]|0)|0;if(!g)break;else l=g}g=(da(c[137788]|0,(c[l+8>>2]|0)>>>21)|0)+28|0;h=g>>5;if(1<<g-(h<<5)&c[(c[137786]|0)+(h<<2)>>2]){n=l;i=b;return n|0}}while(0);n=0;i=b;return n|0}function q6d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d>>2]|0;l=c[d+4>>2]|0;if((l|0)==(k|0))m=k;else{n=c[e>>2]|0;o=c[e+40>>2]|0;p=c[e+44>>2]|0;q=k;r=(l-k|0)/56|0;while(1){k=(r|0)/2|0;s=c[q+(k*56|0)>>2]|0;if((s|0)==(n|0)){t=c[q+(k*56|0)+40>>2]|0;if((t|0)>=(o|0))if((t|0)<=(o|0)?(c[q+(k*56|0)+44>>2]|0)>>>0<p>>>0:0)u=8;else{v=q;w=k}else u=8}else if(s>>>0<n>>>0)u=8;else{v=q;w=k}if((u|0)==8){u=0;v=q+((k+1|0)*56|0)|0;w=r+-1-k|0}if(!w){m=v;break}else{q=v;r=w}}}do if((m|0)!=(l|0)){w=c[e>>2]|0;r=c[m>>2]|0;if((w|0)==(r|0)){v=c[e+40>>2]|0;q=c[m+40>>2]|0;if((v|0)<(q|0))break;if((v|0)<=(q|0)?(c[e+44>>2]|0)>>>0<(c[m+44>>2]|0)>>>0:0)break}else if(w>>>0<r>>>0)break;c[b>>2]=m;a[b+4>>0]=0;i=f;return}while(0);c[j>>2]=m;c[g+0>>2]=c[j+0>>2];D6d(h,d,g,e);c[b>>2]=c[h>>2];a[b+4>>0]=1;i=f;return}function r6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=(((c[g>>2]|0)-h|0)/56|0)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=((c[k>>2]|0)-l|0)/56|0;if(h>>>0<1073741823){m=h<<1;h=m>>>0<j>>>0?j:m;m=((c[g>>2]|0)-l|0)/56|0;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=((c[g>>2]|0)-l|0)/56|0;s=6}if((s|0)==6){c[f>>2]=27;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q*56|0,16,e,0,3653512,80)|0;p=r}r=o+(p*56|0)|0;q=o+(n*56|0)|0;if(r){n=r+0|0;r=b+0|0;b=n+56|0;do{c[n>>2]=c[r>>2];n=n+4|0;r=r+4|0}while((n|0)<(b|0))}r=c[a>>2]|0;n=(c[g>>2]|0)-r|0;b=o+((((n|0)/-56|0)+p|0)*56|0)|0;YEi(b|0,r|0,n|0)|0;n=c[a>>2]|0;c[a>>2]=b;c[g>>2]=o+((p+1|0)*56|0);c[k>>2]=q;if(!n){i=d;return}c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(n,e);i=d;return}function s6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=((c[g>>2]|0)-h>>4)+1|0;if((j|0)<0)vxi(a);k=a+8|0;l=h;h=(c[k>>2]|0)-l|0;if(h>>4>>>0<1073741823){m=h>>3;h=m>>>0<j>>>0?j:m;m=(c[g>>2]|0)-l>>4;if(!h){n=0;o=0;p=m}else{q=h;r=m;s=6}}else{q=2147483647;r=(c[g>>2]|0)-l>>4;s=6}if((s|0)==6){c[f>>2]=27;c[e+0>>2]=c[f+0>>2];n=q;o=cOb(q<<4,16,e,0,3653512,80)|0;p=r}r=o+(p<<4)|0;if(r){c[r+0>>2]=c[b+0>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2]}b=c[a>>2]|0;r=(c[g>>2]|0)-b|0;q=o+(p-(r>>4)<<4)|0;YEi(q|0,b|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=q;c[g>>2]=o+(p+1<<4);c[k>>2]=o+(n<<4);if(!r){i=d;return}c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function t6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>5)+1|0;if(g>>>0>134217727)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>5>>>0<67108863){l=k>>4;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>5;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=134217727;r=l>>5;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<5)|0;o=r;p=s}s=n+(o<<5)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];c[s+16>>2]=c[b+16>>2];c[s+20>>2]=c[b+20>>2];c[s+24>>2]=c[b+24>>2];c[s+28>>2]=c[b+28>>2]}YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<5);c[h>>2]=n+(m<<5);if(!f){i=d;return}ACi(f);i=d;return}function u6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[a>>2]|0;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];f=bOb(220,e,1,16,3653512,90)|0;c[g>>2]=h;c[e+0>>2]=c[g+0>>2];Q5d(f,e,b);i=d;return f|0}function v6d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+96|0;h=f;j=f+40|0;k=f+36|0;l=f+32|0;m=f+20|0;n=f+16|0;xWb(d,e);ddd(e,4);o=c[142270]|0;add(e,723184,o,d+72|0,0);p=e+12|0;q=e+20|0;c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);r=c[142268]|0;add(e,723208,r,d+60|0,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,723224,r,d+28|0,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,723240,o,d+64|0,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,723264,o,d+68|0,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);s=d+76|0;add(e,723288,o,s,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);t=d+36|0;add(e,723304,723624,t,0);u=h+8|0;v=u;c[v>>2]=0;c[v+4>>2]=0;c[h>>2]=0;add(e,792256,o,t,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);t=c[142290]|0;add(e,792272,t,u,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=8;bdd(e);bdd(e);if((c[s>>2]|0)==-2){c[m>>2]=0;s=m+4|0;c[s>>2]=0;c[m+8>>2]=0;u=c[142306]|0;add(e,723328,u,m,0);c[j>>2]=-1;v=j+4|0;w=v+0|0;x=w+48|0;do{c[w>>2]=0;w=w+4|0}while((w|0)<(x|0));a[v+48>>0]=0;$cd(e,2646336,2646336,h,0);add(e,3142592,2495816,j,0);F6d(j,e);bdd(e);cdd(e);bdd(e);v=c[m>>2]|0;if(!v)y=u;else{m=c[s>>2]|0;if((m|0)!=(v|0))c[s>>2]=m+(~(((m+-56-v|0)>>>0)/56|0)*56|0);c[l>>2]=89;c[h+0>>2]=c[l+0>>2];eOb(v,h);y=u}}else{u=c[142306]|0;add(e,723328,u,d+84|0,0);c[j>>2]=-1;v=j+4|0;w=v+0|0;x=w+48|0;do{c[w>>2]=0;w=w+4|0}while((w|0)<(x|0));a[v+48>>0]=0;$cd(e,2646336,2646336,h,0);add(e,3142592,2495816,j,0);F6d(j,e);bdd(e);cdd(e);bdd(e);y=u}u=d+40|0;add(e,723352,723608,u,1);v=h+8|0;w=v;c[w>>2]=0;c[w+4>>2]=0;c[h>>2]=0;add(e,792256,o,u,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,792272,t,v,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=8;bdd(e);bdd(e);add(e,723368,c[142272]|0,d+44|0,1);b[j>>1]=0;v=j+2|0;b[v>>1]=0;t=j+4|0;g[t>>2]=ea(0.0);$cd(e,2646336,2646336,h,0);u=c[142274]|0;add(e,3142592,u,j,0);o=c[142266]|0;add(e,o,u,j,0);u=c[142296]|0;add(e,o,u,j,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=2;bdd(e);o=c[142282]|0;add(e,o,u,v,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=2;bdd(e);bdd(e);add(e,o,r,t,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);bdd(e);cdd(e);bdd(e);add(e,723384,r,d+80|0,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);fdd(e);add(e,723472,y,d+120|0,1);$cd(e,2646336,2646336,h,0);add(e,3142592,c[142260]|0,j,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=1;bdd(e);cdd(e);bdd(e);fdd(e);y=d+32|0;g[n>>2]=ea(c[y>>2]|0);r=c[142268]|0;add(e,723488,r,n,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);c[y>>2]=~~ea(g[n>>2]);add(e,723504,r,d+208|0,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,723520,c[142304]|0,d+204|0,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);G6d(e,d+132|0,723536,1);add(e,723552,c[142306]|0,d+144|0,1);c[k>>2]=0;$cd(e,2646336,2646336,j,0);add(e,3142592,723592,k,0);j=h+8|0;r=j;c[r>>2]=0;c[r+4>>2]=0;c[h>>2]=0;h=c[142270]|0;add(e,792256,h,k,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);add(e,792272,c[142290]|0,j,1);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=8;bdd(e);bdd(e);cdd(e);bdd(e);fdd(e);add(e,723568,h,d+212|0,0);c[(c[c[p>>2]>>2]|0)+((c[q>>2]|0)*24|0)+12>>2]=4;bdd(e);i=f;return}function w6d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=Im,P=Im,Q=Im,R=Im,S=Im,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+112|0;f=e;h=e+68|0;j=e+56|0;k=e+60|0;l=e+92|0;m=e+96|0;n=e+108|0;o=e+76|0;p=e+72|0;q=e+80|0;r=e+64|0;yWb(b,d);rdd(d,4);s=b+72|0;t=c[142270]|0;u=qdd(d,723184,t,f,0)|0;if(u){if((u|0)>0){u=d+12|0;v=c[d+16>>2]|0;w=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;x=v+w|0;c[u>>2]=x;if((w|0)>=0?(y=v+(w+4)|0,y>>>0<=(c[d+20>>2]|0)>>>0):0){c[s>>2]=c[x>>2];c[u>>2]=y}else Bid(u,s,4);if(c[d>>2]&512)c[s>>2]=XEi(c[s>>2]|0)|0}else{u=c[f>>2]|0;if(u)_n[u&4095](s,d)|0}sdd(d)}u=b+60|0;y=c[142268]|0;x=qdd(d,723208,y,f,0)|0;if(x){if((x|0)>0){x=d+12|0;w=c[d+16>>2]|0;v=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;z=w+v|0;c[x>>2]=z;if((v|0)>=0?(A=w+(v+4)|0,A>>>0<=(c[d+20>>2]|0)>>>0):0){g[u>>2]=ea(g[z>>2]);c[x>>2]=A}else Bid(x,u,4);if(c[d>>2]&512)c[u>>2]=XEi(c[u>>2]|0)|0}else{x=c[f>>2]|0;if(x)_n[x&4095](u,d)|0}sdd(d)}u=b+28|0;x=qdd(d,723224,y,f,0)|0;if(x){if((x|0)>0){x=d+12|0;A=c[d+16>>2]|0;z=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;v=A+z|0;c[x>>2]=v;if((z|0)>=0?(w=A+(z+4)|0,w>>>0<=(c[d+20>>2]|0)>>>0):0){g[u>>2]=ea(g[v>>2]);c[x>>2]=w}else Bid(x,u,4);if(c[d>>2]&512)c[u>>2]=XEi(c[u>>2]|0)|0}else{x=c[f>>2]|0;if(x)_n[x&4095](u,d)|0}sdd(d)}x=b+64|0;w=qdd(d,723240,t,f,0)|0;if(w){if((w|0)>0){w=d+12|0;v=c[d+16>>2]|0;z=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;A=v+z|0;c[w>>2]=A;if((z|0)>=0?(B=v+(z+4)|0,B>>>0<=(c[d+20>>2]|0)>>>0):0){c[x>>2]=c[A>>2];c[w>>2]=B}else Bid(w,x,4);if(c[d>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0}else{w=c[f>>2]|0;if(w)_n[w&4095](x,d)|0}sdd(d)}x=b+68|0;w=qdd(d,723264,t,f,0)|0;if(w){if((w|0)>0){w=d+12|0;B=c[d+16>>2]|0;A=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;z=B+A|0;c[w>>2]=z;if((A|0)>=0?(v=B+(A+4)|0,v>>>0<=(c[d+20>>2]|0)>>>0):0){c[x>>2]=c[z>>2];c[w>>2]=v}else Bid(w,x,4);if(c[d>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0}else{w=c[f>>2]|0;if(w)_n[w&4095](x,d)|0}sdd(d)}x=b+76|0;w=qdd(d,723288,t,f,0)|0;if(w){if((w|0)>0){w=d+12|0;v=c[d+16>>2]|0;z=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;A=v+z|0;c[w>>2]=A;if((z|0)>=0?(B=v+(z+4)|0,B>>>0<=(c[d+20>>2]|0)>>>0):0){c[x>>2]=c[A>>2];c[w>>2]=B}else Bid(w,x,4);if(c[d>>2]&512)c[x>>2]=XEi(c[x>>2]|0)|0}else{w=c[f>>2]|0;if(w)_n[w&4095](x,d)|0}sdd(d)}w=b+36|0;B=qdd(d,723304,723624,f,1)|0;if(B){if((B|0)<=0){B=c[f>>2]|0;if(B)_n[B&4095](w,d)|0}else g7b(w,d);sdd(d)}if((c[x>>2]|0)==-2){c[m>>2]=0;x=m+4|0;c[x>>2]=0;c[m+8>>2]=0;w=c[142306]|0;B=qdd(d,723328,w,f,1)|0;if(B){if((B|0)<=0){B=c[f>>2]|0;if(B)_n[B&4095](m,d)|0}else I6d(d,m,0);sdd(d)}B=c[m>>2]|0;if(!B)C=w;else{m=c[x>>2]|0;if((m|0)!=(B|0))c[x>>2]=m+(~(((m+-56-B|0)>>>0)/56|0)*56|0);c[k>>2]=89;c[f+0>>2]=c[k+0>>2];eOb(B,f);C=w}}else{w=b+84|0;B=c[142306]|0;k=qdd(d,723328,B,l,1)|0;if(!k)C=B;else{if((k|0)<=0){k=c[l>>2]|0;if(k)_n[k&4095](w,d)|0}else H6d(d,w,0);sdd(d);C=B}}B=b+40|0;w=qdd(d,723352,723608,f,1)|0;if(w){if((w|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](B,d)|0}else GYb(B,d);sdd(d)}B=b+44|0;w=qdd(d,723368,c[142272]|0,f,1)|0;if(w){if((w|0)<=0){w=c[f>>2]|0;if(w)_n[w&4095](B,d)|0}else J6d(d,B,0);sdd(d)}if(wdd(d,1)|0)g[u>>2]=ea(ea(g[u>>2])+ea(1.0));u=b+80|0;B=qdd(d,723384,y,f,0)|0;if(B){if((B|0)>0){B=d+12|0;w=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=w+k|0;c[B>>2]=l;if((k|0)>=0?(m=w+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){g[u>>2]=ea(g[l>>2]);c[B>>2]=m}else Bid(B,u,4);if(c[d>>2]&512)c[u>>2]=XEi(c[u>>2]|0)|0}else{B=c[f>>2]|0;if(B)_n[B&4095](u,d)|0}sdd(d)}do if(xdd(d,3)|0){B=qdd(d,723400,c[142258]|0,f,0)|0;if(B){a:do if((B|0)<=0){m=c[f>>2]|0;if(m)_n[m&4095](n,d)|0}else{m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;w=l+k|0;c[m>>2]=w;do if((k|0)>=0){if((l+(k+1)|0)>>>0>(c[d+20>>2]|0)>>>0)break;a[n>>0]=a[w>>0]|0;c[m>>2]=l+(k+1);break a}while(0);Bid(m,n,1)}while(0);sdd(d)}if(a[n>>0]|0){B=qdd(d,723416,t,f,0)|0;if(B){do if((B|0)>0){k=d+12|0;l=c[d+16>>2]|0;w=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;x=l+w|0;c[k>>2]=x;do if((w|0)<0)D=131;else{A=l+(w+4)|0;if(A>>>0>(c[d+20>>2]|0)>>>0){D=131;break}c[o>>2]=c[x>>2];c[k>>2]=A}while(0);if((D|0)==131)Bid(k,o,4);if(!(c[d>>2]&512))break;c[o>>2]=XEi(c[o>>2]|0)|0}else{x=c[f>>2]|0;if(!x)break;_n[x&4095](o,d)|0}while(0);sdd(d)}B=qdd(d,723432,t,f,0)|0;if(B){do if((B|0)>0){x=d+12|0;w=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=w+l|0;c[x>>2]=m;do if((l|0)<0)D=142;else{A=w+(l+4)|0;if(A>>>0>(c[d+20>>2]|0)>>>0){D=142;break}c[p>>2]=c[m>>2];c[x>>2]=A}while(0);if((D|0)==142)Bid(x,p,4);if(!(c[d>>2]&512))break;c[p>>2]=XEi(c[p>>2]|0)|0}else{m=c[f>>2]|0;if(!m)break;_n[m&4095](p,d)|0}while(0);sdd(d)}g[u>>2]=ea(0-(c[o>>2]|0)|0);c[q>>2]=0;B=q+4|0;c[B>>2]=0;c[q+8>>2]=0;m=qdd(d,723448,C,j,1)|0;if(m){do if((m|0)>0)K6d(d,q,0);else{l=c[j>>2]|0;if(!l)break;_n[l&4095](q,d)|0}while(0);sdd(d)}m=c[o>>2]|0;l=c[p>>2]|0;if((da(l,m)|0)>0){w=f+4|0;k=f+20|0;A=f+24|0;z=f+28|0;v=f+32|0;E=f+8|0;F=f+12|0;G=f+16|0;H=f+36|0;I=b+88|0;J=b+92|0;K=b+84|0;L=m;m=l;l=0;while(1){M=w+0|0;N=M+48|0;do{c[M>>2]=0;M=M+4|0}while((M|0)<(N|0));a[w+48>>0]=0;c[f>>2]=l;g[k>>2]=ea(0.0);g[A>>2]=ea(0.0);g[z>>2]=ea(1.0);g[v>>2]=ea(-1.0);O=ea(ea(1.0)/ea(L|0));P=ea(ea(1.0)/ea(m|0));Q=ea(ea((((l|0)%(L|0)|0)&65535)<<16>>16)*O);R=ea(ea(1.0)-ea(ea((((l|0)/(L|0)|0)&65535)<<16>>16)*P));S=ea(R-P);P=ea(ea(O+Q)-Q);O=ea(R-S);g[w>>2]=Q;g[E>>2]=S;g[F>>2]=P;g[G>>2]=O;g[H>>2]=ea(1.0);x=c[q>>2]|0;T=c[B>>2]|0;if((x|0)!=(T|0)){U=c[s>>2]|0;V=x;do{if(((c[V>>2]|0)-U|0)==(l|0))g[H>>2]=ea(g[V+4>>2]);V=V+8|0}while((V|0)!=(T|0))}T=c[I>>2]|0;if((T|0)==(c[J>>2]|0)){r6d(K,f);W=c[p>>2]|0;X=c[o>>2]|0}else{if(!T)Y=0;else{M=T+0|0;T=f+0|0;N=M+56|0;do{c[M>>2]=c[T>>2];M=M+4|0;T=T+4|0}while((M|0)<(N|0));Y=c[I>>2]|0}c[I>>2]=Y+56;W=m;X=L}l=l+1|0;if((l|0)>=(da(W,X)|0))break;else{L=X;m=W}}}m=c[q>>2]|0;if(!m)break;L=c[B>>2]|0;if((L|0)!=(m|0))c[B>>2]=L+(~((L+-8-m|0)>>>3)<<3);c[h>>2]=27;c[f+0>>2]=c[h+0>>2];eOb(m,f)}}while(0);h=b+120|0;q=qdd(d,723472,C,f,1)|0;if(q){if((q|0)<=0){q=c[f>>2]|0;if(q)_n[q&4095](h,d)|0}else L6d(d,h,0);sdd(d)}h=b+32|0;g[r>>2]=ea(c[h>>2]|0);q=qdd(d,723488,y,f,0)|0;if(q){if((q|0)>0){q=d+12|0;W=c[d+16>>2]|0;X=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;Y=W+X|0;c[q>>2]=Y;do if((X|0)<0)D=182;else{o=W+(X+4)|0;if(o>>>0>(c[d+20>>2]|0)>>>0){D=182;break}g[r>>2]=ea(g[Y>>2]);c[q>>2]=o}while(0);if((D|0)==182)Bid(q,r,4);if(c[d>>2]&512)c[r>>2]=XEi(c[r>>2]|0)|0}else{q=c[f>>2]|0;if(q)_n[q&4095](r,d)|0}sdd(d)}c[h>>2]=~~ea(g[r>>2]);r=b+208|0;h=qdd(d,723504,y,f,0)|0;if(h){do if((h|0)<=0){y=c[f>>2]|0;if(y)_n[y&4095](r,d)|0}else{y=d+12|0;q=c[d+16>>2]|0;Y=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;X=q+Y|0;c[y>>2]=X;do if((Y|0)<0)D=193;else{W=q+(Y+4)|0;if(W>>>0>(c[d+20>>2]|0)>>>0){D=193;break}g[r>>2]=ea(g[X>>2]);c[y>>2]=W}while(0);if((D|0)==193)Bid(y,r,4);if(!(c[d>>2]&512))break;c[r>>2]=XEi(c[r>>2]|0)|0}while(0);sdd(d)}r=b+204|0;h=qdd(d,723520,c[142304]|0,f,0)|0;if(h){do if((h|0)>0){X=d+12|0;Y=c[d+16>>2]|0;q=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;B=Y+q|0;c[X>>2]=B;do if((q|0)<0)D=204;else{W=Y+(q+4)|0;if(W>>>0>(c[d+20>>2]|0)>>>0){D=204;break}c[r>>2]=c[B>>2];c[X>>2]=W}while(0);if((D|0)==204)Bid(X,r,4);if(!(c[d>>2]&512))break;c[r>>2]=XEi(c[r>>2]|0)|0}else{B=c[f>>2]|0;if(!B)break;_n[B&4095](r,d)|0}while(0);sdd(d)}r=b+132|0;h=qdd(d,723536,C,f,1)|0;if(h){do if((h|0)>0)M6d(d,r,0);else{B=c[f>>2]|0;if(!B)break;_n[B&4095](r,d)|0}while(0);sdd(d)}r=b+144|0;h=qdd(d,723552,C,f,1)|0;if(h){do if((h|0)>0)N6d(d,r,0);else{C=c[f>>2]|0;if(!C)break;_n[C&4095](r,d)|0}while(0);sdd(d)}r=b+212|0;b=qdd(d,723568,t,f,0)|0;if(!b){i=e;return}do if((b|0)>0){t=d+12|0;h=c[d+16>>2]|0;C=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;B=h+C|0;c[t>>2]=B;do if((C|0)<0)D=227;else{q=h+(C+4)|0;if(q>>>0>(c[d+20>>2]|0)>>>0){D=227;break}c[r>>2]=c[B>>2];c[t>>2]=q}while(0);if((D|0)==227)Bid(t,r,4);if(!(c[d>>2]&512))break;c[r>>2]=XEi(c[r>>2]|0)|0}else{B=c[f>>2]|0;if(!B)break;_n[B&4095](r,d)|0}while(0);sdd(d);i=e;return}function x6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=0,D=0,E=0,F=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+4|0;j=d;zWb(a,b);k=a+72|0;l=b+12|0;m=c[l>>2]|0;n=m+4|0;o=b+20|0;p=c[o>>2]|0;if(n>>>0>p>>>0){Bid(l,k,4);q=c[l>>2]|0;r=c[o>>2]|0}else{c[k>>2]=c[m>>2];c[l>>2]=n;q=n;r=p}p=a+60|0;n=q+4|0;if(n>>>0>r>>>0){Bid(l,p,4);s=c[l>>2]|0;t=c[o>>2]|0}else{g[p>>2]=ea(g[q>>2]);c[l>>2]=n;s=n;t=r}r=a+28|0;n=s+4|0;if(n>>>0>t>>>0){Bid(l,r,4);u=c[l>>2]|0;v=c[o>>2]|0}else{g[r>>2]=ea(g[s>>2]);c[l>>2]=n;u=n;v=t}t=a+64|0;n=u+4|0;if(n>>>0>v>>>0){Bid(l,t,4);w=c[l>>2]|0;x=c[o>>2]|0}else{c[t>>2]=c[u>>2];c[l>>2]=n;w=n;x=v}v=a+68|0;n=w+4|0;if(n>>>0>x>>>0){Bid(l,v,4);y=c[l>>2]|0;z=c[o>>2]|0}else{c[v>>2]=c[w>>2];c[l>>2]=n;y=n;z=x}x=a+76|0;n=y+4|0;if(n>>>0>z>>>0)Bid(l,x,4);else{c[x>>2]=c[y>>2];c[l>>2]=n}h7b(a+36|0,b);if((c[x>>2]|0)==-2){c[h>>2]=0;x=h+4|0;c[x>>2]=0;c[h+8>>2]=0;P6d(b,h,0);n=c[h>>2]|0;if(n){h=c[x>>2]|0;if((h|0)!=(n|0))c[x>>2]=h+(~(((h+-56-n|0)>>>0)/56|0)*56|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(n,e)}}else O6d(b,a+84|0,0);IYb(a+40|0,b);Q6d(b,a+44|0,0);e=a+80|0;n=c[l>>2]|0;f=n+4|0;if(f>>>0>(c[o>>2]|0)>>>0)Bid(l,e,4);else{g[e>>2]=ea(g[n>>2]);c[l>>2]=f}Ndd(b);R6d(b,a+120|0,0);Ndd(b);f=a+32|0;g[j>>2]=ea(c[f>>2]|0);n=c[l>>2]|0;e=n+4|0;h=c[o>>2]|0;if(e>>>0>h>>>0){Bid(l,j,4);A=ea(g[j>>2]);B=A;C=c[l>>2]|0;D=c[o>>2]|0}else{A=ea(g[n>>2]);g[j>>2]=A;c[l>>2]=e;B=A;C=e;D=h}c[f>>2]=~~B;f=a+208|0;h=C+4|0;if(h>>>0>D>>>0){Bid(l,f,4);E=c[l>>2]|0;F=c[o>>2]|0}else{g[f>>2]=ea(g[C>>2]);c[l>>2]=h;E=h;F=D}D=a+204|0;h=E+4|0;if(h>>>0>F>>>0)Bid(l,D,4);else{c[D>>2]=c[E>>2];c[l>>2]=h}S6d(b,a+132|0,0);T6d(b,a+144|0,0);Ndd(b);b=a+212|0;a=c[l>>2]|0;h=a+4|0;if(h>>>0>(c[o>>2]|0)>>>0){Bid(l,b,4);i=d;return}else{c[b>>2]=c[a>>2];c[l>>2]=h;i=d;return}}function y6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+4|0;j=d;AWb(a,b);l=a+72|0;m=b+12|0;n=c[m>>2]|0;o=n+4|0;p=b+20|0;q=c[p>>2]|0;if(o>>>0>q>>>0){Bid(m,l,4);r=c[m>>2]|0;s=c[p>>2]|0;t=c[l>>2]|0}else{u=c[n>>2]|0;c[l>>2]=u;c[m>>2]=o;r=o;s=q;t=u}c[l>>2]=XEi(t|0)|0;t=a+60|0;l=r+4|0;if(l>>>0>s>>>0){Bid(m,t,4);v=t;w=c[t>>2]|0;x=c[m>>2]|0;y=c[p>>2]|0}else{z=ea(g[r>>2]);g[t>>2]=z;c[m>>2]=l;v=t;w=(g[k>>2]=z,c[k>>2]|0);x=l;y=s}c[v>>2]=XEi(w|0)|0;w=a+28|0;v=x+4|0;if(v>>>0>y>>>0){Bid(m,w,4);A=w;B=c[w>>2]|0;C=c[m>>2]|0;D=c[p>>2]|0}else{z=ea(g[x>>2]);g[w>>2]=z;c[m>>2]=v;A=w;B=(g[k>>2]=z,c[k>>2]|0);C=v;D=y}c[A>>2]=XEi(B|0)|0;B=a+64|0;A=C+4|0;if(A>>>0>D>>>0){Bid(m,B,4);E=c[B>>2]|0;F=c[m>>2]|0;G=c[p>>2]|0}else{y=c[C>>2]|0;c[B>>2]=y;c[m>>2]=A;E=y;F=A;G=D}c[B>>2]=XEi(E|0)|0;E=a+68|0;B=F+4|0;if(B>>>0>G>>>0){Bid(m,E,4);H=c[E>>2]|0;I=c[m>>2]|0;J=c[p>>2]|0}else{D=c[F>>2]|0;c[E>>2]=D;c[m>>2]=B;H=D;I=B;J=G}c[E>>2]=XEi(H|0)|0;H=a+76|0;E=I+4|0;if(E>>>0>J>>>0){Bid(m,H,4);K=c[H>>2]|0}else{J=c[I>>2]|0;c[H>>2]=J;c[m>>2]=E;K=J}c[H>>2]=XEi(K|0)|0;i7b(a+36|0,b);if((c[H>>2]|0)==-2){c[h>>2]=0;H=h+4|0;c[H>>2]=0;c[h+8>>2]=0;V6d(b,h,0);K=c[h>>2]|0;if(K){h=c[H>>2]|0;if((h|0)!=(K|0))c[H>>2]=h+(~(((h+-56-K|0)>>>0)/56|0)*56|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(K,e)}}else U6d(b,a+84|0,0);LYb(a+40|0,b);W6d(b,a+44|0,0);e=a+80|0;K=c[m>>2]|0;f=K+4|0;if(f>>>0>(c[p>>2]|0)>>>0){Bid(m,e,4);L=e;M=c[e>>2]|0}else{z=ea(g[K>>2]);g[e>>2]=z;c[m>>2]=f;L=e;M=(g[k>>2]=z,c[k>>2]|0)}c[L>>2]=XEi(M|0)|0;Mdd(b);X6d(b,a+120|0,0);Mdd(b);M=a+32|0;g[j>>2]=ea(c[M>>2]|0);L=c[m>>2]|0;e=L+4|0;f=c[p>>2]|0;if(e>>>0>f>>>0){Bid(m,j,4);N=j;O=c[j>>2]|0;P=c[m>>2]|0;Q=c[p>>2]|0}else{z=ea(g[L>>2]);g[j>>2]=z;c[m>>2]=e;N=j;O=(g[k>>2]=z,c[k>>2]|0);P=e;Q=f}f=XEi(O|0)|0;c[N>>2]=f;c[M>>2]=~~(c[k>>2]=f,ea(g[k>>2]));f=a+208|0;M=P+4|0;if(M>>>0>Q>>>0){Bid(m,f,4);R=f;S=c[m>>2]|0;T=c[p>>2]|0;U=c[f>>2]|0}else{z=ea(g[P>>2]);g[f>>2]=z;c[m>>2]=M;R=f;S=M;T=Q;U=(g[k>>2]=z,c[k>>2]|0)}c[R>>2]=XEi(U|0)|0;U=a+204|0;R=S+4|0;if(R>>>0>T>>>0){Bid(m,U,4);V=c[U>>2]|0}else{T=c[S>>2]|0;c[U>>2]=T;c[m>>2]=R;V=T}c[U>>2]=XEi(V|0)|0;Y6d(b,a+132|0,0);Z6d(b,a+144|0,0);Mdd(b);b=a+212|0;a=c[m>>2]|0;V=a+4|0;if(V>>>0>(c[p>>2]|0)>>>0){Bid(m,b,4);W=c[b>>2]|0;X=XEi(W|0)|0;c[b>>2]=X;i=d;return}else{p=c[a>>2]|0;c[b>>2]=p;c[m>>2]=V;W=p;X=XEi(W|0)|0;c[b>>2]=X;i=d;return}}function z6d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;BWb(b,d);l=b+72|0;m=d+12|0;n=c[m>>2]|0;o=n+4|0;p=d+20|0;q=c[p>>2]|0;if(o>>>0<q>>>0){c[n>>2]=c[l>>2];c[m>>2]=o;r=o;s=q}else{Gid(m,l,4);r=c[m>>2]|0;s=c[p>>2]|0}l=b+60|0;q=r+4|0;if(q>>>0<s>>>0){g[r>>2]=ea(g[l>>2]);c[m>>2]=q;t=q;u=s}else{Gid(m,l,4);t=c[m>>2]|0;u=c[p>>2]|0}l=b+28|0;s=t+4|0;if(s>>>0<u>>>0){g[t>>2]=ea(g[l>>2]);c[m>>2]=s;v=s;w=u}else{Gid(m,l,4);v=c[m>>2]|0;w=c[p>>2]|0}l=b+64|0;u=v+4|0;if(u>>>0<w>>>0){c[v>>2]=c[l>>2];c[m>>2]=u;x=u;y=w}else{Gid(m,l,4);x=c[m>>2]|0;y=c[p>>2]|0}l=b+68|0;w=x+4|0;if(w>>>0<y>>>0){c[x>>2]=c[l>>2];c[m>>2]=w;z=w;A=y}else{Gid(m,l,4);z=c[m>>2]|0;A=c[p>>2]|0}l=b+76|0;y=z+4|0;if(y>>>0<A>>>0){c[z>>2]=c[l>>2];c[m>>2]=y}else Gid(m,l,4);j7b(b+36|0,d);do if((c[l>>2]|0)==-2){c[h>>2]=0;y=c[m>>2]|0;z=y+4|0;if(z>>>0<(c[p>>2]|0)>>>0){c[y>>2]=0;c[m>>2]=z;break}else{Gid(m,h,4);break}}else{z=b+88|0;y=c[z>>2]|0;A=b+84|0;w=c[A>>2]|0;x=(y-w|0)/56|0;c[j>>2]=x;u=c[m>>2]|0;v=u+4|0;if(v>>>0<(c[p>>2]|0)>>>0){c[u>>2]=x;c[m>>2]=v;B=w;C=y}else{Gid(m,j,4);B=c[A>>2]|0;C=c[z>>2]|0}if((B|0)!=(C|0)){z=B;do{_6d(z,d);z=z+56|0}while((z|0)!=(C|0))}}while(0);OYb(b+40|0,d);$6d(d,b+44|0,0);C=b+80|0;B=c[m>>2]|0;j=B+4|0;if(j>>>0<(c[p>>2]|0)>>>0){g[B>>2]=ea(g[C>>2]);c[m>>2]=j}else Gid(m,C,4);Tdd(d);C=b+124|0;j=c[C>>2]|0;B=b+120|0;h=c[B>>2]|0;l=j-h|0;c[f>>2]=l;z=c[m>>2]|0;A=z+4|0;if(A>>>0<(c[p>>2]|0)>>>0){c[z>>2]=l;c[m>>2]=A;D=h;E=j}else{Gid(m,f,4);D=c[B>>2]|0;E=c[C>>2]|0}if((D|0)!=(E|0)){C=D;do{D=c[m>>2]|0;if((D+1|0)>>>0<(c[p>>2]|0)>>>0){a[D>>0]=a[C>>0]|0;c[m>>2]=(c[m>>2]|0)+1}else Gid(m,C,1);C=C+1|0}while((C|0)!=(E|0))}Tdd(d);E=b+32|0;F=ea(c[E>>2]|0);g[k>>2]=F;C=c[m>>2]|0;D=C+4|0;B=c[p>>2]|0;if(D>>>0<B>>>0){g[C>>2]=F;c[m>>2]=D;G=D;H=B}else{Gid(m,k,4);G=c[m>>2]|0;H=c[p>>2]|0}c[E>>2]=~~ea(g[k>>2]);k=b+208|0;E=G+4|0;if(E>>>0<H>>>0){g[G>>2]=ea(g[k>>2]);c[m>>2]=E;I=E;J=H}else{Gid(m,k,4);I=c[m>>2]|0;J=c[p>>2]|0}k=b+204|0;H=I+4|0;if(H>>>0<J>>>0){c[I>>2]=c[k>>2];c[m>>2]=H;K=H;L=J}else{Gid(m,k,4);K=c[m>>2]|0;L=c[p>>2]|0}k=b+136|0;J=c[k>>2]|0;H=b+132|0;I=c[H>>2]|0;E=(J-I|0)/12|0;c[f>>2]=E;G=K+4|0;if(G>>>0<L>>>0){c[K>>2]=E;c[m>>2]=G;M=I;N=J}else{Gid(m,f,4);M=c[H>>2]|0;N=c[k>>2]|0}if((M|0)!=(N|0)){k=M;do{FXb(d,k,3142592,0);k=k+12|0}while((k|0)!=(N|0))}N=b+148|0;k=c[N>>2]|0;M=b+144|0;H=c[M>>2]|0;J=k-H>>2;c[f>>2]=J;I=c[m>>2]|0;G=I+4|0;if(G>>>0<(c[p>>2]|0)>>>0){c[I>>2]=J;c[m>>2]=G;O=H;P=k}else{Gid(m,f,4);O=c[M>>2]|0;P=c[N>>2]|0}if((O|0)!=(P|0)){N=O;do{a7d(N,d);N=N+4|0}while((N|0)!=(P|0))}Tdd(d);d=b+212|0;b=c[m>>2]|0;P=b+4|0;if(P>>>0<(c[p>>2]|0)>>>0){c[b>>2]=c[d>>2];c[m>>2]=P;i=e;return}else{Gid(m,d,4);i=e;return}}function A6d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;CWb(b,d);f=b+36|0;g=d+12|0;h=c[g>>2]|0;j=d+28|0;k=xo[c[c[h>>2]>>2]&2047](h,c[f>>2]|0,c[j>>2]|0)|0;h=d+32|0;if(a[h>>0]|0)c[f>>2]=k;idd(d,1);k=b+40|0;f=c[g>>2]|0;l=xo[c[c[f>>2]>>2]&2047](f,c[k>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[k>>2]=l;jdd(d);l=b+32|0;c[l>>2]=~~ea(c[l>>2]|0);idd(d,1);l=c[b+144>>2]|0;k=c[b+148>>2]|0;if((l|0)==(k|0)){jdd(d);i=e;return}else m=l;do{l=c[g>>2]|0;b=xo[c[c[l>>2]>>2]&2047](l,c[m>>2]|0,c[j>>2]|0)|0;if(a[h>>0]|0)c[m>>2]=b;m=m+4|0}while((m|0)!=(k|0));jdd(d);i=e;return}function B6d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+4|0;f=d+16|0;g=d+8|0;h=d+20|0;j=d+28|0;k=d;l=d+12|0;m=d+24|0;c[b>>2]=722880;n=b+216|0;o=c[n>>2]|0;p=c[153096]|0;if(o)t5d(o);c[f>>2]=p;c[e+0>>2]=c[f+0>>2];eOb(o,e);c[n>>2]=0;o6d(b+168|0,c[b+172>>2]|0);n=c[b+156>>2]|0;if(n){o=b+160|0;p=c[o>>2]|0;if((p|0)!=(n|0))c[o>>2]=p+(~((p+-16-n|0)>>>4)<<4);c[m>>2]=27;c[e+0>>2]=c[m+0>>2];eOb(n,e)}n=c[b+144>>2]|0;if(n){m=b+148|0;p=c[m>>2]|0;if((p|0)!=(n|0))c[m>>2]=p+(~((p+-4-n|0)>>>2)<<2);c[l>>2]=27;c[e+0>>2]=c[l+0>>2];eOb(n,e)}n=b+132|0;l=c[n>>2]|0;if(l){p=b+136|0;m=c[p>>2]|0;if((m|0)==(l|0))q=l;else{o=m;while(1){m=o+-12|0;c[p>>2]=m;if(!(a[m>>0]&1))r=m;else{m=c[o+-4>>2]|0;c[j>>2]=58;c[e+0>>2]=c[j+0>>2];eOb(m,e);r=c[p>>2]|0}if((r|0)==(l|0))break;else o=r}q=c[n>>2]|0}c[k>>2]=27;c[e+0>>2]=c[k+0>>2];eOb(q,e)}q=c[b+120>>2]|0;if(q){k=b+124|0;if((c[k>>2]|0)!=(q|0))c[k>>2]=q;c[h>>2]=27;c[e+0>>2]=c[h+0>>2];eOb(q,e)}q=c[b+108>>2]|0;if(q){h=b+112|0;k=c[h>>2]|0;if((k|0)!=(q|0))c[h>>2]=k+(~(((k+-56-q|0)>>>0)/56|0)*56|0);c[g>>2]=27;c[e+0>>2]=c[g+0>>2];eOb(q,e)}q=c[b+96>>2]|0;if(q){g=b+100|0;k=c[g>>2]|0;if((k|0)!=(q|0))c[g>>2]=k+(~(((k+-56-q|0)>>>0)/56|0)*56|0);ACi(q)}q=c[b+84>>2]|0;if(q){k=b+88|0;g=c[k>>2]|0;if((g|0)!=(q|0))c[k>>2]=g+(~(((g+-56-q|0)>>>0)/56|0)*56|0);c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(q,e)}e=c[b+48>>2]|0;if(!e){EWb(b);i=d;return}q=b+52|0;f=c[q>>2]|0;if((f|0)!=(e|0))c[q>>2]=f+(~((f+-8-e|0)>>>3)<<3);ACi(e);EWb(b);i=d;return}function C6d(a){a=a|0;var b=0;b=i;B6d(a);ACi(a);i=b;return}function D6d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;h=c[d>>2]|0;j=h;k=((c[e>>2]|0)-j|0)/56|0;e=h+(k*56|0)|0;l=d+4|0;m=c[l>>2]|0;n=d+8|0;o=c[n>>2]|0;if(m>>>0<o>>>0){if((e|0)==(m|0)){if(!e)p=0;else{q=e+0|0;r=f+0|0;s=q+56|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));p=c[l>>2]|0}c[l>>2]=p+56;t=e;c[b>>2]=t;i=g;return}p=m-(h+((k+1|0)*56|0))|0;u=h+((((p|0)/56|0)+k|0)*56|0)|0;if(u>>>0<m>>>0){k=m;v=u;do{if(!k)w=0;else{q=k+0|0;r=v+0|0;s=q+56|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));w=c[l>>2]|0}v=v+56|0;k=w+56|0;c[l>>2]=k}while(v>>>0<m>>>0)}aFi(m+(((p|0)/-56|0)*56|0)|0,e|0,p|0)|0;if(e>>>0>f>>>0)x=f;else x=(c[l>>2]|0)>>>0>f>>>0?f+56|0:f;q=e+0|0;r=x+0|0;s=q+52|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));a[e+52>>0]=a[x+52>>0]|0;t=e;c[b>>2]=t;i=g;return}x=((m-j|0)/56|0)+1|0;if(x>>>0>76695844)vxi(d);j=h;h=(o-j|0)/56|0;if(h>>>0<38347922){o=h<<1;h=o>>>0<x>>>0?x:o;o=e;x=(o-j|0)/56|0;if(!h){y=0;z=0;A=x;B=o}else{C=h;D=x;E=o;F=18}}else{o=e;C=76695844;D=(o-j|0)/56|0;E=o;F=18}if((F|0)==18){y=C;z=xCi(C*56|0)|0;A=D;B=E}E=z+(A*56|0)|0;D=z+(y*56|0)|0;do if((A|0)==(y|0)){C=(A*56|0)/56|0;if((A|0)>0){G=z+((((C+1|0)/-2|0)+A|0)*56|0)|0;H=D;break}F=C<<1;C=(F|0)==0?1:F;F=xCi(C*56|0)|0;o=F+((C>>>2)*56|0)|0;j=F+(C*56|0)|0;if(!z){G=o;H=j}else{ACi(z);G=o;H=j}}else{G=E;H=D}while(0);if(!G)I=0;else{q=G+0|0;r=f+0|0;s=q+56|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));I=G}r=c[d>>2]|0;q=B-r|0;s=G+(((q|0)/-56|0)*56|0)|0;YEi(s|0,r|0,q|0)|0;q=(c[l>>2]|0)-B|0;YEi(I+56|0,e|0,q|0)|0;e=c[d>>2]|0;c[d>>2]=s;c[l>>2]=I+((((q|0)/56|0)+1|0)*56|0);c[n>>2]=H;if(!e){t=G;c[b>>2]=t;i=g;return}ACi(e);t=G;c[b>>2]=t;i=g;return}function E6d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=c[b>>2]|0;if(!h){i=d;return}j=b+4|0;k=c[j>>2]|0;if((k|0)==(h|0))l=h;else{m=k;while(1){k=m+-12|0;c[j>>2]=k;if(!(a[k>>0]&1))n=k;else{k=c[m+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);n=c[j>>2]|0}if((n|0)==(h|0))break;else m=n}l=c[b>>2]|0}c[g>>2]=27;c[e+0>>2]=c[g+0>>2];eOb(l,e);c[b+8>>2]=0;c[j>>2]=0;c[b>>2]=0;i=d;return}function F6d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;ddd(b,2);add(b,2984400,c[142304]|0,a,0);e=b+12|0;f=b+20|0;c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);g=a+4|0;h=c[142280]|0;add(b,2493952,h,g,0);FYb(g,b);bdd(b);g=a+20|0;add(b,2494e3,h,g,0);FYb(g,b);bdd(b);add(b,2684928,c[142268]|0,a+36|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,2494136,c[142258]|0,a+52|0,0);c[(c[c[e>>2]>>2]|0)+((c[f>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);i=d;return}function G6d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g;add(b,e,c[142306]|0,d,f);c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;$cd(b,2646336,2646336,g+12|0,0);add(b,3142592,c[142294]|0,k,0);$cd(b,2646336,2646336,h,1);add(b,3142592,c[142260]|0,j,0);c[(c[c[b+12>>2]>>2]|0)+((c[b+20>>2]|0)*24|0)+12>>2]=1;bdd(b);cdd(b);fdd(b);bdd(b);cdd(b);if(!(a[k>>0]&1)){bdd(b);i=g;return}f=c[k+8>>2]|0;c[j>>2]=58;c[h+0>>2]=c[j+0>>2];eOb(f,h);bdd(b);i=g;return}function H6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/56|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}b7d(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,2495816,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;c7d(r,a);t=r+56|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,2495816,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else c7d(m,a);sdd(a)}m=m+56|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function I6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/56|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}d7d(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,2495816,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;c7d(r,a);t=r+56|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,2495816,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else c7d(m,a);sdd(a)}m=m+56|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function J6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+8|0;j=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[j>>2]|0)>>3;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k=c[f>>2]|0;l=b+4|0;b=c[h>>2]|0;m=c[l>>2]|0;n=b-m>>3;if(k>>>0<=n>>>0)if(k>>>0<n>>>0?(o=m+(k<<3)|0,(b|0)!=(o|0)):0){m=b+(~((b+-8-o|0)>>>3)<<3)|0;c[h>>2]=m;p=k;q=m}else{p=k;q=b}else{e7d(l,k-n|0);p=c[f>>2]|0;q=c[h>>2]|0}do if(p){h=c[142274]|0;f=qdd(a,3142592,h,0,1)|0;n=a+80|0;k=c[($hd(c[n>>2]|0)|0)+12>>2]|0;l=a+84|0;c[c[l>>2]>>2]=0;if((f|0)==2){f=c[n>>2]|0;b=c[f+12>>2]|0;m=c[j>>2]|0;a:do if((m|0)!=(q|0)){o=0;r=f;s=m;while(1){t=(da(o,k)|0)+b|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[l>>2]|0;c[u>>2]=(c[u>>2]|0)+1;f7d(s,a);u=s+8|0;if((u|0)==(q|0))break a;o=c[c[l>>2]>>2]|0;r=c[n>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);n=c[j>>2]|0;if((n|0)!=(q|0)){l=n;do{n=qdd(a,3142592,h,e,1)|0;if(n){if((n|0)<=0){n=c[e>>2]|0;if(n)_n[n&4095](l,a)|0}else f7d(l,a);sdd(a)}l=l+8|0}while((l|0)!=(q|0))}}while(0);udd(a);i=d;return}function K6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>3;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}g7d(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142274]|0;k=qdd(a,3142592,h,0,1)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;h7d(s,a);u=s+8|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,1)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else h7d(n,a);sdd(a)}n=n+8|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function L6d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d+4|0;c[f>>2]=(c[h>>2]|0)-(c[d>>2]|0);if(!(tdd(b,2646336,2646336,f)|0)){i=e;return}i7d(d,c[f>>2]|0);j=c[h>>2]|0;a:do if(c[f>>2]|0){h=qdd(b,3142592,c[142260]|0,0,0)|0;k=b+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=b+84|0;c[c[m>>2]>>2]=0;if((h|0)!=2){sdd(b);h=c[d>>2]|0;if((h|0)==(j|0))break;else n=h;while(1){kVb(b,n,3142592,0);n=n+1|0;if((n|0)==(j|0))break a}}h=c[k>>2]|0;o=c[h+12>>2]|0;p=c[d>>2]|0;b:do if((p|0)!=(j|0)){q=b+12|0;r=b+16|0;s=b+28|0;t=b+32|0;u=b+20|0;v=0;w=h;x=p;while(1){y=(da(v,l)|0)+o|0;c[w+20>>2]=y;c[w+12>>2]=y;cid(g,w);y=g;z=c[y+4>>2]|0;A=w+24|0;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=c[m>>2]|0;c[z>>2]=(c[z>>2]|0)+1;z=c[r>>2]|0;A=(c[(c[k>>2]|0)+12>>2]|0)-(da(c[t>>2]|0,c[s>>2]|0)|0)|0;y=z+A|0;c[q>>2]=y;if((A|0)>=0?(z+(A+1)|0)>>>0<=(c[u>>2]|0)>>>0:0){a[x>>0]=a[y>>0]|0;c[q>>2]=(c[q>>2]|0)+1}else Bid(q,x,1);y=x+1|0;if((y|0)==(j|0))break b;v=c[c[m>>2]>>2]|0;w=c[k>>2]|0;x=y}}while(0);sdd(b)}while(0);udd(b);i=e;return}function M6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=((c[h>>2]|0)-(c[b>>2]|0)|0)/12|0;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}j7d(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=c[142294]|0;k=qdd(a,3142592,h,0,0)|0;l=a+80|0;m=c[($hd(c[l>>2]|0)|0)+12>>2]|0;n=a+84|0;c[c[n>>2]>>2]=0;if((k|0)==2){k=c[l>>2]|0;o=c[k+12>>2]|0;p=c[b>>2]|0;a:do if((p|0)!=(j|0)){q=0;r=k;s=p;while(1){t=(da(q,m)|0)+o|0;c[r+20>>2]=t;c[r+12>>2]=t;cid(g,r);t=g;u=c[t+4>>2]|0;v=r+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;u=c[n>>2]|0;c[u>>2]=(c[u>>2]|0)+1;zXb(a,s,1);u=s+12|0;if((u|0)==(j|0))break a;q=c[c[n>>2]>>2]|0;r=c[l>>2]|0;s=u}}while(0);sdd(a);break}sdd(a);l=c[b>>2]|0;if((l|0)!=(j|0)){n=l;do{l=qdd(a,3142592,h,e,0)|0;if(l){if((l|0)<=0){l=c[e>>2]|0;if(l)_n[l&4095](n,a)|0}else zXb(a,n,1);sdd(a)}n=n+12|0}while((n|0)!=(j|0))}}while(0);udd(a);i=d;return}function N6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;h=b+4|0;c[f>>2]=(c[h>>2]|0)-(c[b>>2]|0)>>2;if(!(tdd(a,2646336,2646336,f)|0)){i=d;return}k7d(b,c[f>>2]|0);j=c[h>>2]|0;do if(c[f>>2]|0){h=qdd(a,3142592,723592,0,1)|0;k=a+80|0;l=c[($hd(c[k>>2]|0)|0)+12>>2]|0;m=a+84|0;c[c[m>>2]>>2]=0;if((h|0)==2){h=c[k>>2]|0;n=c[h+12>>2]|0;o=c[b>>2]|0;a:do if((o|0)!=(j|0)){p=0;q=h;r=o;while(1){s=(da(p,l)|0)+n|0;c[q+20>>2]=s;c[q+12>>2]=s;cid(g,q);s=g;t=c[s+4>>2]|0;u=q+24|0;c[u>>2]=c[s>>2];c[u+4>>2]=t;t=c[m>>2]|0;c[t>>2]=(c[t>>2]|0)+1;l7d(r,a);t=r+4|0;if((t|0)==(j|0))break a;p=c[c[m>>2]>>2]|0;q=c[k>>2]|0;r=t}}while(0);sdd(a);break}sdd(a);k=c[b>>2]|0;if((k|0)!=(j|0)){m=k;do{k=qdd(a,3142592,723592,e,1)|0;if(k){if((k|0)<=0){k=c[e>>2]|0;if(k)_n[k&4095](m,a)|0}else l7d(m,a);sdd(a)}m=m+4|0}while((m|0)!=(j|0))}}while(0);udd(a);i=d;return}function O6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}b7d(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{m7d(r,a);r=r+56|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*56|0)|0;c[j>>2]=0;i=d;return}function P6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}d7d(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{m7d(r,a);r=r+56|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*56|0)|0;c[j>>2]=0;i=d;return}function Q6d(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e+8|0;h=e+4|0;j=e;k=a+12|0;l=a+48|0;m=c[k>>2]|0;n=m+4|0;o=a+20|0;a=c[o>>2]|0;p=n>>>0>a>>>0;if(c[l>>2]|0){if(p){Bid(k,h,4);q=c[k>>2]|0;r=c[o>>2]|0}else{c[h>>2]=c[m>>2];c[k>>2]=n;q=n;r=a}a=q+4|0;if(a>>>0>r>>>0){Bid(k,f,4);s=c[f>>2]|0}else{r=c[q>>2]|0;c[f>>2]=r;c[k>>2]=a;s=r}zid(k,s,c[h>>2]<<3)|0;c[l>>2]=0;i=e;return}if(p){Bid(k,j,4);t=c[j>>2]|0}else{p=c[m>>2]|0;c[j>>2]=p;c[k>>2]=n;t=p}p=d+4|0;n=d+8|0;j=c[n>>2]|0;m=c[p>>2]|0;l=j-m>>3;if(t>>>0<=l>>>0)if(t>>>0<l>>>0?(h=m+(t<<3)|0,(j|0)!=(h|0)):0){s=j+(~((j+-8-h|0)>>>3)<<3)|0;c[n>>2]=s;u=m;v=s}else{u=m;v=j}else{e7d(p,t-l|0);u=c[d+4>>2]|0;v=c[n>>2]|0}if((u|0)==(v|0)){i=e;return}else w=u;do{u=c[k>>2]|0;n=u+2|0;d=c[o>>2]|0;if(n>>>0>d>>>0){Bid(k,w,2);x=c[k>>2]|0;y=c[o>>2]|0}else{b[w>>1]=b[u>>1]|0;c[k>>2]=n;x=n;y=d}d=w+2|0;n=x+2|0;if(n>>>0>y>>>0){Bid(k,d,2);z=c[k>>2]|0;A=c[o>>2]|0}else{b[d>>1]=b[x>>1]|0;c[k>>2]=n;z=n;A=y}n=w+4|0;d=z+4|0;if(d>>>0>A>>>0)Bid(k,n,4);else{g[n>>2]=ea(g[z>>2]);c[k>>2]=d}w=w+8|0}while((w|0)!=(v|0));i=e;return}function R6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}i7d(b,p);p=c[g>>2]|0;if(!p){i=d;return}Ldd(a,c[b>>2]|0,p);i=d;return}if(o){Bid(h,f,4);r=c[h>>2]|0;s=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;r=l;s=n}n=r+4|0;if(n>>>0>s>>>0){Bid(h,e,4);t=c[e>>2]|0}else{s=c[r>>2]|0;c[e>>2]=s;c[h>>2]=n;t=s}zid(h,t,c[f>>2]|0)|0;c[j>>2]=0;i=d;return}function S6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}j7d(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{NXb(a,r,1);Ndd(a);r=r+12|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,(c[f>>2]|0)*12|0)|0;c[j>>2]=0;i=d;return}function T6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}k7d(b,p);p=c[b+4>>2]|0;q=c[b>>2]|0;if((q|0)==(p|0)){i=d;return}else r=q;do{n7d(r,a);r=r+4|0}while((r|0)!=(p|0));i=d;return}if(o){Bid(h,f,4);s=c[h>>2]|0;t=c[m>>2]|0}else{c[f>>2]=c[k>>2];c[h>>2]=l;s=l;t=n}n=s+4|0;if(n>>>0>t>>>0){Bid(h,e,4);u=c[e>>2]|0}else{t=c[s>>2]|0;c[e>>2]=t;c[h>>2]=n;u=t}zid(h,u,c[f>>2]<<2)|0;c[j>>2]=0;i=d;return}function U6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;b7d(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{o7d(r,a);r=r+56|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*56|0)|0;c[j>>2]=0;i=d;return}function V6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;d7d(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{o7d(r,a);r=r+56|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*56|0)|0;c[j>>2]=0;i=d;return}function W6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(c[j>>2]|0){if(o){Bid(h,f,4);p=c[f>>2]|0;q=c[h>>2]|0;r=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;p=m;q=l;r=n}n=XEi(p|0)|0;c[f>>2]=n;p=q+4|0;if(p>>>0>r>>>0){Bid(h,e,4);s=c[e>>2]|0;t=c[f>>2]|0}else{f=c[q>>2]|0;c[e>>2]=f;c[h>>2]=p;s=f;t=n}n=XEi(s|0)|0;c[e>>2]=n;zid(h,n,t<<3)|0;c[j>>2]=0;i=d;return}if(o){Bid(h,g,4);u=c[g>>2]|0}else{o=c[k>>2]|0;c[g>>2]=o;c[h>>2]=l;u=o}o=XEi(u|0)|0;c[g>>2]=o;g=b+4|0;u=b+8|0;l=c[u>>2]|0;h=c[g>>2]|0;k=l-h>>3;if(o>>>0<=k>>>0)if(o>>>0<k>>>0?(j=h+(o<<3)|0,(l|0)!=(j|0)):0){t=l+(~((l+-8-j|0)>>>3)<<3)|0;c[u>>2]=t;v=h;w=t}else{v=h;w=l}else{e7d(g,o-k|0);v=c[b+4>>2]|0;w=c[u>>2]|0}if((v|0)==(w|0)){i=d;return}else x=v;do{p7d(a,x,3142592,0);x=x+8|0}while((x|0)!=(w|0));i=d;return}function X6d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+12|0;k=b+48|0;l=c[j>>2]|0;m=l+4|0;n=b+20|0;b=c[n>>2]|0;o=m>>>0>b>>>0;if(c[k>>2]|0){if(o){Bid(j,g,4);p=c[g>>2]|0;q=c[j>>2]|0;r=c[n>>2]|0}else{s=c[l>>2]|0;c[g>>2]=s;c[j>>2]=m;p=s;q=m;r=b}b=XEi(p|0)|0;c[g>>2]=b;p=q+4|0;if(p>>>0>r>>>0){Bid(j,f,4);t=c[f>>2]|0;u=c[g>>2]|0}else{g=c[q>>2]|0;c[f>>2]=g;c[j>>2]=p;t=g;u=b}b=XEi(t|0)|0;c[f>>2]=b;zid(j,b,u)|0;c[k>>2]=0;i=e;return}if(o){Bid(j,h,4);v=c[h>>2]|0}else{o=c[l>>2]|0;c[h>>2]=o;c[j>>2]=m;v=o}o=XEi(v|0)|0;c[h>>2]=o;i7d(d,o);o=c[d+4>>2]|0;h=c[d>>2]|0;if((h|0)==(o|0)){i=e;return}else w=h;do{h=c[j>>2]|0;if((h+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(j,w,1);else{a[w>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}w=w+1|0}while((w|0)!=(o|0));i=e;return}function Y6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;j7d(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{OXb(a,r,1);Mdd(a);r=r+12|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w*12|0)|0;c[j>>2]=0;i=d;return}function Z6d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=a+12|0;j=a+48|0;k=c[h>>2]|0;l=k+4|0;m=a+20|0;n=c[m>>2]|0;o=l>>>0>n>>>0;if(!(c[j>>2]|0)){if(o){Bid(h,g,4);p=c[g>>2]|0}else{q=c[k>>2]|0;c[g>>2]=q;c[h>>2]=l;p=q}q=XEi(p|0)|0;c[g>>2]=q;k7d(b,q);q=c[b+4>>2]|0;g=c[b>>2]|0;if((g|0)==(q|0)){i=d;return}else r=g;do{q7d(r,a);r=r+4|0}while((r|0)!=(q|0));i=d;return}if(o){Bid(h,f,4);s=c[f>>2]|0;t=c[h>>2]|0;u=c[m>>2]|0}else{m=c[k>>2]|0;c[f>>2]=m;c[h>>2]=l;s=m;t=l;u=n}n=XEi(s|0)|0;c[f>>2]=n;s=t+4|0;if(s>>>0>u>>>0){Bid(h,e,4);v=c[e>>2]|0;w=c[f>>2]|0}else{f=c[t>>2]|0;c[e>>2]=f;c[h>>2]=s;v=f;w=n}n=XEi(v|0)|0;c[e>>2]=n;zid(h,n,w<<2)|0;c[j>>2]=0;i=d;return}function _6d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0<(c[k>>2]|0)>>>0){c[h>>2]=c[b>>2];c[f>>2]=j}else Gid(f,b,4);QYb(d,b+4|0,2493952,0);QYb(d,b+20|0,2494e3,0);j=b+36|0;h=c[f>>2]|0;l=h+4|0;m=c[k>>2]|0;if(l>>>0<m>>>0){g[h>>2]=ea(g[j>>2]);c[f>>2]=l;n=l;o=m}else{Gid(f,j,4);n=c[f>>2]|0;o=c[k>>2]|0}k=b+52|0;if((n+1|0)>>>0<o>>>0){a[n>>0]=a[k>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Tdd(d);i=e;return}else{Gid(f,k,1);Tdd(d);i=e;return}}function $6d(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+16|0;f=e;h=d+8|0;j=c[h>>2]|0;k=d+4|0;d=c[k>>2]|0;l=j-d>>3;c[f>>2]=l;m=a+12|0;n=c[m>>2]|0;o=n+4|0;p=a+20|0;if(o>>>0<(c[p>>2]|0)>>>0){c[n>>2]=l;c[m>>2]=o;q=d;r=j}else{Gid(m,f,4);q=c[k>>2]|0;r=c[h>>2]|0}if((q|0)==(r|0)){i=e;return}else s=q;do{q=c[m>>2]|0;h=q+2|0;k=c[p>>2]|0;if(h>>>0<k>>>0){b[q>>1]=b[s>>1]|0;c[m>>2]=h;t=h;u=k}else{Gid(m,s,2);t=c[m>>2]|0;u=c[p>>2]|0}k=s+2|0;h=t+2|0;if(h>>>0<u>>>0){b[t>>1]=b[k>>1]|0;c[m>>2]=h;v=h;w=u}else{Gid(m,k,2);v=c[m>>2]|0;w=c[p>>2]|0}k=s+4|0;h=v+4|0;if(h>>>0<w>>>0){g[v>>2]=ea(g[k>>2]);c[m>>2]=h}else Gid(m,k,4);s=s+8|0}while((s|0)!=(r|0));i=e;return}function a7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function b7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=((c[q>>2]|0)-s|0)/56|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b*56|0);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];s7d(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~(((r+-56-o|0)>>>0)/56|0)*56|0);c[h>>2]=27;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if((((c[o>>2]|0)-s|0)/56|0|0)==(b|0)){m6d(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=27,c[e+0>>2]=c[f+0>>2],h=cOb(b*56|0,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(((p|0)/-56|0)*56|0)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b*56|0),(p|0)!=0):0){c[g>>2]=27;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];r7d(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=(l-k|0)/56|0;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b*56|0)|0,(l|0)!=(g|0)):0){h=l+(~(((l+-56-g|0)>>>0)/56|0)*56|0)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{m6d(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~(((v+-56-p|0)>>>0)/56|0)*56|0);c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function c7d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;rdd(d,2);h=qdd(d,2984400,c[142304]|0,f,0)|0;if(h){if((h|0)>0){h=d+12|0;j=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[d+20>>2]|0)>>>0):0){c[b>>2]=c[l>>2];c[h>>2]=m}else Bid(h,b,4);if(c[d>>2]&512)c[b>>2]=XEi(c[b>>2]|0)|0}else{h=c[f>>2]|0;if(h)_n[h&4095](b,d)|0}sdd(d)}xDc(d,b+4|0,2493952,0);xDc(d,b+20|0,2494e3,0);h=b+36|0;m=qdd(d,2684928,c[142268]|0,f,0)|0;if(m){if((m|0)>0){m=d+12|0;l=c[d+16>>2]|0;k=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;j=l+k|0;c[m>>2]=j;if((k|0)>=0?(n=l+(k+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[j>>2]);c[m>>2]=n}else Bid(m,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{m=c[f>>2]|0;if(m)_n[m&4095](h,d)|0}sdd(d)}m=b+52|0;n=qdd(d,2494136,c[142258]|0,f,0)|0;if(n){do if((n|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](m,d)|0}else{j=d+12|0;k=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=k+l|0;c[j>>2]=o;if((l|0)>=0?(k+(l+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[m>>0]=a[o>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,m,1)}while(0);sdd(d)}if(vdd(d)|0){i=e;return}g[h>>2]=ea(g[b+28>>2]);i=e;return}function d7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=((c[q>>2]|0)-s|0)/56|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b*56|0);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];v7d(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~(((r+-56-o|0)>>>0)/56|0)*56|0);c[h>>2]=89;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if((((c[o>>2]|0)-s|0)/56|0|0)==(b|0)){u7d(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=89,c[e+0>>2]=c[f+0>>2],h=cOb(b*56|0,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(((p|0)/-56|0)*56|0)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b*56|0),(p|0)!=0):0){c[g>>2]=89;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];t7d(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=(l-k|0)/56|0;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b*56|0)|0,(l|0)!=(g|0)):0){h=l+(~(((l+-56-g|0)>>>0)/56|0)*56|0)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{u7d(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~(((v+-56-p|0)>>>0)/56|0)*56|0);c[f>>2]=89;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function e7d(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8|0;h=c[f>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>3>>>0>=d>>>0){m=d;n=k;while(1){if(n){b[n>>1]=0;b[n+2>>1]=0;g[n+4>>2]=ea(0.0)}m=m+-1|0;if(!m)break;else n=n+8|0}c[j>>2]=k+(d<<3);i=e;return}k=c[a>>2]|0;n=(l-k>>3)+d|0;if(n>>>0>536870911)vxi(a);l=k;m=h-l|0;if(m>>3>>>0<268435455){h=m>>2;m=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l|0;n=h>>3;if(!m){o=0;p=0;q=n;r=h}else{s=m;t=n;u=h;v=11}}else{h=(c[j>>2]|0)-l|0;s=536870911;t=h>>3;u=h;v=11}if((v|0)==11){o=s;p=xCi(s<<3)|0;q=t;r=u}u=d;t=p+(q<<3)|0;while(1){if(t){b[t>>1]=0;b[t+2>>1]=0;g[t+4>>2]=ea(0.0)}u=u+-1|0;if(!u)break;else t=t+8|0}YEi(p|0,k|0,r|0)|0;r=c[a>>2]|0;c[a>>2]=p;c[j>>2]=p+(q+d<<3);c[f>>2]=p+(o<<3);if(!r){i=e;return}ACi(r);i=e;return}function f7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=c[142266]|0;h=qdd(b,f,c[142274]|0,e,1)|0;if(h){if((h|0)<=0){h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}else{AUb(b,a,f,0);AUb(b,a+2|0,c[142282]|0,0)}sdd(b)}f=a+4|0;a=qdd(b,c[142282]|0,c[142268]|0,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[a>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){g[f>>2]=ea(g[k>>2]);c[a>>2]=l}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function g7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s>>3;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+(b<<3);c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];y7d(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=r+(~((r+-8-o|0)>>>3)<<3);c[h>>2]=27;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s>>3|0)==(b|0)){x7d(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=27,c[e+0>>2]=c[f+0>>2],h=cOb(b<<3,16,e,0,3653512,80)|0,r=c[j>>2]|0,p=(c[t>>2]|0)-r|0,u=h+(0-(p>>3)<<3)|0,YEi(u|0,r|0,p|0)|0,p=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+(b<<3),(p|0)!=0):0){c[g>>2]=27;c[e+0>>2]=c[g+0>>2];eOb(p,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];w7d(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;p=l-k>>3;if(p>>>0>=b>>>0)if(p>>>0>b>>>0?(g=k+(b<<3)|0,(l|0)!=(g|0)):0){h=l+(~((l+-8-g|0)>>>3)<<3)|0;c[t>>2]=h;v=k;w=h}else{v=k;w=l}else{x7d(j,b-p|0);v=c[j>>2]|0;w=c[t>>2]|0}p=c[a>>2]|0;c[j>>2]=p;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!p){i=d;return}if((v|0)!=(p|0))c[t>>2]=v+(~((v+-8-p|0)>>>3)<<3);c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(p,e);i=d;return}function h7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=qdd(b,c[142266]|0,c[142270]|0,e,0)|0;if(f){if((f|0)>0){f=b+12|0;h=c[b+16>>2]|0;j=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=h+j|0;c[f>>2]=k;if((j|0)>=0?(l=h+(j+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[k>>2];c[f>>2]=l}else Bid(f,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}sdd(b)}f=a+4|0;a=qdd(b,c[142282]|0,c[142268]|0,e,0)|0;if(!a){i=d;return}if((a|0)>0){a=b+12|0;l=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;j=l+k|0;c[a>>2]=j;if((k|0)>=0?(h=l+(k+4)|0,h>>>0<=(c[b+20>>2]|0)>>>0):0){g[f>>2]=ea(g[j>>2]);c[a>>2]=h}else Bid(a,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{a=c[e>>2]|0;if(a)_n[a&4095](f,b)|0}sdd(b);i=d;return}function i7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+16|0;g=d+36|0;h=d+4|0;j=d+40|0;k=d;l=d+12|0;m=d+24|0;n=d+20|0;o=d+8|0;p=d+56|0;q=a+4|0;r=c[a>>2]|0;s=r;t=(c[q>>2]|0)-s|0;if(t>>>0>=b>>>0){if(t>>>0<=b>>>0){i=d;return}c[n>>2]=r;c[o>>2]=r+b;c[f+0>>2]=c[n+0>>2];c[e+0>>2]=c[o+0>>2];B7d(m,f,e,p,0);p=c[m>>2]|0;o=c[a>>2]|0;c[m>>2]=o;c[a>>2]=p;p=m+4|0;n=c[p>>2]|0;r=c[q>>2]|0;c[p>>2]=r;c[q>>2]=n;n=m+8|0;m=a+8|0;u=c[n>>2]|0;c[n>>2]=c[m>>2];c[m>>2]=u;if(!o){i=d;return}if((r|0)!=(o|0))c[p>>2]=o;c[h>>2]=27;c[e+0>>2]=c[h+0>>2];eOb(o,e);i=d;return}o=a+8|0;if(((c[o>>2]|0)-s|0)==(b|0)){A7d(a,b-t|0);i=d;return}c[j>>2]=0;t=j+4|0;c[t>>2]=0;s=j+8|0;c[s>>2]=0;if((b|0)!=0?(c[f>>2]=27,c[e+0>>2]=c[f+0>>2],h=cOb(b,16,e,0,3653512,80)|0,p=c[j>>2]|0,r=(c[t>>2]|0)-p|0,u=h+(0-r)|0,YEi(u|0,p|0,r|0)|0,r=c[j>>2]|0,c[j>>2]=u,c[t>>2]=h,c[s>>2]=h+b,(r|0)!=0):0){c[g>>2]=27;c[e+0>>2]=c[g+0>>2];eOb(r,e)}c[k>>2]=c[a>>2];c[l>>2]=c[q>>2];c[f+0>>2]=c[k+0>>2];c[e+0>>2]=c[l+0>>2];z7d(j,f,e);l=c[t>>2]|0;k=c[j>>2]|0;r=l-k|0;if(r>>>0>=b>>>0)if(r>>>0>b>>>0?(g=k+b|0,(l|0)!=(g|0)):0){c[t>>2]=g;v=k;w=g}else{v=k;w=l}else{A7d(j,b-r|0);v=c[j>>2]|0;w=c[t>>2]|0}r=c[a>>2]|0;c[j>>2]=r;c[a>>2]=v;v=c[q>>2]|0;c[t>>2]=v;c[q>>2]=w;w=c[s>>2]|0;c[s>>2]=c[o>>2];c[o>>2]=w;if(!r){i=d;return}if((v|0)!=(r|0))c[t>>2]=r;c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function j7d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+60|0;g=e+32|0;h=e+52|0;j=e;k=e+48|0;l=e+56|0;m=e+4|0;n=e+40|0;o=e+36|0;p=e+16|0;q=e+28|0;r=e+44|0;s=e+64|0;t=b+4|0;u=c[b>>2]|0;v=u;w=((c[t>>2]|0)-v|0)/12|0;if(w>>>0>=d>>>0){if(w>>>0<=d>>>0){i=e;return}c[q>>2]=u;c[r>>2]=u+(d*12|0);c[g+0>>2]=c[q+0>>2];c[f+0>>2]=c[r+0>>2];F7d(p,g,f,s,0);s=c[p>>2]|0;r=c[b>>2]|0;c[p>>2]=r;c[b>>2]=s;s=p+4|0;q=c[s>>2]|0;u=c[t>>2]|0;c[s>>2]=u;c[t>>2]=q;q=p+8|0;x=b+8|0;y=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=y;if(!r){i=e;return}if((u|0)==(r|0))z=r;else{y=u;while(1){u=y+-12|0;c[s>>2]=u;if(!(a[u>>0]&1))A=u;else{u=c[y+-4>>2]|0;c[k>>2]=58;c[f+0>>2]=c[k+0>>2];eOb(u,f);A=c[s>>2]|0}if((A|0)==(r|0))break;else y=A}z=c[p>>2]|0}c[l>>2]=27;c[f+0>>2]=c[l+0>>2];eOb(z,f);i=e;return}z=b+8|0;if((((c[z>>2]|0)-v|0)/12|0|0)==(d|0)){E7d(b,d-w|0);i=e;return}c[m>>2]=0;w=m+4|0;c[w>>2]=0;v=m+8|0;c[v>>2]=0;C7d(m,d);c[n>>2]=c[b>>2];c[o>>2]=c[t>>2];c[g+0>>2]=c[n+0>>2];c[f+0>>2]=c[o+0>>2];D7d(m,g,f);o=c[w>>2]|0;n=c[m>>2]|0;l=(o-n|0)/12|0;if(l>>>0>=d>>>0)if(l>>>0>d>>>0?(p=n+(d*12|0)|0,(o|0)!=(p|0)):0){n=o;while(1){A=n+-12|0;c[w>>2]=A;if(!(a[A>>0]&1))B=A;else{A=c[n+-4>>2]|0;c[j>>2]=58;c[f+0>>2]=c[j+0>>2];eOb(A,f);B=c[w>>2]|0}if((B|0)==(p|0)){C=p;break}else n=B}}else C=o;else{E7d(m,d-l|0);C=c[w>>2]|0}l=c[m>>2]|0;d=c[b>>2]|0;c[m>>2]=d;c[b>>2]=l;l=c[t>>2]|0;c[w>>2]=l;c[t>>2]=C;C=c[v>>2]|0;c[v>>2]=c[z>>2];c[z>>2]=C;if(!d){i=e;return}if((l|0)==(d|0))D=d;else{C=l;while(1){l=C+-12|0;c[w>>2]=l;if(!(a[l>>0]&1))E=l;else{l=c[C+-4>>2]|0;c[g>>2]=58;c[f+0>>2]=c[g+0>>2];eOb(l,f);E=c[w>>2]|0}if((E|0)==(d|0))break;else C=E}D=c[m>>2]|0}c[h>>2]=27;c[f+0>>2]=c[h+0>>2];eOb(D,f);i=e;return}function k7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+4|0;h=d+8|0;j=d+44|0;k=d;l=d+20|0;m=d+40|0;n=d+36|0;o=d+52|0;p=a+4|0;q=c[a>>2]|0;r=q;s=(c[p>>2]|0)-r>>2;if(s>>>0>=b>>>0){if(s>>>0<=b>>>0){i=d;return}c[m>>2]=q;c[n>>2]=q+(b<<2);c[f+0>>2]=c[m+0>>2];c[e+0>>2]=c[n+0>>2];J7d(l,f,e,o,0);o=c[l>>2]|0;n=c[a>>2]|0;c[l>>2]=n;c[a>>2]=o;o=l+4|0;m=c[o>>2]|0;q=c[p>>2]|0;c[o>>2]=q;c[p>>2]=m;m=l+8|0;l=a+8|0;t=c[m>>2]|0;c[m>>2]=c[l>>2];c[l>>2]=t;if(!n){i=d;return}if((q|0)!=(n|0))c[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);c[g>>2]=27;c[e+0>>2]=c[g+0>>2];eOb(n,e);i=d;return}n=a+8|0;if(((c[n>>2]|0)-r>>2|0)==(b|0)){I7d(a,b-s|0);i=d;return}c[h>>2]=0;s=h+4|0;c[s>>2]=0;r=h+8|0;c[r>>2]=0;G7d(h,b);c[j>>2]=c[a>>2];c[k>>2]=c[p>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];H7d(h,f,e);k=c[s>>2]|0;j=c[h>>2]|0;g=k-j>>2;if(g>>>0>=b>>>0)if(g>>>0>b>>>0?(q=j+(b<<2)|0,(k|0)!=(q|0)):0){o=k+(~((k+-4-q|0)>>>2)<<2)|0;c[s>>2]=o;u=j;v=o}else{u=j;v=k}else{I7d(h,b-g|0);u=c[h>>2]|0;v=c[s>>2]|0}g=c[a>>2]|0;c[h>>2]=g;c[a>>2]=u;u=c[p>>2]|0;c[s>>2]=u;c[p>>2]=v;v=c[r>>2]|0;c[r>>2]=c[n>>2];c[n>>2]=v;if(!g){i=d;return}if((u|0)!=(g|0))c[s>>2]=u+(~((u+-4-g|0)>>>2)<<2);c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(g,e);i=d;return}function l7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function m7d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;k=d+20|0;if(j>>>0>(c[k>>2]|0)>>>0)Bid(f,b,4);else{c[b>>2]=c[h>>2];c[f>>2]=j}KYb(d,b+4|0,2493952,0);KYb(d,b+20|0,2494e3,0);j=b+36|0;h=c[f>>2]|0;l=h+4|0;m=c[k>>2]|0;if(l>>>0>m>>>0){Bid(f,j,4);n=c[f>>2]|0;o=c[k>>2]|0}else{g[j>>2]=ea(g[h>>2]);c[f>>2]=l;n=l;o=m}m=b+52|0;if((n+1|0)>>>0>o>>>0){Bid(f,m,1);Ndd(d);i=e;return}else{a[m>>0]=a[n>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Ndd(d);i=e;return}}function n7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function o7d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im;e=i;f=d+12|0;h=c[f>>2]|0;j=h+4|0;l=d+20|0;if(j>>>0>(c[l>>2]|0)>>>0){Bid(f,b,4);m=c[b>>2]|0}else{n=c[h>>2]|0;c[b>>2]=n;c[f>>2]=j;m=n}c[b>>2]=XEi(m|0)|0;NYb(b+4|0,d);NYb(b+20|0,d);m=b+36|0;n=c[f>>2]|0;j=n+4|0;h=c[l>>2]|0;if(j>>>0>h>>>0){Bid(f,m,4);o=m;p=c[m>>2]|0;q=c[f>>2]|0;r=c[l>>2]|0}else{s=ea(g[n>>2]);g[m>>2]=s;c[f>>2]=j;o=m;p=(g[k>>2]=s,c[k>>2]|0);q=j;r=h}c[o>>2]=XEi(p|0)|0;p=b+52|0;if((q+1|0)>>>0>r>>>0){Bid(f,p,1);Mdd(d);i=e;return}else{a[p>>0]=a[q>>0]|0;c[f>>2]=(c[f>>2]|0)+1;Mdd(d);i=e;return}}function p7d(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im;f=i;e=a+12|0;h=c[e>>2]|0;j=h+2|0;l=a+20|0;a=c[l>>2]|0;if(j>>>0>a>>>0){Bid(e,d,2);m=c[e>>2]|0;n=c[l>>2]|0;o=b[d>>1]|0}else{p=b[h>>1]|0;b[d>>1]=p;c[e>>2]=j;m=j;n=a;o=p}p=o&65535;b[d>>1]=p<<8|p>>>8;p=d+2|0;o=m+2|0;if(o>>>0>n>>>0){Bid(e,p,2);q=b[p>>1]|0;r=c[e>>2]|0;s=c[l>>2]|0}else{l=b[m>>1]|0;b[p>>1]=l;c[e>>2]=o;q=l;r=o;s=n}n=q&65535;b[p>>1]=n<<8|n>>>8;n=d+4|0;d=r+4|0;if(d>>>0>s>>>0){Bid(e,n,4);t=n;u=c[n>>2]|0;v=XEi(u|0)|0;c[t>>2]=v;i=f;return}else{w=ea(g[r>>2]);g[n>>2]=w;c[e>>2]=d;t=n;u=(g[k>>2]=w,c[k>>2]|0);v=XEi(u|0)|0;c[t>>2]=v;i=f;return}}function q7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function r7d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=(j|0)/56|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=((m-o|0)/56|0)>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=(q|0)/56|0;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(((s|0)/56|0)*56|0)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~(((s+-56-d|0)>>>0)/56|0)*56|0);i=e;return}d=h+(r*56|0)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{u=q+0|0;v=r+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=c[p>>2]|0}q=t+56|0;c[p>>2]=q;r=r+56|0}while((r|0)!=(b|0));i=e;return}if(!n)x=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~(((r+-56-o|0)>>>0)/56|0)*56|0);c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=(x-0|0)/56|0;if(j>>>0<1073741823){x=j<<1;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=27;c[f+0>>2]=c[g+0>>2];g=cOb(y*56|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y*56|0);if((h|0)==(b|0)){i=e;return}else{z=g;A=h}do{if(!z)B=0;else{u=z+0|0;v=A+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));B=c[f>>2]|0}z=B+56|0;c[f>>2]=z;A=A+56|0}while((A|0)!=(b|0));i=e;return}function s7d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=27;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/56|0)*56|0);d=g;g=k;do{if(!d)l=0;else{k=d+0|0;j=g+0|0;a=k+56|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(a|0));l=c[h>>2]|0}d=l+56|0;c[h>>2]=d;g=g+56|0}while((g|0)!=(b|0));i=f;return}function t7d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=(j|0)/56|0;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0<=((m-o|0)/56|0)>>>0){p=a+4|0;q=(c[p>>2]|0)-o|0;r=(q|0)/56|0;if(k>>>0<=r>>>0){s=b-d|0;aFi(n|0,h|0,s|0)|0;d=n+(((s|0)/56|0)*56|0)|0;s=c[p>>2]|0;if((s|0)==(d|0)){i=e;return}c[p>>2]=s+(~(((s+-56-d|0)>>>0)/56|0)*56|0);i=e;return}d=h+(r*56|0)|0;aFi(n|0,h|0,q|0)|0;if((d|0)==(b|0)){i=e;return}q=c[p>>2]|0;r=d;do{if(!q)t=0;else{u=q+0|0;v=r+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));t=c[p>>2]|0}q=t+56|0;c[p>>2]=q;r=r+56|0}while((r|0)!=(b|0));i=e;return}if(!n)x=m;else{m=a+4|0;r=c[m>>2]|0;if((r|0)!=(n|0))c[m>>2]=r+(~(((r+-56-o|0)>>>0)/56|0)*56|0);c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;x=0}if((j|0)<0)vxi(a);j=(x-0|0)/56|0;if(j>>>0<1073741823){x=j<<1;j=x>>>0<k>>>0?k:x;if((j|0)<0)vxi(a);else y=j}else y=2147483647;c[g>>2]=89;c[f+0>>2]=c[g+0>>2];g=cOb(y*56|0,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(y*56|0);if((h|0)==(b|0)){i=e;return}else{z=g;A=h}do{if(!z)B=0;else{u=z+0|0;v=A+0|0;w=u+56|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));B=c[f>>2]|0}z=B+56|0;c[f>>2]=z;A=A+56|0}while((A|0)!=(b|0));i=e;return}function u7d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if(((j-m|0)/56|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{c[o>>2]=-1;l=o+4|0;q=l+0|0;r=q+48|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));a[l+48>>0]=0;p=c[k>>2]|0}o=p+56|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=((m-n|0)/56|0)+d|0;if((o|0)<0)vxi(b);m=n;n=(j-m|0)/56|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=((c[k>>2]|0)-m|0)/56|0;if(!n){s=0;t=0;u=j}else{v=n;w=j;x=10}}else{v=2147483647;w=((c[k>>2]|0)-m|0)/56|0;x=10}if((x|0)==10){c[g>>2]=89;c[f+0>>2]=c[g+0>>2];s=v;t=cOb(v*56|0,16,f,0,3653512,80)|0;u=w}w=d;d=t+(u*56|0)|0;while(1){if(!d)y=0;else{c[d>>2]=-1;v=d+4|0;q=v+0|0;r=q+48|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));a[v+48>>0]=0;y=d}l=y+56|0;w=w+-1|0;if(!w){z=l;break}else d=l}d=c[b>>2]|0;w=(c[k>>2]|0)-d|0;y=t+((((w|0)/-56|0)+u|0)*56|0)|0;YEi(y|0,d|0,w|0)|0;w=c[b>>2]|0;c[b>>2]=y;c[k>>2]=z;c[h>>2]=t+(s*56|0);if(!w){i=e;return}c[g>>2]=89;c[f+0>>2]=c[g+0>>2];eOb(w,f);i=e;return}function v7d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;if((b|0)==(k|0)){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=89;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(((d|0)/56|0)*56|0);d=g;g=k;do{if(!d)l=0;else{k=d+0|0;j=g+0|0;a=k+56|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(a|0));l=c[h>>2]|0}d=l+56|0;c[h>>2]=d;g=g+56|0}while((g|0)!=(b|0));i=f;return}function w7d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e+4|0;h=e;j=c[b>>2]|0;b=c[d>>2]|0;d=j;k=b-d|0;l=k>>3;m=a+8|0;n=c[m>>2]|0;o=c[a>>2]|0;p=o;if(l>>>0>n-p>>3>>>0){if(!o)q=n;else{n=a+4|0;r=c[n>>2]|0;if((r|0)!=(o|0))c[n>>2]=r+(~((r+-8-p|0)>>>3)<<3);c[h>>2]=27;c[f+0>>2]=c[h+0>>2];eOb(o,f);c[m>>2]=0;c[n>>2]=0;c[a>>2]=0;q=0}if((k|0)<0)vxi(a);k=q-0|0;if(k>>3>>>0<1073741823){q=k>>2;k=q>>>0<l>>>0?l:q;if((k|0)<0)vxi(a);else s=k}else s=2147483647;c[h>>2]=27;c[f+0>>2]=c[h+0>>2];h=cOb(s<<3,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=h;c[a>>2]=h;c[m>>2]=h+(s<<3);if((j|0)==(b|0)){i=e;return}else{t=h;u=j}do{if(!t)v=0;else{h=u;s=c[h+4>>2]|0;m=t;c[m>>2]=c[h>>2];c[m+4>>2]=s;v=c[f>>2]|0}t=v+8|0;c[f>>2]=t;u=u+8|0}while((u|0)!=(b|0));i=e;return}u=a+4|0;a=c[u>>2]|0;t=a-p>>3;if(l>>>0>t>>>0){w=j+(t<<3)|0;x=1}else{w=b;x=0}if((j|0)==(w|0))y=o;else{t=(w+-8-d|0)>>>3;d=o;l=j;while(1){c[d>>2]=c[l>>2];g[d+4>>2]=ea(g[l+4>>2]);l=l+8|0;if((l|0)==(w|0))break;else d=d+8|0}y=o+(t+1<<3)|0}if(!x){if((a|0)==(y|0)){i=e;return}c[u>>2]=a+(~((a+-8-y|0)>>>3)<<3);i=e;return}if((w|0)==(b|0)){i=e;return}else{z=a;A=w}do{if(!z)B=0;else{w=A;a=c[w+4>>2]|0;y=z;c[y>>2]=c[w>>2];c[y+4>>2]=a;B=c[u>>2]|0}z=B+8|0;c[u>>2]=z;A=A+8|0}while((A|0)!=(b|0));i=e;return}function x7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+4|0;f=d;h=a+8|0;j=c[h>>2]|0;k=a+4|0;l=c[k>>2]|0;m=l;if(j-m>>3>>>0>=b>>>0){n=b;o=l;while(1){if(o){c[o>>2]=0;g[o+4>>2]=ea(0.0)}n=n+-1|0;if(!n)break;else o=o+8|0}c[k>>2]=l+(b<<3);i=d;return}l=c[a>>2]|0;o=(m-l>>3)+b|0;if((o|0)<0)vxi(a);m=l;l=j-m|0;if(l>>3>>>0<1073741823){j=l>>2;l=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m>>3;if(!l){p=0;q=0;r=j}else{s=l;t=j;u=11}}else{s=2147483647;t=(c[k>>2]|0)-m>>3;u=11}if((u|0)==11){c[f>>2]=27;c[e+0>>2]=c[f+0>>2];p=s;q=cOb(s<<3,16,e,0,3653512,80)|0;r=t}t=b;s=q+(r<<3)|0;while(1){if(s){c[s>>2]=0;g[s+4>>2]=ea(0.0)}t=t+-1|0;if(!t)break;else s=s+8|0}s=c[a>>2]|0;t=(c[k>>2]|0)-s|0;u=q+(r-(t>>3)<<3)|0;YEi(u|0,s|0,t|0)|0;t=c[a>>2]|0;c[a>>2]=u;c[k>>2]=q+(r+b<<3);c[h>>2]=q+(p<<3);if(!t){i=d;return}c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(t,e);i=d;return}function y7d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=b-k|0;l=d>>3;if(!l){i=f;return}if((d|0)<0)vxi(a);c[g>>2]=27;c[e+0>>2]=c[g+0>>2];g=cOb(d,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(l<<3);if((k|0)==(b|0)){i=f;return}else{m=g;n=k}do{if(!m)o=0;else{k=n;g=c[k+4>>2]|0;l=m;c[l>>2]=c[k>>2];c[l+4>>2]=g;o=c[h>>2]|0}m=o+8|0;c[h>>2]=m;n=n+8|0}while((n|0)!=(b|0));i=f;return}function z7d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;e=j;k=d-e|0;l=b+8|0;m=c[l>>2]|0;n=c[b>>2]|0;o=n;if(k>>>0<=(m-o|0)>>>0){p=b+4|0;q=(c[p>>2]|0)-o|0;if(k>>>0<=q>>>0){o=d-e|0;aFi(n|0,j|0,o|0)|0;e=n+o|0;if((c[p>>2]|0)==(e|0)){i=f;return}c[p>>2]=e;i=f;return}e=j+q|0;aFi(n|0,j|0,q|0)|0;if((e|0)==(d|0)){i=f;return}q=c[p>>2]|0;o=e;do{if(!q)r=0;else{a[q>>0]=a[o>>0]|0;r=c[p>>2]|0}q=r+1|0;c[p>>2]=q;o=o+1|0}while((o|0)!=(d|0));i=f;return}if(!n)s=m;else{m=b+4|0;if((c[m>>2]|0)!=(n|0))c[m>>2]=n;c[h>>2]=27;c[g+0>>2]=c[h+0>>2];eOb(n,g);c[l>>2]=0;c[m>>2]=0;c[b>>2]=0;s=0}if((k|0)<0)vxi(b);m=s-0|0;if(m>>>0<1073741823){s=m<<1;m=s>>>0<k>>>0?k:s;if((m|0)<0)vxi(b);else t=m}else t=2147483647;c[h>>2]=27;c[g+0>>2]=c[h+0>>2];h=cOb(t,16,g,0,3653512,80)|0;g=b+4|0;c[g>>2]=h;c[b>>2]=h;c[l>>2]=h+t;if((j|0)==(d|0)){i=f;return}else{u=h;v=j}do{if(!u)w=0;else{a[u>>0]=a[v>>0]|0;w=c[g>>2]|0}u=w+1|0;c[g>>2]=u;v=v+1|0}while((v|0)!=(d|0));i=f;return}function A7d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+8|0;j=c[h>>2]|0;k=b+4|0;l=c[k>>2]|0;m=l;if((j-m|0)>>>0>=d>>>0){n=d;o=l;do{if(!o)p=0;else{a[o>>0]=0;p=c[k>>2]|0}o=p+1|0;c[k>>2]=o;n=n+-1|0}while((n|0)!=0);i=e;return}n=c[b>>2]|0;o=m-n+d|0;if((o|0)<0)vxi(b);m=n;n=j-m|0;if(n>>>0<1073741823){j=n<<1;n=j>>>0<o>>>0?o:j;j=(c[k>>2]|0)-m|0;if(!n){q=0;r=0;s=j}else{t=n;u=j;v=10}}else{t=2147483647;u=(c[k>>2]|0)-m|0;v=10}if((v|0)==10){c[g>>2]=27;c[f+0>>2]=c[g+0>>2];q=t;r=cOb(t,16,f,0,3653512,80)|0;s=u}u=d;d=r+s|0;while(1){if(!d)w=0;else{a[d>>0]=0;w=d}t=w+1|0;u=u+-1|0;if(!u){x=t;break}else d=t}d=c[b>>2]|0;u=(c[k>>2]|0)-d|0;w=r+(s-u)|0;YEi(w|0,d|0,u|0)|0;u=c[b>>2]|0;c[b>>2]=w;c[k>>2]=x;c[h>>2]=r+q;if(!u){i=e;return}c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(u,f);i=e;return}function B7d(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=27;c[f+0>>2]=c[h+0>>2];h=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=h;c[b>>2]=h;c[k>>2]=h+e;e=h;h=l;do{if(!e)m=0;else{a[e>>0]=a[h>>0]|0;m=c[j>>2]|0}e=m+1|0;c[j>>2]=e;h=h+1|0}while((h|0)!=(d|0));i=g;return}function C7d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b>>2]|0;if((((c[b+8>>2]|0)-k|0)/12|0)>>>0>=d>>>0){i=e;return}l=((c[b+4>>2]|0)-k|0)/12|0;k=j+12|0;c[k>>2]=0;c[j+16>>2]=b+8;if(!d)m=0;else{c[g>>2]=27;c[f+0>>2]=c[g+0>>2];m=cOb(d*12|0,16,f,0,3653512,80)|0}c[j>>2]=m;n=m+(l*12|0)|0;l=j+8|0;c[l>>2]=n;o=j+4|0;c[o>>2]=n;c[k>>2]=m+(d*12|0);P5d(b,j);b=c[o>>2]|0;o=c[l>>2]|0;if((o|0)!=(b|0)){d=o;do{o=d;d=d+-12|0;c[l>>2]=d;if(a[d>>0]&1){m=c[o+-4>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(m,f)}}while((d|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function D7d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[d>>2]|0;d=c[e>>2]|0;k=j;l=d-k|0;m=(l|0)/12|0;n=b+8|0;o=c[b>>2]|0;p=o;if(m>>>0>(((c[n>>2]|0)-p|0)/12|0)>>>0){E6d(b);if((l|0)<0)vxi(b);l=((c[n>>2]|0)-(c[b>>2]|0)|0)/12|0;if(l>>>0<1073741823){q=l<<1;l=q>>>0<m>>>0?m:q;if((l|0)<0)vxi(b);else r=l}else r=2147483647;c[h>>2]=27;c[g+0>>2]=c[h+0>>2];l=cOb(r*12|0,16,g,0,3653512,80)|0;q=b+4|0;c[q>>2]=l;c[b>>2]=l;c[n>>2]=l+(r*12|0);if((j|0)==(d|0)){i=f;return}r=l;l=j;while(1){if(!r)s=0;else{n=a[l>>0]|0;if(!(n&1)){t=(n&255)>>>1;u=l+1|0}else{t=c[l+4>>2]|0;u=c[l+8>>2]|0}if(t>>>0>2147483631){v=56;break}if(t>>>0<11){a[r>>0]=t<<1;w=r+1|0}else{n=t+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];x=cOb(n,16,g,0,3653512,80)|0;c[r+8>>2]=x;c[r>>2]=n|1;c[r+4>>2]=t;w=x}YEi(w|0,u|0,t|0)|0;a[w+t>>0]=0;s=c[q>>2]|0}x=s+12|0;c[q>>2]=x;l=l+12|0;if((l|0)==(d|0)){v=62;break}else r=x}if((v|0)==56)ori(r);else if((v|0)==62){i=f;return}}r=b+4|0;b=((c[r>>2]|0)-p|0)/12|0;if(m>>>0>b>>>0){y=j+(b*12|0)|0;z=1}else{y=d;z=0}if((j|0)==(y|0))A=o;else{d=((y+-12-k|0)>>>0)/12|0;k=o;b=j;while(1){do if((k|0)!=(b|0)){j=a[b>>0]|0;if(!(j&1)){B=(j&255)>>>1;C=b+1|0}else{B=c[b+4>>2]|0;C=c[b+8>>2]|0}j=a[k>>0]|0;if(!(j&1)){D=10;E=j}else{j=c[k>>2]|0;D=(j&-2)+-1|0;E=j&255}j=(E&1)==0;if(B>>>0>D>>>0){if(j)F=(E&255)>>>1;else F=c[k+4>>2]|0;eXb(k,D,B-D|0,F,0,F,B,C);break}if(j)G=k+1|0;else G=c[k+8>>2]|0;aFi(G|0,C|0,B|0)|0;a[G+B>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=B<<1;break}else{c[k+4>>2]=B;break}}while(0);b=b+12|0;if((b|0)==(y|0))break;else k=k+12|0}A=o+((d+1|0)*12|0)|0}if(!z){z=c[r>>2]|0;if((z|0)==(A|0)){i=f;return}d=z;while(1){z=d+-12|0;c[r>>2]=z;if(!(a[z>>0]&1))H=z;else{z=c[d+-4>>2]|0;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];eOb(z,g);H=c[r>>2]|0}if((H|0)==(A|0))break;else d=H}i=f;return}H=c[e>>2]|0;if((y|0)==(H|0)){i=f;return}e=c[r>>2]|0;d=y;while(1){if(!e)I=0;else{y=a[d>>0]|0;if(!(y&1)){J=d+1|0;K=(y&255)>>>1}else{J=c[d+8>>2]|0;K=c[d+4>>2]|0}if(K>>>0>2147483631){v=33;break}if(K>>>0<11){a[e>>0]=K<<1;L=e+1|0}else{y=K+16&-16;c[h>>2]=58;c[g+0>>2]=c[h+0>>2];A=cOb(y,16,g,0,3653512,80)|0;c[e+8>>2]=A;c[e>>2]=y|1;c[e+4>>2]=K;L=A}YEi(L|0,J|0,K|0)|0;a[L+K>>0]=0;I=c[r>>2]|0}A=I+12|0;c[r>>2]=A;d=d+12|0;if((d|0)==(H|0)){v=62;break}else e=A}if((v|0)==33)ori(e);else if((v|0)==62){i=f;return}}function E7d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;k=c[b+8>>2]|0;l=b+4|0;m=c[l>>2]|0;n=m;if(((k-n|0)/12|0)>>>0>=d>>>0){o=d;p=m;do{if(!p)q=0;else{c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;q=c[l>>2]|0}p=q+12|0;c[l>>2]=p;o=o+-1|0}while((o|0)!=0);i=e;return}o=c[b>>2]|0;p=((n-o|0)/12|0)+d|0;if((p|0)<0)vxi(b);n=o;o=(k-n|0)/12|0;if(o>>>0<1073741823){k=o<<1;r=k>>>0<p>>>0?p:k}else r=2147483647;k=((c[l>>2]|0)-n|0)/12|0;n=j+12|0;c[n>>2]=0;c[j+16>>2]=b+8;if(!r)s=0;else{c[g>>2]=27;c[f+0>>2]=c[g+0>>2];s=cOb(r*12|0,16,f,0,3653512,80)|0}c[j>>2]=s;l=s+(k*12|0)|0;k=j+8|0;c[k>>2]=l;p=j+4|0;c[p>>2]=l;c[n>>2]=s+(r*12|0);r=d;d=l;while(1){if(!d)t=0;else{c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;t=d}l=t+12|0;r=r+-1|0;if(!r){u=l;break}else d=l}c[k>>2]=u;P5d(b,j);b=c[p>>2]|0;p=c[k>>2]|0;if((p|0)!=(b|0)){u=p;do{p=u;u=u+-12|0;c[k>>2]=u;if(a[u>>0]&1){d=c[p+-4>>2]|0;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];eOb(d,f)}}while((u|0)!=(b|0))}b=c[j>>2]|0;if(!b){i=e;return}c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(b,f);i=e;return}function F7d(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;f=g+4|0;h=g;c[b>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=c[d>>2]|0;d=c[e>>2]|0;e=d-l|0;if((d|0)==(l|0)){i=g;return}if((e|0)<0)vxi(b);c[h>>2]=27;c[f+0>>2]=c[h+0>>2];m=cOb(e,16,f,0,3653512,80)|0;c[j>>2]=m;c[b>>2]=m;c[k>>2]=m+(((e|0)/12|0)*12|0);e=m;m=l;while(1){if(!e)n=0;else{l=a[m>>0]|0;if(!(l&1)){o=(l&255)>>>1;p=m+1|0}else{o=c[m+4>>2]|0;p=c[m+8>>2]|0}if(o>>>0>2147483631){q=10;break}if(o>>>0<11){a[e>>0]=o<<1;r=e+1|0}else{l=o+16&-16;c[h>>2]=58;c[f+0>>2]=c[h+0>>2];k=cOb(l,16,f,0,3653512,80)|0;c[e+8>>2]=k;c[e>>2]=l|1;c[e+4>>2]=o;r=k}YEi(r|0,p|0,o|0)|0;a[r+o>>0]=0;n=c[j>>2]|0}k=n+12|0;c[j>>2]=k;m=m+12|0;if((m|0)==(d|0)){q=16;break}else e=k}if((q|0)==10)ori(e);else if((q|0)==16){i=g;return}}function G7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((c[g>>2]|0)-j>>2>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;m=l-j>>2;if(!b){n=h;o=0;p=l}else{c[f>>2]=27;c[e+0>>2]=c[f+0>>2];l=cOb(b<<2,16,e,0,3653512,80)|0;n=c[a>>2]|0;o=l;p=c[k>>2]|0}l=o+(m<<2)|0;h=o+(b<<2)|0;if((p|0)==(n|0)){q=l;r=p}else{b=p+-4-n|0;j=p;p=l;while(1){j=j+-4|0;c[p+-4>>2]=c[j>>2];if((j|0)==(n|0))break;else p=p+-4|0}q=o+(m+~(b>>>2)<<2)|0;r=n}c[a>>2]=q;c[k>>2]=l;c[g>>2]=h;if(!r){i=d;return}c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(r,e);i=d;return}function H7d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[b>>2]|0;b=c[d>>2]|0;d=h;j=b-d|0;k=j>>2;l=a+8|0;m=c[l>>2]|0;n=c[a>>2]|0;o=n;if(k>>>0>m-o>>2>>>0){if(!n)p=m;else{m=a+4|0;q=c[m>>2]|0;if((q|0)!=(n|0))c[m>>2]=q+(~((q+-4-o|0)>>>2)<<2);c[g>>2]=27;c[f+0>>2]=c[g+0>>2];eOb(n,f);c[l>>2]=0;c[m>>2]=0;c[a>>2]=0;p=0}if((j|0)<0)vxi(a);j=p-0|0;if(j>>2>>>0<1073741823){p=j>>1;j=p>>>0<k>>>0?k:p;if((j|0)<0)vxi(a);else r=j}else r=2147483647;c[g>>2]=27;c[f+0>>2]=c[g+0>>2];g=cOb(r<<2,16,f,0,3653512,80)|0;f=a+4|0;c[f>>2]=g;c[a>>2]=g;c[l>>2]=g+(r<<2);if((h|0)==(b|0)){i=e;return}r=(b+-4-d|0)>>>2;l=g;j=h;while(1){if(l)c[l>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else l=l+4|0}c[f>>2]=g+(r+1<<2);i=e;return}r=a+4|0;a=c[r>>2]|0;g=a-o>>2;if(k>>>0>g>>>0){s=h+(g<<2)|0;t=1}else{s=b;t=0}if((h|0)==(s|0))u=n;else{g=(s+-4-d|0)>>>2;d=n;k=h;while(1){c[d>>2]=c[k>>2];k=k+4|0;if((k|0)==(s|0))break;else d=d+4|0}u=n+(g+1<<2)|0}if(!t){if((a|0)==(u|0)){i=e;return}c[r>>2]=a+(~((a+-4-u|0)>>>2)<<2);i=e;return}if((s|0)==(b|0)){i=e;return}u=(b+-4-s|0)>>>2;t=a;g=s;while(1){if(t)c[t>>2]=c[g>>2];g=g+4|0;if((g|0)==(b|0))break;else t=t+4|0}c[r>>2]=a+(u+1<<2);i=e;return}function I7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[g>>2]|0;j=a+4|0;k=c[j>>2]|0;l=k;if(h-l>>2>>>0>=b>>>0){m=b;n=k;while(1){if(n)c[n>>2]=0;m=m+-1|0;if(!m)break;else n=n+4|0}c[j>>2]=k+(b<<2);i=d;return}k=c[a>>2]|0;n=(l-k>>2)+b|0;if((n|0)<0)vxi(a);l=k;k=h-l|0;if(k>>2>>>0<1073741823){h=k>>1;k=h>>>0<n>>>0?n:h;h=(c[j>>2]|0)-l>>2;if(!k){o=0;p=0;q=h}else{r=k;s=h;t=11}}else{r=2147483647;s=(c[j>>2]|0)-l>>2;t=11}if((t|0)==11){c[f>>2]=27;c[e+0>>2]=c[f+0>>2];o=r;p=cOb(r<<2,16,e,0,3653512,80)|0;q=s}s=p+(q<<2)|0;r=b;t=s;while(1){if(t)c[t>>2]=0;r=r+-1|0;if(!r)break;else t=t+4|0}t=p+(o<<2)|0;o=p+(q+b<<2)|0;b=c[a>>2]|0;r=c[j>>2]|0;if((r|0)==(b|0)){u=s;v=b}else{l=r+-4-b|0;h=r;r=s;while(1){h=h+-4|0;c[r+-4>>2]=c[h>>2];if((h|0)==(b|0))break;else r=r+-4|0}u=p+(q+~(l>>>2)<<2)|0;v=c[a>>2]|0}c[a>>2]=u;c[j>>2]=o;c[g>>2]=t;if(!v){i=d;return}c[f>>2]=27;c[e+0>>2]=c[f+0>>2];eOb(v,e);i=d;return}function J7d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;e=f+4|0;g=f;c[a>>2]=0;h=a+4|0;c[h>>2]=0;j=a+8|0;c[j>>2]=0;k=c[b>>2]|0;b=c[d>>2]|0;d=k;l=b-d|0;m=l>>2;if(!m){i=f;return}if((l|0)<0)vxi(a);c[g>>2]=27;c[e+0>>2]=c[g+0>>2];g=cOb(l,16,e,0,3653512,80)|0;c[h>>2]=g;c[a>>2]=g;c[j>>2]=g+(m<<2);if((k|0)==(b|0)){i=f;return}m=(b+-4-d|0)>>>2;d=g;j=k;while(1){if(d)c[d>>2]=c[j>>2];j=j+4|0;if((j|0)==(b|0))break;else d=d+4|0}c[h>>2]=g+(m+1<<2);i=f;return}function K7d(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a+4|0;e=a;c[e>>2]=c[153096];c[d+0>>2]=c[e+0>>2];e=cOb(b,16,d,0,3653512,10)|0;i=a;return e|0}function L7d(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a+4|0;e=a;c[e>>2]=c[153096];c[d+0>>2]=c[e+0>>2];eOb(b,d);i=a;return}function M7d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;i=i+16|0;a=b+4|0;f=b;c[f>>2]=c[153096];c[a+0>>2]=c[f+0>>2];f=hOb(e,d,16,a,0,3653512,20)|0;i=b;return f|0}function N7d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[g>>2]=c[153096];c[e+0>>2]=c[g+0>>2];g=bOb(16,e,0,16,3653512,32)|0;if(!g){Krd(723640,0,3653512,39,1,0,0,0);h=7;i=d;return h|0};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];b=U9d(g,a)|0;if(!b){l9d(c[a>>2]|0);h=0;i=d;return h|0}else{c[f>>2]=c[153096];c[e+0>>2]=c[f+0>>2];eOb(g,e);h=b;i=d;return h|0}return 0}function O7d(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;if(!a){i=b;return 0}f=c[a>>2]|0;V9d(a)|0;c[e>>2]=c[153096];c[d+0>>2]=c[e+0>>2];eOb(f,d);i=b;return 0}function P7d(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+12|0;d=a+8|0;e=a+4|0;f=a;c[d>>2]=c[153096];c[b+0>>2]=c[d+0>>2];d=bOb(12,b,0,16,3653512,32)|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[180924]=d;c[e>>2]=c[153096];c[b+0>>2]=c[e+0>>2];e=bOb(12,b,0,16,3653512,33)|0;d=e+4|0;c[d>>2]=0;c[e+8>>2]=0;c[e>>2]=d;c[180926]=e;c[f>>2]=c[153096];c[b+0>>2]=c[f+0>>2];f=bOb(12,b,0,16,3653512,34)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[180928]=f;i=a;return}function Q7d(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;j=c[180924]|0;k=c[153096]|0;if((j|0)!=0?(l=c[j>>2]|0,(l|0)!=0):0){m=j+4|0;n=c[m>>2]|0;if((n|0)==(l|0))o=l;else{p=n;while(1){n=p+-12|0;c[m>>2]=n;if(!(a[n>>0]&1))q=n;else{n=c[p+-4>>2]|0;c[h>>2]=58;c[d+0>>2]=c[h+0>>2];eOb(n,d);q=c[m>>2]|0}if((q|0)==(l|0))break;else p=q}o=c[j>>2]|0}ACi(o)}c[e>>2]=k;c[d+0>>2]=c[e+0>>2];eOb(j,d);c[180924]=0;j=c[180926]|0;k=c[153096]|0;if(j)U7d(j,c[j+4>>2]|0);c[e>>2]=k;c[d+0>>2]=c[e+0>>2];eOb(j,d);c[180926]=0;j=c[180928]|0;k=c[153096]|0;if(!j){c[g>>2]=k;c[d+0>>2]=c[g+0>>2];eOb(j,d);c[180928]=0;i=b;return}o=c[j>>2]|0;if(!o){c[g>>2]=k;c[d+0>>2]=c[g+0>>2];eOb(j,d);c[180928]=0;i=b;return}q=j+4|0;p=c[q>>2]|0;if((p|0)==(o|0))r=o;else{l=p;while(1){p=l+-12|0;c[q>>2]=p;if(!(a[p>>0]&1))s=p;else{p=c[l+-4>>2]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];eOb(p,d);s=c[q>>2]|0}if((s|0)==(o|0))break;else l=s}r=c[j>>2]|0}c[f>>2]=27;c[d+0>>2]=c[f+0>>2];eOb(r,d);c[g>>2]=k;c[d+0>>2]=c[g+0>>2];eOb(j,d);c[180928]=0;i=b;return}function R7d(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;i=i+112|0;d=b+84|0;e=b+40|0;f=b;g=b+68|0;h=b+72|0;j=b+88|0;k=b+28|0;l=b+56|0;m=b+44|0;n=b+16|0;o=b+4|0;p=c[180928]|0;q=c[p>>2]|0;r=p+4|0;if((q|0)!=(c[r>>2]|0)){s=p;i=b;return s|0}a[h>>0]=10;t=h+1|0;a[t+0>>0]=a[723720]|0;a[t+1>>0]=a[723721]|0;a[t+2>>0]=a[723722]|0;a[t+3>>0]=a[723723]|0;a[t+4>>0]=a[723724]|0;a[h+6>>0]=0;if((q|0)==(c[p+8>>2]|0))M5d(p,h);else{if(!q)u=0;else{a[q>>0]=10;h=q+1|0;a[h+0>>0]=a[t+0>>0]|0;a[h+1>>0]=a[t+1>>0]|0;a[h+2>>0]=a[t+2>>0]|0;a[h+3>>0]=a[t+3>>0]|0;a[h+4>>0]=a[t+4>>0]|0;a[q+6>>0]=0;u=c[r>>2]|0}c[r>>2]=u+12}u=c[180928]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];r=cOb(32,16,d,0,3653512,80)|0;c[j+8>>2]=r;c[j>>2]=33;c[j+4>>2]=16;q=r+0|0;t=723728|0;h=q+16|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[r+16>>0]=0;p=u+4|0;v=c[p>>2]|0;if((v|0)==(c[u+8>>2]|0))M5d(u,j);else{if(!v)w=0;else{c[e>>2]=58;c[d+0>>2]=c[e+0>>2];j=cOb(32,16,d,0,3653512,80)|0;c[v+8>>2]=j;c[v>>2]=33;c[v+4>>2]=16;q=j+0|0;t=r+0|0;h=q+16|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[j+16>>0]=0;w=c[p>>2]|0}c[p>>2]=w+12}c[g>>2]=58;c[d+0>>2]=c[g+0>>2];eOb(r,d);r=c[180928]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];g=cOb(32,16,d,0,3653512,80)|0;c[k+8>>2]=g;c[k>>2]=33;c[k+4>>2]=20;q=g+0|0;t=723752|0;h=q+20|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[g+20>>0]=0;w=r+4|0;p=c[w>>2]|0;if((p|0)==(c[r+8>>2]|0))M5d(r,k);else{if(!p)x=0;else{c[e>>2]=58;c[d+0>>2]=c[e+0>>2];k=cOb(32,16,d,0,3653512,80)|0;c[p+8>>2]=k;c[p>>2]=33;c[p+4>>2]=20;q=k+0|0;t=g+0|0;h=q+20|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[k+20>>0]=0;x=c[w>>2]|0}c[w>>2]=x+12}c[f>>2]=58;c[d+0>>2]=c[f+0>>2];eOb(g,d);g=c[180928]|0;c[e>>2]=58;c[d+0>>2]=c[e+0>>2];f=cOb(16,16,d,0,3653512,80)|0;c[l+8>>2]=f;c[l>>2]=17;c[l+4>>2]=15;q=f+0|0;t=723776|0;h=q+15|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[f+15>>0]=0;x=g+4|0;w=c[x>>2]|0;if((w|0)==(c[g+8>>2]|0))M5d(g,l);else{if(!w)y=0;else{c[e>>2]=58;c[d+0>>2]=c[e+0>>2];l=cOb(16,16,d,0,3653512,80)|0;c[w+8>>2]=l;c[w>>2]=17;c[w+4>>2]=15;q=l+0|0;t=f+0|0;h=q+15|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[l+15>>0]=0;y=c[x>>2]|0}c[x>>2]=y+12}c[e>>2]=58;c[d+0>>2]=c[e+0>>2];eOb(f,d);d=c[180928]|0;a[m>>0]=10;f=m+1|0;a[f+0>>0]=a[723792]|0;a[f+1>>0]=a[723793]|0;a[f+2>>0]=a[723794]|0;a[f+3>>0]=a[723795]|0;a[f+4>>0]=a[723796]|0;a[m+6>>0]=0;e=d+4|0;y=c[e>>2]|0;if((y|0)==(c[d+8>>2]|0))M5d(d,m);else{if(!y)z=0;else{a[y>>0]=10;m=y+1|0;a[m+0>>0]=a[f+0>>0]|0;a[m+1>>0]=a[f+1>>0]|0;a[m+2>>0]=a[f+2>>0]|0;a[m+3>>0]=a[f+3>>0]|0;a[m+4>>0]=a[f+4>>0]|0;a[y+6>>0]=0;z=c[e>>2]|0}c[e>>2]=z+12}z=c[180928]|0;e=c[z+4>>2]|0;y=c[z+8>>2]|0;a[n>>0]=18;f=n+1|0;q=f+0|0;t=723800|0;h=q+9|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[n+10>>0]=0;m=z+4|0;if((e|0)==(y|0))M5d(z,n);else{if(!e)A=0;else{a[e>>0]=18;q=e+1|0;t=f+0|0;h=q+9|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[e+10>>0]=0;A=c[m>>2]|0}c[m>>2]=A+12}A=c[180928]|0;m=c[A+4>>2]|0;e=c[A+8>>2]|0;a[o>>0]=20;f=o+1|0;q=f+0|0;t=723816|0;h=q+10|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[o+11>>0]=0;n=A+4|0;if((m|0)==(e|0))M5d(A,o);else{if(!m)B=0;else{a[m>>0]=20;q=m+1|0;t=f+0|0;h=q+10|0;do{a[q>>0]=a[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(h|0));a[m+11>>0]=0;B=c[n>>2]|0}c[n>>2]=B+12}s=c[180928]|0;i=b;return s|0}function S7d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+24|0;h=d+12|0;j=d;k=c[b>>2]|0;l=b+4|0;while(1){m=c[l>>2]|0;if((m|0)==(k|0))break;n=m+-12|0;c[l>>2]=n;xri(n)}k=c[180924]|0;n=c[k>>2]|0;m=k+4|0;k=c[m>>2]|0;if((k|0)==(n|0)){i=d;return}o=k;while(1){k=o+-12|0;c[m>>2]=k;if(!(a[k>>0]&1))p=k;else{k=c[o+-4>>2]|0;c[f>>2]=58;c[e+0>>2]=c[f+0>>2];eOb(k,e);p=c[m>>2]|0}if((p|0)==(n|0))break;else o=p}p=c[180924]|0;if((c[p+4>>2]|0)==(c[p>>2]|0)){i=d;return}o=g+4|0;n=g+8|0;m=g+4|0;e=j+1|0;f=j+8|0;k=j+4|0;q=b+8|0;r=p;p=0;do{c[o>>2]=0;c[n>>2]=0;c[g>>2]=m;s=c[r>>2]|0;t=s+(p*12|0)|0;u=a[t>>0]|0;if(!(u&1)){v=t+1|0;w=(u&255)>>>1}else{v=c[s+(p*12|0)+8>>2]|0;w=c[s+(p*12|0)+4>>2]|0}rri(h,v,w);s=tqd(h,g)|0;xri(h);if(s?(s=c[g>>2]|0,(s|0)!=(m|0)):0){u=s;while(1){s=u+16|0;gsd(j,s);t=a[j>>0]|0;x=t;y=(t&1)==0?e:c[f>>2]|0;while(1){t=(x&1)==0;if(t){z=e;A=(x&255)>>>1}else{z=c[f>>2]|0;A=c[k>>2]|0}if((y|0)==(z+A|0)){B=t;break}t=a[y>>0]|0;C=t<<24>>24;a[y>>0]=(t+-65<<24>>24&255)<26?C+32|0:C;x=a[j>>0]|0;y=y+1|0}if(!((((Fsd(B?e:c[f>>2]|0,723832)|0)!=0?(Fsd((a[j>>0]&1)==0?e:c[f>>2]|0,723840)|0)!=0:0)?(Fsd((a[j>>0]&1)==0?e:c[f>>2]|0,723848)|0)!=0:0)?(Fsd((a[j>>0]&1)==0?e:c[f>>2]|0,723856)|0)!=0:0))D=26;do if((D|0)==26){D=0;y=c[l>>2]|0;if((y|0)==(c[q>>2]|0)){nO(b,s);break}if(!y)E=0;else{sri(y,s);E=c[l>>2]|0}c[l>>2]=E+12}while(0);xri(j);s=c[u+4>>2]|0;if(!s){y=u;while(1){x=c[y+8>>2]|0;if((c[x>>2]|0)==(y|0)){F=x;break}else y=x}}else{y=s;while(1){x=c[y>>2]|0;if(!x){F=y;break}else y=x}}if((F|0)==(m|0))break;else u=F}}WN(g,c[o>>2]|0);p=p+1|0;r=c[180924]|0}while(p>>>0<(((c[r+4>>2]|0)-(c[r>>2]|0)|0)/12|0)>>>0);i=d;return}function T7d(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=i;i=i+16|0;m=l;n=c[180926]|0;o=n+4|0;V7d(m,n,b,c[n+4>>2]|0,o);n=c[m>>2]|0;do if((n|0)!=(o|0)){m=n+16|0;p=a[b>>0]|0;q=(p&1)==0;if(q)r=(p&255)>>>1;else r=c[b+4>>2]|0;p=a[m>>0]|0;s=(p&1)==0;if(s)t=(p&255)>>>1;else t=c[n+20>>2]|0;if(q)u=b+1|0;else u=c[b+8>>2]|0;if(s)v=m+1|0;else v=c[n+24>>2]|0;m=FEi(u,v,t>>>0<r>>>0?t:r)|0;if(!m)if(r>>>0<t>>>0){w=17;break}else{x=n;break}else if((m|0)<0){w=17;break}else{x=n;break}}else w=17;while(0);if((w|0)==17)x=o;if((x|0)==((c[180926]|0)+4|0)){y=0;i=l;return y|0}if(!(c[x+36>>2]|0)){y=0;i=l;return y|0}o=x+32|0;x=c[o>>2]|0;w=(x|0)==0;if(w){n=o;while(1){t=c[n+8>>2]|0;if((c[t>>2]|0)==(n|0))n=t;else{z=t;break}}}else{n=x;while(1){t=c[n+4>>2]|0;if(!t){z=n;break}else n=t}}c[j>>2]=c[z+16>>2];if(!w){w=o;z=x;a:while(1){x=z;while(1){if((c[x+16>>2]|0)>=(h|0)){A=x;break}x=c[x+4>>2]|0;if(!x){B=w;break a}}z=c[A>>2]|0;if(!z){B=A;break}else w=A}if((B|0)!=(o|0)?(c[B+16>>2]|0)<=(h|0):0){zri(d,c[B+20>>2]|0)|0;zri(e,c[B+24>>2]|0)|0;c[f>>2]=c[B+28>>2];c[g>>2]=c[B+32>>2];C=1}else C=0}else C=0;a[k>>0]=C;y=1;i=l;return y|0}function U7d(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}U7d(a,c[b>>2]|0);U7d(a,c[b+4>>2]|0);W7d(b+28|0,c[b+32>>2]|0);xri(b+16|0);ACi(b);i=d;return}function V7d(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;if(!f){h=g;c[b>>2]=h;i=d;return}j=a[e>>0]|0;k=(j&1)==0;l=(j&255)>>>1;j=e+1|0;m=c[e+8>>2]|0;n=c[e+4>>2]|0;e=g;g=f;a:while(1){b:do if(k){f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){q=(p&255)>>>1;r=o+1|0}else{q=c[f+20>>2]|0;r=c[f+24>>2]|0}o=FEi(r,j,l>>>0<q>>>0?l:q)|0;if(!o){if(q>>>0>=l>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}else{f=g;while(1){o=f+16|0;p=a[o>>0]|0;if(!(p&1)){u=(p&255)>>>1;v=o+1|0}else{u=c[f+20>>2]|0;v=c[f+24>>2]|0}o=FEi(v,m,n>>>0<u>>>0?n:u)|0;if(!o){if(u>>>0>=n>>>0){s=f;break b}}else if((o|0)>=0){s=f;break b}f=c[f+4>>2]|0;if(!f){h=e;t=19;break a}}}while(0);g=c[s>>2]|0;if(!g){h=s;t=19;break}else e=s}if((t|0)==19){c[b>>2]=h;i=d;return}}function W7d(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{W7d(a,c[b>>2]|0);W7d(a,c[b+4>>2]|0);ACi(b);i=d;return}}function X7d(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=c[e>>2]|0;j=c[d>>2]|0;if((b[j+(h<<1)>>1]|0)!=60){k=-1;i=g;return k|0}l=h+1|0;m=c[d+4>>2]|0;if((l|0)==(m|0)){k=-1;i=g;return k|0}d=(b[j+(l<<1)>>1]|0)==47;a[f>>0]=d&1;f=d?h+2|0:l;a:do if(d){l=0;while(1){h=c[723872+(l<<2)>>2]|0;n=a[h>>0]|0;b:do if(!(n<<24>>24))o=15;else{p=n;q=0;while(1){r=q+f|0;if((r|0)==(m|0))break b;s=b[j+(r<<1)>>1]&255;r=s<<24>>24;q=q+1|0;if((((s+-65<<24>>24&255)<26?r+32|0:r)&255)<<24>>24!=p<<24>>24)break b;p=a[h+q>>0]|0;if(!(p<<24>>24)){o=15;break}}}while(0);if((o|0)==15?(o=0,n=b[j+((SEi(h|0)|0)+f<<1)>>1]|0,n<<16>>16==32&(l|0)==5|n<<16>>16==62):0){t=h;u=l;break a}l=l+1|0;if((l|0)>=10){k=-1;break}}i=g;return k|0}else{l=0;while(1){n=c[723872+(l<<2)>>2]|0;p=a[n>>0]|0;c:do if(!(p<<24>>24))o=8;else{q=p;r=0;while(1){s=r+f|0;if((s|0)==(m|0))break c;v=b[j+(s<<1)>>1]&255;s=v<<24>>24;r=r+1|0;if((((v+-65<<24>>24&255)<26?s+32|0:s)&255)<<24>>24!=q<<24>>24)break c;q=a[n+r>>0]|0;if(!(q<<24>>24)){o=8;break}}}while(0);if((o|0)==8){o=0;p=b[j+((SEi(n|0)|0)+f<<1)>>1]|0;if(p<<16>>16==61){t=n;u=l;break a}if(p<<16>>16==32&(l|0)==5|p<<16>>16==62){t=n;u=l;break a}}l=l+1|0;if((l|0)>=10){k=-1;break}}i=g;return k|0}while(0);c[e>>2]=(SEi(t|0)|0)+f;k=u;i=g;return k|0}function Y7d(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+16|0;j=h;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;k=c[f>>2]|0;l=c[e>>2]|0;if((b[l+(k<<1)>>1]|0)==61){m=k+1|0;c[f>>2]=m;k=e+4|0;a:do if(g){n=l;o=m;while(1){p=b[n+(o<<1)>>1]|0;if(p<<16>>16==32|p<<16>>16==62)break a;if((o|0)>=(c[k>>2]|0))break a;c[f>>2]=o+1;Fri(d,p&255);n=c[e>>2]|0;o=c[f>>2]|0}}else{o=m;n=l;while(1){p=b[n+(o<<1)>>1]|0;if(!(p<<16>>16!=62?(o|0)<(c[k>>2]|0):0))break a;c[f>>2]=o+1;Fri(d,p&255);o=c[f>>2]|0;n=c[e>>2]|0}}while(0);e=b[d>>1]|0;f=e&255;k=(e&65535)>>>8&255;if(!(f&1)){q=f;r=k;s=10}else{t=c[d+4>>2]|0;u=f;v=0;w=k}}else{q=0;r=0;s=10}if((s|0)==10){t=(q&255)>>>1;u=q;v=1;w=r}if(t>>>0<=2){i=h;return}if(v)x=w;else x=a[c[d+8>>2]>>0]|0;v=(u&1)==0;if(v){y=(u&255)>>>1;z=d+1|0}else{y=c[d+4>>2]|0;z=c[d+8>>2]|0}if(x<<24>>24!=(a[z+(y+-1)>>0]|0)){i=h;return}if(v)A=w;else A=a[c[d+8>>2]>>0]|0;v=u&1;if(A<<24>>24!=39){if(!(v<<24>>24))B=w;else B=a[c[d+8>>2]>>0]|0;if(B<<24>>24!=34){i=h;return}}if(!(v<<24>>24))C=(u&255)>>>1;else C=c[d+4>>2]|0;vri(j,d,1,C+-2|0,d);yri(d,j)|0;xri(j);i=h;return}function Z7d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e+12|0;g=e;c[f>>2]=-1;h=a[d>>0]|0;j=(h&1)==0;if(j)k=d+1|0;else k=c[d+8>>2]|0;a:do if((a[k>>0]|0)==35){if(j)l=(h&255)>>>1;else l=c[d+4>>2]|0;if((l|0)!=4){if(j)m=(h&255)>>>1;else m=c[d+4>>2]|0;if((m|0)!=5)n=h;else o=14}else o=14;if((o|0)==14){rri(g,724176,1);p=d+1|0;q=d+8|0;r=d+4|0;s=1;while(1){t=a[d>>0]|0;u=(t&1)==0;if(u)v=(t&255)>>>1;else v=c[r>>2]|0;if(s>>>0>=v>>>0)break;if(u)w=p;else w=c[q>>2]|0;Fri(g,a[w+s>>0]|0);if(!(a[d>>0]&1))x=p;else x=c[q>>2]|0;Fri(g,a[x+s>>0]|0);s=s+1|0}yri(d,g)|0;xri(g);n=a[d>>0]|0}s=(n&1)==0;if(s)y=(n&255)>>>1;else y=c[d+4>>2]|0;if((y|0)!=7){if(s)z=(n&255)>>>1;else z=c[d+4>>2]|0;if((z|0)!=9)break}if(s){A=d+1|0;B=(n&255)>>>1}else{A=c[d+8>>2]|0;B=c[d+4>>2]|0}Msd(A+1|0,B>>>1,f)}else{s=d+1|0;q=d+8|0;p=h;r=0;while(1){if(!(p&1))C=s;else C=c[q>>2]|0;u=r+1|0;if(!(Gsd(C,c[724088+(r<<2)>>2]|0)|0)){D=r;break}if(u>>>0>=22)break a;p=a[d>>0]|0;r=u}c[b>>2]=c[724184+(D<<2)>>2];i=e;return}while(0);c[b>>2]=c[f>>2];i=e;return}function _7d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=0;f=d+4|0;c[f>>2]=0;g=d+8|0;c[g>>2]=0;h=c[a>>2]|0;j=a+4|0;a=c[j>>2]|0;a:do if((h|0)==(a|0)){k=0;l=0;m=13}else{n=a;o=h;while(1){p=c[o+40>>2]|0;c[e>>2]=p;do if(!(p&32768)){q=c[f>>2]|0;if((q|0)==(c[g>>2]|0)){JO(d,e);r=c[j>>2]|0;break}if(q)c[q>>2]=p;c[f>>2]=q+4;r=n}else{q=c[d>>2]|0;s=c[f>>2]|0;if((q|0)==(s|0)){t=0;u=q;v=q;break a}w=p&-32769;c[e>>2]=w;x=s+-4|0;if((c[x>>2]|0)!=(w|0)){t=0;u=q;v=s;break a}c[f>>2]=x;r=n}while(0);o=o+44|0;if((o|0)==(r|0))break;else n=r}k=c[d>>2]|0;l=c[f>>2]|0;m=13}while(0);if((m|0)==13){t=(k|0)==(l|0);u=k;v=l}if(!u){i=b;return t|0}if((v|0)!=(u|0))c[f>>2]=v+(~((v+-4-u|0)>>>2)<<2);ACi(u);i=b;return t|0}function $7d(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;g=i;i=i+96|0;h=g;j=g+56|0;k=g+44|0;l=g+16|0;m=g+32|0;n=g+4|0;o=g+20|0;p=g+68|0;q=g+80|0;r=c[e>>2]|0;s=d+4|0;t=c[s>>2]|0;if((r|0)>=(t|0)){i=g;return}u=f+40|0;v=j+1|0;w=f+20|0;x=j+8|0;y=k+1|0;z=f+16|0;A=k+8|0;B=f+12|0;C=n+1|0;D=f+24|0;E=n+8|0;F=o+1|0;G=f+28|0;H=o+8|0;I=p+1|0;J=f+32|0;K=p+8|0;L=q+1|0;M=f+36|0;f=q+8|0;N=r;r=t;while(1){t=c[d>>2]|0;if((b[t+(N<<1)>>1]|0)==62){O=20;break}else P=0;while(1){Q=c[723872+(P<<2)>>2]|0;R=a[Q>>0]|0;a:do if(!(R<<24>>24))O=8;else{S=R;T=0;while(1){U=T+N|0;if((U|0)==(r|0))break a;V=b[t+(U<<1)>>1]&255;U=V<<24>>24;T=T+1|0;if((((V+-65<<24>>24&255)<26?U+32|0:U)&255)<<24>>24!=S<<24>>24)break a;S=a[Q+T>>0]|0;if(!(S<<24>>24)){O=8;break}}}while(0);if((O|0)==8?(O=0,R=(SEi(Q|0)|0)+N|0,(b[t+(R<<1)>>1]|0)==61):0){W=R;X=P;O=10;break}P=P+1|0;if((P|0)>=10){Y=N;O=19;break}}b:do if((O|0)==10){O=0;c[e>>2]=W;switch(X|0){case 9:{Y7d(q,d,e,1);t=(a[q>>0]&1)==0?L:c[f>>2]|0;c[h>>2]=M;aCi(t,724272,h)|0;xri(q);break b;break}case -1:{Y=W;O=19;break b;break}case 8:{Y7d(p,d,e,1);t=(a[p>>0]&1)==0?I:c[K>>2]|0;c[h>>2]=J;aCi(t,724272,h)|0;xri(p);break b;break}case 7:{Y7d(o,d,e,1);t=(a[o>>0]&1)==0?F:c[H>>2]|0;c[h>>2]=G;aCi(t,724272,h)|0;xri(o);break b;break}case 3:{c[u>>2]=c[u>>2]|8;Y7d(k,d,e,1);c[z>>2]=Hsd((a[k>>0]&1)==0?y:c[A>>2]|0)|0;xri(k);break b;break}case 4:{c[u>>2]=c[u>>2]|16;Y7d(j,d,e,1);c[w>>2]=Hsd((a[j>>0]&1)==0?v:c[x>>2]|0)|0;xri(j);break b;break}case 6:{Y7d(n,d,e,1);t=(a[n>>0]&1)==0?C:c[E>>2]|0;c[h>>2]=D;aCi(t,724272,h)|0;xri(n);break b;break}case 2:{c[u>>2]=c[u>>2]|4;Y7d(m,d,e,1);Z7d(l,m);c[B>>2]=c[l>>2];xri(m);break b;break}default:break b}}while(0);if((O|0)==19){O=0;c[e>>2]=Y+1}N=c[e>>2]|0;r=c[s>>2]|0;if((N|0)>=(r|0)){O=20;break}}if((O|0)==20){i=g;return}}function a8d(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0;f=i;i=i+96|0;h=f+4|0;j=f+88|0;k=f+8|0;l=f+76|0;m=f;n=f+64|0;o=f+52|0;c[h>>2]=0;p=b+4|0;if((c[p>>2]|0)>0){q=k+8|0;r=k+12|0;s=k+16|0;t=k+20|0;u=k+24|0;v=k+32|0;w=k+28|0;x=k+36|0;y=k+40|0;z=l+1|0;A=l+8|0;B=k+12|0;C=o+1|0;D=o+8|0;E=k+4|0;F=d+4|0;G=d+8|0;H=0;do{I=X7d(b,h,j)|0;do if((I|0)!=-1){c[q>>2]=0;c[r>>2]=-1;c[s>>2]=0;c[t>>2]=0;g[u>>2]=ea(0.0);g[v>>2]=ea(1.0);g[w>>2]=ea(0.0);g[x>>2]=ea(1.0);c[y>>2]=32768;switch(I|0){case 5:{c[y>>2]=32;J=32800;break}case 3:{c[y>>2]=8;J=32776;break}case 1:{c[y>>2]=2;J=32770;break}case 0:{c[y>>2]=1;J=32769;break}case 4:{c[y>>2]=16;J=32784;break}case 2:{c[y>>2]=4;J=32772;break}default:J=32768}do if(!(a[j>>0]|0))if((I|0)==3){Y7d(l,b,h,0);c[s>>2]=~~ea(R(ea(ea(ea(Hsd((a[l>>0]&1)==0?z:c[A>>2]|0)|0)*e)+ea(.5))));xri(l);break}else if((I|0)==2){Y7d(n,b,h,0);Z7d(m,n);c[B>>2]=c[m>>2];xri(n);break}else if((I|0)==4){Y7d(o,b,h,0);c[t>>2]=Hsd((a[o>>0]&1)==0?C:c[D>>2]|0)|0;xri(o);break}else if((I|0)==5){$7d(b,h,k);break}else break;else c[y>>2]=J;while(0);K=c[h>>2]|0;c[E>>2]=1-H+K;c[k>>2]=H;L=c[F>>2]|0;if((L|0)==(c[G>>2]|0))b8d(d,k);else{if(!L)M=0;else{N=L+0|0;O=k+0|0;P=N+44|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));M=c[F>>2]|0}c[F>>2]=M+44}if((I|0)==5){c[y>>2]=c[y>>2]|32768;c[E>>2]=0;L=c[F>>2]|0;if((L|0)==(c[G>>2]|0)){b8d(d,k);Q=K;break}if(!L)S=0;else{N=L+0|0;O=k+0|0;P=N+44|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));S=c[F>>2]|0}c[F>>2]=S+44;Q=K}else Q=K}else Q=c[h>>2]|0;while(0);H=Q+1|0;c[h>>2]=H}while((H|0)<(c[p>>2]|0))}if(_7d(d)|0){i=f;return}p=c[d>>2]|0;H=d+4|0;d=c[H>>2]|0;if((d|0)==(p|0)){i=f;return}c[H>>2]=d+(~(((d+-44-p|0)>>>0)/44|0)*44|0);i=f;return}function b8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/44|0)+1|0;if(g>>>0>97612893)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/44|0;if(k>>>0<48806446){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/44|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=97612893;r=(l|0)/44|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*44|0)|0;o=r;p=s}s=n+(o*44|0)|0;r=n+(m*44|0)|0;if(s){m=s+0|0;s=b+0|0;b=m+44|0;do{c[m>>2]=c[s>>2];m=m+4|0;s=s+4|0}while((m|0)<(b|0))}s=n+((((p|0)/-44|0)+o|0)*44|0)|0;YEi(s|0,f|0,p|0)|0;c[a>>2]=s;c[e>>2]=n+((o+1|0)*44|0);c[h>>2]=r;if(!f){i=d;return}ACi(f);i=d;return}function c8d(b,d,e,f,h,j,k,l,m,n,o,p,q,r,s,t){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=n|0;o=o|0;p=p|0;q=ea(q);r=r|0;s=s|0;t=t|0;var u=0,v=0,w=0,x=Im,y=Im,z=Im;u=i;i=i+32|0;v=u;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+16>>2]=60;c[b+28>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+32>>2]=60;c[b+44>>2]=0;c[b+52>>2]=0;c[b+56>>2]=0;c[b+48>>2]=60;c[b+60>>2]=0;c[b+68>>2]=0;c[b+72>>2]=0;c[b+64>>2]=60;c[b+76>>2]=0;c[b+84>>2]=0;c[b+88>>2]=0;c[b+80>>2]=60;c[b+92>>2]=0;c[b+100>>2]=0;c[b+104>>2]=0;c[b+96>>2]=60;c[b+108>>2]=0;c[b+116>>2]=0;c[b+120>>2]=0;c[b+112>>2]=60;c[b+124>>2]=0;c[b+132>>2]=0;c[b+136>>2]=0;c[b+128>>2]=60;c[b+140>>2]=t;c[b+144>>2]=e;t=b+148|0;w=(h|0)!=0;if(w){x=ea(ea(ea(h|0)*q)+ea(.5));if(!(x>=ea(0.0)))y=ea(x+ea(-.99999994));else y=x}else{x=ea(ea(ea(c[e+32>>2]|0)*q)+ea(.5));if(!(x>=ea(0.0)))y=ea(x+ea(-.99999994));else y=x}c[t>>2]=~~y;xJc(b+152|0,d);c[b+164>>2]=n;n=j;j=c[n+4>>2]|0;d=b+168|0;c[d>>2]=c[n>>2];c[d+4>>2]=j;a[b+176>>0]=k&1;a[b+177>>0]=p&1;c[b+180>>2]=l;c[b+184>>2]=o;g[b+188>>2]=m;g[b+192>>2]=q;a[b+196>>0]=r&1;a[b+197>>0]=s&1;c[b+200>>2]=0;c[b+204>>2]=0;c[b+208>>2]=-1;c[b+212>>2]=0;c[b+216>>2]=0;c[b+220>>2]=0;s=b+276|0;r=b+232|0;o=r+44|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(o|0));r=c[f>>2]|0;if(w){m=ea(ea(ea(h|0)*q)+ea(.5));if(!(m>=ea(0.0)))z=ea(m+ea(-.99999994));else z=m}else{m=ea(ea(ea(c[e+32>>2]|0)*q)+ea(.5));if(!(m>=ea(0.0)))z=ea(m+ea(-.99999994));else z=m}c[s>>2]=0;e=b+280|0;c[e>>2]=0;c[b+284>>2]=0;c[v>>2]=0;c[v+4>>2]=-1;c[v+8>>2]=0;c[v+12>>2]=0;g[v+16>>2]=ea(0.0);g[v+24>>2]=ea(1.0);g[v+20>>2]=ea(0.0);g[v+28>>2]=ea(1.0);t6d(s,v);v=c[e>>2]|0;c[v+-28>>2]=r;c[v+-24>>2]=~~z;c[v+-32>>2]=l;l=b+288|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;a[b+304>>0]=1;c[b+308>>2]=0;c[b+316>>2]=0;c[b+320>>2]=0;c[b+312>>2]=60;c[b+324>>2]=0;c[b+332>>2]=0;c[b+336>>2]=0;c[b+328>>2]=60;c[b+340>>2]=0;c[b+348>>2]=0;c[b+352>>2]=0;c[b+344>>2]=60;c[b+356>>2]=0;c[b+364>>2]=0;c[b+368>>2]=0;c[b+360>>2]=60;i=u;return}function d8d(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,S=Im,T=0,U=Im,V=0,W=0,X=0;d=i;i=i+64|0;e=d;f=d+52|0;h=d+40|0;j=d+28|0;k=d+16|0;l=d+4|0;if(!(a[b+176>>0]|0))m=b;else{a8d(b+152|0,b,ea(g[b+192>>2]));m=b}n=b+148|0;o=c[n>>2]|0;p=b+228|0;c[p>>2]=1;q=c[b>>2]|0;r=b+4|0;if((q|0)==(c[r>>2]|0)){s=o;t=2147483647}else{u=h+1|0;v=h+8|0;w=b+192|0;x=q;q=1;y=o;o=2147483647;while(1){z=c[x+40>>2]|0;if(z&8){A=c[x+16>>2]|0;if(!A)B=ea(c[n>>2]|0);else{C=ea(A|0);B=ea(C*ea(g[w>>2]))}if(B>ea(y|0))D=~~B;else D=y;if(B<ea(o|0)){E=D;F=~~B}else{E=D;F=o}}else{E=y;F=o}if(z&48){z=x+20|0;A=c[z>>2]|0;if(A>>>0>7){c[e>>2]=8;Lsd(h,724280,e);Krd((a[h>>0]&1)==0?u:c[v>>2]|0,0,3653512,190,512,0,0,0);xri(h);c[z>>2]=0;G=0;H=c[p>>2]|0}else{G=A;H=q}if((G|0)<(H|0))I=H;else{A=G+1|0;c[p>>2]=A;I=A}}else I=q;x=x+44|0;if((x|0)==(c[r>>2]|0)){J=F;break}else{q=I;y=E;o=F}}s=c[n>>2]|0;t=J}J=(s|0)<(t|0)?s:t;vJc(j,1076904);RQb(1);t=b+144|0;s=c[t>>2]|0;F=c[j>>2]|0;o=c[j+4>>2]|0;E=c[n>>2]|0;y=b+180|0;I=c[y>>2]|0;c[k>>2]=0;q=k+4|0;c[q>>2]=0;c[k+8>>2]=0;a6d(s,F,o,E,I,k)|0;I=c[k>>2]|0;if(I){k=c[q>>2]|0;if((k|0)!=(I|0))c[q>>2]=k+(~(((k+-44-I|0)>>>0)/44|0)*44|0);ACi(I)}I=c[t>>2]|0;k=c[b+152>>2]|0;q=b+156|0;E=c[q>>2]|0;o=c[n>>2]|0;F=c[y>>2]|0;n8d(l,m);a6d(I,k,E,o,F,l)|0;F=c[l>>2]|0;if(F){o=l+4|0;l=c[o>>2]|0;if((l|0)!=(F|0))c[o>>2]=l+(~(((l+-44-F|0)>>>0)/44|0)*44|0);ACi(F)}RQb(0);B=ea(U5d(c[t>>2]|0,32,c[n>>2]|0,c[y>>2]|0));y=B==ea(0.0);C=y?ea(4.0):B;y=b+184|0;c[y>>2]=~~ea(C*ea(c[y>>2]|0));y=c[t>>2]|0;if((J|0)!=0?(t=c[y+32>>2]|0,(t|0)!=0):0)K=ea(ea(ea(J|0)*ea(g[y+28>>2]))/ea(t|0));else K=ea(g[y+28>>2]);C=ea(K*ea(g[b+188>>2]));if(!(a[b+177>>0]|0))L=C;else L=ea(R(ea(C+ea(.5))));g[b+232>>2]=L;y=b+288|0;g[y>>2]=L;t=c[b+292>>2]|0;J=b+296|0;n=c[J>>2]|0;if((n|0)!=(t|0))c[J>>2]=n+(~((n+-4-t|0)>>>2)<<2);g[b+264>>2]=ea(0.0);g[b+268>>2]=ea(0.0);g[b+272>>2]=ea(0.0);t=c[q>>2]|0;q=b+224|0;c[q>>2]=t;if(((t<<2)+4|0)>65535){Krd(724328,0,3653512,229,1,0,0,0);c[q>>2]=16382;M=16382}else M=t;t=b+308|0;n=M+1|0;M=b+316|0;c[M>>2]=n;J=b+320|0;F=c[J>>2]|0;do if((F&2147483647)>>>0<n>>>0)if((F|0)>-1){c[J>>2]=n;l=c[t>>2]|0;c[f>>2]=c[b+312>>2];c[e+0>>2]=c[f+0>>2];c[t>>2]=hOb(l,n<<3,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+312>>2];c[e+0>>2]=c[f+0>>2];l=cOb(n<<3,4,e,0,3653512,352)|0;YEi(l|0,c[t>>2]|0,c[M>>2]<<3|0)|0;c[J>>2]=n;c[t>>2]=l;break}while(0);t=b+356|0;n=(c[q>>2]|0)+1|0;J=b+364|0;c[J>>2]=n;M=b+368|0;F=c[M>>2]|0;do if((F&2147483647)>>>0<n>>>0)if((F|0)>-1){c[M>>2]=n;l=c[t>>2]|0;c[f>>2]=c[b+360>>2];c[e+0>>2]=c[f+0>>2];c[t>>2]=hOb(l,n<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[b+360>>2];c[e+0>>2]=c[f+0>>2];l=cOb(n<<2,4,e,0,3653512,352)|0;YEi(l|0,c[t>>2]|0,c[J>>2]<<2|0)|0;c[M>>2]=n;c[t>>2]=l;break}while(0);t=b+140|0;n=c[t>>2]|0;M=(c[q>>2]<<2)+4|0;q=n+8|0;c[q>>2]=M;J=n+12|0;F=c[J>>2]|0;if((F&2147483647)>>>0>=M>>>0){N=c[t>>2]|0;O=c[N>>2]|0;P=b+372|0;c[P>>2]=O;Q=b+376|0;c[Q>>2]=O;S=ea(g[y>>2]);T=b+172|0;U=ea(g[T>>2]);V=S<=U;W=b+304|0;X=V&1;a[W>>0]=X;wJc(j);i=d;return V|0}if((F|0)>-1){c[J>>2]=M;F=c[n>>2]|0;c[f>>2]=c[n+4>>2];c[e+0>>2]=c[f+0>>2];c[n>>2]=hOb(F,M*60|0,4,e,0,3653512,370)|0;N=c[t>>2]|0;O=c[N>>2]|0;P=b+372|0;c[P>>2]=O;Q=b+376|0;c[Q>>2]=O;S=ea(g[y>>2]);T=b+172|0;U=ea(g[T>>2]);V=S<=U;W=b+304|0;X=V&1;a[W>>0]=X;wJc(j);i=d;return V|0}else{c[f>>2]=c[n+4>>2];c[e+0>>2]=c[f+0>>2];f=cOb(M*60|0,4,e,0,3653512,352)|0;YEi(f|0,c[n>>2]|0,(c[q>>2]|0)*60|0)|0;c[J>>2]=M;c[n>>2]=f;N=c[t>>2]|0;O=c[N>>2]|0;P=b+372|0;c[P>>2]=O;Q=b+376|0;c[Q>>2]=O;S=ea(g[y>>2]);T=b+172|0;U=ea(g[T>>2]);V=S<=U;W=b+304|0;X=V&1;a[W>>0]=X;wJc(j);i=d;return V|0}return 0}function e8d(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e+4|0;h=e;j=a+324|0;k=a+332|0;l=(c[k>>2]|0)+1|0;c[k>>2]=l;m=a+336|0;n=c[m>>2]|0;o=n&2147483647;if(l>>>0>o>>>0){p=n<<1;q=(p|0)==0?1:p;do if(o>>>0<q>>>0)if((n|0)>-1){c[m>>2]=q;p=c[j>>2]|0;c[h>>2]=c[a+328>>2];c[f+0>>2]=c[h+0>>2];c[j>>2]=hOb(p,q<<2,4,f,0,3653512,370)|0;break}else{c[h>>2]=c[a+328>>2];c[f+0>>2]=c[h+0>>2];p=cOb(q<<2,4,f,0,3653512,352)|0;YEi(p|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[m>>2]=q;c[j>>2]=p;break}while(0);r=c[k>>2]|0}else r=l;c[(c[j>>2]|0)+(r+-1<<2)>>2]=b;b=a+340|0;r=a+348|0;j=(c[r>>2]|0)+1|0;c[r>>2]=j;l=a+352|0;k=c[l>>2]|0;q=k&2147483647;if(j>>>0<=q>>>0){s=j;t=s+-1|0;u=c[b>>2]|0;v=u+(t<<2)|0;g[v>>2]=d;i=e;return}j=k<<1;m=(j|0)==0?1:j;do if(q>>>0<m>>>0)if((k|0)>-1){c[l>>2]=m;j=c[b>>2]|0;c[h>>2]=c[a+344>>2];c[f+0>>2]=c[h+0>>2];c[b>>2]=hOb(j,m<<2,4,f,0,3653512,370)|0;break}else{c[h>>2]=c[a+344>>2];c[f+0>>2]=c[h+0>>2];j=cOb(m<<2,4,f,0,3653512,352)|0;YEi(j|0,c[b>>2]|0,c[r>>2]<<2|0)|0;c[l>>2]=m;c[b>>2]=j;break}while(0);s=c[r>>2]|0;t=s+-1|0;u=c[b>>2]|0;v=u+(t<<2)|0;g[v>>2]=d;i=e;return}function f8d(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=0,y=0;d=i;e=b+372|0;f=c[e>>2]|0;h=f+60|0;j=f+120|0;k=f+180|0;l=b+264|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];aFi(j|0,l|0,12)|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[e>>2]=(c[e>>2]|0)+240;e=b+204|0;j=c[e>>2]|0;g[(c[b+356>>2]|0)+(j<<2)>>2]=ea(0.0);f=b+236|0;m=ea(g[f>>2]);h=b+216|0;k=c[h>>2]|0;n=b+376|0;o=(c[n>>2]|0)+((k<<2)*60|0)|0;p=(c[b+308>>2]|0)+(k<<3)|0;q=j-k+1|0;k=c[b+164>>2]|0;if((k|0)==2){if(q){j=o;r=q<<2;while(1){r=r+-1|0;g[j>>2]=ea(ea(g[j>>2])-m);s=j+4|0;g[s>>2]=ea(ea(g[s>>2])+ea(0.0));if(!r)break;else j=j+60|0}if(p){j=p;r=q;while(1){r=r+-1|0;g[j>>2]=ea(ea(g[j>>2])-m);s=j+4|0;g[s>>2]=ea(ea(g[s>>2])+ea(0.0));if(!r)break;else j=j+8|0}}}}else if((k|0)==1){t=ea(m*ea(-.5));if(!(a[b+177>>0]|0))u=t;else u=ea(R(ea(t+ea(.5))));if(q){k=o;o=q<<2;while(1){o=o+-1|0;g[k>>2]=ea(u+ea(g[k>>2]));j=k+4|0;g[j>>2]=ea(ea(g[j>>2])+ea(0.0));if(!o)break;else k=k+60|0}if(p){k=p;p=q;while(1){p=p+-1|0;g[k>>2]=ea(u+ea(g[k>>2]));q=k+4|0;g[q>>2]=ea(ea(g[q>>2])+ea(0.0));if(!p)break;else k=k+8|0}}}}k=b+232|0;u=ea(g[k>>2]);p=b+144|0;q=c[p>>2]|0;if((c[q+76>>2]|0)==-2){t=ea(b6d(q,ea(u/ea(g[b+188>>2]))));q=c[p>>2]|0;m=ea(g[q+208>>2]);v=ea(m*ea(ea(t/ea(c[q+32>>2]|0))+ea(-1.0)));if(!(a[b+177>>0]|0))w=v;else w=ea(R(ea(v+ea(.5))))}else w=ea(u-ea(g[b+288>>2]));q=w!=ea(0.0);p=c[h>>2]|0;if(q?(q=(c[e>>2]|0)-p+1|0,(q|0)!=0):0){o=(c[n>>2]|0)+((p<<2)*60|0)|0;n=q<<2;while(1){n=n+-1|0;g[o>>2]=ea(ea(g[o>>2])+ea(0.0));q=o+4|0;g[q>>2]=ea(w+ea(g[q>>2]));if(!n)break;else o=o+60|0}}e8d(b,p,ea(g[k>>2]));p=b+260|0;w=ea(g[p>>2]);u=ea(g[f>>2]);g[p>>2]=w<u?u:w;w=ea(g[k>>2]);p=b+268|0;u=ea(w+ea(g[p>>2]));g[p>>2]=u;p=c[e>>2]|0;w=ea(u+ea(g[(c[b+292>>2]|0)+(p<<2)>>2]));if(w>ea(g[b+172>>2]))if(!(a[b+197>>0]|0)){x=0;i=d;return x|0}else y=0;else y=1;g[k>>2]=ea(g[b+288>>2]);g[l>>2]=ea(0.0);g[f>>2]=ea(0.0);g[b+252>>2]=ea(0.0);c[b+256>>2]=0;f=p+1|0;c[b+220>>2]=f;c[b+212>>2]=f;c[h>>2]=f;x=y;i=d;return x|0}function g8d(b){b=b|0;var d=0,e=0,f=Im,h=0,j=0,k=0,l=Im,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=Im,y=0,z=0,A=Im,B=0,C=0;d=i;e=b+252|0;if(ea(g[e>>2])==ea(0.0)){f=ea(g[b+264>>2]);g[b+244>>2]=f;c[b+220>>2]=c[b+204>>2];h=b+264|0;j=h;k=h;l=f}else{h=b+264|0;j=h;k=h;l=ea(g[h>>2])}g[e>>2]=ea(0.0);h=b+256|0;c[h>>2]=0;m=c[b+184>>2]|0;f=ea(l/ea(m|0));if(!(f>=ea(0.0)))n=ea(f+ea(-.99999994));else n=f;f=ea(g[b+168>>2]);l=ea(da(m,~~n+1|0)|0);if(!(f>ea(0.0)&l>f)){g[j>>2]=l;g[b+236>>2]=l;m=b+372|0;o=c[m>>2]|0;p=o+60|0;q=o+120|0;r=o+180|0;c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];aFi(q|0,k|0,12)|0;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[m>>2]=(c[m>>2]|0)+240;c[b+212>>2]=(c[b+204>>2]|0)+1;g[b+240>>2]=ea(0.0);g[b+248>>2]=ea(g[j>>2]);s=1;i=d;return s|0}m=b+372|0;q=c[m>>2]|0;o=q+60|0;p=q+120|0;r=q+180|0;c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];aFi(p|0,k|0,12)|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[q+0>>2]=c[p+0>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[m>>2]=(c[m>>2]|0)+240;m=b+204|0;p=c[m>>2]|0;g[(c[b+356>>2]|0)+(p<<2)>>2]=ea(0.0);q=b+236|0;l=ea(g[q>>2]);o=b+216|0;k=c[o>>2]|0;r=b+376|0;t=(c[r>>2]|0)+((k<<2)*60|0)|0;u=b+308|0;v=(c[u>>2]|0)+(k<<3)|0;w=p-k+1|0;k=c[b+164>>2]|0;if((k|0)==1){f=ea(l*ea(-.5));if(!(a[b+177>>0]|0))x=f;else x=ea(R(ea(f+ea(.5))));if(w){p=t;y=w<<2;while(1){y=y+-1|0;g[p>>2]=ea(x+ea(g[p>>2]));z=p+4|0;g[z>>2]=ea(ea(g[z>>2])+ea(0.0));if(!y)break;else p=p+60|0}if(v){p=v;y=w;while(1){y=y+-1|0;g[p>>2]=ea(x+ea(g[p>>2]));z=p+4|0;g[z>>2]=ea(ea(g[z>>2])+ea(0.0));if(!y)break;else p=p+8|0}}}}else if((k|0)==2?(w|0)!=0:0){k=t;t=w<<2;while(1){t=t+-1|0;g[k>>2]=ea(ea(g[k>>2])-l);p=k+4|0;g[p>>2]=ea(ea(g[p>>2])+ea(0.0));if(!t)break;else k=k+60|0}if(v){k=v;v=w;while(1){v=v+-1|0;g[k>>2]=ea(ea(g[k>>2])-l);w=k+4|0;g[w>>2]=ea(ea(g[w>>2])+ea(0.0));if(!v)break;else k=k+8|0}}}k=b+232|0;l=ea(g[k>>2]);v=b+144|0;w=c[v>>2]|0;if((c[w+76>>2]|0)==-2){x=ea(b6d(w,ea(l/ea(g[b+188>>2]))));w=c[v>>2]|0;f=ea(g[w+208>>2]);n=ea(f*ea(ea(x/ea(c[w+32>>2]|0))+ea(-1.0)));if(!(a[b+177>>0]|0))A=n;else A=ea(R(ea(n+ea(.5))))}else A=ea(l-ea(g[b+288>>2]));w=A!=ea(0.0);v=c[o>>2]|0;if(w?(w=(c[u>>2]|0)+(v<<3)|0,u=(c[m>>2]|0)-v+1|0,(u|0)!=0):0){t=(c[r>>2]|0)+((v<<2)*60|0)|0;r=u<<2;while(1){r=r+-1|0;g[t>>2]=ea(ea(g[t>>2])+ea(0.0));p=t+4|0;g[p>>2]=ea(A+ea(g[p>>2]));if(!r){B=w;C=u;break}else t=t+60|0}while(1){C=C+-1|0;g[B>>2]=ea(ea(g[B>>2])+ea(0.0));t=B+4|0;g[t>>2]=ea(A+ea(g[t>>2]));if(!C)break;else B=B+8|0}}e8d(b,v,ea(g[k>>2]));v=b+260|0;A=ea(g[v>>2]);l=ea(g[q>>2]);g[v>>2]=A<l?l:A;A=ea(g[k>>2]);v=b+268|0;l=ea(A+ea(g[v>>2]));g[v>>2]=l;v=c[m>>2]|0;A=ea(l+ea(g[(c[b+292>>2]|0)+(v<<2)>>2]));if(A>ea(g[b+172>>2])?(a[b+304>>0]=0,(a[b+197>>0]|0)==0):0){s=0;i=d;return s|0}g[k>>2]=ea(g[b+288>>2]);g[j>>2]=ea(0.0);g[q>>2]=ea(0.0);g[e>>2]=ea(0.0);c[h>>2]=0;h=v+1|0;c[b+220>>2]=h;c[b+212>>2]=h;c[o>>2]=h;s=1;i=d;return s|0}function h8d(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=Im,x=0,y=0,z=Im,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=Im,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=Im,_=Im,$=0,aa=Im,ba=0,ca=0,da=0,fa=0,ga=Im,ha=0,ia=0,ja=0,ka=Im,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=Im;f=i;i=i+48|0;h=f+16|0;j=f;k=f+44|0;l=f+40|0;m=f+34|0;n=f+32|0;o=f+38|0;p=f+36|0;q=f+42|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;r=d+144|0;s=d+280|0;t=c[s>>2]|0;S5d(c[r>>2]|0,e,c[t+-24>>2]|0,c[t+-32>>2]|0,h,j,k);t=c[s>>2]|0;u=ea(U5d(c[r>>2]|0,e,c[t+-24>>2]|0,c[t+-32>>2]|0));t=d+177|0;v=(a[t>>0]|0)==0;if(v)w=u;else w=ea(R(ea(u+ea(.5))));x=d+204|0;g[(c[d+356>>2]|0)+(c[x>>2]<<2)>>2]=w;y=h+4|0;u=ea(g[y>>2]);if(v){g[y>>2]=u;z=ea(g[h>>2]);A=h+12|0;B=ea(g[A>>2]);C=z;D=u;E=h;F=h+8|0;G=A}else{z=ea(R(ea(u+ea(.5))));g[y>>2]=z;u=ea(R(ea(ea(g[h>>2])+ea(.5))));g[h>>2]=u;A=h+8|0;g[A>>2]=ea(R(ea(ea(g[A>>2])+ea(.5))));H=h+12|0;B=ea(R(ea(ea(g[H>>2])+ea(.5))));C=u;D=z;E=h;F=A;G=H}g[G>>2]=B;H=c[r>>2]|0;A=c[H+48>>2]|0;h=c[H+52>>2]|0;if((A|0)!=(h|0)?(I=c[d+208>>2]|0,(I|0)!=-1):0){J=h-A>>3;if(!J)K=A;else{L=I&255;M=e&255;N=A;A=J;while(1){J=(A|0)/2|0;O=b[N+(J<<3)>>1]&255;if(O<<24>>24==L<<24>>24?(b[N+(J<<3)+2>>1]&255)<<24>>24<M<<24>>24:O<<24>>24<L<<24>>24){P=N+(J+1<<3)|0;Q=A+-1-J|0}else{P=N;Q=J}if(!Q){K=P;break}else{N=P;A=Q}}}if((K|0)!=(h|0)?(Q=I&255,I=b[K>>1]&255,A=(Q<<24>>24==I<<24>>24?(e&255)<<24>>24<(b[K+2>>1]&255)<<24>>24:Q<<24>>24<I<<24>>24)?h:K,(A|0)!=(h|0)):0){B=ea(g[A+4>>2]);A=c[d+148>>2]|0;if(A){z=ea(B*ea(A|0));u=ea(z/ea(c[H+32>>2]|0));if(v)S=u;else S=ea(R(ea(u+ea(.5))))}else S=B;v=d+264|0;g[v>>2]=ea(S+ea(g[v>>2]))}}v=d+372|0;H=c[v>>2]|0;A=d+264|0;S=ea(C+ea(g[A>>2]));h=d+268|0;C=ea(ea(g[h>>2])-D);K=d+272|0;D=ea(ea(g[K>>2])+ea(0.0));g[H>>2]=S;g[H+4>>2]=C;g[H+8>>2]=D;H=(a[k>>0]|0)!=0;D=ea(g[j>>2]);k=j+4|0;C=ea(g[k>>2]);I=j+12|0;S=ea(C+ea(g[I>>2]));C=ea(D);D=ea(S);Q=(c[v>>2]|0)+((H?2:0)*60|0)+28|0;g[Q>>2]=C;g[Q+4>>2]=D;Q=c[v>>2]|0;D=ea(g[E>>2]);C=ea(D+ea(g[F>>2]));D=ea(g[y>>2]);S=ea(C+ea(g[A>>2]));C=ea(ea(g[h>>2])-D);D=ea(ea(g[K>>2])+ea(0.0));g[Q+60>>2]=S;g[Q+64>>2]=C;g[Q+68>>2]=D;D=ea(g[j>>2]);Q=j+8|0;C=ea(D+ea(g[Q>>2]));D=ea(g[k>>2]);S=ea(D+ea(g[I>>2]));D=ea(C);C=ea(S);I=(c[v>>2]|0)+88|0;g[I>>2]=D;g[I+4>>2]=C;I=c[v>>2]|0;C=ea(g[E>>2]);D=ea(C+ea(g[F>>2]));C=ea(g[y>>2]);S=ea(C+ea(g[G>>2]));C=ea(D+ea(g[A>>2]));D=ea(ea(g[h>>2])-S);S=ea(ea(g[K>>2])+ea(0.0));g[I+120>>2]=C;g[I+124>>2]=D;g[I+128>>2]=S;S=ea(g[j>>2]);D=ea(S+ea(g[Q>>2]));S=ea(g[k>>2]);C=ea(D);D=ea(S);Q=(c[v>>2]|0)+((H?0:2)*60|0)+28|0;g[Q>>2]=C;g[Q+4>>2]=D;Q=c[v>>2]|0;D=ea(g[E>>2]);C=ea(g[y>>2]);S=ea(C+ea(g[G>>2]));C=ea(D+ea(g[A>>2]));D=ea(ea(g[h>>2])-S);S=ea(ea(g[K>>2])+ea(0.0));g[Q+180>>2]=C;g[Q+184>>2]=D;g[Q+188>>2]=S;S=ea(g[j>>2]);D=ea(g[k>>2]);C=ea(S);S=ea(D);k=(c[v>>2]|0)+208|0;g[k>>2]=C;g[k+4>>2]=S;k=c[s>>2]|0;s=k+-28|0;do if(a[d+196>>0]|0)if(!(a[621175]|0)){j=c[s>>2]|0;T=j>>>24&255;U=j>>>16&255;V=j>>>8&255;W=j&255;break}else{T=a[k+-25>>0]|0;U=a[s>>0]|0;V=a[k+-27>>0]|0;W=a[k+-26>>0]|0;break}else{j=c[s>>2]|0;T=j>>>24&255;U=j>>>16&255;V=j>>>8&255;W=j&255}while(0);s=c[v>>2]|0;j=(U&255)<<16|(T&255)<<24|(V&255)<<8|W&255;c[s+204>>2]=j;c[s+144>>2]=j;c[s+84>>2]=j;c[s+24>>2]=j;c[v>>2]=s+240;s=c[x>>2]<<2;j=d+(c[k+-20>>2]<<4)+12|0;b[l>>1]=s|1;mJd(j,l);l=(s|2)&65535;b[m>>1]=l;mJd(j,m);m=s&65535;b[n>>1]=m;mJd(j,n);b[o>>1]=l;mJd(j,o);b[p>>1]=s|3;mJd(j,p);b[q>>1]=m;mJd(j,q);q=c[x>>2]|0;j=c[d+292>>2]|0;S=ea(g[j+(q<<2)>>2]);m=d+232|0;if(S>ea(g[m>>2]))g[m>>2]=S;S=ea(g[d+168>>2]);p=S>ea(0.0);C=ea(g[A>>2]);if(p&ea(w+C)>S){p=d+212|0;s=c[p>>2]|0;o=d+216|0;l=c[o>>2]|0;if((s|0)==(l|0)){c[p>>2]=q;g[d+240>>2]=ea(0.0);g[d+248>>2]=C;g[d+244>>2]=C;c[d+220>>2]=s;X=q}else X=s;s=d+288|0;S=ea(g[j+(l<<2)>>2]);a:do if((l|0)<(X|0)){D=S;B=S;n=l;while(1){u=D<B?B:D;k=n+1|0;if((k|0)>=(X|0)){Y=u;break a}D=ea(g[j+(k<<2)>>2]);B=u;n=k}}else Y=S;while(0);S=ea(g[s>>2]);g[m>>2]=S;if((X|0)>(q|0))Z=S;else{B=S;s=X;while(1){D=ea(g[j+(s<<2)>>2]);u=D<B?B:D;g[m>>2]=u;if((s|0)<(q|0)){B=u;s=s+1|0}else{Z=u;break}}}B=ea(ea(Y+ea(g[h>>2]))+Z);if(B>ea(g[d+172>>2])?(a[d+304>>0]=0,(a[d+197>>0]|0)==0):0)if((X|0)<(q|0)){B=Y;s=X;while(1){Z=ea(g[j+(s<<2)>>2]);u=Z<B?B:Z;s=s+1|0;if((s|0)>=(q|0)){_=u;$=1;break}else B=u}}else{_=Y;$=1}else{_=Y;$=0}q=c[r>>2]|0;if((c[q+76>>2]|0)==-2){Y=ea(b6d(q,ea(_/ea(g[d+188>>2]))));q=c[r>>2]|0;B=ea(g[q+208>>2]);u=ea(B*ea(ea(Y/ea(c[q+32>>2]|0))+ea(-1.0)));if(!(a[t>>0]|0))aa=u;else aa=ea(R(ea(u+ea(.5))))}else aa=ea(_-S);q=aa!=ea(0.0);r=c[o>>2]|0;if(q?(q=(c[d+308>>2]|0)+(r<<3)|0,s=c[($?x:p)>>2]|0,j=s-r|0,(s|0)!=(r|0)):0){s=(c[d+376>>2]|0)+((r<<2)*60|0)|0;X=j<<2;while(1){X=X+-1|0;g[s>>2]=ea(ea(g[s>>2])+ea(0.0));m=s+4|0;g[m>>2]=ea(aa+ea(g[m>>2]));if(!X){ba=q;ca=j;break}else s=s+60|0}while(1){ca=ca+-1|0;g[ba>>2]=ea(ea(g[ba>>2])+ea(0.0));s=ba+4|0;g[s>>2]=ea(aa+ea(g[s>>2]));if(!ca)break;else ba=ba+8|0}}e8d(d,r,_);if($){c[v>>2]=(c[v>>2]|0)+-240;aa=ea(g[A>>2]);S=ea(aa-ea(g[d+252>>2]));v=c[o>>2]|0;$=(c[d+376>>2]|0)+((v<<2)*60|0)|0;r=(c[d+308>>2]|0)+(v<<3)|0;ba=(c[x>>2]|0)-(c[d+256>>2]|0)|0;ca=ba-v|0;s=c[d+164>>2]|0;if((s|0)==2){if((ba|0)!=(v|0)){j=$;q=ca<<2;while(1){q=q+-1|0;g[j>>2]=ea(ea(g[j>>2])-S);X=j+4|0;g[X>>2]=ea(ea(g[X>>2])+ea(0.0));if(!q){da=r;fa=ca;break}else j=j+60|0}while(1){fa=fa+-1|0;g[da>>2]=ea(ea(g[da>>2])-S);j=da+4|0;g[j>>2]=ea(ea(g[j>>2])+ea(0.0));if(!fa)break;else da=da+8|0}}}else if((s|0)==1){aa=ea(S*ea(-.5));if(!(a[t>>0]|0))ga=aa;else ga=ea(R(ea(aa+ea(.5))));if((ba|0)!=(v|0)){v=$;$=ca<<2;while(1){$=$+-1|0;g[v>>2]=ea(ga+ea(g[v>>2]));ba=v+4|0;g[ba>>2]=ea(ea(g[ba>>2])+ea(0.0));if(!$){ha=r;ia=ca;break}else v=v+60|0}while(1){ia=ia+-1|0;g[ha>>2]=ea(ga+ea(g[ha>>2]));v=ha+4|0;g[v>>2]=ea(ea(g[v>>2])+ea(0.0));if(!ia)break;else ha=ha+8|0}}}ha=d+260|0;ga=ea(g[ha>>2]);aa=ea(g[A>>2]);g[ha>>2]=ga<aa?aa:ga;g[h>>2]=ea(_+ea(g[h>>2]));ja=0;i=f;return ja|0}ga=ea(g[d+244>>2]);ha=c[o>>2]|0;ia=c[d+376>>2]|0;v=ia+((ha<<2)*60|0)|0;ca=c[d+308>>2]|0;r=ca+(ha<<3)|0;$=c[p>>2]|0;p=$-ha|0;ba=c[d+164>>2]|0;if((ba|0)==1){aa=ea(ga*ea(-.5));if(!(a[t>>0]|0))ka=aa;else ka=ea(R(ea(aa+ea(.5))));if(($|0)!=(ha|0)){t=v;s=p<<2;while(1){s=s+-1|0;g[t>>2]=ea(ka+ea(g[t>>2]));da=t+4|0;g[da>>2]=ea(ea(g[da>>2])+ea(0.0));if(!s){la=r;ma=p;break}else t=t+60|0}while(1){ma=ma+-1|0;g[la>>2]=ea(ka+ea(g[la>>2]));t=la+4|0;g[t>>2]=ea(ea(g[t>>2])+ea(0.0));if(!ma)break;else la=la+8|0}}}else if((ba|0)==2?($|0)!=(ha|0):0){ha=v;v=p<<2;while(1){v=v+-1|0;g[ha>>2]=ea(ea(g[ha>>2])-ga);ba=ha+4|0;g[ba>>2]=ea(ea(g[ba>>2])+ea(0.0));if(!v){na=r;oa=p;break}else ha=ha+60|0}while(1){oa=oa+-1|0;g[na>>2]=ea(ea(g[na>>2])-ga);ha=na+4|0;g[ha>>2]=ea(ea(g[ha>>2])+ea(0.0));if(!oa)break;else na=na+8|0}}na=d+260|0;oa=d+248|0;ga=ea(g[na>>2]);ka=ea(g[oa>>2]);g[na>>2]=ga<ka?ka:ga;g[h>>2]=ea(_+ea(g[h>>2]));h=ca+($<<3)|0;ca=(c[x>>2]|0)-$+1|0;if(ca){x=ia+(($<<2)*60|0)|0;ia=ca<<2;while(1){ia=ia+-1|0;g[x>>2]=ea(ea(g[x>>2])-ka);na=x+4|0;g[na>>2]=ea(_+ea(g[na>>2]));if(!ia){pa=h;qa=ca;break}else x=x+60|0}while(1){qa=qa+-1|0;g[pa>>2]=ea(ea(g[pa>>2])-ka);x=pa+4|0;g[x>>2]=ea(_+ea(g[x>>2]));if(!qa)break;else pa=pa+8|0}}_=ea(g[oa>>2]);ka=ea(ea(g[A>>2])-_);g[A>>2]=ka;g[d+236>>2]=ea(g[d+240>>2]);c[o>>2]=$;g[oa>>2]=ea(0.0);c[d+220>>2]=$;ra=ka}else ra=C;$=d+240|0;g[$>>2]=ea(w+ea(g[$>>2]));g[A>>2]=ea(w+ra);A=d+252|0;ra=ea(w+ea(g[A>>2]));$=d+236|0;g[$>>2]=ea(ea(g[$>>2])+ra);g[A>>2]=ea(0.0);c[d+256>>2]=0;c[d+208>>2]=e;ja=1;i=f;return ja|0}function i8d(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=Im,Z=0,_=Im,$=Im,aa=Im,ba=0,ca=Im,da=Im,fa=Im,ga=Im,ha=Im,ia=Im,ja=0,ka=0,la=0,ma=0,na=Im,oa=0,pa=0,qa=Im,ra=Im;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+10|0;k=e+14|0;l=e+6|0;m=e+4|0;n=e;o=d+200|0;p=c[o>>2]|0;q=d+4|0;r=c[d>>2]|0;a:do if((p|0)<(((c[q>>2]|0)-r|0)/44|0|0)){s=d+204|0;t=d+224|0;u=d+276|0;v=d+280|0;w=d+284|0;x=d+372|0;y=d+144|0;z=d+264|0;A=d+268|0;B=d+272|0;C=d+177|0;D=d+236|0;E=d+232|0;F=d+264|0;G=d+296|0;H=d+300|0;I=d+292|0;J=r;K=p;while(1){L=c[s>>2]|0;if((L|0)<(c[J+(K*44|0)>>2]|0)){M=y;N=v;break a}O=c[J+(K*44|0)+4>>2]|0;P=O+L|0;c[s>>2]=P;L=c[t>>2]|0;if((P|0)>(L|0)){Q=L;break}if((O|0)>0){O=0;do{L=c[x>>2]|0;P=L+60|0;S=L+120|0;T=L+180|0;c[T+0>>2]=c[F+0>>2];c[T+4>>2]=c[F+4>>2];c[T+8>>2]=c[F+8>>2];aFi(S|0,F|0,12)|0;c[P+0>>2]=c[S+0>>2];c[P+4>>2]=c[S+4>>2];c[P+8>>2]=c[S+8>>2];c[L+0>>2]=c[S+0>>2];c[L+4>>2]=c[S+4>>2];c[L+8>>2]=c[S+8>>2];c[x>>2]=(c[x>>2]|0)+240;S=c[G>>2]|0;if((S|0)==(c[H>>2]|0))_1b(I,E);else{if(S)g[S>>2]=ea(g[E>>2]);c[G>>2]=S+4}O=O+1|0;S=c[o>>2]|0;L=c[d>>2]|0}while((O|0)<(c[L+(S*44|0)+4>>2]|0));U=S;V=L}else{U=K;V=J}O=V+(U*44|0)+40|0;L=c[v>>2]|0;S=L+-32|0;if(!(c[O>>2]&32768)){if((L|0)==(c[w>>2]|0))t6d(u,S);else{if(!L)W=0;else{c[L+0>>2]=c[S+0>>2];c[L+4>>2]=c[S+4>>2];c[L+8>>2]=c[S+8>>2];c[L+12>>2]=c[S+12>>2];c[L+16>>2]=c[S+16>>2];c[L+20>>2]=c[S+20>>2];c[L+24>>2]=c[S+24>>2];c[L+28>>2]=c[S+28>>2];W=c[v>>2]|0}c[v>>2]=W+32}L=c[O>>2]|0;if(L&1){P=(c[v>>2]|0)+-32|0;c[P>>2]=c[P>>2]|1}if(L&2){P=(c[v>>2]|0)+-32|0;c[P>>2]=c[P>>2]|2}if(!(L&4))X=L;else{c[(c[v>>2]|0)+-28>>2]=c[V+(U*44|0)+12>>2];X=c[O>>2]|0}if(X&8)c[(c[v>>2]|0)+-24>>2]=c[V+(U*44|0)+16>>2];if(X&16)c[(c[v>>2]|0)+-20>>2]=c[V+(U*44|0)+20>>2]}else c[v>>2]=S;S=c[o>>2]|0;O=c[d>>2]|0;if((c[O+(S*44|0)+40>>2]&32800|0)==32){L=c[x>>2]|0;P=L+-240|0;c[x>>2]=P;Y=ea(c[(c[v>>2]|0)+-24>>2]|0);T=c[y>>2]|0;Z=c[T+32>>2]|0;if(!Z){_=ea(g[T+208>>2]);$=_;aa=_}else{ba=Y==ea(0.0);_=ea(Z|0);ca=ea((ba?_:Y)/_);_=ea(g[T+208>>2]);$=_;aa=ea(ca*_)}_=ea(ea(g[z>>2])+ea(0.0));ca=ea($+ea(g[A>>2]));Y=ea(ea(g[B>>2])+ea(0.0));T=O+(S*44|0)+32|0;da=ea(g[T>>2]);ba=O+(S*44|0)+36|0;fa=ea(da/ea(g[ba>>2]));da=ea(ca-aa);g[P>>2]=_;g[L+-236>>2]=da;g[L+-232>>2]=Y;L=O+(S*44|0)+24|0;ga=ea(g[L>>2]);P=O+(S*44|0)+28|0;ha=ea(g[P>>2]);ia=ea(ha+ea(g[ba>>2]));ha=ea(ga);ga=ea(ia);Z=(c[x>>2]|0)+28|0;g[Z>>2]=ha;g[Z+4>>2]=ga;Z=c[x>>2]|0;ga=ea(aa*fa);fa=ea(_+ga);g[Z+60>>2]=fa;g[Z+64>>2]=da;g[Z+68>>2]=Y;da=ea(g[L>>2]);ha=ea(da+ea(g[T>>2]));da=ea(g[P>>2]);ia=ea(da+ea(g[ba>>2]));da=ea(ha);ha=ea(ia);ba=(c[x>>2]|0)+88|0;g[ba>>2]=da;g[ba+4>>2]=ha;ba=c[x>>2]|0;ha=ea(ca+ea(0.0));g[ba+120>>2]=fa;g[ba+124>>2]=ha;g[ba+128>>2]=Y;fa=ea(g[L>>2]);ca=ea(fa+ea(g[T>>2]));fa=ea(g[P>>2]);da=ea(ca);ca=ea(fa);T=(c[x>>2]|0)+148|0;g[T>>2]=da;g[T+4>>2]=ca;T=c[x>>2]|0;g[T+180>>2]=_;g[T+184>>2]=ha;g[T+188>>2]=Y;Y=ea(g[L>>2]);ha=ea(g[P>>2]);_=ea(Y);Y=ea(ha);P=(c[x>>2]|0)+208|0;g[P>>2]=_;g[P+4>>2]=Y;P=c[v>>2]|0;L=P+-28|0;if(!(a[621175]|0)){T=c[L>>2]|0;ja=T>>>24&255;ka=T>>>16&255;la=T>>>8&255;ma=T&255}else{ja=a[P+-25>>0]|0;ka=a[L>>0]|0;la=a[P+-27>>0]|0;ma=a[P+-26>>0]|0}L=c[x>>2]|0;T=(ka&255)<<16|(ja&255)<<24|(la&255)<<8|ma&255;c[L+204>>2]=T;c[L+144>>2]=T;c[L+84>>2]=T;c[L+24>>2]=T;if(!(a[C>>0]|0))na=ga;else na=ea(R(ea(ga+ea(.5))));Y=ea(na+ea(g[z>>2]));g[z>>2]=Y;g[A>>2]=ea(ea(g[A>>2])+ea(0.0));g[B>>2]=ea(ea(g[B>>2])+ea(0.0));g[D>>2]=Y;if(ea(g[E>>2])<ga)g[E>>2]=ga;c[x>>2]=L+240;L=c[s>>2]<<2;T=d+(c[P+-20>>2]<<4)+12|0;b[f>>1]=L+65533;mJd(T,f);P=L+65534&65535;b[h>>1]=P;mJd(T,h);ba=L+65532&65535;b[j>>1]=ba;mJd(T,j);b[k>>1]=P;mJd(T,k);b[l>>1]=L+65535;mJd(T,l);b[m>>1]=ba;mJd(T,m);oa=c[o>>2]|0;pa=c[d>>2]|0}else{oa=S;pa=O}K=oa+1|0;c[o>>2]=K;if((K|0)>=(((c[q>>2]|0)-pa|0)/44|0|0)){M=y;N=v;break a}else J=pa}c[s>>2]=Q;J=c[G>>2]|0;if((J|0)==(c[H>>2]|0)){_1b(I,E);i=e;return}if(J)g[J>>2]=ea(g[E>>2]);c[G>>2]=J+4;i=e;return}else{M=d+144|0;N=d+280|0}while(0);Q=c[(c[N>>2]|0)+-24>>2]|0;N=c[M>>2]|0;if((Q|0)!=0?(M=c[N+32>>2]|0,(M|0)!=0):0)qa=ea(ea(ea(Q|0)*ea(g[N+28>>2]))/ea(M|0));else qa=ea(g[N+28>>2]);na=ea(qa*ea(g[d+188>>2]));if(!(a[d+177>>0]|0))ra=na;else ra=ea(R(ea(na+ea(.5))));g[n>>2]=ra;N=d+296|0;M=c[N>>2]|0;if((M|0)==(c[d+300>>2]|0)){_1b(d+292|0,n);i=e;return}if(M)g[M>>2]=ra;c[N>>2]=M+4;i=e;return}function j8d(b){b=b|0;var d=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=Im,E=Im,F=Im,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;f=b+204|0;c[f>>2]=0;h=b+224|0;a:do if((c[h>>2]|0)>=0){j=b+152|0;k=b+308|0;l=b+264|0;m=b+268|0;n=b+304|0;o=b+197|0;p=b+372|0;q=b+264|0;r=b+144|0;s=b+280|0;t=b+356|0;u=b+252|0;v=b+244|0;w=b+220|0;x=b+256|0;y=b+212|0;z=b+240|0;A=b+248|0;while(1){i8d(b);B=c[f>>2]|0;if((B|0)<(c[h>>2]|0))C=e[(c[j>>2]|0)+(B<<1)>>1]|0;else C=10;D=ea(g[l>>2]);E=ea(g[m>>2]);F=ea(D);D=ea(E);G=(c[k>>2]|0)+(B<<3)|0;g[G>>2]=F;g[G+4>>2]=D;if((C|0)==32){G=c[p>>2]|0;B=G+60|0;H=G+120|0;I=G+180|0;c[I+0>>2]=c[q+0>>2];c[I+4>>2]=c[q+4>>2];c[I+8>>2]=c[q+8>>2];aFi(H|0,q|0,12)|0;c[B+0>>2]=c[H+0>>2];c[B+4>>2]=c[H+4>>2];c[B+8>>2]=c[H+8>>2];c[G+0>>2]=c[H+0>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];c[p>>2]=(c[p>>2]|0)+240;H=c[s>>2]|0;D=ea(U5d(c[r>>2]|0,32,c[H+-24>>2]|0,c[H+-32>>2]|0));H=c[f>>2]|0;g[(c[t>>2]|0)+(H<<2)>>2]=D;F=ea(g[u>>2]);G=F==ea(0.0);E=ea(g[q>>2]);if(G){g[v>>2]=E;c[w>>2]=H}g[u>>2]=ea(D+F);c[x>>2]=(c[x>>2]|0)+1;c[y>>2]=H+1;g[z>>2]=ea(0.0);F=ea(D+E);g[A>>2]=F;g[q>>2]=F}else if((C|0)==9){if(!(g8d(b)|0)){J=0;K=19;break}}else if((C|0)==10){if(!(f8d(b)|0)){if(!(a[n>>0]|0))L=0;else L=(c[f>>2]|0)==(c[h>>2]|0)&1;a[n>>0]=L;if(!(a[o>>0]|0)){M=L;K=11;break}}}else if(!(h8d(b,C)|0)){J=0;K=19;break}H=c[f>>2]|0;c[f>>2]=H+1;if((H|0)>=(c[h>>2]|0)){N=n;break a}}if((K|0)==11){J=M<<24>>24!=0;i=d;return J|0}else if((K|0)==19){i=d;return J|0}}else N=b+304|0;while(0);J=(a[N>>0]|0)!=0;i=d;return J|0}function k8d(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=0,n=Im;e=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g[b+12>>2]=ea(g[d+268>>2]);f=c[d+164>>2]|0;if((f|0)==1){h=ea(g[d+260>>2]);j=ea(h*ea(.5));if(!(a[d+177>>0]|0)){g[b>>2]=ea(-j);k=h}else{g[b>>2]=ea(-ea(R(ea(j+ea(.5)))));k=ea(R(ea(h+ea(.5))))}g[b+8>>2]=k;i=e;return}else if((f|0)==2){k=ea(g[d+260>>2]);if(!(a[d+177>>0]|0))l=k;else l=ea(R(ea(k+ea(.5))));k=ea(-l);g[b>>2]=k;m=l>ea(-0.0);g[b+8>>2]=m?l:k;i=e;return}else if(!f){g[b>>2]=ea(0.0);k=ea(g[d+260>>2]);if(!(a[d+177>>0]|0))n=k;else n=ea(R(ea(k+ea(.5))));g[b+8>>2]=n;i=e;return}else{i=e;return}}function l8d(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=0;e=i;i=i+80|0;f=e+40|0;h=e+56|0;j=e+60|0;k=e+64|0;l=e+16|0;m=e;n=e+44|0;o=c[d>>2]|0;if(!o){c[j>>2]=c[153106];c[f+0>>2]=c[j+0>>2];j=bOb(280,f,1,16,3653512,716)|0;c[k>>2]=c[153106];c[f+0>>2]=c[k+0>>2];Fdc(j,f,0);k=pQb(j)|0;c[d>>2]=k;ko[c[(c[k>>2]|0)+24>>2]&4095](k);In[c[(c[k>>2]|0)+12>>2]&4095](k,4);In[c[(c[k>>2]|0)+44>>2]&4095](k,61);a[k+275>>0]=1;p=k}else{Vdc(o,1);p=o}o=b+140|0;Odc(p,c[(c[o>>2]|0)+8>>2]|0,13);a[p+276>>0]=a[621175]|0;k=p+28|0;j=c[o>>2]|0;if((c[j+8>>2]|0)>0){q=j;j=0;r=c[(c[k>>2]|0)+92>>2]|0;while(1){s=(c[q>>2]|0)+(j*60|0)|0;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];s=c[c[o>>2]>>2]|0;c[r+12>>2]=c[s+(j*60|0)+24>>2];t=s+(j*60|0)+28|0;s=c[t+4>>2]|0;u=r+16|0;c[u>>2]=c[t>>2];c[u+4>>2]=s;j=j+1|0;q=c[o>>2]|0;if((j|0)>=(c[q+8>>2]|0))break;else r=r+24|0}}r=b+228|0;pec(p,c[r>>2]|0,1);q=c[r>>2]|0;if((q|0)>0){j=q;q=0;while(1){o=c[b+(q<<4)+20>>2]|0;if(!o)v=j;else{lec(p,c[b+(q<<4)+12>>2]|0,o,q,0,1)|0;v=c[r>>2]|0}q=q+1|0;if((q|0)>=(v|0))break;else j=v}};c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;v=d+8|0;w=ea(g[v>>2]);j=d+12|0;x=ea(g[j>>2]);g[m>>2]=w;g[m+4>>2]=x;g[m+8>>2]=ea(0.0);Ulc(l,m);x=ea(g[v>>2]);w=ea(x+ea(g[d+16>>2]));x=ea(g[j>>2]);y=ea(x+ea(g[d+20>>2]));g[n>>2]=w;g[n+4>>2]=y;g[n+8>>2]=ea(0.0);Ulc(l,n);n=p+168|0;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];c[n+16>>2]=c[l+16>>2];c[n+20>>2]=c[l+20>>2];Xdc(p,c[(c[k>>2]|0)+96>>2]|0,0);k=d+76|0;p=b+308|0;if((p|0)==(k|0)){i=e;return}l=c[p>>2]|0;p=c[b+316>>2]<<3;b=p>>3;n=d+84|0;c[n>>2]=b;j=d+88|0;v=c[j>>2]|0;do if((v&2147483647)>>>0<b>>>0)if((v|0)>-1){c[j>>2]=b;m=c[k>>2]|0;c[h>>2]=c[d+80>>2];c[f+0>>2]=c[h+0>>2];q=hOb(m,p,4,f,0,3653512,370)|0;c[k>>2]=q;z=q;break}else{c[h>>2]=c[d+80>>2];c[f+0>>2]=c[h+0>>2];q=cOb(p,4,f,0,3653512,352)|0;YEi(q|0,c[k>>2]|0,c[n>>2]<<3|0)|0;c[j>>2]=b;c[k>>2]=q;z=q;break}else z=c[k>>2]|0;while(0);YEi(z|0,l|0,c[n>>2]<<3|0)|0;i=e;return}function m8d(b,d,e,f,h,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=Im,L=Im,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=Im,na=0,oa=0,pa=Im,qa=Im,ra=Im,sa=Im,ta=Im,ua=Im,va=Im,wa=Im,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=Im,La=Im,Ma=0;y=i;i=i+416|0;z=y+408|0;A=y+404|0;B=y;C=y+392|0;D=y+12|0;E=y+8|0;F=b+48|0;a[F>>0]=0;if(!e){i=y;return}G=(o|0)>(p|0)?o:p;if(!((t|0)==1|(t|0)==4|(t|0)==7))if((t|0)==2|(t|0)==5|(t|0)==8)H=2;else H=0;else H=1;p=u;I=c[p+4>>2]|0;J=B;c[J>>2]=c[p>>2];c[J+4>>2]=I;J=(q|0)==1;K=(c[k>>2]=I,ea(g[k>>2]));if(J){g[B+4>>2]=ea(3402823469999999843913219.0e14);L=ea(3402823469999999843913219.0e14)}else L=K;I=(r|0)==1;if(I)g[B>>2]=ea(3402823469999999843913219.0e14);if(!h)M=c[e+32>>2]|0;else M=h;h=(G|0)<(M|0)&n?G:M;M=(h|0)<(o|0)&n?o:h;h=a[d>>0]|0;if(!(h&1))N=(h&255)>>>1;else N=c[d+4>>2]|0;o8d(b,N);if(!(a[d>>0]&1))O=d+1|0;else O=c[d+8>>2]|0;vJc(C,O);O=n^1;n=b+64|0;N=D+232|0;h=u+4|0;r=D+268|0;q=D+164|0;p=s^1;s=J^1|p;J=I^1|p;p=b+52|0;I=b+56|0;P=v+4|0;Q=b+8|0;S=D+316|0;T=D+348|0;U=D+372|0;V=D+376|0;W=b+60|0;X=b+12|0;Y=b+4|0;Z=D+324|0;_=b+32|0;$=D+340|0;aa=b+16|0;ba=D+308|0;ca=D+356|0;da=D+260|0;fa=D+177|0;K=ea(M|0);ga=d+4|0;ha=c[f>>2]|0;f=t;t=M;ia=0;ja=o;ka=M;la=G;ma=ea(1.0);while(1){c[E>>2]=ha;c[z+0>>2]=c[E+0>>2];c8d(D,C,e,z,M,B,m,l,j,H,4,1,ma,w,x,b);if(d8d(D)|0)na=j8d(D)|0;else na=0;if(ia|O){c[n>>2]=ka;a:do if(ea(g[N>>2])>L)switch(f|0){case 7:{oa=1;break a;break}case 8:{oa=2;break a;break}case 4:{oa=1;break a;break}case 5:{oa=2;break a;break}case 6:{oa=0;break a;break}case 3:{oa=0;break a;break}default:{oa=f;break a}}else oa=f;while(0);pa=ea(g[u>>2]);qa=ea(g[h>>2]);ra=ea(g[r>>2]);G=c[q>>2]|0;if(!G){sa=ea(g[da>>2]);if(!(a[fa>>0]|0))ta=sa;else ta=ea(R(ea(sa+ea(.5))))}else if((G|0)==1){sa=ea(g[da>>2]);if(!(a[fa>>0]|0))ta=sa;else ta=ea(R(ea(sa+ea(.5))))}else if((G|0)==2){sa=ea(g[da>>2]);if(!(a[fa>>0]|0))ua=sa;else ua=ea(R(ea(sa+ea(.5))));sa=ea(-ua);G=ua>ea(-0.0);ta=G?ua:sa}else ta=ea(0.0);sa=s?qa:ra;qa=J?pa:ta;g[p>>2]=qa;g[I>>2]=sa;pa=ea(sa-ra);switch(oa|0){case 7:case 4:case 1:{va=ea(R(ea(ea(qa*ea(.5))+ea(.5))));break}case 2:case 5:case 8:{va=ea(R(ea(qa+ea(.5))));break}default:va=ea(0.0)}ra=ea(va-ea(ea(g[v>>2])*qa));switch(oa|0){case 5:case 4:case 3:{wa=ea(R(ea(ea(pa*ea(.5))+ea(.5))));break}case 6:case 7:case 8:{wa=ea(R(ea(pa+ea(.5))));break}default:wa=ea(0.0)}pa=ea(wa-ea(ea(ea(1.0)-ea(g[P>>2]))*sa));G=c[Q>>2]|0;if((G|0)>0){xa=c[b>>2]|0;ya=0;do{za=xa+(ya*60|0)|0;g[za>>2]=ea(ra+ea(g[za>>2]));za=xa+(ya*60|0)+4|0;sa=ea(pa+ea(g[za>>2]));Aa=xa+(ya*60|0)+8|0;g[Aa>>2]=ea(ea(g[Aa>>2])+ea(0.0));g[za>>2]=ea(-sa);ya=ya+1|0}while((ya|0)<(G|0))}G=c[S>>2]|0;ya=c[T>>2]|0;q8d(b,ya,G);if((G|0)>0){xa=c[aa>>2]|0;za=0;do{Aa=(c[ba>>2]|0)+(za<<3)|0;Ba=c[Aa+4>>2]|0;Ca=xa+(za*12|0)|0;c[Ca>>2]=c[Aa>>2];c[Ca+4>>2]=Ba;xa=c[aa>>2]|0;Ba=xa+(za*12|0)|0;g[Ba>>2]=ea(ra+ea(g[Ba>>2]));Ba=xa+(za*12|0)+4|0;g[Ba>>2]=ea(-ea(pa+ea(g[Ba>>2])));g[xa+(za*12|0)+8>>2]=ea(g[(c[ca>>2]|0)+(za<<2)>>2]);za=za+1|0}while((za|0)!=(G|0))}if((ya|0)>0){G=c[Z>>2]|0;za=c[_>>2]|0;xa=c[$>>2]|0;Ba=0;do{c[za+(Ba<<3)>>2]=c[G+(Ba<<2)>>2];c[za+(Ba<<3)+4>>2]=~~ea(g[xa+(Ba<<2)>>2]);Ba=Ba+1|0}while((Ba|0)!=(ya|0))}ya=(c[U>>2]|0)-(c[V>>2]|0)|0;Ba=(ya|0)/60|0;c[W>>2]=Ba;c[Q>>2]=Ba;xa=c[X>>2]|0;do if((xa&2147483647)>>>0<Ba>>>0)if((xa|0)>-1){c[X>>2]=Ba;za=c[b>>2]|0;c[A>>2]=c[Y>>2];c[z+0>>2]=c[A+0>>2];c[b>>2]=hOb(za,ya,4,z,0,3653512,370)|0;break}else{c[A>>2]=c[Y>>2];c[z+0>>2]=c[A+0>>2];za=cOb(ya,4,z,0,3653512,352)|0;YEi(za|0,c[b>>2]|0,(c[Q>>2]|0)*60|0)|0;c[X>>2]=Ba;c[b>>2]=za;break}while(0);a[F>>0]=1;Da=1;Ea=oa;Fa=t;Ga=ia;Ha=ja;Ia=ka;Ja=la;Ka=ma}else{Ba=na?ka:ja;ya=na?la:ka+-1|0;xa=na?ka:t;za=(ya|0)<(Ba|0);G=za?o:Ba;Ba=za?o:ya;pa=ea(+(Ba-G|0)*.5);if(!(pa>=ea(0.0)))La=pa;else La=ea(pa+ea(.99999994));ya=a[d>>0]|0;if(!(ya&1))Ma=(ya&255)>>>1;else Ma=c[ga>>2]|0;o8d(b,Ma);ya=(Ba|0)==(G|0);za=ya?xa:~~La+G|0;Da=2;Ea=f;Fa=xa;Ga=ya;Ha=G;Ia=za;Ja=Ba;Ka=ea(ea(za|0)/K)}p8d(D);if((Da|0)==2){f=Ea;t=Fa;ia=Ga;ja=Ha;ka=Ia;la=Ja;ma=Ka}else break}wJc(C);i=y;return}function n8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;c[a>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;g=b+4|0;h=c[g>>2]|0;j=c[b>>2]|0;k=h-j|0;l=(k|0)/44|0;if((h|0)==(j|0)){i=d;return}if(l>>>0>97612893)vxi(a);j=xCi(k)|0;c[e>>2]=j;c[a>>2]=j;c[f>>2]=j+(l*44|0);l=c[b>>2]|0;b=c[g>>2]|0;if((l|0)==(b|0)){i=d;return}else{m=l;n=j}do{j=n+0|0;l=m+0|0;g=j+44|0;do{c[j>>2]=c[l>>2];j=j+4|0;l=l+4|0}while((j|0)<(g|0));n=(c[e>>2]|0)+44|0;c[e>>2]=n;m=m+44|0}while((m|0)!=(b|0));i=d;return}function o8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;h=d;j=(b<<2)+4|0;c[h+0>>2]=c[150284];c[h+4>>2]=c[150285];c[h+8>>2]=c[150286];b=601088;k=c[b>>2]|0;l=c[b+4>>2]|0;b=a+12|0;m=c[b>>2]|0;do if((m&2147483647)>>>0<j>>>0)if((m|0)>-1){c[b>>2]=j;n=c[a>>2]|0;c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];c[a>>2]=hOb(n,j*60|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[a+4>>2];c[e+0>>2]=c[f+0>>2];n=cOb(j*60|0,4,e,0,3653512,352)|0;YEi(n|0,c[a>>2]|0,(c[a+8>>2]|0)*60|0)|0;c[b>>2]=j;c[a>>2]=n;break}while(0);b=a+8|0;e=c[b>>2]|0;if(e>>>0>=j>>>0){c[b>>2]=j;i=d;return}f=c[a>>2]|0;a=f+(j*60|0)|0;if((e|0)==(j|0)){c[b>>2]=j;i=d;return}m=f+(e*60|0)|0;do{if(m){c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];g[m+12>>2]=ea(0.0);g[m+16>>2]=ea(0.0);g[m+20>>2]=ea(-1.0);c[m+24>>2]=-1;e=m+28|0;c[e>>2]=k;c[e+4>>2]=l;e=m+36|0;c[e>>2]=k;c[e+4>>2]=l;g[m+44>>2]=ea(1.0);g[m+48>>2]=ea(0.0);g[m+52>>2]=ea(0.0);g[m+56>>2]=ea(-1.0)}m=m+60|0}while((m|0)!=(a|0));c[b>>2]=j;i=d;return}function p8d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+368>>2]|0)>-1){f=a+356|0;g=c[f>>2]|0;c[e>>2]=c[a+360>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+352>>2]|0)>-1){f=a+340|0;g=c[f>>2]|0;c[e>>2]=c[a+344>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+336>>2]|0)>-1){f=a+324|0;g=c[f>>2]|0;c[e>>2]=c[a+328>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+320>>2]|0)>-1){f=a+308|0;g=c[f>>2]|0;c[e>>2]=c[a+312>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}f=c[a+292>>2]|0;if(f){g=a+296|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~((h+-4-f|0)>>>2)<<2);ACi(f)}f=c[a+276>>2]|0;if(f){h=a+280|0;g=c[h>>2]|0;if((g|0)!=(f|0))c[h>>2]=g+(~((g+-32-f|0)>>>5)<<5);ACi(f)}wJc(a+152|0);f=a+12|0;g=a+140|0;do{h=g;g=g+-16|0;if((c[h+-4>>2]|0)>-1){j=c[g>>2]|0;c[e>>2]=c[h+-12>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[g>>2]=0}}while((g|0)!=(f|0));f=c[a>>2]|0;if(!f){i=b;return}g=a+4|0;a=c[g>>2]|0;if((a|0)!=(f|0))c[g>>2]=a+(~(((a+-44-f|0)>>>0)/44|0)*44|0);ACi(f);i=b;return}function q8d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+32|0;j=a+40|0;c[j>>2]=b;k=a+44|0;l=c[k>>2]|0;do if((l&2147483647)>>>0<b>>>0)if((l|0)>-1){c[k>>2]=b;m=c[h>>2]|0;c[g>>2]=c[a+36>>2];c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(m,b<<3,4,f,0,3653512,370)|0;break}else{c[g>>2]=c[a+36>>2];c[f+0>>2]=c[g+0>>2];m=cOb(b<<3,4,f,0,3653512,352)|0;YEi(m|0,c[h>>2]|0,c[j>>2]<<3|0)|0;c[k>>2]=b;c[h>>2]=m;break}while(0);h=a+16|0;b=a+24|0;c[b>>2]=d;k=a+28|0;j=c[k>>2]|0;if((j&2147483647)>>>0>=d>>>0){i=e;return}if((j|0)>-1){c[k>>2]=d;j=c[h>>2]|0;c[g>>2]=c[a+20>>2];c[f+0>>2]=c[g+0>>2];c[h>>2]=hOb(j,d*12|0,4,f,0,3653512,370)|0;i=e;return}else{c[g>>2]=c[a+20>>2];c[f+0>>2]=c[g+0>>2];g=cOb(d*12|0,4,f,0,3653512,352)|0;YEi(g|0,c[h>>2]|0,(c[b>>2]|0)*12|0)|0;c[k>>2]=d;c[h>>2]=g;i=e;return}}function r8d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+80|0;a=c[g>>2]|0;if(a){h=a;i=b;return h|0}c[e>>2]=c[153106];c[d+0>>2]=c[e+0>>2];e=bOb(280,d,1,16,3653512,47)|0;c[f>>2]=c[153106];c[d+0>>2]=c[f+0>>2];Fdc(e,d,0);d=pQb(e)|0;c[g>>2]=d;ko[c[(c[d>>2]|0)+24>>2]&4095](d);d=c[g>>2]|0;In[c[(c[d>>2]|0)+12>>2]&4095](d,4);d=c[g>>2]|0;In[c[(c[d>>2]|0)+44>>2]&4095](d,61);h=c[g>>2]|0;i=b;return h|0}function s8d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b;g=a+40|0;a=c[g>>2]|0;if(a){c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);h=c[d>>2]|0;j=c[a+28>>2]|0;if((h|0)==-1){k=j+(c[a+32>>2]<<3)|0;break}else{k=j+(h<<3)|0;break}}else k=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if((k|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(a=c[k+4>>2]|0,(a|0)!=0):0){l=a;i=b;return l|0}}a=hQb(c[g>>2]|0)|0;if(a){l=a;i=b;return l|0}}a=c[181098]|0;if(a){l=a;i=b;return l|0}rri(f,724424,9);c[181098]=nUc(mUc()|0,128,f)|0;xri(f);l=c[181098]|0;i=b;return l|0}function t8d(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=0,y=0,z=0,A=Im,B=0,C=Im,D=0;e=i;i=i+160|0;f=e+80|0;h=e+36|0;j=e+12|0;k=e+16|0;l=e+144|0;m=e;n=e+24|0;o=e+56|0;p=e+48|0;q=r8d(d)|0;r=d+28|0;if(!(a[r>>0]&1))s=r+1|0;else s=c[d+36>>2]|0;vJc(h,s);s=s8d(d)|0;r=b[d+50>>1]|0;t=d+48|0;u=b[t>>1]|0;v=ea(g[d+60>>2]);w=ea(g[d+56>>2]);x=(a[d+76>>0]|0)!=0;c[j>>2]=c[d+72>>2];y=c[d+64>>2]|0;z=c[d+68>>2]|0;c[f+0>>2]=c[j+0>>2];j=u8d(h,s,r,u,ea(0.0),v,w,x,0,f,y,z)|0;wJc(h);w=ea(g[j+16>>2]);v=ea(-w);A=ea(ea(g[j+20>>2])*ea(2.0));g[l>>2]=ea(0.0);g[l+8>>2]=v;g[l+4>>2]=ea(0.0);g[l+12>>2]=A;aJc(k,j,l);l=b[t>>1]|0;if((l|0)==1){A=ea(w*ea(.5));g[k>>2]=ea(A+ea(g[k>>2]));B=k}else if((l|0)==2){g[k>>2]=ea(w+ea(g[k>>2]));B=k}else B=k;l=c[j>>2]|0;w=ea(g[d+52>>2]);A=ea(g[(s8d(d)|0)+80>>2]);v=ea(A*w);g[m>>2]=v;C=ea(-ea(w*A));g[m+4>>2]=C;g[m+8>>2]=v;A=ea(ea(g[B>>2])*v);v=ea(-ea(ea(g[k+4>>2])*C));C=ea(g[d+44>>2]);g[n>>2]=A;g[n+4>>2]=v;g[n+8>>2]=C;kMc(f,n)|0;jMc(f,m)|0;vec(q,l,f);l=q+168|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;Wlc(l,f,o);c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];o=ATb(c[d+24>>2]|0,23)|0;if(!o){i=e;return}if(!q)D=0;else D=c[q+4>>2]|0;c[p>>2]=D;Nhc(o,p);i=e;return}function u8d(b,e,f,h,j,k,l,m,n,o,p,q){b=b|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=ea(k);l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;r=i;i=i+32|0;s=r+20|0;t=r+8|0;u=r+4|0;v=r;if(!e){w=c[181104]|0;if(!w){rri(t,724424,9);c[181104]=nUc(mUc()|0,128,t)|0;xri(t);x=c[181104]|0}else x=w}else x=e;if((c[x+76>>2]|0)==-2){y=p;z=q;A=0}else{y=0;z=0;A=(q|p|0)!=0}if((h|0)==3&(f|0)>-1&f>>>0<9)B=c[724440+(f<<2)>>2]|0;else B=h;h=c[181100]|0;p=c[181101]|0;a:do if((h|0)!=(p|0)){q=c[x+4>>2]|0;e=c[b+4>>2]|0;w=c[b>>2]|0;t=(w|0)==0;C=m&1;D=n&1;E=c[o>>2]|0;F=E&255;G=(E&65535)>>>8&255;H=E>>>16&255;I=E>>>24&255;b:do if((f|0)==9){E=h;while(1){J=c[E>>2]|0;do if(((((c[J+4>>2]|0)==(q|0)?ea(g[J+32>>2])==j:0)?ea(g[J+44>>2])==k:0)?ea(g[J+40>>2])==l:0)?(c[J+68>>2]|0)==(e|0):0){if(!t?(FEi(c[J+64>>2]|0,w,e<<1)|0)!=0:0)break;if(((((c[J+52>>2]|0)==(y|0)?(c[J+56>>2]|0)==(z|0):0)?(d[J+49>>0]|0)==(C|0):0)?(d[J+28>>0]|0)==(D|0):0)?(a[J+60>>0]|0)==F<<24>>24:0){if((a[J+61>>0]|0)!=G<<24>>24)break;if((a[J+62>>0]|0)!=H<<24>>24)break;if((a[J+63>>0]|0)==I<<24>>24){K=J;break b}}}while(0);E=E+4|0;if((E|0)==(p|0))break a}}else{E=h;while(1){J=c[E>>2]|0;do if(((((((c[J+4>>2]|0)==(q|0)?(c[J+24>>2]|0)==(f|0):0)?(c[J+36>>2]|0)==(B|0):0)?ea(g[J+32>>2])==j:0)?ea(g[J+44>>2])==k:0)?ea(g[J+40>>2])==l:0)?(c[J+68>>2]|0)==(e|0):0){if(!t?(FEi(c[J+64>>2]|0,w,e<<1)|0)!=0:0)break;if(((c[J+52>>2]|0)==(y|0)?(c[J+56>>2]|0)==(z|0):0)?(d[J+49>>0]|0)==(C|0):0){if((d[J+28>>0]|0)!=(D|0))break;if((a[J+60>>0]|0)!=F<<24>>24)break;if((a[J+61>>0]|0)!=G<<24>>24)break;if((a[J+62>>0]|0)!=H<<24>>24)break;if((a[J+63>>0]|0)==I<<24>>24){K=J;break b}}}while(0);E=E+4|0;if((E|0)==(p|0))break a}}while(0);c[K+92>>2]=c[(jLc()|0)+128>>2];L=K;i=r;return L|0}while(0);if(A)Krd(724480,0,3653512,88,512,0,0,0);A=xCi(96)|0;c[v>>2]=c[o>>2];c[s+0>>2]=c[v+0>>2];A8d(A,b,x,(f|0)==9?0:f,B,j,k,l,m,n,s,y,z);c[u>>2]=A;v8d(A);c[A+92>>2]=c[(jLc()|0)+128>>2];z=c[181101]|0;if((z|0)==(c[181102]|0)){C8d(724400,u);L=A;i=r;return L|0}if(!z)M=0;else{c[z>>2]=A;M=c[181101]|0}c[181101]=M+4;L=A;i=r;return L|0}function v8d(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=0,A=0;d=i;i=i+464|0;e=d+64|0;f=d+32|0;h=d+4|0;j=d+8|0;k=d+72|0;l=d;m=d+24|0;n=d+56|0;o=d+40|0;p=c[153134]|0;c[j>>2]=0;q=j+4|0;c[q>>2]=p;c[j+8>>2]=0;p=j+12|0;c[p>>2]=0;r=b+4|0;c[h>>2]=c[r>>2];s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(e,s,h);t=c[e>>2]|0;u=c[s+28>>2]|0;if((t|0)==-1){v=u+(c[s+32>>2]<<3)|0;break}else{v=u+(t<<3)|0;break}}else v=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((v|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[v+4>>2]|0,(s|0)!=0):0)w=s;else x=9}else x=9;if((x|0)==9)w=hQb(c[r>>2]|0)|0;c[l>>2]=c[b+60>>2];r=c[b+52>>2]|0;g[m>>2]=ea(g[b+32>>2]);g[m+4>>2]=ea(3402823469999999843913219.0e14);x=(a[b+49>>0]|0)!=0;s=c[b+56>>2]|0;y=ea(g[b+40>>2]);v=c[b+36>>2]|0;h=~~ea(g[b+44>>2]);t=(a[b+28>>0]|0)!=0;c[e+0>>2]=c[l+0>>2];c8d(k,b+64|0,w,e,r,m,x,s,y,v,h,t,ea(1.0),1,0,j);d8d(k)|0;t=c[k+224>>2]|0;h=t*6|0;v=(t*12|0)+15|0;s=(t|0)!=0;if(v>>>0<2e3)if(s){t=i;i=i+((1*v|0)+15&-16)|0;z=0;A=t}else{z=0;A=0}else if(s){c[n>>2]=c[153134];c[e+0>>2]=c[n+0>>2];n=cOb(v,16,e,0,3653512,296)|0;z=n;A=n}else{z=0;A=0}n=A+15&-16;A=n;v=k+24|0;s=k+12|0;if((c[v>>2]|0)>-1){t=c[s>>2]|0;c[f>>2]=c[k+16>>2];c[e+0>>2]=c[f+0>>2];eOb(t,e);c[s>>2]=0}c[v>>2]=(A+(h<<1)-n|0)>>>1|-2147483648;c[s>>2]=A;c[k+20>>2]=0;j8d(k)|0;k8d(o,k);A=b+8|0;c[A+0>>2]=c[o+0>>2];c[A+4>>2]=c[o+4>>2];c[A+8>>2]=c[o+8>>2];c[A+12>>2]=c[o+12>>2];l8d(k,b);if(z){c[f>>2]=c[153134];c[e+0>>2]=c[f+0>>2];eOb(z,e)}p8d(k);if((c[p>>2]|0)<=-1){i=d;return}p=c[j>>2]|0;c[f>>2]=c[q>>2];c[e+0>>2]=c[f+0>>2];eOb(p,e);c[j>>2]=0;i=d;return}function w8d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im;f=i;i=i+16|0;h=f;if((e|0)<0)j=0;else{k=c[b+68>>2]|0;l=(k|0)<(e|0)?k:e;j=((l<<2)+4|0)>65535?16382:l}l=c[b+76>>2]|0;aJc(h,b,d);m=ea(g[l+(j<<3)>>2]);n=ea(m+ea(g[h>>2]));m=ea(g[l+(j<<3)+4>>2]);o=ea(m+ea(g[h+4>>2]));g[a>>2]=n;g[a+4>>2]=o;i=f;return}function x8d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=0,y=0,z=0,A=0,B=0,C=Im,D=Im,E=0;f=i;i=i+32|0;h=f+16|0;j=f+8|0;k=f;l=(c[b+84>>2]|0)+-1|0;aJc(k,b,d);m=ea(g[e>>2]);n=ea(m-ea(g[k>>2]));m=ea(g[e+4>>2]);o=ea(m-ea(g[k+4>>2]));k=c[b+76>>2]|0;e=b+4|0;c[j>>2]=c[e>>2];d=c[137784]|0;if(d){do if((c[d+36>>2]|0)!=(c[d+4>>2]|0)){fRb(h,d,j);p=c[h>>2]|0;q=c[d+28>>2]|0;if((p|0)==-1){r=q+(c[d+32>>2]<<3)|0;break}else{r=q+(p<<3)|0;break}}else r=(c[d+28>>2]|0)+(c[d+32>>2]<<3)|0;while(0);d=c[137784]|0;if((r|0)!=((c[d+28>>2]|0)+(c[d+32>>2]<<3)|0)?(d=c[r+4>>2]|0,(d|0)!=0):0)s=d;else t=9}else t=9;if((t|0)==9)s=hQb(c[e>>2]|0)|0;e=c[b+52>>2]|0;if((e|0)!=0?(d=c[s+32>>2]|0,(d|0)!=0):0)u=ea(ea(ea(e|0)*ea(g[s+28>>2]))/ea(d|0));else u=ea(g[s+28>>2]);if(!(a[b+28>>0]|0))v=u;else v=ea(R(ea(u+ea(.5))));u=ea(o-v);b=l;s=0;a:while(1){d=s;b:while(1){e=(d|0)>(b|0);r=d+b>>1;h=k+(r<<3)|0;j=k+(r<<3)+4|0;p=r+1|0;q=(r|0)==(l|0)?l:p;w=k+(q<<3)+4|0;x=k+(q<<3)|0;q=r+-1|0;y=(r|0)==0?0:q;z=k+(y<<3)+4|0;A=k+(y<<3)|0;while(1){if(e){B=b;break a}v=ea(g[j>>2]);if(v<=u){d=p;continue b}if(v>o){b=q;s=d;continue a}m=ea(g[h>>2]);if(ea(g[w>>2])==v)C=ea(g[x>>2]);else C=ea(1.0e4);if(ea(ea(m+C)*ea(.5))<n){d=p;continue b}if(ea(g[z>>2])==v)D=ea(g[A>>2]);else D=ea(-1.0e4);y=ea(ea(m+D)*ea(.5))>n&1;if(!y){E=r;t=29;break a}else if((y|0)==1){b=q;s=d;continue a}}}}if((t|0)==29){i=f;return E|0}E=(B|0)<0?0:B;i=f;return E|0}function y8d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;b=c[(jLc()|0)+128>>2]|0;d=c[181101]|0;e=c[181100]|0;f=d-e>>2;if(!f){i=a;return}else{g=f;h=e;j=d}while(1){d=g+-1|0;e=c[h+(d<<2)>>2]|0;if((b-(c[e+92>>2]|0)|0)>5){if(!e){k=h;l=j}else{B8d(e);ACi(e);k=c[181100]|0;l=c[181101]|0}e=d<<2>>2;f=k+(e+1<<2)|0;m=l-f|0;aFi(k+(e<<2)|0,f|0,m|0)|0;f=k+((m>>2)+e<<2)|0;e=c[181101]|0;if((e|0)==(f|0))n=f;else{m=e+(~((e+-4-f|0)>>>2)<<2)|0;c[181101]=m;n=m}}else n=j;if(!d)break;g=d;h=c[181100]|0;j=n}i=a;return}function z8d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=c[181101]|0;d=c[181100]|0;e=b-d>>2;if(!e){f=d;g=b}else{b=e;e=d;while(1){b=b+-1|0;d=c[e+(b<<2)>>2]|0;if(!d)h=e;else{B8d(d);ACi(d);h=c[181100]|0}if(!b){j=h;break}else e=h}f=j;g=c[181101]|0}if((g|0)==(f|0)){i=a;return}c[181101]=g+(~((g+-4-f|0)>>>2)<<2);i=a;return}function A8d(b,d,e,f,h,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=ea(k);l=ea(l);m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0;r=i;i=i+16|0;s=r;t=b+4|0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;u=b+60|0;xJc(b+64|0,d);c[b+76>>2]=0;c[b+84>>2]=0;c[b+88>>2]=0;c[b+80>>2]=60;do if(!e){d=c[181104]|0;if(!d){rri(s,724424,9);c[181104]=nUc(mUc()|0,128,s)|0;xri(s);v=c[181104]|0;if(!v){w=0;break}else x=v}else x=d;w=c[x+4>>2]|0}else w=c[e+4>>2]|0;while(0);c[t>>2]=w;c[b+52>>2]=p;c[b+56>>2]=q;c[b+24>>2]=f;c[b+36>>2]=h;g[b+32>>2]=j;g[b+44>>2]=k;c[b+92>>2]=0;g[b+40>>2]=l;c[b>>2]=0;a[b+49>>0]=m&1;a[b+28>>0]=n&1;c[u>>2]=c[o>>2];i=r;return}function B8d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a>>2]|0;if(f)kQb(f);if((c[a+88>>2]|0)<=-1){g=a+64|0;wJc(g);i=b;return}f=a+76|0;h=c[f>>2]|0;c[e>>2]=c[a+80>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0;g=a+64|0;wJc(g);i=b;return}function C8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function D8d(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function E8d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=c[a>>2]|0;c[f>>2]=0;a=c[b+8>>2]|0;if((b|0)==(d|0)){h=0;i=e;return h|0}j=b+12|0;if(!(c[j>>2]|0)){c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];h=0;i=e;return h|0}k=da(c[b>>2]|0,(a|0)<0?0-a|0:a)|0;a=d+12|0;l=c[a>>2]|0;if(l){m=c[d+8>>2]|0;n=da((m|0)<0?0-m|0:m,c[d>>2]|0)|0;if((n|0)==(k|0))o=l;else{m=_ae(g,1,n,k,l,f)|0;c[a>>2]=m;o=m}}else{m=Yae(g,k,f)|0;c[a>>2]=m;o=m}m=c[f>>2]|0;if(m){h=m;i=e;return h|0};c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];c[a>>2]=o;YEi(o|0,c[j>>2]|0,k|0)|0;h=c[f>>2]|0;i=e;return h|0}function F8d(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+16|0;k=j;c[k>>2]=0;if(!e){l=33;i=j;return l|0}m=c[e>>2]|0;e=f+18|0;if(((a[e>>0]|0)+-1|0)>>>0<6){n=g+8|0;o=da(c[n>>2]|0,c[g>>2]|0)|0;p=(o|0)<0?0-o|0:o;a[g+18>>0]=2;o=c[f>>2]|0;c[g>>2]=o;q=f+4|0;c[g+4>>2]=c[q>>2];r=c[q>>2]|0;if((h|0)>0){q=(r|0)%(h|0)|0;s=(q|0)==0?0:h-q|0}else s=0;q=r+s|0;c[n>>2]=q;if((q|0)>0?o>>>0>(4294967295/(q>>>0)|0)>>>0:0){l=6;i=j;return l|0}n=da(q,o)|0;if((n|0)>(p|0)?(o=g+12|0,c[o>>2]=_ae(m,1,p,n,c[o>>2]|0,k)|0,o=c[k>>2]|0,(o|0)!=0):0){l=o;i=j;return l|0}}else c[k>>2]=6;switch(a[e>>0]|0){case 1:{e=c[f+12>>2]|0;o=c[g+12>>2]|0;b[g+16>>1]=2;n=c[f>>2]|0;if((n|0)>0){p=f+4|0;m=f+8|0;q=g+8|0;s=n;n=e;e=o;while(1){o=c[p>>2]|0;r=o>>3;if((r|0)>0){h=r<<3;t=r;u=n;v=e;while(1){w=a[u>>0]|0;x=w&255;a[v>>0]=(w&255)>>>7;a[v+1>>0]=x>>>6&1;a[v+2>>0]=x>>>5&1;a[v+3>>0]=x>>>4&1;a[v+4>>0]=x>>>3&1;a[v+5>>0]=x>>>2&1;a[v+6>>0]=x>>>1&1;a[v+7>>0]=x&1;t=t+-1|0;if((t|0)<=0)break;else{u=u+1|0;v=v+8|0}}y=c[p>>2]|0;z=n+r|0;A=e+h|0}else{y=o;z=n;A=e}v=y&7;if(v){u=v;v=A;t=d[z>>0]|0;while(1){a[v>>0]=t>>>7&1;u=u+-1|0;if((u|0)<=0)break;else{v=v+1|0;t=t<<1}}}s=s+-1|0;if((s|0)<=0)break;else{n=n+(c[m>>2]|0)|0;e=e+(c[q>>2]|0)|0}}}break}case 4:{q=c[f+12>>2]|0;e=c[g+12>>2]|0;b[g+16>>1]=16;m=c[f>>2]|0;if((m|0)>0){n=f+4|0;s=f+8|0;z=g+8|0;A=m;m=q;q=e;while(1){e=c[n>>2]|0;y=e>>1;if((y|0)>0){p=q+(y<<1)|0;t=y;v=m;u=q;while(1){o=a[v>>0]|0;a[u>>0]=(o&255)>>>4;a[u+1>>0]=o&15;t=t+-1|0;if((t|0)<=0)break;else{v=v+1|0;u=u+2|0}}B=c[n>>2]|0;C=m+y|0;D=p}else{B=e;C=m;D=q}if(B&1)a[D>>0]=(d[C>>0]|0)>>>4;A=A+-1|0;if((A|0)<=0)break;else{m=m+(c[s>>2]|0)|0;q=q+(c[z>>2]|0)|0}}}break}case 6:case 5:case 2:{z=c[f+4>>2]|0;q=c[f+12>>2]|0;s=c[g+12>>2]|0;m=c[f+8>>2]|0;A=c[g+8>>2]|0;b[g+16>>1]=256;C=c[f>>2]|0;if((C|0)>0){D=C;C=q;q=s;while(1){YEi(q|0,C|0,z|0)|0;D=D+-1|0;if((D|0)<=0)break;else{C=C+m|0;q=q+A|0}}}break}case 3:{A=c[f+12>>2]|0;q=c[g+12>>2]|0;b[g+16>>1]=4;m=c[f>>2]|0;if((m|0)>0){C=f+4|0;D=f+8|0;f=g+8|0;g=m;m=A;A=q;while(1){q=c[C>>2]|0;z=q>>2;if((z|0)>0){s=A+(z<<2)|0;B=z;n=m;u=A;while(1){v=a[n>>0]|0;t=v&255;a[u>>0]=(v&255)>>>6;a[u+1>>0]=t>>>4&3;a[u+2>>0]=t>>>2&3;a[u+3>>0]=t&3;B=B+-1|0;if((B|0)<=0)break;else{n=n+1|0;u=u+4|0}}E=c[C>>2]|0;F=m+z|0;G=s}else{E=q;F=m;G=A}u=E&3;if(u){n=u;u=G;B=d[F>>0]|0;while(1){a[u>>0]=B>>>6&3;n=n+-1|0;if((n|0)<=0)break;else{u=u+1|0;B=B<<2}}}g=g+-1|0;if((g|0)<=0)break;else{m=m+(c[D>>2]|0)|0;A=A+(c[f>>2]|0)|0}}}break}default:{}}l=c[k>>2]|0;i=j;return l|0}function G8d(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!a){e=33;i=d;return e|0}if(!b){e=6;i=d;return e|0}$ae(c[a>>2]|0,c[b+12>>2]|0);c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=0;i=d;return e|0}function H8d(a){a=a|0;var b=0,c=0;b=i;if((a|0)>-1){c=a+32768&-65536;i=b;return c|0}else{c=0-(32768-a&-65536)|0;i=b;return c|0}return 0}function I8d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;if((a|0)==0|(b|0)==(c|0)){e=a;i=d;return e|0}f=(a|0)<0?0-a|0:a;g=(b|0)<0?0-b|0:b;h=b^a^c;a=(c|0)<0?0-c|0:c;c=(a|0)>0;if(!((f|0)<46341&(g|0)<46341&(a|0)<176096&c))if(c?(c=f&65535,b=f>>>16,j=g&65535,k=g>>>16,l=da(j,c)|0,m=da(k,c)|0,c=m+(da(j,b)|0)|0,j=l+(c<<16)|0,n=j+(a>>1)|0,o=(c>>>16)+(da(k,b)|0)+((c>>>0<m>>>0&1)<<16)+(j>>>0<l>>>0&1)+(n>>>0<j>>>0&1)|0,o>>>0<a>>>0):0){j=n;n=32;l=0;m=o;while(1){o=l<<1;c=m<<1|j>>>31;if(c>>>0<a>>>0){p=o;q=c}else{p=o|1;q=c-a|0}n=n+-1|0;if(!n){r=p;break}else{j=j<<1;l=p;m=q}}}else r=2147483647;else r=((a>>1)+(da(g,f)|0)|0)/(a|0)|0;e=(h|0)<0?0-r|0:r;i=d;return e|0}function J8d(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a|0)==0|(b|0)==(c|0)){e=a;i=d;return e|0}f=(a|0)<0?0-a|0:a;g=(b|0)<0?0-b|0:b;h=b^a^c;a=(c|0)<0?0-c|0:c;c=(a|0)>0;if(!((f|0)<46341&(g|0)<46341&c))if(c?(c=f&65535,b=f>>>16,j=g&65535,k=g>>>16,l=da(j,c)|0,m=da(k,c)|0,c=m+(da(j,b)|0)|0,j=l+(c<<16)|0,n=(c>>>16)+(da(k,b)|0)+((c>>>0<m>>>0&1)<<16)+(j>>>0<l>>>0&1)|0,n>>>0<a>>>0):0){l=j;j=32;m=0;c=n;while(1){n=m<<1;b=c<<1|l>>>31;if(b>>>0<a>>>0){o=n;p=b}else{o=n|1;p=b-a|0}j=j+-1|0;if(!j){q=o;break}else{l=l<<1;m=o;c=p}}}else q=2147483647;else q=(da(g,f)|0)/(a|0)|0;e=(h|0)<0?0-q|0:q;i=d;return e|0}function K8d(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;if((a|0)==0|(b|0)==65536){d=a;i=c;return d|0}e=(a|0)<0?0-a|0:a;f=(b|0)<0?0-b|0:b;if(e>>>0<2049&f>>>0<1048577)g=((da(f,e)|0)+32768|0)>>>16;else{h=e&65535;g=(da(f>>>16,h)|0)+(da(e>>>16,f)|0)+(((da(f&65535,h)|0)+32768|0)>>>16)|0}d=(b^a|0)<0?0-g|0:g;i=c;return d|0}function L8d(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;c=i;d=(a|0)<0?0-a|0:a;e=b^a;a=(b|0)<0?0-b|0:b;do if(a){b=d>>16;f=d<<16;g=a>>1;if(!b){h=((g+f|0)>>>0)/(a>>>0)|0;break}j=f+g|0;g=(j>>>0<f>>>0&1)+b|0;if(g>>>0<a>>>0){b=j;j=32;f=0;k=g;while(1){g=f<<1;l=k<<1|b>>>31;if(l>>>0<a>>>0){m=g;n=l}else{m=g|1;n=l-a|0}j=j+-1|0;if(!j){h=m;break}else{b=b<<1;f=m;k=n}}}else h=2147483647}else h=2147483647;while(0);i=c;return ((e|0)<0?0-h|0:h)|0}function M8d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=d<<16;if(!((a|0)!=0&(b|0)!=0)){i=e;return}d=c[a>>2]|0;g=c[b>>2]|0;h=I8d(d,g,f)|0;j=c[a+4>>2]|0;k=b+8|0;l=c[k>>2]|0;m=(I8d(j,l,f)|0)+h|0;h=b+4|0;n=c[h>>2]|0;o=I8d(d,n,f)|0;d=b+12|0;p=c[d>>2]|0;q=(I8d(j,p,f)|0)+o|0;o=c[a+8>>2]|0;j=I8d(o,g,f)|0;g=c[a+12>>2]|0;a=(I8d(g,l,f)|0)+j|0;j=I8d(o,n,f)|0;n=(I8d(g,p,f)|0)+j|0;c[b>>2]=m;c[h>>2]=q;c[k>>2]=a;c[d>>2]=n;i=e;return}function N8d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d<<16;if(!((a|0)!=0&(b|0)!=0)){i=e;return}d=c[a>>2]|0;g=I8d(d,c[b>>2]|0,f)|0;h=a+4|0;j=c[h>>2]|0;k=(I8d(j,c[b+4>>2]|0,f)|0)+g|0;g=I8d(d,c[b+8>>2]|0,f)|0;d=(I8d(j,c[b+12>>2]|0,f)|0)+g|0;c[a>>2]=k;c[h>>2]=d;i=e;return}function O8d(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;if((a|0)>0){c=24;d=0;e=a;f=0}else{g=0;i=b;return g|0}while(1){a=e>>>30|d<<2;h=f<<1;j=f<<2|1;if(a>>>0<j>>>0){k=a;l=h}else{k=a-j|0;l=h|1}c=c+-1|0;if(!c){g=l;break}else{d=k;e=e<<2;f=l}}i=b;return g|0}function P8d(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!b){i=e;return ((a|0)>-1?d:0-d|0)|0}if(!a){f=(b|0)>-1?0-c|0:c;i=e;return f|0}if(!d){f=(c|0)>-1?b:0-b|0;i=e;return f|0}if(!c){f=(d|0)>-1?0-a|0:a;i=e;return f|0}g=a&65535;h=a>>>16;a=d&65535;j=d>>>16;d=da(a,g)|0;k=da(j,g)|0;g=k+(da(a,h)|0)|0;a=d+(g<<16)|0;l=(g>>>16)+(da(j,h)|0)+((g>>>0<k>>>0&1)<<16)+(a>>>0<d>>>0&1)|0;d=b&65535;k=b>>>16;b=c&65535;g=c>>>16;c=da(b,d)|0;h=da(g,d)|0;d=h+(da(b,k)|0)|0;b=c+(d<<16)|0;j=(d>>>16)+(da(g,k)|0)+((d>>>0<h>>>0&1)<<16)+(b>>>0<c>>>0&1)|0;if(l>>>0>j>>>0){f=1;i=e;return f|0}if(l>>>0<j>>>0){f=-1;i=e;return f|0}if(a>>>0>b>>>0){f=1;i=e;return f|0}f=(a>>>0<b>>>0)<<31>>31;i=e;return f|0}function Q8d(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=c+a|0;f=d+b|0;g=((f|0)<0?0-f|0:f)+((e|0)<0?0-e|0:e)|0;return (((b|0)<0?0-b|0:b)+((a|0)<0?0-a|0:a)+((c|0)<0?0-c|0:c)+((d|0)<0?0-d|0:d)-g|0)<(g>>4|0)|0}function R8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=Xae(a,96,e)|0;g=c[e>>2]|0;if(g){i=d;return g|0}c[f>>2]=a;c[b>>2]=f;i=d;return g|0}function S8d(a){a=a|0;var d=0,e=0,f=0;d=i;e=a+20|0;b[a+22>>1]=0;b[e>>1]=0;c[a+48>>2]=0;f=a+56|0;a=e+0|0;e=f+36|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(e|0));i=d;return}function T8d(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!a){i=d;return}e=c[a>>2]|0;f=a+24|0;$ae(e,c[f>>2]|0);c[f>>2]=0;f=a+28|0;$ae(e,c[f>>2]|0);c[f>>2]=0;f=a+32|0;$ae(e,c[f>>2]|0);c[f>>2]=0;f=a+40|0;$ae(e,c[f>>2]|0);c[f>>2]=0;f=a+52|0;$ae(e,c[f>>2]|0);c[f>>2]=0;c[a+44>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;f=a+20|0;b[a+22>>1]=0;b[f>>1]=0;c[a+48>>2]=0;g=a+56|0;h=f+0|0;f=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(f|0));$ae(e,a);i=d;return}function U8d(d){d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=d+4|0;h=Zae(c[d>>2]|0,8,0,c[g>>2]<<1,0,f)|0;c[d+40>>2]=h;j=c[f>>2]|0;if(j){i=e;return j|0}a[d+16>>0]=1;f=c[g>>2]|0;c[d+44>>2]=h+(f<<3);g=b[d+22>>1]|0;c[d+60>>2]=(c[d+24>>2]|0)+(g<<3);c[d+64>>2]=(c[d+28>>2]|0)+g;c[d+68>>2]=(c[d+32>>2]|0)+(b[d+20>>1]<<1);c[d+76>>2]=h+(g<<3);c[d+80>>2]=h+(f+g<<3);i=e;return j|0}function V8d(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g;j=c[d>>2]|0;c[h>>2]=0;k=d+22|0;l=(b[k>>1]|0)+e+(b[d+58>>1]|0)|0;e=d+4|0;m=c[e>>2]|0;do if(l>>>0>m>>>0){n=l+7&-8;if(n>>>0>32767){o=10;i=g;return o|0}p=d+24|0;c[p>>2]=Zae(j,8,m,n,c[p>>2]|0,h)|0;if((c[h>>2]|0)==0?(p=d+28|0,c[p>>2]=Zae(j,1,m,n,c[p>>2]|0,h)|0,(c[h>>2]|0)==0):0){if(a[d+16>>0]|0){p=d+40|0;q=Zae(j,8,m<<1,n<<1,c[p>>2]|0,h)|0;c[p>>2]=q;if(c[h>>2]|0)break;aFi(q+(n<<3)|0,q+(m<<3)|0,m<<3|0)|0;c[d+44>>2]=(c[p>>2]|0)+(n<<3)}c[e>>2]=n;r=1;s=9}}else{r=0;s=9}while(0);do if((s|0)==9){e=d+8|0;m=c[e>>2]|0;l=d+20|0;n=b[l>>1]|0;p=(n<<16>>16)+f+(b[d+56>>1]|0)|0;if(p>>>0>m>>>0){q=p+3&-4;if(q>>>0>32767){o=10;i=g;return o|0}p=d+32|0;t=Zae(j,2,m,q,c[p>>2]|0,h)|0;c[p>>2]=t;if(c[h>>2]|0)break;c[e>>2]=q;u=b[l>>1]|0;v=t}else{if(!(r<<24>>24))break;u=n;v=c[d+32>>2]|0}n=b[k>>1]|0;c[d+60>>2]=(c[d+24>>2]|0)+(n<<3);c[d+64>>2]=(c[d+28>>2]|0)+n;c[d+68>>2]=v+(u<<16>>16<<1);if(a[d+16>>0]|0){c[d+76>>2]=(c[d+40>>2]|0)+(n<<3);c[d+80>>2]=(c[d+44>>2]|0)+(n<<3)}}while(0);o=c[h>>2]|0;i=g;return o|0}function W8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;c[e>>2]=0;g=a+48|0;h=(c[g>>2]|0)+b+(c[a+84>>2]|0)|0;b=a+12|0;j=c[b>>2]|0;if(h>>>0<=j>>>0){k=0;i=d;return k|0}l=h+1&-2;h=a+52|0;m=Zae(f,32,j,l,c[h>>2]|0,e)|0;c[h>>2]=m;h=c[e>>2]|0;if(h){k=h;i=d;return k|0}c[b>>2]=l;c[a+88>>2]=m+(c[g>>2]<<5);k=0;i=d;return k|0}function X8d(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;b[d+58>>1]=0;b[d+56>>1]=0;c[d+84>>2]=0;f=b[d+22>>1]|0;c[d+60>>2]=(c[d+24>>2]|0)+(f<<3);c[d+64>>2]=(c[d+28>>2]|0)+f;c[d+68>>2]=(c[d+32>>2]|0)+(b[d+20>>1]<<1);if(!(a[d+16>>0]|0)){g=d+52|0;h=c[g>>2]|0;j=d+48|0;k=c[j>>2]|0;l=h+(k<<5)|0;m=d+88|0;c[m>>2]=l;i=e;return}c[d+76>>2]=(c[d+40>>2]|0)+(f<<3);c[d+80>>2]=(c[d+44>>2]|0)+(f<<3);g=d+52|0;h=c[g>>2]|0;j=d+48|0;k=c[j>>2]|0;l=h+(k<<5)|0;m=d+88|0;c[m>>2]=l;i=e;return}function Y8d(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;if(!d){i=f;return}g=d+56|0;h=b[g>>1]|0;j=h<<16>>16;k=d+22|0;l=b[k>>1]|0;m=d+58|0;n=(e[m>>1]|0)+l&65535;b[k>>1]=n;o=d+20|0;p=(h&65535)+(e[o>>1]|0)&65535;b[o>>1]=p;q=d+84|0;r=d+48|0;s=(c[r>>2]|0)+(c[q>>2]|0)|0;c[r>>2]=s;r=d+68|0;if(!(h<<16>>16)){t=n;u=p}else{p=c[r>>2]|0;n=0;do{h=p+(n<<1)|0;b[h>>1]=(e[h>>1]|0)+l;n=n+1|0}while(n>>>0<j>>>0);t=b[k>>1]|0;u=b[o>>1]|0}b[m>>1]=0;b[g>>1]=0;c[q>>2]=0;q=t<<16>>16;c[d+60>>2]=(c[d+24>>2]|0)+(q<<3);c[d+64>>2]=(c[d+28>>2]|0)+q;c[r>>2]=(c[d+32>>2]|0)+(u<<16>>16<<1);if(a[d+16>>0]|0){c[d+76>>2]=(c[d+40>>2]|0)+(q<<3);c[d+80>>2]=(c[d+44>>2]|0)+(q<<3)}c[d+88>>2]=(c[d+52>>2]|0)+(s<<5);i=f;return}function Z8d(a){a=a|0;c[a>>2]=52;c[a+4>>2]=1651078259;c[a+8>>2]=2742;c[a+12>>2]=3537;c[a+16>>2]=2743;c[a+20>>2]=0;c[a+24>>2]=3051;c[a+28>>2]=0;return}function _8d(a){a=a|0;c[a>>2]=40;c[a+4>>2]=1869968492;c[a+8>>2]=2744;c[a+12>>2]=3538;c[a+16>>2]=2745;c[a+20>>2]=1845;c[a+24>>2]=3052;c[a+28>>2]=2746;return}function $8d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a>>2]|0;if((c[b+72>>2]|0)!=1651078259){f=18;i=d;return f|0}c[a+20>>2]=c[b+100>>2];c[a+24>>2]=c[b+104>>2];g=b+156|0;h=a+28|0;if(!(c[(c[g>>2]|0)+4>>2]&1)){D8d(h);f=E8d(e,b+76|0,h)|0;i=d;return f|0}else{e=b+76|0;c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[h+16>>2]=c[e+16>>2];c[h+20>>2]=c[e+20>>2];e=(c[g>>2]|0)+4|0;c[e>>2]=c[e>>2]&-2;f=0;i=d;return f|0}return 0}function a9d(a){a=a|0;var b=0;b=i;G8d(c[a>>2]|0,a+28|0)|0;i=b;return}function b9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;c[b+20>>2]=c[a+20>>2];c[b+24>>2]=c[a+24>>2];f=E8d(e,a+28|0,b+28|0)|0;i=d;return f|0}function c9d(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a+20>>2]<<6;c[b>>2]=d;e=a+28|0;c[b+8>>2]=(c[e+4>>2]<<6)+d;d=c[a+24>>2]<<6;c[b+12>>2]=d;c[b+4>>2]=d-(c[e>>2]<<6);return}function d9d(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d+108|0;g=a+20|0;if((c[d+72>>2]|0)!=1869968492){h=18;i=e;return h|0}j=dae(c[a>>2]|0,b[d+110>>1]|0,b[f>>1]|0,g)|0;if(j){h=j;i=e;return h|0}fae(f,g)|0;h=0;i=e;return h|0}function e9d(a){a=a|0;var b=0;b=i;gae(c[a>>2]|0,a+20|0)|0;i=b;return}function f9d(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+20|0;g=d+20|0;d=dae(c[a>>2]|0,b[f+2>>1]|0,b[f>>1]|0,g)|0;if(d){i=e;return d|0}fae(f,g)|0;i=e;return d|0}function g9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(b)kae(a+20|0,b);if(!d){i=e;return}iae(a+20|0,c[d>>2]|0,c[d+4>>2]|0);i=e;return}function h9d(a,b){a=a|0;b=b|0;var c=0;c=i;hae(a+20|0,b);i=c;return}function i9d(a,b){a=a|0;b=b|0;var d=0,e=0;c[b+72>>2]=1869968492;d=b+108|0;e=a+20|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];e=b+124|0;c[e>>2]=c[e>>2]&-2;return 0}function j9d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+196>>2]|0;e=c[d>>2]|0;if(!e){i=b;return}f=c[a>>2]|0;g=c[e>>2]|0;if(g)Bfe(a,g);g=c[e+4>>2]|0;if(g)obe(a,g);g=c[e+8>>2]|0;if(g)Ace(a,g);g=c[e+12>>2]|0;if(g)Nhe(a,g);g=c[e+16>>2]|0;if(g)rie(a,g);g=c[e+20>>2]|0;if(g)_ce(a,g);g=c[e+24>>2]|0;if(g)pfe(a,g);$ae(f,e);c[d>>2]=0;i=b;return}function k9d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=c[a+196>>2]|0;g=c[a>>2]|0;c[f>>2]=0;h=Xae(g,32,d)|0;g=c[d>>2]|0;if(g){j=g;i=b;return j|0};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[h+28>>2]=0;g=Cfe(a,e)|0;c[d>>2]=g;if(((((((g|0)==0?(c[h>>2]=c[e>>2],g=pbe(a,e)|0,c[d>>2]=g,(g|0)==0):0)?(c[h+4>>2]=c[e>>2],g=Bce(a,e)|0,c[d>>2]=g,(g|0)==0):0)?(c[h+8>>2]=c[e>>2],g=Ohe(a,e)|0,c[d>>2]=g,(g|0)==0):0)?(c[h+12>>2]=c[e>>2],g=sie(a,e)|0,c[d>>2]=g,(g|0)==0):0)?(c[h+16>>2]=c[e>>2],g=$ce(a,e)|0,c[d>>2]=g,(g|0)==0):0)?(c[h+20>>2]=c[e>>2],g=qfe(a,e)|0,c[d>>2]=g,(g|0)==0):0){c[h+24>>2]=c[e>>2];c[f>>2]=h;j=0;i=b;return j|0}j9d(a);j=c[d>>2]|0;i=b;return j|0}function l9d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[c[a+196>>2]>>2]|0;e=c[d>>2]|0;if(!e){i=b;return}else{f=e;g=d}do{Q9d(a,f)|0;g=g+4|0;f=c[g>>2]|0}while((f|0)!=0);i=b;return}function m9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;a:do if((a|0)!=0&(b|0)!=0?(e=c[a>>2]|0,(e|0)!=0):0){f=e;e=a;while(1){if(!(HEi(f,b)|0)){g=e;break}e=e+8|0;f=c[e>>2]|0;if(!f){h=0;break a}}h=c[g+4>>2]|0}else h=0;while(0);i=d;return h|0}function n9d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=e;c[a+12>>2]=0;return}function o9d(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function p9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;c[d>>2]=0;if(!a){g=33;i=e;return g|0}if(!b){g=6;i=e;return g|0}h=c[a>>2]|0;a=Xae(h,40,f)|0;j=c[f>>2]|0;if(j){g=j;i=e;return g|0}c[a+28>>2]=h;j=c[b>>2]|0;do if(!(j&1)){if(j&4){k=b+12|0;c[f>>2]=Tae(a,c[k>>2]|0)|0;c[a+16>>2]=c[k>>2];l=a;m=12;break}if((j&2|0)!=0?(k=b+16|0,(c[k>>2]|0)!=0):0){$ae(h,a);l=c[k>>2]|0;m=12;break}c[f>>2]=6;n=a;m=13}else{Bae(a,c[b+4>>2]|0,c[b+8>>2]|0);l=a;m=12}while(0);if((m|0)==12)if(!(c[f>>2]|0)){c[l+28>>2]=h;o=0;p=l}else{n=l;m=13}if((m|0)==13){$ae(h,n);o=c[f>>2]|0;p=0}c[d>>2]=p;g=o;i=e;return g|0}function q9d(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((a|0)!=0?(e=c[a+28>>2]|0,Cae(a),(b|0)==0):0)$ae(e,a);i=d;return}function r9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[(c[a+4>>2]|0)+100>>2]|0;g=(c[a+156>>2]|0)+4|0;h=c[g>>2]|0;if(!(h&1)){c[g>>2]=h|1;j=a+88|0}else{h=a+88|0;$ae(f,c[h>>2]|0);c[h>>2]=0;j=h}c[j>>2]=Xae(f,b,e)|0;i=d;return c[e>>2]|0}function s9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!a){g=6;i=d;return g|0}h=a+96|0;j=c[h>>2]|0;if(!j){g=6;i=d;return g|0}k=c[j+8>>2]|0;l=Xae(k,c[(c[j+20>>2]|0)+44>>2]|0,f)|0;j=c[f>>2]|0;if(j){if(!b){g=j;i=d;return g|0}c[b>>2]=0;g=j;i=d;return g|0}j=l+4|0;c[j>>2]=a;m=c[h>>2]|0;h=c[m+20>>2]|0;n=c[m+8>>2]|0;c[e>>2]=0;c[l>>2]=c[m+4>>2];o=Xae(n,40,e)|0;p=c[e>>2]|0;do if(!p){c[l+156>>2]=o;if((c[c[m>>2]>>2]&512|0)==0?(q=R8d(n,o)|0,c[e>>2]=q,(q|0)!=0):0){r=q;s=9;break}q=c[h+64>>2]|0;if(q){t=mo[q&4095](l)|0;c[f>>2]=t;if(t)break}else c[f>>2]=0;t=a+84|0;c[l+8>>2]=c[t>>2];c[t>>2]=l;if(!b){g=0;i=d;return g|0}c[b>>2]=l;g=0;i=d;return g|0}else{r=p;s=9}while(0);if((s|0)==9)c[f>>2]=r;r=c[(c[j>>2]|0)+96>>2]|0;s=c[r+8>>2]|0;p=c[(c[r+20>>2]|0)+68>>2]|0;if(p)ko[p&4095](l);p=l+156|0;b=c[p>>2]|0;if((b|0)!=0?(c[b+4>>2]&1|0)!=0:0){a=l+88|0;$ae(c[(c[j>>2]|0)+100>>2]|0,c[a>>2]|0);c[a>>2]=0;a=c[p>>2]|0;j=a+4|0;c[j>>2]=c[j>>2]&-2;u=a}else{c[l+88>>2]=0;u=b}if(u){if(!(c[c[r>>2]>>2]&512)){T8d(c[u>>2]|0);r=c[p>>2]|0;c[r>>2]=0;v=r}else v=u;$ae(s,v);c[p>>2]=0}$ae(k,l);g=c[f>>2]|0;i=d;return g|0}function t9d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;if(!a){i=b;return}d=a+4|0;e=c[d>>2]|0;f=c[e+96>>2]|0;g=c[f+8>>2]|0;h=e+84|0;e=c[h>>2]|0;if(!e){i=b;return}else{j=e;k=0}while(1){if((j|0)==(a|0)){l=k;break}e=c[j+8>>2]|0;if(!e){m=19;break}else{n=j;j=e;k=n}}if((m|0)==19){i=b;return}m=c[a+8>>2]|0;if(!l)c[h>>2]=m;else c[l+8>>2]=m;m=c[(c[f+20>>2]|0)+68>>2]|0;if(m)ko[m&4095](a);m=a+156|0;l=c[m>>2]|0;if((l|0)!=0?(c[l+4>>2]&1|0)!=0:0){h=a+88|0;$ae(c[(c[d>>2]|0)+100>>2]|0,c[h>>2]|0);c[h>>2]=0;h=c[m>>2]|0;d=h+4|0;c[d>>2]=c[d>>2]&-2;o=h}else{c[a+88>>2]=0;o=l}if(o){if(!(c[c[f>>2]>>2]&512)){T8d(c[o>>2]|0);f=c[m>>2]|0;c[f>>2]=0;p=f}else p=o;$ae(g,p);c[m>>2]=0}$ae(g,a);i=b;return}function u9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!a){i=e;return}f=c[a+128>>2]|0;a=f+28|0;c[a>>2]=0;g=f+4|0;if(!b){c[g>>2]=65536;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=65536;h=g}else{c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];h=b}if(((c[h+8>>2]|c[h+4>>2]|0)==0?(c[h>>2]|0)==65536:0)?(c[h+12>>2]|0)==65536:0)j=2;else{c[a>>2]=1;j=3}h=f+20|0;if(!d){c[h>>2]=0;c[f+24>>2]=0;k=h;l=0}else{f=d;b=c[f+4>>2]|0;g=h;c[g>>2]=c[f>>2];c[g+4>>2]=b;k=d;l=c[d>>2]|0}if(!(c[k+4>>2]|l)){i=e;return}c[a>>2]=j;i=e;return}function v9d(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;if(!d){h=35;i=g;return h|0}j=d+88|0;if(!(c[j>>2]|0)){h=35;i=g;return h|0}k=c[d+84>>2]|0;if(!k){h=35;i=g;return h|0}l=k+156|0;m=c[l>>2]|0;if((m|0)!=0?(c[m+4>>2]&1|0)!=0:0){m=k+88|0;$ae(c[(c[k+4>>2]|0)+100>>2]|0,c[m>>2]|0);c[m>>2]=0;m=(c[l>>2]|0)+4|0;c[m>>2]=c[m>>2]&-2}else c[k+88>>2]=0;m=k+24|0;a[k+94>>0]=0;l=k+100|0;n=k+72|0;o=m+0|0;p=o+40|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;o=l+0|0;p=o+56|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));o=c[d+96>>2]|0;p=c[(c[o+4>>2]|0)+168>>2]|0;l=(f&1024|0)==0?f:f|2049;if(!(l&1))q=l;else q=l&-15|10;l=(q&2|0)==0;a:do if(((p|0)!=0&l&(q&32768|0)==0?(f=c[c[o>>2]>>2]|0,(f&768|0)==256):0)?(r=c[d+8>>2]|0,(r&8192|0)==0):0){do if(!(q&2048)){s=c[d+128>>2]|0;t=(c[s+4>>2]|0)==0;if(!(c[s+12>>2]|0))if(t){u=27;break a}else break;else if(t)break;else{u=27;break a}}while(0);if(((q&32|0)==0?!((f&1024|0)==0|(q&983040|0)==65536):0)?(a[(c[d+128>>2]|0)+52>>0]|0)==0:0){if(!(r&8)){u=27;break}if(!(c[d+732>>2]|0)){u=27;break}if(b[d+286>>1]|0){u=27;break}}if(((r&2|0)!=0&(q&8|0)==0?(kn[c[(c[o+20>>2]|0)+80>>2]&511](k,c[j>>2]|0,e,q|16384)|0)==0:0)?(c[n>>2]|0)==1651078259:0){v=0;break}t=(c[d+128>>2]|0)+28|0;s=c[t>>2]|0;c[t>>2]=0;w=Bn[c[(c[(c[p>>2]|0)+20>>2]|0)+12>>2]&255](p,k,c[j>>2]|0,e,q)|0;c[t>>2]=s;v=w}else u=27;while(0);if((u|0)==27){p=kn[c[(c[o+20>>2]|0)+80>>2]&511](k,c[j>>2]|0,e,q)|0;if(p){h=p;i=g;return h|0}if((c[n>>2]|0)==1869968492){p=eae(k+108|0)|0;if(p){h=p;i=g;return h|0}if(l){if(!(q&16)){l=k+44|0;c[l>>2]=c[l>>2]&-64;l=k+48|0;c[l>>2]=c[l>>2]&-64;l=k+32|0;p=c[l>>2]|0;e=p+63+(c[m>>2]|0)&-64;o=k+36|0;w=c[o>>2]|0;s=k+28|0;t=w-(c[s>>2]|0)&-64;x=p&-64;c[l>>2]=x;l=w+63&-64;c[o>>2]=l;c[m>>2]=e-x;c[s>>2]=l-t}else{t=k+32|0;c[t>>2]=c[t>>2]&-64;t=k+36|0;c[t>>2]=(c[t>>2]|0)+63&-64;t=k+44|0;l=c[t>>2]|0;s=l+63+(c[m>>2]|0)&-64;x=k+48|0;e=c[x>>2]|0;o=k+28|0;w=e+63+(c[o>>2]|0)&-64;p=l&-64;c[t>>2]=p;t=e&-64;c[x>>2]=t;c[m>>2]=s-p;c[o>>2]=w-t}t=k+40|0;c[t>>2]=(c[t>>2]|0)+32&-64;t=k+52|0;c[t>>2]=(c[t>>2]|0)+32&-64;v=0}else v=0}else v=0}if(!(q&16)){c[k+64>>2]=c[k+40>>2];y=0}else{c[k+64>>2]=0;y=c[k+52>>2]|0}c[k+68>>2]=y;if((q&8192|0)==0?(c[d+8>>2]&1|0)!=0:0){y=c[j>>2]|0;j=k+56|0;c[j>>2]=I8d(c[j>>2]|0,c[y+16>>2]|0,64)|0;j=k+60|0;c[j>>2]=I8d(c[j>>2]|0,c[y+20>>2]|0,64)|0}if((q&2048|0)==0?(y=c[d+128>>2]|0,d=y+28|0,j=c[d>>2]|0,(j|0)!=0):0){t=c[(c[(c[k+4>>2]|0)+96>>2]|0)+4>>2]|0;w=c[t+164>>2]|0;if(w){o=c[n>>2]|0;if((c[w+24>>2]|0)==(o|0)){z=w;u=51}else{A=o;u=46}}else{A=c[n>>2]|0;u=46}b:do if((u|0)==46){c:do if((t|0)!=0?(o=c[t+156>>2]|0,(o|0)!=0):0){w=o;while(1){o=c[w+8>>2]|0;if((c[o+24>>2]|0)==(A|0)){B=o;break}w=c[w+4>>2]|0;if(!w)break c}if(B){z=B;u=51;break b}}while(0);if((A|0)==1869968492){if(!(j&1))C=j;else{kae(k+108|0,y+4|0);C=c[d>>2]|0}if(C&2){iae(k+108|0,c[y+20>>2]|0,c[y+24>>2]|0);D=v}else D=v}else D=v}while(0);if((u|0)==51)D=kn[c[(c[z+20>>2]|0)+44>>2]&511](z,k,y+4|0,y+20|0)|0;jae(k+64|0,y+4|0);E=D}else E=v;if(E){h=E;i=g;return h|0}E=c[n>>2]|0;if((E|0)==1668246896|(E|0)==1651078259){h=0;i=g;return h|0}if(!(q&4)){h=0;i=g;return h|0}E=q>>>16&15;n=c[k+4>>2]|0;if(!n){h=6;i=g;return h|0}h=P9d(c[(c[n+96>>2]|0)+4>>2]|0,k,(E|0)!=0|(q&4096|0)==0?E:2)|0;i=g;return h|0}function w9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)!=0?(e=c[a+4>>2]|0,(e|0)!=0):0)f=P9d(c[(c[e+96>>2]|0)+4>>2]|0,a,b)|0;else f=6;i=d;return f|0}function x9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)!=0?(e=c[a+92>>2]|0,(e|0)!=0):0)f=_n[c[(c[e+12>>2]|0)+12>>2]&4095](e,b)|0;else f=0;i=d;return f|0}function y9d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+32|0;g=f;if(!b){h=6;i=f;return h|0}c[g>>2]=4;c[g+12>>2]=b;c[g+16>>2]=0;h=z9d(a,g,d,e)|0;i=f;return h|0}function z9d(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;j=i;i=i+304|0;k=j+168|0;l=j+48|0;m=j+8|0;n=j+84|0;o=j+128|0;p=j+160|0;q=j+44|0;r=j+120|0;s=j+4|0;t=j;c[r>>2]=0;c[s>>2]=0;u=(h|0)==0;v=(g|0)>-1;if(!((f|0)!=0&(u&v^1))){w=6;i=j;return w|0}if(!(c[f>>2]&2))x=0;else x=(c[f+16>>2]|0)!=0&1;y=p9d(e,f,r)|0;c[q>>2]=y;a:do if(!y){z=c[e>>2]|0;A=c[f>>2]|0;do if((A&8|0)!=0?(B=c[f+20>>2]|0,(B|0)!=0):0){if(c[c[B>>2]>>2]&1){if(!(A&16)){C=0;D=0}else{C=c[f+24>>2]|0;D=c[f+28>>2]|0}E=c[r>>2]|0;F=Y9d(B,E,g,C,D,s)|0;c[q>>2]=F;if(!F)break;else G=E}else{c[q>>2]=32;G=c[r>>2]|0}if(!G){H=99;break a}E=c[G+28>>2]|0;Cae(G);if(x<<24>>24){H=99;break a}$ae(E,G);H=99;break a}else H=15;while(0);b:do if((H|0)==15){A=c[e+24>>2]|0;E=e+(A<<2)+28|0;if((A|0)<=0){H=30;break a}A=f+24|0;F=f+28|0;B=0;I=e+28|0;while(1){J=c[I>>2]|0;if(c[c[J>>2]>>2]&1){if(!(c[f>>2]&16)){K=0;L=0}else{K=c[A>>2]|0;L=c[F>>2]|0}M=c[r>>2]|0;N=Y9d(J,M,g,K,L,s)|0;c[q>>2]=N;if(!N)break b;if((HEi(c[(c[c[I>>2]>>2]|0)+8>>2]|0,789840)|0)==0&(N&255|0)==142){if(Dae(M,0)|0){O=N;H=29;break a}J=D9d(e,M,g,0,0,h)|0;c[q>>2]=J;if(!J){P=M;break}else Q=J}else Q=N;if((Q&255|0)==2)R=Q;else{O=Q;H=29;break a}}else R=B;I=I+4|0;if(I>>>0>=E>>>0){O=R;H=29;break a}else B=R}if(!P){w=0;i=j;return w|0}B=c[P+28>>2]|0;Cae(P);if(x<<24>>24){w=0;i=j;return w|0}$ae(B,P);w=0;i=j;return w|0}while(0);if(x<<24>>24){B=(c[s>>2]|0)+8|0;c[B>>2]=c[B>>2]|1024}B=Xae(z,12,q)|0;if(!(c[q>>2]|0)){E=c[s>>2]|0;c[B+8>>2]=E;I=E+96|0;dbe((c[I>>2]|0)+24|0,B);if(v){B=s9d(E,0)|0;c[q>>2]=B;if(B){H=99;break}B=E9d(E,t)|0;c[q>>2]=B;if(B){H=99;break}c[E+88>>2]=c[t>>2]}B=c[E+8>>2]|0;if(B&1){F=E+74|0;A=b[F>>1]|0;if(A<<16>>16<0){N=0-(A&65535)&65535;b[F>>1]=N;S=N}else S=A;if(!(B&32))b[E+78>>1]=S}if((B&2|0)!=0?(B=c[E+28>>2]|0,(B|0)>0):0){A=c[E+32>>2]|0;N=0;do{F=A+(N<<4)|0;J=b[F>>1]|0;if(J<<16>>16<0)b[F>>1]=0-(J&65535);J=A+(N<<4)+8|0;F=c[J>>2]|0;if((F|0)<0)c[J>>2]=0-F<<16>>16;F=A+(N<<4)+12|0;J=c[F>>2]|0;if((J|0)<0)c[F>>2]=0-J;N=N+1|0}while((N|0)<(B|0))}B=c[E+128>>2]|0;c[B+4>>2]=65536;c[B+8>>2]=0;c[B+12>>2]=0;c[B+16>>2]=65536;c[B+20>>2]=0;c[B+24>>2]=0;N=B+56|0;c[N>>2]=1;if(!u){c[h>>2]=E;break}if(((E|0)!=0?(B=c[I>>2]|0,(B|0)!=0):0)?(c[N>>2]=0,N=c[B+8>>2]|0,A=B+24|0,z=cbe(A,E)|0,(z|0)!=0):0){ebe(A,z);$ae(N,z);_9d(N,E,B)}}else H=99}else{O=y;H=29}while(0);do if((H|0)==29){y=O&255;if((y|0)==85|(y|0)==2|(y|0)==81){y=c[r>>2]|0;u=(y|0)==0;if(!u){S=Dae(y,0)|0;if(!S){t=Gae(y,k,128)|0;if(!t)if((((((a[k>>0]|0)==0?(a[k+74>>0]|0)==0:0)?(a[k+82>>0]|0)==0:0)?(v=a[k+1>>0]|0,P=v&255,(v+-1<<24>>24&255)<=32):0)?(a[k+63>>0]|0)==0:0)?(a[k+(P+2)>>0]|0)==0:0){T=Z9d(e,y,(d[k+84>>0]<<16|d[k+83>>0]<<24|d[k+85>>0]<<8|d[k+86>>0])+255&-128,g,h)|0;H=41}else H=42;else{T=t;H=41}}else{T=S;H=41}if((H|0)==41)if((T&255|0)==2)H=42;else U=T;if((H|0)==42)U=Z9d(e,y,0,g,h)|0;S=U&255;if((S|0)==85|(S|0)==2){V=U;H=44}else{W=U;H=61}}else{V=85;H=44}do if((H|0)==44)if(c[f>>2]&4){S=c[e>>2]|0;c[p>>2]=0;t=f+12|0;nae(e,y,c[t>>2]|0,l,m,n);P=o+12|0;v=2;R=0;Q=0;while(1){L=oae(R)|0;K=L<<24>>24!=0;if(Q<<24>>24==0|K^1?(c[n+(R<<2)>>2]|0)==0:0){c[o>>2]=4;G=c[l+(R<<2)>>2]|0;if(!G)X=c[t>>2]|0;else X=G;c[P>>2]=X;G=p9d(e,o,p)|0;D=K&(G|0)==81?1:Q;if(!G){K=c[p>>2]|0;C=Z9d(e,K,c[m+(R<<2)>>2]|0,g,h)|0;if(K){B=c[K+28>>2]|0;Cae(K);$ae(B,K)}if(!C){Y=0;break}Z=C;_=L<<24>>24==0?D:1}else{Z=G;_=D}}else{Z=v;_=Q}R=R+1|0;if((R|0)>=9){Y=Z;break}else{v=Z;Q=_}}Q=c[l>>2]|0;if(Q){$ae(S,Q);c[l>>2]=0}Q=l+4|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+8|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+12|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+16|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+20|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+24|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+28|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}Q=l+32|0;v=c[Q>>2]|0;if(v){$ae(S,v);c[Q>>2]=0}if(!Y){c[q>>2]=0;break}else{c[q>>2]=2;H=67;break}}else{W=V;H=61}while(0);if((H|0)==61?(c[q>>2]=W,(W|0)!=0):0)if((W&255|0)==2)H=67;else{$=y;H=68;break}if((H|0)==67){c[q>>2]=2;$=y;H=68;break}if(!u?(E=c[y+28>>2]|0,Cae(y),x<<24>>24==0):0)$ae(E,y);w=c[q>>2]|0;i=j;return w|0}else H=30}while(0);if((H|0)==30){$=c[r>>2]|0;H=68}if((H|0)==68)if(($|0)!=0?(r=c[$+28>>2]|0,Cae($),x<<24>>24==0):0){$ae(r,$);H=99}else H=99;if(((((H|0)==99?(H=c[s>>2]|0,(H|0)!=0):0)?(s=c[H+96>>2]|0,(s|0)!=0):0)?($=(c[H+128>>2]|0)+56|0,r=(c[$>>2]|0)+-1|0,c[$>>2]=r,(r|0)==0):0)?(r=c[s+8>>2]|0,$=s+24|0,x=cbe($,H)|0,(x|0)!=0):0){ebe($,x);$ae(r,x);_9d(r,H,s)}w=c[q>>2]|0;i=j;return w|0}function A9d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+32|0;h=g;if(!b){j=6;i=g;return j|0}c[h>>2]=1;c[h+4>>2]=b;c[h+8>>2]=d;c[h+16>>2]=0;j=z9d(a,h,e,f)|0;i=g;return j|0}function B9d(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=h+32|0;k=h;l=c[a>>2]|0;if(a)if(b){m=Xae(l,40,j)|0;n=c[j>>2]|0;if(!n){Bae(m,b,d);c[m+24>>2]=3539;d=c[j>>2]|0;if(!d){c[k>>2]=2;c[k+16>>2]=m;if(f){c[k>>2]=10;j=c[a+24>>2]|0;o=a+(j<<2)+28|0;a:do if((j|0)>0){p=a+28|0;while(1){q=c[p>>2]|0;p=p+4|0;if(!(HEi(c[(c[q>>2]|0)+8>>2]|0,f)|0)){r=q;break a}if(p>>>0>=o>>>0){r=0;break}}}else r=0;while(0);c[k+20>>2]=r}r=z9d(a,k,e,g)|0;if(!r){e=(c[g>>2]|0)+8|0;c[e>>2]=c[e>>2]&-1025;s=0;i=h;return s|0}else{Cae(m);$ae(l,m);s=r;i=h;return s|0}}else t=d}else t=n}else t=6;else t=33;$ae(l,b);s=t;i=h;return s|0}function C9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;a:do if((a|0)!=0&(b|0)!=0?(e=c[a+24>>2]|0,f=a+(e<<2)+28|0,(e|0)>0):0){e=a+28|0;while(1){g=c[e>>2]|0;e=e+4|0;if(!(HEi(c[(c[g>>2]|0)+8>>2]|0,b)|0)){h=g;break a}if(e>>>0>=f>>>0){h=0;break}}}else h=0;while(0);i=d;return h|0}function D9d(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+16|0;e=f+4|0;h=f;j=c[a>>2]|0;k=Fae(b)|0;l=Rae(b,e)|0;m=c[e>>2]|0;a:do if(!m)if((l|0)==1954115633){n=Qae(b,e)|0;o=c[e>>2]|0;if(!o){p=Eae(b,6)|0;c[e>>2]=p;if(!p){q=n&65535;if(n<<16>>16){n=(d|0)>-1;r=(d|0)<0;s=0;t=0;u=-1;while(1){v=Rae(b,e)|0;w=c[e>>2]|0;if(w){x=w;y=16;break a}w=Eae(b,4)|0;c[e>>2]=w;if(w){x=w;y=16;break a}w=Rae(b,e)|0;z=c[e>>2]|0;if(z){x=z;y=16;break a}z=Rae(b,e)|0;A=c[e>>2]|0;if(A){x=A;y=16;break a}if((v|0)==1128875040){A=w+22|0;B=z+-22|0;if(r){C=A;D=B;E=1;break}else{F=1;G=A;H=B;I=u+1|0}}else if((v|0)==1415139377){v=w+24|0;B=z+-24|0;if(r){C=v;D=B;E=0;break}else{F=0;G=v;H=B;I=u+1|0}}else{F=s;G=w;H=z;I=u}t=t+1|0;if(n&(I|0)==(d|0)){C=G;D=H;E=F;break}if((t|0)>=(q|0)){x=142;y=16;break a}else{s=F;u=I}}c[h>>2]=0;if(Dae(b,C+k|0)|0){J=0;i=f;return J|0}u=Xae(j,D,h)|0;s=c[h>>2]|0;if(!s){q=Gae(b,u,D)|0;c[h>>2]=q;if(!q){t=B9d(a,u,D,r?d:0,E<<24>>24!=0?724552:724560,g)|0;c[h>>2]=t;K=t}else K=q}else K=s}else{x=142;y=16}}else{x=p;y=16}}else{x=o;y=16}}else{x=2;y=16}else{x=m;y=16}while(0);if((y|0)==16){c[h>>2]=x;K=x}if((K|0)==2){x=Dae(b,k)|0;i=f;return ((x|0)==0?c[h>>2]|0:x)|0}else{J=K;i=f;return J|0}return 0}function E9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;if(!a){f=35;i=d;return f|0}if(!b){f=36;i=d;return f|0}g=a+96|0;if(!(c[g>>2]|0)){f=34;i=d;return f|0}c[b>>2]=0;h=c[(c[g>>2]|0)+20>>2]|0;g=c[a+100>>2]|0;j=Xae(g,c[h+40>>2]|0,e)|0;do if(!(c[e>>2]|0)){k=Xae(g,12,e)|0;if(!(c[e>>2]|0)){c[j>>2]=a;c[j+40>>2]=0;l=c[h+56>>2]|0;if((l|0)!=0?(m=mo[l&4095](j)|0,c[e>>2]=m,(m|0)!=0):0){n=k;break}c[b>>2]=j;c[k+8>>2]=j;dbe(a+108|0,k);if(!(c[e>>2]|0)){f=0;i=d;return f|0}else n=k}else n=k}else n=0;while(0);$ae(g,n);$ae(g,j);f=c[e>>2]|0;i=d;return f|0}function F9d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;if((a|0)!=0?(d=c[a+96>>2]|0,(d|0)!=0):0){e=(c[a+128>>2]|0)+56|0;f=(c[e>>2]|0)+-1|0;c[e>>2]=f;if(!f){f=c[d+8>>2]|0;e=d+24|0;g=cbe(e,a)|0;if(!g)h=35;else{ebe(e,g);$ae(f,g);_9d(f,a,d);h=0}}else h=0}else h=35;i=b;return h|0}function G9d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if(!(c[a+8>>2]&2)){g=35;i=f;return g|0}if(c[b>>2]|0){g=7;i=f;return g|0}h=c[b+12>>2]|0;j=c[b+4>>2]|0;if(!h)k=j;else k=((da(j,h)|0)+36|0)/72|0;h=c[b+16>>2]|0;l=c[b+8>>2]|0;if(!h)m=l;else m=((da(l,h)|0)+36|0)/72|0;h=(j|0)==0;j=(l|0)==0?k:m;l=(h?j:k)+32|0;k=(h?m:j)+32|0;j=c[a+28>>2]|0;if((j|0)<=0){g=23;i=f;return g|0}m=c[a+32>>2]|0;a:do if(!(d<<24>>24)){a=0;while(1){if(((c[m+(a<<4)+12>>2]|0)+32^k)>>>0<=63?((c[m+(a<<4)+8>>2]|0)+32^l)>>>0<=63:0){n=a;break a}a=a+1|0;if((a|0)>=(j|0)){g=23;break}}i=f;return g|0}else{a=0;while(1){if(((c[m+(a<<4)+12>>2]|0)+32^k)>>>0<=63){n=a;break a}a=a+1|0;if((a|0)>=(j|0)){g=23;break}}i=f;return g|0}while(0);if(!e){g=0;i=f;return g|0}c[e>>2]=n;g=0;i=f;return g|0}function H9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=c[a+4>>2]|0;e=c[a+12>>2]|0;if((e|0)<0)f=(d|0)<(e|0)?e:d;else f=d-((e|0)>0?e:0)|0;if(!b)g=(f*12|0)/10|0;else g=b;c[a+20>>2]=(c[a+8>>2]|0)-((c[a+16>>2]|0)/2|0);c[a+24>>2]=(g-f|0)/2|0;c[a+28>>2]=g;return}function I9d(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[a+88>>2]|0;h=c[a+32>>2]|0;j=c[h+(d<<4)+8>>2]|0;b[g+12>>1]=(j+32|0)>>>6;k=h+(d<<4)+12|0;l=c[k>>2]|0;b[g+14>>1]=(l+32|0)>>>6;if(!(c[a+8>>2]&1)){c[g+16>>2]=65536;c[g+20>>2]=65536;c[g+24>>2]=l;c[g+28>>2]=0;c[g+32>>2]=b[h+(d<<4)>>1]<<6;m=j;n=g+36|0;c[n>>2]=m;i=f;return}else{d=a+68|0;h=g+16|0;c[h>>2]=L8d(j,e[d>>1]|0)|0;j=L8d(c[k>>2]|0,e[d>>1]|0)|0;d=g+20|0;c[d>>2]=j;c[g+24>>2]=(K8d(b[a+70>>1]|0,j)|0)+63&-64;c[g+28>>2]=(K8d(b[a+72>>1]|0,c[d>>2]|0)|0)&-64;c[g+32>>2]=(K8d(b[a+74>>1]|0,c[d>>2]|0)|0)+32&-64;m=(K8d(b[a+76>>1]|0,c[h>>2]|0)|0)+32&-64;n=g+36|0;c[n>>2]=m;i=f;return}}function J9d(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;g=c[a+88>>2]|0;h=g+12|0;if(!(c[a+8>>2]&1)){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[h+24>>2]=0;c[g+16>>2]=65536;c[g+20>>2]=65536;i=f;return}a:do switch(c[d>>2]|0){case 2:{j=(c[a+64>>2]|0)-(c[a+56>>2]|0)|0;k=(c[a+60>>2]|0)-(c[a+52>>2]|0)|0;l=11;break}case 0:{m=e[a+68>>1]|0;j=m;k=m;l=11;break}case 1:{m=(b[a+70>>1]|0)-(b[a+72>>1]|0)|0;j=m;k=m;l=11;break}case 3:{j=(b[a+70>>1]|0)-(b[a+72>>1]|0)|0;k=b[a+76>>1]|0;l=11;break}case 4:{m=c[d+4>>2]|0;n=g+16|0;c[n>>2]=m;o=c[d+8>>2]|0;p=g+20|0;c[p>>2]=o;if(!m){c[n>>2]=o;q=0;r=0;l=23;break a}if(!o){c[p>>2]=m;q=0;r=0;l=23}else{q=0;r=0;l=23}break}default:{j=0;k=0;l=11}}while(0);do if((l|0)==11){m=(k|0)<0?0-k|0:k;p=(j|0)<0?0-j|0:j;o=c[d+12>>2]|0;n=c[d+4>>2]|0;if(!o)s=n;else s=((da(n,o)|0)+36|0)/72|0;o=c[d+16>>2]|0;t=d+8|0;u=c[t>>2]|0;if(!o)v=u;else v=((da(u,o)|0)+36|0)/72|0;if(!n){n=L8d(v,p)|0;c[g+20>>2]=n;c[g+16>>2]=n;q=v;r=I8d(v,m,p)|0;l=23;break}n=L8d(s,m)|0;o=g+16|0;c[o>>2]=n;if(!(c[t>>2]|0)){c[g+20>>2]=n;q=I8d(s,p,m)|0;r=s;l=23;break}m=L8d(v,p)|0;p=g+20|0;c[p>>2]=m;n=c[d>>2]|0;if((n|0)==3){t=c[o>>2]|0;if((m|0)>(t|0)){c[p>>2]=t;q=v;r=s;l=23;break}else{c[o>>2]=m;q=v;r=s;l=23;break}}else{w=n;x=v;y=s}}while(0);if((l|0)==23){w=c[d>>2]|0;x=q;y=r}if(!w){z=g+16|0;A=g+20|0;B=x;C=y}else{y=a+68|0;x=g+16|0;w=K8d(e[y>>1]|0,c[x>>2]|0)|0;r=g+20|0;z=x;A=r;B=K8d(e[y>>1]|0,c[r>>2]|0)|0;C=w}b[h>>1]=(C+32|0)>>>6;b[g+14>>1]=(B+32|0)>>>6;c[g+24>>2]=(K8d(b[a+70>>1]|0,c[A>>2]|0)|0)+63&-64;c[g+28>>2]=(K8d(b[a+72>>1]|0,c[A>>2]|0)|0)&-64;c[g+32>>2]=(K8d(b[a+74>>1]|0,c[A>>2]|0)|0)+32&-64;c[g+36>>2]=(K8d(b[a+76>>1]|0,c[z>>2]|0)|0)+32&-64;i=f;return}function K9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;a:do if(a)if((((b|0)!=0?(e=c[b+4>>2]|0,(e|0)>=0):0)?(f=c[b+8>>2]|0,(f|0)>=0):0)?(g=c[b>>2]|0,g>>>0<=4):0){h=c[(c[a+96>>2]|0)+20>>2]|0;j=c[h+96>>2]|0;if(j){k=_n[j&4095](c[a+88>>2]|0,b)|0;break}j=c[a+8>>2]|0;if((j&3|0)!=2){J9d(a,b);k=0;break}if(j&2)if(!g){g=c[b+12>>2]|0;if(!g)l=e;else l=((da(g,e)|0)+36|0)/72|0;g=c[b+16>>2]|0;if(!g)m=f;else m=((da(f,g)|0)+36|0)/72|0;g=(e|0)==0;e=(f|0)==0?l:m;f=(g?e:l)+32|0;j=(g?m:e)+32|0;e=c[a+28>>2]|0;if((e|0)>0){g=c[a+32>>2]|0;n=0;while(1){if(((c[g+(n<<4)+12>>2]|0)+32^j)>>>0<=63?((c[g+(n<<4)+8>>2]|0)+32^f)>>>0<=63:0){o=n;break}n=n+1|0;if((n|0)>=(e|0)){k=23;break a}}if((o|0)>-1&(e|0)>(o|0)){n=c[h+100>>2]|0;if(!n){I9d(a,o);k=0;break}else{k=_n[n&4095](c[a+88>>2]|0,o)|0;break}}else k=6}else k=23}else k=7;else k=35}else k=6;else k=35;while(0);i=d;return k|0}function L9d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g;if(!b){j=d;k=d}else{j=(d|0)==0?b:d;k=b}if(!e){l=f;m=f}else{l=(f|0)==0?e:f;m=e}e=(m|0)==0;c[h>>2]=0;c[h+4>>2]=(k|0)<64?64:k;c[h+8>>2]=(j|0)<64?64:j;c[h+12>>2]=e?72:m;c[h+16>>2]=e?72:l;l=K9d(a,h)|0;i=g;return l|0}function M9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;if(!b){g=d;h=d}else{g=(d|0)==0?b:d;h=b}b=(h|0)==0?1:h;h=(g|0)==0?1:g;c[f>>2]=0;c[f+4>>2]=b>>>0<65535?b<<6:4194240;c[f+8>>2]=h>>>0<65535?h<<6:4194240;c[f+12>>2]=0;c[f+16>>2]=0;h=K9d(a,f)|0;i=e;return h|0}function N9d(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;c[g>>2]=0;if((a|0)==0|(d|0)==0){h=6;i=f;return h|0}j=c[d>>2]|0;if(!j){h=6;i=f;return h|0}k=c[j+100>>2]|0;l=Xae(k,c[a>>2]|0,g)|0;do if(!(c[g>>2]|0)){c[l+0>>2]=c[d+0>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];m=l+12|0;c[m>>2]=a;n=c[a+4>>2]|0;if(!((n|0)!=0?(o=_n[n&4095](l,b)|0,c[g>>2]=o,(o|0)!=0):0))p=6;if((p|0)==6?(o=j+36|0,n=c[o>>2]|0,q=j+40|0,r=Zae(k,4,n,n+1|0,c[q>>2]|0,g)|0,c[q>>2]=r,(c[g>>2]|0)==0):0){q=c[o>>2]|0;c[o>>2]=q+1;c[r+(q<<2)>>2]=l;s=l;break}q=c[(c[l>>2]|0)+100>>2]|0;r=c[(c[m>>2]|0)+8>>2]|0;if(r)ko[r&4095](l);$ae(q,l);s=0}else s=l;while(0);if(e)c[e>>2]=s;h=c[g>>2]|0;i=f;return h|0}function O9d(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((e|0)!=0&(f|0)!=0)a[e>>0]=0;a:do if(((b|0)!=0?(c[b+16>>2]|0)>=(d|0):0)?(c[b+8>>2]&512|0)!=0:0){h=b+128|0;j=(c[h>>2]|0)+40|0;k=c[j>>2]|0;l=k;do if(!l){m=c[b+96>>2]|0;n=c[(c[m>>2]|0)+32>>2]|0;if(n){o=_n[n&4095](m,788840)|0;c[(c[h>>2]|0)+40>>2]=(o|0)!=0?o:-2;if(!o){p=6;break a}else{q=o;break}}else{c[j>>2]=-2;p=6;break a}}else if((l|0)==-2){p=6;break a}else q=k;while(0);k=c[q>>2]|0;if(k)p=kn[k&511](b,d,e,f)|0;else p=6}else p=6;while(0);i=g;return p|0}function P9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;f=b+72|0;g=c[f>>2]|0;a:do if((g|0)==1869968492){h=a+156|0;j=c[h>>2]|0;k=h;l=c[a+164>>2]|0;m=9}else if((g|0)==1651078259){n=0;i=e;return n|0}else{if(a){h=a+156|0;o=c[h>>2]|0;if(!o){j=0;k=h;l=0;m=9;break}else p=o;while(1){o=c[p+8>>2]|0;if((c[o+24>>2]|0)==(g|0)){q=o;r=p;m=6;break}p=c[p+4>>2]|0;if(!p){s=0;t=0;break}}if((m|0)==6){s=r;t=q}if(!a){u=7;v=t;w=0}else{j=s;k=h;l=t;m=9;break}}else{u=7;v=0;w=0}while(1){if(!v){n=u;break}o=kn[c[v+68>>2]&511](v,b,d,0)|0;if((o|0)!=0&(o&255|0)==19){u=o;v=0;w=1}else{x=o;y=1;z=v;A=w;break a}}i=e;return n|0}while(0);b:do if((m|0)==9){w=j;v=7;u=l;t=0;c:while(1){if(!u){n=v;break}s=kn[c[u+68>>2]&511](u,b,d,0)|0;if(!((s|0)!=0&(s&255|0)==19)){x=s;y=0;z=u;A=t;break b}q=c[f>>2]|0;r=c[((w|0)==0?k:w+4|0)>>2]|0;if(!r){w=0;v=s;u=0;t=1;continue}else B=r;while(1){r=c[B+8>>2]|0;if((c[r+24>>2]|0)==(q|0)){C=r;D=B;break}r=c[B+4>>2]|0;if(!r){w=0;v=s;u=0;t=1;continue c}else B=r}w=D;v=s;u=C;t=1}i=e;return n|0}while(0);if(y|((A|0)==0|(x|0)!=0)|(z|0)==0){n=x;i=e;return n|0}A=a+156|0;y=cbe(A,z)|0;if(!y){n=x;i=e;return n|0}fbe(A,y);if((c[z+24>>2]|0)!=1869968492){n=x;i=e;return n|0}c[a+164>>2]=z;n=x;i=e;return n|0}function Q9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d+4|0;f=d;if(!a){g=33;i=d;return g|0}if(!b){g=6;i=d;return g|0}if((c[b+16>>2]|0)>131076){g=4;i=d;return g|0}h=a+24|0;j=c[h>>2]|0;if(j){k=c[b+8>>2]|0;l=0;while(1){m=c[a+(l<<2)+28>>2]|0;n=c[m>>2]|0;l=l+1|0;if(!(HEi(c[n+8>>2]|0,k)|0)){o=m;p=n;q=9;break}if(l>>>0>=j>>>0){r=j;break}}do if((q|0)==9)if((c[b+12>>2]|0)>(c[p+12>>2]|0)){R9d(a,o)|0;r=c[h>>2]|0;break}else{g=5;i=d;return g|0}while(0);o=c[a>>2]|0;c[f>>2]=0;if(r>>>0>31){c[f>>2]=48;g=48;i=d;return g|0}else{s=o;t=a}}else{o=c[a>>2]|0;c[f>>2]=0;s=o;t=a}o=Xae(s,c[b+4>>2]|0,f)|0;r=c[f>>2]|0;if(r){g=r;i=d;return g|0}c[o+4>>2]=a;c[o+8>>2]=s;c[o>>2]=b;do if(c[b>>2]&2){r=c[t>>2]|0;p=Xae(r,12,e)|0;j=c[e>>2]|0;if(j){c[f>>2]=j;break}j=c[o>>2]|0;c[o+20>>2]=j;l=c[j+36>>2]|0;c[o+24>>2]=l;if((l|0)==1869968492?(l=j+56|0,k=c[(c[l>>2]|0)+4>>2]|0,(k|0)!=0):0){n=_n[k&4095](r,o+60|0)|0;c[e>>2]=n;if(!n){c[o+64>>2]=c[(c[l>>2]|0)+16>>2];c[o+68>>2]=c[j+40>>2];q=21}}else q=21;if((q|0)==21){c[p+8>>2]=o;dbe(a+156|0,p);j=c[a+156>>2]|0;a:do if(!j)u=0;else{l=j;while(1){n=c[l+8>>2]|0;if((c[n+24>>2]|0)==1869968492){v=n;break}l=c[l+4>>2]|0;if(!l){u=0;break a}}u=v}while(0);c[a+164>>2]=u;if(!(c[e>>2]|0)){c[f>>2]=0;q=28;break}}$ae(r,p);j=c[e>>2]|0;c[f>>2]=j;if(!j)q=28}else q=28;while(0);do if((q|0)==28){e=c[o>>2]|0;u=c[e>>2]|0;if(u&4)c[a+168>>2]=o;if(((u&1|0)!=0?(c[o+20>>2]=e,(u&512|0)==0):0)?(u=R8d(s,o+36|0)|0,c[f>>2]=u,(u|0)!=0):0)break;u=c[b+24>>2]|0;if((u|0)!=0?(e=mo[u&4095](o)|0,c[f>>2]=e,(e|0)!=0):0)break;e=c[h>>2]|0;c[h>>2]=e+1;c[a+(e<<2)+28>>2]=o;g=0;i=d;return g|0}while(0);a=c[c[o>>2]>>2]|0;if((a&513|0)==1){T8d(c[o+36>>2]|0);w=c[c[o>>2]>>2]|0}else w=a;if(((w&2|0)!=0?(w=c[o+20>>2]|0,(c[w+36>>2]|0)==1869968492):0)?(a=c[o+60>>2]|0,(a|0)!=0):0)ko[c[(c[w+56>>2]|0)+20>>2]&4095](a);$ae(s,o);g=c[f>>2]|0;i=d;return g|0}function R9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;if(!a){e=33;i=d;return e|0}if(!b){e=34;i=d;return e|0}f=a+24|0;g=c[f>>2]|0;h=a+(g<<2)+28|0;if((g|0)<=0){e=34;i=d;return e|0}j=a+28|0;while(1){if((c[j>>2]|0)==(b|0)){k=j;break}j=j+4|0;if(j>>>0>=h>>>0){e=34;l=31;break}}if((l|0)==31){i=d;return e|0}l=g+-1|0;c[f>>2]=l;f=a+(l<<2)+28|0;if(k>>>0<f>>>0){l=k;do{k=l;l=l+4|0;c[k>>2]=c[l>>2]}while(l>>>0<f>>>0)}c[f>>2]=0;f=b+8|0;l=c[f>>2]|0;k=c[b>>2]|0;a=b+4|0;g=c[a>>2]|0;h=c[b+16>>2]|0;if(h)ko[h&4095](b);if((g|0)!=0?(h=g+168|0,(c[h>>2]|0)==(b|0)):0)c[h>>2]=0;if((c[c[b>>2]>>2]&2|0)!=0?(h=c[a>>2]|0,a=c[h>>2]|0,g=h+156|0,j=cbe(g,b)|0,(j|0)!=0):0){m=c[b+20>>2]|0;if((c[m+36>>2]|0)==1869968492?(n=c[b+60>>2]|0,(n|0)!=0):0)ko[c[(c[m+56>>2]|0)+20>>2]&4095](n);ebe(g,j);$ae(a,j);a:do if((h|0)!=0?(j=c[h+156>>2]|0,(j|0)!=0):0){a=j;while(1){j=c[a+8>>2]|0;if((c[j+24>>2]|0)==1869968492){o=j;break}a=c[a+4>>2]|0;if(!a){p=0;break a}}p=o}else p=0;while(0);c[h+164>>2]=p}if((c[c[b>>2]>>2]&1|0)!=0?(gbe(b+24|0,1846,c[f>>2]|0,b),(c[c[b>>2]>>2]&512|0)==0):0)T8d(c[b+36>>2]|0);f=c[k+28>>2]|0;if(f)ko[f&4095](b);$ae(l,b);e=0;i=d;return e|0}function S9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;a:do if((a|0)!=0&(b|0)!=0?(e=c[a+24>>2]|0,f=a+(e<<2)+28|0,(e|0)>0):0){e=a+28|0;while(1){g=c[e>>2]|0;h=c[g>>2]|0;e=e+4|0;if(!(HEi(c[h+8>>2]|0,b)|0)){j=g;k=h;break}if(e>>>0>=f>>>0){l=0;break a}}if(j)l=c[k+20>>2]|0;else l=0}else l=0;while(0);i=d;return l|0}function T9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;a:do if(a){e=c[(c[a>>2]|0)+32>>2]|0;if((e|0)!=0?(f=_n[e&4095](a,b)|0,(f|0)!=0):0){g=f;break}f=c[a+4>>2]|0;e=c[f+24>>2]|0;h=f+(e<<2)+28|0;if((e|0)>0){e=f+28|0;while(1){f=c[e>>2]|0;if(((f|0)!=(a|0)?(j=c[(c[f>>2]|0)+32>>2]|0,(j|0)!=0):0)?(k=_n[j&4095](f,b)|0,(k|0)!=0):0){g=k;break a}e=e+4|0;if(e>>>0>=h>>>0){g=0;break}}}else g=0}else g=0;while(0);i=d;return g|0}function U9d(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;if(!a){f=6;i=d;return f|0}g=Xae(a,236,e)|0;h=c[e>>2]|0;if(h){f=h;i=d;return f|0}c[g>>2]=a;h=Aie(g)|0;c[e>>2]=h;if((h|0)==0?(c[g+176>>2]=16384,c[g+172>>2]=Xae(a,16384,e)|0,(c[e>>2]|0)==0):0){c[g+12>>2]=2;c[g+16>>2]=4;c[g+20>>2]=8;c[g+232>>2]=1;c[b>>2]=g;f=0;i=d;return f|0}Bie(g);$ae(a,g);f=c[e>>2]|0;i=d;return f|0}function V9d(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;if(!a){d=33;i=b;return d|0}e=a+232|0;f=(c[e>>2]|0)+-1|0;c[e>>2]=f;if(f){d=0;i=b;return d|0}f=c[a>>2]|0;e=c[a+8>>2]|0;if(e)ko[e&4095](a);e=a+24|0;if(c[e>>2]|0){g=0;do{h=c[a+(g<<2)+28>>2]|0;j=c[h>>2]|0;if(((HEi(c[j+8>>2]|0,724568)|0)==0?(c[j>>2]&1|0)!=0:0)?(j=h+24|0,h=c[j>>2]|0,(h|0)!=0):0){k=h;do{h=c[k+8>>2]|0;if((((h|0)!=0?(l=c[h+96>>2]|0,(l|0)!=0):0)?(m=(c[h+128>>2]|0)+56|0,n=(c[m>>2]|0)+-1|0,c[m>>2]=n,(n|0)==0):0)?(n=c[l+8>>2]|0,m=l+24|0,o=cbe(m,h)|0,(o|0)!=0):0){ebe(m,o);$ae(n,o);_9d(n,h,l)}k=c[j>>2]|0}while((k|0)!=0)}g=g+1|0;k=c[e>>2]|0}while(g>>>0<k>>>0);p=k;if(p){g=p;k=p;p=0;while(1){j=c[a+(p<<2)+28>>2]|0;if(c[c[j>>2]>>2]&1){l=j+24|0;j=c[l>>2]|0;if(!j){q=g;r=g}else{h=j;do{j=c[h+8>>2]|0;if((((j|0)!=0?(n=c[j+96>>2]|0,(n|0)!=0):0)?(o=(c[j+128>>2]|0)+56|0,m=(c[o>>2]|0)+-1|0,c[o>>2]=m,(m|0)==0):0)?(m=c[n+8>>2]|0,o=n+24|0,s=cbe(o,j)|0,(s|0)!=0):0){ebe(o,s);$ae(m,s);_9d(m,j,n)}h=c[l>>2]|0}while((h|0)!=0);h=c[e>>2]|0;q=h;r=h}}else{q=g;r=k}p=p+1|0;if(p>>>0>=r>>>0){t=r;break}else{g=q;k=r}}if(t){r=t;do{R9d(a,c[a+(r+-1<<2)+28>>2]|0)|0;r=c[e>>2]|0}while((r|0)!=0)}}}r=a+172|0;$ae(f,c[r>>2]|0);c[r>>2]=0;c[a+176>>2]=0;Bie(a);$ae(f,a);d=0;i=b;return d|0}function W9d(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g;j=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+20>>2]|0)+96>>2]|0;if(!j){k=0;i=g;return k|0}c[h>>2]=0;c[h+4>>2]=b;c[h+8>>2]=d;d=(e|0)==0?f:e;e=(d|0)==0;c[h+12>>2]=e?72:d;c[h+16>>2]=e?72:(f|0)==0?d:f;k=_n[j&4095](a,h)|0;i=g;return k|0}function X9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+20>>2]|0)+96>>2]|0;if(!g){h=0;i=e;return h|0}c[f>>2]=0;c[f+4>>2]=b<<6;c[f+8>>2]=d<<6;c[f+12>>2]=0;c[f+16>>2]=0;h=_n[g&4095](a,f)|0;i=e;return h|0}function Y9d(a,d,e,f,g,h){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+16|0;k=j;l=c[a+20>>2]|0;m=c[a+8>>2]|0;n=Xae(m,c[l+36>>2]|0,k)|0;do if(!(c[k>>2]|0)){o=Xae(m,60,k)|0;if(!(c[k>>2]|0)){c[n+128>>2]=o;c[n+96>>2]=a;c[n+100>>2]=m;c[n+104>>2]=d;p=c[l+48>>2]|0;if((p|0)!=0?(q=Bn[p&255](d,n,e,f,g)|0,c[k>>2]=q,(q|0)!=0):0){r=o;break}q=c[n+40>>2]|0;if(!q){c[h>>2]=n;s=0;i=j;return s|0}p=(c[n+36>>2]|0)+-1|0;a:do if((p|0)>=0){t=q+(p<<2)|0;u=q;v=t;b:while(1){w=c[v>>2]|0;do if((c[w+4>>2]|0)==1970170211){x=b[w+8>>1]|0;if(x<<16>>16==3){if((b[w+10>>1]|0)!=10)break}else if(!(x<<16>>16==0?(b[w+10>>1]|0)==4:0))break;if((v-u|0)<=60){y=w;z=15;break b}}while(0);v=v+-4|0;if(v>>>0<q>>>0){A=t;break}}if((z|0)==15){c[n+92>>2]=y;break}while(1){t=c[A>>2]|0;if((c[t+4>>2]|0)==1970170211?(A-u|0)<=60:0){B=t;break}A=A+-4|0;if(A>>>0<q>>>0)break a}c[n+92>>2]=B}while(0);c[h>>2]=n;s=0;i=j;return s|0}else r=o}else r=0;while(0);if(n){B=n+36|0;A=n+40|0;y=c[A>>2]|0;if((c[B>>2]|0)>0){z=y;g=0;while(1){f=c[z+(g<<2)>>2]|0;e=c[(c[f>>2]|0)+100>>2]|0;d=c[(c[f+12>>2]|0)+8>>2]|0;if(d)ko[d&4095](f);$ae(e,f);c[(c[A>>2]|0)+(g<<2)>>2]=0;g=g+1|0;f=c[A>>2]|0;if((g|0)>=(c[B>>2]|0)){C=f;break}else z=f}}else C=y;$ae(m,C);c[A>>2]=0;c[B>>2]=0}B=c[l+52>>2]|0;if(B)ko[B&4095](n);$ae(m,r);$ae(m,n);c[h>>2]=0;s=c[k>>2]|0;i=j;return s|0}function Z9d(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;o=c[b>>2]|0;p=lae(b,d,e,k,l)|0;if(p){q=p;i=h;return q|0}if(mae(b,d,c[k>>2]|0,c[l>>2]|0,1347375956,m,n)|0){p=mae(b,d,c[k>>2]|0,c[l>>2]|0,1936092788,m,n)|0;if(p){q=p;i=h;return q|0}p=c[n>>2]|0;l=(f|0)%(p|0)|0;k=c[b>>2]|0;e=(l|0)==-1?0:l;do if((e|0)<(p|0)){l=c[(c[m>>2]|0)+(e<<2)>>2]|0;r=Dae(d,l)|0;c[j>>2]=r;if(!r){s=Rae(d,j)|0;t=c[j>>2]|0;if(!t)if((s|0)!=-1){u=D9d(b,d,e,0,0,g)|0;c[j>>2]=u;if(u){if(Dae(d,l+4|0)|0){v=c[j>>2]|0;break}l=Xae(k,s,j)|0;u=c[j>>2]|0;if(!u){w=Gae(d,l,s)|0;c[j>>2]=w;if(!w){if((s|0)>4){x=(FEi(l,724576,4)|0)!=0;y=x?789840:724784}else y=789840;x=B9d(b,l,s,0,y,g)|0;c[j>>2]=x;v=x}else v=w}else v=u}else v=0}else v=1;else v=t}else v=r}else v=1;while(0);$ae(o,c[m>>2]|0);c[m>>2]=0;if(v){q=v;i=h;return q|0}c[c[g>>2]>>2]=c[n>>2];q=0;i=h;return q|0}v=c[m>>2]|0;y=c[n>>2]|0;c[j>>2]=1;n=c[b>>2]|0;a:do if((f|0)==0|(f|0)==-1){k=(y|0)>0;if(k){e=0;p=0;while(1){r=Dae(d,c[v+(e<<2)>>2]|0)|0;c[j>>2]=r;if(r){z=r;break a}r=Rae(d,j)|0;t=c[j>>2]|0;if(t){z=t;break a}t=p+6+r|0;e=e+1|0;if((e|0)>=(y|0)){A=t;break}else p=t}}else A=0;p=A+2|0;e=Xae(n,p,j)|0;t=c[j>>2]|0;if(!t){a[e>>0]=-128;a[e+1>>0]=1;r=e+2|0;a[r>>0]=0;a[r+1>>0]=0;a[r+2>>0]=0;a[r+3>>0]=0;b:do if(k){r=0;u=0;w=2;x=6;s=1;while(1){l=Dae(d,c[v+(r<<2)>>2]|0)|0;c[j>>2]=l;if(l)break b;l=Rae(d,j)|0;B=c[j>>2]|0;if(B){z=B;break a}B=Qae(d,j)|0;C=c[j>>2]|0;if(C){z=C;break a}C=(B&65535)>>>8;if(C){B=(l|0)>2?l+-2|0:0;if((C|0)==(s|0)){D=B+u|0;E=w;F=x;G=s}else{l=w+3|0;if((l|0)>(p|0))break b;a[e+w>>0]=u;a[e+(w+1)>>0]=u>>>8;a[e+(w+2)>>0]=u>>>16;a[e+l>>0]=u>>>24;if((C|0)==5){H=u;I=w;J=x;K=24;break b}l=x+4|0;if((l|0)>(A|0))break b;a[e+x>>0]=-128;L=x+2|0;a[e+(x+1)>>0]=C;a[e+L>>0]=0;a[e+(x+3)>>0]=0;a[e+l>>0]=0;a[e+(x+5)>>0]=0;D=B;E=L;F=x+6|0;G=C}c[j>>2]=1;if((F|0)>(A|0))break b;C=F+B|0;if((C|0)>(A|0))break b;L=Gae(d,e+F|0,B)|0;c[j>>2]=L;if(!L){M=D;N=E;O=C;P=G}else break b}else{M=u;N=w;O=x;P=s}r=r+1|0;if((r|0)>=(y|0)){H=M;I=N;J=O;K=24;break}else{u=M;w=N;x=O;s=P}}}else{H=0;I=2;J=6;K=24}while(0);if(((K|0)==24?(J|0)<=(A|0):0)?(a[e+J>>0]=-128,a[e+(J+1)>>0]=3,k=I+3|0,(k|0)<=(p|0)):0){a[e+I>>0]=H;a[e+(I+1)>>0]=H>>>8;a[e+(I+2)>>0]=H>>>16;a[e+k>>0]=H>>>24;z=B9d(b,e,J+2|0,0,724560,g)|0;break}$ae(n,e);z=c[j>>2]|0}else z=t}else z=1;while(0);$ae(o,c[m>>2]|0);c[m>>2]=0;if(z){q=z;i=h;return q|0}c[c[g>>2]>>2]=1;q=0;i=h;return q|0}function _9d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[d+20>>2]|0;g=c[b+120>>2]|0;if(g)ko[g&4095](c[b+116>>2]|0);g=b+84|0;h=c[g>>2]|0;if(h){j=h;do{t9d(j);j=c[g>>2]|0}while((j|0)!=0)}gbe(b+108|0,1847,a,d);c[b+88>>2]=0;d=c[b+48>>2]|0;if(d)ko[d&4095](b);if(b){d=b+36|0;j=b+40|0;g=c[j>>2]|0;if((c[d>>2]|0)>0){h=g;k=0;while(1){l=c[h+(k<<2)>>2]|0;m=c[(c[l>>2]|0)+100>>2]|0;n=c[(c[l+12>>2]|0)+8>>2]|0;if(n)ko[n&4095](l);$ae(m,l);c[(c[j>>2]|0)+(k<<2)>>2]=0;k=k+1|0;l=c[j>>2]|0;if((k|0)>=(c[d>>2]|0)){o=l;break}else h=l}}else o=g;$ae(a,o);c[j>>2]=0;c[d>>2]=0}d=c[f+52>>2]|0;if(d)ko[d&4095](b);d=b+104|0;f=c[d>>2]|0;if((f|0)!=0?(j=c[b+8>>2]&1024,o=c[f+28>>2]|0,Cae(f),(j|0)==0):0)$ae(o,f);c[d>>2]=0;d=b+128|0;f=c[d>>2]|0;if(!f){$ae(a,b);i=e;return}$ae(a,f);c[d>>2]=0;$ae(a,b);i=e;return}function $9d(a){a=a|0;var b=0;b=i;$ae(c[a+28>>2]|0,c[a>>2]|0);c[a+4>>2]=0;c[a>>2]=0;c[a+24>>2]=0;i=b;return}function aae(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+8>>2]|0;if(f)ko[f&4095](b);f=c[(c[d+20>>2]|0)+60>>2]|0;if(f)ko[f&4095](b);f=b+40|0;$ae(a,c[f>>2]|0);c[f>>2]=0;$ae(a,b);i=e;return}function bae(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;h=i;i=i+64|0;j=h+16|0;k=h+8|0;l=h+48|0;m=h;n=h+32|0;o=h+24|0;p=h+40|0;q=h+56|0;if(!((e|0)!=0&(f|0)!=0)){r=6;i=h;return r|0}s=c[f+16>>2]|0;t=c[f+20>>2]|0;if((b[e>>1]|0)<=0){r=0;i=h;return r|0}u=e+12|0;v=e+4|0;w=k+4|0;x=e+8|0;y=f+4|0;z=o+4|0;A=p+4|0;B=q+4|0;C=f+12|0;D=l+4|0;E=j+4|0;F=m+4|0;G=n+4|0;H=f+8|0;I=0;J=0;a:while(1){K=b[(c[u>>2]|0)+(J<<1)>>1]|0;L=K<<16>>16;if(K<<16>>16<0){r=20;M=29;break}K=c[v>>2]|0;N=K+(L<<3)|0;O=K+(I<<3)|0;P=c[O>>2]|0;Q=c[O+4>>2]|0;O=k;c[O>>2]=P;c[O+4>>2]=Q;c[k>>2]=(P<<s)-t;P=(Q<<s)-t|0;c[w>>2]=P;Q=(c[K+(L<<3)>>2]<<s)-t|0;O=(c[K+(L<<3)+4>>2]<<s)-t|0;R=k;S=c[R>>2]|0;T=c[R+4>>2]|0;R=j;c[R>>2]=S;c[R+4>>2]=T;T=c[x>>2]|0;R=T+I|0;U=d[R>>0]&3;if((U|0)==2){r=20;M=29;break}else if(!U){if((a[T+L>>0]&3)==1){c[k>>2]=Q;c[w>>2]=O;V=K+(L+-1<<3)|0}else{c[k>>2]=(S+Q|0)/2|0;c[w>>2]=(P+O|0)/2|0;V=N}O=I+-1|0;W=O;X=V;Y=T+O|0}else{W=I;X=N;Y=R}R=K+(W<<3)|0;K=_n[c[f>>2]&4095](k,g)|0;if(K){r=K;M=29;break}b:do if(R>>>0<X>>>0){K=R;N=Y;c:while(1){O=K+8|0;T=N+1|0;P=d[T>>0]&3;if((P|0)==1){c[l>>2]=(c[O>>2]<<s)-t;c[D>>2]=(c[K+12>>2]<<s)-t;Q=_n[c[y>>2]&4095](l,g)|0;if(!Q){Z=O;_=T}else{r=Q;M=29;break a}}else if(!P){P=(c[O>>2]<<s)-t|0;c[j>>2]=P;Q=(c[K+12>>2]<<s)-t|0;c[E>>2]=Q;if(O>>>0<X>>>0){$=K;aa=N;ba=P;ca=Q;da=O;ea=T}else{M=20;break}while(1){T=$+16|0;O=aa+2|0;Q=d[O>>0]&3;P=(c[T>>2]<<s)-t|0;c[m>>2]=P;S=(c[$+20>>2]<<s)-t|0;c[F>>2]=S;if((Q|0)==1){fa=T;ga=O;break}else if(Q){r=20;M=29;break a}c[n>>2]=(P+ba|0)/2|0;c[G>>2]=(S+ca|0)/2|0;S=xo[c[H>>2]&2047](j,n,g)|0;if(S){r=S;M=29;break a}S=m;ba=c[S>>2]|0;ca=c[S+4>>2]|0;S=j;c[S>>2]=ba;c[S+4>>2]=ca;if(T>>>0>=X>>>0){M=20;break c}else{S=ea;P=da;da=T;ea=O;aa=S;$=P}}P=xo[c[H>>2]&2047](j,m,g)|0;if(!P){Z=fa;_=ga}else{r=P;M=29;break a}}else{if((K+16|0)>>>0>X>>>0){r=20;M=29;break a}if((a[N+2>>0]&3)!=2){r=20;M=29;break a}P=K+24|0;c[o>>2]=(c[K+8>>2]<<s)-t;c[z>>2]=(c[K+12>>2]<<s)-t;c[p>>2]=(c[K+16>>2]<<s)-t;c[A>>2]=(c[K+20>>2]<<s)-t;if(P>>>0>X>>>0){M=25;break}c[q>>2]=(c[P>>2]<<s)-t;c[B>>2]=(c[K+28>>2]<<s)-t;S=kn[c[C>>2]&511](o,p,q,g)|0;if(!S){Z=P;_=N+3|0}else{r=S;M=29;break a}}if(Z>>>0<X>>>0){K=Z;N=_}else{M=26;break b}}if((M|0)==20){M=0;ha=xo[c[H>>2]&2047](j,k,g)|0;break}else if((M|0)==25){M=0;ha=kn[c[C>>2]&511](o,p,k,g)|0;break}}else M=26;while(0);if((M|0)==26){M=0;ha=_n[c[y>>2]&4095](k,g)|0}if(ha){r=ha;M=29;break}J=J+1|0;if((J|0)>=(b[e>>1]|0)){r=0;M=29;break}else I=L+1|0}if((M|0)==29){i=h;return r|0}return 0}function cae(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g;if(!((f|0)!=0&(a|0)!=0)){j=6;i=g;return j|0};c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;k=Zae(a,8,0,d,0,h)|0;l=f+4|0;c[l>>2]=k;if(!(c[h>>2]|0)){m=f+8|0;c[m>>2]=Zae(a,1,0,d,0,h)|0;if((c[h>>2]|0)==0?(c[f+12>>2]=Zae(a,2,0,e,0,h)|0,(c[h>>2]|0)==0):0){b[f+2>>1]=d;b[f>>1]=e;e=f+16|0;c[e>>2]=c[e>>2]|1;j=0;i=g;return j|0}e=f+16|0;c[e>>2]=c[e>>2]|1;n=m;o=c[l>>2]|0}else{m=f+16|0;c[m>>2]=c[m>>2]|1;n=f+8|0;o=k}$ae(a,o);c[l>>2]=0;$ae(a,c[n>>2]|0);c[n>>2]=0;$ae(a,c[f+12>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;j=c[h>>2]|0;i=g;return j|0}function dae(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!a){g=33;i=f;return g|0}g=cae(c[a>>2]|0,b,d,e)|0;i=f;return g|0}function eae(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;a:do if(a){e=b[a+2>>1]|0;f=e<<16>>16;g=b[a>>1]|0;h=g<<16>>16;if(!((g|e)<<16>>16)){j=0;i=d;return j|0}if(!(e<<16>>16<1|g<<16>>16<1)){if(g<<16>>16>0){g=c[a+12>>2]|0;k=-1;l=0;while(1){m=b[g+(l<<1)>>1]|0;n=m<<16>>16;l=l+1|0;if(!((n|0)>(k|0)?m<<16>>16<e<<16>>16:0))break a;if((l|0)>=(h|0)){o=n;break}else k=n}}else o=-1;if((o|0)==(f+-1|0)){j=0;i=d;return j|0}}}while(0);j=6;i=d;return j|0}function fae(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!((a|0)!=0&(d|0)!=0)){f=6;i=e;return f|0}g=a+2|0;h=b[g>>1]|0;if(h<<16>>16!=(b[d+2>>1]|0)){f=6;i=e;return f|0}if((b[a>>1]|0)!=(b[d>>1]|0)){f=6;i=e;return f|0}if((a|0)==(d|0)){f=0;i=e;return f|0}YEi(c[d+4>>2]|0,c[a+4>>2]|0,h<<16>>16<<3|0)|0;YEi(c[d+8>>2]|0,c[a+8>>2]|0,b[g>>1]|0)|0;YEi(c[d+12>>2]|0,c[a+12>>2]|0,b[a>>1]<<1|0)|0;g=d+16|0;c[g>>2]=c[a+16>>2]&-2|c[g>>2]&1;f=0;i=e;return f|0}function gae(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!a){e=33;i=d;return e|0}f=c[a>>2]|0;if(!((f|0)!=0&(b|0)!=0)){e=6;i=d;return e|0}if(c[b+16>>2]&1){a=b+4|0;$ae(f,c[a>>2]|0);c[a>>2]=0;a=b+8|0;$ae(f,c[a>>2]|0);c[a>>2]=0;a=b+12|0;$ae(f,c[a>>2]|0);c[a>>2]=0};c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;e=0;i=d;return e|0}function hae(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;if(!((a|0)!=0&(d|0)!=0)){i=e;return}f=b[a+2>>1]|0;if(f<<16>>16){g=c[a+4>>2]|0;a=g+(f<<16>>16<<3)|0;h=c[g>>2]|0;j=c[g+4>>2]|0;if(f<<16>>16>1){f=g;k=g+8|0;g=h;l=h;m=j;n=j;while(1){o=c[f+8>>2]|0;p=(o|0)<(l|0)?o:l;q=(o|0)>(g|0)?o:g;o=c[f+12>>2]|0;r=(o|0)<(n|0)?o:n;s=(o|0)>(m|0)?o:m;o=f+16|0;if(o>>>0<a>>>0){t=k;k=o;g=q;l=p;m=s;n=r;f=t}else{u=q;v=p;w=s;x=r;break}}}else{u=h;v=h;w=j;x=j}}else{u=0;v=0;w=0;x=0}c[d>>2]=v;c[d+8>>2]=u;c[d+4>>2]=x;c[d+12>>2]=w;i=e;return}function iae(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(!a){i=f;return}g=b[a+2>>1]|0;if(g<<16>>16<=0){i=f;return}h=g<<16>>16;g=0;j=c[a+4>>2]|0;while(1){c[j>>2]=(c[j>>2]|0)+d;a=j+4|0;c[a>>2]=(c[a>>2]|0)+e;g=g+1<<16>>16;if((g&65535|0)>=(h|0))break;else j=j+8|0}i=f;return}function jae(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!((a|0)!=0&(b|0)!=0)){i=d;return}e=K8d(c[a>>2]|0,c[b>>2]|0)|0;f=a+4|0;g=(K8d(c[f>>2]|0,c[b+4>>2]|0)|0)+e|0;e=K8d(c[a>>2]|0,c[b+8>>2]|0)|0;h=(K8d(c[f>>2]|0,c[b+12>>2]|0)|0)+e|0;c[a>>2]=g;c[f>>2]=h;i=d;return}function kae(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if(!((a|0)!=0&(d|0)!=0)){i=e;return}f=c[a+4>>2]|0;g=b[a+2>>1]|0;a=f+(g<<16>>16<<3)|0;if(g<<16>>16<=0){i=e;return}g=d+4|0;h=d+8|0;j=d+12|0;k=f;do{if(k){f=K8d(c[k>>2]|0,c[d>>2]|0)|0;l=k+4|0;m=(K8d(c[l>>2]|0,c[g>>2]|0)|0)+f|0;f=K8d(c[k>>2]|0,c[h>>2]|0)|0;n=(K8d(c[l>>2]|0,c[j>>2]|0)|0)+f|0;c[k>>2]=m;c[l>>2]=n}k=k+8|0}while(k>>>0<a>>>0);i=e;return}function lae(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+48|0;j=b;k=b+24|0;l=b+8|0;m=Dae(e,f)|0;c[j>>2]=m;if(m){n=m;i=b;return n|0}m=Gae(e,k,16)|0;c[j>>2]=m;if(m){n=m;i=b;return n|0}m=(d[k+1>>0]<<16|d[k>>0]<<24|d[k+2>>0]<<8|d[k+3>>0])+f|0;c[h>>2]=m;h=d[k+5>>0]<<16|d[k+4>>0]<<24|d[k+6>>0]<<8|d[k+7>>0];o=h+f|0;if((h|0)==0?1:((d[k+9>>0]<<16|d[k+8>>0]<<24|d[k+10>>0]<<8|d[k+11>>0])+m|0)!=(o|0)){n=2;i=b;return n|0}m=Dae(e,o)|0;c[j>>2]=m;if(m){n=m;i=b;return n|0}a[l+15>>0]=(d[k+15>>0]|0)+1;m=Gae(e,l,16)|0;c[j>>2]=m;if(!m){p=1;q=1;r=0}else{n=m;i=b;return n|0}while(1){m=a[l+r>>0]|0;h=m<<24>>24==0?q:0;f=m<<24>>24==(a[k+r>>0]|0)?p:0;r=r+1|0;if((r|0)==16){s=f;t=h;break}else{p=f;q=h}}if(!(s|t)){n=2;i=b;return n|0}c[j>>2]=Eae(e,8)|0;t=Qae(e,j)|0;s=c[j>>2]|0;if(s){n=s;i=b;return n|0}s=(t&65535)+o|0;o=Dae(e,s)|0;c[j>>2]=o;if(o){n=o;i=b;return n|0}c[g>>2]=s;n=0;i=b;return n|0}function mae(a,d,e,f,g,h,j){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+16|0;l=k;m=c[a>>2]|0;a=Dae(d,e)|0;c[l>>2]=a;if(a){n=a;i=k;return n|0}a=Qae(d,l)|0;o=c[l>>2]|0;if(o){n=o;i=k;return n|0}o=a&65535;a=0;while(1){p=Rae(d,l)|0;q=c[l>>2]|0;if(q){n=q;r=22;break}q=Qae(d,l)|0;s=c[l>>2]|0;if(s){n=s;r=22;break}s=Qae(d,l)|0;t=c[l>>2]|0;if(t){n=t;r=22;break}if((p|0)==(g|0)){u=q;v=s;r=9;break}if((a|0)<(o|0))a=a+1|0;else{n=1;r=22;break}}if((r|0)==9){c[j>>2]=(u&65535)+1;u=Dae(d,(v&65535)+e|0)|0;c[l>>2]=u;if(u){n=u;i=k;return n|0}u=Zae(m,8,0,c[j>>2]|0,0,l)|0;e=c[l>>2]|0;if(e){n=e;i=k;return n|0}e=c[j>>2]|0;a:do if((e|0)>0){v=0;while(1){b[u+(v<<3)>>1]=Qae(d,l)|0;if(c[l>>2]|0)break a;a=Eae(d,2)|0;c[l>>2]=a;if(a)break a;a=Rae(d,l)|0;if(c[l>>2]|0)break a;o=Eae(d,4)|0;c[l>>2]=o;if(o)break a;c[u+(v<<3)+4>>2]=a&16777215;v=v+1|0;a=c[j>>2]|0;if((v|0)>=(a|0)){w=a;r=17;break}}}else{w=e;r=17}while(0);if((r|0)==17?(fCi(u,w,8,2747),w=Zae(m,4,0,c[j>>2]|0,0,l)|0,(c[l>>2]|0)==0):0){if((c[j>>2]|0)>0){e=0;do{c[w+(e<<2)>>2]=(c[u+(e<<3)+4>>2]|0)+f;e=e+1|0}while((e|0)<(c[j>>2]|0))}c[h>>2]=w;c[l>>2]=0}$ae(m,u);n=c[l>>2]|0;i=k;return n|0}else if((r|0)==22){i=k;return n|0}return 0}function nae(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;if(!b){j=0;do{k=e+(j<<2)|0;c[k>>2]=0;c[g+(j<<2)>>2]=0;c[g+(j<<2)>>2]=Bn[c[724584+(j<<3)>>2]&255](a,0,d,k,f+(j<<2)|0)|0;j=j+1|0}while((j|0)!=9);i=h;return}else l=0;do{j=e+(l<<2)|0;c[j>>2]=0;k=Dae(b,0)|0;c[g+(l<<2)>>2]=k;if(!k)c[g+(l<<2)>>2]=Bn[c[724584+(l<<3)>>2]&255](a,b,d,j,f+(l<<2)|0)|0;l=l+1|0}while((l|0)!=9);i=h;return}function oae(a){a=a|0;var b=0,d=0;b=i;if(a>>>0>8){d=0;i=b;return d|0}d=((c[724588+(a<<3)>>2]|0)+-3|0)>>>0<2&1;i=b;return d|0}function pae(a,c){a=a|0;c=c|0;var d=0,e=0;d=b[a>>1]|0;a=b[c>>1]|0;if((d&65535)<(a&65535))e=-1;else e=(d&65535)>(a&65535)&1;return e|0}function qae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;d=i;c[e>>2]=0;if(!b){g=81;i=d;return g|0}g=zae(b,333319,f)|0;i=d;return g|0}function rae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;d=i;c[e>>2]=0;if(!b){g=81;i=d;return g|0}g=zae(b,333312,f)|0;i=d;return g|0}function sae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;g=b+8|0;h=b;j=c[a>>2]|0;k=Aae(j,d,724744)|0;if(!k){l=64;i=b;return l|0}c[g>>2]=4;c[g+12>>2]=k;d=p9d(a,g,h)|0;if(!d){g=c[h>>2]|0;if(!g){m=81;n=0}else{a=zae(g,333319,f)|0;m=a;n=c[h>>2]|0}q9d(n,0);if(!m){c[e>>2]=k;l=0;i=b;return l|0}else o=m}else o=d;$ae(j,k);l=o;i=b;return l|0}function tae(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;d=i;i=i+16|0;h=d;j=SEi(e|0)|0;k=Xae(c[b>>2]|0,j+18|0,h)|0;b=c[h>>2]|0;if(b){l=b;i=d;return l|0}YEi(k|0,e|0,j|0)|0;e=k+j+0|0;j=724720|0;b=e+18|0;do{a[e>>0]=a[j>>0]|0;e=e+1|0;j=j+1|0}while((e|0)<(b|0));c[f>>2]=k;c[g>>2]=0;l=0;i=d;return l|0}function uae(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;d=i;i=i+16|0;h=d;j=SEi(e|0)|0;k=Xae(c[b>>2]|0,j+6|0,h)|0;b=c[h>>2]|0;if(b){l=b;i=d;return l|0}YEi(k|0,e|0,j|0)|0;e=k+j|0;a[e+0>>0]=a[724712]|0;a[e+1>>0]=a[724713]|0;a[e+2>>0]=a[724714]|0;a[e+3>>0]=a[724715]|0;a[e+4>>0]=a[724716]|0;a[e+5>>0]=a[724717]|0;c[f>>2]=k;c[g>>2]=0;l=0;i=d;return l|0}function vae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;g=Aae(c[a>>2]|0,d,724696)|0;if(!g){h=64;i=b;return h|0}c[e>>2]=g;c[f>>2]=0;h=0;i=b;return h|0}function wae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;g=Aae(c[a>>2]|0,d,724680)|0;if(!g){h=64;i=b;return h|0}c[e>>2]=g;c[f>>2]=0;h=0;i=b;return h|0}function xae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;g=b+8|0;h=b;j=c[a>>2]|0;k=Aae(j,d,724672)|0;if(!k){l=64;i=b;return l|0}c[g>>2]=4;c[g+12>>2]=k;d=p9d(a,g,h)|0;if(!d){g=c[h>>2]|0;if(!g){m=81;n=0}else{a=zae(g,333319,f)|0;m=a;n=c[h>>2]|0}q9d(n,0);if(!m){c[e>>2]=k;l=0;i=b;return l|0}else o=m}else o=d;$ae(j,k);l=o;i=b;return l|0}function yae(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;g=b+8|0;h=b;j=c[a>>2]|0;k=Aae(j,d,724656)|0;if(!k){l=64;i=b;return l|0}c[g>>2]=4;c[g+12>>2]=k;d=p9d(a,g,h)|0;if(!d){g=c[h>>2]|0;if(!g){m=81;n=0}else{a=zae(g,333319,f)|0;m=a;n=c[h>>2]|0}q9d(n,0);if(!m){c[e>>2]=k;l=0;i=b;return l|0}else o=m}else o=d;$ae(j,k);l=o;i=b;return l|0}function zae(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e;g=Rae(a,f)|0;h=c[f>>2]|0;a:do if(!h)if((g|0)==(b|0)){Rae(a,f)|0;j=c[f>>2]|0;if(!j){k=Eae(a,16)|0;c[f>>2]=k;if(!k){l=Qae(a,f)|0;m=c[f>>2]|0;if(!m){n=l&65535;if(!(l<<16>>16))o=2;else{l=0;while(1){p=Rae(a,f)|0;q=c[f>>2]|0;if(q){o=q;break a}if((p|0)==2){p=Rae(a,f)|0;if((c[f>>2]|0)==0?(Rae(a,f)|0,(c[f>>2]|0)==0):0){r=p;break}}else{p=Eae(a,8)|0;c[f>>2]=p;if(p){o=p;break a}}l=l+1|0;if((l|0)>=(n|0)){o=2;break a}}c[d>>2]=r;o=0}}else o=m}else o=k}else o=j}else o=2;else o=h;while(0);i=e;return o|0}function Aae(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;c[g>>2]=0;h=SEi(d|0)|0;j=(SEi(e|0)|0)+h|0;h=Xae(b,j+1|0,g)|0;if(c[g>>2]|0){k=0;i=f;return k|0}g=lCi(d,47)|0;if(!g){a[h>>0]=0;l=d}else{b=g-d+1|0;UEi(h|0,d|0,b|0)|0;a[h+b>>0]=0;l=g+1|0}kCi(h,e,j-(SEi(h|0)|0)|0)|0;kCi(h,l,j-(SEi(h|0)|0)|0)|0;k=h;i=f;return k|0}function Bae(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=0;c[a+32>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;return}function Cae(a){a=a|0;var b=0,d=0;b=i;if((a|0)!=0?(d=c[a+24>>2]|0,(d|0)!=0):0)ko[d&4095](a);i=b;return}function Dae(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+20>>2]|0;if(!e)if((c[a+4>>2]|0)>>>0<b>>>0)f=85;else g=4;else if(!(kn[e&511](a,b,0,0)|0))g=4;else f=85;if((g|0)==4){c[a+8>>2]=b;f=0}i=d;return f|0}function Eae(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;do if((b|0)<0)e=85;else{f=a+8|0;g=(c[f>>2]|0)+b|0;h=c[a+20>>2]|0;if(!h){if((c[a+4>>2]|0)>>>0<g>>>0){e=85;break}}else if(kn[h&511](a,g,0,0)|0){e=85;break}c[f>>2]=g;e=0}while(0);i=d;return e|0}function Fae(a){a=a|0;return c[a+8>>2]|0}function Gae(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+8|0;g=c[f>>2]|0;h=c[a+4>>2]|0;if(h>>>0<=g>>>0){j=85;i=e;return j|0}k=c[a+20>>2]|0;if(!k){l=h-g|0;h=l>>>0>d>>>0?d:l;YEi(b|0,(c[a>>2]|0)+g|0,h|0)|0;m=h}else m=kn[k&511](a,g,b,d)|0;c[f>>2]=m+g;j=m>>>0<d>>>0?85:0;i=e;return j|0}function Hae(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[a+4>>2]|0;if(g>>>0<=b>>>0){h=85;i=f;return h|0}j=c[a+20>>2]|0;if(!j){k=g-b|0;g=k>>>0>e>>>0?e:k;YEi(d|0,(c[a>>2]|0)+b|0,g|0)|0;l=g}else l=kn[j&511](a,b,d,e)|0;c[a+8>>2]=l+b;h=l>>>0<e>>>0?85:0;i=f;return h|0}function Iae(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Jae(a,b)|0;if(f){i=e;return f|0}b=a+32|0;c[d>>2]=c[b>>2];c[b>>2]=0;c[a+36>>2]=0;i=e;return f|0}function Jae(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;c[e>>2]=0;f=a+20|0;if(!(c[f>>2]|0)){g=a+8|0;h=c[g>>2]|0;j=c[a+4>>2]|0;if(j>>>0<=h>>>0|(j-h|0)>>>0<b>>>0){c[e>>2]=85;k=85;i=d;return k|0}else{j=c[a>>2]|0;c[a+32>>2]=j+h;l=h+b|0;c[a+36>>2]=j+l;c[g>>2]=l;k=0;i=d;return k|0}}l=c[a+28>>2]|0;if((c[a+4>>2]|0)>>>0<b>>>0){c[e>>2]=85;k=85;i=d;return k|0}g=Yae(l,b,e)|0;c[a>>2]=g;j=c[e>>2]|0;if(j){k=j;i=d;return k|0}j=a+8|0;h=kn[c[f>>2]&511](a,c[j>>2]|0,g,b)|0;g=c[a>>2]|0;if(h>>>0<b>>>0){$ae(l,g);c[a>>2]=0;c[e>>2]=85;m=85;n=0}else{m=c[e>>2]|0;n=g}c[a+32>>2]=n;c[a+36>>2]=n+b;c[j>>2]=(c[j>>2]|0)+h;k=m;i=d;return k|0}function Kae(a,b){a=a|0;b=b|0;var d=0;d=i;if((a|0)!=0?(c[a+20>>2]|0)!=0:0){$ae(c[a+28>>2]|0,c[b>>2]|0);c[b>>2]=0}c[b>>2]=0;i=d;return}function Lae(a){a=a|0;var b=0;b=i;if(c[a+20>>2]|0){$ae(c[a+28>>2]|0,c[a>>2]|0);c[a>>2]=0}c[a+32>>2]=0;c[a+36>>2]=0;i=b;return}function Mae(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+32|0;f=c[e>>2]|0;if(f>>>0>=(c[b+36>>2]|0)>>>0){g=0;i=d;return g|0}c[e>>2]=f+1;g=a[f>>0]|0;i=d;return g|0}function Nae(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;e=a+32|0;f=c[e>>2]|0;g=f+1|0;if(g>>>0>=(c[a+36>>2]|0)>>>0){h=f;j=0;c[e>>2]=h;i=b;return j|0}h=f+2|0;j=((d[f>>0]|0)<<8|(d[g>>0]|0))&65535;c[e>>2]=h;i=b;return j|0}function Oae(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;e=a+32|0;f=c[e>>2]|0;g=f+3|0;if(g>>>0>=(c[a+36>>2]|0)>>>0){h=f;j=0;c[e>>2]=h;i=b;return j|0}h=f+4|0;j=(d[f+1>>0]|0)<<16|(d[f>>0]|0)<<24|(d[f+2>>0]|0)<<8|(d[g>>0]|0);c[e>>2]=h;i=b;return j|0}function Pae(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;a[f>>0]=0;c[d>>2]=0;g=c[b+20>>2]|0;h=b+8|0;j=c[h>>2]|0;if(!g)if(j>>>0<(c[b+4>>2]|0)>>>0){k=a[(c[b>>2]|0)+j>>0]|0;a[f>>0]=k;l=j;m=k;n=6}else n=7;else if((kn[g&511](b,j,f,1)|0)==1){l=c[h>>2]|0;m=a[f>>0]|0;n=6}else n=7;if((n|0)==6){c[h>>2]=l+1;o=m;i=e;return o|0}else if((n|0)==7){c[d>>2]=85;o=0;i=e;return o|0}return 0}function Qae(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;c[b>>2]=0;g=a+8|0;h=c[g>>2]|0;do if((h+1|0)>>>0<(c[a+4>>2]|0)>>>0){j=c[a+20>>2]|0;if(!j){k=(c[a>>2]|0)+h|0;if(!k){l=h;m=0}else{n=h;o=k;p=6}}else{if((kn[j&511](a,h,f,2)|0)!=2)break;n=c[g>>2]|0;o=f;p=6}if((p|0)==6){l=n;m=((d[o>>0]|0)<<8|(d[o+1>>0]|0))&65535}c[g>>2]=l+2;q=m;i=e;return q|0}while(0);c[b>>2]=85;q=0;i=e;return q|0}function Rae(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;c[b>>2]=0;g=a+8|0;h=c[g>>2]|0;do if((h+3|0)>>>0<(c[a+4>>2]|0)>>>0){j=c[a+20>>2]|0;if(!j){k=(c[a>>2]|0)+h|0;if(!k){l=h;m=0}else{n=h;o=k;p=6}}else{if((kn[j&511](a,h,f,4)|0)!=4)break;n=c[g>>2]|0;o=f;p=6}if((p|0)==6){l=n;m=(d[o+1>>0]|0)<<16|(d[o>>0]|0)<<24|(d[o+2>>0]|0)<<8|(d[o+3>>0]|0)}c[g>>2]=l+4;q=m;i=e;return q|0}while(0);c[b>>2]=85;q=0;i=e;return q|0}function Sae(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;j=i;if(!((g|0)!=0&(f|0)!=0)){k=6;i=j;return k|0}l=f+32|0;m=f+36|0;n=g;g=0;a:while(1){o=n;p=c[l>>2]|0;b:while(1){q=a[o>>0]|0;switch(q&255|0){case 14:case 15:{r=p+2|0;s=16;t=(d[p+1>>0]|0)<<8|(d[p>>0]|0);u=18;break}case 9:case 8:{r=p+1|0;s=24;t=d[p>>0]|0;u=18;break}case 4:{v=o;break b;break}case 18:case 19:{r=p+4|0;s=0;t=(d[p+2>>0]|0)<<16|(d[p+3>>0]|0)<<24|(d[p+1>>0]|0)<<8|(d[p>>0]|0);u=18;break}case 25:case 24:{w=d[o+1>>0]|0;x=p+w|0;if(x>>>0>(c[m>>2]|0)>>>0){y=85;z=g;break a}if(q<<24>>24==24){YEi(h+(e[o+2>>1]|0)|0,p|0,w|0)|0;A=x}else A=x;break}case 20:case 21:{r=p+3|0;s=8;t=(d[p+1>>0]|0)<<8|(d[p>>0]|0)<<16|(d[p+2>>0]|0);u=18;break}case 22:case 23:{r=p+3|0;s=8;t=(d[p+1>>0]|0)<<8|(d[p+2>>0]|0)<<16|(d[p>>0]|0);u=18;break}case 16:case 17:{r=p+4|0;s=0;t=(d[p+1>>0]|0)<<16|(d[p>>0]|0)<<24|(d[p+2>>0]|0)<<8|(d[p+3>>0]|0);u=18;break}case 12:case 13:{r=p+2|0;s=16;t=(d[p>>0]|0)<<8|(d[p+1>>0]|0);u=18;break}default:{B=p;C=g;u=17;break a}}do if((u|0)==18){u=0;if(!(q&1))D=t;else D=t<<s>>s;x=h+(e[o+2>>1]|0)|0;w=d[o+1>>0]|0;if((w|0)==4){c[x>>2]=D;A=r;break}else if((w|0)==1){a[x>>0]=D;A=r;break}else if((w|0)==2){b[x>>1]=D;A=r;break}else{c[x>>2]=D;A=r;break}}while(0);o=o+4|0;p=A}p=Jae(f,e[v+2>>1]|0)|0;if(p){y=p;z=g;break}n=v+4|0;g=1}if((u|0)==17){c[l>>2]=B;y=0;z=C}if(!(z<<24>>24)){k=y;i=j;return k|0}if(c[f+20>>2]|0){$ae(c[f+28>>2]|0,c[f>>2]|0);c[f>>2]=0}c[l>>2]=0;c[m>>2]=0;k=y;i=j;return k|0}function Tae(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(!a){e=40;i=d;return e|0}f=a+12|0;c[f>>2]=0;c[a+16>>2]=b;c[a>>2]=0;c[a+8>>2]=0;g=a+20|0;c[g>>2]=0;h=a+24|0;c[h>>2]=0;j=ed(b|0,1067824)|0;if(!j){e=1;i=d;return e|0}yg(j|0,0,2)|0;b=Hc(j|0)|0;c[a+4>>2]=b;if(!b){dj(j|0)|0;e=81;i=d;return e|0}else{yg(j|0,0,0)|0;c[f>>2]=j;c[g>>2]=256;c[h>>2]=3540;e=0;i=d;return e|0}return 0}function Uae(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if((e|0)==0?(c[a+4>>2]|0)>>>0<b>>>0:0){g=1;i=f;return g|0}h=c[a+12>>2]|0;if((c[a+8>>2]|0)!=(b|0))yg(h|0,b|0,0)|0;g=ik(d|0,1,e|0,h|0)|0;i=f;return g|0}function Vae(a){a=a|0;var b=0,d=0;b=i;d=a+12|0;dj(c[d>>2]|0)|0;c[d>>2]=0;c[a+4>>2]=0;c[a>>2]=0;i=b;return}function Wae(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a;a=c[d>>2]|0;e=c[d+4>>2]|0;if(!a){f=(e|0)>-1?e:0-e|0;i=b;return f|0}d=(a|0)>-1?a:0-a|0;if(!e){f=d;i=b;return f|0}g=((e|0)>-1?e:0-e|0)|d;d=(g|0)>65535;h=d?g>>16:g;g=d?16:0;if((h|0)>255){j=g|8;k=h>>8}else{j=g;k=h}if((k|0)>15){l=j+4|0;m=k>>4}else{l=j;m=k}if((m|0)>3){n=l+2|0;o=m>>2}else{n=l;o=m}m=((o|0)>1&1)+n|0;if((m|0)<28){n=27-m|0;p=a<<n;q=e<<n;r=n}else{n=m+-27|0;p=a>>n;q=e>>n;r=27-m|0}if((p|0)<0){s=0-p|0;t=0-q|0}else{s=p;t=q}q=s<<1;if((t|0)<0){u=0;v=s-(t<<1)|0;w=t+q|0}else{u=0;v=(t<<1)+s|0;w=t-q|0}while(1){q=v>>u;if((w|0)<0){x=v-(w>>u)|0;y=w+q|0}else{x=(w>>u)+v|0;y=w-q|0}u=u+1|0;if((u|0)==23){z=x;break}else{v=x;w=y}}y=(z|0)>-1;w=y?z:0-z|0;z=w>>>16;x=w&65535;w=(x*17797|0)+(z*47593|0)|0;v=(x*47593|0)>>>16;x=w+v|0;u=(x>>>16)+(z*17797|0)|0;z=x>>>0<(w>>>0>=v>>>0?w:v)>>>0?u+65536|0:u;u=y?z:0-z|0;if((r|0)>0){f=u+(1<<r+-1)>>r;i=b;return f|0}else{f=u<<0-r;i=b;return f|0}return 0}function Xae(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((b|0)>0){f=_n[c[a+4>>2]&4095](a,b)|0;a=(f|0)==0;g=a?64:0;if(a){h=0;j=g}else{PEi(f|0,0,b|0)|0;h=f;j=g}}else{h=0;j=b>>31&6}c[d>>2]=j;i=e;return h|0}function Yae(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((b|0)>0){f=_n[c[a+4>>2]&4095](a,b)|0;g=f;h=(f|0)==0?64:0}else{g=0;h=b>>31&6}c[d>>2]=h;i=e;return g|0}function Zae(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;if((d|b|e|0)<0){j=f;k=6;c[g>>2]=k;i=h;return j|0}do if((e|0)==0|(b|0)==0)if(!f){l=0;m=0}else{In[c[a+8>>2]&4095](a,f);l=0;m=0}else{if((2147483647/(b|0)|0|0)<(e|0)){j=f;k=10;c[g>>2]=k;i=h;return j|0}if(!((d|0)==0&(f|0)==0)){n=da(d,b)|0;o=da(e,b)|0;p=kn[c[a+12>>2]&511](a,n,o,f)|0;o=(p|0)==0;l=o?f:p;m=o?64:0;break}o=da(e,b)|0;if((o|0)<=0){l=0;m=o>>31&6;break}p=_n[c[a+4>>2]&4095](a,o)|0;n=(p|0)==0;q=n?64:0;if(n){l=0;m=q}else{PEi(p|0,0,o|0)|0;l=p;m=q}}while(0);if(!((m|0)==0&(e|0)>(d|0))){j=l;k=m;c[g>>2]=k;i=h;return j|0}PEi(l+(da(d,b)|0)|0,0,da(e-d|0,b)|0)|0;j=l;k=0;c[g>>2]=k;i=h;return j|0}function _ae(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;do if((d|b|e|0)>=0){if((e|0)==0|(b|0)==0){if(!f){j=0;k=0;break}In[c[a+8>>2]&4095](a,f);j=0;k=0;break}if((2147483647/(b|0)|0|0)>=(e|0)){if(!((d|0)==0&(f|0)==0)){l=da(d,b)|0;m=da(e,b)|0;n=kn[c[a+12>>2]&511](a,l,m,f)|0;m=(n|0)==0;j=m?f:n;k=m?64:0;break}m=da(e,b)|0;if((m|0)<=0){j=0;k=m>>31&6;break}n=_n[c[a+4>>2]&4095](a,m)|0;l=(n|0)==0;o=l?64:0;if(l){j=0;k=o}else{PEi(n|0,0,m|0)|0;j=n;k=o}}else{j=f;k=10}}else{j=f;k=6}while(0);c[g>>2]=k;i=h;return j|0}function $ae(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}In[c[a+8>>2]&4095](a,b);i=d;return}function abe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if(b){f=(SEi(b|0)|0)+1|0;if((f|0)>0){g=_n[c[a+4>>2]&4095](a,f)|0;h=f;j=g;k=(g|0)==0?64:0}else{l=f;m=4}}else{l=0;m=4}if((m|0)==4){h=l;j=0;k=l>>31&6}if(!((k|0)==0&(b|0)!=0)){c[d>>2]=k;i=e;return j|0}YEi(j|0,b|0,h|0)|0;c[d>>2]=k;i=e;return j|0}function bbe(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;a:do if(d>>>0>1){f=c;g=b;h=d;while(1){j=a[f>>0]|0;if(!(j<<24>>24)){k=f;l=g;break a}m=f+1|0;n=g+1|0;a[g>>0]=j;h=h+-1|0;if(h>>>0<=1){k=m;l=n;break}else{f=m;g=n}}}else{k=c;l=b}while(0);a[l>>0]=0;i=e;return (a[k>>0]|0)!=0|0}function cbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;a:do if(!e)f=0;else{a=e;while(1){if((c[a+8>>2]|0)==(b|0)){f=a;break a}a=c[a+4>>2]|0;if(!a){f=0;break}}}while(0);i=d;return f|0}function dbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+4|0;f=c[e>>2]|0;c[b+4>>2]=0;c[b>>2]=f;if(!f){c[a>>2]=b;c[e>>2]=b;i=d;return}else{c[f+4>>2]=b;c[e>>2]=b;i=d;return}}function ebe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b>>2]|0;f=c[b+4>>2]|0;if(!e)c[a>>2]=f;else c[e+4>>2]=f;if(!f){c[a+4>>2]=e;i=d;return}else{c[f>>2]=e;i=d;return}}function fbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b>>2]|0;f=b+4|0;g=c[f>>2]|0;if(!e){i=d;return}c[e+4>>2]=g;if(!g)c[a+4>>2]=e;else c[g>>2]=e;c[b>>2]=0;e=c[a>>2]|0;c[f>>2]=e;c[e>>2]=b;c[a>>2]=b;i=d;return}function gbe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[a>>2]|0;if(g){h=d+8|0;if(!b){j=g;do{k=j;j=c[j+4>>2]|0;if(k)In[c[h>>2]&4095](d,k)}while((j|0)!=0)}else{j=g;do{g=j;j=c[j+4>>2]|0;co[b&2047](d,c[g+8>>2]|0,e);if(g)In[c[h>>2]&4095](d,g)}while((j|0)!=0)}}c[a>>2]=0;c[a+4>>2]=0;i=f;return}function hbe(a,b){a=a|0;b=b|0;c[b>>2]=257;c[b+4>>2]=2748;return}function ibe(a,b){a=a|0;b=b|0;c[b>>2]=2749;c[b+4>>2]=0;c[b+8>>2]=3606;c[b+12>>2]=0;c[b+16>>2]=0;return}function jbe(a,b){a=a|0;b=b|0;c[b>>2]=3607;return}function kbe(a,b){a=a|0;b=b|0;c[b>>2]=2750;return}function lbe(a,b){a=a|0;b=b|0;c[b>>2]=258;c[b+4>>2]=2751;c[b+8>>2]=1741;return}function mbe(a,b){a=a|0;b=b|0;var d=0;d=i;if(b)$ae(c[a>>2]|0,b);i=d;return}function nbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=Xae(c[a>>2]|0,56,e)|0;g=c[e>>2]|0;if(g){h=g;i=d;return h|0}c[f>>2]=789752;c[f+4>>2]=724752;c[f+8>>2]=724760;g=c[a+204>>2]|0;c[f+12>>2]=g+8;c[f+16>>2]=788816;c[f+20>>2]=g+36;c[f+24>>2]=788840;c[f+28>>2]=g+28;c[f+32>>2]=788856;c[f+36>>2]=g+40;c[f+40>>2]=724776;c[f+44>>2]=g+44;c[f+48>>2]=0;c[f+52>>2]=0;c[b>>2]=f;h=0;i=d;return h|0}function obe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;Eie(a);if(!b){i=d;return}$ae(e,b);i=d;return}function pbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,104,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=Fie(a)|0;c[e>>2]=h;if(!h){c[g>>2]=1281;c[g+4>>2]=44;c[g+8>>2]=724784;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=0;c[g+24>>2]=3608;c[g+28>>2]=3541;c[g+32>>2]=2752;c[g+36>>2]=800;c[g+40>>2]=48;c[g+44>>2]=172;c[g+48>>2]=208;c[g+52>>2]=3542;c[g+56>>2]=3609;c[g+60>>2]=3543;c[g+64>>2]=3610;c[g+68>>2]=3544;c[g+72>>2]=209;c[g+76>>2]=1742;c[g+80>>2]=259;c[g+84>>2]=260;c[g+88>>2]=0;c[g+92>>2]=210;c[g+96>>2]=2753;c[g+100>>2]=2754;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function qbe(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0;g=i;h=c[a+692>>2]|0;if(!(c[h+2956>>2]|0)){j=2;i=g;return j|0}a=Mbe(h,e[(c[h+1160>>2]|0)+(b<<1)>>1]|0)|0;if(!a){j=0;i=g;return j|0}bbe(d,a,f)|0;j=0;i=g;return j|0}function rbe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[a+692>>2]|0;g=T9d(c[a+96>>2]|0,788624)|0;if(!g){h=0;i=e;return h|0}a=f+12|0;if(!(c[a>>2]|0)){h=0;i=e;return h|0}j=f+1160|0;k=g+20|0;g=0;while(1){l=b[(c[j>>2]|0)+(g<<1)>>1]|0;m=l&65535;if((l&65535)>390)n=Lbe(f,m+-391|0)|0;else n=mo[c[k>>2]&4095](m)|0;if((n|0)!=0?(HEi(d,n)|0)==0:0){h=g;o=10;break}g=g+1|0;if(g>>>0>=(c[a>>2]|0)>>>0){h=0;o=10;break}}if((o|0)==10){i=e;return h|0}return 0}function sbe(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[d+692>>2]|0;c[g>>2]=0;if(!h){j=c[g>>2]|0;i=f;return j|0}k=h+2960|0;l=c[k>>2]|0;do if(!l){m=Xae(c[d+100>>2]|0,32,g)|0;if(!(c[g>>2]|0)){c[m>>2]=Mbe(h,c[h+1324>>2]|0)|0;c[m+4>>2]=Mbe(h,c[h+1328>>2]|0)|0;c[m+8>>2]=Mbe(h,c[h+1336>>2]|0)|0;c[m+12>>2]=Mbe(h,c[h+1340>>2]|0)|0;c[m+16>>2]=Mbe(h,c[h+1344>>2]|0)|0;c[m+20>>2]=c[h+1352>>2];a[m+24>>0]=a[h+1348>>0]|0;b[m+26>>1]=c[h+1356>>2];b[m+28>>1]=c[h+1360>>2];c[k>>2]=m;n=m;break}else{j=c[g>>2]|0;i=f;return j|0}}else n=l;while(0);c[e+0>>2]=c[n+0>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];c[e+16>>2]=c[n+16>>2];c[e+20>>2]=c[n+20>>2];c[e+24>>2]=c[n+24>>2];c[e+28>>2]=c[n+28>>2];j=c[g>>2]|0;i=f;return j|0}function tbe(a){a=a|0;return (c[a+8>>2]|0)>>>9&1|0}function ube(a){a=a|0;return c[(c[a+692>>2]|0)+1304>>2]|0}function vbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0;c[b>>2]=0;c[b+4>>2]=0;f=c[a+12>>2]|0;g=c[e+204>>2]|0;if((((f|0)!=(g+56|0)?(f|0)!=(g+96|0):0)?(g=T9d(C9d(e,789856)|0,788856)|0,(g|0)!=0):0)?(e=c[g>>2]|0,(e|0)!=0):0)h=_n[e&4095](a,b)|0;else h=0;i=d;return h|0}function wbe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[a+692>>2]|0;if(!g){h=0;i=f;return h|0}a=c[g+1456>>2]|0;if((a|0)==65535){h=6;i=f;return h|0}if(b){j=g+2964|0;k=c[j>>2]|0;if(!k){l=Mbe(g,a)|0;c[j>>2]=l;m=l}else m=k;c[b>>2]=m}if(d){m=g+2968|0;b=c[m>>2]|0;if(!b){k=Mbe(g,c[g+1460>>2]|0)|0;c[m>>2]=k;n=k}else n=b;c[d>>2]=n}if(!e){h=0;i=f;return h|0}c[e>>2]=c[g+1464>>2];h=0;i=f;return h|0}function xbe(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=c[b+692>>2]|0;a[d>>0]=0;if((f|0)!=0?(c[f+1456>>2]|0)!=65535:0)a[d>>0]=1;i=e;return 0}function ybe(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0;f=i;g=c[a+692>>2]|0;if(g)if((c[g+1456>>2]|0)!=65535?(c[g+12>>2]|0)>>>0>=b>>>0:0)if(!d)h=0;else{c[d>>2]=e[(c[g+1160>>2]|0)+(b<<1)>>1];h=0}else h=6;else h=0;i=f;return h|0}function zbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+4|0;a=m9d(c[c[(c[e>>2]|0)+204>>2]>>2]|0,b)|0;if(a){f=a;i=d;return f|0}a=C9d(c[e>>2]|0,789856)|0;if(!a){f=0;i=d;return f|0}f=_n[c[(c[a>>2]|0)+32>>2]&4095](a,b)|0;i=d;return f|0}function Abe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if(!a){g=37;i=f;return g|0}h=(b|0)==0?e|3:e;e=(h&1|0)==0?b:0;if((e|0)!=0?(c[b>>2]|0)!=(c[a+4>>2]|0):0){g=35;i=f;return g|0}g=Ebe(a,e,d,h)|0;i=f;return g|0}function Bbe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[a+532>>2]|0;c[e>>2]=0;c[e+4>>2]=0;if(!g){i=f;return 0}c[e>>2]=xo[c[g+128>>2]&2047](a,b,d)|0;i=f;return 0}function Cbe(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;h=c[a+84>>2]|0;j=a+88|0;if(!d){k=0;i=g;return k|0}a=(e&16|0)==0?h+56|0:h+60|0;l=h+4|0;if(!h){k=37;i=g;return k|0}else m=0;while(1){n=c[j>>2]|0;o=m+b|0;p=((n|0)==0?259:256)|e;q=(p&1|0)==0?n:0;if((q|0)!=0?(c[n>>2]|0)!=(c[l>>2]|0):0){k=35;r=7;break}n=Ebe(h,q,o,p)|0;if(n){k=n;r=7;break}c[f+(m<<2)>>2]=c[a>>2];m=m+1|0;if(m>>>0>=d>>>0){k=0;r=7;break}}if((r|0)==7){i=g;return k|0}return 0}function Dbe(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0;h=i;i=i+16|0;j=h+8|0;k=h+4|0;l=h;c[j>>2]=e;c[k>>2]=f;m=c[(c[e+76>>2]|0)+1368>>2]|0;c[e+756>>2]=0;a[e+752>>0]=1;n=k^j^l;k=(n>>>10^n^n>>20)&65535;c[l>>2]=(k|0)==0?29572:k;k=e+80|0;c[e+276>>2]=k;n=e+280|0;c[e+676>>2]=n;o=c[e+68>>2]|0;p=e+64|0;a[p>>0]=0;c[n>>2]=f;q=f+g|0;c[e+284>>2]=q;c[e+288>>2]=f;g=c[e+24>>2]|0;r=c[e+28>>2]|0;s=(o|0)!=0;if(s){ko[c[o+4>>2]&4095](c[o>>2]|0);t=o}else t=o;u=k;v=(m|0)==2?0:16;m=o+12|0;w=o+16|0;x=e+20|0;y=o+20|0;z=e+65|0;A=e+12|0;B=f;f=q;q=g;g=r;r=n;a:while(1){if(B>>>0<f>>>0)C=B;else{D=0;E=444;break}b:while(1){n=C+1|0;F=a[C>>0]|0;G=F&255;H=F<<24>>24==28;c:do if((F&255)>31|H){do if(!H){if((F&255)<247){I=n;J=16;K=G+-139|0;break}if((F&255)<251){if(n>>>0>=f>>>0){D=3;E=444;break a}I=C+2|0;J=16;K=(d[n>>0]|(G<<8)+-63232)+108|0;break}if(F<<24>>24==-1){L=C+4|0;if(L>>>0>=f>>>0){D=3;E=444;break a}I=C+5|0;J=v;K=d[C+2>>0]<<16|d[n>>0]<<24|d[C+3>>0]<<8|d[L>>0];break}else{if(n>>>0>=f>>>0){D=3;E=444;break a}I=C+2|0;J=16;K=(251-G<<8)+-108-(d[n>>0]|0)|0;break}}else{L=C+2|0;if(L>>>0>=f>>>0){D=3;E=444;break a}I=C+3|0;J=16;K=(d[n>>0]<<8|d[L>>0])<<16>>16}while(0);L=(c[j>>2]|0)+276|0;M=c[L>>2]|0;if((M-u|0)>188){D=130;E=444;break a}c[L>>2]=M+4;c[M>>2]=K<<J;N=I}else{M=c[j>>2]|0;L=c[M+276>>2]|0;switch(G|0){case 4:{O=n;P=M;Q=L;E=25;break b;break}case 23:{R=n;S=M;T=L;E=76;break b;break}case 29:{U=n;V=M;W=L;E=81;break b;break}case 30:{X=n;Y=M;Z=L;E=82;break b;break}case 13:{_=n;$=M;aa=L;E=68;break b;break}case 12:break;case 14:{ba=n;ca=M;da=L;E=69;break b;break}case 16:{ea=n;fa=M;ga=L;E=70;break b;break}case 18:{ha=n;ia=M;ja=L;E=71;break b;break}case 19:{ka=n;la=M;ma=L;E=72;break b;break}case 20:{na=n;oa=M;pa=L;E=73;break b;break}case 21:{qa=n;ra=M;sa=L;E=74;break b;break}case 5:{ta=n;ua=M;va=L;E=26;break b;break}case 3:{wa=n;xa=M;ya=L;E=24;break b;break}case 8:{za=n;Aa=M;Ba=L;E=29;break b;break}case 7:{Ca=n;Da=M;Ea=L;E=28;break b;break}case 24:{Fa=n;Ga=M;Ha=L;E=77;break b;break}case 25:{Ia=n;Ja=M;Ka=L;E=78;break b;break}case 26:{La=n;Ma=M;Na=L;E=79;break b;break}case 27:{Oa=n;Pa=M;Qa=L;E=80;break b;break}case 11:{Ra=n;Sa=M;Ta=L;E=32;break b;break}case 9:{Ua=n;Va=M;Wa=L;E=30;break b;break}case 6:{Xa=n;Ya=M;Za=L;E=27;break b;break}case 10:{_a=n;$a=M;ab=L;E=31;break b;break}case 22:{bb=n;cb=M;db=L;E=75;break b;break}case 31:{eb=n;fb=M;gb=L;E=83;break b;break}case 1:{hb=M;ib=L;jb=n;kb=19;E=84;break b;break}default:{N=n;break c}}if(n>>>0>=f>>>0){D=3;E=444;break a}lb=C+2|0;switch(d[n>>0]|0){case 27:{mb=M;nb=L;ob=lb;E=59;break b;break}case 28:{pb=M;qb=L;rb=lb;E=60;break b;break}case 15:{sb=M;tb=L;ub=lb;E=49;break b;break}case 37:{vb=M;wb=L;xb=lb;E=67;break b;break}case 14:{yb=M;zb=L;Ab=lb;E=48;break b;break}case 16:{Bb=M;Cb=L;Db=lb;E=50;break b;break}case 4:{Eb=M;Fb=L;Gb=lb;E=38;break b;break}case 5:{Hb=M;Ib=L;Jb=lb;E=39;break b;break}case 6:{Kb=M;Lb=L;Mb=lb;E=40;break b;break}case 7:{Nb=M;Ob=L;Pb=lb;E=41;break b;break}case 24:{Qb=M;Rb=L;Sb=lb;E=57;break b;break}case 12:{Tb=M;Ub=L;Vb=lb;E=46;break b;break}case 13:{Wb=M;Xb=L;Yb=lb;E=47;break b;break}case 17:{Zb=M;_b=L;$b=lb;E=51;break b;break}case 18:{ac=M;bc=L;cc=lb;E=52;break b;break}case 30:{dc=M;ec=L;fc=lb;E=62;break b;break}case 33:{gc=M;hc=L;ic=lb;E=63;break b;break}case 34:{jc=M;kc=L;lc=lb;E=64;break b;break}case 35:{mc=M;nc=L;oc=lb;E=65;break b;break}case 36:{pc=M;qc=L;rc=lb;E=66;break b;break}case 8:{sc=M;tc=L;uc=lb;E=42;break b;break}case 9:{vc=M;wc=L;xc=lb;E=43;break b;break}case 2:{yc=M;zc=L;Ac=lb;E=36;break b;break}case 3:{Bc=M;Cc=L;Dc=lb;E=37;break b;break}case 26:{Ec=M;Fc=L;Gc=lb;E=58;break b;break}case 1:{Hc=M;Ic=L;Jc=lb;E=35;break b;break}case 20:{Kc=M;Lc=L;Mc=lb;E=53;break b;break}case 21:{Nc=M;Oc=L;Pc=lb;E=54;break b;break}case 22:{Qc=M;Rc=L;Sc=lb;E=55;break b;break}case 23:{Tc=M;Uc=L;Vc=lb;E=56;break b;break}case 10:{Wc=M;Xc=L;Yc=lb;E=44;break b;break}case 11:{Zc=M;_c=L;$c=lb;E=45;break b;break}case 29:{ad=M;bd=L;cd=lb;E=61;break b;break}case 0:{hb=M;ib=L;jb=lb;kb=25;E=84;break b;break}default:N=lb}}while(0);if(N>>>0<f>>>0)C=N;else{D=0;E=444;break a}}switch(E|0){case 24:{E=0;dd=ya-(xa+80)|0;ed=xa;fd=ya;gd=wa;hd=20;break}case 25:{E=0;dd=Q-(P+80)|0;ed=P;fd=Q;gd=O;hd=3;break}case 26:{E=0;dd=va-(ua+80)|0;ed=ua;fd=va;gd=ta;hd=4;break}case 27:{E=0;dd=Za-(Ya+80)|0;ed=Ya;fd=Za;gd=Xa;hd=5;break}case 28:{E=0;dd=Ea-(Da+80)|0;ed=Da;fd=Ea;gd=Ca;hd=6;break}case 29:{E=0;dd=Ba-(Aa+80)|0;ed=Aa;fd=Ba;gd=za;hd=7;break}case 30:{E=0;dd=Wa-(Va+80)|0;ed=Va;fd=Wa;gd=Ua;hd=53;break}case 31:{E=0;dd=ab-($a+80)|0;ed=$a;fd=ab;gd=_a;hd=49;break}case 32:{E=0;dd=Ta-(Sa+80)|0;ed=Sa;fd=Ta;gd=Ra;hd=51;break}case 35:{E=0;dd=Ic-(Hc+80)|0;ed=Hc;fd=Ic;gd=Jc;hd=20;break}case 36:{E=0;dd=zc-(yc+80)|0;ed=yc;fd=zc;gd=Ac;hd=19;break}case 37:{E=0;dd=Cc-(Bc+80)|0;ed=Bc;fd=Cc;gd=Dc;hd=44;break}case 38:{E=0;dd=Fb-(Eb+80)|0;ed=Eb;fd=Fb;gd=Gb;hd=45;break}case 39:{E=0;dd=Ib-(Hb+80)|0;ed=Hb;fd=Ib;gd=Jb;hd=46;break}case 40:{E=0;dd=Lb-(Kb+80)|0;ed=Kb;fd=Lb;gd=Mb;hd=56;break}case 41:{E=0;dd=Ob-(Nb+80)|0;ed=Nb;fd=Ob;gd=Pb;hd=57;break}case 42:{E=0;dd=tc-(sc+80)|0;ed=sc;fd=tc;gd=uc;hd=42;break}case 43:{E=0;dd=wc-(vc+80)|0;ed=vc;fd=wc;gd=xc;hd=26;break}case 44:{E=0;dd=Xc-(Wc+80)|0;ed=Wc;fd=Xc;gd=Yc;hd=27;break}case 45:{E=0;dd=_c-(Zc+80)|0;ed=Zc;fd=_c;gd=$c;hd=28;break}case 46:{E=0;dd=Ub-(Tb+80)|0;ed=Tb;fd=Ub;gd=Vb;hd=29;break}case 47:{E=0;dd=Xb-(Wb+80)|0;ed=Wb;fd=Xb;gd=Yb;hd=43;break}case 48:{E=0;dd=zb-(yb+80)|0;ed=yb;fd=zb;gd=Ab;hd=30;break}case 49:{E=0;dd=tb-(sb+80)|0;ed=sb;fd=tb;gd=ub;hd=47;break}case 50:{E=0;dd=Cb-(Bb+80)|0;ed=Bb;fd=Cb;gd=Db;hd=54;break}case 51:{E=0;dd=_b-(Zb+80)|0;ed=Zb;fd=_b;gd=$b;hd=55;break}case 52:{E=0;dd=bc-(ac+80)|0;ed=ac;fd=bc;gd=cc;hd=35;break}case 53:{E=0;dd=Lc-(Kc+80)|0;ed=Kc;fd=Lc;gd=Mc;hd=40;break}case 54:{E=0;dd=Oc-(Nc+80)|0;ed=Nc;fd=Oc;gd=Pc;hd=41;break}case 55:{E=0;dd=Rc-(Qc+80)|0;ed=Qc;fd=Rc;gd=Sc;hd=48;break}case 56:{E=0;dd=Uc-(Tc+80)|0;ed=Tc;fd=Uc;gd=Vc;hd=31;break}case 57:{E=0;dd=Rb-(Qb+80)|0;ed=Qb;fd=Rb;gd=Sb;hd=32;break}case 58:{E=0;dd=Fc-(Ec+80)|0;ed=Ec;fd=Fc;gd=Gc;hd=33;break}case 59:{E=0;dd=nb-(mb+80)|0;ed=mb;fd=nb;gd=ob;hd=39;break}case 60:{E=0;dd=qb-(pb+80)|0;ed=pb;fd=qb;gd=rb;hd=36;break}case 61:{E=0;dd=bd-(ad+80)|0;ed=ad;fd=bd;gd=cd;hd=37;break}case 62:{E=0;dd=ec-(dc+80)|0;ed=dc;fd=ec;gd=fc;hd=38;break}case 63:{E=0;dd=hc-(gc+80)|0;ed=gc;fd=hc;gd=ic;hd=58;break}case 64:{E=0;dd=kc-(jc+80)|0;ed=jc;fd=kc;gd=lc;hd=15;break}case 65:{E=0;dd=nc-(mc+80)|0;ed=mc;fd=nc;gd=oc;hd=14;break}case 66:{E=0;dd=qc-(pc+80)|0;ed=pc;fd=qc;gd=rc;hd=16;break}case 67:{E=0;dd=wb-(vb+80)|0;ed=vb;fd=wb;gd=xb;hd=17;break}case 68:{E=0;dd=aa-($+80)|0;ed=$;fd=aa;gd=_;hd=52;break}case 69:{E=0;dd=da-(ca+80)|0;ed=ca;fd=da;gd=ba;hd=18;break}case 70:{E=0;dd=ga-(fa+80)|0;ed=fa;fd=ga;gd=ea;hd=34;break}case 71:{E=0;dd=ja-(ia+80)|0;ed=ia;fd=ja;gd=ha;hd=21;break}case 72:{E=0;dd=ma-(la+80)|0;ed=la;fd=ma;gd=ka;hd=23;break}case 73:{E=0;dd=pa-(oa+80)|0;ed=oa;fd=pa;gd=na;hd=24;break}case 74:{E=0;dd=sa-(ra+80)|0;ed=ra;fd=sa;gd=qa;hd=1;break}case 75:{E=0;dd=db-(cb+80)|0;ed=cb;fd=db;gd=bb;hd=2;break}case 76:{E=0;dd=T-(S+80)|0;ed=S;fd=T;gd=R;hd=22;break}case 77:{E=0;dd=Ha-(Ga+80)|0;ed=Ga;fd=Ha;gd=Fa;hd=10;break}case 78:{E=0;dd=Ka-(Ja+80)|0;ed=Ja;fd=Ka;gd=Ia;hd=11;break}case 79:{E=0;dd=Na-(Ma+80)|0;ed=Ma;fd=Na;gd=La;hd=13;break}case 80:{E=0;dd=Qa-(Pa+80)|0;ed=Pa;fd=Qa;gd=Oa;hd=8;break}case 81:{E=0;dd=W-(V+80)|0;ed=V;fd=W;gd=U;hd=50;break}case 82:{E=0;dd=Z-(Y+80)|0;ed=Y;fd=Z;gd=X;hd=12;break}case 83:{E=0;dd=gb-(fb+80)|0;ed=fb;fd=gb;gd=eb;hd=9;break}case 84:{E=0;dd=ib-(hb+80)|0;ed=hb;fd=ib;gd=jb;hd=kb;break}}n=dd>>2;G=d[724792+hd>>0]|0;if(!(G&128)){id=n;jd=G}else{G=ed+752|0;d:do if((dd|0)>0?(a[G>>0]|0)!=0:0){switch(hd|0){case 3:case 2:{kd=n&2;break}case 24:case 23:case 1:case 22:case 21:case 20:case 19:{kd=n&1;break}case 18:{kd=(n&-5|0)==1&1;break}default:{ld=n;break d}}if(kd){c[ed+744>>2]=(c[k>>2]>>16)+(c[ed+748>>2]|0);if(a[ed+753>>0]|0){D=0;E=444;break a}ld=n+-1|0}else ld=n}else ld=n;while(0);a[G>>0]=0;id=ld;jd=0}n=jd&15;if((id|0)<(n|0)){D=129;E=444;break}F=fd+(0-n<<2)|0;H=id-n|0;e:do switch(hd|0){case 22:case 21:case 20:case 19:{if(s){lb=(H|0)/2|0;Dn[c[m>>2]&511](c[t>>2]|0,((hd|0)==19|(hd|0)==21)&1,lb,fd+(0-(n+(H&-2))<<2)|0);md=lb;nd=c[j>>2]|0}else{md=(H|0)/2|0;nd=ed}lb=nd+756|0;c[lb>>2]=(c[lb>>2]|0)+md;od=k;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 24:case 23:{if((H|0)>0){if(s){lb=(H|0)/2|0;Dn[c[m>>2]&511](c[t>>2]|0,0,lb,fd+(0-(n+(H&-2))<<2)|0);ud=lb;vd=c[j>>2]|0}else{ud=(H|0)/2|0;vd=ed}lb=vd+756|0;L=(c[lb>>2]|0)+ud|0;c[lb>>2]=L;wd=L}else wd=c[ed+756>>2]|0;if((gd+(wd+7>>3)|0)>>>0>=f>>>0){D=3;E=444;break a}do if(s)if((hd|0)==23){Dn[c[w>>2]&511](c[t>>2]|0,b[(c[x>>2]|0)+2>>1]|0,wd,gd);break}else{co[c[y>>2]&2047](c[t>>2]|0,wd,gd);break}while(0);od=k;pd=gd+((c[(c[j>>2]|0)+756>>2]|0)+7>>3)|0;qd=f;rd=q;sd=g;td=r;break}case 1:{L=c[x>>2]|0;do if(L){lb=b[L>>1]|0;if(lb<<16>>16<2)xd=0;else xd=(b[(c[L+12>>2]|0)+((lb<<16>>16)+-2<<1)>>1]|0)+1|0;M=L+2|0;yd=b[M>>1]|0;if(((yd<<16>>16>1?(zd=c[L+4>>2]|0,Ad=(yd<<16>>16)+-1|0,Bd=(c[L+8>>2]|0)+Ad|0,(c[zd+(xd<<3)>>2]|0)==(c[zd+(Ad<<3)>>2]|0)):0)?(c[zd+(xd<<3)+4>>2]|0)==(c[zd+(Ad<<3)+4>>2]|0):0)?(a[Bd>>0]|0)==1:0){Bd=yd+-1<<16>>16;b[M>>1]=Bd;Cd=Bd}else Cd=yd;yd=lb<<16>>16;if(lb<<16>>16>0){Bd=(Cd<<16>>16)+-1|0;if((xd|0)==(Bd|0)){b[L>>1]=lb+-1<<16>>16;b[M>>1]=Cd+-1<<16>>16;break}else{b[(c[L+12>>2]|0)+(yd+-1<<1)>>1]=Bd;break}}}while(0);a[p>>0]=0;od=k;pd=gd;qd=f;rd=(c[fd+(-2-n<<2)>>2]|0)+q|0;sd=(c[fd+(((jd|-16)^15)<<2)>>2]|0)+g|0;td=r;break}case 3:{L=c[x>>2]|0;do if(L){Bd=b[L>>1]|0;if(Bd<<16>>16<2)Dd=0;else Dd=(b[(c[L+12>>2]|0)+((Bd<<16>>16)+-2<<1)>>1]|0)+1|0;yd=L+2|0;M=b[yd>>1]|0;if(((M<<16>>16>1?(lb=c[L+4>>2]|0,Ad=(M<<16>>16)+-1|0,zd=(c[L+8>>2]|0)+Ad|0,(c[lb+(Dd<<3)>>2]|0)==(c[lb+(Ad<<3)>>2]|0)):0)?(c[lb+(Dd<<3)+4>>2]|0)==(c[lb+(Ad<<3)+4>>2]|0):0)?(a[zd>>0]|0)==1:0){zd=M+-1<<16>>16;b[yd>>1]=zd;Ed=zd}else Ed=M;M=Bd<<16>>16;if(Bd<<16>>16>0){zd=(Ed<<16>>16)+-1|0;if((Dd|0)==(zd|0)){b[L>>1]=Bd+-1<<16>>16;b[yd>>1]=Ed+-1<<16>>16;break}else{b[(c[L+12>>2]|0)+(M+-1<<1)>>1]=zd;break}}}while(0);a[p>>0]=0;od=k;pd=gd;qd=f;rd=q;sd=(c[fd+(((jd|-16)^15)<<2)>>2]|0)+g|0;td=r;break}case 2:{L=c[x>>2]|0;do if(L){zd=b[L>>1]|0;if(zd<<16>>16<2)Fd=0;else Fd=(b[(c[L+12>>2]|0)+((zd<<16>>16)+-2<<1)>>1]|0)+1|0;M=L+2|0;yd=b[M>>1]|0;if(((yd<<16>>16>1?(Bd=c[L+4>>2]|0,Ad=(yd<<16>>16)+-1|0,lb=(c[L+8>>2]|0)+Ad|0,(c[Bd+(Fd<<3)>>2]|0)==(c[Bd+(Ad<<3)>>2]|0)):0)?(c[Bd+(Fd<<3)+4>>2]|0)==(c[Bd+(Ad<<3)+4>>2]|0):0)?(a[lb>>0]|0)==1:0){lb=yd+-1<<16>>16;b[M>>1]=lb;Gd=lb}else Gd=yd;yd=zd<<16>>16;if(zd<<16>>16>0){lb=(Gd<<16>>16)+-1|0;if((Fd|0)==(lb|0)){b[L>>1]=zd+-1<<16>>16;b[M>>1]=Gd+-1<<16>>16;break}else{b[(c[L+12>>2]|0)+(yd+-1<<1)>>1]=lb;break}}}while(0);a[p>>0]=0;od=k;pd=gd;qd=f;rd=(c[fd+(((jd|-16)^15)<<2)>>2]|0)+q|0;sd=g;td=r;break}case 4:{if(Fbe(e,q,g)|0){D=0;E=444;break a}L=(H|0)/2|0;if((H+1|0)>>>0<3){D=129;E=444;break a}lb=c[A>>2]|0;if(((b[lb+22>>1]|0)+L+(b[lb+58>>1]|0)|0)>>>0>(c[lb+4>>2]|0)>>>0?(V8d(lb,L,0)|0)!=0:0){D=0;E=444;break a}if((H|0)<2){D=129;E=444;break a}L=fd+(0-(n+(H&-2))<<2)|0;lb=c[j>>2]|0;if(L>>>0<(c[lb+276>>2]|0)>>>0){yd=lb;lb=L;L=q;M=g;while(1){zd=(c[lb>>2]|0)+L|0;Ad=(c[lb+4>>2]|0)+M|0;Bd=c[x>>2]|0;if(!(a[z>>0]|0)){Hd=Bd+2|0;Id=yd}else{Jd=c[Bd+4>>2]|0;Kd=Bd+2|0;Ld=b[Kd>>1]|0;Md=(c[Bd+8>>2]|0)+Ld|0;c[Jd+(Ld<<3)>>2]=zd>>16;c[Jd+(Ld<<3)+4>>2]=Ad>>16;a[Md>>0]=1;Hd=Kd;Id=c[j>>2]|0}b[Hd>>1]=(b[Hd>>1]|0)+1<<16>>16;lb=lb+8|0;if(lb>>>0>=(c[Id+276>>2]|0)>>>0){od=k;pd=gd;qd=f;rd=zd;sd=Ad;td=r;break}else{yd=Id;L=zd;M=Ad}}}else{od=k;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 6:case 5:{M=(hd|0)==5&1;if((H|0)<0){D=129;E=444;break a}if((id|0)!=(n|0)){if(Fbe(e,q,g)|0){D=0;E=444;break a}L=c[A>>2]|0;if(((b[L+22>>1]|0)+H+(b[L+58>>1]|0)|0)>>>0>(c[L+4>>2]|0)>>>0?(V8d(L,H,0)|0)!=0:0){D=0;E=444;break a}if(k>>>0<(c[(c[j>>2]|0)+276>>2]|0)>>>0){L=k;yd=M;M=q;lb=g;while(1){Ad=(yd|0)==0;zd=c[L>>2]|0;Kd=(Ad?zd:0)+lb|0;Md=(Ad?0:zd)+M|0;zd=c[A>>2]|0;if(((b[zd+22>>1]|0)+1+(b[zd+58>>1]|0)|0)>>>0>(c[zd+4>>2]|0)>>>0?(V8d(zd,1,0)|0)!=0:0){D=0;E=444;break a}zd=c[x>>2]|0;if(!(a[z>>0]|0))Nd=zd+2|0;else{Ad=c[zd+4>>2]|0;Ld=zd+2|0;Jd=b[Ld>>1]|0;Bd=(c[zd+8>>2]|0)+Jd|0;c[Ad+(Jd<<3)>>2]=Md>>16;c[Ad+(Jd<<3)+4>>2]=Kd>>16;a[Bd>>0]=1;Nd=Ld}b[Nd>>1]=(b[Nd>>1]|0)+1<<16>>16;L=L+4|0;if(L>>>0>=(c[(c[j>>2]|0)+276>>2]|0)>>>0){od=k;pd=gd;qd=f;rd=Md;sd=Kd;td=r;break}else{yd=yd^1;M=Md;lb=Kd}}}else{od=k;pd=gd;qd=f;rd=q;sd=g;td=r}}else{od=F;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 7:{if((H|0)<6){D=129;E=444;break a}lb=H-((H|0)%6|0)|0;if(Fbe(e,q,g)|0){D=0;E=444;break a}M=(lb|0)/2|0;if(((lb+1|0)>>>0>=3?(yd=c[A>>2]|0,((b[yd+22>>1]|0)+M+(b[yd+58>>1]|0)|0)>>>0>(c[yd+4>>2]|0)>>>0):0)?(V8d(yd,M,0)|0)!=0:0){D=0;E=444;break a}M=fd+(0-(n+lb)<<2)|0;if(M>>>0<(c[(c[j>>2]|0)+276>>2]|0)>>>0){lb=M;M=q;yd=g;while(1){L=(c[lb>>2]|0)+M|0;Kd=(c[lb+4>>2]|0)+yd|0;Md=c[x>>2]|0;if(!(a[z>>0]|0)){Od=Md;Pd=1;Qd=Md+2|0}else{Ld=c[Md+4>>2]|0;Bd=Md+2|0;Jd=b[Bd>>1]|0;Ad=(c[Md+8>>2]|0)+Jd|0;c[Ld+(Jd<<3)>>2]=L>>16;c[Ld+(Jd<<3)+4>>2]=Kd>>16;a[Ad>>0]=2;Od=c[x>>2]|0;Pd=(a[z>>0]|0)==0;Qd=Bd}b[Qd>>1]=(b[Qd>>1]|0)+1<<16>>16;Bd=(c[lb+8>>2]|0)+L|0;L=(c[lb+12>>2]|0)+Kd|0;if(Pd){Rd=Od;Sd=1;Td=Od+2|0}else{Kd=c[Od+4>>2]|0;Ad=Od+2|0;Jd=b[Ad>>1]|0;Ld=(c[Od+8>>2]|0)+Jd|0;c[Kd+(Jd<<3)>>2]=Bd>>16;c[Kd+(Jd<<3)+4>>2]=L>>16;a[Ld>>0]=2;Rd=c[x>>2]|0;Sd=(a[z>>0]|0)==0;Td=Ad}b[Td>>1]=(b[Td>>1]|0)+1<<16>>16;Ad=(c[lb+16>>2]|0)+Bd|0;Bd=(c[lb+20>>2]|0)+L|0;if(Sd)Ud=Rd+2|0;else{L=c[Rd+4>>2]|0;Ld=Rd+2|0;Jd=b[Ld>>1]|0;Kd=(c[Rd+8>>2]|0)+Jd|0;c[L+(Jd<<3)>>2]=Ad>>16;c[L+(Jd<<3)+4>>2]=Bd>>16;a[Kd>>0]=1;Ud=Ld}b[Ud>>1]=(b[Ud>>1]|0)+1<<16>>16;lb=lb+24|0;if(lb>>>0>=(c[(c[j>>2]|0)+276>>2]|0)>>>0){od=k;pd=gd;qd=f;rd=Ad;sd=Bd;td=r;break}else{M=Ad;yd=Bd}}}else{od=k;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 13:{if((H|0)<4){D=129;E=444;break a}yd=(H|0)%4|0;M=((yd|0)>0&1)+(H-yd)|0;if(Fbe(e,q,g)|0){D=0;E=444;break a}yd=M+n|0;lb=fd+(0-yd<<2)|0;if(!(M&1)){Vd=lb;Wd=M;Xd=q}else{Vd=fd+(1-yd<<2)|0;Wd=M+-1|0;Xd=(c[lb>>2]|0)+q|0}lb=((Wd|0)/4|0)*3|0;if(((Wd+3|0)>>>0>=7?(M=c[A>>2]|0,((b[M+22>>1]|0)+lb+(b[M+58>>1]|0)|0)>>>0>(c[M+4>>2]|0)>>>0):0)?(V8d(M,lb,0)|0)!=0:0){D=0;E=444;break a}if(Vd>>>0<(c[(c[j>>2]|0)+276>>2]|0)>>>0){lb=Vd;M=Xd;yd=g;while(1){Bd=(c[lb>>2]|0)+yd|0;Ad=c[x>>2]|0;if(!(a[z>>0]|0)){Yd=Ad;Zd=1;_d=Ad+2|0}else{Ld=c[Ad+4>>2]|0;Kd=Ad+2|0;Jd=b[Kd>>1]|0;L=(c[Ad+8>>2]|0)+Jd|0;c[Ld+(Jd<<3)>>2]=M>>16;c[Ld+(Jd<<3)+4>>2]=Bd>>16;a[L>>0]=2;Yd=c[x>>2]|0;Zd=(a[z>>0]|0)==0;_d=Kd}b[_d>>1]=(b[_d>>1]|0)+1<<16>>16;Kd=(c[lb+4>>2]|0)+M|0;L=(c[lb+8>>2]|0)+Bd|0;if(!Zd){Bd=c[Yd+4>>2]|0;Jd=Yd+2|0;Ld=b[Jd>>1]|0;Ad=(c[Yd+8>>2]|0)+Ld|0;c[Bd+(Ld<<3)>>2]=Kd>>16;c[Bd+(Ld<<3)+4>>2]=L>>16;a[Ad>>0]=2;Ad=c[x>>2]|0;Ld=(a[z>>0]|0)==0;b[Jd>>1]=(b[Jd>>1]|0)+1<<16>>16;Jd=(c[lb+12>>2]|0)+L|0;if(Ld){$d=Ad;ae=Jd;E=205}else{Ld=c[Ad+4>>2]|0;Bd=Ad+2|0;Md=b[Bd>>1]|0;zd=(c[Ad+8>>2]|0)+Md|0;c[Ld+(Md<<3)>>2]=Kd>>16;c[Ld+(Md<<3)+4>>2]=Jd>>16;a[zd>>0]=1;be=Bd;ce=Jd}}else{Jd=Yd+2|0;b[Jd>>1]=(b[Jd>>1]|0)+1<<16>>16;$d=Yd;ae=(c[lb+12>>2]|0)+L|0;E=205}if((E|0)==205){E=0;be=$d+2|0;ce=ae}b[be>>1]=(b[be>>1]|0)+1<<16>>16;lb=lb+16|0;if(lb>>>0>=(c[(c[j>>2]|0)+276>>2]|0)>>>0){od=k;pd=gd;qd=f;rd=Kd;sd=ce;td=r;break}else{M=Kd;yd=ce}}}else{od=k;pd=gd;qd=f;rd=Xd;sd=g;td=r}break}case 8:{if((H|0)<4){D=129;E=444;break a}yd=(H|0)%4|0;M=((yd|0)>0&1)+(H-yd)|0;if(Fbe(e,q,g)|0){D=0;E=444;break a}yd=M+n|0;lb=fd+(0-yd<<2)|0;if(!(M&1)){de=lb;ee=M;fe=g}else{de=fd+(1-yd<<2)|0;ee=M+-1|0;fe=(c[lb>>2]|0)+g|0}lb=((ee|0)/4|0)*3|0;if(((ee+3|0)>>>0>=7?(M=c[A>>2]|0,((b[M+22>>1]|0)+lb+(b[M+58>>1]|0)|0)>>>0>(c[M+4>>2]|0)>>>0):0)?(V8d(M,lb,0)|0)!=0:0){D=0;E=444;break a}if(de>>>0<(c[(c[j>>2]|0)+276>>2]|0)>>>0){lb=de;M=q;yd=fe;while(1){Kd=(c[lb>>2]|0)+M|0;L=c[x>>2]|0;if(!(a[z>>0]|0)){ge=L;he=1;ie=L+2|0}else{Jd=c[L+4>>2]|0;Bd=L+2|0;zd=b[Bd>>1]|0;Md=(c[L+8>>2]|0)+zd|0;c[Jd+(zd<<3)>>2]=Kd>>16;c[Jd+(zd<<3)+4>>2]=yd>>16;a[Md>>0]=2;ge=c[x>>2]|0;he=(a[z>>0]|0)==0;ie=Bd}b[ie>>1]=(b[ie>>1]|0)+1<<16>>16;Bd=(c[lb+4>>2]|0)+Kd|0;Kd=(c[lb+8>>2]|0)+yd|0;if(!he){Md=c[ge+4>>2]|0;zd=ge+2|0;Jd=b[zd>>1]|0;L=(c[ge+8>>2]|0)+Jd|0;c[Md+(Jd<<3)>>2]=Bd>>16;c[Md+(Jd<<3)+4>>2]=Kd>>16;a[L>>0]=2;L=c[x>>2]|0;Jd=(a[z>>0]|0)==0;b[zd>>1]=(b[zd>>1]|0)+1<<16>>16;zd=(c[lb+12>>2]|0)+Bd|0;if(Jd){je=L;ke=zd;E=222}else{Jd=c[L+4>>2]|0;Md=L+2|0;Ld=b[Md>>1]|0;Ad=(c[L+8>>2]|0)+Ld|0;c[Jd+(Ld<<3)>>2]=zd>>16;c[Jd+(Ld<<3)+4>>2]=Kd>>16;a[Ad>>0]=1;le=Md;me=zd}}else{zd=ge+2|0;b[zd>>1]=(b[zd>>1]|0)+1<<16>>16;je=ge;ke=(c[lb+12>>2]|0)+Bd|0;E=222}if((E|0)==222){E=0;le=je+2|0;me=ke}b[le>>1]=(b[le>>1]|0)+1<<16>>16;lb=lb+16|0;if(lb>>>0>=(c[(c[j>>2]|0)+276>>2]|0)>>>0){od=k;pd=gd;qd=f;rd=me;sd=Kd;td=r;break}else{M=me;yd=Kd}}}else{od=k;pd=gd;qd=f;rd=q;sd=fe;td=r}break}case 9:case 12:{if(Fbe(e,q,g)|0){D=0;E=444;break a}if((H|0)<4){D=129;E=444;break a}yd=(H|0)%4|0;M=((yd|0)>0&1)+(H-yd)|0;yd=((M|0)/4|0)*3|0;if((M+3|0)>>>0>=7){lb=c[A>>2]|0;if(((b[lb+22>>1]|0)+yd+(b[lb+58>>1]|0)|0)>>>0>(c[lb+4>>2]|0)>>>0?(V8d(lb,yd,0)|0)!=0:0){D=129;E=444;break a}if((M|0)>3){yd=fd+(0-(n+M)<<2)|0;lb=M;M=(hd|0)==9&1;Kd=q;Bd=g;while(1){lb=lb+-4|0;zd=c[yd>>2]|0;if(!M){Md=zd+Bd|0;Ad=c[x>>2]|0;if(!(a[z>>0]|0)){ne=Ad;oe=1;pe=Ad+2|0}else{Ld=c[Ad+4>>2]|0;Jd=Ad+2|0;L=b[Jd>>1]|0;qe=(c[Ad+8>>2]|0)+L|0;c[Ld+(L<<3)>>2]=Kd>>16;c[Ld+(L<<3)+4>>2]=Md>>16;a[qe>>0]=2;ne=c[x>>2]|0;oe=(a[z>>0]|0)==0;pe=Jd}b[pe>>1]=(b[pe>>1]|0)+1<<16>>16;Jd=(c[yd+4>>2]|0)+Kd|0;qe=(c[yd+8>>2]|0)+Md|0;if(oe)re=ne+2|0;else{Md=c[ne+4>>2]|0;L=ne+2|0;Ld=b[L>>1]|0;Ad=(c[ne+8>>2]|0)+Ld|0;c[Md+(Ld<<3)>>2]=Jd>>16;c[Md+(Ld<<3)+4>>2]=qe>>16;a[Ad>>0]=2;re=L}b[re>>1]=(b[re>>1]|0)+1<<16>>16;L=(c[yd+12>>2]|0)+Jd|0;if((lb|0)==1)se=(c[yd+16>>2]|0)+qe|0;else se=qe;qe=c[x>>2]|0;if(!(a[z>>0]|0))te=qe+2|0;else{Jd=c[qe+4>>2]|0;Ad=qe+2|0;Ld=b[Ad>>1]|0;Md=(c[qe+8>>2]|0)+Ld|0;c[Jd+(Ld<<3)>>2]=L>>16;c[Jd+(Ld<<3)+4>>2]=se>>16;a[Md>>0]=1;te=Ad}b[te>>1]=(b[te>>1]|0)+1<<16>>16;ue=L;ve=se}else{L=zd+Kd|0;zd=c[x>>2]|0;if(!(a[z>>0]|0)){we=zd;xe=1;ye=zd+2|0}else{Ad=c[zd+4>>2]|0;Md=zd+2|0;Ld=b[Md>>1]|0;Jd=(c[zd+8>>2]|0)+Ld|0;c[Ad+(Ld<<3)>>2]=L>>16;c[Ad+(Ld<<3)+4>>2]=Bd>>16;a[Jd>>0]=2;we=c[x>>2]|0;xe=(a[z>>0]|0)==0;ye=Md}b[ye>>1]=(b[ye>>1]|0)+1<<16>>16;Md=(c[yd+4>>2]|0)+L|0;L=(c[yd+8>>2]|0)+Bd|0;if(xe)ze=we+2|0;else{Jd=c[we+4>>2]|0;Ld=we+2|0;Ad=b[Ld>>1]|0;zd=(c[we+8>>2]|0)+Ad|0;c[Jd+(Ad<<3)>>2]=Md>>16;c[Jd+(Ad<<3)+4>>2]=L>>16;a[zd>>0]=2;ze=Ld}b[ze>>1]=(b[ze>>1]|0)+1<<16>>16;Ld=(c[yd+12>>2]|0)+L|0;if((lb|0)==1)Ae=(c[yd+16>>2]|0)+Md|0;else Ae=Md;Md=c[x>>2]|0;if(!(a[z>>0]|0))Be=Md+2|0;else{L=c[Md+4>>2]|0;zd=Md+2|0;Ad=b[zd>>1]|0;Jd=(c[Md+8>>2]|0)+Ad|0;c[L+(Ad<<3)>>2]=Ae>>16;c[L+(Ad<<3)+4>>2]=Ld>>16;a[Jd>>0]=1;Be=zd}b[Be>>1]=(b[Be>>1]|0)+1<<16>>16;ue=Ae;ve=Ld}if((lb|0)<=3){od=k;pd=gd;qd=f;rd=ue;sd=ve;td=r;break}else{yd=yd+16|0;M=M^1;Kd=ue;Bd=ve}}}else{od=k;pd=gd;qd=f;rd=q;sd=g;td=r}}else{od=k;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 11:{if((H|0)<8){D=129;E=444;break a}Bd=H&-2;Kd=Bd+-6|0;M=(Kd|0)/2|0;if(Fbe(e,q,g)|0){D=0;E=444;break a}yd=M+3|0;if(((yd|0)!=0?(lb=c[A>>2]|0,((b[lb+22>>1]|0)+yd+(b[lb+58>>1]|0)|0)>>>0>(c[lb+4>>2]|0)>>>0):0)?(V8d(lb,yd,0)|0)!=0:0){D=0;E=444;break a}yd=n+Bd|0;Bd=0-yd|0;lb=fd+(Bd<<2)|0;Ld=(c[lb>>2]|0)+q|0;zd=(c[fd+(1-yd<<2)>>2]|0)+g|0;yd=c[x>>2]|0;Jd=a[z>>0]|0;Ad=Jd<<24>>24==0;if((Kd|0)>1){Kd=0-M|0;L=jd&15;Md=(M+((Kd|0)>-1?Kd:2147483647)<<1)-((id-L&-2)+L)|0;L=yd;Kd=Jd;Jd=Ld;qe=zd;Ce=Ad;De=lb;lb=M;while(1){if(Ce){Ee=L;Fe=Kd;Ge=L+2|0}else{M=c[L+4>>2]|0;He=L+2|0;Ie=b[He>>1]|0;Je=(c[L+8>>2]|0)+Ie|0;c[M+(Ie<<3)>>2]=Jd>>16;c[M+(Ie<<3)+4>>2]=qe>>16;a[Je>>0]=1;Ee=c[x>>2]|0;Fe=a[z>>0]|0;Ge=He}b[Ge>>1]=(b[Ge>>1]|0)+1<<16>>16;He=De;De=De+8|0;lb=lb+-1|0;Jd=(c[De>>2]|0)+Jd|0;qe=(c[He+12>>2]|0)+qe|0;Ce=Fe<<24>>24==0;if((lb|0)<=0)break;else{L=Ee;Kd=Fe}}Kd=Md+2|0;if(Ce){Ke=Ee;Le=Jd;Me=qe;Ne=Kd;E=271}else{Oe=Ee;Pe=Jd;Qe=qe;Re=Kd;E=272}}else if(Ad){Ke=yd;Le=Ld;Me=zd;Ne=Bd;E=271}else{Oe=yd;Pe=Ld;Qe=zd;Re=Bd;E=272}if((E|0)==271){E=0;Se=Ke;Te=1;Ue=Le;Ve=Me;We=Ke+2|0;Xe=Ne}else if((E|0)==272){E=0;Kd=c[Oe+4>>2]|0;L=Oe+2|0;lb=b[L>>1]|0;De=(c[Oe+8>>2]|0)+lb|0;c[Kd+(lb<<3)>>2]=Pe>>16;c[Kd+(lb<<3)+4>>2]=Qe>>16;a[De>>0]=2;Se=c[x>>2]|0;Te=(a[z>>0]|0)==0;Ue=Pe;Ve=Qe;We=L;Xe=Re}b[We>>1]=(b[We>>1]|0)+1<<16>>16;L=(c[fd+(Xe+2<<2)>>2]|0)+Ue|0;De=(c[fd+(Xe+3<<2)>>2]|0)+Ve|0;if(Te){Ye=Se;Ze=1;_e=Se+2|0}else{lb=c[Se+4>>2]|0;Kd=Se+2|0;He=b[Kd>>1]|0;Je=(c[Se+8>>2]|0)+He|0;c[lb+(He<<3)>>2]=L>>16;c[lb+(He<<3)+4>>2]=De>>16;a[Je>>0]=2;Ye=c[x>>2]|0;Ze=(a[z>>0]|0)==0;_e=Kd}b[_e>>1]=(b[_e>>1]|0)+1<<16>>16;Kd=(c[fd+(Xe+4<<2)>>2]|0)+L|0;L=(c[fd+(Xe+5<<2)>>2]|0)+De|0;if(Ze)$e=Ye+2|0;else{De=c[Ye+4>>2]|0;Je=Ye+2|0;He=b[Je>>1]|0;lb=(c[Ye+8>>2]|0)+He|0;c[De+(He<<3)>>2]=Kd>>16;c[De+(He<<3)+4>>2]=L>>16;a[lb>>0]=1;$e=Je}b[$e>>1]=(b[$e>>1]|0)+1<<16>>16;od=k;pd=gd;qd=f;rd=Kd;sd=L;td=r;break}case 10:{if((H|0)<8){D=129;E=444;break a}L=H+-2|0;Kd=(L|0)%6|0;Je=(L|0)/6|0;if(Fbe(e,q,g)|0){D=0;E=444;break a}lb=(Je*3|0)+2|0;if(((lb|0)!=0?(He=c[A>>2]|0,((b[He+22>>1]|0)+lb+(b[He+58>>1]|0)|0)>>>0>(c[He+4>>2]|0)>>>0):0)?(V8d(He,lb,0)|0)!=0:0){D=0;E=444;break a}lb=-2-n+(2-H)+Kd|0;Kd=fd+(lb<<2)|0;He=(c[Kd>>2]|0)+q|0;De=(c[fd+(lb+1<<2)>>2]|0)+g|0;lb=c[x>>2]|0;Ie=a[z>>0]|0;M=Ie<<24>>24==0;if((L|0)>5){L=Ie;Ie=lb;af=He;bf=De;cf=M;df=Kd;Kd=Je;while(1){if(cf){ef=Ie;ff=L;gf=Ie+2|0}else{Je=c[Ie+4>>2]|0;hf=Ie+2|0;jf=b[hf>>1]|0;kf=(c[Ie+8>>2]|0)+jf|0;c[Je+(jf<<3)>>2]=af>>16;c[Je+(jf<<3)+4>>2]=bf>>16;a[kf>>0]=2;ef=c[x>>2]|0;ff=a[z>>0]|0;gf=hf}b[gf>>1]=(b[gf>>1]|0)+1<<16>>16;hf=(c[df+8>>2]|0)+af|0;kf=(c[df+12>>2]|0)+bf|0;if(!(ff<<24>>24)){lf=ef;mf=1;nf=ef+2|0}else{jf=c[ef+4>>2]|0;Je=ef+2|0;of=b[Je>>1]|0;pf=(c[ef+8>>2]|0)+of|0;c[jf+(of<<3)>>2]=hf>>16;c[jf+(of<<3)+4>>2]=kf>>16;a[pf>>0]=2;lf=c[x>>2]|0;mf=(a[z>>0]|0)==0;nf=Je}b[nf>>1]=(b[nf>>1]|0)+1<<16>>16;Je=(c[df+16>>2]|0)+hf|0;hf=(c[df+20>>2]|0)+kf|0;if(mf){qf=lf;rf=0;sf=lf+2|0}else{kf=c[lf+4>>2]|0;pf=lf+2|0;of=b[pf>>1]|0;jf=(c[lf+8>>2]|0)+of|0;c[kf+(of<<3)>>2]=Je>>16;c[kf+(of<<3)+4>>2]=hf>>16;a[jf>>0]=1;qf=c[x>>2]|0;rf=a[z>>0]|0;sf=pf}b[sf>>1]=(b[sf>>1]|0)+1<<16>>16;pf=df;df=df+24|0;Kd=Kd+-1|0;jf=(c[df>>2]|0)+Je|0;Je=(c[pf+28>>2]|0)+hf|0;hf=rf<<24>>24==0;if((Kd|0)<=0){tf=qf;uf=jf;vf=Je;wf=hf;break}else{L=rf;Ie=qf;af=jf;bf=Je;cf=hf}}}else{tf=lb;uf=He;vf=De;wf=M}if(wf)xf=tf+2|0;else{cf=c[tf+4>>2]|0;bf=tf+2|0;af=b[bf>>1]|0;Ie=(c[tf+8>>2]|0)+af|0;c[cf+(af<<3)>>2]=uf>>16;c[cf+(af<<3)+4>>2]=vf>>16;a[Ie>>0]=1;xf=bf}b[xf>>1]=(b[xf>>1]|0)+1<<16>>16;od=k;pd=gd;qd=f;rd=uf;sd=vf;td=r;break}case 16:{if(Fbe(e,q,g)|0){D=0;E=444;break a}bf=c[A>>2]|0;if(((b[bf+22>>1]|0)+6+(b[bf+58>>1]|0)|0)>>>0>(c[bf+4>>2]|0)>>>0?(V8d(bf,6,0)|0)!=0:0){D=0;E=444;break a}bf=(c[F>>2]|0)+q|0;Ie=(c[fd+(1-n<<2)>>2]|0)+g|0;af=c[x>>2]|0;if(!(a[z>>0]|0)){yf=af;zf=1;Af=af+2|0}else{cf=c[af+4>>2]|0;L=af+2|0;Kd=b[L>>1]|0;df=(c[af+8>>2]|0)+Kd|0;c[cf+(Kd<<3)>>2]=bf>>16;c[cf+(Kd<<3)+4>>2]=Ie>>16;a[df>>0]=2;yf=c[x>>2]|0;zf=(a[z>>0]|0)==0;Af=L}b[Af>>1]=(b[Af>>1]|0)+1<<16>>16;L=(c[fd+(2-n<<2)>>2]|0)+bf|0;bf=(c[fd+(3-n<<2)>>2]|0)+Ie|0;if(zf){Bf=yf;Cf=1;Df=yf+2|0}else{Ie=c[yf+4>>2]|0;df=yf+2|0;Kd=b[df>>1]|0;cf=(c[yf+8>>2]|0)+Kd|0;c[Ie+(Kd<<3)>>2]=L>>16;c[Ie+(Kd<<3)+4>>2]=bf>>16;a[cf>>0]=2;Bf=c[x>>2]|0;Cf=(a[z>>0]|0)==0;Df=df}b[Df>>1]=(b[Df>>1]|0)+1<<16>>16;df=(c[fd+(4-n<<2)>>2]|0)+L|0;if(Cf){Ef=Bf;Ff=1;Gf=Bf+2|0}else{L=c[Bf+4>>2]|0;cf=Bf+2|0;Kd=b[cf>>1]|0;Ie=(c[Bf+8>>2]|0)+Kd|0;c[L+(Kd<<3)>>2]=df>>16;c[L+(Kd<<3)+4>>2]=bf>>16;a[Ie>>0]=1;Ef=c[x>>2]|0;Ff=(a[z>>0]|0)==0;Gf=cf}b[Gf>>1]=(b[Gf>>1]|0)+1<<16>>16;cf=(c[fd+(5-n<<2)>>2]|0)+df|0;if(Ff){Hf=Ef;If=1;Jf=Ef+2|0}else{df=c[Ef+4>>2]|0;Ie=Ef+2|0;Kd=b[Ie>>1]|0;L=(c[Ef+8>>2]|0)+Kd|0;c[df+(Kd<<3)>>2]=cf>>16;c[df+(Kd<<3)+4>>2]=bf>>16;a[L>>0]=2;Hf=c[x>>2]|0;If=(a[z>>0]|0)==0;Jf=Ie}b[Jf>>1]=(b[Jf>>1]|0)+1<<16>>16;Ie=(c[fd+(6-n<<2)>>2]|0)+cf|0;if(If){Kf=Hf;Lf=1;Mf=Hf+2|0}else{cf=(c[fd+(7-n<<2)>>2]|0)+bf|0;bf=c[Hf+4>>2]|0;L=Hf+2|0;Kd=b[L>>1]|0;df=(c[Hf+8>>2]|0)+Kd|0;c[bf+(Kd<<3)>>2]=Ie>>16;c[bf+(Kd<<3)+4>>2]=cf>>16;a[df>>0]=2;Kf=c[x>>2]|0;Lf=(a[z>>0]|0)==0;Mf=L}b[Mf>>1]=(b[Mf>>1]|0)+1<<16>>16;L=(c[fd+(8-n<<2)>>2]|0)+Ie|0;if(Lf)Nf=Kf+2|0;else{Ie=c[Kf+4>>2]|0;df=Kf+2|0;cf=b[df>>1]|0;Kd=(c[Kf+8>>2]|0)+cf|0;c[Ie+(cf<<3)>>2]=L>>16;c[Ie+(cf<<3)+4>>2]=g>>16;a[Kd>>0]=1;Nf=df}b[Nf>>1]=(b[Nf>>1]|0)+1<<16>>16;od=k;pd=gd;qd=f;rd=L;sd=g;td=r;break}case 15:{if(Fbe(e,q,g)|0){D=0;E=444;break a}L=c[A>>2]|0;if(((b[L+22>>1]|0)+6+(b[L+58>>1]|0)|0)>>>0>(c[L+4>>2]|0)>>>0?(V8d(L,6,0)|0)!=0:0){D=0;E=444;break a}L=(c[F>>2]|0)+q|0;df=c[x>>2]|0;if(!(a[z>>0]|0)){Of=df;Pf=1;Qf=df+2|0}else{Kd=c[df+4>>2]|0;cf=df+2|0;Ie=b[cf>>1]|0;bf=(c[df+8>>2]|0)+Ie|0;c[Kd+(Ie<<3)>>2]=L>>16;c[Kd+(Ie<<3)+4>>2]=g>>16;a[bf>>0]=2;Of=c[x>>2]|0;Pf=(a[z>>0]|0)==0;Qf=cf}b[Qf>>1]=(b[Qf>>1]|0)+1<<16>>16;cf=(c[fd+(1-n<<2)>>2]|0)+L|0;L=(c[fd+(2-n<<2)>>2]|0)+g|0;if(Pf){Rf=Of;Sf=1;Tf=Of+2|0}else{bf=c[Of+4>>2]|0;Ie=Of+2|0;Kd=b[Ie>>1]|0;df=(c[Of+8>>2]|0)+Kd|0;c[bf+(Kd<<3)>>2]=cf>>16;c[bf+(Kd<<3)+4>>2]=L>>16;a[df>>0]=2;Rf=c[x>>2]|0;Sf=(a[z>>0]|0)==0;Tf=Ie}b[Tf>>1]=(b[Tf>>1]|0)+1<<16>>16;Ie=(c[fd+(3-n<<2)>>2]|0)+cf|0;if(Sf){Uf=Rf;Vf=1;Wf=Rf+2|0}else{cf=c[Rf+4>>2]|0;df=Rf+2|0;Kd=b[df>>1]|0;bf=(c[Rf+8>>2]|0)+Kd|0;c[cf+(Kd<<3)>>2]=Ie>>16;c[cf+(Kd<<3)+4>>2]=L>>16;a[bf>>0]=1;Uf=c[x>>2]|0;Vf=(a[z>>0]|0)==0;Wf=df}b[Wf>>1]=(b[Wf>>1]|0)+1<<16>>16;df=(c[fd+(4-n<<2)>>2]|0)+Ie|0;if(Vf){Xf=Uf;Yf=1;Zf=Uf+2|0}else{Ie=c[Uf+4>>2]|0;bf=Uf+2|0;Kd=b[bf>>1]|0;cf=(c[Uf+8>>2]|0)+Kd|0;c[Ie+(Kd<<3)>>2]=df>>16;c[Ie+(Kd<<3)+4>>2]=L>>16;a[cf>>0]=2;Xf=c[x>>2]|0;Yf=(a[z>>0]|0)==0;Zf=bf}b[Zf>>1]=(b[Zf>>1]|0)+1<<16>>16;bf=(c[fd+(5-n<<2)>>2]|0)+df|0;if(Yf){_f=Xf;$f=1;ag=Xf+2|0}else{df=c[Xf+4>>2]|0;cf=Xf+2|0;L=b[cf>>1]|0;Kd=(c[Xf+8>>2]|0)+L|0;c[df+(L<<3)>>2]=bf>>16;c[df+(L<<3)+4>>2]=g>>16;a[Kd>>0]=2;_f=c[x>>2]|0;$f=(a[z>>0]|0)==0;ag=cf}b[ag>>1]=(b[ag>>1]|0)+1<<16>>16;cf=(c[fd+(6-n<<2)>>2]|0)+bf|0;if($f)bg=_f+2|0;else{bf=c[_f+4>>2]|0;Kd=_f+2|0;L=b[Kd>>1]|0;df=(c[_f+8>>2]|0)+L|0;c[bf+(L<<3)>>2]=cf>>16;c[bf+(L<<3)+4>>2]=g>>16;a[df>>0]=1;bg=Kd}b[bg>>1]=(b[bg>>1]|0)+1<<16>>16;od=k;pd=gd;qd=f;rd=cf;sd=g;td=r;break}case 17:{if(Fbe(e,q,g)|0){D=0;E=444;break a}cf=c[A>>2]|0;if(((b[cf+22>>1]|0)+6+(b[cf+58>>1]|0)|0)>>>0>(c[cf+4>>2]|0)>>>0?(V8d(cf,6,0)|0)!=0:0){D=0;E=444;break a}cf=c[F>>2]|0;Kd=c[fd+(1-n<<2)>>2]|0;df=2-n|0;L=fd+(df<<2)|0;bf=c[L>>2]|0;Ie=fd+(df+1<<2)|0;af=c[Ie>>2]|0;Bd=fd+(df+2<<2)|0;zd=fd+(df+3<<2)|0;Ld=fd+(df+4<<2)|0;yd=fd+(df+5<<2)|0;Ad=fd+(df+6<<2)|0;qe=(c[Ad>>2]|0)+((c[Ld>>2]|0)+((c[Bd>>2]|0)+(bf+cf)))|0;Jd=fd+(df+7<<2)|0;Ce=(c[Jd>>2]|0)+((c[yd>>2]|0)+((c[zd>>2]|0)+(af+Kd)))|0;Md=0-qe|0;hf=(Ce|0)<0?0-Ce|0:Ce;Ce=cf+q|0;cf=Kd+g|0;Kd=c[x>>2]|0;if(a[z>>0]|0){Je=c[Kd+4>>2]|0;jf=Kd+2|0;pf=b[jf>>1]|0;of=(c[Kd+8>>2]|0)+pf|0;c[Je+(pf<<3)>>2]=Ce>>16;c[Je+(pf<<3)+4>>2]=cf>>16;a[of>>0]=2;of=c[L>>2]|0;L=c[Ie>>2]|0;Ie=c[x>>2]|0;pf=(a[z>>0]|0)==0;b[jf>>1]=(b[jf>>1]|0)+1<<16>>16;jf=of+Ce|0;of=L+cf|0;if(pf){cg=Ie;dg=of;eg=jf;E=446}else{pf=c[Ie+4>>2]|0;L=Ie+2|0;Je=b[L>>1]|0;kf=(c[Ie+8>>2]|0)+Je|0;c[pf+(Je<<3)>>2]=jf>>16;c[pf+(Je<<3)+4>>2]=of>>16;a[kf>>0]=2;fg=c[x>>2]|0;gg=(a[z>>0]|0)==0;hg=L;ig=jf;jg=of}}else{of=Kd+2|0;b[of>>1]=(b[of>>1]|0)+1<<16>>16;cg=Kd;dg=af+cf|0;eg=bf+Ce|0;E=446}if((E|0)==446){E=0;fg=cg;gg=1;hg=cg+2|0;ig=eg;jg=dg}b[hg>>1]=(b[hg>>1]|0)+1<<16>>16;Ce=(c[Bd>>2]|0)+ig|0;Bd=(c[zd>>2]|0)+jg|0;if(gg){kg=fg;lg=1;mg=fg+2|0}else{zd=c[fg+4>>2]|0;bf=fg+2|0;cf=b[bf>>1]|0;af=(c[fg+8>>2]|0)+cf|0;c[zd+(cf<<3)>>2]=Ce>>16;c[zd+(cf<<3)+4>>2]=Bd>>16;a[af>>0]=1;kg=c[x>>2]|0;lg=(a[z>>0]|0)==0;mg=bf}b[mg>>1]=(b[mg>>1]|0)+1<<16>>16;bf=(c[Ld>>2]|0)+Ce|0;Ce=(c[yd>>2]|0)+Bd|0;if(lg){ng=kg;og=1;pg=kg+2|0}else{Bd=c[kg+4>>2]|0;yd=kg+2|0;Ld=b[yd>>1]|0;af=(c[kg+8>>2]|0)+Ld|0;c[Bd+(Ld<<3)>>2]=bf>>16;c[Bd+(Ld<<3)+4>>2]=Ce>>16;a[af>>0]=2;ng=c[x>>2]|0;og=(a[z>>0]|0)==0;pg=yd}b[pg>>1]=(b[pg>>1]|0)+1<<16>>16;yd=(c[Ad>>2]|0)+bf|0;bf=(c[Jd>>2]|0)+Ce|0;if(og){qg=ng;rg=1;sg=ng+2|0}else{Ce=c[ng+4>>2]|0;Jd=ng+2|0;Ad=b[Jd>>1]|0;af=(c[ng+8>>2]|0)+Ad|0;c[Ce+(Ad<<3)>>2]=yd>>16;c[Ce+(Ad<<3)+4>>2]=bf>>16;a[af>>0]=2;qg=c[x>>2]|0;rg=(a[z>>0]|0)==0;sg=Jd}b[sg>>1]=(b[sg>>1]|0)+1<<16>>16;Jd=c[fd+(df+8<<2)>>2]|0;df=(((qe|0)<0?Md:qe)|0)>(hf|0);hf=df?g:Jd+bf|0;bf=df?Jd+yd|0:q;if(rg)tg=qg+2|0;else{yd=c[qg+4>>2]|0;Jd=qg+2|0;df=b[Jd>>1]|0;qe=(c[qg+8>>2]|0)+df|0;c[yd+(df<<3)>>2]=bf>>16;c[yd+(df<<3)+4>>2]=hf>>16;a[qe>>0]=1;tg=Jd}b[tg>>1]=(b[tg>>1]|0)+1<<16>>16;od=k;pd=gd;qd=f;rd=bf;sd=hf;td=r;break}case 14:{if(Fbe(e,q,g)|0){D=0;E=444;break a}hf=c[A>>2]|0;if(((b[hf+22>>1]|0)+6+(b[hf+58>>1]|0)|0)>>>0>(c[hf+4>>2]|0)>>>0?(V8d(hf,6,0)|0)!=0:0){D=0;E=444;break a}else{ug=F;vg=6;wg=q;xg=g}while(1){hf=(c[ug>>2]|0)+wg|0;bf=(c[ug+4>>2]|0)+xg|0;if((vg|0)==4)yg=1;else yg=(vg|0)==1&1;Jd=c[x>>2]|0;if(!(a[z>>0]|0))zg=Jd+2|0;else{qe=c[Jd+4>>2]|0;df=Jd+2|0;yd=b[df>>1]|0;Md=(c[Jd+8>>2]|0)+yd|0;c[qe+(yd<<3)>>2]=hf>>16;c[qe+(yd<<3)+4>>2]=bf>>16;a[Md>>0]=yg<<24>>24!=0?1:2;zg=df}b[zg>>1]=(b[zg>>1]|0)+1<<16>>16;vg=vg+-1|0;if(!vg){od=k;pd=gd;qd=f;rd=hf;sd=bf;td=r;break}else{ug=ug+8|0;wg=hf;xg=bf}}break}case 18:{Ag=fd;Bg=ed;Cg=n;Dg=H;Eg=jd;E=363;break a;break}case 56:{Fg=fd;Gg=ed;Hg=n;Ig=F;E=362;break a;break}case 26:{M=c[F>>2]|0;if((M|0)<0)c[F>>2]=0-M;od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 27:{M=fd+(1-n<<2)|0;c[F>>2]=(c[F>>2]|0)+(c[M>>2]|0);od=M;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 28:{M=fd+(1-n<<2)|0;c[F>>2]=(c[F>>2]|0)-(c[M>>2]|0);od=M;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 29:{M=fd+(1-n<<2)|0;c[F>>2]=L8d(c[F>>2]|0,c[M>>2]|0)|0;od=M;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 30:{c[F>>2]=0-(c[F>>2]|0);od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 31:{M=c[l>>2]|0;c[F>>2]=((M|0)>32767&1)+M;M=c[l>>2]|0;De=K8d(M,65536-M|0)|0;c[l>>2]=(De|0)==0?De+10355|0:De;od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 32:{De=fd+(1-n<<2)|0;c[F>>2]=K8d(c[F>>2]|0,c[De>>2]|0)|0;od=De;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 33:{De=c[F>>2]|0;f:do if((De|0)>0){M=De;He=De;while(1){lb=He+1+(L8d(M,He)|0)>>1;if((lb|0)==(He|0)){Jg=He;break f}M=c[F>>2]|0;He=lb}}else Jg=0;while(0);c[F>>2]=Jg;od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 36:{De=c[F>>2]|0;He=fd+(1-n<<2)|0;c[F>>2]=c[He>>2];c[He>>2]=De;od=fd+(2-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 37:{De=c[F>>2]>>16;if((De|0)<0)Kg=-1;else{He=H+-2|0;Kg=~((De|0)>(He|0)?He:De)}c[F>>2]=c[fd+(Kg-n<<2)>>2];od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 38:{De=c[F>>2]>>16;He=c[fd+(1-n<<2)>>2]>>16;M=(De|0)<1?1:De;De=M+n|0;lb=fd+(0-De<<2)|0;if(lb>>>0<k>>>0){D=129;E=444;break a}if((He|0)>-1){if((He|0)<=0){od=F;pd=gd;qd=f;rd=q;sd=g;td=r;break e}bf=fd+(M+-1-De<<2)|0;hf=M+-2|0;df=1-De|0;if((hf|0)>-1)Lg=He;else{Md=He;while(1){c[lb>>2]=c[bf>>2];Md=Md+-1|0;if((Md|0)<=0){od=F;pd=gd;qd=f;rd=q;sd=g;td=r;break e}}}do{Md=c[bf>>2]|0;yd=hf;while(1){c[fd+(df+yd<<2)>>2]=c[fd+(yd-De<<2)>>2];if((yd|0)>0)yd=yd+-1|0;else break}c[lb>>2]=Md;Lg=Lg+-1|0}while((Lg|0)>0);od=F;pd=gd;qd=f;rd=q;sd=g;td=r}else{df=M+-1|0;if((df|0)<=0){hf=He;while(1){c[fd+(df-De<<2)>>2]=c[lb>>2];hf=hf+1|0;if(!hf){od=F;pd=gd;qd=f;rd=q;sd=g;td=r;break e}}}hf=fd+(df-De<<2)|0;M=He;do{bf=c[lb>>2]|0;yd=0;do{qe=yd;yd=yd+1|0;c[fd+(qe-De<<2)>>2]=c[fd+(yd-De<<2)>>2]}while((yd|0)<(df|0));c[hf>>2]=bf;M=M+1|0}while((M|0)!=0);od=F;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 39:{c[fd+(1-n<<2)>>2]=c[F>>2];od=fd+(2-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 40:{M=c[fd+(1-n<<2)>>2]>>16;if(M>>>0<32){c[ed+(M<<2)+760>>2]=c[F>>2];od=F;pd=gd;qd=f;rd=q;sd=g;td=r}else{od=F;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 41:{M=c[F>>2]>>16;if(M>>>0<32)Mg=c[ed+(M<<2)+760>>2]|0;else Mg=0;c[F>>2]=Mg;od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 53:{od=k;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 52:{c[ed+744>>2]=(c[fd+(1-n<<2)>>2]>>16)+(c[ed+748>>2]|0);c[ed+32>>2]=c[F>>2];c[ed+36>>2]=0;od=k;pd=gd;qd=f;rd=(c[F>>2]|0)+(c[ed+24>>2]|0)|0;sd=c[ed+28>>2]|0;td=r;break}case 57:{c[ed+744>>2]=(c[fd+(2-n<<2)>>2]>>16)+(c[ed+748>>2]|0);c[ed+32>>2]=c[F>>2];M=fd+(1-n<<2)|0;c[ed+36>>2]=c[M>>2];od=k;pd=gd;qd=f;rd=(c[F>>2]|0)+(c[ed+24>>2]|0)|0;sd=(c[M>>2]|0)+(c[ed+28>>2]|0)|0;td=r;break}case 58:{od=k;pd=gd;qd=f;rd=(c[F>>2]|0)+(c[ed+24>>2]|0)|0;sd=(c[fd+(1-n<<2)>>2]|0)+(c[ed+28>>2]|0)|0;td=r;break}case 55:{od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 54:{M=-2-n|0;hf=fd+(M-(c[fd+(M<<2)>>2]>>16)<<2)|0;if(hf>>>0<k>>>0){D=129;E=444;break a}else{od=hf;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 44:{hf=fd+(1-n<<2)|0;if(!(c[F>>2]|0))Ng=0;else Ng=(c[hf>>2]|0)!=0?65536:0;c[F>>2]=Ng;od=hf;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 45:{hf=fd+(1-n<<2)|0;if(!(c[F>>2]|0))Og=(c[hf>>2]|0)!=0?65536:0;else Og=65536;c[F>>2]=Og;od=hf;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 47:{c[F>>2]=(c[F>>2]|0)==0?65536:0;od=fd+(1-n<<2)|0;pd=gd;qd=f;rd=q;sd=g;td=r;break}case 48:{hf=fd+(1-n<<2)|0;if((c[fd+(2-n<<2)>>2]|0)>(c[fd+(3-n<<2)>>2]|0)){c[F>>2]=c[hf>>2];od=hf;pd=gd;qd=f;rd=q;sd=g;td=r}else{od=hf;pd=gd;qd=f;rd=q;sd=g;td=r}break}case 49:{hf=(c[ed+896>>2]|0)+(c[F>>2]>>16)|0;if(hf>>>0>=(c[ed+888>>2]|0)>>>0){D=3;E=444;break a}if((r-(ed+280)|0)>372){D=3;E=444;break a}c[r+8>>2]=gd;M=r+12|0;df=c[(c[(c[j>>2]|0)+904>>2]|0)+(hf<<2)>>2]|0;c[M>>2]=df;De=c[(c[(c[j>>2]|0)+904>>2]|0)+(hf+1<<2)>>2]|0;c[r+16>>2]=De;c[r+20>>2]=df;if((df|0)==0|(De|0)==(df|0)){D=3;E=444;break a}c[(c[j>>2]|0)+676>>2]=M;od=F;pd=df;qd=De;rd=q;sd=g;td=M;break}case 50:{M=(c[ed+900>>2]|0)+(c[F>>2]>>16)|0;if(M>>>0>=(c[ed+892>>2]|0)>>>0){D=3;E=444;break a}if((r-(ed+280)|0)>372){D=3;E=444;break a}c[r+8>>2]=gd;De=r+12|0;df=c[(c[(c[j>>2]|0)+908>>2]|0)+(M<<2)>>2]|0;c[De>>2]=df;hf=c[(c[(c[j>>2]|0)+908>>2]|0)+(M+1<<2)>>2]|0;c[r+16>>2]=hf;c[r+20>>2]=df;if((df|0)==0|(hf|0)==(df|0)){D=3;E=444;break a}c[(c[j>>2]|0)+676>>2]=De;od=F;pd=df;qd=hf;rd=q;sd=g;td=De;break}case 51:{De=ed+676|0;hf=c[De>>2]|0;if(hf>>>0<=(ed+280|0)>>>0){D=3;E=444;break a}c[De>>2]=hf+-12;hf=c[(c[j>>2]|0)+676>>2]|0;od=F;pd=c[hf+8>>2]|0;qd=c[hf+4>>2]|0;rd=q;sd=g;td=hf;break}case 25:case 35:{od=F;pd=gd;qd=f;rd=q;sd=g;td=r;break}default:{D=7;E=444;break a}}while(0);c[(c[j>>2]|0)+276>>2]=od;if(((c[(c[j>>2]|0)+276>>2]|0)-u|0)>188){D=130;E=444;break}else{B=pd;f=qd;q=rd;g=sd;r=td}}if((E|0)==362){td=Gbe(Gg,c[Ig>>2]|0,c[Fg+(1-Hg<<2)>>2]|0,c[Fg+(2-Hg<<2)>>2]|0,c[Fg+(3-Hg<<2)>>2]>>16,c[Fg+(4-Hg<<2)>>2]>>16)|0;Y8d(c[A>>2]|0);D=td;i=h;return D|0}else if((E|0)==363){if((Dg|0)>3){Dg=c[Bg+744>>2]|0;td=Gbe(Bg,0,c[Ag+(-4-Cg<<2)>>2]|0,c[Ag+(-3-Cg<<2)>>2]|0,c[Ag+(-2-Cg<<2)>>2]>>16,c[Ag+(((Eg|-16)^15)<<2)>>2]>>16)|0;c[(c[j>>2]|0)+744>>2]=Dg;D=td;i=h;return D|0}td=c[x>>2]|0;do if(td){Dg=b[td>>1]|0;if(Dg<<16>>16<2)Pg=0;else Pg=(b[(c[td+12>>2]|0)+((Dg<<16>>16)+-2<<1)>>1]|0)+1|0;Eg=td+2|0;Ag=b[Eg>>1]|0;if(((Ag<<16>>16>1?(Cg=c[td+4>>2]|0,Bg=(Ag<<16>>16)+-1|0,Hg=(c[td+8>>2]|0)+Bg|0,(c[Cg+(Pg<<3)>>2]|0)==(c[Cg+(Bg<<3)>>2]|0)):0)?(c[Cg+(Pg<<3)+4>>2]|0)==(c[Cg+(Bg<<3)+4>>2]|0):0)?(a[Hg>>0]|0)==1:0){Hg=Ag+-1<<16>>16;b[Eg>>1]=Hg;Qg=Hg}else Qg=Ag;Ag=Dg<<16>>16;if(Dg<<16>>16>0){Hg=(Qg<<16>>16)+-1|0;if((Pg|0)==(Hg|0)){b[td>>1]=Dg+-1<<16>>16;b[Eg>>1]=Qg+-1<<16>>16;break}else{b[(c[td+12>>2]|0)+(Ag+-1<<1)>>1]=Hg;break}}}while(0);do if(s)if(!(_n[c[o+8>>2]&4095](c[t>>2]|0,b[td+2>>1]|0)|0)){kn[c[o+24>>2]&511](c[t>>2]|0,c[x>>2]|0,c[e+72>>2]|0,c[(c[j>>2]|0)+920>>2]|0)|0;break}else{D=3;i=h;return D|0}while(0);Y8d(c[A>>2]|0);D=0;i=h;return D|0}else if((E|0)==444){i=h;return D|0}return 0}function Ebe(f,g,h,j){f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;k=i;i=i+992|0;l=k+48|0;m=k+16|0;n=k+984|0;o=k+4|0;p=k;q=k+32|0;r=k+8|0;s=k+978|0;t=k+976|0;u=c[f+4>>2]|0;v=u+692|0;w=c[v>>2]|0;x=w+1324|0;if((c[x+132>>2]|0)!=65535?(y=w+1152|0,(c[w+1164>>2]|0)!=0):0)if(h){z=Obe(y,h)|0;if(!z){A=6;i=k;return A|0}else B=z}else B=0;else if((c[w+12>>2]|0)>>>0>h>>>0)B=h;else{A=6;i=k;return A|0}h=(j&1024|0)==0?j:j|3;j=f+164|0;c[j>>2]=65536;z=f+168|0;c[z>>2]=65536;y=(g|0)!=0;if(((y?(c[j>>2]=c[g+16>>2],c[z>>2]=c[g+20>>2],C=c[g>>2]|0,D=c[C+532>>2]|0,E=c[C+104>>2]|0,C=c[g+44>>2]|0,(C|0)!=-1):0)?(c[D+140>>2]|0)!=0&(h&8|0)==0:0)?(gn[c[D+104>>2]&127](u,C,B,h,E,f+76|0,n)|0)==0:0){b[f+110>>1]=0;b[f+108>>1]=0;c[f+24>>2]=d[n+1>>0]<<6;c[f+28>>2]=d[n>>0]<<6;E=a[n+2>>0]|0;c[f+32>>2]=E<<6;C=a[n+3>>0]|0;c[f+36>>2]=C<<6;c[f+40>>2]=d[n+4>>0]<<6;D=a[n+5>>0]|0;c[f+44>>2]=D<<6;F=a[n+6>>0]|0;c[f+48>>2]=F<<6;c[f+52>>2]=d[n+7>>0]<<6;c[f+72>>2]=1651078259;n=f+100|0;if(!(h&16)){c[n>>2]=E;c[f+104>>2]=C;A=0;i=k;return A|0}else{c[n>>2]=D;c[f+104>>2]=F;A=0;i=k;return A|0}}if(h&16384){A=6;i=k;return A|0}F=w+1896|0;if(c[F>>2]|0){D=Nbe(w+2924|0,B)|0;n=c[F>>2]|0;if((D&255)>>>0<n>>>0)G=D;else G=n+255&255;n=c[x+68>>2]|0;D=w+1900+((G&255)<<2)|0;G=c[D>>2]|0;F=c[G+68>>2]|0;C=G+48|0;c[m+0>>2]=c[C+0>>2];c[m+4>>2]=c[C+4>>2];c[m+8>>2]=c[C+8>>2];c[m+12>>2]=c[C+12>>2];C=c[D>>2]|0;D=c[C+72>>2]|0;G=c[C+76>>2]|0;if((n|0)==(F|0)){H=D;I=G;J=0}else{c[j>>2]=I8d(c[j>>2]|0,n,F)|0;c[z>>2]=I8d(c[z>>2]|0,n,F)|0;H=D;I=G;J=1}}else{G=x+48|0;c[m+0>>2]=c[G+0>>2];c[m+4>>2]=c[G+4>>2];c[m+8>>2]=c[G+8>>2];c[m+12>>2]=c[G+12>>2];H=c[w+1396>>2]|0;I=c[w+1400>>2]|0;J=0}G=f+108|0;x=f+110|0;b[x>>1]=0;b[G>>1]=0;D=(h&1|0)==0;if(D)K=(h>>>1&1^1)&255;else K=0;F=f+72|0;c[F>>2]=1869968492;n=h>>>16&15;C=c[v>>2]|0;PEi(l|0,0,928)|0;a[l+65>>0]=1;E=l+4|0;c[E>>2]=u;L=l+8|0;c[L>>2]=f;c[l>>2]=c[u+100>>2];if((f|0)!=0?(M=f+156|0,N=c[c[M>>2]>>2]|0,c[l+12>>2]=N,c[l+16>>2]=N+20,c[l+20>>2]=N+56,S8d(N),N=l+72|0,c[N>>2]=0,O=l+68|0,c[O>>2]=0,K<<24>>24!=0&y):0){c[N>>2]=c[c[g+40>>2]>>2];c[O>>2]=c[(c[M>>2]|0)+36>>2]}M=l+24|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;c[M+16>>2]=0;c[M+20>>2]=0;M=l+76|0;c[M>>2]=C;O=c[C+92>>2]|0;c[l+892>>2]=O;c[l+908>>2]=c[C+1308>>2];if((c[C+1368>>2]|0)!=1)if(O>>>0<1240)P=107;else P=O>>>0<33900?1131:32768;else P=0;c[l+900>>2]=P;c[l+920>>2]=n;if(h&256)a[l+753>>0]=1;n=h&1024;a[l+66>>0]=0;P=Ibe((c[v>>2]|0)+1176|0,B,o,p)|0;if(P){A=P;i=k;return A|0}P=c[(c[E>>2]|0)+692>>2]|0;E=P+1896|0;if(c[E>>2]|0){O=(Nbe(P+2924|0,B)|0)&255;if(O>>>0>=(c[E>>2]|0)>>>0){A=3;i=k;return A|0}E=c[P+1900+(O<<2)>>2]|0;if((c[l+68>>2]|0)!=0&y){c[l+72>>2]=c[(c[g+40>>2]|0)+(O<<2)+4>>2];Q=E}else Q=E}else Q=P+1324|0;P=c[Q+544>>2]|0;c[l+888>>2]=P;c[l+904>>2]=c[Q+568>>2];if((c[(c[M>>2]|0)+1368>>2]|0)!=1)if(P>>>0<1240)R=107;else R=P>>>0<33900?1131:32768;else R=0;c[l+896>>2]=R;R=l+744|0;c[R>>2]=c[Q+528>>2];c[l+748>>2]=c[Q+532>>2];Q=Dbe(l,c[o>>2]|0,c[p>>2]|0)|0;Jbe((c[v>>2]|0)+1176|0,o);if(Q){A=Q;i=k;return A|0}Q=w+1176|0;w=c[Q+24>>2]|0;if(w){c[f+136>>2]=(c[Q+28>>2]|0)+((c[w+(B<<2)>>2]|0)+-1);c[f+140>>2]=c[p>>2]}p=c[L>>2]|0;if(p){L=c[l+16>>2]|0;w=p+108|0;c[w+0>>2]=c[L+0>>2];c[w+4>>2]=c[L+4>>2];c[w+8>>2]=c[L+8>>2];c[w+12>>2]=c[L+12>>2];c[w+16>>2]=c[L+16>>2]}if(n){n=c[f+156>>2]|0;c[f+32>>2]=c[l+32>>2];c[f+40>>2]=c[R>>2];L=n+12|0;c[L+0>>2]=c[m+0>>2];c[L+4>>2]=c[m+4>>2];c[L+8>>2]=c[m+8>>2];c[L+12>>2]=c[m+12>>2];c[n+28>>2]=H;c[n+32>>2]=I;a[n+8>>0]=1;A=0;i=k;return A|0}n=f+24|0;L=c[R>>2]|0;R=f+40|0;c[R>>2]=L;c[f+56>>2]=L;a[(c[f+156>>2]|0)+8>>0]=0;if(((a[u+296>>0]|0)!=0?(L=u+300|0,(b[L+34>>1]|0)!=0):0)?(c[L+36>>2]|0)!=0:0){b[s>>1]=0;b[t>>1]=0;Bn[c[(c[u+532>>2]|0)+156>>2]&255](u,1,B,s,t)|0;c[f+48>>2]=b[s>>1];s=e[t>>1]|0;c[f+52>>2]=s;S=s;T=1}else U=49;do if((U|0)==49){s=u+368|0;if((b[s>>1]|0)==-1){t=u+216|0;B=(b[t+4>>1]|0)-(b[t+6>>1]|0)|0;c[f+52>>2]=B;S=B;T=0;break}else{B=(b[s+70>>1]|0)-(b[s+72>>1]|0)|0;c[f+52>>2]=B;S=B;T=0;break}}while(0);u=f+52|0;c[f+60>>2]=S;c[F>>2]=1869968492;F=f+124|0;c[F>>2]=0;if(y?(e[g+14>>1]|0)<24:0){c[F>>2]=256;V=260}else V=4;c[F>>2]=V;do if((c[m>>2]|0)==65536?(c[m+12>>2]|0)==65536:0){if(c[m+4>>2]|0){U=59;break}if(c[m+8>>2]|0)U=59}else U=59;while(0);if((U|0)==59)kae(G,m);if(I|H)iae(G,H,I);c[r>>2]=c[R>>2];V=r+4|0;c[V>>2]=0;jae(r,m);c[R>>2]=(c[r>>2]|0)+H;c[r>>2]=0;c[V>>2]=c[u>>2];jae(r,m);c[u>>2]=(c[V>>2]|0)+I;if(!((J|0)==0&(D^1))){D=c[f+112>>2]|0;J=c[j>>2]|0;j=c[z>>2]|0;if(!(K<<24>>24!=0?(c[l+68>>2]|0)!=0:0))U=65;do if((U|0)==65){l=b[x>>1]|0;if(l<<16>>16<=0)break;K=l<<16>>16;l=D;while(1){c[l>>2]=K8d(c[l>>2]|0,J)|0;z=l+4|0;c[z>>2]=K8d(c[z>>2]|0,j)|0;K=K+-1|0;if((K|0)<=0)break;else l=l+8|0}}while(0);c[R>>2]=K8d(c[R>>2]|0,J)|0;c[u>>2]=K8d(c[u>>2]|0,j)|0}hae(G,q);G=c[q>>2]|0;c[n>>2]=(c[q+8>>2]|0)-G;j=c[q+12>>2]|0;c[f+28>>2]=j-(c[q+4>>2]|0);c[f+32>>2]=G;c[f+36>>2]=j;if(T){c[f+44>>2]=G-((c[R>>2]|0)/2|0);A=0;i=k;return A|0}if(!(h&16)){A=0;i=k;return A|0}H9d(n,c[u>>2]|0);A=0;i=k;return A|0}function Fbe(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;j=d+64|0;if(a[j>>0]|0){k=0;i=h;return k|0}a[j>>0]=1;j=d+20|0;l=c[j>>2]|0;m=d+65|0;if(!(a[m>>0]|0)){b[l>>1]=(b[l>>1]|0)+1<<16>>16;n=d+12|0}else{o=d+12|0;d=c[o>>2]|0;if(((b[d+20>>1]|0)+1+(b[d+56>>1]|0)|0)>>>0>(c[d+8>>2]|0)>>>0?(p=V8d(d,0,1)|0,(p|0)!=0):0){k=p;i=h;return k|0}p=b[l>>1]|0;if(p<<16>>16>0){b[(c[l+12>>2]|0)+((p<<16>>16)+-1<<1)>>1]=(e[l+2>>1]|0)+65535;q=b[l>>1]|0}else q=p;b[l>>1]=q+1<<16>>16;n=o}o=c[n>>2]|0;if(((b[o+22>>1]|0)+1+(b[o+58>>1]|0)|0)>>>0>(c[o+4>>2]|0)>>>0?(n=V8d(o,1,0)|0,(n|0)!=0):0){k=n;i=h;return k|0}n=c[j>>2]|0;if(!(a[m>>0]|0))r=n+2|0;else{m=c[n+4>>2]|0;j=n+2|0;o=b[j>>1]|0;q=(c[n+8>>2]|0)+o|0;c[m+(o<<3)>>2]=f>>16;c[m+(o<<3)+4>>2]=g>>16;a[q>>0]=1;r=j}b[r>>1]=(b[r>>1]|0)+1<<16>>16;k=0;i=h;return k|0}function Gbe(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;k=i;i=i+16|0;l=k+4|0;m=k;n=d+924|0;if(a[n>>0]|0){o=160;i=k;return o|0}p=d+32|0;q=(c[p>>2]|0)+f|0;f=d+36|0;r=(c[f>>2]|0)+g|0;g=(c[d+4>>2]|0)+692|0;s=c[g>>2]|0;t=s+1160|0;u=c[t>>2]|0;a:do if(!((u|0)==0|h>>>0>255)){v=Hbe(h)|0;w=c[s+12>>2]|0;x=c[t>>2]|0;if(!w){y=-1;z=x}else{A=0;while(1){if((b[x+(A<<1)>>1]|0)==v<<16>>16){y=A;z=x;break a}A=A+1|0;if(A>>>0>=w>>>0){y=-1;z=x;break}}}}else{y=-1;z=u}while(0);b:do if(!((z|0)==0|j>>>0>255)?(u=Hbe(j)|0,h=c[s+12>>2]|0,(h|0)!=0):0){x=c[t>>2]|0;w=0;while(1){if((b[x+(w<<1)>>1]|0)==u<<16>>16){B=w;break b}w=w+1|0;if(w>>>0>=h>>>0){B=-1;break}}}else B=-1;while(0);if((B|y|0)<0){o=160;i=k;return o|0}do if(a[d+66>>0]|0){t=c[d+8>>2]|0;s=c[c[t+156>>2]>>2]|0;j=W8d(s,2)|0;if(!j){z=c[s+88>>2]|0;c[z>>2]=y;b[z+4>>1]=514;c[z+8>>2]=0;c[z+12>>2]=0;c[z+32>>2]=B;b[z+36>>1]=2;c[z+40>>2]=q>>16;c[z+44>>2]=r>>16;c[t+128>>2]=2;c[t+132>>2]=c[s+52>>2];c[t+72>>2]=1668246896;c[s+84>>2]=2;break}else{o=j;i=k;return o|0}}while(0);X8d(c[d+12>>2]|0);if((Ibe((c[g>>2]|0)+1176|0,y,l,m)|0)==0?(a[n>>0]=1,y=Dbe(d,c[l>>2]|0,c[m>>2]|0)|0,a[n>>0]=0,Jbe((c[g>>2]|0)+1176|0,l),(y|0)!=0):0){o=y;i=k;return o|0}y=p;j=c[y>>2]|0;s=c[y+4>>2]|0;y=d+40|0;t=y;z=c[t>>2]|0;h=c[t+4>>2]|0;t=d+744|0;w=c[t>>2]|0;c[p>>2]=0;c[f>>2]=0;f=d+24|0;c[f>>2]=q-e;e=d+28|0;c[e>>2]=r;r=Ibe((c[g>>2]|0)+1176|0,B,l,m)|0;if(!r){a[n>>0]=1;B=Dbe(d,c[l>>2]|0,c[m>>2]|0)|0;a[n>>0]=0;Jbe((c[g>>2]|0)+1176|0,l);if(!B)C=0;else{o=B;i=k;return o|0}}else C=r;r=p;c[r>>2]=j;c[r+4>>2]=s;s=y;c[s>>2]=z;c[s+4>>2]=h;c[t>>2]=w;c[f>>2]=0;c[e>>2]=0;o=C;i=k;return o|0}function Hbe(a){a=a|0;var c=0;if(a>>>0<256)c=b[724856+(a<<1)>>1]|0;else c=0;return c|0}function Ibe(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=i;i=i+16|0;j=h;if(!b){k=6;i=h;return k|0}l=b+8|0;m=c[l>>2]|0;if(m>>>0<=e>>>0){k=6;i=h;return k|0}n=c[b>>2]|0;o=c[b+24>>2]|0;a:do if(!o){p=b+12|0;q=da(d[p>>0]|0,e)|0;r=Dae(n,(c[b+4>>2]|0)+3+q|0)|0;if(r){k=r;i=h;return k|0}r=Gae(c[b>>2]|0,j,d[p>>0]|0)|0;if(r){k=r;i=h;return k|0}r=a[p>>0]|0;if(r<<24>>24){q=r&255;s=0;t=0;while(1){u=d[j+s>>0]|0|t<<8;s=s+1|0;if((s|0)>=(q|0)){v=u;break}else t=u}if(v){t=e;q=r;while(1){s=t+1|0;u=Gae(c[b>>2]|0,j,q&255)|0;if((u|0)==0?(w=a[p>>0]|0,w<<24>>24!=0):0){x=w&255;w=0;y=0;while(1){z=d[j+w>>0]|0|y<<8;w=w+1|0;if((w|0)>=(x|0)){A=z;break}else y=z}if(A){B=v;C=A;D=22;break a}}if(s>>>0>=(c[l>>2]|0)>>>0){E=u;F=v;D=21;break a}t=s;q=a[p>>0]|0}}else D=20}else D=20}else{p=c[o+(e<<2)>>2]|0;if(!p)D=20;else{q=e;while(1){q=q+1|0;t=c[o+(q<<2)>>2]|0;if(t){B=p;C=t;D=22;break a}if(q>>>0>=m>>>0){E=0;F=p;D=21;break}}}}while(0);if((D|0)==20){G=c[n+4>>2]|0;H=0;I=0;J=0;D=24}else if((D|0)==21){G=c[n+4>>2]|0;H=E;I=F;J=0;D=24}else if((D|0)==22){F=c[n+4>>2]|0;if(C>>>0>(F+1|0)>>>0){K=F;L=c[b+16>>2]|0;M=0;N=B;D=25}else{G=F;H=0;I=B;J=C;D=24}}if((D|0)==24){C=c[b+16>>2]|0;if(C>>>0>(G+1-J|0)>>>0){K=G;L=C;M=H;N=I;D=25}else{O=H;P=I;Q=J}}if((D|0)==25){O=M;P=N;Q=K+1-L|0}if(!((P|0)!=0&Q>>>0>P>>>0)){c[f>>2]=0;c[g>>2]=0;k=O;i=h;return k|0}L=Q-P|0;c[g>>2]=L;g=c[b+28>>2]|0;if(g){c[f>>2]=g+(P+-1);k=O;i=h;return k|0}O=Dae(n,P+-1+(c[b+16>>2]|0)|0)|0;if(O){k=O;i=h;return k|0}k=Iae(n,L,f)|0;i=h;return k|0}function Jbe(a,b){a=a|0;b=b|0;var d=0;d=i;if(c[a+28>>2]|0){i=d;return}Kae(c[a>>2]|0,b);i=d;return}function Kbe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=b+20|0;k=c[(c[j>>2]|0)+28>>2]|0;l=Ibe(j,d,f,g)|0;c[h>>2]=l;if(l){m=0;i=e;return m|0}l=c[g>>2]|0;g=Xae(k,l+1|0,h)|0;if(!(c[h>>2]|0)){YEi(g|0,c[f>>2]|0,l|0)|0;a[g+l>>0]=0}if(c[b+48>>2]|0){m=g;i=e;return m|0}Kae(c[j>>2]|0,f);m=g;i=e;return m|0}function Lbe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a+1312>>2]|0)>>>0<=b>>>0){e=0;i=d;return e|0}e=c[(c[a+1316>>2]|0)+(b<<2)>>2]|0;i=d;return e|0}function Mbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do if((b|0)!=65535)if(b>>>0>390){e=b+-391|0;if((c[a+1312>>2]|0)>>>0<=e>>>0){f=0;break}f=c[(c[a+1316>>2]|0)+(e<<2)>>2]|0;break}else{e=c[a+2956>>2]|0;if(!e){f=0;break}f=mo[c[e+20>>2]&4095](b)|0;break}else f=0;while(0);i=d;return f|0}function Nbe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=d[b>>0]|0;if(!g){h=a[(c[b+8>>2]|0)+e>>0]|0;i=f;return h|0}else if((g|0)==3){g=b+16|0;j=b+20|0;if((e-(c[g>>2]|0)|0)>>>0<(c[j>>2]|0)>>>0){h=a[b+24>>0]|0;i=f;return h|0}k=c[b+8>>2]|0;l=k+(c[b+12>>2]|0)|0;m=k;n=(d[k>>0]|0)<<8|(d[k+1>>0]|0);o=k+2|0;while(1){if(n>>>0>e>>>0){h=0;p=10;break}k=o;o=m+5|0;q=m;m=m+3|0;r=n;n=(d[m>>0]|0)<<8|(d[q+4>>0]|0);if(n>>>0>e>>>0){s=n;t=r;u=k;p=8;break}if(o>>>0>=l>>>0){h=0;p=10;break}}if((p|0)==8){l=a[u>>0]|0;c[g>>2]=t;c[j>>2]=s-t;a[b+24>>0]=l;h=l;i=f;return h|0}else if((p|0)==10){i=f;return h|0}}else{h=0;i=f;return h|0}return 0}function Obe(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;if((c[a+16>>2]|0)>>>0<b>>>0){f=0;i=d;return f|0}f=e[(c[a+12>>2]|0)+(b<<1)>>1]|0;i=d;return f|0}function Pbe(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;l=i;i=i+80|0;m=l+76|0;n=l+72|0;o=l+68|0;p=l+64|0;q=l+32|0;r=l;s=g+28|0;t=c[s>>2]|0;PEi(j|0,0,2972)|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;c[j>>2]=g;c[j+4>>2]=t;u=j+1324|0;v=Fae(g)|0;w=Sae(g,725368,j)|0;c[p>>2]=w;a:do if(!w){if(((a[j+16>>0]|0)==1?(x=a[j+18>>0]|0,y=x&255,(x&255)>=4):0)?(d[j+19>>0]|0)<=4:0){x=Eae(g,y+-4|0)|0;c[p>>2]=x;if(x)break;x=j+20|0;y=Rbe(x,g,0)|0;c[p>>2]=y;if(y)break;y=j+1208|0;z=Rbe(y,g,0)|0;c[p>>2]=z;if(z)break;z=Rbe(q,g,1)|0;c[p>>2]=z;if(z)break;z=j+84|0;A=Rbe(z,g,1)|0;c[p>>2]=A;if(A)break;A=Sbe(q,j+1316|0,j+1320|0)|0;c[p>>2]=A;if(A)break;c[j+1312>>2]=c[q+8>>2];A=c[j+28>>2]|0;c[j+8>>2]=A;if((A|0)<=(h|0))c[p>>2]=6;if((h|0)<0)break;A=Tbe(u,y,h,g,v,f)|0;c[p>>2]=A;if(A)break;A=j+1436|0;y=Dae(g,(c[A>>2]|0)+v|0)|0;c[p>>2]=y;if(y)break;y=Rbe(j+1176|0,g,0)|0;c[p>>2]=y;if(y)break;y=j+1456|0;if((c[y>>2]|0)!=65535){B=Dae(g,(c[j+1488>>2]|0)+v|0)|0;c[p>>2]=B;if(B)break;B=Rbe(r,g,0)|0;c[p>>2]=B;if(B)break;B=r+8|0;C=c[B>>2]|0;b:do if(C>>>0>256)D=0;else{c[j+1896>>2]=C;E=Zae(t,572,0,C,0,p)|0;F=c[p>>2]|0;if(F){D=F;break}F=c[B>>2]|0;do if(F){G=0;do{c[j+(G<<2)+1900>>2]=E+(G*572|0);G=G+1|0}while(G>>>0<F>>>0);if(!F)break;else H=0;do{G=Tbe(c[j+(H<<2)+1900>>2]|0,r,H,g,v,f)|0;c[p>>2]=G;H=H+1|0;if(G){D=G;break b}}while(H>>>0<(c[B>>2]|0)>>>0)}while(0);F=c[j+1184>>2]|0;E=Dae(g,(c[j+1492>>2]|0)+v|0)|0;c[m>>2]=E;do if(!E){G=Pae(g,m)|0;I=c[m>>2]|0;if(I){J=I;break}a[j+2924>>0]=G;c[j+2944>>2]=0;I=G&255;if((I|0)==3){G=Qae(g,m)|0;K=c[m>>2]|0;if(K){J=K;break}K=((G&65535)*3|0)+2|0;c[j+2936>>2]=K;L=K}else if(!I){c[j+2936>>2]=F;L=F}else{c[m>>2]=3;J=3;break}I=Iae(g,L,j+2932|0)|0;c[m>>2]=I;J=I}else J=E;while(0);c[p>>2]=J;D=J}while(0);B=c[r>>2]|0;if(!B)M=D;else{C=c[B+28>>2]|0;E=r+28|0;if(c[E>>2]|0)Kae(B,E);$ae(C,c[r+24>>2]|0);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[r+16>>2]=0;c[r+20>>2]=0;c[r+24>>2]=0;c[r+28>>2]=0;M=c[p>>2]|0}if(M)break}else c[j+1896>>2]=0;if(!(c[A>>2]|0)){c[p>>2]=2;break}C=j+12|0;c[C>>2]=c[j+1184>>2];E=Sbe(z,j+1308|0,0)|0;c[p>>2]=E;if(E)break;E=c[C>>2]|0;c:do if(E){if((c[y>>2]|0)==65535)N=0;else N=k<<24>>24!=0&1;B=j+1152|0;F=c[j+1428>>2]|0;I=c[s>>2]|0;c[n>>2]=0;d:do if(F>>>0>2){K=F+v|0;G=j+1156|0;c[G>>2]=K;O=Dae(g,K)|0;c[n>>2]=O;if(O){P=G;Q=97;break}c[B>>2]=(Pae(g,n)|0)&255;if(c[n>>2]|0){P=G;Q=97;break}O=Zae(I,2,0,E,0,n)|0;K=j+1160|0;c[K>>2]=O;if(c[n>>2]|0){P=G;Q=97;break}b[O>>1]=0;O=c[B>>2]|0;if((O|0)==2|(O|0)==1){if(E>>>0>1)R=1;else{Q=83;break}while(1){S=Qae(g,n)|0;if(c[n>>2]|0){P=G;Q=97;break d}if((c[B>>2]|0)==2){T=(Qae(g,n)|0)&65535;if(!(c[n>>2]|0))U=T;else{P=G;Q=97;break d}}else{T=(Pae(g,n)|0)&255;if(!(c[n>>2]|0))U=T;else{P=G;Q=97;break d}}T=S&65535;if(R>>>0<E>>>0){V=c[K>>2]|0;W=R-E|0;X=~(T>>>0>(U^65535)>>>0?T^65535:U);T=W>>>0>X>>>0?W:X;X=0-T|0;W=S;S=0;Y=R;while(1){b[V+(Y<<1)>>1]=W;S=S+1|0;if((S|0)==(X|0))break;else{W=W+1<<16>>16;Y=Y+1|0}}Z=R-T|0}else Z=R;if(Z>>>0<E>>>0)R=Z;else{Q=83;break}}}else if(!O){Y=Jae(g,(E<<1)+-2|0)|0;c[n>>2]=Y;if(Y){P=G;Q=97;break}if(E>>>0>1){Y=1;do{W=Nae(g)|0;b[(c[K>>2]|0)+(Y<<1)>>1]=W;Y=Y+1|0}while((Y|0)!=(E|0))}Lae(g);Q=83;break}else{c[n>>2]=3;P=G;Q=97;break}}else{Y=j+1156|0;c[Y>>2]=F;if((F|0)==2){if(E>>>0>87){c[n>>2]=3;P=Y;Q=97;break}K=Zae(I,2,0,E,0,n)|0;c[j+1160>>2]=K;if(c[n>>2]|0){P=Y;Q=97;break}YEi(K|0,726704,E<<1|0)|0;Q=83;break}else if(!F){if(E>>>0>229){c[n>>2]=3;P=Y;Q=97;break}K=Zae(I,2,0,E,0,n)|0;c[j+1160>>2]=K;if(c[n>>2]|0){P=Y;Q=97;break}YEi(K|0,725904,E<<1|0)|0;Q=83;break}else if((F|0)==1){if(E>>>0>166){c[n>>2]=3;P=Y;Q=97;break}K=Zae(I,2,0,E,0,n)|0;c[j+1160>>2]=K;if(c[n>>2]|0){P=Y;Q=97;break}YEi(K|0,726368,E<<1|0)|0;Q=83;break}else{c[n>>2]=3;P=Y;Q=97;break}}while(0);do if((Q|0)==83){if(!(N<<24>>24))_=c[n>>2]|0;else{c[m>>2]=0;F=j+1168|0;do if(!(c[F>>2]|0)){Y=c[j+1160>>2]|0;K=0;O=0;while(1){W=b[Y+(K<<1)>>1]|0;X=(W&65535)>(O&65535)?W:O;K=K+1|0;if((K|0)==(E|0)){$=X;break}else O=X}O=$&65535;K=Zae(I,2,0,O+1|0,0,m)|0;c[j+1164>>2]=K;Y=c[m>>2]|0;if(Y){aa=Y;break}Y=E+-1|0;if((Y|0)>-1){T=c[j+1160>>2]|0;X=Y;do{b[K+(e[T+(X<<1)>>1]<<1)>>1]=X;X=X+-1|0}while((X|0)>-1)}c[F>>2]=O;c[j+1172>>2]=E;aa=0}else aa=0;while(0);c[n>>2]=aa;_=aa}if(!_){c[p>>2]=0;break}else{P=j+1156|0;Q=97;break}}while(0);if((Q|0)==97?(F=j+1160|0,$ae(I,c[F>>2]|0),c[F>>2]=0,G=j+1164|0,$ae(I,c[G>>2]|0),c[G>>2]=0,c[B>>2]=0,c[P>>2]=0,c[F>>2]=0,F=c[n>>2]|0,c[p>>2]=F,(F|0)!=0):0)break a;if((c[y>>2]|0)!=65535)break;F=c[C>>2]|0;G=c[j+1432>>2]|0;c[n>>2]=0;X=j+1160|0;e:do if(!(c[X>>2]|0)){c[n>>2]=3;ba=3}else{T=0;do{b[j+(T<<1)+128>>1]=0;b[j+(T<<1)+640>>1]=0;T=T+1|0}while((T|0)!=256);f:do if(G>>>0>1){T=G+v|0;c[j+120>>2]=T;K=Dae(g,T)|0;c[n>>2]=K;if(K){ba=K;break e}K=j+116|0;c[K>>2]=(Pae(g,n)|0)&255;T=c[n>>2]|0;if(T){ba=T;break e}T=Pae(g,n)|0;Y=T&255;W=c[n>>2]|0;if(W){ba=W;break e}W=c[K>>2]&127;do if((W|0)==1){S=j+124|0;c[S>>2]=0;if(!(T<<24>>24))break;else{ca=1;da=0}do{V=(Pae(g,n)|0)&255;ea=c[n>>2]|0;if(ea){ba=ea;break e}ea=Pae(g,n)|0;fa=c[n>>2]|0;if(fa){ba=fa;break e}fa=ea&255;ea=fa+1|0;if(ea>>>0>(c[S>>2]|0)>>>0)c[S>>2]=ea;ga=ca;ca=ea+ca|0;if(ga>>>0<ca>>>0){ea=ga+1+fa|0;fa=V;V=ga;while(1){if(V>>>0<F>>>0&fa>>>0<256){b[j+(fa<<1)+640>>1]=V;b[j+(fa<<1)+128>>1]=b[(c[X>>2]|0)+(V<<1)>>1]|0}V=V+1|0;if((V|0)==(ea|0))break;else fa=fa+1|0}}da=da+1|0}while(da>>>0<Y>>>0);if((c[S>>2]|0)>>>0<=256)break;c[S>>2]=256}else if(!W){c[j+124>>2]=Y+1;fa=Jae(g,Y)|0;c[n>>2]=fa;if(fa){ba=fa;break e}if(T<<24>>24){fa=1;ea=c[g+32>>2]|0;while(1){V=d[ea>>0]|0;if(fa>>>0<F>>>0){b[j+(V<<1)+640>>1]=fa;b[j+(V<<1)+128>>1]=b[(c[X>>2]|0)+(fa<<1)>>1]|0}fa=fa+1|0;if(fa>>>0>Y>>>0)break;else ea=ea+1|0}}Lae(g)}else{c[n>>2]=3;ba=3;break e}while(0);if(!(c[K>>2]&128)){Y=c[n>>2]|0;c[p>>2]=Y;if(!Y)break c;else break a}Y=Pae(g,n)|0;T=Y&255;W=c[n>>2]|0;if(W){ba=W;break e}if(!(Y<<24>>24))break;if(!F){Y=0;while(1){W=(Pae(g,n)|0)&255;O=c[n>>2]|0;if(O){ba=O;break e}O=Qae(g,n)|0;ea=c[n>>2]|0;if(ea){ba=ea;break e}b[j+(W<<1)+128>>1]=O;Y=Y+1|0;if(Y>>>0>=T>>>0)break f}}else ha=0;do{Y=(Pae(g,n)|0)&255;K=c[n>>2]|0;if(K){ba=K;break e}K=Qae(g,n)|0;O=c[n>>2]|0;if(O){ba=O;break e}b[j+(Y<<1)+128>>1]=K;O=c[X>>2]|0;W=0;do{if((b[O+(W<<1)>>1]|0)==K<<16>>16){ia=W;Q=136;break}W=W+1|0}while(W>>>0<F>>>0);if((Q|0)==136){Q=0;b[j+(Y<<1)+640>>1]=ia}ha=ha+1|0}while(ha>>>0<T>>>0)}else{if(!G)YEi(j+128|0,724856,512)|0;else if((G|0)==1)YEi(j+128|0,725392,512)|0;else{c[n>>2]=3;ba=3;break e}T=j+124|0;c[T>>2]=0;W=c[s>>2]|0;c[m>>2]=0;K=j+1168|0;O=c[K>>2]|0;if(!O){if(!F)ja=0;else{ea=c[X>>2]|0;fa=0;S=0;while(1){V=b[ea+(fa<<1)>>1]|0;ga=(V&65535)>(S&65535)?V:S;fa=fa+1|0;if((fa|0)==(F|0)){ja=ga;break}else S=ga}}S=ja&65535;fa=Zae(W,2,0,S+1|0,0,m)|0;ea=j+1164|0;c[ea>>2]=fa;ga=c[m>>2]|0;if(ga){c[n>>2]=ga;ba=ga;break e}ga=F+-1|0;if((ga|0)>-1){V=c[X>>2]|0;ka=ga;do{b[fa+(e[V+(ka<<1)>>1]<<1)>>1]=ka;ka=ka+-1|0}while((ka|0)>-1)}c[K>>2]=S;c[j+1172>>2]=F;la=ea;ma=S}else{la=j+1164|0;ma=O}c[n>>2]=0;ka=0;while(1){V=j+(ka<<1)+128|0;fa=b[V>>1]|0;do if(!(fa<<16>>16))Q=161;else{W=fa&65535;if(ma>>>0<W>>>0){Q=161;break}ga=b[(c[la>>2]|0)+(W<<1)>>1]|0;if(!(ga<<16>>16)){Q=161;break}b[j+(ka<<1)+640>>1]=ga;ga=ka+1|0;c[T>>2]=ga;na=ga}while(0);if((Q|0)==161){Q=0;b[j+(ka<<1)+640>>1]=0;b[V>>1]=0;na=ka+1|0}if((na|0)==256)break;else ka=na}}while(0);c[p>>2]=0;break c}while(0);c[p>>2]=ba;break a}while(0);C=c[(c[x>>2]|0)+28>>2]|0;y=Ibe(x,h,m,n)|0;c[o>>2]=y;do if(!y){E=c[n>>2]|0;z=Xae(C,E+1|0,o)|0;if(!(c[o>>2]|0)){YEi(z|0,c[m>>2]|0,E|0)|0;a[z+E>>0]=0}if(c[j+48>>2]|0){oa=z;break}Kae(c[x>>2]|0,m);oa=z}else oa=0;while(0);c[j+1304>>2]=oa;break}c[p>>2]=2}while(0);oa=c[q>>2]|0;if(!oa){pa=c[p>>2]|0;i=l;return pa|0}j=c[oa+28>>2]|0;m=q+28|0;if(c[m>>2]|0)Kae(oa,m);$ae(j,c[q+24>>2]|0);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;c[q+16>>2]=0;c[q+20>>2]=0;c[q+24>>2]=0;c[q+28>>2]=0;pa=c[p>>2]|0;i=l;return pa|0}function Qbe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=c[b+4>>2]|0;f=b+84|0;g=c[f>>2]|0;if(g){h=c[g+28>>2]|0;j=b+112|0;if(c[j>>2]|0)Kae(g,j);$ae(h,c[b+108>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0}f=b+1208|0;h=c[f>>2]|0;if(h){j=c[h+28>>2]|0;g=b+1236|0;if(c[g>>2]|0)Kae(h,g);$ae(j,c[b+1232>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0}f=b+20|0;j=c[f>>2]|0;if(j){g=c[j+28>>2]|0;h=b+48|0;if(c[h>>2]|0)Kae(j,h);$ae(g,c[b+44>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0}f=b+1176|0;g=c[f>>2]|0;if(g){h=c[g+28>>2]|0;j=b+1204|0;if(c[j>>2]|0)Kae(g,j);$ae(h,c[b+1200>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0}f=b+1896|0;h=c[f>>2]|0;if(h){j=h;h=0;while(1){g=c[b+(h<<2)+1900>>2]|0;if(!g)k=j;else{l=g+536|0;m=c[l>>2]|0;if(m){n=c[m+28>>2]|0;o=g+564|0;if(c[o>>2]|0)Kae(m,o);$ae(n,c[g+560>>2]|0);c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0}l=g+568|0;$ae(e,c[l>>2]|0);c[l>>2]=0;k=c[f>>2]|0}h=h+1|0;if(h>>>0>=k>>>0)break;else j=k}k=b+1900|0;$ae(e,c[k>>2]|0);c[k>>2]=0}c[b+116>>2]=0;c[b+120>>2]=0;c[b+124>>2]=0;k=c[(c[b>>2]|0)+28>>2]|0;j=b+1164|0;$ae(k,c[j>>2]|0);c[j>>2]=0;c[b+1168>>2]=0;j=b+1160|0;$ae(k,c[j>>2]|0);c[j>>2]=0;c[b+1152>>2]=0;c[b+1156>>2]=0;j=b+1860|0;k=c[j>>2]|0;if(k){h=c[k+28>>2]|0;f=b+1888|0;if(c[f>>2]|0)Kae(k,f);$ae(h,c[b+1884>>2]|0);c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0}j=b+1892|0;$ae(e,c[j>>2]|0);c[j>>2]=0;j=b+2932|0;if(!(c[j>>2]|0)){p=b+2936|0;c[p>>2]=0;q=b+2924|0;a[q>>0]=0;r=b+2928|0;c[r>>2]=0;s=b+2960|0;t=c[s>>2]|0;$ae(e,t);c[s>>2]=0;u=b+1304|0;v=c[u>>2]|0;$ae(e,v);c[u>>2]=0;w=b+1308|0;x=c[w>>2]|0;$ae(e,x);c[w>>2]=0;y=b+1316|0;z=c[y>>2]|0;$ae(e,z);c[y>>2]=0;A=b+1320|0;B=c[A>>2]|0;$ae(e,B);c[A>>2]=0;i=d;return}Kae(c[b>>2]|0,j);p=b+2936|0;c[p>>2]=0;q=b+2924|0;a[q>>0]=0;r=b+2928|0;c[r>>2]=0;s=b+2960|0;t=c[s>>2]|0;$ae(e,t);c[s>>2]=0;u=b+1304|0;v=c[u>>2]|0;$ae(e,v);c[u>>2]=0;w=b+1308|0;x=c[w>>2]|0;$ae(e,x);c[w>>2]=0;y=b+1316|0;z=c[y>>2]|0;$ae(e,z);c[y>>2]=0;A=b+1320|0;B=c[A>>2]|0;$ae(e,B);c[A>>2]=0;i=d;return}function Rbe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g+4|0;j=g;k=c[e+28>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b>>2]=e;l=b+4|0;c[l>>2]=Fae(e)|0;m=Qae(e,j)|0;do if(!(c[j>>2]|0)){n=m&65535;if(!(m<<16>>16)){o=0;i=g;return o|0}p=Pae(e,j)|0;if(!(c[j>>2]|0)){q=p&255;if((p+-1<<24>>24&255)>3){c[j>>2]=8;break}c[b+8>>2]=n;r=b+12|0;a[r>>0]=p;p=da(q,n+1|0)|0;c[b+16>>2]=p+3+(c[l>>2]|0);p=Eae(e,da(q,n)|0)|0;c[j>>2]=p;if(!p){p=Gae(c[b>>2]|0,h,d[r>>0]|0)|0;n=(p|0)==0;if(!n){c[j>>2]=p;break}q=a[r>>0]|0;if(q<<24>>24){r=q&255;q=0;s=0;while(1){t=d[h+q>>0]|0|s<<8;q=q+1|0;if((q|0)>=(r|0)){u=t;break}else s=t}c[j>>2]=p;if(!n)break;if(u){s=u+-1|0;c[b+20>>2]=s;if(!(f<<24>>24))v=Eae(e,s)|0;else v=Iae(e,s,b+28|0)|0;c[j>>2]=v;if(!v)o=0;else break;i=g;return o|0}}else c[j>>2]=p;c[j>>2]=8}}}while(0);v=b+24|0;$ae(k,c[v>>2]|0);c[v>>2]=0;o=c[j>>2]|0;i=g;return o|0}function Sbe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;i=i+16|0;h=g+4|0;j=g;c[j>>2]=0;k=c[(c[b>>2]|0)+28>>2]|0;c[e>>2]=0;l=b+24|0;a:do if(!(c[l>>2]|0)){c[h>>2]=0;m=c[b>>2]|0;n=c[m+28>>2]|0;o=b+8|0;p=c[o>>2]|0;do if(p){q=p+1|0;r=d[b+12>>0]|0;s=da(r,q)|0;c[l>>2]=Zae(n,4,0,q,0,h)|0;if(((c[h>>2]|0)==0?(q=Dae(m,(c[b+4>>2]|0)+3|0)|0,c[h>>2]=q,(q|0)==0):0)?(q=Jae(m,s)|0,c[h>>2]=q,(q|0)==0):0){q=c[l>>2]|0;t=c[m+32>>2]|0;u=t+s|0;if((r|0)==1){if((s|0)>0){v=t;w=q;while(1){c[w>>2]=d[v>>0];v=v+1|0;if(v>>>0>=u>>>0)break;else w=w+4|0}}}else if((r|0)==2){if((s|0)>0){w=t;v=q;while(1){c[v>>2]=d[w>>0]<<8|d[w+1>>0];w=w+2|0;if(w>>>0>=u>>>0)break;else v=v+4|0}}}else if((r|0)==3){if((s|0)>0){v=t;w=q;while(1){c[w>>2]=d[v+1>>0]<<8|a[v>>0]<<16|d[v+2>>0];v=v+3|0;if(v>>>0>=u>>>0)break;else w=w+4|0}}}else if((s|0)>0){w=t;v=q;while(1){c[v>>2]=d[w+1>>0]<<16|d[w>>0]<<24|d[w+2>>0]<<8|d[w+3>>0];w=w+4|0;if(w>>>0>=u>>>0)break;else v=v+4|0}}Lae(m);if(!(c[h>>2]|0))break}$ae(n,c[l>>2]|0);c[l>>2]=0;v=c[h>>2]|0;c[j>>2]=v;if(!v){x=o;break a}y=c[j>>2]|0;i=g;return y|0}while(0);c[j>>2]=0;x=o}else x=b+8|0;while(0);h=c[x>>2]|0;if(!h){y=c[j>>2]|0;i=g;return y|0}n=Zae(k,4,0,h+1|0,0,j)|0;if(c[j>>2]|0){y=c[j>>2]|0;i=g;return y|0}h=(f|0)!=0;m=b+20|0;if(h){p=Xae(k,(c[x>>2]|0)+(c[m>>2]|0)|0,j)|0;if(!(c[j>>2]|0))z=p;else{y=c[j>>2]|0;i=g;return y|0}}else z=0;p=c[b+28>>2]|0;b=(c[c[l>>2]>>2]|0)+-1|0;k=c[m>>2]|0;v=b>>>0>=k>>>0?0:b;c[n>>2]=(h?z:p)+v;b=c[x>>2]|0;b:do if(b){if(h){A=b;B=v;C=0;D=1}else{u=v;w=1;while(1){q=(c[(c[l>>2]|0)+(w<<2)>>2]|0)+-1|0;if(!((q|0)==0|q>>>0<u>>>0)?!(q>>>0>=k>>>0&w>>>0<b>>>0):0)E=q;else E=u;c[n+(w<<2)>>2]=p+E;w=w+1|0;if(w>>>0>b>>>0)break b;else u=E}}while(1){u=(c[(c[l>>2]|0)+(D<<2)>>2]|0)+-1|0;if(!((u|0)==0|u>>>0<B>>>0)?!(D>>>0<A>>>0?u>>>0>=(c[m>>2]|0)>>>0:0):0){w=z+(u+C)|0;o=n+(D<<2)|0;c[o>>2]=w;if((u|0)==(B|0)){F=A;G=C;H=u}else{q=c[n+(D+-1<<2)>>2]|0;YEi(q|0,p+B|0,w-q|0)|0;a[c[o>>2]>>0]=0;c[o>>2]=(c[o>>2]|0)+1;F=c[x>>2]|0;G=C+1|0;H=u}}else{c[n+(D<<2)>>2]=z+(B+C);F=A;G=C;H=B}D=D+1|0;if(D>>>0>F>>>0)break;else{A=F;B=H;C=G}}}while(0);c[e>>2]=n;if(!h){y=c[j>>2]|0;i=g;return y|0}c[f>>2]=z;y=c[j>>2]|0;i=g;return y|0}function Tbe(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+432|0;l=k+8|0;m=k+4|0;n=k;c[m>>2]=0;dce(l,4096,b,j);PEi(b|0,0,172)|0;c[b+32>>2]=-6553600;c[b+36>>2]=3276800;c[b+44>>2]=2;c[b+48>>2]=65536;c[b+60>>2]=65536;c[b+156>>2]=8720;c[b>>2]=65535;c[b+4>>2]=65535;c[b+8>>2]=65535;c[b+12>>2]=65535;c[b+16>>2]=65535;c[b+20>>2]=65535;c[b+128>>2]=65535;o=b+132|0;c[o>>2]=65535;c[b+136>>2]=65535;c[b+172>>2]=65535;p=Ibe(e,f,m,n)|0;if(!p){f=c[m>>2]|0;q=gce(l,f,f+(c[n>>2]|0)|0)|0}else q=p;if(!(c[e+28>>2]|0))Kae(c[e>>2]|0,m);if(q){r=q;i=k;return r|0}if((c[o>>2]|0)!=65535){r=0;i=k;return r|0}o=b+116|0;do if((c[o>>2]|0)!=0?(q=b+120|0,(c[q>>2]|0)!=0):0){m=b+176|0;PEi(m|0,0,360)|0;c[b+376>>2]=7;c[b+380>>2]=1;c[b+508>>2]=-1;c[b+516>>2]=3932;c[b+372>>2]=2596864;dce(l,8192,m,j);e=Dae(g,(c[o>>2]|0)+h|0)|0;if(e){r=e;i=k;return r|0}e=Jae(g,c[q>>2]|0)|0;if(e){r=e;i=k;return r|0}e=gce(l,c[g+32>>2]|0,c[g+36>>2]|0)|0;Lae(g);if(!e){a[m>>0]=(d[m>>0]|0)&254;break}else{r=e;i=k;return r|0}}while(0);l=c[b+524>>2]|0;if(!l){r=0;i=k;return r|0}j=Dae(g,l+h+(c[o>>2]|0)|0)|0;if(j){r=j;i=k;return r|0}j=b+536|0;o=Rbe(j,g,1)|0;if(o){r=o;i=k;return r|0}r=Sbe(j,b+568|0,0)|0;i=k;return r|0}function Ube(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=c[d+692>>2]|0;f=c[a+40>>2]|0;if(!f){i=b;return}a=c[e+2952>>2]|0;g=C9d(c[(c[d+96>>2]|0)+4>>2]|0,791048)|0;if(!((g|0)!=0&(a|0)!=0)){i=b;return}d=c[a>>2]|0;if(!d){i=b;return}a=mo[d&4095](g)|0;if(!a){i=b;return}g=a+8|0;ko[c[g>>2]&4095](c[f>>2]|0);a=c[e+1896>>2]|0;if(!a){i=b;return}else h=a;do{h=h+-1|0;ko[c[g>>2]&4095](c[f+(h<<2)+4>>2]|0)}while((h|0)!=0);i=b;return}function Vbe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+208|0;d=b+196|0;e=b;c[d>>2]=0;f=c[a>>2]|0;g=c[(c[f+692>>2]|0)+2952>>2]|0;h=C9d(c[(c[f+96>>2]|0)+4>>2]|0,791048)|0;do if(((h|0)!=0&(g|0)!=0?(f=c[g>>2]|0,(f|0)!=0):0)?(j=mo[f&4095](h)|0,(j|0)!=0):0){f=c[a>>2]|0;k=c[f+692>>2]|0;l=Xae(c[f+100>>2]|0,1028,d)|0;f=c[d>>2]|0;if(f){m=f;i=b;return m|0}cce(k+1324|0,e);f=xo[c[j>>2]&2047](c[(c[a>>2]|0)+100>>2]|0,e,l)|0;c[d>>2]=f;if(f){m=f;i=b;return m|0}f=k+1900|0;n=l+4|0;o=c[k+1896>>2]|0;while(1){if(!o){p=9;break}o=o+-1|0;cce(c[f+(o<<2)>>2]|0,e);k=xo[c[j>>2]&2047](c[(c[a>>2]|0)+100>>2]|0,e,n+(o<<2)|0)|0;c[d>>2]=k;if(k){m=k;p=11;break}}if((p|0)==9){c[a+40>>2]=l;break}else if((p|0)==11){i=b;return m|0}}while(0);c[a+44>>2]=-1;m=0;i=b;return m|0}function Wbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;c[a+44>>2]=b;I9d(c[a>>2]|0,b);b=c[a>>2]|0;e=c[(c[b+692>>2]|0)+2952>>2]|0;f=C9d(c[(c[b+96>>2]|0)+4>>2]|0,791048)|0;if(!((f|0)!=0&(e|0)!=0)){i=d;return 0}b=c[e>>2]|0;if(!b){i=d;return 0}e=mo[b&4095](f)|0;if(!e){i=d;return 0}f=c[(c[a>>2]|0)+692>>2]|0;b=c[a+40>>2]|0;g=c[f+1392>>2]|0;h=e+4|0;e=a+16|0;j=a+20|0;Bn[c[h>>2]&255](c[b>>2]|0,c[e>>2]|0,c[j>>2]|0,0,0)|0;a=c[f+1896>>2]|0;if(!a){i=d;return 0}k=f+1900|0;f=a;do{f=f+-1|0;a=c[(c[k+(f<<2)>>2]|0)+68>>2]|0;l=c[e>>2]|0;if((g|0)==(a|0)){m=l;n=c[j>>2]|0}else{o=I8d(l,g,a)|0;m=o;n=I8d(c[j>>2]|0,g,a)|0}Bn[c[h>>2]&255](c[b+(f<<2)+4>>2]|0,m,n,0,0)|0}while((f|0)!=0);i=d;return 0}function Xbe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;do if(!(c[f+8>>2]&2))g=f;else{if(xo[c[(c[f+532>>2]|0)+148>>2]&2047](f,b,e)|0){c[a+44>>2]=-1;g=c[a>>2]|0;break}Wbe(a,c[e>>2]|0)|0;i=d;return 0}while(0);J9d(g,b);b=c[a>>2]|0;g=c[(c[b+692>>2]|0)+2952>>2]|0;e=C9d(c[(c[b+96>>2]|0)+4>>2]|0,791048)|0;if(!((e|0)!=0&(g|0)!=0)){i=d;return 0}b=c[g>>2]|0;if(!b){i=d;return 0}g=mo[b&4095](e)|0;if(!g){i=d;return 0}e=c[(c[a>>2]|0)+692>>2]|0;b=c[a+40>>2]|0;f=c[e+1392>>2]|0;h=g+4|0;g=a+16|0;j=a+20|0;Bn[c[h>>2]&255](c[b>>2]|0,c[g>>2]|0,c[j>>2]|0,0,0)|0;a=c[e+1896>>2]|0;if(!a){i=d;return 0}k=e+1900|0;e=a;do{e=e+-1|0;a=c[(c[k+(e<<2)>>2]|0)+68>>2]|0;l=c[g>>2]|0;if((f|0)==(a|0)){m=l;n=c[j>>2]|0}else{o=I8d(l,f,a)|0;m=o;n=I8d(c[j>>2]|0,f,a)|0}Bn[c[h>>2]&255](c[b+(e<<2)+4>>2]|0,m,n,0,0)|0}while((e|0)!=0);i=d;return 0}function Ybe(a){a=a|0;c[(c[a+156>>2]|0)+36>>2]=0;return}function Zbe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=c[(c[d+692>>2]|0)+2952>>2]|0;if(!e){i=b;return 0}f=C9d(c[(c[d+96>>2]|0)+4>>2]|0,791048)|0;if(!f){i=b;return 0}d=mo[c[e+8>>2]&4095](f)|0;c[(c[a+156>>2]|0)+36>>2]=d;i=b;return 0}function _be(d,f,g,h,j){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;k=i;i=i+32|0;l=k+16|0;m=k+12|0;n=k;o=f+96|0;p=c[(c[o>>2]|0)+4>>2]|0;q=S9d(p,789856)|0;do if(q){r=T9d(c[o>>2]|0,788624)|0;s=S9d(p,791048)|0;t=Dae(d,0)|0;c[m>>2]=t;if(!t){t=Bn[c[q+4>>2]&255](d,f,g,h,j)|0;c[m>>2]=t;if(!t){if((c[f+148>>2]|0)!=1330926671){u=111;break}if((g|0)<0){v=0;i=k;return v|0}if((g|0)>0){c[m>>2]=6;break}t=f+508|0;w=kn[c[t>>2]&511](f,1751474532,d,0)|0;c[m>>2]=w;if(!w){w=Bn[c[q+8>>2]&255](d,f,0,h,j)|0;c[m>>2]=w;if(!w)x=0;else break}else{w=_n[c[q+40>>2]&4095](f,d)|0;c[m>>2]=w;if(!w)x=1;else break}w=kn[c[t>>2]&511](f,1128678944,d,0)|0;c[m>>2]=w;if(!w){y=x;z=1}else break}else{w=Dae(d,0)|0;c[m>>2]=w;if(w)break;c[m>>2]=0;y=1;z=0}w=c[f+100>>2]|0;t=Xae(w,2972,m)|0;if((c[m>>2]|0)==0?(c[f+692>>2]=t,A=Pbe(p,d,g,t,y)|0,c[m>>2]=A,(A|0)==0):0){c[t+2952>>2]=s;c[t+2956>>2]=r;c[f+4>>2]=g;s=f+16|0;c[s>>2]=c[t+12>>2];A=t+1456|0;if((c[A>>2]|0)!=65535|(r|0)!=0){r=t+1388|0;if(!(a[r>>0]|0)){if(!(y<<24>>24))B=e[f+68>>1]|0;else B=1e3;C=t+1392|0;c[C>>2]=B;D=C}else D=t+1392|0;C=t+1372|0;E=t+1396|0;F=t+1384|0;G=c[F>>2]|0;H=(G|0)<0?0-G|0:G;if((H|0)==65536){I=E;J=c[t+1400>>2]|0}else{c[D>>2]=L8d(c[D>>2]|0,H)|0;c[C>>2]=L8d(c[C>>2]|0,H)|0;G=t+1380|0;c[G>>2]=L8d(c[G>>2]|0,H)|0;G=t+1376|0;c[G>>2]=L8d(c[G>>2]|0,H)|0;c[F>>2]=L8d(c[F>>2]|0,H)|0;c[E>>2]=L8d(c[E>>2]|0,H)|0;F=t+1400|0;G=L8d(c[F>>2]|0,H)|0;c[F>>2]=G;I=E;J=G}c[I>>2]=c[I>>2]>>16;c[t+1400>>2]=J>>16;G=c[t+1896>>2]|0;if(G){F=t+1900|0;H=G;do{H=H+-1|0;G=c[F+(H<<2)>>2]|0;do if(!(a[G+64>>0]|0)){K=G+48|0;c[K+0>>2]=c[C+0>>2];c[K+4>>2]=c[C+4>>2];c[K+8>>2]=c[C+8>>2];c[K+12>>2]=c[C+12>>2];K=E;L=c[K+4>>2]|0;M=G+72|0;c[M>>2]=c[K>>2];c[M+4>>2]=L;L=G+68|0;c[L>>2]=c[D>>2];N=L}else{if(!(a[r>>0]|0)){N=G+68|0;break}L=c[D>>2]|0;M=G+68|0;if(L>>>0>1?(K=c[M>>2]|0,K>>>0>1):0)O=L>>>0<K>>>0?L:K;else O=1;M8d(C,G+48|0,O);N8d(G+72|0,C,O);c[M>>2]=I8d(c[M>>2]|0,c[D>>2]|0,O)|0;N=M}while(0);M=G+60|0;K=c[M>>2]|0;L=(K|0)<0?0-K|0:K;if((L|0)==65536){P=G+72|0;Q=c[G+76>>2]|0}else{c[N>>2]=L8d(c[N>>2]|0,L)|0;K=G+48|0;c[K>>2]=L8d(c[K>>2]|0,L)|0;K=G+56|0;c[K>>2]=L8d(c[K>>2]|0,L)|0;K=G+52|0;c[K>>2]=L8d(c[K>>2]|0,L)|0;c[M>>2]=L8d(c[M>>2]|0,L)|0;M=G+72|0;c[M>>2]=L8d(c[M>>2]|0,L)|0;K=G+76|0;R=L8d(c[K>>2]|0,L)|0;c[K>>2]=R;P=M;Q=R}c[P>>2]=c[P>>2]>>16;c[G+76>>2]=Q>>16}while((H|0)!=0)}H=y<<24>>24==0;if(!H){c[f>>2]=c[t+8>>2];if((c[A>>2]|0)==65535)S=c[t+1184>>2]|0;else S=(c[t+1168>>2]|0)+1|0;c[s>>2]=S;c[f+52>>2]=c[t+1408>>2]>>16;C=c[t+1412>>2]>>16;c[f+56>>2]=C;c[f+60>>2]=(c[t+1416>>2]|0)+65535>>16;r=(c[t+1420>>2]|0)+65535>>16;c[f+64>>2]=r;E=c[D>>2]|0;b[f+68>>1]=E;b[f+70>>1]=r;b[f+72>>1]=C;F=(((E&65535)*12|0)>>>0)/10|0;E=r-C|0;b[f+74>>1]=(F<<16>>16|0)<(E|0)?E:F;b[f+80>>1]=(c[t+1356>>2]|0)>>>16;b[f+82>>1]=(c[t+1360>>2]|0)>>>16;F=Kbe(t,g)|0;E=f+20|0;c[E>>2]=F;a:do if(!F){C=Mbe(t,c[t+1496>>2]|0)|0;if(!C)u=74;else{c[E>>2]=abe(w,C,l)|0;u=74}}else{C=Mbe(t,c[t+1336>>2]|0)|0;r=c[E>>2]|0;R=(SEi(r|0)|0)+1|0;M=r+6|0;b:do if((R|0)>6){K=r+1|0;L=r+2|0;T=r+3|0;U=r+4|0;V=r+5|0;W=1;X=R;do{if((a[M>>0]|0)!=43)break b;W=((a[U>>0]|0)+-65<<24>>24&255)<26?(((a[T>>0]|0)+-65<<24>>24&255)<26?(((a[L>>0]|0)+-65<<24>>24&255)<26?(((a[K>>0]|0)+-65<<24>>24&255)<26?(((a[r>>0]|0)+-65<<24>>24&255)<26?W:0):0):0):0):0;if(W<<24>>24==0?1:((a[V>>0]|0)+-65<<24>>24&255)>25)break b;if((X|0)>7){Y=7;do{a[r+(Y+-7)>>0]=a[r+Y>>0]|0;Y=Y+1|0}while((Y|0)!=(X|0))}X=X+-7|0}while((X|0)>6)}while(0);M=c[t+1340>>2]|0;if(!M)Z=r;else{R=Mbe(t,M)|0;Z=(R|0)==0?r:R}if((C|0)!=0&(Z|0)!=0?(R=a[C>>0]|0,R<<24>>24!=0):0){M=R;R=Z;G=C;c:while(1){X=R;while(1){V=a[X>>0]|0;if(M<<24>>24==V<<24>>24){_=X;u=57;break}if(M<<24>>24==45|M<<24>>24==32){$=X;break}if(!(V<<24>>24)){aa=G;break c}else if(!(V<<24>>24==45|V<<24>>24==32)){u=74;break a}if(!(M<<24>>24)){u=74;break a}else X=X+1|0}if((u|0)==57){u=0;$=_+1|0}G=G+1|0;M=a[G>>0]|0;if(!(M<<24>>24)){u=74;break a}else R=$}R=abe(w,aa,l)|0;M=c[E>>2]|0;G=SEi(M|0)|0;C=SEi(R|0)|0;d:do if((G|0)>(C|0)){if((C|0)>=1){r=1;do{if((a[M+(G-r)>>0]|0)!=(a[R+(C-r)>>0]|0))break d;r=r+1|0}while((C|0)>=(r|0))}r=G-C|0;X=r+-1|0;if((X|0)>0){ba=r;ca=X}else break;while(1){X=a[M+ca>>0]|0;if(!(X<<24>>24==43|X<<24>>24==95|X<<24>>24==32|X<<24>>24==45)){da=ba;break}X=ca+-1|0;if((X|0)>0){r=ca;ca=X;ba=r}else break d}a[M+da>>0]=0}while(0);if(!R){u=74;break}c[f+24>>2]=R}else u=74}while(0);if((u|0)==74)c[f+24>>2]=abe(w,726880,l)|0;E=z<<24>>24==0?2065:2073;c[f+8>>2]=(a[t+1348>>0]|0)==0?E:E|4;E=(c[t+1352>>2]|0)!=0&1;F=Mbe(t,c[t+1344>>2]|0)|0;do if(!F)ea=E;else{if((HEi(F,2390840)|0)!=0?(HEi(F,726888)|0)!=0:0){ea=E;break}ea=E|2}while(0);do if((ea&2|0)==0?(E=c[f+24>>2]|0,(E|0)!=0):0){if((IEi(E,2390840,4)|0)!=0?(IEi(E,726888,5)|0)!=0:0){fa=ea;break}fa=ea|2}else fa=ea;while(0);c[f+12>>2]=fa}E=(c[A>>2]|0)==65535;if(!E){if(!(E|H)){E=f+8|0;c[E>>2]=c[E>>2]|4096}}else{E=f+8|0;c[E>>2]=c[E>>2]|512}E=f+36|0;F=c[E>>2]|0;e:do if(!F){ga=0;ha=1;u=95}else{w=c[f+40>>2]|0;s=0;while(1){M=c[w+(s<<2)>>2]|0;C=b[M+8>>1]|0;if(!(C<<16>>16)){ia=s;break e}else if(C<<16>>16==3?(b[M+10>>1]|0)==1:0){ia=s;break e}M=s+1|0;if(M>>>0<F>>>0)s=M;else{ja=s;break}}ga=F;ha=ja+2|0;u=95}while(0);if((u|0)==95){if(H){if(ha>>>0>15)break}else if((c[A>>2]|0)!=65535|ha>>>0>15)break;c[n>>2]=f;b[n+8>>1]=3;b[n+10>>1]=1;c[n+4>>2]=1970170211;F=N9d((c[p+204>>2]|0)+96|0,0,n,0)|0;c[m>>2]=F;if(!((F|0)==0|(F|0)==163))break;c[m>>2]=0;F=f+92|0;if((c[F>>2]|0)==0?(ga|0)!=(c[E>>2]|0):0){c[F>>2]=c[(c[f+40>>2]|0)+(ga<<2)>>2];ia=ga}else ia=ga}if(ia>>>0<=15?(c[t+124>>2]|0)!=0:0){c[n>>2]=f;b[n+8>>1]=7;F=c[t+120>>2]|0;do if(F){s=n+10|0;if((F|0)==1){b[s>>1]=1;c[n+4>>2]=1094992453;ka=(c[p+204>>2]|0)+56|0;break}else{b[s>>1]=2;c[n+4>>2]=1094992451;ka=(c[p+204>>2]|0)+56|0;break}}else{b[n+10>>1]=0;c[n+4>>2]=1094995778;ka=(c[p+204>>2]|0)+56|0}while(0);c[m>>2]=N9d(ka,0,n,0)|0}}else u=111}}}else u=111;while(0);if((u|0)==111)c[m>>2]=2;v=c[m>>2]|0;i=k;return v|0}function $be(a){a=a|0;var b=0,d=0,e=0;b=i;if(!a){i=b;return}d=c[a+100>>2]|0;e=c[a+532>>2]|0;if(e)ko[c[e+12>>2]&4095](a);e=a+692|0;a=c[e>>2]|0;if(!a){i=b;return}Qbe(a);$ae(d,c[e>>2]|0);c[e>>2]=0;i=b;return}function ace(a){a=a|0;return 0}function bce(a){a=a|0;return}function cce(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;PEi(e|0,0,196)|0;g=a[d+176>>0]|0;a[e+8>>0]=g;if(g<<24>>24){h=g&255;g=0;do{b[e+(g<<1)+12>>1]=c[d+(g<<2)+180>>2];g=g+1|0}while((g|0)!=(h|0))}h=a[d+177>>0]|0;a[e+9>>0]=h;if(h<<24>>24){g=h&255;h=0;do{b[e+(h<<1)+40>>1]=c[d+(h<<2)+236>>2];h=h+1|0}while((h|0)!=(g|0))}g=a[d+178>>0]|0;a[e+10>>0]=g;if(g<<24>>24){h=g&255;g=0;do{b[e+(g<<1)+60>>1]=c[d+(g<<2)+276>>2];g=g+1|0}while((g|0)!=(h|0))}h=a[d+179>>0]|0;a[e+11>>0]=h;if(h<<24>>24){g=h&255;h=0;do{b[e+(h<<1)+88>>1]=c[d+(h<<2)+332>>2];h=h+1|0}while((h|0)!=(g|0))}c[e+108>>2]=c[d+372>>2];c[e+112>>2]=c[d+376>>2];c[e+116>>2]=c[d+380>>2];b[e+120>>1]=c[d+384>>2];b[e+122>>1]=c[d+388>>2];g=a[d+392>>0]|0;a[e+124>>0]=g;if(g<<24>>24){h=g&255;g=0;do{b[e+(g<<1)+128>>1]=c[d+(g<<2)+396>>2];g=g+1|0}while((g|0)!=(h|0))}h=a[d+393>>0]|0;a[e+125>>0]=h;if(!(h<<24>>24)){j=d+500|0;k=a[j>>0]|0;l=e+126|0;a[l>>0]=k;m=d+512|0;n=c[m>>2]|0;o=e+184|0;c[o>>2]=n;p=d+508|0;q=c[p>>2]|0;r=e+4|0;c[r>>2]=q;i=f;return}g=h&255;h=0;do{b[e+(h<<1)+154>>1]=c[d+(h<<2)+448>>2];h=h+1|0}while((h|0)!=(g|0));j=d+500|0;k=a[j>>0]|0;l=e+126|0;a[l>>0]=k;m=d+512|0;n=c[m>>2]|0;o=e+184|0;c[o>>2]=n;p=d+508|0;q=c[p>>2]|0;r=e+4|0;c[r>>2]=q;i=f;return}function dce(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;PEi(a|0,0,412)|0;c[a+404>>2]=a+16;c[a+408>>2]=b;c[a+412>>2]=d;c[a>>2]=e;i=f;return}function ece(a,b){a=a|0;b=b|0;var d=0;d=i;if(b)$ae(c[a>>2]|0,b);i=d;return}function fce(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=Xae(c[b>>2]|0,1456,f)|0;b=c[f>>2]|0;if(b){h=b;i=e;return h|0}c[g>>2]=4;c[g+4>>2]=4096;c[g+8>>2]=0;a[g+12>>0]=4;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;c[g+28>>2]=4;c[g+32>>2]=4097;c[g+36>>2]=4;a[g+40>>0]=4;c[g+44>>2]=0;c[g+48>>2]=0;c[g+52>>2]=0;c[g+56>>2]=4;c[g+60>>2]=4352;c[g+64>>2]=8;a[g+68>>0]=4;c[g+72>>2]=0;c[g+76>>2]=0;c[g+80>>2]=0;c[g+84>>2]=4;c[g+88>>2]=4098;c[g+92>>2]=12;a[g+96>>0]=4;c[g+100>>2]=0;c[g+104>>2]=0;c[g+108>>2]=0;c[g+112>>2]=4;c[g+116>>2]=4099;c[g+120>>2]=16;a[g+124>>0]=4;c[g+128>>2]=0;c[g+132>>2]=0;c[g+136>>2]=0;c[g+140>>2]=4;c[g+144>>2]=4100;c[g+148>>2]=20;a[g+152>>0]=4;c[g+156>>2]=0;c[g+160>>2]=0;c[g+164>>2]=0;c[g+168>>2]=5;c[g+172>>2]=4353;c[g+176>>2]=24;a[g+180>>0]=1;c[g+184>>2]=0;c[g+188>>2]=0;c[g+192>>2]=0;c[g+196>>2]=2;c[g+200>>2]=4354;c[g+204>>2]=28;a[g+208>>0]=4;c[g+212>>2]=0;c[g+216>>2]=0;c[g+220>>2]=0;c[g+224>>2]=2;c[g+228>>2]=4355;c[g+232>>2]=32;a[g+236>>0]=4;c[g+240>>2]=0;c[g+244>>2]=0;c[g+248>>2]=0;c[g+252>>2]=2;c[g+256>>2]=4356;c[g+260>>2]=36;a[g+264>>0]=4;c[g+268>>2]=0;c[g+272>>2]=0;c[g+276>>2]=0;c[g+280>>2]=1;c[g+284>>2]=4357;c[g+288>>2]=40;a[g+292>>0]=4;c[g+296>>2]=0;c[g+300>>2]=0;c[g+304>>2]=0;c[g+308>>2]=1;c[g+312>>2]=4358;c[g+316>>2]=44;a[g+320>>0]=4;c[g+324>>2]=0;c[g+328>>2]=0;c[g+332>>2]=0;c[g+336>>2]=7;c[g+340>>2]=4359;c[g+344>>2]=0;a[g+348>>0]=0;c[g+352>>2]=3611;c[g+356>>2]=0;c[g+360>>2]=0;c[g+364>>2]=1;c[g+368>>2]=4109;c[g+372>>2]=80;a[g+376>>0]=4;c[g+380>>2]=0;c[g+384>>2]=0;c[g+388>>2]=0;c[g+392>>2]=7;c[g+396>>2]=4101;c[g+400>>2]=0;a[g+404>>0]=0;c[g+408>>2]=3612;c[g+412>>2]=0;c[g+416>>2]=0;c[g+420>>2]=1;c[g+424>>2]=4360;c[g+428>>2]=100;a[g+432>>0]=4;c[g+436>>2]=0;c[g+440>>2]=0;c[g+444>>2]=0;c[g+448>>2]=1;c[g+452>>2]=4111;c[g+456>>2]=104;a[g+460>>0]=4;c[g+464>>2]=0;c[g+468>>2]=0;c[g+472>>2]=0;c[g+476>>2]=1;c[g+480>>2]=4112;c[g+484>>2]=108;a[g+488>>0]=4;c[g+492>>2]=0;c[g+496>>2]=0;c[g+500>>2]=0;c[g+504>>2]=1;c[g+508>>2]=4113;c[g+512>>2]=112;a[g+516>>0]=4;c[g+520>>2]=0;c[g+524>>2]=0;c[g+528>>2]=0;c[g+532>>2]=7;c[g+536>>2]=4114;c[g+540>>2]=0;a[g+544>>0]=0;c[g+548>>2]=3613;c[g+552>>2]=0;c[g+556>>2]=0;c[g+560>>2]=1;c[g+564>>2]=4372;c[g+568>>2]=124;a[g+572>>0]=4;c[g+576>>2]=0;c[g+580>>2]=0;c[g+584>>2]=0;c[g+588>>2]=4;c[g+592>>2]=4373;c[g+596>>2]=128;a[g+600>>0]=4;c[g+604>>2]=0;c[g+608>>2]=0;c[g+612>>2]=0;c[g+616>>2]=7;c[g+620>>2]=4382;c[g+624>>2]=0;a[g+628>>0]=0;c[g+632>>2]=3614;c[g+636>>2]=0;c[g+640>>2]=0;c[g+644>>2]=1;c[g+648>>2]=4383;c[g+652>>2]=144;a[g+656>>0]=4;c[g+660>>2]=0;c[g+664>>2]=0;c[g+668>>2]=0;c[g+672>>2]=1;c[g+676>>2]=4384;c[g+680>>2]=148;a[g+684>>0]=4;c[g+688>>2]=0;c[g+692>>2]=0;c[g+696>>2]=0;c[g+700>>2]=1;c[g+704>>2]=4385;c[g+708>>2]=152;a[g+712>>0]=4;c[g+716>>2]=0;c[g+720>>2]=0;c[g+724>>2]=0;c[g+728>>2]=1;c[g+732>>2]=4386;c[g+736>>2]=156;a[g+740>>0]=4;c[g+744>>2]=0;c[g+748>>2]=0;c[g+752>>2]=0;c[g+756>>2]=1;c[g+760>>2]=4387;c[g+764>>2]=160;a[g+768>>0]=4;c[g+772>>2]=0;c[g+776>>2]=0;c[g+780>>2]=0;c[g+784>>2]=1;c[g+788>>2]=4388;c[g+792>>2]=164;a[g+796>>0]=4;c[g+800>>2]=0;c[g+804>>2]=0;c[g+808>>2]=0;c[g+812>>2]=1;c[g+816>>2]=4389;c[g+820>>2]=168;a[g+824>>0]=4;c[g+828>>2]=0;c[g+832>>2]=0;c[g+836>>2]=0;c[g+840>>2]=4;c[g+844>>2]=4390;c[g+848>>2]=172;a[g+852>>0]=4;c[g+856>>2]=0;c[g+860>>2]=0;c[g+864>>2]=0;c[g+868>>2]=6;c[g+872>>2]=8198;c[g+876>>2]=4;a[g+880>>0]=4;c[g+884>>2]=0;c[g+888>>2]=14;c[g+892>>2]=0;c[g+896>>2]=6;c[g+900>>2]=8199;c[g+904>>2]=60;a[g+908>>0]=4;c[g+912>>2]=0;c[g+916>>2]=10;c[g+920>>2]=1;c[g+924>>2]=6;c[g+928>>2]=8200;c[g+932>>2]=100;a[g+936>>0]=4;c[g+940>>2]=0;c[g+944>>2]=14;c[g+948>>2]=2;c[g+952>>2]=6;c[g+956>>2]=8201;c[g+960>>2]=156;a[g+964>>0]=4;c[g+968>>2]=0;c[g+972>>2]=10;c[g+976>>2]=3;c[g+980>>2]=3;c[g+984>>2]=8457;c[g+988>>2]=196;a[g+992>>0]=4;c[g+996>>2]=0;c[g+1e3>>2]=0;c[g+1004>>2]=0;c[g+1008>>2]=1;c[g+1012>>2]=8458;c[g+1016>>2]=200;a[g+1020>>0]=4;c[g+1024>>2]=0;c[g+1028>>2]=0;c[g+1032>>2]=0;c[g+1036>>2]=1;c[g+1040>>2]=8459;c[g+1044>>2]=204;a[g+1048>>0]=4;c[g+1052>>2]=0;c[g+1056>>2]=0;c[g+1060>>2]=0;c[g+1064>>2]=1;c[g+1068>>2]=8202;c[g+1072>>2]=208;a[g+1076>>0]=4;c[g+1080>>2]=0;c[g+1084>>2]=0;c[g+1088>>2]=0;c[g+1092>>2]=1;c[g+1096>>2]=8203;c[g+1100>>2]=212;a[g+1104>>0]=4;c[g+1108>>2]=0;c[g+1112>>2]=0;c[g+1116>>2]=0;c[g+1120>>2]=6;c[g+1124>>2]=8460;c[g+1128>>2]=220;a[g+1132>>0]=4;c[g+1136>>2]=0;c[g+1140>>2]=13;c[g+1144>>2]=216;c[g+1148>>2]=6;c[g+1152>>2]=8461;c[g+1156>>2]=272;a[g+1160>>0]=4;c[g+1164>>2]=0;c[g+1168>>2]=13;c[g+1172>>2]=217;c[g+1176>>2]=5;c[g+1180>>2]=8462;c[g+1184>>2]=324;a[g+1188>>0]=1;c[g+1192>>2]=0;c[g+1196>>2]=0;c[g+1200>>2]=0;c[g+1204>>2]=2;c[g+1208>>2]=8463;c[g+1212>>2]=328;a[g+1216>>0]=4;c[g+1220>>2]=0;c[g+1224>>2]=0;c[g+1228>>2]=0;c[g+1232>>2]=1;c[g+1236>>2]=8464;c[g+1240>>2]=332;a[g+1244>>0]=4;c[g+1248>>2]=0;c[g+1252>>2]=0;c[g+1256>>2]=0;c[g+1260>>2]=1;c[g+1264>>2]=8465;c[g+1268>>2]=336;a[g+1272>>0]=4;c[g+1276>>2]=0;c[g+1280>>2]=0;c[g+1284>>2]=0;c[g+1288>>2]=2;c[g+1292>>2]=8466;c[g+1296>>2]=340;a[g+1300>>0]=4;c[g+1304>>2]=0;c[g+1308>>2]=0;c[g+1312>>2]=0;c[g+1316>>2]=1;c[g+1320>>2]=8467;c[g+1324>>2]=344;a[g+1328>>0]=4;c[g+1332>>2]=0;c[g+1336>>2]=0;c[g+1340>>2]=0;c[g+1344>>2]=1;c[g+1348>>2]=8211;c[g+1352>>2]=348;a[g+1356>>0]=4;c[g+1360>>2]=0;c[g+1364>>2]=0;c[g+1368>>2]=0;c[g+1372>>2]=1;c[g+1376>>2]=8212;c[g+1380>>2]=352;a[g+1384>>0]=4;c[g+1388>>2]=0;c[g+1392>>2]=0;c[g+1396>>2]=0;c[g+1400>>2]=1;c[g+1404>>2]=8213;c[g+1408>>2]=356;a[g+1412>>0]=4;b=g+1416|0;c[g+1444>>2]=0;c[g+1448>>2]=0;c[g+1452>>2]=0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;a[b+24>>0]=0;c[d>>2]=g;h=0;i=e;return h|0}function gce(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=i;j=c[e>>2]|0;k=e+16|0;l=e+404|0;c[l>>2]=k;c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=f;if(f>>>0>=g>>>0){m=0;i=h;return m|0}n=k;o=e+408|0;p=j+204|0;j=e+412|0;q=e+20|0;r=k;s=f;a:while(1){f=a[s>>0]|0;t=r-n|0;u=t>>2;do if((f&255)>26&f<<24>>24!=31){if((t|0)>380){m=6;v=94;break a}c[l>>2]=r+4;c[r>>2]=s;if(f<<24>>24==28){w=s+2|0;break}else if(f<<24>>24==30){x=s;while(1){y=x+1|0;if(y>>>0>=g>>>0){m=0;v=94;break a}z=d[y>>0]|0;if((z&240|0)==240|(z&15|0)==15){w=y;break}else x=y}}else if(f<<24>>24==29){w=s+4|0;break}else{w=(f&255)>246?s+1|0:s;break}}else{x=f&255;c[r>>2]=s;if(f<<24>>24==12){y=s+1|0;if(y>>>0>=g>>>0){m=6;v=94;break a}A=d[y>>0]|0|256;B=y}else{A=x;B=s}x=c[o>>2]|A;y=c[(c[p>>2]|0)+4>>2]|0;z=c[y>>2]|0;b:do if(z){C=z;D=y;while(1){if((c[D+4>>2]|0)==(x|0)){E=C;F=D;break}D=D+28|0;C=c[D>>2]|0;if(!C)break b}C=c[j>>2]|0;D=C+(c[F+8>>2]|0)|0;if((E|0)!=6&(u|0)==0){m=6;v=94;break a}c:do switch(E|0){case 2:{G=c[k>>2]|0;H=c[q>>2]|0;I=a[G>>0]|0;if(I<<24>>24==30){J=lce(G,H,0,0)|0;break c}K=G+1|0;L=I&255;do if(I<<24>>24==28)if((G+3|0)>>>0>H>>>0)M=0;else M=((d[K>>0]|0)<<8|(d[G+2>>0]|0))<<16>>16;else if(I<<24>>24==29)if((G+5|0)>>>0>H>>>0)M=0;else M=(d[G+2>>0]|0)<<16|(d[K>>0]|0)<<24|(d[G+3>>0]|0)<<8|(d[G+4>>0]|0);else{if((I&255)<247){M=L+-139|0;break}N=(G+2|0)>>>0>H>>>0;if((I&255)<251){if(N){M=0;break}M=(d[K>>0]|0|(L<<8)+-63232)+108|0;break}else{if(N){M=0;break}M=(251-L<<8)+-108-(d[K>>0]|0)|0;break}}while(0);J=M<<16;break}case 6:{K=c[F+20>>2]|0;L=u>>>0>K>>>0?K:u;a[C+(c[F+24>>2]|0)>>0]=L;if(!L)break b;K=F+12|0;I=k;H=L;L=D;G=0;while(1){N=c[I>>2]|0;I=I+4|0;O=c[I>>2]|0;P=a[N>>0]|0;do if(P<<24>>24!=30){Q=N+1|0;R=P&255;if(P<<24>>24==28){if((N+3|0)>>>0>O>>>0){S=0;break}S=((d[Q>>0]|0)<<8|(d[N+2>>0]|0))<<16>>16;break}else if(P<<24>>24!=29){if((P&255)<247){S=R+-139|0;break}T=(N+2|0)>>>0>O>>>0;if((P&255)<251){if(T){S=0;break}S=(d[Q>>0]|0|(R<<8)+-63232)+108|0;break}else{if(T){S=0;break}S=(251-R<<8)+-108-(d[Q>>0]|0)|0;break}}else{if((N+5|0)>>>0>O>>>0){S=0;break}S=(d[N+2>>0]|0)<<16|(d[Q>>0]|0)<<24|(d[N+3>>0]|0)<<8|(d[N+4>>0]|0);break}}else S=(lce(N,O,0,0)|0)>>16;while(0);G=S+G|0;O=a[K>>0]|0;N=O&255;if((N|0)==2){b[L>>1]=G;U=O}else if((N|0)==4){c[L>>2]=G;U=O}else if((N|0)==1){a[L>>0]=G;U=a[K>>0]|0}else{c[L>>2]=G;U=O}H=H+-1|0;if(!H)break b;else L=L+(U&255)|0}break}case 1:case 4:case 5:{L=c[k>>2]|0;H=c[q>>2]|0;G=a[L>>0]|0;if(G<<24>>24==30){J=(lce(L,H,0,0)|0)>>16;break c}K=L+1|0;I=G&255;if(G<<24>>24==28){if((L+3|0)>>>0>H>>>0){J=0;break c}J=((d[K>>0]|0)<<8|(d[L+2>>0]|0))<<16>>16;break c}else if(G<<24>>24!=29){if((G&255)<247){J=I+-139|0;break c}O=(L+2|0)>>>0>H>>>0;if((G&255)<251){if(O){J=0;break c}J=(d[K>>0]|0|(I<<8)+-63232)+108|0;break c}else{if(O){J=0;break c}J=(251-I<<8)+-108-(d[K>>0]|0)|0;break c}}else{if((L+5|0)>>>0>H>>>0){J=0;break c}J=(d[L+2>>0]|0)<<16|(d[K>>0]|0)<<24|(d[L+3>>0]|0)<<8|(d[L+4>>0]|0);break c}break}case 3:{L=c[k>>2]|0;K=c[q>>2]|0;H=a[L>>0]|0;if(H<<24>>24==30){J=lce(L,K,3,0)|0;break c}I=L+1|0;O=H&255;do if(H<<24>>24==29)if((L+5|0)>>>0>K>>>0)V=0;else V=(d[L+2>>0]|0)<<16|(d[I>>0]|0)<<24|(d[L+3>>0]|0)<<8|(d[L+4>>0]|0);else if(H<<24>>24==28)if((L+3|0)>>>0>K>>>0)V=0;else V=((d[I>>0]|0)<<8|(d[L+2>>0]|0))<<16>>16;else{if((H&255)<247){V=O+-139|0;break}G=(L+2|0)>>>0>K>>>0;if((H&255)<251){if(G){V=0;break}V=(d[I>>0]|0|(O<<8)+-63232)+108|0;break}else{if(G){V=0;break}V=(251-O<<8)+-108-(d[I>>0]|0)|0;break}}while(0);J=da(V,65536e3)|0;break}default:{I=mo[c[F+16>>2]&4095](e)|0;if(!I)break b;else{m=I;v=94;break a}}}while(0);C=d[F+12>>0]|0;if((C|0)==2){b[D>>1]=J;break}else if((C|0)==4){c[D>>2]=J;break}else if((C|0)==1){a[D>>0]=J;break}else{c[D>>2]=J;break}}while(0);c[l>>2]=k;w=B}while(0);u=w+1|0;if(u>>>0>=g>>>0){m=0;v=94;break}r=c[l>>2]|0;s=u}if((v|0)==94){i=h;return m|0}return 0}function hce(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=i;i=i+16|0;f=e;g=c[b+412>>2]|0;h=g+72|0;j=g+68|0;k=b+40|0;if((c[b+404>>2]|0)>>>0<k>>>0){l=161;i=e;return l|0}m=g+48|0;a[g+64>>0]=1;n=c[b+16>>2]|0;o=b+20|0;p=c[o>>2]|0;q=a[n>>0]|0;do if(q<<24>>24==30)r=lce(n,p,0,f)|0;else{s=n+1|0;t=q&255;do if(q<<24>>24==29)if((n+5|0)>>>0>p>>>0)u=0;else{v=(d[n+2>>0]|0)<<16|(d[s>>0]|0)<<24|(d[n+3>>0]|0)<<8|(d[n+4>>0]|0);w=16}else if(q<<24>>24==28)if((n+3|0)>>>0>p>>>0)u=0;else u=((d[s>>0]|0)<<8|(d[n+2>>0]|0))<<16>>16;else{if((q&255)<247){v=t+-139|0;w=16;break}x=(n+2|0)>>>0>p>>>0;if((q&255)<251){if(x){u=0;break}v=(d[s>>0]|0|(t<<8)+-63232)+108|0;w=16;break}else{if(x){u=0;break}v=(251-t<<8)+-108-(d[s>>0]|0)|0;w=16;break}}while(0);if((w|0)==16)if((v|0)>32767){s=5;while(1){t=s+1|0;if((v|0)<(c[726896+(s<<2)>>2]|0)){y=s;break}if((t|0)<10)s=t;else{y=t;break}}s=y+-5|0;t=c[726896+(s<<2)>>2]|0;if(((v|0)/(t|0)|0|0)>32767){x=y+-4|0;c[f>>2]=x;r=L8d(v,c[726896+(x<<2)>>2]|0)|0;break}else{c[f>>2]=s;r=L8d(v,t)|0;break}}else u=v;c[f>>2]=0;r=u<<16}while(0);c[m>>2]=r;r=c[f>>2]|0;u=0-r|0;c[f>>2]=u;if((r+9|0)>>>0>9){c[m>>2]=65536;c[g+56>>2]=0;c[g+52>>2]=0;c[g+60>>2]=65536;c[h>>2]=0;c[g+76>>2]=0;c[j>>2]=1;l=0;i=e;return l|0}m=b+24|0;r=c[o>>2]|0;o=c[m>>2]|0;v=a[r>>0]|0;if(v<<24>>24==30){y=lce(r,o,u,0)|0;z=c[m>>2]|0;A=y}else{y=r+1|0;m=v&255;do if(v<<24>>24==29)if((r+5|0)>>>0>o>>>0)B=0;else B=(d[r+2>>0]|0)<<16|(d[y>>0]|0)<<24|(d[r+3>>0]|0)<<8|(d[r+4>>0]|0);else if(v<<24>>24==28)if((r+3|0)>>>0>o>>>0)B=0;else B=((d[y>>0]|0)<<8|(d[r+2>>0]|0))<<16>>16;else{if((v&255)<247){B=m+-139|0;break}w=(r+2|0)>>>0>o>>>0;if((v&255)<251){if(w){B=0;break}B=(d[y>>0]|0|(m<<8)+-63232)+108|0;break}else{if(w){B=0;break}B=(251-m<<8)+-108-(d[y>>0]|0)|0;break}}while(0);z=o;A=da(B<<16,c[726896+(u<<2)>>2]|0)|0}c[g+56>>2]=A;A=b+28|0;u=c[f>>2]|0;B=c[A>>2]|0;o=a[z>>0]|0;if(o<<24>>24==30){y=lce(z,B,u,0)|0;C=c[A>>2]|0;D=y}else{y=z+1|0;A=o&255;do if(o<<24>>24==28)if((z+3|0)>>>0>B>>>0)E=0;else E=((d[y>>0]|0)<<8|(d[z+2>>0]|0))<<16>>16;else if(o<<24>>24==29)if((z+5|0)>>>0>B>>>0)E=0;else E=(d[z+2>>0]|0)<<16|(d[y>>0]|0)<<24|(d[z+3>>0]|0)<<8|(d[z+4>>0]|0);else{if((o&255)<247){E=A+-139|0;break}m=(z+2|0)>>>0>B>>>0;if((o&255)<251){if(m){E=0;break}E=(d[y>>0]|0|(A<<8)+-63232)+108|0;break}else{if(m){E=0;break}E=(251-A<<8)+-108-(d[y>>0]|0)|0;break}}while(0);C=B;D=da(E<<16,c[726896+(u<<2)>>2]|0)|0}c[g+52>>2]=D;D=b+32|0;u=c[f>>2]|0;E=c[D>>2]|0;B=a[C>>0]|0;if(B<<24>>24==30){y=lce(C,E,u,0)|0;F=c[D>>2]|0;G=y}else{y=C+1|0;D=B&255;do if(B<<24>>24==29)if((C+5|0)>>>0>E>>>0)H=0;else H=(d[C+2>>0]|0)<<16|(d[y>>0]|0)<<24|(d[C+3>>0]|0)<<8|(d[C+4>>0]|0);else if(B<<24>>24==28)if((C+3|0)>>>0>E>>>0)H=0;else H=((d[y>>0]|0)<<8|(d[C+2>>0]|0))<<16>>16;else{if((B&255)<247){H=D+-139|0;break}A=(C+2|0)>>>0>E>>>0;if((B&255)<251){if(A){H=0;break}H=(d[y>>0]|0|(D<<8)+-63232)+108|0;break}else{if(A){H=0;break}H=(251-D<<8)+-108-(d[y>>0]|0)|0;break}}while(0);F=E;G=da(H<<16,c[726896+(u<<2)>>2]|0)|0}c[g+60>>2]=G;G=b+36|0;b=c[f>>2]|0;u=c[G>>2]|0;H=a[F>>0]|0;if(H<<24>>24==30){E=lce(F,u,b,0)|0;I=c[G>>2]|0;J=E}else{E=F+1|0;G=H&255;do if(H<<24>>24==29)if((F+5|0)>>>0>u>>>0)K=0;else K=(d[F+2>>0]|0)<<16|(d[E>>0]|0)<<24|(d[F+3>>0]|0)<<8|(d[F+4>>0]|0);else if(H<<24>>24==28)if((F+3|0)>>>0>u>>>0)K=0;else K=((d[E>>0]|0)<<8|(d[F+2>>0]|0))<<16>>16;else{if((H&255)<247){K=G+-139|0;break}y=(F+2|0)>>>0>u>>>0;if((H&255)<251){if(y){K=0;break}K=(d[E>>0]|0|(G<<8)+-63232)+108|0;break}else{if(y){K=0;break}K=(251-G<<8)+-108-(d[E>>0]|0)|0;break}}while(0);I=u;J=da(K<<16,c[726896+(b<<2)>>2]|0)|0}c[h>>2]=J;J=c[f>>2]|0;h=c[k>>2]|0;k=a[I>>0]|0;if(k<<24>>24==30)L=lce(I,h,J,0)|0;else{b=I+1|0;K=k&255;do if(k<<24>>24==28)if((I+3|0)>>>0>h>>>0)M=0;else M=((d[b>>0]|0)<<8|(d[I+2>>0]|0))<<16>>16;else if(k<<24>>24==29)if((I+5|0)>>>0>h>>>0)M=0;else M=(d[I+2>>0]|0)<<16|(d[b>>0]|0)<<24|(d[I+3>>0]|0)<<8|(d[I+4>>0]|0);else{if((k&255)<247){M=K+-139|0;break}u=(I+2|0)>>>0>h>>>0;if((k&255)<251){if(u){M=0;break}M=(d[b>>0]|0|(K<<8)+-63232)+108|0;break}else{if(u){M=0;break}M=(251-K<<8)+-108-(d[b>>0]|0)|0;break}}while(0);L=da(M<<16,c[726896+(J<<2)>>2]|0)|0}c[g+76>>2]=L;c[j>>2]=c[726896+(c[f>>2]<<2)>>2];l=0;i=e;return l|0}function ice(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[b+412>>2]|0;g=b+32|0;if((c[b+404>>2]|0)>>>0<g>>>0){h=161;i=e;return h|0}j=f+84|0;k=b+20|0;l=c[b+16>>2]|0;m=c[k>>2]|0;n=a[l>>0]|0;if(n<<24>>24==30)o=lce(l,m,0,0)|0;else{p=l+1|0;q=n&255;do if(n<<24>>24==29)if((l+5|0)>>>0>m>>>0)r=0;else r=(d[l+2>>0]|0)<<16|(d[p>>0]|0)<<24|(d[l+3>>0]|0)<<8|(d[l+4>>0]|0);else if(n<<24>>24==28)if((l+3|0)>>>0>m>>>0)r=0;else r=((d[p>>0]|0)<<8|(d[l+2>>0]|0))<<16>>16;else{if((n&255)<247){r=q+-139|0;break}s=(l+2|0)>>>0>m>>>0;if((n&255)<251){if(s){r=0;break}r=(d[p>>0]|0|(q<<8)+-63232)+108|0;break}else{if(s){r=0;break}r=(251-q<<8)+-108-(d[p>>0]|0)|0;break}}while(0);o=r<<16}c[j>>2]=H8d(o)|0;o=b+24|0;j=c[k>>2]|0;k=c[o>>2]|0;r=a[j>>0]|0;if(r<<24>>24==30)t=lce(j,k,0,0)|0;else{p=j+1|0;q=r&255;do if(r<<24>>24==28)if((j+3|0)>>>0>k>>>0)u=0;else u=((d[p>>0]|0)<<8|(d[j+2>>0]|0))<<16>>16;else if(r<<24>>24==29)if((j+5|0)>>>0>k>>>0)u=0;else u=(d[j+2>>0]|0)<<16|(d[p>>0]|0)<<24|(d[j+3>>0]|0)<<8|(d[j+4>>0]|0);else{if((r&255)<247){u=q+-139|0;break}n=(j+2|0)>>>0>k>>>0;if((r&255)<251){if(n){u=0;break}u=(d[p>>0]|0|(q<<8)+-63232)+108|0;break}else{if(n){u=0;break}u=(251-q<<8)+-108-(d[p>>0]|0)|0;break}}while(0);t=u<<16}c[f+88>>2]=H8d(t)|0;t=b+28|0;b=c[o>>2]|0;o=c[t>>2]|0;u=a[b>>0]|0;if(u<<24>>24==30)v=lce(b,o,0,0)|0;else{p=b+1|0;q=u&255;do if(u<<24>>24==29)if((b+5|0)>>>0>o>>>0)w=0;else w=(d[b+2>>0]|0)<<16|(d[p>>0]|0)<<24|(d[b+3>>0]|0)<<8|(d[b+4>>0]|0);else if(u<<24>>24==28)if((b+3|0)>>>0>o>>>0)w=0;else w=((d[p>>0]|0)<<8|(d[b+2>>0]|0))<<16>>16;else{if((u&255)<247){w=q+-139|0;break}r=(b+2|0)>>>0>o>>>0;if((u&255)<251){if(r){w=0;break}w=(d[p>>0]|0|(q<<8)+-63232)+108|0;break}else{if(r){w=0;break}w=(251-q<<8)+-108-(d[p>>0]|0)|0;break}}while(0);v=w<<16}c[f+92>>2]=H8d(v)|0;v=c[t>>2]|0;t=c[g>>2]|0;g=a[v>>0]|0;if(g<<24>>24==30)x=lce(v,t,0,0)|0;else{w=v+1|0;p=g&255;do if(g<<24>>24==29)if((v+5|0)>>>0>t>>>0)y=0;else y=(d[v+2>>0]|0)<<16|(d[w>>0]|0)<<24|(d[v+3>>0]|0)<<8|(d[v+4>>0]|0);else if(g<<24>>24==28)if((v+3|0)>>>0>t>>>0)y=0;else y=((d[w>>0]|0)<<8|(d[v+2>>0]|0))<<16>>16;else{if((g&255)<247){y=p+-139|0;break}q=(v+2|0)>>>0>t>>>0;if((g&255)<251){if(q){y=0;break}y=(d[w>>0]|0|(p<<8)+-63232)+108|0;break}else{if(q){y=0;break}y=(251-p<<8)+-108-(d[w>>0]|0)|0;break}}while(0);x=y<<16}c[f+96>>2]=H8d(x)|0;h=0;i=e;return h|0}function jce(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=c[b+412>>2]|0;g=b+24|0;if((c[b+404>>2]|0)>>>0<g>>>0){h=161;i=e;return h|0}j=b+20|0;k=c[b+16>>2]|0;b=c[j>>2]|0;l=a[k>>0]|0;do if(l<<24>>24!=30){m=k+1|0;n=l&255;if(l<<24>>24==29){if((k+5|0)>>>0>b>>>0){o=b;p=0;break}o=b;p=(d[k+2>>0]|0)<<16|(d[m>>0]|0)<<24|(d[k+3>>0]|0)<<8|(d[k+4>>0]|0);break}else if(l<<24>>24!=28){if((l&255)<247){o=b;p=n+-139|0;break}q=(k+2|0)>>>0>b>>>0;if((l&255)<251){if(q){o=b;p=0;break}o=b;p=(d[m>>0]|0|(n<<8)+-63232)+108|0;break}else{if(q){o=b;p=0;break}o=b;p=(251-n<<8)+-108-(d[m>>0]|0)|0;break}}else{if((k+3|0)>>>0>b>>>0){o=b;p=0;break}o=b;p=((d[m>>0]|0)<<8|(d[k+2>>0]|0))<<16>>16;break}}else{m=(lce(k,b,0,0)|0)>>16;o=c[j>>2]|0;p=m}while(0);c[f+120>>2]=p;p=c[g>>2]|0;g=a[o>>0]|0;do if(g<<24>>24!=30){j=o+1|0;b=g&255;if(g<<24>>24==29){if((o+5|0)>>>0>p>>>0){r=0;break}r=(d[o+2>>0]|0)<<16|(d[j>>0]|0)<<24|(d[o+3>>0]|0)<<8|(d[o+4>>0]|0);break}else if(g<<24>>24!=28){if((g&255)<247){r=b+-139|0;break}k=(o+2|0)>>>0>p>>>0;if((g&255)<251){if(k){r=0;break}r=(d[j>>0]|0|(b<<8)+-63232)+108|0;break}else{if(k){r=0;break}r=(251-b<<8)+-108-(d[j>>0]|0)|0;break}}else{if((o+3|0)>>>0>p>>>0){r=0;break}r=((d[j>>0]|0)<<8|(d[o+2>>0]|0))<<16>>16;break}}else r=(lce(o,p,0,0)|0)>>16;while(0);c[f+116>>2]=r;h=0;i=e;return h|0}function kce(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=c[b+412>>2]|0;g=b+28|0;if((c[b+404>>2]|0)>>>0<g>>>0){h=161;i=e;return h|0}j=b+20|0;k=c[b+16>>2]|0;l=c[j>>2]|0;m=a[k>>0]|0;do if(m<<24>>24!=30){n=k+1|0;o=m&255;if(m<<24>>24==28){if((k+3|0)>>>0>l>>>0){p=l;q=0;break}p=l;q=((d[n>>0]|0)<<8|(d[k+2>>0]|0))<<16>>16;break}else if(m<<24>>24!=29){if((m&255)<247){p=l;q=o+-139|0;break}r=(k+2|0)>>>0>l>>>0;if((m&255)<251){if(r){p=l;q=0;break}p=l;q=(d[n>>0]|0|(o<<8)+-63232)+108|0;break}else{if(r){p=l;q=0;break}p=l;q=(251-o<<8)+-108-(d[n>>0]|0)|0;break}}else{if((k+5|0)>>>0>l>>>0){p=l;q=0;break}p=l;q=(d[k+2>>0]|0)<<16|(d[n>>0]|0)<<24|(d[k+3>>0]|0)<<8|(d[k+4>>0]|0);break}}else{n=(lce(k,l,0,0)|0)>>16;p=c[j>>2]|0;q=n}while(0);c[f+132>>2]=q;q=b+24|0;b=c[q>>2]|0;j=a[p>>0]|0;do if(j<<24>>24!=30){l=p+1|0;k=j&255;if(j<<24>>24==29){if((p+5|0)>>>0>b>>>0){s=b;t=0;break}s=b;t=(d[p+2>>0]|0)<<16|(d[l>>0]|0)<<24|(d[p+3>>0]|0)<<8|(d[p+4>>0]|0);break}else if(j<<24>>24!=28){if((j&255)<247){s=b;t=k+-139|0;break}m=(p+2|0)>>>0>b>>>0;if((j&255)<251){if(m){s=b;t=0;break}s=b;t=(d[l>>0]|0|(k<<8)+-63232)+108|0;break}else{if(m){s=b;t=0;break}s=b;t=(251-k<<8)+-108-(d[l>>0]|0)|0;break}}else{if((p+3|0)>>>0>b>>>0){s=b;t=0;break}s=b;t=((d[l>>0]|0)<<8|(d[p+2>>0]|0))<<16>>16;break}}else{l=(lce(p,b,0,0)|0)>>16;s=c[q>>2]|0;t=l}while(0);c[f+136>>2]=t;t=c[g>>2]|0;g=a[s>>0]|0;do if(g<<24>>24!=30){q=s+1|0;b=g&255;if(g<<24>>24==29){if((s+5|0)>>>0>t>>>0){u=0;break}u=(d[s+2>>0]|0)<<16|(d[q>>0]|0)<<24|(d[s+3>>0]|0)<<8|(d[s+4>>0]|0);break}else if(g<<24>>24!=28){if((g&255)<247){u=b+-139|0;break}p=(s+2|0)>>>0>t>>>0;if((g&255)<251){if(p){u=0;break}u=(d[q>>0]|0|(b<<8)+-63232)+108|0;break}else{if(p){u=0;break}u=(251-b<<8)+-108-(d[q>>0]|0)|0;break}}else{if((s+3|0)>>>0>t>>>0){u=0;break}u=((d[q>>0]|0)<<8|(d[s+2>>0]|0))<<16>>16;break}}else u=(lce(s,t,0,0)|0)>>16;while(0);c[f+140>>2]=u;h=0;i=e;return h|0}function lce(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;g=i;h=(f|0)!=0;if(h){c[f>>2]=0;j=0;k=0;l=0;m=b;n=4;o=0}else{j=0;k=0;l=0;m=b;n=4;o=0}a:while(1){b=(l|0)>214748363;p=j;q=m;r=n;s=o;b:while(1){t=p;u=q;v=r;while(1){if(!b){w=t;x=u;y=v;break}if(v){z=u+1|0;if(z>>>0<d>>>0)A=z;else{B=65;break a}}else A=u;z=a[A>>0]|0;C=(z&255)>>>v&15;D=4-v|0;if((C|0)==14){p=t;q=A;r=D;s=1;continue b}if(C>>>0>9){E=C;F=D;G=z;H=t;I=k;J=l;K=A;L=s;B=18;break a}t=t+1|0;u=A;v=D}v=x;u=y;while(1){if(u){t=v+1|0;if(t>>>0<d>>>0)M=t;else{B=65;break a}}else M=v;t=a[M>>0]|0;D=(t&255)>>>u&15;z=4-u|0;if((D|0)==14){p=w;q=M;r=z;s=1;continue b}if(D>>>0>9){E=D;F=z;G=t;H=w;I=k;J=l;K=M;L=s;B=18;break a}if(!(D|l)){v=M;u=z}else{N=D;O=z;P=w;Q=M;R=s;break b}}}j=P;k=k+1|0;l=N+(l*10|0)|0;m=Q;n=O;o=R}if((B|0)==18){c:do if((E|0)==10){R=G;o=H;O=0;n=J;Q=K;m=F;d:while(1){if((n|0)<214748364&(O|0)<9){S=R;T=o;U=Q;V=m}else{W=R;X=o;Y=O;Z=n;_=Q;$=m;break}while(1){if(!V){aa=S;ba=U}else{l=U+1|0;if(l>>>0>=d>>>0){B=65;break d}aa=a[l>>0]|0;ba=l}l=(aa&255)>>>V&15;N=4-V|0;if(l>>>0>9){ca=aa;ea=T;fa=O;ga=l;ha=n;ia=ba;ja=N;break c}if(l|n){ka=aa;la=l;ma=N;na=T;oa=ba;break}S=aa;T=T+-1|0;U=ba;V=N}R=ka;o=na;O=O+1|0;n=la+(n*10|0)|0;Q=oa;m=ma}if((B|0)==65){i=g;return 0}m=W;Q=X;n=_;O=$;e:while(1){o=m;R=n;N=O;while(1){if(!N){pa=o;qa=R}else{l=R+1|0;if(l>>>0>=d>>>0)break e;pa=a[l>>0]|0;qa=l}l=(pa&255)>>>N&15;k=4-N|0;if(l>>>0>9){ca=pa;ea=Q;fa=Y;ga=l;ha=Z;ia=qa;ja=k;break c}if(!(l|Z)){ra=pa;sa=k;ta=qa;break}else{o=pa;R=qa;N=k}}m=ra;Q=Q+-1|0;n=ta;O=sa}i=g;return 0}else{ca=G;ea=H;fa=0;ga=E;ha=J;ia=K;ja=F}while(0);F=(ga|0)==12;do if((ga+-11|0)>>>0<2){K=ca;J=0;E=ia;H=ja;while(1){if(!H){ua=K;va=E}else{G=E+1|0;if(G>>>0>=d>>>0){B=65;break}ua=a[G>>0]|0;va=G}G=(ua&255)>>>H&15;if(G>>>0>9){wa=J;B=41;break}J=G+(J*10|0)|0;if((J|0)>1e3){B=65;break}else{K=ua;E=va;H=4-H|0}}if((B|0)==41){xa=F?0-wa|0:wa;break}else if((B|0)==65){i=g;return 0}}else xa=0;while(0);wa=ea+e+xa|0;if(h){h=fa+I|0;xa=wa+I|0;if((h|0)>=6){e=c[726896+(h+-5<<2)>>2]|0;if(((ha|0)/(e|0)|0|0)>32767){ea=L8d(ha,c[726896+(h+-4<<2)>>2]|0)|0;c[f>>2]=xa+-4;ya=ea;za=(L|0)==0;Aa=0-ya|0;Ba=za?ya:Aa;i=g;return Ba|0}else{ea=L8d(ha,e)|0;c[f>>2]=xa+-5;ya=ea;za=(L|0)==0;Aa=0-ya|0;Ba=za?ya:Aa;i=g;return Ba|0}}if((ha|0)>32767){ea=L8d(ha,10)|0;c[f>>2]=1-h+xa;ya=ea;za=(L|0)==0;Aa=0-ya|0;Ba=za?ya:Aa;i=g;return Ba|0}if((xa|0)>0){ea=(xa|0)<5?xa:5;e=xa-ea|0;F=da(c[726896+(ea-h<<2)>>2]|0,ha)|0;if((F|0)>32767){Ca=e+1|0;Da=(F|0)/10|0}else{Ca=e;Da=F}}else{Ca=xa-h|0;Da=ha}c[f>>2]=Ca;ya=Da<<16;za=(L|0)==0;Aa=0-ya|0;Ba=za?ya:Aa;i=g;return Ba|0}else{Da=wa+I|0;Ca=(Da|0)<0;f=0-Da|0;if(((Ca?f:Da)|0)>5){i=g;return 0}if(Ca){Ea=fa+I|0;Fa=(ha|0)/(c[726896+(f<<2)>>2]|0)|0}else{Ea=fa-wa|0;Fa=ha}if((Ea|0)!=10)if((Ea|0)>0){Ga=Ea;Ha=Fa}else{ha=da(c[726896+(0-Ea<<2)>>2]|0,Fa)|0;if((ha|0)>32767){i=g;return 0}ya=ha<<16;za=(L|0)==0;Aa=0-ya|0;Ba=za?ya:Aa;i=g;return Ba|0}else{Ga=9;Ha=(Fa|0)/10|0}Fa=c[726896+(Ga<<2)>>2]|0;if(((Ha|0)/(Fa|0)|0|0)>32767){i=g;return 0}ya=L8d(Ha,Fa)|0;za=(L|0)==0;Aa=0-ya|0;Ba=za?ya:Aa;i=g;return Ba|0}}else if((B|0)==65){i=g;return 0}return 0}function mce(a,b){a=a|0;b=b|0;c[b>>2]=20;c[b+4>>2]=2755;c[b+8>>2]=3545;c[b+12>>2]=2756;c[b+16>>2]=2757;a=b+20|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;return}function nce(a,b){a=a|0;b=b|0;c[b>>2]=24;c[b+4>>2]=2758;c[b+8>>2]=3546;c[b+12>>2]=2759;c[b+16>>2]=2760;a=b+20|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;return}function oce(a,b){a=a|0;b=b|0;c[a+16>>2]=(c[(c[a>>2]|0)+692>>2]|0)+640;return 0}function pce(a){a=a|0;c[a+16>>2]=0;return}function qce(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;if(b>>>0>=256){f=0;i=d;return f|0}f=e[(c[a+16>>2]|0)+(b<<1)>>1]|0;i=d;return f|0}function rce(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;f=c[d>>2]|0;c[d>>2]=0;a:do if(f>>>0<255){g=a+16|0;h=f;j=0;while(1){k=h+1|0;if(k>>>0>255){l=j;break a}m=b[(c[g>>2]|0)+(k<<1)>>1]|0;n=m&65535;if(!(m<<16>>16)){h=k;j=n}else{o=n;p=k;break}}c[d>>2]=p;l=o}else l=0;while(0);i=e;return l|0}function sce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;b=i;d=c[a>>2]|0;e=c[d+692>>2]|0;if(!(c[e+1160>>2]|0)){f=163;i=b;return f|0}f=Km[c[(c[e+2956>>2]|0)+4>>2]&127](c[d+100>>2]|0,a,c[e+12>>2]|0,2761,0,d)|0;i=b;return f|0}function tce(a){a=a|0;var b=0,d=0;b=i;d=a+20|0;$ae(c[(c[a>>2]|0)+100>>2]|0,c[d>>2]|0);c[d>>2]=0;c[a+16>>2]=0;i=b;return}function uce(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[(c[(c[a>>2]|0)+692>>2]|0)+2956>>2]|0)+8>>2]&4095](a,b)|0;i=d;return e|0}function vce(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[(c[(c[a>>2]|0)+692>>2]|0)+2956>>2]|0)+12>>2]&4095](a,b)|0;i=d;return e|0}function wce(a,b){a=a|0;b=b|0;var d=0,f=0;d=i;f=c[a+692>>2]|0;a=Mbe(f,e[(c[f+1160>>2]|0)+(b<<1)>>1]|0)|0;i=d;return a|0}function xce(a,b){a=a|0;b=b|0;c[b>>2]=3615;c[b+4>>2]=117;c[b+8>>2]=2762;c[b+12>>2]=2763;c[b+16>>2]=3616;c[b+20>>2]=3617;c[b+24>>2]=724856;c[b+28>>2]=726936;return}function yce(a,b){a=a|0;b=b|0;var d=0;d=i;if(b)$ae(c[a>>2]|0,b);i=d;return}function zce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=Xae(c[a>>2]|0,16,e)|0;g=c[e>>2]|0;if(g){h=g;i=d;return h|0}c[f>>2]=788624;c[f+4>>2]=(c[a+212>>2]|0)+4;c[f+8>>2]=0;c[f+12>>2]=0;c[b>>2]=f;h=0;i=d;return h|0}function Ace(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;Lce(a);if(!b){i=d;return}$ae(e,b);i=d;return}function Bce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,36,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=Mce(a)|0;c[e>>2]=h;if(!h){c[g>>2]=0;c[g+4>>2]=20;c[g+8>>2]=727448;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=(c[a+212>>2]|0)+4;c[g+24>>2]=0;c[g+28>>2]=0;c[g+32>>2]=2764;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function Cce(b){b=b|0;var c=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;c=i;e=a[b>>0]|0;do if(e<<24>>24==117){f=b+1|0;g=a[f>>0]|0;do if(g<<24>>24==110)if((a[b+2>>0]|0)==105){h=4;j=b+3|0;k=0;while(1){l=d[j>>0]|0;m=l+-48|0;if(m>>>0>9){n=l+-55|0;if((l+-65|0)>>>0>5|n>>>0>15){o=h;p=j;q=k;break}else r=n}else r=m;m=r+(k<<4)|0;n=h+-1|0;l=j+1|0;if((n|0)>0){h=n;j=l;k=m}else{o=n;p=l;q=m;break}}if(!o){k=a[p>>0]|0;if(!(k<<24>>24)){s=q;i=c;return s|0}else if(k<<24>>24!=46){t=g;u=b;v=6;w=f;x=0;break}s=q|-2147483648;i=c;return s|0}else{t=g;u=b;v=6;w=f;x=0}}else{t=110;u=b;v=6;w=f;x=0}else{t=g;u=b;v=6;w=f;x=0}while(0);while(1){f=t&255;g=f+-48|0;if(g>>>0>9){k=f+-55|0;if((f+-65|0)>>>0>5|k>>>0>15){y=v;z=w;A=x;B=15;break}else C=k}else C=g;g=C+(x<<4)|0;k=v+-1|0;f=u+2|0;if((k|0)<=0){D=f;E=g;break}j=w;t=a[f>>0]|0;v=k;w=f;x=g;u=j}if((B|0)==15)if((y|0)<3){D=z;E=A}else{F=e;G=b;break}j=a[D>>0]|0;if(!(j<<24>>24)){s=E;i=c;return s|0}else if(j<<24>>24!=46){F=e;G=b;break}s=E|-2147483648;i=c;return s|0}else{F=e;G=b}while(0);while(1){if(F<<24>>24==46){if(G>>>0>b>>>0){H=G;B=21;break}}else if(!(F<<24>>24)){I=G;break}e=G+1|0;F=a[e>>0]|0;G=e}if((B|0)==21)if(!H)I=0;else{s=Jce(b,H)|0|-2147483648;i=c;return s|0}s=Jce(b,I)|0;i=c;return s|0}function Dce(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=i;i=i+96|0;j=h+80|0;k=h+40|0;l=h;m=k+0|0;n=m+40|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));m=b+16|0;c[m>>2]=0;n=b+20|0;c[n>>2]=0;b=Zae(a,8,0,d+10|0,0,j)|0;c[n>>2]=b;o=c[j>>2]|0;if(o){p=o;i=h;return p|0}if(d){if(!f){o=b;q=0;while(1){r=_n[e&4095](g,q)|0;if(r){s=0;do{if(!(HEi(732496+(c[732584+(s<<2)>>2]|0)|0,r)|0)){t=s;u=7;break}s=s+1|0}while(s>>>0<10);if((u|0)==7?(u=0,s=k+(t<<2)|0,(c[s>>2]|0)==0):0){c[s>>2]=1;c[l+(t<<2)>>2]=q}s=Cce(r)|0;if(s&2147483647){v=0;do{if((c[732456+(v<<2)>>2]|0)==(s|0)){w=v;u=12;break}v=v+1|0}while(v>>>0<10);if((u|0)==12){u=0;c[k+(w<<2)>>2]=2}c[o>>2]=s;c[o+4>>2]=q;x=o+8|0}else x=o}else x=o;q=q+1|0;if((q|0)==(d|0)){y=x;break}else o=x}}else{x=b;o=0;while(1){q=_n[e&4095](g,o)|0;if(!q)z=x;else{w=0;do{if(!(HEi(732496+(c[732584+(w<<2)>>2]|0)|0,q)|0)){A=w;u=19;break}w=w+1|0}while(w>>>0<10);if((u|0)==19?(u=0,w=k+(A<<2)|0,(c[w>>2]|0)==0):0){c[w>>2]=1;c[l+(A<<2)>>2]=o}w=Cce(q)|0;if(!(w&2147483647))B=x;else{s=0;do{if((c[732456+(s<<2)>>2]|0)==(w|0)){C=s;u=24;break}s=s+1|0}while(s>>>0<10);if((u|0)==24){u=0;c[k+(C<<2)>>2]=2}c[x>>2]=w;c[x+4>>2]=o;B=x+8|0}In[f&4095](g,q);z=B}o=o+1|0;if((o|0)==(d|0)){y=z;break}else x=z}}if((c[k>>2]|0)==1){c[y>>2]=916;c[y+4>>2]=c[l>>2];D=y+8|0}else D=y}else D=b;if((c[k+4>>2]|0)==1){c[D>>2]=937;c[D+4>>2]=c[l+4>>2];E=D+8|0}else E=D;if((c[k+8>>2]|0)==1){c[E>>2]=8725;c[E+4>>2]=c[l+8>>2];F=E+8|0}else F=E;if((c[k+12>>2]|0)==1){c[F>>2]=173;c[F+4>>2]=c[l+12>>2];G=F+8|0}else G=F;if((c[k+16>>2]|0)==1){c[G>>2]=713;c[G+4>>2]=c[l+16>>2];H=G+8|0}else H=G;if((c[k+20>>2]|0)==1){c[H>>2]=956;c[H+4>>2]=c[l+20>>2];I=H+8|0}else I=H;if((c[k+24>>2]|0)==1){c[I>>2]=8729;c[I+4>>2]=c[l+24>>2];J=I+8|0}else J=I;if((c[k+28>>2]|0)==1){c[J>>2]=160;c[J+4>>2]=c[l+28>>2];K=J+8|0}else K=J;if((c[k+32>>2]|0)==1){c[K>>2]=538;c[K+4>>2]=c[l+32>>2];L=K+8|0}else L=K;if((c[k+36>>2]|0)==1){c[L>>2]=539;c[L+4>>2]=c[l+36>>2];M=L+8|0}else M=L;L=c[n>>2]|0;l=M-L>>3;if(!l){$ae(a,L);c[n>>2]=0;M=c[j>>2]|0;if(!M){c[j>>2]=163;N=163}else N=M}else{if(l>>>0<d>>>1>>>0){M=Zae(a,8,d,l,L,j)|0;c[n>>2]=M;c[j>>2]=0;O=M}else O=L;fCi(O,l,8,2765);N=c[j>>2]|0}c[m>>2]=l;p=N;i=h;return p|0}function Ece(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;e=c[a+20>>2]|0;f=(c[a+16>>2]|0)+-1|0;if((f|0)<0){g=0;i=d;return g|0}a=e+(f<<3)|0;f=e;e=0;a:while(1){h=a;j=f;k=e;while(1){l=h-j>>4;m=j+(l<<3)|0;n=c[m>>2]|0;if((n|0)==(b|0)){o=m;break a}p=n&2147483647;n=(p|0)==(b|0)?m:k;if((j|0)==(a|0)){o=n;break a}if(p>>>0>=b>>>0){q=l;r=n;s=j;break}j=j+(l+1<<3)|0;if(j>>>0>a>>>0){o=n;break a}else k=n}if((q|0)<1){o=r;break}else{a=s+(q+-1<<3)|0;f=s;e=r}}if(!o){g=0;i=d;return g|0}g=c[o+4>>2]|0;i=d;return g|0}function Fce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=(c[b>>2]|0)+1|0;f=c[a+16>>2]|0;do if(f){g=c[a+20>>2]|0;h=f;j=0;k=0;while(1){l=((h-j|0)>>>1)+j|0;m=c[g+(l<<3)>>2]|0;if((m|0)==(e|0)){n=l;o=4;break}p=m&2147483647;if((p|0)==(e|0))q=c[g+(l<<3)+4>>2]|0;else q=k;m=p>>>0<e>>>0;p=m?l+1|0:j;h=m?h:l;if(h>>>0<=p>>>0){r=p;s=q;o=8;break}else{j=p;k=q}}if((o|0)==4){t=e;u=c[g+(n<<3)+4>>2]|0;break}else if((o|0)==8)if(!s){v=r;o=9;break}else{t=e;u=s;break}}else{v=0;o=9}while(0);if((o|0)==9)if(v>>>0<f>>>0){f=c[a+20>>2]|0;t=c[f+(v<<3)>>2]&2147483647;u=c[f+(v<<3)+4>>2]|0}else{t=0;u=0}c[b>>2]=t;i=d;return u|0}function Gce(a){a=a|0;return 727456+(b[731936+((a>>>0>257?0:a)<<1)>>1]|0)|0}function Hce(a){a=a|0;var c=0;if(a>>>0>390)c=0;else c=727456+(b[731152+(a<<1)>>1]|0)|0;return c|0}function Ice(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=m9d(c[c[(c[a+4>>2]|0)+212>>2]>>2]|0,b)|0;i=d;return e|0}function Jce(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;if(!((b|0)!=0&b>>>0<c>>>0)){f=0;i=e;return f|0}g=b+1|0;h=a[b>>0]|0;j=52;k=0;while(1){l=j+k>>1;m=l<<1;n=732624+(d[m+732626>>0]<<8|d[m+732627>>0])|0;m=a[n>>0]|0;o=m&127;if((o|0)==(h|0)){p=n;q=m;break}m=(o|0)<(h|0);k=m?l+1|0:k;j=m?j:l;if((k|0)>=(j|0)){f=0;r=16;break}}if((r|0)==16){i=e;return f|0}a:do if(g>>>0<c>>>0){j=g;k=b;h=q;l=p;b:while(1){m=k+2|0;o=a[j>>0]|0;n=l+1|0;s=a[n>>0]|0;t=s&255;u=t&127;c:do if(h<<24>>24<0)if((o|0)==(u|0)){v=s;w=n}else{f=0;r=16;break b}else{if(!u){f=0;r=16;break b}x=u;y=l+((t>>>6&2)+2)|0;while(1){z=732624+(d[y>>0]<<8|d[y+1>>0])|0;A=a[z>>0]|0;if((o|0)==(A&127|0)){v=A;w=z;break c}x=x+-1|0;if((x|0)<=0){f=0;r=16;break b}else y=y+2|0}}while(0);if(m>>>0<c>>>0){o=j;j=m;h=v;l=w;k=o}else{B=v;C=w;break a}}if((r|0)==16){i=e;return f|0}}else{B=q;C=p}while(0);if(B<<24>>24<=-1){f=0;i=e;return f|0}if((a[C+1>>0]|0)>=0){f=0;i=e;return f|0}f=d[C+2>>0]<<8|d[C+3>>0];i=e;return f|0}function Kce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a>>2]|0;a=e&2147483647;f=c[b>>2]|0;b=f&2147483647;if((a|0)==(b|0))if(e>>>0>f>>>0)g=1;else g=(e>>>0<f>>>0)<<31>>31;else if(a>>>0>b>>>0)g=1;else g=(a>>>0<b>>>0)<<31>>31;i=d;return g|0}function Lce(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a>>2]|0;e=a+212|0;f=c[e>>2]|0;if(!f){i=b;return}g=c[f>>2]|0;if(g)yce(a,g);c[f>>2]=0;$ae(d,f);c[e>>2]=0;i=b;return}function Mce(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=Xae(c[a>>2]|0,36,d)|0;f=c[d>>2]|0;if(f){g=f;i=b;return g|0}f=e+0|0;h=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));f=a+212|0;c[f>>2]=e;h=zce(a,e)|0;c[d>>2]=h;if(!h){xce(a,e+4|0);e=c[d>>2]|0;if(!e){g=0;i=b;return g|0}else j=e}else j=h;h=c[a>>2]|0;e=c[f>>2]|0;if(!e){g=j;i=b;return g|0}j=c[e>>2]|0;if(j)yce(a,j);c[e>>2]=0;$ae(h,e);c[f>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Nce(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+16|0;e=f;g=b+532|0;h=c[g>>2]|0;j=b+96|0;do if(!h){k=S9d(c[(c[j>>2]|0)+4>>2]|0,789856)|0;if(!k){l=3;i=f;return l|0}else{c[g>>2]=k;c[b+508>>2]=c[k>>2];m=k;break}}else m=h;while(0);c[b+536>>2]=T9d(c[j>>2]|0,788624)|0;j=c[a+28>>2]|0;h=b+132|0;c[h>>2]=0;g=b+136|0;c[g>>2]=0;k=b+140|0;c[k>>2]=0;n=Fae(a)|0;o=Rae(a,e)|0;p=c[e>>2]|0;if(p){l=p;i=f;return l|0}if(!((o|0)==65536|(o|0)==131072|(o|0)==1330926671|(o|0)==1953658213|(o|0)==1953784678|(o|0)==1954115633)){l=2;i=f;return l|0}c[h>>2]=1953784678;do if((o|0)==1953784678){p=Sae(a,788784,h)|0;c[e>>2]=p;if(p){l=p;i=f;return l|0}p=c[k>>2]|0;if(!p){l=8;i=f;return l|0}if(p>>>0>(c[a+4>>2]|0)>>>5>>>0){l=10;i=f;return l|0}q=b+144|0;c[q>>2]=Zae(j,4,0,p,0,e)|0;p=c[e>>2]|0;if(p){l=p;i=f;return l|0}p=Jae(a,c[k>>2]<<2)|0;c[e>>2]=p;if(p){l=p;i=f;return l|0}if((c[k>>2]|0)>0){p=0;do{r=Oae(a)|0;c[(c[q>>2]|0)+(p<<2)>>2]=r;p=p+1|0}while((p|0)<(c[k>>2]|0))}Lae(a);p=c[e>>2]|0;if(p){l=p;i=f;return l|0}}else{c[g>>2]=65536;c[k>>2]=1;p=Xae(j,4,e)|0;c[b+144>>2]=p;q=c[e>>2]|0;if(!q){c[p>>2]=n;break}else{l=q;i=f;return l|0}}while(0);n=(d|0)<0?0:d;if((n|0)>=(c[k>>2]|0)){l=6;i=f;return l|0}d=Dae(a,c[(c[b+144>>2]|0)+(n<<2)>>2]|0)|0;if(d){l=d;i=f;return l|0}d=_n[c[m+132>>2]&4095](b,a)|0;if(d){l=d;i=f;return l|0}c[b>>2]=c[k>>2];c[b+4>>2]=n;l=0;i=f;return l|0}function Oce(d,f,g,h,j){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=i;i=i+32|0;k=g+28|0;l=g;m=c[f+532>>2]|0;if((h|0)>0){n=0;o=0;p=0;while(1){q=c[j+(n<<3)>>2]|0;if((q|0)==1768386662){r=1;s=p}else{r=o;s=(q|0)==1768386675?1:p}n=n+1|0;if((n|0)==(h|0)){t=r;u=s;break}else{o=r;p=s}}}else{t=0;u=0}if(!(Dee(f,1735162214)|0)){s=(Dee(f,1128678944)|0)!=0;p=s&1;if(!s){s=c[m+84>>2]|0;if(s){r=_n[s&4095](f,d)|0;c[k>>2]=r;if(!r){v=p;w=1}else{x=p;y=9}}else{x=0;y=9}}else{x=p;y=9}}else{x=1;y=9}if((y|0)==9){p=_n[c[m+32>>2]&4095](f,d)|0;c[k>>2]=p;if(!p){v=x;w=0}else{z=p;i=g;return z|0}}p=f+178|0;if(!(b[p>>1]|0)){c[k>>2]=8;z=8;i=g;return z|0}_n[c[m+44>>2]&4095](f,d)|0;_n[c[m+40>>2]&4095](f,d)|0;_n[c[m+56>>2]&4095](f,d)|0;x=_n[c[m+52>>2]&4095](f,d)|0;c[k>>2]=x;if(!w){w=m+36|0;r=xo[c[w>>2]&2047](f,d,0)|0;c[k>>2]=r;do if(!r){s=xo[c[m+136>>2]&2047](f,d,0)|0;o=(s|0)==142?147:s;c[k>>2]=o;A=o;y=18}else if((r|0)==142){if((c[f+148>>2]|0)==1953658213){c[k>>2]=0;B=0;break}c[k>>2]=143;z=143;i=g;return z|0}else{A=r;y=18}while(0);if((y|0)==18)if(!A)B=v;else{z=A;i=g;return z|0}A=xo[c[w>>2]&2047](f,d,1)|0;c[k>>2]=A;if(!A){w=xo[c[m+136>>2]&2047](f,d,1)|0;c[k>>2]=w;if(!w)a[f+296>>0]=1;else{C=w;y=22}}else{C=A;y=22}if((y|0)==22?!((C|0)==0|(C|0)==142):0){z=C;i=g;return z|0}C=_n[c[m+48>>2]&4095](f,d)|0;c[k>>2]=C;if(!C)D=B;else{b[f+368>>1]=-1;D=B}}else D=v;v=c[m+140>>2]|0;do if(v){B=_n[v&4095](f,d)|0;c[k>>2]=B;if((B|0)==142){c[k>>2]=0;break}else if(!B)break;else{z=B;i=g;return z|0}}while(0);v=_n[c[m+80>>2]&4095](f,d)|0;c[k>>2]=v;if((v|0)==142)c[f+556>>2]=0;else if(v){z=v;i=g;return z|0}_n[c[m+76>>2]&4095](f,d)|0;c[k>>2]=_n[c[m+72>>2]&4095](f,d)|0;c[f+16>>2]=e[f+264>>1];d=f+20|0;c[d>>2]=0;v=f+24|0;c[v>>2]=0;B=f+368|0;if((b[B>>1]|0)!=-1?(b[f+432>>1]&256)!=0:0){do if(!(t<<24>>24)){C=Qce(f,16,d)|0;c[k>>2]=C;if(!C)if(!(c[d>>2]|0)){y=35;break}else break;else{z=C;i=g;return z|0}}else y=35;while(0);if((y|0)==35?(C=Qce(f,1,d)|0,c[k>>2]=C,(C|0)!=0):0){z=C;i=g;return z|0}if(u<<24>>24==0?(C=Qce(f,17,v)|0,c[k>>2]=C,(C|0)!=0):0){z=C;i=g;return z|0}if((c[v>>2]|0)==0?(C=Qce(f,2,v)|0,c[k>>2]=C,(C|0)!=0):0){z=C;i=g;return z|0}}else{C=Qce(f,21,d)|0;c[k>>2]=C;if(C){z=C;i=g;return z|0}C=c[d>>2]|0;do if(!((C|0)!=0|t<<24>>24!=0)){A=Qce(f,16,d)|0;c[k>>2]=A;if(!A){E=c[d>>2]|0;break}else{z=A;i=g;return z|0}}else E=C;while(0);if((E|0)==0?(E=Qce(f,1,d)|0,c[k>>2]=E,(E|0)!=0):0){z=E;i=g;return z|0}E=Qce(f,22,v)|0;c[k>>2]=E;if(E){z=E;i=g;return z|0}E=c[v>>2]|0;do if(!((E|0)!=0|u<<24>>24!=0)){d=Qce(f,17,v)|0;c[k>>2]=d;if(!d){F=c[v>>2]|0;break}else{z=d;i=g;return z|0}}else F=E;while(0);if((F|0)==0?(F=Qce(f,2,v)|0,c[k>>2]=F,(F|0)!=0):0){z=F;i=g;return z|0}}F=f+8|0;v=D<<24>>24==1;D=c[F>>2]|v&1;E=D|24;if(!x)G=(c[f+468>>2]|0)==196608?E:D|536;else G=E;E=(c[f+480>>2]|0)==0?G:G|4;G=f+296|0;D=(a[G>>0]|0)==0?E:E|32;E=(c[f+784>>2]|0)==0?D:D|64;if((Dee(f,1735162214)|0)!=0?(Dee(f,1719034226)|0)!=0:0){D=(Dee(f,1735811442)|0)==0;H=D?E:E|256}else H=E;c[F>>2]=H;if(v?(b[B>>1]|0)!=-1:0){v=b[f+432>>1]|0;H=v&65535;I=(v&65535)>>>4&2|((H&512|0)==0?H&1:1)}else{H=b[f+204>>1]|0;I=(H&65535)>>>1&1|(H&1)<<1}c[f+12>>2]=I;rde(f)|0;I=c[f+36>>2]|0;if((I|0)>0){H=c[f+40>>2]|0;v=0;do{E=c[H+(v<<2)>>2]|0;D=e[E+8>>1]|0;x=e[E+10>>1]|0;u=788648;while(1){if((c[u>>2]|0)==(D|0)?(d=c[u+4>>2]|0,(d|0)==(x|0)|(d|0)==-1):0){J=u;y=66;break}u=u+12|0;if(u>>>0>=788780>>>0){K=0;break}}if((y|0)==66){y=0;K=c[J+8>>2]|0}c[E+4>>2]=K;v=v+1|0}while((v|0)<(I|0))}I=c[f+612>>2]|0;do if(I){v=c[(c[f+104>>2]|0)+28>>2]|0;K=b[p>>1]|0;if(K<<16>>16!=0?(b[B>>1]|0)!=-1:0){L=b[f+370>>1]|0;M=K}else{L=0;M=1}K=Zae(v,16,0,I,0,k)|0;v=f+32|0;c[v>>2]=K;J=c[k>>2]|0;if(J){z=J;i=g;return z|0}J=m+152|0;H=l+20|0;u=L<<16>>16;x=M&65535;D=(M&65535)>>>1&65535;d=K;K=0;while(1){C=xo[c[J>>2]&2047](f,K,l)|0;c[k>>2]=C;if(C){z=C;y=92;break}b[d+(K<<4)>>1]=(c[H>>2]|0)>>>6;C=c[l>>2]|0;t=C&65535;b[d+(K<<4)+2>>1]=((da(t,u)|0)+D|0)/(x|0)|0;c[d+(K<<4)+8>>2]=t<<6;t=C>>>16<<6;c[d+(K<<4)+12>>2]=t;c[d+(K<<4)+4>>2]=t;t=K+1|0;if(t>>>0>=I>>>0){y=79;break}d=c[v>>2]|0;K=t}if((y|0)==79){K=c[F>>2]|2;c[F>>2]=K;c[f+28>>2]=I;N=K;break}else if((y|0)==92){i=g;return z|0}}else N=c[F>>2]|0;while(0);if(!(N&3)){y=N|1;c[F>>2]=y;O=y}else O=N;if(!(O&1)){z=0;i=g;return z|0}c[f+52>>2]=b[f+196>>1];c[f+56>>2]=b[f+198>>1];c[f+60>>2]=b[f+200>>1];c[f+64>>2]=b[f+202>>1];b[f+68>>1]=b[p>>1]|0;p=b[f+220>>1]|0;O=f+70|0;b[O>>1]=p;N=b[f+222>>1]|0;y=f+72|0;b[y>>1]=N;F=(p&65535)-(N&65535)+(e[f+224>>1]|0)|0;I=f+74|0;b[I>>1]=F;do if((p|N)<<16>>16==0?(b[B>>1]|0)!=-1:0){l=b[f+438>>1]|0;k=b[f+440>>1]|0;if(!((l|k)<<16>>16)){M=b[f+444>>1]|0;b[O>>1]=M;L=e[f+446>>1]|0;b[y>>1]=0-L;m=(M&65535)+L|0;b[I>>1]=m;P=m;break}else{b[O>>1]=l;b[y>>1]=k;m=(l&65535)-(k&65535)+(e[f+442>>1]|0)|0;b[I>>1]=m;P=m;break}}else P=F;while(0);b[f+76>>1]=b[f+226>>1]|0;if(!(a[G>>0]|0))Q=P<<16>>16;else Q=e[f+310>>1]|0;b[f+78>>1]=Q;Q=b[f+478>>1]|0;b[f+80>>1]=(e[f+476>>1]|0)-((Q<<16>>16|0)/2|0);b[f+82>>1]=Q;z=0;i=g;return z|0}function Pce(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!d){i=e;return}f=c[d+100>>2]|0;g=d+532|0;h=c[g>>2]|0;j=(h|0)!=0;if(j){k=c[h+116>>2]|0;if(k)ko[k&4095](d);k=c[h+144>>2]|0;if(k)ko[k&4095](d)}afe(d);k=d+144|0;$ae(f,c[k>>2]|0);c[k>>2]=0;c[d+140>>2]=0;k=d+156|0;$ae(f,c[k>>2]|0);c[k>>2]=0;b[d+152>>1]=0;Kae(c[d+104>>2]|0,d+500|0);c[d+504>>2]=0;k=d+252|0;$ae(f,c[k>>2]|0);c[k>>2]=0;k=d+256|0;$ae(f,c[k>>2]|0);c[k>>2]=0;k=d+296|0;if(a[k>>0]|0){l=d+336|0;$ae(f,c[l>>2]|0);c[l>>2]=0;l=d+340|0;$ae(f,c[l>>2]|0);c[l>>2]=0;a[k>>0]=0}k=d+552|0;$ae(f,c[k>>2]|0);c[k>>2]=0;b[d+550>>1]=0;if(j)ko[c[h+60>>2]&4095](d);h=d+20|0;$ae(f,c[h>>2]|0);c[h>>2]=0;h=d+24|0;$ae(f,c[h>>2]|0);c[h>>2]=0;h=d+32|0;$ae(f,c[h>>2]|0);c[h>>2]=0;c[d+28>>2]=0;h=d+700|0;$ae(f,c[h>>2]|0);c[h>>2]=0;c[g>>2]=0;i=e;return}function Qce(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=i;i=i+16|0;h=g;j=c[a+100>>2]|0;c[h>>2]=0;k=a+360|0;l=b[a+344>>1]|0;if(!(l<<16>>16)){m=0;c[f>>2]=m;n=c[h>>2]|0;i=g;return n|0}o=-1;p=-1;q=-1;r=-1;s=0;t=0;u=c[k>>2]|0;while(1){do if((b[u+6>>1]|0)==d<<16>>16?(b[u+8>>1]|0)!=0:0){v=e[u>>1]|0;if((v|0)==2|(v|0)==0){w=o;x=p;y=s;z=r;A=t;break}else if((v|0)==3){if((r|0)!=-1?(b[u+4>>1]&1023)!=9:0){w=o;x=p;y=q;z=r;A=t;break}B=e[u+2>>1]|0;if(!((B|0)==10|(B|0)==1|(B|0)==0)){w=o;x=p;y=q;z=r;A=t;break}w=o;x=p;y=q;z=s;A=(b[u+4>>1]&1023)==9&1;break}else if((v|0)==1){if(!(b[u+4>>1]|0)){w=s;x=p;y=q;z=r;A=t;break}w=o;x=(b[u+2>>1]|0)==0?s:p;y=q;z=r;A=t;break}else{w=o;x=p;y=q;z=r;A=t;break}}else{w=o;x=p;y=q;z=r;A=t}while(0);s=s+1|0;if((s&65535)>=(l&65535)){C=w;D=x;E=y;F=z;G=A;break}else{o=w;p=x;q=y;r=z;t=A;u=u+20|0}}u=(C|0)>-1?C:D;if((F|0)>-1?(u|0)<0|G<<24>>24!=0:0){G=c[k>>2]|0;D=e[G+(F*20|0)+2>>1]|0;if((D|0)==10|(D|0)==0|(D|0)==1){H=2766;I=G+(F*20|0)|0}else{m=0;c[f>>2]=m;n=c[h>>2]|0;i=g;return n|0}}else J=17;do if((J|0)==17){if((u|0)>-1){H=2767;I=(c[k>>2]|0)+(u*20|0)|0;break}if((E|0)>-1){H=2766;I=(c[k>>2]|0)+(E*20|0)|0;break}else{m=0;c[f>>2]=m;n=c[h>>2]|0;i=g;return n|0}}while(0);if(!I){m=0;c[f>>2]=m;n=c[h>>2]|0;i=g;return n|0}E=I+16|0;do if(!(c[E>>2]|0)){k=c[a+364>>2]|0;u=I+8|0;c[E>>2]=Zae(j,1,0,e[u>>1]|0,0,h)|0;if(((c[h>>2]|0)==0?(J=Dae(k,c[I+12>>2]|0)|0,c[h>>2]=J,(J|0)==0):0)?(J=Gae(k,c[E>>2]|0,e[u>>1]|0)|0,c[h>>2]=J,(J|0)==0):0)break;$ae(j,c[E>>2]|0);c[E>>2]=0;b[u>>1]=0;m=0;c[f>>2]=m;n=c[h>>2]|0;i=g;return n|0}while(0);m=_n[H&4095](I,j)|0;c[f>>2]=m;n=c[h>>2]|0;i=g;return n|0}function Rce(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=c[d+16>>2]|0;j=b[d+8>>1]|0;d=j&65535;k=Zae(e,1,0,d+1|0,0,g)|0;if(c[g>>2]|0){l=0;i=f;return l|0}if(j<<16>>16){j=0;g=h;while(1){h=a[g>>0]|0;a[k+j>>0]=(h&255)<32|h<<24>>24<0?63:h;j=j+1|0;if((j|0)==(d|0))break;else g=g+1|0}}a[k+d>>0]=0;l=k;i=f;return l|0}function Sce(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;j=c[b+16>>2]|0;k=(e[b+8>>1]|0)>>>1;b=k&65535;l=Zae(f,1,0,b+1|0,0,h)|0;if(c[h>>2]|0){m=0;i=g;return m|0}if(k<<16>>16){k=0;h=j;while(1){j=a[h+1>>0]|0;a[l+k>>0]=(((d[h>>0]|0)<<8|j&255)+-32|0)>>>0>95?63:j;k=k+1|0;if((k|0)==(b|0))break;else h=h+2|0}}a[l+b>>0]=0;m=l;i=g;return m|0}function Tce(a){a=a|0;c[a>>2]=211;c[a+4>>2]=2768;c[a+8>>2]=212;return}function Uce(a,b){a=a|0;b=b|0;c[b>>2]=261;c[b+4>>2]=2769;return}function Vce(a,b){a=a|0;b=b|0;c[b>>2]=3618;return}function Wce(a,b){a=a|0;b=b|0;c[b>>2]=2770;return}function Xce(a,b){a=a|0;b=b|0;var d=0;d=i;if(b)$ae(c[a>>2]|0,b);i=d;return}function Yce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=Xae(c[a>>2]|0,40,e)|0;g=c[e>>2]|0;if(g){h=g;i=d;return h|0}c[f>>2]=788800;g=c[a+220>>2]|0;c[f+4>>2]=g+24;c[f+8>>2]=788816;c[f+12>>2]=g+12;c[f+16>>2]=788840;c[f+20>>2]=g+4;c[f+24>>2]=788856;c[f+28>>2]=g+16;c[f+32>>2]=0;c[f+36>>2]=0;c[b>>2]=f;h=0;i=d;return h|0}function Zce(a,b){a=a|0;b=b|0;c[b>>2]=262;c[b+4>>2]=213;c[b+8>>2]=214;c[b+12>>2]=3547;c[b+16>>2]=2771;c[b+20>>2]=211;c[b+24>>2]=263;c[b+28>>2]=1743;c[b+32>>2]=2772;c[b+36>>2]=1744;c[b+40>>2]=2773;c[b+44>>2]=2774;c[b+48>>2]=2775;c[b+52>>2]=2776;c[b+56>>2]=2777;c[b+60>>2]=3548;c[b+64>>2]=2778;c[b+68>>2]=3549;c[b+72>>2]=2779;c[b+76>>2]=2780;c[b+80>>2]=2781;c[b+84>>2]=2782;c[b+88>>2]=264;c[b+92>>2]=2783;c[b+96>>2]=118;c[b+100>>2]=1745;c[b+104>>2]=111;c[b+108>>2]=3550;c[b+112>>2]=1746;c[b+116>>2]=3551;c[b+120>>2]=1747;c[b+124>>2]=2784;c[b+128>>2]=1748;c[b+132>>2]=2785;c[b+136>>2]=1749;c[b+140>>2]=2786;c[b+144>>2]=3552;c[b+148>>2]=1750;c[b+152>>2]=1751;c[b+156>>2]=215;return}function _ce(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;Gie(a);if(!b){i=d;return}$ae(e,b);i=d;return}function $ce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,36,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=Hie(a)|0;c[e>>2]=h;if(!h){c[g>>2]=0;c[g+4>>2]=20;c[g+8>>2]=789856;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=(c[a+220>>2]|0)+36;c[g+24>>2]=0;c[g+28>>2]=0;c[g+32>>2]=2771;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function ade(d,e){d=d|0;e=e|0;var f=0,g=0;f=i;switch(e|0){case 3:{g=d+216|0;break}case 4:{if(!(a[d+296>>0]|0))g=0;else g=d+300|0;break}case 0:{g=d+160|0;break}case 5:{g=d+468|0;break}case 6:{e=d+556|0;g=(c[e>>2]|0)==0?0:e;break}case 1:{g=d+260|0;break}case 2:{e=d+368|0;g=(b[e>>1]|0)==-1?0:e;break}default:g=0}i=f;return g|0}function bde(a,b,d,f,g){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;if(!((f|0)!=0&(g|0)!=0)){j=6;i=h;return j|0}k=e[a+152>>1]|0;do if(d)if(k>>>0>b>>>0){l=c[a+156>>2]|0;c[d>>2]=c[l+(b<<4)>>2];c[f>>2]=c[l+(b<<4)+8>>2];m=c[l+(b<<4)+12>>2]|0;break}else{j=142;i=h;return j|0}else m=k;while(0);c[g>>2]=m;j=0;i=h;return j|0}function cde(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=Bee(a,b,g)|0;if(h){i=f;return h|0}bbe(d,c[g>>2]|0,e)|0;i=f;return h|0}function dde(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[a+16>>2]|0;a:do if((f|0)<1)g=0;else{h=0;while(1){if((Bee(a,h,e)|0)==0?(HEi(b,c[e>>2]|0)|0)==0:0){g=h;break a}h=h+1|0;if(h>>>0>=f>>>0){g=0;break}}}while(0);i=d;return g|0}function ede(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+16|0;g=f+4|0;h=f;j=d+700|0;k=c[j>>2]|0;if(k){l=k;i=f;return l|0}k=b[d+344>>1]|0;do if(k<<16>>16){m=c[d+360>>2]|0;n=k&65535;o=-1;p=-1;q=0;while(1){do if((b[m+(q*20|0)+6>>1]|0)==6?(b[m+(q*20|0)+8>>1]|0)!=0:0){r=b[m+(q*20|0)>>1]|0;if(r<<16>>16==3){if((b[m+(q*20|0)+2>>1]|0)!=1){s=o;t=p;break}u=(b[m+(q*20|0)+4>>1]|0)==1033?q:p}else u=p;if(r<<16>>16==1?(b[m+(q*20|0)+2>>1]|0)==0:0){s=(b[m+(q*20|0)+4>>1]|0)==0?q:o;t=u}else{s=o;t=u}}else{s=o;t=p}while(0);q=q+1|0;if((q|0)>=(n|0)){v=s;w=t;break}else{o=s;p=t}}if((w|0)==-1){if((v|0)==-1){x=0;break}p=c[d+100>>2]|0;o=c[d+360>>2]|0;n=o+(v*20|0)+8|0;q=e[n>>1]|0;c[h>>2]=0;m=Xae(p,q+1|0,h)|0;if(c[h>>2]|0){x=m;break}r=c[d+364>>2]|0;y=o+(v*20|0)+12|0;z=Dae(r,c[y>>2]|0)|0;c[h>>2]=z;if((z|0)==0?(z=Gae(r,m,q)|0,c[h>>2]=z,(z|0)==0):0){a[m+q>>0]=0;x=m;break}c[y>>2]=0;b[n>>1]=0;n=o+(v*20|0)+16|0;$ae(p,c[n>>2]|0);c[n>>2]=0;$ae(p,m);x=0;break}m=c[d+100>>2]|0;p=c[d+360>>2]|0;n=p+(w*20|0)+8|0;o=b[n>>1]|0;y=(o&65535)>>>1;q=y&65535;c[g>>2]=0;z=Xae(m,(o&65535)+1|0,g)|0;if(!(c[g>>2]|0)){o=c[d+364>>2]|0;r=p+(w*20|0)+16|0;A=p+(w*20|0)+12|0;p=Dae(o,c[A>>2]|0)|0;c[g>>2]=p;if((p|0)==0?(p=Jae(o,e[n>>1]|0)|0,c[g>>2]=p,(p|0)==0):0){if(!(y<<16>>16))B=z;else{y=q;q=c[o+32>>2]|0;p=z;while(1){if((a[q>>0]|0)==0?(C=a[q+1>>0]|0,(C&255)>31&C<<24>>24>-1):0){a[p>>0]=C;D=p+1|0}else D=p;y=y+-1|0;if(!y){B=D;break}else{q=q+2|0;p=D}}}a[B>>0]=0;Lae(o);x=z;break}$ae(m,z);b[n>>1]=0;c[A>>2]=0;$ae(m,c[r>>2]|0);c[r>>2]=0;x=0}else x=z}else x=0;while(0);c[j>>2]=x;l=x;i=f;return l|0}function fde(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=m9d(c[c[(c[a+4>>2]|0)+220>>2]>>2]|0,b)|0;i=d;return e|0}function gde(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 7}function hde(a,b,c){a=a|0;b=b|0;c=c|0;return 7}function ide(a,b){a=a|0;b=b|0;return 7}function jde(a){a=a|0;return}function kde(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+32|0;g=f;c[g>>2]=0;c[g+4>>2]=b;c[g+8>>2]=d;c[g+12>>2]=0;c[g+16>>2]=0;c[e>>2]=2147483647;d=Tee(a,g,e)|0;i=f;return d|0}function lde(a,b){a=a|0;b=b|0;return 7}function mde(a){a=a|0;return}function nde(a,b,c){a=a|0;b=b|0;c=c|0;return 7}function ode(a,b){a=a|0;b=b|0;return 0}function pde(a,b){a=a|0;b=b|0;var d=0;d=i;if(b)$ae(c[a>>2]|0,b);i=d;return}function qde(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=Xae(c[a>>2]|0,508,e)|0;a=c[e>>2]|0;if(a){g=a;i=d;return g|0}a=f+40|0;c[a>>2]=24;c[f+44>>2]=2787;c[f+48>>2]=0;c[f+52>>2]=2788;c[f+56>>2]=2789;e=f+60|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[f+84>>2]=2790;c[f+88>>2]=2791;c[f>>2]=a;a=f+92|0;c[a>>2]=24;c[f+96>>2]=2787;c[f+100>>2]=0;c[f+104>>2]=2792;c[f+108>>2]=2793;e=f+112|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+132>>2]=2;c[f+136>>2]=2794;c[f+140>>2]=2795;c[f+4>>2]=a;a=f+144|0;c[a>>2]=56;c[f+148>>2]=2796;c[f+152>>2]=0;c[f+156>>2]=2797;c[f+160>>2]=2798;e=f+164|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+184>>2]=4;c[f+188>>2]=2799;c[f+192>>2]=2800;c[f+8>>2]=a;a=f+196|0;c[a>>2]=24;c[f+200>>2]=2787;c[f+204>>2]=0;c[f+208>>2]=2801;c[f+212>>2]=2802;e=f+216|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+236>>2]=6;c[f+240>>2]=2803;c[f+244>>2]=2804;c[f+12>>2]=a;a=f+248|0;c[a>>2]=24;c[f+252>>2]=2787;c[f+256>>2]=0;c[f+260>>2]=2805;c[f+264>>2]=2806;e=f+268|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+288>>2]=8;c[f+292>>2]=2807;c[f+296>>2]=2808;c[f+16>>2]=a;a=f+300|0;c[a>>2]=24;c[f+304>>2]=2787;c[f+308>>2]=0;c[f+312>>2]=2809;c[f+316>>2]=2810;e=f+320|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+340>>2]=10;c[f+344>>2]=2811;c[f+348>>2]=2812;c[f+20>>2]=a;a=f+352|0;c[a>>2]=44;c[f+356>>2]=2813;c[f+360>>2]=0;c[f+364>>2]=2814;c[f+368>>2]=2815;e=f+372|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+392>>2]=12;c[f+396>>2]=2816;c[f+400>>2]=2817;c[f+24>>2]=a;a=f+404|0;c[a>>2]=44;c[f+408>>2]=2818;c[f+412>>2]=0;c[f+416>>2]=2819;c[f+420>>2]=2820;e=f+424|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[f+444>>2]=13;c[f+448>>2]=2821;c[f+452>>2]=2822;c[f+28>>2]=a;a=f+456|0;c[a>>2]=40;c[f+460>>2]=2823;c[f+464>>2]=3553;c[f+468>>2]=2824;c[f+472>>2]=2825;c[f+476>>2]=265;c[f+480>>2]=1752;c[f+484>>2]=2826;c[f+488>>2]=1753;c[f+492>>2]=1754;c[f+496>>2]=14;c[f+500>>2]=2827;c[f+504>>2]=2828;c[f+32>>2]=a;c[f+36>>2]=0;c[b>>2]=f;g=0;i=d;return g|0}function rde(a){a=a|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+80|0;g=f;h=f+16|0;j=f+48|0;k=f+4|0;l=f+60|0;m=f+64|0;n=f+12|0;o=f+24|0;p=f+20|0;q=f+8|0;r=c[a+500>>2]|0;s=a+504|0;t=r+(c[s>>2]|0)|0;c[h>>2]=r;u=c[(c[a+96>>2]|0)+4>>2]|0;if(!(c[h>>2]|0)){v=8;i=f;return v|0}if(((c[h>>2]|0)+4|0)>>>0>t>>>0){v=8;i=f;return v|0}c[h>>2]=(c[h>>2]|0)+2;w=c[h>>2]|0;if(d[(c[h>>2]|0)+-1>>0]|0|(d[(c[h>>2]|0)+-2>>0]|0)<<8){c[h>>2]=w+-2;v=8;i=f;return v|0}c[h>>2]=w+2;c[g>>2]=d[(c[h>>2]|0)+-1>>0]|0|(d[(c[h>>2]|0)+-2>>0]|0)<<8;if(!(c[g>>2]|0)){v=0;i=f;return v|0}w=j+8|0;x=j+10|0;y=j+4|0;z=u+220|0;u=a+264|0;A=o+20|0;B=o+12|0;while(1){if(((c[h>>2]|0)+8|0)>>>0>t>>>0){v=0;C=18;break}c[h>>2]=(c[h>>2]|0)+2;b[w>>1]=d[(c[h>>2]|0)+-1>>0]|0|(d[(c[h>>2]|0)+-2>>0]|0)<<8;c[h>>2]=(c[h>>2]|0)+2;b[x>>1]=d[(c[h>>2]|0)+-1>>0]|0|(d[(c[h>>2]|0)+-2>>0]|0)<<8;c[j>>2]=a;c[y>>2]=0;c[h>>2]=(c[h>>2]|0)+4;D=(d[(c[h>>2]|0)+-3>>0]|0)<<16|(d[(c[h>>2]|0)+-4>>0]|0)<<24|(d[(c[h>>2]|0)+-2>>0]|0)<<8|(d[(c[h>>2]|0)+-1>>0]|0);if((D|0)!=0?D>>>0<=((c[s>>2]|0)+-2|0)>>>0:0){c[k>>2]=r+D;c[l>>2]=d[(c[k>>2]|0)+1>>0]|0|(d[c[k>>2]>>0]|0)<<8;c[m>>2]=c[(c[z>>2]|0)+20>>2];a:do if(c[c[m>>2]>>2]|0){while(1){c[n>>2]=c[c[m>>2]>>2];if((c[(c[n>>2]|0)+40>>2]|0)==(c[l>>2]|0))break;c[m>>2]=(c[m>>2]|0)+4;if(!(c[c[m>>2]>>2]|0))break a}c[p>>2]=0;n9d(o,c[k>>2]|0,t,0);c[A>>2]=e[u>>1];c[p>>2]=_n[c[(c[n>>2]|0)+44>>2]&4095](c[k>>2]|0,o)|0;if((c[B>>2]|0)==0?(N9d(c[n>>2]|0,c[k>>2]|0,j,q)|0)==0:0)c[(c[q>>2]|0)+20>>2]=c[p>>2]}while(0)}c[g>>2]=(c[g>>2]|0)+-1;if(!(c[g>>2]|0)){v=0;C=18;break}}if((C|0)==18){i=f;return v|0}return 0}function sde(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[a+12>>2]|0)+48>>2]&4095](a,b)|0;i=d;return e|0}function tde(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return 0}function ude(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;if(b>>>0>=256){f=0;i=e;return f|0}f=d[(c[a+16>>2]|0)+(b+6)>>0]|0;i=e;return f|0}function vde(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[b+16>>2]|0;b=c[d>>2]|0;g=0;while(1){h=b+1|0;if(h>>>0>=256){j=g;k=0;break}l=a[f+(b+7)>>0]|0;m=l&255;if(!(l<<24>>24)){b=h;g=m}else{j=m;k=h;break}}c[d>>2]=k;i=e;return j|0}function wde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;f=(d[a+2>>0]|0)<<8|(d[a+3>>0]|0);if(f>>>0<262?1:(a+f|0)>>>0>(c[b+4>>2]|0)>>>0)o9d(b,8);if(!(c[b+8>>2]|0)){i=e;return 0}f=b+20|0;g=0;h=a+6|0;while(1){if((d[h>>0]|0)>>>0>=(c[f>>2]|0)>>>0)o9d(b,16);g=g+1|0;if((g|0)==256)break;else h=h+1|0}i=e;return 0}function xde(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=0;c[b>>2]=(d[e+4>>0]|0)<<8|(d[e+5>>0]|0);return 0}function yde(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[b+16>>2]|0;if(e>>>0>=65536){h=0;i=f;return h|0}b=e>>>8;if(!b){j=e<<1&510;if(!(d[g+(j+6)>>0]<<8|d[g+(j+7)>>0])){k=518;l=g+518|0}else{h=0;i=f;return h|0}}else{j=b<<1;b=d[g+(j+7)>>0]&248|d[g+(j+6)>>0]<<8;j=b+518|0;if(!b){h=0;i=f;return h|0}else{k=j;l=g+j|0}}j=k+6|0;b=k+7|0;m=d[g+j>>0]<<8|d[g+b>>0];n=(e&255)-(d[l>>0]<<8|d[g+(k+1)>>0])|0;if(!((m|0)!=0?n>>>0<(d[g+(k+2)>>0]<<8|d[g+(k+3)>>0])>>>0:0)){h=0;i=f;return h|0}l=m+(n<<1)|0;n=d[g+(j+l)>>0]<<8|d[g+(b+l)>>0];if(!n){h=0;i=f;return h|0}h=n+(a[g+(k+4)>>0]<<8|d[g+(k+5)>>0])&65535;i=f;return h|0}function zde(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=c[b+16>>2]|0;b=(c[e>>2]|0)+1|0;if(b>>>0>=65536){h=0;j=0;c[e>>2]=j;i=f;return h|0}k=g+518|0;l=b;a:while(1){b=l>>>8;if(!b){m=l<<1&510;if(!(d[g+(m+6)>>0]<<8|d[g+(m+7)>>0])){n=518;o=k;p=6}else q=l}else{m=b<<1;b=d[g+(m+7)>>0]&248|d[g+(m+6)>>0]<<8;m=b+518|0;if(!b)q=l;else{n=m;o=g+m|0;p=6}}if((p|0)==6){p=0;m=d[o>>0]<<8|d[g+(n+1)>>0];b=d[g+(n+2)>>0]<<8|d[g+(n+3)>>0];r=n+6|0;s=a[g+(n+4)>>0]<<8|d[g+(n+5)>>0];t=d[g+r>>0]<<8|d[g+(n+7)>>0];u=l&255;if(t){v=u>>>0<m>>>0;w=v?0:u-m|0;x=(v?m:u)+(l&-256)|0;if(w>>>0<b>>>0){u=x;m=g+(r+(w<<1)+t)|0;t=w;while(1){w=d[m>>0]<<8|d[m+1>>0];m=m+2|0;if((w|0)!=0?(r=w+s&65535,(r|0)!=0):0){h=r;j=u;p=13;break a}t=t+1|0;r=u+1|0;if(t>>>0>=b>>>0){q=r;break}else u=r}}else q=x}else q=l}l=q+256&-256;if(l>>>0>=65536){h=0;j=0;p=13;break}}if((p|0)==13){c[e>>2]=j;i=f;return h|0}return 0}function Ade(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;g=d[b+2>>0]<<8|d[b+3>>0];h=b+g|0;j=e+4|0;if(g>>>0<518?1:h>>>0>(c[j>>2]|0)>>>0)o9d(e,8);g=e+8|0;k=b+518|0;l=0;m=0;n=b+6|0;while(1){o=d[n+1>>0]|0;p=d[n>>0]<<8|o;if(!((c[g>>2]|0)>>>0<2|(o&7|0)==0))o9d(e,8);o=p>>>3;p=o>>>0>l>>>0?o:l;m=m+1|0;if((m|0)==256){q=p;break}else{l=p;n=n+2|0}}n=b+((q<<3)+526)|0;if(n>>>0>(c[j>>2]|0)>>>0)o9d(e,8);j=e+20|0;b=0;l=k;while(1){k=l;m=d[l>>0]<<8|d[l+1>>0];p=d[l+2>>0]<<8|d[l+3>>0];o=a[l+4>>0]<<8|d[l+5>>0];r=l+8|0;s=d[l+6>>0]<<8|d[l+7>>0];if(p){if((c[g>>2]|0)>>>0>1?m>>>0>255|(p+m|0)>>>0>256:0)o9d(e,8);if(s){m=s+6|0;if(!((l+m|0)>>>0>=n>>>0?(l+(m+(p<<1))|0)>>>0<=h>>>0:0))o9d(e,9);if(c[g>>2]|0){m=l+((p<<1)+8)|0;s=l+((p<<1)+8)|0;p=l+10|0;t=(s>>>0>p>>>0?s:p)+(-9-k)|0;k=r;do{p=d[k>>0]<<8|d[k+1>>0];k=k+2|0;if((p|0)!=0?(p+o&65535)>>>0>=(c[j>>2]|0)>>>0:0)o9d(e,16)}while(k>>>0<m>>>0);u=l+(t+10&-2)|0}else u=r}else u=r}else u=r;b=b+1|0;if(b>>>0>q>>>0)break;else l=u}i=f;return 0}function Bde(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=2;c[b>>2]=(d[e+4>>0]|0)<<8|(d[e+5>>0]|0);return 0}function Cde(a,b){a=a|0;b=b|0;c[a+16>>2]=b;c[a+32>>2]=((d[b+6>>0]|0)<<8|(d[b+7>>0]|0))>>>1;c[a+24>>2]=-1;c[a+28>>2]=0;return 0}function Dde(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;do if(b>>>0<=65535)if(!(c[a+20>>2]&1)){f=nee(a,e,0)|0;break}else{f=mee(a,e,0)|0;break}else f=0;while(0);i=d;return f|0}function Ede(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[b>>2]|0;do if(e>>>0<=65534){if(c[a+20>>2]&1){f=mee(a,b,1)|0;break}g=a+24|0;if((e|0)!=(c[g>>2]|0)){f=nee(a,b,1)|0;break}oee(a);h=c[a+28>>2]|0;if(h){c[b>>2]=c[g>>2];f=h}else f=0}else f=0;while(0);i=d;return f|0}function Fde(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;g=d[b+2>>0]<<8|d[b+3>>0];if(g>>>0<16)o9d(e,8);h=e+4|0;j=e+8|0;if((b+g|0)>>>0>(c[h>>2]|0)>>>0){if(c[j>>2]|0)o9d(e,8);k=(c[h>>2]|0)-b|0}else k=g;g=d[b+7>>0]|0;l=d[b+6>>0]<<8|g;if(!((c[j>>2]|0)>>>0<2|(g&1|0)==0))o9d(e,8);g=l>>>1;l=g<<1;if(k>>>0<((g<<3)+16|0)>>>0)o9d(e,8);if((c[j>>2]|0)>>>0>1){m=a[b+9>>0]|0;n=d[b+8>>0]<<8|m&255;o=d[b+10>>0]<<8|d[b+11>>0];p=a[b+13>>0]|0;q=d[b+12>>0]<<8|p&255;if((p|m)&1)o9d(e,8);m=n>>>1;if(!(m<<1>>>0>=g>>>0&m>>>0<=g>>>0&((q>>>1)+m|0)==(g|0)&(m|0)==(1<<o|0)))o9d(e,8)}o=b+14|0;m=l+16|0;q=b+m|0;n=m+l|0;m=b+n|0;p=n+l|0;n=b+p|0;r=b+(p+l)|0;if((c[j>>2]|0)>>>0>1?(d[b+(l+12)>>0]<<8|d[b+(l+13)>>0]|0)!=65535:0)o9d(e,8);if(!g){s=0;i=f;return s|0}l=g+-1|0;p=e+20|0;t=b+k|0;k=0;b=0;u=0;v=0;w=m;m=o;o=n;n=q;while(1){q=n;n=n+2|0;x=u;u=d[q>>0]<<8|d[q+1>>0];q=m;m=m+2|0;y=b;b=d[q>>0]<<8|d[q+1>>0];q=a[w>>0]<<8|d[w+1>>0];w=w+2|0;z=o;o=o+2|0;A=d[z>>0]<<8|d[z+1>>0];if(b>>>0<u>>>0)o9d(e,8);do if(u>>>0<=y>>>0&(v|0)!=0){if(c[j>>2]|0){o9d(e,8);B=k;break}if(x>>>0>u>>>0|y>>>0>b>>>0){B=k|1;break}else{B=k|2;break}}else B=k;while(0);do if((A|0)==65535){if((c[j>>2]|0)>>>0<=1?(v|0)==(l|0)&(u|0)==65535&(b|0)==65535:0)break;o9d(e,8)}else if(A){y=z+A|0;do if(!(c[j>>2]|0)){if(!((v|0)==(l|0)&(u|0)==65535&(b|0)==65535)){if(y>>>0>=r>>>0?(z+((b-u<<1)+2+A)|0)>>>0<=(c[h>>2]|0)>>>0:0)break;o9d(e,8)}}else{if(y>>>0>=r>>>0?(z+((b-u<<1)+2+A)|0)>>>0<=t>>>0:0)break;o9d(e,8)}while(0);if((c[j>>2]|0)!=0&b>>>0>u>>>0){x=u;C=y;do{D=d[C>>0]<<8|d[C+1>>0];C=C+2|0;if((D|0)!=0?(D+q&65535)>>>0>=(c[p>>2]|0)>>>0:0)o9d(e,16);x=x+1|0}while((x|0)!=(b|0))}}while(0);v=v+1|0;if(v>>>0>=g>>>0){s=B;break}else k=B}i=f;return s|0}function Gde(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=4;c[b>>2]=(d[e+4>>0]|0)<<8|(d[e+5>>0]|0);return 0}function Hde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;f=c[a+16>>2]|0;a=b-((d[f+6>>0]|0)<<8|(d[f+7>>0]|0))|0;if(a>>>0>=((d[f+8>>0]|0)<<8|(d[f+9>>0]|0))>>>0){g=0;i=e;return g|0}b=a<<1;g=(d[f+(b+10)>>0]|0)<<8|(d[f+(b+11)>>0]|0);i=e;return g|0}function Ide(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=c[a+16>>2]|0;a=(c[b>>2]|0)+1|0;g=(d[f+6>>0]|0)<<8|(d[f+7>>0]|0);h=(d[f+8>>0]|0)<<8|(d[f+9>>0]|0);a:do if(a>>>0<=65535?(j=a>>>0<g>>>0?g:a,k=j-g|0,k>>>0<h>>>0):0){l=j;j=k;m=f+((k<<1)+10)|0;while(1){k=(d[m>>0]|0)<<8|(d[m+1>>0]|0);if(k){n=k;o=l;break a}j=j+1|0;if(j>>>0>=h>>>0){n=0;o=0;break}else{l=l+1|0;m=m+2|0}}}else{n=0;o=0}while(0);c[b>>2]=o;i=e;return n|0}function Jde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+10|0;g=b+4|0;if(f>>>0>(c[g>>2]|0)>>>0)o9d(b,8);h=(d[a+2>>0]|0)<<8|(d[a+3>>0]|0);j=(d[a+8>>0]|0)<<8|(d[a+9>>0]|0);if(!((a+h|0)>>>0<=(c[g>>2]|0)>>>0?h>>>0>=((j<<1)+10|0)>>>0:0))o9d(b,8);if(!((c[b+8>>2]|0)!=0&(j|0)!=0)){i=e;return 0}h=b+20|0;g=j;j=f;while(1){if(((d[j>>0]|0)<<8|(d[j+1>>0]|0))>>>0>=(c[h>>2]|0)>>>0)o9d(b,16);g=g+-1|0;if(!g)break;else j=j+2|0}i=e;return 0}function Kde(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=6;c[b>>2]=(d[e+4>>0]|0)<<8|(d[e+5>>0]|0);return 0}function Lde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[a+16>>2]|0;a=(d[f+8205>>0]|0)<<16|(d[f+8204>>0]|0)<<24|(d[f+8206>>0]|0)<<8|(d[f+8207>>0]|0);if(!a){g=0;i=e;return g|0}h=a;a=f+8208|0;while(1){f=(d[a+1>>0]|0)<<16|(d[a>>0]|0)<<24|(d[a+2>>0]|0)<<8|(d[a+3>>0]|0);if(f>>>0>b>>>0){g=0;j=7;break}h=h+-1|0;if(((d[a+5>>0]|0)<<16|(d[a+4>>0]|0)<<24|(d[a+6>>0]|0)<<8|(d[a+7>>0]|0))>>>0>=b>>>0){k=f;l=a;j=6;break}if(!h){g=0;j=7;break}else a=a+12|0}if((j|0)==6){g=b-k+((d[l+9>>0]|0)<<16|(d[l+8>>0]|0)<<24|(d[l+10>>0]|0)<<8|(d[l+11>>0]|0))|0;i=e;return g|0}else if((j|0)==7){i=e;return g|0}return 0}function Mde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[a+16>>2]|0;a=(d[f+8205>>0]|0)<<16|(d[f+8204>>0]|0)<<24|(d[f+8206>>0]|0)<<8|(d[f+8207>>0]|0);if(!a){g=0;h=0;c[b>>2]=h;i=e;return g|0}j=(c[b>>2]|0)+1|0;k=a;a=f+8208|0;while(1){f=(d[a+1>>0]|0)<<16|(d[a>>0]|0)<<24|(d[a+2>>0]|0)<<8|(d[a+3>>0]|0);l=a;a=a+12|0;j=j>>>0<f>>>0?f:j;if(j>>>0<=((d[l+5>>0]|0)<<16|(d[l+4>>0]|0)<<24|(d[l+6>>0]|0)<<8|(d[l+7>>0]|0))>>>0?(m=((d[l+9>>0]|0)<<16|(d[l+8>>0]|0)<<24|(d[l+10>>0]|0)<<8|(d[l+11>>0]|0))+(j-f)|0,(m|0)!=0):0){g=m;h=j;n=6;break}k=k+-1|0;if(!k){g=0;h=0;n=6;break}}if((n|0)==6){c[b>>2]=h;i=e;return g|0}return 0}function Nde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=a+8208|0;g=b+4|0;if(f>>>0>(c[g>>2]|0)>>>0)o9d(b,8);h=(d[a+5>>0]|0)<<16|(d[a+4>>0]|0)<<24|(d[a+6>>0]|0)<<8|(d[a+7>>0]|0);if(h>>>0<8208?1:h>>>0>((c[g>>2]|0)-a|0)>>>0)o9d(b,8);h=(d[a+8205>>0]|0)<<16|(d[a+8204>>0]|0)<<24|(d[a+8206>>0]|0)<<8|(d[a+8207>>0]|0);if((a+((h*12|0)+8208)|0)>>>0>(c[g>>2]|0)>>>0)o9d(b,8);if(!h){i=e;return 0}g=b+8|0;j=b+20|0;k=0;l=0;m=f;do{f=(d[m+1>>0]|0)<<16|(d[m>>0]|0)<<24;n=f|(d[m+2>>0]|0)<<8|(d[m+3>>0]|0);o=(d[m+5>>0]|0)<<16|(d[m+4>>0]|0)<<24;p=k;k=o|(d[m+6>>0]|0)<<8|(d[m+7>>0]|0);q=(d[m+9>>0]|0)<<16|(d[m+8>>0]|0)<<24|(d[m+10>>0]|0)<<8|(d[m+11>>0]|0);m=m+12|0;if(k>>>0<n>>>0)o9d(b,8);if(!((l|0)==0|n>>>0>p>>>0))o9d(b,8);do if(c[g>>2]|0){p=k-n|0;if((p+q|0)>>>0>=(c[j>>2]|0)>>>0)o9d(b,16);r=p+1|0;if(!f){if(o)o9d(b,8);if(!r)break;else{s=r;t=n}while(1){if((d[a+((t>>>3&8191)+12)>>0]|0)&128>>>(t&7))o9d(b,8);s=s+-1|0;if(!s)break;else t=t+1|0}}else{if(!r)break;else{u=r;v=n}while(1){if(!((d[a+((v>>>19)+12)>>0]|0)&128>>>(v>>>16&7)))o9d(b,8);if(!((d[a+((v>>>3&8191)+12)>>0]|0)&128>>>(v&7)))o9d(b,8);u=u+-1|0;if(!u)break;else v=v+1|0}}}while(0);l=l+1|0}while((l|0)!=(h|0));i=e;return 0}function Ode(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=8;c[b>>2]=(d[e+9>>0]|0)<<16|(d[e+8>>0]|0)<<24|(d[e+10>>0]|0)<<8|(d[e+11>>0]|0);return 0}function Pde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;f=c[a+16>>2]|0;a=b-((d[f+13>>0]|0)<<16|(d[f+12>>0]|0)<<24|(d[f+14>>0]|0)<<8|(d[f+15>>0]|0))|0;if(a>>>0>=((d[f+17>>0]|0)<<16|(d[f+16>>0]|0)<<24|(d[f+18>>0]|0)<<8|(d[f+19>>0]|0))>>>0){g=0;i=e;return g|0}b=a<<1;g=(d[f+(b+20)>>0]|0)<<8|(d[f+(b+21)>>0]|0);i=e;return g|0}function Qde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=c[a+16>>2]|0;a=(c[b>>2]|0)+1|0;g=(d[f+13>>0]|0)<<16|(d[f+12>>0]|0)<<24|(d[f+14>>0]|0)<<8|(d[f+15>>0]|0);h=(d[f+17>>0]|0)<<16|(d[f+16>>0]|0)<<24|(d[f+18>>0]|0)<<8|(d[f+19>>0]|0);j=a>>>0<g>>>0?g:a;a=j-g|0;if(a>>>0>=h>>>0){k=j;l=0;c[b>>2]=k;i=e;return l|0}g=j;j=a;m=f+((a<<1)+20)|0;while(1){a=(d[m>>0]|0)<<8|(d[m+1>>0]|0);if(a){k=g;l=a;n=5;break}a=g+1|0;j=j+1|0;if(j>>>0>=h>>>0){k=a;l=0;n=5;break}else{g=a;m=m+2|0}}if((n|0)==5){c[b>>2]=k;i=e;return l|0}return 0}function Rde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+20|0;g=b+4|0;if(f>>>0>(c[g>>2]|0)>>>0)o9d(b,8);h=(d[a+5>>0]|0)<<16|(d[a+4>>0]|0)<<24|(d[a+6>>0]|0)<<8|(d[a+7>>0]|0);j=(d[a+17>>0]|0)<<16|(d[a+16>>0]|0)<<24|(d[a+18>>0]|0)<<8|(d[a+19>>0]|0);if(!(h>>>0<=((c[g>>2]|0)-a|0)>>>0?h>>>0>=((j<<1)+20|0)>>>0:0))o9d(b,8);if(!((c[b+8>>2]|0)!=0&(j|0)!=0)){i=e;return 0}h=b+20|0;a=j;j=f;while(1){if(((d[j>>0]|0)<<8|(d[j+1>>0]|0))>>>0>=(c[h>>2]|0)>>>0)o9d(b,16);a=a+-1|0;if(!a)break;else j=j+2|0}i=e;return 0}function Sde(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=10;c[b>>2]=(d[e+9>>0]|0)<<16|(d[e+8>>0]|0)<<24|(d[e+10>>0]|0)<<8|(d[e+11>>0]|0);return 0}function Tde(b,e){b=b|0;e=e|0;c[b+16>>2]=e;c[b+40>>2]=(d[e+13>>0]|0)<<16|(d[e+12>>0]|0)<<24|(d[e+14>>0]|0)<<8|(d[e+15>>0]|0);a[b+24>>0]=0;return 0}function Ude(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=pee(a,e,0)|0;i=d;return b|0}function Vde(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+28|0;g=c[f>>2]|0;do if((g|0)==-1)h=0;else{j=b+24|0;if((a[j>>0]|0)!=0?(g|0)==(c[d>>2]|0):0){qee(b);if(!(a[j>>0]|0)){h=0;break}j=c[b+32>>2]|0;if(!j){h=0;break}c[d>>2]=c[f>>2];h=j;break}h=pee(b,d,1)|0}while(0);i=e;return h|0}function Wde(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+16|0;g=b+4|0;if(f>>>0>(c[g>>2]|0)>>>0)o9d(b,8);h=(d[a+5>>0]|0)<<16|(d[a+4>>0]|0)<<24|(d[a+6>>0]|0)<<8|(d[a+7>>0]|0);j=(d[a+13>>0]|0)<<16|(d[a+12>>0]|0)<<24|(d[a+14>>0]|0)<<8|(d[a+15>>0]|0);if(!(h>>>0<=((c[g>>2]|0)-a|0)>>>0?h>>>0>=((j*12|0)+16|0)>>>0:0))o9d(b,8);if(!j){i=e;return 0}h=b+8|0;a=b+20|0;g=0;k=0;l=f;do{f=(d[l+1>>0]|0)<<16|(d[l>>0]|0)<<24|(d[l+2>>0]|0)<<8|(d[l+3>>0]|0);m=g;g=(d[l+5>>0]|0)<<16|(d[l+4>>0]|0)<<24|(d[l+6>>0]|0)<<8|(d[l+7>>0]|0);n=(d[l+9>>0]|0)<<16|(d[l+8>>0]|0)<<24|(d[l+10>>0]|0)<<8|(d[l+11>>0]|0);l=l+12|0;if(g>>>0<f>>>0)o9d(b,8);if(!((k|0)==0|f>>>0>m>>>0))o9d(b,8);if((c[h>>2]|0)!=0?(g-f+n|0)>>>0>=(c[a>>2]|0)>>>0:0)o9d(b,16);k=k+1|0}while((k|0)!=(j|0));i=e;return 0}function Xde(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=12;c[b>>2]=(d[e+9>>0]|0)<<16|(d[e+8>>0]|0)<<24|(d[e+10>>0]|0)<<8|(d[e+11>>0]|0);return 0}function Yde(b,e){b=b|0;e=e|0;c[b+16>>2]=e;c[b+40>>2]=(d[e+13>>0]|0)<<16|(d[e+12>>0]|0)<<24|(d[e+14>>0]|0)<<8|(d[e+15>>0]|0);a[b+24>>0]=0;return 0}function Zde(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=ree(a,e,0)|0;i=d;return b|0}function _de(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+28|0;g=c[f>>2]|0;do if((g|0)==-1)h=0;else{j=b+24|0;if((a[j>>0]|0)!=0?(g|0)==(c[d>>2]|0):0){see(b);if(!(a[j>>0]|0)){h=0;break}j=c[b+32>>2]|0;if(!j){h=0;break}c[d>>2]=c[f>>2];h=j;break}h=ree(b,d,1)|0}while(0);i=e;return h|0}function $de(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+16|0;g=b+4|0;if(f>>>0>(c[g>>2]|0)>>>0)o9d(b,8);h=(d[a+5>>0]|0)<<16|(d[a+4>>0]|0)<<24|(d[a+6>>0]|0)<<8|(d[a+7>>0]|0);j=(d[a+13>>0]|0)<<16|(d[a+12>>0]|0)<<24|(d[a+14>>0]|0)<<8|(d[a+15>>0]|0);if(!(h>>>0<=((c[g>>2]|0)-a|0)>>>0?h>>>0>=((j*12|0)+16|0)>>>0:0))o9d(b,8);if(!j){i=e;return 0}h=b+8|0;a=b+20|0;g=0;k=0;l=f;do{f=(d[l+1>>0]|0)<<16|(d[l>>0]|0)<<24|(d[l+2>>0]|0)<<8|(d[l+3>>0]|0);m=g;g=(d[l+5>>0]|0)<<16|(d[l+4>>0]|0)<<24|(d[l+6>>0]|0)<<8|(d[l+7>>0]|0);n=(d[l+9>>0]|0)<<16|(d[l+8>>0]|0)<<24|(d[l+10>>0]|0)<<8|(d[l+11>>0]|0);l=l+12|0;if(f>>>0>g>>>0)o9d(b,8);if(!((k|0)==0|f>>>0>m>>>0))o9d(b,8);if((c[h>>2]|0)!=0?n>>>0>=(c[a>>2]|0)>>>0:0)o9d(b,16);k=k+1|0}while((k|0)!=(j|0));i=e;return 0}function aee(a,b){a=a|0;b=b|0;var e=0;e=c[a+16>>2]|0;c[b+4>>2]=13;c[b>>2]=(d[e+9>>0]|0)<<16|(d[e+8>>0]|0)<<24|(d[e+10>>0]|0)<<8|(d[e+11>>0]|0);return 0}function bee(a,b){a=a|0;b=b|0;c[a+16>>2]=b;c[a+24>>2]=(d[b+7>>0]|0)<<16|(d[b+6>>0]|0)<<24|(d[b+8>>0]|0)<<8|(d[b+9>>0]|0);c[a+28>>2]=0;c[a+32>>2]=0;return 0}function cee(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+36>>2]|0;c[a+28>>2]=0;if(!d){i=b;return}e=a+32|0;a=c[e>>2]|0;if(!a){i=b;return}$ae(d,a);c[e>>2]=0;i=b;return}function dee(a,b){a=a|0;b=b|0;return 0}function eee(a,b){a=a|0;b=b|0;c[b>>2]=0;return 0}function fee(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=c[a+16>>2]|0;a=(d[h+7>>0]|0)<<16|(d[h+6>>0]|0)<<24|(d[h+8>>0]|0)<<8|(d[h+9>>0]|0);if(!a){j=0;i=g;return j|0}else{k=a;l=0}a:while(1){a=l;while(1){m=(a+k|0)>>>1;n=m*11|0;o=(d[h+(n+11)>>0]|0)<<8|(d[h+(n+10)>>0]|0)<<16|(d[h+(n+12)>>0]|0);if(o>>>0>f>>>0){p=m;q=a;break}a=m+1|0;if(o>>>0>=f>>>0){r=n;s=7;break a}if(a>>>0>=k>>>0){j=0;s=24;break a}}if(q>>>0<p>>>0){k=p;l=q}else{j=0;s=24;break}}if((s|0)==7){q=h+(r+13)|0;if(!q){j=0;i=g;return j|0}l=(d[h+(r+14)>>0]|0)<<16|(d[q>>0]|0)<<24|(d[h+(r+15)>>0]|0)<<8|(d[h+(r+16)>>0]|0);q=(d[h+(r+18)>>0]|0)<<16|(d[h+(r+17)>>0]|0)<<24|(d[h+(r+19)>>0]|0)<<8|(d[h+(r+20)>>0]|0);b:do if(l){r=l+4|0;p=l+5|0;k=l+6|0;f=l+7|0;a=(d[h+(l+1)>>0]|0)<<16|(d[h+l>>0]|0)<<24|(d[h+(l+2)>>0]|0)<<8|(d[h+(l+3)>>0]|0);n=0;while(1){o=a;while(1){if(n>>>0>=o>>>0)break b;m=(o+n|0)>>>1;t=m<<2;u=(d[h+(p+t)>>0]|0)<<8|(d[h+(r+t)>>0]|0)<<16|(d[h+(k+t)>>0]|0);if(u>>>0>e>>>0)o=m;else{v=m;w=t;x=u;y=o;break}}if(((d[h+(f+w)>>0]|0)+x|0)>>>0<e>>>0){a=y;n=v+1|0}else break}j=_n[c[(c[b+12>>2]|0)+12>>2]&4095](b,e)|0;i=g;return j|0}while(0);if(!q){j=0;i=g;return j|0}b=(d[h+(q+1)>>0]|0)<<16|(d[h+q>>0]|0)<<24|(d[h+(q+2)>>0]|0)<<8|(d[h+(q+3)>>0]|0);if(!b){j=0;i=g;return j|0}v=q+4|0;y=q+5|0;x=q+6|0;w=b;b=0;c:while(1){l=b;while(1){n=(l+w|0)>>>1;a=n*5|0;f=(d[h+(y+a)>>0]|0)<<8|(d[h+(v+a)>>0]|0)<<16|(d[h+(x+a)>>0]|0);if(f>>>0>e>>>0){z=n;A=l;break}l=n+1|0;if(f>>>0>=e>>>0){B=a;s=23;break c}if(l>>>0>=w>>>0){j=0;s=24;break c}}if(A>>>0<z>>>0){w=z;b=A}else{j=0;s=24;break}}if((s|0)==23){j=(d[h+(q+7+B)>>0]|0)<<8|(d[h+(q+8+B)>>0]|0);i=g;return j|0}else if((s|0)==24){i=g;return j|0}}else if((s|0)==24){i=g;return j|0}return 0}function gee(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[a+16>>2]|0;a=(d[g+7>>0]|0)<<16|(d[g+6>>0]|0)<<24|(d[g+8>>0]|0)<<8|(d[g+9>>0]|0);if(!a){h=-1;i=f;return h|0}else{j=a;k=0}a:while(1){a=k;while(1){l=(a+j|0)>>>1;m=l*11|0;n=(d[g+(m+11)>>0]|0)<<8|(d[g+(m+10)>>0]|0)<<16|(d[g+(m+12)>>0]|0);if(n>>>0>e>>>0){o=l;p=a;break}a=l+1|0;if(n>>>0>=e>>>0){q=m;r=7;break a}if(a>>>0>=j>>>0){h=-1;r=24;break a}}if(p>>>0<o>>>0){j=o;k=p}else{h=-1;r=24;break}}if((r|0)==7){p=g+(q+13)|0;if(!p){h=-1;i=f;return h|0}k=(d[g+(q+14)>>0]|0)<<16|(d[p>>0]|0)<<24|(d[g+(q+15)>>0]|0)<<8|(d[g+(q+16)>>0]|0);p=(d[g+(q+18)>>0]|0)<<16|(d[g+(q+17)>>0]|0)<<24|(d[g+(q+19)>>0]|0)<<8|(d[g+(q+20)>>0]|0);b:do if(k){q=k+4|0;o=k+5|0;j=k+6|0;e=k+7|0;a=(d[g+(k+1)>>0]|0)<<16|(d[g+k>>0]|0)<<24|(d[g+(k+2)>>0]|0)<<8|(d[g+(k+3)>>0]|0);m=0;while(1){n=a;while(1){if(m>>>0>=n>>>0)break b;l=(n+m|0)>>>1;s=l<<2;t=(d[g+(o+s)>>0]|0)<<8|(d[g+(q+s)>>0]|0)<<16|(d[g+(j+s)>>0]|0);if(t>>>0>b>>>0)n=l;else{u=l;v=s;w=t;x=n;break}}if(((d[g+(e+v)>>0]|0)+w|0)>>>0<b>>>0){a=x;m=u+1|0}else{h=1;break}}i=f;return h|0}while(0);c:do if((p|0)!=0?(u=(d[g+(p+1)>>0]|0)<<16|(d[g+p>>0]|0)<<24|(d[g+(p+2)>>0]|0)<<8|(d[g+(p+3)>>0]|0),(u|0)!=0):0){x=p+4|0;w=p+5|0;v=p+6|0;k=u;u=0;d:while(1){m=u;while(1){a=(m+k|0)>>>1;e=a*5|0;j=(d[g+(w+e)>>0]|0)<<8|(d[g+(x+e)>>0]|0)<<16|(d[g+(v+e)>>0]|0);if(j>>>0>b>>>0){y=a;z=m;break}m=a+1|0;if(j>>>0>=b>>>0){A=e;break d}if(m>>>0>=k>>>0)break c}if(z>>>0<y>>>0){k=y;u=z}else break c}if((d[g+(p+7+A)>>0]|0)<<8|(d[g+(p+8+A)>>0]|0)){h=0;i=f;return h|0}}while(0);h=-1;i=f;return h|0}else if((r|0)==24){i=f;return h|0}return 0}function hee(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=c[a+24>>2]|0;h=c[a+16>>2]|0;j=g+1|0;k=a+28|0;l=c[k>>2]|0;c[f>>2]=0;do if(l>>>0<j>>>0){c[a+36>>2]=b;m=a+32|0;n=Zae(b,4,l,j,c[m>>2]|0,f)|0;c[m>>2]=n;if(!(c[f>>2]|0)){c[k>>2]=j;o=n;break}else{p=0;i=e;return p|0}}else o=c[a+32>>2]|0;while(0);if(!g)q=0;else{a=0;j=h+10|0;while(1){c[o+(a<<2)>>2]=(d[j+1>>0]|0)<<8|(d[j>>0]|0)<<16|(d[j+2>>0]|0);a=a+1|0;if((a|0)==(g|0)){q=g;break}else j=j+11|0}}c[o+(q<<2)>>2]=0;p=o;i=e;return p|0}function iee(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+16|0;g=f;h=c[a+24>>2]|0;j=a+16|0;k=c[j>>2]|0;l=h+1|0;m=a+28|0;n=c[m>>2]|0;c[g>>2]=0;do if(n>>>0<l>>>0){c[a+36>>2]=b;o=a+32|0;p=Zae(b,4,n,l,c[o>>2]|0,g)|0;c[o>>2]=p;if(!(c[g>>2]|0)){c[m>>2]=l;q=p;break}else{r=0;i=f;return r|0}}else q=c[a+32>>2]|0;while(0);if(!h)s=q;else{a=h;h=k+10|0;k=q;while(1){l=(d[h+1>>0]|0)<<8|(d[h>>0]|0)<<16|(d[h+2>>0]|0);m=(d[h+4>>0]|0)<<16|(d[h+3>>0]|0)<<24|(d[h+5>>0]|0)<<8|(d[h+6>>0]|0);g=(d[h+8>>0]|0)<<16|(d[h+7>>0]|0)<<24|(d[h+9>>0]|0)<<8|(d[h+10>>0]|0);h=h+11|0;a:do if(!m)t=13;else{n=c[j>>2]|0;b=m+4|0;p=m+5|0;o=m+6|0;u=m+7|0;v=(d[n+(m+1)>>0]|0)<<16|(d[n+m>>0]|0)<<24|(d[n+(m+2)>>0]|0)<<8|(d[n+(m+3)>>0]|0);w=0;while(1){x=v;while(1){if(w>>>0>=x>>>0){t=13;break a}y=(x+w|0)>>>1;z=y<<2;A=(d[n+(p+z)>>0]|0)<<8|(d[n+(b+z)>>0]|0)<<16|(d[n+(o+z)>>0]|0);if(A>>>0>e>>>0)x=y;else{B=y;C=z;D=A;E=x;break}}if(((d[n+(u+C)>>0]|0)+D|0)>>>0<e>>>0){v=E;w=B+1|0}else{t=22;break}}}while(0);b:do if((t|0)==13){t=0;if((g|0)!=0?(m=c[j>>2]|0,w=(d[m+(g+1)>>0]|0)<<16|(d[m+g>>0]|0)<<24|(d[m+(g+2)>>0]|0)<<8|(d[m+(g+3)>>0]|0),(w|0)!=0):0){v=g+4|0;u=g+5|0;n=g+6|0;o=w;w=0;c:while(1){b=w;while(1){p=(b+o|0)>>>1;x=p*5|0;A=(d[m+(u+x)>>0]|0)<<8|(d[m+(v+x)>>0]|0)<<16|(d[m+(n+x)>>0]|0);if(A>>>0>e>>>0){F=p;G=b;break}b=p+1|0;if(A>>>0>=e>>>0){H=x;break c}if(b>>>0>=o>>>0){I=k;break b}}if(G>>>0<F>>>0){o=F;w=G}else{I=k;break b}}if((d[m+(g+7+H)>>0]|0)<<8|(d[m+(g+8+H)>>0]|0))t=22;else I=k}else I=k}while(0);if((t|0)==22){t=0;c[k>>2]=l;I=k+4|0}a=a+-1|0;if(!a){s=I;break}else k=I}}c[s>>2]=0;r=q;i=f;return r|0}function jee(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[a+16>>2]|0;l=(d[k+7>>0]|0)<<16|(d[k+6>>0]|0)<<24|(d[k+8>>0]|0)<<8|(d[k+9>>0]|0);if(!l){m=0;i=f;return m|0}else{n=l;o=0}a:while(1){l=o;while(1){p=(l+n|0)>>>1;q=p*11|0;r=(d[k+(q+11)>>0]|0)<<8|(d[k+(q+10)>>0]|0)<<16|(d[k+(q+12)>>0]|0);if(r>>>0>e>>>0){s=p;t=l;break}l=p+1|0;if(r>>>0>=e>>>0){u=q;v=7;break a}if(l>>>0>=n>>>0){m=0;v=59;break a}}if(t>>>0<s>>>0){n=s;o=t}else{m=0;v=59;break}}if((v|0)==7){t=k+(u+13)|0;if(!t){m=0;i=f;return m|0}o=(d[k+(u+14)>>0]|0)<<16|(d[t>>0]|0)<<24|(d[k+(u+15)>>0]|0)<<8|(d[k+(u+16)>>0]|0);t=(d[k+(u+18)>>0]|0)<<16|(d[k+(u+17)>>0]|0)<<24|(d[k+(u+19)>>0]|0)<<8|(d[k+(u+20)>>0]|0);u=(t|0)==0;if(!(t|o)){m=0;i=f;return m|0}if(!o){s=(d[k+(t+1)>>0]|0)<<16|(d[k+t>>0]|0)<<24|(d[k+(t+2)>>0]|0)<<8|(d[k+(t+3)>>0]|0);n=s+1|0;e=a+28|0;l=c[e>>2]|0;c[h>>2]=0;do if(l>>>0<n>>>0){c[a+36>>2]=b;q=a+32|0;r=Zae(b,4,l,n,c[q>>2]|0,h)|0;c[q>>2]=r;if(!(c[h>>2]|0)){c[e>>2]=n;w=r;break}else{m=0;i=f;return m|0}}else w=c[a+32>>2]|0;while(0);if(!s)x=0;else{n=k+(t+4)|0;e=0;while(1){c[w+(e<<2)>>2]=(d[n+1>>0]|0)<<8|(d[n>>0]|0)<<16|(d[n+2>>0]|0);e=e+1|0;if((e|0)==(s|0)){x=s;break}else n=n+5|0}}c[w+(x<<2)>>2]=0;m=w;i=f;return m|0}w=k+o|0;if(u){m=tee(a,w,b)|0;i=f;return m|0}u=(d[k+(t+1)>>0]|0)<<16|(d[k+t>>0]|0)<<24|(d[k+(t+2)>>0]|0)<<8|(d[k+(t+3)>>0]|0);x=(d[k+(o+1)>>0]|0)<<16|(d[w>>0]|0)<<24|(d[k+(o+2)>>0]|0)<<8|(d[k+(o+3)>>0]|0);if(!x)y=0;else{n=k+(o+7)|0;s=x;e=0;while(1){h=e+1+(d[n>>0]|0)|0;s=s+-1|0;if(!s){y=h;break}else{n=n+4|0;e=h}}}if(!u){m=tee(a,w,b)|0;i=f;return m|0}w=u+1|0;if(!y){e=a+28|0;n=c[e>>2]|0;c[g>>2]=0;do if(n>>>0<w>>>0){c[a+36>>2]=b;s=a+32|0;h=Zae(b,4,n,w,c[s>>2]|0,g)|0;c[s>>2]=h;if(!(c[g>>2]|0)){c[e>>2]=w;z=h;break}else{m=0;i=f;return m|0}}else z=c[a+32>>2]|0;while(0);e=k+(t+4)|0;g=0;while(1){c[z+(g<<2)>>2]=(d[e+1>>0]|0)<<8|(d[e>>0]|0)<<16|(d[e+2>>0]|0);g=g+1|0;if((g|0)==(u|0))break;else e=e+5|0}c[z+(u<<2)>>2]=0;m=z;i=f;return m|0}z=w+y|0;y=a+28|0;w=c[y>>2]|0;c[j>>2]=0;do if(w>>>0<z>>>0){c[a+36>>2]=b;e=a+32|0;g=Zae(b,4,w,z,c[e>>2]|0,j)|0;c[e>>2]=g;if(!(c[j>>2]|0)){c[y>>2]=z;A=g;break}else{m=0;i=f;return m|0}}else A=c[a+32>>2]|0;while(0);a=d[k+(o+7)>>0]|0;z=1;y=k+(o+8)|0;j=(d[k+(o+5)>>0]|0)<<8|(d[k+(o+4)>>0]|0)<<16|(d[k+(o+6)>>0]|0);o=0;w=1;b=(d[k+(t+5)>>0]|0)<<8|(d[k+(t+4)>>0]|0)<<16|(d[k+(t+6)>>0]|0);g=k+(t+9)|0;b:while(1){if(b>>>0>(a+j|0)>>>0){t=a;k=z;e=y;n=j;h=o;while(1){s=h;l=0;while(1){r=s+1|0;c[A+(s<<2)>>2]=l+n;l=l+1|0;if(l>>>0>t>>>0){B=r;break}else s=r}s=k+1|0;if(s>>>0>x>>>0){C=t;D=s;E=e;F=n;G=B;H=w;I=b;J=g;break b}l=(d[e+1>>0]|0)<<8|(d[e>>0]|0)<<16|(d[e+2>>0]|0);r=e+4|0;q=d[e+3>>0]|0;if(b>>>0>(q+l|0)>>>0){t=q;k=s;e=r;n=l;h=B}else{K=q;L=s;M=r;N=l;O=B;break}}}else{K=a;L=z;M=y;N=j;O=o}if(b>>>0<N>>>0){c[A+(O<<2)>>2]=b;P=O+1|0}else P=O;h=w+1|0;if(h>>>0>u>>>0){C=K;D=L;E=M;F=N;G=P;H=h;I=b;J=g;break}a=K;z=L;y=M;j=N;o=P;w=h;b=(d[g+1>>0]|0)<<8|(d[g>>0]|0)<<16|(d[g+2>>0]|0);g=g+5|0}if(H>>>0>u>>>0)if(D>>>0<=x>>>0){g=G;b=0;while(1){w=g+1|0;c[A+(g<<2)>>2]=b+F;b=b+1|0;if(b>>>0>C>>>0){Q=w;break}else g=w}if(D>>>0<x>>>0){g=D;D=E;E=Q;while(1){C=(d[D+1>>0]|0)<<8|(d[D>>0]|0)<<16|(d[D+2>>0]|0);b=d[D+3>>0]|0;F=E;w=0;while(1){c[A+(F<<2)>>2]=w+C;if((w|0)==(b|0))break;else{F=F+1|0;w=w+1|0}}w=E+1+b|0;g=g+1|0;if((g|0)==(x|0)){R=w;break}else{D=D+4|0;E=w}}}else R=Q}else R=G;else{c[A+(G<<2)>>2]=I;I=G+1|0;if(H>>>0<u>>>0){Q=G+u+1|0;G=I;E=H;D=J;while(1){c[A+(G<<2)>>2]=(d[D+1>>0]|0)<<8|(d[D>>0]|0)<<16|(d[D+2>>0]|0);E=E+1|0;if((E|0)==(u|0))break;else{G=G+1|0;D=D+5|0}}R=Q-H|0}else R=I}c[A+(R<<2)>>2]=0;m=A;i=f;return m|0}else if((v|0)==59){i=f;return m|0}return 0}function kee(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=(d[a+3>>0]|0)<<16|(d[a+2>>0]|0)<<24|(d[a+4>>0]|0)<<8|(d[a+5>>0]|0);g=a+10|0;h=(d[a+7>>0]|0)<<16|(d[a+6>>0]|0)<<24|(d[a+8>>0]|0)<<8|(d[a+9>>0]|0);j=b+4|0;if(!(f>>>0<=((c[j>>2]|0)-a|0)>>>0?f>>>0>=((h*11|0)+10|0)>>>0:0))o9d(b,8);if(!h){i=e;return 0}k=b+8|0;l=b+20|0;m=1;n=0;o=g;do{g=(d[o+1>>0]|0)<<8|(d[o>>0]|0)<<16|(d[o+2>>0]|0);p=(d[o+4>>0]|0)<<16|(d[o+3>>0]|0)<<24|(d[o+5>>0]|0)<<8|(d[o+6>>0]|0);q=(d[o+8>>0]|0)<<16|(d[o+7>>0]|0)<<24|(d[o+9>>0]|0)<<8|(d[o+10>>0]|0);o=o+11|0;if(!(p>>>0<f>>>0&q>>>0<f>>>0))o9d(b,8);if(g>>>0<m>>>0)o9d(b,8);m=g+1|0;if(p){g=p+4|0;r=(d[a+(p+1)>>0]|0)<<16|(d[a+p>>0]|0)<<24|(d[a+(p+2)>>0]|0)<<8|(d[a+(p+3)>>0]|0);if((a+((r<<2)+g)|0)>>>0>(c[j>>2]|0)>>>0)o9d(b,8);if(r){p=a+g|0;g=0;s=0;while(1){t=(d[p+1>>0]|0)<<8|(d[p>>0]|0)<<16|(d[p+2>>0]|0);u=t+(d[p+3>>0]|0)|0;if(u>>>0>1114111)o9d(b,8);if(t>>>0<s>>>0)o9d(b,8);g=g+1|0;if((g|0)==(r|0))break;else{p=p+4|0;s=u+1|0}}}}if(q){s=a+(q+4)|0;p=(d[a+(q+1)>>0]|0)<<16|(d[a+q>>0]|0)<<24|(d[a+(q+2)>>0]|0)<<8|(d[a+(q+3)>>0]|0);if(p<<2>>>0>((c[j>>2]|0)-s|0)>>>0)o9d(b,8);if(p){r=0;g=0;u=s;do{s=(d[u+1>>0]|0)<<8|(d[u>>0]|0)<<16|(d[u+2>>0]|0);t=(d[u+3>>0]|0)<<8|(d[u+4>>0]|0);u=u+5|0;if(s>>>0>1114111)o9d(b,8);if(s>>>0<g>>>0)o9d(b,8);g=s+1|0;if((c[k>>2]|0)!=0?t>>>0>=(c[l>>2]|0)>>>0:0)o9d(b,16);r=r+1|0}while((r|0)!=(p|0))}}n=n+1|0}while((n|0)!=(h|0));i=e;return 0}function lee(a,b){a=a|0;b=b|0;c[b+4>>2]=14;c[b>>2]=-1;return 0}function mee(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=i;h=c[b+16>>2]|0;j=d[h+7>>0]&254|d[h+6>>0]<<8;k=j>>>1;if(!k){l=0;i=g;return l|0}m=f<<24>>24==0;n=(c[e>>2]|0)+(m&1^1)|0;if(n>>>0>=65536){l=0;i=g;return l|0}o=h+14|0;p=h+(j+16)|0;h=j|1;q=j<<1;r=q|1;s=k+-1|0;t=q|2;u=n;while(1){n=0;v=o;w=p;while(1){x=d[v>>0]<<8|d[v+1>>0];y=d[w>>0]<<8|d[w+1>>0];if(!(u>>>0<y>>>0|u>>>0>x>>>0)){z=a[w+j>>0]<<8|d[w+h>>0];A=w+q|0;B=d[A>>0]<<8|d[w+r>>0];if(n>>>0>=s>>>0&(y|0)==65535&(x|0)==65535){x=c[b>>2]|0;if(!B){C=z;D=12;break}E=(w+(t+B)|0)>>>0>((c[x+500>>2]|0)+(c[x+504>>2]|0)|0)>>>0;F=E?1:z;G=E?0:B}else{F=z;G=B}if((G|0)==65535)H=A;else if(!G){C=F;D=12;break}else{I=y;J=F;K=G;L=w;D=10;break}}else H=v+2|0;w=w+2|0;n=n+1|0;if(n>>>0>=k>>>0){M=0;break}else v=H}if((D|0)==10){D=0;v=(u-I<<1)+q+K|0;n=d[L+v>>0]<<8|d[L+(v+1)>>0];if(!n)M=0;else M=n+J&65535}else if((D|0)==12){D=0;M=C+u&65535}if(m|(M|0)!=0){N=u;O=M;break}u=u+1|0;if(u>>>0>=65536){l=0;D=18;break}}if((D|0)==18){i=g;return l|0}if(!(f<<24>>24!=0&(O|0)!=0)){l=O;i=g;return l|0}c[e>>2]=N;l=O;i=g;return l|0}function nee(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;g=i;h=c[b+16>>2]|0;j=d[h+7>>0]&254|d[h+6>>0]<<8;if(!j){k=0;i=g;return k|0}l=j>>>1;m=f<<24>>24!=0;f=(c[e>>2]|0)+(m&1)|0;n=j+2|0;o=65535;p=l;q=l;r=0;a:while(1){s=o;t=p;u=q;while(1){if(r>>>0>=t>>>0){v=s;w=0;x=u;break a}u=(t+r|0)>>>1;y=u<<1;z=y+14|0;A=d[h+z>>0]<<8|d[h+(y+15)>>0];y=z+n|0;z=d[h+y>>0]<<8|d[h+(y|1)>>0];if(f>>>0>=z>>>0){B=u;C=A;D=z;E=y;F=t;break}else{s=A;t=u}}u=B+1|0;if(f>>>0>C>>>0){o=C;p=F;q=B;r=u}else{G=B;H=C;I=D;J=u;K=E;L=7;break}}do if((L|0)==7){E=K+j|0;D=a[h+E>>0]<<8|d[h+(E|1)>>0];C=E+j|0;E=h+C|0;B=d[E>>0]<<8|d[h+(C|1)>>0];if(G>>>0>=(l+-1|0)>>>0&(I|0)==65535&(H|0)==65535){r=c[b>>2]|0;if(!B){M=D;N=0}else{q=(h+(C+2+B)|0)>>>0>((c[r+500>>2]|0)+(c[r+504>>2]|0)|0)>>>0;M=q?1:D;N=q?0:B}}else{M=D;N=B}q=(N|0)==65535;if(!(c[b+20>>2]&2))if(q){v=H;w=0;x=G;break}else{O=M;P=H;Q=G;R=N;S=E;T=I}else{r=q?J:G;b:do if(!G){U=M;V=H;W=0;X=r;Y=N;Z=E;_=I}else{q=M;C=H;F=G;p=r;o=N;u=E;t=I;while(1){s=F;F=F+-1|0;A=F<<1;y=A+14|0;z=d[h+y>>0]<<8|d[h+(A+15)>>0];if(f>>>0>z>>>0){U=q;V=C;W=s;X=p;Y=o;Z=u;_=t;break b}s=y+n|0;y=d[h+s>>0]<<8|d[h+(s|1)>>0];A=s+j|0;s=a[h+A>>0]<<8|d[h+(A|1)>>0];$=A+j|0;A=h+$|0;aa=d[A>>0]<<8|d[h+($|1)>>0];$=(aa|0)==65535?p:F;if(!F){U=s;V=z;W=0;X=$;Y=aa;Z=A;_=y;break}else{q=s;C=z;p=$;o=aa;u=A;t=y}}}while(0);if((X|0)==(J|0)){E=(W|0)==(G|0);r=E?V:H;if(J>>>0<l>>>0){ba=E?U:D;ca=r;da=J;ea=G;fa=E?Y:B;ga=E?_:I}else{v=r;w=0;x=G;break}while(1){r=da<<1;E=r+14|0;t=E+n|0;u=h+t|0;o=d[u>>0]<<8|d[h+(t|1)>>0];if(f>>>0<o>>>0){ha=ba;ia=ca;ja=da;ka=ea;la=fa;ma=u;na=ga;break}u=d[h+E>>0]<<8|d[h+(r+15)>>0];r=t+j|0;t=a[h+r>>0]<<8|d[h+(r|1)>>0];E=r+j|0;r=h+E|0;p=d[r>>0]<<8|d[h+(E|1)>>0];E=(p|0)==65535?ea:da;C=da+1|0;if(C>>>0<l>>>0){ba=t;ca=u;da=C;ea=E;fa=p;ga=o}else{ha=t;ia=u;ja=C;ka=E;la=p;ma=r;na=o;break}}B=ja+-1|0;if((ka|0)==(G|0)){v=ia;w=0;x=B;break}else{oa=ha;pa=ia;qa=B;ra=ka;sa=la;ta=ma;ua=na}}else{oa=U;pa=V;qa=W;ra=X;sa=Y;ta=Z;ua=_}if((ra|0)==(qa|0)){O=oa;P=pa;Q=ra;R=sa;S=ta;T=ua}else{B=ra<<1;D=B+14|0;o=D+n|0;r=o+j|0;p=r+j|0;E=h+p|0;O=a[h+r>>0]<<8|d[h+(r|1)>>0];P=d[h+D>>0]<<8|d[h+(B+15)>>0];Q=ra;R=d[E>>0]<<8|d[h+(p|1)>>0];S=E;T=d[h+o>>0]<<8|d[h+(o|1)>>0]}}if(!R){v=P;w=O+f&65535;x=Q;break}o=(f-T<<1)+R|0;E=d[S+o>>0]<<8|d[S+(o+1)>>0];if(!E){v=P;w=0;x=Q}else{v=P;w=E+O&65535;x=Q}}while(0);if(!m){k=w;i=g;return k|0}if(f>>>0>v>>>0){v=x+1|0;if((v|0)==(l|0)){k=0;i=g;return k|0}else va=v}else va=x;if(uee(b,va)|0){if(!w){k=0;i=g;return k|0}c[e>>2]=f;k=w;i=g;return k|0}va=b+24|0;x=f;c[va>>2]=x;if(!w){c[va>>2]=x;oee(b);wa=c[b+28>>2]|0}else{c[b+28>>2]=w;wa=w}if(!wa){k=0;i=g;return k|0}c[e>>2]=c[va>>2];k=wa;i=g;return k|0}function oee(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;e=a+24|0;f=c[e>>2]|0;a:do if(f>>>0<=65534){g=f+1|0;h=a+40|0;j=c[h>>2]|0;k=a+52|0;l=a+44|0;m=a+48|0;n=a+36|0;o=j;p=g>>>0<j>>>0?j:g;b:while(1){g=c[k>>2]|0;j=c[l>>2]|0;q=c[m>>2]|0;c:do if(p>>>0>j>>>0)r=p;else{if(!g){s=p;while(1){t=s+q&65535;if(t){u=t;v=s;w=11;break b}t=s+1|0;if(t>>>0>j>>>0){r=t;break c}else s=t}}s=p;t=g+(p-o<<1)|0;while(1){x=(d[t>>0]|0)<<8|(d[t+1>>0]|0);t=t+2|0;if((x|0)!=0?(y=x+q&65535,(y|0)!=0):0){z=y;A=s;w=8;break b}y=s+1|0;if(y>>>0>j>>>0){r=y;break}else s=y}}while(0);if((uee(a,(c[n>>2]|0)+1|0)|0)<0)break a;j=c[h>>2]|0;o=j;p=r>>>0<j>>>0?j:r}if((w|0)==8){c[e>>2]=A;c[a+28>>2]=z;i=b;return}else if((w|0)==11){c[e>>2]=v;c[a+28>>2]=u;i=b;return}}while(0);c[e>>2]=-1;c[a+28>>2]=0;i=b;return}function pee(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;h=c[b+16>>2]|0;j=d[h+13>>0]<<16|d[h+12>>0]<<24|d[h+14>>0]<<8|d[h+15>>0];if(!j){k=0;i=g;return k|0}l=f<<24>>24!=0;f=(c[e>>2]|0)+(l&1)|0;m=j;n=0;a:while(1){o=n;while(1){p=(o+m|0)>>>1;q=p*12|0;r=d[h+(q+17)>>0]<<16|d[h+(q+16)>>0]<<24|d[h+(q+18)>>0]<<8|d[h+(q+19)>>0];s=d[h+(q+21)>>0]<<16|d[h+(q+20)>>0]<<24|d[h+(q+22)>>0]<<8|d[h+(q+23)>>0];if(f>>>0<r>>>0){t=p;u=s;v=o;break}o=p+1|0;if(f>>>0<=s>>>0){w=p;x=q;y=r;z=s;A=8;break a}if(o>>>0>=m>>>0){B=s;C=p;D=0;break a}}if(v>>>0<t>>>0){m=t;n=v}else{B=u;C=t;D=0;break}}if((A|0)==8){B=z;C=w;D=f-y+(d[h+(x+25)>>0]<<16|d[h+(x+24)>>0]<<24|d[h+(x+26)>>0]<<8|d[h+(x+27)>>0])|0}if(!l){k=D;i=g;return k|0}if(f>>>0>B>>>0){B=C+1|0;if((B|0)==(j|0)){k=0;i=g;return k|0}else E=B}else E=C;C=b+24|0;a[C>>0]=1;B=b+28|0;c[B>>2]=f;c[b+36>>2]=E;do if(!D){qee(b);if(!(a[C>>0]|0)){k=0;i=g;return k|0}else{F=c[b+32>>2]|0;break}}else{c[b+32>>2]=D;F=D}while(0);if(!F){k=0;i=g;return k|0}c[e>>2]=c[B>>2];k=F;i=g;return k|0}function qee(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=b+28|0;g=c[f>>2]|0;a:do if((g|0)!=-1?(h=b+36|0,j=c[h>>2]|0,k=c[b+40>>2]|0,j>>>0<k>>>0):0){l=c[b+16>>2]|0;m=g+1|0;n=j;b:while(1){j=n*12|0;o=(d[l+(j+17)>>0]|0)<<16|(d[l+(j+16)>>0]|0)<<24|(d[l+(j+18)>>0]|0)<<8|(d[l+(j+19)>>0]|0);p=(d[l+(j+21)>>0]|0)<<16|(d[l+(j+20)>>0]|0)<<24|(d[l+(j+22)>>0]|0)<<8|(d[l+(j+23)>>0]|0);q=(d[l+(j+25)>>0]|0)<<16|(d[l+(j+24)>>0]|0)<<24|(d[l+(j+26)>>0]|0)<<8|(d[l+(j+27)>>0]|0);j=m>>>0<o>>>0?o:m;if(j>>>0>p>>>0)r=j;else{s=j;while(1){j=s+q|0;t=s+1|0;if((j|0)!=(o|0)){u=j;v=o;w=s;x=n;break b}if(t>>>0>p>>>0){r=t;break}else s=t}}n=n+1|0;if(n>>>0>=k>>>0)break a;else m=r}c[f>>2]=w;c[b+32>>2]=u-v;c[h>>2]=x;i=e;return}while(0);a[b+24>>0]=0;i=e;return}function ree(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=i;h=c[b+16>>2]|0;j=d[h+13>>0]<<16|d[h+12>>0]<<24|d[h+14>>0]<<8|d[h+15>>0];if(!j){k=0;i=g;return k|0}l=f<<24>>24!=0;f=(c[e>>2]|0)+(l&1)|0;m=j;n=0;a:while(1){o=n;while(1){p=(o+m|0)>>>1;q=p*12|0;r=d[h+(q+21)>>0]<<16|d[h+(q+20)>>0]<<24|d[h+(q+22)>>0]<<8|d[h+(q+23)>>0];if(f>>>0<(d[h+(q+17)>>0]<<16|d[h+(q+16)>>0]<<24|d[h+(q+18)>>0]<<8|d[h+(q+19)>>0])>>>0){s=p;t=r;u=o;break}o=p+1|0;if(f>>>0<=r>>>0){v=p;w=q;x=r;y=8;break a}if(o>>>0>=m>>>0){z=r;A=p;B=0;break a}}if(u>>>0<s>>>0){m=s;n=u}else{z=t;A=s;B=0;break}}if((y|0)==8){z=x;A=v;B=d[h+(w+25)>>0]<<16|d[h+(w+24)>>0]<<24|d[h+(w+26)>>0]<<8|d[h+(w+27)>>0]}if(!l){k=B;i=g;return k|0}if(f>>>0>z>>>0){z=A+1|0;if((z|0)==(j|0)){k=0;i=g;return k|0}else C=z}else C=A;A=b+24|0;a[A>>0]=1;z=b+28|0;c[z>>2]=f;c[b+36>>2]=C;do if(!B){see(b);if(!(a[A>>0]|0)){k=0;i=g;return k|0}else{D=c[b+32>>2]|0;break}}else{c[b+32>>2]=B;D=B}while(0);if(!D){k=0;i=g;return k|0}c[e>>2]=c[z>>2];k=D;i=g;return k|0}function see(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=b+28|0;g=c[f>>2]|0;a:do if((g|0)!=-1?(h=b+36|0,j=c[h>>2]|0,k=c[b+40>>2]|0,j>>>0<k>>>0):0){l=c[b+16>>2]|0;m=g+1|0;n=j;while(1){j=n*12|0;o=(d[l+(j+17)>>0]|0)<<16|(d[l+(j+16)>>0]|0)<<24|(d[l+(j+18)>>0]|0)<<8|(d[l+(j+19)>>0]|0);p=(d[l+(j+25)>>0]|0)<<16|(d[l+(j+24)>>0]|0)<<24|(d[l+(j+26)>>0]|0)<<8|(d[l+(j+27)>>0]|0);m=m>>>0<o>>>0?o:m;o=n;n=n+1|0;if(!((p|0)==0?1:m>>>0>((d[l+(j+21)>>0]|0)<<16|(d[l+(j+20)>>0]|0)<<24|(d[l+(j+22)>>0]|0)<<8|(d[l+(j+23)>>0]|0))>>>0)){q=m;r=p;s=o;break}if(n>>>0>=k>>>0)break a}c[f>>2]=q;c[b+32>>2]=r;c[h>>2]=s;i=e;return}while(0);a[b+24>>0]=0;i=e;return}function tee(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=vee(e)|0;j=a[e>>0]|0;k=a[e+1>>0]|0;l=a[e+2>>0]|0;m=a[e+3>>0]|0;if(wee(b,h+1|0,f)|0){n=0;i=g;return n|0}f=(k&255)<<16|(j&255)<<24|(l&255)<<8|m&255;m=c[b+32>>2]|0;if(!f)o=m;else{b=f;f=e;e=m;while(1){l=f;f=f+4|0;j=d[l+7>>0]|0;k=j+1|0;h=e;p=(d[l+5>>0]|0)<<8|(d[f>>0]|0)<<16|(d[l+6>>0]|0);while(1){c[h>>2]=p;k=k+-1|0;if(!k)break;else{h=h+4|0;p=p+1|0}}p=e+(j+1<<2)|0;b=b+-1|0;if(!b){o=p;break}else e=p}}c[o>>2]=0;n=m;i=g;return n|0}function uee(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+16>>2]|0;h=c[b+32>>2]|0;if(h>>>0<=e>>>0){j=-1;i=f;return j|0}k=b+44|0;l=h<<1;m=l+2|0;n=b+40|0;o=b+48|0;p=h+-1|0;q=e;while(1){e=q<<1;r=e+14|0;s=d[g+r>>0]<<8|d[g+(e+15)>>0];c[k>>2]=s;e=m+r|0;r=d[g+e>>0]<<8|d[g+(e|1)>>0];c[n>>2]=r;t=e+l|0;c[o>>2]=a[g+t>>0]<<8|d[g+(t|1)>>0];e=t+l|0;t=d[g+e>>0]<<8|d[g+(e|1)>>0];if(q>>>0>=p>>>0&(r|0)==65535&(s|0)==65535){s=c[b>>2]|0;if(!t){u=q;v=0;break}if((g+(e+2+t)|0)>>>0>((c[s+500>>2]|0)+(c[s+504>>2]|0)|0)>>>0){w=q;x=6;break}}if(!t){u=q;v=0;break}else if((t|0)!=65535){y=q;z=t;A=e;x=8;break}q=q+1|0;if(q>>>0>=h>>>0){j=-1;x=11;break}}if((x|0)==6){c[o>>2]=1;u=w;v=0}else if((x|0)==8){u=y;v=g+(z+A)|0}else if((x|0)==11){i=f;return j|0}c[b+52>>2]=v;c[b+36>>2]=u;j=0;i=f;return j|0}function vee(a){a=a|0;var b=0,c=0,e=0,f=0,g=0;b=i;c=(d[a+1>>0]|0)<<16|(d[a>>0]|0)<<24|(d[a+2>>0]|0)<<8|(d[a+3>>0]|0);if(!c){e=0;i=b;return e|0}f=a+7|0;a=c;c=0;while(1){g=c+1+(d[f>>0]|0)|0;a=a+-1|0;if(!a){e=g;break}else{f=f+4|0;c=g}}i=b;return e|0}function wee(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=a+28|0;h=c[g>>2]|0;c[f>>2]=0;if(h>>>0>=b>>>0){j=0;i=e;return j|0}c[a+36>>2]=d;k=a+32|0;c[k>>2]=Zae(d,4,h,b,c[k>>2]|0,f)|0;k=c[f>>2]|0;if(k){j=k;i=e;return j|0}c[g>>2]=b;j=0;i=e;return j|0}function xee(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j+4|0;l=j;m=c[g+28>>2]|0;n=h<<24>>24!=0;h=c[f+508>>2]|0;do if(n){o=kn[h&511](f,1986884728,g,l)|0;c[k>>2]=o;if(!o){o=f+334|0;p=e[o>>1]|0;q=c[l>>2]|0;r=q>>>2;b[o>>1]=0;s=q;t=f+336|0;u=p>>>0>r>>>0?r:p;v=f+340|0;break}else{w=c[k>>2]|0;i=j;return w|0}}else{p=kn[h&511](f,1752003704,g,l)|0;c[k>>2]=p;if(!p){p=f+250|0;r=e[p>>1]|0;q=c[l>>2]|0;o=q>>>2;b[p>>1]=0;s=q;t=f+252|0;u=r>>>0>o>>>0?o:r;v=f+256|0;break}else{w=c[k>>2]|0;i=j;return w|0}}while(0);h=(e[f+264>>1]|0)-u|0;r=(s-(u<<2)|0)>>>1;o=(h|0)<0?0:h;c[t>>2]=Zae(m,4,0,u,0,k)|0;if(c[k>>2]|0){w=c[k>>2]|0;i=j;return w|0}c[v>>2]=Zae(m,2,0,o,0,k)|0;if(c[k>>2]|0){w=c[k>>2]|0;i=j;return w|0}m=Jae(g,c[l>>2]|0)|0;c[k>>2]=m;if(m){w=c[k>>2]|0;i=j;return w|0}m=c[g+32>>2]|0;l=c[t>>2]|0;t=l+(u<<2)|0;if(l>>>0<t>>>0){q=u<<2;p=l;l=m;while(1){b[p>>1]=d[l>>0]<<8|d[l+1>>0];b[p+2>>1]=a[l+2>>0]<<8|d[l+3>>0];p=p+4|0;if(p>>>0>=t>>>0)break;else l=l+4|0}x=m+q|0}else x=m;m=c[v>>2]|0;q=m+(((o|0)<(r|0)?o:r)<<1)|0;if(m>>>0<q>>>0){l=(h|0)>0?~h:-1;h=~((s-(u<<2)|0)>>>1);s=m+(-3-(((l|0)>(h|0)?l:h)<<1)+2&-2)|0;h=m;l=x;while(1){b[h>>1]=a[l>>0]<<8|d[l+1>>0];h=h+2|0;if(h>>>0>=q>>>0)break;else l=l+2|0}y=s}else y=m;if((o|0)>(r|0)&(r|0)!=0?(m=c[v>>2]|0,v=b[m+(r+-1<<1)>>1]|0,r=m+(o<<1)|0,y>>>0<r>>>0):0){o=y;do{b[o>>1]=v;o=o+2|0}while(o>>>0<r>>>0)}Lae(g);g=u&65535;if(n){b[f+334>>1]=g;w=c[k>>2]|0;i=j;return w|0}else{b[f+250>>1]=g;w=c[k>>2]|0;i=j;return w|0}return 0}function yee(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a+508>>2]|0;if(!(d<<24>>24)){d=kn[f&511](a,1751672161,b,0)|0;if(!d){g=a+216|0;h=6}else j=d}else{d=kn[f&511](a,1986553185,b,0)|0;if(!d){g=a+300|0;h=6}else j=d}if((h|0)==6){h=Sae(b,788872,g)|0;if(!h){c[g+36>>2]=0;c[g+40>>2]=0;j=0}else j=h}i=e;return j|0}function zee(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;k=d<<24>>24!=0?a+300|0:a+216|0;d=b[k+34>>1]|0;l=d&65535;if((d<<16>>16!=0?(d=c[k+36>>2]|0,(d|0)!=0):0)?(e[a+264>>1]|0)>>>0>f>>>0:0){if(l>>>0>f>>>0){b[g>>1]=b[d+(f<<2)+2>>1]|0;m=d+(f<<2)|0}else{b[g>>1]=b[(c[k+40>>2]|0)+(f-l<<1)>>1]|0;m=d+(l+-1<<2)|0}b[h>>1]=b[m>>1]|0;i=j;return 0}b[h>>1]=0;b[g>>1]=0;i=j;return 0}function Aee(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=c[d+100>>2]|0;h=d+628|0;if(!(a[h>>0]|0)){a[h>>0]=0;i=f;return}j=c[d+468>>2]|0;if((j|0)==163840){k=d+636|0;$ae(g,c[k>>2]|0);c[k>>2]=0;b[d+632>>1]=0;a[h>>0]=0;i=f;return}else if((j|0)==131072){j=d+636|0;$ae(g,c[j>>2]|0);c[j>>2]=0;b[d+632>>1]=0;j=d+634|0;k=d+640|0;d=c[k>>2]|0;if(!(b[j>>1]|0))l=d;else{m=d;d=0;n=0;while(1){$ae(g,c[m+(d<<2)>>2]|0);c[(c[k>>2]|0)+(d<<2)>>2]=0;o=n+1<<16>>16;p=c[k>>2]|0;if((o&65535)<(e[j>>1]|0)){m=p;d=o&65535;n=o}else{l=p;break}}}$ae(g,l);c[k>>2]=0;b[j>>1]=0;a[h>>0]=0;i=f;return}else{a[h>>0]=0;i=f;return}}function Bee(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;do if(d)if((e[d+264>>1]|0)>>>0>f>>>0){j=c[d+536>>2]|0;if(j){k=d+628|0;l=j+16|0;c[g>>2]=mo[c[l>>2]&4095](0)|0;j=c[d+468>>2]|0;if((j|0)==65536){if(f>>>0>=258){m=0;break}c[g>>2]=mo[c[l>>2]&4095](f)|0;m=0;break}else if((j|0)==131072){if((a[k>>0]|0)==0?(Cee(d)|0)!=0:0){m=0;break}if((e[d+632>>1]|0)>>>0<=f>>>0){m=0;break}n=b[(c[d+636>>2]|0)+(f<<1)>>1]|0;o=n&65535;if((n&65535)<258){c[g>>2]=mo[c[l>>2]&4095](o)|0;m=0;break}else{c[g>>2]=c[(c[d+640>>2]|0)+(o+-258<<2)>>2];m=0;break}}else if((j|0)==163840){if((a[k>>0]|0)==0?(Cee(d)|0)!=0:0){m=0;break}if((e[d+632>>1]|0)>>>0<=f>>>0){m=0;break}c[g>>2]=mo[c[l>>2]&4095]((a[(c[d+636>>2]|0)+f>>0]|0)+f|0)|0;m=0;break}else{m=0;break}}else m=7}else m=16;else m=35;while(0);i=h;return m|0}function Cee(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d+104>>2]|0;l=kn[c[d+508>>2]&511](d,1886352244,k,j)|0;if(l){m=l;i=f;return m|0}l=Fae(k)|0;n=(c[j>>2]|0)+l|0;l=c[d+468>>2]|0;j=Eae(k,32)|0;if(j){m=j;i=f;return m|0}a:do if((l|0)==131072){j=c[k+28>>2]|0;o=Qae(k,h)|0;p=o&65535;q=c[h>>2]|0;if(!q){if((o&65535)>(e[d+264>>1]|0)){c[h>>2]=3;r=3;break}s=Zae(j,2,0,p,0,h)|0;b:do if((c[h>>2]|0)==0?(t=Jae(k,p<<1)|0,c[h>>2]=t,(t|0)==0):0){if(!(o<<16>>16)){Lae(k);u=0}else{t=0;do{b[s+(t<<1)>>1]=Nae(k)|0;t=t+1|0}while((t|0)<(p|0));Lae(k);t=0;v=0;while(1){w=b[s+(t<<1)>>1]|0;if((w&65535)>257){x=(w&65535)+-257|0;y=(x|0)>(v&65535|0)?x&65535:v}else y=v;t=t+1|0;if((t|0)>=(p|0)){u=y;break}else v=y}}v=Zae(j,4,0,u&65535,0,h)|0;if(!(c[h>>2]|0)){c:do if(u<<16>>16){t=0;while(1){if((Fae(k)|0)>=(n|0)){z=t;A=19;break}x=(Pae(k,h)|0)&255;if(c[h>>2]|0){B=0;break}if((n|0)>=(x|0)?(Fae(k)|0)<=(n-x|0):0)C=x;else if((n-(Fae(k)|0)|0)<0)C=0;else C=n-(Fae(k)|0)|0;x=Zae(j,1,0,C+1|0,0,h)|0;w=v+(t<<2)|0;c[w>>2]=x;if(c[h>>2]|0){B=0;break}D=Gae(k,x,C)|0;c[h>>2]=D;if(D){B=0;break}a[(c[w>>2]|0)+C>>0]=0;t=t+1|0;if((t&65535)>=(u&65535))break c}d:do if((A|0)==19){t=z&65535;if((t&65535)>=(u&65535))break c;w=z&65535;D=t;while(1){t=Zae(j,1,0,1,0,h)|0;c[v+(w<<2)>>2]=t;if(c[h>>2]|0){B=0;break d}a[t>>0]=0;D=D+1<<16>>16;if((D&65535)>=(u&65535))break c;else w=w+1|0}}while(0);while(1){w=v+(B<<2)|0;$ae(j,c[w>>2]|0);c[w>>2]=0;B=B+1|0;if((B&65535)<<16>>16==u<<16>>16){E=v;break b}}}while(0);b[d+632>>1]=o;b[d+634>>1]=u;c[d+636>>2]=s;c[d+640>>2]=v;r=0;break a}else E=v}else E=0;while(0);$ae(j,E);$ae(j,s);r=c[h>>2]|0}else r=q}else if((l|0)==163840){o=c[k+28>>2]|0;p=Qae(k,g)|0;w=p&65535;D=c[g>>2]|0;if(!D){if((p&65535)>258?1:(p&65535)>(e[d+264>>1]|0)){c[g>>2]=3;r=3;break}t=Zae(o,1,0,w,0,g)|0;e:do if((c[g>>2]|0)==0?(x=Gae(k,t,w)|0,c[g>>2]=x,(x|0)==0):0){f:do if(p<<16>>16){x=0;while(1){F=(a[t+x>>0]|0)+x|0;x=x+1|0;if((F|0)<0|(F|0)>(w|0))break;if((x|0)>=(w|0))break f}c[g>>2]=3;break e}while(0);b[d+632>>1]=p;c[d+636>>2]=t;r=0;break a}while(0);$ae(o,t);r=c[g>>2]|0}else r=D}else r=3;while(0);a[d+628>>0]=1;m=r;i=f;return m|0}function Dee(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[a+156>>2]|0;g=b[a+152>>1]|0;a=f+((g&65535)<<4)|0;if(!(g<<16>>16)){h=0;i=e;return h|0}else j=f;while(1){if((c[j>>2]|0)==(d|0)?(c[j+12>>2]|0)!=0:0){h=j;k=5;break}j=j+16|0;if(j>>>0>=a>>>0){h=0;k=5;break}}if((k|0)==5){i=e;return h|0}return 0}function Eee(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=c[a+156>>2]|0;j=b[a+152>>1]|0;a=h+((j&65535)<<4)|0;if(!(j<<16>>16)){k=142;i=g;return k|0}else l=h;while(1){if((c[l>>2]|0)==(d|0)?(h=c[l+12>>2]|0,(h|0)!=0):0){m=h;n=l;break}l=l+16|0;if(l>>>0>=a>>>0){k=142;o=9;break}}if((o|0)==9){i=g;return k|0}if(!n){k=142;i=g;return k|0}if(f)c[f>>2]=m;k=Dae(e,c[n+8>>2]|0)|0;i=g;return k|0}function Fee(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;f=i;i=i+48|0;g=f+40|0;h=f+24|0;j=f+8|0;k=f;l=c[d+28>>2]|0;m=j+12|0;c[m>>2]=Fae(d)|0;c[j>>2]=Rae(d,k)|0;n=c[k>>2]|0;if(n){o=n;i=f;return o|0}n=Sae(d,788952,j)|0;c[k>>2]=n;if(n){o=n;i=f;return o|0}n=c[m>>2]|0;p=Dae(d,n+12|0)|0;c[g>>2]=p;a:do if(!p){q=j+4|0;if(b[q>>1]|0){r=h+8|0;s=h+12|0;t=d+4|0;u=n+28|0;v=0;w=0;x=0;y=0;z=0;A=0;b:while(1){B=Sae(d,789536,h)|0;c[g>>2]=B;if(B){C=w;D=x;E=y;F=z;G=A;H=8;break}B=c[r>>2]|0;I=c[s>>2]|0;do if((I+B|0)>>>0<=(c[t>>2]|0)>>>0){J=A+1<<16>>16;K=c[h>>2]|0;if((K|0)==1397313095){L=w;M=x;N=1;O=J;break}else if(!((K|0)==1651008868|(K|0)==1751474532)){L=w;M=(K|0)==1296389185?1:x;N=y;O=J;break}if(I>>>0<54){H=12;break b}K=Dae(d,B+12|0)|0;c[g>>2]=K;if(K){P=K;break a}K=Rae(d,g)|0;Q=c[g>>2]|0;if(Q){P=Q;break a}if((K|0)!=1594834165){H=16;break b}K=Dae(d,u+(v<<4)|0)|0;c[g>>2]=K;if(!K){L=1;M=x;N=y;O=J}else{P=K;break a}}else{L=w;M=x;N=y;O=A}while(0);B=z+1<<16>>16;if((B&65535)<(e[q>>1]|0)){v=B&65535;w=L;x=M;y=N;z=B;A=O}else{R=O;S=L;T=M;U=N;break}}if((H|0)==8){b[q>>1]=F+-1<<16>>16;R=G;S=C;T=D;U=E}else if((H|0)==12){c[g>>2]=142;P=142;break}else if((H|0)==16){c[g>>2]=142;P=142;break}b[q>>1]=R;if(R<<16>>16){if((S|0)==0?!((U|0)!=0&(T|0)!=0):0){c[g>>2]=142;P=142;break}c[k>>2]=0;A=a+152|0;b[A>>1]=R;c[a+148>>2]=c[j>>2];z=a+156|0;c[z>>2]=Zae(l,16,0,R&65535,0,k)|0;y=c[k>>2]|0;if(y){o=y;i=f;return o|0}y=Dae(d,(c[m>>2]|0)+12|0)|0;c[k>>2]=y;if(y){o=y;i=f;return o|0}y=Jae(d,e[A>>1]<<4)|0;c[k>>2]=y;if(y){o=y;i=f;return o|0}if(b[q>>1]|0){y=c[z>>2]|0;z=0;while(1){c[y>>2]=Oae(d)|0;c[y+4>>2]=Oae(d)|0;A=y+8|0;c[A>>2]=Oae(d)|0;x=Oae(d)|0;c[y+12>>2]=x;z=z+1|0;if((z|0)>=(e[q>>1]|0))break;else y=((c[A>>2]|0)+x|0)>>>0>(c[t>>2]|0)>>>0?y:y+16|0}}Lae(d);o=c[k>>2]|0;i=f;return o|0}}else b[q>>1]=0;c[g>>2]=2;P=2}else P=p;while(0);c[k>>2]=P;o=P;i=f;return o|0}function Gee(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;do if(d){j=c[a+156>>2]|0;k=b[a+152>>1]|0;l=j+((k&65535)<<4)|0;if(!(k<<16>>16)){m=142;i=h;return m|0}else n=j;while(1){if((c[n>>2]|0)==(d|0)?(j=c[n+12>>2]|0,(j|0)!=0):0){o=j;p=n;break}n=n+16|0;if(n>>>0>=l>>>0){m=142;q=13;break}}if((q|0)==13){i=h;return m|0}if(!p){m=142;i=h;return m|0}else{r=(c[p+8>>2]|0)+e|0;s=o;break}}else{r=e;s=c[(c[a+104>>2]|0)+4>>2]|0}while(0);if(g){e=c[g>>2]|0;if(!e){c[g>>2]=s;m=0;i=h;return m|0}else t=e}else t=s;m=Hae(c[a+104>>2]|0,r,f,t)|0;i=h;return m|0}function Hee(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=kn[c[a+508>>2]&511](a,1751474532,b,0)|0;if(e){f=e;i=d;return f|0}f=Sae(b,789448,a+160|0)|0;i=d;return f|0}function Iee(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=kn[c[a+508>>2]&511](a,1651008868,b,0)|0;if(e){f=e;i=d;return f|0}f=Sae(b,789448,a+160|0)|0;i=d;return f|0}function Jee(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=a+260|0;h=kn[c[a+508>>2]&511](a,1835104368,d,0)|0;if(!h){j=Sae(d,788976,g)|0;if(!j){k=a+276|0;l=a+280|0;m=a+290|0;n=a+266|0;a=n+26|0;do{b[n>>1]=0;n=n+2|0}while((n|0)<(a|0));if((c[g>>2]|0)>65535){n=Sae(d,788992,g)|0;if(!n){if((e[l>>1]|0)<64)b[l>>1]=64;if((e[k>>1]|0)>65531)b[k>>1]=-5;if((e[m>>1]|0)>100){b[m>>1]=100;o=0}else o=0}else o=n}else o=0}else o=j}else o=h;i=f;return o|0}function Kee(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[d+28>>2]|0;c[a+364>>2]=d;j=kn[c[a+508>>2]&511](a,1851878757,d,g)|0;c[f>>2]=j;if(j){k=j;i=e;return k|0}j=Fae(d)|0;l=Sae(d,789056,a+348|0)|0;c[f>>2]=l;if(l){k=l;i=e;return k|0}l=a+352|0;m=c[l>>2]|0;n=m*12|0;o=j+6+n|0;p=(c[g>>2]|0)+j|0;if(o>>>0>p>>>0){c[f>>2]=145;k=145;i=e;return k|0}c[l>>2]=0;g=a+360|0;c[g>>2]=Zae(h,20,0,m,0,f)|0;h=c[f>>2]|0;if(h){k=h;i=e;return k|0}h=Jae(d,n)|0;c[f>>2]=h;if(h){k=h;i=e;return k|0}h=c[g>>2]|0;if(!m){q=h;r=h}else{n=a+356|0;s=m;m=h;while(1){h=Sae(d,789080,m)|0;c[f>>2]=h;do if((h|0)==0?(t=m+8|0,u=b[t>>1]|0,u<<16>>16!=0):0){v=m+12|0;w=(c[n>>2]|0)+j+(c[v>>2]|0)|0;c[v>>2]=w;if(w>>>0>=o>>>0?((u&65535)+w|0)>>>0<=p>>>0:0){x=m+20|0;break}c[v>>2]=0;b[t>>1]=0;x=m}else x=m;while(0);s=s+-1|0;if(!s){y=x;break}else m=x}q=c[g>>2]|0;r=y}c[l>>2]=(r-q|0)/20|0;Lae(d);b[a+344>>1]=c[l>>2];k=c[f>>2]|0;i=e;return k|0}function Lee(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=c[(c[a+96>>2]|0)+8>>2]|0;f=a+360|0;g=c[f>>2]|0;h=a+352|0;j=c[h>>2]|0;if(g){if(!j)k=g;else{l=j;j=g;while(1){g=j+16|0;$ae(e,c[g>>2]|0);c[g>>2]=0;b[j+8>>1]=0;l=l+-1|0;if(!l)break;else j=j+20|0}k=c[f>>2]|0}$ae(e,k);c[f>>2]=0}c[h>>2]=0;b[a+348>>1]=0;c[a+356>>2]=0;i=d;return}function Mee(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+504|0;f=kn[c[a+508>>2]&511](a,1668112752,b,e)|0;if(!f){g=Iae(b,c[e>>2]|0,a+500|0)|0;if(!g)h=0;else{c[e>>2]=0;h=g}}else h=f;i=d;return h|0}function Nee(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=kn[c[a+508>>2]&511](a,1330851634,d,0)|0;if(!g){h=a+368|0;j=Sae(d,789112,h)|0;if(!j){k=a+448|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;b[k+16>>1]=0;if(b[h>>1]|0){k=Sae(d,789288,h)|0;if(!k)if((e[h>>1]|0)>1)l=Sae(d,789304,h)|0;else l=0;else l=k}else l=0}else l=j}else l=g;i=f;return l|0}function Oee(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=kn[c[a+508>>2]&511](a,1886352244,b,0)|0;if(e){f=e;i=d;return f|0}f=Sae(b,789336,a+468|0)|0;i=d;return f|0}function Pee(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=kn[c[a+508>>2]&511](a,1346587732,b,0)|0;if(e){f=e;i=d;return f|0}f=Sae(b,789384,a+556|0)|0;i=d;return f|0}function Qee(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;h=c[d+28>>2]|0;j=kn[c[a+508>>2]&511](a,1734439792,d,0)|0;c[g>>2]=j;if(j){k=j;i=f;return k|0}j=Jae(d,4)|0;c[g>>2]=j;if(j){k=j;i=f;return k|0}j=a+548|0;b[j>>1]=Nae(d)|0;l=a+550|0;b[l>>1]=Nae(d)|0;Lae(d);if((e[j>>1]|0)>1){b[l>>1]=0;c[g>>2]=8;k=8;i=f;return k|0}j=b[l>>1]|0;l=j&65535;m=Zae(h,4,0,l,0,g)|0;h=c[g>>2]|0;if(h){k=h;i=f;return k|0}h=Jae(d,l<<2)|0;c[g>>2]=h;if(h){k=h;i=f;return k|0}c[a+552>>2]=m;if(j<<16>>16){j=0;do{b[m+(j<<2)>>1]=Nae(d)|0;b[m+(j<<2)+2>>1]=Nae(d)|0;j=j+1|0}while((j|0)!=(l|0))}Lae(d);k=c[g>>2]|0;i=f;return k|0}function Ree(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=d+28|0;k=c[j>>2]|0;l=a+612|0;c[l>>2]=0;m=a+508|0;n=kn[c[m>>2]&511](a,1161972803,d,0)|0;c[h>>2]=n;if((n|0)!=0?(n=kn[c[m>>2]&511](a,1651273571,d,0)|0,c[h>>2]=n,(n|0)!=0):0){o=n;i=e;return o|0}n=Fae(d)|0;m=Jae(d,8)|0;c[h>>2]=m;if(m){o=m;i=e;return o|0}m=Oae(d)|0;p=Oae(d)|0;Lae(d);if((m|0)!=131072|p>>>0>65535){c[h>>2]=3;o=3;i=e;return o|0}m=Zae(k,48,0,p,0,h)|0;q=a+616|0;c[q>>2]=m;a=c[h>>2]|0;if(a){o=a;i=e;return o|0}c[l>>2]=p;l=Jae(d,p*48|0)|0;c[h>>2]=l;if(l){o=l;i=e;return o|0}l=(p|0)==0;a:do if(!l){a=p;r=m;while(1){s=Sae(d,789616,r)|0;c[h>>2]=s;if(s)break;s=Sae(d,789560,r+16|0)|0;c[h>>2]=s;if(s)break;s=Sae(d,789560,r+28|0)|0;c[h>>2]=s;if(s)break;s=Sae(d,789640,r)|0;c[h>>2]=s;if(s)break;a=a+-1|0;if(!a)break;else r=r+48|0}Lae(d);if(!l){r=p;a=c[q>>2]|0;b:while(1){s=c[a>>2]|0;t=a+8|0;u=Dae(d,(c[t>>2]|0)+n|0)|0;c[h>>2]=u;if(u)break a;u=Jae(d,c[a>>2]<<3)|0;c[h>>2]=u;if(u)break a;u=Zae(k,40,0,c[a>>2]|0,0,h)|0;v=a+4|0;c[v>>2]=u;if(c[h>>2]|0)break a;if(s){w=s;s=u;while(1){b[s>>1]=Nae(d)|0;b[s+2>>1]=Nae(d)|0;u=(c[t>>2]|0)+n|0;c[s+36>>2]=u+(Oae(d)|0);w=w+-1|0;if(!w)break;else s=s+40|0}}Lae(d);s=c[a>>2]|0;c:do if(s){w=s;t=c[v>>2]|0;while(1){u=Dae(d,c[t+36>>2]|0)|0;c[h>>2]=u;if(u){o=u;x=50;break b}u=Jae(d,8)|0;c[h>>2]=u;if(u){o=u;x=50;break b}u=t+4|0;b[u>>1]=Nae(d)|0;b[t+6>>1]=Nae(d)|0;y=t+8|0;c[y>>2]=Oae(d)|0;Lae(d);z=c[j>>2]|0;A=b[u>>1]|0;d:do switch(A&65535|0){case 3:case 1:{u=b[t+2>>1]|0;B=b[t>>1]|0;if((u&65535)<(B&65535)){x=28;break b}C=u&65535;u=B&65535;B=A<<16>>16==1;D=C-u|0;c[t+24>>2]=D+1;E=D+2|0;D=t+28|0;c[D>>2]=Zae(z,4,0,E,0,g)|0;F=c[g>>2]|0;if(F){G=F;break b}F=Jae(d,da(E,B?4:2)|0)|0;c[g>>2]=F;if(F){G=F;break b}if(E){E=C+2-u|0;if(B){B=0;do{u=c[y>>2]|0;C=(Oae(d)|0)+u|0;c[(c[D>>2]|0)+(B<<2)>>2]=C;B=B+1|0}while((B|0)!=(E|0))}else{B=0;do{C=c[y>>2]|0;u=((Nae(d)|0)&65535)+C|0;c[(c[D>>2]|0)+(B<<2)>>2]=u;B=B+1|0}while((B|0)!=(E|0))}}Lae(d);H=c[g>>2]|0;break}case 2:{c[t+12>>2]=Rae(d,f)|0;E=c[f>>2]|0;if(!E){B=Sae(d,789704,t+16|0)|0;c[f>>2]=B;I=(B|0)!=0&1}else I=E;c[g>>2]=I;H=I;break}case 4:{E=Yee(t,d,1)|0;c[g>>2]=E;H=E;break}case 5:{c[t+12>>2]=Rae(d,f)|0;E=c[f>>2]|0;if(E){J=E;x=41;break b}E=(Sae(d,789704,t+16|0)|0)!=0;B=E&1;c[g>>2]=B;if(E){H=B;break d}B=Yee(t,d,0)|0;c[g>>2]=B;H=B;break}default:{x=44;break b}}while(0);c[h>>2]=H;if(H){o=H;x=50;break b}w=w+-1|0;if(!w)break c;else t=t+40|0}}while(0);r=r+-1|0;if(!r)break a;else a=a+48|0}if((x|0)==28){c[g>>2]=3;G=3}else if((x|0)==41){c[g>>2]=J;G=J}else if((x|0)==44){c[g>>2]=3;G=3}else if((x|0)==50){i=e;return o|0}c[h>>2]=G;o=G;i=e;return o|0}}else Lae(d);while(0);o=c[h>>2]|0;i=e;return o|0}function See(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=c[a+100>>2]|0;e=a+616|0;f=c[e>>2]|0;g=a+612|0;a=c[g>>2]|0;h=f+(a*48|0)|0;if(!f){c[g>>2]=0;i=b;return}if((a|0)>0){a=f;do{j=a+4|0;k=c[j>>2]|0;l=c[a>>2]|0;m=k+(l*40|0)|0;if(k)if((l|0)>0){l=k;do{n=l+28|0;$ae(d,c[n>>2]|0);c[n>>2]=0;n=l+32|0;$ae(d,c[n>>2]|0);c[n>>2]=0;l=l+40|0}while(l>>>0<m>>>0);o=c[j>>2]|0}else o=k;else o=0;$ae(d,o);c[j>>2]=0;c[a>>2]=0;a=a+48|0}while(a>>>0<h>>>0);p=c[e>>2]|0}else p=f;$ae(d,p);c[e>>2]=0;c[g>>2]=0;i=b;return}function Tee(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=G9d(a,b,0,c)|0;i=d;return e|0}function Uee(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;if((c[e+612>>2]|0)>>>0<=f>>>0){j=6;i=h;return j|0}k=c[e+616>>2]|0;b[g>>1]=d[k+(f*48|0)+44>>0]|0;b[g+2>>1]=d[k+(f*48|0)+45>>0]|0;e=a[k+(f*48|0)+16>>0]<<6;c[g+12>>2]=e;l=a[k+(f*48|0)+17>>0]<<6;c[g+16>>2]=l;c[g+24>>2]=(d[k+(f*48|0)+18>>0]|0)+(a[k+(f*48|0)+22>>0]|0)+(a[k+(f*48|0)+23>>0]|0)<<6;c[g+20>>2]=e-l;j=0;i=h;return j|0}function Vee(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=c[a+616>>2]|0;if(((j|0)!=0?(c[a+612>>2]|0)>>>0>d>>>0:0)?(a=j+(d*48|0)|0,(Zee(b,a,e,g)|0)==0):0){c[f>>2]=a;k=0;i=h;return k|0}c[e>>2]=0;c[f>>2]=0;c[g>>2]=0;k=6;i=h;return k|0}function Wee(c,f,g){c=c|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h;switch(e[f+6>>1]|0|0){case 9:case 7:case 6:{k=Sae(c,789704,g)|0;i=h;return k|0}case 8:case 2:case 1:{l=Sae(c,789672,j)|0;if(l){k=l;i=h;return k|0}a[g>>0]=a[j>>0]|0;a[g+1>>0]=a[j+1>>0]|0;a[g+2>>0]=a[j+2>>0]|0;a[g+3>>0]=a[j+3>>0]|0;a[g+4>>0]=a[j+4>>0]|0;a[g+5>>0]=0;a[g+6>>0]=0;a[g+7>>0]=0;k=0;i=h;return k|0}default:{j=b[f+4>>1]|0;if(!(j<<16>>16==5|j<<16>>16==2)){k=3;i=h;return k|0}j=f+16|0;f=j;l=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;f=j+4|0;j=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;f=g;g=f;a[g>>0]=l;a[g+1>>0]=l>>8;a[g+2>>0]=l>>16;a[g+3>>0]=l>>24;l=f+4|0;a[l>>0]=j;a[l+1>>0]=j>>8;a[l+2>>0]=j>>16;a[l+3>>0]=j>>24;k=0;i=h;return k|0}}return 0}function Xee(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;l=i;i=i+16|0;m=l+4|0;n=l;o=c[b+616>>2]|0;if(((o|0)!=0?(c[b+612>>2]|0)>>>0>e>>>0:0)?(p=o+(e*48|0)|0,(Zee(f,p,n,m)|0)==0):0){f=b+508|0;if((kn[c[f>>2]&511](b,1161970772,h,0)|0)!=0?(q=kn[c[f>>2]&511](b,1650745716,h,0)|0,(q|0)!=0):0){r=q;i=l;return r|0}q=Fae(h)|0;f=_ee(p,c[n>>2]|0,q,c[m>>2]|0,c[b+84>>2]|0,0,0,h,k,0)|0;if(f){r=f;i=l;return r|0}if(a[o+(e*48|0)+47>>0]&1){f=(a[o+(e*48|0)+16>>0]|0)-(a[o+(e*48|0)+17>>0]|0)|0;a[k+5>>0]=(d[k+1>>0]|0)/-2|0;a[k+6>>0]=(f-(d[k>>0]|0)|0)/2|0;a[k+7>>0]=(f*12|0)/10|0}if(!(g&64)){r=0;i=l;return r|0}g=j+12|0;f=c[j>>2]|0;e=j+8|0;o=c[e>>2]|0;a:do if((f|0)>0){h=c[g>>2]|0;if((o|0)>0){s=0;t=h}else{b=0;while(1){b=b+1|0;if((f|0)<=(b|0))break a}}b:while(1){b=t;t=t+o|0;do{if(a[b>>0]|0){u=s;break b}b=b+1|0}while(b>>>0<t>>>0);s=s+1|0;if((f|0)<=(s|0))break a}if((u|0)>0){b=f-u|0;aFi(h|0,h+(da(u,o)|0)|0,da(b,o)|0)|0;a[k>>0]=(d[k>>0]|0)-u;q=k+3|0;a[q>>0]=(d[q>>0]|0)-u;q=k+6|0;a[q>>0]=(d[q>>0]|0)-u;q=(c[j>>2]|0)-u|0;c[j>>2]=q;v=q;w=b}else{v=f;w=f}if((w|0)>0){b=0-o|0;q=0;p=(c[g>>2]|0)+(da(w+-1|0,o)|0)|0;c:while(1){x=p+o|0;y=p;do{if(a[y>>0]|0){z=q;break c}y=y+1|0}while(y>>>0<x>>>0);x=q+1|0;if((w|0)>(x|0)){q=x;p=p+b|0}else{z=x;break}}if((z|0)>0){a[k>>0]=(d[k>>0]|0)-z;c[j>>2]=v-z;A=w-z|0}else A=w}else A=w;b=da(A,o)|0;p=j+4|0;q=k+2|0;h=k+5|0;x=k+1|0;y=(b|0)>0;d:while(1){B=c[g>>2]|0;C=B+b|0;if(y){D=B;do{if((a[D>>0]|0)<0){E=B;F=40;break d}D=D+o|0}while(D>>>0<C>>>0);D=c[p>>2]|0;G=B+1|0;H=B;while(1){I=d[H>>0]<<1;if((D|0)>8){J=D+-9|0;K=H;L=8;M=I;while(1){N=K;K=K+1|0;O=d[K>>0]|0;a[N>>0]=O>>>7|M;L=L+8|0;N=O<<1;if((L|0)>=(D|0)){P=N;break}else M=N}Q=G+(J>>>3)|0;R=P}else{Q=H;R=I}a[Q>>0]=R;H=H+o|0;M=c[p>>2]|0;if(H>>>0>=C>>>0){S=M;break}else{D=M;G=G+o|0}}}else S=c[p>>2]|0;G=S+-1|0;c[p>>2]=G;a[q>>0]=(a[q>>0]|0)+1<<24>>24;a[h>>0]=(a[h>>0]|0)+1<<24>>24;a[x>>0]=(a[x>>0]|0)+-1<<24>>24;if((G|0)<=0){T=G;F=41;break}}if((F|0)==40){U=c[p>>2]|0;V=E}else if((F|0)==41){U=T;V=c[g>>2]|0}h=U;e:while(1){h=h+-1|0;q=h>>3;y=q+b|0;G=V+y|0;if((q|0)<(y|0)){y=128>>>(h&7);D=V+q|0;do{if(d[D>>0]&y){r=0;F=49;break e}D=D+o|0}while(D>>>0<G>>>0)}c[p>>2]=h;a[x>>0]=(a[x>>0]|0)+-1<<24>>24;if((h|0)<=0){r=0;F=49;break}}if((F|0)==49){i=l;return r|0}}while(0);c[j+4>>2]=0;c[j>>2]=0;c[e>>2]=0;a[j+18>>0]=1;r=0;i=l;return r|0}c[n>>2]=0;c[m>>2]=0;r=6;i=l;return r|0}function Yee(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[d+28>>2]|0;j=Rae(d,g)|0;k=c[g>>2]|0;if(k){l=k;i=f;return l|0}c[a+24>>2]=j;k=e<<24>>24!=0;do if(k){c[a+28>>2]=Zae(h,4,0,j,0,g)|0;e=c[g>>2]|0;if(!e){m=j<<2;break}else{l=e;i=f;return l|0}}else m=j<<1;while(0);e=a+32|0;c[e>>2]=Zae(h,2,0,j,0,g)|0;h=c[g>>2]|0;if(h){l=h;i=f;return l|0}h=Jae(d,m)|0;c[g>>2]=h;if(h){l=h;i=f;return l|0}if(j){h=a+8|0;m=a+28|0;if(k){k=0;do{a=Nae(d)|0;b[(c[e>>2]|0)+(k<<1)>>1]=a;a=c[h>>2]|0;n=((Nae(d)|0)&65535)+a|0;c[(c[m>>2]|0)+(k<<2)>>2]=n;k=k+1|0}while((k|0)!=(j|0))}else{k=0;do{m=Nae(d)|0;b[(c[e>>2]|0)+(k<<1)>>1]=m;k=k+1|0}while((k|0)!=(j|0))}}Lae(d);l=c[g>>2]|0;i=f;return l|0}function Zee(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;a:do if(((e[d+40>>1]|0)>>>0<=a>>>0?(e[d+42>>1]|0)>>>0>=a>>>0:0)?(j=c[d+4>>2]|0,k=c[d>>2]|0,l=j+(k*40|0)|0,(j|0)!=0&(k|0)>0):0){k=j;while(1){j=e[k>>1]|0;if(j>>>0<=a>>>0?(e[k+2>>1]|0)>>>0>=a>>>0:0){m=j;n=k;break}k=k+40|0;if(k>>>0>=l>>>0)break a}l=a-m|0;k=b[n+4>>1]|0;b:do switch(k&65535|0){case 3:case 1:{c[g>>2]=c[(c[n+28>>2]|0)+((l&65535)<<2)>>2];break}case 5:case 4:{j=c[n+24>>2]|0;if(!j)break a;o=c[n+32>>2]|0;p=0;while(1){if((e[o+(p<<1)>>1]|0|0)==(a|0)){q=p;break}p=p+1|0;if(p>>>0>=j>>>0)break a}if(k<<16>>16==4){c[g>>2]=c[(c[n+28>>2]|0)+(q<<2)>>2];break b}else{c[g>>2]=(da(c[n+12>>2]|0,q)|0)+(c[n+8>>2]|0);break b}break}case 2:{c[g>>2]=(da(c[n+12>>2]|0,l&65535)|0)+(c[n+8>>2]|0);break}default:break a}while(0);c[f>>2]=n;r=0;i=h;return r|0}while(0);c[f>>2]=0;c[g>>2]=0;r=6;i=h;return r|0}function _ee(f,g,h,j,k,l,m,n,o,p){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0;q=i;i=i+32|0;r=q+24|0;s=q+8|0;t=q+4|0;u=q+16|0;v=q;w=c[n+28>>2]|0;x=k+76|0;y=Dae(n,j+h|0)|0;c[s>>2]=y;if(y){z=y;i=q;return z|0}y=g+6|0;switch(e[y>>1]|0){case 8:case 2:case 1:{j=Sae(n,789672,r)|0;if(!j){a[o>>0]=a[r>>0]|0;a[o+1>>0]=a[r+1>>0]|0;a[o+2>>0]=a[r+2>>0]|0;a[o+3>>0]=a[r+3>>0]|0;a[o+4>>0]=a[r+4>>0]|0;a[o+5>>0]=0;a[o+6>>0]=0;a[o+7>>0]=0;A=7}else{B=j;A=8}break}case 9:case 7:case 6:{j=Sae(n,789704,o)|0;c[s>>2]=j;if(j){z=j;i=q;return z|0}break}default:{j=b[g+4>>1]|0;if(j<<16>>16==5|j<<16>>16==2){j=g+16|0;g=j;r=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;g=j+4|0;j=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;g=o;C=g;a[C>>0]=r;a[C+1>>0]=r>>8;a[C+2>>0]=r>>16;a[C+3>>0]=r>>24;r=g+4|0;a[r>>0]=j;a[r+1>>0]=j>>8;a[r+2>>0]=j>>16;a[r+3>>0]=j>>24;A=7}else{B=3;A=8}}}if((A|0)==7)c[s>>2]=0;else if((A|0)==8){c[s>>2]=B;z=B;i=q;return z|0}if(!p){B=d[o+1>>0]|0;c[k+80>>2]=B;A=d[o>>0]|0;c[x>>2]=A;j=d[f+46>>0]|0;if((j|0)==4){a[k+94>>0]=4;r=(B+1|0)>>>1;c[k+84>>2]=r;D=r}else if((j|0)==2){a[k+94>>0]=3;r=(B+3|0)>>>2;c[k+84>>2]=r;D=r}else if((j|0)==8){a[k+94>>0]=2;c[k+84>>2]=B;D=B}else if((j|0)==1){a[k+94>>0]=1;j=(B+7|0)>>>3;c[k+84>>2]=j;D=j}else{z=3;i=q;return z|0}j=da(D,A)|0;if(!j){z=0;i=q;return z|0}A=r9d(k,j)|0;c[s>>2]=A;if(A){z=A;i=q;return z|0}}A=e[y>>1]|0;switch(A|0){case 7:case 6:case 5:case 2:case 1:{y=d[f+46>>0]|0;if((l|0)<0){z=6;i=q;return z|0}j=d[o+1>>0]|0;if((m|0)<0?1:(j+l|0)>(c[k+80>>2]|0)){z=6;i=q;return z|0}D=d[o>>0]|0;if((D+m|0)>(c[x>>2]|0)){z=6;i=q;return z|0}B=da(j,y)|0;switch(A|0){case 6:case 1:{if((y|0)==1)E=(j+7|0)>>>3;else if((y|0)==4)E=(j+1|0)>>>1;else if((y|0)==2)E=(j+3|0)>>>2;else E=j;F=da(E,D)|0;G=1;break}case 7:case 5:case 2:{F=((da(D,B)|0)+7|0)>>>3;G=0;break}default:{z=3;i=q;return z|0}}D=Jae(n,F)|0;if(D){z=D;i=q;return z|0}D=da(y,l)|0;y=a[o>>0]|0;o=c[k+84>>2]|0;F=c[k+88>>2]|0;if((o|0)<0)H=F+(da((c[x>>2]|0)+-1|0,0-o|0)|0)|0;else H=F;if(y<<24>>24){F=da(o,m)|0;x=D>>3;E=D&7;D=8-E|0;j=B>>>0>7;A=B+-8|0;r=(E|0)==0;g=G<<24>>24==0;G=(15-B|0)>0?0:A>>>3;C=A-(G<<3)|0;I=c[n+32>>2]|0;J=0;K=y&255;y=H+(x+1+G+F)|0;G=H+(F+x)|0;x=0;while(1){if(j)if(r){F=I;H=J;L=A;M=G;N=x;while(1){if(N>>>0<8){O=F+1|0;P=(d[F>>0]<<8-N|H&65535)&65535;Q=N+8|0}else{O=F;P=H;Q=N}a[M>>0]=d[M>>0]|(P&65535)>>>8&65535;R=(P&65535)<<8&65535;S=Q+-8|0;L=L+-8|0;if((L|0)<=-1){T=O;U=R;V=C;W=y;X=S;break}else{F=O;H=R;M=M+1|0;N=S}}}else{N=I;M=J;H=A;F=G;L=x;while(1){if(L>>>0<8){Y=N+1|0;Z=(d[N>>0]<<8-L|M&65535)&65535;_=L+8|0}else{Y=N;Z=M;_=L}S=(Z&65535)>>>8&65535;a[F>>0]=d[F>>0]|S>>>E;F=F+1|0;a[F>>0]=d[F>>0]|S<<D;S=(Z&65535)<<8&65535;R=_+-8|0;H=H+-8|0;if((H|0)<=-1){T=Y;U=S;V=C;W=y;X=R;break}else{N=Y;M=S;L=R}}}else{T=I;U=J;V=B;W=G;X=x}if((V|0)>0){if((X|0)<(V|0)){$=T+1|0;aa=(d[T>>0]<<8-X|U&65535)&65535;ba=X+8|0}else{$=T;aa=U;ba=X}L=(aa&65535)>>>8&65535&(255>>>V^255);a[W>>0]=L>>>E|d[W>>0];if((V|0)>(D|0)){M=W+1|0;a[M>>0]=d[M>>0]|L<<D}ca=$;ea=(aa&65535)<<V&65535;fa=ba-V|0}else{ca=T;ea=U;fa=X}K=K+-1|0;if((K|0)<=0)break;else{I=ca;J=g?ea:0;y=y+o|0;G=G+o|0;x=g?fa:0}}}Lae(n);z=0;i=q;return z|0}case 8:{fa=Eae(n,1)|0;c[s>>2]=fa;if(fa){c[s>>2]=83;z=83;i=q;return z|0}break}case 9:break;default:{z=3;i=q;return z|0}}fa=Qae(n,s)|0;g=c[s>>2]|0;if(g){z=g;i=q;return z|0}g=fa&65535;x=Zae(w,4,0,g,0,s)|0;o=c[s>>2]|0;if(o){z=o;i=q;return z|0}o=Jae(n,g<<2)|0;c[s>>2]=o;a:do if(!o){g=fa<<16>>16==0;if(g){Lae(n);break}else{ga=x;ha=fa}while(1){b[ga>>1]=Nae(n)|0;a[ga+2>>0]=Mae(n)|0;a[ga+3>>0]=Mae(n)|0;ha=ha+-1<<16>>16;if(!(ha<<16>>16))break;else ga=ga+4|0}Lae(n);if(!g){G=p+1|0;y=x;ea=fa;while(1){J=Zee(e[y>>1]|0,f,t,v)|0;c[s>>2]=J;if(J)break a;J=_ee(f,c[t>>2]|0,h,c[v>>2]|0,k,(a[y+2>>0]|0)+l|0,(a[y+3>>0]|0)+m|0,n,u,G)|0;c[s>>2]=J;if(J)break a;ea=ea+-1<<16>>16;if(!(ea<<16>>16))break;else y=y+4|0}}}while(0);$ae(w,x);z=c[s>>2]|0;i=q;return z|0}function $ee(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e;g=kn[c[a+508>>2]&511](a,1801810542,b,f)|0;if(g){h=g;i=e;return h|0}g=c[f>>2]|0;if(g>>>0<4){h=142;i=e;return h|0}j=a+772|0;k=Iae(b,g,j)|0;if(k){h=k;i=e;return h|0}k=c[f>>2]|0;c[a+776>>2]=k;f=c[j>>2]|0;j=f+k|0;k=(d[f+2>>0]|0)<<8|(d[f+3>>0]|0);g=k>>>0>32?32:k;a:do if(!g){l=0;m=0;n=0}else{k=0;b=0;o=0;p=f+4|0;while(1){q=1<<b;r=p+6|0;if(r>>>0>j>>>0){l=k;m=b;n=o;break a}s=(d[p+2>>0]|0)<<8|(d[p+3>>0]|0);if(s>>>0<7){l=k;m=b;n=o;break a}t=p+s|0;s=p;p=t>>>0>j>>>0?j:t;t=s+14|0;b:do if(!(t>>>0>j>>>0?1:((d[s+4>>0]|0)<<8|(d[s+5>>0]|0)&247|0)!=1)){u=(d[r>>0]|0)<<8|(d[s+7>>0]|0);v=p-t|0;if((v|0)<(u*6|0))w=(v|0)/6|0;else w=u;u=q|k;if(!w){x=u;y=o}else{v=w+-1|0;if(v){z=v;v=(d[s+15>>0]|0)<<16|(d[t>>0]|0)<<24|(d[s+16>>0]|0)<<8|(d[s+17>>0]|0);A=s+20|0;while(1){B=v;v=(d[A+1>>0]|0)<<16|(d[A>>0]|0)<<24|(d[A+2>>0]|0)<<8|(d[A+3>>0]|0);if(v>>>0<=B>>>0){x=u;y=o;break b}z=z+-1|0;if(!z)break;else A=A+6|0}}x=u;y=q|o}}else{x=k;y=o}while(0);q=b+1|0;if(q>>>0>=g>>>0){l=x;m=q;n=y;break}else{k=x;b=q;o=y}}}while(0);c[a+780>>2]=m;c[a+784>>2]=l;c[a+788>>2]=n;h=0;i=e;return h|0}function afe(a){a=a|0;var b=0,d=0;b=i;Kae(c[a+104>>2]|0,a+772|0);d=a+776|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}function bfe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;h=c[b+772>>2]|0;j=c[b+776>>2]|0;k=h+j|0;l=c[b+780>>2]|0;if((l|0)==0|(j|0)<10){m=0;i=g;return m|0}j=c[b+784>>2]|0;n=e<<16|f;f=b+788|0;b=h+10|0;e=l;l=1;o=h+4|0;h=0;while(1){p=a[o+4>>0]|0;q=a[o+5>>0]|0;r=o+(d[o+2>>0]<<8|d[o+3>>0])|0;s=o;o=r>>>0>k>>>0?k:r;r=s+14|0;a:do if(!((j&l|0)==0|r>>>0>o>>>0)){t=d[b>>0]<<8|d[s+7>>0];u=o-r|0;if((u|0)<(t*6|0))v=(u|0)/6|0;else v=t;if(!(p<<24>>24)){t=(v|0)==0;if(!(c[f>>2]&l)){if(t){w=h;break}else{x=v;y=r}while(1){if((d[y+1>>0]<<16|d[y>>0]<<24|d[y+2>>0]<<8|d[y+3>>0]|0)==(n|0)){z=y;break}x=x+-1|0;if(!x){w=h;break a}else y=y+6|0}A=a[z+4>>0]<<8|d[z+5>>0]}else{if(t){w=h;break}else{B=v;C=0}while(1){u=(B+C|0)>>>1;D=u*6|0;E=d[s+(D+15)>>0]<<16|d[s+(D+14)>>0]<<24|d[s+(D+16)>>0]<<8|d[s+(D+17)>>0];if((E|0)==(n|0)){F=D;break}D=E>>>0<n>>>0;C=D?u+1|0:C;B=D?B:u;if(C>>>0>=B>>>0){w=h;break a}}A=a[s+(F+18)>>0]<<8|d[s+(F+19)>>0]}w=A+((q&8)==0?h:0)|0}else w=h}else w=h;while(0);e=e+-1|0;b=o+6|0;if((e|0)==0|b>>>0>k>>>0){m=w;break}else{l=l<<1;h=w}}i=g;return m|0}function cfe(a){a=a|0;c[a>>2]=1869968492;c[a+4>>2]=2829;c[a+8>>2]=1848;c[a+12>>2]=0;c[a+16>>2]=2830;c[a+20>>2]=3554;return}function dfe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[b>>2]=0;f=Xae(a,20,e)|0;g=c[e>>2]|0;if(g){i=d;return g|0}c[f+12>>2]=a;c[b>>2]=f;i=d;return g|0}function efe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(!a){i=e;return}if((b|0)!=0&(d|0)>3323){c[a+16>>2]=b;c[a>>2]=b+1280;b=d+-1280|0;c[a+4>>2]=b&-16;c[a+8>>2]=b>>>7;i=e;return}else{c[a>>2]=0;c[a+4>>2]=0;c[a+16>>2]=0;i=e;return}}function ffe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=i;i=i+384|0;f=e+368|0;g=e+336|0;h=e+8|0;j=e+328|0;k=e+372|0;l=e;m=e+332|0;n=e+364|0;o=e+360|0;p=c[d+4>>2]|0;q=c[d>>2]|0;if(!a){r=6;i=e;return r|0}s=c[a>>2]|0;if(!s){r=6;i=e;return r|0}t=a+4|0;u=c[t>>2]|0;if(!u){r=6;i=e;return r|0}if(!p){r=20;i=e;return r|0}v=b[p+2>>1]|0;if(!(v<<16>>16)){r=0;i=e;return r|0}w=b[p>>1]|0;if(w<<16>>16<1){r=0;i=e;return r|0}x=c[p+12>>2]|0;if(!x){r=20;i=e;return r|0}if(!(c[p+4>>2]|0)){r=20;i=e;return r|0}if((v<<16>>16|0)!=((b[x+((w<<16>>16)+-1<<1)>>1]|0)+1|0)){r=20;i=e;return r|0}w=c[a+16>>2]|0;x=d+8|0;v=c[x>>2]|0;y=(v&2|0)==0;if(y){if(!q){r=6;i=e;return r|0}if(!(c[q+4>>2]|0)){r=0;i=e;return r|0}if(!(c[q>>2]|0)){r=0;i=e;return r|0}if(!(c[q+12>>2]|0)){r=6;i=e;return r|0}}if(!(v&1)){r=19;i=e;return r|0}do if(!y){z=w+1024|0;if(!(v&4)){c[z>>2]=-32768;c[w+1028>>2]=-32768;c[w+1032>>2]=32767;c[w+1036>>2]=32767;A=s;B=u;break}else{C=d+32|0;c[z+0>>2]=c[C+0>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];A=c[a>>2]|0;B=c[t>>2]|0;break}}else{c[w+1024>>2]=0;c[w+1028>>2]=0;c[w+1032>>2]=c[q+4>>2];c[w+1036>>2]=c[q>>2];A=s;B=u}while(0);u=w+1260|0;c[u>>2]=A;s=w+1264|0;c[s>>2]=B;B=w+1268|0;c[B>>2]=A;A=w+44|0;c[A>>2]=0;t=w+48|0;c[t>>2]=0;v=w+52|0;c[v>>2]=0;y=w+32|0;c[y>>2]=0;C=w+36|0;c[C>>2]=0;z=w+40|0;c[z>>2]=1;D=w+980|0;c[D+0>>2]=c[p+0>>2];c[D+4>>2]=c[p+4>>2];c[D+8>>2]=c[p+8>>2];c[D+12>>2]=c[p+12>>2];c[D+16>>2]=c[p+16>>2];c[v>>2]=0;c[z>>2]=1;p=c[a+8>>2]|0;a=w+1248|0;c[a>>2]=p;E=w+1232|0;c[E>>2]=0;if(!(c[x>>2]&2)){x=w+1e3|0;c[x+0>>2]=c[q+0>>2];c[x+4>>2]=c[q+4>>2];c[x+8>>2]=c[q+8>>2];c[x+12>>2]=c[q+12>>2];c[x+16>>2]=c[q+16>>2];c[x+20>>2]=c[q+20>>2];c[w+1236>>2]=341;F=w}else{c[w+1236>>2]=c[d+12>>2];F=c[d+28>>2]|0}d=w+1240|0;c[d>>2]=F;F=c[w+984>>2]|0;q=b[w+982>>1]|0;x=F+(q<<16>>16<<3)|0;if(q<<16>>16<1){G=w+8|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;H=w+12|0;I=0;J=0;K=0;L=0}else{G=c[F>>2]|0;M=w+12|0;c[M>>2]=G;N=w+8|0;c[N>>2]=G;O=c[F+4>>2]|0;P=w+20|0;c[P>>2]=O;Q=w+16|0;c[Q>>2]=O;if(q<<16>>16>1){q=F;R=G;S=G;T=O;U=O;V=F+8|0;while(1){F=c[q+8>>2]|0;W=c[q+12>>2]|0;if((F|0)<(R|0)){c[N>>2]=F;X=F}else X=R;if((F|0)>(S|0)){c[M>>2]=F;Y=F}else Y=S;if((W|0)<(T|0)){c[Q>>2]=W;Z=W}else Z=T;if((W|0)>(U|0)){c[P>>2]=W;_=W}else _=U;W=q+16|0;if(W>>>0<x>>>0){F=V;R=X;S=Y;T=Z;U=_;V=W;q=F}else{$=X;aa=Z;ba=Y;ca=_;break}}}else{$=G;aa=O;ba=G;ca=O}O=$>>6;c[N>>2]=O;N=aa>>6;c[Q>>2]=N;Q=ba+63>>6;c[M>>2]=Q;ba=ca+63>>6;c[P>>2]=ba;H=M;I=Q;J=O;K=ba;L=N}N=c[w+1024>>2]|0;if((I|0)<=(N|0)){r=0;i=e;return r|0}ba=c[w+1032>>2]|0;if((J|0)>=(ba|0)){r=0;i=e;return r|0}O=w+20|0;Q=c[w+1028>>2]|0;if((K|0)<=(Q|0)){r=0;i=e;return r|0}M=w+16|0;P=c[w+1036>>2]|0;if((L|0)>=(P|0)){r=0;i=e;return r|0}if((J|0)<(N|0)){c[w+8>>2]=N;da=N}else da=J;if((L|0)<(Q|0)){c[M>>2]=Q;ea=Q}else ea=L;if((I|0)>(ba|0)){c[H>>2]=ba;fa=ba}else fa=I;if((K|0)>(P|0)){c[O>>2]=P;ga=P}else ga=K;K=w+24|0;c[K>>2]=fa-da;da=ga-ea|0;ea=w+28|0;c[ea>>2]=da;c[l>>2]=(da|0)/(p|0)|0;if(!(c[l>>2]|0))c[l>>2]=1;if((c[l>>2]|0)>38)c[l>>2]=39;p=w+1252|0;c[p>>2]=0;c[m>>2]=c[M>>2];c[o>>2]=c[O>>2];c[k>>2]=0;a:do if((c[k>>2]|0)<(c[l>>2]|0)){da=h+4|0;ga=w+1272|0;fa=g+4|0;P=g+8|0;I=g+12|0;ba=g+16|0;H=g+20|0;L=w+1256|0;Q=w+4|0;J=w+1236|0;N=w+1244|0;ca=w+1040|0;b:while(1){c[n>>2]=(c[a>>2]|0)+(c[m>>2]|0);if(!((c[k>>2]|0)!=((c[l>>2]|0)+-1|0)?(c[n>>2]|0)<=(c[o>>2]|0):0))c[n>>2]=c[o>>2];c[h>>2]=c[m>>2];c[da>>2]=c[n>>2];c[j>>2]=h;if((c[j>>2]|0)>>>0>=h>>>0)do{c[B>>2]=c[u>>2];aa=(c[(c[j>>2]|0)+4>>2]|0)-(c[c[j>>2]>>2]|0)|0;c[ga>>2]=aa;$=aa<<2;G=$&12;if(!G)ha=$;else ha=$+16-G|0;G=c[s>>2]&-16;c[A>>2]=(c[u>>2]|0)+ha;do if((G|0)>(ha|0)){$=G-ha|0;c[t>>2]=$>>4;if(($|0)<32){ia=97;break}if((aa|0)>0){$=0;do{c[(c[B>>2]|0)+($<<2)>>2]=0;$=$+1|0}while(($|0)!=(aa|0))}c[v>>2]=0;c[z>>2]=1;c[M>>2]=c[c[j>>2]>>2];c[O>>2]=c[(c[j>>2]|0)+4>>2];c[ea>>2]=(c[(c[j>>2]|0)+4>>2]|0)-(c[c[j>>2]>>2]|0);c[f>>2]=0;c[g>>2]=2831;c[fa>>2]=2832;c[P>>2]=1755;c[I>>2]=266;c[ba>>2]=0;c[H>>2]=0;c[L>>2]=0;c[f>>2]=bae(D,g,w)|0;c:do if(!(c[z>>2]|0)){$=c[y>>2]|0;_=c[C>>2]|0;if(!(_|$)){ia=77;break}Y=c[w>>2]|0;Z=c[K>>2]|0;X=(Y|0)>(Z|0)?Z:Y;Y=(c[B>>2]|0)+(c[Q>>2]<<2)|0;Z=c[Y>>2]|0;d:do if(!Z){ja=0;ka=Y;ia=72}else{q=Z;V=Y;while(1){U=c[q>>2]|0;if((U|0)>(X|0)){ja=q;ka=V;ia=72;break d}T=q+12|0;if((U|0)==(X|0)){la=q;break d}q=c[T>>2]|0;if(!q){ja=0;ka=T;ia=72;break}else V=T}}while(0);do if((ia|0)==72){ia=0;Y=c[v>>2]|0;if((Y|0)<(c[t>>2]|0)){Z=c[A>>2]|0;c[v>>2]=Y+1;V=Z+(Y<<4)|0;c[V>>2]=X;c[Z+(Y<<4)+8>>2]=0;c[Z+(Y<<4)+4>>2]=0;c[Z+(Y<<4)+12>>2]=ja;c[ka>>2]=V;la=V;break}else{c[L>>2]=64;ma=64;ia=78;break c}}while(0);if(!la){ia=77;break}X=la+8|0;c[X>>2]=(c[X>>2]|0)+$;X=la+4|0;c[X>>2]=(c[X>>2]|0)+_;ia=77}else ia=77;while(0);if((ia|0)==77?(ia=0,X=c[L>>2]|0,(X|0)!=0):0){ma=X;ia=78}if((ia|0)==78){ia=0;c[f>>2]=ma;c[L>>2]=0}X=c[f>>2]|0;if((X|0)==64){ia=97;break}else if(X){r=1;ia=105;break b}do if(c[v>>2]|0){c[E>>2]=0;if((c[ga>>2]|0)>0){X=0;do{V=c[(c[B>>2]|0)+(X<<2)>>2]|0;do if(V){Y=V;Z=0;q=0;while(1){T=c[Y>>2]|0;if((T|0)>(q|0)&(Z|0)!=0)mfe(w,q,X,Z<<9,T-q|0);T=(c[Y+4>>2]|0)+Z|0;U=T<<9;S=c[Y+8>>2]|0;R=U-S|0;do if((U|0)!=(S|0)){x=c[Y>>2]|0;if((x|0)<=-1)break;mfe(w,x,X,R,1)}while(0);R=(c[Y>>2]|0)+1|0;Y=c[Y+12>>2]|0;if(!Y){na=T;oa=U;pa=R;break}else{Z=T;q=R}}if(!na)break;mfe(w,pa,X,oa,(c[K>>2]|0)-pa|0)}while(0);X=X+1|0}while((X|0)<(c[ga>>2]|0))}X=c[J>>2]|0;if(!X)break;_=c[E>>2]|0;if((_|0)<=0)break;Dn[X&511](c[N>>2]|0,_,ca,c[d>>2]|0)}while(0);c[j>>2]=(c[j>>2]|0)+-8}else ia=97;while(0);if((ia|0)==97){ia=0;aa=c[c[j>>2]>>2]|0;G=c[(c[j>>2]|0)+4>>2]|0;_=G-aa>>1;X=_+aa|0;if(!_){r=1;ia=105;break b}if((aa-G|0)>=(c[a>>2]|0))c[p>>2]=(c[p>>2]|0)+1;c[(c[j>>2]|0)+8>>2]=aa;c[(c[j>>2]|0)+12>>2]=X;c[c[j>>2]>>2]=X;c[(c[j>>2]|0)+4>>2]=G;c[j>>2]=(c[j>>2]|0)+8}}while((c[j>>2]|0)>>>0>=h>>>0);c[k>>2]=(c[k>>2]|0)+1;c[m>>2]=c[n>>2];if((c[k>>2]|0)>=(c[l>>2]|0))break a}if((ia|0)==105){i=e;return r|0}}while(0);if((c[p>>2]|0)<=8){r=0;i=e;return r|0}p=c[a>>2]|0;if((p|0)<=16){r=0;i=e;return r|0}c[a>>2]=(p|0)/2|0;r=0;i=e;return r|0}function gfe(a){a=a|0;var b=0;b=i;$ae(c[a+12>>2]|0,a);i=b;return}function hfe(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;j=c[g+1012>>2]|0;k=c[g+1008>>2]|0;l=da(k,d)|0;if((k|0)>-1)m=da((c[g+1e3>>2]|0)+-1|0,k)|0;else m=0;k=m-l|0;if((e|0)>0){n=f;o=e}else{i=h;return}while(1){e=a[n+4>>0]|0;a:do if(e<<24>>24){f=b[n+2>>1]|0;l=f&65535;m=b[n>>1]|0;g=j+(k+m)|0;if((f&65535)>7){PEi(g|0,e|0,l|0)|0;break}switch(l|0){case 3:{p=m;q=g;r=12;break}case 5:{s=m;t=g;r=10;break}case 2:{u=m;v=g;r=13;break}case 7:{l=m+1|0;a[g>>0]=e;w=l;x=j+(k+l)|0;r=9;break}case 4:{y=m;z=g;r=11;break}case 6:{w=m;x=g;r=9;break}case 1:{A=g;break}default:break a}if((r|0)==9){r=0;g=w+1|0;a[x>>0]=e;s=g;t=j+(k+g)|0;r=10}if((r|0)==10){r=0;g=s+1|0;a[t>>0]=e;y=g;z=j+(k+g)|0;r=11}if((r|0)==11){r=0;g=y+1|0;a[z>>0]=e;p=g;q=j+(k+g)|0;r=12}if((r|0)==12){r=0;g=p+1|0;a[q>>0]=e;u=g;v=j+(k+g)|0;r=13}if((r|0)==13){r=0;a[v>>0]=e;A=j+(k+(u+1))|0}a[A>>0]=e}while(0);o=o+-1|0;if((o|0)<=0)break;else n=n+6|0}i=h;return}function ife(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=b+40|0;a:do if((c[e>>2]|0)==0?(f=c[b+32>>2]|0,g=c[b+36>>2]|0,(g|f|0)!=0):0){h=c[b>>2]|0;j=c[b+24>>2]|0;k=(h|0)>(j|0)?j:h;h=(c[b+1268>>2]|0)+(c[b+4>>2]<<2)|0;j=c[h>>2]|0;b:do if(!j){l=0;m=h;n=7}else{o=j;p=h;while(1){q=c[o>>2]|0;if((q|0)>(k|0)){l=o;m=p;n=7;break b}r=o+12|0;if((q|0)==(k|0)){s=o;break b}o=c[r>>2]|0;if(!o){l=0;m=r;n=7;break}else p=r}}while(0);do if((n|0)==7){h=b+52|0;j=c[h>>2]|0;if((j|0)<(c[b+48>>2]|0)){p=c[b+44>>2]|0;c[h>>2]=j+1;h=p+(j<<4)|0;c[h>>2]=k;c[p+(j<<4)+8>>2]=0;c[p+(j<<4)+4>>2]=0;c[p+(j<<4)+12>>2]=l;c[m>>2]=h;s=h;break}else{c[b+1256>>2]=64;break a}}while(0);if(s){k=s+8|0;c[k>>2]=(c[k>>2]|0)+f;k=s+4|0;c[k>>2]=(c[k>>2]|0)+g}}while(0);s=c[b+1256>>2]|0;if(s){t=s;i=d;return t|0}s=c[a>>2]<<2;m=c[a+4>>2]<<2;a=s>>8;l=m>>8;n=c[b+12>>2]|0;k=(n|0)<(a|0)?n:a;a=c[b+8>>2]|0;h=(k|0)<(a|0)?a+-1|0:k;k=b+32|0;c[k>>2]=0;j=b+36|0;c[j>>2]=0;p=h-a|0;c[b>>2]=p;o=l-(c[b+16>>2]|0)|0;r=b+4|0;c[r>>2]=o;c[b+72>>2]=l<<8;c[e>>2]=0;l=((n|0)<(h|0)?n:h)-a|0;a=(l|0)>-1?l:-1;if((a|0)!=(p|0)){c[k>>2]=0;c[j>>2]=0}c[b>>2]=a;c[r>>2]=o;if(o>>>0<(c[b+28>>2]|0)>>>0)u=(a|0)>=(c[b+24>>2]|0);else u=1;c[e>>2]=u&1;c[b+64>>2]=s;c[b+68>>2]=m;t=0;i=d;return t|0}function jfe(a,b){a=a|0;b=b|0;var d=0;d=i;nfe(b,c[a>>2]<<2,c[a+4>>2]<<2);i=d;return 0}function kfe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[b+4>>2]|0;g=d+76|0;h=c[b>>2]<<2;c[g>>2]=h;b=f<<2;c[d+80>>2]=b;f=c[a>>2]|0;c[d+84>>2]=f<<2;j=c[a+4>>2]|0;a=j<<2;c[d+88>>2]=a;k=c[d+64>>2]|0;c[d+92>>2]=k;l=c[d+68>>2]|0;c[d+96>>2]=l;m=h-(f<<3)+k|0;k=(m|0)<0?0-m|0:m;m=b-(j<<3)+l|0;j=(m|0)<0?0-m|0:m;m=(k|0)<(j|0)?j:k;if(((m|0)>=64?(k=(a|0)<(b|0)?a:b,j=(a|0)>(b|0)?a:b,(((l|0)<(k|0)?l:k)>>8|0)<(c[d+20>>2]|0)):0)?(((l|0)>(j|0)?l:j)>>8|0)>=(c[d+16>>2]|0):0){j=m;m=0;while(1){j=j>>2;l=m+1|0;if((j|0)<=64){n=l;break}else m=l}m=d+852|0;c[m>>2]=n;o=n;p=g;q=m;r=0;s=6}else{t=h;u=g;v=0;w=0;s=9}a:while(1){do if((s|0)==6){s=0;if((o|0)>0){g=p+16|0;h=c[g>>2]|0;c[p+32>>2]=h;m=p+8|0;n=c[m>>2]|0;j=(n+h|0)/2|0;c[p+24>>2]=j;h=((c[p>>2]|0)+n|0)/2|0;c[m>>2]=h;c[g>>2]=(h+j|0)/2|0;j=p+20|0;h=c[j>>2]|0;c[p+36>>2]=h;g=p+12|0;m=c[g>>2]|0;n=(m+h|0)/2|0;c[p+28>>2]=n;h=((c[p+4>>2]|0)+m|0)/2|0;c[g>>2]=h;c[j>>2]=(h+n|0)/2|0;n=r+1|0;h=o+-1|0;c[q+(r<<2)>>2]=h;c[q+(n<<2)>>2]=h;x=p+16|0;y=q;z=n;break}else{t=c[p>>2]|0;u=p;v=q;w=r;s=9;continue a}}else if((s|0)==9){s=0;nfe(d,t,c[u+4>>2]|0);x=u+-16|0;y=v;z=w+-1|0}while(0);if((z|0)<=-1)break;o=c[y+(z<<2)>>2]|0;p=x;q=y;r=z;s=6}i=e;return 0}function lfe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;g=c[d+4>>2]|0;h=e+76|0;j=c[d>>2]<<2;c[h>>2]=j;d=g<<2;c[e+80>>2]=d;c[e+84>>2]=c[b>>2]<<2;g=c[b+4>>2]<<2;c[e+88>>2]=g;c[e+92>>2]=c[a>>2]<<2;b=c[a+4>>2]<<2;c[e+96>>2]=b;c[e+100>>2]=c[e+64>>2];a=c[e+68>>2]|0;c[e+104>>2]=a;k=(g|0)<(d|0)?g:d;l=(g|0)>(d|0)?g:d;d=(b|0)<(k|0)?b:k;k=(b|0)>(l|0)?b:l;if((((a|0)<(d|0)?a:d)>>8|0)<(c[e+20>>2]|0)?(((a|0)>(k|0)?a:k)>>8|0)>=(c[e+16>>2]|0):0){m=j;n=h}else{o=j;p=h;q=15}while(1){if((q|0)==15){q=0;nfe(e,o,c[p+4>>2]|0);if((p|0)==(h|0))break;j=p+-24|0;m=c[j>>2]|0;n=j}j=n+24|0;k=c[j>>2]|0;a=k-m|0;d=n+28|0;l=c[d>>2]|0;b=c[n+4>>2]|0;g=l-b|0;r=(a|0)<0?0-a|0:a;s=(g|0)<0?0-g|0:g;if((r|0)>(s|0))t=(s*97|0)+(r*236|0)|0;else t=(s*236|0)+(r*97|0)|0;r=t>>8;if((r|0)<=32767){s=r*42|0;r=c[n+8>>2]|0;u=r-m|0;v=c[n+12>>2]|0;w=v-b|0;x=(da(u,g)|0)-(da(w,a)|0)|0;if((((((((x|0)<0?0-x|0:x)|0)<=(s|0)?(x=c[n+16>>2]|0,y=x-m|0,z=c[n+20>>2]|0,A=z-b|0,B=(da(y,g)|0)-(da(A,a)|0)|0,(((B|0)<0?0-B|0:B)|0)<=(s|0)):0)?((da(w,g)|0)+(da(u,a)|0)|0)>=0:0)?((da(A,g)|0)+(da(y,a)|0)|0)>=0:0)?((da(l-v|0,g)|0)+(da(k-r|0,a)|0)|0)>=0:0)?((da(l-z|0,g)|0)+(da(k-x|0,a)|0)|0)>=0:0){o=m;p=n;q=15;continue}else{C=r;D=v}}else{C=c[n+8>>2]|0;D=c[n+12>>2]|0}c[n+48>>2]=k;v=n+16|0;r=c[v>>2]|0;a=(C+m|0)/2|0;c[n+8>>2]=a;x=(r+k|0)/2|0;c[n+40>>2]=x;k=(r+C|0)/2|0;r=(k+a|0)/2|0;c[v>>2]=r;v=(k+x|0)/2|0;c[n+32>>2]=v;x=(v+r|0)/2|0;c[n+24>>2]=x;c[n+52>>2]=l;r=n+20|0;v=c[r>>2]|0;k=(D+b|0)/2|0;c[n+12>>2]=k;b=(v+l|0)/2|0;c[n+44>>2]=b;l=(v+D|0)/2|0;v=(l+k|0)/2|0;c[r>>2]=v;r=(l+b|0)/2|0;c[n+36>>2]=r;c[d>>2]=(r+v|0)/2|0;m=x;n=j}i=f;return 0}function mfe(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=i;m=j>>9;j=(m|0)<0?0-m|0:m;do if(c[f+996>>2]&2){m=j&511;if(m>>>0>256){n=512-m|0;break}else{n=(m|0)==256?255:m;break}}else n=(j|0)>255?255:j;while(0);j=(c[f+16>>2]|0)+h|0;h=(c[f+8>>2]|0)+g|0;g=(h|0)<32767?h:32767;if(!n){i=l;return}h=f+1232|0;m=c[h>>2]|0;o=f+1040|0;p=m+-1|0;q=(m|0)>0;r=c[f+1244>>2]|0;if(q&(r|0)==(j|0)){s=f+(p*6|0)+1042|0;t=e[s>>1]|0;if((t+(b[f+(p*6|0)+1040>>1]|0)|0)==(g|0)?(d[f+(p*6|0)+1044>>0]|0)==(n|0):0){b[s>>1]=t+k;i=l;return}else u=j}else u=r;r=f+1244|0;if((u|0)!=(j|0)|(m|0)>31){t=c[f+1236>>2]|0;if((t|0)!=0&q)Dn[t&511](u,m,o,c[f+1240>>2]|0);c[h>>2]=0;c[r>>2]=j;v=0}else v=m;b[f+(v*6|0)+1040>>1]=g;b[f+(v*6|0)+1042>>1]=k;a[f+(v*6|0)+1044>>0]=n;c[h>>2]=(c[h>>2]|0)+1;i=l;return}function nfe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=i;f=a+72|0;g=c[f>>2]|0;h=g>>8;j=d>>8;k=a+68|0;l=c[k>>2]|0;m=l-g|0;g=j<<8;n=d-g|0;o=a+64|0;p=c[o>>2]|0;q=b-p|0;r=d-l|0;l=(h|0)>(j|0);if(((l?j:h)|0)>=(c[a+20>>2]|0)){c[o>>2]=b;c[k>>2]=d;c[f>>2]=g;i=e;return}s=a+16|0;t=c[s>>2]|0;if(((l?h:j)|0)<(t|0)){c[o>>2]=b;c[k>>2]=d;c[f>>2]=g;i=e;return}if((h|0)==(j|0)){ofe(a,h,p,m,b,n);c[o>>2]=b;c[k>>2]=d;c[f>>2]=g;i=e;return}if((p|0)==(b|0)){l=b>>8;u=b-(l<<8)<<1;v=r>>31;w=v+256&-256;x=v|1;v=w-m|0;y=da(u,v)|0;z=a+32|0;A=(c[z>>2]|0)+y|0;c[z>>2]=A;y=a+36|0;B=(c[y>>2]|0)+v|0;c[y>>2]=B;v=x+h|0;C=v-t|0;t=a+12|0;D=c[t>>2]|0;E=a+8|0;F=((D|0)<(l|0)?D:l)-(c[E>>2]|0)|0;D=(F|0)>-1?F:-1;F=c[a>>2]|0;if((D|0)==(F|0)?(G=a+4|0,(C|0)==(c[G>>2]|0)):0)H=G;else{a:do if(!((c[a+40>>2]|0)!=0|(B|A|0)==0)){G=c[a+24>>2]|0;I=(F|0)>(G|0)?G:F;G=(c[a+1268>>2]|0)+(c[a+4>>2]<<2)|0;J=c[G>>2]|0;b:do if(!J){K=0;L=G;M=13}else{N=J;O=G;while(1){P=c[N>>2]|0;if((P|0)>(I|0)){K=N;L=O;M=13;break b}Q=N+12|0;if((P|0)==(I|0)){R=N;break b}N=c[Q>>2]|0;if(!N){K=0;L=Q;M=13;break}else O=Q}}while(0);do if((M|0)==13){G=a+52|0;J=c[G>>2]|0;if((J|0)<(c[a+48>>2]|0)){O=c[a+44>>2]|0;c[G>>2]=J+1;G=O+(J<<4)|0;c[G>>2]=I;c[O+(J<<4)+8>>2]=0;c[O+(J<<4)+4>>2]=0;c[O+(J<<4)+12>>2]=K;c[L>>2]=G;R=G;break}else{c[a+1256>>2]=64;break a}}while(0);if(R){I=R+8|0;c[I>>2]=(c[I>>2]|0)+A;I=R+4|0;c[I>>2]=(c[I>>2]|0)+B}}while(0);c[z>>2]=0;c[y>>2]=0;H=a+4|0}c[a>>2]=D;c[H>>2]=C;H=c[a+28>>2]|0;if(C>>>0<H>>>0)S=(D|0)>=(c[a+24>>2]|0);else S=1;C=S&1;S=a+40|0;c[S>>2]=C;B=(w<<1)+-256|0;R=da(B,u)|0;if((v|0)!=(j|0)){A=a+4|0;L=a+24|0;K=a+1268|0;F=a+52|0;I=a+48|0;G=a+44|0;J=a+1256|0;O=D;D=C;C=v;while(1){v=(c[z>>2]|0)+R|0;c[z>>2]=v;N=(c[y>>2]|0)+B|0;c[y>>2]=N;C=C+x|0;Q=C-(c[s>>2]|0)|0;P=c[t>>2]|0;T=((P|0)<(l|0)?P:l)-(c[E>>2]|0)|0;P=(T|0)>-1?T:-1;if(!((P|0)==(O|0)?(Q|0)==(c[A>>2]|0):0)){c:do if(!((D|0)!=0|(N|v|0)==0)){T=c[L>>2]|0;U=(O|0)>(T|0)?T:O;T=(c[K>>2]|0)+(c[A>>2]<<2)|0;V=c[T>>2]|0;d:do if(!V){W=0;X=T;M=30}else{Y=V;Z=T;while(1){_=c[Y>>2]|0;if((_|0)>(U|0)){W=Y;X=Z;M=30;break d}$=Y+12|0;if((_|0)==(U|0)){aa=Y;break d}Y=c[$>>2]|0;if(!Y){W=0;X=$;M=30;break}else Z=$}}while(0);do if((M|0)==30){M=0;T=c[F>>2]|0;if((T|0)<(c[I>>2]|0)){V=c[G>>2]|0;c[F>>2]=T+1;Z=V+(T<<4)|0;c[Z>>2]=U;c[V+(T<<4)+8>>2]=0;c[V+(T<<4)+4>>2]=0;c[V+(T<<4)+12>>2]=W;c[X>>2]=Z;aa=Z;break}else{c[J>>2]=64;break c}}while(0);if(aa){U=aa+8|0;c[U>>2]=(c[U>>2]|0)+v;U=aa+4|0;c[U>>2]=(c[U>>2]|0)+N}}while(0);c[z>>2]=0;c[y>>2]=0}c[A>>2]=Q;if(Q>>>0<H>>>0)ba=(P|0)>=(c[L>>2]|0);else ba=1;D=ba&1;c[S>>2]=D;if((C|0)==(j|0)){ca=P;break}else O=P}c[a>>2]=ca}ca=n+-256+w|0;w=da(u,ca)|0;c[z>>2]=(c[z>>2]|0)+w;c[y>>2]=(c[y>>2]|0)+ca;c[o>>2]=b;c[k>>2]=d;c[f>>2]=g;i=e;return}ca=(r|0)<0;y=r>>31;w=y+256&-256;z=y|1;y=ca?0-r|0:r;r=da(ca?m:256-m|0,q)|0;ca=(r|0)/(y|0)|0;u=(r|0)%(y|0)|0;if((u|0)<0){ea=ca+-1|0;fa=u+y|0}else{ea=ca;fa=u}u=p+ea|0;ofe(a,h,p,m,u,w);m=z+h|0;h=u>>8;p=m-(c[s>>2]|0)|0;ea=a+12|0;ca=c[ea>>2]|0;r=a+8|0;O=((ca|0)<(h|0)?ca:h)-(c[r>>2]|0)|0;h=(O|0)>-1?O:-1;O=c[a>>2]|0;if((h|0)==(O|0)?(ca=a+4|0,(p|0)==(c[ca>>2]|0)):0)ga=ca;else{ca=a+32|0;e:do if(!(c[a+40>>2]|0)){C=c[ca>>2]|0;D=a+36|0;S=c[D>>2]|0;if(S|C){ba=c[a+24>>2]|0;L=(O|0)>(ba|0)?ba:O;ba=(c[a+1268>>2]|0)+(c[a+4>>2]<<2)|0;H=c[ba>>2]|0;f:do if(!H){ha=0;ia=ba;M=52}else{A=H;aa=ba;while(1){J=c[A>>2]|0;if((J|0)>(L|0)){ha=A;ia=aa;M=52;break f}X=A+12|0;if((J|0)==(L|0)){ja=A;break f}A=c[X>>2]|0;if(!A){ha=0;ia=X;M=52;break}else aa=X}}while(0);do if((M|0)==52){ba=a+52|0;H=c[ba>>2]|0;if((H|0)<(c[a+48>>2]|0)){P=c[a+44>>2]|0;c[ba>>2]=H+1;ba=P+(H<<4)|0;c[ba>>2]=L;c[P+(H<<4)+8>>2]=0;c[P+(H<<4)+4>>2]=0;c[P+(H<<4)+12>>2]=ha;c[ia>>2]=ba;ja=ba;break}else{c[a+1256>>2]=64;ka=D;break e}}while(0);if(ja){L=ja+8|0;c[L>>2]=(c[L>>2]|0)+C;L=ja+4|0;c[L>>2]=(c[L>>2]|0)+S;ka=D}else ka=D}else ka=D}else ka=a+36|0;while(0);c[ca>>2]=0;c[ka>>2]=0;ga=a+4|0}c[a>>2]=h;c[ga>>2]=p;ga=a+28|0;if(p>>>0<(c[ga>>2]|0)>>>0)la=(h|0)>=(c[a+24>>2]|0);else la=1;h=a+40|0;c[h>>2]=la&1;if((m|0)==(j|0))ma=u;else{la=q<<8;q=(la|0)/(y|0)|0;p=(la|0)%(y|0)|0;if((p|0)<0){na=q+-1|0;oa=p+y|0}else{na=q;oa=p}p=256-w|0;q=a+4|0;la=a+24|0;ka=a+32|0;ca=a+36|0;ja=a+1268|0;ia=a+52|0;ha=a+48|0;O=a+44|0;L=a+1256|0;ba=m;m=fa-y|0;fa=u;while(1){u=m+oa|0;m=u-((u|0)>-1?y:0)|0;H=na+(u>>>31^1)+fa|0;ofe(a,ba,fa,p,H,w);ba=ba+z|0;u=H>>8;P=ba-(c[s>>2]|0)|0;Q=c[ea>>2]|0;aa=((Q|0)<(u|0)?Q:u)-(c[r>>2]|0)|0;u=(aa|0)>-1?aa:-1;aa=c[a>>2]|0;if(!((u|0)==(aa|0)?(P|0)==(c[q>>2]|0):0)){g:do if((c[h>>2]|0)==0?(Q=c[ka>>2]|0,A=c[ca>>2]|0,(A|Q|0)!=0):0){X=c[la>>2]|0;J=(aa|0)>(X|0)?X:aa;X=(c[ja>>2]|0)+(c[q>>2]<<2)|0;W=c[X>>2]|0;h:do if(!W){pa=0;qa=X;M=72}else{F=W;G=X;while(1){I=c[F>>2]|0;if((I|0)>(J|0)){pa=F;qa=G;M=72;break h}K=F+12|0;if((I|0)==(J|0)){ra=F;break h}F=c[K>>2]|0;if(!F){pa=0;qa=K;M=72;break}else G=K}}while(0);do if((M|0)==72){M=0;X=c[ia>>2]|0;if((X|0)<(c[ha>>2]|0)){W=c[O>>2]|0;c[ia>>2]=X+1;G=W+(X<<4)|0;c[G>>2]=J;c[W+(X<<4)+8>>2]=0;c[W+(X<<4)+4>>2]=0;c[W+(X<<4)+12>>2]=pa;c[qa>>2]=G;ra=G;break}else{c[L>>2]=64;break g}}while(0);if(ra){J=ra+8|0;c[J>>2]=(c[J>>2]|0)+Q;J=ra+4|0;c[J>>2]=(c[J>>2]|0)+A}}while(0);c[ka>>2]=0;c[ca>>2]=0}c[a>>2]=u;c[q>>2]=P;if(P>>>0<(c[ga>>2]|0)>>>0)sa=(u|0)>=(c[la>>2]|0);else sa=1;c[h>>2]=sa&1;if((ba|0)==(j|0)){ma=H;break}else fa=H}}ofe(a,j,ma,256-w|0,b,n);c[o>>2]=b;c[k>>2]=d;c[f>>2]=g;i=e;return}function ofe(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;h=i;j=f-d|0;k=d>>8;l=f>>8;m=d-(k<<8)|0;d=f-(l<<8)|0;if((g|0)==(e|0)){f=b-(c[a+16>>2]|0)|0;n=c[a+12>>2]|0;o=((n|0)<(l|0)?n:l)-(c[a+8>>2]|0)|0;n=(o|0)>-1?o:-1;o=c[a>>2]|0;if((n|0)==(o|0)?(p=a+4|0,(f|0)==(c[p>>2]|0)):0)q=p;else{p=a+32|0;a:do if(!(c[a+40>>2]|0)){r=c[p>>2]|0;s=a+36|0;t=c[s>>2]|0;if(t|r){u=c[a+24>>2]|0;v=(o|0)>(u|0)?u:o;u=(c[a+1268>>2]|0)+(c[a+4>>2]<<2)|0;w=c[u>>2]|0;b:do if(!w){x=0;y=u;z=11}else{A=w;B=u;while(1){C=c[A>>2]|0;if((C|0)>(v|0)){x=A;y=B;z=11;break b}D=A+12|0;if((C|0)==(v|0)){E=A;break b}A=c[D>>2]|0;if(!A){x=0;y=D;z=11;break}else B=D}}while(0);do if((z|0)==11){u=a+52|0;w=c[u>>2]|0;if((w|0)<(c[a+48>>2]|0)){B=c[a+44>>2]|0;c[u>>2]=w+1;u=B+(w<<4)|0;c[u>>2]=v;c[B+(w<<4)+8>>2]=0;c[B+(w<<4)+4>>2]=0;c[B+(w<<4)+12>>2]=x;c[y>>2]=u;E=u;break}else{c[a+1256>>2]=64;F=s;break a}}while(0);if(E){v=E+8|0;c[v>>2]=(c[v>>2]|0)+r;v=E+4|0;c[v>>2]=(c[v>>2]|0)+t;F=s}else F=s}else F=s}else F=a+36|0;while(0);c[p>>2]=0;c[F>>2]=0;q=a+4|0}c[a>>2]=n;c[q>>2]=f;if(f>>>0<(c[a+28>>2]|0)>>>0)G=(n|0)>=(c[a+24>>2]|0);else G=1;c[a+40>>2]=G&1;i=h;return}if((k|0)==(l|0)){G=g-e|0;n=da(d+m|0,G)|0;f=a+32|0;c[f>>2]=(c[f>>2]|0)+n;n=a+36|0;c[n>>2]=(c[n>>2]|0)+G;i=h;return}G=(j|0)<0;n=j>>31;f=n+256&-256;q=G?0-j|0:j;j=n|1;n=da(G?m:256-m|0,g-e|0)|0;G=(n|0)/(q|0)|0;F=(n|0)%(q|0)|0;if((F|0)<0){H=G+-1|0;I=F+q|0}else{H=G;I=F}F=da(H,f+m|0)|0;m=a+32|0;G=(c[m>>2]|0)+F|0;c[m>>2]=G;F=a+36|0;n=(c[F>>2]|0)+H|0;c[F>>2]=n;p=j+k|0;k=a+16|0;E=b-(c[k>>2]|0)|0;y=a+12|0;x=c[y>>2]|0;o=a+8|0;v=((x|0)<(p|0)?x:p)-(c[o>>2]|0)|0;x=(v|0)>-1?v:-1;v=c[a>>2]|0;if((x|0)==(v|0)?(u=a+4|0,(E|0)==(c[u>>2]|0)):0)J=u;else{c:do if(!((c[a+40>>2]|0)!=0|(n|G|0)==0)){u=c[a+24>>2]|0;w=(v|0)>(u|0)?u:v;u=(c[a+1268>>2]|0)+(c[a+4>>2]<<2)|0;B=c[u>>2]|0;d:do if(!B){K=0;L=u;z=31}else{A=B;D=u;while(1){C=c[A>>2]|0;if((C|0)>(w|0)){K=A;L=D;z=31;break d}M=A+12|0;if((C|0)==(w|0)){N=A;break d}A=c[M>>2]|0;if(!A){K=0;L=M;z=31;break}else D=M}}while(0);do if((z|0)==31){u=a+52|0;B=c[u>>2]|0;if((B|0)<(c[a+48>>2]|0)){s=c[a+44>>2]|0;c[u>>2]=B+1;u=s+(B<<4)|0;c[u>>2]=w;c[s+(B<<4)+8>>2]=0;c[s+(B<<4)+4>>2]=0;c[s+(B<<4)+12>>2]=K;c[L>>2]=u;N=u;break}else{c[a+1256>>2]=64;break c}}while(0);if(N){w=N+8|0;c[w>>2]=(c[w>>2]|0)+G;w=N+4|0;c[w>>2]=(c[w>>2]|0)+n}}while(0);c[m>>2]=0;c[F>>2]=0;J=a+4|0}c[a>>2]=x;c[J>>2]=E;J=c[a+28>>2]|0;if(E>>>0<J>>>0)O=(x|0)>=(c[a+24>>2]|0);else O=1;E=O&1;O=a+40|0;c[O>>2]=E;n=H+e|0;if((p|0)==(l|0))P=n;else{e=H+g-n<<8;H=(e|0)/(q|0)|0;N=(e|0)%(q|0)|0;if((N|0)<0){Q=H+-1|0;R=N+q|0}else{Q=H;R=N}N=a+4|0;H=a+24|0;e=a+1268|0;G=a+52|0;L=a+48|0;K=a+44|0;v=a+1256|0;w=n;n=x;x=E;E=p;p=I-q|0;while(1){I=p+R|0;u=Q+(I>>>31^1)|0;p=I-((I|0)>-1?q:0)|0;I=(c[m>>2]|0)+(u<<8)|0;c[m>>2]=I;B=(c[F>>2]|0)+u|0;c[F>>2]=B;s=u+w|0;E=E+j|0;u=b-(c[k>>2]|0)|0;t=c[y>>2]|0;r=((t|0)<(E|0)?t:E)-(c[o>>2]|0)|0;t=(r|0)>-1?r:-1;if(!((t|0)==(n|0)?(u|0)==(c[N>>2]|0):0)){e:do if(!((x|0)!=0|(B|I|0)==0)){r=c[H>>2]|0;D=(n|0)>(r|0)?r:n;r=(c[e>>2]|0)+(c[N>>2]<<2)|0;A=c[r>>2]|0;f:do if(!A){S=0;T=r;z=50}else{M=A;C=r;while(1){U=c[M>>2]|0;if((U|0)>(D|0)){S=M;T=C;z=50;break f}V=M+12|0;if((U|0)==(D|0)){W=M;break f}M=c[V>>2]|0;if(!M){S=0;T=V;z=50;break}else C=V}}while(0);do if((z|0)==50){z=0;r=c[G>>2]|0;if((r|0)<(c[L>>2]|0)){A=c[K>>2]|0;c[G>>2]=r+1;C=A+(r<<4)|0;c[C>>2]=D;c[A+(r<<4)+8>>2]=0;c[A+(r<<4)+4>>2]=0;c[A+(r<<4)+12>>2]=S;c[T>>2]=C;W=C;break}else{c[v>>2]=64;break e}}while(0);if(W){D=W+8|0;c[D>>2]=(c[D>>2]|0)+I;D=W+4|0;c[D>>2]=(c[D>>2]|0)+B}}while(0);c[m>>2]=0;c[F>>2]=0}c[N>>2]=u;if(u>>>0<J>>>0)X=(t|0)>=(c[H>>2]|0);else X=1;x=X&1;c[O>>2]=x;if((E|0)==(l|0)){Y=t;Z=s;break}else{w=s;n=t}}c[a>>2]=Y;P=Z}Z=g-P|0;P=da(Z,d+256-f|0)|0;c[m>>2]=P+(c[m>>2]|0);c[F>>2]=(c[F>>2]|0)+Z;i=h;return}function pfe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;Iie(a);if(!b){i=d;return}$ae(e,b);i=d;return}function qfe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,60,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=Jie(a)|0;c[e>>2]=h;if(!h){c[g>>2]=2;c[g+4>>2]=72;c[g+8>>2]=789744;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=0;c[g+24>>2]=3619;c[g+28>>2]=0;c[g+32>>2]=0;c[g+36>>2]=1869968492;c[g+40>>2]=267;c[g+44>>2]=268;c[g+48>>2]=1849;c[g+52>>2]=1756;c[g+56>>2]=(c[a+224>>2]|0)+4;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function rfe(a){a=a|0;var b=0,d=0;b=i;d=c[a+4>>2]|0;co[c[(c[(c[a+20>>2]|0)+56>>2]|0)+8>>2]&2047](c[a+60>>2]|0,c[d+172>>2]|0,c[d+176>>2]|0);i=b;return 0}function sfe(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=wfe(a,b,(c|0)==1?0:c,d,0)|0;i=e;return f|0}function tfe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if((c[b+72>>2]|0)!=(c[a+24>>2]|0)){g=6;i=f;return g|0}if(d)kae(b+108|0,d);if(!e){g=0;i=f;return g|0}iae(b+108|0,c[e>>2]|0,c[e+4>>2]|0);g=0;i=f;return g|0}function ufe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;if((c[b+72>>2]|0)!=(c[a+24>>2]|0)){i=e;return}hae(b+108|0,d);i=e;return}function vfe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[(c[(c[a+20>>2]|0)+56>>2]|0)+12>>2]&2047](c[a+60>>2]|0,b,d)|0;i=e;return f|0}function wfe(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+80|0;k=j+64|0;l=j+48|0;m=j;n=(f|0)==3;o=(f|0)==4;p=e+72|0;if((c[p>>2]|0)!=(c[d+24>>2]|0)){c[k>>2]=6;q=6;i=j;return q|0}if((f|0)!=(h|0)){q=19;i=j;return q|0}h=e+108|0;f=(g|0)==0;if(!f)iae(h,c[g>>2]|0,c[g+4>>2]|0);hae(h,l);r=c[l>>2]&-64;c[l>>2]=r;s=l+4|0;t=c[s>>2]&-64;c[s>>2]=t;u=l+8|0;v=(c[u>>2]|0)+63&-64;c[u>>2]=v;u=l+12|0;w=(c[u>>2]|0)+63&-64;c[u>>2]=w;if((r|0)<0&(v|0)>(r+2147483647|0)){q=98;i=j;return q|0}x=v-r>>6;if((t|0)<0&(w|0)>(t+2147483647|0)){q=98;i=j;return q|0}r=w-t>>6;t=e+76|0;w=c[d+8>>2]|0;v=e+156|0;if(c[(c[v>>2]|0)+4>>2]&1){y=e+88|0;$ae(w,c[y>>2]|0);c[y>>2]=0;y=(c[v>>2]|0)+4|0;c[y>>2]=c[y>>2]&-2}if(n){y=x*3|0;z=y+3&-4;A=y}else{z=x;A=x}if(o)B=r*3|0;else B=r;y=c[l>>2]|0;l=c[s>>2]|0;s=y>>6;C=c[u>>2]>>6;if((B|A)>>>0>32767){q=98;i=j;return q|0}a[e+94>>0]=2;b[e+92>>1]=256;c[e+80>>2]=A;c[t>>2]=B;c[e+84>>2]=z;iae(h,0-y|0,0-l|0);u=e+88|0;c[u>>2]=Xae(w,da(B,z)|0,k)|0;w=c[k>>2]|0;if(!w){D=(c[v>>2]|0)+4|0;c[D>>2]=c[D>>2]|1;c[m>>2]=t;c[m+4>>2]=h;c[m+8>>2]=1;c[k>>2]=_n[c[d+64>>2]&4095](c[d+60>>2]|0,m)|0;a:do if(!(n^1|(r|0)==0)){m=c[u>>2]|0;if(!x){d=r;while(1){d=d+-1|0;if(!d)break a}}else{E=r;F=m}while(1){d=F+A|0;t=x;do{t=t+-1|0;D=a[F+t>>0]|0;v=d;d=d+-3|0;a[d>>0]=D;a[v+-2>>0]=D;a[v+-1>>0]=D}while((t|0)!=0);E=E+-1|0;if(!E)break;else F=F+z|0}}while(0);if(o?(o=c[u>>2]|0,(r|0)!=0):0){u=z<<1;F=z*3|0;E=r;x=o+(da(B-r|0,z)|0)|0;r=o;while(1){YEi(r|0,x|0,z|0)|0;YEi(r+z|0,x|0,z|0)|0;YEi(r+u|0,x|0,z|0)|0;E=E+-1|0;if(!E)break;else{x=x+z|0;r=r+F|0}}}iae(h,y,l);l=c[k>>2]|0;if(!l){c[p>>2]=1651078259;c[e+100>>2]=s;c[e+104>>2]=C;G=0}else G=l}else G=w;if(f){q=G;i=j;return q|0}iae(h,0-(c[g>>2]|0)|0,0-(c[g+4>>2]|0)|0);q=c[k>>2]|0;i=j;return q|0}function xfe(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=1757;c[a+12>>2]=2833;c[a+16>>2]=1758;return}function yfe(a){a=a|0;c[a>>2]=1759;return}function zfe(a,b){a=a|0;b=b|0;var d=0;d=i;if(b)$ae(c[a>>2]|0,b);i=d;return}function Afe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=Xae(c[a>>2]|0,40,e)|0;g=c[e>>2]|0;if(g){h=g;i=d;return h|0}c[f>>2]=789752;c[f+4>>2]=789776;c[f+8>>2]=789792;g=c[a+228>>2]|0;c[f+12>>2]=g+4;c[f+16>>2]=789808;c[f+20>>2]=789824;c[f+24>>2]=789832;c[f+28>>2]=g+24;c[f+32>>2]=0;c[f+36>>2]=0;c[b>>2]=f;h=0;i=d;return h|0}function Bfe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;Kie(a);if(!b){i=d;return}$ae(e,b);i=d;return}function Cfe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,104,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=Lie(a)|0;c[e>>2]=h;if(!h){c[g>>2]=1281;c[g+4>>2]=84;c[g+8>>2]=789840;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=0;c[g+24>>2]=3620;c[g+28>>2]=3555;c[g+32>>2]=2834;c[g+36>>2]=800;c[g+40>>2]=304;c[g+44>>2]=160;c[g+48>>2]=216;c[g+52>>2]=3556;c[g+56>>2]=3621;c[g+60>>2]=3557;c[g+64>>2]=3622;c[g+68>>2]=0;c[g+72>>2]=209;c[g+76>>2]=1742;c[g+80>>2]=269;c[g+84>>2]=270;c[g+88>>2]=0;c[g+92>>2]=217;c[g+96>>2]=2835;c[g+100>>2]=2836;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function Dfe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+4|0;f=m9d(c[c[(c[e>>2]|0)+228>>2]>>2]|0,b)|0;if(f){g=f;i=d;return g|0}f=C9d(c[e>>2]|0,789856)|0;if(!f){g=0;i=d;return g|0}e=c[(c[f>>2]|0)+20>>2]|0;if(!e){g=0;i=d;return g|0}g=_n[c[e+16>>2]&4095](a,b)|0;i=d;return g|0}function Efe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=c[a+4>>2]|0;if(!a){h=37;i=f;return h|0}if(!b){h=36;i=f;return h|0}if(!g){h=6;i=f;return h|0}if((c[g+16>>2]|0)>>>0<=d>>>0){h=6;i=f;return h|0}if(!(e&2))j=e;else{k=(c[g+8>>2]&8192|0)==0?e:e&-3;j=k>>>14&2|k}if(!(j&1025))l=j;else l=(c[g+8>>2]|0)>>>12&2^11|j;h=gge(b,a,d,l)|0;i=f;return h|0}function Ffe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[a+532>>2]|0;c[e>>2]=0;c[e+4>>2]=0;if(!g){i=f;return 0}c[e>>2]=xo[c[g+128>>2]&2047](a,b,d)|0;i=f;return 0}function Gfe(a,b,d,f,g){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h+6|0;k=h+4|0;l=h+2|0;m=h;n=(d|0)==0;if(!(f&16)){if(n){i=h;return 0}else o=0;do{dge(a,o+b|0,l,m);c[g+(o<<2)>>2]=e[m>>1];o=o+1|0}while((o|0)!=(d|0));i=h;return 0}else{if(n){i=h;return 0}else p=0;do{ege(a,p+b|0,j,k);c[g+(p<<2)>>2]=e[k>>1];p=p+1|0}while((p|0)!=(d|0));i=h;return 0}return 0}function Hfe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;do if(!(c[f+8>>2]&2)){g=f;h=0}else{j=xo[c[(c[f+532>>2]|0)+148>>2]&2047](f,b,e)|0;if(j){c[a+112>>2]=-1;g=c[a>>2]|0;h=j;break}j=c[e>>2]|0;k=c[a>>2]|0;l=a+112|0;c[l>>2]=j;if(c[k+8>>2]&1){I9d(k,j);Rfe(a)|0;m=0;i=d;return m|0}n=xo[c[(c[k+532>>2]|0)+152>>2]&2047](k,j,a+12|0)|0;if(!n){m=0;i=d;return m|0}c[l>>2]=-1;m=n;i=d;return m|0}while(0);J9d(g,b);if(!(c[(c[a>>2]|0)+8>>2]&1)){m=h;i=d;return m|0}h=Rfe(a)|0;b=a+12|0;g=a+44|0;c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];c[b+16>>2]=c[g+16>>2];c[b+20>>2]=c[g+20>>2];c[b+24>>2]=c[g+24>>2];m=h;i=d;return m|0}function Ife(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a>>2]|0;f=a+112|0;c[f>>2]=b;if(c[e+8>>2]&1){I9d(e,b);Rfe(a)|0;g=0;i=d;return g|0}h=xo[c[(c[e+532>>2]|0)+152>>2]&2047](e,b,a+12|0)|0;if(!h){g=0;i=d;return g|0}c[f>>2]=-1;g=h;i=d;return g|0}function Jfe(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g;j=f+0|0;k=j+36|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=a;j=d&65535;k=f+12|0;c[k>>2]=Zae(a,8,0,j,0,h)|0;l=c[h>>2]|0;if(!l){c[f+16>>2]=Zae(a,8,0,j,0,h)|0;m=c[h>>2]|0;if(!m){c[f+20>>2]=Zae(a,8,0,j,0,h)|0;n=c[h>>2]|0;if(!n){c[f+24>>2]=Zae(a,1,0,j,0,h)|0;j=c[h>>2]|0;if(!j){c[f+28>>2]=Zae(a,2,0,e<<16>>16,0,h)|0;a=c[h>>2]|0;if(!a){b[f+4>>1]=d;b[f+6>>1]=e;o=0;i=g;return o|0}else p=a}else p=j}else p=n}else p=m}else p=l;l=c[f>>2]|0;if(!l){o=p;i=g;return o|0}p=f+28|0;$ae(l,c[p>>2]|0);c[p>>2]=0;p=f+24|0;$ae(l,c[p>>2]|0);c[p>>2]=0;p=f+16|0;$ae(l,c[p>>2]|0);c[p>>2]=0;$ae(l,c[k>>2]|0);c[k>>2]=0;k=f+20|0;$ae(l,c[k>>2]|0);c[k>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;o=c[h>>2]|0;i=g;return o|0}function Kfe(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;j=i;i=i+64|0;k=j+52|0;l=j+56|0;m=j;n=S9d(c[(c[e+96>>2]|0)+4>>2]|0,789856)|0;if(!n){o=2;i=j;return o|0}p=Dae(d,0)|0;if(p){o=p;i=j;return o|0}p=Bn[c[n+4>>2]&255](d,e,f,g,h)|0;if(p){o=p;i=j;return o|0}p=c[e+148>>2]|0;if(!((p|0)==1953658213|(p|0)==131072|(p|0)==65536)){o=2;i=j;return o|0}p=e+8|0;c[p>>2]=c[p>>2]|2048;if((f|0)<0){o=0;i=j;return o|0}q=Bn[c[n+8>>2]&255](d,e,f,g,h)|0;if(q){o=q;i=j;return o|0}a:do if(e){q=c[e+20>>2]|0;b:do if(!q)r=11;else{h=0;while(1){if(mCi(q,790184+(h*17|0)|0)|0)break b;h=h+1|0;if((h|0)>=8){r=11;break}}}while(0);c:do if((r|0)==11){q=m+0|0;h=q+52|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(h|0));q=e+152|0;h=b[q>>1]|0;if(h<<16>>16){g=e+156|0;f=e+508|0;n=e+104|0;s=h;h=0;t=0;u=0;while(1){v=c[g>>2]|0;w=c[v+(h<<4)>>2]|0;if((w|0)==1668707360){x=1;y=0;r=19}else if((w|0)==1718642541){x=t;y=1;r=19}else if((w|0)==1886545264){x=t;y=2;r=19}else{z=s;A=t}if((r|0)==19){r=0;w=v;v=0;B=0;while(1){if((c[w+(h<<4)+12>>2]|0)==(c[789872+(B*24|0)+(y<<3)+4>>2]|0)){do if(!v){C=c[f>>2]|0;if(!C)D=0;else{if(kn[C&511](e,c[w+(h<<4)>>2]|0,c[n>>2]|0,0)|0){D=0;break}C=c[n>>2]|0;E=c[(c[g>>2]|0)+(h<<4)+12>>2]|0;if(Jae(C,E)|0){D=0;break}if(E>>>0>3){F=E;G=0;while(1){H=(Oae(C)|0)+G|0;F=F+-4|0;if(F>>>0<=3){I=H;break}else G=H}J=E&3;K=I}else{J=E;K=0}if(!J)L=K;else{G=J;F=K;H=3;while(1){M=(((Mae(C)|0)&255)<<(H<<3))+F|0;G=G+-1|0;if(!G){L=M;break}else{F=M;H=H+-1|0}}}Lae(C);D=L}}else D=v;while(0);H=m+(B<<2)|0;F=c[H>>2]|0;if((c[789872+(B*24|0)+(y<<3)>>2]|0)==(D|0)){G=F+1|0;c[H>>2]=G;N=G}else N=F;if((N|0)==3)break c;else O=D}else O=v;F=B+1|0;if((F|0)>=13)break;w=c[g>>2]|0;v=O;B=F}z=b[q>>1]|0;A=x}B=u+1<<16>>16;if((B&65535)<(z&65535)){s=z;h=B&65535;t=A;u=B}else{P=A;break}}if(P<<24>>24){u=0;while(1){if((c[m+(u<<2)>>2]|0)==3)break c;u=u+1|0;if((u|0)>=13)break a}}else Q=0}else Q=0;while(1){u=m+(Q<<2)|0;t=c[u>>2]|0;if(Q>>>0<5)R=t;else{h=t+1|0;c[u>>2]=h;R=h}Q=Q+1|0;if((R|0)==3)break c;if((Q|0)>=13)break a}}while(0);c[p>>2]=c[p>>2]|8192}while(0);Q=age(e,d)|0;if(Q){o=Q;i=j;return o|0}d:do if(c[p>>2]&1){Q=Wfe(e,d)|0;if(!Q){R=Zfe(e,d)|0;if(!R){m=_fe(e,d)|0;if(!m)S=$fe(e,d)|0;else S=m}else S=R}else S=Q;if(((c[e+28>>2]|0)!=0?(c[e+736>>2]|0)!=0:0)?(Q=e+732|0,(c[Q>>2]|0)!=0):0){R=0;m=0;P=0;while(1){Xfe(e,P,k)|0;if(c[k>>2]|0){A=R+1|0;if(A>>>0>1){T=S;break d}else{U=A;V=P}}else{U=R;V=m}P=P+1|0;if(P>>>0>=(c[Q>>2]|0)>>>0){W=U;X=V;break}else{R=U;m=V}}if((W|0)==1){if(X){m=(O9d(e,X,l,8)|0)==0;if(!(m&(a[l>>0]|0)==46)){T=S;break}if(IEi(l,789864,8)|0){T=S;break}}c[p>>2]=c[p>>2]&-2;T=S}else T=S}else T=S}else T=0;while(0);fge(e);o=T;i=j;return o|0}function Lfe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;if(!a){i=b;return}d=c[a+100>>2]|0;e=c[a+104>>2]|0;f=c[a+532>>2]|0;g=a+692|0;h=c[g+4>>2]|0;if(h)ko[h&4095](c[g>>2]|0);if(f)ko[c[f+12>>2]&4095](a);Yfe(a);bge(a);f=a+672|0;$ae(d,c[f>>2]|0);c[f>>2]=0;c[a+668>>2]=0;Kae(e,a+656|0);Kae(e,a+664|0);c[a+652>>2]=0;c[a+660>>2]=0;e=a+712|0;tge(d,c[e>>2]|0);c[e>>2]=0;i=b;return}function Mfe(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=c[d>>2]|0;if(!(a[d+292>>0]|0))h=(c[g+96>>2]|0)+40|0;else h=d+296|0;j=c[h>>2]|0;if(!j){k=153;i=f;return k|0}Cge(j,g,d)|0;c[j+428>>2]=0;c[j+16>>2]=0;c[j+476>>2]=64;c[j+480>>2]=0;c[j+484>>2]=0;a[j+488>>0]=0;c[j+564>>2]=65536;a[j+561>>0]=e;e=j+216|0;b[j+252>>1]=0;c[j+260>>2]=0;b[e+0>>1]=0;b[e+2>>1]=0;b[e+4>>1]=0;b[e+6>>1]=0;b[e+8>>1]=0;b[e+10>>1]=0;c[j+256>>2]=65536;e=g+652|0;yge(j,1,c[g+656>>2]|0,c[e>>2]|0)|0;zge(j,2)|0;zge(j,3)|0;if(c[e>>2]|0){e=xge(j,1,0)|0;if(e){k=e;i=f;return k|0}e=mo[c[g+688>>2]&4095](j)|0;if(e){k=e;i=f;return k|0}}Dge(j,d)|0;k=0;i=f;return k|0}function Nfe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=c[b>>2]|0;g=b+292|0;if(!(a[g>>0]|0))h=(c[f+96>>2]|0)+40|0;else h=b+296|0;j=c[h>>2]|0;if(!j){k=153;i=e;return k|0}Cge(j,f,b)|0;c[j+428>>2]=0;c[j+16>>2]=0;a[j+488>>0]=0;a[j+561>>0]=d;d=f+660|0;yge(j,2,c[f+664>>2]|0,c[d>>2]|0)|0;zge(j,3)|0;if(c[d>>2]|0){d=xge(j,2,0)|0;if(!d)if(!(a[g>>0]|0))l=mo[c[f+688>>2]&4095](j)|0;else l=0;else l=d}else l=0;d=b+172|0;f=j+284|0;g=d+68|0;do{c[d>>2]=c[f>>2];d=d+4|0;f=f+4|0}while((d|0)<(g|0));Dge(j,b)|0;k=l;i=e;return k|0}function Ofe(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+16|0;h=g;do if(!(a[d+300>>0]|0)){j=c[d>>2]|0;k=c[j+100>>2]|0;l=j+260|0;a[d+300>>0]=1;m=d+301|0;a[m>>0]=0;n=e[l+20>>1]|0;c[d+120>>2]=n;o=d+132|0;c[o>>2]=e[l+22>>1];c[d+116>>2]=0;c[d+128>>2]=0;c[d+140>>2]=0;c[d+144>>2]=0;p=d+240|0;c[p>>2]=c[j+668>>2];q=d+248|0;b[q>>1]=b[l+18>>1]|0;r=d+72|0;a[r+37>>0]=0;a[r+38>>0]=0;r=d+92|0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[d+124>>2]=Zae(k,16,0,n,0,h)|0;if(((((c[h>>2]|0)==0?(c[d+136>>2]=Zae(k,16,0,c[o>>2]|0,0,h)|0,(c[h>>2]|0)==0):0)?(c[d+244>>2]=Zae(k,4,0,c[p>>2]|0,0,h)|0,(c[h>>2]|0)==0):0)?(c[d+252>>2]=Zae(k,4,0,e[q>>1]|0,0,h)|0,(c[h>>2]|0)==0):0)?(q=(e[l+16>>1]|0)+4&65535,l=d+256|0,p=Jfe(k,q,0,l)|0,c[h>>2]=p,(p|0)==0):0){b[l+8>>1]=q;s=d+172|0;t=790464;u=s+68|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));q=c[(c[(c[j+96>>2]|0)+4>>2]|0)+180>>2]|0;c[j+688>>2]=(q|0)==0?3623:q;q=Mfe(d,f)|0;c[h>>2]=q;if(!q){v=m;break}}Vfe(d);q=c[h>>2]|0;if(!q)v=m;else{w=q;i=g;return w|0}}else v=d+301|0;while(0);if(a[v>>0]|0){w=0;i=g;return w|0}h=d+240|0;if(c[h>>2]|0){q=(c[d>>2]|0)+672|0;l=d+88|0;p=d+244|0;k=0;do{o=K8d(b[(c[q>>2]|0)+(k<<1)>>1]|0,c[l>>2]|0)|0;c[(c[p>>2]|0)+(k<<2)>>2]=o;k=k+1|0}while(k>>>0<(c[h>>2]|0)>>>0)}h=b[d+264>>1]|0;if(h<<16>>16){k=c[d+268>>2]|0;p=c[d+272>>2]|0;l=h&65535;h=0;do{c[k+(h<<3)>>2]=0;c[k+(h<<3)+4>>2]=0;c[p+(h<<3)>>2]=0;c[p+(h<<3)+4>>2]=0;h=h+1|0}while(h>>>0<l>>>0)}l=b[d+248>>1]|0;if(l<<16>>16)PEi(c[d+252>>2]|0,0,((l&65535)>1?(l&65535)<<2:4)|0)|0;s=d+172|0;t=790464;u=s+68|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));t=Nfe(d,f)|0;if(t){w=t;i=g;return w|0}a[v>>0]=1;w=0;i=g;return w|0}function Pfe(b){b=b|0;a[b+300>>0]=0;a[b+301>>0]=0;a[b+108>>0]=0;c[b+112>>2]=-1;return 0}function Qfe(b){b=b|0;var c=0;c=i;if(a[b+300>>0]|0)Vfe(b);a[b+108>>0]=0;i=c;return}function Rfe(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;g=d+72|0;h=d+108|0;a[h>>0]=0;j=c[d>>2]|0;k=d+44|0;l=d+12|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];c[k+24>>2]=c[l+24>>2];l=b[k>>1]|0;if(!(l<<16>>16)){m=151;i=f;return m|0}n=d+46|0;o=b[n>>1]|0;if(!(o<<16>>16)){m=151;i=f;return m|0}if(!(b[j+176>>1]&8)){p=l;q=o}else{o=j+68|0;r=d+48|0;c[r>>2]=L8d((l&65535)<<6,e[o>>1]|0)|0;l=L8d(e[n>>1]<<6,e[o>>1]|0)|0;o=d+52|0;c[o>>2]=l;c[d+56>>2]=(K8d(b[j+70>>1]|0,l)|0)+32&-64;c[d+60>>2]=(K8d(b[j+72>>1]|0,c[o>>2]|0)|0)+32&-64;c[d+64>>2]=(K8d(b[j+74>>1]|0,c[o>>2]|0)|0)+32&-64;c[d+68>>2]=(K8d(b[j+76>>1]|0,c[r>>2]|0)|0)+32&-64;p=b[k>>1]|0;q=b[n>>1]|0}if((p&65535)<(q&65535)){c[d+88>>2]=c[d+52>>2];b[d+80>>1]=q;c[g>>2]=I8d(p&65535,65536,q&65535)|0;s=65536}else{c[d+88>>2]=c[d+48>>2];b[d+80>>1]=p;c[g>>2]=65536;s=I8d(q&65535,65536,p&65535)|0}c[d+76>>2]=s;a[d+301>>0]=0;a[h>>0]=1;m=0;i=f;return m|0}function Sfe(a){a=a|0;var b=0,c=0;b=i;c=(Fge(a)|0)==0;i=b;return (c?153:0)|0}function Tfe(a){a=a|0;var b=0,d=0;b=i;d=a+40|0;a=c[d>>2]|0;if(!a){i=b;return}Age(a)|0;c[d>>2]=0;i=b;return}function Ufe(a){a=a|0;var b=0,d=0;b=i;d=U8d(c[c[a+156>>2]>>2]|0)|0;i=b;return d|0}function Vfe(d){d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[(c[d>>2]|0)+100>>2]|0;g=d+292|0;if(a[g>>0]|0){c[d+296>>2]=0;a[g>>0]=0}g=d+244|0;$ae(f,c[g>>2]|0);c[g>>2]=0;c[d+240>>2]=0;g=d+252|0;$ae(f,c[g>>2]|0);c[g>>2]=0;b[d+248>>1]=0;g=d+256|0;h=c[g>>2]|0;if(h){j=g+28|0;$ae(h,c[j>>2]|0);c[j>>2]=0;j=g+24|0;$ae(h,c[j>>2]|0);c[j>>2]=0;j=g+16|0;$ae(h,c[j>>2]|0);c[j>>2]=0;j=g+12|0;$ae(h,c[j>>2]|0);c[j>>2]=0;j=g+20|0;$ae(h,c[j>>2]|0);c[j>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0}g=d+124|0;$ae(f,c[g>>2]|0);c[g>>2]=0;$ae(f,c[d+136>>2]|0);c[d+116>>2]=0;c[d+120>>2]=0;f=d+128|0;a[d+300>>0]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;a[d+301>>0]=0;i=e;return}function Wfe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e;g=a+508|0;h=a+704|0;j=kn[c[g>>2]&511](a,1735162214,d,h)|0;if((j|0)==142)c[h>>2]=0;else if(j){k=j;i=e;return k|0}if(kn[c[g>>2]&511](a,1819239265,d,f)|0){k=144;i=e;return k|0}g=c[f>>2]|0;do if(!(b[a+210>>1]|0))if(g>>>0>131071){k=8;i=e;return k|0}else{j=g>>>1;c[a+732>>2]=j;l=j;m=1;break}else if(g>>>0>262143){k=8;i=e;return k|0}else{j=g>>>2;c[a+732>>2]=j;l=j;m=2;break}while(0);j=a+732|0;h=a+16|0;n=c[h>>2]|0;o=n+1|0;do if(!((l|0)==(o|0)|l>>>0>n>>>0)){p=o<<m;q=c[a+156>>2]|0;r=b[a+152>>1]|0;s=q+((r&65535)<<4)|0;t=Fae(d)|0;if(!(r<<16>>16)){u=2147483647;v=q}else{r=q+16|0;w=(((s>>>0>r>>>0?s:r)+~q|0)>>>4)+1|0;r=2147483647;x=q;while(1){y=(c[x+8>>2]|0)-t|0;z=(y|0)>0&(y|0)<(r|0)?y:r;x=x+16|0;if(x>>>0>=s>>>0){A=z;break}else r=z}u=A;v=q+(w<<4)|0}if((v|0)==(s|0))B=(c[d+4>>2]|0)-t|0;else B=u;if((p|0)>(B|0)){C=c[f>>2]|0;break}else{c[j>>2]=(c[h>>2]|0)+1;c[f>>2]=p;C=p;break}}else C=g;while(0);k=Iae(d,C,a+736|0)|0;i=e;return k|0}function Xfe(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=c[a+732>>2]|0;do if(h>>>0>e>>>0){j=c[a+736>>2]|0;if(b[a+210>>1]|0){k=e<<2;l=d[j+(k|1)>>0]<<16|d[j+k>>0]<<24|d[j+(k|2)>>0]<<8|d[j+(k|3)>>0];if((k+8|0)>(h<<2|0)){m=l;n=l;break}m=l;n=d[j+(k+5)>>0]<<16|d[j+(k+4)>>0]<<24|d[j+(k+6)>>0]<<8|d[j+(k+7)>>0];break}k=e<<1;l=d[j+k>>0]<<8|d[j+(k|1)>>0];if((k+4|0)>(h<<1|0))o=l;else o=d[j+(k+2)>>0]<<8|d[j+(k+3)>>0];m=l<<1;n=o<<1}else{m=0;n=0}while(0);o=c[a+704>>2]|0;if(m>>>0>=o>>>0){p=0;q=0;c[f>>2]=q;i=g;return p|0}a=n>>>0<o>>>0?n:o;p=m;q=(a>>>0<m>>>0?o:a)-m|0;c[f>>2]=q;i=g;return p|0}function Yfe(a){a=a|0;var b=0;b=i;Kae(c[a+104>>2]|0,a+736|0);c[a+732>>2]=0;i=b;return}function Zfe(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[e+28>>2]|0;k=kn[c[d+508>>2]&511](d,1668707360,e,h)|0;c[g>>2]=k;if(k){c[d+668>>2]=0;c[d+672>>2]=0;c[g>>2]=0;l=0;i=f;return l|0}k=(c[h>>2]|0)>>>1;h=d+668|0;c[h>>2]=k;m=d+672|0;c[m>>2]=Zae(j,2,0,k,0,g)|0;k=c[g>>2]|0;if(k){l=k;i=f;return l|0}k=Jae(e,c[h>>2]<<1)|0;c[g>>2]=k;if(k){l=k;i=f;return l|0}k=c[m>>2]|0;m=c[h>>2]|0;h=k+(m<<1)|0;if((m|0)>0){m=k;do{b[m>>1]=Nae(e)|0;m=m+2|0}while(m>>>0<h>>>0)}Lae(e);if(!(a[d+708>>0]|0)){l=c[g>>2]|0;i=f;return l|0}else{h=qge(d,e)|0;c[g>>2]=h;l=h;i=f;return l|0}return 0}function _fe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!(kn[c[a+508>>2]&511](a,1718642541,b,e)|0)){f=c[e>>2]|0;c[a+652>>2]=f;g=Iae(b,f,a+656|0)|0;i=d;return g|0}else{c[a+656>>2]=0;c[a+652>>2]=0;g=0;i=d;return g|0}return 0}function $fe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!(kn[c[a+508>>2]&511](a,1886545264,b,e)|0)){f=c[e>>2]|0;c[a+660>>2]=f;g=Iae(b,f,a+664|0)|0;i=d;return g|0}else{c[a+664>>2]=0;c[a+660>>2]=0;g=0;i=d;return g|0}return 0}function age(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[e+28>>2]|0;k=kn[c[b+508>>2]&511](b,1751412088,e,h)|0;c[g>>2]=k;l=c[h>>2]|0;if((k|0)!=0|l>>>0<8){m=0;i=f;return m|0}k=b+740|0;n=Iae(e,l,k)|0;c[g>>2]=n;do if(!n){l=c[k>>2]|0;o=l+(c[h>>2]|0)|0;p=(d[l+2>>0]|0)<<8|(d[l+3>>0]|0);q=(d[l+5>>0]|0)<<16|(d[l+4>>0]|0)<<24|(d[l+6>>0]|0)<<8|(d[l+7>>0]|0);r=q>>>0>4294901759?q&65535:q;if(!((p>>>0>255?1:((d[l>>0]|0)<<8|(d[l+1>>0]|0)|0)!=0)|r>>>0>65537)){q=b+756|0;c[q>>2]=Zae(j,1,0,p,0,g)|0;if(!(c[g>>2]|0)){a:do if(!p)s=0;else{t=0;u=l+8|0;while(1){v=u;u=u+r|0;if(u>>>0>o>>>0){s=t;break a}a[(c[q>>2]|0)+t>>0]=a[v>>0]|0;v=t+1|0;if(v>>>0>=p>>>0){s=v;break}else t=v}}while(0);c[b+748>>2]=s;c[b+744>>2]=c[h>>2];c[b+752>>2]=r;break}}else c[g>>2]=3;Kae(e,k);c[b+744>>2]=0}while(0);m=c[g>>2]|0;i=f;return m|0}function bge(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+104>>2]|0;e=a+756|0;$ae(c[d+28>>2]|0,c[e>>2]|0);c[e>>2]=0;Kae(d,a+740|0);i=b;return}function cge(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[a+752>>2]|0;h=c[a+740>>2]|0;j=c[a+748>>2]|0;if(!j){k=0;i=f;return k|0}l=c[a+756>>2]|0;a=0;while(1){if((d[l+a>>0]|0|0)==(b|0)){m=a;break}a=a+1|0;if(a>>>0>=j>>>0){k=0;n=7;break}}if((n|0)==7){i=f;return k|0}if((e+2|0)>>>0>=g>>>0){k=0;i=f;return k|0}k=h+(e+10+(da(m,g)|0))|0;i=f;return k|0}function dge(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Bn[c[(c[a+532>>2]|0)+156>>2]&255](a,0,b,d,e)|0;i=f;return}function ege(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;if(!(a[d+296>>0]|0)){b[f>>1]=0;b[g>>1]=b[d+68>>1]|0;i=h;return}else{Bn[c[(c[d+532>>2]|0)+156>>2]&255](d,1,e,f,g)|0;i=h;return}}function fge(a){a=a|0;c[a+512>>2]=271;c[a+520>>2]=3624;c[a+524>>2]=3625;c[a+528>>2]=3626;c[a+516>>2]=3558;return}function gge(f,g,h,j){f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=i;i=i+240|0;l=k+208|0;m=k+224|0;n=k;o=g+4|0;p=c[o>>2]|0;q=c[f+112>>2]|0;if((q|0)!=-1&(j&8|0)==0?(gn[c[(c[p+532>>2]|0)+104>>2]&127](p,q,h,j,c[p+104>>2]|0,g+76|0,m)|0)==0:0){b[g+110>>1]=0;b[g+108>>1]=0;c[g+24>>2]=d[m+1>>0]<<6;c[g+28>>2]=d[m>>0]<<6;q=a[m+2>>0]|0;c[g+32>>2]=q<<6;r=a[m+3>>0]|0;c[g+36>>2]=r<<6;c[g+40>>2]=d[m+4>>0]<<6;s=a[m+5>>0]|0;c[g+44>>2]=s<<6;t=a[m+6>>0]|0;c[g+48>>2]=t<<6;c[g+52>>2]=d[m+7>>0]<<6;c[g+72>>2]=1651078259;m=g+100|0;if(!(j&16)){c[m>>2]=q;c[g+104>>2]=r}else{c[m>>2]=s;c[g+104>>2]=t}if(!(c[p+8>>2]&1)){u=0;i=k;return u|0}p=c[o>>2]|0;t=c[p+104>>2]|0;PEi(n|0,0,208)|0;s=kn[c[p+508>>2]&511](p,1735162214,t,0)|0;if((s|0)==142){c[n+84>>2]=0;v=10}else if(!s){c[n+84>>2]=Fae(t)|0;v=10}if((v|0)==10){c[n+16>>2]=j;c[n>>2]=p;c[n+4>>2]=f;c[n+8>>2]=g;c[n+24>>2]=t}mge(n,h,0,1)|0;c[g+56>>2]=c[n+60>>2];c[g+60>>2]=(c[n+48>>2]|0)+(c[n+176>>2]|0)-(c[n+180>>2]|0);u=0;i=k;return u|0}t=(j&1|0)!=0;if(!t?(a[f+108>>0]|0)==0:0){u=36;i=k;return u|0}if(j&16384){u=6;i=k;return u|0}p=j&128;v=c[o>>2]|0;o=c[v+104>>2]|0;PEi(n|0,0,208)|0;s=(j&2|0)==0;if(s){if((a[f+301>>0]|0)==0?(m=Ofe(f,p)|0,(m|0)!=0):0){u=m;i=k;return u|0}if(!(a[f+292>>0]|0))w=(c[v+96>>2]|0)+40|0;else w=f+296|0;m=c[w>>2]|0;if(!m){u=153;i=k;return u|0}w=(j&983040|0)!=131072;Cge(m,v,f)|0;r=m+604|0;if((w&1|0)!=(d[r>>0]|0)){a[r>>0]=w&1;w=f+240|0;if(c[w>>2]|0){r=v+672|0;q=f+88|0;x=f+244|0;y=0;do{z=K8d(b[(c[r>>2]|0)+(y<<1)>>1]|0,c[q>>2]|0)|0;c[(c[x>>2]|0)+(y<<2)>>2]=z;y=y+1|0}while(y>>>0<(c[w>>2]|0)>>>0)}Nfe(f,p)|0}w=a[m+336>>0]|0;y=(w&1)<<1|j;if(w&2){w=m+284|0;x=790464;q=w+68|0;do{c[w>>2]=c[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(q|0))}a[m+561>>0]=p;c[n+160>>2]=m;c[n+164>>2]=c[m+392>>2];A=y}else A=j;j=kn[c[v+508>>2]&511](v,1735162214,o,0)|0;if((j|0)==142)c[n+84>>2]=0;else if(!j)c[n+84>>2]=Fae(o)|0;else{u=j;i=k;return u|0}j=c[c[g+156>>2]>>2]|0;S8d(j);y=n+12|0;c[y>>2]=j;j=n+16|0;c[j>>2]=A;c[n>>2]=v;v=n+4|0;c[v>>2]=f;A=n+8|0;c[A>>2]=g;c[n+24>>2]=o;o=g+72|0;c[o>>2]=1869968492;m=g+128|0;c[m>>2]=0;p=g+108|0;x=g+124|0;c[x>>2]=0;w=mge(n,h,0,0)|0;if(!w){q=c[y>>2]|0;if((c[o>>2]|0)!=1668246896){o=q+20|0;c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];c[p+12>>2]=c[o+12>>2];c[p+16>>2]=c[o+16>>2];c[x>>2]=c[x>>2]&-513;o=c[n+68>>2]|0;if(o)iae(p,0-o|0,0)}else{c[m>>2]=c[q+48>>2];c[g+132>>2]=c[q+52>>2]}do if(s){q=c[n+160>>2]|0;if(!(a[q+337>>0]|0)){c[x>>2]=c[x>>2]|8;break}g=c[q+340>>2]|0;if((g|0)==1)break;else if(!g){c[x>>2]=c[x>>2]|32;break}else if((g|0)==4){c[x>>2]=c[x>>2]|48;break}else if((g|0)==5){c[x>>2]=c[x>>2]|16;break}else{c[x>>2]=c[x>>2]|8;break}}while(0);s=c[n>>2]|0;g=c[A>>2]|0;A=c[v>>2]|0;if(!(c[j>>2]&1))B=c[A+20>>2]|0;else B=65536;if((c[g+72>>2]|0)==1668246896){v=n+36|0;c[l+0>>2]=c[v+0>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];c[l+12>>2]=c[v+12>>2]}else hae(g+108|0,l);c[g+56>>2]=c[n+60>>2];v=g+32|0;c[v>>2]=c[l>>2];q=l+12|0;c[g+36>>2]=c[q>>2];m=g+40|0;c[m>>2]=(c[n+76>>2]|0)-(c[n+68>>2]|0);if(((c[s+480>>2]|0)==0?(c[j>>2]&2|0)==0:0)?(o=cge(s,e[A+12>>1]|0,h)|0,(o|0)!=0):0)c[m>>2]=d[o>>0]<<6;c[g+24>>2]=(c[l+8>>2]|0)-(c[l>>2]|0);o=c[q>>2]|0;q=o-(c[l+4>>2]|0)|0;c[g+28>>2]=q;if((a[s+296>>0]|0)!=0?(b[s+334>>1]|0)!=0:0){l=n+188|0;h=(L8d((c[l>>2]|0)-o|0,B)|0)<<16>>16;o=c[l>>2]|0;l=c[n+196>>2]|0;if((o|0)>(l|0)){C=(L8d(o-l|0,B)|0)&65535;D=h}else{C=0;D=h}}else{h=(L8d(q,B)|0)<<16>>16;q=s+368|0;if((b[q>>1]|0)==-1){l=s+216|0;E=(b[l+4>>1]|0)-(b[l+6>>1]|0)|0}else E=(b[q+70>>1]|0)-(b[q+72>>1]|0)|0;C=E;D=(E-h|0)/2|0}c[g+60>>2]=C;if(!(c[j>>2]&1)){j=K8d(D,B)|0;F=K8d(C,B)|0;G=j}else{F=C;G=D}c[g+44>>2]=(c[v>>2]|0)-((c[m>>2]|0)/2|0);c[g+48>>2]=G;c[g+52>>2]=F}if(t){u=w;i=k;return u|0}if((e[f+14>>1]|0)>=24){u=w;i=k;return u|0}c[x>>2]=c[x>>2]|256;u=w;i=k;return u|0}function hge(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[a+24>>2]|0;g=Dae(f,d)|0;if(g){h=g;i=b;return h|0}g=Jae(f,e)|0;if(g){h=g;i=b;return h|0}c[a+200>>2]=c[f+32>>2];c[a+204>>2]=c[f+36>>2];h=0;i=b;return h|0}function ige(e){e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=e+200|0;h=c[g>>2]|0;j=h+10|0;if(j>>>0>(c[e+204>>2]|0)>>>0){k=20;i=f;return k|0}b[e+32>>1]=a[h>>0]<<8|d[h+1>>0];c[e+36>>2]=a[h+2>>0]<<8|d[h+3>>0];c[e+40>>2]=a[h+4>>0]<<8|d[h+5>>0];c[e+44>>2]=a[h+6>>0]<<8|d[h+7>>0];c[e+48>>2]=a[h+8>>0]<<8|d[h+9>>0];c[g>>2]=j;k=0;i=f;return k|0}function jge(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=i;h=f+200|0;j=c[h>>2]|0;k=c[f+204>>2]|0;l=c[f+12>>2]|0;m=b[f+32>>1]|0;n=m<<16>>16;o=c[f>>2]|0;if(m<<16>>16){if(((b[l+20>>1]|0)+n+(b[l+56>>1]|0)|0)>>>0>(c[l+8>>2]|0)>>>0?(p=V8d(l,0,n)|0,(p|0)!=0):0){q=p;i=g;return q|0}if(m<<16>>16>4094){q=20;i=g;return q|0}}p=l+68|0;r=c[p>>2]|0;s=r+(n<<1)|0;if((j+((n<<1)+2)|0)>>>0>k>>>0){q=20;i=g;return q|0}n=j+2|0;t=d[j>>0]<<8|d[j+1>>0];u=m<<16>>16>0;a:do if(u){b[r>>1]=t;do if(m<<16>>16>1){v=j;w=r;x=r+2|0;y=n;z=t;while(1){A=z;z=d[v+2>>0]<<8|d[v+3>>0];b[x>>1]=z;if((z<<16|0)<=(A<<16|0)){q=8;B=52;break}A=w+4|0;if(A>>>0>=s>>>0){C=x;D=y;B=11;break}else{E=x;F=y;x=A;y=v+4|0;w=E;v=F}}if((B|0)==11)if(u){G=D;H=C;break}else{I=D;J=4;K=0;B=14;break a}else if((B|0)==52){i=g;return q|0}}else{G=j;H=r}while(0);v=b[H>>1]|0;w=v+1|0;if((w|0)>=0){y=v+5|0;if(!y){L=G;M=w;break}else{I=G;J=y;K=w;B=14;break}}else{q=20;i=g;return q|0}}else{I=j;J=4;K=0;B=14}while(0);if((B|0)==14)if(((b[l+22>>1]|0)+J+(b[l+58>>1]|0)|0)>>>0>(c[l+4>>2]|0)>>>0?(j=V8d(l,J,0)|0,(j|0)!=0):0){q=j;i=g;return q|0}else{L=I;M=K}K=c[p>>2]|0;while(1){p=K;K=K+2|0;if(K>>>0>=s>>>0)break;if((b[p>>1]|0)>=(b[K>>1]|0)){q=20;B=52;break}}if((B|0)==52){i=g;return q|0}K=c[f+8>>2]|0;s=K+140|0;c[s>>2]=0;p=K+136|0;c[p>>2]=0;K=L+4|0;if(K>>>0>k>>>0){q=20;i=g;return q|0}I=d[L+2>>0]<<8|d[L+3>>0];if(I>>>0>(e[o+286>>1]|0)>>>0){q=22;i=g;return q|0}if((k-K|0)<(I|0)){q=22;i=g;return q|0}if(!(c[f+16>>2]&2)){c[s>>2]=I;s=c[(c[f+160>>2]|0)+392>>2]|0;c[p>>2]=s;YEi(s|0,K|0,I|0)|0}K=L+(I+4)|0;I=l+64|0;L=c[I>>2]|0;s=L+M|0;p=(M|0)>0;do if(p){f=L;o=K;while(1){j=o+1|0;if(j>>>0>k>>>0){q=20;B=52;break}J=a[o>>0]|0;G=f+1|0;a[f>>0]=J;if(J&8){H=o+2|0;if(H>>>0>k>>>0){q=20;B=52;break}r=a[j>>0]|0;if((f+((r&255)+1)|0)>>>0>s>>>0){q=20;B=52;break}if(!(r<<24>>24)){N=G;O=H}else{D=f;C=r;r=G;while(1){u=D+2|0;a[r>>0]=J;C=C+-1<<24>>24;if(!(C<<24>>24)){N=u;O=H;break}else{t=r;r=u;D=t}}}}else{N=G;O=j}if(N>>>0<s>>>0){f=N;o=O}else{P=O;B=32;break}}if((B|0)==32){Q=c[I>>2]|0;R=P;break}else if((B|0)==52){i=g;return q|0}}else{Q=L;R=K}while(0);K=l+60|0;L=c[K>>2]|0;P=L+(M<<3)|0;if(R>>>0>k>>>0){q=20;i=g;return q|0}b:do if(p){O=Q;N=R;s=L;o=0;while(1){f=d[O>>0]|0;if(!(f&2))if(!(f&16)){D=N+2|0;if(D>>>0>k>>>0){q=20;B=52;break}S=D;T=a[N>>0]<<8|d[N+1>>0]}else{S=N;T=0}else{D=N+1|0;if(D>>>0>k>>>0){q=20;B=52;break}r=d[N>>0]|0;S=D;T=(f&16|0)==0?0-r|0:r}o=T+o|0;c[s>>2]=o;a[O>>0]=f&237;s=s+8|0;if(s>>>0>=P>>>0){U=S;B=42;break}else{O=O+1|0;N=S}}if((B|0)==42){N=c[K>>2]|0;O=N+(M<<3)|0;if(!p){V=U;break}s=c[I>>2]|0;o=U;f=N;N=0;while(1){r=d[s>>0]|0;if(!(r&4))if(!(r&32)){D=o+2|0;if(D>>>0>k>>>0){q=20;B=52;break}W=D;X=a[o>>0]<<8|d[o+1>>0]}else{W=o;X=0}else{D=o+1|0;if(D>>>0>k>>>0){q=20;B=52;break}H=d[o>>0]|0;W=D;X=(r&32|0)==0?0-H|0:H}N=X+N|0;c[f+4>>2]=N;a[s>>0]=r&1;f=f+8|0;if(f>>>0>=O>>>0){V=W;break b}else{s=s+1|0;o=W}}if((B|0)==52){i=g;return q|0}}else if((B|0)==52){i=g;return q|0}}else V=R;while(0);b[l+58>>1]=M;b[l+56>>1]=m;c[h>>2]=V;q=0;i=g;return q|0}function kge(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;f=i;g=e+200|0;h=c[e+204>>2]|0;j=c[e+12>>2]|0;k=j+88|0;l=0;m=c[g>>2]|0;while(1){n=l+1|0;o=W8d(j,n)|0;if(o){p=o;q=21;break}o=m+4|0;if(o>>>0>h>>>0){p=21;q=21;break}r=c[k>>2]|0;s=r+(l<<5)+12|0;c[s>>2]=0;t=r+(l<<5)+8|0;c[t>>2]=0;u=d[m+1>>0]|0;v=(d[m>>0]<<8|u)&65535;b[r+(l<<5)+4>>1]=v;c[r+(l<<5)>>2]=d[m+2>>0]<<8|d[m+3>>0];w=v&1;x=(w&65535)<<1;y=x+2|0;z=(u&8|0)==0;do if(z)if(!(u&64)){A=y|u>>>4&8;break}else{A=x+6|0;break}else A=x|4;while(0);if((m+(A+4)|0)>>>0>h>>>0){p=21;q=21;break}if(!(w<<16>>16)){c[t>>2]=a[o>>0];B=11;C=14;D=12;E=13;F=8;G=7;H=10;I=9;J=m+6|0;K=a[m+5>>0]|0}else{c[t>>2]=a[o>>0]<<8|d[m+5>>0];B=13;C=16;D=14;E=15;F=10;G=9;H=12;I=11;J=m+8|0;K=a[m+6>>0]<<8|d[m+7>>0]}c[s>>2]=K;do if(z){if(u&64){L=m+H|0;M=(a[J>>0]<<8|d[m+G>>0])<<2;N=0;O=0;P=(a[m+F>>0]<<8|d[m+I>>0])<<2;break}if(!(u&128)){L=J;M=65536;N=0;O=0;P=65536}else{L=m+C|0;M=(a[J>>0]<<8|d[m+G>>0])<<2;N=(a[m+H>>0]<<8|d[m+B>>0])<<2;O=(a[m+F>>0]<<8|d[m+I>>0])<<2;P=(a[m+D>>0]<<8|d[m+E>>0])<<2}}else{x=(a[J>>0]<<8|d[m+G>>0])<<2;L=m+F|0;M=x;N=0;O=0;P=x}while(0);c[r+(l<<5)+16>>2]=M;c[r+(l<<5)+20>>2]=N;c[r+(l<<5)+24>>2]=O;c[r+(l<<5)+28>>2]=P;if(!(v&32)){Q=n;R=L;q=20;break}else{l=n;m=L}}if((q|0)==20){c[j+84>>2]=Q;c[e+168>>2]=R+(Fae(c[e+24>>2]|0)|0)-h;c[g>>2]=R;p=0;i=f;return p|0}else if((q|0)==21){i=f;return p|0}return 0}function lge(a){a=a|0;var b=0;b=i;Lae(c[a+24>>2]|0);i=b;return}
function mge(f,g,h,j){f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;k=i;i=i+32|0;l=k+12|0;m=k+8|0;n=k+4|0;o=k+16|0;p=k;q=c[f>>2]|0;r=f+12|0;s=c[r>>2]|0;c[p>>2]=0;if(h>>>0>1?(e[q+290>>1]|0)>>>0<h>>>0:0){t=21;i=k;return t|0}if((c[q+16>>2]|0)>>>0<=g>>>0){t=16;i=k;return t|0}u=f+20|0;c[u>>2]=g;v=f+16|0;if(!(c[v>>2]&1)){w=c[f+4>>2]|0;x=c[w+48>>2]|0;y=c[w+52>>2]|0}else{x=65536;y=65536}b[l>>1]=0;b[m>>1]=0;b[n>>1]=0;b[o>>1]=0;w=q+532|0;Bn[c[(c[w>>2]|0)+156>>2]&255](q,0,g,l,n)|0;if(!(a[q+296>>0]|0)){b[m>>1]=0;z=b[q+68>>1]|0;b[o>>1]=z;A=0;B=z}else{Bn[c[(c[w>>2]|0)+156>>2]&255](q,1,g,m,o)|0;A=b[m>>1]|0;B=b[o>>1]|0}o=f+52|0;c[o>>2]=b[l>>1];w=e[n>>1]|0;z=f+56|0;c[z>>2]=w;C=f+176|0;c[C>>2]=A<<16>>16;A=f+180|0;c[A>>2]=B&65535;B=f+64|0;if(!(a[B>>0]|0)){a[B>>0]=1;c[f+60>>2]=w}w=f+28|0;B=Xfe(q,g,w)|0;D=c[w>>2]|0;if((D|0)>0){E=c[f+84>>2]|0;if(!E){t=8;i=k;return t|0}F=kn[c[q+512>>2]&511](f,g,E+B|0,D)|0;if(F){t=F;i=k;return t|0}F=mo[c[q+520>>2]&4095](f)|0;if((F|0)==0&j<<24>>24==0){G=c[w>>2]|0;H=1;I=16}else J=F}else{G=D;H=0;I=16}if((I|0)==16){do if((G|0)!=0?(D=b[f+32>>1]|0,D<<16>>16!=0):0){F=(c[f+36>>2]|0)-(c[o>>2]|0)|0;B=f+68|0;c[B>>2]=F;E=f+72|0;c[E>>2]=0;K=f+76|0;c[K>>2]=(c[z>>2]|0)+F;F=f+80|0;c[F>>2]=0;L=f+184|0;c[L>>2]=0;M=(c[f+48>>2]|0)+(c[C>>2]|0)|0;N=f+188|0;c[N>>2]=M;O=f+192|0;c[O>>2]=0;P=f+196|0;c[P>>2]=M-(c[A>>2]|0);if(D<<16>>16>0){M=mo[c[q+524>>2]&4095](f)|0;if(M){Q=M;break}ko[c[q+516>>2]&4095](f);M=c[r>>2]|0;R=M+58|0;S=b[R>>1]|0;T=M+60|0;U=B;V=c[U+4>>2]|0;W=(c[T>>2]|0)+(S<<3)|0;c[W>>2]=c[U>>2];c[W+4>>2]=V;V=S+1|0;W=K;U=c[W+4>>2]|0;X=(c[T>>2]|0)+(V<<3)|0;c[X>>2]=c[W>>2];c[X+4>>2]=U;U=S+2|0;X=L;W=c[X+4>>2]|0;Y=(c[T>>2]|0)+(U<<3)|0;c[Y>>2]=c[X>>2];c[Y+4>>2]=W;W=S+3|0;Y=O;X=c[Y+4>>2]|0;Z=(c[T>>2]|0)+(W<<3)|0;c[Z>>2]=c[Y>>2];c[Z+4>>2]=X;X=M+64|0;a[(c[X>>2]|0)+S>>0]=0;a[(c[X>>2]|0)+V>>0]=0;a[(c[X>>2]|0)+U>>0]=0;a[(c[X>>2]|0)+W>>0]=0;Z=S+4|0;Y=c[f>>2]|0;if(a[Y+708>>0]|0){_=c[Y+100>>2]|0;$=sge(Y,c[u>>2]|0,n,Z)|0;if($){t=$;i=k;return t|0}$=c[n>>2]|0;if((Z|0)>0){Y=c[T>>2]|0;aa=0;do{ba=Y+(aa<<3)|0;c[ba>>2]=(c[ba>>2]|0)+(c[$+(aa<<3)>>2]|0);ba=Y+(aa<<3)+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[$+(aa<<3)+4>>2]|0);aa=aa+1|0}while((aa|0)!=(Z|0))}$ae(_,$);c[n>>2]=0}aa=c[v>>2]|0;if(!(aa&2)){Y=b[R>>1]|0;b[f+132>>1]=Y;b[f+134>>1]=b[M+56>>1]|0;c[f+136>>2]=c[M+76>>2];ba=c[T>>2]|0;c[f+140>>2]=ba;ca=c[M+80>>2]|0;c[f+144>>2]=ca;c[f+148>>2]=c[X>>2];c[f+152>>2]=c[M+68>>2];b[f+156>>1]=0;YEi(ca|0,ba|0,((Y&65535)<<3)+32|0)|0;da=c[v>>2]|0}else da=aa;if(!(da&1)){aa=c[T>>2]|0;Y=aa+(Z<<3)|0;ba=c[f+4>>2]|0;ca=c[ba+48>>2]|0;ea=c[ba+52>>2]|0;if((Z|0)>0){ba=aa;do{c[ba>>2]=K8d(c[ba>>2]|0,ca)|0;fa=ba+4|0;c[fa>>2]=K8d(c[fa>>2]|0,ea)|0;ba=ba+8|0}while(ba>>>0<Y>>>0);ga=c[v>>2]|0;ha=c[T>>2]|0}else{ga=da;ha=aa}Y=ha+(S<<3)|0;ba=c[Y+4>>2]|0;ea=B;c[ea>>2]=c[Y>>2];c[ea+4>>2]=ba;ba=(c[T>>2]|0)+(V<<3)|0;ea=c[ba+4>>2]|0;Y=K;c[Y>>2]=c[ba>>2];c[Y+4>>2]=ea;ea=(c[T>>2]|0)+(U<<3)|0;Y=c[ea+4>>2]|0;ba=L;c[ba>>2]=c[ea>>2];c[ba+4>>2]=Y;Y=(c[T>>2]|0)+(W<<3)|0;ba=c[Y+4>>2]|0;ea=O;c[ea>>2]=c[Y>>2];c[ea+4>>2]=ba;ia=ga}else ia=da;if((ia&2|0)==0?(ba=f+132|0,b[ba>>1]=(e[ba>>1]|0)+4,ba=nge(f,0)|0,(ba|0)!=0):0){t=ba;i=k;return t|0}Y8d(s);t=0;i=k;return t|0}if(D<<16>>16==-1){ba=s+22|0;ea=b[ba>>1]|0;Y=ea<<16>>16;ca=b[s+20>>1]|0;Z=mo[c[q+528>>2]&4095](f)|0;if(!Z){M=f+168|0;X=c[M>>2]|0;ko[c[q+516>>2]&4095](f);if(a[q+708>>0]|0){R=c[q+100>>2]|0;$=s+84|0;_=sge(q,g,p,(c[$>>2]|0)+4|0)|0;if(_){t=_;i=k;return t|0}_=c[$>>2]|0;if((_|0)>0){$=c[p>>2]|0;fa=0;ja=(c[s+88>>2]|0)+(c[s+48>>2]<<5)|0;while(1){if(b[ja+4>>1]&2){ka=ja+8|0;c[ka>>2]=(c[$+(fa<<3)>>2]<<16>>16)+(c[ka>>2]|0);ka=ja+12|0;c[ka>>2]=(c[$+(fa<<3)+4>>2]<<16>>16)+(c[ka>>2]|0)}fa=fa+1|0;if((fa|0)==(_|0)){la=$;ma=_;break}else ja=ja+32|0}}else{la=c[p>>2]|0;ma=0}c[B>>2]=(c[B>>2]|0)+(c[la+(ma<<3)>>2]|0);c[E>>2]=(c[E>>2]|0)+(c[la+(ma<<3)+4>>2]|0);ja=ma+1|0;c[K>>2]=(c[K>>2]|0)+(c[la+(ja<<3)>>2]|0);c[F>>2]=(c[F>>2]|0)+(c[la+(ja<<3)+4>>2]|0);ja=ma+2|0;c[L>>2]=(c[L>>2]|0)+(c[la+(ja<<3)>>2]|0);c[N>>2]=(c[N>>2]|0)+(c[la+(ja<<3)+4>>2]|0);ja=ma+3|0;c[O>>2]=(c[O>>2]|0)+(c[la+(ja<<3)>>2]|0);c[P>>2]=(c[P>>2]|0)+(c[la+(ja<<3)+4>>2]|0);$ae(R,la);c[p>>2]=0}ja=c[v>>2]|0;if(!(ja&1)){c[B>>2]=K8d(c[B>>2]|0,x)|0;c[K>>2]=K8d(c[K>>2]|0,x)|0;c[N>>2]=K8d(c[N>>2]|0,y)|0;c[P>>2]=K8d(c[P>>2]|0,y)|0;na=c[v>>2]|0}else na=ja;if(na&1024){Y8d(s);c[(c[f+8>>2]|0)+72>>2]=1668246896;t=0;i=k;return t|0}ja=c[s+84>>2]|0;_=c[s+48>>2]|0;$=f+24|0;fa=c[$>>2]|0;D=c[w>>2]|0;Y8d(s);do if(ja){W=s+52|0;T=h+1|0;U=f+4|0;V=0;while(1){S=V+_|0;aa=B;ka=c[aa>>2]|0;oa=c[aa+4>>2]|0;aa=K;pa=c[aa>>2]|0;qa=c[aa+4>>2]|0;aa=L;ra=c[aa>>2]|0;sa=c[aa+4>>2]|0;aa=O;ta=c[aa>>2]|0;ua=c[aa+4>>2]|0;aa=b[ba>>1]|0;va=aa<<16>>16;wa=mge(f,c[(c[W>>2]|0)+(S<<5)>>2]|0,T,0)|0;if(wa){t=wa;I=104;break}wa=c[W>>2]|0;xa=wa+(S<<5)+4|0;if(!(b[xa>>1]&512)){ya=B;c[ya>>2]=ka;c[ya+4>>2]=oa;oa=K;c[oa>>2]=pa;c[oa+4>>2]=qa;qa=L;c[qa>>2]=ra;c[qa+4>>2]=sa;sa=O;c[sa>>2]=ta;c[sa+4>>2]=ua}ua=b[ba>>1]|0;a:do if(ua<<16>>16!=aa<<16>>16){sa=c[r>>2]|0;ta=sa+24|0;qa=c[ta>>2]|0;ra=b[sa+22>>1]|0;sa=ra<<16>>16;oa=b[xa>>1]|0;pa=(oa&200)==0;if((ra&65535)>(aa&65535)&(pa^1)){ya=wa+(S<<5)+16|0;ka=va;do{jae(qa+(ka<<3)|0,ya);ka=ka+1|0}while((ka|0)!=(sa|0));za=b[xa>>1]|0}else za=oa;ka=za&65535;ya=c[wa+(S<<5)+8>>2]|0;Aa=c[wa+(S<<5)+12>>2]|0;do if(!(ka&2)){Ba=ya+Y|0;Ca=Aa+va|0;if(!(Ba>>>0<va>>>0&Ca>>>0<sa>>>0))break a;Da=c[ta>>2]|0;Ea=(c[Da+(Ba<<3)>>2]|0)-(c[Da+(Ca<<3)>>2]|0)|0;Fa=(c[Da+(Ba<<3)+4>>2]|0)-(c[Da+(Ca<<3)+4>>2]|0)|0}else{if(!(Aa|ya))break a;if(pa|(ka&2048|0)==0){Ga=ya;Ha=Aa}else{Ca=c[wa+(S<<5)+16>>2]|0;Da=K8d(Ca,Ca)|0;Ca=c[wa+(S<<5)+20>>2]|0;Ba=O8d((K8d(Ca,Ca)|0)+Da|0)|0;Da=c[wa+(S<<5)+28>>2]|0;Ca=K8d(Da,Da)|0;Da=c[wa+(S<<5)+24>>2]|0;Ia=O8d((K8d(Da,Da)|0)+Ca|0)|0;Ca=K8d(ya,Ba)|0;Ga=Ca;Ha=K8d(Aa,Ia)|0}if(c[v>>2]&1){Ea=Ga;Fa=Ha;break}Ia=c[U>>2]|0;Ca=c[Ia+52>>2]|0;Ba=K8d(Ga,c[Ia+48>>2]|0)|0;Ia=K8d(Ha,Ca)|0;if(!(b[xa>>1]&4)){Ea=Ba;Fa=Ia;break}Ea=Ba+32&-64;Fa=Ia+32&-64}while(0);if(!(Ea|Fa))break;Aa=sa-va|0;ya=ra<<16>>16==aa<<16>>16;if(!((Ea|0)==0|ya)){ka=0;do{pa=qa+(ka+va<<3)|0;c[pa>>2]=(c[pa>>2]|0)+Ea;ka=ka+1|0}while((ka|0)!=(Aa|0))}if((Fa|0)==0|ya)break;else Ja=0;do{ka=qa+(Ja+va<<3)+4|0;c[ka>>2]=(c[ka>>2]|0)+Fa;Ja=Ja+1|0}while((Ja|0)!=(Aa|0))}while(0);V=V+1|0;if(V>>>0>=ja>>>0){Ka=wa;La=ua;Ma=S;I=82;break}}if((I|0)==82){Na=La<<16>>16;Oa=Ka+(Ma<<5)|0;break}else if((I|0)==104){i=k;return t|0}}else{Na=Y;Oa=0}while(0);c[$>>2]=fa;c[w>>2]=D;c[M>>2]=X;if(c[v>>2]&2){t=0;i=k;return t|0}if(!(Na>>>0>Y>>>0?(b[Oa+4>>1]&256)!=0:0)){t=0;i=k;return t|0}ja=c[r>>2]|0;ba=ja+22|0;_=b[ba>>1]|0;P=_<<16>>16;N=P+4|0;do if(N){if((N+P+(b[ja+58>>1]|0)|0)>>>0<=(c[ja+4>>2]|0)>>>0){I=87;break}R=V8d(ja,N,0)|0;c[l>>2]=R;if(!R){Pa=b[ba>>1]|0;break}else{t=0;i=k;return t|0}}else I=87;while(0);if((I|0)==87){c[l>>2]=0;Pa=_}N=ja+24|0;P=B;X=c[P+4>>2]|0;D=(c[N>>2]|0)+(Pa<<16>>16<<3)|0;c[D>>2]=c[P>>2];c[D+4>>2]=X;X=K;D=c[X+4>>2]|0;P=(c[N>>2]|0)+((b[ba>>1]|0)+1<<3)|0;c[P>>2]=c[X>>2];c[P+4>>2]=D;D=L;P=c[D+4>>2]|0;X=(c[N>>2]|0)+((b[ba>>1]|0)+2<<3)|0;c[X>>2]=c[D>>2];c[X+4>>2]=P;P=O;X=c[P+4>>2]|0;D=(c[N>>2]|0)+((b[ba>>1]|0)+3<<3)|0;c[D>>2]=c[P>>2];c[D+4>>2]=X;X=ja+28|0;a[(c[X>>2]|0)+(b[ba>>1]|0)>>0]=0;a[(c[X>>2]|0)+((b[ba>>1]|0)+1)>>0]=0;a[(c[X>>2]|0)+((b[ba>>1]|0)+2)>>0]=0;a[(c[X>>2]|0)+((b[ba>>1]|0)+3)>>0]=0;X=c[$>>2]|0;D=Dae(X,c[M>>2]|0)|0;c[l>>2]=D;if(D){t=0;i=k;return t|0}D=Qae(X,l)|0;if(c[l>>2]|0){t=0;i=k;return t|0}P=D&65535;do if((D&65535)<=(e[(c[f>>2]|0)+286>>1]|0))if(!(D<<16>>16)){t=0;i=k;return t|0}else{Qa=c[f+160>>2]|0;break}else{if((P|0)>(c[w>>2]|0)){t=0;i=k;return t|0}N=f+160|0;fa=c[N>>2]|0;c[m>>2]=c[fa+388>>2];c[l>>2]=Bge(c[fa+8>>2]|0,m,1,fa+392|0,P)|0;fa=c[N>>2]|0;c[fa+388>>2]=c[m>>2]&65535;if(!(c[l>>2]|0)){Qa=fa;break}else t=0;i=k;return t|0}while(0);D=Gae(X,c[Qa+392>>2]|0,P)|0;c[l>>2]=D;if(D){t=0;i=k;return t|0}D=c[f+8>>2]|0;c[D+136>>2]=c[(c[f+160>>2]|0)+392>>2];c[D+140>>2]=P;D=c[r>>2]|0;M=(e[D+22>>1]|0)-Y|0;$=f+132|0;b[$>>1]=M;b[f+134>>1]=(e[D+20>>1]|0)-ca;c[f+136>>2]=(c[D+40>>2]|0)+(Y<<3);c[f+140>>2]=(c[D+24>>2]|0)+(Y<<3);c[f+144>>2]=(c[D+44>>2]|0)+(Y<<3);ba=c[D+28>>2]|0;ja=f+148|0;c[ja>>2]=ba+Y;c[f+152>>2]=(c[D+32>>2]|0)+(ca<<1);b[f+156>>1]=ea;D=M&65535;do if(D>>>0>Y>>>0){M=ba+(Y<<1)|0;a[M>>0]=d[M>>0]&231;M=Y+1|0;O=e[$>>1]|0;if(M>>>0<O>>>0)Ra=M;else{Sa=O;break}do{O=(c[ja>>2]|0)+Ra|0;a[O>>0]=d[O>>0]&231;Ra=Ra+1|0;O=e[$>>1]|0}while(Ra>>>0<O>>>0);Sa=O}else Sa=D;while(0);b[$>>1]=Sa+4;nge(f,1)|0;t=0;i=k;return t|0}else Q=Z}else Q=20}else I=18;while(0);do if((I|0)==18){Sa=f+36|0;c[Sa+0>>2]=0;c[Sa+4>>2]=0;c[Sa+8>>2]=0;c[Sa+12>>2]=0;if(!(j<<24>>24)){Sa=c[o>>2]|0;Ra=f+68|0;c[Ra>>2]=0-Sa;r=f+72|0;c[r>>2]=0;l=f+76|0;c[l>>2]=(c[z>>2]|0)-Sa;Sa=f+80|0;c[Sa>>2]=0;Qa=f+184|0;c[Qa>>2]=0;m=c[C>>2]|0;w=f+188|0;c[w>>2]=m;Pa=f+192|0;c[Pa>>2]=0;Oa=f+196|0;c[Oa>>2]=m-(c[A>>2]|0);m=c[f>>2]|0;if(a[m+708>>0]|0){Na=c[m+100>>2]|0;Ma=sge(m,g,p,4)|0;if(Ma){Q=Ma;break}Ma=c[p>>2]|0;c[Ra>>2]=(c[Ra>>2]|0)+(c[Ma>>2]|0);c[r>>2]=(c[r>>2]|0)+(c[Ma+4>>2]|0);c[l>>2]=(c[l>>2]|0)+(c[Ma+8>>2]|0);c[Sa>>2]=(c[Sa>>2]|0)+(c[Ma+12>>2]|0);c[Qa>>2]=(c[Qa>>2]|0)+(c[Ma+16>>2]|0);c[w>>2]=(c[w>>2]|0)+(c[Ma+20>>2]|0);c[Pa>>2]=(c[Pa>>2]|0)+(c[Ma+24>>2]|0);c[Oa>>2]=(c[Oa>>2]|0)+(c[Ma+28>>2]|0);$ae(Na,Ma);c[p>>2]=0}if(!(c[v>>2]&1)){c[Ra>>2]=K8d(c[Ra>>2]|0,x)|0;c[l>>2]=K8d(c[l>>2]|0,x)|0;c[w>>2]=K8d(c[w>>2]|0,y)|0;c[Oa>>2]=K8d(c[Oa>>2]|0,y)|0;Q=0}else Q=0}else Q=0}while(0);if(!(H<<24>>24)){t=Q;i=k;return t|0}else J=Q}ko[c[q+516>>2]&4095](f);t=J;i=k;return t|0}function nge(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;j=f+124|0;k=c[(c[f+8>>2]|0)+140>>2]|0;l=f+132|0;m=b[l>>1]|0;n=m&65535;o=f+140|0;p=c[o>>2]|0;q=c[p+(n+-4<<3)>>2]|0;r=q+32&-64;if((r|0)!=(q|0)?(s=r-q|0,m<<16>>16!=0):0){m=0;do{q=p+(m<<3)|0;c[q>>2]=s+(c[q>>2]|0);m=m+1|0}while((m|0)!=(n|0))}m=(k|0)!=0;if(m)YEi(c[f+136>>2]|0,p|0,n<<3|0)|0;n=f+160|0;p=f+4|0;s=(c[n>>2]|0)+284|0;q=(c[p>>2]|0)+172|0;r=s+68|0;do{c[s>>2]=c[q>>2];s=s+4|0;q=q+4|0}while((s|0)<(r|0));if(!(g<<24>>24)){t=c[p>>2]|0;u=c[n>>2]|0;c[u+220>>2]=c[t+48>>2];c[u+224>>2]=c[t+52>>2]}else{t=c[n>>2]|0;c[t+220>>2]=65536;c[t+224>>2]=65536;YEi(c[f+144>>2]|0,c[o>>2]|0,e[l>>1]<<3|0)|0}t=e[l>>1]|0;u=c[o>>2]|0;v=u+(t+-3<<3)|0;c[v>>2]=(c[v>>2]|0)+32&-64;v=u+(t+-1<<3)+4|0;c[v>>2]=(c[v>>2]|0)+32&-64;if(m){m=c[(c[f+12>>2]|0)+64>>2]|0;v=c[n>>2]|0;t=yge(v,3,c[v+392>>2]|0,k)|0;if(t){w=t;i=h;return w|0}t=c[n>>2]|0;a[t+560>>0]=g;s=t+144|0;q=j+0|0;r=s+36|0;do{c[s>>2]=c[q>>2];s=s+4|0;q=q+4|0}while((s|0)<(r|0));if(!(c[f+16>>2]&1))x=(a[(c[p>>2]|0)+292>>0]|0)!=0&1;else x=0;p=Ege(c[n>>2]|0,x)|0;x=c[n>>2]|0;if((p|0)!=0?(a[x+561>>0]|0)!=0:0){w=p;i=h;return w|0}a[m>>0]=c[x+340>>2]<<5|d[m>>0]|4}if(a[f+65>>0]|0){w=0;i=h;return w|0}m=e[l>>1]|0;l=c[o>>2]|0;o=l+(m+-4<<3)|0;x=c[o+4>>2]|0;p=f+68|0;c[p>>2]=c[o>>2];c[p+4>>2]=x;x=l+(m+-3<<3)|0;p=c[x+4>>2]|0;o=f+76|0;c[o>>2]=c[x>>2];c[o+4>>2]=p;p=l+(m+-2<<3)|0;o=c[p+4>>2]|0;x=f+184|0;c[x>>2]=c[p>>2];c[x+4>>2]=o;o=l+(m+-1<<3)|0;m=c[o+4>>2]|0;l=f+192|0;c[l>>2]=c[o>>2];c[l+4>>2]=m;w=0;i=h;return w|0}function oge(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+24|0;l=g;m=c[d+104>>2]|0;n=c[d+100>>2]|0;c[j>>2]=0;o=d+712|0;a:do if(!(c[o>>2]|0)){p=d+508|0;q=kn[c[p>>2]&511](d,1735811442,m,h)|0;c[j>>2]=q;if(q){r=c[j>>2]|0;i=g;return r|0}q=kn[c[p>>2]&511](d,1719034226,m,h)|0;c[j>>2]=q;if(q){r=c[j>>2]|0;i=g;return r|0}q=Fae(m)|0;p=Sae(m,790320,k)|0;c[j>>2]=p;if(p){r=c[j>>2]|0;i=g;return r|0}if(((((((c[k>>2]|0)==65536?(b[k+6>>1]|0)==2:0)?(b[k+10>>1]|0)==20:0)?(p=k+8|0,s=b[p>>1]|0,t=s&65535,(s&65535)<=16382):0)?(s=e[k+14>>1]|0,(s|0)==((t<<2)+4|0)):0)?(u=k+12|0,v=b[u>>1]|0,(v&65535)<=32511):0)?(w=k+4|0,x=(da(v&65535,s)|0)+(t*20|0)+(e[w>>1]|0)|0,x>>>0<=(c[h>>2]|0)>>>0):0){x=Xae(n,40,j)|0;c[o>>2]=x;if(c[j>>2]|0){r=c[j>>2]|0;i=g;return r|0}t=e[u>>1]|0;s=(t<<3)+20+(da((t<<2)+29|0,e[p>>1]|0)|0)|0;c[x+12>>2]=s;x=Xae(n,s,j)|0;if(c[j>>2]|0){r=c[j>>2]|0;i=g;return r|0}c[(c[o>>2]|0)+8>>2]=x;s=b[p>>1]|0;t=s&65535;c[x>>2]=t;c[x+4>>2]=-1;v=b[u>>1]|0;y=v&65535;c[x+8>>2]=y;z=x+20|0;A=x+12|0;c[A>>2]=z;B=z+(t*24|0)|0;C=x+16|0;c[C>>2]=B;D=B+(y<<3)|0;if(!(v<<16>>16))E=D;else{v=x+(((da(y>>>0>1?y:1,t)|0)<<2)+(t*24|0)+(y<<3)+20)|0;x=0;F=D;while(1){c[B+(x<<3)>>2]=F;x=x+1|0;if((x|0)>=(y|0))break;else F=F+(t<<2)|0}E=v}if(s<<16>>16){F=0;y=E;while(1){c[z+(F*24|0)>>2]=y;F=F+1|0;if((F|0)>=(t|0))break;else y=y+5|0}}y=Dae(m,(e[w>>1]|0)+q|0)|0;c[j>>2]=y;if(y){r=c[j>>2]|0;i=g;return r|0}b:do if(!(b[p>>1]|0))G=0;else{y=l+4|0;t=l+8|0;F=l+12|0;z=l+18|0;s=c[A>>2]|0;v=0;while(1){x=Sae(m,790360,l)|0;c[j>>2]=x;if(x)break;x=c[l>>2]|0;B=s+16|0;c[B>>2]=x;c[s+4>>2]=c[y>>2];c[s+8>>2]=c[t>>2];c[s+12>>2]=c[F>>2];c[s+20>>2]=e[z>>1];a[c[s>>2]>>0]=x>>>24;a[(c[s>>2]|0)+1>>0]=(c[B>>2]|0)>>>16;a[(c[s>>2]|0)+2>>0]=(c[B>>2]|0)>>>8;a[(c[s>>2]|0)+3>>0]=c[B>>2];a[(c[s>>2]|0)+4>>0]=0;v=v+1|0;B=b[p>>1]|0;if((v|0)>=(B&65535|0)){G=B;break b}else s=s+24|0}r=c[j>>2]|0;i=g;return r|0}while(0);if(!(b[u>>1]|0))break;A=G;q=1;w=c[C>>2]|0;while(1){s=Jae(m,((A&65535)<<2)+4|0)|0;c[j>>2]=s;if(s)break;c[w+4>>2]=(Nae(m)|0)&65535;Nae(m)|0;if(b[p>>1]|0){s=0;do{v=Oae(m)|0;c[(c[w>>2]|0)+(s<<2)>>2]=v;s=s+1|0}while((s|0)<(e[p>>1]|0))}Lae(m);if((q|0)>=(e[u>>1]|0))break a;A=b[p>>1]|0;q=q+1|0;w=w+8|0}r=c[j>>2]|0;i=g;return r|0}c[j>>2]=8;r=c[j>>2]|0;i=g;return r|0}while(0);if(!f){r=c[j>>2]|0;i=g;return r|0}m=Xae(n,c[(c[o>>2]|0)+12>>2]|0,j)|0;if(c[j>>2]|0){r=c[j>>2]|0;i=g;return r|0}n=c[o>>2]|0;YEi(m|0,c[n+8>>2]|0,c[n+12>>2]|0)|0;n=m+20|0;c[m+12>>2]=n;o=c[m>>2]|0;G=n+(o*24|0)|0;c[m+16>>2]=G;l=c[m+8>>2]|0;E=G+(l<<3)|0;if(!l)H=E;else{h=m+(((da(o,l>>>0>1?l:1)|0)<<2)+(o*24|0)+(l<<3)+20)|0;k=0;d=E;while(1){c[G+(k<<3)>>2]=d;k=k+1|0;if(k>>>0>=l>>>0)break;else d=d+(o<<2)|0}H=h}if(o){h=n;n=0;d=H;while(1){c[h>>2]=d;H=c[h+16>>2]|0;if((H|0)==2003265652)c[h>>2]=790392;else if((H|0)==2003072104)c[h>>2]=2368048;else if((H|0)==1869640570)c[h>>2]=790400;else if((H|0)==1936486004)c[h>>2]=790416;n=n+1|0;if(n>>>0>=o>>>0)break;else{h=h+24|0;d=d+5|0}}}c[f>>2]=m;r=c[j>>2]|0;i=g;return r|0}function pge(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+4|0;m=h;c[m>>2]=0;n=c[d+100>>2]|0;o=d+708|0;a[o>>0]=0;p=d+712|0;q=c[p>>2]|0;do if(!q){r=oge(d,0)|0;c[m>>2]=r;if(!r){s=c[p>>2]|0;break}else{t=c[m>>2]|0;i=h;return t|0}}else s=q;while(0);q=s+8|0;if((c[c[q>>2]>>2]|0)!=(f|0)){c[m>>2]=6;t=c[m>>2]|0;i=h;return t|0}p=(f|0)==0;a:do if(!p){r=0;while(1){if(((c[g+(r<<2)>>2]|0)+65536|0)>>>0>131072)break;r=r+1|0;if(r>>>0>=f>>>0)break a}c[m>>2]=6;t=c[m>>2]|0;i=h;return t|0}while(0);r=s+36|0;if(!(c[r>>2]|0)){u=c[d+104>>2]|0;v=c[u+28>>2]|0;w=kn[c[d+508>>2]&511](d,1735811442,u,k)|0;c[j>>2]=w;do if(!w){k=Fae(u)|0;x=Sae(u,790424,l)|0;c[j>>2]=x;if(!x){y=s+24|0;c[y>>2]=e[l+6>>1];z=e[l+12>>1]|0;A=s+32|0;c[A>>2]=z;B=(c[l+16>>2]|0)+k|0;if((c[l>>2]|0)==65536?(C=l+4|0,(b[C>>1]|0)==(c[c[q>>2]>>2]&65535)<<16>>16):0){c[r>>2]=Zae(v,4,0,z+1|0,0,j)|0;z=c[j>>2]|0;if(z){D=z;break}z=(c[A>>2]|0)+1|0;if(!(b[l+14>>1]&1)){E=Jae(u,z<<1)|0;c[j>>2]=E;if(!E)F=0;else{D=E;break}do{E=(((Nae(u)|0)&65535)<<1)+B|0;c[(c[r>>2]|0)+(F<<2)>>2]=E;F=F+1|0}while(F>>>0<=(c[A>>2]|0)>>>0);Lae(u)}else{E=Jae(u,z<<2)|0;c[j>>2]=E;if(!E)G=0;else{D=E;break}do{E=(Oae(u)|0)+B|0;c[(c[r>>2]|0)+(G<<2)>>2]=E;G=G+1|0}while(G>>>0<=(c[A>>2]|0)>>>0);Lae(u)}A=c[y>>2]|0;if(A){B=s+28|0;c[B>>2]=Zae(v,4,0,da(e[C>>1]|0,A)|0,0,j)|0;A=c[j>>2]|0;if(A){D=A;break}A=Dae(u,(c[l+8>>2]|0)+k|0)|0;c[j>>2]=A;if(A){D=A;break}A=Jae(u,da(c[y>>2]<<1,e[C>>1]|0)|0)|0;c[j>>2]=A;if(A){D=A;break}A=c[y>>2]|0;if(A){z=b[C>>1]|0;E=A;A=0;while(1){if(!(z<<16>>16)){H=E;I=0}else{J=0;do{K=(Nae(u)|0)<<16>>16<<2;L=b[C>>1]|0;M=L&65535;N=(da(M,A)|0)+J|0;c[(c[B>>2]|0)+(N<<2)>>2]=K;J=J+1|0}while(J>>>0<M>>>0);O=L;H=c[y>>2]|0;I=O}A=A+1|0;if(A>>>0>=H>>>0)break;else{z=I;E=H}}}Lae(u)}D=c[j>>2]|0;break}c[j>>2]=8;D=8}else D=x}else D=w;while(0);c[m>>2]=D;if(D){t=c[m>>2]|0;i=h;return t|0}}D=s+4|0;w=c[D>>2]|0;b:do if(!w){j=Zae(n,4,0,f,0,m)|0;c[D>>2]=j;if(!(c[m>>2]|0)){P=j;Q=1}else{t=c[m>>2]|0;i=h;return t|0}}else if(p){P=w;Q=0}else{j=0;while(1){if((c[w+(j<<2)>>2]|0)!=(c[g+(j<<2)>>2]|0)){P=w;Q=2;break b}j=j+1|0;if(j>>>0>=f>>>0){P=w;Q=0;break}}}while(0);c[s>>2]=f;YEi(P|0,g|0,f<<2|0)|0;a[o>>0]=1;o=d+672|0;f=c[o>>2]|0;if(!f){t=c[m>>2]|0;i=h;return t|0}if((Q|0)==2){$ae(n,f);c[o>>2]=0;Zfe(d,c[d+104>>2]|0)|0;t=c[m>>2]|0;i=h;return t|0}else if((Q|0)==1){qge(d,c[d+104>>2]|0)|0;t=c[m>>2]|0;i=h;return t|0}else{t=c[m>>2]|0;i=h;return t|0}return 0}function qge(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=c[d+28>>2]|0;l=c[a+712>>2]|0;if(!l){c[g>>2]=0;m=0;n=0;o=0;$ae(k,o);$ae(k,n);$ae(k,m);p=c[g>>2]|0;i=f;return p|0}q=a+672|0;if(!(c[q>>2]|0)){c[g>>2]=0;m=0;n=0;o=0;$ae(k,o);$ae(k,n);$ae(k,m);p=c[g>>2]|0;i=f;return p|0}r=kn[c[a+508>>2]&511](a,1668702578,d,h)|0;c[g>>2]=r;if(r){c[g>>2]=0;m=0;n=0;o=0;$ae(k,o);$ae(k,n);$ae(k,m);p=c[g>>2]|0;i=f;return p|0}r=Jae(d,c[h>>2]|0)|0;c[g>>2]=r;if(r){c[g>>2]=0;m=0;n=0;o=0;$ae(k,o);$ae(k,n);$ae(k,m);p=c[g>>2]|0;i=f;return p|0}r=d+32|0;h=(c[r>>2]|0)-(c[d>>2]|0)|0;if((Oae(d)|0)==65536){s=Zae(k,4,0,c[l>>2]|0,0,g)|0;if(!(c[g>>2]|0)){t=Zae(k,4,0,c[l>>2]|0,0,g)|0;if(!(c[g>>2]|0)){u=Zae(k,4,0,c[l>>2]|0,0,g)|0;if((c[g>>2]|0)==0?(v=Nae(d)|0,w=Nae(d)|0,(v&4095)!=0):0){x=a+668|0;a=v&4095;v=0;y=h+(w&65535)|0;while(1){w=(Nae(d)|0)&65535;h=Nae(d)|0;z=h&65535;if(!(z&32768)){if((z&16384|0)!=0?(c[l>>2]&2147483647|0)!=0:0){A=0;do{Nae(d)|0;A=A+1|0}while(A>>>0<c[l>>2]<<1>>>0)}}else{if(!(c[l>>2]|0))B=0;else{A=0;do{c[s+(A<<2)>>2]=(Nae(d)|0)<<16>>16<<2;A=A+1|0;C=c[l>>2]|0}while(A>>>0<C>>>0);B=C}if(!((z&16384|0)==0|(B|0)==0)){A=0;do{c[t+(A<<2)>>2]=(Nae(d)|0)<<16>>16<<2;A=A+1|0;C=c[l>>2]|0}while(A>>>0<C>>>0);D=C;if(D){A=0;do{c[u+(A<<2)>>2]=(Nae(d)|0)<<16>>16<<2;A=A+1|0}while(A>>>0<(c[l>>2]|0)>>>0)}}A=uge(l,h,s,t,u)|0;if(!((A|0)==0|(z&8192|0)==0)){C=c[d>>2]|0;E=(c[r>>2]|0)-C|0;c[r>>2]=C+y;C=vge(d,j)|0;F=c[j>>2]|0;G=(F|0)==0;if(G)H=c[x>>2]|0;else H=F;I=wge(d,H)|0;do if(!((C|0)==0|(I|0)==0))if((C|0)==(-1|0)){if(!(c[x>>2]|0))break;J=c[q>>2]|0;K=0;do{L=e[J+(K<<1)>>1]|0;M=(K8d(b[I+(K<<1)>>1]|0,A)|0)+L&65535;J=c[q>>2]|0;b[J+(K<<1)>>1]=M;K=K+1|0}while(K>>>0<(c[x>>2]|0)>>>0);N=37}else{if(G){N=38;break}K=c[q>>2]|0;J=0;do{M=e[C+(J<<1)>>1]|0;L=e[K+(M<<1)>>1]|0;O=(K8d(b[I+(J<<1)>>1]|0,A)|0)+L&65535;K=c[q>>2]|0;b[K+(M<<1)>>1]=O;J=J+1|0}while(J>>>0<F>>>0);N=37}else N=37;while(0);if((N|0)==37?(N=0,(C|0)!=(-1|0)):0)N=38;if((N|0)==38){N=0;$ae(k,C)}$ae(k,I);c[r>>2]=(c[d>>2]|0)+E}}v=v+1|0;if((v|0)==(a|0)){P=u;Q=t;R=s;break}else y=w+y|0}}else{P=u;Q=t;R=s}}else{P=0;Q=t;R=s}}else{P=0;Q=0;R=s}}else{c[g>>2]=0;P=0;Q=0;R=0}Lae(d);m=P;n=Q;o=R;$ae(k,o);$ae(k,n);$ae(k,m);p=c[g>>2]|0;i=f;return p|0}function rge(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+16|0;j=h+8|0;k=h+4|0;l=h;c[l>>2]=0;m=c[d+100>>2]|0;n=d+712|0;o=c[n>>2]|0;do if(!o){p=oge(d,0)|0;c[l>>2]=p;if(!p){q=c[n>>2]|0;break}else{r=0;$ae(m,r);s=c[l>>2]|0;i=h;return s|0}}else q=o;while(0);o=c[q+8>>2]|0;if((c[o>>2]|0)!=(f|0)){c[l>>2]=6;r=0;$ae(m,r);s=c[l>>2]|0;i=h;return s|0}p=Zae(m,4,0,f,0,l)|0;if(c[l>>2]|0){r=p;$ae(m,r);s=c[l>>2]|0;i=h;return s|0}a:do if(c[o>>2]|0){t=c[o+12>>2]|0;u=0;while(1){v=c[g+(u<<2)>>2]|0;w=c[t+12>>2]|0;if((v|0)>(w|0))break;x=c[t+4>>2]|0;if((v|0)<(x|0))break;y=c[t+8>>2]|0;do if((v|0)>=(y|0))if((w|0)==(y|0)){c[p+(u<<2)>>2]=0;break}else{c[p+(u<<2)>>2]=I8d(v-y|0,65536,w-y|0)|0;break}else c[p+(u<<2)>>2]=0-(I8d(v-y|0,65536,x-y|0)|0);while(0);u=u+1|0;if(u>>>0>=(c[o>>2]|0)>>>0)break a;else t=t+24|0}c[l>>2]=6;r=p;$ae(m,r);s=c[l>>2]|0;i=h;return s|0}while(0);if(((a[q+16>>0]|0)==0?(g=c[d+104>>2]|0,t=c[g+28>>2]|0,u=c[n>>2]|0,a[u+16>>0]=1,n=kn[c[d+508>>2]&511](d,1635148146,g,k)|0,c[j>>2]=n,(n|0)==0):0)?(n=Jae(g,c[k>>2]|0)|0,c[j>>2]=n,(n|0)==0):0){n=Oae(g)|0;k=Oae(g)|0;b:do if(((n|0)==65536?(k|0)==(c[c[u+8>>2]>>2]|0):0)?(y=Zae(t,8,0,k,0,j)|0,x=u+20|0,c[x>>2]=y,(c[j>>2]|0)==0&(k|0)>0):0){v=0;w=y;while(1){y=Nae(g)|0;b[w>>1]=y;z=w+4|0;c[z>>2]=Zae(t,8,0,y&65535,0,j)|0;if(c[j>>2]|0){A=v;break}if(b[w>>1]|0){y=0;do{B=(Nae(g)|0)<<16>>16<<2;c[(c[z>>2]|0)+(y<<3)>>2]=B;B=(Nae(g)|0)<<16>>16<<2;c[(c[z>>2]|0)+(y<<3)+4>>2]=B;y=y+1|0}while((y|0)<(e[w>>1]|0))}v=v+1|0;if((v|0)>=(k|0))break b;else w=w+8|0}w=c[x>>2]|0;if((A|0)>0){v=w;y=A;while(1){y=y+-1|0;$ae(t,c[v+(y<<3)+4>>2]|0);z=c[x>>2]|0;c[z+(y<<3)+4>>2]=0;if((y|0)<=0){C=z;break}else v=z}}else C=w;$ae(t,C);c[x>>2]=0}while(0);Lae(g)}g=c[q+20>>2]|0;if((g|0)!=0?(q=c[o>>2]|0,(q|0)!=0):0){C=q;q=g;g=0;while(1){t=b[q>>1]|0;c:do if((t&65535)>1){A=p+(g<<2)|0;k=c[A>>2]|0;j=q+4|0;u=c[j>>2]|0;n=1;while(1){v=c[u+(n<<3)>>2]|0;if((k|0)<(v|0)){D=v;E=n;break}n=n+1|0;if(n>>>0>=(t&65535)>>>0){F=C;break c}}n=E+-1|0;v=c[u+(n<<3)>>2]|0;y=I8d(k-v|0,65536,D-v|0)|0;v=c[j>>2]|0;z=I8d(y,(c[v+(E<<3)+4>>2]|0)-(c[v+(n<<3)+4>>2]|0)|0,65536)|0;c[A>>2]=(c[(c[j>>2]|0)+(n<<3)+4>>2]|0)+z;F=c[o>>2]|0}else F=C;while(0);g=g+1|0;if(g>>>0>=F>>>0)break;else{C=F;q=q+8|0}}}c[l>>2]=pge(d,f,p)|0;r=p;$ae(m,r);s=c[l>>2]|0;i=h;return s|0}function sge(d,f,g,h){d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;n=c[d+104>>2]|0;o=c[n+28>>2]|0;p=c[d+712>>2]|0;c[m>>2]=0;if((a[d+708>>0]|0)==0|(p|0)==0){q=6;i=j;return q|0}d=Zae(o,8,0,h,0,k)|0;r=c[k>>2]|0;if(r){q=r;i=j;return q|0}c[g>>2]=d;if((c[p+32>>2]|0)>>>0<=f>>>0){q=0;i=j;return q|0}r=p+36|0;s=c[r>>2]|0;t=c[s+(f<<2)>>2]|0;u=f+1|0;if((t|0)==(c[s+(u<<2)>>2]|0)){q=0;i=j;return q|0}s=Dae(n,t)|0;c[k>>2]=s;if((s|0)==0?(s=c[r>>2]|0,r=Jae(n,(c[s+(u<<2)>>2]|0)-(c[s+(f<<2)>>2]|0)|0)|0,c[k>>2]=r,(r|0)==0):0){r=n+32|0;f=(c[r>>2]|0)-(c[n>>2]|0)|0;s=Zae(o,4,0,c[p>>2]|0,0,k)|0;if(((c[k>>2]|0)==0?(u=Zae(o,4,0,c[p>>2]|0,0,k)|0,(c[k>>2]|0)==0):0)?(t=Zae(o,4,0,c[p>>2]|0,0,k)|0,(c[k>>2]|0)==0):0){v=(Nae(n)|0)&65535;w=((Nae(n)|0)&65535)+f|0;if(!(v&32768)){x=w;y=0}else{f=c[n>>2]|0;z=(c[r>>2]|0)-f|0;c[r>>2]=f+w;w=vge(n,m)|0;f=c[n>>2]|0;A=(c[r>>2]|0)-f|0;c[r>>2]=f+z;x=A;y=w}w=v&4095;a:do if(w){v=p+24|0;A=p+28|0;z=c[m>>2]|0;f=(h|0)==0;B=0;C=0;D=x;while(1){E=(Nae(n)|0)&65535;F=Nae(n)|0;G=F&65535;if(G&32768){if(c[p>>2]|0){H=0;do{c[s+(H<<2)>>2]=(Nae(n)|0)<<16>>16<<2;H=H+1|0}while(H>>>0<(c[p>>2]|0)>>>0)}}else{H=G&4095;if(H>>>0>=(c[v>>2]|0)>>>0)break;I=c[p>>2]|0;J=da(I,H)|0;YEi(s|0,(c[A>>2]|0)+(J<<2)|0,I<<2|0)|0}if((G&16384|0)!=0?(c[p>>2]|0)!=0:0){I=0;do{c[u+(I<<2)>>2]=(Nae(n)|0)<<16>>16<<2;I=I+1|0;J=c[p>>2]|0}while(I>>>0<J>>>0);K=J;if(K){I=0;do{c[t+(I<<2)>>2]=(Nae(n)|0)<<16>>16<<2;I=I+1|0}while(I>>>0<(c[p>>2]|0)>>>0)}}I=uge(p,F,s,u,t)|0;if(!I)L=C;else{J=c[n>>2]|0;H=(c[r>>2]|0)-J|0;if(!(G&8192)){c[l>>2]=z;M=z;N=C;O=y}else{c[r>>2]=J+D;J=vge(n,l)|0;M=c[l>>2]|0;N=J;O=J}J=(M|0)==0;P=J?h:M;Q=wge(n,P)|0;R=wge(n,P)|0;b:do if(!((O|0)==0|(R|0)==0|(Q|0)==0)){if((O|0)==(-1|0)){if(f)break;else S=0;while(1){P=K8d(b[Q+(S<<1)>>1]|0,I)|0;T=d+(S<<3)|0;c[T>>2]=(c[T>>2]|0)+P;P=K8d(b[R+(S<<1)>>1]|0,I)|0;T=d+(S<<3)+4|0;c[T>>2]=(c[T>>2]|0)+P;S=S+1|0;if((S|0)==(h|0))break b}}if(J)break;else U=0;do{P=N+(U<<1)|0;if((e[P>>1]|0)>>>0<h>>>0){T=K8d(b[Q+(U<<1)>>1]|0,I)|0;V=d+(e[P>>1]<<3)|0;c[V>>2]=(c[V>>2]|0)+T;T=K8d(b[R+(U<<1)>>1]|0,I)|0;V=d+(e[P>>1]<<3)+4|0;c[V>>2]=(c[V>>2]|0)+T}U=U+1|0}while(U>>>0<M>>>0)}while(0);if((N|0)==(-1|0))W=-1;else{$ae(o,N);W=0}$ae(o,Q);$ae(o,R);c[r>>2]=(c[n>>2]|0)+H;L=W}B=B+1|0;if(B>>>0>=w>>>0)break a;else{C=L;D=E+D|0}}c[k>>2]=8}while(0);$ae(o,s);$ae(o,u);$ae(o,t)}Lae(n);if(!(c[k>>2]|0)){q=0;i=j;return q|0}}$ae(o,d);c[g>>2]=0;q=c[k>>2]|0;i=j;return q|0}function tge(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;if(!b){i=d;return}e=b+4|0;$ae(a,c[e>>2]|0);c[e>>2]=0;e=b+8|0;$ae(a,c[e>>2]|0);c[e>>2]=0;e=b+20|0;f=c[e>>2]|0;if(f){if(!(c[b>>2]|0))g=f;else{h=f;f=0;while(1){$ae(a,c[h+(f<<3)+4>>2]|0);j=c[e>>2]|0;c[j+(f<<3)+4>>2]=0;f=f+1|0;if(f>>>0>=(c[b>>2]|0)>>>0){g=j;break}else h=j}}$ae(a,g);c[e>>2]=0}e=b+28|0;$ae(a,c[e>>2]|0);c[e>>2]=0;e=b+36|0;$ae(a,c[e>>2]|0);c[e>>2]=0;$ae(a,b);i=d;return}function uge(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a+4|0;j=c[a>>2]|0;a:do if(!j)k=65536;else{if(!(b&16384)){l=j;m=65536;n=0;while(1){o=c[d+(n<<2)>>2]|0;if(!o){p=l;q=m}else{r=c[(c[h>>2]|0)+(n<<2)>>2]|0;if(!r){k=0;break a}if((r|0)<0&(o|0)>0){k=0;break a}s=(r|0)>0;if(s&(o|0)<0){k=0;break a}o=I8d(m,s?r:0-r|0,65536)|0;p=c[a>>2]|0;q=o}n=n+1|0;if(n>>>0>=p>>>0){k=q;break a}else{l=p;m=q}}}else{t=65536;u=0}while(1){m=c[d+(u<<2)>>2]|0;do if(m){l=c[(c[h>>2]|0)+(u<<2)>>2]|0;if(!l){k=0;break a}if((l|0)<0&(m|0)>0){k=0;break a}if((l|0)>0&(m|0)<0){k=0;break a}n=c[e+(u<<2)>>2]|0;if((l|0)<=(n|0)){k=0;break a}o=c[f+(u<<2)>>2]|0;if((o|0)<=(l|0)){k=0;break a}if((l|0)<(m|0)){v=I8d(t,I8d(l-n|0,65536,m-n|0)|0,65536)|0;break}else{v=I8d(t,I8d(o-l|0,65536,o-m|0)|0,65536)|0;break}}else v=t;while(0);u=u+1|0;if(u>>>0>=(c[a>>2]|0)>>>0){k=v;break}else t=v}}while(0);i=g;return k|0}function vge(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+16|0;f=e;g=c[a+28>>2]|0;c[f>>2]=0;h=Mae(a)|0;j=h&255;c[d>>2]=j;if(!(h<<24>>24)){k=-1;i=e;return k|0}if(!(j&128))l=j;else l=(Mae(a)|0)&255|j<<8&32512;j=Zae(g,2,0,l,0,f)|0;if(c[f>>2]|0){k=0;i=e;return k|0}if((l|0)>0)m=0;else{k=j;i=e;return k|0}while(1){f=Mae(a)|0;g=f&255;if(!(g&128)){h=Mae(a)|0;d=m+1|0;b[j+(m<<1)>>1]=h&255;if(!(f<<24>>24!=0&(g+d|0)<(l|0))){k=j;n=16;break}o=g>>>0>1?g:1;p=h&255;h=d;q=0;while(1){p=((Mae(a)|0)&255)+p|0;b[j+(h<<1)>>1]=p;q=q+1|0;if((q|0)>=(g|0))break;else h=h+1|0}r=d+o|0}else{h=g&127;q=Nae(a)|0;p=m+1|0;b[j+(m<<1)>>1]=q;if(!((h|0)!=0&(h+p|0)<(l|0))){k=j;n=16;break}s=f&127;t=s>>>0>1?s:1;s=q&65535;q=p;u=0;while(1){s=((Nae(a)|0)&65535)+s|0;b[j+(q<<1)>>1]=s;u=u+1|0;if((u|0)>=(h|0))break;else q=q+1|0}r=p+t|0}if((r|0)<(l|0))m=r;else{k=j;n=16;break}}if((n|0)==16){i=e;return k|0}return 0}function wge(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e;g=c[a+28>>2]|0;c[f>>2]=0;h=Zae(g,2,0,d,0,f)|0;if(!(c[f>>2]|0))j=0;else{k=0;i=e;return k|0}while(1){if(j>>>0>=d>>>0){k=h;l=10;break}f=Mae(a)|0;m=f&255;if(!(m&128)){n=j-d|0;o=(f&255|-64)^63;p=n>>>0>o>>>0?n:o;o=0-p|0;if(!(m&64)){n=j;q=0;while(1){b[h+(n<<1)>>1]=(Mae(a)|0)<<24>>24;q=q+1|0;if((q|0)==(o|0)){r=o;s=p;break}else n=n+1|0}}else{n=j;q=0;while(1){b[h+(n<<1)>>1]=Nae(a)|0;q=q+1|0;if((q|0)==(o|0)){r=o;s=p;break}else n=n+1|0}}}else{n=j-d|0;p=(f&255|-64)^63;o=n>>>0>p>>>0?n:p;PEi(h+(j<<1)|0,0,da(o,-2)|0)|0;r=0-o|0;s=o}if(r>>>0>(m&63)>>>0)j=j-s|0;else break}if((l|0)==10){i=e;return k|0}$ae(g,h);k=0;i=e;return k|0}function xge(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=b+-1|0;c[a+356>>2]=c[a+(e<<3)+444>>2];c[a+364>>2]=c[a+(e<<3)+448>>2];c[a+360>>2]=d;c[a+352>>2]=b;return 0}function yge(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=b+-1|0;c[a+(f<<3)+444>>2]=d;c[a+(f<<3)+448>>2]=e;return 0}function zge(a,b){a=a|0;b=b|0;var d=0;d=b+-1|0;c[a+(d<<3)+444>>2]=0;c[a+(d<<3)+448>>2]=0;return 0}function Age(a){a=a|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;b[a+440>>1]=0;b[a+442>>1]=0;f=a+24|0;$ae(e,c[f>>2]|0);c[f>>2]=0;c[a+20>>2]=0;f=a+436|0;$ae(e,c[f>>2]|0);c[f>>2]=0;c[a+432>>2]=0;c[a+428>>2]=0;f=a+392|0;$ae(e,c[f>>2]|0);c[f>>2]=0;c[a+388>>2]=0;c[a+4>>2]=0;c[a>>2]=0;$ae(e,a);i=d;return 0}function Bge(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g;j=c[b>>2]|0;if(j>>>0>=f>>>0){k=0;i=g;return k|0}l=da(j,d)|0;j=da(f,d)|0;c[e>>2]=Zae(a,1,l,j,c[e>>2]|0,h)|0;e=c[h>>2]|0;if(e){k=e;i=g;return k|0}c[b>>2]=f;k=0;i=g;return k|0}function Cge(d,f,g){d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+16|0;j=h;c[d>>2]=f;c[d+4>>2]=g;if(g){c[d+396>>2]=c[g+116>>2];c[d+400>>2]=c[g+120>>2];c[d+408>>2]=c[g+128>>2];c[d+412>>2]=c[g+132>>2];c[d+404>>2]=c[g+124>>2];c[d+416>>2]=c[g+136>>2];k=d+244|0;l=g+72|0;m=k+40|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));n=d+216|0;o=g+44|0;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[d+420>>2]=c[g+140>>2];c[d+424>>2]=c[g+144>>2];o=g+148|0;n=c[o+4>>2]|0;p=d+444|0;c[p>>2]=c[o>>2];c[p+4>>2]=n;n=g+156|0;p=c[n+4>>2]|0;o=d+452|0;c[o>>2]=c[n>>2];c[o+4>>2]=p;p=g+164|0;o=c[p+4>>2]|0;n=d+460|0;c[n>>2]=c[p>>2];c[n+4>>2]=o;k=d+284|0;l=g+172|0;m=k+68|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));c[d+380>>2]=c[g+240>>2];c[d+384>>2]=c[g+244>>2];b[d+468>>1]=b[g+248>>1]|0;c[d+472>>2]=c[g+252>>2];k=d+180|0;l=g+256|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));g=d+36|0;k=g+0|0;m=k+36|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(m|0));k=d+72|0;l=g+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));k=d+108|0;l=g+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0))}g=d+20|0;o=c[g>>2]|0;n=d+8|0;p=c[n>>2]|0;q=d+24|0;r=(e[f+284>>1]|0)+32|0;do if(o>>>0<r>>>0){c[q>>2]=Zae(p,1,o<<2,r<<2,c[q>>2]|0,j)|0;s=c[j>>2]|0;if(!s){t=r;u=c[n>>2]|0;break}c[g>>2]=o;v=s;i=h;return v|0}else{t=o;u=p}while(0);c[g>>2]=t;t=d+388|0;g=c[t>>2]|0;p=d+392|0;o=e[f+286>>1]|0;if(g>>>0<o>>>0){c[p>>2]=Zae(u,1,g,o,c[p>>2]|0,j)|0;p=c[j>>2]|0;if(!p)w=o;else{c[t>>2]=g&65535;v=p;i=h;return v|0}}else w=g;c[t>>2]=w&65535;w=d+144|0;b[d+152>>1]=0;b[d+154>>1]=0;k=d+72|0;l=w+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));k=d+108|0;l=w+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));k=d+36|0;l=w+0|0;m=k+36|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));a[d+488>>0]=0;v=0;i=h;return v|0}function Dge(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[b+116>>2]=c[a+396>>2];c[b+128>>2]=c[a+408>>2];c[b+140>>2]=c[a+420>>2];c[b+144>>2]=c[a+424>>2];d=a+444|0;e=c[d+4>>2]|0;f=b+148|0;c[f>>2]=c[d>>2];c[f+4>>2]=e;e=a+452|0;f=c[e+4>>2]|0;d=b+156|0;c[d>>2]=c[e>>2];c[d+4>>2]=f;f=a+460|0;a=c[f+4>>2]|0;d=b+164|0;c[d>>2]=c[f>>2];c[d+4>>2]=a;return 0}function Ege(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0;d=i;c[a+356>>2]=c[a+460>>2];c[a+364>>2]=c[a+464>>2];c[a+360>>2]=0;c[a+352>>2]=3;f=a+144|0;g=a+36|0;h=f+0|0;j=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));g=a+72|0;h=f+0|0;j=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));g=a+108|0;h=f+0|0;j=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));b[a+344>>1]=1;b[a+346>>1]=1;b[a+348>>1]=1;h=a+294|0;b[h>>1]=16384;b[a+296>>1]=0;g=a+298|0;j=e[h>>1]|e[h+2>>1]<<16;b[g>>1]=j;b[g+2>>1]=j>>>16;g=a+290|0;b[g>>1]=j;b[g+2>>1]=j>>>16;c[a+312>>2]=1;c[a+304>>2]=1;c[a+16>>2]=0;c[a+428>>2]=0;j=mo[c[(c[a>>2]|0)+688>>2]&4095](a)|0;i=d;return j|0}function Fge(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[a+8>>2]|0;h=a+40|0;a=c[h>>2]|0;if(a){j=a;i=d;return j|0}a=Xae(g,608,f)|0;if(c[f>>2]|0){j=0;i=d;return j|0}k=a+8|0;c[k>>2]=g;l=a+432|0;c[l>>2]=32;m=a+436|0;c[m>>2]=Zae(g,16,0,32,0,e)|0;if(c[e>>2]|0){g=c[k>>2]|0;b[a+440>>1]=0;b[a+442>>1]=0;k=a+24|0;$ae(g,c[k>>2]|0);c[k>>2]=0;c[a+20>>2]=0;$ae(g,c[m>>2]|0);c[m>>2]=0;c[l>>2]=0;c[a+428>>2]=0;l=a+392|0;$ae(g,c[l>>2]|0);c[l>>2]=0;c[a+388>>2]=0;c[a+4>>2]=0;c[a>>2]=0;$ae(g,a);g=c[e>>2]|0;c[f>>2]=g;if(g){j=0;i=d;return j|0}}else{b[a+440>>1]=0;b[a+442>>1]=0;c[a+20>>2]=0;c[a+388>>2]=0;c[a+24>>2]=0;c[a+392>>2]=0;c[a>>2]=0;c[a+4>>2]=0;c[f>>2]=0}c[h>>2]=a;j=a;i=d;return j|0}function Gge(f){f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0;g=i;i=i+160|0;h=g+12|0;j=g+148|0;k=g+4|0;l=g+8|0;m=g+108|0;n=g+150|0;o=g+144|0;p=g+100|0;q=g+64|0;r=g+152|0;s=g+104|0;t=g;u=g+48|0;c[f+256>>2]=0;v=(b[f+216>>1]|0)==(b[f+218>>1]|0);w=f+592|0;c[w>>2]=v?2837:2838;x=f+596|0;c[x>>2]=v?1850:1851;y=f+600|0;c[y>>2]=v?1852:1853;Nge(f);v=f+312|0;switch(c[v>>2]&255|0){case 6:{z=f+568|0;c[z>>2]=1766;A=z;break}case 4:{z=f+568|0;c[z>>2]=1762;A=z;break}case 1:{z=f+568|0;c[z>>2]=1761;A=z;break}case 3:{z=f+568|0;c[z>>2]=1763;A=z;break}case 5:{z=f+568|0;c[z>>2]=1760;A=z;break}case 2:{z=f+568|0;c[z>>2]=1765;A=z;break}case 0:{z=f+568|0;c[z>>2]=1764;A=z;break}case 7:{z=f+568|0;c[z>>2]=1767;A=z;break}default:A=f+568|0}z=f+360|0;B=f+356|0;C=f+368|0;D=f+372|0;E=f+364|0;F=f+16|0;G=f+28|0;H=f+561|0;I=f+24|0;J=f+32|0;K=f+20|0;L=f+376|0;M=f+12|0;N=f+72|0;O=f+80|0;P=f+380|0;Q=f+284|0;R=f+44|0;S=f+328|0;T=f+324|0;U=f+346|0;V=f+48|0;W=f+298|0;X=f+84|0;Y=f+300|0;Z=f+88|0;_=f+52|0;$=f+576|0;aa=f+572|0;ba=f+316|0;ca=f+584|0;ea=f+308|0;fa=f+344|0;ga=f+320|0;ha=f+286|0;ia=f+288|0;ja=f+92|0;ka=f+56|0;la=f+220|0;ma=f+224|0;na=f+488|0;oa=f+416|0;pa=f+408|0;qa=f+428|0;ra=f+432|0;sa=f+436|0;ta=f+352|0;ua=f+294|0;va=f+296|0;wa=f+290|0;xa=f+292|0;ya=f+294|0;za=f+116|0;Aa=f+124|0;Ba=f+290|0;Ca=f+298|0;Da=f+132|0;Ea=f+36|0;Fa=f+180|0;Ga=f+144|0;Ha=f+108|0;Ia=f+348|0;Ja=f+304|0;Ka=f+60|0;La=f+420|0;Ma=f+404|0;Na=f+396|0;Oa=f+400|0;Pa=f+264|0;Qa=f+154|0;Ra=f+156|0;Sa=f+160|0;Ta=u+4|0;Ua=f+164|0;Va=u+8|0;Wa=f+152|0;Xa=u+12|0;Ya=f+172|0;Za=f+176|0;_a=f+168|0;$a=m+16|0;ab=h+16|0;bb=f+118|0;cb=f+136|0;db=f+120|0;eb=f+128|0;fb=f+588|0;gb=f+468|0;hb=f+472|0;ib=f+332|0;jb=f+334|0;kb=f+260|0;lb=f+384|0;mb=f+476|0;nb=f+484|0;ob=f+480|0;pb=f+282|0;qb=f+337|0;rb=f+281|0;sb=f+252|0;tb=f+604|0;ub=f+412|0;vb=f+424|0;wb=f+340|0;xb=f+336|0;yb=c[z>>2]|0;zb=0;a:while(1){Ab=c[B>>2]|0;Bb=a[Ab+yb>>0]|0;a[C>>0]=Bb;Cb=Bb&255;Db=a[790536+Cb>>0]|0;c[D>>2]=Db;Eb=c[E>>2]|0;if((Cb&254|0)==64){if((yb|0)>=(Eb|0)){Fb=707;break}Gb=2-(da(d[Ab+(yb+1)>>0]|0,Db)|0)|0;c[D>>2]=Gb;Hb=Gb}else Hb=Db;if((Hb+yb|0)>(Eb|0)){Fb=707;break}Eb=a[790792+Cb>>0]|0;Db=Eb&255;Gb=Db>>>4;Ib=(c[F>>2]|0)-Gb|0;c[G>>2]=Ib;if((Ib|0)<0){if(a[H>>0]|0){Fb=20;break}if((Eb&255)>15){Eb=c[I>>2]|0;Jb=0;Kb=0;do{c[Eb+(Jb<<2)>>2]=0;Kb=Kb+1<<16>>16;Jb=Kb&65535}while(Jb>>>0<Gb>>>0)}c[G>>2]=0;Lb=0}else Lb=Ib;Gb=(Db&15)+Lb|0;c[J>>2]=Gb;Jb=c[K>>2]|0;if(Gb>>>0>Jb>>>0){Fb=24;break}a[L>>0]=1;c[M>>2]=0;Kb=c[I>>2]|0;Eb=Kb+(Lb<<2)|0;b:do switch(Cb|0){case 35:{Mb=c[Eb>>2]|0;Nb=Kb+(Lb+1<<2)|0;c[Eb>>2]=c[Nb>>2];c[Nb>>2]=Mb;Fb=685;break}case 17:{b[ha>>1]=c[Eb>>2];Fb=685;break}case 28:{Mb=c[Eb>>2]|0;if(!(Mb|Lb))c[M>>2]=132;Nb=(c[z>>2]|0)+Mb|0;c[z>>2]=Nb;if((Nb|0)<0)c[M>>2]=132;a[L>>0]=0;Fb=685;break}case 86:{c[Eb>>2]=((xo[c[A>>2]&2047](f,c[Eb>>2]|0,0)|0)&127|0)==64&1;Fb=685;break}case 84:{c[Eb>>2]=(c[Eb>>2]|0)==(c[Kb+(Lb+1<<2)>>2]|0)&1;Fb=685;break}case 85:{c[Eb>>2]=(c[Eb>>2]|0)!=(c[Kb+(Lb+1<<2)>>2]|0)&1;Fb=685;break}case 82:{c[Eb>>2]=(c[Eb>>2]|0)>(c[Kb+(Lb+1<<2)>>2]|0)&1;Fb=685;break}case 77:{a[ba>>0]=1;Fb=685;break}case 75:{c[Eb>>2]=_ge(f)|0;Fb=685;break}case 76:{c[Eb>>2]=_ge(f)|0;Fb=685;break}case 83:{c[Eb>>2]=(c[Eb>>2]|0)>=(c[Kb+(Lb+1<<2)>>2]|0)&1;Fb=685;break}case 80:{c[Eb>>2]=(c[Eb>>2]|0)<(c[Kb+(Lb+1<<2)>>2]|0)&1;Fb=685;break}case 78:{a[ba>>0]=0;Fb=685;break}case 88:{if(!(c[Eb>>2]|0)){Nb=c[E>>2]|0;Mb=Hb+(c[z>>2]|0)|0;c[z>>2]=Mb;if((Mb|0)<(Nb|0)){Ob=Mb;Pb=1}else{Fb=435;break a}while(1){Mb=(Pb|0)==1;Qb=Ob;while(1){Rb=a[Ab+Qb>>0]|0;a[C>>0]=Rb;Sb=Rb&255;Rb=a[790536+Sb>>0]|0;c[D>>2]=Rb;if((Sb&254|0)==64){Tb=2-(da(d[Ab+(Qb+1)>>0]|0,Rb)|0)|0;c[D>>2]=Tb;Ub=Tb}else Ub=Rb;Qb=Ub+Qb|0;if((Qb|0)>(Nb|0)){Fb=435;break a}if((Sb|0)==88){Vb=Qb;Fb=438;break}else if((Sb|0)==89){Wb=Qb;Fb=440;break}else if((Sb|0)==27?Mb:0){Fb=685;break b}c[z>>2]=Qb;if((Qb|0)>=(Nb|0)){Fb=435;break a}}if((Fb|0)==438){Fb=0;Xb=Vb;Yb=Pb+1|0}else if((Fb|0)==440){Fb=0;Qb=Pb+-1|0;if(!Qb){Fb=685;break b}else{Xb=Wb;Yb=Qb}}c[z>>2]=Xb;if((Xb|0)<(Nb|0)){Ob=Xb;Pb=Yb}else{Fb=435;break a}}}else Fb=685;break}case 11:{Wge(c[Eb>>2]<<16>>16,c[Kb+(Lb+1<<2)>>2]<<16>>16,Ca);Nge(f);Fb=685;break}case 31:{c[S>>2]=c[Eb>>2]>>10;Fb=685;break}case 18:{b[ia>>1]=c[Eb>>2];Fb=685;break}case 39:{Nb=c[Eb>>2]|0;Qb=c[Kb+(Lb+1<<2)>>2]|0;Mb=Nb&65535;Sb=Qb&65535;Rb=Nb&65535;if(Rb>>>0<(e[O>>1]|0)>>>0?(Nb=Qb&65535,Nb>>>0<(e[R>>1]|0)>>>0):0){Qb=c[_>>2]|0;Tb=c[Z>>2]|0;Zb=(xo[c[aa>>2]&2047](f,(c[Qb+(Nb<<3)>>2]|0)-(c[Tb+(Rb<<3)>>2]|0)|0,(c[Qb+(Nb<<3)+4>>2]|0)-(c[Tb+(Rb<<3)+4>>2]|0)|0)|0)/2|0;Dn[c[ca>>2]&511](f,N,Mb,Zb);Dn[c[ca>>2]&511](f,Ea,Sb,0-Zb|0);Fb=685;break b}if(!(a[H>>0]|0))Fb=685;else{Fb=123;break a}break}case 12:{c[Eb>>2]=b[ua>>1];c[Kb+(Lb+1<<2)>>2]=b[va>>1];Fb=685;break}case 9:case 8:{Zb=c[Kb+(Lb+1<<2)>>2]|0;Sb=c[Eb>>2]|0;Mb=Zb&65535;if((e[za>>1]|0)>(Zb&65535)?(e[O>>1]|0)>(Sb&65535):0){Zb=Sb&65535;Sb=c[Z>>2]|0;Rb=c[Aa>>2]|0;Tb=c[Sb+(Zb<<3)>>2]|0;Nb=c[Rb+(Mb<<3)>>2]|0;Qb=c[Sb+(Zb<<3)+4>>2]|0;Zb=c[Rb+(Mb<<3)+4>>2]|0;Mb=Qb-Zb|0;Rb=(Tb|0)==(Nb|0)&(Qb|0)==(Zb|0);Zb=Rb?16384:Tb-Nb|0;Nb=Rb|(Bb&1)==0;Wge(Nb?Zb:0-Mb|0,Nb?Mb:Zb,Ca);Nge(f);Fb=685;break b}if(!(a[H>>0]|0))Fb=685;else{Fb=39;break a}break}case 41:{Zb=c[Eb>>2]&65535;if(Zb>>>0>=(e[R>>1]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=128;break a}Mb=(b[W>>1]|0)==0?-1:-9;if(!(b[Y>>1]|0))_b=Mb;else _b=Mb&239;Mb=(c[Ka>>2]|0)+Zb|0;a[Mb>>0]=a[Mb>>0]&_b;Fb=685;break}case 37:{Mb=c[Eb>>2]|0;if(!((Mb|0)<1|(Lb|0)<(Mb|0))){c[Eb>>2]=c[Kb+(Lb-Mb<<2)>>2];Fb=685;break b}if(a[H>>0]|0)c[M>>2]=134;c[Eb>>2]=0;Fb=685;break}case 40:{Xge(f);Fb=685;break}case 34:{c[J>>2]=0;Fb=685;break}case 26:{c[ea>>2]=c[Eb>>2];Fb=685;break}case 7:case 6:{Mb=c[Kb+(Lb+1<<2)>>2]|0;Zb=c[Eb>>2]|0;Nb=Mb&65535;if((e[za>>1]|0)>(Mb&65535)?(e[O>>1]|0)>(Zb&65535):0){Mb=Zb&65535;Zb=c[Z>>2]|0;Rb=c[Aa>>2]|0;Tb=c[Zb+(Mb<<3)>>2]|0;Qb=c[Rb+(Nb<<3)>>2]|0;Sb=c[Zb+(Mb<<3)+4>>2]|0;Mb=c[Rb+(Nb<<3)+4>>2]|0;Nb=Sb-Mb|0;Rb=(Tb|0)==(Qb|0)&(Sb|0)==(Mb|0);Mb=Rb?16384:Tb-Qb|0;Qb=Rb|(Bb&1)==0;Wge(Qb?Mb:0-Nb|0,Qb?Nb:Mb,ya);Mb=e[ya>>1]|e[ya+2>>1]<<16;b[Ba>>1]=Mb;b[Ba+2>>1]=Mb>>>16;Nge(f);Fb=685;break b}if(!(a[H>>0]|0))Fb=685;else{Fb=34;break a}break}case 36:{c[Eb>>2]=c[F>>2];Fb=685;break}case 19:{Mb=c[Eb>>2]|0;if((Mb|0)==1){$b=Ea+0|0;ac=Ga+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}else if(Mb)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=63;break a}else{$b=Ea+0|0;ac=Fa+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}b[fa>>1]=c[Eb>>2];Fb=685;break}case 38:{Mb=c[Eb>>2]|0;if((Mb|0)<1|(Lb|0)<(Mb|0))if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=118;break a}else{Nb=Lb-Mb|0;Qb=Kb+(Nb<<2)|0;Rb=c[Qb>>2]|0;aFi(Qb|0,Kb+(Nb+1<<2)|0,(Mb<<2)+-4|0)|0;c[(c[I>>2]|0)+((c[G>>2]|0)+-1<<2)>>2]=Rb;Fb=685;break b}break}case 24:{c[v>>2]=1;c[A>>2]=1761;Fb=685;break}case 22:{Rb=c[Eb>>2]|0;if(!Rb){$b=Ea+0|0;ac=Fa+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}else if((Rb|0)!=1)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=81;break a}else{$b=Ea+0|0;ac=Ga+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}$b=N+0|0;ac=Ea+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0));$b=Ha+0|0;ac=Ea+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0));Rb=c[Eb>>2]&65535;b[fa>>1]=Rb;b[U>>1]=Rb;b[Ia>>1]=Rb;Fb=685;break}case 27:{Rb=c[E>>2]|0;Mb=Hb;Nb=c[z>>2]|0;Qb=1;while(1){Nb=Mb+Nb|0;c[z>>2]=Nb;if((Nb|0)>=(Rb|0)){Fb=94;break a}Tb=a[Ab+Nb>>0]|0;a[C>>0]=Tb;Sb=Tb&255;Tb=a[790536+Sb>>0]|0;c[D>>2]=Tb;if((Sb&254|0)==64){Zb=2-(da(d[Ab+(Nb+1)>>0]|0,Tb)|0)|0;c[D>>2]=Zb;cc=Zb}else cc=Tb;if((cc+Nb|0)>(Rb|0)){Fb=94;break a}if((Sb|0)==89)dc=Qb+-1|0;else if((Sb|0)==88)dc=Qb+1|0;else dc=Qb;if(!dc){Fb=685;break}else{Mb=cc;Qb=dc}}break}case 25:{c[v>>2]=0;c[A>>2]=1764;Fb=685;break}case 23:{Qb=c[Eb>>2]|0;if((Qb|0)<0){Fb=84;break a}c[Ja>>2]=Qb;Fb=685;break}case 30:{c[T>>2]=c[Eb>>2];Fb=685;break}case 21:{Qb=c[Eb>>2]|0;if(!Qb){$b=Ha+0|0;ac=Fa+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}else if((Qb|0)!=1)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=75;break a}else{$b=Ha+0|0;ac=Ga+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}b[Ia>>1]=c[Eb>>2];Fb=685;break}case 32:{c[Kb+(Lb+1<<2)>>2]=c[Eb>>2];Fb=685;break}case 42:{Qb=c[Kb+(Lb+1<<2)>>2]|0;Mb=(c[La>>2]|0)+1|0;if(Qb>>>0>=Mb>>>0){Fb=151;break a}Rb=c[Ma>>2]|0;Nb=c[Na>>2]|0;if((Mb|0)==(Nb|0)?(c[Rb+(Qb<<4)+8>>2]|0)==(Qb|0):0)ec=Rb+(Qb<<4)|0;else{Mb=Rb+(Nb<<4)|0;c:do if((Nb|0)>0){Sb=Rb;while(1){Tb=Sb+16|0;if((c[Sb+8>>2]|0)==(Qb|0)){fc=Sb;break c}if(Tb>>>0<Mb>>>0)Sb=Tb;else{fc=Tb;break}}}else fc=Rb;while(0);if((fc|0)==(Mb|0)){Fb=151;break a}else ec=fc}if(!(a[ec+12>>0]|0)){Fb=151;break a}Rb=c[qa>>2]|0;if((Rb|0)>=(c[ra>>2]|0)){Fb=141;break a}if((c[Eb>>2]|0)>0){Qb=c[sa>>2]|0;c[Qb+(Rb<<4)>>2]=c[ta>>2];c[Qb+(Rb<<4)+4>>2]=(c[z>>2]|0)+1;c[Qb+(Rb<<4)+8>>2]=c[Eb>>2];Nb=c[ec+4>>2]|0;c[Qb+(Rb<<4)+12>>2]=Nb;c[qa>>2]=Rb+1;Rb=c[ec>>2]|0;Qb=Rb+-1|0;do if(Qb>>>0<=2){Sb=c[f+(Qb<<3)+444>>2]|0;if(!Sb){c[M>>2]=138;break}Tb=c[f+(Qb<<3)+448>>2]|0;if(Tb>>>0<Nb>>>0){c[M>>2]=131;break}else{c[B>>2]=Sb;c[E>>2]=Tb;c[z>>2]=Nb;c[ta>>2]=Rb;break}}else c[M>>2]=132;while(0);a[L>>0]=0;Fb=685}else Fb=685;break}case 13:{c[Eb>>2]=b[W>>1];c[Kb+(Lb+1<<2)>>2]=b[Y>>1];Fb=685;break}case 29:{c[ga>>2]=c[Eb>>2];Fb=685;break}case 14:{Rb=e[ya>>1]|e[ya+2>>1]<<16;b[Ca>>1]=Rb;b[Ca+2>>1]=Rb>>>16;Nge(f);Fb=685;break}case 16:{b[Q>>1]=c[Eb>>2];Fb=685;break}case 20:{Rb=c[Eb>>2]|0;if((Rb|0)==1){$b=N+0|0;ac=Ga+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}else if(Rb)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=69;break a}else{$b=N+0|0;ac=Fa+0|0;bc=$b+36|0;do{c[$b>>2]=c[ac>>2];$b=$b+4|0;ac=ac+4|0}while(($b|0)<(bc|0))}b[U>>1]=c[Eb>>2];Fb=685;break}case 15:{Rb=c[Eb>>2]|0;Nb=c[Kb+(Lb+1<<2)>>2]|0;Qb=c[Kb+(Lb+2<<2)>>2]|0;Mb=c[Kb+(Lb+3<<2)>>2]&65535;Tb=e[R>>1]|0;if((((Mb>>>0<Tb>>>0?(Sb=c[Kb+(Lb+4<<2)>>2]&65535,Sb>>>0<Tb>>>0):0)?(Tb=Nb&65535,Nb=e[O>>1]|0,Tb>>>0<Nb>>>0):0)?(Zb=Qb&65535,Zb>>>0<Nb>>>0):0)?(Nb=Rb&65535,Nb>>>0<(e[za>>1]|0)>>>0):0){Rb=c[_>>2]|0;Qb=c[Rb+(Mb<<3)>>2]|0;gc=(c[Rb+(Sb<<3)>>2]|0)-Qb|0;hc=c[Rb+(Sb<<3)+4>>2]|0;ic=c[Rb+(Mb<<3)+4>>2]|0;Rb=c[Z>>2]|0;jc=c[Rb+(Tb<<3)>>2]|0;kc=(c[Rb+(Zb<<3)>>2]|0)-jc|0;lc=c[Rb+(Tb<<3)+4>>2]|0;mc=(c[Rb+(Zb<<3)+4>>2]|0)-lc|0;Rb=(c[Da>>2]|0)+Nb|0;a[Rb>>0]=d[Rb>>0]|24;Rb=ic-hc|0;hc=I8d(kc,Rb,64)|0;nc=(I8d(mc,gc,64)|0)+hc|0;if((((nc|0)<0?0-nc|0:nc)|0)>63){hc=I8d(Qb-jc|0,Rb,64)|0;Rb=(I8d(ic-lc|0,gc,64)|0)+hc|0;hc=I8d(Rb,kc,nc)|0;kc=I8d(Rb,mc,nc)|0;nc=c[Z>>2]|0;mc=c[Aa>>2]|0;c[mc+(Nb<<3)>>2]=(c[nc+(Tb<<3)>>2]|0)+hc;c[mc+(Nb<<3)+4>>2]=(c[nc+(Tb<<3)+4>>2]|0)+kc;Fb=685;break b}else{kc=c[Z>>2]|0;nc=c[_>>2]|0;mc=c[Aa>>2]|0;c[mc+(Nb<<3)>>2]=((c[kc+(Zb<<3)>>2]|0)+(c[kc+(Tb<<3)>>2]|0)+(c[nc+(Mb<<3)>>2]|0)+(c[nc+(Sb<<3)>>2]|0)|0)/4|0;c[mc+(Nb<<3)+4>>2]=((c[kc+(Zb<<3)+4>>2]|0)+(c[kc+(Tb<<3)+4>>2]|0)+(c[nc+(Mb<<3)+4>>2]|0)+(c[nc+(Sb<<3)+4>>2]|0)|0)/4|0;Fb=685;break b}}if(!(a[H>>0]|0))Fb=685;else{Fb=52;break a}break}case 5:case 4:case 3:case 2:case 1:case 0:{Sb=Cb<<14&16384;nc=Sb&65535;Mb=(Sb^16384)&65535;if((Bb&255)<4){b[ua>>1]=nc;b[va>>1]=Mb;b[wa>>1]=nc;b[xa>>1]=Mb}if(!(Cb&2)){b[W>>1]=nc;b[Y>>1]=Mb}Nge(f);Fb=685;break}case 66:{Mb=c[Eb>>2]|0;if(Mb>>>0>=(e[gb>>1]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=379;break a}else{c[(c[hb>>2]|0)+(Mb<<2)>>2]=c[Kb+(Lb+1<<2)>>2];Fb=685;break b}break}case 64:{Mb=c[z>>2]|0;nc=a[Ab+(Mb+1)>>0]|0;Sb=nc&255;if(Sb>>>0>=(Jb+1-(c[F>>2]|0)|0)>>>0){Fb=367;break a}if(nc<<24>>24!=0?(Tb=Lb+-1|0,c[Eb>>2]=d[Ab+(Mb+2)>>0],(nc&255)>=2):0){nc=2;Mb=2;do{Mb=Mb+1<<16>>16;c[Kb+(Tb+nc<<2)>>2]=d[Ab+((c[z>>2]|0)+1+nc)>>0];nc=Mb&65535}while(nc>>>0<=Sb>>>0)}c[J>>2]=Gb+Sb;Fb=685;break}case 65:{nc=c[z>>2]|0;Mb=a[Ab+(nc+1)>>0]|0;Tb=Mb&255;if(Tb>>>0>=(Jb+1-(c[F>>2]|0)|0)>>>0){Fb=371;break a}kc=nc+2|0;c[z>>2]=kc;d:do if(Mb<<24>>24){nc=kc;Zb=0;Nb=1;while(1){c[z>>2]=nc+2;c[Kb+(Zb+Lb<<2)>>2]=(d[Ab+nc>>0]<<8|d[Ab+(nc+1)>>0])<<16>>16;mc=Nb&65535;if(mc>>>0>=Tb>>>0)break d;nc=c[z>>2]|0;Zb=mc;Nb=Nb+1<<16>>16}}while(0);a[L>>0]=0;c[J>>2]=Gb+Tb;Fb=685;break}case 67:{kc=c[Eb>>2]|0;if(kc>>>0<(e[gb>>1]|0)>>>0){c[Eb>>2]=c[(c[hb>>2]|0)+(kc<<2)>>2];Fb=685;break b}if(a[H>>0]|0){Fb=379;break a}c[Eb>>2]=0;Fb=685;break}case 68:{kc=c[Eb>>2]|0;if(kc>>>0>=(c[P>>2]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=379;break a}else{co[c[x>>2]&2047](f,kc,c[Kb+(Lb+1<<2)>>2]|0);Fb=685;break b}break}case 71:case 70:{kc=c[Eb>>2]|0;do if(kc>>>0<(e[za>>1]|0)>>>0)if(!(Bb&1)){Mb=c[Aa>>2]|0;oc=xo[c[aa>>2]&2047](f,c[Mb+(kc<<3)>>2]|0,c[Mb+(kc<<3)+4>>2]|0)|0;break}else{Mb=c[db>>2]|0;oc=xo[c[$>>2]&2047](f,c[Mb+(kc<<3)>>2]|0,c[Mb+(kc<<3)+4>>2]|0)|0;break}else if(!(a[H>>0]|0))oc=0;else{c[M>>2]=134;oc=0}while(0);c[Eb>>2]=oc;Fb=685;break}case 69:{kc=c[Eb>>2]|0;if(kc>>>0<(c[P>>2]|0)>>>0){c[Eb>>2]=_n[c[w>>2]&4095](f,kc)|0;Fb=685;break b}if(a[H>>0]|0){Fb=379;break a}c[Eb>>2]=0;Fb=685;break}case 74:case 73:{kc=c[Eb>>2]&65535;do if(kc>>>0<(e[R>>1]|0)>>>0?(Tb=c[Kb+(Lb+1<<2)>>2]&65535,Tb>>>0<(e[O>>1]|0)>>>0):0){if(Bb&1){Mb=c[_>>2]|0;Sb=c[Z>>2]|0;pc=xo[c[aa>>2]&2047](f,(c[Mb+(kc<<3)>>2]|0)-(c[Sb+(Tb<<3)>>2]|0)|0,(c[Mb+(kc<<3)+4>>2]|0)-(c[Sb+(Tb<<3)+4>>2]|0)|0)|0;break}if((b[fa>>1]|0)!=0?(b[U>>1]|0)!=0:0){Sb=c[ka>>2]|0;Mb=c[ja>>2]|0;Nb=c[la>>2]|0;Zb=c[Sb+(kc<<3)>>2]|0;nc=c[Mb+(Tb<<3)>>2]|0;if((Nb|0)==(c[ma>>2]|0)){mc=xo[c[$>>2]&2047](f,Zb-nc|0,(c[Sb+(kc<<3)+4>>2]|0)-(c[Mb+(Tb<<3)+4>>2]|0)|0)|0;pc=K8d(mc,c[la>>2]|0)|0;break}else{mc=K8d(Zb-nc|0,Nb)|0;Nb=K8d((c[Sb+(kc<<3)+4>>2]|0)-(c[Mb+(Tb<<3)+4>>2]|0)|0,c[ma>>2]|0)|0;pc=xo[c[$>>2]&2047](f,mc,Nb)|0;break}}Nb=c[V>>2]|0;mc=c[X>>2]|0;pc=xo[c[$>>2]&2047](f,(c[Nb+(kc<<3)>>2]|0)-(c[mc+(Tb<<3)>>2]|0)|0,(c[Nb+(kc<<3)+4>>2]|0)-(c[mc+(Tb<<3)+4>>2]|0)|0)|0}else Fb=405;while(0);if((Fb|0)==405){Fb=0;if(!(a[H>>0]|0))pc=0;else{c[M>>2]=134;pc=0}}c[Eb>>2]=pc;Fb=685;break}case 44:{kc=c[Eb>>2]|0;Tb=c[Ma>>2]|0;mc=c[Na>>2]|0;Nb=Tb+(mc<<4)|0;e:do if((mc|0)>0){Mb=Tb;while(1){Sb=Mb+16|0;if((c[Mb+8>>2]|0)==(kc|0)){qc=Mb;break e}if(Sb>>>0<Nb>>>0)Mb=Sb;else{qc=Sb;break}}}else qc=Tb;while(0);if((qc|0)==(Nb|0)){if(mc>>>0>=(c[Oa>>2]|0)>>>0){Fb=176;break a}c[Na>>2]=mc+1}if(kc>>>0>65535){Fb=179;break a}c[qc>>2]=c[ta>>2];Tb=kc&65535;c[qc+8>>2]=Tb;Mb=c[z>>2]|0;c[qc+4>>2]=Mb+1;a[qc+12>>0]=1;if((c[La>>2]|0)>>>0<kc>>>0)c[La>>2]=Tb;Tb=c[E>>2]|0;Sb=Hb;nc=Mb;while(1){Mb=Sb+nc|0;c[z>>2]=Mb;if((Mb|0)>=(Tb|0)){Fb=187;break a}Zb=a[Ab+Mb>>0]|0;a[C>>0]=Zb;hc=Zb&255;Zb=a[790536+hc>>0]|0;c[D>>2]=Zb;if((hc&254|0)==64){Rb=2-(da(d[Ab+(Mb+1)>>0]|0,Zb)|0)|0;c[D>>2]=Rb;rc=Rb}else rc=Zb;if((rc+Mb|0)>(Tb|0)){Fb=187;break a}if((hc|0)==44|(hc|0)==137){Fb=189;break a}else if((hc|0)==45){Fb=685;break}else{Sb=rc;nc=Mb}}break}case 45:{nc=c[qa>>2]|0;if((nc|0)<1){Fb=191;break a}Sb=nc+-1|0;c[qa>>2]=Sb;Tb=c[sa>>2]|0;kc=Tb+(Sb<<4)+8|0;mc=(c[kc>>2]|0)+-1|0;c[kc>>2]=mc;a[L>>0]=0;if((mc|0)>0){c[qa>>2]=nc;c[z>>2]=c[Tb+(Sb<<4)+12>>2];Fb=685;break b}nc=c[Tb+(Sb<<4)>>2]|0;mc=c[Tb+(Sb<<4)+4>>2]|0;Sb=nc+-1|0;if(Sb>>>0>2){Fb=195;break a}Tb=c[f+(Sb<<3)+444>>2]|0;if(!Tb){Fb=197;break a}kc=c[f+(Sb<<3)+448>>2]|0;if(kc>>>0<mc>>>0){Fb=199;break a}c[B>>2]=Tb;c[E>>2]=kc;c[z>>2]=mc;c[ta>>2]=nc;Fb=685;break}case 47:case 46:{nc=c[Eb>>2]|0;mc=nc&65535;kc=nc&65535;if(kc>>>0>=(e[R>>1]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=203;break a}if(!(Bb&1))sc=0;else{nc=c[_>>2]|0;Tb=xo[c[aa>>2]&2047](f,c[nc+(kc<<3)>>2]|0,c[nc+(kc<<3)+4>>2]|0)|0;sc=(xo[c[A>>2]&2047](f,Tb,c[Pa>>2]|0)|0)-Tb|0}Dn[c[ca>>2]&511](f,Ea,mc,sc);b[Q>>1]=mc;b[ha>>1]=mc;Fb=685;break}case 49:case 48:{if(!(b[Qa>>1]|0))Fb=685;else{mc=c[Ra>>2]|0;if(!(Bb&1)){Tb=mc+4|0;c[u>>2]=Tb;kc=(c[Sa>>2]|0)+4|0;c[Ta>>2]=kc;tc=(c[Ua>>2]|0)+4|0;uc=Tb;vc=kc;wc=16}else{c[u>>2]=mc;kc=c[Sa>>2]|0;c[Ta>>2]=kc;tc=c[Ua>>2]|0;uc=mc;vc=kc;wc=8}c[Va>>2]=tc;kc=b[Wa>>1]|0;c[Xa>>2]=kc&65535;mc=kc;kc=0;Tb=0;while(1){nc=(e[(c[Ya>>2]|0)+(kc<<16>>16<<1)>>1]|0)-(e[Za>>1]|0)|0;Sb=mc&65535;Nb=nc>>>0<Sb>>>0?nc:Sb+-1|0;f:do if(Tb>>>0<=Nb>>>0){Sb=c[_a>>2]|0;nc=Tb;while(1){Mb=nc+1|0;if((a[Sb+nc>>0]&wc)<<24>>24){xc=Mb;yc=nc;break}if(Mb>>>0>Nb>>>0){zc=Mb;break f}else nc=Mb}nc=yc;g:while(1){Sb=nc;while(1){Mb=Sb+1|0;if(Mb>>>0>Nb>>>0){Ac=nc;Bc=Mb;break g}if(!((a[(c[_a>>2]|0)+Mb>>0]&wc)<<24>>24))Sb=Mb;else{Cc=Mb;Dc=Sb;break}}Yge(u,nc+1|0,Dc,nc,Cc);nc=Cc}if((Ac|0)!=(yc|0)){Yge(u,Ac+1&65535,Nb,Ac,yc);if(!yc){zc=Bc;break}Yge(u,Tb,yc+-1|0,Ac,yc);zc=Bc;break}nc=c[vc+(yc<<3)>>2]|0;Sb=c[uc+(yc<<3)>>2]|0;Mb=nc-Sb|0;if((nc|0)!=(Sb|0)){if(Tb>>>0<yc>>>0){Sb=Tb;do{nc=vc+(Sb<<3)|0;c[nc>>2]=(c[nc>>2]|0)+Mb;Sb=Sb+1|0}while((Sb|0)!=(yc|0))}if(xc>>>0<=Nb>>>0){Sb=xc;do{nc=vc+(Sb<<3)|0;c[nc>>2]=(c[nc>>2]|0)+Mb;Sb=Sb+1|0}while(Sb>>>0<=Nb>>>0);zc=Bc}else zc=Bc}else zc=Bc}else zc=Tb;while(0);Nb=kc+1<<16>>16;if(Nb<<16>>16>=(b[Qa>>1]|0)){Fb=685;break b}mc=b[Wa>>1]|0;kc=Nb;Tb=zc}}break}case 51:case 50:{if((c[F>>2]|0)<(c[Ja>>2]|0)){if(a[H>>0]|0)c[M>>2]=134}else{if((Zge(f,s,t,q,r)|0)<<24>>24){Fb=685;break b}if((c[Ja>>2]|0)>0){Tb=c[t>>2]|0;kc=c[s>>2]|0;do{mc=(c[G>>2]|0)+-1|0;c[G>>2]=mc;Nb=c[(c[I>>2]|0)+(mc<<2)>>2]&65535;if(Nb>>>0<(e[za>>1]|0)>>>0){if(b[W>>1]|0){mc=(c[Aa>>2]|0)+(Nb<<3)|0;c[mc>>2]=(c[mc>>2]|0)+kc;mc=(c[Da>>2]|0)+Nb|0;a[mc>>0]=d[mc>>0]|8}if(b[Y>>1]|0){mc=(c[Aa>>2]|0)+(Nb<<3)+4|0;c[mc>>2]=(c[mc>>2]|0)+Tb;mc=(c[Da>>2]|0)+Nb|0;a[mc>>0]=d[mc>>0]|16}}else if(a[H>>0]|0){Fb=239;break a}mc=(c[Ja>>2]|0)+-1|0;c[Ja>>2]=mc}while((mc|0)>0)}}c[Ja>>2]=1;c[J>>2]=c[G>>2];Fb=685;break}case 53:case 52:{Tb=c[Eb>>2]<<16>>16;if(Tb>>>0>=(b[Qa>>1]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=248;break a}if(!((Zge(f,o,p,m,n)|0)<<24>>24)){if(!Tb){Ec=c[Ya>>2]|0;Fc=b[Za>>1]|0;Gc=0}else{kc=c[Ya>>2]|0;mc=b[Za>>1]|0;Ec=kc;Fc=mc;Gc=(e[kc+(Tb+-1<<1)>>1]|0)+1-(mc&65535)&65535}mc=(e[Ec+(Tb<<1)>>1]|0)-(Fc&65535)|0;Tb=b[za>>1]|0;kc=Tb&65535;if((mc&65535)>>>0<kc>>>0)Hc=mc;else Hc=Tb<<16>>16==0?0:kc+-1|0;kc=Gc&65535;Tb=Hc&65535;if(kc>>>0<=Tb>>>0){mc=c[$a>>2]|0;Nb=b[n>>1]|0;Sb=c[p>>2]|0;Mb=c[o>>2]|0;nc=kc;kc=Gc;do{hc=c[Aa>>2]|0;if(!((mc|0)==(hc|0)?Nb<<16>>16==kc<<16>>16:0)){if(b[W>>1]|0){Zb=hc+(nc<<3)|0;c[Zb>>2]=(c[Zb>>2]|0)+Mb;Zb=(c[Da>>2]|0)+nc|0;a[Zb>>0]=d[Zb>>0]|8}if(b[Y>>1]|0){Zb=(c[Aa>>2]|0)+(nc<<3)+4|0;c[Zb>>2]=(c[Zb>>2]|0)+Sb;Zb=(c[Da>>2]|0)+nc|0;a[Zb>>0]=d[Zb>>0]|16}}kc=kc+1<<16>>16;nc=kc&65535}while(nc>>>0<=Tb>>>0);Fb=685}else Fb=685}else Fb=685;break}case 55:case 54:{if((c[Eb>>2]|0)>>>0>1)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=265;break a}if(!((Zge(f,k,l,h,j)|0)<<24>>24)){Tb=b[Ia>>1]|0;if(!(Tb<<16>>16)){nc=b[za>>1]|0;if(!(nc<<16>>16))Ic=0;else Ic=(nc&65535)+65535&65535}else if(Tb<<16>>16==1?(Tb=b[bb>>1]|0,Tb<<16>>16>0):0){nc=b[(c[cb>>2]|0)+((Tb<<16>>16)+-1<<1)>>1]|0;if((nc&65535)>=(e[za>>1]|0))if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=273;break a}else Ic=nc}else Ic=0;nc=c[ab>>2]|0;Tb=c[Aa>>2]|0;kc=b[j>>1]|0;Sb=c[l>>2]|0;Mb=c[k>>2]|0;if((nc|0)==(Tb|0)){Nb=0;while(1){if(kc<<16>>16!=Nb<<16>>16){if(b[W>>1]|0){mc=nc+((Nb&65535)<<3)|0;c[mc>>2]=(c[mc>>2]|0)+Mb}if(b[Y>>1]|0){mc=nc+((Nb&65535)<<3)+4|0;c[mc>>2]=(c[mc>>2]|0)+Sb}}Nb=Nb+1<<16>>16;if((Nb&65535)>(Ic&65535)){Fb=685;break b}}}Nb=(b[Y>>1]|0)==0;if(!(b[W>>1]|0)){nc=0;do{if(!Nb){kc=Tb+((nc&65535)<<3)+4|0;c[kc>>2]=(c[kc>>2]|0)+Sb}nc=nc+1<<16>>16}while((nc&65535)<=(Ic&65535));Fb=685}else{nc=0;do{kc=Tb+((nc&65535)<<3)|0;c[kc>>2]=(c[kc>>2]|0)+Mb;if(!Nb){kc=Tb+((nc&65535)<<3)+4|0;c[kc>>2]=(c[kc>>2]|0)+Sb}nc=nc+1<<16>>16}while((nc&65535)<=(Ic&65535));Fb=685}}else Fb=685;break}case 56:{nc=c[Ja>>2]|0;h:do if((c[F>>2]|0)<(nc+1|0))if(!(a[H>>0]|0))Jc=Lb;else{c[M>>2]=134;Jc=Lb}else{Sb=c[Eb>>2]|0;Tb=b[W>>1]|0;Nb=Tb<<16>>16;Mb=(Sb|0)<0?0-Sb|0:Sb;kc=Tb<<16>>16<0?0-Nb|0:Nb;Tb=Mb>>>16;mc=Mb&65535;Mb=da(mc,kc)|0;Zb=da(Tb,kc)|0;kc=Mb+(Zb<<16|8192)|0;hc=(Zb>>>16)+(kc>>>0<Mb>>>0&1)<<18|kc>>>14;kc=(Nb^Sb|0)>-1?hc:0-hc|0;hc=b[Y>>1]|0;Nb=hc<<16>>16;Mb=hc<<16>>16<0?0-Nb|0:Nb;hc=da(Mb,mc)|0;mc=da(Mb,Tb)|0;Tb=hc+(mc<<16|8192)|0;Mb=(mc>>>16)+(Tb>>>0<hc>>>0&1)<<18|Tb>>>14;Tb=(Nb^Sb|0)>-1?Mb:0-Mb|0;if((nc|0)>0){Mb=Lb;Sb=Kb;while(1){Nb=Mb+-1|0;c[G>>2]=Nb;hc=c[Sb+(Nb<<2)>>2]&65535;if(hc>>>0<(e[za>>1]|0)>>>0){if(b[W>>1]|0){Nb=(c[Aa>>2]|0)+(hc<<3)|0;c[Nb>>2]=(c[Nb>>2]|0)+kc;Nb=(c[Da>>2]|0)+hc|0;a[Nb>>0]=d[Nb>>0]|8}if(b[Y>>1]|0){Nb=(c[Aa>>2]|0)+(hc<<3)+4|0;c[Nb>>2]=(c[Nb>>2]|0)+Tb;Nb=(c[Da>>2]|0)+hc|0;a[Nb>>0]=d[Nb>>0]|16}}else if(a[H>>0]|0){Fb=294;break a}Nb=(c[Ja>>2]|0)+-1|0;c[Ja>>2]=Nb;hc=c[G>>2]|0;if((Nb|0)<=0){Jc=hc;break h}Mb=hc;Sb=c[I>>2]|0}}else Jc=Lb}while(0);c[Ja>>2]=1;c[J>>2]=Jc;Fb=685;break}case 57:{nc=c[Ja>>2]|0;do if((c[F>>2]|0)<(nc|0)){if(a[H>>0]|0)c[M>>2]=134}else{if((b[fa>>1]|0)!=0?(b[U>>1]|0)!=0:0)Kc=(b[Ia>>1]|0)==0;else Kc=1;Sb=b[ha>>1]|0;Mb=Sb&65535;if((Sb&65535)>=(e[R>>1]|0)){if(!(a[H>>0]|0))break;c[M>>2]=134;break}Sb=c[(Kc?V:ka)>>2]|0;Tb=Sb+(Mb<<3)|0;kc=c[_>>2]|0;hc=kc+(Mb<<3)|0;Nb=b[ia>>1]|0;mc=Nb&65535;if((Nb&65535)<(e[O>>1]|0)){Nb=c[$>>2]|0;Zb=c[Tb>>2]|0;Rb=c[Sb+(Mb<<3)+4>>2]|0;if(Kc){gc=c[X>>2]|0;Lc=xo[Nb&2047](f,(c[gc+(mc<<3)>>2]|0)-Zb|0,(c[gc+(mc<<3)+4>>2]|0)-Rb|0)|0}else{gc=c[ja>>2]|0;Lc=xo[Nb&2047](f,(c[gc+(mc<<3)>>2]|0)-Zb|0,(c[gc+(mc<<3)+4>>2]|0)-Rb|0)|0}Rb=e[ia>>1]|0;mc=c[Z>>2]|0;gc=xo[c[aa>>2]&2047](f,(c[mc+(Rb<<3)>>2]|0)-(c[hc>>2]|0)|0,(c[mc+(Rb<<3)+4>>2]|0)-(c[kc+(Mb<<3)+4>>2]|0)|0)|0;Mc=c[Ja>>2]|0;Nc=gc;Oc=Lc}else{Mc=nc;Nc=0;Oc=0}if((Mc|0)>0){gc=Sb+(Mb<<3)+4|0;Sb=kc+(Mb<<3)+4|0;Mb=(Oc|0)==0;if(Kc){kc=Mc;do{Rb=(c[G>>2]|0)+-1|0;c[G>>2]=Rb;mc=c[(c[I>>2]|0)+(Rb<<2)>>2]|0;if(mc>>>0>=(e[za>>1]|0)>>>0)if(!(a[H>>0]|0))Pc=kc;else{Fb=326;break a}else{Rb=c[db>>2]|0;Zb=xo[c[$>>2]&2047](f,(c[Rb+(mc<<3)>>2]|0)-(c[Tb>>2]|0)|0,(c[Rb+(mc<<3)+4>>2]|0)-(c[gc>>2]|0)|0)|0;Rb=c[Aa>>2]|0;Nb=xo[c[aa>>2]&2047](f,(c[Rb+(mc<<3)>>2]|0)-(c[hc>>2]|0)|0,(c[Rb+(mc<<3)+4>>2]|0)-(c[Sb>>2]|0)|0)|0;Rb=(Zb|0)==0;if(Rb|Mb)Qc=Rb?0:Nb;else Qc=I8d(Zb,Nc,Oc)|0;Dn[c[ca>>2]&511](f,Ha,mc&65535,Qc-Nb|0);Pc=c[Ja>>2]|0}kc=Pc+-1|0;c[Ja>>2]=kc}while((kc|0)>0)}else{kc=Mc;do{Nb=(c[G>>2]|0)+-1|0;c[G>>2]=Nb;mc=c[(c[I>>2]|0)+(Nb<<2)>>2]|0;if(mc>>>0>=(e[za>>1]|0)>>>0)if(!(a[H>>0]|0))Rc=kc;else{Fb=326;break a}else{Nb=c[eb>>2]|0;Zb=xo[c[$>>2]&2047](f,(c[Nb+(mc<<3)>>2]|0)-(c[Tb>>2]|0)|0,(c[Nb+(mc<<3)+4>>2]|0)-(c[gc>>2]|0)|0)|0;Nb=c[Aa>>2]|0;Rb=xo[c[aa>>2]&2047](f,(c[Nb+(mc<<3)>>2]|0)-(c[hc>>2]|0)|0,(c[Nb+(mc<<3)+4>>2]|0)-(c[Sb>>2]|0)|0)|0;Nb=(Zb|0)==0;if(Nb|Mb)Sc=Nb?0:Rb;else Sc=I8d(Zb,Nc,Oc)|0;Dn[c[ca>>2]&511](f,Ha,mc&65535,Sc-Rb|0);Rc=c[Ja>>2]|0}kc=Rc+-1|0;c[Ja>>2]=kc}while((kc|0)>0)}}}while(0);c[Ja>>2]=1;c[J>>2]=c[G>>2];Fb=685;break}case 59:case 58:{nc=c[Eb>>2]|0;kc=nc&65535;Mb=nc&65535;if(Mb>>>0<(e[O>>1]|0)>>>0?(nc=b[Q>>1]|0,Sb=nc&65535,(nc&65535)<(e[R>>1]|0)):0){if(!(b[U>>1]|0)){hc=(c[V>>2]|0)+(Sb<<3)|0;Sb=c[hc+4>>2]|0;gc=(c[X>>2]|0)+(Mb<<3)|0;c[gc>>2]=c[hc>>2];c[gc+4>>2]=Sb;Sb=Kb+(Lb+1<<2)|0;Dn[c[fb>>2]&511](f,N,kc,c[Sb>>2]|0);gc=(c[X>>2]|0)+(Mb<<3)|0;hc=c[gc+4>>2]|0;Tb=(c[Z>>2]|0)+(Mb<<3)|0;c[Tb>>2]=c[gc>>2];c[Tb+4>>2]=hc;Tc=Sb;Uc=b[Q>>1]|0}else{Tc=Kb+(Lb+1<<2)|0;Uc=nc}nc=c[Z>>2]|0;Sb=c[_>>2]|0;hc=Uc&65535;Tb=xo[c[aa>>2]&2047](f,(c[nc+(Mb<<3)>>2]|0)-(c[Sb+(hc<<3)>>2]|0)|0,(c[nc+(Mb<<3)+4>>2]|0)-(c[Sb+(hc<<3)+4>>2]|0)|0)|0;Dn[c[ca>>2]&511](f,N,kc,(c[Tc>>2]|0)-Tb|0);b[ha>>1]=b[Q>>1]|0;b[ia>>1]=kc;if(!(a[C>>0]&1)){Fb=685;break b}b[Q>>1]=kc;Fb=685;break b}if(!(a[H>>0]|0))Fb=685;else{Fb=335;break a}break}case 60:{kc=c[Ja>>2]|0;i:do if((c[F>>2]|0)>=(kc|0)?(e[Q>>1]|0)<(e[R>>1]|0):0)if((kc|0)>0){Tb=Lb;hc=Kb;Sb=kc;while(1){Mb=Tb+-1|0;c[G>>2]=Mb;nc=c[hc+(Mb<<2)>>2]|0;Mb=nc&65535;if(Mb>>>0>=(e[O>>1]|0)>>>0)if(!(a[H>>0]|0))Vc=Sb;else{Fb=348;break a}else{gc=c[Z>>2]|0;Rb=c[_>>2]|0;mc=e[Q>>1]|0;Zb=xo[c[aa>>2]&2047](f,(c[gc+(Mb<<3)>>2]|0)-(c[Rb+(mc<<3)>>2]|0)|0,(c[gc+(Mb<<3)+4>>2]|0)-(c[Rb+(mc<<3)+4>>2]|0)|0)|0;Dn[c[ca>>2]&511](f,N,nc&65535,0-Zb|0);Vc=c[Ja>>2]|0}Zb=Vc+-1|0;c[Ja>>2]=Zb;nc=c[G>>2]|0;if((Zb|0)<=0){Wc=nc;break i}Tb=nc;hc=c[I>>2]|0;Sb=Zb}}else Wc=Lb;else Fb=343;while(0);if((Fb|0)==343){Fb=0;if(!(a[H>>0]|0))Wc=Lb;else{c[M>>2]=134;Wc=Lb}}c[Ja>>2]=1;c[J>>2]=Wc;Fb=685;break}case 61:{c[v>>2]=2;c[A>>2]=1765;Fb=685;break}case 63:case 62:{kc=c[Eb>>2]|0;Sb=c[Kb+(Lb+1<<2)>>2]|0;hc=kc&65535;Tb=kc&65535;if(Tb>>>0<(e[R>>1]|0)>>>0?(c[P>>2]|0)>>>0>Sb>>>0:0){kc=_n[c[w>>2]&4095](f,Sb)|0;if(!(b[fa>>1]|0)){Sb=b[W>>1]|0;Zb=Sb<<16>>16;nc=(kc|0)<0?0-kc|0:kc;mc=Sb<<16>>16<0?0-Zb|0:Zb;Sb=nc>>>16;Rb=nc&65535;nc=da(mc,Rb)|0;Mb=da(mc,Sb)|0;mc=nc+(Mb<<16|8192)|0;gc=(Mb>>>16)+(mc>>>0<nc>>>0&1)<<18|mc>>>14;mc=c[V>>2]|0;c[mc+(Tb<<3)>>2]=(Zb^kc|0)>-1?gc:0-gc|0;gc=b[Y>>1]|0;Zb=gc<<16>>16;nc=gc<<16>>16<0?0-Zb|0:Zb;gc=da(nc,Rb)|0;Rb=da(nc,Sb)|0;Sb=gc+(Rb<<16|8192)|0;nc=(Rb>>>16)+(Sb>>>0<gc>>>0&1)<<18|Sb>>>14;c[mc+(Tb<<3)+4>>2]=(Zb^kc|0)>-1?nc:0-nc|0;nc=mc+(Tb<<3)|0;mc=c[nc+4>>2]|0;Zb=(c[_>>2]|0)+(Tb<<3)|0;c[Zb>>2]=c[nc>>2];c[Zb+4>>2]=mc}mc=c[_>>2]|0;Zb=xo[c[aa>>2]&2047](f,c[mc+(Tb<<3)>>2]|0,c[mc+(Tb<<3)+4>>2]|0)|0;if(!(a[C>>0]&1))Xc=kc;else{Tb=kc-Zb|0;Xc=xo[c[A>>2]&2047](f,(((Tb|0)<0?0-Tb|0:Tb)|0)>(c[ga>>2]|0)?Zb:kc,c[Pa>>2]|0)|0}Dn[c[ca>>2]&511](f,Ea,hc,Xc-Zb|0)}else Fb=356;if((Fb|0)==356?(Fb=0,(a[H>>0]|0)!=0):0)c[M>>2]=134;b[Q>>1]=hc;b[ha>>1]=hc;Fb=685;break}case 10:{Wge(c[Eb>>2]<<16>>16,c[Kb+(Lb+1<<2)>>2]<<16>>16,ya);hc=e[ya>>1]|e[ya+2>>1]<<16;b[Ba>>1]=hc;b[Ba+2>>1]=hc>>>16;Nge(f);Fb=685;break}case 43:{hc=c[Eb>>2]|0;Zb=(c[La>>2]|0)+1|0;if(Zb>>>0<=hc>>>0){Fb=170;break a}kc=c[Ma>>2]|0;Tb=c[Na>>2]|0;if((Zb|0)==(Tb|0)?(c[kc+(hc<<4)+8>>2]|0)==(hc|0):0)Yc=kc+(hc<<4)|0;else{Zb=kc+(Tb<<4)|0;j:do if((Tb|0)>0){mc=kc;while(1){nc=mc+16|0;if((c[mc+8>>2]|0)==(hc|0)){Zc=mc;break j}if(nc>>>0<Zb>>>0)mc=nc;else{Zc=nc;break}}}else Zc=kc;while(0);if((Zc|0)==(Zb|0)){Fb=170;break a}else Yc=Zc}if(!(a[Yc+12>>0]|0)){Fb=170;break a}kc=c[qa>>2]|0;if((kc|0)>=(c[ra>>2]|0)){Fb=161;break a}hc=c[sa>>2]|0;c[hc+(kc<<4)>>2]=c[ta>>2];c[hc+(kc<<4)+4>>2]=(c[z>>2]|0)+1;c[hc+(kc<<4)+8>>2]=1;Tb=c[Yc+4>>2]|0;c[hc+(kc<<4)+12>>2]=Tb;c[qa>>2]=kc+1;kc=c[Yc>>2]|0;hc=kc+-1|0;do if(hc>>>0<=2){mc=c[f+(hc<<3)+444>>2]|0;if(!mc){c[M>>2]=138;break}nc=c[f+(hc<<3)+448>>2]|0;if(nc>>>0<Tb>>>0){c[M>>2]=131;break}else{c[B>>2]=mc;c[E>>2]=nc;c[z>>2]=Tb;c[ta>>2]=kc;break}}else c[M>>2]=132;while(0);a[L>>0]=0;Fb=685;break}case 79:{Fb=420;break a;break}case 81:{c[Eb>>2]=(c[Eb>>2]|0)<=(c[Kb+(Lb+1<<2)>>2]|0)&1;Fb=685;break}case 90:{if(!(c[Eb>>2]|0))_c=0;else _c=(c[Kb+(Lb+1<<2)>>2]|0)!=0;c[Eb>>2]=_c&1;Fb=685;break}case 101:{c[Eb>>2]=0-(c[Eb>>2]|0);Fb=685;break}case 99:{c[Eb>>2]=I8d(c[Eb>>2]|0,c[Kb+(Lb+1<<2)>>2]|0,64)|0;Fb=685;break}case 137:{kc=c[oa>>2]|0;Tb=c[pa>>2]|0;hc=kc+(Tb<<4)|0;k:do if((Tb|0)>0){Zb=c[Eb>>2]|0;nc=kc;while(1){mc=nc+16|0;if((c[nc+8>>2]|0)==(Zb|0)){$c=nc;break k}if(mc>>>0<hc>>>0)nc=mc;else{$c=mc;break}}}else $c=kc;while(0);if(($c|0)==(hc|0)){if(Tb>>>0>=(c[ub>>2]|0)>>>0){Fb=592;break a}c[pa>>2]=Tb+1}kc=c[Eb>>2]|0;if(kc>>>0>255){Fb=595;break a}c[$c+8>>2]=kc&255;kc=c[z>>2]|0;c[$c+4>>2]=kc+1;c[$c>>2]=c[ta>>2];a[$c+12>>0]=1;nc=c[Eb>>2]|0;if(nc>>>0>(c[vb>>2]|0)>>>0)c[vb>>2]=nc&255;nc=c[E>>2]|0;Zb=Hb;mc=kc;while(1){kc=Zb+mc|0;c[z>>2]=kc;if((kc|0)>=(nc|0)){Fb=603;break a}Sb=a[Ab+kc>>0]|0;a[C>>0]=Sb;gc=Sb&255;Sb=a[790536+gc>>0]|0;c[D>>2]=Sb;if((gc&254|0)==64){Rb=2-(da(d[Ab+(kc+1)>>0]|0,Sb)|0)|0;c[D>>2]=Rb;ad=Rb}else ad=Sb;if((ad+kc|0)>(nc|0)){Fb=603;break a}if((gc|0)==44|(gc|0)==137){Fb=605;break a}else if((gc|0)==45){Fb=685;break}else{Zb=ad;mc=kc}}break}case 119:{mc=c[Eb>>2]|0;Zb=mc&192;if(!Zb)c[mb>>2]=5792;else if((Zb|0)==64)c[mb>>2]=11585;else if((Zb|0)==128)c[mb>>2]=23170;else if((Zb|0)==192)c[mb>>2]=11585;Zb=mc&48;if(!Zb)c[ob>>2]=0;else if((Zb|0)==16)c[ob>>2]=(c[mb>>2]|0)/4|0;else if((Zb|0)==32)c[ob>>2]=(c[mb>>2]|0)/2|0;else if((Zb|0)==48)c[ob>>2]=((c[mb>>2]|0)*3|0)/4|0;Zb=mc&15;mc=c[mb>>2]|0;if(!Zb)bd=mc+-1|0;else bd=(da(mc,Zb+-4|0)|0)/8|0;c[mb>>2]=(mc|0)/256|0;c[ob>>2]=(c[ob>>2]|0)/256|0;c[nb>>2]=(bd|0)/256|0;c[v>>2]=7;c[A>>2]=1767;Fb=685;break}case 136:{mc=c[Eb>>2]|0;Zb=(mc&1|0)!=0?35:0;if(!(mc&2))cd=Zb;else cd=(a[rb>>0]|0)==0?Zb:Zb|128;if(!(mc&4))dd=cd;else dd=(a[pb>>0]|0)==0?cd:cd|256;if(!(mc&32))ed=dd;else ed=(a[tb>>0]|0)==0?dd:dd|4096;c[Eb>>2]=ed;Fb=685;break}case 112:{mc=c[Eb>>2]|0;if(mc>>>0>=(c[P>>2]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=379;break a}else{Zb=K8d(c[Kb+(Lb+1<<2)>>2]|0,c[kb>>2]|0)|0;c[(c[lb>>2]|0)+(mc<<2)>>2]=Zb;Fb=685;break b}break}case 114:case 113:{$ge(f,c[Eb>>2]|0);Fb=685;break}case 91:{if(!(c[Eb>>2]|0))fd=(c[Kb+(Lb+1<<2)>>2]|0)!=0;else fd=1;c[Eb>>2]=fd&1;Fb=685;break}case 118:{Zb=c[Eb>>2]|0;mc=Zb&192;if((mc|0)==192)c[mb>>2]=16384;else if(!mc)c[mb>>2]=8192;else if((mc|0)==64)c[mb>>2]=16384;else if((mc|0)==128)c[mb>>2]=32768;mc=Zb&48;if(!mc)c[ob>>2]=0;else if((mc|0)==16)c[ob>>2]=(c[mb>>2]|0)/4|0;else if((mc|0)==32)c[ob>>2]=(c[mb>>2]|0)/2|0;else if((mc|0)==48)c[ob>>2]=((c[mb>>2]|0)*3|0)/4|0;mc=Zb&15;Zb=c[mb>>2]|0;if(!mc)gd=Zb+-1|0;else gd=(da(Zb,mc+-4|0)|0)/8|0;c[mb>>2]=(Zb|0)/256|0;c[ob>>2]=(c[ob>>2]|0)/256|0;c[nb>>2]=(gd|0)/256|0;c[v>>2]=6;c[A>>2]=1766;Fb=685;break}case 117:case 116:case 115:{Zb=c[Eb>>2]|0;l:do if(!Zb)hd=Lb;else{mc=Lb;nc=2;while(1){if((mc|0)<2)break;Tb=mc+-2|0;c[G>>2]=Tb;hc=c[I>>2]|0;kc=c[hc+(mc+-1<<2)>>2]|0;gc=c[hc+(Tb<<2)>>2]|0;if(kc>>>0<(c[P>>2]|0)>>>0){Tb=gc>>>4&15;hc=d[C>>0]|0;if((hc|0)==116)id=Tb|16;else if((hc|0)==117)id=Tb|32;else id=Tb;Tb=(b[ib>>1]|0)+id|0;if((_ge(f)|0)==(Tb|0)){Tb=gc&15;gc=Tb+-8|0;co[c[y>>2]&2047](f,kc,(((gc|0)>-1?Tb+-7|0:gc)<<6|0)/(1<<b[jb>>1]|0)|0)}}else if(a[H>>0]|0){Fb=478;break a}gc=c[G>>2]|0;if(nc>>>0>Zb>>>0){hd=gc;break l}mc=gc;nc=nc+1|0}if(a[H>>0]|0)c[M>>2]=129;c[G>>2]=0;hd=0}while(0);c[J>>2]=hd;Fb=685;break}case 103:{c[Eb>>2]=(c[Eb>>2]|0)+63&-64;Fb=685;break}case 111:case 110:case 109:case 108:{Zb=c[Eb>>2]|0;nc=c[f+(Cb+-108<<2)+264>>2]|0;if((Zb|0)>-1){mc=nc+Zb|0;jd=(Zb|0)!=0&(mc|0)<0?0:mc}else{mc=Zb-nc|0;jd=(mc|0)>0?0:mc}c[Eb>>2]=jd;Fb=685;break}case 107:case 106:case 105:case 104:{c[Eb>>2]=xo[c[A>>2]&2047](f,c[Eb>>2]|0,c[f+(Cb+-104<<2)+264>>2]|0)|0;Fb=685;break}case 87:{c[Eb>>2]=((xo[c[A>>2]&2047](f,c[Eb>>2]|0,0)|0)&127|0)==0&1;Fb=685;break}case 92:{c[Eb>>2]=(c[Eb>>2]|0)==0&1;Fb=685;break}case 125:{c[v>>2]=3;c[A>>2]=1763;Fb=685;break}case 128:{mc=c[Ja>>2]|0;m:do if((c[F>>2]|0)<(mc|0))if(!(a[H>>0]|0))kd=Lb;else{c[M>>2]=129;kd=Lb}else if((mc|0)>0){nc=Lb;Zb=Kb;gc=mc;while(1){Tb=nc+-1|0;c[G>>2]=Tb;kc=c[Zb+(Tb<<2)>>2]&65535;if(kc>>>0>=(e[Wa>>1]|0)>>>0)if(!(a[H>>0]|0))ld=gc;else{Fb=537;break a}else{Tb=(c[_a>>2]|0)+kc|0;a[Tb>>0]=d[Tb>>0]^1;ld=c[Ja>>2]|0}Tb=ld+-1|0;c[Ja>>2]=Tb;kc=c[G>>2]|0;if((Tb|0)<=0){kd=kc;break m}nc=kc;Zb=c[I>>2]|0;gc=Tb}}else kd=Lb;while(0);c[Ja>>2]=1;c[J>>2]=kd;Fb=685;break}case 100:{mc=c[Eb>>2]|0;c[Eb>>2]=(mc|0)<0?0-mc|0:mc;Fb=685;break}case 102:{c[Eb>>2]=c[Eb>>2]&-64;Fb=685;break}case 121:{if(!(c[Kb+(Lb+1<<2)>>2]|0)){mc=c[Eb>>2]|0;if(!(mc|Lb))c[M>>2]=132;gc=(c[z>>2]|0)+mc|0;c[z>>2]=gc;if((gc|0)<0)c[M>>2]=132;a[L>>0]=0;Fb=685}else Fb=685;break}case 122:{c[v>>2]=5;c[A>>2]=1760;Fb=685;break}case 123:{Xge(f);Fb=685;break}case 124:{c[v>>2]=4;c[A>>2]=1762;Fb=685;break}case 130:{gc=c[Eb>>2]|0;mc=c[Kb+(Lb+1<<2)>>2]&65535;Zb=e[Wa>>1]|0;nc=gc&65535;if(!(mc>>>0<Zb>>>0&nc>>>0<Zb>>>0))if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=550;break a}if(nc>>>0>mc>>>0)Fb=685;else{Zb=nc;nc=gc&65535;do{gc=(c[_a>>2]|0)+Zb|0;a[gc>>0]=d[gc>>0]&254;nc=nc+1<<16>>16;Zb=nc&65535}while(Zb>>>0<=mc>>>0);Fb=685}break}case 132:case 131:{Xge(f);Fb=685;break}case 133:{mc=c[Eb>>2]|0;Zb=mc&255;if((Zb|0)==255){a[qb>>0]=1;Fb=685;break b}else if(!Zb){a[qb>>0]=0;Fb=685;break b}else{if((mc&256|0)!=0?(e[sb>>1]|0)>>>0<=Zb>>>0:0)a[qb>>0]=1;if((mc&512|0)!=0?(a[rb>>0]|0)!=0:0)a[qb>>0]=1;if((mc&1024|0)!=0?(a[pb>>0]|0)!=0:0)a[qb>>0]=1;if((mc&2048|0)!=0?(e[sb>>1]|0)>>>0>Zb>>>0:0)a[qb>>0]=0;if((mc&4096|0)!=0?(a[rb>>0]|0)!=0:0)a[qb>>0]=0;if(!(mc&8192)){Fb=685;break b}if(!(a[pb>>0]|0)){Fb=685;break b}a[qb>>0]=0;Fb=685;break b}break}case 135:case 134:{mc=c[Eb>>2]&65535;if(mc>>>0<(e[O>>1]|0)>>>0?(Zb=c[Kb+(Lb+1<<2)>>2]&65535,Zb>>>0<(e[za>>1]|0)>>>0):0){nc=c[X>>2]|0;gc=c[db>>2]|0;Tb=c[nc+(mc<<3)>>2]|0;kc=c[gc+(Zb<<3)>>2]|0;hc=c[nc+(mc<<3)+4>>2]|0;nc=c[gc+(Zb<<3)+4>>2]|0;gc=hc-nc|0;Sb=(Tb|0)==(kc|0);Rb=(hc|0)==(nc|0);nc=Sb&Rb?16384:Tb-kc|0;kc=(Bb&1)!=0&(Sb&Rb^1);Wge(kc?0-gc|0:nc,kc?nc:gc,Ba);gc=c[Z>>2]|0;nc=c[Aa>>2]|0;Rb=(c[gc+(mc<<3)>>2]|0)-(c[nc+(Zb<<3)>>2]|0)|0;Sb=(c[gc+(mc<<3)+4>>2]|0)-(c[nc+(Zb<<3)+4>>2]|0)|0;Wge(kc?0-Sb|0:Rb,kc?Rb:Sb,ya);Nge(f);Fb=685;break b}if(!(a[H>>0]|0))Fb=685;else{Fb=577;break a}break}case 120:{if(!(c[Kb+(Lb+1<<2)>>2]|0))Fb=685;else{Sb=c[Eb>>2]|0;if(!(Sb|Lb))c[M>>2]=132;Rb=(c[z>>2]|0)+Sb|0;c[z>>2]=Rb;if((Rb|0)<0)c[M>>2]=132;a[L>>0]=0;Fb=685}break}case 97:{c[Eb>>2]=(c[Eb>>2]|0)-(c[Kb+(Lb+1<<2)>>2]|0);Fb=685;break}case 98:{Rb=c[Kb+(Lb+1<<2)>>2]|0;if(!Rb){Fb=455;break a}c[Eb>>2]=J8d(c[Eb>>2]|0,64,Rb)|0;Fb=685;break}case 129:{Rb=c[Eb>>2]|0;Sb=c[Kb+(Lb+1<<2)>>2]&65535;kc=e[Wa>>1]|0;Zb=Rb&65535;if(!(Sb>>>0<kc>>>0&Zb>>>0<kc>>>0))if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=545;break a}if(Zb>>>0>Sb>>>0)Fb=685;else{kc=Zb;Zb=Rb&65535;do{Rb=(c[_a>>2]|0)+kc|0;a[Rb>>0]=d[Rb>>0]|1;Zb=Zb+1<<16>>16;kc=Zb&65535}while(kc>>>0<=Sb>>>0);Fb=685}break}case 93:{$ge(f,c[Eb>>2]|0);Fb=685;break}case 94:{b[ib>>1]=c[Eb>>2];Fb=685;break}case 95:{b[jb>>1]=c[Eb>>2];Fb=685;break}case 96:{c[Eb>>2]=(c[Eb>>2]|0)+(c[Kb+(Lb+1<<2)>>2]|0);Fb=685;break}case 140:{Sb=c[Kb+(Lb+1<<2)>>2]|0;if((Sb|0)<(c[Eb>>2]|0)){c[Eb>>2]=Sb;Fb=685}else Fb=685;break}case 141:{Sb=c[Eb>>2]|0;if((Sb|0)>-1){c[wb>>2]=Sb;Fb=685}else Fb=685;break}case 142:{Sb=c[Kb+(Lb+1<<2)>>2]|0;if((Sb+-1|0)>>>0>1)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=615;break a}else{a[xb>>0]=d[xb>>0]&(Sb^255)|((c[Eb>>2]|0)==0?0:Sb);Fb=685;break b}break}case 143:{Xge(f);Fb=685;break}case 138:{Sb=Kb+(Lb+2<<2)|0;kc=c[Sb>>2]|0;Zb=Kb+(Lb+1<<2)|0;Rb=c[Zb>>2]|0;c[Sb>>2]=c[Eb>>2];c[Zb>>2]=kc;c[Eb>>2]=Rb;Fb=685;break}case 139:{Rb=c[Kb+(Lb+1<<2)>>2]|0;if((Rb|0)>(c[Eb>>2]|0)){c[Eb>>2]=Rb;Fb=685}else Fb=685;break}case 72:{Rb=c[Eb>>2]|0;kc=Rb&65535;if(kc>>>0>=(e[za>>1]|0)>>>0)if(!(a[H>>0]|0)){Fb=685;break b}else{Fb=400;break a}Zb=c[Aa>>2]|0;Sb=xo[c[aa>>2]&2047](f,c[Zb+(kc<<3)>>2]|0,c[Zb+(kc<<3)+4>>2]|0)|0;Dn[c[ca>>2]&511](f,Ha,Rb&65535,(c[Kb+(Lb+1<<2)>>2]|0)-Sb|0);if(!(b[Ia>>1]|0)){Sb=(c[Aa>>2]|0)+(kc<<3)|0;Rb=c[Sb+4>>2]|0;Zb=(c[db>>2]|0)+(kc<<3)|0;c[Zb>>2]=c[Sb>>2];c[Zb+4>>2]=Rb;Fb=685}else Fb=685;break}case 127:case 126:case 89:case 33:{Fb=700;break}default:{if((Bb&255)>223){Rb=c[Eb>>2]|0;Zb=c[Kb+(Lb+1<<2)>>2]|0;Sb=Rb&65535;kc=Zb+1|0;nc=Rb&65535;if((nc>>>0<(e[O>>1]|0)>>>0?kc>>>0<((c[P>>2]|0)+1|0)>>>0:0)?(e[Q>>1]|0)<(e[R>>1]|0):0){if(!kc)md=0;else md=_n[c[w>>2]&4095](f,Zb)|0;Zb=c[S>>2]|0;kc=md-Zb|0;if((((kc|0)<0?0-kc|0:kc)|0)<(c[T>>2]|0))nd=(md|0)>-1?Zb:0-Zb|0;else nd=md;if(!(b[U>>1]|0)){Zb=e[Q>>1]|0;kc=c[V>>2]|0;Rb=b[W>>1]|0;mc=Rb<<16>>16;gc=0-nd|0;Tb=(nd|0)<0?gc:nd;hc=Rb<<16>>16<0?0-mc|0:mc;Rb=Tb>>>16;Mb=Tb&65535;Tb=da(hc,Mb)|0;Nb=da(hc,Rb)|0;hc=Tb+(Nb<<16|8192)|0;lc=(Nb>>>16)+(hc>>>0<Tb>>>0&1)<<18|hc>>>14;hc=c[X>>2]|0;c[hc+(nc<<3)>>2]=((mc^nd|0)>-1?lc:0-lc|0)+(c[kc+(Zb<<3)>>2]|0);lc=b[Y>>1]|0;mc=lc<<16>>16;Tb=lc<<16>>16<0?0-mc|0:mc;lc=da(Tb,Mb)|0;Mb=da(Tb,Rb)|0;Rb=lc+(Mb<<16|8192)|0;Tb=(Mb>>>16)+(Rb>>>0<lc>>>0&1)<<18|Rb>>>14;c[hc+(nc<<3)+4>>2]=((mc^nd|0)>-1?Tb:0-Tb|0)+(c[kc+(Zb<<3)+4>>2]|0);Zb=(c[_>>2]|0)+(nc<<3)|0;kc=c[Zb+4>>2]|0;Tb=(c[Z>>2]|0)+(nc<<3)|0;c[Tb>>2]=c[Zb>>2];c[Tb+4>>2]=kc;od=gc}else od=0-nd|0;gc=c[X>>2]|0;kc=e[Q>>1]|0;Tb=c[V>>2]|0;Zb=xo[c[$>>2]&2047](f,(c[gc+(nc<<3)>>2]|0)-(c[Tb+(kc<<3)>>2]|0)|0,(c[gc+(nc<<3)+4>>2]|0)-(c[Tb+(kc<<3)+4>>2]|0)|0)|0;kc=c[Z>>2]|0;Tb=e[Q>>1]|0;gc=c[_>>2]|0;mc=xo[c[aa>>2]&2047](f,(c[kc+(nc<<3)>>2]|0)-(c[gc+(Tb<<3)>>2]|0)|0,(c[kc+(nc<<3)+4>>2]|0)-(c[gc+(Tb<<3)+4>>2]|0)|0)|0;Tb=(a[ba>>0]|0)!=0&(Zb^nd|0)<0?od:nd;gc=a[C>>0]|0;nc=gc&255;do if(!(nc&4)){kc=c[f+((nc&3)<<2)+264>>2]|0;if((Tb|0)>-1){hc=kc+Tb|0;pd=gc;qd=(nd|0)!=0&(hc|0)<0?0:hc;break}else{hc=Tb-kc|0;pd=gc;qd=(hc|0)>0?0:hc;break}}else{if((b[fa>>1]|0)==(b[U>>1]|0)){hc=Tb-Zb|0;rd=(((hc|0)<0?0-hc|0:hc)|0)>(c[ga>>2]|0)?Zb:Tb}else rd=Tb;hc=xo[c[A>>2]&2047](f,rd,c[f+((nc&3)<<2)+264>>2]|0)|0;pd=a[C>>0]|0;qd=hc}while(0);do if(pd&8){nc=c[ea>>2]|0;if((Zb|0)>-1){sd=(qd|0)<(nc|0)?nc:qd;break}else{Tb=0-nc|0;sd=(qd|0)>(Tb|0)?Tb:qd;break}}else sd=qd;while(0);Dn[c[ca>>2]&511](f,N,Sb,sd-mc|0);td=a[C>>0]|0}else if(!(a[H>>0]|0))td=Bb;else{c[M>>2]=134;td=Bb}b[ha>>1]=b[Q>>1]|0;if(td&16)b[Q>>1]=Sb;b[ia>>1]=Sb;Fb=685;break b}if((Bb&255)<=191){if((Bb&255)>183){Zb=Cb+65353&65535;if(Zb>>>0>=(Jb+1-(c[F>>2]|0)|0)>>>0){Fb=673;break a}Tb=(c[z>>2]|0)+1|0;c[z>>2]=Tb;n:do if(Zb){nc=Tb;gc=0;hc=1;while(1){c[z>>2]=nc+2;c[Kb+(gc+Lb<<2)>>2]=(d[Ab+nc>>0]<<8|d[Ab+(nc+1)>>0])<<16>>16;kc=hc&65535;if(kc>>>0>=Zb>>>0)break n;nc=c[z>>2]|0;gc=kc;hc=hc+1<<16>>16}}while(0);a[L>>0]=0;Fb=685;break b}if((Bb&255)<=175){Xge(f);Fb=685;break b}Zb=Cb+65361&65535;if(Zb>>>0>=(Jb+1-(c[F>>2]|0)|0)>>>0){Fb=682;break a}if(!Zb){Fb=685;break b}Tb=Lb+-1|0;Sb=1;mc=1;while(1){c[Kb+(Tb+Sb<<2)>>2]=d[Ab+((c[z>>2]|0)+Sb)>>0];mc=mc+1<<16>>16;Sb=mc&65535;if(Sb>>>0>Zb>>>0){Fb=685;break b}}}Zb=c[Eb>>2]|0;Sb=Zb&65535;mc=Zb&65535;if(mc>>>0<(e[O>>1]|0)>>>0?(Zb=b[Q>>1]|0,Tb=Zb&65535,(Zb&65535)<(e[R>>1]|0)):0){do if((b[fa>>1]|0)!=0?(b[U>>1]|0)!=0:0){Zb=c[ja>>2]|0;hc=c[ka>>2]|0;gc=c[la>>2]|0;nc=c[Zb+(mc<<3)>>2]|0;kc=c[hc+(Tb<<3)>>2]|0;if((gc|0)==(c[ma>>2]|0)){Rb=xo[c[$>>2]&2047](f,nc-kc|0,(c[Zb+(mc<<3)+4>>2]|0)-(c[hc+(Tb<<3)+4>>2]|0)|0)|0;ud=K8d(Rb,c[la>>2]|0)|0;break}else{Rb=K8d(nc-kc|0,gc)|0;gc=K8d((c[Zb+(mc<<3)+4>>2]|0)-(c[hc+(Tb<<3)+4>>2]|0)|0,c[ma>>2]|0)|0;ud=xo[c[$>>2]&2047](f,Rb,gc)|0;break}}else Fb=653;while(0);if((Fb|0)==653){Fb=0;gc=c[X>>2]|0;Rb=c[V>>2]|0;ud=xo[c[$>>2]&2047](f,(c[gc+(mc<<3)>>2]|0)-(c[Rb+(Tb<<3)>>2]|0)|0,(c[gc+(mc<<3)+4>>2]|0)-(c[Rb+(Tb<<3)+4>>2]|0)|0)|0}Rb=c[S>>2]|0;gc=ud-Rb|0;if((((gc|0)<0?0-gc|0:gc)|0)<(c[T>>2]|0))vd=(ud|0)>-1?Rb:0-Rb|0;else vd=ud;Rb=a[C>>0]|0;gc=Rb&255;do if(!(gc&4)){hc=c[f+((gc&3)<<2)+264>>2]|0;if((vd|0)>-1){Zb=hc+vd|0;wd=Rb;xd=(vd|0)!=0&(Zb|0)<0?0:Zb;break}else{Zb=vd-hc|0;wd=Rb;xd=(Zb|0)>0?0:Zb;break}}else{Zb=xo[c[A>>2]&2047](f,vd,c[f+((gc&3)<<2)+264>>2]|0)|0;wd=a[C>>0]|0;xd=Zb}while(0);do if(wd&8){gc=c[ea>>2]|0;if((vd|0)>-1){yd=(xd|0)<(gc|0)?gc:xd;break}else{Rb=0-gc|0;yd=(xd|0)>(Rb|0)?Rb:xd;break}}else yd=xd;while(0);Rb=c[Z>>2]|0;gc=c[_>>2]|0;Tb=e[Q>>1]|0;Zb=xo[c[aa>>2]&2047](f,(c[Rb+(mc<<3)>>2]|0)-(c[gc+(Tb<<3)>>2]|0)|0,(c[Rb+(mc<<3)+4>>2]|0)-(c[gc+(Tb<<3)+4>>2]|0)|0)|0;Dn[c[ca>>2]&511](f,N,Sb,yd-Zb|0);zd=a[C>>0]|0}else if(!(a[H>>0]|0))zd=Bb;else{c[M>>2]=134;zd=Bb}b[ha>>1]=b[Q>>1]|0;b[ia>>1]=Sb;if(!(zd&16))Fb=685;else{b[Q>>1]=Sb;Fb=685}}}while(0);do if((Fb|0)==685){Fb=0;Bb=c[M>>2]|0;if(!Bb){Fb=700;break}else if((Bb|0)!=128){Ad=Bb;Fb=708;break a}Bb=c[oa>>2]|0;Eb=c[pa>>2]|0;Ab=Bb+(Eb<<4)|0;if((Eb|0)>0)Bd=Bb;else{Fb=699;break a}while(1){if((a[Bd+12>>0]|0)!=0?(a[C>>0]|0)==(c[Bd+8>>2]&255)<<24>>24:0){Cd=Bd;break}Bd=Bd+16|0;if(Bd>>>0>=Ab>>>0){Fb=699;break a}}Ab=c[qa>>2]|0;if((Ab|0)>=(c[ra>>2]|0)){Fb=690;break a}Sb=c[sa>>2]|0;c[Sb+(Ab<<4)>>2]=c[ta>>2];c[Sb+(Ab<<4)+4>>2]=(c[z>>2]|0)+1;c[Sb+(Ab<<4)+8>>2]=1;mc=c[Cd+4>>2]|0;c[Sb+(Ab<<4)+12>>2]=mc;Ab=c[Cd>>2]|0;Sb=Ab+-1|0;if(Sb>>>0>2){Fb=692;break a}Bb=c[f+(Sb<<3)+444>>2]|0;if(!Bb){Fb=694;break a}Eb=c[f+(Sb<<3)+448>>2]|0;if(Eb>>>0<mc>>>0){Fb=696;break a}c[B>>2]=Bb;c[E>>2]=Eb;c[z>>2]=mc;c[ta>>2]=Ab;Dd=zb}while(0);if((Fb|0)==700){Fb=0;c[F>>2]=c[J>>2];if(a[L>>0]|0)c[z>>2]=(c[z>>2]|0)+(c[D>>2]|0);if((zb|0)>999999){Ed=139;Fb=711;break}else Dd=zb+1|0}yb=c[z>>2]|0;if((yb|0)>=(c[E>>2]|0)){Fb=704;break}if(a[na>>0]|0){Ed=0;Fb=711;break}else zb=Dd}switch(Fb|0){case 20:{c[M>>2]=129;Fd=129;break}case 24:{c[M>>2]=130;Fd=130;break}case 34:{c[M>>2]=134;Fd=134;break}case 39:{c[M>>2]=134;Fd=134;break}case 52:{c[M>>2]=134;Fd=134;break}case 63:{c[M>>2]=134;Fd=134;break}case 69:{c[M>>2]=134;Fd=134;break}case 75:{c[M>>2]=134;Fd=134;break}case 81:{c[M>>2]=134;Fd=134;break}case 84:{c[M>>2]=132;Fd=132;break}case 94:{c[M>>2]=131;Fd=131;break}case 118:{c[M>>2]=134;Fd=134;break}case 123:{c[M>>2]=134;Fd=134;break}case 128:{c[M>>2]=134;Fd=134;break}case 141:{c[M>>2]=130;Fd=130;break}case 151:{c[M>>2]=134;Fd=134;break}case 161:{c[M>>2]=130;Fd=130;break}case 170:{c[M>>2]=134;Fd=134;break}case 176:{c[M>>2]=140;Fd=140;break}case 179:{c[M>>2]=140;Fd=140;break}case 187:{c[M>>2]=131;Fd=131;break}case 189:{c[M>>2]=137;Fd=137;break}case 191:{c[M>>2]=136;Fd=136;break}case 195:{c[M>>2]=132;Fd=132;break}case 197:{c[M>>2]=138;Fd=138;break}case 199:{c[M>>2]=131;Fd=131;break}case 203:{c[M>>2]=134;Fd=134;break}case 239:{c[M>>2]=134;Fd=134;break}case 248:{c[M>>2]=134;Fd=134;break}case 265:{c[M>>2]=134;Fd=134;break}case 273:{c[M>>2]=134;Fd=134;break}case 294:{c[M>>2]=134;Fd=134;break}case 326:{c[M>>2]=134;Fd=134;break}case 335:{c[M>>2]=134;Fd=134;break}case 348:{c[M>>2]=134;Fd=134;break}case 367:{c[M>>2]=130;Fd=130;break}case 371:{c[M>>2]=130;Fd=130;break}case 379:{c[M>>2]=134;Fd=134;break}case 400:{c[M>>2]=134;Fd=134;break}case 420:{c[M>>2]=135;Fd=135;break}case 435:{c[M>>2]=131;Fd=131;break}case 455:{c[M>>2]=133;Fd=133;break}case 478:{c[M>>2]=134;Fd=134;break}case 537:{c[M>>2]=134;Fd=134;break}case 545:{c[M>>2]=134;Fd=134;break}case 550:{c[M>>2]=134;Fd=134;break}case 577:{c[M>>2]=134;Fd=134;break}case 592:{c[M>>2]=141;Fd=141;break}case 595:{c[M>>2]=141;Fd=141;break}case 603:{c[M>>2]=131;Fd=131;break}case 605:{c[M>>2]=137;Fd=137;break}case 615:{c[M>>2]=134;Fd=134;break}case 673:{c[M>>2]=130;Fd=130;break}case 682:{c[M>>2]=130;Fd=130;break}case 690:{c[M>>2]=134;Fd=134;break}case 692:{c[M>>2]=132;Fd=132;break}case 694:{c[M>>2]=138;Fd=138;break}case 696:{c[M>>2]=131;Fd=131;break}case 699:{c[M>>2]=128;Fd=128;break}case 704:{if((c[qa>>2]|0)>0){c[M>>2]=131;Fd=131;break}else{Ed=0;i=g;return Ed|0}break}case 707:{c[M>>2]=131;Fd=131;break}case 708:{if(!Ad){Ed=0;i=g;return Ed|0}else Fd=Ad;break}case 711:{i=g;return Ed|0}}if(a[na>>0]|0){Ed=Fd;i=g;return Ed|0}a[(c[f+4>>2]|0)+301>>0]=0;Ed=Fd;i=g;return Ed|0}function Hge(a,b){a=a|0;b=b|0;return c[(c[a+384>>2]|0)+(b<<2)>>2]|0}function Ige(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;g=c[(c[a+384>>2]|0)+(d<<2)>>2]|0;d=a+244|0;h=a+256|0;j=c[h>>2]|0;do if(!j){k=a+296|0;if(!(b[k>>1]|0)){l=c[d>>2]|0;c[h>>2]=l;m=l;break}l=b[a+294>>1]|0;if(!(l<<16>>16)){n=c[a+248>>2]|0;c[h>>2]=n;m=n;break}else{n=I8d(l<<16>>16,c[d>>2]|0,16384)|0;l=I8d(b[k>>1]|0,c[a+248>>2]|0,16384)|0;c[f>>2]=n;c[f+4>>2]=l;l=Wae(f)|0;c[h>>2]=l;m=l;break}}else m=j;while(0);j=K8d(g,m)|0;i=e;return j|0}function Jge(a,b,d){a=a|0;b=b|0;d=d|0;c[(c[a+384>>2]|0)+(b<<2)>>2]=d;return}function Kge(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=a+244|0;j=a+256|0;k=c[j>>2]|0;do if(!k){l=a+296|0;if(!(b[l>>1]|0)){m=c[h>>2]|0;c[j>>2]=m;n=m;break}m=b[a+294>>1]|0;if(!(m<<16>>16)){o=c[a+248>>2]|0;c[j>>2]=o;n=o;break}else{o=I8d(m<<16>>16,c[h>>2]|0,16384)|0;m=I8d(b[l>>1]|0,c[a+248>>2]|0,16384)|0;c[g>>2]=o;c[g+4>>2]=m;m=Wae(g)|0;c[j>>2]=m;n=m;break}}else n=k;while(0);k=L8d(e,n)|0;c[(c[a+384>>2]|0)+(d<<2)>>2]=k;i=f;return}function Lge(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+384>>2]|0)+(b<<2)|0;c[e>>2]=(c[e>>2]|0)+d;return}function Mge(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=a+244|0;j=a+256|0;k=c[j>>2]|0;do if(!k){l=a+296|0;if(!(b[l>>1]|0)){m=c[h>>2]|0;c[j>>2]=m;n=m;break}m=b[a+294>>1]|0;if(!(m<<16>>16)){o=c[a+248>>2]|0;c[j>>2]=o;n=o;break}else{o=I8d(m<<16>>16,c[h>>2]|0,16384)|0;m=I8d(b[l>>1]|0,c[a+248>>2]|0,16384)|0;c[g>>2]=o;c[g+4>>2]=m;m=Wae(g)|0;c[j>>2]=m;n=m;break}}else n=k;while(0);k=L8d(e,n)|0;n=(c[a+384>>2]|0)+(d<<2)|0;c[n>>2]=(c[n>>2]|0)+k;i=f;return}function Nge(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=b[a+298>>1]|0;f=e<<16>>16;g=e<<16>>16==16384;do if(!g){e=b[a+300>>1]|0;h=b[a+296>>1]|0;if(e<<16>>16==16384){j=h<<16>>16<<16;c[a+564>>2]=j;k=b[a+294>>1]|0;l=j;break}else{j=b[a+294>>1]|0;m=(da(h<<16>>16,e<<16>>16)|0)+(da(j<<16>>16,f)|0)<<2;c[a+564>>2]=m;k=j;l=m;break}}else{m=b[a+294>>1]|0;j=m<<16>>16<<16;c[a+564>>2]=j;k=m;l=j}while(0);do if(k<<16>>16!=16384){f=a+572|0;if((b[a+296>>1]|0)==16384){c[f>>2]=1769;break}else{c[f>>2]=1770;break}}else c[a+572>>2]=1768;while(0);do if((b[a+290>>1]|0)!=16384){k=a+576|0;if((b[a+292>>1]|0)==16384){c[k>>2]=1769;break}else{c[k>>2]=1771;break}}else c[a+576>>2]=1768;while(0);k=a+584|0;c[k>>2]=342;f=a+588|0;c[f>>2]=343;j=a+564|0;do if((l|0)==1073741824){if(g){c[k>>2]=344;c[f>>2]=345;break}if((b[a+300>>1]|0)==16384){c[k>>2]=346;c[f>>2]=347}}while(0);if((((l|0)<0?0-l|0:l)|0)>=67108864){n=a+256|0;c[n>>2]=0;i=d;return}c[j>>2]=1073741824;n=a+256|0;c[n>>2]=0;i=d;return}function Oge(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=i;if((b|0)>-1){d=c+b|0;e=(b|0)!=0&(d|0)<0?0:d;i=a;return e|0}else{d=b-c|0;e=(d|0)>0?0:d;i=a;return e|0}return 0}function Pge(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if((b|0)>-1){d=b+32+c|0;i=a;return ((b|0)!=0&(d|0)>0?d&-64:0)|0}else{d=0-(32-b+c&-64)|0;i=a;return ((d|0)>0?0:d)|0}return 0}function Qge(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if((b|0)>-1){d=b+63+c|0;i=a;return ((b|0)!=0&(d|0)>0?d&-64:0)|0}else{d=0-(63-b+c&-64)|0;i=a;return ((d|0)>0?0:d)|0}return 0}function Rge(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if((b|0)>-1){d=c+b|0;i=a;return ((b|0)!=0&(d|0)>0?d&-64:0)|0}else{d=0-(c-b&-64)|0;i=a;return ((d|0)>0?0:d)|0}return 0}function Sge(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=i;if((b|0)>-1){d=c+b&-64|32;e=(b|0)!=0&(d|0)<0?0:d;i=a;return e|0}else{d=0-(c-b&-64|32)|0;e=(d|0)>0?0:d;i=a;return e|0}return 0}function Tge(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if((b|0)>-1){d=b+16+c|0;i=a;return ((b|0)!=0&(d|0)>0?d&-32:0)|0}else{d=0-(16-b+c&-32)|0;i=a;return ((d|0)>0?0:d)|0}return 0}function Uge(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a+480>>2]|0;g=c[a+484>>2]|0;h=c[a+476>>2]|0;if((b|0)>-1){a=d+b-f+g&0-h;j=((b|0)!=0&(a|0)<0?0:a)+f|0;i=e;return j|0}else{a=0-(d-b+g-f&0-h)|0;j=((a|0)>0?0:a)-f|0;i=e;return j|0}return 0}function Vge(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[a+480>>2]|0;g=c[a+484>>2]|0;h=c[a+476>>2]|0;if((b|0)>-1){a=d+b-f+g|0;j=a-((a|0)%(h|0)|0)|0;k=((b|0)!=0&(j|0)<0?0:j)+f|0;i=e;return k|0}else{j=d-b+g-f|0;g=((j|0)%(h|0)|0)-j|0;k=((g|0)>0?0:g)-f|0;i=e;return k|0}return 0}function Wge(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f;if((((a|0)<0?0-a|0:a)|0)<65536?(((d|0)<0?0-d|0:d)|0)<65536:0){h=a<<8;j=d<<8;c[g>>2]=h;c[g+4>>2]=j;k=Wae(g)|0;if(!k){i=f;return}b[e>>1]=I8d(h,16384,k)|0;b[e+2>>1]=I8d(j,16384,k)|0;i=f;return}c[g>>2]=a;c[g+4>>2]=d;k=Wae(g)|0;g=I8d(a,16384,k)|0;a=I8d(d,16384,k)|0;k=(da(a,a)|0)+(da(g,g)|0)|0;d=(g|0)<0?0-g|0:g;j=(a|0)<0?0-a|0:a;if((k|0)<268435456){h=j;l=d;while(1){m=(l|0)<(h|0)&1;n=m+l|0;o=(m^1)+h|0;m=(da(o,o)|0)+(da(n,n)|0)|0;if((m|0)<268435456){h=o;l=n}else{p=o;q=n;r=m;break}}}else{p=j;q=d;r=k}if((r|0)>268451839){r=p;k=q;while(1){d=(k|0)<(r|0);j=(d<<31>>31)+k|0;l=((d^1)<<31>>31)+r|0;if(((da(j,j)|0)+(da(l,l)|0)|0)>268451839){r=l;k=j}else{s=l;t=j;break}}}else{s=p;t=q}b[e>>1]=(g|0)>-1?t:0-t|0;b[e+2>>1]=(a|0)>-1?s:0-s|0;i=f;return}function Xge(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=c[b+416>>2]|0;f=c[b+408>>2]|0;g=e+(f<<4)|0;a:do if((f|0)>0){h=a[b+368>>0]|0;j=e;while(1){if(h<<24>>24==(c[j+8>>2]&255)<<24>>24?(a[j+12>>0]|0)!=0:0){k=j;break}j=j+16|0;if(j>>>0>=g>>>0)break a}j=b+428|0;h=c[j>>2]|0;if((h|0)>=(c[b+432>>2]|0)){c[b+12>>2]=130;i=d;return}l=c[b+436>>2]|0;c[j>>2]=h+1;j=b+352|0;c[l+(h<<4)>>2]=c[j>>2];m=b+360|0;c[l+(h<<4)+4>>2]=(c[m>>2]|0)+1;c[l+(h<<4)+8>>2]=1;n=c[k+4>>2]|0;c[l+(h<<4)+12>>2]=n;h=c[k>>2]|0;l=h+-1|0;do if(l>>>0<=2){o=c[b+(l<<3)+444>>2]|0;if(!o){c[b+12>>2]=138;break}p=c[b+(l<<3)+448>>2]|0;if(p>>>0<n>>>0){c[b+12>>2]=131;break}else{c[b+356>>2]=o;c[b+364>>2]=p;c[m>>2]=n;c[j>>2]=h;break}}else c[b+12>>2]=132;while(0);a[b+376>>0]=0;i=d;return}while(0);c[b+12>>2]=128;i=d;return}function Yge(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;if(b>>>0>d>>>0){i=g;return}h=c[a+12>>2]|0;if(!(h>>>0>e>>>0&h>>>0>f>>>0)){i=g;return}h=a+8|0;j=c[h>>2]|0;k=c[j+(e<<3)>>2]|0;l=c[j+(f<<3)>>2]|0;j=(k|0)>(l|0);m=j?k:l;n=j?l:k;k=j?e:f;l=j?f:e;e=c[a>>2]|0;f=c[e+(l<<3)>>2]|0;j=c[e+(k<<3)>>2]|0;o=a+4|0;p=c[o>>2]|0;q=c[p+(l<<3)>>2]|0;l=q-f|0;r=c[p+(k<<3)>>2]|0;k=r-j|0;if((m|0)==(n|0)){s=b;do{t=c[e+(s<<3)>>2]|0;c[p+(s<<3)>>2]=((t|0)>(f|0)?k:l)+t;s=s+1|0}while(s>>>0<=d>>>0);i=g;return}s=r-q|0;r=m-n|0;m=e;e=p;p=b;b=0;t=0;while(1){u=c[m+(p<<3)>>2]|0;do if((u|0)>(f|0)){if((u|0)>=(j|0)){v=e;w=b;x=t;y=u+k|0;break}if(!(t<<24>>24)){z=I8d(s,65536,r)|0;A=1}else{z=b;A=t}B=(K8d((c[(c[h>>2]|0)+(p<<3)>>2]|0)-n|0,z)|0)+q|0;v=c[o>>2]|0;w=z;x=A;y=B}else{v=e;w=b;x=t;y=u+l|0}while(0);c[v+(p<<3)>>2]=y;u=p+1|0;if(u>>>0>d>>>0)break;m=c[a>>2]|0;e=v;p=u;b=w;t=x}i=g;return}function Zge(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+16|0;k=j;if(!(a[d+368>>0]&1)){l=d+72|0;m=c[l>>2]|0;n=c[l+4>>2]|0;l=c[d+80>>2]|0;o=c[d+84>>2]|0;p=c[d+88>>2]|0;q=d+92|0;c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];r=m;s=n;t=d+288|0;u=l;v=o;w=p}else{p=d+36|0;o=c[p>>2]|0;l=c[p+4>>2]|0;p=c[d+44>>2]|0;n=c[d+48>>2]|0;m=c[d+52>>2]|0;q=d+56|0;c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];r=o;s=l;t=d+286|0;u=p;v=n;w=m}m=u&65535;n=b[t>>1]|0;t=n&65535;if((n&65535)<(m&65535)){p=g;c[p>>2]=r;c[p+4>>2]=s;b[g+8>>1]=m;b[g+10>>1]=u>>>16;c[g+12>>2]=v;c[g+16>>2]=w;u=g+20|0;c[u+0>>2]=c[k+0>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];c[u+12>>2]=c[k+12>>2];b[h>>1]=n;n=xo[c[d+572>>2]&2047](d,(c[w+(t<<3)>>2]|0)-(c[v+(t<<3)>>2]|0)|0,(c[w+(t<<3)+4>>2]|0)-(c[v+(t<<3)+4>>2]|0)|0)|0;t=d+564|0;c[e>>2]=I8d(n,b[d+298>>1]<<16,c[t>>2]|0)|0;c[f>>2]=I8d(n,b[d+300>>1]<<16,c[t>>2]|0)|0;x=0;i=j;return x|0}if(a[d+561>>0]|0)c[d+12>>2]=134;b[h>>1]=0;x=1;i=j;return x|0}function _ge(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;f=d;g=e[a+252>>1]|0;h=a+244|0;j=a+256|0;k=c[j>>2]|0;do if(!k){l=a+296|0;if(!(b[l>>1]|0)){m=c[h>>2]|0;c[j>>2]=m;n=m;break}m=b[a+294>>1]|0;if(!(m<<16>>16)){o=c[a+248>>2]|0;c[j>>2]=o;n=o;break}else{o=I8d(m<<16>>16,c[h>>2]|0,16384)|0;m=I8d(b[l>>1]|0,c[a+248>>2]|0,16384)|0;c[f>>2]=o;c[f+4>>2]=m;m=Wae(f)|0;c[j>>2]=m;n=m;break}}else n=k;while(0);k=K8d(g,n)|0;i=d;return k|0}function $ge(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;j=f+28|0;a:do if(g){k=f+24|0;l=f+36|0;m=f+44|0;n=f+368|0;o=f+332|0;p=f+334|0;q=f+584|0;r=f+561|0;s=f+12|0;t=1;while(1){u=c[j>>2]|0;if((u|0)<2)break;v=u+-2|0;c[j>>2]=v;w=c[k>>2]|0;x=c[w+(u+-1<<2)>>2]|0;u=x&65535;y=c[w+(v<<2)>>2]|0;if((x&65535)>>>0<(e[m>>1]|0)>>>0){x=y>>>4&15;v=d[n>>0]|0;if((v|0)==113)z=x|16;else if((v|0)==114)z=x|32;else z=x;x=(b[o>>1]|0)+z|0;if((_ge(f)|0)==(x|0)){x=y&15;y=x+-8|0;Dn[c[q>>2]&511](f,l,u,(((y|0)>-1?x+-7|0:y)<<6|0)/(1<<b[p>>1]|0)|0)}}else if(a[r>>0]|0)c[s>>2]=134;t=t+1|0;if(t>>>0>g>>>0)break a}if(a[r>>0]|0)c[s>>2]=129;c[j>>2]=0;A=0;B=f+32|0;c[B>>2]=A;i=h;return}while(0);A=c[j>>2]|0;B=f+32|0;c[B>>2]=A;i=h;return}function ahe(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function bhe(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function che(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b[a+294>>1]|0;f=b[a+296>>1]|0;a=da(e,c&65535)|0;g=da(e,c>>16)|0;c=a+(g<<16)|0;e=da(f,d&65535)|0;h=da(f,d>>16)|0;d=e+(h<<16)|0;f=c+d|0;i=(g>>16)+(a>>31)+(e>>31)+(h>>16)+(c>>>0<a>>>0&1)+(d>>>0<e>>>0&1)+(f>>>0<c>>>0&1)|0;c=i>>31;e=f+c|0;return (e>>>0>4294959103&1)+(e>>>0<f>>>0&1)+i+c<<18|(e+8192|0)>>>14|0}function dhe(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b[a+290>>1]|0;f=b[a+292>>1]|0;a=da(e,c&65535)|0;g=da(e,c>>16)|0;c=a+(g<<16)|0;e=da(f,d&65535)|0;h=da(f,d>>16)|0;d=e+(h<<16)|0;f=c+d|0;i=(g>>16)+(a>>31)+(e>>31)+(h>>16)+(c>>>0<a>>>0&1)+(d>>>0<e>>>0&1)+(f>>>0<c>>>0&1)|0;c=i>>31;e=f+c|0;return (e>>>0>4294959103&1)+(e>>>0<f>>>0&1)+i+c<<18|(e+8192|0)>>>14|0}function ehe(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;k=b[e+298>>1]|0;if(k<<16>>16){l=I8d(h,k<<16>>16<<16,c[e+564>>2]|0)|0;k=g&65535;m=(c[f+16>>2]|0)+(k<<3)|0;c[m>>2]=(c[m>>2]|0)+l;l=(c[f+24>>2]|0)+k|0;a[l>>0]=d[l>>0]|0|8}l=b[e+300>>1]|0;if(!(l<<16>>16)){i=j;return}k=I8d(h,l<<16>>16<<16,c[e+564>>2]|0)|0;e=g&65535;g=(c[f+16>>2]|0)+(e<<3)+4|0;c[g>>2]=(c[g>>2]|0)+k;k=(c[f+24>>2]|0)+e|0;a[k>>0]=d[k>>0]|0|16;i=j;return}function fhe(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=b[a+298>>1]|0;if(h<<16>>16){j=I8d(f,h<<16>>16<<16,c[a+564>>2]|0)|0;h=(c[d+12>>2]|0)+((e&65535)<<3)|0;c[h>>2]=(c[h>>2]|0)+j}j=b[a+300>>1]|0;if(!(j<<16>>16)){i=g;return}h=I8d(f,j<<16>>16<<16,c[a+564>>2]|0)|0;a=(c[d+12>>2]|0)+((e&65535)<<3)+4|0;c[a>>2]=(c[a>>2]|0)+h;i=g;return}function ghe(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;b=f&65535;f=(c[e+16>>2]|0)+(b<<3)|0;c[f>>2]=(c[f>>2]|0)+g;g=(c[e+24>>2]|0)+b|0;a[g>>0]=d[g>>0]|0|8;return}function hhe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;a=(c[b+12>>2]|0)+((d&65535)<<3)|0;c[a>>2]=(c[a>>2]|0)+e;return}function ihe(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;b=f&65535;f=(c[e+16>>2]|0)+(b<<3)+4|0;c[f>>2]=(c[f>>2]|0)+g;g=(c[e+24>>2]|0)+b|0;a[g>>0]=d[g>>0]|0|16;return}function jhe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;a=(c[b+12>>2]|0)+((d&65535)<<3)+4|0;c[a>>2]=(c[a>>2]|0)+e;return}function khe(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;ohe(a+16|0,d);ohe(a+52|0,d);c[a+4>>2]=0;c[a>>2]=0;i=b;return}function lhe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+0|0;f=e+88|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[a>>2]=b;i=d;return 0}function mhe(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+0|0;f=e+24|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(f|0));c[b+4>>2]=3559;c[b+8>>2]=2839;c[b+12>>2]=1854;c[b+16>>2]=1855;c[b+20>>2]=3053;c[b+24>>2]=272;i=d;return}function nhe(a){a=a|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+4>>2]=3560;c[a+8>>2]=2839;c[a+12>>2]=348;c[a+16>>2]=349;c[a+20>>2]=1856;c[a+24>>2]=272;return}function ohe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+28|0;f=c[e>>2]|0;g=a+32|0;if(f){h=f;f=c[g>>2]|0;while(1){$ae(b,c[f+8>>2]|0);c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;h=h+-1|0;if(!h)break;else f=f+16|0}}$ae(b,c[g>>2]|0);c[g>>2]=0;c[a+24>>2]=0;c[e>>2]=0;e=a+16|0;g=c[e>>2]|0;f=a+20|0;if(g){h=g;g=c[f>>2]|0;while(1){$ae(b,c[g+8>>2]|0);c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;h=h+-1|0;if(!h)break;else g=g+16|0}}$ae(b,c[f>>2]|0);c[f>>2]=0;c[a+12>>2]=0;c[e>>2]=0;e=a+8|0;$ae(b,c[e>>2]|0);c[e>>2]=0;c[a>>2]=0;c[a+4>>2]=0;i=d;return}function phe(a){a=a|0;c[a+4>>2]=0;c[a+16>>2]=0;c[a+28>>2]=0;c[a+40>>2]=0;c[a+52>>2]=0;c[a+64>>2]=0;c[a+76>>2]=0;c[a+12>>2]=1;return}function qhe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+4>>2]|0;if(!e){f=c[a>>2]|0;g=yhe(a+16|0,b,f)|0;if(!g)h=yhe(a+52|0,b,f)|0;else h=g}else h=e;i=d;return h|0}function rhe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=(H8d(c[d>>2]|0)|0)>>16;c[f>>2]=g;c[f+4>>2]=(H8d(c[d+4>>2]|0)|0)>>16;d=a+4|0;if(c[d>>2]|0){i=e;return}if(((c[a+12>>2]|0)+-1|0)>>>0>=2){i=e;return}h=zhe(a+((b>>>0>1?1:b)*36|0)+16|0,g,c[f+4>>2]|0,c[a>>2]|0,0)|0;if(!h){i=e;return}c[d>>2]=h;i=e;return}function she(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g;n=b+4|0;if(c[n>>2]|0){i=g;return}o=c[b>>2]|0;p=e>>>0>1?1:e;e=b+(p*36|0)+16|0;a:do if((c[b+12>>2]|0)==1){q=f;r=0;while(1){s=(H8d(c[q>>2]|0)|0)>>16;t=zhe(e,s,(H8d(c[q+4>>2]|0)|0)>>16,o,m+(r<<2)|0)|0;if(t){u=t;break a}r=r+1|0;if((r|0)>=3)break;else q=q+8|0}q=c[m>>2]|0;r=c[m+4>>2]|0;t=c[m+8>>2]|0;s=b+(p*36|0)+40|0;v=c[s>>2]|0;b:do if(!v)w=14;else{x=q>>3;y=128>>>(q&7);z=r>>3;A=128>>>(r&7);B=t>>3;C=128>>>(t&7);D=v;E=c[b+(p*36|0)+48>>2]|0;while(1){F=c[E>>2]|0;if(F>>>0>q>>>0?((d[(c[E+8>>2]|0)+x>>0]|0)&y|0)!=0:0){G=F;H=E;break b}if(F>>>0>r>>>0?((d[(c[E+8>>2]|0)+z>>0]|0)&A|0)!=0:0){G=F;H=E;break b}if(F>>>0>t>>>0?((d[(c[E+8>>2]|0)+B>>0]|0)&C|0)!=0:0){G=F;H=E;break b}D=D+-1|0;if(!D){w=14;break}else E=E+16|0}}while(0);if((w|0)==14){E=v+1|0;D=b+(p*36|0)+44|0;C=c[D>>2]|0;if(E>>>0>C>>>0){c[h>>2]=0;B=v+8&-8;A=b+(p*36|0)+48|0;z=Zae(o,16,C,B,c[A>>2]|0,h)|0;c[A>>2]=z;A=c[h>>2]|0;if(A){u=A;break}c[D>>2]=B;I=z}else I=c[b+(p*36|0)+48>>2]|0;z=I+(v<<4)|0;c[z>>2]=0;c[I+(v<<4)+12>>2]=0;c[s>>2]=E;G=0;H=z}if((q|0)>=0){if(G>>>0<=q>>>0){z=q+1|0;E=H+4|0;B=((c[E>>2]|0)+7|0)>>>3;D=(q+8|0)>>>3;c[j>>2]=0;if(D>>>0>B>>>0){A=D+7&1073741816;D=H+8|0;c[D>>2]=Zae(o,1,B,A,c[D>>2]|0,j)|0;D=c[j>>2]|0;if(D){u=D;break}c[E>>2]=A<<3}c[H>>2]=z}z=(c[H+8>>2]|0)+(q>>3)|0;a[z>>0]=d[z>>0]|0|128>>>(q&7)}if((r|0)>=0){if((c[H>>2]|0)>>>0<=r>>>0){z=r+1|0;A=H+4|0;E=((c[A>>2]|0)+7|0)>>>3;D=(r+8|0)>>>3;c[k>>2]=0;if(D>>>0>E>>>0){B=D+7&1073741816;D=H+8|0;c[D>>2]=Zae(o,1,E,B,c[D>>2]|0,k)|0;D=c[k>>2]|0;if(D){u=D;break}c[A>>2]=B<<3}c[H>>2]=z}z=(c[H+8>>2]|0)+(r>>3)|0;a[z>>0]=d[z>>0]|0|128>>>(r&7)}if((t|0)<0){i=g;return}if((c[H>>2]|0)>>>0<=t>>>0){z=t+1|0;B=H+4|0;A=((c[B>>2]|0)+7|0)>>>3;D=(t+8|0)>>>3;c[l>>2]=0;if(D>>>0>A>>>0){E=D+7&1073741816;D=H+8|0;c[D>>2]=Zae(o,1,A,E,c[D>>2]|0,l)|0;D=c[l>>2]|0;if(D){u=D;break}c[B>>2]=E<<3}c[H>>2]=z}z=(c[H+8>>2]|0)+(t>>3)|0;a[z>>0]=d[z>>0]|0|128>>>(t&7);i=g;return}else u=6;while(0);c[n>>2]=u;i=g;return}function the(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;if(c[g>>2]|0){i=d;return}h=c[a>>2]|0;do if((c[a+12>>2]|0)==1){j=a+28|0;k=c[j>>2]|0;if(k)c[(c[a+36>>2]|0)+(k+-1<<4)+12>>2]=b;l=k+1|0;m=a+32|0;n=c[m>>2]|0;if(l>>>0>n>>>0){c[f>>2]=0;o=k+8&-8;p=a+36|0;q=Zae(h,16,n,o,c[p>>2]|0,f)|0;c[p>>2]=q;p=c[f>>2]|0;if(p){r=p;break}c[m>>2]=o;s=q}else s=c[a+36>>2]|0;c[s+(k<<4)>>2]=0;c[s+(k<<4)+12>>2]=0;c[j>>2]=l;l=a+64|0;j=c[l>>2]|0;if(j)c[(c[a+72>>2]|0)+(j+-1<<4)+12>>2]=b;k=j+1|0;q=a+68|0;o=c[q>>2]|0;if(k>>>0>o>>>0){c[e>>2]=0;m=j+8&-8;p=a+72|0;n=Zae(h,16,o,m,c[p>>2]|0,e)|0;c[p>>2]=n;p=c[e>>2]|0;if(p){r=p;break}c[q>>2]=m;t=n}else t=c[a+72>>2]|0;c[t+(j<<4)>>2]=0;c[t+(j<<4)+12>>2]=0;c[l>>2]=k;i=d;return}else r=6;while(0);c[g>>2]=r;i=d;return}function uhe(a){a=a|0;c[a+4>>2]=0;c[a+16>>2]=0;c[a+28>>2]=0;c[a+40>>2]=0;c[a+52>>2]=0;c[a+64>>2]=0;c[a+76>>2]=0;c[a+12>>2]=2;return}function vhe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+128|0;g=f;if((d|0)<=0){i=f;return}h=a+4|0;j=a+12|0;k=a+((b>>>0>1?1:b)*36|0)+16|0;b=d;d=0;while(1){l=(b|0)>16?16:b;m=l<<1;n=(l|0)>0;if(n){o=0;p=d;while(1){q=(c[e+(o<<2)>>2]|0)+p|0;c[g+(o<<2)>>2]=(H8d(q)|0)>>16;o=o+1|0;if((o|0)>=(m|0)){r=q;break}else p=q}if(n){p=0;do{o=g+((p|1)<<2)|0;c[o>>2]=(c[o>>2]|0)-(c[g+(p<<2)>>2]|0);p=p+2|0}while((p|0)<(m|0));s=r}else s=r}else s=d;a:do if((c[h>>2]|0)==0?!((l|0)==0?1:((c[j>>2]|0)+-1|0)>>>0>1):0){m=l;p=g;while(1){n=zhe(k,c[p>>2]|0,c[p+4>>2]|0,c[a>>2]|0,0)|0;if(n){t=n;break}m=m+-1|0;if(!m)break a;else p=p+8|0}c[h>>2]=t}while(0);b=b-l|0;if((b|0)<=0)break;else d=s}i=f;return}function whe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=a+4|0;if(c[g>>2]|0){i=f;return}h=a+16|0;j=c[a>>2]|0;k=c[h>>2]|0;l=a+52|0;a=c[l>>2]|0;if((a+k|0)!=(d|0)){i=f;return}d=Ahe(h,e,a,k,b,j)|0;if(!d){k=Ahe(l,e,0,a,b,j)|0;if(!k){i=f;return}else m=k}else m=d;c[g>>2]=m;i=f;return}function xhe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+4|0;if(c[f>>2]|0){i=e;return}g=a+16|0;h=c[a>>2]|0;j=c[g>>2]|0;k=a+52|0;a=c[k>>2]|0;if((a+j|0)!=(b|0)){i=e;return}b=Ahe(g,d,0,j,0,h)|0;if(!b){g=Ahe(k,d,j,a,0,h)|0;if(!g){i=e;return}else l=g}else l=b;c[f>>2]=l;i=e;return}function yhe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=i;i=i+32|0;h=g+16|0;j=g;k=c[b+12>>2]|0;if(k)c[(c[b+20>>2]|0)+(k+-1<<4)+12>>2]=e;e=b+24|0;k=c[e>>2]|0;l=k+-1|0;if((l|0)<=0){m=0;i=g;return m|0}n=b+32|0;b=k;o=k;k=l;a:while(1){l=o+-2|0;b:do if((l|0)>-1){p=c[n>>2]|0;q=c[p+(k<<4)+8>>2]|0;r=c[p+(k<<4)>>2]|0;s=l;c:while(1){t=c[p+(s<<4)+8>>2]|0;u=c[p+(s<<4)>>2]|0;v=r>>>0<=u>>>0?r:u;if(v>>>0>7){u=v;w=q;x=t;while(1){if((a[x>>0]&a[w>>0])<<24>>24){y=s;break c}z=w+1|0;A=x+1|0;B=u+-8|0;if(B>>>0>7){u=B;w=z;x=A}else{C=B;D=z;E=A;break}}}else{C=v;D=q;E=t}if((C|0)!=0?(a[E>>0]&a[D>>0]&255&~(255>>>C)|0)!=0:0){y=s;break}if((s|0)>0)s=s+-1|0;else{F=b;break b}}s=(y|0)>(k|0);q=s?y:k;r=s?k:y;if((r|0)<(q|0)&(r|0)>-1&(q|0)<(b|0)){s=p+(q<<4)|0;x=p+(r<<4)|0;w=c[x>>2]|0;u=c[s>>2]|0;if(!u)G=b;else{if(u>>>0>w>>>0){A=p+(r<<4)+4|0;z=((c[A>>2]|0)+7|0)>>>3;B=(u+7|0)>>>3;c[h>>2]=0;if(B>>>0>z>>>0){H=B+7&1073741816;I=p+(r<<4)+8|0;c[I>>2]=Zae(f,1,z,H,c[I>>2]|0,h)|0;z=c[h>>2]|0;if(z){m=z;J=33;break a}c[A>>2]=H<<3;K=I}else K=p+(r<<4)+8|0;I=w;do{if((c[x>>2]|0)>>>0>I>>>0){w=(c[K>>2]|0)+(I>>3)|0;a[w>>0]=(d[w>>0]|0)&(128>>>(I&7)^255)}I=I+1|0}while((I|0)!=(u|0));L=B}else L=(u+7|0)>>>3;if(L){B=L;I=c[p+(q<<4)+8>>2]|0;x=c[p+(r<<4)+8>>2]|0;while(1){a[x>>0]=a[I>>0]|a[x>>0];B=B+-1|0;if(!B)break;else{I=I+1|0;x=x+1|0}}}G=c[e>>2]|0}c[s>>2]=0;c[p+(q<<4)+12>>2]=0;x=G+-1|0;I=x-q|0;if((I|0)>0){c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];aFi(s|0,p+(q+1<<4)|0,I<<4|0)|0;I=p+(x<<4)|0;c[I+0>>2]=c[j+0>>2];c[I+4>>2]=c[j+4>>2];c[I+8>>2]=c[j+8>>2];c[I+12>>2]=c[j+12>>2];M=c[e>>2]|0}else M=G;I=M+-1|0;c[e>>2]=I;F=I}else F=b}else F=b;while(0);l=k+-1|0;if((l|0)>0){I=k;b=F;k=l;o=I}else{m=0;J=33;break}}if((J|0)==33){i=g;return m|0}return 0}function zhe(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;if((f|0)<0){n=(f|0)==-21;o=0;p=(n?-21:0)+e|0;q=n?3:1}else{o=f;p=e;q=0}e=(h|0)!=0;if(e)c[h>>2]=-1;f=c[b>>2]|0;a:do if(!f){r=0;s=10}else{n=0;t=c[b+8>>2]|0;while(1){if((c[t>>2]|0)==(p|0)?(c[t+4>>2]|0)==(o|0):0){u=n;break a}v=n+1|0;if(v>>>0<f>>>0){n=v;t=t+12|0}else{r=v;s=10;break}}}while(0);if((s|0)==10){s=f+1|0;t=b+4|0;n=c[t>>2]|0;do if(s>>>0>=n>>>0?(c[m>>2]=0,n>>>0<s>>>0):0){v=f+8&-8;w=b+8|0;c[w>>2]=Zae(g,12,n,v,c[w>>2]|0,m)|0;w=c[m>>2]|0;if(!w){c[t>>2]=v;break}else{x=w;i=j;return x|0}}while(0);t=c[b+8>>2]|0;c[b>>2]=s;c[t+(f*12|0)>>2]=p;c[t+(f*12|0)+4>>2]=o;c[t+(f*12|0)+8>>2]=q;u=r}r=b+12|0;q=c[r>>2]|0;if(!q){f=b+16|0;do if(!(c[f>>2]|0)){c[l>>2]=0;t=b+20|0;o=Zae(g,16,0,8,c[t>>2]|0,l)|0;c[t>>2]=o;t=c[l>>2]|0;if(!t){c[f>>2]=8;y=o;break}else{x=t;i=j;return x|0}}else y=c[b+20>>2]|0;while(0);c[y>>2]=0;c[y+12>>2]=0;c[r>>2]=1;z=y}else z=(c[b+20>>2]|0)+(q+-1<<4)|0;if((u|0)>=0){if((c[z>>2]|0)>>>0<=u>>>0){q=u+1|0;b=z+4|0;y=((c[b>>2]|0)+7|0)>>>3;r=(u+8|0)>>>3;c[k>>2]=0;do if(r>>>0>y>>>0){f=r+7&1073741816;l=z+8|0;c[l>>2]=Zae(g,1,y,f,c[l>>2]|0,k)|0;l=c[k>>2]|0;if(!l){c[b>>2]=f<<3;break}else{x=l;i=j;return x|0}}while(0);c[z>>2]=q}q=(c[z+8>>2]|0)+(u>>3)|0;a[q>>0]=d[q>>0]|0|128>>>(u&7)}if(!e){x=0;i=j;return x|0}c[h>>2]=u;x=0;i=j;return x|0}function Ahe(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;i=i+16|0;l=k+8|0;m=k+4|0;n=k;o=b+12|0;p=c[o>>2]|0;if(p)c[(c[b+20>>2]|0)+(p+-1<<4)+12>>2]=h;h=p+1|0;q=b+16|0;r=c[q>>2]|0;do if(h>>>0>r>>>0){c[n>>2]=0;s=p+8&-8;t=b+20|0;u=Zae(j,16,r,s,c[t>>2]|0,n)|0;c[t>>2]=u;t=c[n>>2]|0;if(!t){c[q>>2]=s;v=u;w=s;break}else{x=t;i=k;return x|0}}else{v=c[b+20>>2]|0;w=r}while(0);c[v+(p<<4)>>2]=0;c[v+(p<<4)+12>>2]=0;c[o>>2]=h;if(!h){do if(!w){c[m>>2]=0;h=Zae(j,16,0,8,v,m)|0;c[b+20>>2]=h;r=c[m>>2]|0;if(!r){c[q>>2]=8;y=h;break}else{x=r;i=k;return x|0}}else y=v;while(0);c[y>>2]=0;c[y+12>>2]=0;c[o>>2]=1;z=y}else z=v+(p<<4)|0;p=z+4|0;v=((c[p>>2]|0)+7|0)>>>3;y=(g+7|0)>>>3;c[l>>2]=0;do if(y>>>0>v>>>0){o=y+7&1073741816;q=z+8|0;c[q>>2]=Zae(j,1,v,o,c[q>>2]|0,l)|0;q=c[l>>2]|0;if(!q){c[p>>2]=o<<3;break}else{x=q;i=k;return x|0}}while(0);c[z>>2]=g;if(!g){x=0;i=k;return x|0}p=g;g=e+(f>>>3)|0;e=128>>>(f&7);f=128;l=c[z+8>>2]|0;while(1){a[l>>0]=(((d[g>>0]|0)&e|0)==0?0:f)|(d[l>>0]|0)&(f^255);z=e>>1;v=(z|0)==0;j=f>>1;y=(j|0)==0;p=p+-1|0;if(!p){x=0;break}else{g=v?g+1|0:g;e=v?128:z;f=y?128:j;l=y?l+1|0:l}}i=k;return x|0}function Bhe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;c[f>>2]=0;h=a[b+2080>>0]|0;j=c[b>>2]|0;a:do if(!j)k=2;else{l=c[b+2076>>2]|0;m=0-l|0;n=j;o=b+4|0;while(1){p=d-(c[o+12>>2]|0)|0;if((p|0)<(m|0)){k=2;break a}if(((c[o+8>>2]|0)+l|0)>=(d|0)){q=p;r=o;break}n=n+-1|0;if(!n){k=2;break a}else o=o+32|0}if(h<<24>>24==0?(q|0)>(c[b+2072>>2]|0):0){k=2;break}c[f>>2]=1;c[f+4>>2]=c[r+16>>2];k=3}while(0);r=c[b+516>>2]|0;if(!r){i=g;return}q=c[b+2076>>2]|0;d=0-q|0;j=r;o=b+(r+-1<<5)+520|0;while(1){r=(c[o+8>>2]|0)-e|0;if((r|0)<(d|0)){s=17;break}if(((c[o+12>>2]|0)-q|0)<=(e|0)){t=r;u=o;s=13;break}j=j+-1|0;if(!j){s=17;break}else o=o+-32|0}if((s|0)==13){if(h<<24>>24==0?(t|0)>=(c[b+2072>>2]|0):0){i=g;return}c[f>>2]=k;c[f+8>>2]=c[u+16>>2];i=g;return}else if((s|0)==17){i=g;return}}function Che(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;j=b+200|0;k=b+204|0;if(!((c[j>>2]|0)==(d|0)?(c[k>>2]|0)==(f|0):0))l=3;if(((l|0)==3?(c[j>>2]=d,c[k>>2]=f,f=c[b+4>>2]|0,(f|0)!=0):0)?(k=K8d(c[b+8>>2]|0,d)|0,j=b+12|0,c[j>>2]=k,c[b+16>>2]=k+32&-64,k=f+-1|0,(k|0)!=0):0){f=k;k=b+20|0;while(1){l=K8d(c[k>>2]|0,d)|0;m=c[j>>2]|0;n=l-m|0;o=(((n|0)<0?0-n|0:n)|0)<128?m:l;c[k+4>>2]=o;c[k+8>>2]=o+32&-64;f=f+-1|0;if(!f)break;else k=k+12|0}}k=b+404|0;f=b+408|0;if((c[k>>2]|0)==(e|0)?(c[f>>2]|0)==(g|0):0){i=h;return 0}c[k>>2]=e;c[f>>2]=g;f=c[b+208>>2]|0;if((f|0)!=0?(k=K8d(c[b+212>>2]|0,e)|0,j=b+216|0,c[j>>2]=k,c[b+220>>2]=k+32&-64,k=f+-1|0,(k|0)!=0):0){f=k;k=b+224|0;while(1){d=K8d(c[k>>2]|0,e)|0;o=c[j>>2]|0;l=d-o|0;m=(((l|0)<0?0-l|0:l)|0)<128?o:d;c[k+4>>2]=m;c[k+8>>2]=m+32&-64;f=f+-1|0;if(!f)break;else k=k+12|0}}k=b+412|0;f=c[b+2476>>2]|0;if((e|0)>34359737)p=((f<<3|0)/125|0|0)>(e|0);else p=(e*125|0)<(f<<3|0);a[b+2492>>0]=p&1;p=c[b+2480>>2]|0;a:do if((p|0)>0){f=p;while(1){j=f+-1|0;if((K8d(f,e)|0)<=32){q=f;break a}if((j|0)>0)f=j;else{q=j;break}}}else q=p;while(0);c[b+2484>>2]=q;q=b+1960|0;p=b+928|0;f=b+1444|0;j=0;do{if((j|0)==1)r=p;else if(!j)r=k;else if((j|0)==2)r=f;else r=q;m=c[r>>2]|0;if(m){d=m;m=r+4|0;while(1){c[m+28>>2]=(K8d(c[m+8>>2]|0,e)|0)+g;c[m+24>>2]=(K8d(c[m+12>>2]|0,e)|0)+g;o=m+16|0;c[o>>2]=(K8d(c[m>>2]|0,e)|0)+g;c[m+20>>2]=K8d(c[m+4>>2]|0,e)|0;c[o>>2]=(c[o>>2]|0)+32&-64;d=d+-1|0;if(!d)break;else m=m+32|0}}j=j+1|0}while((j|0)!=4);j=c[k>>2]|0;if(j){k=b+1448|0;g=j;j=b+416|0;while(1){r=c[f>>2]|0;b:do if(r){m=r;d=k;while(1){o=(c[j>>2]|0)-(c[d>>2]|0)|0;if((K8d((o|0)<0?0-o|0:o,e)|0)<64){s=d;break}m=m+-1|0;if(!m)break b;else d=d+32|0}c[j+28>>2]=c[s+28>>2];c[j+24>>2]=c[s+24>>2];c[j+16>>2]=c[s+16>>2];c[j+20>>2]=c[s+20>>2]}while(0);g=g+-1|0;if(!g)break;else j=j+32|0}}j=c[p>>2]|0;if(!j){i=h;return 0}p=b+1964|0;g=j;j=b+932|0;while(1){b=c[q>>2]|0;c:do if(b){s=b;k=p;while(1){f=(c[j>>2]|0)-(c[k>>2]|0)|0;if((K8d((f|0)<0?0-f|0:f,e)|0)<64){t=k;break}s=s+-1|0;if(!s)break c;else k=k+32|0}c[j+28>>2]=c[t+28>>2];c[j+24>>2]=c[t+24>>2];c[j+16>>2]=c[t+16>>2];c[j+20>>2]=c[t+20>>2]}while(0);g=g+-1|0;if(!g)break;else j=j+32|0}i=h;return 0}function Dhe(a){a=a|0;c[a>>2]=1772;c[a+4>>2]=218;c[a+8>>2]=3561;return}function Ehe(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+16|0;k=j;l=Xae(f,2496,k)|0;m=c[k>>2]|0;if(m){n=m;c[h>>2]=l;i=j;return n|0}c[l>>2]=f;f=l+4|0;m=l+208|0;c[l+212>>2]=e[g+120>>1];o=a[g+124>>0]|0;p=o&255;if(o<<24>>24){o=p;q=g+128|0;r=l+224|0;while(1){c[r>>2]=b[q>>1];o=o+-1|0;if(!o)break;else{q=q+2|0;r=r+12|0}}}c[m>>2]=p+1;c[l+8>>2]=e[g+122>>1];p=a[g+125>>0]|0;m=p&255;if(p<<24>>24){p=m;r=g+154|0;q=l+20|0;while(1){c[q>>2]=b[r>>1];p=p+-1|0;if(!p)break;else{r=r+2|0;q=q+12|0}}}c[f>>2]=m+1;m=l+412|0;f=g+116|0;Ghe(m,d[g+8>>0]|0,g+12|0,d[g+9>>0]|0,g+40|0,c[f>>2]|0,0);Ghe(m,d[g+10>>0]|0,g+60|0,d[g+11>>0]|0,g+88|0,c[f>>2]|0,1);c[l+2476>>2]=c[g+108>>2];c[l+2480>>2]=c[g+112>>2];c[l+2488>>2]=c[f>>2];c[l+200>>2]=0;c[l+204>>2]=0;c[l+404>>2]=0;c[l+408>>2]=0;n=c[k>>2]|0;c[h>>2]=l;i=j;return n|0}function Fhe(a){a=a|0;var b=0,d=0;b=i;if(!a){i=b;return}d=c[a>>2]|0;c[a+4>>2]=0;c[a+208>>2]=0;c[a+412>>2]=0;c[a+928>>2]=0;c[a+1444>>2]=0;c[a+1960>>2]=0;$ae(d,a);i=b;return}function Ghe(a,d,e,f,g,h,j){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;k=i;if(!j){l=a+516|0;m=a}else{l=a+1548|0;m=a+1032|0}c[m>>2]=0;c[l>>2]=0;if(d>>>0>1){a=e;e=d;d=0;j=0;n=0;while(1){if(n){o=b[a>>1]|0;p=m;q=j;r=(b[a+2>>1]|0)-o|0;s=o;t=1}else{o=b[a+2>>1]|0;p=l;q=d;r=(b[a>>1]|0)-o|0;s=o;t=0}o=p+4|0;a:do if(q){u=q;v=o;while(1){w=c[v>>2]|0;if((s|0)<(w|0)){x=u;y=v;z=9;break}if((s|0)==(w|0)){A=v;break}u=u+-1|0;w=v+32|0;if(!u){B=w;z=19;break a}else v=w}if((z|0)==9){z=0;if(!x){B=y;z=19;break}else C=x;while(1){v=y+(C<<5)|0;C=C+-1|0;u=y+(C<<5)|0;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];c[v+24>>2]=c[u+24>>2];c[v+28>>2]=c[u+28>>2];if(!C){B=y;z=19;break a}}}u=A+4|0;v=c[u>>2]|0;if((r|0)<0){if((r|0)>=(v|0)){D=d;E=j;break}c[u>>2]=r;D=d;E=j;break}else{if((r|0)<=(v|0)){D=d;E=j;break}c[u>>2]=r;D=d;E=j;break}}else{B=o;z=19}while(0);do if((z|0)==19){z=0;c[B>>2]=s;c[B+4>>2]=r;if(!(t<<24>>24)){D=d+1|0;E=j;break}else{D=d;E=j+1|0;break}}while(0);e=e+-2|0;if(e>>>0<=1){F=D;G=E;break}else{a=a+4|0;d=D;j=E;n=1}}}else{F=0;G=0}c[m>>2]=G;c[l>>2]=F;if(f>>>0>1){n=l+4|0;E=g;g=f;f=F;while(1){j=b[E+2>>1]|0;D=(b[E>>1]|0)-j|0;b:do if(f){d=f;a=n;while(1){e=c[a>>2]|0;if((j|0)<(e|0)){H=d;I=a;z=26;break}if((j|0)==(e|0)){J=a;break}d=d+-1|0;e=a+32|0;if(!d){K=e;z=36;break b}else a=e}if((z|0)==26){z=0;if(!H){K=I;z=36;break}else L=H;while(1){a=I+(L<<5)|0;L=L+-1|0;d=I+(L<<5)|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[a+28>>2]=c[d+28>>2];if(!L){K=I;z=36;break b}}}d=J+4|0;a=c[d>>2]|0;if((D|0)<0){if((D|0)>=(a|0)){M=f;break}c[d>>2]=D;M=f;break}else{if((D|0)<=(a|0)){M=f;break}c[d>>2]=D;M=f;break}}else{K=n;z=36}while(0);if((z|0)==36){z=0;c[K>>2]=j;c[K+4>>2]=D;M=f+1|0}g=g+-2|0;if(g>>>0<=1){N=M;break}else{E=E+4|0;f=M}}}else N=F;c[m>>2]=G;c[l>>2]=N;if((G|0)>0){F=G;M=m+4|0;while(1){if(F>>>0>1){f=c[M>>2]|0;E=(c[M+32>>2]|0)-f|0;g=M+4|0;K=c[g>>2]|0;if((K|0)>(E|0)){c[g>>2]=E;O=f;P=E}else{O=f;P=K}}else{O=c[M>>2]|0;P=c[M+4>>2]|0}c[M+12>>2]=O;c[M+8>>2]=O+P;F=F+-1|0;if(!F)break;else M=M+32|0}}if((N|0)>0){M=N;F=l+4|0;while(1){P=c[F>>2]|0;if(M>>>0>1){O=P-(c[F+32>>2]|0)|0;K=F+4|0;f=c[K>>2]|0;if((f|0)<(O|0)){c[K>>2]=O;Q=O}else Q=f}else Q=c[F+4>>2]|0;c[F+8>>2]=P;c[F+12>>2]=P+Q;M=M+-1|0;if(!M)break;else F=F+32|0}}F=h<<1;M=m+4|0;if(G){Q=m+16|0;c[Q>>2]=(c[Q>>2]|0)-h;Q=G+-1|0;P=c[m+12>>2]|0;if(!Q){R=P;S=M}else{f=m+-28+(G<<3<<2)|0;G=Q;Q=P;P=M;while(1){M=P+44|0;m=c[M>>2]|0;O=m-Q|0;if((O|0)<(F|0)){K=((O|0)/2|0)+Q|0;c[M>>2]=K;c[P+8>>2]=K}else{c[P+8>>2]=Q+h;c[M>>2]=m-h}G=G+-1|0;m=c[P+40>>2]|0;if(!G){T=m;break}else{Q=m;P=P+32|0}}R=T;S=f}c[S+8>>2]=R+h}R=l+4|0;if(!N){i=k;return}S=l+16|0;c[S>>2]=(c[S>>2]|0)-h;S=N+-1|0;f=c[l+12>>2]|0;if(!S){U=f;V=R}else{T=l+-28+(N<<3<<2)|0;N=S;S=f;f=R;while(1){R=f+44|0;l=c[R>>2]|0;P=l-S|0;if((P|0)<(F|0)){Q=((P|0)/2|0)+S|0;W=Q;X=Q}else{W=S+h|0;X=l-h|0}c[R>>2]=X;c[f+8>>2]=W;N=N+-1|0;R=c[f+40>>2]|0;if(!N){Y=R;break}else{S=R;f=f+32|0}}U=Y;V=T}c[V+8>>2]=U+h;i=k;return}function Hhe(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;j=i;i=i+208|0;k=j+136|0;l=j+128|0;m=j;n=f+2|0;o=b[n>>1]|0;if(!(o<<16>>16)){p=0;i=j;return p|0}if(!(b[f>>1]|0)){p=0;i=j;return p|0}q=m+0|0;r=q+128|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));q=c[g>>2]|0;r=m+16|0;c[r>>2]=q;s=m+8|0;c[s>>2]=Zae(q,48,0,o<<16>>16,0,k)|0;o=c[k>>2]|0;if(!o){t=Zae(q,8,0,b[f>>1]|0,0,k)|0;u=m+12|0;c[u>>2]=t;v=c[k>>2]|0;if(!v){w=b[n>>1]|0;c[m>>2]=w<<16>>16;n=b[f>>1]|0;x=n<<16>>16;y=m+4|0;c[y>>2]=x;z=c[s>>2]|0;if(n<<16>>16){n=c[f+12>>2]|0;A=t;t=0;B=0;while(1){C=b[n+(B<<1)>>1]|0;D=t;t=C+1|0;E=t-D|0;F=z+(D*48|0)|0;c[A>>2]=F;c[A+4>>2]=E;if((E|0)>0){c[F>>2]=z+(C*48|0);c[z+(D*48|0)+8>>2]=A;if((E|0)>1){G=E;E=F;do{H=E;E=E+48|0;c[H+4>>2]=E;c[E>>2]=H;c[H+56>>2]=A;G=G+-1|0}while((G|0)>1);I=C}else I=D;c[z+(I*48|0)+4>>2]=F}B=B+1|0;if(B>>>0>=x>>>0)break;else A=A+8|0}}A=f+4|0;x=c[A>>2]|0;if(w<<16>>16){w=z;B=f+8|0;I=0;t=z;while(1){z=((c[t>>2]|0)-w|0)/48|0;n=((c[t+4>>2]|0)-w|0)/48|0;if(!(a[(c[B>>2]|0)+I>>0]&1))c[t+12>>2]=1;C=c[x+(I<<3)>>2]|0;G=C-(c[x+(z<<3)>>2]|0)|0;E=c[x+(I<<3)+4>>2]|0;H=E-(c[x+(z<<3)+4>>2]|0)|0;z=(G|0)>-1?G:0-G|0;J=(H|0)>-1?H:0-H|0;if((J*12|0)>=(z|0))if((z*12|0)<(J|0))K=(H>>31&2)+-1|0;else K=4;else K=G>>31&-4|2;a[t+20>>0]=K;J=(c[x+(n<<3)>>2]|0)-C|0;C=(c[x+(n<<3)+4>>2]|0)-E|0;E=(J|0)>-1?J:0-J|0;n=(C|0)>-1?C:0-C|0;if((n*12|0)>=(E|0))if((E*12|0)<(n|0))L=(C>>31&2)+-1|0;else L=4;else L=J>>31&-4|2;a[t+21>>0]=L;n=t+12|0;E=c[n>>2]|0;do if(!(E&1)){if((K|0)==(L|0)){if((K|0)==4){if(!(Q8d(G,H,J,C)|0))break;M=c[n>>2]|0}else M=E;c[n>>2]=M|2}}else c[n>>2]=E|2;while(0);I=I+1|0;E=c[m>>2]|0;if(I>>>0>=E>>>0){N=E;break}else t=t+48|0}c[m+20>>2]=f;c[m+24>>2]=g;if(N){t=N;N=c[s>>2]|0;I=c[A>>2]|0;while(1){c[N+16>>2]=0;c[N+32>>2]=0;c[N+36>>2]=c[I>>2];c[N+40>>2]=c[I+4>>2];t=t+-1|0;if(!t)break;else{N=N+48|0;I=I+8|0}}}}else{c[m+20>>2]=f;c[m+24>>2]=g}if(c[y>>2]|0){f=0;do{I=c[u>>2]|0;a:do if((c[I+(f<<3)+4>>2]|0)>>>0>=4){N=c[I+(f<<3)>>2]|0;t=N+36|0;A=N+40|0;M=N;while(1){K=c[M+4>>2]|0;if((K|0)==(N|0))break a;L=c[K+36>>2]|0;x=c[t>>2]|0;B=c[K+40>>2]|0;w=c[A>>2]|0;if((L|0)==(x|0)&(B|0)==(w|0))M=K;else{O=K;P=L;Q=x;R=B;S=w;break}}M=P-Q|0;A=R-S|0;t=c[N>>2]|0;if((t|0)!=(N|0)){w=t;t=Q;B=S;x=N;while(1){L=w+36|0;K=c[L>>2]|0;E=t-K|0;n=w+40|0;C=c[n>>2]|0;J=B-C|0;if(!((t|0)==(K|0)&(B|0)==(C|0))?(C=P8d(M,A,E,J)|0,(C|0)!=0):0){T=E;U=J;V=C;W=x;break}C=c[w>>2]|0;if((C|0)==(N|0))break a;J=w;w=C;t=c[L>>2]|0;B=c[n>>2]|0;x=J}x=O;B=T;t=U;w=V;N=W;while(1){A=x;M=0;while(1){J=c[A+4>>2]|0;n=(J|0)==(W|0)?1:M;L=c[J+36>>2]|0;C=c[A+36>>2]|0;E=L-C|0;K=c[J+40>>2]|0;H=c[A+40>>2]|0;G=K-H|0;if((L|0)==(C|0)&(K|0)==(H|0)){A=J;M=n;continue}H=P8d(B,t,E,G)|0;if(!H){A=J;M=n}else{X=n;Y=J;Z=E;_=G;$=H;aa=A;break}}if(($^w|0)<0){A=N;do{M=A+12|0;c[M>>2]=c[M>>2]|4;A=c[A+4>>2]|0}while((A|0)!=(aa|0));A=aa+12|0;c[A>>2]=c[A>>2]|4}if(!X){x=Y;B=Z;t=_;w=$;N=aa}else break}}}while(0);f=f+1|0}while(f>>>0<(c[y>>2]|0)>>>0)}f=Ihe(m+28|0,e+16|0,e+28|0,q)|0;c[k>>2]=f;if(!f){aa=Ihe(m+68|0,e+52|0,e+64|0,q)|0;if(!aa){q=m+24|0;e=c[q>>2]|0;$=c[e+200>>2]|0;_=c[e+404>>2]|0;e=K8d(c[g+416>>2]|0,_)|0;Z=e+32&-64;if((Z|0)==0|(e|0)==(Z|0))ba=0;else{Y=I8d(_,Z,e)|0;if((Z|0)<(e|0))ca=$-(($|0)/50|0)|0;else ca=$;Che(c[q>>2]|0,ca,Y,0,0)|0;ba=1}a[m+120>>0]=1;a[m+121>>0]=1;if((h|0)==2){da=1;ea=1}else{da=(h|0)==4&1;ea=(h|0)==3&1}a[m+122>>0]=ea;a[m+123>>0]=da;a[m+124>>0]=(h|0)!=1&1;h=m+20|0;da=g+412|0;ea=g+416|0;Y=g+928|0;ca=g+2488|0;e=g+2492|0;Z=g+2484|0;X=ba<<24>>24==0;ba=0;while(1){W=c[m>>2]|0;V=c[s>>2]|0;U=c[(c[h>>2]|0)+4>>2]|0;if(W)if(!ba){T=W;O=V;S=U;while(1){c[O+16>>2]=0;c[O+32>>2]=0;c[O+36>>2]=c[S>>2];c[O+40>>2]=c[S+4>>2];T=T+-1|0;if(!T)break;else{O=O+48|0;S=S+8|0}}}else{S=W;O=V;T=U;while(1){c[O+16>>2]=0;c[O+32>>2]=0;c[O+36>>2]=c[T+4>>2];c[O+40>>2]=c[T>>2];S=S+-1|0;if(!S)break;else{O=O+48|0;T=T+8|0}}}T=c[y>>2]|0;b:do if(!T)fa=0;else{O=c[u>>2]|0;S=0;while(1){U=c[O+(S<<3)>>2]|0;c:do if(c[O+(S<<3)+4>>2]|0){Q=U+36|0;R=U;while(1){P=c[R>>2]|0;if((P|0)==(U|0)){ga=S;ha=97;break b}if((c[P+36>>2]|0)==(c[Q>>2]|0))R=P;else{ia=P;break}}R=c[ia+4>>2]|0;Q=ia;P=R;while(1){I=P+36|0;N=P;while(1){w=c[N+4>>2]|0;if((w|0)==(R|0))break c;t=c[w+36>>2]|0;B=c[I>>2]|0;if((t|0)==(B|0))N=w;else{ja=t;ka=w;la=B;break}}if((c[Q+36>>2]|0)<(la|0)){if((ja|0)<(la|0)){ma=P;ha=82}}else if((ja|0)>(la|0)){ma=P;ha=82}if((ha|0)==82)while(1){ha=0;N=ma+16|0;c[N>>2]=c[N>>2]|64;ma=c[ma+4>>2]|0;if((ma|0)==(ka|0))break;else ha=82}Q=c[ka>>2]|0;P=ka}}while(0);S=S+1|0;if(S>>>0>=T>>>0){fa=0;break}}}while(0);d:while(1){if((ha|0)==97){ha=0;fa=ga+1|0}if(fa>>>0>=W>>>0)break;T=V+(fa*48|0)|0;S=V+(fa*48|0)+16|0;O=c[S>>2]|0;if(!(O&64)){ga=fa;ha=97;continue}U=V+(fa*48|0)+40|0;P=T;while(1){P=c[P>>2]|0;if((P|0)==(T|0)){ga=fa;ha=97;continue d}Q=c[P+40>>2]|0;R=c[U>>2]|0;if((Q|0)!=(R|0)){na=Q;oa=R;break}}U=T;while(1){U=c[U+4>>2]|0;if((U|0)==(T|0)){ga=fa;ha=97;continue d}P=c[U+40>>2]|0;if((P|0)!=(oa|0)){pa=P;break}}if((na|0)<(oa|0)&(pa|0)>(oa|0)){c[S>>2]=O|128;ga=fa;ha=97;continue}if(!((na|0)>(oa|0)&(pa|0)<(oa|0))){ga=fa;ha=97;continue}c[S>>2]=O|256;ga=fa;ha=97}V=m+(ba*40|0)+28|0;W=c[q>>2]|0;U=c[V>>2]|0;if(!U)qa=W;else{T=U;U=c[m+(ba*40|0)+36>>2]|0;while(1){Jhe(U,W,ba,m);T=T+-1|0;if(!T)break;else U=U+28|0}qa=c[q>>2]|0}U=m+(ba*40|0)+60|0;T=c[U>>2]|0;W=c[T+8>>2]|0;P=c[T>>2]|0;T=(ba|0)==0;R=T?1:2;Q=L8d(32,c[qa+(ba*204|0)+200>>2]|0)|0;N=(Q|0)>30?30:Q;e:do if(P>>>0>1){Q=c[m>>2]|0;if(!Q){ra=1;sa=0}else{I=c[W+12>>2]|0;B=m+(ba*40|0)+32|0;w=m+(ba*40|0)+40|0;t=W;x=Q;A=I>>>0>Q>>>0?Q:I;I=P;while(1){Q=t+16|0;M=c[t+28>>2]|0;H=M>>>0>x>>>0?x:M;M=H-A|0;if((M|0)>0){G=(c[s>>2]|0)+(A*48|0)|0;Khe(V,c[Q>>2]|0,c[t+24>>2]|0);Lhe(c[B>>2]|0,c[w>>2]|0,G,M,N,R)}M=I+-1|0;if(M>>>0<=1){ta=B;ua=w;ha=111;break e}t=Q;x=c[m>>2]|0;A=H;I=M}}}else if((P|0)==1){ta=m+(ba*40|0)+32|0;ua=m+(ba*40|0)+40|0;ha=111}else ha=112;while(0);if((ha|0)==111){ha=0;P=c[m>>2]|0;W=c[s>>2]|0;I=c[(c[U>>2]|0)+8>>2]|0;Khe(V,c[I>>2]|0,c[I+8>>2]|0);Lhe(c[ta>>2]|0,c[ua>>2]|0,W,P,N,R);ha=112}if((ha|0)==112){ha=0;P=c[m>>2]|0;W=(P|0)==0;if(W){ra=1;sa=0}else{I=P;A=c[s>>2]|0;while(1){do if(c[A+32>>2]|0){x=A+16|0;t=c[x>>2]|0;if(t&16)break;c[x>>2]=t|16}while(0);I=I+-1|0;if(!I){ra=W;sa=P;break}else A=A+48|0}}}if((ba|0)==1)if(ra)va=0;else{A=sa;P=c[s>>2]|0;while(1){W=a[P+20>>0]|0;if(!(!(W<<24>>24==-2|W<<24>>24==2)?(W=a[P+21>>0]|0,!(W<<24>>24==-2|W<<24>>24==2)):0))ha=123;f:do if((ha|0)==123){ha=0;W=P+16|0;I=c[W>>2]|0;if(I&16)break;R=c[P+36>>2]|0;N=c[da>>2]|0;g:do if(!N)wa=I;else{V=c[ca>>2]|0;U=0-V|0;t=P+44|0;x=I;w=N;B=ea;while(1){O=R-(c[B+12>>2]|0)|0;if((O|0)<(U|0)){wa=x;break g}do if((R|0)>((c[B+8>>2]|0)+V|0))xa=x;else{if((a[e>>0]|0)==0?(O|0)>(c[Z>>2]|0):0){xa=x;break}c[t>>2]=c[B+24>>2];S=x|48;c[W>>2]=S;xa=S}while(0);w=w+-1|0;if(!w){wa=xa;break}else{x=xa;B=B+32|0}}}while(0);N=c[Y>>2]|0;if(!N)break;I=c[ca>>2]|0;B=0-I|0;x=P+44|0;w=wa;t=N;V=g+(N+-1<<5)+932|0;while(1){N=(c[V+8>>2]|0)-R|0;if((N|0)<(B|0))break f;do if((R|0)<((c[V+12>>2]|0)-I|0))ya=w;else{if((a[e>>0]|0)==0?(N|0)>=(c[Z>>2]|0):0){ya=w;break}c[x>>2]=c[V+28>>2];U=w|48;c[W>>2]=U;ya=U}while(0);t=t+-1|0;if(!t)break;else{w=ya;V=V+-32|0}}}while(0);A=A+-1|0;if(!A){ha=141;break}else P=P+48|0}}else ha=141;if((ha|0)==141){ha=0;P=c[(c[q>>2]|0)+(ba*204|0)+200>>2]|0;if(ra)va=0;else{A=sa;V=c[s>>2]|0;while(1){w=c[V+32>>2]|0;if(w){t=V+16|0;W=c[t>>2]|0;do if(!(W&512)){if(W&1024){c[V+44>>2]=(c[w+12>>2]|0)+(c[w+8>>2]|0);break}x=(c[V+36>>2]|0)-(c[w>>2]|0)|0;if((x|0)<1){I=c[w+8>>2]|0;c[V+44>>2]=(K8d(x,P)|0)+I;break}I=c[w+4>>2]|0;R=c[w+8>>2]|0;B=c[w+12>>2]|0;if((x|0)<(I|0)){c[V+44>>2]=(I8d(x,B,I)|0)+R;break}else{c[V+44>>2]=B+R+(K8d(x-I|0,P)|0);break}}else c[V+44>>2]=c[w+8>>2];while(0);c[t>>2]=c[t>>2]|32}A=A+-1|0;if(!A)break;else V=V+48|0}va=c[m>>2]|0}}V=c[(c[q>>2]|0)+(ba*204|0)+200>>2]|0;A=c[r>>2]|0;P=c[s>>2]|0;w=P+(va*48|0)|0;do if((va|0)>0){W=0;I=P;while(1){x=((c[I+16>>2]|0)>>>4&1)+W|0;I=I+48|0;if(I>>>0>=w>>>0){za=x;break}else W=x}if(!za)break;if(za>>>0>=17){W=Zae(A,4,0,za,0,l)|0;if(!(c[l>>2]|0))Aa=W;else break}else Aa=k;W=0;I=P;while(1){if(!(c[I+16>>2]&16))Ba=W;else{t=Aa+(W<<2)|0;h:do if((W|0)>0){x=c[I+36>>2]|0;R=t;while(1){B=R+-4|0;N=c[B>>2]|0;if((c[N+36>>2]|0)<=(x|0)){Ca=R;break h}c[R>>2]=N;if(B>>>0>Aa>>>0)R=B;else{Ca=B;break}}}else Ca=t;while(0);c[Ca>>2]=I;Ba=W+1|0}I=I+48|0;if(I>>>0>=w>>>0){Da=Ba;break}else W=Ba}W=(Da|0)==0;I=Aa+(Da+-1<<2)|0;t=P;do{R=t+16|0;x=c[R>>2]|0;do if(!(x&16)){B=t+12|0;N=c[B>>2]|0;if(N&2){U=a[t+20>>0]|0;if(U<<24>>24==4)break;if(U<<24>>24!=(a[t+21>>0]|0))break;if(!(N&4|x&64))break;c[B>>2]=N&-3}N=c[t+36>>2]|0;do if(!W){B=0;while(1){U=B+1|0;if((c[(c[Aa+(B<<2)>>2]|0)+36>>2]|0)>(N|0)){Ea=B;break}if(U>>>0<Da>>>0)B=U;else{Ea=U;break}}if(!Ea){ha=180;break}B=c[Aa+(Ea+-1<<2)>>2]|0;U=Da;while(1){if(!U){Fa=0;break}O=U+-1|0;if((c[(c[Aa+(O<<2)>>2]|0)+36>>2]|0)<(N|0)){Fa=U;break}else U=O}if((Fa|0)==(Da|0)){U=c[I>>2]|0;O=c[U+44>>2]|0;c[t+44>>2]=(K8d(N-(c[U+36>>2]|0)|0,V)|0)+O;break}O=c[Aa+(Fa<<2)>>2]|0;U=c[B+36>>2]|0;if((N|0)==(U|0)){c[t+44>>2]=c[B+44>>2];break}S=c[O+36>>2]|0;M=c[O+44>>2]|0;if((N|0)==(S|0)){c[t+44>>2]=M;break}else{O=c[B+44>>2]|0;c[t+44>>2]=(I8d(N-U|0,M-O|0,S-U|0)|0)+O;break}}else ha=180;while(0);if((ha|0)==180){ha=0;O=c[Aa>>2]|0;U=c[O+44>>2]|0;c[t+44>>2]=(K8d(N-(c[O+36>>2]|0)|0,V)|0)+U}c[R>>2]=c[R>>2]|32}while(0);t=t+48|0}while(t>>>0<w>>>0);if((Aa|0)==(k|0))break;$ae(A,Aa)}while(0);A=c[y>>2]|0;w=c[q>>2]|0;V=c[w+(ba*204|0)+200>>2]|0;if(A){P=c[u>>2]|0;t=c[w+(ba*204|0)+204>>2]|0;w=A;while(1){A=c[P>>2]|0;I=c[P+4>>2]|0;W=A+(I*48|0)|0;i:do if((I|0)>0){R=0;x=0;U=A;while(1){if(!(c[U+16>>2]&32)){Ga=R;Ha=x}else{Ga=(R|0)==0?U:R;Ha=x+1|0}U=U+48|0;if(U>>>0>=W>>>0){Ia=Ga;Ja=Ha;break}else{R=Ga;x=Ha}}if(Ja>>>0<2){if((Ja|0)==1){x=c[Ia+44>>2]|0;Ka=x-(K8d(c[Ia+36>>2]|0,V)|0)|0}else Ka=t;x=A;while(1){if((x|0)!=(Ia|0))c[x+44>>2]=(K8d(c[x+36>>2]|0,V)|0)+Ka;x=x+48|0;if(x>>>0>=W>>>0){La=Ka;break i}}}x=Ia+4|0;R=c[x>>2]|0;if((R|0)==(Ia|0)){La=t;break}else{Ma=R;Na=x;Oa=Ia}while(1){if(!(c[Ma+16>>2]&32)){x=Ma;while(1){R=c[x+4>>2]|0;if(!(c[R+16>>2]&32))x=R;else{Pa=R;break}}x=c[Oa+36>>2]|0;N=c[Pa+36>>2]|0;R=c[Pa+44>>2]|0;U=c[Oa+44>>2]|0;if((x|0)>(N|0)){Qa=R;Ra=U-R|0;Sa=N;Ta=x-N|0}else{Qa=U;Ra=R-U|0;Sa=x;Ta=N-x|0}if((Ta|0)>0){x=L8d(Ra,Ta)|0;Ua=c[Na>>2]|0;Va=x}else{Ua=Ma;Va=65536}x=Ra+Qa|0;N=Ua;do{U=(c[N+36>>2]|0)-Sa|0;do if((U|0)>=1)if((U|0)<(Ta|0)){Wa=(K8d(U,Va)|0)+Qa|0;break}else{Wa=x+(K8d(U-Ta|0,V)|0)|0;break}else Wa=(K8d(U,V)|0)+Qa|0;while(0);c[N+44>>2]=Wa;N=c[N+4>>2]|0}while((N|0)!=(Pa|0));if((Pa|0)==(Ia|0)){La=t;break i}else Xa=Pa}else Xa=Ma;Na=Xa+4|0;Ma=c[Na>>2]|0;if((Ma|0)==(Ia|0)){La=t;break}else Oa=Xa}}else La=t;while(0);w=w+-1|0;if(!w)break;else{P=P+8|0;t=La}}}t=c[s>>2]|0;P=c[h>>2]|0;w=c[P+4>>2]|0;V=c[P+8>>2]|0;P=c[m>>2]|0;if(P){W=T?32:64;if(T){A=P;I=0;N=t;while(1){c[w+(I<<3)>>2]=c[N+44>>2];if(!(c[N+16>>2]&16))Ya=A;else{x=V+I|0;a[x>>0]=d[x>>0]|W;Ya=c[m>>2]|0}I=I+1|0;if(I>>>0>=Ya>>>0)break;else{A=Ya;N=N+48|0}}}else{N=P;A=0;I=t;while(1){c[w+(A<<3)+4>>2]=c[I+44>>2];if(!(c[I+16>>2]&16))Za=N;else{T=V+A|0;a[T>>0]=d[T>>0]|W;Za=c[m>>2]|0}A=A+1|0;if(A>>>0>=Za>>>0)break;else{N=Za;I=I+48|0}}}}if(!X)Che(c[q>>2]|0,$,_,0,0)|0;ba=ba+1|0;if((ba|0)==2){_a=u;$a=0;break}}}else{_a=u;$a=aa}}else{_a=u;$a=f}}else{_a=u;$a=v}}else{_a=m+12|0;$a=o}o=c[r>>2]|0;v=m+92|0;$ae(o,c[v>>2]|0);c[v>>2]=0;c[m+88>>2]=0;c[m+96>>2]=0;v=m+80|0;$ae(o,c[v>>2]|0);c[v>>2]=0;v=m+76|0;$ae(o,c[v>>2]|0);c[v>>2]=0;c[m+72>>2]=0;c[m+68>>2]=0;c[m+84>>2]=0;v=m+52|0;$ae(o,c[v>>2]|0);c[v>>2]=0;c[m+48>>2]=0;c[m+56>>2]=0;v=m+40|0;$ae(o,c[v>>2]|0);c[v>>2]=0;v=m+36|0;$ae(o,c[v>>2]|0);c[v>>2]=0;c[m+32>>2]=0;c[m+28>>2]=0;c[m+44>>2]=0;$ae(o,c[s>>2]|0);c[s>>2]=0;$ae(o,c[_a>>2]|0);c[_a>>2]=0;c[m>>2]=0;c[m+4>>2]=0;c[r>>2]=0;p=$a;i=j;return p|0}function Ihe(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=i;i=i+16|0;h=g;j=c[b>>2]|0;k=j<<1;l=a+12|0;c[l>>2]=Zae(f,4,0,k,0,h)|0;if(c[h>>2]|0){m=c[h>>2]|0;i=g;return m|0}n=a+8|0;c[n>>2]=Zae(f,28,0,j,0,h)|0;if(c[h>>2]|0){m=c[h>>2]|0;i=g;return m|0}c[a+24>>2]=Zae(f,16,0,k|1,0,h)|0;if(c[h>>2]|0){m=c[h>>2]|0;i=g;return m|0}c[a>>2]=j;k=a+16|0;c[k>>2]=(c[l>>2]|0)+(j<<2);l=a+4|0;c[l>>2]=0;c[a+20>>2]=0;c[a+28>>2]=0;f=(j|0)==0;if(!f){o=j;p=c[b+8>>2]|0;b=c[n>>2]|0;while(1){c[b>>2]=c[p>>2];c[b+4>>2]=c[p+4>>2];c[b+16>>2]=c[p+8>>2];o=o+-1|0;if(!o)break;else{p=p+12|0;b=b+28|0}}}if((e|0)!=0?(b=c[e+8>>2]|0,p=c[e>>2]|0,c[a+32>>2]=e,(p|0)!=0):0){e=0;a=p;p=b;while(1){b=c[p>>2]|0;if(!b)q=e;else{o=e;r=c[p+8>>2]|0;s=0;t=0;u=0;while(1){if(!t){v=r+1|0;w=128;x=d[r>>0]|0}else{v=r;w=t;x=u}if(((w&x|0)!=0?(y=c[n>>2]|0,z=y+(s*28|0)|0,j>>>0>s>>>0):0)?(A=y+(s*28|0)+16|0,B=c[A>>2]|0,(B&4|0)==0):0){c[A>>2]=B|4;B=c[k>>2]|0;A=y+(s*28|0)+20|0;c[A>>2]=0;a:do if(o){C=c[z>>2]|0;D=(c[y+(s*28|0)+4>>2]|0)+C|0;E=o;F=B;while(1){G=c[F>>2]|0;H=c[G>>2]|0;if((D|0)>=(H|0)?((c[G+4>>2]|0)+H|0)>=(C|0):0){I=G;break}E=E+-1|0;if(!E)break a;else F=F+4|0}c[A>>2]=I}while(0);if(o>>>0<j>>>0){A=o+1|0;c[l>>2]=A;c[B+(o<<2)>>2]=z;J=A}else J=o}else J=o;s=s+1|0;if((s|0)==(b|0)){q=J;break}else{o=J;r=v;t=w>>1;u=x}}}a=a+-1|0;if(!a){K=q;break}else{e=q;p=p+16|0}}}else K=0;if((K|0)==(j|0)|f){m=c[h>>2]|0;i=g;return m|0}else{L=K;M=0}while(1){K=c[n>>2]|0;f=K+(M*28|0)|0;if(j>>>0>M>>>0?(p=K+(M*28|0)+16|0,q=c[p>>2]|0,(q&4|0)==0):0){c[p>>2]=q|4;q=c[k>>2]|0;p=K+(M*28|0)+20|0;c[p>>2]=0;b:do if(L){e=c[f>>2]|0;a=(c[K+(M*28|0)+4>>2]|0)+e|0;x=L;w=q;while(1){v=c[w>>2]|0;J=c[v>>2]|0;if((a|0)>=(J|0)?((c[v+4>>2]|0)+J|0)>=(e|0):0){N=v;break}x=x+-1|0;if(!x)break b;else w=w+4|0}c[p>>2]=N}while(0);if(L>>>0<j>>>0){p=L+1|0;c[l>>2]=p;c[q+(L<<2)>>2]=f;O=p}else O=L}else O=L;M=M+1|0;if((M|0)==(j|0))break;else L=O}m=c[h>>2]|0;i=g;return m|0}function Jhe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+16|0;h=g;j=c[d+(e*204|0)+200>>2]|0;k=b+16|0;if(c[k>>2]&8){i=g;return}l=c[d+(e*204|0)+204>>2]|0;m=(K8d(c[b>>2]|0,j)|0)+l|0;l=b+4|0;n=K8d(c[l>>2]|0,j)|0;if((e|0)==1)if(!(a[f+121>>0]|0))o=6;else{p=1;q=(a[f+123>>0]|0)!=0}else if(!e)if(!(a[f+120>>0]|0))o=6;else{p=0;q=(a[f+122>>0]|0)!=0}else{p=0;q=0}if((o|0)==6){c[b+8>>2]=m;c[b+12>>2]=n;c[k>>2]=c[k>>2]|8;i=g;return}r=b+12|0;c[r>>2]=n;c[h>>2]=0;s=h+4|0;c[s>>2]=0;t=h+8|0;c[t>>2]=0;do if(p){u=c[b>>2]|0;Bhe(d+412|0,(c[l>>2]|0)+u|0,u,h);u=c[h>>2]|0;if((u|0)==2){v=c[t>>2]|0;c[b+8>>2]=v;w=v;break}else if((u|0)==3){v=c[t>>2]|0;c[b+8>>2]=v;c[r>>2]=(c[s>>2]|0)-v;w=v;break}else if((u|0)==1){u=(c[s>>2]|0)-n|0;c[b+8>>2]=u;w=u;break}else{o=13;break}}else o=13;while(0);if((o|0)==13){t=c[b+20>>2]|0;if(!t)x=m;else{if(!(c[t+16>>2]&8))Jhe(t,d,e,f);m=c[t+8>>2]|0;p=c[t+12>>2]>>1;x=m-(n>>1)+p+(K8d((c[b>>2]|0)-((c[t+4>>2]>>1)+(c[t>>2]|0))+(c[l>>2]>>1)|0,j)|0)|0}j=b+8|0;c[j>>2]=x;c[r>>2]=n;do if(!(a[f+124>>0]|0)){y=n;z=x}else{if((n|0)<65){if((n|0)>31){y=64;z=x+(n>>1)&-64;break}l=x+32&-64;if((n|0)<=0){y=n;z=l;break}t=x+n|0;p=t+32&-64;m=l-x|0;u=p-t|0;y=n;z=(((m|0)<0?0-m|0:m)|0)>(((u|0)<0?0-u|0:u)|0)?p:l;break}l=c[d+(e*204|0)+12>>2]|0;p=n-l|0;if((((p|0)<0?0-p|0:p)|0)<40)if((l|0)<48){A=48;B=48;C=0}else{D=l;o=25}else{D=n;o=25}if((o|0)==25){if((D|0)>=192){y=D+32&-64;z=x;break}l=D&63;p=D&-64;if(l>>>0<10){y=D;z=x;break}if(l>>>0<32){y=p|10;z=x;break}else{A=D;B=l;C=p}}y=B>>>0<54?C|54:A;z=x}while(0);x=z+32|0;A=(x&-64)-z|0;C=(x+y&-64)-z-y|0;x=((((A|0)<0?0-A|0:A)|0)>(((C|0)<0?0-C|0:C)|0)?C:A)+z|0;c[j>>2]=x;c[r>>2]=y;w=x}do if(q){x=b+8|0;y=c[r>>2]|0;if((y|0)<64)E=64;else E=y+32&-64;y=c[h>>2]|0;if((y|0)==1){c[x>>2]=(c[s>>2]|0)-E;c[r>>2]=E;break}else if((y|0)==2){c[r>>2]=E;break}else if((y|0)==3)break;else{c[r>>2]=E;y=E>>1;j=y+w|0;if(!(E&64))F=j+32&-64;else F=j&-64|32;c[x>>2]=F-y;c[r>>2]=E;break}}while(0);c[k>>2]=c[k>>2]|8;i=g;return}function Khe(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[a>>2]|0;if(g){h=g;j=c[a+8>>2]|0;while(1){k=j+16|0;c[k>>2]=c[k>>2]&-5;c[j+24>>2]=-1;h=h+-1|0;if(!h)break;else j=j+28|0}}if(!b){c[a+4>>2]=0;i=f;return}j=a+8|0;h=a+12|0;k=0;l=e;e=0;m=0;n=0;while(1){if(!m){o=l+1|0;p=128;q=d[l>>0]|0}else{o=l;p=m;q=n}if(((p&q|0)!=0?(r=c[j>>2]|0,s=r+(e*28|0)|0,t=r+(e*28|0)+16|0,r=c[t>>2]|0,(r&4|0)==0):0)?(c[t>>2]=r|4,k>>>0<g>>>0):0){c[(c[h>>2]|0)+(k<<2)>>2]=s;u=k+1|0}else u=k;e=e+1|0;if((e|0)==(b|0)){v=u;break}else{k=u;l=o;m=p>>1;n=q}}c[a+4>>2]=v;a=c[h>>2]|0;if((v|0)>1)w=1;else{i=f;return}do{h=c[a+(w<<2)>>2]|0;q=c[h>>2]|0;n=w;do{p=n;n=n+-1|0;m=a+(n<<2)|0;o=c[m>>2]|0;if((c[o>>2]|0)<(q|0))break;c[a+(p<<2)>>2]=o;c[m>>2]=h}while((n|0)>0);w=w+1|0}while((w|0)!=(v|0));i=f;return}function Lhe(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;j=i;if(!f){i=j;return}k=0-h|0;l=(b|0)==0;m=(h|0)==2;n=m?128:256;o=m?256:128;m=f;f=e;while(1){e=c[f+36>>2]|0;p=f+16|0;q=c[p>>2]|0;a:do if(!(q&16)){r=a[f+20>>0]|0;if(!((r|0)==(h|0)|(r|0)==(k|0))){s=a[f+21>>0]|0;if((s|0)==(h|0)|(s|0)==(k|0)){t=s;u=6}}else{t=r;u=6}if((u|0)==6?(u=0,(t|0)!=0):0)if((t|0)==(h|0)){if(l)break;else v=0;while(1){r=c[d+(v<<2)>>2]|0;s=e-(c[r>>2]|0)|0;v=v+1|0;if((s|0)<(g|0)&(0-s|0)<(g|0)){w=r;break}if(v>>>0>=b>>>0)break a}c[p>>2]=q|528;c[f+32>>2]=w;break}else{if((t|0)!=(k|0)|l)break;else x=0;while(1){r=c[d+(x<<2)>>2]|0;s=e-(c[r>>2]|0)-(c[r+4>>2]|0)|0;x=x+1|0;if((s|0)<(g|0)&(0-s|0)<(g|0)){y=r;break}if(x>>>0>=b>>>0)break a}c[p>>2]=q|1040;c[f+32>>2]=y;break}if(q&64){b:do if(!(q&n)){if(!((q&o|0)==0|l)){r=0;while(1){s=c[d+(r<<2)>>2]|0;z=e-(c[s>>2]|0)-(c[s+4>>2]|0)|0;r=r+1|0;if((z|0)<(g|0)&(0-z|0)<(g|0)){A=s;break}if(r>>>0>=b>>>0)break b}c[f+32>>2]=A;c[p>>2]=q|1040}}else if(!l){r=0;while(1){s=c[d+(r<<2)>>2]|0;z=e-(c[s>>2]|0)|0;r=r+1|0;if((z|0)<(g|0)&(0-z|0)<(g|0)){B=s;break}if(r>>>0>=b>>>0)break b}c[f+32>>2]=B;c[p>>2]=q|528}while(0);r=f+32|0;if(!((c[r>>2]|0)!=0|l)){s=0;while(1){z=c[d+(s<<2)>>2]|0;C=c[z>>2]|0;if((e|0)>=(C|0)?(e|0)<=((c[z+4>>2]|0)+C|0):0){D=z;break}s=s+1|0;if(s>>>0>=b>>>0)break a}c[r>>2]=D}}}while(0);m=m+-1|0;if(!m)break;else f=f+48|0}i=j;return}function Mhe(a,b){a=a|0;b=b|0;c[b>>2]=3627;c[b+4>>2]=3628;c[b+8>>2]=3629;return}function Nhe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;Uhe(a);if(!b){i=d;return}$ae(e,b);i=d;return}function Ohe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,36,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=Vhe(a)|0;c[e>>2]=h;if(!h){c[g>>2]=0;c[g+4>>2]=176;c[g+8>>2]=791048;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=c[a+200>>2];c[g+24>>2]=3630;c[g+28>>2]=3562;c[g+32>>2]=0;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function Phe(a){a=a|0;return a+108|0}function Qhe(a){a=a|0;return a+120|0}function Rhe(a){a=a|0;return a+148|0}function She(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+20|0;lhe(d,c[a+8>>2]|0)|0;Dhe(a+108|0);e=a+120|0;mhe(e);c[e>>2]=d;e=a+148|0;nhe(e);c[e>>2]=d;i=b;return 0}function The(a){a=a|0;var b=0;b=i;c[a+120>>2]=0;c[a+148>>2]=0;khe(a+20|0);i=b;return}function Uhe(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+208|0;e=c[d>>2]|0;if(!e){i=b;return}$ae(c[a>>2]|0,e);c[d>>2]=0;i=b;return}function Vhe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=Xae(c[a>>2]|0,12,d)|0;f=c[d>>2]|0;if(f){g=f;i=b;return g|0};c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;f=a+208|0;c[f>>2]=e;Mhe(a,e);e=c[d>>2]|0;if(!e){g=0;i=b;return g|0}h=c[f>>2]|0;if(!h){g=e;i=b;return g|0}$ae(c[a>>2]|0,h);c[f>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Whe(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=c[d+144>>2]|0;g=(f&256|0)==0;h=g?6:12;c[d>>2]=h;c[d+16>>2]=g?32:256;c[d+20>>2]=g?2:30;g=1<<h;c[d+4>>2]=g;c[d+8>>2]=(g|0)/2|0;g=h+-6|0;c[d+12>>2]=g;c[d+24>>2]=g;if(!(f&8)){g=d+180|0;h=(f&16)>>>2;a[g>>0]=h;if(!(f&32))a[g>>0]=h&255|1}else a[d+180>>0]=2;h=d+181|0;a[h>>0]=f>>>9&1^1;f=d+164|0;c[f>>2]=1857;g=d+168|0;c[g>>2]=117;j=d+172|0;c[j>>2]=118;k=d+176|0;c[k>>2]=3563;l=d+1024|0;c[l>>2]=0;m=d+960|0;b[m>>1]=0;n=d+962|0;b[n>>1]=(c[d+104>>2]|0)+65535;o=d+108|0;b[d+56>>1]=c[o>>2];c[d+60>>2]=c[d+116>>2];p=aie(d,0)|0;if(p){q=p;i=e;return q|0}if(((a[h>>0]|0)!=0?(a[d+180>>0]|0)!=2:0)?(c[f>>2]=1858,c[g>>2]=119,c[j>>2]=120,c[k>>2]=3564,c[l>>2]=0,b[m>>1]=0,b[n>>1]=(c[o>>2]|0)+65535,o=aie(d,1)|0,(o|0)!=0):0){q=o;i=e;return q|0}q=0;i=e;return q|0}function Xhe(a){a=a|0;c[a>>2]=1869968492;c[a+4>>2]=2840;c[a+8>>2]=1859;c[a+12>>2]=1860;c[a+16>>2]=2841;c[a+20>>2]=3565;return}function Yhe(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;e=c[a+112>>2]|0;f=0-e|0;b[a+156>>1]=f;g=da(b[d>>1]|0,f)|0;f=a+148|0;c[f>>2]=g;if((e|0)>0)c[f>>2]=(da((c[a+104>>2]|0)+-1|0,e)|0)+g;b[a+158>>1]=0;b[a+160>>1]=0;return}function Zhe(f,g,h,j,k,l){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0;l=i;k=c[f+4>>2]|0;g=0-k|0;m=c[f>>2]|0;n=(h+-1+k&g)>>m;if((j-h-k|0)>(c[f+20>>2]|0))o=(g&j)>>m;else o=n;if((o|0)<=-1){i=l;return}m=e[f+56>>1]|0;if((n|0)>=(m|0)){i=l;return}j=(n|0)<0?0:n;n=(o|0)<(m|0)?o:m+-1|0;m=j<<13>>16;o=n<<13>>16;g=255>>>(j&7);j=127>>>(n&7)^255;n=f+158|0;if((b[n>>1]|0)>(m|0))b[n>>1]=m;n=f+160|0;if((b[n>>1]|0)<(o|0))b[n>>1]=o;n=c[f+60>>2]|0;k=c[f+148>>2]|0;f=k+m|0;h=n+f|0;p=o-m|0;if((p|0)<=0){a[h>>0]=d[h>>0]|j&g;i=l;return}a[h>>0]=d[h>>0]|g;g=n+(f+1)|0;if((p+-1|0)>0){PEi(g|0,-1,o+-1-m|0)|0;q=n+(k+o)|0}else q=g;a[q>>0]=d[q>>0]|j;i=l;return}function _he(f,g,h,j,k,l){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=i;n=c[f+4>>2]|0;o=h+-1|0;p=0-n|0;q=o+n&p;r=p&j;if((q|0)>(r|0)){s=c[k+12>>2]|0;t=s&7;if((q|0)!=(r+n|0)){i=m;return}if((t|0)==4)u=(c[f+8>>2]|0)+((o+j|0)/2|0)&p;else if((t|0)==5|(t|0)==1){if((c[k+28>>2]|0)==(l|0)?(c[k+16>>2]|0)<1:0){if(!(s&16)){i=m;return}if((j-h|0)<(c[f+8>>2]|0)){i=m;return}}if((c[l+28>>2]|0)==(k|0)?(c[k+20>>2]|0)==(g<<16>>16|0):0){if(!(s&32)){i=m;return}if((j-h|0)<(c[f+8>>2]|0)){i=m;return}}if((t|0)==1)u=r;else u=(c[f+8>>2]|0)+((o+j|0)/2|0)&p}else if(!t)u=r;else{i=m;return}t=c[f>>2]|0;if((u|0)<0)v=q;else v=(u>>t|0)<(e[f+56>>1]|0)?u:r;u=((v|0)==(q|0)?r:q)>>t;r=u&7;if(((u|0)>-1?(u|0)<(e[f+56>>1]|0):0)?(d[(c[f+60>>2]|0)+((c[f+148>>2]|0)+(u<<13>>16))>>0]&128>>>r|0)!=0:0){i=m;return}else{w=t;x=v}}else{w=c[f>>2]|0;x=q}q=x>>w;if((q|0)<=-1){i=m;return}if((q|0)>=(e[f+56>>1]|0)){i=m;return}w=q>>>3;x=w&65535;v=f+158|0;t=w<<16>>16;if((b[v>>1]|0)>(t|0))b[v>>1]=x;v=f+160|0;if((b[v>>1]|0)<(t|0))b[v>>1]=x;x=(c[f+60>>2]|0)+((c[f+148>>2]|0)+t)|0;a[x>>0]=d[x>>0]|128>>>(q&7);i=m;return}function $he(a){a=a|0;var d=0;d=a+148|0;c[d>>2]=(c[d>>2]|0)+(b[a+156>>1]|0);return}function aie(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;h=i;i=i+16|0;j=h+14|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;o=f+1024|0;p=c[o>>2]|0;if((p|0)<=-1){q=0;i=h;return q|0}r=f+4|0;s=f+80|0;t=f+76|0;u=f+28|0;v=f+40|0;w=f+44|0;x=f+92|0;y=f+87|0;z=f+86|0;A=f+32|0;B=f+36|0;C=f+48|0;D=f+88|0;E=f+84|0;F=f+128|0;G=f+100|0;H=f+96|0;I=f+140|0;J=f+132|0;K=f+24|0;L=f+8|0;M=g<<24>>24!=0;g=f+136|0;N=f+68|0;O=f+72|0;P=f+180|0;Q=f+164|0;R=f+176|0;S=f+172|0;T=f+168|0;U=p;a:while(1){p=c[r>>2]|0;c[s>>2]=da(b[f+(U<<2)+962>>1]|0,p)|0;c[t>>2]=da(b[f+(U<<2)+960>>1]|0,p)|0;p=c[u>>2]|0;c[v>>2]=p;c[w>>2]=0;c[x>>2]=0;a[y>>0]=0;a[z>>0]=0;V=(c[A>>2]|0)+-32|0;c[B>>2]=V;c[C>>2]=0;c[D>>2]=p;c[p+8>>2]=p;b[E>>1]=0;b:do if((b[F>>1]|0)>0){W=c[I>>2]|0;X=c[L>>2]|0;Y=0;Z=0;while(1){c[G>>2]=0;c[H>>2]=0;_=c[J>>2]|0;$=e[W+(Y<<1)>>1]|0;aa=_+($<<3)|0;ba=_+(Z<<3)|0;ca=c[K>>2]|0;ea=(c[ba>>2]<<ca)-X|0;fa=(c[_+(Z<<3)+4>>2]<<ca)-X|0;ga=(c[aa>>2]<<ca)-X|0;ha=(c[_+($<<3)+4>>2]<<ca)-X|0;ca=M?fa:ea;ia=M?ea:fa;fa=M?ha:ga;ea=M?ga:ha;ha=c[g>>2]|0;ga=ha+Z|0;ja=a[ga>>0]|0;if(!(ja&4))ka=ja;else{a[P>>0]=(ja&255)>>>5;ka=a[ga>>0]|0}ja=ka&3;if((ja|0)==2){la=31;break a}else if(!ja){if((a[ha+$>>0]&3)==1){ma=_+($+-1<<3)|0;na=fa;oa=ea}else{ma=aa;na=(fa+ca|0)/2|0;oa=(ea+ia|0)/2|0}ea=Z+-1|0;pa=ma;qa=_+(ea<<3)|0;ra=ha+ea|0;sa=na;ta=oa}else{pa=aa;qa=ba;ra=ga;sa=ca;ta=ia}c[N>>2]=sa;c[O>>2]=ta;c:do if(qa>>>0<pa>>>0){ia=qa;ca=ra;d:while(1){ga=ia+8|0;ba=ca+1|0;aa=d[ba>>0]&3;if(!aa){ea=c[K>>2]|0;ha=c[L>>2]|0;_=(c[ga>>2]<<ea)-ha|0;fa=(c[ia+12>>2]<<ea)-ha|0;ha=M?fa:_;ea=M?_:fa;e:do if(M){fa=ia;_=ca;$=ga;ja=ba;ua=ha;va=ea;while(1){if($>>>0>=pa>>>0){wa=ua;xa=va;la=24;break d}ya=fa+16|0;za=_+2|0;Aa=d[za>>0]&3;Ba=c[K>>2]|0;Ca=c[L>>2]|0;Da=va;va=(c[ya>>2]<<Ba)-Ca|0;Ea=ua;ua=(c[fa+20>>2]<<Ba)-Ca|0;if((Aa|0)==1){Fa=ua;Ga=va;Ha=ya;Ia=za;Ja=Ea;Ka=Da;break e}else if(Aa){la=31;break a}if((lie(f,Ea,Da,(ua+Ea|0)/2|0,(va+Da|0)/2|0)|0)<<24>>24){la=86;break b}else{Da=ja;Ea=$;$=ya;ja=za;_=Da;fa=Ea}}}else{fa=ia;_=ca;ja=ga;$=ba;va=ha;ua=ea;while(1){if(ja>>>0>=pa>>>0){wa=va;xa=ua;la=24;break d}Ea=fa+16|0;Da=_+2|0;za=d[Da>>0]&3;ya=c[K>>2]|0;Aa=c[L>>2]|0;Ca=va;va=(c[Ea>>2]<<ya)-Aa|0;Ba=ua;ua=(c[fa+20>>2]<<ya)-Aa|0;if((za|0)==1){Fa=va;Ga=ua;Ha=Ea;Ia=Da;Ja=Ca;Ka=Ba;break e}else if(za){la=31;break a}if((lie(f,Ca,Ba,(va+Ca|0)/2|0,(ua+Ba|0)/2|0)|0)<<24>>24){la=86;break b}else{Ba=$;Ca=ja;ja=Ea;$=Da;_=Ba;fa=Ca}}}while(0);if(!((lie(f,Ja,Ka,Fa,Ga)|0)<<24>>24)){La=Ha;Ma=Ia}else{la=86;break b}}else if((aa|0)==1){ea=c[K>>2]|0;ha=c[L>>2]|0;fa=(c[ga>>2]<<ea)-ha|0;_=(c[ia+12>>2]<<ea)-ha|0;if(!((kie(f,M?_:fa,M?fa:_)|0)<<24>>24)){La=ga;Ma=ba}else{la=86;break b}}else{if((ia+16|0)>>>0>pa>>>0){la=31;break a}if((a[ca+2>>0]&3)!=2){la=31;break a}_=ia+24|0;fa=c[K>>2]|0;ha=c[L>>2]|0;ea=(c[ia+8>>2]<<fa)-ha|0;$=(c[ia+12>>2]<<fa)-ha|0;ja=(c[ia+16>>2]<<fa)-ha|0;ua=(c[ia+20>>2]<<fa)-ha|0;va=M?$:ea;Ca=M?ea:$;$=M?ua:ja;ea=M?ja:ua;if(_>>>0>pa>>>0){Na=va;Oa=Ca;Pa=$;Qa=ea;la=29;break}ua=(c[_>>2]<<fa)-ha|0;ja=(c[ia+28>>2]<<fa)-ha|0;if(!((mie(f,va,Ca,$,ea,M?ja:ua,M?ua:ja)|0)<<24>>24)){La=_;Ma=ca+3|0}else{la=86;break b}}if(La>>>0<pa>>>0){ia=La;ca=Ma}else{la=30;break c}}if((la|0)==24){la=0;if(!((lie(f,wa,xa,sa,ta)|0)<<24>>24))break;else{la=86;break b}}else if((la|0)==29){la=0;if(!((mie(f,Na,Oa,Pa,Qa,sa,ta)|0)<<24>>24))break;else{la=86;break b}}}else la=30;while(0);if((la|0)==30?(la=0,(kie(f,sa,ta)|0)<<24>>24!=0):0){la=86;break b}W=c[I>>2]|0;ca=(e[W+(Y<<1)>>1]|0)+1|0;ia=c[O>>2]|0;_=c[r>>2]|0;ja=_+-1&ia;if(((((ja|0)==0?(ia|0)>=(c[t>>2]|0):0)?(ia|0)<=(c[s>>2]|0):0)?(ua=c[H>>2]|0,(ua|0)!=0):0)?((c[(c[D>>2]|0)+12>>2]^c[ua+12>>2])&8|0)==0:0)c[v>>2]=(c[v>>2]|0)+-4;ua=c[D>>2]|0;ea=ua+12|0;$=c[ea>>2]|0;Ca=($&8|0)==0;if(Ca){va=c[L>>2]|0;Ra=va;Sa=((ia+-1+_&0-_)-ia|0)>=(va|0)}else{va=c[L>>2]|0;Ra=va;Sa=(ja|0)>=(va|0)}va=c[v>>2]|0;ja=va-(c[ua+8>>2]|0)|0;if((ja|0)<0){la=42;break a}if((ja|0)>0){c[ua+16>>2]=ja>>2;do if(Sa)if(Ca){c[ea>>2]=$|32;break}else{c[ea>>2]=$|16;break}while(0);c[D>>2]=va;$=va+32|0;c[v>>2]=$;c[va+16>>2]=0;c[va+8>>2]=$;c[ua+28>>2]=va;b[E>>1]=(b[E>>1]|0)+1<<16>>16;Ta=$}else Ta=va;$=c[B>>2]|0;if(Ta>>>0>=$>>>0){la=50;break}a[y>>0]=0;ea=c[H>>2]|0;if(ea)c[ua+28>>2]=ea;Y=Y+1|0;if((Y|0)>=(b[F>>1]|0)){Ua=Ta;Va=$;break}else{X=Ra;Z=ca&65535}}if((la|0)==50){la=0;c[w>>2]=98;la=87;break}Z=b[E>>1]|0;X=c[x>>2]|0;if((Z&65535)>1&(X|0)!=0)if(Z<<16>>16){Y=c[A>>2]|0;W=Z;Z=X;while(1){X=c[Z+16>>2]|0;if((W&65535)>1)Wa=(c[Z+8>>2]|0)+(X<<2)|0;else Wa=0;c[Z+4>>2]=Wa;$=Z+20|0;ea=c[$>>2]|0;if(!(c[Z+12>>2]&8)){Ca=ea-X+1|0;c[$>>2]=Ca;$=Z+8|0;c[$>>2]=(c[$>>2]|0)+(X+-1<<2);Xa=Ca;Ya=ea}else{Xa=ea;Ya=X+-1+ea|0}ea=c[C>>2]|0;X=ea;while(1){Ca=X+-1|0;if((X|0)<=0){Za=Xa;_a=Ca;la=68;break}$=c[Y+(Ca-ea<<2)>>2]|0;if(($|0)>(Xa|0))X=Ca;else{$a=$;ab=Ca;bb=X;la=65;break}}if((la|0)==65){la=0;if(($a|0)<(Xa|0)){X=Xa;ca=ab;while(1){ua=Y+(ca-ea<<2)|0;va=c[ua>>2]|0;c[ua>>2]=X;if((ca|0)>0){X=va;ca=ca+-1|0}else{cb=va;break}}if((0-bb|0)>-1){Za=cb;_a=bb+-2|0;la=68}else{db=cb;la=69}}else{Za=Xa;_a=ab;la=68}}if((la|0)==68){la=0;if((_a|0)<0){db=Za;la=69}else eb=ea}if((la|0)==69){la=0;ca=(c[B>>2]|0)+-4|0;c[B>>2]=ca;if(ca>>>0<=(c[v>>2]|0)>>>0){la=71;break}ca=ea+1|0;c[C>>2]=ca;c[Y+(~ea<<2)>>2]=db;eb=ca}ca=Ya+1|0;X=c[A>>2]|0;va=eb;while(1){ua=va+-1|0;if((va|0)<=0){fb=ca;gb=ua;la=78;break}Ca=c[X+(ua-eb<<2)>>2]|0;if((Ca|0)>(ca|0))va=ua;else{hb=Ca;ib=ua;jb=va;la=75;break}}if((la|0)==75){la=0;if((hb|0)<(ca|0)){va=ca;ea=ib;while(1){ua=X+(ea-eb<<2)|0;Ca=c[ua>>2]|0;c[ua>>2]=va;if((ea|0)>0){va=Ca;ea=ea+-1|0}else{kb=Ca;break}}if((0-jb|0)>-1){fb=kb;gb=jb+-2|0;la=78}else{lb=kb;la=79}}else{fb=ca;gb=ib;la=78}}if((la|0)==78?(la=0,(gb|0)<0):0){lb=fb;la=79}if((la|0)==79){la=0;ea=(c[B>>2]|0)+-4|0;c[B>>2]=ea;if(ea>>>0<=(c[v>>2]|0)>>>0){la=81;break}c[C>>2]=eb+1;c[X+(~eb<<2)>>2]=lb}W=W+-1<<16>>16;if(!(W<<16>>16)){la=84;break}else Z=Wa}if((la|0)==71){la=0;c[w>>2]=98;la=87;break}else if((la|0)==81){la=0;c[w>>2]=98;la=87;break}else if((la|0)==84){la=0;mb=c[v>>2]|0;nb=c[B>>2]|0;la=85;break}}else{mb=Ua;nb=Va;la=85}else{ob=Ua;pb=Va;la=83}}else{ob=p;pb=V;la=83}while(0);if((la|0)==83){la=0;c[x>>2]=0;mb=ob;nb=pb;la=85}if((la|0)==85){la=0;if(mb>>>0<nb>>>0){V=c[x>>2]|0;if(V){c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;p=c[f>>2]|0;Z=c[t>>2]>>p&65535;b[k>>1]=Z;W=c[s>>2]>>p&65535;b[j>>1]=W;p=W;W=Z;Z=V;while(1){V=Z+4|0;Y=Z;Z=c[V>>2]|0;ea=c[Y+20>>2]|0;va=ea+65535+(c[Y+16>>2]|0)|0;Ca=va&65535;if((p<<16>>16|0)>(ea<<16>>16|0)){ua=ea&65535;b[j>>1]=ua;qb=ua}else qb=p;if((W<<16>>16|0)<(va<<16>>16|0)){b[k>>1]=Ca;rb=Ca}else rb=W;c[Y>>2]=0;Ca=c[l>>2]|0;f:do if(!Ca){sb=l;tb=0}else{va=l;ua=Ca;while(1){ea=ua+4|0;if((c[ua>>2]|0)>0){sb=va;tb=ua;break f}ua=c[ea>>2]|0;if(!ua){sb=ea;tb=0;break}else va=ea}}while(0);c[V>>2]=tb;c[sb>>2]=Y;if(!Z)break;else{p=qb;W=rb}}if(!(c[C>>2]|0)){la=102;break}co[c[Q>>2]&2047](f,j,k);W=c[l>>2]|0;p=b[j>>1]|0;if(W){Z=p&65535;Ca=W;do{c[Ca+24>>2]=(c[Ca+20>>2]|0)-Z&65535;Ca=c[Ca+4>>2]|0}while((Ca|0)!=0)}Ca=c[C>>2]|0;g:do if((Ca|0)>0){if((c[(c[A>>2]|0)+(0-Ca<<2)>>2]|0)==(p<<16>>16|0)){Z=Ca+-1|0;c[C>>2]=Z;if((Z|0)>0){ub=W;vb=Z;wb=p;xb=0}else{yb=p;break}}else{ub=W;vb=Ca;wb=p;xb=0}while(1){if(ub){Z=ub;do{va=Z+4|0;ua=Z;Z=c[va>>2]|0;X=ua+24|0;ca=c[X>>2]|0;c[X>>2]=ca-xb;do if((ca|0)==(xb|0)){X=l;while(1){ea=c[X>>2]|0;if(!ea)break;$=ea+4|0;if((ea|0)==(ua|0)){zb=$;Ab=X;la=116;break}else X=$}if((la|0)==116){la=0;c[Ab>>2]=c[zb>>2]}X=c[ua>>2]|0;if(!(c[ua+12>>2]&8)){ba=c[n>>2]|0;h:do if(!ba){Bb=n;Cb=0}else{ga=n;aa=ba;while(1){$=aa+4|0;if((X|0)<(c[aa>>2]|0)){Bb=ga;Cb=aa;break h}aa=c[$>>2]|0;if(!aa){Bb=$;Cb=0;break}else ga=$}}while(0);c[va>>2]=Cb;c[Bb>>2]=ua;break}else{ba=c[m>>2]|0;i:do if(!ba){Db=m;Eb=0}else{ga=m;aa=ba;while(1){$=aa+4|0;if((X|0)<(c[aa>>2]|0)){Db=ga;Eb=aa;break i}aa=c[$>>2]|0;if(!aa){Db=$;Eb=0;break}else ga=$}}while(0);c[va>>2]=Eb;c[Db>>2]=ua;break}}while(0)}while((Z|0)!=0)}Z=c[m>>2]|0;if(Z){ua=Z;do{va=ua+8|0;ca=c[va>>2]|0;c[ua>>2]=c[ca>>2];c[va>>2]=ca+(((c[ua+12>>2]|0)>>>2&2)+-1<<2);ca=ua+16|0;c[ca>>2]=(c[ca>>2]|0)+-1;ua=c[ua+4>>2]|0}while((ua|0)!=0);ua=Z+4|0;ca=c[ua>>2]|0;if(ca){va=Z;X=ua;ua=ca;ca=m;while(1){if((c[va>>2]|0)>(c[ua>>2]|0)){c[ca>>2]=ua;ba=ua+4|0;c[X>>2]=c[ba>>2];c[ba>>2]=va;Fb=c[m>>2]|0;Gb=m}else{Fb=ua;Gb=X}X=Fb+4|0;ua=c[X>>2]|0;if(!ua)break;else{va=Fb;ca=Gb}}}}ca=c[n>>2]|0;if(ca){va=ca;do{ua=va+8|0;X=c[ua>>2]|0;c[va>>2]=c[X>>2];c[ua>>2]=X+(((c[va+12>>2]|0)>>>2&2)+-1<<2);X=va+16|0;c[X>>2]=(c[X>>2]|0)+-1;va=c[va+4>>2]|0}while((va|0)!=0);va=ca+4|0;X=c[va>>2]|0;if(!X)Hb=ca;else{ua=ca;Z=ca;ba=va;va=X;X=n;while(1){if((c[Z>>2]|0)>(c[va>>2]|0)){c[X>>2]=va;ga=va+4|0;c[ba>>2]=c[ga>>2];c[ga>>2]=Z;ga=c[n>>2]|0;Ib=ga;Jb=ga;Kb=n}else{Ib=ua;Jb=va;Kb=ba}ba=Jb+4|0;va=c[ba>>2]|0;if(!va){Hb=Ib;break}else{ua=Ib;Z=Jb;X=Kb}}}}else Hb=0;c[C>>2]=vb+-1;X=c[(c[A>>2]|0)+(0-vb<<2)>>2]<<16>>16;Z=X-(wb&65535)|0;j:do if((wb<<16>>16|0)<(X|0)){ua=Hb;va=wb;k:while(1){ba=c[m>>2]|0;ca=(ba|0)==0;do if(!ca){ga=ba;aa=n;$=0;while(1){ea=c[aa>>2]|0;ja=c[ga>>2]|0;ia=c[ea>>2]|0;_=(ja|0)>(ia|0);ha=_?ia:ja;fa=_?ja:ia;ia=c[r>>2]|0;ja=0-ia|0;_=ha&ja;Ba=ia+-1+fa&ja;do if((fa-ha|0)>(ia|0)|(_|0)==(ha|0)|(Ba|0)==(fa|0))la=145;else{if(!((_|0)>(Ba|0)|(Ba|0)==(_+ia|0))){la=145;break}if((c[ga+12>>2]&7|0)==2){Lb=$;break}c[ga>>2]=ha;c[ea>>2]=fa;c[ga+24>>2]=1;Lb=$+1<<16>>16}while(0);if((la|0)==145){la=0;rn[c[T>>2]&127](f,va,ha,fa,ga,ea);Lb=$}ga=c[ga+4>>2]|0;if(!ga){Mb=Lb;break}else{aa=ea+4|0;$=Lb}}if(Mb<<16>>16<1)break;else{Nb=ba;Ob=n}while(1){$=c[Ob>>2]|0;aa=Nb+24|0;if(c[aa>>2]|0){c[aa>>2]=0;rn[c[S>>2]&127](f,va,c[Nb>>2]|0,c[$>>2]|0,Nb,$)}Nb=c[Nb+4>>2]|0;if(!Nb)break;else Ob=$+4|0}}while(0);ko[c[R>>2]&4095](f);$=va+1<<16>>16;if(($<<16>>16|0)>=(X|0)){Pb=$;break j}do if(ca)Qb=ua;else{aa=ba;do{ga=aa+8|0;ia=c[ga>>2]|0;c[aa>>2]=c[ia>>2];c[ga>>2]=ia+(((c[aa+12>>2]|0)>>>2&2)+-1<<2);ia=aa+16|0;c[ia>>2]=(c[ia>>2]|0)+-1;aa=c[aa+4>>2]|0}while((aa|0)!=0);aa=ba+4|0;ia=c[aa>>2]|0;if(!ia){Qb=ua;break}else{Rb=ba;Sb=aa;Tb=ia;Ub=m}while(1){if((c[Rb>>2]|0)>(c[Tb>>2]|0)){c[Ub>>2]=Tb;ia=Tb+4|0;c[Sb>>2]=c[ia>>2];c[ia>>2]=Rb;Vb=c[m>>2]|0;Wb=m}else{Vb=Tb;Wb=Sb}Sb=Vb+4|0;Tb=c[Sb>>2]|0;if(!Tb)break;else{Rb=Vb;Ub=Wb}}Qb=c[n>>2]|0}while(0);if(!Qb){ua=0;va=$;continue}else Xb=Qb;do{ba=Xb+8|0;ca=c[ba>>2]|0;c[Xb>>2]=c[ca>>2];c[ba>>2]=ca+(((c[Xb+12>>2]|0)>>>2&2)+-1<<2);ca=Xb+16|0;c[ca>>2]=(c[ca>>2]|0)+-1;Xb=c[Xb+4>>2]|0}while((Xb|0)!=0);ca=Qb+4|0;ba=c[ca>>2]|0;if(!ba){ua=Qb;va=$;continue}else{Yb=Qb;Zb=Qb;_b=ca;$b=ba;ac=n}while(1){if((c[Zb>>2]|0)>(c[$b>>2]|0)){c[ac>>2]=$b;ba=$b+4|0;c[_b>>2]=c[ba>>2];c[ba>>2]=Zb;ba=c[n>>2]|0;bc=ba;cc=ba;dc=n}else{bc=Yb;cc=$b;dc=_b}ba=cc+4|0;ca=c[ba>>2]|0;if(!ca){ua=bc;va=$;continue k}else{Yb=bc;Zb=cc;_b=ba;$b=ca;ac=dc}}}}else Pb=wb;while(0);X=c[m>>2]|0;if(X){va=X;do{X=va;va=c[va+4>>2]|0;l:do if(!(c[X+16>>2]|0)){ua=m;while(1){$=c[ua>>2]|0;if(!$)break l;ca=$+4|0;if(($|0)==(X|0)){ec=ca;fc=ua;break}else ua=ca}c[fc>>2]=c[ec>>2]}while(0)}while((va|0)!=0)}va=c[n>>2]|0;if(va){X=va;do{va=X;X=c[X+4>>2]|0;m:do if(!(c[va+16>>2]|0)){ua=n;while(1){ca=c[ua>>2]|0;if(!ca)break m;$=ca+4|0;if((ca|0)==(va|0)){gc=$;hc=ua;break}else ua=$}c[hc>>2]=c[gc>>2]}while(0)}while((X|0)!=0)}X=c[C>>2]|0;if((X|0)<=0){yb=Pb;break g}ub=c[l>>2]|0;vb=X;wb=Pb;xb=Z<<16>>16}}else yb=p;while(0);if(yb<<16>>16<=(b[k>>1]|0)){p=yb;do{ko[c[R>>2]&4095](f);p=p+1<<16>>16}while(p<<16>>16<=(b[k>>1]|0))}}ic=(c[o>>2]|0)+-1|0}else la=86}if((la|0)==86){la=0;if((c[w>>2]|0)==98)la=87;else{q=1;la=180;break}}if((la|0)==87){la=0;c[w>>2]=0;p=c[o>>2]|0;Ca=b[f+(p<<2)+962>>1]|0;W=b[f+(p<<2)+960>>1]|0;Y=((Ca<<16>>16)+W|0)/2|0;if((p|0)>6){la=89;break}V=Y<<16>>16;if((V|0)<(W|0)){la=89;break}b[f+(p+1<<2)+960>>1]=Y;b[f+((c[o>>2]|0)+1<<2)+962>>1]=Ca;b[f+(c[o>>2]<<2)+962>>1]=V+65535;ic=(c[o>>2]|0)+1|0}c[o>>2]=ic;if((ic|0)>-1)U=ic;else{q=0;la=180;break}}if((la|0)==31){c[w>>2]=20;q=1;i=h;return q|0}else if((la|0)==42){c[w>>2]=99;q=1;i=h;return q|0}else if((la|0)==89){c[o>>2]=0;c[w>>2]=20;q=20;i=h;return q|0}else if((la|0)==102){c[w>>2]=20;q=20;i=h;return q|0}else if((la|0)==180){i=h;return q|0}return 0}function bie(a,b,c){a=a|0;b=b|0;c=c|0;return}function cie(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0;j=i;h=c[b+4>>2]|0;if((g-f|0)>=(h|0)){i=j;return}k=0-h|0;l=f+-1+h&k;if((l|0)!=(k&g|0)){i=j;return}g=e<<16>>16;e=l>>c[b>>2];if((e|0)<=-1){i=j;return}l=c[b+104>>2]|0;if((e|0)>=(l|0)){i=j;return}k=c[b+112>>2]|0;h=(g>>3)-(da(k,e)|0)|0;if((k|0)>0)m=h+(da(k,l+-1|0)|0)|0;else m=h;h=(c[b+60>>2]|0)+m|0;a[h>>0]=d[h>>0]|0|128>>>(g&7);i=j;return}function die(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;l=c[b+4>>2]|0;m=f+-1|0;n=0-l|0;o=m+l&n;p=n&g;if((o|0)>(p|0)){q=c[h+12>>2]|0;r=q&7;if((o|0)!=(p+l|0)){i=k;return}if((r|0)==4)s=(c[b+8>>2]|0)+((m+g|0)/2|0)&n;else if((r|0)==5|(r|0)==1){if((c[h+28>>2]|0)==(j|0)?(c[h+16>>2]|0)<1:0){if(!(q&16)){i=k;return}if((g-f|0)<(c[b+8>>2]|0)){i=k;return}}if((c[j+28>>2]|0)==(h|0)?(c[h+20>>2]|0)==(e<<16>>16|0):0){if(!(q&32)){i=k;return}if((g-f|0)<(c[b+8>>2]|0)){i=k;return}}if((r|0)==1)s=p;else s=(c[b+8>>2]|0)+((m+g|0)/2|0)&n}else if(!r)s=p;else{i=k;return}r=c[b>>2]|0;if((s|0)<0)t=o;else t=(s>>r|0)<(c[b+104>>2]|0)?s:p;s=((t|0)==(o|0)?p:o)>>r;p=c[b+60>>2]|0;n=e<<16>>16;g=n>>3;m=128>>>(n&7);n=b+104|0;f=c[b+112>>2]|0;q=g-(da(s,f)|0)|0;if((f|0)>0)u=(da((c[n>>2]|0)+-1|0,f)|0)+q|0;else u=q;q=p+u|0;if(((s|0)>-1?(s|0)<(c[n>>2]|0):0)?(m&(d[q>>0]|0)|0)!=0:0){i=k;return}else{v=g;w=m;x=r;y=p;z=t}}else{t=e<<16>>16;v=t>>3;w=128>>>(t&7);x=c[b>>2]|0;y=c[b+60>>2]|0;z=o}o=z>>x;if((o|0)<=-1){i=k;return}x=c[b+104>>2]|0;if((o|0)>=(x|0)){i=k;return}z=c[b+112>>2]|0;b=v-(da(z,o)|0)|0;if((z|0)>0)A=b+(da(z,x+-1|0)|0)|0;else A=b;b=y+A|0;a[b>>0]=d[b>>0]|0|w;i=k;return}function eie(a){a=a|0;return}function fie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[b>>2]=0;f=Xae(a,24,e)|0;g=c[e>>2]|0;if(g){i=d;return g|0}c[f+8>>2]=a;c[b>>2]=f;i=d;return g|0}function gie(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(!a){i=e;return}if((b|0)!=0&(d|0)>3075){c[a>>2]=b+1032;c[a+4>>2]=d+-1032;c[a+12>>2]=b;i=e;return}else{c[a>>2]=0;c[a+4>>2]=0;c[a+12>>2]=0;i=e;return}}function hie(a,b,c){a=a|0;b=b|0;c=c|0;return}function iie(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[d+4>>2]|0;g=c[d>>2]|0;if(((a|0)!=0?(c[a>>2]|0)!=0:0)?(h=a+4|0,(c[h>>2]|0)!=0):0)if(f){j=b[f+2>>1]|0;k=j<<16>>16;if(j<<16>>16!=0?(j=b[f>>1]|0,l=j<<16>>16,j<<16>>16>=1):0){j=c[f+12>>2]|0;if(((j|0)!=0?(c[f+4>>2]|0)!=0:0)?(k|0)==((b[j+(l+-1<<1)>>1]|0)+1|0):0){l=c[a+12>>2]|0;j=d+8|0;if(!(c[j>>2]&2))if(g)if((c[g+4>>2]|0)!=0?(c[g>>2]|0)!=0:0)if(c[g+12>>2]|0){d=l+128|0;c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];f=l+104|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];g=c[a>>2]|0;c[l+28>>2]=g;c[l+32>>2]=g+((c[h>>2]|0)>>>2<<2);if(!(c[j>>2]&1))m=Whe(l)|0;else m=19}else m=20;else m=0;else m=20;else m=19}else m=20}else m=0}else m=20;else m=96;i=e;return m|0}function jie(a){a=a|0;var b=0;b=i;$ae(c[a+8>>2]|0,a);i=b;return}function kie(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=i;j=e+100|0;k=c[j>>2]|0;do if((k|0)==2){l=c[e+72>>2]|0;if((l|0)<(g|0)){m=c[e+4>>2]|0;n=((l+-1+m&0-m)-l|0)<(c[e+8>>2]|0);l=e+40|0;m=c[l>>2]|0;o=e+88|0;p=c[o>>2]|0;q=m-(c[p+8>>2]|0)|0;if((q|0)<0){c[e+44>>2]=99;r=1;i=h;return r|0}if((q|0)>0){c[p+16>>2]=q>>2;do if(!n){q=p+12|0;s=c[q>>2]|0;if(!(s&8)){c[q>>2]=s|32;break}else{c[q>>2]=s|16;break}}while(0);c[o>>2]=m;s=m+32|0;c[l>>2]=s;c[m+16>>2]=0;c[m+8>>2]=s;c[p+28>>2]=m;q=e+84|0;b[q>>1]=(b[q>>1]|0)+1<<16>>16;t=s;u=m}else{t=m;u=p}s=c[e+36>>2]|0;if(t>>>0>=s>>>0){c[e+44>>2]=98;r=1;i=h;return r|0}q=e+87|0;a[q>>0]=0;v=e+92|0;if(!(c[v>>2]|0)){c[o>>2]=t;c[v>>2]=t;v=t+32|0;c[l>>2]=v;w=v;x=t}else{w=t;x=u}if(w>>>0>=s>>>0){c[e+44>>2]=98;r=1;i=h;return r|0}c[x+20>>2]=0;c[x+16>>2]=0;c[x+8>>2]=w;c[x+4>>2]=0;c[x+28>>2]=0;c[x+12>>2]=d[e+180>>0]|(n?8:40);s=e+96|0;if(!(c[s>>2]|0))c[s>>2]=x;c[j>>2]=1;a[e+86>>0]=1;a[q>>0]=0;y=55}else y=56}else if(!k){q=c[e+72>>2]|0;if((q|0)<(g|0)){s=c[e+4>>2]|0;v=((q+-1+s&0-s)-q|0)<(c[e+8>>2]|0);s=e+92|0;z=e+40|0;A=c[z>>2]|0;if(!(c[s>>2]|0)){c[e+88>>2]=A;c[s>>2]=A;s=A+32|0;c[z>>2]=s;B=s}else B=A;if(B>>>0>=(c[e+36>>2]|0)>>>0){c[e+44>>2]=98;r=1;i=h;return r|0}A=c[e+88>>2]|0;c[A+20>>2]=0;c[A+16>>2]=0;c[A+8>>2]=B;c[A+4>>2]=0;c[A+28>>2]=0;c[A+12>>2]=d[e+180>>0]|(v?8:40);v=e+96|0;if(!(c[v>>2]|0))c[v>>2]=A;c[j>>2]=1;a[e+86>>0]=1;a[e+87>>0]=0;y=55;break}if((q|0)>(g|0)){A=((c[e+4>>2]|0)+-1&q|0)<(c[e+8>>2]|0);q=e+92|0;v=e+40|0;s=c[v>>2]|0;if(!(c[q>>2]|0)){c[e+88>>2]=s;c[q>>2]=s;q=s+32|0;c[v>>2]=q;C=q}else C=s;if(C>>>0>=(c[e+36>>2]|0)>>>0){c[e+44>>2]=98;r=1;i=h;return r|0}s=c[e+88>>2]|0;c[s+20>>2]=0;c[s+16>>2]=0;c[s+8>>2]=C;c[s+4>>2]=0;c[s+28>>2]=0;q=d[e+180>>0]|0;c[s+12>>2]=A?q:q|16;q=e+96|0;if(!(c[q>>2]|0))c[q>>2]=s;c[j>>2]=2;a[e+86>>0]=1;a[e+87>>0]=0;y=56}else y=54}else if((k|0)==1){s=c[e+72>>2]|0;if((s|0)>(g|0)){q=((c[e+4>>2]|0)+-1&s|0)<(c[e+8>>2]|0);s=e+40|0;A=c[s>>2]|0;v=e+88|0;z=c[v>>2]|0;D=A-(c[z+8>>2]|0)|0;if((D|0)<0){c[e+44>>2]=99;r=1;i=h;return r|0}if((D|0)>0){c[z+16>>2]=D>>2;do if(!q){D=z+12|0;E=c[D>>2]|0;if(!(E&8)){c[D>>2]=E|32;break}else{c[D>>2]=E|16;break}}while(0);c[v>>2]=A;n=A+32|0;c[s>>2]=n;c[A+16>>2]=0;c[A+8>>2]=n;c[z+28>>2]=A;l=e+84|0;b[l>>1]=(b[l>>1]|0)+1<<16>>16;F=n;G=A}else{F=A;G=z}n=c[e+36>>2]|0;if(F>>>0>=n>>>0){c[e+44>>2]=98;r=1;i=h;return r|0}l=e+87|0;a[l>>0]=0;o=e+92|0;if(!(c[o>>2]|0)){c[v>>2]=F;c[o>>2]=F;o=F+32|0;c[s>>2]=o;H=o;I=F}else{H=F;I=G}if(H>>>0>=n>>>0){c[e+44>>2]=98;r=1;i=h;return r|0}c[I+20>>2]=0;c[I+16>>2]=0;c[I+8>>2]=H;c[I+4>>2]=0;c[I+28>>2]=0;n=d[e+180>>0]|0;c[I+12>>2]=q?n:n|16;n=e+96|0;if(!(c[n>>2]|0))c[n>>2]=I;c[j>>2]=2;a[e+86>>0]=1;a[l>>0]=0;y=56}else y=55}else y=54;while(0);if((y|0)==54){J=e+72|0;K=e+68|0}else if((y|0)==55){j=e+68|0;I=e+72|0;if(!((nie(e,c[j>>2]|0,c[I>>2]|0,f,g,c[e+76>>2]|0,c[e+80>>2]|0)|0)<<24>>24)){J=I;K=j}else{r=1;i=h;return r|0}}else if((y|0)==56){y=e+68|0;j=e+72|0;I=e+86|0;H=a[I>>0]|0;G=nie(e,c[y>>2]|0,0-(c[j>>2]|0)|0,f,0-g|0,0-(c[e+80>>2]|0)|0,0-(c[e+76>>2]|0)|0)|0;if(H<<24>>24!=0?(a[I>>0]|0)==0:0){I=(c[e+88>>2]|0)+20|0;c[I>>2]=0-(c[I>>2]|0)}if(!(G<<24>>24)){J=j;K=y}else{r=1;i=h;return r|0}}c[K>>2]=f;c[J>>2]=g;r=0;i=h;return r|0}function lie(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;k=i;l=e+184|0;m=e+52|0;c[m>>2]=l;n=e+68|0;c[e+200>>2]=c[n>>2];o=e+72|0;p=c[o>>2]|0;c[e+204>>2]=p;c[e+192>>2]=f;c[e+196>>2]=g;c[l>>2]=h;c[e+188>>2]=j;f=e+100|0;q=e+76|0;r=e+80|0;s=e+86|0;t=e+88|0;u=e+4|0;v=e+8|0;w=e+92|0;x=e+40|0;y=e+36|0;z=e+180|0;A=e+96|0;B=e+87|0;C=e+84|0;D=l;E=p;p=j;j=g;g=h;a:while(1){h=D+20|0;F=D+12|0;G=D+4|0;H=(E|0)>(p|0);do if(!((j|0)<((H?p:E)|0)|(j|0)>((H?E:p)|0))){if((E|0)==(p|0)){c[m>>2]=D+-16;break}I=(E|0)<(p|0);J=I?1:2;K=c[f>>2]|0;if((K|0)!=(J|0)){L=c[u>>2]|0;if(I)M=((E+-1+L&0-L)-E|0)>=(c[v>>2]|0);else M=(L+-1&E|0)>=(c[v>>2]|0);L=c[x>>2]|0;if(!K)N=L;else{K=c[t>>2]|0;O=L-(c[K+8>>2]|0)|0;if((O|0)<0){P=12;break a}if((O|0)>0){c[K+16>>2]=O>>2;do if(M){O=K+12|0;Q=c[O>>2]|0;if(!(Q&8)){c[O>>2]=Q|32;break}else{c[O>>2]=Q|16;break}}while(0);c[t>>2]=L;Q=L+32|0;c[x>>2]=Q;c[L+16>>2]=0;c[L+8>>2]=Q;c[K+28>>2]=L;b[C>>1]=(b[C>>1]|0)+1<<16>>16;R=Q}else R=L;if(R>>>0>=(c[y>>2]|0)>>>0){P=20;break a}a[B>>0]=0;N=R}if(!(c[w>>2]|0)){c[t>>2]=N;c[w>>2]=N;Q=N+32|0;c[x>>2]=Q;S=Q}else S=N;if(S>>>0>=(c[y>>2]|0)>>>0){P=25;break a}Q=c[t>>2]|0;O=Q+12|0;c[Q+20>>2]=0;c[Q+16>>2]=0;c[Q+8>>2]=S;c[Q+4>>2]=0;c[Q+28>>2]=0;T=d[z>>0]|0;c[O>>2]=T;if(I){c[O>>2]=T|8;if(M)c[O>>2]=T|40}else if(M)c[O>>2]=T|16;if(!(c[A>>2]|0))c[A>>2]=Q;c[f>>2]=J;a[s>>0]=1;a[B>>0]=0}Q=c[q>>2]|0;T=c[r>>2]|0;if(I)if(!((pie(e,2,3566,Q,T)|0)<<24>>24))break;else{U=1;P=43;break a}c[G>>2]=0-p;c[F>>2]=0-j;c[h>>2]=0-E;O=a[s>>0]|0;V=pie(e,2,3566,0-T|0,0-Q|0)|0;if(O<<24>>24!=0?(a[s>>0]|0)==0:0){O=(c[t>>2]|0)+20|0;c[O>>2]=0-(c[O>>2]|0)}c[G>>2]=0-(c[G>>2]|0);if(V<<24>>24){U=1;P=43;break a}}else{V=D+16|0;O=c[V>>2]|0;c[D+32>>2]=O;Q=D+8|0;T=c[Q>>2]|0;W=(T+O|0)/2|0;c[D+24>>2]=W;O=(g+T|0)/2|0;c[Q>>2]=O;c[V>>2]=(O+W|0)/2|0;c[D+36>>2]=E;W=(j+E|0)/2|0;c[D+28>>2]=W;O=(p+j|0)/2|0;c[F>>2]=O;c[h>>2]=(O+W|0)/2|0;c[m>>2]=D+16}while(0);h=c[m>>2]|0;if(h>>>0<l>>>0){X=g;Y=p;P=42;break}D=h;E=c[h+20>>2]|0;p=c[h+4>>2]|0;j=c[h+12>>2]|0;g=c[h>>2]|0}if((P|0)==12){c[e+44>>2]=99;U=1;i=k;return U|0}else if((P|0)==20){c[e+44>>2]=98;U=1;i=k;return U|0}else if((P|0)==25){c[e+44>>2]=98;U=1;i=k;return U|0}else if((P|0)==42){c[n>>2]=X;c[o>>2]=Y;U=0;i=k;return U|0}else if((P|0)==43){i=k;return U|0}return 0}function mie(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;m=i;n=e+184|0;o=e+52|0;c[o>>2]=n;p=e+68|0;c[e+208>>2]=c[p>>2];q=e+72|0;r=c[q>>2]|0;c[e+212>>2]=r;c[e+200>>2]=f;c[e+204>>2]=g;c[e+192>>2]=h;c[e+196>>2]=j;c[n>>2]=k;c[e+188>>2]=l;h=e+100|0;f=e+76|0;s=e+80|0;t=e+86|0;u=e+88|0;v=e+4|0;w=e+8|0;x=e+92|0;y=e+40|0;z=e+36|0;A=e+180|0;B=e+96|0;C=e+87|0;D=e+84|0;E=n;F=r;r=l;l=g;g=j;j=k;a:while(1){k=E+28|0;G=E+20|0;H=E+12|0;I=E+4|0;J=(F|0)<=(r|0);K=(l|0)>(g|0);do if(!(((K?g:l)|0)<((J?F:r)|0)?1:((K?l:g)|0)>((J?r:F)|0))){if((F|0)==(r|0)){c[o>>2]=E+-24;break}L=J?1:2;M=c[h>>2]|0;if((M|0)!=(L|0)){N=c[v>>2]|0;if(J)O=((F+-1+N&0-N)-F|0)>=(c[w>>2]|0);else O=(N+-1&F|0)>=(c[w>>2]|0);N=c[y>>2]|0;if(!M)P=N;else{M=c[u>>2]|0;Q=N-(c[M+8>>2]|0)|0;if((Q|0)<0){R=12;break a}if((Q|0)>0){c[M+16>>2]=Q>>2;do if(O){Q=M+12|0;S=c[Q>>2]|0;if(!(S&8)){c[Q>>2]=S|32;break}else{c[Q>>2]=S|16;break}}while(0);c[u>>2]=N;S=N+32|0;c[y>>2]=S;c[N+16>>2]=0;c[N+8>>2]=S;c[M+28>>2]=N;b[D>>1]=(b[D>>1]|0)+1<<16>>16;T=S}else T=N;if(T>>>0>=(c[z>>2]|0)>>>0){R=20;break a}a[C>>0]=0;P=T}if(!(c[x>>2]|0)){c[u>>2]=P;c[x>>2]=P;S=P+32|0;c[y>>2]=S;U=S}else U=P;if(U>>>0>=(c[z>>2]|0)>>>0){R=25;break a}S=c[u>>2]|0;Q=S+12|0;c[S+20>>2]=0;c[S+16>>2]=0;c[S+8>>2]=U;c[S+4>>2]=0;c[S+28>>2]=0;V=d[A>>0]|0;c[Q>>2]=V;if(J){c[Q>>2]=V|8;if(O)c[Q>>2]=V|40}else if(O)c[Q>>2]=V|16;if(!(c[B>>2]|0))c[B>>2]=S;c[h>>2]=L;a[t>>0]=1;a[C>>0]=0}S=c[f>>2]|0;V=c[s>>2]|0;if(J)if(!((pie(e,3,3567,S,V)|0)<<24>>24))break;else{W=1;R=43;break a}c[I>>2]=0-r;c[H>>2]=0-g;c[G>>2]=0-l;c[k>>2]=0-F;Q=a[t>>0]|0;X=pie(e,3,3567,0-V|0,0-S|0)|0;if(Q<<24>>24!=0?(a[t>>0]|0)==0:0){Q=(c[u>>2]|0)+20|0;c[Q>>2]=0-(c[Q>>2]|0)}c[I>>2]=0-(c[I>>2]|0);if(X<<24>>24){W=1;R=43;break a}}else{X=E+24|0;Q=c[X>>2]|0;c[E+48>>2]=Q;S=E+8|0;V=E+16|0;Y=c[V>>2]|0;Z=(c[S>>2]|0)+1|0;_=j+Z>>1;c[S>>2]=_;S=Q+1+Y>>1;c[E+40>>2]=S;Q=(Z+Y>>1)+1|0;Y=Q+_>>1;c[V>>2]=Y;V=Q+S>>1;c[E+32>>2]=V;c[X>>2]=Y+1+V>>1;c[E+52>>2]=F;V=g+1|0;Y=r+V>>1;c[H>>2]=Y;X=F+1+l>>1;c[E+44>>2]=X;S=(V+l>>1)+1|0;V=S+Y>>1;c[G>>2]=V;Y=S+X>>1;c[E+36>>2]=Y;c[k>>2]=V+1+Y>>1;c[o>>2]=E+24}while(0);k=c[o>>2]|0;if(k>>>0<n>>>0){$=j;aa=r;R=42;break}E=k;F=c[k+28>>2]|0;r=c[k+4>>2]|0;l=c[k+20>>2]|0;g=c[k+12>>2]|0;j=c[k>>2]|0}if((R|0)==12){c[e+44>>2]=99;W=1;i=m;return W|0}else if((R|0)==20){c[e+44>>2]=98;W=1;i=m;return W|0}else if((R|0)==25){c[e+44>>2]=98;W=1;i=m;return W|0}else if((R|0)==42){c[p>>2]=$;c[q>>2]=aa;W=0;i=m;return W|0}else if((R|0)==43){i=m;return W|0}return 0}function nie(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=i;l=f-d|0;f=g-e|0;if((f|0)<1|(g|0)<(h|0)|(e|0)>(j|0)){m=0;i=k;return m|0}if((h|0)>(e|0)){n=(I8d(l,h-e|0,f)|0)+d|0;o=c[b>>2]|0;p=n;q=o;r=h>>o;s=0}else{o=c[b>>2]|0;p=d;q=o;r=e>>o;s=(c[b+4>>2]|0)+-1&e}if((g|0)>(j|0)){t=0;u=j}else{t=(c[b+4>>2]|0)+-1&g;u=g}g=u>>q;do if((s|0)>0)if((r|0)==(g|0)){m=0;i=k;return m|0}else{v=(I8d(l,(c[b+4>>2]|0)-s|0,f)|0)+p|0;w=b+87|0;x=r+1|0;break}else{q=b+87|0;if(!(a[q>>0]|0)){v=p;w=q;x=r}else{u=b+40|0;c[u>>2]=(c[u>>2]|0)+-4;a[q>>0]=0;v=p;w=q;x=r}}while(0);a[w>>0]=(t|0)==0&1;t=b+86|0;if(a[t>>0]|0){c[(c[b+88>>2]|0)+20>>2]=x;a[t>>0]=0}t=g-x|0;w=t+1|0;r=b+40|0;if(((c[r>>2]|0)+(w<<2)|0)>>>0>=(c[b+36>>2]|0)>>>0){c[b+44>>2]=98;m=1;i=k;return m|0}p=b+4|0;b=c[p>>2]|0;if((l|0)>0){s=I8d(b,l,f)|0;y=da(c[p>>2]|0,l)|0;z=1;A=s}else{s=0-l|0;l=0-(I8d(b,s,f)|0)|0;y=da(c[p>>2]|0,s)|0;z=-1;A=l}l=(y|0)%(f|0)|0;y=c[r>>2]|0;if((t|0)>-1){t=x+-1-g|0;s=g+((t|0)>-1?t:-1)+2-x|0;x=v;v=0-f|0;t=w;w=y;while(1){c[w>>2]=x;g=x+A|0;p=v+l|0;if((p|0)>-1){B=g+z|0;C=p-f|0}else{B=g;C=p}t=t+-1|0;if((t|0)<=0)break;else{x=B;v=C;w=w+4|0}}D=y+(s<<2)|0}else D=y;c[r>>2]=D;m=0;i=k;return m|0}function oie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+16|0;d=c[b>>2]|0;c[a+32>>2]=d;e=a+8|0;f=c[e>>2]|0;g=(d+f|0)/2|0;c[a+24>>2]=g;d=((c[a>>2]|0)+f|0)/2|0;c[e>>2]=d;c[b>>2]=(d+g|0)/2|0;g=a+20|0;d=c[g>>2]|0;c[a+36>>2]=d;b=a+12|0;e=c[b>>2]|0;f=(d+e|0)/2|0;c[a+28>>2]=f;d=((c[a+4>>2]|0)+e|0)/2|0;c[b>>2]=d;c[g>>2]=(d+f|0)/2|0;return}function pie(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=i;j=b+52|0;k=c[j>>2]|0;l=c[k+(d<<3)+4>>2]|0;m=c[k+4>>2]|0;n=b+40|0;o=c[n>>2]|0;if(!((m|0)<(f|0)|(l|0)>(g|0))){p=b+4|0;q=c[p>>2]|0;r=0-q|0;s=m&r;m=(s|0)>(g|0)?g:s;if((l|0)>=(f|0)){s=l+-1+q&r;if(!(l&65535&q+65535)){l=b+87|0;if(!(a[l>>0]|0))t=o;else{a[l>>0]=0;t=o+-4|0}c[t>>2]=c[k+(d<<3)>>2];u=q+s|0;v=s;w=t+4|0}else{u=s;v=s;w=o}}else{u=f;v=f;w=o}f=b+86|0;if(a[f>>0]|0){c[(c[b+88>>2]|0)+20>>2]=v>>c[b>>2];a[f>>0]=0}if((m|0)<(u|0)){x=k;y=w}else{if((w+((m-u>>c[b>>2])+1<<2)|0)>>>0>=(c[b+36>>2]|0)>>>0){c[n>>2]=w;c[b+44>>2]=98;z=1;i=h;return z|0}f=b+87|0;v=b+16|0;b=0-d|0;s=k;t=u;u=w;a:while(1){w=s;while(1){a[f>>0]=0;q=c[w+4>>2]|0;if((q|0)<=(t|0)){A=q;B=w;C=19;break}l=c[w+(d<<3)+4>>2]|0;r=q-l|0;if((r|0)<(c[v>>2]|0)){D=l;E=r;F=w;C=16;break}ko[e&4095](w);w=w+(d<<3)|0;if(w>>>0<k>>>0){G=u;break a}}if((C|0)==16){C=0;w=c[F+(d<<3)>>2]|0;c[u>>2]=((da((c[F>>2]|0)-w|0,t-D|0)|0)/(E|0)|0)+w;H=F;I=(c[p>>2]|0)+t|0;J=u+4|0}else if((C|0)==19){C=0;if((A|0)==(t|0)){a[f>>0]=1;c[u>>2]=c[B>>2];H=B;I=(c[p>>2]|0)+t|0;J=u+4|0}else{H=B;I=t;J=u}}s=H+(b<<3)|0;if(s>>>0<k>>>0|(I|0)>(m|0)){G=J;break}else{t=I;u=J}}x=c[j>>2]|0;y=G}}else{x=k;y=o}c[n>>2]=y;c[j>>2]=x+(0-d<<3);z=0;i=h;return z|0}function qie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+24|0;d=c[b>>2]|0;c[a+48>>2]=d;e=a+8|0;f=a+16|0;g=c[f>>2]|0;h=(c[e>>2]|0)+1|0;i=h+(c[a>>2]|0)>>1;c[e>>2]=i;e=g+1+d>>1;c[a+40>>2]=e;d=(h+g>>1)+1|0;g=d+i>>1;c[f>>2]=g;f=d+e>>1;c[a+32>>2]=f;c[b>>2]=g+1+f>>1;f=a+28|0;g=c[f>>2]|0;c[a+52>>2]=g;b=a+12|0;e=a+20|0;d=c[e>>2]|0;i=(c[b>>2]|0)+1|0;h=i+(c[a+4>>2]|0)>>1;c[b>>2]=h;b=d+1+g>>1;c[a+44>>2]=b;g=(i+d>>1)+1|0;d=g+h>>1;c[e>>2]=d;e=g+b>>1;c[a+36>>2]=e;c[f>>2]=d+1+e>>1;return}function rie(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;yie(a);if(!b){i=d;return}$ae(e,b);i=d;return}function sie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;g=Xae(f,60,e)|0;h=c[e>>2]|0;if(h){j=h;i=d;return j|0}h=zie(a)|0;c[e>>2]=h;if(!h){c[g>>2]=2;c[g+4>>2]=72;c[g+8>>2]=791064;c[g+12>>2]=65536;c[g+16>>2]=131072;c[g+20>>2]=0;c[g+24>>2]=3631;c[g+28>>2]=0;c[g+32>>2]=0;c[g+36>>2]=1869968492;c[g+40>>2]=273;c[g+44>>2]=274;c[g+48>>2]=1861;c[g+52>>2]=1773;c[g+56>>2]=(c[a+216>>2]|0)+4;c[b>>2]=g;j=0;i=d;return j|0}else{$ae(f,g);j=c[e>>2]|0;i=d;return j|0}return 0}function tie(a){a=a|0;var b=0,d=0;b=i;d=c[a+4>>2]|0;co[c[(c[(c[a+20>>2]|0)+56>>2]|0)+8>>2]&2047](c[a+60>>2]|0,c[d+172>>2]|0,c[d+176>>2]|0);i=b;return 0}function uie(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+64|0;k=h+48|0;l=h;m=e+72|0;if((c[m>>2]|0)!=(c[d+24>>2]|0)){c[j>>2]=6;n=6;i=h;return n|0}o=a[(c[(c[d+20>>2]|0)+8>>2]|0)+6>>0]|0;if((f|0)==2){if(o<<24>>24==53){n=19;i=h;return n|0}}else if(o<<24>>24==49){n=19;i=h;return n|0}o=e+108|0;if(g)iae(o,c[g>>2]|0,c[g+4>>2]|0);hae(o,k);g=(c[k>>2]|0)+32&-64;c[k>>2]=g;p=k+4|0;q=(c[p>>2]|0)+32&-64;c[p>>2]=q;r=k+8|0;s=(c[r>>2]|0)+32&-64;c[r>>2]=s;r=k+12|0;t=(c[r>>2]|0)+32&-64;c[r>>2]=t;u=s-g>>6;g=t-q>>6;if((g|u)>>>0>65535){c[j>>2]=6;n=6;i=h;return n|0}q=e+76|0;t=c[d+8>>2]|0;s=e+156|0;if(c[(c[s>>2]|0)+4>>2]&1){v=e+88|0;$ae(t,c[v>>2]|0);c[v>>2]=0;v=(c[s>>2]|0)+4|0;c[v>>2]=c[v>>2]&-2}if(!(f&2)){b[e+92>>1]=256;w=2;x=u+3&-4}else{w=1;x=(u+15|0)>>>4<<1}f=e+94|0;a[f>>0]=w;c[e+80>>2]=u;c[q>>2]=g;c[e+84>>2]=x;c[e+88>>2]=Zae(t,g,0,x,0,j)|0;x=c[j>>2]|0;if(x){n=x;i=h;return n|0}x=(c[s>>2]|0)+4|0;c[x>>2]=c[x>>2]|1;iae(o,0-(c[k>>2]|0)|0,0-(c[p>>2]|0)|0);c[l>>2]=q;c[l+4>>2]=o;c[l+8>>2]=(a[f>>0]|0)==2&1;c[j>>2]=_n[c[d+64>>2]&4095](c[d+60>>2]|0,l)|0;iae(o,c[k>>2]|0,c[p>>2]|0);p=c[j>>2]|0;if(p){n=p;i=h;return n|0}c[m>>2]=1651078259;c[e+100>>2]=c[k>>2]>>6;c[e+104>>2]=c[r>>2]>>6;n=0;i=h;return n|0}function vie(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if((c[b+72>>2]|0)!=(c[a+24>>2]|0)){g=6;i=f;return g|0}if(d)kae(b+108|0,d);if(!e){g=0;i=f;return g|0}iae(b+108|0,c[e>>2]|0,c[e+4>>2]|0);g=0;i=f;return g|0}function wie(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;if((c[b+72>>2]|0)!=(c[a+24>>2]|0)){i=e;return}hae(b+108|0,d);i=e;return}function xie(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[(c[(c[a+20>>2]|0)+56>>2]|0)+12>>2]&2047](c[a+60>>2]|0,b,d)|0;i=e;return f|0}function yie(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;e=a+216|0;a=c[e>>2]|0;if(!a){i=b;return}f=(c[a>>2]|0)+-1|0;c[a>>2]=f;if(f){i=b;return}$ae(d,a);c[e>>2]=0;i=b;return}function zie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=a+216|0;f=c[e>>2]|0;if(f){c[f>>2]=(c[f>>2]|0)+1;g=c[d>>2]|0;i=b;return g|0}f=Xae(c[a>>2]|0,28,d)|0;h=c[d>>2]|0;if(h){g=h;i=b;return g|0};c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[e>>2]=f;c[f>>2]=1;Xhe(f+4|0);if(((c[d>>2]|0)!=0?(f=c[a>>2]|0,a=c[e>>2]|0,(a|0)!=0):0)?(h=(c[a>>2]|0)+-1|0,c[a>>2]=h,(h|0)==0):0){$ae(f,a);c[e>>2]=0}g=c[d>>2]|0;i=b;return g|0}function Aie(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+196|0;e=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=Die(a)|0;i=b;return d|0}function Bie(a){a=a|0;var b=0;b=i;Cie(a);i=b;return}function Cie(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+196|0;if(!(c[d>>2]|0)){i=b;return}e=c[a>>2]|0;j9d(a);$ae(e,c[d>>2]|0);c[d>>2]=0;i=b;return}function Die(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=Xae(c[a>>2]|0,68,d)|0;f=c[d>>2]|0;if(f){g=f;i=b;return g|0}f=e+0|0;h=f+68|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));f=a+196|0;c[f>>2]=e;h=k9d(a)|0;c[d>>2]=h;if(!h){_8d(e+4|0);Z8d(e+36|0);e=c[d>>2]|0;if(!e){g=0;i=b;return g|0}else j=e}else j=h;if(!(c[f>>2]|0)){g=j;i=b;return g|0}j=c[a>>2]|0;j9d(a);$ae(j,c[f>>2]|0);c[f>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Eie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=a+204|0;f=c[e>>2]|0;if(!f){i=b;return}g=c[f>>2]|0;if(g)mbe(a,g);c[f>>2]=0;g=f+4|0;h=c[g>>2]|0;if(h)ece(a,h);c[g>>2]=0;$ae(d,f);c[e>>2]=0;i=b;return}function Fie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=Xae(c[a>>2]|0,136,d)|0;f=c[d>>2]|0;if(f){g=f;i=b;return g|0}PEi(e|0,0,136)|0;f=a+204|0;c[f>>2]=e;h=nbe(a,e)|0;c[d>>2]=h;if(!h){j=fce(a,e+4|0)|0;c[d>>2]=j;if(!j){ibe(a,e+8|0);hbe(a,e+28|0);jbe(a,e+36|0);kbe(a,e+40|0);lbe(a,e+44|0);mce(a,e+56|0);nce(a,e+96|0);e=c[d>>2]|0;if(!e){g=0;i=b;return g|0}else k=e}else k=j}else k=h;h=c[a>>2]|0;j=c[f>>2]|0;if(!j){g=k;i=b;return g|0}k=c[j>>2]|0;if(k)mbe(a,k);c[j>>2]=0;k=j+4|0;e=c[k>>2]|0;if(e)ece(a,e);c[k>>2]=0;$ae(h,j);c[f>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Gie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;e=a+220|0;f=c[e>>2]|0;if(!f){i=b;return}g=c[f>>2]|0;if(g)Xce(a,g);c[f>>2]=0;g=f+20|0;h=c[g>>2]|0;if(h)pde(a,h);c[g>>2]=0;$ae(d,f);c[e>>2]=0;i=b;return}function Hie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=Xae(c[a>>2]|0,196,d)|0;f=c[d>>2]|0;if(f){g=f;i=b;return g|0}PEi(e|0,0,196)|0;f=a+220|0;c[f>>2]=e;h=Yce(a,e)|0;c[d>>2]=h;if(!h){j=qde(a,e+20|0)|0;c[d>>2]=j;if(!j){Uce(a,e+4|0);Vce(a,e+12|0);Wce(a,e+16|0);Tce(e+24|0);Zce(a,e+36|0);e=c[d>>2]|0;if(!e){g=0;i=b;return g|0}else k=e}else k=j}else k=h;h=c[a>>2]|0;j=c[f>>2]|0;if(!j){g=k;i=b;return g|0}k=c[j>>2]|0;if(k)Xce(a,k);c[j>>2]=0;k=j+20|0;e=c[k>>2]|0;if(e)pde(a,e);c[k>>2]=0;$ae(h,j);c[f>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Iie(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;e=a+224|0;a=c[e>>2]|0;if(!a){i=b;return}f=(c[a>>2]|0)+-1|0;c[a>>2]=f;if(f){i=b;return}$ae(d,a);c[e>>2]=0;i=b;return}function Jie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=a+224|0;f=c[e>>2]|0;if(f){c[f>>2]=(c[f>>2]|0)+1;g=c[d>>2]|0;i=b;return g|0}f=Xae(c[a>>2]|0,28,d)|0;h=c[d>>2]|0;if(h){g=h;i=b;return g|0};c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[e>>2]=f;c[f>>2]=1;cfe(f+4|0);if(((c[d>>2]|0)!=0?(f=c[a>>2]|0,a=c[e>>2]|0,(a|0)!=0):0)?(h=(c[a>>2]|0)+-1|0,c[a>>2]=h,(h|0)==0):0){$ae(f,a);c[e>>2]=0}g=c[d>>2]|0;i=b;return g|0}function Kie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a>>2]|0;e=a+228|0;f=c[e>>2]|0;if(!f){i=b;return}g=c[f>>2]|0;if(g)zfe(a,g);c[f>>2]=0;$ae(d,f);c[e>>2]=0;i=b;return}function Lie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=Xae(c[a>>2]|0,28,d)|0;f=c[d>>2]|0;if(f){g=f;i=b;return g|0};c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;f=a+228|0;c[f>>2]=e;h=Afe(a,e)|0;c[d>>2]=h;if(!h){xfe(e+4|0);yfe(e+24|0);e=c[d>>2]|0;if(!e){g=0;i=b;return g|0}else j=e}else j=h;h=c[a>>2]|0;e=c[f>>2]|0;if(!e){g=j;i=b;return g|0}j=c[e>>2]|0;if(j)zfe(a,j);c[e>>2]=0;$ae(h,e);c[f>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Mie(a){a=a|0;var b=0,d=0,e=0;b=i;if(a){d=Erc(a)|0;if(!d)e=a;else{i=b;return (c[d+76>>2]|0)==-2|0}}else e=0;Orc(e);return 0}function Nie(b){b=b|0;var d=0,e=0,f=0;d=i;e=xCi(68)|0;c[e>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+4>>2]=60;c[e+16>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;c[e+20>>2]=60;c[e+32>>2]=0;c[e+40>>2]=0;c[e+44>>2]=0;c[e+36>>2]=60;a[e+48>>0]=0;f=e+52|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[b+8>>2]=e;i=d;return}function Oie(a){a=a|0;var b=0,d=0;b=i;if((a|0)!=0?(d=c[a+8>>2]|0,(d|0)!=0):0){oje(d);ACi(d)}i=b;return}function Pie(b,d,e,f,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=ea(t);u=ea(u);v=ea(v);w=ea(w);x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;y=i;i=i+48|0;z=y;A=y+40|0;B=y+32|0;C=y+24|0;D=y+8|0;E=y+4|0;Stc(A,d);g[B>>2]=t;g[B+4>>2]=u;g[C>>2]=v;g[C+4>>2]=w;if(!b)Mrc(791816,z);d=b+8|0;b=c[d>>2]|0;if(!b)Mrc(791816,z);Vtc(D,A);if(!e)F=0;else F=Erc(e)|0;w=ea(g[f>>2]);e=w<ea(0.0);v=e?ea(0.0):w;e=v>ea(1.0);A=~~ea(ea(v*ea(255.0))+ea(.5))>>>0&255;a[E>>0]=e?-1:A;v=ea(g[f+4>>2]);A=v<ea(0.0);w=A?ea(0.0):v;A=w>ea(1.0);e=~~ea(ea(w*ea(255.0))+ea(.5))>>>0&255;a[E+1>>0]=A?-1:e;w=ea(g[f+8>>2]);e=w<ea(0.0);v=e?ea(0.0):w;e=v>ea(1.0);A=~~ea(ea(v*ea(255.0))+ea(.5))>>>0&255;a[E+2>>0]=e?-1:A;v=ea(g[f+12>>2]);f=v<ea(0.0);w=f?ea(0.0):v;f=w>ea(1.0);A=~~ea(ea(w*ea(255.0))+ea(.5))>>>0&255;a[E+3>>0]=f?-1:A;c[z+0>>2]=c[E+0>>2];m8d(b,D,F,z,h,j,k,l<<24>>24!=0,m<<24>>24!=0,n,o,p,q,r<<24>>24!=0,s,B,C,0,x<<24>>24!=0);xri(D);D=c[d>>2]|0;if(!D)Mrc(791816,z);else{i=y;return a[D+48>>0]|0}return 0}function Qie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;if(!b)Mrc(791816,e);f=c[b+8>>2]|0;if(!f)Mrc(791816,e);else{g[a+8>>2]=ea(g[f+52>>2]);g[a+12>>2]=ea(g[f+56>>2]);i=d;return}}function Rie(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if((b|0)!=0?(f=c[b+8>>2]|0,(f|0)!=0):0){if(!(a[f+48>>0]|0)){g=0;i=d;return g|0}g=c[f+60>>2]|0;i=d;return g|0}Mrc(791816,e);return 0}function Sie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+64|0;e=d+24|0;f=d;if(!b)Nrc(791072,e);g=c[(Xbd()|0)+600>>2]|0;if(!a)Mrc(791816,e);h=c[a+8>>2]|0;if(!h)Mrc(791816,e);a=b+8|0;j=yrc(c[a>>2]|0)|0;k=h+8|0;l=c[k>>2]|0;if(j>>>0<l>>>0){j=Isc(g,60,l)|0;c[a>>2]=j;m=j;n=c[k>>2]|0}else{m=c[a>>2]|0;n=l}yrc(m)|0;if((n|0)<=0){o=c[k>>2]|0;p=b+12|0;c[p>>2]=o;q=b+16|0;r=c[q>>2]|0;s=r+1|0;c[q>>2]=s;i=d;return}l=0;a=c[h>>2]|0;while(1){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];h=c[a+24>>2]|0;aFi(e|0,a+28|0,32)|0;j=Gsc(m,l,60)|0;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=h;h=j+28|0;c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[h+16>>2]=c[e+16>>2];c[h+20>>2]=c[e+20>>2];c[h+24>>2]=c[e+24>>2];c[h+28>>2]=c[e+28>>2];l=l+1|0;if((l|0)==(n|0))break;else a=a+60|0}o=c[k>>2]|0;p=b+12|0;c[p>>2]=o;q=b+16|0;r=c[q>>2]|0;s=r+1|0;c[q>>2]=s;i=d;return}function Tie(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+64|0;e=d+32|0;f=d;if(!b)Mrc(791816,e);g=b+8|0;b=c[g>>2]|0;if(!b)Mrc(791816,e);if(!(a[b+48>>0]|0))h=0;else h=c[b+60>>2]|0;b=Isc(c[(Xbd()|0)+600>>2]|0,60,h)|0;if(!h){i=d;return b|0}j=0;while(1){k=c[g>>2]|0;if(!k){l=9;break}m=c[k>>2]|0;k=m+(j*60|0)|0;n=c[m+(j*60|0)+24>>2]|0;o=m+(j*60|0)+28|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[e+16>>2]=c[k+16>>2];c[e+20>>2]=c[k+20>>2];c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[f+16>>2]=c[o+16>>2];c[f+20>>2]=c[o+20>>2];c[f+24>>2]=c[o+24>>2];c[f+28>>2]=c[o+28>>2];o=Gsc(b,j,60)|0;c[o+0>>2]=c[e+0>>2];c[o+4>>2]=c[e+4>>2];c[o+8>>2]=c[e+8>>2];c[o+12>>2]=c[e+12>>2];c[o+16>>2]=c[e+16>>2];c[o+20>>2]=c[e+20>>2];c[o+24>>2]=n;n=o+28|0;c[n+0>>2]=c[f+0>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];c[n+16>>2]=c[f+16>>2];c[n+20>>2]=c[f+20>>2];c[n+24>>2]=c[f+24>>2];c[n+28>>2]=c[f+28>>2];j=j+1|0;if(j>>>0>=h>>>0){l=11;break}}if((l|0)==9)Mrc(791816,e);else if((l|0)==11){i=d;return b|0}return 0}function Uie(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if((b|0)!=0?(f=c[b+8>>2]|0,(f|0)!=0):0){if(!(a[f+48>>0]|0)){g=0;i=d;return g|0}g=c[f+24>>2]|0;i=d;return g|0}Mrc(791816,e);return 0}function Vie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;if(!b)Nrc(791072,e);f=c[(Xbd()|0)+604>>2]|0;if(!a)Mrc(791816,e);g=c[a+8>>2]|0;if(!g)Mrc(791816,e);a=b+8|0;h=yrc(c[a>>2]|0)|0;j=g+24|0;k=c[j>>2]|0;if(h>>>0<k>>>0){h=Isc(f,12,k)|0;c[a>>2]=h;l=h;m=c[j>>2]|0}else{l=c[a>>2]|0;m=k}yrc(l)|0;if((m|0)<=0){n=c[j>>2]|0;o=b+12|0;c[o>>2]=n;p=b+16|0;q=c[p>>2]|0;r=q+1|0;c[p>>2]=r;i=d;return}k=0;a=c[g+16>>2]|0;while(1){aFi(e|0,a|0,12)|0;g=Gsc(l,k,12)|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];k=k+1|0;if((k|0)==(m|0))break;else a=a+12|0}n=c[j>>2]|0;o=b+12|0;c[o>>2]=n;p=b+16|0;q=c[p>>2]|0;r=q+1|0;c[p>>2]=r;i=d;return}function Wie(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;if(!b)Mrc(791816,e);f=b+8|0;b=c[f>>2]|0;if(!b)Mrc(791816,e);if(!(a[b+48>>0]|0))g=0;else g=c[b+24>>2]|0;b=Isc(c[(Xbd()|0)+604>>2]|0,12,g)|0;if(!g){i=d;return b|0}h=0;while(1){j=c[f>>2]|0;if(!j){k=9;break}l=(c[j+16>>2]|0)+(h*12|0)|0;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];l=Gsc(b,h,12)|0;c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];h=h+1|0;if(h>>>0>=g>>>0){k=11;break}}if((k|0)==9)Mrc(791816,e);else if((k|0)==11){i=d;return b|0}return 0}function Xie(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if((b|0)!=0?(f=c[b+8>>2]|0,(f|0)!=0):0){if(!(a[f+48>>0]|0)){g=0;i=d;return g|0}g=c[f+40>>2]|0;i=d;return g|0}Mrc(791816,e);return 0}function Yie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;if(!b)Nrc(791072,e);f=c[(Xbd()|0)+608>>2]|0;if(!a)Mrc(791816,e);g=c[a+8>>2]|0;if(!g)Mrc(791816,e);e=b+8|0;a=yrc(c[e>>2]|0)|0;h=g+40|0;j=c[h>>2]|0;if(a>>>0<j>>>0){a=Isc(f,8,j)|0;c[e>>2]=a;k=a;l=c[h>>2]|0}else{k=c[e>>2]|0;l=j}yrc(k)|0;if((l|0)<=0){m=c[h>>2]|0;n=b+12|0;c[n>>2]=m;o=b+16|0;p=c[o>>2]|0;q=p+1|0;c[o>>2]=q;i=d;return}j=0;e=c[g+32>>2]|0;while(1){g=e;a=c[g>>2]|0;f=c[g+4>>2]|0;g=Gsc(k,j,8)|0;c[g>>2]=a;c[g+4>>2]=f;j=j+1|0;if((j|0)==(l|0))break;else e=e+8|0}m=c[h>>2]|0;n=b+12|0;c[n>>2]=m;o=b+16|0;p=c[o>>2]|0;q=p+1|0;c[o>>2]=q;i=d;return}function Zie(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;if(!b)Mrc(791816,e);f=b+8|0;b=c[f>>2]|0;if(!b)Mrc(791816,e);if(!(a[b+48>>0]|0))g=0;else g=c[b+40>>2]|0;b=Isc(c[(Xbd()|0)+608>>2]|0,8,g)|0;if(!g){i=d;return b|0}else h=0;while(1){j=c[f>>2]|0;if(!j){k=8;break}l=(c[j+32>>2]|0)+(h<<3)|0;j=c[l>>2]|0;m=c[l+4>>2]|0;l=Gsc(b,h,8)|0;c[l>>2]=j;c[l+4>>2]=m;h=h+1|0;if(h>>>0>=g>>>0){k=10;break}}if((k|0)==8)Mrc(791816,e);else if((k|0)==10){i=d;return b|0}return 0}function _ie(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;if((a|0)!=0?(e=c[a+8>>2]|0,(e|0)!=0):0){i=b;return c[e+64>>2]|0}Mrc(791816,d);return 0}function $ie(){var a=0;a=i;xrc(791104,3632);i=a;return}function aje(){var a=0;a=i;xrc(791136,3568);i=a;return}function bje(){var a=0;a=i;xrc(791168,3569);i=a;return}function cje(){var a=0;a=i;xrc(791208,2);i=a;return}function dje(){var a=0;a=i;xrc(791272,3054);i=a;return}function eje(){var a=0;a=i;xrc(791320,3633);i=a;return}function fje(){var a=0;a=i;xrc(791368,3055);i=a;return}function gje(){var a=0;a=i;xrc(791416,3634);i=a;return}function hje(){var a=0;a=i;xrc(791464,3635);i=a;return}function ije(){var a=0;a=i;xrc(791512,3056);i=a;return}function jje(){var a=0;a=i;xrc(791568,3636);i=a;return}function kje(){var a=0;a=i;xrc(791616,3637);i=a;return}function lje(){var a=0;a=i;xrc(791664,3057);i=a;return}function mje(){var a=0;a=i;xrc(791712,3638);i=a;return}function nje(){var a=0;a=i;xrc(791760,3639);i=a;return}function oje(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+44>>2]|0)>-1){f=a+32|0;g=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function pje(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+32>>2]|0;if(!e){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;i=d;return}else{b=e+168|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];i=d;return}}function qje(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+16|0;g=f+4|0;h=f;if((b|0)==(d|0)){i=f;return}j=e+8|0;k=e+12|0;l=e+4|0;m=b;b=c[j>>2]|0;while(1){n=b+1|0;c[j>>2]=n;o=c[k>>2]|0;p=o&2147483647;if(n>>>0>p>>>0){q=o<<1;r=(q|0)==0?1:q;do if(p>>>0<r>>>0)if((o|0)>-1){c[k>>2]=r;q=c[e>>2]|0;c[h>>2]=c[l>>2];c[g+0>>2]=c[h+0>>2];c[e>>2]=hOb(q,r<<4,4,g,0,3653512,370)|0;break}else{c[h>>2]=c[l>>2];c[g+0>>2]=c[h+0>>2];q=cOb(r<<4,4,g,0,3653512,352)|0;YEi(q|0,c[e>>2]|0,c[j>>2]<<4|0)|0;c[k>>2]=r;c[e>>2]=q;break}while(0);s=c[j>>2]|0}else s=n;r=s+-1|0;o=c[e>>2]|0;p=o+(r<<4)|0;c[p>>2]=0;c[o+(r<<4)+4>>2]=m;if(!(a[m+148>>0]|0)){q=c[m>>2]|0;t=c[m+4>>2]|0;u=t;v=0;w=m;while(1){if((t|0)!=(u|0)){x=w;break}if(a[w+148>>0]|0){x=w;break}y=(c[w+140>>2]|0)+v|0;c[p>>2]=y;z=w+152|0;if((z|0)==(d|0)){x=d;break}if((q|0)!=(c[z>>2]|0)){x=z;break}u=c[w+156>>2]|0;v=y;w=z}a[o+(r<<4)+12>>0]=1;A=x}else{a[o+(r<<4)+12>>0]=0;A=m+152|0}w=(A-m|0)/152|0;c[o+(r<<4)+8>>2]=w;m=m+(w*152|0)|0;if((m|0)==(d|0))break;else b=s}i=f;return}function rje(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a>>2]|0;h=a+4|0;if((g|0)==(h|0)){i=b;return}a=g;while(1){g=a+52|0;j=c[g>>2]|0;if(j){kQb(j);c[g>>2]=0}g=a+32|0;if((c[g>>2]|0)>-1){j=a+20|0;k=c[j>>2]|0;c[e>>2]=c[a+24>>2];c[d+0>>2]=c[e+0>>2];eOb(k,d);c[j>>2]=0}c[a+28>>2]=0;c[g>>2]=0;g=a+36|0;j=a+44|0;if((c[j>>2]|0)>0){k=0;do{l=c[(c[g>>2]|0)+(k<<2)>>2]|0;m=c[153110]|0;if(l){if((c[l+28>>2]|0)>-1){n=l+16|0;o=c[n>>2]|0;c[e>>2]=c[l+20>>2];c[d+0>>2]=c[e+0>>2];eOb(o,d);c[n>>2]=0}if((c[l+12>>2]|0)>-1){n=c[l>>2]|0;c[e>>2]=c[l+4>>2];c[d+0>>2]=c[e+0>>2];eOb(n,d);c[l>>2]=0}}c[f>>2]=m;c[d+0>>2]=c[f+0>>2];eOb(l,d);c[(c[g>>2]|0)+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(c[j>>2]|0))}k=a+48|0;if((c[k>>2]|0)>-1){l=c[g>>2]|0;c[e>>2]=c[a+40>>2];c[d+0>>2]=c[e+0>>2];eOb(l,d);c[g>>2]=0}c[j>>2]=0;c[k>>2]=0;k=c[a+4>>2]|0;if(!k){l=a;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){p=m;break}else l=m}}else{l=k;while(1){j=c[l>>2]|0;if(!j){p=l;break}else l=j}}if((p|0)==(h|0))break;else a=p}i=b;return}function sje(e,f,h,j){e=e|0;f=f|0;h=h|0;j=ea(j);var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=Im,Fa=Im,Ga=Im,Ha=Im,Ia=Im,Ja=0,Ka=0,La=Im,Ma=Im,Na=Im,Oa=Im,Pa=Im,Qa=Im,Ra=0,Sa=Im,Ta=Im,Ua=Im,Va=Im,Wa=Im,Xa=Im,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=Im,cb=Im,db=Im,eb=Im,fb=Im,gb=Im,hb=0,ib=0,jb=0,kb=0,lb=Im,mb=Im,nb=Im,ob=Im,pb=Im,qb=Im,rb=0,sb=Im,tb=Im,ub=Im,vb=Im,wb=Im,xb=Im,yb=Im,zb=0,Ab=0,Bb=0,Cb=Im,Db=Im,Eb=Im,Fb=Im,Gb=0,Hb=Im,Ib=Im,Jb=Im,Kb=0,Lb=Im,Mb=Im,Nb=Im,Ob=Im,Pb=Im,Qb=Im,Rb=Im,Sb=Im,Tb=Im,Ub=Im,Vb=Im,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=Im,dc=Im,ec=Im,fc=Im,gc=Im,hc=Im,ic=Im,jc=Im,kc=Im,lc=Im,mc=Im,nc=Im,oc=Im,pc=Im,qc=Im,rc=Im,sc=Im,tc=Im,uc=0,vc=Im,wc=Im,xc=Im,yc=Im,zc=Im,Ac=Im,Bc=Im,Cc=Im,Dc=Im,Ec=Im,Fc=0,Gc=0,Hc=Im,Ic=Im,Jc=Im,Kc=Im,Lc=Im,Mc=Im,Nc=Im,Oc=Im,Pc=Im,Qc=Im,Rc=Im,Sc=Im,Tc=0,Uc=0;k=i;i=i+432|0;l=k;m=k+344|0;n=k+128|0;o=k+152|0;p=k+280|0;q=k+216|0;r=k+64|0;s=k+360|0;t=k+384|0;u=k+408|0;v=k+412|0;w=k+416|0;x=c[f+32>>2]|0;y=(h|0)>0;if(y){z=0;A=0;while(1){B=(c[e+(z<<4)>>2]|0)+A|0;z=z+1|0;if((z|0)==(h|0)){C=B;break}else A=B}if((C|0)>65535){c[l>>2]=65535;Lsd(m,791856,l);if(!(a[m>>0]&1))D=m+1|0;else D=c[m+8>>2]|0;Krd(D,0,3653512,207,1,0,0,0);xri(m)}else{E=C;F=8}}else{E=0;F=8}if((F|0)==8){Odc(x,E,159);pec(x,h,0);if(y){C=0;do{lec(x,0,((c[e+(C<<4)>>2]|0)/4|0)*6|0,C,0,41)|0;C=C+1|0}while((C|0)!=(h|0))}G=ea(ea(j*ea(255.0))+ea(.5));if(!(G>=ea(0.0)))H=ea(G+ea(-.99999994));else H=G;G=ea(g[150280]);j=ea(g[150281]);I=ea(g[150282]);J=ea(-G);K=ea(-j);L=ea(-I);if(y){C=x+28|0;M=ea(ea(~~H&255|0)/ea(255.0));D=l+4|0;A=l+8|0;z=q+4|0;B=q+8|0;N=q+16|0;O=q+20|0;P=q+24|0;Q=q+32|0;R=q+36|0;S=q+40|0;V=l+16|0;W=l+32|0;X=l+48|0;Y=l+20|0;Z=l+36|0;_=l+52|0;$=l+24|0;aa=l+40|0;ba=l+56|0;ca=r+4|0;fa=r+8|0;ga=r+16|0;ha=r+20|0;ia=r+24|0;ja=r+32|0;ka=r+36|0;la=r+40|0;ma=o+4|0;na=o+8|0;oa=o+16|0;pa=o+20|0;qa=o+24|0;ra=o+32|0;sa=o+36|0;ta=o+40|0;ua=p+4|0;va=p+8|0;wa=p+16|0;xa=p+20|0;ya=p+24|0;za=p+32|0;Aa=p+36|0;Ba=p+40|0;Ca=x+44|0;Da=n+12|0;H=G;Ea=j;Fa=I;Ga=J;Ha=K;Ia=L;Ja=0;Ka=0;while(1){if(!(a[e+(Ja<<4)+12>>0]|0)){La=Ia;Ma=Ha;Na=Ga;Oa=Fa;Pa=Ea;Qa=H;Ra=Ka}else{Sa=ea(g[150280]);Ta=ea(g[150281]);Ua=ea(g[150282]);Va=ea(-Sa);Wa=ea(-Ta);Xa=ea(-Ua);Ya=c[(c[C>>2]|0)+92>>2]|0;Za=(KLc()|0)==1;_a=e+(Ja<<4)+8|0;$a=c[_a>>2]|0;if(($a|0)>0){ab=e+(Ja<<4)+4|0;bb=Xa;cb=Wa;db=Va;eb=Ua;fb=Ta;gb=Sa;hb=$a;$a=0;ib=Ya+(Ka*60|0)|0;while(1){Ya=c[ab>>2]|0;jb=c[Ya+($a*152|0)+140>>2]|0;if(!jb){kb=hb;lb=bb;mb=cb;nb=db;ob=eb;pb=fb;qb=gb;rb=ib}else{sb=ea(g[Ya+($a*152|0)+116>>2]);do if(Za){do if(!(sb<=ea(.0404499993)))if(sb<ea(1.0)){tb=ea(+U(+ea(ea(sb+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{tb=ea(+U(+sb,2.20000005));break}else tb=ea(sb/ea(12.9200001));while(0);ub=ea(g[Ya+($a*152|0)+120>>2]);do if(!(ub<=ea(.0404499993)))if(ub<ea(1.0)){vb=ea(+U(+ea(ea(ub+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{vb=ea(+U(+ub,2.20000005));break}else vb=ea(ub/ea(12.9200001));while(0);ub=ea(g[Ya+($a*152|0)+124>>2]);if(ub<=ea(.0404499993)){wb=ea(ub/ea(12.9200001));xb=vb;yb=tb;break}if(ub<ea(1.0)){wb=ea(+U(+ea(ea(ub+ea(.0549999997))/ea(1.05499995)),2.4000001));xb=vb;yb=tb;break}else{wb=ea(+U(+ub,2.20000005));xb=vb;yb=tb;break}}else{ub=ea(g[Ya+($a*152|0)+120>>2]);wb=ea(g[Ya+($a*152|0)+124>>2]);xb=ub;yb=sb}while(0);sb=ea(M*ea(g[Ya+($a*152|0)+128>>2]));ub=ea(sb*ea(g[Ya+($a*152|0)+132>>2]));zb=l+0|0;Ab=Ya+($a*152|0)+12|0;Bb=zb+64|0;do{c[zb>>2]=c[Ab>>2];zb=zb+4|0;Ab=Ab+4|0}while((zb|0)<(Bb|0));Ab=c[Ya+($a*152|0)+136>>2]|0;a:do if(!(a[621175]|0)){if(!Za){tMc(l,r);sb=ea(g[l>>2]);Cb=ea(g[D>>2]);Db=ea(g[A>>2]);Eb=ea(T(ea(ea(ea(sb*sb)+ea(Cb*Cb))+ea(Db*Db))));if(Eb>ea(9.99999997e-07))Fb=ea(ea(1.0)/Eb);else Fb=ea(1.0);g[r>>2]=ea(Fb*ea(g[r>>2]));g[ca>>2]=ea(Fb*ea(g[ca>>2]));g[fa>>2]=ea(Fb*ea(g[fa>>2]));g[ga>>2]=ea(Fb*ea(g[ga>>2]));g[ha>>2]=ea(Fb*ea(g[ha>>2]));g[ia>>2]=ea(Fb*ea(g[ia>>2]));g[ja>>2]=ea(Fb*ea(g[ja>>2]));g[ka>>2]=ea(Fb*ea(g[ka>>2]));g[la>>2]=ea(Fb*ea(g[la>>2]));zb=ib;Bb=Ab;Gb=jb;Eb=sb;sb=gb;Db=fb;Cb=eb;Hb=db;Ib=cb;Jb=bb;while(1){Kb=Gb+-1|0;Lb=ea(g[Bb>>2]);Mb=ea(Eb*Lb);Nb=ea(g[V>>2]);Ob=ea(g[Bb+4>>2]);Pb=ea(Mb+ea(Nb*Ob));Nb=ea(g[W>>2]);Mb=ea(g[Bb+8>>2]);Qb=ea(Pb+ea(Nb*Mb));Nb=ea(ea(g[X>>2])+Qb);g[zb>>2]=Nb;Qb=ea(Lb*ea(g[D>>2]));Pb=ea(Qb+ea(Ob*ea(g[Y>>2])));Qb=ea(Pb+ea(Mb*ea(g[Z>>2])));Pb=ea(ea(g[_>>2])+Qb);g[zb+4>>2]=Pb;Qb=ea(Lb*ea(g[A>>2]));Lb=ea(Qb+ea(Ob*ea(g[$>>2])));Ob=ea(Lb+ea(Mb*ea(g[aa>>2])));Mb=ea(ea(g[ba>>2])+Ob);g[zb+8>>2]=Mb;Ob=Nb<sb?Nb:sb;Lb=Pb<Db?Pb:Db;Qb=Mb<Cb?Mb:Cb;Rb=Hb<Nb?Nb:Hb;Nb=Ib<Pb?Pb:Ib;Pb=Jb<Mb?Mb:Jb;Mb=ea(g[r>>2]);Sb=ea(g[Bb+12>>2]);Tb=ea(Mb*Sb);Mb=ea(g[ga>>2]);Ub=ea(g[Bb+16>>2]);Vb=ea(Tb+ea(Mb*Ub));Mb=ea(g[ja>>2]);Tb=ea(g[Bb+20>>2]);g[zb+12>>2]=ea(Vb+ea(Mb*Tb));Mb=ea(Sb*ea(g[ca>>2]));Vb=ea(Mb+ea(Ub*ea(g[ha>>2])));g[zb+16>>2]=ea(Vb+ea(Tb*ea(g[ka>>2])));Vb=ea(Sb*ea(g[fa>>2]));Sb=ea(Vb+ea(Ub*ea(g[ia>>2])));g[zb+20>>2]=ea(Sb+ea(Tb*ea(g[la>>2])));Tb=ea(ea(d[Bb+24>>0]|0)/ea(255.0));Sb=ea(ea(d[Bb+25>>0]|0)/ea(255.0));Ub=ea(ea(d[Bb+26>>0]|0)/ea(255.0));Vb=ea(yb*Tb);Tb=ea(xb*Sb);Sb=ea(wb*Ub);Ub=ea(ub*ea(ea(d[Bb+27>>0]|0)/ea(255.0)));Wb=Vb<ea(0.0);Mb=Wb?ea(0.0):Vb;Wb=Mb>ea(1.0);Xb=~~ea(ea(Mb*ea(255.0))+ea(.5))>>>0;Yb=Tb<ea(0.0);Mb=Yb?ea(0.0):Tb;Yb=Mb>ea(1.0);Zb=~~ea(ea(Mb*ea(255.0))+ea(.5))>>>0;_b=Sb<ea(0.0);Mb=_b?ea(0.0):Sb;_b=Mb>ea(1.0);$b=~~ea(ea(Mb*ea(255.0))+ea(.5))>>>0;ac=Ub<ea(0.0);Mb=ac?ea(0.0):Ub;ac=Mb>ea(1.0);bc=~~ea(ea(Mb*ea(255.0))+ea(.5))>>>0<<24;c[zb+24>>2]=(Yb?65280:Zb<<8&65280)|(Wb?255:Xb&255)|(_b?16711680:$b<<16&16711680)|(ac?-16777216:bc);bc=Bb+28|0;ac=c[bc+4>>2]|0;$b=zb+28|0;c[$b>>2]=c[bc>>2];c[$b+4>>2]=ac;ac=Bb+36|0;$b=c[ac+4>>2]|0;bc=zb+36|0;c[bc>>2]=c[ac>>2];c[bc+4>>2]=$b;Mb=ea(g[r>>2]);Ub=ea(g[Bb+44>>2]);Sb=ea(Mb*Ub);Mb=ea(g[ga>>2]);Tb=ea(g[Bb+48>>2]);Vb=ea(Sb+ea(Mb*Tb));Mb=ea(g[ja>>2]);Sb=ea(g[Bb+52>>2]);g[zb+44>>2]=ea(Vb+ea(Mb*Sb));Mb=ea(Ub*ea(g[ca>>2]));Vb=ea(Mb+ea(Tb*ea(g[ha>>2])));g[zb+48>>2]=ea(Vb+ea(Sb*ea(g[ka>>2])));Vb=ea(Ub*ea(g[fa>>2]));Ub=ea(Vb+ea(Tb*ea(g[ia>>2])));g[zb+52>>2]=ea(Ub+ea(Sb*ea(g[la>>2])));g[zb+56>>2]=ea(g[Bb+56>>2]);if(!Kb){cc=Pb;dc=Nb;ec=Rb;fc=Qb;gc=Lb;hc=Ob;break a}zb=zb+60|0;Bb=Bb+60|0;Gb=Kb;Eb=ea(g[l>>2]);sb=Ob;Db=Lb;Cb=Qb;Hb=Rb;Ib=Nb;Jb=Pb}}tMc(l,q);Jb=ea(g[l>>2]);Ib=ea(g[D>>2]);Hb=ea(g[A>>2]);Cb=ea(T(ea(ea(ea(Jb*Jb)+ea(Ib*Ib))+ea(Hb*Hb))));if(Cb>ea(9.99999997e-07))ic=ea(ea(1.0)/Cb);else ic=ea(1.0);g[q>>2]=ea(ic*ea(g[q>>2]));g[z>>2]=ea(ic*ea(g[z>>2]));g[B>>2]=ea(ic*ea(g[B>>2]));g[N>>2]=ea(ic*ea(g[N>>2]));g[O>>2]=ea(ic*ea(g[O>>2]));g[P>>2]=ea(ic*ea(g[P>>2]));g[Q>>2]=ea(ic*ea(g[Q>>2]));g[R>>2]=ea(ic*ea(g[R>>2]));g[S>>2]=ea(ic*ea(g[S>>2]));Gb=ib;Bb=Ab;zb=jb;Cb=Jb;Jb=gb;Hb=fb;Ib=eb;Db=db;sb=cb;Eb=bb;while(1){Kb=zb+-1|0;Pb=ea(g[Bb>>2]);Nb=ea(Cb*Pb);Rb=ea(g[V>>2]);Qb=ea(g[Bb+4>>2]);Lb=ea(Nb+ea(Rb*Qb));Rb=ea(g[W>>2]);Nb=ea(g[Bb+8>>2]);Ob=ea(Lb+ea(Rb*Nb));Rb=ea(ea(g[X>>2])+Ob);g[Gb>>2]=Rb;Ob=ea(Pb*ea(g[D>>2]));Lb=ea(Ob+ea(Qb*ea(g[Y>>2])));Ob=ea(Lb+ea(Nb*ea(g[Z>>2])));Lb=ea(ea(g[_>>2])+Ob);g[Gb+4>>2]=Lb;Ob=ea(Pb*ea(g[A>>2]));Pb=ea(Ob+ea(Qb*ea(g[$>>2])));Qb=ea(Pb+ea(Nb*ea(g[aa>>2])));Nb=ea(ea(g[ba>>2])+Qb);g[Gb+8>>2]=Nb;Qb=Rb<Jb?Rb:Jb;Pb=Lb<Hb?Lb:Hb;Ob=Nb<Ib?Nb:Ib;Sb=Db<Rb?Rb:Db;Rb=sb<Lb?Lb:sb;Lb=Eb<Nb?Nb:Eb;Nb=ea(g[q>>2]);Ub=ea(g[Bb+12>>2]);Tb=ea(Nb*Ub);Nb=ea(g[N>>2]);Vb=ea(g[Bb+16>>2]);Mb=ea(Tb+ea(Nb*Vb));Nb=ea(g[Q>>2]);Tb=ea(g[Bb+20>>2]);g[Gb+12>>2]=ea(Mb+ea(Nb*Tb));Nb=ea(Ub*ea(g[z>>2]));Mb=ea(Nb+ea(Vb*ea(g[O>>2])));g[Gb+16>>2]=ea(Mb+ea(Tb*ea(g[R>>2])));Mb=ea(Ub*ea(g[B>>2]));Ub=ea(Mb+ea(Vb*ea(g[P>>2])));g[Gb+20>>2]=ea(Ub+ea(Tb*ea(g[S>>2])));Tb=ea(ea(d[Bb+24>>0]|0)/ea(255.0));Ub=ea(ea(d[Bb+25>>0]|0)/ea(255.0));Vb=ea(ea(d[Bb+26>>0]|0)/ea(255.0));Mb=ea(ea(d[Bb+27>>0]|0)/ea(255.0));do if(!(Tb<=ea(.0404499993)))if(Tb<ea(1.0)){jc=ea(+U(+ea(ea(Tb+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{jc=ea(+U(+Tb,2.20000005));break}else jc=ea(Tb/ea(12.9200001));while(0);do if(!(Ub<=ea(.0404499993)))if(Ub<ea(1.0)){kc=ea(+U(+ea(ea(Ub+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{kc=ea(+U(+Ub,2.20000005));break}else kc=ea(Ub/ea(12.9200001));while(0);do if(!(Vb<=ea(.0404499993)))if(Vb<ea(1.0)){lc=ea(+U(+ea(ea(Vb+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{lc=ea(+U(+Vb,2.20000005));break}else lc=ea(Vb/ea(12.9200001));while(0);Vb=ea(yb*jc);Ub=ea(xb*kc);Tb=ea(wb*lc);Nb=ea(ub*Mb);$b=Vb<ea(0.0);mc=$b?ea(0.0):Vb;$b=mc>ea(1.0);bc=~~ea(ea(mc*ea(255.0))+ea(.5))>>>0;ac=Ub<ea(0.0);mc=ac?ea(0.0):Ub;ac=mc>ea(1.0);_b=~~ea(ea(mc*ea(255.0))+ea(.5))>>>0;Xb=Tb<ea(0.0);mc=Xb?ea(0.0):Tb;Xb=mc>ea(1.0);Wb=~~ea(ea(mc*ea(255.0))+ea(.5))>>>0;Zb=Nb<ea(0.0);mc=Zb?ea(0.0):Nb;Zb=mc>ea(1.0);Yb=~~ea(ea(mc*ea(255.0))+ea(.5))>>>0<<24;c[Gb+24>>2]=($b?255:bc&255)|(Zb?-16777216:Yb)|(ac?65280:_b<<8&65280)|(Xb?16711680:Wb<<16&16711680);Wb=Bb+28|0;Xb=c[Wb+4>>2]|0;_b=Gb+28|0;c[_b>>2]=c[Wb>>2];c[_b+4>>2]=Xb;Xb=Bb+36|0;_b=c[Xb+4>>2]|0;Wb=Gb+36|0;c[Wb>>2]=c[Xb>>2];c[Wb+4>>2]=_b;mc=ea(g[q>>2]);Nb=ea(g[Bb+44>>2]);Tb=ea(mc*Nb);mc=ea(g[N>>2]);Ub=ea(g[Bb+48>>2]);Vb=ea(Tb+ea(mc*Ub));mc=ea(g[Q>>2]);Tb=ea(g[Bb+52>>2]);g[Gb+44>>2]=ea(Vb+ea(mc*Tb));mc=ea(Nb*ea(g[z>>2]));Vb=ea(mc+ea(Ub*ea(g[O>>2])));g[Gb+48>>2]=ea(Vb+ea(Tb*ea(g[R>>2])));Vb=ea(Nb*ea(g[B>>2]));Nb=ea(Vb+ea(Ub*ea(g[P>>2])));g[Gb+52>>2]=ea(Nb+ea(Tb*ea(g[S>>2])));g[Gb+56>>2]=ea(g[Bb+56>>2]);if(!Kb){cc=Lb;dc=Rb;ec=Sb;fc=Ob;gc=Pb;hc=Qb;break a}Gb=Gb+60|0;Bb=Bb+60|0;zb=Kb;Cb=ea(g[l>>2]);Jb=Qb;Hb=Pb;Ib=Ob;Db=Sb;sb=Rb;Eb=Lb}}else{if(!Za){tMc(l,p);Eb=ea(g[l>>2]);sb=ea(g[D>>2]);Db=ea(g[A>>2]);Ib=ea(T(ea(ea(ea(Eb*Eb)+ea(sb*sb))+ea(Db*Db))));if(Ib>ea(9.99999997e-07))nc=ea(ea(1.0)/Ib);else nc=ea(1.0);g[p>>2]=ea(nc*ea(g[p>>2]));g[ua>>2]=ea(nc*ea(g[ua>>2]));g[va>>2]=ea(nc*ea(g[va>>2]));g[wa>>2]=ea(nc*ea(g[wa>>2]));g[xa>>2]=ea(nc*ea(g[xa>>2]));g[ya>>2]=ea(nc*ea(g[ya>>2]));g[za>>2]=ea(nc*ea(g[za>>2]));g[Aa>>2]=ea(nc*ea(g[Aa>>2]));g[Ba>>2]=ea(nc*ea(g[Ba>>2]));zb=ib;Bb=Ab;Gb=jb;Ib=Eb;Eb=gb;Db=fb;sb=eb;Hb=db;Jb=cb;Cb=bb;while(1){_b=Gb+-1|0;Tb=ea(g[Bb>>2]);Nb=ea(Ib*Tb);Ub=ea(g[V>>2]);Vb=ea(g[Bb+4>>2]);mc=ea(Nb+ea(Ub*Vb));Ub=ea(g[W>>2]);Nb=ea(g[Bb+8>>2]);oc=ea(mc+ea(Ub*Nb));Ub=ea(ea(g[X>>2])+oc);g[zb>>2]=Ub;oc=ea(Tb*ea(g[D>>2]));mc=ea(oc+ea(Vb*ea(g[Y>>2])));oc=ea(mc+ea(Nb*ea(g[Z>>2])));mc=ea(ea(g[_>>2])+oc);g[zb+4>>2]=mc;oc=ea(Tb*ea(g[A>>2]));Tb=ea(oc+ea(Vb*ea(g[$>>2])));Vb=ea(Tb+ea(Nb*ea(g[aa>>2])));Nb=ea(ea(g[ba>>2])+Vb);g[zb+8>>2]=Nb;Vb=Ub<Eb?Ub:Eb;Tb=mc<Db?mc:Db;oc=Nb<sb?Nb:sb;pc=Hb<Ub?Ub:Hb;Ub=Jb<mc?mc:Jb;mc=Cb<Nb?Nb:Cb;Nb=ea(g[p>>2]);qc=ea(g[Bb+12>>2]);rc=ea(Nb*qc);Nb=ea(g[wa>>2]);sc=ea(g[Bb+16>>2]);tc=ea(rc+ea(Nb*sc));Nb=ea(g[za>>2]);rc=ea(g[Bb+20>>2]);g[zb+12>>2]=ea(tc+ea(Nb*rc));Nb=ea(qc*ea(g[ua>>2]));tc=ea(Nb+ea(sc*ea(g[xa>>2])));g[zb+16>>2]=ea(tc+ea(rc*ea(g[Aa>>2])));tc=ea(qc*ea(g[va>>2]));qc=ea(tc+ea(sc*ea(g[ya>>2])));g[zb+20>>2]=ea(qc+ea(rc*ea(g[Ba>>2])));rc=ea(ea(d[Bb+24>>0]|0)/ea(255.0));qc=ea(ea(d[Bb+25>>0]|0)/ea(255.0));sc=ea(ea(d[Bb+26>>0]|0)/ea(255.0));tc=ea(yb*rc);rc=ea(xb*qc);qc=ea(wb*sc);sc=ea(ub*ea(ea(d[Bb+27>>0]|0)/ea(255.0)));Wb=tc<ea(0.0);Nb=Wb?ea(0.0):tc;Wb=Nb>ea(1.0);Xb=~~ea(ea(Nb*ea(255.0))+ea(.5))>>>0;ac=rc<ea(0.0);Nb=ac?ea(0.0):rc;ac=Nb>ea(1.0);Yb=~~ea(ea(Nb*ea(255.0))+ea(.5))>>>0;Zb=qc<ea(0.0);Nb=Zb?ea(0.0):qc;Zb=Nb>ea(1.0);bc=~~ea(ea(Nb*ea(255.0))+ea(.5))>>>0;$b=sc<ea(0.0);Nb=$b?ea(0.0):sc;$b=Nb>ea(1.0);uc=~~ea(ea(Nb*ea(255.0))+ea(.5))>>>0<<24;c[zb+24>>2]=(ac?65280:Yb<<8&65280)|(Wb?16711680:Xb<<16&16711680)|(Zb?255:bc&255)|($b?-16777216:uc);uc=Bb+28|0;$b=c[uc+4>>2]|0;bc=zb+28|0;c[bc>>2]=c[uc>>2];c[bc+4>>2]=$b;$b=Bb+36|0;bc=c[$b+4>>2]|0;uc=zb+36|0;c[uc>>2]=c[$b>>2];c[uc+4>>2]=bc;Nb=ea(g[p>>2]);sc=ea(g[Bb+44>>2]);qc=ea(Nb*sc);Nb=ea(g[wa>>2]);rc=ea(g[Bb+48>>2]);tc=ea(qc+ea(Nb*rc));Nb=ea(g[za>>2]);qc=ea(g[Bb+52>>2]);g[zb+44>>2]=ea(tc+ea(Nb*qc));Nb=ea(sc*ea(g[ua>>2]));tc=ea(Nb+ea(rc*ea(g[xa>>2])));g[zb+48>>2]=ea(tc+ea(qc*ea(g[Aa>>2])));tc=ea(sc*ea(g[va>>2]));sc=ea(tc+ea(rc*ea(g[ya>>2])));g[zb+52>>2]=ea(sc+ea(qc*ea(g[Ba>>2])));g[zb+56>>2]=ea(g[Bb+56>>2]);if(!_b){cc=mc;dc=Ub;ec=pc;fc=oc;gc=Tb;hc=Vb;break a}zb=zb+60|0;Bb=Bb+60|0;Gb=_b;Ib=ea(g[l>>2]);Eb=Vb;Db=Tb;sb=oc;Hb=pc;Jb=Ub;Cb=mc}}tMc(l,o);Cb=ea(g[l>>2]);Jb=ea(g[D>>2]);Hb=ea(g[A>>2]);sb=ea(T(ea(ea(ea(Cb*Cb)+ea(Jb*Jb))+ea(Hb*Hb))));if(sb>ea(9.99999997e-07))vc=ea(ea(1.0)/sb);else vc=ea(1.0);g[o>>2]=ea(vc*ea(g[o>>2]));g[ma>>2]=ea(vc*ea(g[ma>>2]));g[na>>2]=ea(vc*ea(g[na>>2]));g[oa>>2]=ea(vc*ea(g[oa>>2]));g[pa>>2]=ea(vc*ea(g[pa>>2]));g[qa>>2]=ea(vc*ea(g[qa>>2]));g[ra>>2]=ea(vc*ea(g[ra>>2]));g[sa>>2]=ea(vc*ea(g[sa>>2]));g[ta>>2]=ea(vc*ea(g[ta>>2]));Gb=ib;Bb=jb;zb=Ab;sb=Cb;Cb=gb;Hb=fb;Jb=eb;Db=db;Eb=cb;Ib=bb;while(1){_b=Bb+-1|0;mc=ea(g[zb>>2]);Ub=ea(sb*mc);pc=ea(g[V>>2]);oc=ea(g[zb+4>>2]);Tb=ea(Ub+ea(pc*oc));pc=ea(g[W>>2]);Ub=ea(g[zb+8>>2]);Vb=ea(Tb+ea(pc*Ub));pc=ea(ea(g[X>>2])+Vb);g[Gb>>2]=pc;Vb=ea(mc*ea(g[D>>2]));Tb=ea(Vb+ea(oc*ea(g[Y>>2])));Vb=ea(Tb+ea(Ub*ea(g[Z>>2])));Tb=ea(ea(g[_>>2])+Vb);g[Gb+4>>2]=Tb;Vb=ea(mc*ea(g[A>>2]));mc=ea(Vb+ea(oc*ea(g[$>>2])));oc=ea(mc+ea(Ub*ea(g[aa>>2])));Ub=ea(ea(g[ba>>2])+oc);g[Gb+8>>2]=Ub;oc=pc<Cb?pc:Cb;mc=Tb<Hb?Tb:Hb;Vb=Ub<Jb?Ub:Jb;qc=Db<pc?pc:Db;pc=Eb<Tb?Tb:Eb;Tb=Ib<Ub?Ub:Ib;Ub=ea(g[o>>2]);sc=ea(g[zb+12>>2]);rc=ea(Ub*sc);Ub=ea(g[oa>>2]);tc=ea(g[zb+16>>2]);Nb=ea(rc+ea(Ub*tc));Ub=ea(g[ra>>2]);rc=ea(g[zb+20>>2]);g[Gb+12>>2]=ea(Nb+ea(Ub*rc));Ub=ea(sc*ea(g[ma>>2]));Nb=ea(Ub+ea(tc*ea(g[pa>>2])));g[Gb+16>>2]=ea(Nb+ea(rc*ea(g[sa>>2])));Nb=ea(sc*ea(g[na>>2]));sc=ea(Nb+ea(tc*ea(g[qa>>2])));g[Gb+20>>2]=ea(sc+ea(rc*ea(g[ta>>2])));rc=ea(ea(d[zb+24>>0]|0)/ea(255.0));sc=ea(ea(d[zb+25>>0]|0)/ea(255.0));tc=ea(ea(d[zb+26>>0]|0)/ea(255.0));Nb=ea(ea(d[zb+27>>0]|0)/ea(255.0));do if(!(rc<=ea(.0404499993)))if(rc<ea(1.0)){wc=ea(+U(+ea(ea(rc+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{wc=ea(+U(+rc,2.20000005));break}else wc=ea(rc/ea(12.9200001));while(0);do if(!(sc<=ea(.0404499993)))if(sc<ea(1.0)){xc=ea(+U(+ea(ea(sc+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{xc=ea(+U(+sc,2.20000005));break}else xc=ea(sc/ea(12.9200001));while(0);do if(!(tc<=ea(.0404499993)))if(tc<ea(1.0)){yc=ea(+U(+ea(ea(tc+ea(.0549999997))/ea(1.05499995)),2.4000001));break}else{yc=ea(+U(+tc,2.20000005));break}else yc=ea(tc/ea(12.9200001));while(0);tc=ea(yb*wc);sc=ea(xb*xc);rc=ea(wb*yc);Lb=ea(ub*Nb);Kb=tc<ea(0.0);Rb=Kb?ea(0.0):tc;Kb=Rb>ea(1.0);bc=~~ea(ea(Rb*ea(255.0))+ea(.5))>>>0;uc=sc<ea(0.0);Rb=uc?ea(0.0):sc;uc=Rb>ea(1.0);$b=~~ea(ea(Rb*ea(255.0))+ea(.5))>>>0;Zb=rc<ea(0.0);Rb=Zb?ea(0.0):rc;Zb=Rb>ea(1.0);Xb=~~ea(ea(Rb*ea(255.0))+ea(.5))>>>0;Wb=Lb<ea(0.0);Rb=Wb?ea(0.0):Lb;Wb=Rb>ea(1.0);Yb=~~ea(ea(Rb*ea(255.0))+ea(.5))>>>0<<24;c[Gb+24>>2]=(Kb?16711680:bc<<16&16711680)|(Wb?-16777216:Yb)|(uc?65280:$b<<8&65280)|(Zb?255:Xb&255);Xb=zb+28|0;Zb=c[Xb+4>>2]|0;$b=Gb+28|0;c[$b>>2]=c[Xb>>2];c[$b+4>>2]=Zb;Zb=zb+36|0;$b=c[Zb+4>>2]|0;Xb=Gb+36|0;c[Xb>>2]=c[Zb>>2];c[Xb+4>>2]=$b;Rb=ea(g[o>>2]);Lb=ea(g[zb+44>>2]);rc=ea(Rb*Lb);Rb=ea(g[oa>>2]);sc=ea(g[zb+48>>2]);tc=ea(rc+ea(Rb*sc));Rb=ea(g[ra>>2]);rc=ea(g[zb+52>>2]);g[Gb+44>>2]=ea(tc+ea(Rb*rc));Rb=ea(Lb*ea(g[ma>>2]));tc=ea(Rb+ea(sc*ea(g[pa>>2])));g[Gb+48>>2]=ea(tc+ea(rc*ea(g[sa>>2])));tc=ea(Lb*ea(g[na>>2]));Lb=ea(tc+ea(sc*ea(g[qa>>2])));g[Gb+52>>2]=ea(Lb+ea(rc*ea(g[ta>>2])));g[Gb+56>>2]=ea(g[zb+56>>2]);if(!_b){cc=Tb;dc=pc;ec=qc;fc=Vb;gc=mc;hc=oc;break a}Gb=Gb+60|0;Bb=_b;zb=zb+60|0;sb=ea(g[l>>2]);Cb=oc;Hb=mc;Jb=Vb;Db=qc;Eb=pc;Ib=Tb}}while(0);kb=c[_a>>2]|0;lb=cc;mb=dc;nb=ec;ob=fc;pb=gc;qb=hc;rb=ib+(jb*60|0)|0}$a=$a+1|0;if(($a|0)>=(kb|0)){zc=qb;Ac=pb;Bc=ob;Cc=nb;Dc=mb;Ec=lb;break}else{bb=lb;cb=mb;db=nb;eb=ob;fb=pb;gb=qb;hb=kb;ib=rb}}}else{zc=Sa;Ac=Ta;Bc=Ua;Cc=Va;Dc=Wa;Ec=Xa}gb=ea(g[150280]);fb=ea(g[150281]);eb=ea(g[150282]);do if(zc==gb&Ac==fb&Bc==eb){Fc=c[Ca>>2]|0;F=96}else{if(Cc==ea(-gb)&Dc==ea(-fb)){ib=Ec!=ea(-eb);hb=c[Ca>>2]|0;if(ib)Gc=hb;else{Fc=hb;F=96;break}}else Gc=c[Ca>>2]|0;db=ea(ea(Dc+Ac)*ea(.5));cb=ea(ea(Ec+Bc)*ea(.5));g[Gc+(Ja*56|0)+32>>2]=ea(ea(Cc+zc)*ea(.5));g[Gc+(Ja*56|0)+36>>2]=db;g[Gc+(Ja*56|0)+40>>2]=cb;cb=ea(ea(Dc-Ac)*ea(.5));db=ea(ea(Ec-Bc)*ea(.5));g[Gc+(Ja*56|0)+44>>2]=ea(ea(Cc-zc)*ea(.5));g[Gc+(Ja*56|0)+48>>2]=cb;g[Gc+(Ja*56|0)+52>>2]=db;Hc=Ia<Ec?Ec:Ia;Ic=Ha<Dc?Dc:Ha;Jc=Ga<Cc?Cc:Ga;Kc=Bc<Fa?Bc:Fa;Lc=Ac<Ea?Ac:Ea;Mc=zc<H?zc:H}while(0);if((F|0)==96){F=0;hb=Fc+(Ja*56|0)+32|0;c[n+0>>2]=c[150284];c[n+4>>2]=c[150285];c[n+8>>2]=c[150286];c[Da+0>>2]=c[150284];c[Da+4>>2]=c[150285];c[Da+8>>2]=c[150286];c[hb+0>>2]=c[n+0>>2];c[hb+4>>2]=c[n+4>>2];c[hb+8>>2]=c[n+8>>2];c[hb+12>>2]=c[n+12>>2];c[hb+16>>2]=c[n+16>>2];c[hb+20>>2]=c[n+20>>2];Hc=Ia;Ic=Ha;Jc=Ga;Kc=Fa;Lc=Ea;Mc=H}La=Hc;Ma=Ic;Na=Jc;Oa=Kc;Pa=Lc;Qa=Mc;Ra=(c[e+(Ja<<4)>>2]|0)+Ka|0}Ja=Ja+1|0;if((Ja|0)==(h|0)){Nc=La;Oc=Ma;Pc=Na;Qc=Oa;Rc=Pa;Sc=Qa;break}else{H=Qa;Ea=Pa;Fa=Oa;Ga=Na;Ha=Ma;Ia=La;Ka=Ra}}}else{Nc=L;Oc=K;Pc=J;Qc=I;Rc=j;Sc=G}Ra=Tdc(x,0)|0;if((E|0)>0){Ka=Ra;Ra=0;while(1){Ja=Ra&65535;b[Ka>>1]=Ja;b[Ka+2>>1]=Ra|1;Da=(Ra|2)&65535;b[Ka+4>>1]=Da;b[Ka+6>>1]=Da;b[Ka+8>>1]=Ra|3;b[Ka+10>>1]=Ja;Ra=Ra+4|0;if((Ra|0)>=(E|0))break;else Ka=Ka+12|0}}if(y){Ka=0;do{fec(x,Ka);Ka=Ka+1|0}while((Ka|0)!=(h|0))}G=ea(g[150280]);j=ea(g[150281]);I=ea(g[150282]);do if(Sc==G&Rc==j&Qc==I)F=107;else{if(Pc==ea(-G)?!(Oc!=ea(-j)|Nc!=ea(-I)):0){F=107;break}c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;J=ea(ea(Rc+Oc)*ea(.5));K=ea(ea(Qc+Nc)*ea(.5));g[s>>2]=ea(ea(Sc+Pc)*ea(.5));g[s+4>>2]=J;g[s+8>>2]=K;K=ea(ea(Oc-Rc)*ea(.5));J=ea(ea(Nc-Qc)*ea(.5));g[s+12>>2]=ea(ea(Pc-Sc)*ea(.5));g[s+16>>2]=K;g[s+20>>2]=J;oec(x,s)}while(0);if((F|0)==107){s=t+12|0;c[t+0>>2]=c[150284];c[t+4>>2]=c[150285];c[t+8>>2]=c[150286];c[s+0>>2]=c[150284];c[s+4>>2]=c[150285];c[s+8>>2]=c[150286];oec(x,t)}Xdc(x,159,1)}x=f+8|0;c[x>>2]=h;t=f+12|0;s=c[t>>2]|0;do if((s&2147483647)>>>0<h>>>0)if((s|0)>-1){c[t>>2]=h;Ka=c[f>>2]|0;c[m>>2]=c[f+4>>2];c[l+0>>2]=c[m+0>>2];c[f>>2]=hOb(Ka,h<<2,4,l,0,3653512,370)|0;break}else{c[m>>2]=c[f+4>>2];c[l+0>>2]=c[m+0>>2];Ka=cOb(h<<2,4,l,0,3653512,352)|0;YEi(Ka|0,c[f>>2]|0,c[x>>2]<<2|0)|0;c[t>>2]=h;c[f>>2]=Ka;break}while(0);if(y){t=c[f>>2]|0;x=0;do{if(a[e+(x<<4)+12>>0]|0)c[t+(x<<2)>>2]=c[c[e+(x<<4)+4>>2]>>2];x=x+1|0}while((x|0)!=(h|0))}x=f+16|0;t=f+28|0;s=c[t>>2]|0;do if((s&2147483647)>>>0<h>>>0)if((s|0)>-1){c[t>>2]=h;Ka=c[x>>2]|0;c[m>>2]=c[f+20>>2];c[l+0>>2]=c[m+0>>2];c[x>>2]=hOb(Ka,h<<2,4,l,0,3653512,370)|0;break}else{c[m>>2]=c[f+20>>2];c[l+0>>2]=c[m+0>>2];Ka=cOb(h<<2,4,l,0,3653512,352)|0;YEi(Ka|0,c[x>>2]|0,c[f+24>>2]<<2|0)|0;c[t>>2]=h;c[x>>2]=Ka;break}while(0);t=f+24|0;s=c[t>>2]|0;if(s>>>0<h>>>0?(Ka=c[x>>2]|0,E=Ka+(h<<2)|0,(s|0)!=(h|0)):0){Ra=Ka+(s<<2)|0;do{if(Ra)c[Ra>>2]=0;Ra=Ra+4|0}while((Ra|0)!=(E|0))}c[t>>2]=h;if(y){t=c[155410]|0;E=0;do{do if((a[e+(E<<4)+12>>0]|0)!=0?(Ra=c[(c[e+(E<<4)+4>>2]|0)+4>>2]|0,(Ra|0)!=0):0){c[n>>2]=Ra;s=c[137784]|0;if(s){do if((c[s+36>>2]|0)!=(c[s+4>>2]|0)){fRb(l,s,n);Ka=c[l>>2]|0;Ja=c[s+28>>2]|0;if((Ka|0)==-1){Tc=Ja+(c[s+32>>2]<<3)|0;break}else{Tc=Ja+(Ka<<3)|0;break}}else Tc=(c[s+28>>2]|0)+(c[s+32>>2]<<3)|0;while(0);s=c[137784]|0;if((Tc|0)!=((c[s+28>>2]|0)+(c[s+32>>2]<<3)|0)?(s=c[Tc+4>>2]|0,(s|0)!=0):0)Uc=s;else F=140}else F=140;if((F|0)==140){F=0;s=hQb(Ra)|0;if(!s)break;else Uc=s}s=(da(c[137788]|0,(c[Uc+8>>2]|0)>>>21)|0)+27|0;jb=s>>5;if(!((Uc|0)==0?1:(1<<s-(jb<<5)&c[(c[137786]|0)+(jb<<2)>>2]|0)==0)){c[u>>2]=c[153110];c[l+0>>2]=c[u+0>>2];jb=bOb(36,l,0,16,3653512,359)|0;s=c[153110]|0;c[jb>>2]=0;c[jb+4>>2]=s;c[jb+8>>2]=0;c[jb+12>>2]=0;c[jb+16>>2]=0;c[jb+20>>2]=s;c[jb+24>>2]=0;c[jb+28>>2]=0;c[jb+32>>2]=t;c[l>>2]=-1;itd(l,791824);c[v>>2]=c[l>>2];s=mo[c[(c[Uc>>2]|0)+92>>2]&4095](Uc)|0;c[w>>2]=c[Uc+44>>2];c[l+0>>2]=c[w+0>>2];mld(jb,v,s,l);c[(c[x>>2]|0)+(E<<2)>>2]=jb}}while(0);E=E+1|0}while((E|0)!=(h|0))}E=f+36|0;x=f+44|0;c[x>>2]=h;v=f+48|0;w=c[v>>2]|0;do if((w&2147483647)>>>0<h>>>0)if((w|0)>-1){c[v>>2]=h;Uc=c[E>>2]|0;c[m>>2]=c[f+40>>2];c[l+0>>2]=c[m+0>>2];c[E>>2]=hOb(Uc,h,1,l,0,3653512,370)|0;break}else{c[m>>2]=c[f+40>>2];c[l+0>>2]=c[m+0>>2];Uc=cOb(h,1,l,0,3653512,352)|0;YEi(Uc|0,c[E>>2]|0,c[x>>2]|0)|0;c[v>>2]=h;c[E>>2]=Uc;break}while(0);if(!y){i=k;return}y=c[E>>2]|0;E=0;do{a[y+E>>0]=a[e+(E<<4)+12>>0]^1;E=E+1|0}while((E|0)!=(h|0));i=k;return}function tje(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+48|0;g=f+28|0;h=f+16|0;j=f+4|0;k=f+8|0;l=f+32|0;m=f;n=f+12|0;o=f+24|0;p=f+20|0;rje(e);q=(b*152|0)+15|0;r=(b|0)!=0;if(q>>>0<2e3)if(r){s=i;i=i+((1*q|0)+15&-16)|0;t=0;u=s}else{t=0;u=0}else if(r){c[k>>2]=c[153134];c[g+0>>2]=c[k+0>>2];k=cOb(q,16,g,0,3653512,384)|0;t=k;u=k}else{t=0;u=0}k=u+15&-16;u=vje(a,b,k)|0;b=c[153134]|0;c[l>>2]=0;a=l+4|0;c[a>>2]=b;b=l+8|0;c[b>>2]=0;q=l+12|0;c[q>>2]=0;qje(k,k+(u*152|0)|0,l);c[m>>2]=0;u=(uje(e,m)|0)+32|0;if(!(c[u>>2]|0)){c[j>>2]=c[153106];c[g+0>>2]=c[j+0>>2];j=_jc(4,g)|0;In[c[(c[j>>2]|0)+44>>2]&4095](j,61);In[c[(c[j>>2]|0)+36>>2]&4095](j,791840);c[u>>2]=j}j=c[b>>2]|0;if((j|0)>0){b=c[l>>2]|0;u=0;m=0;k=0;r=0;while(1){s=b+(k<<4)|0;v=(c[s>>2]|0)+r|0;if((v|0)>65535){c[n>>2]=m;sje(b+(u<<4)|0,uje(e,n)|0,k-u|0,d);w=m+1|0;c[o>>2]=w;x=(uje(e,o)|0)+32|0;if(!(c[x>>2]|0)){c[h>>2]=c[153106];c[g+0>>2]=c[h+0>>2];y=_jc(4,g)|0;In[c[(c[y>>2]|0)+44>>2]&4095](y,61);In[c[(c[y>>2]|0)+36>>2]&4095](y,791840);c[x>>2]=y}z=k;A=w;B=c[s>>2]|0}else{z=u;A=m;B=v}k=k+1|0;if((k|0)>=(j|0)){C=z;D=A;break}else{u=z;m=A;r=B}}}else{C=0;D=0}if(j){B=c[l>>2]|0;c[p>>2]=D;sje(B+(C<<4)|0,uje(e,p)|0,j-C|0,d)}if((c[q>>2]|0)>-1){q=c[l>>2]|0;c[h>>2]=c[a>>2];c[g+0>>2]=c[h+0>>2];eOb(q,g);c[l>>2]=0}if(!t){i=f;return}c[h>>2]=c[153134];c[g+0>>2]=c[h+0>>2];eOb(t,g);i=f;return}function uje(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=c[b>>2]|0;j=g;while(1){k=c[j+16>>2]|0;if(h>>>0<k>>>0){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if(k>>>0>=h>>>0){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=a+4|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+20|0;i=d;return v|0}e=xCi(72)|0;c[e+16>>2]=c[b>>2];c[e+20>>2]=0;c[e+28>>2]=0;c[e+32>>2]=0;c[e+24>>2]=60;c[e+36>>2]=0;c[e+44>>2]=0;c[e+48>>2]=0;c[e+40>>2]=60;c[e+52>>2]=0;c[e+56>>2]=0;c[e+64>>2]=0;c[e+68>>2]=0;c[e+60>>2]=60;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=c[c[a>>2]>>2]|0;if(!t)w=e;else{c[a>>2]=t;w=c[s>>2]|0}GN(c[f>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;u=e;v=u+20|0;i=d;return v|0}function vje(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0;f=i;i=i+16|0;h=f;j=f+8|0;k=f+4|0;l=(d*20|0)+15|0;m=(d|0)!=0;if(l>>>0<2e3)if(m){n=i;i=i+((1*l|0)+15&-16)|0;o=0;p=n}else{o=0;p=0}else if(m){c[k>>2]=c[153134];c[h+0>>2]=c[k+0>>2];k=cOb(l,16,h,0,3653512,148)|0;o=k;p=k}else{o=0;p=0}k=p+15&-16;wje(b,d,k);xje(k,k+(d*20|0)|0,h);if((d|0)>0){p=0;l=0;while(1){if((c[k+(p*20|0)>>2]|0)==-1)q=l;else{m=c[k+(p*20|0)+4>>2]|0;n=l+1|0;r=e+(l*152|0)+0|0;s=b+(m*152|0)+0|0;t=r+116|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));u=ea(g[b+(m*152|0)+116>>2]);v=ea(g[b+(m*152|0)+120>>2]);w=ea(g[b+(m*152|0)+124>>2]);x=ea(g[b+(m*152|0)+128>>2]);g[e+(l*152|0)+116>>2]=u;g[e+(l*152|0)+120>>2]=v;g[e+(l*152|0)+124>>2]=w;g[e+(l*152|0)+128>>2]=x;s=e+(l*152|0)+132|0;r=b+(m*152|0)+132|0;c[s+0>>2]=c[r+0>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];c[s+12>>2]=c[r+12>>2];a[s+16>>0]=a[r+16>>0]|0;q=n}p=p+1|0;if((p|0)==(d|0)){y=q;break}else l=q}}else y=0;if(!o){i=f;return y|0}c[j>>2]=c[153134];c[h+0>>2]=c[j+0>>2];eOb(o,h);i=f;return y|0}function wje(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=0,y=Im,z=0,A=Im,B=0,C=Im,D=0,E=Im,F=Im,G=Im,H=Im,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;f=i;i=i+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;if(!d){i=f;return}m=d<<4|15;if(m>>>0<2e3){n=i;i=i+((1*m|0)+15&-16)|0;o=0;p=n}else{c[k>>2]=c[153134];c[h+0>>2]=c[k+0>>2];k=cOb(m,16,h,0,3653512,49)|0;o=k;p=k}k=p+15&-16;p=d+15|0;m=p|15;n=p>>>0>15;if(m>>>0<2e3)if(n){p=i;i=i+((1*m|0)+15&-16)|0;q=0;r=p}else{q=0;r=0}else if(n){c[l>>2]=c[153134];c[h+0>>2]=c[l+0>>2];l=cOb(m,16,h,0,3653512,59)|0;q=l;r=l}else{q=0;r=0}l=r+15&-16;if((d|0)>0){r=-1;m=0;while(1){n=e+(m*20|0)|0;c[e+(m*20|0)+4>>2]=m;c[e+(m*20|0)+8>>2]=c[b+(m*152|0)+8>>2];c[e+(m*20|0)+12>>2]=c[b+(m*152|0)>>2];p=b+(m*152|0)+4|0;c[e+(m*20|0)+16>>2]=c[p>>2];s=(m|0)/16|0;t=ea(g[b+(m*152|0)+100>>2]);u=ea(g[b+(m*152|0)+104>>2]);v=ea(g[b+(m*152|0)+108>>2]);w=ea(g[b+(m*152|0)+112>>2]);x=l+(s<<4)|0;if(!(m&15)){g[x>>2]=t;g[l+(s<<4)+4>>2]=u;g[l+(s<<4)+8>>2]=v;g[l+(s<<4)+12>>2]=w}else{y=ea(g[x>>2]);z=l+(s<<4)+4|0;A=ea(g[z>>2]);B=l+(s<<4)+8|0;C=ea(g[B>>2]);D=l+(s<<4)+12|0;E=ea(g[D>>2]);F=t<y?t:y;G=u<A?u:A;H=ea(y+C);C=ea(t+v);y=ea(A+E);E=ea(u+w);A=ea((H<C?C:H)-F);H=ea((y<E?E:y)-G);g[x>>2]=F;g[z>>2]=G;g[B>>2]=A;g[D>>2]=H}D=b+(m*152|0)|0;if((c[b+(m*152|0)+140>>2]|0)!=0?(c[D>>2]|0)!=0:0)I=18;else if(!(a[b+(m*152|0)+148>>0]|0))c[n>>2]=-1;else I=18;if((I|0)==18){I=0;g[k+(m<<4)>>2]=t;g[k+(m<<4)+4>>2]=u;g[k+(m<<4)+8>>2]=v;g[k+(m<<4)+12>>2]=w;H=ea(t+v);v=ea(u+w);B=0;z=-17;x=0;while(1){J=~((z|0)>(r|0)?z:r);w=ea(g[l+(x<<4)>>2]);K=H<w?1:ea(w+ea(g[l+(x<<4)+8>>2]))<t;w=ea(g[l+(x<<4)+4>>2]);if(!(K|v<w|ea(w+ea(g[l+(x<<4)+12>>2]))<u)?(K=x<<4,L=K+16|0,(K|0)<(((m|0)<(L|0)?m:L)|0)):0){L=B;M=K;while(1){K=c[e+(M*20|0)>>2]|0;do if((K|0)!=-1?(w=ea(g[k+(M<<4)>>2]),N=H<w?1:ea(w+ea(g[k+(M<<4)+8>>2]))<t,w=ea(g[k+(M<<4)+4>>2]),!(N|v<w|ea(w+ea(g[k+(M<<4)+12>>2]))<u)):0){if((c[D>>2]|0)==(c[b+(M*152|0)>>2]|0)?(c[p>>2]|0)==(c[b+(M*152|0)+4>>2]|0):0){O=(K|0)<(L|0)?L:K;break}N=K+1|0;O=(N|0)<(L|0)?L:N}else O=L;while(0);M=M+1|0;if((M|0)==(J|0)){P=O;break}else L=O}}else P=B;if((x|0)<(s|0)){B=P;z=z+-16|0;x=x+1|0}else{Q=P;break}}c[n>>2]=Q}m=m+1|0;if((m|0)==(d|0))break;else r=r+-1|0}}if(q){c[j>>2]=c[153134];c[h+0>>2]=c[j+0>>2];eOb(q,h)}if(!o){i=f;return}c[j>>2]=c[153134];c[h+0>>2]=c[j+0>>2];eOb(o,h);i=f;return}function xje(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=i;i=i+32|0;f=e;g=a;a=b;a:while(1){b=a;h=a+-20|0;j=a+-40|0;k=a+-8|0;l=a+-4|0;m=a+-12|0;n=g;b:while(1){o=n;p=b-o|0;switch((p|0)/20|0|0){case 4:{q=n;r=h;s=13;break a;break}case 3:{t=n;u=h;s=12;break a;break}case 2:{v=n;w=h;x=k;y=l;z=m;A=h;s=4;break a;break}case 1:case 0:{s=113;break a;break}case 5:{B=n;C=h;s=14;break a;break}default:{}}if((p|0)<620){D=n;E=a;s=16;break a}F=(p|0)/40|0;G=n+(F*20|0)|0;if((p|0)>19980){H=(p|0)/80|0;I=Aje(n,n+(H*20|0)|0,G,n+((H+F|0)*20|0)|0,h,d)|0}else I=yje(n,G,h,d)|0;H=c[n>>2]|0;p=c[G>>2]|0;do if((H|0)==(p|0)){J=c[n+12>>2]|0;K=c[n+(F*20|0)+12>>2]|0;if((J|0)!=(K|0))if((J|0)<(K|0)){L=h;M=I;break}else{s=27;break}K=c[n+16>>2]|0;J=c[n+(F*20|0)+16>>2]|0;if((K|0)==(J|0))if((c[n+8>>2]|0)<(c[n+(F*20|0)+8>>2]|0)){L=h;M=I;break}else{s=27;break}else if((K|0)<(J|0)){L=h;M=I;break}else{s=27;break}}else if((H|0)<(p|0)){L=h;M=I}else s=27;while(0);c:do if((s|0)==27){s=0;d:do if((n|0)!=(j|0)){J=n+(F*20|0)+12|0;K=n+(F*20|0)+16|0;N=n+(F*20|0)+8|0;O=a;P=j;Q=h;e:while(1){R=c[O+-40>>2]|0;do if((R|0)==(p|0)){S=c[O+-28>>2]|0;T=c[J>>2]|0;if((S|0)!=(T|0))if((S|0)<(T|0)){U=P;break e}else break;T=c[O+-24>>2]|0;S=c[K>>2]|0;if((T|0)==(S|0))if((c[O+-32>>2]|0)<(c[N>>2]|0)){U=P;break e}else break;else if((T|0)<(S|0)){U=P;break e}else break}else if((R|0)<(p|0)){U=P;break e}while(0);R=Q+-40|0;if((n|0)==(R|0))break d;else{S=P;T=Q;P=R;Q=S;O=T}}c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[f+16>>2]=c[n+16>>2];c[n+0>>2]=c[U+0>>2];c[n+4>>2]=c[U+4>>2];c[n+8>>2]=c[U+8>>2];c[n+12>>2]=c[U+12>>2];c[n+16>>2]=c[U+16>>2];c[U+0>>2]=c[f+0>>2];c[U+4>>2]=c[f+4>>2];c[U+8>>2]=c[f+8>>2];c[U+12>>2]=c[f+12>>2];c[U+16>>2]=c[f+16>>2];L=U;M=I+1|0;break c}while(0);O=n+20|0;Q=c[h>>2]|0;do if((H|0)==(Q|0)){P=c[n+12>>2]|0;N=c[k>>2]|0;if((P|0)!=(N|0))if((P|0)<(N|0)){V=O;break}else{s=36;break}N=c[n+16>>2]|0;P=c[l>>2]|0;if((N|0)==(P|0))if((c[n+8>>2]|0)<(c[m>>2]|0)){V=O;break}else{s=36;break}else if((N|0)<(P|0)){V=O;break}else{s=36;break}}else if((H|0)<(Q|0))V=O;else s=36;while(0);if((s|0)==36){s=0;if((O|0)==(h|0)){s=113;break a}Q=n+12|0;P=n+16|0;N=n+8|0;K=n;J=O;f:while(1){T=c[J>>2]|0;do if((H|0)==(T|0)){S=c[Q>>2]|0;R=c[J+12>>2]|0;if((S|0)!=(R|0))if((S|0)<(R|0)){W=J;break f}else break;R=c[P>>2]|0;S=c[J+16>>2]|0;if((R|0)==(S|0))if((c[N>>2]|0)<(c[J+8>>2]|0)){W=J;break f}else break;else if((R|0)<(S|0)){W=J;break f}else break}else if((H|0)<(T|0)){W=J;break f}while(0);T=K+40|0;if((T|0)==(h|0)){s=113;break a}else{S=J;J=T;K=S}}c[f+0>>2]=c[W+0>>2];c[f+4>>2]=c[W+4>>2];c[f+8>>2]=c[W+8>>2];c[f+12>>2]=c[W+12>>2];c[f+16>>2]=c[W+16>>2];c[W+0>>2]=c[h+0>>2];c[W+4>>2]=c[h+4>>2];c[W+8>>2]=c[h+8>>2];c[W+12>>2]=c[h+12>>2];c[W+16>>2]=c[h+16>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];V=W+20|0}if((V|0)==(h|0)){s=113;break a}K=n+8|0;J=n+12|0;N=n+16|0;P=V;Q=h;while(1){O=c[n>>2]|0;S=P;g:while(1){T=c[S>>2]|0;do if((O|0)==(T|0)){R=c[J>>2]|0;X=c[S+12>>2]|0;if((R|0)!=(X|0))if((R|0)<(X|0)){Y=S;break g}else break;X=c[N>>2]|0;R=c[S+16>>2]|0;if((X|0)==(R|0))if((c[K>>2]|0)<(c[S+8>>2]|0)){Y=S;break g}else break;else if((X|0)<(R|0)){Y=S;break g}else break}else if((O|0)<(T|0)){Y=S;break g}while(0);S=S+20|0}S=Q;while(1){T=S+-20|0;R=c[T>>2]|0;if((O|0)!=(R|0))if((O|0)<(R|0)){S=T;continue}else{Z=T;break}R=c[J>>2]|0;X=c[S+-8>>2]|0;if((R|0)!=(X|0))if((R|0)<(X|0)){S=T;continue}else{Z=T;break}X=c[N>>2]|0;R=c[S+-4>>2]|0;if((X|0)==(R|0))if((c[K>>2]|0)<(c[S+-12>>2]|0)){S=T;continue}else{Z=T;break}else if((X|0)<(R|0)){S=T;continue}else{Z=T;break}}if(Y>>>0>=Z>>>0){n=Y;continue b};c[f+0>>2]=c[Y+0>>2];c[f+4>>2]=c[Y+4>>2];c[f+8>>2]=c[Y+8>>2];c[f+12>>2]=c[Y+12>>2];c[f+16>>2]=c[Y+16>>2];c[Y+0>>2]=c[Z+0>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];c[Y+16>>2]=c[Z+16>>2];c[Z+0>>2]=c[f+0>>2];c[Z+4>>2]=c[f+4>>2];c[Z+8>>2]=c[f+8>>2];c[Z+12>>2]=c[f+12>>2];c[Z+16>>2]=c[f+16>>2];P=Y+20|0;Q=Z}}while(0);H=n+20|0;h:do if(H>>>0<L>>>0){p=H;F=L;Q=G;P=M;while(1){K=c[Q>>2]|0;N=Q+12|0;J=Q+16|0;S=Q+8|0;O=p;i:while(1){T=c[O>>2]|0;do if((T|0)==(K|0)){R=c[O+12>>2]|0;X=c[N>>2]|0;if((R|0)!=(X|0))if((R|0)<(X|0))break;else{_=O;break i}X=c[O+16>>2]|0;R=c[J>>2]|0;if((X|0)==(R|0))if((c[O+8>>2]|0)<(c[S>>2]|0))break;else{_=O;break i}else if((X|0)<(R|0))break;else{_=O;break i}}else if((T|0)>=(K|0)){_=O;break i}while(0);O=O+20|0}O=F;while(1){T=O+-20|0;R=c[T>>2]|0;if((R|0)!=(K|0))if((R|0)<(K|0)){$=T;break}else{O=T;continue}R=c[O+-8>>2]|0;X=c[N>>2]|0;if((R|0)!=(X|0))if((R|0)<(X|0)){$=T;break}else{O=T;continue}X=c[O+-4>>2]|0;R=c[J>>2]|0;if((X|0)==(R|0))if((c[O+-12>>2]|0)<(c[S>>2]|0)){$=T;break}else{O=T;continue}else if((X|0)<(R|0)){$=T;break}else{O=T;continue}}if(_>>>0>$>>>0){aa=_;ba=Q;ca=P;break h};c[f+0>>2]=c[_+0>>2];c[f+4>>2]=c[_+4>>2];c[f+8>>2]=c[_+8>>2];c[f+12>>2]=c[_+12>>2];c[f+16>>2]=c[_+16>>2];c[_+0>>2]=c[$+0>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];c[_+12>>2]=c[$+12>>2];c[_+16>>2]=c[$+16>>2];c[$+0>>2]=c[f+0>>2];c[$+4>>2]=c[f+4>>2];c[$+8>>2]=c[f+8>>2];c[$+12>>2]=c[f+12>>2];c[$+16>>2]=c[f+16>>2];p=_+20|0;F=$;Q=(Q|0)==(_|0)?$:Q;P=P+1|0}}else{aa=H;ba=G;ca=M}while(0);j:do if((aa|0)==(ba|0))da=ca;else{G=c[ba>>2]|0;H=c[aa>>2]|0;do if((G|0)==(H|0)){P=c[ba+12>>2]|0;Q=c[aa+12>>2]|0;if((P|0)!=(Q|0))if((P|0)<(Q|0))break;else{da=ca;break j}Q=c[ba+16>>2]|0;P=c[aa+16>>2]|0;if((Q|0)==(P|0))if((c[ba+8>>2]|0)<(c[aa+8>>2]|0))break;else{da=ca;break j}else if((Q|0)<(P|0))break;else{da=ca;break j}}else if((G|0)>=(H|0)){da=ca;break j}while(0);c[f+0>>2]=c[aa+0>>2];c[f+4>>2]=c[aa+4>>2];c[f+8>>2]=c[aa+8>>2];c[f+12>>2]=c[aa+12>>2];c[f+16>>2]=c[aa+16>>2];c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];c[aa+12>>2]=c[ba+12>>2];c[aa+16>>2]=c[ba+16>>2];c[ba+0>>2]=c[f+0>>2];c[ba+4>>2]=c[f+4>>2];c[ba+8>>2]=c[f+8>>2];c[ba+12>>2]=c[f+12>>2];c[ba+16>>2]=c[f+16>>2];da=ca+1|0}while(0);if(!da){ea=Cje(n,aa,d)|0;H=aa+20|0;if(Cje(H,a,d)|0){s=108;break}if(ea){n=H;continue}}H=aa;if((H-o|0)>=(b-H|0)){fa=n;ga=aa;s=112;break}xje(n,aa,d);n=aa+20|0}if((s|0)==108){s=0;if(ea){s=113;break}else{g=n;a=aa;continue}}else if((s|0)==112){s=0;xje(ga+20|0,a,d);g=fa;a=ga;continue}}if((s|0)==4){ga=c[w>>2]|0;w=c[v>>2]|0;do if((ga|0)==(w|0)){a=c[x>>2]|0;fa=c[v+12>>2]|0;if((a|0)!=(fa|0)){if((a|0)<(fa|0))break;i=e;return}fa=c[y>>2]|0;a=c[v+16>>2]|0;if((fa|0)==(a|0)){if((c[z>>2]|0)<(c[v+8>>2]|0))break;i=e;return}else{if((fa|0)<(a|0))break;i=e;return}}else if((ga|0)>=(w|0)){i=e;return}while(0);c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];c[f+16>>2]=c[v+16>>2];c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[v+12>>2]=c[A+12>>2];c[v+16>>2]=c[A+16>>2];c[A+0>>2]=c[f+0>>2];c[A+4>>2]=c[f+4>>2];c[A+8>>2]=c[f+8>>2];c[A+12>>2]=c[f+12>>2];c[A+16>>2]=c[f+16>>2];i=e;return}else if((s|0)==12){yje(t,t+20|0,u,d)|0;i=e;return}else if((s|0)==13){zje(q,q+20|0,q+40|0,r,d)|0;i=e;return}else if((s|0)==14){Aje(B,B+20|0,B+40|0,B+60|0,C,d)|0;i=e;return}else if((s|0)==16){Bje(D,E,d);i=e;return}else if((s|0)==113){i=e;return}}function yje(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=c[b>>2]|0;h=c[a>>2]|0;do if((g|0)==(h|0)){j=c[b+12>>2]|0;k=c[a+12>>2]|0;if((j|0)!=(k|0)){l=(j|0)<(k|0);break}k=c[b+16>>2]|0;j=c[a+16>>2]|0;if((k|0)==(j|0)){l=(c[b+8>>2]|0)<(c[a+8>>2]|0);break}else{l=(k|0)<(j|0);break}}else l=(g|0)<(h|0);while(0);h=c[d>>2]|0;do if((h|0)==(g|0)){j=c[d+12>>2]|0;k=c[b+12>>2]|0;if((j|0)!=(k|0)){m=(j|0)<(k|0);break}k=c[d+16>>2]|0;j=c[b+16>>2]|0;if((k|0)==(j|0)){m=(c[d+8>>2]|0)<(c[b+8>>2]|0);break}else{m=(k|0)<(j|0);break}}else m=(h|0)<(g|0);while(0);if(!l){if(!m){n=0;i=e;return n|0};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];l=c[b>>2]|0;g=c[a>>2]|0;do if((l|0)==(g|0)){h=c[b+12>>2]|0;j=c[a+12>>2]|0;if((h|0)!=(j|0)){if((h|0)<(j|0))break;else n=1;i=e;return n|0}j=c[b+16>>2]|0;h=c[a+16>>2]|0;if((j|0)==(h|0)){if((c[b+8>>2]|0)<(c[a+8>>2]|0))break;else n=1;i=e;return n|0}else{if((j|0)<(h|0))break;else n=1;i=e;return n|0}}else if((l|0)>=(g|0)){n=1;i=e;return n|0}while(0);c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];n=2;i=e;return n|0}if(m){c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];n=1;i=e;return n|0};c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];a=c[d>>2]|0;m=c[b>>2]|0;do if((a|0)==(m|0)){g=c[d+12>>2]|0;l=c[b+12>>2]|0;if((g|0)!=(l|0)){if((g|0)<(l|0))break;else n=1;i=e;return n|0}l=c[d+16>>2]|0;g=c[b+16>>2]|0;if((l|0)==(g|0)){if((c[d+8>>2]|0)<(c[b+8>>2]|0))break;else n=1;i=e;return n|0}else{if((l|0)<(g|0))break;else n=1;i=e;return n|0}}else if((a|0)>=(m|0)){n=1;i=e;return n|0}while(0);c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];n=2;i=e;return n|0}function zje(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=yje(a,b,d,f)|0;f=c[e>>2]|0;k=c[d>>2]|0;do if((f|0)==(k|0)){l=c[e+12>>2]|0;m=c[d+12>>2]|0;if((l|0)!=(m|0)){if((l|0)<(m|0))break;else n=j;i=g;return n|0}m=c[e+16>>2]|0;l=c[d+16>>2]|0;if((m|0)==(l|0)){if((c[e+8>>2]|0)<(c[d+8>>2]|0))break;else n=j;i=g;return n|0}else{if((m|0)<(l|0))break;else n=j;i=g;return n|0}}else if((f|0)>=(k|0)){n=j;i=g;return n|0}while(0);c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];e=j+1|0;k=c[d>>2]|0;f=c[b>>2]|0;do if((k|0)==(f|0)){l=c[d+12>>2]|0;m=c[b+12>>2]|0;if((l|0)!=(m|0)){if((l|0)<(m|0))break;else n=e;i=g;return n|0}m=c[d+16>>2]|0;l=c[b+16>>2]|0;if((m|0)==(l|0)){if((c[d+8>>2]|0)<(c[b+8>>2]|0))break;else n=e;i=g;return n|0}else{if((m|0)<(l|0))break;else n=e;i=g;return n|0}}else if((k|0)>=(f|0)){n=e;i=g;return n|0}while(0);c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];d=j+2|0;e=c[b>>2]|0;f=c[a>>2]|0;do if((e|0)==(f|0)){k=c[b+12>>2]|0;l=c[a+12>>2]|0;if((k|0)!=(l|0)){if((k|0)<(l|0))break;else n=d;i=g;return n|0}l=c[b+16>>2]|0;k=c[a+16>>2]|0;if((l|0)==(k|0)){if((c[b+8>>2]|0)<(c[a+8>>2]|0))break;else n=d;i=g;return n|0}else{if((l|0)<(k|0))break;else n=d;i=g;return n|0}}else if((e|0)>=(f|0)){n=d;i=g;return n|0}while(0);c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];n=j+3|0;i=g;return n|0}function Aje(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h;k=zje(a,b,d,e,g)|0;g=c[f>>2]|0;l=c[e>>2]|0;do if((g|0)==(l|0)){m=c[f+12>>2]|0;n=c[e+12>>2]|0;if((m|0)!=(n|0)){if((m|0)<(n|0))break;else o=k;i=h;return o|0}n=c[f+16>>2]|0;m=c[e+16>>2]|0;if((n|0)==(m|0)){if((c[f+8>>2]|0)<(c[e+8>>2]|0))break;else o=k;i=h;return o|0}else{if((n|0)<(m|0))break;else o=k;i=h;return o|0}}else if((g|0)>=(l|0)){o=k;i=h;return o|0}while(0);c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];f=k+1|0;l=c[e>>2]|0;g=c[d>>2]|0;do if((l|0)==(g|0)){m=c[e+12>>2]|0;n=c[d+12>>2]|0;if((m|0)!=(n|0)){if((m|0)<(n|0))break;else o=f;i=h;return o|0}n=c[e+16>>2]|0;m=c[d+16>>2]|0;if((n|0)==(m|0)){if((c[e+8>>2]|0)<(c[d+8>>2]|0))break;else o=f;i=h;return o|0}else{if((n|0)<(m|0))break;else o=f;i=h;return o|0}}else if((l|0)>=(g|0)){o=f;i=h;return o|0}while(0);c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];e=k+2|0;f=c[d>>2]|0;g=c[b>>2]|0;do if((f|0)==(g|0)){l=c[d+12>>2]|0;m=c[b+12>>2]|0;if((l|0)!=(m|0)){if((l|0)<(m|0))break;else o=e;i=h;return o|0}m=c[d+16>>2]|0;l=c[b+16>>2]|0;if((m|0)==(l|0)){if((c[d+8>>2]|0)<(c[b+8>>2]|0))break;else o=e;i=h;return o|0}else{if((m|0)<(l|0))break;else o=e;i=h;return o|0}}else if((f|0)>=(g|0)){o=e;i=h;return o|0}while(0);c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2];c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[d+16>>2]=c[j+16>>2];d=k+3|0;e=c[b>>2]|0;g=c[a>>2]|0;do if((e|0)==(g|0)){f=c[b+12>>2]|0;l=c[a+12>>2]|0;if((f|0)!=(l|0)){if((f|0)<(l|0))break;else o=d;i=h;return o|0}l=c[b+16>>2]|0;f=c[a+16>>2]|0;if((l|0)==(f|0)){if((c[b+8>>2]|0)<(c[a+8>>2]|0))break;else o=d;i=h;return o|0}else{if((l|0)<(f|0))break;else o=d;i=h;return o|0}}else if((e|0)>=(g|0)){o=d;i=h;return o|0}while(0);c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];c[b+16>>2]=c[j+16>>2];o=k+4|0;i=h;return o|0}function Bje(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=a+40|0;yje(a,a+20|0,f,d)|0;d=a+60|0;if((d|0)==(b|0)){i=e;return}else{g=d;h=f}while(1){f=c[g>>2]|0;d=c[h>>2]|0;do if((f|0)==(d|0)){j=c[g+12>>2]|0;k=c[h+12>>2]|0;if((j|0)!=(k|0))if((j|0)<(k|0)){l=j;m=10;break}else break;k=c[g+16>>2]|0;n=c[h+16>>2]|0;if((k|0)==(n|0))if((c[g+8>>2]|0)<(c[h+8>>2]|0)){l=j;m=10;break}else break;else if((k|0)<(n|0)){l=j;m=10;break}else break}else if((f|0)<(d|0)){l=c[g+12>>2]|0;m=10}while(0);if((m|0)==10){m=0;d=c[g+4>>2]|0;j=c[g+8>>2]|0;n=c[g+16>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[g+16>>2]=c[h+16>>2];a:do if((h|0)==(a|0))o=a;else{k=h;while(1){p=k;k=k+-20|0;q=c[k>>2]|0;do if((f|0)==(q|0)){r=c[p+-8>>2]|0;if((l|0)!=(r|0))if((l|0)<(r|0))break;else{o=p;break a}r=c[p+-4>>2]|0;if((n|0)==(r|0))if((j|0)<(c[p+-12>>2]|0))break;else{o=p;break a}else if((n|0)<(r|0))break;else{o=p;break a}}else if((f|0)>=(q|0)){o=p;break a}while(0);c[p+0>>2]=c[k+0>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];c[p+16>>2]=c[k+16>>2];if((k|0)==(a|0)){o=a;break}}}while(0);c[o>>2]=f;c[o+4>>2]=d;c[o+8>>2]=j;c[o+12>>2]=l;c[o+16>>2]=n}k=g+20|0;if((k|0)==(b|0))break;else{q=g;g=k;h=q}}i=e;return}function Cje(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e;switch((b-a|0)/20|0|0){case 5:{Aje(a,a+20|0,a+40|0,a+60|0,b+-20|0,d)|0;g=1;i=e;return g|0}case 4:{zje(a,a+20|0,a+40|0,b+-20|0,d)|0;g=1;i=e;return g|0}case 3:{yje(a,a+20|0,b+-20|0,d)|0;g=1;i=e;return g|0}case 1:case 0:{g=1;i=e;return g|0}case 2:{h=b+-20|0;j=c[h>>2]|0;k=c[a>>2]|0;do if((j|0)==(k|0)){l=c[b+-8>>2]|0;m=c[a+12>>2]|0;if((l|0)!=(m|0)){if((l|0)<(m|0))break;else g=1;i=e;return g|0}m=c[b+-4>>2]|0;l=c[a+16>>2]|0;if((m|0)==(l|0)){if((c[b+-12>>2]|0)<(c[a+8>>2]|0))break;else g=1;i=e;return g|0}else{if((m|0)<(l|0))break;else g=1;i=e;return g|0}}else if((j|0)>=(k|0)){g=1;i=e;return g|0}while(0);c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[a+0>>2]=c[h+0>>2];c[a+4>>2]=c[h+4>>2];c[a+8>>2]=c[h+8>>2];c[a+12>>2]=c[h+12>>2];c[a+16>>2]=c[h+16>>2];c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];g=1;i=e;return g|0}default:{f=a+40|0;yje(a,a+20|0,f,d)|0;d=a+60|0;if((d|0)==(b|0)){g=1;i=e;return g|0}else{n=0;o=d;p=f}while(1){f=c[o>>2]|0;d=c[p>>2]|0;do if((f|0)==(d|0)){h=c[o+12>>2]|0;k=c[p+12>>2]|0;if((h|0)!=(k|0))if((h|0)<(k|0)){q=h;r=22;break}else{s=n;break}k=c[o+16>>2]|0;j=c[p+16>>2]|0;if((k|0)==(j|0))if((c[o+8>>2]|0)<(c[p+8>>2]|0)){q=h;r=22;break}else{s=n;break}else if((k|0)<(j|0)){q=h;r=22;break}else{s=n;break}}else if((f|0)<(d|0)){q=c[o+12>>2]|0;r=22}else s=n;while(0);if((r|0)==22){r=0;d=c[o+4>>2]|0;h=c[o+8>>2]|0;j=c[o+16>>2]|0;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[o+16>>2]=c[p+16>>2];a:do if((p|0)==(a|0))t=a;else{k=p;while(1){l=k;k=k+-20|0;m=c[k>>2]|0;do if((f|0)==(m|0)){u=c[l+-8>>2]|0;if((q|0)!=(u|0))if((q|0)<(u|0))break;else{t=l;break a}u=c[l+-4>>2]|0;if((j|0)==(u|0))if((h|0)<(c[l+-12>>2]|0))break;else{t=l;break a}else if((j|0)<(u|0))break;else{t=l;break a}}else if((f|0)>=(m|0)){t=l;break a}while(0);c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[l+16>>2]=c[k+16>>2];if((k|0)==(a|0)){t=a;break}}}while(0);c[t>>2]=f;c[t+4>>2]=d;c[t+8>>2]=h;c[t+12>>2]=q;c[t+16>>2]=j;k=n+1|0;if((k|0)==8){v=o;break}else s=k}k=o+20|0;if((k|0)==(b|0)){g=1;r=34;break}else{m=o;n=s;o=k;p=m}}if((r|0)==34){i=e;return g|0}g=(v+20|0)==(b|0);i=e;return g|0}}return 0}function Dje(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=Im,x=Im,y=Im,z=Im,A=0;e=i;f=d+76|0;h=(c[f>>2]|0)!=0;j=h&1;k=d+92|0;l=(c[k>>2]|0)!=0;if(h)m=l?3:j;else m=l?2:j;j=d+68|0;l=b[j>>1]|0;if(l<<16>>16==0|(m|0)==0){i=e;return}h=d+24|0;n=c[h>>2]|0;if(n){o=vTb(n)|0;n=b[j>>1]|0;if(o)p=n;else{q=n;r=7}}else{q=l;r=7}if((r|0)==7)if(!(q&512)){i=e;return}else p=q;if(p&256){if(m&1){q=c[f>>2]|0;a[q+96>>0]=1;r=c[d+80>>2]|0;c[(c[q+80>>2]|0)+(r*152|0)+8>>2]=(q|0)==0?-1:r}if(m&2){r=c[k>>2]|0;a[r+96>>0]=1;if(!(c[f>>2]|0))s=-1;else s=c[d+80>>2]|0;c[(c[r+80>>2]|0)+((c[d+96>>2]|0)*152|0)+8>>2]=s}}if(!(p&2))t=p;else{Eje(d,m);t=b[j>>1]|0}if(t&32){if(m&1){p=c[f>>2]|0;a[p+96>>0]=1;s=c[d+80>>2]|0;r=c[p+80>>2]|0;c[r+(s*152|0)+136>>2]=c[d+44>>2];c[r+(s*152|0)+140>>2]=c[d+48>>2]}if(m&2){s=c[k>>2]|0;a[s+96>>0]=1;r=c[d+96>>2]|0;p=c[s+80>>2]|0;c[p+(r*152|0)+136>>2]=c[d+44>>2];c[p+(r*152|0)+140>>2]=c[d+48>>2]}}if(!(t&4))u=t;else{Fje(d,m);u=b[j>>1]|0}if(!(u&1))v=u;else{Gje(d,m);v=b[j>>1]|0}if(v&16){do if(m&1){u=c[f>>2]|0;a[u+96>>0]=1;t=(c[u+80>>2]|0)+((c[d+80>>2]|0)*152|0)+144|0;if(!(a[d+70>>0]|0)){c[t>>2]=0;break}else{c[t>>2]=1;break}}while(0);if(m&2){t=c[k>>2]|0;a[t+96>>0]=1;c[(c[t+80>>2]|0)+((c[d+96>>2]|0)*152|0)+144>>2]=2}}if(v&64){if(m&1){t=c[f>>2]|0;a[t+96>>0]=1;u=c[d+80>>2]|0;r=c[t+80>>2]|0;w=ea(g[d+28>>2]);x=ea(g[d+32>>2]);y=ea(g[d+36>>2]);z=ea(g[d+40>>2]);g[r+(u*152|0)+116>>2]=w;g[r+(u*152|0)+120>>2]=x;g[r+(u*152|0)+124>>2]=y;g[r+(u*152|0)+128>>2]=z}if(m&2){u=c[k>>2]|0;a[u+96>>0]=1;r=c[d+96>>2]|0;t=c[u+80>>2]|0;z=ea(g[d+28>>2]);y=ea(g[d+32>>2]);x=ea(g[d+36>>2]);w=ea(g[d+40>>2]);g[t+(r*152|0)+116>>2]=z;g[t+(r*152|0)+120>>2]=y;g[t+(r*152|0)+124>>2]=x;g[t+(r*152|0)+128>>2]=w}}if(v&128){v=c[d+72>>2]|0;if(!v)A=0;else A=BTb(c[v+24>>2]|0)|0;w=ea(Yje(BTb(c[h>>2]|0)|0,A,ea(1.0)));if(m&1){A=c[f>>2]|0;a[A+96>>0]=1;g[(c[A+80>>2]|0)+((c[d+80>>2]|0)*152|0)+132>>2]=w}if(m&2){A=c[k>>2]|0;a[A+96>>0]=1;g[(c[A+80>>2]|0)+((c[d+96>>2]|0)*152|0)+132>>2]=w}}if(b[j>>1]&8){if(m&1){A=c[f>>2]|0;a[A+96>>0]=1;f=c[d+80>>2]|0;h=c[A+80>>2]|0;A=h+(f*152|0)|0;v=c[h+(f*152|0)+144>>2]|0;if((v|0)==1)c[A>>2]=c[d+56>>2];else if((v|0)==2)c[A>>2]=c[d+60>>2];else c[A>>2]=c[d+52>>2];c[h+(f*152|0)+4>>2]=c[d+64>>2]}if(m&2){m=c[k>>2]|0;a[m+96>>0]=1;k=c[d+96>>2]|0;f=c[m+80>>2]|0;m=f+(k*152|0)|0;h=c[f+(k*152|0)+144>>2]|0;if((h|0)==1)c[m>>2]=c[d+56>>2];else if((h|0)==2)c[m>>2]=c[d+60>>2];else c[m>>2]=c[d+52>>2];c[f+(k*152|0)+4>>2]=c[d+64>>2]}}b[j>>1]=0;i=e;return}function Eje(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e;if(d&1){g=b+76|0;h=c[g>>2]|0;a[h+96>>0]=1;j=c[b+80>>2]|0;k=c[h+80>>2]|0;NGc(BTb(c[b+24>>2]|0)|0,f)|0;eMc(c[g>>2]|0,f,k+(j*152|0)+12|0)}if(!(d&2)){i=e;return}d=b+92|0;j=c[d>>2]|0;a[j+96>>0]=1;k=c[b+96>>2]|0;g=c[j+80>>2]|0;NGc(BTb(c[b+24>>2]|0)|0,f)|0;eMc(c[d>>2]|0,f,g+(k*152|0)+12|0);i=e;return}function Fje(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=0,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im;e=i;if(d&1){f=c[b+76>>2]|0;a[f+96>>0]=1;h=c[b+80>>2]|0;j=c[f+80>>2]|0;k=ea(g[150280]);l=ea(g[150281]);m=ea(g[150282]);n=ea(-k);o=ea(-l);p=ea(-m);f=c[j+(h*152|0)+140>>2]|0;if((f|0)>0){q=c[j+(h*152|0)+136>>2]|0;r=k;s=l;t=m;u=n;v=o;w=p;x=0;while(1){y=ea(g[q+(x*60|0)>>2]);z=y<r?y:r;A=ea(g[q+(x*60|0)+4>>2]);B=A<s?A:s;C=ea(g[q+(x*60|0)+8>>2]);D=C<t?C:t;E=u<y?y:u;y=v<A?A:v;A=w<C?C:w;x=x+1|0;if((x|0)>=(f|0)){F=B;G=z;H=A;I=y;J=E;K=D;break}else{r=z;s=B;t=D;u=E;v=y;w=A}}}else{F=l;G=k;H=p;I=o;J=n;K=m}g[j+(h*152|0)+76>>2]=G;g[j+(h*152|0)+80>>2]=F;g[j+(h*152|0)+84>>2]=K;g[j+(h*152|0)+88>>2]=J;g[j+(h*152|0)+92>>2]=I;g[j+(h*152|0)+96>>2]=H}if(!(d&2)){i=e;return}d=c[b+92>>2]|0;a[d+96>>0]=1;h=c[b+96>>2]|0;b=c[d+80>>2]|0;H=ea(g[150280]);I=ea(g[150281]);J=ea(g[150282]);K=ea(-H);F=ea(-I);G=ea(-J);d=c[b+(h*152|0)+140>>2]|0;if((d|0)>0){j=c[b+(h*152|0)+136>>2]|0;m=H;n=I;o=J;p=K;k=F;l=G;f=0;while(1){w=ea(g[j+(f*60|0)>>2]);v=w<m?w:m;u=ea(g[j+(f*60|0)+4>>2]);t=u<n?u:n;s=ea(g[j+(f*60|0)+8>>2]);r=s<o?s:o;A=p<w?w:p;w=k<u?u:k;u=l<s?s:l;f=f+1|0;if((f|0)>=(d|0)){L=u;M=w;N=A;O=r;P=t;Q=v;break}else{m=v;n=t;o=r;p=A;k=w;l=u}}}else{L=G;M=F;N=K;O=J;P=I;Q=H}g[b+(h*152|0)+76>>2]=Q;g[b+(h*152|0)+80>>2]=P;g[b+(h*152|0)+84>>2]=O;g[b+(h*152|0)+88>>2]=N;g[b+(h*152|0)+92>>2]=M;g[b+(h*152|0)+96>>2]=L;i=e;return}function Gje(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=Im,r=0,s=0,t=Im,u=0,v=0,w=Im,x=Im,y=Im,z=Im;e=i;i=i+96|0;f=e+72|0;h=e+48|0;j=e+24|0;k=e;if(d&1){l=c[b+76>>2]|0;a[l+96>>0]=1;m=c[b+80>>2]|0;n=c[l+80>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;l=n+(m*152|0)+88|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;o=ea(g[l>>2]);p=n+(m*152|0)+76|0;q=ea(o+ea(g[p>>2]));r=n+(m*152|0)+92|0;o=ea(g[r>>2]);s=n+(m*152|0)+80|0;t=ea(o+ea(g[s>>2]));u=n+(m*152|0)+96|0;o=ea(g[u>>2]);v=n+(m*152|0)+84|0;w=ea(t*ea(.5));t=ea(ea(o+ea(g[v>>2]))*ea(.5));g[h>>2]=ea(q*ea(.5));g[h+4>>2]=w;g[h+8>>2]=t;t=ea(g[l>>2]);w=ea(t-ea(g[p>>2]));t=ea(g[r>>2]);q=ea(t-ea(g[s>>2]));t=ea(g[u>>2]);o=ea(q*ea(.5));q=ea(ea(t-ea(g[v>>2]))*ea(.5));g[h+12>>2]=ea(w*ea(.5));g[h+16>>2]=o;g[h+20>>2]=q;Xlc(h,n+(m*152|0)+12|0,f);q=ea(g[f>>2]);o=ea(g[f+12>>2]);w=ea(q-o);t=ea(g[f+4>>2]);x=ea(g[f+16>>2]);y=ea(t-x);z=ea(ea(q+o)-w);o=ea(ea(t+x)-y);g[n+(m*152|0)+100>>2]=w;g[n+(m*152|0)+108>>2]=z;g[n+(m*152|0)+104>>2]=y;g[n+(m*152|0)+112>>2]=o}if(!(d&2)){i=e;return}d=c[b+92>>2]|0;a[d+96>>0]=1;m=c[b+96>>2]|0;b=c[d+80>>2]|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;d=b+(m*152|0)+88|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;o=ea(g[d>>2]);n=b+(m*152|0)+76|0;y=ea(o+ea(g[n>>2]));f=b+(m*152|0)+92|0;o=ea(g[f>>2]);h=b+(m*152|0)+80|0;z=ea(o+ea(g[h>>2]));v=b+(m*152|0)+96|0;o=ea(g[v>>2]);u=b+(m*152|0)+84|0;w=ea(z*ea(.5));z=ea(ea(o+ea(g[u>>2]))*ea(.5));g[k>>2]=ea(y*ea(.5));g[k+4>>2]=w;g[k+8>>2]=z;z=ea(g[d>>2]);w=ea(z-ea(g[n>>2]));z=ea(g[f>>2]);y=ea(z-ea(g[h>>2]));z=ea(g[v>>2]);o=ea(y*ea(.5));y=ea(ea(z-ea(g[u>>2]))*ea(.5));g[k+12>>2]=ea(w*ea(.5));g[k+16>>2]=o;g[k+20>>2]=y;Xlc(k,b+(m*152|0)+12|0,j);y=ea(g[j>>2]);o=ea(g[j+12>>2]);w=ea(y-o);z=ea(g[j+4>>2]);x=ea(g[j+16>>2]);t=ea(z-x);q=ea(ea(y+o)-w);o=ea(ea(z+x)-t);g[b+(m*152|0)+100>>2]=w;g[b+(m*152|0)+108>>2]=q;g[b+(m*152|0)+104>>2]=t;g[b+(m*152|0)+112>>2]=o;i=e;return}function Hje(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=nQc(c[a+24>>2]|0,223)|0;h=a+72|0;c[h>>2]=g;if(!((g|0)!=0&(g|0)==(d|0))){j=g;i=f;return j|0}ele((e&2|0)!=0?a+92|0:a+76|0,d+108|0);d=a+68|0;b[d>>1]=b[d>>1]|511;d=Vke()|0;Rke(d,c[h>>2]|0,a);j=c[h>>2]|0;i=f;return j|0}function Ije(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=0,r=0,s=Im,t=Im,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=0,M=0,N=0;d=i;i=i+96|0;e=d+72|0;f=d+48|0;h=d+24|0;j=d;k=e+12|0;l=e+16|0;m=e+20|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+0>>2]=c[150280];c[e+4>>2]=c[150281];c[e+8>>2]=c[150282];n=ea(-ea(g[150280]));o=ea(-ea(g[150281]));p=ea(-ea(g[150282]));g[k>>2]=n;g[l>>2]=o;g[m>>2]=p;q=c[b+208>>2]|0;r=b+212|0;if((q|0)==(r|0)){s=n;t=o;u=p}else{b=h+4|0;v=h+8|0;w=h+12|0;x=h+16|0;y=h+20|0;z=j+12|0;A=j+4|0;B=j+16|0;C=j+8|0;D=j+20|0;E=q;while(1){pje(j,E+20|0);c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;p=ea(g[j>>2]);o=ea(g[z>>2]);n=ea(p-o);F=ea(g[A>>2]);G=ea(g[B>>2]);H=ea(F-G);I=ea(g[C>>2]);J=ea(g[D>>2]);K=ea(I-J);g[h>>2]=n;g[b>>2]=H;g[v>>2]=K;K=ea(F+G);G=ea(I+J);g[w>>2]=ea(p+o);g[x>>2]=K;g[y>>2]=G;Vlc(f,e,h);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];q=c[E+4>>2]|0;if(!q){L=E;while(1){M=c[L+8>>2]|0;if((c[M>>2]|0)==(L|0)){N=M;break}else L=M}}else{L=q;while(1){M=c[L>>2]|0;if(!M){N=L;break}else L=M}}if((N|0)==(r|0))break;else E=N}G=ea(g[k>>2]);K=ea(g[l>>2]);s=G;t=K;u=ea(g[m>>2])}c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;K=ea(g[e>>2]);G=ea(s+K);o=ea(g[e+4>>2]);p=ea(t+o);J=ea(g[e+8>>2]);I=ea(p*ea(.5));p=ea(ea(u+J)*ea(.5));g[a>>2]=ea(G*ea(.5));g[a+4>>2]=I;g[a+8>>2]=p;p=ea(ea(t-o)*ea(.5));o=ea(ea(u-J)*ea(.5));g[a+12>>2]=ea(ea(s-K)*ea(.5));g[a+16>>2]=p;g[a+20>>2]=o;i=d;return}function Jje(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=0,B=Im,C=0,D=0,E=0,F=0,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=Im,N=0,O=0,P=0,Q=0,R=0,S=Im,T=Im,U=Im,V=Im;e=i;i=i+48|0;f=e+24|0;h=e;j=d+276|0;if(!(a[j>>0]|0)){k=ea(g[d+264>>2]);l=ea(g[d+252>>2]);m=ea(g[d+268>>2]);n=ea(g[d+256>>2]);o=ea(g[d+272>>2]);p=k;q=l;r=m;s=n;t=o;u=ea(g[d+260>>2])}else{Ije(f,d);o=ea(g[f>>2]);n=ea(g[f+12>>2]);m=ea(o-n);l=ea(g[f+4>>2]);k=ea(g[f+16>>2]);v=ea(l-k);w=ea(g[f+8>>2]);x=ea(g[f+20>>2]);y=ea(w-x);f=d+252|0;g[f>>2]=m;z=d+256|0;g[z>>2]=v;A=d+260|0;g[A>>2]=y;B=ea(o+n);n=ea(l+k);k=ea(w+x);C=d+264|0;g[C>>2]=B;D=d+268|0;g[D>>2]=n;E=d+272|0;g[E>>2]=k;F=c[d+280>>2]|0;G=d+284|0;if((F|0)==(c[G>>2]|0)){H=y;I=k;J=v;K=n;L=m;M=B}else{d=h+12|0;N=h+4|0;O=h+16|0;P=h+8|0;Q=h+20|0;R=F;do{Jje(h,c[R>>2]|0);B=ea(g[h>>2]);m=ea(g[d>>2]);n=ea(B+m);v=ea(g[N>>2]);k=ea(g[O>>2]);y=ea(v+k);x=ea(g[P>>2]);w=ea(g[Q>>2]);l=ea(x+w);o=ea(g[f>>2]);S=n<o?n:o;o=ea(g[z>>2]);T=y<o?y:o;o=ea(g[A>>2]);U=l<o?l:o;o=ea(g[C>>2]);V=o<n?n:o;o=ea(g[D>>2]);n=o<y?y:o;o=ea(g[E>>2]);y=o<l?l:o;o=ea(B-m);m=ea(v-k);k=ea(x-w);w=o<S?o:S;S=m<T?m:T;T=k<U?k:U;g[f>>2]=w;g[z>>2]=S;g[A>>2]=T;U=V<o?o:V;V=n<m?m:n;n=y<k?k:y;g[C>>2]=U;g[D>>2]=V;g[E>>2]=n;R=R+4|0}while((R|0)!=(c[G>>2]|0));H=T;I=n;J=S;K=V;L=w;M=U}a[j>>0]=0;p=M;q=L;r=K;s=J;t=I;u=H}c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;H=ea(ea(r+s)*ea(.5));I=ea(ea(t+u)*ea(.5));g[b>>2]=ea(ea(p+q)*ea(.5));g[b+4>>2]=H;g[b+8>>2]=I;I=ea(ea(r-s)*ea(.5));s=ea(ea(t-u)*ea(.5));g[b+12>>2]=ea(ea(p-q)*ea(.5));g[b+16>>2]=I;g[b+20>>2]=s;i=e;return}function Kje(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d;f=c[(BTb(c[b+24>>2]|0)|0)+156>>2]|0;a:do if(!f)g=0;else{h=f;while(1){j=nQc(c[h+24>>2]|0,223)|0;if(!j){g=0;break a}if(a[j+29>>0]|0){k=j;break}h=c[(BTb(c[j+24>>2]|0)|0)+156>>2]|0;if(!h){g=0;break a}}g=k}while(0);k=b+220|0;f=c[k>>2]|0;if((f|0)==(g|0)){i=d;return}h=(f|0)==0;b:do if(!h){j=f;l=b;while(1){a[l+276>>0]=1;if(!j)break b;m=j;j=c[j+220>>2]|0;l=m}}while(0);l=(g|0)!=0;if(l){j=g;do{a[j+276>>0]=1;j=c[j+220>>2]|0}while((j|0)!=0)}c:do if(!h?(a[b+250>>0]|0)==0:0){j=c[f+280>>2]|0;m=f+284|0;n=c[m>>2]|0;if((j|0)!=(n|0)){o=j;while(1){if((c[o>>2]|0)==(b|0)){p=o;break}o=o+4|0;if((o|0)==(n|0))break c}o=p-j>>2;q=j+(o+1<<2)|0;r=n-q|0;aFi(j+(o<<2)|0,q|0,r|0)|0;q=j+((r>>2)+o<<2)|0;o=c[m>>2]|0;if((o|0)!=(q|0))c[m>>2]=o+(~((o+-4-q|0)>>>2)<<2);a[f+205>>0]=1}}else s=20;while(0);if((s|0)==20)Mke(Vke()|0,b);if(l?(a[b+250>>0]|0)==0:0){c[e>>2]=b;l=g+284|0;s=c[l>>2]|0;if((s|0)==(c[g+288>>2]|0))pke(g+280|0,e);else{if(!s)t=0;else{c[s>>2]=b;t=c[l>>2]|0}c[l>>2]=t+4}a[g+205>>0]=1}else Lke(Vke()|0,b);c[k>>2]=g;i=d;return}function Lje(d,e){d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;okc(d,e);a[d+204>>0]=1;a[d+205>>0]=1;if((a[d+29>>0]|0)!=0&(e|0)==0){Mje(d,1);c[g+8>>2]=0;c[g+4>>2]=0;c[g>>2]=0;KGc(BTb(c[d+24>>2]|0)|0,556808,g)}if(!(e&13)){i=f;return}e=ZWb()|0;b[d+278>>1]=PWb(e,c[d+244>>2]|0)|0;i=f;return}function Mje(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im,x=Im,y=Im,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=0,G=0,H=0,I=Im,J=Im,K=Im,L=Im,M=Im,N=Im,O=Im,P=Im,Q=Im,R=Im,S=Im,T=Im,U=Im,V=Im,W=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=Im,fa=0,ga=0,ha=Im,ia=Im,ja=Im,ka=Im,la=Im,ma=Im,na=Im,oa=Im,pa=Im,qa=Im,ra=0,sa=0,ta=Im,ua=Im,va=Im,wa=Im,xa=Im,ya=Im,za=0,Aa=0;f=i;i=i+80|0;h=f+64|0;j=f+28|0;k=f+16|0;l=f+20|0;m=f+72|0;n=f;o=f+24|0;p=f+48|0;q=f+32|0;r=ATb(c[b+24>>2]|0,224)|0;do if((c[b+32>>2]|0)>>>0<2?(c[b+220>>2]|0)==0:0){s=r+176|0;t=ea(g[s>>2]);u=ea(g[150272]);v=ea(u-t);if(v<ea(0.0))w=ea(-v);else w=v;if(t<ea(0.0))x=ea(-t);else x=t;if(u<ea(0.0))y=ea(-u);else y=u;t=ea((x<y?y:x)*ea(9.99999997e-07));z=t<ea(.000079999998);if(w<(z?ea(.000079999998):t)){t=ea(g[r+180>>2]);v=ea(g[150273]);A=ea(v-t);if(A<ea(0.0))B=ea(-A);else B=A;if(t<ea(0.0))C=ea(-t);else C=t;if(v<ea(0.0))D=ea(-v);else D=v;v=ea((C<D?D:C)*ea(9.99999997e-07));z=v<ea(.000079999998);if(B<(z?ea(.000079999998):v))E=u;else F=17}else F=17;if((F|0)==17){z=601088;G=c[z+4>>2]|0;H=s;c[H>>2]=c[z>>2];c[H+4>>2]=G;hzc(r);E=ea(g[150272])}G=r+184|0;u=ea(g[G>>2]);v=ea(E-u);if(v<ea(0.0))I=ea(-v);else I=v;if(u<ea(0.0))J=ea(-u);else J=u;if(E<ea(0.0))K=ea(-E);else K=E;u=ea((J<K?K:J)*ea(9.99999997e-07));H=u<ea(.000079999998);if(I<(H?ea(.000079999998):u)){u=ea(g[r+188>>2]);v=ea(g[150273]);t=ea(v-u);if(t<ea(0.0))L=ea(-t);else L=t;if(u<ea(0.0))M=ea(-u);else M=u;if(v<ea(0.0))N=ea(-v);else N=v;v=ea((M<N?N:M)*ea(9.99999997e-07));H=v<ea(.000079999998);if(!(L<(H?ea(.000079999998):v)))F=32}else F=32;if((F|0)==32){H=601088;z=c[H+4>>2]|0;s=G;c[s>>2]=c[H>>2];c[s+4>>2]=z;hzc(r)}z=r+208|0;v=ea(g[z>>2]);u=ea(ea(.5)-v);if(u<ea(0.0))O=ea(-u);else O=u;if(v<ea(0.0))P=ea(-v);else P=v;s=P<ea(.5);v=ea(P*ea(9.99999997e-07));u=s?ea(4.99999999e-07):v;s=u<ea(.000079999998);if(O<(s?ea(.000079999998):u)){u=ea(g[r+212>>2]);v=ea(ea(.5)-u);if(v<ea(0.0))Q=ea(-v);else Q=v;if(u<ea(0.0))R=ea(-u);else R=u;s=R<ea(.5);u=ea(R*ea(9.99999997e-07));v=s?ea(4.99999999e-07):u;s=v<ea(.000079999998);if(!(Q<(s?ea(.000079999998):v)))F=43}else F=43;if((F|0)==43){s=z;c[s>>2]=1056964608;c[s+4>>2]=1056964608;hzc(r)}s=(Qje(b)|0)==0;if(s){z=ECc()|0;v=ea(mo[c[(c[z>>2]|0)+80>>2]&4095](z)|0);z=ECc()|0;u=ea(mo[c[(c[z>>2]|0)+84>>2]&4095](z)|0);t=ea(g[b+228>>2]);S=v;T=t;U=u;V=t}else{z=b+36|0;c[m>>2]=c[z>>2];H=c[137784]|0;if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(h,H,m);G=c[h>>2]|0;W=c[H+28>>2]|0;if((G|0)==-1){Y=W+(c[H+32>>2]<<3)|0;break}else{Y=W+(G<<3)|0;break}}else Y=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);H=c[137784]|0;if((Y|0)!=((c[H+28>>2]|0)+(c[H+32>>2]<<3)|0)?(H=c[Y+4>>2]|0,(H|0)!=0):0)Z=H;else F=54}else F=54;if((F|0)==54)Z=hQb(c[z>>2]|0)|0;u$b(n,Z,1);t=ea(g[n+8>>2]);u=ea(g[n+12>>2]);c[l>>2]=c[z>>2];H=c[137784]|0;do if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(h,H,l);G=c[h>>2]|0;W=c[H+28>>2]|0;if((G|0)==-1){_=W+(c[H+32>>2]<<3)|0;break}else{_=W+(G<<3)|0;break}}else _=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);G=c[137784]|0;if((_|0)==((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)){F=63;break}G=c[_+4>>2]|0;if(G)$=G;else F=63}else F=63;while(0);if((F|0)==63)$=hQb(c[z>>2]|0)|0;if(!(a[$+616>>0]|0)){aa=+ea(g[b+240>>2])*2.0;c[j>>2]=c[z>>2];H=c[137784]|0;do if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(h,H,j);G=c[h>>2]|0;W=c[H+28>>2]|0;if((G|0)==-1){ba=W+(c[H+32>>2]<<3)|0;break}else{ba=W+(G<<3)|0;break}}else ba=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);G=c[137784]|0;if((ba|0)==((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)){F=83;break}G=c[ba+4>>2]|0;if(G)ca=G;else F=83}else F=83;while(0);if((F|0)==83)ca=hQb(c[z>>2]|0)|0;da=ea(aa*+ea(+X(+ea(ea(ea(ea(ea(g[ca+452>>2])*ea(.5))/ea(360.0))*ea(2.0))*ea(3.14159274)))))}else{c[k>>2]=c[z>>2];H=c[137784]|0;do if(H){do if((c[H+36>>2]|0)!=(c[H+4>>2]|0)){fRb(h,H,k);G=c[h>>2]|0;W=c[H+28>>2]|0;if((G|0)==-1){fa=W+(c[H+32>>2]<<3)|0;break}else{fa=W+(G<<3)|0;break}}else fa=(c[H+28>>2]|0)+(c[H+32>>2]<<3)|0;while(0);G=c[137784]|0;if((fa|0)==((c[G+28>>2]|0)+(c[G+32>>2]<<3)|0)){F=73;break}G=c[fa+4>>2]|0;if(G)ga=G;else F=73}else F=73;while(0);if((F|0)==73)ga=hQb(c[z>>2]|0)|0;da=ea(ea(g[ga+448>>2])*ea(2.0))}v=ea(da/u);A=ea(g[b+228>>2]);S=t;T=A;U=u;V=ea(v*A)}A=ea(S/T);v=ea(A);ha=ea(U/T);H=r+200|0;ia=ea(g[H>>2]);if(!(!(ia!=A)?!(ea(g[H+4>>2])!=ha):0))F=88;do if((F|0)==88){ja=ea(A-ia);if(ja<ea(0.0))ka=ea(-ja);else ka=ja;if(ia<ea(0.0))la=ea(-ia);else la=ia;if(A<ea(0.0))ma=ea(-A);else ma=A;ja=ea((la<ma?ma:la)*ea(9.99999997e-07));G=ja<ea(.000079999998);if(ka<(G?ea(.000079999998):ja)){ja=ea(g[r+204>>2]);na=ea(ha-ja);if(na<ea(0.0))oa=ea(-na);else oa=na;if(ja<ea(0.0))pa=ea(-ja);else pa=ja;if(ha<ea(0.0))qa=ea(-ha);else qa=ha;ja=ea((pa<qa?qa:pa)*ea(9.99999997e-07));G=ja<ea(.000079999998);if(oa<(G?ea(.000079999998):ja))break}ja=ea(ha);G=H;g[G>>2]=v;g[G+4>>2]=ja;hzc(r)}while(0);c[o>>2]=0;H=r+56|0;v=ea(g[H>>2]);z=r+60|0;ha=ea(g[z>>2]);G=r+64|0;if(v!=V|ha!=V|ea(g[G>>2])!=V){g[H>>2]=V;g[z>>2]=V;g[G>>2]=V;G=r+135|0;a[G>>0]=d[G>>0]|8;gGc(r);c[o>>2]=8;ra=8}else ra=0;a:do if(!s)if(e){Rje(b,o);sa=c[o>>2]|0;F=128}else{sa=ra;F=128}else{ha=ea(S*ea(.5));v=ea(U*ea(.5));A=ea(ha);G=r+192|0;ia=ea(g[G>>2]);u=ea(ha-ia);if(u<ea(0.0))ta=ea(-u);else ta=u;if(ia<ea(0.0))ua=ea(-ia);else ua=ia;if(ha<ea(0.0))va=ea(-ha);else va=ha;ha=ea((ua<va?va:ua)*ea(9.99999997e-07));z=ha<ea(.000079999998);if(ta<(z?ea(.000079999998):ha)){ha=ea(g[r+196>>2]);ia=ea(v-ha);if(ia<ea(0.0))wa=ea(-ia);else wa=ia;if(ha<ea(0.0))xa=ea(-ha);else xa=ha;if(v<ea(0.0))ya=ea(-v);else ya=v;ha=ea((xa<ya?ya:xa)*ea(9.99999997e-07));z=ha<ea(.000079999998);if(!(wa<(z?ea(.000079999998):ha)))F=120}else F=120;if((F|0)==120){ha=ea(v);z=G;g[z>>2]=A;g[z+4>>2]=ha;hzc(r)}oGc(p,r);do if(!(ea(g[p>>2])!=ea(0.0))){if(ea(g[p+4>>2])!=ea(0.0))break;if(ea(g[p+8>>2])!=ea(0.0))break;if(!(ea(g[p+12>>2])!=ea(1.0))){sa=ra;F=128;break a}}while(0);g[q>>2]=ea(0.0);g[q+4>>2]=ea(0.0);g[q+8>>2]=ea(0.0);g[q+12>>2]=ea(1.0);DGc(r,q);z=ra|2;c[o>>2]=z;za=z}while(0);if((F|0)==128)if(!sa)break;else za=sa;hGc(r,za)}else F=130;while(0);(F|0)==130?(pzc(r)|0)==(b|0):0;r=c[b+280>>2]|0;F=b+284|0;if((r|0)==(c[F>>2]|0)){i=f;return}else Aa=r;do{Mje(c[Aa>>2]|0,1);Aa=Aa+4|0}while((Aa|0)!=(c[F>>2]|0));i=f;return}function Nje(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+80|0;e=d+16|0;f=d;Lke(Vke()|0,b);c[f+8>>2]=0;c[f+4>>2]=0;c[f>>2]=0;KGc(BTb(c[b+24>>2]|0)|0,556952,f);Mje(b,1);f=b;while(1){g=c[f+220>>2]|0;if(!g){h=f;break}else f=g}RGc(e,BTb(c[h+24>>2]|0)|0);h=b+108|0;f=e+0|0;e=h+64|0;do{c[h>>2]=c[f>>2];h=h+4|0;f=f+4|0}while((h|0)<(e|0));f=c[b+220>>2]|0;if(!f){a[b+204>>0]=1;a[b+205>>0]=1;i=d;return}else{a[f+204>>0]=1;a[b+204>>0]=1;a[b+205>>0]=1;a[f+205>>0]=1;a[f+204>>0]=1;i=d;return}}function Oje(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=b+220|0;g=c[f>>2]|0;a:do if((g|0)!=0?(a[b+250>>0]|0)==0:0){h=c[g+280>>2]|0;j=g+284|0;k=c[j>>2]|0;if((h|0)!=(k|0)){l=h;while(1){if((c[l>>2]|0)==(b|0)){m=l;break}l=l+4|0;if((l|0)==(k|0))break a}l=m-h>>2;n=h+(l+1<<2)|0;o=k-n|0;aFi(h+(l<<2)|0,n|0,o|0)|0;n=h+((o>>2)+l<<2)|0;l=c[j>>2]|0;if((l|0)!=(n|0))c[j>>2]=l+(~((l+-4-n|0)>>>2)<<2);a[g+205>>0]=1}}else p=3;while(0);if((p|0)==3)Mke(Vke()|0,b);c[e+8>>2]=0;c[e+4>>2]=0;c[e>>2]=0;KGc(BTb(c[b+24>>2]|0)|0,556952,e);c[f>>2]=0;rje(b+208|0);gle(b+108|0);i=d;return}function Pje(b){b=b|0;var d=0,e=0,f=0,g=0,h=Im,j=0,k=0;d=i;i=i+64|0;e=d;if(!(a[b+40>>0]|0)){f=b+44|0;i=d;return f|0}g=ECc()|0;h=ea(mo[c[(c[g>>2]|0)+80>>2]&4095](g)|0);g=ECc()|0;j=b+44|0;oMc(j,ea(0.0),h,ea(0.0),ea(mo[c[(c[g>>2]|0)+84>>2]&4095](g)|0),ea(-1.0e3),ea(1.0e3))|0;g=b;while(1){b=c[g+220>>2]|0;if(!b){k=g;break}else g=b}SGc(e,BTb(c[k+24>>2]|0)|0);cMc(j,e)|0;f=j;i=d;return f|0}function Qje(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+8|0;e=b;f=c[a+220>>2]|0;if(f){g=Qje(f)|0;i=b;return g|0}f=a+32|0;h=c[f>>2]|0;if((h|0)!=1){g=h;i=b;return g|0}h=a+36|0;a=c[h>>2]|0;if(!a){g=0;i=b;return g|0}c[e>>2]=a;a=c[137784]|0;if(a){do if((c[a+36>>2]|0)!=(c[a+4>>2]|0)){fRb(d,a,e);j=c[d>>2]|0;k=c[a+28>>2]|0;if((j|0)==-1){l=k+(c[a+32>>2]<<3)|0;break}else{l=k+(j<<3)|0;break}}else l=(c[a+28>>2]|0)+(c[a+32>>2]<<3)|0;while(0);a=c[137784]|0;if(!((l|0)!=((c[a+28>>2]|0)+(c[a+32>>2]<<3)|0)?(c[l+4>>2]|0)!=0:0))m=13}else m=13;if((m|0)==13?(hQb(c[h>>2]|0)|0)==0:0){g=0;i=b;return g|0}g=c[f>>2]|0;i=b;return g|0}function Rje(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im;d=i;i=i+80|0;e=d+24|0;f=d+48|0;h=d+52|0;j=d+64|0;k=d+12|0;l=d;m=d+32|0;if((Qje(a)|0)!=1){i=d;return}if(c[a+220>>2]|0){i=d;return}n=ATb(c[a+24>>2]|0,224)|0;o=a+36|0;c[f>>2]=c[o>>2];p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(e,p,f);q=c[e>>2]|0;r=c[p+28>>2]|0;if((q|0)==-1){s=r+(c[p+32>>2]<<3)|0;break}else{s=r+(q<<3)|0;break}}else s=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((s|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[s+4>>2]|0,(p|0)!=0):0)t=p;else u=11}else u=11;if((u|0)==11)t=hQb(c[o>>2]|0)|0;o=BTb(c[t+24>>2]|0)|0;t=o;while(1){t=c[t+156>>2]|0;if(!t)break;if((t|0)==(n|0)){u=24;break}}if((u|0)==24){i=d;return}rGc(h,o);oGc(j,o);v=ea(g[a+240>>2]);w=ea(g[j>>2]);x=ea(w*ea(2.0));a=j+4|0;y=ea(g[a>>2]);z=ea(y*ea(2.0));o=j+8|0;A=ea(g[o>>2]);B=ea(A*ea(2.0));C=ea(w*x);D=ea(y*z);E=ea(A*B);A=ea(w*z);F=ea(w*B);w=ea(y*B);u=j+12|0;y=ea(g[u>>2]);G=ea(x*y);x=ea(z*y);z=ea(y*B);B=ea(ea(v*ea(F+x))+ea(ea(ea(A-z)*ea(0.0))+ea(ea(ea(1.0)-ea(D+E))*ea(0.0))));y=ea(ea(v*ea(w-G))+ea(ea(ea(A+z)*ea(0.0))+ea(ea(ea(1.0)-ea(C+E))*ea(0.0))));E=ea(ea(v*ea(ea(1.0)-ea(C+D)))+ea(ea(ea(F-x)*ea(0.0))+ea(ea(w+G)*ea(0.0))));G=ea(ea(g[h>>2])+B);B=ea(ea(g[h+4>>2])+y);y=ea(ea(g[h+8>>2])+E);g[k>>2]=G;g[k+4>>2]=B;g[k+8>>2]=y;rGc(l,n);if(!((!(ea(g[l>>2])!=G)?!(ea(g[l+4>>2])!=B):0)?!(ea(g[l+8>>2])!=y):0)){CGc(n,k);c[b>>2]=c[b>>2]|1}oGc(m,n);y=ea(g[m>>2]);if(((!(y!=ea(g[j>>2]))?(y=ea(g[m+4>>2]),!(y!=ea(g[a>>2]))):0)?(y=ea(g[m+8>>2]),!(y!=ea(g[o>>2]))):0)?(y=ea(g[m+12>>2]),!(y!=ea(g[u>>2]))):0){i=d;return}DGc(n,j);c[b>>2]=c[b>>2]|2;i=d;return}function Sje(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=0;Rje(a,d);e=c[d>>2]|0;if(!e){i=b;return}hGc(ATb(c[a+24>>2]|0,224)|0,e);i=b;return}function Tje(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+16|0;e=a+8|0;f=a;g=ync()|0;h=(c[b>>2]|0)+(d<<2)|0;j=c[h>>2]|0;if(!j){i=a;return}c[f>>2]=j;j=c[137784]|0;if(j){do if((c[j+36>>2]|0)!=(c[j+4>>2]|0)){fRb(e,j,f);k=c[e>>2]|0;l=c[j+28>>2]|0;if((k|0)==-1){m=l+(c[j+32>>2]<<3)|0;break}else{m=l+(k<<3)|0;break}}else m=(c[j+28>>2]|0)+(c[j+32>>2]<<3)|0;while(0);j=c[137784]|0;if((m|0)!=((c[j+28>>2]|0)+(c[j+32>>2]<<3)|0)?(j=c[m+4>>2]|0,(j|0)!=0):0)n=j;else o=10}else o=10;if((o|0)==10){o=hQb(c[h>>2]|0)|0;if(!o){i=a;return}else n=o}o=c[(hkd(n)|0)+52>>2]|0;h=c[(c[o>>2]|0)+(c[o+32>>2]<<2)>>2]|0;if((kkd(n)|0)<=0){i=a;return}o=b+16|0;j=b+32|0;b=0;do{if((c[(c[(c[h>>2]|0)+(b<<2)>>2]|0)+584>>2]|0)==0?(m=dkd(n,b,c[158074]|0,0,1)|0,(m|0)!=0):0){e=c[(c[o>>2]|0)+(d<<2)>>2]|0;if(e)In[c[(c[g>>2]|0)+220>>2]&4095](g,e);Xuc(m,c[j>>2]|0,d,0,0)}b=b+1|0}while((b|0)<(kkd(n)|0));i=a;return}function Uje(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;if(!(Vje(b)|0)?(c[b+284>>2]|0)==(c[b+280>>2]|0):0){i=d;return}e=ync()|0;f=c[(c[e>>2]|0)+72>>2]|0;g=(KLc()|0)==1;In[f&4095](e,g);g=c[b+208>>2]|0;e=b+212|0;f=(g|0)==(e|0);if(f)h=1;else{j=g;k=0;while(1){l=(c[j+28>>2]|0)+k|0;m=c[j+4>>2]|0;if(!m){n=j;while(1){o=c[n+8>>2]|0;if((c[o>>2]|0)==(n|0)){p=o;break}else n=o}}else{n=m;while(1){o=c[n>>2]|0;if(!o){p=n;break}else n=o}}if((p|0)==(e|0)){q=l;break}else{j=p;k=l}}h=(q|0)==0}q=b+284|0;k=c[b+280>>2]|0;if((c[q>>2]|0)!=(k|0)&h){h=k;do{Uje(c[h>>2]|0);h=h+4|0}while((h|0)!=(c[q>>2]|0));h=ync()|0;In[c[(c[h>>2]|0)+72>>2]&4095](h,0);i=d;return}if(!f){f=g;g=k;while(1){k=f+28|0;if((c[k>>2]|0)>0){h=f+56|0;p=f+20|0;j=g;n=0;while(1){if((a[(c[h>>2]|0)+n>>0]|0)!=0?(j|0)!=(c[q>>2]|0):0){Uje(c[j>>2]|0);r=j+4|0}else{m=ync()|0;o=c[(c[m>>2]|0)+108>>2]|0;s=Pje(b)|0;In[o&4095](m,s);In[c[(c[m>>2]|0)+100>>2]&4095](m,601008);In[c[(c[m>>2]|0)+104>>2]&4095](m,601008);Tje(0,p,n);r=j}n=n+1|0;if((n|0)>=(c[k>>2]|0)){t=r;break}else j=r}}else t=g;j=c[f+4>>2]|0;if(!j){k=f;while(1){n=c[k+8>>2]|0;if((c[n>>2]|0)==(k|0)){u=n;break}else k=n}}else{k=j;while(1){n=c[k>>2]|0;if(!n){u=k;break}else k=n}}if((u|0)==(e|0))break;else{f=u;g=t}}}t=ync()|0;In[c[(c[t>>2]|0)+72>>2]&4095](t,0);i=d;return}function Vje(b){b=b|0;var d=0,e=Im,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=ea(Zje(b));ake(b);Ske(Vke()|0,b);f=b+204|0;if(a[f>>0]|0){if(e>ea(0.0))g=c[b+196>>2]|0;else g=0;tje(c[b+188>>2]|0,g,e,b+208|0);a[f>>0]=0;f=b;do{a[f+276>>0]=1;f=c[f+220>>2]|0}while((f|0)!=0)}f=c[b+208>>2]|0;g=b+212|0;if((f|0)==(g|0)){h=0;i=d;return h|0}else{j=f;k=0}while(1){f=(c[j+28>>2]|0)+k|0;b=c[j+4>>2]|0;if(!b){l=j;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){n=m;break}else l=m}}else{l=b;while(1){m=c[l>>2]|0;if(!m){n=l;break}else l=m}}if((n|0)==(g|0)){o=f;break}else{j=n;k=f}}h=(o|0)>0;i=d;return h|0}function Wje(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+48|0;m=l+36|0;n=l+32|0;o=l+8|0;p=l;q=c[e+32>>2]|0;r=d;while(1){s=c[r+220>>2]|0;if(!s){t=r;break}else r=s}Jje(o,t);c[p>>2]=c[(c[e>>2]|0)+(g<<2)>>2];t=h4b(f,q,k,o,p,h,0,0,g,j)|0;j=c[(c[e+16>>2]|0)+(g<<2)>>2]|0;if(!j)u=d;else{g=t+204|0;if((g|0)!=(j|0)){e=c[j>>2]|0;h=c[j+8>>2]<<4;p=h>>4;o=t+212|0;c[o>>2]=p;k=t+216|0;q=c[k>>2]|0;do if((q&2147483647)>>>0<p>>>0)if((q|0)>-1){c[k>>2]=p;f=c[g>>2]|0;c[n>>2]=c[t+208>>2];c[m+0>>2]=c[n+0>>2];r=hOb(f,h,4,m,0,3653512,370)|0;c[g>>2]=r;v=r;break}else{c[n>>2]=c[t+208>>2];c[m+0>>2]=c[n+0>>2];r=cOb(h,4,m,0,3653512,352)|0;YEi(r|0,c[g>>2]|0,c[o>>2]<<4|0)|0;c[k>>2]=p;c[g>>2]=r;v=r;break}else v=c[g>>2]|0;while(0);YEi(v|0,e|0,c[o>>2]<<4|0)|0;o=t+220|0;e=c[j+16>>2]|0;v=c[j+24>>2]<<2;p=v>>2;k=t+228|0;c[k>>2]=p;h=t+232|0;q=c[h>>2]|0;do if((q&2147483647)>>>0<p>>>0)if((q|0)>-1){c[h>>2]=p;r=c[o>>2]|0;c[n>>2]=c[t+224>>2];c[m+0>>2]=c[n+0>>2];f=hOb(r,v,4,m,0,3653512,370)|0;c[o>>2]=f;w=f;break}else{c[n>>2]=c[t+224>>2];c[m+0>>2]=c[n+0>>2];f=cOb(v,4,m,0,3653512,352)|0;YEi(f|0,c[o>>2]|0,c[k>>2]<<2|0)|0;c[h>>2]=p;c[o>>2]=f;w=f;break}else w=c[o>>2]|0;while(0);YEi(w|0,e|0,c[k>>2]<<2|0)|0}c[t+236>>2]=c[j+32>>2];xld(g);c[t+168>>2]=g;u=d}while(1){if(a[u+250>>0]|0){x=u;y=19;break}d=c[u+220>>2]|0;if(!d){x=u;y=19;break}else u=d}if((y|0)==19){y=ZWb()|0;u=PWb(y,c[x+244>>2]|0)|0;c[t+172>>2]=(b[x+248>>1]|0)+32768|u<<16^-2147483648;i=l;return}}function Xje(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+128|0;j=h+64|0;k=h;if(g)Mje(d,1);if(!(Vje(d)|0)?(c[d+284>>2]|0)==(c[d+280>>2]|0):0){i=h;return}l=d+208|0;m=c[l>>2]|0;n=d+212|0;if((m|0)==(n|0))o=1;else{p=m;m=0;while(1){q=(c[p+28>>2]|0)+m|0;r=c[p+4>>2]|0;if(!r){s=p;while(1){t=c[s+8>>2]|0;if((c[t>>2]|0)==(s|0)){u=t;break}else s=t}}else{s=r;while(1){t=c[s>>2]|0;if(!t){u=s;break}else s=t}}if((u|0)==(n|0)){v=q;break}else{p=u;m=q}}o=(v|0)==0}v=d+284|0;m=d+280|0;u=c[m>>2]|0;if((c[v>>2]|0)!=(u|0)&o){o=u;do{Xje(c[o>>2]|0,e,f,g);o=o+4|0}while((o|0)!=(c[v>>2]|0));i=h;return}o=c[(c[d+24>>2]|0)+40>>2]|0;u=d;while(1){p=c[u+220>>2]|0;if(!p){w=u;break}else u=p}SGc(k,BTb(c[w+24>>2]|0)|0);w=c[l>>2]|0;if((w|0)==(n|0)){i=h;return}l=w;w=c[m>>2]|0;while(1){m=l+28|0;if((c[m>>2]|0)>0){u=l+56|0;p=l+20|0;s=w;r=0;while(1){if((a[(c[u>>2]|0)+r>>0]|0)!=0?(s|0)!=(c[v>>2]|0):0){Xje(c[s>>2]|0,e,f,g);x=s+4|0}else{t=(b[f>>1]|0)+1<<16>>16;b[f>>1]=t;y=j+0|0;z=k+0|0;A=y+64|0;do{c[y>>2]=c[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));Wje(d,p,j,r,o,e,t);x=s}r=r+1|0;if((r|0)>=(c[m>>2]|0)){B=x;break}else s=x}}else B=w;s=c[l+4>>2]|0;if(!s){m=l;while(1){r=c[m+8>>2]|0;if((c[r>>2]|0)==(m|0)){C=r;break}else m=r}}else{m=s;while(1){r=c[m>>2]|0;if(!r){C=m;break}else m=r}}if((C|0)==(n|0))break;else{l=C;w=B}}i=h;return}function Yje(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=Im,j=Im,k=0,l=0,m=Im,n=Im,o=Im;f=i;a:do if((b|0)==(d|0))h=ea(1.0);else{j=ea(1.0);k=b;while(1){l=ATb(c[k+24>>2]|0,225)|0;if((l|0)!=0?(a[l+28>>0]|0)!=0:0){m=ea(j*ea(g[l+32>>2]));if(!(a[l+38>>0]|0))n=m;else{o=m;break}}else n=j;k=c[k+156>>2]|0;if((k|0)==(d|0)){h=n;break a}else j=n}i=f;return ea(o)}while(0);o=ea(h*e);i=f;return ea(o)}function Zje(b){b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=Im,l=Im,m=Im,n=Im,o=Im;d=i;e=b+220|0;f=c[e>>2]|0;if(f){h=ea(Zje(f));f=c[e>>2]|0;if(!f){j=0;k=h}else{j=BTb(c[f+24>>2]|0)|0;k=h}}else{j=0;k=ea(1.0)}f=BTb(c[b+24>>2]|0)|0;a:do if((f|0)==(j|0))l=ea(1.0);else{h=ea(1.0);b=f;while(1){e=ATb(c[b+24>>2]|0,225)|0;if((e|0)!=0?(a[e+28>>0]|0)!=0:0){m=ea(h*ea(g[e+32>>2]));if(!(a[e+38>>0]|0))n=m;else{o=m;break}}else n=h;b=c[b+156>>2]|0;if((b|0)==(j|0)){l=n;break a}else h=n}i=d;return ea(o)}while(0);o=ea(k*l);i=d;return ea(o)}function _je(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im;e=i;f=a+8|0;a=(Qje(c[f>>2]|0)|0)==0;h=c[f>>2]|0;if(a){a=b[h+248>>1]|0;f=c[d+8>>2]|0;j=b[f+248>>1]|0;if(a<<16>>16==j<<16>>16)k=f;else{l=a<<16>>16<j<<16>>16;i=e;return l|0}}else{j=b[h+278>>1]|0;a=c[d+8>>2]|0;d=b[a+278>>1]|0;if(j<<16>>16!=d<<16>>16){l=j<<16>>16<d<<16>>16;i=e;return l|0}d=b[h+248>>1]|0;j=b[a+248>>1]|0;if(d<<16>>16==j<<16>>16)k=a;else{l=d<<16>>16<j<<16>>16;i=e;return l|0}}m=ea(g[h+224>>2]);if(m==ea(-1.0)){l=0;i=e;return l|0}n=ea(g[k+224>>2]);if(n==ea(-1.0)){l=1;i=e;return l|0}l=m<n;i=e;return l|0}function $je(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=Im,w=Im,x=Im;e=i;i=i+112|0;f=e+48|0;h=e+24|0;j=e;k=ATb(c[b+24>>2]|0,224)|0;NGc(k,f)|0;l=d+12|0;eMc(b+108|0,f,l);f=jzc(k)|0;m=ea(g[f>>2]);n=ea(g[f+4>>2]);o=ea(g[f+8>>2]);p=ea(g[f+12>>2]);q=ea(g[150280]);r=ea(g[150281]);s=ea(g[150282]);t=ea(-q);u=ea(-r);v=ea(-s);w=m<q?m:q;q=n<r?n:r;f=s>ea(0.0);r=f?ea(0.0):s;x=m>t?m:t;t=n>u?n:u;f=s>ea(-0.0);s=f?ea(0.0):v;v=ea(m+o);o=v<w?v:w;w=x<v?v:x;x=ea(n+p);p=m<o?m:o;o=x<q?x:q;q=w<m?m:w;w=t<x?x:t;t=v<p?v:p;p=q<v?v:q;g[d+76>>2]=t;g[d+80>>2]=o;g[d+84>>2]=r;g[d+88>>2]=p;g[d+92>>2]=w;g[d+96>>2]=s;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;q=ea(ea(w+o)*ea(.5));v=ea(ea(s+r)*ea(.5));g[j>>2]=ea(ea(p+t)*ea(.5));g[j+4>>2]=q;g[j+8>>2]=v;v=ea(ea(w-o)*ea(.5));o=ea(ea(s-r)*ea(.5));g[j+12>>2]=ea(ea(p-t)*ea(.5));g[j+16>>2]=v;g[j+20>>2]=o;Xlc(j,l,h);o=ea(g[h>>2]);v=ea(g[h+12>>2]);t=ea(o-v);p=ea(g[h+4>>2]);r=ea(g[h+16>>2]);s=ea(p-r);w=ea(ea(o+v)-t);v=ea(ea(p+r)-s);g[d+100>>2]=t;g[d+108>>2]=w;g[d+104>>2]=s;g[d+112>>2]=v;a[d+148>>0]=1;c[d+140>>2]=0;i=e;return}function ake(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;h=d+20|0;j=d+16|0;k=d;l=b+205|0;if(!(a[l>>0]|0)){i=d;return}m=c[153134]|0;c[k>>2]=0;n=k+4|0;c[n>>2]=m;m=k+8|0;c[m>>2]=0;o=k+12|0;c[o>>2]=0;oQc(c[b+24>>2]|0,222,k);fle(b+108|0);p=b+280|0;q=c[p>>2]|0;r=b+284|0;s=c[r>>2]|0;if((q|0)!=(s|0)){t=q;do{g[(c[t>>2]|0)+224>>2]=ea(-1.0);t=t+4|0}while((t|0)!=(s|0))}s=c[153134]|0;if((c[m>>2]|0)>0){t=b+196|0;q=b+200|0;u=b+188|0;v=b+192|0;w=0;x=0;y=0;z=0;A=0;while(1){a:do if(!w)B=0;else{C=w;while(1){D=C;C=C+-1|0;E=c[x+(C<<2)>>2]|0;F=c[(c[k>>2]|0)+(z<<2)>>2]|0;if((E|0)==(F|0)){B=D;break a}G=BTb(c[E+24>>2]|0)|0;if((F|0)!=0?(H=c[(BTb(c[F+24>>2]|0)|0)+156>>2]|0,(H|0)!=0):0){F=H;do{if((G|0)==(F|0)){B=D;break a}F=c[F+156>>2]|0}while((F|0)!=0)}Hje(E,b,2)|0;if(!C){B=0;break}}}while(0);C=c[(c[k>>2]|0)+(z<<2)>>2]|0;if(!(a[C+70>>0]|0)){I=y;J=B;K=x;L=0;M=C}else{F=B+1|0;D=y&2147483647;do if(F>>>0>D>>>0?(G=y<<1,H=(G|0)==0?1:G,D>>>0<H>>>0):0)if((y|0)>-1){c[f>>2]=s;c[e+0>>2]=c[f+0>>2];N=H;O=hOb(x,H<<2,4,e,0,3653512,370)|0;break}else{c[f>>2]=s;c[e+0>>2]=c[f+0>>2];G=cOb(H<<2,4,e,0,3653512,352)|0;YEi(G|0,x|0,F<<2|0)|0;N=H;O=G;break}else{N=y;O=x}while(0);c[O+(B<<2)>>2]=C;D=c[(c[k>>2]|0)+(z<<2)>>2]|0;I=N;J=F;K=O;L=a[D+70>>0]|0;M=D}D=Hje(M,b,L&255)|0;if((D|0)!=(b|0)){G=D;while(1){D=c[G+220>>2]|0;if((D|0)==0|(D|0)==(b|0)){P=G;break}else G=D}G=P+224|0;if(ea(g[G>>2])==ea(-1.0)){F=(c[t>>2]|0)+1|0;c[t>>2]=F;C=c[q>>2]|0;D=C&2147483647;if(F>>>0>D>>>0){H=C<<1;Q=(H|0)==0?1:H;do if(D>>>0<Q>>>0)if((C|0)>-1){c[q>>2]=Q;H=c[u>>2]|0;c[f>>2]=c[v>>2];c[e+0>>2]=c[f+0>>2];c[u>>2]=hOb(H,Q*152|0,4,e,0,3653512,370)|0;break}else{c[f>>2]=c[v>>2];c[e+0>>2]=c[f+0>>2];H=cOb(Q*152|0,4,e,0,3653512,352)|0;YEi(H|0,c[u>>2]|0,(c[t>>2]|0)*152|0)|0;c[q>>2]=Q;c[u>>2]=H;break}while(0);R=c[t>>2]|0}else R=F;$je(P,(c[u>>2]|0)+((R+-1|0)*152|0)|0);g[G>>2]=ea(A|0);S=A+1|0}else S=A}else S=A;z=z+1|0;if((z|0)>=(c[m>>2]|0)){T=I;U=J;V=K;break}else{w=J;x=K;y=I;A=S}}}else{T=0;U=0;V=0}S=U;while(1){if(!S)break;U=S+-1|0;Hje(c[V+(U<<2)>>2]|0,b,2)|0;S=U}S=c[p>>2]|0;p=c[r>>2]|0;if((S|0)!=(p|0)){c[f>>2]=2842;qke(S,p,f)}bke(b);a[l>>0]=0;a[b+204>>0]=1;if((T|0)>-1){c[h>>2]=s;c[e+0>>2]=c[h+0>>2];eOb(V,e)}if((c[o>>2]|0)<=-1){i=d;return}o=c[k>>2]|0;c[j>>2]=c[n>>2];c[e+0>>2]=c[j+0>>2];eOb(o,e);c[k>>2]=0;i=d;return}function bke(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[b+220>>2]|0;if((f|0)!=0?(a[b+250>>0]|0)==0:0){bke(f);i=d;return}c[e>>2]=0;cke(b,e);i=d;return}function cke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=a+172|0;f=a+180|0;g=c[f>>2]|0;a:do if(!g){h=a+280|0;j=a+284|0;k=0}else{l=c[e>>2]|0;m=a+284|0;n=a+280|0;o=l;p=g;q=l;l=-1;r=0;while(1){s=p;t=q;u=l;while(1){v=c[t>>2]|0;u=u+1|0;if(!v)w=s;else{if((u|0)<(c[v+4>>2]|0)?(x=c[n>>2]|0,r>>>0<(c[m>>2]|0)-x>>2>>>0):0){y=u;z=x;A=t;break}c[v+12>>2]=c[b>>2];c[b>>2]=(c[b>>2]|0)+1;w=c[f>>2]|0}t=t+4|0;if((t|0)==(o+(w<<2)|0)){h=n;j=m;k=r;break a}else s=w}cke(c[z+(r<<2)>>2]|0,b);s=r+1|0;t=c[e>>2]|0;u=c[f>>2]|0;if((A|0)==(t+(u<<2)|0)){h=n;j=m;k=s;break}else{o=t;p=u;q=A;l=y;r=s}}}while(0);y=c[h>>2]|0;if(k>>>0<(c[j>>2]|0)-y>>2>>>0){B=y;C=k}else{i=d;return}do{cke(c[B+(C<<2)>>2]|0,b);C=C+1|0;B=c[h>>2]|0}while(C>>>0<(c[j>>2]|0)-B>>2>>>0);i=d;return}function dke(){var a=0;a=i;QTb(223,554336,1862,1e5);QTb(223,556952,1863,0);Tke();i=a;return}function eke(){var a=0;a=i;Uke();i=a;return}function fke(b){b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;e=d;f=b+228|0;h=ea(g[f>>2]);j=h<ea(.00100000005);g[f>>2]=j?ea(.00100000005):h;j=c[b+220>>2]|0;a:do if(j){f=c[j+280>>2]|0;k=j+284|0;l=c[k>>2]|0;b:do if((f|0)!=(l|0)){m=f;while(1){if((c[m>>2]|0)==(b|0))break;m=m+4|0;if((m|0)==(l|0))break b}if(!(a[b+250>>0]|0))break a;else n=f;do{if((c[n>>2]|0)==(b|0)){o=n;p=8;break}n=n+4|0}while((n|0)!=(l|0));if((p|0)==8){m=o-f>>2;q=f+(m+1<<2)|0;r=l-q|0;aFi(f+(m<<2)|0,q|0,r|0)|0;q=f+((r>>2)+m<<2)|0;m=c[k>>2]|0;if((m|0)!=(q|0))c[k>>2]=m+(~((m+-4-q|0)>>>2)<<2);a[j+205>>0]=1}Lke(Vke()|0,b);break a}while(0);if(!(a[b+250>>0]|0)){c[e>>2]=b;if((l|0)==(c[j+288>>2]|0))pke(j+280|0,e);else{if(!l)s=0;else{c[l>>2]=b;s=c[k>>2]|0}c[k>>2]=s+4}a[j+205>>0]=1;Mke(Vke()|0,b)}}while(0);if(Qje(b)|0){i=d;return}Oke(Vke()|0);i=d;return}function gke(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(xQb(8)|0))Fkc();rri(b,2504352,6);wQb(223,8,b,292,2843,0,1);xri(b);i=a;return}function hke(a){a=a|0;return 223}function ike(a,b){a=a|0;b=b|0;var c=0;c=i;add(b,792072,2504352,a,0);uke(a,b);bdd(b);i=c;return}function jke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=qdd(b,792072,2504352,e,1)|0;if(!f){i=d;return}if((f|0)<=0){f=c[e>>2]|0;if(f)_n[f&4095](a,b)|0}else vke(a,b);sdd(b);i=d;return}function kke(a,b){a=a|0;b=b|0;var c=0;c=i;wke(a,b);i=c;return}function lke(a,b){a=a|0;b=b|0;var c=0;c=i;xke(a,b);i=c;return}function mke(a,b){a=a|0;b=b|0;var c=0;c=i;yke(a,b);i=c;return}function nke(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mkc(b,d);idd(d,2048);f=b+36|0;b=c[d+12>>2]|0;g=xo[c[c[b>>2]>>2]&2047](b,c[f>>2]|0,c[d+28>>2]|0)|0;if(!(a[d+32>>0]|0)){jdd(d);i=e;return}c[f>>2]=g;jdd(d);i=e;return}function oke(){var a=0;a=i;QQb(223,230,231,0,232);i=a;return}function pke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function qke(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;e=i;i=i+288|0;f=e+132|0;g=e+120|0;h=e+12|0;j=e+252|0;k=e;l=e+48|0;m=e+60|0;n=e+72|0;o=e+192|0;p=e+216|0;q=e+240|0;r=e+264|0;s=e+276|0;t=e+144|0;u=e+156|0;v=e+168|0;w=e+24|0;x=e+180|0;y=e+84|0;z=e+36|0;A=e+96|0;B=e+204|0;C=e+108|0;D=e+228|0;E=m+4|0;F=m+8|0;G=n+4|0;H=n+8|0;I=C+4|0;J=C+8|0;K=D+4|0;L=D+8|0;M=y+4|0;N=y+8|0;O=z+4|0;P=z+8|0;Q=A+4|0;R=A+8|0;S=B+4|0;T=B+8|0;U=w+4|0;V=w+8|0;W=x+4|0;X=x+8|0;Y=o+4|0;Z=o+8|0;_=p+4|0;$=p+8|0;aa=s+4|0;ba=s+8|0;ca=t+4|0;da=t+8|0;ea=u+4|0;fa=u+8|0;ga=v+4|0;ha=v+8|0;ia=q+4|0;ja=q+8|0;ka=r+4|0;la=r+8|0;ma=a;a=b;a:while(1){b=a;na=a+-4|0;oa=ma;b:while(1){pa=oa;qa=b-pa|0;ra=qa>>2;switch(ra|0){case 5:{sa=oa;ta=na;ua=8;break a;break}case 2:{va=oa;wa=na;ua=4;break a;break}case 3:{xa=oa;ya=na;ua=6;break a;break}case 1:case 0:{ua=54;break a;break}case 4:{za=oa;Aa=na;ua=7;break a;break}default:{}}if((qa|0)<124){Ba=oa;Ca=a;ua=10;break a}Da=(ra|0)/2|0;Ea=oa+(Da<<2)|0;if((qa|0)>3996){qa=(ra|0)/4|0;Fa=Dke(oa,oa+(qa<<2)|0,Ea,oa+(qa+Da<<2)|0,na,d)|0}else Fa=Bke(oa,Ea,na,d)|0;Da=c[d>>2]|0;qa=c[oa>>2]|0;c[m>>2]=0;c[E>>2]=0;c[F>>2]=qa;qa=c[Ea>>2]|0;c[n>>2]=0;c[G>>2]=0;c[H>>2]=qa;do if(_n[Da&4095](m,n)|0){Ga=na;Ha=Fa}else{qa=a;ra=na;while(1){Ia=qa+-8|0;if((oa|0)==(Ia|0))break;Ja=c[d>>2]|0;Ka=c[Ia>>2]|0;c[w>>2]=0;c[U>>2]=0;c[V>>2]=Ka;Ka=c[Ea>>2]|0;c[x>>2]=0;c[W>>2]=0;c[X>>2]=Ka;if(_n[Ja&4095](w,x)|0){La=Ia;ua=36;break}else{Ja=ra;ra=Ia;qa=Ja}}if((ua|0)==36){ua=0;qa=c[oa>>2]|0;c[oa>>2]=c[La>>2];c[La>>2]=qa;Ga=La;Ha=Fa+1|0;break}qa=oa+4|0;ra=c[d>>2]|0;Ja=c[oa>>2]|0;c[o>>2]=0;c[Y>>2]=0;c[Z>>2]=Ja;Ja=c[na>>2]|0;c[p>>2]=0;c[_>>2]=0;c[$>>2]=Ja;if(_n[ra&4095](o,p)|0)Ma=qa;else{if((qa|0)==(na|0)){ua=54;break a}else{Na=oa;Oa=qa}while(1){qa=c[d>>2]|0;ra=c[oa>>2]|0;c[q>>2]=0;c[ia>>2]=0;c[ja>>2]=ra;ra=c[Oa>>2]|0;c[r>>2]=0;c[ka>>2]=0;c[la>>2]=ra;ra=Na+8|0;if(_n[qa&4095](q,r)|0){Pa=Oa;break}if((ra|0)==(na|0)){ua=54;break a}else{qa=Oa;Oa=ra;Na=qa}}qa=c[Pa>>2]|0;c[Pa>>2]=c[na>>2];c[na>>2]=qa;Ma=Pa+4|0}if((Ma|0)==(na|0)){ua=54;break a}else{Qa=Ma;Ra=na}while(1){qa=Qa;while(1){ra=c[d>>2]|0;Ja=c[oa>>2]|0;c[s>>2]=0;c[aa>>2]=0;c[ba>>2]=Ja;Ja=c[qa>>2]|0;c[t>>2]=0;c[ca>>2]=0;c[da>>2]=Ja;Ja=qa+4|0;if(_n[ra&4095](s,t)|0){Sa=Ja;Ta=qa;break}else qa=Ja}qa=Ra;while(1){Ja=c[d>>2]|0;ra=c[oa>>2]|0;c[u>>2]=0;c[ea>>2]=0;c[fa>>2]=ra;ra=qa+-4|0;Ia=c[ra>>2]|0;c[v>>2]=0;c[ga>>2]=0;c[ha>>2]=Ia;if(_n[Ja&4095](u,v)|0)qa=ra;else{Ua=ra;break}}if(Ta>>>0>=Ua>>>0){oa=Ta;continue b}qa=c[Ta>>2]|0;c[Ta>>2]=c[Ua>>2];c[Ua>>2]=qa;Qa=Sa;Ra=Ua}}while(0);Da=oa+4|0;c:do if(Da>>>0<Ga>>>0){qa=Da;ra=Ga;Ja=Ea;Ia=Ha;while(1){Ka=qa;while(1){Va=c[d>>2]|0;Wa=c[Ka>>2]|0;c[y>>2]=0;c[M>>2]=0;c[N>>2]=Wa;Wa=c[Ja>>2]|0;c[z>>2]=0;c[O>>2]=0;c[P>>2]=Wa;Wa=Ka+4|0;if(_n[Va&4095](y,z)|0)Ka=Wa;else{Xa=Wa;Ya=Ka;break}}Ka=ra;while(1){Wa=c[d>>2]|0;Va=Ka+-4|0;Za=c[Va>>2]|0;c[A>>2]=0;c[Q>>2]=0;c[R>>2]=Za;Za=c[Ja>>2]|0;c[B>>2]=0;c[S>>2]=0;c[T>>2]=Za;if(_n[Wa&4095](A,B)|0){_a=Va;break}else Ka=Va}if(Ya>>>0>_a>>>0){$a=Ya;ab=Ja;bb=Ia;break c}Ka=c[Ya>>2]|0;c[Ya>>2]=c[_a>>2];c[_a>>2]=Ka;qa=Xa;ra=_a;Ja=(Ja|0)==(Ya|0)?_a:Ja;Ia=Ia+1|0}}else{$a=Da;ab=Ea;bb=Ha}while(0);if(($a|0)!=(ab|0)?(Ea=c[d>>2]|0,Da=c[ab>>2]|0,c[C>>2]=0,c[I>>2]=0,c[J>>2]=Da,Da=c[$a>>2]|0,c[D>>2]=0,c[K>>2]=0,c[L>>2]=Da,_n[Ea&4095](C,D)|0):0){Ea=c[$a>>2]|0;c[$a>>2]=c[ab>>2];c[ab>>2]=Ea;cb=bb+1|0}else cb=bb;if(!cb){db=Eke(oa,$a,d)|0;Ea=$a+4|0;if(Eke(Ea,a,d)|0){ua=49;break}if(db){oa=Ea;continue}}Ea=$a;if((Ea-pa|0)>=(b-Ea|0)){eb=oa;fb=$a;ua=53;break}qke(oa,$a,d);oa=$a+4|0}if((ua|0)==49){ua=0;if(db){ua=54;break}else{ma=oa;a=$a;continue}}else if((ua|0)==53){ua=0;qke(fb+4|0,a,d);ma=eb;a=fb;continue}}if((ua|0)==4){fb=c[d>>2]|0;a=c[wa>>2]|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=a;a=c[va>>2]|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=a;if(!(_n[fb&4095](k,l)|0)){i=e;return}l=c[va>>2]|0;c[va>>2]=c[wa>>2];c[wa>>2]=l;i=e;return}else if((ua|0)==6){Bke(xa,xa+4|0,ya,d)|0;i=e;return}else if((ua|0)==7){Cke(za,za+4|0,za+8|0,Aa,d)|0;i=e;return}else if((ua|0)==8){Dke(sa,sa+4|0,sa+8|0,sa+12|0,ta,d)|0;i=e;return}else if((ua|0)==10){ta=Ba+8|0;Bke(Ba,Ba+4|0,ta,d)|0;sa=Ba+12|0;if((sa|0)==(Ca|0)){i=e;return}Aa=f+4|0;za=f+8|0;ya=g+4|0;xa=g+8|0;l=h+4|0;wa=h+8|0;va=j+4|0;k=j+8|0;fb=sa;sa=ta;while(1){ta=c[d>>2]|0;a=c[fb>>2]|0;c[f>>2]=0;c[Aa>>2]=0;c[za>>2]=a;a=c[sa>>2]|0;c[g>>2]=0;c[ya>>2]=0;c[xa>>2]=a;if(_n[ta&4095](f,g)|0){ta=c[fb>>2]|0;a=fb;eb=sa;while(1){c[a>>2]=c[eb>>2];if((eb|0)==(Ba|0)){gb=Ba;break}ma=c[d>>2]|0;c[h>>2]=0;c[l>>2]=0;c[wa>>2]=ta;$a=eb+-4|0;db=c[$a>>2]|0;c[j>>2]=0;c[va>>2]=0;c[k>>2]=db;if(_n[ma&4095](h,j)|0){ma=eb;eb=$a;a=ma}else{gb=eb;break}}c[gb>>2]=ta}eb=fb+4|0;if((eb|0)==(Ca|0))break;else{a=fb;fb=eb;sa=a}}i=e;return}else if((ua|0)==54){i=e;return}}function rke(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+64|0;f=d;g=c[e+4>>2]|0;if(!(a[b+29>>0]|0)){i=d;return}if(g&32)Kje(b);if((g&128|0)!=0?(g=c[b+220>>2]|0,(g|0)!=0):0)a[g+205>>0]=1;g=b;while(1){e=c[g+220>>2]|0;if(!e){h=g;break}else g=e}RGc(f,BTb(c[h+24>>2]|0)|0);h=b+108|0;g=f+0|0;f=h+64|0;do{c[h>>2]=c[g>>2];h=h+4|0;g=g+4|0}while((h|0)<(f|0));g=c[b+220>>2]|0;if(!g){i=d;return}a[g+204>>0]=1;i=d;return}function ske(b,c,d){b=b|0;c=c|0;d=d|0;d=i;if(!(a[b+29>>0]|0)){i=d;return}Kje(b);i=d;return}function tke(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=Im,n=Im,o=Im;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;l=c[d>>2]|0;c[k>>2]=l;c[h+0>>2]=c[k+0>>2];k=bOb(292,h,1,16,3653512,27)|0;c[j>>2]=l;c[h+0>>2]=c[j+0>>2];bUb(k,h,e);a[k+28>>0]=1;a[k+29>>0]=0;c[k>>2]=791936;c[k+32>>2]=2;c[k+36>>2]=0;a[k+40>>0]=1;c[k+172>>2]=0;c[k+180>>2]=0;c[k+184>>2]=0;c[k+176>>2]=60;c[k+188>>2]=0;c[k+196>>2]=0;c[k+200>>2]=0;c[k+192>>2]=60;e=k+212|0;c[e>>2]=0;c[k+216>>2]=0;c[k+208>>2]=e;c[k+220>>2]=0;g[k+224>>2]=ea(0.0);g[k+228>>2]=ea(1.0);g[k+232>>2]=ea(100.0);a[k+236>>0]=0;a[k+237>>0]=0;a[k+238>>0]=1;g[k+240>>2]=ea(100.0);c[k+244>>2]=0;b[k+248>>1]=0;a[k+250>>0]=0;e=k+252|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+0>>2]=c[150280];c[e+4>>2]=c[150281];c[e+8>>2]=c[150282];m=ea(-ea(g[150280]));n=ea(-ea(g[150281]));o=ea(-ea(g[150282]));g[k+264>>2]=m;g[k+268>>2]=n;g[k+272>>2]=o;a[k+276>>0]=1;e=k+278|0;b[e+0>>1]=0;b[e+2>>1]=0;b[e+4>>1]=0;b[e+6>>1]=0;b[e+8>>1]=0;b[e+10>>1]=0;b[e+12>>1]=0;i=f;return k|0}function uke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;Hkc(a,b);ddd(b,2);f=c[142270]|0;add(b,792080,f,a+32|0,0);g=b+12|0;h=b+20|0;c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);j=a+36|0;add(b,792096,792288,j,2048);k=e+8|0;l=k;c[l>>2]=0;c[l+4>>2]=0;c[e>>2]=0;add(b,792256,f,j,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792272,c[142290]|0,k,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=8;bdd(b);bdd(b);add(b,792112,c[142268]|0,a+240|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);k=c[142258]|0;add(b,792128,k,a+236|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,792144,k,a+238|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,792168,k,a+250|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);add(b,792192,k,a+237|0,0);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=1;bdd(b);fdd(b);add(b,792216,c[142304]|0,a+244|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=4;bdd(b);add(b,792240,c[142286]|0,a+248|0,1);c[(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)+12>>2]=2;bdd(b);i=d;return}function vke(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e;Ikc(b,d);rdd(d,2);h=b+32|0;j=qdd(d,792080,c[142270]|0,f,0)|0;if(j){if((j|0)>0){j=d+12|0;k=c[d+16>>2]|0;l=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=k+l|0;c[j>>2]=m;if((l|0)>=0?(n=k+(l+4)|0,n>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[m>>2];c[j>>2]=n}else Bid(j,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}sdd(d)}h=b+36|0;j=qdd(d,792096,792288,f,1)|0;if(j){if((j|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else Fke(h,d);sdd(d)}h=b+240|0;j=qdd(d,792112,c[142268]|0,f,0)|0;if(j){if((j|0)>0){j=d+12|0;n=c[d+16>>2]|0;m=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;l=n+m|0;c[j>>2]=l;if((m|0)>=0?(k=n+(m+4)|0,k>>>0<=(c[d+20>>2]|0)>>>0):0){g[h>>2]=ea(g[l>>2]);c[j>>2]=k}else Bid(j,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}sdd(d)}h=b+236|0;j=c[142258]|0;k=qdd(d,792128,j,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[l>>2]=o;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+238|0;k=qdd(d,792144,j,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;o=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;m=o+n|0;c[l>>2]=m;if((n|0)>=0?(o+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[m>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+250|0;k=qdd(d,792168,j,f,0)|0;if(k){do if((k|0)<=0){l=c[f>>2]|0;if(l)_n[l&4095](h,d)|0}else{l=d+12|0;m=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=m+n|0;c[l>>2]=o;if((n|0)>=0?(m+(n+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[o>>0]|0;c[l>>2]=(c[l>>2]|0)+1;break}Bid(l,h,1)}while(0);sdd(d)}h=b+237|0;k=qdd(d,792192,j,f,0)|0;if(k){do if((k|0)<=0){j=c[f>>2]|0;if(j)_n[j&4095](h,d)|0}else{j=d+12|0;l=c[d+16>>2]|0;o=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;n=l+o|0;c[j>>2]=n;if((o|0)>=0?(l+(o+1)|0)>>>0<=(c[d+20>>2]|0)>>>0:0){a[h>>0]=a[n>>0]|0;c[j>>2]=(c[j>>2]|0)+1;break}Bid(j,h,1)}while(0);sdd(d)}h=b+244|0;k=qdd(d,792216,c[142304]|0,f,0)|0;if(!k){p=b+248|0;RAc(d,p,792240,1);i=e;return}if((k|0)>0){k=d+12|0;j=c[d+16>>2]|0;n=(c[(c[d+80>>2]|0)+12>>2]|0)-(da(c[d+32>>2]|0,c[d+28>>2]|0)|0)|0;o=j+n|0;c[k>>2]=o;if((n|0)>=0?(l=j+(n+4)|0,l>>>0<=(c[d+20>>2]|0)>>>0):0){c[h>>2]=c[o>>2];c[k>>2]=l}else Bid(k,h,4);if(c[d>>2]&512)c[h>>2]=XEi(c[h>>2]|0)|0}else{k=c[f>>2]|0;if(k)_n[k&4095](h,d)|0}sdd(d);p=b+248|0;RAc(d,p,792240,1);i=e;return}function wke(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;Jkc(d,e);h=d+32|0;j=e+12|0;k=c[j>>2]|0;l=k+4|0;m=e+20|0;if(l>>>0>(c[m>>2]|0)>>>0)Bid(j,h,4);else{c[h>>2]=c[k>>2];c[j>>2]=l}Gke(d+36|0,e);l=d+240|0;k=c[j>>2]|0;h=k+4|0;n=c[m>>2]|0;if(h>>>0>n>>>0){Bid(j,l,4);o=c[j>>2]|0;p=c[m>>2]|0}else{g[l>>2]=ea(g[k>>2]);c[j>>2]=h;o=h;p=n}n=d+236|0;if((o+1|0)>>>0>p>>>0){Bid(j,n,1);q=c[j>>2]|0}else{a[n>>0]=a[o>>0]|0;o=(c[j>>2]|0)+1|0;c[j>>2]=o;q=o}o=d+238|0;if((q+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(j,o,1);r=c[j>>2]|0}else{a[o>>0]=a[q>>0]|0;q=(c[j>>2]|0)+1|0;c[j>>2]=q;r=q}q=d+250|0;if((r+1|0)>>>0>(c[m>>2]|0)>>>0){Bid(j,q,1);s=c[j>>2]|0}else{a[q>>0]=a[r>>0]|0;r=(c[j>>2]|0)+1|0;c[j>>2]=r;s=r}r=d+237|0;if((s+1|0)>>>0>(c[m>>2]|0)>>>0)Bid(j,r,1);else{a[r>>0]=a[s>>0]|0;c[j>>2]=(c[j>>2]|0)+1}Ndd(e);e=d+244|0;s=c[j>>2]|0;r=s+4|0;q=c[m>>2]|0;if(r>>>0>q>>>0){Bid(j,e,4);t=c[j>>2]|0;u=c[m>>2]|0}else{c[e>>2]=c[s>>2];c[j>>2]=r;t=r;u=q}q=d+248|0;d=t+2|0;if(d>>>0>u>>>0){Bid(j,q,2);i=f;return}else{b[q>>1]=b[t>>1]|0;c[j>>2]=d;i=f;return}}function xke(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;Kkc(d,e);h=d+32|0;j=e+12|0;l=c[j>>2]|0;m=l+4|0;n=e+20|0;if(m>>>0>(c[n>>2]|0)>>>0){Bid(j,h,4);o=c[h>>2]|0}else{p=c[l>>2]|0;c[h>>2]=p;c[j>>2]=m;o=p}c[h>>2]=XEi(o|0)|0;Hke(d+36|0,e);o=d+240|0;h=c[j>>2]|0;p=h+4|0;m=c[n>>2]|0;if(p>>>0>m>>>0){Bid(j,o,4);q=o;r=c[o>>2]|0;s=c[j>>2]|0;t=c[n>>2]|0}else{u=ea(g[h>>2]);g[o>>2]=u;c[j>>2]=p;q=o;r=(g[k>>2]=u,c[k>>2]|0);s=p;t=m}c[q>>2]=XEi(r|0)|0;r=d+236|0;if((s+1|0)>>>0>t>>>0){Bid(j,r,1);v=c[j>>2]|0}else{a[r>>0]=a[s>>0]|0;s=(c[j>>2]|0)+1|0;c[j>>2]=s;v=s}s=d+238|0;if((v+1|0)>>>0>(c[n>>2]|0)>>>0){Bid(j,s,1);w=c[j>>2]|0}else{a[s>>0]=a[v>>0]|0;v=(c[j>>2]|0)+1|0;c[j>>2]=v;w=v}v=d+250|0;if((w+1|0)>>>0>(c[n>>2]|0)>>>0){Bid(j,v,1);x=c[j>>2]|0}else{a[v>>0]=a[w>>0]|0;w=(c[j>>2]|0)+1|0;c[j>>2]=w;x=w}w=d+237|0;if((x+1|0)>>>0>(c[n>>2]|0)>>>0)Bid(j,w,1);else{a[w>>0]=a[x>>0]|0;c[j>>2]=(c[j>>2]|0)+1}Mdd(e);e=d+244|0;x=c[j>>2]|0;w=x+4|0;v=c[n>>2]|0;if(w>>>0>v>>>0){Bid(j,e,4);y=c[e>>2]|0;z=c[j>>2]|0;A=c[n>>2]|0}else{n=c[x>>2]|0;c[e>>2]=n;c[j>>2]=w;y=n;z=w;A=v}c[e>>2]=XEi(y|0)|0;y=d+248|0;d=z+2|0;if(d>>>0>A>>>0){Bid(j,y,2);B=b[y>>1]|0;C=B&65535;D=C<<8;E=C>>>8;F=D|E;G=F&65535;b[y>>1]=G;i=f;return}else{A=b[z>>1]|0;b[y>>1]=A;c[j>>2]=d;B=A;C=B&65535;D=C<<8;E=C>>>8;F=D|E;G=F&65535;b[y>>1]=G;i=f;return}}function yke(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;Lkc(d,e);h=d+32|0;j=e+12|0;k=c[j>>2]|0;l=k+4|0;m=e+20|0;if(l>>>0<(c[m>>2]|0)>>>0){c[k>>2]=c[h>>2];c[j>>2]=l}else Gid(j,h,4);Ike(d+36|0,e);h=d+240|0;l=c[j>>2]|0;k=l+4|0;n=c[m>>2]|0;if(k>>>0<n>>>0){g[l>>2]=ea(g[h>>2]);c[j>>2]=k;o=k;p=n}else{Gid(j,h,4);o=c[j>>2]|0;p=c[m>>2]|0}h=d+236|0;if((o+1|0)>>>0<p>>>0){a[o>>0]=a[h>>0]|0;o=(c[j>>2]|0)+1|0;c[j>>2]=o;q=o}else{Gid(j,h,1);q=c[j>>2]|0}h=d+238|0;if((q+1|0)>>>0<(c[m>>2]|0)>>>0){a[q>>0]=a[h>>0]|0;q=(c[j>>2]|0)+1|0;c[j>>2]=q;r=q}else{Gid(j,h,1);r=c[j>>2]|0}h=d+250|0;if((r+1|0)>>>0<(c[m>>2]|0)>>>0){a[r>>0]=a[h>>0]|0;r=(c[j>>2]|0)+1|0;c[j>>2]=r;s=r}else{Gid(j,h,1);s=c[j>>2]|0}h=d+237|0;if((s+1|0)>>>0<(c[m>>2]|0)>>>0){a[s>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}else Gid(j,h,1);Tdd(e);e=d+244|0;h=c[j>>2]|0;s=h+4|0;r=c[m>>2]|0;if(s>>>0<r>>>0){c[h>>2]=c[e>>2];c[j>>2]=s;t=s;u=r}else{Gid(j,e,4);t=c[j>>2]|0;u=c[m>>2]|0}m=d+248|0;d=t+2|0;if(d>>>0<u>>>0){b[t>>1]=b[m>>1]|0;c[j>>2]=d;i=f;return}else{Gid(j,m,2);i=f;return}}function zke(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=791936;f=c[a+280>>2]|0;if(f){g=a+284|0;h=c[g>>2]|0;if((h|0)!=(f|0))c[g>>2]=h+(~((h+-4-f|0)>>>2)<<2);ACi(f)}Jke(a+208|0,c[a+212>>2]|0);if((c[a+200>>2]|0)>-1){f=a+188|0;h=c[f>>2]|0;c[e>>2]=c[a+192>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0}if((c[a+184>>2]|0)<=-1){c[a>>2]=577608;WUb(a);i=b;return}f=a+172|0;h=c[f>>2]|0;c[e>>2]=c[a+176>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[f>>2]=0;c[a>>2]=577608;WUb(a);i=b;return}function Ake(a){a=a|0;var b=0;b=i;zke(a);ACi(a);i=b;return}function Bke(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+128|0;g=f;h=f+48|0;j=f+84|0;k=f+12|0;l=f+96|0;m=f+108|0;n=f+36|0;o=f+72|0;p=f+60|0;q=f+24|0;r=c[e>>2]|0;s=c[b>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=s;s=c[a>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=s;s=_n[r&4095](g,h)|0;h=c[e>>2]|0;g=c[d>>2]|0;if(!s){c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=g;s=c[b>>2]|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=s;if(!(_n[h&4095](j,k)|0)){t=0;i=f;return t|0}k=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=k;k=c[e>>2]|0;j=c[b>>2]|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=j;j=c[a>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=j;if(!(_n[k&4095](l,m)|0)){t=1;i=f;return t|0}m=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=m;t=2;i=f;return t|0}c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=g;g=c[b>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=g;g=_n[h&4095](n,o)|0;o=c[a>>2]|0;if(g){c[a>>2]=c[d>>2];c[d>>2]=o;t=1;i=f;return t|0}c[a>>2]=c[b>>2];c[b>>2]=o;a=c[e>>2]|0;e=c[d>>2]|0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=e;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=o;if(!(_n[a&4095](p,q)|0)){t=1;i=f;return t|0}q=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=q;t=2;i=f;return t|0}function Cke(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=g+60|0;j=g+48|0;k=g+36|0;l=g+24|0;m=g+12|0;n=g;o=Bke(a,b,d,f)|0;p=c[f>>2]|0;q=c[e>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=q;q=c[d>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=q;if(!(_n[p&4095](h,j)|0)){r=o;i=g;return r|0}j=c[d>>2]|0;c[d>>2]=c[e>>2];c[e>>2]=j;j=c[f>>2]|0;e=c[d>>2]|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=e;e=c[b>>2]|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=e;if(!(_n[j&4095](k,l)|0)){r=o+1|0;i=g;return r|0}l=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=l;l=c[f>>2]|0;f=c[b>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=f;f=c[a>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=f;if(!(_n[l&4095](m,n)|0)){r=o+2|0;i=g;return r|0}n=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=n;r=o+3|0;i=g;return r|0}function Dke(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+12|0;k=h+48|0;l=h+24|0;m=h+60|0;n=h+84|0;o=h;p=h+36|0;q=h+72|0;r=Cke(a,b,d,e,g)|0;s=c[g>>2]|0;t=c[f>>2]|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=t;t=c[e>>2]|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=t;if(!(_n[s&4095](j,k)|0)){u=r;i=h;return u|0}k=c[e>>2]|0;c[e>>2]=c[f>>2];c[f>>2]=k;k=c[g>>2]|0;f=c[e>>2]|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=f;f=c[d>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=f;if(!(_n[k&4095](l,m)|0)){u=r+1|0;i=h;return u|0}m=c[d>>2]|0;c[d>>2]=c[e>>2];c[e>>2]=m;m=c[g>>2]|0;e=c[d>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=e;e=c[b>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=e;if(!(_n[m&4095](n,o)|0)){u=r+2|0;i=h;return u|0}o=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=o;o=c[g>>2]|0;g=c[b>>2]|0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=g;g=c[a>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=g;if(!(_n[o&4095](p,q)|0)){u=r+3|0;i=h;return u|0}q=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=q;u=r+4|0;i=h;return u|0}function Eke(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+80|0;f=e+60|0;g=e+48|0;h=e+36|0;j=e+24|0;k=e+12|0;l=e;switch(b-a>>2|0){case 4:{Cke(a,a+4|0,a+8|0,b+-4|0,d)|0;m=1;i=e;return m|0}case 3:{Bke(a,a+4|0,b+-4|0,d)|0;m=1;i=e;return m|0}case 5:{Dke(a,a+4|0,a+8|0,a+12|0,b+-4|0,d)|0;m=1;i=e;return m|0}case 2:{n=c[d>>2]|0;o=b+-4|0;p=c[o>>2]|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=p;p=c[a>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=p;if(!(_n[n&4095](f,g)|0)){m=1;i=e;return m|0}g=c[a>>2]|0;c[a>>2]=c[o>>2];c[o>>2]=g;m=1;i=e;return m|0}case 1:case 0:{m=1;i=e;return m|0}default:{g=a+8|0;Bke(a,a+4|0,g,d)|0;o=a+12|0;if((o|0)==(b|0)){m=1;i=e;return m|0}f=h+4|0;n=h+8|0;p=j+4|0;q=j+8|0;r=k+4|0;s=k+8|0;t=l+4|0;u=l+8|0;v=0;w=o;o=g;while(1){g=c[d>>2]|0;x=c[w>>2]|0;c[h>>2]=0;c[f>>2]=0;c[n>>2]=x;x=c[o>>2]|0;c[j>>2]=0;c[p>>2]=0;c[q>>2]=x;if(_n[g&4095](h,j)|0){g=c[w>>2]|0;x=w;y=o;while(1){c[x>>2]=c[y>>2];if((y|0)==(a|0)){z=a;break}A=c[d>>2]|0;c[k>>2]=0;c[r>>2]=0;c[s>>2]=g;B=y+-4|0;C=c[B>>2]|0;c[l>>2]=0;c[t>>2]=0;c[u>>2]=C;if(_n[A&4095](k,l)|0){A=y;y=B;x=A}else{z=y;break}}c[z>>2]=g;y=v+1|0;if((y|0)==8){D=w;break}else E=y}else E=v;y=w+4|0;if((y|0)==(b|0)){m=1;F=16;break}else{x=w;v=E;w=y;o=x}}if((F|0)==16){i=e;return m|0}m=(D+4|0)==(b|0);i=e;return m|0}}return 0}function Fke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d;g=f+8|0;h=g;c[h>>2]=0;c[h+4>>2]=0;c[f>>2]=0;if(!(c[b>>2]&1)){h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;l=j+k|0;c[h>>2]=l;if((k|0)>=0?(m=j+(k+4)|0,m>>>0<=(c[b+20>>2]|0)>>>0):0){c[a>>2]=c[l>>2];c[h>>2]=m}else Bid(h,a,4);if(c[b>>2]&512)c[a>>2]=XEi(c[a>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](a,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(!h){i=d;return}if((h|0)>0){h=b+12|0;m=c[b+16>>2]|0;l=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=m+l|0;c[h>>2]=k;if((l|0)>=0?(j=m+(l+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){l=k;k=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b);i=d;return}else{h=qdd(b,792256,c[142270]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;j=c[b+16>>2]|0;k=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;m=j+k|0;c[h>>2]=m;if((k|0)>=0?(l=j+(k+4)|0,l>>>0<=(c[b+20>>2]|0)>>>0):0){c[f>>2]=c[m>>2];c[h>>2]=l}else Bid(h,f,4);if(c[b>>2]&512)c[f>>2]=XEi(c[f>>2]|0)|0}else{h=c[e>>2]|0;if(h)_n[h&4095](f,b)|0}sdd(b)}h=qdd(b,792272,c[142290]|0,e,0)|0;if(h){if((h|0)>0){h=b+12|0;l=c[b+16>>2]|0;m=(c[(c[b+80>>2]|0)+12>>2]|0)-(da(c[b+32>>2]|0,c[b+28>>2]|0)|0)|0;k=l+m|0;c[h>>2]=k;if((m|0)>=0?(j=l+(m+8)|0,j>>>0<=(c[b+20>>2]|0)>>>0):0){m=k;k=c[m+4>>2]|0;l=g;c[l>>2]=c[m>>2];c[l+4>>2]=k;c[h>>2]=j}else Bid(h,g,8);if(c[b>>2]&512){h=XEi(c[g>>2]|0)|0;j=g+4|0;c[g>>2]=XEi(c[j>>2]|0)|0;c[j>>2]=h}}else{h=c[e>>2]|0;if(h)_n[h&4095](g,b)|0}sdd(b)}gQb(f,a);i=d;return}}function Gke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;m=j>>>0>l>>>0;if(!(c[b>>2]&1)){if(m){Bid(g,a,4);n=c[g>>2]|0;o=c[k>>2]|0}else{c[a>>2]=c[h>>2];c[g>>2]=j;n=j;o=l}b=n+8|0;if(b>>>0>o>>>0){Bid(g,f,8);i=d;return}else{o=n;n=c[o+4>>2]|0;p=f;c[p>>2]=c[o>>2];c[p+4>>2]=n;c[g>>2]=b;i=d;return}}else{if(m){Bid(g,e,4);q=c[g>>2]|0;r=c[k>>2]|0}else{c[e>>2]=c[h>>2];c[g>>2]=j;q=j;r=l}l=q+8|0;if(l>>>0>r>>>0)Bid(g,f,8);else{r=q;q=c[r+4>>2]|0;j=f;c[j>>2]=c[r>>2];c[j+4>>2]=q;c[g>>2]=l}gQb(e,a);i=d;return}}function Hke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0>l>>>0){Bid(g,a,4);m=c[a>>2]|0;n=c[g>>2]|0;o=c[k>>2]|0}else{k=c[h>>2]|0;c[a>>2]=k;c[g>>2]=j;m=k;n=j;o=l}c[a>>2]=XEi(m|0)|0;m=n+8|0;if(m>>>0>o>>>0){Bid(g,f,8);o=f+4|0;p=f;q=o;r=c[f>>2]|0;s=c[o>>2]|0}else{o=n;n=c[o>>2]|0;l=c[o+4>>2]|0;o=f;c[o>>2]=n;c[o+4>>2]=l;c[g>>2]=m;p=f;q=f+4|0;r=n;s=l}l=XEi(r|0)|0;c[p>>2]=XEi(s|0)|0;c[q>>2]=l;i=d;return}else{l=b+12|0;q=c[l>>2]|0;s=q+4|0;p=b+20|0;b=c[p>>2]|0;if(s>>>0>b>>>0){Bid(l,e,4);t=c[e>>2]|0;u=c[l>>2]|0;v=c[p>>2]|0}else{p=c[q>>2]|0;c[e>>2]=p;c[l>>2]=s;t=p;u=s;v=b}c[e>>2]=XEi(t|0)|0;t=u+8|0;if(t>>>0>v>>>0){Bid(l,f,8);v=f+4|0;w=f;x=v;y=c[f>>2]|0;z=c[v>>2]|0}else{v=u;u=c[v>>2]|0;b=c[v+4>>2]|0;v=f;c[v>>2]=u;c[v+4>>2]=b;c[l>>2]=t;w=f;x=f+4|0;y=u;z=b}b=XEi(y|0)|0;c[w>>2]=XEi(z|0)|0;c[x>>2]=b;gQb(e,a);i=d;return}}function Ike(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;f=e+8|0;g=f;c[g>>2]=0;c[g+4>>2]=0;c[e>>2]=0;if(!(c[b>>2]&1)){g=b+12|0;h=c[g>>2]|0;j=h+4|0;k=b+20|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[h>>2]=c[a>>2];c[g>>2]=j;m=j;n=l}else{Gid(g,a,4);m=c[g>>2]|0;n=c[k>>2]|0}k=m+8|0;if(k>>>0<n>>>0){n=m;c[n>>2]=0;c[n+4>>2]=0;c[g>>2]=k;i=d;return}else{Gid(g,f,8);i=d;return}}else{fQb(c[a>>2]|0,e);a=b+12|0;g=c[a>>2]|0;k=g+4|0;n=b+20|0;b=c[n>>2]|0;if(k>>>0<b>>>0){c[g>>2]=c[e>>2];c[a>>2]=k;o=k;p=b}else{Gid(a,e,4);o=c[a>>2]|0;p=c[n>>2]|0}n=o+8|0;if(n>>>0<p>>>0){p=f;e=c[p+4>>2]|0;b=o;c[b>>2]=c[p>>2];c[b+4>>2]=e;c[a>>2]=n;i=d;return}else{Gid(a,f,8);i=d;return}}}function Jke(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}Jke(a,c[b>>2]|0);Jke(a,c[b+4>>2]|0);Kke(b+20|0);ACi(b);i=d;return}function Kke(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if((c[a+48>>2]|0)>-1){f=a+36|0;g=c[f>>2]|0;c[e>>2]=c[a+40>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+28>>2]|0)>-1){f=a+16|0;g=c[f>>2]|0;c[e>>2]=c[a+20>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0}if((c[a+12>>2]|0)<=-1){i=b;return}f=c[a>>2]|0;c[e>>2]=c[a+4>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[a>>2]=0;i=b;return}function Lke(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=d;a:do if(!(Qje(d)|0)){k=c[a>>2]|0;l=c[a+4>>2]|0;if((k|0)==(l|0))m=l;else{n=b[d+248>>1]|0;o=k;while(1){if(n<<16>>16<(b[(c[o>>2]|0)+248>>1]|0)){p=o;break}o=o+4|0;if((o|0)==(l|0)){m=l;break a}}c[h>>2]=p;c[f+0>>2]=c[h+0>>2];Wke(j,a,f,g);i=e;return}}else m=c[a+4>>2]|0;while(0);f=a+4|0;if((m|0)==(c[a+8>>2]|0)){pke(a,g);i=e;return}if(!m)q=0;else{c[m>>2]=d;q=c[f>>2]|0}c[f>>2]=q+4;i=e;return}function Mke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;c[e>>2]=b;f=c[a>>2]|0;g=a+4|0;h=c[g>>2]|0;a:do if((f|0)!=(h|0)){j=f;while(1){if((c[j>>2]|0)==(b|0)){k=j;break}j=j+4|0;if((j|0)==(h|0))break a}j=k-f>>2;l=f+(j+1<<2)|0;m=h-l|0;aFi(f+(j<<2)|0,l|0,m|0)|0;l=f+((m>>2)+j<<2)|0;j=c[g>>2]|0;if((j|0)!=(l|0))c[g>>2]=j+(~((j+-4-l|0)>>>2)<<2)}while(0);Xke(a+12|0,e)|0;i=d;return}function Nke(a,d){a=a|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im;e=i;f=a+8|0;a=Qje(c[f>>2]|0)|0;h=d+8|0;if((a|0)!=(Qje(c[h>>2]|0)|0)){j=1;i=e;return j|0}if(!a){j=(b[(c[f>>2]|0)+248>>1]|0)<(b[(c[h>>2]|0)+248>>1]|0);i=e;return j|0}else if((a|0)==1){k=ea(g[(c[f>>2]|0)+240>>2]);j=k>ea(g[(c[h>>2]|0)+240>>2]);i=e;return j|0}else{j=0;i=e;return j|0}return 0}function Oke(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=c[a>>2]|0;f=c[a+4>>2]|0;c[d>>2]=2844;qke(e,f,d);i=b;return}function Pke(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+24|0;e=b+8|0;f=b;g=ync()|0;n1b(e,(n8b()|0)+56|0);i1b(g,e);In[c[(c[g>>2]|0)+176>>2]&4095](g,e);e=(c[158074]|0)+20|0;c[d>>2]=-1;itd(d,792304);c[f>>2]=c[d>>2];nud(e,f,ea(8.0));f=c[a>>2]|0;e=a+4|0;if((f|0)==(c[e>>2]|0)){i=b;return}else h=f;do{f=c[h>>2]|0;if(!(Qje(f)|0))Uje(f);h=h+4|0}while((h|0)!=(c[e>>2]|0));i=b;return}function Qke(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+8|0;f=d+4|0;g=d;h=d+16|0;j=(c[158074]|0)+20|0;c[e>>2]=-1;itd(e,792304);c[g>>2]=c[e>>2];nud(j,g,ea(4.0));b[h>>1]=0;g=c[a>>2]|0;j=a+4|0;if((g|0)==(c[j>>2]|0)){i=d;return}a=g;do{g=c[a>>2]|0;if((Qje(g)|0)==1){k=g;while(1){l=c[k+220>>2]|0;if(!l){m=k;break}else k=l}k=c[m+36>>2]|0;if(!k)n=0;else{c[f>>2]=k;l=c[137784]|0;if(l){do if((c[l+36>>2]|0)!=(c[l+4>>2]|0)){fRb(e,l,f);o=c[e>>2]|0;p=c[l+28>>2]|0;if((o|0)==-1){q=p+(c[l+32>>2]<<3)|0;break}else{q=p+(o<<3)|0;break}}else q=(c[l+28>>2]|0)+(c[l+32>>2]<<3)|0;while(0);l=c[137784]|0;if((q|0)!=((c[l+28>>2]|0)+(c[l+32>>2]<<3)|0)?(l=c[q+4>>2]|0,(l|0)!=0):0)r=l;else s=14}else s=14;if((s|0)==14){s=0;r=hQb(k)|0}n=r}Xje(g,n,h,0)}a=a+4|0}while((a|0)!=(c[j>>2]|0));i=d;return}function Rke(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e;if(!b){i=e;return}g=a+16|0;h=c[g>>2]|0;do if(h){j=h;while(1){k=c[j+16>>2]|0;if(k>>>0>b>>>0){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if(k>>>0>=b>>>0){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[f>>2]=n;s=m;t=n;break}else if((o|0)==8){c[f>>2]=r;s=q;t=r;break}else if((o|0)==9){c[f>>2]=p;s=f;t=p;break}}else{j=a+16|0;c[f>>2]=j;s=j;t=j}while(0);p=c[s>>2]|0;if(!p){r=xCi(32)|0;c[r+16>>2]=b;b=r+24|0;c[b>>2]=0;c[r+28>>2]=0;c[r+20>>2]=b;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=t;c[s>>2]=r;t=a+12|0;b=c[c[t>>2]>>2]|0;if(!b)u=r;else{c[t>>2]=b;u=c[s>>2]|0}GN(c[g>>2]|0,u);u=a+20|0;c[u>>2]=(c[u>>2]|0)+1;v=r}else v=p;p=v+24|0;r=c[p>>2]|0;do if(r){u=r;while(1){a=c[u+16>>2]|0;if(a>>>0>d>>>0){g=c[u>>2]|0;if(!g){w=u;x=u;o=18;break}else{u=g;continue}}if(a>>>0>=d>>>0){y=u;o=22;break}a=u+4|0;g=c[a>>2]|0;if(!g){z=a;A=u;o=21;break}else u=g}if((o|0)==18){c[f>>2]=x;B=w;C=x;break}else if((o|0)==21){c[f>>2]=A;B=z;C=A;break}else if((o|0)==22){c[f>>2]=y;B=f;C=y;break}}else{u=v+24|0;c[f>>2]=u;B=u;C=u}while(0);if(c[B>>2]|0){i=e;return}f=xCi(20)|0;c[f+16>>2]=d;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=C;c[B>>2]=f;C=v+20|0;d=c[c[C>>2]>>2]|0;if(!d)D=f;else{c[C>>2]=d;D=c[B>>2]|0}GN(c[p>>2]|0,D);D=v+28|0;c[D>>2]=(c[D>>2]|0)+1;i=e;return}function Ske(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+16|0;e=d;if(!b){i=d;return}f=a+16|0;g=c[f>>2]|0;do if(g){h=g;while(1){j=c[h+16>>2]|0;if(j>>>0>b>>>0){k=c[h>>2]|0;if(!k){l=h;m=h;n=5;break}else{h=k;continue}}if(j>>>0>=b>>>0){o=h;n=9;break}j=h+4|0;k=c[j>>2]|0;if(!k){p=j;q=h;n=8;break}else h=k}if((n|0)==5){c[e>>2]=m;r=l;s=m;break}else if((n|0)==8){c[e>>2]=q;r=p;s=q;break}else if((n|0)==9){c[e>>2]=o;r=e;s=o;break}}else{h=a+16|0;c[e>>2]=h;r=h;s=h}while(0);e=c[r>>2]|0;if(!e){o=xCi(32)|0;c[o+16>>2]=b;b=o+24|0;c[b>>2]=0;c[o+28>>2]=0;c[o+20>>2]=b;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=s;c[r>>2]=o;s=a+12|0;b=c[c[s>>2]>>2]|0;if(!b)t=o;else{c[s>>2]=b;t=c[r>>2]|0}GN(c[f>>2]|0,t);t=a+20|0;c[t>>2]=(c[t>>2]|0)+1;u=o}else u=e;e=u+20|0;o=c[e>>2]|0;t=u+24|0;if((o|0)!=(t|0)){a=o;while(1){Dje(c[a+16>>2]|0);o=c[a+4>>2]|0;if(!o){f=a;while(1){r=c[f+8>>2]|0;if((c[r>>2]|0)==(f|0)){v=r;break}else f=r}}else{f=o;while(1){r=c[f>>2]|0;if(!r){v=f;break}else f=r}}if((v|0)==(t|0))break;else a=v}}Yke(e,c[u+24>>2]|0);c[u+28>>2]=0;c[e>>2]=t;c[t>>2]=0;i=d;return}function Tke(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153110];c[b+0>>2]=c[d+0>>2];d=bOb(24,b,1,16,3653512,246)|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=d+16|0;c[b>>2]=0;c[d+20>>2]=0;c[d+12>>2]=b;c[198082]=d;c[141976]=233;c[141978]=234;c[141980]=235;c[141982]=236;c[141984]=237;c[141986]=238;i=a;return}function Uke(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[198082]|0;f=c[153110]|0;if((e|0)!=0?(dle(e+12|0,c[e+16>>2]|0),g=c[e>>2]|0,(g|0)!=0):0){h=e+4|0;j=c[h>>2]|0;if((j|0)!=(g|0))c[h>>2]=j+(~((j+-4-g|0)>>>2)<<2);ACi(g)}c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[198082]=0;i=a;return}function Vke(){return c[198082]|0}function Wke(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;g=c[b>>2]|0;h=g;j=(c[d>>2]|0)-h>>2;d=g+(j<<2)|0;k=b+4|0;l=c[k>>2]|0;m=b+8|0;n=c[m>>2]|0;if(l>>>0<n>>>0){if((d|0)==(l|0)){if(!d)o=0;else{c[d>>2]=c[e>>2];o=c[k>>2]|0}c[k>>2]=o+4;p=d;c[a>>2]=p;i=f;return}o=l-(g+(j+1<<2))|0;q=o>>2;r=g+(q+j<<2)|0;if(r>>>0<l>>>0){j=l;s=r;do{if(!j)t=0;else{c[j>>2]=c[s>>2];t=c[k>>2]|0}s=s+4|0;j=t+4|0;c[k>>2]=j}while(s>>>0<l>>>0)}aFi(l+(0-q<<2)|0,d|0,o|0)|0;if(d>>>0>e>>>0)u=e;else u=(c[k>>2]|0)>>>0>e>>>0?e+4|0:e;c[d>>2]=c[u>>2];p=d;c[a>>2]=p;i=f;return}u=(l-h>>2)+1|0;if(u>>>0>1073741823)vxi(b);h=g;g=n-h|0;if(g>>2>>>0<536870911){n=g>>1;g=n>>>0<u>>>0?u:n;n=d;u=n-h>>2;if(!g){v=0;w=0;x=u;y=n}else{z=g;A=u;B=n;C=18}}else{n=d;z=1073741823;A=n-h>>2;B=n;C=18}if((C|0)==18){v=z;w=xCi(z<<2)|0;x=A;y=B}B=w+(x<<2)|0;A=w+(v<<2)|0;do if((x|0)==(v|0)){if((x|0)>0){D=w+(((x+1|0)/-2|0)+x<<2)|0;E=A;break}z=(x|0)==0?1:x<<1;C=xCi(z<<2)|0;n=C+(z>>>2<<2)|0;h=C+(z<<2)|0;if(!w){D=n;E=h}else{ACi(w);D=n;E=h}}else{D=B;E=A}while(0);if(!D)F=0;else{c[D>>2]=c[e>>2];F=D}e=c[b>>2]|0;A=y-e|0;B=D+(0-(A>>2)<<2)|0;YEi(B|0,e|0,A|0)|0;A=(c[k>>2]|0)-y|0;YEi(F+4|0,d|0,A|0)|0;d=c[b>>2]|0;c[b>>2]=B;c[k>>2]=F+((A>>2)+1<<2);c[m>>2]=E;if(!d){p=D;c[a>>2]=p;i=f;return}ACi(d);p=D;c[a>>2]=p;i=f;return}function Xke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+4>>2]|0;f=a+4|0;if(!e){g=0;i=d;return g|0}h=c[b>>2]|0;b=f;j=e;a:while(1){k=j;while(1){if((c[k+16>>2]|0)>>>0>=h>>>0){l=k;break}k=c[k+4>>2]|0;if(!k){m=b;break a}}j=c[l>>2]|0;if(!j){m=l;break}else b=l}if((m|0)==(f|0)){g=0;i=d;return g|0}if(h>>>0<(c[m+16>>2]|0)>>>0){g=0;i=d;return g|0}h=c[m+4>>2]|0;if(!h){f=m;while(1){l=c[f+8>>2]|0;if((c[l>>2]|0)==(f|0)){n=l;break}else f=l}}else{f=h;while(1){h=c[f>>2]|0;if(!h){n=f;break}else f=h}}if((c[a>>2]|0)==(m|0))c[a>>2]=n;n=a+8|0;c[n>>2]=(c[n>>2]|0)+-1;tYb(e,m);Yke(m+20|0,c[m+24>>2]|0);ACi(m);g=1;i=d;return g|0}function Yke(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Yke(a,c[b>>2]|0);Yke(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Zke(){var a=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;d=a+4|0;e=a;f=a+8|0;g=c[198082]|0;h=(c[158074]|0)+20|0;c[d>>2]=-1;itd(d,792304);c[e>>2]=c[d>>2];nud(h,e,ea(4.0));b[f>>1]=0;e=c[g>>2]|0;h=g+4|0;if((e|0)==(c[h>>2]|0)){i=a;return}else j=e;do{e=c[j>>2]|0;if((Qje(e)|0)==2)Xje(e,0,f,0);j=j+4|0}while((j|0)!=(c[h>>2]|0));i=a;return}function _ke(){var a=0;a=i;Qke(c[198082]|0);i=a;return}function $ke(){var a=0;a=i;Pke(c[198082]|0);i=a;return}function ale(){var a=0,b=0,d=0,e=0,f=0;a=i;b=c[198082]|0;d=c[b>>2]|0;e=b+4|0;if((d|0)==(c[e>>2]|0)){i=a;return}else f=d;do{Mje(c[f>>2]|0,0);f=f+4|0}while((f|0)!=(c[e>>2]|0));i=a;return}function ble(){var a=0,b=0,d=0,e=0,f=0;a=i;b=c[198082]|0;d=c[b>>2]|0;e=b+4|0;if((d|0)==(c[e>>2]|0)){i=a;return}else f=d;do{d=c[f>>2]|0;if((Qje(d)|0)==1)Sje(d);f=f+4|0}while((f|0)!=(c[e>>2]|0));i=a;return}function cle(){var a=0,b=0,d=0,e=0;a=i;i=i+224|0;b=a+208|0;d=a;e=a+200|0;Gcd(e,3516336,3516216,2504352,2504272);c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];jbd(d,b);nbd(d)|0;i=a;return}function dle(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{dle(a,c[b>>2]|0);dle(a,c[b+4>>2]|0);Yke(b+20|0,c[b+24>>2]|0);ACi(b);i=d;return}}function ele(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+112|0;f=e+96|0;h=e+92|0;j=e+16|0;k=e;l=d+64|0;m=d+72|0;c[b+8>>2]=c[m>>2];n=d+80|0;o=d+88|0;p=c[o>>2]|0;c[b+4>>2]=p;c[b>>2]=d;q=j+64|0;c[q+0>>2]=c[150280];c[q+4>>2]=c[150281];c[q+8>>2]=c[150282];r=ea(-ea(g[150280]));s=ea(-ea(g[150281]));t=ea(-ea(g[150282]));c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;q=p+1|0;c[o>>2]=q;p=d+92|0;u=c[p>>2]|0;v=u&2147483647;if(q>>>0>v>>>0){w=u<<1;x=(w|0)==0?1:w;do if(v>>>0<x>>>0)if((u|0)>-1){c[p>>2]=x;w=c[n>>2]|0;c[h>>2]=c[d+84>>2];c[f+0>>2]=c[h+0>>2];c[n>>2]=hOb(w,x*152|0,4,f,0,3653512,370)|0;break}else{c[h>>2]=c[d+84>>2];c[f+0>>2]=c[h+0>>2];w=cOb(x*152|0,4,f,0,3653512,352)|0;YEi(w|0,c[n>>2]|0,(c[o>>2]|0)*152|0)|0;c[p>>2]=x;c[n>>2]=w;break}while(0);y=c[o>>2]|0}else y=q;q=y+-1|0;y=c[n>>2]|0;c[y+(q*152|0)>>2]=0;c[y+(q*152|0)+4>>2]=0;c[y+(q*152|0)+8>>2]=0;n=y+(q*152|0)+12|0;o=j+0|0;j=n+76|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(j|0));g[y+(q*152|0)+88>>2]=r;g[y+(q*152|0)+92>>2]=s;g[y+(q*152|0)+96>>2]=t;o=y+(q*152|0)+100|0;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];g[y+(q*152|0)+116>>2]=ea(1.0);g[y+(q*152|0)+120>>2]=ea(1.0);g[y+(q*152|0)+124>>2]=ea(1.0);g[y+(q*152|0)+128>>2]=ea(1.0);k=y+(q*152|0)+132|0;g[k>>2]=ea(1.0);q=k+4|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;a[q+12>>0]=0;q=(c[m>>2]|0)+1|0;c[m>>2]=q;k=d+76|0;y=c[k>>2]|0;o=y&2147483647;if(q>>>0<=o>>>0){z=q;A=z+-1|0;B=c[l>>2]|0;C=B+(A<<2)|0;c[C>>2]=b;D=d+96|0;a[D>>0]=1;E=d+97|0;a[E>>0]=1;i=e;return}q=y<<1;n=(q|0)==0?1:q;do if(o>>>0<n>>>0)if((y|0)>-1){c[k>>2]=n;q=c[l>>2]|0;c[h>>2]=c[d+68>>2];c[f+0>>2]=c[h+0>>2];c[l>>2]=hOb(q,n<<2,4,f,0,3653512,370)|0;break}else{c[h>>2]=c[d+68>>2];c[f+0>>2]=c[h+0>>2];q=cOb(n<<2,4,f,0,3653512,352)|0;YEi(q|0,c[l>>2]|0,c[m>>2]<<2|0)|0;c[k>>2]=n;c[l>>2]=q;break}while(0);z=c[m>>2]|0;A=z+-1|0;B=c[l>>2]|0;C=B+(A<<2)|0;c[C>>2]=b;D=d+96|0;a[D>>0]=1;E=d+97|0;a[E>>0]=1;i=e;return}function fle(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+72|0;e=c[d>>2]|0;if((e|0)<=0){c[d>>2]=0;f=a+88|0;c[f>>2]=0;i=b;return}g=a+64|0;h=e;e=0;while(1){j=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((j|0)!=0?(c[j>>2]|0)==(a|0):0){c[j>>2]=0;c[j+4>>2]=-1;c[j+8>>2]=-1;c[j+12>>2]=-1;k=c[d>>2]|0}else k=h;e=e+1|0;if((e|0)>=(k|0))break;else h=k}c[d>>2]=0;f=a+88|0;c[f>>2]=0;i=b;return}function gle(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+64|0;g=a+72|0;h=c[g>>2]|0;if((h|0)>0){j=h;h=0;while(1){k=c[(c[f>>2]|0)+(h<<2)>>2]|0;if((k|0)!=0?(c[k>>2]|0)==(a|0):0){c[k>>2]=0;c[k+4>>2]=-1;c[k+8>>2]=-1;c[k+12>>2]=-1;l=c[g>>2]|0}else l=j;h=h+1|0;if((h|0)>=(l|0))break;else j=l}}l=a+76|0;if((c[l>>2]|0)>-1){j=c[f>>2]|0;c[e>>2]=c[a+68>>2];c[d+0>>2]=c[e+0>>2];eOb(j,d);c[f>>2]=0}c[g>>2]=0;c[l>>2]=0;l=a+92|0;if((c[l>>2]|0)<=-1){m=a+88|0;c[m>>2]=0;c[l>>2]=0;i=b;return}g=a+80|0;f=c[g>>2]|0;c[e>>2]=c[a+84>>2];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[g>>2]=0;m=a+88|0;c[m>>2]=0;c[l>>2]=0;i=b;return}function hle(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=xbc()|0;d=0;do{e=b+(d<<2)+64|0;d=d+1|0;if(!(c[e>>2]|0)){f=e;g=4;break}}while((d|0)<16);if((g|0)==4)c[f>>2]=239;f=xbc()|0;d=0;do{b=f+(d<<2)|0;d=d+1|0;if(!(c[b>>2]|0)){h=b;g=8;break}}while((d|0)<16);if((g|0)==8)c[h>>2]=240;h=xbc()|0;d=0;while(1){f=h+(d<<2)+128|0;d=d+1|0;if(!(c[f>>2]|0)){j=f;break}if((d|0)>=16){g=13;break}}if((g|0)==13){i=a;return}c[j>>2]=241;i=a;return}function ile(){return}function jle(){return}function kle(){return}function lle(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im;b=i;i=i+16|0;c=b;d=a>>>16&32768;e=a>>>23&255;f=e+-112|0;h=a&8388607;if((f|0)<1){if((f|0)<-10){j=0;i=b;return j|0}k=(h|8388608)>>>(113-e|0);j=(((k&4096|0)==0?k:k+8192|0)>>>13|d)&65535;i=b;return j|0}if((f|0)==143){k=d|31744;if(!h){j=k&65535;i=b;return j|0}else{j=(k|h>>>13)&65535;i=b;return j|0}}if(!(a&4096)){l=f;m=h}else{a=h+8192|0;h=(a&8388608|0)==0;l=h?f:e+-111|0;m=h?a:0}if((l|0)>30){g[c>>2]=ea(1.0e10);n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));n=ea(g[c>>2]);g[c>>2]=ea(n*ea(g[c>>2]));j=(d|31744)&65535;i=b;return j|0}else{j=(l<<10|d|m>>>13)&65535;i=b;return j|0}return 0}function mle(){var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=0;do{f=e>>>15&1;g=e>>>10&31;h=e&1023;do if((g|0)==31){j=f<<31|2139095040;if(!h)k=j;else k=j|h<<13}else if(!g){if(!h){k=f<<31;break}else{l=0;m=h}while(1){j=m<<1;if(!(j&1024)){l=l+-1|0;m=j}else{n=j;o=l;break}}p=o;q=n&-1026;r=9}else{p=g;q=h;r=9}while(0);if((r|0)==9){r=0;k=(p<<23)+939524096|f<<31|q<<13}c[792336+(e<<2)>>2]=k;e=e+1|0}while((e|0)!=65536);s=0;do{if((s+-113|0)>>>0>28){b[1054480+((s|256)<<1)>>1]=0;t=0}else{e=(s<<10)+-114688|0;b[1054480+((s|256)<<1)>>1]=e|32768;t=e&65535}b[1054480+(s<<1)>>1]=t;s=s+1|0}while((s|0)!=256);a[1055504]=1;i=d;return}function nle(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;Yoe(a);c[a>>2]=b;c[a+4>>2]=d;g=c[e>>2]|0;h=g>>>3&8191;j=da(h,b)|0;c[a+8>>2]=j;c[a+12>>2]=g;c[a+16>>2]=c[e+4>>2];c[a+20>>2]=c[e+8>>2];c[a+24>>2]=c[e+12>>2];c[a+28>>2]=c[e+16>>2];c[a+32>>2]=c[e+20>>2];c[a+36>>2]=c[e+24>>2];c[a+40>>2]=zCi((da(j,d)|0)+h|0)|0;i=f;return}function ole(a){a=a|0;var b=0,d=0;b=i;d=c[a+40>>2]|0;if(d)BCi(d);i=b;return}function ple(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)==(h|0)?(c[a+4>>2]|0)==(c[b+4>>2]|0):0)j=0;else j=(d+-1|0)>>>0<2;d=b+12|0;k=c[d>>2]|0;if((k|0)<0){if(!j){qle(a,b);i=e;return}l=a+12|0;nle(f,h,c[b+4>>2]|0,l);qle(f,b);h=c[l>>2]|0;do if(!(h&536870912)){if(h&1073741824){if(((((c[a+16>>2]|0)==(c[f+16>>2]|0)?(c[a+20>>2]|0)==(c[f+20>>2]|0):0)?(c[a+24>>2]|0)==(c[f+24>>2]|0):0)?(c[a+28>>2]|0)==(c[f+28>>2]|0):0)?(h|0)==(c[f+12>>2]|0):0){Krd(1055592,0,3653512,489,1,0,0,0);break}Krd(1055512,0,3653512,484,1,0,0,0)}}else rle(a,f);while(0);ole(f);i=e;return}h=a+12|0;l=c[h>>2]|0;if((l|0)<0){if(!j){sle(a,b);i=e;return}nle(f,g,c[a+4>>2]|0,d);g=c[d>>2]|0;do if(g&1073741824){if(((((c[f+16>>2]|0)==(c[b+16>>2]|0)?(c[f+20>>2]|0)==(c[b+20>>2]|0):0)?(c[f+24>>2]|0)==(c[b+24>>2]|0):0)?(c[f+28>>2]|0)==(c[b+28>>2]|0):0)?(c[f+12>>2]|0)==(g|0):0){Krd(1055592,0,3653512,489,1,0,0,0);break}Krd(1055512,0,3653512,484,1,0,0,0)}while(0);if(c[d>>2]&536870912)rle(f,b);sle(a,f);ole(f);i=e;return}f=(k&1073741824|0)!=0;if(!j){if(f){if(!(l&1073741824))m=l;else{tle(a,b);m=c[h>>2]|0}if(m&536870912)ule(a,b)}if(!(c[d>>2]&536870912)){i=e;return}m=c[h>>2]|0;if(!(m&1073741824))n=m;else{vle(a,b);n=c[h>>2]|0}if(!(n&536870912)){i=e;return}wle(a,b);i=e;return}if(f){do if(l&1073741824){if((((c[a+16>>2]|0)==(c[b+16>>2]|0)?(c[a+20>>2]|0)==(c[b+20>>2]|0):0)?(c[a+24>>2]|0)==(c[b+24>>2]|0):0)?((l|0)==(k|0)?(c[a+28>>2]|0)==(c[b+28>>2]|0):0):0){Krd(1055592,0,3653512,489,1,0,0,0);break}Krd(1055512,0,3653512,484,1,0,0,0)}while(0);if(c[h>>2]&536870912)Krd(1055512,0,3653512,484,1,0,0,0)}if(!(c[d>>2]&536870912)){i=e;return}d=c[h>>2]|0;if(!(d&1073741824))o=d;else{Krd(1055512,0,3653512,484,1,0,0,0);o=c[h>>2]|0}if(!(o&536870912)){i=e;return}rle(a,b);i=e;return}function qle(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+80|0;f=e+28|0;g=e;h=b+12|0;j=d+12|0;k=c[d+16>>2]|0;do if((k|0)==65280){if(!((((c[d+20>>2]|0)==16711680?(c[d+24>>2]|0)==-16777216:0)?(c[d+28>>2]|0)==255:0)?(c[j>>2]|0)==-1879048160:0))l=26}else if(!k){if(!((((c[d+20>>2]|0)==0?(c[d+24>>2]|0)==255:0)?(c[d+28>>2]|0)==0:0)?(c[j>>2]|0)==-2013265912:0))l=26}else if((k|0)==255){if(!((((c[d+20>>2]|0)==65280?(c[d+24>>2]|0)==16711680:0)?(c[d+28>>2]|0)==0:0)?(c[j>>2]|0)==-1879048168:0))l=26}else if((k|0)==16711680){if((((c[d+20>>2]|0)==65280?(c[d+24>>2]|0)==255:0)?(c[d+28>>2]|0)==-16777216:0)?(c[j>>2]|0)==-1879048160:0)break;if(!((((c[d+20>>2]|0)==65280?(c[d+24>>2]|0)==255:0)?(c[d+28>>2]|0)==0:0)?(c[j>>2]|0)==-1879048168:0))l=26}else l=26;while(0);if((l|0)==26){l=c[d>>2]|0;j=c[d+4>>2]|0;c[g>>2]=-1879048160;c[g+4>>2]=16711680;c[g+8>>2]=65280;c[g+12>>2]=255;c[g+16>>2]=-16777216;a[g+26>>0]=23;a[g+22>>0]=8;a[g+25>>0]=15;a[g+21>>0]=8;a[g+24>>0]=7;a[g+20>>0]=8;a[g+27>>0]=31;a[g+23>>0]=8;nle(f,l,j,g);Gle(f,d,0);g=c[h>>2]|0;if(!(g&536870912)){if(g&1073741824)yle(b,f)}else xle(b,f);ole(f);i=e;return}f=c[h>>2]|0;if(f&536870912){xle(b,d);i=e;return}if(!(f&1073741824)){i=e;return}yle(b,d);i=e;return}function rle(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=0,D=Im,E=Im,F=0,G=Im,H=Im,I=Im,J=Im,K=Im;d=i;if(((((c[a+16>>2]|0)==(c[b+16>>2]|0)?(c[a+20>>2]|0)==(c[b+20>>2]|0):0)?(c[a+24>>2]|0)==(c[b+24>>2]|0):0)?(c[a+28>>2]|0)==(c[b+28>>2]|0):0)?(e=c[a+12>>2]|0,(e|0)==(c[b+12>>2]|0)):0){if((e&65528|0)!=128){Krd(1055592,0,3653512,489,1,0,0,0);i=d;return}e=c[a>>2]|0;f=c[b>>2]|0;if(e>>>0<f>>>0){h=(f<<16>>>0)/(e>>>0)|0;j=h;k=(h>>>1)+-32768|0}else{h=e+-1|0;j=(((f<<16)+-65536|0)>>>0)/(((h|0)!=0?h:1)>>>0)|0;k=0}h=c[a+4>>2]|0;f=c[b+4>>2]|0;if(h>>>0<f>>>0){l=(f<<16>>>0)/(h>>>0)|0;m=(l>>>1)+-32768|0;n=l}else{l=h+-1|0;m=0;n=(((f<<16)+-65536|0)>>>0)/(((l|0)!=0?l:1)>>>0)|0}l=c[b+40>>2]|0;o=c[b+8>>2]|0;b=da(f+-1|0,o)|0;if(!h){i=d;return}f=(e|0)==0;p=c[a+8>>2]|0;q=c[a+40>>2]|0;a=m;m=0;while(1){r=da(o,a>>>16)|0;s=l+r|0;t=r+o|0;r=(m|0)==(h+-1|0)&(t|0)>(b|0)?s:l+t|0;u=ea(ea((a&65535)>>>0)*ea(.0000152587891));v=ea(ea(1.0)-u);if(!f){t=e;w=q;x=k;while(1){t=t+-1|0;y=x>>>16<<2;z=ea(ea((x&65535)>>>0)*ea(.0000152587891));A=ea(ea(1.0)-z);B=ea(ea(g[s+(y<<2)>>2])*A);C=y+4|0;D=ea(B+ea(z*ea(g[s+(C<<2)>>2])));B=ea(A*ea(g[r+(y<<2)>>2]));E=ea(B+ea(z*ea(g[r+(C<<2)>>2])));C=y|1;B=ea(A*ea(g[s+(C<<2)>>2]));F=y+5|0;G=ea(B+ea(z*ea(g[s+(F<<2)>>2])));B=ea(A*ea(g[r+(C<<2)>>2]));H=ea(B+ea(z*ea(g[r+(F<<2)>>2])));F=y|2;B=ea(A*ea(g[s+(F<<2)>>2]));C=y+6|0;I=ea(B+ea(z*ea(g[s+(C<<2)>>2])));B=ea(A*ea(g[r+(F<<2)>>2]));J=ea(B+ea(z*ea(g[r+(C<<2)>>2])));C=y|3;B=ea(A*ea(g[s+(C<<2)>>2]));F=y+7|0;K=ea(B+ea(z*ea(g[s+(F<<2)>>2])));B=ea(A*ea(g[r+(C<<2)>>2]));A=ea(B+ea(z*ea(g[r+(F<<2)>>2])));g[w>>2]=ea(ea(v*D)+ea(u*E));g[w+4>>2]=ea(ea(v*G)+ea(u*H));g[w+8>>2]=ea(ea(v*I)+ea(u*J));g[w+12>>2]=ea(ea(v*K)+ea(u*A));if(!t)break;else{w=w+16|0;x=x+j|0}}}m=m+1|0;if(m>>>0>=h>>>0)break;else{q=q+p|0;a=a+n|0}}i=d;return}Krd(1055512,0,3653512,484,1,0,0,0);i=d;return}function sle(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+80|0;f=e+28|0;g=e;h=b+12|0;j=d+12|0;k=c[b+16>>2]|0;do if((k|0)==65280)if((((c[b+20>>2]|0)==16711680?(c[b+24>>2]|0)==-16777216:0)?(c[b+28>>2]|0)==255:0)?(c[h>>2]|0)==-1879048160:0)l=22;else l=26;else if((k|0)==255)if((((c[b+20>>2]|0)==65280?(c[b+24>>2]|0)==16711680:0)?(c[b+28>>2]|0)==0:0)?(c[h>>2]|0)==-1879048168:0)l=22;else l=26;else if(!k)if((((c[b+20>>2]|0)==0?(c[b+24>>2]|0)==255:0)?(c[b+28>>2]|0)==0:0)?(c[h>>2]|0)==-2013265912:0)l=22;else l=26;else if((k|0)==16711680){if((((c[b+20>>2]|0)==65280?(c[b+24>>2]|0)==255:0)?(c[b+28>>2]|0)==-16777216:0)?(c[h>>2]|0)==-1879048160:0){l=22;break}if((((c[b+20>>2]|0)==65280?(c[b+24>>2]|0)==255:0)?(c[b+28>>2]|0)==0:0)?(c[h>>2]|0)==-1879048168:0)l=22;else l=26}else l=26;while(0);if((l|0)==22){h=c[j>>2]|0;if(!(h&1073741824))m=h;else{zle(b,d);m=c[j>>2]|0}if(!(m&536870912)){i=e;return}Ale(b,d);i=e;return}else if((l|0)==26){l=c[b>>2]|0;m=c[b+4>>2]|0;c[g>>2]=-1879048160;c[g+4>>2]=16711680;c[g+8>>2]=65280;c[g+12>>2]=255;c[g+16>>2]=-16777216;a[g+26>>0]=23;a[g+22>>0]=8;a[g+25>>0]=15;a[g+21>>0]=8;a[g+24>>0]=7;a[g+20>>0]=8;a[g+27>>0]=31;a[g+23>>0]=8;nle(f,l,m,g);g=c[j>>2]|0;if(!(g&1073741824))n=g;else{zle(f,d);n=c[j>>2]|0}if(n&536870912)Ale(f,d);Gle(b,f,0);ole(f);i=e;return}}function tle(a,f){a=a|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=0,cb=Im,db=0,eb=Im,fb=0,gb=Im,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=Im,vb=0,wb=Im,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=Im,$b=0,ac=Im,bc=0,cc=Im,dc=0,ec=Im,fc=0,gc=0,hc=0,ic=Im,jc=0,kc=Im,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0;h=i;j=c[a>>2]|0;l=c[a+4>>2]|0;m=c[a+8>>2]|0;n=c[f+8>>2]|0;o=((m>>>0)/(j>>>0)|0)>>>1;p=((n>>>0)/((c[f>>2]|0)>>>0)|0)>>>1;q=a+12|0;r=c[q>>2]|0;s=f+12|0;t=(c[s>>2]|0)>>>28&1|r>>>27&2;if(!l){i=h;return}u=a+38|0;v=a+37|0;w=a+36|0;x=a+39|0;y=a+16|0;z=a+20|0;A=a+24|0;B=a+28|0;C=f+38|0;D=f+37|0;E=f+36|0;F=f+39|0;G=f+16|0;H=f+20|0;I=f+24|0;J=f+28|0;K=(j|0)==0;L=r;r=c[a+40>>2]|0;a=c[f+40>>2]|0;f=0;while(1){M=(c[y>>2]|0)==0?0:r+((d[u>>0]|0)<<1)|0;N=(c[z>>2]|0)==0?0:r+((d[v>>0]|0)<<1)|0;O=(c[A>>2]|0)==0?0:r+((d[w>>0]|0)<<1)|0;P=(c[B>>2]|0)==0?0:r+((d[x>>0]|0)<<1)|0;Q=(c[G>>2]|0)==0?0:a+((d[C>>0]|0)<<1)|0;R=(c[H>>2]|0)==0?0:a+((d[D>>0]|0)<<1)|0;S=(c[I>>2]|0)==0?0:a+((d[E>>0]|0)<<1)|0;T=(c[J>>2]|0)==0?0:a+((d[F>>0]|0)<<1)|0;a:do if(L&1073741824){b:do if(c[s>>2]&1073741824)if((t|0)==1){Ble(j,o,p,O,P,Q,R,S,T);break}else if((t|0)==3){c:do if(M){if(Q){if(K)break;else{U=j;V=M;W=Q}while(1){U=U+-1|0;b[V>>1]=b[W>>1]|0;if(!U)break c;else{V=V+(o<<1)|0;W=W+(p<<1)|0}}}if(!K){X=j;Y=M;while(1){X=X+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))_=lle(1065353216)|0;else _=Z;b[Y>>1]=_;if(!X)break;else Y=Y+(o<<1)|0}}}while(0);d:do if(N){if(R){if(K)break;else{$=j;aa=N;ba=R}while(1){$=$+-1|0;b[aa>>1]=b[ba>>1]|0;if(!$)break d;else{aa=aa+(o<<1)|0;ba=ba+(p<<1)|0}}}if(!K){Y=j;X=N;while(1){Y=Y+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))ca=lle(1065353216)|0;else ca=Z;b[X>>1]=ca;if(!Y)break;else X=X+(o<<1)|0}}}while(0);e:do if(O){if(S){if(K)break;else{da=j;fa=O;ga=S}while(1){da=da+-1|0;b[fa>>1]=b[ga>>1]|0;if(!da)break e;else{fa=fa+(o<<1)|0;ga=ga+(p<<1)|0}}}if(!K){X=j;Y=O;while(1){X=X+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))ha=lle(1065353216)|0;else ha=Z;b[Y>>1]=ha;if(!X)break;else Y=Y+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;else{ia=j;ja=P;ka=T}while(1){ia=ia+-1|0;b[ja>>1]=b[ka>>1]|0;if(!ia)break b;else{ja=ja+(o<<1)|0;ka=ka+(p<<1)|0}}}if(K)break;else{la=j;ma=P}while(1){la=la+-1|0;Y=b[527367]|0;if(!(Y<<16>>16))na=lle(1065353216)|0;else na=Y;b[ma>>1]=na;if(!la)break;else ma=ma+(o<<1)|0}}else if(!t){f:do if(O){if(S){if(K)break;else{oa=j;pa=O;qa=S}while(1){oa=oa+-1|0;b[pa>>1]=b[qa>>1]|0;if(!oa)break f;else{pa=pa+(o<<1)|0;qa=qa+(p<<1)|0}}}if(!K){Y=j;X=O;while(1){Y=Y+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))ra=lle(1065353216)|0;else ra=Z;b[X>>1]=ra;if(!Y)break;else X=X+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;else{sa=j;ta=P;ua=T}while(1){sa=sa+-1|0;b[ta>>1]=b[ua>>1]|0;if(!sa)break b;else{ta=ta+(o<<1)|0;ua=ua+(p<<1)|0}}}if(K)break;else{va=j;wa=P}while(1){va=va+-1|0;X=b[527367]|0;if(!(X<<16>>16))xa=lle(1065353216)|0;else xa=X;b[wa>>1]=xa;if(!va)break;else wa=wa+(o<<1)|0}}else if((t|0)==2){Cle(j,o,p,M,N,O,P,S,T);break}else break;while(0);if(c[s>>2]&536870912)if(!t){g:do if(O){if(!S){if(K)break;else{ya=j;za=O}while(1){ya=ya+-1|0;X=b[527367]|0;if(!(X<<16>>16))Aa=lle(1065353216)|0;else Aa=X;b[za>>1]=Aa;if(!ya)break g;else za=za+(o<<1)|0}}if(!K){X=j;Y=O;Z=S;while(1){X=X+-1|0;Ba=ea(g[Z>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ea=lle(Ca)|0;break}else{Ea=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ea=0;while(0);b[Y>>1]=Ea;if(!X)break;else{Y=Y+(o<<1)|0;Z=Z+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Fa=j;Ga=P}while(1){Fa=Fa+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))Ha=lle(1065353216)|0;else Ha=Z;b[Ga>>1]=Ha;if(!Fa)break a;else Ga=Ga+(o<<1)|0}}if(K)break;Z=j;Y=P;X=T;while(1){Z=Z+-1|0;Ba=ea(g[X>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ia=lle(Ca)|0;break}else{Ia=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ia=0;while(0);b[Y>>1]=Ia;if(!Z)break;else{Y=Y+(o<<1)|0;X=X+(p<<2)|0}}}else if((t|0)==1){Dle(j,o,p,O,P,Q,R,S,T);break}else if((t|0)==2){Ele(j,o,p,M,N,O,P,S,T);break}else if((t|0)==3){h:do if(M){if(!Q){if(K)break;else{Ja=j;Ka=M}while(1){Ja=Ja+-1|0;X=b[527367]|0;if(!(X<<16>>16))La=lle(1065353216)|0;else La=X;b[Ka>>1]=La;if(!Ja)break h;else Ka=Ka+(o<<1)|0}}if(!K){X=j;Y=M;Z=Q;while(1){X=X+-1|0;Ba=ea(g[Z>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ma=lle(Ca)|0;break}else{Ma=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ma=0;while(0);b[Y>>1]=Ma;if(!X)break;else{Y=Y+(o<<1)|0;Z=Z+(p<<2)|0}}}}while(0);i:do if(N){if(!R){if(K)break;else{Na=j;Oa=N}while(1){Na=Na+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))Pa=lle(1065353216)|0;else Pa=Z;b[Oa>>1]=Pa;if(!Na)break i;else Oa=Oa+(o<<1)|0}}if(!K){Z=j;Y=N;X=R;while(1){Z=Z+-1|0;Ba=ea(g[X>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Qa=lle(Ca)|0;break}else{Qa=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Qa=0;while(0);b[Y>>1]=Qa;if(!Z)break;else{Y=Y+(o<<1)|0;X=X+(p<<2)|0}}}}while(0);j:do if(O){if(!S){if(K)break;else{Ra=j;Sa=O}while(1){Ra=Ra+-1|0;X=b[527367]|0;if(!(X<<16>>16))Ta=lle(1065353216)|0;else Ta=X;b[Sa>>1]=Ta;if(!Ra)break j;else Sa=Sa+(o<<1)|0}}if(!K){X=j;Y=O;Z=S;while(1){X=X+-1|0;Ba=ea(g[Z>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ua=lle(Ca)|0;break}else{Ua=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ua=0;while(0);b[Y>>1]=Ua;if(!X)break;else{Y=Y+(o<<1)|0;Z=Z+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Va=j;Wa=P}while(1){Va=Va+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))Xa=lle(1065353216)|0;else Xa=Z;b[Wa>>1]=Xa;if(!Va)break a;else Wa=Wa+(o<<1)|0}}if(K)break;Z=j;Y=P;X=T;while(1){Z=Z+-1|0;Ba=ea(g[X>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ya=lle(Ca)|0;break}else{Ya=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ya=0;while(0);b[Y>>1]=Ya;if(!Z)break;else{Y=Y+(o<<1)|0;X=X+(p<<2)|0}}}else break}while(0);L=c[q>>2]|0;k:do if(L&536870912){X=c[s>>2]|0;do if(X&1073741824)if((t|0)==1){if(K)break;Y=j;Z=P;Ca=T;Da=S;Za=R;_a=O;$a=Q;while(1){Y=Y+-1|0;if(!$a){ab=ea(.298999995);bb=0}else{ab=ea(ea(g[792336+((e[$a>>1]|0)<<2)>>2])*ea(.298999995));bb=$a+(p<<1)|0}if(!Za){cb=ea(.587000012);db=0}else{cb=ea(ea(g[792336+((e[Za>>1]|0)<<2)>>2])*ea(.587000012));db=Za+(p<<1)|0}if(!Da){eb=ea(.114);fb=0}else{eb=ea(ea(g[792336+((e[Da>>1]|0)<<2)>>2])*ea(.114));fb=Da+(p<<1)|0}if(!Ca){gb=ea(1.0);hb=0}else{gb=ea(g[792336+((e[Ca>>1]|0)<<2)>>2]);hb=Ca+(p<<1)|0}if(!_a)ib=0;else{g[_a>>2]=ea(ab+ea(cb+eb));ib=_a+(o<<2)|0}if(!Z)jb=0;else{g[Z>>2]=gb;jb=Z+(o<<2)|0}if(!Y)break;else{Z=jb;Ca=hb;Da=fb;Za=db;_a=ib;$a=bb}}}else if(!t){do if(O)if(!S){if(K)break;else{kb=j;lb=O}while(1){kb=kb+-1|0;g[lb>>2]=ea(1.0);if(!kb)break;else lb=lb+(o<<2)|0}}else{if(K)break;else{mb=j;nb=O;ob=S}while(1){mb=mb+-1|0;g[nb>>2]=ea(g[792336+((e[ob>>1]|0)<<2)>>2]);if(!mb)break;else{nb=nb+(o<<2)|0;ob=ob+(p<<1)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{pb=j;qb=P}while(1){pb=pb+-1|0;g[qb>>2]=ea(1.0);if(!pb)break;else qb=qb+(o<<2)|0}}else{if(K)break;else{rb=j;sb=P;tb=T}while(1){rb=rb+-1|0;g[sb>>2]=ea(g[792336+((e[tb>>1]|0)<<2)>>2]);if(!rb)break;else{sb=sb+(o<<2)|0;tb=tb+(p<<1)|0}}}}else if((t|0)==2){if(K)break;$a=j;_a=P;Za=T;Da=O;Ca=N;Z=S;Y=M;while(1){$a=$a+-1|0;if(!Z){ub=ea(1.0);vb=0}else{ub=ea(g[792336+((e[Z>>1]|0)<<2)>>2]);vb=Z+(p<<1)|0}if(!Za){wb=ea(1.0);xb=0}else{wb=ea(g[792336+((e[Za>>1]|0)<<2)>>2]);xb=Za+(p<<1)|0}if(!Y)yb=0;else{g[Y>>2]=ub;yb=Y+(o<<2)|0}if(!Ca)zb=0;else{g[Ca>>2]=ub;zb=Ca+(o<<2)|0}if(!Da)Ab=0;else{g[Da>>2]=ub;Ab=Da+(o<<2)|0}if(!_a)Bb=0;else{g[_a>>2]=wb;Bb=_a+(o<<2)|0}if(!$a)break;else{_a=Bb;Za=xb;Da=Ab;Ca=zb;Z=vb;Y=yb}}}else if((t|0)==3){do if(M)if(!Q){if(K)break;else{Cb=j;Db=M}while(1){Cb=Cb+-1|0;g[Db>>2]=ea(1.0);if(!Cb)break;else Db=Db+(o<<2)|0}}else{if(K)break;else{Eb=j;Fb=M;Gb=Q}while(1){Eb=Eb+-1|0;g[Fb>>2]=ea(g[792336+((e[Gb>>1]|0)<<2)>>2]);if(!Eb)break;else{Fb=Fb+(o<<2)|0;Gb=Gb+(p<<1)|0}}}while(0);do if(N)if(!R){if(K)break;else{Hb=j;Ib=N}while(1){Hb=Hb+-1|0;g[Ib>>2]=ea(1.0);if(!Hb)break;else Ib=Ib+(o<<2)|0}}else{if(K)break;else{Jb=j;Kb=N;Lb=R}while(1){Jb=Jb+-1|0;g[Kb>>2]=ea(g[792336+((e[Lb>>1]|0)<<2)>>2]);if(!Jb)break;else{Kb=Kb+(o<<2)|0;Lb=Lb+(p<<1)|0}}}while(0);do if(O)if(!S){if(K)break;else{Mb=j;Nb=O}while(1){Mb=Mb+-1|0;g[Nb>>2]=ea(1.0);if(!Mb)break;else Nb=Nb+(o<<2)|0}}else{if(K)break;else{Ob=j;Pb=O;Qb=S}while(1){Ob=Ob+-1|0;g[Pb>>2]=ea(g[792336+((e[Qb>>1]|0)<<2)>>2]);if(!Ob)break;else{Pb=Pb+(o<<2)|0;Qb=Qb+(p<<1)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{Rb=j;Sb=P}while(1){Rb=Rb+-1|0;g[Sb>>2]=ea(1.0);if(!Rb)break;else Sb=Sb+(o<<2)|0}}else{if(K)break;else{Tb=j;Ub=P;Vb=T}while(1){Tb=Tb+-1|0;g[Ub>>2]=ea(g[792336+((e[Vb>>1]|0)<<2)>>2]);if(!Tb)break;else{Ub=Ub+(o<<2)|0;Vb=Vb+(p<<1)|0}}}}else break;while(0);if(X&536870912)if(!t){l:do if(O){if(!S){if(K)break;else{Wb=j;Xb=O}while(1){Wb=Wb+-1|0;g[Xb>>2]=ea(1.0);if(!Wb)break l;else Xb=Xb+(o<<2)|0}}if(!K){Y=j;Z=O;Ca=S;while(1){Y=Y+-1|0;g[Z>>2]=ea(g[Ca>>2]);if(!Y)break;else{Z=Z+(o<<2)|0;Ca=Ca+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Yb=j;Zb=P}while(1){Yb=Yb+-1|0;g[Zb>>2]=ea(1.0);if(!Yb)break k;else Zb=Zb+(o<<2)|0}}if(K)break;X=j;Ca=P;Z=T;while(1){X=X+-1|0;g[Ca>>2]=ea(g[Z>>2]);if(!X)break;else{Ca=Ca+(o<<2)|0;Z=Z+(p<<2)|0}}}else if((t|0)==1){if(K)break;Z=j;Ca=P;X=T;Y=S;Da=R;Za=O;_a=Q;while(1){Z=Z+-1|0;if(!_a){_b=ea(.298999995);$b=0}else{_b=ea(ea(g[_a>>2])*ea(.298999995));$b=_a+(p<<2)|0}if(!Da){ac=ea(.587000012);bc=0}else{ac=ea(ea(g[Da>>2])*ea(.587000012));bc=Da+(p<<2)|0}if(!Y){cc=ea(.114);dc=0}else{cc=ea(ea(g[Y>>2])*ea(.114));dc=Y+(p<<2)|0}if(!X){ec=ea(1.0);fc=0}else{ec=ea(g[X>>2]);fc=X+(p<<2)|0}if(!Za)gc=0;else{g[Za>>2]=ea(_b+ea(ac+cc));gc=Za+(o<<2)|0}if(!Ca)hc=0;else{g[Ca>>2]=ec;hc=Ca+(o<<2)|0}if(!Z)break;else{Ca=hc;X=fc;Y=dc;Da=bc;Za=gc;_a=$b}}}else if((t|0)==2){if(K)break;_a=j;Za=P;Da=T;Y=O;X=N;Ca=S;Z=M;while(1){_a=_a+-1|0;if(!Ca){ic=ea(1.0);jc=0}else{ic=ea(g[Ca>>2]);jc=Ca+(p<<2)|0}if(!Da){kc=ea(1.0);lc=0}else{kc=ea(g[Da>>2]);lc=Da+(p<<2)|0}if(!Z)mc=0;else{g[Z>>2]=ic;mc=Z+(o<<2)|0}if(!X)nc=0;else{g[X>>2]=ic;nc=X+(o<<2)|0}if(!Y)oc=0;else{g[Y>>2]=ic;oc=Y+(o<<2)|0}if(!Za)pc=0;else{g[Za>>2]=kc;pc=Za+(o<<2)|0}if(!_a)break;else{Za=pc;Da=lc;Y=oc;X=nc;Ca=jc;Z=mc}}}else if((t|0)==3){m:do if(M){if(!Q){if(K)break;else{qc=j;rc=M}while(1){qc=qc+-1|0;g[rc>>2]=ea(1.0);if(!qc)break m;else rc=rc+(o<<2)|0}}if(!K){Z=j;Ca=M;X=Q;while(1){Z=Z+-1|0;g[Ca>>2]=ea(g[X>>2]);if(!Z)break;else{Ca=Ca+(o<<2)|0;X=X+(p<<2)|0}}}}while(0);n:do if(N){if(!R){if(K)break;else{sc=j;tc=N}while(1){sc=sc+-1|0;g[tc>>2]=ea(1.0);if(!sc)break n;else tc=tc+(o<<2)|0}}if(!K){X=j;Ca=N;Z=R;while(1){X=X+-1|0;g[Ca>>2]=ea(g[Z>>2]);if(!X)break;else{Ca=Ca+(o<<2)|0;Z=Z+(p<<2)|0}}}}while(0);o:do if(O){if(!S){if(K)break;else{uc=j;vc=O}while(1){uc=uc+-1|0;g[vc>>2]=ea(1.0);if(!uc)break o;else vc=vc+(o<<2)|0}}if(!K){Z=j;Ca=O;X=S;while(1){Z=Z+-1|0;g[Ca>>2]=ea(g[X>>2]);if(!Z)break;else{Ca=Ca+(o<<2)|0;X=X+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{wc=j;xc=P}while(1){wc=wc+-1|0;g[xc>>2]=ea(1.0);if(!wc)break k;else xc=xc+(o<<2)|0}}if(K)break;X=j;Ca=P;Z=T;while(1){X=X+-1|0;g[Ca>>2]=ea(g[Z>>2]);if(!X)break;else{Ca=Ca+(o<<2)|0;Z=Z+(p<<2)|0}}}else break}while(0);f=f+1|0;if((f|0)==(l|0))break;else{r=r+m|0;a=a+n|0}}i=h;return}function ule(a,f){a=a|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=Im,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=Im,fb=0,gb=Im,hb=0,ib=Im,jb=0,kb=Im,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=Im,_b=0,$b=Im,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=Im,mc=0,nc=Im,oc=0,pc=Im,qc=0,rc=Im,sc=0,tc=0,uc=0,vc=Im,wc=0,xc=Im,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0;h=i;j=c[a>>2]|0;l=c[a+4>>2]|0;m=c[a+8>>2]|0;n=c[f+8>>2]|0;o=((m>>>0)/(j>>>0)|0)>>>2;p=((n>>>0)/((c[f>>2]|0)>>>0)|0)>>>1;q=a+12|0;r=c[q>>2]|0;s=f+12|0;t=(c[s>>2]|0)>>>28&1|r>>>27&2;if(!l){i=h;return}u=a+38|0;v=a+37|0;w=a+36|0;x=a+39|0;y=a+16|0;z=a+20|0;A=a+24|0;B=a+28|0;C=f+38|0;D=f+37|0;E=f+36|0;F=f+39|0;G=f+16|0;H=f+20|0;I=f+24|0;J=f+28|0;K=(j|0)==0;L=r;r=c[a+40>>2]|0;a=c[f+40>>2]|0;f=0;while(1){M=(c[y>>2]|0)==0?0:r+((d[u>>0]|0)<<2)|0;N=(c[z>>2]|0)==0?0:r+((d[v>>0]|0)<<2)|0;O=(c[A>>2]|0)==0?0:r+((d[w>>0]|0)<<2)|0;P=(c[B>>2]|0)==0?0:r+((d[x>>0]|0)<<2)|0;Q=(c[G>>2]|0)==0?0:a+((d[C>>0]|0)<<1)|0;R=(c[H>>2]|0)==0?0:a+((d[D>>0]|0)<<1)|0;S=(c[I>>2]|0)==0?0:a+((d[E>>0]|0)<<1)|0;T=(c[J>>2]|0)==0?0:a+((d[F>>0]|0)<<1)|0;a:do if(L&1073741824){b:do if(c[s>>2]&1073741824)if(!t){c:do if(O){if(S){if(K)break;else{U=j;V=O;W=S}while(1){U=U+-1|0;b[V>>1]=b[W>>1]|0;if(!U)break c;else{V=V+(o<<1)|0;W=W+(p<<1)|0}}}if(!K){X=j;Y=O;while(1){X=X+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))_=lle(1065353216)|0;else _=Z;b[Y>>1]=_;if(!X)break;else Y=Y+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;else{$=j;aa=P;ba=T}while(1){$=$+-1|0;b[aa>>1]=b[ba>>1]|0;if(!$)break b;else{aa=aa+(o<<1)|0;ba=ba+(p<<1)|0}}}if(K)break;else{ca=j;da=P}while(1){ca=ca+-1|0;Y=b[527367]|0;if(!(Y<<16>>16))fa=lle(1065353216)|0;else fa=Y;b[da>>1]=fa;if(!ca)break;else da=da+(o<<1)|0}}else if((t|0)==1){Ble(j,o,p,O,P,Q,R,S,T);break}else if((t|0)==3){d:do if(M){if(Q){if(K)break;else{ga=j;ha=M;ia=Q}while(1){ga=ga+-1|0;b[ha>>1]=b[ia>>1]|0;if(!ga)break d;else{ha=ha+(o<<1)|0;ia=ia+(p<<1)|0}}}if(!K){Y=j;X=M;while(1){Y=Y+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))ja=lle(1065353216)|0;else ja=Z;b[X>>1]=ja;if(!Y)break;else X=X+(o<<1)|0}}}while(0);e:do if(N){if(R){if(K)break;else{ka=j;la=N;ma=R}while(1){ka=ka+-1|0;b[la>>1]=b[ma>>1]|0;if(!ka)break e;else{la=la+(o<<1)|0;ma=ma+(p<<1)|0}}}if(!K){X=j;Y=N;while(1){X=X+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))na=lle(1065353216)|0;else na=Z;b[Y>>1]=na;if(!X)break;else Y=Y+(o<<1)|0}}}while(0);f:do if(O){if(S){if(K)break;else{oa=j;pa=O;qa=S}while(1){oa=oa+-1|0;b[pa>>1]=b[qa>>1]|0;if(!oa)break f;else{pa=pa+(o<<1)|0;qa=qa+(p<<1)|0}}}if(!K){Y=j;X=O;while(1){Y=Y+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))ra=lle(1065353216)|0;else ra=Z;b[X>>1]=ra;if(!Y)break;else X=X+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;else{sa=j;ta=P;ua=T}while(1){sa=sa+-1|0;b[ta>>1]=b[ua>>1]|0;if(!sa)break b;else{ta=ta+(o<<1)|0;ua=ua+(p<<1)|0}}}if(K)break;else{va=j;wa=P}while(1){va=va+-1|0;X=b[527367]|0;if(!(X<<16>>16))xa=lle(1065353216)|0;else xa=X;b[wa>>1]=xa;if(!va)break;else wa=wa+(o<<1)|0}}else if((t|0)==2){Cle(j,o,p,M,N,O,P,S,T);break}else break;while(0);if(c[s>>2]&536870912)if(!t){g:do if(O){if(!S){if(K)break;else{ya=j;za=O}while(1){ya=ya+-1|0;X=b[527367]|0;if(!(X<<16>>16))Aa=lle(1065353216)|0;else Aa=X;b[za>>1]=Aa;if(!ya)break g;else za=za+(o<<1)|0}}if(!K){X=j;Y=O;Z=S;while(1){X=X+-1|0;Ba=ea(g[Z>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ea=lle(Ca)|0;break}else{Ea=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ea=0;while(0);b[Y>>1]=Ea;if(!X)break;else{Y=Y+(o<<1)|0;Z=Z+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Fa=j;Ga=P}while(1){Fa=Fa+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))Ha=lle(1065353216)|0;else Ha=Z;b[Ga>>1]=Ha;if(!Fa)break a;else Ga=Ga+(o<<1)|0}}if(K)break;Z=j;Y=P;X=T;while(1){Z=Z+-1|0;Ba=ea(g[X>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ia=lle(Ca)|0;break}else{Ia=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ia=0;while(0);b[Y>>1]=Ia;if(!Z)break;else{Y=Y+(o<<1)|0;X=X+(p<<2)|0}}}else if((t|0)==1){Dle(j,o,p,O,P,Q,R,S,T);break}else if((t|0)==2){Ele(j,o,p,M,N,O,P,S,T);break}else if((t|0)==3){h:do if(M){if(!Q){if(K)break;else{Ja=j;Ka=M}while(1){Ja=Ja+-1|0;X=b[527367]|0;if(!(X<<16>>16))La=lle(1065353216)|0;else La=X;b[Ka>>1]=La;if(!Ja)break h;else Ka=Ka+(o<<1)|0}}if(!K){X=j;Y=M;Z=Q;while(1){X=X+-1|0;Ba=ea(g[Z>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ma=lle(Ca)|0;break}else{Ma=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ma=0;while(0);b[Y>>1]=Ma;if(!X)break;else{Y=Y+(o<<1)|0;Z=Z+(p<<2)|0}}}}while(0);i:do if(N){if(!R){if(K)break;else{Na=j;Oa=N}while(1){Na=Na+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))Pa=lle(1065353216)|0;else Pa=Z;b[Oa>>1]=Pa;if(!Na)break i;else Oa=Oa+(o<<1)|0}}if(!K){Z=j;Y=N;X=R;while(1){Z=Z+-1|0;Ba=ea(g[X>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Qa=lle(Ca)|0;break}else{Qa=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Qa=0;while(0);b[Y>>1]=Qa;if(!Z)break;else{Y=Y+(o<<1)|0;X=X+(p<<2)|0}}}}while(0);j:do if(O){if(!S){if(K)break;else{Ra=j;Sa=O}while(1){Ra=Ra+-1|0;X=b[527367]|0;if(!(X<<16>>16))Ta=lle(1065353216)|0;else Ta=X;b[Sa>>1]=Ta;if(!Ra)break j;else Sa=Sa+(o<<1)|0}}if(!K){X=j;Y=O;Z=S;while(1){X=X+-1|0;Ba=ea(g[Z>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ua=lle(Ca)|0;break}else{Ua=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ua=0;while(0);b[Y>>1]=Ua;if(!X)break;else{Y=Y+(o<<1)|0;Z=Z+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Va=j;Wa=P}while(1){Va=Va+-1|0;Z=b[527367]|0;if(!(Z<<16>>16))Xa=lle(1065353216)|0;else Xa=Z;b[Wa>>1]=Xa;if(!Va)break a;else Wa=Wa+(o<<1)|0}}if(K)break;Z=j;Y=P;X=T;while(1){Z=Z+-1|0;Ba=ea(g[X>>2]);do if(!(Ba==ea(0.0))){Ca=(g[k>>2]=Ba,c[k>>2]|0);Da=b[1054480+(Ca>>>23<<1)>>1]|0;if(!(Da<<16>>16)){Ya=lle(Ca)|0;break}else{Ya=(Da&65535)+(((Ca&8388607)+4096|0)>>>13)&65535;break}}else Ya=0;while(0);b[Y>>1]=Ya;if(!Z)break;else{Y=Y+(o<<1)|0;X=X+(p<<2)|0}}}else break}while(0);L=c[q>>2]|0;k:do if(L&536870912){X=c[s>>2]|0;do if(X&1073741824)if((t|0)==1){if(K)break;else{Za=j;_a=P;$a=T;ab=S;bb=R;cb=O;db=Q}while(1){Za=Za+-1|0;if(!db){eb=ea(.298999995);fb=0}else{eb=ea(ea(g[792336+((e[db>>1]|0)<<2)>>2])*ea(.298999995));fb=db+(p<<1)|0}if(!bb){gb=ea(.587000012);hb=0}else{gb=ea(ea(g[792336+((e[bb>>1]|0)<<2)>>2])*ea(.587000012));hb=bb+(p<<1)|0}if(!ab){ib=ea(.114);jb=0}else{ib=ea(ea(g[792336+((e[ab>>1]|0)<<2)>>2])*ea(.114));jb=ab+(p<<1)|0}if(!$a){kb=ea(1.0);lb=0}else{kb=ea(g[792336+((e[$a>>1]|0)<<2)>>2]);lb=$a+(p<<1)|0}if(!cb)mb=0;else{g[cb>>2]=ea(eb+ea(gb+ib));mb=cb+(o<<2)|0}if(!_a)nb=0;else{g[_a>>2]=kb;nb=_a+(o<<2)|0}if(!Za)break;else{_a=nb;$a=lb;ab=jb;bb=hb;cb=mb;db=fb}}}else if((t|0)==3){do if(M)if(!Q){if(K)break;else{ob=j;pb=M}while(1){ob=ob+-1|0;g[pb>>2]=ea(1.0);if(!ob)break;else pb=pb+(o<<2)|0}}else{if(K)break;else{qb=j;rb=M;sb=Q}while(1){qb=qb+-1|0;g[rb>>2]=ea(g[792336+((e[sb>>1]|0)<<2)>>2]);if(!qb)break;else{rb=rb+(o<<2)|0;sb=sb+(p<<1)|0}}}while(0);do if(N)if(!R){if(K)break;else{tb=j;ub=N}while(1){tb=tb+-1|0;g[ub>>2]=ea(1.0);if(!tb)break;else ub=ub+(o<<2)|0}}else{if(K)break;else{vb=j;wb=N;xb=R}while(1){vb=vb+-1|0;g[wb>>2]=ea(g[792336+((e[xb>>1]|0)<<2)>>2]);if(!vb)break;else{wb=wb+(o<<2)|0;xb=xb+(p<<1)|0}}}while(0);do if(O)if(!S){if(K)break;else{yb=j;zb=O}while(1){yb=yb+-1|0;g[zb>>2]=ea(1.0);if(!yb)break;else zb=zb+(o<<2)|0}}else{if(K)break;else{Ab=j;Bb=O;Cb=S}while(1){Ab=Ab+-1|0;g[Bb>>2]=ea(g[792336+((e[Cb>>1]|0)<<2)>>2]);if(!Ab)break;else{Bb=Bb+(o<<2)|0;Cb=Cb+(p<<1)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{Db=j;Eb=P}while(1){Db=Db+-1|0;g[Eb>>2]=ea(1.0);if(!Db)break;else Eb=Eb+(o<<2)|0}}else{if(K)break;else{Fb=j;Gb=P;Hb=T}while(1){Fb=Fb+-1|0;g[Gb>>2]=ea(g[792336+((e[Hb>>1]|0)<<2)>>2]);if(!Fb)break;else{Gb=Gb+(o<<2)|0;Hb=Hb+(p<<1)|0}}}}else if(!t){do if(O)if(!S){if(K)break;else{Ib=j;Jb=O}while(1){Ib=Ib+-1|0;g[Jb>>2]=ea(1.0);if(!Ib)break;else Jb=Jb+(o<<2)|0}}else{if(K)break;else{Kb=j;Lb=O;Mb=S}while(1){Kb=Kb+-1|0;g[Lb>>2]=ea(g[792336+((e[Mb>>1]|0)<<2)>>2]);if(!Kb)break;else{Lb=Lb+(o<<2)|0;Mb=Mb+(p<<1)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{Nb=j;Ob=P}while(1){Nb=Nb+-1|0;g[Ob>>2]=ea(1.0);if(!Nb)break;else Ob=Ob+(o<<2)|0}}else{if(K)break;else{Pb=j;Qb=P;Rb=T}while(1){Pb=Pb+-1|0;g[Qb>>2]=ea(g[792336+((e[Rb>>1]|0)<<2)>>2]);if(!Pb)break;else{Qb=Qb+(o<<2)|0;Rb=Rb+(p<<1)|0}}}}else if((t|0)==2){if(K)break;else{Sb=j;Tb=P;Ub=T;Vb=O;Wb=N;Xb=S;Yb=M}while(1){Sb=Sb+-1|0;if(!Xb){Zb=ea(1.0);_b=0}else{Zb=ea(g[792336+((e[Xb>>1]|0)<<2)>>2]);_b=Xb+(p<<1)|0}if(!Ub){$b=ea(1.0);ac=0}else{$b=ea(g[792336+((e[Ub>>1]|0)<<2)>>2]);ac=Ub+(p<<1)|0}if(!Yb)bc=0;else{g[Yb>>2]=Zb;bc=Yb+(o<<2)|0}if(!Wb)cc=0;else{g[Wb>>2]=Zb;cc=Wb+(o<<2)|0}if(!Vb)dc=0;else{g[Vb>>2]=Zb;dc=Vb+(o<<2)|0}if(!Tb)ec=0;else{g[Tb>>2]=$b;ec=Tb+(o<<2)|0}if(!Sb)break;else{Tb=ec;Ub=ac;Vb=dc;Wb=cc;Xb=_b;Yb=bc}}}else break;while(0);if(X&536870912)if(!t){l:do if(O){if(!S){if(K)break;else{fc=j;gc=O}while(1){fc=fc+-1|0;g[gc>>2]=ea(1.0);if(!fc)break l;else gc=gc+(o<<2)|0}}if(!K){Y=j;Z=O;Ca=S;while(1){Y=Y+-1|0;g[Z>>2]=ea(g[Ca>>2]);if(!Y)break;else{Z=Z+(o<<2)|0;Ca=Ca+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{hc=j;ic=P}while(1){hc=hc+-1|0;g[ic>>2]=ea(1.0);if(!hc)break k;else ic=ic+(o<<2)|0}}if(K)break;X=j;Ca=P;Z=T;while(1){X=X+-1|0;g[Ca>>2]=ea(g[Z>>2]);if(!X)break;else{Ca=Ca+(o<<2)|0;Z=Z+(p<<2)|0}}}else if((t|0)==1){if(K)break;Z=j;Ca=P;X=T;Y=S;Da=R;jc=O;kc=Q;while(1){Z=Z+-1|0;if(!kc){lc=ea(.298999995);mc=0}else{lc=ea(ea(g[kc>>2])*ea(.298999995));mc=kc+(p<<2)|0}if(!Da){nc=ea(.587000012);oc=0}else{nc=ea(ea(g[Da>>2])*ea(.587000012));oc=Da+(p<<2)|0}if(!Y){pc=ea(.114);qc=0}else{pc=ea(ea(g[Y>>2])*ea(.114));qc=Y+(p<<2)|0}if(!X){rc=ea(1.0);sc=0}else{rc=ea(g[X>>2]);sc=X+(p<<2)|0}if(!jc)tc=0;else{g[jc>>2]=ea(lc+ea(nc+pc));tc=jc+(o<<2)|0}if(!Ca)uc=0;else{g[Ca>>2]=rc;uc=Ca+(o<<2)|0}if(!Z)break;else{Ca=uc;X=sc;Y=qc;Da=oc;jc=tc;kc=mc}}}else if((t|0)==2){if(K)break;kc=j;jc=P;Da=T;Y=O;X=N;Ca=S;Z=M;while(1){kc=kc+-1|0;if(!Ca){vc=ea(1.0);wc=0}else{vc=ea(g[Ca>>2]);wc=Ca+(p<<2)|0}if(!Da){xc=ea(1.0);yc=0}else{xc=ea(g[Da>>2]);yc=Da+(p<<2)|0}if(!Z)zc=0;else{g[Z>>2]=vc;zc=Z+(o<<2)|0}if(!X)Ac=0;else{g[X>>2]=vc;Ac=X+(o<<2)|0}if(!Y)Bc=0;else{g[Y>>2]=vc;Bc=Y+(o<<2)|0}if(!jc)Cc=0;else{g[jc>>2]=xc;Cc=jc+(o<<2)|0}if(!kc)break;else{jc=Cc;Da=yc;Y=Bc;X=Ac;Ca=wc;Z=zc}}}else if((t|0)==3){m:do if(M){if(!Q){if(K)break;else{Dc=j;Ec=M}while(1){Dc=Dc+-1|0;g[Ec>>2]=ea(1.0);if(!Dc)break m;else Ec=Ec+(o<<2)|0}}if(!K){Z=j;Ca=M;X=Q;while(1){Z=Z+-1|0;g[Ca>>2]=ea(g[X>>2]);if(!Z)break;else{Ca=Ca+(o<<2)|0;X=X+(p<<2)|0}}}}while(0);n:do if(N){if(!R){if(K)break;else{Fc=j;Gc=N}while(1){Fc=Fc+-1|0;g[Gc>>2]=ea(1.0);if(!Fc)break n;else Gc=Gc+(o<<2)|0}}if(!K){X=j;Ca=N;Z=R;while(1){X=X+-1|0;g[Ca>>2]=ea(g[Z>>2]);if(!X)break;else{Ca=Ca+(o<<2)|0;Z=Z+(p<<2)|0}}}}while(0);o:do if(O){if(!S){if(K)break;else{Hc=j;Ic=O}while(1){Hc=Hc+-1|0;g[Ic>>2]=ea(1.0);if(!Hc)break o;else Ic=Ic+(o<<2)|0}}if(!K){Z=j;Ca=O;X=S;while(1){Z=Z+-1|0;g[Ca>>2]=ea(g[X>>2]);if(!Z)break;else{Ca=Ca+(o<<2)|0;X=X+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Jc=j;Kc=P}while(1){Jc=Jc+-1|0;g[Kc>>2]=ea(1.0);if(!Jc)break k;else Kc=Kc+(o<<2)|0}}if(K)break;X=j;Ca=P;Z=T;while(1){X=X+-1|0;g[Ca>>2]=ea(g[Z>>2]);if(!X)break;else{Ca=Ca+(o<<2)|0;Z=Z+(p<<2)|0}}}else break}while(0);f=f+1|0;if((f|0)==(l|0))break;else{r=r+m|0;a=a+n|0}}i=h;return}function vle(a,f){a=a|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=Im,bb=0,cb=Im,db=0,eb=Im,fb=0,gb=Im,hb=0,ib=0,jb=0,kb=Im,lb=0,mb=Im,nb=0,ob=0,pb=0,qb=0,rb=0,sb=Im,tb=0,ub=Im,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=Im,dc=0,ec=Im,fc=0,gc=Im,hc=0,ic=Im,jc=0,kc=0,lc=0;h=i;j=c[a>>2]|0;l=c[a+4>>2]|0;m=c[a+8>>2]|0;n=c[f+8>>2]|0;o=((m>>>0)/(j>>>0)|0)>>>1;p=((n>>>0)/((c[f>>2]|0)>>>0)|0)>>>2;q=a+12|0;r=c[q>>2]|0;s=f+12|0;t=(c[s>>2]|0)>>>28&1|r>>>27&2;if(!l){i=h;return}u=a+38|0;v=a+37|0;w=a+36|0;x=a+39|0;y=a+16|0;z=a+20|0;A=a+24|0;B=a+28|0;C=f+38|0;D=f+37|0;E=f+36|0;F=f+39|0;G=f+16|0;H=f+20|0;I=f+24|0;J=f+28|0;K=(j|0)==0;L=r;r=c[a+40>>2]|0;a=c[f+40>>2]|0;f=0;while(1){M=(c[y>>2]|0)==0?0:r+((d[u>>0]|0)<<1)|0;N=(c[z>>2]|0)==0?0:r+((d[v>>0]|0)<<1)|0;O=(c[A>>2]|0)==0?0:r+((d[w>>0]|0)<<1)|0;P=(c[B>>2]|0)==0?0:r+((d[x>>0]|0)<<1)|0;Q=(c[G>>2]|0)==0?0:a+((d[C>>0]|0)<<2)|0;R=(c[H>>2]|0)==0?0:a+((d[D>>0]|0)<<2)|0;S=(c[I>>2]|0)==0?0:a+((d[E>>0]|0)<<2)|0;T=(c[J>>2]|0)==0?0:a+((d[F>>0]|0)<<2)|0;a:do if(L&1073741824){b:do if(c[s>>2]&1073741824)if((t|0)==2){Cle(j,o,p,M,N,O,P,S,T);break}else if(!t){c:do if(O){if(S){if(K)break;U=j;V=O;W=S;while(1){U=U+-1|0;b[V>>1]=b[W>>1]|0;if(!U)break c;else{V=V+(o<<1)|0;W=W+(p<<1)|0}}}if(!K){W=j;V=O;while(1){W=W+-1|0;U=b[527367]|0;if(!(U<<16>>16))X=lle(1065353216)|0;else X=U;b[V>>1]=X;if(!W)break;else V=V+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;V=j;W=P;U=T;while(1){V=V+-1|0;b[W>>1]=b[U>>1]|0;if(!V)break b;else{W=W+(o<<1)|0;U=U+(p<<1)|0}}}if(K)break;else{Y=j;Z=P}while(1){Y=Y+-1|0;U=b[527367]|0;if(!(U<<16>>16))_=lle(1065353216)|0;else _=U;b[Z>>1]=_;if(!Y)break;else Z=Z+(o<<1)|0}}else if((t|0)==3){d:do if(M){if(Q){if(K)break;U=j;W=M;V=Q;while(1){U=U+-1|0;b[W>>1]=b[V>>1]|0;if(!U)break d;else{W=W+(o<<1)|0;V=V+(p<<1)|0}}}if(!K){V=j;W=M;while(1){V=V+-1|0;U=b[527367]|0;if(!(U<<16>>16))$=lle(1065353216)|0;else $=U;b[W>>1]=$;if(!V)break;else W=W+(o<<1)|0}}}while(0);e:do if(N){if(R){if(K)break;W=j;V=N;U=R;while(1){W=W+-1|0;b[V>>1]=b[U>>1]|0;if(!W)break e;else{V=V+(o<<1)|0;U=U+(p<<1)|0}}}if(!K){U=j;V=N;while(1){U=U+-1|0;W=b[527367]|0;if(!(W<<16>>16))aa=lle(1065353216)|0;else aa=W;b[V>>1]=aa;if(!U)break;else V=V+(o<<1)|0}}}while(0);f:do if(O){if(S){if(K)break;V=j;U=O;W=S;while(1){V=V+-1|0;b[U>>1]=b[W>>1]|0;if(!V)break f;else{U=U+(o<<1)|0;W=W+(p<<1)|0}}}if(!K){W=j;U=O;while(1){W=W+-1|0;V=b[527367]|0;if(!(V<<16>>16))ba=lle(1065353216)|0;else ba=V;b[U>>1]=ba;if(!W)break;else U=U+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;U=j;W=P;V=T;while(1){U=U+-1|0;b[W>>1]=b[V>>1]|0;if(!U)break b;else{W=W+(o<<1)|0;V=V+(p<<1)|0}}}if(K)break;else{ca=j;da=P}while(1){ca=ca+-1|0;V=b[527367]|0;if(!(V<<16>>16))fa=lle(1065353216)|0;else fa=V;b[da>>1]=fa;if(!ca)break;else da=da+(o<<1)|0}}else if((t|0)==1){Ble(j,o,p,O,P,Q,R,S,T);break}else break;while(0);if(c[s>>2]&536870912)if(!t){g:do if(O){if(!S){if(K)break;else{ga=j;ha=O}while(1){ga=ga+-1|0;V=b[527367]|0;if(!(V<<16>>16))ia=lle(1065353216)|0;else ia=V;b[ha>>1]=ia;if(!ga)break g;else ha=ha+(o<<1)|0}}if(!K){V=j;W=O;U=S;while(1){V=V+-1|0;ja=ea(g[U>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){ma=lle(ka)|0;break}else{ma=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else ma=0;while(0);b[W>>1]=ma;if(!V)break;else{W=W+(o<<1)|0;U=U+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{na=j;oa=P}while(1){na=na+-1|0;U=b[527367]|0;if(!(U<<16>>16))pa=lle(1065353216)|0;else pa=U;b[oa>>1]=pa;if(!na)break a;else oa=oa+(o<<1)|0}}if(K)break;else{qa=j;ra=P;sa=T}while(1){qa=qa+-1|0;ja=ea(g[sa>>2]);do if(!(ja==ea(0.0))){U=(g[k>>2]=ja,c[k>>2]|0);W=b[1054480+(U>>>23<<1)>>1]|0;if(!(W<<16>>16)){ta=lle(U)|0;break}else{ta=(W&65535)+(((U&8388607)+4096|0)>>>13)&65535;break}}else ta=0;while(0);b[ra>>1]=ta;if(!qa)break;else{ra=ra+(o<<1)|0;sa=sa+(p<<2)|0}}}else if((t|0)==1){Dle(j,o,p,O,P,Q,R,S,T);break}else if((t|0)==2){Ele(j,o,p,M,N,O,P,S,T);break}else if((t|0)==3){h:do if(M){if(!Q){if(K)break;else{ua=j;va=M}while(1){ua=ua+-1|0;U=b[527367]|0;if(!(U<<16>>16))wa=lle(1065353216)|0;else wa=U;b[va>>1]=wa;if(!ua)break h;else va=va+(o<<1)|0}}if(!K){U=j;W=M;V=Q;while(1){U=U+-1|0;ja=ea(g[V>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){xa=lle(ka)|0;break}else{xa=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else xa=0;while(0);b[W>>1]=xa;if(!U)break;else{W=W+(o<<1)|0;V=V+(p<<2)|0}}}}while(0);i:do if(N){if(!R){if(K)break;else{ya=j;za=N}while(1){ya=ya+-1|0;V=b[527367]|0;if(!(V<<16>>16))Aa=lle(1065353216)|0;else Aa=V;b[za>>1]=Aa;if(!ya)break i;else za=za+(o<<1)|0}}if(!K){V=j;W=N;U=R;while(1){V=V+-1|0;ja=ea(g[U>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){Ba=lle(ka)|0;break}else{Ba=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else Ba=0;while(0);b[W>>1]=Ba;if(!V)break;else{W=W+(o<<1)|0;U=U+(p<<2)|0}}}}while(0);j:do if(O){if(!S){if(K)break;else{Ca=j;Da=O}while(1){Ca=Ca+-1|0;U=b[527367]|0;if(!(U<<16>>16))Ea=lle(1065353216)|0;else Ea=U;b[Da>>1]=Ea;if(!Ca)break j;else Da=Da+(o<<1)|0}}if(!K){U=j;W=O;V=S;while(1){U=U+-1|0;ja=ea(g[V>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){Fa=lle(ka)|0;break}else{Fa=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else Fa=0;while(0);b[W>>1]=Fa;if(!U)break;else{W=W+(o<<1)|0;V=V+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Ga=j;Ha=P}while(1){Ga=Ga+-1|0;V=b[527367]|0;if(!(V<<16>>16))Ia=lle(1065353216)|0;else Ia=V;b[Ha>>1]=Ia;if(!Ga)break a;else Ha=Ha+(o<<1)|0}}if(K)break;else{Ja=j;Ka=P;La=T}while(1){Ja=Ja+-1|0;ja=ea(g[La>>2]);do if(!(ja==ea(0.0))){V=(g[k>>2]=ja,c[k>>2]|0);W=b[1054480+(V>>>23<<1)>>1]|0;if(!(W<<16>>16)){Ma=lle(V)|0;break}else{Ma=(W&65535)+(((V&8388607)+4096|0)>>>13)&65535;break}}else Ma=0;while(0);b[Ka>>1]=Ma;if(!Ja)break;else{Ka=Ka+(o<<1)|0;La=La+(p<<2)|0}}}else break}while(0);L=c[q>>2]|0;do if(L&536870912){V=c[s>>2]|0;k:do if(V&1073741824)if((t|0)==3){l:do if(M){if(!Q){if(K)break;else{Na=j;Oa=M}while(1){Na=Na+-1|0;g[Oa>>2]=ea(1.0);if(!Na)break l;else Oa=Oa+(o<<2)|0}}if(!K){W=j;U=M;ka=Q;while(1){W=W+-1|0;g[U>>2]=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);if(!W)break;else{U=U+(o<<2)|0;ka=ka+(p<<1)|0}}}}while(0);m:do if(N){if(!R){if(K)break;else{Pa=j;Qa=N}while(1){Pa=Pa+-1|0;g[Qa>>2]=ea(1.0);if(!Pa)break m;else Qa=Qa+(o<<2)|0}}if(!K){ka=j;U=N;W=R;while(1){ka=ka+-1|0;g[U>>2]=ea(g[792336+((e[W>>1]|0)<<2)>>2]);if(!ka)break;else{U=U+(o<<2)|0;W=W+(p<<1)|0}}}}while(0);n:do if(O){if(!S){if(K)break;else{Ra=j;Sa=O}while(1){Ra=Ra+-1|0;g[Sa>>2]=ea(1.0);if(!Ra)break n;else Sa=Sa+(o<<2)|0}}if(!K){W=j;U=O;ka=S;while(1){W=W+-1|0;g[U>>2]=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);if(!W)break;else{U=U+(o<<2)|0;ka=ka+(p<<1)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Ta=j;Ua=P}while(1){Ta=Ta+-1|0;g[Ua>>2]=ea(1.0);if(!Ta)break k;else Ua=Ua+(o<<2)|0}}if(K)break;ka=j;U=P;W=T;while(1){ka=ka+-1|0;g[U>>2]=ea(g[792336+((e[W>>1]|0)<<2)>>2]);if(!ka)break;else{U=U+(o<<2)|0;W=W+(p<<1)|0}}}else if(!t){o:do if(O){if(!S){if(K)break;else{Va=j;Wa=O}while(1){Va=Va+-1|0;g[Wa>>2]=ea(1.0);if(!Va)break o;else Wa=Wa+(o<<2)|0}}if(!K){W=j;U=O;ka=S;while(1){W=W+-1|0;g[U>>2]=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);if(!W)break;else{U=U+(o<<2)|0;ka=ka+(p<<1)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Xa=j;Ya=P}while(1){Xa=Xa+-1|0;g[Ya>>2]=ea(1.0);if(!Xa)break k;else Ya=Ya+(o<<2)|0}}if(K)break;ka=j;U=P;W=T;while(1){ka=ka+-1|0;g[U>>2]=ea(g[792336+((e[W>>1]|0)<<2)>>2]);if(!ka)break;else{U=U+(o<<2)|0;W=W+(p<<1)|0}}}else if((t|0)==1){if(K)break;W=j;U=P;ka=T;la=S;Za=R;_a=O;$a=Q;while(1){W=W+-1|0;if(!$a){ab=ea(.298999995);bb=0}else{ab=ea(ea(g[792336+((e[$a>>1]|0)<<2)>>2])*ea(.298999995));bb=$a+(p<<1)|0}if(!Za){cb=ea(.587000012);db=0}else{cb=ea(ea(g[792336+((e[Za>>1]|0)<<2)>>2])*ea(.587000012));db=Za+(p<<1)|0}if(!la){eb=ea(.114);fb=0}else{eb=ea(ea(g[792336+((e[la>>1]|0)<<2)>>2])*ea(.114));fb=la+(p<<1)|0}if(!ka){gb=ea(1.0);hb=0}else{gb=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);hb=ka+(p<<1)|0}if(!_a)ib=0;else{g[_a>>2]=ea(ab+ea(cb+eb));ib=_a+(o<<2)|0}if(!U)jb=0;else{g[U>>2]=gb;jb=U+(o<<2)|0}if(!W)break;else{U=jb;ka=hb;la=fb;Za=db;_a=ib;$a=bb}}}else if((t|0)==2){if(K)break;$a=j;_a=P;Za=T;la=O;ka=N;U=S;W=M;while(1){$a=$a+-1|0;if(!U){kb=ea(1.0);lb=0}else{kb=ea(g[792336+((e[U>>1]|0)<<2)>>2]);lb=U+(p<<1)|0}if(!Za){mb=ea(1.0);nb=0}else{mb=ea(g[792336+((e[Za>>1]|0)<<2)>>2]);nb=Za+(p<<1)|0}if(!W)ob=0;else{g[W>>2]=kb;ob=W+(o<<2)|0}if(!ka)pb=0;else{g[ka>>2]=kb;pb=ka+(o<<2)|0}if(!la)qb=0;else{g[la>>2]=kb;qb=la+(o<<2)|0}if(!_a)rb=0;else{g[_a>>2]=mb;rb=_a+(o<<2)|0}if(!$a)break;else{_a=rb;Za=nb;la=qb;ka=pb;U=lb;W=ob}}}else break;while(0);if(V&536870912)if((t|0)==2){if(K)break;W=j;U=P;ka=T;la=O;Za=N;_a=S;$a=M;while(1){W=W+-1|0;if(!_a){sb=ea(1.0);tb=0}else{sb=ea(g[_a>>2]);tb=_a+(p<<2)|0}if(!ka){ub=ea(1.0);vb=0}else{ub=ea(g[ka>>2]);vb=ka+(p<<2)|0}if(!$a)wb=0;else{g[$a>>2]=sb;wb=$a+(o<<2)|0}if(!Za)xb=0;else{g[Za>>2]=sb;xb=Za+(o<<2)|0}if(!la)yb=0;else{g[la>>2]=sb;yb=la+(o<<2)|0}if(!U)zb=0;else{g[U>>2]=ub;zb=U+(o<<2)|0}if(!W)break;else{U=zb;ka=vb;la=yb;Za=xb;_a=tb;$a=wb}}}else if((t|0)==3){do if(M)if(!Q){if(K)break;else{Ab=j;Bb=M}while(1){Ab=Ab+-1|0;g[Bb>>2]=ea(1.0);if(!Ab)break;else Bb=Bb+(o<<2)|0}}else{if(K)break;else{Cb=j;Db=M;Eb=Q}while(1){Cb=Cb+-1|0;g[Db>>2]=ea(g[Eb>>2]);if(!Cb)break;else{Db=Db+(o<<2)|0;Eb=Eb+(p<<2)|0}}}while(0);do if(N)if(!R){if(K)break;else{Fb=j;Gb=N}while(1){Fb=Fb+-1|0;g[Gb>>2]=ea(1.0);if(!Fb)break;else Gb=Gb+(o<<2)|0}}else{if(K)break;else{Hb=j;Ib=N;Jb=R}while(1){Hb=Hb+-1|0;g[Ib>>2]=ea(g[Jb>>2]);if(!Hb)break;else{Ib=Ib+(o<<2)|0;Jb=Jb+(p<<2)|0}}}while(0);do if(O)if(!S){if(K)break;else{Kb=j;Lb=O}while(1){Kb=Kb+-1|0;g[Lb>>2]=ea(1.0);if(!Kb)break;else Lb=Lb+(o<<2)|0}}else{if(K)break;else{Mb=j;Nb=O;Ob=S}while(1){Mb=Mb+-1|0;g[Nb>>2]=ea(g[Ob>>2]);if(!Mb)break;else{Nb=Nb+(o<<2)|0;Ob=Ob+(p<<2)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{Pb=j;Qb=P}while(1){Pb=Pb+-1|0;g[Qb>>2]=ea(1.0);if(!Pb)break;else Qb=Qb+(o<<2)|0}}else{if(K)break;else{Rb=j;Sb=P;Tb=T}while(1){Rb=Rb+-1|0;g[Sb>>2]=ea(g[Tb>>2]);if(!Rb)break;else{Sb=Sb+(o<<2)|0;Tb=Tb+(p<<2)|0}}}}else if(!t){do if(O)if(!S){if(K)break;else{Ub=j;Vb=O}while(1){Ub=Ub+-1|0;g[Vb>>2]=ea(1.0);if(!Ub)break;else Vb=Vb+(o<<2)|0}}else{if(K)break;else{Wb=j;Xb=O;Yb=S}while(1){Wb=Wb+-1|0;g[Xb>>2]=ea(g[Yb>>2]);if(!Wb)break;else{Xb=Xb+(o<<2)|0;Yb=Yb+(p<<2)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{Zb=j;_b=P}while(1){Zb=Zb+-1|0;g[_b>>2]=ea(1.0);if(!Zb)break;else _b=_b+(o<<2)|0}}else{if(K)break;else{$b=j;ac=P;bc=T}while(1){$b=$b+-1|0;g[ac>>2]=ea(g[bc>>2]);if(!$b)break;else{ac=ac+(o<<2)|0;bc=bc+(p<<2)|0}}}}else if((t|0)==1){if(K)break;$a=j;_a=P;Za=T;la=S;ka=R;U=O;W=Q;while(1){$a=$a+-1|0;if(!W){cc=ea(.298999995);dc=0}else{cc=ea(ea(g[W>>2])*ea(.298999995));dc=W+(p<<2)|0}if(!ka){ec=ea(.587000012);fc=0}else{ec=ea(ea(g[ka>>2])*ea(.587000012));fc=ka+(p<<2)|0}if(!la){gc=ea(.114);hc=0}else{gc=ea(ea(g[la>>2])*ea(.114));hc=la+(p<<2)|0}if(!Za){ic=ea(1.0);jc=0}else{ic=ea(g[Za>>2]);jc=Za+(p<<2)|0}if(!U)kc=0;else{g[U>>2]=ea(cc+ea(ec+gc));kc=U+(o<<2)|0}if(!_a)lc=0;else{g[_a>>2]=ic;lc=_a+(o<<2)|0}if(!$a)break;else{_a=lc;Za=jc;la=hc;ka=fc;U=kc;W=dc}}}else break}while(0);f=f+1|0;if((f|0)==(l|0))break;else{r=r+m|0;a=a+n|0}}i=h;return}function wle(a,f){a=a|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=Im,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=Im,Va=0,Wa=Im,Xa=0,Ya=Im,Za=0,_a=Im,$a=0,ab=0,bb=0,cb=Im,db=0,eb=Im,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=Im,Kb=0,Lb=Im,Mb=0,Nb=Im,Ob=0,Pb=Im,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=Im,$b=0,ac=Im,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0;h=i;j=c[a>>2]|0;l=c[a+4>>2]|0;m=c[a+8>>2]|0;n=c[f+8>>2]|0;o=((m>>>0)/(j>>>0)|0)>>>2;p=((n>>>0)/((c[f>>2]|0)>>>0)|0)>>>2;q=a+12|0;r=c[q>>2]|0;s=f+12|0;t=(c[s>>2]|0)>>>28&1|r>>>27&2;if(!l){i=h;return}u=a+38|0;v=a+37|0;w=a+36|0;x=a+39|0;y=a+16|0;z=a+20|0;A=a+24|0;B=a+28|0;C=f+38|0;D=f+37|0;E=f+36|0;F=f+39|0;G=f+16|0;H=f+20|0;I=f+24|0;J=f+28|0;K=(j|0)==0;L=r;r=c[a+40>>2]|0;a=c[f+40>>2]|0;f=0;while(1){M=(c[y>>2]|0)==0?0:r+((d[u>>0]|0)<<2)|0;N=(c[z>>2]|0)==0?0:r+((d[v>>0]|0)<<2)|0;O=(c[A>>2]|0)==0?0:r+((d[w>>0]|0)<<2)|0;P=(c[B>>2]|0)==0?0:r+((d[x>>0]|0)<<2)|0;Q=(c[G>>2]|0)==0?0:a+((d[C>>0]|0)<<2)|0;R=(c[H>>2]|0)==0?0:a+((d[D>>0]|0)<<2)|0;S=(c[I>>2]|0)==0?0:a+((d[E>>0]|0)<<2)|0;T=(c[J>>2]|0)==0?0:a+((d[F>>0]|0)<<2)|0;a:do if(L&1073741824){b:do if(c[s>>2]&1073741824)if((t|0)==3){c:do if(M){if(Q){if(K)break;U=j;V=M;W=Q;while(1){U=U+-1|0;b[V>>1]=b[W>>1]|0;if(!U)break c;else{V=V+(o<<1)|0;W=W+(p<<1)|0}}}if(!K){W=j;V=M;while(1){W=W+-1|0;U=b[527367]|0;if(!(U<<16>>16))X=lle(1065353216)|0;else X=U;b[V>>1]=X;if(!W)break;else V=V+(o<<1)|0}}}while(0);d:do if(N){if(R){if(K)break;V=j;W=N;U=R;while(1){V=V+-1|0;b[W>>1]=b[U>>1]|0;if(!V)break d;else{W=W+(o<<1)|0;U=U+(p<<1)|0}}}if(!K){U=j;W=N;while(1){U=U+-1|0;V=b[527367]|0;if(!(V<<16>>16))Y=lle(1065353216)|0;else Y=V;b[W>>1]=Y;if(!U)break;else W=W+(o<<1)|0}}}while(0);e:do if(O){if(S){if(K)break;W=j;U=O;V=S;while(1){W=W+-1|0;b[U>>1]=b[V>>1]|0;if(!W)break e;else{U=U+(o<<1)|0;V=V+(p<<1)|0}}}if(!K){V=j;U=O;while(1){V=V+-1|0;W=b[527367]|0;if(!(W<<16>>16))Z=lle(1065353216)|0;else Z=W;b[U>>1]=Z;if(!V)break;else U=U+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;U=j;V=P;W=T;while(1){U=U+-1|0;b[V>>1]=b[W>>1]|0;if(!U)break b;else{V=V+(o<<1)|0;W=W+(p<<1)|0}}}if(K)break;else{_=j;$=P}while(1){_=_+-1|0;W=b[527367]|0;if(!(W<<16>>16))aa=lle(1065353216)|0;else aa=W;b[$>>1]=aa;if(!_)break;else $=$+(o<<1)|0}}else if((t|0)==2){Cle(j,o,p,M,N,O,P,S,T);break}else if(!t){f:do if(O){if(S){if(K)break;W=j;V=O;U=S;while(1){W=W+-1|0;b[V>>1]=b[U>>1]|0;if(!W)break f;else{V=V+(o<<1)|0;U=U+(p<<1)|0}}}if(!K){U=j;V=O;while(1){U=U+-1|0;W=b[527367]|0;if(!(W<<16>>16))ba=lle(1065353216)|0;else ba=W;b[V>>1]=ba;if(!U)break;else V=V+(o<<1)|0}}}while(0);if(!P)break;if(T){if(K)break;V=j;U=P;W=T;while(1){V=V+-1|0;b[U>>1]=b[W>>1]|0;if(!V)break b;else{U=U+(o<<1)|0;W=W+(p<<1)|0}}}if(K)break;else{ca=j;da=P}while(1){ca=ca+-1|0;W=b[527367]|0;if(!(W<<16>>16))fa=lle(1065353216)|0;else fa=W;b[da>>1]=fa;if(!ca)break;else da=da+(o<<1)|0}}else if((t|0)==1){Ble(j,o,p,O,P,Q,R,S,T);break}else break;while(0);if(c[s>>2]&536870912)if(!t){g:do if(O){if(!S){if(K)break;else{ga=j;ha=O}while(1){ga=ga+-1|0;W=b[527367]|0;if(!(W<<16>>16))ia=lle(1065353216)|0;else ia=W;b[ha>>1]=ia;if(!ga)break g;else ha=ha+(o<<1)|0}}if(!K){W=j;U=O;V=S;while(1){W=W+-1|0;ja=ea(g[V>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){ma=lle(ka)|0;break}else{ma=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else ma=0;while(0);b[U>>1]=ma;if(!W)break;else{U=U+(o<<1)|0;V=V+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{na=j;oa=P}while(1){na=na+-1|0;V=b[527367]|0;if(!(V<<16>>16))pa=lle(1065353216)|0;else pa=V;b[oa>>1]=pa;if(!na)break a;else oa=oa+(o<<1)|0}}if(K)break;else{qa=j;ra=P;sa=T}while(1){qa=qa+-1|0;ja=ea(g[sa>>2]);do if(!(ja==ea(0.0))){V=(g[k>>2]=ja,c[k>>2]|0);U=b[1054480+(V>>>23<<1)>>1]|0;if(!(U<<16>>16)){ta=lle(V)|0;break}else{ta=(U&65535)+(((V&8388607)+4096|0)>>>13)&65535;break}}else ta=0;while(0);b[ra>>1]=ta;if(!qa)break;else{ra=ra+(o<<1)|0;sa=sa+(p<<2)|0}}}else if((t|0)==1){Dle(j,o,p,O,P,Q,R,S,T);break}else if((t|0)==2){Ele(j,o,p,M,N,O,P,S,T);break}else if((t|0)==3){h:do if(M){if(!Q){if(K)break;else{ua=j;va=M}while(1){ua=ua+-1|0;V=b[527367]|0;if(!(V<<16>>16))wa=lle(1065353216)|0;else wa=V;b[va>>1]=wa;if(!ua)break h;else va=va+(o<<1)|0}}if(!K){V=j;U=M;W=Q;while(1){V=V+-1|0;ja=ea(g[W>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){xa=lle(ka)|0;break}else{xa=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else xa=0;while(0);b[U>>1]=xa;if(!V)break;else{U=U+(o<<1)|0;W=W+(p<<2)|0}}}}while(0);i:do if(N){if(!R){if(K)break;else{ya=j;za=N}while(1){ya=ya+-1|0;W=b[527367]|0;if(!(W<<16>>16))Aa=lle(1065353216)|0;else Aa=W;b[za>>1]=Aa;if(!ya)break i;else za=za+(o<<1)|0}}if(!K){W=j;U=N;V=R;while(1){W=W+-1|0;ja=ea(g[V>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){Ba=lle(ka)|0;break}else{Ba=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else Ba=0;while(0);b[U>>1]=Ba;if(!W)break;else{U=U+(o<<1)|0;V=V+(p<<2)|0}}}}while(0);j:do if(O){if(!S){if(K)break;else{Ca=j;Da=O}while(1){Ca=Ca+-1|0;V=b[527367]|0;if(!(V<<16>>16))Ea=lle(1065353216)|0;else Ea=V;b[Da>>1]=Ea;if(!Ca)break j;else Da=Da+(o<<1)|0}}if(!K){V=j;U=O;W=S;while(1){V=V+-1|0;ja=ea(g[W>>2]);do if(!(ja==ea(0.0))){ka=(g[k>>2]=ja,c[k>>2]|0);la=b[1054480+(ka>>>23<<1)>>1]|0;if(!(la<<16>>16)){Fa=lle(ka)|0;break}else{Fa=(la&65535)+(((ka&8388607)+4096|0)>>>13)&65535;break}}else Fa=0;while(0);b[U>>1]=Fa;if(!V)break;else{U=U+(o<<1)|0;W=W+(p<<2)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Ga=j;Ha=P}while(1){Ga=Ga+-1|0;W=b[527367]|0;if(!(W<<16>>16))Ia=lle(1065353216)|0;else Ia=W;b[Ha>>1]=Ia;if(!Ga)break a;else Ha=Ha+(o<<1)|0}}if(K)break;else{Ja=j;Ka=P;La=T}while(1){Ja=Ja+-1|0;ja=ea(g[La>>2]);do if(!(ja==ea(0.0))){W=(g[k>>2]=ja,c[k>>2]|0);U=b[1054480+(W>>>23<<1)>>1]|0;if(!(U<<16>>16)){Ma=lle(W)|0;break}else{Ma=(U&65535)+(((W&8388607)+4096|0)>>>13)&65535;break}}else Ma=0;while(0);b[Ka>>1]=Ma;if(!Ja)break;else{Ka=Ka+(o<<1)|0;La=La+(p<<2)|0}}}else break}while(0);L=c[q>>2]|0;do if(L&536870912){W=c[s>>2]|0;k:do if(W&1073741824)if(!t){l:do if(O){if(!S){if(K)break;else{Na=j;Oa=O}while(1){Na=Na+-1|0;g[Oa>>2]=ea(1.0);if(!Na)break l;else Oa=Oa+(o<<2)|0}}if(!K){U=j;V=O;ka=S;while(1){U=U+-1|0;g[V>>2]=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);if(!U)break;else{V=V+(o<<2)|0;ka=ka+(p<<1)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{Pa=j;Qa=P}while(1){Pa=Pa+-1|0;g[Qa>>2]=ea(1.0);if(!Pa)break k;else Qa=Qa+(o<<2)|0}}if(K)break;ka=j;V=P;U=T;while(1){ka=ka+-1|0;g[V>>2]=ea(g[792336+((e[U>>1]|0)<<2)>>2]);if(!ka)break;else{V=V+(o<<2)|0;U=U+(p<<1)|0}}}else if((t|0)==1){if(K)break;U=j;V=P;ka=T;la=S;Ra=R;Sa=O;Ta=Q;while(1){U=U+-1|0;if(!Ta){Ua=ea(.298999995);Va=0}else{Ua=ea(ea(g[792336+((e[Ta>>1]|0)<<2)>>2])*ea(.298999995));Va=Ta+(p<<1)|0}if(!Ra){Wa=ea(.587000012);Xa=0}else{Wa=ea(ea(g[792336+((e[Ra>>1]|0)<<2)>>2])*ea(.587000012));Xa=Ra+(p<<1)|0}if(!la){Ya=ea(.114);Za=0}else{Ya=ea(ea(g[792336+((e[la>>1]|0)<<2)>>2])*ea(.114));Za=la+(p<<1)|0}if(!ka){_a=ea(1.0);$a=0}else{_a=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);$a=ka+(p<<1)|0}if(!Sa)ab=0;else{g[Sa>>2]=ea(Ua+ea(Wa+Ya));ab=Sa+(o<<2)|0}if(!V)bb=0;else{g[V>>2]=_a;bb=V+(o<<2)|0}if(!U)break;else{V=bb;ka=$a;la=Za;Ra=Xa;Sa=ab;Ta=Va}}}else if((t|0)==2){if(K)break;Ta=j;Sa=P;Ra=T;la=O;ka=N;V=S;U=M;while(1){Ta=Ta+-1|0;if(!V){cb=ea(1.0);db=0}else{cb=ea(g[792336+((e[V>>1]|0)<<2)>>2]);db=V+(p<<1)|0}if(!Ra){eb=ea(1.0);fb=0}else{eb=ea(g[792336+((e[Ra>>1]|0)<<2)>>2]);fb=Ra+(p<<1)|0}if(!U)gb=0;else{g[U>>2]=cb;gb=U+(o<<2)|0}if(!ka)hb=0;else{g[ka>>2]=cb;hb=ka+(o<<2)|0}if(!la)ib=0;else{g[la>>2]=cb;ib=la+(o<<2)|0}if(!Sa)jb=0;else{g[Sa>>2]=eb;jb=Sa+(o<<2)|0}if(!Ta)break;else{Sa=jb;Ra=fb;la=ib;ka=hb;V=db;U=gb}}}else if((t|0)==3){m:do if(M){if(!Q){if(K)break;else{kb=j;lb=M}while(1){kb=kb+-1|0;g[lb>>2]=ea(1.0);if(!kb)break m;else lb=lb+(o<<2)|0}}if(!K){U=j;V=M;ka=Q;while(1){U=U+-1|0;g[V>>2]=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);if(!U)break;else{V=V+(o<<2)|0;ka=ka+(p<<1)|0}}}}while(0);n:do if(N){if(!R){if(K)break;else{mb=j;nb=N}while(1){mb=mb+-1|0;g[nb>>2]=ea(1.0);if(!mb)break n;else nb=nb+(o<<2)|0}}if(!K){ka=j;V=N;U=R;while(1){ka=ka+-1|0;g[V>>2]=ea(g[792336+((e[U>>1]|0)<<2)>>2]);if(!ka)break;else{V=V+(o<<2)|0;U=U+(p<<1)|0}}}}while(0);o:do if(O){if(!S){if(K)break;else{ob=j;pb=O}while(1){ob=ob+-1|0;g[pb>>2]=ea(1.0);if(!ob)break o;else pb=pb+(o<<2)|0}}if(!K){U=j;V=O;ka=S;while(1){U=U+-1|0;g[V>>2]=ea(g[792336+((e[ka>>1]|0)<<2)>>2]);if(!U)break;else{V=V+(o<<2)|0;ka=ka+(p<<1)|0}}}}while(0);if(!P)break;if(!T){if(K)break;else{qb=j;rb=P}while(1){qb=qb+-1|0;g[rb>>2]=ea(1.0);if(!qb)break k;else rb=rb+(o<<2)|0}}if(K)break;ka=j;V=P;U=T;while(1){ka=ka+-1|0;g[V>>2]=ea(g[792336+((e[U>>1]|0)<<2)>>2]);if(!ka)break;else{V=V+(o<<2)|0;U=U+(p<<1)|0}}}else break;while(0);if(W&536870912)if(!t){do if(O)if(!S){if(K)break;else{sb=j;tb=O}while(1){sb=sb+-1|0;g[tb>>2]=ea(1.0);if(!sb)break;else tb=tb+(o<<2)|0}}else{if(K)break;else{ub=j;vb=O;wb=S}while(1){ub=ub+-1|0;g[vb>>2]=ea(g[wb>>2]);if(!ub)break;else{vb=vb+(o<<2)|0;wb=wb+(p<<2)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{xb=j;yb=P}while(1){xb=xb+-1|0;g[yb>>2]=ea(1.0);if(!xb)break;else yb=yb+(o<<2)|0}}else{if(K)break;else{zb=j;Ab=P;Bb=T}while(1){zb=zb+-1|0;g[Ab>>2]=ea(g[Bb>>2]);if(!zb)break;else{Ab=Ab+(o<<2)|0;Bb=Bb+(p<<2)|0}}}}else if((t|0)==1){if(K)break;else{Cb=j;Db=P;Eb=T;Fb=S;Gb=R;Hb=O;Ib=Q}while(1){Cb=Cb+-1|0;if(!Ib){Jb=ea(.298999995);Kb=0}else{Jb=ea(ea(g[Ib>>2])*ea(.298999995));Kb=Ib+(p<<2)|0}if(!Gb){Lb=ea(.587000012);Mb=0}else{Lb=ea(ea(g[Gb>>2])*ea(.587000012));Mb=Gb+(p<<2)|0}if(!Fb){Nb=ea(.114);Ob=0}else{Nb=ea(ea(g[Fb>>2])*ea(.114));Ob=Fb+(p<<2)|0}if(!Eb){Pb=ea(1.0);Qb=0}else{Pb=ea(g[Eb>>2]);Qb=Eb+(p<<2)|0}if(!Hb)Rb=0;else{g[Hb>>2]=ea(Jb+ea(Lb+Nb));Rb=Hb+(o<<2)|0}if(!Db)Sb=0;else{g[Db>>2]=Pb;Sb=Db+(o<<2)|0}if(!Cb)break;else{Db=Sb;Eb=Qb;Fb=Ob;Gb=Mb;Hb=Rb;Ib=Kb}}}else if((t|0)==2){if(K)break;else{Tb=j;Ub=P;Vb=T;Wb=O;Xb=N;Yb=S;Zb=M}while(1){Tb=Tb+-1|0;if(!Yb){_b=ea(1.0);$b=0}else{_b=ea(g[Yb>>2]);$b=Yb+(p<<2)|0}if(!Vb){ac=ea(1.0);bc=0}else{ac=ea(g[Vb>>2]);bc=Vb+(p<<2)|0}if(!Zb)cc=0;else{g[Zb>>2]=_b;cc=Zb+(o<<2)|0}if(!Xb)dc=0;else{g[Xb>>2]=_b;dc=Xb+(o<<2)|0}if(!Wb)ec=0;else{g[Wb>>2]=_b;ec=Wb+(o<<2)|0}if(!Ub)fc=0;else{g[Ub>>2]=ac;fc=Ub+(o<<2)|0}if(!Tb)break;else{Ub=fc;Vb=bc;Wb=ec;Xb=dc;Yb=$b;Zb=cc}}}else if((t|0)==3){do if(M)if(!Q){if(K)break;else{gc=j;hc=M}while(1){gc=gc+-1|0;g[hc>>2]=ea(1.0);if(!gc)break;else hc=hc+(o<<2)|0}}else{if(K)break;else{ic=j;jc=M;kc=Q}while(1){ic=ic+-1|0;g[jc>>2]=ea(g[kc>>2]);if(!ic)break;else{jc=jc+(o<<2)|0;kc=kc+(p<<2)|0}}}while(0);do if(N)if(!R){if(K)break;else{lc=j;mc=N}while(1){lc=lc+-1|0;g[mc>>2]=ea(1.0);if(!lc)break;else mc=mc+(o<<2)|0}}else{if(K)break;else{nc=j;oc=N;pc=R}while(1){nc=nc+-1|0;g[oc>>2]=ea(g[pc>>2]);if(!nc)break;else{oc=oc+(o<<2)|0;pc=pc+(p<<2)|0}}}while(0);do if(O)if(!S){if(K)break;else{qc=j;rc=O}while(1){qc=qc+-1|0;g[rc>>2]=ea(1.0);if(!qc)break;else rc=rc+(o<<2)|0}}else{if(K)break;else{sc=j;tc=O;uc=S}while(1){sc=sc+-1|0;g[tc>>2]=ea(g[uc>>2]);if(!sc)break;else{tc=tc+(o<<2)|0;uc=uc+(p<<2)|0}}}while(0);if(!P)break;if(!T){if(K)break;else{vc=j;wc=P}while(1){vc=vc+-1|0;g[wc>>2]=ea(1.0);if(!vc)break;else wc=wc+(o<<2)|0}}else{if(K)break;else{xc=j;yc=P;zc=T}while(1){xc=xc+-1|0;g[yc>>2]=ea(g[zc>>2]);if(!xc)break;else{yc=yc+(o<<2)|0;zc=zc+(p<<2)|0}}}}else break}while(0);f=f+1|0;if((f|0)==(l|0))break;else{r=r+m|0;a=a+n|0}}i=h;return}function xle(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0;f=i;h=c[b+40>>2]|0;j=c[e+40>>2]|0;k=c[b>>2]|0;l=c[b+4>>2]|0;m=c[b+8>>2]|0;n=c[e+8>>2]|0;o=((m>>>0)/(k>>>0)|0)>>>2;p=(c[e+12>>2]|0)>>>3&8191;q=(c[b+16>>2]|0)==0;r=(c[b+20>>2]|0)==0;s=(c[b+24>>2]|0)!=0;t=(c[b+28>>2]|0)!=0;u=(c[e+16>>2]|0)!=0;v=(c[e+20>>2]|0)!=0;w=(c[e+24>>2]|0)!=0;x=(c[e+28>>2]|0)!=0;y=c[b+12>>2]|0;if(!(y&268435456)){if((y&134217728|0)==0|(l|0)==0){i=f;return}y=e+38|0;z=e+37|0;A=e+36|0;B=e+39|0;C=b+36|0;D=b+39|0;E=(k|0)==0;F=h;G=j;H=0;while(1){if(!E){I=F+((d[D>>0]|0)<<2)|0;J=G+((d[B>>0]|0)>>>3)|0;K=F+((d[C>>0]|0)<<2)|0;L=G+((d[A>>0]|0)>>>3)|0;M=G+((d[z>>0]|0)>>>3)|0;N=G+((d[y>>0]|0)>>>3)|0;O=0;while(1){if(u){P=a[N>>0]|0;Q=N+p|0}else{P=-1;Q=N}if(v){R=a[M>>0]|0;S=M+p|0}else{R=-1;S=M}if(w){T=a[L>>0]|0;U=L+p|0}else{T=-1;U=L}if(x){V=a[J>>0]|0;W=J+p|0}else{V=-1;W=J}if(s){g[K>>2]=ea(ea(ea(ea(P&255|0)/ea(255.0))*ea(.298999995))+ea(ea(ea(ea(R&255|0)/ea(255.0))*ea(.587000012))+ea(ea(ea(T&255|0)/ea(255.0))*ea(.114))));X=K+(o<<2)|0}else X=K;if(t){g[I>>2]=ea(ea(V&255|0)/ea(255.0));Y=I+(o<<2)|0}else Y=I;O=O+1|0;if((O|0)==(k|0))break;else{I=Y;J=W;K=X;L=U;M=S;N=Q}}}H=H+1|0;if((H|0)==(l|0))break;else{F=F+m|0;G=G+n|0}}i=f;return}if(!l){i=f;return}G=e+38|0;F=e+37|0;H=e+36|0;Q=e+39|0;e=b+38|0;S=b+37|0;U=b+36|0;X=b+39|0;b=(k|0)==0;W=h;h=j;j=0;while(1){if(!b){Y=W+((d[X>>0]|0)<<2)|0;V=h+((d[Q>>0]|0)>>>3)|0;T=W+((d[U>>0]|0)<<2)|0;R=h+((d[H>>0]|0)>>>3)|0;P=W+((d[S>>0]|0)<<2)|0;y=h+((d[F>>0]|0)>>>3)|0;z=W+((d[e>>0]|0)<<2)|0;A=h+((d[G>>0]|0)>>>3)|0;C=0;while(1){if(u){Z=a[A>>0]|0;_=A+p|0}else{Z=-1;_=A}if(v){$=a[y>>0]|0;aa=y+p|0}else{$=-1;aa=y}if(w){ba=a[R>>0]|0;ca=R+p|0}else{ba=-1;ca=R}if(x){da=a[V>>0]|0;fa=V+p|0}else{da=-1;fa=V}if(q)ga=z;else{g[z>>2]=ea(ea(Z&255|0)*ea(.00392156886));ga=z+(o<<2)|0}if(r)ha=P;else{g[P>>2]=ea(ea($&255|0)*ea(.00392156886));ha=P+(o<<2)|0}if(s){g[T>>2]=ea(ea(ba&255|0)*ea(.00392156886));ia=T+(o<<2)|0}else ia=T;if(t){g[Y>>2]=ea(ea(da&255|0)*ea(.00392156886));ja=Y+(o<<2)|0}else ja=Y;C=C+1|0;if((C|0)==(k|0))break;else{Y=ja;V=fa;T=ia;R=ca;P=ha;y=aa;z=ga;A=_}}}j=j+1|0;if((j|0)==(l|0))break;else{W=W+m|0;h=h+n|0}}i=f;return}function yle(e,f){e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;h=i;j=c[e+40>>2]|0;l=c[f+40>>2]|0;m=c[e>>2]|0;n=c[e+4>>2]|0;o=c[e+8>>2]|0;p=c[f+8>>2]|0;q=((o>>>0)/(m>>>0)|0)>>>1;r=(c[f+12>>2]|0)>>>3&8191;s=(c[e+16>>2]|0)==0;t=(c[e+20>>2]|0)==0;u=(c[e+24>>2]|0)!=0;v=(c[e+28>>2]|0)!=0;w=(c[f+16>>2]|0)!=0;x=(c[f+20>>2]|0)!=0;y=(c[f+24>>2]|0)!=0;z=(c[f+28>>2]|0)!=0;A=c[e+12>>2]|0;if(!(A&268435456)){if((A&134217728|0)==0|(n|0)==0){i=h;return}A=f+38|0;B=f+37|0;C=f+36|0;D=f+39|0;E=e+36|0;F=e+39|0;G=(m|0)==0;H=j;I=l;J=0;while(1){if(!G){K=H+((d[F>>0]|0)<<1)|0;L=I+((d[D>>0]|0)>>>3)|0;M=H+((d[E>>0]|0)<<1)|0;N=I+((d[C>>0]|0)>>>3)|0;O=I+((d[B>>0]|0)>>>3)|0;P=I+((d[A>>0]|0)>>>3)|0;Q=0;while(1){if(w){R=a[P>>0]|0;S=P+r|0}else{R=-1;S=P}if(x){T=a[O>>0]|0;U=O+r|0}else{T=-1;U=O}if(y){V=a[N>>0]|0;W=N+r|0}else{V=-1;W=N}if(z){X=a[L>>0]|0;Y=L+r|0}else{X=-1;Y=L}if(u){Z=ea(ea(ea(ea(R&255|0)/ea(255.0))*ea(.298999995))+ea(ea(ea(ea(T&255|0)/ea(255.0))*ea(.587000012))+ea(ea(ea(V&255|0)/ea(255.0))*ea(.114))));do if(!(Z==ea(0.0))){_=(g[k>>2]=Z,c[k>>2]|0);$=b[1054480+(_>>>23<<1)>>1]|0;if(!($<<16>>16)){aa=lle(_)|0;break}else{aa=($&65535)+(((_&8388607)+4096|0)>>>13)&65535;break}}else aa=0;while(0);b[M>>1]=aa;ba=M+(q<<1)|0}else ba=M;if(v){Z=ea(ea(X&255|0)/ea(255.0));do if(!(Z==ea(0.0))){_=(g[k>>2]=Z,c[k>>2]|0);$=b[1054480+(_>>>23<<1)>>1]|0;if(!($<<16>>16)){ca=lle(_)|0;break}else{ca=($&65535)+(((_&8388607)+4096|0)>>>13)&65535;break}}else ca=0;while(0);b[K>>1]=ca;da=K+(q<<1)|0}else da=K;Q=Q+1|0;if((Q|0)==(m|0))break;else{K=da;L=Y;M=ba;N=W;O=U;P=S}}}J=J+1|0;if((J|0)==(n|0))break;else{H=H+o|0;I=I+p|0}}i=h;return}if(!n){i=h;return}I=f+38|0;H=f+37|0;J=f+36|0;S=f+39|0;f=e+38|0;U=e+37|0;W=e+36|0;ba=e+39|0;e=(m|0)==0;Y=j;j=l;l=0;while(1){if(!e){da=Y+((d[ba>>0]|0)<<1)|0;ca=j+((d[S>>0]|0)>>>3)|0;X=Y+((d[W>>0]|0)<<1)|0;aa=j+((d[J>>0]|0)>>>3)|0;V=Y+((d[U>>0]|0)<<1)|0;T=j+((d[H>>0]|0)>>>3)|0;R=Y+((d[f>>0]|0)<<1)|0;A=j+((d[I>>0]|0)>>>3)|0;B=0;while(1){if(w){fa=a[A>>0]|0;ga=A+r|0}else{fa=-1;ga=A}if(x){ha=a[T>>0]|0;ia=T+r|0}else{ha=-1;ia=T}if(y){ja=a[aa>>0]|0;ka=aa+r|0}else{ja=-1;ka=aa}if(z){la=a[ca>>0]|0;ma=ca+r|0}else{la=-1;ma=ca}if(s)na=R;else{Z=ea(ea(fa&255|0)*ea(.00392156886));do if(!(Z==ea(0.0))){C=(g[k>>2]=Z,c[k>>2]|0);E=b[1054480+(C>>>23<<1)>>1]|0;if(!(E<<16>>16)){oa=lle(C)|0;break}else{oa=(E&65535)+(((C&8388607)+4096|0)>>>13)&65535;break}}else oa=0;while(0);b[R>>1]=oa;na=R+(q<<1)|0}if(t)pa=V;else{Z=ea(ea(ha&255|0)*ea(.00392156886));do if(!(Z==ea(0.0))){C=(g[k>>2]=Z,c[k>>2]|0);E=b[1054480+(C>>>23<<1)>>1]|0;if(!(E<<16>>16)){qa=lle(C)|0;break}else{qa=(E&65535)+(((C&8388607)+4096|0)>>>13)&65535;break}}else qa=0;while(0);b[V>>1]=qa;pa=V+(q<<1)|0}if(u){Z=ea(ea(ja&255|0)*ea(.00392156886));do if(!(Z==ea(0.0))){C=(g[k>>2]=Z,c[k>>2]|0);E=b[1054480+(C>>>23<<1)>>1]|0;if(!(E<<16>>16)){ra=lle(C)|0;break}else{ra=(E&65535)+(((C&8388607)+4096|0)>>>13)&65535;break}}else ra=0;while(0);b[X>>1]=ra;sa=X+(q<<1)|0}else sa=X;if(v){Z=ea(ea(la&255|0)*ea(.00392156886));do if(!(Z==ea(0.0))){C=(g[k>>2]=Z,c[k>>2]|0);E=b[1054480+(C>>>23<<1)>>1]|0;if(!(E<<16>>16)){ta=lle(C)|0;break}else{ta=(E&65535)+(((C&8388607)+4096|0)>>>13)&65535;break}}else ta=0;while(0);b[da>>1]=ta;ua=da+(q<<1)|0}else ua=da;B=B+1|0;if((B|0)==(m|0))break;else{da=ua;ca=ma;X=sa;aa=ka;V=pa;T=ia;R=na;A=ga}}}l=l+1|0;if((l|0)==(n|0))break;else{Y=Y+o|0;j=j+p|0}}i=h;return}function zle(b,f){b=b|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=Im,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;h=i;j=c[b+40>>2]|0;k=c[f+40>>2]|0;l=c[b>>2]|0;m=c[b+4>>2]|0;n=c[b+8>>2]|0;o=c[f+8>>2]|0;p=((o>>>0)/((c[f>>2]|0)>>>0)|0)>>>1;q=(c[b+12>>2]|0)>>>3&8191;r=(c[b+16>>2]|0)!=0;s=(c[b+20>>2]|0)!=0;t=(c[b+24>>2]|0)!=0;u=(c[b+28>>2]|0)!=0;v=(c[f+16>>2]|0)==0;w=(c[f+20>>2]|0)==0;x=(c[f+24>>2]|0)!=0;y=(c[f+28>>2]|0)!=0;z=c[f+12>>2]|0;if(!(z&268435456)){if((z&134217728|0)==0|(m|0)==0){i=h;return}z=b+38|0;A=b+37|0;B=b+36|0;C=b+39|0;D=f+36|0;E=f+39|0;F=(l|0)==0;G=j;H=k;I=0;while(1){if(!F){J=G+((d[C>>0]|0)>>>3)|0;K=H+((d[E>>0]|0)<<1)|0;L=G+((d[B>>0]|0)>>>3)|0;M=H+((d[D>>0]|0)<<1)|0;N=G+((d[A>>0]|0)>>>3)|0;O=G+((d[z>>0]|0)>>>3)|0;P=0;while(1){if(x){Q=~~ea(ea(ea(g[792336+((e[M>>1]|0)<<2)>>2])*ea(255.0))+ea(.5))&255;R=M+(p<<1)|0}else{Q=-1;R=M}if(y){S=~~ea(ea(ea(g[792336+((e[K>>1]|0)<<2)>>2])*ea(255.0))+ea(.5))&255;T=K+(p<<1)|0}else{S=-1;T=K}if(r){a[O>>0]=Q;U=O+q|0}else U=O;if(s){a[N>>0]=Q;V=N+q|0}else V=N;if(t){a[L>>0]=Q;W=L+q|0}else W=L;if(u){a[J>>0]=S;X=J+q|0}else X=J;P=P+1|0;if((P|0)==(l|0))break;else{J=X;K=T;L=W;M=R;N=V;O=U}}}I=I+1|0;if((I|0)==(m|0))break;else{G=G+n|0;H=H+o|0}}i=h;return}if(!m){i=h;return}H=b+38|0;G=b+37|0;I=b+36|0;U=b+39|0;b=f+38|0;V=f+37|0;R=f+36|0;W=f+39|0;f=(l|0)==0;T=j;j=k;k=0;while(1){if(!f){X=T+((d[U>>0]|0)>>>3)|0;S=j+((d[W>>0]|0)<<1)|0;Q=T+((d[I>>0]|0)>>>3)|0;z=j+((d[R>>0]|0)<<1)|0;A=T+((d[G>>0]|0)>>>3)|0;D=j+((d[V>>0]|0)<<1)|0;B=T+((d[H>>0]|0)>>>3)|0;E=j+((d[b>>0]|0)<<1)|0;C=0;while(1){if(v){Y=-1;Z=E}else{_=ea(g[792336+((e[E>>1]|0)<<2)>>2]);if(_<ea(0.0))$=0;else{F=_>ea(1.0);O=~~ea(ea(_*ea(255.0))+ea(.5))&255;$=F?-1:O}Y=$;Z=E+(p<<1)|0}if(w){aa=-1;ba=D}else{_=ea(g[792336+((e[D>>1]|0)<<2)>>2]);if(_<ea(0.0))ca=0;else{O=_>ea(1.0);F=~~ea(ea(_*ea(255.0))+ea(.5))&255;ca=O?-1:F}aa=ca;ba=D+(p<<1)|0}if(x){_=ea(g[792336+((e[z>>1]|0)<<2)>>2]);if(_<ea(0.0))da=0;else{F=_>ea(1.0);O=~~ea(ea(_*ea(255.0))+ea(.5))&255;da=F?-1:O}fa=da;ga=z+(p<<1)|0}else{fa=-1;ga=z}if(y){_=ea(g[792336+((e[S>>1]|0)<<2)>>2]);if(_<ea(0.0))ha=0;else{O=_>ea(1.0);F=~~ea(ea(_*ea(255.0))+ea(.5))&255;ha=O?-1:F}ia=ha;ja=S+(p<<1)|0}else{ia=-1;ja=S}if(r){a[B>>0]=Y;ka=B+q|0}else ka=B;if(s){a[A>>0]=aa;la=A+q|0}else la=A;if(t){a[Q>>0]=fa;ma=Q+q|0}else ma=Q;if(u){a[X>>0]=ia;na=X+q|0}else na=X;C=C+1|0;if((C|0)==(l|0))break;else{X=na;S=ja;Q=ma;z=ga;A=la;D=ba;B=ka;E=Z}}}k=k+1|0;if((k|0)==(m|0))break;else{T=T+n|0;j=j+o|0}}i=h;return}function Ale(b,e){b=b|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=Im,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;f=i;h=c[b+40>>2]|0;j=c[e+40>>2]|0;k=c[b>>2]|0;l=c[b+4>>2]|0;m=c[b+8>>2]|0;n=c[e+8>>2]|0;o=((n>>>0)/((c[e>>2]|0)>>>0)|0)>>>2;p=(c[b+12>>2]|0)>>>3&8191;q=(c[b+16>>2]|0)!=0;r=(c[b+20>>2]|0)!=0;s=(c[b+24>>2]|0)!=0;t=(c[b+28>>2]|0)!=0;u=(c[e+16>>2]|0)==0;v=(c[e+20>>2]|0)==0;w=(c[e+24>>2]|0)!=0;x=(c[e+28>>2]|0)!=0;y=c[e+12>>2]|0;if(!(y&268435456)){if((y&134217728|0)==0|(l|0)==0){i=f;return}y=b+38|0;z=b+37|0;A=b+36|0;B=b+39|0;C=e+36|0;D=e+39|0;E=(k|0)==0;F=h;G=j;H=0;while(1){if(!E){I=F+((d[B>>0]|0)>>>3)|0;J=G+((d[D>>0]|0)<<2)|0;K=F+((d[A>>0]|0)>>>3)|0;L=G+((d[C>>0]|0)<<2)|0;M=F+((d[z>>0]|0)>>>3)|0;N=F+((d[y>>0]|0)>>>3)|0;O=0;while(1){if(w){P=~~ea(ea(ea(g[L>>2])*ea(255.0))+ea(.5))&255;Q=L+(o<<2)|0}else{P=-1;Q=L}if(x){R=~~ea(ea(ea(g[J>>2])*ea(255.0))+ea(.5))&255;S=J+(o<<2)|0}else{R=-1;S=J}if(q){a[N>>0]=P;T=N+p|0}else T=N;if(r){a[M>>0]=P;U=M+p|0}else U=M;if(s){a[K>>0]=P;V=K+p|0}else V=K;if(t){a[I>>0]=R;W=I+p|0}else W=I;O=O+1|0;if((O|0)==(k|0))break;else{I=W;J=S;K=V;L=Q;M=U;N=T}}}H=H+1|0;if((H|0)==(l|0))break;else{F=F+m|0;G=G+n|0}}i=f;return}if(!l){i=f;return}G=b+38|0;F=b+37|0;H=b+36|0;T=b+39|0;b=e+38|0;U=e+37|0;Q=e+36|0;V=e+39|0;e=(k|0)==0;S=h;h=j;j=0;while(1){if(!e){W=S+((d[T>>0]|0)>>>3)|0;R=h+((d[V>>0]|0)<<2)|0;P=S+((d[H>>0]|0)>>>3)|0;y=h+((d[Q>>0]|0)<<2)|0;z=S+((d[F>>0]|0)>>>3)|0;C=h+((d[U>>0]|0)<<2)|0;A=S+((d[G>>0]|0)>>>3)|0;D=h+((d[b>>0]|0)<<2)|0;B=0;while(1){if(u){X=-1;Y=D}else{Z=ea(g[D>>2]);if(Z<ea(0.0))_=0;else{E=Z>ea(1.0);N=~~ea(ea(Z*ea(255.0))+ea(.5))&255;_=E?-1:N}X=_;Y=D+(o<<2)|0}if(v){$=-1;aa=C}else{Z=ea(g[C>>2]);if(Z<ea(0.0))ba=0;else{N=Z>ea(1.0);E=~~ea(ea(Z*ea(255.0))+ea(.5))&255;ba=N?-1:E}$=ba;aa=C+(o<<2)|0}if(w){Z=ea(g[y>>2]);if(Z<ea(0.0))ca=0;else{E=Z>ea(1.0);N=~~ea(ea(Z*ea(255.0))+ea(.5))&255;ca=E?-1:N}da=ca;fa=y+(o<<2)|0}else{da=-1;fa=y}if(x){Z=ea(g[R>>2]);if(Z<ea(0.0))ga=0;else{N=Z>ea(1.0);E=~~ea(ea(Z*ea(255.0))+ea(.5))&255;ga=N?-1:E}ha=ga;ia=R+(o<<2)|0}else{ha=-1;ia=R}if(q){a[A>>0]=X;ja=A+p|0}else ja=A;if(r){a[z>>0]=$;ka=z+p|0}else ka=z;if(s){a[P>>0]=da;la=P+p|0}else la=P;if(t){a[W>>0]=ha;ma=W+p|0}else ma=W;B=B+1|0;if((B|0)==(k|0))break;else{W=ma;R=ia;P=la;y=fa;z=ka;C=aa;A=ja;D=Y}}}j=j+1|0;if((j|0)==(l|0))break;else{S=S+m|0;h=h+n|0}}i=f;return}function Ble(a,d,f,h,j,l,m,n,o){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=0,A=Im,B=0,C=0,D=0,E=0;p=i;if(!a){i=p;return}q=a;a=j;j=o;o=n;n=m;m=h;h=l;while(1){q=q+-1|0;if(!h){r=ea(.298999995);s=0}else{r=ea(ea(g[792336+((e[h>>1]|0)<<2)>>2])*ea(.298999995));s=h+(f<<1)|0}if(!n){t=ea(.587000012);u=0}else{t=ea(ea(g[792336+((e[n>>1]|0)<<2)>>2])*ea(.587000012));u=n+(f<<1)|0}if(!o){v=ea(.114);w=0}else{v=ea(ea(g[792336+((e[o>>1]|0)<<2)>>2])*ea(.114));w=o+(f<<1)|0}if(!j){x=ea(1.0);y=0}else{x=ea(g[792336+((e[j>>1]|0)<<2)>>2]);y=j+(f<<1)|0}if(!m)z=0;else{A=ea(r+ea(t+v));do if(!(A==ea(0.0))){l=(g[k>>2]=A,c[k>>2]|0);B=b[1054480+(l>>>23<<1)>>1]|0;if(!(B<<16>>16)){C=lle(l)|0;break}else{C=(B&65535)+(((l&8388607)+4096|0)>>>13)&65535;break}}else C=0;while(0);b[m>>1]=C;z=m+(d<<1)|0}if(!a)D=0;else{do if(!(x==ea(0.0))){l=(g[k>>2]=x,c[k>>2]|0);B=b[1054480+(l>>>23<<1)>>1]|0;if(!(B<<16>>16)){E=lle(l)|0;break}else{E=(B&65535)+(((l&8388607)+4096|0)>>>13)&65535;break}}else E=0;while(0);b[a>>1]=E;D=a+(d<<1)|0}if(!q)break;else{a=D;j=y;o=w;n=u;m=z;h=s}}i=p;return}function Cle(a,d,f,h,j,l,m,n,o){a=a|0;d=d|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=Im,s=0,t=Im,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;p=i;if(!a){i=p;return}q=a;a=m;m=o;o=l;l=j;j=n;n=h;while(1){q=q+-1|0;if(!j){r=ea(1.0);s=0}else{r=ea(g[792336+((e[j>>1]|0)<<2)>>2]);s=j+(f<<1)|0}if(!m){t=ea(1.0);u=0}else{t=ea(g[792336+((e[m>>1]|0)<<2)>>2]);u=m+(f<<1)|0}if(!n)v=0;else{do if(!(r==ea(0.0))){h=(g[k>>2]=r,c[k>>2]|0);w=b[1054480+(h>>>23<<1)>>1]|0;if(!(w<<16>>16)){x=lle(h)|0;break}else{x=(w&65535)+(((h&8388607)+4096|0)>>>13)&65535;break}}else x=0;while(0);b[n>>1]=x;v=n+(d<<1)|0}if(!l)y=0;else{do if(!(r==ea(0.0))){h=(g[k>>2]=r,c[k>>2]|0);w=b[1054480+(h>>>23<<1)>>1]|0;if(!(w<<16>>16)){z=lle(h)|0;break}else{z=(w&65535)+(((h&8388607)+4096|0)>>>13)&65535;break}}else z=0;while(0);b[l>>1]=z;y=l+(d<<1)|0}if(!o)A=0;else{do if(!(r==ea(0.0))){h=(g[k>>2]=r,c[k>>2]|0);w=b[1054480+(h>>>23<<1)>>1]|0;if(!(w<<16>>16)){B=lle(h)|0;break}else{B=(w&65535)+(((h&8388607)+4096|0)>>>13)&65535;break}}else B=0;while(0);b[o>>1]=B;A=o+(d<<1)|0}if(!a)C=0;else{do if(!(t==ea(0.0))){h=(g[k>>2]=t,c[k>>2]|0);w=b[1054480+(h>>>23<<1)>>1]|0;if(!(w<<16>>16)){D=lle(h)|0;break}else{D=(w&65535)+(((h&8388607)+4096|0)>>>13)&65535;break}}else D=0;while(0);b[a>>1]=D;C=a+(d<<1)|0}if(!q)break;else{a=C;m=u;o=A;l=y;j=s;n=v}}i=p;return}function Dle(a,d,e,f,h,j,l,m,n){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=Im,r=0,s=Im,t=0,u=Im,v=0,w=Im,x=0,y=0,z=Im,A=0,B=0,C=0,D=0;o=i;if(!a){i=o;return}p=a;a=h;h=n;n=m;m=l;l=f;f=j;while(1){p=p+-1|0;if(!f){q=ea(.298999995);r=0}else{q=ea(ea(g[f>>2])*ea(.298999995));r=f+(e<<2)|0}if(!m){s=ea(.587000012);t=0}else{s=ea(ea(g[m>>2])*ea(.587000012));t=m+(e<<2)|0}if(!n){u=ea(.114);v=0}else{u=ea(ea(g[n>>2])*ea(.114));v=n+(e<<2)|0}if(!h){w=ea(1.0);x=0}else{w=ea(g[h>>2]);x=h+(e<<2)|0}if(!l)y=0;else{z=ea(q+ea(s+u));do if(!(z==ea(0.0))){j=(g[k>>2]=z,c[k>>2]|0);A=b[1054480+(j>>>23<<1)>>1]|0;if(!(A<<16>>16)){B=lle(j)|0;break}else{B=(A&65535)+(((j&8388607)+4096|0)>>>13)&65535;break}}else B=0;while(0);b[l>>1]=B;y=l+(d<<1)|0}if(!a)C=0;else{do if(!(w==ea(0.0))){j=(g[k>>2]=w,c[k>>2]|0);A=b[1054480+(j>>>23<<1)>>1]|0;if(!(A<<16>>16)){D=lle(j)|0;break}else{D=(A&65535)+(((j&8388607)+4096|0)>>>13)&65535;break}}else D=0;while(0);b[a>>1]=D;C=a+(d<<1)|0}if(!p)break;else{a=C;h=x;n=v;m=t;l=y;f=r}}i=o;return}function Ele(a,d,e,f,h,j,l,m,n){a=a|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=Im,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;o=i;if(!a){i=o;return}p=a;a=l;l=n;n=j;j=h;h=m;m=f;while(1){p=p+-1|0;if(!h){q=ea(1.0);r=0}else{q=ea(g[h>>2]);r=h+(e<<2)|0}if(!l){s=ea(1.0);t=0}else{s=ea(g[l>>2]);t=l+(e<<2)|0}if(!m)u=0;else{do if(!(q==ea(0.0))){f=(g[k>>2]=q,c[k>>2]|0);v=b[1054480+(f>>>23<<1)>>1]|0;if(!(v<<16>>16)){w=lle(f)|0;break}else{w=(v&65535)+(((f&8388607)+4096|0)>>>13)&65535;break}}else w=0;while(0);b[m>>1]=w;u=m+(d<<1)|0}if(!j)x=0;else{do if(!(q==ea(0.0))){f=(g[k>>2]=q,c[k>>2]|0);v=b[1054480+(f>>>23<<1)>>1]|0;if(!(v<<16>>16)){y=lle(f)|0;break}else{y=(v&65535)+(((f&8388607)+4096|0)>>>13)&65535;break}}else y=0;while(0);b[j>>1]=y;x=j+(d<<1)|0}if(!n)z=0;else{do if(!(q==ea(0.0))){f=(g[k>>2]=q,c[k>>2]|0);v=b[1054480+(f>>>23<<1)>>1]|0;if(!(v<<16>>16)){A=lle(f)|0;break}else{A=(v&65535)+(((f&8388607)+4096|0)>>>13)&65535;break}}else A=0;while(0);b[n>>1]=A;z=n+(d<<1)|0}if(!a)B=0;else{do if(!(s==ea(0.0))){f=(g[k>>2]=s,c[k>>2]|0);v=b[1054480+(f>>>23<<1)>>1]|0;if(!(v<<16>>16)){C=lle(f)|0;break}else{C=(v&65535)+(((f&8388607)+4096|0)>>>13)&65535;break}}else C=0;while(0);b[a>>1]=C;B=a+(d<<1)|0}if(!p)break;else{a=B;l=t;n=z;j=x;h=r;m=u}}i=o;return}function Fle(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0;g=i;h=b+76|0;j=b+136|0;c[j>>2]=0;k=h+0|0;l=k+56|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));if(!(a[1057008]|0)){c[264174]=-2013265912;c[264175]=0;c[264176]=0;c[264177]=255;c[264178]=0;c[264179]=0;c[264180]=0;a[1056720]=7;a[1056716]=8;a[1056723]=-1;a[1056719]=0;c[264181]=-2013265912;c[264182]=0;c[264183]=0;c[264184]=255;c[264185]=0;c[264186]=0;c[264187]=0;a[1056748]=7;a[1056744]=8;a[1056751]=-1;a[1056747]=0;c[264188]=-1879048184;c[264189]=224;c[264190]=28;c[264191]=3;c[264192]=0;a[1056778]=7;a[1056774]=3;a[1056777]=4;a[1056773]=3;a[1056776]=1;a[1056772]=2;a[1056779]=-1;a[1056775]=0;c[264195]=-1879048176;c[264196]=63488;c[264197]=2016;c[264198]=31;c[264199]=0;a[1056806]=15;a[1056802]=5;a[1056805]=10;a[1056801]=6;a[1056804]=4;a[1056800]=5;a[1056807]=-1;a[1056803]=0;c[264202]=-1879048168;c[264203]=16711680;c[264204]=65280;c[264205]=255;c[264206]=0;a[1056834]=23;a[1056830]=8;a[1056833]=15;a[1056829]=8;a[1056832]=7;a[1056828]=8;a[1056835]=-1;a[1056831]=0;c[264209]=-1879048176;c[264210]=31744;c[264211]=992;c[264212]=31;c[264213]=32768;a[1056862]=14;a[1056858]=5;a[1056861]=9;a[1056857]=5;a[1056860]=4;a[1056856]=5;a[1056863]=15;a[1056859]=1;c[264216]=-1879048176;c[264217]=3840;c[264218]=240;c[264219]=15;c[264220]=61440;a[1056890]=11;a[1056886]=4;a[1056889]=7;a[1056885]=4;a[1056888]=3;a[1056884]=4;a[1056891]=15;a[1056887]=4;c[264223]=-1879048160;c[264224]=16711680;c[264225]=65280;c[264226]=255;c[264227]=-16777216;a[1056918]=23;a[1056914]=8;a[1056917]=15;a[1056913]=8;a[1056916]=7;a[1056912]=8;a[1056919]=31;a[1056915]=8;c[264230]=-1879048168;c[264231]=255;c[264232]=65280;c[264233]=16711680;c[264234]=0;a[1056946]=7;a[1056942]=8;a[1056945]=15;a[1056941]=8;a[1056944]=23;a[1056940]=8;a[1056947]=-1;a[1056943]=0;c[264237]=-1879048160;c[264238]=255;c[264239]=65280;c[264240]=16711680;c[264241]=-16777216;a[1056974]=7;a[1056970]=8;a[1056973]=15;a[1056969]=8;a[1056972]=23;a[1056968]=8;a[1056975]=31;a[1056971]=8;c[264244]=-1879048176;c[264245]=61440;c[264246]=3840;c[264247]=240;c[264248]=15;a[1057002]=15;a[1056998]=4;a[1057001]=11;a[1056997]=4;a[1057e3]=7;a[1056996]=4;a[1057003]=3;a[1056999]=4;a[1057008]=1}k=c[e>>2]|0;if((k&65528)>>>0>32){i=g;return}if((c[d>>2]&65528)>>>0>32){i=g;return}c[b+132>>2]=f;c[b+104>>2]=k;k=e+4|0;c[b+108>>2]=c[k>>2];l=e+8|0;c[b+112>>2]=c[l>>2];m=e+12|0;c[b+116>>2]=c[m>>2];n=e+16|0;c[b+120>>2]=c[n>>2];c[b+124>>2]=c[e+20>>2];c[b+128>>2]=c[e+24>>2];c[h>>2]=c[d>>2];h=d+4|0;c[b+80>>2]=c[h>>2];o=d+8|0;c[b+84>>2]=c[o>>2];p=d+12|0;c[b+88>>2]=c[p>>2];q=d+16|0;c[b+92>>2]=c[q>>2];c[b+96>>2]=c[d+20>>2];c[b+100>>2]=c[d+24>>2];r=c[k>>2]|0;k=c[l>>2]|0;s=c[m>>2]|0;t=c[n>>2]|0;u=c[e>>2]|0;v=0;while(1){if(((((c[1056700+(v*28|0)>>2]|0)==(r|0)?(c[1056704+(v*28|0)>>2]|0)==(k|0):0)?(c[1056708+(v*28|0)>>2]|0)==(s|0):0)?(c[1056712+(v*28|0)>>2]|0)==(t|0):0)?(c[1056696+(v*28|0)>>2]|0)==(u|0):0){w=v;break}x=v+1|0;if((x|0)<11)v=x;else{w=x;break}}v=(w|0)==11?-1:w;w=c[h>>2]|0;h=c[o>>2]|0;x=c[p>>2]|0;y=c[q>>2]|0;z=c[d>>2]|0;A=0;while(1){if(((((c[1056700+(A*28|0)>>2]|0)==(w|0)?(c[1056704+(A*28|0)>>2]|0)==(h|0):0)?(c[1056708+(A*28|0)>>2]|0)==(x|0):0)?(c[1056712+(A*28|0)>>2]|0)==(y|0):0)?(c[1056696+(A*28|0)>>2]|0)==(z|0):0){B=A;break}C=A+1|0;if((C|0)<11)A=C;else{B=C;break}}A=(B|0)==11?-1:B;if((f|0)==3){if((v|0)!=-1&(A|0)!=-1?(B=c[1057664+(v*44|0)+(A<<2)>>2]|0,c[j>>2]=B,(B|0)!=0):0){i=g;return}B=(u&134217728|0)!=0;if(z&134217728){y=B?s:k;if(!y){c[b+8>>2]=0;c[b+4>>2]=0;c[b>>2]=0;D=u;E=s;F=k}else{do if(y>>>0>65535)if(y>>>0>16777215){G=y>>>24;H=24;break}else{G=y>>>16;H=16;break}else{x=(y&65280|0)==0;G=x?y:y>>>8;H=x?0:8}while(0);if(!(G&65280)){I=G;J=H}else{I=G>>>8;J=H+8|0}if(!(I&240)){K=I;L=J}else{K=I>>>4;L=J+4|0}if(!(K&12)){M=K;N=L}else{M=K>>>2;N=L+2|0}if(!(M&2)){O=M;P=N}else{O=M>>>1;P=N+1|0}N=8-P-(O&1)|0;if((N|0)>0){c[b>>2]=N;Q=0;R=N}else{c[b>>2]=0;Q=0-N|0;R=0}c[b+4>>2]=Q;c[b+8>>2]=y>>>Q<<R&255;D=c[e>>2]|0;E=c[m>>2]|0;F=c[l>>2]|0}R=b+12|0;Q=(D&134217728|0)!=0?E:F;if(!Q){c[b+20>>2]=0;c[b+16>>2]=0;c[R>>2]=0;S=E}else{do if(Q>>>0>65535)if(Q>>>0>16777215){T=Q>>>24;U=24;break}else{T=Q>>>16;U=16;break}else{E=(Q&65280|0)==0;T=E?Q:Q>>>8;U=E?0:8}while(0);if(!(T&65280)){V=T;W=U}else{V=T>>>8;W=U+8|0}if(!(V&240)){X=V;Y=W}else{X=V>>>4;Y=W+4|0}if(!(X&12)){Z=X;_=Y}else{Z=X>>>2;_=Y+2|0}if(!(Z&2)){$=Z;aa=_}else{$=Z>>>1;aa=_+1|0}_=8-aa-($&1)|0;if((_|0)>0){c[R>>2]=_;ba=0;ca=_}else{c[R>>2]=0;ba=0-_|0;ca=0}c[b+16>>2]=ba;c[b+20>>2]=Q>>>ba<<ca&255;S=c[m>>2]|0}ca=b+24|0;if(!S){c[b+32>>2]=0;c[b+28>>2]=0;c[ca>>2]=0}else{do if(S>>>0>65535)if(S>>>0>16777215){da=S>>>24;ea=24;break}else{da=S>>>16;ea=16;break}else{ba=(S&65280|0)==0;da=ba?S:S>>>8;ea=ba?0:8}while(0);if(!(da&65280)){fa=da;ga=ea}else{fa=da>>>8;ga=ea+8|0}if(!(fa&240)){ha=fa;ia=ga}else{ha=fa>>>4;ia=ga+4|0}if(!(ha&12)){ja=ha;ka=ia}else{ja=ha>>>2;ka=ia+2|0}if(!(ja&2)){la=ja;ma=ka}else{la=ja>>>1;ma=ka+1|0}ka=8-ma-(la&1)|0;if((ka|0)>0){c[ca>>2]=ka;na=0;oa=ka}else{c[ca>>2]=0;na=0-ka|0;oa=0}c[b+28>>2]=na;c[b+32>>2]=S>>>na<<oa&255}oa=b+36|0;na=c[n>>2]|0;S=c[q>>2]|0;if((na|0)!=0&(S|0)!=0){do if(S>>>0>65535)if(S>>>0>16777215){pa=S>>>24;qa=24;break}else{pa=S>>>16;qa=16;break}else{ka=(S&65280|0)==0;pa=ka?S:S>>>8;qa=ka?0:8}while(0);if(!(pa&65280)){ra=pa;sa=qa}else{ra=pa>>>8;sa=qa+8|0}if(!(ra&240)){ta=ra;ua=sa}else{ta=ra>>>4;ua=sa+4|0}if(!(ta&12)){va=ta;wa=ua}else{va=ta>>>2;wa=ua+2|0}if(!(va&2)){xa=va;ya=wa}else{xa=va>>>1;ya=wa+1|0}wa=xa&1;do if(na>>>0>65535)if(na>>>0>16777215){za=na>>>24;Aa=24;break}else{za=na>>>16;Aa=16;break}else{xa=(na&65280|0)==0;za=xa?na:na>>>8;Aa=xa?0:8}while(0);if(!(za&65280)){Ba=za;Ca=Aa}else{Ba=za>>>8;Ca=Aa+8|0}if(!(Ba&240)){Da=Ba;Ea=Ca}else{Da=Ba>>>4;Ea=Ca+4|0}if(!(Da&12)){Fa=Da;Ga=Ea}else{Fa=Da>>>2;Ga=Ea+2|0}if(!(Fa&2)){Ha=Fa;Ia=Ga}else{Ha=Fa>>>1;Ia=Ga+1|0}Ga=wa+ya-Ia-(Ha&1)|0;if((Ga|0)>0){c[oa>>2]=Ga;Ja=0;Ka=Ga}else{c[oa>>2]=0;Ja=0-Ga|0;Ka=0}c[b+40>>2]=Ja;c[b+44>>2]=na>>>Ja<<Ka&S}else{c[b+44>>2]=0;c[b+40>>2]=0;c[oa>>2]=0}oa=b+60|0;S=c[p>>2]|0;if(!S){c[b+68>>2]=0;c[b+64>>2]=0;c[oa>>2]=0}else{do if(S>>>0>65535)if(S>>>0>16777215){La=S>>>24;Ma=24;break}else{La=S>>>16;Ma=16;break}else{Ka=(S&65280|0)==0;La=Ka?S:S>>>8;Ma=Ka?0:8}while(0);if(!(La&65280)){Na=La;Oa=Ma}else{Na=La>>>8;Oa=Ma+8|0}if(!(Na&240)){Pa=Na;Qa=Oa}else{Pa=Na>>>4;Qa=Oa+4|0}if(!(Pa&12)){Ra=Pa;Sa=Qa}else{Ra=Pa>>>2;Sa=Qa+2|0}if(!(Ra&2)){Ta=Ra;Ua=Sa}else{Ta=Ra>>>1;Ua=Sa+1|0}Sa=Ua+-8+(Ta&1)|0;if((Sa|0)>0){c[oa>>2]=Sa;Va=0;Wa=Sa}else{c[oa>>2]=0;Va=0-Sa|0;Wa=0}c[b+64>>2]=Va;c[b+68>>2]=255>>>Va<<Wa&S}c[b+72>>2]=(c[n>>2]|0)==0?c[q>>2]|0:0;c[j>>2]=c[1058152+(((c[e>>2]|0)>>>3&8191)+-1<<4)+(((c[d>>2]|0)>>>3&8191)+-1<<2)>>2];i=g;return}S=B?s:r;if((S|0)!=0&(w|0)!=0){do if(w>>>0>65535)if(w>>>0>16777215){Xa=w>>>24;Ya=24;break}else{Xa=w>>>16;Ya=16;break}else{B=(w&65280|0)==0;Xa=B?w:w>>>8;Ya=B?0:8}while(0);if(!(Xa&65280)){Za=Xa;_a=Ya}else{Za=Xa>>>8;_a=Ya+8|0}if(!(Za&240)){$a=Za;ab=_a}else{$a=Za>>>4;ab=_a+4|0}if(!($a&12)){bb=$a;cb=ab}else{bb=$a>>>2;cb=ab+2|0}if(!(bb&2)){db=bb;eb=cb}else{db=bb>>>1;eb=cb+1|0}cb=db&1;do if(S>>>0>65535)if(S>>>0>16777215){fb=S>>>24;gb=24;break}else{fb=S>>>16;gb=16;break}else{db=(S&65280|0)==0;fb=db?S:S>>>8;gb=db?0:8}while(0);if(!(fb&65280)){hb=fb;ib=gb}else{hb=fb>>>8;ib=gb+8|0}if(!(hb&240)){jb=hb;kb=ib}else{jb=hb>>>4;kb=ib+4|0}if(!(jb&12)){lb=jb;mb=kb}else{lb=jb>>>2;mb=kb+2|0}if(!(lb&2)){nb=lb;ob=mb}else{nb=lb>>>1;ob=mb+1|0}mb=cb+eb-ob-(nb&1)|0;if((mb|0)>0){c[b>>2]=mb;pb=0;qb=mb}else{c[b>>2]=0;pb=0-mb|0;qb=0}c[b+4>>2]=pb;c[b+8>>2]=S>>>pb<<qb&w;rb=c[e>>2]|0;sb=c[m>>2]|0;tb=c[l>>2]|0;ub=c[o>>2]|0}else{c[b+8>>2]=0;c[b+4>>2]=0;c[b>>2]=0;rb=u;sb=s;tb=k;ub=h}qb=b+12|0;pb=(rb&134217728|0)!=0?sb:tb;if((pb|0)!=0&(ub|0)!=0){do if(ub>>>0>65535)if(ub>>>0>16777215){vb=ub>>>24;wb=24;break}else{vb=ub>>>16;wb=16;break}else{tb=(ub&65280|0)==0;vb=tb?ub:ub>>>8;wb=tb?0:8}while(0);if(!(vb&65280)){xb=vb;yb=wb}else{xb=vb>>>8;yb=wb+8|0}if(!(xb&240)){zb=xb;Ab=yb}else{zb=xb>>>4;Ab=yb+4|0}if(!(zb&12)){Bb=zb;Cb=Ab}else{Bb=zb>>>2;Cb=Ab+2|0}if(!(Bb&2)){Db=Bb;Eb=Cb}else{Db=Bb>>>1;Eb=Cb+1|0}Cb=Db&1;do if(pb>>>0>65535)if(pb>>>0>16777215){Fb=pb>>>24;Gb=24;break}else{Fb=pb>>>16;Gb=16;break}else{Db=(pb&65280|0)==0;Fb=Db?pb:pb>>>8;Gb=Db?0:8}while(0);if(!(Fb&65280)){Hb=Fb;Ib=Gb}else{Hb=Fb>>>8;Ib=Gb+8|0}if(!(Hb&240)){Jb=Hb;Kb=Ib}else{Jb=Hb>>>4;Kb=Ib+4|0}if(!(Jb&12)){Lb=Jb;Mb=Kb}else{Lb=Jb>>>2;Mb=Kb+2|0}if(!(Lb&2)){Nb=Lb;Ob=Mb}else{Nb=Lb>>>1;Ob=Mb+1|0}Mb=Cb+Eb-Ob-(Nb&1)|0;if((Mb|0)>0){c[qb>>2]=Mb;Pb=0;Qb=Mb}else{c[qb>>2]=0;Pb=0-Mb|0;Qb=0}c[b+16>>2]=Pb;c[b+20>>2]=pb>>>Pb<<Qb&ub;Rb=c[m>>2]|0}else{c[b+20>>2]=0;c[b+16>>2]=0;c[qb>>2]=0;Rb=sb}sb=b+24|0;qb=c[p>>2]|0;if((Rb|0)!=0&(qb|0)!=0){do if(qb>>>0>65535)if(qb>>>0>16777215){Sb=qb>>>24;Tb=24;break}else{Sb=qb>>>16;Tb=16;break}else{ub=(qb&65280|0)==0;Sb=ub?qb:qb>>>8;Tb=ub?0:8}while(0);if(!(Sb&65280)){Ub=Sb;Vb=Tb}else{Ub=Sb>>>8;Vb=Tb+8|0}if(!(Ub&240)){Wb=Ub;Xb=Vb}else{Wb=Ub>>>4;Xb=Vb+4|0}if(!(Wb&12)){Yb=Wb;Zb=Xb}else{Yb=Wb>>>2;Zb=Xb+2|0}if(!(Yb&2)){_b=Yb;$b=Zb}else{_b=Yb>>>1;$b=Zb+1|0}Zb=_b&1;do if(Rb>>>0>65535)if(Rb>>>0>16777215){ac=Rb>>>24;bc=24;break}else{ac=Rb>>>16;bc=16;break}else{_b=(Rb&65280|0)==0;ac=_b?Rb:Rb>>>8;bc=_b?0:8}while(0);if(!(ac&65280)){cc=ac;dc=bc}else{cc=ac>>>8;dc=bc+8|0}if(!(cc&240)){ec=cc;fc=dc}else{ec=cc>>>4;fc=dc+4|0}if(!(ec&12)){gc=ec;hc=fc}else{gc=ec>>>2;hc=fc+2|0}if(!(gc&2)){ic=gc;jc=hc}else{ic=gc>>>1;jc=hc+1|0}hc=Zb+$b-jc-(ic&1)|0;if((hc|0)>0){c[sb>>2]=hc;kc=0;lc=hc}else{c[sb>>2]=0;kc=0-hc|0;lc=0}c[b+28>>2]=kc;c[b+32>>2]=Rb>>>kc<<lc&qb}else{c[b+32>>2]=0;c[b+28>>2]=0;c[sb>>2]=0}sb=b+36|0;qb=c[n>>2]|0;lc=c[q>>2]|0;if((qb|0)!=0&(lc|0)!=0){do if(lc>>>0>65535)if(lc>>>0>16777215){mc=lc>>>24;nc=24;break}else{mc=lc>>>16;nc=16;break}else{kc=(lc&65280|0)==0;mc=kc?lc:lc>>>8;nc=kc?0:8}while(0);if(!(mc&65280)){oc=mc;pc=nc}else{oc=mc>>>8;pc=nc+8|0}if(!(oc&240)){qc=oc;rc=pc}else{qc=oc>>>4;rc=pc+4|0}if(!(qc&12)){sc=qc;tc=rc}else{sc=qc>>>2;tc=rc+2|0}if(!(sc&2)){uc=sc;vc=tc}else{uc=sc>>>1;vc=tc+1|0}tc=uc&1;do if(qb>>>0>65535)if(qb>>>0>16777215){wc=qb>>>24;xc=24;break}else{wc=qb>>>16;xc=16;break}else{uc=(qb&65280|0)==0;wc=uc?qb:qb>>>8;xc=uc?0:8}while(0);if(!(wc&65280)){yc=wc;zc=xc}else{yc=wc>>>8;zc=xc+8|0}if(!(yc&240)){Ac=yc;Bc=zc}else{Ac=yc>>>4;Bc=zc+4|0}if(!(Ac&12)){Cc=Ac;Dc=Bc}else{Cc=Ac>>>2;Dc=Bc+2|0}if(!(Cc&2)){Ec=Cc;Fc=Dc}else{Ec=Cc>>>1;Fc=Dc+1|0}Dc=tc+vc-Fc-(Ec&1)|0;if((Dc|0)>0){c[sb>>2]=Dc;Gc=0;Hc=Dc}else{c[sb>>2]=0;Gc=0-Dc|0;Hc=0}c[b+40>>2]=Gc;c[b+44>>2]=qb>>>Gc<<Hc&lc;Ic=c[n>>2]|0;Jc=c[q>>2]|0}else{c[b+44>>2]=0;c[b+40>>2]=0;c[sb>>2]=0;Ic=qb;Jc=lc}c[b+72>>2]=(Ic|0)==0?Jc:0;c[j>>2]=c[1058216+(((c[e>>2]|0)>>>3&8191)+-1<<4)+(((c[d>>2]|0)>>>3&8191)+-1<<2)>>2];i=g;return}else if((f|0)==2){if((v|0)!=-1&(A|0)!=-1?(Jc=c[1057016+(v*44|0)+(A<<2)>>2]|0,c[j>>2]=Jc,(Jc|0)!=0):0){i=g;return}Jc=(u&134217728|0)!=0?s:r;if(z&134217728){if(!Jc){c[b+8>>2]=0;c[b+4>>2]=0;c[b>>2]=0;Kc=u;Lc=s;Mc=k}else{do if(Jc>>>0>65535)if(Jc>>>0>16777215){Nc=Jc>>>24;Oc=24;break}else{Nc=Jc>>>16;Oc=16;break}else{z=(Jc&65280|0)==0;Nc=z?Jc:Jc>>>8;Oc=z?0:8}while(0);if(!(Nc&65280)){Pc=Nc;Qc=Oc}else{Pc=Nc>>>8;Qc=Oc+8|0}if(!(Pc&240)){Rc=Pc;Sc=Qc}else{Rc=Pc>>>4;Sc=Qc+4|0}if(!(Rc&12)){Tc=Rc;Uc=Sc}else{Tc=Rc>>>2;Uc=Sc+2|0}if(!(Tc&2)){Vc=Tc;Wc=Uc}else{Vc=Tc>>>1;Wc=Uc+1|0}Uc=8-Wc-(Vc&1)|0;if((Uc|0)>0){c[b>>2]=Uc;Xc=0;Yc=Uc}else{c[b>>2]=0;Xc=0-Uc|0;Yc=0}c[b+4>>2]=Xc;c[b+8>>2]=Jc>>>Xc<<Yc&255;Kc=c[e>>2]|0;Lc=c[m>>2]|0;Mc=c[l>>2]|0}Yc=b+12|0;Xc=(Kc&134217728|0)!=0?Lc:Mc;if(!Xc){c[b+20>>2]=0;c[b+16>>2]=0;c[Yc>>2]=0;Zc=Lc}else{do if(Xc>>>0>65535)if(Xc>>>0>16777215){_c=Xc>>>24;$c=24;break}else{_c=Xc>>>16;$c=16;break}else{Lc=(Xc&65280|0)==0;_c=Lc?Xc:Xc>>>8;$c=Lc?0:8}while(0);if(!(_c&65280)){ad=_c;bd=$c}else{ad=_c>>>8;bd=$c+8|0}if(!(ad&240)){cd=ad;dd=bd}else{cd=ad>>>4;dd=bd+4|0}if(!(cd&12)){ed=cd;fd=dd}else{ed=cd>>>2;fd=dd+2|0}if(!(ed&2)){gd=ed;hd=fd}else{gd=ed>>>1;hd=fd+1|0}fd=8-hd-(gd&1)|0;if((fd|0)>0){c[Yc>>2]=fd;id=0;jd=fd}else{c[Yc>>2]=0;id=0-fd|0;jd=0}c[b+16>>2]=id;c[b+20>>2]=Xc>>>id<<jd&255;Zc=c[m>>2]|0}jd=b+24|0;if(!Zc){c[b+32>>2]=0;c[b+28>>2]=0;c[jd>>2]=0}else{do if(Zc>>>0>65535)if(Zc>>>0>16777215){kd=Zc>>>24;ld=24;break}else{kd=Zc>>>16;ld=16;break}else{id=(Zc&65280|0)==0;kd=id?Zc:Zc>>>8;ld=id?0:8}while(0);if(!(kd&65280)){md=kd;nd=ld}else{md=kd>>>8;nd=ld+8|0}if(!(md&240)){od=md;pd=nd}else{od=md>>>4;pd=nd+4|0}if(!(od&12)){qd=od;rd=pd}else{qd=od>>>2;rd=pd+2|0}if(!(qd&2)){sd=qd;td=rd}else{sd=qd>>>1;td=rd+1|0}rd=8-td-(sd&1)|0;if((rd|0)>0){c[jd>>2]=rd;ud=0;vd=rd}else{c[jd>>2]=0;ud=0-rd|0;vd=0}c[b+28>>2]=ud;c[b+32>>2]=Zc>>>ud<<vd&255}vd=b+36|0;ud=c[n>>2]|0;Zc=c[q>>2]|0;if((ud|0)!=0&(Zc|0)!=0){do if(Zc>>>0>65535)if(Zc>>>0>16777215){wd=Zc>>>24;xd=24;break}else{wd=Zc>>>16;xd=16;break}else{rd=(Zc&65280|0)==0;wd=rd?Zc:Zc>>>8;xd=rd?0:8}while(0);if(!(wd&65280)){yd=wd;zd=xd}else{yd=wd>>>8;zd=xd+8|0}if(!(yd&240)){Ad=yd;Bd=zd}else{Ad=yd>>>4;Bd=zd+4|0}if(!(Ad&12)){Cd=Ad;Dd=Bd}else{Cd=Ad>>>2;Dd=Bd+2|0}if(!(Cd&2)){Ed=Cd;Fd=Dd}else{Ed=Cd>>>1;Fd=Dd+1|0}Dd=Ed&1;do if(ud>>>0>65535)if(ud>>>0>16777215){Gd=ud>>>24;Hd=24;break}else{Gd=ud>>>16;Hd=16;break}else{Ed=(ud&65280|0)==0;Gd=Ed?ud:ud>>>8;Hd=Ed?0:8}while(0);if(!(Gd&65280)){Id=Gd;Jd=Hd}else{Id=Gd>>>8;Jd=Hd+8|0}if(!(Id&240)){Kd=Id;Ld=Jd}else{Kd=Id>>>4;Ld=Jd+4|0}if(!(Kd&12)){Md=Kd;Nd=Ld}else{Md=Kd>>>2;Nd=Ld+2|0}if(!(Md&2)){Od=Md;Pd=Nd}else{Od=Md>>>1;Pd=Nd+1|0}Nd=Dd+Fd-Pd-(Od&1)|0;if((Nd|0)>0){c[vd>>2]=Nd;Qd=0;Rd=Nd}else{c[vd>>2]=0;Qd=0-Nd|0;Rd=0}c[b+40>>2]=Qd;c[b+44>>2]=ud>>>Qd<<Rd&Zc}else{c[b+44>>2]=0;c[b+40>>2]=0;c[vd>>2]=0}vd=b+60|0;Zc=c[p>>2]|0;if(!Zc){c[b+68>>2]=0;c[b+64>>2]=0;c[vd>>2]=0}else{do if(Zc>>>0>65535)if(Zc>>>0>16777215){Sd=Zc>>>24;Td=24;break}else{Sd=Zc>>>16;Td=16;break}else{Rd=(Zc&65280|0)==0;Sd=Rd?Zc:Zc>>>8;Td=Rd?0:8}while(0);if(!(Sd&65280)){Ud=Sd;Vd=Td}else{Ud=Sd>>>8;Vd=Td+8|0}if(!(Ud&240)){Wd=Ud;Xd=Vd}else{Wd=Ud>>>4;Xd=Vd+4|0}if(!(Wd&12)){Yd=Wd;Zd=Xd}else{Yd=Wd>>>2;Zd=Xd+2|0}if(!(Yd&2)){_d=Yd;$d=Zd}else{_d=Yd>>>1;$d=Zd+1|0}Zd=$d+-8+(_d&1)|0;if((Zd|0)>0){c[vd>>2]=Zd;ae=0;be=Zd}else{c[vd>>2]=0;ae=0-Zd|0;be=0}c[b+64>>2]=ae;c[b+68>>2]=255>>>ae<<be&Zc}c[b+72>>2]=(c[n>>2]|0)==0?c[q>>2]|0:0;c[j>>2]=c[1057504+(((c[e>>2]|0)>>>3&8191)+-1<<4)+(((c[d>>2]|0)>>>3&8191)+-1<<2)>>2];i=g;return}if((Jc|0)!=0&(w|0)!=0){do if(w>>>0>65535)if(w>>>0>16777215){ce=w>>>24;de=24;break}else{ce=w>>>16;de=16;break}else{Zc=(w&65280|0)==0;ce=Zc?w:w>>>8;de=Zc?0:8}while(0);if(!(ce&65280)){ee=ce;fe=de}else{ee=ce>>>8;fe=de+8|0}if(!(ee&240)){ge=ee;he=fe}else{ge=ee>>>4;he=fe+4|0}if(!(ge&12)){ie=ge;je=he}else{ie=ge>>>2;je=he+2|0}if(!(ie&2)){ke=ie;le=je}else{ke=ie>>>1;le=je+1|0}je=ke&1;do if(Jc>>>0>65535)if(Jc>>>0>16777215){me=Jc>>>24;ne=24;break}else{me=Jc>>>16;ne=16;break}else{ke=(Jc&65280|0)==0;me=ke?Jc:Jc>>>8;ne=ke?0:8}while(0);if(!(me&65280)){oe=me;pe=ne}else{oe=me>>>8;pe=ne+8|0}if(!(oe&240)){qe=oe;re=pe}else{qe=oe>>>4;re=pe+4|0}if(!(qe&12)){se=qe;te=re}else{se=qe>>>2;te=re+2|0}if(!(se&2)){ue=se;ve=te}else{ue=se>>>1;ve=te+1|0}te=je+le-ve-(ue&1)|0;if((te|0)>0){c[b>>2]=te;we=0;xe=te}else{c[b>>2]=0;we=0-te|0;xe=0}c[b+4>>2]=we;c[b+8>>2]=Jc>>>we<<xe&w;ye=c[e>>2]|0;ze=c[m>>2]|0;Ae=c[l>>2]|0;Be=c[o>>2]|0}else{c[b+8>>2]=0;c[b+4>>2]=0;c[b>>2]=0;ye=u;ze=s;Ae=k;Be=h}h=b+12|0;o=(ye&134217728|0)!=0?ze:Ae;if((o|0)!=0&(Be|0)!=0){do if(Be>>>0>65535)if(Be>>>0>16777215){Ce=Be>>>24;De=24;break}else{Ce=Be>>>16;De=16;break}else{Ae=(Be&65280|0)==0;Ce=Ae?Be:Be>>>8;De=Ae?0:8}while(0);if(!(Ce&65280)){Ee=Ce;Fe=De}else{Ee=Ce>>>8;Fe=De+8|0}if(!(Ee&240)){Ge=Ee;He=Fe}else{Ge=Ee>>>4;He=Fe+4|0}if(!(Ge&12)){Ie=Ge;Je=He}else{Ie=Ge>>>2;Je=He+2|0}if(!(Ie&2)){Ke=Ie;Le=Je}else{Ke=Ie>>>1;Le=Je+1|0}Je=Ke&1;do if(o>>>0>65535)if(o>>>0>16777215){Me=o>>>24;Ne=24;break}else{Me=o>>>16;Ne=16;break}else{Ke=(o&65280|0)==0;Me=Ke?o:o>>>8;Ne=Ke?0:8}while(0);if(!(Me&65280)){Oe=Me;Pe=Ne}else{Oe=Me>>>8;Pe=Ne+8|0}if(!(Oe&240)){Qe=Oe;Re=Pe}else{Qe=Oe>>>4;Re=Pe+4|0}if(!(Qe&12)){Se=Qe;Te=Re}else{Se=Qe>>>2;Te=Re+2|0}if(!(Se&2)){Ue=Se;Ve=Te}else{Ue=Se>>>1;Ve=Te+1|0}Te=Je+Le-Ve-(Ue&1)|0;if((Te|0)>0){c[h>>2]=Te;We=0;Xe=Te}else{c[h>>2]=0;We=0-Te|0;Xe=0}c[b+16>>2]=We;c[b+20>>2]=o>>>We<<Xe&Be;Ye=c[m>>2]|0}else{c[b+20>>2]=0;c[b+16>>2]=0;c[h>>2]=0;Ye=ze}ze=b+24|0;h=c[p>>2]|0;if((Ye|0)!=0&(h|0)!=0){do if(h>>>0>65535)if(h>>>0>16777215){Ze=h>>>24;_e=24;break}else{Ze=h>>>16;_e=16;break}else{p=(h&65280|0)==0;Ze=p?h:h>>>8;_e=p?0:8}while(0);if(!(Ze&65280)){$e=Ze;af=_e}else{$e=Ze>>>8;af=_e+8|0}if(!($e&240)){bf=$e;cf=af}else{bf=$e>>>4;cf=af+4|0}if(!(bf&12)){df=bf;ef=cf}else{df=bf>>>2;ef=cf+2|0}if(!(df&2)){ff=df;gf=ef}else{ff=df>>>1;gf=ef+1|0}ef=ff&1;do if(Ye>>>0>65535)if(Ye>>>0>16777215){hf=Ye>>>24;jf=24;break}else{hf=Ye>>>16;jf=16;break}else{ff=(Ye&65280|0)==0;hf=ff?Ye:Ye>>>8;jf=ff?0:8}while(0);if(!(hf&65280)){kf=hf;lf=jf}else{kf=hf>>>8;lf=jf+8|0}if(!(kf&240)){mf=kf;nf=lf}else{mf=kf>>>4;nf=lf+4|0}if(!(mf&12)){of=mf;pf=nf}else{of=mf>>>2;pf=nf+2|0}if(!(of&2)){qf=of;rf=pf}else{qf=of>>>1;rf=pf+1|0}pf=ef+gf-rf-(qf&1)|0;if((pf|0)>0){c[ze>>2]=pf;sf=0;tf=pf}else{c[ze>>2]=0;sf=0-pf|0;tf=0}c[b+28>>2]=sf;c[b+32>>2]=Ye>>>sf<<tf&h}else{c[b+32>>2]=0;c[b+28>>2]=0;c[ze>>2]=0}ze=b+36|0;h=c[n>>2]|0;tf=c[q>>2]|0;if((h|0)!=0&(tf|0)!=0){do if(tf>>>0>65535)if(tf>>>0>16777215){uf=tf>>>24;vf=24;break}else{uf=tf>>>16;vf=16;break}else{sf=(tf&65280|0)==0;uf=sf?tf:tf>>>8;vf=sf?0:8}while(0);if(!(uf&65280)){wf=uf;xf=vf}else{wf=uf>>>8;xf=vf+8|0}if(!(wf&240)){yf=wf;zf=xf}else{yf=wf>>>4;zf=xf+4|0}if(!(yf&12)){Af=yf;Bf=zf}else{Af=yf>>>2;Bf=zf+2|0}if(!(Af&2)){Cf=Af;Df=Bf}else{Cf=Af>>>1;Df=Bf+1|0}Bf=Cf&1;do if(h>>>0>65535)if(h>>>0>16777215){Ef=h>>>24;Ff=24;break}else{Ef=h>>>16;Ff=16;break}else{Cf=(h&65280|0)==0;Ef=Cf?h:h>>>8;Ff=Cf?0:8}while(0);if(!(Ef&65280)){Gf=Ef;Hf=Ff}else{Gf=Ef>>>8;Hf=Ff+8|0}if(!(Gf&240)){If=Gf;Jf=Hf}else{If=Gf>>>4;Jf=Hf+4|0}if(!(If&12)){Kf=If;Lf=Jf}else{Kf=If>>>2;Lf=Jf+2|0}if(!(Kf&2)){Mf=Kf;Nf=Lf}else{Mf=Kf>>>1;Nf=Lf+1|0}Lf=Bf+Df-Nf-(Mf&1)|0;if((Lf|0)>0){c[ze>>2]=Lf;Of=0;Pf=Lf}else{c[ze>>2]=0;Of=0-Lf|0;Pf=0}c[b+40>>2]=Of;c[b+44>>2]=h>>>Of<<Pf&tf;Qf=c[n>>2]|0;Rf=c[q>>2]|0}else{c[b+44>>2]=0;c[b+40>>2]=0;c[ze>>2]=0;Qf=h;Rf=tf}c[b+72>>2]=(Qf|0)==0?Rf:0;c[j>>2]=c[1057568+(((c[e>>2]|0)>>>3&8191)+-1<<4)+(((c[d>>2]|0)>>>3&8191)+-1<<2)>>2];i=g;return}else if((f|0)==1){d=(u>>>3&8191)+-1|0;if(!(u&134217728)){c[j>>2]=c[1057648+(d<<2)>>2];i=g;return}else{c[j>>2]=c[1057632+(d<<2)>>2];i=g;return}}else if((f|0)==5){if((v|0)!=-1?(c[j>>2]=c[1058280+(v<<2)>>2],(250>>>v&1|0)!=0):0){i=g;return}if(u&134217728){u=b+60|0;if(!s){c[u>>2]=0;c[b+64>>2]=32;c[b+68>>2]=0;Sf=t}else{do if(s>>>0>65535)if(s>>>0>16777215){Tf=s>>>24;Uf=24;break}else{Tf=s>>>16;Uf=16;break}else{t=(s&65280|0)==0;Tf=t?s:s>>>8;Uf=t?0:8}while(0);if(!(Tf&65280)){Vf=Tf;Wf=Uf}else{Vf=Tf>>>8;Wf=Uf+8|0}if(!(Vf&240)){Xf=Vf;Yf=Wf}else{Xf=Vf>>>4;Yf=Wf+4|0}if(!(Xf&12)){Zf=Xf;_f=Yf}else{Zf=Xf>>>2;_f=Yf+2|0}if(!(Zf&2)){$f=Zf;ag=_f}else{$f=Zf>>>1;ag=_f+1|0}_f=8-ag-($f&1)|0;if((_f|0)>0){c[u>>2]=_f;bg=0;cg=_f}else{c[u>>2]=0;bg=0-_f|0;cg=0}c[b+64>>2]=bg;c[b+68>>2]=255>>>cg<<bg&s;Sf=c[n>>2]|0}s=b+36|0;if(!Sf){c[s>>2]=0;c[b+40>>2]=32;c[b+44>>2]=0}else{do if(Sf>>>0>65535)if(Sf>>>0>16777215){dg=Sf>>>24;eg=24;break}else{dg=Sf>>>16;eg=16;break}else{bg=(Sf&65280|0)==0;dg=bg?Sf:Sf>>>8;eg=bg?0:8}while(0);if(!(dg&65280)){fg=dg;gg=eg}else{fg=dg>>>8;gg=eg+8|0}if(!(fg&240)){hg=fg;ig=gg}else{hg=fg>>>4;ig=gg+4|0}if(!(hg&12)){jg=hg;kg=ig}else{jg=hg>>>2;kg=ig+2|0}if(!(jg&2)){lg=jg;mg=kg}else{lg=jg>>>1;mg=kg+1|0}kg=8-mg-(lg&1)|0;if((kg|0)>0){c[s>>2]=kg;ng=0;og=kg}else{c[s>>2]=0;ng=0-kg|0;og=0}c[b+40>>2]=ng;c[b+44>>2]=255>>>og<<ng&Sf}c[j>>2]=c[1058328+(((c[e>>2]|0)>>>3&8191)+-1<<2)>>2];i=g;return}if(!r){c[b>>2]=0;c[b+4>>2]=32;c[b+8>>2]=0;pg=k}else{do if(r>>>0>65535)if(r>>>0>16777215){qg=r>>>24;rg=24;break}else{qg=r>>>16;rg=16;break}else{k=(r&65280|0)==0;qg=k?r:r>>>8;rg=k?0:8}while(0);if(!(qg&65280)){sg=qg;tg=rg}else{sg=qg>>>8;tg=rg+8|0}if(!(sg&240)){ug=sg;vg=tg}else{ug=sg>>>4;vg=tg+4|0}if(!(ug&12)){wg=ug;xg=vg}else{wg=ug>>>2;xg=vg+2|0}if(!(wg&2)){yg=wg;zg=xg}else{yg=wg>>>1;zg=xg+1|0}xg=8-zg-(yg&1)|0;if((xg|0)>0){c[b>>2]=xg;Ag=0;Bg=xg}else{c[b>>2]=0;Ag=0-xg|0;Bg=0}c[b+4>>2]=Ag;c[b+8>>2]=255>>>Bg<<Ag&r;pg=c[l>>2]|0}l=b+12|0;if(!pg){c[l>>2]=0;c[b+16>>2]=32;c[b+20>>2]=0}else{do if(pg>>>0>65535)if(pg>>>0>16777215){Cg=pg>>>24;Dg=24;break}else{Cg=pg>>>16;Dg=16;break}else{r=(pg&65280|0)==0;Cg=r?pg:pg>>>8;Dg=r?0:8}while(0);if(!(Cg&65280)){Eg=Cg;Fg=Dg}else{Eg=Cg>>>8;Fg=Dg+8|0}if(!(Eg&240)){Gg=Eg;Hg=Fg}else{Gg=Eg>>>4;Hg=Fg+4|0}if(!(Gg&12)){Ig=Gg;Jg=Hg}else{Ig=Gg>>>2;Jg=Hg+2|0}if(!(Ig&2)){Kg=Ig;Lg=Jg}else{Kg=Ig>>>1;Lg=Jg+1|0}Jg=8-Lg-(Kg&1)|0;if((Jg|0)>0){c[l>>2]=Jg;Mg=0;Ng=Jg}else{c[l>>2]=0;Mg=0-Jg|0;Ng=0}c[b+16>>2]=Mg;c[b+20>>2]=255>>>Ng<<Mg&pg}pg=b+24|0;Mg=c[m>>2]|0;if(!Mg){c[pg>>2]=0;c[b+28>>2]=32;c[b+32>>2]=0}else{do if(Mg>>>0>65535)if(Mg>>>0>16777215){Og=Mg>>>24;Pg=24;break}else{Og=Mg>>>16;Pg=16;break}else{m=(Mg&65280|0)==0;Og=m?Mg:Mg>>>8;Pg=m?0:8}while(0);if(!(Og&65280)){Qg=Og;Rg=Pg}else{Qg=Og>>>8;Rg=Pg+8|0}if(!(Qg&240)){Sg=Qg;Tg=Rg}else{Sg=Qg>>>4;Tg=Rg+4|0}if(!(Sg&12)){Ug=Sg;Vg=Tg}else{Ug=Sg>>>2;Vg=Tg+2|0}if(!(Ug&2)){Wg=Ug;Xg=Vg}else{Wg=Ug>>>1;Xg=Vg+1|0}Vg=8-Xg-(Wg&1)|0;if((Vg|0)>0){c[pg>>2]=Vg;Yg=0;Zg=Vg}else{c[pg>>2]=0;Yg=0-Vg|0;Zg=0}c[b+28>>2]=Yg;c[b+32>>2]=255>>>Zg<<Yg&Mg}Mg=b+36|0;Yg=c[n>>2]|0;if(!Yg){c[Mg>>2]=0;c[b+40>>2]=32;c[b+44>>2]=0}else{do if(Yg>>>0>65535)if(Yg>>>0>16777215){_g=Yg>>>24;$g=24;break}else{_g=Yg>>>16;$g=16;break}else{n=(Yg&65280|0)==0;_g=n?Yg:Yg>>>8;$g=n?0:8}while(0);if(!(_g&65280)){ah=_g;bh=$g}else{ah=_g>>>8;bh=$g+8|0}if(!(ah&240)){ch=ah;dh=bh}else{ch=ah>>>4;dh=bh+4|0}if(!(ch&12)){eh=ch;fh=dh}else{eh=ch>>>2;fh=dh+2|0}if(!(eh&2)){gh=eh;hh=fh}else{gh=eh>>>1;hh=fh+1|0}fh=8-hh-(gh&1)|0;if((fh|0)>0){c[Mg>>2]=fh;ih=0;jh=fh}else{c[Mg>>2]=0;ih=0-fh|0;jh=0}c[b+40>>2]=ih;c[b+44>>2]=255>>>jh<<ih&Yg}c[j>>2]=c[1058344+(((c[e>>2]|0)>>>3&8191)+-1<<2)>>2];i=g;return}else{i=g;return}}function Gle(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=Im,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+176|0;g=f+28|0;h=f;if(!(a[1058360]|0)){j=0;do{k=ea(j|0);a[1055674+(j<<2)>>0]=~~ea(k*ea(.298999995));a[1055673+(j<<2)>>0]=~~ea(k*ea(.587000012));a[1055672+(j<<2)>>0]=~~ea(k*ea(.114));a[1055675+(j<<2)>>0]=0;j=j+1|0}while((j|0)!=256);a[1058360]=1}j=c[b>>2]|0;if(!j){i=f;return}l=b+4|0;m=c[l>>2]|0;if(!m){i=f;return}n=b+40|0;o=c[n>>2]|0;if(!o){i=f;return}p=c[d>>2]|0;if(!p){i=f;return}q=d+4|0;r=c[q>>2]|0;if(!r){i=f;return}s=d+40|0;t=c[s>>2]|0;if(!t){i=f;return}u=(m|0)!=(r|0)|(j|0)!=(p|0);v=d+12|0;w=b+12|0;if((((c[d+16>>2]|0)==(c[b+16>>2]|0)?(c[d+20>>2]|0)==(c[b+20>>2]|0):0)?(c[d+24>>2]|0)==(c[b+24>>2]|0):0)?(c[d+28>>2]|0)==(c[b+28>>2]|0):0)x=(c[v>>2]|0)!=(c[w>>2]|0)?2:0;else x=2;if((e|0)==1)y=x|u&1;else if((e|0)==2)y=u?x|5:x;else y=x;if(!y){x=da((c[w>>2]|0)>>>3&8191,p>>>0<j>>>0?p:j)|0;if(!((r>>>0<m>>>0?r:m)|0)){i=f;return}j=d+8|0;p=b+8|0;u=~r;r=~m;m=~(u>>>0>r>>>0?u:r);r=o;o=t;t=0;while(1){YEi(r|0,o|0,x|0)|0;t=t+1|0;if((t|0)==(m|0))break;else{r=r+(c[p>>2]|0)|0;o=o+(c[j>>2]|0)|0}}i=f;return}if((c[w>>2]|0)<=-1?(c[v>>2]|0)<=-1:0){Fle(g,w,v,(y&2|0)==0?y:y&-5);c[h>>2]=c[n>>2];n=c[g+132>>2]|0;if(!(n&1)){y=c[d>>2]|0;v=c[b>>2]|0;w=c[q>>2]|0;j=c[l>>2]|0;c[h+12>>2]=y>>>0<v>>>0?y:v;v=h+4|0;c[v>>2]=c[s>>2];if(!((w>>>0<j>>>0?w:j)|0)){i=f;return}y=g+136|0;o=b+8|0;p=d+8|0;r=~w;w=~j;j=~(r>>>0>w>>>0?r:w);w=0;do{In[c[y>>2]&4095](g,h);c[h>>2]=(c[h>>2]|0)+(c[o>>2]|0);c[v>>2]=(c[v>>2]|0)+(c[p>>2]|0);w=w+1|0}while((w|0)!=(j|0));i=f;return}do if(n&4){j=c[b>>2]|0;w=c[d>>2]|0;if(j>>>0<w>>>0){p=(w<<16>>>0)/(j>>>0)|0;z=(p>>>1)+-32768|0;A=p}else{p=j+-1|0;z=0;A=(((w<<16)+-65536|0)>>>0)/(((p|0)!=0?p:1)>>>0)|0}c[h+20>>2]=A;c[h+16>>2]=z;p=c[l>>2]|0;w=c[q>>2]|0;if(p>>>0<w>>>0){v=(w<<16>>>0)/(p>>>0)|0;B=j;C=w;D=p;E=(v>>>1)+-32768|0;F=v;break}else{v=p+-1|0;B=j;C=w;D=p;E=0;F=(((w<<16)+-65536|0)>>>0)/(((v|0)!=0?v:1)>>>0)|0;break}}else{v=c[b>>2]|0;w=(c[d>>2]<<16>>>0)/(v>>>0)|0;c[h+20>>2]=w;c[h+16>>2]=w>>>1;w=c[q>>2]|0;p=c[l>>2]|0;j=(w<<16>>>0)/(p>>>0)|0;B=v;C=w;D=p;E=j>>>1;F=j}while(0);c[h+12>>2]=B;B=c[s>>2]|0;q=d+8|0;z=c[q>>2]|0;A=B+(da(C+-1|0,z)|0)|0;if(!D){i=f;return}D=h+4|0;C=h+8|0;n=h+24|0;j=g+136|0;p=b+8|0;w=z;z=B;B=E;E=1;while(1){v=da(w,B>>>16)|0;o=z+v|0;c[D>>2]=o;y=z+(v+w)|0;c[C>>2]=y>>>0>A>>>0?o:y;c[n>>2]=B&65535;In[c[j>>2]&4095](g,h);c[h>>2]=(c[h>>2]|0)+(c[p>>2]|0);if(E>>>0>=(c[l>>2]|0)>>>0)break;w=c[q>>2]|0;z=c[s>>2]|0;B=B+F|0;E=E+1|0}i=f;return}ple(b,d,e);i=f;return}function Hle(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=c[a>>2]|0;if(!d){i=b;return}e=c[a+4>>2]|0;if(!e){i=b;return}f=c[a+40>>2]|0;if(!f){i=b;return}g=a+8|0;h=da(c[g>>2]|0,e+-1|0)|0;e=f+h|0;j=c[a+12>>2]|0;do if(!(j&1073741824)){if(j&536870912){k=1865;l=(da(j>>>3&8191,d)|0)>>>2;break}if((j|0)<0){a=j>>>3&8191;if((a|0)==3){k=1867;l=d;break}else if((a|0)==4){k=1865;l=d;break}else if((a|0)==2){k=1864;l=d;break}else if((a|0)==1){k=1866;l=d;break}else{i=b;return}}else{k=0;l=0}}else{k=1864;l=(da(j>>>3&8191,d)|0)>>>1}while(0);if((h|0)>0){m=e;n=f}else{i=b;return}do{co[k&2047](n,m,l);f=c[g>>2]|0;n=n+f|0;m=m+(0-f)|0}while(n>>>0<m>>>0);i=b;return}function Ile(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if(!d){i=e;return}f=d;d=b;b=a;while(1){f=f+-1|0;a=c[b>>2]|0;c[b>>2]=c[d>>2];c[d>>2]=a;if(!f)break;else{d=d+4|0;b=b+4|0}}i=e;return}function Jle(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=i;if(!d){i=e;return}f=d;d=c;c=a;while(1){f=f+-1|0;a=b[c>>1]|0;b[c>>1]=b[d>>1]|0;b[d>>1]=a;if(!f)break;else{d=d+2|0;c=c+2|0}}i=e;return}function Kle(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d*3|0;if(!f){i=e;return}else{g=f;h=c;j=b}while(1){g=g+-1|0;b=a[j>>0]|0;a[j>>0]=a[h>>0]|0;a[h>>0]=b;if(!g)break;else{h=h+1|0;j=j+1|0}}i=e;return}function Lle(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!d){i=e;return}else{f=d;g=c;h=b}while(1){f=f+-1|0;b=a[h>>0]|0;a[h>>0]=a[g>>0]|0;a[g>>0]=b;if(!f)break;else{g=g+1|0;h=h+1|0}}i=e;return}function Mle(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;f=c[e+12>>2]|0;if(!f){i=b;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;j=e&224;a[f>>0]=e>>>6|j|j>>>3;if(!g)break;else{f=f+1|0;h=h+1|0}}i=b;return}function Nle(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;b[f>>1]=e<<3&2016|e>>>3|e<<8&63488;if(!g)break;else{f=f+2|0;h=h+1|0}}i=a;return}function Ole(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[d+12>>2]|0;if(!e){i=b;return}f=e;e=c[d>>2]|0;g=c[d+4>>2]|0;while(1){f=f+-1|0;d=a[g>>0]|0;a[e>>0]=d;a[e+1>>0]=d;a[e+2>>0]=d;if(!f)break;else{e=e+3|0;g=g+1|0}}i=b;return}function Ple(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;j=e&248;b[f>>1]=e>>>3|j<<2|j<<7|32768;if(!g)break;else{f=f+2|0;h=h+1|0}}i=a;return}function Qle(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;j=e&240;b[f>>1]=j|e>>>4|j<<4|61440;if(!g)break;else{f=f+2|0;h=h+1|0}}i=a;return}function Rle(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;a=i;e=c[b+12>>2]|0;if(!e){i=a;return}f=e;e=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=d[g>>0]|0;c[e>>2]=b|b<<8|b<<16|-16777216;if(!f)break;else{e=e+4|0;g=g+1|0}}i=a;return}function Sle(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[e+12>>2]|0;if(!f){i=b;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;a[f>>0]=(d[1055673+((e<<3&224)<<2)>>0]|0)+(d[1055674+((e&224)<<2)>>0]|0)+(d[1055672+((e<<6&192)<<2)>>0]|0);if(!g)break;else{f=f+1|0;h=h+1|0}}i=b;return}function Tle(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;b[f>>1]=e<<8&57344|e<<6&1792|e<<3&24;if(!g)break;else{f=f+2|0;h=h+1|0}}i=a;return}function Ule(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[e+12>>2]|0;if(!f){i=b;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;a[f>>0]=e<<6;a[f+1>>0]=e<<3&224;a[f+2>>0]=e&224;if(!g)break;else{f=f+3|0;h=h+1|0}}i=b;return}function Vle(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;b[f>>1]=e<<5&896|e<<7&28672|e<<3&24|32768;if(!g)break;else{f=f+2|0;h=h+1|0}}i=a;return}function Wle(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=d[h>>0]|0;b[f>>1]=e<<3&224|e<<4&3584|e<<2&12|61440;if(!g)break;else{f=f+2|0;h=h+1|0}}i=a;return}function Xle(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;a=i;e=c[b+12>>2]|0;if(!e){i=a;return}f=e;e=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=d[g>>0]|0;c[e>>2]=b<<11&57344|b<<16&14680064|b<<6&192|-16777216;if(!f)break;else{e=e+4|0;g=g+1|0}}i=a;return}function Yle(b,f){b=b|0;f=f|0;var g=0,h=0,j=0;b=i;g=c[f+12>>2]|0;if(!g){i=b;return}h=g;g=c[f>>2]|0;j=c[f+4>>2]|0;while(1){h=h+-1|0;f=e[j>>1]|0;a[g>>0]=(d[1055673+((f>>>3&252)<<2)>>0]|0)+(d[1055674+((f>>>8&248)<<2)>>0]|0)+(d[1055672+((f<<3&248)<<2)>>0]|0);if(!h)break;else{g=g+1|0;j=j+2|0}}i=b;return}function Zle(b,d){b=b|0;d=d|0;var f=0,g=0,h=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;a[f>>0]=d>>>8&224|d>>>6&28|d>>>3&3;if(!g)break;else{f=f+1|0;h=h+2|0}}i=b;return}function _le(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;j=d&2016;k=d<<3;a[f>>0]=d>>>2&7|k;a[f+1>>0]=(j>>>1&768|j<<5)>>>8;a[f+2>>0]=(d<<8&16252928|k&458752)>>>16;if(!g)break;else{f=f+3|0;h=h+2|0}}i=b;return}function $le(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;f=c[d+4>>2]|0;g=c[d>>2]|0;h=c[d+12>>2]|0;d=f;if((g^d)&2){if(!h){i=a;return}else{j=h;k=g;l=f}while(1){j=j+-1|0;m=e[l>>1]|0;b[k>>1]=m&31|m>>>1&32736|32768;if(!j)break;else{k=k+2|0;l=l+2|0}}i=a;return}if(!(d&2)){n=h;o=g;p=f}else{d=e[f>>1]|0;b[g>>1]=d&31|d>>>1&32736|32768;n=h+-1|0;o=g+2|0;p=f+2|0}f=n>>>1;if(!f){q=o;r=p}else{g=f<<1;h=o+(g<<1)|0;d=f;f=o;o=p;while(1){d=d+-1|0;l=c[o>>2]|0;c[f>>2]=l&2031647|l>>>1&2145419232|-2147450880;if(!d)break;else{f=f+4|0;o=o+4|0}}q=h;r=p+(g<<1)|0}if(!(n&1)){i=a;return}n=e[r>>1]|0;b[q>>1]=n&31|n>>>1&32736|32768;i=a;return}function ame(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;f=c[d+4>>2]|0;g=c[d>>2]|0;h=c[d+12>>2]|0;d=f;if((g^d)&2){if(!h){i=a;return}else{j=h;k=g;l=f}while(1){j=j+-1|0;m=e[l>>1]|0;b[k>>1]=m>>>3&240|m>>>4&3840|m>>>1&15|61440;if(!j)break;else{k=k+2|0;l=l+2|0}}i=a;return}if(!(d&2)){n=h;o=g;p=f}else{d=e[f>>1]|0;b[g>>1]=d>>>3&240|d>>>4&3840|d>>>1&15|61440;n=h+-1|0;o=g+2|0;p=f+2|0}f=n>>>1;if(!f){q=o;r=p}else{g=f<<1;h=o+(g<<1)|0;d=f;f=o;o=p;while(1){d=d+-1|0;l=c[o>>2]|0;c[f>>2]=l>>>3&15728880|l>>>4&251662080|l>>>1&983055|-268374016;if(!d)break;else{f=f+4|0;o=o+4|0}}q=h;r=p+(g<<1)|0}if(!(n&1)){i=a;return}n=e[r>>1]|0;b[q>>1]=n>>>3&240|n>>>4&3840|n>>>1&15|61440;i=a;return}function bme(a,b){a=a|0;b=b|0;var d=0,f=0,g=0;a=i;d=c[b+12>>2]|0;if(!d){i=a;return}f=d;d=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=e[g>>1]|0;c[d>>2]=b<<5&64512|b<<8&16252928|b<<3&248|-16777216;if(!f)break;else{d=d+4|0;g=g+2|0}}i=a;return}function cme(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;j=d&2016;a[f>>0]=d>>>8&248|d>>>13;a[f+1>>0]=(j<<5|j>>>1)>>>8;a[f+2>>0]=(d<<14&458752|d<<19)>>>16;if(!g)break;else{f=f+3|0;h=h+2|0}}i=b;return}function dme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[e+12>>2]|0;if(!f){i=b;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;a[f>>0]=(d[1055673+((d[h+1>>0]|0)<<2)>>0]|0)+(d[1055674+((d[h+2>>0]|0)<<2)>>0]|0)+(d[1055672+((d[h>>0]|0)<<2)>>0]|0);if(!g)break;else{f=f+1|0;h=h+3|0}}i=b;return}function eme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[e+12>>2]|0;if(!f){i=b;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;a[f>>0]=(d[h+1>>0]|0)>>>3&28|(d[h>>0]|0)>>>6|(d[h+2>>0]|0)&224;if(!g)break;else{f=f+1|0;h=h+3|0}}i=b;return}function fme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;b[f>>1]=(d[h+1>>0]|0)<<3&2016|(d[h>>0]|0)>>>3|(d[h+2>>0]|0)<<8&63488;if(!g)break;else{f=f+2|0;h=h+3|0}}i=a;return}function gme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;b[f>>1]=(d[h>>0]|0)>>>3|(d[h+1>>0]|0)<<2&992|(d[h+2>>0]|0)<<7&31744|32768;if(!g)break;else{f=f+2|0;h=h+3|0}}i=a;return}function hme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[e+12>>2]|0;if(!f){i=a;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;b[f>>1]=(d[h>>0]|0)>>>4|(d[h+1>>0]|0)&240|(d[h+2>>0]|0)<<4&3840|61440;if(!g)break;else{f=f+2|0;h=h+3|0}}i=a;return}function ime(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;a=i;e=c[b+12>>2]|0;if(!e){i=a;return}f=e;e=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;c[e>>2]=d[g>>0]|0|(d[g+1>>0]|0)<<8|(d[g+2>>0]|0)<<16|-16777216;if(!f)break;else{e=e+4|0;g=g+3|0}}i=a;return}function jme(b,f){b=b|0;f=f|0;var g=0,h=0,j=0;b=i;g=c[f+12>>2]|0;if(!g){i=b;return}h=g;g=c[f>>2]|0;j=c[f+4>>2]|0;while(1){h=h+-1|0;f=e[j>>1]|0;a[g>>0]=(d[1055673+((f>>>2&248)<<2)>>0]|0)+(d[1055674+((f>>>7&248)<<2)>>0]|0)+(d[1055672+((f<<3&248)<<2)>>0]|0);if(!h)break;else{g=g+1|0;j=j+2|0}}i=b;return}function kme(b,d){b=b|0;d=d|0;var f=0,g=0,h=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;a[f>>0]=d>>>7&224|d>>>5&28|d>>>3&3;if(!g)break;else{f=f+1|0;h=h+2|0}}i=b;return}function lme(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;f=c[d+4>>2]|0;g=c[d>>2]|0;h=c[d+12>>2]|0;d=f;if((g^d)&2){if(!h){i=a;return}else{j=h;k=g;l=f}while(1){j=j+-1|0;m=e[l>>1]|0;b[k>>1]=(m&32767)+(m&32736);if(!j)break;else{k=k+2|0;l=l+2|0}}i=a;return}if(!(d&2)){n=h;o=g;p=f}else{d=e[f>>1]|0;b[g>>1]=(d&32767)+(d&32736);n=h+-1|0;o=g+2|0;p=f+2|0}f=n>>>1;if(!f){q=o;r=p}else{g=f<<1;h=o+(g<<1)|0;d=f;f=o;o=p;while(1){d=d+-1|0;l=c[o>>2]|0;c[f>>2]=(l&2147450879)+(l&2145419232);if(!d)break;else{f=f+4|0;o=o+4|0}}q=h;r=p+(g<<1)|0}if(!(n&1)){i=a;return}n=e[r>>1]|0;b[q>>1]=(n&32767)+(n&32736);i=a;return}function mme(b,d){b=b|0;d=d|0;var f=0,g=0,h=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;a[f>>0]=d<<3;a[f+1>>0]=d>>>2&248;a[f+2>>0]=d>>>7&248;if(!g)break;else{f=f+3|0;h=h+2|0}}i=b;return}function nme(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;f=c[d+4>>2]|0;g=c[d>>2]|0;h=c[d+12>>2]|0;d=f;if((g^d)&2){if(!h){i=a;return}else{j=h;k=g;l=f}while(1){j=j+-1|0;m=e[l>>1]|0;n=m>>>3;b[k>>1]=n&3840|m>>>2&240|m>>>1&15|65536-(n&4096);if(!j)break;else{k=k+2|0;l=l+2|0}}i=a;return}if(!(d&2)){o=h;p=g;q=f}else{d=e[f>>1]|0;l=d>>>3;b[g>>1]=l&3840|d>>>2&240|d>>>1&15|65536-(l&4096);o=h+-1|0;p=g+2|0;q=f+2|0}f=o>>>1;if(!f){r=p;s=q}else{g=f<<1;h=p+(g<<1)|0;l=f;f=p;p=q;while(1){l=l+-1|0;d=c[p>>2]|0;c[f>>2]=d>>>3&251662080|d>>>2&15728880|d>>>1&983055|0-(d>>>4&2048)&-268374016;if(!l)break;else{f=f+4|0;p=p+4|0}}r=h;s=q+(g<<1)|0}if(!(o&1)){i=a;return}o=e[s>>1]|0;s=o>>>3;b[r>>1]=s&3840|o>>>2&240|o>>>1&15|65536-(s&4096);i=a;return}function ome(a,b){a=a|0;b=b|0;var d=0,f=0,g=0;a=i;d=c[b+12>>2]|0;if(!d){i=a;return}f=d;d=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=e[g>>1]|0;c[d>>2]=b<<9&16252928|b<<6&63488|b<<3&248|0-(b&32768)&-16777216;if(!f)break;else{d=d+4|0;g=g+2|0}}i=a;return}function pme(b,f){b=b|0;f=f|0;var g=0,h=0,j=0;b=i;g=c[f+12>>2]|0;if(!g){i=b;return}h=g;g=c[f>>2]|0;j=c[f+4>>2]|0;while(1){h=h+-1|0;f=e[j>>1]|0;a[g>>0]=(d[1055673+((f&240)<<2)>>0]|0)+(d[1055674+((f>>>8&15)<<2)>>0]|0)+(d[1055672+((f<<4&240)<<2)>>0]|0);if(!h)break;else{g=g+1|0;j=j+2|0}}i=b;return}function qme(b,d){b=b|0;d=d|0;var f=0,g=0,h=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;a[f>>0]=d>>>4&224|d>>>3&28|d>>>2&3;if(!g)break;else{f=f+1|0;h=h+2|0}}i=b;return}function rme(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;f=c[d+4>>2]|0;g=c[d>>2]|0;h=c[d+12>>2]|0;d=f;if((g^d)&2){if(!h){i=a;return}else{j=h;k=g;l=f}while(1){j=j+-1|0;m=e[l>>1]|0;b[k>>1]=m<<4&61440|m<<3&1920|m<<1&30;if(!j)break;else{k=k+2|0;l=l+2|0}}i=a;return}if(!(d&2)){n=h;o=g;p=f}else{d=e[f>>1]|0;b[g>>1]=d<<4&61440|d<<3&1920|d<<1&30;n=h+-1|0;o=g+2|0;p=f+2|0}f=n>>>1;if(!f){q=o;r=p}else{g=f<<1;h=o+(g<<1)|0;d=f;f=o;o=p;while(1){d=d+-1|0;l=c[o>>2]|0;c[f>>2]=l<<4&-268374016|l<<3&125831040|l<<1&1966110;if(!d)break;else{f=f+4|0;o=o+4|0}}q=h;r=p+(g<<1)|0}if(!(n&1)){i=a;return}n=e[r>>1]|0;b[q>>1]=n<<4&61440|n<<3&1920|n<<1&30;i=a;return}function sme(b,d){b=b|0;d=d|0;var f=0,g=0,h=0;b=i;f=c[d+12>>2]|0;if(!f){i=b;return}g=f;f=c[d>>2]|0;h=c[d+4>>2]|0;while(1){g=g+-1|0;d=e[h>>1]|0;a[f>>0]=d<<4;a[f+1>>0]=d&240;a[f+2>>0]=d>>>4&240;if(!g)break;else{f=f+3|0;h=h+2|0}}i=b;return}function tme(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;f=c[d+4>>2]|0;g=c[d>>2]|0;h=c[d+12>>2]|0;d=f;if((g^d)&2){if(!h){i=a;return}else{j=h;k=g;l=f}while(1){j=j+-1|0;m=e[l>>1]|0;b[k>>1]=m<<2&960|m&32768|m<<3&30720|m<<1&30;if(!j)break;else{k=k+2|0;l=l+2|0}}i=a;return}if(!(d&2)){n=h;o=g;p=f}else{d=e[f>>1]|0;b[g>>1]=d<<2&960|d&32768|d<<3&30720|d<<1&30;n=h+-1|0;o=g+2|0;p=f+2|0}f=n>>>1;if(!f){q=o;r=p}else{g=f<<1;h=o+(g<<1)|0;d=f;f=o;o=p;while(1){d=d+-1|0;l=c[o>>2]|0;c[f>>2]=l<<2&62915520|l&-2147450880|l<<3&2013296640|l<<1&1966110;if(!d)break;else{f=f+4|0;o=o+4|0}}q=h;r=p+(g<<1)|0}if(!(n&1)){i=a;return}n=e[r>>1]|0;b[q>>1]=n<<2&960|n&32768|n<<3&30720|n<<1&30;i=a;return}function ume(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;a=i;d=c[b+12>>2]|0;if(!d){i=a;return}f=d;d=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=e[g>>1]|0;h=b<<8&983040|b&15|b<<12&251658240|b<<4&3840;c[d>>2]=h<<4|h;if(!f)break;else{d=d+4|0;g=g+2|0}}i=a;return}function vme(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;a=i;d=c[b+12>>2]|0;if(!d){i=a;return}f=d;d=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=e[g>>1]|0;h=b<<12&251658240|b>>>8&15|b<<4&3840|b<<16&983040;c[d>>2]=h<<4|h;if(!f)break;else{d=d+4|0;g=g+2|0}}i=a;return}function wme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[e+12>>2]|0;if(!f){i=b;return}g=f;f=c[e>>2]|0;h=c[e+4>>2]|0;while(1){g=g+-1|0;e=c[h>>2]|0;a[f>>0]=(d[1055673+((e>>>8&255)<<2)>>0]|0)+(d[1055674+((e>>>16&255)<<2)>>0]|0)+(d[1055672+((e&255)<<2)>>0]|0);if(!g)break;else{f=f+1|0;h=h+4|0}}i=b;return}function xme(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[d+12>>2]|0;if(!e){i=b;return}f=e;e=c[d>>2]|0;g=c[d+4>>2]|0;while(1){f=f+-1|0;d=c[g>>2]|0;a[e>>0]=d>>>16&224|d>>>11&28|d>>>6&3;if(!f)break;else{e=e+1|0;g=g+4|0}}i=b;return}function yme(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[d+12>>2]|0;if(!e){i=a;return}f=e;e=c[d>>2]|0;g=c[d+4>>2]|0;while(1){f=f+-1|0;d=c[g>>2]|0;b[e>>1]=d>>>8&63488|d>>>5&2016|d>>>3&31;if(!f)break;else{e=e+2|0;g=g+4|0}}i=a;return}function zme(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[d+12>>2]|0;if(!e){i=b;return}f=e;e=c[d>>2]|0;g=c[d+4>>2]|0;while(1){f=f+-1|0;d=c[g>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>>8;a[e+2>>0]=d>>>16;if(!f)break;else{e=e+3|0;g=g+4|0}}i=b;return}function Ame(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[d+12>>2]|0;if(!e){i=a;return}f=e;e=c[d>>2]|0;g=c[d+4>>2]|0;while(1){f=f+-1|0;d=c[g>>2]|0;b[e>>1]=d>>>9&31744|d>>>6&992|d>>>3&31|d>>>16&32768;if(!f)break;else{e=e+2|0;g=g+4|0}}i=a;return}function Bme(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[d+12>>2]|0;if(!e){i=a;return}f=e;e=c[d>>2]|0;g=c[d+4>>2]|0;while(1){f=f+-1|0;d=c[g>>2]|0;b[e>>1]=d>>>12&3840|d>>>8&240|d>>>4&15|d>>>16&61440;if(!f)break;else{e=e+2|0;g=g+4|0}}i=a;return}function Cme(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;a=i;d=c[b+12>>2]|0;if(!d){i=a;return}f=d;d=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=e[g>>1]|0;h=b<<4&983040|b&3840|b>>>4&15|b<<24&251658240;c[d>>2]=h<<4|h;if(!f)break;else{d=d+4|0;g=g+2|0}}i=a;return}function Dme(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;a=i;d=c[b+12>>2]|0;if(!d){i=a;return}f=d;d=c[b>>2]|0;g=c[b+4>>2]|0;while(1){f=f+-1|0;b=e[g>>1]|0;h=b>>>12|b&3840|b<<12&983040|b<<24&251658240;c[d>>2]=h<<4|h;if(!f)break;else{d=d+4|0;g=g+2|0}}i=a;return}function Eme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+64|0;r=b+60|0;s=b+68|0;t=b+40|0;u=b+36|0;v=b+44|0;w=b+72|0;x=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){x=x+-1|0;e=d[y>>0]|0;a[g>>0]=e>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!x)break;else{g=g+1|0;y=y+1|0}}i=f;return}function Fme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+64>>2]|0;s=c[a+60>>2]|0;t=c[a+68>>2]|0;u=c[a+40>>2]|0;v=c[a+36>>2]|0;w=c[a+44>>2]|0;x=c[a+72>>2]|0;a=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){a=a+-1|0;e=d[y>>0]|0;b[g>>1]=e>>>u<<v&w|x|((d[1055673+((e>>>l<<m&n)<<2)>>0]|0)+(d[1055674+((e>>>h<<j&k)<<2)>>0]|0)+(d[1055672+((e>>>o<<p&q)<<2)>>0]|0)|0)>>>r<<s&t;if(!a)break;else{g=g+2|0;y=y+1|0}}i=f;return}function Gme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+64|0;r=b+60|0;s=b+68|0;t=b+40|0;u=b+36|0;v=b+44|0;w=b+72|0;x=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){x=x+-1|0;e=d[y>>0]|0;z=e>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];a[g>>0]=z;a[g+1>>0]=z>>>8;a[g+2>>0]=z>>>16;if(!x)break;else{g=g+3|0;y=y+1|0}}i=f;return}function Hme(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[b+12>>2]|0;if(!f){i=e;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+64|0;q=a+60|0;r=a+68|0;s=a+40|0;t=a+36|0;u=a+44|0;v=a+72|0;w=f;f=c[b>>2]|0;x=c[b+4>>2]|0;while(1){w=w+-1|0;b=d[x>>0]|0;c[f>>2]=b>>>(c[s>>2]|0)<<c[t>>2]&c[u>>2]|((d[1055673+((b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2])<<2)>>0]|0)|0)>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[v>>2];if(!w)break;else{f=f+4|0;x=x+1|0}}i=e;return}function Ime(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;h=c[f+12>>2]|0;if(!h){i=g;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=h;h=c[f>>2]|0;z=c[f+4>>2]|0;while(1){y=y+-1|0;f=e[z>>1]|0;a[h>>0]=f>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((f>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((f>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((f>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];if(!y)break;else{h=h+1|0;z=z+2|0}}i=g;return}function Jme(a,f){a=a|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;h=c[f+12>>2]|0;if(!h){i=g;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+64>>2]|0;t=c[a+60>>2]|0;u=c[a+68>>2]|0;v=c[a+40>>2]|0;w=c[a+36>>2]|0;x=c[a+44>>2]|0;y=c[a+72>>2]|0;a=h;h=c[f>>2]|0;z=c[f+4>>2]|0;while(1){a=a+-1|0;f=e[z>>1]|0;b[h>>1]=f>>>v<<w&x|y|((d[1055673+((f>>>m<<n&o)<<2)>>0]|0)+(d[1055674+((f>>>j<<k&l)<<2)>>0]|0)+(d[1055672+((f>>>p<<q&r)<<2)>>0]|0)|0)>>>s<<t&u;if(!a)break;else{h=h+2|0;z=z+2|0}}i=g;return}function Kme(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;h=c[f+12>>2]|0;if(!h){i=g;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=h;h=c[f>>2]|0;z=c[f+4>>2]|0;while(1){y=y+-1|0;f=e[z>>1]|0;A=f>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((f>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((f>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((f>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];a[h>>0]=A;a[h+1>>0]=A>>>8;a[h+2>>0]=A>>>16;if(!y)break;else{h=h+3|0;z=z+2|0}}i=g;return}function Lme(a,b){a=a|0;b=b|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[b+12>>2]|0;if(!g){i=f;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+64|0;r=a+60|0;s=a+68|0;t=a+40|0;u=a+36|0;v=a+44|0;w=a+72|0;x=g;g=c[b>>2]|0;y=c[b+4>>2]|0;while(1){x=x+-1|0;b=e[y>>1]|0;c[g>>2]=b>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((b>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!x)break;else{g=g+4|0;y=y+2|0}}i=f;return}function Mme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+64|0;r=b+60|0;s=b+68|0;t=b+40|0;u=b+36|0;v=b+44|0;w=b+72|0;x=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){x=x+-1|0;e=(d[y+1>>0]|0)<<8|(d[y>>0]|0)|(d[y+2>>0]|0)<<16;a[g>>0]=e>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!x)break;else{g=g+1|0;y=y+3|0}}i=f;return}function Nme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+64>>2]|0;s=c[a+60>>2]|0;t=c[a+68>>2]|0;u=c[a+40>>2]|0;v=c[a+36>>2]|0;w=c[a+44>>2]|0;x=c[a+72>>2]|0;a=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){a=a+-1|0;e=(d[y+1>>0]|0)<<8|(d[y>>0]|0)|(d[y+2>>0]|0)<<16;b[g>>1]=e>>>u<<v&w|((d[1055673+((e>>>l<<m&n)<<2)>>0]|0)+(d[1055674+((e>>>h<<j&k)<<2)>>0]|0)+(d[1055672+((e>>>o<<p&q)<<2)>>0]|0)|0)>>>r<<s&t|x;if(!a)break;else{g=g+2|0;y=y+3|0}}i=f;return}function Ome(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+64|0;r=b+60|0;s=b+68|0;t=b+40|0;u=b+36|0;v=b+44|0;w=b+72|0;x=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){x=x+-1|0;e=(d[y+1>>0]|0)<<8|(d[y>>0]|0)|(d[y+2>>0]|0)<<16;z=e>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];a[g>>0]=z;a[g+1>>0]=z>>>8;a[g+2>>0]=z>>>16;if(!x)break;else{g=g+3|0;y=y+3|0}}i=f;return}function Pme(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[b+12>>2]|0;if(!f){i=e;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+64|0;q=a+60|0;r=a+68|0;s=a+40|0;t=a+36|0;u=a+44|0;v=a+72|0;w=f;f=c[b>>2]|0;x=c[b+4>>2]|0;while(1){w=w+-1|0;b=(d[x+1>>0]|0)<<8|(d[x>>0]|0)|(d[x+2>>0]|0)<<16;c[f>>2]=b>>>(c[s>>2]|0)<<c[t>>2]&c[u>>2]|((d[1055673+((b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2])<<2)>>0]|0)|0)>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[v>>2];if(!w)break;else{f=f+4|0;x=x+3|0}}i=e;return}function Qme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+64|0;r=b+60|0;s=b+68|0;t=b+40|0;u=b+36|0;v=b+44|0;w=b+72|0;x=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){x=x+-1|0;e=c[y>>2]|0;a[g>>0]=e>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!x)break;else{g=g+1|0;y=y+4|0}}i=f;return}function Rme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+64>>2]|0;s=c[a+60>>2]|0;t=c[a+68>>2]|0;u=c[a+40>>2]|0;v=c[a+36>>2]|0;w=c[a+44>>2]|0;x=c[a+72>>2]|0;a=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){a=a+-1|0;e=c[y>>2]|0;b[g>>1]=e>>>u<<v&w|x|((d[1055673+((e>>>l<<m&n)<<2)>>0]|0)+(d[1055674+((e>>>h<<j&k)<<2)>>0]|0)+(d[1055672+((e>>>o<<p&q)<<2)>>0]|0)|0)>>>r<<s&t;if(!a)break;else{g=g+2|0;y=y+4|0}}i=f;return}function Sme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+64|0;r=b+60|0;s=b+68|0;t=b+40|0;u=b+36|0;v=b+44|0;w=b+72|0;x=g;g=c[e>>2]|0;y=c[e+4>>2]|0;while(1){x=x+-1|0;e=c[y>>2]|0;z=e>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];a[g>>0]=z;a[g+1>>0]=z>>>8;a[g+2>>0]=z>>>16;if(!x)break;else{g=g+3|0;y=y+4|0}}i=f;return}function Tme(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[b+12>>2]|0;if(!f){i=e;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+64|0;q=a+60|0;r=a+68|0;s=a+40|0;t=a+36|0;u=a+44|0;v=a+72|0;w=f;f=c[b>>2]|0;x=c[b+4>>2]|0;while(1){w=w+-1|0;b=c[x>>2]|0;c[f>>2]=b>>>(c[s>>2]|0)<<c[t>>2]&c[u>>2]|((d[1055673+((b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2])<<2)>>0]|0)|0)>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[v>>2];if(!w)break;else{f=f+4|0;x=x+4|0}}i=e;return}function Ume(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=g;g=c[e>>2]|0;v=c[e+4>>2]|0;while(1){u=u+-1|0;e=d[v>>0]|0;a[g>>0]=e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|e>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!u)break;else{g=g+1|0;v=v+1|0}}i=f;return}function Vme(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+40>>2]|0;s=c[a+36>>2]|0;t=c[a+44>>2]|0;u=c[a+72>>2]|0;a=g;g=c[e>>2]|0;v=c[e+4>>2]|0;while(1){a=a+-1|0;e=d[v>>0]|0;b[g>>1]=e>>>h<<j&k|u|e>>>l<<m&n|e>>>o<<p&q|e>>>r<<s&t;if(!a)break;else{g=g+2|0;v=v+1|0}}i=f;return}function Wme(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=g;g=c[e>>2]|0;v=c[e+4>>2]|0;while(1){u=u+-1|0;e=d[v>>0]|0;w=e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|e>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];a[g>>0]=w;a[g+1>>0]=w>>>8;a[g+2>>0]=w>>>16;if(!u)break;else{g=g+3|0;v=v+1|0}}i=f;return}function Xme(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=c[b+12>>2]|0;if(!f){i=e;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+40|0;q=a+36|0;r=a+44|0;s=a+72|0;t=f;f=c[b>>2]|0;u=c[b+4>>2]|0;while(1){t=t+-1|0;b=d[u>>0]|0;c[f>>2]=b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2]|b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2]|b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2]|b>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[s>>2];if(!t)break;else{f=f+4|0;u=u+1|0}}i=e;return}function Yme(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[d+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=g;g=c[d>>2]|0;v=c[d+4>>2]|0;while(1){u=u+-1|0;d=e[v>>1]|0;a[g>>0]=d>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|d>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|d>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|d>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!u)break;else{g=g+1|0;v=v+2|0}}i=f;return}function Zme(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[d+12>>2]|0;if(!g){i=f;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+40>>2]|0;s=c[a+36>>2]|0;t=c[a+44>>2]|0;u=c[a+72>>2]|0;a=g;g=c[d>>2]|0;v=c[d+4>>2]|0;while(1){a=a+-1|0;d=e[v>>1]|0;b[g>>1]=d>>>h<<j&k|u|d>>>l<<m&n|d>>>o<<p&q|d>>>r<<s&t;if(!a)break;else{g=g+2|0;v=v+2|0}}i=f;return}function _me(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[d+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=g;g=c[d>>2]|0;v=c[d+4>>2]|0;while(1){u=u+-1|0;d=e[v>>1]|0;w=d>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|d>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|d>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|d>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];a[g>>0]=w;a[g+1>>0]=w>>>8;a[g+2>>0]=w>>>16;if(!u)break;else{g=g+3|0;v=v+2|0}}i=f;return}function $me(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;f=c[b+12>>2]|0;if(!f){i=d;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+40|0;q=a+36|0;r=a+44|0;s=a+72|0;t=f;f=c[b>>2]|0;u=c[b+4>>2]|0;while(1){t=t+-1|0;b=e[u>>1]|0;c[f>>2]=b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2]|b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2]|b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2]|b>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[s>>2];if(!t)break;else{f=f+4|0;u=u+2|0}}i=d;return}function ane(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=g;g=c[e>>2]|0;v=c[e+4>>2]|0;while(1){u=u+-1|0;e=(d[v+1>>0]|0)<<8|(d[v>>0]|0)|(d[v+2>>0]|0)<<16;a[g>>0]=e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|e>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!u)break;else{g=g+1|0;v=v+3|0}}i=f;return}function bne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+40>>2]|0;s=c[a+36>>2]|0;t=c[a+44>>2]|0;u=c[a+72>>2]|0;a=g;g=c[e>>2]|0;v=c[e+4>>2]|0;while(1){a=a+-1|0;e=(d[v+1>>0]|0)<<8|(d[v>>0]|0)|(d[v+2>>0]|0)<<16;b[g>>1]=e>>>l<<m&n|e>>>h<<j&k|e>>>o<<p&q|e>>>r<<s&t|u;if(!a)break;else{g=g+2|0;v=v+3|0}}i=f;return}function cne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[e+12>>2]|0;if(!g){i=f;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=g;g=c[e>>2]|0;v=c[e+4>>2]|0;while(1){u=u+-1|0;e=(d[v+1>>0]|0)<<8|(d[v>>0]|0)|(d[v+2>>0]|0)<<16;w=e>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|e>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|e>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|e>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];a[g>>0]=w;a[g+1>>0]=w>>>8;a[g+2>>0]=w>>>16;if(!u)break;else{g=g+3|0;v=v+3|0}}i=f;return}function dne(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=c[b+12>>2]|0;if(!f){i=e;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+40|0;q=a+36|0;r=a+44|0;s=a+72|0;t=f;f=c[b>>2]|0;u=c[b+4>>2]|0;while(1){t=t+-1|0;b=(d[u+1>>0]|0)<<8|(d[u>>0]|0)|(d[u+2>>0]|0)<<16;c[f>>2]=b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2]|b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2]|b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2]|b>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[s>>2];if(!t)break;else{f=f+4|0;u=u+3|0}}i=e;return}function ene(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=c[d+12>>2]|0;if(!f){i=e;return}g=b+4|0;h=b+8|0;j=b+16|0;k=b+12|0;l=b+20|0;m=b+28|0;n=b+24|0;o=b+32|0;p=b+40|0;q=b+36|0;r=b+44|0;s=b+72|0;t=f;f=c[d>>2]|0;u=c[d+4>>2]|0;while(1){t=t+-1|0;d=c[u>>2]|0;a[f>>0]=d>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2]|d>>>(c[g>>2]|0)<<c[b>>2]&c[h>>2]|d>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2]|d>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[s>>2];if(!t)break;else{f=f+1|0;u=u+4|0}}i=e;return}function fne(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;f=c[d+12>>2]|0;if(!f){i=e;return}g=c[a+4>>2]|0;h=c[a>>2]|0;j=c[a+8>>2]|0;k=c[a+16>>2]|0;l=c[a+12>>2]|0;m=c[a+20>>2]|0;n=c[a+28>>2]|0;o=c[a+24>>2]|0;p=c[a+32>>2]|0;q=c[a+40>>2]|0;r=c[a+36>>2]|0;s=c[a+44>>2]|0;t=c[a+72>>2]|0;a=f;f=c[d>>2]|0;u=c[d+4>>2]|0;while(1){a=a+-1|0;d=c[u>>2]|0;b[f>>1]=d>>>g<<h&j|t|d>>>k<<l&m|d>>>n<<o&p|d>>>q<<r&s;if(!a)break;else{f=f+2|0;u=u+4|0}}i=e;return}function gne(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[d+12>>2]|0;if(!f){i=e;return}g=b+4|0;h=b+8|0;j=b+16|0;k=b+12|0;l=b+20|0;m=b+28|0;n=b+24|0;o=b+32|0;p=b+40|0;q=b+36|0;r=b+44|0;s=b+72|0;t=f;f=c[d>>2]|0;u=c[d+4>>2]|0;while(1){t=t+-1|0;d=c[u>>2]|0;v=d>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2]|d>>>(c[g>>2]|0)<<c[b>>2]&c[h>>2]|d>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2]|d>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[s>>2];a[f>>0]=v;a[f+1>>0]=v>>>8;a[f+2>>0]=v>>>16;if(!t)break;else{f=f+3|0;u=u+4|0}}i=e;return}function hne(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[b+12>>2]|0;if(!e){i=d;return}f=a+4|0;g=a+8|0;h=a+16|0;j=a+12|0;k=a+20|0;l=a+28|0;m=a+24|0;n=a+32|0;o=a+40|0;p=a+36|0;q=a+44|0;r=a+72|0;s=e;e=c[b>>2]|0;t=c[b+4>>2]|0;while(1){s=s+-1|0;b=c[t>>2]|0;c[e>>2]=b>>>(c[h>>2]|0)<<c[j>>2]&c[k>>2]|b>>>(c[f>>2]|0)<<c[a>>2]&c[g>>2]|b>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|b>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|c[r>>2];if(!s)break;else{e=e+4|0;t=t+4|0}}i=d;return}function ine(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=c[d+4>>2]|0;f=c[d+12>>2]|0;if(!f){i=b;return}g=d+20|0;h=f;f=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;a[f>>0]=a[e+(j>>>16)>>0]|0;if(!h)break;else{f=f+1|0;j=(c[g>>2]|0)+j|0}}i=b;return}function jne(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[d+4>>2]|0;f=c[d+12>>2]|0;if(!f){i=a;return}g=c[d+20>>2]|0;h=f;f=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;b[f>>1]=b[e+(j>>>16<<1)>>1]|0;if(!h)break;else{f=f+2|0;j=g+j|0}}i=a;return}function kne(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;e=c[d+4>>2]|0;f=c[d+12>>2]|0;if(!f){i=b;return}g=d+20|0;h=f;f=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=(j>>>16)*3|0;k=a[e+(d+1)>>0]|0;l=a[e+(d+2)>>0]|0;a[f>>0]=a[e+d>>0]|0;a[f+1>>0]=k;a[f+2>>0]=l;if(!h)break;else{f=f+3|0;j=(c[g>>2]|0)+j|0}}i=b;return}function lne(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;d=c[b+4>>2]|0;e=c[b+12>>2]|0;if(!e){i=a;return}f=b+20|0;g=e;e=c[b>>2]|0;h=c[b+16>>2]|0;while(1){g=g+-1|0;c[e>>2]=c[d+(h>>>16<<2)>>2];if(!g)break;else{e=e+4|0;h=(c[f>>2]|0)+h|0}}i=a;return}function mne(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=c[d+4>>2]|0;f=c[d+12>>2]|0;if(!f){i=b;return}g=d+20|0;h=f;f=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;a[f>>0]=a[e+(j>>>16)>>0]|0;if(!h)break;else{f=f+1|0;j=(c[g>>2]|0)+j|0}}i=b;return}function nne(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[d+4>>2]|0;f=c[d+12>>2]|0;if(!f){i=a;return}g=c[d+20>>2]|0;h=f;f=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;b[f>>1]=b[e+(j>>>16<<1)>>1]|0;if(!h)break;else{f=f+2|0;j=g+j|0}}i=a;return}function one(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;e=c[d+4>>2]|0;f=c[d+12>>2]|0;if(!f){i=b;return}g=d+20|0;h=f;f=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=(j>>>16)*3|0;k=a[e+(d+1)>>0]|0;l=a[e+(d+2)>>0]|0;a[f>>0]=a[e+d>>0]|0;a[f+1>>0]=k;a[f+2>>0]=l;if(!h)break;else{f=f+3|0;j=(c[g>>2]|0)+j|0}}i=b;return}function pne(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;d=c[b+4>>2]|0;e=c[b+12>>2]|0;if(!e){i=a;return}f=b+20|0;g=e;e=c[b>>2]|0;h=c[b+16>>2]|0;while(1){g=g+-1|0;c[e>>2]=c[d+(h>>>16<<2)>>2];if(!g)break;else{e=e+4|0;h=(c[f>>2]|0)+h|0}}i=a;return}function qne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;b=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=b;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;l=e&224;a[h>>0]=e>>>6|l|l>>>3;if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function rne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;b[h>>1]=e<<3&2016|e>>>3|e<<8&63488;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function sne(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=c[d+20>>2]|0;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=b;return}h=g;g=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=a[f+(j>>>16)>>0]|0;a[g>>0]=d;a[g+1>>0]=d;a[g+2>>0]=d;if(!h)break;else{g=g+3|0;j=j+e|0}}i=b;return}function tne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;l=e&248;b[h>>1]=e>>>3|l<<2|l<<7|32768;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function une(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;l=e&240;b[h>>1]=l|e>>>4|l<<4|61440;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function vne(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[b+20>>2]|0;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=a;return}h=g;g=c[b>>2]|0;j=c[b+16>>2]|0;while(1){h=h+-1|0;b=d[f+(j>>>16)>>0]|0;c[g>>2]=b|b<<8|b<<16|-16777216;if(!h)break;else{g=g+4|0;j=j+e|0}}i=a;return}function wne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=b;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;a[h>>0]=(d[1055673+((e<<3&224)<<2)>>0]|0)+(d[1055674+((e&224)<<2)>>0]|0)+(d[1055672+((e<<6&192)<<2)>>0]|0);if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function xne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;b[h>>1]=e<<8&57344|e<<6&1792|e<<3&24;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function yne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=b;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;a[h>>0]=e<<6;a[h+1>>0]=e<<3&224;a[h+2>>0]=e&224;if(!j)break;else{h=h+3|0;k=k+f|0}}i=b;return}function zne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;b[h>>1]=e<<5&896|e<<7&28672|e<<3&24|32768;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Ane(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=d[g+(k>>>16)>>0]|0;b[h>>1]=e<<3&224|e<<4&3584|e<<2&12|61440;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Bne(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[b+20>>2]|0;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=a;return}h=g;g=c[b>>2]|0;j=c[b+16>>2]|0;while(1){h=h+-1|0;b=d[f+(j>>>16)>>0]|0;c[g>>2]=b<<11&57344|b<<16&14680064|b<<6&192|-16777216;if(!h)break;else{g=g+4|0;j=j+e|0}}i=a;return}function Cne(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;g=c[f+20>>2]|0;h=c[f+4>>2]|0;j=c[f+12>>2]|0;if(!j){i=b;return}k=j;j=c[f>>2]|0;l=c[f+16>>2]|0;while(1){k=k+-1|0;f=e[h+(l>>>16<<1)>>1]|0;a[j>>0]=(d[1055673+((f>>>3&252)<<2)>>0]|0)+(d[1055674+((f>>>8&248)<<2)>>0]|0)+(d[1055672+((f<<3&248)<<2)>>0]|0);if(!k)break;else{j=j+1|0;l=l+g|0}}i=b;return}function Dne(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=b;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;a[h>>0]=d>>>8&224|d>>>6&28|d>>>3&3;if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function Ene(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=b;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;a[h>>0]=d<<3;a[h+1>>0]=d>>>3&252;a[h+2>>0]=d>>>8&248;if(!j)break;else{h=h+3|0;k=k+f|0}}i=b;return}function Fne(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=a;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;b[h>>1]=d&31|d>>>1&32736|32768;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Gne(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=a;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;b[h>>1]=d>>>3&240|d>>>4&3840|d>>>1&15|61440;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Hne(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0;a=i;d=c[b+20>>2]|0;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=a;return}h=g;g=c[b>>2]|0;j=c[b+16>>2]|0;while(1){h=h+-1|0;b=e[f+(j>>>16<<1)>>1]|0;c[g>>2]=b<<5&64512|b<<8&16252928|b<<3&248|-16777216;if(!h)break;else{g=g+4|0;j=j+d|0}}i=a;return}function Ine(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=b;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=(k>>>16)*3|0;a[h>>0]=(d[1055673+((d[g+(e+1)>>0]|0)<<2)>>0]|0)+(d[1055674+((d[g+(e+2)>>0]|0)<<2)>>0]|0)+(d[1055672+((d[g+e>>0]|0)<<2)>>0]|0);if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function Jne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=b;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=(k>>>16)*3|0;a[h>>0]=(d[g+(e+1)>>0]|0)>>>3&28|(d[g+e>>0]|0)>>>6|(d[g+(e+2)>>0]|0)&224;if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function Kne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=(k>>>16)*3|0;b[h>>1]=(d[g+(e+1)>>0]|0)<<3&2016|(d[g+e>>0]|0)>>>3|(d[g+(e+2)>>0]|0)<<8&63488;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Lne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=(k>>>16)*3|0;b[h>>1]=(d[g+e>>0]|0)>>>3|(d[g+(e+1)>>0]|0)<<2&992|(d[g+(e+2)>>0]|0)<<7&31744|32768;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Mne(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=a;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=(k>>>16)*3|0;b[h>>1]=(d[g+e>>0]|0)>>>4|(d[g+(e+1)>>0]|0)&240|(d[g+(e+2)>>0]|0)<<4&3840|61440;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Nne(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[b+20>>2]|0;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=a;return}h=g;g=c[b>>2]|0;j=c[b+16>>2]|0;while(1){h=h+-1|0;b=(j>>>16)*3|0;c[g>>2]=d[f+b>>0]|0|(d[f+(b+1)>>0]|0)<<8|(d[f+(b+2)>>0]|0)<<16|-16777216;if(!h)break;else{g=g+4|0;j=j+e|0}}i=a;return}function One(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;g=c[f+20>>2]|0;h=c[f+4>>2]|0;j=c[f+12>>2]|0;if(!j){i=b;return}k=j;j=c[f>>2]|0;l=c[f+16>>2]|0;while(1){k=k+-1|0;f=e[h+(l>>>16<<1)>>1]|0;a[j>>0]=(d[1055673+((f>>>2&248)<<2)>>0]|0)+(d[1055674+((f>>>7&248)<<2)>>0]|0)+(d[1055672+((f<<3&248)<<2)>>0]|0);if(!k)break;else{j=j+1|0;l=l+g|0}}i=b;return}function Pne(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=b;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;a[h>>0]=d>>>7&224|d>>>5&28|d>>>3&3;if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function Qne(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=a;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;b[h>>1]=(d&32767)+(d&32736);if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Rne(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=b;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;a[h>>0]=d<<3;a[h+1>>0]=d>>>2&248;a[h+2>>0]=d>>>7&248;if(!j)break;else{h=h+3|0;k=k+f|0}}i=b;return}function Sne(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0;a=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=a;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;l=d>>>3;b[h>>1]=l&3840|d>>>2&240|d>>>1&15|65536-(l&4096);if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Tne(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0;a=i;d=c[b+20>>2]|0;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=a;return}h=g;g=c[b>>2]|0;j=c[b+16>>2]|0;while(1){h=h+-1|0;b=e[f+(j>>>16<<1)>>1]|0;c[g>>2]=b<<9&16252928|b<<6&63488|b<<3&248|0-(b&32768)&-16777216;if(!h)break;else{g=g+4|0;j=j+d|0}}i=a;return}function Une(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;g=c[f+20>>2]|0;h=c[f+4>>2]|0;j=c[f+12>>2]|0;if(!j){i=b;return}k=j;j=c[f>>2]|0;l=c[f+16>>2]|0;while(1){k=k+-1|0;f=e[h+(l>>>16<<1)>>1]|0;a[j>>0]=(d[1055673+((f&240)<<2)>>0]|0)+(d[1055674+((f>>>8&15)<<2)>>0]|0)+(d[1055672+((f<<4&240)<<2)>>0]|0);if(!k)break;else{j=j+1|0;l=l+g|0}}i=b;return}function Vne(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=b;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;a[h>>0]=d>>>4&224|d>>>3&28|d>>>2&3;if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function Wne(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=a;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;b[h>>1]=d<<4&61440|d<<3&1920|d<<1&30;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Xne(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=b;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;a[h>>0]=d<<4;a[h+1>>0]=d&240;a[h+2>>0]=d>>>4&240;if(!j)break;else{h=h+3|0;k=k+f|0}}i=b;return}function Yne(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0;a=i;f=c[d+20>>2]|0;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=a;return}j=h;h=c[d>>2]|0;k=c[d+16>>2]|0;while(1){j=j+-1|0;d=e[g+(k>>>16<<1)>>1]|0;b[h>>1]=d<<2&960|d&32768|d<<3&30720|d<<1&30;if(!j)break;else{h=h+2|0;k=k+f|0}}i=a;return}function Zne(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0;a=i;d=c[b+20>>2]|0;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=a;return}h=g;g=c[b>>2]|0;j=c[b+16>>2]|0;while(1){h=h+-1|0;b=e[f+(j>>>16<<1)>>1]|0;k=b&61440;c[g>>2]=b<<12&15728640|b<<8&61440|b<<4&240|k<<16|k<<12;if(!h)break;else{g=g+4|0;j=j+d|0}}i=a;return}function _ne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;f=c[e+20>>2]|0;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=b;return}j=h;h=c[e>>2]|0;k=c[e+16>>2]|0;while(1){j=j+-1|0;e=c[g+(k>>>16<<2)>>2]|0;a[h>>0]=(d[1055673+((e>>>8&255)<<2)>>0]|0)+(d[1055674+((e>>>16&255)<<2)>>0]|0)+(d[1055672+((e&255)<<2)>>0]|0);if(!j)break;else{h=h+1|0;k=k+f|0}}i=b;return}function $ne(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=c[d+20>>2]|0;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=b;return}h=g;g=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=c[f+(j>>>16<<2)>>2]|0;a[g>>0]=d>>>16&224|d>>>11&28|d>>>6&3;if(!h)break;else{g=g+1|0;j=j+e|0}}i=b;return}function aoe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[d+20>>2]|0;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=a;return}h=g;g=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=c[f+(j>>>16<<2)>>2]|0;b[g>>1]=d>>>8&63488|d>>>5&2016|d>>>3&31;if(!h)break;else{g=g+2|0;j=j+e|0}}i=a;return}function boe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=c[d+20>>2]|0;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=b;return}h=g;g=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=c[f+(j>>>16<<2)>>2]|0;a[g>>0]=d;a[g+1>>0]=d>>>8;a[g+2>>0]=d>>>16;if(!h)break;else{g=g+3|0;j=j+e|0}}i=b;return}function coe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[d+20>>2]|0;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=a;return}h=g;g=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=c[f+(j>>>16<<2)>>2]|0;b[g>>1]=d>>>6&992|d>>>9&31744|d>>>3&31|32768;if(!h)break;else{g=g+2|0;j=j+e|0}}i=a;return}function doe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;e=c[d+20>>2]|0;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=a;return}h=g;g=c[d>>2]|0;j=c[d+16>>2]|0;while(1){h=h+-1|0;d=c[f+(j>>>16<<2)>>2]|0;b[g>>1]=d>>>8&240|d>>>12&3840|d>>>4&15|61440;if(!h)break;else{g=g+2|0;j=j+e|0}}i=a;return}function eoe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=e+20|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=d[g+(A>>>16)>>0]|0;a[h>>0]=e>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((e>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];if(!z)break;else{h=h+1|0;A=(c[y>>2]|0)+A|0}}i=f;return}function foe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+64>>2]|0;t=c[a+60>>2]|0;u=c[a+68>>2]|0;v=c[a+40>>2]|0;w=c[a+36>>2]|0;x=c[a+44>>2]|0;y=c[a+72>>2]|0;a=c[e+20>>2]|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=d[g+(A>>>16)>>0]|0;b[h>>1]=e>>>v<<w&x|y|((d[1055673+((e>>>m<<n&o)<<2)>>0]|0)+(d[1055674+((e>>>j<<k&l)<<2)>>0]|0)+(d[1055672+((e>>>p<<q&r)<<2)>>0]|0)|0)>>>s<<t&u;if(!z)break;else{h=h+2|0;A=A+a|0}}i=f;return}function goe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=e+20|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=d[g+(A>>>16)>>0]|0;B=e>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((e>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];a[h>>0]=B;a[h+1>>0]=B>>>8;a[h+2>>0]=B>>>16;if(!z)break;else{h=h+3|0;A=(c[y>>2]|0)+A|0}}i=f;return}function hoe(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=e;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+64|0;r=a+60|0;s=a+68|0;t=a+40|0;u=a+36|0;v=a+44|0;w=a+72|0;x=b+20|0;y=g;g=c[b>>2]|0;z=c[b+16>>2]|0;while(1){y=y+-1|0;b=d[f+(z>>>16)>>0]|0;c[g>>2]=b>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((b>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!y)break;else{g=g+4|0;z=(c[x>>2]|0)+z|0}}i=e;return}function ioe(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=c[f+4>>2]|0;j=c[f+12>>2]|0;if(!j){i=g;return}k=b+4|0;l=b+8|0;m=b+16|0;n=b+12|0;o=b+20|0;p=b+28|0;q=b+24|0;r=b+32|0;s=b+64|0;t=b+60|0;u=b+68|0;v=b+40|0;w=b+36|0;x=b+44|0;y=b+72|0;z=f+20|0;A=j;j=c[f>>2]|0;B=c[f+16>>2]|0;while(1){A=A+-1|0;f=e[h+(B>>>16<<1)>>1]|0;a[j>>0]=f>>>(c[v>>2]|0)<<c[w>>2]&c[x>>2]|((d[1055673+((f>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2])<<2)>>0]|0)+(d[1055674+((f>>>(c[k>>2]|0)<<c[b>>2]&c[l>>2])<<2)>>0]|0)+(d[1055672+((f>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2])<<2)>>0]|0)|0)>>>(c[s>>2]|0)<<c[t>>2]&c[u>>2]|c[y>>2];if(!A)break;else{j=j+1|0;B=(c[z>>2]|0)+B|0}}i=g;return}function joe(a,f){a=a|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=c[f+4>>2]|0;j=c[f+12>>2]|0;if(!j){i=g;return}k=c[a+4>>2]|0;l=c[a>>2]|0;m=c[a+8>>2]|0;n=c[a+16>>2]|0;o=c[a+12>>2]|0;p=c[a+20>>2]|0;q=c[a+28>>2]|0;r=c[a+24>>2]|0;s=c[a+32>>2]|0;t=c[a+64>>2]|0;u=c[a+60>>2]|0;v=c[a+68>>2]|0;w=c[a+40>>2]|0;x=c[a+36>>2]|0;y=c[a+44>>2]|0;z=c[a+72>>2]|0;a=c[f+20>>2]|0;A=j;j=c[f>>2]|0;B=c[f+16>>2]|0;while(1){A=A+-1|0;f=e[h+(B>>>16<<1)>>1]|0;b[j>>1]=f>>>w<<x&y|z|((d[1055673+((f>>>n<<o&p)<<2)>>0]|0)+(d[1055674+((f>>>k<<l&m)<<2)>>0]|0)+(d[1055672+((f>>>q<<r&s)<<2)>>0]|0)|0)>>>t<<u&v;if(!A)break;else{j=j+2|0;B=B+a|0}}i=g;return}function koe(b,f){b=b|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=c[f+4>>2]|0;j=c[f+12>>2]|0;if(!j){i=g;return}k=b+4|0;l=b+8|0;m=b+16|0;n=b+12|0;o=b+20|0;p=b+28|0;q=b+24|0;r=b+32|0;s=b+64|0;t=b+60|0;u=b+68|0;v=b+40|0;w=b+36|0;x=b+44|0;y=b+72|0;z=f+20|0;A=j;j=c[f>>2]|0;B=c[f+16>>2]|0;while(1){A=A+-1|0;f=e[h+(B>>>16<<1)>>1]|0;C=f>>>(c[v>>2]|0)<<c[w>>2]&c[x>>2]|((d[1055673+((f>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2])<<2)>>0]|0)+(d[1055674+((f>>>(c[k>>2]|0)<<c[b>>2]&c[l>>2])<<2)>>0]|0)+(d[1055672+((f>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2])<<2)>>0]|0)|0)>>>(c[s>>2]|0)<<c[t>>2]&c[u>>2]|c[y>>2];a[j>>0]=C;a[j+1>>0]=C>>>8;a[j+2>>0]=C>>>16;if(!A)break;else{j=j+3|0;B=(c[z>>2]|0)+B|0}}i=g;return}function loe(a,b){a=a|0;b=b|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[b+4>>2]|0;h=c[b+12>>2]|0;if(!h){i=f;return}j=a+4|0;k=a+8|0;l=a+16|0;m=a+12|0;n=a+20|0;o=a+28|0;p=a+24|0;q=a+32|0;r=a+64|0;s=a+60|0;t=a+68|0;u=a+40|0;v=a+36|0;w=a+44|0;x=a+72|0;y=b+20|0;z=h;h=c[b>>2]|0;A=c[b+16>>2]|0;while(1){z=z+-1|0;b=e[g+(A>>>16<<1)>>1]|0;c[h>>2]=b>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((b>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[j>>2]|0)<<c[a>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];if(!z)break;else{h=h+4|0;A=(c[y>>2]|0)+A|0}}i=f;return}function moe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=e+20|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=(A>>>16)*3|0;B=(d[g+(e+1)>>0]|0)<<8|(d[g+e>>0]|0)|(d[g+(e+2)>>0]|0)<<16;a[h>>0]=B>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((B>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((B>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((B>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];if(!z)break;else{h=h+1|0;A=(c[y>>2]|0)+A|0}}i=f;return}function noe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+64>>2]|0;t=c[a+60>>2]|0;u=c[a+68>>2]|0;v=c[a+40>>2]|0;w=c[a+36>>2]|0;x=c[a+44>>2]|0;y=c[a+72>>2]|0;a=c[e+20>>2]|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=(A>>>16)*3|0;B=(d[g+(e+1)>>0]|0)<<8|(d[g+e>>0]|0)|(d[g+(e+2)>>0]|0)<<16;b[h>>1]=B>>>v<<w&x|((d[1055673+((B>>>m<<n&o)<<2)>>0]|0)+(d[1055674+((B>>>j<<k&l)<<2)>>0]|0)+(d[1055672+((B>>>p<<q&r)<<2)>>0]|0)|0)>>>s<<t&u|y;if(!z)break;else{h=h+2|0;A=a+A|0}}i=f;return}function ooe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=e+20|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=(A>>>16)*3|0;B=(d[g+(e+1)>>0]|0)<<8|(d[g+e>>0]|0)|(d[g+(e+2)>>0]|0)<<16;e=B>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((B>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((B>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((B>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];a[h>>0]=e;a[h+1>>0]=e>>>8;a[h+2>>0]=e>>>16;if(!z)break;else{h=h+3|0;A=(c[y>>2]|0)+A|0}}i=f;return}function poe(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=e;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+64|0;r=a+60|0;s=a+68|0;t=a+40|0;u=a+36|0;v=a+44|0;w=a+72|0;x=b+20|0;y=g;g=c[b>>2]|0;z=c[b+16>>2]|0;while(1){y=y+-1|0;b=(z>>>16)*3|0;A=(d[f+(b+1)>>0]|0)<<8|(d[f+b>>0]|0)|(d[f+(b+2)>>0]|0)<<16;c[g>>2]=A>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((A>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((A>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((A>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!y)break;else{g=g+4|0;z=(c[x>>2]|0)+z|0}}i=e;return}function qoe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=e+20|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=c[g+(A>>>16<<2)>>2]|0;a[h>>0]=e>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((e>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];if(!z)break;else{h=h+1|0;A=(c[y>>2]|0)+A|0}}i=f;return}function roe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+64>>2]|0;t=c[a+60>>2]|0;u=c[a+68>>2]|0;v=c[a+40>>2]|0;w=c[a+36>>2]|0;x=c[a+44>>2]|0;y=c[a+72>>2]|0;a=c[e+20>>2]|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=c[g+(A>>>16<<2)>>2]|0;b[h>>1]=e>>>v<<w&x|y|((d[1055673+((e>>>m<<n&o)<<2)>>0]|0)+(d[1055674+((e>>>j<<k&l)<<2)>>0]|0)+(d[1055672+((e>>>p<<q&r)<<2)>>0]|0)|0)>>>s<<t&u;if(!z)break;else{h=h+2|0;A=A+a|0}}i=f;return}function soe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+64|0;s=b+60|0;t=b+68|0;u=b+40|0;v=b+36|0;w=b+44|0;x=b+72|0;y=e+20|0;z=h;h=c[e>>2]|0;A=c[e+16>>2]|0;while(1){z=z+-1|0;e=c[g+(A>>>16<<2)>>2]|0;B=e>>>(c[u>>2]|0)<<c[v>>2]&c[w>>2]|((d[1055673+((e>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2])<<2)>>0]|0)+(d[1055674+((e>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2])<<2)>>0]|0)+(d[1055672+((e>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2])<<2)>>0]|0)|0)>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[x>>2];a[h>>0]=B;a[h+1>>0]=B>>>8;a[h+2>>0]=B>>>16;if(!z)break;else{h=h+3|0;A=(c[y>>2]|0)+A|0}}i=f;return}function toe(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=e;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+64|0;r=a+60|0;s=a+68|0;t=a+40|0;u=a+36|0;v=a+44|0;w=a+72|0;x=b+20|0;y=g;g=c[b>>2]|0;z=c[b+16>>2]|0;while(1){y=y+-1|0;b=c[f+(z>>>16<<2)>>2]|0;c[g>>2]=b>>>(c[t>>2]|0)<<c[u>>2]&c[v>>2]|((d[1055673+((b>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2])<<2)>>0]|0)+(d[1055674+((b>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2])<<2)>>0]|0)+(d[1055672+((b>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2])<<2)>>0]|0)|0)>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[w>>2];if(!y)break;else{g=g+4|0;z=(c[x>>2]|0)+z|0}}i=e;return}function uoe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+36|0;t=b+44|0;u=b+72|0;v=e+20|0;w=h;h=c[e>>2]|0;x=c[e+16>>2]|0;while(1){w=w+-1|0;e=d[g+(x>>>16)>>0]|0;a[h>>0]=e>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|e>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2]|e>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|e>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[u>>2];if(!w)break;else{h=h+1|0;x=(c[v>>2]|0)+x|0}}i=f;return}function voe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+40>>2]|0;t=c[a+36>>2]|0;u=c[a+44>>2]|0;v=c[a+72>>2]|0;a=c[e+20>>2]|0;w=h;h=c[e>>2]|0;x=c[e+16>>2]|0;while(1){w=w+-1|0;e=d[g+(x>>>16)>>0]|0;b[h>>1]=e>>>j<<k&l|v|e>>>m<<n&o|e>>>p<<q&r|e>>>s<<t&u;if(!w)break;else{h=h+2|0;x=x+a|0}}i=f;return}function woe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+36|0;t=b+44|0;u=b+72|0;v=e+20|0;w=h;h=c[e>>2]|0;x=c[e+16>>2]|0;while(1){w=w+-1|0;e=d[g+(x>>>16)>>0]|0;y=e>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|e>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2]|e>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|e>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[u>>2];a[h>>0]=y;a[h+1>>0]=y>>>8;a[h+2>>0]=y>>>16;if(!w)break;else{h=h+3|0;x=(c[v>>2]|0)+x|0}}i=f;return}function xoe(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=e;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+40|0;r=a+36|0;s=a+44|0;t=a+72|0;u=b+20|0;v=g;g=c[b>>2]|0;w=c[b+16>>2]|0;while(1){v=v+-1|0;b=d[f+(w>>>16)>>0]|0;c[g>>2]=b>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|b>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2]|b>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|b>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!v)break;else{g=g+4|0;w=(c[u>>2]|0)+w|0}}i=e;return}function yoe(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+36|0;t=b+44|0;u=b+72|0;v=d+20|0;w=h;h=c[d>>2]|0;x=c[d+16>>2]|0;while(1){w=w+-1|0;d=e[g+(x>>>16<<1)>>1]|0;a[h>>0]=d>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|d>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2]|d>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|d>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[u>>2];if(!w)break;else{h=h+1|0;x=(c[v>>2]|0)+x|0}}i=f;return}function zoe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=f;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+40>>2]|0;t=c[a+36>>2]|0;u=c[a+44>>2]|0;v=c[a+72>>2]|0;a=c[d+20>>2]|0;w=h;h=c[d>>2]|0;x=c[d+16>>2]|0;while(1){w=w+-1|0;d=e[g+(x>>>16<<1)>>1]|0;b[h>>1]=d>>>j<<k&l|v|d>>>m<<n&o|d>>>p<<q&r|d>>>s<<t&u;if(!w)break;else{h=h+2|0;x=x+a|0}}i=f;return}function Aoe(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[d+4>>2]|0;h=c[d+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+36|0;t=b+44|0;u=b+72|0;v=d+20|0;w=h;h=c[d>>2]|0;x=c[d+16>>2]|0;while(1){w=w+-1|0;d=e[g+(x>>>16<<1)>>1]|0;y=d>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|d>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2]|d>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|d>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[u>>2];a[h>>0]=y;a[h+1>>0]=y>>>8;a[h+2>>0]=y>>>16;if(!w)break;else{h=h+3|0;x=(c[v>>2]|0)+x|0}}i=f;return}function Boe(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=d;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+40|0;r=a+36|0;s=a+44|0;t=a+72|0;u=b+20|0;v=g;g=c[b>>2]|0;w=c[b+16>>2]|0;while(1){v=v+-1|0;b=e[f+(w>>>16<<1)>>1]|0;c[g>>2]=b>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|b>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2]|b>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|b>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!v)break;else{g=g+4|0;w=(c[u>>2]|0)+w|0}}i=d;return}function Coe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+36|0;t=b+44|0;u=b+72|0;v=e+20|0;w=h;h=c[e>>2]|0;x=c[e+16>>2]|0;while(1){w=w+-1|0;e=(x>>>16)*3|0;y=(d[g+(e+1)>>0]|0)<<8|(d[g+e>>0]|0)|(d[g+(e+2)>>0]|0)<<16;a[h>>0]=y>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|y>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2]|y>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|y>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[u>>2];if(!w)break;else{h=h+1|0;x=(c[v>>2]|0)+x|0}}i=f;return}function Doe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=c[a+4>>2]|0;k=c[a>>2]|0;l=c[a+8>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+20>>2]|0;p=c[a+28>>2]|0;q=c[a+24>>2]|0;r=c[a+32>>2]|0;s=c[a+40>>2]|0;t=c[a+36>>2]|0;u=c[a+44>>2]|0;v=c[a+72>>2]|0;a=c[e+20>>2]|0;w=h;h=c[e>>2]|0;x=c[e+16>>2]|0;while(1){w=w+-1|0;e=(x>>>16)*3|0;y=(d[g+(e+1)>>0]|0)<<8|(d[g+e>>0]|0)|(d[g+(e+2)>>0]|0)<<16;b[h>>1]=y>>>m<<n&o|y>>>j<<k&l|y>>>p<<q&r|y>>>s<<t&u|v;if(!w)break;else{h=h+2|0;x=a+x|0}}i=f;return}function Eoe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=c[e+4>>2]|0;h=c[e+12>>2]|0;if(!h){i=f;return}j=b+4|0;k=b+8|0;l=b+16|0;m=b+12|0;n=b+20|0;o=b+28|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+36|0;t=b+44|0;u=b+72|0;v=e+20|0;w=h;h=c[e>>2]|0;x=c[e+16>>2]|0;while(1){w=w+-1|0;e=(x>>>16)*3|0;y=(d[g+(e+1)>>0]|0)<<8|(d[g+e>>0]|0)|(d[g+(e+2)>>0]|0)<<16;e=y>>>(c[l>>2]|0)<<c[m>>2]&c[n>>2]|y>>>(c[j>>2]|0)<<c[b>>2]&c[k>>2]|y>>>(c[o>>2]|0)<<c[p>>2]&c[q>>2]|y>>>(c[r>>2]|0)<<c[s>>2]&c[t>>2]|c[u>>2];a[h>>0]=e;a[h+1>>0]=e>>>8;a[h+2>>0]=e>>>16;if(!w)break;else{h=h+3|0;x=(c[v>>2]|0)+x|0}}i=f;return}function Foe(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[b+4>>2]|0;g=c[b+12>>2]|0;if(!g){i=e;return}h=a+4|0;j=a+8|0;k=a+16|0;l=a+12|0;m=a+20|0;n=a+28|0;o=a+24|0;p=a+32|0;q=a+40|0;r=a+36|0;s=a+44|0;t=a+72|0;u=b+20|0;v=g;g=c[b>>2]|0;w=c[b+16>>2]|0;while(1){v=v+-1|0;b=(w>>>16)*3|0;x=(d[f+(b+1)>>0]|0)<<8|(d[f+b>>0]|0)|(d[f+(b+2)>>0]|0)<<16;c[g>>2]=x>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|x>>>(c[h>>2]|0)<<c[a>>2]&c[j>>2]|x>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|x>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!v)break;else{g=g+4|0;w=(c[u>>2]|0)+w|0}}i=e;return}function Goe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=e;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=d+20|0;v=g;g=c[d>>2]|0;w=c[d+16>>2]|0;while(1){v=v+-1|0;d=c[f+(w>>>16<<2)>>2]|0;a[g>>0]=d>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|d>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|d>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|d>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];if(!v)break;else{g=g+1|0;w=(c[u>>2]|0)+w|0}}i=e;return}function Hoe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=e;return}h=c[a+4>>2]|0;j=c[a>>2]|0;k=c[a+8>>2]|0;l=c[a+16>>2]|0;m=c[a+12>>2]|0;n=c[a+20>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+32>>2]|0;r=c[a+40>>2]|0;s=c[a+36>>2]|0;t=c[a+44>>2]|0;u=c[a+72>>2]|0;a=c[d+20>>2]|0;v=g;g=c[d>>2]|0;w=c[d+16>>2]|0;while(1){v=v+-1|0;d=c[f+(w>>>16<<2)>>2]|0;b[g>>1]=d>>>h<<j&k|u|d>>>l<<m&n|d>>>o<<p&q|d>>>r<<s&t;if(!v)break;else{g=g+2|0;w=w+a|0}}i=e;return}function Ioe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;f=c[d+4>>2]|0;g=c[d+12>>2]|0;if(!g){i=e;return}h=b+4|0;j=b+8|0;k=b+16|0;l=b+12|0;m=b+20|0;n=b+28|0;o=b+24|0;p=b+32|0;q=b+40|0;r=b+36|0;s=b+44|0;t=b+72|0;u=d+20|0;v=g;g=c[d>>2]|0;w=c[d+16>>2]|0;while(1){v=v+-1|0;d=c[f+(w>>>16<<2)>>2]|0;x=d>>>(c[k>>2]|0)<<c[l>>2]&c[m>>2]|d>>>(c[h>>2]|0)<<c[b>>2]&c[j>>2]|d>>>(c[n>>2]|0)<<c[o>>2]&c[p>>2]|d>>>(c[q>>2]|0)<<c[r>>2]&c[s>>2]|c[t>>2];a[g>>0]=x;a[g+1>>0]=x>>>8;a[g+2>>0]=x>>>16;if(!v)break;else{g=g+3|0;w=(c[u>>2]|0)+w|0}}i=e;return}function Joe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=c[b+4>>2]|0;f=c[b+12>>2]|0;if(!f){i=d;return}g=a+4|0;h=a+8|0;j=a+16|0;k=a+12|0;l=a+20|0;m=a+28|0;n=a+24|0;o=a+32|0;p=a+40|0;q=a+36|0;r=a+44|0;s=a+72|0;t=b+20|0;u=f;f=c[b>>2]|0;v=c[b+16>>2]|0;while(1){u=u+-1|0;b=c[e+(v>>>16<<2)>>2]|0;c[f>>2]=b>>>(c[j>>2]|0)<<c[k>>2]&c[l>>2]|b>>>(c[g>>2]|0)<<c[a>>2]&c[h>>2]|b>>>(c[m>>2]|0)<<c[n>>2]&c[o>>2]|b>>>(c[p>>2]|0)<<c[q>>2]&c[r>>2]|c[s>>2];if(!u)break;else{f=f+4|0;v=(c[t>>2]|0)+v|0}}i=d;return}function Koe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;f=(c[e+24>>2]|0)>>>8;g=256-f|0;h=c[e+4>>2]|0;j=c[e+8>>2]|0;k=c[e+12>>2]|0;if(!k){i=b;return}l=e+20|0;m=k;k=c[e>>2]|0;n=c[e+16>>2]|0;while(1){m=m+-1|0;e=n>>>16;o=n>>>8&255;p=e+1|0;q=(da((d[h+p>>0]|0)<<16|(d[j+p>>0]|0),o)|0)+(da((d[h+e>>0]|0)<<16|(d[j+e>>0]|0),256-o|0)|0)|0;a[k>>0]=((da(q>>>16&65280,g)|0)+(da(q&65280,f)|0)|0)>>>16;if(!m)break;else{k=k+1|0;n=(c[l>>2]|0)+n|0}}i=b;return}function Loe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;f=(c[d+24>>2]|0)>>>11;g=32-f|0;h=c[d+4>>2]|0;j=c[d+8>>2]|0;k=c[d+12>>2]|0;if(!k){i=a;return}l=c[d+20>>2]|0;m=k;k=c[d>>2]|0;n=c[d+16>>2]|0;while(1){m=m+-1|0;d=n>>>16;o=n>>>11&31;p=32-o|0;q=(e[h+(d<<1)>>1]|0)<<16|(e[j+(d<<1)>>1]|0);r=d+1|0;d=(e[h+(r<<1)>>1]|0)<<16|(e[j+(r<<1)>>1]|0);r=(da(d>>>5&130086975,o)|0)+(da(q>>>5&130086975,p)|0)|0;s=(da(d&132184095,o)|0)+(da(q&132184095,p)|0)|0;b[k>>1]=((da(r>>>16&63519,g)|0)+(da(s>>>5&63519,f)|0)|0)>>>5&63519|((da(s>>>21&2016,g)|0)+(da(r&2016,f)|0)|0)>>>5&2016;if(!m)break;else{k=k+2|0;n=l+n|0}}i=a;return}function Moe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;f=(c[e+24>>2]|0)>>>8;g=256-f|0;h=c[e+4>>2]|0;j=c[e+8>>2]|0;k=c[e+12>>2]|0;if(!k){i=b;return}l=e+20|0;m=k;k=c[e>>2]|0;n=c[e+16>>2]|0;while(1){m=m+-1|0;e=n>>>8&255;o=256-e|0;p=(n>>>16)*3|0;q=p+1|0;r=p+2|0;s=p+3|0;t=p+4|0;u=p+5|0;v=((da((da(d[j+t>>0]|0,e)|0)+(da(d[j+q>>0]|0,o)|0)<<8&16711680,f)|0)+(da((da(d[h+t>>0]|0,e)|0)+(da(d[h+q>>0]|0,o)|0)<<8&16711680,g)|0)|0)>>>24;q=(da(((da((d[j+u>>0]|0)<<16|(d[j+s>>0]|0),e)|0)+(da((d[j+r>>0]|0)<<16|(d[j+p>>0]|0),o)|0)|0)>>>8&16711935,f)|0)+(da(((da((d[h+u>>0]|0)<<16|(d[h+s>>0]|0),e)|0)+(da((d[h+r>>0]|0)<<16|(d[h+p>>0]|0),o)|0)|0)>>>8&16711935,g)|0)|0;a[k>>0]=q>>>8;a[k+1>>0]=v;a[k+2>>0]=q>>>24;if(!m)break;else{k=k+3|0;n=(c[l>>2]|0)+n|0}}i=b;return}function Noe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;f=(c[d+24>>2]|0)>>>11;g=32-f|0;h=c[d+4>>2]|0;j=c[d+8>>2]|0;k=c[d+12>>2]|0;if(!k){i=a;return}l=c[d+20>>2]|0;m=k;k=c[d>>2]|0;n=c[d+16>>2]|0;while(1){m=m+-1|0;d=n>>>16;o=n>>>11&31;p=32-o|0;q=e[h+(d<<1)>>1]|0;r=q<<16|(e[j+(d<<1)>>1]|0);s=d+1|0;d=(e[h+(s<<1)>>1]|0)<<16|(e[j+(s<<1)>>1]|0);s=(da(d>>>5&65075231,o)|0)+(da(r>>>5&65075231,p)|0)|0;t=(da(d&65043487,o)|0)+(da(r&65043487,p)|0)|0;b[k>>1]=((da(t>>>21&992,g)|0)+(da(s&992,f)|0)|0)>>>5&992|q&32768|((da(s>>>16&31775,g)|0)+(da(t>>>5&31775,f)|0)|0)>>>5&31775;if(!m)break;else{k=k+2|0;n=l+n|0}}i=a;return}function Ooe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;f=(c[d+24>>2]|0)>>>12;g=16-f|0;h=c[d+4>>2]|0;j=c[d+8>>2]|0;k=c[d+12>>2]|0;if(!k){i=a;return}l=c[d+20>>2]|0;m=k;k=c[d>>2]|0;n=c[d+16>>2]|0;while(1){m=m+-1|0;d=n>>>16;o=n>>>12&15;p=16-o|0;q=(e[h+(d<<1)>>1]|0)<<16|(e[j+(d<<1)>>1]|0);r=d+1|0;d=(e[h+(r<<1)>>1]|0)<<16|(e[j+(r<<1)>>1]|0);r=(da(d>>>4&252645135,o)|0)+(da(q>>>4&252645135,p)|0)|0;s=(da(d&252645135,o)|0)+(da(q&252645135,p)|0)|0;b[k>>1]=(da(r>>>20&3855,g)|0)+(da(r>>>4&3855,f)|0)&61680|((da(s>>>20&3855,g)|0)+(da(s>>>4&3855,f)|0)|0)>>>4&3855;if(!m)break;else{k=k+2|0;n=l+n|0}}i=a;return}function Poe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;d=(c[b+24>>2]|0)>>>8;e=256-d|0;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;if(!h){i=a;return}j=b+20|0;k=h;h=c[b>>2]|0;l=c[b+16>>2]|0;while(1){k=k+-1|0;b=l>>>16;m=l>>>8&255;n=256-m|0;o=c[f+(b<<2)>>2]|0;p=b+1|0;q=c[f+(p<<2)>>2]|0;r=c[g+(b<<2)>>2]|0;b=c[g+(p<<2)>>2]|0;c[h>>2]=(da(((da(b>>>8&16711935,m)|0)+(da(r>>>8&16711935,n)|0)|0)>>>8&16711935,d)|0)+(da(((da(q>>>8&16711935,m)|0)+(da(o>>>8&16711935,n)|0)|0)>>>8&16711935,e)|0)&-16711936|((da(((da(b&16711935,m)|0)+(da(r&16711935,n)|0)|0)>>>8&16711935,d)|0)+(da(((da(q&16711935,m)|0)+(da(o&16711935,n)|0)|0)>>>8&16711935,e)|0)|0)>>>8&16711935;if(!k)break;else{h=h+4|0;l=(c[j>>2]|0)+l|0}}i=a;return}function Qoe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[e+4>>2]|0;h=c[e+8>>2]|0;j=c[e+12>>2]|0;if(!j){i=f;return}k=b+64|0;l=b+60|0;m=b+40|0;n=b+36|0;o=e+24|0;p=b+68|0;q=b+44|0;b=e+20|0;r=j;j=c[e>>2]|0;s=c[e+16>>2]|0;while(1){r=r+-1|0;e=s>>>16;t=s&65535;u=65536-t|0;v=d[g+e>>0]|0;w=c[k>>2]|0;x=c[l>>2]|0;y=da(v>>>w<<x&255,u)|0;z=e+1|0;A=d[g+z>>0]|0;B=((da(A>>>w<<x&255,t)|0)+y|0)>>>16;y=d[h+e>>0]|0;e=da(y>>>w<<x&255,u)|0;C=d[h+z>>0]|0;z=((da(C>>>w<<x&255,t)|0)+e|0)>>>16;e=c[m>>2]|0;D=c[n>>2]|0;E=((da(v>>>e<<D&255,u)|0)+(da(A>>>e<<D&255,t)|0)|0)>>>16;A=((da(y>>>e<<D&255,u)|0)+(da(C>>>e<<D&255,t)|0)|0)>>>16;t=c[o>>2]|0;C=65536-t|0;u=((da(z,t)|0)+(da(B,C)|0)|0)>>>16>>>x<<w;w=((da(E,C)|0)+(da(A,t)|0)|0)>>>16>>>D<<e;a[j>>0]=u&c[p>>2]|w&c[q>>2];if(!r)break;else{j=j+1|0;s=(c[b>>2]|0)+s|0}}i=f;return}function Roe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[d+4>>2]|0;h=c[d+8>>2]|0;j=c[d+12>>2]|0;if(!j){i=f;return}k=c[a+64>>2]|0;l=c[a+60>>2]|0;m=c[a+40>>2]|0;n=c[a+36>>2]|0;o=c[d+24>>2]|0;p=65536-o|0;q=c[a+68>>2]|0;r=c[a+44>>2]|0;a=c[d+20>>2]|0;s=j;j=c[d>>2]|0;t=c[d+16>>2]|0;while(1){s=s+-1|0;d=t>>>16;u=t&65535;v=65536-u|0;w=e[g+(d<<1)>>1]|0;x=da(w>>>k<<l&255,v)|0;y=d+1|0;z=e[g+(y<<1)>>1]|0;A=((da(z>>>k<<l&255,u)|0)+x|0)>>>16;x=e[h+(d<<1)>>1]|0;d=da(x>>>k<<l&255,v)|0;B=e[h+(y<<1)>>1]|0;b[j>>1]=((da(((da(B>>>k<<l&255,u)|0)+d|0)>>>16,o)|0)+(da(A,p)|0)|0)>>>16>>>l<<k&q|((da(((da(w>>>m<<n&255,v)|0)+(da(z>>>m<<n&255,u)|0)|0)>>>16,p)|0)+(da(((da(x>>>m<<n&255,v)|0)+(da(B>>>m<<n&255,u)|0)|0)>>>16,o)|0)|0)>>>16>>>n<<m&r;if(!s)break;else{j=j+2|0;t=a+t|0}}i=f;return}function Soe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[e+4>>2]|0;h=c[e+8>>2]|0;j=c[e+12>>2]|0;if(!j){i=f;return}k=b+64|0;l=b+60|0;m=b+40|0;n=b+36|0;o=e+24|0;p=b+68|0;q=b+44|0;b=e+20|0;r=j;j=c[e>>2]|0;s=c[e+16>>2]|0;while(1){r=r+-1|0;e=s&65535;t=(s>>>16)*3|0;u=t+1|0;v=t+2|0;w=(d[g+u>>0]|0)<<8|(d[g+t>>0]|0)|(d[g+v>>0]|0)<<16;x=t+3|0;y=t+4|0;z=t+5|0;A=(d[g+y>>0]|0)<<8|(d[g+x>>0]|0)|(d[g+z>>0]|0)<<16;B=(d[h+u>>0]|0)<<8|(d[h+t>>0]|0)|(d[h+v>>0]|0)<<16;v=(d[h+y>>0]|0)<<8|(d[h+x>>0]|0)|(d[h+z>>0]|0)<<16;z=65536-e|0;x=c[k>>2]|0;y=c[l>>2]|0;t=((da(w>>>x<<y&255,z)|0)+(da(A>>>x<<y&255,e)|0)|0)>>>16;u=((da(v>>>x<<y&255,e)|0)+(da(B>>>x<<y&255,z)|0)|0)>>>16;C=c[m>>2]|0;D=c[n>>2]|0;E=((da(w>>>C<<D&255,z)|0)+(da(A>>>C<<D&255,e)|0)|0)>>>16;A=((da(B>>>C<<D&255,z)|0)+(da(v>>>C<<D&255,e)|0)|0)>>>16;e=c[o>>2]|0;v=65536-e|0;z=((da(u,e)|0)+(da(t,v)|0)|0)>>>16>>>y<<x;x=((da(E,v)|0)+(da(A,e)|0)|0)>>>16>>>D<<C;C=z&c[p>>2]|x&c[q>>2];a[j>>0]=C;a[j+1>>0]=C>>>8;a[j+2>>0]=C>>>16;if(!r)break;else{j=j+3|0;s=(c[b>>2]|0)+s|0}}i=f;return}function Toe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=c[b+4>>2]|0;f=c[b+8>>2]|0;g=c[b+12>>2]|0;if(!g){i=d;return}h=a+64|0;j=a+60|0;k=a+40|0;l=a+36|0;m=b+24|0;n=a+68|0;o=a+44|0;a=b+20|0;p=g;g=c[b>>2]|0;q=c[b+16>>2]|0;while(1){p=p+-1|0;b=q>>>16;r=q&65535;s=65536-r|0;t=c[e+(b<<2)>>2]|0;u=c[h>>2]|0;v=c[j>>2]|0;w=da(t>>>u<<v&255,s)|0;x=b+1|0;y=c[e+(x<<2)>>2]|0;z=((da(y>>>u<<v&255,r)|0)+w|0)>>>16;w=c[f+(b<<2)>>2]|0;b=da(w>>>u<<v&255,s)|0;A=c[f+(x<<2)>>2]|0;x=((da(A>>>u<<v&255,r)|0)+b|0)>>>16;b=c[k>>2]|0;B=c[l>>2]|0;C=((da(t>>>b<<B&255,s)|0)+(da(y>>>b<<B&255,r)|0)|0)>>>16;y=((da(w>>>b<<B&255,s)|0)+(da(A>>>b<<B&255,r)|0)|0)>>>16;r=c[m>>2]|0;A=65536-r|0;s=((da(x,r)|0)+(da(A,z)|0)|0)>>>16>>>v<<u;u=((da(C,A)|0)+(da(y,r)|0)|0)>>>16>>>B<<b;c[g>>2]=u&c[o>>2]|s&c[n>>2];if(!p)break;else{g=g+4|0;q=(c[a>>2]|0)+q|0}}i=d;return}function Uoe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;g=c[e+4>>2]|0;h=c[e+8>>2]|0;j=c[e+12>>2]|0;if(!j){i=f;return}k=b+4|0;l=b+16|0;m=b+12|0;n=b+28|0;o=b+24|0;p=b+40|0;q=b+36|0;r=e+24|0;s=b+8|0;t=b+20|0;u=b+32|0;v=b+44|0;w=e+20|0;x=j;j=c[e>>2]|0;y=c[e+16>>2]|0;while(1){x=x+-1|0;e=y>>>16;z=y&65535;A=d[g+e>>0]|0;B=e+1|0;C=d[g+B>>0]|0;D=d[h+e>>0]|0;e=d[h+B>>0]|0;B=65536-z|0;E=c[k>>2]|0;F=c[b>>2]|0;G=((da(A>>>E<<F&255,B)|0)+(da(C>>>E<<F&255,z)|0)|0)>>>16;H=((da(D>>>E<<F&255,B)|0)+(da(e>>>E<<F&255,z)|0)|0)>>>16;I=c[l>>2]|0;J=c[m>>2]|0;K=((da(A>>>I<<J&255,B)|0)+(da(C>>>I<<J&255,z)|0)|0)>>>16;L=((da(D>>>I<<J&255,B)|0)+(da(e>>>I<<J&255,z)|0)|0)>>>16;M=c[n>>2]|0;N=c[o>>2]|0;O=((da(A>>>M<<N&255,B)|0)+(da(C>>>M<<N&255,z)|0)|0)>>>16;P=((da(D>>>M<<N&255,B)|0)+(da(e>>>M<<N&255,z)|0)|0)>>>16;Q=c[p>>2]|0;R=c[q>>2]|0;S=((da(A>>>Q<<R&255,B)|0)+(da(C>>>Q<<R&255,z)|0)|0)>>>16;C=((da(D>>>Q<<R&255,B)|0)+(da(e>>>Q<<R&255,z)|0)|0)>>>16;z=c[r>>2]|0;e=65536-z|0;B=((da(e,G)|0)+(da(z,H)|0)|0)>>>16>>>F<<E;E=((da(e,K)|0)+(da(z,L)|0)|0)>>>16>>>J<<I;I=((da(O,e)|0)+(da(P,z)|0)|0)>>>16>>>N<<M;M=((da(S,e)|0)+(da(C,z)|0)|0)>>>16>>>R<<Q;a[j>>0]=B&c[s>>2]|E&c[t>>2]|I&c[u>>2]|M&c[v>>2];if(!x)break;else{j=j+1|0;y=(c[w>>2]|0)+y|0}}i=f;return}function Voe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[d+4>>2]|0;h=c[d+8>>2]|0;j=c[d+12>>2]|0;if(!j){i=f;return}k=c[a+4>>2]|0;l=c[a>>2]|0;m=c[a+16>>2]|0;n=c[a+12>>2]|0;o=c[a+28>>2]|0;p=c[a+24>>2]|0;q=c[a+40>>2]|0;r=c[a+36>>2]|0;s=c[d+24>>2]|0;t=65536-s|0;u=c[a+8>>2]|0;v=c[a+20>>2]|0;w=c[a+32>>2]|0;x=c[a+44>>2]|0;a=c[d+20>>2]|0;y=j;j=c[d>>2]|0;z=c[d+16>>2]|0;while(1){y=y+-1|0;d=z>>>16;A=z&65535;B=e[g+(d<<1)>>1]|0;C=d+1|0;D=e[g+(C<<1)>>1]|0;E=e[h+(d<<1)>>1]|0;d=e[h+(C<<1)>>1]|0;C=65536-A|0;b[j>>1]=((da(t,((da(B>>>k<<l&255,C)|0)+(da(D>>>k<<l&255,A)|0)|0)>>>16)|0)+(da(s,((da(E>>>k<<l&255,C)|0)+(da(d>>>k<<l&255,A)|0)|0)>>>16)|0)|0)>>>16>>>l<<k&u|((da(t,((da(B>>>m<<n&255,C)|0)+(da(D>>>m<<n&255,A)|0)|0)>>>16)|0)+(da(s,((da(E>>>m<<n&255,C)|0)+(da(d>>>m<<n&255,A)|0)|0)>>>16)|0)|0)>>>16>>>n<<m&v|((da(((da(B>>>o<<p&255,C)|0)+(da(D>>>o<<p&255,A)|0)|0)>>>16,t)|0)+(da(((da(E>>>o<<p&255,C)|0)+(da(d>>>o<<p&255,A)|0)|0)>>>16,s)|0)|0)>>>16>>>p<<o&w|((da(((da(B>>>q<<r&255,C)|0)+(da(D>>>q<<r&255,A)|0)|0)>>>16,t)|0)+(da(((da(E>>>q<<r&255,C)|0)+(da(d>>>q<<r&255,A)|0)|0)>>>16,s)|0)|0)>>>16>>>r<<q&x;if(!y)break;else{j=j+2|0;z=a+z|0}}i=f;return}function Woe(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;g=c[e+4>>2]|0;h=c[e+8>>2]|0;j=c[e+12>>2]|0;if(!j){i=f;return}k=b+4|0;l=b+16|0;m=b+12|0;n=b+28|0;o=b+24|0;p=b+40|0;q=b+36|0;r=e+24|0;s=b+8|0;t=b+20|0;u=b+32|0;v=b+44|0;w=e+20|0;x=j;j=c[e>>2]|0;y=c[e+16>>2]|0;while(1){x=x+-1|0;e=y&65535;z=(y>>>16)*3|0;A=z+1|0;B=z+2|0;C=(d[g+A>>0]|0)<<8|(d[g+z>>0]|0)|(d[g+B>>0]|0)<<16;D=z+3|0;E=z+4|0;F=z+5|0;G=(d[g+E>>0]|0)<<8|(d[g+D>>0]|0)|(d[g+F>>0]|0)<<16;H=(d[h+A>>0]|0)<<8|(d[h+z>>0]|0)|(d[h+B>>0]|0)<<16;B=(d[h+E>>0]|0)<<8|(d[h+D>>0]|0)|(d[h+F>>0]|0)<<16;F=65536-e|0;D=c[k>>2]|0;E=c[b>>2]|0;z=((da(C>>>D<<E&255,F)|0)+(da(G>>>D<<E&255,e)|0)|0)>>>16;A=((da(B>>>D<<E&255,e)|0)+(da(H>>>D<<E&255,F)|0)|0)>>>16;I=c[l>>2]|0;J=c[m>>2]|0;K=((da(C>>>I<<J&255,F)|0)+(da(G>>>I<<J&255,e)|0)|0)>>>16;L=((da(H>>>I<<J&255,F)|0)+(da(B>>>I<<J&255,e)|0)|0)>>>16;M=c[n>>2]|0;N=c[o>>2]|0;O=((da(C>>>M<<N&255,F)|0)+(da(G>>>M<<N&255,e)|0)|0)>>>16;P=((da(H>>>M<<N&255,F)|0)+(da(B>>>M<<N&255,e)|0)|0)>>>16;Q=c[p>>2]|0;R=c[q>>2]|0;S=((da(C>>>Q<<R&255,F)|0)+(da(G>>>Q<<R&255,e)|0)|0)>>>16;G=((da(H>>>Q<<R&255,F)|0)+(da(B>>>Q<<R&255,e)|0)|0)>>>16;e=c[r>>2]|0;B=65536-e|0;F=((da(B,z)|0)+(da(e,A)|0)|0)>>>16>>>E<<D;D=((da(B,K)|0)+(da(e,L)|0)|0)>>>16>>>J<<I;I=((da(O,B)|0)+(da(P,e)|0)|0)>>>16>>>N<<M;M=((da(S,B)|0)+(da(G,e)|0)|0)>>>16>>>R<<Q;Q=F&c[s>>2]|D&c[t>>2]|I&c[u>>2]|M&c[v>>2];a[j>>0]=Q;a[j+1>>0]=Q>>>8;a[j+2>>0]=Q>>>16;if(!x)break;else{j=j+3|0;y=(c[w>>2]|0)+y|0}}i=f;return}function Xoe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;e=c[b+4>>2]|0;f=c[b+8>>2]|0;g=c[b+12>>2]|0;if(!g){i=d;return}h=a+4|0;j=a+16|0;k=a+12|0;l=a+28|0;m=a+24|0;n=a+40|0;o=a+36|0;p=b+24|0;q=a+8|0;r=a+20|0;s=a+32|0;t=a+44|0;u=b+20|0;v=g;g=c[b>>2]|0;w=c[b+16>>2]|0;while(1){v=v+-1|0;b=w>>>16;x=w&65535;y=c[e+(b<<2)>>2]|0;z=b+1|0;A=c[e+(z<<2)>>2]|0;B=c[f+(b<<2)>>2]|0;b=c[f+(z<<2)>>2]|0;z=65536-x|0;C=c[h>>2]|0;D=c[a>>2]|0;E=((da(y>>>C<<D&255,z)|0)+(da(A>>>C<<D&255,x)|0)|0)>>>16;F=((da(B>>>C<<D&255,z)|0)+(da(b>>>C<<D&255,x)|0)|0)>>>16;G=c[j>>2]|0;H=c[k>>2]|0;I=((da(y>>>G<<H&255,z)|0)+(da(A>>>G<<H&255,x)|0)|0)>>>16;J=((da(B>>>G<<H&255,z)|0)+(da(b>>>G<<H&255,x)|0)|0)>>>16;K=c[l>>2]|0;L=c[m>>2]|0;M=((da(y>>>K<<L&255,z)|0)+(da(A>>>K<<L&255,x)|0)|0)>>>16;N=((da(B>>>K<<L&255,z)|0)+(da(b>>>K<<L&255,x)|0)|0)>>>16;O=c[n>>2]|0;P=c[o>>2]|0;Q=((da(y>>>O<<P&255,z)|0)+(da(A>>>O<<P&255,x)|0)|0)>>>16;A=((da(B>>>O<<P&255,z)|0)+(da(b>>>O<<P&255,x)|0)|0)>>>16;x=c[p>>2]|0;b=65536-x|0;z=((da(b,E)|0)+(da(x,F)|0)|0)>>>16>>>D<<C;C=((da(b,I)|0)+(da(x,J)|0)|0)>>>16>>>H<<G;G=((da(M,b)|0)+(da(N,x)|0)|0)>>>16>>>L<<K;K=((da(Q,b)|0)+(da(A,x)|0)|0)>>>16>>>P<<O;c[g>>2]=z&c[q>>2]|C&c[r>>2]|G&c[s>>2]|K&c[t>>2];if(!v)break;else{g=g+4|0;w=(c[u>>2]|0)+w|0}}i=d;return}function Yoe(a){a=a|0;var b=0,d=0;b=i;d=a+0|0;a=d+44|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function Zoe(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=e;c[a+12>>2]=c[f>>2];c[a+16>>2]=c[f+4>>2];c[a+20>>2]=c[f+8>>2];c[a+24>>2]=c[f+12>>2];c[a+28>>2]=c[f+16>>2];c[a+32>>2]=c[f+20>>2];c[a+36>>2]=c[f+24>>2];c[a+40>>2]=g;return}function _oe(){var a=0,b=0,d=0;a=i;b=xCi(12)|0;d=b+4|0;c[d>>2]=0;c[b+8>>2]=0;c[b>>2]=d;c[264602]=b;i=a;return}function $oe(){var b=0,d=0,e=0;b=i;d=c[264602]|0;bpe(d,c[d+4>>2]|0);c[d+8>>2]=0;e=d+4|0;c[d>>2]=e;c[e>>2]=0;e=c[264602]|0;if(e){bpe(e,c[e+4>>2]|0);ACi(e)}c[264602]=0;if(!(a[1058384]&1)){a[1058385]=0;a[1058384]=0;i=b;return}else{a[c[264598]>>0]=0;c[264597]=0;i=b;return}}function ape(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;cpe();e=c[264602]|0;if(!(dpe(e,a)|0)){f=b;i=d;return f|0}g=epe(e,a)|0;if((c[g>>2]|0)!=254){f=b;i=d;return f|0}f=c[g+4>>2]|0;i=d;return f|0}function bpe(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}bpe(a,c[b>>2]|0);bpe(a,c[b+4>>2]|0);xri(b+36|0);xri(b+16|0);ACi(b);i=d;return}function cpe(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=i;i=i+96|0;e=b+80|0;f=b+56|0;g=b+24|0;h=b+60|0;j=b;k=b+40|0;l=b+44|0;m=b+84|0;if(c[264600]|0){i=b;return}rri(l,1058416,18);n=c[264602]|0;bpe(n,c[n+4>>2]|0);c[n+8>>2]=0;o=n+4|0;c[n>>2]=o;c[o>>2]=0;c[264600]=16;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;if(uqd(m,l)|0){o=a[m>>0]|0;if(!(o&1)){p=m+1|0;q=(o&255)>>>1}else{p=c[m+8>>2]|0;q=c[m+4>>2]|0}c[f>>2]=p;o=p+q|0;if(q>>>0>=16?(n=p,r=n,s=n+4|0,n=d[s>>0]|d[s+1>>0]<<8|d[s+2>>0]<<16|d[s+3>>0]<<24,s=g,c[s>>2]=d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24,c[s+4>>2]=n,n=c[p+8>>2]|0,c[g+8>>2]=n,c[g+12>>2]=c[p+12>>2],c[f>>2]=p+16,(FEi(1058368,g,8)|0)==0&(n|0)==65536&(q|0)>16):0){q=j+8|0;n=h+8|0;g=j+12|0;p=h+12|0;do{fpe(h,f,o);s=c[f>>2]|0;if((c[h>>2]|0)==128&s>>>0<o>>>0){fpe(j,f,o);if((c[j>>2]|0)==255)t=3;else{r=epe(c[264602]|0,n)|0;u=j;v=c[u+4>>2]|0;w=r;c[w>>2]=c[u>>2];c[w+4>>2]=v;yri(r+8|0,q)|0;if(((c[h>>2]|0)+-253|0)>>>0<2)x=5;else{r=a[n>>0]|0;if(!(r&1))y=(r&255)>>>1;else y=c[p>>2]|0;x=(y>>>0<128?1:5)+y|0}if(((c[j>>2]|0)+-253|0)>>>0<2)z=5;else{r=a[q>>0]|0;if(!(r&1))A=(r&255)>>>1;else A=c[g>>2]|0;z=(A>>>0<128?1:5)+A|0}c[264600]=z+x+(c[264600]|0);t=0}xri(q);B=t;C=c[f>>2]|0}else{B=3;C=s}xri(n)}while((B|0)!=3&C>>>0<o>>>0)}}if(a[m>>0]&1){o=c[m+8>>2]|0;c[k>>2]=89;c[e+0>>2]=c[k+0>>2];eOb(o,e)}xri(l);i=b;return}function dpe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;f=c[b+4>>2]|0;if(!f){g=0;i=e;return g|0}b=a[d>>0]|0;h=(b&1)==0;j=(b&255)>>>1;b=d+1|0;k=c[d+8>>2]|0;l=c[d+4>>2]|0;d=f;while(1){f=d+16|0;m=h?j:l;n=a[f>>0]|0;o=(n&1)==0;if(o)p=(n&255)>>>1;else p=c[d+20>>2]|0;if(o)q=f+1|0;else q=c[d+24>>2]|0;r=FEi(h?b:k,q,p>>>0<m>>>0?p:m)|0;if(!r)if(m>>>0<p>>>0)s=12;else s=13;else if((r|0)<0)s=12;else s=13;if((s|0)==12){s=0;t=d}else if((s|0)==13){s=0;if(o)u=(n&255)>>>1;else u=c[d+20>>2]|0;n=h?j:l;if(o)v=f+1|0;else v=c[d+24>>2]|0;f=FEi(v,h?b:k,n>>>0<u>>>0?n:u)|0;if(!f){if(u>>>0>=n>>>0){g=1;s=24;break}}else if((f|0)>=0){g=1;s=24;break}t=d+4|0}d=c[t>>2]|0;if(!d){g=0;s=24;break}}if((s|0)==24){i=e;return g|0}return 0}function epe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=gpe(a,e,b)|0;g=c[f>>2]|0;if(g){h=g;j=h+28|0;i=d;return j|0}g=xCi(48)|0;sri(g+16|0,b);c[g+28>>2]=255;b=g+36|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;b=c[e>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=b;c[f>>2]=g;b=c[c[a>>2]>>2]|0;if(!b)k=g;else{c[a>>2]=b;k=c[f>>2]|0}GN(c[a+4>>2]|0,k);k=a+8|0;c[k>>2]=(c[k>>2]|0)+1;h=g;j=h+28|0;i=d;return j|0}function fpe(b,e,f){b=b|0;e=e|0;f=f|0;var h=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im;h=i;i=i+16|0;j=h;l=c[e>>2]|0;m=l+1|0;c[e>>2]=m;n=a[l>>0]|0;o=n&255;if(m>>>0>f>>>0){c[b>>2]=255;p=b+8|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;i=h;return}if((n+127<<24>>24&255)<124){c[b>>2]=255;n=b+8|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=h;return}if((o|0)==128){n=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;p=l+5|0;c[e>>2]=p;if(p>>>0>f>>>0){c[b>>2]=255;q=b+8|0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;i=h;return}else{r=5;s=p;t=n}}else if((o|0)==254){n=l+5|0;c[e>>2]=n;if(n>>>0>f>>>0){c[b>>2]=255;n=b+8|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=h;return}else{n=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;c[b>>2]=254;c[b+4>>2]=n;n=b+8|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=h;return}}else if((o|0)==253){n=l+5|0;c[e>>2]=n;if(n>>>0>f>>>0){c[b>>2]=255;n=b+8|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=h;return}else{a[k>>0]=a[m>>0];a[k+1>>0]=a[m+1>>0];a[k+2>>0]=a[m+2>>0];a[k+3>>0]=a[m+3>>0];u=ea(g[k>>2]);c[b>>2]=253;g[b+4>>2]=u;n=b+8|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=h;return}}else{r=1;s=m;t=o}o=l+(r+t)|0;c[e>>2]=o;if(o>>>0>f>>>0){c[b>>2]=255;f=b+8|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;i=h;return}else{rri(j,s,t);c[b>>2]=128;sri(b+8|0,j);xri(j);i=h;return}}function gpe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e>>0]|0;b=(h&255)>>>1;k=e+1|0;l=c[e+8>>2]|0;m=c[e+4>>2]|0;a:do if(!(h&1)){e=g;while(1){n=e+16|0;o=a[n>>0]|0;p=(o&1)==0;if(p){q=(o&255)>>>1;r=n+1|0}else{q=c[e+20>>2]|0;r=c[e+24>>2]|0}s=FEi(k,r,q>>>0<b>>>0?q:b)|0;if(!s){if(b>>>0<q>>>0)t=16}else if((s|0)<0)t=16;if((t|0)==16){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){w=(o&255)>>>1;x=n+1|0}else{w=c[e+20>>2]|0;x=c[e+24>>2]|0}n=FEi(x,k,b>>>0<w>>>0?b:w)|0;if(!n){if(w>>>0>=b>>>0){y=e;t=33;break a}}else if((n|0)>=0){y=e;t=33;break a}n=e+4|0;o=c[n>>2]|0;if(!o){z=n;A=e;t=32;break}else e=o}}else{e=g;while(1){o=e+16|0;n=a[o>>0]|0;p=(n&1)==0;if(p){B=(n&255)>>>1;C=o+1|0}else{B=c[e+20>>2]|0;C=c[e+24>>2]|0}s=FEi(l,C,B>>>0<m>>>0?B:m)|0;if(!s){if(m>>>0<B>>>0)t=23}else if((s|0)<0)t=23;if((t|0)==23){t=0;s=c[e>>2]|0;if(!s){u=e;v=e;t=24;break}else{e=s;continue}}if(p){D=(n&255)>>>1;E=o+1|0}else{D=c[e+20>>2]|0;E=c[e+24>>2]|0}o=FEi(E,l,m>>>0<D>>>0?m:D)|0;if(!o){if(D>>>0>=m>>>0){y=e;t=33;break a}}else if((o|0)>=0){y=e;t=33;break a}o=e+4|0;n=c[o>>2]|0;if(!n){z=o;A=e;t=32;break}else e=n}}while(0);if((t|0)==24){c[d>>2]=v;j=u;i=f;return j|0}else if((t|0)==32){c[d>>2]=A;j=z;i=f;return j|0}else if((t|0)==33){c[d>>2]=y;j=d;i=f;return j|0}return 0}function hpe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=b;e=b+4|0;if(!(Ig()|0)){f=1;i=b;return f|0}Bm(e|0);c[e+4>>2]=1;c[e+8>>2]=1;g=pyc()|0;c[e+12>>2]=(c[(c[g+24>>2]|0)+((c[g+40>>2]|0)*96|0)+64>>2]|0)>0&1;g=a+-1|0;c[e+32>>2]=g;c[d>>2]=g;gl(1058440,d|0)|0;c[e>>2]=1;g=uc(0,e|0)|0;if((g|0)<1){Ec(1058512)|0;f=0;i=b;return f|0}e=Pe(g|0)|0;if(!e){f=1;i=b;return f|0}c[d>>2]=e;gl(1058472,d|0)|0;f=0;i=b;return f|0}function ipe(){return 1}function jpe(){var a=0;a=i;hh(We()|0)|0;i=a;return}function kpe(b){b=b|0;a[b>>0]=0;return 1}function lpe(a){a=a|0;return 1}function mpe(a){a=a|0;return 1}function npe(){return}function ope(){var a=0;a=i;if(Ig()|0)Cm();i=a;return}function ppe(d,e,f){d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h;n=e;o=c[n+4>>2]|0;p=1058552;c[p>>2]=c[n>>2];c[p+4>>2]=o;c[264636]=0;if(!d){ji(1);i=h;return}if((f|0)==1){ji(0);c[264636]=c[d+4>>2];i=h;return}f=mo[c[(c[d>>2]|0)+104>>2]&4095](d)|0;o=mo[c[(c[d>>2]|0)+108>>2]&4095](d)|0;p=f<<2;n=da(o,p)|0;q=n+62|0;r=n+77|0;if(r>>>0<2e3){s=i;i=i+((1*r|0)+15&-16)|0;t=0;u=s}else{c[l>>2]=c[153134];c[j+0>>2]=c[l+0>>2];l=cOb(r,16,j,0,3653512,43)|0;t=l;u=l}l=u+15&-16;u=l;b[l>>1]=0;b[u+2>>1]=2;b[u+4>>1]=1;a[u+6>>0]=f;a[u+7>>0]=o;a[u+8>>0]=0;a[u+9>>0]=0;b[u+10>>1]=~~ea(g[e>>2]);b[u+12>>1]=~~ea(g[e+4>>2]);e=u+14|0;l=n+40|0;b[e>>1]=l;b[e+2>>1]=l>>>16;l=u+18|0;b[l>>1]=22;b[l+2>>1]=22>>>16;l=u+22|0;b[l>>1]=40;b[l+2>>1]=40>>>16;l=u+26|0;b[l>>1]=f;b[l+2>>1]=f>>>16;l=u+30|0;e=o<<1;b[l>>1]=e;b[l+2>>1]=e>>>16;b[u+34>>1]=1;b[u+36>>1]=32;e=u+62|0;l=u+38|0;r=l+24|0;do{b[l>>1]=0;l=l+2|0}while((l|0)<(r|0));iwc(m,f,o,p,5,e);xo[c[(c[d>>2]|0)+96>>2]&2047](d,m,0)|0;if((n|0)>0){m=0;do{d=u+((m|3)+62)|0;e=a[d>>0]|0;p=u+(m+62)|0;a[d>>0]=a[p>>0]|0;a[p>>0]=e;e=u+((m|2)+62)|0;p=a[e>>0]|0;d=u+((m|1)+62)|0;a[e>>0]=a[d>>0]|0;a[d>>0]=p;m=m+4|0}while((m|0)<(n|0))}wl(u|0,q|0);if(!t){i=h;return}c[k>>2]=c[153134];c[j+0>>2]=c[k+0>>2];eOb(t,j);i=h;return}function qpe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];ppe(a,e,0);i=d;return}function rpe(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+8|0;d=a;e=c[264636]|0;if(!e){f=0;i=a;return f|0}c[d>>2]=e;e=c[137784]|0;if(e){do if((c[e+36>>2]|0)!=(c[e+4>>2]|0)){fRb(b,e,d);g=c[b>>2]|0;h=c[e+28>>2]|0;if((g|0)==-1){j=h+(c[e+32>>2]<<3)|0;break}else{j=h+(g<<3)|0;break}}else j=(c[e+28>>2]|0)+(c[e+32>>2]<<3)|0;while(0);e=c[137784]|0;if((j|0)!=((c[e+28>>2]|0)+(c[e+32>>2]<<3)|0)?(e=c[j+4>>2]|0,(e|0)!=0):0)k=e;else l=10}else l=10;if((l|0)==10)k=hQb(c[264636]|0)|0;f=k;i=a;return f|0}function spe(a){a=a|0;var b=0,d=0,e=0;b=1058552;d=c[b+4>>2]|0;e=a;c[e>>2]=c[b>>2];c[e+4>>2]=d;return}function tpe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+64|0;f=e+8|0;g=e+52|0;h=e+40|0;j=e+28|0;k=e+16|0;l=e;rrd(b,d);if(Wi(512)|0){c[f>>2]=Ph()|0;gl(1058560,f|0)|0;m=1;i=e;return m|0}Vi(1058592);Ye(512)|0;He();Pq();Drc();mRc();rri(h,3653512,0);rri(j,3653512,0);d=jRc(h,j)|0;xri(j);xri(h);if(!d){Ird(1058912,f);m=1;i=e;return m|0}if(!(kRc(0)|0)){Ird(1058912,f);m=1;i=e;return m|0}d=Xbd()|0;ko[c[(c[d>>2]|0)+100>>2]&4095](d);tri(k,Wk(0,0)|0,0);d=a[k>>0]|0;if(!(d&1)){n=k+1|0;o=(d&255)>>>1}else{n=c[k+8>>2]|0;o=c[k+4>>2]|0}Wk(n|0,o|0)|0;o=rSc()|0;n=o+240|0;d=a[k>>0]|0;if(!(d&1)){p=(d&255)>>>1;q=k+1|0}else{p=c[k+4>>2]|0;q=c[k+8>>2]|0}d=a[n>>0]|0;if(!(d&1)){r=10;s=d}else{d=c[n>>2]|0;r=(d&-2)+-1|0;s=d&255}d=(s&1)==0;do if(p>>>0<=r>>>0){if(d)t=n+1|0;else t=c[o+248>>2]|0;aFi(t|0,q|0,p|0)|0;a[t+p>>0]=0;if(!(a[n>>0]&1)){a[n>>0]=p<<1;break}else{c[o+244>>2]=p;break}}else{if(d)u=(s&255)>>>1;else u=c[o+244>>2]|0;eXb(n,r,p-r|0,u,0,u,p,q)}while(0);lRc();q=c[(rSc()|0)+72>>2]|0;if(!q)v=0;else{c[g>>2]=q;p=c[137784]|0;if(p){do if((c[p+36>>2]|0)!=(c[p+4>>2]|0)){fRb(f,p,g);u=c[f>>2]|0;r=c[p+28>>2]|0;if((u|0)==-1){w=r+(c[p+32>>2]<<3)|0;break}else{w=r+(u<<3)|0;break}}else w=(c[p+28>>2]|0)+(c[p+32>>2]<<3)|0;while(0);p=c[137784]|0;if((w|0)!=((c[p+28>>2]|0)+(c[p+32>>2]<<3)|0)?(p=c[w+4>>2]|0,(p|0)!=0):0)x=p;else y=35}else y=35;if((y|0)==35)x=hQb(q)|0;v=x}x=(rSc()|0)+76|0;q=c[x+4>>2]|0;y=l;c[y>>2]=c[x>>2];c[y+4>>2]=q;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];qpe(v,f);f=ECc()|0;v=c[(c[f>>2]|0)+16>>2]|0;l=c[(rSc()|0)+120>>2]|0;q=c[(rSc()|0)+124>>2]|0;Bn[v&255](f,l,q,0,0)|0;mh(242,0,1);xri(k);m=0;i=e;return m|0}function upe(){var a=0;a=i;Oq();Mp()|0;Pq();Ope(ECc()|0);if(Ruc()|0?!(Quc()|0):0){Suc(1);i=a;return}Ape();if((fRc()|0)==2){i=a;return}if((fRc()|0)==1)eRc(2);pRc(0,1,0);i=a;return}function vpe(){return}function wpe(){return}function xpe(){var b=0;b=i;if(a[1064176]|0){i=b;return}a[1064176]=1;PEi(1058944,0,5228)|0;c[264749]=13;c[264763]=27;c[264744]=8;c[264745]=9;c[264768]=32;c[264769]=33;c[264770]=34;c[264771]=35;c[264772]=36;c[264774]=38;c[264775]=39;c[264776]=40;c[264777]=41;c[264778]=42;c[264779]=43;c[264780]=44;c[264781]=45;c[264782]=46;c[264783]=47;c[264784]=48;c[264785]=49;c[264786]=50;c[264787]=51;c[264788]=52;c[264789]=53;c[264790]=54;c[264791]=55;c[264792]=56;c[264793]=57;c[264794]=58;c[264795]=59;c[264796]=60;c[264797]=61;c[264798]=62;c[264799]=63;c[264800]=64;c[264827]=91;c[264828]=92;c[264829]=93;c[264830]=94;c[264831]=95;c[264832]=96;c[264833]=97;c[264834]=98;c[264835]=99;c[264836]=100;c[264837]=101;c[264838]=102;c[264839]=103;c[264840]=104;c[264841]=105;c[264842]=106;c[264843]=107;c[264844]=108;c[264845]=109;c[264846]=110;c[264847]=111;c[264848]=112;c[264849]=113;c[264850]=114;c[264851]=115;c[264852]=116;c[264853]=117;c[264854]=118;c[264855]=119;c[264856]=120;c[264857]=121;c[264858]=122;c[265817]=301;c[265818]=282;c[265819]=283;c[265820]=284;c[265821]=285;c[265822]=286;c[265823]=287;c[265824]=288;c[265825]=289;c[265826]=290;c[265827]=291;c[265828]=292;c[265829]=293;c[265832]=19;c[265833]=277;c[265834]=278;c[265835]=280;c[264863]=127;c[265837]=279;c[265838]=281;c[265839]=275;c[265840]=276;c[265841]=274;c[265842]=273;c[265844]=267;c[265845]=268;c[265846]=269;c[265847]=270;c[265848]=271;c[265859]=266;c[265862]=320;c[265863]=272;c[265864]=294;c[265865]=295;c[265866]=296;c[265877]=315;c[265878]=319;c[265882]=322;c[265914]=317;c[265916]=12;c[265984]=306;c[265985]=304;c[265986]=308;c[265987]=310;c[265988]=305;c[265989]=303;c[265990]=307;c[265991]=309;c[266017]=313;i=b;return}function ype(a,e){a=a|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=0,u=0,v=0,w=0,x=0;f=i;i=i+48|0;h=f+36|0;j=f+32|0;k=f+16|0;l=f;UQc(a);m=c[e>>2]|0;switch(m|0){case 1024:case 1026:case 1025:{n=fKc()|0;o=c[(c[n+40>>2]|0)+36>>2]|c[(c[n+56>>2]|0)+36>>2];n=(o&98304|0)!=0&1;p=(o&393216|0)!=0?n|2:n;n=(o&1572864|0)!=0?p|4:p;c[a+24>>2]=(o&6291456|0)!=0?n|8:n;if((c[e>>2]|0)==1024){n=fKc()|0;c[a>>2]=(c[(c[n+40>>2]|0)+40>>2]|c[(c[n+56>>2]|0)+40>>2])>>>3&1|2;q=ea(c[e+28>>2]|0);r=ea(c[e+32>>2]|0);s=ea(q);q=ea(r);n=a+12|0;g[n>>2]=s;g[n+4>>2]=q;q=ea(c[e+20>>2]|0);s=ea(c[e+24>>2]|0);r=ea(q);q=ea(s);n=a+4|0;g[n>>2]=r;g[n+4>>2]=q;n=fKc()|0;if(!((c[(c[n+40>>2]|0)+40>>2]|c[(c[n+56>>2]|0)+40>>2])&8)){n=fKc()|0;if(!((c[(c[n+40>>2]|0)+40>>2]|c[(c[n+56>>2]|0)+40>>2])&16)){n=fKc()|0;t=(c[(c[n+40>>2]|0)+40>>2]|c[(c[n+56>>2]|0)+40>>2])>>>4&2}else t=1}else t=0;c[a+20>>2]=t;i=f;return}t=a+32|0;c[t>>2]=1;n=d[e+16>>0]|0;if((n|0)==3)u=1;else if((n|0)==2)u=2;else if((n|0)==1)u=0;else u=3;c[a+20>>2]=u;u=e+20|0;q=ea(c[u>>2]|0);n=e+24|0;r=ea(c[n>>2]|0);s=ea(q);q=ea(r);o=a+4|0;g[o>>2]=s;g[o+4>>2]=q;o=c[e>>2]|0;if((o|0)==1025){q=ea(+$Kc(jLc()|0));c[a>>2]=0;p=c[u>>2]|0;if(((p|0)==(c[266048]|0)?(c[n>>2]|0)==(c[266050]|0):0)?ea(q-ea(g[266046]))<=ea(1.0):0)c[t>>2]=(c[266052]|0)+1;c[266048]=p;c[266050]=c[n>>2];c[266052]=c[t>>2];g[266046]=q;i=f;return}else if((o|0)==1026){c[a>>2]=1;c[t>>2]=1;i=f;return}else{i=f;return}break}case 769:case 768:{c[a>>2]=(m|0)==768?4:5;m=fKc()|0;t=c[(c[m+40>>2]|0)+36>>2]|c[(c[m+56>>2]|0)+36>>2];m=(t&98304|0)!=0&1;o=(t&393216|0)!=0?m|2:m;m=(t&1572864|0)!=0?o|4:o;c[a+24>>2]=(t&6291456|0)!=0?m|8:m;b[a+38>>1]=c[1058944+(c[e+16>>2]<<2)>>2];m=fKc()|0;q=ea(g[m+100>>2]);s=ea(g[m+104>>2]);m=ECc()|0;r=ea(ea(mo[c[(c[m>>2]|0)+84>>2]&4095](m)|0)-s);s=ea(q);q=ea(r);m=a+4|0;g[m>>2]=s;g[m+4>>2]=q;XQc(a);i=f;return}case 1027:{c[a>>2]=6;q=ea(c[e+16>>2]|0);s=ea(0-(c[e+20>>2]|0)|0);r=ea(q);q=ea(s);m=a+12|0;g[m>>2]=r;g[m+4>>2]=q;m=fKc()|0;q=ea(g[m+100>>2]);r=ea(g[m+104>>2]);m=ECc()|0;s=ea(ea(mo[c[(c[m>>2]|0)+84>>2]&4095](m)|0)-r);r=ea(q);q=ea(s);m=a+4|0;g[m>>2]=r;g[m+4>>2]=q;i=f;return}case 771:{c[a>>2]=4;m=fKc()|0;t=c[(c[m+40>>2]|0)+36>>2]|c[(c[m+56>>2]|0)+36>>2];m=(t&98304|0)!=0&1;o=(t&393216|0)!=0?m|2:m;m=(t&1572864|0)!=0?o|4:o;c[a+24>>2]=(t&6291456|0)!=0?m|8:m;m=fKc()|0;q=ea(g[m+100>>2]);r=ea(g[m+104>>2]);m=ECc()|0;s=ea(ea(mo[c[(c[m>>2]|0)+84>>2]&4095](m)|0)-r);r=ea(q);q=ea(s);m=a+4|0;g[m>>2]=r;g[m+4>>2]=q;c[k>>2]=0;m=k+8|0;c[m>>2]=0;t=k+12|0;c[t>>2]=0;o=k+4|0;c[o>>2]=60;n=e+8|0;rri(l,n,SEi(n|0)|0);JVc(l,k)|0;xri(l);XQc(a);l=c[k>>2]|0;n=c[m>>2]|0;if(!n)v=l;else{e=a+36|0;p=l;u=n;n=l;while(1){if((n|0)==(p|0)){w=p;x=u}else{zJc(EJc()|0,a);w=c[k>>2]|0;x=c[m>>2]|0}b[e>>1]=b[n>>1]|0;n=n+2|0;if((n|0)==(w+(x<<1)|0)){v=w;break}else{p=w;u=x}}}if((c[t>>2]|0)<=-1){i=f;return}c[j>>2]=c[o>>2];c[h+0>>2]=c[j+0>>2];eOb(v,h);c[k>>2]=0;i=f;return}default:{c[a>>2]=11;i=f;return}}}function zpe(b){b=b|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=0,s=Im,t=Im;e=i;i=i+128|0;f=e;h=e+20|0;j=e+8|0;k=fKc()|0;l=c[b>>2]|0;switch(l|0){case 1026:case 1025:{m=d[b+16>>0]|0;if((m|0)==2)n=325;else if((m|0)==3)n=324;else if((m|0)==1)n=323;else n=326;sKc(k,n,(l|0)==1025);i=e;return}case 1536:{oKc(k,(d[b+4>>0]|0)+1|0,d[b+5>>0]|0,ea(+(c[b+8>>2]|0)/32767.0));i=e;return}case 1027:{l=k+84|0;o=ea(g[l>>2]);n=k+88|0;p=ea(g[n>>2]);m=k+92|0;q=ea(g[m>>2]);r=k+96|0;s=ea(g[r>>2]);t=ea(q+ea(c[b+16>>2]|0));q=ea(s+ea(c[b+20>>2]|0));g[l>>2]=o;g[n>>2]=p;g[m>>2]=t;g[r>>2]=q;break}case 1538:{r=b+4|0;m=(Sl(lf(d[r>>0]|0)|0)|0)+(d[b+5>>0]<<1)|0;n=a[b+6>>0]|0;l=n&255;q=ea(l<<28>>31|0);oKc(k,(d[r>>0]|0)+1|0,m,(n&2)==0?q:ea(1.0));q=ea(l&1|0);oKc(k,(d[r>>0]|0)+1|0,m+1|0,(l&4|0)!=0?ea(-1.0):q);i=e;return}case 769:case 768:{if(tKc(k)|0?uKc(k)|0:0){i=e;return}xpe();l=b+16|0;sKc(k,c[1058944+(c[l>>2]<<2)>>2]|0,(c[b>>2]|0)==768);if((c[l>>2]|0)!=8){i=e;return}Eri(k+124|0,1064216)|0;i=e;return}case 1024:{q=ea(c[b+28>>2]|0);t=ea(0-(c[b+32>>2]|0)|0);g[k+84>>2]=q;g[k+88>>2]=t;g[k+92>>2]=ea(0.0);g[k+96>>2]=ea(0.0);t=ea(c[b+20>>2]|0);l=ECc()|0;q=ea((mo[c[(c[l>>2]|0)+84>>2]&4095](l)|0)-(c[b+24>>2]|0)|0);p=ea(t);t=ea(q);l=k+100|0;g[l>>2]=p;g[l+4>>2]=t;i=e;return}case 1540:case 1539:{l=d[b+5>>0]|0;c[f>>2]=(d[b+4>>0]|0)+1;c[f+4>>2]=l;sEi(h,1064224,f)|0;rri(j,h,SEi(h|0)|0);sKc(k,kKc(j)|0,(a[b+6>>0]|0)!=0);xri(j);break}case 771:{Eri(k+124|0,b+8|0)|0;break}default:{}}i=e;return}function Ape(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+96|0;b=a;d=a+48|0;e=Nd()|0;f=c[266062]|0;if((e|0)>(f|0)){e=f;do{c[266062]=e+1;lf(e|0)|0;f=Nd()|0;e=c[266062]|0}while((f|0)>(e|0))}if(!(_g(b|0)|0)){i=a;return}e=d+4|0;f=d+40|0;do{zpe(b);c[f>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;ype(d,b);zJc(EJc()|0,d);TQc(d)}while((_g(b|0)|0)!=0);i=a;return}function Bpe(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;f=i;g=pyc()|0;h=c[(c[g+24>>2]|0)+((c[g+40>>2]|0)*96|0)+64>>2]|0;g=a+60|0;j=c[g>>2]|0;if(!((j|0)==-1|(j|0)==(h|0)))Krd(1064256,0,3653512,15,512,0,0,0);c[g>>2]=h;if(e){c[a+28>>2]=b;c[a+32>>2]=d}else bl(b|0,d|0);if(!((mo[c[(c[a>>2]|0)+92>>2]&4095](a)|0)^e)){k=1;i=f;return k|0}if(!e){Xg()|0;k=1;i=f;return k|0}if(!(mf()|0)){Krd(1064336,0,3653512,35,1,0,0,0);k=0;i=f;return k|0}else{Oe(0,1)|0;k=1;i=f;return k|0}return 0}function Cpe(a){a=a|0;var b=0;a=i;b=em(1064384)|0;i=a;return b|0}function Dpe(a){a=a|0;var b=0;a=i;b=em(1064424)|0;i=a;return b|0}function Epe(a){a=a|0;var b=0;a=i;i=i+288|0;b=a;fm(b|0)|0;i=a;return (c[b>>2]|0)!=0|0}function Fpe(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Gpe(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Hpe(a,b,d){a=a|0;b=b|0;d=d|0;a=i;if(!(c[b>>2]|0)){bl(c[d+28>>2]|0,c[d+32>>2]|0);i=a;return 1}else{bl(c[b+272>>2]|0,c[b+276>>2]|0);i=a;return 1}return 0}function Ipe(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b=(a|0)==13;gRc(b);if(hRc()|0){i=c;return 1}eRc(b&1^1);i=c;return 1}function Jpe(b){b=b|0;var d=0;d=i;GCc(b);c[b>>2]=1064472;Wf(1064600,0,0,1774)|0;vm(0,0,0,1775)|0;ek(0,b|0,1,1776)|0;zj(0,0,0,1777)|0;pj(0,0,0,1777)|0;a[b+56>>0]=1;c[b+60>>2]=-1;i=d;return}function Kpe(b,c){b=b|0;c=c|0;var e=0,f=0;e=i;f=b+56|0;if((d[f>>0]|0|0)==(c&1|0)){i=e;return}ji(c|0);a[f>>0]=c&1;i=e;return}function Lpe(a,b){a=a|0;b=b|0;a=i;if((b|0)!=1){Ul()|0;i=a;return}if(!(zf()|0)){Krd(1064608,0,3653512,140,1,0,0,0);i=a;return}else{tj(0,1)|0;i=a;return}}function Mpe(a){a=a|0;var b=0,d=0;a=i;i=i+272|0;b=a;if(!(zf()|0)){d=0;i=a;return d|0}Oj(b|0)|0;d=(c[b>>2]|0)!=0&1;i=a;return d|0}function Npe(a,b){a=a|0;b=b|0;b=i;c[a+4>>2]=ee()|0;c[a>>2]=Nk()|0;c[a+8>>2]=60;i=b;return}function Ope(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im;b=i;i=i+16|0;d=b;e=n8b()|0;f=mo[c[(c[a>>2]|0)+80>>2]&4095](a)|0;h=mo[c[(c[a>>2]|0)+84>>2]&4095](a)|0;j=ea(f|0);if(!(ea(g[e+64>>2])!=j)){k=ea(h|0);if(ea(g[e+68>>2])!=k)l=k;else{i=b;return}}else l=ea(h|0);g[d>>2]=ea(0.0);g[d+8>>2]=j;g[d+4>>2]=ea(0.0);g[d+12>>2]=l;l8b(e,d);bl(f|0,h|0);i=b;return}function Ppe(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Qpe(b){b=b|0;return (a[b+56>>0]|0)!=0|0}function Rpe(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e;h=tsc(c[(Xbd()|0)+212>>2]|0)|0;g[h+8>>2]=d;j=nHc(a)|0;if(!j){c[f>>2]=a;Ird(1064728,f);i=e;return}if(Icd(c[j+24>>2]|0,b,h)|0){i=e;return}c[f>>2]=a;c[f+4>>2]=b;Ird(1064664,f);i=e;return}function Spe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=ysc(d)|0;d=nHc(a)|0;if(!d){c[f>>2]=a;Ird(1064728,f);i=e;return}if(Icd(c[d+24>>2]|0,b,g)|0){i=e;return}c[f>>2]=a;c[f+4>>2]=b;Ird(1064664,f);i=e;return}function Tpe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=nHc(a)|0;if(!f){c[e>>2]=a;Ird(1064728,e);i=d;return}if(Icd(c[f+24>>2]|0,b,0)|0){i=d;return}c[e>>2]=a;c[e+4>>2]=b;Ird(1064664,e);i=d;return}function Upe(a){a=a|0;var b=0;b=i;if(!(FCc()|0)){i=b;return}MCc(ECc()|0,(a|0)!=0);i=b;return}function Vpe(){var a=0,b=0;a=i;b=xj()|0;i=a;return b|0}function Wpe(a){a=a|0;var b=0;b=i;rri(a,1064768,6);i=b;return}function Xpe(a){a=a|0;var b=0;b=i;Krd(1064776,0,3653512,87,1,0,0,0);rri(a,3653512,0);i=b;return}function Ype(){var b=0,c=0,d=0.0,e=0.0;b=i;c=(a[1064792]|0)==0;d=+Ki();if(c){h[133100]=d;a[1064792]=1;e=0.0;i=b;return +e}else{e=(d-+h[133100])*.001;i=b;return +e}return +(0.0)}function Zpe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;d=a+3184|0;a:do if(!d)e=0;else{f=d;g=0;h=0;while(1){j=f;k=c[j+4>>2]|0;if(k>>>0<4){e=g;break a}l=g+(((h|0)!=(k>>>1&1|0))<<31>>31)|0;f=(k+-4&-4)+(j+8)|0;if(!f){e=l;break}else{g=l;h=k&1}}}while(0);d=c[a+16>>2]|0;h=a+20|0;g=a+116|0;f=0;k=e;while(1){e=c[h+(f<<2)>>2]|0;l=(d&1<<f|0)==0;j=((e|0)==0)<<31>>31;m=0;n=k;while(1){o=c[g+(f<<7)+(m<<2)>>2]|0;p=(e&1<<m|0)!=0;q=((l&p)<<31>>31)+n|0;if(p){p=(o|0)==(a|0);r=(p<<31>>31)+j+q|0;if(p)s=r;else{p=o;t=r;while(1){r=c[p+4>>2]|0;u=p+8|0;v=c[(r+-4&-4)+u+4>>2]|0;w=r&-4;if(w>>>0<128){x=0;y=(w|0)/4|0}else{z=31-(QEi(w|0)|0)|0;x=z+-6|0;y=w>>>(z+-5|0)^32}z=t+-2+(r&1)+(r<<30>>31)+((w>>>0<12)<<31>>31)+(v<<31>>31)+(v>>>1&1)+(((y|0)!=(m|0)|(x|0)!=(f|0))<<31>>31)|0;p=c[u>>2]|0;if((p|0)==(a|0)){s=z;break}else t=z}}}else s=q+(((o|0)!=(a|0))<<31>>31)|0;m=m+1|0;if((m|0)==32){A=s;break}else n=s}f=f+1|0;if((f|0)==24){B=A;break}else k=A}i=b;return B|0}function _pe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(b|0)!=0?b:350;b=a+3184|0;if(!b){i=e;return}else g=b;while(1){b=g;a=b+4|0;h=c[a>>2]|0;if(h>>>0<4){j=4;break}k=b+8|0;Dn[f&511](k,h&-4,h&1^1,d);g=((c[a>>2]|0)+-4&-4)+k|0;if(!g){j=4;break}}if((j|0)==4){i=e;return}}function $pe(a){a=a|0;var b=0;if(!a)b=0;else b=c[a+-4>>2]&-4;return b|0}function aqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d;f=b+-3196&-4;if((f+-12|0)>>>0>1073741812){c[e>>2]=3208;c[e+4>>2]=1073745020;gl(1064808,e|0)|0;g=0;i=d;return g|0}c[a+8>>2]=a;c[a+12>>2]=a;e=a+16|0;c[e>>2]=0;b=0;do{c[a+(b<<2)+20>>2]=0;h=0;do{c[a+(b<<7)+(h<<2)+116>>2]=a;h=h+1|0}while((h|0)!=32);b=b+1|0}while((b|0)!=24);b=a+3184|0;h=b+4|0;c[h>>2]=f|1;if(f>>>0<128){j=0;k=(f|0)/4|0}else{l=31-(QEi(f|0)|0)|0;j=l+-6|0;k=f>>>(l+-5|0)^32}l=a+(j<<7)+(k<<2)+116|0;f=c[l>>2]|0;m=b+8|0;c[m>>2]=f;c[b+12>>2]=a;c[f+12>>2]=b;c[l>>2]=b;c[e>>2]=c[e>>2]|1<<j;e=a+(j<<2)+20|0;c[e>>2]=c[e>>2]|1<<k;k=((c[h>>2]|0)+-4&-4)+m|0;c[k>>2]=b;c[k+4>>2]=2;g=a;i=d;return g|0}function bqe(a){a=a|0;return}function cqe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;if((d|0)!=0&d>>>0<1073741824){f=d+3&-4;g=f>>>0>12?f:12}else g=0;f=g+b|0;d=f+16|0;if((d|0)!=0&d>>>0<1073741824){d=b+15+f&0-b;h=d>>>0>12?d:12}else h=0;d=gqe(a,b>>>0<5?g:h)|0;if(!d){j=0;k=hqe(a,j,g)|0;i=e;return k|0}h=d+8|0;f=h;l=b+-1|0;m=0-b|0;n=f+l&m;o=n-f|0;if((n|0)!=(h|0)&o>>>0<16){p=16-o|0;q=(n+l+(p>>>0>b>>>0?p:b)&m)-f|0}else q=o;if(!q){j=d;k=hqe(a,j,g)|0;i=e;return k|0}o=d+4|0;m=c[o>>2]&-4;if(m>>>0<(q+16|0)>>>0){j=d;k=hqe(a,j,g)|0;i=e;return k|0}b=f+-8+q|0;p=b+4|0;c[p>>2]=c[p>>2]&3|m-q;c[o>>2]=c[o>>2]&3|q+-4;q=((c[p>>2]|0)+-4&-4)+(b+8)|0;c[q>>2]=b;m=q+4|0;c[m>>2]=c[m>>2]|2;c[p>>2]=c[p>>2]|3;p=c[o>>2]|0;c[(p+-4&-4)+f>>2]=d;f=p&-4;if(f>>>0<128){r=0;s=(f|0)/4|0}else{p=31-(QEi(f|0)|0)|0;r=p+-6|0;s=f>>>(p+-5|0)^32}p=a+(r<<7)+(s<<2)+116|0;f=c[p>>2]|0;c[h>>2]=f;c[d+12>>2]=a;c[f+12>>2]=d;c[p>>2]=d;d=a+16|0;c[d>>2]=c[d>>2]|1<<r;d=a+(r<<2)+20|0;c[d>>2]=c[d>>2]|1<<s;j=b;k=hqe(a,j,g)|0;i=e;return k|0}function dqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;if(!b){i=d;return}e=b+-8|0;f=b+-4|0;g=((c[f>>2]|0)+-4&-4)+b|0;c[g>>2]=e;b=g+4|0;c[b>>2]=c[b>>2]|2;b=c[f>>2]|0;g=b|1;c[f>>2]=g;if(!(b&2)){h=e;j=g}else{g=c[e>>2]|0;e=g+4|0;b=c[e>>2]&-4;if(b>>>0<128){k=0;l=(b|0)/4|0}else{m=31-(QEi(b|0)|0)|0;k=m+-6|0;l=b>>>(m+-5|0)^32}m=c[g+12>>2]|0;b=g+8|0;n=c[b>>2]|0;c[n+12>>2]=m;c[m+8>>2]=n;m=a+(k<<7)+(l<<2)+116|0;if(((c[m>>2]|0)==(g|0)?(c[m>>2]=n,(n|0)==(a|0)):0)?(n=a+(k<<2)+20|0,m=c[n>>2]&~(1<<l),c[n>>2]=m,(m|0)==0):0){m=a+16|0;c[m>>2]=c[m>>2]&~(1<<k)}k=((c[f>>2]|0)+4&-4)+(c[e>>2]|0)|0;c[e>>2]=k;c[(k+-4&-4)+b>>2]=g;h=g;j=k}k=h+8|0;g=h+4|0;b=k;e=(j+-4&-4)+b|0;f=e+4|0;m=c[f>>2]|0;if(!(m&1))o=j;else{j=m&-4;if(j>>>0<128){p=0;q=(j|0)/4|0}else{m=31-(QEi(j|0)|0)|0;p=m+-6|0;q=j>>>(m+-5|0)^32}m=c[e+12>>2]|0;j=c[e+8>>2]|0;c[j+12>>2]=m;c[m+8>>2]=j;m=a+(p<<7)+(q<<2)+116|0;if(((c[m>>2]|0)==(e|0)?(c[m>>2]=j,(j|0)==(a|0)):0)?(j=a+(p<<2)+20|0,m=c[j>>2]&~(1<<q),c[j>>2]=m,(m|0)==0):0){m=a+16|0;c[m>>2]=c[m>>2]&~(1<<p)}p=((c[f>>2]|0)+4&-4)+(c[g>>2]|0)|0;c[g>>2]=p;c[(p+-4&-4)+b>>2]=h;o=p}p=o&-4;if(p>>>0<128){r=0;s=(p|0)/4|0}else{o=31-(QEi(p|0)|0)|0;r=o+-6|0;s=p>>>(o+-5|0)^32}o=a+(r<<7)+(s<<2)+116|0;p=c[o>>2]|0;c[k>>2]=p;c[h+12>>2]=a;c[p+12>>2]=h;c[o>>2]=h;h=a+16|0;c[h>>2]=c[h>>2]|1<<r;h=a+(r<<2)+20|0;c[h>>2]=c[h>>2]|1<<s;i=d;return}function eqe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=(b|0)!=0;if(g&(e|0)==0){dqe(a,b);h=0;i=f;return h|0}if(!g){h=cqe(a,d,e)|0;i=f;return h|0}g=b+-8|0;j=b+-4|0;k=c[j>>2]|0;l=b;m=(k+-4&-4)+l|0;n=k&-4;o=m+4|0;p=c[o>>2]|0;q=p&-4;r=n+4+q|0;if((e|0)!=0&e>>>0<1073741824){s=e+3&-4;t=s>>>0>12?s:12;if(t>>>0>n>>>0){if(!((p&1|0)==0|t>>>0>r>>>0)){u=1;v=t;w=8}}else{u=0;v=t;w=8}}else{u=0;v=0;w=8}if((w|0)==8?(d+-1+l&0-d|0)==(b|0):0){if(u){if(!(p&1))x=k;else{if(q>>>0<128){y=0;z=(q|0)/4|0}else{k=31-(QEi(q|0)|0)|0;y=k+-6|0;z=q>>>(k+-5|0)^32}k=c[m+12>>2]|0;q=c[m+8>>2]|0;c[q+12>>2]=k;c[k+8>>2]=q;k=a+(y<<7)+(z<<2)+116|0;if(((c[k>>2]|0)==(m|0)?(c[k>>2]=q,(q|0)==(a|0)):0)?(q=a+(y<<2)+20|0,k=c[q>>2]&~(1<<z),c[q>>2]=k,(k|0)==0):0){k=a+16|0;c[k>>2]=c[k>>2]&~(1<<y)}y=((c[o>>2]|0)+4&-4)+(c[j>>2]|0)|0;c[j>>2]=y;c[(y+-4&-4)+l>>2]=g;x=y}y=(x+-4&-4)+l+4|0;c[y>>2]=c[y>>2]&-3;c[j>>2]=c[j>>2]&-2}iqe(a,g,v);h=b;i=f;return h|0}v=cqe(a,d,e)|0;if(!v){h=0;i=f;return h|0}YEi(v|0,b|0,(n>>>0<e>>>0?n:e)|0)|0;dqe(a,b);h=v;i=f;return h|0}function fqe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;c[f>>2]=a;c[f+4>>2]=(d|0)!=0?2414536:1064896;c[f+8>>2]=b;c[f+12>>2]=a+-8;gl(1064872,f|0)|0;i=e;return}function gqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;if(!b){e=0;i=d;return e|0}if(b>>>0>31){f=b+-1+(1<<26-(QEi(b|0)|0))|0;if(f>>>0<128){g=f;h=4}else{j=31-(QEi(f|0)|0)|0;k=j+-6|0;l=f>>>(j+-5|0)^32}}else{g=b;h=4}if((h|0)==4){k=0;l=(g|0)/4|0}g=c[a+(k<<2)+20>>2]&-1<<l;do if(!g){l=c[a+16>>2]&-1<<k+1;if(!l){e=0;i=d;return e|0}else{h=$Ei(l|0)|0;m=h;n=c[a+(h<<2)+20>>2]|0;break}}else{m=k;n=g}while(0);g=$Ei(n|0)|0;k=(n|0)==0?-1:g;g=a+(m<<7)+(k<<2)+116|0;n=c[g>>2]|0;if(!n){e=0;i=d;return e|0}h=c[n+12>>2]|0;l=c[n+8>>2]|0;c[l+12>>2]=h;c[h+8>>2]=l;if((c[g>>2]|0)!=(n|0)){e=n;i=d;return e|0}c[g>>2]=l;if((l|0)!=(a|0)){e=n;i=d;return e|0}l=a+(m<<2)+20|0;g=c[l>>2]&~(1<<k);c[l>>2]=g;if(g){e=n;i=d;return e|0}g=a+16|0;c[g>>2]=c[g>>2]&~(1<<m);e=n;i=d;return e|0}function hqe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;if(!b){f=0;i=e;return f|0}g=b+4|0;h=c[g>>2]|0;j=h&-4;k=b+8|0;if(j>>>0<(d+16|0)>>>0){l=k;m=h}else{h=k;n=d+-4+h|0;o=n+4|0;c[o>>2]=c[o>>2]&3|-4-d+j;c[g>>2]=c[g>>2]&3|d;d=n+8|0;j=((c[o>>2]|0)+-4&-4)+d|0;c[j>>2]=n;p=j+4|0;c[p>>2]=c[p>>2]|2;p=c[o>>2]|0;c[o>>2]=p|1;c[((c[g>>2]|0)+-4&-4)+h>>2]=b;c[o>>2]=p|3;o=p&-4;if(o>>>0<128){q=0;r=(o|0)/4|0}else{p=31-(QEi(o|0)|0)|0;q=p+-6|0;r=o>>>(p+-5|0)^32}p=a+(q<<7)+(r<<2)+116|0;o=c[p>>2]|0;c[d>>2]=o;c[n+12>>2]=a;c[o+12>>2]=n;c[p>>2]=n;n=a+16|0;c[n>>2]=c[n>>2]|1<<q;n=a+(q<<2)+20|0;c[n>>2]=c[n>>2]|1<<r;l=h;m=c[g>>2]|0}h=(m+-4&-4)+l+4|0;c[h>>2]=c[h>>2]&-3;c[g>>2]=c[g>>2]&-2;f=k;i=e;return f|0}function iqe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=b+4|0;g=c[f>>2]&-4;if(g>>>0<(d+16|0)>>>0){i=e;return}h=d+-4+(b+8)|0;b=h+4|0;c[b>>2]=c[b>>2]&3|-4-d+g;c[f>>2]=c[f>>2]&3|d;d=h+8|0;f=d;g=((c[b>>2]|0)+-4&-4)+f|0;c[g>>2]=h;j=g+4|0;c[j>>2]=c[j>>2]|2;j=c[b>>2]&-4|1;c[b>>2]=j;g=(j+-4&-4)+f|0;k=g+4|0;l=c[k>>2]|0;if(!(l&1))m=j;else{j=l&-4;if(j>>>0<128){n=0;o=(j|0)/4|0}else{l=31-(QEi(j|0)|0)|0;n=l+-6|0;o=j>>>(l+-5|0)^32}l=c[g+12>>2]|0;j=c[g+8>>2]|0;c[j+12>>2]=l;c[l+8>>2]=j;l=a+(n<<7)+(o<<2)+116|0;if(((c[l>>2]|0)==(g|0)?(c[l>>2]=j,(j|0)==(a|0)):0)?(j=a+(n<<2)+20|0,l=c[j>>2]&~(1<<o),c[j>>2]=l,(l|0)==0):0){l=a+16|0;c[l>>2]=c[l>>2]&~(1<<n)}n=((c[k>>2]|0)+4&-4)+(c[b>>2]|0)|0;c[b>>2]=n;c[(n+-4&-4)+f>>2]=h;m=n}n=m&-4;if(n>>>0<128){p=0;q=(n|0)/4|0}else{m=31-(QEi(n|0)|0)|0;p=m+-6|0;q=n>>>(m+-5|0)^32}m=a+(p<<7)+(q<<2)+116|0;n=c[m>>2]|0;c[d>>2]=n;c[h+12>>2]=a;c[n+12>>2]=h;c[m>>2]=h;h=a+16|0;c[h>>2]=c[h>>2]|1<<p;h=a+(p<<2)+20|0;c[h>>2]=c[h>>2]|1<<q;i=e;return}function jqe(a){a=a|0;var b=0,c=0;b=i;c=zDi(a)|0;i=b;return c|0}function kqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;PEi(1064952,0,520)|0;e=1064904|0;f=e+44|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[266238]=3570;c[266239]=3058;c[266240]=1868;c[266241]=3059;c[266242]=3060;c[266243]=3061;c[266244]=3062;c[266245]=3063;c[266246]=351;c[266247]=352;c[266248]=353;c[266249]=3640;c[266250]=3571;c[266251]=1;c[266252]=1;c[266253]=3572;c[266254]=354;c[266255]=3573;c[266256]=26;c[266257]=9;c[266258]=27;c[266259]=69;c[266260]=3641;c[266261]=3574;c[266262]=3064;c[266263]=3065;c[266264]=3575;c[266265]=3066;c[266266]=3576;c[266267]=3067;c[266268]=3577;c[266269]=3578;c[266270]=3579;c[266271]=3580;c[266272]=1869;c[266273]=355;c[266274]=3581;c[266275]=3582;c[266276]=243;c[266277]=244;c[266278]=356;c[266279]=101;c[266280]=3583;c[266281]=3068;c[266282]=3584;c[266283]=3069;c[266284]=3070;c[266285]=3071;c[266286]=63;c[266287]=64;c[266288]=2845;c[266289]=70;c[266290]=357;c[266291]=3072;c[266292]=1870;c[266293]=358;c[266294]=1871;c[266295]=359;c[266296]=3642;c[266297]=1872;c[266298]=2846;c[266299]=1873;c[266300]=1874;c[266301]=1875;c[266302]=3585;c[266303]=3073;c[266304]=1;c[266305]=65;c[266306]=360;c[266307]=361;c[266308]=362;c[266309]=1876;c[266310]=363;c[266311]=3586;c[266312]=1877;c[266313]=364;c[266314]=10;c[266315]=1878;c[266316]=11;c[266317]=1879;c[266318]=3074;c[266319]=1880;c[266320]=1881;c[266321]=1882;c[266322]=1883;c[266323]=1884;c[266324]=1885;c[266325]=1886;c[266326]=365;c[266327]=366;c[266328]=3587;c[266329]=7;c[266330]=121;c[266331]=367;Uue(a,b);if((a|0)==8){fwe(b,1064952,1064904);Vue(a,b);lqe(1064952);i=d;return}else if((a|0)==11){nwe(b,1064952,1064904);Vue(a,b);lqe(1064952);i=d;return}else{Vue(a,b);lqe(1064952);i=d;return}}function lqe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[266368]=0;c[266369]=0;c[266370]=0;c[266371]=0;c[266372]=0;d=c[155300]|0;c[266376]=d;e=d*24|0;f=ADi(e)|0;c[266374]=f;PEi(f|0,0,e|0)|0;e=ADi(d)|0;c[266378]=e;PEi(e|0,0,d|0)|0;d=a+12|0;e=c[d>>2]|0;if(e){c[266380]=e;c[d>>2]=3075}d=a+368|0;e=c[d>>2]|0;if(e){c[266382]=e;c[d>>2]=122}d=a+96|0;e=c[d>>2]|0;if(e){c[266384]=e;c[d>>2]=3076}d=a+436|0;e=c[d>>2]|0;if(e){c[266386]=e;c[d>>2]=3588}d=a+132|0;e=c[d>>2]|0;if(e){c[266388]=e;c[d>>2]=3589}d=a+148|0;a=c[d>>2]|0;if(!a){i=b;return}c[266390]=a;c[d>>2]=3590;i=b;return}function mqe(){var a=0,b=0;a=i;c[266368]=0;c[266369]=0;c[266370]=0;c[266371]=0;c[266372]=0;b=c[266374]|0;if(b)PEi(b|0,0,(c[266376]|0)*24|0)|0;b=c[266378]|0;if(!b){i=a;return}PEi(b|0,0,c[266376]|0)|0;i=a;return}function nqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==35982)e=3;else if((a|0)==36663)e=4;else if((a|0)==35345)e=2;else if((a|0)==34963)e=1;else e=0;f=1065472+(e<<2)|0;if((b|0)!=0?(c[f>>2]|0)==(b|0):0){i=d;return}c[f>>2]=b;In[c[1065520>>2]&4095](a,b);b=(c[266694]|0)+192|0;c[b>>2]=c[b>>2]|7;i=d;return}function oqe(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+32|0;k=j;c[k>>2]=h;c[k+4>>2]=g;c[k+8>>2]=c[266368];c[k+12>>2]=d;c[k+16>>2]=e;a[k+20>>0]=f;l=(c[266374]|0)+(b*24|0)|0;m=h;n=0;while(1){o=n+1|0;if((m|0)!=(c[l+(n<<2)>>2]|0))break;if((o|0)>=6){p=6;break}m=c[k+(o<<2)>>2]|0;n=o}if((p|0)==6){i=j;return};c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[l+16>>2]=c[k+16>>2];c[l+20>>2]=c[k+20>>2];rn[c[1065528>>2]&127](b,d,e,f,g,h);i=j;return}function pqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a|0)<=0){e=c[266384]|0;In[e&4095](a,b);i=d;return}f=c[266374]|0;g=c[266376]|0;h=0;do{if((g|0)>0){j=b+(h<<2)|0;k=0;do{if((c[f+(k*24|0)+8>>2]|0)==(c[j>>2]|0)){l=f+(k*24|0)|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0}k=k+1|0}while((k|0)!=(g|0))}h=h+1|0}while((h|0)!=(a|0));e=c[266384]|0;In[e&4095](a,b);i=d;return}function qqe(a){a=a|0;var b=0;b=i;c[266368]=0;c[266369]=0;c[266370]=0;c[266371]=0;c[266372]=0;PEi(c[266374]|0,0,(c[266376]|0)*24|0)|0;ko[c[1065544>>2]&4095](a);i=b;return}function rqe(b){b=b|0;var d=0;d=i;if(!(a[(c[266378]|0)+b>>0]|0)){i=d;return}ko[c[1065552>>2]&4095](b);a[(c[266378]|0)+b>>0]=0;i=d;return}function sqe(b){b=b|0;var d=0;d=i;if(a[(c[266378]|0)+b>>0]|0){i=d;return}ko[c[1065560>>2]&4095](b);a[(c[266378]|0)+b>>0]=1;i=d;return}function tqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;if((a+3|0)>=(c[c[267510]>>2]|0)){g=0;i=d;return g|0}c[f>>2]=c[153080];c[e+0>>2]=c[f+0>>2];f=bOb(8,e,0,16,3653512,14)|0;c[f>>2]=a;c[f+4>>2]=b;g=f;i=d;return g|0}function uqe(a){a=a|0;var b=0,d=0;b=i;d=a+0|0;a=d+88|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(a|0));i=b;return}function vqe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a+24|0;e=d+64|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=a+16|0;e=c[d>>2]|0;f=a+12|0;g=c[f>>2]|0;h=e-g|0;j=(h|0)/12|0;if((h|0)>0){h=g;k=0;while(1){l=c[h+(k*12|0)>>2]|0;if(l)BCi(l);l=h+(k*12|0)+4|0;if(c[l>>2]|0)In[c[1064952+96>>2]&4095](1,l);k=k+1|0;l=c[f>>2]|0;if((k|0)>=(j|0)){m=l;break}else h=l}n=m;o=c[d>>2]|0}else{n=g;o=e}if((o|0)!=(n|0))c[d>>2]=o+(~(((o+-12-n|0)>>>0)/12|0)*12|0);n=c[a>>2]|0;o=a+4|0;a=c[o>>2]|0;if((a|0)==(n|0)){i=b;return}c[o>>2]=a+(~((a+-4-n|0)>>>2)<<2);i=b;return}function wqe(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g+12|0;j=g;k=f<<16|e;c[h>>2]=k;e=d+12|0;l=d+16|0;m=(c[l>>2]|0)-(c[e>>2]|0)|0;n=(m|0)/12|0;a:do if((m|0)>0){o=c[d>>2]|0;p=0;while(1){if((c[o+(p<<2)>>2]|0)==(k|0))break;p=p+1|0;if((p|0)>=(n|0))break a}i=g;return}while(0);n=zCi((f|0)>-1?f:-1)|0;c[j>>2]=n;m=j+4|0;c[m>>2]=0;b[j+8>>1]=-1;a[j+10>>0]=1;PEi(n|0,0,f|0)|0;In[c[1064952+172>>2]&4095](1,m);In[c[1064952+12>>2]&4095](35345,c[m>>2]|0);Dn[c[1064952+36>>2]&511](35345,f,0,35048);f=c[l>>2]|0;if((f|0)==(c[d+20>>2]|0))Bqe(e,j);else{if(!f)q=0;else{c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];q=c[l>>2]|0}c[l>>2]=q+12}q=d+4|0;l=c[q>>2]|0;if((l|0)==(c[d+8>>2]|0)){HGd(d,h);i=g;return}if(l)c[l>>2]=k;c[q>>2]=l+4;i=g;return}function xqe(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=f<<16|d;d=c[a+12>>2]|0;f=(c[a+16>>2]|0)-d|0;j=(f|0)/12|0;if((f|0)<=0){k=-1;i=g;return k|0}f=c[a>>2]|0;a=0;while(1){if((c[f+(a<<2)>>2]|0)==(h|0)){l=a;break}a=a+1|0;if((a|0)>=(j|0)){k=-1;m=7;break}}if((m|0)==7){i=g;return k|0}if((e|0)<=-1){k=l;i=g;return k|0}b[d+(l*12|0)+8>>1]=e;k=l;i=g;return k|0}function yqe(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+12>>2]|0;f=(c[a+16>>2]|0)-e|0;a=(f|0)/12|0;if((f|0)>0)g=0;else{i=d;return}do{b[e+(g*12|0)+8>>1]=-1;g=g+1|0}while((g|0)<(a|0));i=d;return}function zqe(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=c[b+12>>2]|0;b=(c[j+(d*12|0)>>2]|0)+e|0;if((g|0)==4){e=c[f>>2]|0;if((c[b>>2]|0)==(e|0)){i=h;return}c[b>>2]=e;a[j+(d*12|0)+10>>0]=1;i=h;return}else{if(!(FEi(b,f,g)|0)){i=h;return}YEi(b|0,f|0,g|0)|0;a[j+(d*12|0)+10>>0]=1;i=h;return}}function Aqe(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=d+12|0;g=c[f>>2]|0;h=(c[d+16>>2]|0)-g|0;j=(h|0)/12|0;if((h|0)<=0){i=e;return}h=g;g=0;while(1){k=h+(g*12|0)+10|0;if(a[k>>0]|0){In[c[1064952+12>>2]&4095](35345,c[h+(g*12|0)+4>>2]|0);Dn[c[1064952+36>>2]&511](35345,(c[(c[d>>2]|0)+(g<<2)>>2]|0)>>>16,c[h+(g*12|0)>>2]|0,35048);In[c[1064952+12>>2]&4095](35345,0)}l=b[h+(g*12|0)+8>>1]|0;m=l<<16>>16;if(l<<16>>16>-1?(l=c[h+(g*12|0)+4>>2]|0,(c[d+(m<<2)+24>>2]|0)!=(l|0)):0)co[c[1064952+456>>2]&2047](35345,m,l);a[k>>0]=0;k=g+1|0;if((k|0)>=(j|0))break;h=c[f>>2]|0;g=k}i=e;return}function Bqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=(((c[e>>2]|0)-f|0)/12|0)+1|0;if(g>>>0>357913941)vxi(a);h=a+8|0;j=f;k=((c[h>>2]|0)-j|0)/12|0;if(k>>>0<178956970){l=k<<1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=(l|0)/12|0;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=357913941;r=(l|0)/12|0;s=l;t=6}if((t|0)==6){m=q;n=xCi(q*12|0)|0;o=r;p=s}s=n+(o*12|0)|0;if(s){c[s+0>>2]=c[b+0>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2]}b=n+((((p|0)/-12|0)+o|0)*12|0)|0;YEi(b|0,f|0,p|0)|0;c[a>>2]=b;c[e>>2]=n+((o+1|0)*12|0);c[h>>2]=n+(m*12|0);if(!f){i=d;return}ACi(f);i=d;return}function Cqe(d){d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+32|0;h=e;Dnc(d);c[d>>2]=1065576;j=d+6068|0;uqe(d+6264|0);c[d+8032>>2]=0;c[d+8040>>2]=0;c[d+8044>>2]=0;c[d+8036>>2]=60;c[d+8200>>2]=0;c[d+8204>>2]=0;c[d+8196>>2]=d+8200;c[d+8212>>2]=0;c[d+8216>>2]=0;c[d+8208>>2]=d+8212;c[d+8224>>2]=0;c[d+8228>>2]=0;c[d+8220>>2]=d+8224;c[d+8236>>2]=0;c[d+8240>>2]=0;c[d+8232>>2]=d+8236;k=d+8252|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;c[d+8308>>2]=0;c[d+8312>>2]=0;c[d+8304>>2]=d+8308;c[d+8300>>2]=1066712;c[266694]=j;gue(d+5996|0,d+6e3|0);Enc(d);b[h>>1]=0;k=c[268650]&65535;b[h+2>>1]=k;Sse(f,d+8196|0,h);c[d+8244>>2]=(c[f>>2]|0)+16;l=a[(c[267510]|0)+85>>0]|0;m=l^1;c[h>>2]=l<<24>>24==0?0:15;a[h+4>>0]=m;a[h+5>>0]=l;a[h+6>>0]=m;a[h+7>>0]=l;c[h+8>>2]=0;n=c[1074640+((m&255)<<2)>>2]&65535;b[h+12>>1]=n;m=c[1074640+((l&255)<<2)>>2]&65535;b[h+14>>1]=m;b[h+16>>1]=n;b[h+18>>1]=m;m=c[268672]&65535;b[h+20>>1]=m;b[h+22>>1]=m;b[h+24>>1]=k;Tse(f,d+8220|0,h);c[d+8248>>2]=(c[f>>2]|0)+16;Kte(j);ko[c[(c[d>>2]|0)+8>>2]&4095](d);a[d+5834>>0]=1;a[d+5984>>0]=1;a[d+5985>>0]=0;g[d+5964>>2]=ea(0.0);g[d+5960>>2]=ea(0.0);i=e;return}function Dqe(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1065576;zve();Onc(a);Eqe();vqe(a+6264|0);Hnc(a);rue();d=a+8300|0;urc(d);jpe();c[d>>2]=1066688;wrc(a+8304|0,c[a+8308>>2]|0);Use(a+6068|0);Ooc(a);i=b;return}function Eqe(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[266636]|0;if((e|0)!=(1066548|0)){f=e;while(1){ko[c[1064952+112>>2]&4095](c[f+60>>2]|0);e=c[f+4>>2]|0;if(!e){g=f;while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){j=h;break}else g=h}}else{g=e;while(1){h=c[g>>2]|0;if(!h){j=g;break}else g=h}}if((j|0)==(1066548|0))break;else f=j}}j=c[266640]|0;if((j|0)!=(1066564|0)){f=j;while(1){ko[c[1064952+112>>2]&4095](c[f+60>>2]|0);j=c[f+4>>2]|0;if(!j){g=f;while(1){e=c[g+8>>2]|0;if((c[e>>2]|0)==(g|0)){k=e;break}else g=e}}else{g=j;while(1){e=c[g>>2]|0;if(!e){k=g;break}else g=e}}if((k|0)==(1066564|0))break;else f=k}}k=c[266632]|0;if((k|0)!=(1066532|0)){f=k;while(1){k=f+60|0;g=c[k>>2]|0;j=c[153080]|0;if(g)eue(g);c[d>>2]=j;c[b+0>>2]=c[d+0>>2];eOb(g,b);c[k>>2]=0;k=c[f+4>>2]|0;if(!k){g=f;while(1){j=c[g+8>>2]|0;if((c[j>>2]|0)==(g|0)){l=j;break}else g=j}}else{g=k;while(1){j=c[g>>2]|0;if(!j){l=g;break}else g=j}}if((l|0)==(1066532|0))break;else f=l}}Vse(1066544,c[266637]|0);c[266638]=0;c[266636]=1066548;c[266637]=0;Wse(1066560,c[266641]|0);c[266642]=0;c[266640]=1066564;c[266641]=0;Xse(1066528,c[266633]|0);c[266634]=0;c[266632]=1066532;c[266633]=0;i=a;return}function Fqe(a){a=a|0;var b=0;b=i;Dqe(a);ACi(a);i=b;return}function Gqe(a){a=a|0;a=i;kue();i=a;return}function Hqe(a){a=a|0;var b=0;b=i;ko[c[(c[a>>2]|0)+8>>2]&4095](a);i=b;return}function Iqe(b){b=b|0;var d=0,e=0,f=0,h=0;d=i;Gnc(b);c[b+6260>>2]=7;Lte(b+6068|0);e=c[266280]|0;if((a[b+8297>>0]|0)==(a[b+5973>>0]|0))ko[e&4095](2304);else ko[e&4095](2305);mqe();jue();g[b+2596>>2]=ea(1.0);g[b+2600>>2]=ea(1.0);g[b+2604>>2]=ea(1.0);g[b+2608>>2]=ea(1.0);g[b+2612>>2]=ea(1.0);g[b+2616>>2]=ea(1.0);g[b+2620>>2]=ea(1.0);g[b+2624>>2]=ea(1.0);g[b+2628>>2]=ea(1.0);g[b+2632>>2]=ea(1.0);g[b+2636>>2]=ea(1.0);g[b+2640>>2]=ea(1.0);g[b+2644>>2]=ea(1.0);g[b+2648>>2]=ea(1.0);g[b+2652>>2]=ea(1.0);g[b+2656>>2]=ea(1.0);g[b+2660>>2]=ea(1.0);g[b+2664>>2]=ea(1.0);g[b+2668>>2]=ea(1.0);g[b+2672>>2]=ea(1.0);e=b+2452|0;f=b+2676|0;h=f+48|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));g[e>>2]=ea(1.0);g[b+2456>>2]=ea(1.0);g[b+2460>>2]=ea(1.0);g[b+2464>>2]=ea(1.0);e=b+2468|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+2532>>2]=ea(1.0);g[b+2536>>2]=ea(1.0);g[b+2540>>2]=ea(0.0);g[b+2544>>2]=ea(0.0);e=b+2484|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+2548>>2]=ea(1.0);g[b+2552>>2]=ea(1.0);g[b+2556>>2]=ea(0.0);g[b+2560>>2]=ea(0.0);e=b+2500|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+2564>>2]=ea(1.0);g[b+2568>>2]=ea(1.0);g[b+2572>>2]=ea(0.0);g[b+2576>>2]=ea(0.0);e=b+2516|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;g[b+2580>>2]=ea(1.0);g[b+2584>>2]=ea(1.0);g[b+2588>>2]=ea(0.0);g[b+2592>>2]=ea(0.0);i=d;return}function Jqe(b){b=b|0;var d=0;d=i;a[b+5832>>0]=1;a[1067108]=2;a[(c[266764]|0)+20>>0]=2;a[1067124]=2;a[(c[266772]|0)+20>>0]=2;lue(1067056);if(!(a[621169]|0)){i=d;return}kue();i=d;return}function Kqe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+8|0;f=d;if((c[266736]|0)==1067256?(g=f,c[g>>2]=0,c[g+4>>2]=0,(a[621270]|0)!=0):0){g=e+0|0;h=g+40|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=(c[266782]|0)==0;h=c[266737]|0;a:do if((h|0)>0)if(g){j=1;k=1;l=0;while(1){if(j)m=l;else{c[e+(l<<2)>>2]=6144;m=l+1|0}if((k|0)==(h|0)){n=m;break a}j=(a[f+k>>0]|0)==0;k=k+1|0;l=m}}else{l=1;k=0;j=0;while(1){if(l)o=j;else{c[e+(j<<2)>>2]=k+36064;o=j+1|0}p=k+1|0;if((p|0)==(h|0)){n=o;break a}l=(a[f+p>>0]|0)==0;k=p;j=o}}else n=0;while(0);c[e+(n<<2)>>2]=g?6145:36096;o=n+2|0;c[e+(n+1<<2)>>2]=g?6146:36128;if(o)co[c[1064952+508>>2]&2047](36160,o,e)}Xte($te()|0);if(!(a[621284]|0)){q=b+5832|0;a[q>>0]=0;i=d;return}a[1066672]=0;q=b+5832|0;a[q>>0]=0;i=d;return}function Lqe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e;if(!(a[621270]|0)){i=e;return}g=f+0|0;h=g+40|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=(c[266782]|0)==0;h=c[266737]|0;if((h|0)>0)if(g){j=0;k=0;while(1){if(!(a[b+j>>0]|0))l=k;else{c[f+(k<<2)>>2]=6144;l=k+1|0}j=j+1|0;if((j|0)==(h|0)){m=l;break}else k=l}}else{l=0;k=0;while(1){if(!(a[b+l>>0]|0))n=k;else{c[f+(k<<2)>>2]=l+36064;n=k+1|0}l=l+1|0;if((l|0)==(h|0)){m=n;break}else k=n}}else m=0;if(d){c[f+(m<<2)>>2]=g?6145:36096;c[f+(m+1<<2)>>2]=g?6146:36128;o=m+2|0}else o=m;if(!o){i=e;return}co[c[1064952+508>>2]&2047](36160,o,f);i=e;return}function Mqe(e,f){e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+48|0;h=g+32|0;j=g;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];b[j+12>>1]=c[1074640+(d[f+4>>0]<<2)>>2];b[j+14>>1]=c[1074640+(d[f+5>>0]<<2)>>2];b[j+16>>1]=c[1074640+(d[f+6>>0]<<2)>>2];b[j+18>>1]=c[1074640+(d[f+7>>0]<<2)>>2];b[j+20>>1]=c[1074688+(d[f+8>>0]<<2)>>2];b[j+22>>1]=c[1074688+(d[f+9>>0]<<2)>>2];b[j+24>>1]=c[1074600+(a[f+10>>0]<<2)>>2];Tse(h,e+8220|0,j);i=g;return (c[h>>2]|0)+16|0}function Nqe(e,f){e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+48|0;h=g+32|0;j=g;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];b[j+12>>1]=c[1074640+(d[f+4>>0]<<2)>>2];b[j+14>>1]=c[1074640+(d[f+5>>0]<<2)>>2];b[j+16>>1]=c[1074640+(d[f+6>>0]<<2)>>2];b[j+18>>1]=c[1074640+(d[f+7>>0]<<2)>>2];b[j+20>>1]=c[1074688+(d[f+8>>0]<<2)>>2];b[j+22>>1]=c[1074688+(d[f+9>>0]<<2)>>2];b[j+24>>1]=c[1074600+(a[f+10>>0]<<2)>>2];Tse(h,e+2152|0,j);i=g;return (c[h>>2]|0)+16|0}function Oqe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f;j=d[e>>0]|d[e+1>>0]<<8;b[h>>1]=j;b[h+2>>1]=c[1074600+(((j&65535)>>>8&65535)<<24>>24<<2)>>2];Sse(g,a+8196|0,h);i=f;return (c[g>>2]|0)+16|0}function Pqe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+48|0;g=f+32|0;h=f;c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];b[h+12>>1]=c[1074600+((d[e+4>>0]|0)<<2)>>2];b[h+14>>1]=c[1074776+((d[e+5>>0]|0)<<2)>>2];b[h+16>>1]=c[1074776+((d[e+6>>0]|0)<<2)>>2];b[h+18>>1]=c[1074776+((d[e+7>>0]|0)<<2)>>2];b[h+20>>1]=c[1074600+((d[e+8>>0]|0)<<2)>>2];b[h+22>>1]=c[1074776+((d[e+9>>0]|0)<<2)>>2];b[h+24>>1]=c[1074776+((d[e+10>>0]|0)<<2)>>2];b[h+26>>1]=c[1074776+((d[e+11>>0]|0)<<2)>>2];Yse(g,a+8208|0,h);i=f;return (c[g>>2]|0)+16|0}function Qqe(a,e){a=a|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+48|0;g=f+32|0;h=f;c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];b[h+12>>1]=c[1074600+((d[e+4>>0]|0)<<2)>>2];b[h+14>>1]=c[1074776+((d[e+5>>0]|0)<<2)>>2];b[h+16>>1]=c[1074776+((d[e+6>>0]|0)<<2)>>2];b[h+18>>1]=c[1074776+((d[e+7>>0]|0)<<2)>>2];b[h+20>>1]=c[1074600+((d[e+8>>0]|0)<<2)>>2];b[h+22>>1]=c[1074776+((d[e+9>>0]|0)<<2)>>2];b[h+24>>1]=c[1074776+((d[e+10>>0]|0)<<2)>>2];b[h+26>>1]=c[1074776+((d[e+11>>0]|0)<<2)>>2];Yse(g,a+2140|0,h);i=f;return (c[g>>2]|0)+16|0}function Rqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];Zse(e,a+8232|0,f);i=d;return (c[e>>2]|0)+16|0}function Sqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];Zse(e,a+2164|0,f);i=d;return (c[e>>2]|0)+16|0}function Tqe(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,g=0,h=0,j=0;f=i;if(!(c[(c[266746]|0)+16>>2]&64))if(!(c[d>>2]|0)){g=a[d+10>>0]|0;h=c[b+8248>>2]|0;if(!(g<<24>>24))j=h;else j=Vqe(b+6068|0,h,g<<24>>24)|0}else j=d;else j=Uqe(b+6068|0,d,0)|0;Wqe(b+6068|0,j,e);i=f;return}function Uqe(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g;if(!e)k=c[d+2120>>2]|0;else k=e;e=c[k+4>>2]|0;l=(e&65535)>>>8;m=e>>>16;n=e>>>24;o=c[k+8>>2]|0;p=(o&65535)>>>8;q=o>>>16;if((c[k>>2]|0)==(f|0)){r=k;i=g;return r|0}c[j>>2]=f;a[j+4>>0]=e;a[j+5>>0]=l;a[j+6>>0]=m;a[j+7>>0]=n;a[j+8>>0]=o;a[j+9>>0]=p;a[j+10>>0]=q;a[j+11>>0]=o>>>24;b[j+12>>1]=c[1074640+((e&255)<<2)>>2];b[j+14>>1]=c[1074640+((l&65535)<<2)>>2];b[j+16>>1]=c[1074640+((m&255)<<2)>>2];b[j+18>>1]=c[1074640+(n<<2)>>2];b[j+20>>1]=c[1074688+((o&255)<<2)>>2];b[j+22>>1]=c[1074688+((p&65535)<<2)>>2];b[j+24>>1]=c[1074600+(q<<24>>24<<2)>>2];Tse(h,d+2152|0,j);r=(c[h>>2]|0)+16|0;i=g;return r|0}function Vqe(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;h=g+32|0;j=g;if(!e)k=c[d+2120>>2]|0;else k=e;e=c[k+4>>2]|0;l=(e&65535)>>>8;m=e>>>16;n=e>>>24;o=c[k+8>>2]|0;p=(o&65535)>>>8;if((o<<8>>24|0)==(f|0)){q=k;i=g;return q|0}c[j>>2]=c[k>>2];a[j+4>>0]=e;a[j+5>>0]=l;a[j+6>>0]=m;a[j+7>>0]=n;a[j+8>>0]=o;a[j+9>>0]=p;a[j+10>>0]=f;a[j+11>>0]=o>>>24;b[j+12>>1]=c[1074640+((e&255)<<2)>>2];b[j+14>>1]=c[1074640+((l&65535)<<2)>>2];b[j+16>>1]=c[1074640+((m&255)<<2)>>2];b[j+18>>1]=c[1074640+(n<<2)>>2];b[j+20>>1]=c[1074688+((o&255)<<2)>>2];b[j+22>>1]=c[1074688+((p&65535)<<2)>>2];b[j+24>>1]=c[1074600+(f<<24>>24<<2)>>2];Tse(h,d+2152|0,j);q=(c[h>>2]|0)+16|0;i=g;return q|0}function Wqe(d,f,h){d=d|0;f=f|0;h=ea(h);var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;if((a[(c[267510]|0)+57>>0]|0)!=0?!((a[f+10>>0]|0)!=5|!(+h<=.01)):0)k=Vqe(d,f,0)|0;else k=f;f=d+2120|0;l=c[f>>2]|0;do if((l|0)==(k|0))if(ea(g[d+2216>>2])==h){i=j;return}else{c[f>>2]=k;break}else{c[f>>2]=k;m=c[k>>2]|0;if((c[l>>2]|0)!=(m|0))Dn[c[1064952+64>>2]&511](m>>>3&1,m>>>2&1,m>>>1&1,m&1);m=b[l+12>>1]|0;if((m<<16>>16==1?(b[l+14>>1]|0)==0:0)?(b[l+16>>1]|0)==1:0)n=(b[l+18>>1]|0)==0;else n=0;o=k+12|0;p=b[o>>1]|0;if(((p<<16>>16==1?(b[k+14>>1]|0)==0:0)?(b[k+16>>1]|0)==1:0)?(b[k+18>>1]|0)==0:0){if(n)break;ko[c[1064952+128>>2]&4095](3042);break}if(!n)if(m<<16>>16==p<<16>>16){if(!(((b[l+14>>1]|0)==(b[k+14>>1]|0)?(b[l+16>>1]|0)==(b[k+16>>1]|0):0)?(b[l+18>>1]|0)==(b[k+18>>1]|0):0)){q=m;r=25}}else{q=p;r=25}else{ko[c[1064952+144>>2]&4095](3042);q=b[o>>1]|0;r=25}if((r|0)==25)Dn[c[1064952+32>>2]&511](q&65535,e[k+14>>1]|0,e[k+16>>1]|0,e[k+18>>1]|0);if((!n?(b[l+20>>1]|0)==(b[k+20>>1]|0):0)?(b[l+22>>1]|0)==(b[k+22>>1]|0):0)break;o=b[k+20>>1]|0;if(!(a[621052]|0)){if((o+32761<<16>>16&65535)<2)break;p=b[k+22>>1]|0;if((p+32761<<16>>16&65535)>1)s=p;else break}else s=b[k+22>>1]|0;In[c[1064952+28>>2]&4095](o&65535,s&65535)}while(0);s=a[k+10>>0]|0;k=s<<24>>24;do if(a[(c[267510]|0)+87>>0]|0){if(s<<24>>24==(a[l+10>>0]|0)?!(ea(g[d+2216>>2])!=h):0)break;if(!(s<<24>>24)){ko[c[1064952+128>>2]&4095](3008);break}else{Fn[c[1064904+24>>2]&255](c[1074600+(k<<2)>>2]|0,h);ko[c[1064952+144>>2]&4095](3008);break}}while(0);g[d+2216>>2]=h;i=j;return}function Xqe(b,d){b=b|0;d=d|0;var f=0,g=0,h=0;f=i;if(!(c[(c[266754]|0)+16>>2]&64))g=d;else g=c[b+8244>>2]|0;d=b+8180|0;b=c[d>>2]|0;if((b|0)==(g|0)){i=f;return}c[d>>2]=g;d=a[g+1>>0]|0;h=a[b+1>>0]|0;do if(h<<24>>24!=d<<24>>24){if(!(d<<24>>24)){ko[c[1064952+128>>2]&4095](2929);break}if(!(h<<24>>24))ko[c[1064952+144>>2]&4095](2929);ko[c[1064952+120>>2]&4095](e[g+2>>1]|0)}while(0);h=a[g>>0]|0;if(h<<24>>24==(a[b>>0]|0)){i=f;return}ko[c[1064952+124>>2]&4095](h);i=f;return}function Yqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im,j=0,k=Im,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+16|0;f=d;h=ea(g[a+5960>>2]);j=h!=ea(0.0);k=ea(g[a+5964>>2]);if(j|k!=ea(0.0)){if(!b)l=c[a+8192>>2]|0;else l=b;j=~~ea(h+ea(c[l+4>>2]|0));h=ea(k+ea(g[l+8>>2]));c[f>>2]=c[l>>2];c[f+4>>2]=j;g[f+8>>2]=h;Zse(e,a+8232|0,f);m=(c[e>>2]|0)+16|0}else m=b;b=c[a+5976>>2]|0;if((b|0)==-1){n=m;o=a+6068|0;Zqe(o,n);i=d;return}if(!m)p=c[a+8192>>2]|0;else p=m;m=p+4|0;p=c[m>>2]|0;j=c[m+4>>2]|0;c[f>>2]=b;b=f+4|0;c[b>>2]=p;c[b+4>>2]=j;Zse(e,a+8232|0,f);n=(c[e>>2]|0)+16|0;o=a+6068|0;Zqe(o,n);i=d;return}function Zqe(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,h=Im;d=i;e=a+2124|0;a=c[e>>2]|0;if((a|0)==(b|0)){i=d;return}c[e>>2]=b;e=c[b>>2]|0;do if((e|0)!=(c[a>>2]|0))if(!e){ko[c[1064952+128>>2]&4095](2884);break}else if((e|0)==1){ko[c[1064952+92>>2]&4095](1028);ko[c[1064952+144>>2]&4095](2884);break}else if((e|0)==2){ko[c[1064952+92>>2]&4095](1029);ko[c[1064952+144>>2]&4095](2884);break}else break;while(0);f=ea(g[b+8>>2]);h=ea(c[b+4>>2]|0);if(!(f!=ea(g[a+8>>2]))?!(h!=ea(c[a+4>>2]|0)):0){i=d;return}Ko[c[1064952+264>>2]&3](f,h);if(f!=ea(0.0)|h!=ea(0.0)){ko[c[1064952+144>>2]&4095](32823);i=d;return}else{ko[c[1064952+128>>2]&4095](32823);i=d;return}}function _qe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$qe(a+6068|0,b,c);i=d;return}function $qe(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;k=f+2116|0;if((c[k>>2]|0)==(g|0)?(c[f+2220>>2]|0)==(h|0):0){i=j;return}c[k>>2]=g;if(!(a[g>>0]|0))ko[c[1064952+128>>2]&4095](2960);else ko[c[1064952+144>>2]&4095](2960);k=b[g+12>>1]|0;if(!(a[621170]|0)){co[c[1064952+284>>2]&2047](k&65535,h,d[g+1>>0]|0);co[c[1064952+296>>2]&2047](e[g+16>>1]|0,e[g+18>>1]|0,e[g+14>>1]|0)}else{l=g+1|0;Dn[c[1064952+288>>2]&511](1028,k&65535,h,d[l>>0]|0);Dn[c[1064952+300>>2]&511](1028,e[g+16>>1]|0,e[g+18>>1]|0,e[g+14>>1]|0);Dn[c[1064952+288>>2]&511](1029,e[g+20>>1]|0,h,d[l>>0]|0);Dn[c[1064952+300>>2]&511](1029,e[g+24>>1]|0,e[g+26>>1]|0,e[g+22>>1]|0)}ko[c[1064952+292>>2]&4095](d[g+2>>0]|0);c[f+2220>>2]=h;i=j;return}function are(a,b){a=a|0;b=b|0;return}function bre(a){a=a|0;return 0}function cre(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;g=b+5973|0;if((d[g>>0]|0)==(e&1|0)){i=f;return}h=e&1;a[g>>0]=h;g=c[266280]|0;if((a[b+8297>>0]|0)==h<<24>>24){ko[g&4095](2304);i=f;return}else{ko[g&4095](2305);i=f;return}}function dre(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+5976|0;if((c[e>>2]|0)==(b|0)){i=d;return}c[e>>2]=b;In[c[(c[a>>2]|0)+56>>2]&4095](a,c[a+8192>>2]|0);i=d;return}function ere(a,b){a=a|0;b=b|0;return}function fre(a,b){a=a|0;b=b|0;var d=0;d=i;tMc(b,a+6132|0);tMc(b,a+2788|0);b=a+6260|0;c[b>>2]=c[b>>2]|4;i=d;return}function gre(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+6068|0;f=b+0|0;b=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(b|0));f=a+6260|0;c[f>>2]=c[f>>2]|1;i=d;return}function hre(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+6068|0;f=a+6260|0;c[f>>2]=c[f>>2]|3;f=a+2724|0;g=a+2788|0;h=a+2852|0;a=f+0|0;j=b+0|0;b=a+64|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(b|0));dMc(g,f,h);a=e+0|0;j=601008|0;b=a+64|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(b|0));i=d;return}function ire(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+6260|0;if(!(c[d>>2]&3)){e=a+6196|0;i=b;return e|0}else{f=a+6196|0;dMc(a+2724|0,a+6068|0,f);c[d>>2]=c[d>>2]&-4;e=f;i=b;return e|0}return 0}function jre(a){a=a|0;return a+6068|0}function kre(a){a=a|0;return a+2724|0}function lre(a){a=a|0;return a+6132|0}function mre(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[a>>2]|0)+124>>2]&4095](a)|0;i=b;return d|0}function nre(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;g=b+8297|0;if((d[g>>0]|0)==(e&1|0)){i=f;return}h=e&1;a[g>>0]=h;g=c[266280]|0;if(h<<24>>24==(a[b+5973>>0]|0)){ko[g&4095](2304);i=f;return}else{ko[g&4095](2305);i=f;return}}function ore(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;a[b+8293>>0]=c&1;a[b+8294>>0]=d&1;a[b+8292>>0]=e;return}function pre(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=0,i=0;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(g[b+12>>2]);g[a+8096>>2]=c;g[a+8100>>2]=d;g[a+8104>>2]=e;h=a+8108|0;g[h>>2]=f;f=ea(g[b+16>>2]);e=ea(g[b+20>>2]);d=ea(g[b+24>>2]);c=ea(g[b+28>>2]);g[a+8112>>2]=f;g[a+8116>>2]=e;g[a+8120>>2]=d;g[a+8124>>2]=c;c=ea(g[b+32>>2]);d=ea(g[b+36>>2]);e=ea(g[b+40>>2]);g[a+8128>>2]=c;g[a+8132>>2]=d;g[a+8136>>2]=e;e=ea(g[b+48>>2]);d=ea(g[b+52>>2]);c=ea(g[b+56>>2]);g[a+8144>>2]=e;g[a+8148>>2]=d;g[a+8152>>2]=c;i=b+64|0;b=a+8160|0;g[b>>2]=ea(g[i>>2]);g[h>>2]=ea(1.0);g[a+8140>>2]=ea(1.0);g[a+8156>>2]=ea(1.0);c=ea(g[i>>2]);i=c>ea(1.0);d=i?ea(1.0):c;i=d<ea(0.0);c=ea(d*ea(128.0));g[b>>2]=i?ea(0.0):c;return}function qre(a,b){a=a|0;b=b|0;var d=0,e=Im,f=0,h=Im,j=0,k=Im,l=0,m=Im;d=i;e=ea(g[b>>2]);f=b+4|0;h=ea(g[f>>2]);j=b+8|0;k=ea(g[j>>2]);l=b+12|0;m=ea(g[l>>2]);g[a+8164>>2]=e;g[a+8168>>2]=h;g[a+8172>>2]=k;g[a+8176>>2]=m;m=ea(g[b>>2]);k=ea(g[f>>2]);h=ea(g[j>>2]);e=ea(g[l>>2]);Zm[c[(c[a>>2]|0)+564>>2]&15](a,m,k,h,e);i=d;return}function rre(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+8252|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];nue(b);i=d;return}function sre(a,b){a=a|0;b=b|0;var d=0;d=b+8252|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function tre(b){b=b|0;var d=0,e=0;d=i;e=b+8298|0;if(!(a[e>>0]|0)){i=d;return}ko[c[1064952+128>>2]&4095](3089);a[e>>0]=0;i=d;return}function ure(b){b=b|0;return (a[b+8298>>0]|0)!=0|0}function vre(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=b+8298|0;if(!(a[f>>0]|0)){ko[c[1064952+144>>2]&4095](3089);a[f>>0]=1}f=b+8268|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];oue(d);i=e;return}function wre(a,b){a=a|0;b=b|0;var d=0;d=b+8268|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function xre(a,b){a=a|0;b=b|0;return 1}function yre(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=i;e=tqe(b,c)|0;i=f;return e|0}function zre(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[b>>2]|0;c[e>>2]=c[153080];c[d+0>>2]=c[e+0>>2];eOb(f,d);c[b>>2]=0;i=a;return}function Are(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im,w=Im,x=Im,y=0,z=0;f=i;i=i+208|0;h=f+200|0;j=f+152|0;k=f+88|0;l=f+24|0;m=f+8|0;n=f;o=c[b>>2]|0;b=c[o>>2]|0;c[j>>2]=0;c[j+12>>2]=0;c[j+24>>2]=0;c[j+36>>2]=0;p=(b|0)>0;if(p){q=o+4|0;r=(b|0)<4?b:4;s=0;do{t=Dtd((c[q>>2]|0)+(s*52|0)|0,d,e)|0;oxd(t,j+(s*12|0)|0);u=ea(g[t+44>>2]);v=ea(u*ea(g[t+32>>2]));u=ea(g[t+48>>2]);w=ea(u*ea(g[t+36>>2]));u=ea(g[t+52>>2]);x=ea(g[t+56>>2]);g[k+(s<<4)>>2]=v;g[k+(s<<4)+4>>2]=w;g[k+(s<<4)+8>>2]=u;g[k+(s<<4)+12>>2]=x;s=s+1|0}while((s|0)!=(r|0));if(p){p=o+4|0;r=m+4|0;s=m+8|0;q=m+12|0;t=(b|0)<4?b:4;b=0;do{_vc(m,(c[p>>2]|0)+(b*52|0)+12|0,d,e);x=ea(g[m>>2]);u=ea(g[r>>2]);w=ea(g[s>>2]);v=ea(g[q>>2]);g[l+(b<<4)>>2]=x;g[l+(b<<4)+4>>2]=u;g[l+(b<<4)+8>>2]=w;g[l+(b<<4)+12>>2]=v;b=b+1|0}while((b|0)!=(t|0));y=l;z=l}else{y=l;z=l}}else{y=l;z=l}c[n>>2]=o;c[h+0>>2]=c[n+0>>2];Bre(a,h,j,k,y);i=f;return}function Bre(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=Im,u=Im,v=Im,w=Im;j=i;i=i+16|0;k=j+4|0;l=j;m=c[d>>2]|0;d=c[m>>2]|0;n=c[155255]|0;o=(d|0)<(n|0)?d:n;p=b+6068|0;c[b+8016>>2]=o;if((o|0)<=0){q=b+8024|0;c[q>>2]=0;Ite(p,0);i=j;return}o=m+4|0;m=~d;d=~n;n=~((m|0)>(d|0)?m:d);d=0;do{m=c[o>>2]|0;r=c[(c[b>>2]|0)+212>>2]|0;c[l>>2]=c[e+(d*12|0)>>2];s=a[e+(d*12|0)+8>>0]&15;t=ea(g[e+(d*12|0)+4>>2]);c[k+0>>2]=c[l+0>>2];Zn[r&1](b,2,d,d,k,s,t);t=ea(g[h+(d<<4)>>2]);u=ea(g[h+(d<<4)+4>>2]);v=ea(g[h+(d<<4)+8>>2]);w=ea(g[h+(d<<4)+12>>2]);g[b+(d*52|0)+6352>>2]=t;g[b+(d*52|0)+6356>>2]=u;g[b+(d*52|0)+6360>>2]=v;g[b+(d*52|0)+6364>>2]=w;s=b+(d*52|0)+6368|0;r=f+(d<<4)|0;c[s+0>>2]=c[r+0>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];c[s+12>>2]=c[r+12>>2];c[b+(d*52|0)+6392>>2]=c[m+(d*52|0)+4>>2];c[b+(d*52|0)+6396>>2]=c[m+(d*52|0)+8>>2];d=d+1|0}while((d|0)!=(n|0));q=b+8024|0;c[q>>2]=0;Ite(p,0);i=j;return}function Cre(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);var j=0;e=i;i=i+16|0;b=e+4|0;j=e;c[j>>2]=c[f>>2];c[b+0>>2]=c[j+0>>2];Jte(a+6068|0,b,g,d);i=e;return}function Dre(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;k=i;i=i+16|0;l=k+8|0;m=k+4|0;n=k;o=c[d>>2]|0;c[m>>2]=o;c[l+0>>2]=c[m+0>>2];_se(l)|0;m=c[1066392+(e<<2)>>2]|0;d=c[(c[b>>2]|0)+212>>2]|0;c[n>>2]=o;c[l+0>>2]=c[n+0>>2];Zn[d&1](b,2,0,0,l,e,ea(x));if(a[621041]|0){e=c[155252]|0;co[c[1064952+308>>2]&2047](m,34046,(e|0)<(h|0)?e:h)}h=c[1066416+(g<<2)>>2]|0;co[c[1064952+308>>2]&2047](m,10242,h);co[c[1064952+308>>2]&2047](m,10243,h);h=(f|0)==2&(j^1)?1:f;f=(h|0)!=0?9729:9728;co[c[1064952+308>>2]&2047](m,10240,f);g=c[266315]|0;if(j){co[g&2047](m,10241,c[1066424+(h<<2)>>2]|0);i=k;return}else{co[g&2047](m,10241,f);i=k;return}}function Ere(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[b+4>>2]|0;if((j|0)!=0?(c[j+4>>2]|0)==6:0){b=a+8024|0;c[b>>2]=j;j=c[d+4>>2]|0;c[a+8028>>2]=j;d=c[j+156>>2]|0;j=a+8032|0;k=a+8040|0;c[k>>2]=d;l=a+8044|0;m=c[l>>2]|0;do if((m&2147483647)>>>0<d>>>0)if((m|0)>-1){c[l>>2]=d;n=c[j>>2]|0;c[h>>2]=c[a+8036>>2];c[g+0>>2]=c[h+0>>2];o=hOb(n,d,1,g,0,3653512,370)|0;c[j>>2]=o;p=o;break}else{c[h>>2]=c[a+8036>>2];c[g+0>>2]=c[h+0>>2];o=cOb(d,1,g,0,3653512,352)|0;YEi(o|0,c[j>>2]|0,c[k>>2]|0)|0;c[l>>2]=d;c[j>>2]=o;p=o;break}else p=c[j>>2]|0;while(0);YEi(p|0,c[e+4>>2]|0,d|0)|0;d=c[b>>2]|0;if(!d){i=f;return}b=a+8028|0;Gue(d,c[b>>2]|0,c[a+8032>>2]|0);e=c[b>>2]|0;c[a+8056>>2]=e+60;c[a+5856>>2]=e+72;c[a+8052>>2]=d+20;i=f;return}c[a+8024>>2]=0;c[a+8028>>2]=0;c[a+8040>>2]=0;i=f;return}function Fre(a,b){a=a|0;b=b|0;return (c[a+8024>>2]|0)!=0|0}function Gre(a,b){a=a|0;b=b|0;a=i;if(!b){i=a;return}Ptd(b);ACi(b);i=a;return}function Hre(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0;d=i;e=c[155251]|0;f=(e|0)<(b|0)?e:b;c[a+8092>>2]=f;if((f|0)<8)h=f;else{i=d;return}do{f=h+8|0;g[a+(f<<4)+4>>2]=ea(0.0);g[a+(f<<4)+8>>2]=ea(0.0);g[a+(f<<4)+12>>2]=ea(1.0);g[a+(f<<4)+16>>2]=ea(0.0);f=a+(h<<4)+4|0;h=h+1|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0}while((h|0)<8);i=d;return}function Ire(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+(b<<2)+8060>>2]=c[d+60>>2];Doc(a,b,d);i=e;return}function Jre(a,b){a=a|0;b=b|0;var d=0;d=a+516|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function Kre(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=Im,i=0;c[a+5284>>2]=c[b>>2];d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(g[b+12>>2]);h=ea(g[b+16>>2]);g[a+5288>>2]=d;g[a+5292>>2]=e;g[a+5296>>2]=f;g[a+5300>>2]=h;i=a+5304|0;a=b+20|0;c[i+0>>2]=c[a+0>>2];c[i+4>>2]=c[a+4>>2];c[i+8>>2]=c[a+8>>2];return}function Lre(a){a=a|0;var b=0,d=0;b=i;d=a+5284|0;if(!(c[d>>2]|0)){i=b;return}c[d>>2]=0;g[a+5312>>2]=ea(0.0);i=b;return}function Mre(a){a=a|0;var b=0,c=0;b=i;c=xCi(72)|0;wdc(c,a,1,0,0);i=b;return c|0}function Nre(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;g=i;i=i+32|0;a=g+24|0;l=g+8|0;m=g;c[l>>2]=d;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;c[m>>2]=c[b>>2];c[a+0>>2]=c[m+0>>2];m=Xue(j,a,0,h,k,l)|0;i=g;return m|0}function Ore(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0;a=i;i=i+32|0;k=a+24|0;l=a+8|0;m=a;c[l>>2]=d;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;c[m>>2]=c[b>>2];c[k+0>>2]=c[m+0>>2];m=Zue(h,k,0,g,j,l)|0;i=a;return m|0}function Pre(b,d){b=b|0;d=d|0;var e=0;b=i;e=c[d>>2]|0;if(!e){i=b;return}if(a[e+23>>0]|0){i=b;return}que(e);_ue(c[d>>2]|0);c[d>>2]=0;i=b;return}function Qre(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;e=0;while(1){if((c[d+(e<<2)>>2]|0)!=(c[1066984+(e<<2)>>2]|0))break;e=e+1|0;if((e|0)>=12){f=8;break}}if((f|0)==8){i=b;return}f=Bnc()|0;if(a[f+5568>>0]|0){e=f+5324|0;c[e>>2]=(c[e>>2]|0)+1}lue(d);if(!(a[621169]|0)){i=b;return}kue();i=b;return}function Rre(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[d>>2]|0;if(!e){i=b;return}if(a[e+22>>0]|0)if(!(c[266755]|0)){f=-1;g=0}else{d=(e|0)==(c[266728]|0);f=(d^1)<<31>>31;g=d}else{f=-1;g=(e|0)==(c[266736]|0)}d=g&(a[(c[267510]|0)+70>>0]|0)!=0;a[e+20>>0]=(a[621168]|0)!=0?2:0;if(!d){i=b;return}if((f|0)>-1){a[1066972+f>>0]=1;i=b;return}else{a[1066981]=1;i=b;return}}function Sre(a,b){a=a|0;b=b|0;return c[1066984+(b<<2)>>2]|0}function Tre(a){a=a|0;return c[266754]|0}function Ure(a){a=a|0;return c[266755]|0}function Vre(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;f=b+8|0;g=b;h=c[d>>2]|0;d=c[e>>2]|0;if((a[h+22>>0]|0)!=0?(a[d+22>>0]|0)!=0:0){c[g>>2]=c[d>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(f,586880,g);e=c[f>>2]|0;j=c[146727]|0;if((e|0)==-1){k=c[146728]|0;l=j;m=k;n=j+(k<<3)|0;break}else{l=j;m=c[146728]|0;n=j+(e<<3)|0;break}}else{e=c[146727]|0;j=c[146728]|0;l=e;m=j;n=e+(j<<3)|0}while(0);if((n|0)!=(l+(m<<3)|0)?!((c[h+24>>2]|0)==0|(c[n+4>>2]|0)==0):0){kue();vve(d,h);i=b;return}Krd(1066488,0,3653512,834,512,0,0,0);i=b;return}Krd(1066440,0,3653512,826,512,0,0,0);i=b;return}function Wre(a,b,d){a=a|0;b=b|0;d=d|0;b=i;kue();xve(c[d>>2]|0);i=b;return}function Xre(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=i;Wn[c[1064952+268>>2]&127](b,d,e,f,6408,5121,g);i=a;return 1}function Yre(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;a=i;kue();j=wve(b,c,d,e,f,g,h)|0;i=a;return j|0}function Zre(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;e=i;b=c[d>>2]|0;if(!b){i=e;return}if(a[b+23>>0]|0){i=e;return}kue();uve(b,c[266746]|0,f,g,h,j);i=e;return}function _re(a){a=a|0;a=i;Dn[c[1064952+64>>2]&511](0,0,0,1);ao[c[1064952+52>>2]&7](ea(0.0),ea(0.0),ea(0.0),ea(1.0));ko[c[1064952+48>>2]&4095](16384);Dn[c[1064952+64>>2]&511](1,1,1,1);ope();i=a;return}function $re(a){a=a|0;return}function ase(a){a=a|0;return}function bse(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+16|0;g=n+8|0;e=n;b=n+4|0;p=c[d>>2]|0;if((a[621284]|0)!=0&(a[1066672]|0)==0){c[e>>2]=p;do if((c[146729]|0)!=(c[146721]|0)){Roc(g,586880,e);d=c[g>>2]|0;q=c[146727]|0;if((d|0)==-1){r=c[146728]|0;s=q;t=r;u=q+(r<<3)|0;break}else{s=q;t=c[146728]|0;u=q+(d<<3)|0;break}}else{d=c[146727]|0;q=c[146728]|0;s=d;t=q;u=d+(q<<3)|0}while(0);if((u|0)!=(s+(t<<3)|0)?(c[u+4>>2]|0)!=0:0){Ad();a[1066672]=1}}c[b>>2]=p;c[g+0>>2]=c[b+0>>2];pve(g,2,k,f,0,h,j,1,l,m,o);i=n;return}function cse(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;b=f+8|0;o=f;p=f+4|0;q=c[d>>2]|0;if((a[621284]|0)!=0&(a[1066672]|0)==0){c[o>>2]=q;do if((c[146729]|0)!=(c[146721]|0)){Roc(b,586880,o);d=c[b>>2]|0;r=c[146727]|0;if((d|0)==-1){s=c[146728]|0;t=r;u=s;v=r+(s<<3)|0;break}else{t=r;u=c[146728]|0;v=r+(d<<3)|0;break}}else{d=c[146727]|0;r=c[146728]|0;t=d;u=r;v=d+(r<<3)|0}while(0);if((v|0)!=(t+(u<<3)|0)?(c[v+4>>2]|0)!=0:0){Ad();a[1066672]=1}}c[p>>2]=q;c[b+0>>2]=c[p+0>>2];qve(b,m,e,g,h,j,k,l,n);i=f;return}function dse(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;b=f+8|0;n=f;o=f+4|0;p=c[d>>2]|0;if((a[621284]|0)!=0&(a[1066672]|0)==0){c[n>>2]=p;do if((c[146729]|0)!=(c[146721]|0)){Roc(b,586880,n);d=c[b>>2]|0;q=c[146727]|0;if((d|0)==-1){r=c[146728]|0;s=q;t=r;u=q+(r<<3)|0;break}else{s=q;t=c[146728]|0;u=q+(d<<3)|0;break}}else{d=c[146727]|0;q=c[146728]|0;s=d;t=q;u=d+(q<<3)|0}while(0);if((u|0)!=(s+(t<<3)|0)?(c[u+4>>2]|0)!=0:0){Ad();a[1066672]=1}}c[o>>2]=p;c[b+0>>2]=c[o+0>>2];pve(b,4,j,e,g,h,h,1,k,l,m);i=f;return}function ese(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;b=f+8|0;n=f;o=f+4|0;p=c[d>>2]|0;if((a[621284]|0)!=0&(a[1066672]|0)==0){c[n>>2]=p;do if((c[146729]|0)!=(c[146721]|0)){Roc(b,586880,n);d=c[b>>2]|0;q=c[146727]|0;if((d|0)==-1){r=c[146728]|0;s=q;t=r;u=q+(r<<3)|0;break}else{s=q;t=c[146728]|0;u=q+(d<<3)|0;break}}else{d=c[146727]|0;q=c[146728]|0;s=d;t=q;u=d+(q<<3)|0}while(0);if((u|0)!=(s+(t<<3)|0)?(c[u+4>>2]|0)!=0:0){Ad();a[1066672]=1}}c[o>>2]=p;c[b+0>>2]=c[o+0>>2];pve(b,3,k,e,0,g,h,j,l,m,0);i=f;return}function fse(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+16|0;g=e;h=e+8|0;j=e+4|0;k=c[d>>2]|0;c[g>>2]=k;do if((c[146729]|0)!=(c[146721]|0)){Roc(f,586880,g);d=c[f>>2]|0;l=c[146727]|0;if((d|0)==-1){m=c[146728]|0;n=l;o=m;p=l+(m<<3)|0;break}else{n=l;o=c[146728]|0;p=l+(d<<3)|0;break}}else{d=c[146727]|0;l=c[146728]|0;n=d;o=l;p=d+(l<<3)|0}while(0);if((p|0)==(n+(o<<3)|0)){c[h>>2]=0;i=e;return}o=c[p+4>>2]|0;c[h>>2]=o;if(!o){i=e;return}In[c[1064952+116>>2]&4095](1,h);if(a[621295]|0)In[c[1064952+188>>2]&4095](1,j);j=c[155255]|0;if((j|0)>0){o=j;j=0;while(1){if((c[b+(j*52|0)+6388>>2]|0)==(c[h>>2]|0)){Fte(b+(j*52|0)+6352|0);q=c[155255]|0}else q=o;j=j+1|0;if((j|0)>=(q|0))break;else o=q}}c[g>>2]=k;do if((c[146729]|0)!=(c[146721]|0)){Roc(f,586880,g);k=c[f>>2]|0;q=c[146727]|0;o=c[146728]|0;if((k|0)==-1){r=q;s=o;t=q+(o<<3)|0;break}else{r=q;s=o;t=q+(k<<3)|0;break}}else{k=c[146727]|0;q=c[146728]|0;r=k;s=q;t=k+(q<<3)|0}while(0);if((t|0)==(r+(s<<3)|0)){i=e;return}s=586892;r=c[s+4>>2]|0;f=t;c[f>>2]=c[s>>2];c[f+4>>2]=r;c[146721]=(c[146721]|0)+1;a[586928]=1;i=e;return}function gse(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wqe(a+6264|0,b,c);i=d;return}function hse(b){b=b|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;if(!(a[621172]|0)){f=0;i=b;return f|0}c[e>>2]=c[153080];c[d+0>>2]=c[e+0>>2];e=bOb(12,d,0,16,3653512,970)|0;c[e+4>>2]=0;c[e>>2]=1066656;c[e+8>>2]=0;f=e;i=b;return f|0}function ise(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[153080]|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(b,d);i=a;return}function jse(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;Ave(b,c,d);i=a;return}function kse(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;Bve(b,c,d,e,f,g,h,j);i=a;return}function lse(a){a=a|0;return 1}function mse(a){a=a|0;var b=0;a=i;b=ipe()|0;i=a;return b|0}function nse(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!(kpe(e)|0)){f=0;i=d;return f|0}if(a[e>>0]|0)ko[c[(c[b>>2]|0)+804>>2]&4095](b);ko[c[(c[b>>2]|0)+8>>2]&4095](b);f=1;i=d;return f|0}function ose(a){a=a|0;a=i;eo[c[1064952+152>>2]&511]();i=a;return}function pse(a,b){a=a|0;b=b|0;var c=0;a=i;c=lpe(b)|0;i=a;return c|0}function qse(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!(mpe(b)|0)){e=0;i=d;return e|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);e=1;i=d;return e|0}function rse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;f=b+8|0;g=b;if(!(a[(c[267510]|0)+68>>0]|0)){i=b;return}h=c[266228]|0;c[g>>2]=c[d>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(f,586880,g);d=c[f>>2]|0;j=c[146727]|0;if((d|0)==-1){k=c[146728]|0;l=j;m=k;n=j+(k<<3)|0;break}else{l=j;m=c[146728]|0;n=j+(d<<3)|0;break}}else{d=c[146727]|0;j=c[146728]|0;l=d;m=j;n=d+(j<<3)|0}while(0);if((n|0)==(l+(m<<3)|0))o=0;else o=c[n+4>>2]|0;Dn[h&511](5890,o,0,e);i=b;return}function sse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;f=b+8|0;g=b;if(!(a[(c[267510]|0)+68>>0]|0)){i=b;return}if(c[d+16>>2]&64){i=b;return}h=c[d>>2]|0;j=c[266228]|0;if(!h){Dn[j&511](36161,c[d+24>>2]|0,0,e);i=b;return}c[g>>2]=h;do if((c[146729]|0)!=(c[146721]|0)){Roc(f,586880,g);h=c[f>>2]|0;d=c[146727]|0;if((h|0)==-1){k=c[146728]|0;l=d;m=k;n=d+(k<<3)|0;break}else{l=d;m=c[146728]|0;n=d+(h<<3)|0;break}}else{h=c[146727]|0;d=c[146728]|0;l=h;m=d;n=h+(d<<3)|0}while(0);if((n|0)==(l+(m<<3)|0))o=0;else o=c[n+4>>2]|0;Dn[j&511](5890,o,0,e);i=b;return}function tse(b,d,e){b=b|0;d=d|0;e=e|0;b=i;if(!(a[(c[267510]|0)+68>>0]|0)){i=b;return}Dn[c[1064904+8>>2]&511](37201,c[(c[d+24>>2]|0)+4>>2]|0,0,e);i=b;return}function use(b,d,e){b=b|0;d=d|0;e=e|0;b=i;if(!(a[(c[267510]|0)+68>>0]|0)){i=b;return}Dn[c[1064904+8>>2]&511](37201,c[(c[d+24>>2]|0)+4>>2]|0,0,e);i=b;return}function vse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;b=i;f=c[d+16>>2]|0;if(!((f|0)!=0?(a[(c[267510]|0)+68>>0]|0)!=0:0)){i=b;return}Dn[c[1064904+8>>2]&511](35648,f,0,e);i=b;return}function wse(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;d=a+8|0;e=a;c[e>>2]=c[b>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(d,586880,e);b=c[d>>2]|0;f=c[146727]|0;if((b|0)==-1){g=c[146728]|0;h=f;j=g;k=f+(g<<3)|0;break}else{h=f;j=c[146728]|0;k=f+(b<<3)|0;break}}else{b=c[146727]|0;f=c[146728]|0;h=b;j=f;k=b+(f<<3)|0}while(0);if((k|0)==(h+(j<<3)|0)){l=0;i=a;return l|0}l=c[k+4>>2]|0;i=a;return l|0}function xse(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[153080];c[e+0>>2]=c[f+0>>2];f=bOb(56,e,0,16,3653512,1153)|0;e=f+4|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[f>>2]=1066632;c[f+24>>2]=0;c[f+32>>2]=0;c[f+40>>2]=0;c[f+44>>2]=0;c[f+36>>2]=60;a[f+48>>0]=0;c[f+20>>2]=0;c[f+28>>2]=3;Inc(b,f);i=d;return f|0}function yse(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;c[b+16>>2]=e;e=b+12|0;do if((c[e>>2]|0)==(d|0)){a=b+24|0;j=c[a>>2]|0;c[b+20>>2]=f;k=b+24|0;if(!j){l=a;m=15}else{if((c[j+8>>2]|0)>>>0>=f>>>0){n=Mte(j)|0;o=c[k>>2]|0;if(n)p=o;else{if(!o){l=a;m=15;break}q=b+28|0;r=a;s=o;break}}else p=j;Nte(p);c[k>>2]=0;l=a;m=15}}else{c[e>>2]=d;if((d|0)==2)t=4;else if((d|0)==1)t=4;else if(!d)t=3;else t=4;c[b+28>>2]=t;a=b+24|0;k=c[a>>2]|0;if(k)Nte(k);c[a>>2]=0;c[b+20>>2]=f;l=a;m=15}while(0);if((m|0)==15){m=$te()|0;t=b+28|0;d=Wte(m,f,c[t>>2]|0)|0;c[b+24>>2]=d;q=t;r=l;s=d}if((c[q>>2]|0)!=2){u=c[r>>2]|0;Qte(u,0,f,g);i=h;return}Pte(s,f);u=c[r>>2]|0;Qte(u,0,f,g);i=h;return}function zse(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+16|0;g=b+4|0;h=b;if(!f)j=c[d+20>>2]|0;else j=f;f=a[621279]|0;a[d+48>>0]=f;if(!(f<<24>>24)){f=d+32|0;k=c[d+20>>2]|0;l=f+8|0;m=k;c[l>>2]=m;n=f+12|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<k>>>0)if((o|0)>-1){c[n>>2]=m;p=c[f>>2]|0;c[h>>2]=c[f+4>>2];c[g+0>>2]=c[h+0>>2];q=hOb(p,k,4,g,0,3653512,370)|0;c[f>>2]=q;r=q;break}else{c[h>>2]=c[f+4>>2];c[g+0>>2]=c[h+0>>2];q=cOb(k,4,g,0,3653512,352)|0;YEi(q|0,c[f>>2]|0,c[l>>2]|0)|0;c[n>>2]=m;c[f>>2]=q;r=q;break}else r=c[f>>2]|0;while(0);c[d+52>>2]=e;s=r+e|0;i=b;return s|0}r=d+24|0;f=c[r>>2]|0;do if(!f)t=10;else{if((c[f+8>>2]|0)>>>0>=j>>>0){m=Mte(f)|0;n=c[r>>2]|0;if(m)u=n;else{if(!n){t=10;break}v=d+28|0;w=n;break}}else u=f;Nte(u);c[r>>2]=0;t=10}while(0);if((t|0)==10){t=$te()|0;u=d+28|0;d=Wte(t,j,c[u>>2]|0)|0;c[r>>2]=d;v=u;w=d}if((c[v>>2]|0)==2){Pte(w,j);x=c[r>>2]|0}else x=w;s=Ste(x,e,j,58)|0;i=b;return s|0}function Ase(a,b,c){a=a|0;b=b|0;c=c|0;a=i;$se(b,c);i=a;return}function Bse(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;Jnc(a,b);a=c[153080]|0;if(b)ko[c[c[b>>2]>>2]&4095](b);c[f>>2]=a;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Cse(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=c[153080];c[e+0>>2]=c[f+0>>2];f=bOb(56,e,0,16,3653512,1184)|0;e=f+4|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[f>>2]=1066608;c[f+24>>2]=0;c[f+32>>2]=0;c[f+40>>2]=0;c[f+44>>2]=0;c[f+36>>2]=60;a[f+48>>0]=0;c[f+20>>2]=0;c[f+28>>2]=0;Knc(b,f);i=d;return f|0}function Dse(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;c[b+16>>2]=e;e=b+12|0;do if((c[e>>2]|0)==(d|0)){a=b+24|0;j=c[a>>2]|0;c[b+20>>2]=f;k=b+24|0;if(!j){l=a;m=15}else{if((c[j+8>>2]|0)>>>0>=f>>>0){n=Mte(j)|0;o=c[k>>2]|0;if(n)p=o;else{if(!o){l=a;m=15;break}q=b+28|0;r=a;s=o;break}}else p=j;Nte(p);c[k>>2]=0;l=a;m=15}}else{c[e>>2]=d;if((d|0)==2)t=1;else if((d|0)==1|(d|0)==0)t=d;else if((d|0)==3)t=2;else t=1;c[b+28>>2]=t;a=b+24|0;k=c[a>>2]|0;if(k)Nte(k);c[a>>2]=0;c[b+20>>2]=f;l=a;m=15}while(0);if((m|0)==15){m=$te()|0;t=b+28|0;d=Wte(m,f,c[t>>2]|0)|0;c[b+24>>2]=d;q=t;r=l;s=d}if((c[q>>2]|0)!=2){u=c[r>>2]|0;Qte(u,0,f,g);i=h;return}Pte(s,f);u=c[r>>2]|0;Qte(u,0,f,g);i=h;return}function Ese(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+16|0;g=b+4|0;h=b;if(!f)j=c[d+20>>2]|0;else j=f;f=a[621279]|0;a[d+48>>0]=f;if(!(f<<24>>24)){f=d+32|0;k=c[d+20>>2]|0;l=f+8|0;m=k;c[l>>2]=m;n=f+12|0;o=c[n>>2]|0;do if((o&2147483647)>>>0<k>>>0)if((o|0)>-1){c[n>>2]=m;p=c[f>>2]|0;c[h>>2]=c[f+4>>2];c[g+0>>2]=c[h+0>>2];q=hOb(p,k,4,g,0,3653512,370)|0;c[f>>2]=q;r=q;break}else{c[h>>2]=c[f+4>>2];c[g+0>>2]=c[h+0>>2];q=cOb(k,4,g,0,3653512,352)|0;YEi(q|0,c[f>>2]|0,c[l>>2]|0)|0;c[n>>2]=m;c[f>>2]=q;r=q;break}else r=c[f>>2]|0;while(0);c[d+52>>2]=e;s=r+e|0;i=b;return s|0}r=d+24|0;f=c[r>>2]|0;do if(!f)t=10;else{if((c[f+8>>2]|0)>>>0>=j>>>0){m=Mte(f)|0;n=c[r>>2]|0;if(m)u=n;else{if(!n){t=10;break}v=d+28|0;w=n;break}}else u=f;Nte(u);c[r>>2]=0;t=10}while(0);if((t|0)==10){t=$te()|0;u=d+28|0;d=Wte(t,j,c[u>>2]|0)|0;c[r>>2]=d;v=u;w=d}if((c[v>>2]|0)==2){Pte(w,j);x=c[r>>2]|0}else x=w;s=Ste(x,e,j,58)|0;i=b;return s|0}function Fse(a,b,c){a=a|0;b=b|0;c=c|0;a=i;ate(b,c);i=a;return}function Gse(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;Lnc(a,b);a=c[153080]|0;if(b)ko[c[c[b>>2]>>2]&4095](b);c[f>>2]=a;c[e+0>>2]=c[f+0>>2];eOb(b,e);i=d;return}function Hse(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=trc(a+8300|0,b)|0;i=c;return d|0}function Ise(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[a+8052>>2]|0;c[e>>2]=a;c[e+4>>2]=f;bte(b,c[a+8024>>2]|0,c[a+8028>>2]|0,e);i=d;return}function Jse(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=Im,t=Im,u=Im,v=0,w=0,x=Im,y=Im,z=0,A=Im,B=Im,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;d=i;i=i+416|0;e=d+104|0;f=d+216|0;h=d+280|0;j=d+344|0;k=d+40|0;l=d;m=d+168|0;n=b+6068|0;kue();o=b+6260|0;p=c[o>>2]|0;q=b+4|0;if(c[o>>2]&3){dMc(b+2724|0,n,b+6196|0);c[o>>2]=c[o>>2]&-4}if(a[b+8293>>0]|0){o=b+8144|0;r=ea(g[o>>2]);s=ea(g[o+4>>2]);t=ea(g[o+8>>2]);u=ea(g[o+12>>2]);g[b+2596>>2]=r;g[b+2600>>2]=s;g[b+2604>>2]=t;g[b+2608>>2]=u;o=b+8096|0;u=ea(g[o>>2]);t=ea(g[o+4>>2]);s=ea(g[o+8>>2]);r=ea(g[o+12>>2]);g[b+2612>>2]=u;g[b+2616>>2]=t;g[b+2620>>2]=s;g[b+2624>>2]=r;o=b+8112|0;r=ea(g[o>>2]);s=ea(g[o+4>>2]);t=ea(g[o+8>>2]);u=ea(g[o+12>>2]);g[b+2628>>2]=r;g[b+2632>>2]=s;g[b+2636>>2]=t;g[b+2640>>2]=u;o=b+8128|0;u=ea(g[o>>2]);t=ea(g[o+4>>2]);s=ea(g[o+8>>2]);r=ea(g[o+12>>2]);g[b+2644>>2]=u;g[b+2648>>2]=t;g[b+2652>>2]=s;g[b+2656>>2]=r;r=ea(g[b+8160>>2]);g[b+2660>>2]=r;g[b+2664>>2]=r;g[b+2668>>2]=r;g[b+2672>>2]=r}o=b+5284|0;v=c[o>>2]|0;if((v|0)>0){w=(v|0)==1;if(w){r=ea(g[b+5308>>2]);s=ea(r-ea(g[b+5304>>2]));if(s<ea(0.0))x=ea(-s);else x=s;if(x>ea(.0000999999974))y=ea(ea(1.0)/s);else y=ea(0.0)}else y=ea(0.0);v=b+5288|0;z=b+2692|0;c[z+0>>2]=c[v+0>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];c[z+12>>2]=c[v+12>>2];s=ea(g[b+5312>>2]);x=ea(s*ea(1.2011224));r=ea(s*ea(1.44269502));if(w){s=ea(-y);A=ea(y*ea(g[b+5308>>2]));B=s}else{A=ea(0.0);B=ea(0.0)}g[b+2708>>2]=x;g[b+2712>>2]=r;g[b+2716>>2]=B;g[b+2720>>2]=A}A=ea(g[b+8284>>2]);g[b+2676>>2]=A;g[b+2680>>2]=A;g[b+2684>>2]=A;g[b+2688>>2]=A;if(!(c[b+8024>>2]|0)){w=b+8164|0;A=ea(g[w>>2]);B=ea(g[w+4>>2]);r=ea(g[w+8>>2]);x=ea(g[w+12>>2]);g[b+2452>>2]=A;g[b+2456>>2]=B;g[b+2460>>2]=r;g[b+2464>>2]=x;w=b+8016|0;if(c[w>>2]|0){v=0;do{z=b+(v*52|0)+6352|0;C=b+(v+154<<4)+4|0;c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];z=b+(v*52|0)+6368|0;C=b+(v+158<<4)+4|0;c[C+0>>2]=c[z+0>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];v=v+1|0}while(v>>>0<(c[w>>2]|0)>>>0)}Hte(n,o,m);o=c[266633]|0;if(o){w=1066532;v=o;a:while(1){o=v;while(1){if(!(cte(1066536,o+16|0,m)|0)){D=o;break}o=c[o+4>>2]|0;if(!o){E=w;break a}}v=c[D>>2]|0;if(!v){E=D;break}else w=D}if((E|0)!=1066532?!(cte(1066536,m,E+16|0)|0):0)F=c[E+60>>2]|0;else G=25}else G=25;if((G|0)==25){dte(f,1066544,m);E=c[f>>2]|0;ete(h,1066560,m);D=c[h>>2]|0;w=(E|0)==1066548;if(w)H=0;else H=c[E+60>>2]|0;E=(D|0)==1066564;if(E)I=0;else I=c[D+60>>2]|0;D=(H|0)!=0;if(w){w=mo[c[1064952+88>>2]&4095](35633)|0;jwe(j,m,c[155306]|0);if(!(a[j>>0]&1))J=j+1|0;else J=c[j+8>>2]|0;v=Due(w,1,J)|0;J=fte(1066544,e,m)|0;o=c[J>>2]|0;if(!o){z=xCi(64)|0;K=z+16|0;L=m+0|0;M=K+44|0;do{c[K>>2]=c[L>>2];K=K+4|0;L=L+4|0}while((K|0)<(M|0));c[z+60>>2]=0;C=c[e>>2]|0;c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=C;c[J>>2]=z;C=c[c[266636]>>2]|0;if(!C)N=z;else{c[266636]=C;N=c[J>>2]|0}GN(c[266637]|0,N);c[266638]=(c[266638]|0)+1;O=z}else O=o;c[O+60>>2]=w;xri(j);P=w;Q=v}else{P=H;Q=D}D=(I|0)!=0;if(E){E=mo[c[1064952+88>>2]&4095](35632)|0;kwe(k,m,c[155306]|0);if(!(a[k>>0]&1))R=k+1|0;else R=c[k+8>>2]|0;H=Due(E,2,R)|0;R=gte(1066560,e,m)|0;v=c[R>>2]|0;if(!v){w=xCi(64)|0;K=w+16|0;L=m+0|0;M=K+44|0;do{c[K>>2]=c[L>>2];K=K+4|0;L=L+4|0}while((K|0)<(M|0));c[w+60>>2]=0;L=c[e>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=L;c[R>>2]=w;L=c[c[266640]>>2]|0;if(!L)S=w;else{c[266640]=L;S=c[R>>2]|0}GN(c[266641]|0,S);c[266642]=(c[266642]|0)+1;T=w}else T=v;c[T+60>>2]=E;xri(k);U=E;V=H}else{U=I;V=D}if(Q&V){c[l>>2]=c[153080];c[e+0>>2]=c[l+0>>2];V=bOb(180,e,0,16,3653512,1283)|0;cue(V,P,U);W=V}else W=0;c[(hte(1066528,m)|0)>>2]=W;F=W}if(F){fue(F,q,b+6264|0);c[b+5856>>2]=F+88;c[b+8056>>2]=F+76;c[b+8052>>2]=F}}F=c[b+5856>>2]|0;b:do if(!((c[F>>2]|0)<0|(p&7|0)==0)){dMc(b+2788|0,b+6196|0,e);q=c[F>>2]|0;W=c[F+8>>2]|0;m=c[b+8056>>2]|0;V=b+6264|0;if(!W){Dn[c[1064952+356>>2]&511](q,1,0,e);break}if((m|0)!=0?(U=c[m+4>>2]|0,P=c[m>>2]|0,(U|0)!=(P|0)):0){m=(U-P|0)/28|0;U=0;while(1){Q=c[P+(U*28|0)>>2]|0;D=c[P+(U*28|0)+20>>2]|0;if((D<<16|Q|0)==(W|0)){X=Q;Y=D;Z=U;break}U=U+1|0;if(U>>>0>=m>>>0)break b}zqe(V,xqe(V,X,c[P+(Z*28|0)+24>>2]|0,Y)|0,q,e,64)}}while(0);e=c[F+12>>2]|0;Y=(p&3|0)==0;c:do if(!((e|0)<0|Y)){Z=c[F+20>>2]|0;X=c[b+8056>>2]|0;m=b+6196|0;U=b+6264|0;if(!Z){Dn[c[1064952+356>>2]&511](e,1,0,m);break}if((X|0)!=0?(W=c[X+4>>2]|0,D=c[X>>2]|0,(W|0)!=(D|0)):0){X=(W-D|0)/28|0;W=0;while(1){Q=c[D+(W*28|0)>>2]|0;I=c[D+(W*28|0)+20>>2]|0;if((I<<16|Q|0)==(Z|0)){_=Q;$=I;aa=W;break}W=W+1|0;if(W>>>0>=X>>>0)break c}zqe(U,xqe(U,_,c[D+(aa*28|0)+24>>2]|0,$)|0,e,m,64)}}while(0);e=F+48|0;d:do if(!((c[e>>2]|0)<0|Y)){AMc(b+6196|0,f);$=c[e>>2]|0;aa=c[F+56>>2]|0;_=c[b+8056>>2]|0;X=b+6264|0;if(!aa){Dn[c[1064952+356>>2]&511]($,1,0,f);break}if((_|0)!=0?(W=c[_+4>>2]|0,Z=c[_>>2]|0,(W|0)!=(Z|0)):0){_=(W-Z|0)/28|0;W=0;while(1){q=c[Z+(W*28|0)>>2]|0;P=c[Z+(W*28|0)+20>>2]|0;if((P<<16|q|0)==(aa|0)){ba=q;ca=P;da=W;break}W=W+1|0;if(W>>>0>=_>>>0)break d}zqe(X,xqe(X,ba,c[Z+(da*28|0)+24>>2]|0,ca)|0,$,f,64)}}while(0);f=F+60|0;e:do if(!((c[f>>2]|0)<0|Y)){rMc(b+6196|0,h)|0;AMc(h,j);ca=c[f>>2]|0;da=c[F+68>>2]|0;ba=c[b+8056>>2]|0;e=b+6264|0;if(!da){Dn[c[1064952+356>>2]&511](ca,1,0,j);break}if((ba|0)!=0?(_=c[ba+4>>2]|0,W=c[ba>>2]|0,(_|0)!=(W|0)):0){ba=(_-W|0)/28|0;_=0;while(1){aa=c[W+(_*28|0)>>2]|0;m=c[W+(_*28|0)+20>>2]|0;if((m<<16|aa|0)==(da|0)){fa=aa;ga=m;ha=_;break}_=_+1|0;if(_>>>0>=ba>>>0)break e}zqe(e,xqe(e,fa,c[W+(ha*28|0)+24>>2]|0,ga)|0,ca,j,64)}}while(0);j=c[F+24>>2]|0;ga=(p&1|0)==0;f:do if(!((j|0)<0|ga)){p=c[F+32>>2]|0;ha=c[b+8056>>2]|0;fa=b+6264|0;if(!p){Dn[c[1064952+356>>2]&511](j,1,0,n);break}if((ha|0)!=0?(f=c[ha+4>>2]|0,h=c[ha>>2]|0,(f|0)!=(h|0)):0){ha=(f-h|0)/28|0;f=0;while(1){ba=c[h+(f*28|0)>>2]|0;_=c[h+(f*28|0)+20>>2]|0;if((_<<16|ba|0)==(p|0)){ia=ba;ja=_;ka=f;break}f=f+1|0;if(f>>>0>=ha>>>0)break f}zqe(fa,xqe(fa,ia,c[h+(ka*28|0)+24>>2]|0,ja)|0,j,n,64)}}while(0);j=c[F+36>>2]|0;g:do if(!((j|0)<0|ga)){ja=c[F+44>>2]|0;rMc(n,k)|0;ka=c[b+8056>>2]|0;ia=b+6264|0;if(!ja){Dn[c[1064952+356>>2]&511](j,1,0,k);break}if((ka|0)!=0?(ha=c[ka+4>>2]|0,f=c[ka>>2]|0,(ha|0)!=(f|0)):0){ka=(ha-f|0)/28|0;ha=0;while(1){p=c[f+(ha*28|0)>>2]|0;ca=c[f+(ha*28|0)+20>>2]|0;if((ca<<16|p|0)==(ja|0)){la=p;ma=ca;na=ha;break}ha=ha+1|0;if(ha>>>0>=ka>>>0)break g}zqe(ia,xqe(ia,la,c[f+(na*28|0)+24>>2]|0,ma)|0,j,k,64)}}while(0);k=c[F+72>>2]|0;if((k|0)<0|Y){oa=b+6264|0;Aqe(oa);i=d;return}Y=c[F+80>>2]|0;TLc(l,b+6196|0);VLc(l);F=c[b+8056>>2]|0;j=b+6264|0;if(!Y){Dn[c[1064952+352>>2]&511](k,1,0,l);oa=j;Aqe(oa);i=d;return}if(!F){oa=j;Aqe(oa);i=d;return}b=c[F+4>>2]|0;ma=c[F>>2]|0;if((b|0)==(ma|0)){oa=j;Aqe(oa);i=d;return}F=(b-ma|0)/28|0;b=0;while(1){na=c[ma+(b*28|0)>>2]|0;la=c[ma+(b*28|0)+20>>2]|0;if((la<<16|na|0)==(Y|0)){pa=na;qa=la;ra=b;break}b=b+1|0;if(b>>>0>=F>>>0){oa=j;G=116;break}}if((G|0)==116){Aqe(oa);i=d;return}zqe(j,xqe(j,pa,c[ma+(ra*28|0)+24>>2]|0,qa)|0,k,l,36);oa=j;Aqe(oa);i=d;return}function Kse(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;l=i;if(!j){i=l;return}ewe(k,j,e,f);a[b+8295>>0]=(a[k+9>>0]|0)==2&1;ko[c[(c[b>>2]|0)+604>>2]&4095](b);a:do if((h|0)>0){k=(d|0)==0;j=b+5568|0;m=b+5348|0;n=b+5352|0;o=b+5360|0;p=b+5356|0;q=b+5344|0;r=d+24|0;s=0;while(1){t=g+(s*24|0)|0;if(k){u=g+(s*24|0)+20|0;co[c[1064952+136>>2]&2047](c[1066576+(c[t>>2]<<2)>>2]|0,c[g+(s*24|0)+16>>2]|0,c[u>>2]|0);v=u}else{In[c[1064952+12>>2]&4095](34963,c[(c[r>>2]|0)+4>>2]|0);u=g+(s*24|0)+8|0;Dn[c[1064952+140>>2]&511](c[1066576+(c[t>>2]<<2)>>2]|0,c[u>>2]|0,5123,c[g+(s*24|0)+4>>2]|0);v=u}u=c[v>>2]|0;switch(c[t>>2]|0){case 5:{w=u;break}case 3:{w=(u|0)/2|0;break}case 2:{w=((u|0)/4|0)<<1;break}case 1:{w=u+-2|0;break}case 0:{w=(u|0)/3|0;break}case 4:{w=u+-1|0;break}default:w=0}if((a[j>>0]|0)!=0?(u=c[g+(s*24|0)+20>>2]|0,c[m>>2]=(c[m>>2]|0)+1,c[n>>2]=(c[n>>2]|0)+w,c[o>>2]=(c[o>>2]|0)+u,c[p>>2]=(c[p>>2]|0)+w,(s|0)<=0):0)c[q>>2]=(c[q>>2]|0)+1;s=s+1|0;if((s|0)==(h|0))break a}}while(0);if(d)Vte(c[d+24>>2]|0);if((f|0)>0)x=0;else{i=l;return}do{d=c[e+(x<<3)>>2]|0;if(d)Vte(c[d+24>>2]|0);x=x+1|0}while((x|0)!=(f|0));i=l;return}function Lse(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=ea(f);g=g|0;var h=0,j=0,k=0,l=0;b=i;if((((a[(c[267510]|0)+59>>0]|0)!=0?(h=c[266746]|0,(c[266794]|c[266793]|0)==0):0)?(c[266795]|0)==(c[h+4>>2]|0):0)?(c[266796]|0)==(c[h+8>>2]|0):0){a[(c[266754]|0)+20>>0]=0;a[h+20>>0]=0}kue();if(!(c[(c[266728]|0)+16>>2]&64))j=(d&1|0)!=0;else j=0;if(c[(c[266736]|0)+16>>2]&64){k=0;l=0;Mse(j,k,l,e,f,g);i=b;return}k=(d&2|0)!=0;l=(d&4|0)!=0;Mse(j,k,l,e,f,g);i=b;return}function Mse(d,f,h,j,k,l){d=d|0;f=f|0;h=h|0;j=j|0;k=ea(k);l=l|0;var m=0,n=0,o=0,p=0,q=Im,r=Im,s=Im,t=Im,u=0,v=0,w=0,x=0,y=0;m=i;i=i+16|0;n=m+8|0;o=m;p=c[266694]|0;if(d){d=Uqe(p,0,15)|0;Wqe(p,d,ea(g[p+2216>>2]));q=ea(g[j>>2]);r=ea(g[j+4>>2]);s=ea(g[j+8>>2]);t=ea(g[j+12>>2]);ao[c[1064952+52>>2]&7](q,r,s,t);u=(a[(c[267510]|0)+94>>0]|0)==0?16384:49152}else u=0;if(f){f=p+2112|0;j=c[f>>2]|0;if((a[j>>0]&1)==0?(d=a[j+1>>0]|0,b[o>>1]=(d&255)<<8&65535|1,b[o+2>>1]=c[1074600+(d<<24>>24<<2)>>2],Sse(n,p+2128|0,o),o=c[n>>2]|0,n=o+16|0,d=c[f>>2]|0,(d|0)!=(n|0)):0){c[f>>2]=n;f=a[o+17>>0]|0;j=a[d+1>>0]|0;do if(j<<24>>24!=f<<24>>24){if(!(f<<24>>24)){ko[c[1064952+128>>2]&4095](2929);break}if(!(j<<24>>24))ko[c[1064952+144>>2]&4095](2929);ko[c[1064952+120>>2]&4095](e[o+18>>1]|0)}while(0);o=a[n>>0]|0;if(o<<24>>24!=(a[d>>0]|0))ko[c[1064952+124>>2]&4095](o)}jo[c[1064952+56>>2]&3](k);v=u|256}else v=u;if(!h){w=v;x=1065e3;y=c[x>>2]|0;ko[y&4095](w);i=m;return}h=Rse(p,0,-1)|0;$qe(p,h,c[p+2220>>2]|0);ko[c[1064952+60>>2]&4095](l);w=v|1024;x=1065e3;y=c[x>>2]|0;ko[y&4095](w);i=m;return}function Nse(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Ose(a){a=a|0;var b=0;b=i;_te($te()|0);zve();Nnc(a);Hnc(a);Mnc(a)|0;Aoc(7);Eqe();sue();ko[c[(c[a>>2]|0)+8>>2]&4095](a);i=b;return}function Pse(a){a=a|0;return 0}function Qse(a){a=a|0;return 0}function Rse(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+32|0;j=g;if(!e)k=c[d+2116>>2]|0;else k=e;e=c[k>>2]|0;l=c[k+4>>2]|0;m=(l&65535)>>>8;n=l>>>16;o=l>>>24;p=c[k+8>>2]|0;q=(p&65535)>>>8;r=p>>>16;s=p>>>24;if((e>>>16&255)<<24>>24==f<<24>>24){t=k;i=g;return t|0}b[j>>1]=e;a[j+2>>0]=f;a[j+3>>0]=e>>>24;a[j+4>>0]=l;a[j+5>>0]=m;a[j+6>>0]=n;a[j+7>>0]=o;a[j+8>>0]=p;a[j+9>>0]=q;a[j+10>>0]=r;a[j+11>>0]=s;b[j+12>>1]=c[1074600+((l&255)<<2)>>2];b[j+14>>1]=c[1074776+((m&65535)<<2)>>2];b[j+16>>1]=c[1074776+((n&255)<<2)>>2];b[j+18>>1]=c[1074776+(o<<2)>>2];b[j+20>>1]=c[1074600+((p&255)<<2)>>2];b[j+22>>1]=c[1074776+((q&65535)<<2)>>2];b[j+24>>1]=c[1074776+((r&255)<<2)>>2];b[j+26>>1]=c[1074776+(s<<2)>>2];Yse(h,d+2140|0,j);t=(c[h>>2]|0)+16|0;i=g;return t|0}function Sse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=j;while(1){l=k+16|0;if((FEi(e,l,4)|0)<0){m=c[k>>2]|0;if(!m){n=k;o=k;p=5;break}else{k=m;continue}}if((FEi(l,e,4)|0)>=0){q=k;p=9;break}l=k+4|0;m=c[l>>2]|0;if(!m){r=l;s=k;p=8;break}else k=m}if((p|0)==5){c[g>>2]=o;t=n;u=o;break}else if((p|0)==8){c[g>>2]=s;t=r;u=s;break}else if((p|0)==9){c[g>>2]=q;t=g;u=q;break}}else{k=d+4|0;c[g>>2]=k;t=k;u=k}while(0);g=c[t>>2]|0;if(g){v=0;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}g=xCi(20)|0;c[g+16>>2]=c[e>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=u;c[t>>2]=g;u=c[c[d>>2]>>2]|0;if(!u)y=g;else{c[d>>2]=u;y=c[t>>2]|0}GN(c[h>>2]|0,y);y=d+8|0;c[y>>2]=(c[y>>2]|0)+1;v=1;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}function Tse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=j;while(1){l=k+16|0;if((FEi(e,l,12)|0)<0){m=c[k>>2]|0;if(!m){n=k;o=k;p=5;break}else{k=m;continue}}if((FEi(l,e,12)|0)>=0){q=k;p=9;break}l=k+4|0;m=c[l>>2]|0;if(!m){r=l;s=k;p=8;break}else k=m}if((p|0)==5){c[g>>2]=o;t=n;u=o;break}else if((p|0)==8){c[g>>2]=s;t=r;u=s;break}else if((p|0)==9){c[g>>2]=q;t=g;u=q;break}}else{k=d+4|0;c[g>>2]=k;t=k;u=k}while(0);g=c[t>>2]|0;if(g){v=0;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}g=xCi(44)|0;q=g+16|0;c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2];c[q+24>>2]=c[e+24>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=u;c[t>>2]=g;u=c[c[d>>2]>>2]|0;if(!u)y=g;else{c[d>>2]=u;y=c[t>>2]|0}GN(c[h>>2]|0,y);y=d+8|0;c[y>>2]=(c[y>>2]|0)+1;v=1;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}function Use(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;Ate(a+2164|0,c[a+2168>>2]|0);Bte(a+2152|0,c[a+2156>>2]|0);Cte(a+2140|0,c[a+2144>>2]|0);Dte(a+2128|0,c[a+2132>>2]|0);if((c[a+1976>>2]|0)<=-1){f=a+196|0;Ete(f);i=b;return}g=a+1964|0;h=c[g>>2]|0;c[e>>2]=c[a+1968>>2];c[d+0>>2]=c[e+0>>2];eOb(h,d);c[g>>2]=0;f=a+196|0;Ete(f);i=b;return}function Vse(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Vse(a,c[b>>2]|0);Vse(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Wse(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Wse(a,c[b>>2]|0);Wse(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Xse(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Xse(a,c[b>>2]|0);Xse(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Yse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=j;while(1){l=k+16|0;if((FEi(e,l,12)|0)<0){m=c[k>>2]|0;if(!m){n=k;o=k;p=5;break}else{k=m;continue}}if((FEi(l,e,12)|0)>=0){q=k;p=9;break}l=k+4|0;m=c[l>>2]|0;if(!m){r=l;s=k;p=8;break}else k=m}if((p|0)==5){c[g>>2]=o;t=n;u=o;break}else if((p|0)==8){c[g>>2]=s;t=r;u=s;break}else if((p|0)==9){c[g>>2]=q;t=g;u=q;break}}else{k=d+4|0;c[g>>2]=k;t=k;u=k}while(0);g=c[t>>2]|0;if(g){v=0;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}g=xCi(44)|0;q=g+16|0;c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[q+16>>2]=c[e+16>>2];c[q+20>>2]=c[e+20>>2];c[q+24>>2]=c[e+24>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=u;c[t>>2]=g;u=c[c[d>>2]>>2]|0;if(!u)y=g;else{c[d>>2]=u;y=c[t>>2]|0}GN(c[h>>2]|0,y);y=d+8|0;c[y>>2]=(c[y>>2]|0)+1;v=1;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}function Zse(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+16|0;g=f;h=d+4|0;j=c[h>>2]|0;do if(j){k=j;while(1){l=k+16|0;if((FEi(e,l,12)|0)<0){m=c[k>>2]|0;if(!m){n=k;o=k;p=5;break}else{k=m;continue}}if((FEi(l,e,12)|0)>=0){q=k;p=9;break}l=k+4|0;m=c[l>>2]|0;if(!m){r=l;s=k;p=8;break}else k=m}if((p|0)==5){c[g>>2]=o;t=n;u=o;break}else if((p|0)==8){c[g>>2]=s;t=r;u=s;break}else if((p|0)==9){c[g>>2]=q;t=g;u=q;break}}else{k=d+4|0;c[g>>2]=k;t=k;u=k}while(0);g=c[t>>2]|0;if(g){v=0;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}g=xCi(28)|0;q=g+16|0;c[q+0>>2]=c[e+0>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=u;c[t>>2]=g;u=c[c[d>>2]>>2]|0;if(!u)y=g;else{c[d>>2]=u;y=c[t>>2]|0}GN(c[h>>2]|0,y);y=d+8|0;c[y>>2]=(c[y>>2]|0)+1;v=1;w=g;c[b>>2]=w;x=b+4|0;a[x>>0]=v;i=f;return}function _se(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+48|0;d=b+40|0;e=b+8|0;f=b+24|0;g=b;h=b+16|0;j=c[a>>2]|0;c[e>>2]=j;do if((c[146729]|0)!=(c[146721]|0)){Roc(d,586880,e);a=c[d>>2]|0;k=c[146727]|0;if((a|0)==-1){l=c[146728]|0;m=k;n=l;o=k+(l<<3)|0;break}else{m=k;n=c[146728]|0;o=k+(a<<3)|0;break}}else{a=c[146727]|0;k=c[146728]|0;m=a;n=k;o=a+(k<<3)|0}while(0);if((o|0)!=(m+(n<<3)|0)){n=c[o+4>>2]|0;c[h>>2]=n;if(n){p=c[h>>2]|0;i=b;return p|0}}else c[h>>2]=0;In[c[1064952+188>>2]&4095](1,h);n=c[h>>2]|0;c[g>>2]=j;do if((c[146729]|0)!=(c[146721]|0)){Roc(d,586880,g);o=c[d>>2]|0;m=c[146727]|0;if((o|0)==-1){k=c[146728]|0;q=m;r=k;s=m+(k<<3)|0;break}else{q=m;r=c[146728]|0;s=m+(o<<3)|0;break}}else{o=c[146727]|0;m=c[146728]|0;q=o;r=m;s=o+(m<<3)|0}while(0);if((s|0)==(q+(r<<3)|0)){c[e>>2]=j;c[e+4>>2]=n;Soc(f,586880,e);p=c[h>>2]|0;i=b;return p|0}else{c[s+4>>2]=n;p=c[h>>2]|0;i=b;return p|0}return 0}function $se(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+48|0;if(a[h>>0]|0){j=b+24|0;Tte(c[j>>2]|0,0,d);Ute(c[j>>2]|0);a[h>>0]=0;i=e;return}h=b+52|0;j=(c[h>>2]|0)+d|0;k=b+24|0;l=c[k>>2]|0;do if(!l)m=9;else{if((c[l+8>>2]|0)>>>0>=j>>>0){n=Mte(l)|0;o=c[k>>2]|0;if(n)p=o;else{if(!o){m=9;break}q=b+28|0;r=o;break}}else p=l;Nte(p);c[k>>2]=0;m=9}while(0);if((m|0)==9){m=$te()|0;p=b+28|0;l=Wte(m,j,c[p>>2]|0)|0;c[k>>2]=l;q=p;r=l}if((c[q>>2]|0)==2){Pte(r,j);s=c[k>>2]|0}else s=r;r=b+32|0;Qte(s,c[h>>2]|0,d,c[r>>2]|0);if(c[b+12>>2]|0){i=e;return}d=b+44|0;if((c[d>>2]|0)>-1){h=c[r>>2]|0;c[g>>2]=c[b+36>>2];c[f+0>>2]=c[g+0>>2];eOb(h,f);c[r>>2]=0}c[b+40>>2]=0;c[d>>2]=0;i=e;return}function ate(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e;h=b+48|0;if(a[h>>0]|0){j=b+24|0;Tte(c[j>>2]|0,0,d);Ute(c[j>>2]|0);a[h>>0]=0;i=e;return}h=b+52|0;j=(c[h>>2]|0)+d|0;k=b+24|0;l=c[k>>2]|0;do if(!l)m=9;else{if((c[l+8>>2]|0)>>>0>=j>>>0){n=Mte(l)|0;o=c[k>>2]|0;if(n)p=o;else{if(!o){m=9;break}q=b+28|0;r=o;break}}else p=l;Nte(p);c[k>>2]=0;m=9}while(0);if((m|0)==9){m=$te()|0;p=b+28|0;l=Wte(m,j,c[p>>2]|0)|0;c[k>>2]=l;q=p;r=l}if((c[q>>2]|0)==2){Pte(r,j);s=c[k>>2]|0}else s=r;r=b+32|0;Qte(s,c[h>>2]|0,d,c[r>>2]|0);if(c[b+12>>2]|0){i=e;return}d=b+44|0;if((c[d>>2]|0)>-1){h=c[r>>2]|0;c[g>>2]=c[b+36>>2];c[f+0>>2]=c[g+0>>2];eOb(h,f);c[r>>2]=0}c[b+40>>2]=0;c[d>>2]=0;i=e;return}function bte(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+16|0;j=h+8|0;k=h+4|0;l=h;if(!e){i=h;return}e=c[b>>2]|0;m=c[b+8>>2]|0;n=e+(m<<4)|0;o=c[b+16>>2]|0;if(!m){i=h;return}m=e;do{c[k>>2]=c[m>>2];e=a[m+6>>0]|0;do if(!(e<<24>>24)){b=Qqc(f,k,0)|0;if((b|0)!=0?(p=a[m+4>>0]|0,q=a[b+16>>0]|0,r=q&255,p<<24>>24==q<<24>>24):0)if(p<<24>>24==1){Kue(g,c[b+12>>2]|0,c[b+4>>2]|0,o+(c[m+12>>2]<<2)|0,d[b+17>>0]|0);break}else if(p<<24>>24==4){Lue(g,c[b+4>>2]|0,o+(c[m+12>>2]<<2)|0,r);break}else break}else{r=Pqc(f,k,e&255)|0;if(r){b=c[r+4>>2]|0;p=c[r+8>>2]|0;q=c[r+12>>2]|0;c[l>>2]=c[o+(c[m+12>>2]<<2)>>2];c[j+0>>2]=c[l+0>>2];Mue(g,2,b,p,q,j)}}while(0);m=m+16|0}while((m|0)!=(n|0));i=h;return}function cte(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;f=c[d+32>>2]|0;g=c[e+32>>2]|0;a:do if(f>>>0>=g>>>0)if(f>>>0<=g>>>0){h=a[d+38>>0]|0;j=a[e+38>>0]|0;if((h&255)>=(j&255))if((h&255)<=(j&255)){j=a[d+36>>0]|0;h=j&255;k=a[e+36>>0]|0;if((j&255)>=(k&255))if((j&255)<=(k&255)){k=a[d+37>>0]|0;l=a[e+37>>0]|0;if((k&255)>=(l&255))if((k&255)<=(l&255)){l=a[d+39>>0]|0;k=a[e+39>>0]|0;if(l<<24>>24>=k<<24>>24)if(l<<24>>24<=k<<24>>24){k=a[d+40>>0]|0;l=a[e+40>>0]|0;if(k<<24>>24>=l<<24>>24)if(k<<24>>24<=l<<24>>24){l=a[d+41>>0]|0;k=a[e+41>>0]|0;if((l&255)>=(k&255))if((l&255)>(k&255)|j<<24>>24==0)m=0;else{j=0;while(1){k=c[d+(j<<2)>>2]|0;l=c[e+(j<<2)>>2]|0;if(k>>>0<l>>>0){m=1;break a}if(k>>>0>l>>>0){m=0;break a}l=c[d+(j<<2)+16>>2]|0;k=c[e+(j<<2)+16>>2]|0;if(l>>>0<k>>>0){m=1;break a}j=j+1|0;if(!(l>>>0<=k>>>0&(j|0)<(h|0))){m=0;break}}}else m=1}else m=0;else m=1}else m=0;else m=1}else m=0;else m=1}else m=0;else m=1}else m=0;else m=1}else m=0;else m=1;while(0);i=b;return m|0}function dte(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=c[e+4>>2]|0;j=e+4|0;do if(h){e=c[f+32>>2]|0;k=a[f+38>>0]|0;l=a[f+36>>0]|0;m=a[f+37>>0]|0;n=a[f+39>>0]|0;o=a[f+41>>0]|0;p=j;q=h;a:while(1){r=q;while(1){s=c[r+48>>2]|0;if(s>>>0>=e>>>0){if(s>>>0>e>>>0){t=r;u=r;break}s=a[r+54>>0]|0;if((s&255)>=(k&255)){if((s&255)>(k&255)){t=r;u=r;break}s=a[r+52>>0]|0;if((s&255)>=(l&255)){if((s&255)>(l&255)){t=r;u=r;break}s=a[r+53>>0]|0;if((s&255)>=(m&255)){if((s&255)>(m&255)){t=r;u=r;break}s=a[r+55>>0]|0;if(s<<24>>24>=n<<24>>24){if(s<<24>>24>n<<24>>24){t=r;u=r;break}if((d[r+57>>0]|0)>=(o&255)){t=r;u=r;break}}}}}}r=c[r+4>>2]|0;if(!r){v=p;break a}}q=c[t>>2]|0;if(!q){v=u;break}else p=u}if((v|0)!=(j|0)?(p=c[v+48>>2]|0,e>>>0>=p>>>0):0){if(e>>>0<=p>>>0){p=a[v+54>>0]|0;if((k&255)<(p&255))break;if((k&255)<=(p&255)){p=a[v+52>>0]|0;if((l&255)<(p&255))break;if((l&255)<=(p&255)){p=a[v+53>>0]|0;if((m&255)<(p&255))break;if((m&255)<=(p&255)){p=a[v+55>>0]|0;if(n<<24>>24<p<<24>>24)break;if(n<<24>>24<=p<<24>>24?(o&255)<(d[v+57>>0]|0):0)break}}}}c[b>>2]=v;i=g;return}}while(0);c[b>>2]=j;i=g;return}function ete(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=c[d+4>>2]|0;h=d+4|0;a:do if(g){d=a[e+38>>0]|0;j=a[e+36>>0]|0;k=a[e+39>>0]|0;l=a[e+40>>0]|0;m=h;n=g;b:while(1){o=n;c:while(1){p=a[o+54>>0]|0;d:do if((p&255)>=(d&255)){if((p&255)>(d&255)){q=o;r=o;break c}s=a[o+52>>0]|0;t=s&255;if((s&255)>=(j&255)){if((s&255)>(j&255)){q=o;r=o;break c}u=a[o+55>>0]|0;if(u<<24>>24>=k<<24>>24){if(u<<24>>24>k<<24>>24){q=o;r=o;break c}u=a[o+56>>0]|0;if(u<<24>>24>=l<<24>>24){if(s<<24>>24==0?1:u<<24>>24>l<<24>>24){q=o;r=o;break c}else v=0;while(1){u=c[o+(v<<2)+16>>2]|0;s=c[e+(v<<2)>>2]|0;if(u>>>0<s>>>0)break d;if(u>>>0>s>>>0){q=o;r=o;break c}s=c[o+(v<<2)+32>>2]|0;u=c[e+(v<<2)+16>>2]|0;if(s>>>0<u>>>0)break d;v=v+1|0;if(!(s>>>0<=u>>>0&(v|0)<(t|0))){q=o;r=o;break c}}}}}}while(0);o=c[o+4>>2]|0;if(!o){w=m;break b}}n=c[q>>2]|0;if(!n){w=r;break}else m=r}if((w|0)!=(h|0)?(m=a[w+54>>0]|0,(d&255)>=(m&255)):0){e:do if((d&255)<=(m&255)){n=j&255;o=a[w+52>>0]|0;if((j&255)<(o&255))break a;if((j&255)<=(o&255)){o=a[w+55>>0]|0;if(k<<24>>24<o<<24>>24)break a;if(k<<24>>24<=o<<24>>24){o=a[w+56>>0]|0;if(l<<24>>24<o<<24>>24)break a;if(!(j<<24>>24==0?1:l<<24>>24>o<<24>>24)){o=0;do{p=c[e+(o<<2)>>2]|0;t=c[w+(o<<2)+16>>2]|0;if(p>>>0<t>>>0)break a;if(p>>>0>t>>>0)break e;t=c[e+(o<<2)+16>>2]|0;p=c[w+(o<<2)+32>>2]|0;if(t>>>0<p>>>0)break a;o=o+1|0}while(t>>>0<=p>>>0&(o|0)<(n|0))}}}}while(0);c[b>>2]=w;i=f;return}}while(0);c[b>>2]=h;i=f;return}function fte(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;h=c[b+4>>2]|0;if(!h){j=b+4|0;c[e>>2]=j;k=j;i=g;return k|0}j=c[f+32>>2]|0;b=a[f+38>>0]|0;l=a[f+36>>0]|0;m=a[f+37>>0]|0;n=a[f+39>>0]|0;o=a[f+41>>0]|0;f=h;a:while(1){h=f+16|0;p=c[f+48>>2]|0;do if(j>>>0>=p>>>0){q=j>>>0>p>>>0;if(!q){r=a[h+38>>0]|0;if((b&255)<(r&255))break;if((b&255)<=(r&255)){r=a[f+52>>0]|0;if((l&255)<(r&255))break;if((l&255)<=(r&255)){r=a[h+37>>0]|0;if((m&255)<(r&255))break;if((m&255)<=(r&255)){r=a[h+39>>0]|0;if(n<<24>>24<r<<24>>24)break;if(n<<24>>24<=r<<24>>24?(o&255)<(d[h+41>>0]|0):0)break}}}if(!q?(q=a[h+38>>0]|0,(q&255)>=(b&255)):0){if((q&255)>(b&255)){s=f;t=28;break a}q=a[f+52>>0]|0;if((q&255)>=(l&255)){if((q&255)>(l&255)){s=f;t=28;break a}q=a[h+37>>0]|0;if((q&255)>=(m&255)){if((q&255)>(m&255)){s=f;t=28;break a}q=a[h+39>>0]|0;if(q<<24>>24>=n<<24>>24){if(q<<24>>24>n<<24>>24){s=f;t=28;break a}if((d[h+41>>0]|0)>=(o&255)){s=f;t=28;break a}}}}}}q=f+4|0;r=c[q>>2]|0;if(!r){u=q;v=f;t=27;break a}else{f=r;continue a}}while(0);h=c[f>>2]|0;if(!h){w=f;x=f;t=15;break}else f=h}if((t|0)==15){c[e>>2]=x;k=w;i=g;return k|0}else if((t|0)==27){c[e>>2]=v;k=u;i=g;return k|0}else if((t|0)==28){c[e>>2]=s;k=e;i=g;return k|0}return 0}function gte(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;g=c[b+4>>2]|0;if(!g){h=b+4|0;c[d>>2]=h;j=h;i=f;return j|0}h=a[e+38>>0]|0;b=a[e+36>>0]|0;k=a[e+39>>0]|0;l=a[e+40>>0]|0;m=b&255;n=b<<24>>24==0;o=g;a:while(1){g=o+16|0;p=a[g+38>>0]|0;b:do if((h&255)>=(p&255)){q=(h&255)>(p&255);c:do if(!q){r=a[o+52>>0]|0;if((b&255)<(r&255))break b;d:do if((b&255)<=(r&255)){s=a[g+39>>0]|0;if(k<<24>>24<s<<24>>24)break b;if(k<<24>>24<=s<<24>>24){s=a[o+56>>0]|0;if(l<<24>>24<s<<24>>24)break b;if(!(l<<24>>24>s<<24>>24|n)){s=0;do{t=c[e+(s<<2)>>2]|0;u=c[g+(s<<2)>>2]|0;if(t>>>0<u>>>0)break b;if(t>>>0>u>>>0)break d;u=c[e+(s<<2)+16>>2]|0;t=c[g+(s<<2)+16>>2]|0;if(u>>>0<t>>>0)break b;s=s+1|0}while(u>>>0<=t>>>0&(s|0)<(m|0))}}}while(0);if(!q?(r=a[o+52>>0]|0,s=r&255,(r&255)>=(b&255)):0){if((r&255)>(b&255)){v=o;w=30;break a}t=a[g+39>>0]|0;if(t<<24>>24>=k<<24>>24){if(t<<24>>24>k<<24>>24){v=o;w=30;break a}t=a[o+56>>0]|0;if(t<<24>>24>=l<<24>>24){if(r<<24>>24==0?1:t<<24>>24>l<<24>>24){v=o;w=30;break a}else x=0;while(1){t=c[g+(x<<2)>>2]|0;r=c[e+(x<<2)>>2]|0;if(t>>>0<r>>>0)break c;if(t>>>0>r>>>0){v=o;w=30;break a}r=c[g+(x<<2)+16>>2]|0;t=c[e+(x<<2)+16>>2]|0;if(r>>>0<t>>>0)break c;x=x+1|0;if(!(r>>>0<=t>>>0&(x|0)<(s|0))){v=o;w=30;break a}}}}}}while(0);q=o+4|0;s=c[q>>2]|0;if(!s){y=q;z=o;w=29;break a}else{o=s;continue a}}while(0);g=c[o>>2]|0;if(!g){A=o;B=o;w=16;break}else o=g}if((w|0)==16){c[d>>2]=B;j=A;i=f;return j|0}else if((w|0)==29){c[d>>2]=z;j=y;i=f;return j|0}else if((w|0)==30){c[d>>2]=v;j=d;i=f;return j|0}return 0}function hte(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=a+4|0;g=c[f>>2]|0;do if(g){h=a+8|0;j=g;while(1){k=j+16|0;if(cte(h,b,k)|0){l=c[j>>2]|0;if(!l){m=j;n=j;o=5;break}else{j=l;continue}}if(!(cte(h,k,b)|0)){p=j;o=9;break}k=j+4|0;l=c[k>>2]|0;if(!l){q=k;r=j;o=8;break}else j=l}if((o|0)==5){c[e>>2]=n;s=m;t=n;break}else if((o|0)==8){c[e>>2]=r;s=q;t=r;break}else if((o|0)==9){c[e>>2]=p;s=e;t=p;break}}else{j=a+4|0;c[e>>2]=j;s=j;t=j}while(0);e=c[s>>2]|0;if(e){u=e;v=u+60|0;i=d;return v|0}e=xCi(64)|0;p=e+16|0;o=b+0|0;b=p+44|0;do{c[p>>2]=c[o>>2];p=p+4|0;o=o+4|0}while((p|0)<(b|0));c[e+60>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=t;c[s>>2]=e;t=c[c[a>>2]>>2]|0;if(!t)w=e;else{c[a>>2]=t;w=c[s>>2]|0}GN(c[f>>2]|0,w);w=a+8|0;c[w>>2]=(c[w>>2]|0)+1;u=e;v=u+60|0;i=d;return v|0}function ite(a,b){a=a|0;b=b|0;return}function jte(a){a=a|0;return 0}function kte(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=1066608;f=c[a+24>>2]|0;if(f)Nte(f);if((c[a+44>>2]|0)<=-1){i=b;return}f=a+32|0;g=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function lte(a){a=a|0;var b=0;b=i;kte(a);ACi(a);i=b;return}function mte(a){a=a|0;return 0}function nte(a){a=a|0;return}function ote(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[a>>2]=1066632;f=c[a+24>>2]|0;if(f)Nte(f);if((c[a+44>>2]|0)<=-1){i=b;return}f=a+32|0;g=c[f>>2]|0;c[e>>2]=c[a+36>>2];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[f>>2]=0;i=b;return}function pte(a){a=a|0;var b=0;b=i;ote(a);ACi(a);i=b;return}function qte(a){a=a|0;return c[a+4>>2]|0}function rte(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1066656;d=c[a+8>>2]|0;if(!d){i=b;return}ko[c[(c[d>>2]|0)+4>>2]&4095](d);i=b;return}function ste(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1066656;d=c[a+8>>2]|0;if(!d){ACi(a);i=b;return}ko[c[(c[d>>2]|0)+4>>2]&4095](d);ACi(a);i=b;return}function tte(a){a=a|0;var b=0;b=i;c[a>>2]=1066688;wrc(a+4|0,c[a+8>>2]|0);i=b;return}function ute(a){a=a|0;var b=0;b=i;c[a>>2]=1066688;wrc(a+4|0,c[a+8>>2]|0);ACi(a);i=b;return}function vte(a){a=a|0;var b=0;b=i;c[a>>2]=1066688;wrc(a+4|0,c[a+8>>2]|0);ACi(a);i=b;return}function wte(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=c[153080];c[e+0>>2]=c[f+0>>2];f=bOb(36,e,0,16,3653512,44)|0;c[f>>2]=1066736;e=f+4|0;g=e+0|0;h=g+32|0;do{a[g>>0]=0;g=g+1|0}while((g|0)<(h|0));c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];c[e+20>>2]=c[d+20>>2];c[e+24>>2]=c[d+24>>2];c[e+28>>2]=c[d+28>>2];i=b;return f|0}function xte(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[153080]|0;if(b)ko[c[c[b>>2]>>2]&4095](b);c[e>>2]=f;c[d+0>>2]=c[e+0>>2];eOb(b,d);i=a;return}function yte(a){a=a|0;return}function zte(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Ate(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Ate(a,c[b>>2]|0);Ate(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Bte(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Bte(a,c[b>>2]|0);Bte(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Cte(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Cte(a,c[b>>2]|0);Cte(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Dte(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Dte(a,c[b>>2]|0);Dte(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Ete(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;vqe(a);d=c[a+12>>2]|0;if(d){e=a+16|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~(((f+-12-d|0)>>>0)/12|0)*12|0);ACi(d)}d=c[a>>2]|0;if(!d){i=b;return}f=a+4|0;a=c[f>>2]|0;if((a|0)!=(d|0))c[f>>2]=a+(~((a+-4-d|0)>>>2)<<2);ACi(d);i=b;return}function Fte(a){a=a|0;g[a>>2]=ea(-1.0);g[a+4>>2]=ea(-1.0);g[a+8>>2]=ea(-1.0);g[a+12>>2]=ea(-1.0);g[a+32>>2]=ea(1.0e6);c[a+36>>2]=-1;c[a+44>>2]=-1;c[a+40>>2]=-1;c[a+48>>2]=0;return}function Gte(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=b+1980|0;if((c[f>>2]|0)!=(d|0)){ko[c[1064952+360>>2]&4095](d);c[f>>2]=d;f=b+192|0;c[f>>2]=c[f>>2]|7;i=e;return}if(!(a[(c[267510]|0)+80>>0]|0)){i=e;return}ko[c[1064952+360>>2]&4095](0);ko[c[1064952+360>>2]&4095](d);i=e;return}function Hte(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=i;h=f+0|0;j=h+44|0;do{c[h>>2]=-1;h=h+4|0}while((h|0)<(j|0));h=f+38|0;a[h>>0]=0;j=f+41|0;k=a[b+2225>>0]|0;a[j>>0]=k;do if(k<<24>>24){a[f+37>>0]=c[b+2024>>2];l=c[b+2024>>2]|0;if((l|0)>0){m=f+32|0;n=-1;o=0;p=1;while(1){q=c[b+(o<<2)+1992>>2]|0;r=p&(q|0)==1;s=o<<2;t=n&~(15<<s)|q<<s;o=o+1|0;if((o|0)==(l|0)){u=r;v=t;break}else{n=t;p=r}}c[m>>2]=v;w=u}else w=1;p=k&255;n=w?p|4:p;p=(a[b+2226>>0]|0)!=0?n|2:n;n=p&255;a[j>>0]=n;l=d[b+2224>>0]|0;if(!l){x=n;break}else if((l|0)==1){n=(p|32)&255;a[j>>0]=n;x=n;break}else if((l|0)==2){l=(p|16)&255;a[j>>0]=l;x=l;break}else{Krd(1066744,0,3653512,85,1,0,0,0);x=a[j>>0]|0;break}}else{a[f+37>>0]=0;x=0}while(0);w=x&255;a[j>>0]=(a[b+2227>>0]|0)==0?w|8:w&247;w=c[b+1948>>2]|0;j=w>>>0>4?4:w&255;a[f+36>>0]=j;w=j&255;if(!(j<<24>>24)){y=c[e>>2]|0;z=y&255;A=f+39|0;B=(y|0)==-1;C=B?0:z;a[A>>0]=C;D=b+2120|0;E=c[D>>2]|0;F=E+10|0;G=a[F>>0]|0;H=c[267510]|0;I=H+87|0;J=a[I>>0]|0;K=J<<24>>24!=0;L=G<<24>>24==-1;M=K|L;N=G<<24>>24==0;O=M|N;P=G<<24>>24==8;Q=O|P;R=Q?0:G;S=f+40|0;a[S>>0]=R;i=g;return}else T=0;do{a[h>>0]=d[h>>0]&(1<<T^255)|((c[b+(T*52|0)+332>>2]|0)==4&1)<<T;c[f+(T<<2)>>2]=c[b+(T*52|0)+324>>2];c[f+(T<<2)+16>>2]=c[b+(T*52|0)+328>>2];T=T+1|0}while((T|0)<(w|0));y=c[e>>2]|0;z=y&255;A=f+39|0;B=(y|0)==-1;C=B?0:z;a[A>>0]=C;D=b+2120|0;E=c[D>>2]|0;F=E+10|0;G=a[F>>0]|0;H=c[267510]|0;I=H+87|0;J=a[I>>0]|0;K=J<<24>>24!=0;L=G<<24>>24==-1;M=K|L;N=G<<24>>24==0;O=M|N;P=G<<24>>24==8;Q=O|P;R=Q?0:G;S=f+40|0;a[S>>0]=R;i=g;return}function Ite(a,b){a=a|0;b=b|0;var d=0;d=i;ko[c[1064952>>2]&4095](b+33984|0);c[a+1952>>2]=b;i=d;return}function Jte(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+8|0;h=f;c[h>>2]=c[b>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(g,586880,h);b=c[g>>2]|0;j=c[146727]|0;if((b|0)==-1){k=c[146728]|0;l=j;m=k;n=j+(k<<3)|0;break}else{l=j;m=c[146728]|0;n=j+(b<<3)|0;break}}else{b=c[146727]|0;j=c[146728]|0;l=b;m=j;n=b+(j<<3)|0}while(0);if((n|0)==(l+(m<<3)|0))o=0;else o=c[n+4>>2]|0;n=a+1952|0;if((c[n>>2]|0)!=(e|0)){ko[c[1064952>>2]&4095](e+33984|0);c[n>>2]=e}n=a+1948|0;if((c[n>>2]|0)>>>0>e>>>0){if((o|0)==(c[a+(e*52|0)+320>>2]|0)){i=f;return}}else c[n>>2]=e+1;In[c[1064952+24>>2]&4095](c[1074576+(d<<2)>>2]|0,o);c[a+(e*52|0)+320>>2]=o;c[a+(e*52|0)+332>>2]=d;i=f;return}function Kte(b){b=b|0;var d=0,e=0,f=0,h=0,j=0;d=i;i=i+48|0;e=d+24|0;f=d+12|0;h=d;c[b+2112>>2]=c[b+2176>>2];ko[c[1064952+120>>2]&4095](512);ko[c[1064952+128>>2]&4095](2929);ko[c[1064952+124>>2]&4095](0);c[e>>2]=15;a[e+4>>0]=1;a[e+5>>0]=0;a[e+6>>0]=1;j=e+7|0;a[j+0>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=0;a[j+4>>0]=0;c[b+2120>>2]=Nqe(b,e)|0;Dn[c[1064952+64>>2]&511](1,1,1,1);ko[c[1064952+128>>2]&4095](3042);Dn[c[1064952+32>>2]&511](1,0,1,0);In[c[1064952+28>>2]&4095](32774,32774);if(a[(c[267510]|0)+87>>0]|0)ko[c[1064952+128>>2]&4095](3008);a[f>>0]=0;a[f+1>>0]=-1;a[f+2>>0]=-1;a[f+4>>0]=8;a[f+5>>0]=0;a[f+6>>0]=0;a[f+7>>0]=0;a[f+8>>0]=8;a[f+9>>0]=0;a[f+10>>0]=0;a[f+11>>0]=0;c[b+2116>>2]=Qqe(b,f)|0;ko[c[1064952+128>>2]&4095](2960);Dn[c[1064952+288>>2]&511](1028,519,0,255);Dn[c[1064952+300>>2]&511](1028,7680,7680,7680);Dn[c[1064952+288>>2]&511](1029,519,0,255);Dn[c[1064952+300>>2]&511](1029,7680,7680,7680);ko[c[1064952+292>>2]&4095](255);f=h;c[f>>2]=0;c[f+4>>2]=0;c[h>>2]=2;c[h+4>>2]=0;g[h+8>>2]=ea(0.0);c[b+2124>>2]=Sqe(b,h)|0;ko[c[1064952+92>>2]&4095](1029);ko[c[1064952+144>>2]&4095](2884);ko[c[1064952+128>>2]&4095](32823);a[b+2230>>0]=0;ko[c[1064952+128>>2]&4095](3089);i=d;return}function Lte(b){b=b|0;var d=0,e=0;d=i;e=0;do{g[b+(e*52|0)+284>>2]=ea(-1.0);g[b+(e*52|0)+288>>2]=ea(-1.0);g[b+(e*52|0)+292>>2]=ea(-1.0);g[b+(e*52|0)+296>>2]=ea(-1.0);g[b+(e*52|0)+316>>2]=ea(1.0e6);c[b+(e*52|0)+320>>2]=-1;c[b+(e*52|0)+328>>2]=-1;c[b+(e*52|0)+324>>2]=-1;c[b+(e*52|0)+332>>2]=0;e=e+1|0}while((e|0)!=32);e=b+1948|0;c[b+1980>>2]=0;c[b+1972>>2]=0;c[b+2024>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[b+1992>>2]=1;c[b+1996>>2]=1;c[b+2e3>>2]=1;c[b+2004>>2]=1;c[b+2008>>2]=1;c[b+2012>>2]=1;c[b+2016>>2]=1;c[b+2020>>2]=1;g[b+2028>>2]=ea(-1.0);g[b+2032>>2]=ea(-1.0);g[b+2036>>2]=ea(-1.0);g[b+2040>>2]=ea(-1.0);g[b+2044>>2]=ea(-1.0);g[b+2048>>2]=ea(-1.0);g[b+2052>>2]=ea(-1.0);g[b+2056>>2]=ea(-1.0);g[b+2060>>2]=ea(-1.0);g[b+2064>>2]=ea(-1.0);g[b+2068>>2]=ea(-1.0);g[b+2072>>2]=ea(-1.0);g[b+2076>>2]=ea(-1.0);g[b+2080>>2]=ea(-1.0);g[b+2084>>2]=ea(-1.0);g[b+2088>>2]=ea(-1.0);g[b+2092>>2]=ea(-1.0);g[b+2096>>2]=ea(-1.0);g[b+2100>>2]=ea(-1.0);g[b+2104>>2]=ea(-1.0);g[b+2108>>2]=ea(-1.0);a[b+2224>>0]=-1;a[b+2225>>0]=0;a[b+2226>>0]=0;a[b+2227>>0]=1;g[b+2216>>2]=ea(-1.0);c[b+2220>>2]=-1;a[b+2228>>0]=-1;a[b+2229>>0]=0;Kte(b);i=d;return}function Mte(a){a=a|0;return ((c[c[a>>2]>>2]|0)-(c[a+36>>2]|0)|0)>>>0<2|0}function Nte(a){a=a|0;var b=0;b=i;Ote(c[a>>2]|0,a);i=b;return}function Ote(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(((c[c[b>>2]>>2]|0)-(c[b+36>>2]|0)|0)>>>0<2){f=a+8|0;g=c[f>>2]|0;if((g|0)==(c[a+12>>2]|0)){aue(a+4|0,e);i=d;return}if(!g)h=0;else{c[g>>2]=b;h=c[f>>2]|0}c[f>>2]=h+4;i=d;return}h=c[b+12>>2]|0;f=c[b+8>>2]|0;g=b;b=a+(h*12|0)+20|0;e=c[b>>2]|0;if(!e){j=a+(h*12|0)+20|0;k=j;l=j}else{j=e;while(1)if((f|0)<(c[j+16>>2]|0)){e=c[j>>2]|0;if(!e){k=j;l=j;break}else{j=e;continue}}else{e=j+4|0;m=c[e>>2]|0;if(!m){k=e;l=j;break}else{j=m;continue}}}j=xCi(24)|0;m=j+16|0;c[m>>2]=f;c[m+4>>2]=g;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=l;c[k>>2]=j;l=a+(h*12|0)+16|0;g=c[c[l>>2]>>2]|0;if(!g)n=j;else{c[l>>2]=g;n=c[k>>2]|0}GN(c[b>>2]|0,n);n=a+(h*12|0)+24|0;c[n>>2]=(c[n>>2]|0)+1;i=d;return}function Pte(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+24|0;if((a[f>>0]|0)!=0?(c[b+8>>2]|0)>=(d|0):0){i=e;return}g=b+16|0;In[c[1064952+12>>2]&4095](c[g>>2]|0,c[b+4>>2]|0);Dn[c[1064952+36>>2]&511](c[g>>2]|0,d,0,c[b+20>>2]|0);if(a[621283]|0)In[c[1064952+12>>2]&4095](c[g>>2]|0,0);c[b+8>>2]=d;c[b+28>>2]=c[c[b>>2]>>2];a[f>>0]=1;i=e;return}function Qte(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;h=b+24|0;do if(!(a[h>>0]|0)){j=b+8|0;k=c[j>>2]|0;if(!((d|0)==0&(k|0)==(e|0))){l=b+16|0;In[c[1064952+12>>2]&4095](c[l>>2]|0,c[b+4>>2]|0);Dn[c[1064952+36>>2]&511](c[l>>2]|0,k,0,c[b+20>>2]|0);if(a[621283]|0)In[c[1064952+12>>2]&4095](c[l>>2]|0,0);c[b+8>>2]=k;c[b+28>>2]=c[c[b>>2]>>2];a[h>>0]=1;break}k=b+16|0;In[c[1064952+12>>2]&4095](c[k>>2]|0,c[b+4>>2]|0);Dn[c[1064952+36>>2]&511](c[k>>2]|0,e,f,c[b+20>>2]|0);if(a[621283]|0)In[c[1064952+12>>2]&4095](c[k>>2]|0,0);c[j>>2]=e;c[b+28>>2]=c[c[b>>2]>>2];a[h>>0]=1;i=g;return}while(0);if((f|0)!=0?(h=b+16|0,In[c[1064952+12>>2]&4095](c[h>>2]|0,c[b+4>>2]|0),Dn[c[1064952+40>>2]&511](c[h>>2]|0,d,e,f),(a[621283]|0)!=0):0)In[c[1064952+12>>2]&4095](c[h>>2]|0,0);c[b+32>>2]=c[c[b>>2]>>2];i=g;return}function Rte(a){a=a|0;c[a+32>>2]=c[c[a>>2]>>2];return}function Ste(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=b+24|0;if(!(a[h>>0]|0)){j=b+8|0;k=c[j>>2]|0;l=b+16|0;m=b+4|0;In[c[1064952+12>>2]&4095](c[l>>2]|0,c[m>>2]|0);Dn[c[1064952+36>>2]&511](c[l>>2]|0,k,0,c[b+20>>2]|0);if(a[621283]|0)In[c[1064952+12>>2]&4095](c[l>>2]|0,0);c[j>>2]=k;c[b+28>>2]=c[c[b>>2]>>2];a[h>>0]=1;n=m;o=l}else{n=b+4|0;o=b+16|0}In[c[1064952+12>>2]&4095](c[o>>2]|0,c[n>>2]|0);n=kn[c[1064952+428>>2]&511](c[o>>2]|0,d,e,f)|0;if(!(a[621283]|0)){i=g;return n|0}In[c[1064952+12>>2]&4095](c[o>>2]|0,0);i=g;return n|0}function Tte(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!(a[621279]|0)){i=f;return}g=b+16|0;In[c[1064952+12>>2]&4095](c[g>>2]|0,c[b+4>>2]|0);co[c[1064952+432>>2]&2047](c[g>>2]|0,d,e);if(!(a[621283]|0)){i=f;return}In[c[1064952+12>>2]&4095](c[g>>2]|0,0);i=f;return}function Ute(b){b=b|0;var d=0,e=0;d=i;e=b+16|0;In[c[1064952+12>>2]&4095](c[e>>2]|0,c[b+4>>2]|0);mo[c[1064952+412>>2]&4095](c[e>>2]|0)|0;if(a[621283]|0)In[c[1064952+12>>2]&4095](c[e>>2]|0,0);c[b+32>>2]=c[c[b>>2]>>2];i=d;return}function Vte(a){a=a|0;c[a+36>>2]=c[c[a>>2]>>2];return}function Wte(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f;h=f+4|0;j=c[b+(e*12|0)+20>>2]|0;k=b+(e*12|0)+20|0;if(j){l=k;m=j;a:while(1){n=m;while(1){if((c[n+16>>2]|0)>=(d|0)){o=n;break}n=c[n+4>>2]|0;if(!n){p=l;break a}}m=c[o>>2]|0;if(!m){p=o;break}else l=o}if((p|0)!=(k|0)?(c[p+16>>2]|0)<(d<<1|0):0){k=c[p+20>>2]|0;o=c[p+4>>2]|0;if(!o){l=p;while(1){m=c[l+8>>2]|0;if((c[m>>2]|0)==(l|0)){q=m;break}else l=m}}else{l=o;while(1){o=c[l>>2]|0;if(!o){q=l;break}else l=o}}l=b+(e*12|0)+16|0;if((c[l>>2]|0)==(p|0))c[l>>2]=q;q=b+(e*12|0)+24|0;c[q>>2]=(c[q>>2]|0)+-1;tYb(j,p);ACi(p);r=k;i=f;return r|0}}c[h>>2]=c[153080];c[g+0>>2]=c[h+0>>2];h=bOb(40,g,0,16,3653512,291)|0;c[h>>2]=b;b=h+4|0;c[b>>2]=0;c[h+8>>2]=d;c[h+12>>2]=e;d=h+16|0;switch(e|0){case 1:case 0:{s=34962;t=20;break}case 2:{c[d>>2]=35982;u=35046;v=h+20|0;break}case 4:case 3:{s=34963;t=20;break}case 6:case 5:{s=35345;t=20;break}default:{c[g>>2]=e;Ird(1066824,g);s=36663;t=20}}b:do if((t|0)==20){c[d>>2]=s;k=h+20|0;switch(e|0){case 6:case 4:case 1:{u=35048;v=k;break b;break}case 5:case 3:case 0:{u=35044;v=k;break b;break}default:{c[g>>2]=e;Ird(1066784,g);u=35048;v=k;break b}}}while(0);c[v>>2]=u;a[h+24>>0]=0;c[h+28>>2]=0;c[h+32>>2]=0;c[h+36>>2]=0;In[c[1064952+172>>2]&4095](1,b);r=h;i=f;return r|0}function Xte(a){a=a|0;var b=0;b=i;c[a>>2]=(c[a>>2]|0)+1;Yte(a);if(((c[a>>2]|0)>>>0)%10|0){i=b;return}Zte(a);i=b;return}function Yte(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;d=a+8|0;e=c[d>>2]|0;f=a+4|0;g=c[f>>2]|0;h=e-g|0;if((h|0)<=0){i=b;return}j=h>>2;h=g;g=e;e=0;a:while(1){k=e+1|0;l=h;m=j;n=g;while(1){o=l+(e<<2)|0;p=c[o>>2]|0;if(((c[c[p>>2]>>2]|0)-(c[p+36>>2]|0)|0)>>>0<2){q=l;r=n;break}if((k|0)==(m|0))s=n;else{t=n+-4|0;c[o>>2]=c[t>>2];c[t>>2]=p;s=c[d>>2]|0}c[d>>2]=s+-4;t=c[p+12>>2]|0;o=c[p+8>>2]|0;u=p;p=a+(t*12|0)+20|0;v=c[p>>2]|0;if(!v){w=a+(t*12|0)+20|0;x=w;y=w}else{w=v;while(1)if((o|0)<(c[w+16>>2]|0)){v=c[w>>2]|0;if(!v){x=w;y=w;break}else{w=v;continue}}else{v=w+4|0;z=c[v>>2]|0;if(!z){x=v;y=w;break}else{w=z;continue}}}w=xCi(24)|0;z=w+16|0;c[z>>2]=o;c[z+4>>2]=u;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=y;c[x>>2]=w;z=a+(t*12|0)+16|0;v=c[c[z>>2]>>2]|0;if(!v)A=w;else{c[z>>2]=v;A=c[x>>2]|0}GN(c[p>>2]|0,A);v=a+(t*12|0)+24|0;c[v>>2]=(c[v>>2]|0)+1;n=c[d>>2]|0;l=c[f>>2]|0;m=n-l>>2;if((e|0)>=(m|0)){B=16;break a}}m=r-q>>2;if((k|0)<(m|0)){j=m;h=q;g=r;e=k}else{B=16;break}}if((B|0)==16){i=b;return}}function Zte(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;i=i+16|0;d=b+4|0;e=b;f=0;do{g=a+(f*12|0)+16|0;h=c[g>>2]|0;j=a+(f*12|0)+20|0;if((h|0)!=(j|0)){k=a+(f*12|0)+24|0;l=a+(f*12|0)+20|0;m=h;while(1){h=c[m+20>>2]|0;n=ea(((c[c[h>>2]>>2]|0)-(c[h+36>>2]|0)|0)>>>0);o=ea(ea(c[h+8>>2]|0)*ea(.000166666665));p=o<ea(50.0);q=!(ea(n+(p?o:ea(50.0)))>=ea(59.0));p=c[m+4>>2]|0;r=(p|0)==0;if(q){if(r){q=m;while(1){s=c[q+8>>2]|0;if((c[s>>2]|0)==(q|0)){t=s;break}else q=s}}else{q=p;while(1){s=c[q>>2]|0;if(!s){t=q;break}else q=s}}if((t|0)==(j|0))break;else{m=t;continue}}if(r){q=m;while(1){s=c[q+8>>2]|0;if((c[s>>2]|0)==(q|0)){u=s;break}else q=s}}else{q=p;while(1){s=c[q>>2]|0;if(!s){u=q;break}else q=s}}if(r){q=m;while(1){s=c[q+8>>2]|0;if((c[s>>2]|0)==(q|0)){v=s;break}else q=s}}else{q=p;while(1){r=c[q>>2]|0;if(!r){v=q;break}else q=r}}if((c[g>>2]|0)==(m|0))c[g>>2]=v;c[k>>2]=(c[k>>2]|0)+-1;tYb(c[l>>2]|0,m);ACi(m);q=c[153080]|0;if((h|0)!=0?(p=h+4|0,(c[p>>2]|0)!=0):0)In[c[1064952+96>>2]&4095](1,p);c[e>>2]=q;c[d+0>>2]=c[e+0>>2];eOb(h,d);if((u|0)==(j|0))break;else m=u}}f=f+1|0}while((f|0)!=7);i=b;return}function _te(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+4|0;g=c[f>>2]|0;h=a+8|0;if((g|0)!=(c[h>>2]|0)){j=g;while(1){g=c[j>>2]|0;c[g+4>>2]=0;c[e>>2]=c[153080];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[j>>2]=0;g=j+4|0;if((g|0)==(c[h>>2]|0)){k=j;l=g;break}else j=g}j=c[f>>2]|0;if((l|0)!=(j|0))c[h>>2]=k+(0-((k-j|0)>>>2)<<2)}j=0;do{k=a+(j*12|0)+16|0;h=c[k>>2]|0;l=a+(j*12|0)+20|0;if((h|0)!=(l|0)){f=h;while(1){h=f+20|0;g=c[h>>2]|0;c[g+4>>2]=0;c[e>>2]=c[153080];c[d+0>>2]=c[e+0>>2];eOb(g,d);c[h>>2]=0;h=c[f+4>>2]|0;if(!h){g=f;while(1){m=c[g+8>>2]|0;if((c[m>>2]|0)==(g|0)){n=m;break}else g=m}}else{g=h;while(1){m=c[g>>2]|0;if(!m){n=g;break}else g=m}}if((n|0)==(l|0))break;else f=n}}bue(k,c[a+(j*12|0)+20>>2]|0);c[a+(j*12|0)+24>>2]=0;c[k>>2]=l;c[l>>2]=0;j=j+1|0}while((j|0)!=7);i=b;return}function $te(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[266718]|0;if(e){f=e;i=a;return f|0}c[d>>2]=c[153080];c[b+0>>2]=c[d+0>>2];d=bOb(100,b,0,16,3653512,450)|0;b=d+20|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[b>>2]=0;c[d+24>>2]=0;c[d+16>>2]=b;b=d+32|0;c[b>>2]=0;c[d+36>>2]=0;c[d+28>>2]=b;b=d+44|0;c[b>>2]=0;c[d+48>>2]=0;c[d+40>>2]=b;b=d+56|0;c[b>>2]=0;c[d+60>>2]=0;c[d+52>>2]=b;b=d+68|0;c[b>>2]=0;c[d+72>>2]=0;c[d+64>>2]=b;b=d+80|0;c[b>>2]=0;c[d+84>>2]=0;c[d+76>>2]=b;b=d+92|0;c[b>>2]=0;c[d+96>>2]=0;c[d+88>>2]=b;c[266718]=d;f=d;i=a;return f|0}function aue(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=a+4|0;f=c[a>>2]|0;g=((c[e>>2]|0)-f>>2)+1|0;if(g>>>0>1073741823)vxi(a);h=a+8|0;j=f;k=(c[h>>2]|0)-j|0;if(k>>2>>>0<536870911){l=k>>1;k=l>>>0<g>>>0?g:l;l=(c[e>>2]|0)-j|0;g=l>>2;if(!k){m=0;n=0;o=g;p=l}else{q=k;r=g;s=l;t=6}}else{l=(c[e>>2]|0)-j|0;q=1073741823;r=l>>2;s=l;t=6}if((t|0)==6){m=q;n=xCi(q<<2)|0;o=r;p=s}s=n+(o<<2)|0;if(s)c[s>>2]=c[b>>2];YEi(n|0,f|0,p|0)|0;c[a>>2]=n;c[e>>2]=n+(o+1<<2);c[h>>2]=n+(m<<2);if(!f){i=d;return}ACi(f);i=d;return}function bue(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{bue(a,c[b>>2]|0);bue(a,c[b+4>>2]|0);ACi(b);i=d;return}}function cue(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=d+4|0;c[h>>2]=0;c[d+8>>2]=e;c[d+12>>2]=f;c[d+16>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[d+20>>2]=60;c[d+32>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;c[d+36>>2]=60;f=d+48|0;c[d+68>>2]=0;c[d+72>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[d+64>>2]=60;c[d+76>>2]=0;c[d+80>>2]=0;c[d+84>>2]=0;c[d+88>>2]=-1;b[d+92>>1]=0;b[d+94>>1]=0;c[d+96>>2]=0;c[d+100>>2]=-1;b[d+104>>1]=0;b[d+106>>1]=0;c[d+108>>2]=0;c[d+112>>2]=-1;b[d+116>>1]=0;b[d+118>>1]=0;c[d+120>>2]=0;c[d+124>>2]=-1;b[d+128>>1]=0;b[d+130>>1]=0;c[d+132>>2]=0;c[d+136>>2]=-1;b[d+140>>1]=0;b[d+142>>1]=0;c[d+144>>2]=0;c[d+148>>2]=-1;b[d+152>>1]=0;b[d+154>>1]=0;c[d+156>>2]=0;c[d+160>>2]=-1;f=d+164|0;b[f+0>>1]=0;b[f+2>>1]=0;b[f+4>>1]=0;b[f+6>>1]=0;b[f+8>>1]=0;b[f+10>>1]=0;b[f+12>>1]=0;b[f+14>>1]=0;f=due(d,0,0)|0;c[h>>2]=f;if(!(a[(c[267510]|0)+68>>0]|0)){i=g;return}Dn[c[1064904+8>>2]&511](35648,f,0,1066880);i=g;return}function due(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;d=e;f=e+16|0;g=e+4|0;h=Jo[c[1064952+84>>2]&127]()|0;j=0;do{k=c[1068952+(j<<2)>>2]|0;if((k|0)<(c[155300]|0)&(k|0)>-1)co[c[1064952+8>>2]&2047](h,k,c[1068904+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=12);In[c[1064952+4>>2]&4095](h,c[b+8>>2]|0);In[c[1064952+4>>2]&4095](h,c[b+12>>2]|0);ko[c[1064952+256>>2]&4095](h);c[f>>2]=0;co[c[1064952+216>>2]&2047](h,35714,f);if(!(c[f>>2]|0)){Eue(h,0,0)|0;ko[c[1064952+104>>2]&4095](h);l=0;i=e;return l|0}Gte(c[266694]|0,h);f=b+16|0;Que(h,f,0,0);j=g+1|0;k=g+8|0;m=0;do{c[d>>2]=m;Lsd(g,1066896,d);n=_n[c[1064952+240>>2]&4095](h,(a[g>>0]&1)==0?j:c[k>>2]|0)|0;if((n|0)!=-1)In[c[1064952+320>>2]&4095](n,m);xri(g);m=m+1|0}while((m|0)<4);m=b+76|0;g=(c[b+80>>2]|0)-(c[m>>2]|0)|0;k=(g|0)/28|0;if((g|0)>0){g=0;do{j=Bnc()|0;d=c[m>>2]|0;co[c[(c[j>>2]|0)+244>>2]&2047](j,c[d+(g*28|0)>>2]|0,c[d+(g*28|0)+20>>2]|0);g=g+1|0}while((g|0)<(k|0))}_ve(b,f,-1,-1);l=h;i=e;return l|0}function eue(a){a=a|0;var b=0,d=0;b=i;d=c[a+4>>2]|0;if(d)ko[c[1064952+104>>2]&4095](d);hrc(a+16|0);i=b;return}function fue(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Gte(c[266694]|0,c[b+4>>2]|0);if(a[(c[267510]|0)+65>>0]|0)yqe(e);Rue(b,b+16|0,d,0);i=f;return}function gue(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;g=f;c[266804]=0;c[266805]=0;c[266806]=0;c[266807]=0;c[266808]=0;c[266809]=0;c[266807]=1;a[1067238]=1;a[1067239]=1;c[266814]=0;c[266815]=0;c[266816]=0;c[266817]=0;c[266818]=0;c[266819]=0;c[266817]=1;a[1067278]=0;a[1067279]=1;h=1067056|0;j=h+72|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));c[266764]=1067216;c[266772]=1067256;c[266773]=1;c[266774]=0;c[266775]=-1;k=vue(1067296,g,1067056)|0;l=c[k>>2]|0;if(!l){m=xCi(92)|0;h=m+16|0;n=1067056|0;j=h+72|0;do{c[h>>2]=c[n>>2];h=h+4|0;n=n+4|0}while((h|0)<(j|0));c[m+88>>2]=0;o=c[g>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=o;c[k>>2]=m;o=c[c[266824]>>2]|0;if(!o)p=m;else{c[266824]=o;p=c[k>>2]|0}GN(c[266825]|0,p);c[266826]=(c[266826]|0)+1;q=m}else q=l;c[q+88>>2]=0;h=1066984|0;n=1067056|0;j=h+68|0;do{c[h>>2]=c[n>>2];h=h+4|0;n=n+4|0}while((h|0)<(j|0));b[533526]=b[533562]|0;h=1066912|0;n=1067056|0;j=h+68|0;do{c[h>>2]=c[n>>2];h=h+4|0;n=n+4|0}while((h|0)<(j|0));b[533490]=b[533562]|0;if(d)c[d>>2]=1067216;if(!e){i=f;return}c[e>>2]=1067256;i=f;return}function hue(){return}function iue(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=i;i=i+384|0;e=d+104|0;f=d;g=d+128|0;h=d+256|0;j=d+80|0;k=d+120|0;l=d+92|0;m=d+124|0;n=d+112|0;o=d+116|0;p=d+100|0;q=d+84|0;r=d+96|0;s=d+88|0;wue(r,1067296,b);t=c[r>>2]|0;if((t|0)!=1067300){u=t;v=u+88|0;w=c[v>>2]|0;i=d;return w|0}c[s>>2]=0;In[c[1064952+180>>2]&4095](1,s);t=c[s>>2]|0;c[k>>2]=0;In[c[1064952+212>>2]&4095](36006,k);In[c[1064952+16>>2]&4095](36160,t);x=b+36|0;y=c[x>>2]|0;if((y|0)>0){z=b+40|0;A=b+44|0;B=0;do{C=B+36064|0;D=c[b+(B<<2)>>2]|0;c[j>>2]=c[D>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(e,586880,j);E=c[e>>2]|0;F=c[146727]|0;if((E|0)==-1){G=c[146728]|0;H=F;I=G;J=F+(G<<3)|0;break}else{H=F;I=c[146728]|0;J=F+(E<<3)|0;break}}else{E=c[146727]|0;F=c[146728]|0;H=E;I=F;J=E+(F<<3)|0}while(0);do if(((J|0)!=(H+(I<<3)|0)?(F=c[J+4>>2]|0,(F|0)!=0):0)?(c[D+28>>2]|0)!=0:0){E=c[z>>2]|0;if(!(a[(c[267510]|0)+96>>0]|0)){Krd(1067416,0,3653512,499,512,0,0,0);K=0}else K=E;if((c[D+32>>2]|0)==4){E=c[A>>2]|0;if((E|0)<0)L=34069;else L=(E|0)>5?34074:E+34069|0;En[c[1064952+164>>2]&127](36160,C,L,F,K);break}E=c[D+12>>2]|0;if(E>>>0>1?(a[(c[267510]|0)+93>>0]|0)!=0:0){rn[c[1064904+16>>2]&127](36160,C,3553,F,K,E);break}En[c[1064952+164>>2]&127](36160,C,3553,F,K)}else M=22;while(0);if((M|0)==22){M=0;Dn[c[1064952+160>>2]&511](36160,C,36161,c[D+24>>2]|0)}B=B+1|0}while((B|0)!=(y|0))}y=b+32|0;B=c[y>>2]|0;do if(B){c[f>>2]=c[B>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(e,586880,f);M=c[e>>2]|0;K=c[146727]|0;if((M|0)==-1){L=c[146728]|0;N=K;O=L;P=K+(L<<3)|0;break}else{N=K;O=c[146728]|0;P=K+(M<<3)|0;break}}else{M=c[146727]|0;K=c[146728]|0;N=M;O=K;P=M+(K<<3)|0}while(0);if((P|0)==(N+(O<<3)|0))Q=0;else Q=c[P+4>>2]|0;D=(Q|0)!=0;if((a[621161]|0)!=0?(C=c[B+28>>2]|0,(C|0)==34041|(C|0)==35056|(C|0)==36013):0)if(D){En[c[1064952+164>>2]&127](36160,33306,3553,Q,0);break}else{Dn[c[1064952+160>>2]&511](36160,33306,36161,c[B+24>>2]|0);break}if(D){En[c[1064952+164>>2]&127](36160,36096,3553,Q,0);En[c[1064952+164>>2]&127](36160,36128,3553,0,0);break}else{Dn[c[1064952+160>>2]&511](36160,36096,36161,c[B+24>>2]|0);Dn[c[1064952+160>>2]&511](36160,36128,36161,0);break}}while(0);if((mo[c[1064952+44>>2]&4095](36160)|0)!=36053){Dn[c[1064952+208>>2]&511](36160,36064,36048,l);Dn[c[1064952+208>>2]&511](36160,36096,36048,m);Dn[c[1064952+208>>2]&511](36160,36128,36048,n);Dn[c[1064952+208>>2]&511](36160,36064,36049,o);Dn[c[1064952+208>>2]&511](36160,36096,36049,p);Dn[c[1064952+208>>2]&511](36160,36128,36049,q)}a:do if(a[(c[267510]|0)+68>>0]|0){q=c[x>>2]|0;if((q|0)>0){p=0;o=0;while(1){n=c[b+(p<<2)>>2]|0;do if(!(c[n+16>>2]&64)){m=c[n>>2]|0;if(!m){l=c[n+24>>2]|0;if(l)En[c[1064904+12>>2]&127](36161,l,128,0,h)}else{l=c[266229]|0;c[f>>2]=m;do if((c[146729]|0)!=(c[146721]|0)){Roc(e,586880,f);m=c[e>>2]|0;B=c[146727]|0;if((m|0)==-1){Q=c[146728]|0;R=B;S=Q;T=B+(Q<<3)|0;break}else{R=B;S=c[146728]|0;T=B+(m<<3)|0;break}}else{m=c[146727]|0;B=c[146728]|0;R=m;S=B;T=m+(B<<3)|0}while(0);if((T|0)==(R+(S<<3)|0))U=0;else U=c[T+4>>2]|0;En[l&127](5890,U,128,0,h)}if(o)if(!(HEi(g,h)|0)){V=1;break}else break a;else{W=g+0|0;X=h+0|0;Y=W+128|0;do{a[W>>0]=a[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Y|0));V=1;break}}else V=o;while(0);p=p+1|0;if((p|0)>=(q|0)){Z=V;break}else o=V}}else Z=0;o=c[y>>2]|0;if(!o){if(!Z)break}else{q=c[o>>2]|0;if(!q){p=c[o+24>>2]|0;if(p)En[c[1064904+12>>2]&127](36161,p,128,0,h)}else{p=c[266229]|0;c[f>>2]=q;do if((c[146729]|0)!=(c[146721]|0)){Roc(e,586880,f);q=c[e>>2]|0;o=c[146727]|0;if((q|0)==-1){n=c[146728]|0;_=o;$=n;aa=o+(n<<3)|0;break}else{_=o;$=c[146728]|0;aa=o+(q<<3)|0;break}}else{q=c[146727]|0;o=c[146728]|0;_=q;$=o;aa=q+(o<<3)|0}while(0);if((aa|0)==(_+($<<3)|0))ba=0;else ba=c[aa+4>>2]|0;En[p&127](5890,ba,128,0,h)}if(Z?(HEi(g,h)|0)!=0:0)break}Dn[c[1064904+8>>2]&511](36160,t,0,h)}while(0);In[c[1064952+16>>2]&4095](36160,c[k>>2]|0);k=c[s>>2]|0;W=f+0|0;X=b+0|0;Y=W+72|0;do{c[W>>2]=c[X>>2];W=W+4|0;X=X+4|0}while((W|0)<(Y|0));c[f+72>>2]=k;k=xue(1067296,e,f)|0;b=c[k>>2]|0;if(!b){s=xCi(92)|0;W=s+16|0;X=f+0|0;Y=W+76|0;do{c[W>>2]=c[X>>2];W=W+4|0;X=X+4|0}while((W|0)<(Y|0));X=c[e>>2]|0;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=X;c[k>>2]=s;X=c[c[266824]>>2]|0;if(!X)ca=s;else{c[266824]=X;ca=c[k>>2]|0}GN(c[266825]|0,ca);c[266826]=(c[266826]|0)+1;da=s}else da=b;c[r>>2]=da;u=da;v=u+88|0;w=c[v>>2]|0;i=d;return w|0}function jue(){c[266783]=0;c[266784]=0;c[266785]=0;c[266786]=0;c[266787]=0;c[266788]=0;c[266789]=0;c[266790]=0;return}function kue(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+48|0;d=b+24|0;e=b+32|0;f=b+8|0;g=b;if(a[1067208]|0){i=b;return}h=c[266728]|0;pue(1066984);j=a[1066964]|0;k=j<<24>>24!=0;l=a[1066980]|0;m=l<<24>>24!=0;if((l|j)<<24>>24){j=c[267510]|0;if(!(a[j+58>>0]|0))n=j;else{a[e>>0]=k&1;j=e+1|0;a[j+0>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=0;a[j+4>>0]=0;a[j+5>>0]=0;a[j+6>>0]=0;Lqe(e,m);n=c[267510]|0}if(a[n+59>>0]|0){c[f+0>>2]=c[266876];c[f+4>>2]=c[266877];c[f+8>>2]=c[266878];c[f+12>>2]=c[266879];Mse(k,m,m,f,ea(1.0),0)}a[1066980]=0;a[1066964]=0;a[(c[266736]|0)+20>>0]=0;a[(c[266728]|0)+20>>0]=0}if((h|0)!=0?(c[h+16>>2]&130|0)==130:0){f=h+32|0;m=c[1074576+(c[f>>2]<<2)>>2]|0;k=Bnc()|0;n=c[(c[k>>2]|0)+212>>2]|0;c[g>>2]=c[h>>2];h=c[f>>2]|0;c[d+0>>2]=c[g+0>>2];Zn[n&1](k,2,0,0,d,h,ea(x));ko[c[1064952+176>>2]&4095](m)}a[1067208]=1;i=b;return}function lue(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;if(!(a[1067400]|0)){In[c[1064952+212>>2]&4095](36006,1067408);g=c[266852]|0;h=vue(1067296,f,1067056)|0;j=c[h>>2]|0;if(!j){k=xCi(92)|0;l=k+16|0;m=1067056;n=l+72|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(n|0));c[k+88>>2]=0;o=c[f>>2]|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=o;c[h>>2]=k;o=c[c[266824]>>2]|0;if(!o)p=k;else{c[266824]=o;p=c[h>>2]|0}GN(c[266825]|0,p);c[266826]=(c[266826]|0)+1;q=k}else q=j;c[q+88>>2]=g;a[1067400]=1}g=f;c[g>>2]=0;c[g+4>>2]=0;g=c[266737]|0;if((g|0)>0){q=0;do{a[f+q>>0]=(a[1066972+q>>0]|0)!=0&1;q=q+1|0}while((q|0)!=(g|0))}Lqe(f,(a[1066981]|0)!=0);l=1066984;m=d+0|0;n=l+68|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(n|0));b[533526]=b[d+68>>1]|0;a[1067208]=0;c[266793]=0;c[266797]=0;c[266794]=0;c[266798]=0;m=c[266746]|0;l=c[m+4>>2]|0;c[266795]=l;c[266799]=l;l=c[m+8>>2]|0;c[266796]=l;c[266800]=l;c[266792]=iue(d)|0;i=e;return}function mue(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;e=c[266737]|0;if((e|0)>0){f=0;do{a[d+f>>0]=(a[1066972+f>>0]|0)!=0&1;f=f+1|0}while((f|0)!=(e|0))}Lqe(d,(a[1066981]|0)!=0);i=b;return}function nue(b){b=b|0;var d=0;d=i;c[266793]=c[b+0>>2];c[266794]=c[b+4>>2];c[266795]=c[b+8>>2];c[266796]=c[b+12>>2];if(!(a[1067208]|0)){i=d;return}if((((c[266783]|0)==(c[266793]|0)?(c[266784]|0)==(c[266794]|0):0)?(c[266785]|0)==(c[266795]|0):0)?(c[266786]|0)==(c[266796]|0):0){i=d;return};c[266783]=c[266793];c[266784]=c[266794];c[266785]=c[266795];c[266786]=c[266796];Dn[c[1064952+372>>2]&511](c[266783]|0,c[266784]|0,c[266785]|0,c[266786]|0);i=d;return}function oue(b){b=b|0;var d=0;d=i;c[266797]=c[b+0>>2];c[266798]=c[b+4>>2];c[266799]=c[b+8>>2];c[266800]=c[b+12>>2];if(!(a[1067208]|0)){i=d;return}if((((c[266787]|0)==(c[266797]|0)?(c[266788]|0)==(c[266798]|0):0)?(c[266789]|0)==(c[266799]|0):0)?(c[266790]|0)==(c[266800]|0):0){i=d;return};c[266787]=c[266797];c[266788]=c[266798];c[266789]=c[266799];c[266790]=c[266800];Dn[c[1064952+276>>2]&511](c[266787]|0,c[266788]|0,c[266789]|0,c[266790]|0);i=d;return}function pue(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=1066912;h=d+0|0;j=g+68|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));b[533490]=b[d+68>>1]|0;h=c[266792]|0;c[266782]=h;In[c[1064952+16>>2]&4095](36160,h);g=(h|0)==0;h=c[267510]|0;if(g)k=(a[h+72>>0]|0)==0;else k=0;if(!((a[h+71>>0]|0)==0|k)){c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;k=c[d+36>>2]|0;h=(k|0)>0;if(g){if(h){g=0;do{c[f+(g<<2)>>2]=1029;g=g+1|0}while((g|0)!=(k|0))}}else if(h){h=0;do{c[f+(h<<2)>>2]=(c[(c[d+(h<<2)>>2]|0)+16>>2]&64|0)!=0?0:h+36064|0;h=h+1|0}while((h|0)!=(k|0))}In[c[1064952+416>>2]&4095](k,f)}if(!((((c[266783]|0)==(c[266793]|0)?(c[266784]|0)==(c[266794]|0):0)?(c[266785]|0)==(c[266795]|0):0)?(c[266786]|0)==(c[266796]|0):0)){c[266783]=c[266793];c[266784]=c[266794];c[266785]=c[266795];c[266786]=c[266796];Dn[c[1064952+372>>2]&511](c[266783]|0,c[266784]|0,c[266785]|0,c[266786]|0)}if((((c[266787]|0)==(c[266797]|0)?(c[266788]|0)==(c[266798]|0):0)?(c[266789]|0)==(c[266799]|0):0)?(c[266790]|0)==(c[266800]|0):0){i=e;return};c[266787]=c[266797];c[266788]=c[266798];c[266789]=c[266799];c[266790]=c[266800];Dn[c[1064952+276>>2]&511](c[266787]|0,c[266788]|0,c[266789]|0,c[266790]|0);i=e;return}function que(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+16|0;d=b;In[c[1064952+212>>2]&4095](36006,d);e=c[266824]|0;if((e|0)!=(1067300|0)){f=e;while(1){e=f+48|0;g=f+52|0;a:do if((c[e>>2]|0)==(a|0))h=6;else{j=c[g>>2]|0;if((j|0)>0){k=0;do{if((c[f+(k<<2)+16>>2]|0)==(a|0)){h=6;break a}k=k+1|0}while((k|0)<(j|0))}j=c[f+4>>2]|0;if(j){k=j;while(1){j=c[k>>2]|0;if(!j){l=k;break a}else k=j}}k=f;while(1){j=c[k+8>>2]|0;if((c[j>>2]|0)==(k|0)){l=j;break}else k=j}}while(0);if((h|0)==6){h=0;k=f+88|0;In[c[1064952+16>>2]&4095](36160,c[k>>2]|0);j=c[g>>2]|0;if((j|0)>0){m=0;do{En[c[1064952+164>>2]&127](36160,m+36064|0,3553,0,0);m=m+1|0}while((m|0)!=(j|0))}if(c[e>>2]|0){Dn[c[1064952+160>>2]&511](36160,36096,36161,0);Dn[c[1064952+160>>2]&511](36160,36128,36161,0)}In[c[1064952+16>>2]&4095](36160,c[d>>2]|0);In[c[1064952+100>>2]&4095](1,k);j=c[f+4>>2]|0;m=(j|0)==0;if(m){g=f;while(1){n=c[g+8>>2]|0;if((c[n>>2]|0)==(g|0)){o=n;break}else g=n}}else{g=j;while(1){k=c[g>>2]|0;if(!k){o=g;break}else g=k}}if(m){g=f;while(1){k=c[g+8>>2]|0;if((c[k>>2]|0)==(g|0)){p=k;break}else g=k}}else{g=j;while(1){m=c[g>>2]|0;if(!m){p=g;break}else g=m}}if((c[266824]|0)==(f|0))c[266824]=p;c[266826]=(c[266826]|0)+-1;tYb(c[266825]|0,f);ACi(f);l=o}if((l|0)==(1067300|0))break;else f=l}}b:do if((c[266754]|0)!=(a|0)){l=c[266755]|0;if((l|0)>0){f=0;while(1){if((c[1066984+(f<<2)>>2]|0)==(a|0)){q=1;break b}f=f+1|0;if((f|0)>=(l|0)){q=0;break}}}else q=0}else q=1;while(0);c:do if((c[266736]|0)!=(a|0)){l=c[266737]|0;if((l|0)>0){f=0;while(1){if((c[1066912+(f<<2)>>2]|0)==(a|0)){r=1;break c}f=f+1|0;if((f|0)>=(l|0)){r=0;break}}}else r=0}else r=1;while(0);if(!q){if(!r){i=b;return}pue(1066984);i=b;return}Krd(1067312,0,3653512,295,1,0,0,0);if(r){pue(1067056);i=b;return}else{lue(1067056);i=b;return}}function rue(){var a=0;a=i;yue(1067296,c[266825]|0);c[266826]=0;c[266824]=1067300;c[266825]=0;i=a;return}function sue(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;yue(1067296,c[266825]|0);c[266826]=0;c[266824]=1067300;c[266825]=0;a[1067400]=0;In[c[1064952+212>>2]&4095](36006,1067408);e=c[266852]|0;f=vue(1067296,d,1067056)|0;g=c[f>>2]|0;if(g){h=g;j=h+88|0;c[j>>2]=e;a[1067400]=1;i=b;return}g=xCi(92)|0;k=g+16|0;l=1067056|0;m=k+72|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));c[g+88>>2]=0;l=c[d>>2]|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=l;c[f>>2]=g;l=c[c[266824]>>2]|0;if(!l)n=g;else{c[266824]=l;n=c[f>>2]|0}GN(c[266825]|0,n);c[266826]=(c[266826]|0)+1;h=g;j=h+88|0;c[j>>2]=e;a[1067400]=1;i=b;return}function tue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+80|0;d=b;e=d+32|0;f=d+0|0;g=f+72|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[e>>2]=a;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=-1;a=iue(d)|0;i=b;return a|0}function uue(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;e=d+0|0;f=e+72|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[d>>2]=a;c[d+32>>2]=0;c[d+36>>2]=(a|0)!=0&1;c[d+40>>2]=0;c[d+44>>2]=-1;a=iue(d)|0;i=b;return a|0}function vue(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;f=c[a+4>>2]|0;if(!f){g=a+4|0;c[b>>2]=g;h=g;i=e;return h|0}g=c[d+36>>2]|0;a=c[d+32>>2]|0;j=c[d+40>>2]|0;k=c[d+44>>2]|0;a:do if((g|0)>0){l=f;while(1){m=l+16|0;n=c[l+52>>2]|0;o=(g|0)==(n|0);b:do if(o){p=0;while(1){q=c[d+(p<<2)>>2]|0;r=c[m+(p<<2)>>2]|0;p=p+1|0;if((q|0)!=(r|0)){s=q;t=r;u=6;break}if((p|0)>=(g|0)){u=8;break}}do if((u|0)==6){u=0;if(s>>>0<t>>>0){u=24;break b}}else if((u|0)==8){u=0;p=c[l+48>>2]|0;if((a|0)!=(p|0))if(a>>>0<p>>>0){u=24;break b}else break;p=c[l+56>>2]|0;if((j|0)==(p|0))if((k|0)<(c[l+60>>2]|0)){u=24;break b}else break;else if(j>>>0<p>>>0){u=24;break b}else break}while(0);if(o){p=0;do{r=c[m+(p<<2)>>2]|0;q=c[d+(p<<2)>>2]|0;p=p+1|0;if((r|0)!=(q|0)){v=r;w=q;u=16;break}}while((p|0)<(g|0));if((u|0)==16){u=0;if(v>>>0<w>>>0)break;else{x=l;u=43;break a}}p=c[l+48>>2]|0;if((p|0)!=(a|0))if(p>>>0<a>>>0)break;else{x=l;u=43;break a}p=c[l+56>>2]|0;if((p|0)==(j|0))if((c[l+60>>2]|0)<(k|0))break;else{x=l;u=43;break a}else if(p>>>0<j>>>0)break;else{x=l;u=43;break a}}else u=14}else if(g>>>0<n>>>0)u=24;else u=14;while(0);if((u|0)==14){u=0;if(n>>>0>=g>>>0){x=l;u=43;break a}}else if((u|0)==24){u=0;m=c[l>>2]|0;if(!m){y=l;z=l;u=33;break}else{l=m;continue}}m=l+4|0;o=c[m>>2]|0;if(!o){A=m;B=l;u=42;break}else l=o}}else{l=f;while(1){o=c[l+52>>2]|0;m=(g|0)==(o|0);c:do if(m){p=c[l+48>>2]|0;do if((a|0)==(p|0)){q=c[l+56>>2]|0;if((j|0)==(q|0))if((k|0)<(c[l+60>>2]|0)){u=32;break c}else{u=34;break}else if(j>>>0<q>>>0){u=32;break c}else break}else if(a>>>0<p>>>0){u=32;break c}else u=34;while(0);if((u|0)==34?(u=0,!m):0){u=35;break}p=c[l+48>>2]|0;if((p|0)!=(a|0))if(p>>>0<a>>>0)break;else{x=l;u=43;break a}p=c[l+56>>2]|0;if((p|0)==(j|0))if((c[l+60>>2]|0)<(k|0))break;else{x=l;u=43;break a}else if(p>>>0<j>>>0)break;else{x=l;u=43;break a}}else if(g>>>0<o>>>0)u=32;else u=35;while(0);if((u|0)==32){u=0;m=c[l>>2]|0;if(!m){y=l;z=l;u=33;break a}else{l=m;continue}}else if((u|0)==35?(u=0,o>>>0>=g>>>0):0){x=l;u=43;break a}m=l+4|0;n=c[m>>2]|0;if(!n){A=m;B=l;u=42;break}else l=n}}while(0);if((u|0)==33){c[b>>2]=z;h=y;i=e;return h|0}else if((u|0)==42){c[b>>2]=B;h=A;i=e;return h|0}else if((u|0)==43){c[b>>2]=x;h=b;i=e;return h|0}return 0}function wue(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=c[b+4>>2]|0;g=b+4|0;a:do if(f){b=c[d+36>>2]|0;h=c[d+32>>2]|0;j=c[d+40>>2]|0;k=c[d+44>>2]|0;l=(b|0)>0;m=g;n=f;b:while(1){o=n;c:while(1){p=c[o+52>>2]|0;d:do if((p|0)==(b|0)){e:do if(l){q=0;while(1){r=c[o+(q<<2)+16>>2]|0;s=c[d+(q<<2)>>2]|0;q=q+1|0;if((r|0)!=(s|0)){t=r;u=s;break}if((q|0)>=(b|0))break e}if(t>>>0<u>>>0)break d;else{v=o;w=o;break c}}while(0);q=c[o+48>>2]|0;if((q|0)!=(h|0))if(q>>>0<h>>>0)break;else{v=o;w=o;break c}q=c[o+56>>2]|0;if((q|0)==(j|0))if((c[o+60>>2]|0)<(k|0))break;else{v=o;w=o;break c}else if(q>>>0<j>>>0)break;else{v=o;w=o;break c}}else if(p>>>0>=b>>>0){v=o;w=o;break c}while(0);o=c[o+4>>2]|0;if(!o){x=m;break b}}n=c[v>>2]|0;if(!n){x=w;break}else m=w}if((x|0)!=(g|0)){m=c[x+52>>2]|0;f:do if((b|0)==(m|0)){g:do if(l){n=0;while(1){o=c[d+(n<<2)>>2]|0;p=c[x+(n<<2)+16>>2]|0;n=n+1|0;if((o|0)!=(p|0)){y=o;z=p;break}if((n|0)>=(b|0))break g}if(y>>>0<z>>>0)break a;else break f}while(0);n=c[x+48>>2]|0;if((h|0)!=(n|0))if(h>>>0<n>>>0)break a;else break;n=c[x+56>>2]|0;if((j|0)==(n|0))if((k|0)<(c[x+60>>2]|0))break a;else break;else if(j>>>0<n>>>0)break a;else break}else if(b>>>0<m>>>0)break a;while(0);c[a>>2]=x;i=e;return}}while(0);c[a>>2]=g;i=e;return}function xue(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;f=c[a+4>>2]|0;if(!f){g=a+4|0;c[b>>2]=g;h=g;i=e;return h|0}g=c[d+36>>2]|0;a=(g|0)>0;j=c[d+32>>2]|0;k=c[d+40>>2]|0;l=c[d+44>>2]|0;m=f;a:while(1){f=m+16|0;n=c[m+52>>2]|0;o=(g|0)==(n|0);b:do if(o){c:do if(a){p=0;while(1){q=c[d+(p<<2)>>2]|0;r=c[f+(p<<2)>>2]|0;p=p+1|0;if((q|0)!=(r|0)){s=q;t=r;break}if((p|0)>=(g|0)){u=9;break c}}if(s>>>0<t>>>0){u=14;break b}}else u=9;while(0);do if((u|0)==9){u=0;p=c[m+48>>2]|0;if((j|0)!=(p|0))if(j>>>0<p>>>0){u=14;break b}else break;p=c[m+56>>2]|0;if((k|0)==(p|0))if((l|0)<(c[m+60>>2]|0)){u=14;break b}else break;else if(k>>>0<p>>>0){u=14;break b}else break}while(0);if(o){d:do if(a){p=0;while(1){r=c[f+(p<<2)>>2]|0;q=c[d+(p<<2)>>2]|0;p=p+1|0;if((r|0)!=(q|0)){v=r;w=q;break}if((p|0)>=(g|0))break d}if(v>>>0<w>>>0)break b;else{x=m;u=29;break a}}while(0);p=c[m+48>>2]|0;if((p|0)!=(j|0))if(p>>>0<j>>>0)break;else{x=m;u=29;break a}p=c[m+56>>2]|0;if((p|0)==(k|0))if((c[m+60>>2]|0)<(l|0))break;else{x=m;u=29;break a}else if(p>>>0<k>>>0)break;else{x=m;u=29;break a}}else u=18}else if(g>>>0<n>>>0)u=14;else u=18;while(0);if((u|0)==14){u=0;f=c[m>>2]|0;if(!f){y=m;z=m;u=15;break}else{m=f;continue}}else if((u|0)==18?(u=0,n>>>0>=g>>>0):0){x=m;u=29;break}f=m+4|0;o=c[f>>2]|0;if(!o){A=f;B=m;u=28;break}else m=o}if((u|0)==15){c[b>>2]=z;h=y;i=e;return h|0}else if((u|0)==28){c[b>>2]=B;h=A;i=e;return h|0}else if((u|0)==29){c[b>>2]=x;h=b;i=e;return h|0}return 0}function yue(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{yue(a,c[b>>2]|0);yue(a,c[b+4>>2]|0);ACi(b);i=d;return}}function zue(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;Vqc(b);h=b+16|0;c[h>>2]=0;c[b>>2]=1067528;c[b+4>>2]=6;c[b+28>>2]=0;c[b+24>>2]=0;j=a[d>>0]|0;if(!(j&1))k=(j&255)>>>1;else k=c[d+4>>2]|0;if(!k){i=f;return}k=b+8|0;a[k>>0]=1;if(!(Aue(b,d,arc(e)|0)|0)){d=c[e+12>>2]|0;do if(d)if(!(a[d>>0]&1)){l=d+1|0;break}else{l=c[d+8>>2]|0;break}else l=1070048;while(0);c[g>>2]=l;Ird(1067640,g);i=f;return}l=$qc(e)|0;d=c[h>>2]|0;h=c[e+8>>2]|0;if(d){Gte(c[266694]|0,d);Que(d,l,h,1);h=l+60|0;d=(c[l+64>>2]|0)-(c[h>>2]|0)|0;j=(d|0)/28|0;if((d|0)>0){d=0;do{m=Bnc()|0;n=c[h>>2]|0;co[c[(c[m>>2]|0)+244>>2]&2047](m,c[n+(d*28|0)>>2]|0,c[n+(d*28|0)+20>>2]|0);d=d+1|0}while((d|0)<(j|0))}Oqc(l)}_ve(b+20|0,l,-1,-1);if(((c[l+36>>2]|0)-(c[l+32>>2]|0)>>4|0)<=(c[155253]|0)){a[k>>0]=0;i=f;return}k=c[e+12>>2]|0;do if(k)if(!(a[k>>0]&1)){o=k+1|0;break}else{o=c[k+8>>2]|0;break}else o=1070048;while(0);c[g>>2]=o;Ird(1067544,g);i=f;return}function Aue(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+4208|0;g=f;h=f+104|0;j=f+52|0;k=f+16|0;l=f+80|0;m=f+4|0;n=f+28|0;o=f+68|0;p=f+40|0;q=f+56|0;r=f+92|0;s=b+16|0;c[s>>2]=Jo[c[1064952+84>>2]&127]()|0;c[b+4>>2]=6;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;rri(n,1067800,6);Iqc(m,n,d,k);xri(n);rri(p,1067808,8);Iqc(o,p,k,l);xri(p);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;p=a[l>>0]|0;n=(p&1)==0;if(n)t=(p&255)>>>1;else t=c[l+4>>2]|0;p=a[m>>0]|0;if(!(p&1))u=(p&255)>>>1;else u=c[m+4>>2]|0;if(n)v=l+1|0;else v=c[l+8>>2]|0;Pri(q,v,t,u+t|0);if(!(a[m>>0]&1))w=m+1|0;else w=c[m+8>>2]|0;Gri(q,w,u)|0;yri(m,q)|0;xri(q);c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;q=a[l>>0]|0;u=(q&1)==0;if(u)x=(q&255)>>>1;else x=c[l+4>>2]|0;q=a[o>>0]|0;if(!(q&1))y=(q&255)>>>1;else y=c[o+4>>2]|0;if(u)z=l+1|0;else z=c[l+8>>2]|0;Pri(r,z,x,y+x|0);if(!(a[o>>0]&1))A=o+1|0;else A=c[o+8>>2]|0;Gri(r,A,y)|0;yri(o,r)|0;xri(r);if(Fue(b,m,o,e)|0){B=1;xri(o);xri(m);xri(l);xri(k);i=f;return B|0}e=c[s>>2]|0;c[j>>2]=0;Dn[c[1064952+220>>2]&511](e,4096,j,h);if((c[j>>2]|0)<=0){B=0;xri(o);xri(m);xri(l);xri(k);i=f;return B|0}c[g>>2]=h;Ird(1067768,g);B=0;xri(o);xri(m);xri(l);xri(k);i=f;return B|0}function Bue(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1067528;d=c[a+24>>2]|0;if(d)ko[c[1064952+112>>2]&4095](d);d=c[a+28>>2]|0;if(d)ko[c[1064952+112>>2]&4095](d);d=c[a+16>>2]|0;if(!d){i=b;return}ko[c[1064952+104>>2]&4095](d);i=b;return}function Cue(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1067528;d=c[a+24>>2]|0;if(d)ko[c[1064952+112>>2]&4095](d);d=c[a+28>>2]|0;if(d)ko[c[1064952+112>>2]&4095](d);d=c[a+16>>2]|0;if(!d){ACi(a);i=b;return}ko[c[1064952+104>>2]&4095](d);ACi(a);i=b;return}function Due(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+4112|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[j>>2]=d;Dn[c[1064952+280>>2]&511](a,1,j,0);ko[c[1064952+68>>2]&4095](a);c[k>>2]=10;co[c[1064952+224>>2]&2047](a,35713,k);if(c[k>>2]|0){l=c[k>>2]|0;m=(l|0)!=0;i=e;return m|0}d=c[j>>2]|0;c[h>>2]=0;if(!b)Dn[c[1064952+220>>2]&511](a,4096,h,g);else Dn[c[1064952+228>>2]&511](a,4096,h,g);if((c[h>>2]|0)<=0){l=c[k>>2]|0;m=(l|0)!=0;i=e;return m|0}if(d){c[f>>2]=(b|0)==1?1067736:1067752;Ird(1067704,f);Nrd(d,-1)}c[f>>2]=g;Ird(1067768,f);l=c[k>>2]|0;m=(l|0)!=0;i=e;return m|0}function Eue(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+4112|0;f=e;g=e+8|0;h=e+4|0;c[h>>2]=0;if(!b)Dn[c[1064952+220>>2]&511](a,4096,h,g);else Dn[c[1064952+228>>2]&511](a,4096,h,g);if((c[h>>2]|0)<=0){j=0;i=e;return j|0}if(d){c[f>>2]=(b|0)==1?1067736:1067752;Ird(1067704,f);Nrd(d,-1)}c[f>>2]=g;Ird(1067768,f);j=1;i=e;return j|0}function Fue(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;g=i;i=i+4240|0;h=g;j=g+8|0;k=g+4152|0;l=g+4140|0;m=g+4164|0;n=g+4176|0;o=g+4104|0;p=g+4192|0;q=g+4116|0;r=g+4128|0;s=g+4|0;t=g+4188|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;do if(a[(c[267510]|0)+64>>0]|0){u=p+0|0;v=u+33|0;do{a[u>>0]=49;u=u+1|0}while((u|0)<(v|0));u=c[267148]|0;rri(r,u,SEi(u|0)|0);yO(q,r,p);yri(o,q)|0;xri(q);xri(r);u=(a[(c[267510]|0)+64>>0]|0)==0;c[s>>2]=0;if(!u){if(!(a[o>>0]&1))w=o+1|0;else w=c[o+8>>2]|0;u=ed(w|0,1067824)|0;if(u){yg(u|0,0,2)|0;v=Hc(u|0)|0;yg(u|0,0,0)|0;x=ADi(v)|0;c[s>>2]=v+-4;ik(x|0,v|0,1,u|0)|0;dj(u|0)|0;u=b+16|0;if(!(Hue(d,f,c[u>>2]|0)|0)){BDi(x);y=12;break}Dn[c[1064952+504>>2]&511](c[u>>2]|0,c[x>>2]|0,x+4|0,c[s>>2]|0);c[t>>2]=0;co[c[1064952+216>>2]&2047](c[u>>2]|0,35714,t);if(!(c[t>>2]|0)){BDi(x);y=12}else z=x}else y=12}else y=12}else{c[s>>2]=0;y=12}while(0);do if((y|0)==12){t=b+16|0;w=c[t>>2]|0;r=b+24|0;a:do if(!(c[(c[267510]|0)+12>>2]|0)){q=a[d>>0]|0;p=(q&1)==0;if(p){A=(q&255)>>>1;B=d+1|0}else{A=c[d+4>>2]|0;B=c[d+8>>2]|0}b:do if((A>>>0>=9?(x=B+A|0,u=B,(A|0)>=9):0)?(v=A+-8|0,C=B+v|0,(v|0)!=0):0){v=B;c:while(1){if((a[v>>0]|0)==116){D=v;E=1081528;do{E=E+1|0;if((E|0)==1081537){F=v;break c}D=D+1|0}while((a[D>>0]|0)==(a[E>>0]|0))}v=v+1|0;if((v|0)==(C|0)){y=25;break b}}if(!((F|0)!=(x|0)?(F-u|0)!=-1:0))y=25}else y=25;while(0);if((y|0)==25){if(p){G=(q&255)>>>1;H=d+1|0}else{G=c[d+4>>2]|0;H=c[d+8>>2]|0}if(G>>>0<5)break;C=H+G|0;v=H;if((G|0)<5)break;E=G+-4|0;D=H+E|0;if(!E)break;else I=H;d:while(1){if((a[I>>0]|0)==116){E=I;J=1068528;do{J=J+1|0;if((J|0)==1068533){K=I;break d}E=E+1|0}while((a[E>>0]|0)==(a[J>>0]|0))}I=I+1|0;if((I|0)==(D|0))break a}if((K|0)==(C|0))break;if((K-v|0)==-1)break}Krd(1068536,0,3653512,332,1,0,0,0);L=0;xri(o);i=g;return L|0}while(0);c[r>>2]=mo[c[1064952+88>>2]&4095](35633)|0;Hue(d,f,w)|0;if(!(a[d>>0]&1))M=d+1|0;else M=c[d+8>>2]|0;if(!(Due(c[r>>2]|0,1,M)|0)){L=0;xri(o);i=g;return L|0}D=b+28|0;c[D>>2]=mo[c[1064952+88>>2]&4095](35632)|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;if(!(a[e>>0]&1))N=e+1|0;else N=c[e+8>>2]|0;q=a[N>>0]|0;if(q<<24>>24){p=q;q=N;e:while(1){J=q+1|0;if(FDi(p<<24>>24)|0){p=a[J>>0]|0;q=J;continue}if((a[q>>0]|0)==35){O=35;P=q}else{Q=q;break}while(1){if(O<<24>>24==13|O<<24>>24==10){p=O;q=P;continue e}J=P+1|0;O=a[J>>0]|0;P=J}}Ari(j,N,Q-N|0)|0;zri(k,Q)|0}q=(a[(c[267510]|0)+81>>0]|0)!=0;rri(l,q?1068160:1068184,q?23:25);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;q=a[j>>0]|0;p=(q&1)==0;if(p)R=(q&255)>>>1;else R=c[j+4>>2]|0;q=a[l>>0]|0;if(!(q&1))S=(q&255)>>>1;else S=c[l+4>>2]|0;if(p)T=j+1|0;else T=c[j+8>>2]|0;Pri(n,T,R,S+R|0);if(!(a[l>>0]&1))U=l+1|0;else U=c[l+8>>2]|0;Gri(n,U,S)|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;p=a[n>>0]|0;q=(p&1)==0;if(q)V=(p&255)>>>1;else V=c[n+4>>2]|0;p=a[k>>0]|0;if(!(p&1))W=(p&255)>>>1;else W=c[k+4>>2]|0;if(q)X=n+1|0;else X=c[n+8>>2]|0;Pri(m,X,V,W+V|0);if(!(a[k>>0]&1))Y=k+1|0;else Y=c[k+8>>2]|0;Gri(m,Y,W)|0;xri(n);if(!(a[m>>0]&1))Z=m+1|0;else Z=c[m+8>>2]|0;do if(Due(c[D>>2]|0,2,Z)|0){xri(m);xri(l);xri(k);xri(j)}else{if(!(a[(c[267510]|0)+82>>0]|0)){xri(m);xri(l);xri(k);xri(j);L=0;xri(o);i=g;return L|0}q=c[D>>2]|0;p=a[m>>0]|0;w=(p&1)==0;if(w){_=(p&255)>>>1;$=m+1|0}else{_=c[m+4>>2]|0;$=c[m+8>>2]|0}f:do if(_>>>0>=17){v=$+_|0;C=$;if((_|0)<17){y=93;break}J=_+-16|0;E=$+J|0;if(!J){y=93;break}else aa=$;g:while(1){if((a[aa>>0]|0)==116){J=aa;u=1068216;do{u=u+1|0;if((u|0)==1068233){ba=aa;break g}J=J+1|0}while((a[J>>0]|0)==(a[u>>0]|0))}aa=aa+1|0;if((aa|0)==(E|0)){y=93;break f}}if((ba|0)==(v|0)){y=93;break}if((ba-C|0)!=-1)y=105;else y=93}else y=93;while(0);h:do if((y|0)==93){if(w){ca=(p&255)>>>1;da=m+1|0}else{ca=c[m+4>>2]|0;da=c[m+8>>2]|0}if(ca>>>0<18){ea=p;break}E=da+ca|0;u=da;if((ca|0)<18){ea=p;break}J=ca+-17|0;x=da+J|0;if(!J){ea=p;break}else fa=da;i:while(1){if((a[fa>>0]|0)==116){J=fa;ga=1068240;do{ga=ga+1|0;if((ga|0)==1068258){ha=fa;break i}J=J+1|0}while((a[J>>0]|0)==(a[ga>>0]|0))}fa=fa+1|0;if((fa|0)==(x|0)){ea=p;break h}}if((ha|0)==(E|0)){ea=p;break}if((ha-u|0)==-1)ea=p;else y=105}while(0);j:do if((y|0)==105){Ird(1068264,h);Ird(1068328,h);Ird(1068400,h);p=a[m>>0]|0;if(!(p&1)){ia=(p&255)>>>1;ja=m+1|0}else{ia=c[m+4>>2]|0;ja=c[m+8>>2]|0}if(ia>>>0<11){ea=p;break}w=ja+ia|0;x=ja;if((ia|0)<11){ea=p;break}C=ia+-10|0;v=ja+C|0;if(!C){ea=p;break}else ka=ja;k:while(1){if((a[ka>>0]|0)==116){C=ka;ga=1081512;do{ga=ga+1|0;if((ga|0)==1081523){la=ka;break k}C=C+1|0}while((a[C>>0]|0)==(a[ga>>0]|0))}ka=ka+1|0;if((ka|0)==(v|0)){ea=p;break j}}if((la|0)==(w|0)){ea=p;break}v=la-x|0;if((v|0)==-1){ea=p;break}u=m+1|0;E=m+8|0;ga=m+4|0;C=p;J=v;while(1){v=J+11|0;ma=(C&1)==0?u:c[E>>2]|0;na=ma+v|0;do if(!(IEi(1068512,na,6)|0)){a[ma+(J+14)>>0]=32;a[((a[m>>0]&1)==0?u:c[E>>2]|0)+(J+15)>>0]=32;a[((a[m>>0]&1)==0?u:c[E>>2]|0)+(J+16)>>0]=32}else{if(IEi(1068520,na,7)|0)break;a[ma+(J+15)>>0]=65;a[((a[m>>0]&1)==0?u:c[E>>2]|0)+(J+16)>>0]=82;a[((a[m>>0]&1)==0?u:c[E>>2]|0)+(J+17)>>0]=66}while(0);ma=a[m>>0]|0;if(!(ma&1)){oa=(ma&255)>>>1;pa=u}else{oa=c[ga>>2]|0;pa=c[E>>2]|0}if(oa>>>0<v>>>0|(oa-v|0)>>>0<11){ea=ma;break j}na=pa+v|0;qa=pa+oa|0;if((qa-na|0)<11){ea=ma;break j}ra=oa+-10|0;sa=pa+ra|0;if((ra|0)==(v|0)){ea=ma;break j}else ta=na;l:while(1){if((a[ta>>0]|0)==116){na=ta;ra=1081512;do{ra=ra+1|0;if((ra|0)==1081523){ua=ta;break l}na=na+1|0}while((a[na>>0]|0)==(a[ra>>0]|0))}ta=ta+1|0;if((ta|0)==(sa|0)){ea=ma;break j}}if((ua|0)==(qa|0)){ea=ma;break j}J=ua-pa|0;if((J|0)==-1){ea=ma;break}else C=ma}}while(0);if(!(ea&1))va=m+1|0;else va=c[m+8>>2]|0;C=Due(q,2,va)|0;xri(m);xri(l);xri(k);xri(j);if(C)break;else L=0;xri(o);i=g;return L|0}while(0);C=c[t>>2]|0;J=c[r>>2]|0;E=c[D>>2]|0;if(!((C|0)!=0&(J|0)!=0&(E|0)!=0)){L=0;xri(o);i=g;return L|0}In[c[1064952+4>>2]&4095](C,J);In[c[1064952+4>>2]&4095](C,E);ko[c[1064952+256>>2]&4095](C);c[l>>2]=0;co[c[1064952+216>>2]&2047](C,35714,l);if(!(c[l>>2]|0)){c[k>>2]=0;Dn[c[1064952+220>>2]&511](C,4096,k,j);if((c[k>>2]|0)<=0){L=0;xri(o);i=g;return L|0}c[h>>2]=j;Ird(1067768,h);L=0;xri(o);i=g;return L|0}if(!(a[(c[267510]|0)+64>>0]|0)){L=1;xri(o);i=g;return L|0}co[c[1064952+216>>2]&2047](c[t>>2]|0,34625,s);C=c[s>>2]|0;E=ADi(C+4|0)|0;En[c[1064952+500>>2]&127](c[t>>2]|0,C,0,E,E+4|0);if(!(a[o>>0]&1))wa=o+1|0;else wa=c[o+8>>2]|0;C=ed(wa|0,1067832)|0;if(!C){z=E;break}_f(E|0,(c[s>>2]|0)+4|0,1,C|0)|0;dj(C|0)|0;z=E}while(0);if(!z){L=1;xri(o);i=g;return L|0}BDi(z);L=1;xri(o);i=g;return L|0}function Gue(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=Im;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;c[j>>2]=e;e=b+16|0;if(!(c[e>>2]|0)){i=f;return}l=Bnc()|0;Gte(c[266694]|0,c[e>>2]|0);Rue(b+20|0,d,0,j);b=c[d+36>>2]|0;e=c[d+32>>2]|0;if((e|0)==(b|0)){i=f;return}d=e;e=c[j>>2]|0;do{m=c[(c[l>>2]|0)+212>>2]|0;n=c[d+4>>2]|0;c[k>>2]=c[e>>2];o=a[e+8>>0]&15;p=ea(g[e+4>>2]);c[h+0>>2]=c[k+0>>2];Zn[m&1](l,2,n,n,h,o,p);e=(c[j>>2]|0)+12|0;c[j>>2]=e;d=d+16|0}while((d|0)!=(b|0));i=f;return}function Hue(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+16|0;g=f;h=b+1|0;j=b+8|0;k=b+4|0;l=0;a:do{m=c[1068904+(l<<2)>>2]|0;n=a[b>>0]|0;if(!(n&1)){o=(n&255)>>>1;p=h}else{o=c[k>>2]|0;p=c[j>>2]|0}n=SEi(m|0)|0;b:do if(o>>>0>=n>>>0){if(n){q=p+o|0;r=m+n|0;s=p;if((o|0)<(n|0))break;t=1-n+o|0;u=p+t|0;if(!t)break;t=a[m>>0]|0;v=p;c:while(1){if((a[v>>0]|0)==t<<24>>24){w=v;x=m;do{x=x+1|0;if((x|0)==(r|0)){y=v;break c}w=w+1|0}while((a[w>>0]|0)==(a[x>>0]|0))}v=v+1|0;if((v|0)==(u|0))break b}if((y|0)==(q|0))break;if((y-s|0)==-1)break}u=c[1068952+(l<<2)>>2]|0;if((u|0)>=(c[c[267510]>>2]|0)){z=17;break a}co[c[1064952+8>>2]&2047](e,u,m);u=c[1067904+(l<<2)>>2]|0;rri(g,u,SEi(u|0)|0);u=gnc(g)|0;xri(g);if((u|0)!=-1)inc(d,u,c[1067952+(l<<2)>>2]|0)}while(0);l=l+1|0}while(l>>>0<12);if((z|0)==17){Krd(1067840,0,3653512,374,1,0,0,0);A=0;i=f;return A|0}l=a[b>>0]|0;b=(l&1)==0;if(b){B=(l&255)>>>1;C=h}else{B=c[k>>2]|0;C=c[j>>2]|0}if(B>>>0<7){A=1;i=f;return A|0}g=C+B|0;y=C;if((B|0)<7){A=1;i=f;return A|0}p=B+-6|0;B=C+p|0;if(!p){A=1;i=f;return A|0}else D=C;d:while(1){if((a[D>>0]|0)==84){C=D;p=1068e3;do{p=p+1|0;if((p|0)==1068007){E=D;break d}C=C+1|0}while((a[C>>0]|0)==(a[p>>0]|0))}D=D+1|0;if((D|0)==(B|0)){A=1;z=48;break}}if((z|0)==48){i=f;return A|0}if((E|0)==(g|0)){A=1;i=f;return A|0}g=E-y|0;if((g|0)==-1){A=1;i=f;return A|0}y=g+1|0;if(b){F=(l&255)>>>1;G=h}else{F=c[k>>2]|0;G=c[j>>2]|0}if(F>>>0<y>>>0|(F-y|0)>>>0<7){A=1;i=f;return A|0}j=G+y|0;k=G+F|0;if((k-j|0)<7){A=1;i=f;return A|0}h=F+-6|0;F=G+h|0;if((h|0)==(y|0)){A=1;i=f;return A|0}else H=j;e:while(1){if((a[H>>0]|0)==84){j=H;y=1068e3;do{y=y+1|0;if((y|0)==1068007){I=H;break e}j=j+1|0}while((a[j>>0]|0)==(a[y>>0]|0))}H=H+1|0;if((H|0)==(F|0)){A=1;z=48;break}}if((z|0)==48){i=f;return A|0}if((I|0)==(k|0)){A=1;i=f;return A|0}if((I-G|0)==-1){A=1;i=f;return A|0}else J=6;while(1){if((a[d+J+8>>0]|0)==-1){K=J;break}J=J+1|0;if((J|0)>=11){A=1;z=48;break}}if((z|0)==48){i=f;return A|0}inc(d,7,K);co[c[1064952+8>>2]&2047](e,K+-1|0,1068008);A=1;i=f;return A|0}function Iue(a,b,c){a=a|0;b=b|0;c=c|0;return}function Jue(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+64|0;d=b+48|0;e=b+36|0;f=b+24|0;g=b+12|0;h=b;j=a[620920]|0;k=(j&1)==0;if(k){l=(j&255)>>>1;m=620921}else{l=c[155231]|0;m=c[155232]|0}a:do if((l>>>0>=9?(n=m+l|0,o=m,(l|0)>=9):0)?(p=l+-8|0,q=m+p|0,(p|0)!=0):0){p=m;b:while(1){if((a[p>>0]|0)==73){r=p;s=1068600;do{s=s+1|0;if((s|0)==1068609){t=p;break b}r=r+1|0}while((a[r>>0]|0)==(a[s>>0]|0))}p=p+1|0;if((p|0)==(q|0))break a}if((t|0)!=(n|0)?(t-o|0)!=-1:0){u=0;i=b;return u|0}}while(0);if(k){v=(j&255)>>>1;w=620921}else{v=c[155231]|0;w=c[155232]|0}c:do if((v>>>0>=6?(j=w+v|0,k=w,(v|0)>=6):0)?(t=v+-5|0,m=w+t|0,(t|0)!=0):0){t=w;d:while(1){if((a[t>>0]|0)==71){l=t;q=1068616;do{q=q+1|0;if((q|0)==1068622){x=t;break d}l=l+1|0}while((a[l>>0]|0)==(a[q>>0]|0))}t=t+1|0;if((t|0)==(m|0))break c}if((x|0)!=(j|0)?(x-k|0)!=-1:0){u=0;i=b;return u|0}}while(0);if(!(c[266363]|0)){u=0;i=b;return u|0}if(!(c[266364]|0)){u=0;i=b;return u|0}c[d>>2]=0;In[c[1064952+212>>2]&4095](34814,d);if((c[d>>2]|0)<=0){u=0;i=b;return u|0}Ssd(f);yO(e,f,1068624);xri(f);f=c[267148]|0;if(f)BDi(f);f=a[e>>0]|0;if(!(f&1)){d=ADi(((f&255)>>>1)+1|0)|0;c[267148]=d;y=d;z=e+1|0}else{d=ADi((c[e+4>>2]|0)+1|0)|0;c[267148]=d;y=d;z=c[e+8>>2]|0}bFi(y|0,z|0)|0;z=c[267148]|0;rri(g,z,SEi(z|0)|0);z=qqd(g)|0;xri(g);if(!z){z=c[267148]|0;rri(h,z,SEi(z|0)|0);xqd(h)|0;xri(h)}xri(e);u=1;i=b;return u|0}function Kue(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;if((f|0)==1){awe(c[a+4>>2]|0,b,d,e);i=g;return}else if((f|0)==3){cwe(c[a+4>>2]|0,b,d,e);i=g;return}else if((f|0)==2){bwe(c[a+4>>2]|0,b,d,e);i=g;return}else if((f|0)==4){dwe(c[a+4>>2]|0,b,d,e);i=g;return}else{i=g;return}}function Lue(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;Dn[c[1064952+356>>2]&511](b,1,0,d);i=e;return}function Mue(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=c[a>>2]|0;a=c[(c[l>>2]|0)+212>>2]|0;c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];Zn[a&1](l,b,d,e,j,f,ea(x));i=h;return}function Nue(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=-1;itd(b,1069008);c[267250]=c[b>>2];i=a;return}function Oue(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;o=i;if((h|0)<2){Jqc(b,g,d,f,k,j,n);i=o;return}k=l+m|0;g=m+1|0;p=l+g|0;q=m+2|0;r=l+q|0;s=m+3|0;m=0;do{a[k>>0]=91;t=(m|0)<10;if(t){a[p>>0]=m+48;u=q;v=2}else{a[p>>0]=((m|0)/10|0)+48;a[r>>0]=((m|0)%10|0)+48;u=s;v=3}a[l+u>>0]=93;a[l+(v+g)>>0]=0;w=_n[c[1064952+240>>2]&4095](e,l)|0;if(t){a[k>>0]=m+48;x=p}else{a[k>>0]=((m|0)/10|0)+48;a[p>>0]=((m|0)%10|0)+48;x=r}a[x>>0]=0;Jqc(b,w,d,f,l,j,n);m=m+1|0}while((m|0)!=(h|0));i=o;return}function Pue(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;o=i;if((h|0)<2){Kqc(b,g,0,k,e,f,j,n);i=o;return}k=l+m|0;g=m+1|0;p=l+g|0;q=m+2|0;r=l+q|0;s=m+3|0;m=0;do{a[k>>0]=91;t=(m|0)<10;if(t){a[p>>0]=m+48;u=q;v=2}else{a[p>>0]=((m|0)/10|0)+48;a[r>>0]=((m|0)%10|0)+48;u=s;v=3}a[l+u>>0]=93;a[l+(v+g)>>0]=0;w=_n[c[1064952+240>>2]&4095](d,l)|0;if(t){a[k>>0]=m+48;x=p}else{a[k>>0]=((m|0)/10|0)+48;a[p>>0]=((m|0)%10|0)+48;x=r}a[x>>0]=0;Kqc(b,w,0,l,e,f,j,n);m=m+1|0}while((m|0)!=(h|0));i=o;return}function Que(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=i;i=i+1104|0;h=g+64|0;j=g+16|0;k=g+72|0;l=g+4|0;m=g+56|0;n=g+60|0;o=g+12|0;p=g+48|0;q=g+20|0;r=g+8|0;s=g;t=g+52|0;u=g+68|0;c[m>>2]=0;c[n>>2]=-1;c[o>>2]=0;if(a[(c[267510]|0)+65>>0]|0){c[p>>2]=0;co[c[1064952+216>>2]&2047](b,35382,p);v=d+60|0;w=c[v>>2]|0;x=d+64|0;y=c[x>>2]|0;if((y|0)!=(w|0)){z=y;while(1){y=z+-28|0;c[x>>2]=y;if((c[z+-12>>2]|0)>-1){A=z+-24|0;B=c[A>>2]|0;c[j>>2]=c[z+-20>>2];c[h+0>>2]=c[j+0>>2];eOb(B,h);c[A>>2]=0;C=c[x>>2]|0}else C=y;if((C|0)==(w|0))break;else z=C}}Sue(v,c[p>>2]|0);C=c[p>>2]|0;if((C|0)>0){p=q+4|0;z=q+12|0;w=q+16|0;y=q+8|0;A=q+20|0;B=q+24|0;D=d+68|0;E=0;do{En[c[1064952+480>>2]&127](b,E,1024,o,k);Dn[c[1064952+476>>2]&511](b,E,35392,m);c[q>>2]=-1;c[p>>2]=0;c[z>>2]=0;c[w>>2]=0;c[y>>2]=60;c[h>>2]=-1;itd(h,k);F=c[h>>2]|0;c[q>>2]=F;c[A>>2]=c[m>>2];c[B>>2]=E;co[c[1064952+484>>2]&2047](b,E,E);G=c[x>>2]|0;if((G|0)==(c[D>>2]|0))Tue(v,q);else{if(!G)H=0;else{c[G>>2]=F;c[G+8>>2]=60;c[G+16>>2]=0;c[G+4>>2]=0;c[G+12>>2]=0;F=A;I=c[F+4>>2]|0;J=G+20|0;c[J>>2]=c[F>>2];c[J+4>>2]=I;H=c[x>>2]|0}c[x>>2]=H+28}c[j>>2]=60;c[h+0>>2]=c[j+0>>2];eOb(0,h);c[p>>2]=0;E=E+1|0}while((E|0)<(C|0))}}co[c[1064952+216>>2]&2047](b,35718,r);c[s>>2]=0;C=c[r>>2]|0;if((C|0)<=0){i=g;return}r=d+36|0;E=d+32|0;p=0;do{Wn[c[1064952+196>>2]&127](b,p,1024,o,m,l,k);a:do if((HEi(k,1069944)|0)!=0?(HEi(k,1069968)|0)!=0:0){h=0;while(1){if(!(HEi(k,c[1069024+(h<<3)>>2]|0)|0)){K=h;L=21;break}h=h+1|0;if(h>>>0>=23){M=0;break}}if((L|0)==21){L=0;M=c[1069028+(K<<3)>>2]|0}h=(M|0)!=0?M:k;if(IEi(k,1069984,3)|0){c[t>>2]=-1;c[n>>2]=-1;j=_n[c[1064952+240>>2]&4095](b,k)|0;c[t>>2]=j;if((j|0)==-1){En[c[1064952+468>>2]&127](b,1,s,35387,t);En[c[1064952+468>>2]&127](b,1,s,35386,n)}a[u>>0]=0;if(Hqc(k,c[o>>2]|0,c[m>>2]|0,u)|0){if((c[m>>2]|0)>99){Krd(1069992,0,3653512,196,1,0,0,0);c[m>>2]=99}j=c[o>>2]|0;if(!(a[u>>0]|0))N=j;else{H=j+-3|0;a[k+H>>0]=48;a[k+(j+-2)>>0]=0;N=H}}else N=0;H=c[l>>2]|0;do if((H|0)==35668){Oue(d,1,b,3,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35664){Oue(d,0,b,2,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==5124){Oue(d,1,b,1,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35672){Oue(d,2,b,3,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35670){Oue(d,2,b,1,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35675){Pue(d,b,3,3,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35665){Oue(d,0,b,3,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35673){Oue(d,2,b,4,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==5126){Oue(d,0,b,1,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35676){Pue(d,b,4,4,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35667){Oue(d,1,b,2,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35671){Oue(d,2,b,2,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35666){Oue(d,0,b,4,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else if((H|0)==35669){Oue(d,1,b,4,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,h,k,N,e);break a}else{switch(H|0){case 36293:case 35682:case 35680:{O=(H|0)==35682?2:4;break}case 35678:{O=2;break}case 35679:{if(!f)break a;j=(c[r>>2]|0)-(c[E>>2]|0)>>4;In[c[1064952+320>>2]&4095](c[t>>2]|0,j);Lqc(d,j,-1,h,3,e);break a;break}default:break a}if(!f)break a;j=(c[r>>2]|0)-(c[E>>2]|0)>>4;In[c[1064952+320>>2]&4095](c[t>>2]|0,j);Lqc(d,j,-1,h,O,e);break a}while(0)}}while(0);p=(c[s>>2]|0)+1|0;c[s>>2]=p}while((p|0)<(C|0));i=g;return}function Rue(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+48|0;j=h;k=Nqc(e)|0;e=c[k>>2]|0;l=c[k+8>>2]|0;k=e+(l*20|0)|0;if(!l){i=h;return}if(!g){l=e;do{do if((a[l+18>>0]|0)==0?(c[l+8>>2]|0)==1:0){m=f+((c[l>>2]&1073741823)<<4)|0;n=d[l+17>>0]|0;if((n|0)==3){cwe(b,c[l+12>>2]|0,c[l+4>>2]|0,m);break}else if((n|0)==1){awe(b,c[l+12>>2]|0,c[l+4>>2]|0,m);break}else if((n|0)==4){dwe(b,c[l+12>>2]|0,c[l+4>>2]|0,m);break}else if((n|0)==2){bwe(b,c[l+12>>2]|0,c[l+4>>2]|0,m);break}else break}else o=5;while(0);do if((o|0)==5){o=0;m=f+((c[l>>2]&1073741823)<<6)+2720|0;if((a[l+16>>0]|0)==3?(a[l+17>>0]|0)==3:0){TLc(j,m);Dn[c[1064952+352>>2]&511](c[l+4>>2]|0,1,0,j);break}Dn[c[1064952+356>>2]&511](c[l+4>>2]|0,1,0,m)}while(0);l=l+20|0}while((l|0)!=(k|0));i=h;return}else{l=e;do{do if((a[l+18>>0]|0)==0?(c[l+8>>2]|0)==1:0){e=c[g>>2]|0;c[g>>2]=e+16;f=d[l+17>>0]|0;if((f|0)==2){bwe(b,c[l+12>>2]|0,c[l+4>>2]|0,e);break}else if((f|0)==1){awe(b,c[l+12>>2]|0,c[l+4>>2]|0,e);break}else if((f|0)==4){dwe(b,c[l+12>>2]|0,c[l+4>>2]|0,e);break}else if((f|0)==3){cwe(b,c[l+12>>2]|0,c[l+4>>2]|0,e);break}else break}else o=22;while(0);do if((o|0)==22){o=0;e=c[g>>2]|0;f=e+4|0;c[g>>2]=e+((c[e>>2]<<2)+4);if((a[l+16>>0]|0)==3?(a[l+17>>0]|0)==3:0){TLc(j,f);Dn[c[1064952+352>>2]&511](c[l+4>>2]|0,1,0,j);break}Dn[c[1064952+356>>2]&511](c[l+4>>2]|0,1,0,f)}while(0);l=l+20|0}while((l|0)!=(k|0));i=h;return}}function Sue(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+8|0;h=c[a>>2]|0;j=h;if((((c[g>>2]|0)-j|0)/28|0)>>>0>=b>>>0){i=d;return}k=a+4|0;l=c[k>>2]|0;if(!b)m=0;else m=xCi(b*28|0)|0;n=m+(((l-j|0)/28|0)*28|0)|0;j=m+(b*28|0)|0;if((l|0)!=(h|0)){b=l;l=n;while(1){m=b;b=b+-28|0;c[l+-28>>2]=c[b>>2];o=c[m+-20>>2]|0;c[l+-20>>2]=o;p=l+-16|0;c[p>>2]=0;q=l+-12|0;c[q>>2]=0;r=l+-24|0;c[r>>2]=0;s=c[m+-24>>2]|0;t=(c[m+-16>>2]|0)*20|0;u=(t|0)/20|0;c[p>>2]=u;if(!t){v=u;w=0}else{c[q>>2]=u;c[f>>2]=o;c[e+0>>2]=c[f+0>>2];o=hOb(0,t,4,e,0,3653512,370)|0;c[r>>2]=o;v=c[p>>2]|0;w=o}YEi(w|0,s|0,v*20|0)|0;s=m+-8|0;m=c[s+4>>2]|0;o=l+-8|0;c[o>>2]=c[s>>2];c[o+4>>2]=m;m=l+-28|0;if((b|0)==(h|0)){x=m;break}else l=m}l=c[a>>2]|0;b=c[k>>2]|0;c[a>>2]=x;c[k>>2]=n;c[g>>2]=j;if((b|0)==(l|0))y=l;else{x=b;do{if((c[x+-12>>2]|0)>-1){b=x+-24|0;v=c[b>>2]|0;c[f>>2]=c[x+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(v,e);c[b>>2]=0}x=x+-28|0}while((x|0)!=(l|0));y=l}}else{c[a>>2]=n;c[k>>2]=n;c[g>>2]=j;y=h}if(!y){i=d;return}ACi(y);i=d;return}function Tue(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+16|0;e=d+4|0;f=d;g=a+4|0;h=c[a>>2]|0;j=(((c[g>>2]|0)-h|0)/28|0)+1|0;if(j>>>0>153391689)vxi(a);k=a+8|0;l=h;m=((c[k>>2]|0)-l|0)/28|0;if(m>>>0<76695844){n=m<<1;m=n>>>0<j>>>0?j:n;n=c[g>>2]|0;j=(n-l|0)/28|0;if(!m){o=0;p=n;q=0;r=j}else{s=m;t=j;u=n;v=6}}else{n=c[g>>2]|0;s=153391689;t=(n-l|0)/28|0;u=n;v=6}if((v|0)==6){o=s;p=u;q=xCi(s*28|0)|0;r=t}t=q+(r*28|0)|0;s=q+(o*28|0)|0;if(!t){w=p;x=h}else{c[t>>2]=c[b>>2];h=c[b+8>>2]|0;c[q+(r*28|0)+8>>2]=h;p=q+(r*28|0)+12|0;o=q+(r*28|0)+16|0;c[o>>2]=0;u=q+(r*28|0)+4|0;c[u>>2]=0;v=c[b+4>>2]|0;n=(c[b+12>>2]|0)*20|0;l=(n|0)/20|0;c[p>>2]=l;if(!n){y=l;z=0}else{c[o>>2]=l;c[f>>2]=h;c[e+0>>2]=c[f+0>>2];h=hOb(0,n,4,e,0,3653512,370)|0;c[u>>2]=h;y=c[p>>2]|0;z=h}YEi(z|0,v|0,y*20|0)|0;y=b+20|0;b=c[y+4>>2]|0;v=q+(r*28|0)+20|0;c[v>>2]=c[y>>2];c[v+4>>2]=b;w=c[g>>2]|0;x=c[a>>2]|0}b=q+((r+1|0)*28|0)|0;if((w|0)!=(x|0)){r=w;q=t;while(1){v=r;r=r+-28|0;c[q+-28>>2]=c[r>>2];y=c[v+-20>>2]|0;c[q+-20>>2]=y;z=q+-16|0;c[z>>2]=0;h=q+-12|0;c[h>>2]=0;p=q+-24|0;c[p>>2]=0;u=c[v+-24>>2]|0;n=(c[v+-16>>2]|0)*20|0;l=(n|0)/20|0;c[z>>2]=l;if(!n){A=l;B=0}else{c[h>>2]=l;c[f>>2]=y;c[e+0>>2]=c[f+0>>2];y=hOb(0,n,4,e,0,3653512,370)|0;c[p>>2]=y;A=c[z>>2]|0;B=y}YEi(B|0,u|0,A*20|0)|0;u=v+-8|0;v=c[u+4>>2]|0;y=q+-8|0;c[y>>2]=c[u>>2];c[y+4>>2]=v;v=q+-28|0;if((r|0)==(x|0)){C=v;break}else q=v}q=c[a>>2]|0;x=c[g>>2]|0;c[a>>2]=C;c[g>>2]=b;c[k>>2]=s;if((x|0)==(q|0))D=q;else{C=x;do{if((c[C+-12>>2]|0)>-1){x=C+-24|0;r=c[x>>2]|0;c[f>>2]=c[C+-20>>2];c[e+0>>2]=c[f+0>>2];eOb(r,e);c[x>>2]=0}C=C+-28|0}while((C|0)!=(q|0));D=q}}else{c[a>>2]=t;c[g>>2]=b;c[k>>2]=s;D=w}if(!D){i=d;return}ACi(D);i=d;return}function Uue(d,e){d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;d=i;i=i+96|0;f=d;h=d+16|0;j=d+36|0;k=d+32|0;l=d+40|0;m=d+4|0;n=d+20|0;o=d+44|0;p=d+56|0;q=d+68|0;r=d+80|0;c[e+60>>2]=0;c[e+64>>2]=0;s=mo[c[1064952+232>>2]&4095](7937)|0;t=(s|0)!=0?s:1070048;s=SEi(t|0)|0;if(s>>>0>2147483631)ori(m);if(s>>>0<11){a[m>>0]=s<<1;u=m+1|0}else{v=s+16&-16;c[h>>2]=59;c[f+0>>2]=c[h+0>>2];w=cOb(v,16,f,0,3653512,80)|0;c[m+8>>2]=w;c[m>>2]=v|1;c[m+4>>2]=s;u=w}YEi(u|0,t|0,s|0)|0;a[u+s>>0]=0;do if((e|0)!=(m|0)){s=a[m>>0]|0;if(!(s&1)){x=(s&255)>>>1;y=m+1|0}else{x=c[m+4>>2]|0;y=c[m+8>>2]|0}s=a[e>>0]|0;if(!(s&1)){z=10;A=s}else{s=c[e>>2]|0;z=(s&-2)+-1|0;A=s&255}s=(A&1)==0;if(x>>>0>z>>>0){if(s)B=(A&255)>>>1;else B=c[e+4>>2]|0;wqc(e,z,x-z|0,B,0,B,x,y);break}if(s)C=e+1|0;else C=c[e+8>>2]|0;aFi(C|0,y|0,x|0)|0;a[C+x>>0]=0;if(!(a[e>>0]&1)){a[e>>0]=x<<1;break}else{c[e+4>>2]=x;break}}while(0);if(a[m>>0]&1){x=c[m+8>>2]|0;c[l>>2]=59;c[f+0>>2]=c[l+0>>2];eOb(x,f)}x=mo[c[1064952+232>>2]&4095](7936)|0;l=e+12|0;m=(x|0)!=0?x:1070048;x=SEi(m|0)|0;if(x>>>0>2147483631)ori(n);if(x>>>0<11){a[n>>0]=x<<1;D=n+1|0}else{C=x+16&-16;c[h>>2]=59;c[f+0>>2]=c[h+0>>2];y=cOb(C,16,f,0,3653512,80)|0;c[n+8>>2]=y;c[n>>2]=C|1;c[n+4>>2]=x;D=y}YEi(D|0,m|0,x|0)|0;a[D+x>>0]=0;do if((l|0)!=(n|0)){x=a[n>>0]|0;if(!(x&1)){E=(x&255)>>>1;F=n+1|0}else{E=c[n+4>>2]|0;F=c[n+8>>2]|0}x=a[l>>0]|0;if(!(x&1)){G=10;H=x}else{x=c[l>>2]|0;G=(x&-2)+-1|0;H=x&255}x=(H&1)==0;if(E>>>0>G>>>0){if(x)I=(H&255)>>>1;else I=c[e+16>>2]|0;wqc(l,G,E-G|0,I,0,I,E,F);break}if(x)J=l+1|0;else J=c[e+20>>2]|0;aFi(J|0,F|0,E|0)|0;a[J+E>>0]=0;if(!(a[l>>0]&1)){a[l>>0]=E<<1;break}else{c[e+16>>2]=E;break}}while(0);if(a[n>>0]&1){E=c[n+8>>2]|0;c[k>>2]=59;c[f+0>>2]=c[k+0>>2];eOb(E,f)}E=mo[c[1064952+232>>2]&4095](7938)|0;k=e+24|0;n=(E|0)!=0?E:1070048;E=SEi(n|0)|0;if(E>>>0>2147483631)ori(o);if(E>>>0<11){a[o>>0]=E<<1;K=o+1|0}else{J=E+16&-16;c[h>>2]=59;c[f+0>>2]=c[h+0>>2];F=cOb(J,16,f,0,3653512,80)|0;c[o+8>>2]=F;c[o>>2]=J|1;c[o+4>>2]=E;K=F}YEi(K|0,n|0,E|0)|0;a[K+E>>0]=0;do if((k|0)!=(o|0)){E=a[o>>0]|0;if(!(E&1)){L=(E&255)>>>1;M=o+1|0}else{L=c[o+4>>2]|0;M=c[o+8>>2]|0}E=a[k>>0]|0;if(!(E&1)){N=10;O=E}else{E=c[k>>2]|0;N=(E&-2)+-1|0;O=E&255}E=(O&1)==0;if(L>>>0>N>>>0){if(E)P=(O&255)>>>1;else P=c[e+28>>2]|0;wqc(k,N,L-N|0,P,0,P,L,M);break}if(E)Q=k+1|0;else Q=c[e+32>>2]|0;aFi(Q|0,M|0,L|0)|0;a[Q+L>>0]=0;if(!(a[k>>0]&1)){a[k>>0]=L<<1;break}else{c[e+28>>2]=L;break}}while(0);if(a[o>>0]&1){L=c[o+8>>2]|0;c[j>>2]=59;c[f+0>>2]=c[j+0>>2];eOb(L,f)}L=e+48|0;a[p>>0]=6;j=p+1|0;a[j+0>>0]=a[1070064]|0;a[j+1>>0]=a[1070065]|0;a[j+2>>0]=a[1070066]|0;a[p+4>>0]=0;a:do if((L|0)!=(p|0)){o=a[L>>0]|0;do if(!(o&1))if(!(o&1))R=79;else R=78;else{Q=c[L>>2]|0;M=Q&-2;P=M+-1|0;N=(Q&1|0)==0;if(P>>>0>=3)if(N){R=79;break}else{R=78;break}if(N)S=Q>>>1&127;else S=c[e+52>>2]|0;wqc(L,P,4-M|0,S,0,S,3,j);break a}while(0);if((R|0)==78)T=c[e+56>>2]|0;else if((R|0)==79)T=L+1|0;aFi(T|0,j|0,3)|0;a[T+3>>0]=0;if(!(a[L>>0]&1)){a[L>>0]=6;break}else{c[e+52>>2]=3;break}}while(0);if(a[p>>0]&1){T=c[p+8>>2]|0;c[h>>2]=59;c[f+0>>2]=c[h+0>>2];eOb(T,f)}T=e+280|0;h=e+308|0;c[h>>2]=0;c[q>>2]=0;p=q+4|0;c[p>>2]=0;c[q+8>>2]=0;j=a[k>>0]|0;if(!(j&1)){U=k+1|0;V=(j&255)>>>1}else{U=c[e+32>>2]|0;V=c[e+28>>2]|0}rri(r,U,V);Qsd(r,32,q,4);xri(r);r=c[q>>2]|0;V=(c[p>>2]|0)-r|0;do if(((V|0)>24?(Ori(r,1070072)|0)==0:0)?(Ori((c[q>>2]|0)+12|0,1070080)|0)==0:0){U=c[q>>2]|0;j=U+24|0;if(!(a[j>>0]&1))W=j+1|0;else W=c[U+32>>2]|0;c[h>>2]=wEi(W)|0;if((V|0)<=36)break;j=U+36|0;S=a[j>>0]|0;if(!(S&1)){X=(S&255)>>>1;Y=j+1|0}else{X=c[U+40>>2]|0;Y=c[U+44>>2]|0}U=a[L>>0]|0;if(!(U&1)){Z=10;_=U}else{U=c[L>>2]|0;Z=(U&-2)+-1|0;_=U&255}U=(_&1)==0;if(X>>>0>Z>>>0){if(U)$=(_&255)>>>1;else $=c[e+52>>2]|0;wqc(L,Z,X-Z|0,$,0,$,X,Y);break}if(U)aa=L+1|0;else aa=c[e+56>>2]|0;aFi(aa|0,Y|0,X|0)|0;a[aa+X>>0]=0;if(!(a[L>>0]&1)){a[L>>0]=X<<1;break}else{c[e+52>>2]=X;break}}while(0);X=e+36|0;L=a[k>>0]|0;if(!(L&1)){ba=(L&255)>>>1;ca=k+1|0}else{ba=c[e+28>>2]|0;ca=c[e+32>>2]|0}L=a[X>>0]|0;if(!(L&1)){da=10;fa=L}else{L=c[X>>2]|0;da=(L&-2)+-1|0;fa=L&255}L=(fa&1)==0;do if(ba>>>0<=da>>>0){if(L)ga=X+1|0;else ga=c[e+44>>2]|0;aFi(ga|0,ca|0,ba|0)|0;a[ga+ba>>0]=0;if(!(a[X>>0]&1)){a[X>>0]=ba<<1;break}else{c[e+40>>2]=ba;break}}else{if(L)ha=(fa&255)>>>1;else ha=c[e+40>>2]|0;wqc(X,da,ba-da|0,ha,0,ha,ba,ca)}while(0);In[c[1064952+212>>2]&4095](34921,T);In[c[1064952+212>>2]&4095](36348,e+284|0);In[c[1064952+212>>2]&4095](35660,e+292|0);In[c[1064952+212>>2]&4095](3379,e+104|0);In[c[1064952+212>>2]&4095](34076,e+108|0);In[c[1064952+212>>2]&4095](34024,e+112|0);ca=e+92|0;In[c[1064952+212>>2]&4095](35661,ca);ba=c[ca>>2]|0;ha=(ba|0)>32?32:ba;ba=(ha|0)<1?1:ha;c[ca>>2]=ba;c[e+96>>2]=ba;c[e+100>>2]=ba;ba=e+88|0;c[ba>>2]=1;if(!(Kjd(1070088)|0)){ca=Kjd(1070128)|0;a[e+121>>0]=ca&1;if(ca)R=134}else{a[e+121>>0]=1;R=134}if((R|0)==134)In[c[1064952+212>>2]&4095](34047,ba);c[e+72>>2]=4;c[e+68>>2]=30;c[e+84>>2]=8;ba=a[e>>0]|0;R=(ba&1)==0;if(R){ia=(ba&255)>>>1;ja=e+1|0}else{ia=c[e+4>>2]|0;ja=c[e+8>>2]|0}b:do if(ia>>>0<7)ka=0;else{ca=ja+ia|0;ha=ja;if((ia|0)<7){ka=0;break}da=ia+-6|0;X=ja+da|0;if(!da){ka=0;break}else la=ja;c:while(1){if((a[la>>0]|0)==80){da=la;fa=1070168;do{fa=fa+1|0;if((fa|0)==1070175){ma=la;break c}da=da+1|0}while((a[da>>0]|0)==(a[fa>>0]|0))}la=la+1|0;if((la|0)==(X|0)){ka=0;break b}}if((ma|0)==(ca|0)){ka=0;break}ka=(ma-ha|0)!=-1&1}while(0);a[e+332>>0]=ka;if(R){na=(ba&255)>>>1;oa=e+1|0}else{na=c[e+4>>2]|0;oa=c[e+8>>2]|0}d:do if(na>>>0<4)pa=0;else{ma=oa+na|0;la=oa;if((na|0)<4){pa=0;break}ja=na+-3|0;ia=oa+ja|0;if(!ja){pa=0;break}else qa=oa;e:while(1){if((a[qa>>0]|0)==77){ja=qa;X=1070176;do{X=X+1|0;if((X|0)==1070180){ra=qa;break e}ja=ja+1|0}while((a[ja>>0]|0)==(a[X>>0]|0))}qa=qa+1|0;if((qa|0)==(ia|0)){pa=0;break d}}if((ra|0)==(ma|0)){pa=0;break}pa=(ra-la|0)!=-1&1}while(0);a[e+333>>0]=pa;if(R){sa=(ba&255)>>>1;ta=e+1|0}else{sa=c[e+4>>2]|0;ta=c[e+8>>2]|0}f:do if(sa>>>0<6)ua=0;else{ra=ta+sa|0;qa=ta;if((sa|0)<6){ua=0;break}oa=sa+-5|0;na=ta+oa|0;if(!oa){ua=0;break}else va=ta;g:while(1){if((a[va>>0]|0)==65){oa=va;ia=1070184;do{ia=ia+1|0;if((ia|0)==1070190){wa=va;break g}oa=oa+1|0}while((a[oa>>0]|0)==(a[ia>>0]|0))}va=va+1|0;if((va|0)==(na|0)){ua=0;break f}}if((wa|0)==(ra|0)){ua=0;break}ua=(wa-qa|0)!=-1&1}while(0);a[e+334>>0]=ua;if(R){xa=(ba&255)>>>1;ya=e+1|0}else{xa=c[e+4>>2]|0;ya=c[e+8>>2]|0}h:do if(xa>>>0<5)za=0;else{wa=ya+xa|0;va=ya;if((xa|0)<5){za=0;break}ta=xa+-4|0;sa=ya+ta|0;if(!ta){za=0;break}else Aa=ya;i:while(1){if((a[Aa>>0]|0)==84){ta=Aa;na=1070192;do{na=na+1|0;if((na|0)==1070197){Ba=Aa;break i}ta=ta+1|0}while((a[ta>>0]|0)==(a[na>>0]|0))}Aa=Aa+1|0;if((Aa|0)==(sa|0)){za=0;break h}}if((Ba|0)==(wa|0)){za=0;break}za=(Ba-va|0)!=-1&1}while(0);a[e+335>>0]=za;if(R){Ca=(ba&255)>>>1;Da=e+1|0}else{Ca=c[e+4>>2]|0;Da=c[e+8>>2]|0}j:do if(Ca>>>0<5)Ea=0;else{ba=Da+Ca|0;R=Da;if((Ca|0)<5){Ea=0;break}za=Ca+-4|0;Ba=Da+za|0;if(!za){Ea=0;break}else Fa=Da;k:while(1){if((a[Fa>>0]|0)==73){za=Fa;Aa=1070200;do{Aa=Aa+1|0;if((Aa|0)==1070205){Ga=Fa;break k}za=za+1|0}while((a[za>>0]|0)==(a[Aa>>0]|0))}Fa=Fa+1|0;if((Fa|0)==(Ba|0)){Ea=0;break j}}if((Ga|0)==(ba|0)){Ea=0;break}Ea=(Ga-R|0)!=-1&1}while(0);a[e+336>>0]=Ea;a[e+248>>0]=(ka|ua)<<24>>24==0?pa:1;if((c[h>>2]|0)==2)Ha=pa<<24>>24==0?ka:1;else Ha=0;a[e+340>>0]=Ha;a[e+338>>0]=a[621254]|0;Ha=b[310626]|0;a[e+339>>0]=(Ha&255)<<24>>24==0?(Ha&65535)>>>8&255:1;a[e+337>>0]=ka<<24>>24==0?ua:1;do if(Kjd(1070208)|0){if(!(c[266226]|0)){Ia=0;break}Ia=(c[266227]|0)!=0&1}else Ia=0;while(0);a[e+347>>0]=Ia;do if(Kjd(1070232)|0){if(!(c[266228]|0)){Ja=0;break}Ja=(c[266229]|0)!=0&1}else Ja=0;while(0);a[e+348>>0]=Ja;if(Kjd(1070256)|0)Ka=(c[266232]|0)!=0&1;else Ka=0;a[e+367>>0]=Ka;do if(Kjd(1070280)|0){if(!(c[266233]|0)){La=0;break}La=(c[266234]|0)!=0&1}else La=0;while(0);a[e+368>>0]=La;a[e+369>>0]=(Kjd(1070296)|0)&1;a[e+374>>0]=(Kjd(1070320)|0)&1;a[e+376>>0]=0;Vpe()|0;g[e+76>>2]=ea(512.0);La=mo[c[1064952+232>>2]&4095](7939)|0;if(!(a[e>>0]&1))Ma=e+1|0;else Ma=c[e+8>>2]|0;c[f>>2]=Ma;Ird(1070344,f);if(!(a[l>>0]&1))Na=l+1|0;else Na=c[e+20>>2]|0;c[f>>2]=Na;Ird(1070360,f);if(!(a[k>>0]&1))Oa=k+1|0;else Oa=c[e+32>>2]|0;c[f>>2]=Oa;Ird(1070376,f);c[f>>2]=c[h>>2];Ird(1070392,f);if(!La)Ird(1070408,f);else Nrd(La,-1);c[267510]=T;T=c[q>>2]|0;if(!T){i=d;return}while(1){La=c[p>>2]|0;if((La|0)==(T|0))break;f=La+-12|0;c[p>>2]=f;xri(f)}ACi(c[q>>2]|0);i=d;return}function Vue(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;e=(b|0)==8;if(e){f=Kjd(1070448)|0;g=Kjd(1070472)|0;h=Kjd(1070496)|0;j=g;k=f}else{h=1;j=1;k=1}if(!(Kjd(1070528)|0)?!(Kjd(1070560)|0):0)l=Kjd(1070592)|0;else l=1;if(Kjd(1070632)|0)m=1;else m=(Kjd(1070672)|0)&1;if(!(Kjd(1070704)|0)?!(Kjd(1070736)|0):0)n=(Kjd(1070776)|0)&1;else n=1;f=Kjd(1070808)|0;g=(b|0)==11;if(!g?!(Kjd(1070848)|0):0)o=(Kjd(1070888)|0)&1;else o=1;if(!l){if(Kjd(1070920)|0)a[c+148>>0]=1;else a[c+148>>0]=(Kjd(1070952)|0)&1;if(Kjd(1070992)|0)p=1;else p=(Kjd(1071032)|0)&1;a[c+149>>0]=p;if(Kjd(1071072)|0)q=1;else q=(Kjd(1071112)|0)&1}else{a[c+148>>0]=1;a[c+149>>0]=1;q=1}a[c+150>>0]=q;a[c+134>>0]=l&1;PEi(c+168|0,m|0,4)|0;a[c+173>>0]=n;a[c+174>>0]=n;PEi(c+186|0,f&1|0,12)|0;PEi(c+179|0,g&1|0,7)|0;a[c+172>>0]=o;if(!(Kjd(1071152)|0)?!(Kjd(1071192)|0):0)r=(Kjd(1071224)|0)&1;else r=1;a[c+152>>0]=r;if(k&h){r=a[c+336>>0]^1;a[c+153>>0]=r;s=r}else{a[c+153>>0]=0;s=0}a[c+154>>0]=s;if(h)t=a[c+336>>0]^1;else t=0;a[c+155>>0]=t;t=k&j&1;a[c+156>>0]=t;a[c+157>>0]=t;a[c+158>>0]=j&1;a[c+147>>0]=0;a[c+143>>0]=0;a[c+144>>0]=0;a[c+146>>0]=0;a[c+342>>0]=(Kjd(1075904)|0)&1;a[c+343>>0]=(Kjd(1071256)|0)&1;if(e){if((!(Kjd(1071280)|0)?!(Kjd(1071304)|0):0)?!(Kjd(1071328)|0):0)u=(Kjd(1071352)|0)&1;else u=1;t=c+244|0;a[t>>0]=u;u=Kjd(1071376)|0;s=c+246|0;a[s>>0]=u&1;if(u){v=1;w=t;x=s}else{v=a[t>>0]|0;w=t;x=s}}else{s=c+244|0;a[s>>0]=1;t=c+246|0;a[t>>0]=1;v=1;w=s;x=t}a[c+242>>0]=v;a[c+198>>0]=1;a[c+199>>0]=a[w>>0]|0;a[c+201>>0]=a[x>>0]|0;a[c+202>>0]=(Wue(4)|0)&1;a[c+203>>0]=(Wue(5)|0)&1;a[c+204>>0]=(Wue(6)|0)&1;if(j){Kjd(1071400)|0;if(k){a[c+212>>0]=(Wue(14)|0)&1;y=(Wue(12)|0)&1}else{a[c+212>>0]=0;y=0}a[c+210>>0]=y;z=(Wue(11)|0)&1}else{a[c+212>>0]=0;a[c+210>>0]=0;z=0}a[c+209>>0]=z;if(h){Kjd(1071432)|0;if(k){a[c+213>>0]=(Wue(15)|0)&1;A=(Wue(13)|0)&1}else{a[c+213>>0]=0;A=0}a[c+211>>0]=A;B=(Wue(2)|0)&1}else{a[c+213>>0]=0;a[c+211>>0]=0;B=0}a[c+200>>0]=B;if(e){if(!(Kjd(1071464)|0)){a[c+206>>0]=0;a[c+215>>0]=0;a[c+216>>0]=0;C=0;D=c+217|0;a[D>>0]=C;E=c+214|0;F=k&1;a[E>>0]=F;G=c+208|0;a[G>>0]=0;i=d;return}a[c+206>>0]=(Wue(8)|0)&1;if(e){a[c+215>>0]=0;a[c+216>>0]=0;C=0;D=c+217|0;a[D>>0]=C;E=c+214|0;F=k&1;a[E>>0]=F;G=c+208|0;a[G>>0]=0;i=d;return}}else a[c+206>>0]=(Wue(8)|0)&1;a[c+215>>0]=(Wue(17)|0)&1;a[c+216>>0]=(Wue(18)|0)&1;C=(Wue(19)|0)&1;D=c+217|0;a[D>>0]=C;E=c+214|0;F=k&1;a[E>>0]=F;G=c+208|0;a[G>>0]=0;i=d;return}function Wue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=0;In[c[1064952+180>>2]&4095](1,d);In[c[1064952+16>>2]&4095](36160,c[d>>2]|0);f=$ue(a)|0;a=cve(f)|0;g=dve(f)|0;h=eve(f)|0;c[e>>2]=0;In[c[1064952+188>>2]&4095](1,e);In[c[1064952+24>>2]&4095](3553,c[e>>2]|0);co[c[1064952+308>>2]&2047](3553,10240,9728);co[c[1064952+308>>2]&2047](3553,10241,9728);co[c[1064952+308>>2]&2047](3553,10242,33071);co[c[1064952+308>>2]&2047](3553,10243,33071);Yn[c[1064952+304>>2]&15](3553,0,h,16,16,0,g,a,0);En[c[1064952+164>>2]&127](36160,36064,3553,c[e>>2]|0,0);a=mo[c[1064952+44>>2]&4095](36160)|0;In[c[1064952+24>>2]&4095](3553,0);In[c[1064952+16>>2]&4095](36160,0);In[c[1064952+116>>2]&4095](1,e);In[c[1064952+100>>2]&4095](1,d);i=b;return (a|0)==36053|0}function Xue(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+16|0;k=j+4|0;l=j;m=c[d>>2]|0;d=$ue(b)|0;b=(g&64|0)==0;n=xCi(36)|0;o=n+0|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));if(!b){b=c[h>>2]|0;o=c[h+4>>2]|0;p=(c[h+12>>2]|0)!=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+12>>2]=1;a[n+22>>0]=1;c[n+4>>2]=b;c[n+8>>2]=o;a[n+23>>0]=p&1;c[n+16>>2]=64;i=j;return n|0};c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;a[n+22>>0]=1;c[n+4>>2]=c[h>>2];c[n+8>>2]=c[h+4>>2];c[n+32>>2]=f;f=n+16|0;c[f>>2]=g;p=c[h+8>>2]|0;o=c[(c[267510]|0)+8>>2]|0;c[n+12>>2]=p>>>0>o>>>0?o:p;a[n+23>>0]=(c[h+12>>2]|0)!=0&1;c[n>>2]=m;c[n+24>>2]=e;c[n+28>>2]=d;if((m|0)!=0&(e|0)==0){c[l>>2]=m;c[k+0>>2]=c[l+0>>2];_se(k)|0;q=c[f>>2]|0}else q=g;if(q&64){i=j;return n|0}if(q&4)c[n+28>>2]=c[(c[267510]|0)+40>>2];Yue(n);i=j;return n|0}function Yue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b+8|0;e=b;f=b+4|0;g=Bnc()|0;h=c[(c[g>>2]|0)+212>>2]|0;c[f>>2]=c[a>>2];j=a+32|0;k=c[j>>2]|0;c[d+0>>2]=c[f+0>>2];Zn[h&1](g,2,0,0,d,k,ea(x));if(c[a>>2]|0){nve(c[j>>2]|0,c[a+28>>2]|0,c[a+4>>2]|0,c[a+8>>2]|0,(c[a+16>>2]&2|0)!=0);if((c[j>>2]|0)!=2){i=b;return}co[c[1064952+308>>2]&2047](3553,10240,9729);co[c[1064952+308>>2]&2047](3553,10241,9729);co[c[1064952+308>>2]&2047](3553,10242,33071);co[c[1064952+308>>2]&2047](3553,10243,33071);i=b;return}c[e>>2]=0;do if((c[146729]|0)!=(c[146721]|0)){Roc(d,586880,e);k=c[d>>2]|0;g=c[146727]|0;if((k|0)==-1){h=c[146728]|0;l=g;m=h;n=g+(h<<3)|0;break}else{l=g;m=c[146728]|0;n=g+(k<<3)|0;break}}else{k=c[146727]|0;g=c[146728]|0;l=k;m=g;n=k+(g<<3)|0}while(0);if(!((n|0)!=(l+(m<<3)|0)?(c[n+4>>2]|0)!=0:0))o=11;if((o|0)==11?(o=a+24|0,(c[o>>2]|0)==0):0){In[c[1064952+184>>2]&4095](1,o);In[c[1064952+20>>2]&4095](36161,c[o>>2]|0)}ove(c[j>>2]|0,c[a+28>>2]|0,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0);i=b;return}function Zue(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+16|0;k=j+8|0;l=j;m=c[d>>2]|0;d=ave(b)|0;b=(g&64|0)==0;n=xCi(36)|0;o=n+0|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));if(!b){b=c[h>>2]|0;o=c[h+4>>2]|0;p=(c[h+12>>2]|0)!=0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+12>>2]=1;a[n+22>>0]=0;c[n+4>>2]=b;c[n+8>>2]=o;a[n+23>>0]=p&1;c[n+16>>2]=64;i=j;return n|0}c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[n+20>>2]=0;c[n+4>>2]=c[h>>2];c[n+8>>2]=c[h+4>>2];c[n+32>>2]=f;p=n+16|0;c[p>>2]=g;o=c[h+8>>2]|0;b=c[(c[267510]|0)+8>>2]|0;c[n+12>>2]=o>>>0>b>>>0?b:o;a[n+23>>0]=(c[h+12>>2]|0)!=0&1;c[n>>2]=m;c[n+24>>2]=e;c[n+28>>2]=d;if((m|0)!=0&(e|0)==0){c[l>>2]=m;c[k+0>>2]=c[l+0>>2];_se(k)|0;q=c[p>>2]|0}else q=g;g=n+16|0;if(q&64){i=j;return n|0}Yue(n);c[l>>2]=c[n>>2];do if((c[146729]|0)!=(c[146721]|0)){Roc(k,586880,l);q=c[k>>2]|0;p=c[146727]|0;if((q|0)==-1){m=c[146728]|0;r=p;s=m;t=p+(m<<3)|0;break}else{r=p;s=c[146728]|0;t=p+(q<<3)|0;break}}else{q=c[146727]|0;p=c[146728]|0;r=q;s=p;t=q+(p<<3)|0}while(0);if((t|0)==(r+(s<<3)|0)){i=j;return n|0}if(!(c[t+4>>2]|0)){i=j;return n|0}if(!(c[g>>2]&8)){i=j;return n|0}g=c[1074576+(f<<2)>>2]|0;co[c[1064952+308>>2]&2047](g,34892,34894);co[c[1064952+308>>2]&2047](g,34893,515);i=j;return n|0}function _ue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;if(c[a>>2]|0){f=Bnc()|0;g=c[(c[f>>2]|0)+484>>2]|0;c[e>>2]=c[a>>2];c[d+0>>2]=c[e+0>>2];In[g&4095](f,d)}d=a+24|0;if(c[d>>2]|0)In[c[1064952+108>>2]&4095](1,d);if(!a){i=b;return}ACi(a);i=b;return}function $ue(a){a=a|0;return ((2097290>>>a&1|0)!=0?32854:c[1071504+(a<<2)>>2]|0)|0}function ave(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((b|0)==2)if(!(a[621161]|0)){e=c[267510]|0;if(!(a[e+74>>0]|0)){f=e;g=5}else h=33190}else h=35056;else if(!b)h=0;else{f=c[267510]|0;g=5}if((g|0)==5)h=(a[f+89>>0]|0)==0?33189:36396;i=d;return h|0}function bve(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;do switch(b|0){case 20:{f=34836;break}case 10:{if(d)f=(a[(c[267510]|0)+62>>0]|0)!=0?35916:33776;else f=33776;break}case 1:{f=(a[(c[267510]|0)+76>>0]|0)!=0?32828:6406;break}case 12:{if(d)f=(a[(c[267510]|0)+62>>0]|0)!=0?35919:33779;else f=33779;break}case 17:{f=34842;break}case 7:{f=36194;break}case 14:{f=37793;break}case 18:{f=33326;break}case 9:{f=(a[(c[267510]|0)+76>>0]|0)!=0?32837:6410;break}case 11:{if(d)f=(a[(c[267510]|0)+62>>0]|0)!=0?35918:33778;else f=33778;break}case 4:{if(d?(g=c[267510]|0,(a[g+61>>0]|0)!=0):0)f=c[g+40>>2]|0;else f=32856;break}case 3:{if(d?(g=c[267510]|0,(a[g+61>>0]|0)!=0):0)f=c[g+44>>2]|0;else f=32849;break}case 16:{f=33327;break}case 6:{f=34836;break}case 15:{f=33325;break}case 41:{f=37488;break}case 58:{f=37819;break}case 51:{f=37815;break}case 33:{if(d)f=(a[(c[267510]|0)+63>>0]|0)!=0?35415:35842;else f=35842;break}case 48:{f=37808;break}case 34:{f=c[(c[267510]|0)+48>>2]|0;break}case 42:{f=37489;break}case 36:{f=34798;break}case 53:{f=37821;break}case 31:{if(d)f=(a[(c[267510]|0)+63>>0]|0)!=0?35413:35843;else f=35843;break}case 52:{f=37819;break}case 56:{f=37812;break}case 50:{f=37812;break}case 47:{f=37496;break}case 32:{if(d)f=(a[(c[267510]|0)+63>>0]|0)!=0?35414:35840;else f=35840;break}case 57:{f=37815;break}case 35:{f=35986;break}case 55:{f=37810;break}case 59:{f=37821;break}case 13:case 2:{f=32854;break}case 43:{f=37490;break}case 45:{f=37492;break}case 54:{f=37808;break}case 44:{f=37491;break}case 46:{f=37494;break}case 49:{f=37810;break}case 30:{if(d)f=(a[(c[267510]|0)+63>>0]|0)!=0?35412:35841;else f=35841;break}case 19:{f=33328;break}default:f=0}while(0);i=e;return f|0}function cve(a){a=a|0;var b=0,d=0;b=i;do if((a|0)==32855)d=32820;else if((a|0)==33333)d=5124;else if((a|0)==33339)d=5124;else if((a|0)==33326)d=5126;else if((a|0)==33328)d=5126;else if((a|0)==34041)d=34042;else if((a|0)==33325)d=c[(c[267510]|0)+36>>2]|0;else if((a|0)==32857)d=33640;else if((a|0)==32854)d=32819;else if((a|0)==34842)d=c[(c[267510]|0)+36>>2]|0;else if((a|0)==35898)d=35899;else if((a|0)==35056)d=34042;else if((a|0)==36226)d=5124;else if((a|0)==36396)d=5123;else if((a|0)==33327)d=c[(c[267510]|0)+36>>2]|0;else if((a|0)==33190|(a|0)==35906|(a|0)==35907|(a|0)==6410|(a|0)==32837|(a|0)==6406|(a|0)==32828|(a|0)==33321|(a|0)==32849|(a|0)==37793|(a|0)==32856)d=5121;else if((a|0)==36194)d=33635;else if((a|0)==33189)d=5123;else if((a|0)==34836)d=5126;else d=0;while(0);i=b;return d|0}function dve(a){a=a|0;var b=0,c=0;b=i;do if((a|0)==33321)c=6403;else if((a|0)==37793)c=32993;else if((a|0)==6406)c=a;else if((a|0)==33339)c=33320;else if((a|0)==36226)c=36249;else if((a|0)==32828)c=6406;else if((a|0)==33328)c=33319;else if((a|0)==36194)c=6407;else if((a|0)==33327)c=33319;else if((a|0)==33189)c=6402;else if((a|0)==33325)c=6403;else if((a|0)==35056)c=34041;else if((a|0)==33190)c=6402;else if((a|0)==32849)c=6407;else if((a|0)==33333)c=36244;else if((a|0)==33326)c=6403;else if((a|0)==32837)c=6410;else if((a|0)==36396)c=6402;else if((a|0)==6410)c=a;else if((a|0)==35906|(a|0)==35907|(a|0)==32857|(a|0)==32855|(a|0)==32854|(a|0)==34836|(a|0)==34842|(a|0)==32856)c=6408;else if((a|0)==35898)c=6407;else if((a|0)==34041)c=a;else c=0;while(0);i=b;return c|0}function eve(b){b=b|0;var d=0,e=0;d=i;a:do if(!(a[(c[267510]|0)+77>>0]|0))do if((b|0)==33321){e=6403;break a}else if((b|0)==32828){e=6406;break a}else if((b|0)==33333){e=36244;break a}else if((b|0)==33328){e=33319;break a}else if((b|0)==37793){e=32993;break a}else if((b|0)==36226){e=36249;break a}else if((b|0)==32837){e=6410;break a}else if((b|0)==36194){e=6407;break a}else if((b|0)==6410){e=b;break a}else if((b|0)==33326){e=6403;break a}else if((b|0)==36396){e=6402;break a}else if((b|0)==35906|(b|0)==35907|(b|0)==32857|(b|0)==32855|(b|0)==32854|(b|0)==34836|(b|0)==34842|(b|0)==32856){e=6408;break a}else if((b|0)==34041){e=b;break a}else if((b|0)==35898){e=6407;break a}else if((b|0)==33339){e=33320;break a}else if((b|0)==33325){e=6403;break a}else if((b|0)==35056){e=34041;break a}else if((b|0)==33189){e=6402;break a}else if((b|0)==6406){e=b;break a}else if((b|0)==33327){e=33319;break a}else if((b|0)==32849){e=6407;break a}else if((b|0)==33190){e=6402;break a}else{e=0;break a}while(0);else e=b;while(0);i=d;return e|0}function fve(a){a=a|0;var b=0,c=0;b=i;switch(a|0){case 37821:case 37819:case 37815:case 37812:case 37810:case 37808:case 37496:case 37494:case 37491:case 37490:case 37489:case 37488:case 37492:case 36196:case 34798:case 35986:case 35842:case 35840:case 35843:case 35841:case 35919:case 35918:case 35916:case 33779:case 33778:case 33776:{c=1;break}default:c=0}i=b;return c|0}function gve(b){b=b|0;var d=0,e=0;d=i;if((a[(c[267510]|0)+76>>0]|0)==0?(b|0)==6406|(b|0)==6410|(b|0)==32828|(b|0)==32837:0)e=0;else e=1;i=d;return e|0}function hve(a){a=a|0;var b=0,c=0;b=i;do switch(a|0){case 36226:{c=17;break}case 33321:{c=16;break}case 33333:{c=19;break}case 33328:{c=12;break}case 36194:{c=4;break}case 33339:{c=18;break}case 32857:{c=8;break}case 34836:{c=11;break}case 33327:{c=13;break}case 37793:{c=20;break}case 32854:{c=5;break}case 33325:{c=15;break}case 33326:{c=14;break}case 34842:{c=2;break}case 32855:{c=6;break}default:c=0}while(0);i=b;return c|0}function ive(a){a=a|0;var b=0,c=0;b=i;do if((a|0)==34836)c=20;else if((a|0)==33776)c=10;else if((a|0)==33326)c=18;else if((a|0)==37490)c=43;else if((a|0)==6406)c=1;else if((a|0)==33328)c=19;else if((a|0)==32856)c=4;else if((a|0)==35919)c=12;else if((a|0)==37793)c=14;else if((a|0)==6410)c=9;else if((a|0)==37494)c=46;else if((a|0)==35907)c=4;else if((a|0)==32849)c=3;else if((a|0)==35916)c=10;else if((a|0)==34842)c=17;else if((a|0)==37489)c=42;else if((a|0)==35918)c=11;else if((a|0)==36196)c=34;else if((a|0)==33778)c=11;else if((a|0)==37815)c=51;else if((a|0)==32828)c=1;else if((a|0)==33325)c=15;else if((a|0)==33327)c=16;else if((a|0)==35842)c=33;else if((a|0)==37810)c=49;else if((a|0)==35841)c=30;else if((a|0)==37821)c=53;else if((a|0)==35840)c=32;else if((a|0)==37819)c=52;else if((a|0)==35906)c=4;else if((a|0)==35843)c=31;else if((a|0)==32837)c=9;else if((a|0)==35986)c=35;else if((a|0)==37808)c=48;else if((a|0)==37491)c=44;else if((a|0)==36194)c=7;else if((a|0)==33779)c=12;else if((a|0)==32854)c=2;else if((a|0)==37492)c=45;else if((a|0)==37496)c=47;else if((a|0)==34798)c=36;else if((a|0)==37488)c=41;else if((a|0)==37812)c=50;else c=4;while(0);i=b;return c|0}function jve(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;switch(b|0){case 37810:case 37808:case 37496:case 37494:case 37491:case 37490:case 37489:case 37488:case 37492:case 36196:case 34798:case 35986:case 37821:case 37819:case 37815:case 37812:case 35919:case 35918:case 35916:case 33779:case 33778:case 33776:{d=4;e=4;break}case 35842:case 35840:{f=(a|0)==2?8:16;break}case 35843:case 35841:{f=16;break}default:{d=2;e=4}}if((e|0)==4)f=d;i=c;return f|0}function kve(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=c;switch(b|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{e=3;break}default:if((b+-48|0)>>>0<12)e=3;else f=0}do if((e|0)==3)if(!(a[621058+b>>0]|0)){if((b+-30|0)>>>0<4){Ird(1071592,d);f=1;break}if((b+-10|0)>>>0<3){Ird(1071664,d);f=1;break}if((b|0)==34){Ird(1071736,d);f=1;break}if((b+-35|0)>>>0<2){Ird(1071808,d);f=1}else f=1}else f=0;while(0);i=c;return f|0}function lve(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=c;switch(b|0){case 10:case 11:case 12:case 30:case 31:case 32:case 33:case 34:case 35:case 36:case 41:case 42:case 43:case 44:case 45:case 46:case 47:{e=3;break}default:if((b+-48|0)>>>0<12)e=3;else e=12}do if((e|0)==3)if(!(a[621058+b>>0]|0)){if((b+-30|0)>>>0<4){Ird(1071592,d);f=4;break}if((b+-10|0)>>>0<3){Ird(1071664,d);f=4;break}if((b|0)==34){Ird(1071736,d);f=4;break}if((b+-35|0)>>>0<2){Ird(1071808,d);f=4}else f=4}else e=12;while(0);do if((e|0)==12){if((b|0)==14){if(!(a[621072]|0)){f=4;break}}else if((b|0)==6){if(!(a[621064]|0)){f=4;break}}else if((b|0)==5){f=4;break}else if((b|0)==8){f=3;break}f=b}while(0);i=c;return f|0}function mve(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;if(!(a[(c[267510]|0)+75>>0]|0)){l=h;i=j;return l|0}if(!(gve(d)|0)){l=h;i=j;return l|0}c[k>>2]=0;m=c[1074576+(b<<2)>>2]|0;co[c[1064952+236>>2]&2047](m,37167,k);if((c[k>>2]|0)==1){l=h;i=j;return l|0}if((h|0)>1){k=jve(b,d)|0;n=cwc(k,k,g)|0;if((n|0)>(h|0))o=1;else o=h+1-n|0}else o=h;if((b|0)==3)rn[c[1064952+516>>2]&127](32879,o,d,e,f,g);else En[c[1064952+512>>2]&127](m,o,d,e,f);if(!(a[621043]|0)){l=o;i=j;return l|0}co[c[1064952+308>>2]&2047](m,33085,o+-1|0);l=o;i=j;return l|0}function nve(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;if(g)j=cwc(e,f,1)|0;else j=1;mve(b,d,e,f,1,j)|0;if((a[(c[267510]|0)+75>>0]|0)!=0?gve(d)|0:0){i=h;return}j=cve(d)|0;k=dve(d)|0;l=eve(d)|0;d=c[266314]|0;if((b|0)==2)Yn[d&15](3553,0,l,e,f,0,k,j,0);else{Yn[d&15](34069,0,l,e,f,0,k,j,0);Yn[c[1064952+304>>2]&15](34070,0,l,e,f,0,k,j,0);Yn[c[1064952+304>>2]&15](34071,0,l,e,f,0,k,j,0);Yn[c[1064952+304>>2]&15](34072,0,l,e,f,0,k,j,0);Yn[c[1064952+304>>2]&15](34073,0,l,e,f,0,k,j,0);Yn[c[1064952+304>>2]&15](34074,0,l,e,f,0,k,j,0)}if(!g){i=h;return}ko[c[1064952+176>>2]&4095](c[1074576+(b<<2)>>2]|0);i=h;return}function ove(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;b=i;if((g|0)<2|(a[621046]|0)==0){Dn[c[1064952+272>>2]&511](36161,d,e,f);i=b;return}else{En[c[1064952+424>>2]&127](36161,g,d,e,f);i=b;return}}function pve(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+32|0;n=l+16|0;o=l+12|0;p=l+8|0;q=l+4|0;r=l;s=c[a>>2]|0;c[q>>2]=s;c[n+0>>2]=c[q+0>>2];_se(n)|0;q=c[266694]|0;c[r>>2]=s;c[n+0>>2]=c[r+0>>2];Jte(q,n,b,0);In[c[1064952+260>>2]&4095](3317,1);q=(m+-1|0)>>>0<2;m=lve(d)|0;r=kve(d)|0;s=(m|0)==(d|0);a=mve(b,bve(m,q)|0,g,h,j,k)|0;k=c[1071936+(b<<2)>>2]|0;if((b+-2|0)>>>0>=3){i=l;return}t=(a|0)>0;u=c[1071912+(b<<2)>>2]|0;v=0;do{w=c[1071880+(u+v<<2)>>2]|0;x=da(v,f)|0;a:do if(r){y=bve(4,q)|0;z=YFc(d)|0;A=da(dwc((z|0)>(g|0)?z:g,(z|0)>(h|0)?z:h,4)|0,j)|0;c[o>>2]=c[153134];c[n+0>>2]=c[o+0>>2];B=cOb(A,16,n,0,3653512,265)|0;if(t){A=0;C=0;while(1){D=g>>A;E=(D|0)<1?1:D;D=h>>A;F=(D|0)<1?1:D;D=j>>A;G=(D|0)<1?1:D;D=da(G,dwc(E,F,d)|0)|0;zCc(d,E,F,e+(C+x)|0,(E|0)<(z|0)?z:E,(F|0)<(z|0)?z:F,B)|0;rve(b,w,y,A,E,F,G,B);A=A+1|0;if((A|0)==(a|0))break;else C=D+C|0}}c[p>>2]=c[153134];c[n+0>>2]=c[p+0>>2];eOb(B,n)}else{if(s){C=bve(d,q)|0;if(t){H=0;I=0}else break;while(1){A=g>>H;y=(A|0)<1?1:A;A=h>>H;z=(A|0)<1?1:A;A=j>>H;D=(A|0)<1?1:A;A=da(D,dwc(y,z,d)|0)|0;rve(b,w,C,H,y,z,D,e+(I+x)|0);H=H+1|0;if((H|0)==(a|0))break a;else I=A+I|0}}C=bve(m,q)|0;B=YFc(d)|0;A=da(dwc((B|0)>(g|0)?B:g,(B|0)>(h|0)?B:h,m)|0,j)|0;c[o>>2]=c[153134];c[n+0>>2]=c[o+0>>2];B=cOb(A,16,n,0,3653512,290)|0;if(t){A=0;D=0;while(1){z=g>>A;y=(z|0)<1?1:z;z=h>>A;G=(z|0)<1?1:z;z=j>>A;F=(z|0)<1?1:z;z=da(F,dwc(y,G,d)|0)|0;sve(d,m,y,G,F,e+(D+x)|0,B);rve(b,w,C,A,y,G,F,B);A=A+1|0;if((A|0)==(a|0))break;else D=z+D|0}}c[p>>2]=c[153134];c[n+0>>2]=c[p+0>>2];eOb(B,n)}while(0);v=v+1|0}while((v|0)<(k|0));i=l;return}function qve(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=i;i=i+32|0;m=l+16|0;n=l+12|0;o=l+8|0;p=l+4|0;q=l;r=(k+-1|0)>>>0<2;k=lve(b)|0;s=bve(k,r)|0;t=c[a>>2]|0;c[p>>2]=t;c[m+0>>2]=c[p+0>>2];_se(m)|0;p=c[266694]|0;c[q>>2]=t;c[m+0>>2]=c[q+0>>2];Jte(p,m,2,0);In[c[1064952+260>>2]&4095](3317,1);if((k|0)==(b|0))if(fve(s)|0){p=dwc(h,j,ive(s)|0)|0;Yn[c[1064952+76>>2]&15](3553,e,f,g,h,j,s,p,d);i=l;return}else{p=cve(s)|0;q=dve(s)|0;Yn[c[1064952+312>>2]&15](3553,e,f,g,h,j,q,p,d);i=l;return}else{p=bve(k,r)|0;r=YFc(b)|0;q=dwc((r|0)>(h|0)?r:h,(r|0)>(j|0)?r:j,k)|0;c[n>>2]=c[153134];c[m+0>>2]=c[n+0>>2];n=cOb(q,16,m,0,3653512,315)|0;sve(b,k,h,j,1,d,n);if(fve(p)|0){d=dwc(h,j,ive(p)|0)|0;Yn[c[1064952+76>>2]&15](3553,e,f,g,h,j,p,d,n)}else{d=cve(p)|0;k=dve(p)|0;Yn[c[1064952+312>>2]&15](3553,e,f,g,h,j,k,d,n)}c[o>>2]=c[153134];c[m+0>>2]=c[o+0>>2];eOb(n,m);i=l;return}}function rve(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=i;if((a[(c[267510]|0)+75>>0]|0)!=0?gve(e)|0:0){tve(b,d,e,f,0,0,g,h,j,k);i=l;return}if(fve(e)|0){m=dwc(g,h,ive(e)|0)|0;Nn[c[1064952+72>>2]&31](d,f,e,g,h,0,m,k);i=l;return}m=cve(e)|0;n=dve(e)|0;o=eve(e)|0;if((b|0)==2|(b|0)==4){Yn[c[1064952+304>>2]&15](d,f,o,g,h,0,n,m,k);i=l;return}else{yn[c[1064952+384>>2]&7](d,f,o,g,h,j,0,n,m,k);i=l;return}}function sve(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+48|0;j=h+20|0;k=h;l=dwc(c,d,a)|0;m=dwc(c,d,b)|0;if((e|0)>0)n=0;else{i=h;return}do{o=f+(da(n,l)|0)|0;p=g+(da(n,m)|0)|0;iwc(j,c,d,VFc(c,a)|0,a,o);iwc(k,c,d,VFc(c,b)|0,b,p);hwc(k,j,0);n=n+1|0}while((n|0)!=(e|0));i=h;return}function tve(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=i;if(fve(d)|0){n=dwc(h,j,ive(d)|0)|0;Yn[c[1064952+76>>2]&15](b,e,f,g,h,j,d,n,l);i=m;return}n=cve(d)|0;o=dve(d)|0;if((a|0)==2|(a|0)==4){Yn[c[1064952+312>>2]&15](b,e,f,g,h,j,o,n,l);i=m;return}else{Mm[c[1064952+388>>2]&3](b,e,f,g,0,h,j,k,o,n,l);i=m;return}}function uve(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=j;l=j+24|0;m=j+20|0;n=j+8|0;o=j+16|0;p=j+4|0;q=j+12|0;r=j+28|0;s=j+32|0;c[m>>2]=0;In[c[1064952+212>>2]&4095](36006,m);a:do if((b|0)!=0?(a[(c[267510]|0)+69>>0]|0)!=0:0){switch(c[d+28>>2]|0){case 34836:case 34837:case 33328:case 33326:case 34842:case 34843:case 33327:case 33325:{t=1;break}default:t=0}switch(c[b+28>>2]|0){case 34836:case 34837:case 33328:case 33326:case 34842:case 34843:case 33327:case 33325:{if(t){u=8;break a}else{u=11;break a}break}default:if(t){u=11;break a}else{u=8;break a}}}else u=8;while(0);do if((u|0)==8)if(!(a[d+23>>0]|0))if((c[d+12>>2]|0)>>>0>1){u=11;break}else{v=0;break}else{c[l>>2]=0;In[c[1064952+212>>2]&4095](32937,l);if((c[l>>2]|0)>0){u=11;break}else{v=0;break}}while(0);do if((u|0)==11){l=c[267510]|0;if((a[l+91>>0]|0)==0?(a[l+69>>0]|0)==0:0){v=0;break}if(((f|e|0)==0?(c[d+4>>2]|0)==(g|0):0)?(c[d+8>>2]|0)==(h|0):0){vve(b,0);In[c[1064952+16>>2]&4095](36160,c[m>>2]|0);i=j;return}v=yve(b)|0}while(0);d=Bnc()|0;u=c[(c[d>>2]|0)+212>>2]|0;c[n>>2]=c[b>>2];c[k+0>>2]=c[n+0>>2];Zn[u&1](d,2,0,0,k,2,ea(x));In[c[1064952+260>>2]&4095](3317,1);c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;In[c[1064952+212>>2]&4095](3410,o);In[c[1064952+212>>2]&4095](3411,p);In[c[1064952+212>>2]&4095](3412,q);In[c[1064952+212>>2]&4095](3413,r);do if((c[o>>2]|0)==8&(c[p>>2]|0)==8&(c[q>>2]|0)==8&(c[r>>2]|0)==0){d=c[b+28>>2]|0;if((d|0)==32856){u=da(h,g)|0;n=zCi((u|0)<0?-1:u<<2)|0;Wn[c[1064952+268>>2]&127](e,f,g,h,6408,5121,n);rve(2,3553,32856,0,g,h,0,n);BCi(n);break}c[k>>2]=d;Lsd(s,1071960,k);if(!(a[s>>0]&1))w=s+1|0;else w=c[s+8>>2]|0;Krd(w,0,3653512,110,1,0,0,0);xri(s)}else Nn[c[1064952+80>>2]&31](3553,0,0,0,e,f,g,h);while(0);if(!v){i=j;return}In[c[1064952+16>>2]&4095](36160,c[m>>2]|0);que(v);_ue(v);i=j;return}function vve(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=c[267510]|0;if((a[f+91>>0]|0)==0?(a[f+69>>0]|0)==0:0){i=d;return}if(a[(c[266736]|0)+21>>0]|0){f=e;c[f>>2]=0;c[f+4>>2]=0;Lqe(e,1);a[(c[266736]|0)+21>>0]=0}e=c[b+4>>2]|0;f=c[b+8>>2]|0;g=c[266242]|0;h=uue(b)|0;In[g&4095](36009,h);In[c[1064952+16>>2]&4095](36008,c[266782]|0);if(!(a[(c[267510]|0)+69>>0]|0))eo[c[1064904+20>>2]&511]();else yn[c[1064952+420>>2]&7](0,0,e,f,0,0,e,f,16384,9728);mue();i=d;return}function wve(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+96|0;k=j+80|0;l=j+76|0;m=j+72|0;n=j+40|0;o=j+20|0;p=j;c[k>>2]=0;In[c[1064952+212>>2]&4095](36006,k);q=yve(0)|0;In[c[1064952+260>>2]&4095](3333,1);r=c[a>>2]|0;if((r|0)==5){s=0;t=0}else{u=bve(r,0)|0;v=cve(u)|0;s=dve(u)|0;t=v}In[c[1064952+212>>2]&4095](35739,l);In[c[1064952+212>>2]&4095](35738,m);c[n>>2]=0;v=c[a+16>>2]|0;u=a+12|0;w=da(c[u>>2]|0,h)|0;c[n+4>>2]=v+(w+g);c[n+8>>2]=0;c[n+12>>2]=v+(w+(g*3|0));h=v+(w+(g<<2))|0;c[n+16>>2]=h;c[n+20>>2]=h;c[n+24>>2]=v+(w+(g<<4));c[n+28>>2]=v+(w+(g<<1));g=c[n+(r<<2)>>2]|0;a:do switch(r|0){case 6:case 1:case 3:case 5:case 4:case 7:{n=c[m>>2]|0;if(((t|0)==(n|0)?(s|0)==(c[l>>2]|0):0)?(c[a+4>>2]|0)==(e|0):0){Wn[c[1064952+268>>2]&127](b,d,e,f,s,t,g);x=1;break a}if((n|0)==(c[155309]|0)&(r|0)==6){Wn[c[1064952+268>>2]&127](b,d,e,f,s,t,g);x=1;break a}else{n=bve(4,0)|0;w=cve(n)|0;v=dve(n)|0;n=dwc(e,f,4)|0;h=zCi((n|0)>-1?n:-1)|0;Wn[c[1064952+268>>2]&127](b,d,e,f,v,w,h);iwc(o,e,f,VFc(e,4)|0,4,h);iwc(p,e,f,c[u>>2]|0,c[a>>2]|0,g);hwc(p,o,0);BCi(h);x=1;break a}break}default:x=0}while(0);if(!q){i=j;return x|0}In[c[1064952+16>>2]&4095](36160,c[k>>2]|0);que(q);_ue(q);i=j;return x|0}function xve(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!(a[(c[267510]|0)+69>>0]|0)){i=d;return}f=tue(b)|0;In[c[1064952+16>>2]&4095](36008,c[266782]|0);In[c[1064952+16>>2]&4095](36009,f);c[e>>2]=0;ko[c[1064952+380>>2]&4095](0);In[c[1064952+416>>2]&4095](1,e);e=c[b+4>>2]|0;f=c[b+8>>2]|0;yn[c[1064952+420>>2]&7](0,0,e,f,0,0,e,f,256,9728);pue(1066912);i=d;return}function yve(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+8|0;h=d;j=c[266746]|0;a:do if((b|0)!=0?(a[(c[267510]|0)+69>>0]|0)!=0:0){switch(c[j+28>>2]|0){case 34836:case 34837:case 33328:case 33326:case 34842:case 34843:case 33327:case 33325:{k=1;break}default:k=0}switch(c[b+28>>2]|0){case 34836:case 34837:case 33328:case 33326:case 34842:case 34843:case 33327:case 33325:{if(k){l=8;break a}else break a;break}default:if(k)break a;else{l=8;break a}}}else l=8;while(0);do if((l|0)==8)if(!(a[j+23>>0]|0)){if((c[j+12>>2]|0)>>>0>1)break;else m=0;i=d;return m|0}else{c[f>>2]=0;In[c[1064952+212>>2]&4095](32937,f);if((c[f>>2]|0)>0)break;else m=0;i=d;return m|0}while(0);f=c[267510]|0;if((a[f+91>>0]|0)==0?(a[f+69>>0]|0)==0:0){m=0;i=d;return m|0}f=hve(c[j+28>>2]|0)|0;l=Bnc()|0;k=mo[c[(c[l>>2]|0)+452>>2]&4095](l)|0;c[g>>2]=c[j+4>>2];c[g+4>>2]=c[j+8>>2];c[g+8>>2]=1;c[g+12>>2]=0;c[h>>2]=k;c[e+0>>2]=c[h+0>>2];h=Xue(f,e,0,2,0,g)|0;vve(h,0);g=c[266242]|0;e=uue(h)|0;In[g&4095](36160,e);m=h;i=d;return m|0}function zve(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;b=c[268e3]|0;if((b|0)!=(1072004|0)){d=b;while(1){b=c[d+24>>2]|0;e=c[d+28>>2]|0;if(b)ko[c[1064952+104>>2]&4095](b);if(e)ko[c[1064952+112>>2]&4095](e);e=c[d+4>>2]|0;if(!e){b=d;while(1){f=c[b+8>>2]|0;if((c[f>>2]|0)==(b|0)){g=f;break}else b=f}}else{b=e;while(1){f=c[b>>2]|0;if(!f){g=b;break}else b=f}}if((g|0)==(1072004|0))break;else d=g}}Cve(1072e3,c[268001]|0);c[268002]=0;c[268e3]=1072004;c[268001]=0;g=c[268004]|0;if(!g){i=a;return}ko[c[1064952+112>>2]&4095](g);c[268004]=0;i=a;return}function Ave(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;h=e+7&-8;j=b+4|0;k=b+8|0;if(((h|0)!=(c[j>>2]|0)?(b=c[k>>2]|0,(b|0)!=0):0)?!(_n[c[(c[b>>2]|0)+24>>2]&4095](b,h)|0):0){b=c[k>>2]|0;if(b)ko[c[(c[b>>2]|0)+4>>2]&4095](b);c[k>>2]=0}c[j>>2]=h;b=c[k>>2]|0;do if(!b){if(((((c[155305]|0)/4|0)+-10|0)/3|0)>>>0>h>>>0){l=xCi(20)|0;c[l+4>>2]=0;c[l>>2]=1074528;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[k>>2]=l;m=h;n=l;break}if((a[621266]|0)!=0?(((c[155304]|0)>>>0)/48|0)>>>0>=h>>>0:0){l=xCi(12)|0;c[l+4>>2]=1;c[l>>2]=1074488;c[l+8>>2]=0;c[k>>2]=l;m=h;n=l;break}l=xCi(52)|0;c[l+4>>2]=2;c[l>>2]=1074448;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+32>>2]=0;c[l+36>>2]=0;In[c[1064952+188>>2]&4095](3,l+20|0);o=l+40|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;o=c[k>>2]|0;if(!((o|0)==(l|0)|(o|0)==0))ko[c[(c[o>>2]|0)+4>>2]&4095](o);c[k>>2]=l;m=c[j>>2]|0;n=l}else{m=h;n=b}while(0);b=_n[c[(c[n>>2]|0)+8>>2]&4095](n,m*12|0)|0;m=c[j>>2]|0;if((((m|0)<(e|0)?m:e)|0)<=0){p=c[k>>2]|0;q=c[p>>2]|0;r=q+12|0;s=c[r>>2]|0;ko[s&4095](p);i=f;return}j=~m;m=~e;e=~((j|0)>(m|0)?j:m);m=b;b=0;while(1){g[m>>2]=ea(g[d+(b<<6)>>2]);g[m+4>>2]=ea(g[d+(b<<6)+16>>2]);g[m+8>>2]=ea(g[d+(b<<6)+32>>2]);g[m+12>>2]=ea(g[d+(b<<6)+48>>2]);g[m+16>>2]=ea(g[d+(b<<6)+4>>2]);g[m+20>>2]=ea(g[d+(b<<6)+20>>2]);g[m+24>>2]=ea(g[d+(b<<6)+36>>2]);g[m+28>>2]=ea(g[d+(b<<6)+52>>2]);g[m+32>>2]=ea(g[d+(b<<6)+8>>2]);g[m+36>>2]=ea(g[d+(b<<6)+24>>2]);g[m+40>>2]=ea(g[d+(b<<6)+40>>2]);g[m+44>>2]=ea(g[d+(b<<6)+56>>2]);b=b+1|0;if((b|0)==(e|0))break;else m=m+48|0}p=c[k>>2]|0;q=c[p>>2]|0;r=q+12|0;s=c[r>>2]|0;ko[s&4095](p);i=f;return}function Bve(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+1680|0;m=l;n=l+584|0;o=l+64|0;p=l+1096|0;q=l+40|0;r=l+56|0;s=l+576|0;t=l+1132|0;u=l+1144|0;v=l+1148|0;w=l+1168|0;x=l+1160|0;y=mo[c[c[e>>2]>>2]&4095](e)|0;z=c[(c[e+8>>2]|0)+4>>2]|0;A=_Ei(h<<16|0,0,j|0,0)|0;B=z<<19;C=_Ei(A|0,H|0,y<<25|0,0)|0;A=_Ei(C|0,H|0,B|0,((B|0)<0)<<31>>31|0)|0;B=H;C=c[268001]|0;if(C){D=1072004|0;E=C;a:while(1){C=E;while(1){F=C+16|0;G=c[F+4>>2]|0;if(!(G>>>0<B>>>0|((G|0)==(B|0)?(c[F>>2]|0)>>>0<A>>>0:0))){I=C;break}C=c[C+4>>2]|0;if(!C){J=D;break a}}E=c[I>>2]|0;if(!E){J=I;break}else D=I}if((J|0)!=(1072004|0)?(I=J+16|0,D=c[I+4>>2]|0,!(B>>>0<D>>>0|((B|0)==(D|0)?A>>>0<(c[I>>2]|0)>>>0:0))):0)K=J+24|0;else L=9}else L=9;do if((L|0)==9){c[p>>2]=0;c[q>>2]=0;if((c[268004]|0)==0?(J=mo[c[1064952+88>>2]&4095](35632)|0,c[268004]=J,c[q>>2]=111,c[r>>2]=1072040,Dn[c[1064952+280>>2]&511](J,1,r,q),ko[c[1064952+68>>2]&4095](c[268004]|0),co[c[1064952+224>>2]&2047](c[268004]|0,35713,p),(c[p>>2]|0)!=1):0){PEi(n|0,0,512)|0;c[s>>2]=512;Dn[c[1064952+228>>2]&511](c[268004]|0,512,s,n);c[m>>2]=n;Ird(1072152,m);K=0;break}J=Jo[c[1064952+84>>2]&127]()|0;I=mo[c[1064952+88>>2]&4095](35633)|0;D=n+4|0;c[n>>2]=406548;c[n+56>>2]=406568;esi(n+56|0,D);c[n+128>>2]=0;c[n+132>>2]=-1;c[n>>2]=406492;c[n+56>>2]=406512;jsi(D);c[D>>2]=74048;E=n+36|0;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;c[n+52>>2]=16;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;yN(D,m);xri(m);uN(eti(uN(fti(uN(n,1072440,44)|0,y)|0,1072488,145)|0,0)|0,1072640,21)|0;E=j&1;C=(E|0)!=0;if(C)uN(eti(uN(n,1072664,16)|0,2)|0,1072688,21)|0;F=(j&7|0)!=0;if(F)uN(eti(uN(n,1072664,16)|0,3)|0,1072712,22)|0;if((h|0)==2){uN(eti(uN(n,1072664,16)|0,4)|0,1072768,27)|0;uN(eti(uN(n,1072664,16)|0,5)|0,1072800,27)|0}else if((h|0)==4){uN(eti(uN(n,1072664,16)|0,4)|0,1072832,27)|0;uN(eti(uN(n,1072664,16)|0,5)|0,1072864,27)|0}else uN(eti(uN(n,1072664,16)|0,4)|0,1072736,25)|0;uN(n,1072896,18)|0;if(C)uN(n,1072920,21)|0;if(F)uN(n,1072944,22)|0;uN(n,1072968,1)|0;if(!z)uN(n,1072976,38)|0;else if((z|0)==1)uN(n,1073016,61)|0;else uN(n,1073080,25)|0;uN(n,1073112,24)|0;if(!z)uN(n,1073144,73)|0;else if((z|0)==1)uN(n,1073224,100)|0;else{uN(n,1073328,5)|0;uN(n,1073336,85)|0;uN(n,1073424,83)|0;uN(n,1073512,84)|0}uN(n,1073600,87)|0;if((h|0)==2){uN(n,1073744,77)|0;uN(n,1073824,29)|0;uN(n,1073856,76)|0}else if((h|0)==4){uN(n,1073744,77)|0;uN(n,1073824,29)|0;uN(n,1073856,76)|0;uN(n,1073936,29)|0;uN(n,1073968,76)|0;uN(n,1074048,29)|0;uN(n,1074080,76)|0}else uN(n,1073688,55)|0;uN(n,1074160,84)|0;if(C)uN(n,1074248,80)|0;if(F)uN(n,1074336,103)|0;uN(n,1078048,2)|0;zN(o,D);if(!(a[o>>0]&1))M=o+1|0;else M=c[o+8>>2]|0;rri(t,M,SEi(M|0)|0);xri(o);PO(n);D=a[t>>0]|0;if(!(D&1)){c[q>>2]=(D&255)>>>1;N=t+1|0}else{c[q>>2]=c[t+4>>2];N=c[t+8>>2]|0}c[r>>2]=N;Dn[c[1064952+280>>2]&511](I,1,r,q);ko[c[1064952+68>>2]&4095](I);co[c[1064952+224>>2]&2047](I,35713,p);do if((c[p>>2]|0)==1){In[c[1064952+4>>2]&4095](J,I);In[c[1064952+4>>2]&4095](J,c[268004]|0);c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;if(!E)O=0;else{c[v>>2]=1072312;O=1}if(!(j&2))P=O;else{c[v+(O<<2)>>2]=1072320;P=O+1|0}if(!(j&128))Q=P;else{c[v+(P<<2)>>2]=1072336;Q=P+1|0}Dn[c[1064952+460>>2]&511](J,Q,v,35980);ko[c[1064952+256>>2]&4095](J);co[c[1064952+216>>2]&2047](J,35714,p);if((c[p>>2]|0)!=1){PEi(w|0,0,512)|0;c[x>>2]=512;Dn[c[1064952+220>>2]&511](J,512,x,w);c[m>>2]=w;Ird(1072352,m);R=0;break}if((z|0)==2){D=_n[c[1064952+240>>2]&4095](J,1072416)|0;Gte(c[266694]|0,J);In[c[1064952+320>>2]&4095](D,0);S=D}else if((z|0)==1){D=_n[c[1064952+472>>2]&4095](J,1072424)|0;co[c[1064952+484>>2]&2047](J,D,0);S=D}else S=_n[c[1064952+240>>2]&4095](J,1072416)|0;D=c[268001]|0;do if(D){F=D;while(1){C=F+16|0;G=c[C>>2]|0;T=c[C+4>>2]|0;if(B>>>0<T>>>0|(B|0)==(T|0)&A>>>0<G>>>0){C=c[F>>2]|0;if(!C){U=F;V=F;L=63;break}else{F=C;continue}}if(!(T>>>0<B>>>0|(T|0)==(B|0)&G>>>0<A>>>0)){W=F;L=67;break}G=F+4|0;T=c[G>>2]|0;if(!T){X=G;Y=F;L=66;break}else F=T}if((L|0)==63){c[m>>2]=V;Z=U;_=V;break}else if((L|0)==66){c[m>>2]=Y;Z=X;_=Y;break}else if((L|0)==67){c[m>>2]=W;Z=m;_=W;break}}else{c[m>>2]=1072004;Z=1072004|0;_=1072004|0}while(0);D=c[Z>>2]|0;if(!D){F=xCi(40)|0;T=F+16|0;c[T>>2]=A;c[T+4>>2]=B;c[F+24>>2]=J;c[F+28>>2]=I;c[F+32>>2]=S;c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=_;c[Z>>2]=F;T=c[c[268e3]>>2]|0;if(!T)$=F;else{c[268e3]=T;$=c[Z>>2]|0}GN(c[268001]|0,$);c[268002]=(c[268002]|0)+1;aa=F}else aa=D;R=aa+24|0}else{PEi(o|0,0,512)|0;c[u>>2]=512;Dn[c[1064952+228>>2]&511](I,512,u,o);c[m>>2]=o;Ird(1072232,m);R=0}while(0);xri(t);K=R}while(0);R=b;b=c[R>>2]|0;t=c[R+4>>2]|0;R=c[K>>2]|0;o=c[268007]|0;if(!o){ba=1072028|0;ca=1072028|0}else{u=o;while(1)if(R>>>0<(c[u+16>>2]|0)>>>0){o=c[u>>2]|0;if(!o){ba=u;ca=u;break}else{u=o;continue}}else{o=u+4|0;aa=c[o>>2]|0;if(!aa){ba=o;ca=u;break}else{u=aa;continue}}}u=xCi(56)|0;c[u+16>>2]=R;R=u+20|0;c[R>>2]=b;c[R+4>>2]=t;c[u+28>>2]=K;c[u+32>>2]=f;c[u+36>>2]=e;c[u+40>>2]=d;c[u+44>>2]=g;c[u+48>>2]=h;c[u+52>>2]=j;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=ca;c[ba>>2]=u;ca=c[c[268006]>>2]|0;if(!ca)da=u;else{c[268006]=ca;da=c[ba>>2]|0}GN(c[268007]|0,da);c[268008]=(c[268008]|0)+1;if(!k){i=l;return}ko[c[1064952+144>>2]&4095](35977);k=c[268006]|0;if((k|0)!=(1072028|0)){da=q+8|0;ba=q+12|0;ca=p+4|0;u=p+5|0;j=p+6|0;h=p+7|0;g=p+20|0;d=p+21|0;e=p+22|0;f=p+23|0;K=p+24|0;t=p+25|0;R=p+26|0;b=p+27|0;aa=p+32|0;o=p+33|0;$=p+34|0;Z=p+35|0;_=p+8|0;S=p+9|0;B=p+10|0;A=p+11|0;W=k;while(1){k=c[W+32>>2]|0;Dve(k,c[k+20>>2]|0);L=c[k+24>>2]|0;co[c[1064952+456>>2]&2047](35982,0,c[L+4>>2]|0);k=W+28|0;Gte(c[266694]|0,c[c[k>>2]>>2]|0);Y=W+36|0;X=c[(c[Y>>2]|0)+8>>2]|0;In[c[(c[X>>2]|0)+16>>2]&4095](X,c[(c[k>>2]|0)+8>>2]|0);hnc(m);inc(m,0,0);k=W+52|0;X=c[k>>2]|0;if(!(X&2))ea=X;else{inc(m,1,2);ea=c[k>>2]|0}if(ea&128)inc(m,7,4);inc(m,4,5);X=W+48|0;if((c[X>>2]|0)>1)inc(m,5,6);c[p>>2]=1066736;c[ca+0>>2]=0;c[ca+4>>2]=0;c[ca+8>>2]=0;c[ca+12>>2]=0;c[ca+16>>2]=0;c[ca+20>>2]=0;c[ca+24>>2]=0;c[ca+28>>2]=0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;V=W+20|0;U=c[V+4>>2]|0;z=q;c[z>>2]=c[V>>2];c[z+4>>2]=U;c[da>>2]=c[W+40>>2];U=c[X>>2]|0;if((U|0)==4)fa=32;else if((U|0)==1)fa=4;else if((U|0)==2)fa=16;else fa=1;c[ba>>2]=fa;a[ca>>0]=0;a[u>>0]=0;a[j>>0]=0;a[h>>0]=3;X=c[k>>2]|0;if(!(X&2))ga=12;else{a[_>>0]=0;a[S>>0]=12;a[B>>0]=0;a[A>>0]=3;ga=24}if(X&128){a[aa>>0]=0;a[o>>0]=ga;a[$>>0]=0;a[Z>>0]=4}if((U|0)==2){a[g>>0]=1;a[d>>0]=8;a[e>>0]=4;a[f>>0]=2;a[K>>0]=1;a[t>>0]=0;a[R>>0]=0;a[b>>0]=2}else if((U|0)==1){a[g>>0]=1;a[d>>0]=0;a[e>>0]=4;a[f>>0]=1}else if((U|0)==4){a[g>>0]=1;a[d>>0]=16;a[e>>0]=4;a[f>>0]=4;a[K>>0]=1;a[t>>0]=0;a[R>>0]=0;a[b>>0]=4}ewe(m,p,q,2);ko[c[1064952+448>>2]&4095](0);co[c[1064952+136>>2]&2047](0,0,c[W+44>>2]|0);eo[c[1064952+452>>2]&511]();U=c[(c[Y>>2]|0)+8>>2]|0;ko[c[(c[U>>2]|0)+20>>2]&4095](U);Rte(L);L=c[W+4>>2]|0;if(!L){U=W;while(1){Y=c[U+8>>2]|0;if((c[Y>>2]|0)==(U|0)){ha=Y;break}else U=Y}}else{U=L;while(1){Y=c[U>>2]|0;if(!Y){ha=U;break}else U=Y}}if((ha|0)==(1072028|0))break;else W=ha}}Eve(1072024,c[268007]|0);c[268008]=0;c[268006]=1072028;c[268007]=0;ko[c[1064952+128>>2]&4095](35977);co[c[1064952+456>>2]&2047](35345,0,0);ko[c[1064952+436>>2]&4095](0);co[c[1064952+456>>2]&2047](35982,0,0);In[c[1064952+488>>2]&4095](36386,0);i=l;return}function Cve(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Cve(a,c[b>>2]|0);Cve(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Dve(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+24|0;f=c[e>>2]|0;do if(!f)g=7;else{if((c[f+8>>2]|0)>>>0>=b>>>0){h=Mte(f)|0;j=c[e>>2]|0;if(h)k=j;else{if(!j){g=7;break}l=a+28|0;m=j;break}}else k=f;Nte(k);c[e>>2]=0;g=7}while(0);if((g|0)==7){g=$te()|0;k=a+28|0;a=Wte(g,b,c[k>>2]|0)|0;c[e>>2]=a;l=k;m=a}if((c[l>>2]|0)!=2){i=d;return}Pte(m,b);i=d;return}function Eve(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}else{Eve(a,c[b>>2]|0);Eve(a,c[b+4>>2]|0);ACi(b);i=d;return}}function Fve(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=1074448;In[c[1064952+116>>2]&4095](3,a+20|0);d=c[a+8>>2]|0;if(!d){i=b;return}e=a+12|0;a=c[e>>2]|0;if((a|0)!=(d|0))c[e>>2]=a+(~((a+-4-d|0)>>>2)<<2);ACi(d);i=b;return}function Gve(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=1074448;In[c[1064952+116>>2]&4095](3,a+20|0);d=c[a+8>>2]|0;if(!d){ACi(a);i=b;return}e=a+12|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d);ACi(a);i=b;return}function Hve(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;c[a+36>>2]=(b>>>0)/12|0;e=a+8|0;f=c[e>>2]|0;g=(c[a+12>>2]|0)-f>>2;if(g>>>0>=b>>>0){h=f;i=d;return h|0}oDd(e,b-g|0);h=c[e>>2]|0;i=d;return h|0}function Ive(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a+36>>2]|0;e=a+32|0;f=c[e>>2]|0;g=(c[a+(f<<2)+40>>2]|0)>>>0<d>>>0;In[c[1064952+24>>2]&4095](3553,c[a+(f<<2)+20>>2]|0);if(g){co[c[1064952+308>>2]&2047](3553,10241,9728);co[c[1064952+308>>2]&2047](3553,10240,9728);co[c[1064952+308>>2]&2047](3553,10242,33071);co[c[1064952+308>>2]&2047](3553,10243,33071);co[c[1064952+308>>2]&2047](3553,33084,0);co[c[1064952+308>>2]&2047](3553,33085,0);Yn[c[1064952+304>>2]&15](3553,0,34836,3,d,0,6408,5126,c[a+8>>2]|0);h=c[e>>2]|0;j=a+(h<<2)+40|0;c[j>>2]=d;i=b;return}else{Yn[c[1064952+312>>2]&15](3553,0,0,0,3,d,6408,5126,c[a+8>>2]|0);h=c[e>>2]|0;j=a+(h<<2)+40|0;c[j>>2]=d;i=b;return}}function Jve(a,b){a=a|0;b=b|0;b=i;Ite(c[266694]|0,0);In[c[1064952+24>>2]&4095](3553,c[a+(c[a+32>>2]<<2)+20>>2]|0);i=b;return}function Kve(a){a=a|0;var b=0,d=0;b=i;In[c[1064952+24>>2]&4095](3553,0);d=a+32|0;c[d>>2]=((c[d>>2]|0)+1|0)%3|0;i=b;return}function Lve(a,b){a=a|0;b=b|0;return (c[155256]|0)>>>0>=b>>>0|0}function Mve(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1074488;d=c[a+8>>2]|0;if(!d){i=b;return}Nte(d);i=b;return}function Nve(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=1074488;d=c[a+8>>2]|0;if(d)Nte(d);ACi(a);i=b;return}function Ove(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+8|0;a=c[e>>2]|0;if((a|0)!=0?Mte(a)|0:0){Nte(c[e>>2]|0);c[e>>2]=0}a=b<<2;b=Wte($te()|0,a,6)|0;c[e>>2]=b;e=Ste(b,0,a,42)|0;i=d;return e|0}function Pve(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;Ute(c[d>>2]|0);Rte(c[d>>2]|0);i=b;return}function Qve(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+8>>2]|0;if(!d){i=b;return}co[c[1064952+456>>2]&2047](35345,0,c[d+4>>2]|0);i=b;return}function Rve(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;if(!d){i=b;return}Vte(d);i=b;return}function Sve(b,d){b=b|0;d=d|0;var e=0;b=i;if(!(a[621266]|0)){e=0;i=b;return e|0}e=(((c[155304]|0)>>>0)/48|0)>>>0>=d>>>0;i=b;return e|0}function Tve(a){a=a|0;var b=0,d=0,e=0;b=i;c[a>>2]=1074528;d=c[a+8>>2]|0;if(!d){i=b;return}e=a+12|0;a=c[e>>2]|0;if((a|0)!=(d|0))c[e>>2]=a+(~((a+-4-d|0)>>>2)<<2);ACi(d);i=b;return}function Uve(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;c[a>>2]=1074528;d=c[a+8>>2]|0;if(!d){ACi(a);i=b;return}e=a+12|0;f=c[e>>2]|0;if((f|0)!=(d|0))c[e>>2]=f+(~((f+-4-d|0)>>>2)<<2);ACi(d);ACi(a);i=b;return}function Vve(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+8|0;f=a+12|0;a=c[f>>2]|0;g=c[e>>2]|0;h=a-g>>2;if((h|0)==(b|0)){j=g;i=d;return j|0}if(h>>>0<b>>>0){oDd(e,b-h|0);j=c[e>>2]|0;i=d;return j|0}if(h>>>0<=b>>>0){j=g;i=d;return j|0}h=g+(b<<2)|0;if((a|0)==(h|0)){j=g;i=d;return j|0}c[f>>2]=a+(~((a+-4-h|0)>>>2)<<2);j=g;i=d;return j|0}function Wve(a){a=a|0;return}function Xve(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+8>>2]|0;co[c[1064952+344>>2]&2047](b,(c[a+12>>2]|0)-e>>2>>>2,e);i=d;return}function Yve(a){a=a|0;return}function Zve(a,b){a=a|0;b=b|0;return ((((c[155305]|0)/4|0)+-10|0)/3|0)>>>0>b>>>0|0}function _ve(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;g=b+4|0;h=b;j=c[(Nqc(d)|0)>>2]|0;k=Nqc(d)|0;d=(c[k>>2]|0)+((c[k+8>>2]|0)*20|0)|0;if((j|0)==(d|0))l=-1;else{k=-1;m=j;while(1){if((a[m+16>>0]|0)==1?(c[m+8>>2]|0)==1:0){j=c[m+4>>2]|0;n=(j|0)>(k|0)?j:k}else n=k;m=m+20|0;if((m|0)==(d|0)){l=n;break}else k=n}}n=(l|0)<(e|0)?e:l;l=c[268642]|0;e=((n|0)<(f|0)?f:n)+1|0;if(l>>>0<e>>>0){n=e<<1;c[268642]=n;o=n}else o=l;l=c[268640]|0;c[h>>2]=c[153078];c[g+0>>2]=c[h+0>>2];h=hOb(l,o<<4,16,g,0,3653512,40)|0;c[268640]=h;PEi(h|0,-1,c[268642]<<4|0)|0;i=b;return}function $ve(a){a=a|0;return}function awe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0;a=i;i=i+16|0;f=a;h=(c[268640]|0)+(d<<2<<2)|0;j=c[e>>2]|0;if((c[h>>2]|0)==(j|0)){i=a;return}g[h>>2]=(c[k>>2]=j,ea(g[k>>2]));if(!b){co[c[1064952+316>>2]&2047](d,1,e);i=a;return}else{c[f>>2]=~~ea(g[e>>2]);c[f+4>>2]=~~ea(g[e+4>>2]);c[f+8>>2]=~~ea(g[e+8>>2]);c[f+12>>2]=~~ea(g[e+12>>2]);co[c[1064952+324>>2]&2047](d,1,f);i=a;return}}function bwe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;f=a;h=c[268640]|0;j=d<<2;k=h+(j<<2)|0;l=0;while(1){if((c[h+(l+j<<2)>>2]|0)!=(c[e+(l<<2)>>2]|0))break;l=l+1|0;if((l|0)>=2){m=7;break}}if((m|0)==7){i=a;return}m=e;l=c[m+4>>2]|0;j=k;c[j>>2]=c[m>>2];c[j+4>>2]=l;if(!b){co[c[1064952+328>>2]&2047](d,1,e);i=a;return}else{c[f>>2]=~~ea(g[e>>2]);c[f+4>>2]=~~ea(g[e+4>>2]);c[f+8>>2]=~~ea(g[e+8>>2]);c[f+12>>2]=~~ea(g[e+12>>2]);co[c[1064952+332>>2]&2047](d,1,f);i=a;return}}function cwe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;f=a;h=c[268640]|0;j=d<<2;k=h+(j<<2)|0;l=0;while(1){if((c[h+(l+j<<2)>>2]|0)!=(c[e+(l<<2)>>2]|0))break;l=l+1|0;if((l|0)>=3){m=7;break}}if((m|0)==7){i=a;return};c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];if(!b){co[c[1064952+336>>2]&2047](d,1,e);i=a;return}else{c[f>>2]=~~ea(g[e>>2]);c[f+4>>2]=~~ea(g[e+4>>2]);c[f+8>>2]=~~ea(g[e+8>>2]);c[f+12>>2]=~~ea(g[e+12>>2]);co[c[1064952+340>>2]&2047](d,1,f);i=a;return}}function dwe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;f=a;h=c[268640]|0;j=d<<2;k=h+(j<<2)|0;l=0;while(1){if((c[h+(l+j<<2)>>2]|0)!=(c[e+(l<<2)>>2]|0))break;l=l+1|0;if((l|0)>=4){m=7;break}}if((m|0)==7){i=a;return};c[k+0>>2]=c[e+0>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];if(!b){co[c[1064952+344>>2]&2047](d,1,e);i=a;return}else{c[f>>2]=~~ea(g[e>>2]);c[f+4>>2]=~~ea(g[e+4>>2]);c[f+8>>2]=~~ea(g[e+8>>2]);c[f+12>>2]=~~ea(g[e+12>>2]);co[c[1064952+348>>2]&2047](d,1,f);i=a;return}}function ewe(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+16|0;j=h;k=c[b>>2]|0;if((c[155300]|0)>1){l=1;do{ko[c[1064952+132>>2]&4095](l);l=l+1|0}while((l|0)<(c[155300]|0))}if(!k){i=h;return}else{m=0;n=-1}while(1){a:do if((1<<m&k|0)!=0?(l=a[b+m+8>>0]|0,o=a[e+(l<<2)+7>>0]|0,o<<24>>24!=0):0){p=a[e+(l<<2)+6>>0]|0;q=p<<24>>24==2?4:o&255;switch(p&255|0){case 0:{r=5126;break}case 1:{r=c[(c[267510]|0)+36>>2]|0;break}case 3:{r=5120;break}case 4:{r=5125;break}case 2:{r=5121;break}default:{Krd(1074896,0,3653512,37,1,0,0,0);r=0}}p=a[e+(l<<2)+5>>0]|0;o=d[e+(l<<2)+4>>0]|0;if(o>>>0<=g>>>0?(l=c[f+(o<<3)>>2]|0,(l|0)!=0):0){s=l+24|0;l=c[(c[s>>2]|0)+4>>2]|0;if((l|0)==(n|0))t=n;else{In[c[1064952+12>>2]&4095](34962,l);t=c[(c[s>>2]|0)+4>>2]|0}s=c[f+(o<<3)+4>>2]|0;o=p&255;switch(m|0){case 1:{u=1;v=1;break}case 2:{u=m;v=0;break}case 0:{u=m;v=0;break}case 3:{Ird(1074808,j);w=t;break a;break}case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{u=m+-1|0;v=0;break}case 27:case 26:case 25:case 24:case 23:case 22:case 21:case 20:case 19:case 18:case 17:case 16:case 15:case 14:case 13:case 12:{u=m+-12|0;v=1;break}default:{w=t;break a}}if(u>>>0>=(c[155300]|0)>>>0){Ird(1074848,j);w=t;break}ko[c[1064952+148>>2]&4095](u);if((r|0)==5125){En[c[1064952+464>>2]&127](u,q,5125,s,o);w=t;break}else{rn[c[1064952+368>>2]&127](u,q,r,v,s,o);w=t;break}}else w=n}else w=n;while(0);o=m;m=m+1|0;if((o|0)>26|(k>>>m|0)==0)break;else n=w}i=h;return}function fwe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;c[d+416>>2]=jqe(3671192)|0;g=b+371|0;h=b+373|0;j=b+372|0;k=b+312|0;l=Kjd(1075224)|0;if(Kjd(1075264)|0)m=Kjd(1075008)|0;else m=0;n=Kjd(1075296)|0;o=Kjd(1075336)|0;do if(l){p=d+424|0;c[p>>2]=jqe(1075376)|0;q=jqe(1075416)|0;r=e+20|0;c[r>>2]=q;if((c[p>>2]|0)==0|(q|0)==0){c[p>>2]=0;c[r>>2]=0;break}else{a[g>>0]=1;c[k>>2]=36183;break}}while(0);if(m?(m=jqe(1075456)|0,c[d+424>>2]=m,(m|0)!=0):0){a[j>>0]=1;c[k>>2]=36183}do if(n|o){m=d+424|0;c[m>>2]=jqe(n?1075496:1075536)|0;l=jqe(n?1075576:1075616)|0;r=e+16|0;c[r>>2]=l;if((c[m>>2]|0)==0|(l|0)==0){c[m>>2]=0;c[r>>2]=0;break}else{a[h>>0]=1;c[k>>2]=n?37173:36183;break}}while(0);n=a[h>>0]|0;a[b+127>>0]=n;if(!((a[g>>0]|n)<<24>>24))s=a[j>>0]|0;else s=1;j=b+126|0;a[j>>0]=s;a[b+222>>0]=(Kjd(1074920)|0)&1;if(a[j>>0]|0)In[c[1064952+212>>2]&4095](c[k>>2]|0,b+288|0);c[b+316>>2]=36193;c[b+328>>2]=36196;a[b+341>>0]=(Kjd(1075888)|0)&1;c[b+320>>2]=35906;c[b+324>>2]=35904;if(Kjd(1074944)|0)t=(Jue()|0)&1;else t=0;a[b+344>>0]=t;a[b+345>>0]=0;a[b+346>>0]=0;a[b+350>>0]=(Kjd(1074976)|0)&1;a[b+349>>0]=(Kjd(1075008)|0)&1;a[b+352>>0]=0;if(Kjd(1075032)|0)u=1;else u=(Kjd(1075056)|0)&1;t=b+351|0;a[t>>0]=u;a[b+353>>0]=(Kjd(1075080)|0)&1;a[b+354>>0]=(Kjd(1075104)|0)&1;if(Kjd(1075120)|0)v=a[b+375>>0]^1;else v=0;a[b+355>>0]=v;a[b+356>>0]=v&1;a[b+357>>0]=0;a[b+358>>0]=(Kjd(1075144)|0)&1;a[b+359>>0]=(Kjd(1075168)|0)&1;if((a[t>>0]|0)!=0?Kjd(1075192)|0:0){t=b+116|0;c[t>>2]=1;w=t;x=28}else x=27;if((x|0)==27?(t=Kjd(1075056)|0,v=b+116|0,c[v>>2]=1,t):0){w=v;x=28}if((x|0)==28){In[c[1064952+212>>2]&4095](36063,w);x=c[w>>2]|0;if((x|0)<1)y=1;else y=(x|0)>8?8:x;c[w>>2]=y}if(a[b+335>>0]|0){z=1;A=b+361|0;a[A>>0]=z;i=f;return}z=a[b+334>>0]|0;A=b+361|0;a[A>>0]=z;i=f;return}function gwe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;c[b+304>>2]=200;c[b+296>>2]=0;e=b+300|0;In[c[1064952+212>>2]&4095](36347,e);c[e>>2]=c[e>>2]<<2;a[b+122>>0]=(Kjd(1075656)|0)&1;a[b+123>>0]=(Kjd(1075680)|0)&1;a[b+129>>0]=1;a[b+130>>0]=1;a[b+131>>0]=1;a[b+132>>0]=(Kjd(1075712)|0)&1;a[b+137>>0]=1;e=b+224|0;c[e>>2]=1;if(!(Kjd(1075736)|0)?!(Kjd(1075760)|0):0)f=c[e>>2]|0;else{c[e>>2]=2;f=2}c[b+228>>2]=f;a[b+238>>0]=1;a[b+247>>0]=0;a[b+251>>0]=0;a[b+239>>0]=1;Kjd(1075792)|0;f=b+243|0;a[f>>0]=1;a[b+250>>0]=1;a[b+241>>0]=1;do if(a[b+334>>0]|0)if(Kjd(1075824)|0)if(!(a[f>>0]|0)){g=0;break}else{h=9;break}else{a[f>>0]=0;g=0;break}else h=9;while(0);if((h|0)==9)g=a[b+244>>0]|0;a[b+245>>0]=g;a[b+253>>0]=(Kjd(1075856)|0)&1;a[b+254>>0]=1;a[b+255>>0]=0;a[b+220>>0]=1;g=Kjd(1075888)|0;h=b+233|0;a[h>>0]=g&1;if(!g){j=0;a[h>>0]=j;k=b+268|0;a[k>>0]=0;l=Kjd(1075928)|0;m=b+366|0;n=l&1;a[m>>0]=n;a[621056]=0;i=d;return}j=(Kjd(1075904)|0)&1;a[h>>0]=j;k=b+268|0;a[k>>0]=0;l=Kjd(1075928)|0;m=b+366|0;n=l&1;a[m>>0]=n;a[621056]=0;i=d;return}function hwe(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;d=a+4|0;hpe(2)|0;kqe(8,620920);gwe(620920);c[d>>2]=c[153080];c[b+0>>2]=c[d+0>>2];d=bOb(8320,b,1,16,3653512,169)|0;Cqe(d);c[d>>2]=1075976;Ird(1076792,b);c[d+5980>>2]=8;i=a;return d|0}function iwe(a){a=a|0;var b=0;b=i;Dqe(a);ACi(a);i=b;return}function jwe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+176|0;h=g+152|0;j=g+16|0;k=g;l=j+4|0;c[j>>2]=406548;c[j+56>>2]=406568;esi(j+56|0,l);c[j+128>>2]=0;c[j+132>>2]=-1;c[j>>2]=406492;c[j+56>>2]=406512;jsi(l);c[l>>2]=74048;m=j+36|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[j+52>>2]=16;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;yN(l,h);xri(h);h=e+41|0;m=a[h>>0]|0;if((m&1)!=0?(a[e+37>>0]|0)!=0:0)n=(m&4)==0;else n=0;m=(f|0)>299;if(m)uN(eti(uN(j,1076832,9)|0,f)|0,1076848,4)|0;f=m?1076856:1076864;o=m?1076880:1076888;p=(a[(c[267510]|0)+66>>0]|0)!=0;q=p?1076904:1076912;if(p){r=uN(j,1076912,8)|0;s=ftd(1069e3)|0;uN(uN(r,s,SEi(s|0)|0)|0,1076928,3)|0}s=uN(j,1076936,4)|0;r=p?1:8;p=uN(uN(s,q,r)|0,1076944,11)|0;s=Smc(0)|0;uN(uN(p,s,SEi(s|0)|0)|0,1076960,2)|0;if(n){s=uN(uN(uN(j,1076936,4)|0,q,r)|0,1076944,11)|0;r=Smc(1)|0;uN(uN(s,r,SEi(r|0)|0)|0,1076960,2)|0}if(a[(c[267510]|0)+66>>0]|0)uN(j,1076968,3)|0;r=m?3:10;uN(uN(j,f,r)|0,1076976,24)|0;uN(uN(j,f,r)|0,1077008,26)|0;if(!(a[h>>0]&8))uN(uN(j,f,r)|0,1077080,22)|0;else uN(j,1077040,32)|0;s=m?4:8;uN(uN(j,o,s)|0,1077104,19)|0;m=e+39|0;if((a[m>>0]|0)>0){uN(j,1077128,35)|0;uN(j,1077168,33)|0;uN(uN(j,o,s)|0,1077208,31)|0;uN(uN(j,o,s)|0,1077240,23)|0}q=e+36|0;p=a[q>>0]|0;t=p&255;if(p<<24>>24){p=e+38|0;u=0;do{uN(eti(uN(uN(j,f,r)|0,1077264,31)|0,u)|0,1076960,2)|0;uN(eti(uN(j,1077296,33)|0,u)|0,1076960,2)|0;v=(d[p>>0]&1<<u|0)==0;w=uN(j,o,s)|0;if(v)uN(eti(uN(w,1077360,23)|0,u)|0,1076960,2)|0;else uN(eti(uN(w,1077336,21)|0,u)|0,1076960,2)|0;u=u+1|0}while((u|0)<(t|0))}t=a[h>>0]|0;u=(t&16)!=0;s=u?1077384:1077400;o=u?1077384:1077432;p=t&32;r=p<<24>>24!=0?1077384:1077464;if((t&1)!=0?(uN(j,1077496,30)|0,uN(j,1077528,18)|0,uN(j,1076968,3)|0,uN(j,1077552,28)|0,uN(j,1077584,19)|0,uN(j,1077528,18)|0,uN(j,1077608,18)|0,uN(j,1077632,19)|0,uN(j,1077656,21)|0,uN(j,1076968,3)|0,uN(j,1077680,46)|0,uN(j,1077728,47)|0,(a[e+37>>0]|0)!=0):0){uN(j,1077776,31)|0;uN(j,1077608,18)|0;uN(j,1077808,19)|0;uN(j,1077832,24)|0;uN(j,1077864,16)|0;uN(j,1076968,3)|0;t=uN(j,1077888,13)|0;f=Umc(32)|0;uN(uN(t,f,SEi(f|0)|0)|0,1076960,2)|0;f=0;do{t=uN(j,1077888,13)|0;w=Umc(f)|0;uN(uN(t,w,SEi(w|0)|0)|0,1076960,2)|0;w=uN(j,1077888,13)|0;t=Umc(f+8|0)|0;uN(uN(w,t,SEi(t|0)|0)|0,1076960,2)|0;t=uN(j,1077888,13)|0;w=Umc(f+16|0)|0;uN(uN(t,w,SEi(w|0)|0)|0,1076960,2)|0;w=uN(j,1077888,13)|0;t=Umc(f+24|0)|0;uN(uN(w,t,SEi(t|0)|0)|0,1076960,2)|0;f=f+1|0}while((f|0)<8);uN(j,1077904,32)|0;uN(j,1077944,36)|0;uN(j,1077984,2)|0;uN(j,1077992,48)|0;uN(j,1078048,2)|0;uN(j,1078056,102)|0;uN(j,1077984,2)|0;uN(j,1078160,56)|0;f=uN(j,1078224,25)|0;uN(uN(f,o,u?11:26)|0,1078256,26)|0;if(a[h>>0]&2){uN(j,1078288,21)|0;uN(j,1078312,6)|0;uN(j,1078320,62)|0;uN(j,1078384,45)|0;uN(j,1078432,113)|0;uN(j,1078552,6)|0}uN(j,1078560,18)|0;uN(j,1078048,2)|0;uN(j,1078584,85)|0;uN(j,1077984,2)|0;uN(j,1078672,42)|0;uN(j,1078720,88)|0;uN(j,1078048,2)|0;uN(j,1078816,105)|0;uN(j,1077984,2)|0;uN(j,1078928,62)|0;uN(j,1078992,49)|0;uN(j,1079048,55)|0;uN(j,1079104,40)|0;uN(j,1079152,94)|0;uN(j,1078048,2)|0;uN(j,1079248,104)|0;uN(j,1077984,2)|0;uN(j,1078928,62)|0;uN(j,1078992,49)|0;uN(j,1079048,55)|0;uN(j,1079104,40)|0;uN(j,1079360,64)|0;uN(j,1079432,59)|0;uN(j,1079496,40)|0;uN(j,1079544,104)|0;uN(j,1078048,2)|0}uN(j,1079656,13)|0;uN(j,1077984,2)|0;f=uN(j,1079672,18)|0;t=Smc(0)|0;uN(uN(f,t,SEi(t|0)|0)|0,1079696,16)|0;uN(j,1079720,24)|0;if(!(a[h>>0]&8))uN(j,1079792,35)|0;else uN(j,1079752,37)|0;if(n){n=uN(j,1079832,30)|0;t=Smc(1)|0;uN(uN(n,t,SEi(t|0)|0)|0,1079696,16)|0}t=a[q>>0]|0;q=t&255;if(t<<24>>24){t=e+38|0;n=0;do{f=(d[t>>0]&1<<n|0)==0;w=eti(uN(eti(uN(j,1079864,14)|0,n)|0,1079880,21)|0,n)|0;if(f)uN(eti(uN(eti(uN(w,1079912,20)|0,n)|0,1079936,20)|0,n)|0,1079960,5)|0;else uN(w,1079904,6)|0;n=n+1|0}while((n|0)<(q|0))}q=a[m>>0]|0;if((q|0)==3){uN(j,1080312,56)|0;uN(j,1080376,39)|0;uN(j,1080224,81)|0;uN(j,1080088,67)|0}else if((q|0)==2){uN(j,1080160,56)|0;uN(j,1080224,81)|0;uN(j,1080088,67)|0}else if((q|0)==1){uN(j,1079968,116)|0;uN(j,1080088,67)|0}if(!(a[h>>0]&1))uN(j,1080960,27)|0;else{h=uN(uN(uN(j,1080416,24)|0,r,(p&255)>>>1^27)|0,1080448,7)|0;p=u?11:26;uN(uN(h,s,p)|0,1080456,36)|0;s=e+37|0;if((a[s>>0]|0)!=0?(uN(j,1080496,68)|0,h=a[s>>0]|0,s=(h&255)<8?h&255:8,(s|0)!=0):0){h=e+32|0;e=0;do{uN(eti(uN(j,1080568,31)|0,e)|0,1076960,2)|0;u=uN(eti(uN(j,1080600,9)|0,e)|0,1080616,11)|0;r=Umc(e)|0;uN(uN(u,r,SEi(r|0)|0)|0,1076960,2)|0;r=uN(eti(uN(j,1080600,9)|0,e)|0,1080632,12)|0;u=Umc(e+8|0)|0;uN(uN(r,u,SEi(u|0)|0)|0,1076960,2)|0;u=uN(eti(uN(j,1080600,9)|0,e)|0,1080648,17)|0;r=Umc(e+16|0)|0;uN(uN(u,r,SEi(r|0)|0)|0,1079904,6)|0;r=uN(eti(uN(j,1080600,9)|0,e)|0,1080672,9)|0;u=Umc(e+24|0)|0;uN(uN(r,u,SEi(u|0)|0)|0,1076960,2)|0;u=(c[h>>2]|0)>>>(e<<2)&15;if(!u)uN(eti(uN(j,1080760,35)|0,e)|0,1080800,40)|0;else if((u|0)==1)uN(eti(uN(j,1080688,34)|0,e)|0,1080728,27)|0;else uN(eti(uN(j,1080848,36)|0,e)|0,1080800,40)|0;e=e+1|0}while((e|0)<(s|0))}uN(uN(uN(j,1080888,18)|0,o,p)|0,1080912,4)|0;uN(j,1080920,34)|0}uN(j,1078048,2)|0;zN(k,l);if(!(a[k>>0]&1)){x=k+1|0;y=SEi(x|0)|0;rri(b,x,y);xri(k);PO(j);i=g;return}else{x=c[k+8>>2]|0;y=SEi(x|0)|0;rri(b,x,y);xri(k);PO(j);i=g;return}}function kwe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+176|0;h=g+152|0;j=g+16|0;k=g;l=j+4|0;c[j>>2]=406548;c[j+56>>2]=406568;esi(j+56|0,l);c[j+128>>2]=0;c[j+132>>2]=-1;c[j>>2]=406492;c[j+56>>2]=406512;jsi(l);c[l>>2]=74048;m=j+36|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[j+52>>2]=16;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;yN(l,h);xri(h);h=e+40|0;m=a[h>>0]|0;n=(f|0)>299;if(n)uN(eti(uN(j,1076832,9)|0,f)|0,1076848,4)|0;o=(f|0)<300;f=o?1080992:1081008;p=n?1076856:1076888;q=n?3:8;uN(uN(j,p,q)|0,1077104,19)|0;if(!(m<<24>>24==0|m<<24>>24==8))uN(j,1081024,44)|0;r=e+39|0;if((a[r>>0]|0)>0){uN(uN(j,p,q)|0,1077208,31)|0;uN(uN(j,p,q)|0,1077240,23)|0}s=e+36|0;t=a[s>>0]|0;u=t&255;if(t<<24>>24){t=e+38|0;v=0;do{w=(d[t>>0]&1<<v|0)==0;x=uN(j,p,q)|0;if(w){uN(eti(uN(x,1077360,23)|0,v)|0,1076960,2)|0;uN(eti(uN(j,1081104,27)|0,v)|0,1076960,2)|0}else{uN(eti(uN(x,1077336,21)|0,v)|0,1076960,2)|0;uN(eti(uN(j,1081072,29)|0,v)|0,1076960,2)|0}uN(eti(uN(j,1081136,38)|0,v)|0,1076960,2)|0;v=v+1|0}while((v|0)<(u|0))}if(!o)uN(j,1081176,30)|0;uN(j,1079656,13)|0;uN(j,1077984,2)|0;uN(j,1081208,31)|0;u=a[s>>0]|0;s=u&255;if(u<<24>>24){u=e+38|0;if(n){n=0;do{v=c[e+(n<<2)>>2]|0;q=c[e+(n<<2)+16>>2]|0;uN(eti(uN(j,1081472,26)|0,n)|0,1081504,4)|0;uN(eti(uN(eti(uN(uN(uN(j,1081544,28)|0,2473240,7)|0,1081576,10)|0,n)|0,1081592,12)|0,n)|0,1081608,3)|0;p=uN(j,1081616,25)|0;t=(n|0)>0;uN(uN(p,t?2504632:1081648,t?5:7)|0,1076960,2)|0;if((v|0)==(q|0))lwe(j,n,v,0);else{lwe(j,n,v,1);lwe(j,n,q,2)}uN(j,1078552,6)|0;n=n+1|0}while((n|0)<(s|0))}else{n=0;do{q=(d[u>>0]&1<<n|0)!=0;v=c[e+(n<<2)>>2]|0;t=c[e+(n<<2)+16>>2]|0;uN(eti(uN(j,1081472,26)|0,n)|0,1081504,4)|0;p=uN(j,1081544,28)|0;uN(eti(uN(eti(uN(uN(p,q?1081512:1081528,q?11:9)|0,1081576,10)|0,n)|0,1081592,12)|0,n)|0,1081608,3)|0;q=uN(j,1081616,25)|0;p=(n|0)>0;uN(uN(q,p?2504632:1081648,p?5:7)|0,1076960,2)|0;if((v|0)==(t|0))lwe(j,n,v,0);else{lwe(j,n,v,1);lwe(j,n,t,2)}uN(j,1078552,6)|0;n=n+1|0}while((n|0)<(s|0))}}s=(a[r>>0]|0)>0;r=uN(j,1076936,4)|0;n=uN(r,f,o?12:14)|0;if(s)uN(n,1081240,46)|0;else uN(n,1081288,10)|0;do if(!(m<<24>>24==0|m<<24>>24==8))if((a[h>>0]|0)==1){uN(j,1081304,17)|0;break}else{n=uN(j,1081416,16)|0;s=c[1081328+(a[h>>0]<<2)>>2]|0;uN(uN(n,s,SEi(s|0)|0)|0,1081440,25)|0;uN(j,1081304,17)|0;break}while(0);uN(j,1078048,2)|0;zN(k,l);if(!(a[k>>0]&1)){y=k+1|0;z=SEi(y|0)|0;rri(b,y,z);xri(k);PO(j);i=g;return}else{y=c[k+8>>2]|0;z=SEi(y|0)|0;rri(b,y,z);xri(k);PO(j);i=g;return}}function lwe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+128|0;h=g;j=g+8|0;k=g+60|0;l=g+48|0;m=g+96|0;n=g+4|0;o=g+44|0;p=g+108|0;rri(j,1081656,4);rri(j+12|0,1081664,4);rri(j+24|0,1081672,5);rri(k,3653512,0);rri(k+12|0,1081680,4);rri(k+24|0,1081688,2);qxd(e,n,l,m,o);e=uN(b,1081696,13)|0;q=k+(f*12|0)|0;r=a[q>>0]|0;if(!(r&1)){s=q+1|0;t=(r&255)>>>1}else{s=c[k+(f*12|0)+8>>2]|0;t=c[k+(f*12|0)+4>>2]|0}uN(uN(e,s,t)|0,1081712,3)|0;t=c[n>>2]|0;switch(t|0){case 5:{uN(b,1081760,4)|0;mwe(b,d,f,c[m+4>>2]|0,c[l+4>>2]|0);uN(b,1081768,2)|0;mwe(b,d,f,c[m>>2]|0,c[l>>2]|0);uN(b,1081768,2)|0;mwe(b,d,2,c[m+8>>2]|0,c[l+8>>2]|0);uN(b,1081744,1)|0;break}case 2:{uN(b,1081728,1)|0;mwe(b,d,f,c[m>>2]|0,c[l>>2]|0);uN(b,1081736,3)|0;mwe(b,d,f,c[m+4>>2]|0,c[l+4>>2]|0);uN(b,1081744,1)|0;break}case 4:{uN(b,1081728,1)|0;mwe(b,d,f,c[m>>2]|0,c[l>>2]|0);uN(b,1081752,3)|0;mwe(b,d,f,c[m+4>>2]|0,c[l+4>>2]|0);uN(b,1081744,1)|0;break}case 0:{mwe(b,d,f,c[m>>2]|0,c[l>>2]|0);break}case 8:{uN(b,1081728,1)|0;mwe(b,d,f,c[m>>2]|0,c[l>>2]|0);uN(b,1081720,3)|0;mwe(b,d,f,c[m+8>>2]|0,c[l+8>>2]|0);uN(b,1081736,3)|0;mwe(b,d,f,c[m+4>>2]|0,c[l+4>>2]|0);uN(b,1081744,1)|0;break}case 1:{mwe(b,d,f,c[m>>2]|0,c[l>>2]|0);uN(b,1081720,3)|0;mwe(b,d,f,c[m+4>>2]|0,c[l+4>>2]|0);break}default:{c[h>>2]=t;Lsd(p,1081776,h);if(!(a[p>>0]&1))u=p+1|0;else u=c[p+8>>2]|0;Krd(u,0,3653512,484,1,0,0,0);xri(p);p=j+(f*12|0)|0;u=a[p>>0]|0;if(!(u&1)){v=p+1|0;w=(u&255)>>>1}else{v=c[j+(f*12|0)+8>>2]|0;w=c[j+(f*12|0)+4>>2]|0}uN(uN(b,v,w)|0,1081816,5)|0}}if((c[o>>2]|0)!=1){w=uN(b,1081824,9)|0;uN(eti(w,c[o>>2]|0)|0,1081840,3)|0}uN(b,1076960,2)|0;b=k+36|0;do{b=b+-12|0;xri(b)}while((b|0)!=(k|0));k=j+36|0;do{k=k+-12|0;xri(k)}while((k|0)!=(j|0));i=g;return}function mwe(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;uN(a,1081728,1)|0;if((e&-2|0)==2)uN(a,1081848,12)|0;if((f|0)==1)uN(a,2473240,7)|0;else if((f|0)==2)eti(uN(a,1081864,20)|0,b)|0;else if(!f)uN(a,2608424,4)|0;else if((f|0)==3)uN(a,1081648,7)|0;else{c[h>>2]=f;Ird(1081888,h);uN(a,1081928,9)|0}uN(a,1081744,1)|0;if((e|0)==2|(e|0)==0)if(!d){uN(a,1081944,5)|0;i=g;return}else if((d|0)==2){uN(a,1081688,2)|0;i=g;return}else if((d|0)==1){uN(a,1081680,4)|0;i=g;return}else{i=g;return}else if((e|0)==3|(e|0)==1)if(!d){uN(a,1081952,5)|0;i=g;return}else if((d|0)==2){uN(a,1081688,2)|0;i=g;return}else if((d|0)==1){uN(a,1081960,4)|0;i=g;return}else{i=g;return}else{i=g;return}}function nwe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;c[d+380>>2]=3591;c[d+384>>2]=6;c[d+388>>2]=2;c[d+392>>2]=3077;c[d+396>>2]=3078;c[d+400>>2]=3079;c[d+404>>2]=3592;c[d+408>>2]=1887;c[d+412>>2]=3643;c[d+416>>2]=3080;c[d+420>>2]=7;c[d+424>>2]=102;c[d+428>>2]=275;c[d+432>>2]=1888;c[d+436>>2]=3593;c[d+440>>2]=3081;c[d+444>>2]=3082;c[d+448>>2]=3594;c[d+452>>2]=245;c[d+456>>2]=1889;c[d+460>>2]=368;c[d+464>>2]=103;c[d+468>>2]=104;c[d+472>>2]=2847;c[d+476>>2]=369;c[d+480>>2]=105;c[d+484>>2]=1890;c[d+488>>2]=3083;c[d+492>>2]=3084;c[d+496>>2]=3085;c[d+500>>2]=106;c[d+504>>2]=370;c[d+508>>2]=1891;c[d+512>>2]=107;c[d+516>>2]=123;a[b+126>>0]=1;a[b+222>>0]=1;c[b+312>>2]=36183;In[c[1064952+212>>2]&4095](36183,b+288|0);d=b+280|0;if((c[d>>2]|0)>11)c[d>>2]=11;c[b+316>>2]=5131;c[b+328>>2]=37492;a[b+341>>0]=1;c[b+320>>2]=35907;c[b+324>>2]=35905;a[b+344>>0]=(Jue()|0)&1;a[b+345>>0]=1;a[b+346>>0]=1;d=b+349|0;a[d+0>>0]=1;a[d+1>>0]=1;a[d+2>>0]=1;a[d+3>>0]=1;a[d+4>>0]=1;a[d+5>>0]=1;a[b+355>>0]=a[b+375>>0]^1;a[b+356>>0]=0;a[b+357>>0]=1;a[b+358>>0]=0;a[b+359>>0]=0;a[b+361>>0]=1;d=b+116|0;In[c[1064952+212>>2]&4095](36063,d);f=c[d>>2]|0;if((f|0)<1){g=1;c[d>>2]=g;h=b+120|0;a[h>>0]=1;i=e;return}g=(f|0)>8?8:f;c[d>>2]=g;h=b+120|0;a[h>>0]=1;i=e;return}function owe(){var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+4|0;hpe(3)|0;kqe(11,620920);c[155306]=300;a[621286]=1;a[621172]=1;a[621042]=1;a[621043]=1;a[621057]=1;a[621049]=1;a[621050]=1;a[621051]=1;a[621052]=1;c[155286]=2;c[155287]=2;a[621158]=1;a[621167]=0;a[621171]=0;a[621159]=1;a[621163]=1;a[621170]=1;a[621165]=1;a[621161]=1;a[621173]=1;a[621175]=0;a[621153]=0;a[621188]=0;a[621056]=0;In[c[1064952+212>>2]&4095](35376,621216);In[c[1064952+212>>2]&4095](35658,621220);if(!(a[621254]|0)){f=c[153080]|0;c[e>>2]=f;c[d+0>>2]=c[e+0>>2];g=bOb(8320,d,1,16,3653512,105)|0;Cqe(g);c[g>>2]=1081976;Ird(1082792,d);h=g+5980|0;c[h>>2]=11;i=b;return g|0}a[621266]=0;f=c[153080]|0;c[e>>2]=f;c[d+0>>2]=c[e+0>>2];g=bOb(8320,d,1,16,3653512,105)|0;Cqe(g);c[g>>2]=1081976;Ird(1082792,d);h=g+5980|0;c[h>>2]=11;i=b;return g|0}function pwe(a){a=a|0;var b=0;b=i;Dqe(a);ACi(a);i=b;return}function qwe(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153112];c[b+0>>2]=c[d+0>>2];eOb(0,b);i=a;return}function rwe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+44|0;g=c[f>>2]|0;c[f>>2]=g+-1;if((g|0)>=2){i=b;return}g=c[a>>2]|0;if(!g){f=c[153112]|0;if(!a){h=f;j=e}else{k=e;l=f;m=5}}else{f=a+4|0;c[g+4>>2]=c[f>>2];c[c[f>>2]>>2]=g;c[a>>2]=0;c[f>>2]=0;k=e;l=c[153112]|0;m=5}if((m|0)==5){twe(a);h=l;j=k}c[e>>2]=h;c[d+0>>2]=c[e+0>>2];eOb(a,d);i=b;return}function swe(b){b=b|0;var d=0,e=0;d=i;if(a[b+66>>0]|0){e=1;i=d;return e|0}if((c[b+56>>2]|0)!=0?(a[b+65>>0]|0)==0:0){e=0;i=d;return e|0}e=(a[b+61>>0]|0)!=0;i=d;return e|0}function twe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;a[b+63>>0]=1;h=b+140|0;j=c[h>>2]|0;if(j){k=c[153112]|0;ko[c[c[j>>2]>>2]&4095](j);c[f>>2]=k;c[e+0>>2]=c[f+0>>2];eOb(j,e);c[h>>2]=0}h=b+152|0;j=c[h>>2]|0;if(j){k=b+148|0;l=b+8|0;m=j;do{j=c[k>>2]|0;n=c[j+12>>2]|0;o=j+4|0;p=c[j>>2]|0;c[p+4>>2]=c[o>>2];c[c[o>>2]>>2]=p;c[h>>2]=m+-1;ACi(j);c[l>>2]=(c[l>>2]|0)+-1;j=c[270710]|0;if((c[j>>2]|0)<4){p=j+4|0;c[f>>2]=6;c[e+0>>2]=c[f+0>>2];o=cOb(12,16,e,0,3653512,80)|0;c[o+8>>2]=n;c[o+4>>2]=p;q=c[p>>2]|0;c[o>>2]=q;c[q+4>>2]=o;c[p>>2]=o;o=j+12|0;c[o>>2]=(c[o>>2]|0)+1;o=c[270710]|0;c[o>>2]=(c[o>>2]|0)+1}else{c[g>>2]=c[153112];c[e+0>>2]=c[g+0>>2];eOb(n,e)}m=c[h>>2]|0}while((m|0)!=0)}m=c[b+156>>2]|0;if(((m|0)!=0?(occ(m),m=b+144|0,(c[h>>2]|0)!=0):0)?(e=c[b+148>>2]|0,g=(c[m>>2]|0)+4|0,f=c[e>>2]|0,c[f+4>>2]=c[g>>2],c[c[g>>2]>>2]=f,c[h>>2]=0,(e|0)!=(m|0)):0){h=e;do{e=h;h=c[h+4>>2]|0;ACi(e)}while((h|0)!=(m|0))}m=c[b+124>>2]|0;if(!m){r=b+96|0;xri(r);s=b+84|0;xri(s);t=b+68|0;xri(t);u=b+12|0;xri(u);i=d;return}h=b+128|0;e=c[h>>2]|0;if((e|0)!=(m|0))c[h>>2]=e+(~((e+-8-m|0)>>>3)<<3);ACi(m);r=b+96|0;xri(r);s=b+84|0;xri(s);t=b+68|0;xri(t);u=b+12|0;xri(u);i=d;return}function uwe(){var a=0,b=0,d=0,e=0;a=i;b=c[270708]|0;if(!b){i=a;return}d=c[b+4>>2]|0;if((d|0)==(b|0)){i=a;return}else e=d;do{d=e;e=c[e+4>>2]|0;vwe(d)}while((e|0)!=(c[270708]|0));i=a;return}function vwe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+32|0;e=d+12|0;f=d;if(a[b+66>>0]|0){i=d;return}g=b+140|0;h=c[g>>2]|0;if(!h){i=d;return}j=b+124|0;k=c[j>>2]|0;l=(c[b+128>>2]|0)-k>>3;m=b+40|0;n=c[m>>2]|0;if((n|0)<(l|0)){o=k;p=h;q=n}else{i=d;return}while(1){n=c[o+(q<<3)+4>>2]|0;h=q+1|0;if((mo[c[(c[p>>2]|0)+28>>2]&4095](p)|0)>>>0<n>>>0){r=q;break}if((h|0)>=(l|0)){r=h;break}o=c[j>>2]|0;p=c[g>>2]|0;q=h}if((r|0)==(c[m>>2]|0)){i=d;return}q=c[g>>2]|0;do if((mo[c[(c[q>>2]|0)+20>>2]&4095](q)|0)!=0?(p=c[g>>2]|0,(mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0)!=2):0){p=c[g>>2]|0;if((mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0)!=1?(p=c[g>>2]|0,(mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0)!=3):0){s=c[m>>2]|0;break}if(!(a[b+65>>0]|0)){i=d;return}else{c[m>>2]=r;s=r;break}}else t=10;while(0);if((t|0)==10){if((a[b+60>>0]|0)!=0?(t=c[g>>2]|0,(c[t+8>>2]|0)!=(c[t+4>>2]|0)):0){t=kfd()|0;uOc(e,c[(c[g>>2]|0)+4>>2]|0);q=c[g>>2]|0;p=c[q+4>>2]|0;if((p|0)!=(c[q+8>>2]|0)){q=e+1|0;j=e+8|0;o=e+4|0;h=p;do{c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;p=a[e>>0]|0;n=(p&1)==0;if(n)u=(p&255)>>>1;else u=c[o>>2]|0;p=a[h>>0]|0;if(!(p&1))v=(p&255)>>>1;else v=c[h+4>>2]|0;Pri(f,n?q:c[j>>2]|0,u,v+u|0);if(!(a[h>>0]&1))w=h+1|0;else w=c[h+8>>2]|0;Gri(f,w,v)|0;if(!(vOc(f)|0)?!(ufd(t,f)|0):0)qfd(t,f,h+12|0,256,0,-1)|0;xri(f);h=h+32|0}while((h|0)!=(c[(c[g>>2]|0)+8>>2]|0))}xri(e)}c[m>>2]=r;s=r}a[b+61>>0]=(s|0)>=(c[b+120>>2]|0)&1;if((s|0)<(l|0)){i=d;return}l=c[b>>2]|0;if(!l){i=d;return}s=b+4|0;c[l+4>>2]=c[s>>2];c[c[s>>2]>>2]=l;c[b>>2]=0;c[s>>2]=0;i=d;return}function wwe(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[153072];c[b+0>>2]=c[d+0>>2];d=bOb(20,b,1,16,3653512,702)|0;c[d>>2]=0;b=d+4|0;c[b>>2]=b;c[d+8>>2]=b;c[d+12>>2]=0;c[270710]=d;i=a;return}function xwe(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=c[270710]|0;f=c[153072]|0;if(e)ywe(e);c[d>>2]=f;c[b+0>>2]=c[d+0>>2];eOb(e,b);c[270710]=0;i=a;return}function ywe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=a+12|0;h=a+8|0;while(1){if(!(c[g>>2]|0))break;a=c[(c[h>>2]|0)+8>>2]|0;c[f>>2]=c[153112];c[d+0>>2]=c[f+0>>2];eOb(a,d);a=c[h>>2]|0;j=a+4|0;k=c[a>>2]|0;c[k+4>>2]=c[j>>2];c[c[j>>2]>>2]=k;c[g>>2]=(c[g>>2]|0)+-1;c[e>>2]=6;c[d+0>>2]=c[e+0>>2];eOb(a,d)}i=b;return}function zwe(){var a=0,b=0;a=i;b=xCi(8)|0;c[b>>2]=b;c[b+4>>2]=b;c[270708]=b;i=a;return}function Awe(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=c[270708]|0;if(!d){i=b;return}e=d+4|0;f=c[e>>2]|0;if((f|0)!=(d|0)){g=f;do{a[g+63>>0]=1;g=c[g+4>>2]|0}while((g|0)!=(d|0));g=c[e>>2]|0;if((g|0)==(d|0))h=d;else{j=g;do{g=j+4|0;k=j;j=c[g>>2]|0;c[k>>2]=0;c[g>>2]=0}while((j|0)!=(d|0));h=d}}else h=f;c[e>>2]=h;c[d>>2]=h;h=c[270708]|0;if(h)ACi(h);c[270708]=0;i=b;return}function Bwe(a){a=a|0;var b=0;b=i;uhf(a);i=b;return}function Cwe(a){a=a|0;var b=0,d=0;b=i;if(!(N3e(0)|0)){Jff(a,0);i=b;return}d=a+16|0;if(k6e(0,c[d>>2]|0)|0?Eef(c[d>>2]|0)|0:0){i=b;return}Jff(a,0);i=b;return}function Dwe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+20|0;if(!(D8e(0,c[d>>2]|0,0)|0)){e=c[d>>2]|0;i=b;return e|0}f=c[a+16>>2]|0;RI(2437216)|0;a=qL(2437216)|0;Jef(a,f);c[d>>2]=a;Hhf(a,61);e=c[d>>2]|0;i=b;return e|0}function Ewe(a){a=a|0;var b=0,d=0;b=i;d=a+20|0;if(!(k6e(0,c[d>>2]|0)|0)){i=b;return}Ghf(0,c[d>>2]|0);i=b;return}function Fwe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2505328)|0;RI(2445136)|0;kmf(a,ML(c[611300]|0)|0);c[c[d>>2]>>2]=a;a=qL(2506664)|0;mmf(a,sM(3653512)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Gwe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+80|0;d=b+56|0;e=b+40|0;f=b+24|0;g=b+8|0;h=b;c[a+28>>2]=15;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;H4e(d,ea(1.0),ea(0.0),ea(0.0),ea(0.0));j=a+44|0;c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;H4e(e,ea(0.0),ea(1.0),ea(0.0),ea(0.0));d=a+60|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;H4e(f,ea(0.0),ea(0.0),ea(1.0),ea(0.0));e=a+76|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;H4e(g,ea(0.0),ea(0.0),ea(0.0),ea(1.0));f=a+92|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];$7e(h,0);g=h;h=c[g+4>>2]|0;f=a+136|0;c[f>>2]=c[g>>2];c[f+4>>2]=h;Bwe(a);i=b;return}function Hwe(a){a=a|0;var b=0;b=i;Ewe(a);Iwe(a);Ehf(0,c[a+108>>2]|0);i=b;return}function Iwe(a){a=a|0;var b=0;b=i;Ehf(0,c[a+112>>2]|0);Ehf(0,c[a+116>>2]|0);Ehf(0,c[a+120>>2]|0);i=b;return}function Jwe(a){a=a|0;var b=0;b=i;c[a+124>>2]=zqh($hf(a)|0)|0;i=b;return}function Kwe(b){b=b|0;var d=0,e=0,f=0;d=i;c[b+128>>2]=0;a[b+132>>0]=0;e=b+108|0;Ehf(0,c[e>>2]|0);c[e>>2]=0;a[b+144>>0]=0;e=zqh($hf(b)|0)|0;f=b+124|0;c[f>>2]=e;$ff(e);Uff(c[f>>2]|0,-1);i=d;return}function Lwe(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;e=b+124|0;f=Zff(c[e>>2]|0)|0;h=_ff(c[e>>2]|0)|0;e=b+133|0;j=a[e>>0]|0;do if(j<<24>>24){k=b+136|0;l=b+140|0;if(!(ea(f|0)!=ea(g[k>>2]))?ea(h|0)==ea(g[l>>2]):0){if(!(j<<24>>24))break;i=d;return}a[e>>0]=0;g[k>>2]=ea(0.0);g[l>>2]=ea(0.0)}while(0);j=b+108|0;if((!(D8e(0,c[j>>2]|0,0)|0)?(Aqh(2361632,c[j>>2]|0)|0)==(f|0):0)?(Aqh(2361704,c[j>>2]|0)|0)==(h|0):0){i=d;return}c[j>>2]=Mwe(0,c[j>>2]|0,f,h,e)|0;if(!((((a[e>>0]|0)==0?(j=b+112|0,c[j>>2]=Mwe(0,c[j>>2]|0,f,h,e)|0,(a[e>>0]|0)==0):0)?(j=b+116|0,c[j>>2]=Mwe(0,c[j>>2]|0,f,h,e)|0,(a[e>>0]|0)==0):0)?(j=b+120|0,c[j>>2]=Mwe(0,c[j>>2]|0,f,h,e)|0,(a[e>>0]|0)==0):0)){g[b+136>>2]=ea(f|0);g[b+140>>2]=ea(h|0)}c[b+128>>2]=0;a[b+132>>0]=0;a[b+144>>0]=0;i=d;return}function Mwe(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=i;a[f>>0]=0;Ehf(0,c);c=Owe(0,d,e,0)|0;if(!(D8e(0,c,0)|0)){i=b;return c|0}a[f>>0]=1;i=b;return c|0}function Nwe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f+48|0;h=f+32|0;j=f+16|0;k=f;qbh();if(a[b+133>>0]|0){i=f;return}l=b+132|0;do if(a[l>>0]|0){m=b+124|0;if(Tff(c[m>>2]|0)|0)Uff(c[m>>2]|0,0)}else{m=b+144|0;n=c[b+128>>2]|0;if((a[m>>0]|0)==0&(n|0)==0){o=b+36|0;if(D8e(0,c[o>>2]|0,0)|0){p=Def(0,c[879090]|0)|0;RI(2437216)|0;q=qL(2437216)|0;Jef(q,p);c[o>>2]=q;r=q}else r=c[o>>2]|0;N4e(0,d,c[b+108>>2]|0,r);a[m>>0]=1;break}m=b+128|0;if((n|0)<(c[b+28>>2]|0)){n=Dwe(b)|0;Ref(n,c[879092]|0,ea(ea(1.0)/ea((c[m>>2]|0)+1|0)));n=Dwe(b)|0;Ref(n,c[879094]|0,ea(c[m>>2]|0));n=Dwe(b)|0;Pef(n,c[879096]|0,d);n=Dwe(b)|0;o=b+44|0;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];o=c[879098]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];Oef(n,o,g);o=Dwe(b)|0;n=b+112|0;Pef(o,c[879100]|0,c[n>>2]|0);o=c[n>>2]|0;N4e(0,d,o,Dwe(b)|0);o=Dwe(b)|0;n=b+60|0;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];n=c[879102]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];Oef(o,n,g);n=Dwe(b)|0;o=b+116|0;Pef(n,c[879104]|0,c[o>>2]|0);n=c[o>>2]|0;N4e(0,d,n,Dwe(b)|0);n=Dwe(b)|0;o=b+76|0;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=c[879106]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];Oef(n,o,g);o=Dwe(b)|0;n=b+120|0;Pef(o,c[879108]|0,c[n>>2]|0);o=c[n>>2]|0;N4e(0,d,o,Dwe(b)|0);c[m>>2]=(c[m>>2]|0)+1;break}m=b+32|0;if(D8e(0,c[m>>2]|0,0)|0){o=Def(0,c[879110]|0)|0;RI(2437216)|0;n=qL(2437216)|0;Jef(n,o);c[m>>2]=n;s=n}else s=c[m>>2]|0;Pef(s,c[879112]|0,c[b+112>>2]|0);Pef(c[m>>2]|0,c[879114]|0,c[b+116>>2]|0);Pef(c[m>>2]|0,c[879116]|0,c[b+120>>2]|0);N4e(0,d,c[b+108>>2]|0,c[m>>2]|0);Iwe(b);a[l>>0]=1}while(0);M4e(0,c[b+108>>2]|0,e);i=f;return}function Owe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;rbh();v9e(0,c[879184]|0);RI(2360704)|0;f=qL(2360704)|0;m5e(f,b,d,e);p5e(f,0);Hhf(f,61);A5e(f,0);i5e(f,0);z5e(f,0);if(B5e(f)|0){g=f;i=a;return g|0}Ghf(0,f);g=0;i=a;return g|0}function Pwe(b){b=b|0;var c=0;c=i;a[b+20>>0]=1;uhf(b);i=c;return}function Qwe(a){a=a|0;var b=0,d=0,e=0;b=i;d=egf(0)|0;e=JSg(d,c[788547]|0)|0;c[a+16>>2]=e;Jff(e,1);i=b;return}function Rwe(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+12|0;f=d;if(!(a[b+20>>0]|0)){i=d;return}g=_hf(b)|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Pbf(f,ea(.100000001),ea(.100000001),ea(.100000001));c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];xif(g,e);i=d;return}function Swe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Twe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=mo[c[(c[b>>2]|0)+4>>2]&4095](a)|0;i=d;return e|0}function Uwe(a){a=a|0;c[a+4>>2]=-2;return}function Vwe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function Wwe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=a+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);Bqh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Bqh(f)}else{f=c[a>>2]|0;a=PCf(f)|0;g=_n[c[(c[b+8>>2]|0)+4>>2]&4095](f,a+-1-(c[e>>2]|0)|0)|0;i=d;return g|0}return 0}function Xwe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Ywe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=Zwe(a)|0;RI(2347552)|0;a=pL(2347552,d)|0;i=b;return a|0}function Zwe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Bqh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Bqh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=KSg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function _we(a){a=a|0;c[a+4>>2]=-2;return}function $we(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function axe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function bxe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=cxe(a)|0;RI(2348024)|0;a=pL(2348024,d)|0;i=b;return a|0}function cxe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Bqh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Bqh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=TSg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function dxe(a){a=a|0;c[a+4>>2]=-2;return}function exe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function fxe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function gxe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=hxe(a)|0;RI(2349448)|0;a=pL(2349448,d)|0;i=b;return a|0}function hxe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Cqh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Cqh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=aTg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function ixe(a){a=a|0;c[a+4>>2]=-2;return}function jxe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function kxe(a){a=a|0;var b=0;b=i;lxe(a,10,0);i=b;return}function lxe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;uhh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[888110]|0);Cqh(g)}if(!e){RI(1759712)|0;if(!(a[1759860]|0)){RI(1759712)|0;Dqh(1759712)}h=oGe(0)|0}else h=e;c[b+40>>2]=h;h=~~ea(ea(d|0)/ea(.899999976))+1|0;Lxe(b,(d|0)==0?12:h);c[b+48>>2]=0;i=f;return}function mxe(a,b){a=a|0;b=b|0;var c=0;c=i;lxe(a,10,b);i=c;return}function nxe(a,b){a=a|0;b=b|0;var c=0;c=i;lxe(a,b,0);i=c;return}function oxe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=pxe(0,b)|0;Eqh(1336016,a,e,qxe(0,c)|0);i=d;return}function pxe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+4|0;f=b;Bhh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888286]|0);Cqh(g)}RI(2540224)|0;if(!(vL(d,2540224)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Dqh(2540728)}c[f>>2]=3431160;c[e+0>>2]=c[f+0>>2];f=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);Cqh(k)}Dqh(2540560);h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);Cqh(k)}RI(2540224)|0;k=c[(c[d>>2]|0)+44>>2]|0;l=c[635067]|0;if((k|0)==(l|0)){j=c[(yL(d)|0)>>2]|0;i=b;return j|0}_J(e,k,l);if(!(a[e>>0]&1)){m=e+1|0;n=MJ(m)|0;FJ(n)}else{m=c[e+8>>2]|0;n=MJ(m)|0;FJ(n)}return 0}function qxe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=0;Chh();j=(d|0)==0;if(j){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Dqh(2540728)}c[g>>2]=3433104;c[e+0>>2]=c[g+0>>2];if(!(Gqh(2650144,npf(0,e)|0)|0)){Hqh(2368616,f);k=c[f>>2]|0;i=b;return k|0}}RI(2368616)|0;if(!(vL(d,2368616)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Dqh(2540728)}c[h>>2]=3433104;c[e+0>>2]=c[h+0>>2];h=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){l=c[888302]|0;m=gwf(0,l,h)|0;RI(2965048)|0;n=qL(2965048)|0;o=c[888304]|0;Rag(n,m,o);Cqh(n)}Dqh(2540560);l=c[888302]|0;m=gwf(0,l,h)|0;RI(2965048)|0;n=qL(2965048)|0;o=c[888304]|0;Rag(n,m,o);Cqh(n)}RI(2368616)|0;if(j){k=0;i=b;return k|0}j=vL(d,2368616)|0;if(j){k=j;i=b;return k|0}_J(e,c[(c[d>>2]|0)+44>>2]|0,2368616);if(!(a[e>>0]&1)){p=e+1|0;q=MJ(p)|0;FJ(q)}else{p=c[e+8>>2]|0;q=MJ(p)|0;FJ(q)}return 0}function rxe(a){a=a|0;return a|0}function sxe(a){a=a|0;return 0}function txe(a,b){a=a|0;b=b|0;var d=0;d=i;Eqh(1336072,a,c[b>>2]|0,c[b+4>>2]|0);i=d;return}function uxe(a){a=a|0;return c[a>>2]|0}function vxe(a){a=a|0;return c[a+4>>2]|0}function wxe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=xxe(a,e)|0;i=d;return f|0}function xxe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=0;if(!(Iqh(1337136,b,c[d>>2]|0,f)|0)){g=0;i=e;return g|0}RI(1777032)|0;if(!(a[1777180]|0)){RI(1777032)|0;Dqh(1777032)}b=Jqh()|0;g=Kqh(1777584,b,c[d+4>>2]|0,c[f>>2]|0)|0;i=e;return g|0}function yxe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zxe(a,b,c);i=d;return}function zxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;Cxe(a,b,d);RI(1758120)|0;h=qL(1758120)|0;c[g>>2]=1336576;c[f+0>>2]=c[g+0>>2];$Fe(h,0,f);ZTg(a,b,d,h);i=e;return}function Axe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g>>2]|0;h=c[g+4>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=h;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];if(!(xxe(a,e)|0)){j=0;i=d;return j|0}j=Lqh(1336128,a,b)|0;i=d;return j|0}function Bxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;RI(1101184)|0;h=vL(b,1101184)|0;if(h){zxe(a,h,d);i=e;return}Cxe(a,b,d);RI(1104096)|0;h=vL(b,1104096)|0;if(!h){RI(1758120)|0;j=qL(1758120)|0;c[g>>2]=1336576;c[f+0>>2]=c[g+0>>2];$Fe(j,0,f);XTg(a,b,d,j);i=e;return}RI(1336184)|0;if(!(c[(c[334069]|0)+16>>2]|0)){RI(1336408)|0;j=qL(1336408)|0;c[j+8>>2]=c[334089];c[j+20>>2]=1336352;c[j+16>>2]=0;RI(1336184)|0;c[(c[334069]|0)+16>>2]=j}RI(1336184)|0;WTg(a,h,d,c[(c[334069]|0)+16>>2]|0);i=e;return}function Cxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;vhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888118]|0);Cqh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888120]|0);Cqh(f)}if((PCf(b)|0)<(d|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[888122]|0);Cqh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(1336912,a)|0)){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[888124]|0);Cqh(a)}else{i=e;return}}function Dxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Exe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(1336632)|0;e=pL(1336632,d)|0;i=b;return e|0}function Fxe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function Gxe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(1336632)|0;e=pL(1336632,d)|0;i=b;return e|0}function Hxe(a){a=a|0;var b=0,c=0;b=i;RI(1758832)|0;c=qL(1758832)|0;dGe(c,a);i=b;return c|0}function Ixe(a){a=a|0;return c[a+32>>2]|0}function Jxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+16|0;f=e;thh();c[f>>2]=b;RI(2540224)|0;if(!(pL(2540224,f)|0)){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888106]|0);Cqh(f)}f=a+40|0;g=Mqh(1336800,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;k=m+-1|0;a:do if(!m){n=k;o=-1;p=9}else{q=a+12|0;r=a+16|0;s=c[q>>2]|0;t=s;u=c[(c[s>>2]|0)+120>>2]|0;s=k;v=-1;while(1){if((c[t+16+(da(u,s)|0)>>2]|0)==(h|0)){w=c[r>>2]|0;if(Nqh(1336856,c[f>>2]|0,c[w+16+(da(c[(c[w>>2]|0)+120>>2]|0,s)|0)>>2]|0,b)|0){n=s;o=v;p=9;break a}w=c[q>>2]|0;x=w;y=c[(c[w>>2]|0)+120>>2]|0}else{x=t;y=u}w=c[x+16+((da(y,s)|0)+4)>>2]|0;if((w|0)==-1)break;else{z=s;t=x;u=y;s=w;v=z}}}while(0);if((p|0)==9?(n|0)!=-1:0){if((o|0)==-1){A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}p=c[a+12>>2]|0;y=p+16|0;x=c[(c[p>>2]|0)+120>>2]|0;c[y+((da(x,o)|0)+4)>>2]=c[y+((da(x,n)|0)+4)>>2];x=c[j>>2]|0;o=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,g)|0)|0;c[y+((da(c[(c[p>>2]|0)+120>>2]|0,n)|0)+4)>>2]=(c[o>>2]|0)+-1;c[o>>2]=n+1;A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}n=a+32|0;o=c[n>>2]|0;c[n>>2]=o+1;if((o|0)<(c[a+36>>2]|0))M=g;else{Kxe(a);M=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){o=a+24|0;n=c[o>>2]|0;c[o>>2]=n+1;o=c[a+12>>2]|0;p=c[o>>2]|0;N=o;O=c[p+120>>2]|0;P=p;Q=n}else{n=c[a+12>>2]|0;p=c[n>>2]|0;o=c[p+120>>2]|0;c[l>>2]=c[n+16+((da(o,g)|0)+4)>>2];N=n;O=o;P=p;Q=g}g=c[j>>2]|0;j=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,M)|0)|0;c[N+16+((da(O,Q)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=Q+1;c[N+16+(da(c[P+120>>2]|0,Q)|0)>>2]=h;h=c[a+16>>2]|0;c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,Q)|0)>>2]=b;A=Q;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}
function Kxe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+8|0;f=c[e>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Dqh(2730168)}g=nPf(0,c[f+12>>2]<<1|1)|0;RI(1101728)|0;f=Oqh(1101728,g)|0;RI(1103136)|0;h=Oqh(1103136,g)|0;j=c[e>>2]|0;if((c[j+12>>2]|0)>0){k=b+40|0;l=b+16|0;m=h+16|0;n=f+16|0;o=b+12|0;p=j;j=0;while(1){q=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0;if(!q)r=p;else{s=q+-1|0;do{q=c[l>>2]|0;t=Mqh(1336800,c[k>>2]|0,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,s)|0)>>2]|0)|0;c[m+(da(c[(c[h>>2]|0)+120>>2]|0,s)|0)>>2]=t|-2147483648;q=n+(da(c[(c[f>>2]|0)+120>>2]|0,(t&2147483647|0)%(g|0)|0)|0)|0;c[m+((da(c[(c[h>>2]|0)+120>>2]|0,s)|0)+4)>>2]=(c[q>>2]|0)+-1;c[q>>2]=s+1;q=c[o>>2]|0;s=c[q+16+((da(c[(c[q>>2]|0)+120>>2]|0,s)|0)+4)>>2]|0}while((s|0)!=-1);r=c[e>>2]|0}j=j+1|0;if((j|0)>=(c[r+12>>2]|0)){u=l;v=o;break}else p=r}}else{u=b+16|0;v=b+12|0}c[e>>2]=f;c[v>>2]=h;RI(1101728)|0;h=Oqh(1101728,g)|0;RI(1103616)|0;v=Oqh(1103616,g)|0;f=b+24|0;wEf(0,c[u>>2]|0,0,h,0,c[f>>2]|0);e=b+20|0;wEf(0,c[e>>2]|0,0,v,0,c[f>>2]|0);c[u>>2]=h;c[e>>2]=v;c[b+36>>2]=~~ea(ea(g|0)*ea(.899999976));i=d;return}function Lxe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(1101728)|0;e=a+8|0;c[e>>2]=Oqh(1101728,b)|0;RI(1103136)|0;c[a+12>>2]=Oqh(1103136,b)|0;c[a+28>>2]=-1;RI(1101728)|0;c[a+16>>2]=Oqh(1101728,b)|0;RI(1103616)|0;c[a+20>>2]=Oqh(1103616,b)|0;c[a+24>>2]=0;b=c[(c[e>>2]|0)+12>>2]|0;e=~~ea(ea(b|0)*ea(.899999976));c[a+36>>2]=(e|0)!=0|(b|0)<1?e:1;i=d;return}function Mxe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[a>>2]=d;c[a+4>>2]=e;return}function Nxe(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;return}function Oxe(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function Pxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e;xhh();c[f>>2]=b;RI(2540224)|0;if(!(pL(2540224,f)|0)){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888216]|0);Cqh(f)}f=a+40|0;g=Mqh(1336800,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;a:do if(m){k=a+12|0;n=a+16|0;o=c[k>>2]|0;p=o;q=c[(c[o>>2]|0)+120>>2]|0;o=m+-1|0;while(1){if((c[p+16+(da(q,o)|0)>>2]|0)==(h|0)){r=c[n>>2]|0;if(Nqh(1336856,c[f>>2]|0,c[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,o)|0)>>2]|0,b)|0)break;r=c[k>>2]|0;s=r;t=c[(c[r>>2]|0)+120>>2]|0}else{s=p;t=q}o=c[s+16+((da(t,o)|0)+4)>>2]|0;if((o|0)==-1)break a;else{p=s;q=t}}RI(2965048)|0;q=qL(2965048)|0;Rbg(q,c[888218]|0);Cqh(q)}while(0);t=a+32|0;s=c[t>>2]|0;c[t>>2]=s+1;if((s|0)<(c[a+36>>2]|0))u=g;else{Kxe(a);u=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){s=a+24|0;t=c[s>>2]|0;c[s>>2]=t+1;s=c[a+12>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0;x=t}else{t=c[a+12>>2]|0;s=c[(c[t>>2]|0)+120>>2]|0;c[l>>2]=c[t+16+((da(s,g)|0)+4)>>2];v=t;w=s;x=g}c[v+16+(da(w,x)|0)>>2]=h;h=c[j>>2]|0;j=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,u)|0)|0;c[v+16+((da(w,x)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=x+1;j=c[a+16>>2]|0;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,x)|0)>>2]=b;b=c[a+20>>2]|0;c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,x)|0)>>2]=d;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function Qxe(a){a=a|0;var b=0,d=0;b=i;c[a+32>>2]=0;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+16>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+20>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+12>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+28>>2]=-1;c[a+24>>2]=0;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Rxe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;RI(1777032)|0;if(!(a[1777180]|0)){RI(1777032)|0;Dqh(1777032)}f=Jqh()|0;g=b+8|0;h=c[g>>2]|0;if((c[h+12>>2]|0)<=0){j=0;i=e;return j|0}k=b+20|0;l=b+12|0;b=h;h=0;a:while(1){m=c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,h)|0)>>2]|0;if(!m)n=b;else{o=m+-1|0;do{m=c[k>>2]|0;if(Pqh(1776488,f,c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,o)|0)>>2]|0,d)|0){j=1;p=11;break a}m=c[l>>2]|0;o=c[m+16+((da(c[(c[m>>2]|0)+120>>2]|0,o)|0)+4)>>2]|0}while((o|0)!=-1);n=c[g>>2]|0}h=h+1|0;if((h|0)>=(c[n+12>>2]|0)){j=0;p=11;break}else b=n}if((p|0)==11){i=e;return j|0}return 0}function Sxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;yhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888254]|0);Cqh(e)}r9f(b,c[888256]|0,c[a+48>>2]|0);L7f(b,c[888258]|0,c[a+40>>2]|0);e=c[a+32>>2]|0;if((e|0)<1)f=0;else{RI(1101184)|0;g=Oqh(1101184,e)|0;zxe(a,g,0);f=g}r9f(b,c[888260]|0,c[(c[a+8>>2]|0)+12>>2]|0);L7f(b,c[888262]|0,f);i=d;return}function Txe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=0;c[f>>2]=0;zhh();c[g>>2]=b;RI(2540224)|0;if(!(pL(2540224,g)|0)){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888278]|0);Cqh(g)}g=a+40|0;h=Mqh(1336800,c[g>>2]|0,b)|0;j=h|-2147483648;k=a+8|0;l=c[k>>2]|0;m=(h&2147483647|0)%(c[l+12>>2]|0)|0;h=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,m)|0)>>2]|0;if(!h){n=0;i=d;return n|0}l=a+12|0;o=a+16|0;p=c[l>>2]|0;q=p;r=c[(c[p>>2]|0)+120>>2]|0;p=h+-1|0;h=-1;while(1){if((c[q+16+(da(r,p)|0)>>2]|0)==(j|0)){s=c[o>>2]|0;if(Nqh(1336856,c[g>>2]|0,c[s+16+(da(c[(c[s>>2]|0)+120>>2]|0,p)|0)>>2]|0,b)|0){t=p;u=h;break}s=c[l>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0}else{v=q;w=r}s=c[v+16+((da(w,p)|0)+4)>>2]|0;if((s|0)==-1){n=0;x=14;break}else{y=p;q=v;r=w;p=s;h=y}}if((x|0)==14){i=d;return n|0}if((t|0)==-1){n=0;i=d;return n|0}x=a+32|0;c[x>>2]=(c[x>>2]|0)+-1;if((u|0)==-1){x=c[k>>2]|0;k=c[l>>2]|0;h=c[k>>2]|0;p=(c[k+16+((da(c[h+120>>2]|0,t)|0)+4)>>2]|0)+1|0;c[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,m)|0)>>2]=p;z=k;A=h}else{h=c[l>>2]|0;l=h+16|0;k=c[(c[h>>2]|0)+120>>2]|0;c[l+((da(k,u)|0)+4)>>2]=c[l+((da(k,t)|0)+4)>>2];z=h;A=c[h>>2]|0}h=a+28|0;k=z+16|0;c[k+((da(c[A+120>>2]|0,t)|0)+4)>>2]=c[h>>2];c[h>>2]=t;c[k+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=0;z=c[o>>2]|0;Hqh(2540224,e);c[z+16+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=c[e>>2];e=c[a+20>>2]|0;Hqh(2368616,f);c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,t)|0)>>2]=c[f>>2];f=a+48|0;c[f>>2]=(c[f>>2]|0)+1;n=1;i=d;return n|0}function Uxe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=0;Ahh();c[g>>2]=b;RI(2540224)|0;if(!(pL(2540224,g)|0)){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888282]|0);Cqh(g)}g=a+40|0;h=Mqh(1336800,c[g>>2]|0,b)|0;j=h|-2147483648;k=c[a+8>>2]|0;l=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,(h&2147483647|0)%(c[k+12>>2]|0)|0)|0)>>2]|0;a:do if(l){k=a+12|0;h=a+16|0;m=c[k>>2]|0;n=m;o=c[(c[m>>2]|0)+120>>2]|0;m=l+-1|0;while(1){if((c[n+16+(da(o,m)|0)>>2]|0)==(j|0)){p=c[h>>2]|0;if(Nqh(1336856,c[g>>2]|0,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,m)|0)>>2]|0,b)|0){q=m;break}p=c[k>>2]|0;r=p;s=c[(c[p>>2]|0)+120>>2]|0}else{r=n;s=o}m=c[r+16+((da(s,m)|0)+4)>>2]|0;if((m|0)==-1)break a;else{n=r;o=s}}o=c[a+20>>2]|0;t=1;u=o+16+(da(c[(c[o>>2]|0)+120>>2]|0,q)|0)|0;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}while(0);Hqh(2368616,f);t=0;u=f;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}function Vxe(a){a=a|0;var b=0,c=0;b=i;RI(1336968)|0;c=qL(1336968)|0;Wxe(c,a);i=b;return c|0}function Wxe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Fhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888332]|0);Cqh(e)}else{c[a+8>>2]=b;i=d;return}}function Xxe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function Yxe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;i=i+16|0;f=b;c[f>>2]=d;RI(2540224)|0;d=pL(2540224,f)|0;f=a;c[f>>2]=0;c[f+4>>2]=0;LOf(a,d,e);i=b;return}function Zxe(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function _xe(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function $xe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;Jhh();RI(1094176)|0;g=Oqh(1094176,5)|0;Qqh(g,c[888370]|0);h=g+16|0;c[h>>2]=c[888370];c[f>>2]=c[b>>2];RI(2540224)|0;if(!(pL(2540224,f)|0)){if(!(a[2540708]|0))Dqh(2540560);j=c[c[635163]>>2]|0}else{c[e>>2]=c[b>>2];RI(2540224)|0;j=Fqh(2536904,pL(2540224,e)|0)|0}Qqh(g,j);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=j;Qqh(g,c[888372]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[888372];j=c[b+4>>2]|0;if(!j){if(!(a[2540708]|0))Dqh(2540560);k=c[c[635163]>>2]|0}else k=Fqh(2536904,j)|0;Qqh(g,k);c[h+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=k;Qqh(g,c[888374]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<2)>>2]=c[888374];if(a[2540708]|0){l=lwf(0,g)|0;i=d;return l|0}Dqh(2540560);l=lwf(0,g)|0;i=d;return l|0}function aye(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function bye(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;cye(c,a);RI(1342344)|0;a=pL(1342344,c)|0;i=b;return a|0}function cye(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);Cqh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Cqh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;jTg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function dye(a){a=a|0;c[a+4>>2]=-2;return}function eye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function fye(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function gye(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=hye(a)|0;RI(2540224)|0;a=pL(2540224,d)|0;i=b;return a|0}function hye(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Cqh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Cqh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=sTg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function iye(a){a=a|0;c[a+4>>2]=-2;return}function jye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function kye(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function lye(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;mye(c,a);RI(2703200)|0;a=pL(2703200,c)|0;i=b;return a|0}function mye(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);Cqh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Cqh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;BTg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function nye(a){a=a|0;c[a+4>>2]=-2;return}function oye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function pye(a,b){a=a|0;b=b|0;Ghh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888342]|0);Cqh(b)}function qye(a){a=a|0;Hhh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[888362]|0);Cqh(a)}function rye(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Rxe(c[a+8>>2]|0,b)|0;i=d;return e|0}function sye(a,b){a=a|0;b=b|0;Ihh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888366]|0);Cqh(b);return 0}function tye(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=0;c[a+4>>2]=0;RI(1358296)|0;a=pL(1358296,d)|0;i=b;return a|0}function uye(a,b){a=a|0;b=b|0;var d=0;d=c[b+8>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=c[d+48>>2]|0;c[a>>2]=d;c[a+4>>2]=0;c[a+8>>2]=b;b=a+12|0;c[b>>2]=0;c[b+4>>2]=0;return}function vye(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(1103616)|0;f=vL(b,1103616)|0;if(!f){g=a+8|0;Cxe(c[g>>2]|0,b,d);h=c[g>>2]|0;RI(1358520)|0;g=qL(1358520)|0;c[g+8>>2]=c[334827];c[g+20>>2]=1339304;c[g+16>>2]=0;KTg(h,b,d,g);i=e;return}else{Rqh(1358464,a,f,d);i=e;return}}function wye(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function xye(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=0;c[a+4>>2]=0;RI(1358296)|0;a=pL(1358296,d)|0;i=b;return a|0}function yye(a){a=a|0;return 1}function zye(a){a=a|0;var b=0,d=0;b=i;d=Sqh(2647408,c[a+8>>2]|0)|0;i=b;return d|0}function Aye(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+8|0;Cxe(c[f>>2]|0,b,d);a=c[f>>2]|0;RI(1358520)|0;f=qL(1358520)|0;c[f+8>>2]=c[334827];c[f+20>>2]=1339304;c[f+16>>2]=0;MTg(a,b,d,f);i=e;return}function Bye(a,b){a=a|0;b=b|0;var d=0;d=c[b+48>>2]|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=d;d=a+12|0;c[d>>2]=0;c[d+4>>2]=0;return}function Cye(a){a=a|0;var b=0,d=0;b=i;d=Aqh(1336912,c[a+8>>2]|0)|0;i=b;return d|0}function Dye(a){a=a|0;var b=0;b=i;Kye(a);i=b;return c[a+16>>2]|0}function Eye(a){a=a|0;var b=0;b=i;Kye(a);i=b;return c[a+16>>2]|0}function Fye(a){a=a|0;c[a>>2]=0;return}function Gye(a){a=a|0;c[a>>2]=0;return}function Hye(a){a=a|0;var b=0,c=0;b=i;c=Iye(a)|0;i=b;return c|0}function Iye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;Pye(a);d=a+4|0;e=c[d>>2]|0;if((e|0)<=-1){f=0;i=b;return f|0}g=c[a>>2]|0;h=c[g+24>>2]|0;j=e;while(1){if((j|0)>=(h|0)){k=6;break}e=j+1|0;c[d>>2]=e;l=c[g+12>>2]|0;if((c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){m=j;k=3;break}else j=e}if((k|0)==3){j=c[g+16>>2]|0;h=c[g+20>>2]|0;g=c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,m)|0)>>2]|0;j=c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,m)|0)>>2]|0;m=a+12|0;c[m>>2]=g;c[m+4>>2]=j;f=1;i=b;return f|0}else if((k|0)==6){c[d>>2]=-1;f=0;i=b;return f|0}return 0}function Jye(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;Kye(a);e=a+12|0;a=c[e+4>>2]|0;f=d;c[f>>2]=c[e>>2];c[f+4>>2]=a;RI(1342344)|0;a=pL(1342344,d)|0;i=b;return a|0}function Kye(a){a=a|0;var b=0;b=i;Ehh();Pye(a);if((c[a+4>>2]|0)>0){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888318]|0);Cqh(b)}}function Lye(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;Kye(b);c[e>>2]=c[b+12>>2];RI(2540224)|0;f=pL(2540224,e)|0;e=c[b+16>>2]|0;b=a;c[b>>2]=0;c[b+4>>2]=0;LOf(a,f,e);i=d;return}function Mye(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;Kye(a);c[d>>2]=c[a+12>>2];RI(2540224)|0;a=pL(2540224,d)|0;i=b;return a|0}function Nye(a){a=a|0;var b=0;b=i;Kye(a);i=b;return c[a+12>>2]|0}function Oye(a){a=a|0;var b=0;b=i;Kye(a);i=b;return c[a+16>>2]|0}function Pye(a){a=a|0;var b=0,d=0,e=0;b=i;Dhh();d=c[a>>2]|0;if(!d){RI(3112928)|0;e=qL(3112928)|0;kwg(e,0);Cqh(e)}if((c[d+48>>2]|0)==(c[a+8>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888308]|0);Cqh(b)}}function Qye(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function Rye(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)Rye(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function Sye(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Tye(a,b){a=a|0;b=b|0;return 0}function Uye(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)Uye(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function Vye(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Wye(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function Xye(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Yye(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;Zye(c,a);RI(2729368)|0;a=pL(2729368,c)|0;i=b;return a|0}function Zye(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);Cqh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Cqh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;NTg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function _ye(a){a=a|0;c[a+4>>2]=-2;return}function $ye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function aze(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function bze(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=cze(a)|0;RI(2606296)|0;a=pL(2606296,d)|0;i=b;return a|0}function cze(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Tqh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Tqh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=_1g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function dze(a){a=a|0;c[a+4>>2]=-2;return}function eze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function fze(a){a=a|0;return}function gze(a){a=a|0;var b=0;a=i;RI(1374016)|0;b=qL(1374016)|0;RI(1374184)|0;c[c[343569]>>2]=b;i=a;return}function hze(a){a=a|0;return}function ize(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=(d|0)!=0;if(!b){g=f<<31>>31;i=e;return g|0}if(!f){g=1;i=e;return g|0}RI(2551640)|0;if((vL(b,2551640)|0)!=0?(RI(2551640)|0,(vL(d,2551640)|0)!=0):0){RI(2551640)|0;f=c[(Uqh(b,2551640)|0)>>2]|0;RI(2551640)|0;g=Vqh(1374352,a,f,c[(Uqh(d,2551640)|0)>>2]|0)|0;i=e;return g|0}RI(2965048)|0;g=qL(2965048)|0;oig(g);Tqh(g);return 0}function jze(b){b=b|0;b=i;RI(1374184)|0;if(!(a[1374332]|0)){RI(1374184)|0;Wqh(1374184)}RI(1374184)|0;i=b;return c[c[343569]>>2]|0}function kze(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;i=i+32|0;e=a+4|0;f=a+16|0;g=a+8|0;h=a+20|0;j=a+28|0;k=a;l=a+12|0;m=a+24|0;shh();c[e>>2]=b;RI(2551640)|0;if(!(pL(2551640,e)|0)){c[f>>2]=d;RI(2551640)|0;n=((pL(2551640,f)|0)!=0)<<31>>31;i=a;return n|0}c[g>>2]=d;RI(2551640)|0;if(!(pL(2551640,g)|0)){n=1;i=a;return n|0}c[h>>2]=b;RI(2551640)|0;g=pL(2551640,h)|0;RI(2201696)|0;if(vL(g,2201696)|0){c[j>>2]=b;RI(2551640)|0;g=pL(2551640,j)|0;RI(2201696)|0;n=Yqh(2201880,Xqh(g,2201696)|0,d)|0;i=a;return n|0}c[k>>2]=b;RI(2551640)|0;g=pL(2551640,k)|0;RI(2546528)|0;if(!(vL(g,2546528)|0)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[888084]|0);Tqh(g)}c[l>>2]=b;RI(2551640)|0;b=pL(2551640,l)|0;c[m>>2]=d;RI(2551640)|0;d=pL(2551640,m)|0;RI(2546528)|0;n=Zqh(2546712,Xqh(b,2546528)|0,d)|0;i=a;return n|0}function lze(a){a=a|0;return}function mze(a){a=a|0;var b=0;a=i;RI(1375480)|0;b=qL(1375480)|0;RI(1375648)|0;c[c[343935]>>2]=b;i=a;return}function nze(a){a=a|0;return}function oze(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=(d|0)!=0;if(!c){g=f<<31>>31;i=e;return g|0}if(!f){g=1;i=e;return g|0}RI(2565248)|0;if((vL(c,2565248)|0)!=0?(RI(2565248)|0,(vL(d,2565248)|0)!=0):0){RI(2565248)|0;f=b[(Uqh(c,2565248)|0)>>1]|0;RI(2565248)|0;g=_qh(1375816,a,f,b[(Uqh(d,2565248)|0)>>1]|0)|0;i=e;return g|0}RI(2965048)|0;g=qL(2965048)|0;oig(g);Tqh(g);return 0}function pze(b){b=b|0;b=i;RI(1375648)|0;if(!(a[1375796]|0)){RI(1375648)|0;Wqh(1375648)}RI(1375648)|0;i=b;return c[c[343935]>>2]|0}function qze(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+16|0;f=a+2|0;g=a+8|0;h=a+4|0;j=a+10|0;k=a+14|0;l=a;m=a+6|0;n=a+12|0;shh();b[f>>1]=d;RI(2565248)|0;if(!(pL(2565248,f)|0)){b[g>>1]=e;RI(2565248)|0;o=((pL(2565248,g)|0)!=0)<<31>>31;i=a;return o|0}b[h>>1]=e;RI(2565248)|0;if(!(pL(2565248,h)|0)){o=1;i=a;return o|0}b[j>>1]=d;RI(2565248)|0;h=pL(2565248,j)|0;RI(2104864)|0;if(vL(h,2104864)|0){b[k>>1]=d;RI(2565248)|0;h=pL(2565248,k)|0;RI(2104864)|0;o=$qh(2105048,Xqh(h,2104864)|0,e)|0;i=a;return o|0}b[l>>1]=d;RI(2565248)|0;h=pL(2565248,l)|0;RI(2546528)|0;if(!(vL(h,2546528)|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[888084]|0);Tqh(h)}b[m>>1]=d;RI(2565248)|0;d=pL(2565248,m)|0;b[n>>1]=e;RI(2565248)|0;e=pL(2565248,n)|0;RI(2546528)|0;o=Zqh(2546712,Xqh(d,2546528)|0,e)|0;i=a;return o|0}function rze(a){a=a|0;return}function sze(a){a=a|0;var b=0;a=i;RI(1376944)|0;b=qL(1376944)|0;RI(1377112)|0;c[c[344301]>>2]=b;i=a;return}function tze(a){a=a|0;return}function uze(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=(d|0)!=0;if(!c){g=f<<31>>31;i=e;return g|0}if(!f){g=1;i=e;return g|0}RI(2557392)|0;if((vL(c,2557392)|0)!=0?(RI(2557392)|0,(vL(d,2557392)|0)!=0):0){RI(2557392)|0;f=a[(Uqh(c,2557392)|0)>>0]|0;RI(2557392)|0;g=arh(1377280,b,f,a[(Uqh(d,2557392)|0)>>0]|0)|0;i=e;return g|0}RI(2965048)|0;g=qL(2965048)|0;oig(g);Tqh(g);return 0}function vze(b){b=b|0;b=i;RI(1377112)|0;if(!(a[1377260]|0)){RI(1377112)|0;Wqh(1377112)}RI(1377112)|0;i=b;return c[c[344301]>>2]|0}function wze(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;f=b+1|0;g=b+4|0;h=b+2|0;j=b+5|0;k=b+7|0;l=b;m=b+3|0;n=b+6|0;shh();a[f>>0]=d;RI(2557392)|0;if(!(pL(2557392,f)|0)){a[g>>0]=e;RI(2557392)|0;o=((pL(2557392,g)|0)!=0)<<31>>31;i=b;return o|0}a[h>>0]=e;RI(2557392)|0;if(!(pL(2557392,h)|0)){o=1;i=b;return o|0}a[j>>0]=d;RI(2557392)|0;h=pL(2557392,j)|0;RI(2165048)|0;if(vL(h,2165048)|0){a[k>>0]=d;RI(2557392)|0;h=pL(2557392,k)|0;RI(2165048)|0;o=brh(2165232,Xqh(h,2165048)|0,e)|0;i=b;return o|0}a[l>>0]=d;RI(2557392)|0;h=pL(2557392,l)|0;RI(2546528)|0;if(!(vL(h,2546528)|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[888084]|0);Tqh(h)}a[m>>0]=d;RI(2557392)|0;d=pL(2557392,m)|0;a[n>>0]=e;RI(2557392)|0;e=pL(2557392,n)|0;RI(2546528)|0;o=Zqh(2546712,Xqh(d,2546528)|0,e)|0;i=b;return o|0}function xze(a){a=a|0;return}function yze(a){a=a|0;var b=0;a=i;RI(1378408)|0;b=qL(1378408)|0;RI(1378576)|0;c[c[344667]>>2]=b;i=a;return}function zze(a){a=a|0;return}function Aze(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=(d|0)!=0;if(!b){g=f<<31>>31;i=e;return g|0}if(!f){g=1;i=e;return g|0}RI(2554736)|0;if(!(vL(b,2554736)|0)){RI(2965048)|0;h=qL(2965048)|0;oig(h);Tqh(h)}RI(2554736)|0;if(!(vL(d,2554736)|0)){RI(2965048)|0;h=qL(2965048)|0;oig(h);Tqh(h)}RI(2554736)|0;h=Uqh(b,2554736)|0;b=c[h>>2]|0;f=c[h+4>>2]|0;RI(2554736)|0;h=Uqh(d,2554736)|0;g=crh(1378744,a,b,f,c[h>>2]|0,c[h+4>>2]|0)|0;i=e;return g|0}function Bze(b){b=b|0;b=i;RI(1378576)|0;if(!(a[1378724]|0)){RI(1378576)|0;Wqh(1378576)}RI(1378576)|0;i=b;return c[c[344667]>>2]|0}function Cze(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=i;i=i+64|0;g=a+8|0;h=a+32|0;j=a+16|0;k=a+40|0;l=a+56|0;m=a;n=a+24|0;o=a+48|0;shh();p=g;c[p>>2]=b;c[p+4>>2]=d;RI(2554736)|0;if(!(pL(2554736,g)|0)){g=h;c[g>>2]=e;c[g+4>>2]=f;RI(2554736)|0;q=((pL(2554736,h)|0)!=0)<<31>>31;i=a;return q|0}h=j;c[h>>2]=e;c[h+4>>2]=f;RI(2554736)|0;if(!(pL(2554736,j)|0)){q=1;i=a;return q|0}j=k;c[j>>2]=b;c[j+4>>2]=d;RI(2554736)|0;j=pL(2554736,k)|0;RI(2212464)|0;if(vL(j,2212464)|0){j=l;c[j>>2]=b;c[j+4>>2]=d;RI(2554736)|0;j=pL(2554736,l)|0;RI(2212464)|0;q=drh(2212648,Xqh(j,2212464)|0,e,f)|0;i=a;return q|0}j=m;c[j>>2]=b;c[j+4>>2]=d;RI(2554736)|0;j=pL(2554736,m)|0;RI(2546528)|0;if(!(vL(j,2546528)|0)){RI(2965048)|0;j=qL(2965048)|0;Rbg(j,c[888084]|0);Tqh(j)}j=n;c[j>>2]=b;c[j+4>>2]=d;RI(2554736)|0;d=pL(2554736,n)|0;n=o;c[n>>2]=e;c[n+4>>2]=f;RI(2554736)|0;f=pL(2554736,o)|0;RI(2546528)|0;q=Zqh(2546712,Xqh(d,2546528)|0,f)|0;i=a;return q|0}function Dze(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Eze(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+48|0;d=b+20|0;e=b;Fze(d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];RI(2673824)|0;d=pL(2673824,e)|0;i=b;return d|0}function Fze(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);erh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);erh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;p2g(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function Gze(a){a=a|0;c[a+4>>2]=-2;return}function Hze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function Ize(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Jze(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=Kze(a)|0;RI(2685904)|0;a=pL(2685904,d)|0;i=b;return a|0}function Kze(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);erh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);erh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=y2g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function Lze(a){a=a|0;c[a+4>>2]=-2;return}function Mze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function Nze(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Oze(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;Pze(c,a);RI(2729920)|0;a=pL(2729920,c)|0;i=b;return a|0}function Pze(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);erh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);erh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;N2g(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function Qze(a){a=a|0;c[a+4>>2]=-2;return}function Rze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function Sze(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Tze(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=Uze(a)|0;RI(2730736)|0;a=pL(2730736,d)|0;i=b;return a|0}function Uze(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);erh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);erh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=W2g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function Vze(a){a=a|0;c[a+4>>2]=-2;return}function Wze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function Xze(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Yze(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=Zze(a)|0;RI(2741840)|0;a=pL(2741840,d)|0;i=b;return a|0}function Zze(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);erh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);erh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=d3g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function _ze(a){a=a|0;c[a+4>>2]=-2;return}function $ze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function aAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function bAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=cAe(a)|0;RI(2742360)|0;a=pL(2742360,d)|0;i=b;return a|0}function cAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);erh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);erh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=m3g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function dAe(a){a=a|0;c[a+4>>2]=-2;return}function eAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function fAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function gAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=hAe(a)|0;RI(2742896)|0;a=pL(2742896,d)|0;i=b;return a|0}function hAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);erh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);erh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=v3g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function iAe(a){a=a|0;c[a+4>>2]=-2;return}function jAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function kAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function lAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=mAe(a)|0;RI(2694720)|0;a=pL(2694720,d)|0;i=b;return a|0}function mAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);frh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=E3g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function nAe(a){a=a|0;c[a+4>>2]=-2;return}function oAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function pAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function qAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=rAe(a)|0;RI(2761136)|0;a=pL(2761136,d)|0;i=b;return a|0}function rAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);frh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=N3g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function sAe(a){a=a|0;c[a+4>>2]=-2;return}function tAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function uAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function vAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=wAe(a)|0;RI(2768376)|0;a=pL(2768376,d)|0;i=b;return a|0}function wAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);frh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=W3g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function xAe(a){a=a|0;c[a+4>>2]=-2;return}function yAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function zAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function AAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=BAe(a)|0;RI(2770776)|0;a=pL(2770776,d)|0;i=b;return a|0}function BAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);frh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=d4g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function CAe(a){a=a|0;c[a+4>>2]=-2;return}function DAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function EAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function FAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=GAe(a)|0;RI(2776480)|0;a=pL(2776480,d)|0;i=b;return a|0}function GAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);frh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=m4g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function HAe(a){a=a|0;c[a+4>>2]=-2;return}function IAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function JAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function KAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=LAe(a)|0;RI(2778984)|0;a=pL(2778984,d)|0;i=b;return a|0}function LAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);frh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=v4g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function MAe(a){a=a|0;c[a+4>>2]=-2;return}function NAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function OAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function PAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=QAe(a)|0;RI(2781760)|0;a=pL(2781760,d)|0;i=b;return a|0}function QAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);frh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=E4g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function RAe(a){a=a|0;c[a+4>>2]=-2;return}function SAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function TAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function UAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=VAe(a)|0;RI(2782256)|0;a=pL(2782256,d)|0;i=b;return a|0}function VAe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);frh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=N4g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function WAe(a){a=a|0;c[a+4>>2]=-2;return}function XAe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function YAe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function ZAe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=_Ae(a)|0;RI(2789408)|0;a=pL(2789408,d)|0;i=b;return a|0}function _Ae(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);frh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=W4g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function $Ae(a){a=a|0;c[a+4>>2]=-2;return}function aBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function bBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function cBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=dBe(a)|0;RI(2790128)|0;a=pL(2790128,d)|0;i=b;return a|0}function dBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);frh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=d5g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function eBe(a){a=a|0;c[a+4>>2]=-2;return}function fBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function gBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function hBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=iBe(a)|0;RI(2805992)|0;a=pL(2805992,d)|0;i=b;return a|0}function iBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);frh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);frh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=m5g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function jBe(a){a=a|0;c[a+4>>2]=-2;return}function kBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function lBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function mBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=nBe(a)|0;RI(2846960)|0;a=pL(2846960,d)|0;i=b;return a|0}function nBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);grh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);grh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=v5g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function oBe(a){a=a|0;c[a+4>>2]=-2;return}function pBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function qBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function rBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=sBe(a)|0;RI(2853040)|0;a=pL(2853040,d)|0;i=b;return a|0}function sBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);grh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);grh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=F5g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function tBe(a){a=a|0;c[a+4>>2]=-2;return}function uBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function vBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function wBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=xBe(a)|0;RI(2854312)|0;a=pL(2854312,d)|0;i=b;return a|0}function xBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=O5g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function yBe(a){a=a|0;c[a+4>>2]=-2;return}function zBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ABe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function BBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=CBe(a)|0;RI(2855816)|0;a=pL(2855816,d)|0;i=b;return a|0}function CBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=X5g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function DBe(a){a=a|0;c[a+4>>2]=-2;return}function EBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function FBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function GBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=HBe(a)|0;RI(2857696)|0;a=pL(2857696,d)|0;i=b;return a|0}function HBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=e6g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function IBe(a){a=a|0;c[a+4>>2]=-2;return}function JBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function KBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function LBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=MBe(a)|0;RI(2860944)|0;a=pL(2860944,d)|0;i=b;return a|0}function MBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=n6g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function NBe(a){a=a|0;c[a+4>>2]=-2;return}function OBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function PBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function QBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=RBe(a)|0;RI(2861632)|0;a=pL(2861632,d)|0;i=b;return a|0}function RBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);hrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=w6g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function SBe(a){a=a|0;c[a+4>>2]=-2;return}function TBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function UBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function VBe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=WBe(a)|0;RI(2865352)|0;a=pL(2865352,d)|0;i=b;return a|0}function WBe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);hrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=F6g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function XBe(a){a=a|0;c[a+4>>2]=-2;return}function YBe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ZBe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function _Be(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=$Be(a)|0;RI(2881760)|0;a=pL(2881760,d)|0;i=b;return a|0}function $Be(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=O6g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function aCe(a){a=a|0;c[a+4>>2]=-2;return}function bCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function cCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function dCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=eCe(a)|0;RI(2884776)|0;a=pL(2884776,d)|0;i=b;return a|0}function eCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);hrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=X6g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function fCe(a){a=a|0;c[a+4>>2]=-2;return}function gCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function hCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function iCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=jCe(a)|0;RI(2887376)|0;a=pL(2887376,d)|0;i=b;return a|0}function jCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);hrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=e7g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function kCe(a){a=a|0;c[a+4>>2]=-2;return}function lCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function mCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function nCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=oCe(a)|0;RI(2889800)|0;a=pL(2889800,d)|0;i=b;return a|0}function oCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=n7g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function pCe(a){a=a|0;c[a+4>>2]=-2;return}function qCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function rCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function sCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=tCe(a)|0;RI(2892360)|0;a=pL(2892360,d)|0;i=b;return a|0}function tCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=w7g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function uCe(a){a=a|0;c[a+4>>2]=-2;return}function vCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function wCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function xCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=yCe(a)|0;RI(2893816)|0;a=pL(2893816,d)|0;i=b;return a|0}function yCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);hrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=F7g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function zCe(a){a=a|0;c[a+4>>2]=-2;return}function ACe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function BCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function CCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=DCe(a)|0;RI(2894608)|0;a=pL(2894608,d)|0;i=b;return a|0}function DCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);hrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=O7g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function ECe(a){a=a|0;c[a+4>>2]=-2;return}function FCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function GCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function HCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=ICe(a)|0;RI(2895112)|0;a=pL(2895112,d)|0;i=b;return a|0}function ICe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);hrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);hrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=X7g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function JCe(a){a=a|0;c[a+4>>2]=-2;return}function KCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function LCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function MCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=NCe(a)|0;RI(2896984)|0;a=pL(2896984,d)|0;i=b;return a|0}function NCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);irh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=e8g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function OCe(a){a=a|0;c[a+4>>2]=-2;return}function PCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function QCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function RCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=SCe(a)|0;RI(2897704)|0;a=pL(2897704,d)|0;i=b;return a|0}function SCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);irh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=n8g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function TCe(a){a=a|0;c[a+4>>2]=-2;return}function UCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function VCe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function WCe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=XCe(a)|0;RI(2911832)|0;a=pL(2911832,d)|0;i=b;return a|0}function XCe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);irh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=w8g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function YCe(a){a=a|0;c[a+4>>2]=-2;return}function ZCe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function _Ce(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function $Ce(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=aDe(b)|0;RI(2929064)|0;b=pL(2929064,d)|0;i=c;return b|0}function aDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);irh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=F8g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function bDe(a){a=a|0;c[a+4>>2]=-2;return}function cDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function dDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function eDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=fDe(a)|0;RI(2951152)|0;a=pL(2951152,d)|0;i=b;return a|0}function fDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);irh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=O8g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function gDe(a){a=a|0;c[a+4>>2]=-2;return}function hDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function iDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function jDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=kDe(a)|0;RI(2952200)|0;a=pL(2952200,d)|0;i=b;return a|0}function kDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);irh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=X8g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function lDe(a){a=a|0;c[a+4>>2]=-2;return}function mDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function nDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function oDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=pDe(a)|0;RI(2952704)|0;a=pL(2952704,d)|0;i=b;return a|0}function pDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);irh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=e9g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function qDe(a){a=a|0;c[a+4>>2]=-2;return}function rDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function sDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function tDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=uDe(a)|0;RI(2953232)|0;a=pL(2953232,d)|0;i=b;return a|0}function uDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);irh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);irh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=n9g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function vDe(a){a=a|0;c[a+4>>2]=-2;return}function wDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function xDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function yDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=zDe(a)|0;RI(2957696)|0;a=pL(2957696,d)|0;i=b;return a|0}function zDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);jrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=w9g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function ADe(a){a=a|0;c[a+4>>2]=-2;return}function BDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function CDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function DDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=EDe(a)|0;RI(2972984)|0;a=pL(2972984,d)|0;i=b;return a|0}function EDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);jrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=F9g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function FDe(a){a=a|0;c[a+4>>2]=-2;return}function GDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function HDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function IDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=JDe(a)|0;RI(3009344)|0;a=pL(3009344,d)|0;i=b;return a|0}function JDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);jrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=O9g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function KDe(a){a=a|0;c[a+4>>2]=-2;return}function LDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function MDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function NDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=ODe(a)|0;RI(3018040)|0;a=pL(3018040,d)|0;i=b;return a|0}function ODe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);jrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=X9g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function PDe(a){a=a|0;c[a+4>>2]=-2;return}function QDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function RDe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function SDe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=TDe(a)|0;RI(3029240)|0;a=pL(3029240,d)|0;i=b;return a|0}function TDe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);jrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=eah(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function UDe(a){a=a|0;c[a+4>>2]=-2;return}function VDe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function WDe(a){a=a|0;return}function XDe(a){a=a|0;return}function YDe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+80|0;e=a+48|0;f=a+64|0;g=a+32|0;h=a+16|0;j=a;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(3034456)|0;if(!(pL(3034456,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];RI(3034456)|0;k=((pL(3034456,h)|0)!=0)<<31>>31;i=a;return k|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];RI(3034456)|0;if(!(pL(3034456,j)|0)){k=1;i=a;return k|0}RI(3034456)|0;jM(f,1708088,pL(3034456,b)|0);b=c[(c[f+4>>2]|0)+4>>2]|0;j=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];k=_n[b&4095](j,e)|0;i=a;return k|0}function ZDe(a){a=a|0;var b=0;a=i;RI(1709096)|0;b=qL(1709096)|0;RI(1708784)|0;c[c[427219]>>2]=b;i=a;return}function _De(a){a=a|0;return}function $De(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+80|0;f=e+48|0;g=e+32|0;h=e+64|0;j=e+16|0;k=e;l=(d|0)!=0;if(!b){m=l<<31>>31;i=e;return m|0}if(!l){m=1;i=e;return m|0}RI(3034456)|0;if(!(vL(b,3034456)|0)){RI(2965048)|0;n=qL(2965048)|0;oig(n);jrh(n)}RI(3034456)|0;if(!(vL(d,3034456)|0)){RI(2965048)|0;n=qL(2965048)|0;oig(n);jrh(n)}RI(3034456)|0;n=krh(b,3034456)|0;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];RI(3034456)|0;aFi(j|0,krh(d,3034456)|0,16)|0;iM(h,1709264,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];m=xo[a&2047](d,g,f)|0;i=e;return m|0}function aEe(b){b=b|0;b=i;RI(1708784)|0;if(!(a[1708932]|0)){RI(1708784)|0;lrh(1708784)}RI(1708784)|0;i=b;return c[c[427219]>>2]|0}function bEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+160|0;e=a;f=a+144|0;g=a+32|0;h=a+80|0;j=a+112|0;k=a+128|0;l=a+48|0;m=a+96|0;n=a+16|0;o=a+64|0;shh();c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(3034456)|0;if(!(pL(3034456,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];RI(3034456)|0;p=((pL(3034456,h)|0)!=0)<<31>>31;i=a;return p|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];RI(3034456)|0;if(!(pL(3034456,j)|0)){p=1;i=a;return p|0};c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];RI(3034456)|0;j=pL(3034456,k)|0;RI(1707904)|0;if(vL(j,1707904)|0){c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];RI(3034456)|0;j=pL(3034456,l)|0;RI(1707904)|0;jM(f,1708088,mrh(j,1707904)|0);j=c[(c[f+4>>2]|0)+4>>2]|0;l=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];p=_n[j&4095](l,e)|0;i=a;return p|0};c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];RI(3034456)|0;e=pL(3034456,m)|0;RI(2546528)|0;if(!(vL(e,2546528)|0)){RI(2965048)|0;e=qL(2965048)|0;Rbg(e,c[888084]|0);jrh(e)};c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];RI(3034456)|0;b=pL(3034456,n)|0;c[o+0>>2]=c[d+0>>2];c[o+4>>2]=c[d+4>>2];c[o+8>>2]=c[d+8>>2];c[o+12>>2]=c[d+12>>2];RI(3034456)|0;d=pL(3034456,o)|0;RI(2546528)|0;p=Zqh(2546712,mrh(b,2546528)|0,d)|0;i=a;return p|0}function cEe(a){a=a|0;return}function dEe(a){a=a|0;return}function eEe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];RI(3034456)|0;if(!(pL(3034456,d)|0)){e=0;i=a;return e|0}RI(3034456)|0;e=Aqh(2536720,pL(3034456,b)|0)|0;i=a;return e|0}function fEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+64|0;e=a+32|0;f=a+48|0;g=a+16|0;h=a;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(3034456)|0;if(!(pL(3034456,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];RI(3034456)|0;j=(pL(3034456,h)|0)==0;i=a;return j|0}else{RI(3034456)|0;jM(f,1708368,pL(3034456,b)|0);b=c[(c[f+4>>2]|0)+4>>2]|0;h=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];j=_n[b&4095](h,e)|0;i=a;return j|0}return 0}function gEe(a){a=a|0;var b=0;a=i;RI(1711112)|0;b=qL(1711112)|0;RI(1710784)|0;c[c[427719]>>2]=b;i=a;return}function hEe(a){a=a|0;return}function iEe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+48|0;e=d+16|0;f=d+32|0;g=d;RI(3034456)|0;aFi(g|0,krh(b,3034456)|0,16)|0;iM(f,1711280,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];g=_n[a&4095](b,e)|0;i=d;return g|0}function jEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+80|0;f=e+48|0;g=e+32|0;h=e+64|0;j=e+16|0;k=e;RI(3034456)|0;l=krh(b,3034456)|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];RI(3034456)|0;aFi(j|0,krh(d,3034456)|0,16)|0;iM(h,1711336,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];j=xo[a&2047](d,g,f)|0;i=e;return j|0}function kEe(b){b=b|0;b=i;RI(1710784)|0;if(!(a[1710932]|0)){RI(1710784)|0;lrh(1710784)}RI(1710784)|0;i=b;return c[c[427719]>>2]|0}function lEe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];RI(3034456)|0;if(!(pL(3034456,d)|0)){e=0;i=a;return e|0}RI(3034456)|0;e=Aqh(2536720,pL(3034456,b)|0)|0;i=a;return e|0}function mEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+48|0;e=a+32|0;f=a+16|0;g=a;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];RI(3034456)|0;if(!(pL(3034456,e)|0)){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];RI(3034456)|0;h=(pL(3034456,f)|0)==0;i=a;return h|0}else{c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];RI(3034456)|0;d=pL(3034456,g)|0;RI(3034456)|0;h=nrh(2536048,pL(3034456,b)|0,d)|0;i=a;return h|0}return 0}function nEe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function oEe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=pEe(a)|0;RI(3053640)|0;a=pL(3053640,d)|0;i=b;return a|0}function pEe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);jrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=nah(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function qEe(a){a=a|0;c[a+4>>2]=-2;return}function rEe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function sEe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function tEe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=uEe(a)|0;RI(3062088)|0;a=pL(3062088,d)|0;i=b;return a|0}function uEe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);jrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=wah(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function vEe(a){a=a|0;c[a+4>>2]=-2;return}function wEe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function xEe(a){a=a|0;return}function yEe(a){a=a|0;return}function zEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+112|0;e=a+72|0;f=a+96|0;g=a+48|0;h=a+24|0;j=a;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];RI(3062592)|0;if(!(pL(3062592,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];RI(3062592)|0;k=((pL(3062592,h)|0)!=0)<<31>>31;i=a;return k|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];RI(3062592)|0;if(!(pL(3062592,j)|0)){k=1;i=a;return k|0}RI(3062592)|0;jM(f,1718040,pL(3062592,b)|0);b=c[(c[f+4>>2]|0)+4>>2]|0;j=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];c[e+20>>2]=c[d+20>>2];k=_n[b&4095](j,e)|0;i=a;return k|0}function AEe(a){a=a|0;var b=0;a=i;RI(1719048)|0;b=qL(1719048)|0;RI(1718736)|0;c[c[429707]>>2]=b;i=a;return}function BEe(a){a=a|0;return}function CEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+112|0;f=e+72|0;g=e+48|0;h=e+96|0;j=e+24|0;k=e;l=(d|0)!=0;if(!b){m=l<<31>>31;i=e;return m|0}if(!l){m=1;i=e;return m|0}RI(3062592)|0;if(!(vL(b,3062592)|0)){RI(2965048)|0;n=qL(2965048)|0;oig(n);jrh(n)}RI(3062592)|0;if(!(vL(d,3062592)|0)){RI(2965048)|0;n=qL(2965048)|0;oig(n);jrh(n)}RI(3062592)|0;n=krh(b,3062592)|0;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];c[k+16>>2]=c[n+16>>2];c[k+20>>2]=c[n+20>>2];RI(3062592)|0;aFi(j|0,krh(d,3062592)|0,24)|0;iM(h,1719216,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];m=xo[a&2047](d,g,f)|0;i=e;return m|0}function DEe(b){b=b|0;b=i;RI(1718736)|0;if(!(a[1718884]|0)){RI(1718736)|0;lrh(1718736)}RI(1718736)|0;i=b;return c[c[429707]>>2]|0}function EEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+224|0;e=a;f=a+216|0;g=a+48|0;h=a+120|0;j=a+168|0;k=a+192|0;l=a+72|0;m=a+144|0;n=a+24|0;o=a+96|0;shh();c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];RI(3062592)|0;if(!(pL(3062592,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];RI(3062592)|0;p=((pL(3062592,h)|0)!=0)<<31>>31;i=a;return p|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[j+16>>2]=c[d+16>>2];c[j+20>>2]=c[d+20>>2];RI(3062592)|0;if(!(pL(3062592,j)|0)){p=1;i=a;return p|0};c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[k+16>>2]=c[b+16>>2];c[k+20>>2]=c[b+20>>2];RI(3062592)|0;j=pL(3062592,k)|0;RI(1717856)|0;if(vL(j,1717856)|0){c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];c[l+16>>2]=c[b+16>>2];c[l+20>>2]=c[b+20>>2];RI(3062592)|0;j=pL(3062592,l)|0;RI(1717856)|0;jM(f,1718040,mrh(j,1717856)|0);j=c[(c[f+4>>2]|0)+4>>2]|0;l=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];c[e+20>>2]=c[d+20>>2];p=_n[j&4095](l,e)|0;i=a;return p|0};c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];RI(3062592)|0;e=pL(3062592,m)|0;RI(2546528)|0;if(!(vL(e,2546528)|0)){RI(2965048)|0;e=qL(2965048)|0;Rbg(e,c[888084]|0);jrh(e)};c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];c[n+16>>2]=c[b+16>>2];c[n+20>>2]=c[b+20>>2];RI(3062592)|0;b=pL(3062592,n)|0;c[o+0>>2]=c[d+0>>2];c[o+4>>2]=c[d+4>>2];c[o+8>>2]=c[d+8>>2];c[o+12>>2]=c[d+12>>2];c[o+16>>2]=c[d+16>>2];c[o+20>>2]=c[d+20>>2];RI(3062592)|0;d=pL(3062592,o)|0;RI(2546528)|0;p=Zqh(2546712,mrh(b,2546528)|0,d)|0;i=a;return p|0}function FEe(a){a=a|0;return}function GEe(a){a=a|0;return}function HEe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+32|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];RI(3062592)|0;if(!(pL(3062592,d)|0)){e=0;i=a;return e|0}RI(3062592)|0;e=Aqh(2536720,pL(3062592,b)|0)|0;i=a;return e|0}function IEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+80|0;e=a+48|0;f=a+72|0;g=a+24|0;h=a;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];RI(3062592)|0;if(!(pL(3062592,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];RI(3062592)|0;j=(pL(3062592,h)|0)==0;i=a;return j|0}else{RI(3062592)|0;jM(f,1718320,pL(3062592,b)|0);b=c[(c[f+4>>2]|0)+4>>2]|0;h=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];c[e+20>>2]=c[d+20>>2];j=_n[b&4095](h,e)|0;i=a;return j|0}return 0}function JEe(a){a=a|0;var b=0;a=i;RI(1721064)|0;b=qL(1721064)|0;RI(1720736)|0;c[c[430207]>>2]=b;i=a;return}function KEe(a){a=a|0;return}function LEe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+64|0;e=d+24|0;f=d+48|0;g=d;RI(3062592)|0;aFi(g|0,krh(b,3062592)|0,24)|0;iM(f,1721232,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];g=_n[a&4095](b,e)|0;i=d;return g|0}function MEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+112|0;f=e+72|0;g=e+48|0;h=e+96|0;j=e+24|0;k=e;RI(3062592)|0;l=krh(b,3062592)|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];RI(3062592)|0;aFi(j|0,krh(d,3062592)|0,24)|0;iM(h,1721288,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];j=xo[a&2047](d,g,f)|0;i=e;return j|0}function NEe(b){b=b|0;b=i;RI(1720736)|0;if(!(a[1720884]|0)){RI(1720736)|0;lrh(1720736)}RI(1720736)|0;i=b;return c[c[430207]>>2]|0}function OEe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+32|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];RI(3062592)|0;if(!(pL(3062592,d)|0)){e=0;i=a;return e|0}RI(3062592)|0;e=Aqh(2536720,pL(3062592,b)|0)|0;i=a;return e|0}function PEe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+80|0;e=a+48|0;f=a+24|0;g=a;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];RI(3062592)|0;if(!(pL(3062592,e)|0)){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];c[f+20>>2]=c[d+20>>2];RI(3062592)|0;h=(pL(3062592,f)|0)==0;i=a;return h|0}else{c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];c[g+20>>2]=c[d+20>>2];RI(3062592)|0;d=pL(3062592,g)|0;RI(3062592)|0;h=nrh(2536048,pL(3062592,b)|0,d)|0;i=a;return h|0}return 0}function QEe(b,d){b=b|0;d=d|0;var e=0,f=0;a[b+8>>0]=1;e=d;d=c[e+4>>2]|0;f=b;c[f>>2]=c[e>>2];c[f+4>>2]=d;return}function REe(b){b=b|0;return (a[b+8>>0]|0)!=0|0}function SEe(b){b=b|0;var d=0,e=0;d=i;chh();if(!(a[b+8>>0]|0)){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887644]|0);jrh(e)}else{e=b;H=c[e+4>>2]|0;i=d;return c[e>>2]|0}return 0}function TEe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;if(!d){g=(a[b+8>>0]|0)==0;i=e;return g|0}RI(1722704)|0;if(!(vL(d,1722704)|0)){g=0;i=e;return g|0}RI(1722704)|0;h=krh(d,1722704)|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];g=UEe(b,f)|0;i=e;return g|0}function UEe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=a[d+8>>0]|0;if(g<<24>>24!=(a[b+8>>0]|0)){h=0;i=e;return h|0}if(!(g<<24>>24)){h=1;i=e;return h|0}g=b;b=c[g+4>>2]|0;j=f;c[j>>2]=c[g>>2];c[j+4>>2]=b;RI(3120120)|0;b=pL(3120120,f)|0;RI(3120120)|0;h=nrh(2538040,pL(3120120,d)|0,b)|0;i=e;return h|0}function VEe(b){b=b|0;var c=0,d=0;c=i;if(!(a[b+8>>0]|0)){d=0;i=c;return d|0}RI(3120120)|0;d=Aqh(2538176,pL(3120120,b)|0)|0;i=c;return d|0}function WEe(b){b=b|0;var d=0,e=0;d=i;if(a[b+8>>0]|0){RI(3120120)|0;e=Fqh(2538232,pL(3120120,b)|0)|0;i=d;return e|0}if(!(a[2540708]|0))lrh(2540560);e=c[c[635163]>>2]|0;i=d;return e|0}function XEe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function YEe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=ZEe(a)|0;RI(3065280)|0;a=pL(3065280,d)|0;i=b;return a|0}function ZEe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);jrh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=Fah(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function _Ee(a){a=a|0;c[a+4>>2]=-2;return}function $Ee(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function aFe(a){a=a|0;return}function bFe(a){a=a|0;return}function cFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+80|0;e=a+56|0;f=a+48|0;g=a+32|0;h=a+16|0;j=a;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(3080504)|0;if(!(pL(3080504,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];RI(3080504)|0;k=((pL(3080504,h)|0)!=0)<<31>>31;i=a;return k|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];RI(3080504)|0;if(!(pL(3080504,j)|0)){k=1;i=a;return k|0}RI(3080504)|0;jM(f,1729968,pL(3080504,b)|0);b=c[(c[f+4>>2]|0)+4>>2]|0;j=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];k=_n[b&4095](j,e)|0;i=a;return k|0}function dFe(a){a=a|0;var b=0;a=i;RI(1730976)|0;b=qL(1730976)|0;RI(1730664)|0;c[c[432689]>>2]=b;i=a;return}function eFe(a){a=a|0;return}function fFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+80|0;f=e+56|0;g=e+40|0;h=e+32|0;j=e;k=e+16|0;l=(d|0)!=0;if(!b){m=l<<31>>31;i=e;return m|0}if(!l){m=1;i=e;return m|0}RI(3080504)|0;if(!(vL(b,3080504)|0)){RI(2965048)|0;n=qL(2965048)|0;oig(n);jrh(n)}RI(3080504)|0;if(!(vL(d,3080504)|0)){RI(2965048)|0;n=qL(2965048)|0;oig(n);jrh(n)}RI(3080504)|0;n=krh(b,3080504)|0;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];RI(3080504)|0;aFi(j|0,krh(d,3080504)|0,16)|0;iM(h,1731144,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];m=xo[a&2047](d,g,f)|0;i=e;return m|0}function gFe(b){b=b|0;b=i;RI(1730664)|0;if(!(a[1730812]|0)){RI(1730664)|0;lrh(1730664)}RI(1730664)|0;i=b;return c[c[432689]>>2]|0}function hFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+160|0;e=a;f=a+64|0;g=a+104|0;h=a+16|0;j=a+120|0;k=a+136|0;l=a+48|0;m=a+88|0;n=a+72|0;o=a+32|0;shh();c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(3080504)|0;if(!(pL(3080504,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];RI(3080504)|0;p=((pL(3080504,h)|0)!=0)<<31>>31;i=a;return p|0};c[j+0>>2]=c[d+0>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];RI(3080504)|0;if(!(pL(3080504,j)|0)){p=1;i=a;return p|0};c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];RI(3080504)|0;j=pL(3080504,k)|0;RI(1729784)|0;if(vL(j,1729784)|0){c[l+0>>2]=c[b+0>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];RI(3080504)|0;j=pL(3080504,l)|0;RI(1729784)|0;jM(f,1729968,mrh(j,1729784)|0);j=c[(c[f+4>>2]|0)+4>>2]|0;l=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];p=_n[j&4095](l,e)|0;i=a;return p|0};c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];RI(3080504)|0;e=pL(3080504,m)|0;RI(2546528)|0;if(!(vL(e,2546528)|0)){RI(2965048)|0;e=qL(2965048)|0;Rbg(e,c[888084]|0);jrh(e)};c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];RI(3080504)|0;b=pL(3080504,n)|0;c[o+0>>2]=c[d+0>>2];c[o+4>>2]=c[d+4>>2];c[o+8>>2]=c[d+8>>2];c[o+12>>2]=c[d+12>>2];RI(3080504)|0;d=pL(3080504,o)|0;RI(2546528)|0;p=Zqh(2546712,mrh(b,2546528)|0,d)|0;i=a;return p|0}function iFe(a){a=a|0;return}function jFe(a){a=a|0;return}function kFe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];RI(3080504)|0;if(!(pL(3080504,d)|0)){e=0;i=a;return e|0}RI(3080504)|0;e=Aqh(2536720,pL(3080504,b)|0)|0;i=a;return e|0}function lFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+64|0;e=a+40|0;f=a+32|0;g=a+16|0;h=a;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(3080504)|0;if(!(pL(3080504,g)|0)){c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];RI(3080504)|0;j=(pL(3080504,h)|0)==0;i=a;return j|0}else{RI(3080504)|0;jM(f,1730248,pL(3080504,b)|0);b=c[(c[f+4>>2]|0)+4>>2]|0;h=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];j=_n[b&4095](h,e)|0;i=a;return j|0}return 0}function mFe(a){a=a|0;var b=0;a=i;RI(1732992)|0;b=qL(1732992)|0;RI(1732664)|0;c[c[433189]>>2]=b;i=a;return}function nFe(a){a=a|0;return}function oFe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+48|0;e=d+24|0;f=d+16|0;g=d;RI(3080504)|0;aFi(g|0,krh(b,3080504)|0,16)|0;iM(f,1733160,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];g=_n[a&4095](b,e)|0;i=d;return g|0}function pFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+80|0;f=e+56|0;g=e+40|0;h=e+32|0;j=e;k=e+16|0;RI(3080504)|0;l=krh(b,3080504)|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];RI(3080504)|0;aFi(j|0,krh(d,3080504)|0,16)|0;iM(h,1733216,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];j=xo[a&2047](d,g,f)|0;i=e;return j|0}function qFe(b){b=b|0;b=i;RI(1732664)|0;if(!(a[1732812]|0)){RI(1732664)|0;lrh(1732664)}RI(1732664)|0;i=b;return c[c[433189]>>2]|0}function rFe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];RI(3080504)|0;if(!(pL(3080504,d)|0)){e=0;i=a;return e|0}RI(3080504)|0;e=Aqh(2536720,pL(3080504,b)|0)|0;i=a;return e|0}function sFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+48|0;e=a+32|0;f=a+16|0;g=a;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];RI(3080504)|0;if(!(pL(3080504,e)|0)){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];RI(3080504)|0;h=(pL(3080504,f)|0)==0;i=a;return h|0}else{c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];RI(3080504)|0;d=pL(3080504,g)|0;RI(3080504)|0;h=nrh(2536048,pL(3080504,b)|0,d)|0;i=a;return h|0}return 0}function tFe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function uFe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=vFe(a)|0;RI(3085560)|0;a=pL(3085560,d)|0;i=b;return a|0}function vFe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);jrh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);jrh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=Oah(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function wFe(a){a=a|0;c[a+4>>2]=-2;return}function xFe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function yFe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function zFe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=AFe(a)|0;RI(3113544)|0;a=pL(3113544,d)|0;i=b;return a|0}function AFe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);orh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);orh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=Xah(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function BFe(a){a=a|0;c[a+4>>2]=-2;return}function CFe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function DFe(a){a=a|0;return}function EFe(a){a=a|0;return}function FFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;i=i+48|0;e=a+32|0;f=a+24|0;g=a+16|0;h=a+8|0;j=a;k=b;l=c[k+4>>2]|0;m=f;c[m>>2]=c[k>>2];c[m+4>>2]=l;RI(3120120)|0;if(!(pL(3120120,f)|0)){f=d;l=c[f+4>>2]|0;m=g;c[m>>2]=c[f>>2];c[m+4>>2]=l;RI(3120120)|0;n=((pL(3120120,g)|0)!=0)<<31>>31;i=a;return n|0}g=d;d=c[g>>2]|0;l=c[g+4>>2]|0;g=h;c[g>>2]=d;c[g+4>>2]=l;RI(3120120)|0;if(!(pL(3120120,h)|0)){n=1;i=a;return n|0}RI(3120120)|0;h=pL(3120120,b)|0;b=j;c[b>>2]=d;c[b+4>>2]=l;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];n=prh(1749632,h,e)|0;i=a;return n|0}function GFe(a){a=a|0;var b=0;a=i;RI(1750640)|0;b=qL(1750640)|0;RI(1750328)|0;c[c[437605]>>2]=b;i=a;return}function HFe(a){a=a|0;return}function IFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;k=(d|0)!=0;if(!b){l=k<<31>>31;i=e;return l|0}if(!k){l=1;i=e;return l|0}RI(3120120)|0;if(!(vL(b,3120120)|0)){RI(2965048)|0;m=qL(2965048)|0;oig(m);orh(m)}RI(3120120)|0;if(!(vL(d,3120120)|0)){RI(2965048)|0;m=qL(2965048)|0;oig(m);orh(m)}RI(3120120)|0;m=qrh(b,3120120)|0;b=c[m+4>>2]|0;k=h;c[k>>2]=c[m>>2];c[k+4>>2]=b;RI(3120120)|0;b=qrh(d,3120120)|0;d=c[b+4>>2]|0;k=j;c[k>>2]=c[b>>2];c[k+4>>2]=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];l=rrh(1750808,a,g,f)|0;i=e;return l|0}function JFe(b){b=b|0;b=i;RI(1750328)|0;if(!(a[1750476]|0)){RI(1750328)|0;srh(1750328)}RI(1750328)|0;i=b;return c[c[437605]>>2]|0}function KFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;i=i+80|0;e=a;f=a+32|0;g=a+56|0;h=a+8|0;j=a+64|0;k=a+72|0;l=a+24|0;m=a+48|0;n=a+40|0;o=a+16|0;shh();p=b;b=c[p>>2]|0;q=c[p+4>>2]|0;p=f;c[p>>2]=b;c[p+4>>2]=q;RI(3120120)|0;if(!(pL(3120120,f)|0)){f=d;p=c[f+4>>2]|0;r=g;c[r>>2]=c[f>>2];c[r+4>>2]=p;RI(3120120)|0;s=((pL(3120120,g)|0)!=0)<<31>>31;i=a;return s|0}g=d;d=c[g>>2]|0;p=c[g+4>>2]|0;g=h;c[g>>2]=d;c[g+4>>2]=p;RI(3120120)|0;if(!(pL(3120120,h)|0)){s=1;i=a;return s|0}h=j;c[h>>2]=b;c[h+4>>2]=q;RI(3120120)|0;h=pL(3120120,j)|0;RI(1749448)|0;if(vL(h,1749448)|0){h=k;c[h>>2]=b;c[h+4>>2]=q;RI(3120120)|0;h=pL(3120120,k)|0;RI(1749448)|0;k=trh(h,1749448)|0;h=l;c[h>>2]=d;c[h+4>>2]=p;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];s=prh(1749632,k,e)|0;i=a;return s|0}e=m;c[e>>2]=b;c[e+4>>2]=q;RI(3120120)|0;e=pL(3120120,m)|0;RI(2546528)|0;if(!(vL(e,2546528)|0)){RI(2965048)|0;e=qL(2965048)|0;Rbg(e,c[888084]|0);orh(e)}e=n;c[e>>2]=b;c[e+4>>2]=q;RI(3120120)|0;q=pL(3120120,n)|0;n=o;c[n>>2]=d;c[n+4>>2]=p;RI(3120120)|0;p=pL(3120120,o)|0;RI(2546528)|0;s=Zqh(2546712,trh(q,2546528)|0,p)|0;i=a;return s|0}function LFe(a){a=a|0;return}function MFe(a){a=a|0;return}function NFe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a;e=b;f=c[e+4>>2]|0;g=d;c[g>>2]=c[e>>2];c[g+4>>2]=f;RI(3120120)|0;if(!(pL(3120120,d)|0)){h=0;i=a;return h|0}RI(3120120)|0;h=Aqh(2536720,pL(3120120,b)|0)|0;i=a;return h|0}function OFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+32|0;e=a+24|0;f=a+16|0;g=a+8|0;h=a;j=b;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k;RI(3120120)|0;if(!(pL(3120120,f)|0)){f=d;k=c[f+4>>2]|0;l=g;c[l>>2]=c[f>>2];c[l+4>>2]=k;RI(3120120)|0;m=(pL(3120120,g)|0)==0;i=a;return m|0}else{RI(3120120)|0;g=pL(3120120,b)|0;b=d;d=c[b+4>>2]|0;k=h;c[k>>2]=c[b>>2];c[k+4>>2]=d;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];m=urh(1749912,g,e)|0;i=a;return m|0}return 0}function PFe(a){a=a|0;var b=0;a=i;RI(1752696)|0;b=qL(1752696)|0;RI(1752368)|0;c[c[438115]>>2]=b;i=a;return}function QFe(a){a=a|0;return}function RFe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;RI(3120120)|0;g=qrh(b,3120120)|0;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=vrh(1752864,a,e)|0;i=d;return f|0}function SFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;RI(3120120)|0;k=qrh(b,3120120)|0;b=c[k+4>>2]|0;l=h;c[l>>2]=c[k>>2];c[l+4>>2]=b;RI(3120120)|0;b=qrh(d,3120120)|0;d=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=wrh(1752920,a,g,f)|0;i=e;return j|0}function TFe(b){b=b|0;b=i;RI(1752368)|0;if(!(a[1752516]|0)){RI(1752368)|0;srh(1752368)}RI(1752368)|0;i=b;return c[c[438115]>>2]|0}function UFe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a;e=b;f=c[e+4>>2]|0;g=d;c[g>>2]=c[e>>2];c[g+4>>2]=f;RI(3120120)|0;if(!(pL(3120120,d)|0)){h=0;i=a;return h|0}RI(3120120)|0;h=Aqh(2536720,pL(3120120,b)|0)|0;i=a;return h|0}function VFe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+32|0;e=a+16|0;f=a+8|0;g=a;h=b;j=c[h+4>>2]|0;k=e;c[k>>2]=c[h>>2];c[k+4>>2]=j;RI(3120120)|0;j=(pL(3120120,e)|0)==0;e=d;d=c[e>>2]|0;k=c[e+4>>2]|0;if(j){j=f;c[j>>2]=d;c[j+4>>2]=k;RI(3120120)|0;l=(pL(3120120,f)|0)==0;i=a;return l|0}else{f=g;c[f>>2]=d;c[f+4>>2]=k;RI(3120120)|0;k=pL(3120120,g)|0;RI(3120120)|0;l=nrh(2536048,pL(3120120,b)|0,k)|0;i=a;return l|0}return 0}function WFe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function XFe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=YFe(a)|0;RI(3126192)|0;a=pL(3126192,d)|0;i=b;return a|0}function YFe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);orh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);orh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=ebh(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function ZFe(a){a=a|0;c[a+4>>2]=-2;return}function _Fe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function $Fe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function aGe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)aGe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function bGe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function cGe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function dGe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d;Xxe(e,b);b=a+8|0;c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];c[b+16>>2]=c[e+16>>2];i=d;return}function eGe(a){a=a|0;var b=0,c=0;b=i;c=Iye(a+8|0)|0;i=b;return c|0}function fGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;f=b+8|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];RI(1336632)|0;xrh(a,2734240,pL(1336632,e)|0);i=d;return}function gGe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+8|0;f=d;c[f>>2]=0;c[f+4>>2]=0;Qye(d,a+8|0);c[e>>2]=uxe(d)|0;RI(2540224)|0;d=pL(2540224,e)|0;i=b;return d|0}function hGe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;Qye(d,a+8|0);a=vxe(d)|0;i=b;return a|0}function iGe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;yrh(c,1758776,a);RI(2729368)|0;a=pL(2729368,c)|0;i=b;return a|0}function jGe(a){a=a|0;return}function kGe(a){a=a|0;var b=0;a=i;RI(1759544)|0;b=qL(1759544)|0;RI(1759712)|0;c[c[439951]>>2]=b;i=a;return}function lGe(a){a=a|0;return}function mGe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(2540224)|0;e=Arh(1759880,a,c[(zrh(b,2540224)|0)>>2]|0)|0;i=d;return e|0}function nGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;RI(2540224)|0;f=c[(zrh(b,2540224)|0)>>2]|0;RI(2540224)|0;b=Brh(1759936,a,f,c[(zrh(d,2540224)|0)>>2]|0)|0;i=e;return b|0}function oGe(b){b=b|0;b=i;RI(1759712)|0;if(!(a[1759860]|0)){RI(1759712)|0;Crh(1759712)}RI(1759712)|0;i=b;return c[c[439951]>>2]|0}function pGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;c[d>>2]=b;c[e>>2]=b;RI(2540224)|0;if(!(pL(2540224,e)|0)){f=0;i=a;return f|0}RI(2540224)|0;f=Aqh(2536720,pL(2540224,d)|0)|0;i=a;return f|0}function qGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+12|0;f=a+8|0;g=a+4|0;h=a;c[e>>2]=b;c[f>>2]=b;RI(2540224)|0;if(!(pL(2540224,f)|0)){c[g>>2]=d;RI(2540224)|0;j=(pL(2540224,g)|0)==0;i=a;return j|0}else{c[h>>2]=d;RI(2540224)|0;d=pL(2540224,h)|0;RI(2540224)|0;j=nrh(2536048,pL(2540224,e)|0,d)|0;i=a;return j|0}return 0}function rGe(a){a=a|0;return}function sGe(a,b){a=a|0;b=b|0;var d=0;a=i;d=qL(c[b+16>>2]|0)|0;ko[c[(c[b+20>>2]|0)+4>>2]&4095](d);c[c[(c[b+12>>2]|0)+92>>2]>>2]=d;i=a;return}function tGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[a>>2]|0)+96>>2]|0;f=c[e+28>>2]|0;g=Erh(f,a,Drh(b,c[e+24>>2]|0)|0)|0;i=d;return g|0}function uGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[(c[a>>2]|0)+96>>2]|0;g=c[f+32>>2]|0;h=Drh(b,c[f+24>>2]|0)|0;f=Frh(g,a,h,Drh(d,c[(c[(c[a>>2]|0)+96>>2]|0)+24>>2]|0)|0)|0;i=e;return f|0}function vGe(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;e=d+12|0;d=c[e>>2]|0;if(!(a[d+148>>0]|0)){Crh(d);f=c[e>>2]|0}else f=d;i=b;return c[c[f+92>>2]>>2]|0}function wGe(a){a=a|0;var b=0;b=i;ko[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+36>>2]|0)+4>>2]&4095](a);i=b;return}function xGe(a,b){a=a|0;b=b|0;var c=0;a=i;if(!b)c=0;else c=Aqh(2536720,b)|0;i=a;return c|0}function yGe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=(c|0)==0;i=a;return d|0}else{d=nrh(2536048,b,c)|0;i=a;return d|0}return 0}function zGe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function AGe(a,b){a=a|0;b=b|0;var d=0;d=i;ko[c[(c[b>>2]|0)+4>>2]&4095](a);if((c[a+4>>2]|0)>0){i=d;return c[a+12>>2]|0}else{RI(3084976)|0;a=qL(3084976)|0;nsg(a);Grh(a)}return 0}function BGe(a){a=a|0;c[a>>2]=0;return}function CGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;Shh();f=c[a>>2]|0;if(!f){c[e+0>>2]=c[a+0>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];g=Fqh(2537592,Xnf(pL(c[b+8>>2]|0,e)|0)|0)|0;RI(3112928)|0;e=qL(3112928)|0;kwg(e,g);Grh(e)}if((c[a+8>>2]|0)==(c[f+16>>2]|0)){i=d;return}else{RI(3084976)|0;d=qL(3084976)|0;osg(d,c[888412]|0);Grh(d)}}function DGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;ko[c[(c[b>>2]|0)+4>>2]&4095](a);b=a+4|0;e=c[b>>2]|0;if((e|0)<=-1){f=0;i=d;return f|0}g=c[a>>2]|0;if((e|0)<(c[g+12>>2]|0)){h=c[g+8>>2]|0;c[b>>2]=e+1;c[a+12>>2]=c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,e)|0)>>2];f=1;i=d;return f|0}else{c[b>>2]=-1;f=0;i=d;return f|0}return 0}function EGe(a){a=a|0;return c[a+12>>2]|0}function FGe(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[b>>2]|0)+96>>2]>>2]|0;if(!(a[e+148>>0]|0)){Crh(e);f=c[c[(c[b>>2]|0)+96>>2]>>2]|0}else f=e;c[b+8>>2]=c[c[f+92>>2]>>2];i=d;return}function GGe(a,b){a=a|0;b=b|0;var d=0;d=i;Nhh();if((b|0)>-1){c[a+8>>2]=Hrh(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0,b)|0;i=d;return}else{RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888390]|0);Grh(d)}}function HGe(a,b){a=a|0;b=b|0;var d=0;a=i;d=Hrh(c[b+4>>2]|0,0)|0;c[c[(c[b>>2]|0)+92>>2]>>2]=d;i=a;return}function IGe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+16|0;e=b;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+8>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+12>>2]|0,e)|0;i=b;return d|0}function JGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function KGe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+16|0;e=b;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+8>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+12>>2]|0,e)|0;i=b;return d|0}function LGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;Ohh();e=c[(c[a>>2]|0)+96>>2]|0;f=c[e+20>>2]|0;Irh(f,a,Drh(b,c[e+16>>2]|0)|0);i=d;return (c[a+12>>2]|0)+-1|0}function MGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[a>>2]|0)+96>>2]|0;f=c[e+24>>2]|0;g=nrh(f,a,Drh(b,c[e+16>>2]|0)|0)|0;i=d;return g|0}function NGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[a>>2]|0)+96>>2]|0;f=c[e+28>>2]|0;g=Erh(f,a,Drh(b,c[e+16>>2]|0)|0)|0;i=d;return g|0}function OGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Phh();In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]&4095](a,b);f=c[(c[a>>2]|0)+96>>2]|0;g=c[f+36>>2]|0;Jrh(g,a,b,Drh(d,c[f+16>>2]|0)|0);i=e;return}function PGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[a>>2]|0)+96>>2]|0;f=c[e+40>>2]|0;nrh(f,a,Drh(b,c[e+16>>2]|0)|0)|0;i=d;return}function QGe(a){a=a|0;return 0}function RGe(a){a=a|0;return a|0}function SGe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Krh(c[(c[(c[a>>2]|0)+96>>2]|0)+44>>2]|0,a,b)|0;i=d;return e|0}function TGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Khh();f=c[(c[a>>2]|0)+96>>2]|0;g=c[f+48>>2]|0;Jrh(g,a,b,Drh(d,c[f+16>>2]|0)|0);i=e;return}function UGe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;if((f|0)==(c[h+12>>2]|0)){In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+52>>2]|0)+4>>2]&4095](a,1);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}c[e>>2]=j+1;c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,j)|0)>>2]=b;b=a+16|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function VGe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(c[a+12>>2]|0)+b|0;if((e|0)<=(c[(c[a+8>>2]|0)+12>>2]|0)){i=d;return}b=Asg(0,Asg(0,(mo[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+56>>2]|0)+4>>2]&4095](a)|0)<<1,4)|0,e)|0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+60>>2]|0)+4>>2]&4095](a,b);i=d;return}function WGe(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+12>>2]=0;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function XGe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(Bn[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+64>>2]|0)+4>>2]&255](0,c[a+8>>2]|0,b,0,c[a+12>>2]|0)|0)!=-1;i=d;return e|0}function YGe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function ZGe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function _Ge(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Bn[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+64>>2]|0)+4>>2]&255](0,c[a+8>>2]|0,b,0,c[a+12>>2]|0)|0;i=d;return e|0}function $Ge(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)>-1;g=b-(f?0:d)|0;b=a+12|0;h=c[b>>2]|0;if((h|0)>(g|0)){j=c[a+8>>2]|0;wEf(0,j,g,j,g+d|0,h-g|0);k=c[b>>2]|0}else k=h;h=k+d|0;c[b>>2]=h;if(f){i=e;return}yDf(0,c[a+8>>2]|0,h,0-d|0);i=e;return}function aHe(a,b){a=a|0;b=b|0;var d=0;d=i;Qhh();if((b|0)>=0?(c[a+12>>2]|0)>=(b|0):0){i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888404]|0);Grh(d)}function bHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]&4095](a,b);f=a+8|0;if((c[a+12>>2]|0)==(c[(c[f>>2]|0)+12>>2]|0))In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+52>>2]|0)+4>>2]&4095](a,1);co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+72>>2]|0)+4>>2]&2047](a,b,1);g=c[f>>2]|0;c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function cHe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=Erh(c[(c[(c[a>>2]|0)+96>>2]|0)+28>>2]|0,a,b)|0;b=(e|0)==-1;if(b){f=b^1;i=d;return f|0}Lrh(c[(c[(c[a>>2]|0)+96>>2]|0)+76>>2]|0,a,e);f=b^1;i=d;return f|0}function dHe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Rhh();if((b|0)>=0?(e=a+12|0,(c[e>>2]|0)>(b|0)):0){co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+72>>2]|0)+4>>2]&2047](a,b,-1);yDf(0,c[a+8>>2]|0,c[e>>2]|0,1);e=a+16|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888408]|0);Grh(d)}function eHe(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+12|0;e=Hrh(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0,c[d>>2]|0)|0;vEf(0,c[a+8>>2]|0,e,c[d>>2]|0);i=b;return e|0}function fHe(a){a=a|0;return c[(c[a+8>>2]|0)+12>>2]|0}function gHe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a+12>>2]|0)>(b|0)){RI(2964880)|0;e=qL(2964880)|0;_eg(e);Grh(e)}else{co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+80>>2]|0)+4>>2]&2047](0,a+8|0,b);i=d;return}}function hHe(a){a=a|0;return c[a+12>>2]|0}function iHe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Lhh();if((c[a+12>>2]|0)>(b|0)){e=c[a+8>>2]|0;a=c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,b)|0)>>2]|0;i=d;return a|0}else{RI(2964880)|0;a=qL(2964880)|0;wdg(a,c[888382]|0);Grh(a)}return 0}function jHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Mhh();In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]&4095](a,b);if((c[a+12>>2]|0)==(b|0)){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888386]|0);Grh(f)}else{f=c[a+8>>2]|0;c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function kHe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function lHe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function mHe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=nHe(a)|0;RI(2375496)|0;a=pL(2375496,d)|0;i=b;return a|0}function nHe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Grh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Grh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=bUg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function oHe(a){a=a|0;c[a+4>>2]=-2;return}function pHe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function qHe(a,b){a=a|0;b=b|0;var d=0;d=i;Mrh(1800264,a,c[b>>2]|0,c[b+4>>2]|0);i=d;return}function rHe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=sHe(a,e)|0;i=d;return f|0}function sHe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=0;if(!(Nrh(1800376,b,c[d>>2]|0,f)|0)){g=0;i=e;return g|0}RI(1833640)|0;if(!(a[1833788]|0)){RI(1833640)|0;Crh(1833640)}RI(1833640)|0;b=vGe(0,c[458434]|0)|0;g=Orh(1834192,b,c[d+4>>2]|0,c[f>>2]|0)|0;i=e;return g|0}function tHe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g>>2]|0;h=c[g+4>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=h;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];if(!(sHe(a,e)|0)){j=0;i=d;return j|0}j=Prh(1800320,a,b)|0;i=d;return j|0}function uHe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qrh(a,d,e);i=b;return}function vHe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function wHe(a){a=a|0;var b=0;b=i;co[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&2047](a,10,0);i=b;return}function xHe(a,b){a=a|0;b=b|0;var d=0;d=i;co[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&2047](a,10,b);i=d;return}function yHe(a,b){a=a|0;b=b|0;var d=0;d=i;co[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&2047](a,b,0);i=d;return}function zHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_n[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0)+4>>2]&4095](a,b)|0;b=_n[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+8>>2]|0)+4>>2]&4095](a,d)|0;Rrh(c[(c[(c[a>>2]|0)+96>>2]|0)+12>>2]|0,a,f,b);i=e;return}function AHe(a,b){a=a|0;b=b|0;var d=0;d=i;Rrh(1804752,a,c[b>>2]|0,c[b+4>>2]|0);i=d;return}function BHe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=CHe(a,e)|0;i=d;return f|0}function CHe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=0;if(!(Srh(1804864,b,c[d>>2]|0,f)|0)){g=0;i=e;return g|0}RI(1777920)|0;if(!(a[1778068]|0)){RI(1777920)|0;Crh(1777920)}b=Trh(0)|0;g=Frh(1778472,b,c[d+4>>2]|0,c[f>>2]|0)|0;i=e;return g|0}function DHe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g>>2]|0;h=c[g+4>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=h;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];if(!(CHe(a,e)|0)){j=0;i=d;return j|0}j=nrh(1804808,a,b)|0;i=d;return j|0}function EHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=vL(b,c[(c[(c[a>>2]|0)+96>>2]|0)+40>>2]|0)|0;k=c[(c[a>>2]|0)+96>>2]|0;if(j){co[c[(c[k+32>>2]|0)+4>>2]&2047](a,j,d);i=e;return}co[c[(c[k+44>>2]|0)+4>>2]&2047](a,b,d);RI(1104096)|0;k=vL(b,1104096)|0;j=c[(c[a>>2]|0)+96>>2]|0;if(!k){l=c[j+68>>2]|0;m=qL(c[j+72>>2]|0)|0;n=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+76>>2]|0)+4>>2]|0;c[h>>2]=l;c[f+0>>2]=c[h+0>>2];co[n&2047](m,0,f);Dn[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+80>>2]|0)+4>>2]&511](a,b,d,m);i=e;return}m=c[(c[(c[j+48>>2]|0)+92>>2]|0)+16>>2]|0;if(!m){b=c[j+52>>2]|0;n=qL(c[j+56>>2]|0)|0;h=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+60>>2]|0)+4>>2]|0;c[g>>2]=b;c[f+0>>2]=c[g+0>>2];co[h&2047](n,0,f);f=c[(c[a>>2]|0)+96>>2]|0;h=f+48|0;c[(c[(c[h>>2]|0)+92>>2]|0)+16>>2]=n;o=f;p=c[(c[(c[h>>2]|0)+92>>2]|0)+16>>2]|0}else{o=j;p=m}Dn[c[(c[o+64>>2]|0)+4>>2]&511](a,k,d,p);i=e;return}function FHe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+48|0;d=b+20|0;e=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+88>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+84>>2]|0,e)|0;i=b;return d|0}function GHe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+48|0;d=b+20|0;e=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+88>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+84>>2]|0,e)|0;i=b;return d|0}function HHe(a){a=a|0;var b=0,d=0;b=i;d=qL(c[(c[(c[a>>2]|0)+96>>2]|0)+92>>2]|0)|0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+96>>2]|0)+4>>2]&4095](d,a);i=b;return d|0}function IHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;thh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888106]|0);Grh(f)}f=a+40|0;g=Zqh(c[(c[(c[a>>2]|0)+96>>2]|0)+104>>2]|0,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;k=m+-1|0;a:do if(!m){n=k;o=-1;p=9}else{q=a+12|0;r=a+16|0;s=c[q>>2]|0;t=s;u=c[(c[s>>2]|0)+120>>2]|0;s=k;v=-1;while(1){if((c[t+16+(da(u,s)|0)>>2]|0)==(h|0)){w=c[r>>2]|0;if(Urh(c[(c[(c[a>>2]|0)+96>>2]|0)+108>>2]|0,c[f>>2]|0,c[w+16+(da(c[(c[w>>2]|0)+120>>2]|0,s)|0)>>2]|0,b)|0){n=s;o=v;p=9;break a}w=c[q>>2]|0;x=w;y=c[(c[w>>2]|0)+120>>2]|0}else{x=t;y=u}w=c[x+16+((da(y,s)|0)+4)>>2]|0;if((w|0)==-1)break;else{z=s;t=x;u=y;s=w;v=z}}}while(0);if((p|0)==9?(n|0)!=-1:0){if((o|0)==-1){A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}p=c[a+12>>2]|0;y=p+16|0;x=c[(c[p>>2]|0)+120>>2]|0;c[y+((da(x,o)|0)+4)>>2]=c[y+((da(x,n)|0)+4)>>2];x=c[j>>2]|0;o=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,g)|0)|0;c[y+((da(c[(c[p>>2]|0)+120>>2]|0,n)|0)+4)>>2]=(c[o>>2]|0)+-1;c[o>>2]=n+1;A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}n=a+32|0;o=c[n>>2]|0;c[n>>2]=o+1;if((o|0)<(c[a+36>>2]|0))M=g;else{ko[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+112>>2]|0)+4>>2]&4095](a);M=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){o=a+24|0;n=c[o>>2]|0;c[o>>2]=n+1;o=c[a+12>>2]|0;p=c[o>>2]|0;N=o;O=c[p+120>>2]|0;P=p;Q=n}else{n=c[a+12>>2]|0;p=c[n>>2]|0;o=c[p+120>>2]|0;c[l>>2]=c[n+16+((da(o,g)|0)+4)>>2];N=n;O=o;P=p;Q=g}g=c[j>>2]|0;j=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,M)|0)|0;c[N+16+((da(O,Q)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=Q+1;c[N+16+(da(c[P+120>>2]|0,Q)|0)>>2]=h;h=c[a+16>>2]|0;c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,Q)|0)>>2]=b;A=Q;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}function JHe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;uhh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[888110]|0);Grh(g)}if(!e){RI(1777920)|0;if(!(a[1778068]|0)){RI(1777920)|0;Crh(1777920)}h=b;j=mo[c[(c[(c[(c[b>>2]|0)+96>>2]|0)+116>>2]|0)+4>>2]&4095](0)|0}else{h=b;j=e}c[b+40>>2]=j;j=~~ea(ea(d|0)/ea(.899999976))+1|0;In[c[(c[(c[(c[h>>2]|0)+96>>2]|0)+120>>2]|0)+4>>2]&4095](b,(d|0)==0?12:j);c[b+48>>2]=0;i=f;return}function KHe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(1101728)|0;e=a+8|0;c[e>>2]=Hrh(1101728,b)|0;RI(1103136)|0;c[a+12>>2]=Hrh(1103136,b)|0;c[a+28>>2]=-1;c[a+16>>2]=Hrh(c[(c[(c[a>>2]|0)+96>>2]|0)+124>>2]|0,b)|0;c[a+20>>2]=Hrh(c[(c[(c[a>>2]|0)+96>>2]|0)+128>>2]|0,b)|0;c[a+24>>2]=0;b=c[(c[e>>2]|0)+12>>2]|0;e=~~ea(ea(b|0)*ea(.899999976));c[a+36>>2]=(e|0)!=0|(b|0)<1?e:1;i=d;return}function LHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;vhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888118]|0);Grh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888120]|0);Grh(f)}if((PCf(b)|0)<(d|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[888122]|0);Grh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(c[(c[(c[a>>2]|0)+96>>2]|0)+132>>2]|0,a)|0)){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[888124]|0);Grh(a)}else{i=e;return}}function MHe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Vrh(a,d,e);i=b;return}function NHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+44>>2]|0)+4>>2]&2047](a,b,d);h=c[(c[a>>2]|0)+96>>2]|0;j=c[h+68>>2]|0;k=qL(c[h+72>>2]|0)|0;h=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+76>>2]|0)+4>>2]|0;c[g>>2]=j;c[f+0>>2]=c[g+0>>2];co[h&2047](k,0,f);Dn[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+144>>2]|0)+4>>2]&511](a,b,d,k);i=e;return}function OHe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=b+8|0;f=c[e>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Crh(2730168)}g=nPf(0,c[f+12>>2]<<1|1)|0;RI(1101728)|0;f=Hrh(1101728,g)|0;RI(1103136)|0;h=Hrh(1103136,g)|0;j=c[e>>2]|0;if((c[j+12>>2]|0)>0){k=b+40|0;l=b+16|0;m=h+16|0;n=f+16|0;o=b+12|0;p=j;j=0;while(1){q=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0;if(!q)r=p;else{s=q+-1|0;do{q=c[l>>2]|0;t=Zqh(c[(c[(c[b>>2]|0)+96>>2]|0)+104>>2]|0,c[k>>2]|0,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,s)|0)>>2]|0)|0;c[m+(da(c[(c[h>>2]|0)+120>>2]|0,s)|0)>>2]=t|-2147483648;q=n+(da(c[(c[f>>2]|0)+120>>2]|0,(t&2147483647|0)%(g|0)|0)|0)|0;c[m+((da(c[(c[h>>2]|0)+120>>2]|0,s)|0)+4)>>2]=(c[q>>2]|0)+-1;c[q>>2]=s+1;q=c[o>>2]|0;s=c[q+16+((da(c[(c[q>>2]|0)+120>>2]|0,s)|0)+4)>>2]|0}while((s|0)!=-1);r=c[e>>2]|0}j=j+1|0;if((j|0)>=(c[r+12>>2]|0)){u=b;v=l;w=o;break}else p=r}}else{u=b;v=b+16|0;w=b+12|0}c[e>>2]=f;c[w>>2]=h;h=Hrh(c[(c[(c[u>>2]|0)+96>>2]|0)+124>>2]|0,g)|0;w=Hrh(c[(c[(c[u>>2]|0)+96>>2]|0)+128>>2]|0,g)|0;u=b+24|0;wEf(0,c[v>>2]|0,0,h,0,c[u>>2]|0);f=b+20|0;wEf(0,c[f>>2]|0,0,w,0,c[u>>2]|0);c[v>>2]=h;c[f>>2]=w;c[b+36>>2]=~~ea(ea(g|0)*ea(.899999976));i=d;return}function PHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;xhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888216]|0);Grh(f)}f=a+40|0;g=Zqh(c[(c[(c[a>>2]|0)+96>>2]|0)+104>>2]|0,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;a:do if(m){k=a+12|0;n=a+16|0;o=c[k>>2]|0;p=o;q=c[(c[o>>2]|0)+120>>2]|0;o=m+-1|0;while(1){if((c[p+16+(da(q,o)|0)>>2]|0)==(h|0)){r=c[n>>2]|0;if(Urh(c[(c[(c[a>>2]|0)+96>>2]|0)+108>>2]|0,c[f>>2]|0,c[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,o)|0)>>2]|0,b)|0)break;r=c[k>>2]|0;s=r;t=c[(c[r>>2]|0)+120>>2]|0}else{s=p;t=q}o=c[s+16+((da(t,o)|0)+4)>>2]|0;if((o|0)==-1)break a;else{p=s;q=t}}RI(2965048)|0;q=qL(2965048)|0;Rbg(q,c[888218]|0);Grh(q)}while(0);t=a+32|0;s=c[t>>2]|0;c[t>>2]=s+1;if((s|0)<(c[a+36>>2]|0))u=g;else{ko[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+112>>2]|0)+4>>2]&4095](a);u=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){s=a+24|0;t=c[s>>2]|0;c[s>>2]=t+1;s=c[a+12>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0;x=t}else{t=c[a+12>>2]|0;s=c[(c[t>>2]|0)+120>>2]|0;c[l>>2]=c[t+16+((da(s,g)|0)+4)>>2];v=t;w=s;x=g}c[v+16+(da(w,x)|0)>>2]=h;h=c[j>>2]|0;j=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,u)|0)|0;c[v+16+((da(w,x)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=x+1;j=c[a+16>>2]|0;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,x)|0)>>2]=b;b=c[a+20>>2]|0;c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,x)|0)>>2]=d;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function QHe(a){a=a|0;var b=0,d=0;b=i;c[a+32>>2]=0;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+16>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+20>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+12>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+28>>2]=-1;c[a+24>>2]=0;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function RHe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;RI(1777920)|0;if(!(a[1778068]|0)){RI(1777920)|0;Crh(1777920)}f=mo[c[(c[(c[(c[b>>2]|0)+96>>2]|0)+148>>2]|0)+4>>2]&4095](0)|0;g=b+8|0;h=c[g>>2]|0;if((c[h+12>>2]|0)<=0){j=0;i=e;return j|0}k=b+20|0;l=b+12|0;m=h;h=0;a:while(1){n=c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,h)|0)>>2]|0;if(!n)o=m;else{p=n+-1|0;do{n=c[k>>2]|0;if(Urh(c[(c[(c[b>>2]|0)+96>>2]|0)+152>>2]|0,f,c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,p)|0)>>2]|0,d)|0){j=1;q=11;break a}n=c[l>>2]|0;p=c[n+16+((da(c[(c[n>>2]|0)+120>>2]|0,p)|0)+4)>>2]|0}while((p|0)!=-1);o=c[g>>2]|0}h=h+1|0;if((h|0)>=(c[o+12>>2]|0)){j=0;q=11;break}else m=o}if((q|0)==11){i=e;return j|0}return 0}function SHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;yhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888254]|0);Grh(e)}r9f(b,c[888256]|0,c[a+48>>2]|0);L7f(b,c[888258]|0,c[a+40>>2]|0);e=c[a+32>>2]|0;if((e|0)<1)f=0;else{g=Hrh(c[(c[(c[a>>2]|0)+96>>2]|0)+156>>2]|0,e)|0;co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]&2047](a,g,0);f=g}r9f(b,c[888260]|0,c[(c[a+8>>2]|0)+12>>2]|0);L7f(b,c[888262]|0,f);i=d;return}function THe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;c[f>>2]=0;zhh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888278]|0);Grh(g)}g=a+40|0;h=Zqh(c[(c[(c[a>>2]|0)+96>>2]|0)+104>>2]|0,c[g>>2]|0,b)|0;j=h|-2147483648;k=a+8|0;l=c[k>>2]|0;m=(h&2147483647|0)%(c[l+12>>2]|0)|0;h=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,m)|0)>>2]|0;if(!h){n=0;i=d;return n|0}l=a+12|0;o=a+16|0;p=c[l>>2]|0;q=p;r=c[(c[p>>2]|0)+120>>2]|0;p=h+-1|0;h=-1;while(1){if((c[q+16+(da(r,p)|0)>>2]|0)==(j|0)){s=c[o>>2]|0;if(Urh(c[(c[(c[a>>2]|0)+96>>2]|0)+108>>2]|0,c[g>>2]|0,c[s+16+(da(c[(c[s>>2]|0)+120>>2]|0,p)|0)>>2]|0,b)|0){t=p;u=h;break}s=c[l>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0}else{v=q;w=r}s=c[v+16+((da(w,p)|0)+4)>>2]|0;if((s|0)==-1){n=0;x=14;break}else{y=p;q=v;r=w;p=s;h=y}}if((x|0)==14){i=d;return n|0}if((t|0)==-1){n=0;i=d;return n|0}x=a+32|0;c[x>>2]=(c[x>>2]|0)+-1;if((u|0)==-1){x=c[k>>2]|0;k=c[l>>2]|0;h=c[k>>2]|0;p=(c[k+16+((da(c[h+120>>2]|0,t)|0)+4)>>2]|0)+1|0;c[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,m)|0)>>2]=p;z=k;A=h}else{h=c[l>>2]|0;l=h+16|0;k=c[(c[h>>2]|0)+120>>2]|0;c[l+((da(k,u)|0)+4)>>2]=c[l+((da(k,t)|0)+4)>>2];z=h;A=c[h>>2]|0}h=a+28|0;k=z+16|0;c[k+((da(c[A+120>>2]|0,t)|0)+4)>>2]=c[h>>2];c[h>>2]=t;c[k+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=0;z=c[o>>2]|0;Wrh(e);c[z+16+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=c[e>>2];e=c[a+20>>2]|0;Wrh(f);c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,t)|0)>>2]=c[f>>2];f=a+48|0;c[f>>2]=(c[f>>2]|0)+1;n=1;i=d;return n|0}function UHe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;c[f>>2]=0;Ahh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888282]|0);Grh(g)}g=a+40|0;h=Zqh(c[(c[(c[a>>2]|0)+96>>2]|0)+104>>2]|0,c[g>>2]|0,b)|0;j=h|-2147483648;k=c[a+8>>2]|0;l=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,(h&2147483647|0)%(c[k+12>>2]|0)|0)|0)>>2]|0;a:do if(l){k=a+12|0;h=a+16|0;m=c[k>>2]|0;n=m;o=c[(c[m>>2]|0)+120>>2]|0;m=l+-1|0;while(1){if((c[n+16+(da(o,m)|0)>>2]|0)==(j|0)){p=c[h>>2]|0;if(Urh(c[(c[(c[a>>2]|0)+96>>2]|0)+108>>2]|0,c[g>>2]|0,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,m)|0)>>2]|0,b)|0){q=m;break}p=c[k>>2]|0;r=p;s=c[(c[p>>2]|0)+120>>2]|0}else{r=n;s=o}m=c[r+16+((da(s,m)|0)+4)>>2]|0;if((m|0)==-1)break a;else{n=r;o=s}}o=c[a+20>>2]|0;t=1;u=o+16+(da(c[(c[o>>2]|0)+120>>2]|0,q)|0)|0;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}while(0);Wrh(f);t=0;u=f;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}function VHe(a){a=a|0;var b=0,d=0;b=i;d=qL(c[(c[(c[a>>2]|0)+96>>2]|0)+160>>2]|0)|0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+164>>2]|0)+4>>2]&4095](d,a);i=b;return d|0}function WHe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;Bhh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888286]|0);Grh(h)}if(vL(d,c[(c[(c[b>>2]|0)+96>>2]|0)+100>>2]|0)|0){h=Drh(d,c[(c[(c[b>>2]|0)+96>>2]|0)+100>>2]|0)|0;i=e;return h|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Crh(2540728)}c[g>>2]=c[(c[(c[b>>2]|0)+96>>2]|0)+168>>2];c[f+0>>2]=c[g+0>>2];g=Fqh(2536192,npf(0,f)|0)|0;if(a[2540708]|0){j=c[888288]|0;k=gwf(0,j,g)|0;RI(2965048)|0;l=qL(2965048)|0;m=c[888290]|0;Rag(l,k,m);Grh(l)}Crh(2540560);j=c[888288]|0;k=gwf(0,j,g)|0;RI(2965048)|0;l=qL(2965048)|0;m=c[888290]|0;Rag(l,k,m);Grh(l);return 0}function XHe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=0;Chh();if(!d){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Crh(2540728)}c[h>>2]=c[(c[(c[b>>2]|0)+96>>2]|0)+172>>2];c[f+0>>2]=c[h+0>>2];if(!(Gqh(2650144,npf(0,f)|0)|0)){Wrh(g);k=c[g>>2]|0;i=e;return k|0}else l=b}else l=b;if(vL(d,c[(c[(c[l>>2]|0)+96>>2]|0)+176>>2]|0)|0){k=Drh(d,c[(c[(c[l>>2]|0)+96>>2]|0)+176>>2]|0)|0;i=e;return k|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Crh(2540728)}c[j>>2]=c[(c[(c[l>>2]|0)+96>>2]|0)+172>>2];c[f+0>>2]=c[j+0>>2];j=Fqh(2536192,npf(0,f)|0)|0;if(a[2540708]|0){m=c[888302]|0;n=gwf(0,m,j)|0;RI(2965048)|0;o=qL(2965048)|0;p=c[888304]|0;Rag(o,n,p);Grh(o)}Crh(2540560);m=c[888302]|0;n=gwf(0,m,j)|0;RI(2965048)|0;o=qL(2965048)|0;p=c[888304]|0;Rag(o,n,p);Grh(o);return 0}function YHe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function ZHe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;Jhh();RI(1094176)|0;f=Hrh(1094176,5)|0;Qqh(f,c[888370]|0);g=f+16|0;c[g>>2]=c[888370];h=d+8|0;if(!(mo[c[(c[h>>2]|0)+4>>2]&4095](b)|0)){if(!(a[2540708]|0))Crh(2540560);j=c[c[635163]>>2]|0}else j=Fqh(2536904,mo[c[(c[h>>2]|0)+4>>2]&4095](b)|0)|0;Qqh(f,j);c[g+(c[(c[f>>2]|0)+120>>2]|0)>>2]=j;Qqh(f,c[888372]|0);c[g+(c[(c[f>>2]|0)+120>>2]<<1)>>2]=c[888372];j=d+16|0;if(!(mo[c[(c[j>>2]|0)+4>>2]&4095](b)|0)){if(!(a[2540708]|0))Crh(2540560);k=c[c[635163]>>2]|0}else k=Fqh(2536904,mo[c[(c[j>>2]|0)+4>>2]&4095](b)|0)|0;Qqh(f,k);c[g+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>2]=k;Qqh(f,c[888374]|0);c[g+(c[(c[f>>2]|0)+120>>2]<<2)>>2]=c[888374];if(a[2540708]|0){l=lwf(0,f)|0;i=e;return l|0}Crh(2540560);l=lwf(0,f)|0;i=e;return l|0}function _He(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function $He(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;aIe(c,a);RI(1810464)|0;a=pL(1810464,c)|0;i=b;return a|0}function aIe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);Grh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Grh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;kUg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function bIe(a){a=a|0;c[a+4>>2]=-2;return}function cIe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function dIe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Fhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888332]|0);Grh(e)}else{c[a+8>>2]=b;i=d;return}}function eIe(a,b){a=a|0;b=b|0;Ghh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888342]|0);Grh(b)}function fIe(a){a=a|0;Hhh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[888362]|0);Grh(a)}function gIe(a,b){a=a|0;b=b|0;Ihh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888366]|0);Grh(b);return 0}function hIe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+48|0;d=b+20|0;e=b;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+8>>2]|0,e)|0;i=b;return d|0}function iIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+4|0;g=e;h=vL(b,c[(c[(c[a>>2]|0)+96>>2]|0)+12>>2]|0)|0;if(!h){j=a+8|0;co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+20>>2]|0)+4>>2]&2047](c[j>>2]|0,b,d);k=c[j>>2]|0;j=c[(c[a>>2]|0)+96>>2]|0;l=c[j+24>>2]|0;m=qL(c[j+28>>2]|0)|0;j=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]|0;c[g>>2]=l;c[f+0>>2]=c[g+0>>2];co[j&2047](m,0,f);Dn[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+36>>2]|0)+4>>2]&511](k,b,d,m);i=e;return}else{Xrh(c[(c[(c[a>>2]|0)+96>>2]|0)+16>>2]|0,a,h,d);i=e;return}}function jIe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+48|0;d=b+20|0;e=b;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+8>>2]|0,e)|0;i=b;return d|0}function kIe(a){a=a|0;var b=0,d=0;b=i;d=Sqh(2647408,c[a+8>>2]|0)|0;i=b;return d|0}function lIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=a+8|0;co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+20>>2]|0)+4>>2]&2047](c[h>>2]|0,b,d);j=c[h>>2]|0;h=c[(c[a>>2]|0)+96>>2]|0;k=c[h+24>>2]|0;l=qL(c[h+28>>2]|0)|0;h=c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]|0;c[g>>2]=k;c[f+0>>2]=c[g+0>>2];co[h&2047](l,0,f);Dn[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+40>>2]|0)+4>>2]&511](j,b,d,l);i=e;return}function mIe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+8>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;Yrh(a,e);i=d;return}function nIe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(c[(c[(c[a>>2]|0)+96>>2]|0)+48>>2]|0,c[a+8>>2]|0)|0;i=b;return d|0}function oIe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;ko[c[(c[b>>2]|0)+4>>2]&4095](a);f=a+12|0;a=c[f+4>>2]|0;g=e;c[g>>2]=c[f>>2];c[g+4>>2]=a;a=pL(c[b+4>>2]|0,e)|0;i=d;return a|0}function pIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;ko[c[(c[d>>2]|0)+4>>2]&4095](b);f=b+12|0;b=mo[c[(c[d+8>>2]|0)+4>>2]&4095](f)|0;g=mo[c[(c[d+16>>2]|0)+4>>2]&4095](f)|0;f=a;c[f>>2]=0;c[f+4>>2]=0;LOf(a,b,g);i=e;return}function qIe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;ko[c[(c[b+32>>2]|0)+4>>2]&4095](a);f=a+4|0;g=c[f>>2]|0;if((g|0)<=-1){h=0;i=d;return h|0}j=c[a>>2]|0;k=c[j+24>>2]|0;l=g;while(1){if((l|0)>=(k|0)){m=6;break}g=l+1|0;c[f>>2]=g;n=c[j+12>>2]|0;if((c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,l)|0)>>2]|0)<0){o=l;m=3;break}else l=g}if((m|0)==3){l=c[j+16>>2]|0;k=c[j+20>>2]|0;j=e;c[j>>2]=0;c[j+4>>2]=0;j=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,o)|0)>>2]|0;l=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,o)|0)>>2]|0;co[c[(c[b+36>>2]|0)+4>>2]&2047](e,j,l);l=e;e=c[l+4>>2]|0;j=a+12|0;c[j>>2]=c[l>>2];c[j+4>>2]=e;h=1;i=d;return h|0}else if((m|0)==6){c[f>>2]=-1;h=0;i=d;return h|0}return 0}function rIe(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function sIe(a){a=a|0;var b=0,d=0,e=0;b=i;Dhh();d=c[a>>2]|0;if(!d){RI(3112928)|0;e=qL(3112928)|0;kwg(e,0);Grh(e)}if((c[d+48>>2]|0)==(c[a+8>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888308]|0);Grh(b)}}function tIe(a,b){a=a|0;b=b|0;var d=0;d=i;Ehh();ko[c[(c[b+32>>2]|0)+4>>2]&4095](a);if((c[a+4>>2]|0)>0){i=d;return}else{RI(3084976)|0;d=qL(3084976)|0;osg(d,c[888318]|0);Grh(d)}}function uIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)uIe(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function vIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function wIe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)wIe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function xIe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function yIe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function zIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function AIe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)AIe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function BIe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function CIe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function DIe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d;In[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&4095](e,b);b=a+8|0;c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];c[b+16>>2]=c[e+16>>2];i=d;return}function EIe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;f=b+8|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];xrh(a,2734240,pL(c[(c[(c[b>>2]|0)+96>>2]|0)+8>>2]|0,e)|0);i=d;return}function FIe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+12>>2]|0)+4>>2]&4095](d,a+8|0);e=mo[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+16>>2]|0)+4>>2]&4095](d)|0;i=b;return e|0}function GIe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;In[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+12>>2]|0)+4>>2]&4095](d,a+8|0);e=mo[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+24>>2]|0)+4>>2]&4095](d)|0;i=b;return e|0}function HIe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;yrh(d,c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0,a);RI(2729368)|0;a=pL(2729368,d)|0;i=b;return a|0}function IIe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function JIe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;KIe(c,a);RI(1820016)|0;a=pL(1820016,c)|0;i=b;return a|0}function KIe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);Grh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Grh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;zUg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function LIe(a){a=a|0;c[a+4>>2]=-2;return}function MIe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function NIe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+8>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;Zrh(a,e);i=d;return}function OIe(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function PIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function QIe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)QIe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function RIe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function SIe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function TIe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function UIe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)UIe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function VIe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function WIe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function XIe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function YIe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=ZIe(a)|0;RI(2390624)|0;a=pL(2390624,d)|0;i=b;return a|0}function ZIe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_rh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_rh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=OUg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function _Ie(a){a=a|0;c[a+4>>2]=-2;return}function $Ie(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function aJe(a){a=a|0;var b=0;b=i;bJe(a,10,0);i=b;return}function bJe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;uhh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[888110]|0);_rh(g)}if(!e){RI(1831832)|0;if(!(a[1831980]|0)){RI(1831832)|0;$rh(1831832)}h=ash(0)|0}else h=e;c[b+40>>2]=h;h=~~ea(ea(d|0)/ea(.899999976))+1|0;DJe(b,(d|0)==0?12:h);c[b+48>>2]=0;i=f;return}function cJe(a,b){a=a|0;b=b|0;var c=0;c=i;bJe(a,10,b);i=c;return}function dJe(a,b){a=a|0;b=b|0;var c=0;c=i;bJe(a,b,0);i=c;return}function eJe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=fJe(0,b)|0;bsh(1837912,a,e,gJe(0,c)|0);i=d;return}function fJe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+4|0;f=b;Bhh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888286]|0);_rh(g)}if(!(vL(d,2540560)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;$rh(2540728)}c[f>>2]=3431728;c[e+0>>2]=c[f+0>>2];f=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);_rh(k)}$rh(2540560);h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);_rh(k)}k=vL(d,2540560)|0;if(k){i=b;return k|0}_J(e,c[(c[d>>2]|0)+44>>2]|0,2540560);if(!(a[e>>0]&1)){m=e+1|0;n=MJ(m)|0;FJ(n)}else{m=c[e+8>>2]|0;n=MJ(m)|0;FJ(n)}return 0}function gJe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=0;Chh();j=(d|0)==0;if(j){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;$rh(2540728)}c[g>>2]=3431160;c[e+0>>2]=c[g+0>>2];if(!(Gqh(2650144,npf(0,e)|0)|0)){csh(2540224,f);k=f;l=c[k>>2]|0;i=b;return l|0}}RI(2540224)|0;if(!(vL(d,2540224)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;$rh(2540728)}c[h>>2]=3431160;c[e+0>>2]=c[h+0>>2];h=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){m=c[888302]|0;n=gwf(0,m,h)|0;RI(2965048)|0;o=qL(2965048)|0;p=c[888304]|0;Rag(o,n,p);_rh(o)}$rh(2540560);m=c[888302]|0;n=gwf(0,m,h)|0;RI(2965048)|0;o=qL(2965048)|0;p=c[888304]|0;Rag(o,n,p);_rh(o)}RI(2540224)|0;if(j)HJ();j=c[(c[d>>2]|0)+44>>2]|0;o=c[635067]|0;if((j|0)==(o|0)){k=yL(d)|0;l=c[k>>2]|0;i=b;return l|0}_J(e,j,o);if(!(a[e>>0]&1)){q=e+1|0;r=MJ(q)|0;FJ(r)}else{q=c[e+8>>2]|0;r=MJ(q)|0;FJ(r)}return 0}function hJe(a){a=a|0;return a|0}function iJe(a){a=a|0;return 0}function jJe(a,b){a=a|0;b=b|0;var d=0;d=i;bsh(1837968,a,c[b>>2]|0,c[b+4>>2]|0);i=d;return}function kJe(a){a=a|0;return c[a>>2]|0}function lJe(a){a=a|0;return c[a+4>>2]|0}function mJe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=nJe(a,e)|0;i=d;return f|0}function nJe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=0;if(!(dsh(1839256,b,c[d>>2]|0,f)|0)){g=0;i=e;return g|0}RI(1759712)|0;if(!(a[1759860]|0)){RI(1759712)|0;$rh(1759712)}b=oGe(0)|0;g=Brh(1759936,b,c[d+4>>2]|0,c[f>>2]|0)|0;i=e;return g|0}function oJe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;pJe(a,b,c);i=d;return}function pJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;sJe(a,b,d);RI(1838528)|0;f=qL(1838528)|0;c[f+8>>2]=c[459619];c[f+20>>2]=1838472;c[f+16>>2]=0;kVg(a,b,d,f);i=e;return}function qJe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g>>2]|0;h=c[g+4>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=h;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];if(!(nJe(a,e)|0)){j=0;i=d;return j|0}j=Prh(1838024,a,b)|0;i=d;return j|0}function rJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(1111064)|0;f=vL(b,1111064)|0;if(f){pJe(a,f,d);i=e;return}sJe(a,b,d);RI(1104096)|0;f=vL(b,1104096)|0;if(!f){RI(1838528)|0;g=qL(1838528)|0;c[g+8>>2]=c[459619];c[g+20>>2]=1838472;c[g+16>>2]=0;iVg(a,b,d,g);i=e;return}RI(1838080)|0;if(!(c[(c[459543]|0)+16>>2]|0)){RI(1838304)|0;g=qL(1838304)|0;c[g+8>>2]=c[459563];c[g+20>>2]=1838248;c[g+16>>2]=0;RI(1838080)|0;c[(c[459543]|0)+16>>2]=g}RI(1838080)|0;hVg(a,f,d,c[(c[459543]|0)+16>>2]|0);i=e;return}function sJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;vhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888118]|0);_rh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888120]|0);_rh(f)}if((PCf(b)|0)<(d|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[888122]|0);_rh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(1839032,a)|0)){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[888124]|0);_rh(a)}else{i=e;return}}function tJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function uJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function vJe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(1838696)|0;e=pL(1838696,d)|0;i=b;return e|0}function wJe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function xJe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(1838696)|0;e=pL(1838696,d)|0;i=b;return e|0}function yJe(a){a=a|0;var b=0,c=0;b=i;RI(1838864)|0;c=qL(1838864)|0;zJe(c,a);i=b;return c|0}function zJe(a,b){a=a|0;b=b|0;var d=0;d=c[b+48>>2]|0;c[a+8>>2]=b;c[a+12>>2]=0;c[a+16>>2]=d;d=a+20|0;c[d>>2]=0;c[d+4>>2]=0;return}function AJe(a){a=a|0;return c[a+32>>2]|0}function BJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;thh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888106]|0);_rh(f)}f=a+40|0;g=esh(1822656,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;k=m+-1|0;a:do if(!m){n=k;o=-1;p=9}else{q=a+12|0;r=a+16|0;s=c[q>>2]|0;t=s;u=c[(c[s>>2]|0)+120>>2]|0;s=k;v=-1;while(1){if((c[t+16+(da(u,s)|0)>>2]|0)==(h|0)){w=c[r>>2]|0;if(fsh(1822584,c[f>>2]|0,c[w+16+(da(c[(c[w>>2]|0)+120>>2]|0,s)|0)>>2]|0,b)|0){n=s;o=v;p=9;break a}w=c[q>>2]|0;x=w;y=c[(c[w>>2]|0)+120>>2]|0}else{x=t;y=u}w=c[x+16+((da(y,s)|0)+4)>>2]|0;if((w|0)==-1)break;else{z=s;t=x;u=y;s=w;v=z}}}while(0);if((p|0)==9?(n|0)!=-1:0){if((o|0)==-1){A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}p=c[a+12>>2]|0;y=p+16|0;x=c[(c[p>>2]|0)+120>>2]|0;c[y+((da(x,o)|0)+4)>>2]=c[y+((da(x,n)|0)+4)>>2];x=c[j>>2]|0;o=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,g)|0)|0;c[y+((da(c[(c[p>>2]|0)+120>>2]|0,n)|0)+4)>>2]=(c[o>>2]|0)+-1;c[o>>2]=n+1;A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}n=a+32|0;o=c[n>>2]|0;c[n>>2]=o+1;if((o|0)<(c[a+36>>2]|0))M=g;else{CJe(a);M=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){o=a+24|0;n=c[o>>2]|0;c[o>>2]=n+1;o=c[a+12>>2]|0;p=c[o>>2]|0;N=o;O=c[p+120>>2]|0;P=p;Q=n}else{n=c[a+12>>2]|0;p=c[n>>2]|0;o=c[p+120>>2]|0;c[l>>2]=c[n+16+((da(o,g)|0)+4)>>2];N=n;O=o;P=p;Q=g}g=c[j>>2]|0;j=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,M)|0)|0;c[N+16+((da(O,Q)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=Q+1;c[N+16+(da(c[P+120>>2]|0,Q)|0)>>2]=h;h=c[a+16>>2]|0;c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,Q)|0)>>2]=b;A=Q;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}function CJe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+8|0;f=c[e>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;$rh(2730168)}g=nPf(0,c[f+12>>2]<<1|1)|0;RI(1101728)|0;f=gsh(1101728,g)|0;RI(1103136)|0;h=gsh(1103136,g)|0;j=c[e>>2]|0;if((c[j+12>>2]|0)>0){k=b+40|0;l=b+16|0;m=h+16|0;n=f+16|0;o=b+12|0;p=j;j=0;while(1){q=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0;if(!q)r=p;else{s=q+-1|0;do{q=c[l>>2]|0;t=esh(1822656,c[k>>2]|0,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,s)|0)>>2]|0)|0;c[m+(da(c[(c[h>>2]|0)+120>>2]|0,s)|0)>>2]=t|-2147483648;q=n+(da(c[(c[f>>2]|0)+120>>2]|0,(t&2147483647|0)%(g|0)|0)|0)|0;c[m+((da(c[(c[h>>2]|0)+120>>2]|0,s)|0)+4)>>2]=(c[q>>2]|0)+-1;c[q>>2]=s+1;q=c[o>>2]|0;s=c[q+16+((da(c[(c[q>>2]|0)+120>>2]|0,s)|0)+4)>>2]|0}while((s|0)!=-1);r=c[e>>2]|0}j=j+1|0;if((j|0)>=(c[r+12>>2]|0)){u=l;v=o;break}else p=r}}else{u=b+16|0;v=b+12|0}c[e>>2]=f;c[v>>2]=h;RI(1094176)|0;h=gsh(1094176,g)|0;RI(1101728)|0;v=gsh(1101728,g)|0;f=b+24|0;wEf(0,c[u>>2]|0,0,h,0,c[f>>2]|0);e=b+20|0;wEf(0,c[e>>2]|0,0,v,0,c[f>>2]|0);c[u>>2]=h;c[e>>2]=v;c[b+36>>2]=~~ea(ea(g|0)*ea(.899999976));i=d;return}function DJe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(1101728)|0;e=a+8|0;c[e>>2]=gsh(1101728,b)|0;RI(1103136)|0;c[a+12>>2]=gsh(1103136,b)|0;c[a+28>>2]=-1;RI(1094176)|0;c[a+16>>2]=gsh(1094176,b)|0;RI(1101728)|0;c[a+20>>2]=gsh(1101728,b)|0;c[a+24>>2]=0;b=c[(c[e>>2]|0)+12>>2]|0;e=~~ea(ea(b|0)*ea(.899999976));c[a+36>>2]=(e|0)!=0|(b|0)<1?e:1;i=d;return}function EJe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[a>>2]=d;c[a+4>>2]=e;return}function FJe(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;return}function GJe(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function HJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;xhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888216]|0);_rh(f)}f=a+40|0;g=esh(1822656,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;a:do if(m){k=a+12|0;n=a+16|0;o=c[k>>2]|0;p=o;q=c[(c[o>>2]|0)+120>>2]|0;o=m+-1|0;while(1){if((c[p+16+(da(q,o)|0)>>2]|0)==(h|0)){r=c[n>>2]|0;if(fsh(1822584,c[f>>2]|0,c[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,o)|0)>>2]|0,b)|0)break;r=c[k>>2]|0;s=r;t=c[(c[r>>2]|0)+120>>2]|0}else{s=p;t=q}o=c[s+16+((da(t,o)|0)+4)>>2]|0;if((o|0)==-1)break a;else{p=s;q=t}}RI(2965048)|0;q=qL(2965048)|0;Rbg(q,c[888218]|0);_rh(q)}while(0);t=a+32|0;s=c[t>>2]|0;c[t>>2]=s+1;if((s|0)<(c[a+36>>2]|0))u=g;else{CJe(a);u=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){s=a+24|0;t=c[s>>2]|0;c[s>>2]=t+1;s=c[a+12>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0;x=t}else{t=c[a+12>>2]|0;s=c[(c[t>>2]|0)+120>>2]|0;c[l>>2]=c[t+16+((da(s,g)|0)+4)>>2];v=t;w=s;x=g}c[v+16+(da(w,x)|0)>>2]=h;h=c[j>>2]|0;j=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,u)|0)|0;c[v+16+((da(w,x)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=x+1;j=c[a+16>>2]|0;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,x)|0)>>2]=b;b=c[a+20>>2]|0;c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,x)|0)>>2]=d;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function IJe(a){a=a|0;var b=0,d=0;b=i;c[a+32>>2]=0;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+16>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+20>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+12>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+28>>2]=-1;c[a+24>>2]=0;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function JJe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;RI(1759712)|0;if(!(a[1759860]|0)){RI(1759712)|0;$rh(1759712)}f=oGe(0)|0;g=b+8|0;h=c[g>>2]|0;if((c[h+12>>2]|0)<=0){j=0;i=e;return j|0}k=b+20|0;l=b+12|0;b=h;h=0;a:while(1){m=c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,h)|0)>>2]|0;if(!m)n=b;else{o=m+-1|0;do{m=c[k>>2]|0;if(Nqh(1336856,f,c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,o)|0)>>2]|0,d)|0){j=1;p=11;break a}m=c[l>>2]|0;o=c[m+16+((da(c[(c[m>>2]|0)+120>>2]|0,o)|0)+4)>>2]|0}while((o|0)!=-1);n=c[g>>2]|0}h=h+1|0;if((h|0)>=(c[n+12>>2]|0)){j=0;p=11;break}else b=n}if((p|0)==11){i=e;return j|0}return 0}function KJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;yhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888254]|0);_rh(e)}r9f(b,c[888256]|0,c[a+48>>2]|0);L7f(b,c[888258]|0,c[a+40>>2]|0);e=c[a+32>>2]|0;if((e|0)<1)f=0;else{RI(1111064)|0;g=gsh(1111064,e)|0;pJe(a,g,0);f=g}r9f(b,c[888260]|0,c[(c[a+8>>2]|0)+12>>2]|0);L7f(b,c[888262]|0,f);i=d;return}function LJe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;c[f>>2]=0;zhh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888278]|0);_rh(g)}g=a+40|0;h=esh(1822656,c[g>>2]|0,b)|0;j=h|-2147483648;k=a+8|0;l=c[k>>2]|0;m=(h&2147483647|0)%(c[l+12>>2]|0)|0;h=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,m)|0)>>2]|0;if(!h){n=0;i=d;return n|0}l=a+12|0;o=a+16|0;p=c[l>>2]|0;q=p;r=c[(c[p>>2]|0)+120>>2]|0;p=h+-1|0;h=-1;while(1){if((c[q+16+(da(r,p)|0)>>2]|0)==(j|0)){s=c[o>>2]|0;if(fsh(1822584,c[g>>2]|0,c[s+16+(da(c[(c[s>>2]|0)+120>>2]|0,p)|0)>>2]|0,b)|0){t=p;u=h;break}s=c[l>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0}else{v=q;w=r}s=c[v+16+((da(w,p)|0)+4)>>2]|0;if((s|0)==-1){n=0;x=14;break}else{y=p;q=v;r=w;p=s;h=y}}if((x|0)==14){i=d;return n|0}if((t|0)==-1){n=0;i=d;return n|0}x=a+32|0;c[x>>2]=(c[x>>2]|0)+-1;if((u|0)==-1){x=c[k>>2]|0;k=c[l>>2]|0;h=c[k>>2]|0;p=(c[k+16+((da(c[h+120>>2]|0,t)|0)+4)>>2]|0)+1|0;c[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,m)|0)>>2]=p;z=k;A=h}else{h=c[l>>2]|0;l=h+16|0;k=c[(c[h>>2]|0)+120>>2]|0;c[l+((da(k,u)|0)+4)>>2]=c[l+((da(k,t)|0)+4)>>2];z=h;A=c[h>>2]|0}h=a+28|0;k=z+16|0;c[k+((da(c[A+120>>2]|0,t)|0)+4)>>2]=c[h>>2];c[h>>2]=t;c[k+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=0;z=c[o>>2]|0;csh(2540560,e);c[z+16+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=c[e>>2];e=c[a+20>>2]|0;csh(2540224,f);c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,t)|0)>>2]=c[f>>2];f=a+48|0;c[f>>2]=(c[f>>2]|0)+1;n=1;i=d;return n|0}function MJe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;c[f>>2]=0;Ahh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888282]|0);_rh(g)}g=a+40|0;h=esh(1822656,c[g>>2]|0,b)|0;j=h|-2147483648;k=c[a+8>>2]|0;l=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,(h&2147483647|0)%(c[k+12>>2]|0)|0)|0)>>2]|0;a:do if(l){k=a+12|0;h=a+16|0;m=c[k>>2]|0;n=m;o=c[(c[m>>2]|0)+120>>2]|0;m=l+-1|0;while(1){if((c[n+16+(da(o,m)|0)>>2]|0)==(j|0)){p=c[h>>2]|0;if(fsh(1822584,c[g>>2]|0,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,m)|0)>>2]|0,b)|0){q=m;break}p=c[k>>2]|0;r=p;s=c[(c[p>>2]|0)+120>>2]|0}else{r=n;s=o}m=c[r+16+((da(s,m)|0)+4)>>2]|0;if((m|0)==-1)break a;else{n=r;o=s}}o=c[a+20>>2]|0;t=1;u=o+16+(da(c[(c[o>>2]|0)+120>>2]|0,q)|0)|0;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}while(0);csh(2540224,f);t=0;u=f;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}function NJe(a){a=a|0;var b=0,c=0;b=i;RI(1839088)|0;c=qL(1839088)|0;OJe(c,a);i=b;return c|0}function OJe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Fhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888332]|0);_rh(e)}else{c[a+8>>2]=b;i=d;return}}function PJe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function QJe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;i=i+16|0;f=b;c[f>>2]=e;RI(2540224)|0;e=pL(2540224,f)|0;f=a;c[f>>2]=0;c[f+4>>2]=0;LOf(a,d,e);i=b;return}function RJe(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function SJe(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function TJe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;Jhh();RI(1094176)|0;g=gsh(1094176,5)|0;Qqh(g,c[888370]|0);h=g+16|0;c[h>>2]=c[888370];j=c[b>>2]|0;if(!j){if(!(a[2540708]|0))$rh(2540560);k=c[c[635163]>>2]|0}else k=Fqh(2536904,j)|0;Qqh(g,k);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=k;Qqh(g,c[888372]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[888372];k=b+4|0;c[f>>2]=c[k>>2];RI(2540224)|0;if(!(pL(2540224,f)|0)){if(!(a[2540708]|0))$rh(2540560);l=c[c[635163]>>2]|0}else{c[e>>2]=c[k>>2];RI(2540224)|0;l=Fqh(2536904,pL(2540224,e)|0)|0}Qqh(g,l);c[h+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=l;Qqh(g,c[888374]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<2)>>2]=c[888374];if(a[2540708]|0){m=lwf(0,g)|0;i=d;return m|0}$rh(2540560);m=lwf(0,g)|0;i=d;return m|0}function UJe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function VJe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;WJe(c,a);RI(1844464)|0;a=pL(1844464,c)|0;i=b;return a|0}function WJe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);_rh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_rh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;XUg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function XJe(a){a=a|0;c[a+4>>2]=-2;return}function YJe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ZJe(a,b){a=a|0;b=b|0;Ghh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888342]|0);_rh(b)}function _Je(a){a=a|0;Hhh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[888362]|0);_rh(a)}function $Je(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=JJe(c[a+8>>2]|0,b)|0;i=d;return e|0}function aKe(a,b){a=a|0;b=b|0;Ihh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888366]|0);_rh(b);return 0}function bKe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=0;c[a+4>>2]=0;RI(1846840)|0;a=pL(1846840,d)|0;i=b;return a|0}function cKe(a,b){a=a|0;b=b|0;var d=0;d=c[b+8>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=c[d+48>>2]|0;c[a>>2]=d;c[a+4>>2]=0;c[a+8>>2]=b;b=a+12|0;c[b>>2]=0;c[b+4>>2]=0;return}function dKe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(1101728)|0;f=vL(b,1101728)|0;if(!f){g=a+8|0;sJe(c[g>>2]|0,b,d);h=c[g>>2]|0;RI(1847064)|0;g=qL(1847064)|0;c[g+8>>2]=c[460357];c[g+20>>2]=1841424;c[g+16>>2]=0;eVg(h,b,d,g);i=e;return}else{hsh(1847008,a,f,d);i=e;return}}function eKe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function fKe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=0;c[a+4>>2]=0;RI(1846840)|0;a=pL(1846840,d)|0;i=b;return a|0}function gKe(a){a=a|0;return 1}function hKe(a){a=a|0;var b=0,d=0;b=i;d=Sqh(2647408,c[a+8>>2]|0)|0;i=b;return d|0}function iKe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+8|0;sJe(c[f>>2]|0,b,d);a=c[f>>2]|0;RI(1847064)|0;f=qL(1847064)|0;c[f+8>>2]=c[460357];c[f+20>>2]=1841424;c[f+16>>2]=0;gVg(a,b,d,f);i=e;return}function jKe(a,b){a=a|0;b=b|0;var d=0;d=c[b+48>>2]|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=d;d=a+12|0;c[d>>2]=0;c[d+4>>2]=0;return}function kKe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(1839032,c[a+8>>2]|0)|0;i=b;return d|0}function lKe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;sKe(a);c[d>>2]=c[a+16>>2];RI(2540224)|0;a=pL(2540224,d)|0;i=b;return a|0}function mKe(a){a=a|0;var b=0;b=i;sKe(a);i=b;return c[a+16>>2]|0}function nKe(a){a=a|0;c[a>>2]=0;return}function oKe(a){a=a|0;c[a>>2]=0;return}function pKe(a){a=a|0;var b=0,c=0;b=i;c=qKe(a)|0;i=b;return c|0}function qKe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;xKe(a);d=a+4|0;e=c[d>>2]|0;if((e|0)<=-1){f=0;i=b;return f|0}g=c[a>>2]|0;h=c[g+24>>2]|0;j=e;while(1){if((j|0)>=(h|0)){k=6;break}e=j+1|0;c[d>>2]=e;l=c[g+12>>2]|0;if((c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){m=j;k=3;break}else j=e}if((k|0)==3){j=c[g+16>>2]|0;h=c[g+20>>2]|0;g=c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,m)|0)>>2]|0;j=c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,m)|0)>>2]|0;m=a+12|0;c[m>>2]=g;c[m+4>>2]=j;f=1;i=b;return f|0}else if((k|0)==6){c[d>>2]=-1;f=0;i=b;return f|0}return 0}function rKe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;sKe(a);e=a+12|0;a=c[e+4>>2]|0;f=d;c[f>>2]=c[e>>2];c[f+4>>2]=a;RI(1844464)|0;a=pL(1844464,d)|0;i=b;return a|0}function sKe(a){a=a|0;var b=0;b=i;Ehh();xKe(a);if((c[a+4>>2]|0)>0){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888318]|0);_rh(b)}}function tKe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;sKe(b);f=c[b+12>>2]|0;c[e>>2]=c[b+16>>2];RI(2540224)|0;b=pL(2540224,e)|0;e=a;c[e>>2]=0;c[e+4>>2]=0;LOf(a,f,b);i=d;return}function uKe(a){a=a|0;var b=0;b=i;sKe(a);i=b;return c[a+12>>2]|0}function vKe(a){a=a|0;var b=0;b=i;sKe(a);i=b;return c[a+12>>2]|0}function wKe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;sKe(a);c[d>>2]=c[a+16>>2];RI(2540224)|0;a=pL(2540224,d)|0;i=b;return a|0}function xKe(a){a=a|0;var b=0,d=0,e=0;b=i;Dhh();d=c[a>>2]|0;if(!d){RI(3112928)|0;e=qL(3112928)|0;kwg(e,0);_rh(e)}if((c[d+48>>2]|0)==(c[a+8>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888308]|0);_rh(b)}}function yKe(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function zKe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)zKe(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function AKe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function BKe(a,b){a=a|0;b=b|0;return 0}function CKe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)CKe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function DKe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function EKe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function FKe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)FKe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function GKe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function HKe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function IKe(a){a=a|0;var b=0,c=0;b=i;c=qKe(a+8|0)|0;i=b;return c|0}function JKe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;f=b+8|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];RI(1838696)|0;xrh(a,2734240,pL(1838696,e)|0);i=d;return}function KKe(a){a=a|0;return c[a+20>>2]|0}function LKe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=c[a+24>>2];RI(2540224)|0;a=pL(2540224,d)|0;i=b;return a|0}function MKe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;yrh(c,1851352,a);RI(2729368)|0;a=pL(2729368,c)|0;i=b;return a|0}function NKe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function OKe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=PKe(a)|0;RI(2395232)|0;a=pL(2395232,d)|0;i=b;return a|0}function PKe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_rh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_rh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=lVg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function QKe(a){a=a|0;c[a+4>>2]=-2;return}function RKe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function SKe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function TKe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=UKe(a)|0;RI(2379888)|0;a=pL(2379888,d)|0;i=b;return a|0}function UKe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_rh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_rh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=uVg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function VKe(a){a=a|0;c[a+4>>2]=-2;return}function WKe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function XKe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function YKe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=ZKe(a)|0;RI(2395064)|0;a=pL(2395064,d)|0;i=b;return a|0}function ZKe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_rh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_rh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=DVg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function _Ke(a){a=a|0;c[a+4>>2]=-2;return}function $Ke(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function aLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function bLe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=cLe(a)|0;RI(2604248)|0;a=pL(2604248,d)|0;i=b;return a|0}function cLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_rh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_rh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=MVg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function dLe(a){a=a|0;c[a+4>>2]=-2;return}function eLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function fLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function gLe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=hLe(a)|0;RI(2455736)|0;a=pL(2455736,d)|0;i=b;return a|0}function hLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ish(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);ish(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=VVg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function iLe(a){a=a|0;c[a+4>>2]=-2;return}function jLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function kLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function lLe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;g[c>>2]=ea(mLe(a));RI(2586184)|0;a=pL(2586184,c)|0;i=b;return a|0}function mLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=Im;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ish(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);ish(e)}else{e=c[a>>2]|0;a=PCf(e)|0;g=ea(cWg(e,a+-1-(c[d>>2]|0)|0));i=b;return ea(g)}return ea(0.0)}function nLe(a){a=a|0;c[a+4>>2]=-2;return}function oLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function pLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function qLe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=rLe(a)|0;RI(2466336)|0;a=pL(2466336,d)|0;i=b;return a|0}function rLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ish(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ish(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=lWg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function sLe(a){a=a|0;c[a+4>>2]=-2;return}function tLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function uLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function vLe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+16|0;e=b;wLe(d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];RI(2469616)|0;d=pL(2469616,e)|0;i=b;return d|0}function wLe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);ish(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ish(f)}else{f=c[b>>2]|0;b=PCf(f)|0;uWg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function xLe(a){a=a|0;c[a+4>>2]=-2;return}function yLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function zLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function ALe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=BLe(a)|0;RI(2492064)|0;a=pL(2492064,d)|0;i=b;return a|0}function BLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ish(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ish(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=DWg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function CLe(a){a=a|0;c[a+4>>2]=-2;return}function DLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ELe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function FLe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=GLe(a)|0;RI(2492856)|0;a=pL(2492856,d)|0;i=b;return a|0}function GLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ish(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ish(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=MWg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function HLe(a){a=a|0;c[a+4>>2]=-2;return}function ILe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function JLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function KLe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=LLe(a)|0;RI(2493312)|0;a=pL(2493312,d)|0;i=b;return a|0}function LLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ish(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ish(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=VWg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function MLe(a){a=a|0;c[a+4>>2]=-2;return}function NLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function OLe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)OLe(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function PLe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function QLe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+128|0;d=b+60|0;e=b;RLe(d,a);a=e+0|0;f=d+0|0;d=a+60|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(d|0));RI(2504408)|0;f=pL(2504408,e)|0;i=b;return f|0}function RLe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);ish(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ish(f)}else{f=c[b>>2]|0;b=PCf(f)|0;cXg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function SLe(a){a=a|0;c[a+4>>2]=-2;return}function TLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ULe(b){b=b|0;var d=0;d=i;RI(1932952)|0;if(!(a[1933100]|0)){RI(1932952)|0;jsh(1932952)}RI(1932952)|0;c[b+8>>2]=c[c[483261]>>2];i=d;return}function VLe(a,b){a=a|0;b=b|0;var d=0;d=i;Nhh();if((b|0)>-1){RI(1127304)|0;c[a+8>>2]=ksh(1127304,b)|0;i=d;return}else{RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888390]|0);ish(d)}}function WLe(a){a=a|0;var b=0;a=i;RI(1127304)|0;b=ksh(1127304,0)|0;RI(1932952)|0;c[c[483261]>>2]=b;i=a;return}function XLe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+144|0;d=b;e=b+64|0;f=d+0|0;g=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));h=c[a+16>>2]|0;c[e>>2]=a;c[e+4>>2]=0;c[e+8>>2]=h;f=e+12|0;h=d+0|0;g=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(g|0));RI(1933120)|0;h=pL(1933120,e)|0;i=b;return h|0}function YLe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+0|0;f=e+72|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[a>>2]=b;c[a+8>>2]=c[b+16>>2];i=d;return}function ZLe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function _Le(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+144|0;d=b;e=b+64|0;f=d+0|0;g=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));h=c[a+16>>2]|0;c[e>>2]=a;c[e+4>>2]=0;c[e+8>>2]=h;f=e+12|0;h=d+0|0;g=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(g|0));RI(1933120)|0;h=pL(1933120,e)|0;i=b;return h|0}function $Le(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+144|0;e=d+72|0;f=d+64|0;g=d;Ohh();RI(2504408)|0;aFi(g|0,lsh(b,2504408)|0,60)|0;iM(f,1933288,a);b=c[(c[f+4>>2]|0)+4>>2]|0;h=c[f>>2]|0;f=e+0|0;j=g+0|0;g=f+60|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(g|0));In[b&4095](h,e);i=d;return (c[a+12>>2]|0)+-1|0}function aMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+144|0;e=d+72|0;f=d+64|0;g=d;RI(2504408)|0;aFi(g|0,lsh(b,2504408)|0,60)|0;iM(f,1933344,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;f=e+0|0;h=g+0|0;g=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(g|0));h=_n[a&4095](b,e)|0;i=d;return h|0}function bMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+144|0;e=d+72|0;f=d+64|0;g=d;RI(2504408)|0;aFi(g|0,lsh(b,2504408)|0,60)|0;iM(f,1933400,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;f=e+0|0;h=g+0|0;g=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(g|0));h=_n[a&4095](b,e)|0;i=d;return h|0}function cMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+144|0;f=e+72|0;g=e+64|0;h=e;Phh();dMe(a,b);RI(2504408)|0;aFi(h|0,lsh(d,2504408)|0,60)|0;iM(g,1933456,a);a=c[(c[g+4>>2]|0)+4>>2]|0;d=c[g>>2]|0;g=f+0|0;j=h+0|0;h=g+60|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(h|0));co[a&2047](d,b,f);i=e;return}function dMe(a,b){a=a|0;b=b|0;var d=0;d=i;Qhh();if((b|0)>=0?(c[a+12>>2]|0)>=(b|0):0){i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888404]|0);ish(d)}function eMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+144|0;e=d+72|0;f=d+64|0;g=d;RI(2504408)|0;aFi(g|0,lsh(b,2504408)|0,60)|0;iM(f,1933512,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;f=e+0|0;h=g+0|0;g=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(g|0));_n[a&4095](b,e)|0;i=d;return}function fMe(a){a=a|0;return 0}function gMe(a){a=a|0;return a|0}function hMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+128|0;e=d+60|0;f=d;msh(e,1933568,a,b);b=f+0|0;a=e+0|0;e=b+60|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(e|0));RI(2504408)|0;a=pL(2504408,f)|0;i=d;return a|0}function iMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+144|0;f=e+72|0;g=e+64|0;h=e;Khh();RI(2504408)|0;aFi(h|0,lsh(d,2504408)|0,60)|0;iM(g,1933624,a);a=c[(c[g+4>>2]|0)+4>>2]|0;d=c[g>>2]|0;g=f+0|0;j=h+0|0;h=g+60|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(h|0));co[a&2047](d,b,f);i=e;return}function jMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;if((f|0)==(c[h+12>>2]|0)){kMe(a,1);j=c[g>>2]|0;k=c[e>>2]|0}else{j=h;k=f}c[e>>2]=k+1;e=j+16+(da(c[(c[j>>2]|0)+120>>2]|0,k)|0)+0|0;k=b+0|0;b=e+60|0;do{c[e>>2]=c[k>>2];e=e+4|0;k=k+4|0}while((e|0)<(b|0));k=a+16|0;c[k>>2]=(c[k>>2]|0)+1;i=d;return}function kMe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(c[a+12>>2]|0)+b|0;b=c[(c[a+8>>2]|0)+12>>2]|0;if((e|0)<=(b|0)){i=d;return}mMe(a,Asg(0,Asg(0,b<<1,4)|0,e)|0);i=d;return}function lMe(a){a=a|0;return c[(c[a+8>>2]|0)+12>>2]|0}function mMe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a+12>>2]|0)>(b|0)){RI(2964880)|0;e=qL(2964880)|0;_eg(e);ish(e)}else{lXg(0,a+8|0,b);i=d;return}}function nMe(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+12>>2]=0;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function oMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+64|0;e=d;f=c[a+8>>2]|0;g=c[a+12>>2]|0;a=e+0|0;h=b+0|0;b=a+60|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(b|0));h=(nXg(0,f,e,0,g)|0)!=-1;i=d;return h|0}function pMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function qMe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function rMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+64|0;e=d;f=c[a+8>>2]|0;g=c[a+12>>2]|0;a=e+0|0;h=b+0|0;b=a+60|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(b|0));h=nXg(0,f,e,0,g)|0;i=d;return h|0}function sMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)>-1;g=b-(f?0:d)|0;b=a+12|0;h=c[b>>2]|0;if((h|0)>(g|0)){j=c[a+8>>2]|0;wEf(0,j,g,j,g+d|0,h-g|0);k=c[b>>2]|0}else k=h;h=k+d|0;c[b>>2]=h;if(f){i=e;return}yDf(0,c[a+8>>2]|0,h,0-d|0);i=e;return}function tMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;dMe(a,b);f=a+8|0;if((c[a+12>>2]|0)==(c[(c[f>>2]|0)+12>>2]|0))kMe(a,1);sMe(a,b,1);g=c[f>>2]|0;f=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)+0|0;b=d+0|0;d=f+60|0;do{c[f>>2]=c[b>>2];f=f+4|0;b=b+4|0}while((f|0)<(d|0));b=a+16|0;c[b>>2]=(c[b>>2]|0)+1;i=e;return}function uMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+80|0;e=d+8|0;f=d;iM(f,1933400,a);g=c[(c[f+4>>2]|0)+4>>2]|0;h=c[f>>2]|0;f=e+0|0;j=b+0|0;b=f+60|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(b|0));j=_n[g&4095](h,e)|0;e=(j|0)==-1;if(e){k=e^1;i=d;return k|0}Lrh(1933680,a,j);k=e^1;i=d;return k|0}function vMe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Rhh();if((b|0)>=0?(e=a+12|0,(c[e>>2]|0)>(b|0)):0){sMe(a,b,-1);yDf(0,c[a+8>>2]|0,c[e>>2]|0,1);e=a+16|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888408]|0);ish(d)}function wMe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;RI(1127304)|0;f=ksh(1127304,e)|0;vEf(0,c[a+8>>2]|0,f,c[d>>2]|0);i=b;return f|0}function xMe(a){a=a|0;return c[a+12>>2]|0}function yMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Lhh();if((c[b+12>>2]|0)>(d|0)){f=c[b+8>>2]|0;b=a+0|0;a=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)+0|0;d=b+60|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(d|0));i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[888382]|0);ish(e)}}function zMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Mhh();dMe(a,b);if((c[a+12>>2]|0)==(b|0)){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888386]|0);ish(f)}else{f=c[a+8>>2]|0;a=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b)|0)+0|0;b=d+0|0;d=a+60|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(d|0));i=e;return}}function AMe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+64|0;d=b;BMe(a);if((c[a+4>>2]|0)>0){e=d+0|0;f=a+12|0;a=e+60|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0));RI(2504408)|0;f=pL(2504408,d)|0;i=b;return f|0}else{RI(3084976)|0;f=qL(3084976)|0;nsg(f);ish(f)}return 0}function BMe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+80|0;d=b;Shh();e=c[a>>2]|0;if(!e){f=d+0|0;g=a+0|0;h=f+72|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));RI(1933120)|0;g=Fqh(2537592,Xnf(pL(1933120,d)|0)|0)|0;RI(3112928)|0;d=qL(3112928)|0;kwg(d,g);ish(d)}if((c[a+8>>2]|0)==(c[e+16>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888412]|0);ish(b)}}function CMe(a){a=a|0;c[a>>2]=0;return}function DMe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;BMe(a);d=a+4|0;e=c[d>>2]|0;if((e|0)<=-1){f=0;i=b;return f|0}g=c[a>>2]|0;if((e|0)<(c[g+12>>2]|0)){h=c[g+8>>2]|0;c[d>>2]=e+1;g=a+12|0;a=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,e)|0)+0|0;e=g+60|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(e|0));f=1;i=b;return f|0}else{c[d>>2]=-1;f=0;i=b;return f|0}return 0}function EMe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+0|0;a=b+12|0;b=e+60|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(b|0));i=d;return}function FMe(a){a=a|0;return}function GMe(a){a=a|0;var b=0;a=i;RI(1936840)|0;b=qL(1936840)|0;RI(1937008)|0;c[c[484275]>>2]=b;i=a;return}function HMe(a){a=a|0;return}function IMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+144|0;e=d+72|0;f=d+64|0;g=d;RI(2504408)|0;aFi(g|0,lsh(b,2504408)|0,60)|0;iM(f,1937176,a);a=c[(c[f+4>>2]|0)+4>>2]|0;b=c[f>>2]|0;f=e+0|0;h=g+0|0;g=f+60|0;do{c[f>>2]=c[h>>2];f=f+4|0;h=h+4|0}while((f|0)<(g|0));h=_n[a&4095](b,e)|0;i=d;return h|0}function JMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+256|0;f=e+188|0;g=e+128|0;h=e+120|0;j=e;k=e+60|0;RI(2504408)|0;l=k+0|0;m=(lsh(b,2504408)|0)+0|0;b=l+60|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));RI(2504408)|0;aFi(j|0,lsh(d,2504408)|0,60)|0;iM(h,1937232,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;l=g+0|0;m=k+0|0;b=l+60|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));l=f+0|0;m=j+0|0;b=l+60|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));m=xo[a&2047](d,g,f)|0;i=e;return m|0}function KMe(b){b=b|0;b=i;RI(1937008)|0;if(!(a[1937156]|0)){RI(1937008)|0;jsh(1937008)}RI(1937008)|0;i=b;return c[c[484275]>>2]|0}function LMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+64|0;d=a;e=d+0|0;f=b+0|0;g=e+60|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));RI(2504408)|0;if(!(pL(2504408,d)|0)){h=0;i=a;return h|0}RI(2504408)|0;h=Aqh(2536720,pL(2504408,b)|0)|0;i=a;return h|0}function MMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+64|0;e=a;f=e+0|0;g=b+0|0;h=f+60|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));RI(2504408)|0;if(!(pL(2504408,e)|0)){f=e+0|0;g=d+0|0;h=f+60|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));RI(2504408)|0;j=(pL(2504408,e)|0)==0;i=a;return j|0}else{f=e+0|0;g=d+0|0;h=f+60|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));RI(2504408)|0;g=pL(2504408,e)|0;RI(2504408)|0;j=nrh(2536048,pL(2504408,b)|0,g)|0;i=a;return j|0}return 0}function NMe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function OMe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+12|0;e=b;PMe(d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];RI(2497248)|0;d=pL(2497248,e)|0;i=b;return d|0}function PMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);ish(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ish(f)}else{f=c[b>>2]|0;b=PCf(f)|0;oXg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function QMe(a){a=a|0;c[a+4>>2]=-2;return}function RMe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function SMe(b){b=b|0;var d=0;d=i;RI(1941480)|0;if(!(a[1941628]|0)){RI(1941480)|0;jsh(1941480)}RI(1941480)|0;c[b+8>>2]=c[c[485393]>>2];i=d;return}function TMe(a,b){a=a|0;b=b|0;var d=0;d=i;Nhh();if((b|0)>-1){RI(1127792)|0;c[a+8>>2]=ksh(1127792,b)|0;i=d;return}else{RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888390]|0);ish(d)}}function UMe(a){a=a|0;var b=0;a=i;RI(1127792)|0;b=ksh(1127792,0)|0;RI(1941480)|0;c[c[485393]>>2]=b;i=a;return}function VMe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+48|0;d=b;e=b+16|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;f=c[a+16>>2]|0;c[e>>2]=a;c[e+4>>2]=0;c[e+8>>2]=f;f=e+12|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];RI(1941648)|0;d=pL(1941648,e)|0;i=b;return d|0}function WMe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function XMe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function YMe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+48|0;d=b;e=b+16|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;f=c[a+16>>2]|0;c[e>>2]=a;c[e+4>>2]=0;c[e+8>>2]=f;f=e+12|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];RI(1941648)|0;d=pL(1941648,e)|0;i=b;return d|0}function ZMe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;Ohh();RI(2497248)|0;f=lsh(b,2497248)|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];nsh(1941816,a,e);i=d;return (c[a+12>>2]|0)+-1|0}function _Me(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;RI(2497248)|0;f=lsh(b,2497248)|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];f=osh(1941872,a,e)|0;i=d;return f|0}function $Me(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;RI(2497248)|0;f=lsh(b,2497248)|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];f=psh(1941928,a,e)|0;i=d;return f|0}function aNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;Phh();bNe(a,b);RI(2497248)|0;g=lsh(d,2497248)|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];qsh(1941984,a,b,f);i=e;return}function bNe(a,b){a=a|0;b=b|0;var d=0;d=i;Qhh();if((b|0)>=0?(c[a+12>>2]|0)>=(b|0):0){i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888404]|0);ish(d)}function cNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;RI(2497248)|0;f=lsh(b,2497248)|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];osh(1942040,a,e)|0;i=d;return}function dNe(a){a=a|0;return 0}function eNe(a){a=a|0;return a|0}function fNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+12|0;f=d;rsh(e,1942096,a,b);c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];RI(2497248)|0;e=pL(2497248,f)|0;i=d;return e|0}function gNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;Khh();RI(2497248)|0;g=lsh(d,2497248)|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];qsh(1942152,a,b,f);i=e;return}function hNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;if((f|0)==(c[h+12>>2]|0)){iNe(a,1);j=c[g>>2]|0;k=c[e>>2]|0}else{j=h;k=f}c[e>>2]=k+1;e=j+16+(da(c[(c[j>>2]|0)+120>>2]|0,k)|0)|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];b=a+16|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function iNe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(c[a+12>>2]|0)+b|0;b=c[(c[a+8>>2]|0)+12>>2]|0;if((e|0)<=(b|0)){i=d;return}kNe(a,Asg(0,Asg(0,b<<1,4)|0,e)|0);i=d;return}function jNe(a){a=a|0;return c[(c[a+8>>2]|0)+12>>2]|0}function kNe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a+12>>2]|0)>(b|0)){RI(2964880)|0;e=qL(2964880)|0;_eg(e);ish(e)}else{xXg(0,a+8|0,b);i=d;return}}function lNe(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+12>>2]=0;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function mNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a+8>>2]|0;g=c[a+12>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];b=(zXg(0,f,e,0,g)|0)!=-1;i=d;return b|0}function nNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function oNe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function pNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a+8>>2]|0;g=c[a+12>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];b=zXg(0,f,e,0,g)|0;i=d;return b|0}function qNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)>-1;g=b-(f?0:d)|0;b=a+12|0;h=c[b>>2]|0;if((h|0)>(g|0)){j=c[a+8>>2]|0;wEf(0,j,g,j,g+d|0,h-g|0);k=c[b>>2]|0}else k=h;h=k+d|0;c[b>>2]=h;if(f){i=e;return}yDf(0,c[a+8>>2]|0,h,0-d|0);i=e;return}function rNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;bNe(a,b);f=a+8|0;if((c[a+12>>2]|0)==(c[(c[f>>2]|0)+12>>2]|0))iNe(a,1);qNe(a,b,1);g=c[f>>2]|0;f=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function sNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];b=psh(1941928,a,e)|0;e=(b|0)==-1;if(e){f=e^1;i=d;return f|0}Lrh(1942208,a,b);f=e^1;i=d;return f|0}function tNe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Rhh();if((b|0)>=0?(e=a+12|0,(c[e>>2]|0)>(b|0)):0){qNe(a,b,-1);yDf(0,c[a+8>>2]|0,c[e>>2]|0,1);e=a+16|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888408]|0);ish(d)}function uNe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;RI(1127792)|0;f=ksh(1127792,e)|0;vEf(0,c[a+8>>2]|0,f,c[d>>2]|0);i=b;return f|0}function vNe(a){a=a|0;return c[a+12>>2]|0}function wNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Lhh();if((c[b+12>>2]|0)>(d|0)){f=c[b+8>>2]|0;b=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[888382]|0);ish(e)}}function xNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Mhh();bNe(a,b);if((c[a+12>>2]|0)==(b|0)){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888386]|0);ish(f)}else{f=c[a+8>>2]|0;a=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b)|0)|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];i=e;return}}function yNe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;zNe(a);if((c[a+4>>2]|0)>0){e=a+12|0;c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];RI(2497248)|0;e=pL(2497248,d)|0;i=b;return e|0}else{RI(3084976)|0;e=qL(3084976)|0;nsg(e);ish(e)}return 0}function zNe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b;Shh();e=c[a>>2]|0;if(!e){c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];c[d+16>>2]=c[a+16>>2];c[d+20>>2]=c[a+20>>2];RI(1941648)|0;f=Fqh(2537592,Xnf(pL(1941648,d)|0)|0)|0;RI(3112928)|0;d=qL(3112928)|0;kwg(d,f);ish(d)}if((c[a+8>>2]|0)==(c[e+16>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888412]|0);ish(b)}}function ANe(a){a=a|0;c[a>>2]=0;return}function BNe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;zNe(a);d=a+4|0;e=c[d>>2]|0;if((e|0)<=-1){f=0;i=b;return f|0}g=c[a>>2]|0;if((e|0)<(c[g+12>>2]|0)){h=c[g+8>>2]|0;c[d>>2]=e+1;g=a+12|0;a=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,e)|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];f=1;i=b;return f|0}else{c[d>>2]=-1;f=0;i=b;return f|0}return 0}function CNe(a,b){a=a|0;b=b|0;var d=0;d=b+12|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];return}function DNe(a){a=a|0;return}function ENe(a){a=a|0;var b=0;a=i;RI(1945368)|0;b=qL(1945368)|0;RI(1945536)|0;c[c[486407]>>2]=b;i=a;return}function FNe(a){a=a|0;return}function GNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;RI(2497248)|0;f=lsh(b,2497248)|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];f=psh(1945704,a,e)|0;i=d;return f|0}function HNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+64|0;f=e+44|0;g=e+32|0;h=e+24|0;j=e;k=e+12|0;RI(2497248)|0;l=lsh(b,2497248)|0;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];RI(2497248)|0;aFi(j|0,lsh(d,2497248)|0,12)|0;iM(h,1945760,a);a=c[(c[h+4>>2]|0)+4>>2]|0;d=c[h>>2]|0;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=xo[a&2047](d,g,f)|0;i=e;return j|0}function INe(b){b=b|0;b=i;RI(1945536)|0;if(!(a[1945684]|0)){RI(1945536)|0;jsh(1945536)}RI(1945536)|0;i=b;return c[c[486407]>>2]|0}function JNe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];RI(2497248)|0;if(!(pL(2497248,d)|0)){e=0;i=a;return e|0}RI(2497248)|0;e=Aqh(2536720,pL(2497248,b)|0)|0;i=a;return e|0}function KNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+48|0;e=a+24|0;f=a+12|0;g=a;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];RI(2497248)|0;if(!(pL(2497248,e)|0)){c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];RI(2497248)|0;h=(pL(2497248,f)|0)==0;i=a;return h|0}else{c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];RI(2497248)|0;d=pL(2497248,g)|0;RI(2497248)|0;h=nrh(2536048,pL(2497248,b)|0,d)|0;i=a;return h|0}return 0}function LNe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function MNe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;NNe(c,a);RI(2497560)|0;a=pL(2497560,c)|0;i=b;return a|0}function NNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);ssh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ssh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;AXg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function ONe(a){a=a|0;c[a+4>>2]=-2;return}function PNe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function QNe(b){b=b|0;var d=0;d=i;RI(1952456)|0;if(!(a[1952604]|0)){RI(1952456)|0;tsh(1952456)}RI(1952456)|0;c[b+8>>2]=c[c[488137]>>2];i=d;return}function RNe(a,b){a=a|0;b=b|0;var d=0;d=i;Nhh();if((b|0)>-1){RI(1128280)|0;c[a+8>>2]=ush(1128280,b)|0;i=d;return}else{RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888390]|0);ssh(d)}}function SNe(a){a=a|0;var b=0;a=i;RI(1128280)|0;b=ush(1128280,0)|0;RI(1952456)|0;c[c[488137]>>2]=b;i=a;return}function TNe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+16>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(1952624)|0;e=pL(1952624,d)|0;i=b;return e|0}function UNe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function VNe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function WNe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+16>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(1952624)|0;e=pL(1952624,d)|0;i=b;return e|0}function XNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;Ohh();RI(2497560)|0;g=vsh(b,2497560)|0;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];wsh(1952792,a,e);i=d;return (c[a+12>>2]|0)+-1|0}function YNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;RI(2497560)|0;g=vsh(b,2497560)|0;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=xsh(1952848,a,e)|0;i=d;return f|0}function ZNe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;RI(2497560)|0;g=vsh(b,2497560)|0;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=ysh(1952904,a,e)|0;i=d;return f|0}function _Ne(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;Phh();$Ne(a,b);RI(2497560)|0;h=vsh(d,2497560)|0;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];zsh(1952960,a,b,f);i=e;return}function $Ne(a,b){a=a|0;b=b|0;var d=0;d=i;Qhh();if((b|0)>=0?(c[a+12>>2]|0)>=(b|0):0){i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888404]|0);ssh(d)}function aOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;RI(2497560)|0;g=vsh(b,2497560)|0;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];xsh(1953016,a,e)|0;i=d;return}function bOe(a){a=a|0;return 0}function cOe(a){a=a|0;return a|0}function dOe(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;Ash(d,1953072,a,b);RI(2497560)|0;b=pL(2497560,d)|0;i=c;return b|0}function eOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;Khh();RI(2497560)|0;h=vsh(d,2497560)|0;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];zsh(1953128,a,b,f);i=e;return}function fOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;if((f|0)==(c[h+12>>2]|0)){gOe(a,1);j=c[g>>2]|0;k=c[e>>2]|0}else{j=h;k=f}c[e>>2]=k+1;e=j+16+(da(c[(c[j>>2]|0)+120>>2]|0,k)|0)|0;k=b;b=c[k+4>>2]|0;j=e;c[j>>2]=c[k>>2];c[j+4>>2]=b;b=a+16|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return}function gOe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(c[a+12>>2]|0)+b|0;b=c[(c[a+8>>2]|0)+12>>2]|0;if((e|0)<=(b|0)){i=d;return}iOe(a,Asg(0,Asg(0,b<<1,4)|0,e)|0);i=d;return}function hOe(a){a=a|0;return c[(c[a+8>>2]|0)+12>>2]|0}function iOe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((c[a+12>>2]|0)>(b|0)){RI(2964880)|0;e=qL(2964880)|0;_eg(e);ssh(e)}else{JXg(0,a+8|0,b);i=d;return}}function jOe(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+12>>2]=0;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function kOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+8>>2]|0;h=c[a+12>>2]|0;a=b;b=c[a+4>>2]|0;j=f;c[j>>2]=c[a>>2];c[j+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=(LXg(0,g,e,0,h)|0)!=-1;i=d;return f|0}function lOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wEf(0,c[a+8>>2]|0,0,b,d,c[a+12>>2]|0);i=e;return}function mOe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function nOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=c[a+8>>2]|0;h=c[a+12>>2]|0;a=b;b=c[a+4>>2]|0;j=f;c[j>>2]=c[a>>2];c[j+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=LXg(0,g,e,0,h)|0;i=d;return f|0}function oOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)>-1;g=b-(f?0:d)|0;b=a+12|0;h=c[b>>2]|0;if((h|0)>(g|0)){j=c[a+8>>2]|0;wEf(0,j,g,j,g+d|0,h-g|0);k=c[b>>2]|0}else k=h;h=k+d|0;c[b>>2]=h;if(f){i=e;return}yDf(0,c[a+8>>2]|0,h,0-d|0);i=e;return}function pOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;$Ne(a,b);f=a+8|0;if((c[a+12>>2]|0)==(c[(c[f>>2]|0)+12>>2]|0))gOe(a,1);oOe(a,b,1);g=c[f>>2]|0;f=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)|0;b=d;d=c[b+4>>2]|0;g=f;c[g>>2]=c[b>>2];c[g+4>>2]=d;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function qOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=ysh(1952904,a,e)|0;e=(f|0)==-1;if(e){j=e^1;i=d;return j|0}Lrh(1953184,a,f);j=e^1;i=d;return j|0}function rOe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Rhh();if((b|0)>=0?(e=a+12|0,(c[e>>2]|0)>(b|0)):0){oOe(a,b,-1);yDf(0,c[a+8>>2]|0,c[e>>2]|0,1);e=a+16|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888408]|0);ssh(d)}function sOe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;RI(1128280)|0;f=ush(1128280,e)|0;vEf(0,c[a+8>>2]|0,f,c[d>>2]|0);i=b;return f|0}function tOe(a){a=a|0;return c[a+12>>2]|0}function uOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Lhh();if((c[b+12>>2]|0)>(d|0)){f=c[b+8>>2]|0;b=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)|0;d=c[b+4>>2]|0;f=a;c[f>>2]=c[b>>2];c[f+4>>2]=d;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[888382]|0);ssh(e)}}function vOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Mhh();$Ne(a,b);if((c[a+12>>2]|0)==(b|0)){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888386]|0);ssh(f)}else{f=c[a+8>>2]|0;a=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b)|0)|0;b=d;d=c[b+4>>2]|0;f=a;c[f>>2]=c[b>>2];c[f+4>>2]=d;i=e;return}}function wOe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;xOe(a);if((c[a+4>>2]|0)>0){e=a+12|0;a=c[e+4>>2]|0;f=d;c[f>>2]=c[e>>2];c[f+4>>2]=a;RI(2497560)|0;a=pL(2497560,d)|0;i=b;return a|0}else{RI(3084976)|0;a=qL(3084976)|0;nsg(a);ssh(a)}return 0}function xOe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b;Shh();e=c[a>>2]|0;if(!e){c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];c[d+16>>2]=c[a+16>>2];RI(1952624)|0;f=Fqh(2537592,Xnf(pL(1952624,d)|0)|0)|0;RI(3112928)|0;d=qL(3112928)|0;kwg(d,f);ssh(d)}if((c[a+8>>2]|0)==(c[e+16>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888412]|0);ssh(b)}}function yOe(a){a=a|0;c[a>>2]=0;return}function zOe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;xOe(a);d=a+4|0;e=c[d>>2]|0;if((e|0)<=-1){f=0;i=b;return f|0}g=c[a>>2]|0;if((e|0)<(c[g+12>>2]|0)){h=c[g+8>>2]|0;c[d>>2]=e+1;g=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,e)|0)|0;e=c[g+4>>2]|0;h=a+12|0;c[h>>2]=c[g>>2];c[h+4>>2]=e;f=1;i=b;return f|0}else{c[d>>2]=-1;f=0;i=b;return f|0}return 0}function AOe(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function BOe(a){a=a|0;return}function COe(a){a=a|0;var b=0;a=i;RI(1956344)|0;b=qL(1956344)|0;RI(1956512)|0;c[c[489151]>>2]=b;i=a;return}function DOe(a){a=a|0;return}function EOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;RI(2497560)|0;g=vsh(b,2497560)|0;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=ysh(1956680,a,e)|0;i=d;return f|0}function FOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;RI(2497560)|0;k=vsh(b,2497560)|0;b=c[k+4>>2]|0;l=h;c[l>>2]=c[k>>2];c[l+4>>2]=b;RI(2497560)|0;b=vsh(d,2497560)|0;d=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Bsh(1956736,a,g,f)|0;i=e;return j|0}function GOe(b){b=b|0;b=i;RI(1956512)|0;if(!(a[1956660]|0)){RI(1956512)|0;tsh(1956512)}RI(1956512)|0;i=b;return c[c[489151]>>2]|0}function HOe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a;e=b;f=c[e+4>>2]|0;g=d;c[g>>2]=c[e>>2];c[g+4>>2]=f;RI(2497560)|0;if(!(pL(2497560,d)|0)){h=0;i=a;return h|0}RI(2497560)|0;h=Aqh(2536720,pL(2497560,b)|0)|0;i=a;return h|0}function IOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+32|0;e=a+16|0;f=a+8|0;g=a;h=b;j=c[h+4>>2]|0;k=e;c[k>>2]=c[h>>2];c[k+4>>2]=j;RI(2497560)|0;if(!(pL(2497560,e)|0)){e=d;j=c[e+4>>2]|0;k=f;c[k>>2]=c[e>>2];c[k+4>>2]=j;RI(2497560)|0;l=(pL(2497560,f)|0)==0;i=a;return l|0}else{f=d;d=c[f+4>>2]|0;j=g;c[j>>2]=c[f>>2];c[j+4>>2]=d;RI(2497560)|0;d=pL(2497560,g)|0;RI(2497560)|0;l=nrh(2536048,pL(2497560,b)|0,d)|0;i=a;return l|0}return 0}function JOe(a,b){a=a|0;b=b|0;var d=0;d=a;c[d>>2]=0;c[d+4>>2]=0;c[a>>2]=b;c[a+4>>2]=-2;c[a+8>>2]=c[b+16>>2];return}function KOe(a){a=a|0;return}function LOe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+8>>2]|0;if(!f){i=e;return}Csh(262e4,f,b,d);IEf(0,b,d,c[a+12>>2]|0);i=e;return}function MOe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+12|0;e=b;In[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0,e)|0;i=b;return d|0}function NOe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+12|0;e=b;In[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&4095](d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];d=pL(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0,e)|0;i=b;return d|0}function OOe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;c[e>>2]=0;f=b+12|0;g=c[f>>2]|0;if(!g){RI(3084976)|0;h=qL(3084976)|0;nsg(h);ssh(h)}h=b+16|0;c[h>>2]=(c[h>>2]|0)+1;h=c[b+8>>2]|0;b=g+-1|0;c[f>>2]=b;f=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)|0;b=c[f>>2]|0;if(!(a[2536457]|0)){c[e>>2]=0;j=0;c[f>>2]=j;i=d;return b|0}else{PEi(e|0,0,(c[634107]|0)+-8|0)|0;j=c[e>>2]|0;c[f>>2]=j;i=d;return b|0}return 0}function POe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+8|0;f=c[e>>2]|0;g=c[a+12>>2]|0;if((f|0)!=0?(g|0)!=(c[f+12>>2]|0):0){h=g;j=f}else{co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+8>>2]|0)+4>>2]&2047](0,e,(g|0)==0?16:g<<1);h=c[a+12>>2]|0;j=c[e>>2]|0}e=a+16|0;c[e>>2]=(c[e>>2]|0)+1;c[a+12>>2]=h+1;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>2]=b;i=d;return}function QOe(a,b){a=a|0;b=b|0;var d=0;d=a;c[d>>2]=0;c[d+4>>2]=0;c[a>>2]=b;c[a+4>>2]=-2;c[a+8>>2]=c[b+16>>2];return}function ROe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a>>2]|0;if((c[a+8>>2]|0)!=(c[d+16>>2]|0)){RI(3084976)|0;e=qL(3084976)|0;nsg(e);ssh(e)}e=a+4|0;a=c[e>>2]|0;if((a|0)==-2){f=c[d+12>>2]|0;c[e>>2]=f;g=f}else g=a;if((g|0)==-1){h=0;i=b;return h|0}c[e>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function SOe(a){a=a|0;var b=0,d=0;b=c[a+4>>2]|0;if((b|0)>-1){d=c[(c[a>>2]|0)+8>>2]|0;a=c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,b)|0)>>2]|0;return a|0}else{RI(3084976)|0;a=qL(3084976)|0;nsg(a);ssh(a)}return 0}function TOe(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;zGe(a,b);i=d;return}function UOe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function VOe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=WOe(a)|0;RI(2887096)|0;a=pL(2887096,d)|0;i=b;return a|0}function WOe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ssh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ssh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=MXg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function XOe(a){a=a|0;c[a+4>>2]=-2;return}function YOe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ZOe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function _Oe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=$Oe(a)|0;RI(2508800)|0;a=pL(2508800,d)|0;i=b;return a|0}function $Oe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ssh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ssh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=VXg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function aPe(a){a=a|0;c[a+4>>2]=-2;return}function bPe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function cPe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function dPe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=ePe(a)|0;RI(2509376)|0;a=pL(2509376,d)|0;i=b;return a|0}function ePe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ssh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);ssh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=cYg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function fPe(a){a=a|0;c[a+4>>2]=-2;return}function gPe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function hPe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function iPe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=jPe(a)|0;RI(2509864)|0;a=pL(2509864,d)|0;i=b;return a|0}function jPe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ssh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);ssh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=lYg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function kPe(a){a=a|0;c[a+4>>2]=-2;return}function lPe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function mPe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function nPe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;oPe(c,a);RI(2511024)|0;a=pL(2511024,c)|0;i=b;return a|0}function oPe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);ssh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);ssh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;uYg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function pPe(a){a=a|0;c[a+4>>2]=-2;return}function qPe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function rPe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function sPe(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=tPe(a)|0;RI(2540392)|0;a=pL(2540392,d)|0;i=c;return a|0}function tPe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);ssh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);ssh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=DYg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function uPe(a){a=a|0;c[a+4>>2]=-2;return}function vPe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function wPe(a){a=a|0;var b=0;b=i;xPe(a,10,0);i=b;return}function xPe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;uhh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[888110]|0);Dsh(g)}if(!e){RI(2023280)|0;if(!(a[2023428]|0)){RI(2023280)|0;Esh(2023280)}h=Fsh(0)|0}else h=e;c[b+40>>2]=h;h=~~ea(ea(d|0)/ea(.899999976))+1|0;ZPe(b,(d|0)==0?12:h);c[b+48>>2]=0;i=f;return}function yPe(a,b){a=a|0;b=b|0;var c=0;c=i;xPe(a,10,b);i=c;return}function zPe(a,b){a=a|0;b=b|0;var c=0;c=i;xPe(a,b,0);i=c;return}function APe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=BPe(0,b)|0;Gsh(2022048,a,e,CPe(0,c)|0);i=d;return}function BPe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+4|0;f=b;Bhh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888286]|0);Dsh(g)}RI(2394824)|0;if(!(vL(d,2394824)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Esh(2540728)}c[f>>2]=3433664;c[e+0>>2]=c[f+0>>2];f=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);Dsh(k)}Esh(2540560);h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);Dsh(k)}RI(2394824)|0;k=vL(d,2394824)|0;if(k){i=b;return k|0}_J(e,c[(c[d>>2]|0)+44>>2]|0,2394824);if(!(a[e>>0]&1)){m=e+1|0;n=MJ(m)|0;FJ(n)}else{m=c[e+8>>2]|0;n=MJ(m)|0;FJ(n)}return 0}function CPe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=0;Chh();if(!d){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Esh(2540728)}c[g>>2]=3436072;c[e+0>>2]=c[g+0>>2];if(!(Gqh(2650144,npf(0,e)|0)|0)){Hsh(2516584,f);j=f;k=c[j>>2]|0;i=b;return k|0}}RI(2516584)|0;if(vL(d,2516584)|0){RI(2516584)|0;j=Ish(d,2516584)|0;k=c[j>>2]|0;i=b;return k|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Esh(2540728)}c[h>>2]=3436072;c[e+0>>2]=c[h+0>>2];h=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){l=c[888302]|0;m=gwf(0,l,h)|0;RI(2965048)|0;n=qL(2965048)|0;o=c[888304]|0;Rag(n,m,o);Dsh(n)}Esh(2540560);l=c[888302]|0;m=gwf(0,l,h)|0;RI(2965048)|0;n=qL(2965048)|0;o=c[888304]|0;Rag(n,m,o);Dsh(n);return 0}function DPe(a){a=a|0;return a|0}function EPe(a){a=a|0;return 0}function FPe(a,b){a=a|0;b=b|0;var d=0;d=i;Gsh(2022104,a,c[b>>2]|0,c[b+4>>2]|0);i=d;return}function GPe(a){a=a|0;return c[a>>2]|0}function HPe(a){a=a|0;return c[a+4>>2]|0}function IPe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=JPe(a,e)|0;i=d;return f|0}function JPe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=0;if(!(Jsh(2023896,b,c[d>>2]|0,f)|0)){g=0;i=e;return g|0}RI(2023504)|0;if(!(a[2023652]|0)){RI(2023504)|0;Esh(2023504)}b=eQe(0)|0;g=Brh(2023952,b,c[d+4>>2]|0,c[f>>2]|0)|0;i=e;return g|0}function KPe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LPe(a,b,c);i=d;return}function LPe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;OPe(a,b,d);RI(2022664)|0;f=qL(2022664)|0;c[f+8>>2]=c[505653];c[f+20>>2]=2022608;c[f+16>>2]=0;iZg(a,b,d,f);i=e;return}function MPe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g>>2]|0;h=c[g+4>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=h;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];if(!(JPe(a,e)|0)){j=0;i=d;return j|0}j=Ksh(2022160,a,b)|0;i=d;return j|0}function NPe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(1139544)|0;f=vL(b,1139544)|0;if(f){LPe(a,f,d);i=e;return}OPe(a,b,d);RI(1104096)|0;f=vL(b,1104096)|0;if(!f){RI(2022664)|0;g=qL(2022664)|0;c[g+8>>2]=c[505653];c[g+20>>2]=2022608;c[g+16>>2]=0;gZg(a,b,d,g);i=e;return}RI(2022216)|0;if(!(c[(c[505577]|0)+16>>2]|0)){RI(2022440)|0;g=qL(2022440)|0;c[g+8>>2]=c[505597];c[g+20>>2]=2022384;c[g+16>>2]=0;RI(2022216)|0;c[(c[505577]|0)+16>>2]=g}RI(2022216)|0;fZg(a,f,d,c[(c[505577]|0)+16>>2]|0);i=e;return}function OPe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;vhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888118]|0);Dsh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888120]|0);Dsh(f)}if((PCf(b)|0)<(d|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[888122]|0);Dsh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(2023448,a)|0)){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[888124]|0);Dsh(a)}else{i=e;return}}function PPe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function QPe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function RPe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(2022832)|0;e=pL(2022832,d)|0;i=b;return e|0}function SPe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function TPe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;RI(2022832)|0;e=pL(2022832,d)|0;i=b;return e|0}function UPe(a){a=a|0;var b=0,c=0;b=i;RI(2023e3)|0;c=qL(2023e3)|0;VPe(c,a);i=b;return c|0}function VPe(a,b){a=a|0;b=b|0;var d=0;d=c[b+48>>2]|0;c[a+8>>2]=b;c[a+12>>2]=0;c[a+16>>2]=d;d=a+20|0;c[d>>2]=0;c[d+4>>2]=0;return}function WPe(a){a=a|0;return c[a+32>>2]|0}function XPe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;thh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888106]|0);Dsh(f)}f=a+40|0;g=Lsh(2023168,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;k=m+-1|0;a:do if(!m){n=k;o=-1;p=9}else{q=a+12|0;r=a+16|0;s=c[q>>2]|0;t=s;u=c[(c[s>>2]|0)+120>>2]|0;s=k;v=-1;while(1){if((c[t+16+(da(u,s)|0)>>2]|0)==(h|0)){w=c[r>>2]|0;if(Msh(2023224,c[f>>2]|0,c[w+16+(da(c[(c[w>>2]|0)+120>>2]|0,s)|0)>>2]|0,b)|0){n=s;o=v;p=9;break a}w=c[q>>2]|0;x=w;y=c[(c[w>>2]|0)+120>>2]|0}else{x=t;y=u}w=c[x+16+((da(y,s)|0)+4)>>2]|0;if((w|0)==-1)break;else{z=s;t=x;u=y;s=w;v=z}}}while(0);if((p|0)==9?(n|0)!=-1:0){if((o|0)==-1){A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}p=c[a+12>>2]|0;y=p+16|0;x=c[(c[p>>2]|0)+120>>2]|0;c[y+((da(x,o)|0)+4)>>2]=c[y+((da(x,n)|0)+4)>>2];x=c[j>>2]|0;o=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,g)|0)|0;c[y+((da(c[(c[p>>2]|0)+120>>2]|0,n)|0)+4)>>2]=(c[o>>2]|0)+-1;c[o>>2]=n+1;A=n;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}n=a+32|0;o=c[n>>2]|0;c[n>>2]=o+1;if((o|0)<(c[a+36>>2]|0))M=g;else{YPe(a);M=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){o=a+24|0;n=c[o>>2]|0;c[o>>2]=n+1;o=c[a+12>>2]|0;p=c[o>>2]|0;N=o;O=c[p+120>>2]|0;P=p;Q=n}else{n=c[a+12>>2]|0;p=c[n>>2]|0;o=c[p+120>>2]|0;c[l>>2]=c[n+16+((da(o,g)|0)+4)>>2];N=n;O=o;P=p;Q=g}g=c[j>>2]|0;j=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,M)|0)|0;c[N+16+((da(O,Q)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=Q+1;c[N+16+(da(c[P+120>>2]|0,Q)|0)>>2]=h;h=c[a+16>>2]|0;c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,Q)|0)>>2]=b;A=Q;B=a+20|0;C=c[B>>2]|0;D=c[C>>2]|0;E=C+16|0;F=D+120|0;G=c[F>>2]|0;H=da(G,A)|0;I=E+H|0;c[I>>2]=d;J=a+48|0;K=c[J>>2]|0;L=K+1|0;c[J>>2]=L;i=e;return}function YPe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+8|0;f=c[e>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Esh(2730168)}g=nPf(0,c[f+12>>2]<<1|1)|0;RI(1101728)|0;f=Nsh(1101728,g)|0;RI(1103136)|0;h=Nsh(1103136,g)|0;j=c[e>>2]|0;if((c[j+12>>2]|0)>0){k=b+40|0;l=b+16|0;m=h+16|0;n=f+16|0;o=b+12|0;p=j;j=0;while(1){q=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0;if(!q)r=p;else{s=q+-1|0;do{q=c[l>>2]|0;t=Lsh(2023168,c[k>>2]|0,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,s)|0)>>2]|0)|0;c[m+(da(c[(c[h>>2]|0)+120>>2]|0,s)|0)>>2]=t|-2147483648;q=n+(da(c[(c[f>>2]|0)+120>>2]|0,(t&2147483647|0)%(g|0)|0)|0)|0;c[m+((da(c[(c[h>>2]|0)+120>>2]|0,s)|0)+4)>>2]=(c[q>>2]|0)+-1;c[q>>2]=s+1;q=c[o>>2]|0;s=c[q+16+((da(c[(c[q>>2]|0)+120>>2]|0,s)|0)+4)>>2]|0}while((s|0)!=-1);r=c[e>>2]|0}j=j+1|0;if((j|0)>=(c[r+12>>2]|0)){u=l;v=o;break}else p=r}}else{u=b+16|0;v=b+12|0}c[e>>2]=f;c[v>>2]=h;RI(1140016)|0;h=Nsh(1140016,g)|0;RI(1140744)|0;v=Nsh(1140744,g)|0;f=b+24|0;wEf(0,c[u>>2]|0,0,h,0,c[f>>2]|0);e=b+20|0;wEf(0,c[e>>2]|0,0,v,0,c[f>>2]|0);c[u>>2]=h;c[e>>2]=v;c[b+36>>2]=~~ea(ea(g|0)*ea(.899999976));i=d;return}function ZPe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(1101728)|0;e=a+8|0;c[e>>2]=Nsh(1101728,b)|0;RI(1103136)|0;c[a+12>>2]=Nsh(1103136,b)|0;c[a+28>>2]=-1;RI(1140016)|0;c[a+16>>2]=Nsh(1140016,b)|0;RI(1140744)|0;c[a+20>>2]=Nsh(1140744,b)|0;c[a+24>>2]=0;b=c[(c[e>>2]|0)+12>>2]|0;e=~~ea(ea(b|0)*ea(.899999976));c[a+36>>2]=(e|0)!=0|(b|0)<1?e:1;i=d;return}function _Pe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[a>>2]=d;c[a+4>>2]=e;return}function $Pe(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;return}function aQe(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function bQe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;xhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888216]|0);Dsh(f)}f=a+40|0;g=Lsh(2023168,c[f>>2]|0,b)|0;h=g|-2147483648;j=a+8|0;k=c[j>>2]|0;l=g&2147483647;g=(l|0)%(c[k+12>>2]|0)|0;m=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]|0;a:do if(m){k=a+12|0;n=a+16|0;o=c[k>>2]|0;p=o;q=c[(c[o>>2]|0)+120>>2]|0;o=m+-1|0;while(1){if((c[p+16+(da(q,o)|0)>>2]|0)==(h|0)){r=c[n>>2]|0;if(Msh(2023224,c[f>>2]|0,c[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,o)|0)>>2]|0,b)|0)break;r=c[k>>2]|0;s=r;t=c[(c[r>>2]|0)+120>>2]|0}else{s=p;t=q}o=c[s+16+((da(t,o)|0)+4)>>2]|0;if((o|0)==-1)break a;else{p=s;q=t}}RI(2965048)|0;q=qL(2965048)|0;Rbg(q,c[888218]|0);Dsh(q)}while(0);t=a+32|0;s=c[t>>2]|0;c[t>>2]=s+1;if((s|0)<(c[a+36>>2]|0))u=g;else{YPe(a);u=(l|0)%(c[(c[j>>2]|0)+12>>2]|0)|0}l=a+28|0;g=c[l>>2]|0;if((g|0)==-1){s=a+24|0;t=c[s>>2]|0;c[s>>2]=t+1;s=c[a+12>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0;x=t}else{t=c[a+12>>2]|0;s=c[(c[t>>2]|0)+120>>2]|0;c[l>>2]=c[t+16+((da(s,g)|0)+4)>>2];v=t;w=s;x=g}c[v+16+(da(w,x)|0)>>2]=h;h=c[j>>2]|0;j=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,u)|0)|0;c[v+16+((da(w,x)|0)+4)>>2]=(c[j>>2]|0)+-1;c[j>>2]=x+1;j=c[a+16>>2]|0;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,x)|0)>>2]=b;b=c[a+20>>2]|0;c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,x)|0)>>2]=d;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}function cQe(a){a=a|0;var b=0,d=0;b=i;c[a+32>>2]=0;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+16>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+20>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+12>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+28>>2]=-1;c[a+24>>2]=0;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function dQe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;RI(2023504)|0;if(!(a[2023652]|0)){RI(2023504)|0;Esh(2023504)}f=eQe(0)|0;g=b+8|0;h=c[g>>2]|0;if((c[h+12>>2]|0)<=0){j=0;i=e;return j|0}k=b+20|0;l=b+12|0;b=h;h=0;a:while(1){m=c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,h)|0)>>2]|0;if(!m)n=b;else{o=m+-1|0;do{m=c[k>>2]|0;if(Nqh(2023672,f,c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,o)|0)>>2]|0,d)|0){j=1;p=11;break a}m=c[l>>2]|0;o=c[m+16+((da(c[(c[m>>2]|0)+120>>2]|0,o)|0)+4)>>2]|0}while((o|0)!=-1);n=c[g>>2]|0}h=h+1|0;if((h|0)>=(c[n+12>>2]|0)){j=0;p=11;break}else b=n}if((p|0)==11){i=e;return j|0}return 0}function eQe(b){b=b|0;b=i;RI(2023504)|0;if(!(a[2023652]|0)){RI(2023504)|0;Esh(2023504)}RI(2023504)|0;i=b;return c[c[505899]>>2]|0}function fQe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;yhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888254]|0);Dsh(e)}r9f(b,c[888256]|0,c[a+48>>2]|0);L7f(b,c[888258]|0,c[a+40>>2]|0);e=c[a+32>>2]|0;if((e|0)<1)f=0;else{RI(1139544)|0;g=Nsh(1139544,e)|0;LPe(a,g,0);f=g}r9f(b,c[888260]|0,c[(c[a+8>>2]|0)+12>>2]|0);L7f(b,c[888262]|0,f);i=d;return}function gQe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;c[f>>2]=0;zhh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888278]|0);Dsh(g)}g=a+40|0;h=Lsh(2023168,c[g>>2]|0,b)|0;j=h|-2147483648;k=a+8|0;l=c[k>>2]|0;m=(h&2147483647|0)%(c[l+12>>2]|0)|0;h=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,m)|0)>>2]|0;if(!h){n=0;i=d;return n|0}l=a+12|0;o=a+16|0;p=c[l>>2]|0;q=p;r=c[(c[p>>2]|0)+120>>2]|0;p=h+-1|0;h=-1;while(1){if((c[q+16+(da(r,p)|0)>>2]|0)==(j|0)){s=c[o>>2]|0;if(Msh(2023224,c[g>>2]|0,c[s+16+(da(c[(c[s>>2]|0)+120>>2]|0,p)|0)>>2]|0,b)|0){t=p;u=h;break}s=c[l>>2]|0;v=s;w=c[(c[s>>2]|0)+120>>2]|0}else{v=q;w=r}s=c[v+16+((da(w,p)|0)+4)>>2]|0;if((s|0)==-1){n=0;x=14;break}else{y=p;q=v;r=w;p=s;h=y}}if((x|0)==14){i=d;return n|0}if((t|0)==-1){n=0;i=d;return n|0}x=a+32|0;c[x>>2]=(c[x>>2]|0)+-1;if((u|0)==-1){x=c[k>>2]|0;k=c[l>>2]|0;h=c[k>>2]|0;p=(c[k+16+((da(c[h+120>>2]|0,t)|0)+4)>>2]|0)+1|0;c[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,m)|0)>>2]=p;z=k;A=h}else{h=c[l>>2]|0;l=h+16|0;k=c[(c[h>>2]|0)+120>>2]|0;c[l+((da(k,u)|0)+4)>>2]=c[l+((da(k,t)|0)+4)>>2];z=h;A=c[h>>2]|0}h=a+28|0;k=z+16|0;c[k+((da(c[A+120>>2]|0,t)|0)+4)>>2]=c[h>>2];c[h>>2]=t;c[k+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=0;z=c[o>>2]|0;Hsh(2394824,e);c[z+16+(da(c[(c[z>>2]|0)+120>>2]|0,t)|0)>>2]=c[e>>2];e=c[a+20>>2]|0;Hsh(2516584,f);c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,t)|0)>>2]=c[f>>2];f=a+48|0;c[f>>2]=(c[f>>2]|0)+1;n=1;i=d;return n|0}function hQe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;c[f>>2]=0;Ahh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888282]|0);Dsh(g)}g=a+40|0;h=Lsh(2023168,c[g>>2]|0,b)|0;j=h|-2147483648;k=c[a+8>>2]|0;l=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,(h&2147483647|0)%(c[k+12>>2]|0)|0)|0)>>2]|0;a:do if(l){k=a+12|0;h=a+16|0;m=c[k>>2]|0;n=m;o=c[(c[m>>2]|0)+120>>2]|0;m=l+-1|0;while(1){if((c[n+16+(da(o,m)|0)>>2]|0)==(j|0)){p=c[h>>2]|0;if(Msh(2023224,c[g>>2]|0,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,m)|0)>>2]|0,b)|0){q=m;break}p=c[k>>2]|0;r=p;s=c[(c[p>>2]|0)+120>>2]|0}else{r=n;s=o}m=c[r+16+((da(s,m)|0)+4)>>2]|0;if((m|0)==-1)break a;else{n=r;o=s}}o=c[a+20>>2]|0;t=1;u=o+16+(da(c[(c[o>>2]|0)+120>>2]|0,q)|0)|0;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}while(0);Hsh(2516584,f);t=0;u=f;v=c[u>>2]|0;c[d>>2]=v;i=e;return t|0}function iQe(a){a=a|0;var b=0,c=0;b=i;RI(2023728)|0;c=qL(2023728)|0;jQe(c,a);i=b;return c|0}function jQe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Fhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888332]|0);Dsh(e)}else{c[a+8>>2]=b;i=d;return}}function kQe(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function lQe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;i=i+16|0;f=b;c[f>>2]=e;RI(2516584)|0;e=pL(2516584,f)|0;f=a;c[f>>2]=0;c[f+4>>2]=0;LOf(a,d,e);i=b;return}function mQe(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function nQe(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function oQe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=0;Jhh();RI(1094176)|0;g=Nsh(1094176,5)|0;Qqh(g,c[888370]|0);h=g+16|0;c[h>>2]=c[888370];j=c[b>>2]|0;if(!j){if(!(a[2540708]|0))Esh(2540560);k=c[c[635163]>>2]|0}else k=Fqh(2536904,j)|0;Qqh(g,k);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=k;Qqh(g,c[888372]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[888372];k=b+4|0;c[f>>2]=c[k>>2];RI(2516584)|0;if(!(pL(2516584,f)|0)){if(!(a[2540708]|0))Esh(2540560);l=c[c[635163]>>2]|0}else{c[e>>2]=c[k>>2];RI(2516584)|0;l=Fqh(2536904,pL(2516584,e)|0)|0}Qqh(g,l);c[h+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=l;Qqh(g,c[888374]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<2)>>2]=c[888374];if(a[2540708]|0){m=lwf(0,g)|0;i=d;return m|0}Esh(2540560);m=lwf(0,g)|0;i=d;return m|0}function pQe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function qQe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;rQe(c,a);RI(2029160)|0;a=pL(2029160,c)|0;i=b;return a|0}function rQe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);Dsh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Dsh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;MYg(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function sQe(a){a=a|0;c[a+4>>2]=-2;return}function tQe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function uQe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function vQe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=wQe(a)|0;RI(2516584)|0;a=pL(2516584,d)|0;i=b;return a|0}function wQe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Dsh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Dsh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=VYg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function xQe(a){a=a|0;c[a+4>>2]=-2;return}function yQe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function zQe(a,b){a=a|0;b=b|0;Ghh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888342]|0);Dsh(b)}function AQe(a){a=a|0;Hhh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[888362]|0);Dsh(a)}function BQe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=dQe(c[a+8>>2]|0,b)|0;i=d;return e|0}function CQe(a,b){a=a|0;b=b|0;Ihh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888366]|0);Dsh(b);return 0}function DQe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=0;c[a+4>>2]=0;RI(2036896)|0;a=pL(2036896,d)|0;i=b;return a|0}function EQe(a,b){a=a|0;b=b|0;var d=0;d=c[b+8>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=c[d+48>>2]|0;c[a>>2]=d;c[a+4>>2]=0;c[a+8>>2]=b;b=a+12|0;c[b>>2]=0;c[b+4>>2]=0;return}function FQe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(1140744)|0;f=vL(b,1140744)|0;if(!f){g=a+8|0;OPe(c[g>>2]|0,b,d);h=c[g>>2]|0;RI(2037120)|0;g=qL(2037120)|0;c[g+8>>2]=c[506531];c[g+20>>2]=2026120;c[g+16>>2]=0;cZg(h,b,d,g);i=e;return}else{Osh(2037064,a,f,d);i=e;return}}function GQe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function HQe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=0;c[a+4>>2]=0;RI(2036896)|0;a=pL(2036896,d)|0;i=b;return a|0}function IQe(a){a=a|0;return 1}function JQe(a){a=a|0;var b=0,d=0;b=i;d=Sqh(2647408,c[a+8>>2]|0)|0;i=b;return d|0}function KQe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+8|0;OPe(c[f>>2]|0,b,d);a=c[f>>2]|0;RI(2037120)|0;f=qL(2037120)|0;c[f+8>>2]=c[506531];c[f+20>>2]=2026120;c[f+16>>2]=0;eZg(a,b,d,f);i=e;return}function LQe(a,b){a=a|0;b=b|0;var d=0;d=c[b+48>>2]|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=d;d=a+12|0;c[d>>2]=0;c[d+4>>2]=0;return}function MQe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2023448,c[a+8>>2]|0)|0;i=b;return d|0}function NQe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;UQe(a);c[d>>2]=c[a+16>>2];RI(2516584)|0;a=pL(2516584,d)|0;i=b;return a|0}function OQe(a){a=a|0;var b=0;b=i;UQe(a);i=b;return c[a+16>>2]|0}function PQe(a){a=a|0;c[a>>2]=0;return}function QQe(a){a=a|0;c[a>>2]=0;return}function RQe(a){a=a|0;var b=0,c=0;b=i;c=SQe(a)|0;i=b;return c|0}function SQe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;ZQe(a);d=a+4|0;e=c[d>>2]|0;if((e|0)<=-1){f=0;i=b;return f|0}g=c[a>>2]|0;h=c[g+24>>2]|0;j=e;while(1){if((j|0)>=(h|0)){k=6;break}e=j+1|0;c[d>>2]=e;l=c[g+12>>2]|0;if((c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){m=j;k=3;break}else j=e}if((k|0)==3){j=c[g+16>>2]|0;h=c[g+20>>2]|0;g=c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,m)|0)>>2]|0;j=c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,m)|0)>>2]|0;m=a+12|0;c[m>>2]=g;c[m+4>>2]=j;f=1;i=b;return f|0}else if((k|0)==6){c[d>>2]=-1;f=0;i=b;return f|0}return 0}function TQe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;UQe(a);e=a+12|0;a=c[e+4>>2]|0;f=d;c[f>>2]=c[e>>2];c[f+4>>2]=a;RI(2029160)|0;a=pL(2029160,d)|0;i=b;return a|0}function UQe(a){a=a|0;var b=0;b=i;Ehh();ZQe(a);if((c[a+4>>2]|0)>0){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888318]|0);Dsh(b)}}function VQe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;UQe(b);f=c[b+12>>2]|0;c[e>>2]=c[b+16>>2];RI(2516584)|0;b=pL(2516584,e)|0;e=a;c[e>>2]=0;c[e+4>>2]=0;LOf(a,f,b);i=d;return}function WQe(a){a=a|0;var b=0;b=i;UQe(a);i=b;return c[a+12>>2]|0}function XQe(a){a=a|0;var b=0;b=i;UQe(a);i=b;return c[a+12>>2]|0}function YQe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;UQe(a);c[d>>2]=c[a+16>>2];RI(2516584)|0;a=pL(2516584,d)|0;i=b;return a|0}function ZQe(a){a=a|0;var b=0,d=0,e=0;b=i;Dhh();d=c[a>>2]|0;if(!d){RI(3112928)|0;e=qL(3112928)|0;kwg(e,0);Dsh(e)}if((c[d+48>>2]|0)==(c[a+8>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888308]|0);Dsh(b)}}function _Qe(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function $Qe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)$Qe(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function aRe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function bRe(a,b){a=a|0;b=b|0;return 0}function cRe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)cRe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function dRe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function eRe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function fRe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)fRe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function gRe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function hRe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function iRe(a){a=a|0;var b=0,c=0;b=i;c=SQe(a+8|0)|0;i=b;return c|0}function jRe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;f=b+8|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];RI(2022832)|0;xrh(a,2734240,pL(2022832,e)|0);i=d;return}function kRe(a){a=a|0;return c[a+20>>2]|0}function lRe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=c[a+24>>2];RI(2516584)|0;a=pL(2516584,d)|0;i=b;return a|0}function mRe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;yrh(c,2041408,a);RI(2729368)|0;a=pL(2729368,c)|0;i=b;return a|0}function nRe(a){a=a|0;return}function oRe(a){a=a|0;var b=0;a=i;RI(2043872)|0;b=qL(2043872)|0;RI(2023504)|0;c[c[505899]>>2]=b;i=a;return}function pRe(a){a=a|0;return}function qRe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(2516584)|0;e=Arh(2044040,a,c[(Ish(b,2516584)|0)>>2]|0)|0;i=d;return e|0}function rRe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;RI(2516584)|0;f=c[(Ish(b,2516584)|0)>>2]|0;RI(2516584)|0;b=Brh(2023952,a,f,c[(Ish(d,2516584)|0)>>2]|0)|0;i=e;return b|0}function sRe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;c[d>>2]=b;c[e>>2]=b;RI(2516584)|0;if(!(pL(2516584,e)|0)){f=0;i=a;return f|0}RI(2516584)|0;f=Aqh(2536720,pL(2516584,d)|0)|0;i=a;return f|0}function tRe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+12|0;f=a+8|0;g=a+4|0;h=a;c[e>>2]=b;c[f>>2]=b;RI(2516584)|0;if(!(pL(2516584,f)|0)){c[g>>2]=d;RI(2516584)|0;j=(pL(2516584,g)|0)==0;i=a;return j|0}else{c[h>>2]=d;RI(2516584)|0;d=pL(2516584,h)|0;RI(2516584)|0;j=nrh(2536048,pL(2516584,e)|0,d)|0;i=a;return j|0}return 0}function uRe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function vRe(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=wRe(b)|0;RI(2515960)|0;b=pL(2515960,d)|0;i=c;return b|0}function wRe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Dsh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Dsh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=jZg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function xRe(a){a=a|0;c[a+4>>2]=-2;return}function yRe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function zRe(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;zGe(a,b);i=d;return}function ARe(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;zGe(a,b);i=d;return}function BRe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function CRe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=DRe(a)|0;RI(2529488)|0;a=pL(2529488,d)|0;i=b;return a|0}function DRe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Psh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=sZg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function ERe(a){a=a|0;c[a+4>>2]=-2;return}function FRe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function GRe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function HRe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=IRe(a)|0;RI(2253112)|0;a=pL(2253112,d)|0;i=b;return a|0}function IRe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Psh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=BZg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function JRe(a){a=a|0;c[a+4>>2]=-2;return}function KRe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function LRe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function MRe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=NRe(a)|0;RI(2255040)|0;a=pL(2255040,d)|0;i=b;return a|0}function NRe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Psh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=KZg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function ORe(a){a=a|0;c[a+4>>2]=-2;return}function PRe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function QRe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function RRe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=SRe(a)|0;RI(2255576)|0;a=pL(2255576,d)|0;i=b;return a|0}function SRe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Psh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=TZg(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function TRe(a){a=a|0;c[a+4>>2]=-2;return}function URe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function VRe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function WRe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=XRe(a)|0;RI(2256176)|0;a=pL(2256176,d)|0;i=b;return a|0}function XRe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Psh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=a_g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function YRe(a){a=a|0;c[a+4>>2]=-2;return}function ZRe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function _Re(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function $Re(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=aSe(a)|0;RI(2565248)|0;a=pL(2565248,d)|0;i=c;return a|0}function aSe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Psh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=j_g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function bSe(a){a=a|0;c[a+4>>2]=-2;return}function cSe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function dSe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function eSe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=fSe(a)|0;RI(2268872)|0;a=pL(2268872,d)|0;i=b;return a|0}function fSe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Psh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=s_g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function gSe(a){a=a|0;c[a+4>>2]=-2;return}function hSe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function iSe(a){a=a|0;var b=0;b=i;jSe(a,10,0);i=b;return}function jSe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;uhh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[888110]|0);Psh(g)}if(!e){RI(1831832)|0;if(!(a[1831980]|0)){RI(1831832)|0;Qsh(1831832)}RI(1831832)|0;h=vGe(0,c[457982]|0)|0}else h=e;c[b+40>>2]=h;h=~~ea(ea(d|0)/ea(.899999976))+1|0;LSe(b,(d|0)==0?12:h);c[b+48>>2]=0;i=f;return}function kSe(a,b){a=a|0;b=b|0;var c=0;c=i;jSe(a,10,b);i=c;return}function lSe(a,b){a=a|0;b=b|0;var c=0;c=i;jSe(a,b,0);i=c;return}function mSe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=nSe(0,b)|0;Rsh(2111856,a,e,oSe(0,c)|0);i=d;return}function nSe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+4|0;f=b;Bhh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888286]|0);Psh(g)}if(!(vL(d,2540560)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Qsh(2540728)}c[f>>2]=3431728;c[e+0>>2]=c[f+0>>2];f=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);Psh(k)}Qsh(2540560);h=c[888288]|0;j=gwf(0,h,f)|0;RI(2965048)|0;k=qL(2965048)|0;l=c[888290]|0;Rag(k,j,l);Psh(k)}k=vL(d,2540560)|0;if(k){i=b;return k|0}_J(e,c[(c[d>>2]|0)+44>>2]|0,2540560);if(!(a[e>>0]&1)){m=e+1|0;n=MJ(m)|0;FJ(n)}else{m=c[e+8>>2]|0;n=MJ(m)|0;FJ(n)}return 0}function oSe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;e=b+8|0;f=b+20|0;g=b+4|0;h=b;a[f>>0]=0;Chh();j=(d|0)==0;if(j){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Qsh(2540728)}c[g>>2]=3431408;c[e+0>>2]=c[g+0>>2];if(!(Gqh(2650144,npf(0,e)|0)|0)){Ssh(2601984,f);k=f;l=a[k>>0]|0;m=l<<24>>24!=0;i=b;return m|0}}RI(2601984)|0;if(!(vL(d,2601984)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Qsh(2540728)}c[h>>2]=3431408;c[e+0>>2]=c[h+0>>2];h=Fqh(2536192,npf(0,e)|0)|0;if(a[2540708]|0){n=c[888302]|0;o=gwf(0,n,h)|0;RI(2965048)|0;p=qL(2965048)|0;q=c[888304]|0;Rag(p,o,q);Psh(p)}Qsh(2540560);n=c[888302]|0;o=gwf(0,n,h)|0;RI(2965048)|0;p=qL(2965048)|0;q=c[888304]|0;Rag(p,o,q);Psh(p)}RI(2601984)|0;if(j)HJ();j=c[(c[d>>2]|0)+44>>2]|0;p=c[650507]|0;if((j|0)==(p|0)){k=yL(d)|0;l=a[k>>0]|0;m=l<<24>>24!=0;i=b;return m|0}_J(e,j,p);if(!(a[e>>0]&1)){r=e+1|0;s=MJ(r)|0;FJ(s)}else{r=c[e+8>>2]|0;s=MJ(r)|0;FJ(s)}return 0}function pSe(a){a=a|0;return a|0}function qSe(a){a=a|0;return 0}function rSe(b,d){b=b|0;d=d|0;var e=0;e=i;Rsh(2111912,b,c[d>>2]|0,(a[d+4>>0]|0)!=0);i=e;return}function sSe(a){a=a|0;return c[a>>2]|0}function tSe(b){b=b|0;return (a[b+4>>0]|0)!=0|0}function uSe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=b;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];f=vSe(a,e)|0;i=d;return f|0}function vSe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;a[f>>0]=0;if(!(Tsh(2113256,b,c[d>>2]|0,f)|0)){g=0;i=e;return g|0}RI(2139464)|0;if(!(a[2139612]|0)){RI(2139464)|0;Qsh(2139464)}b=dUe(0)|0;g=Ush(2139688,b,(a[d+4>>0]|0)!=0,(a[f>>0]|0)!=0)|0;i=e;return g|0}function wSe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;xSe(a,b,c);i=d;return}function xSe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;ASe(a,b,d);RI(2112472)|0;f=qL(2112472)|0;c[f+8>>2]=c[528105];c[f+20>>2]=2112416;c[f+16>>2]=0;Z_g(a,b,d,f);i=e;return}function ySe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d;g=b;b=c[g>>2]|0;h=c[g+4>>2]|0;g=f;c[g>>2]=b;c[g+4>>2]=h;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];if(!(vSe(a,e)|0)){j=0;i=d;return j|0}j=Prh(2111968,a,b)|0;i=d;return j|0}function zSe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(1152504)|0;f=vL(b,1152504)|0;if(f){xSe(a,f,d);i=e;return}ASe(a,b,d);RI(1104096)|0;f=vL(b,1104096)|0;if(!f){RI(2112472)|0;g=qL(2112472)|0;c[g+8>>2]=c[528105];c[g+20>>2]=2112416;c[g+16>>2]=0;X_g(a,b,d,g);i=e;return}RI(2112024)|0;if(!(c[(c[528029]|0)+16>>2]|0)){RI(2112248)|0;g=qL(2112248)|0;c[g+8>>2]=c[528049];c[g+20>>2]=2112192;c[g+16>>2]=0;RI(2112024)|0;c[(c[528029]|0)+16>>2]=g}RI(2112024)|0;W_g(a,f,d,c[(c[528029]|0)+16>>2]|0);i=e;return}function ASe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;vhh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888118]|0);Psh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[888120]|0);Psh(f)}if((PCf(b)|0)<(d|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[888122]|0);Psh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(2112976,a)|0)){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[888124]|0);Psh(a)}else{i=e;return}}function BSe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function CSe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function DSe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b;e=2113324|0;f=c[e>>2]|0;g=c[e+4>>2]|0;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=f;c[e+4>>2]=g;RI(2112640)|0;g=pL(2112640,d)|0;i=b;return g|0}function ESe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function FSe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b;e=2113324|0;f=c[e>>2]|0;g=c[e+4>>2]|0;e=c[a+48>>2]|0;c[d>>2]=a;c[d+4>>2]=0;c[d+8>>2]=e;e=d+12|0;c[e>>2]=f;c[e+4>>2]=g;RI(2112640)|0;g=pL(2112640,d)|0;i=b;return g|0}function GSe(a){a=a|0;var b=0,c=0;b=i;RI(2112808)|0;c=qL(2112808)|0;HSe(c,a);i=b;return c|0}function HSe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=2113324|0;e=c[d>>2]|0;f=c[d+4>>2]|0;d=c[b+48>>2]|0;c[a+8>>2]=b;c[a+12>>2]=0;c[a+16>>2]=d;d=a+20|0;c[d>>2]=e;c[d+4>>2]=f;return}function ISe(a){a=a|0;return c[a+32>>2]|0}function JSe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;thh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888106]|0);Psh(g)}g=b+40|0;h=esh(1822656,c[g>>2]|0,d)|0;j=h|-2147483648;k=b+8|0;l=c[k>>2]|0;m=h&2147483647;h=(m|0)%(c[l+12>>2]|0)|0;n=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,h)|0)>>2]|0;l=n+-1|0;a:do if(!n){o=l;p=-1;q=9}else{r=b+12|0;s=b+16|0;t=c[r>>2]|0;u=t;v=c[(c[t>>2]|0)+120>>2]|0;t=l;w=-1;while(1){if((c[u+16+(da(v,t)|0)>>2]|0)==(j|0)){x=c[s>>2]|0;if(fsh(1822584,c[g>>2]|0,c[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,t)|0)>>2]|0,d)|0){o=t;p=w;q=9;break a}x=c[r>>2]|0;y=x;z=c[(c[x>>2]|0)+120>>2]|0}else{y=u;z=v}x=c[y+16+((da(z,t)|0)+4)>>2]|0;if((x|0)==-1)break;else{A=t;u=y;v=z;t=x;w=A}}}while(0);if((q|0)==9?(o|0)!=-1:0){if((p|0)==-1){B=o;C=b+20|0;D=c[C>>2]|0;E=c[D>>2]|0;F=D+16|0;G=E+120|0;H=c[G>>2]|0;I=da(H,B)|0;J=F+I|0;K=e&1;a[J>>0]=K;L=b+48|0;M=c[L>>2]|0;N=M+1|0;c[L>>2]=N;i=f;return}q=c[b+12>>2]|0;z=q+16|0;y=c[(c[q>>2]|0)+120>>2]|0;c[z+((da(y,p)|0)+4)>>2]=c[z+((da(y,o)|0)+4)>>2];y=c[k>>2]|0;p=y+16+(da(c[(c[y>>2]|0)+120>>2]|0,h)|0)|0;c[z+((da(c[(c[q>>2]|0)+120>>2]|0,o)|0)+4)>>2]=(c[p>>2]|0)+-1;c[p>>2]=o+1;B=o;C=b+20|0;D=c[C>>2]|0;E=c[D>>2]|0;F=D+16|0;G=E+120|0;H=c[G>>2]|0;I=da(H,B)|0;J=F+I|0;K=e&1;a[J>>0]=K;L=b+48|0;M=c[L>>2]|0;N=M+1|0;c[L>>2]=N;i=f;return}o=b+32|0;p=c[o>>2]|0;c[o>>2]=p+1;if((p|0)<(c[b+36>>2]|0))O=h;else{KSe(b);O=(m|0)%(c[(c[k>>2]|0)+12>>2]|0)|0}m=b+28|0;h=c[m>>2]|0;if((h|0)==-1){p=b+24|0;o=c[p>>2]|0;c[p>>2]=o+1;p=c[b+12>>2]|0;q=c[p>>2]|0;P=p;Q=c[q+120>>2]|0;R=q;S=o}else{o=c[b+12>>2]|0;q=c[o>>2]|0;p=c[q+120>>2]|0;c[m>>2]=c[o+16+((da(p,h)|0)+4)>>2];P=o;Q=p;R=q;S=h}h=c[k>>2]|0;k=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,O)|0)|0;c[P+16+((da(Q,S)|0)+4)>>2]=(c[k>>2]|0)+-1;c[k>>2]=S+1;c[P+16+(da(c[R+120>>2]|0,S)|0)>>2]=j;j=c[b+16>>2]|0;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,S)|0)>>2]=d;B=S;C=b+20|0;D=c[C>>2]|0;E=c[D>>2]|0;F=D+16|0;G=E+120|0;H=c[G>>2]|0;I=da(H,B)|0;J=F+I|0;K=e&1;a[J>>0]=K;L=b+48|0;M=c[L>>2]|0;N=M+1|0;c[L>>2]=N;i=f;return}function KSe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+8|0;f=c[e>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Qsh(2730168)}g=nPf(0,c[f+12>>2]<<1|1)|0;RI(1101728)|0;f=Vsh(1101728,g)|0;RI(1103136)|0;h=Vsh(1103136,g)|0;j=c[e>>2]|0;if((c[j+12>>2]|0)>0){k=b+40|0;l=b+16|0;m=h+16|0;n=f+16|0;o=b+12|0;p=j;j=0;while(1){q=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0;if(!q)r=p;else{s=q+-1|0;do{q=c[l>>2]|0;t=esh(1822656,c[k>>2]|0,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,s)|0)>>2]|0)|0;c[m+(da(c[(c[h>>2]|0)+120>>2]|0,s)|0)>>2]=t|-2147483648;q=n+(da(c[(c[f>>2]|0)+120>>2]|0,(t&2147483647|0)%(g|0)|0)|0)|0;c[m+((da(c[(c[h>>2]|0)+120>>2]|0,s)|0)+4)>>2]=(c[q>>2]|0)+-1;c[q>>2]=s+1;q=c[o>>2]|0;s=c[q+16+((da(c[(c[q>>2]|0)+120>>2]|0,s)|0)+4)>>2]|0}while((s|0)!=-1);r=c[e>>2]|0}j=j+1|0;if((j|0)>=(c[r+12>>2]|0)){u=l;v=o;break}else p=r}}else{u=b+16|0;v=b+12|0}c[e>>2]=f;c[v>>2]=h;RI(1094176)|0;h=Vsh(1094176,g)|0;RI(1153040)|0;v=Vsh(1153040,g)|0;f=b+24|0;wEf(0,c[u>>2]|0,0,h,0,c[f>>2]|0);e=b+20|0;wEf(0,c[e>>2]|0,0,v,0,c[f>>2]|0);c[u>>2]=h;c[e>>2]=v;c[b+36>>2]=~~ea(ea(g|0)*ea(.899999976));i=d;return}function LSe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(1101728)|0;e=a+8|0;c[e>>2]=Vsh(1101728,b)|0;RI(1103136)|0;c[a+12>>2]=Vsh(1103136,b)|0;c[a+28>>2]=-1;RI(1094176)|0;c[a+16>>2]=Vsh(1094176,b)|0;RI(1153040)|0;c[a+20>>2]=Vsh(1153040,b)|0;c[a+24>>2]=0;b=c[(c[e>>2]|0)+12>>2]|0;e=~~ea(ea(b|0)*ea(.899999976));c[a+36>>2]=(e|0)!=0|(b|0)<1?e:1;i=d;return}function MSe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=3264928;g=c[d+4>>2]|0;h=b;c[h>>2]=c[d>>2];c[h+4>>2]=g;c[b>>2]=e;a[b+4>>0]=f&1;return}function NSe(b,d,e){b=b|0;d=d|0;e=e|0;c[b>>2]=d;a[b+4>>0]=e&1;return}function OSe(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function PSe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;xhh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888216]|0);Psh(g)}g=b+40|0;h=esh(1822656,c[g>>2]|0,d)|0;j=h|-2147483648;k=b+8|0;l=c[k>>2]|0;m=h&2147483647;h=(m|0)%(c[l+12>>2]|0)|0;n=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,h)|0)>>2]|0;a:do if(n){l=b+12|0;o=b+16|0;p=c[l>>2]|0;q=p;r=c[(c[p>>2]|0)+120>>2]|0;p=n+-1|0;while(1){if((c[q+16+(da(r,p)|0)>>2]|0)==(j|0)){s=c[o>>2]|0;if(fsh(1822584,c[g>>2]|0,c[s+16+(da(c[(c[s>>2]|0)+120>>2]|0,p)|0)>>2]|0,d)|0)break;s=c[l>>2]|0;t=s;u=c[(c[s>>2]|0)+120>>2]|0}else{t=q;u=r}p=c[t+16+((da(u,p)|0)+4)>>2]|0;if((p|0)==-1)break a;else{q=t;r=u}}RI(2965048)|0;r=qL(2965048)|0;Rbg(r,c[888218]|0);Psh(r)}while(0);u=b+32|0;t=c[u>>2]|0;c[u>>2]=t+1;if((t|0)<(c[b+36>>2]|0))v=h;else{KSe(b);v=(m|0)%(c[(c[k>>2]|0)+12>>2]|0)|0}m=b+28|0;h=c[m>>2]|0;if((h|0)==-1){t=b+24|0;u=c[t>>2]|0;c[t>>2]=u+1;t=c[b+12>>2]|0;w=t;x=c[(c[t>>2]|0)+120>>2]|0;y=u}else{u=c[b+12>>2]|0;t=c[(c[u>>2]|0)+120>>2]|0;c[m>>2]=c[u+16+((da(t,h)|0)+4)>>2];w=u;x=t;y=h}c[w+16+(da(x,y)|0)>>2]=j;j=c[k>>2]|0;k=j+16+(da(c[(c[j>>2]|0)+120>>2]|0,v)|0)|0;c[w+16+((da(x,y)|0)+4)>>2]=(c[k>>2]|0)+-1;c[k>>2]=y+1;k=c[b+16>>2]|0;c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,y)|0)>>2]=d;d=c[b+20>>2]|0;a[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,y)|0)>>0]=e&1;e=b+48|0;c[e>>2]=(c[e>>2]|0)+1;i=f;return}function QSe(a){a=a|0;var b=0,d=0;b=i;c[a+32>>2]=0;d=c[a+8>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+16>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+20>>2]|0;yDf(0,d,0,c[d+12>>2]|0);d=c[a+12>>2]|0;yDf(0,d,0,c[d+12>>2]|0);c[a+28>>2]=-1;c[a+24>>2]=0;d=a+48|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function RSe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;RI(2139464)|0;if(!(a[2139612]|0)){RI(2139464)|0;Qsh(2139464)}f=dUe(0)|0;g=b+8|0;h=c[g>>2]|0;if((c[h+12>>2]|0)<=0){j=0;i=e;return j|0}k=b+20|0;l=b+12|0;b=h;h=0;a:while(1){m=c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,h)|0)>>2]|0;if(!m)n=b;else{o=m+-1|0;do{m=c[k>>2]|0;if(Wsh(2113032,f,(a[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,o)|0)>>0]|0)!=0,d)|0){j=1;p=11;break a}m=c[l>>2]|0;o=c[m+16+((da(c[(c[m>>2]|0)+120>>2]|0,o)|0)+4)>>2]|0}while((o|0)!=-1);n=c[g>>2]|0}h=h+1|0;if((h|0)>=(c[n+12>>2]|0)){j=0;p=11;break}else b=n}if((p|0)==11){i=e;return j|0}return 0}function SSe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;yhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888254]|0);Psh(e)}r9f(b,c[888256]|0,c[a+48>>2]|0);L7f(b,c[888258]|0,c[a+40>>2]|0);e=c[a+32>>2]|0;if((e|0)<1)f=0;else{RI(1152504)|0;g=Vsh(1152504,e)|0;xSe(a,g,0);f=g}r9f(b,c[888260]|0,c[(c[a+8>>2]|0)+12>>2]|0);L7f(b,c[888262]|0,f);i=d;return}function TSe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+16|0;f=e;g=e+4|0;c[f>>2]=0;a[g>>0]=0;zhh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888278]|0);Psh(h)}h=b+40|0;j=esh(1822656,c[h>>2]|0,d)|0;k=j|-2147483648;l=b+8|0;m=c[l>>2]|0;n=(j&2147483647|0)%(c[m+12>>2]|0)|0;j=c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,n)|0)>>2]|0;if(!j){o=0;i=e;return o|0}m=b+12|0;p=b+16|0;q=c[m>>2]|0;r=q;s=c[(c[q>>2]|0)+120>>2]|0;q=j+-1|0;j=-1;while(1){if((c[r+16+(da(s,q)|0)>>2]|0)==(k|0)){t=c[p>>2]|0;if(fsh(1822584,c[h>>2]|0,c[t+16+(da(c[(c[t>>2]|0)+120>>2]|0,q)|0)>>2]|0,d)|0){u=q;v=j;break}t=c[m>>2]|0;w=t;x=c[(c[t>>2]|0)+120>>2]|0}else{w=r;x=s}t=c[w+16+((da(x,q)|0)+4)>>2]|0;if((t|0)==-1){o=0;y=14;break}else{z=q;r=w;s=x;q=t;j=z}}if((y|0)==14){i=e;return o|0}if((u|0)==-1){o=0;i=e;return o|0}y=b+32|0;c[y>>2]=(c[y>>2]|0)+-1;if((v|0)==-1){y=c[l>>2]|0;l=c[m>>2]|0;j=c[l>>2]|0;q=(c[l+16+((da(c[j+120>>2]|0,u)|0)+4)>>2]|0)+1|0;c[y+16+(da(c[(c[y>>2]|0)+120>>2]|0,n)|0)>>2]=q;A=l;B=j}else{j=c[m>>2]|0;m=j+16|0;l=c[(c[j>>2]|0)+120>>2]|0;c[m+((da(l,v)|0)+4)>>2]=c[m+((da(l,u)|0)+4)>>2];A=j;B=c[j>>2]|0}j=b+28|0;l=A+16|0;c[l+((da(c[B+120>>2]|0,u)|0)+4)>>2]=c[j>>2];c[j>>2]=u;c[l+(da(c[(c[A>>2]|0)+120>>2]|0,u)|0)>>2]=0;A=c[p>>2]|0;Ssh(2540560,f);c[A+16+(da(c[(c[A>>2]|0)+120>>2]|0,u)|0)>>2]=c[f>>2];f=c[b+20>>2]|0;Ssh(2601984,g);a[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,u)|0)>>0]=a[g>>0]|0;g=b+48|0;c[g>>2]=(c[g>>2]|0)+1;o=1;i=e;return o|0}function USe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f;a[g>>0]=0;Ahh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888282]|0);Psh(h)}h=b+40|0;j=esh(1822656,c[h>>2]|0,d)|0;k=j|-2147483648;l=c[b+8>>2]|0;m=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,(j&2147483647|0)%(c[l+12>>2]|0)|0)|0)>>2]|0;a:do if(m){l=b+12|0;j=b+16|0;n=c[l>>2]|0;o=n;p=c[(c[n>>2]|0)+120>>2]|0;n=m+-1|0;while(1){if((c[o+16+(da(p,n)|0)>>2]|0)==(k|0)){q=c[j>>2]|0;if(fsh(1822584,c[h>>2]|0,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,n)|0)>>2]|0,d)|0){r=n;break}q=c[l>>2]|0;s=q;t=c[(c[q>>2]|0)+120>>2]|0}else{s=o;t=p}n=c[s+16+((da(t,n)|0)+4)>>2]|0;if((n|0)==-1)break a;else{o=s;p=t}}p=c[b+20>>2]|0;u=1;v=p+16+(da(c[(c[p>>2]|0)+120>>2]|0,r)|0)|0;w=a[v>>0]|0;a[e>>0]=w;i=f;return u|0}while(0);Ssh(2601984,g);u=0;v=g;w=a[v>>0]|0;a[e>>0]=w;i=f;return u|0}function VSe(a){a=a|0;var b=0,c=0;b=i;RI(2113088)|0;c=qL(2113088)|0;WSe(c,a);i=b;return c|0}function WSe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Fhh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888332]|0);Psh(e)}else{c[a+8>>2]=b;i=d;return}}function XSe(a,b){a=a|0;b=b|0;c[a+0>>2]=c[528328];c[a+4>>2]=c[528329];c[a+8>>2]=c[528330];c[a+12>>2]=c[528331];c[a+16>>2]=c[528332];c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function YSe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;d=i;i=i+16|0;g=d;a[g>>0]=f&1;RI(2601984)|0;f=pL(2601984,g)|0;g=b;c[g>>2]=0;c[g+4>>2]=0;LOf(b,e,f);i=d;return}function ZSe(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function _Se(b,c){b=b|0;c=c|0;a[b+4>>0]=c&1;return}function $Se(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+1|0;f=d;a[e>>0]=0;Jhh();RI(1094176)|0;g=Vsh(1094176,5)|0;Qqh(g,c[888370]|0);h=g+16|0;c[h>>2]=c[888370];j=c[b>>2]|0;if(!j){if(!(a[2540708]|0))Qsh(2540560);k=c[c[635163]>>2]|0}else k=Fqh(2536904,j)|0;Qqh(g,k);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=k;Qqh(g,c[888372]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[888372];k=b+4|0;a[f>>0]=a[k>>0]|0;RI(2601984)|0;if(!(pL(2601984,f)|0)){if(!(a[2540708]|0))Qsh(2540560);l=c[c[635163]>>2]|0}else{a[e>>0]=a[k>>0]|0;RI(2601984)|0;l=Fqh(2536904,pL(2601984,e)|0)|0}Qqh(g,l);c[h+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=l;Qqh(g,c[888374]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<2)>>2]=c[888374];if(a[2540708]|0){m=lwf(0,g)|0;i=d;return m|0}Qsh(2540560);m=lwf(0,g)|0;i=d;return m|0}function aTe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function bTe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;cTe(c,a);RI(2119600)|0;a=pL(2119600,c)|0;i=b;return a|0}function cTe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887014]|0);Psh(g)}else if((f|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);Psh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;B_g(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function dTe(a){a=a|0;c[a+4>>2]=-2;return}function eTe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function fTe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function gTe(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=(hTe(b)|0)&1;RI(2601984)|0;b=pL(2601984,d)|0;i=c;return b|0}function hTe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);Psh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);Psh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=K_g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function iTe(a){a=a|0;c[a+4>>2]=-2;return}function jTe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function kTe(a,b){a=a|0;b=b|0;Ghh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888342]|0);Psh(b)}function lTe(a){a=a|0;Hhh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[888362]|0);Psh(a)}function mTe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=RSe(c[a+8>>2]|0,b)|0;i=d;return e|0}function nTe(a,b){a=a|0;b=b|0;Ihh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[888366]|0);Psh(b);return 0}function oTe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=2113324|0;f=c[a>>2]|0;g=c[a+4>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=f;c[a+4>>2]=g;RI(2130216)|0;g=pL(2130216,d)|0;i=b;return g|0}function pTe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[b+8>>2]|0;c[a+0>>2]=c[532652];c[a+4>>2]=c[532653];c[a+8>>2]=c[532654];b=2113324|0;e=c[b>>2]|0;f=c[b+4>>2]|0;b=c[d+48>>2]|0;c[a>>2]=d;c[a+4>>2]=0;c[a+8>>2]=b;b=a+12|0;c[b>>2]=e;c[b+4>>2]=f;return}function qTe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(1153040)|0;f=vL(b,1153040)|0;if(!f){g=a+8|0;ASe(c[g>>2]|0,b,d);h=c[g>>2]|0;RI(2130440)|0;g=qL(2130440)|0;c[g+8>>2]=c[529113];c[g+20>>2]=2116448;c[g+16>>2]=0;T_g(h,b,d,g);i=e;return}else{Xsh(2130384,a,f,d);i=e;return}}function rTe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function sTe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b;e=c[a+8>>2]|0;a=2113324|0;f=c[a>>2]|0;g=c[a+4>>2]|0;a=c[e+48>>2]|0;c[d>>2]=e;c[d+4>>2]=0;c[d+8>>2]=a;a=d+12|0;c[a>>2]=f;c[a+4>>2]=g;RI(2130216)|0;g=pL(2130216,d)|0;i=b;return g|0}function tTe(a){a=a|0;return 1}function uTe(a){a=a|0;var b=0,d=0;b=i;d=Sqh(2647408,c[a+8>>2]|0)|0;i=b;return d|0}function vTe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+8|0;ASe(c[f>>2]|0,b,d);a=c[f>>2]|0;RI(2130440)|0;f=qL(2130440)|0;c[f+8>>2]=c[529113];c[f+20>>2]=2116448;c[f+16>>2]=0;V_g(a,b,d,f);i=e;return}function wTe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=2113324|0;e=c[d>>2]|0;f=c[d+4>>2]|0;d=c[b+48>>2]|0;c[a>>2]=b;c[a+4>>2]=0;c[a+8>>2]=d;d=a+12|0;c[d>>2]=e;c[d+4>>2]=f;return}function xTe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2112976,c[a+8>>2]|0)|0;i=b;return d|0}function yTe(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=(zTe(b)|0)&1;RI(2601984)|0;b=pL(2601984,d)|0;i=c;return b|0}function zTe(b){b=b|0;var c=0;c=i;FTe(b);i=c;return (a[b+16>>0]|0)!=0|0}function ATe(a){a=a|0;c[a>>2]=0;return}function BTe(a){a=a|0;c[a>>2]=0;return}function CTe(a){a=a|0;var b=0,c=0;b=i;c=DTe(a)|0;i=b;return c|0}function DTe(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;KTe(a);e=a+4|0;f=c[e>>2]|0;if((f|0)<=-1){g=0;i=b;return g|0}h=c[a>>2]|0;j=c[h+24>>2]|0;k=f;while(1){if((k|0)>=(j|0)){l=6;break}f=k+1|0;c[e>>2]=f;m=c[h+12>>2]|0;if((c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){n=k;l=3;break}else k=f}if((l|0)==3){k=c[h+16>>2]|0;j=c[h+20>>2]|0;h=c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,n)|0)>>2]|0;k=c[816233]&-256|(d[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,n)|0)>>0]|0);n=a+12|0;c[n>>2]=h;c[n+4>>2]=k;g=1;i=b;return g|0}else if((l|0)==6){c[e>>2]=-1;g=0;i=b;return g|0}return 0}function ETe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;FTe(a);e=a+12|0;a=c[e+4>>2]|0;f=d;c[f>>2]=c[e>>2];c[f+4>>2]=a;RI(2119600)|0;a=pL(2119600,d)|0;i=b;return a|0}function FTe(a){a=a|0;var b=0;b=i;Ehh();KTe(a);if((c[a+4>>2]|0)>0){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888318]|0);Psh(b)}}function GTe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;FTe(d);g=c[d+12>>2]|0;a[f>>0]=a[d+16>>0]|0;RI(2601984)|0;d=pL(2601984,f)|0;f=b;c[f>>2]=0;c[f+4>>2]=0;LOf(b,g,d);i=e;return}function HTe(a){a=a|0;var b=0;b=i;FTe(a);i=b;return c[a+12>>2]|0}function ITe(a){a=a|0;var b=0;b=i;FTe(a);i=b;return c[a+12>>2]|0}function JTe(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=(zTe(b)|0)&1;RI(2601984)|0;b=pL(2601984,d)|0;i=c;return b|0}function KTe(a){a=a|0;var b=0,d=0,e=0;b=i;Dhh();d=c[a>>2]|0;if(!d){RI(3112928)|0;e=qL(3112928)|0;kwg(e,0);Psh(e)}if((c[d+48>>2]|0)==(c[a+8>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888308]|0);Psh(b)}}function LTe(a,b){a=a|0;b=b|0;var d=0,e=0;d=b+12|0;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function MTe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)MTe(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function NTe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function OTe(a,b){a=a|0;b=b|0;return 0}function PTe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)PTe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function QTe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function RTe(a,b,d){a=a|0;b=b|0;d=d|0;d=a;c[d>>2]=0;c[d+4>>2]=0;return}function STe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=c[b+44>>2]|0;if(g)STe(f,g,d,e);Dn[c[b+8>>2]&511](a,c[b+16>>2]|0,d,e);i=f;return}function TTe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function UTe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=3264928;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;return}function VTe(a){a=a|0;var b=0,c=0;b=i;c=DTe(a+8|0)|0;i=b;return c|0}function WTe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;f=b+8|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];RI(2112640)|0;xrh(a,2734240,pL(2112640,e)|0);i=d;return}function XTe(a){a=a|0;return c[a+20>>2]|0}function YTe(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;a[e>>0]=(c[b+24>>2]&255)<<24>>24!=0&1;RI(2601984)|0;b=pL(2601984,e)|0;i=d;return b|0}function ZTe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;yrh(c,2135376,a);RI(2729368)|0;a=pL(2729368,c)|0;i=b;return a|0}function _Te(a){a=a|0;return}function $Te(a){a=a|0;var b=0;a=i;RI(2139296)|0;b=qL(2139296)|0;RI(2139464)|0;c[c[534889]>>2]=b;i=a;return}function aUe(a){a=a|0;return}function bUe(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(2601984)|0;e=Zsh(2139632,b,(a[(Ysh(c,2601984)|0)>>0]|0)!=0)|0;i=d;return e|0}function cUe(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(2601984)|0;f=(a[(Ysh(c,2601984)|0)>>0]|0)!=0;RI(2601984)|0;c=Ush(2139688,b,f,(a[(Ysh(d,2601984)|0)>>0]|0)!=0)|0;i=e;return c|0}function dUe(b){b=b|0;b=i;RI(2139464)|0;if((a[2139612]|0)==0?(RI(2139464)|0,(a[2139612]|0)==0):0)lM(2139464);RI(2139464)|0;i=b;return c[c[534889]>>2]|0}function eUe(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+1|0;e=b;f=c&1;a[d>>0]=f;a[e>>0]=f;RI(2601984)|0;if(!(pL(2601984,e)|0)){g=0;i=b;return g|0}RI(2601984)|0;g=Aqh(2536720,pL(2601984,d)|0)|0;i=b;return g|0}function fUe(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+3|0;f=b+2|0;g=b+1|0;h=b;j=c&1;a[e>>0]=j;a[f>>0]=j;RI(2601984)|0;j=d&1;if(!(pL(2601984,f)|0)){a[g>>0]=j;RI(2601984)|0;k=(pL(2601984,g)|0)==0;i=b;return k|0}else{a[h>>0]=j;RI(2601984)|0;j=pL(2601984,h)|0;RI(2601984)|0;k=nrh(2536048,pL(2601984,e)|0,j)|0;i=b;return k|0}return 0}function gUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function hUe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;iUe(c,a);RI(2273904)|0;a=pL(2273904,c)|0;i=b;return a|0}function iUe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);_sh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;__g(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function jUe(a){a=a|0;c[a+4>>2]=-2;return}function kUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function lUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function mUe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=nUe(a)|0;RI(2274184)|0;a=pL(2274184,d)|0;i=b;return a|0}function nUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=h$g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function oUe(a){a=a|0;c[a+4>>2]=-2;return}function pUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function qUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function rUe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=sUe(a)|0;RI(2276200)|0;a=pL(2276200,d)|0;i=b;return a|0}function sUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=q$g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function tUe(a){a=a|0;c[a+4>>2]=-2;return}function uUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function vUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function wUe(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=xUe(a)|0;RI(2279080)|0;a=pL(2279080,d)|0;i=c;return a|0}function xUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_sh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=z$g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function yUe(a){a=a|0;c[a+4>>2]=-2;return}function zUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function AUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function BUe(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=CUe(a)|0;RI(2280424)|0;a=pL(2280424,d)|0;i=c;return a|0}function CUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=I$g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function DUe(a){a=a|0;c[a+4>>2]=-2;return}function EUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function FUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function GUe(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=HUe(a)|0;RI(2280960)|0;a=pL(2280960,d)|0;i=c;return a|0}function HUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=R$g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function IUe(a){a=a|0;c[a+4>>2]=-2;return}function JUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function KUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function LUe(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=MUe(a)|0;RI(2284056)|0;a=pL(2284056,d)|0;i=c;return a|0}function MUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_sh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=_$g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function NUe(a){a=a|0;c[a+4>>2]=-2;return}function OUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function PUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function QUe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+12|0;e=b;RUe(d,a);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];RI(2324976)|0;d=pL(2324976,e)|0;i=b;return d|0}function RUe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Kgh();e=b+4|0;f=c[e>>2]|0;if((f|0)==-2){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[887012]|0);_sh(g)}else if((f|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else{f=c[b>>2]|0;b=PCf(f)|0;h0g(a,f,b+-1-(c[e>>2]|0)|0);i=d;return}}function SUe(a){a=a|0;c[a+4>>2]=-2;return}function TUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function UUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function VUe(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=WUe(b)|0;RI(2557392)|0;b=pL(2557392,d)|0;i=c;return b|0}function WUe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=q0g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function XUe(a){a=a|0;c[a+4>>2]=-2;return}function YUe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function ZUe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function _Ue(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=$Ue(a)|0;RI(2331416)|0;a=pL(2331416,d)|0;i=b;return a|0}function $Ue(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=z0g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function aVe(a){a=a|0;c[a+4>>2]=-2;return}function bVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function cVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function dVe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=eVe(a)|0;RI(2331968)|0;a=pL(2331968,d)|0;i=b;return a|0}function eVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_sh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=I0g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function fVe(a){a=a|0;c[a+4>>2]=-2;return}function gVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function hVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function iVe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=jVe(a)|0;RI(2333648)|0;a=pL(2333648,d)|0;i=b;return a|0}function jVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);_sh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=R0g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function kVe(a){a=a|0;c[a+4>>2]=-2;return}function lVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function mVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function nVe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=oVe(a)|0;a=d;c[a>>2]=e;c[a+4>>2]=H;RI(2548816)|0;a=pL(2548816,d)|0;i=b;return a|0}function oVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);_sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);_sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=_0g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function pVe(a){a=a|0;c[a+4>>2]=-2;return}function qVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function rVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function sVe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=tVe(a)|0;RI(2551640)|0;a=pL(2551640,d)|0;i=b;return a|0}function tVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);$sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);$sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=h1g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function uVe(a){a=a|0;c[a+4>>2]=-2;return}function vVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function wVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function xVe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=yVe(a)|0;a=d;c[a>>2]=e;c[a+4>>2]=H;RI(2554736)|0;a=pL(2554736,d)|0;i=b;return a|0}function yVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);$sh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);$sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=q1g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function zVe(a){a=a|0;c[a+4>>2]=-2;return}function AVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function BVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function CVe(b){b=b|0;var c=0,d=0;c=i;i=i+16|0;d=c;a[d>>0]=DVe(b)|0;RI(2560032)|0;b=pL(2560032,d)|0;i=c;return b|0}function DVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887012]|0);$sh(f)}else if((e|0)==-1){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887014]|0);$sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=z1g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function EVe(a){a=a|0;c[a+4>>2]=-2;return}function FVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function GVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function HVe(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=IVe(a)|0;RI(2562664)|0;a=pL(2562664,d)|0;i=c;return a|0}function IVe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);$sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);$sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;f=I1g(e,a+-1-(c[d>>2]|0)|0)|0;i=b;return f|0}return 0}function JVe(a){a=a|0;c[a+4>>2]=-2;return}function KVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function LVe(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function MVe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;h[c>>3]=+NVe(a);RI(2589144)|0;a=pL(2589144,c)|0;i=b;return a|0}function NVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;Kgh();d=a+4|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[887014]|0);$sh(f)}else if((e|0)==-2){RI(3084976)|0;e=qL(3084976)|0;osg(e,c[887012]|0);$sh(e)}else{e=c[a>>2]|0;a=PCf(e)|0;g=+R1g(e,a+-1-(c[d>>2]|0)|0);i=b;return +g}return +(0.0)}function OVe(a){a=a|0;c[a+4>>2]=-2;return}function PVe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+4|0;e=c[d>>2]|0;if((e|0)==-2){f=PCf(c[a>>2]|0)|0;c[d>>2]=f;g=f}else g=e;if((g|0)==-1){h=0;i=b;return h|0}c[d>>2]=g+-1;h=(g|0)!=0;i=b;return h|0}function QVe(a){a=a|0;return}function RVe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,69);c[c[d>>2]>>2]=a;i=b;return}function SVe(a,b){a=a|0;b=b|0;return b|0}function TVe(a){a=a|0;return}function UVe(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function VVe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,32767);Dpf(a,1);c[c[d>>2]>>2]=a;i=b;return}function WVe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function XVe(a){a=a|0;var b=0;b=i;YVe(a,0,0);i=b;return}function YVe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;a[b+8>>0]=e&1;if(e){RI(2723776)|0;if(!(a[2723924]|0)){RI(2723776)|0;ath(2723776);g=VNf(0)|0}else g=VNf(0)|0;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;ath(2724880)}h=g;j=cOf(0)|0}else{h=0;j=0}if((d|0)<=10){RI(2245352)|0;g=qL(2245352)|0;e=g+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[g+20>>2]=h;c[b+16>>2]=g;i=f;return}RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;g=qL(2730168)|0;sPf(g,d,j,h);c[b+12>>2]=g;i=f;return}function ZVe(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[a+20>>2]=b;return}function _Ve(a){a=a|0;var b=0,c=0;b=i;c=bth(2245520,a)|0;i=b;return c|0}function $Ve(a){a=a|0;var b=0,d=0;b=c[a+16>>2]|0;if(!b)d=c[a+12>>2]|0;else d=b;return d|0}function aWe(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+16>>2]|0;if(!d)e=c[a+12>>2]|0;else e=d;d=cth(2647352,e)|0;i=b;return d|0}function bWe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a+16|0;g=c[f>>2]|0;if(!g)h=c[a+12>>2]|0;else h=g;dth(2739248,h,b,d);if(!(c[f>>2]|0)){i=e;return}if((Aqh(2245576,a)|0)<11){i=e;return}cWe(a);i=e;return}function cWe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+8|0;if(a[e>>0]|0){RI(2723776)|0;if(!(a[2723924]|0)){RI(2723776)|0;ath(2723776)}f=VNf(0)|0;if(!(a[e>>0]|0)){g=f;h=0}else{RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;ath(2724880)}g=f;h=cOf(0)|0}}else{g=0;h=0}f=b+16|0;e=c[f>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;j=qL(2730168)|0;uPf(j,e,h,g);c[b+12>>2]=j;eth(2245632,c[f>>2]|0);c[f>>2]=0;i=d;return}function dWe(a){a=a|0;return a|0}function eWe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+16>>2]|0;if(!f)g=c[a+12>>2]|0;else g=f;fth(2647488,g,b,d);i=e;return}function fWe(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+16>>2]|0;if(!d)e=c[a+12>>2]|0;else e=d;d=Sqh(2733848,e)|0;i=b;return d|0}function gWe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function hWe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;return}function iWe(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=b;c[a+20>>2]=c[b+12>>2];eth(2247160,a);i=d;return}function jWe(a){a=a|0;var b=0;b=i;mch();if((c[a+20>>2]|0)==(c[(c[a+8>>2]|0)+12>>2]|0)){i=b;return}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[881024]|0);gth(b)}}function kWe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;jWe(b);e=b+16|0;f=c[e>>2]|0;g=a[b+12>>0]|0;do if(!f)if(!(g<<24>>24)){h=0;i=d;return h|0}else{j=b+12|0;k=6;break}else{l=b+12|0;if(!(g<<24>>24)){m=l;n=f+16|0}else{j=l;k=6}}while(0);if((k|0)==6){m=j;n=(c[b+8>>2]|0)+16|0}b=c[n>>2]|0;c[e>>2]=b;a[m>>0]=0;h=(b|0)!=0;i=d;return h|0}function lWe(b){b=b|0;var d=0;d=i;jWe(b);a[b+12>>0]=1;c[b+16>>2]=0;i=d;return}function mWe(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;c=b;yrh(c,2247216,a);RI(2729368)|0;a=pL(2729368,c)|0;i=b;return a|0}function nWe(a){a=a|0;var b=0,d=0;b=i;lch();jWe(a);d=c[a+16>>2]|0;if(!d){RI(3084976)|0;a=qL(3084976)|0;osg(a,c[880974]|0);gth(a)}else{i=b;return d|0}return 0}function oWe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(nWe(b)|0)+8>>2]|0;f=c[(c[b+16>>2]|0)+12>>2]|0;b=a;c[b>>2]=0;c[b+4>>2]=0;LOf(a,e,f);i=d;return}function pWe(a){a=a|0;var b=0,d=0;b=i;d=c[(nWe(a)|0)+8>>2]|0;i=b;return d|0}function qWe(a){a=a|0;var b=0,d=0;b=i;d=c[(nWe(a)|0)+12>>2]|0;i=b;return d|0}function rWe(a){a=a|0;var b=0;b=a+8|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;return}function sWe(a){a=a|0;var b=0,c=0;b=i;RI(2247280)|0;c=qL(2247280)|0;iWe(c,a);i=b;return c|0}function tWe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;jch();if(!b){RI(2963920)|0;f=qL(2963920)|0;uig(f,c[880882]|0,c[880884]|0);gth(f)}f=c[a+16>>2]|0;c[d>>2]=0;g=a+20|0;a=c[g>>2]|0;h=(f|0)==0;if(!a){if(h){j=0;i=e;return j|0}k=f;while(1){if(nrh(2536048,b,c[k+8>>2]|0)|0){j=k;l=12;break}c[d>>2]=k;k=c[k+16>>2]|0;if(!k){j=0;l=12;break}}if((l|0)==12){i=e;return j|0}}else{if(h){j=0;i=e;return j|0}else{m=a;n=f}while(1){if(!(hth(2734520,m,b,c[n+8>>2]|0)|0)){j=n;l=12;break}c[d>>2]=n;f=c[n+16>>2]|0;if(!f){j=0;l=12;break}m=c[g>>2]|0;n=f}if((l|0)==12){i=e;return j|0}}return 0}function uWe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(!e){g=a+16|0;h=c[g>>2]|0;RI(2246760)|0;j=qL(2246760)|0;c[j+8>>2]=b;c[j+12>>2]=d;c[j+16>>2]=h;c[g>>2]=j}else{j=e+16|0;e=c[j>>2]|0;RI(2246760)|0;g=qL(2246760)|0;c[g+8>>2]=b;c[g+12>>2]=d;c[g+16>>2]=e;c[j>>2]=g}g=a+8|0;c[g>>2]=(c[g>>2]|0)+1;g=a+12|0;c[g>>2]=(c[g>>2]|0)+1;i=f;return}function vWe(a){a=a|0;return c[a+8>>2]|0}function wWe(a){a=a|0;return a|0}function xWe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;kch();if(!b){RI(2963920)|0;g=qL(2963920)|0;uig(g,c[880906]|0,c[880908]|0);gth(g)}if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[880910]|0,c[880912]|0);gth(g)}if((PCf(b)|0)<(d|0)){RI(3084024)|0;g=qL(3084024)|0;isg(g,c[880914]|0);gth(g)}g=Aqh(2248208,a)|0;if((g|0)>((PCf(b)|0)-d|0)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[880916]|0);gth(g)}g=bth(2248264,a)|0;a=d;while(1){if(!(jth(2568176,g)|0))break;d=Sqh(2568120,g)|0;RI(2729368)|0;h=ith(d,2729368)|0;d=c[h+4>>2]|0;j=f;c[j>>2]=c[h>>2];c[j+4>>2]=d;RI(2729368)|0;bEf(b,pL(2729368,f)|0,a);a=a+1|0}RI(2568648)|0;a=vL(g,2568648)|0;if(!a)if(174==174){i=e;return}else gth(0);else{kth(2568816,a);if(174==174){i=e;return}else gth(0)}}function yWe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=0;g=tWe(a,b,f)|0;if(!g){uWe(a,b,d,c[f>>2]|0);i=e;return}else{c[g+12>>2]=d;i=e;return}}function zWe(a){a=a|0;var b=0;c[a+16>>2]=0;c[a+8>>2]=0;b=a+12|0;c[b>>2]=(c[b>>2]|0)+1;return}function AWe(a){a=a|0;var b=0,c=0;b=i;RI(2247280)|0;c=qL(2247280)|0;iWe(c,a);i=b;return c|0}function BWe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function CWe(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=b;eth(2249696,a);i=d;return}function DWe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;f=a+8|0;a=(e|0)>=(Aqh(2249752,c[f>>2]|0)|0);e=c[d>>2]|0;if(a&(e|0)>-1){RI(3084976)|0;a=qL(3084976)|0;nsg(a);gth(a)}else{a=EWe(c[f>>2]|0,e)|0;i=b;return a|0}return 0}function EWe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Krh(2713112,c[a+16>>2]|0,b)|0;RI(2249256)|0;b=c[(lth(e,2249256)|0)+8>>2]|0;i=d;return b|0}function FWe(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+12|0;e=(c[d>>2]|0)+1|0;c[d>>2]=e;d=(e|0)<(Aqh(2249752,c[a+8>>2]|0)|0);i=b;return d|0}function GWe(a){a=a|0;c[a+12>>2]=-1;return}function HWe(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function IWe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;och();f=c[(c[a+8>>2]|0)+16>>2]|0;if(!b){RI(2963920)|0;a=qL(2963920)|0;Iag(a,c[881126]|0);gth(a)}if((d|0)<=-1){RI(2964880)|0;a=qL(2964880)|0;wdg(a,c[881128]|0);gth(a)}if((PCf(b)|0)>=1?(PCf(b)|0)<=(d|0):0){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[881130]|0);gth(a)}a=Aqh(2713056,f)|0;if((a+d|0)>(PCf(b)|0)){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[881132]|0);gth(a)}if((sDf(b)|0)>=2){RI(2965048)|0;a=qL(2965048)|0;Rbg(a,c[881134]|0);gth(a)}RI(1086352)|0;a=lth(b,1086352)|0;if((Aqh(2713056,f)|0)<=0){i=e;return}b=a+16|0;g=d;d=0;while(1){h=Krh(2713112,f,d)|0;RI(2249256)|0;j=c[(lth(h,2249256)|0)+8>>2]|0;Qqh(a,j);c[b+(da(c[(c[a>>2]|0)+120>>2]|0,g)|0)>>2]=j;d=d+1|0;if((d|0)>=(Aqh(2713056,f)|0))break;else g=g+1|0}i=e;return}function JWe(a){a=a|0;return c[a+8>>2]|0}function KWe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2249752,c[a+8>>2]|0)|0;i=b;return d|0}function LWe(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;RI(2249824)|0;a=qL(2249824)|0;CWe(a,d);i=b;return a|0}function MWe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function NWe(b){b=b|0;var d=0;d=i;a[b+32>>0]=0;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;ath(2724880)}c[b+20>>2]=cOf(0)|0;RI(2723776)|0;if(!(a[2723924]|0)){RI(2723776)|0;ath(2723776)}c[b+24>>2]=VNf(0)|0;c[b+28>>2]=0;OWe(b);i=d;return}function OWe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+40>>2]|0;f=c[b+28>>2]|0;if(!e){g=c[b+20>>2]|0;h=c[b+24>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;j=qL(2730168)|0;sPf(j,f,g,h);c[b+8>>2]=j}else{RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;j=qL(2730168)|0;wPf(j,f,e);c[b+8>>2]=j}RI(2713640)|0;if(a[2713788]|0){RI(2713640)|0;k=qL(2713640)|0;$Lf(k);l=b+16|0;c[l>>2]=k;m=b+12|0;c[m>>2]=0;i=d;return}RI(2713640)|0;ath(2713640);RI(2713640)|0;k=qL(2713640)|0;$Lf(k);l=b+16|0;c[l>>2]=k;m=b+12|0;c[m>>2]=0;i=d;return}function PWe(a){a=a|0;return a|0}function QWe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;fth(2647488,mth(2251040,a)|0,b,c);i=d;return}function RWe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+36|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}RI(2250360)|0;e=qL(2250360)|0;c[e+8>>2]=a;c[d>>2]=e;f=e;i=b;return f|0}function SWe(a){a=a|0;var b=0,c=0;b=i;RI(2249824)|0;c=qL(2249824)|0;CWe(c,a);i=b;return c|0}function TWe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+48|0;f=e;g=e+16|0;h=e+28|0;j=e+4|0;k=e+32|0;l=e+36|0;m=e+12|0;n=e+24|0;o=e+20|0;p=e+8|0;nch();if(!d){RI(2963920)|0;q=qL(2963920)|0;Iag(q,c[881068]|0);gth(q)}q=Aqh(2249752,b)|0;RI(1094176)|0;r=nth(1094176,q)|0;RI(1086352)|0;s=nth(1086352,q)|0;t=bth(2714784,c[b+16>>2]|0)|0;u=r+16|0;v=s+16|0;w=0;while(1){if(!(jth(2568176,t)|0))break;x=Sqh(2568120,t)|0;RI(2249256)|0;y=lth(x,2249256)|0;x=c[y+8>>2]|0;Qqh(r,x);c[u+(da(c[(c[r>>2]|0)+120>>2]|0,w)|0)>>2]=x;x=c[y+12>>2]|0;Qqh(s,x);c[v+(da(c[(c[s>>2]|0)+120>>2]|0,w)|0)>>2]=x;w=w+1|0}RI(2568648)|0;w=vL(t,2568648)|0;if(!w){if(135!=135)gth(0)}else{kth(2568816,w);if(135!=135)gth(0)}w=c[b+40>>2]|0;if(!w){t=c[b+20>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[k>>2]=3437160;c[f+0>>2]=c[k+0>>2];k=npf(0,f)|0;q9f(d,c[881074]|0,t,k);k=c[b+24>>2]|0;c[l>>2]=3437032;c[f+0>>2]=c[l+0>>2];l=npf(0,f)|0;q9f(d,c[881076]|0,k,l);c[m>>2]=2;RI(2540224)|0;l=pL(2540224,m)|0;c[n>>2]=3431160;c[f+0>>2]=c[n+0>>2];n=npf(0,f)|0;q9f(d,c[881078]|0,l,n)}else{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[g>>2]=3437136;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[881070]|0,w,g);c[h>>2]=4;RI(2540224)|0;g=pL(2540224,h)|0;c[j>>2]=3431160;c[f+0>>2]=c[j+0>>2];j=npf(0,f)|0;q9f(d,c[881072]|0,g,j)}fag(d,c[881080]|0,(a[b+32>>0]|0)!=0);r9f(d,c[881082]|0,q);RI(2540728)|0;if(a[2540876]|0){c[o>>2]=3432016;c[f+0>>2]=c[o+0>>2];z=npf(0,f)|0;A=c[881084]|0;q9f(d,A,r,z);c[p>>2]=3434168;c[f+0>>2]=c[p+0>>2];B=npf(0,f)|0;C=c[881086]|0;q9f(d,C,s,B);i=e;return}RI(2540728)|0;ath(2540728);c[o>>2]=3432016;c[f+0>>2]=c[o+0>>2];z=npf(0,f)|0;A=c[881084]|0;q9f(d,A,r,z);c[p>>2]=3434168;c[f+0>>2]=c[p+0>>2];B=npf(0,f)|0;C=c[881086]|0;q9f(d,C,s,B);i=e;return}function UWe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2713056,c[a+16>>2]|0)|0;i=b;return d|0}function VWe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Krh(2713112,c[a+16>>2]|0,b)|0;RI(2249256)|0;b=c[(lth(e,2249256)|0)+12>>2]|0;i=d;return b|0}function WWe(a){a=a|0;var b=0;b=i;NWe(a);i=b;return}function XWe(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=VWe(a,b)|0;RI(2713640)|0;b=YWe(0,lth(d,2713640)|0)|0;i=c;return b|0}function YWe(c,d){c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;i=i+16|0;e=c;if(!d){f=0;i=c;return f|0}g=Aqh(2713056,d)|0;if(!g){f=0;i=c;return f|0}else if((g|0)==2){h=Krh(2713112,d,0)|0;b[e>>1]=44;RI(2540392)|0;j=pL(2540392,e)|0;e=Krh(2713112,d,1)|0;if(!(a[2540708]|0))ath(2540560);k=lth(h,2540560)|0;f=hwf(0,k,j,lth(e,2540560)|0)|0;i=c;return f|0}else if((g|0)==1){f=lth(Krh(2713112,d,0)|0,2540560)|0;i=c;return f|0}else{if((g|0)>0){e=g;j=0;while(1){k=(Vof(lth(Krh(2713112,d,j)|0,2540560)|0)|0)+e|0;j=j+1|0;if((j|0)==(g|0)){l=k;break}else e=k}}else l=g;e=Krh(2713112,d,0)|0;RI(2971904)|0;j=qL(2971904)|0;Veg(j,lth(e,2540560)|0,l);if((g|0)>1){l=1;do{acg(j,44)|0;ifg(j,Krh(2713112,d,l)|0)|0;l=l+1|0}while((l|0)!=(g|0))}f=Fqh(2972072,j)|0;i=c;return f|0}return 0}function ZWe(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=EWe(a,b)|0;i=c;return d|0}function _We(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function $We(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function aXe(a){a=a|0;return c[a+8>>2]|0}function bXe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2252944)|0;if(!(vL(b,2252944)|0)){e=0;i=d;return e|0}if((a|0)==(b|0)){e=1;i=d;return e|0}RI(2252944)|0;f=c[(lth(b,2252944)|0)+8>>2]|0;e=(f|0)==(c[a+8>>2]|0);i=d;return e|0}function cXe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=c[a+8>>2];RI(2253112)|0;a=Aqh(2614936,pL(2253112,d)|0)|0;i=b;return a|0}function dXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,6140);c[c[d>>2]>>2]=a;i=b;return}function eXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function fXe(b){b=b|0;var d=0;d=i;if(!(a[2540708]|0))ath(2540560);c[b+8>>2]=c[c[635163]>>2];i=d;return}function gXe(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=Fqh(2652904,b)|0;i=d;return}function hXe(a){a=a|0;var b=0;a=i;RI(2254280)|0;b=qL(2254280)|0;fXe(b);RI(2254280)|0;c[c[563593]>>2]=b;i=a;return}function iXe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2254280)|0;if(!(vL(d,2254280)|0)){f=0;i=e;return f|0}RI(2254280)|0;g=c[(lth(d,2254280)|0)+8>>2]|0;d=c[b+8>>2]|0;if(!(a[2540708]|0))ath(2540560);f=gpf(0,g,d)|0;i=e;return f|0}function jXe(a){a=a|0;return c[a+8>>2]|0}function kXe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2582544,c[a+8>>2]|0)|0;i=b;return d|0}function lXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,32767);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function mXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function nXe(a){a=a|0;return}function oXe(b,d){b=b|0;d=d|0;var e=0;e=i;pch();c[b+40>>2]=1;c[b+44>>2]=c[881220];c[b+52>>2]=1e5;c[b+12>>2]=1;c[b+16>>2]=d;RI(2258168)|0;if(!(a[2258316]|0)){RI(2258168)|0;ath(2258168)}RI(2258168)|0;d=qL(2258168)|0;NWe(d);c[b+20>>2]=d;i=e;return}function pXe(a){a=a|0;c[a+12>>2]=1;return}function qXe(a){a=a|0;var b=0;b=i;NWe(a);i=b;return}function rXe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];oth(2258336,a,b,f);i=e;return}function sXe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;qch();l=c[b+20>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[g>>2]=3437480;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[881226]|0,l,g);g=c[b+48>>2]|0;c[h>>2]=3437504;c[f+0>>2]=c[h+0>>2];h=npf(0,f)|0;q9f(d,c[881228]|0,g,h);h=c[b+16>>2]|0;c[j>>2]=3437536;c[f+0>>2]=c[j+0>>2];j=npf(0,f)|0;q9f(d,c[881230]|0,h,j);L7f(d,c[881232]|0,c[b+24>>2]|0);L7f(d,c[881234]|0,c[b+44>>2]|0);j=b+32|0;iag(d,c[881236]|0,c[j>>2]|0,c[j+4>>2]|0);r9f(d,c[881238]|0,c[b+52>>2]|0);c[k>>2]=c[b+40>>2];RI(2781760)|0;b=pL(2781760,k)|0;L7f(d,c[881240]|0,b);fag(d,c[881242]|0,0);i=e;return}function tXe(a){a=a|0;return}function uXe(a,b){a=a|0;b=b|0;var c=0;a=i;RI(2258392)|0;c=qL(2258392)|0;oXe(c,b);i=a;return c|0}function vXe(a){a=a|0;return}function wXe(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2259688)|0;if(!(a[2259836]|0)){RI(2259688)|0;ath(2259688)}RI(2259688)|0;d=qL(2259688)|0;xXe(d,c);i=b;return d|0}function xXe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;rch();c[b+24>>2]=1e5;c[b+28>>2]=3e5;a[b+32>>0]=1;a[b+33>>0]=1;c[b+36>>2]=c[881296];RI(2536312)|0;c[b+40>>2]=qL(2536312)|0;RI(2259688)|0;if(!(a[2259836]|0)){RI(2259688)|0;ath(2259688)}RI(2259688)|0;if(!(c[(c[564945]|0)+4>>2]|0)){RI(2260296)|0;f=qL(2260296)|0;c[f+8>>2]=c[565061];c[f+20>>2]=2260240;c[f+16>>2]=0;RI(2259688)|0;if(!(a[2259836]|0)){RI(2259688)|0;ath(2259688)}RI(2259688)|0;c[(c[564945]|0)+4>>2]=f}RI(2259688)|0;if(a[2259836]|0){RI(2259688)|0;g=c[564945]|0;h=g+4|0;j=c[h>>2]|0;k=b+44|0;c[k>>2]=j;l=b+12|0;c[l>>2]=1;m=b+16|0;c[m>>2]=d;n=zXe(0)|0;o=b+20|0;c[o>>2]=n;i=e;return}RI(2259688)|0;ath(2259688);RI(2259688)|0;g=c[564945]|0;h=g+4|0;j=c[h>>2]|0;k=b+44|0;c[k>>2]=j;l=b+12|0;c[l>>2]=1;m=b+16|0;c[m>>2]=d;n=zXe(0)|0;o=b+20|0;c[o>>2]=n;i=e;return}function yXe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function zXe(b){b=b|0;var c=0;b=i;RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}c=FXe(0)|0;i=b;return c|0}function AXe(a){a=a|0;var b=0,d=0;a=i;sch();RI(1094176)|0;b=nth(1094176,13)|0;Qqh(b,c[881302]|0);d=b+16|0;c[d>>2]=c[881302];Qqh(b,c[881304]|0);c[d+(c[(c[b>>2]|0)+120>>2]|0)>>2]=c[881304];Qqh(b,c[881306]|0);c[d+(c[(c[b>>2]|0)+120>>2]<<1)>>2]=c[881306];Qqh(b,c[881308]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*3|0)>>2]=c[881308];Qqh(b,c[881310]|0);c[d+(c[(c[b>>2]|0)+120>>2]<<2)>>2]=c[881310];Qqh(b,c[881312]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*5|0)>>2]=c[881312];Qqh(b,c[881314]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*6|0)>>2]=c[881314];Qqh(b,c[881316]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*7|0)>>2]=c[881316];Qqh(b,c[881318]|0);c[d+(c[(c[b>>2]|0)+120>>2]<<3)>>2]=c[881318];Qqh(b,c[881320]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*9|0)>>2]=c[881320];Qqh(b,c[881322]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*10|0)>>2]=c[881322];Qqh(b,c[881324]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*11|0)>>2]=c[881324];Qqh(b,c[881326]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*12|0)>>2]=c[881326];RI(2259688)|0;c[c[564945]>>2]=b;i=a;return}function BXe(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+16|0;h=b;tch();RI(2260464)|0;if(!(a[2260612]|0)){RI(2260464)|0;ath(2260464)}if(CXe(0)|0){RI(2260464)|0;if(!(a[2260612]|0)){RI(2260464)|0;ath(2260464)}j=pth(2260632,CXe(0)|0,d,e,f,g)|0;i=b;return j|0}if(!g){j=1;i=b;return j|0}c[h>>2]=g;RI(2255576)|0;g=pL(2255576,h)|0;if(!(a[2540708]|0))ath(2540560);h=fwf(0,c[881356]|0,g)|0;RI(3084976)|0;g=qL(3084976)|0;osg(g,h);gth(g);return 0}function CXe(b){b=b|0;b=i;RI(2260464)|0;if(!(a[2260612]|0)){RI(2260464)|0;ath(2260464)}RI(2260464)|0;i=b;return c[(c[565139]|0)+32>>2]|0}function DXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function EXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function FXe(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}RI(2259080)|0;if(!(a[(c[564793]|0)+4>>0]|0)){RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}RI(2259080)|0;d=c[(c[564793]|0)+12>>2]|0;Jag(0,d);RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}RI(2259080)|0;if(!(c[(c[564793]|0)+8>>2]|0)){RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}RI(2259080)|0;c[(c[564793]|0)+8>>2]=0}Kag(0,d)}RI(2259080)|0;if(a[2259228]|0){RI(2259080)|0;e=c[564793]|0;f=e+8|0;g=c[f>>2]|0;i=b;return g|0}RI(2259080)|0;ath(2259080);RI(2259080)|0;e=c[564793]|0;f=e+8|0;g=c[f>>2]|0;i=b;return g|0}function GXe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2261648)|0);c[c[d>>2]>>2]=a;i=b;return}function HXe(a){a=a|0;return}function IXe(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2261768)|0;if(!(a[2261916]|0)){RI(2261768)|0;ath(2261768)}RI(2261768)|0;d=qL(2261768)|0;JXe(d,c);i=b;return d|0}function JXe(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;uch();a[b+24>>0]=1;a[b+25>>0]=1;f=b+40|0;c[f>>2]=-1;c[f+4>>2]=-1;RI(2258168)|0;if(!(a[2258316]|0)){RI(2258168)|0;ath(2258168)}RI(2258168)|0;f=qL(2258168)|0;NWe(f);a[f+44>>0]=1;c[b+48>>2]=f;a[b+52>>0]=1;c[b+56>>2]=50;if(!(a[2540708]|0))ath(2540560);c[b+60>>2]=c[c[635163]>>2];c[b+64>>2]=c[881374];c[b+68>>2]=c[881376];a[b+72>>0]=1;RI(2262320)|0;if(!(a[2262468]|0)){RI(2262320)|0;ath(2262320)}RI(2262320)|0;c[b+76>>2]=c[(c[565603]|0)+4>>2];c[b+88>>2]=1e5;RI(2536312)|0;c[b+96>>2]=qL(2536312)|0;c[b+100>>2]=3e5;c[b+12>>2]=1;c[b+16>>2]=d;c[b+20>>2]=d;c[b+80>>2]=zXe(0)|0;i=e;return}function KXe(a){a=a|0;var b=0;a=i;RI(3129672)|0;b=qL(3129672)|0;myg(b,1,0);RI(2262320)|0;c[c[565603]>>2]=b;RI(3129672)|0;b=qL(3129672)|0;myg(b,1,1);RI(2262320)|0;c[(c[565603]|0)+4>>2]=b;i=a;return}function LXe(b,c){b=b|0;c=c|0;var d=0;d=i;NWe(b);a[b+44>>0]=c&1;i=d;return}function MXe(a){a=a|0;a=i;RI(2261768)|0;c[c[565465]>>2]=65536;i=a;return}function NXe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];oth(2262688,a,b,f);i=e;return}function OXe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+8|0;g=e+16|0;h=e+20|0;j=e+24|0;k=e+4|0;l=e;m=e+12|0;vch();n=c[b+16>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[g>>2]=3437536;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[881380]|0,n,g);g=c[b+20>>2]|0;c[h>>2]=3437536;c[f+0>>2]=c[h+0>>2];h=npf(0,f)|0;q9f(d,c[881382]|0,g,h);fag(d,c[881384]|0,(a[b+24>>0]|0)!=0);fag(d,c[881386]|0,(a[b+25>>0]|0)!=0);h=c[b+28>>2]|0;c[j>>2]=3437856;c[f+0>>2]=c[j+0>>2];j=npf(0,f)|0;q9f(d,c[881388]|0,h,j);L7f(d,c[881390]|0,c[b+32>>2]|0);j=b+40|0;iag(d,c[881392]|0,c[j>>2]|0,c[j+4>>2]|0);j=c[b+48>>2]|0;c[k>>2]=3437480;c[f+0>>2]=c[k+0>>2];k=npf(0,f)|0;q9f(d,c[881394]|0,j,k);fag(d,c[881396]|0,(a[b+52>>0]|0)!=0);r9f(d,c[881398]|0,c[b+56>>2]|0);L7f(d,c[881400]|0,c[b+60>>2]|0);L7f(d,c[881402]|0,c[b+64>>2]|0);L7f(d,c[881404]|0,c[b+68>>2]|0);fag(d,c[881406]|0,(a[b+72>>0]|0)!=0);k=c[b+76>>2]|0;c[l>>2]=3437816;c[f+0>>2]=c[l+0>>2];l=npf(0,f)|0;q9f(d,c[881408]|0,k,l);l=c[b+80>>2]|0;c[m>>2]=3437504;c[f+0>>2]=c[m+0>>2];m=npf(0,f)|0;q9f(d,c[881410]|0,l,m);fag(d,c[881412]|0,(a[b+84>>0]|0)!=0);r9f(d,c[881414]|0,c[b+88>>2]|0);r9f(d,c[881416]|0,c[b+92>>2]|0);i=e;return}function PXe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;c[a+16>>2]=2;return}function QXe(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;j=d+20|0;c[j>>2]=e;k=e;e=0;while(1){RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}l=k+16|0;m=RXe(0,b[l+(da(c[(c[k>>2]|0)+120>>2]|0,e)|0)>>1]|0)|0;b[l+(da(c[(c[k>>2]|0)+120>>2]|0,e)|0)>>1]=m;m=e+1|0;if((m|0)==8)break;k=c[j>>2]|0;e=m}c[d+16>>2]=23;e=d+24|0;c[e>>2]=f;c[e+4>>2]=g;i=h;return}function RXe(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;ath(3007432)}RI(3007432)|0;if(!(a[(c[751881]|0)+1>>0]|0)){e=d;i=b;return e|0}RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}f=d<<16>>16;e=(f>>>8&255|f<<8)&65535;i=b;return e|0}function SXe(a){a=a|0;var b=0,d=0;a=i;xch();RI(2264136)|0;b=qL(2264136)|0;d=b+8|0;c[d>>2]=0;c[d+4>>2]=0;c[b+16>>2]=2;RI(2264136)|0;c[c[566057]>>2]=b;b=TXe(0,c[881562]|0)|0;RI(2264136)|0;c[(c[566057]|0)+4>>2]=b;b=TXe(0,c[881564]|0)|0;RI(2264136)|0;c[(c[566057]|0)+8>>2]=b;b=TXe(0,c[881566]|0)|0;RI(2264136)|0;c[(c[566057]|0)+12>>2]=b;b=UXe(0,c[881568]|0)|0;RI(2264136)|0;c[(c[566057]|0)+16>>2]=b;b=UXe(0,c[881570]|0)|0;RI(2264136)|0;c[(c[566057]|0)+20>>2]=b;b=UXe(0,c[881572]|0)|0;RI(2264136)|0;c[(c[566057]|0)+24>>2]=b;i=a;return}function TXe(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;c[e>>2]=0;ych();RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}if(XXe(0,d,e)|0){i=b;return c[e>>2]|0}else{RI(3079480)|0;e=qL(3079480)|0;Hrg(e,c[881594]|0);gth(e)}return 0}function UXe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b;c[e>>2]=0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}if(!($Xe(0,d,e)|0)){f=0;i=b;return f|0}d=c[e>>2]|0;e=c[d+8>>2]|0;g=d+16|0;d=c[g>>2]|0;h=c[g+4>>2]|0;RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}RI(2264136)|0;g=qL(2264136)|0;QXe(g,e,d,h);f=g;i=b;return f|0}function VXe(a,b){a=a|0;b=b|0;a=b<<16>>16;return (a>>>8&255|a<<8)&65535|0}function WXe(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;ath(3007432)}RI(3007432)|0;if(!(a[(c[751881]|0)+1>>0]|0)){e=d;i=b;return e|0}RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}f=d<<16>>16;e=(f>>>8&255|f<<8)&65535;i=b;return e|0}function XXe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;zch();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[881616]|0);gth(f)}RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}f=YXe(0,d)|0;c[e>>2]=f;if(!f){RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}f=UXe(0,d)|0;c[e>>2]=f;if(!f){g=0;i=b;return g|0}}g=1;i=b;return g|0}function YXe(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0;d=i;i=i+16|0;f=d;g=f;c[g>>2]=0;c[g+4>>2]=0;g=Cvf(e,32)|0;if((g|0)==-1)h=e;else{j=gvf(e,g+1|0)|0;RI(1136088)|0;k=nth(1136088,1)|0;b[k+16>>1]=46;l=dvf(j,k)|0;k=c[l+12>>2]|0;a:do if((k|0)>=1){j=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,k+-1|0)|0)>>2]|0;if(!(Vof(j)|0)){m=0;i=d;return m|0}n=$uf(j)|0;j=n+12|0;if((c[j>>2]|0)>0){o=n+16|0;p=0;while(1){q=b[o+(da(c[(c[n>>2]|0)+120>>2]|0,p)|0)>>1]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}p=p+1|0;if(!(ZXe(0,q)|0)){m=0;break}if((p|0)>=(c[j>>2]|0))break a}i=d;return m|0}}while(0);h=fpf(e,0,g)|0}if(!(Vof(h)|0)){m=0;i=d;return m|0}if((Wof(h,(Vof(h)|0)+-1|0)|0)<<16>>16==46){m=0;i=d;return m|0}RI(1136088)|0;g=nth(1136088,1)|0;b[g+16>>1]=46;e=dvf(h,g)|0;g=e+12|0;h=c[g>>2]|0;if((h|0)>=5){m=0;i=d;return m|0}k=f;c[k>>2]=0;c[k+4>>2]=0;b:do if((h|0)>0){k=e+16|0;l=0;j=0;p=0;c:while(1){n=c[k+(da(c[(c[e>>2]|0)+120>>2]|0,p)|0)>>2]|0;do if(((Vof(n)|0)>=3?(Vof(n)|0)<=4:0)?(Wof(n,0)|0)<<16>>16==48:0){if((Wof(n,1)|0)<<16>>16!=120?(Wof(n,1)|0)<<16>>16!=88:0){r=27;break}o=(Vof(n)|0)==3;q=Wof(n,2)|0;RI(2264304)|0;s=(a[2264452]|0)==0;if(o){if(s){RI(2264304)|0;ath(2264304)}o=f;c[o>>2]=(_Xe(0,q)|0)&255;c[o+4>>2]=0;break}else{if(s){RI(2264304)|0;ath(2264304)}s=_Xe(0,q)|0;q=f;c[q>>2]=(_Xe(0,Wof(n,3)|0)|0|s<<4)&255;c[q+4>>2]=0;break}}else r=27;while(0);d:do if((r|0)==27){r=0;if(!(Vof(n)|0)){m=0;r=45;break c}if((Wof(n,0)|0)<<16>>16!=48)if(gqf(0,n,0,0,f)|0)break;else{m=0;r=45;break c}q=f;c[q>>2]=0;c[q+4>>2]=0;q=1;while(1){if((q|0)>=(Vof(n)|0))break d;if(((Wof(n,q)|0)&65535)<48){m=0;r=45;break c}if(((Wof(n,q)|0)&65535)>55){m=0;r=45;break c}s=Wof(n,q)|0;o=f;t=cFi(c[o>>2]|0,c[o+4>>2]|0,3)|0;o=H;u=_Ei(s&65535|0,0,-48,-1)|0;s=_Ei(u|0,H|0,t|0,o|0)|0;o=f;c[o>>2]=s;c[o+4>>2]=H;q=q+1|0}}while(0);n=c[g>>2]|0;q=f;o=c[q>>2]|0;s=c[q+4>>2]|0;if((p|0)!=(n+-1|0))if((s|0)<0|(s|0)==0&o>>>0<256)v=p;else{m=0;r=45;break}else v=3;if((s|0)>0|(s|0)==0&o>>>0>0){q=o;o=l;t=j;u=s;s=0;while(1){w=cFi(q&255|0,0,v-s<<3&56|0)|0;x=w|o;w=H|t;y=eFi(q|0,u|0,256,0)|0;z=H;if((u|0)>0|(u|0)==0&q>>>0>255){q=y;o=x;t=w;u=z;s=s+1|0}else{A=y;B=z;C=x;D=w;break}}s=f;c[s>>2]=A;c[s+4>>2]=B;E=C;F=D}else{E=l;F=j}p=v+1|0;if((p|0)>=(n|0)){G=E;I=F;break b}else{l=E;j=F}}if((r|0)==45){i=d;return m|0}}else{G=0;I=0}while(0);RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}RI(2264136)|0;r=qL(2264136)|0;F=r+8|0;c[F>>2]=G;c[F+4>>2]=I;c[r+16>>2]=2;m=r;i=d;return m|0}function ZXe(a,b){a=a|0;b=b|0;a=i;if((b+-48<<16>>16&65535)<10|(b+-97<<16>>16&65535)<6){i=a;return 1}else{i=a;return (b+-65<<16>>16&65535)<6|0}return 0}function _Xe(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;kdh();d=b&65535;if((b+-48<<16>>16&65535)<=9){e=d+65488&65535;i=a;return e|0}if((b+-97<<16>>16&65535)<=5){e=(d+65439&65535)+10|0;i=a;return e|0}if((b+-65<<16>>16&65535)>5){RI(2965048)|0;b=qL(2965048)|0;Rbg(b,c[882800]|0);gth(b)}e=(d+65471&65535)+10|0;i=a;return e|0}function $Xe(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;g=d+8|0;h=d+4|0;j=d;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;Gch();c[f>>2]=0;if(!e){k=0;i=d;return k|0}if(((Vof(e)|0)>=3?(Wof(e,0)|0)<<16>>16==91:0)?(Wof(e,(Vof(e)|0)+-1|0)|0)<<16>>16==93:0)l=fpf(e,1,(Vof(e)|0)+-2|0)|0;else l=e;if((Vof(l)|0)<=1){k=0;i=d;return k|0}c[g>>2]=0;c[h>>2]=0;e=Kvf(l,47)|0;do if((e|0)==-1){m=Kvf(l,37)|0;if((m|0)==-1)n=l;else{o=gvf(l,m+1|0)|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}if(!(rYe(0,o,h)|0))c[h>>2]=0;n=fpf(l,0,m)|0}}else{m=gvf(l,e+1|0)|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}if(!(rYe(0,m,g)|0)){c[g>>2]=-1;k=0;i=d;return k|0}if((c[g>>2]|0)>>>0<129){n=fpf(l,0,e)|0;break}else{k=0;i=d;return k|0}}while(0);RI(1150432)|0;e=nth(1150432,8)|0;l=Kvf(n,58)|0;if((l|0)==-1){k=0;i=d;return k|0}do if((l|0)<((Vof(n)|0)+-1|0)?(m=l+1|0,o=gvf(n,m)|0,(Cvf(o,46)|0)!=-1):0){RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}if(!(XXe(0,o,j)|0)){k=0;i=d;return k|0}o=(c[j>>2]|0)+8|0;p=c[o>>2]|0;q=c[o+4>>2]|0;o=VEi(p|0,q|0,8)|0;r=e+16|0;b[r+((c[(c[e>>2]|0)+120>>2]|0)*6|0)>>1]=o&255|p<<8;s=VEi(p|0,q|0,24)|0;b[r+((c[(c[e>>2]|0)+120>>2]|0)*7|0)>>1]=o&65280|s&255;if((l|0)>=1?(Wof(n,l+-1|0)|0)<<16>>16==58:0){t=fpf(n,0,m)|0;u=0;v=2;break}t=fpf(n,0,l)|0;u=0;v=2}else{t=n;u=1;v=0}while(0);n=Fvf(t,c[881678]|0)|0;if((n|0)==-1){RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}if((qYe(0,e,t)|0)!=(8-v|0)){k=0;i=d;return k|0}}else{l=gvf(t,n+2|0)|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}j=qYe(0,e,l)|0;l=j+v|0;if(!((j|0)!=-1&(l|0)<9)){k=0;i=d;return k|0}if((j|0)>0){m=e+16|0;s=(v^7)-j|0;o=j;do{j=o;o=o+-1|0;r=c[(c[e>>2]|0)+120>>2]|0;b[m+(da(r,s+j|0)|0)>>1]=b[m+(da(r,o)|0)>>1]|0;b[m+(da(c[(c[e>>2]|0)+120>>2]|0,o)|0)>>1]=0}while((o|0)>0)}o=fpf(t,0,n)|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}n=qYe(0,e,o)|0;if(!((n|0)!=-1&(l+n|0)<8)){k=0;i=d;return k|0}}if(!v)w=0;else{n=e+16|0;l=c[(c[e>>2]|0)+120>>2]|0;o=0;t=0;while(1){m=o|(b[n+(da(l,t)|0)>>1]|0)!=0;t=t+1|0;if((t|0)>=(v|0)){w=m;break}else o=m}}if(!(u|w)){w=e+16|0;u=c[(c[e>>2]|0)+120>>2]|0;o=0;do{if(b[w+(da(u,o)|0)>>1]|0){k=0;x=54;break}o=o+1|0}while((o|0)<5);if((x|0)==54){i=d;return k|0}x=b[w+(u*5|0)>>1]|0;if(!(x<<16>>16==-1|x<<16>>16==0)){k=0;i=d;return k|0}}RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}RI(2264472)|0;x=qL(2264472)|0;u=c[h>>2]|0;mYe(x,e,c[g>>2]|0);g=x+16|0;c[g>>2]=u;c[g+4>>2]=((u|0)<0)<<31>>31;c[f>>2]=x;k=1;i=d;return k|0}function aYe(a){a=a|0;return c[a+8>>2]|0}function bYe(a){a=a|0;var b=0,d=0;b=i;d=a+16|0;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function cYe(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function dYe(a){a=a|0;var b=0,d=0;b=i;wch();if((c[a+16>>2]|0)==23){d=a+24|0;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}else{RI(2589312)|0;d=qL(2589312)|0;Vxf(d,c[881520]|0);gth(d)}return 0}function eYe(a){a=a|0;return c[a+16>>2]|0}function fYe(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((c[d+16>>2]|0)==2){f=d+8|0;g=c[f>>2]|0;h=c[f+4>>2]|0;RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}j=gYe(0,g,h)|0;i=e;return j|0}h=bth(2628880,c[d+20>>2]|0)|0;RI(1150432)|0;g=vL(h,1150432)|0;h=g+12|0;if((c[h>>2]|0)>0){f=g+16|0;k=0;do{RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}l=WXe(0,b[f+(da(c[(c[g>>2]|0)+120>>2]|0,k)|0)>>1]|0)|0;b[f+(da(c[(c[g>>2]|0)+120>>2]|0,k)|0)>>1]=l;k=k+1|0}while((k|0)<(c[h>>2]|0))}RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}RI(2264472)|0;h=qL(2264472)|0;hYe(h,g);g=dYe(d)|0;d=h+16|0;c[d>>2]=g;c[d+4>>2]=H;j=Fqh(2264640,h)|0;i=e;return j|0}function gYe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=g;c[k>>2]=0;c[k+4>>2]=0;k=h;c[k>>2]=0;c[k+4>>2]=0;k=j;c[k>>2]=0;c[k+4>>2]=0;Ach();RI(1094176)|0;k=nth(1094176,7)|0;l=f;c[l>>2]=d&255;c[l+4>>2]=0;l=hqf(f)|0;Qqh(k,l);f=k+16|0;c[f>>2]=l;Qqh(k,c[881624]|0);c[f+(c[(c[k>>2]|0)+120>>2]|0)>>2]=c[881624];l=VEi(d|0,e|0,8)|0;m=g;c[m>>2]=l&255;c[m+4>>2]=0;m=hqf(g)|0;Qqh(k,m);c[f+(c[(c[k>>2]|0)+120>>2]<<1)>>2]=m;Qqh(k,c[881626]|0);c[f+((c[(c[k>>2]|0)+120>>2]|0)*3|0)>>2]=c[881626];m=VEi(d|0,e|0,16)|0;g=h;c[g>>2]=m&255;c[g+4>>2]=0;g=hqf(h)|0;Qqh(k,g);c[f+(c[(c[k>>2]|0)+120>>2]<<2)>>2]=g;Qqh(k,c[881628]|0);c[f+((c[(c[k>>2]|0)+120>>2]|0)*5|0)>>2]=c[881628];g=VEi(d|0,e|0,24)|0;e=j;c[e>>2]=g&255;c[e+4>>2]=0;e=hqf(j)|0;Qqh(k,e);c[f+((c[(c[k>>2]|0)+120>>2]|0)*6|0)>>2]=e;if(a[2540708]|0){n=lwf(0,k)|0;i=b;return n|0}ath(2540560);n=lwf(0,k)|0;i=b;return n|0}function hYe(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Bch();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[881632]|0);gth(e)}if((c[b+12>>2]|0)==8){c[a+8>>2]=b;i=d;return}else{RI(2965048)|0;d=qL(2965048)|0;Rbg(d,c[881634]|0);gth(d)}}function iYe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+16|0;c[e>>2]=b;c[e+4>>2]=d;return}function jYe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;RI(2264136)|0;f=vL(d,2264136)|0;if(!f){g=0;i=e;return g|0}d=c[a+16>>2]|0;if((d|0)!=(c[f+16>>2]|0)){g=0;i=e;return g|0}if((d|0)==2){d=a+8|0;h=f+8|0;g=(c[d>>2]|0)==(c[h>>2]|0)?(c[d+4>>2]|0)==(c[h+4>>2]|0):0;i=e;return g|0}h=c[f+20>>2]|0;f=c[a+20>>2]|0;a=f+16|0;d=c[(c[f>>2]|0)+120>>2]|0;f=h+16|0;j=c[(c[h>>2]|0)+120>>2]|0;h=0;while(1){k=b[a+(da(d,h)|0)>>1]|0;if(k<<16>>16!=(b[f+(da(j,h)|0)>>1]|0)){g=0;l=8;break}h=h+1|0;if((h|0)>=8){g=1;l=8;break}}if((l|0)==8){i=e;return g|0}return 0}function kYe(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0;d=i;if((c[b+16>>2]|0)==2){f=c[b+8>>2]|0;i=d;return f|0}g=c[b+20>>2]|0;RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}b=g+16|0;h=c[(c[g>>2]|0)+120>>2]|0;g=e[b+(h<<1)>>1]<<16;j=e[b+(h*5|0)>>1]|0;k=e[b+(h*6|0)>>1]<<16;f=((g|e[b+(h*3|0)>>1])<<13|g>>19)^(e[b+h>>1]|e[b>>1]<<16)^((e[b+(h<<2)>>1]<<16|j)>>6|j<<26)^((k|e[b+(h*7|0)>>1])<<7|k>>25);i=d;return f|0}function lYe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return (c<<13|c>>19)^b^(d<<26|d>>6)^(e<<7|e>>25)|0}function mYe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Cch();hYe(a,b);if(d>>>0<129){c[a+12>>2]=d;i=e;return}else{RI(2965048)|0;e=qL(2965048)|0;Rbg(e,c[881640]|0);gth(e)}}function nYe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;mYe(a,b,d);d=a+16|0;c[d>>2]=e;c[d+4>>2]=((e|0)<0)<<31>>31;i=f;return}function oYe(a){a=a|0;var b=0;a=i;Dch();b=pYe(0,c[881650]|0)|0;RI(2264472)|0;c[c[566141]>>2]=b;b=pYe(0,c[881652]|0)|0;RI(2264472)|0;c[(c[566141]|0)+4>>2]=b;i=a;return}function pYe(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;i=i+16|0;e=b;c[e>>2]=0;Ech();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[881656]|0);gth(f)}RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}if($Xe(0,d,e)|0){i=b;return c[e>>2]|0}else{RI(3079480)|0;e=qL(3079480)|0;Hrg(e,c[881658]|0);gth(e)}return 0}function qYe(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;Fch();if(!(Vof(e)|0)){f=0;i=a;return f|0}if((Fvf(e,c[881674]|0)|0)!=-1){f=-1;i=a;return f|0}do if((Vof(e)|0)>0){g=d+16|0;h=0;j=0;k=0;a:while(1){l=Wof(e,k)|0;m=l&65535;if(l<<16>>16!=58){do if((l+-48<<16>>16&65535)>9){if((l+-97<<16>>16&65535)<=5){n=(m+65439&65535)+10|0;break}if((l+-65<<16>>16&65535)>5){f=-1;o=18;break a}n=(m+65471&65535)+10|0}else n=m+65488&65535;while(0);m=n+(h<<4)|0;if((m|0)<65536){p=m;q=j}else{f=-1;o=18;break}}else{if((k|0)==((Vof(e)|0)+-1|0)|(j|0)==8){f=-1;o=18;break}b[g+(da(c[(c[d>>2]|0)+120>>2]|0,j)|0)>>1]=h;p=0;q=j+1|0}k=k+1|0;if((k|0)>=(Vof(e)|0)){r=p;s=q;o=16;break}else{h=p;j=q}}if((o|0)==16){if((s|0)==8)f=-1;else{t=r;u=s;break}i=a;return f|0}else if((o|0)==18){i=a;return f|0}}else{t=0;u=0}while(0);b[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,u)|0)>>1]=t;f=u+1|0;i=a;return f|0}function rYe(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}e=rpf(0,c,7,eKf(0)|0,d)|0;i=b;return e|0}function sYe(a,b){a=a|0;b=b|0;return ((b&65535)>>>8&65535|(b&65535)<<8)&65535|0}function tYe(d){d=d|0;var e=0,f=0,g=0;e=i;f=d+8|0;d=c[f>>2]|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}g=b[d+16+((c[(c[d>>2]|0)+120>>2]|0)*7|0)>>1]|0;d=c[f>>2]|0;f=b[d+16+((c[(c[d>>2]|0)+120>>2]|0)*6|0)>>1]|0;i=e;return (f&65535)>>>8&65535|((g&65535)<<8&65280|(g&65535)>>>8&65535)<<16|(f&65535)<<8&65280|0}function uYe(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a+8>>2]|0;f=e+16|0;g=c[(c[e>>2]|0)+120>>2]|0;e=0;do{if(b[f+(da(g,e)|0)>>1]|0){h=0;j=5;break}e=e+1|0}while((e|0)<6);if((j|0)==5){i=d;return h|0}h=(tYe(a)|0)>1;i=d;return h|0}function vYe(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+8>>2]|0;a=e+16|0;f=c[(c[e>>2]|0)+120>>2]|0;e=0;do{if(b[a+(da(f,e)|0)>>1]|0){g=0;h=5;break}e=e+1|0}while((e|0)<5);if((h|0)==5){i=d;return g|0}g=(b[a+(f*5|0)>>1]|0)==-1;i=d;return g|0}function wYe(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+16|0;f=e;Hch();RI(2971904)|0;g=qL(2971904)|0;Gbg(g);if(!(uYe(d)|0)?!(vYe(d)|0):0){h=d+8|0;j=c[h>>2]|0;k=j+16|0;l=c[(c[j>>2]|0)+120>>2]|0;j=-1;m=0;n=0;o=0;while(1){if(!(b[k+(da(l,o)|0)>>1]|0)){p=j;q=m;r=n+1|0}else{s=(n|0)<=(m|0)|(n|0)<2;p=s?j:o-n|0;q=s?m:n;r=0}o=o+1|0;if((o|0)==8){t=p;u=q;v=r;break}else{j=p;m=q;n=r}}r=(v|0)<=(u|0)|(v|0)<2;n=r?t:8-v|0;if(!n)Hbg(g,c[881686]|0)|0;t=(r?u:v)+-1|0;v=0;do{if((v|0)!=(n|0)){u=c[h>>2]|0;b[f>>1]=b[u+16+(da(c[(c[u>>2]|0)+120>>2]|0,v)|0)>>1]|0;RI(2565248)|0;u=pL(2565248,f)|0;qcg(g,c[881690]|0,u)|0;if((v|0)>6)w=v;else{acg(g,58)|0;w=v}}else{Hbg(g,c[881688]|0)|0;w=t+n|0}v=w+1|0}while((v|0)<8);v=d+16|0;w=v;if(!((c[w>>2]|0)==0&(c[w+4>>2]|0)==0)){w=acg(g,37)|0;n=v;hfg(w,c[n>>2]|0,c[n+4>>2]|0)|0}x=Fqh(2972072,g)|0;i=e;return x|0}Hbg(g,c[881682]|0)|0;if(vYe(d)|0)Hbg(g,c[881684]|0)|0;n=tYe(d)|0;RI(2264136)|0;if(!(a[2264284]|0)){RI(2264136)|0;ath(2264136)}RI(2264136)|0;d=qL(2264136)|0;w=d+8|0;c[w>>2]=n;c[w+4>>2]=((n|0)<0)<<31>>31;c[d+16>>2]=2;Hbg(g,Fqh(2266144,d)|0)|0;x=Fqh(2972072,g)|0;i=e;return x|0}function xYe(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e+2|0;g=e;Ich();if(!d){h=Fqh(2264640,a)|0;i=e;return h|0}RI(2971904)|0;d=qL(2971904)|0;Gbg(d);j=a+8|0;a=c[j>>2]|0;k=(c[a+12>>2]|0)+-1|0;l=a+16|0;m=c[(c[a>>2]|0)+120>>2]|0;if((k|0)>0){a=m;n=l;o=0;while(1){b[f>>1]=b[n+(da(a,o)|0)>>1]|0;RI(2565248)|0;p=pL(2565248,f)|0;qcg(d,c[881702]|0,p)|0;o=o+1|0;p=c[j>>2]|0;q=(c[p+12>>2]|0)+-1|0;r=p+16|0;s=c[(c[p>>2]|0)+120>>2]|0;if((o|0)>=(q|0)){t=q;u=r;v=s;break}else{a=s;n=r}}}else{t=k;u=l;v=m}b[g>>1]=b[u+(da(v,t)|0)>>1]|0;RI(2565248)|0;t=pL(2565248,g)|0;qcg(d,c[881704]|0,t)|0;h=Fqh(2972072,d)|0;i=e;return h|0}function yYe(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;RI(2264472)|0;g=vL(d,2264472)|0;if(g){h=c[a+8>>2]|0;j=c[g+8>>2]|0;g=h+16|0;k=c[(c[h>>2]|0)+120>>2]|0;h=j+16|0;l=c[(c[j>>2]|0)+120>>2]|0;j=0;while(1){m=b[g+(da(k,j)|0)>>1]|0;if(m<<16>>16!=(b[h+(da(l,j)|0)>>1]|0)){n=0;o=12;break}j=j+1|0;if((j|0)>=8){n=1;o=12;break}}if((o|0)==12){i=f;return n|0}}RI(2264136)|0;j=vL(d,2264136)|0;if(!j){n=0;i=f;return n|0}d=c[a+8>>2]|0;a=d+16|0;l=c[(c[d>>2]|0)+120>>2]|0;d=0;do{if(b[a+(da(l,d)|0)>>1]|0){n=0;o=12;break}d=d+1|0}while((d|0)<5);if((o|0)==12){i=f;return n|0}o=b[a+(l*5|0)>>1]|0;if(!(o<<16>>16==-1|o<<16>>16==0)){n=0;i=f;return n|0}o=j+8|0;j=c[o>>2]|0;d=c[o+4>>2]|0;o=e[a+(l*6|0)>>1]|0;h=VEi(j|0,d|0,8)|0;if((o|0)==(j<<8&65280|h&255|0)){o=e[a+(l*7|0)>>1]|0;l=VEi(j|0,d|0,24)|0;i=f;return (o|0)==(h&65280|l&255|0)|0}else{n=0;i=f;return n|0}return 0}function zYe(b){b=b|0;var d=0,f=0,g=0,h=0,j=0;d=i;f=c[b+8>>2]|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}b=f+16|0;g=c[(c[f>>2]|0)+120>>2]|0;f=e[b+(g<<1)>>1]<<16;h=e[b+(g*5|0)>>1]|0;j=e[b+(g*6|0)>>1]<<16;i=d;return ((f|e[b+(g*3|0)>>1])<<13|f>>19)^(e[b+g>>1]|e[b>>1]<<16)^((e[b+(g<<2)>>1]<<16|h)>>6|h<<26)^((j|e[b+(g*7|0)>>1])<<7|j>>25)|0}function AYe(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return (c<<13|c>>19)^b^(d<<26|d>>6)^(e<<7|e>>25)|0}function BYe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function CYe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function DYe(b){b=b|0;var d=0;b=i;RI(2245704)|0;d=qL(2245704)|0;XVe(d);RI(2260464)|0;c[c[565139]>>2]=d;RI(2257840)|0;d=qL(2257840)|0;RI(2260464)|0;c[(c[565139]|0)+4>>2]=d;RI(2260464)|0;c[(c[565139]|0)+8>>2]=2;RI(2260464)|0;c[(c[565139]|0)+12>>2]=9e5;RI(2260464)|0;c[(c[565139]|0)+16>>2]=0;RI(2260464)|0;a[(c[565139]|0)+20>>0]=0;RI(2260464)|0;c[(c[565139]|0)+24>>2]=240;RI(2260464)|0;a[(c[565139]|0)+28>>0]=1;i=b;return}function EYe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+48|0;d=b;e=b+4|0;f=b+21|0;g=b+8|0;h=b+35|0;j=b+10|0;k=b+11|0;l=b+9|0;m=b+12|0;n=b+14|0;o=b+15|0;p=b+16|0;q=b+17|0;r=b+18|0;s=b+19|0;t=b+20|0;u=b+13|0;v=b+22|0;w=b+23|0;x=b+24|0;y=b+25|0;z=b+26|0;A=b+27|0;B=b+28|0;C=b+29|0;D=b+30|0;E=b+31|0;F=b+32|0;G=b+33|0;H=b+34|0;I=b+36|0;J=b+37|0;K=b+38|0;L=b+39|0;M=b+40|0;N=b+41|0;O=b+42|0;P=b+43|0;Q=b+44|0;R=b+45|0;Jch();RI(1153040)|0;S=nth(1153040,126)|0;c[e>>2]=2269984;c[d+0>>2]=c[e+0>>2];Guf(0,S,d);RI(2258168)|0;c[(c[564565]|0)+12>>2]=S;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;ath(2724880)}S=cOf(0)|0;RI(2723776)|0;if(!(a[2723924]|0)){RI(2723776)|0;ath(2723776)}d=VNf(0)|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;e=qL(2730168)|0;vPf(e,S,d);RI(2258168)|0;c[c[564565]>>2]=e;a[f>>0]=1;RI(2601984)|0;e=pL(2601984,f)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881716]|0,e);a[g>>0]=1;RI(2601984)|0;e=pL(2601984,g)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881718]|0,e);a[h>>0]=1;RI(2601984)|0;e=pL(2601984,h)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881720]|0,e);a[j>>0]=1;RI(2601984)|0;e=pL(2601984,j)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881722]|0,e);a[k>>0]=1;RI(2601984)|0;e=pL(2601984,k)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881724]|0,e);a[l>>0]=1;RI(2601984)|0;e=pL(2601984,l)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881726]|0,e);a[m>>0]=1;RI(2601984)|0;e=pL(2601984,m)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881728]|0,e);a[n>>0]=1;RI(2601984)|0;e=pL(2601984,n)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881730]|0,e);a[o>>0]=1;RI(2601984)|0;e=pL(2601984,o)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881732]|0,e);a[p>>0]=1;RI(2601984)|0;e=pL(2601984,p)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881734]|0,e);a[q>>0]=1;RI(2601984)|0;e=pL(2601984,q)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881736]|0,e);a[r>>0]=1;RI(2601984)|0;e=pL(2601984,r)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881738]|0,e);a[s>>0]=1;RI(2601984)|0;e=pL(2601984,s)|0;RI(2258168)|0;Rrh(2734016,c[c[564565]>>2]|0,c[881740]|0,e);RI(3117120)|0;if(!(a[3117268]|0)){RI(3117120)|0;ath(3117120)}e=Nwg(0)|0;RI(2112024)|0;s=qL(2112024)|0;kSe(s,e);RI(2258168)|0;c[(c[564565]|0)+8>>2]=s;RI(2258168)|0;Rsh(2111912,c[(c[564565]|0)+8>>2]|0,c[881742]|0,1);RI(2258168)|0;Rsh(2111912,c[(c[564565]|0)+8>>2]|0,c[881744]|0,1);RI(2258168)|0;Rsh(2111912,c[(c[564565]|0)+8>>2]|0,c[881746]|0,1);s=cOf(0)|0;e=VNf(0)|0;RI(2730168)|0;r=qL(2730168)|0;vPf(r,s,e);RI(2258168)|0;c[(c[564565]|0)+4>>2]=r;a[t>>0]=1;RI(2601984)|0;r=pL(2601984,t)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881748]|0,r);a[u>>0]=1;RI(2601984)|0;r=pL(2601984,u)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881750]|0,r);a[v>>0]=1;RI(2601984)|0;r=pL(2601984,v)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881752]|0,r);a[w>>0]=1;RI(2601984)|0;r=pL(2601984,w)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881754]|0,r);a[x>>0]=1;RI(2601984)|0;r=pL(2601984,x)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881756]|0,r);a[y>>0]=1;RI(2601984)|0;r=pL(2601984,y)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881758]|0,r);a[z>>0]=1;RI(2601984)|0;r=pL(2601984,z)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881760]|0,r);a[A>>0]=1;RI(2601984)|0;r=pL(2601984,A)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881762]|0,r);a[B>>0]=1;RI(2601984)|0;r=pL(2601984,B)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881764]|0,r);a[C>>0]=1;RI(2601984)|0;r=pL(2601984,C)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881766]|0,r);a[D>>0]=1;RI(2601984)|0;r=pL(2601984,D)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881768]|0,r);a[E>>0]=1;RI(2601984)|0;r=pL(2601984,E)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881770]|0,r);a[F>>0]=1;RI(2601984)|0;r=pL(2601984,F)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881772]|0,r);a[G>>0]=1;RI(2601984)|0;r=pL(2601984,G)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881774]|0,r);a[H>>0]=1;RI(2601984)|0;r=pL(2601984,H)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881776]|0,r);a[I>>0]=1;RI(2601984)|0;r=pL(2601984,I)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881778]|0,r);a[J>>0]=1;RI(2601984)|0;r=pL(2601984,J)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881780]|0,r);a[K>>0]=1;RI(2601984)|0;r=pL(2601984,K)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881782]|0,r);a[L>>0]=1;RI(2601984)|0;r=pL(2601984,L)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881784]|0,r);a[M>>0]=1;RI(2601984)|0;r=pL(2601984,M)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881786]|0,r);a[N>>0]=1;RI(2601984)|0;r=pL(2601984,N)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881788]|0,r);a[O>>0]=1;RI(2601984)|0;r=pL(2601984,O)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881790]|0,r);a[P>>0]=1;RI(2601984)|0;r=pL(2601984,P)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881792]|0,r);a[Q>>0]=1;RI(2601984)|0;r=pL(2601984,Q)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881794]|0,r);a[R>>0]=1;RI(2601984)|0;r=pL(2601984,R)|0;RI(2258168)|0;Rrh(2734016,c[(c[564565]|0)+4>>2]|0,c[881796]|0,r);i=b;return}function FYe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];oth(2270008,a,b,f);i=e;return}function GYe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;Kch();RI(2971904)|0;d=qL(2971904)|0;Gbg(d);e=UWe(a)|0;if((e|0)>0){f=0;do{g=Hbg(d,qth(2270064,a,f)|0)|0;h=Hbg(g,c[882026]|0)|0;g=Hbg(h,qth(2270120,a,f)|0)|0;Hbg(g,c[882028]|0)|0;f=f+1|0}while((f|0)!=(e|0))}e=Fqh(2972072,Hbg(d,c[882030]|0)|0)|0;i=b;return e|0}function HYe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=0;Lch();g=UWe(a)|0;r9f(b,c[882036]|0,g);c[e>>2]=0;if((g|0)<=0){i=d;return}do{h=spf(e)|0;L7f(b,h,qth(2270064,a,c[e>>2]|0)|0);c[f>>2]=(c[e>>2]|0)+g;h=spf(f)|0;L7f(b,h,qth(2270120,a,c[e>>2]|0)|0);h=(c[e>>2]|0)+1|0;c[e>>2]=h}while((h|0)<(g|0));i=d;return}function IYe(a){a=a|0;var b=0,c=0;b=i;c=UWe(a)|0;i=b;return c|0}function JYe(a){a=a|0;var b=0,c=0;b=i;c=RWe(a)|0;i=b;return c|0}function KYe(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XWe(a,b)|0;i=c;return d|0}function LYe(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=EWe(a,b)|0;i=c;return d|0}function MYe(a){a=a|0;var b=0,c=0;b=i;c=SWe(a)|0;i=b;return c|0}function NYe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function OYe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];oth(2271184,a,b,f);i=e;return}function PYe(b){b=b|0;return (a[b+20>>0]|0)!=0|0}function QYe(b,d,e){b=b|0;d=d|0;e=e|0;e=i;Mch();fag(d,c[882040]|0,(a[b+12>>0]|0)!=0);L7f(d,c[882042]|0,c[b+8>>2]|0);L7f(d,c[882044]|0,c[b+16>>2]|0);fag(d,c[882046]|0,(a[b+20>>0]|0)!=0);i=e;return}function RYe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2244128)|0;c[a+8>>2]=sM(2271752)|0;c[c[d>>2]>>2]=a;i=b;return}function SYe(a){a=a|0;var b=0;a=i;Nch();RI(2245704)|0;b=qL(2245704)|0;XVe(b);RI(2259080)|0;c[c[564793]>>2]=b;RI(2536312)|0;b=qL(2536312)|0;RI(2259080)|0;c[(c[564793]|0)+12>>2]=b;TYe(0,c[882084]|0,c[882086]|0);TYe(0,c[882088]|0,c[882090]|0);TYe(0,c[882092]|0,c[882094]|0);TYe(0,c[882096]|0,c[882098]|0);i=a;return}function TYe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+16|0;f=b+4|0;g=b;Och();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[g>>2]=3437648;c[f+0>>2]=c[g+0>>2];g=rth(2652848,npf(0,f)|0)|0;if(!(a[2540708]|0))ath(2540560);f=sth(2843312,g,gwf(0,c[882144]|0,e)|0)|0;if(!f){i=b;return}RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}VYe(0,d,f);i=b;return}function UYe(a,b,c){a=a|0;b=b|0;c=c|0;RI(3100472)|0;c=qL(3100472)|0;oug(c);gth(c)}function VYe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;b=i;f=Thg(0,e,1)|0;RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}RI(2259080)|0;Rrh(2246248,c[c[564793]>>2]|0,d,f);i=b;return}function WYe(a){a=a|0;var b=0;a=i;Pch();RI(3100016)|0;b=qL(3100016)|0;mug(b,c[882154]|0);i=a;return b|0}function XYe(a){a=a|0;return 0}function YYe(b,c,d){b=b|0;c=c|0;d=d|0;RI(2259080)|0;if(!(a[2259228]|0)){RI(2259080)|0;ath(2259080)}gth(WYe(0)|0)}function ZYe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2244128)|0;c[a+8>>2]=sM(2272936)|0;c[c[d>>2]>>2]=a;i=b;return}function _Ye(a){a=a|0;var b=0,c=0;b=i;c=Aqh(2536720,hOf(a)|0)|0;i=b;return c|0}function $Ye(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function aZe(a){a=a|0;var b=0;a=i;RI(1154432)|0;b=nth(1154432,0)|0;RI(2273592)|0;c[c[568421]>>2]=b;i=a;return}function bZe(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=c[a>>2];c[b+4>>2]=AL(c[a+4>>2]|0)|0;i=d;return}function cZe(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=c[a>>2];c[b+4>>2]=BL(c[a+4>>2]|0)|0;i=d;return}function dZe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;zL(c[d>>2]|0);c[d>>2]=0;i=b;return}function eZe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function fZe(a,b){a=a|0;b=b|0;var c=0;c=i;gZe(a,b,0);i=c;return}function gZe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;Qch();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[882184]|0);gth(g)}RI(2275808)|0;if(!(a[2275956]|0)){RI(2275808)|0;ath(2275808)}hZe(0,e);c[b+28>>2]=d;c[b+32>>2]=e;iZe(b);i=f;return}function hZe(a,b){a=a|0;b=b|0;var d=0;a=i;Sch();if(b&-888){RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[882202]|0);gth(d)}if((b&256|0)==0|(b&-260|0)==0){i=a;return}else{RI(2964880)|0;a=qL(2964880)|0;wdg(a,c[882204]|0);gth(a)}}function iZe(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;RI(2275808)|0;if(!(a[2275956]|0)){RI(2275808)|0;ath(2275808)}e=c[b+28>>2]|0;f=c[b+32>>2]|0;RI(2275808)|0;g=nZe(c[c[568975]>>2]|0,e,f)|0;f=b+8|0;c[f>>2]=g;if(!g){oZe(b);i=d;return}else{c[b+16>>2]=cth(2276368,g)|0;c[b+20>>2]=cth(2276424,c[f>>2]|0)|0;c[b+12>>2]=Sqh(2276480,c[f>>2]|0)|0;c[b+24>>2]=tth(2276536,c[f>>2]|0)|0;i=d;return}}function jZe(a){a=a|0;var b=0;a=i;RI(2275976)|0;b=qL(2275976)|0;kZe(b,15);RI(2275808)|0;c[c[568975]>>2]=b;i=a;return}function kZe(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;c[b+8>>2]=d;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;f=qL(2730168)|0;rPf(f,d);c[b+12>>2]=f;RI(2282680)|0;f=qL(2282680)|0;DZe(f);c[b+16>>2]=f;i=e;return}function lZe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;Rch();k=Fqh(2276144,b)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[g>>2]=3431728;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[882192]|0,k,g);c[h>>2]=c[b+32>>2];RI(2276200)|0;b=pL(2276200,h)|0;c[j>>2]=3438288;c[f+0>>2]=c[j+0>>2];j=npf(0,f)|0;q9f(d,c[882194]|0,b,j);i=e;return}function mZe(a){a=a|0;return c[a+32>>2]|0}function nZe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Jag(0,a);RI(2282136)|0;f=qL(2282136)|0;c[f+8>>2]=b;c[f+12>>2]=d;d=a+12|0;if(nrh(2734296,c[d>>2]|0,f)|0){FZe(c[a+16>>2]|0,f);b=uth(2736488,c[d>>2]|0,f)|0;RI(2281752)|0;f=lth(b,2281752)|0;Kag(0,a);g=f;i=e;return g|0}else{Kag(0,a);g=0;i=e;return g|0}return 0}function oZe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+28|0;f=c[e>>2]|0;g=b+32|0;h=c[g>>2]|0;RI(2275808)|0;if(!(a[2275956]|0)){RI(2275808)|0;ath(2275808)}j=pZe(0,f,h)|0;h=b+8|0;c[h>>2]=j;f=c[e>>2]|0;e=c[g>>2]|0;RI(2275808)|0;qZe(c[c[568975]>>2]|0,f,e,j);c[b+16>>2]=cth(2276368,c[h>>2]|0)|0;c[b+20>>2]=cth(2276424,c[h>>2]|0)|0;c[b+12>>2]=Sqh(2276480,c[h>>2]|0)|0;c[b+24>>2]=tth(2276536,c[h>>2]|0)|0;i=d;return}function pZe(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;RI(2276592)|0;e=qL(2276592)|0;rZe(e);f=sZe(e,c,d)|0;RI(2276760)|0;c=qL(2276760)|0;tZe(c);vth(2276928,f,c,(d&64|0)!=0);d=Sqh(2276984,c)|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;c=qL(2730168)|0;kPf(c);wth(2277040,d,uZe(e,c)|0);xth(2277096,d,c);c=cth(2276368,d)|0;e=Sqh(2276480,d)|0;RI(2275808)|0;if(a[2275956]|0){g=vZe(0,c,e)|0;yth(2277152,d,g);i=b;return d|0}RI(2275808)|0;ath(2275808);g=vZe(0,c,e)|0;yth(2277152,d,g);i=b;return d|0}function qZe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;Jag(0,a);RI(2282136)|0;g=qL(2282136)|0;c[g+8>>2]=b;c[g+12>>2]=d;EZe(a);Rrh(2736568,c[a+12>>2]|0,g,e);FZe(c[a+16>>2]|0,g);Kag(0,a);i=f;return}function rZe(b){b=b|0;var d=0,e=0;d=i;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;ath(2713640)}RI(2713640)|0;e=qL(2713640)|0;$Lf(e);c[b+16>>2]=e;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;e=qL(2730168)|0;kPf(e);c[b+20>>2]=e;i=d;return}function sZe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Vch();c[a+8>>2]=b;c[a+12>>2]=0;eth(2714112,c[a+16>>2]|0);eth(2736744,c[a+20>>2]|0);b=a+24|0;c[b>>2]=0;RI(2306072)|0;f=qL(2306072)|0;R0e(f);g=f+12|0;c[g>>2]=0;D$e(a,f,d,0);E$e(a);c[g>>2]=c[b>>2];i=e;return f|0}function tZe(b){b=b|0;var d=0,e=0;d=i;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;ath(2713640)}RI(2713640)|0;e=qL(2713640)|0;$Lf(e);c[b+8>>2]=e;i=d;return}function uZe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=0;Wch();h=a+16|0;j=Aqh(2713056,c[h>>2]|0)|0;c[f>>2]=0;RI(2540224)|0;k=pL(2540224,f)|0;Rrh(2734016,b,c[882252]|0,k);if((j|0)<=0){l=a+28|0;m=c[l>>2]|0;i=d;return m|0}k=0;while(1){f=Krh(2713112,c[h>>2]|0,k)|0;RI(2306240)|0;n=lth(f,2306240)|0;f=c[n+16>>2]|0;if(!f){c[e>>2]=c[n+12>>2];o=spf(e)|0}else o=f;if(nrh(2734296,b,o)|0){f=uth(2736488,b,o)|0;p=c[n+12>>2]|0;RI(2540224)|0;if((c[(ith(f,2540224)|0)>>2]|0)!=(p|0)){q=6;break}}else{c[g>>2]=c[n+12>>2];RI(2540224)|0;Rrh(2734016,b,o,pL(2540224,g)|0)}k=k+1|0;if((k|0)>=(j|0)){q=10;break}}if((q|0)==6){RI(3079856)|0;j=qL(3079856)|0;Grg(j,c[882254]|0);gth(j)}else if((q|0)==10){l=a+28|0;m=c[l>>2]|0;i=d;return m|0}return 0}function vZe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;RI(1094176)|0;e=nth(1094176,b+1|0)|0;b=Sqh(2733848,d)|0;if(!(jth(2568176,b)|0)){i=a;return e|0}d=e+16|0;do{f=Sqh(2733960,b)|0;g=Sqh(2733904,b)|0;Qqh(e,lth(g,2540560)|0);h=lth(g,2540560)|0;RI(2540224)|0;g=c[(ith(f,2540224)|0)>>2]|0;c[d+(da(c[(c[e>>2]|0)+120>>2]|0,g)|0)>>2]=h}while(jth(2568176,b)|0);i=a;return e|0}function wZe(a){a=a|0;return c[a+28>>2]|0}function xZe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function yZe(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function zZe(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return}function AZe(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2582544,c[a+8>>2]|0)|0;i=b;return c[a+12>>2]^d|0}function BZe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b){e=0;i=d;return e|0}RI(2282136)|0;if(!(vL(b,2282136)|0)){e=0;i=d;return e|0}RI(2282136)|0;f=lth(b,2282136)|0;if((c[a+12>>2]|0)!=(c[f+12>>2]|0)){e=0;i=d;return e|0}e=Prh(2575520,c[a+8>>2]|0,c[f+8>>2]|0)|0;i=d;return e|0}function CZe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;Tch();RI(1086352)|0;f=nth(1086352,5)|0;Qqh(f,c[882208]|0);g=f+16|0;c[g>>2]=c[882208];h=c[b+8>>2]|0;Qqh(f,h);c[g+(c[(c[f>>2]|0)+120>>2]|0)>>2]=h;Qqh(f,c[882210]|0);c[g+(c[(c[f>>2]|0)+120>>2]<<1)>>2]=c[882210];c[e>>2]=c[b+12>>2];RI(2276200)|0;b=pL(2276200,e)|0;Qqh(f,b);c[g+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>2]=b;Qqh(f,c[882212]|0);c[g+(c[(c[f>>2]|0)+120>>2]<<2)>>2]=c[882212];if(a[2540708]|0){j=eqf(0,f)|0;i=d;return j|0}ath(2540560);j=eqf(0,f)|0;i=d;return j|0}function DZe(a){a=a|0;c[a+12>>2]=0;c[a+8>>2]=0;return}function EZe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+12|0;e=Aqh(2732416,c[d>>2]|0)|0;f=a+8|0;g=c[f>>2]|0;if(!((e|0)>=(g|0)&(g|0)>0)){i=b;return}g=a+16|0;do{a=GZe(c[g>>2]|0)|0;if(a){e=c[d>>2]|0;RI(2282136)|0;Irh(2736848,e,lth(a,2282136)|0)}a=Aqh(2732416,c[d>>2]|0)|0;e=c[f>>2]|0}while((a|0)>=(e|0)&(e|0)>0);i=b;return}function FZe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a+8|0;f=c[e>>2]|0;if(!f){RI(2283352)|0;g=qL(2283352)|0;c[g+8>>2]=b;c[a+12>>2]=g;c[e>>2]=g;i=d;return}g=f;while(1){if(nrh(2536048,b,c[g+8>>2]|0)|0){h=g;j=7;break}g=c[g+12>>2]|0;if(!g){j=6;break}}if((j|0)==6){RI(2283352)|0;g=qL(2283352)|0;c[g+8>>2]=b;k=c[e>>2]|0;l=g}else if((j|0)==7){j=c[e>>2]|0;if((h|0)==(j|0)){i=d;return}g=a+12|0;a=h+16|0;b=c[a>>2]|0;if((h|0)==(c[g>>2]|0)){c[g>>2]=b;m=b;n=c[h+12>>2]|0}else{g=c[h+12>>2]|0;c[g+16>>2]=b;m=c[a>>2]|0;n=g}c[m+12>>2]=n;k=j;l=h}c[k+16>>2]=l;c[l+12>>2]=k;c[l+16>>2]=0;c[e>>2]=l;i=d;return}function GZe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+12|0;e=c[d>>2]|0;if(!e){f=0;i=b;return f|0}g=c[e+8>>2]|0;h=c[e+16>>2]|0;c[d>>2]=h;if(!h){c[a+8>>2]=0;f=g;i=b;return f|0}else{c[h+12>>2]=0;f=g;i=b;return f|0}return 0}function HZe(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function IZe(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;f=d+4|0;g=d;Uch();if(Pvf(e,c[882222]|0)|0)h=gvf(e,2)|0;else h=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ath(2540728)}c[g>>2]=3438560;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;if(!(a[2540708]|0))ath(2540560);f=gwf(0,c[882224]|0,h)|0;RI(2610848)|0;if(a[2610996]|0){j=tCf(0,g,f,0)|0;RI(2565248)|0;k=ith(j,2565248)|0;l=b[k>>1]|0;i=d;return l|0}RI(2610848)|0;ath(2610848);j=tCf(0,g,f,0)|0;RI(2565248)|0;k=ith(j,2565248)|0;l=b[k>>1]|0;i=d;return l|0}function JZe(a){a=a|0;return}function KZe(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function LZe(a){a=a|0;var b=0;b=c[a+12>>2]|0;return e[b+16+(c[(c[b>>2]|0)+120>>2]|0)>>1]|0|0}function MZe(a){a=a|0;return c[a+20>>2]|0}function NZe(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function OZe(a){a=a|0;return c[a+8>>2]|0}function PZe(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function QZe(a){a=a|0;return c[a+16>>2]|0}function RZe(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function SZe(a){a=a|0;var b=0;b=i;TZe(a);i=b;return}function TZe(a){a=a|0;var b=0,d=0;b=i;RI(2740648)|0;d=qL(2740648)|0;lQf(d);c[a+8>>2]=d;i=b;return}function UZe(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function VZe(a){a=a|0;return c[a+16>>2]|0}function WZe(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function XZe(a,b){a=a|0;b=b|0;return b-(c[a+12>>2]|0)|0}function YZe(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=a+12|0;a=c[e+4>>2]|0;f=d;c[f>>2]=c[e>>2];c[f+4>>2]=a;RI(2296912)|0;a=pL(2296912,d)|0;i=b;return a|0}function ZZe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2296912)|0;e=ith(b,2296912)|0;b=c[e+4>>2]|0;f=a+12|0;c[f>>2]=c[e>>2];c[f+4>>2]=b;i=d;return}function _Ze(a,b,c){a=a|0;b=b|0;c=c|0;return (c&65280|b&65535)&65535|0}function $Ze(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+8|0;a=Aqh(2713056,c[d>>2]|0)|0;RI(1150432)|0;e=nth(1150432,a)|0;zth(2714616,c[d>>2]|0,e);RI(2295920)|0;d=qL(2295920)|0;c[d+12>>2]=e;i=b;return d|0}function a_e(a){a=a|0;var b=0;b=i;e_e(a,0);i=b;return}function b_e(a,b){a=a|0;b=b|0;var c=0;c=i;h_e(a,b,0);i=c;return}function c_e(a){a=a|0;var b=0;b=i;e_e(a,1);i=b;return}function d_e(a,b){a=a|0;b=b|0;var c=0;c=i;e_e(a,b&65535);e_e(a,b>>>16&65535);i=c;return}function e_e(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+8>>2]|0;b[f>>1]=d;RI(2565248)|0;Erh(2714056,g,pL(2565248,f)|0)|0;i=e;return}function f_e(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;h=d?256:0;if(e)j=(h&65535|512)&65535;else j=h;if(f)k=(j&65535|1024)&65535;else k=j;h_e(b,5,k);if(!e){l=c;e_e(b,l);i=g;return}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}l=suf(0,c)|0;e_e(b,l);i=g;return}function g_e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;a=i;f=b?256:0;if(c)g=(f&65535|512)&65535;else g=f;if(d)h=(g&65535|1024)&65535;else h=g;if(!e){j=h;i=a;return j|0}j=(h&65535|2048)&65535;i=a;return j|0}function h_e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;e_e(a,(c&65280|b&65535)&65535);i=d;return}function i_e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=c?256:0;if(d)g=(f&65535|1024)&65535;else g=f;h_e(a,6,g);e_e(a,b);i=e;return}function j_e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=c?256:0;if(d)g=(f&65535|1024)&65535;else g=f;h_e(a,7,g);e_e(a,b);i=e;return}function k_e(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=d?256:0;if(e)j=(h&65535|512)&65535;else j=h;if(f)k=(j&65535|1024)&65535;else k=j;h_e(a,8,k);e_e(a,b);e_e(a,c);i=g;return}function l_e(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=d?256:0;if(e)j=(h&65535|512)&65535;else j=h;if(f)k=(j&65535|1024)&65535;else k=j;h_e(a,9,k);e_e(a,b);b=(NNf(c)|0)+15>>4;e_e(a,b&65535);if(!b){i=g;return}else{l=b;m=0}while(1){l=l+-1|0;b=m;k=0;j=0;while(1){if((b|0)>=(NNf(c)|0)){n=b;o=k;break}f=b+1|0;if(GNf(c,b)|0)p=(k&65535|1<<j)&65535;else p=k;j=j+1|0;if((j|0)>=16){n=f;o=p;break}else{b=f;k=p}}e_e(a,o);if(!l)break;else m=n}i=g;return}function m_e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c?512:0;if(d)g=(f&65535|1024)&65535;else g=f;h_e(a,3,g);g=Vof(b)|0;e_e(a,g&65535);if(c)h=Vvf(b)|0;else h=b;if((g|0)>0)j=0;else{i=e;return}do{e_e(a,Wof(h,j)|0);j=j+1|0}while((j|0)!=(g|0));i=e;return}function n_e(a,b){a=a|0;b=b|0;var c=0;c=i;e_e(a,2);e_e(a,b);i=c;return}function o_e(a,b){a=a|0;b=b|0;var c=0;c=i;e_e(a,11);e_e(a,b&65535);i=c;return}function p_e(a,b){a=a|0;b=b|0;var c=0;c=i;e_e(a,12);e_e(a,b&65535);i=c;return}function q_e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;r_e(a,e);e_e(a,14);e_e(a,b&65535);e_e(a,c&65535);e_e(a,d&1);s_e(a,e);i=f;return}function r_e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(2297168)|0;e=lth(b,2297168)|0;c[e+12>>2]=I_e(a)|0;i=d;return}function s_e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(2297168)|0;e=lth(b,2297168)|0;c[e+16>>2]=I_e(a)|0;e_e(a,0);M_e(e);i=d;return}function t_e(a){a=a|0;var b=0;b=i;e_e(a,13);i=b;return}function u_e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=c?512:0;if(d)g=(f&65535|1024)&65535;else g=f;h_e(a,4,g);e_e(a,b&65535);i=e;return}function v_e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;r_e(a,c);e_e(a,15);s_e(a,c);e_e(a,b&65535);i=d;return}function w_e(a,b){a=a|0;b=b|0;var c=0;c=i;r_e(a,b);e_e(a,16);s_e(a,b);i=c;return}function x_e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;r_e(a,b);r_e(a,c);e_e(a,17);s_e(a,b);s_e(a,c);i=d;return}function y_e(a,b){a=a|0;b=b|0;var c=0;c=i;r_e(a,b);e_e(a,18);s_e(a,b);i=c;return}function z_e(a,b){a=a|0;b=b|0;var c=0;c=i;r_e(a,b);e_e(a,19);s_e(a,b);i=c;return}function A_e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;r_e(a,e);h_e(a,20,d?2048:0);s_e(a,e);d_e(a,b);d_e(a,c);i=f;return}function B_e(a,b){a=a|0;b=b|0;var c=0;c=i;Ath(2298248,a,b);e_e(a,21);i=c;return}function C_e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;r_e(a,e);h_e(a,22,d?2048:0);s_e(a,e);d_e(a,b);d_e(a,c);i=f;return}function D_e(a,b){a=a|0;b=b|0;var c=0;c=i;r_e(a,b);e_e(a,10);s_e(a,b);i=c;return}function E_e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;r_e(a,d);h_e(a,23,b?1024:0);s_e(a,d);e_e(a,c&65535);i=e;return}function F_e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;e_e(a,24);d_e(a,b);d_e(a,c);d_e(a,d);i=e;return}function G_e(a){a=a|0;var b=0;a=i;RI(2297168)|0;b=qL(2297168)|0;TZe(b);i=a;return b|0}function H_e(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;RI(2297168)|0;g=lth(d,2297168)|0;if(!(J_e(g)|0)){i=e;return}d=a+8|0;h=g+16|0;j=g+12|0;do{k=c[d>>2]|0;l=c[h>>2]|0;m=I_e(a)|0;b[f>>1]=m-(c[j>>2]|0);RI(2565248)|0;Jrh(2713888,k,l,pL(2565248,f)|0)}while(J_e(g)|0);i=e;return}function I_e(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2713056,c[a+8>>2]|0)|0;i=b;return d|0}function J_e(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+8|0;if((Aqh(2741168,c[d>>2]|0)|0)<1){e=0;i=b;return e|0}Irh(2301992,a,bth(2741480,c[d>>2]|0)|0);e=1;i=b;return e|0}function K_e(a){a=a|0;return}function L_e(a){a=a|0;return}function M_e(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;Irh(2741560,d,bth(2301936,a)|0);i=b;return}function N_e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=(d|0)>(e|0);c[b>>2]=f?e:d;c[b+4>>2]=f?d:e;a[b+8>>0]=1;return}function O_e(b,d){b=b|0;d=d|0;c[b+0>>2]=c[580698];c[b+4>>2]=c[580699];c[b+8>>2]=c[580700];c[b>>2]=0;c[b+4>>2]=-1;a[b+8>>0]=1;return}function P_e(b){b=b|0;return (a[b+8>>0]|0)==0|0}function Q_e(b){b=b|0;var d=0,e=0;d=i;if(!(a[b+8>>0]|0)){e=0;i=d;return e|0}e=(c[b>>2]|0)==(c[b+4>>2]|0);i=d;return e|0}function R_e(a){a=a|0;return (c[a>>2]|0)>(c[a+4>>2]|0)|0}function S_e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;e=c[a+4>>2]|0;if((e|0)<(d|0)){f=0;i=b;return f|0}f=1-d+e|0;i=b;return f|0}function T_e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a>>2]|0;f=c[a+4>>2]|0;if((e|0)>(f|0)){i=d;return 1}else{a=c[b>>2]|0;g=c[b+4>>2]|0;i=d;return (a|0)>(g|0)|(e|0)>(g|0)|(a|0)>(f|0)|0}return 0}function U_e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a>>2]|0;f=c[a+4>>2]|0;if((e|0)<=(f|0)?(a=c[b>>2]|0,g=c[b+4>>2]|0,(a|0)<=(g|0)):0)if((e|0)==(g+1|0))h=1;else h=(f|0)==(a+-1|0);else h=0;i=d;return h|0}function V_e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a>>2]|0;f=c[a+4>>2]|0;if((e|0)<=(f|0))if((c[b>>2]|0)<=(c[b+4>>2]|0))if((e|0)>(c[b>>2]|0))g=0;else g=(c[b+4>>2]|0)<=(f|0);else g=1;else g=0;i=d;return g|0}function W_e(a,b){a=a|0;b=b|0;var d=0;if((c[a>>2]|0)>(b|0))d=0;else d=(c[a+4>>2]|0)>=(b|0);return d|0}function X_e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a>>2]|0;f=c[a+4>>2]|0;if((e|0)>(f|0)){g=0;i=d;return g|0}a=c[b>>2]|0;h=c[b+4>>2]|0;if((a|0)>(h|0)){g=0;i=d;return g|0}if((e|0)<=(a|0)&(f|0)>=(a|0)?(e|0)>(h|0)|(f|0)<(h|0):0){g=1;i=d;return g|0}if((e|0)>(h|0)|(f|0)<(h|0)){g=0;i=d;return g|0}else{i=d;return (e|0)>(a|0)|(f|0)<(a|0)|0}return 0}function Y_e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b>>2]|0;f=c[b+4>>2]|0;if((e|0)>(f|0)){i=d;return}b=c[a>>2]|0;g=a+4|0;h=c[g>>2]|0;if((b|0)>(h|0)){c[a>>2]=e;c[g>>2]=f;j=f;k=e}else{j=h;k=b}if((e|0)<(k|0))c[a>>2]=e;if((f|0)<=(j|0)){i=d;return}c[g>>2]=f;i=d;return}function Z_e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;RI(2302336)|0;a=e-(c[(ith(b,2302336)|0)>>2]|0)|0;i=d;return a|0}function __e(a,b){a=a|0;b=b|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=d[a+8>>0];return}function $_e(b,d){b=b|0;d=d|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];a[d+8>>0]=(c[b+8>>2]|0)!=0&1;return}function a$e(a){a=a|0;return}function b$e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=b;eth(2303736,a);i=d;return}function c$e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;f=a+8|0;if((e|0)<(cth(2647352,c[f>>2]|0)|0)){e=Bth(2647800,c[f>>2]|0,c[d>>2]|0)|0;i=b;return e|0}else{RI(3084976)|0;e=qL(3084976)|0;nsg(e);gth(e)}return 0}function d$e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;f=a+8|0;if((e|0)>(cth(2647352,c[f>>2]|0)|0)){RI(3084976)|0;e=qL(3084976)|0;nsg(e);gth(e)}else{e=(c[d>>2]|0)+1|0;c[d>>2]=e;d=(e|0)<(cth(2647352,c[f>>2]|0)|0);i=b;return d|0}return 0}function e$e(a){a=a|0;c[a+12>>2]=-1;return}function f$e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function g$e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0;d=i;i=i+16|0;e=d;f=c[a+44>>2]|0;if(f){c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];+g$e(f,e)}f=c[a+8>>2]|0;g=c[a+16>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];h=+$m[f&63](g,e);i=d;return +h}function h$e(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0.0;e=i;i=i+32|0;f=e+12|0;g=e;h=c[(c[a+20>>2]|0)+4>>2]|0;a=c[b+4>>2]|0;j=d[b+8>>0]|0;c[g>>2]=c[b>>2];c[g+4>>2]=a;c[g+8>>2]=j;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];k=+Wm[h&15](f);i=e;return +k}function i$e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function j$e(a,b){a=a|0;b=b|0;return 0.0}function k$e(b){b=b|0;var d=0,e=0;d=i;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;ath(2713640)}RI(2713640)|0;e=qL(2713640)|0;$Lf(e);c[b+8>>2]=e;i=d;return}function l$e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Krh(2713112,c[b+8>>2]|0,d)|0;RI(2302336)|0;d=ith(f,2302336)|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];i=e;return}function m$e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=c[a+8>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];RI(2302336)|0;Erh(2714056,f,pL(2302336,e)|0)|0;i=d;return}function n$e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+48|0;d=b+36|0;e=b+24|0;f=b+12|0;g=b;c[e+0>>2]=c[580698];c[e+4>>2]=c[580699];c[e+8>>2]=c[580700];h=a+8|0;eth(2714896,c[h>>2]|0);if(((Aqh(2713056,c[h>>2]|0)|0)+-1|0)<=0){i=b;return}a=e+4|0;j=f+4|0;k=f+8|0;l=0;a:while(1){m=l;l=l+1|0;while(1){n=Krh(2713112,c[h>>2]|0,m)|0;RI(2302336)|0;o=ith(n,2302336)|0;c[e+0>>2]=c[o+0>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];o=Krh(2713112,c[h>>2]|0,l)|0;RI(2302336)|0;n=ith(o,2302336)|0;o=c[n>>2]|0;p=c[n+4>>2]|0;q=c[n+8>>2]|0;n=c[e>>2]|0;r=c[a>>2]|0;s=(n|0)>(r|0);if(s)break;if((o|0)>(p|0)|(n|0)>(p|0)|(o|0)>(r|0)){if(s|(o|0)>(p|0))break;if(!((n|0)==(p+1|0)|(r|0)==(o+-1|0)))break}c[f>>2]=o;c[j>>2]=p;c[k>>2]=q;c[d+0>>2]=c[f+0>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];Y_e(e,d);q=c[h>>2]|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];RI(2302336)|0;Jrh(2713888,q,m,pL(2302336,g)|0);Lrh(2714560,c[h>>2]|0,l);if((m|0)>=((Aqh(2713056,c[h>>2]|0)|0)+-1|0)){t=10;break a}}if((l|0)>=((Aqh(2713056,c[h>>2]|0)|0)+-1|0)){t=10;break}}if((t|0)==10){i=b;return}}function o$e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(2304240)|0;e=qL(2304240)|0;k$e(e);n$e(a);p$e(a,0,(Aqh(2305080,a)|0)+-1|0,e,b);eth(2714896,c[e+8>>2]|0);i=d;return e|0}function p$e(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0;h=i;i=i+112|0;j=h+84|0;k=h+48|0;l=h+12|0;m=h+24|0;n=h+96|0;o=h;p=h+36|0;q=h+72|0;r=h+60|0;s=(d|0)>(e|0);if(s){i=h;return}t=l+4|0;u=n+4|0;v=n+8|0;w=n+9|0;x=-1;y=-1;z=0.0;A=d;while(1){l$e(k,b,A);B=c[k>>2]|0;if((A|0)>(e|0)){C=x;D=y;E=z}else{F=x;G=y;H=z;I=0.0;J=A;while(1){l$e(l,b,J);K=c[t>>2]|0;l$e(m,b,J);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];I=I+ +Cth(2304728,g,j);c[n>>2]=B;c[u>>2]=K;a[v>>0]=0;a[w+0>>0]=a[2322801]|0;a[w+1>>0]=a[2322802]|0;a[w+2>>0]=a[2322803]|0;c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];K=!(+Cth(2304728,g,j)>=I)&!(I<=H);L=K?I:H;M=K?J:G;N=K?A:F;if((J|0)>=(e|0)){C=N;D=M;E=L;break}else{F=N;G=M;H=L;J=J+1|0}}}if((A|0)<(e|0)){x=C;y=D;z=E;A=A+1|0}else{O=C;P=D;break}}if((O|0)<=-1){if(s){i=h;return}else Q=d;while(1){l$e(o,b,Q);c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];m$e(f,j);if((Q|0)<(e|0))Q=Q+1|0;else break}i=h;return}l$e(p,b,O);Q=c[p>>2]|0;l$e(q,b,P);p=c[q+4>>2]|0;c[r>>2]=Q;c[r+4>>2]=p;a[r+8>>0]=0;p=r+9|0;a[p+0>>0]=a[2322801]|0;a[p+1>>0]=a[2322802]|0;a[p+2>>0]=a[2322803]|0;c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];m$e(f,j);if((O|0)>(d|0))p$e(b,d,O+-1|0,f,g);if((P|0)>=(e|0)){i=h;return}p$e(b,P+1|0,e,f,g);i=h;return}function q$e(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2713056,c[a+8>>2]|0)|0;i=b;return d|0}function r$e(a){a=a|0;return c[a+8>>2]|0}function s$e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+12|0;g=e;c[f+0>>2]=c[580698];c[f+4>>2]=c[580699];c[f+8>>2]=c[580700];h=bth(2714784,c[a+8>>2]|0)|0;a=d;while(1){if(!(jth(2568176,h)|0))break;d=Sqh(2568120,h)|0;RI(2302336)|0;j=ith(d,2302336)|0;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];if((a|0)>(PCf(b)|0))break;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];RI(2302336)|0;bEf(b,pL(2302336,g)|0,a);a=a+1|0}RI(2568648)|0;a=vL(h,2568648)|0;if(!a)if(98==98){i=e;return}else gth(0);else{kth(2568816,a);if(98==98){i=e;return}else gth(0)}}function t$e(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;RI(2303792)|0;a=qL(2303792)|0;b$e(a,d);i=b;return a|0}function u$e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function v$e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=w$e(0,b,c,10,1,2147483647)|0;i=a;return d|0}function w$e(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;h=c[d>>2]|0;j=(g|0)<(f|0)?2147483647:g;a:do if((j|0)>0){g=h;k=0;l=0;while(1){if((g|0)>=(Vof(b)|0)){m=g;n=k;o=l;break a}p=z$e(0,Wof(b,g)|0,e,0)|0;if((p|0)<=-1){m=g;n=k;o=l;break a}q=g+1|0;r=p+(da(k,e)|0)|0;p=l+1|0;if((p|0)<(j|0)){g=q;k=r;l=p}else{m=q;n=r;o=p;break}}}else{m=h;n=0;o=0}while(0);if((o|0)<(f|0)){s=-1;i=a;return s|0}c[d>>2]=m;s=n;i=a;return s|0}function x$e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=w$e(0,b,c,8,1,3)|0;i=a;return d|0}function y$e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=i;e=w$e(0,b,c,16,d,d)|0;i=a;return e|0}function z$e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=i;do if((c|0)==10)if((b+-48<<16>>16&65535)>9)e=-1;else e=(b&65535)+65488&65535;else if((c|0)==8)if((b&-8)<<16>>16==48)e=(b&65535)+65488&65535;else e=-1;else if((c|0)==16){a=b&65535;if((b+-48<<16>>16&65535)<=9){e=a+65488&65535;break}if((b+-97<<16>>16&65535)>5){i=d;return ((b+-65<<16>>16&65535)>5?-1:a+-55|0)|0}else{e=a+-87|0;break}}else e=-1;while(0);i=d;return e|0}function A$e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;f=b;c[f>>2]=0;g=Wof(d,c[e>>2]|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(jpf(0,g)|0){g=w$e(0,d,e,10,1,0)|0;c[f>>2]=g;if((g|0)<1){h=0;i=b;return h|0}h=spf(f)|0;i=b;return h|0}f=c[e>>2]|0;g=B$e(0,Wof(d,f)|0)|0;j=c[e>>2]|0;if(g){g=j;while(1){k=g+1|0;c[e>>2]=k;l=B$e(0,Wof(d,k)|0)|0;k=c[e>>2]|0;if(l)g=k;else{m=k;break}}}else m=j;j=m-f|0;if((j|0)<1){h=0;i=b;return h|0}h=fpf(d,f,j)|0;i=b;return h|0}function B$e(b,c){b=b|0;c=c|0;var d=0,e=0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}d=nuf(0,c)|0;if((d|0)==18){e=1;i=b;return e|0}else if((d|0)==3){e=0;i=b;return e|0}else{RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}e=puf(0,c)|0;i=b;return e|0}return 0}function C$e(a){a=a|0;var b=0;b=i;R0e(a);c[a+12>>2]=0;i=b;return}function D$e(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;h=i;i=i+16|0;j=h+8|0;k=h+14|0;l=h+4|0;m=h;n=h+12|0;c[j>>2]=f;b[k>>1]=0;c[l>>2]=0;c[m>>2]=0;Xch();RI(2306072)|0;o=(vL(e,2306072)|0)!=0;RI(2306408)|0;p=qL(2306408)|0;R0e(p);L$e(d,(f&32|0)!=0);q=d+12|0;r=c[q>>2]|0;s=d+8|0;a:do if((r|0)<(Vof(c[s>>2]|0)|0)){t=(g|0)==0;u=f;v=0;w=0;x=p;b:while(1){y=(u&32|0)!=0;z=u&1;A=z&255;B=v;C=w;D=x;c:while(1){E=c[s>>2]|0;F=c[q>>2]|0;c[q>>2]=F+1;G=Wof(E,F)|0;b[k>>1]=G;F=G&65535;switch(F+65500&65535|0){case 10:{H=B;I=C;J=D;K=9;break c;break}case 4:{L=B;M=C;N=D;K=17;break c;break}case 0:{O=B;P=C;Q=D;K=8;break c;break}case 6:case 7:{K=34;break b;break}case 5:{R=u;S=B;T=C;U=D;K=66;break b;break}default:{}}E=F+65445&65535;if((E|0)==3){V=B;W=C;X=D;K=7;break}else if((E|0)==1){Y=B;Z=C;_=D;K=12;break}else if(!E){$=B;aa=C;ba=D;K=16;break}if(G<<16>>16==63){K=34;break b}else if(G<<16>>16!=124){ca=u;da=B;ea=C;fa=D;ga=0;K=35;break}if(C){RI(2306912)|0;G=qL(2306912)|0;c[G+8>>2]=C;a[G+12>>0]=A;I0e(c[D+8>>2]|0,G)}do if(t){if(!B){RI(2307080)|0;G=qL(2307080)|0;R0e(G);ha=G}else ha=B;I0e(c[ha+8>>2]|0,D);ia=ha}else{if(!(X$e(g)|0)){Y$e(g,D);ia=B;break}if(Z$e(g)|0){K=29;break b}_$e(g,D);ia=B}while(0);RI(2306408)|0;G=qL(2306408)|0;R0e(G);L$e(d,y);E=c[q>>2]|0;if((E|0)<(Vof(c[s>>2]|0)|0)){B=ia;C=0;D=G}else{ja=u;ka=ia;la=0;ma=G;K=68;break a}}do if((K|0)==7){K=0;RI(2306576)|0;D=qL(2306576)|0;b[D+8>>1]=u&2|1;ca=u;da=V;ea=W;fa=X;ga=D;K=35}else if((K|0)==8){K=0;RI(2306576)|0;D=qL(2306576)|0;b[D+8>>1]=u&2|5;ca=u;da=O;ea=P;fa=Q;ga=D;K=35}else if((K|0)==9){K=0;RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;D=qL(2306744)|0;P$e(D,((u&16)>>>4)+1<<16>>16,0);ca=u;da=H;ea=I;fa=J;ga=D;K=35}else if((K|0)==12){K=0;D=Q$e(d)|0;if((D|0)>=0){b[k>>1]=D;ca=u;da=Y;ea=Z;fa=_;ga=0;K=35;break}D=R$e(d,u)|0;if(!D){C=c[s>>2]|0;B=c[q>>2]|0;c[q>>2]=B+1;b[k>>1]=Wof(C,B)|0;ca=u;da=Y;ea=Z;fa=_;ga=0;K=35}else{ca=u;da=Y;ea=Z;fa=_;ga=D;K=35}}else if((K|0)==16){K=0;ca=u;da=$;ea=aa;fa=ba;ga=S$e(d,u)|0;K=35}else if((K|0)==17){K=0;D=U$e(d,j)|0;if(D){ca=c[j>>2]|0;da=L;ea=M;fa=N;ga=D;K=35;break}D=c[j>>2]|0;if(M){B=D&1;if((B|0)!=0^(z|0)!=0){RI(2306912)|0;C=qL(2306912)|0;c[C+8>>2]=M;a[C+12>>0]=B;I0e(c[N+8>>2]|0,C);na=D;oa=L;pa=0;qa=N}else{na=D;oa=L;pa=M;qa=N}}else{na=D;oa=L;pa=0;qa=N}}while(0);if((K|0)==35){K=0;z=(ca&32|0)!=0;L$e(d,z);D=c[q>>2]|0;d:do if((D|0)<(Vof(c[s>>2]|0)|0)){C=Wof(c[s>>2]|0,c[q>>2]|0)|0;c[l>>2]=0;c[m>>2]=0;do if(C<<16>>16==42|C<<16>>16==43|C<<16>>16==63){c[q>>2]=(c[q>>2]|0)+1;if(C<<16>>16==43){c[l>>2]=1;c[m>>2]=2147483647;break}else if(C<<16>>16==63){c[l>>2]=0;c[m>>2]=1;break}else if(C<<16>>16==42){c[l>>2]=0;c[m>>2]=2147483647;break}else break}else if(C<<16>>16==123){B=c[q>>2]|0;if((B+1|0)>=(Vof(c[s>>2]|0)|0)){ra=ga;break d}B=c[q>>2]|0;c[q>>2]=B+1;if(!(b0e(d,l,m,ca)|0)){c[q>>2]=B;ra=ga;break d}}else{ra=ga;break d}while(0);L$e(d,z);C=c[q>>2]|0;if((C|0)<(Vof(c[s>>2]|0)|0)?(Wof(c[s>>2]|0,c[q>>2]|0)|0)<<16>>16==63:0){c[q>>2]=(c[q>>2]|0)+1;sa=1}else sa=0;RI(2307248)|0;C=qL(2307248)|0;c0e(C,c[l>>2]|0,c[m>>2]|0,sa);if(!ga){B=xuf(k)|0;RI(2306912)|0;y=qL(2306912)|0;c[y+8>>2]=B;a[y+12>>0]=ca&1;d0e(C,y)}else d0e(C,ga);ra=C}else ra=ga;while(0);z=(ea|0)!=0;if(!ra){if(z)ta=ea;else{if(!(a[2540708]|0))ath(2540560);ta=c[c[635163]>>2]|0}b[n>>1]=b[k>>1]|0;RI(2540392)|0;D=pL(2540392,n)|0;if(!(a[2540708]|0))ath(2540560);ua=fwf(0,ta,D)|0}else{if(z){RI(2306912)|0;z=qL(2306912)|0;c[z+8>>2]=ea;a[z+12>>0]=ca&1;D=fa+8|0;I0e(c[D>>2]|0,z);va=D}else va=fa+8|0;I0e(c[va>>2]|0,ra);ua=0}if(o?(D=c[q>>2]|0,(D|0)>=(Vof(c[s>>2]|0)|0)):0){wa=ca;xa=da;ya=ua;za=fa;break a}else{na=ca;oa=da;pa=ua;qa=fa}}L$e(d,(na&32|0)!=0);D=c[q>>2]|0;if((D|0)<(Vof(c[s>>2]|0)|0)){u=na;v=oa;w=pa;x=qa}else{ja=na;ka=oa;la=pa;ma=qa;K=68;break a}}if((K|0)==29)gth(G$e(d,c[882268]|0)|0);else if((K|0)==34)gth(G$e(d,c[882270]|0)|0);else if((K|0)==66){if(!o){wa=R;xa=S;ya=T;za=U;break}gth(G$e(d,c[882272]|0)|0)}}else{ja=f;ka=0;la=0;ma=p;K=68}while(0);if((K|0)==68)if(o){wa=ja;xa=ka;ya=la;za=ma}else gth(G$e(d,c[882274]|0)|0);if(ya){RI(2306912)|0;d=qL(2306912)|0;c[d+8>>2]=ya;a[d+12>>0]=wa&1;I0e(c[za+8>>2]|0,d)}if(!g)if(!xa){I0e(c[e+8>>2]|0,za);i=h;return}else{I0e(c[xa+8>>2]|0,za);I0e(c[e+8>>2]|0,xa);i=h;return}else{if(!(X$e(g)|0))Y$e(g,za);else _$e(g,za);I0e(c[e+8>>2]|0,g);i=h;return}}function E$e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=0;c[g>>2]=0;cdh();c[e>>2]=1;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;h=qL(2730168)|0;kPf(h);j=b+16|0;k=bth(2714784,c[j>>2]|0)|0;l=b+24|0;while(1){if(!(jth(2568176,k)|0))break;m=Sqh(2568120,k)|0;RI(2306240)|0;n=lth(m,2306240)|0;if(c[n+16>>2]|0)continue;Rrh(2734016,h,spf(e)|0,n);m=c[e>>2]|0;c[e>>2]=m+1;c[n+12>>2]=m;c[l>>2]=(c[l>>2]|0)+1}RI(2568648)|0;m=vL(k,2568648)|0;if(!m){if(135!=135)gth(0)}else{kth(2568816,m);if(135!=135)gth(0)}m=bth(2714784,c[j>>2]|0)|0;j=0;a:while(1){while(1){if(!(jth(2568176,m)|0)){o=j;break a}k=Sqh(2568120,m)|0;RI(2306240)|0;n=lth(k,2306240)|0;k=n+16|0;p=c[k>>2]|0;if(!p)continue;q=nrh(2734296,h,p)|0;p=c[k>>2]|0;if(q){q=uth(2736488,h,p)|0;RI(2306240)|0;r=c[(lth(q,2306240)|0)+12>>2]|0;c[n+12>>2]=r;q=c[e>>2]|0;if((r|0)==(q|0)){c[e>>2]=r+1;continue}if((r|0)<=(q|0))continue;Erh(2714056,j,n)|0;continue}q=Wof(p,0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(jpf(0,q)|0?(c[f>>2]=0,q=v$e(0,c[k>>2]|0,f)|0,p=Vof(c[k>>2]|0)|0,(c[f>>2]|0)==(p|0)):0){c[n+12>>2]=q;Rrh(2734016,h,c[k>>2]|0,n);c[l>>2]=(c[l>>2]|0)+1;if((q|0)!=(c[e>>2]|0)){s=n;break}c[e>>2]=q+1;continue}q=spf(e)|0;while(1){if(!(nrh(2734296,h,q)|0)){t=q;break}p=(c[e>>2]|0)+1|0;c[e>>2]=p;c[g>>2]=p;q=spf(g)|0}Rrh(2734016,h,t,n);Rrh(2734016,h,c[k>>2]|0,n);q=c[e>>2]|0;c[e>>2]=q+1;c[n+12>>2]=q;c[l>>2]=(c[l>>2]|0)+1}if(!j){RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;ath(2713640)}RI(2713640)|0;q=qL(2713640)|0;ZMf(q,4);u=q}else u=j;Erh(2714056,u,s)|0;j=u}RI(2568648)|0;u=vL(m,2568648)|0;if(!u){if(561!=561)gth(0)}else{kth(2568816,u);if(561!=561)gth(0)}c[b+28>>2]=c[e>>2];if(o)C0e(b,o);o=b+20|0;e=Sqh(2568512,bth(2736416,c[o>>2]|0)|0)|0;while(1){if(!(jth(2568176,e)|0))break;u=Sqh(2568120,e)|0;RI(2308424)|0;m=lth(u,2308424)|0;u=lth(uth(2736488,c[o>>2]|0,m)|0,2540560)|0;if(!(nrh(2734296,h,u)|0)){RI(2307920)|0;if(vL(m,2307920)|0){j=Wof(u,0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(!(jpf(0,j)|0))continue}RI(2308088)|0;j=vL(m,2308088)|0;if(!j){v=u;w=50;break}if(D0e(j,u,h)|0)continue;else{v=u;w=50;break}}else{j=uth(2736488,h,u)|0;RI(2306240)|0;u=lth(j,2306240)|0;RI(2308256)|0;if(vL(m,2308256)|0){RI(2308256)|0;c[(lth(m,2308256)|0)+8>>2]=u;continue}RI(2307920)|0;if(vL(m,2307920)|0){RI(2307920)|0;c[(lth(m,2307920)|0)+16>>2]=u;continue}RI(2307752)|0;if(!(vL(m,2307752)|0))continue;RI(2307752)|0;c[(lth(m,2307752)|0)+20>>2]=u;continue}}if((w|0)==50){w=Wof(v,0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}h=jpf(0,w)|0;w=c[882618]|0;o=h?c[882620]|0:c[882622]|0;if(a[2540708]|0){x=iwf(0,w,o,v)|0;y=G$e(b,x)|0;FJ(y)}ath(2540560);x=iwf(0,w,o,v)|0;y=G$e(b,x)|0;FJ(y)}RI(2568648)|0;y=vL(e,2568648)|0;if(!y)if(916==916){i=d;return}else gth(0);else{kth(2568816,y);if(916==916){i=d;return}else gth(0)}}function F$e(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function G$e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;ddh();f=b+8|0;b=c[f>>2]|0;if(!(a[2540708]|0))ath(2540560);g=jwf(0,c[882650]|0,b,c[882652]|0,d)|0;d=c[f>>2]|0;RI(2965048)|0;f=qL(2965048)|0;Rag(f,g,d);i=e;return f|0}function H$e(a){a=a|0;return c[a+16>>2]|0}function I$e(a){a=a|0;return c[a+12>>2]|0}function J$e(a){a=a|0;var b=0;b=i;R0e(a);i=b;return}function K$e(a,b){a=a|0;b=b|0;return (b&32|0)!=0|0}function L$e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+12|0;g=c[f>>2]|0;h=b+8|0;if((g|0)>=(Vof(c[h>>2]|0)|0)){i=e;return}a:while(1){b:do if((Wof(c[h>>2]|0,c[f>>2]|0)|0)<<16>>16!=40){if(!d){j=23;break a}if((Wof(c[h>>2]|0,c[f>>2]|0)|0)<<16>>16==35)while(1){g=c[f>>2]|0;if((g|0)>=(Vof(c[h>>2]|0)|0))break b;g=c[h>>2]|0;b=c[f>>2]|0;c[f>>2]=b+1;if((Wof(g,b)|0)<<16>>16==10)break b}b=Wof(c[h>>2]|0,c[f>>2]|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(!(Xof(0,b)|0)){j=23;break a}b=c[f>>2]|0;if((b|0)<(Vof(c[h>>2]|0)|0))do{b=Wof(c[h>>2]|0,c[f>>2]|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(!(Xof(0,b)|0))break b;b=(c[f>>2]|0)+1|0;c[f>>2]=b}while((b|0)<(Vof(c[h>>2]|0)|0))}else{b=c[f>>2]|0;if((b+3|0)>=(Vof(c[h>>2]|0)|0)){j=23;break a}if((Wof(c[h>>2]|0,(c[f>>2]|0)+1|0)|0)<<16>>16!=63){j=23;break a}if((Wof(c[h>>2]|0,(c[f>>2]|0)+2|0)|0)<<16>>16!=35){j=23;break a}b=(c[f>>2]|0)+3|0;c[f>>2]=b;g=b;while(1){if((g|0)>=(Vof(c[h>>2]|0)|0))break b;b=c[h>>2]|0;k=c[f>>2]|0;c[f>>2]=k+1;if((Wof(b,k)|0)<<16>>16==41)break b;g=c[f>>2]|0}}while(0);g=c[f>>2]|0;if((g|0)>=(Vof(c[h>>2]|0)|0)){j=23;break}}if((j|0)==23){i=e;return}}function M$e(a,b){a=a|0;b=b|0;return (b&2|0)!=0|0}function N$e(a,c){a=a|0;c=c|0;b[a+8>>1]=c;return}function O$e(a,b){a=a|0;b=b|0;return (b&16|0)!=0|0}function P$e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;t0e(a,0,0);v0e(a,b,c);i=d;return}function Q$e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;bdh();e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=(f|0)<(Vof(c[g>>2]|0)|0);j=c[g>>2]|0;if(!h){if(a[2540708]|0){k=c[882558]|0;l=_vf(0,k,j)|0;m=c[g>>2]|0;RI(2965048)|0;n=qL(2965048)|0;Rag(n,l,m);gth(n)}ath(2540560);k=c[882558]|0;l=_vf(0,k,j)|0;m=c[g>>2]|0;RI(2965048)|0;n=qL(2965048)|0;Rag(n,l,m);gth(n)}n=c[e>>2]|0;c[e>>2]=n+1;m=Wof(j,n)|0;n=m&65535;a:do switch(n+65426&65535|0){case 8:{o=11;break}case 0:{o=10;break}case 4:{o=13;break}case 7:{j=y$e(0,c[g>>2]|0,e,4)|0;if((j|0)>-1)o=j;else gth(G$e(b,c[882562]|0)|0);break}case 10:{j=y$e(0,c[g>>2]|0,e,2)|0;if((j|0)>-1)o=j;else gth(G$e(b,c[882560]|0)|0);break}case 6:{o=9;break}default:{j=n+65439&65535;if((j|0)==4){o=27;break a}else if((j|0)==2){l=c[g>>2]|0;k=c[e>>2]|0;c[e>>2]=k+1;h=Wof(l,k)|0;if((h&-32)<<16>>16==64){o=(h&65535)+-64|0;break a}else gth(G$e(b,c[882564]|0)|0)}else if(!j){o=7;break a}else if((j|0)==5){o=12;break a}else{if(m<<16>>16==92){o=92;break a}else if(m<<16>>16!=48){c[e>>2]=f;o=-1;break a}j=(c[e>>2]|0)+-1|0;c[e>>2]=j;h=x$e(0,c[g>>2]|0,e)|0;if((h|0)==-1?(j|0)==(c[e>>2]|0):0){o=0;break a}o=h;break a}}}while(0);i=d;return o|0}function R$e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f;c[g>>2]=0;adh();h=d+12|0;j=c[h>>2]|0;k=(e&256|0)!=0;l=d+8|0;m=c[l>>2]|0;c[h>>2]=j+1;n=Wof(m,j)|0;m=n&65535;a:do switch(m+65487&65535|0){case 17:{RI(2306576)|0;o=qL(2306576)|0;b[o+8>>1]=9;p=o;q=48;break}case 8:case 7:case 6:case 5:case 4:case 3:case 2:case 1:case 0:{c[h>>2]=(c[h>>2]|0)+-1;o=y0e(d,10,1,0)|0;c[g>>2]=o;if((o|0)>-1){RI(2308088)|0;o=qL(2308088)|0;z0e(o,(e&1|0)!=0,k);r=c[d+20>>2]|0;Rrh(2734016,r,o,spf(g)|0);p=o;q=48;break a}c[h>>2]=j;s=0;i=f;return s|0}case 19:{RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;o=qL(2306744)|0;P$e(o,k?9:4,1);p=o;q=48;break}case 16:{RI(2306576)|0;o=qL(2306576)|0;b[o+8>>1]=2;p=o;q=48;break}case 22:{RI(2306576)|0;o=qL(2306576)|0;b[o+8>>1]=4;p=o;q=48;break}default:{o=m+65456&65535;if((o|0)==3){RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;r=qL(2306744)|0;P$e(r,k?10:5,1);p=r;q=48;break a}else if(o){o=m+65449&65535;if(!o){RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;r=qL(2306744)|0;P$e(r,k?8:3,1);p=r;q=48;break a}else if((o|0)!=3){o=m+65424&65535;if(!o){r=w0e(d)|0;RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;t=qL(2306744)|0;P$e(t,r,0);p=t;q=48;break a}else if((o|0)!=3){o=m+65417&65535;if(!o){RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;t=qL(2306744)|0;P$e(t,k?8:3,0);p=t;q=48;break a}else if((o|0)!=3){o=m+65438&65535;if(!o){RI(2306576)|0;t=qL(2306576)|0;b[t+8>>1]=8;p=t;q=48;break a}else if((o|0)!=2){if(n<<16>>16!=107)break a;o=c[l>>2]|0;t=c[h>>2]|0;c[h>>2]=t+1;r=Wof(o,t)|0;if(r<<16>>16!=60)if(r<<16>>16==39)u=39;else gth(G$e(d,c[882532]|0)|0);else u=62;r=l0e(d)|0;if(!r){v=c[882534]|0;w=G$e(d,v)|0;gth(w)}if((Wof(c[l>>2]|0,c[h>>2]|0)|0)<<16>>16==u<<16>>16){c[h>>2]=(c[h>>2]|0)+1;RI(2308256)|0;t=qL(2308256)|0;a[t+12>>0]=e&1;Rrh(2734016,c[d+20>>2]|0,t,r);p=t;q=48;break a}else{v=c[882534]|0;w=G$e(d,v)|0;gth(w)}}else{RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;t=qL(2306744)|0;P$e(t,k?9:4,0);p=t;q=48;break a}}else{RI(2306576)|0;t=qL(2306576)|0;b[t+8>>1]=6;p=t;q=48;break a}}else{RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;t=qL(2306744)|0;P$e(t,k?10:5,0);p=t;q=48;break a}}else{RI(2306576)|0;t=qL(2306576)|0;b[t+8>>1]=5;p=t;q=48;break a}}else{t=w0e(d)|0;RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;r=qL(2306744)|0;P$e(r,t,1);p=r;q=48;break a}}}while(0);if((q|0)==48?(p|0)!=0:0){s=p;i=f;return s|0}c[h>>2]=j;s=0;i=f;return s|0}function S$e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;Zch();j=b+8|0;k=b+12|0;if((Wof(c[j>>2]|0,c[k>>2]|0)|0)<<16>>16==94){c[k>>2]=(c[k>>2]|0)+1;l=1}else l=0;m=(d&256|0)!=0;RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;n=qL(2306744)|0;t0e(n,l,(d&1|0)!=0);if((Wof(c[j>>2]|0,c[k>>2]|0)|0)<<16>>16==93){x0e(n,93,93);c[k>>2]=(c[k>>2]|0)+1}d=m?9:4;l=m?8:3;o=m?10:5;m=-1;a:while(1){p=(m|0)<0;q=0;while(1){r=c[k>>2]|0;if((r|0)>=(Vof(c[j>>2]|0)|0)){s=34;break a}r=c[j>>2]|0;t=c[k>>2]|0;c[k>>2]=t+1;u=Wof(r,t)|0;if(u<<16>>16==93){s=35;break a}if(u<<16>>16!=45|p|q){v=u;w=q;break}else q=1}p=v&65535;b:do if(v<<16>>16==92){u=Q$e(b)|0;if((u|0)<0){t=c[j>>2]|0;r=c[k>>2]|0;c[k>>2]=r+1;x=Wof(t,r)|0;r=x&65535;switch(r|0){case 112:case 80:{v0e(n,w0e(b)|0,x<<16>>16==80);y=w;break}case 115:case 83:{v0e(n,o,x<<16>>16==83);y=w;break}case 98:{z=8;break b;break}case 99:{if(x<<16>>16==68)s=16;else{A=x&-33;s=15}break}default:{t=x&-33;if(t<<16>>16==68)s=16;else{A=t;s=15}}}if((s|0)==15){s=0;if(A<<16>>16!=87){z=r;break}v0e(n,l,x<<16>>16==87);y=w}else if((s|0)==16){s=0;v0e(n,d,x<<16>>16==68);y=w}if(y){B=r;s=21;break a}else{m=-1;continue a}}else z=u}else z=p;while(0);if(!w){p=z&65535;x0e(n,p,p);m=z;continue}if((z|0)<(m|0)){C=z;D=m;s=26;break}x0e(n,m&65535,z&65535);m=-1}if((s|0)==21){c[f>>2]=B;RI(2540224)|0;B=pL(2540224,f)|0;if(a[2540708]|0){E=c[882394]|0;F=fwf(0,E,B)|0;G=G$e(b,F)|0;gth(G)}ath(2540560);E=c[882394]|0;F=fwf(0,E,B)|0;G=G$e(b,F)|0;gth(G)}else if((s|0)==26){RI(1086352)|0;G=nth(1086352,5)|0;Qqh(G,c[882396]|0);F=G+16|0;c[F>>2]=c[882396];c[g>>2]=D;RI(2540224)|0;D=pL(2540224,g)|0;Qqh(G,D);c[F+(c[(c[G>>2]|0)+120>>2]|0)>>2]=D;Qqh(G,c[882398]|0);c[F+(c[(c[G>>2]|0)+120>>2]<<1)>>2]=c[882398];c[h>>2]=C;RI(2540224)|0;C=pL(2540224,h)|0;Qqh(G,C);c[F+((c[(c[G>>2]|0)+120>>2]|0)*3|0)>>2]=C;Qqh(G,c[882400]|0);c[F+(c[(c[G>>2]|0)+120>>2]<<2)>>2]=c[882400];if(a[2540708]|0){H=eqf(0,G)|0;I=G$e(b,H)|0;gth(I)}ath(2540560);H=eqf(0,G)|0;I=G$e(b,H)|0;gth(I)}else if((s|0)==34)gth(G$e(b,c[882402]|0)|0);else if((s|0)==35){if(!q){i=e;return n|0}x0e(n,45,45);i=e;return n|0}return 0}function T$e(a,b){a=a|0;b=b|0;return (b&1|0)!=0|0}function U$e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+16|0;f=e;c[f>>2]=0;Ych();g=b+8|0;h=b+12|0;if((Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16!=63){if(!(c[d>>2]&4)){RI(2306240)|0;j=qL(2306240)|0;f0e(j);Erh(2714056,c[b+16>>2]|0,j)|0;k=j}else{RI(2306408)|0;j=qL(2306408)|0;R0e(j);k=j}D$e(b,k,c[d>>2]|0,0);l=k;i=e;return l|0}k=(c[h>>2]|0)+1|0;c[h>>2]=k;j=Wof(c[g>>2]|0,k)|0;k=j&65535;m=k+65503&65535;a:do if((m|0)==7){n=(c[h>>2]|0)+1|0;c[h>>2]=n;o=l0e(b)|0;if((o|0)!=0?(Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16==41:0){c[h>>2]=(c[h>>2]|0)+1;p=c[d>>2]&1;RI(2306912)|0;q=qL(2306912)|0;c[q+8>>2]=o;a[q+12>>0]=p;RI(2307920)|0;p=qL(2307920)|0;u1e(p);c[p+20>>2]=q;Rrh(2734016,c[b+20>>2]|0,p,o);r=p}else{c[h>>2]=n;RI(2307584)|0;n=qL(2307584)|0;i0e(n);if((Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16==63){c[h>>2]=(c[h>>2]|0)+1;if(!(j0e(b,n)|0))gth(G$e(b,c[882322]|0)|0)}else{a[n+13>>0]=0;a[n+12>>0]=0}RI(2306408)|0;p=qL(2306408)|0;R0e(p);D$e(b,p,c[d>>2]|0,0);k0e(n,p);r=n}RI(2306408)|0;n=qL(2306408)|0;R0e(n);D$e(b,n,c[d>>2]|0,r);l=n;i=e;return l|0}else if((m|0)==2){n=(c[h>>2]|0)+1|0;c[h>>2]=n;p=n;while(1){n=c[g>>2]|0;c[h>>2]=p+1;if((Wof(n,p)|0)<<16>>16==41){l=0;s=49;break}n=c[h>>2]|0;if((n|0)>=(Vof(c[g>>2]|0)|0)){s=44;break}p=c[h>>2]|0}if((s|0)==44)gth(G$e(b,c[882324]|0)|0);else if((s|0)==49){i=e;return l|0}}else if(!m)s=19;else if((m|0)!=6){p=k+65431&65535;do if(!((p|0)==4|(p|0)==5|(p|0)==0)){n=k+65478&65535;if(!n){c[h>>2]=(c[h>>2]|0)+1;RI(2306408)|0;o=qL(2306408)|0;R0e(o);D$e(b,o,c[d>>2]|0,0);l=o;i=e;return l|0}else if((n|0)==4){c[h>>2]=(c[h>>2]|0)+1;RI(2307416)|0;o=qL(2307416)|0;R0e(o);D$e(b,o,c[d>>2]|0,0);l=o;i=e;return l|0}else if((n|0)==3|(n|0)==2){s=19;break a}else{if(j<<16>>16==120|j<<16>>16==115|j<<16>>16==45)break;gth(G$e(b,c[882326]|0)|0)}}while(0);c[f>>2]=c[d>>2];h0e(b,f,0);if((Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16==45){c[h>>2]=(c[h>>2]|0)+1;h0e(b,f,1)}if((Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16==58){c[h>>2]=(c[h>>2]|0)+1;RI(2306408)|0;p=qL(2306408)|0;R0e(p);D$e(b,p,c[f>>2]|0,0);l=p;i=e;return l|0}if((Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16!=41)gth(G$e(b,c[882314]|0)|0);c[h>>2]=(c[h>>2]|0)+1;c[d>>2]=c[f>>2];l=0;i=e;return l|0}while(0);if((s|0)==19?(RI(2307584)|0,s=qL(2307584)|0,i0e(s),j0e(b,s)|0):0){RI(2306408)|0;f=qL(2306408)|0;R0e(f);D$e(b,f,c[d>>2]|0,0);k0e(s,f);l=s;i=e;return l|0}s=(Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16==60;f=s?62:39;c[h>>2]=(c[h>>2]|0)+1;s=l0e(b)|0;if(((Wof(c[g>>2]|0,c[h>>2]|0)|0)&65535|0)==(f|0)){if(!s)gth(G$e(b,c[882316]|0)|0);c[h>>2]=(c[h>>2]|0)+1;RI(2306240)|0;j=qL(2306240)|0;f0e(j);c[j+16>>2]=s;Erh(2714056,c[b+16>>2]|0,j)|0;D$e(b,j,c[d>>2]|0,0);l=j;i=e;return l|0}if((Wof(c[g>>2]|0,c[h>>2]|0)|0)<<16>>16!=45)gth(G$e(b,c[882320]|0)|0);c[h>>2]=(c[h>>2]|0)+1;j=l0e(b)|0;if(!j){t=c[882318]|0;u=G$e(b,t)|0;gth(u)}if(((Wof(c[g>>2]|0,c[h>>2]|0)|0)&65535|0)!=(f|0)){t=c[882318]|0;u=G$e(b,t)|0;gth(u)}c[h>>2]=(c[h>>2]|0)+1;RI(2307752)|0;h=qL(2307752)|0;f0e(h);c[h+20>>2]=0;c[h+16>>2]=s;if(!s)v=h;else{Erh(2714056,c[b+16>>2]|0,h)|0;v=h}Rrh(2734016,c[b+20>>2]|0,v,j);D$e(b,h,c[d>>2]|0,0);l=h;i=e;return l|0}function V$e(b,d,e){b=b|0;d=d|0;e=e|0;c[b+8>>2]=d;a[b+12>>0]=e&1;return}function W$e(a,b){a=a|0;b=b|0;var d=0;d=i;I0e(c[a+8>>2]|0,b);i=d;return}function X$e(a){a=a|0;var b=0,d=0;b=i;d=J0e(c[a+8>>2]|0,0)|0;i=b;return d|0}function Y$e(a,b){a=a|0;b=b|0;var d=0;d=i;K0e(c[a+8>>2]|0,0,b);i=d;return}function Z$e(a){a=a|0;var b=0,d=0;b=i;d=J0e(c[a+8>>2]|0,1)|0;i=b;return d|0}function _$e(a,b){a=a|0;b=b|0;var d=0;d=i;K0e(c[a+8>>2]|0,1,b);i=d;return}function $$e(a){a=a|0;var b=0;b=i;R0e(a);i=b;return}function a0e(a,b){a=a|0;b=b|0;var d=0;d=i;I0e(c[a+8>>2]|0,b);i=d;return}function b0e(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;_ch();c[d>>2]=0;c[b>>2]=0;g=(e&32|0)!=0;L$e(a,g);e=a+8|0;h=a+12|0;if((Wof(c[e>>2]|0,c[h>>2]|0)|0)<<16>>16==44)j=-1;else{k=y0e(a,10,1,0)|0;L$e(a,g);j=k}k=c[e>>2]|0;l=c[h>>2]|0;c[h>>2]=l+1;m=Wof(k,l)|0;if(m<<16>>16==44)n=4;else if(m<<16>>16==125)o=j;else{p=0;i=f;return p|0}if((n|0)==4){L$e(a,g);n=y0e(a,10,1,0)|0;L$e(a,g);g=c[e>>2]|0;e=c[h>>2]|0;c[h>>2]=e+1;if((Wof(g,e)|0)<<16>>16!=125){p=0;i=f;return p|0}if((n|0)>-1&(n|0)<(j|0))gth(G$e(a,c[882452]|0)|0);else o=n}c[b>>2]=j;c[d>>2]=(o|0)<1?2147483647:o;p=1;i=f;return p|0}function c0e(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;R0e(b);I0e(c[b+8>>2]|0,0);c[b+12>>2]=d;c[b+16>>2]=e;a[b+20>>0]=f&1;i=g;return}function d0e(a,b){a=a|0;b=b|0;var d=0;d=i;K0e(c[a+8>>2]|0,0,b);i=d;return}function e0e(a,b){a=a|0;b=b|0;return (b&4|0)!=0|0}function f0e(a){a=a|0;var b=0;b=i;R0e(a);c[a+12>>2]=0;c[a+16>>2]=0;i=b;return}function g0e(a){a=a|0;var b=0;b=i;R0e(a);i=b;return}function h0e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+8|0;g=a+12|0;a=c[g>>2]|0;a:while(1){h=Wof(c[f>>2]|0,a)|0;j=(h&65535)+65431&65535;do if((j|0)==4){k=c[b>>2]|0;if(d){c[b>>2]=k&-3;break}else{c[b>>2]=k|2;break}}else if(!j){k=c[b>>2]|0;if(d){c[b>>2]=k&-2;break}else{c[b>>2]=k|1;break}}else if((j|0)==5){k=c[b>>2]|0;if(d){c[b>>2]=k&-5;break}else{c[b>>2]=k|4;break}}else if(h<<16>>16==120){k=c[b>>2]|0;if(d){c[b>>2]=k&-33;break}else{c[b>>2]=k|32;break}}else if(h<<16>>16==115){k=c[b>>2]|0;if(d){c[b>>2]=k&-17;break}else{c[b>>2]=k|16;break}}else break a;while(0);h=(c[g>>2]|0)+1|0;c[g>>2]=h;a=h}i=e;return}function i0e(a){a=a|0;var b=0;b=i;u1e(a);I0e(c[a+8>>2]|0,0);i=b;return}function j0e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+8|0;g=b+12|0;b=(Wof(c[f>>2]|0,c[g>>2]|0)|0)<<16>>16==60;h=c[f>>2]|0;f=c[g>>2]|0;if(b){b=Wof(h,f+1|0)|0;if(b<<16>>16==33)a[d+13>>0]=1;else if(b<<16>>16==61)a[d+13>>0]=0;else{j=0;i=e;return j|0}a[d+12>>0]=1;k=(c[g>>2]|0)+2|0}else{b=Wof(h,f)|0;if(b<<16>>16==33)a[d+13>>0]=1;else if(b<<16>>16==61)a[d+13>>0]=0;else{j=0;i=e;return j|0}a[d+12>>0]=0;k=(c[g>>2]|0)+1|0}c[g>>2]=k;j=1;i=e;return j|0}function k0e(a,b){a=a|0;b=b|0;var d=0;d=i;K0e(c[a+8>>2]|0,2,b);i=d;return}function l0e(a){a=a|0;var b=0,d=0;b=i;d=A$e(0,c[a+8>>2]|0,a+12|0)|0;i=b;return d|0}function m0e(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function n0e(a){a=a|0;var b=0;b=i;f0e(a);c[a+20>>2]=0;i=b;return}function o0e(a){a=a|0;return (c[a+16>>2]|0)!=0|0}function p0e(b,c){b=b|0;c=c|0;a[b+13>>0]=c&1;return}function q0e(b,c){b=b|0;c=c|0;a[b+12>>0]=c&1;return}function r0e(a,b){a=a|0;b=b|0;var d=0;d=i;u1e(a);c[a+20>>2]=b;i=d;return}function s0e(a,b){a=a|0;b=b|0;return (b&256|0)!=0|0}function t0e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;a[b+8>>0]=d&1;a[b+9>>0]=e&1;RI(2304240)|0;e=qL(2304240)|0;k$e(e);c[b+20>>2]=e;RI(2722504)|0;e=qL(2722504)|0;HNf(e,144);c[b+12>>2]=e;RI(2722504)|0;e=qL(2722504)|0;HNf(e,144);c[b+16>>2]=e;i=f;return}function u0e(a,b){a=a|0;b=b|0;var c=0;c=i;x0e(a,b,b);i=c;return}function v0e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=b&65535;if(d){LNf(c[a+16>>2]|0,f,1);i=e;return}else{LNf(c[a+12>>2]|0,f,1);i=e;return}}function w0e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;$ch();e=b+8|0;f=c[e>>2]|0;g=b+12|0;h=c[g>>2]|0;c[g>>2]=h+1;if((Wof(f,h)|0)<<16>>16!=123)gth(G$e(b,c[882490]|0)|0);h=A$e(0,c[e>>2]|0,g)|0;if(!h)gth(G$e(b,c[882492]|0)|0);f=IZe(0,h)|0;if(f<<16>>16){j=c[e>>2]|0;e=c[g>>2]|0;c[g>>2]=e+1;if((Wof(j,e)|0)<<16>>16==125){i=d;return f|0}else gth(G$e(b,c[882498]|0)|0)}if(a[2540708]|0){k=c[882494]|0;l=c[882496]|0;m=iwf(0,k,h,l)|0;n=G$e(b,m)|0;gth(n)}ath(2540560);k=c[882494]|0;l=c[882496]|0;m=iwf(0,k,h,l)|0;n=G$e(b,m)|0;gth(n);return 0}function x0e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+48|0;g=f+36|0;h=f+24|0;j=f+12|0;k=f;l=d&65535;m=e&65535;n=(d&65535)>(e&65535);e=n?m:l;d=n?l:m;do if(!(a[b+9>>0]|0)){o=e;p=d}else{RI(2306744)|0;if(!(a[2306892]|0)){RI(2306744)|0;ath(2306744)}RI(2306744)|0;m=c[576709]|0;c[h>>2]=e;c[h+4>>2]=d;c[h+8>>2]=1;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];l=X_e(m,g)|0;RI(2306744)|0;m=(a[2306892]|0)==0;if(!l){if(m){RI(2306744)|0;ath(2306744)}RI(2306744)|0;l=c[576709]|0;n=c[l>>2]|0;q=c[l+4>>2]|0;if(!((n|0)<=(e|0)&(n|0)<=(q|0)&(d|0)<=(q|0))){o=e;p=d;break}o=e+32|0;p=d+32|0;break}if(m){RI(2306744)|0;ath(2306744)}RI(2306744)|0;m=(e|0)<(c[c[576709]>>2]|0);RI(2306744)|0;q=(a[2306892]|0)==0;if(m){if(q){RI(2306744)|0;ath(2306744)}RI(2306744)|0;m=(c[c[576709]>>2]|0)+32|0;n=d+32|0;l=(m|0)>(n|0);RI(2306744)|0;r=l?m:n;s=(c[c[576709]>>2]|0)+-1|0;t=e;u=l?n:m}else{if(q){RI(2306744)|0;ath(2306744)}RI(2306744)|0;q=e+32|0;m=(c[(c[576709]|0)+4>>2]|0)+32|0;n=(q|0)>(m|0);RI(2306744)|0;r=n?q:m;s=d;t=(c[(c[576709]|0)+4>>2]|0)+1|0;u=n?m:q}q=c[b+20>>2]|0;c[j>>2]=u;c[j+4>>2]=r;a[j+8>>0]=1;m=j+9|0;a[m+0>>0]=a[2322801]|0;a[m+1>>0]=a[2322802]|0;a[m+2>>0]=a[2322803]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];m$e(q,g);o=t;p=s}while(0);s=c[b+20>>2]|0;c[k>>2]=o;c[k+4>>2]=p;c[k+8>>2]=1;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];m$e(s,g);i=f;return}function y0e(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=w$e(0,c[a+8>>2]|0,a+12|0,b,d,e)|0;i=f;return g|0}function z0e(b,c,d){b=b|0;c=c|0;d=d|0;a[b+12>>0]=c&1;a[b+20>>0]=d&1;return}function A0e(b,c){b=b|0;c=c|0;a[b+12>>0]=c&1;return}function B0e(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function C0e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;e=a+28|0;a=c[e>>2]|0;f=Aqh(2713056,b)|0;eth(2714896,b);a:do if((f|0)>0){g=a;h=0;while(1){j=Krh(2713112,b,h)|0;RI(2306240)|0;k=c[(lth(j,2306240)|0)+12>>2]|0;if((k|0)>(g|0)){l=g;m=h;break a}j=((k|0)==(g|0)&1)+g|0;k=h+1|0;if((k|0)<(f|0)){g=j;h=k}else{l=j;m=k;break}}}else{l=a;m=0}while(0);c[e>>2]=l;if((m|0)<(f|0)){n=l;o=m;p=l}else{i=d;return}while(1){l=Krh(2713112,b,o)|0;RI(2306240)|0;m=(lth(l,2306240)|0)+12|0;l=p;p=c[m>>2]|0;e=(p|0)==(l|0);c[m>>2]=n+(e<<31>>31);o=o+1|0;if((o|0)==(f|0))break;else n=n+(e&1^1)|0}i=d;return}function D0e(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+16|0;h=g;j=g+4|0;c[h>>2]=0;k=d+20|0;l=(a[k>>0]|0)==0;m=Vof(e)|0;if(l){if((m|0)==1){n=0;i=g;return n|0}}else if((m|0)>1){m=0;l=1;while(1){o=(uth(2736488,f,fpf(e,0,l)|0)|0)==0;p=o?m:l;l=l+1|0;if((l|0)>=(Vof(e)|0)){q=p;break}else m=p}if(q){m=uth(2736488,f,fpf(e,0,q)|0)|0;RI(2306240)|0;c[d+8>>2]=lth(m,2306240)|0;c[d+16>>2]=gvf(e,q)|0;n=1;i=g;return n|0}}c[h>>2]=0;q=x$e(0,e,h)|0;if((q|0)==-1){n=0;i=g;return n|0}if((q|0)>=256?(a[k>>0]|0)!=0:0){c[h>>2]=(c[h>>2]|0)+-1;r=(q|0)/8|0}else r=q;b[j>>1]=r&255;RI(2540392)|0;r=pL(2540392,j)|0;j=gvf(e,c[h>>2]|0)|0;if(!(a[2540708]|0))ath(2540560);c[d+16>>2]=fwf(0,r,j)|0;n=1;i=g;return n|0}function E0e(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function F0e(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function G0e(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function H0e(a){a=a|0;var b=0;b=i;fOf(a);i=b;return}function I0e(a,b){a=a|0;b=b|0;var c=0;c=i;Zqh(2647952,uOf(a)|0,b)|0;i=c;return}function J0e(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Bth(2647800,uOf(a)|0,b)|0;RI(2308424)|0;b=lth(d,2308424)|0;i=c;return b|0}function K0e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Dth(2647880,uOf(a)|0,b,c);i=d;return}function L0e(a,b){a=a|0;b=b|0;return}function M0e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function N0e(a){a=a|0;return}function O0e(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=0;c[e>>2]=0;Eth(2312640,a,d,e);a=c[d>>2]|0;i=b;return ((a|0)==(c[e>>2]|0)?a:-1)|0}function P0e(a,b){a=a|0;b=b|0;var c=0,d=0;b=i;c=O0e(a)|0;RI(2312696)|0;d=qL(2312696)|0;Q0e(d,a,c);i=b;return d|0}function Q0e(d,e,f){d=d|0;e=e|0;f=f|0;c[d+8>>2]=e;c[d+16>>2]=0;c[d+24>>2]=f;c[d+20>>2]=0;a[d+28>>0]=0;b[d+12>>1]=0;return}function R0e(a){a=a|0;var b=0,d=0;b=i;RI(2311904)|0;d=qL(2311904)|0;fOf(d);c[a+8>>2]=d;i=b;return}function S0e(a){a=a|0;return c[a+8>>2]|0}function T0e(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=0;c[h>>2]=0;c[b>>2]=2147483647;c[d>>2]=0;if((e|0)>0){j=a+8|0;a=1;k=0;while(1){l=J0e(c[j>>2]|0,k)|0;if(l){Eth(2312640,l,g,h);l=c[g>>2]|0;if((l|0)<(c[b>>2]|0))c[b>>2]=l;l=c[h>>2]|0;if((l|0)>(c[d>>2]|0)){c[d>>2]=l;m=0}else m=0}else m=a;k=k+1|0;if((k|0)==(e|0))break;else a=m}if(!m){i=f;return}}c[d>>2]=0;c[b>>2]=0;i=f;return}function U0e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=bth(2727704,c[a+8>>2]|0)|0;while(1){if(!(jth(2568176,d)|0)){e=0;f=81;break}g=Sqh(2568120,d)|0;RI(2308424)|0;if(Gqh(2313224,lth(g,2308424)|0)|0){e=1;f=94;break}}RI(2568648)|0;g=vL(d,2568648)|0;do if(!g)if((f|0)==94){h=e;i=b;return h|0}else if((f|0)==81)break;else gth(0);else{kth(2568816,g);if((f|0)==94){h=e;i=b;return h|0}else if((f|0)==81)break;else gth(0)}while(0);h=(O0e(a)|0)<1;i=b;return h|0}function V0e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+8|0;a=Aqh(2727648,c[f>>2]|0)|0;if((a|0)<=0){i=e;return}g=a+-1|0;h=0;do{j=c[f>>2]|0;if(d)k=J0e(j,g-h|0)|0;else k=J0e(j,h)|0;vth(2312952,k,b,d);h=h+1|0}while((h|0)!=(a|0));i=e;return}function W0e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=0;c[g>>2]=0;c[b>>2]=0;c[d>>2]=0;h=bth(2727704,c[a+8>>2]|0)|0;while(1){if(!(jth(2568176,h)|0))break;a=Sqh(2568120,h)|0;RI(2308424)|0;Eth(2312640,lth(a,2308424)|0,f,g);c[b>>2]=(c[f>>2]|0)+(c[b>>2]|0);a=c[d>>2]|0;j=c[g>>2]|0;c[d>>2]=(a|0)!=2147483647&(j|0)!=2147483647?j+a|0:2147483647}RI(2568648)|0;d=vL(h,2568648)|0;if(!d)if(129==129){i=e;return}else gth(0);else{kth(2568816,d);if(129==129){i=e;return}else gth(0)}}function X0e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+48|0;g=f+24|0;h=f+12|0;j=f;edh();k=O0e(d)|0;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;ath(2713640)}RI(2713640)|0;l=qL(2713640)|0;$Lf(l);RI(2304240)|0;m=qL(2304240)|0;k$e(m);n=d+8|0;o=Aqh(2727648,c[n>>2]|0)|0;a:do if((o|0)>0){p=o+-1|0;q=0;r=0;while(1){s=c[n>>2]|0;if(e)t=J0e(s,p-r|0)|0;else t=J0e(s,r)|0;s=Fth(2313152,t,e)|0;Erh(2714056,l,s)|0;u=b[s+12>>1]|0;if(u<<16>>16){v=s;w=u;x=q;break}if(c[s+20>>2]|0){b1e(h,s,q);c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];m$e(m,g)}u=c[s+24>>2]|0;if((u|0)<0)break a;r=r+1|0;if((o|0)<=(r|0))break a;else q=u+q|0}q=c[v+16>>2]|0;RI(2312696)|0;r=qL(2312696)|0;$0e(r,d,q+x|0,k,w);y=r;i=f;return y|0}while(0);n$e(m);w=bth(2305800,m)|0;m=-1;x=0;while(1){if(!(jth(2568176,w)|0)){z=m;A=x;break}v=Sqh(2568120,w)|0;RI(2302336)|0;o=ith(v,2302336)|0;v=c[o>>2]|0;g=c[o+4>>2]|0;if((g|0)<(v|0))B=0;else B=1-v+g|0;if((m|0)<(x|0))C=0;else C=m+1-x|0;o=(B|0)>(C|0);m=o?g:m;x=o?v:x}RI(2568648)|0;x=vL(w,2568648)|0;if(!x){if(313!=313)gth(0)}else{kth(2568816,x);if(313!=313)gth(0)}if((A|0)>(z|0)){RI(2312696)|0;x=qL(2312696)|0;Q0e(x,d,k);y=x;i=f;return y|0}b:do if((Aqh(2713056,l)|0)>0){x=j+4|0;w=0;m=0;C=0;B=0;while(1){v=Krh(2713112,l,B)|0;RI(2312696)|0;o=lth(v,2312696)|0;do if(!(c[o+20>>2]|0)){D=m;E=C}else{b1e(j,o,w);v=c[j>>2]|0;g=c[x>>2]|0;if((v|0)<=(g|0)?!((A|0)<=(v|0)&(g|0)<=(z|0)):0){D=m;E=C;break}g=m|(a[o+28>>0]|0)!=0;Jrh(2713888,l,C,o);D=g;E=C+1|0}while(0);g=c[o+24>>2]|0;if((g|0)<0){F=D;G=E;break b}B=B+1|0;if((B|0)>=(Aqh(2713056,l)|0)){F=D;G=E;break}else{w=g+w|0;m=D;C=E}}}else{F=0;G=0}while(0);RI(2971904)|0;E=qL(2971904)|0;Gbg(E);if((G|0)>0){D=G+-1|0;j=0;do{if(e){C=Krh(2713112,l,D-j|0)|0;RI(2312696)|0;H=lth(C,2312696)|0}else{C=Krh(2713112,l,j)|0;RI(2312696)|0;H=lth(C,2312696)|0}Hbg(E,c[H+20>>2]|0)|0;j=j+1|0}while((j|0)!=(G|0))}if((Yeg(E)|0)==(z+1-A|0)){G=Fqh(2972072,E)|0;RI(2312696)|0;j=qL(2312696)|0;g1e(j,d,A,k,G,F);y=j;i=f;return y|0}if((Yeg(E)|0)<=(z+1-A|0)){RI(3079856)|0;A=qL(3079856)|0;Grg(A,c[882666]|0);gth(A)}RI(3032824)|0;if(!(a[3032972]|0)){RI(3032824)|0;ath(3032824)}A=cjg(0)|0;Gth(2816256,A,c[882664]|0);RI(2312696)|0;A=qL(2312696)|0;Q0e(A,d,k);y=A;i=f;return y|0}function Y0e(a){a=a|0;return (b[a+12>>1]|0)!=0|0}function Z0e(a){a=a|0;return c[a+16>>2]|0}function _0e(a){a=a|0;return b[a+12>>1]|0}function $0e(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c[d+8>>2]=e;c[d+16>>2]=f;c[d+24>>2]=g;b[d+12>>1]=h;c[d+20>>2]=0;a[d+28>>0]=0;return}function a1e(a){a=a|0;return (c[a+20>>2]|0)!=0|0}function b1e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(!(c[d+20>>2]|0)){c[b+0>>2]=c[580698];c[b+4>>2]=c[580699];c[b+8>>2]=c[580700];g=-1;h=0}else{j=c[d+16>>2]|0;k=Z1e(d)|0;c[b+0>>2]=c[580698];c[b+4>>2]=c[580699];c[b+8>>2]=c[580700];d=j+e|0;e=k+-1+d|0;k=(d|0)>(e|0);g=k?d:e;h=k?e:d}c[b>>2]=h;c[b+4>>2]=g;a[b+8>>0]=1;i=f;return}function c1e(a){a=a|0;return (c[a+24>>2]|0)<0|0}function d1e(a){a=a|0;return c[a+24>>2]|0}function e1e(b){b=b|0;return (a[b+28>>0]|0)!=0|0}function f1e(a){a=a|0;return c[a+20>>2]|0}function g1e(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;c[d+8>>2]=e;c[d+16>>2]=f;c[d+24>>2]=g;if(j)l=Vvf(h)|0;else l=h;c[d+20>>2]=l;a[d+28>>0]=j&1;b[d+12>>1]=0;i=k;return}function h1e(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+4|0;j=g;c[h>>2]=0;c[j>>2]=0;Eth(2314216,d,h,j);Hth(2295184,e,c[d+12>>2]|0,c[h>>2]|0,c[j>>2]|0);j=Fth(2314288,d,f)|0;h=Ith(2295632,e)|0;Jth(2295416,e,f,c[j+16>>2]|0,h);k=b[j+12>>1]|0;if(!(k<<16>>16)){l=c[j+20>>2]|0;if(l)Lth(2293760,e,l,(a[j+28>>0]|0)!=0,f)}else Kth(2293848,e,k);kth(2293040,e);Mth(2295720,e,h);V0e(d,e,f);kth(2293040,e);i=g;return}function i1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a+12|0;wth(2293936,b,c[f>>2]|0);V0e(a,b,d);wth(2294024,b,c[f>>2]|0);i=e;return}function j1e(a){a=a|0;return 1}function k1e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+12>>2]|0;RI(2306240)|0;a=e-(c[(lth(b,2306240)|0)+12>>2]|0)|0;i=d;return a|0}function l1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=Ith(2295632,b)|0;Nth(2294152,b,c[a+12>>2]|0,c[(c[a+20>>2]|0)+12>>2]|0,(c[a+16>>2]|0)!=0,f);g=a+8|0;a=Aqh(2727648,c[g>>2]|0)|0;if((a|0)<=0){kth(2294224,b);Mth(2295720,b,f);i=e;return}h=a+-1|0;j=0;do{k=c[g>>2]|0;if(d)l=J0e(k,h-j|0)|0;else l=J0e(k,j)|0;vth(2312952,l,b,d);j=j+1|0}while((j|0)!=(a|0));kth(2294224,b);Mth(2295720,b,f);i=e;return}function m1e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Ith(2295632,b)|0;Mth(2294512,b,e);V0e(a,b,c);kth(2293040,b);Mth(2295720,b,e);i=d;return}function n1e(a){a=a|0;return 1}function o1e(a){a=a|0;var b=0,d=0;b=i;d=J0e(c[a+8>>2]|0,0)|0;i=b;return d|0}function p1e(a){a=a|0;return c[a+12>>2]|0}function q1e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=Gqh(2313224,o1e(b)|0)|0;h=Ith(2295632,d)|0;j=c[b+12>>2]|0;k=c[b+16>>2]|0;l=(a[b+20>>0]|0)!=0;if(g){Nth(2294904,d,j,k,l,h);vth(2312952,o1e(b)|0,d,e);Mth(2294992,d,h);i=f;return}else{Nth(2295304,d,j,k,l,h);vth(2312952,o1e(b)|0,d,e);kth(2293040,d);Mth(2295720,d,h);i=f;return}}function r1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Eth(2312640,o1e(a)|0,b,d);c[b>>2]=da(c[b>>2]|0,c[a+12>>2]|0)|0;b=c[d>>2]|0;if((b|0)!=2147483647?(f=c[a+16>>2]|0,(f|0)!=65535):0)g=da(f,b)|0;else g=2147483647;c[d>>2]=g;i=e;return}function s1e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=O0e(d)|0;h=d+12|0;if(!(c[h>>2]|0)){RI(2312696)|0;j=qL(2312696)|0;Q0e(j,d,g);k=j;i=f;return k|0}j=Fth(2313152,o1e(d)|0,e)|0;e=b[j+12>>1]|0;if(e<<16>>16){l=c[j+16>>2]|0;RI(2312696)|0;m=qL(2312696)|0;$0e(m,d,l,g,e);k=m;i=f;return k|0}m=j+20|0;if(!(c[m>>2]|0)){RI(2312696)|0;e=qL(2312696)|0;Q0e(e,d,g);k=e;i=f;return k|0}if(!(t1e(j)|0)){e=c[j+16>>2]|0;l=c[m>>2]|0;n=(a[j+28>>0]|0)!=0;RI(2312696)|0;o=qL(2312696)|0;g1e(o,d,e,g,l,n);k=o;i=f;return k|0}o=c[m>>2]|0;RI(2971904)|0;m=qL(2971904)|0;bcg(m,o);if((c[h>>2]|0)>1){n=1;do{Hbg(m,o)|0;n=n+1|0}while((n|0)<(c[h>>2]|0))}h=Fqh(2972072,m)|0;m=(a[j+28>>0]|0)!=0;RI(2312696)|0;j=qL(2312696)|0;g1e(j,d,0,g,h,m);k=j;i=f;return k|0}function t1e(a){a=a|0;var b=0,d=0;b=i;d=Z1e(a)|0;i=b;return (d|0)==(c[a+24>>2]|0)|0}function u1e(a){a=a|0;var b=0,d=0;b=i;R0e(a);d=a+8|0;I0e(c[d>>2]|0,0);I0e(c[d>>2]|0,0);i=b;return}function v1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;T0e(a,b,d,2);if((X$e(a)|0)!=0?(Z$e(a)|0)!=0:0){i=e;return}c[b>>2]=0;i=e;return}function w1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[a+16>>2]|0;if(!f){vth(2317688,x1e(a)|0,b,d);i=e;return}g=c[f+12>>2]|0;f=Ith(2295632,b)|0;if(!(Z$e(a)|0)){Oth(2294432,b,g,f);vth(2312952,X$e(a)|0,b,d)}else{h=Ith(2295632,b)|0;Oth(2294432,b,g,h);vth(2312952,X$e(a)|0,b,d);Mth(2294784,b,f);Mth(2295720,b,h);vth(2312952,Z$e(a)|0,b,d)}Mth(2295720,b,f);i=e;return}function x1e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}RI(2307584)|0;e=qL(2307584)|0;i0e(e);c[d>>2]=e;Y$e(e,X$e(a)|0);e=c[d>>2]|0;_$e(e,Z$e(a)|0);k0e(c[d>>2]|0,c[a+20>>2]|0);f=c[d>>2]|0;i=b;return f|0}function y1e(a){a=a|0;var b=0,d=0;b=i;if(!(c[a+16>>2]|0)){d=Gqh(2317744,x1e(a)|0)|0;i=b;return d|0}if((X$e(a)|0)!=0?Gqh(2313224,X$e(a)|0)|0:0){d=1;i=b;return d|0}if((Z$e(a)|0)!=0?Gqh(2313224,Z$e(a)|0)|0:0){d=1;i=b;return d|0}d=(O0e(a)|0)<1;i=b;return d|0}function z1e(a){a=a|0;var b=0,d=0;b=i;d=J0e(c[a+8>>2]|0,2)|0;i=b;return d|0}function A1e(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Ith(2295632,c)|0;g=Ith(2295632,c)|0;if(!(a[b+13>>0]|0))Pth(2294608,c,f,g);else Pth(2294608,c,g,f);h=z1e(b)|0;vth(2312952,h,c,(a[b+12>>0]|0)!=0);kth(2293040,c);if(!(X$e(b)|0)){Mth(2295720,c,g);kth(2292968,c);Mth(2295720,c,f);i=e;return}Mth(2295720,c,f);vth(2312952,X$e(b)|0,c,d);if(!(Z$e(b)|0)){Mth(2295720,c,g);i=e;return}else{f=Ith(2295632,c)|0;Mth(2294784,c,f);Mth(2295720,c,g);vth(2312952,Z$e(b)|0,c,d);Mth(2295720,c,f);i=e;return}}function B1e(a){a=a|0;return 1}function C1e(a){a=a|0;return c[a+8>>2]|0}function D1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Ith(2295632,b)|0;g=bth(2727704,c[a+8>>2]|0)|0;while(1){if(!(jth(2568176,g)|0))break;a=Sqh(2568120,g)|0;RI(2308424)|0;h=lth(a,2308424)|0;a=Ith(2295632,b)|0;Mth(2294696,b,a);vth(2312952,h,b,d);Mth(2294784,b,f);Mth(2295720,b,a);kth(2295488,b)}RI(2568648)|0;d=vL(g,2568648)|0;if(!d)if(115==115){kth(2292968,b);Mth(2295720,b,f);kth(2295568,b);i=e;return}else gth(0);else{kth(2568816,d);if(115==115){kth(2292968,b);Mth(2295720,b,f);kth(2295568,b);i=e;return}else gth(0)}}function E1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;T0e(a,b,d,Aqh(2727648,c[a+8>>2]|0)|0);i=e;return}function F1e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;if(!(Vof(b)|0)){i=a;return}if((Vof(b)|0)==1){Qth(2293160,c,Wof(b,0)|0,0,d,e);i=a;return}else{Lth(2293760,c,b,d,e);i=a;return}}function G1e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;F1e(0,c[b+8>>2]|0,d,(a[b+12>>0]|0)!=0,e);i=f;return}function H1e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Vof(c[a+8>>2]|0)|0;c[d>>2]=f;c[b>>2]=f;i=e;return}function I1e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;e=b+8|0;f=Vof(c[e>>2]|0)|0;g=c[e>>2]|0;e=(a[b+12>>0]|0)!=0;RI(2312696)|0;h=qL(2312696)|0;g1e(h,b,0,f,g,e);i=d;return h|0}function J1e(a){a=a|0;return 0}function K1e(a,c,d){a=a|0;c=c|0;d=d|0;d=i;Kth(2293848,c,b[a+8>>1]|0);i=d;return}function L1e(a,b,d){a=a|0;b=b|0;d=d|0;c[d>>2]=0;c[b>>2]=0;return}function M1e(a){a=a|0;return 0}function N1e(a,c){a=a|0;c=c|0;var d=0,e=0;c=i;d=b[a+8>>1]|0;RI(2312696)|0;e=qL(2312696)|0;if(((d&65535)+65534&65535)>>>0<3){$0e(e,a,0,0,d);i=c;return e|0}else{Q0e(e,a,0);i=c;return e|0}return 0}function O1e(a){a=a|0;return c[a+8>>2]|0}function P1e(b){b=b|0;return (a[b+12>>0]|0)!=0|0}function Q1e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Rth(2294336,d,c[(c[b+8>>2]|0)+12>>2]|0,(a[b+12>>0]|0)!=0,e);i=f;return}function R1e(a,b,d){a=a|0;b=b|0;d=d|0;c[b>>2]=0;c[d>>2]=2147483647;return}function S1e(a){a=a|0;return 1}function T1e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(c[b+8>>2]|0)Q1e(b,d,e);g=c[b+16>>2]|0;if(!g){i=f;return}F1e(0,g,d,(a[b+12>>0]|0)!=0,e);i=f;return}function U1e(b){b=b|0;var d=0,e=0;b=i;RI(2306744)|0;d=c[576709]|0;c[d>>2]=65;c[d+4>>2]=90;a[d+8>>0]=1;e=d+9|0;a[e+0>>0]=a[2322801]|0;a[e+1>>0]=a[2322802]|0;a[e+2>>0]=a[2322803]|0;i=b;return}function V1e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;g=b+20|0;h=c[g>>2]|0;RI(2304464)|0;j=qL(2304464)|0;c[j+8>>2]=c[580419];c[j+20>>2]=2321672;c[j+16>>2]=0;k=o$e(h,j)|0;j=Aqh(2305080,k)|0;h=b+12|0;if((NNf(c[h>>2]|0)|0)>0){l=b+16|0;m=j;n=0;while(1){if(!(GNf(c[h>>2]|0,n)|0)?!(GNf(c[l>>2]|0,n)|0):0)o=m;else o=m+1|0;n=n+1|0;if((n|0)>=(NNf(c[h>>2]|0)|0)){p=o;break}else m=o}}else p=j;if(!p){i=f;return}j=Ith(2295632,d)|0;o=(p|0)<2;if(!o)Mth(2295072,d,j);p=bth(2305800,k)|0;k=b+8|0;m=b+9|0;n=0;a:while(1){while(1){if(!(jth(2568176,p)|0)){q=n;r=30;break a}l=Sqh(2568120,p)|0;RI(2302336)|0;s=ith(l,2302336)|0;l=c[s>>2]|0;t=c[s+4>>2]|0;if(!(a[s+8>>0]|0)){u=l;v=t;break}s=(a[k>>0]|0)!=0;w=(a[m>>0]|0)!=0;x=l&65535;if((l|0)==(t|0)){Qth(2293160,d,x,s,w,e);continue}else{Tth(2293520,d,x,t&65535,s,w,e);continue}}w=(v|0)<(u|0);if(w)y=0;else y=1-u+v|0;RI(2722504)|0;s=qL(2722504)|0;HNf(s,y);t=bth(2305800,c[g>>2]|0)|0;b:while(1){if(!(jth(2568176,t)|0))break;x=Sqh(2568120,t)|0;RI(2302336)|0;l=ith(x,2302336)|0;x=c[l>>2]|0;z=c[l+4>>2]|0;if(w|(x|0)>(z|0))continue;if((u|0)<=(x|0)&(z|0)<=(v|0))A=x;else continue;while(1){LNf(s,A-u|0,1);if((A|0)<(z|0))A=A+1|0;else continue b}}RI(2568648)|0;w=vL(t,2568648)|0;if(!w){if(315!=315){B=n;r=21;break}}else{kth(2568816,w);if(315!=315){C=n;r=23;break}}Sth(2293648,d,u&65535,s,(a[k>>0]|0)!=0,(a[m>>0]|0)!=0,e)}if((r|0)==21)FJ(B);else if((r|0)==23)FJ(C);else if((r|0)==30){RI(2568648)|0;r=vL(p,2568648)|0;if(!r){if(467!=467)gth(q)}else{kth(2568816,r);if(467!=467)gth(q)}if((NNf(c[h>>2]|0)|0)>0){q=b+16|0;b=0;do{r=GNf(c[h>>2]|0,b)|0;p=GNf(c[q>>2]|0,b)|0;do if(r){C=a[k>>0]|0;if(p){Uth(2293272,d,2,C<<24>>24!=0,e);break}else{Uth(2293272,d,b&65535,C<<24>>24!=0,e);break}}else if(p)Uth(2293384,d,b&65535,(a[k>>0]|0)!=0,e);while(0);b=b+1|0}while((b|0)<(NNf(c[h>>2]|0)|0))}if(o){i=f;return}if(!(a[k>>0]|0))kth(2292968,d);else kth(2293040,d);Mth(2295720,d,j);i=f;return}}function W1e(a,b,d){a=a|0;b=b|0;d=d|0;c[d>>2]=1;c[b>>2]=1;return}function X1e(a){a=a|0;return 0}function Y1e(b,c){b=b|0;c=c|0;var d=0.0,e=0;b=i;if(!(a[c+8>>0]|0)){d=+(((S_e(c)|0)+15>>4)+3|0);i=b;return +d}else{e=Q_e(c)|0;d=e?2.0:3.0;i=b;return +d}return +(0.0)}function Z1e(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+20>>2]|0;if(!d)e=0;else e=Vof(d)|0;i=b;return e|0}function _1e(a){a=a|0;return}function $1e(a){a=a|0;return}function a2e(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function b2e(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=e;return}function c2e(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=AL(c[a>>2]|0)|0;c[b+4>>2]=AL(c[a+4>>2]|0)|0;c[b+8>>2]=c[a+8>>2];i=d;return}function d2e(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=BL(c[a>>2]|0)|0;c[b+4>>2]=BL(c[a+4>>2]|0)|0;c[b+8>>2]=c[a+8>>2];i=d;return}function e2e(a){a=a|0;var b=0,d=0;b=i;zL(c[a>>2]|0);c[a>>2]=0;d=a+4|0;zL(c[d>>2]|0);c[d>>2]=0;i=b;return}function f2e(a,b){a=a|0;b=b|0;var c=0;c=i;g2e(a,b,0);i=c;return}function g2e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;gdh();if(!(a[2540708]|0))ath(2540560);g=c[c[635163]>>2]|0;c[b+16>>2]=g;c[b+20>>2]=g;c[b+24>>2]=-1;c[b+28>>2]=g;c[b+32>>2]=g;c[b+36>>2]=g;c[b+40>>2]=g;g=b+46|0;a[g>>0]=1;a[b+47>>0]=e&1;c[b+12>>2]=d;h2e(b,1);if(a[g>>0]|0){i=f;return}if(!(a[2540708]|0))ath(2540560);f=gwf(0,c[882690]|0,d)|0;RI(2325408)|0;d=qL(2325408)|0;Hrg(d,f);gth(d)}function h2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;K2e(b,d,c[b+12>>2]|0);if(a[b+47>>0]|0){i=e;return}d=b+20|0;f=c[d>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}g=J2e(0,f,0,1,0)|0;c[d>>2]=g;if(((Vof(g)|0)>=2?(Wof(c[d>>2]|0,0)|0)<<16>>16!=91:0)?(g=c[d>>2]|0,(Wof(g,(Vof(g)|0)+-1|0)|0)<<16>>16!=93):0){g=c[d>>2]|0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}c[d>>2]=Wvf(g,eKf(0)|0)|0}g=b+28|0;if((Vof(c[g>>2]|0)|0)<1){i=e;return}b=c[g>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}c[g>>2]=I2e(0,b)|0;i=e;return}function i2e(a,b){a=a|0;b=b|0;var c=0;c=i;Hrg(a,b);i=c;return}function j2e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;a=i;hdh();b=c[882724]|0;RI(2264304)|0;c[c[566099]>>2]=b;b=c[882726]|0;RI(2264304)|0;c[(c[566099]|0)+4>>2]=b;b=c[882728]|0;RI(2264304)|0;c[(c[566099]|0)+8>>2]=b;b=c[882730]|0;RI(2264304)|0;c[(c[566099]|0)+12>>2]=b;b=c[882732]|0;RI(2264304)|0;c[(c[566099]|0)+16>>2]=b;b=c[882734]|0;RI(2264304)|0;c[(c[566099]|0)+20>>2]=b;b=c[882736]|0;RI(2264304)|0;c[(c[566099]|0)+24>>2]=b;b=c[882738]|0;RI(2264304)|0;c[(c[566099]|0)+28>>2]=b;b=c[882740]|0;RI(2264304)|0;c[(c[566099]|0)+32>>2]=b;b=c[882742]|0;RI(2264304)|0;c[(c[566099]|0)+36>>2]=b;b=c[882744]|0;RI(2264304)|0;c[(c[566099]|0)+40>>2]=b;b=c[882746]|0;RI(2264304)|0;c[(c[566099]|0)+44>>2]=b;RI(1158720)|0;b=nth(1158720,8)|0;RI(2264304)|0;d=c[(c[566099]|0)+20>>2]|0;RI(2264304)|0;e=c[(c[566099]|0)+4>>2]|0;f=b+16|0;c[f>>2]=d;c[b+20>>2]=e;c[b+24>>2]=80;RI(2264304)|0;e=c[(c[566099]|0)+24>>2]|0;RI(2264304)|0;d=c[(c[566099]|0)+4>>2]|0;g=c[(c[b>>2]|0)+120>>2]|0;c[f+g>>2]=e;c[f+(g+4)>>2]=d;c[f+(g+8)>>2]=443;RI(2264304)|0;g=c[(c[566099]|0)+12>>2]|0;RI(2264304)|0;d=c[(c[566099]|0)+4>>2]|0;e=c[(c[b>>2]|0)+120>>2]<<1;c[f+e>>2]=g;c[f+(e+4)>>2]=d;c[f+(e+8)>>2]=21;RI(2264304)|0;e=c[(c[566099]|0)+8>>2]|0;RI(2264304)|0;d=c[(c[566099]|0)+4>>2]|0;g=(c[(c[b>>2]|0)+120>>2]|0)*3|0;c[f+g>>2]=e;c[f+(g+4)>>2]=d;c[f+(g+8)>>2]=-1;RI(2264304)|0;g=c[882748]|0;d=c[(c[b>>2]|0)+120>>2]<<2;c[f+d>>2]=c[(c[566099]|0)+28>>2];c[f+(d+4)>>2]=g;c[f+(d+8)>>2]=25;RI(2264304)|0;d=c[882750]|0;g=(c[(c[b>>2]|0)+120>>2]|0)*5|0;c[f+g>>2]=c[(c[566099]|0)+32>>2];c[f+(g+4)>>2]=d;c[f+(g+8)>>2]=119;RI(2264304)|0;g=c[(c[566099]|0)+36>>2]|0;RI(2264304)|0;d=c[(c[566099]|0)+4>>2]|0;e=(c[(c[b>>2]|0)+120>>2]|0)*6|0;c[f+e>>2]=g;c[f+(e+4)>>2]=d;c[f+(e+8)>>2]=119;RI(2264304)|0;e=c[(c[566099]|0)+16>>2]|0;RI(2264304)|0;d=c[(c[566099]|0)+4>>2]|0;g=(c[(c[b>>2]|0)+120>>2]|0)*7|0;c[f+g>>2]=e;c[f+(g+4)>>2]=d;c[f+(g+8)>>2]=70;RI(2264304)|0;c[(c[566099]|0)+48>>2]=b;i=a;return}function k2e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;idh();e=l2e(a)|0;L7f(b,c[882784]|0,e);i=d;return}function l2e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;m2e(b);e=b+48|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}c[e>>2]=n2e(b,2)|0;f=b+32|0;if((Vof(c[f>>2]|0)|0)>=1){h=c[e>>2]|0;j=c[f>>2]|0;if(!(a[2540708]|0))ath(2540560);c[e>>2]=gwf(0,h,j)|0}j=b+36|0;b=(Vof(c[j>>2]|0)|0)<1;h=c[e>>2]|0;if(b){g=h;i=d;return g|0}b=c[j>>2]|0;if(!(a[2540708]|0))ath(2540560);j=gwf(0,h,b)|0;c[e>>2]=j;g=j;i=d;return g|0}function m2e(b){b=b|0;var d=0;d=i;xdh();if(!(a[b+46>>0]|0)){RI(3084976)|0;b=qL(3084976)|0;osg(b,c[883222]|0);gth(b)}else{i=d;return}}function n2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e;c[f>>2]=0;jdh();m2e(b);if((d|0)==1){g=b+16|0;h=c[g>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(gpf(0,h,c[(c[566099]|0)+28>>2]|0)|0)){h=c[g>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(gpf(0,h,c[(c[566099]|0)+32>>2]|0)|0)){RI(2971904)|0;h=qL(2971904)|0;Gbg(h);Hbg(h,c[g>>2]|0)|0;Hbg(h,z2e(b)|0)|0;j=b+28|0;if((Vof(c[j>>2]|0)|0)>=2?(Wof(c[j>>2]|0,1)|0)<<16>>16==58:0){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}j=c[g>>2]|0;if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(gpf(0,c[(c[566099]|0)+8>>2]|0,j)|0)acg(h,47)|0}j=b+40|0;if((Vof(c[j>>2]|0)|0)>=1)acg(Hbg(h,c[j>>2]|0)|0,64)|0;Hbg(h,c[b+20>>2]|0)|0;j=c[g>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}g=A2e(0,j)|0;j=b+24|0;k=c[j>>2]|0;if(!((k|0)==-1|(k|0)==(g|0))){g=acg(h,58)|0;gfg(g,c[j>>2]|0)|0}l=Fqh(2972072,h)|0;i=e;return l|0}}if(!(a[2540708]|0))ath(2540560);l=c[c[635163]>>2]|0;i=e;return l|0}else if((d|0)==2){RI(2971904)|0;h=qL(2971904)|0;Gbg(h);j=b+16|0;Hbg(h,c[j>>2]|0)|0;Hbg(h,z2e(b)|0)|0;g=b+28|0;if((Vof(c[g>>2]|0)|0)>=2?(Wof(c[g>>2]|0,1)|0)<<16>>16==58:0){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}k=c[j>>2]|0;if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(gpf(0,c[(c[566099]|0)+8>>2]|0,k)|0)acg(h,47)|0}k=b+40|0;if((Vof(c[k>>2]|0)|0)>=1)acg(Hbg(h,c[k>>2]|0)|0,64)|0;Hbg(h,c[b+20>>2]|0)|0;k=c[j>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}m=A2e(0,k)|0;k=b+24|0;n=c[k>>2]|0;if(!((n|0)==-1|(n|0)==(m|0))){m=acg(h,58)|0;gfg(m,c[k>>2]|0)|0}do if((Vof(c[g>>2]|0)|0)>=1){m2e(b);k=c[j>>2]|0;if(k){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;if(!(c[(c[566099]|0)+52>>2]|0)){RI(1838080)|0;m=qL(1838080)|0;dJe(m,2);bsh(1837968,m,c[882794]|0,0);bsh(1837968,m,c[882796]|0,0);RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c[(c[566099]|0)+52>>2]=m}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;m=(dsh(1839256,c[(c[566099]|0)+52>>2]|0,k,f)|0)^1;if(!((c[f>>2]|0)!=0|m)){Hbg(h,c[g>>2]|0)|0;break}}m=c[g>>2]|0;m2e(b);k=c[j>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}Hbg(h,C2e(0,m,B2e(0,k)|0)|0)|0}while(0);l=Fqh(2972072,h)|0;i=e;return l|0}else if(!d){d=c[b+16>>2]|0;h=z2e(b)|0;if(!(a[2540708]|0))ath(2540560);l=gwf(0,d,h)|0;i=e;return l|0}else{l=0;i=e;return l|0}return 0}function o2e(b){b=b|0;var c=0;c=i;m2e(b);i=c;return (a[b+44>>0]|0)!=0|0}function p2e(a){a=a|0;var b=0;b=i;m2e(a);i=b;return c[a+16>>2]|0}function q2e(b){b=b|0;return (a[b+46>>0]|0)!=0|0}function r2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b;c[e>>2]=0;if(!d){f=0;i=b;return f|0}if(!(Vof(d)|0)){f=0;i=b;return f|0}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(s2e(0,d)|0){f=3;i=b;return f|0}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(t2e(0,d)|0){f=2;i=b;return f|0}RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}g=$Xe(0,d,e)|0;f=g?4:0;i=b;return f|0}function s2e(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;e=a;c[e>>2]=0;RI(1136088)|0;f=nth(1136088,1)|0;b[f+16>>1]=46;g=dvf(d,f)|0;if((c[g+12>>2]|0)!=4){h=0;i=a;return h|0}f=g+16|0;d=0;while(1){if(!(Vof(c[f+(da(c[(c[g>>2]|0)+120>>2]|0,d)|0)>>2]|0)|0)){h=0;j=6;break}k=Kqf(0,c[f+(da(c[(c[g>>2]|0)+120>>2]|0,d)|0)>>2]|0,e)|0;d=d+1|0;if(!(k&(c[e>>2]|0)>>>0<256)){h=0;j=6;break}if((d|0)>=4){h=1;j=6;break}}if((j|0)==6){i=a;return h|0}return 0}function t2e(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=Vof(c)|0;if((d|0)>0){e=0;f=0}else{g=1;i=b;return g|0}while(1){h=Wof(c,f)|0;if(!e){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(puf(0,h)|0)j=10;else{g=0;j=13;break}}else if(h<<16>>16!=46){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(!(puf(0,h)|0)?!(h<<16>>16==45|h<<16>>16==95):0){g=0;j=13;break}else j=10}else k=1;if((j|0)==10){j=0;h=e+1|0;if((h|0)==64){g=0;j=13;break}else k=h}f=f+1|0;if((f|0)>=(d|0)){g=1;j=13;break}else e=k}if((j|0)==13){i=b;return g|0}return 0}function u2e(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;b=i;if(!c){d=0;i=b;return d|0}if(!(Vof(c)|0)){d=0;i=b;return d|0}e=Wof(c,0)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!((e+-65<<16>>16&65535)<26|(e+-97<<16>>16&65535)<26)){d=0;i=b;return d|0}e=Vof(c)|0;if((e|0)>1)f=1;else{d=1;i=b;return d|0}while(1){g=Wof(c,f)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}if(!(jpf(0,g)|0)){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!((g+-65<<16>>16&65535)<26|(g+-97<<16>>16&65535)<26)?!(g<<16>>16==43|g<<16>>16==45|g<<16>>16==46):0){d=0;h=15;break}}f=f+1|0;if((f|0)>=(e|0)){d=1;h=15;break}}if((h|0)==15){i=b;return d|0}return 0}function v2e(a,b){a=a|0;b=b|0;a=i;if((b+-65<<16>>16&65535)<26){i=a;return 1}else{i=a;return (b+-97<<16>>16&65535)<26|0}return 0}function w2e(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!c){e=0;i=d;return e|0}RI(2264304)|0;f=vL(c,2264304)|0;if(!f){g=vL(c,2540560)|0;if(!g){e=0;i=d;return e|0}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c=qL(2264304)|0;g2e(c,g,0);h=c}else h=f;e=x2e(b,h)|0;i=d;return e|0}function x2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a[b+46>>0]|0;if(f<<24>>24!=(a[d+46>>0]|0)){g=0;i=e;return g|0}if(!(f<<24>>24)){f=c[b+12>>2]|0;h=c[d+12>>2]|0;if(!(a[2540708]|0))ath(2540560);g=gpf(0,f,h)|0;i=e;return g|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}h=eKf(0)|0;f=Wvf(c[b+16>>2]|0,h)|0;j=Wvf(c[d+16>>2]|0,h)|0;if(!(a[2540708]|0))ath(2540560);if(!(gpf(0,f,j)|0)){g=0;i=e;return g|0}j=Wvf(c[b+20>>2]|0,h)|0;f=Wvf(c[d+20>>2]|0,h)|0;if(!(a[2540708]|0))ath(2540560);if(!(gpf(0,j,f)|0)){g=0;i=e;return g|0}if((c[b+24>>2]|0)!=(c[d+24>>2]|0)){g=0;i=e;return g|0}f=c[b+32>>2]|0;j=c[d+32>>2]|0;if(!(a[2540708]|0))ath(2540560);if(!(gpf(0,f,j)|0)){g=0;i=e;return g|0}j=c[b+28>>2]|0;b=c[d+28>>2]|0;if(!(a[2540708]|0))ath(2540560);g=gpf(0,j,b)|0;i=e;return g|0}function y2e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+56|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}f=eKf(0)|0;if(!(a[b+46>>0]|0)){h=Aqh(2582544,c[b+12>>2]|0)|0;c[e>>2]=h;g=h;i=d;return g|0}else{h=Aqh(2582544,Wvf(c[b+16>>2]|0,f)|0)|0;j=Aqh(2582544,Wvf(c[b+20>>2]|0,f)|0)|0;f=c[b+24>>2]|0;k=Aqh(2582544,c[b+32>>2]|0)|0;l=j^h^f^k^(Aqh(2582544,c[b+28>>2]|0)|0);c[e>>2]=l;g=l;i=d;return g|0}return 0}function z2e(b){b=b|0;var d=0,e=0,f=0;d=i;vdh();if(a[b+45>>0]|0){e=c[883196]|0;i=d;return e|0}f=c[b+16>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}e=T2e(0,f)|0;i=d;return e|0}function A2e(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}e=U2e(0,d)|0;if(!e){f=-1;i=b;return f|0}f=c[e+12>>2]|0;i=b;return f|0}function B2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b;c[e>>2]=0;sdh();if(d){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;if(!(c[(c[566099]|0)+56>>2]|0)){RI(1838080)|0;f=qL(1838080)|0;dJe(f,5);bsh(1837968,f,c[883164]|0,0);bsh(1837968,f,c[883166]|0,0);bsh(1837968,f,c[883168]|0,0);bsh(1837968,f,c[883170]|0,0);bsh(1837968,f,c[883172]|0,0);RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c[(c[566099]|0)+56>>2]=f}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;f=(dsh(1839256,c[(c[566099]|0)+56>>2]|0,d,e)|0)^1;if(!((c[e>>2]|0)!=0|f)){g=1;i=b;return g|0}}g=0;i=b;return g|0}function C2e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;tdh();if(!(a[2540708]|0))ath(2540560);if(gpf(0,d,c[883176]|0)|0){f=d;i=b;return f|0}RI(2971904)|0;g=qL(2971904)|0;Gbg(g);if(e){if((Vof(d)|0)>0){e=0;do{h=Wof(d,e)|0;do if(h<<16>>16==37){if((e|0)>=((Vof(d)|0)+-2|0)){acg(g,37)|0;j=e;break}k=Wof(d,e+1|0)|0;l=e+2|0;m=Wof(d,l)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;ath(2540392)}n=vuf(0,m)|0;if(!(k<<16>>16==50&n<<16>>16==70)?!(k<<16>>16==53&n<<16>>16==67):0){acg(g,37)|0;j=e;break}acg(g,47)|0;j=l}else if(h<<16>>16==92){acg(g,47)|0;j=e}else{acg(g,h)|0;j=e}while(0);e=j+1|0}while((e|0)<(Vof(d)|0))}o=Fqh(2972072,g)|0}else o=Qvf(d,92,47)|0;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;ath(2713640)}RI(2713640)|0;d=qL(2713640)|0;$Lf(d);if((Vof(o)|0)>0){e=0;do{j=Dvf(o,47,e)|0;if((j|0)==-1)p=Vof(o)|0;else p=j;j=fpf(o,e,p-e|0)|0;e=p+1|0;do if(Vof(j)|0){if(!(a[2540708]|0))ath(2540560);if(!(gpf(0,j,c[883178]|0)|0)){if(!(a[2540708]|0))ath(2540560);if(!(gpf(0,j,c[883180]|0)|0)){Erh(2714056,d,j)|0;break}h=Aqh(2713056,d)|0;if(h)Lrh(2714560,d,h+-1|0)}}while(0)}while((e|0)<(Vof(o)|0))}if(!(Aqh(2713056,d)|0)){f=c[883182]|0;i=b;return f|0}Zeg(g,0);if((Wof(o,0)|0)<<16>>16==47)acg(g,47)|0;e=bth(2714784,d)|0;d=1;while(1){if(!(jth(2568176,e)|0))break;p=lth(Sqh(2568120,e)|0,2540560)|0;if(!d)acg(g,47)|0;Hbg(g,p)|0;d=0}RI(2568648)|0;d=vL(e,2568648)|0;if(!d){if(583!=583)gth(0)}else{kth(2568816,d);if(583!=583)gth(0)}if(xvf(o,c[883184]|0)|0)acg(g,47)|0;f=Fqh(2972072,g)|0;i=b;return f|0}function D2e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;f=d+2|0;g=d;ldh();h=e&65535;if((e&65535)>=256){RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[882808]|0);gth(e)}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;b[f>>1]=Wof(c[c[566099]>>2]|0,h>>>4&15)|0;RI(2540392)|0;e=pL(2540392,f)|0;RI(2264304)|0;b[g>>1]=Wof(c[c[566099]>>2]|0,h&15)|0;RI(2540392)|0;h=pL(2540392,g)|0;if(a[2540708]|0){j=c[882810]|0;k=hwf(0,j,e,h)|0;i=d;return k|0}ath(2540560);j=c[882810]|0;k=hwf(0,j,e,h)|0;i=d;return k|0}function E2e(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=i;if((d+3|0)>(Vof(c)|0)){e=0;i=b;return e|0}if((Wof(c,d)|0)<<16>>16!=37){e=0;i=b;return e|0}f=Wof(c,d+1|0)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(ZXe(0,f)|0)){e=0;i=b;return e|0}f=Wof(c,d+2|0)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}e=ZXe(0,f)|0;i=b;return e|0}function F2e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=d+32|0;if((Vof(c[h>>2]|0)|0)>=1){if((Wof(c[h>>2]|0,0)|0)<<16>>16==63){b[g>>1]=63;RI(2540392)|0;j=pL(2540392,g)|0;g=gvf(c[h>>2]|0,1)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}k=G2e(0,g,0)|0;if(!(a[2540708]|0))ath(2540560);l=fwf(0,j,k)|0}else{k=c[h>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}l=G2e(0,k,0)|0}if(!(a[2540708]|0))ath(2540560);c[e>>2]=gwf(0,c[e>>2]|0,l)|0}l=d+36|0;if((Vof(c[l>>2]|0)|0)<1){i=f;return}d=c[l>>2]|0;if(!(a[2540708]|0))ath(2540560);c[e>>2]=gwf(0,c[e>>2]|0,d)|0;i=f;return}function G2e(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;g=d;h=d+4|0;c[g>>2]=0;b[h>>1]=0;ndh();if(!e){if(!(a[2540708]|0))ath(2540560);j=c[c[635163]>>2]|0;i=d;return j|0}RI(2971904)|0;k=qL(2971904)|0;Gbg(k);l=Vof(e)|0;c[g>>2]=0;if((l|0)>0){m=0;do{n=Wof(e,m)|0;if(n<<16>>16==37){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}o=M2e(0,e,g,h)|0;do if(!(o<<16>>16==35&f)){if(o<<16>>16==37&f){Hbg(k,c[882842]|0)|0;break}if(o<<16>>16==63&f){Hbg(k,c[882844]|0)|0;break}acg(k,o)|0;p=b[h>>1]|0;if(p<<16>>16)acg(k,p)|0}else Hbg(k,c[882840]|0)|0;while(0);o=(c[g>>2]|0)+-1|0;c[g>>2]=o;q=o}else{acg(k,n)|0;q=m}m=q+1|0;c[g>>2]=m}while((m|0)<(l|0))}j=Fqh(2972072,k)|0;i=d;return j|0}function H2e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+52|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}if(!(a[b+46>>0]|0))h=Vth(2325576,b,c[b+28>>2]|0)|0;else{f=n2e(b,2)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}h=G2e(0,f,1)|0}c[e>>2]=h;F2e(b,e);g=c[e>>2]|0;i=d;return g|0}function I2e(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}d=J2e(0,c,0,1,1)|0;i=b;return d|0}function J2e(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;mdh();if(!e){if(!(a[2540708]|0))ath(2540560);j=c[c[635163]>>2]|0;i=d;return j|0}RI(2971904)|0;k=qL(2971904)|0;Gbg(k);l=Vof(e)|0;if((l|0)>0){m=0;do{RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(E2e(0,e,m)|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;ath(2978896)}n=leg(0)|0;RI(1136088)|0;o=nth(1136088,1)|0;b[o+16>>1]=Wof(e,m)|0;p=Wth(2993568,n,o)|0;o=c[p+12>>2]|0;if((o|0)>0){n=p+16|0;q=0;do{r=a[n+(da(c[(c[p>>2]|0)+120>>2]|0,q)|0)>>0]|0;s=r&255;do if((r+-33<<24>>24&255)<=93?!((Cvf(c[882822]|0,s)|0)!=-1|r<<24>>24==35&g):0){if(h?r<<24>>24==93|r<<24>>24==91:0){t=18;break}if(f?(Cvf(c[882824]|0,s)|0)!=-1:0){t=18;break}acg(k,s)|0}else t=18;while(0);if((t|0)==18){t=0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}Hbg(k,D2e(0,s)|0)|0}q=q+1|0}while((q|0)!=(o|0));u=m}else u=m}else{Hbg(k,fpf(e,m,3)|0)|0;u=m+2|0}m=u+1|0}while((m|0)<(l|0))}j=Fqh(2972072,k)|0;i=d;return j|0}function K2e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;qdh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[882890]|0);gth(f)}f=Q2e(a,b,d)|0;if(!f){i=e;return}else{RI(2325408)|0;e=qL(2325408)|0;Hrg(e,f);gth(e)}}function L2e(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}d=G2e(0,c,0)|0;i=b;return d|0}function M2e(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;udh();b[h>>1]=0;if(!f){RI(2965048)|0;j=qL(2965048)|0;Rbg(j,c[883190]|0);gth(j)}if((c[g>>2]|0)<0){RI(2964880)|0;k=qL(2964880)|0;l=c[883192]|0;wdg(k,l);gth(k)}j=Vof(f)|0;if((c[g>>2]|0)>=(j|0)){RI(2964880)|0;k=qL(2964880)|0;l=c[883192]|0;wdg(k,l);gth(k)}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}k=E2e(0,f,c[g>>2]|0)|0;l=c[g>>2]|0;j=l+1|0;if(!k){c[g>>2]=j;m=Wof(f,l)|0;i=e;return m|0}c[g>>2]=l+2;k=Wof(f,j)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}j=_Xe(0,k)|0;k=c[g>>2]|0;c[g>>2]=k+1;n=_Xe(0,Wof(f,k)|0)|0;if(j&8){k=j;o=0;while(1){p=o+1|0;k=k<<1;if(!(k&8)){q=p;r=o;break}else o=p}if((r|0)>0){RI(1159264)|0;o=nth(1159264,q)|0;k=o+16|0;a[k>>0]=n|j<<4;p=1;do{s=c[g>>2]|0;c[g>>2]=s+1;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(E2e(0,f,s)|0)){t=26;break}s=c[g>>2]|0;c[g>>2]=s+1;u=Wof(f,s)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}s=_Xe(0,u)|0;if((s&12|0)!=8){t=26;break}u=c[g>>2]|0;c[g>>2]=u+1;v=Wof(f,u)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}u=(_Xe(0,v)|0|s<<4)&255;a[k+(da(c[(c[o>>2]|0)+120>>2]|0,p)|0)>>0]=u;p=p+1|0}while((p|0)<(q|0));if((t|0)==26){c[g>>2]=l+3;m=d[k>>0]|0;i=e;return m|0}l=c[(c[o>>2]|0)+120>>2]|0;o=d[k>>0]&255>>>(r+2&31);r=1;while(1){g=d[k+(da(l,r)|0)>>0]&63|o<<6;r=r+1|0;if((r|0)==(q|0)){w=g;break}else o=g}if((w|0)>65535){o=w+-65536|0;b[h>>1]=o&1023|56320;m=(o>>>10|55296)&65535;i=e;return m|0}else{m=w&65535;i=e;return m|0}}}m=(n|j<<4)&65535;i=e;return m|0}function N2e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;odh();RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c[d+16>>2]=c[(c[566099]|0)+8>>2];c[d+24>>2]=-1;if(!(a[2540708]|0))ath(2540560);g=c[c[635163]>>2]|0;c[d+36>>2]=g;c[d+32>>2]=g;a[d+44>>0]=1;RI(1136088)|0;g=nth(1136088,1)|0;b[g+16>>1]=92;h=lvf(e,g)|0;g=Cvf(h,92)|0;if((g|0)>=1){e=d+28|0;c[e>>2]=gvf(h,g)|0;c[d+20>>2]=fpf(h,0,g)|0;j=c[e>>2]|0;k=d+28|0;l=c[882854]|0;m=c[882856]|0;n=Rvf(j,l,m)|0;c[k>>2]=n;i=f;return}c[d+20>>2]=h;if(!(a[2540708]|0))ath(2540560);h=c[c[635163]>>2]|0;c[d+28>>2]=h;j=h;k=d+28|0;l=c[882854]|0;m=c[882856]|0;n=Rvf(j,l,m)|0;c[k>>2]=n;i=f;return}function O2e(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;pdh();if(((Vof(d)|0)>=3?(Wof(d,2)|0)<<16>>16!=92:0)?(Wof(d,2)|0)<<16>>16!=47:0){f=c[882864]|0;i=e;return f|0}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c[b+16>>2]=c[(c[566099]|0)+8>>2];if(!(a[2540708]|0))ath(2540560);c[b+20>>2]=c[c[635163]>>2];c[b+24>>2]=-1;c[b+28>>2]=Rvf(d,c[882866]|0,c[882868]|0)|0;d=c[c[635163]>>2]|0;c[b+36>>2]=d;c[b+32>>2]=d;f=0;i=e;return f|0}function P2e(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;a[d+8>>0]=1;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c[d+16>>2]=c[(c[566099]|0)+8>>2];c[d+24>>2]=-1;if(!(a[2540708]|0))ath(2540560);h=c[c[635163]>>2]|0;c[d+36>>2]=h;c[d+32>>2]=h;c[d+20>>2]=h;h=d+28|0;c[h>>2]=0;if(((Vof(e)|0)>=2?(Wof(e,0)|0)<<16>>16==47:0)?(Wof(e,1)|0)<<16>>16==47:0){RI(1136088)|0;d=nth(1136088,1)|0;b[d+16>>1]=47;j=lvf(e,d)|0;b[g>>1]=47;RI(2540392)|0;d=pL(2540392,g)|0;if(!(a[2540708]|0))ath(2540560);g=fwf(0,d,j)|0;c[h>>2]=g;k=j;l=g}else{k=e;l=c[h>>2]|0}if(l){i=f;return}c[h>>2]=k;i=f;return}function Q2e(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=i;i=i+16|0;h=g+4|0;j=g;k=g+8|0;c[h>>2]=0;c[j>>2]=0;rdh();l=jvf(f)|0;f=Vof(l)|0;if((f|0)==0?(e|0)==0|(e|0)==2:0){a[d+46>>0]=0;m=0;i=g;return m|0}n=(e|0)==2;if(!((f|0)>1|n)){m=c[882900]|0;i=g;return m|0}f=Cvf(l,58)|0;if(!f){m=c[882902]|0;i=g;return m|0}if((f|0)<=-1){if((Wof(l,0)|0)<<16>>16==47){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;ath(2785008)}RI(2785008)|0;if((b[(c[696275]|0)+6>>1]|0)==47){P2e(d,l);if(!n){m=0;i=g;return m|0}a[d+46>>0]=0;m=0;i=g;return m|0}}if(((Vof(l)|0)>=2?(Wof(l,0)|0)<<16>>16==92:0)?(Wof(l,1)|0)<<16>>16==92:0){N2e(d,l);m=0;i=g;return m|0}a[d+46>>0]=0;c[d+28>>2]=l;m=0;i=g;return m|0}if((f|0)==1){e=Wof(l,0)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if((e+-65<<16>>16&65535)<26|(e+-97<<16>>16&65535)<26){m=O2e(d,l)|0;i=g;return m|0}else{m=c[882904]|0;i=g;return m|0}}e=fpf(l,0,f)|0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}o=Wvf(e,eKf(0)|0)|0;e=d+16|0;c[e>>2]=o;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(u2e(0,o)|0)){m=c[882906]|0;i=g;return m|0}o=f+1|0;p=Vof(l)|0;q=Dvf(l,35,o)|0;do if(o2e(d)|0|(q|0)==-1)r=p;else{if(a[d+47>>0]|0){c[d+36>>2]=gvf(l,q)|0;r=q;break}s=gvf(l,q+1|0)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}t=I2e(0,s)|0;if(!(a[2540708]|0))ath(2540560);c[d+36>>2]=gwf(0,c[882908]|0,t)|0;r=q}while(0);q=Evf(l,63,o,r-o|0)|0;if((q|0)!=-1){p=fpf(l,q,r-q|0)|0;t=d+32|0;c[t>>2]=p;if(!(a[d+47>>0]|0)){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}c[t>>2]=I2e(0,p)|0;u=q}else u=q}else u=r;r=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}do if(R2e(0,r)|0){q=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(Iwf(0,q,c[(c[566099]|0)+28>>2]|0)|0){q=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(Iwf(0,q,c[(c[566099]|0)+32>>2]|0)|0){if((u-o|0)>=2){if((Wof(l,o)|0)<<16>>16!=47)break;if((Wof(l,f+2|0)|0)<<16>>16==47)break}m=c[882910]|0;i=g;return m|0}}}while(0);r=u-o|0;if((r|0)>=2?(Wof(l,o)|0)<<16>>16==47:0)v=(Wof(l,f+2|0)|0)<<16>>16==47;else v=0;q=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if((gpf(0,q,c[(c[566099]|0)+8>>2]|0)|0)&v)if((r|0)==2)w=1;else w=(Wof(l,f+3|0)|0)<<16>>16==47;else w=0;q=w&1;do if(v){if(n){m=c[882912]|0;i=g;return m|0}p=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(Iwf(0,p,c[(c[566099]|0)+28>>2]|0)|0){p=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;t=Iwf(0,p,c[(c[566099]|0)+32>>2]|0)|0;x=t?f+3|0:o}else x=o;t=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;a:do if(gpf(0,t,c[(c[566099]|0)+8>>2]|0)|0){p=(x|0)<(u|0);do if(p){s=2;y=x;while(1){if((Wof(l,y)|0)<<16>>16!=47){z=s;break}A=s+1|0;y=y+1|0;if((y|0)>=(u|0)){z=A;break}else s=A}if((z|0)<4){B=z;break}if(p)C=x;else{D=x;E=0;break a}while(1){s=C+1|0;if((Wof(l,C)|0)<<16>>16!=47){D=C;E=0;break a}if((s|0)<(u|0))C=s;else{D=s;E=0;break a}}}else B=2;while(0);D=((B|0)>2&1)+x|0;E=q}else{D=x;E=q}while(0);t=E<<24>>24!=0;if((u-D|0)<2){F=D;G=t;H=104;break}p=(Wof(l,D+1|0)|0)<<16>>16==58;if(t&(p^1)){I=D;J=1;H=108}else{K=D;L=p;H=105}}else{p=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(R2e(0,p)|0){F=o;G=w;H=104}else{c[d+28>>2]=fpf(l,o,r)|0;a[d+45>>0]=1;m=0;i=g;return m|0}}while(0);if((H|0)==104)if(G){I=F;J=1;H=108}else{K=F;L=0;H=105}if((H|0)==105){F=u-K|0;G=Evf(l,47,K,F)|0;if((G|0)!=-1|L^1)M=G;else M=Evf(l,92,K,F)|0;if((M|0)==-1){I=K;J=0;H=108}else{c[d+28>>2]=fpf(l,M,u-M|0)|0;N=K;O=M;H=121}}b:do if((H|0)==108){M=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;do if(Iwf(0,M,c[(c[566099]|0)+28>>2]|0)|0){K=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(Iwf(0,K,c[(c[566099]|0)+32>>2]|0)|0)){H=120;break}c[d+28>>2]=c[882914];if(!J){N=I;O=u;H=121;break b}}else H=120;while(0);if((H|0)==120?!J:0){N=I;O=u;H=121;break}M=d+24|0;c[M>>2]=-1;P=M;Q=I;R=u;S=1;H=137}while(0);c:do if((H|0)==121){u=Evf(l,64,N,O-N|0)|0;if((u|0)==-1)T=N;else{c[d+40>>2]=fpf(l,N,u-N|0)|0;T=u+1|0}u=d+24|0;c[u>>2]=-1;I=O+-1|0;J=Lvf(l,58,I,O-T|0)|0;if((J|0)==-1|(J|0)==(I|0))if((c[u>>2]|0)==-1){P=u;Q=T;R=O;S=0;H=137;break}else{U=T;V=O;W=0;break}I=J+1|0;M=fpf(l,I,O-I|0)|0;do if((Vof(M)|0)>=1){if((Wof(M,(Vof(M)|0)+-1|0)|0)<<16>>16==93)break;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}if(rpf(0,M,7,eKf(0)|0,u)|0?(c[u>>2]|0)>>>0<65536:0){U=T;V=J;W=0;break c}m=c[882916]|0;i=g;return m|0}while(0);if((c[u>>2]|0)!=-1){U=T;V=O;W=0;break}J=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}c[u>>2]=A2e(0,J)|0;U=T;V=O;W=0}while(0);if((H|0)==137){O=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}c[P>>2]=A2e(0,O)|0;U=Q;V=R;W=S}S=fpf(l,U,V-U|0)|0;U=d+20|0;c[U>>2]=S;d:do if(W){b[k>>1]=47;RI(2540392)|0;V=pL(2540392,k)|0;if(!(a[2540708]|0))ath(2540560);l=fwf(0,V,S)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}c[d+28>>2]=C2e(0,l,1)|0;c[U>>2]=c[c[635163]>>2]}else{do if((Vof(S)|0)==2){if((Wof(c[U>>2]|0,1)|0)<<16>>16!=58)break;l=c[U>>2]|0;V=d+28|0;R=c[V>>2]|0;if(!(a[2540708]|0))ath(2540560);c[V>>2]=gwf(0,l,R)|0;c[U>>2]=c[c[635163]>>2];break d}while(0);if(a[d+8>>0]|0){if(!(a[2540708]|0))ath(2540560);gwf(0,c[882918]|0,S)|0;c[U>>2]=c[c[635163]>>2];break}u=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(gpf(0,u,c[(c[566099]|0)+8>>2]|0)|0){a[d+44>>0]=1;break}u=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;R=gpf(0,u,c[(c[566099]|0)+32>>2]|0)|0;u=Vof(c[U>>2]|0)|0;if(R){if((u|0)<1)break;c[d+28>>2]=c[U>>2];if(!(a[2540708]|0))ath(2540560);c[U>>2]=c[c[635163]>>2];break}if(u)break;u=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;do if(!(gpf(0,u,c[(c[566099]|0)+20>>2]|0)|0)){R=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(gpf(0,R,c[(c[566099]|0)+16>>2]|0)|0)break;R=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(gpf(0,R,c[(c[566099]|0)+36>>2]|0)|0)break;R=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(gpf(0,R,c[(c[566099]|0)+24>>2]|0)|0)break;R=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(gpf(0,R,c[(c[566099]|0)+12>>2]|0)|0))break d}while(0);m=c[882920]|0;i=g;return m|0}while(0);if((Vof(c[U>>2]|0)|0)>=1){S=c[U>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(r2e(0,S)|0))H=210;else H=201}else H=201;do if((H|0)==201){if((Vof(c[U>>2]|0)|0)<2)break;if((Wof(c[U>>2]|0,0)|0)<<16>>16!=91)break;S=c[U>>2]|0;if((Wof(S,(Vof(S)|0)+-1|0)|0)<<16>>16!=93)break;S=c[U>>2]|0;RI(2264472)|0;if(!(a[2264620]|0)){RI(2264472)|0;ath(2264472)}if(!($Xe(0,S,h)|0)){H=210;break}S=xYe(c[h>>2]|0,1)|0;if(!(a[2540708]|0))ath(2540560);c[U>>2]=iwf(0,c[882922]|0,S,c[882924]|0)|0}while(0);do if((H|0)==210){h=S2e(d)|0;RI(2324200)|0;if((vL(h,2324200)|0)==0?(S2e(d)|0)!=0:0)break;h=c[U>>2]|0;if(!(a[2540708]|0))ath(2540560);m=iwf(0,c[882926]|0,h,c[882928]|0)|0;i=g;return m|0}while(0);c[j>>2]=0;do if(S2e(d)|0){Xth(2325632,S2e(d)|0,d,j);U=c[j>>2]|0;if(!U)break;m=Fqh(2660392,U)|0;i=g;return m|0}while(0);j=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(Iwf(0,j,c[(c[566099]|0)+28>>2]|0)|0)){m=0;i=g;return m|0}j=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(Iwf(0,j,c[(c[566099]|0)+32>>2]|0)|0)){m=0;i=g;return m|0}j=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}if(!(a[2540708]|0))ath(2540560);RI(2264304)|0;if(!(Iwf(0,j,c[(c[566099]|0)+8>>2]|0)|0)){m=0;i=g;return m|0}j=d+28|0;d=c[j>>2]|0;U=c[e>>2]|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}c[j>>2]=C2e(0,d,B2e(0,U)|0)|0;m=0;i=g;return m|0}function R2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b;c[e>>2]=0;wdh();if(d){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;if(!(c[(c[566099]|0)+60>>2]|0)){RI(1838080)|0;f=qL(1838080)|0;dJe(f,10);bsh(1837968,f,c[883200]|0,0);bsh(1837968,f,c[883202]|0,0);bsh(1837968,f,c[883204]|0,0);bsh(1837968,f,c[883206]|0,0);bsh(1837968,f,c[883208]|0,0);bsh(1837968,f,c[883210]|0,0);bsh(1837968,f,c[883212]|0,0);bsh(1837968,f,c[883214]|0,0);bsh(1837968,f,c[883216]|0,0);bsh(1837968,f,c[883218]|0,0);RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;c[(c[566099]|0)+60>>2]=f}RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;f=(dsh(1839256,c[(c[566099]|0)+60>>2]|0,d,e)|0)^1;if(!((c[e>>2]|0)!=0|f)){g=1;i=b;return g|0}}g=0;i=b;return g|0}function S2e(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;fdh();e=b+60|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}m2e(b);f=c[b+16>>2]|0;RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}b=U2e(0,f)|0;c[e>>2]=b;if(b){g=b;i=d;return g|0}RI(2324200)|0;b=qL(2324200)|0;c[b+8>>2]=c[882684];c[e>>2]=b;g=b;i=d;return g|0}function T2e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;e=0;while(1){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;f=(e|0)<(c[(c[(c[566099]|0)+48>>2]|0)+12>>2]|0);RI(2264304)|0;g=(a[2264452]|0)!=0;if(!f){h=13;break}if(!g){RI(2264304)|0;ath(2264304)}RI(2264304)|0;f=c[(c[566099]|0)+48>>2]|0;j=c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,e)|0)>>2]|0;if(!(a[2540708]|0))ath(2540560);if(gpf(0,j,d)|0){k=e;h=6;break}else e=e+1|0}if((h|0)==6){RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2264304)|0;e=c[(c[566099]|0)+48>>2]|0;l=e+16+(da(c[(c[e>>2]|0)+120>>2]|0,k)|0)|0;m=l+4|0;n=c[m>>2]|0;i=b;return n|0}else if((h|0)==13){if(!g){RI(2264304)|0;ath(2264304)}RI(2264304)|0;l=c[566099]|0;m=l+4|0;n=c[m>>2]|0;i=b;return n|0}return 0}function U2e(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;if(!d){e=0;i=b;return e|0}RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}h3e(0);RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;ath(2686624)}f=Wvf(d,eKf(0)|0)|0;RI(2324536)|0;d=uth(2736488,c[(c[581157]|0)+4>>2]|0,f)|0;RI(2324536)|0;e=lth(d,2324536)|0;i=b;return e|0}function V2e(a){a=a|0;return c[a+12>>2]|0}function W2e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2254280)|0;RI(2330528)|0;gXe(a,ML(c[582648]|0)|0);c[c[d>>2]>>2]=a;i=b;return}function X2e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function Y2e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function Z2e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function _2e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[c[d>>2]>>2]=a;i=b;return}function $2e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[c[d>>2]>>2]=a;i=b;return}function a3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[c[d>>2]>>2]=a;i=b;return}function b3e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];THf(a,b,f);i=e;return}function c3e(b){b=b|0;var d=0;b=i;ydh();RI(2536312)|0;d=qL(2536312)|0;RI(2324536)|0;c[c[581157]>>2]=d;RI(2275808)|0;if(!(a[2275956]|0)){RI(2275808)|0;ath(2275808)}RI(2275808)|0;d=qL(2275808)|0;gZe(d,c[883252]|0,0);RI(2324536)|0;c[(c[581157]|0)+8>>2]=d;RI(2275808)|0;d=qL(2275808)|0;gZe(d,c[883254]|0,0);RI(2324536)|0;c[(c[581157]|0)+12>>2]=d;i=b;return}function d3e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;zdh();m2e(d);g=c[d+16>>2]|0;d=b+8|0;b=c[d>>2]|0;if(!(a[2540708]|0))ath(2540560);if(!(Iwf(0,g,b)|0)){h=0;c[e>>2]=h;i=f;return}b=c[d>>2]|0;if(!(a[2540708]|0))ath(2540560);if(!(Iwf(0,b,c[883304]|0)|0)){h=0;c[e>>2]=h;i=f;return}RI(2325408)|0;b=qL(2325408)|0;Hrg(b,c[883306]|0);h=b;c[e>>2]=h;i=f;return}function e3e(a,b,c){a=a|0;b=b|0;c=c|0;return}function f3e(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function g3e(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function h3e(b){b=b|0;var d=0,e=0;b=i;Adh();RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}RI(2324536)|0;if(c[(c[581157]|0)+4>>2]|0){i=b;return}RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;ath(2730168)}RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;if(!(a[2264452]|0)){RI(2264304)|0;ath(2264304)}RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+8>>2]|0,-1);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+12>>2]|0,21);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+16>>2]|0,70);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+20>>2]|0,80);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+24>>2]|0,443);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+28>>2]|0,25);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+40>>2]|0,-1);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+44>>2]|0,-1);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+32>>2]|0,119);RI(2324200)|0;e=qL(2324200)|0;RI(2264304)|0;i3e(0,d,e,c[(c[566099]|0)+36>>2]|0,119);RI(2324200)|0;e=qL(2324200)|0;i3e(0,d,e,c[883330]|0,389);RI(2324536)|0;e=c[c[581157]>>2]|0;Jag(0,e);RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}RI(2324536)|0;if(!(c[(c[581157]|0)+4>>2]|0)){RI(2324536)|0;if(!(a[2324684]|0)){RI(2324536)|0;ath(2324536)}RI(2324536)|0;c[(c[581157]|0)+4>>2]=d}Kag(0,e);i=b;return}function i3e(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;c[d+8>>2]=e;c[d+12>>2]=f;RI(2324768)|0;if(!(vL(d,2324768)|0)){RI(2324200)|0;g=qL(2324200)|0;c[g+8>>2]=e;c[g+12>>2]=f;Rrh(2734016,b,e,g);bsh(2332472,d,e,f);i=a;return}else{Rrh(2734016,b,e,d);bsh(2332472,d,e,f);i=a;return}}function j3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2244128)|0;c[c[d>>2]>>2]=a;i=b;return}function k3e(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=c[a+44>>2]|0;if(h)k3e(h,b,d,e,f)|0;h=Bn[c[a+8>>2]&255](c[a+16>>2]|0,b,d,e,f)|0;i=g;return h|0}function l3e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gth(SJ(3131272)|0);return 0}function m3e(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function n3e(a,b){a=a|0;b=b|0;return 0}function o3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function p3e(a){a=a|0;return}function q3e(a){a=a|0;return}function r3e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[586314]|0;if(!d){e=MK(2345264)|0;c[586314]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function s3e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[586330]|0;if(!d){e=MK(2345328)|0;c[586330]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function t3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function u3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function v3e(a){a=a|0;return}function w3e(a){a=a|0;var b=0,d=0;b=i;d=x3e(c[a+12>>2]|0,c[a+16>>2]|0,c[a+20>>2]|0)|0;i=b;return d|0}function x3e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;sbh();if(!b){RI(3100960)|0;f=qL(3100960)|0;sug(f,c[879200]|0);Yth(f)}if(!(Vof(b)|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[879202]|0);Yth(f)}if(!d){RI(3100960)|0;f=qL(3100960)|0;sug(f,c[879204]|0);Yth(f)}else{f=A3e(a,b,d)|0;i=e;return f|0}return 0}function y3e(a){a=a|0;var b=0,d=0;b=i;d=z3e(c[a+12>>2]|0,c[a+16>>2]|0,c[a+20>>2]|0)|0;i=b;return d|0}function z3e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[586676]|0;if(!f){g=MK(2346712)|0;c[586676]=g;h=g}else h=f;f=xo[h&2047](a,b,d)|0;i=e;return f|0}function A3e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[586656]|0;if(!f){g=MK(2346632)|0;c[586656]=g;h=g}else h=f;f=xo[h&2047](a,b,d)|0;i=e;return f|0}function B3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2530144)|0;Hnf(a,1);c[c[d>>2]>>2]=a;i=b;return}function C3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2530144)|0;Hnf(a,1);c[c[d>>2]>>2]=a;a=qL(2490056)|0;okf(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function D3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function E3e(a){a=a|0;return c[a>>2]|0}function F3e(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function G3e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[587114]|0;if(!d){e=MK(2348464)|0;c[587114]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function H3e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[587130]|0;if(!d){e=MK(2348528)|0;c[587130]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function I3e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;d=b+12|0;if((c[d>>2]|0)<=0){e=0;i=a;return e|0}f=b+16|0;g=0;h=0;while(1){j=H3e(0,c[f+(da(c[(c[b>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0;if(!j)k=g;else k=1<<(j&31)|g;h=h+1|0;if((h|0)>=(c[d>>2]|0)){e=k;break}else g=k}i=a;return e|0}function J3e(a,b){a=a|0;b=b|0;return c[b>>2]|0}function K3e(a,b){a=a|0;b=b|0;return b|0}function L3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function M3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function N3e(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[587496]|0;if(!b){d=MK(2349992)|0;c[587496]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function O3e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function P3e(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function Q3e(a){a=a|0;return}function R3e(a,b){a=a|0;b=b|0;g[b>>2]=ea(g[a+8>>2]);return}function S3e(a,b){a=a|0;b=b|0;g[b+8>>2]=ea(g[a>>2]);return}function T3e(a){a=a|0;return}function U3e(a){a=a|0;return}function V3e(a){a=a|0;return}function W3e(a){a=a|0;return}function X3e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[587860]|0;if(!d){e=MK(2351448)|0;c[587860]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function Y3e(a){a=a|0;var b=0;b=i;X3e(a);i=b;return}function Z3e(a,b){a=a|0;b=b|0;c[b>>2]=c[a+8>>2];return}function _3e(a,b){a=a|0;b=b|0;c[b+8>>2]=c[a>>2];return}function $3e(a){a=a|0;return}function a4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function b4e(a){a=a|0;var b=0;b=i;d4e(0,a);i=b;return}function c4e(a){a=a|0;return}function d4e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[587990]|0;if(!d){e=MK(2351968)|0;c[587990]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function e4e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[588016]|0;if(!d){e=MK(2352072)|0;c[588016]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function f4e(a,b){a=a|0;b=b|0;var c=0;a=i;c=g4e(0,b)|0;i=a;return c|0}function g4e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[588034]|0;if(!d){e=MK(2352144)|0;c[588034]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function h4e(a,b){a=a|0;b=b|0;return}function i4e(a,b){a=a|0;b=b|0;return}function j4e(a){a=a|0;return}function k4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function l4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function m4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function n4e(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[588302]|0;if(!b){d=MK(2353216)|0;c[588302]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function o4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function p4e(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function q4e(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function r4e(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function s4e(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function t4e(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function u4e(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function v4e(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function w4e(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function x4e(a){a=a|0;return c[a+16>>2]|0}function y4e(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function z4e(a){a=a|0;return c[a+20>>2]|0}function A4e(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function B4e(a){a=a|0;return c[a+24>>2]|0}function C4e(a,b){a=a|0;b=b|0;c[a+24>>2]=b;return}function D4e(a){a=a|0;return c[a+28>>2]|0}function E4e(a,b){a=a|0;b=b|0;c[a+28>>2]=b;return}function F4e(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+4|0;e=b+16|0;f=b+8|0;h=b+20|0;j=b+28|0;k=b;l=b+12|0;m=b+24|0;c[d>>2]=c[a+16>>2];n=Rof(d)|0;c[e>>2]=c[a+20>>2];d=Rof(e)|0;c[f>>2]=c[a+24>>2];e=Rof(f)|0;c[h>>2]=c[a+28>>2];f=Rof(h)|0;g[j>>2]=ea(g[a>>2]);h=kxf(j)|0;g[k>>2]=ea(g[a+4>>2]);j=kxf(k)|0;g[l>>2]=ea(g[a+8>>2]);k=kxf(l)|0;g[m>>2]=ea(g[a+12>>2]);a=d<<2^n^e>>2^f>>1^h<<5^j<<4^k>>4^(kxf(m)|0)>>3;i=b;return a|0}function G4e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=Im,q=Im,r=Im,s=0,t=0,u=0,v=Im,w=Im,x=Im,y=Im;d=i;i=i+48|0;e=d+44|0;f=d+40|0;h=d+36|0;j=d+32|0;k=d+16|0;l=d;c[e>>2]=0;c[f>>2]=0;c[h>>2]=0;c[j>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;RI(2353592)|0;if(!(vL(b,2353592)|0)){m=0;i=d;return m|0}RI(2353592)|0;n=Zth(b,2353592)|0;o=ea(g[n>>2]);p=ea(g[n+4>>2]);q=ea(g[n+8>>2]);r=ea(g[n+12>>2]);b=c[n+16>>2]|0;s=c[n+20>>2]|0;t=c[n+24>>2]|0;u=c[n+28>>2]|0;c[e>>2]=c[a+16>>2];if(!(Tof(e,b)|0)){m=0;i=d;return m|0}c[f>>2]=c[a+20>>2];if(!(Tof(f,s)|0)){m=0;i=d;return m|0}c[h>>2]=c[a+24>>2];if(!(Tof(h,t)|0)){m=0;i=d;return m|0}c[j>>2]=c[a+28>>2];if(!(Tof(j,u)|0)){m=0;i=d;return m|0}v=ea(g[a>>2]);w=ea(g[a+4>>2]);x=ea(g[a+8>>2]);y=ea(g[a+12>>2]);g[k>>2]=v;g[k+4>>2]=w;g[k+8>>2]=x;g[k+12>>2]=y;g[l>>2]=o;g[l+4>>2]=p;g[l+8>>2]=q;g[l+12>>2]=r;RI(2353760)|0;m=I4e(k,pL(2353760,l)|0)|0;i=d;return m|0}function H4e(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);g[a>>2]=b;g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=e;return}function I4e(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=Im,h=Im,j=Im,k=Im;c=i;RI(2353760)|0;if(!(vL(b,2353760)|0)){d=0;i=c;return d|0}RI(2353760)|0;e=Zth(b,2353760)|0;f=ea(g[e>>2]);h=ea(g[e+4>>2]);j=ea(g[e+8>>2]);k=ea(g[e+12>>2]);if(!(jxf(a,f)|0)){d=0;i=c;return d|0}if(!(jxf(a+4|0,h)|0)){d=0;i=c;return d|0}if(!(jxf(a+8|0,j)|0)){d=0;i=c;return d|0}d=jxf(a+12|0,k)|0;i=c;return d|0}function J4e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;a=i;if((c[b+16>>2]|0)!=(c[d+16>>2]|0)){e=0;i=a;return e|0}if((c[b+20>>2]|0)!=(c[d+20>>2]|0)){e=0;i=a;return e|0}if((c[b+24>>2]|0)!=(c[d+24>>2]|0)){e=0;i=a;return e|0}if((c[b+28>>2]|0)!=(c[d+28>>2]|0)){e=0;i=a;return e|0}f=ea(g[b>>2]);h=ea(g[b+4>>2]);j=ea(g[b+8>>2]);k=ea(g[b+12>>2]);l=ea(g[d>>2]);m=ea(g[d+4>>2]);n=ea(g[d+8>>2]);o=ea(f-l);l=ea(h-m);m=ea(j-n);n=ea(k-ea(g[d+12>>2]));e=ea(ea(ea(ea(o*o)+ea(l*l))+ea(m*m))+ea(n*n))<ea(9.99999943e-11);i=a;return e|0}function K4e(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[b+12>>2]);i=ea(g[c>>2]);j=ea(g[c+4>>2]);k=ea(g[c+8>>2]);l=ea(d-i);i=ea(e-j);j=ea(f-k);k=ea(h-ea(g[c+12>>2]));c=ea(ea(ea(ea(l*l)+ea(i*i))+ea(j*j))+ea(k*k))<ea(9.99999943e-11);return c|0}function L4e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;a=i;if(!(((c[b+16>>2]|0)==(c[d+16>>2]|0)?(c[b+20>>2]|0)==(c[d+20>>2]|0):0)&(c[b+24>>2]|0)==(c[d+24>>2]|0)&(c[b+28>>2]|0)==(c[d+28>>2]|0))){e=1;i=a;return e|0}f=ea(g[d+12>>2]);h=ea(g[d+8>>2]);j=ea(g[d+4>>2]);k=ea(g[d>>2]);l=ea(g[b+12>>2]);m=ea(g[b+8>>2]);n=ea(g[b+4>>2]);o=ea(ea(g[b>>2])-k);k=ea(n-j);j=ea(m-h);h=ea(l-f);e=!(ea(ea(h*h)+ea(ea(j*j)+ea(ea(k*k)+ea(o*o))))<ea(9.99999943e-11));i=a;return e|0}function M4e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[589006]|0;if(!e){f=MK(2356032)|0;c[589006]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function N4e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;P4e(0,b,c,d,-1,1);i=a;return}function O4e(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;P4e(0,b,c,d,e,1);i=a;return}function P4e(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;a=i;h=c[589028]|0;if(!h){j=MK(2356120)|0;c[589028]=j;k=j}else k=h;En[k&127](b,d,e,f,g);i=a;return}function Q4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function R4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2528920)|0;Enf(a);c[c[d>>2]>>2]=a;i=b;return}function S4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function T4e(a){a=a|0;return c[a>>2]|0}function U4e(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function V4e(a){a=a|0;return c[a+4>>2]|0}function W4e(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function X4e(a){a=a|0;return c[a+8>>2]|0}function Y4e(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Z4e(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[589460]|0;if(!b){d=MK(2357848)|0;c[589460]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function _4e(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[589470]|0;if(!b){d=MK(2357888)|0;c[589470]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function $4e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function a5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function b5e(a){a=a|0;return}function c5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[589576]|0;if(!d){e=MK(2358312)|0;c[589576]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function d5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[589594]|0;if(!d){e=MK(2358384)|0;c[589594]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function e5e(a){a=a|0;var b=0,c=0;b=i;c=c5e(0,a)|0;i=b;return c|0}function f5e(a,b){a=a|0;b=b|0;tbh();RI(2589312)|0;b=qL(2589312)|0;Vxf(b,c[879262]|0);Yth(b)}function g5e(a){a=a|0;var b=0,c=0;b=i;c=d5e(0,a)|0;i=b;return c|0}function h5e(a,b){a=a|0;b=b|0;ubh();RI(2589312)|0;b=qL(2589312)|0;Vxf(b,c[879274]|0);Yth(b)}function i5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[589612]|0;if(!e){f=MK(2358456)|0;c[589612]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function j5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function k5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function l5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function m5e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;n5e(0,a);Lrh(2359656,a,b);Lrh(2359712,a,c);o5e(a,d);p5e(a,7);q5e(0,a,(n4e(0)|0)==1);i=e;return}function n5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[589942]|0;if(!d){e=MK(2359776)|0;c[589942]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function o5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[590082]|0;if(!e){f=MK(2360336)|0;c[590082]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function p5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[590116]|0;if(!e){f=MK(2360472)|0;c[590116]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function q5e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[590056]|0;if(!e){f=MK(2360232)|0;c[590056]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function r5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[589966]|0;if(!d){e=MK(2359872)|0;c[589966]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function s5e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[589986]|0;if(!e){f=MK(2359952)|0;c[589986]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function t5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[590010]|0;if(!d){e=MK(2360048)|0;c[590010]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function u5e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[590032]|0;if(!e){f=MK(2360136)|0;c[590032]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function v5e(a){a=a|0;var b=0,c=0;b=i;c=r5e(0,a)|0;i=b;return c|0}function w5e(a,b){a=a|0;b=b|0;var c=0;c=i;s5e(0,a,b);i=c;return}function x5e(a){a=a|0;var b=0,c=0;b=i;c=t5e(0,a)|0;i=b;return c|0}function y5e(a,b){a=a|0;b=b|0;var c=0;c=i;u5e(0,a,b);i=c;return}function z5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[590098]|0;if(!e){f=MK(2360400)|0;c[590098]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function A5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[590136]|0;if(!e){f=MK(2360552)|0;c[590136]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function B5e(a){a=a|0;var b=0,c=0;b=i;c=C5e(0,a)|0;i=b;return c|0}function C5e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[590154]|0;if(!d){e=MK(2360624)|0;c[590154]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function D5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function E5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function F5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function G5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function H5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function I5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function J5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function K5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function L5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function M5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function N5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function O5e(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=P5e(0,a,b)|0;i=c;return d|0}function P5e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[590728]|0;if(!e){f=MK(2362920)|0;c[590728]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Q5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function R5e(a,b,d){a=a|0;b=b|0;d=ea(d);c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];g[a+16>>2]=d;return}function S5e(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a>>2]=b;g[a+4>>2]=c;return}function T5e(a){a=a|0;var b=0;b=i;U5e(a);i=b;return}function U5e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[591044]|0;if(!d){e=MK(2364184)|0;c[591044]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function V5e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[591054]|0;if(!d){e=MK(2364224)|0;c[591054]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function W5e(a){a=a|0;var b=0;b=i;V5e(a);i=b;return}function X5e(a,b){a=a|0;b=b|0;c[b>>2]=c[a+8>>2];return}function Y5e(a,b){a=a|0;b=b|0;c[b+8>>2]=c[a>>2];return}function Z5e(a){a=a|0;return}function _5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function $5e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function a6e(a){a=a|0;return}function b6e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function c6e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)c6e(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function d6e(a,b){a=a|0;b=b|0;var d=0;d=i;ko[c[(c[a+20>>2]|0)+4>>2]&4095](b);i=d;return}function e6e(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function f6e(a,b){a=a|0;b=b|0;return}function g6e(b){b=b|0;var d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=b;vbh();RI(2365280)|0;g[c[591343]>>2]=ea(10.0);f=Aqh(2582544,c[879278]|0)|0;RI(2365280)|0;c[(c[591343]|0)+28>>2]=f;f=Aqh(2582544,c[879280]|0)|0;RI(2365280)|0;c[(c[591343]|0)+32>>2]=f;f=Aqh(2582544,c[879282]|0)|0;RI(2365280)|0;c[(c[591343]|0)+36>>2]=f;f=Aqh(2582544,c[879284]|0)|0;RI(2365280)|0;c[(c[591343]|0)+40>>2]=f;f=Aqh(2582544,c[879286]|0)|0;RI(2365280)|0;c[(c[591343]|0)+44>>2]=f;f=Aqh(2582544,c[879288]|0)|0;RI(2365280)|0;c[(c[591343]|0)+48>>2]=f;f=Aqh(2582544,c[879290]|0)|0;RI(2365280)|0;c[(c[591343]|0)+52>>2]=f;RI(2530648)|0;f=qL(2530648)|0;Lnf(f);RI(2365280)|0;c[(c[591343]|0)+56>>2]=f;RI(3034456)|0;if(a[3034604]|0){Dpg(e,0);c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];h6e(0,d);i=b;return}RI(3034456)|0;_th(3034456);Dpg(e,0);c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];h6e(0,d);i=b;return}function h6e(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2365280)|0;if(!(a[2365428]|0)){RI(2365280)|0;_th(2365280)}RI(2365280)|0;e=(c[591343]|0)+64|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];i=b;return}function i6e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}j6e(0);if(k6e(0,d)|0)e=d;else{RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}e=l6e(0)|0}RI(2365280)|0;if(a[2365428]|0){RI(2365280)|0;f=c[591343]|0;g=f+8|0;c[g>>2]=e;m6e(e);i=b;return}RI(2365280)|0;_th(2365280);RI(2365280)|0;f=c[591343]|0;g=f+8|0;c[g>>2]=e;m6e(e);i=b;return}function j6e(b){b=b|0;b=i;ybh();RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}if((g8e(0)|0)>0){i=b;return}else{RI(2965048)|0;b=qL(2965048)|0;Rbg(b,c[879406]|0);Yth(b)}}function k6e(a,b){a=a|0;b=b|0;var c=0;a=i;c=(Khf(0,b,0)|0)^1;i=a;return c|0}function l6e(b){b=b|0;var d=0;b=i;RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}RI(2366088)|0;d=a8e(0,c[c[591545]>>2]|0)|0;i=b;return d|0}function m6e(b){b=b|0;var d=0,e=0;d=i;RI(2379632)|0;c[(c[594931]|0)+8>>2]=b;e=c[b+16>>2]|0;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}E8e(0,e);RI(2379632)|0;if(!(c[(c[594931]|0)+4>>2]|0)){i=d;return}RI(2379632)|0;eth(2379376,c[(c[594931]|0)+4>>2]|0);i=d;return}function n6e(b){b=b|0;b=i;RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}j6e(0);RI(2365280)|0;if(!(a[2365428]|0)){RI(2365280)|0;_th(2365280)}RI(2365280)|0;i=b;return c[(c[591343]|0)+8>>2]|0}function o6e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[591564]|0;if(!d){e=MK(2366264)|0;c[591564]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function p6e(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);j=ea(j);k=k|0;var l=0,m=0,n=0,o=0;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}q6e(0,e,1)|0;RI(2365280)|0;if(!(a[2365428]|0)){RI(2365280)|0;_th(2365280)}l=n6e(0)|0;do if((s6e(r6e(0)|0)|0)==8)if(!g){RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}v6e(0,e,k,0);break}else{RI(1100728)|0;m=$th(1100728,2)|0;n=t6e(0,h)|0;Qqh(m,n);o=m+16|0;c[o>>2]=n;n=u6e(0,j)|0;Qqh(m,n);c[o+(c[(c[m>>2]|0)+120>>2]|0)>>2]=n;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}v6e(0,e,k,m);break}while(0);RI(2365280)|0;if(!(a[2365428]|0)){RI(2365280)|0;_th(2365280)}i6e(0,f);Lrh(2365736,d,e);if((s6e(r6e(0)|0)|0)==8){RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}w6e(0)}RI(2365280)|0;if(a[2365428]|0){i6e(0,l);i=b;return}RI(2365280)|0;_th(2365280);i6e(0,l);i=b;return}function q6e(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;i=i+16|0;f=b;c[f>>2]=0;RI(2366312)|0;g=(a[2366460]|0)!=0;if(e){if(!g){RI(2366312)|0;_th(2366312)}RI(2366312)|0;h=(c[591601]|0)+4|0}else{if(!g){RI(2366312)|0;_th(2366312)}RI(2366312)|0;h=c[591601]|0}g=c[h>>2]|0;if(!(Iqh(1337136,g,d,f)|0)){RI(2368616)|0;h=qL(2368616)|0;C6e(h);c[f>>2]=h;Eqh(1336016,g,d,h)}RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}h=c[(c[f>>2]|0)+8>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+8>>2]=h;h=c[(c[f>>2]|0)+12>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+12>>2]=h;h=c[(c[f>>2]|0)+16>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+16>>2]=h;i=b;return c[f>>2]|0}function r6e(a){a=a|0;a=i;RI(2394824)|0;i=a;return c[c[598729]>>2]|0}function s6e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598628]|0;if(!d){e=MK(2394520)|0;c[598628]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function t6e(a,b){a=a|0;b=ea(b);var d=0,e=0;a=i;i=i+16|0;d=a;g[d>>2]=b;RI(2586184)|0;e=pL(2586184,d)|0;RI(2367880)|0;d=qL(2367880)|0;c[d+8>>2]=0;c[d+12>>2]=e;i=a;return d|0}function u6e(a,b){a=a|0;b=ea(b);var d=0,e=0;a=i;i=i+16|0;d=a;g[d>>2]=b;RI(2586184)|0;e=pL(2586184,d)|0;RI(2367880)|0;d=qL(2367880)|0;c[d+8>>2]=1;c[d+12>>2]=e;i=a;return d|0}function v6e(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}g=q6e(0,d,1)|0;h=(s6e(r6e(0)|0)|0)==8;RI(2366312)|0;j=(a[2366460]|0)!=0;if(!h){if(!j){RI(2366312)|0;_th(2366312)}h=c[g+8>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+8>>2]=h;h=c[g+12>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+12>>2]=h;h=c[g+16>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+16>>2]=h;i=b;return}if(!j){RI(2366312)|0;_th(2366312)}RI(2368432)|0;j=qL(2368432)|0;D6e(j);c[g+8>>2]=j;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+8>>2]=j;RI(2366312)|0;H6e(c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0,e);RI(2366312)|0;c[(c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0)+68>>2]=d;if(f){RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;auh(2369e3,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0,f)}RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;eth(2741280,c[(c[(c[591601]|0)+8>>2]|0)+12>>2]|0);RI(2366312)|0;f=c[(c[(c[591601]|0)+8>>2]|0)+12>>2]|0;RI(2366312)|0;Irh(2741560,f,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2368432)|0;f=qL(2368432)|0;D6e(f);c[g+16>>2]=f;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+16>>2]=f;i=b;return}function w6e(b){b=b|0;var d=0,e=0,f=Im,h=Im;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;d=(c[(c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0)+68>>2]|0)==-1;RI(2366312)|0;e=(a[2366460]|0)!=0;if(!d){if(!e){RI(2366312)|0;_th(2366312)}RI(2366312)|0;K6e(0,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2366312)|0;J6e(0,c[(c[(c[591601]|0)+8>>2]|0)+16>>2]|0);i=b;return}if(!e){RI(2366312)|0;_th(2366312)}RI(2366312)|0;eth(2369056,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2366312)|0;e=c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0;d=Z4e(0)|0;RI(2366312)|0;f=ea(g[(c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0)+12>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}h=ea(d|0);buh(2369280,e,ea(0.0),!(h>=f)?h:f);RI(2366312)|0;eth(2369336,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2366312)|0;e=c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0;d=_4e(0)|0;RI(2366312)|0;f=ea(g[(c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0)+20>>2]);h=ea(d|0);buh(2369392,e,ea(0.0),!(h>=f)?h:f);RI(2366312)|0;J6e(0,c[(c[(c[591601]|0)+8>>2]|0)+16>>2]|0);i=b;return}function x6e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function y6e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function z6e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function A6e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function B6e(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return}function C6e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;RI(2368432)|0;d=qL(2368432)|0;D6e(d);e=a+8|0;c[e>>2]=d;RI(2530648)|0;d=qL(2530648)|0;Lnf(d);f=a+12|0;c[f>>2]=d;RI(2368432)|0;d=qL(2368432)|0;D6e(d);c[a+16>>2]=d;Irh(2741560,c[f>>2]|0,c[e>>2]|0);i=b;return}function D6e(b){b=b|0;var d=0,e=0,f=0;d=i;RI(1785128)|0;if(!(a[1785276]|0)){RI(1785128)|0;_th(1785128)}RI(1785128)|0;e=qL(1785128)|0;FGe(e);c[b+52>>2]=e;a[b+56>>0]=1;a[b+64>>0]=1;c[b+68>>2]=-1;c[b+76>>2]=100;c[b+80>>2]=100;g[b+88>>2]=ea(100.0);g[b+92>>2]=ea(100.0);g[b+96>>2]=ea(100.0);g[b+100>>2]=ea(100.0);RI(2372912)|0;e=qL(2372912)|0;x7e(e);c[b+104>>2]=e;RI(2369632)|0;if(a[2369780]|0){f=$6e(0)|0;_6e(b,ea(0.0),ea(0.0),ea(0.0),ea(0.0),f);i=d;return}RI(2369632)|0;_th(2369632);f=$6e(0)|0;_6e(b,ea(0.0),ea(0.0),ea(0.0),ea(0.0),f);i=d;return}function E6e(a){a=a|0;var b=0;a=i;RI(1336184)|0;b=qL(1336184)|0;kxe(b);RI(2366312)|0;c[c[591601]>>2]=b;RI(1336184)|0;b=qL(1336184)|0;kxe(b);RI(2366312)|0;c[(c[591601]|0)+4>>2]=b;RI(2368616)|0;b=qL(2368616)|0;C6e(b);RI(2366312)|0;c[(c[591601]|0)+8>>2]=b;RI(2366312)|0;b=c[591601]|0;g[b+12>>2]=ea(0.0);g[b+16>>2]=ea(0.0);g[b+20>>2]=ea(1.0);g[b+24>>2]=ea(1.0);i=a;return}function F6e(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);g[a>>2]=b;g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=e;return}function G6e(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}e=q6e(0,d,0)|0;d=(s6e(r6e(0)|0)|0)==8;RI(2366312)|0;f=(a[2366460]|0)!=0;if(d){if(!f){RI(2366312)|0;_th(2366312)}RI(2368432)|0;d=qL(2368432)|0;D6e(d);c[e+8>>2]=d;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+8>>2]=d;RI(2366312)|0;eth(2741280,c[(c[(c[591601]|0)+8>>2]|0)+12>>2]|0);RI(2366312)|0;d=c[(c[(c[591601]|0)+8>>2]|0)+12>>2]|0;RI(2366312)|0;Irh(2741560,d,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2368432)|0;d=qL(2368432)|0;D6e(d);c[e+16>>2]=d;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+16>>2]=d;i=b;return}else{if(!f){RI(2366312)|0;_th(2366312)}f=c[e+8>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+8>>2]=f;f=c[e+12>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+12>>2]=f;f=c[e+16>>2]|0;RI(2366312)|0;c[(c[(c[591601]|0)+8>>2]|0)+16>>2]=f;i=b;return}}function H6e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+48>>2]=b;cuh(2371384,a,b);i=d;return}function I6e(a,b,c){a=a|0;b=ea(b);c=ea(c);return ea(!(b>=c)?b:c)}function J6e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;i=i+48|0;e=b+32|0;f=b+16|0;g=b;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;kHe(f,c[d+52>>2]|0);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];while(1){if(!(euh(e)|0))break;f=EGe(e)|0;RI(2368432)|0;h=duh(f,2368432)|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}K6e(0,h)}c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,g)|0);c[d+72>>2]=0;i=b;return}function K6e(b,d){b=b|0;d=d|0;var e=0,f=0,h=Im,j=0,k=Im,l=Im,m=Im,n=Im,o=Im,p=0,q=Im,r=Im;b=i;i=i+32|0;e=b+16|0;f=b;if(!(a[d+65>>0]|0)){h=ea(g[d+8>>2]);j=d+12|0;k=ea(g[j>>2]);eth(2369056,d);l=ea(g[d+24>>2]);m=ea(g[j>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}if(m>=h)if(!(m<=k))n=k;else n=m;else n=h;buh(2369280,d,l,n);n=ea(g[d+16>>2]);j=d+20|0;l=ea(g[j>>2]);eth(2369336,d);h=ea(g[d+28>>2]);m=ea(g[j>>2]);if(m>=n)if(!(m<=l))o=l;else o=m;else o=n;buh(2369392,d,h,o);i=b;return}eth(2369056,d);j=d+68|0;p=c[j>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}Q6e(f,0,p);o=ea(g[f>>2]);h=ea(g[f+4>>2]);n=ea(g[f+8>>2]);m=ea(g[f+12>>2]);l=ea(g[d+8>>2]);k=ea(g[d+12>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}if(n>=l)if(!(n<=k))q=k;else q=n;else q=l;buh(2369280,d,o,q);eth(2369336,d);q=ea(g[d+16>>2]);o=ea(g[d+20>>2]);if(m>=q)if(!(m<=o))r=o;else r=m;else r=q;buh(2369392,d,h,r);f=c[j>>2]|0;j=d+24|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];T6e(0,f,e);i=b;return}function L6e(b){b=b|0;var d=0;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;eth(2369056,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2366312)|0;d=c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0;buh(2369280,d,ea(0.0),ea(Z4e(0)|0));RI(2366312)|0;eth(2369336,c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0);RI(2366312)|0;d=c[(c[(c[591601]|0)+8>>2]|0)+8>>2]|0;buh(2369392,d,ea(0.0),ea(_4e(0)|0));RI(2366312)|0;J6e(0,c[(c[(c[591601]|0)+8>>2]|0)+16>>2]|0);i=b;return}function M6e(a){a=a|0;c[a+72>>2]=0;return}function N6e(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function O6e(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);var e=Im;a=i;if(b>=c)if(!(b<=d))e=d;else e=b;else e=c;i=a;return ea(e)}function P6e(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function Q6e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[592362]|0;if(!e){f=MK(2369456)|0;c[592362]=f;g=f}else g=e;In[g&4095](a,d);i=b;return}function R6e(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function S6e(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function T6e(b,c,d){b=b|0;c=c|0;d=d|0;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}U6e(0,c,d);i=b;return}function U6e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[592382]|0;if(!e){f=MK(2369536)|0;c[592382]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function V6e(b){b=b|0;var d=0;b=i;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;if(!(c[(c[591601]|0)+28>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;d=qL(2369632)|0;W6e(d);RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;c[(c[591601]|0)+28>>2]=d}RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366312)|0;X6e(c[(c[591601]|0)+28>>2]|0,0);RI(2366312)|0;i=b;return c[(c[591601]|0)+28>>2]|0}function W6e(a){a=a|0;var b=0;b=i;Kaf(a);i=b;return}function X6e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597902]|0;if(!e){f=MK(2391616)|0;c[597902]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Y6e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Z6e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function _6e(b,d,e,f,h,j){b=b|0;d=ea(d);e=ea(e);f=ea(f);h=ea(h);j=j|0;var k=0,l=0,m=0;k=i;l=b+24|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}c[b+48>>2]=$6e(0)|0;g[b+8>>2]=d;g[b+12>>2]=e;g[b+16>>2]=f;g[b+20>>2]=h;if(j){m=j;H6e(b,m);i=k;return}RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}m=$6e(0)|0;H6e(b,m);i=k;return}function $6e(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;if(!(c[(c[592431]|0)+4>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;d=qL(2369632)|0;W6e(d);RI(2369632)|0;c[(c[592431]|0)+4>>2]=d}RI(2369632)|0;if(a[2369780]|0){RI(2369632)|0;e=c[592431]|0;f=e+4|0;g=c[f>>2]|0;i=b;return g|0}RI(2369632)|0;_th(2369632);RI(2369632)|0;e=c[592431]|0;f=e+4|0;g=c[f>>2]|0;i=b;return g|0}function a7e(a){a=a|0;var b=0;a=i;RI(2371216)|0;b=c[592827]|0;g[b>>2]=ea(0.0);g[b+4>>2]=ea(0.0);g[b+8>>2]=ea(1.0);g[b+12>>2]=ea(1.0);RI(2371216)|0;c[(c[592827]|0)+16>>2]=0;i=a;return}function b7e(a){a=a|0;return c[a+48>>2]|0}function c7e(a){a=a|0;var b=0,d=0;b=i;d=d7e(c[a+48>>2]|0)|0;i=b;return d|0}function d7e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+52|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=Paf(a,1)|0;RI(2372912)|0;g=qL(2372912)|0;c[g+12>>2]=a;c[g+8>>2]=e;c[d>>2]=g;f=g;i=b;return f|0}function e7e(a){a=a|0;return}function f7e(a){a=a|0;return}function g7e(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a+24>>2]=b;g[a+32>>2]=c;return}function h7e(a,b){a=a|0;b=ea(b);g[a>>2]=b;return}function i7e(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function j7e(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a+28>>2]=b;g[a+36>>2]=c;return}function k7e(a,b){a=a|0;b=ea(b);g[a+4>>2]=b;return}function l7e(a,b){a=a|0;b=ea(b);g[a+12>>2]=b;return}function m7e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!(ea(n7e(b))!=ea(0.0))?o7e(b)|0:0)e=1;else e=0;c[a+40>>2]=e;if(!(ea(p7e(b))!=ea(0.0))?q7e(b)|0:0)f=1;else f=0;c[a+44>>2]=f;c[a+48>>2]=b;i=d;return}function n7e(a){a=a|0;var b=0,d=0,e=0,f=0,g=Im;b=i;d=c[597864]|0;if(!d){e=MK(2391464)|0;c[597864]=e;f=e}else f=d;g=ea(Kn[f&255](a));i=b;return ea(g)}function o7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597888]|0;if(!d){e=MK(2391560)|0;c[597888]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function p7e(a){a=a|0;var b=0,d=0,e=0,f=0,g=Im;b=i;d=c[597876]|0;if(!d){e=MK(2391512)|0;c[597876]=e;f=e}else f=d;g=ea(Kn[f&255](a));i=b;return ea(g)}function q7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597918]|0;if(!d){e=MK(2391680)|0;c[597918]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function r7e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=Im;d=i;if(!b){i=d;return}e=b+12|0;a:do if((c[e>>2]|0)>0){f=b+16|0;h=a+12|0;j=a+8|0;k=a+40|0;l=a+20|0;m=a+16|0;n=a+44|0;o=0;while(1){p=c[f+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]|0;switch(c[p+8>>2]|0){case 1:{q=c[p+12>>2]|0;RI(2586184)|0;r=ea(g[(Zth(q,2586184)|0)>>2]);g[l>>2]=r;g[m>>2]=r;c[n>>2]=0;break}case 5:{q=c[p+12>>2]|0;RI(2586184)|0;r=ea(g[(Zth(q,2586184)|0)>>2]);g[l>>2]=r;if(!(ea(g[m>>2])<=r))g[m>>2]=r;c[n>>2]=0;break}case 3:{q=c[p+12>>2]|0;RI(2586184)|0;r=ea(g[(Zth(q,2586184)|0)>>2]);g[h>>2]=r;if(!(ea(g[j>>2])<=r))g[j>>2]=r;c[k>>2]=0;break}case 7:{q=c[p+12>>2]|0;RI(2540224)|0;c[n>>2]=c[(Zth(q,2540224)|0)>>2];break}case 6:{q=c[p+12>>2]|0;RI(2540224)|0;c[k>>2]=c[(Zth(q,2540224)|0)>>2];break}case 2:{q=c[p+12>>2]|0;RI(2586184)|0;r=ea(g[(Zth(q,2586184)|0)>>2]);g[j>>2]=r;if(!(ea(g[h>>2])>=r))g[h>>2]=r;break}case 0:{q=c[p+12>>2]|0;RI(2586184)|0;r=ea(g[(Zth(q,2586184)|0)>>2]);g[h>>2]=r;g[j>>2]=r;c[k>>2]=0;break}case 4:{q=c[p+12>>2]|0;RI(2586184)|0;r=ea(g[(Zth(q,2586184)|0)>>2]);g[m>>2]=r;if(!(ea(g[l>>2])>=r))g[l>>2]=r;break}default:{}}o=o+1|0;if((o|0)>=(c[e>>2]|0)){s=h;break a}}}else s=a+12|0;while(0);r=ea(g[s>>2]);if(!(r==ea(0.0))?(t=ea(g[a+8>>2]),!(r>=t)):0)g[s>>2]=t;s=a+20|0;t=ea(g[s>>2]);if(t==ea(0.0)){i=d;return}r=ea(g[a+16>>2]);if(t>=r){i=d;return}g[s>>2]=r;i=d;return}function s7e(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=Im,w=0,x=0,y=0;d=i;i=i+32|0;e=d+4|0;f=d+16|0;h=d+8|0;j=d+20|0;k=d+28|0;l=d;m=d+12|0;n=d+24|0;wbh();if(!(a[2540708]|0))_th(2540560);o=c[c[635163]>>2]|0;p=0;while(1){RI(2371216)|0;if(!(a[2371364]|0)){RI(2371216)|0;_th(2371216)}RI(2371216)|0;if((p|0)>=(c[(c[592827]|0)+16>>2]|0)){q=o;break}if(!(a[2540708]|0))_th(2540560);o=gwf(0,o,c[879328]|0)|0;p=p+1|0}RI(1086352)|0;p=$th(1086352,12)|0;Qqh(p,q);o=p+16|0;c[o>>2]=q;RI(1086352)|0;q=$th(1086352,6)|0;r=c[b+48>>2]|0;s=c[879330]|0;if(!r)t=c[879332]|0;else t=t7e(r)|0;Qqh(q,t);r=q+16|0;c[r>>2]=t;t=Xnf(b)|0;Qqh(q,t);c[r+(c[(c[q>>2]|0)+120>>2]|0)>>2]=t;t=b+24|0;g[e>>2]=ea(g[t>>2]);RI(2586184)|0;u=pL(2586184,e)|0;Qqh(q,u);c[r+(c[(c[q>>2]|0)+120>>2]<<1)>>2]=u;v=ea(g[b+32>>2]);g[f>>2]=ea(v+ea(g[t>>2]));RI(2586184)|0;t=pL(2586184,f)|0;Qqh(q,t);c[r+((c[(c[q>>2]|0)+120>>2]|0)*3|0)>>2]=t;t=b+28|0;g[h>>2]=ea(g[t>>2]);RI(2586184)|0;f=pL(2586184,h)|0;Qqh(q,f);c[r+(c[(c[q>>2]|0)+120>>2]<<2)>>2]=f;v=ea(g[b+36>>2]);g[j>>2]=ea(v+ea(g[t>>2]));RI(2586184)|0;t=pL(2586184,j)|0;Qqh(q,t);c[r+((c[(c[q>>2]|0)+120>>2]|0)*5|0)>>2]=t;t=w7e(0,s,q)|0;Qqh(p,t);c[o+(c[(c[p>>2]|0)+120>>2]|0)>>2]=t;Qqh(p,c[879334]|0);c[o+(c[(c[p>>2]|0)+120>>2]<<1)>>2]=c[879334];g[k>>2]=ea(g[b+8>>2]);RI(2586184)|0;t=pL(2586184,k)|0;Qqh(p,t);c[o+((c[(c[p>>2]|0)+120>>2]|0)*3|0)>>2]=t;Qqh(p,c[879336]|0);c[o+(c[(c[p>>2]|0)+120>>2]<<2)>>2]=c[879336];g[l>>2]=ea(g[b+12>>2]);RI(2586184)|0;t=pL(2586184,l)|0;Qqh(p,t);c[o+((c[(c[p>>2]|0)+120>>2]|0)*5|0)>>2]=t;if(!(c[b+40>>2]|0)){if(!(a[2540708]|0))_th(2540560);w=c[635163]|0}else w=3517352;t=c[w>>2]|0;Qqh(p,t);c[o+((c[(c[p>>2]|0)+120>>2]|0)*6|0)>>2]=t;Qqh(p,c[879340]|0);c[o+((c[(c[p>>2]|0)+120>>2]|0)*7|0)>>2]=c[879340];g[m>>2]=ea(g[b+16>>2]);RI(2586184)|0;t=pL(2586184,m)|0;Qqh(p,t);c[o+(c[(c[p>>2]|0)+120>>2]<<3)>>2]=t;Qqh(p,c[879342]|0);c[o+((c[(c[p>>2]|0)+120>>2]|0)*9|0)>>2]=c[879342];g[n>>2]=ea(g[b+20>>2]);RI(2586184)|0;t=pL(2586184,n)|0;Qqh(p,t);c[o+((c[(c[p>>2]|0)+120>>2]|0)*10|0)>>2]=t;if(!(c[b+44>>2]|0)){if(!(a[2540708]|0))_th(2540560);x=c[635163]|0}else x=3517376;b=c[x>>2]|0;Qqh(p,b);c[o+((c[(c[p>>2]|0)+120>>2]|0)*11|0)>>2]=b;if(a[2540708]|0){y=eqf(0,p)|0;i=d;return y|0}_th(2540560);y=eqf(0,p)|0;i=d;return y|0}function t7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597806]|0;if(!d){e=MK(2391232)|0;c[597806]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function u7e(a){a=a|0;var b=Im,c=Im;b=ea(g[a+8>>2]);c=ea(b+ea(g[a>>2]));return ea(c)}function v7e(a){a=a|0;var b=Im,c=Im;b=ea(g[a+12>>2]);c=ea(b+ea(g[a+4>>2]));return ea(c)}function w7e(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;if(!(a[2540708]|0))_th(2540560);e=cwf(0,c,d)|0;i=b;return e|0}function x7e(a){a=a|0;var b=0;b=i;saf(a);i=b;return}function y7e(a){a=a|0;return c[a+104>>2]|0}function z7e(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;if(!d){i=e;return}r7e(b,d);f=d+12|0;h=c[f>>2]|0;if((h|0)<=0){i=e;return}j=d+16|0;k=b+60|0;l=b+85|0;m=b+84|0;b=h;h=0;while(1){n=c[j+(da(c[(c[d>>2]|0)+120>>2]|0,h)|0)>>2]|0;o=c[n+8>>2]|0;do if(!o)p=6;else if((o|0)!=1){q=o&-2;if((q|0)==2){p=6;break}else if((q|0)==4){p=7;break}if((o|0)==13&(((q|0)==6|(o|0)==8|(o|0)==9|(o|0)==10|(o|0)==11|(o|0)==12)^1)){q=c[n+12>>2]|0;RI(2540224)|0;g[k>>2]=ea(c[(Zth(q,2540224)|0)>>2]|0);r=c[f>>2]|0}else r=b}else p=7;while(0);if((p|0)==6){p=0;a[l>>0]=1;r=b}else if((p|0)==7){p=0;a[m>>0]=1;r=b}h=h+1|0;if((h|0)>=(r|0))break;else b=r}i=e;return}function A7e(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;m7e(a,b);e=d7e(b)|0;b=a+104|0;a=c[b>>2]|0;C7e(a,B7e(e)|0);a=c[b>>2]|0;E7e(a,D7e(e)|0);a=c[b>>2]|0;G7e(a,F7e(e)|0);a=c[b>>2]|0;I7e(a,H7e(e)|0);i=d;return}function B7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597116]|0;if(!d){e=MK(2388472)|0;c[597116]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function C7e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597128]|0;if(!e){f=MK(2388520)|0;c[597128]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function D7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597142]|0;if(!d){e=MK(2388576)|0;c[597142]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function E7e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597154]|0;if(!e){f=MK(2388624)|0;c[597154]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function F7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597168]|0;if(!d){e=MK(2388680)|0;c[597168]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function G7e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597180]|0;if(!e){f=MK(2388728)|0;c[597180]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function H7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597194]|0;if(!d){e=MK(2388784)|0;c[597194]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function I7e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597206]|0;if(!e){f=MK(2388832)|0;c[597206]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function J7e(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=Im,C=Im,D=Im,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=Im,O=Im,P=Im,Q=Im;d=i;i=i+96|0;e=d+80|0;f=d+64|0;h=d+48|0;j=d+32|0;k=d+16|0;l=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;m=b+52|0;if(!(Aqh(1787440,c[m>>2]|0)|0)){n=ea(L7e(K7e(c[b+48>>2]|0)|0)|0);g[b+8>>2]=n;g[b+12>>2]=n;i=d;return}o=b+88|0;g[o>>2]=ea(0.0);p=b+92|0;g[p>>2]=ea(0.0);q=b+76|0;c[q>>2]=0;r=c[m>>2]|0;if(!(a[b+56>>0]|0)){kHe(k,r);c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];k=b+60|0;s=1;t=0;a:while(1){while(1){if(!(euh(f)|0)){u=t;break a}v=EGe(f)|0;eth(2372224,v);w=fuh(2372152,v)|0;x=c[v+48>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}if((x|0)!=(V6e(0)|0)){y=v;z=w;break}n=ea(g[o>>2]);g[o>>2]=ea(n+ea(g[v+8>>2]));n=ea(g[p>>2]);g[p>>2]=ea(n+ea(g[v+12>>2]));c[q>>2]=(c[v+40>>2]|0)+(c[q>>2]|0)}if(!s)if((t|0)>(B7e(z)|0))A=t;else A=B7e(z)|0;else A=0;n=ea(g[o>>2]);B=ea(g[y+8>>2]);C=ea(g[k>>2]);D=ea(A|0);g[o>>2]=ea(n+ea(D+ea(B+C)));B=ea(g[p>>2]);g[p>>2]=ea(B+ea(D+ea(ea(g[y+12>>2])+C)));v=D7e(z)|0;c[q>>2]=(c[y+40>>2]|0)+(c[q>>2]|0);s=0;t=v}c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,l)|0);C=ea(g[o>>2]);D=ea(g[k>>2]);g[o>>2]=ea(C-D);g[p>>2]=ea(ea(g[p>>2])-D);if(!(Aqh(1787440,c[m>>2]|0)|0)){E=0;F=0}else{E=B7e(fuh(2372152,guh(1787512,c[m>>2]|0,0)|0)|0)|0;F=u}}else{kHe(h,r);c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];h=0;r=0;u=1;while(1){if(!(euh(e)|0)){G=h;H=r;break}m=EGe(e)|0;eth(2372224,m);k=fuh(2372152,m)|0;l=c[m+48>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}if((l|0)==(V6e(0)|0)){I=h;J=r;K=u}else{l=B7e(k)|0;if(u){L=l;M=D7e(k)|0}else{RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}f=D7e(k)|0;L=(l|0)<(h|0)?l:h;M=(f|0)<(r|0)?f:r}D=ea(g[m+8>>2]);f=L7e(k)|0;C=ea(g[o>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}B=ea(D+ea(f|0));g[o>>2]=!(B<=C)?B:C;C=ea(g[m+12>>2]);f=L7e(k)|0;B=ea(g[p>>2]);D=ea(C+ea(f|0));g[p>>2]=!(D<=B)?D:B;I=L;J=M;K=0}c[q>>2]=(c[m+40>>2]|0)+(c[q>>2]|0);h=I;r=J;u=K}c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,j)|0);B=ea(G+H|0);g[o>>2]=ea(ea(g[o>>2])-B);g[p>>2]=ea(ea(g[p>>2])-B);E=G;F=H}H=b+48|0;G=c[H>>2]|0;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}if((G|0)==($6e(0)|0)?(a[b+84>>0]|0)==0:0){G=b+104|0;C7e(c[G>>2]|0,E);E7e(c[G>>2]|0,F);N=ea(0.0);O=ea(0.0)}else{G=B7e(K7e(c[H>>2]|0)|0)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}B=ea(((G|0)>(E|0)?G:E)|0);E=D7e(K7e(c[H>>2]|0)|0)|0;N=B;O=ea(((E|0)>(F|0)?E:F)|0)}F=b+8|0;B=ea(g[F>>2]);D=ea(g[o>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}C=ea(O+ea(N+D));D=!(B<=C)?B:C;g[F>>2]=D;o=b+12|0;C=ea(g[o>>2]);E=b+40|0;if(C!=ea(0.0)){c[E>>2]=0;P=C;Q=D}else{b=c[E>>2]|0;G=c[q>>2]|0;c[E>>2]=G+b+((o7e(c[H>>2]|0)|0)&1);D=ea(O+ea(N+ea(g[p>>2])));g[o>>2]=D;P=D;Q=ea(g[F>>2])}RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}g[o>>2]=!(P<=Q)?P:Q;if(ea(n7e(c[H>>2]|0))==ea(0.0)){i=d;return}Q=ea(n7e(c[H>>2]|0));g[F>>2]=Q;g[o>>2]=Q;c[E>>2]=0;i=d;return}function K7e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+48|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=Paf(a,2)|0;RI(2372912)|0;g=qL(2372912)|0;c[g+12>>2]=a;c[g+8>>2]=e;c[d>>2]=g;f=g;i=b;return f|0}function L7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597222]|0;if(!d){e=MK(2388896)|0;c[597222]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function M7e(a,b,c){a=a|0;b=b|0;c=c|0;return ((b|0)<(c|0)?b:c)|0}function N7e(a,b,c){a=a|0;b=ea(b);c=ea(c);return ea(!(b<=c)?b:c)}function O7e(a,b,c){a=a|0;b=b|0;c=c|0;return ((b|0)>(c|0)?b:c)|0}function P7e(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0,t=0,u=0,v=0,w=Im,x=0,y=0,z=Im,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=0,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0;f=i;i=i+144|0;h=f+112|0;j=f+64|0;k=f+16|0;l=f+32|0;m=f+128|0;n=f;o=f+48|0;p=f+96|0;q=f+80|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[b+24>>2]=d;g[b+32>>2]=e;r=(a[b+57>>0]|0)==0?d:ea(0.0);s=b+48|0;t=K7e(c[s>>2]|0)|0;u=(a[b+56>>0]|0)==0;v=c[s>>2]|0;RI(2369632)|0;s=(a[2369780]|0)==0;if(!u){if(s){RI(2369632)|0;_th(2369632)}if((v|0)==($6e(0)|0)){d=ea(r-ea(B7e(fuh(2373080,b)|0)|0));w=ea(ea(L7e(fuh(2373080,b)|0)|0)+e);kHe(n,c[b+52>>2]|0);c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];while(1){if(!(euh(j)|0))break;n=EGe(j)|0;u=(c[n+40>>2]|0)==0;x=B7e(fuh(2372152,n)|0)|0;y=L7e(fuh(2372152,n)|0)|0;if(!u){buh(2372392,n,ea(d+ea(x|0)),ea(w-ea(y|0)));continue}z=ea(g[n+8>>2]);A=ea(g[n+12>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}B=ea(w-ea(y|0));if(B>=z)if(!(B<=A))C=A;else C=B;else C=z;buh(2372392,n,ea(d+ea(x|0)),C)}c[o+0>>2]=c[j+0>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];c[o+12>>2]=c[j+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,o)|0);i=f;return}kHe(l,c[b+52>>2]|0);c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];while(1){if(!(euh(h)|0))break;l=EGe(h)|0;o=B7e(fuh(2372152,l)|0)|0;j=B7e(t)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}C=ea(((o|0)>(j|0)?o:j)|0);d=ea(r+C);j=D7e(fuh(2372152,l)|0)|0;o=D7e(t)|0;w=ea(ea(e-ea(((j|0)>(o|0)?j:o)|0))-C);if(c[l+40>>2]|0){buh(2372392,l,d,w);continue}C=ea(g[l+8>>2]);z=ea(g[l+12>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}if(w>=C)if(!(w<=z))D=z;else D=w;else D=C;buh(2372392,l,d,D)}c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,m)|0);i=f;return}if(s){RI(2369632)|0;_th(2369632)}if((v|0)==($6e(0)|0)){E=e;F=r;G=b+52|0}else{D=ea(B7e(t)|0);d=ea(D7e(t)|0);t=b+52|0;if(!(Aqh(1787440,c[t>>2]|0)|0)){H=D;I=d}else{v=B7e(fuh(2372152,guh(1787512,c[t>>2]|0,0)|0)|0)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}C=ea(v|0);v=c[t>>2]|0;w=ea(D7e(fuh(2372152,guh(1787512,v,(Aqh(1787440,v)|0)+-1|0)|0)|0)|0);H=!(D<=C)?D:C;I=!(d<=w)?d:w}E=ea(e-ea(I+H));F=ea(r+H);G=t}t=b+60|0;H=ea(g[t>>2]);r=ea(E-ea(H*ea((Aqh(1787440,c[G>>2]|0)|0)+-1|0)));H=ea(g[b+88>>2]);v=b+92|0;E=ea(g[v>>2]);if(!(H==E)){RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}I=ea(ea(r-H)/ea(E-H));if(I>=ea(0.0))if(!(I<=ea(1.0)))J=ea(1.0);else J=I;else J=ea(0.0)}else J=ea(0.0);I=ea(g[v>>2]);if(!(r<=I)?(v=c[b+76>>2]|0,(v|0)>=1):0)K=ea(ea(r-I)/ea(v|0));else K=ea(0.0);kHe(p,c[G>>2]|0);c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];I=F;p=0;G=1;while(1){if(!(euh(k)|0))break;v=EGe(k)|0;F=ea(g[v+8>>2]);r=ea(g[v+12>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}H=ea(Q7e(0,F,r,J));r=ea(H+ea(K*ea(c[v+40>>2]|0)));b=c[v+48>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}if((b|0)==(V6e(0)|0)){L=I;M=p;N=G}else{b=B7e(fuh(2372152,v)|0)|0;s=G?0:b;b=fuh(2372152,v)|0;H=ea(I+ea(((p|0)>(s|0)?p:s)|0));L=H;M=D7e(b)|0;N=0}RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}H=ea(eEi(L));buh(2372392,v,H,ea(eEi(r)));I=ea(L+ea(r+ea(g[t>>2])));p=M;G=N}c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,q)|0);i=f;return}function Q7e(b,c,d,e){b=b|0;c=ea(c);d=ea(d);e=ea(e);var f=Im,g=0;b=i;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}if(!(e>=ea(0.0)))f=ea(0.0);else{g=!(e<=ea(1.0));f=g?ea(1.0):e}e=ea(ea(ea(d-c)*f)+c);i=b;return ea(e)}function R7e(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=Im,B=Im,C=Im,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=Im,N=Im,O=Im,P=Im;d=i;i=i+96|0;e=d+80|0;f=d+64|0;h=d+48|0;j=d+32|0;k=d+16|0;l=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;m=b+52|0;if(!(Aqh(1787440,c[m>>2]|0)|0)){n=ea(S7e(K7e(c[b+48>>2]|0)|0)|0);g[b+16>>2]=n;g[b+20>>2]=n;i=d;return}o=b+100|0;g[o>>2]=ea(0.0);p=b+96|0;g[p>>2]=ea(0.0);q=b+80|0;c[q>>2]=0;r=c[m>>2]|0;if(a[b+56>>0]|0){kHe(h,r);c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];h=b+60|0;s=0;t=1;a:while(1){while(1){if(!(euh(e)|0)){u=s;break a}v=EGe(e)|0;eth(2372296,v);w=fuh(2372152,v)|0;x=c[v+48>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}if((x|0)!=(V6e(0)|0)){y=v;z=w;break}n=ea(g[p>>2]);g[p>>2]=ea(n+ea(g[v+16>>2]));n=ea(g[o>>2]);g[o>>2]=ea(n+ea(g[v+20>>2]));c[q>>2]=(c[v+44>>2]|0)+(c[q>>2]|0)}if(t)A=ea(0.0);else{v=F7e(z)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}A=ea(((s|0)>(v|0)?s:v)|0)}n=ea(g[p>>2]);B=ea(g[y+16>>2]);C=ea(g[h>>2]);g[p>>2]=ea(n+ea(A+ea(B+C)));B=ea(g[o>>2]);g[o>>2]=ea(B+ea(A+ea(ea(g[y+20>>2])+C)));v=H7e(z)|0;c[q>>2]=(c[y+44>>2]|0)+(c[q>>2]|0);s=v;t=0}c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,j)|0);A=ea(g[p>>2]);C=ea(g[h>>2]);g[p>>2]=ea(A-C);g[o>>2]=ea(ea(g[o>>2])-C);if(!(Aqh(1787440,c[m>>2]|0)|0)){D=0;E=0}else{D=F7e(fuh(2372152,guh(1787512,c[m>>2]|0,0)|0)|0)|0;E=u}}else{kHe(k,r);c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];k=0;r=0;u=1;while(1){if(!(euh(f)|0)){F=k;G=r;break}m=EGe(f)|0;eth(2372296,m);h=fuh(2372152,m)|0;j=c[m+48>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}if((j|0)==(V6e(0)|0)){H=k;I=r;J=u}else{j=F7e(h)|0;if(u){K=j;L=H7e(h)|0}else{RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}e=H7e(h)|0;K=(j|0)<(k|0)?j:k;L=(e|0)<(r|0)?e:r}C=ea(g[m+16>>2]);A=ea(g[p>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}g[p>>2]=!(C<=A)?C:A;A=ea(g[m+20>>2]);C=ea(g[o>>2]);g[o>>2]=!(A<=C)?A:C;H=K;I=L;J=0}c[q>>2]=(c[m+44>>2]|0)+(c[q>>2]|0);k=H;r=I;u=J}c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,l)|0);D=F;E=G}G=b+48|0;F=c[G>>2]|0;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}if((F|0)==($6e(0)|0)?(a[b+85>>0]|0)==0:0){F=b+104|0;G7e(c[F>>2]|0,D);I7e(c[F>>2]|0,E);M=ea(0.0);N=ea(0.0)}else{F=F7e(K7e(c[G>>2]|0)|0)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}C=ea(((F|0)>(D|0)?F:D)|0);D=H7e(K7e(c[G>>2]|0)|0)|0;M=C;N=ea(((D|0)>(E|0)?D:E)|0)}E=b+16|0;C=ea(g[E>>2]);A=ea(g[p>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}B=ea(N+ea(M+A));A=!(C<=B)?C:B;g[E>>2]=A;p=b+20|0;B=ea(g[p>>2]);D=b+44|0;if(B!=ea(0.0)){c[D>>2]=0;O=B;P=A}else{b=c[D>>2]|0;F=c[q>>2]|0;c[D>>2]=F+b+((q7e(c[G>>2]|0)|0)&1);A=ea(N+ea(M+ea(g[o>>2])));g[p>>2]=A;O=A;P=ea(g[E>>2])}RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}g[p>>2]=!(O<=P)?O:P;if(ea(p7e(c[G>>2]|0))==ea(0.0)){i=d;return}P=ea(p7e(c[G>>2]|0));g[E>>2]=P;g[p>>2]=P;c[D>>2]=0;i=d;return}function S7e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597236]|0;if(!d){e=MK(2388952)|0;c[597236]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function T7e(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=0,w=0,x=Im,y=0,z=0,A=Im,B=Im,C=Im,D=Im,E=Im,F=Im,G=Im,H=Im,I=Im,J=Im,K=Im,L=Im,M=0,N=0;f=i;i=i+144|0;h=f+112|0;j=f+64|0;k=f+16|0;l=f+32|0;m=f+128|0;n=f;o=f+48|0;p=f+96|0;q=f+80|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;g[b+28>>2]=d;g[b+36>>2]=e;r=b+52|0;if(!(Aqh(1787440,c[r>>2]|0)|0)){i=f;return}s=b+48|0;t=K7e(c[s>>2]|0)|0;u=(a[b+57>>0]|0)==0?d:ea(0.0);v=(a[b+56>>0]|0)==0;w=c[s>>2]|0;RI(2369632)|0;s=(a[2369780]|0)==0;if(v){if(s){RI(2369632)|0;_th(2369632)}if((w|0)==($6e(0)|0)){d=ea(u-ea(F7e(fuh(2373080,b)|0)|0));x=ea(ea(S7e(fuh(2373080,b)|0)|0)+e);kHe(p,c[r>>2]|0);c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];while(1){if(!(euh(k)|0))break;p=EGe(k)|0;v=(c[p+44>>2]|0)==0;y=F7e(fuh(2372152,p)|0)|0;z=S7e(fuh(2372152,p)|0)|0;if(!v){buh(2372488,p,ea(d+ea(y|0)),ea(x-ea(z|0)));continue}A=ea(g[p+16>>2]);B=ea(g[p+20>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}C=ea(x-ea(z|0));if(C>=A)if(!(C<=B))D=B;else D=C;else D=A;buh(2372488,p,ea(d+ea(y|0)),D)}c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,q)|0);i=f;return}kHe(n,c[r>>2]|0);c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];while(1){if(!(euh(j)|0))break;n=EGe(j)|0;q=F7e(fuh(2372152,n)|0)|0;k=F7e(t)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}D=ea(((q|0)>(k|0)?q:k)|0);d=ea(u+D);k=H7e(fuh(2372152,n)|0)|0;q=H7e(t)|0;x=ea(ea(e-ea(((k|0)>(q|0)?k:q)|0))-D);if(c[n+44>>2]|0){buh(2372488,n,d,x);continue}D=ea(g[n+16>>2]);A=ea(g[n+20>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}if(x>=D)if(!(x<=A))E=A;else E=x;else E=D;buh(2372488,n,d,E)}c[o+0>>2]=c[j+0>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];c[o+12>>2]=c[j+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,o)|0);i=f;return}if(s){RI(2369632)|0;_th(2369632)}if((w|0)==($6e(0)|0)){F=e;G=u}else{E=ea(F7e(t)|0);d=ea(H7e(t)|0);if(!(Aqh(1787440,c[r>>2]|0)|0)){H=E;I=d}else{t=F7e(fuh(2372152,guh(1787512,c[r>>2]|0,0)|0)|0)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}D=ea(t|0);t=c[r>>2]|0;x=ea(H7e(fuh(2372152,guh(1787512,t,(Aqh(1787440,t)|0)+-1|0)|0)|0)|0);H=!(E<=D)?E:D;I=!(d<=x)?d:x}F=ea(e-ea(I+H));G=ea(u+H)}t=b+60|0;H=ea(g[t>>2]);u=ea(F-ea(H*ea((Aqh(1787440,c[r>>2]|0)|0)+-1|0)));H=ea(g[b+96>>2]);w=b+100|0;F=ea(g[w>>2]);if(!(H==F)){RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}I=ea(ea(u-H)/ea(F-H));if(I>=ea(0.0))if(!(I<=ea(1.0)))J=ea(1.0);else J=I;else J=ea(0.0)}else J=ea(0.0);I=ea(g[w>>2]);if(!(u<=I)?(w=c[b+80>>2]|0,(w|0)>=1):0)K=ea(ea(u-I)/ea(w|0));else K=ea(0.0);kHe(l,c[r>>2]|0);c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];I=G;l=0;r=1;while(1){if(!(euh(h)|0))break;w=EGe(h)|0;G=ea(g[w+16>>2]);u=ea(g[w+20>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}H=ea(Q7e(0,G,u,J));u=ea(H+ea(K*ea(c[w+44>>2]|0)));b=c[w+48>>2]|0;RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}if((b|0)==(V6e(0)|0)){L=I;M=l;N=r}else{b=F7e(fuh(2372152,w)|0)|0;s=r?0:b;b=fuh(2372152,w)|0;H=ea(I+ea(((l|0)>(s|0)?l:s)|0));L=H;M=H7e(b)|0;N=0}RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}H=ea(eEi(L));buh(2372488,w,H,ea(eEi(u)));I=ea(L+ea(u+ea(g[t>>2])));l=M;r=N}c[m+0>>2]=c[h+0>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,m)|0);i=f;return}function U7e(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+64|0;e=d+40|0;f=d+32|0;h=d+16|0;j=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;xbh();if(!(a[2540708]|0))_th(2540560);k=c[c[635163]>>2]|0;l=k;m=0;while(1){RI(2371216)|0;if(!(a[2371364]|0)){RI(2371216)|0;_th(2371216)}RI(2371216)|0;if((m|0)>=(c[(c[592827]|0)+16>>2]|0)){n=l;break}if(!(a[2540708]|0))_th(2540560);l=gwf(0,l,c[879382]|0)|0;m=m+1|0}RI(1086352)|0;m=$th(1086352,5)|0;Qqh(m,k);l=m+16|0;c[l>>2]=k;k=s7e(b)|0;Qqh(m,k);c[l+(c[(c[m>>2]|0)+120>>2]|0)>>2]=k;Qqh(m,c[879384]|0);c[l+(c[(c[m>>2]|0)+120>>2]<<1)>>2]=c[879384];g[f>>2]=ea(g[b+96>>2]);RI(2586184)|0;k=pL(2586184,f)|0;Qqh(m,k);c[l+((c[(c[m>>2]|0)+120>>2]|0)*3|0)>>2]=k;Qqh(m,c[879386]|0);c[l+(c[(c[m>>2]|0)+120>>2]<<2)>>2]=c[879386];if(!(a[2540708]|0))_th(2540560);l=eqf(0,m)|0;RI(2371216)|0;if(!(a[2371364]|0)){RI(2371216)|0;_th(2371216)}RI(2371216)|0;m=(c[(c[592827]|0)+16>>2]|0)+4|0;RI(2371216)|0;c[(c[592827]|0)+16>>2]=m;kHe(h,c[b+52>>2]|0);c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];h=l;while(1){if(!(euh(e)|0)){o=h;break}l=Fqh(2372672,EGe(e)|0)|0;if(!(a[2540708]|0))_th(2540560);h=iwf(0,h,l,c[879388]|0)|0}c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];RI(1780192)|0;kth(2568816,pL(1780192,j)|0);if(!(a[2540708]|0))_th(2540560);j=iwf(0,o,n,c[879390]|0)|0;RI(2371216)|0;if(a[2371364]|0){RI(2371216)|0;p=c[592827]|0;q=p+16|0;r=c[q>>2]|0;s=r+-4|0;RI(2371216)|0;t=c[592827]|0;u=t+16|0;c[u>>2]=s;i=d;return j|0}RI(2371216)|0;_th(2371216);RI(2371216)|0;p=c[592827]|0;q=p+16|0;r=c[q>>2]|0;s=r+-4|0;RI(2371216)|0;t=c[592827]|0;u=t+16|0;c[u>>2]=s;i=d;return j|0}function V7e(b){b=b|0;var c=0;c=i;a[b+132>>0]=1;a[b+133>>0]=1;D6e(b);i=c;return}function W7e(b){b=b|0;var d=0,e=0,f=Im,h=0,j=Im,k=0,l=Im;d=i;e=b+8|0;f=ea(g[e>>2]);h=b+12|0;j=ea(g[h>>2]);k=b+132|0;if(a[k>>0]|0){g[e>>2]=ea(0.0);g[h>>2]=ea(0.0)}J7e(b);l=ea(g[e>>2]);g[b+108>>2]=l;g[b+112>>2]=ea(g[h>>2]);if(!(a[k>>0]|0)){i=d;return}if(!(l<=ea(32.0)))g[e>>2]=ea(32.0);if(!(f==ea(0.0)))g[e>>2]=f;if(j==ea(0.0)){i=d;return}g[h>>2]=j;c[b+40>>2]=0;i=d;return}function X7e(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=Im,j=0,k=Im,l=0;f=i;if(!(a[b+135>>0]|0))h=e;else{j=b+140|0;k=ea(n7e(c[j>>2]|0));h=ea(ea(e-k)-ea(B7e(d7e(c[j>>2]|0)|0)|0))}do if(!(a[b+132>>0]|0))a[b+134>>0]=0;else{j=b+108|0;k=ea(g[j>>2]);l=b+134|0;if(h>=k){a[l>>0]=0;g[b+8>>2]=ea(g[b+108>>2]);g[b+12>>2]=ea(g[b+112>>2]);break}a[l>>0]=1;g[b+8>>2]=k;g[b+12>>2]=ea(g[b+112>>2]);P7e(b,d,k);g[b+32>>2]=e;g[b+124>>2]=ea(g[j>>2]);i=f;return}while(0);P7e(b,d,h);g[b+32>>2]=e;g[b+124>>2]=h;i=f;return}function Y7e(b){b=b|0;var d=0,e=0,f=Im,h=0,j=Im,k=0,l=Im,m=Im,n=0,o=Im;d=i;e=b+16|0;f=ea(g[e>>2]);h=b+20|0;j=ea(g[h>>2]);k=b+133|0;if(a[k>>0]|0){g[e>>2]=ea(0.0);g[h>>2]=ea(0.0)}R7e(b);l=ea(g[e>>2]);g[b+116>>2]=l;g[b+120>>2]=ea(g[h>>2]);if(!(a[b+134>>0]|0))m=l;else{n=b+136|0;l=ea(p7e(c[n>>2]|0));o=ea(l+ea(F7e(d7e(c[n>>2]|0)|0)|0));l=ea(ea(g[e>>2])+o);g[e>>2]=l;g[h>>2]=ea(ea(g[h>>2])+o);m=l}if(!(a[k>>0]|0)){i=d;return}if(!(m<=ea(32.0)))g[e>>2]=ea(32.0);if(!(f==ea(0.0)))g[e>>2]=f;if(j==ea(0.0)){i=d;return}g[h>>2]=j;c[b+44>>2]=0;i=d;return}function Z7e(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=0,h=0,j=Im,k=0,l=Im,m=0,n=Im,o=0,p=Im,q=Im,r=Im,s=Im;f=i;h=b+134|0;if(!(a[h>>0]|0))j=e;else{k=b+136|0;l=ea(p7e(c[k>>2]|0));j=ea(e-ea(l+ea(F7e(d7e(c[k>>2]|0)|0)|0)))}do if(a[b+133>>0]|0){k=b+116|0;l=ea(g[k>>2]);if(j>=l){g[b+16>>2]=l;g[b+20>>2]=ea(g[b+120>>2]);break}if((a[h>>0]|0)==0?(a[b+135>>0]|0)==0:0){m=b+32|0;n=ea(g[m>>2]);o=b+140|0;p=ea(n7e(c[o>>2]|0));q=ea(ea(n-p)-ea(B7e(d7e(c[o>>2]|0)|0)|0));o=b+124|0;g[o>>2]=q;p=ea(g[b+108>>2]);if(!(q>=p)){g[o>>2]=p;r=p}else r=q;q=ea(g[m>>2]);buh(2374320,b,ea(g[b+24>>2]),r);eth(2374376,b);g[m>>2]=q;s=ea(g[k>>2])}else s=l;m=b+16|0;l=ea(g[m>>2]);o=b+20|0;q=ea(g[o>>2]);g[m>>2]=s;g[o>>2]=ea(g[b+120>>2]);T7e(b,d,s);g[m>>2]=l;g[o>>2]=q;g[b+36>>2]=e;g[b+128>>2]=ea(g[k>>2]);i=f;return}while(0);T7e(b,d,j);g[b+36>>2]=e;g[b+128>>2]=j;i=f;return}function _7e(b){b=b|0;var d=0;b=i;RI(2366088)|0;d=(c[591545]|0)+8|0;c[d>>2]=0;c[d+4>>2]=0;RI(2366088)|0;a[(c[591545]|0)+16>>0]=0;i=b;return}function $7e(a,b){a=a|0;b=b|0;b=a;c[b>>2]=0;c[b+4>>2]=0;g[a>>2]=ea(0.0);g[a+4>>2]=ea(0.0);return}function a8e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[594226]|0;if(!d){e=MK(2376912)|0;c[594226]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function b8e(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;b=i;RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}RI(2366088)|0;c[c[591545]>>2]=d;RI(2366088)|0;c[(c[591545]|0)+4>>2]=e;RI(2365280)|0;if(!(a[2365428]|0)){RI(2365280)|0;_th(2365280)}i6e(0,0);if(f){RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}q6e(0,e,0)|0;G6e(0,e)}RI(2365280)|0;if(a[2365428]|0){o6e(0,0);i=b;return}RI(2365280)|0;_th(2365280);o6e(0,0);i=b;return}function c8e(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[594244]|0;if(!b){d=MK(2376984)|0;c[594244]=d;e=d}else e=b;eo[e&511]();i=a;return}function d8e(b,d){b=b|0;d=d|0;b=i;do if(!((s6e(r6e(0)|0)|0)!=8|(d|0)==0))if((d|0)==1){RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}w6e(0);break}else if((d|0)==2){RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}L6e(0);break}else break;while(0);RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}RI(2366312)|0;if(!(a[2366460]|0)){RI(2366312)|0;_th(2366312)}RI(2366088)|0;q6e(0,c[(c[591545]|0)+4>>2]|0,0)|0;RI(2377032)|0;if(!(a[2377180]|0)){RI(2377032)|0;_th(2377032)}e8e(0);RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}c8e(0);if(94==94){i=b;return}else Yth(0)}function e8e(b){b=b|0;b=i;RI(2377032)|0;if(!(a[2377180]|0)){RI(2377032)|0;_th(2377032)}RI(2377032)|0;c[(c[(c[594281]|0)+4>>2]|0)+8>>2]=0;RI(2377032)|0;c[(c[(c[594281]|0)+8>>2]|0)+12>>2]=0;RI(2377032)|0;c[(c[(c[594281]|0)+12>>2]|0)+8>>2]=0;RI(2377032)|0;c[(c[(c[594281]|0)+12>>2]|0)+12>>2]=0;i=b;return}function f8e(b,c){b=b|0;c=c|0;var d=0,e=0;b=i;if(!c){d=0;i=b;return d|0}RI(2376632)|0;if((vL(c,2376632)|0)==0?(e=huh(2660224,c)|0,RI(2376632)|0,(vL(e,2376632)|0)==0):0){d=0;i=b;return d|0}RI(2366088)|0;if(!(a[2366236]|0)){RI(2366088)|0;_th(2366088)}c8e(0);d=1;i=b;return d|0}function g8e(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[594300]|0;if(!b){d=MK(2377208)|0;c[594300]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function h8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function i8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function j8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function k8e(b){b=b|0;a[b+8>>0]=1;a[b+9>>0]=1;g[b+12>>2]=ea(1.0);g[b+16>>2]=ea(1.0);g[b+20>>2]=ea(1.0);g[b+24>>2]=ea(1.0);g[b+28>>2]=ea(-1.0);g[b+32>>2]=ea(.5);g[b+36>>2]=ea(.5);g[b+40>>2]=ea(1.0);g[b+44>>2]=ea(1.0);return}function l8e(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=ea(1.0);g[a+4>>2]=ea(1.0);g[a+8>>2]=ea(1.0);g[a+12>>2]=ea(1.0);return}function m8e(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);g[a>>2]=b;g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=ea(1.0);return}function n8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function o8e(a){a=a|0;return}function p8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function q8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function r8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function s8e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function t8e(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function u8e(a){a=a|0;var b=0,d=0;b=i;d=c[a+44>>2]|0;if(d)u8e(d);ko[c[a+8>>2]&4095](c[a+16>>2]|0);i=b;return}function v8e(a){a=a|0;var b=0;b=i;eo[c[(c[a+20>>2]|0)+4>>2]&511]();i=b;return}function w8e(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function x8e(a,b){a=a|0;b=b|0;return}function y8e(a){a=a|0;var b=0,d=0;b=i;RI(2378368)|0;d=qL(2378368)|0;k8e(d);c[a+104>>2]=d;b4e(a);RI(1109032)|0;c[a+100>>2]=$th(1109032,1)|0;i=b;return}function z8e(a){a=a|0;var b=0;b=i;A8e(a);i=b;return}function A8e(a){a=a|0;var b=0;b=i;zbh();if(!(c[a+100>>2]|0))v9e(0,c[879436]|0);w9e(a);i=b;return}function B8e(a){a=a|0;return c[a+16>>2]|0}function C8e(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=b+16|0;c[f>>2]=d;RI(2379632)|0;if(!(Khf(0,c[(c[594931]|0)+8>>2]|0,b)|0)){A8e(b);i=e;return}d=c[f>>2]|0;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}E8e(0,d);A8e(b);i=e;return}function D8e(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Khf(0,b,c)|0;i=a;return d|0}function E8e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[597948]|0;if(!d){e=MK(2391800)|0;c[597948]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function F8e(a){a=a|0;return c[a+20>>2]|0}function G8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+20>>2]=b;A8e(a);i=d;return}function H8e(a){a=a|0;return c[a+32>>2]|0}function I8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+32>>2]=b;A8e(a);i=d;return}function J8e(a){a=a|0;return c[a+36>>2]|0}function K8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+36>>2]=b;A8e(a);i=d;return}function L8e(a){a=a|0;return c[a+40>>2]|0}function M8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+40>>2]=b;A8e(a);i=d;return}function N8e(a){a=a|0;return c[a+24>>2]|0}function O8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+24>>2]=b;A8e(a);i=d;return}function P8e(a){a=a|0;return c[a+28>>2]|0}function Q8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+28>>2]=b;A8e(a);i=d;return}function R8e(a){a=a|0;return c[a+44>>2]|0}function S8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+44>>2]=b;A8e(a);i=d;return}function T8e(a){a=a|0;return c[a+48>>2]|0}function U8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+48>>2]=b;A8e(a);i=d;return}function V8e(a){a=a|0;return c[a+52>>2]|0}function W8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+52>>2]=b;A8e(a);i=d;return}function X8e(a){a=a|0;return c[a+56>>2]|0}function Y8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+56>>2]=b;A8e(a);i=d;return}function Z8e(a){a=a|0;return c[a+60>>2]|0}function _8e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+60>>2]=b;A8e(a);i=d;return}function $8e(a){a=a|0;return c[a+64>>2]|0}function a9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+64>>2]=b;A8e(a);i=d;return}function b9e(a){a=a|0;return c[a+68>>2]|0}function c9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+68>>2]=b;A8e(a);i=d;return}function d9e(a){a=a|0;return c[a+72>>2]|0}function e9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+72>>2]=b;A8e(a);i=d;return}function f9e(a){a=a|0;return c[a+76>>2]|0}function g9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+76>>2]=b;A8e(a);i=d;return}function h9e(a){a=a|0;return c[a+80>>2]|0}function i9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+80>>2]=b;A8e(a);i=d;return}function j9e(a){a=a|0;return c[a+84>>2]|0}function k9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+84>>2]=b;A8e(a);i=d;return}function l9e(a){a=a|0;return c[a+88>>2]|0}function m9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+88>>2]=b;A8e(a);i=d;return}function n9e(a){a=a|0;return c[a+92>>2]|0}function o9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+92>>2]=b;A8e(a);i=d;return}function p9e(a){a=a|0;return c[a+96>>2]|0}function q9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+96>>2]=b;A8e(a);i=d;return}function r9e(a){a=a|0;return c[a+100>>2]|0}function s9e(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+100>>2]=b;A8e(a);i=d;return}function t9e(a){a=a|0;return c[a+104>>2]|0}function u9e(b){b=b|0;var d=0,e=0,f=0;b=i;RI(2379632)|0;if(c[c[594931]>>2]|0){RI(2379632)|0;d=c[594931]|0;e=c[d>>2]|0;i=b;return e|0}RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;f=qL(2369632)|0;W6e(f);RI(2379632)|0;c[c[594931]>>2]=f;RI(2379632)|0;d=c[594931]|0;e=c[d>>2]|0;i=b;return e|0}function v9e(a,b){a=a|0;b=b|0;var d=0;a=i;Xbh();if(!b)d=c[880196]|0;else d=Fqh(2536904,b)|0;Fgf(0,0,d,0);i=a;return}function w9e(b){b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;e=d;Abh();f=b+20|0;if(!(c[f>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;h=qL(2369632)|0;W6e(h);c[f>>2]=h}h=b+24|0;if(!(c[h>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;j=qL(2369632)|0;W6e(j);c[h>>2]=j}j=b+28|0;if(!(c[j>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;k=qL(2369632)|0;W6e(k);c[j>>2]=k}k=b+32|0;if(!(c[k>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;l=qL(2369632)|0;W6e(l);c[k>>2]=l}l=b+44|0;if(!(c[l>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;m=qL(2369632)|0;W6e(m);c[l>>2]=m}m=b+36|0;if(!(c[m>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;n=qL(2369632)|0;W6e(n);c[m>>2]=n}n=b+40|0;if(!(c[n>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;o=qL(2369632)|0;W6e(o);c[n>>2]=o}o=b+48|0;if(!(c[o>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;p=qL(2369632)|0;W6e(p);c[o>>2]=p}p=b+52|0;if(!(c[p>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;q=qL(2369632)|0;W6e(q);c[p>>2]=q}q=b+56|0;if(!(c[q>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;r=qL(2369632)|0;W6e(r);c[q>>2]=r}r=b+60|0;if(!(c[r>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;s=qL(2369632)|0;W6e(s);c[r>>2]=s}s=b+64|0;if(!(c[s>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;t=qL(2369632)|0;W6e(t);c[s>>2]=t}t=b+68|0;if(!(c[t>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;u=qL(2369632)|0;W6e(u);c[t>>2]=u}u=b+72|0;if(!(c[u>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;v=qL(2369632)|0;W6e(v);c[u>>2]=v}v=b+76|0;if(!(c[v>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;w=qL(2369632)|0;W6e(w);c[v>>2]=w}w=b+80|0;if(!(c[w>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;x=qL(2369632)|0;W6e(x);c[w>>2]=x}x=b+84|0;if(!(c[x>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;y=qL(2369632)|0;W6e(y);c[x>>2]=y}y=b+88|0;if(!(c[y>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;z=qL(2369632)|0;W6e(z);c[y>>2]=z}z=b+92|0;if(!(c[z>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;A=qL(2369632)|0;W6e(A);c[z>>2]=A}A=b+96|0;if(!(c[A>>2]|0)){RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;_th(2369632)}RI(2369632)|0;B=qL(2369632)|0;W6e(B);c[A>>2]=B}RI(3117120)|0;if(!(a[3117268]|0)){RI(3117120)|0;_th(3117120)}B=Owg(0)|0;RI(1800432)|0;C=qL(1800432)|0;xHe(C,B);B=b+108|0;c[B>>2]=C;Mrh(1802e3,C,c[879452]|0,c[f>>2]|0);x9e(c[f>>2]|0,c[879454]|0);Mrh(1802e3,c[B>>2]|0,c[879456]|0,c[h>>2]|0);x9e(c[h>>2]|0,c[879458]|0);Mrh(1802e3,c[B>>2]|0,c[879460]|0,c[j>>2]|0);x9e(c[j>>2]|0,c[879462]|0);Mrh(1802e3,c[B>>2]|0,c[879464]|0,c[k>>2]|0);x9e(c[k>>2]|0,c[879466]|0);Mrh(1802e3,c[B>>2]|0,c[879468]|0,c[l>>2]|0);x9e(c[l>>2]|0,c[879470]|0);Mrh(1802e3,c[B>>2]|0,c[879472]|0,c[m>>2]|0);x9e(c[m>>2]|0,c[879474]|0);Mrh(1802e3,c[B>>2]|0,c[879476]|0,c[n>>2]|0);x9e(c[n>>2]|0,c[879478]|0);Mrh(1802e3,c[B>>2]|0,c[879480]|0,c[o>>2]|0);x9e(c[o>>2]|0,c[879482]|0);Mrh(1802e3,c[B>>2]|0,c[879484]|0,c[p>>2]|0);x9e(c[p>>2]|0,c[879486]|0);Mrh(1802e3,c[B>>2]|0,c[879488]|0,c[q>>2]|0);x9e(c[q>>2]|0,c[879490]|0);Mrh(1802e3,c[B>>2]|0,c[879492]|0,c[r>>2]|0);x9e(c[r>>2]|0,c[879494]|0);Mrh(1802e3,c[B>>2]|0,c[879496]|0,c[s>>2]|0);x9e(c[s>>2]|0,c[879498]|0);Mrh(1802e3,c[B>>2]|0,c[879500]|0,c[t>>2]|0);x9e(c[t>>2]|0,c[879502]|0);Mrh(1802e3,c[B>>2]|0,c[879504]|0,c[u>>2]|0);x9e(c[u>>2]|0,c[879506]|0);Mrh(1802e3,c[B>>2]|0,c[879508]|0,c[v>>2]|0);x9e(c[v>>2]|0,c[879510]|0);Mrh(1802e3,c[B>>2]|0,c[879512]|0,c[w>>2]|0);x9e(c[w>>2]|0,c[879514]|0);Mrh(1802e3,c[B>>2]|0,c[879516]|0,c[x>>2]|0);x9e(c[x>>2]|0,c[879518]|0);Mrh(1802e3,c[B>>2]|0,c[879520]|0,c[y>>2]|0);x9e(c[y>>2]|0,c[879522]|0);Mrh(1802e3,c[B>>2]|0,c[879524]|0,c[z>>2]|0);x9e(c[z>>2]|0,c[879526]|0);Mrh(1802e3,c[B>>2]|0,c[879528]|0,c[A>>2]|0);x9e(c[A>>2]|0,c[879530]|0);A=b+100|0;b=c[A>>2]|0;if(!b){D=u9e(0)|0;y9e(D,1);E=u9e(0)|0;F=z9e(E)|0;g[e>>2]=ea(1.0);G=e+4|0;g[G>>2]=ea(0.0);H=e+8|0;g[H>>2]=ea(0.0);I=e+12|0;g[I>>2]=ea(1.0);oaf(F,e);i=d;return}if((c[b+12>>2]|0)>0){J=b;K=0}else{D=u9e(0)|0;y9e(D,1);E=u9e(0)|0;F=z9e(E)|0;g[e>>2]=ea(1.0);G=e+4|0;g[G>>2]=ea(0.0);H=e+8|0;g[H>>2]=ea(0.0);I=e+12|0;g[I>>2]=ea(1.0);oaf(F,e);i=d;return}while(1){b=c[J+16+(da(c[(c[J>>2]|0)+120>>2]|0,K)|0)>>2]|0;if(!b)L=J;else{z=c[B>>2]|0;y=t7e(b)|0;b=c[A>>2]|0;Mrh(1802e3,z,y,c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,K)|0)>>2]|0);L=c[A>>2]|0}K=K+1|0;if((K|0)>=(c[L+12>>2]|0))break;else J=L}D=u9e(0)|0;y9e(D,1);E=u9e(0)|0;F=z9e(E)|0;g[e>>2]=ea(1.0);G=e+4|0;g[G>>2]=ea(0.0);H=e+8|0;g[H>>2]=ea(0.0);I=e+12|0;g[I>>2]=ea(1.0);oaf(F,e);i=d;return}function x9e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597818]|0;if(!e){f=MK(2391280)|0;c[597818]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function y9e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597932]|0;if(!e){f=MK(2391736)|0;c[597932]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function z9e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;f=a+12|0;g=c[f>>2]|0;if(g){h=g;i=b;return h|0}g=Oaf(a,0)|0;RI(2387504)|0;j=qL(2387504)|0;c[e>>2]=g;c[d+0>>2]=c[e+0>>2];kaf(j,a,d);c[f>>2]=j;h=j;i=b;return h|0}function A9e(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=ea(1.0);g[a+4>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+12>>2]=ea(1.0);return}function B9e(a,b){a=a|0;b=b|0;var c=0;c=i;oaf(a,b);i=c;return}function C9e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;Bbh();g=D9e(b,d)|0;if(g){h=g;i=e;return h|0}RI(1086352)|0;g=$th(1086352,6)|0;Qqh(g,c[879710]|0);j=g+16|0;c[j>>2]=c[879710];Qqh(g,d);c[j+(c[(c[g>>2]|0)+120>>2]|0)>>2]=d;Qqh(g,c[879712]|0);c[j+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[879712];d=E9e(b)|0;Qqh(g,d);c[j+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=d;Qqh(g,c[879714]|0);c[j+(c[(c[g>>2]|0)+120>>2]<<2)>>2]=c[879714];c[f>>2]=s6e(r6e(0)|0)|0;RI(2379888)|0;d=pL(2379888,f)|0;Qqh(g,d);c[j+((c[(c[g>>2]|0)+120>>2]|0)*5|0)>>2]=d;if(!(a[2540708]|0))_th(2540560);F9e(0,eqf(0,g)|0);h=u9e(0)|0;i=e;return h|0}function D9e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Cbh();if(Khf(0,a,0)|0){G9e(0,c[879738]|0);i=d;return 0}f=a+108|0;g=c[f>>2]|0;if(!g){w9e(a);h=c[f>>2]|0}else h=g;g=Nrh(1800376,h,b,e)|0;i=d;return (g?c[e>>2]|0:0)|0}function E9e(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[614174]|0;if(!d){e=MK(2456704)|0;c[614174]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function F9e(a,b){a=a|0;b=b|0;a=i;Fgf(0,1,Fqh(2536904,b)|0,0);i=a;return}function G9e(a,b){a=a|0;b=b|0;var d=0;a=i;Ybh();if(!b)d=c[880202]|0;else d=Fqh(2536904,b)|0;Fgf(0,2,d,0);i=a;return}function H9e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+48|0;d=b+20|0;e=b;f=a+108|0;g=c[f>>2]|0;if(!g){w9e(a);h=c[f>>2]|0}else h=g;NIe(d,VHe(h)|0);c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];RI(1824112)|0;d=pL(1824112,e)|0;i=b;return d|0}function I9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2507056)|0;nmf(a);c[c[d>>2]>>2]=a;i=b;return}function J9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function K9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function L9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function M9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function N9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function O9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function P9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function Q9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function R9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function S9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function T9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function U9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function V9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function W9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function X9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function Y9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function Z9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function _9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function $9e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function aaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function baf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function caf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function daf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function eaf(b){b=b|0;var d=0,e=0;d=i;if(!(a[2540708]|0))_th(2540560);e=c[c[635163]>>2]|0;c[b+8>>2]=e;c[b+16>>2]=e;i=d;return}function faf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!(a[2540708]|0))_th(2540560);f=c[c[635163]>>2]|0;g=b+8|0;c[g>>2]=f;c[b+16>>2]=f;c[g>>2]=d;i=e;return}function gaf(b){b=b|0;var d=0;b=i;if(!(a[2540708]|0))_th(2540560);RI(2377032)|0;d=qL(2377032)|0;faf(d,c[c[635163]>>2]|0);RI(2377032)|0;c[c[594281]>>2]=d;RI(2377032)|0;d=qL(2377032)|0;eaf(d);RI(2377032)|0;c[(c[594281]|0)+4>>2]=d;RI(2377032)|0;d=qL(2377032)|0;eaf(d);RI(2377032)|0;c[(c[594281]|0)+8>>2]=d;RI(2377032)|0;d=qL(2377032)|0;eaf(d);RI(2377032)|0;c[(c[594281]|0)+12>>2]=d;i=b;return}function haf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function iaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function jaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;c[c[d>>2]>>2]=a;i=b;return}function kaf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+12>>2]=b;c[a+8>>2]=c[d>>2];c[a+16>>2]=laf(a)|0;i=e;return}function laf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[596840]|0;if(!d){e=MK(2387368)|0;c[596840]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function maf(a){a=a|0;var b=0;b=i;if(c[a+12>>2]|0){i=b;return}naf(a);i=b;return}function naf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[596828]|0;if(!d){e=MK(2387320)|0;c[596828]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function oaf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[596856]|0;if(!e){f=MK(2387432)|0;c[596856]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function paf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function qaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function raf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function saf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597094]|0;if(!d){e=MK(2388384)|0;c[597094]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function taf(a,b,d){a=a|0;b=b|0;d=d|0;c[a+12>>2]=b;c[a+8>>2]=c[d>>2];return}function uaf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;saf(a);C7e(a,b);E7e(a,c);G7e(a,d);I7e(a,e);i=f;return}function vaf(a){a=a|0;var b=0;b=i;if(c[a+12>>2]|0){i=b;return}waf(a);i=b;return}function waf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597104]|0;if(!d){e=MK(2388424)|0;c[597104]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function xaf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;Dbh();RI(1086352)|0;h=$th(1086352,4)|0;c[d>>2]=B7e(a)|0;RI(2540224)|0;j=pL(2540224,d)|0;Qqh(h,j);d=h+16|0;c[d>>2]=j;c[e>>2]=D7e(a)|0;RI(2540224)|0;j=pL(2540224,e)|0;Qqh(h,j);c[d+(c[(c[h>>2]|0)+120>>2]|0)>>2]=j;c[f>>2]=F7e(a)|0;RI(2540224)|0;j=pL(2540224,f)|0;Qqh(h,j);c[d+(c[(c[h>>2]|0)+120>>2]<<1)>>2]=j;c[g>>2]=H7e(a)|0;RI(2540224)|0;a=pL(2540224,g)|0;Qqh(h,a);c[d+((c[(c[h>>2]|0)+120>>2]|0)*3|0)>>2]=a;a=w7e(0,c[879750]|0,h)|0;i=b;return a|0}function yaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function zaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Aaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Baf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Caf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Daf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Eaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Faf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Gaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Haf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Iaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Jaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Kaf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597786]|0;if(!d){e=MK(2391152)|0;c[597786]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function Laf(b){b=b|0;b=i;RI(2369632)|0;a[c[592431]>>0]=1;i=b;return}function Maf(a){a=a|0;var b=0;b=i;Naf(a);i=b;return}function Naf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[597796]|0;if(!d){e=MK(2391192)|0;c[597796]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function Oaf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597832]|0;if(!e){f=MK(2391336)|0;c[597832]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function Paf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[597848]|0;if(!e){f=MK(2391400)|0;c[597848]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function Qaf(a){a=a|0;var b=0,d=0,e=0;b=i;Ebh();RI(1086352)|0;d=$th(1086352,1)|0;e=t7e(a)|0;Qqh(d,e);c[d+16>>2]=e;e=w7e(0,c[879772]|0,d)|0;i=b;return e|0}function Raf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Saf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Taf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Uaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Vaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Waf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Xaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Yaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Zaf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function _af(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function $af(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function abf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function bbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function cbf(a){a=a|0;var b=0;b=i;dbf(a);i=b;return}function dbf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598608]|0;if(!d){e=MK(2394440)|0;c[598608]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function ebf(a){a=a|0;var b=0;b=i;fbf(a);i=b;return}function fbf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598618]|0;if(!d){e=MK(2394480)|0;c[598618]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function gbf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a;c[e>>2]=0;c[e+4>>2]=0;hbf(b,a);i=d;return}function hbf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[598638]|0;if(!e){f=MK(2394560)|0;c[598638]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function ibf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598658]|0;if(!d){e=MK(2394640)|0;c[598658]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function jbf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598670]|0;if(!d){e=MK(2394688)|0;c[598670]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function kbf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598682]|0;if(!d){e=MK(2394736)|0;c[598682]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function lbf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[598694]|0;if(!d){e=MK(2394784)|0;c[598694]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function mbf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[598748]|0;if(!f){g=MK(2395e3)|0;c[598748]=g;h=g}else h=f;c[e>>2]=c[b>>2];c[d+0>>2]=c[e+0>>2];ko[h&4095](d);i=a;return}function nbf(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;RI(2394824)|0;if(!(c[(c[598729]|0)+4>>2]|0)){RI(2394824)|0;e=qL(2394824)|0;cbf(e);RI(2394824)|0;c[(c[598729]|0)+4>>2]=e}RI(2394824)|0;e=c[(c[598729]|0)+4>>2]|0;RI(2394824)|0;c[c[598729]>>2]=e;RI(2394824)|0;c[d>>2]=c[(c[(c[598729]|0)+4>>2]|0)+8>>2];c[b+0>>2]=c[d+0>>2];mbf(0,b);i=a;return}function obf(a){a=a|0;var b=0,c=0;b=i;c=((s6e(a)|0)&-2|0)==4;i=b;return c|0}function pbf(a){a=a|0;var b=0,c=0;b=i;c=(s6e(a)|0)>>>0<4;i=b;return c|0}function qbf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;if(obf(a)|0)g=(lbf(a)|0)&65535;else g=1;if((s6e(a)|0)>>>0>=4){h=g;j=ibf(a)|0;k=h*37|0;l=k|j;i=b;return l|0}g=e;c[g>>2]=0;c[g+4>>2]=0;hbf(a,e);g=e;e=c[g+4>>2]|0;f=d;c[f>>2]=c[g>>2];c[f+4>>2]=e;h=rbf(d)|0;j=ibf(a)|0;k=h*37|0;l=k|j;i=b;return l|0}function rbf(a){a=a|0;var b=0,c=0,d=0;b=i;c=kxf(a)|0;d=(kxf(a+4|0)|0)<<2^c;i=b;return d|0}function sbf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im;d=i;i=i+16|0;e=d+8|0;f=d;if(!b){h=0;i=d;return h|0}if(_nf(0,a,b)|0){h=1;i=d;return h|0}j=Xnf(b)|0;if((j|0)!=(Xnf(a)|0)){h=0;i=d;return h|0}RI(2394824)|0;j=duh(b,2394824)|0;b=s6e(a)|0;if((b|0)!=(s6e(j)|0)){h=0;i=d;return h|0}b=ibf(a)|0;if(((ibf(j)|0)^b)&-33){h=0;i=d;return h|0}if(obf(a)|0){b=lbf(a)|0;h=(b|0)==(lbf(j)|0);i=d;return h|0}if((s6e(a)|0)>>>0>=4){h=0;i=d;return h|0}b=e;c[b>>2]=0;c[b+4>>2]=0;hbf(a,e);a=f;c[a>>2]=0;c[a+4>>2]=0;hbf(j,f);j=e;e=f;k=ea(g[e>>2]);l=ea(g[e+4>>2]);m=ea(g[j>>2]);n=ea(m-k);k=ea(ea(g[j+4>>2])-l);h=ea(ea(n*n)+ea(k*k))<ea(9.99999943e-11);i=d;return h|0}function tbf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im;a=i;d=b;b=c;e=ea(g[b>>2]);f=ea(g[b+4>>2]);h=ea(g[d>>2]);j=ea(h-e);e=ea(ea(g[d+4>>2])-f);d=ea(ea(j*j)+ea(e*e))<ea(9.99999943e-11);i=a;return d|0}function ubf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+64|0;e=d+52|0;f=d+44|0;g=d+28|0;h=d+40|0;j=d+16|0;k=d+48|0;l=d+56|0;m=d+32|0;n=d;o=d+8|0;p=d+20|0;q=d+24|0;r=d+36|0;Fbh();if(obf(b)|0){s=(jbf(b)|0)<<16>>16==0;RI(1086352)|0;if(s){s=$th(1086352,3)|0;c[e>>2]=s6e(b)|0;RI(2379888)|0;t=pL(2379888,e)|0;Qqh(s,t);e=s+16|0;c[e>>2]=t;c[f>>2]=ibf(b)|0;RI(2395064)|0;t=pL(2395064,f)|0;Qqh(s,t);c[e+(c[(c[s>>2]|0)+120>>2]|0)>>2]=t;c[g>>2]=lbf(b)|0;RI(2395232)|0;t=pL(2395232,g)|0;Qqh(s,t);c[e+(c[(c[s>>2]|0)+120>>2]<<1)>>2]=t;u=w7e(0,c[879784]|0,s)|0;i=d;return u|0}s=$th(1086352,8)|0;Qqh(s,c[879786]|0);t=s+16|0;c[t>>2]=c[879786];c[h>>2]=s6e(b)|0;RI(2379888)|0;e=pL(2379888,h)|0;Qqh(s,e);c[t+(c[(c[s>>2]|0)+120>>2]|0)>>2]=e;Qqh(s,c[879788]|0);c[t+(c[(c[s>>2]|0)+120>>2]<<1)>>2]=c[879788];c[j>>2]=(jbf(b)|0)&65535;RI(2540224)|0;e=pL(2540224,j)|0;Qqh(s,e);c[t+((c[(c[s>>2]|0)+120>>2]|0)*3|0)>>2]=e;Qqh(s,c[879790]|0);c[t+(c[(c[s>>2]|0)+120>>2]<<2)>>2]=c[879790];c[k>>2]=ibf(b)|0;RI(2395064)|0;e=pL(2395064,k)|0;Qqh(s,e);c[t+((c[(c[s>>2]|0)+120>>2]|0)*5|0)>>2]=e;Qqh(s,c[879792]|0);c[t+((c[(c[s>>2]|0)+120>>2]|0)*6|0)>>2]=c[879792];c[l>>2]=lbf(b)|0;RI(2395232)|0;e=pL(2395232,l)|0;Qqh(s,e);c[t+((c[(c[s>>2]|0)+120>>2]|0)*7|0)>>2]=e;if(!(a[2540708]|0))_th(2540560);e=eqf(0,s)|0;RI(1086352)|0;u=w7e(0,e,$th(1086352,0)|0)|0;i=d;return u|0}if((s6e(b)|0)>>>0<4){RI(1086352)|0;e=$th(1086352,3)|0;c[m>>2]=s6e(b)|0;RI(2379888)|0;s=pL(2379888,m)|0;Qqh(e,s);m=e+16|0;c[m>>2]=s;s=n;c[s>>2]=0;c[s+4>>2]=0;hbf(b,n);s=n;n=c[s+4>>2]|0;t=o;c[t>>2]=c[s>>2];c[t+4>>2]=n;RI(2395400)|0;n=pL(2395400,o)|0;Qqh(e,n);c[m+(c[(c[e>>2]|0)+120>>2]|0)>>2]=n;c[p>>2]=ibf(b)|0;RI(2395064)|0;n=pL(2395064,p)|0;Qqh(e,n);c[m+(c[(c[e>>2]|0)+120>>2]<<1)>>2]=n;u=w7e(0,c[879794]|0,e)|0;i=d;return u|0}if((s6e(b)|0)!=14?(s6e(b)|0)!=13:0){if(!(a[2540708]|0))_th(2540560);c[r>>2]=s6e(b)|0;RI(2379888)|0;e=pL(2379888,r)|0;u=fwf(0,c[c[635163]>>2]|0,e)|0;i=d;return u|0}RI(1086352)|0;e=$th(1086352,2)|0;c[q>>2]=s6e(b)|0;RI(2379888)|0;r=pL(2379888,q)|0;Qqh(e,r);q=e+16|0;c[q>>2]=r;r=kbf(b)|0;Qqh(e,r);c[q+(c[(c[e>>2]|0)+120>>2]|0)>>2]=r;u=w7e(0,c[879796]|0,e)|0;i=d;return u|0}function vbf(a,b){a=a|0;b=b|0;Yth(SJ(2395568)|0)}function wbf(a,b){a=a|0;b=b|0;Yth(SJ(2395568)|0)}function xbf(a){a=a|0;return}function ybf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function zbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Abf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Bbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Cbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Dbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Ebf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Fbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Gbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Hbf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Ibf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function Jbf(a,b,c){a=a|0;b=ea(b);c=ea(c);g[a>>2]=b;g[a+4>>2]=c;return}function Kbf(a){a=a|0;var b=0,d=0,e=0,f=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;Gbh();RI(1086352)|0;f=$th(1086352,2)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;h=pL(2586184,d)|0;Qqh(f,h);d=f+16|0;c[d>>2]=h;g[e>>2]=ea(g[a+4>>2]);RI(2586184)|0;a=pL(2586184,e)|0;Qqh(f,a);c[d+(c[(c[f>>2]|0)+120>>2]|0)>>2]=a;a=w7e(0,c[879886]|0,f)|0;i=b;return a|0}function Lbf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=Im,h=Im;c=i;RI(2395400)|0;if(!(vL(b,2395400)|0)){d=0;i=c;return d|0}RI(2395400)|0;e=Zth(b,2395400)|0;f=ea(g[e>>2]);h=ea(g[e+4>>2]);if(!(jxf(a,f)|0)){d=0;i=c;return d|0}d=jxf(a+4|0,h)|0;i=c;return d|0}function Mbf(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(ea(c*c)+ea(d*d));return ea(e)}function Nbf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im;f=ea(g[d>>2]);h=ea(g[e>>2]);i=ea(g[d+4>>2]);j=ea(g[e+4>>2]);e=a;c[e>>2]=0;c[e+4>>2]=0;k=ea(i-j);g[a>>2]=ea(f-h);g[a+4>>2]=k;return}function Obf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function Pbf(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);g[a>>2]=b;g[a+4>>2]=c;g[a+8>>2]=d;return}function Qbf(a){a=a|0;var b=0,c=0,d=0,e=0;b=i;c=kxf(a)|0;d=kxf(a+4|0)|0;e=d<<2^c^(kxf(a+8|0)|0)>>2;i=b;return e|0}function Rbf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=Im,h=Im,j=Im;c=i;RI(2416264)|0;if(!(vL(b,2416264)|0)){d=0;i=c;return d|0}RI(2416264)|0;e=Zth(b,2416264)|0;f=ea(g[e>>2]);h=ea(g[e+4>>2]);j=ea(g[e+8>>2]);if(!(jxf(a,f)|0)){d=0;i=c;return d|0}if(!(jxf(a+4|0,h)|0)){d=0;i=c;return d|0}d=jxf(a+8|0,j)|0;i=c;return d|0}function Sbf(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;Hbh();RI(1086352)|0;h=$th(1086352,3)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;j=pL(2586184,d)|0;Qqh(h,j);d=h+16|0;c[d>>2]=j;g[e>>2]=ea(g[a+4>>2]);RI(2586184)|0;j=pL(2586184,e)|0;Qqh(h,j);c[d+(c[(c[h>>2]|0)+120>>2]|0)>>2]=j;g[f>>2]=ea(g[a+8>>2]);RI(2586184)|0;a=pL(2586184,f)|0;Qqh(h,a);c[d+(c[(c[h>>2]|0)+120>>2]<<1)>>2]=a;a=w7e(0,c[879898]|0,h)|0;i=b;return a|0}function Tbf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Ibh();RI(1086352)|0;e=$th(1086352,3)|0;f=rxf(a,b)|0;Qqh(e,f);g=e+16|0;c[g>>2]=f;f=rxf(a+4|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]|0)>>2]=f;f=rxf(a+8|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]<<1)>>2]=f;f=w7e(0,c[879914]|0,e)|0;i=d;return f|0}function Ubf(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(ea(ea(c*c)+ea(d*d))+ea(e*e));return ea(f)}function Vbf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=Im,j=Im,k=Im,l=Im,m=Im,n=Im;d=i;h=ea(g[e>>2]);j=ea(g[f>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}k=ea(g[e+4>>2]);l=ea(g[f+4>>2]);m=ea(g[e+8>>2]);n=ea(g[f+8>>2]);f=b;c[f>>2]=0;c[f+4>>2]=0;g[b>>2]=!(h>=j)?h:j;g[b+4>>2]=!(k>=l)?k:l;g[b+8>>2]=!(m>=n)?m:n;i=d;return}function Wbf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=Im,j=Im,k=Im,l=Im,m=Im,n=Im;d=i;h=ea(g[e>>2]);j=ea(g[f>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}k=ea(g[e+4>>2]);l=ea(g[f+4>>2]);m=ea(g[e+8>>2]);n=ea(g[f+8>>2]);f=b;c[f>>2]=0;c[f+4>>2]=0;g[b>>2]=!(h<=j)?h:j;g[b+4>>2]=!(k<=l)?k:l;g[b+8>>2]=!(m<=n)?m:n;i=d;return}function Xbf(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Ybf(a,b){a=a|0;b=b|0;b=a;c[b>>2]=0;c[b+4>>2]=0;g[a+8>>2]=ea(-1.0);return}function Zbf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im;f=ea(g[d>>2]);h=ea(g[e>>2]);i=ea(g[d+4>>2]);j=ea(g[e+4>>2]);k=ea(g[d+8>>2]);l=ea(g[e+8>>2]);e=a;c[e>>2]=0;c[e+4>>2]=0;m=ea(i+j);j=ea(k+l);g[a>>2]=ea(f+h);g[a+4>>2]=m;g[a+8>>2]=j;return}function _bf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im;f=ea(g[d>>2]);h=ea(g[e>>2]);i=ea(g[d+4>>2]);j=ea(g[e+4>>2]);k=ea(g[d+8>>2]);l=ea(g[e+8>>2]);e=a;c[e>>2]=0;c[e+4>>2]=0;m=ea(i-j);j=ea(k-l);g[a>>2]=ea(f-h);g[a+4>>2]=m;g[a+8>>2]=j;return}function $bf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=Im,h=Im,i=Im,j=Im;f=ea(g[d>>2]);h=ea(g[d+4>>2]);i=ea(g[d+8>>2]);d=a;c[d>>2]=0;c[d+4>>2]=0;j=ea(h*e);h=ea(i*e);g[a>>2]=ea(f*e);g[a+4>>2]=j;g[a+8>>2]=h;return}function acf(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[c>>2]);i=ea(g[c+4>>2]);j=ea(d-h);h=ea(e-i);i=ea(f-ea(g[c+8>>2]));c=ea(ea(ea(j*j)+ea(h*h))+ea(i*i))<ea(9.99999943e-11);return c|0}function bcf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function ccf(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);g[a>>2]=b;g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=e;return}function dcf(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;h=b;Jbh();RI(1086352)|0;j=$th(1086352,4)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;k=pL(2586184,d)|0;Qqh(j,k);d=j+16|0;c[d>>2]=k;g[e>>2]=ea(g[a+4>>2]);RI(2586184)|0;k=pL(2586184,e)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]|0)>>2]=k;g[f>>2]=ea(g[a+8>>2]);RI(2586184)|0;k=pL(2586184,f)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=k;g[h>>2]=ea(g[a+12>>2]);RI(2586184)|0;a=pL(2586184,h)|0;Qqh(j,a);c[d+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=a;a=w7e(0,c[879926]|0,j)|0;i=b;return a|0}function ecf(a){a=a|0;var b=0,d=0,e=Im,f=Im,h=Im,j=Im;b=i;i=i+16|0;d=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;e=ea(g[a>>2]);f=ea(g[a+4>>2]);h=ea(g[a+8>>2]);j=ea(g[a+12>>2]);g[d>>2]=e;g[d+4>>2]=f;g[d+8>>2]=h;g[d+12>>2]=j;a=gcf(d)|0;i=b;return a|0}function fcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im,f=Im,h=Im,i=Im;e=ea(g[d>>2]);f=ea(g[d+4>>2]);h=ea(g[d+8>>2]);i=ea(g[d+12>>2]);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=e;g[a+4>>2]=f;g[a+8>>2]=h;g[a+12>>2]=i;return}function gcf(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=kxf(a)|0;d=kxf(a+4|0)|0;e=kxf(a+8|0)|0;f=d<<2^c^e>>2^(kxf(a+12|0)|0)>>1;i=b;return f|0}function hcf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=Im,h=Im,j=Im,k=Im;c=i;RI(2417688)|0;if(!(vL(b,2417688)|0)){d=0;i=c;return d|0}RI(2417688)|0;e=Zth(b,2417688)|0;f=ea(g[e>>2]);h=ea(g[e+4>>2]);j=ea(g[e+8>>2]);k=ea(g[e+12>>2]);if(!(jxf(a,f)|0)){d=0;i=c;return d|0}if(!(jxf(a+4|0,h)|0)){d=0;i=c;return d|0}if(!(jxf(a+8|0,j)|0)){d=0;i=c;return d|0}d=jxf(a+12|0,k)|0;i=c;return d|0}function icf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=Im,h=Im,i=Im,j=Im,k=Im;f=ea(g[d>>2]);h=ea(g[d+4>>2]);i=ea(g[d+8>>2]);j=ea(g[d+12>>2]);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;k=ea(h*e);h=ea(i*e);i=ea(j*e);g[a>>2]=ea(f*e);g[a+4>>2]=k;g[a+8>>2]=h;g[a+12>>2]=i;return}function jcf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function kcf(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a[b>>0]=c;a[b+1>>0]=d;a[b+2>>0]=e;a[b+3>>0]=f;return}function lcf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+3|0;f=d+2|0;g=d+1|0;h=d;Kbh();RI(1086352)|0;j=$th(1086352,4)|0;a[e>>0]=a[b>>0]|0;RI(2557392)|0;k=pL(2557392,e)|0;Qqh(j,k);e=j+16|0;c[e>>2]=k;a[f>>0]=a[b+1>>0]|0;RI(2557392)|0;k=pL(2557392,f)|0;Qqh(j,k);c[e+(c[(c[j>>2]|0)+120>>2]|0)>>2]=k;a[g>>0]=a[b+2>>0]|0;RI(2557392)|0;k=pL(2557392,g)|0;Qqh(j,k);c[e+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=k;a[h>>0]=a[b+3>>0]|0;RI(2557392)|0;b=pL(2557392,h)|0;Qqh(j,b);c[e+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=b;b=w7e(0,c[879948]|0,j)|0;i=d;return b|0}function mcf(b,c,d){b=b|0;c=c|0;d=d|0;var e=Im,f=0,h=0,j=0,k=0,l=0,m=0;c=i;e=ea(g[d>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}if(!(e>=ea(0.0)))f=0;else{h=!(e<=ea(1.0));j=~~ea(e*ea(255.0))&255;f=h?-1:j}e=ea(g[d+4>>2]);if(!(e>=ea(0.0)))k=0;else{j=!(e<=ea(1.0));h=~~ea(e*ea(255.0))&255;k=j?-1:h}e=ea(g[d+8>>2]);if(!(e>=ea(0.0)))l=0;else{h=!(e<=ea(1.0));j=~~ea(e*ea(255.0))&255;l=h?-1:j}e=ea(g[d+12>>2]);if(!(e>=ea(0.0)))m=0;else{d=!(e<=ea(1.0));j=~~ea(e*ea(255.0))&255;m=d?-1:j}a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;a[b>>0]=f;a[b+1>>0]=k;a[b+2>>0]=l;a[b+3>>0]=m;i=c;return}function ncf(a,b){a=a|0;b=ea(b);var c=Im;if(!(b>=ea(0.0)))c=ea(0.0);else{a=!(b<=ea(1.0));c=a?ea(1.0):b}return ea(c)}function ocf(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);g[a>>2]=b;g[a+4>>2]=c;g[a+8>>2]=d;g[a+12>>2]=e;return}function pcf(a,b,c){a=a|0;b=b|0;c=c|0;b=i;qcf(a,0,c);i=b;return}function qcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[604830]|0;if(!e){f=MK(2419328)|0;c[604830]=f;g=f}else g=e;In[g&4095](a,d);i=b;return}function rcf(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;h=b;Lbh();RI(1086352)|0;j=$th(1086352,4)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;k=pL(2586184,d)|0;Qqh(j,k);d=j+16|0;c[d>>2]=k;g[e>>2]=ea(g[a+4>>2]);RI(2586184)|0;k=pL(2586184,e)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]|0)>>2]=k;g[f>>2]=ea(g[a+8>>2]);RI(2586184)|0;k=pL(2586184,f)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=k;g[h>>2]=ea(g[a+12>>2]);RI(2586184)|0;a=pL(2586184,h)|0;Qqh(j,a);c[d+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=a;a=w7e(0,c[879964]|0,j)|0;i=b;return a|0}function scf(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);var f=0,h=Im,j=0;b=i;i=i+16|0;f=b;h=ea(c*ea(.0174532924));c=ea(d*ea(.0174532924));d=ea(e*ea(.0174532924));e=ea(h);h=ea(c);j=f;g[j>>2]=e;g[j+4>>2]=h;g[f+8>>2]=d;ucf(a,0,f);i=b;return}function tcf(a,b,c){a=a|0;b=b|0;c=c|0;b=i;ucf(a,0,c);i=b;return}function ucf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[604850]|0;if(!e){f=MK(2419408)|0;c[604850]=f;g=f}else g=e;In[g&4095](a,d);i=b;return}function vcf(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=kxf(a)|0;d=kxf(a+4|0)|0;e=kxf(a+8|0)|0;f=d<<2^c^e>>2^(kxf(a+12|0)|0)>>1;i=b;return f|0}function wcf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=Im,h=Im,j=Im,k=Im;c=i;RI(2419496)|0;if(!(vL(b,2419496)|0)){d=0;i=c;return d|0}RI(2419496)|0;e=Zth(b,2419496)|0;f=ea(g[e>>2]);h=ea(g[e+4>>2]);j=ea(g[e+8>>2]);k=ea(g[e+12>>2]);if(!(jxf(a,f)|0)){d=0;i=c;return d|0}if(!(jxf(a+4|0,h)|0)){d=0;i=c;return d|0}if(!(jxf(a+8|0,j)|0)){d=0;i=c;return d|0}d=jxf(a+12|0,k)|0;i=c;return d|0}function xcf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im;f=ea(g[d+12>>2]);h=ea(g[e>>2]);i=ea(g[d>>2]);j=ea(g[e+12>>2]);k=ea(g[d+4>>2]);l=ea(g[e+8>>2]);m=ea(g[d+8>>2]);n=ea(g[e+4>>2]);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;o=ea(ea(ea(h*m)+ea(ea(j*k)+ea(f*n)))-ea(i*l));p=ea(ea(ea(ea(f*l)+ea(j*m))+ea(i*n))-ea(h*k));q=ea(ea(ea(ea(f*j)-ea(h*i))-ea(k*n))-ea(l*m));g[a>>2]=ea(ea(ea(ea(f*h)+ea(i*j))+ea(k*l))-ea(m*n));g[a+4>>2]=o;g[a+8>>2]=p;g[a+12>>2]=q;return}function ycf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function zcf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Acf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Bcf(a){a=a|0;var b=Im;b=ea(g[a>>2]);return ea(b)}function Ccf(a){a=a|0;var b=Im;b=ea(g[a+4>>2]);return ea(b)}function Dcf(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;h=b;Mbh();RI(1086352)|0;j=$th(1086352,4)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;k=pL(2586184,d)|0;Qqh(j,k);d=j+16|0;c[d>>2]=k;g[e>>2]=ea(g[a+4>>2]);RI(2586184)|0;k=pL(2586184,e)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]|0)>>2]=k;g[f>>2]=ea(g[a+8>>2]);RI(2586184)|0;k=pL(2586184,f)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=k;g[h>>2]=ea(g[a+12>>2]);RI(2586184)|0;a=pL(2586184,h)|0;Qqh(j,a);c[d+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=a;a=w7e(0,c[879984]|0,j)|0;i=b;return a|0}function Ecf(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=0;c=i;d=ea(g[b>>2]);e=ea(g[a>>2]);if((!(d<e)?!(d>=ea(e+ea(g[a+8>>2]))):0)?(e=ea(g[b+4>>2]),d=ea(g[a+4>>2]),!(e<d)):0)f=e<ea(d+ea(g[a+12>>2]));else f=0;i=c;return f|0}function Fcf(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,h=0;b=i;i=i+16|0;c=b+12|0;d=b+8|0;e=b+4|0;f=b;g[c>>2]=ea(g[a>>2]);h=kxf(c)|0;g[d>>2]=ea(g[a+8>>2]);c=kxf(d)|0;g[e>>2]=ea(g[a+4>>2]);d=kxf(e)|0;g[f>>2]=ea(g[a+12>>2]);a=c<<2^h^d>>2^(kxf(f)|0)>>1;i=b;return a|0}function Gcf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=0,j=0,k=0,l=Im,m=Im,n=Im,o=Im;c=i;i=i+16|0;d=c+12|0;e=c+8|0;f=c+4|0;h=c;g[d>>2]=ea(0.0);g[e>>2]=ea(0.0);g[f>>2]=ea(0.0);g[h>>2]=ea(0.0);RI(2420784)|0;if(!(vL(b,2420784)|0)){j=0;i=c;return j|0}RI(2420784)|0;k=Zth(b,2420784)|0;l=ea(g[k>>2]);m=ea(g[k+4>>2]);n=ea(g[k+8>>2]);o=ea(g[k+12>>2]);g[d>>2]=ea(g[a>>2]);if(!(jxf(d,l)|0)){j=0;i=c;return j|0}g[e>>2]=ea(g[a+4>>2]);if(!(jxf(e,m)|0)){j=0;i=c;return j|0}g[f>>2]=ea(g[a+8>>2]);if(!(jxf(f,n)|0)){j=0;i=c;return j|0}g[h>>2]=ea(g[a+12>>2]);j=jxf(h,o)|0;i=c;return j|0}function Hcf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im;d=i;e=ea(Icf(a,(c<<2)+b|0));i=d;return ea(e)}function Icf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im;d=i;Nbh();do switch(b|0){case 9:{e=a+36|0;break}case 8:{e=a+32|0;break}case 3:{e=a+12|0;break}case 15:{e=a+60|0;break}case 5:{e=a+20|0;break}case 14:{e=a+56|0;break}case 4:{e=a+16|0;break}case 0:{e=a;break}case 1:{e=a+4|0;break}case 6:{e=a+24|0;break}case 10:{e=a+40|0;break}case 12:{e=a+48|0;break}case 11:{e=a+44|0;break}case 7:{e=a+28|0;break}case 2:{e=a+8|0;break}case 13:{e=a+52|0;break}default:{RI(3084024)|0;f=qL(3084024)|0;isg(f,c[880014]|0);Yth(f)}}while(0);h=ea(g[e>>2]);i=d;return ea(h)}function Jcf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);var e=0;e=i;Kcf(a,(c<<2)+b|0,d);i=e;return}function Kcf(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0;e=i;Obh();do switch(b|0){case 9:{g[a+36>>2]=d;break}case 5:{g[a+20>>2]=d;break}case 10:{g[a+40>>2]=d;break}case 1:{g[a+4>>2]=d;break}case 13:{g[a+52>>2]=d;break}case 14:{g[a+56>>2]=d;break}case 0:{g[a>>2]=d;break}case 4:{g[a+16>>2]=d;break}case 3:{g[a+12>>2]=d;break}case 12:{g[a+48>>2]=d;break}case 8:{g[a+32>>2]=d;break}case 6:{g[a+24>>2]=d;break}case 7:{g[a+28>>2]=d;break}case 11:{g[a+44>>2]=d;break}case 2:{g[a+8>>2]=d;break}case 15:{g[a+60>>2]=d;break}default:{RI(3084024)|0;f=qL(3084024)|0;isg(f,c[880030]|0);Yth(f)}}while(0);i=e;return}function Lcf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+64|0;d=b+48|0;e=b+32|0;f=b+16|0;g=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;Mcf(d,a,0);h=gcf(d)|0;Mcf(e,a,1);d=gcf(e)|0;Mcf(f,a,2);e=gcf(f)|0;Mcf(g,a,3);a=d<<2^h^e>>2^(gcf(g)|0)>>1;i=b;return a|0}function Mcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im;e=i;f=d<<2;h=ea(Icf(b,f));j=ea(Icf(b,f|1));k=ea(Icf(b,f|2));l=ea(Icf(b,f|3));c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=h;g[a+4>>2]=j;g[a+8>>2]=k;g[a+12>>2]=l;i=e;return}function Ncf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+192|0;e=d+112|0;f=d+64|0;g=d+16|0;h=d+32|0;j=d+176|0;k=d;l=d+48|0;m=d+96|0;n=d+80|0;o=e+0|0;p=o+64|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;RI(2422424)|0;if(!(vL(b,2422424)|0)){q=0;i=d;return q|0}RI(2422424)|0;o=e+0|0;r=(Zth(b,2422424)|0)+0|0;p=o+64|0;do{c[o>>2]=c[r>>2];o=o+4|0;r=r+4|0}while((o|0)<(p|0));Mcf(f,a,0);Mcf(k,e,0);RI(2353760)|0;if(!(I4e(f,pL(2353760,k)|0)|0)){q=0;i=d;return q|0}Mcf(g,a,1);Mcf(l,e,1);RI(2353760)|0;if(!(I4e(g,pL(2353760,l)|0)|0)){q=0;i=d;return q|0}Mcf(h,a,2);Mcf(m,e,2);RI(2353760)|0;if(!(I4e(h,pL(2353760,m)|0)|0)){q=0;i=d;return q|0}Mcf(j,a,3);Mcf(n,e,3);RI(2353760)|0;q=I4e(j,pL(2353760,n)|0)|0;i=d;return q|0}function Ocf(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Pcf(a,0,c);i=b;return}function Pcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[605648]|0;if(!e){f=MK(2422600)|0;c[605648]=f;g=f}else g=e;In[g&4095](a,d);i=b;return}function Qcf(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Rcf(a,0,c);i=b;return}function Rcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;b=i;e=c[605668]|0;if(!e){f=MK(2422680)|0;c[605668]=f;g=f}else g=e;In[g&4095](a,d);i=b;return}function Scf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Tcf(0,b,c)|0;i=a;return d|0}function Tcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[605688]|0;if(!e){f=MK(2422760)|0;c[605688]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Ucf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+64|0;e=d;f=e+0|0;g=b+0|0;b=f+64|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(b|0));Pcf(a,0,e);i=d;return}function Vcf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+64|0;e=d;f=e+0|0;g=b+0|0;b=f+64|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(b|0));Rcf(a,0,e);i=d;return}function Wcf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[605714]|0;if(!d){e=MK(2422864)|0;c[605714]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Xcf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im;e=i;f=ea(Icf(b,d));h=ea(Icf(b,d+4|0));j=ea(Icf(b,d+8|0));k=ea(Icf(b,d+12|0));c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;g[a>>2]=f;g[a+4>>2]=h;g[a+8>>2]=j;g[a+12>>2]=k;i=e;return}function Ycf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=b<<2;Kcf(a,e,ea(g[c>>2]));Kcf(a,e|1,ea(g[c+4>>2]));Kcf(a,e|2,ea(g[c+8>>2]));Kcf(a,e|3,ea(g[c+12>>2]));i=d;return}function Zcf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Kcf(a,b,ea(g[c>>2]));Kcf(a,b+4|0,ea(g[c+4>>2]));Kcf(a,b+8|0,ea(g[c+8>>2]));Kcf(a,b+12|0,ea(g[c+12>>2]));i=d;return}function _cf(a,b,d){a=a|0;b=b|0;d=d|0;var e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;c[a>>2]=0;e=ea(g[b>>2]);f=ea(g[d>>2]);h=ea(g[b+16>>2]);i=ea(g[d+4>>2]);j=ea(g[b+32>>2]);k=ea(g[d+8>>2]);l=ea(ea(g[b+48>>2])+ea(ea(ea(e*f)+ea(h*i))+ea(j*k)));j=ea(g[b+4>>2]);h=ea(g[b+20>>2]);e=ea(g[b+36>>2]);m=ea(ea(g[b+52>>2])+ea(ea(ea(j*f)+ea(h*i))+ea(e*k)));e=ea(g[b+8>>2]);h=ea(g[b+24>>2]);j=ea(g[b+40>>2]);n=ea(ea(g[b+56>>2])+ea(ea(ea(e*f)+ea(h*i))+ea(j*k)));j=ea(g[b+12>>2]);h=ea(g[b+28>>2]);e=ea(g[b+44>>2]);o=ea(ea(1.0)/ea(ea(g[b+60>>2])+ea(ea(ea(j*f)+ea(h*i))+ea(e*k))));g[a>>2]=ea(o*l);g[a+4>>2]=ea(o*m);g[a+8>>2]=ea(o*n);return}function $cf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im;e=a;c[e>>2]=0;c[e+4>>2]=0;f=ea(g[b>>2]);h=ea(g[d>>2]);i=ea(g[b+16>>2]);j=ea(g[d+4>>2]);k=ea(g[b+32>>2]);l=ea(g[d+8>>2]);g[a>>2]=ea(ea(g[b+48>>2])+ea(ea(ea(f*h)+ea(i*j))+ea(k*l)));k=ea(g[b+4>>2]);i=ea(g[b+20>>2]);f=ea(g[b+36>>2]);g[a+4>>2]=ea(ea(g[b+52>>2])+ea(ea(ea(k*h)+ea(i*j))+ea(f*l)));f=ea(g[b+8>>2]);i=ea(g[b+24>>2]);k=ea(g[b+40>>2]);g[a+8>>2]=ea(ea(g[b+56>>2])+ea(ea(ea(f*h)+ea(i*j))+ea(k*l)));return}function adf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im;e=a;c[e>>2]=0;c[e+4>>2]=0;f=ea(g[b>>2]);h=ea(g[d>>2]);i=ea(g[b+16>>2]);j=ea(g[d+4>>2]);k=ea(g[b+32>>2]);l=ea(g[d+8>>2]);g[a>>2]=ea(ea(ea(f*h)+ea(i*j))+ea(k*l));k=ea(g[b+4>>2]);i=ea(g[b+20>>2]);g[a+4>>2]=ea(ea(ea(k*h)+ea(i*j))+ea(ea(g[b+36>>2])*l));i=ea(g[b+8>>2]);k=ea(g[b+24>>2]);g[a+8>>2]=ea(ea(ea(i*h)+ea(k*j))+ea(ea(g[b+40>>2])*l));return}function bdf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;b=i;e=a+0|0;f=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));iuh(2422424,a);g[a>>2]=ea(g[d>>2]);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+20>>2]=ea(g[d+4>>2]);g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(g[d+8>>2]);g[a+56>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);i=b;return}function cdf(a,b){a=a|0;b=b|0;var d=0,e=0;b=i;d=a+0|0;e=d+64|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));iuh(2422424,a);d=a+0|0;e=d+64|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));i=b;return}function ddf(a,b){a=a|0;b=b|0;var d=0,e=0;b=i;d=a+0|0;e=d+64|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));iuh(2422424,a);g[a>>2]=ea(1.0);g[a+16>>2]=ea(0.0);g[a+32>>2]=ea(0.0);g[a+48>>2]=ea(0.0);g[a+4>>2]=ea(0.0);g[a+20>>2]=ea(1.0);g[a+36>>2]=ea(0.0);g[a+52>>2]=ea(0.0);g[a+8>>2]=ea(0.0);g[a+24>>2]=ea(0.0);g[a+40>>2]=ea(1.0);g[a+56>>2]=ea(0.0);g[a+12>>2]=ea(0.0);g[a+28>>2]=ea(0.0);g[a+44>>2]=ea(0.0);g[a+60>>2]=ea(1.0);i=b;return}function edf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+112|0;g=f+32|0;h=f+16|0;j=f;k=f+48|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];gdf(k,0,j,h,g);g=a+0|0;a=k+0|0;k=g+64|0;do{c[g>>2]=c[a>>2];g=g+4|0;a=a+4|0}while((g|0)<(k|0));i=f;return}function fdf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;gdf(a,0,c,d,e);i=b;return}function gdf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;g=c[605726]|0;if(!g){h=MK(2422912)|0;c[605726]=h;j=h}else j=g;Dn[j&511](a,d,e,f);i=b;return}function hdf(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;i=i+64|0;d=b+8|0;e=b+24|0;f=b+44|0;h=b+52|0;j=b+32|0;k=b+40|0;l=b+48|0;m=b+56|0;n=b+60|0;o=b+4|0;p=b+28|0;q=b+12|0;r=b;s=b+16|0;t=b+36|0;u=b+20|0;Pbh();RI(1086352)|0;v=$th(1086352,16)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;w=pL(2586184,d)|0;Qqh(v,w);d=v+16|0;c[d>>2]=w;g[e>>2]=ea(g[a+16>>2]);RI(2586184)|0;w=pL(2586184,e)|0;Qqh(v,w);c[d+(c[(c[v>>2]|0)+120>>2]|0)>>2]=w;g[f>>2]=ea(g[a+32>>2]);RI(2586184)|0;w=pL(2586184,f)|0;Qqh(v,w);c[d+(c[(c[v>>2]|0)+120>>2]<<1)>>2]=w;g[h>>2]=ea(g[a+48>>2]);RI(2586184)|0;w=pL(2586184,h)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*3|0)>>2]=w;g[j>>2]=ea(g[a+4>>2]);RI(2586184)|0;w=pL(2586184,j)|0;Qqh(v,w);c[d+(c[(c[v>>2]|0)+120>>2]<<2)>>2]=w;g[k>>2]=ea(g[a+20>>2]);RI(2586184)|0;w=pL(2586184,k)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*5|0)>>2]=w;g[l>>2]=ea(g[a+36>>2]);RI(2586184)|0;w=pL(2586184,l)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*6|0)>>2]=w;g[m>>2]=ea(g[a+52>>2]);RI(2586184)|0;w=pL(2586184,m)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*7|0)>>2]=w;g[n>>2]=ea(g[a+8>>2]);RI(2586184)|0;w=pL(2586184,n)|0;Qqh(v,w);c[d+(c[(c[v>>2]|0)+120>>2]<<3)>>2]=w;g[o>>2]=ea(g[a+24>>2]);RI(2586184)|0;w=pL(2586184,o)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*9|0)>>2]=w;g[p>>2]=ea(g[a+40>>2]);RI(2586184)|0;w=pL(2586184,p)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*10|0)>>2]=w;g[q>>2]=ea(g[a+56>>2]);RI(2586184)|0;w=pL(2586184,q)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*11|0)>>2]=w;g[r>>2]=ea(g[a+12>>2]);RI(2586184)|0;w=pL(2586184,r)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*12|0)>>2]=w;g[s>>2]=ea(g[a+28>>2]);RI(2586184)|0;w=pL(2586184,s)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*13|0)>>2]=w;g[t>>2]=ea(g[a+44>>2]);RI(2586184)|0;w=pL(2586184,t)|0;Qqh(v,w);c[d+((c[(c[v>>2]|0)+120>>2]|0)*14|0)>>2]=w;g[u>>2]=ea(g[a+60>>2]);RI(2586184)|0;a=pL(2586184,u)|0;Qqh(v,a);c[d+((c[(c[v>>2]|0)+120>>2]|0)*15|0)>>2]=a;a=w7e(0,c[880034]|0,v)|0;i=b;return a|0}function idf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Qbh();RI(1086352)|0;e=$th(1086352,16)|0;f=rxf(a,b)|0;Qqh(e,f);g=e+16|0;c[g>>2]=f;f=rxf(a+16|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]|0)>>2]=f;f=rxf(a+32|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]<<1)>>2]=f;f=rxf(a+48|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*3|0)>>2]=f;f=rxf(a+4|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]<<2)>>2]=f;f=rxf(a+20|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*5|0)>>2]=f;f=rxf(a+36|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*6|0)>>2]=f;f=rxf(a+52|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*7|0)>>2]=f;f=rxf(a+8|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]<<3)>>2]=f;f=rxf(a+24|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*9|0)>>2]=f;f=rxf(a+40|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*10|0)>>2]=f;f=rxf(a+56|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*11|0)>>2]=f;f=rxf(a+12|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*12|0)>>2]=f;f=rxf(a+28|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*13|0)>>2]=f;f=rxf(a+44|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*14|0)>>2]=f;f=rxf(a+60|0,b)|0;Qqh(e,f);c[g+((c[(c[e>>2]|0)+120>>2]|0)*15|0)>>2]=f;f=w7e(0,c[880098]|0,e)|0;i=d;return f|0}function jdf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=ea(d);e=ea(e);f=ea(f);g=ea(g);h=ea(h);j=ea(j);var k=0,l=0,m=0;b=i;k=c[605756]|0;if(!k){l=MK(2423032)|0;c[605756]=l;m=l}else m=k;Do[m&1](a,d,e,f,g,h,j);i=b;return}function kdf(a,b,d,e,f,g){a=a|0;b=b|0;d=ea(d);e=ea(e);f=ea(f);g=ea(g);var h=0,j=0,k=0;b=i;h=c[605788]|0;if(!h){j=MK(2423160)|0;c[605788]=j;k=j}else k=h;Zm[k&15](a,d,e,f,g);i=b;return}function ldf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=0,r=Im,s=0,t=Im,u=0,v=Im,w=0,x=Im,y=0,z=Im,A=0,B=Im,C=0,D=Im,E=0,F=Im,G=0,H=Im,I=0,J=Im,K=0,L=Im,M=0,N=Im,O=0,P=Im;b=i;f=a+0|0;h=f+64|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));iuh(2422424,a);j=ea(g[d>>2]);k=ea(g[e>>2]);l=ea(g[d+16>>2]);f=e+4|0;m=ea(g[f>>2]);n=ea(g[d+32>>2]);h=e+8|0;o=ea(g[h>>2]);p=ea(g[d+48>>2]);q=e+12|0;r=ea(g[q>>2]);g[a>>2]=ea(ea(ea(ea(j*k)+ea(l*m))+ea(n*o))+ea(p*r));s=e+16|0;t=ea(g[s>>2]);u=e+20|0;v=ea(g[u>>2]);w=e+24|0;x=ea(g[w>>2]);y=e+28|0;z=ea(g[y>>2]);g[a+16>>2]=ea(ea(ea(ea(j*t)+ea(l*v))+ea(n*x))+ea(p*z));A=e+32|0;B=ea(g[A>>2]);C=e+36|0;D=ea(g[C>>2]);E=e+40|0;F=ea(g[E>>2]);G=e+44|0;H=ea(g[G>>2]);g[a+32>>2]=ea(ea(ea(ea(j*B)+ea(l*D))+ea(n*F))+ea(p*H));I=e+48|0;J=ea(g[I>>2]);K=e+52|0;L=ea(g[K>>2]);M=e+56|0;N=ea(g[M>>2]);O=e+60|0;P=ea(g[O>>2]);g[a+48>>2]=ea(ea(ea(ea(j*J)+ea(l*L))+ea(n*N))+ea(p*P));p=ea(g[d+4>>2]);n=ea(g[d+20>>2]);l=ea(g[d+36>>2]);j=ea(g[d+52>>2]);g[a+4>>2]=ea(ea(ea(ea(p*k)+ea(n*m))+ea(l*o))+ea(j*r));g[a+20>>2]=ea(ea(ea(ea(p*t)+ea(n*v))+ea(l*x))+ea(j*z));g[a+36>>2]=ea(ea(ea(ea(p*B)+ea(n*D))+ea(l*F))+ea(j*H));g[a+52>>2]=ea(ea(ea(ea(p*J)+ea(n*L))+ea(l*N))+ea(j*P));P=ea(g[d+8>>2]);j=ea(g[e>>2]);N=ea(g[d+24>>2]);l=ea(g[f>>2]);L=ea(g[d+40>>2]);n=ea(g[h>>2]);J=ea(g[d+56>>2]);p=ea(g[q>>2]);g[a+8>>2]=ea(ea(ea(ea(P*j)+ea(N*l))+ea(L*n))+ea(J*p));H=ea(g[s>>2]);F=ea(g[u>>2]);D=ea(g[w>>2]);B=ea(g[y>>2]);g[a+24>>2]=ea(ea(ea(ea(P*H)+ea(N*F))+ea(L*D))+ea(J*B));z=ea(g[A>>2]);x=ea(g[C>>2]);v=ea(g[E>>2]);t=ea(g[G>>2]);g[a+40>>2]=ea(ea(ea(ea(P*z)+ea(N*x))+ea(L*v))+ea(J*t));r=ea(g[I>>2]);o=ea(g[K>>2]);m=ea(g[M>>2]);k=ea(g[O>>2]);g[a+56>>2]=ea(ea(ea(ea(P*r)+ea(N*o))+ea(L*m))+ea(J*k));J=ea(g[d+12>>2]);L=ea(g[d+28>>2]);N=ea(g[d+44>>2]);P=ea(g[d+60>>2]);g[a+12>>2]=ea(ea(ea(ea(J*j)+ea(L*l))+ea(N*n))+ea(P*p));g[a+28>>2]=ea(ea(ea(ea(J*H)+ea(L*F))+ea(N*D))+ea(P*B));g[a+44>>2]=ea(ea(ea(ea(J*z)+ea(L*x))+ea(N*v))+ea(P*t));g[a+60>>2]=ea(ea(ea(ea(J*r)+ea(L*o))+ea(N*m))+ea(P*k));i=b;return}function mdf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;f=ea(g[d>>2]);h=ea(g[e>>2]);i=ea(g[d+16>>2]);j=ea(g[e+4>>2]);k=ea(g[d+32>>2]);l=ea(g[e+8>>2]);m=ea(g[d+48>>2]);n=ea(g[e+12>>2]);g[a>>2]=ea(ea(ea(ea(f*h)+ea(i*j))+ea(k*l))+ea(m*n));m=ea(g[d+4>>2]);k=ea(g[d+20>>2]);i=ea(g[d+36>>2]);g[a+4>>2]=ea(ea(ea(ea(m*h)+ea(k*j))+ea(i*l))+ea(ea(g[d+52>>2])*n));i=ea(g[d+8>>2]);k=ea(g[d+24>>2]);m=ea(g[d+40>>2]);g[a+8>>2]=ea(ea(ea(ea(i*h)+ea(k*j))+ea(m*l))+ea(ea(g[d+56>>2])*n));m=ea(g[d+12>>2]);k=ea(g[d+28>>2]);i=ea(g[d+44>>2]);g[a+12>>2]=ea(ea(ea(ea(m*h)+ea(k*j))+ea(i*l))+ea(ea(g[d+60>>2])*n));return}function ndf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im,t=Im,u=Im,v=0;a=i;i=i+128|0;d=a+16|0;e=a+64|0;f=a+32|0;h=a+80|0;j=a+112|0;k=a;l=a+48|0;m=a+96|0;Mcf(d,b,0);Mcf(e,c,0);n=ea(g[d>>2]);o=ea(g[d+4>>2]);p=ea(g[d+8>>2]);q=ea(g[d+12>>2]);r=ea(g[e>>2]);s=ea(g[e+4>>2]);t=ea(g[e+8>>2]);u=ea(n-r);r=ea(o-s);s=ea(p-t);t=ea(q-ea(g[e+12>>2]));if(!(ea(ea(ea(ea(u*u)+ea(r*r))+ea(s*s))+ea(t*t))<ea(9.99999943e-11))){v=0;i=a;return v|0}Mcf(f,b,1);Mcf(h,c,1);t=ea(g[f>>2]);s=ea(g[f+4>>2]);r=ea(g[f+8>>2]);u=ea(g[f+12>>2]);q=ea(g[h>>2]);p=ea(g[h+4>>2]);o=ea(g[h+8>>2]);n=ea(t-q);q=ea(s-p);p=ea(r-o);o=ea(u-ea(g[h+12>>2]));if(!(ea(ea(ea(ea(n*n)+ea(q*q))+ea(p*p))+ea(o*o))<ea(9.99999943e-11))){v=0;i=a;return v|0}Mcf(j,b,2);Mcf(k,c,2);o=ea(g[j>>2]);p=ea(g[j+4>>2]);q=ea(g[j+8>>2]);n=ea(g[j+12>>2]);u=ea(g[k>>2]);r=ea(g[k+4>>2]);s=ea(g[k+8>>2]);t=ea(o-u);u=ea(p-r);r=ea(q-s);s=ea(n-ea(g[k+12>>2]));if(!(ea(ea(ea(ea(t*t)+ea(u*u))+ea(r*r))+ea(s*s))<ea(9.99999943e-11))){v=0;i=a;return v|0}Mcf(l,b,3);Mcf(m,c,3);s=ea(g[l>>2]);r=ea(g[l+4>>2]);u=ea(g[l+8>>2]);t=ea(g[l+12>>2]);n=ea(g[m>>2]);q=ea(g[m+4>>2]);p=ea(g[m+8>>2]);o=ea(s-n);n=ea(r-q);q=ea(u-p);p=ea(t-ea(g[m+12>>2]));v=ea(ea(ea(ea(o*o)+ea(n*n))+ea(q*q))+ea(p*p))<ea(9.99999943e-11);i=a;return v|0}function odf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+128|0;e=a+64|0;f=a;g=f+0|0;h=b+0|0;b=g+64|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(b|0));g=e+0|0;h=d+0|0;b=g+64|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(b|0));h=(ndf(0,f,e)|0)^1;i=a;return h|0}function pdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function qdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function rdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function sdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function tdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function udf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function vdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function wdf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function xdf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im;e=i;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];f=ea(g[d>>2]);h=ea(g[d+4>>2]);j=ea(f*ea(.5));f=ea(h*ea(.5));h=ea(ea(g[d+8>>2])*ea(.5));k=ea(j);j=ea(f);d=a+12|0;g[d>>2]=k;g[d+4>>2]=j;g[a+20>>2]=h;i=e;return}function ydf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+12|0;e=b;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];f=Qbf(d)|0;d=a+12|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];d=(Qbf(e)|0)<<2^f;i=b;return d|0}function zdf(a,b){a=a|0;b=b|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];return}function Adf(a,b){a=a|0;b=b|0;var d=0;d=b+12|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];return}function Bdf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+80|0;e=d+48|0;f=d+36|0;g=d+24|0;h=d+12|0;j=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;RI(2427248)|0;if(!(vL(b,2427248)|0)){k=0;i=d;return k|0}RI(2427248)|0;l=Zth(b,2427248)|0;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];c[e+16>>2]=c[l+16>>2];c[e+20>>2]=c[l+20>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];RI(2416264)|0;if(!(Rbf(f,pL(2416264,h)|0)|0)){k=0;i=d;return k|0}h=a+12|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];h=e+12|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];RI(2416264)|0;k=Rbf(g,pL(2416264,j)|0)|0;i=d;return k|0}function Cdf(a,b){a=a|0;b=b|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];return}function Ddf(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=Im;d=ea(g[b+12>>2]);e=ea(g[b+16>>2]);f=ea(g[b+20>>2]);b=a;c[b>>2]=0;c[b+4>>2]=0;h=ea(e*ea(2.0));e=ea(f*ea(2.0));g[a>>2]=ea(d*ea(2.0));g[a+4>>2]=h;g[a+8>>2]=e;return}function Edf(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=Im,h=Im;c=i;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(d*ea(.5));d=ea(e*ea(.5));e=ea(ea(g[b+8>>2])*ea(.5));h=ea(f);f=ea(d);b=a+12|0;g[b>>2]=h;g[b+4>>2]=f;g[a+20>>2]=e;i=c;return}function Fdf(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];return}function Gdf(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[b+12>>2]);i=ea(g[b+16>>2]);j=ea(g[b+20>>2]);b=a;c[b>>2]=0;c[b+4>>2]=0;k=ea(e-i);i=ea(f-j);g[a>>2]=ea(d-h);g[a+4>>2]=k;g[a+8>>2]=i;return}function Hdf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+48|0;e=d+24|0;f=d+12|0;g=d;Idf(g,a);c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];Jdf(a,f,e);i=d;return}function Idf(a,b){a=a|0;b=b|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[b+12>>2]);i=ea(g[b+16>>2]);j=ea(g[b+20>>2]);b=a;c[b>>2]=0;c[b+4>>2]=0;k=ea(e+i);i=ea(f+j);g[a>>2]=ea(d+h);g[a+4>>2]=k;g[a+8>>2]=i;return}function Jdf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=Im,f=Im,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im;d=i;e=ea(g[c>>2]);f=ea(g[c+4>>2]);h=ea(g[c+8>>2]);j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(g[b+8>>2]);m=ea(ea(e-j)*ea(.5));e=ea(ea(f-k)*ea(.5));f=ea(ea(h-l)*ea(.5));h=ea(m);n=ea(e);b=a+12|0;g[b>>2]=h;g[b+4>>2]=n;g[a+20>>2]=f;n=ea(m+j);j=ea(e+k);k=ea(f+l);l=ea(n);n=ea(j);b=a;g[b>>2]=l;g[b+4>>2]=n;g[a+8>>2]=k;i=d;return}function Kdf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+48|0;e=d+24|0;f=d+12|0;g=d;Gdf(g,a);c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];Jdf(a,f,e);i=d;return}function Ldf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+80|0;e=d+60|0;f=d+48|0;g=d+36|0;h=d+24|0;j=d+12|0;k=d;Gdf(g,a);c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];Vbf(j,0,f,e);Idf(h,a);c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];Wbf(k,0,f,e);c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];Jdf(a,f,e);i=d;return}function Mdf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im,p=Im,q=Im,r=Im,s=Im;d=i;i=i+48|0;e=d+28|0;f=d+16|0;h=d;j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(g[b+8>>2]);m=ea(g[b+12>>2]);n=ea(g[b+16>>2]);o=ea(g[b+20>>2]);p=ea(j-m);q=ea(k-n);r=ea(l-o);s=ea(p);p=ea(q);b=f;g[b>>2]=s;g[b+4>>2]=p;g[f+8>>2]=r;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];Ldf(a,e);r=ea(j+m);m=ea(k+n);n=ea(l+o);o=ea(r);r=ea(m);f=h;g[f>>2]=o;g[f+4>>2]=r;g[h+8>>2]=n;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];Ldf(a,e);i=d;return}function Ndf(a,b){a=a|0;b=ea(b);var c=0,d=Im,e=Im,f=0,h=Im,j=0;c=i;d=ea(b*ea(.5));b=ea(g[a+12>>2]);e=ea(g[a+16>>2]);f=a+20|0;h=ea(d+b);b=ea(d+e);e=ea(d+ea(g[f>>2]));d=ea(h);h=ea(b);j=a+12|0;g[j>>2]=d;g[j+4>>2]=h;g[f>>2]=e;i=c;return}function Odf(a,b){a=a|0;b=b|0;var c=0,d=Im,e=Im,f=0,h=Im,j=Im,k=Im,l=Im;c=i;d=ea(g[a+12>>2]);e=ea(g[a+16>>2]);f=a+20|0;h=ea(g[f>>2]);j=ea(g[b>>2]);k=ea(g[b+4>>2]);l=ea(d+ea(j*ea(.5)));j=ea(e+ea(k*ea(.5)));k=ea(h+ea(ea(g[b+8>>2])*ea(.5)));h=ea(l);l=ea(j);b=a+12|0;g[b>>2]=h;g[b+4>>2]=l;g[f>>2]=k;i=c;return}function Pdf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=Im,s=0;c=i;i=i+144|0;d=c+12|0;e=c+48|0;f=c+108|0;h=c;j=c+96|0;k=c+120|0;l=c+132|0;m=c+72|0;n=c+60|0;o=c+24|0;p=c+36|0;q=c+84|0;Gdf(d,a);r=ea(g[d>>2]);Idf(e,b);if(r>ea(g[e>>2])){s=0;i=c;return s|0}Idf(f,a);r=ea(g[f>>2]);Gdf(h,b);if(r<ea(g[h>>2])){s=0;i=c;return s|0}Gdf(j,a);r=ea(g[j+4>>2]);Idf(k,b);if(r>ea(g[k+4>>2])){s=0;i=c;return s|0}Idf(l,a);r=ea(g[l+4>>2]);Gdf(m,b);if(r<ea(g[m+4>>2])){s=0;i=c;return s|0}Gdf(n,a);r=ea(g[n+8>>2]);Idf(o,b);if(r>ea(g[o+8>>2])){s=0;i=c;return s|0}Idf(p,a);r=ea(g[p+8>>2]);Gdf(q,b);s=!(r<ea(g[q+8>>2]));i=c;return s|0}function Qdf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Rdf(0,b,c)|0;i=a;return d|0}function Rdf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[606854]|0;if(!e){f=MK(2427424)|0;c[606854]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Sdf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+48|0;e=d+24|0;f=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];a=Rdf(0,f,e)|0;i=d;return a|0}function Tdf(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im;a=i;d=ea(Udf(0,b,c));i=a;return ea(d)}function Udf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=Im;a=i;e=c[606880]|0;if(!e){f=MK(2427528)|0;c[606880]=f;g=f}else g=e;h=ea(Um[g&63](b,d));i=a;return ea(h)}function Vdf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=Im;d=i;i=i+48|0;e=d+24|0;f=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];g=ea(Udf(0,f,e));i=d;return ea(g)}function Wdf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=i;e=Xdf(0,b,c,d)|0;i=a;return e|0}function Xdf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[606908]|0;if(!f){g=MK(2427640)|0;c[606908]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function Ydf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c;g[d>>2]=ea(0.0);e=Xdf(0,b,a,d)|0;i=c;return e|0}function Zdf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Xdf(0,b,a,c)|0;i=d;return e|0}function _df(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=i;$df(a,0,c,d);i=b;return}function $df(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[606938]|0;if(!f){g=MK(2427760)|0;c[606938]=g;h=g}else h=f;co[h&2047](a,d,e);i=b;return}function aef(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$df(a,0,b,c);i=d;return}function bef(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+12|0;e=b;Rbh();RI(1086352)|0;f=$th(1086352,2)|0;c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];RI(2416264)|0;g=pL(2416264,d)|0;Qqh(f,g);d=f+16|0;c[d>>2]=g;g=a+12|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];RI(2416264)|0;g=pL(2416264,e)|0;Qqh(f,g);c[d+(c[(c[f>>2]|0)+120>>2]|0)>>2]=g;g=w7e(0,c[880138]|0,f)|0;i=b;return g|0}function cef(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Sbh();RI(1086352)|0;e=$th(1086352,2)|0;f=Tbf(a,b)|0;Qqh(e,f);g=e+16|0;c[g>>2]=f;f=Tbf(a+12|0,b)|0;Qqh(e,f);c[g+(c[(c[e>>2]|0)+120>>2]|0)>>2]=f;f=w7e(0,c[880156]|0,e)|0;i=d;return f|0}function def(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=0;a=i;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[c>>2]);j=ea(g[c+4>>2]);k=ea(d-h);h=ea(e-j);j=ea(f-ea(g[c+8>>2]));if(!(ea(ea(ea(k*k)+ea(h*h))+ea(j*j))<ea(9.99999943e-11))){l=0;i=a;return l|0}j=ea(g[b+12>>2]);h=ea(g[b+16>>2]);k=ea(g[b+20>>2]);f=ea(g[c+12>>2]);e=ea(g[c+16>>2]);d=ea(j-f);f=ea(h-e);e=ea(k-ea(g[c+20>>2]));l=ea(ea(ea(d*d)+ea(f*f))+ea(e*e))<ea(9.99999943e-11);i=a;return l|0}function eef(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,j=Im,k=Im,l=0;a=i;d=ea(g[b>>2]);e=ea(g[b+4>>2]);f=ea(g[b+8>>2]);h=ea(g[c>>2]);j=ea(g[c+4>>2]);k=ea(d-h);h=ea(e-j);j=ea(f-ea(g[c+8>>2]));if(!(ea(ea(ea(k*k)+ea(h*h))+ea(j*j))<ea(9.99999943e-11))){l=1;i=a;return l|0}j=ea(g[c+20>>2]);h=ea(g[c+16>>2]);k=ea(g[c+12>>2]);f=ea(g[b+20>>2]);e=ea(g[b+16>>2]);d=ea(ea(g[b+12>>2])-k);k=ea(e-h);h=ea(f-j);l=!(ea(ea(h*h)+ea(ea(k*k)+ea(d*d)))<ea(9.99999943e-11));i=a;return l|0}function fef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function gef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function hef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function ief(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function jef(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;h=b;Tbh();RI(1086352)|0;j=$th(1086352,4)|0;g[d>>2]=ea(g[a>>2]);RI(2586184)|0;k=pL(2586184,d)|0;Qqh(j,k);d=j+16|0;c[d>>2]=k;g[e>>2]=ea(g[a+4>>2]);RI(2586184)|0;k=pL(2586184,e)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]|0)>>2]=k;g[f>>2]=ea(g[a+8>>2]);RI(2586184)|0;k=pL(2586184,f)|0;Qqh(j,k);c[d+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=k;g[h>>2]=ea(g[a+12>>2]);RI(2586184)|0;a=pL(2586184,h)|0;Qqh(j,a);c[d+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=a;a=w7e(0,c[880160]|0,j)|0;i=b;return a|0}function kef(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=Im,h=Im,i=Im,j=Im,k=Im,l=Im;d=ea(g[b>>2]);e=ea(g[c>>2]);f=ea(g[b+4>>2]);h=ea(g[c+4>>2]);i=ea(g[b+8>>2]);j=ea(g[c+8>>2]);k=ea(g[b+12>>2]);l=ea(ea(ea(ea(d*e)+ea(f*h))+ea(i*j))+ea(k*ea(g[c+12>>2])));return ea(l)}function lef(a,b){a=a|0;b=b|0;var c=Im,d=Im,e=Im,f=Im,h=Im;c=ea(g[b>>2]);d=ea(g[b+4>>2]);e=ea(g[b+8>>2]);f=ea(g[b+12>>2]);h=ea(ea(ea(ea(c*c)+ea(d*d))+ea(e*e))+ea(f*f));return ea(h)}function mef(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=Im,h=Im,i=Im,j=Im,k=Im,l=Im,m=Im,n=Im,o=Im;f=ea(g[d>>2]);h=ea(g[e>>2]);i=ea(g[d+4>>2]);j=ea(g[e+4>>2]);k=ea(g[d+8>>2]);l=ea(g[e+8>>2]);m=ea(g[d+12>>2]);n=ea(g[e+12>>2]);c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;o=ea(i-j);j=ea(k-l);l=ea(m-n);g[a>>2]=ea(f-h);g[a+4>>2]=o;g[a+8>>2]=j;g[a+12>>2]=l;return}function nef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function oef(a,b){a=a|0;b=b|0;var d=0;d=b+12|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];return}function pef(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+12|0;e=b;Ubh();RI(1086352)|0;f=$th(1086352,2)|0;c[d+0>>2]=c[a+0>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];RI(2416264)|0;g=pL(2416264,d)|0;Qqh(f,g);d=f+16|0;c[d>>2]=g;g=a+12|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];RI(2416264)|0;g=pL(2416264,e)|0;Qqh(f,g);c[d+(c[(c[f>>2]|0)+120>>2]|0)>>2]=g;g=w7e(0,c[880164]|0,f)|0;i=b;return g|0}function qef(b){b=b|0;var d=0;b=i;RI(2432600)|0;g[c[608173]>>2]=ea(1.17549435e-38);RI(2432600)|0;g[(c[608173]|0)+4>>2]=ea(1.40129846e-45);RI(2432600)|0;d=ea(g[(c[608173]|0)+4>>2])==ea(0.0);RI(2432600)|0;a[(c[608173]|0)+8>>0]=d&1;i=b;return}function ref(b){b=b|0;var d=0,e=0,f=0,h=Im,j=0;b=i;RI(2432600)|0;if(!(a[2432748]|0)){RI(2432600)|0;_th(2432600)}RI(2432600)|0;d=(a[(c[608173]|0)+8>>0]|0)==0;RI(2432600)|0;e=(a[2432748]|0)!=0;if(d){if(!e){RI(2432600)|0;_th(2432600)}RI(2432600)|0;f=(c[608173]|0)+4|0;h=ea(g[f>>2]);RI(2369112)|0;j=c[592301]|0;g[j>>2]=h;i=b;return}else{if(!e){RI(2432600)|0;_th(2432600)}RI(2432600)|0;f=c[608173]|0;h=ea(g[f>>2]);RI(2369112)|0;j=c[592301]|0;g[j>>2]=h;i=b;return}}function sef(a,b){a=a|0;b=ea(b);var c=Im;c=ea(S(ea(b)));return ea(c)}function tef(a,b){a=a|0;b=ea(b);var c=Im;a=i;c=ea(eEi(b));i=a;return ea(c)}function uef(b,d,e){b=b|0;d=ea(d);e=ea(e);var f=Im,h=Im;b=i;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;_th(2369112)}f=ea(S(ea(e-d)));h=ea(S(ea(d)));d=ea(S(ea(e)));e=ea((!(h<=d)?h:d)*ea(9.99999997e-07));RI(2369112)|0;d=ea(ea(g[c[592301]>>2])*ea(8.0));i=b;return f<(!(e<=d)?e:d)|0}function vef(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function wef(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)wef(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function xef(a,b){a=a|0;b=b|0;Yth(SJ(2434040)|0)}function yef(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function zef(a,b){a=a|0;b=b|0;return}function Aef(a,b){a=a|0;b=b|0;a=i;RI(2434632)|0;if(!(c[c[608681]>>2]|0)){i=a;return}RI(2434632)|0;juh(2434360,c[c[608681]>>2]|0,b);i=a;return}function Bef(a){a=a|0;return}function Cef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2435512)|0);c[c[d>>2]>>2]=a;i=b;return}function Def(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[609048]|0;if(!d){e=MK(2436200)|0;c[609048]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Eef(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[609060]|0;if(!d){e=MK(2436248)|0;c[609060]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Fef(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[609072]|0;if(!d){e=MK(2436296)|0;c[609072]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Gef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Hef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Ief(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Jef(a,b){a=a|0;b=b|0;var c=0;c=i;Kef(0,a,b);i=c;return}function Kef(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[609278]|0;if(!e){f=MK(2437120)|0;c[609278]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function Lef(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=Fef(0,b)|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];Nef(0,a,g,f);i=e;return}function Mef(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Nef(0,a,b,c);i=d;return}function Nef(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[609212]|0;if(!f){g=MK(2436856)|0;c[609212]=g;h=g}else h=f;co[h&2047](b,d,e);i=a;return}function Oef(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im,k=Im,l=Im,m=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=ea(g[d>>2]);k=ea(g[d+4>>2]);l=ea(g[d+8>>2]);m=ea(g[d+12>>2]);g[h>>2]=j;g[h+4>>2]=k;g[h+8>>2]=l;g[h+12>>2]=m;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];Lef(a,b,f);i=e;return}function Pef(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Qef(a,Fef(0,b)|0,c);i=d;return}function Qef(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[609240]|0;if(!f){g=MK(2436968)|0;c[609240]=g;h=g}else h=f;co[h&2047](a,b,d);i=e;return}function Ref(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;Sef(a,Fef(0,b)|0,c);i=d;return}function Sef(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0,h=0;e=i;f=c[609260]|0;if(!f){g=MK(2437048)|0;c[609260]=g;h=g}else h=f;go[h&63](a,b,d);i=e;return}function Tef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Uef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Vef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Wef(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Xef(a){a=a|0;var b=0;b=i;Zef(0,a);i=b;return}function Yef(a,b){a=a|0;b=b|0;a=i;Zef(0,b);i=a;return}function Zef(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[609616]|0;if(!d){e=MK(2438472)|0;c[609616]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function _ef(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];aff(0,e,a);i=d;return}function $ef(a,b,c){a=a|0;b=b|0;c=c|0;a=i;aff(0,b,c);i=a;return}function aff(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[609648]|0;if(!e){f=MK(2438600)|0;c[609648]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function bff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=Im,l=Im,m=Im,n=Im;f=i;i=i+32|0;h=f+16|0;j=f;k=ea(g[d>>2]);l=ea(g[d+4>>2]);m=ea(g[d+8>>2]);n=ea(e*ea(2.0));e=ea(n*l);l=ea(n*m);m=ea(n*ea(g[d+12>>2]));g[h>>2]=ea(n*k);g[h+4>>2]=e;g[h+8>>2]=l;g[h+12>>2]=m;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];dff(0,j,h,a);i=f;return}function cff(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;dff(0,b,c,d);i=a;return}function dff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[609688]|0;if(!f){g=MK(2438760)|0;c[609688]=g;h=g}else h=f;co[h&2047](b,d,e);i=a;return}function eff(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=Im;e=i;Vbh();do switch((b*9|0)+d|0){case 5:{f=a+20|0;break}case 24:{f=a+96|0;break}case 4:{f=a+16|0;break}case 13:{f=a+52|0;break}case 12:{f=a+48|0;break}case 19:{f=a+76|0;break}case 16:{f=a+64|0;break}case 3:{f=a+12|0;break}case 6:{f=a+24|0;break}case 11:{f=a+44|0;break}case 7:{f=a+28|0;break}case 14:{f=a+56|0;break}case 15:{f=a+60|0;break}case 20:{f=a+80|0;break}case 23:{f=a+92|0;break}case 10:{f=a+40|0;break}case 8:{f=a+32|0;break}case 25:{f=a+100|0;break}case 2:{f=a+8|0;break}case 1:{f=a+4|0;break}case 17:{f=a+68|0;break}case 18:{f=a+72|0;break}case 0:{f=a;break}case 22:{f=a+88|0;break}case 21:{f=a+84|0;break}case 9:{f=a+36|0;break}case 26:{f=a+104|0;break}default:{RI(3084024)|0;h=qL(3084024)|0;isg(h,c[880180]|0);Yth(h)}}while(0);j=ea(g[f>>2]);i=e;return ea(j)}function fff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0;f=i;Wbh();do switch((b*9|0)+d|0){case 1:{g[a+4>>2]=e;break}case 2:{g[a+8>>2]=e;break}case 25:{g[a+100>>2]=e;break}case 12:{g[a+48>>2]=e;break}case 13:{g[a+52>>2]=e;break}case 18:{g[a+72>>2]=e;break}case 9:{g[a+36>>2]=e;break}case 3:{g[a+12>>2]=e;break}case 0:{g[a>>2]=e;break}case 7:{g[a+28>>2]=e;break}case 14:{g[a+56>>2]=e;break}case 11:{g[a+44>>2]=e;break}case 10:{g[a+40>>2]=e;break}case 17:{g[a+68>>2]=e;break}case 15:{g[a+60>>2]=e;break}case 8:{g[a+32>>2]=e;break}case 26:{g[a+104>>2]=e;break}case 4:{g[a+16>>2]=e;break}case 5:{g[a+20>>2]=e;break}case 24:{g[a+96>>2]=e;break}case 20:{g[a+80>>2]=e;break}case 19:{g[a+76>>2]=e;break}case 6:{g[a+24>>2]=e;break}case 22:{g[a+88>>2]=e;break}case 21:{g[a+84>>2]=e;break}case 16:{g[a+64>>2]=e;break}case 23:{g[a+92>>2]=e;break}default:{RI(3084024)|0;h=qL(3084024)|0;isg(h,c[880192]|0);Yth(h)}}while(0);i=f;return}function gff(a){a=a|0;var b=0,c=0,d=0;b=i;c=kxf(a)|0;d=(c*23|0)+8993+(kxf(a+4|0)|0)|0;c=(d*23|0)+(kxf(a+8|0)|0)|0;d=(c*23|0)+(kxf(a+12|0)|0)|0;c=(d*23|0)+(kxf(a+16|0)|0)|0;d=(c*23|0)+(kxf(a+20|0)|0)|0;c=(d*23|0)+(kxf(a+24|0)|0)|0;d=(c*23|0)+(kxf(a+28|0)|0)|0;c=(d*23|0)+(kxf(a+32|0)|0)|0;d=(c*23|0)+(kxf(a+36|0)|0)|0;c=(d*23|0)+(kxf(a+40|0)|0)|0;d=(c*23|0)+(kxf(a+44|0)|0)|0;c=(d*23|0)+(kxf(a+48|0)|0)|0;d=(c*23|0)+(kxf(a+52|0)|0)|0;c=(d*23|0)+(kxf(a+56|0)|0)|0;d=(c*23|0)+(kxf(a+60|0)|0)|0;c=(d*23|0)+(kxf(a+64|0)|0)|0;d=(c*23|0)+(kxf(a+68|0)|0)|0;c=(d*23|0)+(kxf(a+72|0)|0)|0;d=(c*23|0)+(kxf(a+76|0)|0)|0;c=(d*23|0)+(kxf(a+80|0)|0)|0;d=(c*23|0)+(kxf(a+84|0)|0)|0;c=(d*23|0)+(kxf(a+88|0)|0)|0;d=(c*23|0)+(kxf(a+92|0)|0)|0;c=(d*23|0)+(kxf(a+96|0)|0)|0;d=(c*23|0)+(kxf(a+100|0)|0)|0;c=(d*23|0)+(kxf(a+104|0)|0)|0;i=b;return c|0}function hff(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+336|0;e=d+216|0;f=d+108|0;g=d;h=g+0|0;j=h+108|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(j|0));RI(2438936)|0;if(!(vL(b,2438936)|0)){k=0;i=d;return k|0}RI(2438936)|0;h=g+0|0;l=(Zth(b,2438936)|0)+0|0;j=h+108|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(j|0));h=f+0|0;l=a+0|0;j=h+108|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(j|0));h=e+0|0;l=g+0|0;j=h+108|0;do{c[h>>2]=c[l>>2];h=h+4|0;l=l+4|0}while((h|0)<(j|0));k=iff(0,f,e)|0;i=d;return k|0}function iff(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im,e=Im,f=0;a=i;d=ea(g[b>>2]);do if((((((((((((((((((!(d!=ea(g[c>>2]))?(e=ea(g[b+4>>2]),!(e!=ea(g[c+4>>2]))):0)?(e=ea(g[b+8>>2]),!(e!=ea(g[c+8>>2]))):0)?(e=ea(g[b+12>>2]),!(e!=ea(g[c+12>>2]))):0)?(e=ea(g[b+16>>2]),!(e!=ea(g[c+16>>2]))):0)?(e=ea(g[b+20>>2]),!(e!=ea(g[c+20>>2]))):0)?(e=ea(g[b+24>>2]),!(e!=ea(g[c+24>>2]))):0)?(e=ea(g[b+28>>2]),!(e!=ea(g[c+28>>2]))):0)?(e=ea(g[b+32>>2]),!(e!=ea(g[c+32>>2]))):0)?(e=ea(g[b+36>>2]),!(e!=ea(g[c+36>>2]))):0)?(e=ea(g[b+40>>2]),!(e!=ea(g[c+40>>2]))):0)?(e=ea(g[b+44>>2]),!(e!=ea(g[c+44>>2]))):0)?(e=ea(g[b+48>>2]),!(e!=ea(g[c+48>>2]))):0)?(e=ea(g[b+52>>2]),!(e!=ea(g[c+52>>2]))):0)?(e=ea(g[b+56>>2]),!(e!=ea(g[c+56>>2]))):0)?(e=ea(g[b+60>>2]),!(e!=ea(g[c+60>>2]))):0)?(e=ea(g[b+64>>2]),!(e!=ea(g[c+64>>2]))):0)?(e=ea(g[b+68>>2]),!(e!=ea(g[c+68>>2]))):0)?(e=ea(g[b+72>>2]),!(e!=ea(g[c+72>>2]))):0){e=ea(g[b+76>>2]);if(e!=ea(g[c+76>>2])){f=0;break}e=ea(g[b+80>>2]);if(e!=ea(g[c+80>>2])){f=0;break}e=ea(g[b+84>>2]);if(e!=ea(g[c+84>>2])){f=0;break}e=ea(g[b+88>>2]);if(e!=ea(g[c+88>>2])){f=0;break}e=ea(g[b+92>>2]);if(e!=ea(g[c+92>>2])){f=0;break}e=ea(g[b+96>>2]);if(e!=ea(g[c+96>>2])){f=0;break}e=ea(g[b+100>>2]);if(e!=ea(g[c+100>>2])){f=0;break}e=ea(g[b+104>>2]);f=e==ea(g[c+104>>2])}else f=0;while(0);i=a;return f|0}function jff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=ea(e);var f=0,h=0;b=i;f=a+0|0;h=f+108|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));iuh(2438936,a);g[a>>2]=ea(ea(g[d>>2])*e);g[a+4>>2]=ea(ea(g[d+4>>2])*e);g[a+8>>2]=ea(ea(g[d+8>>2])*e);g[a+12>>2]=ea(ea(g[d+12>>2])*e);g[a+16>>2]=ea(ea(g[d+16>>2])*e);g[a+20>>2]=ea(ea(g[d+20>>2])*e);g[a+24>>2]=ea(ea(g[d+24>>2])*e);g[a+28>>2]=ea(ea(g[d+28>>2])*e);g[a+32>>2]=ea(ea(g[d+32>>2])*e);g[a+36>>2]=ea(ea(g[d+36>>2])*e);g[a+40>>2]=ea(ea(g[d+40>>2])*e);g[a+44>>2]=ea(ea(g[d+44>>2])*e);g[a+48>>2]=ea(ea(g[d+48>>2])*e);g[a+52>>2]=ea(ea(g[d+52>>2])*e);g[a+56>>2]=ea(ea(g[d+56>>2])*e);g[a+60>>2]=ea(ea(g[d+60>>2])*e);g[a+64>>2]=ea(ea(g[d+64>>2])*e);g[a+68>>2]=ea(ea(g[d+68>>2])*e);g[a+72>>2]=ea(ea(g[d+72>>2])*e);g[a+76>>2]=ea(ea(g[d+76>>2])*e);g[a+80>>2]=ea(ea(g[d+80>>2])*e);g[a+84>>2]=ea(ea(g[d+84>>2])*e);g[a+88>>2]=ea(ea(g[d+88>>2])*e);g[a+92>>2]=ea(ea(g[d+92>>2])*e);g[a+96>>2]=ea(ea(g[d+96>>2])*e);g[a+100>>2]=ea(ea(g[d+100>>2])*e);g[a+104>>2]=ea(ea(g[d+104>>2])*e);i=b;return}function kff(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0,h=0;b=i;f=a+0|0;h=f+108|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));iuh(2438936,a);g[a>>2]=ea(ea(g[e>>2])*d);g[a+4>>2]=ea(ea(g[e+4>>2])*d);g[a+8>>2]=ea(ea(g[e+8>>2])*d);g[a+12>>2]=ea(ea(g[e+12>>2])*d);g[a+16>>2]=ea(ea(g[e+16>>2])*d);g[a+20>>2]=ea(ea(g[e+20>>2])*d);g[a+24>>2]=ea(ea(g[e+24>>2])*d);g[a+28>>2]=ea(ea(g[e+28>>2])*d);g[a+32>>2]=ea(ea(g[e+32>>2])*d);g[a+36>>2]=ea(ea(g[e+36>>2])*d);g[a+40>>2]=ea(ea(g[e+40>>2])*d);g[a+44>>2]=ea(ea(g[e+44>>2])*d);g[a+48>>2]=ea(ea(g[e+48>>2])*d);g[a+52>>2]=ea(ea(g[e+52>>2])*d);g[a+56>>2]=ea(ea(g[e+56>>2])*d);g[a+60>>2]=ea(ea(g[e+60>>2])*d);g[a+64>>2]=ea(ea(g[e+64>>2])*d);g[a+68>>2]=ea(ea(g[e+68>>2])*d);g[a+72>>2]=ea(ea(g[e+72>>2])*d);g[a+76>>2]=ea(ea(g[e+76>>2])*d);g[a+80>>2]=ea(ea(g[e+80>>2])*d);g[a+84>>2]=ea(ea(g[e+84>>2])*d);g[a+88>>2]=ea(ea(g[e+88>>2])*d);g[a+92>>2]=ea(ea(g[e+92>>2])*d);g[a+96>>2]=ea(ea(g[e+96>>2])*d);g[a+100>>2]=ea(ea(g[e+100>>2])*d);g[a+104>>2]=ea(ea(g[e+104>>2])*d);i=b;return}function lff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im;b=i;f=a+0|0;h=f+108|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));iuh(2438936,a);j=ea(g[d>>2]);g[a>>2]=ea(j+ea(g[e>>2]));j=ea(g[d+4>>2]);g[a+4>>2]=ea(j+ea(g[e+4>>2]));j=ea(g[d+8>>2]);g[a+8>>2]=ea(j+ea(g[e+8>>2]));j=ea(g[d+12>>2]);g[a+12>>2]=ea(j+ea(g[e+12>>2]));j=ea(g[d+16>>2]);g[a+16>>2]=ea(j+ea(g[e+16>>2]));j=ea(g[d+20>>2]);g[a+20>>2]=ea(j+ea(g[e+20>>2]));j=ea(g[d+24>>2]);g[a+24>>2]=ea(j+ea(g[e+24>>2]));j=ea(g[d+28>>2]);g[a+28>>2]=ea(j+ea(g[e+28>>2]));j=ea(g[d+32>>2]);g[a+32>>2]=ea(j+ea(g[e+32>>2]));j=ea(g[d+36>>2]);g[a+36>>2]=ea(j+ea(g[e+36>>2]));j=ea(g[d+40>>2]);g[a+40>>2]=ea(j+ea(g[e+40>>2]));j=ea(g[d+44>>2]);g[a+44>>2]=ea(j+ea(g[e+44>>2]));j=ea(g[d+48>>2]);g[a+48>>2]=ea(j+ea(g[e+48>>2]));j=ea(g[d+52>>2]);g[a+52>>2]=ea(j+ea(g[e+52>>2]));j=ea(g[d+56>>2]);g[a+56>>2]=ea(j+ea(g[e+56>>2]));j=ea(g[d+60>>2]);g[a+60>>2]=ea(j+ea(g[e+60>>2]));j=ea(g[d+64>>2]);g[a+64>>2]=ea(j+ea(g[e+64>>2]));j=ea(g[d+68>>2]);g[a+68>>2]=ea(j+ea(g[e+68>>2]));j=ea(g[d+72>>2]);g[a+72>>2]=ea(j+ea(g[e+72>>2]));j=ea(g[d+76>>2]);g[a+76>>2]=ea(j+ea(g[e+76>>2]));j=ea(g[d+80>>2]);g[a+80>>2]=ea(j+ea(g[e+80>>2]));j=ea(g[d+84>>2]);g[a+84>>2]=ea(j+ea(g[e+84>>2]));j=ea(g[d+88>>2]);g[a+88>>2]=ea(j+ea(g[e+88>>2]));j=ea(g[d+92>>2]);g[a+92>>2]=ea(j+ea(g[e+92>>2]));j=ea(g[d+96>>2]);g[a+96>>2]=ea(j+ea(g[e+96>>2]));j=ea(g[d+100>>2]);g[a+100>>2]=ea(j+ea(g[e+100>>2]));j=ea(g[d+104>>2]);g[a+104>>2]=ea(j+ea(g[e+104>>2]));i=b;return}function mff(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;i=i+224|0;e=a+108|0;f=a;g=f+0|0;h=b+0|0;b=g+108|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(b|0));g=e+0|0;h=d+0|0;b=g+108|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(b|0));h=(iff(0,f,e)|0)^1;i=a;return h|0}function nff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function off(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function pff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function qff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function rff(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=AL(c[a>>2]|0)|0;c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];i=d;return}function sff(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=BL(c[a>>2]|0)|0;c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];i=d;return}function tff(a){a=a|0;var b=0;b=i;zL(c[a>>2]|0);c[a>>2]=0;i=b;return}function uff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2442208)|0);c[c[d>>2]>>2]=a;i=b;return}function vff(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[610654]|0;if(!d){e=MK(2442624)|0;c[610654]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function wff(a){a=a|0;var b=0;b=i;vff(a);i=b;return}function xff(a,b){a=a|0;b=b|0;c[b>>2]=c[a+8>>2];return}function yff(a,b){a=a|0;b=b|0;c[b+8>>2]=c[a>>2];return}function zff(a){a=a|0;return}function Aff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Bff(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Cff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[a+44>>2]|0;if(g)Cff(g,b,d,e);Dn[c[a+8>>2]&511](c[a+16>>2]|0,b,d,e);i=f;return}function Dff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[(c[a+20>>2]|0)+4>>2]|0;a=AL(b)|0;b=AL(d)|0;co[g&2047](a,b,e);zL(a);zL(b);i=f;return}function Eff(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function Fff(a,b){a=a|0;b=b|0;return}function Gff(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;RI(2443536)|0;g=c[610907]|0;if(f){f=c[g>>2]|0;if(!f){i=a;return}kuh(2443248,f,b,d,e);i=a;return}else{f=c[g+4>>2]|0;if(!f){i=a;return}kuh(2443248,f,b,d,e);i=a;return}}function Hff(a){a=a|0;return}function Iff(a){a=a|0;return}function Jff(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[611022]|0;if(!e){f=MK(2444096)|0;c[611022]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Kff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Lff(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Mff(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)Mff(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function Nff(a,b){a=a|0;b=b|0;Yth(SJ(2444544)|0)}function Off(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Pff(a,b){a=a|0;b=b|0;return}function Qff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2252944)|0;$We(a,1);c[c[d>>2]>>2]=a;i=b;return}function Rff(a){a=a|0;var b=0,d=0,e=0,f=0,g=Im;b=i;d=c[611348]|0;if(!d){e=MK(2445400)|0;c[611348]=e;f=e}else f=d;g=ea(Kn[f&255](a));i=b;return ea(g)}function Sff(a){a=a|0;var b=0,d=0,e=0,f=0,g=Im;b=i;d=c[611360]|0;if(!d){e=MK(2445448)|0;c[611360]=e;f=e}else f=d;g=ea(Kn[f&255](a));i=b;return ea(g)}function Tff(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[611372]|0;if(!d){e=MK(2445496)|0;c[611372]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Uff(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[611384]|0;if(!e){f=MK(2445544)|0;c[611384]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Vff(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[611400]|0;if(!d){e=MK(2445608)|0;c[611400]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Wff(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[611412]|0;if(!e){f=MK(2445656)|0;c[611412]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Xff(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;Wff(b,a);i=d;return}function Yff(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[611430]|0;if(!d){e=MK(2445728)|0;c[611430]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Zff(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[611442]|0;if(!d){e=MK(2445776)|0;c[611442]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function _ff(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[611454]|0;if(!d){e=MK(2445824)|0;c[611454]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function $ff(a){a=a|0;var b=0;b=i;agf(0,a);i=b;return}function agf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[611466]|0;if(!d){e=MK(2445872)|0;c[611466]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function bgf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[611488]|0;if(!d){e=MK(2445960)|0;c[611488]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function cgf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;dgf(a,0,b,c);i=d;return}function dgf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;f=c[611500]|0;if(!f){g=MK(2446008)|0;c[611500]=g;h=g}else h=f;co[h&2047](a,d,e);i=b;return}function egf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[611526]|0;if(!b){d=MK(2446112)|0;c[611526]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function fgf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[611536]|0;if(!b){d=MK(2446152)|0;c[611536]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function ggf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[611550]|0;if(!d){e=MK(2446208)|0;c[611550]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function hgf(a,b){a=a|0;b=b|0;a=i;RI(2445136)|0;if(!(c[c[611307]>>2]|0)){i=a;return}RI(2445136)|0;luh(2444856,c[c[611307]>>2]|0,b);i=a;return}function igf(a,b){a=a|0;b=b|0;a=i;RI(2445136)|0;if(!(c[(c[611307]|0)+4>>2]|0)){i=a;return}RI(2445136)|0;luh(2444856,c[(c[611307]|0)+4>>2]|0,b);i=a;return}function jgf(a,b){a=a|0;b=b|0;a=i;RI(2445136)|0;if(!(c[(c[611307]|0)+8>>2]|0)){i=a;return}RI(2445136)|0;luh(2444856,c[(c[611307]|0)+8>>2]|0,b);i=a;return}function kgf(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;var e=0,f=0;e=i;f=lgf(0,a,b,c,d)|0;i=e;return f|0}function lgf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;var g=0,h=0,j=0;a=i;g=c[611566]|0;if(!g){h=MK(2446272)|0;c[611566]=h;j=h}else j=g;g=wo[j&7](b,d,e,f)|0;i=a;return g|0}function mgf(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;var e=0,f=0;e=i;f=ngf(0,a,b,c,d)|0;i=e;return f|0}function ngf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=ea(e);f=f|0;var g=0,h=0,j=0;a=i;g=c[611596]|0;if(!g){h=MK(2446392)|0;c[611596]=h;j=h}else j=g;g=wo[j&7](b,d,e,f)|0;i=a;return g|0}function ogf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function pgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function qgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function rgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function sgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function tgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function ugf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function vgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function wgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function xgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function ygf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function zgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Agf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Bgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Cgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Dgf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Egf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Fgf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[612342]|0;if(!f){g=MK(2449376)|0;c[612342]=g;h=g}else h=f;co[h&2047](b,d,e);i=a;return}function Ggf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Hgf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Igf(a){a=a|0;var b=0,d=0;b=i;d=c[a+44>>2]|0;if(d)Igf(d);ko[c[a+8>>2]&4095](c[a+16>>2]|0);i=b;return}function Jgf(a){a=a|0;var b=0;b=i;eo[c[(c[a+20>>2]|0)+4>>2]&511]();i=b;return}function Kgf(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Lgf(a,b){a=a|0;b=b|0;return}function Mgf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=0;vAf(d,0);c[a+8>>2]=c[d>>2];i=b;return}function Ngf(a,b){a=a|0;b=b|0;c[a+8>>2]=c[b>>2];return}function Ogf(a){a=a|0;var b=0,d=0;a=i;RI(1118152)|0;b=$th(1118152,1)|0;RI(2450560)|0;d=qL(2450560)|0;Mgf(d);Qqh(b,d);c[b+16>>2]=d;RI(2450560)|0;c[c[612663]>>2]=b;RI(2450560)|0;b=c[(c[c[612663]>>2]|0)+16>>2]|0;RI(2450560)|0;c[(c[612663]|0)+4>>2]=b;RI(2450560)|0;c[(c[612663]|0)+8>>2]=0;i=a;return}function Pgf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}RI(2450560)|0;e=NBf(0,c[(c[612663]|0)+8>>2]|0,d)|0;RI(2450056)|0;d=duh(e,2450056)|0;RI(2450560)|0;c[(c[612663]|0)+8>>2]=d;i=b;return}function Qgf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}RI(2450560)|0;e=PBf(0,c[(c[612663]|0)+8>>2]|0,d)|0;RI(2450056)|0;d=duh(e,2450056)|0;RI(2450560)|0;c[(c[612663]|0)+8>>2]=d;i=b;return}function Rgf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=0;c[g>>2]=0;j=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[e+0>>2]=c[h+0>>2];Sgf(0,e,f,g);i=d;return c[f>>2]|0}function Sgf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;f=a+4|0;g=a;h=c[612728]|0;if(!h){j=MK(2450920)|0;c[612728]=j;k=j}else k=h;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];co[k&2047](f,d,e);i=a;return}function Tgf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=0;c[g>>2]=0;j=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[e+0>>2]=c[h+0>>2];Sgf(0,e,f,g);i=d;return c[g>>2]|0}function Ugf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=0;c[g>>2]=0;j=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[e+0>>2]=c[h+0>>2];Vgf(0,e,f,g);i=d;return c[f>>2]|0}function Vgf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;f=a+4|0;g=a;h=c[612704]|0;if(!h){j=MK(2450824)|0;c[612704]=j;k=j}else k=h;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];co[k&2047](f,d,e);i=a;return}function Wgf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=0;c[g>>2]=0;j=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[e+0>>2]=c[h+0>>2];Vgf(0,e,f,g);i=d;return c[g>>2]|0}function Xgf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e;h=e+8|0;j=b;c[j>>2]=0;c[j+4>>2]=0;j=g;c[j>>2]=0;c[j+4>>2]=0;j=c[d+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[f+0>>2]=c[h+0>>2];Ygf(0,f,b,g);i=e;return}function Ygf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;f=a+4|0;g=a;h=c[612752]|0;if(!h){j=MK(2451016)|0;c[612752]=j;k=j}else k=h;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];co[k&2047](f,d,e);i=a;return}function Zgf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e;h=e+8|0;j=g;c[j>>2]=0;c[j+4>>2]=0;j=b;c[j>>2]=0;c[j+4>>2]=0;j=c[d+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[f+0>>2]=c[h+0>>2];Ygf(0,f,g,b);i=e;return}function _gf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];$gf(0,e,0,0,60);i=d;return}function $gf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;g=a+4|0;h=a;j=c[612808]|0;if(!j){k=MK(2451240)|0;c[612808]=k;l=k}else l=j;c[h>>2]=c[b>>2];c[g+0>>2]=c[h+0>>2];Dn[l&511](g,d,e,f);i=a;return}function ahf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;k=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[j>>2]=k;c[h+0>>2]=c[j+0>>2];$gf(0,h,d,e,f);i=g;return}function bhf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[k>>2]=l;c[j+0>>2]=c[k+0>>2];chf(0,j,d,e,f,g);i=h;return}function chf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;h=a+4|0;j=a;k=c[612834]|0;if(!k){l=MK(2451344)|0;c[612834]=l;m=l}else m=k;c[j>>2]=c[b>>2];c[h+0>>2]=c[j+0>>2];En[m&127](h,d,e,f,g);i=a;return}function dhf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[b+8>>2]|0;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c[h>>2]=j;c[g+0>>2]=c[h+0>>2];ehf(0,g,d,e);i=f;return}function ehf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;f=a+4|0;g=a;h=c[612782]|0;if(!h){j=MK(2451136)|0;c[612782]=j;k=j}else k=h;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];co[k&2047](f,d,e);i=a;return}function fhf(b){b=b|0;var c=0;b=i;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}c=ghf(0)|0;i=b;return c|0}function ghf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[612862]|0;if(!b){d=MK(2451456)|0;c[612862]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function hhf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;d=i;i=i+16|0;f=d+4|0;h=d;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[f>>2]=0;c[h>>2]=0;j=~~ea(g[e>>2]);k=~~ea(g[e+4>>2]);RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}g[b+8>>2]=ea(ihf(0,j,k,f,h)|0);g[b>>2]=ea(c[f>>2]|0);g[b+4>>2]=ea(c[h>>2]|0);i=d;return}function ihf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;g=c[612876]|0;if(!g){h=MK(2451512)|0;c[612876]=h;j=h}else j=g;g=kn[j&511](b,d,e,f)|0;i=a;return g|0}function jhf(b){b=b|0;b=i;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}RI(2450560)|0;i=b;return c[(c[612663]|0)+4>>2]|0}function khf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}RI(1118152)|0;e=d+12|0;f=$th(1118152,c[e>>2]|0)|0;RI(2450560)|0;c[c[612663]>>2]=f;f=(c[e>>2]|0)>0;RI(2450560)|0;g=(a[2450708]|0)!=0;if(f){f=d+16|0;h=g;j=0;while(1){if(!h){RI(2450560)|0;_th(2450560)}RI(2450560)|0;k=qL(2450560)|0;c[k+8>>2]=c[f+(da(c[(c[d>>2]|0)+120>>2]|0,j)|0)>>2];RI(2450560)|0;Qqh(c[c[612663]>>2]|0,k);RI(2450560)|0;l=c[c[612663]>>2]|0;c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,j)|0)>>2]=k;j=j+1|0;k=(j|0)<(c[e>>2]|0);RI(2450560)|0;l=(a[2450708]|0)!=0;if(!k){m=l;break}else h=l}}else m=g;if(m){RI(2450560)|0;n=c[612663]|0;o=c[n>>2]|0;p=o+16|0;q=c[p>>2]|0;RI(2450560)|0;r=c[612663]|0;s=r+4|0;c[s>>2]=q;i=b;return}RI(2450560)|0;_th(2450560);RI(2450560)|0;n=c[612663]|0;o=c[n>>2]|0;p=o+16|0;q=c[p>>2]|0;RI(2450560)|0;r=c[612663]|0;s=r+4|0;c[s>>2]=q;i=b;return}function lhf(b){b=b|0;b=i;RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}RI(2450560)|0;if(!(c[(c[612663]|0)+8>>2]|0)){i=b;return}RI(2450560)|0;if(!(a[2450708]|0)){RI(2450560)|0;_th(2450560)}RI(2450560)|0;eth(2450304,c[(c[612663]|0)+8>>2]|0);i=b;return}function mhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function nhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function ohf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function phf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function qhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function rhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function shf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function thf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function uhf(a){a=a|0;return}function vhf(a){a=a|0;return}function whf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[613748]|0;if(!d){e=MK(2455e3)|0;c[613748]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function xhf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[613762]|0;if(!d){e=MK(2455056)|0;c[613762]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function yhf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;b=i;d=c[613778]|0;if(!d){e=MK(2455120)|0;c[613778]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function zhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Ahf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Bhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Chf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function Dhf(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,g=0;a=i;e=c[614136]|0;if(!e){f=MK(2456552)|0;c[614136]=f;g=f}else g=e;Fn[g&255](b,d);i=a;return}function Ehf(a,b){a=a|0;b=b|0;a=i;Dhf(0,b,ea(0.0));i=a;return}function Fhf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[614154]|0;if(!e){f=MK(2456624)|0;c[614154]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function Ghf(a,b){a=a|0;b=b|0;a=i;Fhf(0,b,0);i=a;return}function Hhf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[614184]|0;if(!e){f=MK(2456744)|0;c[614184]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Ihf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[614202]|0;if(!d){e=MK(2456816)|0;c[614202]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Jhf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(2347360)|0;d=Khf(0,a,vL(b,2347360)|0)|0;i=c;return d|0}function Khf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=(b|0)==0;f=(d|0)==0;do if(!(f&e)){if(f){g=(Nhf(0,b)|0)^1;break}if(e){g=(Nhf(0,d)|0)^1;break}else{g=(c[b+8>>2]|0)==(c[d+8>>2]|0);break}}else g=1;while(0);i=a;return g|0}function Lhf(a){a=a|0;return c[a+8>>2]|0}function Mhf(a){a=a|0;return c[a+8>>2]|0}function Nhf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;c[f>>2]=c[b+12>>2];RI(2604248)|0;c[g>>2]=c[c[651085]>>2];c[e+0>>2]=c[f+0>>2];c[d+0>>2]=c[g+0>>2];g=GAf(0,e,d)|0;i=a;return g|0}function Ohf(a){a=a|0;return c[a+12>>2]|0}function Phf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=(Khf(0,b,c)|0)^1;i=a;return d|0}function Qhf(a,b){a=a|0;b=b|0;c[b>>2]=c[a+8>>2];c[b+4>>2]=c[a+12>>2];return}function Rhf(a,b){a=a|0;b=b|0;c[b+8>>2]=c[a>>2];c[b+12>>2]=c[a+4>>2];return}function Shf(a){a=a|0;return}function Thf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Uhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2528920)|0;Enf(a);c[c[d>>2]>>2]=a;i=b;return}function Vhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Whf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2528920)|0;Enf(a);c[c[d>>2]>>2]=a;i=b;return}function Xhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Yhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Zhf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function _hf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[614616]|0;if(!d){e=MK(2458472)|0;c[614616]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function $hf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[614628]|0;if(!d){e=MK(2458520)|0;c[614628]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function aif(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=bif($hf(a)|0,b)|0;i=c;return d|0}function bif(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[614816]|0;if(!e){f=MK(2459272)|0;c[614816]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function cif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function dif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function eif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2530144)|0;Hnf(a,0);c[c[d>>2]>>2]=a;i=b;return}function fif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2977872)|0;tcg(a);c[c[d>>2]>>2]=a;i=b;return}function gif(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[614832]|0;if(!g){h=MK(2459336)|0;c[614832]=h;j=h}else j=g;Dn[j&511](a,b,d,e);i=f;return}function hif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2530144)|0;Hnf(a,0);c[c[d>>2]>>2]=a;a=qL(2490056)|0;okf(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function iif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2977872)|0;tcg(a);c[c[d>>2]>>2]=a;i=b;return}function jif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function kif(a,b){a=a|0;b=b|0;c[a+12>>2]=-1;c[a+8>>2]=b;return}function lif(a){a=a|0;var b=0,d=0;b=i;d=mif(c[a+8>>2]|0,c[a+12>>2]|0)|0;i=b;return d|0}function mif(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[615266]|0;if(!e){f=MK(2461072)|0;c[615266]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function nif(a){a=a|0;var b=0,d=0,e=0;b=i;d=oif(c[a+8>>2]|0)|0;e=a+12|0;a=(c[e>>2]|0)+1|0;c[e>>2]=a;i=b;return (a|0)<(d|0)|0}function oif(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[615254]|0;if(!d){e=MK(2461024)|0;c[615254]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function pif(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[615170]|0;if(!e){f=MK(2460688)|0;c[615170]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function qif(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[615190]|0;if(!e){f=MK(2460768)|0;c[615190]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function rif(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;pif(b,a);i=d;return}function sif(a,b){a=a|0;b=b|0;var c=0;c=i;qif(a,b);i=c;return}function tif(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[615210]|0;if(!e){f=MK(2460848)|0;c[615210]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function uif(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[615232]|0;if(!e){f=MK(2460936)|0;c[615232]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function vif(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;tif(b,a);i=d;return}function wif(a,b){a=a|0;b=b|0;var c=0;c=i;uif(a,b);i=c;return}function xif(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];yif(a,e,1);i=d;return}function yif(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=Im,v=Im;e=i;i=i+208|0;f=e;h=e+16|0;j=e+48|0;k=e+32|0;l=e+96|0;m=e+64|0;n=e+80|0;o=e+112|0;p=e+128|0;q=e+144|0;r=e+160|0;s=e+176|0;t=e+192|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;u=ea(g[b>>2]);v=ea(g[b+4>>2]);scf(k,0,u,v,ea(g[b+8>>2]));c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];if((d|0)==1){c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;tif(a,l);c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];xcf(m,0,h,f);c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];uif(a,f);i=e;return}else{c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;pif(a,n);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;pif(a,o);c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];qcf(p,0,f);c[h+0>>2]=c[p+0>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];xcf(r,0,h,f);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;pif(a,q);c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[h+12>>2]=c[r+12>>2];c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];xcf(s,0,h,f);c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];xcf(t,0,h,f);c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];qif(a,f);i=e;return}}function zif(a){a=a|0;var b=0,d=0;b=i;RI(2460168)|0;d=qL(2460168)|0;c[d+12>>2]=-1;c[d+8>>2]=a;i=b;return d|0}function Aif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Bif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Cif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Dif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Eif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2528920)|0;Enf(a);c[c[d>>2]>>2]=a;i=b;return}function Fif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Gif(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Hif(a,b){a=a|0;b=b|0;return}function Iif(a,b){a=a|0;b=b|0;return}function Jif(a){a=a|0;return}function Kif(a,b){a=a|0;b=b|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];return}function Lif(a,b){a=a|0;b=b|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];return}function Mif(a,b){a=a|0;b=b|0;var d=0;d=b+12|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];return}function Nif(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];return}function Oif(a){a=a|0;var b=Im;b=ea(g[a+36>>2]);return ea(b)}function Pif(a,b){a=a|0;b=ea(b);g[a+36>>2]=b;return}function Qif(a){a=a|0;var b=Im;b=ea(g[a+40>>2]);return ea(b)}function Rif(a,b){a=a|0;b=ea(b);g[a+40>>2]=b;return}function Sif(a){a=a|0;var b=Im;b=ea(g[a+24>>2]);return ea(b)}function Tif(a,b){a=a|0;b=ea(b);g[a+24>>2]=b;return}function Uif(a){a=a|0;var b=Im;b=ea(g[a+28>>2]);return ea(b)}function Vif(a,b){a=a|0;b=ea(b);g[a+28>>2]=b;return}function Wif(a){a=a|0;var b=Im;b=ea(g[a+32>>2]);return ea(b)}function Xif(a,b){a=a|0;b=ea(b);g[a+32>>2]=b;return}function Yif(a,b){a=a|0;b=b|0;var d=0;d=b+44|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function Zif(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];return}function _if(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function $if(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)$if(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function ajf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b)e=0;else e=b+16|0;ko[c[(c[a+20>>2]|0)+4>>2]&4095](e);i=d;return}function bjf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function cjf(a,b){a=a|0;b=b|0;return}function djf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function ejf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)ejf(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function fjf(a,b){a=a|0;b=b|0;var d=0;d=i;ko[c[(c[a+20>>2]|0)+4>>2]&4095](b);i=d;return}function gjf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function hjf(a,b){a=a|0;b=b|0;return}function ijf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+16>>2]|0;if(!e){i=d;return}muh(2464768,e,b);i=d;return}function jjf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+20>>2]|0;if(!e){i=d;return}Lrh(2465560,e,b);i=d;return}function kjf(b){b=b|0;var d=0,e=0;d=i;g[b+8>>2]=ea(0.0);if(!(a[2540708]|0))_th(2540560);e=c[c[635163]>>2]|0;c[b+12>>2]=e;c[b+16>>2]=e;e=b+20|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;i=d;return}function ljf(a){a=a|0;return c[a+16>>2]|0}function mjf(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function njf(a){a=a|0;return c[a+16>>2]|0}function ojf(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function pjf(a){a=a|0;var b=Im;b=ea(g[a+24>>2]);return ea(b)}function qjf(a,b){a=a|0;b=ea(b);g[a+24>>2]=b;return}function rjf(a){a=a|0;return c[a+28>>2]|0}function sjf(a,b){a=a|0;b=b|0;c[a+28>>2]=b;return}function tjf(a){a=a|0;return c[a+20>>2]|0}function ujf(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function vjf(a){a=a|0;return c[a+12>>2]|0}function wjf(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function xjf(a){a=a|0;var b=Im;b=ea(g[a+8>>2]);return ea(b)}function yjf(a,b){a=a|0;b=ea(b);g[a+8>>2]=b;return}function zjf(a){a=a|0;return c[a+32>>2]|0}function Ajf(a,b){a=a|0;b=b|0;c[a+32>>2]=b;return}function Bjf(a){a=a|0;return (c[a+36>>2]|0)==1|0}function Cjf(a){a=a|0;return (c[a+36>>2]|0)==2|0}function Djf(a){a=a|0;var b=0;b=i;Zbh();if((c[a+36>>2]|0)!=1)G9e(0,c[880206]|0);i=b;return c[a+40>>2]|0}function Ejf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;_bh();if((c[b+36>>2]|0)!=2)G9e(0,c[880260]|0);e=b+44|0;c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];c[a+20>>2]=c[e+20>>2];c[a+24>>2]=c[e+24>>2];i=d;return}function Fjf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;$bh();if((c[b+36>>2]|0)!=2)G9e(0,c[880316]|0);e=b+72|0;b=c[e+4>>2]|0;f=a;c[f>>2]=c[e>>2];c[f+4>>2]=b;i=d;return}function Gjf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2469328)|0);c[c[d>>2]>>2]=a;i=b;return}function Hjf(a,b){a=a|0;b=b|0;var c=0;c=i;Ijf(a,b);i=c;return}function Ijf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[617510]|0;if(!e){f=MK(2470048)|0;c[617510]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Jjf(a){a=a|0;var b=0;b=i;Ijf(a,0);i=b;return}function Kjf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[617498]|0;if(!d){e=MK(247e4)|0;c[617498]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function Ljf(a){a=a|0;var b=0;b=i;Kjf(a);i=b;return}function Mjf(a,b){a=a|0;b=b|0;c[b>>2]=c[a+8>>2];return}function Njf(a,b){a=a|0;b=b|0;c[b+8>>2]=c[a>>2];return}function Ojf(a){a=a|0;return}function Pjf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function Qjf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Rjf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;okf(a);c[c[d>>2]>>2]=a;i=b;return}function Sjf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=Tjf(0,b)|0;if((e|0)!=(c[a+8>>2]|0)?(e|0)!=(c[a>>2]|0):0)f=(e|0)==(c[a+4>>2]|0);else f=1;i=d;return f|0}function Tjf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[622430]|0;if(!d){e=MK(2489728)|0;c[622430]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Ujf(a){a=a|0;return c[a+8>>2]|0}function Vjf(a){a=a|0;return c[a+4>>2]|0}function Wjf(a){a=a|0;return c[a>>2]|0}function Xjf(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function Yjf(a){a=a|0;var b=Im;b=ea(g[a+16>>2]);return ea(b)}function Zjf(a){a=a|0;return c[a+20>>2]|0}function _jf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Tjf(0,b)|0;i=d;return (e|0)==(c[a+20>>2]|0)|0}function $jf(a){a=a|0;return (c[a+24>>2]|0)!=0|0}function akf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2488360)|0);c[c[d>>2]>>2]=a;i=b;return}function bkf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=Tjf(0,b)|0;if((e|0)==(c[a+8>>2]|0)){f=1;i=d;return f|0}e=Tjf(0,b)|0;f=(e|0)==(c[a>>2]|0);i=d;return f|0}function ckf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Tjf(0,b)|0;i=d;return (e|0)==(c[a+4>>2]|0)|0}function dkf(a){a=a|0;return c[a>>2]|0}function ekf(a){a=a|0;return c[a+8>>2]|0}function fkf(a){a=a|0;return c[a+4>>2]|0}function gkf(a){a=a|0;var b=Im;b=ea(g[a+12>>2]);return ea(b)}function hkf(b){b=b|0;return (a[b+16>>0]|0)!=0|0}function ikf(a){a=a|0;return (c[a+20>>2]&2|0)!=0|0}function jkf(a){a=a|0;return (c[a+20>>2]&4|0)!=0|0}function kkf(a,b){a=a|0;b=b|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];g[b+12>>2]=ea(g[a+12>>2]);c[b+16>>2]=d[a+16>>0];c[b+20>>2]=c[a+20>>2];return}function lkf(b,d){b=b|0;d=d|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];g[d+12>>2]=ea(g[b+12>>2]);a[d+16>>0]=(c[b+16>>2]|0)!=0&1;c[d+20>>2]=c[b+20>>2];return}function mkf(a){a=a|0;return}function nkf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function okf(a){a=a|0;return}function pkf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;c[b>>2]=AL(c[a>>2]|0)|0;e=b+4|0;f=a+4|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];f=b+16|0;e=a+16|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=b+32|0;f=a+32|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[b+44>>2]=c[a+44>>2];i=d;return}function qkf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;c[b>>2]=BL(c[a>>2]|0)|0;e=b+4|0;f=a+4|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];f=b+16|0;e=a+16|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=b+32|0;f=a+32|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[b+44>>2]=c[a+44>>2];i=d;return}function rkf(a){a=a|0;var b=0;b=i;zL(c[a>>2]|0);c[a>>2]=0;i=b;return}function skf(a){a=a|0;return c[a>>2]|0}function tkf(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function ukf(a){a=a|0;return c[a+4>>2]|0}function vkf(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function wkf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[b>>2]=AL(c[a>>2]|0)|0;c[b+4>>2]=AL(c[a+4>>2]|0)|0;e=b+8|0;b=a+8|0;a=e+44|0;do{c[e>>2]=c[b>>2];e=e+4|0;b=b+4|0}while((e|0)<(a|0));i=d;return}function xkf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[b>>2]=BL(c[a>>2]|0)|0;c[b+4>>2]=BL(c[a+4>>2]|0)|0;e=b+8|0;b=a+8|0;a=e+44|0;do{c[e>>2]=c[b>>2];e=e+4|0;b=b+4|0}while((e|0)<(a|0));i=d;return}function ykf(a){a=a|0;var b=0,d=0;b=i;zL(c[a>>2]|0);c[a>>2]=0;d=a+4|0;zL(c[d>>2]|0);c[d>>2]=0;i=b;return}function zkf(a){a=a|0;var b=0;b=i;Hff(a);i=b;return}function Akf(a){a=a|0;var b=0;b=~~ea(g[a+36>>2]);return b|0}function Bkf(a){a=a|0;var b=0,c=0;b=i;c=~~ea(R6e(a+20|0));i=b;return c|0}function Ckf(a){a=a|0;var b=0,c=0;b=i;c=~~ea(-ea(S6e(a+20|0)));i=b;return c|0}function Dkf(a){a=a|0;var b=0,c=0;b=i;c=~~ea(N6e(a+20|0));i=b;return c|0}function Ekf(a){a=a|0;var b=0,d=0,e=0,f=Im;b=i;d=c[a+52>>2]|0;e=a+20|0;f=ea(P6e(e));a=~~ea(f+ea(S6e(e)))+d|0;i=b;return a|0}function Fkf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+52>>2]|0;e=~~ea(P6e(a+20|0))+d|0;i=b;return e|0}function Gkf(a){a=a|0;var b=0,c=0;b=i;c=~~ea(N6e(a+20|0));i=b;return c|0}function Hkf(a){a=a|0;var b=0,c=0,d=Im;b=i;c=a+20|0;d=ea(N6e(c));a=~~ea(d+ea(R6e(c)));i=b;return a|0}function Ikf(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,g=Im;d=i;e=b+4|0;f=ea(N6e(e));g=ea(P6e(e));e=a;c[e>>2]=0;c[e+4>>2]=0;Jbf(a,f,g);i=d;return}function Jkf(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,g=Im,h=Im;d=i;e=b+4|0;f=ea(N6e(e));g=ea(R6e(e));h=ea(P6e(e));e=a;c[e>>2]=0;c[e+4>>2]=0;Jbf(a,ea(f+g),h);i=d;return}function Kkf(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,g=Im,h=Im,j=Im;d=i;e=b+4|0;f=ea(N6e(e));g=ea(R6e(e));h=ea(P6e(e));j=ea(S6e(e));e=a;c[e>>2]=0;c[e+4>>2]=0;Jbf(a,ea(f+g),ea(h+j));i=d;return}function Lkf(a,b){a=a|0;b=b|0;var d=0,e=0,f=Im,g=Im,h=Im;d=i;e=b+4|0;f=ea(N6e(e));g=ea(P6e(e));h=ea(S6e(e));e=a;c[e>>2]=0;c[e+4>>2]=0;Jbf(a,f,ea(g+h));i=d;return}function Mkf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=b;c[h>>2]=0;c[h+4>>2]=0;if(!(a[d+48>>0]|0)){Ikf(g,d);j=g}else{Ikf(f,d);j=f}f=j;j=c[f+4>>2]|0;d=b;c[d>>2]=c[f>>2];c[d+4>>2]=j;i=e;return}function Nkf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=b;c[h>>2]=0;c[h+4>>2]=0;if(!(a[d+48>>0]|0)){Jkf(g,d);j=g}else{Lkf(f,d);j=f}f=j;j=c[f+4>>2]|0;d=b;c[d>>2]=c[f>>2];c[d+4>>2]=j;i=e;return}function Okf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=b;c[h>>2]=0;c[h+4>>2]=0;if(!(a[d+48>>0]|0)){Kkf(g,d);j=g}else{Kkf(f,d);j=f}f=j;j=c[f+4>>2]|0;d=b;c[d>>2]=c[f>>2];c[d+4>>2]=j;i=e;return}function Pkf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=b;c[h>>2]=0;c[h+4>>2]=0;if(!(a[d+48>>0]|0)){Lkf(g,d);j=g}else{Jkf(f,d);j=f}f=j;j=c[f+4>>2]|0;d=b;c[d>>2]=c[f>>2];c[d+4>>2]=j;i=e;return}function Qkf(a,b){a=a|0;b=b|0;var e=0,f=0;c[b>>2]=c[a>>2];e=b+4|0;f=a+4|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=b+20|0;e=a+20|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];g[b+36>>2]=ea(g[a+36>>2]);c[b+40>>2]=c[a+40>>2];c[b+44>>2]=c[a+44>>2];c[b+48>>2]=d[a+48>>0];c[b+52>>2]=c[a+52>>2];return}function Rkf(b,d){b=b|0;d=d|0;var e=0,f=0;c[d>>2]=c[b>>2];e=d+4|0;f=b+4|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=d+20|0;e=b+20|0;c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];g[d+36>>2]=ea(g[b+36>>2]);c[d+40>>2]=c[b+40>>2];c[d+44>>2]=c[b+44>>2];a[d+48>>0]=(c[b+48>>2]|0)!=0&1;c[d+52>>2]=c[b+52>>2];return}function Skf(a){a=a|0;return}function Tkf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2495432)|0);c[c[d>>2]>>2]=a;i=b;return}function Ukf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2495536)|0);c[c[d>>2]>>2]=a;i=b;return}function Vkf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2495608)|0);c[c[d>>2]>>2]=a;i=b;return}function Wkf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2495664)|0);c[c[d>>2]>>2]=a;i=b;return}function Xkf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Ykf(a){a=a|0;var b=0,d=0;b=i;d=c[a+44>>2]|0;if(d)Ykf(d);ko[c[a+8>>2]&4095](c[a+16>>2]|0);i=b;return}function Zkf(a){a=a|0;var b=0;b=i;eo[c[(c[a+20>>2]|0)+4>>2]&511]();i=b;return}function _kf(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function $kf(a,b){a=a|0;b=b|0;return}function alf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2252944)|0;$We(a,1);c[c[d>>2]>>2]=a;i=b;return}function blf(a,b){a=a|0;b=b|0;var d=0;a=i;RI(2496568)|0;d=c[c[624165]>>2]|0;if(d)nuh(1929400,d,b);d=c[b+16>>2]|0;if(!d){i=a;return}eth(2496288,d);i=a;return}function clf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624206]|0;if(!d){e=MK(2496832)|0;c[624206]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function dlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function elf(a){a=a|0;var b=0;b=i;flf(a,50);i=b;return}function flf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;RI(1932952)|0;if(!(a[1933100]|0)){RI(1932952)|0;ouh(1932952)}RI(1932952)|0;f=qL(1932952)|0;g=d+1|0;VLe(f,g<<2);c[b+104>>2]=f;RI(1941480)|0;if(!(a[1941628]|0)){RI(1941480)|0;ouh(1941480)}RI(1941480)|0;f=qL(1941480)|0;TMe(f,g);c[b+108>>2]=f;RI(1952456)|0;if(a[1952604]|0){RI(1952456)|0;h=qL(1952456)|0;RNe(h,20);j=b+112|0;c[j>>2]=h;glf(b);i=e;return}RI(1952456)|0;ouh(1952456);RI(1952456)|0;h=qL(1952456)|0;RNe(h,20);j=b+112|0;c[j>>2]=h;glf(b);i=e;return}function glf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624462]|0;if(!d){e=MK(2497856)|0;c[624462]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function hlf(a){a=a|0;var b=0;b=i;ilf(a);i=b;return}function ilf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624474]|0;if(!d){e=MK(2497904)|0;c[624474]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function jlf(a){a=a|0;var b=0;b=i;kth(2568816,a);i=b;return}function klf(a,b,d,e,f,h,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=Im,y=Im,z=Im,A=Im;v=i;i=i+16|0;w=v;x=ea(g[s>>2]);y=ea(g[s+4>>2]);z=ea(g[t>>2]);A=ea(g[t+4>>2]);c[w+0>>2]=c[e+0>>2];c[w+4>>2]=c[e+4>>2];c[w+8>>2]=c[e+8>>2];c[w+12>>2]=c[e+12>>2];e=mlf(0,a,b,d,w,f,h,j,k,l,m,n,o,p,q,r,x,y,z,A,u)|0;i=v;return e|0}function llf(a,b,c,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);r=ea(r);s=ea(s);t=ea(t);u=u|0;var v=0,w=0;v=i;w=mlf(0,a,b,c,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u)|0;i=v;return w|0}function mlf(a,b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=ea(s);t=ea(t);u=ea(u);v=ea(v);w=w|0;var x=0,y=0,z=0;a=i;x=c[624488]|0;if(!x){y=MK(2497960)|0;c[624488]=y;z=y}else z=x;x=vn[z&3](b,d,e,f,g,h,j,k,l,m,n,o,p,q,r,s,t,u,v,w)|0;i=a;return x|0}function nlf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[624586]|0;if(!e){f=MK(2498352)|0;c[624586]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function olf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624600]|0;if(!d){e=MK(2498408)|0;c[624600]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function plf(a,b){a=a|0;b=b|0;var c=0;c=i;qlf(a,b);i=c;return}function qlf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[624614]|0;if(!e){f=MK(2498464)|0;c[624614]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function rlf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624632]|0;if(!d){e=MK(2498536)|0;c[624632]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function slf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624646]|0;if(!d){e=MK(2498592)|0;c[624646]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function tlf(b){b=b|0;var d=0,e=0,f=0;d=i;e=Vof(c[b+12>>2]|0)|0;f=olf(b)|0;RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;ouh(2369112)}b=M7e(0,e,O7e(0,0,(f+-4|0)/4|0)|0)|0;i=d;return b|0}function ulf(a,b){a=a|0;b=b|0;var c=0;c=i;vlf(a,b);i=c;return}function vlf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[624660]|0;if(!e){f=MK(2498648)|0;c[624660]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function wlf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624678]|0;if(!d){e=MK(2498720)|0;c[624678]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function xlf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624692]|0;if(!d){e=MK(2498776)|0;c[624692]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function ylf(a,b){a=a|0;b=b|0;var c=0;c=i;zlf(a,b);i=c;return}function zlf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[624706]|0;if(!e){f=MK(2498832)|0;c[624706]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Alf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624724]|0;if(!d){e=MK(2498904)|0;c[624724]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Blf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[624738]|0;if(!d){e=MK(2498960)|0;c[624738]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Clf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;d=i;ach();f=c[e>>2]|0;if(Phf(0,f,0)|0?clf(f)|0:0){g=b+0|0;h=e+0|0;j=g+84|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));i=d;return}f=e+20|0;k=e+32|0;if(c[f>>2]|c[k>>2]){F9e(0,c[880372]|0);c[f>>2]=0;c[k>>2]=0}k=e+40|0;if(a[k>>0]|0){F9e(0,c[880374]|0);a[k>>0]=0}g=b+0|0;h=e+0|0;j=g+84|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));i=d;return}function Dlf(b){b=b|0;a[b+100>>0]=0;return}function Elf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=Im;f=i;i=i+128|0;g=f+32|0;h=f+16|0;j=f;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[e+60>>2]=1;c[e+56>>2]=1;a[e+52>>0]=1;k=g+0|0;l=e+0|0;e=k+84|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(e|0));Flf(b,d,g)|0;nlf(j,b);c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];m=ea(R6e(h));i=f;return ea(m)}function Flf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+96|0;g=f;if(a[b+100>>0]|0){h=c[b+12>>2]|0;if(!(a[2540708]|0))ouh(2540560);if(gpf(0,d,h)|0){j=g+0|0;k=b+16|0;l=j+84|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));if(Hlf(e,g)|0){m=(a[b+101>>0]|0)!=0;i=f;return m|0}}}j=g+0|0;k=e+0|0;l=j+84|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));m=Ilf(b,d,g)|0;i=f;return m|0}function Glf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=Im;f=i;i=i+128|0;g=f+32|0;h=f+16|0;j=f;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[e+56>>2]=1;a[e+52>>0]=1;k=g+0|0;l=e+0|0;e=k+84|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(e|0));Flf(b,d,g)|0;nlf(j,b);c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];m=ea(S6e(h));i=f;return ea(m)}function Hlf(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=Im,u=0;e=i;i=i+64|0;f=e+48|0;h=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;n=b+4|0;o=d+4|0;c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];if(!($mf(0,h,f)|0)){p=0;i=e;return p|0}if((c[b+20>>2]|0)!=(c[d+20>>2]|0)){p=0;i=e;return p|0}o=b+44|0;n=c[o>>2]|0;if((n|0)!=(c[d+44>>2]|0)){p=0;i=e;return p|0}q=b+48|0;r=c[q>>2]|0;if((r|0)!=(c[d+48>>2]|0)){p=0;i=e;return p|0}s=ea(g[b+24>>2]);t=ea(g[d+24>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;ouh(2369112)}if(!(uef(0,s,t)|0)){p=0;i=e;return p|0}if((c[b+32>>2]|0)!=(c[d+32>>2]|0)){p=0;i=e;return p|0}if((a[b+28>>0]|0)!=(a[d+28>>0]|0)){p=0;i=e;return p|0}if((c[b+36>>2]|0)!=(c[d+36>>2]|0)){p=0;i=e;return p|0}if((a[b+40>>0]|0)!=(a[d+40>>0]|0)){p=0;i=e;return p|0}if((c[o>>2]|0)!=(n|0)){p=0;i=e;return p|0}if((c[q>>2]|0)!=(r|0)){p=0;i=e;return p|0}if((a[b+52>>0]|0)!=(a[d+52>>0]|0)){p=0;i=e;return p|0}if((c[b+60>>2]|0)!=(c[d+60>>2]|0)){p=0;i=e;return p|0}if((c[b+56>>2]|0)!=(c[d+56>>2]|0)){p=0;i=e;return p|0}r=b+64|0;q=c[r+4>>2]|0;n=d+64|0;o=c[n>>2]|0;u=c[n+4>>2]|0;n=j;c[n>>2]=c[r>>2];c[n+4>>2]=q;q=k;c[q>>2]=o;c[q+4>>2]=u;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];if(!(anf(0,h,f)|0)){p=0;i=e;return p|0}k=b+72|0;j=c[k+4>>2]|0;u=d+72|0;q=c[u>>2]|0;o=c[u+4>>2]|0;u=l;c[u>>2]=c[k>>2];c[u+4>>2]=j;j=m;c[j>>2]=q;c[j+4>>2]=o;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];if(!(anf(0,h,f)|0)){p=0;i=e;return p|0}p=D8e(0,c[b>>2]|0,c[d>>2]|0)|0;i=e;return p|0}function Ilf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=Im,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=Im,A=Im,B=Im,C=Im;f=i;i=i+176|0;h=f;j=f+84|0;c[b+12>>2]=d;a[b+100>>0]=1;a[b+116>>0]=0;a[b+117>>0]=0;a[b+118>>0]=0;k=b+16|0;l=e+0|0;m=k+84|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));k=h+0|0;l=e+0|0;m=k+84|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));Clf(j,0,h);l=c[j>>2]|0;k=j+4|0;m=c[j+20>>2]|0;n=ea(g[j+24>>2]);e=c[j+32>>2]|0;o=c[j+36>>2]|0;p=c[j+44>>2]|0;q=c[j+48>>2]|0;r=c[j+56>>2]|0;s=c[j+60>>2]|0;t=j+64|0;u=j+72|0;v=(a[j+28>>0]&1)!=0;w=(a[j+40>>0]&1)!=0;x=(a[j+52>>0]&1)!=0;y=(a[j+80>>0]&1)!=0;z=ea(g[u>>2]);A=ea(g[u+4>>2]);B=ea(g[t>>2]);C=ea(g[t+4>>2]);c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];k=mlf(0,b,d,l,h,m,n,e,v,w,p,q,r,s,x,o,B,C,z,A,y)|0;a[b+101>>0]=k&1;i=f;return k|0}function Jlf(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+116|0;f=b+104|0;if(!(a[e>>0]|0)){qlf(b,c[f>>2]|0);a[e>>0]=1}i=d;return c[f>>2]|0}function Klf(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+117|0;f=b+108|0;if(!(a[e>>0]|0)){vlf(b,c[f>>2]|0);a[e>>0]=1}i=d;return c[f>>2]|0}function Llf(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+118|0;f=b+112|0;if(!(a[e>>0]|0)){zlf(b,c[f>>2]|0);a[e>>0]=1}i=d;return c[f>>2]|0}function Mlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Nlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Olf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Plf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Qlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Rlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Slf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Tlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Ulf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Vlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Wlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Xlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Ylf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function Zlf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2490056)|0;c[c[d>>2]>>2]=a;i=b;return}function _lf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function $lf(a){a=a|0;var b=0,d=0;b=i;d=c[a+44>>2]|0;if(d)$lf(d);ko[c[a+8>>2]&4095](c[a+16>>2]|0);i=b;return}function amf(a){a=a|0;var b=0;b=i;eo[c[(c[a+20>>2]|0)+4>>2]&511]();i=b;return}function bmf(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function cmf(a,b){a=a|0;b=b|0;return}function dmf(a){a=a|0;a=i;RI(2503968)|0;if(!(c[c[626015]>>2]|0)){i=a;return}RI(2503968)|0;eth(2503712,c[c[626015]>>2]|0);i=a;return}function emf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+128|0;e=b+48|0;f=b+28|0;g=b+32|0;h=b+108|0;j=b+16|0;k=b;l=b+8|0;m=e+0|0;n=m+60|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));c[f>>2]=0;kcf(f,-1,-1,-1,-1);RI(2504408)|0;o=c[626125]|0;p=c[f>>2]|0;a[o>>0]=p;a[o+1>>0]=p>>8;a[o+2>>0]=p>>16;a[o+3>>0]=p>>24;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;H4e(g,ea(1.0),ea(0.0),ea(0.0),ea(-1.0));RI(2504408)|0;p=(c[626125]|0)+4|0;c[p+0>>2]=c[g+0>>2];c[p+4>>2]=c[g+4>>2];c[p+8>>2]=c[g+8>>2];c[p+12>>2]=c[g+12>>2];quh(2504408,e);Xbf(h,0);c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];Ybf(j,0);h=e+12|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];j=e+44|0;RI(2504408)|0;h=(c[626125]|0)+4|0;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];RI(2504408)|0;h=c[626125]|0;c[e+24>>2]=d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24;$7e(k,0);h=k;k=c[h+4>>2]|0;j=e+28|0;c[j>>2]=c[h>>2];c[j+4>>2]=k;$7e(l,0);k=l;l=c[k+4>>2]|0;j=e+36|0;c[j>>2]=c[k>>2];c[j+4>>2]=l;RI(2504408)|0;m=(c[626125]|0)+20|0;l=e+0|0;n=m+60|0;do{c[m>>2]=c[l>>2];m=m+4|0;l=l+4|0}while((m|0)<(n|0));i=b;return}function fmf(a){a=a|0;var b=0;a=i;RI(1129904)|0;b=ruh(1129904,1)|0;RI(2505160)|0;c[c[626313]>>2]=b;RI(1130448)|0;b=ruh(1130448,1)|0;RI(2505160)|0;c[(c[626313]|0)+4>>2]=b;RI(1130992)|0;b=ruh(1130992,1)|0;RI(2505160)|0;c[(c[626313]|0)+8>>2]=b;i=a;return}function gmf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;RI(1971200)|0;h=qL(1971200)|0;KOe(h);a:do if(d){j=d;do{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[f>>2]=3434528;c[e+0>>2]=c[f+0>>2];if((j|0)==(npf(0,e)|0))break a;POe(h,j);j=suh(2651176,j)|0}while((j|0)!=0)}while(0);while(1){if((Aqh(1971872,h)|0)<=0){k=0;l=12;break}f=OOe(h)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[g>>2]=3435632;c[e+0>>2]=c[g+0>>2];if(c[(tuh(2658944,f,npf(0,e)|0,0)|0)+12>>2]|0){k=f;l=12;break}}if((l|0)==12){i=b;return k|0}return 0}function hmf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;if(!d){j=0;i=b;return j|0}k=d;d=0;a:while(1){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[h>>2]=3434528;c[e+0>>2]=c[h+0>>2];if((k|0)==(npf(0,e)|0)){l=d;break}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[f>>2]=3435648;c[e+0>>2]=c[f+0>>2];m=tuh(2658944,k,npf(0,e)|0,0)|0;n=m+12|0;if((c[n>>2]|0)>0){o=m+16|0;p=d;q=0;while(1){r=c[o+(da(c[(c[m>>2]|0)+120>>2]|0,q)|0)>>2]|0;RI(2505328)|0;s=vuh(r,2505328)|0;if(!p){if((c[n>>2]|0)==1){r=suh(2651176,k)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[g>>2]=3434528;c[e+0>>2]=c[g+0>>2];if((r|0)==(npf(0,e)|0)){t=s;u=10;break a}}RI(1974640)|0;if(!(a[1974788]|0)){RI(1974640)|0;ouh(1974640)}RI(1974640)|0;r=qL(1974640)|0;FGe(r);v=r}else v=p;r=c[s+8>>2]|0;if(r)uuh(1975928,v,r);r=c[s+12>>2]|0;if(r)uuh(1975928,v,r);r=c[s+16>>2]|0;if(r)uuh(1975928,v,r);q=q+1|0;if((q|0)>=(c[n>>2]|0)){w=v;break}else p=v}}else w=d;k=suh(2651176,k)|0;if(!k){l=w;break}else d=w}if((u|0)==10){RI(1104624)|0;u=ruh(1104624,3)|0;w=c[t+8>>2]|0;Qqh(u,w);d=u+16|0;c[d>>2]=w;w=c[t+12>>2]|0;Qqh(u,w);c[d+(c[(c[u>>2]|0)+120>>2]|0)>>2]=w;w=c[t+16>>2]|0;Qqh(u,w);c[d+(c[(c[u>>2]|0)+120>>2]<<1)>>2]=w;j=u;i=b;return j|0}if(!l){j=0;i=b;return j|0}j=eHe(l)|0;i=b;return j|0}function imf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;if(!d){h=0;i=b;return h|0}j=d;while(1){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[g>>2]=3434528;c[e+0>>2]=c[g+0>>2];if((j|0)==(npf(0,e)|0)){h=0;k=10;break}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;ouh(2540728)}c[f>>2]=3435664;c[e+0>>2]=c[f+0>>2];if(c[(tuh(2658944,j,npf(0,e)|0,0)|0)+12>>2]|0){h=1;k=10;break}j=suh(2651176,j)|0;if(!j){h=0;k=10;break}}if((k|0)==10){i=b;return h|0}return 0}function jmf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,4);Cpf(a,0);c[c[d>>2]>>2]=a;i=b;return}function kmf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function lmf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,4);Dpf(a,1);c[c[d>>2]>>2]=a;i=b;return}function mmf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;c[a+12>>2]=0;return}function nmf(a){a=a|0;return}function omf(a){a=a|0;return}function pmf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;if(!e)f=0;else{RI(1086352)|0;g=ruh(1086352,1)|0;Qqh(g,e);c[g+16>>2]=e;f=g}g=wuh(2656728,Xnf(b)|0,d,308,0,b,f,0,0,0)|0;i=a;return g|0}function qmf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;if(!e)f=0;else{RI(1086352)|0;g=ruh(1086352,1)|0;Qqh(g,e);c[g+16>>2]=e;f=g}g=wuh(2656728,b,d,312,0,0,f,0,0,0)|0;i=a;return g|0}function rmf(a){a=a|0;return}function smf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,2048);Dpf(a,0);c[c[d>>2]>>2]=a;i=b;return}function tmf(a){a=a|0;return}function umf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);c[c[d>>2]>>2]=a;i=b;return}function vmf(a,b){a=a|0;b=b|0;var d=0;d=i;gif(c[a>>2]|0,b,0,1);i=d;return}function wmf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;if(!(D8e(0,c[b>>2]|0,c[d>>2]|0)|0)){e=0;i=a;return e|0}e=D8e(0,c[b+4>>2]|0,c[d+4>>2]|0)|0;i=a;return e|0}function xmf(a,b){a=a|0;b=b|0;var d=0;a=i;if(Phf(0,c[b>>2]|0,0)|0)d=Phf(0,c[b+4>>2]|0,0)|0;else d=0;i=a;return d|0}function ymf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+80|0;b=a+56|0;d=a+32|0;e=a+8|0;f=a+16|0;g=a+64|0;h=a;j=a+24|0;k=a+48|0;l=a+40|0;m=b;c[m>>2]=0;c[m+4>>2]=0;m=d;c[m>>2]=0;c[m+4>>2]=0;m=e;c[m>>2]=0;c[m+4>>2]=0;m=f;c[m>>2]=0;c[m+4>>2]=0;m=g;c[m>>2]=0;c[m+4>>2]=0;m=h;c[m>>2]=0;c[m+4>>2]=0;m=j;c[m>>2]=0;c[m+4>>2]=0;m=k;c[m>>2]=0;c[m+4>>2]=0;m=l;c[m>>2]=0;c[m+4>>2]=0;RI(1135560)|0;m=ruh(1135560,3)|0;quh(2511024,b);n=m+16|0;o=b;b=c[o+4>>2]|0;p=n;c[p>>2]=c[o>>2];c[p+4>>2]=b;quh(2511024,d);b=d;d=c[b+4>>2]|0;p=n+(c[(c[m>>2]|0)+120>>2]|0)|0;c[p>>2]=c[b>>2];c[p+4>>2]=d;quh(2511024,e);d=e;e=c[d+4>>2]|0;p=n+(c[(c[m>>2]|0)+120>>2]<<1)|0;c[p>>2]=c[d>>2];c[p+4>>2]=e;RI(2511528)|0;c[(c[627905]|0)+12>>2]=m;RI(1135560)|0;m=ruh(1135560,3)|0;quh(2511024,f);e=m+16|0;p=f;f=c[p+4>>2]|0;d=e;c[d>>2]=c[p>>2];c[d+4>>2]=f;quh(2511024,g);f=g;g=c[f+4>>2]|0;d=e+(c[(c[m>>2]|0)+120>>2]|0)|0;c[d>>2]=c[f>>2];c[d+4>>2]=g;quh(2511024,h);g=h;h=c[g+4>>2]|0;d=e+(c[(c[m>>2]|0)+120>>2]<<1)|0;c[d>>2]=c[g>>2];c[d+4>>2]=h;RI(2511528)|0;c[(c[627905]|0)+16>>2]=m;RI(1135560)|0;m=ruh(1135560,3)|0;quh(2511024,j);h=m+16|0;d=j;j=c[d+4>>2]|0;g=h;c[g>>2]=c[d>>2];c[g+4>>2]=j;quh(2511024,k);j=k;k=c[j+4>>2]|0;g=h+(c[(c[m>>2]|0)+120>>2]|0)|0;c[g>>2]=c[j>>2];c[g+4>>2]=k;quh(2511024,l);k=l;l=c[k+4>>2]|0;g=h+(c[(c[m>>2]|0)+120>>2]<<1)|0;c[g>>2]=c[k>>2];c[g+4>>2]=l;RI(2511528)|0;c[(c[627905]|0)+20>>2]=m;i=a;return}function zmf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=Im,A=Im,B=Im,C=Im,D=0;b=i;i=i+160|0;f=b+16|0;h=b+72|0;j=b+40|0;k=b+88|0;l=b+8|0;m=b+148|0;n=b+56|0;o=b+112|0;p=b+136|0;q=b;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;r=l;c[r>>2]=0;c[r+4>>2]=0;RI(2455160)|0;if(!(a[2455308]|0)){RI(2455160)|0;ouh(2455160)}yhf(m,0);c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];m=fgf(0)|0;RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;if(c[(c[627905]|0)+24>>2]|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;if((c[(c[(c[627905]|0)+24>>2]|0)+12>>2]|0)!=(m|0))s=9}else s=9;if((s|0)==9){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(1117624)|0;s=ruh(1117624,m)|0;RI(2511528)|0;c[(c[627905]|0)+24>>2]=s}RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;ggf(0,c[(c[627905]|0)+24>>2]|0)|0;s=0;while(1){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;if((s|0)>=(c[(c[(c[627905]|0)+20>>2]|0)+12>>2]|0))break;RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}quh(2511024,l);RI(2511528)|0;m=c[(c[627905]|0)+20>>2]|0;r=m+16+(da(c[(c[m>>2]|0)+120>>2]|0,s)|0)|0;m=l;t=c[m+4>>2]|0;u=r;c[u>>2]=c[m>>2];c[u+4>>2]=t;s=s+1|0}if(!d){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;d=c[(c[627905]|0)+24>>2]|0;s=d+12|0;if((c[s>>2]|0)>0){l=d+16|0;t=(e|0)==0;e=p+8|0;u=0;do{m=c[l+(da(c[(c[d>>2]|0)+120>>2]|0,u)|0)>>2]|0;do if(!(D8e(0,m,0)|0)){if(!t?Phf(0,Yff(m)|0,0)|0:0)break;Xff(n,m);c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];if(Ecf(j,f)|0){r=JSg(m,c[809659]|0)|0;do if(k6e(0,r)|0){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];v=O5e(r,f)|0;w=k6e(0,v)|0;RI(2511528)|0;y=(a[2511676]|0)!=0;if(w){if(!y){RI(2511528)|0;ouh(2511528)}w=$hf(v)|0;RI(2511528)|0;c[(c[(c[627905]|0)+20>>2]|0)+16>>2]=w;RI(2511528)|0;c[(c[(c[627905]|0)+20>>2]|0)+20>>2]=m;break}else{if(!y){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;c[(c[(c[627905]|0)+20>>2]|0)+16>>2]=0;RI(2511528)|0;c[(c[(c[627905]|0)+20>>2]|0)+20>>2]=0;break}}while(0);if(Vff(m)|0){c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];cgf(o,m,f);c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];oef(p,k);z=ea(g[e>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;ouh(2369112)}if(uef(0,ea(0.0),z)|0)A=ea(x);else{B=ea(Sff(m));C=ea(Rff(m));RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;ouh(2369112)}A=ea(S(ea(ea(B-C)/z)))}r=Tff(m)|0;y=(Vff(m)|0)&r;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2];c[f+20>>2]=c[k+20>>2];r=kgf(m,f,A,y)|0;do if(Phf(0,r,0)|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;y=c[(c[627905]|0)+20>>2]|0;c[y+16+(c[(c[y>>2]|0)+120>>2]|0)>>2]=r;RI(2511528)|0;y=c[(c[627905]|0)+20>>2]|0;c[y+16+((c[(c[y>>2]|0)+120>>2]|0)+4)>>2]=m}else{if((bgf(m)|0)!=1?(bgf(m)|0)!=2:0)break;RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;y=c[(c[627905]|0)+20>>2]|0;c[y+16+(c[(c[y>>2]|0)+120>>2]|0)>>2]=0;RI(2511528)|0;y=c[(c[627905]|0)+20>>2]|0;c[y+16+((c[(c[y>>2]|0)+120>>2]|0)+4)>>2]=0}while(0);r=Tff(m)|0;y=(Vff(m)|0)&r;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2];c[f+20>>2]=c[k+20>>2];r=mgf(m,f,A,y)|0;if(Phf(0,r,0)|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;y=c[(c[627905]|0)+20>>2]|0;c[y+16+(c[(c[y>>2]|0)+120>>2]<<1)>>2]=r;RI(2511528)|0;r=c[(c[627905]|0)+20>>2]|0;c[r+16+((c[(c[r>>2]|0)+120>>2]<<1)+4)>>2]=m;break}if((bgf(m)|0)!=1?(bgf(m)|0)!=2:0)break;RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;r=c[(c[627905]|0)+20>>2]|0;c[r+16+(c[(c[r>>2]|0)+120>>2]<<1)>>2]=0;RI(2511528)|0;r=c[(c[627905]|0)+20>>2]|0;c[r+16+((c[(c[r>>2]|0)+120>>2]<<1)+4)>>2]=0}}}while(0);u=u+1|0}while((u|0)<(c[s>>2]|0));D=0}else D=0}else D=0;while(1){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;if((D|0)>=(c[(c[(c[627905]|0)+20>>2]|0)+12>>2]|0))break;RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;s=c[(c[627905]|0)+20>>2]|0;u=s+16+(da(c[(c[s>>2]|0)+120>>2]|0,D)|0)|0;s=c[u+4>>2]|0;k=q;c[k>>2]=c[u>>2];c[k+4>>2]=s;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];Amf(0,D,f);D=D+1|0}i=b;return}function Amf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;b=i;i=i+112|0;f=b+96|0;g=b+88|0;h=b+56|0;j=b+8|0;k=b+64|0;l=b+72|0;m=b+80|0;n=b+48|0;o=b+40|0;p=b+16|0;q=b;r=b+24|0;s=b+32|0;t=h;c[t>>2]=0;c[t+4>>2]=0;bch();RI(2455160)|0;if(!(a[2455308]|0)){RI(2455160)|0;ouh(2455160)}t=xhf(0,0)|0;u=whf(0,0)|0;do if(t){v=e;w=c[v>>2]|0;x=c[v+4>>2]|0;v=j;c[v>>2]=w;c[v+4>>2]=x;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];if(xmf(0,f)|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;v=c[(c[627905]|0)+16>>2]|0;y=v+16+(da(c[(c[v>>2]|0)+120>>2]|0,d)|0)|0;c[y>>2]=w;c[y+4>>2]=x;RI(2511528)|0;x=c[(c[627905]|0)+16>>2]|0;y=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,d)|0)|0;vmf(y,c[880436]|0)}}else{RI(2511528)|0;y=(a[2511676]|0)!=0;if(u){if(!y){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;x=c[(c[627905]|0)+16>>2]|0;w=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,d)|0)|0;x=c[w+4>>2]|0;v=n;c[v>>2]=c[w>>2];c[v+4>>2]=x;c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];if(!(xmf(0,f)|0))break;RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;x=c[(c[627905]|0)+16>>2]|0;v=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,d)|0)|0;vmf(v,c[880442]|0);break}if(!y){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;y=c[(c[627905]|0)+16>>2]|0;v=y+16+(da(c[(c[y>>2]|0)+120>>2]|0,d)|0)|0;y=c[v+4>>2]|0;x=k;c[x>>2]=c[v>>2];c[x+4>>2]=y;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];if(xmf(0,f)|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}y=e;x=c[y+4>>2]|0;v=l;c[v>>2]=c[y>>2];c[v+4>>2]=x;RI(2511528)|0;x=c[(c[627905]|0)+16>>2]|0;v=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,d)|0)|0;x=c[v+4>>2]|0;y=m;c[y>>2]=c[v>>2];c[y+4>>2]=x;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];if(wmf(0,g,f)|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;x=c[(c[627905]|0)+16>>2]|0;y=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,d)|0)|0;vmf(y,c[880438]|0)}RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;y=c[(c[627905]|0)+16>>2]|0;x=y+16+(da(c[(c[y>>2]|0)+120>>2]|0,d)|0)|0;vmf(x,c[880440]|0);quh(2511024,h);RI(2511528)|0;x=c[(c[627905]|0)+16>>2]|0;y=x+16+(da(c[(c[x>>2]|0)+120>>2]|0,d)|0)|0;x=h;v=c[x+4>>2]|0;w=y;c[w>>2]=c[x>>2];c[w+4>>2]=v}}while(0);RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}h=e;m=c[h>>2]|0;l=c[h+4>>2]|0;h=o;c[h>>2]=m;c[h+4>>2]=l;RI(2511528)|0;h=c[(c[627905]|0)+12>>2]|0;k=h+16+(da(c[(c[h>>2]|0)+120>>2]|0,d)|0)|0;h=c[k+4>>2]|0;n=p;c[n>>2]=c[k>>2];c[n+4>>2]=h;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];if(wmf(0,g,f)|0){g=q;c[g>>2]=m;c[g+4>>2]=l;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];if(xmf(0,f)|0)vmf(e,c[880444]|0)}else{RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;q=c[(c[627905]|0)+12>>2]|0;g=q+16+(da(c[(c[q>>2]|0)+120>>2]|0,d)|0)|0;q=c[g+4>>2]|0;p=r;c[p>>2]=c[g>>2];c[p+4>>2]=q;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];if(xmf(0,f)|0){RI(2511528)|0;if(!(a[2511676]|0)){RI(2511528)|0;ouh(2511528)}RI(2511528)|0;r=c[(c[627905]|0)+12>>2]|0;q=r+16+(da(c[(c[r>>2]|0)+120>>2]|0,d)|0)|0;vmf(q,c[880446]|0)}q=s;c[q>>2]=m;c[q+4>>2]=l;c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];if(xmf(0,f)|0){vmf(e,c[880448]|0);vmf(e,c[880450]|0)}}RI(2511528)|0;if(a[2511676]|0){RI(2511528)|0;z=c[627905]|0;A=z+12|0;B=c[A>>2]|0;C=c[B>>2]|0;D=B+16|0;E=C+120|0;F=c[E>>2]|0;G=da(F,d)|0;H=D+G|0;I=H;J=I;c[J>>2]=m;K=I+4|0;L=K;c[L>>2]=l;i=b;return}RI(2511528)|0;ouh(2511528);RI(2511528)|0;z=c[627905]|0;A=z+12|0;B=c[A>>2]|0;C=c[B>>2]|0;D=B+16|0;E=C+120|0;F=c[E>>2]|0;G=da(F,d)|0;H=D+G|0;I=H;J=I;c[J>>2]=m;K=I+4|0;L=K;c[L>>2]=l;i=b;return}function Bmf(a){a=a|0;return}function Cmf(a){a=a|0;return}function Dmf(b){b=b|0;var d=0;b=i;if(!(a[2540708]|0))ouh(2540560);d=c[c[635163]>>2]|0;RI(2512776)|0;c[c[628217]>>2]=d;i=b;return}function Emf(b,d){b=b|0;d=d|0;b=i;RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}RI(2512776)|0;c[c[628217]>>2]=d;i=b;return}function Fmf(b){b=b|0;var c=0,d=0;b=i;RI(2746864)|0;c=qL(2746864)|0;PQf(c,1,1);RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}d=Fqh(2580312,Gmf(0,c)|0)|0;i=b;return d|0}function Gmf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;e=b;c[e>>2]=0;gch();RI(2971904)|0;f=qL(2971904)|0;Ueg(f,255);if((Aqh(2746736,d)|0)>0)g=0;else{h=Fqh(2972072,f)|0;i=b;return h|0}do{j=yuh(2746792,d,g)|0;k=zuh(2746160,j)|0;if((k|0)!=0?(l=suh(2658656,k)|0,(l|0)!=0):0){m=Fqh(2653928,l)|0;if((m|0)!=0?(Vof(m)|0)!=0:0){Hbg(f,m)|0;Hbg(f,c[880816]|0)|0}Hbg(f,Fqh(2649752,l)|0)|0;Hbg(f,c[880818]|0)|0;Hbg(f,Fqh(2649752,k)|0)|0;Hbg(f,c[880820]|0)|0;m=xuh(2849384,k)|0;k=m+12|0;if((c[k>>2]|0)>0){n=m+16|0;o=0;p=1;while(1){if(!p)Hbg(f,c[880822]|0)|0;Hbg(f,Fqh(2649752,suh(2849496,c[n+(da(c[(c[m>>2]|0)+120>>2]|0,o)|0)>>2]|0)|0)|0)|0;o=o+1|0;if((o|0)>=(c[k>>2]|0))break;else p=0}}Hbg(f,c[880824]|0)|0;p=Fqh(2745112,j)|0;do if(p){k=Fqh(2649752,l)|0;if(!(a[2540708]|0))ouh(2540560);if(gpf(0,k,c[880826]|0)|0){k=Fqh(2653928,l)|0;if(!(a[2540708]|0))ouh(2540560);if(gpf(0,k,c[880828]|0)|0)break}Hbg(f,c[880830]|0)|0;RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}RI(2512776)|0;if(Pvf(p,c[c[628217]>>2]|0)|0){RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}RI(2512776)|0;k=Vof(c[c[628217]>>2]|0)|0;o=Vof(p)|0;RI(2512776)|0;q=fpf(p,k,o-(Vof(c[c[628217]>>2]|0)|0)|0)|0}else q=p;Hbg(f,q)|0;Hbg(f,c[880832]|0)|0;c[e>>2]=Aqh(2745936,j)|0;Hbg(f,spf(e)|0)|0;Hbg(f,c[880834]|0)|0}while(0);Hbg(f,c[880836]|0)|0}g=g+1|0}while((g|0)<(Aqh(2746736,d)|0));h=Fqh(2972072,f)|0;i=b;return h|0}function Hmf(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;cch();d=vuh(b,2540560)|0;if((((!(Pvf(d,c[880500]|0)|0)?!(Pvf(d,c[880502]|0)|0):0)?!(Pvf(d,c[880504]|0)|0):0)?!(Pvf(d,c[880506]|0)|0):0)?!(Pvf(d,c[880508]|0)|0):0)e=Pvf(d,c[880510]|0)|0;else e=1;i=a;return e|0}function Imf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=0;c[f>>2]=0;dch();if(!(a[2540708]|0))ouh(2540560);g=c[c[635163]>>2]|0;c[e>>2]=g;c[f>>2]=g;RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}Jmf(0,d,e,f);d=iwf(0,c[e>>2]|0,c[880560]|0,c[f>>2]|0)|0;i=b;return d|0}function Jmf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;ech();if(!d){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[880564]|0);puh(g)}RI(2589312)|0;g=vL(d,2589312)|0;if(!g){RI(2965048)|0;d=qL(2965048)|0;Rbg(d,c[880566]|0);puh(d)}if(!(Fqh(2660280,g)|0))h=512;else h=(Vof(Fqh(2660280,g)|0)|0)<<1;RI(2971904)|0;d=qL(2971904)|0;Ueg(d,h);if(!(a[2540708]|0))ouh(2540560);c[e>>2]=c[c[635163]>>2];h=g;g=c[c[635163]>>2]|0;while(1){j=(Vof(g)|0)==0;k=Fqh(2660280,h)|0;if(j)l=k;else{if(!(a[2540708]|0))ouh(2540560);l=iwf(0,k,c[880568]|0,g)|0}k=Fqh(2649752,suh(2660168,h)|0)|0;if(!(a[2540708]|0))ouh(2540560);j=c[c[635163]>>2]|0;if(!(Fqh(2660392,h)|0))m=j;else m=Fqh(2660392,h)|0;if(!(Vof(jvf(m)|0)|0))n=k;else{if(!(a[2540708]|0))ouh(2540560);n=gwf(0,gwf(0,k,c[880570]|0)|0,m)|0}c[e>>2]=n;if(!(huh(2660224,h)|0))o=l;else{if(!(a[2540708]|0))ouh(2540560);o=jwf(0,c[880572]|0,n,c[880574]|0,l)|0}h=huh(2660224,h)|0;if(!h){p=o;break}else g=o}if(!(a[2540708]|0))ouh(2540560);Hbg(d,gwf(0,p,c[880576]|0)|0)|0;RI(2746864)|0;p=qL(2746864)|0;PQf(p,1,1);RI(2512776)|0;if(a[2512924]|0){q=Gmf(0,p)|0;Hbg(d,q)|0;r=Fqh(2972072,d)|0;c[f>>2]=r;i=b;return}RI(2512776)|0;ouh(2512776);q=Gmf(0,p)|0;Hbg(d,q)|0;r=Fqh(2972072,d)|0;c[f>>2]=r;i=b;return}function Kmf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;fch();if(!e){if(!(a[2540708]|0))ouh(2540560);g=c[c[635163]>>2]|0;i=d;return g|0}RI(1136088)|0;h=ruh(1136088,1)|0;b[h+16>>1]=10;j=dvf(e,h)|0;h=Vof(e)|0;RI(2971904)|0;e=qL(2971904)|0;Ueg(e,h);h=j+12|0;a:do if((c[h>>2]|0)>0){k=j+16|0;l=0;do{m=jvf(c[k+(da(c[(c[j>>2]|0)+120>>2]|0,l)|0)>>2]|0)|0;Qqh(j,m);c[k+(da(c[(c[j>>2]|0)+120>>2]|0,l)|0)>>2]=m;l=l+1|0;m=c[h>>2]|0}while((l|0)<(m|0));n=m;if((n|0)>0){l=j+16|0;k=0;do{m=c[l+(da(c[(c[j>>2]|0)+120>>2]|0,k)|0)>>2]|0;do if(((Vof(m)|0)!=0?(Wof(m,0)|0)<<16>>16!=10:0)?!(Pvf(m,c[880670]|0)|0):0){if(f){if(Pvf(m,c[880672]|0)|0)break a;if((k|0)<((c[h>>2]|0)+-1|0)){RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}if(Hmf(0,m)|0){RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}if(Hmf(0,c[l+(da(c[(c[j>>2]|0)+120>>2]|0,k+1|0)|0)>>2]|0)|0)break;o=Fvf(m,c[880674]|0)|0;if((o|0)!=-1)p=fpf(m,0,o)|0;else p=m}else p=m}else p=m}else p=m;if(((Fvf(p,c[880676]|0)|0)==-1?(Fvf(p,c[880678]|0)|0)==-1:0)?(Fvf(p,c[880680]|0)|0)==-1:0){if((f?Pvf(p,c[880682]|0)|0:0)?xvf(p,c[880684]|0)|0:0)break;if(Pvf(p,c[880686]|0)|0)q=Uvf(p,0,3)|0;else q=p;o=Fvf(q,c[880688]|0)|0;if((o|0)!=-1?(r=Gvf(q,c[880690]|0,o)|0,(r|0)>(o|0)):0)s=Uvf(q,o,1-o+r|0)|0;else s=q;if(!(a[2540708]|0))ouh(2540560);r=Rvf(s,c[880692]|0,c[c[635163]>>2]|0)|0;RI(2512776)|0;if(!(a[2512924]|0)){RI(2512776)|0;ouh(2512776)}RI(2512776)|0;o=Qvf(Rvf(r,c[c[628217]>>2]|0,c[c[635163]>>2]|0)|0,92,47)|0;r=Mvf(o,c[880694]|0)|0;if((r|0)==-1)t=o;else{u=Uvf(o,r,5)|0;o=mwf(u,r,c[880696]|0)|0;r=Vof(o)|0;t=mwf(o,r,c[880698]|0)|0}if(!(a[2540708]|0))ouh(2540560);Hbg(e,gwf(0,t,c[880700]|0)|0)|0}}while(0);k=k+1|0}while((k|0)<(c[h>>2]|0))}}while(0);g=Fqh(2972072,e)|0;i=d;return g|0}function Lmf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2977872)|0;tcg(a);c[c[d>>2]>>2]=a;i=b;return}function Mmf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2977872)|0;tcg(a);c[c[d>>2]>>2]=a;i=b;return}function Nmf(a){a=a|0;var b=0;b=i;hch();Vxf(a,c[880858]|0);KHf(a,-2147467261);i=b;return}function Omf(a,b){a=a|0;b=b|0;var c=0;c=i;Vxf(a,b);KHf(a,-2147467261);i=c;return}function Pmf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GHf(a,b,c);KHf(a,-2147467261);i=d;return}function Qmf(a){a=a|0;return}function Rmf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,4);Dpf(a,0);c[c[d>>2]>>2]=a;i=b;return}function Smf(a){a=a|0;var b=0;b=i;b4e(a);i=b;return}function Tmf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Umf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Vmf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Wmf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Xmf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Ymf(a,b,c){a=a|0;b=b|0;c=c|0;return}function Zmf(a,b,c){a=a|0;b=b|0;c=c|0;return}function _mf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;RI(2377032)|0;if(!(a[2377180]|0)){RI(2377032)|0;ouh(2377032)}RI(2377032)|0;f=qL(2377032)|0;eaf(f);c[b+20>>2]=f;RI(2369632)|0;if(!(a[2369780]|0)){RI(2369632)|0;ouh(2369632)}c[b+24>>2]=$6e(0)|0;$7e(e,0);f=e;e=c[f+4>>2]|0;g=b+48|0;c[g>>2]=c[f>>2];c[g+4>>2]=e;c[b+88>>2]=-1;i=d;return}function $mf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+32|0;e=a+16|0;f=a+12|0;g=a+8|0;h=a+4|0;j=a;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];mcf(f,0,e);b=c[f>>2]|0;c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];mcf(g,0,e);e=c[g>>2]|0;c[h>>2]=b;RI(2418752)|0;b=pL(2418752,h)|0;c[j>>2]=e;RI(2418752)|0;e=nrh(2538040,b,pL(2418752,j)|0)|0;i=a;return e|0}function anf(b,c,d){b=b|0;c=c|0;d=d|0;var e=Im,f=Im,h=0;b=i;e=ea(g[c>>2]);f=ea(g[d>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;ouh(2369112)}if(!(uef(0,e,f)|0)){h=0;i=b;return h|0}f=ea(g[c+4>>2]);e=ea(g[d+4>>2]);RI(2369112)|0;if(!(a[2369260]|0)){RI(2369112)|0;ouh(2369112)}h=uef(0,f,e)|0;i=b;return h|0}function bnf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(2486560)|0;d=cnf(0,vL(b,2486560)|0,a)|0;i=c;return d|0}function cnf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+32|0;e=a+4|0;f=a+16|0;g=a+8|0;h=a+20|0;j=a+28|0;k=a;l=a+12|0;m=a+24|0;n=(d|0)!=0;o=(b|0)!=0;if(!(n|o)){p=1;i=a;return p|0}if(!n){c[g>>2]=c[b+8>>2];RI(2604248)|0;c[h>>2]=c[c[651085]>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];p=FAf(0,f,e)|0;i=a;return p|0}h=c[d+8>>2]|0;if(o){c[l>>2]=c[b+8>>2];c[m>>2]=h;c[f+0>>2]=c[l+0>>2];c[e+0>>2]=c[m+0>>2];p=FAf(0,f,e)|0;i=a;return p|0}else{c[j>>2]=h;RI(2604248)|0;c[k>>2]=c[c[651085]>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];p=FAf(0,f,e)|0;i=a;return p|0}return 0}function dnf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=KAf(0,d)|0;i=b;return e|0}function enf(a,b){a=a|0;b=b|0;c[b>>2]=c[a+8>>2];return}function fnf(a,b){a=a|0;b=b|0;c[b+8>>2]=c[a>>2];return}function gnf(a){a=a|0;return}function hnf(b){b=b|0;var d=0,e=0;d=i;RI(2047920)|0;if(!(a[2048068]|0)){RI(2047920)|0;ouh(2047920)}RI(2047920)|0;e=qL(2047920)|0;FGe(e);c[b+8>>2]=e;i=d;return}function inf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2522856)|0;c[a+8>>2]=sM(2523024)|0;c[c[d>>2]>>2]=a;a=qL(2378888)|0;o8e(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function jnf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function knf(b){b=b|0;var d=0,e=0;d=i;RI(2056600)|0;if(!(a[2056748]|0)){RI(2056600)|0;ouh(2056600)}RI(2056600)|0;e=qL(2056600)|0;FGe(e);c[b+8>>2]=e;RI(2056600)|0;e=qL(2056600)|0;FGe(e);c[b+12>>2]=e;RI(2056600)|0;e=qL(2056600)|0;FGe(e);c[b+16>>2]=e;i=d;return}function lnf(a){a=a|0;var b=0;b=i;eth(2058016,c[a+8>>2]|0);i=b;return}function mnf(b){b=b|0;var d=0,e=0;d=i;a[b+20>>0]=1;RI(2523128)|0;e=qL(2523128)|0;knf(e);c[b+8>>2]=e;RI(2522592)|0;e=qL(2522592)|0;hnf(e);c[b+12>>2]=e;c[b+16>>2]=Fqh(2652904,Xnf(b)|0)|0;i=d;return}function nnf(a){a=a|0;return}function onf(a){a=a|0;var b=0;b=i;pnf(a);c[a+16>>2]=Fqh(2652904,Xnf(a)|0)|0;i=b;return}function pnf(b){b=b|0;var d=0;d=i;lnf(c[b+8>>2]|0);a[b+20>>0]=1;i=d;return}function qnf(b){b=b|0;var d=0,e=0,f=0;d=i;ich();e=Znf(b)|0;f=Fqh(2537592,Xnf(b)|0)|0;if(!(a[2540708]|0))ouh(2540560);b=iwf(0,e,c[880878]|0,f)|0;i=d;return b|0}function rnf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;o8e(a);c[c[d>>2]>>2]=a;a=qL(2522856)|0;c[a+8>>2]=sM(2524376)|0;c[(c[d>>2]|0)+4>>2]=a;i=b;return}function snf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2378888)|0;o8e(a);c[c[d>>2]>>2]=a;i=b;return}function tnf(a){a=a|0;var b=0;b=i;RI(1086352)|0;c[a+24>>2]=ruh(1086352,0)|0;mnf(a);i=b;return}function unf(a){a=a|0;var b=0;b=i;uhf(a);i=b;return}function vnf(a){a=a|0;return}function wnf(a){a=a|0;return}function xnf(a,b){a=a|0;b=b|0;return}function ynf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2506664)|0;c[a+8>>2]=sM(3653512)|0;c[a+12>>2]=0;c[c[d>>2]>>2]=a;i=b;return}function znf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Anf(a){a=a|0;return c[a+8>>2]|0}function Bnf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2528312)|0;e=vL(b,2528312)|0;if(!e){f=0;i=d;return f|0}b=c[a+8>>2]|0;a=c[e+8>>2]|0;if(!b){f=(a|0)==0;i=d;return f|0}else{f=nrh(2536048,b,a)|0;i=d;return f|0}return 0}function Cnf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(!d){e=oof(a)|0;i=b;return e|0}else{e=Aqh(2536720,d)|0;i=b;return e|0}return 0}function Dnf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,18432);c[c[d>>2]>>2]=a;i=b;return}function Enf(a){a=a|0;return}function Fnf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,64);c[c[d>>2]>>2]=a;i=b;return}function Gnf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,256);Dpf(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;i=b;return}function Hnf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;RI(2529488)|0;c[a+8>>2]=Fqh(2613712,pL(2529488,e)|0)|0;i=d;return}function Inf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Jnf(a){a=a|0;return c[a+8>>2]|0}function Knf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,64);c[c[d>>2]>>2]=a;i=b;return}function Lnf(a){a=a|0;var b=0;b=i;lQf(a);i=b;return}function Mnf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3088720)|0;b=qL(3088720)|0;Nsg(b,c);Auh(b);return 0}function Nnf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3088720)|0;b=qL(3088720)|0;Nsg(b,c);Auh(b);return 0}function Onf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3088720)|0;b=qL(3088720)|0;Nsg(b,c);Auh(b);return 0}function Pnf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RI(3088720)|0;d=qL(3088720)|0;Nsg(d,e);Auh(d);return 0}function Qnf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3088720)|0;b=qL(3088720)|0;Nsg(b,c);Auh(b);return 0}function Rnf(a){a=a|0;return}function Snf(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function Tnf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if((b|0)!=(c|0))if((b|0)!=0&(c|0)!=0)d=nrh(2536048,b,c)|0;else d=0;else d=1;i=a;return d|0}function Unf(a){a=a|0;return}function Vnf(a){a=a|0;var b=0,c=0;b=i;c=Wnf(0,a)|0;i=b;return c|0}function Wnf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[634062]|0;if(!d){e=MK(2536256)|0;c[634062]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Xnf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[634026]|0;if(!d){e=MK(2536112)|0;c[634026]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Ynf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[634036]|0;if(!d){e=MK(2536152)|0;c[634036]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Znf(a){a=a|0;var b=0,c=0;b=i;c=Fqh(2536192,Xnf(a)|0)|0;i=b;return c|0}function _nf(a,b,c){a=a|0;b=b|0;c=c|0;return (b|0)==(c|0)|0}function $nf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2819056)|0;OXf(b,2);c[(c[e>>2]|0)+4>>2]=b;i=d;return}function aof(b,c){b=b|0;c=c|0;a[b+8>>0]=c&1;return}function bof(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function cof(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function dof(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function eof(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[634356]|0;if(!f){g=MK(2537432)|0;c[634356]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function fof(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;e=a;c[e>>2]=0;if(!d){f=0;i=a;return f|0}g=eof(0,b,d,e)|0;d=c[e>>2]|0;if(!d){f=g;i=a;return f|0}if((c[d+12>>2]|0)>0){h=d;j=0}else{f=1;i=a;return f|0}while(1){d=h+16|0;g=c[(c[h>>2]|0)+120>>2]|0;b=c[d+(da(g,j)|0)>>2]|0;k=c[d+(da(g,j|1)|0)>>2]|0;if(!b)if(!k)l=h;else{f=0;m=9;break}else{if(!(nrh(2536048,b,k)|0)){f=0;m=9;break}l=c[e>>2]|0}j=j+2|0;if((j|0)>=(c[l+12>>2]|0)){f=1;m=9;break}else h=l}if((m|0)==9){i=a;return f|0}return 0}function gof(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=fof(0,a,b)|0;i=c;return d|0}function hof(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[634378]|0;if(!e){f=MK(2537520)|0;c[634378]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function iof(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;c[d>>2]=0;e=hof(0,a,d)|0;a=c[d>>2]|0;if(!a){f=e;i=b;return f|0}if((c[a+12>>2]|0)>0){g=a;h=e;j=0}else{f=e;i=b;return f|0}while(1){e=c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,j)|0)>>2]|0;if(!e){k=g;l=h}else{a=(Aqh(2536720,e)|0)^h;k=c[d>>2]|0;l=a}j=j+1|0;if((j|0)>=(c[k+12>>2]|0)){f=l;break}else{g=k;h=l}}i=b;return f|0}function jof(a){a=a|0;var b=0,c=0;b=i;c=Fqh(2537592,Xnf(a)|0)|0;i=b;return c|0}function kof(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function lof(a){a=a|0;return}function mof(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=nof(0,b,c,1)|0;i=a;return d|0}function nof(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Buh(3090792)}f=ftg(0,c,d,e)|0;i=b;return f|0}function oof(a){a=a|0;var b=0,c=0;b=i;c=Wnf(0,a)|0;i=b;return c|0}function pof(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=qof(0,b,c,1)|0;i=a;return d|0}function qof(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=i;if(Cuh(2886704,b,c,d)|0){e=1;i=a;return e|0}e=sof(0,Duh(2886544,b)|0,c,d)|0;i=a;return e|0}function rof(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=sof(0,b,c,1)|0;i=a;return d|0}function sof(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;b=i;Bdh();switch(Aqh(2538376,d)|0){case 128:case 32:case 8:case 4:case 2:case 1:{g=Cuh(2538432,d,e,f)|0;i=b;return g|0}case 16:{RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Buh(3090792)}g=ktg(0,d,e,f)|0;i=b;return g|0}default:{g=c[883336]|0;RI(3100472)|0;b=qL(3100472)|0;pug(b,g);Auh(b)}}return 0}function tof(a,b){a=a|0;b=b|0;return b|0}function uof(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)!=0?(RI(2538488)|0,(vL(b,2538488)|0)!=0):0)d=fof(0,a,b)|0;else d=0;i=c;return d|0}function vof(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2819224)|0;RI(2539368)|0;PXf(b,ML(c[634858]|0)|0);c[(c[e>>2]|0)+4>>2]=b;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=32767;c[(c[e>>2]|0)+8>>2]=b;b=qL(2819056)|0;OXf(b,0);c[(c[e>>2]|0)+12>>2]=b;i=d;return}function wof(b,d){b=b|0;d=d|0;a[b+13>>0]=1;c[b+8>>2]=d;return}function xof(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2911064)|0;RI(2538488)|0;Y5f(b,ML(c[634638]|0)|0);c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+8>>2]=b;b=qL(2898616)|0;B5f(b,1);c[(c[e>>2]|0)+12>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2540144)|0;c[(c[e>>2]|0)+16>>2]=b;i=d;return}function yof(b,c){b=b|0;c=c|0;a[b+8>>0]=c&1;return}function zof(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Aof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=kjg(0,c[b>>2]|0)|0;i=d;return e|0}function Bof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=yjg(0,c[b>>2]|0)|0;i=d;return e|0}function Cof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Ijg(0,c[b>>2]|0)|0;i=d;return e|0}function Dof(b,d,e){b=b|0;d=d|0;e=e|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Vjg(b,0,c[d>>2]|0)}function Eof(b,d,e){b=b|0;d=d|0;e=e|0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}fkg(b,0,c[d>>2]|0);i=e;return}function Fof(b,d){b=b|0;d=d|0;var e=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=+tkg(0,c[b>>2]|0);i=d;return +e}function Gof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Ikg(0,c[b>>2]|0)|0;i=d;return e|0}function Hof(a,b){a=a|0;b=b|0;return c[a>>2]|0}function Iof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=jlg(0,c[b>>2]|0)|0;i=d;return e|0}function Jof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=zlg(0,c[b>>2]|0)|0;i=d;return e|0}function Kof(b,d){b=b|0;d=d|0;var e=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ea(Mlg(0,c[b>>2]|0));i=d;return ea(e)}function Lof(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Cdh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883376]|0);Auh(h)}c[g>>2]=c[b>>2];RI(2540224)|0;b=pL(2540224,g)|0;RI(3034288)|0;if(a[3034436]|0){j=Lmg(0,b,d,e,0)|0;i=f;return j|0}RI(3034288)|0;Buh(3034288);j=Lmg(0,b,d,e,0)|0;i=f;return j|0}function Mof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=$lg(0,c[b>>2]|0)|0;i=d;return e|0}function Nof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=nmg(0,c[b>>2]|0)|0;i=d;return e|0}function Oof(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Bmg(0,c[b>>2]|0)|0;i=d;return e|0}function Pof(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Ddh();if(!b){e=1;i=d;return e|0}RI(2540224)|0;if(!(vL(b,2540224)|0)){f=c[883386]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}RI(2540224)|0;g=c[(Euh(b,2540224)|0)>>2]|0;b=c[a>>2]|0;if((b|0)==(g|0)){e=0;i=d;return e|0}e=(b|0)>(g|0)?1:-1;i=d;return e|0}function Qof(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2540224)|0;if(!(vL(b,2540224)|0)){e=0;i=d;return e|0}RI(2540224)|0;f=c[(Euh(b,2540224)|0)>>2]|0;e=(f|0)==(c[a>>2]|0);i=d;return e|0}function Rof(a){a=a|0;return c[a>>2]|0}function Sof(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a>>2]|0;if((d|0)==(b|0))e=0;else e=(d|0)>(b|0)?1:-1;return e|0}function Tof(a,b){a=a|0;b=b|0;return (c[a>>2]|0)==(b|0)|0}function Uof(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;h=c[e+8>>2]|0;if((h|0)>(f|0))j=f;else{k=1;i=b;return k|0}while(1){f=Wof(e,j)|0;if(f<<16>>16){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(Xof(0,f)|0))break}j=j+1|0;if((j|0)>=(h|0)){k=1;l=9;break}}if((l|0)==9){i=b;return k|0}if(d){k=0;i=b;return k|0}c[g>>2]=Yof(0)|0;k=0;i=b;return k|0}function Vof(a){a=a|0;return c[a+8>>2]|0}function Wof(a,d){a=a|0;d=d|0;var e=0;e=i;if((d|0)>=0?(c[a+8>>2]|0)>(d|0):0){i=e;return b[a+12+(d<<1)>>1]|0}RI(3084024)|0;d=qL(3084024)|0;hsg(d);Auh(d);return 0}function Xof(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;e=a[(c[(c[635121]|0)+4>>2]|0)+(d&65535)>>0]|0;if((e&255)<=10){f=0;i=b;return f|0}if((e&255)>13){i=b;return (d+-9<<16>>16&65535)<5|d<<16>>16==133|d<<16>>16==8287|0}else{f=1;i=b;return f|0}return 0}function Yof(a){a=a|0;var b=0;a=i;Hdh();RI(3079480)|0;b=qL(3079480)|0;Hrg(b,c[883504]|0);i=a;return b|0}function Zof(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;Edh();c[f>>2]=0;c[g>>2]=0;if(!d){if(e){h=0;i=b;return h|0}RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[883404]|0);c[g>>2]=j;h=0;i=b;return h|0}j=c[d+8>>2]|0;a:do if((j|0)>0){k=0;while(1){l=Wof(d,k)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}m=k+1|0;if(!(Xof(0,l)|0)){n=k;break a}if((m|0)<(j|0))k=m;else{n=m;break}}}else n=0;while(0);if((n|0)==(j|0)){if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}k=Wof(d,n)|0;if(k<<16>>16==45){o=n+1|0;p=-1}else if(k<<16>>16==43){o=n+1|0;p=1}else{o=n;p=1}b:do if((o|0)<(j|0)){n=0;k=o;m=0;c:while(1){l=Wof(d,k)|0;do if(!(l<<16>>16)){q=n;r=j;s=m}else{if((l+-48<<16>>16&65535)>9)if(Uof(0,e,d,k,g)|0){q=n;r=k;s=m;break}else{h=0;t=33;break c}u=(l&65535)+208|0;if((n|0)>=214748365)break c;if((n|0)==214748364){v=u;w=k;t=19;break c}q=(u&255)+(n*10|0)|0;r=k;s=1}while(0);k=r+1|0;if((k|0)>=(j|0)){t=27;break}else{n=q;m=s}}do if((t|0)==19){m=v&255;if(m>>>0>=8?!((p|0)!=1&m>>>0<9):0)break;if(Uof(0,e,d,w+1|0,g)|0){c[f>>2]=(p|0)==-1?-2147483640-m|0:m+2147483640|0;h=1;i=b;return h|0}}else if((t|0)==27){if(!s)break b;c[f>>2]=(p|0)==-1?0-q|0:q;h=1;i=b;return h|0}else if((t|0)==33){i=b;return h|0}while(0);if(e){h=0;i=b;return h|0}RI(3086272)|0;m=qL(3086272)|0;xsg(m,c[883406]|0);c[g>>2]=m;h=0;i=b;return h|0}while(0);if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}function _of(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=$of(0,b,7,c)|0;i=a;return d|0}function $of(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;i=i+16|0;f=a+4|0;g=a;c[f>>2]=0;c[g>>2]=0;if(mpf(0,b,d,e,0,g,f)|0){i=a;return c[g>>2]|0}else Auh(c[f>>2]|0);return 0}function apf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;Fdh();if(!(b&512)){f=(b|0)<512;if(f|d){g=f;i=a;return g|0}RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[883424]|0);c[e>>2]=f;g=0;i=a;return g|0}else{f=(b&1|512)^b;h=(((b&2|0)==0?f:f^2)|0)==0;if(h|d){g=h;i=a;return g|0}RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[883422]|0);c[e>>2]=h;g=0;i=a;return g|0}return 0}function bpf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;b=i;j=e+8|0;k=c[d>>2]|0;a:do if((k|0)<(c[j>>2]|0)){l=k;do{m=Wof(e,l)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(Xof(0,m)|0))break a;l=(c[d>>2]|0)+1|0;c[d>>2]=l}while((l|0)<(c[j>>2]|0))}while(0);if(!f){n=1;i=b;return n|0}f=(c[d>>2]|0)<(c[j>>2]|0);if(f|g){n=f;i=b;return n|0}c[h>>2]=Yof(0)|0;n=0;i=b;return n|0}function cpf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;j=c[(VTf(f)|0)+8>>2]|0;k=e+8|0;if(((c[d>>2]|0)+j|0)<=(c[k>>2]|0)?(j=VTf(f)|0,l=c[(VTf(f)|0)+8>>2]|0,m=dpf(e,j,c[d>>2]|0,l)|0,(m|0)==(c[d>>2]|0)):0){a[h>>0]=1;a[g>>0]=1;m=c[(VTf(f)|0)+8>>2]|0;c[d>>2]=(c[d>>2]|0)+m;i=b;return}m=c[(iUf(f)|0)+8>>2]|0;if(((c[d>>2]|0)+m|0)>=(c[k>>2]|0)){i=b;return}k=iUf(f)|0;m=c[(iUf(f)|0)+8>>2]|0;l=dpf(e,k,c[d>>2]|0,m)|0;if((l|0)!=(c[d>>2]|0)){i=b;return}a[h>>0]=0;h=c[(iUf(f)|0)+8>>2]|0;c[d>>2]=(c[d>>2]|0)+h;a[g>>0]=1;i=b;return}function dpf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;weh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[884324]|0);Auh(h)}if((e|0)<0){RI(2964880)|0;j=qL(2964880)|0;k=c[884326]|0;l=c[884328]|0;Qag(j,k,l);Auh(j)}h=c[b+8>>2]|0;if((h|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;k=c[884326]|0;l=c[884328]|0;Qag(j,k,l);Auh(j)}if((f|0)<0|(h-f|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[884330]|0,c[884332]|0);Auh(j)}if(!(c[d+8>>2]|0)){m=e;i=g;return m|0}if(!e){if((h|0)==0|(f|0)==0){m=-1;i=g;return m|0}}else if(!f){m=-1;i=g;return m|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}m=Guh(2754056,Fuh(2723944,eKf(0)|0)|0,b,d,e,f)|0;i=g;return m|0}function epf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;h=c[(QTf(f)|0)+8>>2]|0;if(((c[d>>2]|0)+h|0)>(c[e+8>>2]|0)){i=b;return}h=c[(QTf(f)|0)+8>>2]|0;j=fpf(e,c[d>>2]|0,h)|0;h=QTf(f)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,j,h)|0)){i=b;return}a[g>>0]=1;g=c[(QTf(f)|0)+8>>2]|0;c[d>>2]=(c[d>>2]|0)+g;i=b;return}function fpf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;peh();if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;Qag(f,c[884172]|0,c[884174]|0);Auh(f)}if((b|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;Qag(f,c[884176]|0,c[884178]|0);Auh(f)}f=c[a+8>>2]|0;if((f|0)<(b|0)){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884180]|0,c[884182]|0);Auh(g)}if((f-d|0)<(b|0)){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884184]|0,c[884186]|0);Auh(g)}if((b|0)==0&(f|0)==(d|0)){h=a;i=e;return h|0}h=hvf(a,b,d)|0;i=e;return h|0}function gpf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;if(!(a[2540708]|0))Buh(2540560);e=Yuf(0,c,d)|0;i=b;return e|0}function hpf(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;Gdh();c[g>>2]=0;RI(1136088)|0;k=Huh(1136088,2)|0;l=k+16|0;b[l>>1]=101;b[l+(c[(c[k>>2]|0)+120>>2]|0)>>1]=69;l=ipf(f,k,c[e>>2]|0)|0;if((l|0)<=-1){c[j>>2]=0;m=0;i=d;return m|0}k=l+1|0;n=f+8|0;if((k|0)==(c[n>>2]|0)){if(h)o=0;else o=Yof(0)|0;c[j>>2]=o;m=1;i=d;return m|0}if((Wof(f,k)|0)<<16>>16==45){if(h)p=0;else{RI(3086272)|0;o=qL(3086272)|0;xsg(o,c[883482]|0);p=o}c[j>>2]=p;m=1;i=d;return m|0}if((Wof(f,k)|0)<<16>>16==43){p=l+2|0;l=c[n>>2]|0;if((p|0)==(l|0)){if(h)q=0;else q=Yof(0)|0;c[j>>2]=q;m=1;i=d;return m|0}else{r=l;s=p}}else{r=c[n>>2]|0;s=k}a:do if((s|0)<(r|0)){k=0;p=0;l=s;while(1){q=Wof(f,l)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(jpf(0,q)|0)){t=20;break}q=Wof(f,l)|0;o=gFi(k|0,p|0,10,0)|0;u=ZEi(o|0,H|0,(q&65535)+65488&65535|0,0)|0;q=H;o=_Ei(u|0,q|0,-2147483648,0)|0;v=H;w=l+1|0;if(!(v>>>0<1|(v|0)==1&o>>>0<0)){t=24;break}if((w|0)<(c[n>>2]|0)){k=u;p=q;l=w}else{x=u;y=q;z=w;break a}}if((t|0)==20){if(h)A=0;else A=Yof(0)|0;c[j>>2]=A;m=1;i=d;return m|0}else if((t|0)==24){if(h)B=0;else{RI(3086272)|0;l=qL(3086272)|0;xsg(l,c[883484]|0);B=l}c[j>>2]=B;m=1;i=d;return m|0}}else{x=0;y=0;z=s}while(0);s=ZEi(0,0,x|0,y|0)|0;c[j>>2]=0;c[g>>2]=s;c[e>>2]=z;m=1;i=d;return m|0}function ipf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!b){RI(2963920)|0;f=qL(2963920)|0;Ucg(f);Auh(f)}if((d|0)>=0?(f=c[a+8>>2]|0,(f|0)>=(d|0)):0){g=zvf(a,b,d,f-d|0)|0;i=e;return g|0}RI(2964880)|0;g=qL(2964880)|0;_eg(g);Auh(g);return 0}function jpf(b,d){b=b|0;d=d|0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;i=b;return (a[(c[(c[635121]|0)+4>>2]|0)+(d&65535)>>0]|0)==8|0}function kpf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;g=f+8|0;h=c[g>>2]|0;j=c[d>>2]|0;if((j+h|0)>(c[e+8>>2]|0)){k=0;i=b;return k|0}l=fpf(e,j,h)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,l,f)|0)){k=0;i=b;return k|0}c[d>>2]=(c[d>>2]|0)+(c[g>>2]|0);k=1;i=b;return k|0}function lpf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=i;RI(2540392)|0;e=(a[2540540]|0)!=0;if(!d){if(!e){RI(2540392)|0;Buh(2540392)}f=jpf(0,c)|0;i=b;return f|0}if(!e){RI(2540392)|0;Buh(2540392)}if(jpf(0,c)|0|(c+-65<<16>>16&65535)<6){f=1;i=b;return f|0}else{i=b;return (c+-97<<16>>16&65535)<6|0}return 0}function mpf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0.0;b=i;i=i+32|0;k=b+8|0;l=b+12|0;m=b+17|0;n=b+18|0;o=b+16|0;p=b;q=b+4|0;c[l>>2]=0;a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;c[p>>2]=0;Idh();c[h>>2]=0;c[j>>2]=0;if(!d){if(g){r=0;i=b;return r|0}RI(2963920)|0;s=qL(2963920)|0;Ucg(s);c[j>>2]=s;r=0;i=b;return r|0}s=d+8|0;if(!(c[s>>2]|0)){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}if(f){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[q>>2]=3439976;c[k+0>>2]=c[q+0>>2];q=Iuh(3083928,f,npf(0,k)|0)|0;RI(2755888)|0;k=Juh(q,2755888)|0;if(k)t=k;else u=11}else u=11;if((u|0)==11){RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;Buh(3013496)}t=Kuh(2756224,lzg(0,jhg(0)|0)|0)|0}if(!(apf(0,e,g,j)|0)){r=0;i=b;return r|0}k=e>>>8;q=(e&512|0)!=0;f=(e&64|0)==0;v=(e&32|0)==0;w=(e&16|0)==0;x=(e&8|0)!=0;y=(e&4|0)!=0;z=e>>>1;A=(e&1|0)!=0;B=(e&128|0)==0;c[l>>2]=0;if(A?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;if(!w?(w=c[l>>2]|0,(Wof(d,w)|0)<<16>>16==40):0){a[n>>0]=1;a[m>>0]=1;e=w+1|0;c[l>>2]=e;do if(A)if(bpf(0,l,d,1,g,j)|0){r=0;i=b;return r|0}else{C=c[l>>2]|0;break}else C=e;while(0);e=fpf(d,C,c[(VTf(t)|0)+8>>2]|0)|0;w=VTf(t)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,e,w)|0){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}w=fpf(d,C,c[(iUf(t)|0)+8>>2]|0)|0;C=iUf(t)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,w,C)|0){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}else{D=0;E=1;F=1}}else if(y?(cpf(0,l,d,t,n,m),C=a[n>>0]|0,C<<24>>24!=0):0){if(A?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(k&1){epf(0,l,d,t,o);w=a[o>>0]|0;if(!(w<<24>>24==0|A^1)?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}else{D=w;E=C;F=0}}else{D=0;E=C;F=0}}else{D=0;E=0;F=0}C=(k&1|0)!=0;if(C&D<<24>>24==0){epf(0,l,d,t,o);k=a[o>>0]|0;if(k<<24>>24){if(A?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(!(E<<24>>24!=0|y^1)){cpf(0,l,d,t,n,m);y=a[n>>0]|0;if(!(y<<24>>24==0|A^1)?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}else{G=y;I=k}}else{G=E;I=k}}else{G=E;I=0}}else{G=E;I=D}c[p>>2]=0;D=c[l>>2]|0;E=0;k=0;y=0;a:while(1){do if(lpf(0,Wof(d,D)|0,q)|0){A=k+1|0;if(!q){if(y){c[l>>2]=D+1;if((Wof(d,D)|0)<<16>>16==48){J=E;K=A;L=1;break}else{u=70;break a}}if((D|0)==2147483647){u=73;break a}c[l>>2]=D+1;J=(E*10|0)-(((Wof(d,D)|0)&65535)+65488&65535)|0;K=A;L=0;break}c[l>>2]=D+1;w=Wof(d,D)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}do if(!(jpf(0,w)|0)){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}e=w&65535;if(opf(0,w)|0){M=(e+65439&65535)+10|0;break}else{M=(e+65471&65535)+10|0;break}}else M=(w&65535)+65488&65535;while(0);if(g){if(E>>>0>268435455){r=0;u=120;break a}J=M+(E<<4)|0;K=A;L=y;break}else{w=E<<4;e=_Ei(M|0,0,w|0,((w|0)<0)<<31>>31|0)|0;N=H;if((N|0)>0|(N|0)==0&e>>>0>2147483647){u=66;break a}J=M+w|0;K=A;L=y;break}}else{if(!f?kpf(0,l,d,YTf(t)|0)|0:0){J=E;K=k;L=y;break}if(y|v){O=E;P=k;u=76;break a}if(kpf(0,l,d,XTf(t)|0)|0){J=E;K=k;L=1}else{O=E;P=k;u=76;break a}}while(0);D=c[l>>2]|0;if((D|0)>=(c[s>>2]|0)){O=J;P=K;u=76;break}else{E=J;k=K;y=L}}if((u|0)==66)Auh(PJ(3068960)|0);else if((u|0)==70){if(g){r=0;i=b;return r|0}RI(3086272)|0;L=qL(3086272)|0;xsg(L,c[883530]|0);c[j>>2]=L;r=0;i=b;return r|0}else if((u|0)==73)FJ(PJ(3068960)|0);else if((u|0)==76){if(!P){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}if((!B?hpf(0,l,d,p,g,j)|0:0)?(c[j>>2]|0)!=0:0){r=0;i=b;return r|0}if(x&G<<24>>24==0){cpf(0,l,d,t,n,m);B=a[n>>0]|0;if(B<<24>>24){if((z&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(C){epf(0,l,d,t,o);Q=a[o>>0]|0;R=B;u=88}}else{Q=I;R=0;u=88}}else{Q=I;R=G;u=88}if(((u|0)==88?C&Q<<24>>24==0:0)?(epf(0,l,d,t,o),(a[o>>0]|0)!=0):0){if((z&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(!(R<<24>>24!=0|x^1))cpf(0,l,d,t,n,m)}n=(z&1|0)!=0;if((n?(c[l>>2]|0)<(c[s>>2]|0):0)?!(bpf(0,l,d,0,g,j)|0):0){r=0;i=b;return r|0}do if(F){z=c[l>>2]|0;if((z|0)<(c[s>>2]|0)?(t=z+1|0,c[l>>2]=t,(Wof(d,z)|0)<<16>>16==41):0){if(!n)break;if((t|0)>=(c[s>>2]|0))break;if(bpf(0,l,d,0,g,j)|0)break;else r=0;i=b;return r|0}if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}while(0);n=c[l>>2]|0;if((n|0)<(c[s>>2]|0)?(Wof(d,n)|0)<<16>>16!=0:0){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}do if(!((a[m>>0]|0)!=0|q)){if(!g){S=0-O|0;break}if((O|0)==-2147483648){r=0;i=b;return r|0}else{S=0-O|0;break}}else S=O;while(0);O=c[p>>2]|0;do if((O|0)<1)T=S;else{V=+(S|0)*+U(10.0,+(+(O|0)));if(!(V<-2147483648.0)&V<=2147483647.0){T=~~V;break}if(g){r=0;i=b;return r|0}RI(3086272)|0;p=qL(3086272)|0;xsg(p,c[883534]|0);c[j>>2]=p;r=0;i=b;return r|0}while(0);c[h>>2]=T;r=1;i=b;return r|0}else if((u|0)==120){i=b;return r|0}return 0}function npf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+4|0;f=b;g=c[d>>2]|0;RI(2604248)|0;if((g|0)==(c[c[651085]>>2]|0)){h=0;i=b;return h|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];h=KGf(0,e)|0;i=b;return h|0}function opf(b,d){b=b|0;d=d|0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;i=b;return (a[(c[(c[635121]|0)+4>>2]|0)+(d&65535)>>0]|0)==1|0}function ppf(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a+4|0;e=a;c[d>>2]=0;c[e>>2]=0;if(Zof(0,b,0,e,d)|0){i=a;return c[e>>2]|0}else Auh(c[d>>2]|0);return 0}function qpf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;i=i+16|0;e=a;c[e>>2]=0;if(Zof(0,b,1,d,e)|0)f=1;else{c[d>>2]=0;f=0}i=a;return f|0}function rpf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=i;i=i+16|0;g=a;c[g>>2]=0;if(mpf(0,b,d,e,1,f,g)|0){h=1;i=a;return h|0}c[f>>2]=0;h=0;i=a;return h|0}function spf(b){b=b|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Gvg(0,c[b>>2]|0,0)|0;i=d;return e|0}function tpf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=Gvg(0,c[b>>2]|0,d)|0;i=e;return f|0}function upf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=vpf(a,b,0)|0;i=c;return d|0}function vpf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}g=vvg(0,d,c[b>>2]|0,e)|0;i=f;return g|0}function wpf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function xpf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function ypf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function zpf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function Apf(a){a=a|0;return}function Bpf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;c[b+8>>2]=4124;a[b+13>>0]=0;a[b+12>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Cpf(b,c){b=b|0;c=c|0;a[b+13>>0]=c&1;return}function Dpf(b,c){b=b|0;c=c|0;a[b+12>>0]=c&1;return}function Epf(b){b=b|0;return (a[b+12>>0]|0)!=0|0}function Fpf(b){b=b|0;return (a[b+13>>0]|0)!=0|0}function Gpf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=4;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Hpf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=5597;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Ipf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=ljg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Jpf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=zjg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Kpf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Jjg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Lpf(b,d,e){b=b|0;d=d|0;e=e|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=d;Wjg(b,0,c[e>>2]|0,c[e+4>>2]|0)}function Mpf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}f=d;gkg(b,0,c[f>>2]|0,c[f+4>>2]|0);i=e;return}function Npf(b,d){b=b|0;d=d|0;var e=0,f=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;f=+ukg(0,c[e>>2]|0,c[e+4>>2]|0);i=d;return +f}function Opf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Jkg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Ppf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Xkg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Qpf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=klg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Rpf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Alg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Spf(b,d){b=b|0;d=d|0;var e=0,f=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;f=ea(Nlg(0,c[e>>2]|0,c[e+4>>2]|0));i=d;return ea(f)}function Tpf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;Jdh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883538]|0);Auh(h)}h=b;b=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=b;RI(2548816)|0;b=pL(2548816,g)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,b,d,e,0)|0;i=f;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,b,d,e,0)|0;i=f;return k|0}function Upf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=amg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Vpf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=omg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Wpf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Cmg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Xpf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;Kdh();if(!b){e=1;i=d;return e|0}RI(2548816)|0;if(!(vL(b,2548816)|0)){f=c[883542]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}RI(2548816)|0;g=Euh(b,2548816)|0;b=c[g>>2]|0;f=c[g+4>>2]|0;g=a;a=c[g>>2]|0;h=c[g+4>>2]|0;if((a|0)==(b|0)&(h|0)==(f|0)){e=0;i=d;return e|0}e=(h|0)<(f|0)|(h|0)==(f|0)&a>>>0<b>>>0?-1:1;i=d;return e|0}function Ypf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2548816)|0;if(!(vL(b,2548816)|0)){e=0;i=d;return e|0}RI(2548816)|0;f=Euh(b,2548816)|0;b=a;e=(c[f>>2]|0)==(c[b>>2]|0)?(c[f+4>>2]|0)==(c[b+4>>2]|0):0;i=d;return e|0}function Zpf(a){a=a|0;var b=0;b=a;return c[b+4>>2]^c[b>>2]|0}function _pf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a;a=c[f>>2]|0;g=c[f+4>>2]|0;if((a|0)==(b|0)&(g|0)==(d|0)){h=0;i=e;return h|0}h=(g|0)>(d|0)|(g|0)==(d|0)&a>>>0>b>>>0?1:-1;i=e;return h|0}function $pf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;return ((c[e>>2]|0)==(b|0)?(c[e+4>>2]|0)==(d|0):0)|0}function aqf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;Ldh();h=f;c[h>>2]=0;c[h+4>>2]=0;c[g>>2]=0;if(!d){if(e){j=0;i=b;return j|0}RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883560]|0);c[g>>2]=h;j=0;i=b;return j|0}h=c[d+8>>2]|0;a:do if((h|0)>0){k=0;while(1){l=Wof(d,k)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}m=k+1|0;if(!(Xof(0,l)|0)){n=k;break a}if((m|0)<(h|0))k=m;else{n=m;break}}}else n=0;while(0);if((n|0)==(h|0)){if(e){j=0;i=b;return j|0}c[g>>2]=Yof(0)|0;j=0;i=b;return j|0}k=Wof(d,n)|0;if(k<<16>>16==43){o=n+1|0;p=1}else if(k<<16>>16==45){o=n+1|0;p=-1}else{o=n;p=1}b:do if((o|0)<(h|0)){n=0;k=0;m=o;l=0;while(1){q=Wof(d,m)|0;if((q+-48<<16>>16&65535)>9)if(Uof(0,e,d,m,g)|0){r=k;s=n;t=l}else{j=0;u=32;break}else{v=(q&65535)+208|0;if(!((n|0)<214748364|(n|0)==214748364&k>>>0<3435973837))break;if((k|0)==-858993460&(n|0)==214748364){w=v;x=m;u=18;break}q=gFi(k|0,n|0,10,0)|0;y=_Ei(v&255|0,0,q|0,H|0)|0;r=y;s=H;t=1}m=m+1|0;if((m|0)>=(h|0)){u=26;break}else{n=s;k=r;l=t}}do if((u|0)==18){l=w&255;if(l>>>0>=8?!((p|0)!=1&l>>>0<9):0)break;if(Uof(0,e,d,x+1|0,g)|0){k=(p|0)==-1;n=ZEi(8,-2147483648,l|0,0)|0;m=H;y=_Ei(l|0,0,-8,2147483647)|0;l=f;c[l>>2]=k?n:y;c[l+4>>2]=k?m:H;j=1;i=b;return j|0}}else if((u|0)==26){if(!t)break b;m=(p|0)==-1;k=ZEi(0,0,r|0,s|0)|0;l=f;c[l>>2]=m?k:r;c[l+4>>2]=m?H:s;j=1;i=b;return j|0}else if((u|0)==32){i=b;return j|0}while(0);if(e){j=0;i=b;return j|0}RI(3086272)|0;m=qL(3086272)|0;xsg(m,c[883562]|0);c[g>>2]=m;j=0;i=b;return j|0}while(0);if(e){j=0;i=b;return j|0}c[g>>2]=Yof(0)|0;j=0;i=b;return j|0}function bqf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cqf(0,b,7,c)|0;i=a;return d|0}function cqf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;i=i+16|0;f=a+8|0;g=a;c[f>>2]=0;h=g;c[h>>2]=0;c[h+4>>2]=0;if(dqf(0,b,d,e,0,g,f)|0){e=g;H=c[e+4>>2]|0;i=a;return c[e>>2]|0}else Auh(c[f>>2]|0);return 0}function dqf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+32|0;k=b+16|0;l=b+8|0;m=b+20|0;n=b+21|0;o=b+22|0;p=b+12|0;q=b;r=b+4|0;c[l>>2]=0;a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;Mdh();s=h;c[s>>2]=0;c[s+4>>2]=0;c[j>>2]=0;if(!d){if(g){t=0;i=b;return t|0}RI(2963920)|0;s=qL(2963920)|0;Iag(s,c[883566]|0);c[j>>2]=s;t=0;i=b;return t|0}s=d+8|0;if(!(c[s>>2]|0)){if(g){t=0;i=b;return t|0}RI(3079480)|0;u=qL(3079480)|0;Hrg(u,c[883568]|0);c[j>>2]=u;t=0;i=b;return t|0}if(f){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[p>>2]=3439976;c[k+0>>2]=c[p+0>>2];p=Iuh(3083928,f,npf(0,k)|0)|0;RI(2755888)|0;k=Juh(p,2755888)|0;if(k)v=k;else w=11}else w=11;if((w|0)==11){RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;Buh(3013496)}v=Kuh(2756224,lzg(0,jhg(0)|0)|0)|0}if(!(apf(0,e,g,j)|0)){t=0;i=b;return t|0}k=e>>>8;p=(e&512|0)!=0;f=(e&64|0)==0;u=(e&32|0)==0;x=(e&16|0)==0;y=(e&8|0)!=0;z=(e&4|0)!=0;A=e>>>1;B=(e&1|0)!=0;c[l>>2]=0;if(B?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;if(!x?(x=c[l>>2]|0,(Wof(d,x)|0)<<16>>16==40):0){a[n>>0]=1;a[m>>0]=1;e=x+1|0;c[l>>2]=e;do if(B)if(bpf(0,l,d,1,g,j)|0){C=c[l>>2]|0;break}else{t=0;i=b;return t|0}else C=e;while(0);e=fpf(d,C,c[(VTf(v)|0)+8>>2]|0)|0;x=VTf(v)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,e,x)|0){if(g){t=0;i=b;return t|0}RI(3079480)|0;x=qL(3079480)|0;Hrg(x,c[883570]|0);c[j>>2]=x;t=0;i=b;return t|0}x=fpf(d,C,c[(iUf(v)|0)+8>>2]|0)|0;C=iUf(v)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,x,C)|0){if(g){t=0;i=b;return t|0}RI(3079480)|0;C=qL(3079480)|0;Hrg(C,c[883572]|0);c[j>>2]=C;t=0;i=b;return t|0}else{D=0;E=1;F=1}}else if(z?(cpf(0,l,d,v,n,m),C=a[n>>0]|0,C<<24>>24!=0):0){if(B?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}if(k&1){epf(0,l,d,v,o);x=a[o>>0]|0;if(!(x<<24>>24==0|B^1)?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}else{D=x;E=C;F=0}}else{D=0;E=C;F=0}}else{D=0;E=0;F=0}C=(k&1|0)!=0;if(C&D<<24>>24==0){epf(0,l,d,v,o);k=a[o>>0]|0;if(k<<24>>24){if(B?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}if(!(E<<24>>24!=0|z^1)){cpf(0,l,d,v,n,m);z=a[n>>0]|0;if(!(z<<24>>24==0|B^1)?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}else{G=z;I=k}}else{G=E;I=k}}else{G=E;I=0}}else{G=E;I=D}D=0;E=0;k=c[l>>2]|0;z=0;B=0;a:while(1){do if(!(lpf(0,Wof(d,k)|0,p)|0)){if(!f){if(kpf(0,l,d,YTf(v)|0)|0){J=D;K=E;L=z;M=B;break}if(kpf(0,l,d,MTf(v)|0)|0){J=D;K=E;L=z;M=B;break}}if(B|u){N=D;O=E;P=z;w=73;break a}if(!(kpf(0,l,d,XTf(v)|0)|0)?!(kpf(0,l,d,LTf(v)|0)|0):0){N=D;O=E;P=z;w=73;break a}else{J=D;K=E;L=z;M=1}}else{x=z+1|0;if(!p){if(B){c[l>>2]=k+1;if((Wof(d,k)|0)<<16>>16==48){J=D;K=E;L=x;M=1;break}else{w=67;break a}}if((k|0)==2147483647){w=70;break a}c[l>>2]=k+1;e=Wof(d,k)|0;Q=gFi(D|0,E|0,10,0)|0;R=ZEi(Q|0,H|0,(e&65535)+65488&65535|0,0)|0;J=R;K=H;L=x;M=0;break}c[l>>2]=k+1;R=Wof(d,k)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}do if(!(jpf(0,R)|0)){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}e=R&65535;if(opf(0,R)|0){S=(e+65439&65535)+10|0;break}else{S=(e+65471&65535)+10|0;break}}else S=(R&65535)+65488&65535;while(0);R=cFi(D|0,E|0,4)|0;e=_Ei(S|0,((S|0)<0)<<31>>31|0,R|0,H|0)|0;J=e;K=H;L=x;M=B}while(0);k=c[l>>2]|0;if((k|0)>=(c[s>>2]|0)){N=J;O=K;P=L;w=73;break}else{D=J;E=K;z=L;B=M}}if((w|0)==67){if(g){t=0;i=b;return t|0}RI(3086272)|0;M=qL(3086272)|0;xsg(M,c[883574]|0);c[j>>2]=M;t=0;i=b;return t|0}else if((w|0)==70)FJ(PJ(3068960)|0);else if((w|0)==73){if(!P){if(g){t=0;i=b;return t|0}RI(3079480)|0;P=qL(3079480)|0;Hrg(P,c[883578]|0);c[j>>2]=P;t=0;i=b;return t|0}if(y&G<<24>>24==0){cpf(0,l,d,v,n,m);P=a[n>>0]|0;if(P<<24>>24){if((A&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}if(C){epf(0,l,d,v,o);T=a[o>>0]|0;U=P;w=82}}else{T=I;U=0;w=82}}else{T=I;U=G;w=82}if((w|0)==82?C&T<<24>>24==0:0){if((PTf(v)|0)==3?(T=c[l>>2]|0,c[l>>2]=T+1,(Wof(d,T)|0)<<16>>16!=32):0)if(g){t=0;i=b;return t|0}else{RI(3079480)|0;T=qL(3079480)|0;Hrg(T,c[883580]|0);Auh(T)}epf(0,l,d,v,o);if((a[o>>0]|0)!=0?(c[l>>2]|0)<(c[s>>2]|0):0){if((A&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){t=0;i=b;return t|0}if(!(U<<24>>24!=0|y^1))cpf(0,l,d,v,n,m)}}n=(A&1|0)!=0;if((n?(c[l>>2]|0)<(c[s>>2]|0):0)?!(bpf(0,l,d,0,g,j)|0):0){t=0;i=b;return t|0}do if(F){A=c[l>>2]|0;if((A|0)<(c[s>>2]|0)?(v=A+1|0,c[l>>2]=v,(Wof(d,A)|0)<<16>>16==41):0){if(!n)break;if((v|0)>=(c[s>>2]|0))break;if(bpf(0,l,d,0,g,j)|0)break;else t=0;i=b;return t|0}if(g){t=0;i=b;return t|0}RI(3079480)|0;v=qL(3079480)|0;Hrg(v,c[883582]|0);c[j>>2]=v;t=0;i=b;return t|0}while(0);n=c[l>>2]|0;if((n|0)<(c[s>>2]|0)?(Wof(d,n)|0)<<16>>16!=0:0){if(g){t=0;i=b;return t|0}RI(1086352)|0;g=Huh(1086352,4)|0;Qqh(g,c[883584]|0);d=g+16|0;c[d>>2]=c[883584];c[q>>2]=n;RI(2540224)|0;n=pL(2540224,q)|0;Qqh(g,n);c[d+(c[(c[g>>2]|0)+120>>2]|0)>>2]=n;Qqh(g,c[883586]|0);c[d+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[883586];c[r>>2]=c[s>>2];RI(2540224)|0;s=pL(2540224,r)|0;Qqh(g,s);c[d+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=s;if(!(a[2540708]|0))Buh(2540560);s=eqf(0,g)|0;RI(3079480)|0;g=qL(3079480)|0;Hrg(g,s);c[j>>2]=g;t=0;i=b;return t|0}if((a[m>>0]|0)!=0|p){V=N;W=O}else{p=ZEi(0,0,N|0,O|0)|0;V=p;W=0}p=h;c[p>>2]=V;c[p+4>>2]=W;t=1;i=b;return t|0}return 0}function eqf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;Feh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[884608]|0);Auh(e)}e=c[d+12>>2]|0;if(!e){if(!(a[2540708]|0))Buh(2540560);f=c[c[635163]>>2]|0;i=b;return f|0}RI(1094176)|0;g=Huh(1094176,e)|0;if((e|0)>0){h=d+16|0;j=g+16|0;k=0;l=0;while(1){m=c[h+(da(c[(c[d>>2]|0)+120>>2]|0,l)|0)>>2]|0;if(!m)n=k;else{o=Fqh(2536904,m)|0;Qqh(g,o);c[j+(da(c[(c[g>>2]|0)+120>>2]|0,l)|0)>>2]=o;n=(c[(c[j+(da(c[(c[g>>2]|0)+120>>2]|0,l)|0)>>2]|0)+8>>2]|0)+k|0}l=l+1|0;if((l|0)==(e|0)){p=n;break}else k=n}}else p=0;if(!(a[2540708]|0))Buh(2540560);f=kwf(0,g,p)|0;i=b;return f|0}function fqf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;i=i+16|0;e=a;c[e>>2]=0;if(aqf(0,b,1,d,e)|0){f=1;i=a;return f|0}e=d;c[e>>2]=0;c[e+4>>2]=0;f=0;i=a;return f|0}function gqf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=i;i=i+16|0;g=a;c[g>>2]=0;if(dqf(0,b,d,e,1,f,g)|0){h=1;i=a;return h|0}g=f;c[g>>2]=0;c[g+4>>2]=0;h=0;i=a;return h|0}function hqf(b){b=b|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=b;b=Ivg(0,c[e>>2]|0,c[e+4>>2]|0,0)|0;i=d;return b|0}function iqf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=b;b=Ivg(0,c[f>>2]|0,c[f+4>>2]|0,d)|0;i=e;return b|0}function jqf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=kqf(a,b,0)|0;i=c;return d|0}function kqf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}g=b;b=xvg(0,d,c[g>>2]|0,c[g+4>>2]|0,e)|0;i=f;return b|0}function lqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function mqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=pjg(0,c[b>>2]|0)|0;i=d;return e|0}function nqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Djg(0,c[b>>2]|0)|0;i=d;return e|0}function oqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Ojg(0,c[b>>2]|0)|0;i=d;return e|0}function pqf(b,d,e){b=b|0;d=d|0;e=e|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}$jg(b,0,c[d>>2]|0)}function qqf(b,d,e){b=b|0;d=d|0;e=e|0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}kkg(b,0,c[d>>2]|0);i=e;return}function rqf(b,d){b=b|0;d=d|0;var e=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=+ykg(0,c[b>>2]|0);i=d;return +e}function sqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Nkg(0,c[b>>2]|0)|0;i=d;return e|0}function tqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=$kg(0,c[b>>2]|0)|0;i=d;return e|0}function uqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=olg(0,c[b>>2]|0)|0;i=d;return e|0}function vqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Dlg(0,c[b>>2]|0)|0;i=d;return e|0}function wqf(b,d){b=b|0;d=d|0;var e=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ea(Rlg(0,c[b>>2]|0));i=d;return ea(e)}function xqf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Ndh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883838]|0);Auh(h)}c[g>>2]=c[b>>2];RI(2551640)|0;b=pL(2551640,g)|0;RI(3034288)|0;if(a[3034436]|0){j=Lmg(0,b,d,e,0)|0;i=f;return j|0}RI(3034288)|0;Buh(3034288);j=Lmg(0,b,d,e,0)|0;i=f;return j|0}function yqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=emg(0,c[b>>2]|0)|0;i=d;return e|0}function zqf(a,b){a=a|0;b=b|0;return c[a>>2]|0}function Aqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Gmg(0,c[b>>2]|0)|0;i=d;return e|0}function Bqf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;Odh();if(!b){e=1;i=d;return e|0}RI(2551640)|0;if(!(vL(b,2551640)|0)){f=c[883842]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}RI(2551640)|0;g=c[(Euh(b,2551640)|0)>>2]|0;b=c[a>>2]|0;if((b|0)==(g|0)){e=0;i=d;return e|0}e=b>>>0<g>>>0?-1:1;i=d;return e|0}function Cqf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2551640)|0;if(!(vL(b,2551640)|0)){e=0;i=d;return e|0}RI(2551640)|0;f=c[(Euh(b,2551640)|0)>>2]|0;e=(f|0)==(c[a>>2]|0);i=d;return e|0}function Dqf(a){a=a|0;return c[a>>2]|0}function Eqf(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a>>2]|0;if((d|0)==(b|0))e=0;else e=d>>>0>b>>>0?1:-1;return e|0}function Fqf(a,b){a=a|0;b=b|0;return (c[a>>2]|0)==(b|0)|0}function Gqf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;Pdh();c[f>>2]=0;c[g>>2]=0;if(!d){if(e){h=0;i=b;return h|0}RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[883862]|0);c[g>>2]=j;h=0;i=b;return h|0}j=c[d+8>>2]|0;a:do if((j|0)>0){k=0;while(1){l=Wof(d,k)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}m=k+1|0;if(!(Xof(0,l)|0)){n=k;break a}if((m|0)<(j|0))k=m;else{n=m;break}}}else n=0;while(0);if((n|0)==(j|0)){if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}if((Wof(d,n)|0)<<16>>16==43){o=n+1|0;p=1}else{k=(Wof(d,n)|0)<<16>>16==45;o=(k&1)+n|0;p=k^1}do if((o|0)<(j|0)){k=0;n=o;m=0;while(1){l=Wof(d,n)|0;if((l+-48<<16>>16&65535)>9)if(Uof(0,e,d,n,g)|0){q=k;r=m}else{h=0;s=31;break}else{t=(l&65535)+65488&65535;if(k>>>0>429496729){s=18;break}if(!((k|0)!=429496729|t>>>0<6)){s=18;break}q=t+(k*10|0)|0;r=1}n=n+1|0;if((n|0)>=(j|0)){s=24;break}else{k=q;m=r}}if((s|0)==18){if(e){h=0;i=b;return h|0}m=c[883864]|0;RI(3086272)|0;k=qL(3086272)|0;xsg(k,m);c[g>>2]=k;h=0;i=b;return h|0}else if((s|0)==24){if(!r)break;if((q|0)==0|p){c[f>>2]=q;h=1;i=b;return h|0}if(e){h=0;i=b;return h|0}k=c[883866]|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,k);c[g>>2]=m;h=0;i=b;return h|0}else if((s|0)==31){i=b;return h|0}}while(0);if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}function Hqf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;i=i+16|0;k=b+8|0;l=b+4|0;m=b+14|0;n=b+13|0;o=b+12|0;p=b;c[l>>2]=0;a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;Qdh();c[h>>2]=0;c[j>>2]=0;if(!d){if(g){q=0;i=b;return q|0}RI(2963920)|0;r=qL(2963920)|0;Iag(r,c[883878]|0);c[j>>2]=r;q=0;i=b;return q|0}r=d+8|0;if(!(c[r>>2]|0)){if(g){q=0;i=b;return q|0}c[j>>2]=Yof(0)|0;q=0;i=b;return q|0}if(f){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[p>>2]=3439976;c[k+0>>2]=c[p+0>>2];p=Iuh(3083928,f,npf(0,k)|0)|0;RI(2755888)|0;k=Juh(p,2755888)|0;if(k)s=k;else t=11}else t=11;if((t|0)==11){RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;Buh(3013496)}s=Kuh(2756224,lzg(0,jhg(0)|0)|0)|0}if(!(apf(0,e,g,j)|0)){q=0;i=b;return q|0}k=e>>>8;p=(e&512|0)!=0;f=(e&64|0)==0;u=(e&32|0)==0;v=(e&16|0)==0;w=(e&8|0)!=0;x=(e&4|0)!=0;y=e>>>1;z=(e&1|0)!=0;c[l>>2]=0;if(z?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;if(!v?(v=c[l>>2]|0,(Wof(d,v)|0)<<16>>16==40):0){a[n>>0]=1;a[m>>0]=1;e=v+1|0;c[l>>2]=e;do if(z)if(bpf(0,l,d,1,g,j)|0){A=c[l>>2]|0;break}else{q=0;i=b;return q|0}else A=e;while(0);e=fpf(d,A,c[(VTf(s)|0)+8>>2]|0)|0;v=VTf(s)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,e,v)|0){if(g){q=0;i=b;return q|0}c[j>>2]=Yof(0)|0;q=0;i=b;return q|0}v=fpf(d,A,c[(iUf(s)|0)+8>>2]|0)|0;A=iUf(s)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,v,A)|0){if(g){q=0;i=b;return q|0}c[j>>2]=Yof(0)|0;q=0;i=b;return q|0}else{B=0;C=1;D=1}}else if(x?(cpf(0,l,d,s,n,m),A=a[n>>0]|0,A<<24>>24!=0):0){if(z?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}if(k&1){epf(0,l,d,s,o);v=a[o>>0]|0;if(!(v<<24>>24==0|z^1)?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}else{B=v;C=A;D=0}}else{B=0;C=A;D=0}}else{B=0;C=0;D=0}A=(k&1|0)!=0;if(A&B<<24>>24==0){epf(0,l,d,s,o);k=a[o>>0]|0;if(k<<24>>24){if(z?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}if(!(C<<24>>24!=0|x^1)){cpf(0,l,d,s,n,m);x=a[n>>0]|0;if(!(x<<24>>24==0|z^1)?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}else{E=x;F=k}}else{E=C;F=k}}else{E=C;F=0}}else{E=C;F=B}B=c[l>>2]|0;C=0;k=0;x=0;a:while(1){do if(!(lpf(0,Wof(d,B)|0,p)|0)){if(!f?kpf(0,l,d,YTf(s)|0)|0:0){G=C;I=k;J=x;break}if(x|u){K=C;L=k;t=77;break a}if(kpf(0,l,d,XTf(s)|0)|0){G=C;I=k;J=1}else{K=C;L=k;t=77;break a}}else{z=k+1|0;if(!p){if(x){c[l>>2]=B+1;if((Wof(d,B)|0)<<16>>16==48){G=C;I=z;J=1;break}else{t=69;break a}}if((B|0)==2147483647){t=72;break a}c[l>>2]=B+1;v=C*10|0;e=((Wof(d,B)|0)&65535)+65488&65535;M=_Ei(e|0,0,v|0,((v|0)<0)<<31>>31|0)|0;N=H;if((N|0)>0|(N|0)==0&M>>>0>2147483647){t=74;break a}G=e+v|0;I=z;J=0;break}c[l>>2]=B+1;v=Wof(d,B)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}do if(!(jpf(0,v)|0)){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}e=v&65535;if(opf(0,v)|0){O=(e+65439&65535)+10|0;break}else{O=(e+65471&65535)+10|0;break}}else O=(v&65535)+65488&65535;while(0);v=C<<4;if(g){G=O+v|0;I=z;J=x;break}e=_Ei(O|0,0,v|0,((v|0)<0)<<31>>31|0)|0;M=H;if((M|0)>0|(M|0)==0&e>>>0>2147483647){t=65;break a}G=O+v|0;I=z;J=x}while(0);B=c[l>>2]|0;if((B|0)>=(c[r>>2]|0)){K=G;L=I;t=77;break}else{C=G;k=I;x=J}}if((t|0)==65)Auh(PJ(3068960)|0);else if((t|0)==69){if(g){q=0;i=b;return q|0}J=c[883880]|0;RI(3086272)|0;x=qL(3086272)|0;xsg(x,J);c[j>>2]=x;q=0;i=b;return q|0}else if((t|0)==72)FJ(PJ(3068960)|0);else if((t|0)==74)FJ(PJ(3068960)|0);else if((t|0)==77){if(!L){if(g){q=0;i=b;return q|0}c[j>>2]=Yof(0)|0;q=0;i=b;return q|0}if(w&E<<24>>24==0){cpf(0,l,d,s,n,m);L=a[n>>0]|0;if(L<<24>>24){if((y&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}if(A){epf(0,l,d,s,o);P=a[o>>0]|0;Q=L;t=86}}else{P=F;Q=0;t=86}}else{P=F;Q=E;t=86}if(((t|0)==86?A&P<<24>>24==0:0)?(epf(0,l,d,s,o),(a[o>>0]|0)!=0):0){if((y&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){q=0;i=b;return q|0}if(!(Q<<24>>24!=0|w^1))cpf(0,l,d,s,n,m)}n=(y&1|0)!=0;if((n?(c[l>>2]|0)<(c[r>>2]|0):0)?!(bpf(0,l,d,0,g,j)|0):0){q=0;i=b;return q|0}do if(D){y=c[l>>2]|0;if((y|0)<(c[r>>2]|0)?(s=y+1|0,c[l>>2]=s,(Wof(d,y)|0)<<16>>16==41):0){if(!n)break;if((s|0)>=(c[r>>2]|0))break;if(bpf(0,l,d,0,g,j)|0)break;else q=0;i=b;return q|0}if(g){q=0;i=b;return q|0}c[j>>2]=Yof(0)|0;q=0;i=b;return q|0}while(0);n=c[l>>2]|0;if((n|0)<(c[r>>2]|0)?(Wof(d,n)|0)<<16>>16!=0:0){if(g){q=0;i=b;return q|0}c[j>>2]=Yof(0)|0;q=0;i=b;return q|0}if((a[m>>0]|0)==0|(K|0)==0){c[h>>2]=K;q=1;i=b;return q|0}if(g){q=0;i=b;return q|0}g=c[883884]|0;RI(3086272)|0;K=qL(3086272)|0;xsg(K,g);c[j>>2]=K;q=0;i=b;return q|0}return 0}function Iqf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;i=i+16|0;f=a+4|0;g=a;c[f>>2]=0;c[g>>2]=0;if(Hqf(0,b,d,e,0,g,f)|0){i=a;return c[g>>2]|0}else Auh(c[f>>2]|0);return 0}function Jqf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Iqf(0,b,7,c)|0;i=a;return d|0}function Kqf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;i=i+16|0;e=a;c[e>>2]=0;if(Gqf(0,b,1,d,e)|0)f=1;else{c[d>>2]=0;f=0}i=a;return f|0}function Lqf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=i;i=i+16|0;g=a;c[g>>2]=0;if(Hqf(0,b,d,e,1,f,g)|0){h=1;i=a;return h|0}c[f>>2]=0;h=0;i=a;return h|0}function Mqf(b){b=b|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Evg(0,c[b>>2]|0,0)|0;i=d;return e|0}function Nqf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=Evg(0,c[b>>2]|0,d)|0;i=e;return f|0}function Oqf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Pqf(a,b,0)|0;i=c;return d|0}function Pqf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}g=uvg(0,d,c[b>>2]|0,e)|0;i=f;return g|0}function Qqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Rqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Sqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Tqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Uqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Vqf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=32767;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Wqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=qjg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Xqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Ejg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Yqf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Pjg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function Zqf(b,d,e){b=b|0;d=d|0;e=e|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=d;akg(b,0,c[e>>2]|0,c[e+4>>2]|0)}function _qf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}f=d;lkg(b,0,c[f>>2]|0,c[f+4>>2]|0);i=e;return}function $qf(b,d){b=b|0;d=d|0;var e=0,f=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;f=+zkg(0,c[e>>2]|0,c[e+4>>2]|0);i=d;return +f}function arf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Okg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function brf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=alg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function crf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=plg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function drf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=Elg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function erf(b,d){b=b|0;d=d|0;var e=0,f=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;f=ea(Slg(0,c[e>>2]|0,c[e+4>>2]|0));i=d;return ea(f)}function frf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;Rdh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883888]|0);Auh(h)}h=b;b=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=b;RI(2554736)|0;b=pL(2554736,g)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,b,d,e,0)|0;i=f;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,b,d,e,0)|0;i=f;return k|0}function grf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=fmg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function hrf(b,d){b=b|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=b;b=smg(0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function irf(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function jrf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;Sdh();if(!b){e=1;i=d;return e|0}RI(2554736)|0;if(!(vL(b,2554736)|0)){f=c[883892]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}RI(2554736)|0;g=Euh(b,2554736)|0;b=c[g>>2]|0;f=c[g+4>>2]|0;g=a;a=c[g>>2]|0;h=c[g+4>>2]|0;if((a|0)==(b|0)&(h|0)==(f|0)){e=0;i=d;return e|0}e=h>>>0<f>>>0|(h|0)==(f|0)&a>>>0<b>>>0?-1:1;i=d;return e|0}function krf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2554736)|0;if(!(vL(b,2554736)|0)){e=0;i=d;return e|0}RI(2554736)|0;f=Euh(b,2554736)|0;b=a;e=(c[f>>2]|0)==(c[b>>2]|0)?(c[f+4>>2]|0)==(c[b+4>>2]|0):0;i=d;return e|0}function lrf(a){a=a|0;var b=0;b=a;return c[b+4>>2]^c[b>>2]|0}function mrf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a;a=c[f>>2]|0;g=c[f+4>>2]|0;if((a|0)==(b|0)&(g|0)==(d|0)){h=0;i=e;return h|0}h=g>>>0>d>>>0|(g|0)==(d|0)&a>>>0>b>>>0?1:-1;i=e;return h|0}function nrf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;return ((c[e>>2]|0)==(b|0)?(c[e+4>>2]|0)==(d|0):0)|0}function orf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=prf(0,b,7,c)|0;i=a;return d|0}function prf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;i=i+16|0;f=a+8|0;g=a;c[f>>2]=0;h=g;c[h>>2]=0;c[h+4>>2]=0;if(qrf(0,b,d,e,0,g,f)|0){e=g;H=c[e+4>>2]|0;i=a;return c[e>>2]|0}else Auh(c[f>>2]|0);return 0}function qrf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+16|0;k=b+8|0;l=b+4|0;m=b+14|0;n=b+13|0;o=b+12|0;p=b;c[l>>2]=0;a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;Tdh();q=h;c[q>>2]=0;c[q+4>>2]=0;c[j>>2]=0;if(!d){if(g){r=0;i=b;return r|0}RI(2963920)|0;q=qL(2963920)|0;Iag(q,c[883912]|0);c[j>>2]=q;r=0;i=b;return r|0}q=d+8|0;if(!(c[q>>2]|0)){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}if(f){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[p>>2]=3439976;c[k+0>>2]=c[p+0>>2];p=Iuh(3083928,f,npf(0,k)|0)|0;RI(2755888)|0;k=Juh(p,2755888)|0;if(k)s=k;else t=11}else t=11;if((t|0)==11){RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;Buh(3013496)}s=Kuh(2756224,lzg(0,jhg(0)|0)|0)|0}if(!(apf(0,e,g,j)|0)){r=0;i=b;return r|0}k=e>>>8;p=(e&512|0)!=0;f=(e&64|0)==0;u=(e&32|0)==0;v=(e&16|0)==0;w=(e&8|0)!=0;x=(e&4|0)!=0;y=e>>>1;z=(e&1|0)!=0;c[l>>2]=0;if(z?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;if(!v?(v=c[l>>2]|0,(Wof(d,v)|0)<<16>>16==40):0){a[n>>0]=1;a[m>>0]=1;e=v+1|0;c[l>>2]=e;do if(z)if(bpf(0,l,d,1,g,j)|0){A=c[l>>2]|0;break}else{r=0;i=b;return r|0}else A=e;while(0);e=fpf(d,A,c[(VTf(s)|0)+8>>2]|0)|0;v=VTf(s)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,e,v)|0){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}v=fpf(d,A,c[(iUf(s)|0)+8>>2]|0)|0;A=iUf(s)|0;if(!(a[2540708]|0))Buh(2540560);if(gpf(0,v,A)|0){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}else{B=0;C=1;D=1}}else if(x?(cpf(0,l,d,s,n,m),A=a[n>>0]|0,A<<24>>24!=0):0){if(z?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(k&1){epf(0,l,d,s,o);v=a[o>>0]|0;if(!(v<<24>>24==0|z^1)?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}else{B=v;C=A;D=0}}else{B=0;C=A;D=0}}else{B=0;C=0;D=0}A=(k&1|0)!=0;if(A&B<<24>>24==0){epf(0,l,d,s,o);k=a[o>>0]|0;if(k<<24>>24){if(z?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(!(C<<24>>24!=0|x^1)){cpf(0,l,d,s,n,m);x=a[n>>0]|0;if(!(x<<24>>24==0|z^1)?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}else{E=x;F=k}}else{E=C;F=k}}else{E=C;F=0}}else{E=C;F=B}B=0;C=0;k=c[l>>2]|0;x=0;z=0;a:while(1){do if(lpf(0,Wof(d,k)|0,p)|0){v=x+1|0;if(!p){if(z){c[l>>2]=k+1;if((Wof(d,k)|0)<<16>>16==48){G=B;I=C;J=v;K=1;break}else{t=66;break a}}if((k|0)==2147483647){t=69;break a}c[l>>2]=k+1;e=((Wof(d,k)|0)&65535)+65488&65535;L=gFi(B|0,C|0,10,0)|0;M=_Ei(e|0,0,L|0,H|0)|0;G=M;I=H;J=v;K=0;break}c[l>>2]=k+1;M=Wof(d,k)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}do if(!(jpf(0,M)|0)){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}L=M&65535;if(opf(0,M)|0){N=(L+65439&65535)+10|0;break}else{N=(L+65471&65535)+10|0;break}}else N=(M&65535)+65488&65535;while(0);M=cFi(B|0,C|0,4)|0;L=_Ei(N|0,0,M|0,H|0)|0;M=H;if(g?!(C>>>0<0|(C|0)==0&B>>>0<65536|(M>>>0>0|(M|0)==0&L>>>0>15)):0){r=0;t=106;break a}else{G=L;I=M;J=v;K=z}}else{if(!f?kpf(0,l,d,YTf(s)|0)|0:0){G=B;I=C;J=x;K=z;break}if(z|u){O=B;P=C;Q=x;t=72;break a}if(kpf(0,l,d,XTf(s)|0)|0){G=B;I=C;J=x;K=1}else{O=B;P=C;Q=x;t=72;break a}}while(0);k=c[l>>2]|0;if((k|0)>=(c[q>>2]|0)){O=G;P=I;Q=J;t=72;break}else{B=G;C=I;x=J;z=K}}if((t|0)==66){if(g){r=0;i=b;return r|0}K=c[883914]|0;RI(3086272)|0;z=qL(3086272)|0;xsg(z,K);c[j>>2]=z;r=0;i=b;return r|0}else if((t|0)==69)FJ(PJ(3068960)|0);else if((t|0)==72){if(!Q){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}if(w&E<<24>>24==0){cpf(0,l,d,s,n,m);Q=a[n>>0]|0;if(Q<<24>>24){if((y&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(A){epf(0,l,d,s,o);R=a[o>>0]|0;S=Q;t=81}}else{R=F;S=0;t=81}}else{R=F;S=E;t=81}if(((t|0)==81?A&R<<24>>24==0:0)?(epf(0,l,d,s,o),(a[o>>0]|0)!=0):0){if((y&1|0)!=0?!(bpf(0,l,d,1,g,j)|0):0){r=0;i=b;return r|0}if(!(S<<24>>24!=0|w^1))cpf(0,l,d,s,n,m)}n=(y&1|0)!=0;if((n?(c[l>>2]|0)<(c[q>>2]|0):0)?!(bpf(0,l,d,0,g,j)|0):0){r=0;i=b;return r|0}do if(D){y=c[l>>2]|0;if((y|0)<(c[q>>2]|0)?(s=y+1|0,c[l>>2]=s,(Wof(d,y)|0)<<16>>16==41):0){if(!n)break;if((s|0)>=(c[q>>2]|0))break;if(bpf(0,l,d,0,g,j)|0)break;else r=0;i=b;return r|0}if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}while(0);n=c[l>>2]|0;if((n|0)<(c[q>>2]|0)?(Wof(d,n)|0)<<16>>16!=0:0){if(g){r=0;i=b;return r|0}c[j>>2]=Yof(0)|0;r=0;i=b;return r|0}if((a[m>>0]|0)==0|(O|0)==0&(P|0)==0){m=h;c[m>>2]=O;c[m+4>>2]=P;r=1;i=b;return r|0}if(g){r=0;i=b;return r|0}g=c[883918]|0;RI(3086272)|0;P=qL(3086272)|0;xsg(P,g);c[j>>2]=P;r=0;i=b;return r|0}else if((t|0)==106){i=b;return r|0}return 0}function rrf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;i=i+16|0;e=a;c[e>>2]=0;if(qrf(0,b,7,0,1,d,e)|0){f=1;i=a;return f|0}e=d;c[e>>2]=0;c[e+4>>2]=0;f=0;i=a;return f|0}function srf(b){b=b|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=b;b=Hvg(0,c[e>>2]|0,c[e+4>>2]|0,0)|0;i=d;return b|0}function trf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=b;b=Hvg(0,c[f>>2]|0,c[f+4>>2]|0,d)|0;i=e;return b|0}function urf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=vrf(a,b,0)|0;i=c;return d|0}function vrf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}g=b;b=wvg(0,d,c[g>>2]|0,c[g+4>>2]|0,e)|0;i=f;return b|0}function wrf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function xrf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function yrf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function zrf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Arf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Udh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883922]|0);Auh(h)}a[g>>0]=a[b>>0]|0;RI(2557392)|0;b=pL(2557392,g)|0;RI(3034288)|0;if(a[3034436]|0){j=Lmg(0,b,d,e,0)|0;i=f;return j|0}RI(3034288)|0;Buh(3034288);j=Lmg(0,b,d,e,0)|0;i=f;return j|0}function Brf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=gjg(0,a[b>>0]|0)|0;i=c;return d|0}function Crf(b,c){b=b|0;c=c|0;return a[b>>0]|0}function Drf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Hjg(0,a[b>>0]|0)|0;i=c;return d|0}function Erf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);Auh(c)}function Frf(b,c,d){b=b|0;c=c|0;d=d|0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}ckg(b,0,a[c>>0]|0);i=d;return}function Grf(b,c){b=b|0;c=c|0;var d=0.0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=+pkg(0,a[b>>0]|0);i=c;return +d}function Hrf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Dkg(0,a[b>>0]|0)|0;i=c;return d|0}function Irf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Skg(0,a[b>>0]|0)|0;i=c;return d|0}function Jrf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=elg(0,a[b>>0]|0)|0;i=c;return d|0}function Krf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ulg(0,a[b>>0]|0)|0;i=c;return d|0}function Lrf(b,c){b=b|0;c=c|0;var d=Im;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ea(Ilg(0,a[b>>0]|0));i=c;return ea(d)}function Mrf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Wlg(0,a[b>>0]|0)|0;i=c;return d|0}function Nrf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=img(0,a[b>>0]|0)|0;i=c;return d|0}function Orf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=wmg(0,a[b>>0]|0)|0;i=c;return d|0}function Prf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;Vdh();if(!d){f=1;i=e;return f|0}RI(2557392)|0;if(!(vL(d,2557392)|0)){g=c[883926]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}RI(2557392)|0;h=a[(Euh(d,2557392)|0)>>0]|0;d=a[b>>0]|0;if(d<<24>>24==h<<24>>24){f=0;i=e;return f|0}f=(d&255)>(h&255)?1:-1;i=e;return f|0}function Qrf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;RI(2557392)|0;if(!(vL(c,2557392)|0)){e=0;i=d;return e|0}RI(2557392)|0;f=a[(Euh(c,2557392)|0)>>0]|0;e=f<<24>>24==(a[b>>0]|0);i=d;return e|0}function Rrf(a){a=a|0;return d[a>>0]|0|0}function Srf(b,c){b=b|0;c=c|0;var d=0,e=0;d=a[b>>0]|0;if(d<<24>>24==c<<24>>24)e=0;else e=(d&255)>(c&255)?1:-1;return e|0}function Trf(b,c){b=b|0;c=c|0;return (a[b>>0]|0)==c<<24>>24|0}function Urf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Vrf(0,b,7,c)|0;i=a;return d|0}function Vrf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;Wdh();f=Iqf(0,b,d,e)|0;if(f>>>0<256){i=a;return f&255|0}else{f=c[883944]|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,f);Auh(a)}return 0}function Wrf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Xrf(0,b,7,0,c)|0;i=a;return d|0}function Xrf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+16|0;h=b;c[h>>2]=0;a[g>>0]=0;if(Lqf(0,d,e,f,h)|0?(f=c[h>>2]|0,f>>>0<256):0){a[g>>0]=f;j=1}else j=0;i=b;return j|0}function Yrf(b){b=b|0;var c=0,e=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Gvg(0,d[b>>0]|0,0)|0;i=c;return e|0}function Zrf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_rf(a,b,0)|0;i=c;return d|0}function _rf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=rvg(0,c,a[b>>0]|0,d)|0;i=e;return f|0}function $rf(b,c){b=b|0;c=c|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=Gvg(0,d[b>>0]|0,c)|0;i=e;return f|0}function asf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function bsf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=mjg(0,a[b>>0]|0)|0;i=c;return d|0}function csf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Ajg(0,a[b>>0]|0)|0;i=c;return d|0}function dsf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Ljg(0,a[b>>0]|0)|0;i=c;return d|0}function esf(b,c,d){b=b|0;c=c|0;d=d|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Zjg(b,0,a[c>>0]|0)}function fsf(b,c,d){b=b|0;c=c|0;d=d|0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}hkg(b,0,a[c>>0]|0);i=d;return}function gsf(b,c){b=b|0;c=c|0;var d=0.0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=+vkg(0,a[b>>0]|0);i=c;return +d}function hsf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Kkg(0,a[b>>0]|0)|0;i=c;return d|0}function isf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Ykg(0,a[b>>0]|0)|0;i=c;return d|0}function jsf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=llg(0,a[b>>0]|0)|0;i=c;return d|0}function ksf(b,c){b=b|0;c=c|0;return a[b>>0]|0}function lsf(b,c){b=b|0;c=c|0;var d=Im;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ea(Olg(0,a[b>>0]|0));i=c;return ea(d)}function msf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Xdh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[883956]|0);Auh(h)}a[g>>0]=a[b>>0]|0;RI(2560032)|0;b=pL(2560032,g)|0;RI(3034288)|0;if(a[3034436]|0){j=Lmg(0,b,d,e,0)|0;i=f;return j|0}RI(3034288)|0;Buh(3034288);j=Lmg(0,b,d,e,0)|0;i=f;return j|0}function nsf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=bmg(0,a[b>>0]|0)|0;i=c;return d|0}function osf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=pmg(0,a[b>>0]|0)|0;i=c;return d|0}function psf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Dmg(0,a[b>>0]|0)|0;i=c;return d|0}function qsf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;Ydh();if(!d){f=1;i=e;return f|0}RI(2560032)|0;if(!(vL(d,2560032)|0)){g=c[883960]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}RI(2560032)|0;h=a[(Euh(d,2560032)|0)>>0]|0;d=a[b>>0]|0;if(d<<24>>24==h<<24>>24){f=0;i=e;return f|0}f=d<<24>>24>h<<24>>24?1:-1;i=e;return f|0}function rsf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;RI(2560032)|0;if(!(vL(c,2560032)|0)){e=0;i=d;return e|0}RI(2560032)|0;f=a[(Euh(c,2560032)|0)>>0]|0;e=f<<24>>24==(a[b>>0]|0);i=d;return e|0}function ssf(b){b=b|0;return a[b>>0]|0}function tsf(b,c){b=b|0;c=c|0;var d=0,e=0;d=a[b>>0]|0;if(d<<24>>24==c<<24>>24)e=0;else e=d<<24>>24>c<<24>>24?1:-1;return e|0}function usf(b,c){b=b|0;c=c|0;return (a[b>>0]|0)==c<<24>>24|0}function vsf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;Zdh();a[f>>0]=0;c[g>>2]=0;if(!d){if(e){h=0;i=b;return h|0}RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[883978]|0);c[g>>2]=j;h=0;i=b;return h|0}j=c[d+8>>2]|0;a:do if((j|0)>0){k=0;while(1){l=Wof(d,k)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}m=k+1|0;if(!(Xof(0,l)|0)){n=k;break a}if((m|0)<(j|0))k=m;else{n=m;break}}}else n=0;while(0);if((n|0)==(j|0)){if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}k=Wof(d,n)|0;if(k<<16>>16==43){o=n+1|0;p=0}else if(k<<16>>16==45){o=n+1|0;p=1}else{o=n;p=0}b:do if((o|0)<(j|0)){n=0;k=o;m=0;while(1){l=Wof(d,k)|0;if((l+-48<<16>>16&65535)>9){q=l;r=n;s=k;t=m;u=20;break}v=(n*10|0)-((l&65535)+65488&65535)|0;if(e){if((v|0)<=-129){h=0;u=39;break}w=v<<24>>24}else w=v;k=k+1|0;if((k|0)>=(j|0)){x=w;break}else{n=w;m=1}}if((u|0)==39){i=b;return h|0}do if((u|0)==20){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(Xof(0,q)|0)y=s;else{if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}do{y=y+1|0;if((y|0)>=(j|0)){u=32;break}m=Wof(d,y)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}}while(Xof(0,m)|0);if((u|0)==32)if(t){x=r;break}else break b;if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}while(0);m=p?x:0-x|0;if((m+128|0)>>>0<256){a[f>>0]=m;h=1;i=b;return h|0}if(e){h=0;i=b;return h|0}RI(3086272)|0;m=qL(3086272)|0;vwg(m);c[g>>2]=m;h=0;i=b;return h|0}while(0);if(e){h=0;i=b;return h|0}c[g>>2]=Yof(0)|0;h=0;i=b;return h|0}function wsf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=xsf(0,b,7,c)|0;i=a;return d|0}function xsf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;_dh();f=$of(0,b,d,e)|0;if((f+128|0)>>>0<256){i=a;return f&255|0}else{f=c[883982]|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,f);Auh(a)}return 0}function ysf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+16|0;f=b;c[f>>2]=0;if(vsf(0,d,1,e,f)|0)g=1;else{a[e>>0]=0;g=0}i=b;return g|0}function zsf(b){b=b|0;var c=0,d=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}d=Gvg(0,a[b>>0]|0,0)|0;i=c;return d|0}function Asf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Gvg(0,a[b>>0]|0,c)|0;i=d;return e|0}function Bsf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Csf(a,b,0)|0;i=c;return d|0}function Csf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=pvg(0,c,a[b>>0]|0,d)|0;i=e;return f|0}function Dsf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Esf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Fsf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Gsf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Hsf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=njg(0,b[c>>1]|0)|0;i=d;return e|0}function Isf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Bjg(0,b[c>>1]|0)|0;i=d;return e|0}function Jsf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Mjg(0,b[c>>1]|0)|0;i=d;return e|0}function Ksf(c,d,e){c=c|0;d=d|0;e=e|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Ujg(c,0,b[d>>1]|0)}function Lsf(c,d,e){c=c|0;d=d|0;e=e|0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}ikg(c,0,b[d>>1]|0);i=e;return}function Msf(c,d){c=c|0;d=d|0;var e=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=+wkg(0,b[c>>1]|0);i=d;return +e}function Nsf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Lkg(0,b[c>>1]|0)|0;i=d;return e|0}function Osf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Zkg(0,b[c>>1]|0)|0;i=d;return e|0}function Psf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=mlg(0,b[c>>1]|0)|0;i=d;return e|0}function Qsf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Blg(0,b[c>>1]|0)|0;i=d;return e|0}function Rsf(c,d){c=c|0;d=d|0;var e=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ea(Plg(0,b[c>>1]|0));i=d;return ea(e)}function Ssf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;$dh();if(!e){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[883986]|0);Auh(j)}b[h>>1]=b[d>>1]|0;RI(2562664)|0;d=pL(2562664,h)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,d,e,f,0)|0;i=g;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,d,e,f,0)|0;i=g;return k|0}function Tsf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=cmg(0,b[c>>1]|0)|0;i=d;return e|0}function Usf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=qmg(0,b[c>>1]|0)|0;i=d;return e|0}function Vsf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Emg(0,b[c>>1]|0)|0;i=d;return e|0}function Wsf(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;aeh();if(!d){f=1;i=e;return f|0}RI(2562664)|0;if(!(vL(d,2562664)|0)){g=c[883990]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}RI(2562664)|0;h=b[(Euh(d,2562664)|0)>>1]|0;d=b[a>>1]|0;if(d<<16>>16==h<<16>>16){f=0;i=e;return f|0}f=d<<16>>16>h<<16>>16?1:-1;i=e;return f|0}function Xsf(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=i;RI(2562664)|0;if(!(vL(c,2562664)|0)){e=0;i=d;return e|0}RI(2562664)|0;f=b[(Euh(c,2562664)|0)>>1]|0;e=f<<16>>16==(b[a>>1]|0);i=d;return e|0}function Ysf(a){a=a|0;return b[a>>1]|0}function Zsf(a,c){a=a|0;c=c|0;var d=0,e=0;d=b[a>>1]|0;if(d<<16>>16==c<<16>>16)e=0;else e=d<<16>>16>c<<16>>16?1:-1;return e|0}function _sf(a,c){a=a|0;c=c|0;return (b[a>>1]|0)==c<<16>>16|0}function $sf(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;beh();b[g>>1]=0;c[h>>2]=0;if(!e){if(f){j=0;i=d;return j|0}RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[884008]|0);c[h>>2]=k;j=0;i=d;return j|0}k=c[e+8>>2]|0;a:do if((k|0)>0){l=0;while(1){m=Wof(e,l)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}n=l+1|0;if(!(Xof(0,m)|0)){o=l;break a}if((n|0)<(k|0))l=n;else{o=n;break}}}else o=0;while(0);if((o|0)==(k|0)){if(f){j=0;i=d;return j|0}c[h>>2]=Yof(0)|0;j=0;i=d;return j|0}l=Wof(e,o)|0;if(l<<16>>16==45){p=o+1|0;q=-1}else if(l<<16>>16==43){p=o+1|0;q=1}else{p=o;q=1}b:do if((p|0)<(k|0)){o=0;l=p;n=0;while(1){m=Wof(e,l)|0;if((m+-48<<16>>16&65535)>9)if(Uof(0,f,e,l,h)|0){r=o;s=n}else{j=0;t=37;break}else{u=(m&65535)+208|0;m=o<<16>>16;if(o<<16>>16>=3277)break;if(o<<16>>16==3276){v=u;w=m;x=l;t=18;break}r=(u&255)+(m*10|0)&65535;s=1}l=l+1|0;if((l|0)>=(k|0)){t=29;break}else{o=r;n=s}}do if((t|0)==18){n=v&255;if(n>>>0>=8?!((q|0)!=1&n>>>0<9):0)break;if((q|0)==-1)y=(da(w,-10)|0)-n|0;else y=n+(w*10|0)|0;if(Uof(0,f,e,x+1|0,h)|0){b[g>>1]=y;j=1;i=d;return j|0}}else if((t|0)==29){if(!s)break b;if((q|0)==-1)z=0-(r&65535)&65535;else z=r;b[g>>1]=z;j=1;i=d;return j|0}else if((t|0)==37){i=d;return j|0}while(0);if(f){j=0;i=d;return j|0}RI(3086272)|0;n=qL(3086272)|0;xsg(n,c[884010]|0);c[h>>2]=n;j=0;i=d;return j|0}while(0);if(f){j=0;i=d;return j|0}c[h>>2]=Yof(0)|0;j=0;i=d;return j|0}function atf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=btf(0,b,7,c)|0;i=a;return d|0}function btf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;ceh();f=$of(0,b,d,e)|0;if((f+32768|0)>>>0<65536){i=a;return f&65535|0}else{RI(3086272)|0;f=qL(3086272)|0;xsg(f,c[884014]|0);Auh(f)}return 0}function ctf(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;a=i;i=i+16|0;f=a;c[f>>2]=0;if($sf(0,d,1,e,f)|0)g=1;else{b[e>>1]=0;g=0}i=a;return g|0}function dtf(c){c=c|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Gvg(0,b[c>>1]|0,0)|0;i=d;return e|0}function etf(c,d){c=c|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=Gvg(0,b[c>>1]|0,d)|0;i=e;return f|0}function ftf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=gtf(a,b,0)|0;i=c;return d|0}function gtf(c,d,e){c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}g=tvg(0,d,b[c>>1]|0,e)|0;i=f;return g|0}function htf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function itf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=rjg(0,b[c>>1]|0)|0;i=d;return e|0}function jtf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Fjg(0,b[c>>1]|0)|0;i=d;return e|0}function ktf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Qjg(0,b[c>>1]|0)|0;i=d;return e|0}function ltf(c,d,e){c=c|0;d=d|0;e=e|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}_jg(c,0,b[d>>1]|0)}function mtf(c,d,e){c=c|0;d=d|0;e=e|0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}mkg(c,0,b[d>>1]|0);i=e;return}function ntf(c,d){c=c|0;d=d|0;var e=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=+Akg(0,b[c>>1]|0);i=d;return +e}function otf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Pkg(0,b[c>>1]|0)|0;i=d;return e|0}function ptf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=blg(0,b[c>>1]|0)|0;i=d;return e|0}function qtf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=qlg(0,b[c>>1]|0)|0;i=d;return e|0}function rtf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Flg(0,b[c>>1]|0)|0;i=d;return e|0}function stf(c,d){c=c|0;d=d|0;var e=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ea(Tlg(0,b[c>>1]|0));i=d;return ea(e)}function ttf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;deh();if(!e){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[884018]|0);Auh(j)}b[h>>1]=b[d>>1]|0;RI(2565248)|0;d=pL(2565248,h)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,d,e,f,0)|0;i=g;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,d,e,f,0)|0;i=g;return k|0}function utf(a,c){a=a|0;c=c|0;return b[a>>1]|0}function vtf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=tmg(0,b[c>>1]|0)|0;i=d;return e|0}function wtf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Hmg(0,b[c>>1]|0)|0;i=d;return e|0}function xtf(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;d=i;eeh();if(!b){f=1;i=d;return f|0}RI(2565248)|0;if(!(vL(b,2565248)|0)){g=c[884022]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}h=e[a>>1]|0;RI(2565248)|0;f=h-(e[(Euh(b,2565248)|0)>>1]|0)|0;i=d;return f|0}function ytf(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=i;RI(2565248)|0;if(!(vL(c,2565248)|0)){e=0;i=d;return e|0}RI(2565248)|0;f=b[(Euh(c,2565248)|0)>>1]|0;e=f<<16>>16==(b[a>>1]|0);i=d;return e|0}function ztf(a){a=a|0;return e[a>>1]|0|0}function Atf(a,b){a=a|0;b=b|0;return (e[a>>1]|0)-(b&65535)|0}function Btf(a,c){a=a|0;c=c|0;return (b[a>>1]|0)==c<<16>>16|0}function Ctf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Dtf(0,b,7,c)|0;i=a;return d|0}function Dtf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;feh();f=Iqf(0,b,d,e)|0;if(f>>>0<65536){i=a;return f&65535|0}else{f=c[884042]|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,f);Auh(a)}return 0}function Etf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Ftf(0,b,7,0,c)|0;i=a;return d|0}function Ftf(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a;c[h>>2]=0;b[g>>1]=0;if(Lqf(0,d,e,f,h)|0?(f=c[h>>2]|0,f>>>0<65536):0){b[g>>1]=f;j=1}else j=0;i=a;return j|0}function Gtf(b){b=b|0;var c=0,d=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}d=Gvg(0,e[b>>1]|0,0)|0;i=c;return d|0}function Htf(b,c){b=b|0;c=c|0;var d=0,f=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=Gvg(0,e[b>>1]|0,c)|0;i=d;return f|0}function Itf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Jtf(a,b,0)|0;i=c;return d|0}function Jtf(c,d,e){c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}g=svg(0,d,b[c>>1]|0,e)|0;i=f;return g|0}function Ktf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Ltf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Mtf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Ntf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Otf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Ptf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2568232)|0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Qtf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2568568)|0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Rtf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2898256)|0;z5f(a,-4);c[c[d>>2]>>2]=a;i=b;return}function Stf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function Ttf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;a=i;RI(2540392)|0;b=(c[635121]|0)+4|0;RI(2540392)|0;d=(c[635121]|0)+8|0;RI(2540392)|0;e=(c[635121]|0)+12|0;RI(2540392)|0;f=(c[635121]|0)+16|0;RI(2540392)|0;g=(c[635121]|0)+20|0;RI(2540392)|0;h=(c[635121]|0)+24|0;RI(2540392)|0;Utf(0,b,d,e,f,g,h,(c[635121]|0)+28|0);i=a;return}function Utf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0;a=i;k=c[642332]|0;if(!k){l=MK(2569336)|0;c[642332]=l;m=l}else m=k;Wn[m&127](b,d,e,f,g,h,j);i=a;return}function Vtf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;geh();if(!e){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[884046]|0);Auh(j)}b[h>>1]=b[d>>1]|0;RI(2540392)|0;d=pL(2540392,h)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,d,e,f,0)|0;i=g;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,d,e,f,0)|0;i=g;return k|0}function Wtf(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);Auh(b);return 0}function Xtf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ujg(0,b[c>>1]|0)|0;i=d;return e|0}function Ytf(a,c){a=a|0;c=c|0;return b[a>>1]|0}function Ztf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);Auh(c)}function _tf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);Auh(c)}function $tf(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);Auh(b);return +(0.0)}function auf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Ekg(0,b[c>>1]|0)|0;i=d;return e|0}function buf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Tkg(0,b[c>>1]|0)|0;i=d;return e|0}function cuf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=flg(0,b[c>>1]|0)|0;i=d;return e|0}function duf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=vlg(0,b[c>>1]|0)|0;i=d;return e|0}function euf(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);Auh(b);return ea(0.0)}function fuf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Xlg(0,b[c>>1]|0)|0;i=d;return e|0}function guf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=jmg(0,b[c>>1]|0)|0;i=d;return e|0}function huf(c,d){c=c|0;d=d|0;var e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=xmg(0,b[c>>1]|0)|0;i=d;return e|0}function iuf(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;heh();if(!d){f=1;i=e;return f|0}RI(2540392)|0;if(!(vL(d,2540392)|0)){g=c[884050]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}RI(2540392)|0;h=b[(Euh(d,2540392)|0)>>1]|0;d=b[a>>1]|0;if(d<<16>>16==h<<16>>16){f=0;i=e;return f|0}f=(d&65535)>(h&65535)?1:-1;i=e;return f|0}function juf(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=i;RI(2540392)|0;if(!(vL(c,2540392)|0)){e=0;i=d;return e|0}RI(2540392)|0;f=b[(Euh(c,2540392)|0)>>1]|0;e=f<<16>>16==(b[a>>1]|0);i=d;return e|0}function kuf(a,c){a=a|0;c=c|0;var d=0,e=0;d=b[a>>1]|0;if(d<<16>>16==c<<16>>16)e=0;else e=(d&65535)>(c&65535)?1:-1;return e|0}function luf(a,c){a=a|0;c=c|0;return (b[a>>1]|0)==c<<16>>16|0}function muf(a){a=a|0;return e[a>>1]|0|0}function nuf(b,e){b=b|0;e=e|0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;i=b;return d[(c[(c[635121]|0)+4>>2]|0)+(e&65535)>>0]|0}function ouf(b,e){b=b|0;e=e|0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;i=b;return (d[(c[(c[635121]|0)+4>>2]|0)+(e&65535)>>0]|0)<5|0}function puf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;e=a[(c[(c[635121]|0)+4>>2]|0)+(d&65535)>>0]|0;i=b;return (e&255)<5|e<<24>>24==8|0}function quf(b,d){b=b|0;d=d|0;b=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;i=b;return (a[(c[(c[635121]|0)+4>>2]|0)+(d&65535)>>0]|0)==16|0}function ruf(a,b){a=a|0;b=b|0;var d=0;a=i;ieh();if(!b){RI(2963920)|0;d=qL(2963920)|0;Iag(d,c[884068]|0);Auh(d)}if((c[b+8>>2]|0)==1){d=Wof(b,0)|0;i=a;return d|0}else{d=c[884070]|0;RI(3079480)|0;a=qL(3079480)|0;Hrg(a,d);Auh(a)}return 0}function suf(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}d=Muh(2686848,Luh(2686512,eKf(0)|0)|0,c)|0;i=b;return d|0}function tuf(d,e){d=d|0;e=e|0;var f=0,g=0;d=i;f=e&65535;if((e&65535)<=9423){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;g=b[(c[(c[635121]|0)+16>>2]|0)+(f<<1)>>1]|0;i=d;return g|0}if((e&65535)<65313){g=e;i=d;return g|0}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;g=b[(c[(c[635121]|0)+20>>2]|0)+((f<<1)+446&131070)>>1]|0;i=d;return g|0}function uuf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;jeh();if(!e){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[884092]|0);Auh(f)}if((Aqh(2686456,e)|0)!=127){g=Muh(2686848,Luh(2686512,e)|0,d)|0;i=b;return g|0}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}g=tuf(0,d)|0;i=b;return g|0}function vuf(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}d=Muh(2778648,Luh(2686512,eKf(0)|0)|0,c)|0;i=b;return d|0}function wuf(d,e){d=d|0;e=e|0;var f=0,g=0;d=i;f=e&65535;if((e&65535)<=9449){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;g=b[(c[(c[635121]|0)+24>>2]|0)+(f<<1)>>1]|0;i=d;return g|0}if((e&65535)<65313){g=e;i=d;return g|0}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}RI(2540392)|0;g=b[(c[(c[635121]|0)+28>>2]|0)+((f<<1)+446&131070)>>1]|0;i=d;return g|0}function xuf(c){c=c|0;var d=0,e=0;d=i;if(!(a[2540708]|0))Buh(2540560);qL(2540560)|0;e=yuf(0,b[c>>1]|0,1)|0;i=d;return e|0}function yuf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;Qeh();if((f|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[884898]|0);Auh(g)}g=(a[2540708]|0)!=0;if(!f){if(!g)Buh(2540560);h=c[c[635163]>>2]|0;i=d;return h|0}if(!g)Buh(2540560);g=ivf(0,f)|0;j=g+(bvf(0)|0)|0;k=j;l=j+(f<<1)|0;if(k>>>0<l>>>0)m=k;else{h=g;i=d;return h|0}do{b[m>>1]=e;m=m+2|0}while(m>>>0<l>>>0);h=g;i=d;return h|0}function zuf(c,d){c=c|0;d=d|0;var e=0;d=i;if(!(a[2540708]|0))Buh(2540560);qL(2540560)|0;e=yuf(0,b[c>>1]|0,1)|0;i=d;return e|0}function Auf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function Buf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[643280]|0;if(!g){h=MK(2573128)|0;c[643280]=h;j=h}else j=g;Dn[j&511](a,b,d,e);i=f;return}function Cuf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[643298]|0;if(!g){h=MK(2573200)|0;c[643298]=h;j=h}else j=g;Dn[j&511](a,b,d,e);i=f;return}function Duf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[643316]|0;if(!e){f=MK(2573272)|0;c[643316]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function Euf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[643328]|0;if(!f){g=MK(2573320)|0;c[643328]=g;h=g}else h=f;co[h&2047](a,b,d);i=e;return}function Fuf(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;keh();c[c[635163]>>2]=c[884100];RI(1136088)|0;e=Huh(1136088,27)|0;c[d>>2]=314e4;c[b+0>>2]=c[d+0>>2];Guf(0,e,b);c[(c[635163]|0)+4>>2]=e;i=a;return}function Guf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;i=i+16|0;e=a+4|0;f=a;if((b|0)!=0?(g=c[d>>2]|0,RI(2604248)|0,(g|0)!=(c[c[651085]>>2]|0)):0){c[f>>2]=g;c[e+0>>2]=c[f+0>>2];$If(0,b,e);i=a;return}RI(2963920)|0;a=qL(2963920)|0;Ucg(a);Auh(a)}function Huf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ojg(0,b,c)|0;i=d;return e|0}function Iuf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Cjg(0,b,c)|0;i=d;return e|0}function Juf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Njg(0,b,c)|0;i=d;return e|0}function Kuf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Sjg(b,0,c,d);i=e;return}function Luf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}jkg(b,0,c,d);i=e;return}function Muf(b,c){b=b|0;c=c|0;var d=0,e=0.0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=+xkg(0,b,c);i=d;return +e}function Nuf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Mkg(0,b,c)|0;i=d;return e|0}function Ouf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=_kg(0,b,c)|0;i=d;return e|0}function Puf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=nlg(0,b,c)|0;i=d;return e|0}function Quf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Clg(0,b,c)|0;i=d;return e|0}function Ruf(b,c){b=b|0;c=c|0;var d=0,e=Im;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=ea(Qlg(0,b,c));i=d;return ea(e)}function Suf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;leh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[884104]|0);Auh(g)}RI(3034288)|0;if(a[3034436]|0){h=Lmg(0,b,d,e,0)|0;i=f;return h|0}RI(3034288)|0;Buh(3034288);h=Lmg(0,b,d,e,0)|0;i=f;return h|0}function Tuf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=dmg(0,b,c)|0;i=d;return e|0}function Uuf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=rmg(0,b,c)|0;i=d;return e|0}function Vuf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}e=Fmg(0,b,c)|0;i=d;return e|0}function Wuf(a){a=a|0;var b=0,c=0;b=i;RI(3032096)|0;c=qL(3032096)|0;Tig(c,a);i=b;return c|0}function Xuf(a){a=a|0;var b=0,c=0;b=i;RI(3032096)|0;c=qL(3032096)|0;Tig(c,a);i=b;return c|0}function Yuf(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;a=i;a:do if((d|0)!=(e|0))if((d|0)!=0&(e|0)!=0?(f=c[d+8>>2]|0,(f|0)==(c[e+8>>2]|0)):0){g=d+12|0;h=e+12|0;if((f|0)>7){j=f;k=g;l=h;while(1){if((c[k>>2]|0)!=(c[l>>2]|0)){m=0;break a}if((c[k+4>>2]|0)!=(c[l+4>>2]|0)){m=0;break a}if((c[k+8>>2]|0)!=(c[l+8>>2]|0)){m=0;break a}if((c[k+12>>2]|0)!=(c[l+12>>2]|0)){m=0;break a}n=k+16|0;o=l+16|0;p=j+-8|0;if((p|0)>7){j=p;k=n;l=o}else{q=p;r=n;s=o;break}}}else{q=f;r=g;s=h}if((q|0)<4){t=q;u=r;v=s}else{if((c[r>>2]|0)!=(c[s>>2]|0)){m=0;break}if((c[r+4>>2]|0)!=(c[s+4>>2]|0)){m=0;break}t=q+-4|0;u=r+8|0;v=s+8|0}if((t|0)<2){w=t;x=u;y=v}else{if((c[u>>2]|0)!=(c[v>>2]|0)){m=0;break}w=t+-2|0;x=u+4|0;y=v+4|0}if(!w)m=1;else m=(b[x>>1]|0)==(b[y>>1]|0)}else m=0;else m=1;while(0);i=a;return m|0}function Zuf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;if(!(a[2540708]|0))Buh(2540560);e=Yuf(0,b,vL(c,2540560)|0)|0;i=d;return e|0}function _uf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;if(!(a[2540708]|0))Buh(2540560);e=Yuf(0,b,c)|0;i=d;return e|0}function $uf(a){a=a|0;var b=0,d=0;b=i;d=avf(a,0,c[a+8>>2]|0)|0;i=b;return d|0}function avf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;meh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884110]|0,c[884112]|0);Auh(g)}if((e|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884114]|0,c[884116]|0);Auh(g)}if(((c[b+8>>2]|0)-e|0)<(d|0)){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884118]|0,c[884120]|0);Auh(g)}RI(1136088)|0;g=Huh(1136088,e)|0;if((g|0)!=0?(c[g+12>>2]|0)!=0:0)h=g+16|0;else h=0;j=(bvf(0)|0)+b|0;if(a[2540708]|0){k=j;l=d<<1;m=k+l|0;cvf(0,h,m,e);i=f;return g|0}Buh(2540560);k=j;l=d<<1;m=k+l|0;cvf(0,h,m,e);i=f;return g|0}function bvf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[667932]|0;if(!b){d=MK(2671736)|0;c[667932]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function cvf(c,d,e,f){c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;c=i;g=d;h=e;if((h|g)&3){if((g&2|0)!=0?!((h&2|0)==0|(f|0)<1):0){b[d>>1]=b[e>>1]|0;j=f+-1|0;k=e+2|0;l=d+2|0}else{j=f;k=e;l=d}if(!((k|l)&2)){m=j;n=k;o=l}else{if(!(a[2540708]|0))Buh(2540560);Dwf(0,l,k,j<<1);i=c;return}}else{m=f;n=e;o=d}if(!(a[2540708]|0))Buh(2540560);Cwf(0,o,n,m<<1);i=c;return}function dvf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=evf(a,b,2147483647)|0;i=c;return d|0}function evf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;neh();if((d|0)!=0?(c[d+12>>2]|0)!=0:0)g=d;else{if(!(a[2540708]|0))Buh(2540560);g=c[(c[635163]|0)+4>>2]|0}if((e|0)<=-1){RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[884160]|0);Auh(d)}if((e|0)==1){RI(1094176)|0;d=Huh(1094176,1)|0;Qqh(d,b);c[d+16>>2]=b;h=d;i=f;return h|0}else if(!e){RI(1094176)|0;h=Huh(1094176,0)|0;i=f;return h|0}else{h=fvf(b,g,e,0)|0;i=f;return h|0}return 0}function fvf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[643342]|0;if(!g){h=MK(2573376)|0;c[643342]=h;j=h}else j=g;g=kn[j&511](a,b,d,e)|0;i=f;return g|0}function gvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;oeh();if(!b){e=a;i=d;return e|0}if((b|0)>=0?(f=c[a+8>>2]|0,(f|0)>=(b|0)):0){e=hvf(a,b,f-b|0)|0;i=d;return e|0}RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[884168]|0);Auh(e);return 0}function hvf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=(a[2540708]|0)!=0;if(!e){if(!g)Buh(2540560);h=c[c[635163]>>2]|0;i=f;return h|0}else{if(!g)Buh(2540560);g=ivf(0,e)|0;j=g+(bvf(0)|0)|0;cvf(0,j,(bvf(0)|0)+b+(d<<1)|0,e);h=g;i=f;return h|0}return 0}function ivf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[643362]|0;if(!d){e=MK(2573456)|0;c[643362]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function jvf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+8|0;f=c[e>>2]|0;if(!f){if(!(a[2540708]|0))Buh(2540560);g=c[c[635163]>>2]|0;i=d;return g|0}h=kvf(b,0,f,1)|0;f=c[e>>2]|0;if((h|0)==(f|0)){if(!(a[2540708]|0))Buh(2540560);g=c[c[635163]>>2]|0;i=d;return g|0}else{j=(kvf(b,f+-1|0,h,-1)|0)-h+1|0;if((j|0)==(c[e>>2]|0)){g=b;i=d;return g|0}g=hvf(b,h,j)|0;i=d;return g|0}return 0}function kvf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;a:do if((b|0)==(c|0))f=b;else{g=b;while(1){h=Wof(a,g)|0;if((h&65535)>132){if(!(h<<16>>16==8287|h<<16>>16==8239|h<<16>>16==8233|h<<16>>16==8232|h<<16>>16==5760|h<<16>>16==133|h<<16>>16==12288|h<<16>>16==-257|h<<16>>16==160)?(h+-8192<<16>>16&65535)>=12:0){f=g;break a}}else switch(h<<16>>16){case 9:case 10:case 11:case 12:case 13:case 32:break;default:{f=g;break a}}g=g+d|0;if((g|0)==(c|0)){f=c;break}}}while(0);i=e;return f|0}function lvf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+8|0;g=c[f>>2]|0;if(!g){if(!(a[2540708]|0))Buh(2540560);h=c[c[635163]>>2]|0;i=e;return h|0}if((d|0)!=0?(c[d+12>>2]|0)!=0:0)j=mvf(b,0,g,1,d)|0;else j=kvf(b,0,g,1)|0;if(!j){h=b;i=e;return h|0}h=hvf(b,j,(c[f>>2]|0)-j|0)|0;i=e;return h|0}function mvf(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;if((g|0)!=0?(c[g+12>>2]|0)!=0:0)j=g+16|0;else j=0;k=bvf(0)|0;if((d|0)==(e|0)){l=d;i=h;return l|0}m=k+a|0;a=c[g+12>>2]|0;g=(a|0)>0;k=d;while(1){d=b[m+(k<<1)>>1]|0;a:do if(g){n=0;while(1){o=n+1|0;if(d<<16>>16==(b[j+(n<<1)>>1]|0)){p=n;break a}if((o|0)<(a|0))n=o;else{p=o;break}}}else p=0;while(0);if((p|0)==(a|0)){l=k;q=11;break}k=k+f|0;if((k|0)==(e|0)){l=e;q=11;break}}if((q|0)==11){i=h;return l|0}return 0}function nvf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+8|0;g=c[f>>2]|0;if(!g){if(!(a[2540708]|0))Buh(2540560);h=c[c[635163]>>2]|0;i=e;return h|0}if((d|0)!=0?(c[d+12>>2]|0)!=0:0)j=mvf(b,g+-1|0,-1,-1,d)|0;else j=kvf(b,g+-1|0,-1,-1)|0;g=j+1|0;if((g|0)==(c[f>>2]|0)){h=b;i=e;return h|0}h=hvf(b,0,g)|0;i=e;return h|0}function ovf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}e=Nuh(2724e3,Fuh(2723944,eKf(0)|0)|0,c,d,0)|0;i=b;return e|0}function pvf(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}f=Nuh(2724e3,Fuh(2723944,eKf(0)|0)|0,c,d,e&1)|0;i=b;return f|0}function qvf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;qeh();if(!f){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[884234]|0);Auh(g)}else{g=Nuh(2724e3,Fuh(2723944,f)|0,b,d,e&1)|0;i=a;return g|0}return 0}function rvf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;a=i;reh();if(!j){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[884238]|0);Auh(k)}k=c[b+8>>2]|0;if((k|0)<(d|0)){RI(2964880)|0;l=qL(2964880)|0;_eg(l);Auh(l)}m=c[e+8>>2]|0;if(!((g|0)>-1&(((m|0)<(f|0)|(d|0)<0|(f|0)<0)^1))){RI(2964880)|0;l=qL(2964880)|0;_eg(l);Auh(l)}if(!g){n=0;i=a;return n|0}l=(e|0)!=0;if(!b){n=l<<31>>31;i=a;return n|0}if(!l){n=1;i=a;return n|0}l=k-d|0;k=m-f|0;n=Ouh(2752104,Fuh(2723944,j)|0,b,d,(l|0)<(g|0)?l:g,e,f,(k|0)<(g|0)?k:g,h&1)|0;i=a;return n|0}function svf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!c){e=1;i=d;return e|0}if(!(vL(c,2540560)|0)){RI(2965048)|0;f=qL(2965048)|0;oig(f);Auh(f)}if(!(a[2540708]|0))Buh(2540560);e=ovf(0,b,Juh(c,2540560)|0)|0;i=d;return e|0}function tvf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;if(!c){e=1;i=d;return e|0}if(!(a[2540708]|0))Buh(2540560);e=ovf(0,b,c)|0;i=d;return e|0}function uvf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;b=i;if((c[d+8>>2]|0)>=(e|0)?(h|0)>-1&((((e|0)<0?1:(c[f+8>>2]|0)<(g|0))|(g|0)<0)^1):0){if(a[2540708]|0){j=vvf(0,d,e,h,f,g,h)|0;i=b;return j|0}Buh(2540560);j=vvf(0,d,e,h,f,g,h)|0;i=b;return j|0}RI(2964880)|0;j=qL(2964880)|0;_eg(j);Auh(j);return 0}function vvf(a,d,e,f,g,h,j){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;k=(g|0)!=0;if(!d){l=k<<31>>31;i=a;return l|0}if(!k){l=1;i=a;return l|0}k=Bsg(0,f,(c[d+8>>2]|0)-e|0)|0;f=Bsg(0,j,(c[g+8>>2]|0)-h|0)|0;if((k|0)==(f|0)&(d|0)==(g|0)){l=0;i=a;return l|0}j=(bvf(0)|0)+d|0;d=bvf(0)|0;m=j;j=e<<1;e=((Bsg(0,k,f)|0)<<1)+j|0;n=m+e|0;a:do if((j|0)<(e|0)){o=m+j|0;p=d+g+(h<<1)|0;while(1){q=b[o>>1]|0;r=b[p>>1]|0;if(q<<16>>16!=r<<16>>16){s=q;t=r;break}o=o+2|0;if(o>>>0>=n>>>0)break a;else p=p+2|0}l=(s&65535)-(t&65535)|0;i=a;return l|0}while(0);l=k-f|0;i=a;return l|0}function wvf(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;l=(h|0)!=0;if(!e){m=l<<31>>31;i=d;return m|0}if(!l){m=1;i=d;return m|0}l=Bsg(0,g,(c[e+8>>2]|0)-f|0)|0;g=Bsg(0,k,(c[h+8>>2]|0)-j|0)|0;if((l|0)==(g|0)&(e|0)==(h|0)){m=0;i=d;return m|0}k=(bvf(0)|0)+e|0;e=bvf(0)|0;n=k;k=f<<1;f=((Bsg(0,l,g)|0)<<1)+k|0;o=n+f|0;a:do if((k|0)<(f|0)){p=n+k|0;q=e+h+(j<<1)|0;while(1){if((b[p>>1]|0)!=(b[q>>1]|0)){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}r=wuf(0,b[p>>1]|0)|0;s=wuf(0,b[q>>1]|0)|0;if(r<<16>>16!=s<<16>>16){t=r;u=s;break}}p=p+2|0;if(p>>>0>=o>>>0)break a;else q=q+2|0}m=(t&65535)-(u&65535)&65535;i=d;return m|0}while(0);m=l-g|0;i=d;return m|0}function xvf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;seh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[884242]|0);Auh(f)}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}f=Puh(2754616,Fuh(2723944,eKf(0)|0)|0,b,d,0)|0;i=e;return f|0}function yvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b){RI(2963920)|0;e=qL(2963920)|0;Ucg(e);Auh(e)}e=c[a+8>>2]|0;if(!e){f=-1;i=d;return f|0}f=zvf(a,b,0,e)|0;i=d;return f|0}function zvf(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;j=c[d+12>>2]|0;if(!j){k=-1;i=h;return k|0}else if((j|0)!=1){if(!d)l=0;else l=d+16|0;m=b[l>>1]|0;n=m&65535;o=l+(j<<1)|0;j=n;p=n;n=l;a:while(1){q=j;r=n;while(1){s=r+2|0;if((s|0)==(o|0)){t=q;u=p;break a}v=e[s>>1]|0;if(v>>>0>q>>>0){q=v;r=s}else{w=v;x=s;y=q;break}}j=y;p=w>>>0<p>>>0?w:p;n=x}x=a+12|0;n=x+(g+f<<1)|0;if(!g){k=-1;i=h;return k|0}p=x+(f<<1)|0;b:while(1){w=b[p>>1]|0;y=w&65535;c:do if(!(y>>>0>t>>>0|y>>>0<u>>>0)){if(w<<16>>16==m<<16>>16){z=p;A=14;break b}else B=l;while(1){B=B+2|0;if((B|0)==(o|0))break c;if(w<<16>>16==(b[B>>1]|0)){C=p;A=15;break b}}}while(0);p=p+2|0;if((p|0)==(n|0)){k=-1;A=19;break}}if((A|0)==14){k=(z-x|0)/2|0;i=h;return k|0}else if((A|0)==15){k=(C-x|0)/2|0;i=h;return k|0}else if((A|0)==19){i=h;return k|0}}else{k=Avf(a,b[d+16>>1]|0,f,g)|0;i=h;return k|0}return 0}function Avf(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;g=a+12|0;a=g+(d<<1)|0;h=a+(e<<1&-16)|0;a:do if((a|0)!=(h|0)){j=a;while(1){if((b[j>>1]|0)==c<<16>>16){k=j;l=2;break}if((b[j+2>>1]|0)==c<<16>>16){m=j;l=4;break}if((b[j+4>>1]|0)==c<<16>>16){n=j;l=6;break}if((b[j+6>>1]|0)==c<<16>>16){o=j;l=8;break}if((b[j+8>>1]|0)==c<<16>>16){p=j;l=10;break}if((b[j+10>>1]|0)==c<<16>>16){q=j;l=12;break}if((b[j+12>>1]|0)==c<<16>>16){r=j;l=14;break}if((b[j+14>>1]|0)==c<<16>>16){s=j;l=16;break}j=j+16|0;if((j|0)==(h|0)){t=h;break a}}if((l|0)==2){u=(k-g|0)/2|0;i=f;return u|0}else if((l|0)==4){u=((m-g|0)/2|0)+1|0;i=f;return u|0}else if((l|0)==6){u=((n-g|0)/2|0)+2|0;i=f;return u|0}else if((l|0)==8){u=((o-g|0)/2|0)+3|0;i=f;return u|0}else if((l|0)==10){u=((p-g|0)/2|0)+4|0;i=f;return u|0}else if((l|0)==12){u=((q-g|0)/2|0)+5|0;i=f;return u|0}else if((l|0)==14){u=((r-g|0)/2|0)+6|0;i=f;return u|0}else if((l|0)==16){u=((s-g|0)/2|0)+7|0;i=f;return u|0}}else t=a;while(0);a=g+(e+d<<1)|0;if((t|0)==(a|0)){u=-1;i=f;return u|0}else v=t;while(1){if((b[v>>1]|0)==c<<16>>16){w=v;break}v=v+2|0;if((v|0)==(a|0)){u=-1;l=23;break}}if((l|0)==23){i=f;return u|0}u=(w-g|0)/2|0;i=f;return u|0}function Bvf(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=c[d+8>>2]|0;if((h|0)>(f|0)){j=-1;i=g;return j|0}if((h|0)<=1){if((h|0)!=1){j=e;i=g;return j|0}j=Avf(a,Wof(d,0)|0,e,f)|0;i=g;return j|0}k=(bvf(0)|0)+a|0;a=(bvf(0)|0)+d|0;d=k;l=e<<1;e=d+l|0;m=d+((f<<1)+l)-(h<<1)|0;if((e|0)==(m+2|0)){j=-1;i=g;return j|0}l=b[a>>1]|0;f=a;a=e;a:while(1){b:do if((b[a>>1]|0)==l<<16>>16){e=1;while(1){d=e<<1;e=e+1|0;if((b[a+d>>1]|0)!=(b[f+d>>1]|0))break b;if((e|0)>=(h|0)){n=a;break a}}}while(0);if((a|0)==(m|0)){j=-1;o=12;break}else a=a+2|0}if((o|0)==12){i=g;return j|0}j=(n-k|0)/2|0;i=g;return j|0}function Cvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;if(!e)f=-1;else f=Avf(a,b,0,e)|0;i=d;return f|0}function Dvf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;teh();if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;Qag(f,c[884250]|0,c[884252]|0);Auh(f)}f=c[a+8>>2]|0;if((f|0)<(d|0)){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884254]|0,c[884256]|0);Auh(g)}if((f|d|0)==0|(f|0)==(d|0)){h=-1;i=e;return h|0}h=Avf(a,b,d,f-d|0)|0;i=e;return h|0}function Evf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;ueh();if((d|0)>=0?(g=c[a+8>>2]|0,(g|0)>=(d|0)):0){if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884276]|0,c[884278]|0);Auh(h)}if((g-e|0)<(d|0)){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884280]|0,c[884282]|0);Auh(h)}if(!(g|d)){j=-1;i=f;return j|0}if(!((g|0)!=(d|0)&(e|0)!=0)){j=-1;i=f;return j|0}j=Avf(a,b,d,e)|0;i=f;return j|0}RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[884272]|0,c[884274]|0);Auh(j);return 0}function Fvf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;veh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[884320]|0);Auh(f)}if(!(c[d+8>>2]|0)){g=0;i=e;return g|0}f=b+8|0;if(!(c[f>>2]|0)){g=-1;i=e;return g|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}h=Fuh(2723944,eKf(0)|0)|0;g=Quh(2752048,h,b,d,0,c[f>>2]|0,1073741824)|0;i=e;return g|0}function Gvf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=dpf(a,b,d,(c[a+8>>2]|0)-d|0)|0;i=e;return f|0}function Hvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(!b){RI(2963920)|0;e=qL(2963920)|0;Ucg(e);Auh(e)}else{e=c[a+8>>2]|0;f=Ivf(a,b,e+-1|0,e)|0;i=d;return f|0}return 0}function Ivf(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=d+12|0;if((c[h>>2]|0)==1){j=Jvf(a,b[d+16>>1]|0,e,f)|0;i=g;return j|0}k=(bvf(0)|0)+a|0;a=c[h>>2]|0;h=(a|0)==0;if(h)l=0;else l=d+16|0;d=k+(e<<1)|0;e=d-(f<<1)|0;f=l+(a<<1)|0;if((d|0)==(e|0)){j=-1;i=g;return j|0}else m=d;a:while(1){if(!h){d=b[m>>1]|0;a=l;do{if((b[a>>1]|0)==d<<16>>16){n=m;break a}a=a+2|0}while((a|0)!=(f|0))}m=m+-2|0;if((m|0)==(e|0)){j=-1;o=12;break}}if((o|0)==12){i=g;return j|0}j=(n-k|0)/2|0;i=g;return j|0}function Jvf(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;g=a+12|0;a=g+(d<<1)|0;d=e<<1;e=a-(d&-16)|0;h=e;a:do if((a|0)!=(h|0)){j=a;while(1){if((b[j>>1]|0)==c<<16>>16){k=j;l=2;break}if((b[j+-2>>1]|0)==c<<16>>16){m=j;l=4;break}if((b[j+-4>>1]|0)==c<<16>>16){n=j;l=6;break}if((b[j+-6>>1]|0)==c<<16>>16){o=j;l=8;break}if((b[j+-8>>1]|0)==c<<16>>16){p=j;l=10;break}if((b[j+-10>>1]|0)==c<<16>>16){q=j;l=12;break}if((b[j+-12>>1]|0)==c<<16>>16){r=j;l=14;break}s=j;if((b[j+-14>>1]|0)==c<<16>>16){t=s;l=16;break}j=s+-16|0;if((j|0)==(h|0)){u=h;break a}}if((l|0)==2){v=(k-g|0)/2|0;i=f;return v|0}else if((l|0)==4){v=((m-g|0)/2|0)+-1|0;i=f;return v|0}else if((l|0)==6){v=((n-g|0)/2|0)+-2|0;i=f;return v|0}else if((l|0)==8){v=((o-g|0)/2|0)+-3|0;i=f;return v|0}else if((l|0)==10){v=((p-g|0)/2|0)+-4|0;i=f;return v|0}else if((l|0)==12){v=((q-g|0)/2|0)+-5|0;i=f;return v|0}else if((l|0)==14){v=((r-g|0)/2|0)+-6|0;i=f;return v|0}else if((l|0)==16){v=((t-g|0)/2|0)+-7|0;i=f;return v|0}}else u=a;while(0);a=e-(d&14)|0;if((u|0)==(a|0)){v=-1;i=f;return v|0}else w=u;while(1){u=w;if((b[w>>1]|0)==c<<16>>16){x=u;break}w=u+-2|0;if((w|0)==(a|0)){v=-1;l=23;break}}if((l|0)==23){i=f;return v|0}v=(x-g|0)/2|0;i=f;return v|0}function Kvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;if(!e){f=-1;i=d;return f|0}f=Jvf(a,b,e+-1|0,e)|0;i=d;return f|0}function Lvf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;xeh();if(!d){g=c[a+8>>2]|0;if(!g){h=-1;i=f;return h|0}else{j=g;k=5}}else if((d|0)>=0){j=c[a+8>>2]|0;k=5}if((k|0)==5?(j|0)>(d|0):0){if((e|0)<0|(j|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[884400]|0,c[884402]|0);Auh(j)}if((d-e|0)<=-2){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[884404]|0);Auh(j)}h=Jvf(a,b,d,e)|0;i=f;return h|0}RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884396]|0,c[884398]|0);Auh(h);return 0}function Mvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;if(!e){f=Nvf(a,b,0,0)|0;i=d;return f|0}else{f=Nvf(a,b,e+-1|0,e)|0;i=d;return f|0}return 0}function Nvf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;yeh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[884444]|0);Auh(h)}if((e|0)<-1){RI(2964880)|0;j=qL(2964880)|0;k=c[884446]|0;l=c[884448]|0;Qag(j,k,l);Auh(j)}h=c[b+8>>2]|0;if((h|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;k=c[884446]|0;l=c[884448]|0;Qag(j,k,l);Auh(j)}if((f|0)<0|(h|0)<(f|0)){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[884450]|0,c[884452]|0);Auh(j)}if((e-f|0)<=-2){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[884454]|0);Auh(j)}j=c[d+8>>2]|0;if(!j){m=e;i=g;return m|0}if(!(h|e)){m=-1;i=g;return m|0}if(!h){if((j|0)>0|(f|0)==0){m=-1;i=g;return m|0}}else if(!f){m=-1;i=g;return m|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}m=Guh(2754720,Fuh(2723944,eKf(0)|0)|0,b,d,(((h|0)==(e|0))<<31>>31)+e|0,f)|0;i=g;return m|0}function Ovf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;zeh();if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884458]|0,c[884460]|0);Auh(h)}h=d+8|0;if((c[h>>2]|0)>(e|0)){j=d;i=g;return j|0}k=(a[2540708]|0)!=0;if(!e){if(!k)Buh(2540560);j=c[c[635163]>>2]|0;i=g;return j|0}if(!k)Buh(2540560);k=ivf(0,e)|0;l=k+(bvf(0)|0)|0;m=(bvf(0)|0)+d|0;cvf(0,l,m,c[h>>2]|0);m=l;l=c[h>>2]<<1;h=e<<1;e=m+h|0;if((l|0)==(h|0)){j=k;i=g;return j|0}h=m+l|0;do{b[h>>1]=f;h=h+2|0}while((h|0)!=(e|0));j=k;i=g;return j|0}function Pvf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Aeh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[884470]|0);Auh(f)}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}f=Puh(2754520,Fuh(2723944,eKf(0)|0)|0,b,d,0)|0;i=e;return f|0}function Qvf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=d+8|0;j=c[h>>2]|0;if((j|0)==0?1:e<<16>>16==f<<16>>16){k=d;i=g;return k|0}l=Avf(d,e,0,j)|0;if((l|0)==-1){k=d;i=g;return k|0}m=(l|0)>3?l:0;if(!(a[2540708]|0))Buh(2540560);l=ivf(0,j)|0;j=l+(bvf(0)|0)|0;n=j;o=d+12|0;if(m){if(!(a[2540708]|0))Buh(2540560);cvf(0,n,o,m)}n=j;j=c[h>>2]<<1;h=n+j|0;d=m<<1;if((d|0)==(j|0)){k=l;i=g;return k|0}j=n+d|0;d=o+(m<<1)|0;while(1){m=b[d>>1]|0;b[j>>1]=m<<16>>16==e<<16>>16?f:m;j=j+2|0;if((j|0)==(h|0)){k=l;break}else d=d+2|0}i=g;return k|0}function Rvf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;Beh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[884474]|0);Auh(g)}if(!(c[d+8>>2]|0)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[884476]|0);Auh(g)}if(!(c[b+8>>2]|0)){h=b;i=f;return h|0}if(!e){if(!(a[2540708]|0))Buh(2540560);j=c[c[635163]>>2]|0}else j=e;h=Svf(b,d,j)|0;i=f;return h|0}function Svf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;g=d+8|0;h=c[g>>2]|0;j=b+8|0;if((h|0)>(c[j>>2]|0)){k=b;i=f;return k|0}if((h|0)==1?(c[e+8>>2]|0)==1:0){h=Wof(d,0)|0;k=Qvf(b,h,Wof(e,0)|0)|0;i=f;return k|0}h=i;i=i+800|0;l=(bvf(0)|0)+b|0;m=(bvf(0)|0)+e|0;n=c[j>>2]|0;if((n|0)>0){o=n;p=0;q=0}else{k=b;i=f;return k|0}while(1){n=Bvf(b,d,p,o-p|0)|0;if((n|0)<=-1){r=q;break}if((q|0)>199){s=8;break}t=q+1|0;c[h+(q<<2)>>2]=n;p=(c[g>>2]|0)+n|0;o=c[j>>2]|0;if((o|0)<=(p|0)){r=t;break}else q=t}if((s|0)==8){k=Tvf(b,d,e,200)|0;i=f;return k|0}if(!r){k=b;i=f;return k|0}b=e+8|0;e=(da((c[b>>2]|0)-(c[g>>2]|0)|0,r)|0)+(c[j>>2]|0)|0;if(!(a[2540708]|0))Buh(2540560);d=ivf(0,e)|0;e=d+(bvf(0)|0)|0;if((r|0)>0){s=e;q=l;p=0;o=0;t=0;while(1){n=c[h+(o<<2)>>2]|0;u=n-p|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,s+(t<<1)|0,q+(p<<1)|0,u);v=u+t|0;u=n+(c[g>>2]|0)|0;cvf(0,s+(v<<1)|0,m,c[b>>2]|0);n=(c[b>>2]|0)+v|0;o=o+1|0;if((o|0)==(r|0)){w=u;x=n;break}else{p=u;t=n}}y=w;z=x<<1}else{y=0;z=0}x=c[j>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,e+z|0,l+(y<<1)|0,x-y|0);k=d;i=f;return k|0}function Tvf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a+8|0;h=b+8|0;j=(da((c[d+8>>2]|0)-(c[h>>2]|0)|0,e)|0)+(c[g>>2]|0)|0;RI(2971904)|0;e=qL(2971904)|0;Ueg(e,j);j=c[g>>2]|0;a:do if((j|0)>0){k=j;l=0;while(1){m=Bvf(a,b,l,k-l|0)|0;if((m|0)<=-1){n=l;break}Hbg(e,hvf(a,l,m-l|0)|0)|0;Hbg(e,d)|0;l=(c[h>>2]|0)+m|0;k=c[g>>2]|0;if((k|0)<=(l|0))break a}Hbg(e,hvf(a,n,(c[g>>2]|0)-n|0)|0)|0}while(0);n=Fqh(2972072,e)|0;i=f;return n|0}function Uvf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;Ceh();if((d|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884500]|0,c[884502]|0);Auh(g)}if((e|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884504]|0,c[884506]|0);Auh(g)}g=b+8|0;h=(c[g>>2]|0)-e|0;if((h|0)<(d|0)){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[884508]|0,c[884510]|0);Auh(j)}if(!(a[2540708]|0))Buh(2540560);j=ivf(0,h)|0;h=j+(bvf(0)|0)|0;k=(bvf(0)|0)+b|0;cvf(0,h,k,d);b=e+d|0;cvf(0,h+(d<<1)|0,k+(b<<1)|0,(c[g>>2]|0)-b|0);i=f;return j|0}function Vvf(b){b=b|0;var c=0,d=0;c=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}d=Wvf(b,eKf(0)|0)|0;i=c;return d|0}function Wvf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;Deh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[884514]|0);Auh(e)}if((Aqh(2686456,b)|0)==127){f=Xvf(a)|0;i=d;return f|0}else{f=Vth(2725048,Luh(2686512,b)|0,a)|0;i=d;return f|0}return 0}function Xvf(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;h=(a[2540708]|0)==0;if(!g){if(h)Buh(2540560);j=c[c[635163]>>2]|0;i=e;return j|0}if(h)Buh(2540560);h=ivf(0,g)|0;g=bvf(0)|0;if((c[f>>2]|0)<=0){j=h;i=e;return j|0}k=h+g|0;g=d+12|0;d=0;while(1){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}b[k>>1]=tuf(0,b[g>>1]|0)|0;d=d+1|0;if((d|0)>=(c[f>>2]|0)){j=h;break}else{k=k+2|0;g=g+2|0}}i=e;return j|0}function Yvf(a){a=a|0;return a|0}function Zvf(a,b){a=a|0;b=b|0;return a|0}function _vf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;b=i;RI(1086352)|0;f=Huh(1086352,1)|0;Qqh(f,e);c[f+16>>2]=e;if(!(a[2540708]|0))Buh(2540560);e=$vf(0,0,d,f)|0;i=b;return e|0}function $vf(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;if(!(a[2540708]|0))Buh(2540560);f=Fqh(2972072,dwf(0,0,c,d,e)|0)|0;i=b;return f|0}function awf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;RI(1086352)|0;g=Huh(1086352,2)|0;Qqh(g,e);h=g+16|0;c[h>>2]=e;Qqh(g,f);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=f;if(a[2540708]|0){j=$vf(0,0,d,g)|0;i=b;return j|0}Buh(2540560);j=$vf(0,0,d,g)|0;i=b;return j|0}function bwf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;b=i;RI(1086352)|0;h=Huh(1086352,3)|0;Qqh(h,e);j=h+16|0;c[j>>2]=e;Qqh(h,f);c[j+(c[(c[h>>2]|0)+120>>2]|0)>>2]=f;Qqh(h,g);c[j+(c[(c[h>>2]|0)+120>>2]<<1)>>2]=g;if(a[2540708]|0){k=$vf(0,0,d,h)|0;i=b;return k|0}Buh(2540560);k=$vf(0,0,d,h)|0;i=b;return k|0}function cwf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;if(!(a[2540708]|0))Buh(2540560);e=$vf(0,0,c,d)|0;i=b;return e|0}function dwf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;b=i;i=i+32|0;h=b+4|0;j=b+12|0;k=b+8|0;l=b+20|0;m=b+24|0;n=b+16|0;o=b;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;a[m>>0]=0;c[n>>2]=0;Eeh();if(!f){RI(2963920)|0;p=qL(2963920)|0;Iag(p,c[884518]|0);Auh(p)}if(!g){RI(2963920)|0;p=qL(2963920)|0;Iag(p,c[884520]|0);Auh(p)}do if(!d){p=g+12|0;q=c[p>>2]|0;a:do if((q|0)>0){r=g+16|0;s=0;t=0;while(1){u=vL(c[r+(da(c[(c[g>>2]|0)+120>>2]|0,s)|0)>>2]|0,2540560)|0;if(!u){v=s;w=t;break}x=(c[u+8>>2]|0)+t|0;u=s+1|0;y=c[p>>2]|0;if((u|0)<(y|0)){s=u;t=x}else{z=y;A=u;B=x;break a}}z=c[p>>2]|0;A=v;B=w}else{z=q;A=0;B=0}while(0);if((A|0)==(z|0)){q=c[f+8>>2]|0;RI(2971904)|0;p=qL(2971904)|0;Ueg(p,q+B|0);C=p;break}else{RI(2971904)|0;p=qL(2971904)|0;Gbg(p);C=p;break}}else C=d;while(0);c[j>>2]=0;d=f+8|0;if((c[d>>2]|0)<=0){i=b;return C|0}B=g+12|0;z=g+16|0;A=(e|0)==0;w=0;v=0;p=0;b:while(1){q=w;while(1){t=q;q=q+1|0;c[j>>2]=q;s=Wof(f,t)|0;if(s<<16>>16==123){D=t;E=q;F=17;break}else if(s<<16>>16==125){G=t;H=q;F=42;break}t=c[d>>2]|0;if((q|0)>=(t|0)){I=t;J=p;F=49;break b}}do if((F|0)==17){F=0;jfg(C,f,p,v+D|0)|0;if((Wof(f,E)|0)<<16>>16==123){q=D+2|0;c[j>>2]=q;K=q;L=E;break}if(!(a[2540708]|0))Buh(2540560);ewf(0,f,j,k,l,m,n);q=c[k>>2]|0;if((q|0)>=(c[B>>2]|0)){F=22;break b}t=c[z+(da(c[(c[g>>2]|0)+120>>2]|0,q)|0)>>2]|0;if(A)M=0;else{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[o>>2]=3440560;c[h+0>>2]=c[o+0>>2];q=Iuh(3083928,e,npf(0,h)|0)|0;RI(3083416)|0;M=vL(q,3083416)|0}do if(t){if(M){N=Ruh(3083624,M,c[n>>2]|0,t,e)|0;break}RI(2544808)|0;if(!(vL(t,2544808)|0)){N=Fqh(2536904,t)|0;break}else{RI(2544808)|0;q=Juh(t,2544808)|0;N=Suh(2545e3,q,c[n>>2]|0,e)|0;break}}else{if(!(a[2540708]|0))Buh(2540560);N=c[c[635163]>>2]|0}while(0);t=c[N+8>>2]|0;q=c[l>>2]|0;do if((q|0)>(t|0)){s=q-t|0;if(!(a[m>>0]|0)){afg(C,32,s)|0;Hbg(C,N)|0;break}else{Hbg(C,N)|0;afg(C,32,s)|0;break}}else Hbg(C,N)|0;while(0);t=c[j>>2]|0;K=t;L=t}else if((F|0)==42){F=0;if((H|0)>=(c[d>>2]|0)){F=47;break b}if((Wof(f,H)|0)<<16>>16!=125){F=47;break b}jfg(C,f,p,v+G|0)|0;t=G+2|0;c[j>>2]=t;K=t;L=H}while(0);t=c[d>>2]|0;if((K|0)<(t|0)){w=K;v=0-L|0;p=L}else{I=t;J=L;F=49;break}}if((F|0)==22){RI(3079480)|0;L=qL(3079480)|0;Hrg(L,c[884522]|0);Auh(L)}else if((F|0)==47){RI(3079480)|0;L=qL(3079480)|0;Hrg(L,c[884524]|0);Auh(L)}else if((F|0)==49){if((I|0)<=(J|0)){i=b;return C|0}jfg(C,f,J,I-J|0)|0;i=b;return C|0}return 0}function ewf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;b=i;Jeh();if(!(a[2540708]|0))Buh(2540560);k=pwf(0,d,e)|0;c[f>>2]=k;if((k|0)<=-1){RI(3079480)|0;k=qL(3079480)|0;Hrg(k,c[884698]|0);FJ(k)}if((Wof(d,c[e>>2]|0)|0)<<16>>16==44){k=c[e>>2]|0;while(1){f=k+1|0;c[e>>2]=f;l=Wof(d,f)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}f=Xof(0,l)|0;l=c[e>>2]|0;if(f)k=l;else{m=l;break}}c[j>>2]=fpf(d,m,0)|0;m=(Wof(d,c[e>>2]|0)|0)<<16>>16==45;a[h>>0]=m&1;if(m)c[e>>2]=(c[e>>2]|0)+1;if(!(a[2540708]|0))Buh(2540560);m=pwf(0,d,e)|0;c[g>>2]=m;if((m|0)<=-1){RI(3079480)|0;m=qL(3079480)|0;Hrg(m,c[884700]|0);FJ(m)}}else{c[g>>2]=0;a[h>>0]=0;if(!(a[2540708]|0))Buh(2540560);c[j>>2]=c[c[635163]>>2]}if((Wof(d,c[e>>2]|0)|0)<<16>>16==58){h=(c[e>>2]|0)+1|0;g=h;while(1){c[e>>2]=g;m=(Wof(d,g)|0)<<16>>16==125;k=c[e>>2]|0;if(m){n=k;break}else g=k+1|0}g=fpf(d,h,n-h|0)|0;if(!(a[2540708]|0))Buh(2540560);o=gwf(0,c[j>>2]|0,g)|0}else o=0;c[j>>2]=o;o=c[e>>2]|0;c[e>>2]=o+1;if((Wof(d,o)|0)<<16>>16==125){i=b;return}else{RI(3079480)|0;b=qL(3079480)|0;Hrg(b,c[884702]|0);FJ(b)}}function fwf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=i;if(!c)e=0;else e=Fqh(2536904,c)|0;if(!d)f=0;else f=Fqh(2536904,d)|0;if(!(a[2540708]|0))Buh(2540560);d=gwf(0,e,f)|0;i=b;return d|0}function gwf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((d|0)!=0?(f=d+8|0,g=c[f>>2]|0,(g|0)!=0):0){if(!e){h=d;i=b;return h|0}j=e+8|0;k=c[j>>2]|0;if(!k){h=d;i=b;return h|0}if(!(a[2540708]|0))Buh(2540560);l=ivf(0,k+g|0)|0;g=l;k=g+(bvf(0)|0)|0;m=(bvf(0)|0)+d|0;cvf(0,k,m,c[f>>2]|0);m=(bvf(0)|0)+g|0;g=(bvf(0)|0)+e|0;cvf(0,m+(c[f>>2]<<1)|0,g,c[j>>2]|0);h=l;i=b;return h|0}if((e|0)!=0?(c[e+8>>2]|0)!=0:0){h=e;i=b;return h|0}if(!(a[2540708]|0))Buh(2540560);h=c[c[635163]>>2]|0;i=b;return h|0}function hwf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;b=i;if(!d){if(!(a[2540708]|0))Buh(2540560);g=c[c[635163]>>2]|0}else g=Fqh(2536904,d)|0;if(!e){if(!(a[2540708]|0))Buh(2540560);h=c[c[635163]>>2]|0}else h=Fqh(2536904,e)|0;if(!f){if(!(a[2540708]|0))Buh(2540560);j=c[c[635163]>>2]|0}else j=Fqh(2536904,f)|0;if(a[2540708]|0){k=iwf(0,g,h,j)|0;i=b;return k|0}Buh(2540560);k=iwf(0,g,h,j)|0;i=b;return k|0}function iwf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;do if((d|0)!=0?(c[d+8>>2]|0)!=0:0){if((e|0)!=0?(c[e+8>>2]|0)!=0:0){if((f|0)!=0?(c[f+8>>2]|0)!=0:0){g=d;h=e;j=f;break}if(!(a[2540708]|0))Buh(2540560);g=d;h=e;j=c[c[635163]>>2]|0;break}if(!f){k=d;i=b;return k|0}if(!(c[f+8>>2]|0)){k=d;i=b;return k|0}if(!(a[2540708]|0))Buh(2540560);g=d;h=c[c[635163]>>2]|0;j=f}else l=3;while(0);do if((l|0)==3){if((e|0)!=0?(c[e+8>>2]|0)!=0:0){if(!f){k=e;i=b;return k|0}if(!(c[f+8>>2]|0)){k=e;i=b;return k|0}if(!(a[2540708]|0))Buh(2540560);g=c[c[635163]>>2]|0;h=e;j=f;break}if((f|0)!=0?(c[f+8>>2]|0)!=0:0){k=f;i=b;return k|0}if(!(a[2540708]|0))Buh(2540560);k=c[c[635163]>>2]|0;i=b;return k|0}while(0);f=g+8|0;e=c[f>>2]|0;l=h+8|0;d=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;if(!(a[2540708]|0))Buh(2540560);o=ivf(0,d+e+n|0)|0;if(c[f>>2]|0){n=(bvf(0)|0)+o|0;e=(bvf(0)|0)+g|0;g=c[f>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,n,e,g)}if(c[l>>2]|0){g=(bvf(0)|0)+o|0;e=(bvf(0)|0)+h|0;h=c[f>>2]|0;n=c[l>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,g+(h<<1)|0,e,n)}if(!(c[m>>2]|0)){k=o;i=b;return k|0}n=(bvf(0)|0)+o|0;e=(bvf(0)|0)+j|0;j=c[f>>2]|0;f=c[l>>2]|0;l=c[m>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,n+(f+j<<1)|0,e,l);k=o;i=b;return k|0}function jwf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;h=(d|0)!=0;j=(e|0)!=0;k=(f|0)!=0;l=(g|0)!=0;if(!(h|j|k|l)){if(!(a[2540708]|0))Buh(2540560);m=c[c[635163]>>2]|0;i=b;return m|0}if(h)n=d;else{if(!(a[2540708]|0))Buh(2540560);n=c[c[635163]>>2]|0}if(j)o=e;else{if(!(a[2540708]|0))Buh(2540560);o=c[c[635163]>>2]|0}if(k)p=f;else{if(!(a[2540708]|0))Buh(2540560);p=c[c[635163]>>2]|0}if(l)q=g;else{if(!(a[2540708]|0))Buh(2540560);q=c[c[635163]>>2]|0}g=n+8|0;l=c[g>>2]|0;f=o+8|0;k=c[f>>2]|0;e=p+8|0;j=c[e>>2]|0;d=q+8|0;h=c[d>>2]|0;if(!(a[2540708]|0))Buh(2540560);r=ivf(0,k+l+j+h|0)|0;if(c[g>>2]|0){h=(bvf(0)|0)+r|0;j=(bvf(0)|0)+n|0;n=c[g>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,h,j,n)}if(c[f>>2]|0){n=(bvf(0)|0)+r|0;j=(bvf(0)|0)+o|0;o=c[g>>2]|0;h=c[f>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,n+(o<<1)|0,j,h)}if(c[e>>2]|0){h=(bvf(0)|0)+r|0;j=(bvf(0)|0)+p|0;p=c[g>>2]|0;o=c[f>>2]|0;n=c[e>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,h+(o+p<<1)|0,j,n)}if(!(c[d>>2]|0)){m=r;i=b;return m|0}n=(bvf(0)|0)+r|0;j=(bvf(0)|0)+q|0;q=c[g>>2]|0;g=c[f>>2]|0;f=c[e>>2]|0;e=c[d>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,n+(g+q+f<<1)|0,j,e);m=r;i=b;return m|0}function kwf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;f=(a[2540708]|0)!=0;if(!e){if(!f)Buh(2540560);g=c[c[635163]>>2]|0;i=b;return g|0}if(!f)Buh(2540560);f=ivf(0,e)|0;e=bvf(0)|0;h=d+12|0;j=c[h>>2]|0;if((j|0)<=0){g=f;i=b;return g|0}k=d+16|0;l=f+e|0;e=j;j=0;m=0;while(1){n=c[k+(da(c[(c[d>>2]|0)+120>>2]|0,m)|0)>>2]|0;if(!n){o=e;p=j}else{q=(bvf(0)|0)+n|0;r=n+8|0;n=c[r>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,l+(j<<1)|0,q,n);o=c[h>>2]|0;p=(c[r>>2]|0)+j|0}m=m+1|0;if((m|0)>=(o|0)){g=f;break}else{e=o;j=p}}i=b;return g|0}function lwf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;Geh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[884612]|0);Auh(e)}e=c[d+12>>2]|0;if((e|0)>0){f=d+16|0;g=c[(c[d>>2]|0)+120>>2]|0;h=0;j=0;while(1){k=c[f+(da(g,j)|0)>>2]|0;if(!k)l=h;else l=(c[k+8>>2]|0)+h|0;j=j+1|0;if((j|0)>=(e|0)){m=l;break}else h=l}}else m=0;if(a[2540708]|0){n=kwf(0,d,m)|0;i=b;return n|0}Buh(2540560);n=kwf(0,d,m)|0;i=b;return n|0}function mwf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;Heh();if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[884620]|0);Auh(g)}if((d|0)<0){RI(2964880)|0;h=qL(2964880)|0;j=c[884622]|0;k=c[884624]|0;Qag(h,j,k);Auh(h)}g=b+8|0;l=c[g>>2]|0;if((l|0)<(d|0)){RI(2964880)|0;h=qL(2964880)|0;j=c[884622]|0;k=c[884624]|0;Qag(h,j,k);Auh(h)}h=e+8|0;k=c[h>>2]|0;if(!k){m=b;i=f;return m|0}if(!l){m=e;i=f;return m|0}if(!(a[2540708]|0))Buh(2540560);j=ivf(0,k+l|0)|0;l=j+(bvf(0)|0)|0;k=(bvf(0)|0)+b|0;b=(bvf(0)|0)+e|0;cvf(0,l,k,d);e=l;l=d<<1;cvf(0,e+l|0,b,c[h>>2]|0);cvf(0,e+((c[h>>2]<<1)+l)|0,k+l|0,(c[g>>2]|0)-d|0);m=j;i=f;return m|0}function nwf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;Ieh();if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[884664]|0);Auh(h)}if((f|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884666]|0,c[884668]|0);Auh(h)}if((g|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884670]|0,c[884672]|0);Auh(h)}h=c[e+12>>2]|0;if((h-g|0)<(f|0)){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[884674]|0,c[884676]|0);Auh(j)}if((h|0)==(f|0)){if(!(a[2540708]|0))Buh(2540560);k=c[c[635163]>>2]|0;i=b;return k|0}if(!d){if(!(a[2540708]|0))Buh(2540560);l=c[c[635163]>>2]|0}else l=d;if(!(a[2540708]|0))Buh(2540560);k=owf(0,l,e,f,g)|0;i=b;return k|0}function owf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;h=g+f|0;if((g|0)>0){j=e+16|0;k=c[(c[e>>2]|0)+120>>2]|0;l=0;m=f;while(1){n=c[j+(da(k,m)|0)>>2]|0;if(!n)o=l;else o=(c[n+8>>2]|0)+l|0;m=m+1|0;if((m|0)>=(h|0)){p=o;break}else l=o}}else p=0;o=d+8|0;l=(da(c[o>>2]|0,g+-1|0)|0)+p|0;p=(a[2540708]|0)!=0;if((l|0)<=0){if(!p)Buh(2540560);q=c[c[635163]>>2]|0;i=b;return q|0}if(!p)Buh(2540560);p=ivf(0,l)|0;l=h+-1|0;h=p+(bvf(0)|0)|0;g=(bvf(0)|0)+d|0;d=e+16|0;m=c[(c[e>>2]|0)+120>>2]|0;if((l|0)>(f|0)){k=h;j=m;n=0;r=f;while(1){f=c[d+(da(j,r)|0)>>2]|0;if((f|0)!=0?(s=f+8|0,(c[s>>2]|0)>=1):0){t=(bvf(0)|0)+f|0;f=c[s>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,k+(n<<1)|0,t,f);u=(c[s>>2]|0)+n|0}else u=n;s=c[o>>2]|0;if((s|0)<1)v=u;else{if(!(a[2540708]|0))Buh(2540560);cvf(0,k+(u<<1)|0,g,s);v=(c[o>>2]|0)+u|0}r=r+1|0;s=c[(c[e>>2]|0)+120>>2]|0;if((r|0)==(l|0)){w=s;x=v;break}else{j=s;n=v}}}else{w=m;x=0}m=c[d+(da(w,l)|0)>>2]|0;if(!m){q=p;i=b;return q|0}l=m+8|0;if((c[l>>2]|0)<1){q=p;i=b;return q|0}w=(bvf(0)|0)+m|0;m=c[l>>2]|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,h+(x<<1)|0,w,m);q=p;i=b;return q|0}function pwf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;e=c[d>>2]|0;f=Wof(b,e)|0;if((f+-48<<16>>16&65535)<10){g=f;f=e;h=0;while(1){j=(h*10|0)+-48+(g&65535)|0;k=f+1|0;g=Wof(b,k)|0;if((g+-48<<16>>16&65535)>=10){l=k;m=j;break}else{f=k;h=j}}}else{l=e;m=0}if((l|0)==(c[d>>2]|0)){n=-1;i=a;return n|0}c[d>>2]=l;n=m;i=a;return n|0}function qwf(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;Keh();if((c[a+8>>2]|0)>(d|0)){b[a+12+(d<<1)>>1]=e;i=f;return}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[884708]|0);Auh(f)}}function rwf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;Leh();e=a+8|0;f=c[e>>2]|0;if((f|0)<(b|0)){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884714]|0,c[884716]|0);Auh(g)}if((f|0)<=(b|0)){c[e>>2]=b;i=d;return}g=b<<1;h=a+(g+14)|0;j=a+((f<<1)+12)|0;PEi(a+(g+12)|0,0,(h>>>0>j>>>0?h:j)+(-13-a-g)+2&-2|0)|0;c[e>>2]=b;i=d;return}function swf(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=(bvf(0)|0)+a|0;f=d;g=d+(c[a+8>>2]<<1)+-2|0;a=g;if(f>>>0<a>>>0){h=((g+~d|0)>>>2<<1)+2|0;d=f;j=0;while(1){k=(((e[d>>1]|0)+(j*31|0)|0)*31|0)+(e[d+2>>1]|0)|0;d=d+4|0;if(d>>>0>=a>>>0){l=k;break}else j=k}m=f+(h<<1)|0;n=l}else{m=f;n=0}if(m>>>0>=(g+2|0)>>>0){o=n;i=b;return o|0}o=(e[m>>1]|0)+(n*31|0)|0;i=b;return o|0}function twf(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=(bvf(0)|0)+d|0;g=f;h=f+(c[d+8>>2]<<1)+-2|0;d=h;if(g>>>0<d>>>0){j=((h+~f|0)>>>2<<1)+2|0;f=g;k=0;while(1){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}l=((wuf(0,b[f>>1]|0)|0)&65535)+(k*31|0)|0;m=(l*31|0)+((wuf(0,b[f+2>>1]|0)|0)&65535)|0;f=f+4|0;if(f>>>0>=d>>>0){n=m;break}else k=m}o=g+(j<<1)|0;p=n}else{o=g;p=0}if(o>>>0>=(h+2|0)>>>0){q=p;i=e;return q|0}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}q=((wuf(0,b[o>>1]|0)|0)&65535)+(p*31|0)|0;i=e;return q|0}function uwf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;Meh();if(!d){if(!(a[2540708]|0))Buh(2540560);e=c[c[635163]>>2]|0;i=b;return e|0}else{if(!(a[d>>0]|0))f=0;else{g=d;h=0;while(1){g=g+1|0;j=h+1|0;if(!(a[g>>0]|0)){f=j;break}else h=j}}e=vwf(0,d,0,f,0)|0;i=b;return e|0}return 0}function vwf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;Neh();if((f|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884772]|0,c[884774]|0);Auh(h)}if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884776]|0,c[884778]|0);Auh(h)}h=d+e|0;do if(!g){if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[884784]|0);Auh(e)}if(f){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;Buh(2978896)}j=ieg(0)|0;break}if(!(a[2540708]|0))Buh(2540560);k=c[c[635163]>>2]|0;i=b;return k|0}else j=g;while(0);RI(1159264)|0;g=Huh(1159264,f)|0;if(f){if((g|0)!=0?(c[g+12>>2]|0)!=0:0)l=g+16|0;else l=0;if(!(a[2540708]|0))Buh(2540560);xwf(0,l,h,f)}k=Tuh(2994312,j,g)|0;i=b;return k|0}function wwf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=i;e=vwf(0,b,c,d,0)|0;i=a;return e|0}function xwf(c,d,e,f){c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=i;g=d;h=e;if((h|g)&3){if((g&1|0)!=0?!((h&1|0)==0|(f|0)<1):0){a[d>>0]=a[e>>0]|0;j=f+-1|0;k=e+1|0;l=d+1|0}else{j=f;k=e;l=d}if((l&2|0)!=0?!((k&2|0)==0|(j|0)<2):0){b[l>>1]=b[k>>1]|0;m=j+-2|0;n=k+2|0;o=l+2|0}else{m=j;n=k;o=l}l=n|o;if(l&1){if(!(a[2540708]|0))Buh(2540560);Ewf(0,o,n,m);i=c;return}if(!(l&2)){p=m;q=n;r=o}else{if(!(a[2540708]|0))Buh(2540560);Dwf(0,o,n,m);i=c;return}}else{p=f;q=e;r=d}if(!(a[2540708]|0))Buh(2540560);Cwf(0,r,q,p);i=c;return}function ywf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;d=i;if(!e){if(!(a[2540708]|0))Buh(2540560);f=c[c[635163]>>2]|0;i=d;return f|0}if(!(b[e>>1]|0))g=0;else{h=e;j=0;while(1){k=j+1|0;h=h+2|0;if(!(b[h>>1]|0)){g=k;break}else j=k}}if(!(a[2540708]|0))Buh(2540560);j=ivf(0,g)|0;if(!g){f=j;i=d;return f|0}h=(bvf(0)|0)+j|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,h,e,g);f=j;i=d;return f|0}function zwf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;Oeh();if(!f){if(!(a[2540708]|0))Buh(2540560);g=c[c[635163]>>2]|0;i=b;return g|0}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[884842]|0);Auh(h)}if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[884844]|0);Auh(h)}if((f|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[884846]|0);Auh(h)}if(!(a[2540708]|0))Buh(2540560);h=ivf(0,f)|0;cvf(0,h+(bvf(0)|0)|0,d+(e<<1)|0,f);g=h;i=b;return g|0}function Awf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;Peh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[884850]|0);Auh(g)}if((e|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884852]|0,c[884854]|0);Auh(g)}if((f|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[884856]|0,c[884858]|0);Auh(g)}g=d+12|0;if(((c[g>>2]|0)-f|0)<(e|0)){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[884860]|0,c[884862]|0);Auh(h)}h=(a[2540708]|0)!=0;if(!f){if(!h)Buh(2540560);j=c[c[635163]>>2]|0;i=b;return j|0}if(!h)Buh(2540560);h=ivf(0,f)|0;k=h+(bvf(0)|0)|0;if(!(c[g>>2]|0))l=0;else l=d+16|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,k,l+(e<<1)|0,f);j=h;i=b;return j|0}function Bwf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;if(!d){if(!(a[2540708]|0))Buh(2540560);e=c[c[635163]>>2]|0;i=b;return e|0}f=d+12|0;g=c[f>>2]|0;h=(a[2540708]|0)!=0;if(!g){if(!h)Buh(2540560);e=c[c[635163]>>2]|0;i=b;return e|0}if(h)j=g;else{Buh(2540560);j=c[f>>2]|0}g=ivf(0,j)|0;j=g+(bvf(0)|0)|0;if(!(c[f>>2]|0))k=0;else k=d+16|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,j,k,c[f>>2]|0);e=g;i=b;return e|0}function Cwf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;if((f|0)>15){g=f+-16|0;h=g&-16;j=h+16|0;k=e+j|0;l=e;m=f;n=d;while(1){c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];m=m+-16|0;if((m|0)<=15)break;else{l=l+16|0;n=n+16|0}}o=g-h|0;p=k;q=d+j|0}else{o=f;p=e;q=d}if((o|0)>3){d=o+-4|0;e=d&-4;f=e+4|0;j=p+f|0;k=o;h=p;g=q;while(1){c[g>>2]=c[h>>2];k=k+-4|0;if((k|0)<=3)break;else{h=h+4|0;g=g+4|0}}r=d-e|0;s=j;t=q+f|0}else{r=o;s=p;t=q}if((r|0)>0){u=r;v=s;w=t}else{i=b;return}while(1){a[w>>0]=a[v>>0]|0;u=u+-1|0;if((u|0)<=0)break;else{v=v+1|0;w=w+1|0}}i=b;return}function Dwf(c,d,e,f){c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;if((f|0)>7){g=f+-8|0;h=g&-8;j=h+8|0;k=e+j|0;l=e;m=f;n=d;while(1){b[n>>1]=b[l>>1]|0;b[n+2>>1]=b[l+2>>1]|0;b[n+4>>1]=b[l+4>>1]|0;b[n+6>>1]=b[l+6>>1]|0;m=m+-8|0;if((m|0)<=7)break;else{l=l+8|0;n=n+8|0}}o=g-h|0;p=k;q=d+j|0}else{o=f;p=e;q=d}if((o|0)>1){d=o+-2|0;e=d&-2;f=e+2|0;j=p+f|0;k=p;h=q;g=o;while(1){b[h>>1]=b[k>>1]|0;g=g+-2|0;if((g|0)<=1)break;else{k=k+2|0;h=h+2|0}}r=d-e|0;s=j;t=q+f|0}else{r=o;s=p;t=q}if((r|0)<1){i=c;return}a[t>>0]=a[s>>0]|0;i=c;return}function Ewf(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;if((e|0)>7){f=e+-8|0;g=f&-8;h=g+8|0;j=d+h|0;k=d;l=e;m=c;while(1){a[m>>0]=a[k>>0]|0;a[m+1>>0]=a[k+1>>0]|0;a[m+2>>0]=a[k+2>>0]|0;a[m+3>>0]=a[k+3>>0]|0;a[m+4>>0]=a[k+4>>0]|0;a[m+5>>0]=a[k+5>>0]|0;a[m+6>>0]=a[k+6>>0]|0;a[m+7>>0]=a[k+7>>0]|0;l=l+-8|0;if((l|0)<=7)break;else{k=k+8|0;m=m+8|0}}n=f-g|0;o=j;p=c+h|0}else{n=e;o=d;p=c}if((n|0)>1){c=n+-2|0;d=c&-2;e=d+2|0;h=o+e|0;j=o;g=p;f=n;while(1){a[g>>0]=a[j>>0]|0;a[g+1>>0]=a[j+1>>0]|0;f=f+-2|0;if((f|0)<=1)break;else{j=j+2|0;g=g+2|0}}q=c-d|0;r=h;s=p+e|0}else{q=n;r=o;s=p}if((q|0)<1){i=b;return}a[s>>0]=a[r>>0]|0;i=b;return}function Fwf(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0;a=i;if((e|0)<=0){i=a;return}f=d+(e<<1)|0;d=c+(e<<1)|0;c=e;do{d=d+-2|0;f=f+-2|0;b[d>>1]=b[f>>1]|0;c=c+-1|0}while((c|0)>0);i=a;return}function Gwf(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;b=i;h=(bvf(0)|0)+c|0;c=(bvf(0)|0)+e|0;if(!(a[2540708]|0))Buh(2540560);cvf(0,h+(d<<1)|0,c+(f<<1)|0,g);i=b;return}function Hwf(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;b=i;h=(bvf(0)|0)+c|0;c=(bvf(0)|0)+e|0;if(!(a[2540708]|0))Buh(2540560);Fwf(0,h+(d<<1)|0,c+(f<<1)|0,g);i=b;return}function Iwf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;if(!(a[2540708]|0))Buh(2540560);e=(Yuf(0,c,d)|0)^1;i=b;return e|0}function Jwf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2584640)|0;c[b+8>>2]=sM(2999440)|0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function Kwf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Lwf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Mwf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function Nwf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function Owf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function Pwf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function Qwf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=jjg(0,ea(g[b>>2]))|0;i=c;return d|0}function Rwf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=xjg(0,ea(g[b>>2]))|0;i=c;return d|0}function Swf(b,c){b=b|0;c=c|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Kjg(0,ea(g[b>>2]))|0;return 0}function Twf(b,c,d){b=b|0;c=c|0;d=d|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Xjg(b,0,ea(g[c>>2]))}function Uwf(b,c,d){b=b|0;c=c|0;d=d|0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}ekg(b,0,ea(g[c>>2]));i=d;return}function Vwf(b,c){b=b|0;c=c|0;var d=0.0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=+skg(0,ea(g[b>>2]));i=c;return +d}function Wwf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Hkg(0,ea(g[b>>2]))|0;i=c;return d|0}function Xwf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Wkg(0,ea(g[b>>2]))|0;i=c;return d|0}function Ywf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ilg(0,ea(g[b>>2]))|0;i=c;return d|0}function Zwf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ylg(0,ea(g[b>>2]))|0;i=c;return d|0}function _wf(b,c){b=b|0;c=c|0;var d=Im;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ea(Llg(0,ea(g[b>>2])));i=c;return ea(d)}function $wf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0;f=i;i=i+16|0;h=f;Reh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[884902]|0);Auh(j)}g[h>>2]=ea(g[b>>2]);RI(2586184)|0;b=pL(2586184,h)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,b,d,e,0)|0;i=f;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,b,d,e,0)|0;i=f;return k|0}function axf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=_lg(0,ea(g[b>>2]))|0;i=c;return d|0}function bxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=mmg(0,ea(g[b>>2]))|0;i=c;return d|0}function cxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Amg(0,ea(g[b>>2]))|0;i=c;return d|0}function dxf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=Im,k=Im;d=i;Seh();if(!b){e=1;i=d;return e|0}RI(2586184)|0;if(!(vL(b,2586184)|0)){f=c[884906]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,f);Auh(h)}RI(2586184)|0;j=ea(g[(Euh(b,2586184)|0)>>2]);k=ea(g[a>>2]);if((!(k<=ea(0.0))?(a=k==ea(-x),(a|k==ea(x))&!(j<=ea(0.0))):0)?(a=j==ea(-x),a|j==ea(x)):0){e=0;i=d;return e|0}if((!(k>=ea(0.0))?(a=k==ea(-x),(a|k==ea(x))&!(j>=ea(0.0))):0)?(a=j==ea(-x),a|j==ea(x)):0){e=0;i=d;return e|0}a=k!=k|ea(0.0)!=ea(0.0);if(j!=j|ea(0.0)!=ea(0.0)){e=a&1^1;i=d;return e|0}if(a){e=-1;i=d;return e|0}if(!(k!=j)){e=0;i=d;return e|0}e=!(k<=j)?1:-1;i=d;return e|0}function exf(a,b){a=a|0;b=ea(b);var c=0;a=i;if(!(b<=ea(0.0)))if(b==ea(-x))c=1;else c=b==ea(x);else c=0;i=a;return c|0}function fxf(a,b){a=a|0;b=ea(b);var c=0;a=i;if(!(b>=ea(0.0)))if(b==ea(-x))c=1;else c=b==ea(x);else c=0;i=a;return c|0}function gxf(a,b){a=a|0;b=ea(b);a=b!=b|ea(0.0)!=ea(0.0);return a|0}function hxf(a,b){a=a|0;b=b|0;var c=0,d=0,e=Im,f=Im;c=i;RI(2586184)|0;if(!(vL(b,2586184)|0)){d=0;i=c;return d|0}RI(2586184)|0;e=ea(g[(Euh(b,2586184)|0)>>2]);b=e!=e|ea(0.0)!=ea(0.0);f=ea(g[a>>2]);if(b){d=f!=f|ea(0.0)!=ea(0.0);i=c;return d|0}else{d=e==f;i=c;return d|0}return 0}function ixf(a,b){a=a|0;b=ea(b);var c=0,d=Im,e=0;c=i;d=ea(g[a>>2]);if((!(d<=ea(0.0))?(a=d==ea(-x),(a|d==ea(x))&!(b<=ea(0.0))):0)?(a=b==ea(-x),a|b==ea(x)):0){e=0;i=c;return e|0}if((!(d>=ea(0.0))?(a=d==ea(-x),(a|d==ea(x))&!(b>=ea(0.0))):0)?(a=b==ea(-x),a|b==ea(x)):0){e=0;i=c;return e|0}a=d!=d|ea(0.0)!=ea(0.0);if(b!=b|ea(0.0)!=ea(0.0)){e=a&1^1;i=c;return e|0}if(a){e=-1;i=c;return e|0}if(!(d!=b)){e=0;i=c;return e|0}e=!(d<=b)?1:-1;i=c;return e|0}function jxf(a,b){a=a|0;b=ea(b);var c=0,d=0,e=Im,f=0;c=i;d=b!=b|ea(0.0)!=ea(0.0);e=ea(g[a>>2]);if(d){f=e!=e|ea(0.0)!=ea(0.0);i=c;return f|0}else{f=e==b;i=c;return f|0}return 0}function kxf(a){a=a|0;var b=0,d=Im;b=i;d=ea(g[a>>2]);a=(g[k>>2]=d,c[k>>2]|0);i=b;return a|0}function lxf(a,b){a=a|0;b=ea(b);var c=0;if(b==ea(x))c=1;else c=b==ea(-x);return c|0}function mxf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=Im;a=i;d=+nxf(0,b,231,c);if(d+-3402823466385288598117041.0e14<=3614711245796177636240109.0e5){e=ea(d);i=a;return ea(e)}if(!(d<=0.0)?d==-x|d==x:0){e=ea(d);i=a;return ea(e)}RI(3086272)|0;a=qL(3086272)|0;vwg(a);Auh(a);return ea(0.0)}function nxf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;i=i+16|0;f=a+8|0;g=a;c[f>>2]=0;h[g>>3]=0.0;if(Txf(0,b,d,e,0,g,f)|0){i=a;return +(+h[g>>3])}else Auh(c[f>>2]|0);return +(0.0)}function oxf(a,b){a=a|0;b=+b;var c=0;a=i;if(!(b<=0.0))if(b==-x)c=1;else c=b==x;else c=0;i=a;return c|0}function pxf(b){b=b|0;var c=0,d=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}d=Jvg(0,ea(g[b>>2]),0)|0;i=c;return d|0}function qxf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Jvg(0,ea(g[b>>2]),c)|0;i=d;return e|0}function rxf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=sxf(a,b,0)|0;i=c;return d|0}function sxf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=yvg(0,c,ea(g[b>>2]),d)|0;i=e;return f|0}function txf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function uxf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function vxf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;Teh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[884926]|0);Auh(j)}h[g>>3]=+h[b>>3];RI(2589144)|0;b=pL(2589144,g)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,b,d,e,0)|0;i=f;return k|0}RI(3034288)|0;Buh(3034288);k=Lmg(0,b,d,e,0)|0;i=f;return k|0}function wxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ijg(0,+h[b>>3])|0;i=c;return d|0}function xxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=wjg(0,+h[b>>3])|0;i=c;return d|0}function yxf(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);Auh(b);return 0}function zxf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);Auh(c)}function Axf(b,c,d){b=b|0;c=c|0;d=d|0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}dkg(b,0,+h[c>>3]);i=d;return}function Bxf(b,c){b=b|0;c=c|0;var d=0.0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=+rkg(0,+h[b>>3]);i=c;return +d}function Cxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Gkg(0,+h[b>>3])|0;i=c;return d|0}function Dxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Vkg(0,+h[b>>3])|0;i=c;return d|0}function Exf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=hlg(0,+h[b>>3])|0;i=c;return d|0}function Fxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=xlg(0,+h[b>>3])|0;i=c;return d|0}function Gxf(b,c){b=b|0;c=c|0;var d=Im;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ea(Klg(0,+h[b>>3]));i=c;return ea(d)}function Hxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Zlg(0,+h[b>>3])|0;i=c;return d|0}function Ixf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=lmg(0,+h[b>>3])|0;i=c;return d|0}function Jxf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=zmg(0,+h[b>>3])|0;i=c;return d|0}function Kxf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;Ueh();if(!b){e=1;i=d;return e|0}RI(2589144)|0;if(!(vL(b,2589144)|0)){f=c[884930]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}RI(2589144)|0;j=+h[(Euh(b,2589144)|0)>>3];k=+h[a>>3];if((!(k<=0.0)?(k==-x|k==x)&!(j<=0.0):0)?j==-x|j==x:0){e=0;i=d;return e|0}if((!(k>=0.0)?(k==-x|k==x)&!(j>=0.0):0)?j==-x|j==x:0){e=0;i=d;return e|0}a=k!=k|0.0!=0.0;if(j!=j|0.0!=0.0){e=a&1^1;i=d;return e|0}if(a){e=-1;i=d;return e|0}if(!(k<=j)){e=1;i=d;return e|0}e=!(k>=j)<<31>>31;i=d;return e|0}function Lxf(a,b){a=a|0;b=+b;var c=0;a=i;if(!(b>=0.0))if(b==-x)c=1;else c=b==x;else c=0;i=a;return c|0}function Mxf(a,b){a=a|0;b=+b;return b!=b|0.0!=0.0|0}function Nxf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0.0;c=i;RI(2589144)|0;if(!(vL(b,2589144)|0)){d=0;i=c;return d|0}RI(2589144)|0;e=+h[(Euh(b,2589144)|0)>>3];f=+h[a>>3];if(e!=e|0.0!=0.0){d=f!=f|0.0!=0.0;i=c;return d|0}else{d=e==f;i=c;return d|0}return 0}function Oxf(a,b){a=a|0;b=+b;var c=0,d=0.0,e=0,f=0;c=i;d=+h[a>>3];if((!(d<=0.0)?(d==-x|d==x)&!(b<=0.0):0)?b==-x|b==x:0)e=0;else f=4;do if((f|0)==4){if((!(d>=0.0)?(d==-x|d==x)&!(b>=0.0):0)?b==-x|b==x:0){e=0;break}a=d!=d|0.0!=0.0;if(b!=b|0.0!=0.0){e=a&1^1;break}if(!a)if(!(d<=b))e=1;else e=!(d>=b)<<31>>31;else e=-1}while(0);i=c;return e|0}function Pxf(a,b){a=a|0;b=+b;var c=0.0,d=0;c=+h[a>>3];if(b!=b|0.0!=0.0)d=c!=c|0.0!=0.0;else d=c==b;return d|0}function Qxf(a){a=a|0;var b=0;b=a;return c[b+4>>2]^c[b>>2]|0}function Rxf(a,b){a=a|0;b=+b;var c=0;if(b==x)c=1;else c=b==-x;return c|0}function Sxf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0;a=i;d=+nxf(0,b,231,c);i=a;return +d}function Txf(d,e,f,g,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0.0;d=i;i=i+32|0;m=d;n=d+16|0;o=d+14|0;p=d+12|0;q=d+10|0;r=d+8|0;h[m>>3]=0.0;Veh();h[k>>3]=0.0;c[l>>2]=0;if(!e){if(j){s=0;i=d;return s|0}RI(2963920)|0;t=qL(2963920)|0;Iag(t,c[884948]|0);c[l>>2]=t;s=0;i=d;return s|0}t=e+8|0;if(!(c[t>>2]|0)){if(j){s=0;i=d;return s|0}RI(3079480)|0;u=qL(3079480)|0;Frg(u);c[l>>2]=u;s=0;i=d;return s|0}if(f&512){RI(1086352)|0;u=Huh(1086352,1)|0;Qqh(u,c[884952]|0);c[u+16>>2]=c[884952];v=Uxf(0,c[884950]|0,u)|0;RI(2965048)|0;u=qL(2965048)|0;Rbg(u,v);Auh(u)}if((f|0)>=512){if(j){s=0;i=d;return s|0}RI(2965048)|0;u=qL(2965048)|0;oig(u);c[l>>2]=u;s=0;i=d;return s|0}RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;Buh(2755888)}u=lUf(0,g)|0;if(!u){RI(2589312)|0;g=qL(2589312)|0;v=c[884954]|0;c[g+40>>2]=-2146233088;c[g+16>>2]=v;Auh(g)}g=c[t>>2]|0;v=(f&2|0)!=0;do if(!(f&1)){y=g;z=0}else{a:do if((g|0)>0){A=0;while(1){B=Wof(e,A)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}C=A+1|0;if(!(Xof(0,B)|0)){D=A;break a}if((C|0)<(g|0))A=C;else{D=C;break}}}else D=0;while(0);if((D|0)!=(g|0)){y=c[t>>2]|0;z=D;break}if(j){s=0;i=d;return s|0}c[l>>2]=Yof(0)|0;s=0;i=d;return s|0}while(0);D=y+-1|0;if(v){y=D;while(1){t=Wof(e,y)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(Xof(0,t)|0)y=y+-1|0;else{E=y;break}}}else E=D;if(Wxf(0,TTf(u)|0,e,z,E)|0){h[k>>3]=w;s=1;i=d;return s|0}if(Wxf(0,hUf(u)|0,e,z,E)|0){h[k>>3]=x;s=1;i=d;return s|0}if(Wxf(0,UTf(u)|0,e,z,E)|0){h[k>>3]=-x;s=1;i=d;return s|0}RI(1159264)|0;E=Huh(1159264,g+1|0)|0;if(!(f&32)){F=0;G=0}else{D=XTf(u)|0;F=D;G=c[D+8>>2]|0}if(!(f&64)){H=0;I=0}else{D=YTf(u)|0;H=D;I=c[D+8>>2]|0}if(!(f&256)){J=0;K=0}else{D=QTf(u)|0;J=D;K=c[D+8>>2]|0}D=iUf(u)|0;y=VTf(u)|0;b:do if((z|0)<(g|0)){u=(f&4|0)==0;t=D+8|0;A=y+8|0;C=E+16|0;B=(G|0)<1;L=(I|0)<1;M=(K|0)<1;N=K+-1|0;O=I+-1|0;P=G+-1|0;Q=(f&128|0)==0;R=1;S=0;T=z;c:while(1){U=Wof(e,T)|0;d:do if(U<<16>>16){e:do switch(R|0){case 2:{V=57;break}case 3:{W=3;V=87;break}case 1:{if(u){V=57;break e}do if(U<<16>>16==(Wof(D,0)|0)<<16>>16){X=fpf(e,T,c[t>>2]|0)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,X,D)|0))break;Y=2;Z=S;_=T+-1+(c[t>>2]|0)|0;break d}while(0);if(U<<16>>16!=(Wof(y,0)|0)<<16>>16){V=57;break e}X=fpf(e,T,c[A>>2]|0)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,X,y)|0)){V=57;break e}a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=45;Y=2;Z=S+1|0;_=T+-1+(c[A>>2]|0)|0;break d;break}case 5:{V=125;break}case 6:break;case 4:{RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(jpf(0,U)|0){V=125;break e}do if(U<<16>>16==(Wof(D,0)|0)<<16>>16){X=fpf(e,T,c[t>>2]|0)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,X,D)|0))break;Y=2;Z=S;_=T+-1+(c[t>>2]|0)|0;break d}while(0);do if(U<<16>>16==(Wof(y,0)|0)<<16>>16){X=fpf(e,T,c[A>>2]|0)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,X,y)|0))break;a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=45;Y=2;Z=S+1|0;_=T+-1+(c[A>>2]|0)|0;break d}while(0);RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(Xof(0,U)|0)){$=U;V=121;break c}break}case 7:{aa=C;ba=E;ca=S;break b;break}default:{Y=R;Z=S;_=T;break d}}while(0);do if((V|0)==57){V=0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(jpf(0,U)|0){a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=U;Y=2;Z=S+1|0;_=T;break d}if(U<<16>>16==69|U<<16>>16==101){W=2;V=87;break}do if(!B){if((Wof(F,0)|0)<<16>>16!=U<<16>>16)break;if(!(a[2540708]|0))Buh(2540560);if(uvf(0,e,T,F,0,G)|0)break;a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=46;Y=3;Z=S+1|0;_=P+T|0;break d}while(0);do if(!L){if((Wof(H,0)|0)<<16>>16!=U<<16>>16)break;X=fpf(e,T,I)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,X,H)|0))break;Y=2;Z=S;_=O+T|0;break d}while(0);do if(!M){if((Wof(J,0)|0)<<16>>16!=U<<16>>16)break;X=fpf(e,T,K)|0;if(!(a[2540708]|0))Buh(2540560);if(!(gpf(0,X,J)|0))break;Y=2;Z=S;_=N+T|0;break d}while(0);RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(Xof(0,U)|0)){ea=U;V=83;break c}}else if((V|0)==125){V=0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(jpf(0,U)|0){a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=U;Y=5;Z=S+1|0;_=T;break d}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(Xof(0,U)|0)){fa=U;V=132;break c}}while(0);if((V|0)==87){V=0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(jpf(0,U)|0){a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=U;Y=W;Z=S+1|0;_=T;break}if(U<<16>>16==69|U<<16>>16==101){if(Q){ga=U;V=93;break c}a[C+(da(c[(c[E>>2]|0)+120>>2]|0,S)|0)>>0]=U;Y=4;Z=S+1|0;_=T;break}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(Xof(0,U)|0)){ha=U;V=101;break c}}if(!v){V=140;break c}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(Xof(0,U)|0){Y=6;Z=S;_=T}else{V=140;break c}}else{Y=R;Z=S;_=g}while(0);T=_+1|0;if((T|0)>=(g|0)){aa=C;ba=E;ca=Z;break b}else{R=Y;S=Z}}if((V|0)==83){if(j){s=0;i=d;return s|0}b[n>>1]=ea;RI(2540392)|0;S=pL(2540392,n)|0;if(!(a[2540708]|0))Buh(2540560);R=fwf(0,c[884956]|0,S)|0;RI(3079480)|0;S=qL(3079480)|0;Hrg(S,R);c[l>>2]=S;s=0;i=d;return s|0}else if((V|0)==93){if(j){s=0;i=d;return s|0}b[o>>1]=ga;RI(2540392)|0;S=pL(2540392,o)|0;if(!(a[2540708]|0))Buh(2540560);R=fwf(0,c[884958]|0,S)|0;RI(3079480)|0;S=qL(3079480)|0;Hrg(S,R);c[l>>2]=S;s=0;i=d;return s|0}else if((V|0)==101){if(j){s=0;i=d;return s|0}b[p>>1]=ha;RI(2540392)|0;S=pL(2540392,p)|0;if(!(a[2540708]|0))Buh(2540560);R=fwf(0,c[884960]|0,S)|0;RI(3079480)|0;S=qL(3079480)|0;Hrg(S,R);c[l>>2]=S;s=0;i=d;return s|0}else if((V|0)==121){if(j){s=0;i=d;return s|0}b[q>>1]=$;RI(2540392)|0;S=pL(2540392,q)|0;if(!(a[2540708]|0))Buh(2540560);R=fwf(0,c[884962]|0,S)|0;RI(3079480)|0;S=qL(3079480)|0;Hrg(S,R);c[l>>2]=S;s=0;i=d;return s|0}else if((V|0)==132){if(j){s=0;i=d;return s|0}b[r>>1]=fa;RI(2540392)|0;S=pL(2540392,r)|0;if(!(a[2540708]|0))Buh(2540560);R=fwf(0,c[884964]|0,S)|0;RI(3079480)|0;S=qL(3079480)|0;Hrg(S,R);c[l>>2]=S;s=0;i=d;return s|0}else if((V|0)==140){if(j){s=0;i=d;return s|0}RI(3079480)|0;S=qL(3079480)|0;Hrg(S,c[884966]|0);c[l>>2]=S;s=0;i=d;return s|0}}else{aa=E+16|0;ba=E;ca=0}while(0);a[aa+(da(c[(c[ba>>2]|0)+120>>2]|0,ca)|0)>>0]=0;if(!(Xxf(0,aa,m)|0)){if(j){s=0;i=d;return s|0}c[l>>2]=Yof(0)|0;s=0;i=d;return s|0}ia=+h[m>>3];if(!(!(ia<=0.0)?ia==-x|ia==x:0))V=149;do if((V|0)==149){if(!(ia>=0.0)?ia==-x|ia==x:0)break;h[k>>3]=ia;s=1;i=d;return s|0}while(0);if(j){s=0;i=d;return s|0}RI(3086272)|0;j=qL(3086272)|0;vwg(j);c[l>>2]=j;s=0;i=d;return s|0}function Uxf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;if(!(a[2540708]|0))Buh(2540560);e=cwf(0,c,d)|0;i=b;return e|0}function Vxf(a,b){a=a|0;b=b|0;c[a+40>>2]=-2146233088;c[a+16>>2]=b;return}function Wxf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;h=c[d+8>>2]|0;if((1-f+g|0)!=(h|0)){j=0;i=b;return j|0}if(!(a[2540708]|0))Buh(2540560);j=(uvf(0,d,0,e,f,h)|0)==0;i=b;return j|0}function Xxf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[647370]|0;if(!e){f=MK(2589488)|0;c[647370]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Yxf(b){b=b|0;var c=0,d=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}d=Lvg(0,+h[b>>3],0)|0;i=c;return d|0}function Zxf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}e=Lvg(0,+h[b>>3],c)|0;i=d;return e|0}function _xf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)}f=Bvg(0,c,+h[b>>3],d)|0;i=e;return f|0}function $xf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function ayf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function byf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;Weh();c[a+8>>2]=b;c[a+12>>2]=d;c[a+4>>2]=e;if((g&255)<29){e=(g&255)<<16;c[a>>2]=f?e|-2147483648:e;i=h;return}else{h=c[885026]|0;RI(2964880)|0;e=qL(2964880)|0;wdg(e,h);Auh(e)}}function cyf(a,b){a=a|0;b=b|0;var d=0;c[a+12>>2]=0;c[a+4>>2]=0;if((b|0)>-1){c[a>>2]=0;d=b}else{c[a>>2]=-2147483648;d=0-b|0}c[a+8>>2]=d;return}function dyf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;c[a+12>>2]=0;c[a+4>>2]=0;c[a>>2]=0;return}function eyf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;c[a+4>>2]=0;if((d|0)>-1|(d|0)==-1&b>>>0>4294967295){c[a>>2]=0;f=b;g=d;h=b}else{c[a>>2]=-2147483648;j=ZEi(0,0,b|0,d|0)|0;f=j;g=H;h=j}c[a+8>>2]=f;c[a+12>>2]=g;i=e;return}function fyf(a,b,d){a=a|0;b=b|0;d=d|0;c[a+4>>2]=0;c[a>>2]=0;c[a+8>>2]=b;c[a+12>>2]=d;return}function gyf(b,d){b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e+20|0;h=e+16|0;j=e;g[f>>2]=d;Xeh();do if(!(d>ea(7922816250000000381049896.0e4)|d<ea(-7922816250000000381049896.0e4)|(d!=d|ea(0.0)!=ea(0.0)))){if(!(d>=ea(0.0))?(k=d==ea(-x),k|d==ea(x)):0)break;if(!(d<=ea(0.0))?(k=d==ea(-x),k|d==ea(x)):0)break;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}k=qxf(f,eKf(0)|0)|0;l=eKf(0)|0;RI(2592872)|0;if(a[2593020]|0){hyf(j,0,k,167,l);m=c[j>>2]|0;n=j+4|0;o=c[n>>2]|0;p=j+8|0;q=c[p>>2]|0;r=j+12|0;s=c[r>>2]|0;c[b>>2]=m;t=b+4|0;c[t>>2]=o;u=b+8|0;c[u>>2]=q;v=b+12|0;c[v>>2]=s;i=e;return}RI(2592872)|0;Buh(2592872);hyf(j,0,k,167,l);m=c[j>>2]|0;n=j+4|0;o=c[n>>2]|0;p=j+8|0;q=c[p>>2]|0;r=j+12|0;s=c[r>>2]|0;c[b>>2]=m;t=b+4|0;c[t>>2]=o;u=b+8|0;c[u>>2]=q;v=b+12|0;c[v>>2]=s;i=e;return}while(0);RI(1086352)|0;e=Huh(1086352,1)|0;g[h>>2]=d;RI(2586184)|0;s=pL(2586184,h)|0;Qqh(e,s);c[e+16>>2]=s;s=Uxf(0,c[885046]|0,e)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,s);Auh(e)}function hyf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;d=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;efh();if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[885228]|0);Auh(h)}if(f&512){RI(2965048)|0;h=qL(2965048)|0;Rag(h,c[885230]|0,c[885232]|0);Auh(h)}RI(2592872)|0;if(a[2593020]|0){_yf(0,e,f,g,b,1)|0;i=d;return}RI(2592872)|0;Buh(2592872);_yf(0,e,f,g,b,1)|0;i=d;return}function iyf(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+8|0;g=e;j=e+16|0;h[f>>3]=d;Yeh();do if(!(d>7922816251426433759354395.0e4|d<-7922816251426433759354395.0e4|(d!=d|0.0!=0.0))){if(!(d>=0.0)?d==-x|d==x:0)break;if(!(d<=0.0)?d==-x|d==x:0)break;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}k=Zxf(f,eKf(0)|0)|0;l=eKf(0)|0;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}hyf(j,0,k,167,l);l=c[j+4>>2]|0;k=c[j+8>>2]|0;m=c[j+12>>2]|0;c[b>>2]=c[j>>2];c[b+4>>2]=l;c[b+8>>2]=k;c[b+12>>2]=m;i=e;return}while(0);RI(1086352)|0;e=Huh(1086352,1)|0;h[g>>3]=d;RI(2589144)|0;b=pL(2589144,g)|0;Qqh(e,b);c[e+16>>2]=b;b=Uxf(0,c[885086]|0,e)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,b);Auh(e)}function jyf(a){a=a|0;var b=0;a=i;Weh();RI(2592872)|0;b=c[648241]|0;c[b>>2]=-2147483648;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;Weh();RI(2592872)|0;b=c[648241]|0;c[b+16>>2]=0;c[b+20>>2]=-1;c[b+24>>2]=-1;c[b+28>>2]=-1;RI(2592872)|0;b=c[648241]|0;c[b+32>>2]=-2147483648;c[b+36>>2]=0;c[b+40>>2]=1;c[b+44>>2]=0;RI(2592872)|0;b=c[648241]|0;c[b+48>>2]=0;c[b+52>>2]=0;c[b+56>>2]=1;c[b+60>>2]=0;Weh();RI(2592872)|0;b=c[648241]|0;c[b+64>>2]=65536;c[b+68>>2]=-1;c[b+72>>2]=-1;c[b+76>>2]=-1;i=a;return}function kyf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Zeh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[885090]|0);Auh(h)};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];RI(2592872)|0;b=pL(2592872,g)|0;RI(3034288)|0;if(a[3034436]|0){j=Lmg(0,b,d,e,0)|0;i=f;return j|0}RI(3034288)|0;Buh(3034288);j=Lmg(0,b,d,e,0)|0;i=f;return j|0}function lyf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=hjg(0,e)|0;i=d;return b|0}function myf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=vjg(0,e)|0;i=d;return b|0}function nyf(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);Auh(b);return 0}function oyf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);Auh(c)}function pyf(a,b,d){a=a|0;b=b|0;d=d|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];return}function qyf(b,d){b=b|0;d=d|0;var e=0,f=0.0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];f=+qkg(0,e);i=d;return +f}function ryf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=Fkg(0,e)|0;i=d;return b|0}function syf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=Ukg(0,e)|0;i=d;return b|0}function tyf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=glg(0,e)|0;i=d;return b|0}function uyf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=wlg(0,e)|0;i=d;return b|0}function vyf(b,d){b=b|0;d=d|0;var e=0,f=Im;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];f=ea(Jlg(0,e));i=d;return ea(f)}function wyf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=Ylg(0,e)|0;i=d;return b|0}function xyf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=kmg(0,e)|0;i=d;return b|0}function yyf(b,d){b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)};c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=ymg(0,e)|0;i=d;return b|0}function zyf(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;RI(1101728)|0;d=Huh(1101728,4)|0;e=d+16|0;c[e>>2]=c[b+8>>2];c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[b+12>>2];c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[b+4>>2];c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[b>>2];i=a;return d|0}function Ayf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;d=i;_eh();RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}if(!(Byf(0,e,f)|0)){c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=d;return}else{d=c[885094]|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,d);Auh(e)}}function Byf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648296]|0;if(!e){f=MK(2593192)|0;c[648296]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Cyf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;i=i+16|0;g=d;$eh();c[f>>2]=c[f>>2]^-2147483648;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}h=Byf(0,e,f)|0;if(!h){c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=d;return}c[g>>2]=h;RI(2540224)|0;h=pL(2540224,g)|0;if(!(a[2540708]|0))Buh(2540560);g=hwf(0,c[885116]|0,h,c[885118]|0)|0;RI(3086272)|0;h=qL(3086272)|0;xsg(h,g);Auh(h)}function Dyf(a){a=a|0;return c[a+4>>2]^c[a>>2]^c[a+8>>2]^c[a+12>>2]|0}function Eyf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;i=i+16|0;e=b;f=e;c[f>>2]=0;c[f+4>>2]=0;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}Fyf(0,d,0);if(!(Gyf(0,d,e)|0)){d=e;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}else{RI(3086272)|0;d=qL(3086272)|0;vwg(d);Auh(d)}return 0}function Fyf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648374]|0;if(!e){f=MK(2593504)|0;c[648374]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function Gyf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648260]|0;if(!e){f=MK(2593048)|0;c[648260]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Hyf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;i=i+16|0;e=b;f=e;c[f>>2]=0;c[f+4>>2]=0;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}Fyf(0,d,0);if(!(Iyf(0,d,e)|0)){d=e;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}else{RI(3086272)|0;d=qL(3086272)|0;vwg(d);Auh(d)}return 0}function Iyf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648278]|0;if(!e){f=MK(2593120)|0;c[648278]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Jyf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+32|0;f=b+16|0;g=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=(Kyf(0,g,f)|0)==0;i=b;return e|0}function Kyf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}e=Syf(0,c,d)|0;i=b;return e|0}function Lyf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;RI(2592872)|0;if(!(vL(d,2592872)|0)){j=0;i=e;return j|0}RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}RI(2592872)|0;k=Euh(d,2592872)|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];j=Jyf(0,g,f)|0;i=e;return j|0}function Myf(a){a=a|0;var b=0,d=0;b=i;if((c[a+4>>2]|0)==0?(c[a+8>>2]|0)==0:0)d=(c[a+12>>2]|0)==0;else d=0;i=b;return d|0}function Nyf(b,d,e){b=b|0;d=d|0;e=e|0;d=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}Fyf(0,e,1);c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=d;return}function Oyf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;d=i;if(!(Myf(e)|0)?!(Myf(f)|0):0){RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}if(Pyf(0,e,f)|0){RI(3086272)|0;f=qL(3086272)|0;vwg(f);Auh(f)};c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=d;return};c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return}function Pyf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648394]|0;if(!e){f=MK(2593584)|0;c[648394]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Qyf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;i=i+16|0;g=d;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;if(Myf(f)|0){RI(3067248)|0;h=qL(3067248)|0;Qqg(h);Auh(h)}if(Myf(e)|0){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return}RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}if(Ryf(0,g,e,f)|0){RI(3086272)|0;f=qL(3086272)|0;vwg(f);Auh(f)};c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];i=d;return}function Ryf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[648412]|0;if(!f){g=MK(2593656)|0;c[648412]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function Syf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648434]|0;if(!e){f=MK(2593744)|0;c[648434]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function Tyf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;afh();if(!d){j=1;i=e;return j|0}RI(2592872)|0;if(!(vL(d,2592872)|0)){k=c[885144]|0;RI(2965048)|0;l=qL(2965048)|0;Rbg(l,k);Auh(l)}RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];RI(2592872)|0;b=Euh(d,2592872)|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];j=Kyf(0,g,f)|0;i=e;return j|0}function Uyf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=Kyf(0,g,f)|0;i=e;return d|0}function Vyf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];b=Jyf(0,g,f)|0;i=e;return b|0}function Wyf(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}hyf(b,0,d,111,e);i=c;return}function Xyf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;bfh();b=c[885164]|0;c[e>>2]=d;RI(2540224)|0;d=pL(2540224,e)|0;if(!(a[2540708]|0))Buh(2540560);e=_vf(0,b,d)|0;RI(3079480)|0;d=qL(3079480)|0;Hrg(d,e);Auh(d)}function Yyf(a){a=a|0;var b=0;cfh();a=c[885186]|0;RI(3079480)|0;b=qL(3079480)|0;Hrg(b,a);Auh(b)}
function Zyf(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;b=i;dfh();a[h>>0]=0;a[j>>0]=0;c[k>>2]=0;c[g>>2]=-1;m=(e&1|0)==0;n=(e&2|0)==0;o=(e&4|0)==0;p=(e&8|0)==0;q=e>>>4;r=(e&64|0)==0;s=e>>>5;t=(e&128|0)==0;if((e&256|0)!=0?(e=Fvf(d,QTf(f)|0)|0,(e|0)>=0):0){u=Uvf(d,e,c[(QTf(f)|0)+8>>2]|0)|0;e=LTf(f)|0;v=u;w=e;x=MTf(f)|0}else{e=XTf(f)|0;v=d;w=e;x=YTf(f)|0}e=c[v+8>>2]|0;RI(2971904)|0;d=qL(2971904)|0;Ueg(d,e);a:do if((e|0)>0){u=(q&1|0)==0;y=0;z=0;b:while(1){A=y;B=z;c:while(1){C=B;d:while(1){while(1){D=Wof(v,C)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(jpf(0,D)|0){E=A;F=y;G=C;break a}if(!m){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(Xof(0,D)|0)break}if(!(D<<16>>16!=40|u|A|y)){H=C;break c}if(o){I=D;J=y;K=A;L=C;break b}if(!(D<<16>>16!=(Wof(VTf(f)|0,0)|0)<<16>>16|A)){M=c[(VTf(f)|0)+8>>2]|0;if((M|0)==1){N=1;O=C;P=23;break d}if((dpf(v,VTf(f)|0,C,M)|0)==(C|0)){N=M;O=C;P=23;break d}else continue}if(D<<16>>16!=(Wof(iUf(f)|0,0)|0)<<16>>16|A){I=D;J=y;K=A;L=C;break b}D=c[(iUf(f)|0)+8>>2]|0;if((D|0)==1){Q=1;R=C;break d}if((dpf(v,iUf(f)|0,C,D)|0)==(C|0)){Q=D;R=C;break d}}D=C+1|0;if((D|0)<(e|0))C=D;else{E=A;F=y;G=D;break a}}if((P|0)==23){P=0;a[h>>0]=1;Q=N;R=O}C=Q+R|0;if((C|0)<(e|0)){A=1;B=C}else{E=1;F=y;G=C;break a}}a[h>>0]=1;B=H+1|0;if((B|0)<(e|0)){y=1;z=B}else{E=1;F=1;G=B;break a}}if((s&1|0)!=0?I<<16>>16==(Wof(w,0)|0)<<16>>16:0){z=c[w+8>>2]|0;if((z|0)==1){E=K;F=J;G=L;break}if((dpf(v,w,L,z)|0)==(L|0)){E=K;F=J;G=L;break}if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Xyf(0,L);RI(2592872)|0;Buh(2592872);Xyf(0,L)}if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Xyf(0,L);RI(2592872)|0;Buh(2592872);Xyf(0,L)}else{E=0;F=0;G=0}while(0);if((G|0)==(e|0))if(l){L=c[885198]|0;RI(3079480)|0;J=qL(3079480)|0;Hrg(J,L);Auh(J)}else{S=0;i=b;return S|0}J=(s&1|0)==0;s=w+8|0;L=x+8|0;K=G;G=0;e:while(1){I=K;f:while(1){H=(I|0)<(e|0);while(1){if(!H){T=I;U=G;break e}R=Wof(v,I)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(jpf(0,R)|0){V=R;P=47;break}if(!r?R<<16>>16==(Wof(x,0)|0)<<16>>16:0)break;if(J){W=I;X=G;P=66;break e}if(R<<16>>16!=(Wof(w,0)|0)<<16>>16|G){W=I;X=G;P=66;break e}R=c[s>>2]|0;if((R|0)==1){Y=1;Z=I;break f}if((dpf(v,w,I,R)|0)==(I|0)){Y=R;Z=I;break f}}if((P|0)==47){P=0;acg(d,V)|0;I=I+1|0;continue}H=c[L>>2]|0;if((H|0)!=1?(dpf(v,x,I,H)|0)!=(I|0):0){_=I;P=52;break e}I=H+I|0}c[g>>2]=Yeg(d)|0;K=Y+Z|0;G=1}if((P|0)==52){if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Xyf(0,_);RI(2592872)|0;Buh(2592872);Xyf(0,_)}if((P|0)==66){_=Wof(v,W)|0;if(!t){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if((wuf(0,_)|0)<<16>>16==69){a[j>>0]=1;j=W+1|0;if((j|0)>=(e|0)){if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Yyf(0);RI(2592872)|0;Buh(2592872);Yyf(0)}_=Wof(v,j)|0;do if(_<<16>>16==(Wof(iUf(f)|0,0)|0)<<16>>16){t=c[(iUf(f)|0)+8>>2]|0;if((t|0)!=1?(dpf(v,iUf(f)|0,j,t)|0)!=(j|0):0){$=j;aa=0;break}G=t+j|0;if((G|0)<(e|0)){$=G;aa=0}else{if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Yyf(0);RI(2592872)|0;Buh(2592872);Yyf(0)}}else if(_<<16>>16==(Wof(VTf(f)|0,0)|0)<<16>>16){G=c[(VTf(f)|0)+8>>2]|0;if((G|0)!=1?(dpf(v,VTf(f)|0,j,G)|0)!=(j|0):0){$=j;aa=0;break}t=G+j|0;if((t|0)<(e|0)){$=t;aa=1}else{if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Yyf(0);RI(2592872)|0;Buh(2592872);Yyf(0)}}else{$=j;aa=0}while(0);j=Wof(v,$)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(jpf(0,j)|0)){if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Yyf(0);RI(2592872)|0;Buh(2592872);Yyf(0)}c[k>>2]=(j&65535)+65488&65535;j=$+1|0;g:do if((j|0)<(e|0)){$=j;while(1){_=Wof(v,$)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!(jpf(0,_)|0)){ba=$;break g}c[k>>2]=(c[k>>2]|0)*10;_=Wof(v,$)|0;c[k>>2]=((_&65535)+65488&65535)+(c[k>>2]|0);_=$+1|0;if((_|0)<(e|0))$=_;else{ba=_;break}}}else ba=j;while(0);if(aa){c[k>>2]=0-(c[k>>2]|0);T=ba;U=X}else{T=ba;U=X}}else{T=W;U=X}}else{T=W;U=X}}h:do if((T|0)<(e|0)){X=(q&1|0)==0;W=E;ba=F;k=T;i:while(1){aa=ba^1;j=W;$=k;j:while(1){_=$;k:while(1){while(1){t=Wof(v,_)|0;if(!n){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(Xof(0,t)|0)break}if(!(t<<16>>16!=41|X|aa)){ca=j;da=_;break j}if(p){ea=_;break i}if(!(t<<16>>16!=(Wof(VTf(f)|0,0)|0)<<16>>16|j)){G=c[(VTf(f)|0)+8>>2]|0;if((G|0)==1){fa=1;ga=_;P=119;break k}if((dpf(v,VTf(f)|0,_,G)|0)==(_|0)){fa=G;ga=_;P=119;break k}else continue}if(t<<16>>16!=(Wof(iUf(f)|0,0)|0)<<16>>16|j){ea=_;break i}t=c[(iUf(f)|0)+8>>2]|0;if((t|0)==1){ha=1;ia=_;break k}if((dpf(v,iUf(f)|0,_,t)|0)==(_|0)){ha=t;ia=_;break k}}_=_+1|0;if((_|0)>=(e|0)){ja=ba;P=130;break h}}if((P|0)==119){P=0;a[h>>0]=1;ha=fa;ia=ga}$=ha+ia|0;if(($|0)>=(e|0)){ja=ba;P=130;break h}else j=1}j=da+1|0;if((j|0)<(e|0)){W=ca;ba=0;k=j}else break h}if(!l){S=0;i=b;return S|0}RI(2592872)|0;if(a[2593020]|0)Xyf(0,ea);RI(2592872)|0;Buh(2592872);Xyf(0,ea)}else{ja=F;P=130}while(0);if((P|0)==130?ja:0)if(l){l=c[885200]|0;RI(3079480)|0;ja=qL(3079480)|0;Hrg(ja,l);Auh(ja)}else{S=0;i=b;return S|0}if(!U)c[g>>2]=Yeg(d)|0;S=Fqh(2972072,d)|0;i=b;return S|0}function _yf(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+32|0;k=d+20|0;l=d+16|0;m=d+25|0;n=d+24|0;o=d;c[k>>2]=0;c[l>>2]=0;a[m>>0]=0;a[n>>0]=0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;ffh();RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;Buh(2755888)}p=lUf(0,g)|0;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}g=Zyf(0,e,f,p,k,m,n,l,j)|0;if(!g){c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;q=0;i=d;return q|0}p=c[k>>2]|0;if((p|0)<=-1){if(j){f=c[885266]|0;RI(2589312)|0;e=qL(2589312)|0;c[e+40>>2]=-2146233088;c[e+16>>2]=f;Auh(e)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;q=0;i=d;return q|0}e=c[g+8>>2]|0;if((p|0)>0){f=0;while(1){r=f+1|0;if((Wof(g,f)|0)<<16>>16!=48){s=f;break}if((r|0)<(p|0))f=r;else{s=r;break}}if((s|0)<2|(e|0)<2){t=g;u=p}else{f=fpf(g,s,e-s|0)|0;e=p-s|0;c[k>>2]=e;t=f;u=e}}else{t=g;u=0}g=(u|0)==0?27:28;e=c[t+8>>2]|0;f=g+1|0;if((e|0)<(f|0))v=g;else{RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}s=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);p=(rvf(0,t,0,c[885268]|0,0,f,0,s)|0)>0;v=p?g:f}do if((e|0)>(v|0)&(u|0)<(e|0)){f=((Wof(t,v)|0)&65535)+65488&65535;g=fpf(t,0,v)|0;if(f>>>0<6){if((f|0)!=5){w=g;x=u;break}if((a[m>>0]|0)==0?((Wof(g,v+-1|0)|0)&1)==0:0){w=g;x=u;break}}f=$uf(g)|0;g=f+16|0;p=v;while(1){s=p+-1|0;r=g+(da(c[(c[f>>2]|0)+120>>2]|0,s)|0)|0;y=b[r>>1]|0;if(y<<16>>16!=57){z=r;A=y;B=p;C=28;break}b[r>>1]=48;if((s|0)>0)p=s;else{D=s;break}}if((C|0)==28){b[z>>1]=(A&65535)+1;D=B}if((D|0)==0?(b[g>>1]|0)==48:0){p=u+1|0;c[k>>2]=p;w=Ovf(c[885270]|0,p,48)|0;x=p;break}if(!(a[2540708]|0))Buh(2540560);qL(2540560)|0;w=Bwf(0,f)|0;x=u}else{w=t;x=u}while(0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}if($yf(0,o,w,x,0)|0){if(j){RI(3086272)|0;x=qL(3086272)|0;vwg(x);Auh(x)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;q=0;i=d;return q|0}if(a[n>>0]|0){RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}if(azf(0,o,c[l>>2]|0)|0){if(j){RI(3086272)|0;j=qL(3086272)|0;vwg(j);Auh(j)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;q=0;i=d;return q|0}}if(a[m>>0]|0)c[o>>2]=c[o>>2]^-2147483648;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];q=1;i=d;return q|0}function $yf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;g=c[648314]|0;if(!g){h=MK(2593264)|0;c[648314]=h;j=h}else j=g;g=kn[j&511](b,d,e,f)|0;i=a;return g|0}function azf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[648340]|0;if(!e){f=MK(2593368)|0;c[648340]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function bzf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Buh(3102784)};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];b=Dvg(0,d,g,e)|0;i=f;return b|0}function czf(a){a=a|0;var b=0,d=0;b=i;gfh();d=bzf(a,c[885308]|0,0)|0;i=b;return d|0}function dzf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;hfh();e=bzf(a,c[885314]|0,b)|0;i=d;return e|0}function ezf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;a=i;d=c[648360]|0;if(!d){e=MK(2593448)|0;c[648360]=e;f=e}else f=d;g=+Wm[f&15](b);i=a;return +g}function fzf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;d=i;i=i+48|0;f=d+32|0;g=d+16|0;h=d;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=1;c[h+12>>2]=0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];Ayf(b,0,g,f);i=d;return}function gzf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;i=i+32|0;g=d+16|0;h=d;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];Cyf(b,0,h,g);i=d;return}function hzf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;i=i+32|0;g=d+16|0;h=d;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];Oyf(b,0,h,g);i=d;return}function izf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;i=i+32|0;g=d+16|0;h=d;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];Qyf(b,0,h,g);i=d;return}function jzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Eyf(0,e)|0;e=H;if(e>>>0>0|(e|0)==0&d>>>0>255)Auh(PJ(3068960)|0);else{i=b;return d&255|0}return 0}function kzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Hyf(0,e)|0;e=H;if((e|0)>0|(e|0)==0&d>>>0>127)Auh(PJ(3068960)|0);else{i=b;return d&255|0}return 0}function lzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Hyf(0,e)|0;e=H;if((e|0)>0|(e|0)==0&d>>>0>32767)Auh(PJ(3068960)|0);else{i=b;return d&65535|0}return 0}function mzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Eyf(0,e)|0;e=H;if(e>>>0>0|(e|0)==0&d>>>0>65535)Auh(PJ(3068960)|0);else{i=b;return d&65535|0}return 0}function nzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Hyf(0,e)|0;e=H;if((e|0)>0|(e|0)==0&d>>>0>2147483647)Auh(PJ(3068960)|0);else{i=b;return d|0}return 0}function ozf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Eyf(0,e)|0;e=H;if(e>>>0>0|(e|0)==0&d>>>0>4294967295)Auh(PJ(3068960)|0);else{i=b;return d|0}return 0}function pzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Hyf(0,e)|0;i=b;return d|0}function qzf(b,d){b=b|0;d=d|0;var e=0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=Eyf(0,e)|0;i=b;return d|0}function rzf(a,b,d){a=a|0;b=b|0;d=d|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;cyf(a,d&255);i=b;return}function szf(a,b,d){a=a|0;b=b|0;d=d|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;cyf(a,d<<24>>24);i=b;return}function tzf(a,b,d){a=a|0;b=b|0;d=d|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;cyf(a,d<<16>>16);i=b;return}function uzf(a,b,d){a=a|0;b=b|0;d=d|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;cyf(a,d&65535);i=b;return}function vzf(a,b,d){a=a|0;b=b|0;d=d|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;cyf(a,d);i=b;return}function wzf(a,b,d){a=a|0;b=b|0;d=d|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+8>>2]=d;c[a+12>>2]=0;c[a+4>>2]=0;c[a>>2]=0;return}function xzf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;eyf(a,d,e);i=b;return}function yzf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+8>>2]=d;c[a+12>>2]=e;return}function zzf(a,b,d){a=a|0;b=b|0;d=ea(d);b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;gyf(a,d);i=b;return}function Azf(a,b,d){a=a|0;b=b|0;d=+d;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;iyf(a,d);i=b;return}function Bzf(b,d){b=b|0;d=d|0;var e=0,f=Im;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];f=ea(+Czf(0,e));i=b;return ea(f)}function Czf(b,c){b=b|0;c=c|0;var d=0.0;b=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)}d=+ezf(0,c);i=b;return +d}function Dzf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+32|0;f=b+16|0;g=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=(Jyf(0,g,f)|0)^1;i=b;return e|0}function Ezf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+32|0;f=b+16|0;g=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=Jyf(0,g,f)|0;i=b;return e|0}function Fzf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+32|0;f=b+16|0;g=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=(Kyf(0,g,f)|0)>0;i=b;return e|0}function Gzf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+32|0;f=b+16|0;g=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Buh(2592872)};c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];e=(Kyf(0,g,f)|0)<0;i=b;return e|0}function Hzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function Izf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2601232)|0;Jzf(a,0,-1,-1,-1,-1);c[c[d>>2]>>2]=a;i=b;return}function Jzf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;a[b+8>>0]=d;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}a[b+9>>0]=(gjg(0,e)|0)&1;c[b+12>>2]=f;c[b+16>>2]=g;c[b+20>>2]=h;i=j;return}function Kzf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2601232)|0;Jzf(a,0,0,-1,-1,-1);c[c[d>>2]>>2]=a;i=b;return}function Lzf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2601232)|0;Jzf(a,0,-1,0,0,1);c[c[d>>2]>>2]=a;i=b;return}function Mzf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2601232)|0;Jzf(a,0,0,0,0,1);c[c[d>>2]>>2]=a;i=b;return}function Nzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Ozf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Pzf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Qzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Rzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Szf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Tzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Uzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Vzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Wzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Xzf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function Yzf(a){a=a|0;var b=0;a=i;ifh();b=c[885318]|0;RI(2601984)|0;c[c[650519]>>2]=b;b=c[885320]|0;RI(2601984)|0;c[(c[650519]|0)+4>>2]=b;i=a;return}function Zzf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;jfh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[885330]|0);Auh(h)}a[g>>0]=(a[b>>0]|0)!=0&1;RI(2601984)|0;b=pL(2601984,g)|0;RI(3034288)|0;if(a[3034436]|0){j=Lmg(0,b,d,e,0)|0;i=f;return j|0}RI(3034288)|0;Buh(3034288);j=Lmg(0,b,d,e,0)|0;i=f;return j|0}function _zf(b,c){b=b|0;c=c|0;return (a[b>>0]|0)!=0|0}function $zf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=tjg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function aAf(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);Auh(b);return 0}function bAf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);Auh(c)}function cAf(b,c,d){b=b|0;c=c|0;d=d|0;d=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}bkg(b,0,(a[c>>0]|0)!=0);i=d;return}function dAf(b,c){b=b|0;c=c|0;var d=0.0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=+okg(0,(a[b>>0]|0)!=0);i=c;return +d}function eAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Ckg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function fAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Rkg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function gAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=dlg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function hAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=tlg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function iAf(b,c){b=b|0;c=c|0;var d=Im;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=ea(Hlg(0,(a[b>>0]|0)!=0));i=c;return ea(d)}function jAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=Vlg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function kAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=hmg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function lAf(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}d=vmg(0,(a[b>>0]|0)!=0)|0;i=c;return d|0}function mAf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;kfh();if(!d){f=1;i=e;return f|0}RI(2601984)|0;if(!(vL(d,2601984)|0)){g=c[885334]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}RI(2601984)|0;h=a[(Euh(d,2601984)|0)>>0]|0;d=a[b>>0]|0;if(d<<24>>24!=0&h<<24>>24==0){f=1;i=e;return f|0}f=((d<<24>>24|0)!=(h&255|0))<<31>>31;i=e;return f|0}function nAf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!c){e=0;i=d;return e|0}RI(2601984)|0;if(!(vL(c,2601984)|0)){e=0;i=d;return e|0}RI(2601984)|0;f=a[(Euh(c,2601984)|0)>>0]|0;e=f<<24>>24!=((a[b>>0]|0)==0&1);i=d;return e|0}function oAf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;e=a[b>>0]|0;if((e<<24>>24|0)==(c&1|0)){f=0;i=d;return f|0}f=e<<24>>24==0?-1:1;i=d;return f|0}function pAf(b,c){b=b|0;c=c|0;return (a[b>>0]|0)!=0^c^1|0}function qAf(b){b=b|0;return (a[b>>0]|0)!=0|0}function rAf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;lfh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[885350]|0);Auh(e)}e=jvf(d)|0;RI(2601984)|0;if(!(a[2602132]|0)){RI(2601984)|0;Buh(2601984)}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}d=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);RI(2601984)|0;if(!(qvf(0,e,c[(c[650519]|0)+4>>2]|0,1,d)|0)){f=1;i=b;return f|0}RI(2601984)|0;if(!(a[2602132]|0)){RI(2601984)|0;Buh(2601984)}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}d=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);RI(2601984)|0;if(!(qvf(0,e,c[c[650519]>>2]|0,1,d)|0)){f=0;i=b;return f|0}else{f=c[885352]|0;RI(3079480)|0;b=qL(3079480)|0;Hrg(b,f);Auh(b)}return 0}function sAf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=(a[b>>0]|0)==0;RI(2601984)|0;b=(a[2602132]|0)!=0;if(e){if(!b){RI(2601984)|0;Buh(2601984)}RI(2601984)|0;f=c[650519]|0;g=c[f>>2]|0;i=d;return g|0}else{if(!b){RI(2601984)|0;Buh(2601984)}RI(2601984)|0;f=(c[650519]|0)+4|0;g=c[f>>2]|0;i=d;return g|0}return 0}function tAf(a,b){a=a|0;b=b|0;var c=0;b=i;c=sAf(a)|0;i=b;return c|0}function uAf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function vAf(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function wAf(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;return}function xAf(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function yAf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;mfh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[885386]|0);Auh(e)}else{e=c[a>>2]|0;iag(b,c[885388]|0,e,((e|0)<0)<<31>>31);i=d;return}}function zAf(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;H=((d|0)<0)<<31>>31;i=b;return d|0}function AAf(a){a=a|0;return 4}function BAf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2604248)|0;if(!(vL(b,2604248)|0)){e=0;i=d;return e|0}RI(2604248)|0;f=c[(Euh(b,2604248)|0)>>2]|0;e=(f|0)==(c[a>>2]|0);i=d;return e|0}function CAf(a){a=a|0;return c[a>>2]|0}function DAf(a){a=a|0;var b=0,c=0;b=i;c=EAf(a,0)|0;i=b;return c|0}function EAf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[a>>2];a=vpf(e,b,0)|0;i=d;return a|0}function FAf(a,b,d){a=a|0;b=b|0;d=d|0;return (c[b>>2]|0)==(c[d>>2]|0)|0}function GAf(a,b,d){a=a|0;b=b|0;d=d|0;return (c[b>>2]|0)!=(c[d>>2]|0)|0}function HAf(a,b){a=a|0;b=b|0;return b|0}function IAf(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function JAf(a,b){a=a|0;b=b|0;return b|0}function KAf(a,b){a=a|0;b=b|0;return c[b>>2]|0}function LAf(a,b){a=a|0;b=b|0;return c[b>>2]|0}function MAf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function NAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function OAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function PAf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2896008)|0;r5f(b,2,1);c[(c[e>>2]|0)+4>>2]=b;i=d;return}function QAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function RAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function SAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function TAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function UAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function VAf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function WAf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2896008)|0;r5f(b,2,1);c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function XAf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function YAf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function ZAf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;nfh();if(e>>>0<1|(e|0)==1&d>>>0<0){c[b>>2]=d;i=f;return}RI(2606296)|0;if(!(a[2606444]|0)){RI(2606296)|0;Buh(2606296)}f=c[885392]|0;RI(3086272)|0;d=qL(3086272)|0;xsg(d,f);Auh(d)}function _Af(a){a=a|0;return 4}function $Af(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function aBf(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function bBf(a){a=a|0;a=i;RI(2606296)|0;c[c[651597]>>2]=0;i=a;return}function cBf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;ofh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[885410]|0);Auh(e)}else{e=c[a>>2]|0;jag(b,c[885412]|0,e,((e|0)<0)<<31>>31);i=d;return}}function dBf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2606296)|0;if(!(vL(b,2606296)|0)){e=0;i=d;return e|0}RI(2606296)|0;f=c[(Euh(b,2606296)|0)>>2]|0;e=(c[a>>2]|0)==(f|0);i=d;return e|0}function eBf(a){a=a|0;return c[a>>2]|0}function fBf(a){a=a|0;return c[a>>2]|0}function gBf(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;H=((d|0)<0)<<31>>31;i=b;return d|0}function hBf(a){a=a|0;return c[a>>2]|0}function iBf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=c[a>>2];a=Mqf(d)|0;i=b;return a|0}function jBf(a,b,d){a=a|0;b=b|0;d=d|0;return (c[b>>2]|0)==(c[d>>2]|0)|0}function kBf(a,b,d){a=a|0;b=b|0;d=d|0;return (c[b>>2]|0)!=(c[d>>2]|0)|0}function lBf(a,b){a=a|0;b=b|0;var d=0;a=i;d=c[b>>2]|0;H=((d|0)<0)<<31>>31;i=a;return d|0}function mBf(a,b){a=a|0;b=b|0;return c[b>>2]|0}function nBf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=0;ZAf(e,b,d);i=a;return c[e>>2]|0}function oBf(a,b){a=a|0;b=b|0;return b|0}function pBf(a,b){a=a|0;b=b|0;return c[b>>2]|0}function qBf(a,b){a=a|0;b=b|0;return b|0}function rBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function sBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function tBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function uBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function vBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function wBf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Oqg(0,a,b,f);i=e;return}function xBf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Oqg(0,a,b,f);i=e;return}function yBf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;do if(zBf(a,b)|0?(RI(2608144)|0,e=vL(b,2608144)|0,(e|0)!=0):0){f=c[a+44>>2]|0;g=c[e+44>>2]|0;if(!f){h=(g|0)==0;break}else{h=nrh(2608312,f,g)|0;break}}else h=0;while(0);i=d;return h|0}function zBf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(2609192)|0;f=vL(d,2609192)|0;if(!f){g=0;i=e;return g|0}if((c[f+16>>2]|0)!=(c[b+16>>2]|0)){g=0;i=e;return g|0}if((c[f+20>>2]|0)!=(c[b+20>>2]|0)){g=0;i=e;return g|0}d=c[f+40>>2]|0;f=(d|0)==0;h=c[b+40>>2]|0;b=(h|0)==0;if(f|b){g=f?b:0;i=e;return g|0}if((c[d+8>>2]|0)!=(c[h+8>>2]|0)){g=0;i=e;return g|0}b=c[d+12>>2]|0;d=c[h+12>>2]|0;if(!(a[2540708]|0))Buh(2540560);g=gpf(0,b,d)|0;i=e;return g|0}function ABf(a){a=a|0;var b=0,c=0;b=i;c=BBf(a)|0;i=b;return c|0}function BBf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+20>>2]|0;e=c[a+16>>2]|0;if(!e)f=0;else f=Aqh(2536720,e)|0;i=b;return f^d|0}function CBf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=bth(2608368,b)|0;RI(2608144)|0;b=Juh(g,2608144)|0;c[b+48>>2]=0;g=c[b+44>>2]|0;if(!g)h=b;else{j=g;k=g;g=b;while(1){c[k+48>>2]=g;b=c[j+44>>2]|0;if(!b){h=j;break}else{l=j;j=b;k=b;g=l}}}if(!(c[h+48>>2]|0)){g=bth(2608368,h)|0;RI(2608144)|0;k=Juh(g,2608144)|0;c[k+44>>2]=0;c[k+48>>2]=0;RI(1175416)|0;g=Huh(1175416,1)|0;Qqh(g,k);c[g+16>>2]=k;m=g;i=d;return m|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;Buh(2713640)}RI(2713640)|0;g=qL(2713640)|0;$Lf(g);if(h){k=h;do{h=bth(2608368,k)|0;RI(2608144)|0;j=Juh(h,2608144)|0;c[j+44>>2]=0;c[j+48>>2]=0;Erh(2714056,g,j)|0;k=c[k+48>>2]|0}while((k|0)!=0)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=3440896;c[e+0>>2]=c[f+0>>2];f=Uuh(2715064,g,npf(0,e)|0)|0;RI(1175416)|0;m=Juh(f,1175416)|0;i=d;return m|0}function DBf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;pfh();e=Xnf(a)|0;if((e|0)!=(Xnf(b)|0)){e=c[885420]|0;RI(2965048)|0;f=qL(2965048)|0;Rbg(f,e);Auh(f)}f=bth(2608368,b)|0;RI(2608144)|0;e=Juh(f,2608144)|0;EBf(e);RI(2608144)|0;f=c[(Juh(b,2608144)|0)+44>>2]|0;if(!f)g=e;else{b=f;f=e;while(1){h=bth(2608368,b)|0;RI(2608144)|0;j=Juh(h,2608144)|0;c[f+44>>2]=j;b=c[b+44>>2]|0;if(!b){g=j;break}else f=j}}f=bth(2608368,a)|0;RI(2608144)|0;b=Juh(f,2608144)|0;c[g+44>>2]=b;g=c[a+44>>2]|0;if(!g){i=d;return e|0}else{k=g;l=b}do{b=bth(2608368,k)|0;RI(2608144)|0;g=l;l=Juh(b,2608144)|0;c[g+44>>2]=l;k=c[k+44>>2]|0}while((k|0)!=0);i=d;return e|0}function EBf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[652360]|0;if(!d){e=MK(2609448)|0;c[652360]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function FBf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zBf(a,b)|0;i=c;return d|0}function GBf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a=i;c[b+48>>2]=0;f=0;g=b;while(1){a:do if(!f){h=0;j=0}else{k=f;while(1){if(zBf(k,g)|0){h=1;j=k;break a}k=c[k+48>>2]|0;if(!k){h=0;j=0;break}}}while(0);k=c[g+44>>2]|0;if(!k){l=b;m=d;n=d;break}if(h)o=c[j+44>>2]|0;else o=b;if(zBf(k,o)|0)p=c[o+48>>2]|0;else p=o;c[k+48>>2]=p;f=o;g=k}b:while(1){g=l;o=m;while(1){if(!g)q=b;else{if(!(zBf(g,o)|0)){r=g;s=o;break}q=c[g+44>>2]|0}o=c[o+44>>2]|0;if(!q){t=n;u=o;v=19;break b}if(!o){t=0;u=0;v=19;break b}else g=q}l=c[r+48>>2]|0;m=s;n=c[n+44>>2]|0}if((v|0)==19){c[e>>2]=u;i=a;return t|0}return 0}function HBf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d;c[e>>2]=0;if(!b){f=a;i=d;return f|0}RI(2608144)|0;g=GBf(0,Juh(b,2608144)|0,a,e)|0;if(!g){f=a;i=d;return f|0}if((g|0)==(a|0)){h=0;j=0}else{b=0;k=0;l=a;while(1){a=bth(2608368,l)|0;RI(2608144)|0;m=Juh(a,2608144)|0;if(!b)n=m;else{c[b+44>>2]=m;n=k}l=c[l+44>>2]|0;if((l|0)==(g|0)){h=m;j=n;break}else{b=m;k=n}}}n=c[e>>2]|0;if(!n){o=h;p=j}else{e=h;h=j;j=n;while(1){n=bth(2608368,j)|0;RI(2608144)|0;k=Juh(n,2608144)|0;if(!e)q=k;else{c[e+44>>2]=k;q=h}j=c[j+44>>2]|0;if(!j){o=k;p=q;break}else{e=k;h=q}}}if(o)c[o+44>>2]=0;f=p;i=d;return f|0}function IBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function JBf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;h=a+32|0;j=c[h>>2]|0;if(j){k=j;i=b;return k|0}j=a+20|0;a=c[j>>2]|0;RI(2604248)|0;if((a|0)==(c[c[651085]>>2]|0)){k=c[h>>2]|0;i=b;return k|0}else{a=c[j>>2]|0;c[e>>2]=0;c[f>>2]=a;c[d+0>>2]=c[f+0>>2];Cwg(e,d);c[g>>2]=c[e>>2];c[d+0>>2]=c[g+0>>2];g=E1f(0,d)|0;RI(2834864)|0;d=Juh(g,2834864)|0;c[h>>2]=d;k=d;i=b;return k|0}return 0}function KBf(a){a=a|0;return c[a+16>>2]|0}function LBf(a){a=a|0;var b=0,c=0;b=i;c=Ynf(a)|0;i=b;return c|0}function MBf(a){a=a|0;var b=0,d=0;b=i;RI(1175416)|0;d=Huh(1175416,1)|0;Qqh(d,a);c[d+16>>2]=a;i=b;return d|0}function NBf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;qfh();if(!b){e=d;i=a;return e|0}if(!d){e=b;i=a;return e|0}f=Xnf(b)|0;if((f|0)!=(Xnf(d)|0)){f=c[885438]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}e=Vuh(2609488,b,d)|0;i=a;return e|0}function OBf(b,d){b=b|0;d=d|0;if(!(a[2540708]|0))Buh(2540560);RI(3099304)|0;d=qL(3099304)|0;hug(d,c[c[635163]>>2]|0);Auh(d);return 0}function PBf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b)d=0;else d=Vuh(2609544,b,c)|0;i=a;return d|0}function QBf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nrh(2609600,a,b)|0;i=c;return (d?0:a)|0}function RBf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2819056)|0;OXf(b,2);c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function SBf(a){a=a|0;var d=0;a=i;RI(1136088)|0;d=Huh(1136088,1)|0;b[d+16>>1]=44;RI(2610848)|0;c[c[652735]>>2]=d;i=a;return}function TBf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=sjg(0,e,c)|0;i=d;return b|0}function UBf(a){a=a|0;var b=0,c=0;b=i;c=kCf(a)|0;i=b;return c|0}function VBf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=Gjg(0,e,c)|0;i=d;return b|0}function WBf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=Rjg(0,e,c)|0;i=d;return b|0}function XBf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=kCf(c)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}Yjg(b,0,f,d);i=e;return}function YBf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=kCf(c)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}nkg(b,0,f,d);i=e;return}function ZBf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0.0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}f=+Bkg(0,e,c);i=d;return +f}function _Bf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=Qkg(0,e,c)|0;i=d;return b|0}function $Bf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=clg(0,e,c)|0;i=d;return b|0}function aCf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=slg(0,e,c)|0;i=d;return b|0}function bCf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=Glg(0,e,c)|0;i=d;return b|0}function cCf(b,c){b=b|0;c=c|0;var d=0,e=0,f=Im;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}f=ea(Ulg(0,e,c));i=d;return ea(f)}function dCf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f;rfh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[885442]|0);Auh(j)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[h>>2]=3431728;c[g+0>>2]=c[h+0>>2];if((npf(0,g)|0)==(d|0)){k=Wuh(2611016,b,e)|0;i=f;return k|0}g=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}k=Lmg(0,g,d,e,0)|0;i=f;return k|0}function eCf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=gmg(0,e,c)|0;i=d;return b|0}function fCf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=umg(0,e,c)|0;i=d;return b|0}function gCf(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=kCf(b)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Buh(3034288)}b=Jmg(0,e,c)|0;i=d;return b|0}function hCf(b){b=b|0;var c=0,d=0,e=0;c=i;d=Xnf(b)|0;RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}b=iCf(0,d)|0;RI(2540728)|0;if(a[2540876]|0){e=jCf(0,b)|0;i=c;return e|0}RI(2540728)|0;Buh(2540728);e=jCf(0,b)|0;i=c;return e|0}function iCf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;tfh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[885476]|0);Auh(e)}if(!(Gqh(2611112,d)|0)){RI(2965048)|0;e=qL(2965048)|0;Rag(e,c[885478]|0,c[885480]|0);Auh(e)}RI(2610848)|0;if(a[2610996]|0){f=qCf(0,d)|0;i=b;return f|0}RI(2610848)|0;Buh(2610848);f=qCf(0,d)|0;i=b;return f|0}function jCf(b,c){b=b|0;c=c|0;var d=0,e=0;b=i;RI(3090984)|0;if(vL(c,3090984)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}d=NGf(0,c)|0;i=b;return d|0}if(!c){d=0;i=b;return d|0}e=suh(2619440,c)|0;if(!(kEf(e)|0)){d=1;i=b;return d|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}d=NGf(0,e)|0;i=b;return d|0}function kCf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[652768]|0;if(!d){e=MK(2611080)|0;c[652768]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function lCf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;g=d+8|0;h=d+12|0;j=d+14|0;k=d;RI(1101728)|0;l=vL(f,1101728)|0;if(l){RI(2540224)|0;c[g>>2]=c[(Euh(e,2540224)|0)>>2];RI(2540224)|0;m=pL(2540224,g)|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}RI(3074072)|0;n=mCf(0,l,m,c[(c[768541]|0)+16>>2]|0)|0;i=d;return n|0}RI(1166304)|0;m=vL(f,1166304)|0;if(m){RI(2551640)|0;n=h2g(0,m,c[(Euh(e,2551640)|0)>>2]|0)|0;i=d;return n|0}RI(1171272)|0;m=vL(f,1171272)|0;if(m){RI(2562664)|0;b[h>>1]=b[(Euh(e,2562664)|0)>>1]|0;RI(2562664)|0;l=pL(2562664,h)|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}RI(3074072)|0;n=mCf(0,m,l,c[(c[768541]|0)+12>>2]|0)|0;i=d;return n|0}RI(1150432)|0;l=vL(f,1150432)|0;if(l){RI(2565248)|0;n=j2g(0,l,b[(Euh(e,2565248)|0)>>1]|0)|0;i=d;return n|0}RI(1169800)|0;l=vL(f,1169800)|0;if(l){RI(2560032)|0;a[j>>0]=a[(Euh(e,2560032)|0)>>0]|0;RI(2560032)|0;m=pL(2560032,j)|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}RI(3074072)|0;n=mCf(0,l,m,c[(c[768541]|0)+8>>2]|0)|0;i=d;return n|0}RI(1159264)|0;m=vL(f,1159264)|0;if(m){RI(2557392)|0;n=l2g(0,m,a[(Euh(e,2557392)|0)>>0]|0)|0;i=d;return n|0}RI(1164824)|0;m=vL(f,1164824)|0;if(m){RI(2548816)|0;l=Euh(e,2548816)|0;j=c[l+4>>2]|0;h=k;c[h>>2]=c[l>>2];c[h+4>>2]=j;RI(2548816)|0;j=pL(2548816,k)|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}RI(3074072)|0;n=mCf(0,m,j,c[(c[768541]|0)+20>>2]|0)|0;i=d;return n|0}RI(1168328)|0;j=vL(f,1168328)|0;if(!j){n=nCf(0,f,e)|0;i=d;return n|0}else{RI(2554736)|0;f=Euh(e,2554736)|0;n=n2g(0,j,c[f>>2]|0,c[f+4>>2]|0)|0;i=d;return n|0}return 0}function mCf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;fgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886472]|0);Auh(f)}if((LDf(b)|0)>=2){f=c[886474]|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Auh(g)}if(!(PCf(b)|0)){h=-1;i=a;return h|0}if((e|0)==0&(d|0)!=0?(RI(2546528)|0,(vL(d,2546528)|0)==0):0){g=c[886476]|0;RI(2965048)|0;f=qL(2965048)|0;Rbg(f,g);Auh(f)}f=xDf(b,0)|0;h=qEf(0,b,f,JDf(b,0)|0,d,e)|0;i=a;return h|0}function nCf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;egh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886446]|0);Auh(e)}if(!d){f=-1;i=a;return f|0}if((LDf(b)|0)>=2){e=c[886448]|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,e);Auh(g)}if(!(PCf(b)|0)){f=-1;i=a;return f|0}RI(2546528)|0;if(!(vL(d,2546528)|0)){g=c[886450]|0;RI(2965048)|0;e=qL(2965048)|0;Rbg(e,g);Auh(e)}e=xDf(b,0)|0;f=qEf(0,b,e,JDf(b,0)|0,d,0)|0;i=a;return f|0}function oCf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;i=i+16|0;f=b;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;sfh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[885446]|0);Auh(g)}if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[885448]|0);Auh(g)}if(!(Gqh(2611112,d)|0)){RI(2965048)|0;g=qL(2965048)|0;Rag(g,c[885450]|0,c[885452]|0);Auh(g)}RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}g=pCf(0,d,e)|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}lrg(0,d,f);d=lCf(0,g,c[f+4>>2]|0)|0;if((d|0)<0){h=0;i=b;return h|0}g=c[f+8>>2]|0;h=c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,d)|0)>>2]|0;i=b;return h|0}function pCf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[652848]|0;if(!e){f=MK(2611400)|0;c[652848]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function qCf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[652792]|0;if(!d){e=MK(2611176)|0;c[652792]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function rCf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;b=i;if(g){g=e+12|0;if((c[g>>2]|0)<=0){h=-1;i=b;return h|0}j=e+16|0;k=0;while(1){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}l=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);if(!(qvf(0,f,c[j+(da(c[(c[e>>2]|0)+120>>2]|0,k)|0)>>2]|0,1,l)|0)){h=k;m=19;break}k=k+1|0;if((k|0)>=(c[g>>2]|0)){h=-1;m=19;break}}if((m|0)==19){i=b;return h|0}}if(d){g=uth(2736488,d,f)|0;if(!g){h=-1;i=b;return h|0}RI(2540224)|0;h=c[(Euh(g,2540224)|0)>>2]|0;i=b;return h|0}g=e+12|0;if((c[g>>2]|0)<=0){h=-1;i=b;return h|0}d=e+16|0;k=0;while(1){if(!(a[2540708]|0))Buh(2540560);if(gpf(0,f,c[d+(da(c[(c[e>>2]|0)+120>>2]|0,k)|0)>>2]|0)|0){h=k;m=19;break}k=k+1|0;if((k|0)>=(c[g>>2]|0)){h=-1;m=19;break}}if((m|0)==19){i=b;return h|0}return 0}function sCf(a,b,f){a=a|0;b=b|0;f=f|0;var g=0,h=0;a=i;ufh();switch(f|0){case 12:{RI(2554736)|0;f=Euh(b,2554736)|0;g=c[f+4>>2]|0;h=c[f>>2]|0;break}case 10:{RI(2551640)|0;g=0;h=c[(Euh(b,2551640)|0)>>2]|0;break}case 8:{RI(2565248)|0;g=0;h=e[(Euh(b,2565248)|0)>>1]|0;break}case 6:{RI(2557392)|0;g=0;h=d[(Euh(b,2557392)|0)>>0]|0;break}case 7:{RI(2562664)|0;g=0;h=e[(Euh(b,2562664)|0)>>1]|0;break}case 9:{RI(2540224)|0;g=0;h=c[(Euh(b,2540224)|0)>>2]|0;break}case 5:{RI(2560032)|0;g=0;h=d[(Euh(b,2560032)|0)>>0]|0;break}case 11:{RI(2548816)|0;f=Euh(b,2548816)|0;g=c[f+4>>2]|0;h=c[f>>2]|0;break}default:{RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885484]|0);Auh(f)}}H=g;i=a;return h|0}function tCf(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0;d=i;i=i+48|0;h=d+24|0;j=d+44|0;k=d+45|0;l=d+40|0;m=d+42|0;n=d+20|0;o=d+16|0;p=d;q=d+8|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;a[j>>0]=0;a[k>>0]=0;b[l>>1]=0;b[m>>1]=0;c[n>>2]=0;c[o>>2]=0;r=p;c[r>>2]=0;c[r+4>>2]=0;r=q;c[r>>2]=0;c[r+4>>2]=0;vfh();if(!e){RI(2963920)|0;r=qL(2963920)|0;Iag(r,c[885512]|0);Auh(r)}if(!f){RI(2963920)|0;r=qL(2963920)|0;Iag(r,c[885514]|0);Auh(r)}if(!(Gqh(2611112,e)|0)){RI(2965048)|0;r=qL(2965048)|0;Rag(r,c[885516]|0,c[885518]|0);Auh(r)}r=jvf(f)|0;if(!(c[r+8>>2]|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885520]|0);Auh(f)}RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}lrg(0,e,h);f=h+12|0;s=c[f>>2]|0;t=h+8|0;u=c[t>>2]|0;RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}v=rCf(0,s,u,r,g)|0;u=h+4|0;h=c[u>>2]|0;if((v|0)>=0){w=uCf(h,v)|0;i=d;return w|0}v=uCf(h,0)|0;RI(2610848)|0;h=Aqh(2611224,Juh(v,2610848)|0)|0;if((Cvf(r,44)|0)!=-1){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}RI(2610848)|0;v=evf(r,c[c[652735]>>2]|0,2147483647)|0;s=v+12|0;a:do if((c[s>>2]|0)>0){x=v+16|0;y=0;z=0;A=0;while(1){B=c[f>>2]|0;C=c[t>>2]|0;D=jvf(c[x+(da(c[(c[v>>2]|0)+120>>2]|0,A)|0)>>2]|0)|0;RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}E=rCf(0,B,C,D,g)|0;if((E|0)<=-1)break;D=uCf(c[u>>2]|0,E)|0;RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}E=sCf(0,D,h)|0;D=E|y;E=H|z;A=A+1|0;if((A|0)>=(c[s>>2]|0)){F=D;G=E;break a}else{y=D;z=E}}RI(2965048)|0;z=qL(2965048)|0;Rbg(z,c[885522]|0);Auh(z)}else{F=0;G=0}while(0);RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=vCf(0,e,F,G)|0;i=d;return w|0}switch(h|0){case 7:{if(ctf(0,r,l)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=yCf(0,e,b[l>>1]|0)|0;i=d;return w|0}break}case 11:{if(fqf(0,r,p)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}l=p;w=CCf(0,e,c[l>>2]|0,c[l+4>>2]|0)|0;i=d;return w|0}break}case 5:{if(ysf(0,r,j)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=wCf(0,e,a[j>>0]|0)|0;i=d;return w|0}break}case 9:{if(qpf(0,r,n)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=ACf(0,e,c[n>>2]|0)|0;i=d;return w|0}break}case 8:{if(Etf(0,r,m)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=zCf(0,e,b[m>>1]|0)|0;i=d;return w|0}break}case 12:{if(rrf(0,r,q)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}m=q;w=vCf(0,e,c[m>>2]|0,c[m+4>>2]|0)|0;i=d;return w|0}break}case 6:{if(Wrf(0,r,k)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=xCf(0,e,a[k>>0]|0)|0;i=d;return w|0}break}case 10:{if(Kqf(0,r,o)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}w=BCf(0,e,c[o>>2]|0)|0;i=d;return w|0}break}default:{}}if(a[2540708]|0){I=c[885524]|0;J=_vf(0,I,r)|0;RI(2965048)|0;K=qL(2965048)|0;Rbg(K,J);Auh(K)}Buh(2540560);I=c[885524]|0;J=_vf(0,I,r)|0;RI(2965048)|0;K=qL(2965048)|0;Rbg(K,J);Auh(K);return 0}function uCf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;Sfh();if((LDf(a)|0)!=1){e=c[886026]|0;RI(2965048)|0;f=qL(2965048)|0;Rbg(f,e);Auh(f)}if((xDf(a,0)|0)<=(b|0)?(WDf(a,0)|0)>=(b|0):0){f=hDf(a,b-(xDf(a,0)|0)|0)|0;i=d;return f|0}f=c[886028]|0;RI(3084024)|0;d=qL(3084024)|0;isg(d,f);Auh(d);return 0}function vCf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+16|0;g=b;h=g;c[h>>2]=e;c[h+4>>2]=f;RI(2554736)|0;f=pL(2554736,g)|0;RI(2610848)|0;if(a[2610996]|0){j=pCf(0,d,f)|0;i=b;return j|0}RI(2610848)|0;Buh(2610848);j=pCf(0,d,f)|0;i=b;return j|0}function wCf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=i;i=i+16|0;e=b;a[e>>0]=d;RI(2560032)|0;d=pL(2560032,e)|0;RI(2610848)|0;if(a[2610996]|0){f=pCf(0,c,d)|0;i=b;return f|0}RI(2610848)|0;Buh(2610848);f=pCf(0,c,d)|0;i=b;return f|0}function xCf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=i;i=i+16|0;e=b;a[e>>0]=d;RI(2557392)|0;d=pL(2557392,e)|0;RI(2610848)|0;if(a[2610996]|0){f=pCf(0,c,d)|0;i=b;return f|0}RI(2610848)|0;Buh(2610848);f=pCf(0,c,d)|0;i=b;return f|0}function yCf(c,d,e){c=c|0;d=d|0;e=e|0;var f=0,g=0;c=i;i=i+16|0;f=c;b[f>>1]=e;RI(2562664)|0;e=pL(2562664,f)|0;RI(2610848)|0;if(a[2610996]|0){g=pCf(0,d,e)|0;i=c;return g|0}RI(2610848)|0;Buh(2610848);g=pCf(0,d,e)|0;i=c;return g|0}function zCf(c,d,e){c=c|0;d=d|0;e=e|0;var f=0,g=0;c=i;i=i+16|0;f=c;b[f>>1]=e;RI(2565248)|0;e=pL(2565248,f)|0;RI(2610848)|0;if(a[2610996]|0){g=pCf(0,d,e)|0;i=c;return g|0}RI(2610848)|0;Buh(2610848);g=pCf(0,d,e)|0;i=c;return g|0}function ACf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+16|0;f=b;c[f>>2]=e;RI(2540224)|0;e=pL(2540224,f)|0;RI(2610848)|0;if(a[2610996]|0){g=pCf(0,d,e)|0;i=b;return g|0}RI(2610848)|0;Buh(2610848);g=pCf(0,d,e)|0;i=b;return g|0}function BCf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+16|0;f=b;c[f>>2]=e;RI(2551640)|0;e=pL(2551640,f)|0;RI(2610848)|0;if(a[2610996]|0){g=pCf(0,d,e)|0;i=b;return g|0}RI(2610848)|0;Buh(2610848);g=pCf(0,d,e)|0;i=b;return g|0}function CCf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+16|0;g=b;h=g;c[h>>2]=e;c[h+4>>2]=f;RI(2548816)|0;f=pL(2548816,g)|0;RI(2610848)|0;if(a[2610996]|0){j=pCf(0,d,f)|0;i=b;return j|0}RI(2610848)|0;Buh(2610848);j=pCf(0,d,f)|0;i=b;return j|0}function DCf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[652820]|0;if(!e){f=MK(2611288)|0;c[652820]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function ECf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;wfh();if(!d){f=1;i=e;return f|0}g=Xnf(b)|0;if((Xnf(d)|0)==(g|0)){f=DCf(b,d)|0;i=e;return f|0}f=Xnf(d)|0;if(!(a[2540708]|0))Buh(2540560);d=awf(0,c[885590]|0,f,g)|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,d);Auh(g);return 0}function FCf(a){a=a|0;var b=0,d=0;b=i;xfh();d=GCf(a,c[885640]|0)|0;i=b;return d|0}function GCf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;zfh();if(!(a[2540708]|0))Buh(2540560);f=(d|0)!=0&((gpf(0,d,c[c[635163]>>2]|0)|0)^1);g=f?d:c[885648]|0;d=Xnf(b)|0;f=kCf(b)|0;RI(2610848)|0;if(a[2610996]|0){h=ICf(0,d,f,g)|0;i=e;return h|0}RI(2610848)|0;Buh(2610848);h=ICf(0,d,f,g)|0;i=e;return h|0}function HCf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;yfh();e=Xuh(2611336,a,c[885644]|0,b)|0;i=d;return e|0}function ICf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+32|0;g=b+24|0;h=b+8|0;j=b;k=b+20|0;l=b+16|0;m=h;c[m>>2]=0;c[m+4>>2]=0;m=j;c[m>>2]=0;c[m+4>>2]=0;Dfh();if(!d){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[885746]|0);Auh(m)}if(!e){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[885748]|0);Auh(m)}if(!f){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[885750]|0);Auh(m)}if(!(Gqh(2611112,d)|0)){RI(2965048)|0;m=qL(2965048)|0;Rag(m,c[885752]|0,c[885754]|0);Auh(m)}m=Xnf(e)|0;RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}n=iCf(0,d)|0;if(Gqh(2611112,m)|0){if((m|0)!=(d|0)){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}o=eKf(0)|0;RI(1086352)|0;p=Huh(1086352,2)|0;q=Fqh(2537592,m)|0;Qqh(p,q);r=p+16|0;c[r>>2]=q;q=Fqh(2537592,d)|0;Qqh(p,q);c[r+(c[(c[p>>2]|0)+120>>2]|0)>>2]=q;if(a[2540708]|0){s=c[885756]|0;t=$vf(0,o,s,p)|0;RI(2965048)|0;u=qL(2965048)|0;Rbg(u,t);Auh(u)}Buh(2540560);s=c[885756]|0;t=$vf(0,o,s,p)|0;RI(2965048)|0;u=qL(2965048)|0;Rbg(u,t);Auh(u)}}else if((m|0)!=(n|0)){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}u=eKf(0)|0;RI(1086352)|0;t=Huh(1086352,2)|0;p=Fqh(2537592,m)|0;Qqh(t,p);m=t+16|0;c[m>>2]=p;p=Fqh(2537592,n)|0;Qqh(t,p);c[m+(c[(c[t>>2]|0)+120>>2]|0)>>2]=p;if(a[2540708]|0){v=c[885758]|0;w=$vf(0,u,v,t)|0;RI(2965048)|0;x=qL(2965048)|0;Rbg(x,w);Auh(x)}Buh(2540560);v=c[885758]|0;w=$vf(0,u,v,t)|0;RI(2965048)|0;x=qL(2965048)|0;Rbg(x,w);Auh(x)}if((c[f+8>>2]|0)!=1){RI(3079480)|0;x=qL(3079480)|0;Hrg(x,c[885760]|0);Auh(x)}x=Wof(f,0)|0;if(x<<16>>16==103|x<<16>>16==71){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[k>>2]=3441024;c[g+0>>2]=c[k+0>>2];if(!(Cuh(2538432,d,npf(0,g)|0,0)|0)){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}k=oCf(0,d,e)|0;if(k){y=k;i=b;return y|0}y=Fqh(2536904,e)|0;i=b;return y|0}}else if(!(x<<16>>16==70|x<<16>>16==102)){if(!(a[2540708]|0))Buh(2540560);if(x<<16>>16==120){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}y=NCf(0,d,e,0)|0;i=b;return y|0}else if(x<<16>>16==100|x<<16>>16==68){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[l>>2]=3440112;c[g+0>>2]=c[l+0>>2];l=(n|0)==(npf(0,g)|0);RI(3034288)|0;g=(a[3034436]|0)!=0;if(l){if(!g){RI(3034288)|0;Buh(3034288)}l=Img(0,e)|0;n=h;c[n>>2]=l;c[n+4>>2]=H;y=srf(h)|0;i=b;return y|0}else{if(!g){RI(3034288)|0;Buh(3034288)}g=rlg(0,e)|0;h=j;c[h>>2]=g;c[h+4>>2]=H;y=hqf(j)|0;i=b;return y|0}}else if(x<<16>>16==88){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}y=NCf(0,d,e,1)|0;i=b;return y|0}else{RI(3079480)|0;x=qL(3079480)|0;Hrg(x,c[885762]|0);Auh(x)}}RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}y=OCf(0,d,e)|0;i=b;return y|0}function JCf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;Afh();if(!(a[2540708]|0))Buh(2540560);f=(d|0)!=0&((gpf(0,d,c[c[635163]>>2]|0)|0)^1);g=f?d:c[885652]|0;d=Xnf(b)|0;f=kCf(b)|0;RI(2610848)|0;if(a[2610996]|0){h=ICf(0,d,f,g)|0;i=e;return h|0}RI(2610848)|0;Buh(2610848);h=ICf(0,d,f,g)|0;i=e;return h|0}function KCf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=fof(0,a,b)|0;i=c;return d|0}function LCf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[652864]|0;if(!d){e=MK(2611464)|0;c[652864]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function MCf(a){a=a|0;var b=0,c=0;b=i;c=LCf(a)|0;i=b;return c|0}function NCf(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;h=d+29|0;j=d+28|0;k=d+24|0;l=d+26|0;m=d+20|0;n=d+16|0;o=d;p=d+8|0;a[h>>0]=0;a[j>>0]=0;b[k>>1]=0;b[l>>1]=0;c[m>>2]=0;c[n>>2]=0;q=o;c[q>>2]=0;c[q+4>>2]=0;q=p;c[q>>2]=0;c[q+4>>2]=0;Bfh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}switch(jCf(0,e)|0){case 10:{RI(2551640)|0;c[n>>2]=c[(Euh(f,2551640)|0)>>2];r=Pqf(n,g?c[885676]|0:c[885678]|0,0)|0;i=d;return r|0}case 8:{RI(2565248)|0;b[l>>1]=b[(Euh(f,2565248)|0)>>1]|0;r=Jtf(l,g?c[885668]|0:c[885670]|0,0)|0;i=d;return r|0}case 5:{RI(2560032)|0;a[h>>0]=a[(Euh(f,2560032)|0)>>0]|0;r=Csf(h,g?c[885656]|0:c[885658]|0,0)|0;i=d;return r|0}case 9:{RI(2540224)|0;c[m>>2]=c[(Euh(f,2540224)|0)>>2];r=vpf(m,g?c[885672]|0:c[885674]|0,0)|0;i=d;return r|0}case 12:{RI(2554736)|0;m=Euh(f,2554736)|0;h=c[m+4>>2]|0;l=p;c[l>>2]=c[m>>2];c[l+4>>2]=h;r=vrf(p,g?c[885684]|0:c[885686]|0,0)|0;i=d;return r|0}case 6:{RI(2557392)|0;a[j>>0]=a[(Euh(f,2557392)|0)>>0]|0;r=_rf(j,g?c[885660]|0:c[885662]|0,0)|0;i=d;return r|0}case 11:{RI(2548816)|0;j=Euh(f,2548816)|0;p=c[j+4>>2]|0;h=o;c[h>>2]=c[j>>2];c[h+4>>2]=p;r=kqf(o,g?c[885680]|0:c[885682]|0,0)|0;i=d;return r|0}case 7:{RI(2562664)|0;b[k>>1]=b[(Euh(f,2562664)|0)>>1]|0;r=gtf(k,g?c[885664]|0:c[885666]|0,0)|0;i=d;return r|0}default:{RI(2589312)|0;r=qL(2589312)|0;d=c[885688]|0;c[r+40>>2]=-2146233088;c[r+16>>2]=d;Auh(r)}}return 0}function OCf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;d=i;i=i+16|0;g=d;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;Cfh();if(!(a[2540708]|0))Buh(2540560);h=c[c[635163]>>2]|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Buh(3074072)}lrg(0,e,g);j=Fqh(2536904,f)|0;if(gpf(0,j,c[885726]|0)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Buh(2610848)}k=oCf(0,e,f)|0;l=(k|0)==0?j:k;i=d;return l|0}k=g+4|0;e=uCf(c[k>>2]|0,0)|0;RI(2610848)|0;switch(Aqh(2611224,Juh(e,2610848)|0)|0){case 8:{RI(2565248)|0;e=b[(Euh(f,2565248)|0)>>1]|0;m=PCf(c[k>>2]|0)|0;a:do if((m|0)>0){n=g+8|0;o=h;p=e;q=m;while(1){r=q;while(1){r=r+-1|0;s=uCf(c[k>>2]|0,r)|0;RI(2565248)|0;t=b[(Euh(s,2565248)|0)>>1]|0;if(t<<16>>16!=0?(t&p)<<16>>16==t<<16>>16:0){u=t;v=r;break}if((r|0)<=0){w=o;x=p;break a}}r=p&65535;t=u&65535;s=c[n>>2]|0;if(!(a[2540708]|0))Buh(2540560);y=gpf(0,o,c[c[635163]>>2]|0)|0;z=c[s+16+(da(c[(c[s>>2]|0)+120>>2]|0,v)|0)>>2]|0;if(y){if(!(a[2540708]|0))Buh(2540560);A=c[635163]|0}else A=3542944;y=c[A>>2]|0;if(!(a[2540708]|0))Buh(2540560);s=iwf(0,z,y,o)|0;y=r-t&65535;if((v|0)>0){o=s;p=y;q=v}else{w=s;x=y;break}}}else{w=h;x=e}while(0);if(!(x<<16>>16))B=w;else{l=j;i=d;return l|0}break}case 6:{RI(2557392)|0;w=a[(Euh(f,2557392)|0)>>0]|0;x=PCf(c[k>>2]|0)|0;b:do if((x|0)>0){e=g+8|0;v=h;A=w;u=x;while(1){m=u;while(1){m=m+-1|0;q=uCf(c[k>>2]|0,m)|0;RI(2557392)|0;p=a[(Euh(q,2557392)|0)>>0]|0;if(p<<24>>24!=0?(p&A)<<24>>24==p<<24>>24:0){C=p;D=m;break}if((m|0)<=0){E=v;F=A;break b}}m=A&255;p=C&255;q=c[e>>2]|0;if(!(a[2540708]|0))Buh(2540560);o=gpf(0,v,c[c[635163]>>2]|0)|0;n=c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,D)|0)>>2]|0;if(o){if(!(a[2540708]|0))Buh(2540560);G=c[635163]|0}else G=3542920;o=c[G>>2]|0;if(!(a[2540708]|0))Buh(2540560);q=iwf(0,n,o,v)|0;o=m-p&255;if((D|0)>0){v=q;A=o;u=D}else{E=q;F=o;break}}}else{E=h;F=w}while(0);if(!(F<<24>>24))B=E;else{l=j;i=d;return l|0}break}case 10:{RI(2551640)|0;E=c[(Euh(f,2551640)|0)>>2]|0;F=g+8|0;w=h;D=E;E=PCf(c[k>>2]|0)|0;c:while(1){G=E;while(1){C=G+-1|0;if((G|0)<=0){I=w;J=D;break c}x=uCf(c[k>>2]|0,C)|0;RI(2551640)|0;u=c[(Euh(x,2551640)|0)>>2]|0;if((u|0)!=0&(u&D|0)==(u|0)){K=u;L=C;break}else G=C}G=c[F>>2]|0;if(!(a[2540708]|0))Buh(2540560);C=gpf(0,w,c[c[635163]>>2]|0)|0;u=c[G+16+(da(c[(c[G>>2]|0)+120>>2]|0,L)|0)>>2]|0;if(C){if(!(a[2540708]|0))Buh(2540560);M=c[635163]|0}else M=3542952;C=c[M>>2]|0;if(!(a[2540708]|0))Buh(2540560);w=iwf(0,u,C,w)|0;D=D-K|0;E=L}if(!J)B=I;else{l=j;i=d;return l|0}break}case 7:{RI(2562664)|0;I=b[(Euh(f,2562664)|0)>>1]|0;J=PCf(c[k>>2]|0)|0;d:do if((J|0)>0){L=g+8|0;E=h;K=J;D=I;while(1){w=K;while(1){w=w+-1|0;M=uCf(c[k>>2]|0,w)|0;RI(2562664)|0;F=b[(Euh(M,2562664)|0)>>1]|0;if(F<<16>>16!=0?(F&D)<<16>>16==F<<16>>16:0){N=F;O=w;break}if((w|0)<=0){P=E;Q=D;break d}}w=D&65535;F=N&65535;M=c[L>>2]|0;if(!(a[2540708]|0))Buh(2540560);C=gpf(0,E,c[c[635163]>>2]|0)|0;u=c[M+16+(da(c[(c[M>>2]|0)+120>>2]|0,O)|0)>>2]|0;if(C){if(!(a[2540708]|0))Buh(2540560);R=c[635163]|0}else R=3542928;C=c[R>>2]|0;if(!(a[2540708]|0))Buh(2540560);M=iwf(0,u,C,E)|0;C=w-F&65535;if((O|0)>0){E=M;K=O;D=C}else{P=M;Q=C;break}}}else{P=h;Q=I}while(0);if(!(Q<<16>>16))B=P;else{l=j;i=d;return l|0}break}case 5:{RI(2560032)|0;P=a[(Euh(f,2560032)|0)>>0]|0;Q=PCf(c[k>>2]|0)|0;e:do if((Q|0)>0){I=g+8|0;O=h;R=P;N=Q;while(1){J=N;while(1){J=J+-1|0;D=uCf(c[k>>2]|0,J)|0;RI(2560032)|0;K=a[(Euh(D,2560032)|0)>>0]|0;if(K<<24>>24!=0?(K&R)<<24>>24==K<<24>>24:0){S=K;T=J;break}if((J|0)<=0){U=O;V=R;break e}}J=S&255;K=R&255;D=c[I>>2]|0;if(!(a[2540708]|0))Buh(2540560);E=gpf(0,O,c[c[635163]>>2]|0)|0;L=c[D+16+(da(c[(c[D>>2]|0)+120>>2]|0,T)|0)>>2]|0;if(E){if(!(a[2540708]|0))Buh(2540560);W=c[635163]|0}else W=3542912;E=c[W>>2]|0;if(!(a[2540708]|0))Buh(2540560);D=iwf(0,L,E,O)|0;E=K-J&255;if((T|0)>0){O=D;R=E;N=T}else{U=D;V=E;break}}}else{U=h;V=P}while(0);if(!(V<<24>>24))B=U;else{l=j;i=d;return l|0}break}case 9:{RI(2540224)|0;U=c[(Euh(f,2540224)|0)>>2]|0;V=g+8|0;P=h;T=U;U=PCf(c[k>>2]|0)|0;f:while(1){W=U;while(1){S=W+-1|0;if((W|0)<=0){X=P;Y=T;break f}Q=uCf(c[k>>2]|0,S)|0;RI(2540224)|0;N=c[(Euh(Q,2540224)|0)>>2]|0;if((N|0)!=0&(N&T|0)==(N|0)){Z=N;_=S;break}else W=S}W=c[V>>2]|0;if(!(a[2540708]|0))Buh(2540560);S=gpf(0,P,c[c[635163]>>2]|0)|0;N=c[W+16+(da(c[(c[W>>2]|0)+120>>2]|0,_)|0)>>2]|0;if(S){if(!(a[2540708]|0))Buh(2540560);$=c[635163]|0}else $=3542936;S=c[$>>2]|0;if(!(a[2540708]|0))Buh(2540560);P=iwf(0,N,S,P)|0;T=T-Z|0;U=_}if(!Y)B=X;else{l=j;i=d;return l|0}break}case 11:{RI(2548816)|0;X=Euh(f,2548816)|0;Y=c[X>>2]|0;_=c[X+4>>2]|0;X=g+8|0;U=Y;Y=_;_=h;Z=PCf(c[k>>2]|0)|0;g:while(1){T=Z;while(1){P=T+-1|0;if((T|0)<=0){aa=U;ba=Y;ca=_;break g}$=uCf(c[k>>2]|0,P)|0;RI(2548816)|0;V=Euh($,2548816)|0;$=c[V>>2]|0;S=c[V+4>>2]|0;if((($|0)!=0|(S|0)!=0)&(($&U|0)==($|0)&(S&Y|0)==(S|0))){ea=$;fa=S;ga=P;break}else T=P}T=c[X>>2]|0;if(!(a[2540708]|0))Buh(2540560);P=gpf(0,_,c[c[635163]>>2]|0)|0;S=c[T+16+(da(c[(c[T>>2]|0)+120>>2]|0,ga)|0)>>2]|0;if(P){if(!(a[2540708]|0))Buh(2540560);ha=c[635163]|0}else ha=3542960;P=c[ha>>2]|0;if(!(a[2540708]|0))Buh(2540560);T=iwf(0,S,P,_)|0;P=ZEi(U|0,Y|0,ea|0,fa|0)|0;U=P;Y=H;_=T;Z=ga}if((aa|0)==0&(ba|0)==0)B=ca;else{l=j;i=d;return l|0}break}case 12:{RI(2554736)|0;ca=Euh(f,2554736)|0;f=c[ca>>2]|0;ba=c[ca+4>>2]|0;ca=g+8|0;g=f;f=ba;ba=h;aa=PCf(c[k>>2]|0)|0;h:while(1){ga=aa;while(1){Z=ga+-1|0;if((ga|0)<=0){ia=g;ja=f;ka=ba;break h}_=uCf(c[k>>2]|0,Z)|0;RI(2554736)|0;Y=Euh(_,2554736)|0;_=c[Y>>2]|0;U=c[Y+4>>2]|0;if(((_|0)!=0|(U|0)!=0)&((_&g|0)==(_|0)&(U&f|0)==(U|0))){la=_;ma=U;na=Z;break}else ga=Z}ga=c[ca>>2]|0;if(!(a[2540708]|0))Buh(2540560);Z=gpf(0,ba,c[c[635163]>>2]|0)|0;U=c[ga+16+(da(c[(c[ga>>2]|0)+120>>2]|0,na)|0)>>2]|0;if(Z){if(!(a[2540708]|0))Buh(2540560);oa=c[635163]|0}else oa=3542968;Z=c[oa>>2]|0;if(!(a[2540708]|0))Buh(2540560);ga=iwf(0,U,Z,ba)|0;Z=ZEi(g|0,f|0,la|0,ma|0)|0;g=Z;f=H;ba=ga;aa=na}if((ia|0)==0&(ja|0)==0)B=ka;else{l=j;i=d;return l|0}break}default:B=h}if(!(a[2540708]|0))Buh(2540560);h=gpf(0,B,c[c[635163]>>2]|0)|0;l=h?j:B;i=d;return l|0}function PCf(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=JDf(a,0)|0;if((LDf(a)|0)>1){d=c;e=1}else{f=c;i=b;return f|0}while(1){c=da(JDf(a,e)|0,d)|0;e=e+1|0;if((e|0)>=(LDf(a)|0)){f=c;break}else d=c}i=b;return f|0}function QCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function RCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function SCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function TCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function UCf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[a+8>>2]=sM(2615488)|0;c[c[d>>2]>>2]=a;i=b;return}function VCf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function WCf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[a+8>>2]=sM(2615488)|0;c[c[d>>2]>>2]=a;i=b;return}function XCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function YCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function ZCf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function _Cf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function $Cf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function aDf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function bDf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function cDf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function dDf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function eDf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function fDf(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=b;c[a+12>>2]=-1;c[a+16>>2]=PCf(b)|0;i=d;return}function gDf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Lgh();d=c[a+12>>2]|0;if((d|0)<=-1){e=c[887054]|0;RI(3084976)|0;f=qL(3084976)|0;osg(f,e);Auh(f)}if((d|0)<(c[a+16>>2]|0)){f=hDf(c[a+8>>2]|0,d)|0;i=b;return f|0}else{f=c[887056]|0;RI(3084976)|0;b=qL(3084976)|0;osg(b,f);Auh(b)}return 0}function hDf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[654782]|0;if(!e){f=MK(2619136)|0;c[654782]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function iDf(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+12|0;d=c[b>>2]|0;e=c[a+16>>2]|0;if((d|0)<(e|0)){a=d+1|0;c[b>>2]=a;f=a}else f=d;return (f|0)<(e|0)|0}function jDf(a){a=a|0;return}function kDf(a){a=a|0;return}function lDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function mDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)mDf(f,b,d);co[c[a+8>>2]&2047](c[a+16>>2]|0,b,d);i=e;return}function nDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[(c[a+20>>2]|0)+4>>2]&4095](b,d);i=e;return}function oDf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function pDf(a,b){a=a|0;b=b|0;return}function qDf(a){a=a|0;return}function rDf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Efh();if((PCf(a)|0)<=(b|0)){RI(3084024)|0;e=qL(3084024)|0;isg(e,c[885862]|0);Auh(e)}if((LDf(a)|0)<2){e=hDf(a,b)|0;i=d;return e|0}else{e=c[885864]|0;RI(2965048)|0;d=qL(2965048)|0;Rbg(d,e);Auh(d)}return 0}function sDf(a){a=a|0;var b=0,c=0;b=i;c=LDf(a)|0;i=b;return c|0}function tDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Ffh();if((PCf(a)|0)<=(b|0)){RI(3084024)|0;f=qL(3084024)|0;isg(f,c[885890]|0);Auh(f)}if((LDf(a)|0)<2){uDf(a,d,b);i=e;return}else{e=c[885892]|0;RI(2965048)|0;b=qL(2965048)|0;Rbg(b,e);Auh(b)}}function uDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[654796]|0;if(!f){g=MK(2619192)|0;c[654796]=g;h=g}else h=f;co[h&2047](a,b,d);i=e;return}function vDf(a,b){a=a|0;b=b|0;RI(3100472)|0;b=qL(3100472)|0;oug(b);Auh(b);return 0}function wDf(a){a=a|0;var b=0,c=0;b=i;c=xDf(a,0)|0;yDf(0,a,c,PCf(a)|0);i=b;return}function xDf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[654740]|0;if(!e){f=MK(2618968)|0;c[654740]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function yDf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;jgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886630]|0);Auh(f)}if((e|0)<=-1){RI(3084024)|0;f=qL(3084024)|0;isg(f,c[886632]|0);Auh(f)}f=xDf(b,0)|0;if((f|0)>(d|0)){RI(3084024)|0;g=qL(3084024)|0;isg(g,c[886634]|0);Auh(g)}g=d-f|0;if((g|0)>((PCf(b)|0)-e|0)){RI(3084024)|0;f=qL(3084024)|0;isg(f,c[886636]|0);Auh(f)}else{tEf(0,b,g,e);i=a;return}}function zDf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;Gfh();if((LDf(a)|0)>=2){e=c[885896]|0;RI(3115536)|0;f=qL(3115536)|0;zwg(f,e);Auh(f)}f=PCf(a)|0;if((f|0)>0)g=0;else{h=0;i=d;return h|0}while(1){if(Tnf(0,hDf(a,g)|0,b)|0){h=1;j=6;break}g=g+1|0;if((g|0)>=(f|0)){h=0;j=6;break}}if((j|0)==6){i=d;return h|0}return 0}function ADf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;Hfh();if((LDf(a)|0)>=2){e=c[885900]|0;RI(3115536)|0;f=qL(3115536)|0;zwg(f,e);Auh(f)}f=PCf(a)|0;a:do if((f|0)>0){e=0;while(1){if(Tnf(0,hDf(a,e)|0,b)|0){g=e;break}e=e+1|0;if((e|0)>=(f|0))break a}h=(xDf(a,0)|0)+g|0;i=d;return h|0}while(0);h=(xDf(a,0)|0)+-1|0;i=d;return h|0}function BDf(a,b,c){a=a|0;b=b|0;c=c|0;RI(3100472)|0;c=qL(3100472)|0;oug(c);Auh(c)}function CDf(a,b){a=a|0;b=b|0;RI(3100472)|0;b=qL(3100472)|0;oug(b);Auh(b)}function DDf(a,b){a=a|0;b=b|0;RI(3100472)|0;b=qL(3100472)|0;oug(b);Auh(b)}function EDf(a){a=a|0;var b=0,c=0;b=i;c=PCf(a)|0;i=b;return c|0}function FDf(a){a=a|0;var b=0,c=0;b=i;c=PCf(a)|0;i=b;return c|0}function GDf(a){a=a|0;return 1}function HDf(a){a=a|0;Ifh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[885904]|0);Auh(a)}function IDf(a,b){a=a|0;b=b|0;Ofh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[886010]|0);Auh(b)}function JDf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[654728]|0;if(!e){f=MK(2618920)|0;c[654728]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function KDf(a){a=a|0;var b=0,c=0;b=i;c=PCf(a)|0;H=((c|0)<0)<<31>>31;i=b;return c|0}function LDf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[654720]|0;if(!d){e=MK(2618888)|0;c[654720]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function MDf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=JDf(a,b)|0;H=((d|0)<0)<<31>>31;i=c;return d|0}function NDf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[654754]|0;if(!e){f=MK(2619024)|0;c[654754]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function ODf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[654766]|0;if(!f){g=MK(2619072)|0;c[654766]=g;h=g}else h=f;co[h&2047](a,b,d);i=e;return}function PDf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;a=i;h=c[654812]|0;if(!h){j=MK(2619256)|0;c[654812]=j;k=j}else k=h;h=Bn[k&255](b,d,e,f,g)|0;i=a;return h|0}function QDf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[654838]|0;if(!f){g=MK(2619360)|0;c[654838]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function RDf(a){a=a|0;return 0}function SDf(a){a=a|0;return a|0}function TDf(a){a=a|0;return 1}function UDf(a){a=a|0;return 0}function VDf(a){a=a|0;var b=0,c=0;b=i;RI(2616504)|0;c=qL(2616504)|0;fDf(c,a);i=b;return c|0}function WDf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;d=xDf(a,b)|0;e=d+-1+(JDf(a,b)|0)|0;i=c;return e|0}function XDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(1101728)|0;f=Huh(1101728,2)|0;g=f+16|0;c[g>>2]=b;c[g+(c[(c[f>>2]|0)+120>>2]|0)>>2]=d;d=NDf(a,f)|0;i=e;return d|0}function YDf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;RI(1101728)|0;g=Huh(1101728,3)|0;h=g+16|0;c[h>>2]=b;c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=d;c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=e;e=NDf(a,g)|0;i=f;return e|0}function ZDf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Tfh();if(d>>>0<0|(d|0)==0&b>>>0<2147483648){d=uCf(a,b)|0;i=e;return d|0}else{d=c[886084]|0;RI(2964880)|0;e=qL(2964880)|0;Qag(e,c[886082]|0,d);Auh(e)}return 0}function _Df(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;Ufh();if(!(d>>>0<0|(d|0)==0&b>>>0<2147483648)){d=c[886112]|0;RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[886110]|0,d);Auh(h)}if(f>>>0<0|(f|0)==0&e>>>0<2147483648){f=XDf(a,b,e)|0;i=g;return f|0}else{f=c[886116]|0;RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[886114]|0,f);Auh(g)}return 0}function $Df(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;Vfh();if(!(d>>>0<0|(d|0)==0&b>>>0<2147483648)){d=c[886130]|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886128]|0,d);Auh(k)}if(!(f>>>0<0|(f|0)==0&e>>>0<2147483648)){f=c[886134]|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886132]|0,f);Auh(k)}if(h>>>0<0|(h|0)==0&g>>>0<2147483648){h=YDf(a,b,e,g)|0;i=j;return h|0}else{h=c[886138]|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886136]|0,h);Auh(j)}return 0}function aEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Wfh();if(e>>>0<0|(e|0)==0&d>>>0<2147483648){bEf(a,b,d);i=f;return}else{f=c[886148]|0;RI(2964880)|0;d=qL(2964880)|0;Qag(d,c[886146]|0,f);Auh(d)}}function bEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Zfh();if((LDf(a)|0)!=1){f=c[886176]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Auh(g)}if((xDf(a,0)|0)<=(d|0)?(WDf(a,0)|0)>=(d|0):0){uDf(a,b,d-(xDf(a,0)|0)|0);i=e;return}e=c[886178]|0;RI(3084024)|0;a=qL(3084024)|0;isg(a,e);Auh(a)}function cEf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;Xfh();if(!(e>>>0<0|(e|0)==0&d>>>0<2147483648)){e=c[886154]|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886152]|0,e);Auh(j)}if(g>>>0<0|(g|0)==0&f>>>0<2147483648){RI(1101728)|0;g=Huh(1101728,2)|0;j=g+16|0;c[j>>2]=d;c[j+(c[(c[g>>2]|0)+120>>2]|0)>>2]=f;ODf(a,b,g);i=h;return}else{h=c[886158]|0;RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[886156]|0,h);Auh(g)}}function dEf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;Yfh();if(!(e>>>0<0|(e|0)==0&d>>>0<2147483648)){e=c[886164]|0;RI(2964880)|0;l=qL(2964880)|0;Qag(l,c[886162]|0,e);Auh(l)}if(!(g>>>0<0|(g|0)==0&f>>>0<2147483648)){g=c[886168]|0;RI(2964880)|0;l=qL(2964880)|0;Qag(l,c[886166]|0,g);Auh(l)}if(j>>>0<0|(j|0)==0&h>>>0<2147483648){RI(1101728)|0;j=Huh(1101728,3)|0;l=j+16|0;c[l>>2]=d;c[l+(c[(c[j>>2]|0)+120>>2]|0)>>2]=f;c[l+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=h;ODf(a,b,j);i=k;return}else{k=c[886172]|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886170]|0,k);Auh(j)}}function eEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;RI(1101728)|0;g=Huh(1101728,2)|0;h=g+16|0;c[h>>2]=d;c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=e;ODf(a,b,g);i=f;return}function fEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;RI(1101728)|0;h=Huh(1101728,3)|0;j=h+16|0;c[j>>2]=d;c[j+(c[(c[h>>2]|0)+120>>2]|0)>>2]=e;c[j+(c[(c[h>>2]|0)+120>>2]<<1)>>2]=f;ODf(a,b,h);i=g;return}function gEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;RI(1101728)|0;e=Huh(1101728,1)|0;c[e+16>>2]=d;d=hEf(0,b,e)|0;i=a;return d|0}function hEf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;i=i+16|0;f=b+4|0;g=b;_fh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[886214]|0);Auh(h)}if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[886216]|0);Auh(h)}if((c[e+12>>2]|0)>=256){RI(3072960)|0;h=qL(3072960)|0;ayg(h);Auh(h)}h=suh(2619440,d)|0;if(!(kEf(h)|0)){RI(2965048)|0;d=qL(2965048)|0;Rag(d,c[886218]|0,c[886220]|0);Auh(d)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[g>>2]=3431552;c[f+0>>2]=c[g+0>>2];if(Yuh(2619496,h,npf(0,f)|0)|0){RI(3100472)|0;f=qL(3100472)|0;pug(f,c[886222]|0);Auh(f)}if(Gqh(2619552,h)|0){RI(3100472)|0;f=qL(3100472)|0;pug(f,c[886224]|0);Auh(f)}else{f=QDf(0,h,e,0)|0;i=b;return f|0}return 0}function iEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;RI(1101728)|0;f=Huh(1101728,2)|0;g=f+16|0;c[g>>2]=d;c[g+(c[(c[f>>2]|0)+120>>2]|0)>>2]=e;e=hEf(0,b,f)|0;i=a;return e|0}function jEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=i;RI(1101728)|0;g=Huh(1101728,3)|0;h=g+16|0;c[h>>2]=d;c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=e;c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=f;f=hEf(0,b,g)|0;i=a;return f|0}function kEf(a){a=a|0;var b=0,d=0;b=i;d=c[a+8>>2]|0;RI(2604248)|0;i=b;return (d|0)!=(c[c[651085]>>2]|0)|0}function lEf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;g=b+4|0;h=b;$fh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886296]|0);Auh(j)}if(!e){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886298]|0);Auh(j)}if(!f){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886300]|0);Auh(j)}j=suh(2619440,d)|0;if(!(kEf(j)|0)){RI(2965048)|0;d=qL(2965048)|0;Rag(d,c[886302]|0,c[886304]|0);Auh(d)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[h>>2]=3431552;c[g+0>>2]=c[h+0>>2];if(Yuh(2619496,j,npf(0,g)|0)|0){RI(3100472)|0;g=qL(3100472)|0;pug(g,c[886306]|0);Auh(g)}if(Gqh(2619552,j)|0){RI(3100472)|0;g=qL(3100472)|0;pug(g,c[886308]|0);Auh(g)}g=c[e+12>>2]|0;if((g|0)<=0){h=c[886310]|0;RI(2965048)|0;d=qL(2965048)|0;Rbg(d,h);Auh(d)}if((g|0)!=(c[f+12>>2]|0)){d=c[886312]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,d);Auh(h)}h=e+16|0;d=c[(c[e>>2]|0)+120>>2]|0;k=f+16|0;l=0;while(1){m=c[h+(da(d,l)|0)>>2]|0;if((m|0)<=-1){n=20;break}o=c[k+(da(c[(c[f>>2]|0)+120>>2]|0,l)|0)>>2]|0;p=_Ei(o|0,((o|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=H;l=l+1|0;if(!((m|0)<0|(m|0)==0&p>>>0<2147483648)){n=22;break}if((l|0)>=(g|0)){n=25;break}}if((n|0)==20){l=c[886316]|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886314]|0,l);Auh(k)}else if((n|0)==22){k=c[886320]|0;RI(2964880)|0;l=qL(2964880)|0;Qag(l,c[886318]|0,k);Auh(l)}else if((n|0)==25)if((g|0)<256){g=QDf(0,j,e,f)|0;i=b;return g|0}else{RI(3072960)|0;g=qL(3072960)|0;ayg(g);Auh(g)}return 0}function mEf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;agh();d=c[b+12>>2]|0;RI(1101728)|0;e=Huh(1101728,d)|0;if((d|0)<=0){i=a;return e|0}f=b+16|0;g=e+16|0;h=c[b>>2]|0;b=0;while(1){j=f+(da(c[h+120>>2]|0,b)|0)|0;k=c[j>>2]|0;l=c[j+4>>2]|0;if(!(l>>>0<0|(l|0)==0&k>>>0<2147483648)){m=3;break}c[g+(da(c[(c[e>>2]|0)+120>>2]|0,b)|0)>>2]=k;b=b+1|0;if((b|0)>=(d|0)){m=6;break}}if((m|0)==3){d=c[886402]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[886400]|0,d);Auh(b)}else if((m|0)==6){i=a;return e|0}return 0}function nEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;bgh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886430]|0);Auh(e)}else{e=hEf(0,b,mEf(0,d)|0)|0;i=a;return e|0}return 0}function oEf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;cgh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886434]|0);Auh(e)}else{e=NDf(a,mEf(0,b)|0)|0;i=d;return e|0}return 0}function pEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;dgh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886442]|0);Auh(f)}else{ODf(a,b,mEf(0,d)|0);i=e;return}}function qEf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;igh();if(!h){RI(2724056)|0;if(!(a[2724204]|0)){RI(2724056)|0;Buh(2724056)}RI(2724056)|0;j=c[c[681037]>>2]|0}else j=h;h=e+-1+f|0;a:do if((h|0)<(e|0))k=e;else{f=e;l=h;b:while(1){m=f;while(1){n=l-m|0;o=((n|0)/2|0)+m|0;p=hth(2734520,j,hDf(d,o)|0,g)|0;if(!p){q=o;break b}r=o+1|0;if((p|0)>=1){s=n;t=o;u=m;break}if((l|0)<(r|0)){k=r;break a}else m=r}if((s|0)<2){k=u;break a}else{f=u;l=t+-1|0}}i=b;return q|0}while(0);q=~k;i=b;return q|0}function rEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;ggh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[886508]|0);Auh(g)}if((LDf(b)|0)>=2){g=c[886510]|0;RI(3115536)|0;h=qL(3115536)|0;zwg(h,g);Auh(h)}if((xDf(b,0)|0)>(d|0)){h=c[886514]|0;RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[886512]|0,h);Auh(g)}if((e|0)<=-1){g=c[886518]|0;RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[886516]|0,g);Auh(h)}h=xDf(b,0)|0;if((h-e+(JDf(b,0)|0)|0)<(d|0)){h=c[886520]|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,h);Auh(g)}if(!(PCf(b)|0)){j=-1;i=a;return j|0}if((f|0)!=0?(RI(2546528)|0,(vL(f,2546528)|0)==0):0){g=c[886522]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);Auh(h)}j=qEf(0,b,d,e,f,0)|0;i=a;return j|0}function sEf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;a=i;hgh();if(!b){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[886594]|0);Auh(h)}if((LDf(b)|0)>=2){h=c[886596]|0;RI(3115536)|0;j=qL(3115536)|0;zwg(j,h);Auh(j)}if((xDf(b,0)|0)>(d|0)){j=c[886600]|0;RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[886598]|0,j);Auh(h)}if((e|0)<=-1){h=c[886604]|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886602]|0,h);Auh(j)}j=xDf(b,0)|0;if((j-e+(JDf(b,0)|0)|0)<(d|0)){j=c[886606]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,j);Auh(h)}if(!(PCf(b)|0)){k=-1;i=a;return k|0}if((g|0)==0&(f|0)!=0?(RI(2546528)|0,(vL(f,2546528)|0)==0):0){h=c[886608]|0;RI(2965048)|0;j=qL(2965048)|0;Rbg(j,h);Auh(j)}k=qEf(0,b,d,e,f,g)|0;i=a;return k|0}function tEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[654902]|0;if(!f){g=MK(2619616)|0;c[654902]=g;h=g}else h=f;co[h&2047](b,d,e);i=a;return}function uEf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[654922]|0;if(!d){e=MK(2619696)|0;c[654922]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function vEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;kgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886668]|0);Auh(f)}if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886670]|0);Auh(f)}else{f=xDf(b,0)|0;wEf(0,b,f,d,xDf(d,0)|0,e);i=a;return}}function wEf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;b=i;lgh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886688]|0);Auh(j)}if(!f){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886690]|0);Auh(j)}if((h|0)<=-1){j=c[886694]|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886692]|0,j);Auh(k)}if((e|0)<=-1){k=c[886698]|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886696]|0,k);Auh(j)}if((g|0)<=-1){j=c[886702]|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886700]|0,j);Auh(k)}if(PDf(0,d,e,f,g,h)|0){i=b;return}k=e-(xDf(d,0)|0)|0;e=g-(xDf(f,0)|0)|0;if((k|0)>((PCf(d)|0)-h|0)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[886704]|0);Auh(g)}if((e|0)>((PCf(f)|0)-h|0)){g=c[886706]|0;if(a[2540708]|0){RI(2965048)|0;l=qL(2965048)|0;m=c[635163]|0;n=c[m>>2]|0;Rag(l,g,n);Auh(l)}Buh(2540560);RI(2965048)|0;l=qL(2965048)|0;m=c[635163]|0;n=c[m>>2]|0;Rag(l,g,n);Auh(l)}l=LDf(d)|0;if((l|0)!=(LDf(f)|0)){l=c[886708]|0;RI(3115536)|0;n=qL(3115536)|0;zwg(n,l);Auh(n)}suh(2619720,Xnf(d)|0)|0;suh(2619720,Xnf(f)|0)|0;if(!((d|0)!=(f|0)|(k|0)>(e|0))){n=h;while(1){l=n+-1|0;if((n|0)<=0)break;uDf(d,hDf(d,l+k|0)|0,l+e|0);n=l}i=b;return}if((h|0)>0)o=0;else{i=b;return}do{uDf(f,hDf(d,o+k|0)|0,o+e|0);o=o+1|0}while((o|0)<(h|0));i=b;return}function xEf(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0;a=i;mgh();if(!b){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[886794]|0);Auh(l)}if(!f){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[886796]|0);Auh(l)}l=_Ei(d|0,e|0,-2147483648,0)|0;e=H;if(!(e>>>0<1|(e|0)==1&l>>>0<0)){l=c[886800]|0;RI(2964880)|0;e=qL(2964880)|0;Qag(e,c[886798]|0,l);Auh(e)}e=_Ei(g|0,h|0,-2147483648,0)|0;h=H;if(!(h>>>0<1|(h|0)==1&e>>>0<0)){e=c[886804]|0;RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[886802]|0,e);Auh(h)}if(k>>>0<0|(k|0)==0&j>>>0<2147483648){wEf(0,b,d,f,g,j);i=a;return}else{a=c[886808]|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886806]|0,a);Auh(j)}}function yEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;a=i;ngh();if(f>>>0<0|(f|0)==0&e>>>0<2147483648){vEf(0,b,d,e);i=a;return}else{a=c[886828]|0;RI(2964880)|0;e=qL(2964880)|0;Qag(e,c[886826]|0,a);Auh(e)}}function zEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;ogh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886832]|0);Auh(e)}else{e=AEf(0,b,d,0,PCf(b)|0)|0;i=a;return e|0}return 0}function AEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;qgh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[886840]|0);Auh(g)}if((LDf(b)|0)>=2){g=c[886842]|0;RI(3115536)|0;h=qL(3115536)|0;zwg(h,g);Auh(h)}if(((f|0)>=0?(xDf(b,0)|0)<=(e|0):0)?(e+-1|0)<=((WDf(b,0)|0)-f|0):0){h=f+e|0;a:do if((f|0)>0){g=e;while(1){if(Tnf(0,hDf(b,g)|0,d)|0){j=g;break}g=g+1|0;if((g|0)>=(h|0))break a}i=a;return j|0}while(0);j=(xDf(b,0)|0)+-1|0;i=a;return j|0}RI(2964880)|0;j=qL(2964880)|0;_eg(j);Auh(j);return 0}function BEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;pgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886836]|0);Auh(f)}else{f=AEf(0,b,d,e,(PCf(b)|0)-e|0)|0;i=a;return f|0}return 0}function CEf(a){a=a|0;return}function DEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;rgh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886846]|0);Auh(e)}if(!(PCf(b)|0)){f=(xDf(b,0)|0)+-1|0;i=a;return f|0}else{f=EEf(0,b,d,(PCf(b)|0)+-1|0)|0;i=a;return f|0}return 0}function EEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;sgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886850]|0);Auh(f)}else{f=FEf(0,b,d,e,e+1-(xDf(b,0)|0)|0)|0;i=a;return f|0}return 0}function FEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;tgh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[886854]|0);Auh(g)}if((LDf(b)|0)>=2){g=c[886856]|0;RI(3115536)|0;h=qL(3115536)|0;zwg(h,g);Auh(h)}h=xDf(b,0)|0;if(!(PCf(b)|0)){j=h+-1|0;i=a;return j|0}if((!((f|0)<0|(h|0)>(e|0))?(WDf(b,0)|0)>=(e|0):0)?(g=e-f+1|0,(g|0)>=(h|0)):0){a:do if((f|0)>=1){k=e;while(1){if(Tnf(0,hDf(b,k)|0,d)|0){j=k;break}if((k|0)>(g|0))k=k+-1|0;else break a}i=a;return j|0}while(0);j=h+-1|0;i=a;return j|0}RI(2964880)|0;j=qL(2964880)|0;_eg(j);Auh(j);return 0}function GEf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;RI(1101728)|0;if(vL(b,1101728)|0){RI(2618256)|0;d=qL(2618256)|0;c[d+8>>2]=c[654945];c[d+20>>2]=2619776;c[d+16>>2]=b;e=d;i=a;return e|0}RI(1173448)|0;if(vL(b,1173448)|0){RI(2618256)|0;d=qL(2618256)|0;c[d+8>>2]=c[654959];c[d+20>>2]=2619832;c[d+16>>2]=b;e=d;i=a;return e|0}RI(1086352)|0;d=(vL(b,1086352)|0)==0;RI(2618256)|0;f=qL(2618256)|0;if(d){c[f+8>>2]=c[654987];c[f+20>>2]=2619944;c[f+16>>2]=b;e=f;i=a;return e|0}else{c[f+8>>2]=c[654973];c[f+20>>2]=2619888;c[f+16>>2]=b;e=f;i=a;return e|0}return 0}function HEf(a,b){a=a|0;b=b|0;var d=0;a=i;ugh();if(!b){RI(2963920)|0;d=qL(2963920)|0;Iag(d,c[886860]|0);Auh(d)}else{d=xDf(b,0)|0;IEf(0,b,d,JDf(b,0)|0);i=a;return}}function IEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;a=i;vgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886864]|0);Auh(f)}if((LDf(b)|0)>=2){f=c[886866]|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Auh(g)}if(!((xDf(b,0)|0)<=(d|0)&(e|0)>-1)){RI(2964880)|0;g=qL(2964880)|0;_eg(g);Auh(g)}if((1-e+(WDf(b,0)|0)|0)<(d|0)){RI(2965048)|0;g=qL(2965048)|0;oig(g);Auh(g)}g=d+-1+e|0;RI(1086352)|0;e=vL(b,1086352)|0;if(e){if((g|0)<=(d|0)){i=a;return}f=e+16|0;j=d;k=g;do{l=c[(c[e>>2]|0)+120>>2]|0;m=c[f+(da(l,j)|0)>>2]|0;Qqh(e,c[f+(da(l,k)|0)>>2]|0);l=c[(c[e>>2]|0)+120>>2]|0;c[f+(da(l,j)|0)>>2]=c[f+(da(l,k)|0)>>2];Qqh(e,m);c[f+(da(c[(c[e>>2]|0)+120>>2]|0,k)|0)>>2]=m;j=j+1|0;k=k+-1|0}while((j|0)<(k|0));i=a;return}RI(1101728)|0;k=vL(b,1101728)|0;if(k){if((g|0)<=(d|0)){i=a;return}j=k+16|0;e=d;f=g;do{m=c[(c[k>>2]|0)+120>>2]|0;l=j+(da(m,e)|0)|0;n=c[l>>2]|0;c[l>>2]=c[j+(da(m,f)|0)>>2];c[j+(da(c[(c[k>>2]|0)+120>>2]|0,f)|0)>>2]=n;e=e+1|0;f=f+-1|0}while((e|0)<(f|0));i=a;return}RI(1173448)|0;f=vL(b,1173448)|0;if(!f){e=GEf(0,b)|0;if((g|0)<=(d|0)){i=a;return}b=d;k=g;do{Zuh(2618528,e,b,k);b=b+1|0;k=k+-1|0}while((b|0)<(k|0));i=a;return}else{if((g|0)<=(d|0)){i=a;return}k=f+16|0;b=d;d=g;do{g=c[(c[f>>2]|0)+120>>2]|0;e=k+(da(g,b)|0)|0;o=+h[e>>3];h[e>>3]=+h[k+(da(g,d)|0)>>3];h[k+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)>>3]=o;b=b+1|0;d=d+-1|0}while((b|0)<(d|0));i=a;return}}function JEf(a,b){a=a|0;b=b|0;var d=0;a=i;wgh();if(!b){RI(2963920)|0;d=qL(2963920)|0;Iag(d,c[886870]|0);Auh(d)}else{d=xDf(b,0)|0;KEf(0,b,0,d,JDf(b,0)|0,0);i=a;return}}function KEf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;a=i;Agh();if(!b){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[886888]|0);Auh(h)}if((LDf(b)|0)>1){RI(3115536)|0;j=qL(3115536)|0;ywg(j);Auh(j)}if(d){if((LDf(d)|0)>=2){RI(3115536)|0;j=qL(3115536)|0;ywg(j);Auh(j)}j=xDf(b,0)|0;if((j|0)==(xDf(d,0)|0))k=1;else{RI(2965048)|0;j=qL(2965048)|0;oig(j);Auh(j)}}else k=0;if((xDf(b,0)|0)>(e|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886890]|0);Auh(j)}if((f|0)<=-1){j=c[886894]|0;RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[886892]|0,j);Auh(h)}h=PCf(b)|0;if((h-e-(xDf(b,0)|0)|0)<(f|0)){RI(2965048)|0;l=qL(2965048)|0;oig(l);Auh(l)}if(k?((PCf(d)|0)-f|0)<(e|0):0){RI(2965048)|0;l=qL(2965048)|0;oig(l);Auh(l)}if((f|0)<=1){i=a;return}if(!g){if(k)m=GEf(0,d)|0;else m=0;RI(1173448)|0;if(vL(b,1173448)|0){RI(1173448)|0;REf(0,vL(b,1173448)|0,e,f,m);i=a;return}RI(1101728)|0;if(vL(b,1101728)|0){RI(1101728)|0;SEf(0,vL(b,1101728)|0,e,f,m);i=a;return}RI(1136088)|0;if(vL(b,1136088)|0){RI(1136088)|0;TEf(0,vL(b,1136088)|0,e,f,m);i=a;return}}UEf(0,b,d,e,e+-1+f|0,g);i=a;return}function LEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;xgh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886874]|0);Auh(e)}else{e=xDf(b,0)|0;KEf(0,b,d,e,JDf(b,0)|0,0);i=a;return}}function MEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;ygh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886880]|0);Auh(e)}else{e=xDf(b,0)|0;KEf(0,b,0,e,JDf(b,0)|0,d);i=a;return}}function NEf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;KEf(0,b,0,c,d,0);i=a;return}function OEf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;zgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886884]|0);Auh(f)}else{f=xDf(b,0)|0;KEf(0,b,d,f,JDf(b,0)|0,e);i=a;return}}function PEf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;KEf(0,b,c,d,e,0);i=a;return}function QEf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;KEf(0,b,0,c,d,e);i=a;return}function REf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0;a=i;g=e+d|0;j=b+16|0;k=(f|0)==0;l=e;do{l=ZEf(0,l)|0;e=g-l|0;if((e|0)>(d|0)){m=0;n=d;while(1){o=n+l|0;p=c[(c[b>>2]|0)+120>>2]|0;q=j+(da(p,n)|0)|0;r=+h[q>>3];s=+h[j+(da(p,o)|0)>>3];if(!(r<=s)){h[q>>3]=s;h[j+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>3]=r;if(k)t=1;else{Zuh(2618528,f,n,o);t=1}}else t=m;n=n+1|0;if((n|0)==(e|0)){u=t;break}else m=t}}else u=0}while((l|0)!=1|u);i=a;return}function SEf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=e+d|0;h=b+16|0;j=(f|0)==0;k=e;do{k=ZEf(0,k)|0;e=g-k|0;if((e|0)>(d|0)){l=0;m=d;while(1){n=m+k|0;o=c[(c[b>>2]|0)+120>>2]|0;p=h+(da(o,m)|0)|0;q=c[p>>2]|0;r=c[h+(da(o,n)|0)>>2]|0;if((q|0)>(r|0)){c[p>>2]=r;c[h+(da(c[(c[b>>2]|0)+120>>2]|0,n)|0)>>2]=q;if(j)s=1;else{Zuh(2618528,f,m,n);s=1}}else s=l;m=m+1|0;if((m|0)==(e|0)){t=s;break}else l=s}}else t=0}while((k|0)!=1|t);i=a;return}function TEf(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;h=f+e|0;j=d+16|0;k=(g|0)==0;l=f;do{l=ZEf(0,l)|0;f=h-l|0;if((f|0)>(e|0)){m=0;n=e;while(1){o=n+l|0;p=c[(c[d>>2]|0)+120>>2]|0;q=j+(da(p,n)|0)|0;r=b[q>>1]|0;s=b[j+(da(p,o)|0)>>1]|0;if((r&65535)>(s&65535)){b[q>>1]=s;b[j+(da(c[(c[d>>2]|0)+120>>2]|0,o)|0)>>1]=r;if(k)t=1;else{Zuh(2618528,g,n,o);t=1}}else t=m;n=n+1|0;if((n|0)==(f|0)){u=t;break}else m=t}}else u=0}while((l|0)!=1|u);i=a;return}function UEf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=i;g=d;while(1){if((g|0)>=(e|0)){h=15;break}d=hDf(b,((e-g|0)/2|0)+g|0)|0;j=g;k=e;while(1){a:do if((j|0)<(e|0)){l=j;while(1){m=l+1|0;if((_Ef(0,hDf(b,l)|0,d,f)|0)>=0){n=0;o=l;break a}if((m|0)<(e|0))l=m;else{n=1;o=m;break}}}else{n=1;o=j}while(0);b:do if((k|0)>(g|0)){l=k;while(1){m=l+-1|0;if((_Ef(0,d,hDf(b,l)|0,f)|0)>=0){p=0;q=l;break b}if((m|0)>(g|0))l=m;else{p=1;q=m;break}}}else{p=1;q=k}while(0);if((o|0)>(q|0))break;$Ef(0,b,c,o,q);j=o+1|0;k=q+-1|0}if(!p)UEf(0,b,c,g,q,f);if(n){h=15;break}else g=o}if((h|0)==15){i=a;return}}function VEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(1101728)|0;f=vL(a,1101728)|0;a=f+16|0;g=c[(c[f>>2]|0)+120>>2]|0;h=a+(da(g,b)|0)|0;b=c[h>>2]|0;c[h>>2]=c[a+(da(g,d)|0)>>2];c[a+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)>>2]=b;i=e;return}function WEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;RI(1086352)|0;f=vL(a,1086352)|0;a=f+16|0;g=c[(c[f>>2]|0)+120>>2]|0;h=c[a+(da(g,b)|0)>>2]|0;Qqh(f,c[a+(da(g,d)|0)>>2]|0);g=c[(c[f>>2]|0)+120>>2]|0;c[a+(da(g,b)|0)>>2]=c[a+(da(g,d)|0)>>2];Qqh(f,h);c[a+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)>>2]=h;i=e;return}function XEf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=hDf(a,b)|0;uDf(a,uCf(a,c)|0,b);uDf(a,e,c);i=d;return}function YEf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0;e=i;RI(1173448)|0;f=vL(a,1173448)|0;a=f+16|0;g=c[(c[f>>2]|0)+120>>2]|0;j=a+(da(g,b)|0)|0;k=+h[j>>3];h[j>>3]=+h[a+(da(g,d)|0)>>3];h[a+(da(c[(c[f>>2]|0)+120>>2]|0,d)|0)>>3]=k;i=e;return}function ZEf(a,b){a=a|0;b=b|0;var c=0,d=0;a=i;c=b*10|0;if(!((c+-117|0)>>>0>12&(c+-130|0)>>>0>12)){d=11;i=a;return d|0}d=(c|0)>12?(c|0)/13|0:1;i=a;return d|0}function _Ef(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=i;e=(c|0)!=0;do if(b)if(e)if(!d){RI(2546528)|0;f=Zqh(2546712,Juh(b,2546528)|0,c)|0;break}else{f=hth(2734520,d,b,c)|0;break}else f=1;else f=e<<31>>31;while(0);i=a;return f|0}function $Ef(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=i;f=hDf(b,d)|0;uDf(b,uCf(b,e)|0,d);uDf(b,f,e);if(!c){i=a;return}f=hDf(c,d)|0;uDf(c,hDf(c,e)|0,d);uDf(c,f,e);i=a;return}function aFf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Egh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886960]|0);Auh(f)}if((LDf(a)|0)>=2){f=c[886962]|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Auh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[886964]|0);Auh(f)}if((LDf(b)|0)>=2){f=c[886966]|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Auh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=c[886970]|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[886968]|0,e);Auh(a)}}function bFf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Fgh();if(e>>>0<0|(e|0)==0&d>>>0<2147483648){Csh(262e4,a,b,d);i=f;return}else{f=c[886976]|0;RI(2964880)|0;d=qL(2964880)|0;Qag(d,c[886974]|0,f);Auh(d)}}function cFf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=i;wEf(0,b,c,d,e,f);i=a;return}function dFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function eFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function fFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function gFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function hFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function iFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function jFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function kFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function lFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function mFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function nFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function oFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function pFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function qFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function rFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function sFf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function tFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function uFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function vFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function wFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function xFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function yFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function zFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function AFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function BFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function CFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function DFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function EFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function FFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function GFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function HFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function IFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function JFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function KFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function LFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function MFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function NFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function OFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function PFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function QFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function RFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function SFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function TFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function UFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function VFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function WFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function XFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function YFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function ZFf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,2,1);c[c[d>>2]>>2]=a;i=b;return}function _Ff(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function $Ff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function aGf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function bGf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function cGf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function dGf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function eGf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function fGf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function gGf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function hGf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2584640)|0;c[b+8>>2]=sM(2887288)|0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function iGf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;c[a+8>>2]=sM(2887288)|0;c[c[d>>2]>>2]=a;i=b;return}function jGf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function kGf(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;RI(2540728)|0;b[(c[635205]|0)+4>>1]=46;RI(1104624)|0;j=Huh(1104624,0)|0;RI(2540728)|0;c[(c[635205]|0)+8>>2]=j;RI(3131312)|0;j=qL(3131312)|0;c[f>>2]=2649584;c[e+0>>2]=c[f+0>>2];wyg(j,0,e);RI(2540728)|0;c[(c[635205]|0)+12>>2]=j;RI(3131312)|0;j=qL(3131312)|0;c[g>>2]=2649640;c[e+0>>2]=c[g+0>>2];wyg(j,0,e);RI(2540728)|0;c[(c[635205]|0)+16>>2]=j;RI(3131312)|0;j=qL(3131312)|0;c[h>>2]=2649696;c[e+0>>2]=c[h+0>>2];wyg(j,0,e);RI(2540728)|0;c[(c[635205]|0)+20>>2]=j;RI(2867160)|0;if(a[2867308]|0){RI(2867160)|0;k=c[716813]|0;l=c[k>>2]|0;RI(2540728)|0;m=c[635205]|0;n=m+24|0;c[n>>2]=l;i=d;return}RI(2867160)|0;Buh(2867160);RI(2867160)|0;k=c[716813]|0;l=c[k>>2]|0;RI(2540728)|0;m=c[635205]|0;n=m+24|0;c[n>>2]=l;i=d;return}function lGf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;f=Juh(e,2540560)|0;if(!f){g=0;i=b;return g|0}e=f+8|0;h=c[e>>2]|0;if(!h){g=0;i=b;return g|0}j=(Wof(f,h+-1|0)|0)<<16>>16==42;h=Fqh(2649752,d)|0;if(!j){g=Prh(2575520,f,h)|0;i=b;return g|0}j=c[e>>2]|0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}e=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);g=(rvf(0,f,0,h,0,j+-1|0,0,e)|0)==0;i=b;return g|0}function mGf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;f=Juh(e,2540560)|0;if(!f){g=0;i=b;return g|0}e=f+8|0;h=c[e>>2]|0;if(!h){g=0;i=b;return g|0}j=(Wof(f,h+-1|0)|0)<<16>>16==42;h=Fqh(2649752,d)|0;if(j){j=c[e>>2]|0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}e=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);g=(rvf(0,f,0,h,0,j+-1|0,1,e)|0)==0;i=b;return g|0}else{RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Buh(2686624)}e=eKf(0)|0;if(!(a[2540708]|0))Buh(2540560);g=(qvf(0,f,h,1,e)|0)==0;i=b;return g|0}return 0}function nGf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=i;RI(2545096)|0;d=Zqh(2545784,Juh(c,2545096)|0,0)|0;RI(2834864)|0;if(vL(b,2834864)|0){RI(2834864)|0;e=((Aqh(2836848,Juh(b,2834864)|0)|0)&d|0)!=0;i=a;return e|0}RI(2828024)|0;if(vL(b,2828024)|0){RI(2828024)|0;e=((Aqh(2836792,Juh(b,2828024)|0)|0)&d|0)!=0;i=a;return e|0}RI(2884456)|0;if(vL(b,2884456)|0){RI(2884456)|0;e=((Aqh(2888032,Juh(b,2884456)|0)|0)&d|0)!=0;i=a;return e|0}RI(2856912)|0;if(!(vL(b,2856912)|0)){e=0;i=a;return e|0}RI(2856912)|0;e=((Aqh(2857272,Juh(b,2856912)|0)|0)&d|0)!=0;i=a;return e|0}function oGf(a){a=a|0;var b=0,c=0;b=i;c=Aqh(2649808,a)|0;i=b;return c|0}function pGf(a){a=a|0;return 0}function qGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2649864,a)|0;i=b;return c|0}function rGf(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2649920,a)|0)&128|0)!=0;i=b;return c|0}function sGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2649976,a)|0;i=b;return c|0}function tGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2650032,a)|0;i=b;return c|0}function uGf(a){a=a|0;var b=0,c=0;b=i;if(Gqh(2650088,a)|0){c=0;i=b;return c|0}c=(Gqh(2650144,a)|0)^1;i=b;return c|0}function vGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2650200,a)|0;i=b;return c|0}function wGf(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=3441064;c[e+0>>2]=c[f+0>>2];f=Yuh(2650256,b,npf(0,e)|0)|0;i=d;return f|0}function xGf(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2649920,a)|0)&24|0)==16;i=b;return c|0}function yGf(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2649920,a)|0)&32|0)!=0;i=b;return c|0}function zGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2650312,a)|0;i=b;return c|0}function AGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2650368,a)|0;i=b;return c|0}function BGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2650424,a)|0;i=b;return c|0}function CGf(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2649920,a)|0)&256|0)!=0;i=b;return c|0}function DGf(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2650480,a)|0;i=b;return c|0}function EGf(a){a=a|0;return 32}function FGf(a){a=a|0;return 0}function GGf(b){b=b|0;var d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=0;if(!(a[2650681]|0)){c[d>>2]=0;e=0;i=b;return e|0}else{PEi(d|0,0,(c[662663]|0)+-8|0)|0;e=c[d>>2]|0;i=b;return e|0}return 0}function HGf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((b|0)!=0?(RI(2540728)|0,d=vL(b,2540728)|0,(d|0)!=0):0)e=Yuh(2619496,a,d)|0;else e=0;i=c;return e|0}function IGf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if(!b){d=0;i=c;return d|0}e=suh(2619440,a)|0;d=JGf(e,suh(2619440,b)|0)|0;i=c;return d|0}function JGf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[662676]|0;if(!e){f=MK(2650712)|0;c[662676]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function KGf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[662690]|0;if(!f){g=MK(2650768)|0;c[662690]=g;h=g}else h=f;c[e>>2]=c[b>>2];c[d+0>>2]=c[e+0>>2];e=mo[h&4095](d)|0;i=a;return e|0}function LGf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[662706]|0;if(!f){g=MK(2650832)|0;c[662706]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function MGf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;Mgh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[887090]|0);Auh(e)}RI(2540728)|0;if(a[2540876]|0){f=LGf(0,d,0,0)|0;i=b;return f|0}RI(2540728)|0;Buh(2540728);f=LGf(0,d,0,0)|0;i=b;return f|0}function NGf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[662728]|0;if(!d){e=MK(2650920)|0;c[662728]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function OGf(a){a=a|0;return c[a>>2]|0}function PGf(a,b){a=a|0;b=b|0;var c=0;a=i;if(!b){RI(2963920)|0;c=qL(2963920)|0;Ucg(c);Auh(c)}else{c=_uh(2650968,Xnf(b)|0)|0;i=a;return c|0}return 0}function QGf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[662756]|0;if(!f){g=MK(2651032)|0;c[662756]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function RGf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[662776]|0;if(!e){f=MK(2651112)|0;c[662776]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function SGf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;a:do if(!((c|0)==0|(c|0)==(b|0))){if(!(kEf(b)|0)){e=suh(2651176,b)|0;if(!e){f=0;break}else g=e;while(1){if((g|0)==(c|0)){f=1;break a}g=suh(2651176,g)|0;if(!g){f=0;break a}}}if(kEf(c)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}f=QGf(0,b,c,0)|0}else f=0}else f=0;while(0);i=d;return f|0}function TGf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if(!c){e=0;i=d;return e|0}if(Yuh(2619496,b,c)|0){e=1;i=d;return e|0}RI(2837096)|0;if(vL(c,2837096)|0){RI(2837096)|0;e=w$f(Juh(c,2837096)|0,b)|0;i=d;return e|0}if(!(kEf(b)|0)){f=suh(2619440,b)|0;if(!(kEf(f)|0)){e=0;i=d;return e|0}e=Yuh(2651232,f,c)|0;i=d;return e|0}if(kEf(c)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}e=RGf(0,b,c)|0;i=d;return e|0}else{f=suh(2619440,c)|0;if(!(kEf(f)|0)){e=0;i=d;return e|0}e=Yuh(2651232,b,f)|0;i=d;return e|0}return 0}function UGf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[662822]|0;if(!e){f=MK(2651296)|0;c[662822]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function VGf(a){a=a|0;var b=0,d=0,e=0;b=i;d=suh(2619440,a)|0;if((d|0)==0|(d|0)==(a|0)){e=c[a+8>>2]|0;i=b;return e|0}else{e=Aqh(2651344,d)|0;i=b;return e|0}return 0}function WGf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Ngh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[887098]|0);Auh(e)}else{e=$uh(2651400,a,b,28,0,3,0,0)|0;i=d;return e|0}return 0}function XGf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Ogh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[887104]|0);Auh(f)}else{f=$uh(2651400,a,b,d,0,3,0,0)|0;i=e;return f|0}return 0}function YGf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=$uh(2651456,a,b,c,d,3,e,f)|0;i=g;return h|0}function ZGf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;Pgh();if(!b){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887108]|0);Auh(k)}if(!g){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887110]|0);Auh(k)}k=c[g+12>>2]|0;if((k|0)<=0){l=$uh(2651400,a,b,d,e,f,g,h)|0;i=j;return l|0}m=g+16|0;n=c[(c[g>>2]|0)+120>>2]|0;o=0;while(1){if(!(c[m+(da(n,o)|0)>>2]|0)){p=7;break}o=o+1|0;if((o|0)>=(k|0)){p=10;break}}if((p|0)==7){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887112]|0);Auh(k)}else if((p|0)==10){l=$uh(2651400,a,b,d,e,f,g,h)|0;i=j;return l|0}return 0}function _Gf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;Qgh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[887120]|0);Auh(f)}else{f=avh(2651512,a,b,28,0,d,0,0)|0;i=e;return f|0}return 0}function $Gf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=avh(2651568,a,b,28,0,c,d,0)|0;i=e;return f|0}function aHf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;Rgh();if(!b){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887124]|0);Auh(k)}if(!g){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887126]|0);Auh(k)}k=c[g+12>>2]|0;if((k|0)<=0){l=avh(2651512,a,b,d,e,f,g,h)|0;i=j;return l|0}m=g+16|0;n=c[(c[g>>2]|0)+120>>2]|0;o=0;while(1){if(!(c[m+(da(n,o)|0)>>2]|0)){p=7;break}o=o+1|0;if((o|0)>=(k|0)){p=10;break}}if((p|0)==7){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887128]|0);Auh(k)}else if((p|0)==10){l=avh(2651512,a,b,d,e,f,g,h)|0;i=j;return l|0}return 0}function bHf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[662906]|0;if(!d){e=MK(2651632)|0;c[662906]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function cHf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=3439888;c[e+0>>2]=c[f+0>>2];if((npf(0,e)|0)==(b|0)){j=0;i=d;return j|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[g>>2]=3441064;c[e+0>>2]=c[g+0>>2];if((npf(0,e)|0)==(b|0)){j=0;i=d;return j|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[h>>2]=3439888;c[e+0>>2]=c[h+0>>2];j=Yuh(2650256,b,npf(0,e)|0)|0;i=d;return j|0}function dHf(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=3442280;c[e+0>>2]=c[f+0>>2];f=Yuh(2651232,npf(0,e)|0,b)|0;i=d;return f|0}function eHf(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=3442296;c[e+0>>2]=c[f+0>>2];f=Yuh(2651232,npf(0,e)|0,b)|0;i=d;return f|0}function fHf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=bvh(2651672,a,b,c,3,d,e)|0;i=f;return g|0}function gHf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;Sgh();if(!f){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[887132]|0);Auh(j)}j=c[f+12>>2]|0;if((j|0)<=0){k=bvh(2651728,a,b,d,e,f,g)|0;i=h;return k|0}l=f+16|0;m=c[(c[f>>2]|0)+120>>2]|0;n=0;while(1){if(!(c[l+(da(m,n)|0)>>2]|0)){o=5;break}n=n+1|0;if((n|0)>=(j|0)){o=8;break}}if((o|0)==5){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[887134]|0);Auh(j)}else if((o|0)==8){k=bvh(2651728,a,b,d,e,f,g)|0;i=h;return k|0}return 0}function hHf(a){a=a|0;var b=0,c=0;b=i;c=Fqh(2537592,a)|0;i=b;return c|0}function iHf(a){a=a|0;RI(3100472)|0;a=qL(3100472)|0;oug(a);Auh(a);return 0}function jHf(a){a=a|0;return 0}function kHf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[662946]|0;if(!d){e=MK(2651792)|0;c[662946]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function lHf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[662960]|0;if(!d){e=MK(2651848)|0;c[662960]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function mHf(a){a=a|0;Tgh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[887138]|0);Auh(a);return 0}function nHf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[662974]|0;if(!d){e=MK(2651904)|0;c[662974]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function oHf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[662986]|0;if(!e){f=MK(2651952)|0;c[662986]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function pHf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+4|0;g=e;Ugh();if(!(Gqh(2652008,b)|0)){RI(3084976)|0;h=qL(3084976)|0;osg(h,c[887166]|0);Auh(h)}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[887168]|0);Auh(h)}h=c[(cvh(2652064,b)|0)+12>>2]|0;j=d+12|0;if((h|0)!=(c[j>>2]|0)){c[f>>2]=c[(cvh(2652064,b)|0)+12>>2];RI(2540224)|0;h=pL(2540224,f)|0;c[g>>2]=c[j>>2];RI(2540224)|0;f=pL(2540224,g)|0;if(a[2540708]|0){k=c[887170]|0;l=awf(0,k,h,f)|0;RI(2965048)|0;m=qL(2965048)|0;n=c[887172]|0;Rag(m,l,n);Auh(m)}Buh(2540560);k=c[887170]|0;l=awf(0,k,h,f)|0;RI(2965048)|0;m=qL(2965048)|0;n=c[887172]|0;Rag(m,l,n);Auh(m)}RI(1104624)|0;m=Huh(1104624,c[j>>2]|0)|0;a:do if((c[j>>2]|0)>0){n=d+16|0;l=m+16|0;f=0;while(1){h=c[n+(da(c[(c[d>>2]|0)+120>>2]|0,f)|0)>>2]|0;if(!h){o=11;break}RI(2823616)|0;if((vL(h,2823616)|0)==0?(RI(2837096)|0,(vL(h,2837096)|0)==0):0){k=suh(2619440,h)|0;if(!k){o=16;break}else p=k}else p=h;if(!(kEf(p)|0)){o=16;break}Qqh(m,p);c[l+(da(c[(c[m>>2]|0)+120>>2]|0,f)|0)>>2]=p;f=f+1|0;if((f|0)>=(c[j>>2]|0))break a}if((o|0)==11){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[887174]|0);Auh(f)}else if((o|0)==16){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[887176]|0);Auh(f)}}while(0);RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}o=oHf(0,b,m)|0;if(!o){RI(3072960)|0;m=qL(3072960)|0;ayg(m);Auh(m)}else{i=e;return o|0}return 0}function qHf(a){a=a|0;return 0}function rHf(a){a=a|0;var b=0,c=0;b=i;c=(suh(2652120,a)|0)!=0;i=b;return c|0}function sHf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=(Aqh(2649920,a)|0)>>>13&1;e=((Aqh(2649920,a)|0)>>>12&1)+d|0;if(!e){f=0;i=b;return f|0}RI(1086352)|0;d=Huh(1086352,e)|0;if(!((Aqh(2649920,a)|0)&8192))g=0;else{RI(2547224)|0;e=qL(2547224)|0;Qqh(d,e);c[d+16>>2]=e;g=1}if(!((Aqh(2649920,a)|0)&4096)){f=d;i=b;return f|0}RI(2652176)|0;a=qL(2652176)|0;Qqh(d,a);c[d+16+(c[(c[d>>2]|0)+120>>2]&0-g)>>2]=a;f=d;i=b;return f|0}function tHf(a){a=a|0;return}function uHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2819056)|0;OXf(b,0);c[c[e>>2]>>2]=b;b=qL(2819224)|0;RI(2657400)|0;PXf(b,ML(c[664366]|0)|0);c[(c[e>>2]|0)+4>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+8>>2]=b;i=d;return}function vHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function wHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function xHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function yHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function zHf(a){a=a|0;var b=0,c=0;b=i;c=dvh(2653872,suh(2658656,a)|0)|0;i=b;return c|0}function AHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2819224)|0;RI(2659e3)|0;PXf(b,ML(c[664766]|0)|0);c[c[e>>2]>>2]=b;b=qL(2819056)|0;OXf(b,0);c[(c[e>>2]|0)+4>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+8>>2]=b;i=d;return}function BHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function CHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2659768)|0;c[(c[e>>2]|0)+4>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+8>>2]=b;b=qL(2911064)|0;RI(2658120)|0;Y5f(b,ML(c[664546]|0)|0);c[(c[e>>2]|0)+12>>2]=b;b=qL(2898616)|0;B5f(b,1);c[(c[e>>2]|0)+16>>2]=b;i=d;return}function DHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2659848)|0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function EHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2911064)|0;RI(2540728)|0;Y5f(b,ML(c[635198]|0)|0);c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+8>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2660096)|0;c[(c[e>>2]|0)+12>>2]=b;b=qL(2898616)|0;B5f(b,1);c[(c[e>>2]|0)+16>>2]=b;i=d;return}function FHf(a){a=a|0;c[a+40>>2]=-2146233088;return}function GHf(a,b,d){a=a|0;b=b|0;d=d|0;c[a+40>>2]=-2146233088;c[a+12>>2]=d;c[a+16>>2]=b;return}function HHf(a){a=a|0;return c[a+12>>2]|0}function IHf(a){a=a|0;return c[a+20>>2]|0}function JHf(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function KHf(a,b){a=a|0;b=b|0;c[a+40>>2]=b;return}function LHf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+24|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=Fqh(2536192,suh(2660168,a)|0)|0;c[d>>2]=e;f=e;i=b;return f|0}function MHf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;Vgh();e=b+16|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}f=c[887282]|0;h=LHf(b)|0;if(!(a[2540708]|0))Buh(2540560);b=_vf(0,f,h)|0;c[e>>2]=b;g=b;i=d;return g|0}function NHf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+44|0;if((((c[d>>2]|0)==0?(RI(2746864)|0,e=qL(2746864)|0,RQf(e,a,1),(Aqh(2746736,e)|0)>=1):0)?(a=yuh(2746792,e,0)|0,(e|0)!=0):0)?(e=zuh(2746160,a)|0,(e|0)!=0):0)c[d>>2]=o0f(evh(2843624,rth(2652848,suh(2658656,e)|0)|0)|0)|0;i=b;return c[d>>2]|0}function OHf(a,b){a=a|0;b=b|0;c[a+44>>2]=b;return}function PHf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;Wgh();j=b+28|0;k=c[j>>2]|0;if(k){l=k;i=d;return l|0}if(!(c[b+8>>2]|0)){l=0;i=d;return l|0}RI(2746864)|0;k=qL(2746864)|0;TQf(k,b,0,1,1);RI(2971904)|0;b=qL(2971904)|0;Gbg(b);m=org(0)|0;n=c[887306]|0;if(!(a[2540708]|0))Buh(2540560);o=awf(0,c[887304]|0,m,n)|0;n=c[887308]|0;if((Aqh(2746736,k)|0)>0){m=0;do{p=yuh(2746792,k,m)|0;if(!m)qcg(b,c[887310]|0,c[887312]|0)|0;else Hbg(b,o)|0;do if(!(zuh(2746160,p)|0)){q=MQf(p)|0;if(!q){c[e>>2]=Aqh(2746232,p)|0;RI(2540224)|0;r=pL(2540224,e)|0;ocg(b,c[887314]|0,r,n)|0;break}else{Hbg(b,q)|0;break}}else{QHf(0,b,zuh(2746160,p)|0);if((Aqh(2746104,p)|0)==-1){c[f>>2]=Aqh(2746232,p)|0;RI(2540224)|0;q=pL(2540224,f)|0;qcg(b,c[887316]|0,q)|0}else{c[g>>2]=Aqh(2746104,p)|0;RI(2540224)|0;q=pL(2540224,g)|0;qcg(b,c[887318]|0,q)|0}q=IQf(p)|0;c[h>>2]=Aqh(2745936,p)|0;RI(2540224)|0;r=pL(2540224,h)|0;ocg(b,c[887320]|0,q,r)|0}while(0);m=m+1|0}while((m|0)<(Aqh(2746736,k)|0))}k=Fqh(2972072,b)|0;c[j>>2]=k;l=k;i=d;return l|0}function QHf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;b=i;Zgh();f=xuh(2849384,e)|0;Hbg(d,Fqh(2536192,suh(2658656,e)|0)|0)|0;Hbg(d,c[887522]|0)|0;Hbg(d,Fqh(2649752,e)|0)|0;if(Gqh(2864864,e)|0){g=cvh(2864752,e)|0;Hbg(d,c[887524]|0)|0;e=g+12|0;if((c[e>>2]|0)>0){h=g+16|0;j=0;do{if((j|0)>=1)Hbg(d,c[887526]|0)|0;Hbg(d,Fqh(2649752,c[h+(da(c[(c[g>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0)|0;j=j+1|0}while((j|0)<(c[e>>2]|0))}Hbg(d,c[887528]|0)|0}Hbg(d,c[887530]|0)|0;e=f+12|0;if((c[e>>2]|0)<=0){k=c[887538]|0;Hbg(d,k)|0;i=b;return}j=f+16|0;g=0;do{if((g|0)>=1)Hbg(d,c[887532]|0)|0;h=suh(2849496,c[j+(da(c[(c[f>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0;if(Gqh(2653256,h)|0){l=Fqh(2653928,h)|0;if(!(a[2540708]|0))Buh(2540560);if(Iwf(0,l,c[c[635163]>>2]|0)|0){Hbg(d,Fqh(2653928,h)|0)|0;Hbg(d,c[887534]|0)|0}}Hbg(d,Fqh(2649752,h)|0)|0;if(Fqh(2849440,c[j+(da(c[(c[f>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0){Hbg(d,c[887536]|0)|0;Hbg(d,Fqh(2849440,c[j+(da(c[(c[f>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0)|0}g=g+1|0}while((g|0)<(c[e>>2]|0));k=c[887538]|0;Hbg(d,k)|0;i=b;return}function RHf(a){a=a|0;var b=0,c=0,d=0;b=i;RI(2746864)|0;c=qL(2746864)|0;RQf(c,a,1);if((Aqh(2746736,c)|0)<1){d=0;i=b;return d|0}d=zuh(2746160,yuh(2746792,c,0)|0)|0;i=b;return d|0}function SHf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+12>>2]|0;a:do if(!d)e=a;else{f=d;while(1){if(!(huh(2660224,f)|0)){e=f;break a}f=huh(2660224,f)|0;if(!f){e=a;break}}}while(0);i=b;return e|0}function THf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;Xgh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[887370]|0);Auh(h)}h=LHf(b)|0;L7f(d,c[887372]|0,h);L7f(d,c[887374]|0,c[b+16>>2]|0);L7f(d,c[887376]|0,c[b+12>>2]|0);L7f(d,c[887378]|0,c[b+20>>2]|0);h=Fqh(2660280,b)|0;L7f(d,c[887380]|0,h);L7f(d,c[887382]|0,c[b+32>>2]|0);r9f(d,c[887384]|0,c[b+36>>2]|0);r9f(d,c[887386]|0,c[b+40>>2]|0);h=Fqh(2660336,b)|0;L7f(d,c[887388]|0,h);L7f(d,c[887390]|0,0);h=c[b+48>>2]|0;RI(2540728)|0;if(a[2540876]|0){c[g>>2]=3436856;c[f+0>>2]=c[g+0>>2];j=npf(0,f)|0;k=c[887392]|0;q9f(d,k,h,j);i=e;return}RI(2540728)|0;Buh(2540728);c[g>>2]=3436856;c[f+0>>2]=c[g+0>>2];j=npf(0,f)|0;k=c[887392]|0;q9f(d,k,h,j);i=e;return}function UHf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Ygh();d=LHf(a)|0;RI(2971904)|0;e=qL(2971904)|0;bcg(e,d);d=Hbg(e,c[887464]|0)|0;Hbg(d,Fqh(2660392,a)|0)|0;d=c[a+32>>2]|0;if(d)Hbg(e,d)|0;if(c[a+12>>2]|0){Hbg(e,c[887466]|0)|0;Mnf(0,0,c[887468]|0)|0}if(!(Fqh(2660280,a)|0)){f=Fqh(2972072,e)|0;i=b;return f|0}d=Hbg(e,org(0)|0)|0;Hbg(d,Fqh(2660280,a)|0)|0;f=Fqh(2972072,e)|0;i=b;return f|0}function VHf(a){a=a|0;var b=0,c=0;b=i;c=Xnf(a)|0;i=b;return c|0}function WHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2819224)|0;RI(2661912)|0;PXf(b,ML(c[665494]|0)|0);c[(c[e>>2]|0)+4>>2]=b;b=qL(2819056)|0;OXf(b,0);c[(c[e>>2]|0)+8>>2]=b;i=d;return}function XHf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;b=qL(2898616)|0;B5f(b,0);c[(c[e>>2]|0)+8>>2]=b;b=qL(2539976)|0;c[b+8>>2]=sM(2662384)|0;c[(c[e>>2]|0)+12>>2]=b;i=d;return}function YHf(a){a=a|0;return c[a>>2]|0}function ZHf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;_gh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[887546]|0);Auh(j)}j=c[b>>2]|0;RI(2604248)|0;if((j|0)==(c[c[651085]>>2]|0)){RI(2955448)|0;j=qL(2955448)|0;cag(j,c[887548]|0);Auh(j)}c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];g=s1f(0,f)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[h>>2]=3442792;c[f+0>>2]=c[h+0>>2];h=npf(0,f)|0;f=c[887550]|0;RI(2871608)|0;q9f(d,f,Juh(g,2871608)|0,h);i=e;return}function _Hf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!b){f=0;i=d;return f|0}c[e>>2]=c[a>>2];RI(2662464)|0;g=Xnf(pL(2662464,e)|0)|0;if((g|0)!=(Xnf(b)|0)){f=0;i=d;return f|0}g=c[a>>2]|0;RI(2662464)|0;f=(g|0)==(c[(Euh(b,2662464)|0)>>2]|0);i=d;return f|0}function $Hf(a){a=a|0;return c[a>>2]|0}function aIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2662936)|0;c[b+8>>2]=sM(3116792)|0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function bIf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function cIf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function dIf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;$gh();if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[887582]|0);Auh(k)}k=c[b>>2]|0;RI(2604248)|0;if((k|0)==(c[c[651085]>>2]|0)){RI(2955448)|0;k=qL(2955448)|0;cag(k,c[887584]|0);Auh(k)}c[g>>2]=c[b>>2];RI(2650536)|0;b=pL(2650536,g)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[h>>2]=PGf(0,b)|0;RI(2650536)|0;b=pL(2650536,h)|0;c[j>>2]=3442832;c[f+0>>2]=c[j+0>>2];j=npf(0,f)|0;q9f(d,c[887586]|0,b,j);i=e;return}function eIf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;if(!b){f=0;i=d;return f|0}c[e>>2]=c[a>>2];RI(2650536)|0;g=Xnf(pL(2650536,e)|0)|0;if((g|0)!=(Xnf(b)|0)){f=0;i=d;return f|0}g=c[a>>2]|0;RI(2650536)|0;f=(g|0)==(c[(Euh(b,2650536)|0)>>2]|0);i=d;return f|0}function fIf(a){a=a|0;return c[a>>2]|0}function gIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2662936)|0;c[b+8>>2]=sM(3116792)|0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function hIf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function iIf(a){a=a|0;return}function jIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=2048;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function kIf(a){a=a|0;return}function lIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=2048;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function mIf(a){a=a|0;return}function nIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=6140;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function oIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;c[b+8>>2]=64;a[b+13>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function pIf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function qIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;c[b+8>>2]=10496;a[b+13>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function rIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function sIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function tIf(a){a=a|0;return}function uIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;c[b+8>>2]=2048;a[b+13>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function vIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=5149;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function wIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=1028;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function xIf(a){a=a|0;return}function yIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;c[b+8>>2]=2048;a[b+13>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function zIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=32767;c[c[e>>2]>>2]=b;i=d;return}function AIf(b,d){b=b|0;d=d|0;a[b+12>>0]=1;c[b+8>>2]=d;return}function BIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=1;a[b+12>>0]=1;a[b+13>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function CIf(a){a=a|0;return}function DIf(b,c){b=b|0;c=c|0;a[b+8>>0]=c&1;return}function EIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=1;a[b+13>>0]=0;a[b+12>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function FIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=224;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function GIf(a){a=a|0;return c[a+8>>2]|0}function HIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=1036;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function IIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539536)|0;c[b+8>>2]=2304;a[b+13>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function JIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539808)|0;a[b+8>>0]=0;c[c[e>>2]>>2]=b;i=d;return}function KIf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function LIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;c[b+8>>2]=256;a[b+13>>0]=0;c[c[e>>2]>>2]=b;b=qL(2537168)|0;a[b+8>>0]=1;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function MIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function NIf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function OIf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)OIf(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function PIf(a,b){a=a|0;b=b|0;Auh(SJ(2669e3)|0)}function QIf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function RIf(a,b){a=a|0;b=b|0;return}function SIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function TIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function UIf(a,b){a=a|0;b=b|0;ahh();b=c[887594]|0;RI(3100472)|0;a=qL(3100472)|0;pug(a,b);Auh(a);return 0}function VIf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b>>2]|0;RI(2604248)|0;if((g|0)==(c[c[651085]>>2]|0)){h=0;i=d;return h|0}g=c[b>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Buh(2540728)}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];h=Aqh(2651344,npf(0,e)|0)|0;i=d;return h|0}function WIf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;b=qL(2539808)|0;a[b+8>>0]=0;c[(c[e>>2]|0)+4>>2]=b;i=d;return}function XIf(a,b){a=a|0;b=b|0;bhh();b=c[887622]|0;RI(3100472)|0;a=qL(3100472)|0;pug(a,b);Auh(a);return 0}function YIf(a){a=a|0;return c[a>>2]|0}function ZIf(a){a=a|0;return}function _If(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2537168)|0;a[b+8>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function $If(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[667906]|0;if(!g){h=MK(2671632)|0;c[667906]=h;j=h}else j=g;c[f>>2]=c[d>>2];c[e+0>>2]=c[f+0>>2];In[j&4095](b,e);i=a;return}function aJf(a){a=a|0;return}function bJf(b){b=b|0;var d=0,e=0;d=i;e=b+4|0;c[e>>2]=Ks(c[b>>2]<<2,0)|0;b=qL(2539536)|0;a[b+13>>0]=1;c[b+8>>2]=32767;a[b+12>>0]=1;c[c[e>>2]>>2]=b;i=d;return}function cJf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=0;c[e+0>>2]=c[f+0>>2];J5f(a,e,b);i=d;return}function dJf(a){a=a|0;var b=0;b=c[a+8>>2]|0;return (b|0)==(-1|0)|(b|0)==0|0}function eJf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function fJf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;cJf(a,d);c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];O5f(a,f);i=e;return}function gJf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];chg(0,d);i=b;return 1}function hJf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function iJf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;c[a>>2]=b;c[a+4>>2]=d;f=d-b|0;c[a+8>>2]=f;c[a+12>>2]=e;c[a+16>>2]=f+e;return}function jJf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;c[a+16>>2]=e;c[a+20>>2]=f;RI(1188416)|0;f=Huh(1188416,c[b+12>>2]|0)|0;e=a+8|0;c[e>>2]=f;if((c[f+12>>2]|0)<=0){i=g;return}h=d+16|0;j=b+16|0;k=f;f=0;while(1){l=c[h+(da(c[(c[d>>2]|0)+120>>2]|0,f)|0)>>2]|0;m=c[j+(da(c[(c[b>>2]|0)+120>>2]|0,f)|0)>>2]|0;n=k+16|0;o=c[(c[k>>2]|0)+120>>2]|0;p=da(o,f)|0;if(!f)q=0;else{r=da(o,f+-1|0)|0;q=(c[n+(r+8)>>2]|0)+(c[n+(r+12)>>2]|0)|0}r=l-m|0;c[n+p>>2]=m;c[n+(p+4)>>2]=l;c[n+(p+8)>>2]=r;c[n+(p+12)>>2]=q;c[n+(p+16)>>2]=q+r;f=f+1|0;r=c[e>>2]|0;p=c[r+12>>2]|0;if((f|0)>=(p|0)){s=r;t=p;break}else k=r}if((t|0)<=0){i=g;return}k=a+12|0;a=c[(c[s>>2]|0)+120>>2]|0;f=c[k>>2]|0;e=0;while(1){q=(c[s+16+((da(a,e)|0)+8)>>2]|0)+f|0;e=e+1|0;if((e|0)>=(t|0)){u=q;break}else f=q}c[k>>2]=u;i=g;return}function kJf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;e=c[a+8>>2]|0;f=c[e+12>>2]|0;a:do if((f|0)>0){g=c[(c[e>>2]|0)+120>>2]|0;h=0;while(1){j=e+16|0;k=da(g,h)|0;l=c[j+k>>2]|0;if((l|0)>(b|0)){m=3;break}h=h+1|0;if((c[j+(k+4)>>2]|0)>(b|0)){n=j;o=k;p=l;m=5;break}if((h|0)>=(f|0))break a}if((m|0)==3){q=c[a+16>>2]|0;i=d;return q|0}else if((m|0)==5){q=b-p+(c[n+(o+12)>>2]|0)|0;i=d;return q|0}}while(0);q=c[a+16>>2]|0;i=d;return q|0}function lJf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[b+8>>2]=d;c[b+12>>2]=e;c[b+16>>2]=f;a[b+20>>0]=g&1;return}function mJf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;return}function nJf(a){a=a|0;return}function oJf(a){a=a|0;var b=0;a=i;RI(2675816)|0;b=qL(2675816)|0;RI(2675816)|0;c[c[668977]>>2]=b;i=a;return}function pJf(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;RI(2675400)|0;f=Juh(d,2675400)|0;RI(2675400)|0;d=Juh(e,2675400)|0;e=c[f+8>>2]|0;f=c[d+8>>2]|0;d=c[e+12>>2]|0;g=c[f+12>>2]|0;h=(d|0)>(g|0)?g:d;a:do if((h|0)>0){j=e+16|0;k=c[(c[e>>2]|0)+120>>2]|0;l=f+16|0;m=c[(c[f>>2]|0)+120>>2]|0;n=0;while(1){o=b[j+(da(k,n)|0)>>1]|0;p=b[l+(da(m,n)|0)>>1]|0;n=n+1|0;if(o<<16>>16!=p<<16>>16){q=o;r=p;break}if((n|0)>=(h|0))break a}s=(q&65535)-(r&65535)|0;i=a;return s|0}while(0);s=d-g|0;i=a;return s|0}function qJf(b,c,d){b=b|0;c=c|0;d=d|0;a[b+8>>0]=c;a[b+9>>0]=d;return}function rJf(a){a=a|0;return}function sJf(a){a=a|0;var b=0;a=i;RI(2676656)|0;b=qL(2676656)|0;RI(2676656)|0;c[c[669187]>>2]=b;i=a;return}function tJf(a,b,c){a=a|0;b=b|0;c=c|0;var e=0;a=i;RI(2676296)|0;e=Juh(b,2676296)|0;RI(2676296)|0;b=Juh(c,2676296)|0;i=a;return (d[e+8>>0]|0)-(d[b+8>>0]|0)|0}function uJf(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;dhh();RI(2677136)|0;c[c[669307]>>2]=3;RI(2536312)|0;f=qL(2536312)|0;RI(2677136)|0;c[(c[669307]|0)+68>>2]=f;f=vJf(0,c[887666]|0)|0;RI(2604248)|0;if((f|0)==(c[c[651085]>>2]|0)){i=e;return}g=vJf(0,c[887668]|0)|0;RI(2604248)|0;if((g|0)==(c[c[651085]>>2]|0)){i=e;return}if(!((f|0)!=0&(g|0)!=0)){i=e;return}if((a[f>>0]|0)!=3){i=e;return}if((a[g>>0]|0)!=3){i=e;return}h=wJf(0,f,1)|0;RI(2677136)|0;c[(c[669307]|0)+4>>2]=f+5;j=wJf(0,f,h+5|0)|0;k=h+9|0;RI(2677136)|0;c[(c[669307]|0)+8>>2]=f+k;h=j+k|0;k=wJf(0,f,h)|0;j=h+4|0;RI(2677136)|0;c[(c[669307]|0)+12>>2]=f+j;h=k+j|0;j=wJf(0,f,h)|0;RI(2677136)|0;c[(c[669307]|0)+16>>2]=f+(h+4);RI(2677136)|0;c[(c[669307]|0)+20>>2]=f+(h+8+j);j=wJf(0,g,1)|0;RI(1188896)|0;h=Huh(1188896,j)|0;RI(2677136)|0;c[(c[669307]|0)+64>>2]=h;if(!j)l=5;else{h=j*13|0;f=5;k=0;while(1){m=wJf(0,g,f)|0;n=wJf(0,g,f+4|0)|0;o=wJf(0,g,f+8|0)|0;RI(2674912)|0;p=qL(2674912)|0;q=(a[g+(f+12)>>0]|0)!=0;c[p+8>>2]=m;c[p+12>>2]=n;c[p+16>>2]=o;a[p+20>>0]=q&1;RI(2677136)|0;Qqh(c[(c[669307]|0)+64>>2]|0,p);RI(2677136)|0;q=c[(c[669307]|0)+64>>2]|0;c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]=p;k=k+1|0;p=((k|0)<0)<<31>>31;if(!(p>>>0<0|(p|0)==0&k>>>0<j>>>0))break;else f=f+13|0}l=h+5|0}h=wJf(0,g,l+2|0)|0;RI(1136088)|0;f=Huh(1136088,h)|0;RI(2677136)|0;c[(c[669307]|0)+60>>2]=f;if(h){f=0;j=l+6|0;while(1){l=(d[g+(j+1)>>0]<<8|d[g+j>>0])&65535;RI(2677136)|0;k=c[(c[669307]|0)+60>>2]|0;b[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,f)|0)>>1]=l;f=f+1|0;l=((f|0)<0)<<31>>31;if(!(l>>>0<0|(l|0)==0&f>>>0<h>>>0))break;else j=j+2|0}}RI(2677136)|0;a[(c[669307]|0)+72>>0]=1;i=e;return}function vJf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+4|0;e=a;c[d>>2]=0;c[e>>2]=0;f=R$f(Y$f(0)|0,b,d,e)|0;i=a;return f|0}function wJf(a,b,c){a=a|0;b=b|0;c=c|0;return (d[b+(c+1)>>0]|0)<<8|(d[b+c>>0]|0)|(d[b+(c+2)>>0]|0)<<16|(d[b+(c+3)>>0]|0)<<24|0}function xJf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;e=0;while(1){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if((e|0)>=(c[(c[(c[669307]|0)+64>>2]|0)+12>>2]|0)){f=0;g=11;break}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;h=c[(c[669307]|0)+64>>2]|0;if((c[(c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,e)|0)>>2]|0)+8>>2]|0)==(d|0)){j=e;break}else e=e+1|0}if((g|0)==11){i=b;return f|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;g=c[(c[669307]|0)+64>>2]|0;f=c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,j)|0)>>2]|0;i=b;return f|0}function yJf(d,f,g,h,j){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+32|0;k=d+8|0;l=d+16|0;m=d+20|0;n=d+24|0;o=d+4|0;p=d;q=d+12|0;ehh();RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;Buh(2713640)}RI(2713640)|0;r=qL(2713640)|0;$Lf(r);RI(2713640)|0;s=qL(2713640)|0;$Lf(s);RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(c[(c[669307]|0)+60>>2]|0){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(c[(c[(c[669307]|0)+60>>2]|0)+12>>2]|0){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;t=(c[(c[669307]|0)+60>>2]|0)+16|0}else t=0}else t=0;u=c[g+12>>2]|0;v=c[g+16>>2]|0;g=v+u|0;a:do if((v|0)>0){w=u;while(1){x=w+1|0;y=(e[t+(w<<1)>>1]|0)+65535&65535;if((y|0)==2){z=x;while(1){A=z+1|0;if(!(b[t+(z<<1)>>1]|0)){B=A;C=z;break}else z=A}RI(1136088)|0;z=C-x|0;A=Huh(1136088,z)|0;RI(2898976)|0;if(!(a[2899124]|0)){RI(2898976)|0;Buh(2898976)}c[m>>2]=t+(x<<1);c[k+0>>2]=c[m+0>>2];F5f(0,k,A,0,z);z=B;while(1){D=z+1|0;if(!(b[t+(z<<1)>>1]|0)){E=D;F=z;break}else z=D}if(!(a[2540708]|0))Buh(2540560);qL(2540560)|0;z=zwf(0,t,B,F-B|0)|0;RI(2675400)|0;D=qL(2675400)|0;c[D+8>>2]=A;c[D+12>>2]=z;c[D+16>>2]=0;Erh(2714056,r,D)|0;G=E}else if(!y){D=x;while(1){z=D+1|0;if(!(b[t+(D<<1)>>1]|0)){H=z;I=D;break}else D=z}RI(1136088)|0;D=I-x|0;A=Huh(1136088,D)|0;RI(2898976)|0;if(!(a[2899124]|0)){RI(2898976)|0;Buh(2898976)}c[l>>2]=t+(x<<1);c[k+0>>2]=c[l+0>>2];F5f(0,k,A,0,D);RI(1159264)|0;D=Huh(1159264,4)|0;z=D+16|0;J=(c[D>>2]|0)+120|0;a[z>>0]=b[t+(H<<1)>>1];a[z+(c[J>>2]|0)>>0]=b[t+(I+2<<1)>>1];a[z+(c[(c[D>>2]|0)+120>>2]<<1)>>0]=b[t+(I+3<<1)>>1];a[z+((c[(c[D>>2]|0)+120>>2]|0)*3|0)>>0]=b[t+(I+4<<1)>>1];RI(2675400)|0;z=qL(2675400)|0;c[z+8>>2]=A;c[z+12>>2]=0;c[z+16>>2]=D;Erh(2714056,r,z)|0;G=I+6|0}else if((y|0)==1){RI(2676296)|0;z=qL(2676296)|0;D=b[t+((w<<1)+4)>>1]&255;a[z+8>>0]=b[t+(x<<1)>>1];a[z+9>>0]=D;Erh(2714056,s,z)|0;G=w+3|0}else{K=w;break}if((G|0)<(g|0))w=G;else break a}c[n>>2]=Aqh(2686456,f)|0;RI(2540224)|0;w=pL(2540224,n)|0;z=Fqh(2686792,f)|0;c[o>>2]=K;RI(2540224)|0;D=pL(2540224,o)|0;if(a[2540708]|0){L=c[887694]|0;M=bwf(0,L,w,z,D)|0;RI(3100016)|0;N=qL(3100016)|0;mug(N,M);Auh(N)}Buh(2540560);L=c[887694]|0;M=bwf(0,L,w,z,D)|0;RI(3100016)|0;N=qL(3100016)|0;mug(N,M);Auh(N)}while(0);RI(2675816)|0;if(!(a[2675964]|0)){RI(2675816)|0;Buh(2675816)}RI(2675816)|0;Irh(2714952,r,c[c[668977]>>2]|0);RI(2676656)|0;if(!(a[2676804]|0)){RI(2676656)|0;Buh(2676656)}RI(2676656)|0;Irh(2714952,s,c[c[669187]>>2]|0);RI(2540728)|0;if(a[2540876]|0){c[p>>2]=3443424;c[k+0>>2]=c[p+0>>2];O=npf(0,k)|0;P=Uuh(2715064,r,O)|0;RI(1189360)|0;Q=vL(P,1189360)|0;c[h>>2]=Q;c[q>>2]=3443464;c[k+0>>2]=c[q+0>>2];R=npf(0,k)|0;S=Uuh(2715064,s,R)|0;RI(1189824)|0;T=vL(S,1189824)|0;c[j>>2]=T;i=d;return}RI(2540728)|0;Buh(2540728);c[p>>2]=3443424;c[k+0>>2]=c[p+0>>2];O=npf(0,k)|0;P=Uuh(2715064,r,O)|0;RI(1189360)|0;Q=vL(P,1189360)|0;c[h>>2]=Q;c[q>>2]=3443464;c[k+0>>2]=c[q+0>>2];R=npf(0,k)|0;S=Uuh(2715064,s,R)|0;RI(1189824)|0;T=vL(S,1189824)|0;c[j>>2]=T;i=d;return}function zJf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;k=b;c[k>>2]=0;fhh();if(!d){i=b;return}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(!(c[(c[669307]|0)+76>>2]|0)){RI(1838080)|0;l=qL(1838080)|0;dJe(l,4);bsh(1837968,l,c[887754]|0,0);bsh(1837968,l,c[887756]|0,1);bsh(1837968,l,c[887758]|0,2);bsh(1837968,l,c[887760]|0,3);RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[(c[669307]|0)+76>>2]=l}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(!(dsh(1839256,c[(c[669307]|0)+76>>2]|0,d,k)|0)){i=b;return}d=c[k>>2]|0;if(!d){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+24>>2];RI(2677136)|0;c[g>>2]=c[(c[669307]|0)+40>>2];RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;c[e>>2]=c[(c[669349]|0)+20>>2];i=b;return}else if((d|0)==3){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+36>>2];RI(2677136)|0;c[g>>2]=c[(c[669307]|0)+52>>2];RI(2677136)|0;c[j>>2]=c[(c[669307]|0)+56>>2];RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;c[e>>2]=c[(c[669349]|0)+24>>2];RI(2677304)|0;c[h>>2]=c[(c[669349]|0)+24>>2];i=b;return}else if((d|0)==2){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+32>>2];RI(2677136)|0;c[g>>2]=c[(c[669307]|0)+48>>2];RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;c[e>>2]=c[(c[669349]|0)+24>>2];i=b;return}else if((d|0)==1){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+28>>2];RI(2677136)|0;c[g>>2]=c[(c[669307]|0)+44>>2];RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;c[e>>2]=c[(c[669349]|0)+24>>2];i=b;return}else{i=b;return}}function AJf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;e=kJf(c[(c[669349]|0)+4>>2]|0,d)|0;RI(2677136)|0;i=b;return a[(c[(c[669307]|0)+8>>2]|0)+e>>0]|0}function BJf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;e=kJf(c[(c[669349]|0)+8>>2]|0,d)|0;RI(2677136)|0;i=b;return a[(c[(c[669307]|0)+12>>2]|0)+e>>0]|0}function CJf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;e=kJf(c[(c[669349]|0)+12>>2]|0,d)|0;RI(2677136)|0;i=b;return a[(c[(c[669307]|0)+16>>2]|0)+e>>0]|0}function DJf(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;e=kJf(c[(c[669349]|0)+16>>2]|0,d)|0;RI(2677136)|0;i=b;return a[(c[(c[669307]|0)+20>>2]|0)+e>>0]|0}function EJf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;if(!d){f=0;i=b;return f|0}if(e&1){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Buh(2540392)}if(!((nuf(0,d&65535)|0)!=29&(d+-55424|0)>>>0>767)){f=1;i=b;return f|0}}RI(2677304)|0;if(!(a[2677452]|0)){RI(2677304)|0;Buh(2677304)}RI(2677304)|0;g=kJf(c[c[669349]>>2]|0,d)|0;if((g|0)<0){f=0;i=b;return f|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;f=(a[(c[(c[669307]|0)+4>>2]|0)+g>>0]&e)<<24>>24!=0;i=b;return f|0}function FJf(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}d=EJf(0,c,4)|0;i=b;return d|0}function GJf(a,b){a=a|0;b=b|0;return ((b+-12353|0)>>>0>83?b:b+96|0)|0}function HJf(a,b){a=a|0;b=b|0;var c=0;a=i;a:do if((b|0)>8591){if((b|0)>=65281){if((b|0)<=65374){c=b+-65248|0;break}switch(b|0){case 65506:{c=172;break a;break}case 65509:{c=165;break a;break}case 65505:{c=163;break a;break}case 65507:{c=175;break a;break}case 65508:{c=166;break a;break}case 65510:{c=8361;break a;break}case 65504:{c=162;break a;break}default:{c=b;break a}}}if((b|0)<13055){if((b|0)<=8595){c=b+56921|0;break}if((b|0)>9473){if((b|0)<=9675)if((b|0)==9632){c=65517;break}else if((b|0)==9474){c=65512;break}else if((b|0)==9675){c=65518;break}else{c=b;break}if((b|0)>12287){if((b|0)>12592)if((b|0)>12643){c=(b|0)==12644?65440:b;break}else{c=b+52848|0;break}if((b|0)==12289){c=65380;break}else if((b|0)==12288){c=32;break}else if((b|0)!=12290)if((b|0)==12539){c=65381;break}else if((b|0)==12300){c=65378;break}else if((b|0)==12301){c=65379;break}else{c=b;break}else{c=65377;break}}else c=b}else c=b}else c=b}else c=b;while(0);i=a;return c|0}function IJf(a,b){a=a|0;b=b|0;var c=0;a=i;do if((b&65535)>12352)if((b+154<<16>>16&65535)>55)if((b&65535)<13056){if((b&65535)<=12444){c=(b&65535)<12441;break}if((b&65535)>12543){i=a;return (b+-13008<<16>>16&65535)<47|0}else{c=b<<16>>16!=12539;break}}else c=0;else c=1;else c=0;while(0);i=a;return c|0}function JJf(a,b){a=a|0;b=b|0;return (b+154<<16>>16&65535)<56|0}function KJf(a,b){a=a|0;b=b|0;return (b+-12353<<16>>16&65535)<84|0}function LJf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=i;c=b&65535;a:do if((b+153<<16>>16&65535)>8){if((b+-12353<<16>>16&65535)<=184){d=c+53183|0;if((d&65535)>>>0<9?(341>>>(d&511)&1)!=0:0){e=1;break}d=c+53087|0;if((d&65535)>>>0<9?(341>>>(d&511)&1)!=0:0){e=1;break}d=c+53117&65535;if((d|0)==2|(d|0)==4|(d|0)==0){e=1;break}d=c+53021&65535;if((d|0)==2|(d|0)==4|(d|0)==0){e=1;break}switch(b<<16>>16){case 12526:case 12483:case 12430:case 12387:case 12534:case 12533:{e=1;break a;break}default:{}}}e=0}else e=1;while(0);i=a;return e|0}function MJf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;k=c[(c[669307]|0)+68>>2]|0;Jag(0,k);RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}NJf(0,d,0,f,g,0,j);zJf(0,d,e,f,g,h,j);Kag(0,k);i=b;return}function NJf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;h=i;i=i+16|0;e=h;c[e>>2]=0;ghh();if((d|0)==0|(nzg(0)|0)^1){i=h;return}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(!(c[(c[669307]|0)+80>>2]|0)){RI(1838080)|0;b=qL(1838080)|0;dJe(b,4);bsh(1837968,b,c[887776]|0,0);bsh(1837968,b,c[887778]|0,1);bsh(1837968,b,c[887780]|0,2);bsh(1837968,b,c[887782]|0,3);RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[(c[669307]|0)+80>>2]=b}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(!(dsh(1839256,c[(c[669307]|0)+80>>2]|0,d,e)|0)){i=h;return}b=c[e>>2]|0;if(!b){k=c[887784]|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+24>>2];RI(2677136)|0;l=c[(c[669307]|0)+40>>2]|0;c[g>>2]=l;m=l;n=k}else if((b|0)==1){k=c[887786]|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+28>>2];RI(2677136)|0;l=c[(c[669307]|0)+44>>2]|0;c[g>>2]=l;m=l;n=k}else if((b|0)==3){k=c[887790]|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+36>>2];RI(2677136)|0;l=c[(c[669307]|0)+52>>2]|0;c[g>>2]=l;m=l;n=k}else if((b|0)==2){b=c[887788]|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[f>>2]=c[(c[669307]|0)+32>>2];RI(2677136)|0;k=c[(c[669307]|0)+48>>2]|0;c[g>>2]=k;m=k;n=b}else{i=h;return}if(!n){i=h;return}if(m){i=h;return}if(!(a[2540708]|0))Buh(2540560);m=_vf(0,c[887792]|0,n)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}b=vJf(0,m)|0;RI(2604248)|0;if((b|0)==(c[c[651085]>>2]|0)){i=h;return}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}m=wJf(0,b,1)|0;c[f>>2]=b+5;c[g>>2]=b+(m+5);RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;if(!(c[(c[669307]|0)+84>>2]|0)){RI(1838080)|0;m=qL(1838080)|0;dJe(m,4);bsh(1837968,m,c[887794]|0,0);bsh(1837968,m,c[887796]|0,1);bsh(1837968,m,c[887798]|0,2);bsh(1837968,m,c[887800]|0,3);RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[(c[669307]|0)+84>>2]=m}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;do if(dsh(1839256,c[(c[669307]|0)+84>>2]|0,d,e)|0){m=c[e>>2]|0;if((m|0)==1){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}b=c[f>>2]|0;RI(2677136)|0;c[(c[669307]|0)+28>>2]=b;b=c[g>>2]|0;RI(2677136)|0;c[(c[669307]|0)+44>>2]=b;break}else if((m|0)==2){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}b=c[f>>2]|0;RI(2677136)|0;c[(c[669307]|0)+32>>2]=b;b=c[g>>2]|0;RI(2677136)|0;c[(c[669307]|0)+48>>2]=b;break}else if(!m){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}b=c[f>>2]|0;RI(2677136)|0;c[(c[669307]|0)+24>>2]=b;b=c[g>>2]|0;RI(2677136)|0;c[(c[669307]|0)+40>>2]=b;break}else if((m|0)==3){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}m=c[f>>2]|0;RI(2677136)|0;c[(c[669307]|0)+36>>2]=m;m=c[g>>2]|0;RI(2677136)|0;c[(c[669307]|0)+52>>2]=m;break}else break}while(0);if(!(a[2540708]|0))Buh(2540560);if(Iwf(0,n,c[887802]|0)|0){i=h;return}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}n=vJf(0,c[887804]|0)|0;RI(2604248)|0;if((n|0)==(c[c[651085]>>2]|0)){i=h;return}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;Buh(2677136)}RI(2677136)|0;c[(c[669307]|0)+56>>2]=n+5;RI(2677136)|0;c[j>>2]=c[(c[669307]|0)+56>>2];i=h;return}function OJf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function PJf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function QJf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function RJf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;i=i+32|0;b=a+8|0;d=a+16|0;e=a+20|0;f=a+24|0;g=a+4|0;h=a;j=a+12|0;RI(1101728)|0;k=Huh(1101728,3)|0;l=k+16|0;c[l+(c[(c[k>>2]|0)+120>>2]|0)>>2]=40960;c[l+(c[(c[k>>2]|0)+120>>2]<<1)>>2]=63744;RI(1101728)|0;l=Huh(1101728,3)|0;m=l+16|0;c[m>>2]=13312;c[m+(c[(c[l>>2]|0)+120>>2]|0)>>2]=42240;c[m+(c[(c[l>>2]|0)+120>>2]<<1)>>2]=65536;RI(1101728)|0;m=Huh(1101728,6)|0;c[d>>2]=3140040;c[b+0>>2]=c[d+0>>2];Guf(0,m,b);RI(1101728)|0;d=Huh(1101728,6)|0;c[e>>2]=3140080;c[b+0>>2]=c[e+0>>2];Guf(0,d,b);RI(1101728)|0;e=Huh(1101728,6)|0;c[f>>2]=3140120;c[b+0>>2]=c[f+0>>2];Guf(0,e,b);RI(1101728)|0;f=Huh(1101728,6)|0;c[g>>2]=3140160;c[b+0>>2]=c[g+0>>2];Guf(0,f,b);RI(1101728)|0;g=Huh(1101728,4)|0;n=g+16|0;c[n+(c[(c[g>>2]|0)+120>>2]|0)>>2]=7680;c[n+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=12288;c[n+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=64256;RI(1101728)|0;n=Huh(1101728,4)|0;c[h>>2]=3140200;c[b+0>>2]=c[h+0>>2];Guf(0,n,b);RI(1101728)|0;h=Huh(1101728,4)|0;o=h+16|0;c[o+(c[(c[h>>2]|0)+120>>2]|0)>>2]=7680;c[o+(c[(c[h>>2]|0)+120>>2]<<1)>>2]=12288;c[o+((c[(c[h>>2]|0)+120>>2]|0)*3|0)>>2]=64256;RI(1101728)|0;o=Huh(1101728,4)|0;c[j>>2]=3140240;c[b+0>>2]=c[j+0>>2];Guf(0,o,b);RI(1101728)|0;b=Huh(1101728,3)|0;j=b+16|0;c[j>>2]=12544;c[j+(c[(c[b>>2]|0)+120>>2]|0)>>2]=19968;c[j+(c[(c[b>>2]|0)+120>>2]<<1)>>2]=59392;RI(1101728)|0;j=Huh(1101728,3)|0;p=j+16|0;c[p>>2]=13312;c[p+(c[(c[j>>2]|0)+120>>2]|0)>>2]=40960;c[p+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=65536;RI(1101728)|0;p=Huh(1101728,3)|0;q=p+16|0;c[q>>2]=12544;c[q+(c[(c[p>>2]|0)+120>>2]|0)>>2]=19968;c[q+(c[(c[p>>2]|0)+120>>2]<<1)>>2]=63744;RI(1101728)|0;q=Huh(1101728,3)|0;r=q+16|0;c[r>>2]=13312;c[r+(c[(c[q>>2]|0)+120>>2]|0)>>2]=40960;c[r+(c[(c[q>>2]|0)+120>>2]<<1)>>2]=64256;RI(2674288)|0;r=qL(2674288)|0;jJf(r,k,l,-1,-1);RI(2677304)|0;c[c[669349]>>2]=r;RI(2674288)|0;r=qL(2674288)|0;jJf(r,m,d,0,0);RI(2677304)|0;c[(c[669349]|0)+4>>2]=r;RI(2674288)|0;r=qL(2674288)|0;jJf(r,e,f,0,0);RI(2677304)|0;c[(c[669349]|0)+8>>2]=r;RI(2674288)|0;r=qL(2674288)|0;jJf(r,g,n,0,0);RI(2677304)|0;c[(c[669349]|0)+12>>2]=r;RI(2674288)|0;r=qL(2674288)|0;jJf(r,h,o,0,0);RI(2677304)|0;c[(c[669349]|0)+16>>2]=r;RI(2674288)|0;r=qL(2674288)|0;jJf(r,b,j,-1,-1);RI(2677304)|0;c[(c[669349]|0)+20>>2]=r;RI(2674288)|0;r=qL(2674288)|0;jJf(r,p,q,-1,-1);RI(2677304)|0;c[(c[669349]|0)+24>>2]=r;i=a;return}function SJf(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;c[b>>2]=d;c[b+8>>2]=e;c[b+4>>2]=f;c[b+12>>2]=g;c[b+16>>2]=h;c[b+24>>2]=i;c[b+20>>2]=-1;a[b+28>>0]=j&1;return}function TJf(a,b){a=a|0;b=b|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];c[b+20>>2]=c[a+20>>2];c[b+24>>2]=c[a+24>>2];c[b+28>>2]=d[a+28>>0];return}function UJf(b,d){b=b|0;d=d|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[d+20>>2]=c[b+20>>2];c[d+24>>2]=c[b+24>>2];a[d+28>>0]=(c[b+28>>2]|0)!=0&1;return}function VJf(a){a=a|0;return}function WJf(a,b){a=a|0;b=b|0;c[a>>2]=-1;c[a+4>>2]=0;return}function XJf(a,b){a=a|0;b=b|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];return}function YJf(a,b){a=a|0;b=b|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];return}function ZJf(a){a=a|0;return}function _Jf(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=AL(c[a>>2]|0)|0;c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];i=d;return}function $Jf(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=BL(c[a>>2]|0)|0;c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];i=d;return}function aKf(a){a=a|0;var b=0;b=i;zL(c[a>>2]|0);c[a>>2]=0;i=b;return}function bKf(e,f){e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=e+36|0;c[h>>2]=Aqh(2686456,f)|0;c[e+8>>2]=Luh(2686512,f)|0;cKf(0,f,e+24|0,e+16|0,e+20|0,e+32|0,e+28|0);a:do if((Aqh(2686456,f)|0)==127)j=6;else{k=f;while(1){l=Aqh(2686456,k)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}m=xJf(0,l)|0;if(m){n=m;break a}k=gvh(2686568,k)|0;if((Aqh(2686456,k)|0)==127){j=6;break}}}while(0);if((j|0)==6){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}n=xJf(0,127)|0}a[e+12>>0]=a[n+20>>0]|0;j=e+40|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}yJf(0,f,n,j,e+44|0);RI(1159264)|0;n=e+48|0;c[n>>2]=hvh(1159264,96)|0;e=c[j>>2]|0;j=e+12|0;f=c[j>>2]|0;if((f|0)>0){k=e+16|0;m=f;f=0;while(1){l=c[(c[k+(da(c[(c[e>>2]|0)+120>>2]|0,f)|0)>>2]|0)+8>>2]|0;o=l+12|0;if((c[o>>2]|0)<2)p=m;else{q=l+16|0;r=0;do{s=b[q+(da(c[(c[l>>2]|0)+120>>2]|0,r)|0)>>1]|0;t=c[n>>2]|0;u=t+16+(da(c[(c[t>>2]|0)+120>>2]|0,(s&65535)>>>3&65535)|0)|0;a[u>>0]=d[u>>0]|1<<(s&7);r=r+1|0}while((r|0)<(c[o>>2]|0));p=c[j>>2]|0}f=f+1|0;if((f|0)>=(p|0))break;else m=p}}if((c[h>>2]|0)==127){i=g;return}RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}RI(2685712)|0;h=c[(c[(c[671451]|0)+4>>2]|0)+40>>2]|0;p=h+12|0;m=c[p>>2]|0;if((m|0)<=0){i=g;return}f=h+16|0;j=m;m=0;while(1){e=c[(c[f+(da(c[(c[h>>2]|0)+120>>2]|0,m)|0)>>2]|0)+8>>2]|0;k=e+12|0;if((c[k>>2]|0)<2)v=j;else{o=e+16|0;r=0;do{l=b[o+(da(c[(c[e>>2]|0)+120>>2]|0,r)|0)>>1]|0;q=c[n>>2]|0;s=q+16+(da(c[(c[q>>2]|0)+120>>2]|0,(l&65535)>>>3&65535)|0)|0;a[s>>0]=d[s>>0]|1<<(l&7);r=r+1|0}while((r|0)<(c[k>>2]|0));v=c[p>>2]|0}m=m+1|0;if((m|0)>=(v|0))break;else j=v}i=g;return}function cKf(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;b=i;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}j=Fqh(2686792,fKf(0,c)|0)|0;RI(2677136)|0;if(a[2677284]|0){MJf(0,j,d,e,f,g,h);i=b;return}RI(2677136)|0;fvh(2677136);MJf(0,j,d,e,f,g,h);i=b;return}function dKf(b){b=b|0;var d=0,e=0;b=i;hhh();d=urg(0,c[887846]|0)|0;if(!(a[2540708]|0))fvh(2540560);e=gpf(0,d,c[887848]|0)|0;RI(2685712)|0;a[c[671451]>>0]=e&1;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}e=eKf(0)|0;RI(2685712)|0;d=qL(2685712)|0;bKf(d,e);RI(2685712)|0;c[(c[671451]|0)+4>>2]=d;i=b;return}function eKf(b){b=b|0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}RI(2686624)|0;i=b;return c[(c[671679]|0)+16>>2]|0}function fKf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a=i;if(!(gvh(2686568,b)|0)){c=b;i=a;return c|0}else{d=b;e=b}while(1){if((Aqh(2686456,gvh(2686568,d)|0)|0)==127){c=e;f=4;break}e=gvh(2686568,d)|0;if(!(gvh(2686568,e)|0)){c=e;f=4;break}else d=e}if((f|0)==4){i=a;return c|0}return 0}function gKf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)>=12288?(f=b+16|0,(c[f>>2]|0)!=0):0){g=kJf(c[b+24>>2]|0,d)|0;if((g|0)>-1){h=a[(c[f>>2]|0)+g>>0]|0;i=e;return h|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}h=AJf(0,d)|0;i=e;return h|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}h=AJf(0,d)|0;i=e;return h|0}function hKf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)>=12288?(f=b+20|0,(c[f>>2]|0)!=0):0){g=kJf(c[b+24>>2]|0,d)|0;if((g|0)>-1){h=a[(c[f>>2]|0)+g>>0]|0;i=e;return h|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}h=BJf(0,d)|0;i=e;return h|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}h=BJf(0,d)|0;i=e;return h|0}function iKf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if((e|0)==3){g=0;i=f;return g|0}else if((e|0)==4){g=5;i=f;return g|0}else{if((d|0)>=12288?(e=b+28|0,(c[e>>2]|0)!=0):0){h=kJf(c[b+32>>2]|0,d)|0;if((h|0)>-1?(j=a[(c[e>>2]|0)+h>>0]|0,j<<24>>24!=0):0){g=j;i=f;return g|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}j=CJf(0,d)|0;h=c[b+44>>2]|0;b=c[h+12>>2]|0;if((b|0)<=0){g=j;i=f;return g|0}e=c[(c[h>>2]|0)+120>>2]|0;k=0;while(1){l=c[h+16+(da(e,k)|0)>>2]|0;m=a[l+8>>0]|0;if(m<<24>>24==j<<24>>24){n=l;break}k=k+1|0;if(!((m&255)<=(j&255)&(k|0)<(b|0))){g=j;o=17;break}}if((o|0)==17){i=f;return g|0}g=a[n+9>>0]|0;i=f;return g|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}g=CJf(0,d)|0;i=f;return g|0}return 0}function jKf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;if(d&16){e=1;i=b;return e|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}e=JJf(0,c&65535)|0;i=b;return e|0}function kKf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=lKf(0,d,e,f,c[b+40>>2]|0)|0;if(h){j=h;i=g;return j|0}if((c[b+36>>2]|0)==127){j=0;i=g;return j|0}RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}RI(2685712)|0;j=lKf(0,d,e,f,c[(c[(c[671451]|0)+4>>2]|0)+40>>2]|0)|0;i=g;return j|0}function lKf(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a=i;j=h+12|0;if((c[j>>2]|0)<=0){k=0;i=a;return k|0}l=h+16|0;m=g-f|0;g=0;a:while(1){n=c[l+(da(c[(c[h>>2]|0)+120>>2]|0,g)|0)>>2]|0;o=n+8|0;p=c[o>>2]|0;q=Wof(d,f)|0;r=(e[p+16>>1]|0)-(q&65535)|0;if((r|0)>=1){k=0;s=11;break}b:do if((r|0)>-1?(q=c[o>>2]|0,p=q+12|0,t=c[p>>2]|0,(m|0)>=(t|0)):0){if((t|0)<=0){k=n;s=11;break a}t=q+16|0;u=0;while(1){v=Wof(d,u+f|0)|0;if(v<<16>>16!=(b[t+(da(c[(c[q>>2]|0)+120>>2]|0,u)|0)>>1]|0))break b;u=u+1|0;if((u|0)>=(c[p>>2]|0)){k=n;s=11;break a}}}while(0);g=g+1|0;if((g|0)>=(c[j>>2]|0)){k=0;s=11;break}}if((s|0)==11){i=a;return k|0}return 0}function mKf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;h=nKf(0,d,e,f,c[b+40>>2]|0)|0;if(h){j=h;i=g;return j|0}if((c[b+36>>2]|0)==127){j=0;i=g;return j|0}RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}RI(2685712)|0;j=nKf(0,d,e,f,c[(c[(c[671451]|0)+4>>2]|0)+40>>2]|0)|0;i=g;return j|0}function nKf(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;j=d+4|0;k=d;ihh();if((!((f|0)==(g|0)|(g|0)<-1)?(Vof(e)|0)>(f|0):0)?(Vof(e)|0)>(g+1|0):0){l=h+12|0;if((c[l>>2]|0)<=0){m=0;i=d;return m|0}n=h+16|0;o=f-g|0;p=0;a:while(1){q=c[n+(da(c[(c[h>>2]|0)+120>>2]|0,p)|0)>>2]|0;r=c[q+8>>2]|0;s=r+12|0;b:do if((c[s>>2]|0)<=(o|0)?(t=Wof(e,f)|0,u=c[s>>2]|0,v=r+16|0,(b[v+(da(c[(c[r>>2]|0)+120>>2]|0,u+-1|0)|0)>>1]|0)==t<<16>>16):0){if((u|0)<=0){m=q;w=16;break a}t=0;x=f-u|0;while(1){x=x+1|0;u=Wof(e,x)|0;if(u<<16>>16!=(b[v+(da(c[(c[r>>2]|0)+120>>2]|0,t)|0)>>1]|0))break b;t=t+1|0;if((t|0)>=(c[s>>2]|0)){m=q;w=16;break a}}}while(0);p=p+1|0;if((p|0)>=(c[l>>2]|0)){m=0;w=16;break}}if((w|0)==16){i=d;return m|0}}c[j>>2]=f;RI(2540224)|0;f=pL(2540224,j)|0;c[k>>2]=g;RI(2540224)|0;g=pL(2540224,k)|0;if(a[2540708]|0){y=c[887872]|0;z=bwf(0,y,f,g,e)|0;RI(3079856)|0;A=qL(3079856)|0;Grg(A,z);ivh(A)}fvh(2540560);y=c[887872]|0;z=bwf(0,y,f,g,e)|0;RI(3079856)|0;A=qL(3079856)|0;Grg(A,z);ivh(A);return 0}function oKf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!(e&16))g=d;else{RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}h=HJf(0,d)|0;g=(h|0)==0?d:h}if(!(e&268435456))j=g;else j=(Muh(2686848,c[b+8>>2]|0,g&65535)|0)&65535;if(!(e&1))k=j;else k=(Muh(2686848,c[b+8>>2]|0,j&65535)|0)&65535;if(!(e&8)){l=k;i=f;return l|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}l=GJf(0,k)|0;i=f;return l|0}function pKf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;a:do if((b|0)!=8213)if((b+-12293|0)>>>0<53100){if((b|0)>=65148){e=b&-2;if((e|0)==65148){f=1;break}if((e|0)==65438){f=2;break}i=d;return ((b|0)==65392?3:0)|0}if((b|0)<12543){b:do if((b|0)==12542)g=12;else if((b|0)==12541)g=11;else if((b|0)==12540){f=3;break a}else{switch(b|0){case 12446:{g=12;break b;break}case 12337:case 12338:case 12445:{g=11;break b;break}case 12293:{f=4;break a;break}default:{}}f=0;break a}while(0);if((g|0)==11){f=1;break}else if((g|0)==12){f=2;break}}else f=0}else f=0;else f=(c[a+36>>2]|0)==16?3:0;while(0);i=d;return f|0}function qKf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if((c&2|0)!=0|(b|0)==0){d=3;i=a;return d|0}d=(b+-1|0)>>>0>1&(b|0)==3?5:4;i=a;return d|0}function rKf(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;a:do if((d|0)==3){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}g=c&65535;if(IJf(0,g)|0){RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}h=jKf(0,c&65535,e)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}j=KJf(0,g)|0;switch((hKf(b,c)|0)&7|0){case 6:{if(h){k=65397;break a}k=j?12362:12458;break a;break}case 5:{if(h){k=65396;break a}k=j?12360:12456;break a;break}case 2:{if(h){k=65393;break a}k=j?12354:12450;break a;break}case 3:{if(h){k=65394;break a}k=j?12356:12452;break a;break}case 4:{if(h){k=65395;break a}k=j?12358:12454;break a;break}default:{k=c;break a}}}else k=c}else k=c;while(0);i=f;return k|0}function sKf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}e=EJf(0,c,(d<<1&4|d>>>1&2|1)&255)|0;i=b;return e|0}function tKf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;f=c[a+48>>2]|0;a=(b|0)/8|0;if((a|0)>=(c[f+12>>2]|0)){g=1;i=e;return g|0}g=(1<<(((b|0)%8|0)&31)&(d[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,a)|0)>>0]|0)|0)==0;i=e;return g|0}function uKf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=vKf(a,b,0,Vof(b)|0,c)|0;i=d;return e|0}function vKf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;RI(2686904)|0;j=qL(2686904)|0;xKf(j,g,c[b+36>>2]|0,d,(a[b+12>>0]|0)!=0);yKf(b,d,e,f+e|0,j,g);g=zKf(j)|0;i=h;return g|0}function wKf(a,b){a=a|0;b=b|0;return}function xKf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;c[b+72>>2]=f;c[b+80>>2]=e;c[b+84>>2]=d;e=Vof(f)|0;f=b+76|0;j=(d>>>1&1^1)&255;a[f>>0]=j;a[b+77>>0]=g&1;g=b+40|0;d=c[g>>2]|0;if((d|0)!=0?(c[d+12>>2]|0)>=(e|0):0)k=j;else{RI(1159264)|0;c[g>>2]=hvh(1159264,(e<<1)+10|0)|0;k=a[f>>0]|0}do if(k<<24>>24){f=b+44|0;g=c[f>>2]|0;if((g|0)!=0?(c[g+12>>2]|0)>=(e|0):0)break;RI(1159264)|0;c[f>>2]=hvh(1159264,e+10|0)|0}while(0);k=b+48|0;f=c[k>>2]|0;if(!((f|0)!=0?(c[f+12>>2]|0)>=(e|0):0)){RI(1159264)|0;c[k>>2]=hvh(1159264,e+10|0)|0}e=b+52|0;if(!(c[e>>2]|0)){RI(1159264)|0;c[e>>2]=hvh(1159264,10)|0}e=b+56|0;if(!(c[e>>2]|0)){RI(1159264)|0;c[e>>2]=hvh(1159264,10)|0}e=b+60|0;if(!(c[e>>2]|0)){RI(1159264)|0;c[e>>2]=hvh(1159264,10)|0}e=b+64|0;if(!(c[e>>2]|0)){RI(1159264)|0;c[e>>2]=hvh(1159264,10)|0}e=b+68|0;if(c[e>>2]|0){i=h;return}RI(1159264)|0;c[e>>2]=hvh(1159264,10)|0;i=h;return}function yKf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+48|0;k=j+8|0;c[k+0>>2]=c[671768];c[k+4>>2]=c[671769];c[k+8>>2]=c[671770];c[k+12>>2]=c[671771];c[k+16>>2]=c[671772];c[k+20>>2]=c[671773];c[k+24>>2]=c[671774];c[k+28>>2]=c[671775];l=j;c[l>>2]=0;SJf(k,h,0,0,0,0,l,0);if((e|0)>=(f|0)){i=j;return}l=k+20|0;m=k+24|0;k=e;do{e=(Wof(d,k)|0)&65535;n=pKf(b,e)|0;do if(!n){RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}if(sKf(0,e,h)|0)o=k;else{p=oKf(b,e,h)|0;q=kKf(b,d,k,f)|0;if(!q){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}if(!(FJf(0,p)|0))c[l>>2]=p;BKf(b,p,0,g,h);o=k;break}r=c[q+12>>2]|0;if(!r){s=c[m>>2]|0;t=q+16|0;u=c[t>>2]|0;if((c[u+12>>2]|0)>0){v=u;u=0;do{a[s+u>>0]=a[v+16+(da(c[(c[v>>2]|0)+120>>2]|0,u)|0)>>0]|0;u=u+1|0;v=c[t>>2]|0}while((u|0)<(c[v+12>>2]|0))}v=a[s+1>>0]|0;u=a[s>>0]|0;t=a[s+2>>0]|0;if(t<<24>>24==1)w=iKf(b,p,0)|0;else w=t;t=a[s+3>>0]|0;if(t<<24>>24==1){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}x=DJf(0,p)|0}else x=t;CKf(g,u,v,w,x);c[l>>2]=-1}else yKf(b,r,0,Vof(r)|0,g,h);o=k+-1+(c[(c[q+8>>2]|0)+12>>2]|0)|0}}else{v=rKf(b,c[l>>2]|0,n,h)|0;if((v|0)>=0){BKf(b,v,n,g,h);o=k;break}u=c[m>>2]|0;if(!u)o=k;else{t=a[u+1>>0]|0;y=a[u>>0]|0;z=a[u+2>>0]|0;if(z<<24>>24==1)A=iKf(b,v,n)|0;else A=z;z=a[u+3>>0]|0;if(z<<24>>24==1){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}B=DJf(0,v)|0}else B=z;CKf(g,y,t,A,B);o=k}}while(0);k=o+1|0}while((k|0)<(f|0));i=j;return}function zKf(b){b=b|0;var d=0,e=0,f=0;d=i;e=sLf(b)|0;f=b+8|0;a[b+78>>0]=0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;i=d;return e|0}function AKf(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((c|0)>0)PEi(b|0,0,c|0)|0;i=a;return}function BKf(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=c+-13312|0;if(h>>>0<=6581){DKf(e,((h|0)/254|0)+16&255,((h|0)%254|0)+2&255);i=g;return}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}h=c&65535;j=nuf(0,h)|0;if((j|0)==16){EKf(0,c,e);i=g;return}else if((j|0)==17){j=c+-57344|0;CKf(e,((j|0)/254|0)+229&255,((j|0)%254|0)+2&255,0,0);i=g;return}else{j=iKf(b,c,d)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}if(!(IJf(0,h)|0)){k=gKf(b,c)|0;l=hKf(b,c)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}CKf(e,k,l,j,DJf(0,c)|0);i=g;return}l=hKf(b,c)|0;k=gKf(b,c)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}b=DJf(0,c)|0;m=LJf(0,h)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}n=qKf(0,d,f)|0;o=KJf(0,h)|0;FKf(e,k,l,j,b,m,n,o^1,jKf(0,c&65535,f)|0);if((f&2|0)!=0|(d|0)!=2){i=g;return}CKf(e,1,1,1,0);i=g;return}}function CKf(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;k=g<<24>>24==0?2:g;g=h<<24>>24==0?2:h;do if(e<<24>>24!=6){h=b+76|0;l=a[h>>0]|0;m=e<<24>>24==1;if(l<<24>>24!=0&m?(c[b+8>>2]|0)>=1:0){n=c[b+44>>2]|0;o=b+12|0;p=(c[o>>2]|0)+-1|0;c[o>>2]=p;o=(d[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,p)|0)>>0]|0)+(k&255)&255;p=c[b+48>>2]|0;n=b+16|0;q=(c[n>>2]|0)+-1|0;c[n>>2]=q;r=a[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,q)|0)>>0]|0;s=o;t=l;break}if(m){r=g;s=k;t=l}else{u=h;v=9}}else{if(c[b+84>>2]&536870912){u=b+76|0;v=9;break}rLf(b,6,f);i=j;return}while(0);if((v|0)==9){v=b+40|0;h=b+8|0;qLf(0,e,v,h);qLf(0,f,v,h);r=g;s=k;t=a[u>>0]|0}if(t<<24>>24)qLf(0,s,b+44|0,b+12|0);qLf(0,r,b+48|0,b+16|0);i=j;return}function DKf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+40|0;g=b+8|0;qLf(0,-2,f,g);qLf(0,-1,f,g);qLf(0,c,f,g);qLf(0,d,f,g);if(a[b+76>>0]|0)qLf(0,2,b+44|0,b+12|0);qLf(0,2,b+48|0,b+16|0);i=e;return}function EKf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a=i;if((b|0)>55359)if((b&-64|0)==55360){d=55360;e=242;f=62}else{g=(b&-128|0)==56192;d=g?56128:56074;e=g?254:65;f=g?62:63}else{d=55296;e=65;f=(b|0)==55296?62:63}g=b-d|0;CKf(c,((g|0)/254|0)+e&255,((g|0)%254|0)+2&255,f,f);i=a;return}function FKf(a,b,c,d,e,f,g,h,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0;k=i;CKf(a,b,c,d,e);qLf(0,f?-60:-28,a+52|0,a+20|0);qLf(0,g,a+56|0,a+24|0);qLf(0,h?-60:-28,a+60|0,a+28|0);qLf(0,j?-60:-28,a+64|0,a+32|0);i=k;return}function GKf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;i=i+32|0;k=b+20|0;l=b+16|0;m=b+12|0;n=b+8|0;o=b+4|0;p=b;jhh();q=(f|0)<(j|0)?f:j;r=q+e|0;s=q+h|0;if(((h|e|0)>=0?(r|0)<=(Vof(d)|0):0)?(s|0)<=(Vof(g)|0):0){a:do if((q|0)>0){t=e;u=h;while(1){v=Wof(d,t)|0;if(v<<16>>16!=(Wof(g,u)|0)<<16>>16){w=t;x=u;break}t=t+1|0;u=u+1|0;if(!((t|0)<(r|0)&(u|0)<(s|0)))break a}u=Wof(d,w)|0;y=(u&65535)-((Wof(g,x)|0)&65535)&65535;i=b;return y|0}while(0);if((f|0)==(j|0)){y=0;i=b;return y|0}y=(q|0)==(f|0)?-1:1;i=b;return y|0}RI(1086352)|0;y=hvh(1086352,6)|0;c[k>>2]=e;RI(2540224)|0;e=pL(2540224,k)|0;Qqh(y,e);k=y+16|0;c[k>>2]=e;c[l>>2]=h;RI(2540224)|0;h=pL(2540224,l)|0;Qqh(y,h);c[k+(c[(c[y>>2]|0)+120>>2]|0)>>2]=h;c[m>>2]=f;RI(2540224)|0;f=pL(2540224,m)|0;Qqh(y,f);c[k+(c[(c[y>>2]|0)+120>>2]<<1)>>2]=f;c[n>>2]=j;RI(2540224)|0;j=pL(2540224,n)|0;Qqh(y,j);c[k+((c[(c[y>>2]|0)+120>>2]|0)*3|0)>>2]=j;c[o>>2]=Vof(d)|0;RI(2540224)|0;d=pL(2540224,o)|0;Qqh(y,d);c[k+(c[(c[y>>2]|0)+120>>2]<<2)>>2]=d;c[p>>2]=Vof(g)|0;RI(2540224)|0;g=pL(2540224,p)|0;Qqh(y,g);c[k+((c[(c[y>>2]|0)+120>>2]|0)*5|0)>>2]=g;if(a[2540708]|0){z=c[887920]|0;A=cwf(0,z,y)|0;RI(3079856)|0;B=qL(3079856)|0;Grg(B,A);ivh(B)}fvh(2540560);z=c[887920]|0;A=cwf(0,z,y)|0;RI(3079856)|0;B=qL(3079856)|0;Grg(B,A);ivh(B);return 0}function HKf(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;n=i;i=i+48|0;o=n;p=n+16|0;q=n+28|0;r=n+4|0;s=n+32|0;t=n+36|0;u=n+12|0;v=n+24|0;w=n+20|0;x=n+8|0;khh();a[k>>0]=0;a[l>>0]=0;y=(f|0)<(j|0)?f:j;z=y+e|0;A=y+h|0;if(((h|e|0)>=0?(z|0)<=(Vof(d)|0):0)?(A|0)<=(Vof(g)|0):0){a:do if((y|0)>0){B=e;C=h;while(1){D=Wof(d,B)|0;if(D<<16>>16!=(Wof(g,C)|0)<<16>>16){E=B;F=C;break}B=B+1|0;C=C+1|0;if(!((B|0)<(z|0)&(C|0)<(A|0)))break a}if(m){G=-1;i=n;return G|0}C=gKf(b,(Wof(d,E)|0)&65535)|0;B=gKf(b,(Wof(g,F)|0)&65535)|0;if(C<<24>>24==B<<24>>24){D=hKf(b,(Wof(d,E)|0)&65535)|0;H=(D&255)-((hKf(b,(Wof(g,F)|0)&65535)|0)&255)|0}else H=(C&255)-(B&255)|0;if(H){G=H;i=n;return G|0}B=Wof(d,E)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}C=DJf(0,B&65535)|0;B=DJf(0,(Wof(g,F)|0)&65535)|0;if(C<<24>>24!=B<<24>>24){G=(C&255)-(B&255)|0;i=n;return G|0}RI(1086352)|0;B=hvh(1086352,6)|0;Qqh(B,d);C=B+16|0;c[C>>2]=d;Qqh(B,g);c[C+(c[(c[B>>2]|0)+120>>2]|0)>>2]=g;c[u>>2]=e;RI(2540224)|0;D=pL(2540224,u)|0;Qqh(B,D);c[C+(c[(c[B>>2]|0)+120>>2]<<1)>>2]=D;c[v>>2]=z;RI(2540224)|0;D=pL(2540224,v)|0;Qqh(B,D);c[C+((c[(c[B>>2]|0)+120>>2]|0)*3|0)>>2]=D;c[w>>2]=h;RI(2540224)|0;D=pL(2540224,w)|0;Qqh(B,D);c[C+(c[(c[B>>2]|0)+120>>2]<<2)>>2]=D;c[x>>2]=A;RI(2540224)|0;D=pL(2540224,x)|0;Qqh(B,D);c[C+((c[(c[B>>2]|0)+120>>2]|0)*5|0)>>2]=D;if(a[2540708]|0){I=c[887962]|0;J=cwf(0,I,B)|0;RI(3079856)|0;K=qL(3079856)|0;Grg(K,J);ivh(K)}fvh(2540560);I=c[887962]|0;J=cwf(0,I,B)|0;RI(3079856)|0;K=qL(3079856)|0;Grg(K,J);ivh(K)}while(0);a[k>>0]=(f|0)<=(j|0)&1;a[l>>0]=(f|0)>=(j|0)&1;if((f|0)==(j|0)){G=0;i=n;return G|0}G=(y|0)==(f|0)?-1:1;i=n;return G|0}RI(1086352)|0;G=hvh(1086352,6)|0;c[o>>2]=e;RI(2540224)|0;e=pL(2540224,o)|0;Qqh(G,e);o=G+16|0;c[o>>2]=e;c[p>>2]=h;RI(2540224)|0;h=pL(2540224,p)|0;Qqh(G,h);c[o+(c[(c[G>>2]|0)+120>>2]|0)>>2]=h;c[q>>2]=f;RI(2540224)|0;f=pL(2540224,q)|0;Qqh(G,f);c[o+(c[(c[G>>2]|0)+120>>2]<<1)>>2]=f;c[r>>2]=j;RI(2540224)|0;j=pL(2540224,r)|0;Qqh(G,j);c[o+((c[(c[G>>2]|0)+120>>2]|0)*3|0)>>2]=j;c[s>>2]=Vof(d)|0;RI(2540224)|0;d=pL(2540224,s)|0;Qqh(G,d);c[o+(c[(c[G>>2]|0)+120>>2]<<2)>>2]=d;c[t>>2]=Vof(g)|0;RI(2540224)|0;g=pL(2540224,t)|0;Qqh(G,g);c[o+((c[(c[G>>2]|0)+120>>2]|0)*5|0)>>2]=g;if(a[2540708]|0){L=c[887960]|0;M=cwf(0,L,G)|0;RI(3079856)|0;N=qL(3079856)|0;Grg(N,M);ivh(N)}fvh(2540560);L=c[887960]|0;M=cwf(0,L,G)|0;RI(3079856)|0;N=qL(3079856)|0;Grg(N,M);ivh(N);return 0}function IKf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=i;i=i+32|0;k=b+20|0;l=b+16|0;m=b+12|0;n=b+8|0;o=b+4|0;p=b;lhh();q=(f|0)<(j|0)?f:j;r=q+e|0;s=q+h|0;if(((h|e|0)>=0?(r|0)<=(Vof(d)|0):0)?(s|0)<=(Vof(g)|0):0){RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}RI(2685712)|0;a:do if((q|0)>0){t=c[(c[(c[671451]|0)+4>>2]|0)+8>>2]|0;u=e;v=h;while(1){w=Muh(2686848,t,Wof(d,u)|0)|0;if(w<<16>>16!=(Muh(2686848,t,Wof(g,v)|0)|0)<<16>>16){x=u;y=v;break}u=u+1|0;v=v+1|0;if(!((u|0)<(r|0)&(v|0)<(s|0)))break a}v=Muh(2686848,t,Wof(d,x)|0)|0;z=(v&65535)-((Muh(2686848,t,Wof(g,y)|0)|0)&65535)&65535;i=b;return z|0}while(0);if((f|0)==(j|0)){z=0;i=b;return z|0}z=(q|0)==(f|0)?-1:1;i=b;return z|0}RI(1086352)|0;z=hvh(1086352,6)|0;c[k>>2]=e;RI(2540224)|0;e=pL(2540224,k)|0;Qqh(z,e);k=z+16|0;c[k>>2]=e;c[l>>2]=h;RI(2540224)|0;h=pL(2540224,l)|0;Qqh(z,h);c[k+(c[(c[z>>2]|0)+120>>2]|0)>>2]=h;c[m>>2]=f;RI(2540224)|0;f=pL(2540224,m)|0;Qqh(z,f);c[k+(c[(c[z>>2]|0)+120>>2]<<1)>>2]=f;c[n>>2]=j;RI(2540224)|0;j=pL(2540224,n)|0;Qqh(z,j);c[k+((c[(c[z>>2]|0)+120>>2]|0)*3|0)>>2]=j;c[o>>2]=Vof(d)|0;RI(2540224)|0;d=pL(2540224,o)|0;Qqh(z,d);c[k+(c[(c[z>>2]|0)+120>>2]<<2)>>2]=d;c[p>>2]=Vof(g)|0;RI(2540224)|0;g=pL(2540224,p)|0;Qqh(z,g);c[k+((c[(c[z>>2]|0)+120>>2]|0)*5|0)>>2]=g;if(a[2540708]|0){A=c[888004]|0;B=cwf(0,A,z)|0;RI(3079856)|0;C=qL(3079856)|0;Grg(C,B);ivh(C)}fvh(2540560);A=c[888004]|0;B=cwf(0,A,z)|0;RI(3079856)|0;C=qL(3079856)|0;Grg(C,B);ivh(C);return 0}function JKf(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+48|0;m=l;n=l+33|0;o=l+32|0;c[m+0>>2]=c[671768];c[m+4>>2]=c[671769];c[m+8>>2]=c[671770];c[m+12>>2]=c[671771];c[m+16>>2]=c[671772];c[m+20>>2]=c[671773];c[m+24>>2]=c[671774];c[m+28>>2]=c[671775];a[n>>0]=0;a[o>>0]=0;if((e|0)==(h|0)&(f|0)==(j|0)?_nf(0,d,g)|0:0){p=0;i=l;return p|0}if((k|0)==268435456){p=IKf(0,d,e,f,g,h,j)|0;i=l;return p|0}else if((k|0)==1073741824){p=GKf(0,d,e,f,g,h,j)|0;i=l;return p|0}else{q=i;i=i+16|0;r=i;i=i+16|0;c[q>>2]=0;c[r>>2]=0;SJf(m,k,0,0,q,r,0,0);r=LKf(b,d,e,f,g,h,j,n,o,1,0,m)|0;if(!r){p=0;i=l;return p|0}p=r>>31|1;i=l;return p|0}return 0}function KKf(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function LKf(b,e,f,g,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0;q=i;i=i+48|0;r=q;s=q+28|0;t=q+8|0;u=r;c[u>>2]=0;c[u+4>>2]=0;c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[s+16>>2]=0;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;u=c[p>>2]|0;v=g+f|0;w=k+j|0;a[l>>0]=0;a[m>>0]=0;WJf(r,0);if((u|0)==0?(a[p+28>>0]|0)!=0:0){x=HKf(b,e,f,g,h,j,k,m,l,o)|0;i=q;return x|0}a:do if(n){b:do if((g|0)>0){y=f;while(1){z=y+1|0;if(!(pKf(b,(Wof(e,y)|0)&65535)|0)){A=y;break b}if((z|0)<(v|0))y=z;else{A=z;break}}}else A=f;while(0);if((k|0)>0){y=j;while(1){z=y+1|0;if(!(pKf(b,(Wof(h,y)|0)&65535)|0)){B=A;C=y;break a}if((z|0)<(w|0))y=z;else{B=A;C=z;break}}}else{B=A;C=j}}else{B=f;C=j}while(0);jvh(2685376,s);jvh(2685376,t);A=p+20|0;k=p+24|0;g=r+4|0;n=(u&536870912|0)!=0;y=s+4|0;z=s+8|0;D=p+12|0;E=(u&2|0)!=0;F=s+12|0;G=s+16|0;H=p+16|0;p=t+8|0;I=t+4|0;J=t+12|0;K=t+16|0;L=b+12|0;M=e;e=h;h=B;N=C;O=f;f=0;P=0;Q=0;R=0;S=B;B=C;C=j;j=v;v=w;w=0;T=5;U=-1;V=-1;c:while(1){W=(h|0)<(j|0);if(W){X=Wof(M,h)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}if(sKf(0,X&65535,u)|0){Y=V;Z=U;_=T;$=w;aa=v;ba=j;ca=C;ea=B;fa=S;ga=R;ha=Q;ia=P;ja=f;ka=O;la=e;ma=M;h=h+1|0;V=Y;U=Z;T=_;w=$;v=aa;j=ba;C=ca;B=ea;S=fa;R=ga;Q=ha;P=ia;f=ja;O=ka;e=la;M=ma;continue}}d:do if((N|0)<(v|0)){X=N;while(1){na=Wof(e,X)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}oa=X+1|0;if(!(sKf(0,na&65535,u)|0)){pa=X;qa=1;break d}if((oa|0)<(v|0))X=oa;else{pa=oa;qa=0;break}}}else{pa=N;qa=0}while(0);if(!W){X=c[s>>2]|0;if(!X){ra=M;sa=e;ta=h;ua=pa;va=W;wa=f;xa=P;ya=Q;za=R;Aa=j;Ba=v;Ca=w;Da=T;Ea=U;Fa=V;Ga=166;break}oa=c[z>>2]|0;na=c[y>>2]|0;Ha=c[F>>2]|0;Ia=c[G>>2]|0;c[s>>2]=0;Y=V;Z=U;_=T;$=w;aa=v;ca=C;ea=B;ga=R;ha=Q;ia=P;ja=f;la=e;M=X;h=na;N=pa;O=oa;S=Ia;j=Ha;V=Y;U=Z;T=_;w=$;v=aa;C=ca;B=ea;R=ga;Q=ha;P=ia;f=ja;e=la;continue}if(!qa){Ha=c[t>>2]|0;if(!Ha){ra=M;sa=e;ta=h;ua=pa;va=W;wa=f;xa=P;ya=Q;za=R;Aa=j;Ba=v;Ca=w;Da=T;Ea=U;Fa=V;Ga=166;break}Ia=c[p>>2]|0;oa=c[I>>2]|0;na=c[J>>2]|0;X=c[K>>2]|0;c[t>>2]=0;Y=V;Z=U;_=T;$=w;ba=j;fa=S;ga=R;ha=Q;ia=P;ja=f;ka=O;ma=M;e=Ha;N=oa;B=X;C=Ia;v=na;V=Y;U=Z;T=_;w=$;j=ba;S=fa;R=ga;Q=ha;P=ia;f=ja;O=ka;M=ma;continue}e:do if((S|0)<(h|0)&(B|0)<(pa|0)){f:do if((pa|0)<(v|0)){na=h;Ia=pa;while(1){X=Wof(M,na)|0;if(X<<16>>16!=(Wof(e,Ia)|0)<<16>>16){Ja=na;Ka=Ia;break f}X=na+1|0;oa=Ia+1|0;if((X|0)<(j|0)&(oa|0)<(v|0)){na=X;Ia=oa}else{Ja=X;Ka=oa;break}}}else{Ja=h;Ka=pa}while(0);if((Ja|0)==(j|0)|(Ka|0)==(v|0)){Y=V;Z=U;_=T;$=w;aa=v;ba=j;ca=C;ea=B;fa=S;ga=R;ha=Q;ia=P;ja=f;ka=O;la=e;ma=M;h=Ja;N=Ka;V=Y;U=Z;T=_;w=$;v=aa;j=ba;C=ca;B=ea;S=fa;R=ga;Q=ha;P=ia;f=ja;O=ka;e=la;M=ma;continue c}Ia=Ka+-1|0;na=Ja;while(1){oa=na+-1|0;X=(oa|0)>(S|0);if(!X){La=oa;Ma=X;break}if((gKf(b,(Wof(M,oa)|0)&65535)|0)<<24>>24==1)na=oa;else{La=oa;Ma=X;break}}g:do if((Ia|0)>(B|0)){na=Ia;while(1){X=na+-1|0;if((gKf(b,(Wof(e,na)|0)&65535)|0)<<24>>24!=1){Na=na;break g}if((X|0)>(B|0))na=X;else{Na=X;break}}}else Na=Ia;while(0);h:do if(Ma){Ia=La;while(1){na=Ia+-1|0;if(tKf(b,(Wof(M,Ia)|0)&65535)|0){Oa=Ia;break h}if((na|0)>(S|0))Ia=na;else{Oa=na;break}}}else Oa=La;while(0);if((Na|0)>(B|0)){Ia=Na;while(1){na=Ia+-1|0;if(tKf(b,(Wof(e,Ia)|0)&65535)|0){Pa=Oa;Qa=Ia;Ra=Ja;Sa=Ka;break e}if((na|0)>(B|0))Ia=na;else{Pa=Oa;Qa=na;Ra=Ja;Sa=Ka;break}}}else{Pa=Oa;Qa=Na;Ra=Ja;Sa=Ka}}else{Pa=h;Qa=pa;Ra=S;Sa=B}while(0);W=oKf(b,(Wof(M,Pa)|0)&65535,u)|0;Ia=oKf(b,(Wof(e,Qa)|0)&65535,u)|0;na=Q;Q=pKf(b,W)|0;na=(Q|0)!=0;do if(na){X=c[A>>2]|0;if((X|0)>-1){Ta=0;Ua=rKf(b,X,Q,u)|0;break}X=c[k>>2]|0;if(!X){Y=V;Z=U;_=T;$=w;aa=v;ba=j;ca=C;ga=R;ia=P;ja=f;ka=O;la=e;ma=M;h=Pa+1|0;N=Qa;Q=Q;S=Ra;B=Sa;V=Y;U=Z;T=_;w=$;v=aa;j=ba;C=ca;R=ga;P=ia;f=ja;O=ka;e=la;M=ma;continue c}else{Ta=X;Ua=W}}else{Ta=0;Ua=W}while(0);W=R;R=pKf(b,Ia)|0;W=(R|0)!=0;do if(W){X=c[r>>2]|0;if((X|0)>-1){Va=0;Wa=rKf(b,X,R,u)|0;break}X=c[g>>2]|0;if(!X){Y=V;Z=U;_=T;$=w;aa=v;ba=j;ca=C;ia=P;ja=f;ka=O;la=e;ma=M;h=Pa;N=Qa+1|0;Q=Q;R=R;S=Ra;B=Sa;V=Y;U=Z;T=_;w=$;v=aa;j=ba;C=ca;P=ia;f=ja;O=ka;e=la;M=ma;continue c}else{Va=X;Wa=Ia}}else{Va=0;Wa=Ia}while(0);Ia=gKf(b,Ua)|0;X=gKf(b,Wa)|0;oa=Ia<<24>>24==6;if(oa){if(n|(T|0)!=5){Xa=f;Ya=U}else{if(!(c[s>>2]|0))Za=Pa-O|0;else Za=(c[y>>2]|0)-(c[z>>2]|0)|0;Ha=hKf(b,Ua)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}Xa=(Ha&255)<<(((DJf(0,Ua)|0)&255)+8&31);Ya=Za}c[A>>2]=Ua;_a=Pa+1|0;$a=Xa;ab=Ya}else{_a=Pa;$a=f;ab=U}Ha=X<<24>>24!=6;if(Ha){bb=Qa;cb=P;db=V}else{if(n|(T|0)!=5){eb=P;fb=V}else{if(!(c[t>>2]|0))gb=Qa-C|0;else gb=(c[I>>2]|0)-(c[p>>2]|0)|0;hb=hKf(b,Wa)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}eb=(hb&255)<<(((DJf(0,Wa)|0)&255)+8&31);fb=gb}c[r>>2]=Wa;bb=Qa+1|0;cb=eb;db=fb}if(oa|Ha^1){if((T|0)!=5){_=T;$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=_a;N=bb;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;U=ab;V=db;T=_;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}Ha=($a|0)==(cb|0);$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=_a;N=bb;f=Ha?0:$a;P=Ha?0:cb;Q=Q;R=R;S=Ra;B=Sa;T=Ha?5:4;U=Ha?-1:ab;V=Ha?-1:db;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}if(na)ib=0;else ib=kKf(b,M,_a,j)|0;do if(!Ta){if(ib){Ha=c[(c[ib+8>>2]|0)+12>>2]|0;oa=ib+16|0;hb=c[oa>>2]|0;if(!hb){if(c[s>>2]|0){jb=0;kb=0;lb=Ha;break}c[s>>2]=M;c[z>>2]=O;c[y>>2]=Ha+Pa;c[F>>2]=j;c[G>>2]=Ra;mb=c[ib+12>>2]|0;_=T;$=w;aa=v;ca=C;la=e;M=mb;h=0;N=bb;O=0;f=$a;P=cb;Q=Q;R=R;S=0;B=Sa;j=Vof(mb)|0;U=ab;V=db;T=_;w=$;v=aa;C=ca;e=la;continue c}mb=c[D>>2]|0;if((c[hb+12>>2]|0)>0){nb=hb;hb=0;do{a[mb+hb>>0]=a[nb+16+(da(c[(c[nb>>2]|0)+120>>2]|0,hb)|0)>>0]|0;hb=hb+1|0;nb=c[oa>>2]|0}while((hb|0)<(c[nb+12>>2]|0))}c[A>>2]=-1;c[k>>2]=mb;jb=mb;kb=0;lb=Ha;break}nb=c[D>>2]|0;a[nb>>0]=Ia;a[nb+1>>0]=hKf(b,Ua)|0;if(!(E|T>>>0<2))a[nb+2>>0]=iKf(b,Ua,Q)|0;do if(T>>>0<3)ob=0;else{RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[nb+3>>0]=DJf(0,Ua)|0;if(T>>>0<4){ob=0;break}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}ob=IJf(0,Ua&65535)|0}while(0);if((Ia&255)<2){jb=nb;kb=ob;lb=1}else{c[A>>2]=Ua;jb=nb;kb=ob;lb=1}}else{jb=Ta;kb=0;lb=1}while(0);if(W)pb=0;else pb=kKf(b,e,bb,v)|0;do if(!Va){if(pb){Ia=c[(c[pb+8>>2]|0)+12>>2]|0;na=Ia+bb|0;Ha=pb+16|0;mb=c[Ha>>2]|0;if(!mb){if(c[t>>2]|0){qb=na;rb=0;sb=0;break}c[t>>2]=e;c[p>>2]=C;c[I>>2]=Ia+Qa;c[J>>2]=v;c[K>>2]=Sa;Ia=c[pb+12>>2]|0;_=T;$=w;ba=j;ka=O;ma=M;e=Ia;h=_a;N=0;f=$a;P=cb;Q=Q;R=R;S=Ra;B=0;C=0;v=Vof(Ia)|0;U=ab;V=db;T=_;w=$;j=ba;O=ka;M=ma;continue c}Ia=c[H>>2]|0;if((c[mb+12>>2]|0)>0){hb=mb;mb=0;do{a[Ia+mb>>0]=a[hb+16+(da(c[(c[hb>>2]|0)+120>>2]|0,mb)|0)>>0]|0;mb=mb+1|0;hb=c[Ha>>2]|0}while((mb|0)<(c[hb+12>>2]|0))}c[r>>2]=-1;c[g>>2]=Ia;qb=na;rb=Ia;sb=0;break}hb=c[H>>2]|0;a[hb>>0]=X;a[hb+1>>0]=hKf(b,Wa)|0;if(!(E|T>>>0<2))a[hb+2>>0]=iKf(b,Wa,R)|0;do if(T>>>0<3)tb=0;else{RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[hb+3>>0]=DJf(0,Wa)|0;if(T>>>0<4){tb=0;break}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}tb=IJf(0,Wa&65535)|0}while(0);if((X&255)>=2)c[r>>2]=Wa;qb=bb+1|0;rb=hb;sb=tb}else{qb=bb+1|0;rb=Va;sb=0}while(0);X=lb+_a|0;i:do if(E){ub=qb;vb=X}else{j:do if((X|0)<(j|0)){W=jb+2|0;Ia=X;while(1){if((gKf(b,(Wof(M,Ia)|0)&65535)|0)<<24>>24!=1){wb=Ia;break j}if(!(a[W>>0]|0))a[W>>0]=2;na=iKf(b,(Wof(M,Ia)|0)&65535,0)|0;a[W>>0]=(d[W>>0]|0)+(na&255);na=Ia+1|0;if((na|0)<(j|0))Ia=na;else{wb=na;break}}}else wb=X;while(0);if((qb|0)>=(v|0)){ub=qb;vb=wb;break}hb=rb+2|0;Ia=qb;while(1){if((gKf(b,(Wof(e,Ia)|0)&65535)|0)<<24>>24!=1){ub=Ia;vb=wb;break i}if(!(a[hb>>0]|0))a[hb>>0]=2;W=iKf(b,(Wof(e,Ia)|0)&65535,0)|0;a[hb>>0]=(d[hb>>0]|0)+(W&255);W=Ia+1|0;if((W|0)<(v|0))Ia=W;else{ub=W;vb=wb;break}}}while(0);X=a[jb>>0]|0;Ia=a[rb>>0]|0;if(X<<24>>24==Ia<<24>>24)xb=(d[jb+1>>0]|0)-(d[rb+1>>0]|0)|0;else xb=(X&255)-(Ia&255)|0;if(xb){x=xb;Ga=196;break}if((T|0)==1){$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;T=1;U=ab;V=db;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}do if(!E){Ia=a[jb+2>>0]|0;X=a[rb+2>>0]|0;if(Ia<<24>>24==X<<24>>24)break;if(o){x=-1;Ga=196;break c}aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;w=(Ia&255)-(X&255)|0;T=(a[L>>0]|0)==0?1:2;U=ab;V=db;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue c}while(0);if((T|0)==2){$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;T=2;U=ab;V=db;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}X=a[jb+3>>0]|0;Ia=a[rb+3>>0]|0;if(X<<24>>24!=Ia<<24>>24)if(o){x=-1;Ga=196;break}else{aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;w=(X&255)-(Ia&255)|0;T=2;U=ab;V=db;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}if((T|0)==3){$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;T=3;U=ab;V=db;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}if(kb^sb){if(o){x=-1;Ga=196;break}aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;w=kb?1:-1;T=3;U=ab;V=db;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}if(!kb){_=T;$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;U=ab;V=db;T=_;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}Ia=Ua&65535;X=LJf(0,Ia)|0;hb=Wa&65535;do if(X^(LJf(0,hb)|0))yb=X?-1:1;else{RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}W=qKf(0,Q,u)|0;na=qKf(0,R,u)|0;if(W<<24>>24!=na<<24>>24){yb=(W&255)-(na&255)|0;break}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}na=KJf(0,Ia)|0;if(na^(KJf(0,hb)|0)){yb=na?1:-1;break}RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}na=jKf(0,Ua&65535,u)|0;if(!(na^(jKf(0,Wa&65535,u)|0))){_=T;$=w;aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;Q=Q;R=R;S=Ra;B=Sa;U=ab;V=db;T=_;w=$;v=aa;j=ba;C=ca;O=ka;e=la;M=ma;continue c}yb=na?-1:1}while(0);if(o){x=-1;Ga=196;break}else{aa=v;ba=j;ca=C;ka=O;la=e;ma=M;h=vb;N=ub;f=$a;P=cb;S=Ra;B=Sa;w=yb;T=3;U=ab;V=db;v=aa;j=ba;C=ca;O=ka;e=la;M=ma}}if((Ga|0)==166){k:do if(va&(ua|0)<(Ba|0)&(((Ca|0)==0|E|Da>>>0<3)^1)){ma=ta;M=ua;la=ya;e=za;ka=Ca;while(1){O=Wof(ra,ma)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}if(!(FJf(0,O&65535)|0)){zb=ma;Ab=M;Bb=ka;break k}O=Wof(sa,M)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}if(!(FJf(0,O&65535)|0)){zb=ma;Ab=M;Bb=ka;break k}O=iKf(b,oKf(b,(Wof(ra,ma)|0)&65535,u)|0,la)|0;ca=iKf(b,oKf(b,(Wof(sa,M)|0)&65535,u)|0,e)|0;C=(O&255)-(ca&255)|0;if(O<<24>>24!=ca<<24>>24){zb=ma;Ab=M;Bb=C;break k}ca=ma+1|0;O=M+1|0;if((ca|0)<(Aa|0)&(O|0)<(Ba|0)){ma=ca;M=O;la=0;e=0;ka=C}else{zb=ca;Ab=O;Bb=C;break}}}else{zb=ta;Ab=ua;Bb=Ca}while(0);Ca=(Bb|0)!=0;l:do if((Da|0)==1&Ca){m:do if((zb|0)<(Aa|0)){ua=zb;while(1){ta=Wof(ra,ua)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}u=ua+1|0;if(!(FJf(0,ta&65535)|0)){Cb=ua;break m}if((u|0)<(Aa|0))ua=u;else{Cb=u;break}}}else Cb=zb;while(0);if((Ab|0)<(Ba|0)){ua=Ab;while(1){u=Wof(sa,ua)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}ta=ua+1|0;if(!(FJf(0,u&65535)|0)){Db=Cb;Eb=ua;break l}if((ta|0)<(Ba|0))ua=ta;else{Db=Cb;Eb=ta;break}}}else{Db=Cb;Eb=Ab}}else{Db=zb;Eb=Ab}while(0);if(!Ca)if((Ea|0)>-1|(Fa|0)<0)if((Fa|0)>-1|(Ea|0)<0){Ca=(Ea|0)==(Fa|0)?wa-xa|0:Ea-Fa|0;if(!Ca){if((Eb|0)==(Ba|0))a[l>>0]=1;if((Db|0)==(Aa|0)){a[m>>0]=1;Fb=0}else Fb=0}else Fb=Ca}else Fb=1;else Fb=-1;else Fb=Bb;if((Db|0)!=(Aa|0)){x=1;i=q;return x|0}x=(Eb|0)==(Ba|0)?Fb:-1;i=q;return x|0}else if((Ga|0)==196){i=q;return x|0}return 0}function MKf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(b^c)d=b?1:-1;else d=0;return d|0}function NKf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=OKf(a,b,c,0,Vof(b)|0,d)|0;i=e;return f|0}function OKf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+32|0;j=h;c[j+0>>2]=c[671768];c[j+4>>2]=c[671769];c[j+8>>2]=c[671770];c[j+12>>2]=c[671771];c[j+16>>2]=c[671772];c[j+20>>2]=c[671773];c[j+24>>2]=c[671774];c[j+28>>2]=c[671775];if(!(Vof(d)|0)){k=1;i=h;return k|0}l=i;i=i+16|0;m=i;i=i+16|0;c[l>>2]=0;c[m>>2]=0;SJf(j,g,0,0,l,m,0,0);k=PKf(a,b,d,e,f,1,j)|0;i=h;return k|0}function PKf(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=j+1|0;l=j;a[k>>0]=0;a[l>>0]=0;LKf(b,c,e,f,d,0,Vof(d)|0,k,l,g,1,h)|0;i=j;return (a[k>>0]|0)!=0|0}function QKf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=Vof(b)|0;g=RKf(a,b,c,f+-1|0,Vof(b)|0,d)|0;i=e;return g|0}function RKf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;if(!(Vof(c)|0)){h=1;i=g;return h|0}j=SKf(a,b,c,d,e,f)|0;if((j|0)<0){h=0;i=g;return h|0}e=Vof(b)|0;h=(JKf(a,b,j,e-j|0,c,0,Vof(c)|0,f)|0)==0;i=g;return h|0}function SKf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+32|0;k=j;c[k+0>>2]=c[671768];c[k+4>>2]=c[671769];c[k+8>>2]=c[671770];c[k+12>>2]=c[671771];c[k+16>>2]=c[671772];c[k+20>>2]=c[671773];c[k+24>>2]=c[671774];c[k+28>>2]=c[671775];if((h|0)==268435456){l=$Kf(b,d,e,f,g)|0;i=j;return l|0}else if((h|0)==1073741824){l=_Kf(0,d,e,f,g)|0;i=j;return l|0}else{m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=m+0|0;s=r+16|0;do{a[r>>0]=0;r=r+1|0}while((r|0)<(s|0));r=n+0|0;s=r+16|0;do{a[r>>0]=0;r=r+1|0}while((r|0)<(s|0));c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;SJf(k,h,m,n,p,q,0,0);l=aLf(b,d,e,f,g,o,k)|0;i=j;return l|0}return 0}function TKf(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;a[g>>0]=1;a:do if(Vof(d)|0)if((Vof(d)|0)<=(f|0)?(a[g>>0]=0,h=e+1+f-(Vof(d)|0)|0,(h|0)>(e|0)):0){j=-1;k=-1;l=e;b:while(1){if((Vof(d)|0)>0){m=j;n=k;o=0}else{p=l;break a}while(1){if((n|0)<(o|0))if(((Wof(d,o)|0)&65535)<128)q=o;else{r=5;break b}else q=n;s=o+l|0;if((m|0)<(s|0))if(((Wof(c,s)|0)&65535)<128)t=s;else{r=8;break b}else t=m;u=Wof(c,s)|0;if(u<<16>>16!=(Wof(d,o)|0)<<16>>16){v=t;w=q;break}o=o+1|0;if((o|0)>=(Vof(d)|0)){p=l;break a}else{m=t;n=q}}u=l+1|0;if((u|0)<(h|0)){j=v;k=w;l=u}else{p=-1;break a}}if((r|0)==5){a[g>>0]=1;p=-1;break}else if((r|0)==8){a[g>>0]=1;p=-1;break}}else p=-1;else p=0;while(0);i=b;return p|0}function UKf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+32|0;l=j;a[k>>0]=0;c[l+0>>2]=c[671768];c[l+4>>2]=c[671769];c[l+8>>2]=c[671770];c[l+12>>2]=c[671771];c[l+16>>2]=c[671772];c[l+20>>2]=c[671773];c[l+24>>2]=c[671774];c[l+28>>2]=c[671775];if((h|0)==268435456){m=WKf(b,d,e,f,g)|0;i=j;return m|0}else if((h|0)==1073741824){m=VKf(0,d,e,f,g)|0;i=j;return m|0}else if((h|0)==0?(n=TKf(0,d,e,f,g,k)|0,(a[k>>0]|0)==0):0){m=n;i=j;return m|0}n=i;i=i+16|0;k=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=n+0|0;s=r+16|0;do{a[r>>0]=0;r=r+1|0}while((r|0)<(s|0));r=k+0|0;s=r+16|0;do{a[r>>0]=0;r=r+1|0}while((r|0)<(s|0));c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;SJf(l,h,n,k,p,q,0,0);m=XKf(b,d,e,f,g,o,l)|0;i=j;return m|0}function VKf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;a=i;a:do if(Vof(c)|0)if((Vof(c)|0)<=(e|0)?(f=d+1+e-(Vof(c)|0)|0,(f|0)>(d|0)):0){g=d;while(1){if((Vof(c)|0)>0)h=0;else{j=g;break a}while(1){k=Wof(b,h+g|0)|0;if(k<<16>>16!=(Wof(c,h)|0)<<16>>16)break;h=h+1|0;if((h|0)>=(Vof(c)|0)){j=g;break a}}g=g+1|0;if((g|0)>=(f|0)){j=-1;break}}}else j=-1;else j=0;while(0);i=a;return j|0}function WKf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(!(Vof(d)|0)){h=0;i=g;return h|0}if((Vof(d)|0)>(f|0)){h=-1;i=g;return h|0}j=e+1+f-(Vof(d)|0)|0;if((j|0)<=(e|0)){h=-1;i=g;return h|0}f=a+8|0;a=e;a:while(1){if((Vof(d)|0)>0)k=0;else{h=a;l=9;break}while(1){e=c[f>>2]|0;m=Muh(2686848,e,Wof(b,k+a|0)|0)|0;e=c[f>>2]|0;if(m<<16>>16!=(Muh(2686848,e,Wof(d,k)|0)|0)<<16>>16)break;k=k+1|0;if((k|0)>=(Vof(d)|0)){h=a;l=9;break a}}a=a+1|0;if((a|0)>=(j|0)){h=-1;l=9;break}}if((l|0)==9){i=g;return h|0}return 0}function XKf(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;l=i;m=c[k>>2]|0;a:do if((Vof(f)|0)>0){n=0;while(1){o=Wof(f,n)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}p=n+1|0;if(!(sKf(0,o&65535,m)|0)){q=n;break a}if((p|0)<(Vof(f)|0))n=p;else{q=p;break}}}else q=0;while(0);if((q|0)==(Vof(f)|0)){r=g;i=l;return r|0}n=kKf(b,f,q,(Vof(f)|0)-q|0)|0;if(!n)if(!j){s=0;t=0;u=0;v=1;w=-1}else{Wof(f,q)|0;p=oKf(b,(Wof(f,q)|0)&65535,m)|0;a[j>>0]=gKf(b,p)|0;a[j+1>>0]=hKf(b,p)|0;if(!(m&2))a[j+2>>0]=iKf(b,p,0)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[j+3>>0]=DJf(0,p)|0;x=j;y=0;z=0;A=(IJf(0,p&65535)|0)^1;B=p;C=17}else{p=c[n+12>>2]|0;m=(p|0)!=0;o=m?0:j;if(o){D=n+16|0;n=c[D>>2]|0;if((c[n+12>>2]|0)>0){E=n;n=0;do{a[o+n>>0]=a[E+16+(da(c[(c[E>>2]|0)+120>>2]|0,n)|0)>>0]|0;n=n+1|0;E=c[D>>2]|0}while((n|0)<(c[E+12>>2]|0));x=o;y=m;z=p;A=1;B=-1;C=17}else{x=o;y=m;z=p;A=1;B=-1;C=17}}else{s=0;t=m;u=p;v=1;w=-1}}b:do if((C|0)==17){p=q+1|0;if((p|0)<(Vof(f)|0)){m=x+2|0;o=p;while(1){if((gKf(b,(Wof(f,o)|0)&65535)|0)<<24>>24!=1){s=x;t=y;u=z;v=A;w=B;break b}if(!(a[m>>0]|0))a[m>>0]=2;p=iKf(b,(Wof(f,o)|0)&65535,0)|0;a[m>>0]=(d[m>>0]|0)+(p&255);o=o+1|0;if((o|0)>=(Vof(f)|0)){s=x;t=y;u=z;v=A;w=B;break}}}else{s=x;t=y;u=z;v=A;w=B}}while(0);B=g;g=h;while(1){if(t)F=XKf(b,e,u,B,g,j,k)|0;else F=YKf(b,e,B,g,s,0,w,v,k)|0;if((F|0)<=-1){r=-1;C=33;break}h=B-F+g|0;if(PKf(b,e,f,F,h,0,k)|0){r=F;C=33;break}A=kKf(b,e,F,h)|0;if(!A){G=h+-1|0;H=1}else{z=c[(c[A+8>>2]|0)+12>>2]|0;G=h-z|0;H=z}if((G|0)>0){B=H+F|0;g=G}else{r=-1;C=33;break}}if((C|0)==33){i=l;return r|0}return 0}function YKf(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;g=i;i=i+16|0;l=g;m=e+d|0;c[l>>2]=d;e=d;while(1){if((e|0)>=(m|0)){n=-1;o=5;break}if(ZKf(a,b,l,m,h,f,j,k)|0){n=e;o=5;break}e=c[l>>2]|0}if((o|0)==5){i=g;return n|0}return 0}function ZKf(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=i;i=i+16|0;n=m;c[n>>2]=0;o=Wof(e,c[f>>2]|0)|0;p=l+8|0;q=c[p>>2]|0;r=(o&65535)>127;if(!((q|0)==0|r)?((d[q+((o&65535)>>>3&65535)>>0]|0)&1<<(o&7)|0)!=0:0){s=1;i=m;return s|0}q=l+4|0;t=c[q>>2]|0;if(!((t|0)==0|r)?((d[t+((o&65535)>>>3&65535)>>0]|0)&1<<(o&7)|0)!=0:0){c[f>>2]=(c[f>>2]|0)+1;s=0;i=m;return s|0}t=pKf(b,(Wof(e,c[f>>2]|0)|0)&65535)|0;c[n>>2]=0;if(dLf(b,e,f,g,h,j,k,t,n,l)|0){l=c[p>>2]|0;if((l|0)==0|(c[n>>2]|0)!=0|(t|0)!=0|r){s=1;i=m;return s|0}p=l+((o&65535)>>>3&65535)|0;a[p>>0]=d[p>>0]|0|1<<(o&7);s=1;i=m;return s|0}else{p=c[q>>2]|0;if((p|0)==0|(c[n>>2]|0)!=0|(t|0)!=0|r){s=0;i=m;return s|0}r=p+((o&65535)>>>3&65535)|0;a[r>>0]=d[r>>0]|0|1<<(o&7);s=0;i=m;return s|0}return 0}function _Kf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;a:do if(Vof(c)|0){f=Vof(b)|0;if(((f|0)>=(Vof(c)|0)?(Vof(c)|0)<=(e|0):0)?(f=d+-1-e+(Vof(c)|0)|0,g=Wof(c,(Vof(c)|0)+-1|0)|0,(f|0)<(d|0)):0){h=d;while(1){b:do if((Wof(b,h)|0)<<16>>16==g<<16>>16){j=h-(Vof(c)|0)+1|0;k=(Vof(c)|0)+-2|0;if((k|0)>-1)l=k;else{m=j;break a}while(1){k=Wof(b,l+j|0)|0;if(k<<16>>16!=(Wof(c,l)|0)<<16>>16)break b;if((l|0)>0)l=l+-1|0;else{m=j;break a}}}while(0);h=h+-1|0;if((h|0)<=(f|0)){m=-1;break}}}else m=-1}else m=0;while(0);i=a;return m|0}function $Kf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;if(!(Vof(d)|0)){h=0;i=g;return h|0}if((Vof(b)|0)<(f|0)){h=-1;i=g;return h|0}if((Vof(d)|0)>(f|0)){h=-1;i=g;return h|0}j=e+-1-f+(Vof(d)|0)|0;f=a+8|0;a=c[f>>2]|0;k=Muh(2686848,a,Wof(d,(Vof(d)|0)+-1|0)|0)|0;if((j|0)<(e|0))l=e;else{h=-1;i=g;return h|0}a:while(1){e=c[f>>2]|0;b:do if((Muh(2686848,e,Wof(b,l)|0)|0)<<16>>16==k<<16>>16){a=l-(Vof(d)|0)+1|0;m=(Vof(d)|0)+-2|0;if((m|0)>-1)n=m;else{h=a;o=10;break a}while(1){m=c[f>>2]|0;p=Muh(2686848,m,Wof(b,n+a|0)|0)|0;m=c[f>>2]|0;if(p<<16>>16!=(Muh(2686848,m,Wof(d,n)|0)|0)<<16>>16)break b;if((n|0)>0)n=n+-1|0;else{h=a;o=10;break a}}}while(0);l=l+-1|0;if((l|0)<=(j|0)){h=-1;o=10;break}}if((o|0)==10){i=g;return h|0}return 0}function aLf(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;m=c[k>>2]|0;a:do if((Vof(f)|0)>0){n=0;while(1){o=Wof(f,n)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}p=n+1|0;if(!(sKf(0,o&65535,m)|0)){q=n;break a}if((p|0)<(Vof(f)|0))n=p;else{q=p;break}}}else q=0;while(0);if((q|0)==(Vof(f)|0)){r=g;i=l;return r|0}n=kKf(b,f,q,(Vof(f)|0)-q|0)|0;if(!n)if(!j){s=0;t=0;u=0;v=1;w=-1}else{p=oKf(b,(Wof(f,q)|0)&65535,m)|0;a[j>>0]=gKf(b,p)|0;a[j+1>>0]=hKf(b,p)|0;if(!(m&2))a[j+2>>0]=iKf(b,p,0)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[j+3>>0]=DJf(0,p)|0;x=j;y=0;z=0;A=(IJf(0,p&65535)|0)^1;B=p;C=17}else{p=c[n+12>>2]|0;o=(p|0)!=0;D=o?0:j;if(D){E=n+16|0;n=c[E>>2]|0;if((c[n+12>>2]|0)>0){F=n;n=0;do{a[D+n>>0]=a[F+16+(da(c[(c[F>>2]|0)+120>>2]|0,n)|0)>>0]|0;n=n+1|0;F=c[E>>2]|0}while((n|0)<(c[F+12>>2]|0));x=D;y=o;z=p;A=1;B=-1;C=17}else{x=D;y=o;z=p;A=1;B=-1;C=17}}else{s=0;t=o;u=p;v=1;w=-1}}b:do if((C|0)==17){p=q+1|0;if((p|0)<(Vof(f)|0)){o=x+2|0;D=p;while(1){if((gKf(b,(Wof(f,D)|0)&65535)|0)<<24>>24!=1){s=x;t=y;u=z;v=A;w=B;break b}if(!(a[o>>0]|0))a[o>>0]=2;p=iKf(b,(Wof(f,D)|0)&65535,0)|0;a[o>>0]=(d[o>>0]|0)+(p&255);D=D+1|0;if((D|0)>=(Vof(f)|0)){s=x;t=y;u=z;v=A;w=B;break}}}else{s=x;t=y;u=z;v=A;w=B}}while(0);B=g;A=h;while(1){if(t)G=aLf(b,e,u,B,A,j,k)|0;else G=bLf(b,e,B,g,A,s,w,v,k)|0;if((G|0)<=-1){r=-1;C=38;break}h=G-B+A|0;z=g-G+1|0;if(PKf(b,e,f,G,z,0,k)|0){H=G;C=29;break}y=kKf(b,e,G,z)|0;if(!y){I=G+-1|0;J=h+-1|0}else{z=c[(c[y+8>>2]|0)+12>>2]|0;I=G-z|0;J=h-z|0}if((J|0)>0){B=I;A=J}else{r=-1;C=38;break}}if((C|0)==29){if((H|0)<(g|0))K=H;else{r=H;i=l;return r|0}while(1){H=Wof(e,K)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}J=K+1|0;if(!(sKf(0,H&65535,m)|0)){r=K;C=38;break}if((J|0)<(g|0))K=J;else{r=J;C=38;break}}if((C|0)==38){i=l;return r|0}}else if((C|0)==38){i=l;return r|0}return 0}function bLf(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;i=i+16|0;m=l;n=d-f|0;c[m>>2]=d;f=d;while(1){if((f|0)<=(n|0)){o=-1;p=5;break}if(cLf(a,b,m,n,e,h,g,j,k)|0){o=f;p=5;break}f=c[m>>2]|0}if((p|0)==5){i=l;return o|0}return 0}function cLf(b,e,f,g,h,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+16|0;o=n;c[o>>2]=0;p=Wof(e,c[f>>2]|0)|0;q=m+8|0;r=c[q>>2]|0;s=(p&65535)>127;if(!((r|0)==0|s)?((d[r+((p&65535)>>>3&65535)>>0]|0)&1<<(p&7)|0)!=0:0){t=1;i=n;return t|0}r=m+4|0;u=c[r>>2]|0;if(!((u|0)==0|s)?((d[u+((p&65535)>>>3&65535)>>0]|0)&1<<(p&7)|0)!=0:0){c[f>>2]=(c[f>>2]|0)+-1;t=0;i=n;return t|0}u=pKf(b,(Wof(e,c[f>>2]|0)|0)&65535)|0;c[o>>2]=0;if(fLf(b,e,f,g,h,j,k,l,u,o,m)|0){m=c[q>>2]|0;if((m|0)==0|(c[o>>2]|0)!=0|(u|0)!=0|s){t=1;i=n;return t|0}q=m+((p&65535)>>>3&65535)|0;a[q>>0]=d[q>>0]|0|1<<(p&7);t=1;i=n;return t|0}else{q=c[r>>2]|0;if((q|0)==0|(c[o>>2]|0)!=0|(u|0)!=0|s){t=0;i=n;return t|0}s=q+((p&65535)>>>3&65535)|0;a[s>>0]=d[s>>0]|0|1<<(p&7);t=0;i=n;return t|0}return 0}function dLf(b,e,f,g,h,j,k,l,m,n){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;o=i;i=i+16|0;p=o;c[p>>2]=0;q=c[n>>2]|0;r=c[n+12>>2]|0;s=q>>>1;if(!l){t=kKf(b,e,c[f>>2]|0,g)|0;c[m>>2]=t;u=t;v=r;w=-1}else{t=c[n+20>>2]|0;if((t|0)<=-1){x=c[n+24>>2]|0;if(!x){c[f>>2]=(c[f>>2]|0)+1;y=0;i=o;return y|0}else{z=x;A=-1}}else{z=r;A=rKf(b,t,l,q)|0}u=c[m>>2]|0;v=z;w=A}do if(!u){if((w|0)>-1)B=w;else B=oKf(b,(Wof(e,c[f>>2]|0)|0)&65535,q)|0;c[f>>2]=(c[f>>2]|0)+1;A=gKf(b,B)|0;a[v>>0]=A;if((a[j>>0]|0)==A<<24>>24){a[v+1>>0]=hKf(b,B)|0;C=0}else C=1;if(!(s&1)){if((a[j+1>>0]|0)==(a[v+1>>0]|0)?(a[v+2>>0]=iKf(b,B,l)|0,!C):0)D=24}else if(!C)D=24;if((D|0)==24){RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[v+3>>0]=DJf(0,B)|0;if((a[v>>0]|0)==1){E=B;break}c[n+20>>2]=B;E=B;break}A=c[f>>2]|0;if((A|0)<(g|0))F=A;else{y=0;i=o;return y|0}while(1){if((gKf(b,(Wof(e,F)|0)&65535)|0)<<24>>24!=1){y=0;D=37;break}F=(c[f>>2]|0)+1|0;c[f>>2]=F;if((F|0)>=(g|0)){y=0;D=37;break}}if((D|0)==37){i=o;return y|0}}else{c[f>>2]=(c[(c[u+8>>2]|0)+12>>2]|0)+(c[f>>2]|0);if(!k){y=0;i=o;return y|0}if(c[u+16>>2]|0){a[v>>0]=a[j>>0]|0;a[v+1>>0]=a[j+1>>0]|0;a[v+2>>0]=a[j+2>>0]|0;a[v+3>>0]=a[j+3>>0]|0;c[n+20>>2]=-1;c[n+24>>2]=v;E=w;break}c[p>>2]=0;A=c[u+12>>2]|0;y=ZKf(b,A,p,Vof(A)|0,h,j,1,n)|0;i=o;return y|0}while(0);n=c[f>>2]|0;a:do if((n|0)<(g|0)){p=(s&1|0)==0;u=v+2|0;w=n;do{if((gKf(b,(Wof(e,w)|0)&65535)|0)<<24>>24!=1)break a;if(p){if(!(a[u>>0]|0))a[u>>0]=2;D=iKf(b,(Wof(e,c[f>>2]|0)|0)&65535,0)|0;a[u>>0]=(d[u>>0]|0)+(D&255)}w=(c[f>>2]|0)+1|0;c[f>>2]=w}while((w|0)<(g|0))}while(0);y=eLf(0,q,v,E,l,j,h,k)|0;i=o;return y|0}function eLf(b,c,d,e,f,g,h,j){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;k=(c&2|0)!=0;if((a[d>>0]|0)!=(a[g>>0]|0)){l=0;i=b;return l|0}if((a[d+1>>0]|0)!=(a[g+1>>0]|0)){l=0;i=b;return l|0}if(!k?(a[d+2>>0]|0)!=(a[g+2>>0]|0):0){l=0;i=b;return l|0}if((a[d+3>>0]|0)!=(a[g+3>>0]|0)){l=0;i=b;return l|0}if(j){if((e|0)<0){l=1;i=b;return l|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}l=(IJf(0,e&65535)|0)^1;i=b;return l|0}if(!(k|(f|0)!=3)){l=0;i=b;return l|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}k=e&65535;j=LJf(0,k)|0;g=h&65535;if(j^(LJf(0,g)|0)){l=0;i=b;return l|0}RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}if((qKf(0,f,c)|0)<<24>>24!=3){l=0;i=b;return l|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}f=KJf(0,k)|0;if(f^(KJf(0,g)|0)){l=0;i=b;return l|0}RI(2685712)|0;if(a[2685860]|0){m=e&65535;n=jKf(0,m,c)|0;o=h&65535;p=jKf(0,o,c)|0;q=n^p;r=q^1;i=b;return r|0}RI(2685712)|0;fvh(2685712);m=e&65535;n=jKf(0,m,c)|0;o=h&65535;p=jKf(0,o,c)|0;q=n^p;r=q^1;i=b;return r|0}function fLf(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;p=i;q=c[o>>2]|0;r=c[o+12>>2]|0;s=q>>>1;t=c[f>>2]|0;u=(m|0)!=0;if(u){v=Wof(e,0)|0;RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}if(sKf(0,v&65535,q)|0){w=0;i=p;return w|0}v=oKf(b,(Wof(e,0)|0)&65535,q)|0;x=gKf(b,v)|0;if(x<<24>>24==1){iKf(b,v,0)|0;w=0;i=p;return w|0}y=rKf(b,v,m,q)|0;a[r>>0]=x;a[r+1>>0]=hKf(b,y)|0;if(!(s&1))a[r+2>>0]=iKf(b,y,m)|0;RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[r+3>>0]=DJf(0,y)|0;c[f>>2]=(c[f>>2]|0)+-1;z=c[n>>2]|0;A=y}else{y=mKf(b,e,t,g)|0;c[n>>2]=y;z=y;A=-1}do if(!z)if(!u){if((A|0)>-1)B=A;else B=oKf(b,(Wof(e,c[f>>2]|0)|0)&65535,q)|0;c[f>>2]=(c[f>>2]|0)+-1;y=gKf(b,B)|0;a[r>>0]=y;if(y<<24>>24==(a[k>>0]|0)){a[r+1>>0]=hKf(b,B)|0;C=0}else C=1;if(!(s&1)){if((a[r+1>>0]|0)!=(a[k+1>>0]|0)){w=0;i=p;return w|0}a[r+2>>0]=iKf(b,B,0)|0;if(C){w=0;i=p;return w|0}}else if(C){w=0;i=p;return w|0}RI(2677136)|0;if(!(a[2677284]|0)){RI(2677136)|0;fvh(2677136)}a[r+3>>0]=DJf(0,B)|0;if((a[r>>0]|0)==1){D=B;E=31}else{c[o+20>>2]=B;D=B;E=31}}else F=A;else{c[f>>2]=(c[f>>2]|0)-(c[(c[z+8>>2]|0)+12>>2]|0);if(!l){w=0;i=p;return w|0}if(c[z+16>>2]|0){a[r>>0]=a[k>>0]|0;a[r+1>>0]=a[k+1>>0]|0;a[r+2>>0]=a[k+2>>0]|0;a[r+3>>0]=a[k+3>>0]|0;c[o+20>>2]=-1;c[o+24>>2]=r;D=A;E=31;break}y=(Vof(c[z+12>>2]|0)|0)+-1|0;g=c[(c[n>>2]|0)+12>>2]|0;w=(bLf(b,g,y,y,Vof(g)|0,k,j,1,o)|0)>-1;i=p;return w|0}while(0);a:do if((E|0)==31)if(!u?(o=t+1|0,(o|0)<(h|0)):0){n=(s&1|0)==0;z=r+2|0;A=o;while(1){if((gKf(b,(Wof(e,A)|0)&65535)|0)<<24>>24!=1){F=D;break a}if(n){if(!(a[z>>0]|0))a[z>>0]=2;o=iKf(b,(Wof(e,A)|0)&65535,0)|0;a[z>>0]=(d[z>>0]|0)+(o&255)}A=A+1|0;if((A|0)>=(h|0)){F=D;break}}}else F=D;while(0);w=eLf(0,q,r,F,m,k,j,l)|0;i=p;return w|0}function gLf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+20>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;return}function hLf(a,b,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;c[a+20>>2]=b;c[a+8>>2]=d;c[a+16>>2]=e;c[a+12>>2]=f;return}function iLf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;mhh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888008]|0);ivh(f)}if(!e){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888010]|0);ivh(f)}if(_nf(0,d,e)|0){g=0;i=b;return g|0}f=Fqh(2694440,d)|0;if(_nf(0,f,Fqh(2694440,e)|0)|0){g=0;i=b;return g|0}f=kvh(2694496,d)|0;d=kvh(2694496,e)|0;e=c[f+12>>2]|0;h=c[d+12>>2]|0;j=(e|0)>(h|0)?h:e;a:do if((j|0)>0){k=f+16|0;l=c[(c[f>>2]|0)+120>>2]|0;m=d+16|0;n=c[(c[d>>2]|0)+120>>2]|0;o=0;while(1){p=a[k+(da(l,o)|0)>>0]|0;q=a[m+(da(n,o)|0)>>0]|0;o=o+1|0;if(p<<24>>24!=q<<24>>24){r=p;s=q;break}if((o|0)>=(j|0))break a}g=(r&255)<(s&255)?-1:1;i=b;return g|0}while(0);if((e|0)==(h|0)){g=0;i=b;return g|0}g=(e|0)<(h|0)?-1:1;i=b;return g|0}function jLf(a){a=a|0;return c[a+8>>2]|0}function kLf(a){a=a|0;return c[a+16>>2]|0}function lLf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2694552)|0;e=vL(b,2694552)|0;if((((e|0)!=0?(c[a+20>>2]|0)==(c[e+20>>2]|0):0)?(c[a+12>>2]|0)==(c[e+12>>2]|0):0)?(iLf(0,a,e)|0)==0:0){f=1;i=d;return f|0}f=0;i=d;return f|0}function mLf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;e=c[a+16>>2]|0;a=c[e+12>>2]|0;if(!a){f=0;i=b;return f|0}g=e+16|0;h=d[g>>0]|0;if((a|0)<=1){f=h;i=b;return f|0}j=c[(c[e>>2]|0)+120>>2]|0;e=h;h=1;while(1){k=(d[g+(da(j,h)|0)>>0]|0)<<(h&3)^e;h=h+1|0;if((h|0)>=(a|0)){f=k;break}else e=k}i=b;return f|0}function nLf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;nhh();RI(1086352)|0;g=hvh(1086352,6)|0;Qqh(g,c[888022]|0);h=g+16|0;c[h>>2]=c[888022];c[e>>2]=c[b+20>>2];RI(2540224)|0;j=pL(2540224,e)|0;Qqh(g,j);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=j;Qqh(g,c[888024]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]=c[888024];c[f>>2]=c[b+12>>2];RI(2694720)|0;j=pL(2694720,f)|0;Qqh(g,j);c[h+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]=j;Qqh(g,c[888026]|0);c[h+(c[(c[g>>2]|0)+120>>2]<<2)>>2]=c[888026];j=c[b+8>>2]|0;Qqh(g,j);c[h+((c[(c[g>>2]|0)+120>>2]|0)*5|0)>>2]=j;if(a[2540708]|0){k=eqf(0,g)|0;i=d;return k|0}fvh(2540560);k=eqf(0,g)|0;i=d;return k|0}function oLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function pLf(b){b=b|0;var d=0;d=b+8|0;a[b+78>>0]=0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;return}function qLf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;g=c[f>>2]|0;c[f>>2]=g+1;h=c[e>>2]|0;a[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,g)|0)>>0]=d;if((c[f>>2]|0)!=(c[(c[e>>2]|0)+12>>2]|0)){i=b;return}RI(1159264)|0;d=hvh(1159264,c[f>>2]<<1)|0;f=c[e>>2]|0;vEf(0,f,d,c[f+12>>2]|0);c[e>>2]=d;i=b;return}function rLf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=((c[a+12>>2]|0)+1|0)%8192|0;g=a+68|0;h=a+36|0;qLf(0,((f|0)/64|0)+128&255,g,h);qLf(0,(((f|0)%64|0)<<2|3)&255,g,h);qLf(0,b,g,h);qLf(0,d,g,h);i=e;return}function sLf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;if(((a[b+77>>0]|0)!=0?(e=b+78|0,(a[e>>0]|0)==0):0)?(f=c[b+44>>2]|0,(f|0)!=0):0){g=c[f+12>>2]|0;a:do if((g|0)>0){h=c[(c[f>>2]|0)+120>>2]|0;j=0;while(1){k=j+1|0;if(!(a[f+16+(da(h,j)|0)>>0]|0)){l=j;break a}if((k|0)<(g|0))j=k;else{l=k;break}}}else l=0;while(0);IEf(0,f,0,l);a[e>>0]=1}e=b+44|0;l=b+12|0;f=tLf(0,c[e>>2]|0,c[l>>2]|0,2)|0;c[l>>2]=f;g=b+48|0;j=b+16|0;h=tLf(0,c[g>>2]|0,c[j>>2]|0,2)|0;c[j>>2]=h;k=b+20|0;m=c[k>>2]|0;n=(m|0)>0;o=b+52|0;p=tLf(0,c[o>>2]|0,m,-28)|0;c[k>>2]=p;m=b+56|0;q=b+24|0;r=tLf(0,c[m>>2]|0,c[q>>2]|0,3)|0;c[q>>2]=r;s=b+60|0;t=b+28|0;u=tLf(0,c[s>>2]|0,c[t>>2]|0,-28)|0;c[t>>2]=u;v=b+64|0;w=b+32|0;x=tLf(0,c[v>>2]|0,c[w>>2]|0,-28)|0;c[w>>2]=x;y=b+68|0;z=b+36|0;A=tLf(0,c[y>>2]|0,c[z>>2]|0,2)|0;c[z>>2]=A;B=b+8|0;C=A+5+(c[B>>2]|0)+f+h|0;if(n)D=C+4+p+r+u+x|0;else D=C;RI(1159264)|0;C=hvh(1159264,D)|0;vEf(0,c[b+40>>2]|0,C,c[B>>2]|0);D=C+16|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,c[B>>2]|0)|0)>>0]=1;x=(c[B>>2]|0)+1|0;B=c[l>>2]|0;if((B|0)<1)E=B;else{wEf(0,c[e>>2]|0,0,C,x,B);E=c[l>>2]|0}l=E+x|0;x=l+1|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,l)|0)>>0]=1;l=c[j>>2]|0;if((l|0)<1)F=l;else{wEf(0,c[g>>2]|0,0,C,x,l);F=c[j>>2]|0}j=F+x|0;x=j+1|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,j)|0)>>0]=1;if(n){wEf(0,c[o>>2]|0,0,C,x,c[k>>2]|0);o=(c[k>>2]|0)+x|0;k=o+1|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,o)|0)>>0]=-1;wEf(0,c[m>>2]|0,0,C,k,c[q>>2]|0);m=(c[q>>2]|0)+k|0;k=m+1|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,m)|0)>>0]=2;wEf(0,c[s>>2]|0,0,C,k,c[t>>2]|0);s=(c[t>>2]|0)+k|0;k=s+1|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,s)|0)>>0]=-1;wEf(0,c[v>>2]|0,0,C,k,c[w>>2]|0);v=(c[w>>2]|0)+k|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,v)|0)>>0]=-1;G=v+1|0}else G=x;x=G+1|0;a[D+(da(c[(c[C>>2]|0)+120>>2]|0,G)|0)>>0]=1;G=c[z>>2]|0;if((G|0)<1){H=G;I=H+x|0;J=c[C>>2]|0;K=J+120|0;L=c[K>>2]|0;M=da(L,I)|0;N=D+M|0;a[N>>0]=0;O=b+80|0;P=c[O>>2]|0;Q=b+72|0;R=c[Q>>2]|0;S=b+84|0;T=c[S>>2]|0;RI(2694552)|0;U=qL(2694552)|0;V=U+20|0;W=P;c[V>>2]=W;X=U+8|0;c[X>>2]=R;Y=U+16|0;c[Y>>2]=C;Z=U+12|0;_=T;c[Z>>2]=_;i=d;return U|0}wEf(0,c[y>>2]|0,0,C,x,G);H=c[z>>2]|0;I=H+x|0;J=c[C>>2]|0;K=J+120|0;L=c[K>>2]|0;M=da(L,I)|0;N=D+M|0;a[N>>0]=0;O=b+80|0;P=c[O>>2]|0;Q=b+72|0;R=c[Q>>2]|0;S=b+84|0;T=c[S>>2]|0;RI(2694552)|0;U=qL(2694552)|0;V=U+20|0;W=P;c[V>>2]=W;X=U+8|0;c[X>>2]=R;Y=U+16|0;c[Y>>2]=C;Z=U+12|0;_=T;c[Z>>2]=_;i=d;return U|0}function tLf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;if((e|0)<=0){g=0;i=b;return g|0}h=d+16|0;j=c[(c[d>>2]|0)+120>>2]|0;d=-1;k=0;while(1){l=(a[h+(da(j,k)|0)>>0]|0)==f<<24>>24;m=l?d:k;k=k+1|0;if((k|0)==(e|0)){n=m;break}else d=m}g=n+1|0;i=b;return g|0}function uLf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(1159264)|0;e=hvh(1159264,4)|0;f=e+16|0;a[f>>0]=d;a[f+(c[(c[e>>2]|0)+120>>2]|0)>>0]=d>>>8;a[f+(c[(c[e>>2]|0)+120>>2]<<1)>>0]=d>>>16;a[f+((c[(c[e>>2]|0)+120>>2]|0)*3|0)>>0]=d>>>24;i=b;return e|0}function vLf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+32|0;e=b;lvh(e,2968200,d,1);d=c[e>>2]|0;f=c[e+4>>2]|0;g=c[e+8>>2]|0;h=c[e+12>>2]|0;j=c[e+16>>2]|0;k=c[e+20>>2]|0;l=c[e+24>>2]|0;m=c[e+28>>2]|0;e=l+12|0;n=c[e>>2]|0;RI(1159264)|0;o=hvh(1159264,(n<<2)+20+(n>>1)|0)|0;p=o+16|0;a[p>>0]=7;a[p+(c[(c[o>>2]|0)+120>>2]|0)>>0]=2;a[p+((c[(c[o>>2]|0)+120>>2]|0)*5|0)>>0]=36;a[p+(c[(c[o>>2]|0)+120>>2]<<3)>>0]=82;a[p+((c[(c[o>>2]|0)+120>>2]|0)*9|0)>>0]=83;a[p+((c[(c[o>>2]|0)+120>>2]|0)*10|0)>>0]=65;a[p+((c[(c[o>>2]|0)+120>>2]|0)*11|0)>>0]=50;q=uLf(0,n<<3)|0;n=q+16|0;a[p+((c[(c[o>>2]|0)+120>>2]|0)*12|0)>>0]=a[n>>0]|0;a[p+((c[(c[o>>2]|0)+120>>2]|0)*13|0)>>0]=a[n+(c[(c[q>>2]|0)+120>>2]|0)>>0]|0;a[p+((c[(c[o>>2]|0)+120>>2]|0)*14|0)>>0]=a[n+(c[(c[q>>2]|0)+120>>2]<<1)>>0]|0;a[p+((c[(c[o>>2]|0)+120>>2]|0)*15|0)>>0]=a[n+((c[(c[q>>2]|0)+120>>2]|0)*3|0)>>0]|0;q=c[m+12>>2]|0;if((q|0)>0){n=m+16|0;r=16;s=q;while(1){s=s+-1|0;t=a[n+(da(c[(c[m>>2]|0)+120>>2]|0,s)|0)>>0]|0;a[p+(da(c[(c[o>>2]|0)+120>>2]|0,r)|0)>>0]=t;if((r|0)==(q+15|0))break;else r=r+1|0}}r=c[e>>2]|0;IEf(0,l,0,r);Qig(0,l,0,o,20,r);l=r+20|0;r=c[d+12>>2]|0;IEf(0,d,0,r);Qig(0,d,0,o,l,r);d=r+l|0;l=c[f+12>>2]|0;IEf(0,f,0,l);Qig(0,f,0,o,d,l);f=l+d|0;d=c[h+12>>2]|0;IEf(0,h,0,d);Qig(0,h,0,o,f,d);h=d+f|0;f=c[j+12>>2]|0;IEf(0,j,0,f);Qig(0,j,0,o,h,f);j=f+h|0;h=c[k+12>>2]|0;IEf(0,k,0,h);Qig(0,k,0,o,j,h);k=c[g+12>>2]|0;IEf(0,g,0,k);Qig(0,g,0,o,h+j|0,k);i=b;return o|0}function wLf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b;lvh(e,2968200,d,0);d=c[e+24>>2]|0;f=c[e+28>>2]|0;e=d+12|0;g=c[e>>2]|0;RI(1159264)|0;h=hvh(1159264,g+20|0)|0;j=h+16|0;a[j>>0]=6;a[j+(c[(c[h>>2]|0)+120>>2]|0)>>0]=2;a[j+((c[(c[h>>2]|0)+120>>2]|0)*5|0)>>0]=36;a[j+(c[(c[h>>2]|0)+120>>2]<<3)>>0]=82;a[j+((c[(c[h>>2]|0)+120>>2]|0)*9|0)>>0]=83;a[j+((c[(c[h>>2]|0)+120>>2]|0)*10|0)>>0]=65;a[j+((c[(c[h>>2]|0)+120>>2]|0)*11|0)>>0]=49;k=uLf(0,g<<3)|0;g=k+16|0;a[j+((c[(c[h>>2]|0)+120>>2]|0)*12|0)>>0]=a[g>>0]|0;a[j+((c[(c[h>>2]|0)+120>>2]|0)*13|0)>>0]=a[g+(c[(c[k>>2]|0)+120>>2]|0)>>0]|0;a[j+((c[(c[h>>2]|0)+120>>2]|0)*14|0)>>0]=a[g+(c[(c[k>>2]|0)+120>>2]<<1)>>0]|0;a[j+((c[(c[h>>2]|0)+120>>2]|0)*15|0)>>0]=a[g+((c[(c[k>>2]|0)+120>>2]|0)*3|0)>>0]|0;k=c[f+12>>2]|0;if((k|0)<=0){l=c[e>>2]|0;IEf(0,d,0,l);Qig(0,d,0,h,20,l);i=b;return h|0}g=f+16|0;m=16;n=k;while(1){n=n+-1|0;o=a[g+(da(c[(c[f>>2]|0)+120>>2]|0,n)|0)>>0]|0;a[j+(da(c[(c[h>>2]|0)+120>>2]|0,m)|0)>>0]=o;if((m|0)==(k+15|0))break;else m=m+1|0}l=c[e>>2]|0;IEf(0,d,0,l);Qig(0,d,0,h,20,l);i=b;return h|0}function xLf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;ohh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888036]|0);ivh(e)}if(d){f=vLf(0,b)|0;i=a;return f|0}else{f=wLf(0,b)|0;i=a;return f|0}return 0}function yLf(a){a=a|0;var b=0;a=i;phh();b=tof(0,c[888042]|0)|0;RI(2698384)|0;c[c[674619]>>2]=b;i=a;return}function zLf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(!d){e=0;i=b;return e|0}a=bth(2628880,d)|0;RI(1159264)|0;e=mvh(a,1159264)|0;i=b;return e|0}function ALf(a,b,d){a=a|0;b=b|0;d=d|0;d=i;qhh();L7f(b,c[888072]|0,c[a+8>>2]|0);i=d;return}function BLf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;fvh(3007432)}RI(3007432)|0;e=(a[(c[751881]|0)+1>>0]|0)==0;RI(1159264)|0;f=hvh(1159264,4)|0;if(e){e=f+16|0;a[e>>0]=a[d+3>>0]|0;a[e+(c[(c[f>>2]|0)+120>>2]|0)>>0]=a[d+2>>0]|0;a[e+(c[(c[f>>2]|0)+120>>2]<<1)>>0]=a[d+1>>0]|0;a[e+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>0]=a[d>>0]|0;i=b;return f|0}else{e=f+16|0;a[e>>0]=a[d>>0]|0;a[e+(c[(c[f>>2]|0)+120>>2]|0)>>0]=a[d+1>>0]|0;a[e+(c[(c[f>>2]|0)+120>>2]<<1)>>0]=a[d+2>>0]|0;a[e+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>0]=a[d+3>>0]|0;i=b;return f|0}return 0}function CLf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d>>2]=b;b=BLf(0,d)|0;i=a;return b|0}function DLf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;fvh(3007432)}RI(3007432)|0;if(!(a[(c[751881]|0)+1>>0]|0)){g=e+16|0;a[d>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f+1|0)|0)>>0]|0;h=g+(da(c[(c[e>>2]|0)+120>>2]|0,f)|0)|0;j=a[h>>0]|0;k=d+1|0;a[k>>0]=j;i=b;return}else{g=e+16|0;a[d>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f)|0)>>0]|0;h=g+(da(c[(c[e>>2]|0)+120>>2]|0,f+1|0)|0)|0;j=a[h>>0]|0;k=d+1|0;a[k>>0]=j;i=b;return}}function ELf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;fvh(3007432)}RI(3007432)|0;if(!(a[(c[751881]|0)+1>>0]|0)){g=e+16|0;a[d>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f+3|0)|0)>>0]|0;a[d+1>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f+2|0)|0)>>0]|0;a[d+2>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f+1|0)|0)>>0]|0;h=g+(da(c[(c[e>>2]|0)+120>>2]|0,f)|0)|0;j=a[h>>0]|0;k=d+3|0;a[k>>0]=j;i=b;return}else{g=e+16|0;a[d>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f)|0)>>0]|0;a[d+1>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f+1|0)|0)>>0]|0;a[d+2>>0]=a[g+(da(c[(c[e>>2]|0)+120>>2]|0,f+2|0)|0)>>0]|0;h=g+(da(c[(c[e>>2]|0)+120>>2]|0,f+3|0)|0)|0;j=a[h>>0]|0;k=d+3|0;a[k>>0]=j;i=b;return}}function FLf(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;b[e>>1]=0;DLf(0,e,c,d);i=a;return b[e>>1]|0}function GLf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=0;ELf(0,e,b,d);i=a;return c[e>>2]|0}function HLf(b){b=b|0;var d=0;b=i;RI(2536312)|0;d=qL(2536312)|0;RI(2699744)|0;c[c[674959]>>2]=d;RI(2699744)|0;a[(c[674959]|0)+4>>0]=0;i=b;return}function ILf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+12|0;f=c[e>>2]|0;if(f){g=f;h=bth(2628880,g)|0;RI(1159264)|0;j=mvh(h,1159264)|0;i=d;return j|0}f=b+8|0;b=xLf(0,c[f>>2]|0,0)|0;k=Aqh(2963512,c[f>>2]|0)|0;RI(1159264)|0;f=hvh(1159264,(k>>3)+32|0)|0;c[e>>2]=f;k=b+16|0;a[f+16>>0]=a[k+(c[(c[b>>2]|0)+120>>2]<<2)>>0]|0;f=c[e>>2]|0;a[f+16+(c[(c[f>>2]|0)+120>>2]|0)>>0]=a[k+((c[(c[b>>2]|0)+120>>2]|0)*5|0)>>0]|0;f=c[e>>2]|0;a[f+16+(c[(c[f>>2]|0)+120>>2]<<1)>>0]=a[k+((c[(c[b>>2]|0)+120>>2]|0)*6|0)>>0]|0;f=c[e>>2]|0;a[f+16+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>0]=a[k+((c[(c[b>>2]|0)+120>>2]|0)*7|0)>>0]|0;k=c[e>>2]|0;a[k+16+(c[(c[k>>2]|0)+120>>2]<<2)>>0]=4;k=c[e>>2]|0;a[k+16+((c[(c[k>>2]|0)+120>>2]|0)*5|0)>>0]=-128;k=c[e>>2]|0;a[k+16+((c[(c[k>>2]|0)+120>>2]|0)*6|0)>>0]=0;k=c[e>>2]|0;a[k+16+((c[(c[k>>2]|0)+120>>2]|0)*7|0)>>0]=0;k=CLf(0,(c[(c[e>>2]|0)+12>>2]|0)+-12|0)|0;f=c[e>>2]|0;l=k+16|0;a[f+16+(c[(c[f>>2]|0)+120>>2]<<3)>>0]=a[l>>0]|0;f=c[e>>2]|0;a[f+16+((c[(c[f>>2]|0)+120>>2]|0)*9|0)>>0]=a[l+(c[(c[k>>2]|0)+120>>2]|0)>>0]|0;f=c[e>>2]|0;a[f+16+((c[(c[f>>2]|0)+120>>2]|0)*10|0)>>0]=a[l+(c[(c[k>>2]|0)+120>>2]<<1)>>0]|0;f=c[e>>2]|0;a[f+16+((c[(c[f>>2]|0)+120>>2]|0)*11|0)>>0]=a[l+((c[(c[k>>2]|0)+120>>2]|0)*3|0)>>0]|0;k=c[e>>2]|0;a[k+16+((c[(c[k>>2]|0)+120>>2]|0)*12|0)>>0]=6;k=c[e>>2]|0;Qig(0,b,1,k,13,(c[k+12>>2]|0)+-13|0);k=c[e>>2]|0;a[k+16+((c[(c[k>>2]|0)+120>>2]|0)*23|0)>>0]=49;g=c[e>>2]|0;h=bth(2628880,g)|0;RI(1159264)|0;j=mvh(h,1159264)|0;i=d;return j|0}function JLf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+16|0;e=c[d>>2]|0;do if(!e){f=ILf(a)|0;if(!f){g=0;i=b;return g|0}else{h=vag(Sag(0,KLf(a)|0)|0,f)|0;RI(1159264)|0;f=hvh(1159264,8)|0;c[d>>2]=f;Qig(0,h,(c[h+12>>2]|0)+-8|0,f,0,8);IEf(0,c[d>>2]|0,0,8);j=c[d>>2]|0;break}}else j=e;while(0);e=bth(2628880,j)|0;RI(1159264)|0;g=mvh(e,1159264)|0;i=b;return g|0}function KLf(a){a=a|0;var b=0,d=0,e=0;b=i;rhh();d=a+20|0;a=c[d>>2]|0;if(a){e=a;i=b;return e|0}a=c[888078]|0;c[d>>2]=a;e=a;i=b;return e|0}function LLf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[675124]|0;if(!b){d=MK(2700504)|0;c[675124]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function MLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[c[d>>2]>>2]=a;a=qL(2706296)|0;RI(2701688)|0;OLf(a,ML(c[675438]|0)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function NLf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!d){if(!(a[2540708]|0))fvh(2540560);f=c[c[635163]>>2]|0}else f=d;c[b+8>>2]=f;if(!(a[2540708]|0))fvh(2540560);f=c[c[635163]>>2]|0;c[b+12>>2]=f;c[b+16>>2]=f;i=e;return}function OLf(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=Fqh(2649752,b)|0;i=d;return}function PLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2706296)|0;RI(2701688)|0;OLf(a,ML(c[675438]|0)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[(c[d>>2]|0)+12>>2]=a;i=b;return}function QLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function RLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function SLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function TLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706112)|0;NLf(a,sM(2711160)|0);c[a+16>>2]=sM(2711168)|0;c[c[d>>2]>>2]=a;i=b;return}function ULf(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function VLf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[c[d>>2]>>2]=a;a=qL(2706296)|0;RI(2701016)|0;OLf(a,ML(c[675270]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function WLf(b,d){b=b|0;d=d|0;var e=0;e=i;c[b+8>>2]=d;c[b+12>>2]=-1;c[b+16>>2]=c[d+16>>2];RI(2712888)|0;if(!(a[2713036]|0)){RI(2712888)|0;fvh(2712888)}RI(2712888)|0;c[b+20>>2]=c[c[678245]>>2];i=e;return}function XLf(a){a=a|0;var b=0;a=i;RI(2536312)|0;b=qL(2536312)|0;RI(2712888)|0;c[c[678245]>>2]=b;i=a;return}function YLf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;bih();e=b+8|0;f=c[e>>2]|0;if((c[b+16>>2]|0)!=(c[f+16>>2]|0)){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[888700]|0);ivh(g)}g=b+12|0;h=(c[g>>2]|0)+1|0;c[g>>2]=h;if((h|0)<(Aqh(2713056,f)|0)){c[b+20>>2]=Krh(2713112,c[e>>2]|0,c[g>>2]|0)|0;j=1;i=d;return j|0}RI(2712888)|0;if(!(a[2713036]|0)){RI(2712888)|0;fvh(2712888)}RI(2712888)|0;c[b+20>>2]=c[c[678245]>>2];j=0;i=d;return j|0}function ZLf(b){b=b|0;var d=0,e=0,f=0;d=i;aih();e=b+20|0;f=c[e>>2]|0;RI(2712888)|0;if(!(a[2713036]|0)){RI(2712888)|0;fvh(2712888)}RI(2712888)|0;if((f|0)!=(c[c[678245]>>2]|0)){i=d;return c[e>>2]|0}e=(c[b+12>>2]|0)==-1;RI(3084976)|0;b=qL(3084976)|0;if(e){osg(b,c[888674]|0);ivh(b)}else{osg(b,c[888676]|0);ivh(b)}return 0}function _Lf(a,b){a=a|0;b=b|0;var d=0;d=i;$Lf(a);c[a+20>>2]=b;i=d;return}function $Lf(b){b=b|0;var d=0;d=i;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;fvh(2713640)}RI(2713640)|0;c[b+12>>2]=c[(c[678433]|0)+4>>2];i=d;return}function aMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Krh(2713112,c[a+20>>2]|0,b)|0;i=d;return e|0}function bMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Jrh(2713888,c[a+20>>2]|0,b,d);i=e;return}function cMf(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2713056,c[a+20>>2]|0)|0;i=b;return d|0}function dMf(a){a=a|0;var b=0,d=0;b=i;d=Gqh(2713944,c[a+20>>2]|0)|0;i=b;return d|0}function eMf(a){a=a|0;var b=0,d=0;b=i;d=bth(2714e3,c[a+20>>2]|0)|0;i=b;return d|0}function fMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Erh(2714056,c[a+20>>2]|0,b)|0;i=d;return e|0}function gMf(a){a=a|0;var b=0;b=i;eth(2714112,c[a+20>>2]|0);i=b;return}function hMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=nrh(2714168,c[a+20>>2]|0,b)|0;i=d;return e|0}function iMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Erh(2714224,c[a+20>>2]|0,b)|0;i=d;return e|0}function jMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=nvh(2714280,c[a+20>>2]|0,b,d)|0;i=e;return f|0}function kMf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=ovh(2714336,c[a+20>>2]|0,b,d,e)|0;i=f;return g|0}function lMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Jrh(2714392,c[a+20>>2]|0,b,d);i=e;return}function mMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Jrh(2714448,c[a+20>>2]|0,b,d);i=e;return}function nMf(a,b){a=a|0;b=b|0;var d=0;d=i;Irh(2714504,c[a+20>>2]|0,b);i=d;return}function oMf(a,b){a=a|0;b=b|0;var d=0;d=i;Lrh(2714560,c[a+20>>2]|0,b);i=d;return}function pMf(a,b){a=a|0;b=b|0;var d=0;d=i;zth(2714616,c[a+20>>2]|0,b);i=d;return}function qMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Csh(2714672,c[a+20>>2]|0,b,d);i=e;return}function rMf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;pvh(2714728,c[a+20>>2]|0,b,d,e,f);i=g;return}function sMf(a){a=a|0;var b=0,d=0;b=i;d=bth(2714784,c[a+20>>2]|0)|0;i=b;return d|0}function tMf(a,b){a=a|0;b=b|0;var d=0;d=i;Irh(2714840,c[a+20>>2]|0,b);i=d;return}function uMf(a){a=a|0;var b=0;b=i;eth(2714896,c[a+20>>2]|0);i=b;return}function vMf(a,b){a=a|0;b=b|0;var d=0;d=i;Irh(2714952,c[a+20>>2]|0,b);i=d;return}function wMf(a){a=a|0;var b=0,d=0;b=i;d=qvh(2715008,c[a+20>>2]|0)|0;i=b;return d|0}function xMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Uuh(2715064,c[a+20>>2]|0,b)|0;i=d;return e|0}function yMf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function zMf(a,b){a=a|0;b=b|0;var d=0;d=i;$Lf(a);c[a+20>>2]=b;c[a+24>>2]=bth(2714e3,b)|0;i=d;return}function AMf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+24>>2]|0;Jag(0,e);f=Krh(2713112,c[a+20>>2]|0,b)|0;Kag(0,e);i=d;return f|0}function BMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+24>>2]|0;Jag(0,f);Jrh(2713888,c[a+20>>2]|0,b,d);Kag(0,f);i=e;return}function CMf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;Jag(0,d);e=Aqh(2713056,c[a+20>>2]|0)|0;Kag(0,d);i=b;return e|0}function DMf(a){a=a|0;return 1}function EMf(a){a=a|0;return c[a+24>>2]|0}function FMf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+24>>2]|0;Jag(0,e);f=Erh(2714056,c[a+20>>2]|0,b)|0;Kag(0,e);i=d;return f|0}function GMf(a){a=a|0;var b=0,d=0;b=i;d=c[a+24>>2]|0;Jag(0,d);eth(2714112,c[a+20>>2]|0);Kag(0,d);i=b;return}function HMf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+24>>2]|0;Jag(0,e);f=nrh(2714168,c[a+20>>2]|0,b)|0;Kag(0,e);i=d;return f|0}function IMf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+24>>2]|0;Jag(0,e);f=Erh(2714224,c[a+20>>2]|0,b)|0;Kag(0,e);i=d;return f|0}function JMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+24>>2]|0;Jag(0,f);g=nvh(2714280,c[a+20>>2]|0,b,d)|0;Kag(0,f);i=e;return g|0}function KMf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[a+24>>2]|0;Jag(0,g);h=ovh(2714336,c[a+20>>2]|0,b,d,e)|0;Kag(0,g);i=f;return h|0}function LMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+24>>2]|0;Jag(0,f);Jrh(2714392,c[a+20>>2]|0,b,d);Kag(0,f);i=e;return}function MMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+24>>2]|0;Jag(0,f);Jrh(2714448,c[a+20>>2]|0,b,d);Kag(0,f);i=e;return}function NMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+24>>2]|0;Jag(0,e);Irh(2714504,c[a+20>>2]|0,b);Kag(0,e);i=d;return}function OMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+24>>2]|0;Jag(0,e);Lrh(2714560,c[a+20>>2]|0,b);Kag(0,e);i=d;return}function PMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+24>>2]|0;Jag(0,e);zth(2714616,c[a+20>>2]|0,b);Kag(0,e);i=d;return}function QMf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+24>>2]|0;Jag(0,f);Csh(2714672,c[a+20>>2]|0,b,d);Kag(0,f);i=e;return}function RMf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=c[a+24>>2]|0;Jag(0,h);pvh(2714728,c[a+20>>2]|0,b,d,e,f);Kag(0,h);i=g;return}function SMf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;Jag(0,d);e=bth(2714784,c[a+20>>2]|0)|0;Kag(0,d);i=b;return e|0}function TMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+24>>2]|0;Jag(0,e);Irh(2714840,c[a+20>>2]|0,b);Kag(0,e);i=d;return}function UMf(a){a=a|0;var b=0,d=0;b=i;d=c[a+24>>2]|0;Jag(0,d);eth(2714896,c[a+20>>2]|0);Kag(0,d);i=b;return}function VMf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+24>>2]|0;Jag(0,e);Irh(2714952,c[a+20>>2]|0,b);Kag(0,e);i=d;return}function WMf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;Jag(0,d);e=qvh(2715008,c[a+20>>2]|0)|0;Kag(0,d);i=b;return e|0}function XMf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+24>>2]|0;Jag(0,e);f=Uuh(2715064,c[a+20>>2]|0,b)|0;Kag(0,e);i=d;return f|0}function YMf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;i=b;return}function ZMf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Vhh();if((d|0)>-1){RI(1086352)|0;c[b+12>>2]=hvh(1086352,(d|0)==0?4:d)|0;i=e;return}c[f>>2]=d;RI(2540224)|0;d=pL(2540224,f)|0;RI(2713640)|0;if(a[2713788]|0){g=c[888494]|0;h=c[888496]|0;_Mf(0,g,d,h)}RI(2713640)|0;fvh(2713640);g=c[888494]|0;h=c[888496]|0;_Mf(0,g,d,h)}function _Mf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RI(2964880)|0;a=qL(2964880)|0;Teg(a,b,c,d);ivh(a)}function $Mf(a){a=a|0;var b=0;a=i;RI(1086352)|0;b=hvh(1086352,0)|0;RI(2713640)|0;c[(c[678433]|0)+4>>2]=b;i=a;return}function aNf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;Thh();if((d|0)>=0?(c[b+8>>2]|0)>(d|0):0){g=c[b+12>>2]|0;b=c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,d)|0)>>2]|0;i=e;return b|0}c[f>>2]=d;RI(2540224)|0;d=pL(2540224,f)|0;RI(2713640)|0;if(a[2713788]|0){h=c[888450]|0;j=c[888452]|0;_Mf(0,h,d,j)}RI(2713640)|0;fvh(2713640);h=c[888450]|0;j=c[888452]|0;_Mf(0,h,d,j);return 0}function bNf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;Uhh();if((d|0)>=0?(c[b+8>>2]|0)>(d|0):0){h=c[b+12>>2]|0;Qqh(h,e);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,d)|0)>>2]=e;e=b+16|0;c[e>>2]=(c[e>>2]|0)+1;i=f;return}c[g>>2]=d;RI(2540224)|0;d=pL(2540224,g)|0;RI(2713640)|0;if(a[2713788]|0){j=c[888488]|0;k=c[888490]|0;_Mf(0,j,d,k)}RI(2713640)|0;fvh(2713640);j=c[888488]|0;k=c[888490]|0;_Mf(0,j,d,k)}function cNf(a){a=a|0;return c[a+8>>2]|0}function dNf(a){a=a|0;return 0}function eNf(a){a=a|0;return a|0}function fNf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+12|0;a=c[(c[e>>2]|0)+12>>2]|0;if((a|0)>=(b|0)){i=d;return}f=a<<1;a=(f|0)!=0?f:4;while(1)if((a|0)<(b|0))a=a<<1;else{g=a;break}RI(1086352)|0;a=hvh(1086352,g)|0;g=c[e>>2]|0;wEf(0,g,0,a,0,c[g+12>>2]|0);c[e>>2]=a;i=d;return}function gNf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if((d|0)<1){if((d|0)>-1){i=e;return}f=b-d|0;g=a+12|0;h=c[g>>2]|0;j=a+8|0;wEf(0,h,f,h,b,(c[j>>2]|0)-f|0);yDf(0,c[g>>2]|0,(c[j>>2]|0)+d|0,0-d|0);i=e;return}j=a+8|0;g=c[j>>2]|0;f=a+12|0;a=c[f>>2]|0;h=g+d|0;k=c[a+12>>2]|0;if((h|0)<=(k|0)){wEf(0,a,b,a,d+b|0,g-b|0);i=e;return}g=(k|0)<1?1:k<<1;while(1)if((g|0)<(h|0))g=g<<1;else{l=g;break}RI(1086352)|0;g=hvh(1086352,l)|0;wEf(0,c[f>>2]|0,0,g,0,b);wEf(0,c[f>>2]|0,b,g,d+b|0,(c[j>>2]|0)-b|0);c[f>>2]=g;i=e;return}function hNf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a+8|0;h=c[g>>2]|0;if((c[f+12>>2]|0)>(h|0)){j=h;k=f}else{fNf(a,h+1|0);j=c[g>>2]|0;k=c[e>>2]|0}Qqh(k,b);c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,j)|0)>>2]=b;b=a+16|0;c[b>>2]=(c[b>>2]|0)+1;b=c[g>>2]|0;c[g>>2]=b+1;i=d;return b|0}function iNf(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;yDf(0,c[a+12>>2]|0,0,c[d>>2]|0);c[d>>2]=0;d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function jNf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=(ovh(2714336,a,b,0,c[a+8>>2]|0)|0)>-1;i=d;return e|0}function kNf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nvh(2714280,a,b,0)|0;i=c;return d|0}function lNf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ovh(2714336,a,b,d,(c[a+8>>2]|0)-d|0)|0;i=e;return f|0}function mNf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g+4|0;j=g;Whh();if((e|0)>=0?(k=c[b+8>>2]|0,(k|0)>=(e|0)):0){if((f|0)>-1)if((k-f|0)<(e|0)){RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[888532]|0,c[888534]|0);ivh(k)}else{k=aUg(0,c[b+12>>2]|0,d,e,f,c[795987]|0)|0;i=g;return k|0}c[j>>2]=f;RI(2540224)|0;f=pL(2540224,j)|0;RI(2713640)|0;if(a[2713788]|0){l=c[888528]|0;m=c[888530]|0;_Mf(0,l,f,m)}RI(2713640)|0;fvh(2713640);l=c[888528]|0;m=c[888530]|0;_Mf(0,l,f,m)}c[h>>2]=e;RI(2540224)|0;e=pL(2540224,h)|0;RI(2713640)|0;if(a[2713788]|0){n=c[888524]|0;o=c[888526]|0;_Mf(0,n,e,o)}RI(2713640)|0;fvh(2713640);n=c[888524]|0;o=c[888526]|0;_Mf(0,n,e,o);return 0}function nNf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;Xhh();if((d|0)>=0?(h=b+8|0,(c[h>>2]|0)>=(d|0)):0){gNf(b,d,1);j=c[b+12>>2]|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;c[h>>2]=(c[h>>2]|0)+1;h=b+16|0;c[h>>2]=(c[h>>2]|0)+1;i=f;return}c[g>>2]=d;RI(2540224)|0;d=pL(2540224,g)|0;RI(2713640)|0;if(a[2713788]|0){k=c[888592]|0;l=c[888594]|0;_Mf(0,k,d,l)}RI(2713640)|0;fvh(2713640);k=c[888592]|0;l=c[888594]|0;_Mf(0,k,d,l)}function oNf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f;Yhh();if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888614]|0);ivh(h)}if((d|0)>=0?(h=b+8|0,(c[h>>2]|0)>=(d|0)):0){j=cth(2647352,e)|0;k=b+12|0;l=c[h>>2]|0;m=l+j|0;if((c[(c[k>>2]|0)+12>>2]|0)<(m|0)){fNf(b,m);n=c[h>>2]|0}else n=l;if((n|0)>(d|0)){l=c[k>>2]|0;wEf(0,l,d,l,j+d|0,n-d|0)}n=(b|0)==(Sqh(2647408,e)|0);l=c[k>>2]|0;if(n){wEf(0,l,0,l,d,d);n=c[k>>2]|0;wEf(0,n,j+d|0,n,d<<1,(c[h>>2]|0)-d|0);o=c[h>>2]|0;p=cth(2647352,e)|0;q=p+o|0;c[h>>2]=q;r=b+16|0;s=c[r>>2]|0;t=s+1|0;c[r>>2]=t;i=f;return}else{fth(2647488,e,l,d);o=c[h>>2]|0;p=cth(2647352,e)|0;q=p+o|0;c[h>>2]=q;r=b+16|0;s=c[r>>2]|0;t=s+1|0;c[r>>2]=t;i=f;return}}c[g>>2]=d;RI(2540224)|0;d=pL(2540224,g)|0;RI(2713640)|0;if(a[2713788]|0){u=c[888616]|0;v=c[888618]|0;_Mf(0,u,d,v)}RI(2713640)|0;fvh(2713640);u=c[888616]|0;v=c[888618]|0;_Mf(0,u,d,v)}function pNf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Erh(2714224,a,b)|0;if((e|0)>=0)Lrh(2714560,a,e);e=a+16|0;c[e>>2]=(c[e>>2]|0)+1;i=d;return}function qNf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;Zhh();if((d|0)>=0?(g=b+8|0,(c[g>>2]|0)>(d|0)):0){gNf(b,d,-1);c[g>>2]=(c[g>>2]|0)+-1;g=b+16|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}c[f>>2]=d;RI(2540224)|0;d=pL(2540224,f)|0;RI(2713640)|0;if(a[2713788]|0){h=c[888624]|0;j=c[888626]|0;_Mf(0,h,d,j)}RI(2713640)|0;fvh(2713640);h=c[888624]|0;j=c[888626]|0;_Mf(0,h,d,j)}function rNf(a,b){a=a|0;b=b|0;var d=0;d=i;vEf(0,c[a+12>>2]|0,b,c[a+8>>2]|0);i=d;return}function sNf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;pvh(2714728,a,0,b,d,c[a+8>>2]|0);i=e;return}function tNf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;_hh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888648]|0);ivh(h)}if((sDf(d)|0)==1){wEf(0,c[a+12>>2]|0,b,d,e,f);i=g;return}else{RI(2965048)|0;g=qL(2965048)|0;Rag(g,c[888650]|0,c[888652]|0);ivh(g)}}function uNf(b){b=b|0;var c=0,d=0;c=i;RI(2712888)|0;if(!(a[2713036]|0)){RI(2712888)|0;fvh(2712888)}RI(2712888)|0;d=qL(2712888)|0;WLf(d,b);i=c;return d|0}function vNf(a,b){a=a|0;b=b|0;var d=0;d=i;Jrh(2714448,a,c[a+8>>2]|0,b);i=d;return}function wNf(a){a=a|0;var b=0,d=0;b=i;H2g(0,c[a+12>>2]|0,0,c[a+8>>2]|0,c[833083]|0);d=a+16|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function xNf(a,b){a=a|0;b=b|0;var d=0;d=i;QEf(0,c[a+12>>2]|0,0,c[a+8>>2]|0,b);i=d;return}function yNf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;RI(1086352)|0;e=hvh(1086352,d)|0;zth(2714616,a,e);i=b;return e|0}function zNf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=gEf(0,b,c[a+8>>2]|0)|0;zth(2714616,a,e);i=d;return e|0}function ANf(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;$hh();if(!b){RI(2963920)|0;d=qL(2963920)|0;Iag(d,c[888670]|0);ivh(d)}if(Gqh(2713944,b)|0){e=b;i=a;return e|0}RI(2717664)|0;d=qL(2717664)|0;zMf(d,b);e=d;i=a;return e|0}function BNf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[c[d>>2]>>2]=a;a=qL(2706296)|0;RI(2721152)|0;OLf(a,ML(c[680304]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+12>>2]=a;i=b;return}function CNf(a,b){a=a|0;b=b|0;c[a+16>>2]=-1;c[a+8>>2]=b;c[a+20>>2]=c[b+16>>2];return}function DNf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;eih();f=c[b+16>>2]|0;if((f|0)==-1){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[888772]|0);ivh(g)}if((f|0)<(Aqh(2721808,c[b+8>>2]|0)|0)){a[e>>0]=a[b+12>>0]|0;RI(2601984)|0;b=pL(2601984,e)|0;i=d;return b|0}else{RI(3084976)|0;b=qL(3084976)|0;osg(b,c[888774]|0);ivh(b)}return 0}function ENf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;FNf(b);e=b+16|0;f=c[e>>2]|0;g=b+8|0;h=(f|0)<((Aqh(2721808,c[g>>2]|0)|0)+-1|0);f=c[g>>2]|0;if(h){h=(c[e>>2]|0)+1|0;c[e>>2]=h;a[b+12>>0]=(KNf(f,h)|0)&1;j=1;i=d;return j|0}else{c[e>>2]=Aqh(2721808,f)|0;j=0;i=d;return j|0}return 0}function FNf(a){a=a|0;if((c[a+20>>2]|0)==(c[(c[a+8>>2]|0)+16>>2]|0))return;else{RI(3084976)|0;a=qL(3084976)|0;nsg(a);ivh(a)}}function GNf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=KNf(a,b)|0;i=c;return d|0}function HNf(a,b){a=a|0;b=b|0;var d=0;d=i;cih();if((b|0)>-1){c[a+12>>2]=b;RI(1101728)|0;c[a+8>>2]=hvh(1101728,(b+31|0)/32|0)|0;i=d;return}else{RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[888714]|0);ivh(d)}}function INf(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a+8>>2]|0;a=((b|0)%4|0)<<3&24;e=(c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,(b|0)/4|0)|0)>>2]&255<<a)>>a&255;return e|0}function JNf(a){a=a|0;return c[a+12>>2]|0}function KNf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((b|0)>=0?(c[a+12>>2]|0)>(b|0):0){e=c[a+8>>2]|0;a=(c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,b>>5)|0)>>2]&1<<(b&31)|0)!=0;i=d;return a|0}RI(2964880)|0;a=qL(2964880)|0;_eg(a);ivh(a);return 0}function LNf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;MNf(a,b,c);i=d;return}function MNf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)>=0?(c[a+12>>2]|0)>(b|0):0){f=c[a+8>>2]|0;g=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b>>5)|0)|0;f=c[g>>2]|0;h=1<<(b&31);if(d){j=f|h;c[g>>2]=j;k=a+16|0;l=c[k>>2]|0;m=l+1|0;c[k>>2]=m;i=e;return}else{j=f&~h;c[g>>2]=j;k=a+16|0;l=c[k>>2]|0;m=l+1|0;c[k>>2]=m;i=e;return}}RI(2964880)|0;e=qL(2964880)|0;_eg(e);ivh(e)}function NNf(a){a=a|0;return c[a+12>>2]|0}function ONf(a){a=a|0;return a|0}function PNf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;dih();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[888718]|0);ivh(g)}if((e|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[888720]|0);ivh(g)}if((sDf(d)|0)!=1){RI(2965048)|0;g=qL(2965048)|0;Rag(g,c[888722]|0,c[888724]|0);ivh(g)}if((PCf(d)|0)<=(e|0)?(c[b+12>>2]|0)>=1:0){RI(2965048)|0;g=qL(2965048)|0;Rag(g,c[888726]|0,c[888728]|0);ivh(g)}RI(1153040)|0;if(vL(d,1153040)|0){g=PCf(d)|0;h=b+12|0;if((g-e|0)<(c[h>>2]|0)){RI(2965048)|0;g=qL(2965048)|0;oig(g);ivh(g)}RI(1153040)|0;g=mvh(d,1153040)|0;if((c[h>>2]|0)<=0){i=f;return}j=g+16|0;k=0;do{l=KNf(b,k)|0;a[j+(da(c[(c[g>>2]|0)+120>>2]|0,k+e|0)|0)>>0]=l&1;k=k+1|0}while((k|0)<(c[h>>2]|0));i=f;return}RI(1159264)|0;if(!(vL(d,1159264)|0)){RI(1101728)|0;if(!(vL(d,1101728)|0)){RI(2965048)|0;h=qL(2965048)|0;Rag(h,c[888730]|0,c[888732]|0);ivh(h)}wEf(0,c[b+8>>2]|0,0,d,e,((c[b+12>>2]|0)+31|0)/32|0);i=f;return}h=c[b+12>>2]|0;k=(h+7|0)/8|0;if(((PCf(d)|0)-e|0)<(k|0)){RI(2965048)|0;g=qL(2965048)|0;oig(g);ivh(g)}RI(1159264)|0;g=mvh(d,1159264)|0;if((h|0)<=0){i=f;return}h=g+16|0;d=0;do{j=INf(b,d)|0;a[h+(da(c[(c[g>>2]|0)+120>>2]|0,d+e|0)|0)>>0]=j;d=d+1|0}while((d|0)<(k|0));i=f;return}function QNf(a){a=a|0;var b=0,c=0;b=i;RI(2721880)|0;c=qL(2721880)|0;CNf(c,a);i=b;return c|0}function RNf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function SNf(b){b=b|0;var d=0;d=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}c[b+8>>2]=eKf(0)|0;i=d;return}function TNf(a,b){a=a|0;b=b|0;return}function UNf(a){a=a|0;var b=0;a=i;RI(2723776)|0;b=qL(2723776)|0;SNf(b);RI(2723776)|0;c[c[680967]>>2]=b;RI(2723776)|0;b=qL(2723776)|0;RI(2723776)|0;c[(c[680967]|0)+4>>2]=b;i=a;return}function VNf(b){b=b|0;b=i;RI(2723776)|0;if(!(a[2723924]|0)){RI(2723776)|0;fvh(2723776)}RI(2723776)|0;i=b;return c[(c[680967]|0)+4>>2]|0}function WNf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=vL(d,2540560)|0;h=vL(e,2540560)|0;if(!((g|0)!=0&(h|0)!=0)){RI(2724056)|0;if(!(a[2724204]|0)){RI(2724056)|0;fvh(2724056)}RI(2724056)|0;j=rvh(2724224,c[c[681037]>>2]|0,d,e)|0;i=f;return j|0}e=c[b+8>>2]|0;if(e){j=Nuh(2724e3,Fuh(2723944,e)|0,g,h,1)|0;i=f;return j|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}j=Nuh(2724e3,Fuh(2723944,eKf(0)|0)|0,g,h,1)|0;i=f;return j|0}function XNf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function YNf(b){b=b|0;var d=0,e=0,f=0;d=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}e=eKf(0)|0;f=eKf(0)|0;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;fvh(2724880)}if(ZNf(0,e,f)|0){i=d;return}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}c[b+8>>2]=Luh(2686512,eKf(0)|0)|0;i=d;return}function ZNf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;e=Fqh(2686792,c)|0;c=Fqh(2686792,d)|0;if(!(a[2540708]|0))fvh(2540560);d=gpf(0,e,c)|0;i=b;return d|0}function _Nf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;fih();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888792]|0);ivh(f)}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}f=eKf(0)|0;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;fvh(2724880)}if(ZNf(0,d,f)|0){i=e;return}c[b+8>>2]=Luh(2686512,d)|0;i=e;return}function $Nf(b){b=b|0;var d=0,e=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}d=eKf(0)|0;RI(2724880)|0;e=qL(2724880)|0;_Nf(e,d);RI(2724880)|0;c[c[681243]>>2]=e;RI(2536312)|0;e=qL(2536312)|0;RI(2724880)|0;c[(c[681243]|0)+4>>2]=e;i=b;return}function aOf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;e=bOf(c)|0;c=Fqh(2686792,d)|0;if(!(a[2540708]|0))fvh(2540560);d=gpf(0,e,c)|0;i=b;return d|0}function bOf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=Fqh(2686792,c[a+20>>2]|0)|0;c[d>>2]=e;f=e;i=b;return f|0}function cOf(b){b=b|0;b=i;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;fvh(2724880)}RI(2724880)|0;i=b;return c[c[681243]>>2]|0}function dOf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;gih();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[888796]|0);ivh(f)}f=vL(d,2540560)|0;if(!f){g=Aqh(2536720,d)|0;i=e;return g|0}d=b+8|0;b=c[d>>2]|0;if(b){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}h=eKf(0)|0;RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;fvh(2724880)}if(!(aOf(0,b,h)|0)){h=Vth(2725048,c[d>>2]|0,f)|0;if((Vof(h)|0)>0){j=0;k=0}else{g=0;i=e;return g|0}while(1){d=((Wof(h,k)|0)&65535)+(j*31|0)|0;k=k+1|0;if((k|0)>=(Vof(h)|0)){g=d;break}else j=d}i=e;return g|0}}if((Vof(f)|0)>0){l=0;m=0}else{g=0;i=e;return g|0}while(1){j=Wof(f,m)|0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}h=eKf(0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}k=((uuf(0,j,h)|0)&65535)+(l*31|0)|0;m=m+1|0;if((m|0)>=(Vof(f)|0)){g=k;break}else l=k}i=e;return g|0}function eOf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2615320)|0;VCf(a,sM(2725704)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function fOf(a){a=a|0;return}function gOf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Csh(2714672,hOf(a)|0,b,c);i=d;return}function hOf(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;b=c[e>>2]|0;if(b){f=b;i=d;return f|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;fvh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);c[e>>2]=b;f=b;i=d;return f|0}function iOf(a){a=a|0;var b=0,c=0;b=i;c=bth(2714e3,hOf(a)|0)|0;i=b;return c|0}function jOf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;Irh(2725896,a,b);d=Aqh(2713056,hOf(a)|0)|0;Jrh(2725952,a,d,b);Erh(2714056,hOf(a)|0,b)|0;Jrh(2726008,a,d,b);i=c;return d|0}function kOf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nrh(2714168,hOf(a)|0,b)|0;i=c;return d|0}function lOf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Erh(2714224,hOf(a)|0,b)|0;i=c;return d|0}function mOf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Irh(2725896,a,c);Jrh(2725952,a,b,c);Jrh(2714392,hOf(a)|0,b,c);Jrh(2726008,a,b,c);i=d;return}function nOf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;iih();Irh(2725896,a,b);e=Erh(2714224,hOf(a)|0,b)|0;if((e|0)==-1){RI(2965048)|0;f=qL(2965048)|0;Rag(f,c[888806]|0,c[888808]|0);ivh(f)}else{Jrh(2726064,a,e,b);Irh(2714504,hOf(a)|0,b);Jrh(2726120,a,e,b);i=d;return}}function oOf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Krh(2713112,hOf(a)|0,b)|0;i=c;return d|0}function pOf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;hih();if((b|0)>=0?(Aqh(2713056,hOf(a)|0)|0)>(b|0):0){Irh(2725896,a,d);f=Krh(2713112,hOf(a)|0,b)|0;svh(2726176,a,b,f,d);Jrh(2713888,hOf(a)|0,b,d);svh(2726232,a,b,f,d);i=e;return}RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[888802]|0);ivh(e)}function qOf(a){a=a|0;var b=0,c=0;b=i;c=Aqh(2713056,hOf(a)|0)|0;i=b;return c|0}function rOf(a){a=a|0;var b=0,c=0;b=i;c=bth(2714784,hOf(a)|0)|0;i=b;return c|0}function sOf(a){a=a|0;var b=0;b=i;eth(2726288,a);eth(2714112,hOf(a)|0);eth(2726344,a);i=b;return}function tOf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Krh(2713112,hOf(a)|0,b)|0;Irh(2725896,a,d);Jrh(2726064,a,b,d);Lrh(2714560,hOf(a)|0,b);Jrh(2726120,a,b,d);i=c;return}function uOf(a){a=a|0;return a|0}function vOf(a){a=a|0;return}function wOf(a){a=a|0;return}function xOf(a,b,c){a=a|0;b=b|0;c=c|0;return}function yOf(a,b,c){a=a|0;b=b|0;c=c|0;return}function zOf(a,b,c){a=a|0;b=b|0;c=c|0;return}function AOf(a,b,c){a=a|0;b=b|0;c=c|0;return}function BOf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function COf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function DOf(a,b){a=a|0;b=b|0;a=i;jih();if(!b){RI(2963920)|0;b=qL(2963920)|0;Iag(b,c[888826]|0);ivh(b)}else{i=a;return}}function EOf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function FOf(a){a=a|0;return}function GOf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;kih();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[888868]|0);ivh(e)}else{c[a+8>>2]=Fuh(2723944,b)|0;i=d;return}}function HOf(b){b=b|0;var d=0,e=0;b=i;RI(2724056)|0;d=qL(2724056)|0;RI(2724056)|0;c[c[681037]>>2]=d;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}d=eKf(0)|0;RI(2724056)|0;e=qL(2724056)|0;GOf(e,d);RI(2724056)|0;c[(c[681037]|0)+4>>2]=e;i=b;return}function IOf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;lih();if((b|0)==(d|0)){f=0;i=e;return f|0}if(!b){f=-1;i=e;return f|0}if(!d){f=1;i=e;return f|0}g=a+8|0;if((c[g>>2]|0)!=0?(a=vL(b,2540560)|0,h=vL(d,2540560)|0,(a|0)!=0&(h|0)!=0):0){f=tvh(2728752,c[g>>2]|0,a,h)|0;i=e;return f|0}RI(2546528)|0;h=(vL(b,2546528)|0)==0;RI(2546528)|0;if(!h){f=Zqh(2546712,vL(b,2546528)|0,d)|0;i=e;return f|0}if(!(vL(d,2546528)|0)){h=tof(0,c[888872]|0)|0;RI(2965048)|0;a=qL(2965048)|0;Rbg(a,h);ivh(a)}RI(2546528)|0;f=0-(Zqh(2546712,vL(d,2546528)|0,b)|0)|0;i=e;return f|0}function JOf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;mih();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888898]|0);ivh(h)}h=c[b+8>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[g>>2]=3444968;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[888900]|0,h,g);i=e;return}function KOf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function LOf(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;return}function MOf(a){a=a|0;return c[a>>2]|0}function NOf(a){a=a|0;return c[a+4>>2]|0}function OOf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706112)|0;NLf(a,sM(2729784)|0);c[a+16>>2]=sM(2729800)|0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function POf(a){a=a|0;return}function QOf(a){a=a|0;var b=0;a=i;RI(2730360)|0;b=qL(2730360)|0;RI(2730360)|0;c[c[682613]>>2]=b;i=a;return}function ROf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+8>>2]=b;c[a+12>>2]=c[b+12>>2];c[a+20>>2]=c[(c[b+20>>2]|0)+12>>2];c[a+24>>2]=d;eth(2731240,a);i=e;return}function SOf(a){a=a|0;var b=0;a=i;wih();b=c[889108]|0;RI(2731296)|0;c[c[682847]>>2]=b;i=a;return}function TOf(b){b=b|0;if((c[(c[b+8>>2]|0)+12>>2]|0)==(c[b+12>>2]|0))return;RI(2731296)|0;if(!(a[2731444]|0)){RI(2731296)|0;fvh(2731296)}RI(3084976)|0;b=qL(3084976)|0;RI(2731296)|0;osg(b,c[c[682847]>>2]|0);ivh(b)}function UOf(a){a=a|0;var b=0;b=i;TOf(a);c[a+16>>2]=-1;c[a+28>>2]=0;c[a+32>>2]=0;i=b;return}function VOf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;TOf(b);e=b+16|0;f=c[e>>2]|0;g=b+20|0;h=c[g>>2]|0;a:do if((f|0)<(h|0)?(j=f+1|0,c[e>>2]=j,(j|0)<(h|0)):0){k=b+8|0;l=j;j=h;while(1){m=c[(c[k>>2]|0)+20>>2]|0;n=m+16|0;o=da(c[(c[m>>2]|0)+120>>2]|0,l)|0;m=c[n+o>>2]|0;p=c[n+(o+4)>>2]|0;if(!m){q=l;r=j}else{RI(2730360)|0;if(!(a[2730508]|0)){RI(2730360)|0;fvh(2730360)}RI(2730360)|0;if((m|0)!=(c[c[682613]>>2]|0)){s=m;t=p;break}q=c[e>>2]|0;r=c[g>>2]|0}l=q+1|0;c[e>>2]=l;if((l|0)>=(r|0))break a;else j=r}c[b+28>>2]=s;c[b+32>>2]=t;u=1;i=d;return u|0}while(0);c[b+28>>2]=0;c[b+32>>2]=0;u=0;i=d;return u|0}function WOf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+28|0;if(!(c[e>>2]|0)){RI(3084976)|0;f=qL(3084976)|0;nsg(f);ivh(f)}else{TOf(b);f=c[e>>2]|0;e=c[b+32>>2]|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[a>>2]=f;c[a+4>>2]=e;i=d;return}}function XOf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+28|0;if(!(c[d>>2]|0)){RI(3084976)|0;e=qL(3084976)|0;nsg(e);ivh(e)}else{TOf(a);i=b;return c[d>>2]|0}return 0}function YOf(a){a=a|0;var b=0,d=0;b=i;if(!(c[a+28>>2]|0)){RI(3084976)|0;d=qL(3084976)|0;nsg(d);ivh(d)}else{TOf(a);i=b;return c[a+32>>2]|0}return 0}function ZOf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;vih();e=c[a+28>>2]|0;if(!e){RI(3084976)|0;f=qL(3084976)|0;nsg(f);ivh(f)}f=c[a+24>>2]|0;if((f|0)==1){g=c[a+32>>2]|0;i=b;return g|0}else if(!f){g=e;i=b;return g|0}else if((f|0)==2){f=c[a+32>>2]|0;a=d;c[a>>2]=e;c[a+4>>2]=f;RI(2729368)|0;g=pL(2729368,d)|0;i=b;return g|0}else{RI(2589312)|0;g=qL(2589312)|0;Vxf(g,c[889094]|0);ivh(g)}return 0}function _Of(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){RI(2963920)|0;e=qL(2963920)|0;Ucg(e);ivh(e)}else{c[a+8>>2]=b;i=d;return}}function $Of(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2732416,c[a+8>>2]|0)|0;i=b;return d|0}function aPf(a){a=a|0;var b=0,d=0;b=i;d=bth(2732472,c[a+8>>2]|0)|0;i=b;return d|0}function bPf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;xih();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[889134]|0);ivh(f)}if((sDf(b)|0)!=1){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[889136]|0);ivh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[889138]|0);ivh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(2732528,a)|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[889140]|0);ivh(f)}else{cPf(c[a+8>>2]|0,b,d,0);i=e;return}}function cPf(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;RI(2731296)|0;if(!(a[2731444]|0)){RI(2731296)|0;fvh(2731296)}RI(2731296)|0;g=qL(2731296)|0;ROf(g,b,e);if(jth(2568176,g)|0)h=d;else{i=f;return}while(1){bEf(c,Sqh(2568120,g)|0,h);if(jth(2568176,g)|0)h=h+1|0;else break}i=f;return}function dPf(b){b=b|0;var d=0,e=0;d=i;e=c[b+8>>2]|0;RI(2731296)|0;if(!(a[2731444]|0)){RI(2731296)|0;fvh(2731296)}RI(2731296)|0;b=qL(2731296)|0;ROf(b,e,0);i=d;return b|0}function ePf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706296)|0;RI(2721152)|0;OLf(a,ML(c[680304]|0)|0);c[c[d>>2]>>2]=a;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function fPf(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2732416,c[a+8>>2]|0)|0;i=b;return d|0}function gPf(a){a=a|0;var b=0,d=0;b=i;d=bth(2732472,c[a+8>>2]|0)|0;i=b;return d|0}function hPf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;yih();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[889152]|0);ivh(f)}if((sDf(b)|0)!=1){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[889154]|0);ivh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[889156]|0);ivh(f)}f=PCf(b)|0;if((f-d|0)<(Aqh(2733224,a)|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[889158]|0);ivh(f)}else{cPf(c[a+8>>2]|0,b,d,1);i=e;return}}function iPf(b){b=b|0;var d=0,e=0;d=i;e=c[b+8>>2]|0;RI(2731296)|0;if(!(a[2731444]|0)){RI(2731296)|0;fvh(2731296)}RI(2731296)|0;b=qL(2731296)|0;ROf(b,e,1);i=d;return b|0}function jPf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2706296)|0;RI(2721152)|0;OLf(a,ML(c[680304]|0)|0);c[c[d>>2]>>2]=a;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function kPf(a){a=a|0;var b=0;b=i;lPf(a,0,ea(1.0));i=b;return}function lPf(a,b,c){a=a|0;b=b|0;c=ea(c);var d=0;d=i;mPf(a,b,c,0,0);i=d;return}function mPf(b,d,e,f,h){b=b|0;d=d|0;e=ea(e);f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=Im;j=i;oih();if((d|0)<=-1){RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[888920]|0,c[888922]|0);ivh(k)}if(e<ea(.100000001)|e>ea(1.0)){RI(2964880)|0;l=qL(2964880)|0;m=c[888924]|0;n=c[888926]|0;Qag(l,m,n);ivh(l)}if(gxf(0,e)|0){RI(2964880)|0;l=qL(2964880)|0;m=c[888924]|0;n=c[888926]|0;Qag(l,m,n);ivh(l)}o=ea(e*ea(.75));g[b+16>>2]=o;e=ea(ea(((d|0)==0&1)+d|0)/o);if(!(+e<=2147483647.0)){RI(2965048)|0;d=qL(2965048)|0;Rbg(d,c[888928]|0);ivh(d)}RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;fvh(2730168)}d=nPf(0,~~e)|0;RI(1190920)|0;l=hvh(1190920,d)|0;RI(1101728)|0;oPf(b,l,hvh(1101728,d)|0);c[b+40>>2]=f;c[b+44>>2]=h;c[b+8>>2]=0;c[b+12>>2]=0;i=j;return}function nPf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;e=0;while(1){RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;fvh(2730168)}RI(2730168)|0;f=(e|0)<(c[(c[(c[682565]|0)+4>>2]|0)+12>>2]|0);RI(2730168)|0;g=(a[2730316]|0)!=0;if(!f){h=11;break}if(!g){RI(2730168)|0;fvh(2730168)}RI(2730168)|0;f=c[(c[682565]|0)+4>>2]|0;if((c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,e)|0)>>2]|0)<(d|0))e=e+1|0;else{j=e;h=4;break}}if((h|0)==4){RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;fvh(2730168)}RI(2730168)|0;e=c[(c[682565]|0)+4>>2]|0;k=c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,j)|0)>>2]|0;i=b;return k|0}else if((h|0)==11){if(!g){RI(2730168)|0;fvh(2730168)}k=UPf(0,d)|0;i=b;return k|0}return 0}function oPf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;sih();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[889056]|0);ivh(f)}else{c[a+20>>2]=b;c[a+24>>2]=d;RPf(a);i=e;return}}function pPf(a,b){a=a|0;b=b|0;c[a+40>>2]=b;return}function qPf(a,b){a=a|0;b=b|0;c[a+44>>2]=b;return}function rPf(a,b){a=a|0;b=b|0;var c=0;c=i;lPf(a,b,ea(1.0));i=c;return}function sPf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;mPf(a,b,ea(1.0),c,d);i=e;return}function tPf(a,b,d,e,f){a=a|0;b=b|0;d=ea(d);e=e|0;f=f|0;var g=0,h=0;g=i;pih();if(!b){mPf(a,0,d,e,f);RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888962]|0);ivh(h)}mPf(a,cth(2647352,b)|0,d,e,f);f=Sqh(2733848,b)|0;if(!(jth(2568176,f)|0)){i=g;return}do{b=Sqh(2733904,f)|0;Rrh(2734016,a,b,Sqh(2733960,f)|0)}while(jth(2568176,f)|0);i=g;return}function uPf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;tPf(a,b,ea(1.0),c,d);i=e;return}function vPf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;mPf(a,1,ea(1.0),b,c);i=d;return}function wPf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;lPf(a,b,ea(1.0));c[a+52>>2]=d;i=e;return}function xPf(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=e|0;var f=0;f=i;lPf(a,b,d);c[a+52>>2]=e;i=f;return}function yPf(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;RI(1101728)|0;e=hvh(1101728,34)|0;c[d>>2]=3140280;c[b+0>>2]=c[d+0>>2];Guf(0,e,b);RI(2730168)|0;c[(c[682565]|0)+4>>2]=e;i=a;return}function zPf(b){b=b|0;var c=0,d=0;c=i;RI(2731296)|0;if(!(a[2731444]|0)){RI(2731296)|0;fvh(2731296)}RI(2731296)|0;d=qL(2731296)|0;ROf(d,b,2);i=c;return d|0}function APf(a){a=a|0;return c[a+8>>2]|0}function BPf(a){a=a|0;return a|0}function CPf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+32|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}RI(2732584)|0;e=qL(2732584)|0;_Of(e,a);c[d>>2]=e;f=e;i=b;return f|0}function DPf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;nih();if(!b){RI(2963920)|0;e=qL(2963920)|0;uig(e,c[888910]|0,c[888912]|0);ivh(e)}e=c[a+20>>2]|0;f=c[a+24>>2]|0;g=c[e+12>>2]|0;h=(Erh(2734072,a,b)|0)&2147483647;j=((((h>>>5)+1|0)>>>0)%((g+-1|0)>>>0)|0)+1|0;if(!g){k=0;i=d;return k|0}l=e+16|0;m=f+16|0;n=h;o=g;while(1){p=(n>>>0)%(g>>>0)|0;q=da(c[(c[e>>2]|0)+120>>2]|0,p)|0;r=c[l+q>>2]|0;s=c[l+(q+4)>>2]|0;q=c[m+(da(c[(c[f>>2]|0)+120>>2]|0,p)|0)>>2]|0;if(!r){k=0;t=11;break}if((r|0)==(b|0)){k=s;t=11;break}if((q&2147483647|0)==(h|0)?Frh(2734128,a,b,r)|0:0){k=s;t=11;break}if((q|0)>=0){k=0;t=11;break}o=o+-1|0;if(!o){k=0;t=11;break}else n=j+p|0}if((t|0)==11){i=d;return k|0}return 0}function EPf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;FPf(a,b,c,1);i=d;return}function FPf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;uih();if(!d){RI(2963920)|0;h=qL(2963920)|0;uig(h,c[889070]|0,c[889072]|0);ivh(h)}h=b+8|0;if((c[h>>2]|0)>=(c[b+28>>2]|0))SPf(b);j=b+20|0;k=c[(c[j>>2]|0)+12>>2]|0;l=(Erh(2734072,b,d)|0)&2147483647;m=((((l>>>5)+1|0)>>>0)%((k+-1|0)>>>0)|0)+1|0;n=c[j>>2]|0;j=c[b+24>>2]|0;if(!k){i=g;return}o=n+16|0;p=j+16|0;q=l;r=-1;s=0;while(1){t=(q>>>0)%(k>>>0)|0;u=c[o+(da(c[(c[n>>2]|0)+120>>2]|0,t)|0)>>2]|0;v=c[p+(da(c[(c[j>>2]|0)+120>>2]|0,t)|0)>>2]|0;if((r|0)==-1){RI(2730360)|0;if(!(a[2730508]|0)){RI(2730360)|0;fvh(2730360)}RI(2730360)|0;w=((v|0)<0?(u|0)==(c[c[682613]>>2]|0):0)?t:-1}else w=r;if(!u){x=t;y=w;z=14;break}RI(2730360)|0;if(!(a[2730508]|0)){RI(2730360)|0;fvh(2730360)}RI(2730360)|0;if(!((v|0)<0?1:(u|0)!=(c[c[682613]>>2]|0))){x=t;y=w;z=14;break}if((v&2147483647|0)==(l|0)?Frh(2734128,b,d,u)|0:0){A=t;z=17;break}if((w|0)==-1){u=p+(da(c[(c[j>>2]|0)+120>>2]|0,t)|0)|0;c[u>>2]=c[u>>2]|-2147483648}s=s+1|0;u=((s|0)<0)<<31>>31;if(!(u>>>0<0|(u|0)==0&s>>>0<k>>>0)){B=w;break}else{q=m+q|0;r=w}}if((z|0)==14)B=(y|0)==-1?x:y;else if((z|0)==17){if(f){c[o+((da(c[(c[n>>2]|0)+120>>2]|0,A)|0)+4)>>2]=e;A=b+12|0;c[A>>2]=(c[A>>2]|0)+1;i=g;return}if(a[2540708]|0){C=c[889074]|0;D=fwf(0,C,d)|0;RI(2965048)|0;E=qL(2965048)|0;Rbg(E,D);ivh(E)}fvh(2540560);C=c[889074]|0;D=fwf(0,C,d)|0;RI(2965048)|0;E=qL(2965048)|0;Rbg(E,D);ivh(E)}if((B|0)==-1){i=g;return}E=n+16|0;c[E+(da(c[(c[n>>2]|0)+120>>2]|0,B)|0)>>2]=d;c[E+((da(c[(c[n>>2]|0)+120>>2]|0,B)|0)+4)>>2]=e;e=j+16+(da(c[(c[j>>2]|0)+120>>2]|0,B)|0)|0;c[e>>2]=c[e>>2]|l;c[h>>2]=(c[h>>2]|0)+1;h=b+12|0;c[h>>2]=(c[h>>2]|0)+1;i=g;return}function GPf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;qih();if(!b){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[888966]|0);ivh(h)}if((d|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[888968]|0);ivh(h)}if((sDf(b)|0)>=2){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[888970]|0);ivh(h)}if((PCf(b)|0)>=1?(PCf(b)|0)<=(d|0):0){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[888972]|0);ivh(h)}h=c[a+8>>2]|0;if((h+d|0)>(PCf(b)|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[888974]|0);ivh(h)}h=bth(2734184,a)|0;if(!(jth(2568176,h)|0)){i=e;return}a=d;while(1){xrh(f,2734240,h);d=f;j=c[d+4>>2]|0;k=g;c[k>>2]=c[d>>2];c[k+4>>2]=j;RI(2729368)|0;bEf(b,pL(2729368,g)|0,a);if(jth(2568176,h)|0)a=a+1|0;else break}i=e;return}function HPf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;FPf(a,b,c,0);i=d;return}function IPf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=c[a+20>>2]|0;e=d+12|0;if((c[e>>2]|0)<=0){f=a+8|0;c[f>>2]=0;g=a+12|0;h=c[g>>2]|0;j=h+1|0;c[g>>2]=j;i=b;return}k=d+16|0;l=c[a+24>>2]|0;m=l+16|0;n=0;do{c[k+(da(c[(c[d>>2]|0)+120>>2]|0,n)|0)>>2]=0;c[k+((da(c[(c[d>>2]|0)+120>>2]|0,n)|0)+4)>>2]=0;c[m+(da(c[(c[l>>2]|0)+120>>2]|0,n)|0)>>2]=0;n=n+1|0}while((n|0)<(c[e>>2]|0));f=a+8|0;c[f>>2]=0;g=a+12|0;h=c[g>>2]|0;j=h+1|0;c[g>>2]=j;i=b;return}function JPf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(KPf(a,b)|0)>-1;i=c;return d|0}function KPf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;tih();if(!b){RI(2963920)|0;e=qL(2963920)|0;uig(e,c[889064]|0,c[889066]|0);ivh(e)}e=c[a+20>>2]|0;f=c[a+24>>2]|0;g=c[e+12>>2]|0;h=(Erh(2734072,a,b)|0)&2147483647;j=((((h>>>5)+1|0)>>>0)%((g+-1|0)>>>0)|0)+1|0;if(!g){k=-1;i=d;return k|0}l=e+16|0;m=f+16|0;n=h;o=g;while(1){p=(n>>>0)%(g>>>0)|0;q=c[l+(da(c[(c[e>>2]|0)+120>>2]|0,p)|0)>>2]|0;r=c[m+(da(c[(c[f>>2]|0)+120>>2]|0,p)|0)>>2]|0;if(!q){k=-1;s=11;break}if((q|0)==(b|0)){k=p;s=11;break}if((r&2147483647|0)==(h|0)?Frh(2734128,a,b,q)|0:0){k=p;s=11;break}if((r|0)>=0){k=-1;s=11;break}o=o+-1|0;if(!o){k=-1;s=11;break}else n=j+p|0}if((s|0)==11){i=d;return k|0}return 0}function LPf(b){b=b|0;var c=0,d=0;c=i;RI(2731296)|0;if(!(a[2731444]|0)){RI(2731296)|0;fvh(2731296)}RI(2731296)|0;d=qL(2731296)|0;ROf(d,b,2);i=c;return d|0}function MPf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=KPf(b,d)|0;if((f|0)<0){i=e;return}d=c[b+20>>2]|0;g=c[b+24>>2]|0;h=g+16+(da(c[(c[g>>2]|0)+120>>2]|0,f)|0)|0;g=c[h>>2]&-2147483648;c[h>>2]=g;h=d+16|0;j=h+(da(c[(c[d>>2]|0)+120>>2]|0,f)|0)|0;if(!g)k=0;else{RI(2730360)|0;if(!(a[2730508]|0)){RI(2730360)|0;fvh(2730360)}RI(2730360)|0;k=c[c[682613]>>2]|0}c[j>>2]=k;c[h+((da(c[(c[d>>2]|0)+120>>2]|0,f)|0)+4)>>2]=0;f=b+8|0;c[f>>2]=(c[f>>2]|0)+-1;f=b+12|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}function NPf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nrh(2734296,a,b)|0;i=c;return d|0}function OPf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=0,j=0,k=0;d=i;rih();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[889012]|0);ivh(e)}f=ea(g[a+16>>2]);hag(b,c[889014]|0,f);r9f(b,c[889016]|0,c[a+12>>2]|0);e=a+52|0;h=c[e>>2]|0;if(!h)L7f(b,c[889020]|0,c[a+44>>2]|0);else L7f(b,c[889018]|0,h);h=c[a+40>>2]|0;if(h)L7f(b,c[889022]|0,h);r9f(b,c[889024]|0,c[(c[a+20>>2]|0)+12>>2]|0);h=a+8|0;j=c[h>>2]|0;RI(1086352)|0;k=hvh(1086352,j)|0;cPf(a,k,0,0);j=c[h>>2]|0;RI(1086352)|0;h=hvh(1086352,j)|0;cPf(a,h,0,1);L7f(b,c[889026]|0,k);L7f(b,c[889028]|0,h);L7f(b,c[889030]|0,c[e>>2]|0);i=d;return}function PPf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+52>>2]|0;if(e){f=Zqh(2734352,e,b)|0;i=d;return f|0}e=c[a+40>>2]|0;if(!e){f=Aqh(2536720,b)|0;i=d;return f|0}else{f=Zqh(2734408,e,b)|0;i=d;return f|0}return 0}function QPf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;RI(2730360)|0;if(!(a[2730508]|0)){RI(2730360)|0;fvh(2730360)}RI(2730360)|0;if((c[c[682613]>>2]|0)==(e|0)){g=0;i=f;return g|0}h=c[b+52>>2]|0;if(h){g=Urh(2734464,h,d,e)|0;i=f;return g|0}h=c[b+44>>2]|0;if(!h){g=nrh(2536048,d,e)|0;i=f;return g|0}else{g=(hth(2734520,h,d,e)|0)==0;i=f;return g|0}return 0}function RPf(a){a=a|0;var b=0,d=0;b=c[(c[a+20>>2]|0)+12>>2]|0;d=~~ea(ea(b|0)*ea(g[a+16>>2]));c[a+28>>2]=(d|0)<(b|0)?d:b+-1|0;return}function SPf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;e=b+20|0;f=c[(c[e>>2]|0)+12>>2]|0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;fvh(2730168)}g=nPf(0,f<<1|1)|0;RI(1190920)|0;h=hvh(1190920,g)|0;j=c[e>>2]|0;RI(1101728)|0;e=hvh(1101728,g)|0;k=c[b+24>>2]|0;if((f|0)<=0){l=b+12|0;m=c[l>>2]|0;n=m+1|0;c[l>>2]=n;oPf(b,h,e);i=d;return}o=j+16|0;p=k+16|0;q=g+-1|0;r=h+16|0;s=e+16|0;t=c[j>>2]|0;j=0;do{u=da(c[t+120>>2]|0,j)|0;v=c[o+u>>2]|0;w=c[o+(u+4)>>2]|0;if(v){u=c[p+(da(c[(c[k>>2]|0)+120>>2]|0,j)|0)>>2]&2147483647;x=((((u>>>5)+1|0)>>>0)%(q>>>0)|0)+1|0;y=(u>>>0)%(g>>>0)|0;z=(c[h>>2]|0)+120|0;A=c[z>>2]|0;B=r+(da(A,y)|0)|0;if(!(c[B>>2]|0)){C=B;D=A;E=y}else{A=u;B=y;while(1){y=s+(da(c[(c[e>>2]|0)+120>>2]|0,B)|0)|0;c[y>>2]=c[y>>2]|-2147483648;A=x+A|0;y=(A>>>0)%(g>>>0)|0;F=c[z>>2]|0;G=r+(da(F,y)|0)|0;if(!(c[G>>2]|0)){C=G;D=F;E=y;break}else B=y}}c[C>>2]=v;c[r+((da(D,E)|0)+4)>>2]=w;B=s+(da(c[(c[e>>2]|0)+120>>2]|0,E)|0)|0;c[B>>2]=c[B>>2]|u}j=j+1|0}while((j|0)!=(f|0));l=b+12|0;m=c[l>>2]|0;n=m+1|0;c[l>>2]=n;oPf(b,h,e);i=d;return}function TPf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=i;a:do if(b&1){c=~~+T(+(+(b|0)));if((c|0)>3){d=3;while(1){if(!((b|0)%(d|0)|0)){e=0;break a}d=d+2|0;if((d|0)>=(c|0)){e=1;break}}}else e=1}else e=(b|0)==2;while(0);i=a;return e|0}function UPf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;d=(c&-2)+-1|0;if((d|0)==2147483647){e=c;i=b;return e|0}else f=d;while(1){RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;fvh(2730168)}if(TPf(0,f)|0){e=f;g=6;break}f=f+2|0;if((f|0)==2147483647){e=c;g=6;break}}if((g|0)==6){i=b;return e|0}return 0}function VPf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;a=qL(2706296)|0;RI(2721152)|0;OLf(a,ML(c[680304]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+12>>2]=a;i=b;return}function WPf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2737920)|0);c[c[d>>2]>>2]=a;i=b;return}function XPf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2737984)|0);c[c[d>>2]>>2]=a;i=b;return}function YPf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2738040)|0);c[c[d>>2]>>2]=a;i=b;return}function ZPf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2738112)|0);c[c[d>>2]>>2]=a;i=b;return}function _Pf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2738176)|0);c[c[d>>2]>>2]=a;i=b;return}function $Pf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function aQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function bQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2738224)|0);c[c[d>>2]>>2]=a;i=b;return}function cQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2738224)|0);c[c[d>>2]>>2]=a;i=b;return}function dQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function eQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function fQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function gQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function hQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2740072)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function iQf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;c[a+12>>2]=c[b+24>>2];c[a+16>>2]=-2;return}function jQf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(((c[a+12>>2]|0)==(c[d+24>>2]|0)?(e=c[a+16>>2]|0,e>>>0<=4294967293):0)?(e|0)<=(c[d+16>>2]|0):0){a=c[d+8>>2]|0;d=c[a+16+(da(c[(c[a>>2]|0)+120>>2]|0,e)|0)>>2]|0;i=b;return d|0}RI(3084976)|0;d=qL(3084976)|0;nsg(d);ivh(d);return 0}function kQf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+8>>2]|0;if((c[a+12>>2]|0)!=(c[d+24>>2]|0)){RI(3084976)|0;e=qL(3084976)|0;nsg(e);ivh(e)}e=a+16|0;a=c[e>>2]|0;if((a|0)==-2){f=c[d+12>>2]|0;c[e>>2]=f;g=(f|0)!=-1;i=b;return g|0}else if((a|0)==-1){g=0;i=b;return g|0}else{c[e>>2]=a+-1;g=(a|0)!=0;i=b;return g|0}return 0}function lQf(a){a=a|0;var b=0;b=i;c[a+12>>2]=-1;RI(1086352)|0;c[a+8>>2]=hvh(1086352,16)|0;c[a+20>>2]=16;i=b;return}function mQf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=Asg(0,b,16)|0;RI(1086352)|0;b=hvh(1086352,e)|0;f=a+8|0;vEf(0,c[f>>2]|0,b,c[a+16>>2]|0);c[a+20>>2]=e;c[f>>2]=b;i=d;return}function nQf(a){a=a|0;return c[a+16>>2]|0}function oQf(a){a=a|0;return a|0}function pQf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+24|0;c[d>>2]=(c[d>>2]|0)+1;d=a+16|0;e=c[d>>2]|0;if((e|0)<=0){c[d>>2]=0;f=a+12|0;c[f>>2]=-1;i=b;return}g=a+8|0;h=0;do{j=c[g>>2]|0;c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>2]=0;h=h+1|0}while((h|0)<(e|0));c[d>>2]=0;f=a+12|0;c[f>>2]=-1;i=b;return}function qQf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;zih();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[889162]|0);ivh(f)}if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[889164]|0);ivh(f)}do if((sDf(b)|0)<=1){if((PCf(b)|0)>=1?(PCf(b)|0)<=(d|0):0)break;f=a+16|0;g=c[f>>2]|0;if((g|0)<=((PCf(b)|0)-d|0)){g=c[a+12>>2]|0;if((g|0)==-1){i=e;return}h=a+8|0;j=d+-1|0;k=g;while(1){g=c[h>>2]|0;bEf(b,c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,k)|0)>>2]|0,j-k+(c[f>>2]|0)|0);if(!k)break;else k=k+-1|0}i=e;return}}while(0);RI(2965048)|0;e=qL(2965048)|0;oig(e);ivh(e)}function rQf(a){a=a|0;var b=0,c=0;b=i;RI(2740168)|0;c=qL(2740168)|0;iQf(c,a);i=b;return c|0}function sQf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+12|0;e=c[d>>2]|0;if((e|0)==-1){RI(3084976)|0;f=qL(3084976)|0;nsg(f);ivh(f)}f=a+24|0;c[f>>2]=(c[f>>2]|0)+1;f=c[a+8>>2]|0;g=f+16+(da(c[(c[f>>2]|0)+120>>2]|0,e)|0)|0;f=c[g>>2]|0;c[g>>2]=0;g=a+16|0;h=c[g>>2]|0;j=h+-1|0;c[g>>2]=j;c[d>>2]=e+-1;e=c[a+20>>2]|0;if((h|0)<18?1:(j|0)>((e|0)/4|0|0)){i=b;return f|0}mQf(a,(e|0)/2|0);i=b;return f|0}function tQf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+24|0;c[e>>2]=(c[e>>2]|0)+1;e=c[a+20>>2]|0;f=a+16|0;g=c[f>>2]|0;if((e|0)==(g|0)){mQf(a,e<<1);h=c[f>>2]|0}else h=g;c[f>>2]=h+1;h=a+12|0;f=(c[h>>2]|0)+1|0;c[h>>2]=f;h=c[a+8>>2]|0;Qqh(h,b);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,f)|0)>>2]=b;i=d;return}function uQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2706112)|0;NLf(a,sM(2706280)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2706296)|0;RI(2721152)|0;OLf(a,ML(c[680304]|0)|0);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function vQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function wQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function xQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function yQf(b,d){b=b|0;d=d|0;c[b+12>>2]=d;a[b+8>>0]=d&1;a[b+9>>0]=d>>>8&1;return}function zQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,3);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function AQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,4509);Dpf(a,1);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function BQf(a){a=a|0;return}function CQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,108);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function DQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,13);Dpf(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function EQf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+8|0;c[f>>2]=-1;g=a+12|0;c[g>>2]=-1;FQf(0,b+2|0,d,a+16|0,f,g,a+20|0,a+24|0,a+28|0)|0;i=e;return}function FQf(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0;a=i;l=c[686232]|0;if(!l){m=MK(2744936)|0;c[686232]=m;n=m}else n=l;l=Oo[n&63](b,d,e,f,g,h,j,k)|0;i=a;return l|0}function GQf(a){a=a|0;return c[a+24>>2]|0}function HQf(a){a=a|0;return c[a+20>>2]|0}function IQf(a){a=a|0;var b=0,d=0;b=i;Aih();if(!(c[a+20>>2]|0)){d=c[889168]|0;i=b;return d|0}d=Fqh(2745112,a)|0;i=b;return d|0}function JQf(a){a=a|0;return c[a+8>>2]|0}function KQf(a){a=a|0;return c[a+16>>2]|0}function LQf(a){a=a|0;return c[a+12>>2]|0}function MQf(a){a=a|0;return c[a+32>>2]|0}function NQf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;Bih();RI(2971904)|0;f=qL(2971904)|0;Gbg(f);g=c[a+16>>2]|0;if(!g)Hbg(f,tof(0,c[889182]|0)|0)|0;else Hbg(f,Fqh(2649752,g)|0)|0;Hbg(f,tof(0,c[889184]|0)|0)|0;g=a+8|0;if((c[g>>2]|0)==-1)Hbg(f,tof(0,c[889186]|0)|0)|0;else{Hbg(f,tof(0,c[889188]|0)|0)|0;gfg(f,c[g>>2]|0)|0}Hbg(f,tof(0,c[889190]|0)|0)|0;Hbg(f,IQf(a)|0)|0;c[d>>2]=c[a+24>>2];RI(2540224)|0;g=pL(2540224,d)|0;c[e>>2]=c[a+28>>2];RI(2540224)|0;a=pL(2540224,e)|0;ocg(f,c[889192]|0,g,a)|0;a=Fqh(2972072,f)|0;i=b;return a|0}function OQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2746424)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function PQf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;QQf(a,b,c);i=d;return}function QQf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+4|0;h=f;Dih();if((d|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[889242]|0,c[889244]|0);ivh(j)}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;fvh(2713640)}RI(2713640)|0;j=qL(2713640)|0;$Lf(j);k=d+2|0;RI(2745184)|0;d=qL(2745184)|0;EQf(d,k,e);a:do if(d){l=k;m=d;do{if(!(zuh(2746160,m)|0))break a;Erh(2714056,j,m)|0;l=l+1|0;RI(2745184)|0;m=qL(2745184)|0;EQf(m,l,e)}while((m|0)!=0)}while(0);a[b+12>>0]=e&1;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[h>>2]=3445360;c[g+0>>2]=c[h+0>>2];h=Uuh(2715064,j,npf(0,g)|0)|0;RI(1196168)|0;c[b+8>>2]=mvh(h,1196168)|0;i=f;return}function RQf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;TQf(a,b,0,c,0);i=d;return}function SQf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;TQf(a,b,c,d,0);i=e;return}function TQf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+16|0;j=h+4|0;k=h;Cih();if(!d){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[889226]|0);ivh(l)}if((e|0)<=-1){RI(2964880)|0;l=qL(2964880)|0;Qag(l,c[889228]|0,c[889230]|0);ivh(l)}l=UQf(0,d,e,f)|0;f=b+8|0;c[f>>2]=l;if(g){i=h;return}if((c[l+12>>2]|0)>0){m=l;n=0;o=0}else{i=h;return}do{n=(zuh(2746160,c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,o)|0)>>2]|0)|0)==0|n;o=o+1|0;m=c[f>>2]|0}while((o|0)<(c[m+12>>2]|0));if(!n){i=h;return}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;fvh(2713640)}RI(2713640)|0;n=qL(2713640)|0;$Lf(n);m=c[f>>2]|0;if((c[m+12>>2]|0)>0){o=m;m=0;do{if(zuh(2746160,c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,m)|0)>>2]|0)|0){l=c[f>>2]|0;Erh(2714056,n,c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,m)|0)>>2]|0)|0}m=m+1|0;o=c[f>>2]|0}while((m|0)<(c[o+12>>2]|0))}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[k>>2]=3445360;c[j+0>>2]=c[k+0>>2];k=Uuh(2715064,n,npf(0,j)|0)|0;RI(1196168)|0;c[f>>2]=mvh(k,1196168)|0;i=h;return}function UQf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[686660]|0;if(!f){g=MK(2746648)|0;c[686660]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function VQf(a){a=a|0;var b=0,d=0;b=c[a+8>>2]|0;if(!b)d=0;else d=c[b+12>>2]|0;return d|0}function WQf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((b|0)<0){e=0;i=d;return e|0}if((Aqh(2746736,a)|0)<=(b|0)){e=0;i=d;return e|0}f=c[a+8>>2]|0;e=c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b)|0)>>2]|0;i=d;return e|0}function XQf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d;Eih();f=org(0)|0;g=tof(0,c[889250]|0)|0;if(!(a[2540708]|0))fvh(2540560);h=awf(0,c[889248]|0,f,g)|0;g=tof(0,c[889252]|0)|0;f=tof(0,c[889254]|0)|0;RI(2971904)|0;j=qL(2971904)|0;Gbg(j);if((Aqh(2746736,b)|0)<=0){k=Fqh(2972072,j)|0;i=d;return k|0}l=b+12|0;m=0;do{n=yuh(2746792,b,m)|0;if((m|0)<1){o=tof(0,c[889258]|0)|0;qcg(j,c[889256]|0,o)|0}else Hbg(j,h)|0;o=zuh(2746160,n)|0;if(!o)Hbg(j,g)|0;else{p=Fqh(2537592,suh(2658656,o)|0)|0;q=Fqh(2649752,o)|0;ocg(j,c[889260]|0,p,q)|0;Hbg(j,c[889262]|0)|0;q=xuh(2849384,o)|0;o=q+12|0;if((c[o>>2]|0)>0){p=q+16|0;r=0;do{if((r|0)>=1)Hbg(j,c[889264]|0)|0;s=suh(2849496,c[p+(da(c[(c[q>>2]|0)+120>>2]|0,r)|0)>>2]|0)|0;t=Gqh(2653184,s)|0;if(t)u=suh(2619720,s)|0;else u=s;if(Gqh(2653256,u)|0){s=Fqh(2653928,u)|0;if(!(a[2540708]|0))fvh(2540560);if(Iwf(0,s,c[c[635163]>>2]|0)|0){Hbg(j,Fqh(2653928,u)|0)|0;Hbg(j,c[889266]|0)|0}}Hbg(j,Fqh(2649752,u)|0)|0;if(t)Hbg(j,c[889268]|0)|0;t=Fqh(2849440,c[p+(da(c[(c[q>>2]|0)+120>>2]|0,r)|0)>>2]|0)|0;qcg(j,c[889270]|0,t)|0;r=r+1|0}while((r|0)<(c[o>>2]|0))}Hbg(j,c[889272]|0)|0}if(a[l>>0]|0){o=IQf(n)|0;if(!(a[2540708]|0))fvh(2540560);if(Iwf(0,o,c[889274]|0)|0){c[e>>2]=Aqh(2745936,n)|0;RI(2540224)|0;ocg(j,f,o,pL(2540224,e)|0)|0}}m=m+1|0}while((m|0)<(Aqh(2746736,b)|0));k=Fqh(2972072,j)|0;i=d;return k|0}function YQf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2747800)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function ZQf(a){a=a|0;c[a+12>>2]=99;return}function _Qf(b){b=b|0;var d=0;d=i;Gih();if(!(a[b+8>>0]|0)){i=d;return}else{RI(3084976)|0;d=qL(3084976)|0;osg(d,c[889330]|0);ivh(d)}}function $Qf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;Fih();d=a+20|0;e=c[d>>2]|0;if((e|0)!=0?(f=uvh(2747976,a)|0,(c[e+12>>2]|0)==(c[f+12>>2]|0)):0){f=bth(2628880,c[d>>2]|0)|0;RI(1094176)|0;d=mvh(f,1094176)|0;i=b;return d|0}RI(2589312)|0;d=qL(2589312)|0;Vxf(d,c[889306]|0);ivh(d);return 0}function aRf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function bRf(a,b,c){a=a|0;b=b|0;c=c|0;a=~~+R(+(+(b|0)/+(c|0)));return a|0}function cRf(a,b,c){a=a|0;b=b|0;c=c|0;a=b-(da(~~+R(+(+(b|0)/+(c|0))),c)|0)|0;return a|0}function dRf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;a=~~+R(+(+(d|0)/+(e|0)));c[b>>2]=d-(da(a,e)|0);return a|0}function eRf(a,b){a=a|0;b=b|0;var c=0;a=i;c=Xog(b)|0;b=eFi(c|0,H|0,711573504,201)|0;i=a;return b+1|0}function fRf(a,b){a=a|0;b=b|0;a=(da(~~+R(+(+(b|0)/7.0)),-7)|0)+b|0;return a|0}function gRf(a,b){a=a|0;b=b|0;var c=0.0,d=0,e=0;a=i;c=+(b|0);if((~~+R(+(c*.25))<<2|0)==(b|0)?(d=(da(~~+R(+(c/400.0)),-400)|0)+b|0,!((d|0)==300|(d|0)==200|(d|0)==100)):0)e=1;else e=0;i=a;return e|0}function hRf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,j=0;a=i;e=d+-1|0;f=+(e|0);g=~~+R(+(f*.25))+(e*365|0)-~~+R(+(f/100.0))+~~+R(+(f/400.0))+~~+R(+(+((c*367|0)+-362|0)/12.0))|0;if((c|0)<3){h=g;j=h+b|0;i=a;return j|0}c=gRf(0,d)|0;h=(c?-1:-2)+g|0;j=h+b|0;i=a;return j|0}function iRf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=b+-1|0;b=~~+R(+(+(a|0)/146097.0));c=(da(b,-146097)|0)+a|0;a=~~+R(+(+(c|0)/36524.0));d=(da(a,-36524)|0)+c|0;c=~~+R(+(+(d|0)/1461.0));e=~~+R(+(+((da(c,-1461)|0)+d|0)/365.0));return (a*100|0)+(b*400|0)+(c<<2)+e+((a|0)!=4&(e|0)!=4&1)|0}function jRf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;f=iRf(0,e)|0;c[d>>2]=f;d=e-(hRf(0,1,1,f)|0)|0;if((hRf(0,1,3,f)|0)>(e|0))g=0;else{e=gRf(0,f)|0;g=e?1:2}c[b>>2]=~~+R(+(+(((d+g|0)*12|0)+373|0)/367.0));i=a;return}function kRf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;a=i;jRf(0,d,e,f);c[b>>2]=f+1-(hRf(0,1,c[d>>2]|0,c[e>>2]|0)|0);i=a;return}function lRf(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;i=i+16|0;d=a+4|0;e=a;c[d>>2]=0;c[e>>2]=0;jRf(0,d,e,b);i=a;return c[d>>2]|0}function mRf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+16|0;d=a+8|0;e=a+4|0;f=a;c[d>>2]=0;c[e>>2]=0;c[f>>2]=0;kRf(0,d,e,f,b);i=a;return c[d>>2]|0}function nRf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=Xog(d)|0;d=eFi(b|0,H|0,711573504,201)|0;b=mRf(0,d+1|0)|0;i=a;return b|0}function oRf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=Xog(d)|0;d=eFi(b|0,H|0,711573504,201)|0;b=lRf(0,d+1|0)|0;i=a;return b|0}function pRf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=Xog(d)|0;d=eFi(b|0,H|0,711573504,201)|0;b=iRf(0,d+1|0)|0;i=a;return b|0}function qRf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[b+8>>2]=Aqh(2686456,d)|0;RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}if(!(rRf(0)|0)){h=sRf(d)|0;c[b+12>>2]=h;tRf(b,h);i=e;return}RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}RI(2751256)|0;h=c[(c[687837]|0)+8>>2]|0;Jag(0,h);RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}RI(2751256)|0;if(!(c[(c[687837]|0)+4>>2]|0)){RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;fvh(2730168)}RI(2730168)|0;j=qL(2730168)|0;kPf(j);RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}RI(2751256)|0;c[(c[687837]|0)+4>>2]=j}RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}c[f>>2]=Aqh(2686456,d)|0;RI(2540224)|0;j=pL(2540224,f)|0;RI(2751256)|0;f=uth(2736488,c[(c[687837]|0)+4>>2]|0,j)|0;RI(2685712)|0;j=mvh(f,2685712)|0;f=b+16|0;c[f>>2]=j;if(!j){RI(2685712)|0;if(!(a[2685860]|0)){RI(2685712)|0;fvh(2685712)}RI(2685712)|0;j=qL(2685712)|0;bKf(j,d);c[f>>2]=j;RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}c[g>>2]=Aqh(2686456,d)|0;RI(2540224)|0;d=pL(2540224,g)|0;g=c[f>>2]|0;RI(2751256)|0;Rrh(2736568,c[(c[687837]|0)+4>>2]|0,d,g)}Kag(0,h);i=e;return}function rRf(b){b=b|0;b=i;RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}RI(2751256)|0;i=b;return (a[c[687837]>>0]|0)!=0|0}function sRf(b){b=b|0;var d=0;d=i;if(!(a[b+112>>0]|0))dSf(b);i=d;return c[b+72>>2]|0}function tRf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[687856]|0;if(!e){f=MK(2751432)|0;c[687856]=f;g=f}else g=e;In[g&4095](a,b);i=d;return}function uRf(b){b=b|0;var d=0,e=0;b=i;Hih();d=urg(0,c[889348]|0)|0;if(!(a[2540708]|0))fvh(2540560);if(Iwf(0,d,c[889350]|0)|0)e=(nzg(0)|0)&1;else e=0;RI(2751256)|0;a[c[687837]>>0]=e;RI(2536312)|0;e=qL(2536312)|0;RI(2751256)|0;c[(c[687837]|0)+8>>2]=e;i=b;return}function vRf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[687876]|0;if(!d){e=MK(2751512)|0;c[687876]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function wRf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;k=i;l=c[687894]|0;if(!l){m=MK(2751584)|0;c[687894]=m;n=m}else n=l;l=Oo[n&63](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function xRf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[687938]|0;if(!g){h=MK(2751760)|0;c[687938]=h;j=h}else j=g;Dn[j&511](a,b,d,e);i=f;return}function yRf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;k=c[687970]|0;if(!k){l=MK(2751888)|0;c[687970]=l;m=l}else m=k;k=gn[m&127](a,b,d,e,f,g,h)|0;i=j;return k|0}function zRf(a){a=a|0;var b=0;b=i;vRf(a);i=b;return}function ARf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=JKf(c[a+16>>2]|0,b,d,e,f,g,h,j)|0;i=k;return l|0}function BRf(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}if(rRf(0)|0){m=JKf(c[b+16>>2]|0,d,e,f,g,h,j,k)|0;i=l;return m|0}else{m=wRf(b,d,e,f,g,h,j,k)|0;i=l;return m|0}return 0}function CRf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Nuh(2724e3,a,b,c,0)|0;i=d;return e|0}function DRf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;Iih();if((e&1879048223|0)!=(e|0)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[889370]|0);ivh(g)}g=(d|0)!=0;if(!b){h=g<<31>>31;i=f;return h|0}if(!g){h=1;i=f;return h|0}if((Vof(b)|0)==0?(Vof(d)|0)==0:0){h=0;i=f;return h|0}g=Vof(b)|0;h=BRf(a,b,0,g,d,0,Vof(d)|0,e)|0;i=f;return h|0}function ERf(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0;k=i;Jih();if((j&1879048223|0)!=(j|0)){RI(2965048)|0;l=qL(2965048)|0;Rbg(l,c[889374]|0);ivh(l)}l=(f|0)!=0;if(!b){m=l<<31>>31;i=k;return m|0}if(!l){m=1;i=k;return m|0}if(!((Vof(b)|0)!=0?(Vof(b)|0)!=(d|0)&(e|0)!=0:0)){if(!(Vof(f)|0)){m=0;i=k;return m|0}if(!((Vof(f)|0)!=(g|0)&(h|0)!=0)){m=0;i=k;return m|0}}if((e|d|g|h|0)<=-1){RI(2964880)|0;l=qL(2964880)|0;wdg(l,c[889376]|0);ivh(l)}if((Vof(b)|0)<(d|0)){RI(2964880)|0;l=qL(2964880)|0;wdg(l,c[889378]|0);ivh(l)}if((Vof(f)|0)<(g|0)){RI(2964880)|0;l=qL(2964880)|0;wdg(l,c[889380]|0);ivh(l)}if(((Vof(b)|0)-d|0)<(e|0)){RI(2964880)|0;l=qL(2964880)|0;wdg(l,c[889382]|0);ivh(l)}if(((Vof(f)|0)-g|0)<(h|0)){RI(2964880)|0;l=qL(2964880)|0;wdg(l,c[889384]|0);ivh(l)}m=BRf(a,b,d,e,f,g,h,j)|0;i=k;return m|0}function FRf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2751256)|0;e=vL(b,2751256)|0;if(!e){f=0;i=d;return f|0}f=(c[e+8>>2]|0)==(c[a+8>>2]|0);i=d;return f|0}function GRf(a){a=a|0;return c[a+8>>2]|0}function HRf(a){a=a|0;return c[a+8>>2]|0}function IRf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;Kih();if((e|0)==268435456|(e|0)==1073741824){RI(2965048)|0;g=qL(2965048)|0;Rag(g,c[889556]|0,c[889558]|0);ivh(g)}RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}if(rRf(0)|0){h=uKf(c[b+16>>2]|0,d,e)|0;i=f;return h|0}else{g=c[b+8>>2]|0;RI(2694552)|0;j=qL(2694552)|0;c[j+20>>2]=g;c[j+8>>2]=d;c[j+12>>2]=e;xRf(b,j,d,e);h=j;i=f;return h|0}return 0}function JRf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Quh(2752048,a,b,c,d,e,0)|0;i=f;return g|0}function KRf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;k=c[a+16>>2]|0;if(h){l=UKf(k,b,f,d,e,g)|0;i=j;return l|0}else{l=SKf(k,b,f,d,e,g)|0;i=j;return l|0}return 0}function LRf(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}if((g|0)==1073741824&h|(rRf(0)|0)^1){k=yRf(b,c,d,e,f,g,h)|0;i=j;return k|0}else{k=KRf(b,c,d,e,f,g,h)|0;i=j;return k|0}return 0}function MRf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;Lih();if(!b){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[889576]|0);ivh(j)}if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[889578]|0);ivh(j)}if((e|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[889580]|0);ivh(j)}if((f|0)<0){RI(2964880)|0;k=qL(2964880)|0;l=c[889582]|0;wdg(k,l);ivh(k)}if(((Vof(b)|0)-e|0)<(f|0)){RI(2964880)|0;k=qL(2964880)|0;l=c[889582]|0;wdg(k,l);ivh(k)}if((g&1342177311|0)!=(g|0)){RI(2965048)|0;k=qL(2965048)|0;Rbg(k,c[889584]|0);ivh(k)}if(!(Vof(d)|0)){m=e;i=h;return m|0}if(!f){m=-1;i=h;return m|0}m=LRf(a,b,e,f,d,g,1)|0;i=h;return m|0}function NRf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;Mih();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[889592]|0);ivh(h)}if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[889594]|0);ivh(h)}RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}if(rRf(0)|0){j=NKf(c[b+16>>2]|0,d,e,f)|0;i=g;return j|0}h=Vof(d)|0;if((h|0)<(Vof(e)|0)){j=0;i=g;return j|0}h=Vof(e)|0;j=(Ouh(2752104,b,d,0,h,e,0,Vof(e)|0,f)|0)==0;i=g;return j|0}function ORf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;Nih();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[889602]|0);ivh(h)}if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[889604]|0);ivh(h)}RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}if(rRf(0)|0){j=QKf(c[b+16>>2]|0,d,e,f)|0;i=g;return j|0}h=Vof(d)|0;if((h|0)<(Vof(e)|0)){j=0;i=g;return j|0}h=Vof(d)|0;k=Vof(e)|0;l=Vof(e)|0;j=(Ouh(2752104,b,d,h-k|0,l,e,0,Vof(e)|0,f)|0)==0;i=g;return j|0}function PRf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Quh(2752160,a,b,c,d,e,0)|0;i=f;return g|0}function QRf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;Oih();if(!b){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[889612]|0);ivh(j)}if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[889614]|0);ivh(j)}if((e|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[889616]|0);ivh(j)}if(!((f|0)>-1&(e-f|0)>-2)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[889618]|0);ivh(j)}if((g&1342177311|0)!=(g|0)){RI(2965048)|0;j=qL(2965048)|0;Rbg(j,c[889620]|0);ivh(j)}if(!f){k=-1;i=h;return k|0}if(!(Vof(d)|0)){k=0;i=h;return k|0}k=LRf(a,b,e,f,d,g,0)|0;i=h;return k|0}function RRf(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;Pih();c[e>>2]=c[b+8>>2];RI(2540224)|0;b=pL(2540224,e)|0;if(!(a[2540708]|0))fvh(2540560);e=fwf(0,c[889624]|0,b)|0;i=d;return e|0}function SRf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function TRf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function URf(a,b){a=a|0;b=b|0;var c=0;c=i;WRf(a,b,1,0);i=c;return}function VRf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;WRf(a,b,c,0);i=d;return}function WRf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g;Qih();if((d|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[889636]|0,c[889638]|0);ivh(j)}a[b+112>>0]=1;a[b+8>>0]=f&1;a[b+32>>0]=e&1;if((d|0)==127){XRf(b,f);i=g;return}if(vSf(b,d)|0){i=g;return}c[h>>2]=d;RI(2540224)|0;d=pL(2540224,h)|0;if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[889640]|0,d)|0;RI(2965048)|0;d=qL(2965048)|0;Rag(d,h,c[889642]|0);ivh(d)}function XRf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;Vih();c[b+12>>2]=127;RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;fvh(2755888)}f=b+36|0;c[f>>2]=xSf(0)|0;RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}g=b+40|0;c[g>>2]=ySf(0)|0;if(!d){h=bth(2756672,c[f>>2]|0)|0;RI(2755888)|0;c[f>>2]=mvh(h,2755888)|0;h=bth(2756728,c[g>>2]|0)|0;RI(2756056)|0;c[g>>2]=mvh(h,2756056)|0}c[b+44>>2]=fSf(b,d)|0;if(!(a[2540708]|0))fvh(2540560);c[b+48>>2]=c[c[635163]>>2];d=c[889838]|0;c[b+60>>2]=d;c[b+56>>2]=d;c[b+52>>2]=d;c[b+64>>2]=c[889840];c[b+68>>2]=c[889842];c[b+72>>2]=c[889844];c[b+76>>2]=c[889846];i=e;return}function YRf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=vSf(a,b)|0;i=c;return d|0}function ZRf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;Rih();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[889688]|0);ivh(h)}a[b+112>>0]=1;a[b+8>>0]=f&1;a[b+32>>0]=e&1;if(!(Vof(d)|0)){XRf(b,f);i=g;return}if(_Rf(b,Xvf(d)|0)|0){i=g;return}if(!(a[2540708]|0))fvh(2540560);g=iwf(0,c[889690]|0,d,c[889692]|0)|0;RI(2965048)|0;d=qL(2965048)|0;Rag(d,g,c[889694]|0);ivh(d)}function _Rf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;c[f>>2]=0;Uih();if(!d){g=0;h=wSf(b,g)|0;i=e;return h|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}RI(2686624)|0;if(!(c[(c[671679]|0)+40>>2]|0)){RI(1838080)|0;j=qL(1838080)|0;dJe(j,2);bsh(1837968,j,c[889812]|0,0);bsh(1837968,j,c[889814]|0,1);RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}RI(2686624)|0;c[(c[671679]|0)+40>>2]=j}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}RI(2686624)|0;if(!(dsh(1839256,c[(c[671679]|0)+40>>2]|0,d,f)|0)){g=d;h=wSf(b,g)|0;i=e;return h|0}j=c[f>>2]|0;if(!j){g=c[889816]|0;h=wSf(b,g)|0;i=e;return h|0}else if((j|0)==1){g=c[889818]|0;h=wSf(b,g)|0;i=e;return h|0}else{g=d;h=wSf(b,g)|0;i=e;return h|0}return 0}function $Rf(a){a=a|0;var b=0;a=i;Sih();RI(2536312)|0;b=qL(2536312)|0;RI(2686624)|0;c[(c[671679]|0)+20>>2]=b;b=c[889716]|0;RI(2686624)|0;c[(c[671679]|0)+28>>2]=b;RI(2686624)|0;b=qL(2686624)|0;WRf(b,127,0,1);RI(2686624)|0;c[(c[671679]|0)+16>>2]=b;i=a;return}function aSf(a){a=a|0;return c[a+12>>2]|0}function bSf(a){a=a|0;return c[a+48>>2]|0}function cSf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+100|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}if(!(a[b+112>>0]|0))dSf(b);f=c[b+16>>2]|0;h=c[b+12>>2]|0;if((f|0)==(h|0)){g=0;i=d;return g|0}if((f|0)==127){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}j=eKf(0)|0;c[e>>2]=j;g=j;i=d;return g|0}if((h|0)==127){c[e>>2]=b;g=b;i=d;return g|0}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}RI(2686624)|0;b=qL(2686624)|0;URf(b,f);c[e>>2]=b;g=b;i=d;return g|0}function dSf(b){b=b|0;var d=0;d=i;vSf(b,c[b+12>>2]|0)|0;a[b+112>>0]=1;i=d;return}function eSf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+44|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}if(!(a[b+112>>0]|0))dSf(b);Jag(0,b);if(!(c[e>>2]|0))c[e>>2]=fSf(b,(a[b+8>>0]|0)!=0)|0;Kag(0,b);g=c[e>>2]|0;i=d;return g|0}function fSf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+12>>2]|0;f=c[a+92>>2]|0;RI(2756784)|0;g=qL(2756784)|0;zSf(g,a,e,f,b);i=d;return g|0}function gSf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2686624)|0;e=vL(b,2686624)|0;if(!e){f=0;i=d;return f|0}f=(c[e+12>>2]|0)==(c[a+12>>2]|0);i=d;return f|0}function hSf(a){a=a|0;return c[a+12>>2]|0}function iSf(a){a=a|0;return c[a+48>>2]|0}function jSf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+84|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}if(!(a[b+112>>0]|0))dSf(b);Jag(0,b);if(!(c[e>>2]|0)){RI(2751256)|0;if(!(a[2751404]|0)){RI(2751256)|0;fvh(2751256)}RI(2751256)|0;f=qL(2751256)|0;qRf(f,b);c[e>>2]=f}Kag(0,b);g=c[e>>2]|0;i=d;return g|0}function kSf(b){b=b|0;var d=0,e=0,f=0;d=i;if(!(a[b+112>>0]|0))dSf(b);e=c[b+12>>2]|0;if((e|0)!=127)if(!(e&65280))f=1;else f=(c[b+20>>2]|0)==0;else f=0;i=d;return f|0}function lSf(b){b=b|0;var d=0;d=i;Tih();if(!(Gqh(2755832,b)|0)){i=d;return}d=c[b+48>>2]|0;if(!(a[2540708]|0))fvh(2540560);b=iwf(0,c[889734]|0,d,c[889736]|0)|0;RI(3100472)|0;d=qL(3100472)|0;pug(d,b);ivh(d)}function mSf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!(a[b+112>>0]|0))dSf(b);lSf(b);e=b+36|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}Jag(0,b);if(!(c[e>>2]|0)){f=(a[b+8>>0]|0)!=0;RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;fvh(2755888)}RI(2755888)|0;h=qL(2755888)|0;HTf(h,127,f);c[e>>2]=h;oSf(b)}Kag(0,b);g=c[e>>2]|0;i=d;return g|0}function nSf(a,b){a=a|0;b=b|0;var c=0;c=i;HTf(a,127,b);i=c;return}function oSf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[689150]|0;if(!d){e=MK(2756608)|0;c[689150]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function pSf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!(a[b+112>>0]|0))dSf(b);lSf(b);e=b+40|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}Jag(0,b);if(!(c[e>>2]|0)){f=(a[b+8>>0]|0)!=0;RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}RI(2756056)|0;h=qL(2756056)|0;qSf(h,f);c[e>>2]=h;rSf(b);h=c[b+96>>2]|0;if(h)sSf(c[e>>2]|0,c[h+16>>2]|0)}Kag(0,b);g=c[e>>2]|0;i=d;return g|0}function qSf(b,d){b=b|0;d=d|0;var e=0;e=i;Yih();a[b+8>>0]=d&1;c[b+12>>2]=c[889908];c[b+16>>2]=c[889910];c[b+20>>2]=c[889912];c[b+24>>2]=c[889914];c[b+28>>2]=c[889916];c[b+32>>2]=c[889918];c[b+36>>2]=c[889920];c[b+40>>2]=c[889922];c[b+44>>2]=c[889924];c[b+48>>2]=c[889926];c[b+52>>2]=c[889928];c[b+56>>2]=c[889930];c[b+60>>2]=c[889932];c[b+64>>2]=c[889934];c[b+68>>2]=0;RI(2761736)|0;d=qL(2761736)|0;xTf(d,1);c[b+72>>2]=d;c[b+76>>2]=0;RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}RI(2756056)|0;c[b+80>>2]=c[(c[689037]|0)+16>>2];RI(2756056)|0;c[b+84>>2]=c[(c[689037]|0)+20>>2];RI(2756056)|0;c[b+92>>2]=c[(c[689037]|0)+24>>2];RI(2756056)|0;c[b+88>>2]=c[(c[689037]|0)+28>>2];RI(2756056)|0;c[b+176>>2]=c[(c[689037]|0)+24>>2];RI(2756056)|0;c[b+172>>2]=c[(c[689037]|0)+28>>2];RI(2756056)|0;c[b+120>>2]=c[(c[689037]|0)+32>>2];i=e;return}function rSf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[689132]|0;if(!d){e=MK(2756536)|0;c[689132]=e;f=e}else f=d;ko[f&4095](a);i=b;return}function sSf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!(a[b+8>>0]|0))if(!d){RI(2963920)|0;f=qL(2963920)|0;Ucg(f);ivh(f)}else{c[b+72>>2]=d;i=e;return}else{RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}RI(3084976)|0;e=qL(3084976)|0;RI(2756056)|0;osg(e,c[(c[689037]|0)+4>>2]|0);ivh(e)}}function tSf(b){b=b|0;return (a[b+8>>0]|0)!=0|0}function uSf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[g>>2]=3439976;c[f+0>>2]=c[g+0>>2];if((npf(0,f)|0)==(d|0)){j=Kuh(2756224,b)|0;i=e;return j|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[h>>2]=3445496;c[f+0>>2]=c[h+0>>2];if((npf(0,f)|0)!=(d|0)){j=0;i=e;return j|0}j=vvh(2756280,b)|0;i=e;return j|0}function vSf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[689084]|0;if(!e){f=MK(2756344)|0;c[689084]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function wSf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[689108]|0;if(!e){f=MK(2756440)|0;c[689108]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function xSf(b){b=b|0;var c=0;b=i;RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;fvh(2755888)}RI(2755888)|0;c=qL(2755888)|0;ITf(c);STf(c,1);a[c+8>>0]=1;i=b;return c|0}function ySf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}RI(2756056)|0;if(!(c[(c[689037]|0)+36>>2]|0)){RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}RI(2756056)|0;d=qL(2756056)|0;qSf(d,0);e=LSf(0,d)|0;RI(2756056)|0;c[(c[689037]|0)+36>>2]=e;RI(2756056)|0;eTf(c[(c[689037]|0)+36>>2]|0)}RI(2756056)|0;if(a[2756204]|0){RI(2756056)|0;f=c[689037]|0;g=f+36|0;h=c[g>>2]|0;i=b;return h|0}RI(2756056)|0;fvh(2756056);RI(2756056)|0;f=c[689037]|0;g=f+36|0;h=c[g>>2]|0;i=b;return h|0}function zSf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=h;c[j+0>>2]=c[694504];c[j+4>>2]=c[694505];c[j+8>>2]=c[694506];c[j+12>>2]=c[694507];c[j+16>>2]=c[694508];a[b+8>>0]=g&1;c[b+16>>2]=e;c[b+20>>2]=d;if(!f){jvh(2777624,j);e=b+28|0;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];a[b+44>>0]=44}else{j=b+28|0;c[j+0>>2]=c[f+0>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2]}a:do if(!(gvh(2686568,d)|0)){k=d;l=d}else{f=d;j=d;while(1){if((Aqh(2686456,gvh(2686568,f)|0)|0)==127){k=f;l=j;break a}if((gvh(2686568,f)|0)==(j|0)){k=f;l=j;break a}e=gvh(2686568,f)|0;if(!(gvh(2686568,e)|0)){k=e;l=e;break}else{f=e;j=e}}}while(0);if(!l){i=h;return}l=Aqh(2686456,k)|0;if(!((l|0)==31|(l|0)==44)){i=h;return}a[b+24>>0]=1;i=h;return}function ASf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;d=i;b=(Vof(c)|0)!=0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}RI(2686624)|0;e=qL(2686624)|0;ZRf(e,c,b,0);i=d;return e|0}function BSf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function CSf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function DSf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function ESf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function FSf(a){a=a|0;var b=0;b=i;xTf(a,1);i=b;return}function GSf(a){a=a|0;var b=0;b=i;qSf(a,0);i=b;return}function HSf(b){b=b|0;var d=0,e=0;b=i;Zih();d=c[890040]|0;RI(2756056)|0;c[(c[689037]|0)+4>>2]=d;d=c[890042]|0;RI(2756056)|0;c[(c[689037]|0)+8>>2]=d;d=c[890044]|0;RI(2756056)|0;c[(c[689037]|0)+12>>2]=d;RI(1094176)|0;d=hvh(1094176,7)|0;Qqh(d,c[890046]|0);e=d+16|0;c[e>>2]=c[890046];Qqh(d,c[890048]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[890048];Qqh(d,c[890050]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[890050];Qqh(d,c[890052]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[890052];Qqh(d,c[890054]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<2)>>2]=c[890054];Qqh(d,c[890056]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*5|0)>>2]=c[890056];Qqh(d,c[890058]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*6|0)>>2]=c[890058];RI(2756056)|0;c[(c[689037]|0)+16>>2]=d;RI(1094176)|0;d=hvh(1094176,7)|0;Qqh(d,c[890060]|0);e=d+16|0;c[e>>2]=c[890060];Qqh(d,c[890062]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[890062];Qqh(d,c[890064]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[890064];Qqh(d,c[890066]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[890066];Qqh(d,c[890068]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<2)>>2]=c[890068];Qqh(d,c[890070]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*5|0)>>2]=c[890070];Qqh(d,c[890072]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*6|0)>>2]=c[890072];RI(2756056)|0;c[(c[689037]|0)+20>>2]=d;RI(1094176)|0;d=hvh(1094176,13)|0;Qqh(d,c[890074]|0);e=d+16|0;c[e>>2]=c[890074];Qqh(d,c[890076]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[890076];Qqh(d,c[890078]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[890078];Qqh(d,c[890080]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[890080];Qqh(d,c[890082]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<2)>>2]=c[890082];Qqh(d,c[890084]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*5|0)>>2]=c[890084];Qqh(d,c[890086]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*6|0)>>2]=c[890086];Qqh(d,c[890088]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*7|0)>>2]=c[890088];Qqh(d,c[890090]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<3)>>2]=c[890090];Qqh(d,c[890092]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*9|0)>>2]=c[890092];Qqh(d,c[890094]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*10|0)>>2]=c[890094];Qqh(d,c[890096]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*11|0)>>2]=c[890096];if(!(a[2540708]|0))fvh(2540560);Qqh(d,c[c[635163]>>2]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*12|0)>>2]=c[c[635163]>>2];RI(2756056)|0;c[(c[689037]|0)+24>>2]=d;RI(1094176)|0;d=hvh(1094176,13)|0;Qqh(d,c[890098]|0);e=d+16|0;c[e>>2]=c[890098];Qqh(d,c[890100]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[890100];Qqh(d,c[890102]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[890102];Qqh(d,c[890104]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[890104];Qqh(d,c[890106]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<2)>>2]=c[890106];Qqh(d,c[890108]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*5|0)>>2]=c[890108];Qqh(d,c[890110]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*6|0)>>2]=c[890110];Qqh(d,c[890112]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*7|0)>>2]=c[890112];Qqh(d,c[890114]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<3)>>2]=c[890114];Qqh(d,c[890116]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*9|0)>>2]=c[890116];Qqh(d,c[890118]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*10|0)>>2]=c[890118];Qqh(d,c[890120]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*11|0)>>2]=c[890120];Qqh(d,c[c[635163]>>2]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*12|0)>>2]=c[c[635163]>>2];RI(2756056)|0;c[(c[689037]|0)+28>>2]=d;RI(1094176)|0;d=hvh(1094176,7)|0;Qqh(d,c[890122]|0);e=d+16|0;c[e>>2]=c[890122];Qqh(d,c[890124]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[890124];Qqh(d,c[890126]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[890126];Qqh(d,c[890128]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[890128];Qqh(d,c[890130]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<2)>>2]=c[890130];Qqh(d,c[890132]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*5|0)>>2]=c[890132];Qqh(d,c[890134]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*6|0)>>2]=c[890134];RI(2756056)|0;c[(c[689037]|0)+32>>2]=d;i=b;return}function ISf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;if(d){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[f>>2]=3445496;c[e+0>>2]=c[f+0>>2];f=Iuh(3083928,d,npf(0,e)|0)|0;RI(2756056)|0;e=mvh(f,2756056)|0;if(e){g=e;i=b;return g|0}}RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;fvh(2756056)}g=JSf(0)|0;i=b;return g|0}function JSf(b){b=b|0;var c=0;b=i;RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;fvh(3013496)}c=vvh(2756280,lzg(0,jhg(0)|0)|0)|0;i=b;return c|0}function KSf(b){b=b|0;return (a[b+8>>0]|0)!=0|0}function LSf(b,c){b=b|0;c=c|0;var d=0;b=i;d=bth(2756728,c)|0;RI(2756056)|0;c=mvh(d,2756056)|0;a[c+8>>0]=1;i=b;return c|0}function MSf(b){b=b|0;var c=0,d=0;c=i;d=Ynf(b)|0;RI(2756056)|0;b=mvh(d,2756056)|0;a[b+8>>0]=0;i=c;return b|0}function NSf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Xnf(a)|0)==(b|0);i=c;return (d?a:0)|0}function OSf(a,b){a=a|0;b=b|0;var d=0;d=b+-1|0;if(d>>>0<13){b=c[a+92>>2]|0;a=c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,d)|0)>>2]|0;return a|0}else{RI(2964880)|0;a=qL(2964880)|0;_eg(a);ivh(a)}return 0}function PSf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;_ih();if((b|0)>=0?(f=a+72|0,(c[($Qf(c[f>>2]|0)|0)+12>>2]|0)>=(b|0)):0){a=$Qf(c[f>>2]|0)|0;f=c[a+16+(da(c[(c[a>>2]|0)+120>>2]|0,b+-1|0)|0)>>2]|0;i=d;return f|0}f=spf(e)|0;RI(2964880)|0;e=qL(2964880)|0;Qag(e,c[890306]|0,f);ivh(e);return 0}function QSf(a,b){a=a|0;b=b|0;var d=0;d=b+-1|0;if(d>>>0<13){b=c[a+88>>2]|0;a=c[b+16+(da(c[(c[b>>2]|0)+120>>2]|0,d)|0)>>2]|0;return a|0}else{RI(2964880)|0;a=qL(2964880)|0;_eg(a);ivh(a)}return 0}function RSf(a){a=a|0;return c[a+80>>2]|0}function SSf(a){a=a|0;return c[a+92>>2]|0}function TSf(a){a=a|0;return c[a+84>>2]|0}function USf(a){a=a|0;return c[a+88>>2]|0}function VSf(a){a=a|0;return c[a+12>>2]|0}function WSf(a){a=a|0;return c[a+16>>2]|0}function XSf(a){a=a|0;return c[a+20>>2]|0}function YSf(a){a=a|0;return c[a+24>>2]|0}function ZSf(a){a=a|0;return c[a+32>>2]|0}function _Sf(a){a=a|0;return c[a+28>>2]|0}function $Sf(a){a=a|0;return c[a+36>>2]|0}function aTf(a){a=a|0;return c[a+40>>2]|0}function bTf(a){a=a|0;return c[a+44>>2]|0}function cTf(a){a=a|0;return c[a+48>>2]|0}function dTf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;Wih();e=c[b+52>>2]|0;if(e){f=e;i=d;return f|0}e=c[b+32>>2]|0;g=c[b+40>>2]|0;if(!(a[2540708]|0))fvh(2540560);f=iwf(0,e,c[889880]|0,g)|0;i=d;return f|0}function eTf(a){a=a|0;var b=0,d=0,e=0;b=i;ajh();RI(1094176)|0;d=hvh(1094176,1)|0;Qqh(d,c[890340]|0);c[d+16>>2]=c[890340];c[a+96>>2]=d;RI(1094176)|0;d=hvh(1094176,1)|0;Qqh(d,c[890342]|0);c[d+16>>2]=c[890342];c[a+100>>2]=d;RI(1094176)|0;d=hvh(1094176,1)|0;Qqh(d,c[890344]|0);c[d+16>>2]=c[890344];c[a+108>>2]=d;RI(1094176)|0;d=hvh(1094176,4)|0;Qqh(d,c[890346]|0);e=d+16|0;c[e>>2]=c[890346];Qqh(d,c[890348]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[890348];Qqh(d,c[890350]|0);c[e+(c[(c[d>>2]|0)+120>>2]<<1)>>2]=c[890350];Qqh(d,c[890352]|0);c[e+((c[(c[d>>2]|0)+120>>2]|0)*3|0)>>2]=c[890352];c[a+104>>2]=d;RI(1094176)|0;d=hvh(1094176,1)|0;Qqh(d,c[890354]|0);c[d+16>>2]=c[890354];c[a+112>>2]=d;RI(1094176)|0;d=hvh(1094176,1)|0;Qqh(d,c[890356]|0);c[d+16>>2]=c[890356];c[a+116>>2]=d;i=b;return}function fTf(a){a=a|0;return c[a+72>>2]|0}function gTf(a){a=a|0;return c[a+56>>2]|0}function hTf(a){a=a|0;a=i;Xih();i=a;return c[889884]|0}function iTf(a){a=a|0;return c[a+60>>2]|0}function jTf(a){a=a|0;return c[a+64>>2]|0}function kTf(a){a=a|0;var b=0;b=i;lTf(a);i=b;return c[a+192>>2]|0}function lTf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+192|0;if(c[g>>2]|0){i=d;return}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;fvh(2713640)}RI(2713640)|0;h=qL(2713640)|0;$Lf(h);Irh(2714840,h,mTf(b,100)|0);Irh(2714840,h,mTf(b,68)|0);Irh(2714840,h,mTf(b,103)|0);Irh(2714840,h,mTf(b,71)|0);Irh(2714840,h,mTf(b,102)|0);Irh(2714840,h,mTf(b,70)|0);Irh(2714840,h,mTf(b,109)|0);Irh(2714840,h,mTf(b,77)|0);Irh(2714840,h,mTf(b,114)|0);Irh(2714840,h,mTf(b,82)|0);Irh(2714840,h,mTf(b,115)|0);Irh(2714840,h,mTf(b,116)|0);Irh(2714840,h,mTf(b,84)|0);Irh(2714840,h,mTf(b,117)|0);Irh(2714840,h,mTf(b,85)|0);Irh(2714840,h,mTf(b,121)|0);Irh(2714840,h,mTf(b,89)|0);RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[f>>2]=3431728;c[e+0>>2]=c[f+0>>2];f=Uuh(2715064,h,npf(0,e)|0)|0;RI(1094176)|0;c[g>>2]=mvh(f,1094176)|0;i=d;return}function mTf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;$ih();f=d&65535;g=f+65454&65535;if((g|0)==2){h=c[b+108>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)>=1:0){j=h;i=e;return j|0}RI(1094176)|0;h=hvh(1094176,1)|0;k=c[b+40>>2]|0;Qqh(h,k);c[h+16>>2]=k;j=h;i=e;return j|0}else if(!g)l=44;else if((g|0)==7)l=41;else if((g|0)==3)l=28;else l=2;a:do if((l|0)==2)switch(f+65422&65535|0){case 2:{g=c[b+104>>2]|0;if((g|0)!=0?(c[g+12>>2]|0)>=1:0){j=g;i=e;return j|0}RI(1094176)|0;g=hvh(1094176,1)|0;h=c[b+36>>2]|0;Qqh(g,h);c[g+16>>2]=h;j=g;i=e;return j|0}case 1:{RI(1094176)|0;g=hvh(1094176,1)|0;h=c[b+60>>2]|0;Qqh(g,h);c[g+16>>2]=h;j=g;i=e;return j|0}case 0:{l=44;break a;break}case 3:{RI(1094176)|0;g=hvh(1094176,1)|0;h=c[b+64>>2]|0;Qqh(g,h);c[g+16>>2]=h;j=g;i=e;return j|0}case 7:{l=41;break a;break}default:{g=f+65468&65535;if((g|0)==3){h=nTf(0,c[b+96>>2]|0,c[b+108>>2]|0)|0;if((h|0)!=0?(c[h+12>>2]|0)>=1:0){j=h;i=e;return j|0}RI(1094176)|0;h=hvh(1094176,1)|0;k=c[b+28>>2]|0;m=c[b+40>>2]|0;if(!(a[2540708]|0))fvh(2540560);n=iwf(0,k,c[890312]|0,m)|0;Qqh(h,n);c[h+16>>2]=n;j=h;i=e;return j|0}else if(!g){h=c[b+100>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)>=1:0){j=h;i=e;return j|0}RI(1094176)|0;h=hvh(1094176,1)|0;n=c[b+32>>2]|0;Qqh(h,n);c[h+16>>2]=n;j=h;i=e;return j|0}else if((g|0)!=2){g=f+65436&65535;if((g|0)==2){h=nTf(0,c[b+100>>2]|0,c[b+104>>2]|0)|0;if((h|0)!=0?(c[h+12>>2]|0)>=1:0){j=h;i=e;return j|0}RI(1094176)|0;h=hvh(1094176,1)|0;n=c[b+32>>2]|0;m=c[b+36>>2]|0;if(!(a[2540708]|0))fvh(2540560);k=iwf(0,n,c[890318]|0,m)|0;Qqh(h,k);c[h+16>>2]=k;j=h;i=e;return j|0}else if(!g){h=c[b+96>>2]|0;if((h|0)!=0?(c[h+12>>2]|0)>=1:0){j=h;i=e;return j|0}RI(1094176)|0;h=hvh(1094176,1)|0;k=c[b+28>>2]|0;Qqh(h,k);c[h+16>>2]=k;j=h;i=e;return j|0}else if((g|0)==3){g=nTf(0,c[b+96>>2]|0,c[b+104>>2]|0)|0;if((g|0)!=0?(c[g+12>>2]|0)>=1:0){j=g;i=e;return j|0}RI(1094176)|0;g=hvh(1094176,1)|0;h=c[b+28>>2]|0;k=c[b+36>>2]|0;if(!(a[2540708]|0))fvh(2540560);m=iwf(0,h,c[890314]|0,k)|0;Qqh(g,m);c[g+16>>2]=m;j=g;i=e;return j|0}else{if(!(d<<16>>16==109|d<<16>>16==77)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[890320]|0);ivh(g)}g=c[b+112>>2]|0;if((g|0)!=0?(c[g+12>>2]|0)>=1:0){j=g;i=e;return j|0}RI(1094176)|0;g=hvh(1094176,1)|0;m=c[b+44>>2]|0;Qqh(g,m);c[g+16>>2]=m;j=g;i=e;return j|0}}else{l=28;break a}}}while(0);if((l|0)==28){d=nTf(0,c[b+100>>2]|0,c[b+108>>2]|0)|0;if((d|0)!=0?(c[d+12>>2]|0)>=1:0){j=d;i=e;return j|0}RI(1094176)|0;d=hvh(1094176,1)|0;f=c[b+32>>2]|0;g=c[b+40>>2]|0;if(!(a[2540708]|0))fvh(2540560);m=iwf(0,f,c[890316]|0,g)|0;Qqh(d,m);c[d+16>>2]=m;j=d;i=e;return j|0}else if((l|0)==41){d=c[b+116>>2]|0;if((d|0)!=0?(c[d+12>>2]|0)>=1:0){j=d;i=e;return j|0}RI(1094176)|0;d=hvh(1094176,1)|0;m=c[b+48>>2]|0;Qqh(d,m);c[d+16>>2]=m;j=d;i=e;return j|0}else if((l|0)==44){RI(1094176)|0;l=hvh(1094176,1)|0;d=c[b+56>>2]|0;Qqh(l,d);c[l+16>>2]=d;j=l;i=e;return j|0}return 0}function nTf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;bjh();if(!((d|0)!=0&(e|0)!=0)){f=0;i=b;return f|0}RI(1094176)|0;g=d+12|0;h=e+12|0;j=hvh(1094176,da(c[h>>2]|0,c[g>>2]|0)|0)|0;k=c[g>>2]|0;if((k|0)<=0){f=j;i=b;return f|0}l=d+16|0;m=e+16|0;n=j+16|0;o=c[h>>2]|0;p=k;k=0;q=0;while(1){r=c[l+(da(c[(c[d>>2]|0)+120>>2]|0,q)|0)>>2]|0;if((o|0)>0){s=k;t=0;while(1){u=c[m+(da(c[(c[e>>2]|0)+120>>2]|0,t)|0)>>2]|0;v=s+1|0;if(!(a[2540708]|0))fvh(2540560);w=iwf(0,r,c[890370]|0,u)|0;Qqh(j,w);c[n+(da(c[(c[j>>2]|0)+120>>2]|0,s)|0)>>2]=w;t=t+1|0;w=c[h>>2]|0;if((t|0)>=(w|0)){x=v;y=w;break}else s=v}z=c[g>>2]|0;A=y;B=x}else{z=p;A=o;B=k}q=q+1|0;if((q|0)>=(z|0)){f=j;break}else{o=A;p=z;k=B}}i=b;return f|0}function oTf(a,b){a=a|0;b=b|0;var d=0;if(b>>>0<7){d=c[a+84>>2]|0;a=c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,b)|0)>>2]|0;return a|0}else{RI(2964880)|0;a=qL(2964880)|0;_eg(a);ivh(a)}return 0}function pTf(a,b){a=a|0;b=b|0;var d=0;if(b>>>0<7){d=c[a+80>>2]|0;a=c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,b)|0)>>2]|0;return a|0}else{RI(2964880)|0;a=qL(2964880)|0;_eg(a);ivh(a)}return 0}function qTf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function rTf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function sTf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=a+8|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];b=a+24|0;c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];d=e;e=c[d+4>>2]|0;b=a+40|0;c[b>>2]=c[d>>2];c[b+4>>2]=e;return}function tTf(a,b){a=a|0;b=b|0;var d=0;d=b+8|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function uTf(a,b){a=a|0;b=b|0;var d=0;d=b+24|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}function vTf(a){a=a|0;var b=0,d=0;b=i;d=a+40|0;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function wTf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function xTf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;cjh();e=a+12|0;c[e>>2]=99;Lrh(2769936,a,b);RI(1094176)|0;b=hvh(1094176,1)|0;Qqh(b,c[890374]|0);c[b+16>>2]=c[890374];c[a+16>>2]=b;RI(1094176)|0;b=hvh(1094176,1)|0;Qqh(b,c[890376]|0);c[b+16>>2]=c[890376];c[a+20>>2]=b;if((c[e>>2]|0)!=99){i=d;return}c[e>>2]=2029;i=d;return}function yTf(a){a=a|0;var b=0;a=i;RI(1101728)|0;b=hvh(1101728,1)|0;c[b+16>>2]=1;i=a;return b|0}function zTf(a,b){a=a|0;b=b|0;var d=0;d=i;_Qf(a);c[a+24>>2]=b;i=d;return}function ATf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=nRf(0,d)|0;i=a;return b|0}function BTf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=Xog(d)|0;d=eFi(b|0,H|0,711573504,201)|0;b=d+1|0;d=(da(~~+R(+(+(b|0)/7.0)),-7)|0)+b|0;i=a;return d|0}function CTf(a,b){a=a|0;b=b|0;return 1}function DTf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=oRf(0,d)|0;i=a;return b|0}function ETf(a,b){a=a|0;b=b|0;var d=0;a=i;i=i+16|0;d=a;c[d+0>>2]=c[b+0>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=pRf(0,d)|0;i=a;return b|0}function FTf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function GTf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function HTf(b,d,e){b=b|0;d=d|0;e=e|0;e=i;ejh();c[b+24>>2]=c[890460];c[b+28>>2]=c[890462];RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;fvh(2755888)}RI(2755888)|0;c[b+144>>2]=c[c[688995]>>2];c[b+148>>2]=1;a[b+8>>0]=0;c[b+32>>2]=2;c[b+36>>2]=c[890464];c[b+40>>2]=c[890466];RI(1101728)|0;d=hvh(1101728,1)|0;c[d+16>>2]=3;c[b+44>>2]=d;c[b+48>>2]=0;c[b+52>>2]=0;c[b+56>>2]=c[890468];c[b+60>>2]=c[890470];c[b+64>>2]=c[890472];c[b+68>>2]=c[890474];c[b+72>>2]=2;c[b+76>>2]=c[890476];c[b+80>>2]=c[890478];RI(1101728)|0;d=hvh(1101728,1)|0;c[d+16>>2]=3;c[b+84>>2]=d;c[b+88>>2]=1;c[b+92>>2]=2;c[b+96>>2]=c[890480];c[b+100>>2]=c[890482];RI(1101728)|0;d=hvh(1101728,1)|0;c[d+16>>2]=3;c[b+104>>2]=d;c[b+108>>2]=0;c[b+112>>2]=0;c[b+116>>2]=c[890484];c[b+120>>2]=c[890486];c[b+124>>2]=c[890488];c[b+128>>2]=c[890490];i=e;return}function ITf(a){a=a|0;var b=0;b=i;HTf(a,127,0);i=b;return}function JTf(a){a=a|0;var b=0,d=0;a=i;fjh();RI(1094176)|0;b=hvh(1094176,10)|0;Qqh(b,c[890510]|0);d=b+16|0;c[d>>2]=c[890510];Qqh(b,c[890512]|0);c[d+(c[(c[b>>2]|0)+120>>2]|0)>>2]=c[890512];Qqh(b,c[890514]|0);c[d+(c[(c[b>>2]|0)+120>>2]<<1)>>2]=c[890514];Qqh(b,c[890516]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*3|0)>>2]=c[890516];Qqh(b,c[890518]|0);c[d+(c[(c[b>>2]|0)+120>>2]<<2)>>2]=c[890518];Qqh(b,c[890520]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*5|0)>>2]=c[890520];Qqh(b,c[890522]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*6|0)>>2]=c[890522];Qqh(b,c[890524]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*7|0)>>2]=c[890524];Qqh(b,c[890526]|0);c[d+(c[(c[b>>2]|0)+120>>2]<<3)>>2]=c[890526];Qqh(b,c[890528]|0);c[d+((c[(c[b>>2]|0)+120>>2]|0)*9|0)>>2]=c[890528];RI(2755888)|0;c[c[688995]>>2]=b;i=a;return}function KTf(a){a=a|0;return c[a+32>>2]|0}function LTf(a){a=a|0;return c[a+36>>2]|0}function MTf(a){a=a|0;return c[a+40>>2]|0}function NTf(a){a=a|0;return c[a+44>>2]|0}function OTf(a){a=a|0;return c[a+48>>2]|0}function PTf(a){a=a|0;return c[a+52>>2]|0}function QTf(a){a=a|0;return c[a+56>>2]|0}function RTf(b){b=b|0;var c=0;b=i;RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;fvh(3013496)}c=Kuh(2756224,lzg(0,jhg(0)|0)|0)|0;a[c+8>>0]=1;i=b;return c|0}function STf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;djh();if(d>>>0>=5){RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[890384]|0);ivh(f)}if(!(a[b+8>>0]|0)){c[b+88>>2]=d;i=e;return}else{RI(3084976)|0;e=qL(3084976)|0;osg(e,c[890386]|0);ivh(e)}}function TTf(a){a=a|0;return c[a+60>>2]|0}function UTf(a){a=a|0;return c[a+64>>2]|0}function VTf(a){a=a|0;return c[a+68>>2]|0}function WTf(a){a=a|0;return c[a+72>>2]|0}function XTf(a){a=a|0;return c[a+76>>2]|0}function YTf(a){a=a|0;return c[a+80>>2]|0}function ZTf(a){a=a|0;return c[a+84>>2]|0}function _Tf(a){a=a|0;return c[a+88>>2]|0}function $Tf(a){a=a|0;return c[a+92>>2]|0}function aUf(a){a=a|0;return c[a+96>>2]|0}function bUf(a){a=a|0;return c[a+100>>2]|0}function cUf(a){a=a|0;return c[a+104>>2]|0}function dUf(a){a=a|0;return c[a+108>>2]|0}function eUf(a){a=a|0;return c[a+112>>2]|0}function fUf(a){a=a|0;return c[a+116>>2]|0}function gUf(a){a=a|0;return c[a+120>>2]|0}function hUf(a){a=a|0;return c[a+124>>2]|0}function iUf(a){a=a|0;return c[a+128>>2]|0}function jUf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[g>>2]=3439976;c[f+0>>2]=c[g+0>>2];g=(npf(0,f)|0)==(d|0);i=e;return (g?b:0)|0}function kUf(b){b=b|0;var c=0,d=0;c=i;d=Ynf(b)|0;RI(2755888)|0;b=mvh(d,2755888)|0;a[b+8>>0]=0;i=c;return b|0}function lUf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;if(d){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;fvh(2540728)}c[f>>2]=3439976;c[e+0>>2]=c[f+0>>2];f=Iuh(3083928,d,npf(0,e)|0)|0;RI(2755888)|0;e=mvh(f,2755888)|0;if(e){g=e;i=b;return g|0}}RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;fvh(2755888)}g=RTf(0)|0;i=b;return g|0}function mUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function nUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function oUf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(((b|0)!=0?(RI(2756784)|0,e=vL(b,2756784)|0,(e|0)!=0):0)?(c[e+16>>2]|0)==(c[a+16>>2]|0):0)f=(c[e+20>>2]|0)==(c[a+20>>2]|0);else f=0;i=d;return f|0}function pUf(a){a=a|0;return c[a+16>>2]|0}function qUf(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;gjh();c[e>>2]=c[b+16>>2];RI(2540224)|0;b=pL(2540224,e)|0;if(!(a[2540708]|0))fvh(2540560);e=fwf(0,c[890548]|0,b)|0;i=d;return e|0}function rUf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d&65535;do if((d&65535)>63&(d+-97<<16>>16&65535)>30){if((d+-65<<16>>16&65535)<=25?!((a[b+24>>0]|0)!=0&d<<16>>16==73):0){g=f+32&65535;break}h=c[b+20>>2]|0;if((h|0)!=0?(Aqh(2686456,h)|0)!=127:0){h=f+65083&65535;if((h|0)==3){g=457;break}else if(!h){g=454;break}h=f+64558&65535;if((h|0)==1){g=973;break}else if(!h){g=965;break}else if((h|0)==2){g=971;break}else{if(d<<16>>16==459){g=460;break}else if(d<<16>>16==304){g=105;break}else if(d<<16>>16==73){if(a[b+24>>0]|0){g=305;break}}else if(d<<16>>16==498){g=499;break}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}g=tuf(0,d)|0;break}}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}g=tuf(0,d)|0}else g=d;while(0);i=e;return g|0}function sUf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d&65535;a:do if((d&65535)>95){if((d+-97<<16>>16&65535)<=25?!((a[b+24>>0]|0)!=0&d<<16>>16==105):0){g=f+65504&65535;break}h=c[b+20>>2]|0;if((h|0)!=0?(Aqh(2686456,h)|0)!=127:0){h=f+64560&65535;if((h|0)==6){g=928;break}else if((h|0)==5){g=934;break}else if(!h){g=914;break}else if((h|0)==1){g=920;break}else{h=f+65083&65535;if((h|0)==3){g=455;break}else if(!h){g=452;break}switch(d<<16>>16){case 105:{if(a[b+24>>0]|0){g=304;break a}break}case 459:{g=458;break a;break}case 944:{g=939;break a;break}case 1008:{g=922;break a;break}case 498:{g=497;break a;break}case 1009:{g=929;break a;break}case 912:{g=938;break a;break}case 305:{g=73;break a;break}default:{}}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}g=wuf(0,d)|0;break}}RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}g=wuf(0,d)|0}else g=d;while(0);i=e;return g|0}function tUf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;hjh();if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[890558]|0);ivh(g)}if(!(Vof(e)|0)){if(!(a[2540708]|0))fvh(2540560);h=c[c[635163]>>2]|0;i=f;return h|0}g=Vof(e)|0;if(!(a[2540708]|0))fvh(2540560);j=ivf(0,g)|0;g=bvf(0)|0;k=bvf(0)|0;if((Vof(e)|0)<=0){h=j;i=f;return h|0}l=k+j|0;k=g+e|0;g=0;while(1){b[l>>1]=Muh(2686848,d,b[k>>1]|0)|0;g=g+1|0;if((g|0)>=(Vof(e)|0)){h=j;break}else{l=l+2|0;k=k+2|0}}i=f;return h|0}function uUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2778720)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function vUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function wUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function xUf(a,b){a=a|0;b=b|0;var c=0;c=i;Vxf(a,b);i=c;return}function yUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function zUf(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;c[d>>2]=0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}e=AUf(0,d)|0;if(!(c[d>>2]|0)){i=b;return e|0}RI(2781280)|0;if(a[2781428]|0){f=c[d>>2]|0;g=BUf(0,f)|0;ivh(g)}RI(2781280)|0;fvh(2781280);f=c[d>>2]|0;g=BUf(0,f)|0;ivh(g);return 0}function AUf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[697574]|0;if(!d){e=MK(2790304)|0;c[697574]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function BUf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;ujh();if((d|0)==5){RI(3128304)|0;e=qL(3128304)|0;eyg(e,c[890940]|0);f=e;i=b;return f|0}else if((d|0)==80){e=c[890942]|0;RI(2784056)|0;g=qL(2784056)|0;oVf(g,e,-2147024816);f=g;i=b;return f|0}else{if(!(a[2540708]|0))fvh(2540560);RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}f=MUf(0,c[c[635163]>>2]|0,d)|0;i=b;return f|0}return 0}function CUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function DUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function EUf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function FUf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function GUf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[a+44>>2]|0;if(g)GUf(g,b,d,e);Dn[c[a+8>>2]&511](c[a+16>>2]|0,b,d,e);i=f;return}function HUf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!b)g=0;else g=b+16|0;co[c[(c[a+20>>2]|0)+4>>2]&2047](g,d,e);i=f;return}function IUf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function JUf(a,b){a=a|0;b=b|0;return}function KUf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+32|0;l=k+8|0;m=k+16|0;n=k+20|0;o=k+24|0;p=k+4|0;q=k;r=k+12|0;c[n>>2]=0;kjh();s=b+56|0;c[s>>2]=c[890606];aWf(b);RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}RI(2781280)|0;t=c[(c[695343]|0)+4>>2]|0;u=b+60|0;c[u>>2]=t;v=c[d>>2]|0;c[o>>2]=v;c[p>>2]=t;c[m+0>>2]=c[o+0>>2];c[l+0>>2]=c[p+0>>2];if(FAf(0,m,l)|0){m=tof(0,c[890610]|0)|0;RI(2965048)|0;p=qL(2965048)|0;Rag(p,c[890608]|0,m);ivh(p)}if((e+-1|0)>>>0>=3){RI(2964880)|0;p=qL(2964880)|0;wdg(p,c[890612]|0);ivh(p)}RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[q>>2]=v;c[l+0>>2]=c[q+0>>2];q=LUf(0,l,n)|0;if(c[n>>2]|0){p=c[s>>2]|0;RI(2781280)|0;if(a[2781428]|0){w=c[n>>2]|0;x=MUf(0,p,w)|0;ivh(x)}RI(2781280)|0;fvh(2781280);w=c[n>>2]|0;x=MUf(0,p,w)|0;ivh(x)}if(!q){RI(2784056)|0;x=qL(2784056)|0;Grg(x,c[890614]|0);ivh(x)}x=b+14|0;a[x>>0]=(q|0)==1&1;c[u>>2]=v;c[b+8>>2]=e;a[b+12>>0]=f&1;a[b+13>>0]=h&1;a[b+24>>0]=0;OUf(b,g,j);if(!(a[x>>0]|0)){y=b+16|0;z=y;A=z;c[A>>2]=0;B=z+4|0;C=B;c[C>>2]=0;i=k;return}RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[r>>2]=v;c[l+0>>2]=c[r+0>>2];r=PUf(0,l,0,0,1,n)|0;l=b+48|0;c[l>>2]=r;c[l+4>>2]=H;if(!(c[n>>2]|0)){y=b+16|0;z=y;A=z;c[A>>2]=0;B=z+4|0;C=B;c[C>>2]=0;i=k;return}k=c[s>>2]|0;RI(2781280)|0;if(a[2781428]|0){D=c[n>>2]|0;E=MUf(0,k,D)|0;ivh(E)}RI(2781280)|0;fvh(2781280);D=c[n>>2]|0;E=MUf(0,k,D)|0;ivh(E)}function LUf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[697592]|0;if(!g){h=MK(2790376)|0;c[697592]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];f=_n[j&4095](e,d)|0;i=a;return f|0}function MUf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;i=i+16|0;f=b;vjh();do switch(e|0){case 145:{if(!(a[2540708]|0))fvh(2540560);g=_vf(0,c[891008]|0,d)|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024751);j=h;i=b;return j|0}case 2:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[890982]|0,d)|0;RI(2780848)|0;g=qL(2780848)|0;Vxf(g,h);j=g;i=b;return j|0}case 3:{if(!(a[2540708]|0))fvh(2540560);g=_vf(0,c[890986]|0,d)|0;RI(2780848)|0;h=qL(2780848)|0;Vxf(h,g);j=h;i=b;return j|0}case 5:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[890988]|0,d)|0;RI(3128304)|0;g=qL(3128304)|0;eyg(g,h);j=g;i=b;return j|0}case 6e3:{RI(2784056)|0;g=qL(2784056)|0;oVf(g,c[891010]|0,-2147018896);j=g;i=b;return j|0}case 82:{if(!(a[2540708]|0))fvh(2540560);g=_vf(0,c[891012]|0,d)|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024814);j=h;i=b;return j|0}case 87:{if(!(a[2540708]|0))fvh(2540560);h=c[890998]|0;RI(1086352)|0;g=cwf(0,h,hvh(1086352,0)|0)|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024809);j=h;i=b;return j|0}case 206:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[890996]|0,d)|0;RI(2789960)|0;g=qL(2789960)|0;Grg(g,h);j=g;i=b;return j|0}case 6:{if(!(a[2540708]|0))fvh(2540560);g=_vf(0,c[890990]|0,d)|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024890);j=h;i=b;return j|0}case 4:{RI(2784056)|0;h=qL(2784056)|0;oVf(h,c[890984]|0,-2147024892);j=h;i=b;return j|0}case 29:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[891e3]|0,d)|0;RI(2784056)|0;g=qL(2784056)|0;oVf(g,h,-2147024867);j=g;i=b;return j|0}case 39:{if(!(a[2540708]|0))fvh(2540560);g=_vf(0,c[891006]|0,d)|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024857);j=h;i=b;return j|0}case 15:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[890992]|0,d)|0;RI(2784056)|0;g=qL(2784056)|0;oVf(g,h,-2147024881);j=g;i=b;return j|0}case 17:{g=c[891014]|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024879);j=h;i=b;return j|0}case 33:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[891004]|0,d)|0;RI(2784056)|0;g=qL(2784056)|0;oVf(g,h,-2147024863);j=g;i=b;return j|0}case 32:{if(!(a[2540708]|0))fvh(2540560);g=_vf(0,c[891002]|0,d)|0;RI(2784056)|0;h=qL(2784056)|0;oVf(h,g,-2147024864);j=h;i=b;return j|0}case 80:{if(!(a[2540708]|0))fvh(2540560);h=_vf(0,c[890994]|0,d)|0;RI(2784056)|0;g=qL(2784056)|0;oVf(g,h,-2147024816);j=g;i=b;return j|0}default:{c[f>>2]=e;RI(2790128)|0;g=pL(2790128,f)|0;if(!(a[2540708]|0))fvh(2540560);h=awf(0,c[891016]|0,g,d)|0;RI(2784056)|0;g=qL(2784056)|0;oVf(g,h,e|-2147024896);j=g;i=b;return j|0}}while(0);return 0}function NUf(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function OUf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;pjh();do if(!e)if((d|0)>0){g=(d|0)<8?8:d;RI(1159264)|0;c[b+28>>2]=hvh(1159264,g)|0;h=g;break}else{RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[890794]|0,c[890796]|0);ivh(g)}else{RI(1159264)|0;c[b+28>>2]=hvh(1159264,1)|0;h=0}while(0);c[b+32>>2]=h;h=b+48|0;c[h>>2]=0;c[h+4>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;a[b+44>>0]=0;i=f;return}function PUf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;h=a+4|0;j=a;k=c[697658]|0;if(!k){l=MK(2790640)|0;c[697658]=l;m=l}else m=k;c[j>>2]=c[b>>2];c[h+0>>2]=c[j+0>>2];j=Bn[m&255](h,d,e,f,g)|0;i=a;return j|0}function QUf(a){a=a|0;return (c[a+8>>2]&-3|0)==1|0}function RUf(a){a=a|0;return (c[a+8>>2]&-2|0)==2|0}function SUf(b){b=b|0;return (a[b+14>>0]|0)!=0|0}function TUf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[g>>2]=0;ijh();l=b+60|0;m=c[l>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[h>>2]=m;RI(2781280)|0;c[j>>2]=c[(c[695343]|0)+4>>2];c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];if(FAf(0,f,e)|0){RI(3112928)|0;f=qL(3112928)|0;kwg(f,c[890564]|0);ivh(f)}if(!(Gqh(2784224,b)|0)){RI(3100472)|0;f=qL(3100472)|0;pug(f,c[890566]|0);ivh(f)}UUf(b);f=c[l>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[k>>2]=f;c[e+0>>2]=c[k+0>>2];k=VUf(0,e,g)|0;if(!(c[g>>2]|0)){i=d;return k|0}k=WUf(b,c[b+56>>2]|0)|0;RI(2781280)|0;if(a[2781428]|0){n=c[g>>2]|0;o=MUf(0,k,n)|0;ivh(o)}RI(2781280)|0;fvh(2781280);n=c[g>>2]|0;o=MUf(0,k,n)|0;ivh(o);return 0}function UUf(b){b=b|0;var c=0;c=i;if(!(a[b+44>>0]|0)){i=c;return}eVf(b,0);i=c;return}function VUf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[697684]|0;if(!g){h=MK(2790744)|0;c[697684]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];f=_n[j&4095](e,d)|0;i=a;return f|0}function WUf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;d=i;e=(a[b+24>>0]|0)==0;RI(2785008)|0;b=(a[2785156]|0)!=0;if(e){if(!b){RI(2785008)|0;fvh(2785008)}f=lVf(0,c)|0;i=d;return f|0}else{if(!b){RI(2785008)|0;fvh(2785008)}f=kVf(0,c)|0;i=d;return f|0}return 0}function XUf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;jjh();j=c[b+60>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[g>>2]=j;RI(2781280)|0;c[h>>2]=c[(c[695343]|0)+4>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];if(FAf(0,f,e)|0){RI(3112928)|0;e=qL(3112928)|0;kwg(e,c[890600]|0);ivh(e)}if(Gqh(2784224,b)|0){e=b+48|0;f=c[b+40>>2]|0;b=_Ei(f|0,((f|0)<0)<<31>>31|0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}else{RI(3100472)|0;b=qL(3100472)|0;pug(b,c[890602]|0);ivh(b)}return 0}function YUf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;ljh();m=c[b+60>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[k>>2]=m;RI(2781280)|0;c[l>>2]=c[(c[695343]|0)+4>>2];c[j+0>>2]=c[k+0>>2];c[h+0>>2]=c[l+0>>2];if(FAf(0,j,h)|0){RI(3112928)|0;h=qL(3112928)|0;kwg(h,c[890644]|0);ivh(h)}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[890646]|0);ivh(h)}if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[890648]|0,c[890650]|0);ivh(h)}if((f|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[890652]|0,c[890654]|0);ivh(h)}if(((c[d+12>>2]|0)-f|0)<(e|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[890656]|0);ivh(h)}if(!(Gqh(2784280,b)|0)){RI(3100472)|0;h=qL(3100472)|0;pug(h,c[890658]|0);ivh(h)}if(!(a[b+13>>0]|0)){ZUf(b,d,e,f);i=g;return}else{Irh(2784392,b,wvh(2784336,b,d,e,f,0,0)|0);i=g;return}}function ZUf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;c[j>>2]=0;if((c[b+32>>2]|0)>=(f|0)){if((f|0)>0){l=f;m=0}else{i=g;return}while(1){n=aVf(b,d,m+e|0,l)|0;if((l|0)==(n|0)){o=15;break}l=l-n|0;eVf(b,0);if((l|0)<=0){o=15;break}else m=n+m|0}if((o|0)==15){i=g;return}}eVf(b,0);a:do if((f|0)>0){o=b+60|0;m=e;l=f;while(1){n=c[o>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[k>>2]=n;c[h+0>>2]=c[k+0>>2];n=$Uf(0,h,d,m,l,j)|0;if(c[j>>2]|0)break;l=l-n|0;if((l|0)<=0)break a;else m=n+m|0}m=WUf(b,c[b+56>>2]|0)|0;RI(2781280)|0;if(a[2781428]|0){p=c[j>>2]|0;q=MUf(0,m,p)|0;ivh(q)}RI(2781280)|0;fvh(2781280);p=c[j>>2]|0;q=MUf(0,m,p)|0;ivh(q)}while(0);q=b+48|0;b=q;p=_Ei(c[b>>2]|0,c[b+4>>2]|0,f|0,((f|0)<0)<<31>>31|0)|0;f=q;c[f>>2]=p;c[f+4>>2]=H;i=g;return}function _Uf(a){a=a|0;var b=0;b=i;eVf(a,0);i=b;return}function $Uf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;a=i;i=i+16|0;h=a+4|0;j=a;k=c[697630]|0;if(!k){l=MK(2790528)|0;c[697630]=l;m=l}else m=k;c[j>>2]=c[b>>2];c[h+0>>2]=c[j+0>>2];j=Bn[m&255](h,d,e,f,g)|0;i=a;return j|0}function aVf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;h=b+40|0;j=c[h>>2]|0;k=(c[b+32>>2]|0)-j|0;l=(k|0)<(f|0)?k:f;if((l|0)<1){i=g;return l|0}Qig(0,d,e,c[b+28>>2]|0,j,l);j=(c[h>>2]|0)+l|0;c[h>>2]=j;h=b+36|0;if((j|0)>(c[h>>2]|0))c[h>>2]=j;a[b+44>>0]=1;i=g;return l|0}function bVf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;mjh();o=c[b+60>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[m>>2]=o;RI(2781280)|0;c[n>>2]=c[(c[695343]|0)+4>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];if(FAf(0,l,k)|0){RI(3112928)|0;k=qL(3112928)|0;kwg(k,c[890696]|0);ivh(k)}if(!(Gqh(2784280,b)|0)){RI(3100472)|0;k=qL(3100472)|0;pug(k,c[890698]|0);ivh(k)}if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[890700]|0);ivh(k)}if((f|0)<=-1){RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[890702]|0,c[890704]|0);ivh(k)}if((e|0)<=-1){RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[890706]|0,c[890708]|0);ivh(k)}if(((c[d+12>>2]|0)-e|0)<(f|0)){RI(2965048)|0;k=qL(2965048)|0;Rbg(k,c[890710]|0);ivh(k)}if(!(a[b+13>>0]|0)){p=gWf(b,d,e,f,g,h)|0;i=j;return p|0}RI(2784448)|0;k=qL(2784448)|0;cVf(k,g,h);c[k+28>>2]=-1;c[k+20>>2]=f;c[k+24>>2]=f;if(!(a[b+44>>0]|0)){q=e;r=f}else{RI(2784616)|0;k=qL(2784616)|0;qVf(k,0);eVf(b,k);xvh(2784784,k,d,e,f);f=yvh(2784840,k)|0;q=0;r=f}RI(2783224)|0;f=qL(2783224)|0;c[f+8>>2]=c[696225];c[f+20>>2]=2784896;c[f+16>>2]=b;p=wvh(2783632,f,d,q,r,g,h)|0;i=j;return p|0}function cVf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[a+8>>2]=d;c[a+32>>2]=b;if(b){RI(2669048)|0;b=qL(2669048)|0;c[g>>2]=2787112;c[f+0>>2]=c[g+0>>2];NIf(b,0,f);c[a+16>>2]=b}RI(3011408)|0;b=qL(3011408)|0;_gg(b,0);c[a+12>>2]=b;i=e;return}function dVf(a){a=a|0;var b=0;b=i;qVf(a,0);i=b;return}function eVf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=0;k=b+44|0;do if(a[k>>0]|0){if(Gqh(2784224,b)|0){l=c[b+60>>2]|0;m=b+48|0;n=c[m>>2]|0;o=c[m+4>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[h>>2]=l;c[f+0>>2]=c[h+0>>2];PUf(0,f,n,o,0,g)|0;if(c[g>>2]|0){o=WUf(b,c[b+56>>2]|0)|0;RI(2781280)|0;if(a[2781428]|0){p=c[g>>2]|0;q=MUf(0,o,p)|0;ivh(q)}RI(2781280)|0;fvh(2781280);p=c[g>>2]|0;q=MUf(0,o,p)|0;ivh(q)}}if(d){o=b+36|0;xvh(2807168,d,c[b+28>>2]|0,0,c[o>>2]|0);r=o;break}o=c[b+60>>2]|0;n=c[b+28>>2]|0;l=b+36|0;m=c[l>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[j>>2]=o;c[f+0>>2]=c[j+0>>2];$Uf(0,f,n,0,m,g)|0;if(!(c[g>>2]|0))r=l;else{l=WUf(b,c[b+56>>2]|0)|0;RI(2781280)|0;if(a[2781428]|0){s=c[g>>2]|0;t=MUf(0,l,s)|0;ivh(t)}RI(2781280)|0;fvh(2781280);s=c[g>>2]|0;t=MUf(0,l,s)|0;ivh(t)}}else r=b+36|0;while(0);t=b+48|0;s=t;g=b+40|0;b=c[g>>2]|0;f=_Ei(b|0,((b|0)<0)<<31>>31|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=t;c[s>>2]=f;c[s+4>>2]=H;c[r>>2]=0;c[g>>2]=0;a[k>>0]=0;i=e;return}function fVf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;njh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[890762]|0);ivh(f)}if(!(a[b+13>>0]|0)){jWf(b,d);i=e;return}RI(2930336)|0;b=vL(d,2930336)|0;if(!b){RI(2965048)|0;f=qL(2965048)|0;Rag(f,c[890764]|0,c[890766]|0);ivh(f)}f=bth(2930552,b)|0;RI(2783224)|0;b=vL(f,2783224)|0;if(!b){RI(2965048)|0;f=qL(2965048)|0;Rag(f,c[890768]|0,c[890770]|0);ivh(f)}Irh(2783704,b,d);i=e;return}function gVf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;ojh();j=c[b+60>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[g>>2]=j;RI(2781280)|0;c[h>>2]=c[(c[695343]|0)+4>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];if(FAf(0,f,e)|0){RI(3112928)|0;e=qL(3112928)|0;kwg(e,c[890790]|0);ivh(e)}else{eVf(b,0);i=d;return}}function hVf(a){a=a|0;var b=0;b=i;zvh(2784952,a,0);i=b;return}function iVf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[h>>2]=0;m=b+60|0;n=c[m>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[j>>2]=n;RI(2781280)|0;c[k>>2]=c[(c[695343]|0)+4>>2];c[g+0>>2]=c[j+0>>2];c[f+0>>2]=c[k+0>>2];do if(GAf(0,g,f)|0?(eVf(b,0),(a[b+12>>0]|0)!=0):0){k=c[m>>2]|0;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}c[l>>2]=k;c[f+0>>2]=c[l+0>>2];jVf(0,f,h)|0;if(!(c[h>>2]|0)){RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}RI(2781280)|0;c[m>>2]=c[(c[695343]|0)+4>>2];o=0;break}k=WUf(b,c[b+56>>2]|0)|0;RI(2781280)|0;if(a[2781428]|0){p=c[h>>2]|0;q=MUf(0,k,p)|0;ivh(q)}RI(2781280)|0;fvh(2781280);p=c[h>>2]|0;q=MUf(0,k,p)|0;ivh(q)}else o=0;while(0);a[b+14>>0]=0;c[b+8>>2]=0;if(d){c[b+28>>2]=0;Jrg(0,b)}if(!o){i=e;return}else ivh(o)}function jVf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[697612]|0;if(!g){h=MK(2790456)|0;c[697612]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];f=_n[j&4095](e,d)|0;i=a;return f|0}function kVf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;xjh();if(!d){e=0;i=b;return e|0}if(!(Vof(d)|0)){e=d;i=b;return e|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((yvf(d,c[c[696275]>>2]|0)|0)!=-1){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[891352]|0);ivh(f)}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;f=Hvf(d,c[(c[696275]|0)+20>>2]|0)|0;if((f|0)<0){e=d;i=b;return e|0}e=gvf(d,f+1|0)|0;i=b;return e|0}function lVf(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}d=RVf(0,c)|0;i=b;return d|0}function mVf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function nVf(a,b){a=a|0;b=b|0;a=i;RI(2784448)|0;Avh(2669408,c[(mvh(b,2784448)|0)+32>>2]|0,b,0,0)|0;i=a;return}function oVf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Grg(a,b);KHf(a,c);i=d;return}function pVf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function qVf(b,d){b=b|0;d=d|0;var e=0;e=i;rjh();aWf(b);if((d|0)>-1){a[b+8>>0]=1;c[b+12>>2]=d;RI(1159264)|0;c[b+20>>2]=hvh(1159264,d)|0;a[b+28>>0]=1;a[b+9>>0]=1;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[890866]|0);ivh(e)}}function rVf(b){b=b|0;var d=0;d=i;sjh();if(!(a[b+29>>0]|0)){i=d;return}else{RI(3112928)|0;d=qL(3112928)|0;kwg(d,c[890870]|0);ivh(d)}}function sVf(b){b=b|0;return (a[b+29>>0]|0)==0|0}function tVf(b){b=b|0;return (a[b+29>>0]|0)==0|0}function uVf(b){b=b|0;var c=0,d=0;c=i;if(a[b+29>>0]|0){d=0;i=c;return d|0}d=(a[b+8>>0]|0)!=0;i=c;return d|0}function vVf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+4|0;g=e;qjh();rVf(b);h=b+12|0;if((c[h>>2]|0)==(d|0)){i=e;return}if(!(a[b+28>>0]|0)){RI(3100472)|0;j=qL(3100472)|0;pug(j,c[890806]|0);ivh(j)}if((d|0)>=0?(j=b+16|0,(c[j>>2]|0)<=(d|0)):0){if(!d){k=b+20|0;l=0}else{RI(1159264)|0;m=hvh(1159264,d)|0;n=b+20|0;Qig(0,c[n>>2]|0,0,m,0,c[j>>2]|0);k=n;l=m}c[b+36>>2]=0;c[k>>2]=l;c[h>>2]=d;i=e;return}RI(1086352)|0;e=hvh(1086352,4)|0;Qqh(e,c[890810]|0);l=e+16|0;c[l>>2]=c[890810];c[f>>2]=d;RI(2540224)|0;d=pL(2540224,f)|0;Qqh(e,d);c[l+(c[(c[e>>2]|0)+120>>2]|0)>>2]=d;Qqh(e,c[890812]|0);c[l+(c[(c[e>>2]|0)+120>>2]<<1)>>2]=c[890812];c[g>>2]=c[h>>2];RI(2540224)|0;h=pL(2540224,g)|0;Qqh(e,h);c[l+((c[(c[e>>2]|0)+120>>2]|0)*3|0)>>2]=h;if(a[2540708]|0){o=eqf(0,e)|0;RI(2964880)|0;p=qL(2964880)|0;q=c[890808]|0;Qag(p,q,o);ivh(p)}fvh(2540560);o=eqf(0,e)|0;RI(2964880)|0;p=qL(2964880)|0;q=c[890808]|0;Qag(p,q,o);ivh(p)}function wVf(a){a=a|0;var b=0,d=0;b=i;rVf(a);d=(c[a+16>>2]|0)-(c[a+24>>2]|0)|0;H=((d|0)<0)<<31>>31;i=b;return d|0}function xVf(a){a=a|0;var b=0,d=0;b=i;rVf(a);d=(c[a+32>>2]|0)-(c[a+24>>2]|0)|0;H=((d|0)<0)<<31>>31;i=b;return d|0}function yVf(b,c){b=b|0;c=c|0;a[b+29>>0]=1;a[b+28>>0]=0;return}function zVf(a){a=a|0;return}function AVf(a,b){a=a|0;b=b|0;var d=0;d=(b|0)<256?256:b;b=c[a+12>>2]<<1;return ((d|0)<(b|0)?b:d)|0}function BVf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;if((e|0)<(b|0)){f=(b|0)<256?256:b;b=e<<1;Lrh(2787920,a,(f|0)<(b|0)?b:f);i=d;return}f=a+36|0;b=c[f>>2]|0;if((b|0)<1){i=d;return}yDf(0,c[a+20>>2]|0,c[a+16>>2]|0,b);c[f>>2]=0;i=d;return}function CVf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;tjh();rVf(b);if(!(a[b+8>>0]|0)){RI(3100472)|0;h=qL(3100472)|0;pug(h,c[890880]|0);ivh(h)}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[890882]|0);ivh(h)}if((f|e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;_eg(h);ivh(h)}if(((c[d+12>>2]|0)-e|0)<(f|0)){RI(2965048)|0;h=qL(2965048)|0;Rag(h,c[890884]|0,c[890886]|0);ivh(h)}h=b+32|0;j=c[h>>2]|0;k=b+16|0;if((j|0)>((c[k>>2]|0)-f|0)){BVf(b,j+f|0);l=c[h>>2]|0}else l=j;Qig(0,d,e,c[b+20>>2]|0,l,f);l=(c[h>>2]|0)+f|0;c[h>>2]=l;if((l|0)<(c[k>>2]|0)){i=g;return}c[k>>2]=l;i=g;return}function DVf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function EVf(a){a=a|0;var b=0;a=i;RI(2781280)|0;c[c[695343]>>2]=-1;b=IAf(0,-1,-1)|0;RI(2781280)|0;c[(c[695343]|0)+4>>2]=b;i=a;return}function FVf(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function GVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697704]|0;if(!b){d=MK(2790824)|0;c[697704]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function HVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697716]|0;if(!b){d=MK(2790872)|0;c[697716]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function IVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697728]|0;if(!b){d=MK(2790920)|0;c[697728]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function JVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697740]|0;if(!b){d=MK(2790968)|0;c[697740]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function KVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697754]|0;if(!b){d=MK(2791024)|0;c[697754]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function LVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697768]|0;if(!b){d=MK(2791080)|0;c[697768]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function MVf(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[697784]|0;if(!b){d=MK(2791144)|0;c[697784]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function NVf(d){d=d|0;var e=0,f=0;d=i;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;fvh(2781280)}e=JVf(0)|0;RI(2785008)|0;b[(c[696275]|0)+16>>1]=e;e=KVf(0)|0;RI(2785008)|0;b[(c[696275]|0)+6>>1]=e;e=LVf(0)|0;RI(2785008)|0;b[(c[696275]|0)+4>>1]=e;e=MVf(0)|0;RI(2785008)|0;b[(c[696275]|0)+8>>1]=e;e=OVf(0)|0;RI(2785008)|0;c[c[696275]>>2]=e;RI(2785008)|0;e=xuf((c[696275]|0)+6|0)|0;RI(2785008)|0;c[(c[696275]|0)+12>>2]=e;RI(1136088)|0;e=hvh(1136088,3)|0;RI(2785008)|0;f=e+16|0;b[f>>1]=b[(c[696275]|0)+6>>1]|0;RI(2785008)|0;b[f+(c[(c[e>>2]|0)+120>>2]|0)>>1]=b[(c[696275]|0)+4>>1]|0;RI(2785008)|0;b[f+(c[(c[e>>2]|0)+120>>2]<<1)>>1]=b[(c[696275]|0)+16>>1]|0;RI(2785008)|0;c[(c[696275]|0)+20>>2]=e;RI(2785008)|0;e=b[(c[696275]|0)+6>>1]|0;RI(2785008)|0;f=e<<16>>16==(b[(c[696275]|0)+16>>1]|0);RI(2785008)|0;a[(c[696275]|0)+24>>0]=f&1;i=d;return}function OVf(a){a=a|0;var b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;e=vrg(0)|0;RI(1136088)|0;if(e){e=hvh(1136088,36)|0;c[d>>2]=3140320;c[b+0>>2]=c[d+0>>2];Guf(0,e,b);f=e;i=a;return f|0}else{f=hvh(1136088,1)|0;i=a;return f|0}return 0}function PVf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;wjh();if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[891320]|0);ivh(g)}if(!f){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[891322]|0);ivh(g)}if(!(Vof(e)|0)){h=f;i=d;return h|0}if(!(Vof(f)|0)){h=e;i=d;return h|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((yvf(e,c[c[696275]>>2]|0)|0)!=-1){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[891324]|0);ivh(g)}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((yvf(f,c[c[696275]>>2]|0)|0)!=-1){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[891326]|0);ivh(g)}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(QVf(0,f)|0){h=f;i=d;return h|0}g=Wof(e,(Vof(e)|0)+-1|0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(g<<16>>16!=(b[(c[696275]|0)+6>>1]|0)){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(g<<16>>16!=(b[(c[696275]|0)+4>>1]|0)){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(g<<16>>16!=(b[(c[696275]|0)+16>>1]|0)){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(a[2540708]|0))fvh(2540560);RI(2785008)|0;h=iwf(0,e,c[(c[696275]|0)+12>>2]|0,f)|0;i=d;return h|0}}}if(!(a[2540708]|0))fvh(2540560);h=gwf(0,e,f)|0;i=d;return h|0}function QVf(d,e){d=d|0;e=e|0;var f=0,g=0;d=i;Ajh();if(!e){f=0;i=d;return f|0}if(!(Vof(e)|0)){f=0;i=d;return f|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((yvf(e,c[c[696275]>>2]|0)|0)!=-1){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[891446]|0);ivh(g)}g=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(g<<16>>16==(b[(c[696275]|0)+6>>1]|0)){f=1;i=d;return f|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(g<<16>>16==(b[(c[696275]|0)+4>>1]|0)){f=1;i=d;return f|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(a[(c[696275]|0)+24>>0]|0){f=0;i=d;return f|0}if((Vof(e)|0)<2){f=0;i=d;return f|0}g=Wof(e,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;f=g<<16>>16==(b[(c[696275]|0)+16>>1]|0);i=d;return f|0}function RVf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;f=d;yjh();if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[891356]|0);ivh(g)}if(!(Vof(jvf(e)|0)|0)){g=tof(0,c[891358]|0)|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,g);ivh(h)}if(vrg(0)|0){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}j=SVf(0,e)|0}else j=e;e=Wof(j,(Vof(j)|0)+-1|0)|0;if((Vof(j)|0)>=2){h=Wof(j,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,h)|0){h=Wof(j,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,h)|0){if((Vof(j)|0)==2){RI(2965048)|0;k=qL(2965048)|0;l=c[891360]|0;Rbg(k,l);ivh(k)}if((Dvf(j,Wof(j,0)|0,2)|0)<=-1){RI(2965048)|0;k=qL(2965048)|0;l=c[891360]|0;Rbg(k,l);ivh(k)}k=Wof(j,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(k<<16>>16==(b[(c[696275]|0)+6>>1]|0))m=j;else{RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;k=b[(c[696275]|0)+4>>1]|0;RI(2785008)|0;m=Qvf(j,k,b[(c[696275]|0)+6>>1]|0)|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}n=UVf(0,m)|0}else o=28}else o=28}else o=28;if((o|0)==28){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}do if(QVf(0,j)|0){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((b[(c[696275]|0)+6>>1]|0)==92?(Vof(j)|0)>=2:0){o=Wof(j,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,o)|0){o=Wof(j,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,o)|0)){o=zUf(0)|0;m=Wof(o,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(m<<16>>16!=(b[(c[696275]|0)+16>>1]|0)){p=fpf(o,0,Dvf(o,92,(Fvf(o,c[891362]|0)|0)+1|0)|0)|0;break}m=fpf(o,0,2)|0;if(!(a[2540708]|0))fvh(2540560);p=gwf(0,m,j)|0}else p=j}else p=j}else p=j}else{m=zUf(0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(a[2540708]|0))fvh(2540560);RI(2785008)|0;p=iwf(0,m,c[(c[696275]|0)+12>>2]|0,j)|0}while(0);RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}n=UVf(0,p)|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,e)|0)){q=n;i=d;return q|0}e=Wof(n,(Vof(n)|0)+-1|0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(e<<16>>16==(b[(c[696275]|0)+6>>1]|0)){q=n;i=d;return q|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;b[f>>1]=b[(c[696275]|0)+6>>1]|0;RI(2540392)|0;e=pL(2540392,f)|0;if(!(a[2540708]|0))fvh(2540560);q=fwf(0,n,e)|0;i=d;return q|0}function SVf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0;d=i;i=i+16|0;f=d;if((Vof(e)|0)<=1){g=e;i=d;return g|0}if((Wof(e,1)|0)<<16>>16!=58){g=e;i=d;return g|0}h=Wof(e,0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;fvh(2540392)}if(!(ouf(0,h)|0)){g=e;i=d;return g|0}h=zUf(0)|0;if((Vof(e)|0)==2){j=Wof(h,0)|0;if(j<<16>>16==(Wof(e,0)|0)<<16>>16){g=h;i=d;return g|0}b[f>>1]=92;RI(2540392)|0;j=pL(2540392,f)|0;if(!(a[2540708]|0))fvh(2540560);g=fwf(0,e,j)|0;i=d;return g|0}j=Wof(e,2)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(j<<16>>16==(b[(c[696275]|0)+6>>1]|0)){g=e;i=d;return g|0}j=Wof(e,2)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(j<<16>>16==(b[(c[696275]|0)+4>>1]|0)){g=e;i=d;return g|0}j=Wof(h,0)|0;if(j<<16>>16==(Wof(e,0)|0)<<16>>16){j=fpf(e,2,(Vof(e)|0)+-2|0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}g=PVf(0,h,j)|0;i=d;return g|0}j=fpf(e,0,2)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}h=fpf(e,2,(Vof(e)|0)+-2|0)|0;if(!(a[2540708]|0))fvh(2540560);RI(2785008)|0;g=iwf(0,j,c[(c[696275]|0)+12>>2]|0,h)|0;i=d;return g|0}function TVf(d,e){d=d|0;e=e|0;var f=0;d=i;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((b[(c[696275]|0)+6>>1]|0)==e<<16>>16){f=1;i=d;return f|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;f=(b[(c[696275]|0)+4>>1]|0)==e<<16>>16;i=d;return f|0}function UVf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+16|0;f=d+2|0;g=d;Bjh();if(!e){h=0;i=d;return h|0}if(vrg(0)|0)j=jvf(e)|0;else j=e;if(!(Vof(j)|0)){h=j;i=d;return h|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}e=VVf(0,j)|0;RI(1136088)|0;k=hvh(1136088,2)|0;RI(2785008)|0;l=k+16|0;b[l>>1]=b[(c[696275]|0)+6>>1]|0;RI(2785008)|0;b[l+(c[(c[k>>2]|0)+120>>2]|0)>>1]=b[(c[696275]|0)+4>>1]|0;l=dvf(j,k)|0;if(vrg(0)|0?(Vof(e)|0)>=3:0){k=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,k)|0){k=Wof(e,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}m=TVf(0,k)|0}else m=0}else m=0;k=m?3:0;n=l+12|0;if((c[n>>2]|0)<=0){h=e;i=d;return h|0}o=l+16|0;p=0;q=0;while(1){if(vrg(0)|0){r=c[o+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0;RI(1136088)|0;s=nvf(r,hvh(1136088,0)|0)|0;Qqh(l,s);c[o+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]=s}if(!(a[2540708]|0))fvh(2540560);s=c[o+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0;do if(!(gpf(0,s,c[891450]|0)|0)){if((q|0)!=0?(Vof(c[o+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0)|0)==0:0){t=p;break}if(!(a[2540708]|0))fvh(2540560);r=c[o+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0;if(gpf(0,r,c[891452]|0)|0){t=(((p|0)>(k|0))<<31>>31)+p|0;break}else{Qqh(l,c[o+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0);r=c[(c[l>>2]|0)+120>>2]|0;c[o+(da(r,p)|0)>>2]=c[o+(da(r,q)|0)>>2];t=p+1|0;break}}else t=p;while(0);q=q+1|0;if((q|0)>=(c[n>>2]|0)){u=t;break}else p=t}if(!u){h=e;i=d;return h|0}else if((u|0)==1)v=31;if((v|0)==31){if(!(a[2540708]|0))fvh(2540560);if(gpf(0,c[l+16>>2]|0,c[c[635163]>>2]|0)|0){h=e;i=d;return h|0}}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(a[2540708]|0))fvh(2540560);RI(2785008)|0;t=nwf(0,c[(c[696275]|0)+12>>2]|0,l,0,u)|0;if(!(vrg(0)|0)){h=t;i=d;return h|0}if(m){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(a[2540708]|0))fvh(2540560);RI(2785008)|0;w=gwf(0,c[(c[696275]|0)+12>>2]|0,t)|0}else w=t;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(XVf(0,e,w)|0)x=w;else{if(!(a[2540708]|0))fvh(2540560);x=gwf(0,e,w)|0}if(m){h=x;i=d;return h|0}m=Wof(j,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,m)|0)){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(XVf(0,e,j)|0){if((Vof(x)|0)>2){h=x;i=d;return h|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(xvf(x,c[(c[696275]|0)+12>>2]|0)|0){h=x;i=d;return h|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;b[f>>1]=b[(c[696275]|0)+6>>1]|0;RI(2540392)|0;j=pL(2540392,f)|0;if(!(a[2540708]|0))fvh(2540560);h=fwf(0,x,j)|0;i=d;return h|0}}j=zUf(0)|0;if((Vof(j)|0)>=2){f=Wof(j,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(f<<16>>16==(b[(c[696275]|0)+16>>1]|0)){if(Vof(x)|0){f=Wof(x,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,f)|0))y=x;else v=75}else v=75;if((v|0)==75){b[g>>1]=92;RI(2540392)|0;v=pL(2540392,g)|0;if(!(a[2540708]|0))fvh(2540560);y=fwf(0,x,v)|0}v=fpf(j,0,2)|0;if(!(a[2540708]|0))fvh(2540560);h=gwf(0,v,y)|0;i=d;return h|0}}y=Wof(j,(Vof(j)|0)+-1|0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}do if(TVf(0,y)|0){v=Wof(x,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,v)|0))break;v=gvf(x,1)|0;if(!(a[2540708]|0))fvh(2540560);h=gwf(0,j,v)|0;i=d;return h|0}while(0);if(!(a[2540708]|0))fvh(2540560);h=gwf(0,j,x)|0;i=d;return h|0}function VVf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;zjh();if(!e){f=0;i=d;return f|0}if(!(Vof(jvf(e)|0)|0)){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[891420]|0);ivh(g)}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(QVf(0,e)|0)){if(!(a[2540708]|0))fvh(2540560);f=c[c[635163]>>2]|0;i=d;return f|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if((b[(c[696275]|0)+6>>1]|0)==47){g=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,g)|0){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;h=(c[696275]|0)+12|0}else{if(!(a[2540708]|0))fvh(2540560);h=c[635163]|0}f=c[h>>2]|0;i=d;return f|0}if((Vof(e)|0)==1){h=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,h)|0){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;f=c[(c[696275]|0)+12>>2]|0;i=d;return f|0}}if((Vof(e)|0)<=1){if(!(a[2540708]|0))fvh(2540560);f=c[c[635163]>>2]|0;i=d;return f|0}h=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,h)|0){h=Wof(e,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,h)|0){a:do if((Vof(e)|0)>2){h=2;while(1){g=Wof(e,h)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}j=h+1|0;if(TVf(0,g)|0){k=h;break a}if((j|0)<(Vof(e)|0))h=j;else{k=j;break}}}else k=2;while(0);b:do if((k|0)<(Vof(e)|0)){h=k;while(1){j=h+1|0;if((j|0)>=(Vof(e)|0)){l=j;break b}g=Wof(e,j)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,g)|0){l=j;break}else h=j}}else l=k;while(0);RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}k=fpf(e,2,l+-2|0)|0;RI(2785008)|0;l=b[(c[696275]|0)+4>>1]|0;RI(2785008)|0;h=Qvf(k,l,b[(c[696275]|0)+6>>1]|0)|0;if(!(a[2540708]|0))fvh(2540560);RI(2785008)|0;l=c[(c[696275]|0)+12>>2]|0;RI(2785008)|0;f=iwf(0,l,c[(c[696275]|0)+12>>2]|0,h)|0;i=d;return f|0}}h=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,h)|0){RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;f=c[(c[696275]|0)+12>>2]|0;i=d;return f|0}h=Wof(e,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(h<<16>>16!=(b[(c[696275]|0)+16>>1]|0)){f=fpf(zUf(0)|0,0,2)|0;i=d;return f|0}if((Vof(e)|0)<3)m=2;else{h=Wof(e,2)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}l=TVf(0,h)|0;m=l?3:2}f=fpf(e,0,m)|0;i=d;return f|0}function WVf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;d=i;a:do if((Vof(e)|0)>2){f=2;while(1){g=Wof(e,f)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}h=f+1|0;if(TVf(0,g)|0){j=f;break a}if((h|0)<(Vof(e)|0))f=h;else{j=h;break}}}else j=2;while(0);b:do if((j|0)<(Vof(e)|0)){f=j;while(1){h=f+1|0;if((h|0)>=(Vof(e)|0)){k=h;break b}g=Wof(e,h)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,g)|0){k=h;break}else f=h}}else k=j;while(0);j=fpf(e,2,k+-2|0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;k=b[(c[696275]|0)+4>>1]|0;RI(2785008)|0;e=Qvf(j,k,b[(c[696275]|0)+6>>1]|0)|0;i=d;return e|0}function XVf(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;g=d;b[g>>1]=0;if((Vof(e)|0)<2){h=0;i=d;return h|0}if((Vof(f)|0)<=1){h=0;i=d;return h|0}j=Wof(e,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,j)|0){j=Wof(e,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(TVf(0,j)|0){j=Wof(f,0)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,j)|0)){h=0;i=d;return h|0}j=Wof(f,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,j)|0)){h=0;i=d;return h|0}RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}j=WVf(0,e)|0;k=WVf(0,f)|0;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;fvh(2686624)}l=eKf(0)|0;if(!(a[2540708]|0))fvh(2540560);h=(qvf(0,j,k,1,l)|0)==0;i=d;return h|0}}b[g>>1]=Wof(e,0)|0;if(!(luf(g,Wof(f,0)|0)|0)){h=0;i=d;return h|0}g=Wof(f,1)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}RI(2785008)|0;if(g<<16>>16!=(b[(c[696275]|0)+16>>1]|0)){h=0;i=d;return h|0}if((Vof(e)|0)<3){h=1;i=d;return h|0}if((Vof(f)|0)<3){h=1;i=d;return h|0}g=Wof(e,2)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}if(!(TVf(0,g)|0)){h=0;i=d;return h|0}g=Wof(f,2)|0;RI(2785008)|0;if(!(a[2785156]|0)){RI(2785008)|0;fvh(2785008)}h=TVf(0,g)|0;i=d;return h|0}function YVf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ZVf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2795840)|0);c[c[d>>2]>>2]=a;i=b;return}function _Vf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function $Vf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function aWf(a){a=a|0;return}function bWf(a){a=a|0;var b=0;a=i;RI(2806496)|0;b=qL(2806496)|0;RI(2806664)|0;c[c[701689]>>2]=b;i=a;return}function cWf(a){a=a|0;return}function dWf(a){a=a|0;var b=0;b=i;eth(2806832,a);i=b;return}function eWf(a,b){a=a|0;b=b|0;return}function fWf(a){a=a|0;var b=0;b=i;zvh(2806888,a,1);i=b;return}function gWf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;Cjh();if(!(Gqh(2806944,a)|0)){RI(3100472)|0;j=qL(3100472)|0;pug(j,c[891456]|0);Bvh(j)}RI(2807e3)|0;j=qL(2807e3)|0;c[j+20>>2]=-1;c[j+8>>2]=g;xvh(2807168,a,b,d,e);iWf(j,0);if(!f){i=h;return j|0}Avh(2669408,f,j,0,0)|0;i=h;return j|0}function hWf(a,b){a=a|0;b=b|0;c[a+20>>2]=-1;c[a+8>>2]=b;return}function iWf(b,d){b=b|0;d=d|0;var e=0;e=i;c[b+16>>2]=d;a[b+12>>0]=1;Jag(0,b);d=c[b+24>>2]|0;if(!d){Kag(0,b);i=e;return}Sgg(d)|0;Kag(0,b);i=e;return}function jWf(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;Djh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[891460]|0);Bvh(e)}RI(2807e3)|0;e=vL(d,2807e3)|0;if((e|0)!=0?(c[e+20>>2]|0)==-1:0){d=e+13|0;if(a[d>>0]|0){RI(3084976)|0;f=qL(3084976)|0;osg(f,c[891466]|0);Bvh(f)}a[d>>0]=1;d=c[e+16>>2]|0;if(!d){i=b;return}else Bvh(d)}RI(2965048)|0;d=qL(2965048)|0;Rag(d,c[891462]|0,c[891464]|0);Bvh(d)}function kWf(a){a=a|0;return c[a+20>>2]|0}function lWf(b){b=b|0;return (a[b+13>>0]|0)!=0|0}function mWf(b,c){b=b|0;c=c|0;a[b+13>>0]=c&1;return}function nWf(a){a=a|0;return c[a+16>>2]|0}function oWf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function pWf(a){a=a|0;return 1}function qWf(a){a=a|0;return 1}function rWf(a){a=a|0;return 1}function sWf(a){a=a|0;a=i;H=0;i=a;return 0}function tWf(a){a=a|0;a=i;H=0;i=a;return 0}function uWf(a){a=a|0;return}function vWf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function wWf(a){a=a|0;return}function xWf(a){a=a|0;return}function yWf(a){a=a|0;return}function zWf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;AWf(a,b,c,1,1024);i=d;return}function AWf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;BWf(a,b,c,d,e);i=f;return}function BWf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;Ejh();if(!b){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[891482]|0);Bvh(h)}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[891484]|0);Bvh(h)}if(!(Gqh(2807384,b)|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[891486]|0);Bvh(h)}if((f|0)>0){h=(f|0)<128?128:f;c[a+40>>2]=b;RI(1159264)|0;c[a+8>>2]=Cvh(1159264,h)|0;c[a+24>>2]=h;c[a+32>>2]=d;c[a+36>>2]=Dvh(2993768,d)|0;b=(c[(kvh(2994200,d)|0)+12>>2]|0)==0;c[a+28>>2]=(b?0:2)|e&1;e=Arh(2994128,d,h)|0;RI(1136088)|0;c[a+12>>2]=Cvh(1136088,e+1|0)|0;c[a+16>>2]=0;c[a+20>>2]=0;i=g;return}else{RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[891488]|0,c[891490]|0);Bvh(g)}}function CWf(a){a=a|0;var b=0;a=i;RI(2809736)|0;b=qL(2809736)|0;RI(2809992)|0;c[c[702521]>>2]=b;i=a;return}function DWf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+40|0;if(b?(f=c[e>>2]|0,(f|0)!=0):0)eth(2806832,f);c[a+8>>2]=0;c[a+12>>2]=0;c[a+32>>2]=0;c[a+36>>2]=0;c[e>>2]=0;EWf(a,b);i=d;return}function EWf(a,b){a=a|0;b=b|0;var c=0;c=i;if(b)Jrg(0,a);i=c;return}function FWf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function GWf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;HWf(a,b,c,1024);i=d;return}function HWf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;Fjh();IWf(a);if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[891536]|0);Bvh(g)}if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[891538]|0);Bvh(g)}if((e|0)<=0){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[891540]|0);Bvh(g)}if(Gqh(2806944,b)|0){c[a+16>>2]=b;JWf(a,d,e);i=f;return}else{RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[891542]|0);Bvh(f)}}function IWf(a){a=a|0;var b=0;b=i;c[a+8>>2]=$uf(org(0)|0)|0;i=b;return}function JWf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;c[b+12>>2]=d;c[b+28>>2]=0;c[b+36>>2]=0;g=Asg(0,e,256)|0;RI(1136088)|0;c[b+32>>2]=Cvh(1136088,g)|0;e=Arh(2994056,d,g)|0;RI(1159264)|0;c[b+24>>2]=Cvh(1159264,e)|0;e=b+16|0;if(!(Gqh(2807456,c[e>>2]|0)|0)){i=f;return}g=yvh(2807600,c[e>>2]|0)|0;e=H;if((e|0)<0|(e|0)==0&g>>>0<1){i=f;return}a[b+41>>0]=1;i=f;return}function KWf(b){b=b|0;var d=0,e=0;b=i;RI(2806664)|0;if(!(a[2806812]|0)){RI(2806664)|0;Evh(2806664)}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;Evh(2978896)}d=zeg(0)|0;RI(2811360)|0;e=qL(2811360)|0;RI(2806664)|0;HWf(e,c[c[701689]>>2]|0,d,1);RI(2811360)|0;c[c[702863]>>2]=e;i=b;return}function LWf(b,c){b=b|0;c=c|0;var d=0;d=i;a[b+20>>0]=c&1;if(!c){i=d;return}eth(2811528,b);i=d;return}function MWf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b+40|0;g=b+16|0;if(!((a[f>>0]|0)!=0|d^1)?(c[g>>2]|0)!=0:0){eth(2811528,b);a[f>>0]=1;eth(2806832,c[g>>2]|0)}c[g>>2]=0;c[b+24>>2]=0;c[b+12>>2]=0;c[b+32>>2]=0;if(!0){i=e;return}else Bvh(0)}function NWf(b){b=b|0;var d=0,e=0;d=i;Gjh();if(a[b+40>>0]|0){RI(3112928)|0;e=qL(3112928)|0;kwg(e,c[891558]|0);Bvh(e)}OWf(b);if((c[b+28>>2]|0)<1){i=d;return}PWf(b);eth(2807736,c[b+16>>2]|0);i=d;return}function OWf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+28|0;if((c[d>>2]|0)>=1)PWf(a);e=a+36|0;f=c[e>>2]|0;if((f|0)<1){i=b;return}g=Fvh(2990632,c[a+12>>2]|0,c[a+32>>2]|0,0,f,c[a+24>>2]|0,c[d>>2]|0)|0;c[d>>2]=(c[d>>2]|0)+g;c[e>>2]=0;i=b;return}function PWf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+41|0;f=b+28|0;if((a[e>>0]|0)==0?(c[f>>2]|0)>=1:0){g=kvh(2994200,c[b+12>>2]|0)|0;h=c[g+12>>2]|0;if((h|0)>=1)xvh(2807168,c[b+16>>2]|0,g,0,h);a[e>>0]=1}xvh(2807168,c[b+16>>2]|0,c[b+24>>2]|0,0,c[f>>2]|0);c[f>>2]=0;i=d;return}function QWf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;Hjh();if(a[b+40>>0]|0){RI(3112928)|0;h=qL(3112928)|0;kwg(h,c[891568]|0);Bvh(h)}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[891570]|0);Bvh(h)}if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[891572]|0,c[891574]|0);Bvh(h)}if((f|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[891576]|0,c[891578]|0);Bvh(h)}if(((c[d+12>>2]|0)-f|0)<(e|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[891580]|0);Bvh(h)}RWf(b,d,e,f);if(!(a[b+20>>0]|0)){i=g;return}eth(2811528,b);i=g;return}function RWf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if((e|0)<=0){i=f;return}g=a+32|0;h=a+36|0;j=e;e=d;d=c[h>>2]|0;while(1){k=c[g>>2]|0;l=c[k+12>>2]|0;if((l|0)==(d|0)){OWf(a);m=c[g>>2]|0;n=m;o=c[h>>2]|0;p=c[m+12>>2]|0}else{n=k;o=d;p=l-d|0}l=(p|0)>(j|0)?j:p;Qig(0,b,e<<1,n,o<<1,l<<1);j=j-l|0;d=(c[h>>2]|0)+l|0;c[h>>2]=d;if((j|0)<=0)break;else e=l+e|0}i=f;return}function SWf(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;f=Vof(d)|0;if((f|0)<=0){i=e;return}g=a+32|0;h=a+36|0;j=c[h>>2]|0;k=f;f=0;while(1){l=c[g>>2]|0;m=c[l+12>>2]|0;if((m|0)==(j|0)){OWf(a);n=c[g>>2]|0;o=n;p=c[n+12>>2]|0}else{o=l;p=m-j|0}m=(p|0)>(k|0)?k:p;a:do if((m|0)>0){l=~k;n=~p;q=~((l|0)>(n|0)?l:n);n=o;l=0;while(1){r=c[h>>2]|0;s=Wof(d,l+f|0)|0;b[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,r+l|0)|0)>>1]=s;s=l+1|0;if((s|0)==(q|0))break a;n=c[g>>2]|0;l=s}}while(0);k=k-m|0;j=(c[h>>2]|0)+m|0;c[h>>2]=j;if((k|0)<=0)break;else f=m+f|0}i=e;return}function TWf(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;Ijh();if(a[d+40>>0]|0){RI(3112928)|0;g=qL(3112928)|0;kwg(g,c[891600]|0);Bvh(g)}g=d+36|0;h=c[g>>2]|0;j=d+32|0;k=c[j>>2]|0;if((h|0)<(c[k+12>>2]|0)){l=h;m=k}else{OWf(d);l=c[g>>2]|0;m=c[j>>2]|0}c[g>>2]=l+1;b[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,l)|0)>>1]=e;if(!(a[d+20>>0]|0)){i=f;return}eth(2811528,d);i=f;return}function UWf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Jjh();if(a[b+40>>0]|0){RI(3112928)|0;f=qL(3112928)|0;kwg(f,c[891604]|0);Bvh(f)}if(d)RWf(b,d,0,c[d+12>>2]|0);if(!(a[b+20>>0]|0)){i=e;return}eth(2811528,b);i=e;return}function VWf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Kjh();if(a[b+40>>0]|0){RI(3112928)|0;f=qL(3112928)|0;kwg(f,c[891608]|0);Bvh(f)}if(d)SWf(b,d);if(!(a[b+20>>0]|0)){i=e;return}eth(2811528,b);i=e;return}function WWf(a){a=a|0;var b=0;b=i;zvh(2811584,a,0);i=b;return}function XWf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function YWf(a){a=a|0;return}function ZWf(a){a=a|0;var b=0;a=i;RI(2813536)|0;b=qL(2813536)|0;RI(2811136)|0;c[c[702807]>>2]=b;i=a;return}function _Wf(a){a=a|0;var b=0;b=i;zvh(2813832,a,1);i=b;return}function $Wf(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;Ljh();if(!b){RI(2963920)|0;d=qL(2963920)|0;Iag(d,c[891612]|0);Bvh(d)}RI(2813888)|0;if(vL(b,2813888)|0){e=b;i=a;return e|0}RI(2813888)|0;d=qL(2813888)|0;c[d+8>>2]=b;e=d;i=a;return e|0}function aXf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function bXf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function cXf(a){a=a|0;var b=0;b=i;IWf(a);i=b;return}function dXf(a,b){a=a|0;b=b|0;return}function eXf(a,b){a=a|0;b=b|0;return}function fXf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function gXf(a){a=a|0;var b=0;a=i;RI(2814672)|0;b=qL(2814672)|0;IWf(b);RI(2813288)|0;c[c[703345]>>2]=b;i=a;return}function hXf(a,b){a=a|0;b=b|0;var c=0;c=i;if(b)Jrg(0,a);i=c;return}function iXf(a){a=a|0;var b=0;b=i;zvh(2815248,a,1);Jrg(0,a);i=b;return}function jXf(a){a=a|0;return}function kXf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;Mjh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[891624]|0);Bvh(f)}RI(2815304)|0;if(vL(d,2815304)|0){g=d;i=b;return g|0}RI(2815304)|0;f=qL(2815304)|0;IWf(f);c[f+12>>2]=d;a[f+16>>0]=e&1;g=f;i=b;return g|0}function lXf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;IWf(b);c[b+12>>2]=d;a[b+16>>0]=e&1;i=f;return}function mXf(a,b){a=a|0;b=b|0;return}function nXf(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}Gvh(2815472,a,b,0,c[b+12>>2]|0);i=d;return}function oXf(a,b){a=a|0;b=b|0;var c=0;c=i;if(!b){i=c;return}Hvh(2815528,a,$uf(b)|0);i=c;return}function pXf(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;Njh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[891636]|0);Bvh(h)}if((e|0)<0){RI(2964880)|0;j=qL(2964880)|0;k=c[891638]|0;wdg(j,k);Bvh(j)}h=c[d+12>>2]|0;if((h|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;k=c[891638]|0;wdg(j,k);Bvh(j)}if((f|0)<0|(h-f|0)<(e|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[891640]|0);Bvh(h)}if((f|0)<=0){i=g;return}h=d+16|0;j=f;f=e;while(1){Ivh(2815584,a,b[h+(da(c[(c[d>>2]|0)+120>>2]|0,f)|0)>>1]|0);j=j+-1|0;if((j|0)<=0)break;else f=f+1|0}i=g;return}function qXf(a){a=a|0;var b=0;b=i;Hvh(2815528,a,c[a+8>>2]|0);i=b;return}function rXf(a,b){a=a|0;b=b|0;var c=0;c=i;Gth(2815640,a,b);eth(2815696,a);i=c;return}function sXf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function tXf(a){a=a|0;var b=0;b=i;Jag(0,a);eth(2816e3,c[a+12>>2]|0);Kag(0,a);i=b;return}function uXf(a,b){a=a|0;b=b|0;var d=0;d=i;Jag(0,a);Ivh(2815584,c[a+12>>2]|0,b);Kag(0,a);i=d;return}function vXf(a,b){a=a|0;b=b|0;var d=0;d=i;Jag(0,a);Hvh(2815528,c[a+12>>2]|0,b);Kag(0,a);i=d;return}function wXf(a,b){a=a|0;b=b|0;var d=0;d=i;Jag(0,a);Gth(2815640,c[a+12>>2]|0,b);Kag(0,a);i=d;return}function xXf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Jag(0,a);Gvh(2815472,c[a+12>>2]|0,b,d,e);Kag(0,a);i=f;return}function yXf(a){a=a|0;var b=0;b=i;Jag(0,a);eth(2815696,c[a+12>>2]|0);Kag(0,a);i=b;return}function zXf(a,b){a=a|0;b=b|0;var d=0;d=i;Jag(0,a);Gth(2816256,c[a+12>>2]|0,b);Kag(0,a);i=d;return}function AXf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zWf(a,b,c);i=d;return}function BXf(a){a=a|0;var d=0,e=0;a=i;d=Vof(org(0)|0)|0;RI(1153040)|0;e=Cvh(1153040,d)|0;RI(2817304)|0;c[c[704349]>>2]=e;e=org(0)|0;if((Vof(e)|0)!=1){i=a;return}d=Wof(e,0)|0;RI(2817304)|0;b[(c[704349]|0)+4>>1]=d;i=a;return}function CXf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;HWf(a,b,c,1024);i=d;return}function DXf(a){a=a|0;var b=0;b=i;NWf(a);i=b;return}function EXf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;QWf(a,b,c,d);i=e;return}function FXf(a,b){a=a|0;b=b|0;var c=0;c=i;TWf(a,b);i=c;return}function GXf(a,b){a=a|0;b=b|0;var c=0;c=i;UWf(a,b);i=c;return}function HXf(a,b){a=a|0;b=b|0;var c=0;c=i;VWf(a,b);i=c;return}function IXf(b){b=b|0;return (a[b+60>>0]|0)!=0|0}function JXf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=KXf(a)|0;e=a+56|0;a=c[e>>2]|0;if(!a){i=b;return d|0}f=ILf(a)|0;a=d+20|0;g=c[a>>2]|0;c[a>>2]=(f|0)==0?g^1:g|1;c[d+32>>2]=f;c[d+36>>2]=JLf(c[e>>2]|0)|0;i=b;return d|0}function KXf(a){a=a|0;var b=0,d=0;b=i;RI(2842352)|0;d=qL(2842352)|0;c[d+40>>2]=1;V$f(0,a,d);i=b;return d|0}function LXf(a,b){a=a|0;b=b|0;var d=0,e=0;d=a+20|0;e=c[d>>2]|0;c[d>>2]=(b|0)==0?e^1:e|1;c[a+32>>2]=b;return}function MXf(a,b){a=a|0;b=b|0;c[a+36>>2]=b;return}function NXf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2914264)|0;c[a+8>>2]=ML(c[728582]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function OXf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function PXf(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function QXf(a){a=a|0;return c[a+20>>2]|0}function RXf(a){a=a|0;return c[a+24>>2]|0}function SXf(a){a=a|0;return c[a+16>>2]|0}function TXf(a){a=a|0;var b=0,d=0;b=i;if((c[(c[a+24>>2]|0)+56>>2]|0)==0?!(VXf(a)|0):0)Bvh(WXf(0)|0);d=XXf(a)|0;i=b;return d|0}function UXf(a){a=a|0;return (c[a+56>>2]|0)!=0|0}function VXf(b){b=b|0;var d=0,e=0;d=i;e=dvh(2820152,c[b+24>>2]|0)|0;RI(2820208)|0;b=c[(Jvh(e,2820208)|0)+12>>2]|0;RI(2818576)|0;e=(a[(Jvh(b,2818576)|0)+60>>0]|0)!=0;i=d;return e|0}function WXf(a){a=a|0;var b=0;a=i;Qjh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[891696]|0);i=a;return b|0}function XXf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;d=a+8|0;e=c[d>>2]|0;RI(1137488)|0;if(!e){f=Cvh(1137488,0)|0;i=b;return f|0}g=Cvh(1137488,c[e+12>>2]|0)|0;e=c[d>>2]|0;if((c[e+12>>2]|0)<=0){f=g;i=b;return f|0}h=a+28|0;j=g+16|0;k=e;e=0;do{l=c[h>>2]|0;m=e;e=e+1|0;if(!l)n=0;else n=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,e)|0)>>2]|0;RI(2819760)|0;l=qL(2819760)|0;YXf(l,n,c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,m)|0)>>2]|0,a,e);Qqh(g,l);c[j+(da(c[(c[g>>2]|0)+120>>2]|0,m)|0)>>2]=l;k=c[d>>2]|0}while((e|0)<(c[k+12>>2]|0));f=g;i=b;return f|0}function YXf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;c[a+8>>2]=d;c[a+16>>2]=e;if(!b){c[a+20>>2]=0;c[a+24>>2]=f+-1;h=0;j=a+28|0;c[j>>2]=h;i=g;return}else{c[a+20>>2]=Fqh(2836032,b)|0;c[a+24>>2]=(Aqh(2836088,b)|0)+-1;h=Aqh(2835976,b)|0;j=a+28|0;c[j>>2]=h;i=g;return}}function ZXf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bvh(_Xf(0)|0);return 0}function _Xf(a){a=a|0;var b=0;a=i;Pjh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[891664]|0);i=a;return b|0}function $Xf(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Bvh(_Xf(0)|0);return 0}function aYf(a){a=a|0;Bvh(_Xf(0)|0);return 0}function bYf(a){a=a|0;return c[a+12>>2]|0}function cYf(a){a=a|0;return c[a+24>>2]|0}function dYf(a){a=a|0;return c[a+24>>2]|0}function eYf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=(c[b+12>>2]&16|0)==0;RI(2819928)|0;b=(a[2820076]|0)!=0;if(e){if(!b){RI(2819928)|0;Evh(2819928)}RI(2819928)|0;f=c[705005]|0;g=c[f>>2]|0;i=d;return g|0}else{if(!b){RI(2819928)|0;Evh(2819928)}RI(2819928)|0;f=(c[705005]|0)+4|0;g=c[f>>2]|0;i=d;return g|0}return 0}function fYf(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(_Xf(0)|0);return 0}function gYf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!(c[(c[b+24>>2]|0)+56>>2]|0)){f=_Xf(0)|0;Bvh(f)}if(!(VXf(b)|0)){f=_Xf(0)|0;Bvh(f)}RI(3090792)|0;if(a[3090940]|0){g=jtg(0,b,d)|0;i=e;return g|0}RI(3090792)|0;Evh(3090792);g=jtg(0,b,d)|0;i=e;return g|0}function hYf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if(!(c[(c[b+24>>2]|0)+56>>2]|0)){g=_Xf(0)|0;Bvh(g)}if(!(VXf(b)|0)){g=_Xf(0)|0;Bvh(g)}RI(3090792)|0;if(a[3090940]|0){h=gtg(0,b,d,e)|0;i=f;return h|0}RI(3090792)|0;Evh(3090792);h=gtg(0,b,d,e)|0;i=f;return h|0}function iYf(a){a=a|0;var b=0,c=0;b=i;c=zHf(a)|0;i=b;return c|0}function jYf(b){b=b|0;var d=0,e=0;d=i;Ojh();e=Fqh(2820096,c[b+24>>2]|0)|0;if(!(a[2540708]|0))Evh(2540560);b=iwf(0,c[891644]|0,e,c[891646]|0)|0;i=d;return b|0}function kYf(a){a=a|0;return c[a+12>>2]|0}function lYf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2914768)|0;c[a+8>>2]=ML(c[728708]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function mYf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function nYf(a){a=a|0;var b=0,d=0;b=i;d=rth(2822656,c[a+12>>2]|0)|0;i=b;return d|0}function oYf(a){a=a|0;var b=0,d=0;b=i;d=Fqh(2822712,c[a+12>>2]|0)|0;i=b;return d|0}function pYf(a){a=a|0;var b=0,d=0;b=i;d=suh(2822768,c[a+12>>2]|0)|0;i=b;return d|0}function qYf(a){a=a|0;var b=0,d=0;b=i;d=suh(2822824,c[a+12>>2]|0)|0;i=b;return d|0}function rYf(a){a=a|0;var b=0,d=0;b=i;d=Fqh(2822880,c[a+12>>2]|0)|0;i=b;return d|0}function sYf(a){a=a|0;var b=0,d=0;b=i;d=dvh(2820152,c[a+12>>2]|0)|0;i=b;return d|0}function tYf(a){a=a|0;var b=0,d=0;b=i;d=Fqh(2820096,c[a+12>>2]|0)|0;i=b;return d|0}function uYf(a){a=a|0;var b=0,d=0;b=i;d=Fqh(2822936,c[a+12>>2]|0)|0;i=b;return d|0}function vYf(a){a=a|0;var b=0,d=0;b=i;d=suh(2822992,c[a+12>>2]|0)|0;i=b;return d|0}function wYf(a){a=a|0;var b=0,d=0;b=i;d=_uh(2823048,c[a+12>>2]|0)|0;i=b;return d|0}function xYf(a){a=a|0;return c[a+16>>2]|0}function yYf(a){a=a|0;return c[(c[a+12>>2]|0)+44>>2]|0}function zYf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=bvh(2651672,c[a+12>>2]|0,b,d,e,f,g)|0;i=h;return j|0}function AYf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Kvh(2823104,c[a+12>>2]|0,b)|0;i=d;return e|0}function BYf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Lvh(2823160,c[a+12>>2]|0,b)|0;i=d;return e|0}function CYf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=tuh(2823216,c[a+12>>2]|0,b,d)|0;i=e;return f|0}function DYf(a){a=a|0;var b=0,d=0;b=i;d=suh(2823272,c[a+12>>2]|0)|0;i=b;return d|0}function EYf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Mvh(2823328,c[a+12>>2]|0,b,d)|0;i=e;return f|0}function FYf(a){a=a|0;var b=0,d=0;b=i;d=cvh(2823384,c[a+12>>2]|0)|0;i=b;return d|0}function GYf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;k=c[a+12>>2]|0;if(!g){l=Nvh(2655432,k,b,d)|0;i=j;return l|0}else{l=$uh(2651456,k,b,d,e,f,g,h)|0;i=j;return l|0}return 0}function HYf(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Ovh(2823440,c[a+12>>2]|0,b)|0;i=d;return e|0}function IYf(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bvh(JYf(0)|0);return 0}function JYf(a){a=a|0;var b=0;a=i;Rjh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[891714]|0);i=a;return b|0}function KYf(a){a=a|0;var b=0,d=0;b=i;d=Gqh(2652984,c[a+12>>2]|0)|0;i=b;return d|0}function LYf(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;m=wuh(2823496,c[a+12>>2]|0,b,d,e,f,g,h,j,k)|0;i=l;return m|0}function MYf(a){a=a|0;return 0}function NYf(a){a=a|0;return 0}function OYf(a){a=a|0;return 0}function PYf(a){a=a|0;return 0}function QYf(a){a=a|0;return 1}function RYf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Cuh(2823552,c[a+12>>2]|0,b,d)|0;i=e;return f|0}function SYf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2915272)|0;c[a+8>>2]=ML(c[728834]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function TYf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function UYf(a){a=a|0;return c[a+8>>2]|0}function VYf(a){a=a|0;return c[a+16>>2]|0}function WYf(a){a=a|0;return c[a+12>>2]|0}function XYf(a){a=a|0;return c[a+16>>2]|0}function YYf(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!(c[(c[b+16>>2]|0)+56>>2]|0))Bvh(ZYf(0)|0);RI(3090792)|0;if(a[3090940]|0){f=jtg(0,b,d)|0;i=e;return f|0}RI(3090792)|0;Evh(3090792);f=jtg(0,b,d)|0;i=e;return f|0}function ZYf(a){a=a|0;var b=0;a=i;Sjh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[891718]|0);i=a;return b|0}function _Yf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!(c[(c[b+16>>2]|0)+56>>2]|0))Bvh(ZYf(0)|0);RI(3090792)|0;if(a[3090940]|0){g=gtg(0,b,d,e)|0;i=f;return g|0}RI(3090792)|0;Evh(3090792);g=gtg(0,b,d,e)|0;i=f;return g|0}function $Yf(a,b){a=a|0;b=b|0;Bvh(ZYf(0)|0);return 0}function aZf(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(ZYf(0)|0);return 0}function bZf(a){a=a|0;return 0}function cZf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bvh(ZYf(0)|0)}function dZf(a){a=a|0;return c[a+20>>2]|0}function eZf(a){a=a|0;var b=0,c=0;b=i;c=zHf(a)|0;i=b;return c|0}function fZf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2915768)|0;c[a+8>>2]=ML(c[728958]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function gZf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=dvh(2820152,c[b+12>>2]|0)|0;RI(2820208)|0;if(!(a[(c[(Jvh(f,2820208)|0)+36>>2]|0)+60>>0]|0))Bvh(hZf(0)|0);if(!(suh(2828344,b)|0)){g=0;i=e;return g|0}if((suh(2828344,b)|0)==(d|0)){g=1;i=e;return g|0}g=Yuh(2650256,suh(2828344,b)|0,d)|0;i=e;return g|0}function hZf(a){a=a|0;var b=0;a=i;RI(3100472)|0;b=qL(3100472)|0;oug(b);i=a;return b|0}function iZf(b){b=b|0;var d=0,e=0;d=i;e=dvh(2820152,c[b+12>>2]|0)|0;RI(2820208)|0;if(!(a[(c[(Jvh(e,2820208)|0)+36>>2]|0)+60>>0]|0))Bvh(hZf(0)|0);else{i=d;return 1}return 0}function jZf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bvh(hZf(0)|0);return 0}function kZf(a,b){a=a|0;b=b|0;Bvh(hZf(0)|0);return 0}function lZf(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(hZf(0)|0);return 0}function mZf(a){a=a|0;Bvh(hZf(0)|0);return 0}function nZf(a,b){a=a|0;b=b|0;Bvh(hZf(0)|0);return 0}function oZf(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bvh(hZf(0)|0);return 0}function pZf(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bvh(hZf(0)|0);return 0}function qZf(a){a=a|0;return 0}function rZf(a,b){a=a|0;b=b|0;Bvh(hZf(0)|0);return 0}function sZf(a,b){a=a|0;b=b|0;Bvh(hZf(0)|0);return 0}function tZf(a){a=a|0;return 0}function uZf(a){a=a|0;return 0}function vZf(a){a=a|0;return 0}function wZf(a){a=a|0;return 0}function xZf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if(!d)e=0;else e=Gqh(2650144,d)|0;i=b;return e|0}function yZf(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Bvh(hZf(0)|0);return 0}function zZf(a){a=a|0;Bvh(hZf(0)|0);return 0}function AZf(a){a=a|0;return a|0}function BZf(a){a=a|0;var b=0,d=0;b=i;d=rth(2822656,c[a+12>>2]|0)|0;i=b;return d|0}function CZf(a){a=a|0;return 0}function DZf(a){a=a|0;return c[a+24>>2]|0}function EZf(a){a=a|0;return 0}function FZf(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(hZf(0)|0);return 0}function GZf(a,b){a=a|0;b=b|0;Bvh(hZf(0)|0);return 0}function HZf(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(hZf(0)|0);return 0}function IZf(a){a=a|0;return c[a+20>>2]|0}function JZf(a){a=a|0;return 0}function KZf(a){a=a|0;var b=0,d=0;b=i;d=dvh(2820152,c[a+12>>2]|0)|0;i=b;return d|0}function LZf(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+16>>2]|0;if(!d){e=c[a+12>>2]|0;i=b;return e|0}else{e=suh(2828400,d)|0;i=b;return e|0}return 0}function MZf(a){a=a|0;var b=0,c=0;b=i;c=suh(2828456,a)|0;i=b;return c|0}function NZf(a){a=a|0;Bvh(hZf(0)|0);return 0}function OZf(a){a=a|0;RI(3084976)|0;a=qL(3084976)|0;nsg(a);Bvh(a);return 0}function PZf(a){a=a|0;RI(3084976)|0;a=qL(3084976)|0;nsg(a);Bvh(a);return 0}function QZf(a){a=a|0;return 1}function RZf(a){a=a|0;return 1}function SZf(a){a=a|0;return 0}function TZf(a){a=a|0;return 0}function UZf(a){a=a|0;return c[a+20>>2]|0}function VZf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=HGf(a,b)|0;i=c;return d|0}function WZf(a){a=a|0;var b=0,c=0;b=i;c=VGf(a)|0;i=b;return c|0}function XZf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pHf(a,b)|0;i=c;return d|0}function YZf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ZZf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _Zf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function $Zf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function a_f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function b_f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function c_f(a){a=a|0;RI(3100472)|0;a=qL(3100472)|0;oug(a);Bvh(a);return 0}function d_f(a){a=a|0;Bvh(e_f(0)|0);return 0}function e_f(a){a=a|0;var b=0;a=i;Ujh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[891738]|0);i=a;return b|0}function f_f(a){a=a|0;return c[a+8>>2]|0}function g_f(a){a=a|0;return c[a+28>>2]|0}function h_f(a){a=a|0;return c[a+28>>2]|0}function i_f(a){a=a|0;return c[a+24>>2]|0}function j_f(a){a=a|0;return c[a+16>>2]|0}function k_f(a){a=a|0;return c[a+36>>2]|0}function l_f(a){a=a|0;return a|0}function m_f(a){a=a|0;return c[a+20>>2]|0}function n_f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;if(!(c[(c[a+28>>2]|0)+56>>2]|0))Bvh(e_f(0)|0);d=a+12|0;e=c[d>>2]|0;if(!e){f=0;i=b;return f|0}RI(1137488)|0;g=Cvh(1137488,c[e+12>>2]|0)|0;e=c[d>>2]|0;if((c[e+12>>2]|0)<=0){f=g;i=b;return f|0}h=a+32|0;j=g+16|0;k=e;e=0;do{l=c[h>>2]|0;m=e;e=e+1|0;if(!l)n=0;else n=c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,e)|0)>>2]|0;RI(2819760)|0;l=qL(2819760)|0;YXf(l,n,c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,m)|0)>>2]|0,a,e);Qqh(g,l);c[j+(da(c[(c[g>>2]|0)+120>>2]|0,m)|0)>>2]=l;k=c[d>>2]|0}while((e|0)<(c[k+12>>2]|0));f=g;i=b;return f|0}function o_f(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bvh(e_f(0)|0);return 0}function p_f(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(e_f(0)|0);return 0}function q_f(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!(c[(c[b+28>>2]|0)+56>>2]|0))Bvh(e_f(0)|0);RI(3090792)|0;if(a[3090940]|0){f=jtg(0,b,d)|0;i=e;return f|0}RI(3090792)|0;Evh(3090792);f=jtg(0,b,d)|0;i=e;return f|0}function r_f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if(!(c[(c[b+28>>2]|0)+56>>2]|0))Bvh(e_f(0)|0);RI(3090792)|0;if(a[3090940]|0){g=gtg(0,b,d,e)|0;i=f;return g|0}RI(3090792)|0;Evh(3090792);g=gtg(0,b,d,e)|0;i=f;return g|0}function s_f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;Tjh();RI(1094176)|0;e=Cvh(1094176,5)|0;Qqh(e,c[891722]|0);f=e+16|0;c[f>>2]=c[891722];g=Fqh(2820096,c[b+28>>2]|0)|0;Qqh(e,g);c[f+(c[(c[e>>2]|0)+120>>2]|0)>>2]=g;Qqh(e,c[891724]|0);c[f+(c[(c[e>>2]|0)+120>>2]<<1)>>2]=c[891724];g=c[b+24>>2]|0;Qqh(e,g);c[f+((c[(c[e>>2]|0)+120>>2]|0)*3|0)>>2]=g;Qqh(e,c[891726]|0);c[f+(c[(c[e>>2]|0)+120>>2]<<2)>>2]=c[891726];if(a[2540708]|0){h=lwf(0,e)|0;i=d;return h|0}Evh(2540560);h=lwf(0,e)|0;i=d;return h|0}function t_f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Snf(a,b)|0;i=c;return d|0}function u_f(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2582544,c[a+24>>2]|0)|0;i=b;return d|0}function v_f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[708138]|0;if(!e){f=MK(2832560)|0;c[708138]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function w_f(a){a=a|0;return (c[a+40>>2]|0)!=0|0}function x_f(a){a=a|0;return (c[a+40>>2]|0)!=0|0}function y_f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=b+40|0;b=c[e>>2]|0;if(!b){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}RI(2540728)|0;f=c[(c[635205]|0)+8>>2]|0;i=d;return f|0}RI(1104624)|0;g=Cvh(1104624,c[b+12>>2]|0)|0;b=c[e>>2]|0;if((c[b+12>>2]|0)<=0){f=g;i=d;return f|0}h=g+16|0;j=b;b=0;do{k=j+16|0;Qqh(g,c[k+(da(c[(c[j>>2]|0)+120>>2]|0,b)|0)>>2]|0);l=c[k+(da(c[(c[j>>2]|0)+120>>2]|0,b)|0)>>2]|0;c[h+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=l;b=b+1|0;j=c[e>>2]|0}while((b|0)<(c[j+12>>2]|0));f=g;i=d;return f|0}function z_f(a){a=a|0;var b=0,c=0;b=i;c=zHf(a)|0;i=b;return c|0}function A_f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2916512)|0;c[a+8>>2]=ML(c[729144]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function B_f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function C_f(a){a=a|0;var d=0,e=0;a=i;RI(1136088)|0;d=Cvh(1136088,3)|0;e=d+16|0;b[e>>1]=38;b[e+(c[(c[d>>2]|0)+120>>2]|0)>>1]=91;b[e+(c[(c[d>>2]|0)+120>>2]<<1)>>1]=42;RI(2820208)|0;c[c[705075]>>2]=d;i=a;return}function D_f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2917248)|0;c[a+8>>2]=ML(c[729328]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function E_f(a){a=a|0;return c[a+12>>2]|0}function F_f(a){a=a|0;return c[a+8>>2]|0}function G_f(a){a=a|0;return c[a+16>>2]|0}function H_f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2917504)|0;c[a+8>>2]=ML(c[729392]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function I_f(a){a=a|0;return c[a+44>>2]|0}function J_f(a){a=a|0;return c[(c[a+48>>2]|0)+12>>2]|0}function K_f(b){b=b|0;var d=0,e=0,f=0;d=i;Vjh();e=c[b+60>>2]|0;f=Fqh(2836288,rth(2822656,b)|0)|0;if(!(a[2540708]|0))Evh(2540560);b=iwf(0,e,c[891742]|0,f)|0;i=d;return b|0}function L_f(a){a=a|0;return c[a+20>>2]|0}function M_f(a){a=a|0;return c[a+24>>2]|0}function N_f(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;Wjh();e=c[b+56>>2]|0;if(e){f=suh(2619440,e)|0;i=d;return f|0}if(Gqh(2611112,b)|0?(a[(c[(c[b+48>>2]|0)+36>>2]|0)+60>>0]|0)==0:0){e=c[b+64>>2]|0;if(!e){RI(3084976)|0;g=qL(3084976)|0;osg(g,c[891746]|0);Bvh(g)}else{f=e;i=d;return f|0}}f=b;i=d;return f|0}function O_f(b){b=b|0;return (a[(c[(c[b+48>>2]|0)+36>>2]|0)+60>>0]|0)!=0|0}function P_f(a){a=a|0;return c[a+60>>2]|0}function Q_f(a){a=a|0;return c[a+48>>2]|0}function R_f(a){a=a|0;return c[a+12>>2]|0}function S_f(a){a=a|0;return c[a+16>>2]|0}function T_f(a){a=a|0;return c[a+24>>2]|0}function U_f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j+4|0;l=j;V_f(b);m=b+56|0;n=c[m>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[l>>2]=3432408;c[k+0>>2]=c[l+0>>2];if((n|0)!=(npf(0,k)|0)){o=bvh(2651672,c[m>>2]|0,d,e,f,g,h)|0;i=j;return o|0}m=b+36|0;b=c[m>>2]|0;if(!b){o=0;i=j;return o|0}k=b+12|0;if((c[k>>2]|0)<=0){o=0;i=j;return o|0}n=b+16|0;l=(f|0)==3;p=0;q=0;r=0;while(1){s=c[n+(da(c[(c[b>>2]|0)+120>>2]|0,r)|0)>>2]|0;if(!l?(Aqh(2820768,s)|0)!=(f|0):0){t=p;u=q}else{t=s;u=q+1|0}r=r+1|0;if((r|0)>=(c[k>>2]|0)){v=t;w=u;break}else{p=t;q=u}}if(!w){o=0;i=j;return o|0}if(!g){if((w|0)>=2){RI(2836344)|0;u=qL(2836344)|0;W_f(u);Bvh(u)}o=v;i=j;return o|0}RI(1177072)|0;u=Cvh(1177072,w)|0;if((w|0)!=1){w=c[m>>2]|0;m=w+12|0;if((c[m>>2]|0)>0){q=w+16|0;t=(f|0)==3;p=u+16|0;k=0;r=0;while(1){l=c[q+(da(c[(c[w>>2]|0)+120>>2]|0,r)|0)>>2]|0;if(!t?(Aqh(2836512,l)|0)!=(f|0):0)x=k;else{Qqh(u,l);c[p+(da(c[(c[u>>2]|0)+120>>2]|0,k)|0)>>2]=l;x=k+1|0}r=r+1|0;if((r|0)>=(c[m>>2]|0))break;else k=x}}}else{Qqh(u,v);c[u+16>>2]=v}if(!e){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}y=X_f(0)|0}else y=e;e=Pvh(2836736,y,d,u,g,h)|0;RI(2819928)|0;o=Jvh(e,2819928)|0;i=j;return o|0}function V_f(a){a=a|0;var b=0;b=i;if(!(c[a+56>>2]|0))Bvh(j$f(0)|0);else{i=b;return}}function W_f(a){a=a|0;var b=0;b=i;Zjh();Grg(a,c[891784]|0);i=b;return}function X_f(b){b=b|0;b=i;RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}RI(2836568)|0;i=b;return c[c[709165]>>2]|0}function Y_f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if((c[b+56>>2]|0)==0?(a[(c[(c[b+48>>2]|0)+36>>2]|0)+60>>0]|0)==0:0){RI(3100472)|0;g=qL(3100472)|0;oug(g);Bvh(g)}RI(3090792)|0;if(a[3090940]|0){h=ktg(0,b,d,e)|0;i=f;return h|0}RI(3090792)|0;Evh(3090792);h=ktg(0,b,d,e)|0;i=f;return h|0}function Z_f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;V_f(a);e=Lvh(2658864,c[a+56>>2]|0,b)|0;i=d;return e|0}function __f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;V_f(a);f=tuh(2658944,c[a+56>>2]|0,b,d)|0;i=e;return f|0}function $_f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+56>>2]|0;if(f){g=Kvh(2656576,f,d)|0;i=e;return g|0}if(!(a[(c[(c[b+48>>2]|0)+36>>2]|0)+60>>0]|0)){RI(3100472)|0;f=qL(3100472)|0;oug(f);Bvh(f)}g=a$f(b,d)|0;i=e;return g|0}function a$f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+36|0;if(!(c[f>>2]|0)){RI(1178128)|0;g=Cvh(1178128,0)|0;i=e;return g|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;Evh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);h=c[f>>2]|0;f=h+12|0;if((c[f>>2]|0)>0){j=h+16|0;k=0;do{l=c[j+(da(c[(c[h>>2]|0)+120>>2]|0,k)|0)>>2]|0;m=Aqh(2821456,l)|0;if((((m&7|0)==6?16:32)&d|0)!=0?((m>>>2&4)+4&d|0)!=0:0)Erh(2714056,b,l)|0;k=k+1|0}while((k|0)<(c[f>>2]|0));n=b}else n=b;b=Aqh(2713056,n)|0;RI(1178128)|0;f=Cvh(1178128,b)|0;zth(2714616,n,f);g=f;i=e;return g|0}function b$f(a){a=a|0;RI(3100472)|0;a=qL(3100472)|0;oug(a);Bvh(a);return 0}function c$f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[b+56>>2]|0;if(g){h=Mvh(2655280,g,d,e)|0;i=f;return h|0}g=c[b+40>>2]|0;if(!g){h=0;i=f;return h|0}b=g+12|0;if((c[b>>2]|0)<=0){h=0;i=f;return h|0}j=g+16|0;k=0;while(1){l=c[j+(da(c[(c[g>>2]|0)+120>>2]|0,k)|0)>>2]|0;if(l){m=Fqh(2649752,l)|0;if(!(a[2540708]|0))Evh(2540560);if((!(Iwf(0,m,d)|0)?(m=Aqh(2836792,l)|0,(((m&7|0)==6?16:32)&e|0)!=0):0)?((m>>>2&4)+4&e|0)!=0:0){n=l;break}}k=k+1|0;if((k|0)>=(c[b>>2]|0)){h=0;o=14;break}}if((o|0)==14){i=f;return h|0}h=n;i=f;return h|0}function d$f(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+56>>2]|0;if(e){f=cvh(2655112,e)|0;i=d;return f|0}e=b+28|0;b=c[e>>2]|0;if(b){RI(1104624)|0;g=Cvh(1104624,c[b+12>>2]|0)|0;Csh(262e4,c[e>>2]|0,g,0);f=g;i=d;return f|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}RI(2540728)|0;f=c[(c[635205]|0)+8>>2]|0;i=d;return f|0}function e$f(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;do if((e&2|0)==0?(h=c[b+20>>2]|0,(h|0)!=0):0){j=Ovh(2655768,h,e)|0;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;Evh(2713640)}RI(2713640)|0;h=qL(2713640)|0;k=j+12|0;ZMf(h,c[k>>2]|0);if((c[k>>2]|0)>0){l=j+16|0;m=(e&64|0)!=0;n=(e&32|0)==0;o=(e&16|0)==0;p=0;do{q=c[l+(da(c[(c[j>>2]|0)+120>>2]|0,p)|0)>>2]|0;r=Aqh(2836848,q)|0;do if(m|(Gqh(2836904,q)|0)^1){s=r&7;if((s|0)==1)break;else if((s|0)==3){if(n)break}else if((s|0)==6){if(o)break}else if(n)break;Erh(2714056,h,q)|0}while(0);p=p+1|0}while((p|0)<(c[k>>2]|0));t=h}else t=h;k=b+32|0;p=c[k>>2]|0;n=Aqh(2713056,t)|0;RI(1176e3)|0;if(!p){o=Cvh(1176e3,n)|0;zth(2714616,t,o);u=o;break}else{o=Cvh(1176e3,(c[p+12>>2]|0)+n|0)|0;Csh(2714672,t,o,0);n=c[k>>2]|0;Csh(262e4,n,o,Aqh(2713056,t)|0);u=o;break}}else v=18;while(0);if((v|0)==18)u=c[b+32>>2]|0;if(!u){RI(1176e3)|0;w=Cvh(1176e3,0)|0;i=g;return w|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;Evh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);v=u+12|0;if((c[v>>2]|0)>0){t=u+16|0;o=(d|0)==0;n=0;do{k=c[t+(da(c[(c[u>>2]|0)+120>>2]|0,n)|0)>>2]|0;do if(k){if(!o){p=Fqh(2649752,k)|0;if(!(a[2540708]|0))Evh(2540560);if(pvf(0,p,d,f)|0)break}p=Aqh(2836848,k)|0;if((((p&7|0)==6?16:32)&e|0)!=0?((p>>>2&4)+4&e|0)!=0:0)Erh(2714056,b,k)|0}while(0);n=n+1|0}while((n|0)<(c[v>>2]|0));x=b}else x=b;b=Aqh(2713056,x)|0;RI(1176e3)|0;v=Cvh(1176e3,b)|0;zth(2714616,x,v);w=v;i=g;return w|0}function f$f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=e$f(a,0,b,0,0)|0;i=c;return d|0}function g$f(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;V_f(b);l=e$f(b,d,e,(e&1|0)!=0,0)|0;d=(h|0)!=0;if(d)m=c[h+12>>2]|0;else m=0;b=l+12|0;if((c[b>>2]|0)<=0){n=0;i=k;return n|0}o=l+16|0;p=(g|0)==3;q=0;r=0;s=0;while(1){t=c[o+(da(c[(c[l>>2]|0)+120>>2]|0,s)|0)>>2]|0;if(!p?((Aqh(2836512,t)|0)&g|0)!=(g|0):0){u=q;v=r}else{u=t;v=r+1|0}s=s+1|0;if((s|0)>=(c[b>>2]|0)){w=u;x=v;break}else{q=u;r=v}}if(!x){n=0;i=k;return n|0}v=(x|0)!=1;if(!(v|(m|0)!=0)){n=w;i=k;return n|0}RI(1177072)|0;m=Cvh(1177072,x)|0;if(v){if((c[b>>2]|0)>0){v=l+16|0;x=(g|0)==3;r=m+16|0;u=0;q=0;while(1){s=c[v+(da(c[(c[l>>2]|0)+120>>2]|0,u)|0)>>2]|0;if(!x?((Aqh(2836512,s)|0)&g|0)!=(g|0):0)y=q;else{Qqh(m,s);c[r+(da(c[(c[m>>2]|0)+120>>2]|0,q)|0)>>2]=s;y=q+1|0}u=u+1|0;if((u|0)>=(c[b>>2]|0))break;else q=y}}}else{Qqh(m,w);c[m+16>>2]=w}if(!d){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}d=h$f(0,m)|0;RI(2834864)|0;n=Jvh(d,2834864)|0;i=k;return n|0}if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}z=X_f(0)|0}else z=f;f=Pvh(2836736,z,e,m,h,j)|0;RI(2834864)|0;n=Jvh(f,2834864)|0;i=k;return n|0}function h$f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;e=c[d+12>>2]|0;f=d+16|0;g=c[(c[d>>2]|0)+120>>2]|0;if((e|0)>0){h=g;j=0;k=-1;l=0}else{m=g;n=-1;o=da(m,n)|0;p=f+o|0;q=c[p>>2]|0;i=b;return q|0}a:while(1){g=c[f+(da(h,l)|0)>>2]|0;r=suh(2658656,g)|0;RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}s=N0f(0,r)|0;if((s|0)==(j|0)){t=4;break}if((k|0)>=0){r=xuh(2849384,g)|0;g=xuh(2849384,c[f+(da(c[(c[d>>2]|0)+120>>2]|0,k)|0)>>2]|0)|0;u=r+12|0;v=c[u>>2]|0;if((v|0)!=(c[g+12>>2]|0)){t=11;break}if((v|0)>0){v=r+16|0;w=g+16|0;x=0;do{y=suh(2849496,c[v+(da(c[(c[r>>2]|0)+120>>2]|0,x)|0)>>2]|0)|0;if((y|0)!=(suh(2849496,c[w+(da(c[(c[g>>2]|0)+120>>2]|0,x)|0)>>2]|0)|0)){t=11;break a}x=x+1|0}while((x|0)<(c[u>>2]|0))}}u=(s|0)>(j|0);x=u?l:k;l=l+1|0;g=c[(c[d>>2]|0)+120>>2]|0;if((l|0)>=(e|0)){m=g;n=x;t=14;break}else{h=g;j=u?s:j;k=x}}if((t|0)==4){RI(2836344)|0;k=qL(2836344)|0;W_f(k);Bvh(k)}else if((t|0)==11){RI(2836344)|0;k=qL(2836344)|0;W_f(k);Bvh(k)}else if((t|0)==14){o=da(m,n)|0;p=f+o|0;q=c[p>>2]|0;i=b;return q|0}return 0}function i$f(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bvh(j$f(0)|0);return 0}function j$f(a){a=a|0;var b=0;a=i;Xjh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[891766]|0);i=a;return b|0}function k$f(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+56>>2]|0;if(!d){e=0;i=b;return e|0}e=Gqh(2652984,d)|0;i=b;return e|0}function l$f(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;V_f(a);m=wuh(2656728,c[a+56>>2]|0,b,d,e,f,g,h,j,k)|0;i=l;return m|0}function m$f(a){a=a|0;return 0}function n$f(a){a=a|0;return 0}function o$f(a){a=a|0;return 0}function p$f(a){a=a|0;return 0}function q$f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+48|0;h=c[(c[(c[g>>2]|0)+36>>2]|0)+48>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}if(!(QGf(0,b,h,0)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[f>>2]=3439888;c[e+0>>2]=c[f+0>>2];if(!(QGf(0,b,npf(0,e)|0,0)|0)){j=0;i=d;return j|0}}e=c[(c[g>>2]|0)+36>>2]|0;if((b|0)==(c[e+48>>2]|0)){j=0;i=d;return j|0}j=(b|0)!=(c[e+52>>2]|0);i=d;return j|0}function r$f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pHf(a,b)|0;i=c;return d|0}function s$f(a){a=a|0;var b=0,d=0;b=i;V_f(a);d=_uh(2650968,c[a+56>>2]|0)|0;i=b;return d|0}function t$f(a){a=a|0;var b=0,c=0;b=i;c=Fqh(2822880,a)|0;i=b;return c|0}function u$f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=TGf(a,b)|0;i=c;return d|0}function v$f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SGf(a,b)|0;i=c;return d|0}function w$f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e+4|0;g=e;if((b|0)==(d|0)){h=1;i=e;return h|0}j=b+20|0;if(Gqh(2650088,d)|0){k=c[j>>2]|0;if(((k|0)!=0?(c[b+56>>2]|0)!=0:0)?Yuh(2651232,d,k)|0:0){h=1;i=e;return h|0}k=c[b+28>>2]|0;if(!k){h=0;i=e;return h|0}l=k+12|0;a:do if((c[l>>2]|0)>0){m=k+16|0;n=0;while(1){if(Yuh(2651232,d,c[m+(da(c[(c[k>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0){h=1;break}n=n+1|0;if((n|0)>=(c[l>>2]|0))break a}i=e;return h|0}while(0);if(!(c[b+56>>2]|0)){h=0;i=e;return h|0}}b=c[j>>2]|0;if(b){h=Yuh(2651232,d,b)|0;i=e;return h|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[g>>2]=3432408;c[f+0>>2]=c[g+0>>2];h=(npf(0,f)|0)==(d|0);i=e;return h|0}function x$f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+52|0;a=c[d>>2]|0;if(!a){e=0;i=b;return e|0}RI(1104624)|0;f=Cvh(1104624,c[a+12>>2]|0)|0;Csh(262e4,c[d>>2]|0,f,0);e=f;i=b;return e|0}function y$f(a){a=a|0;var b=0,d=0;b=i;Yjh();if(!(c[a+52>>2]|0)){RI(3084976)|0;d=qL(3084976)|0;osg(d,c[891770]|0);Bvh(d)}else{i=b;return a|0}return 0}function z$f(a){a=a|0;return (c[a+52>>2]|0)!=0|0}function A$f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[709240]|0;if(!d){e=MK(2836968)|0;c[709240]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function B$f(a){a=a|0;return (c[a+52>>2]|0)!=0|0}function C$f(a){a=a|0;var b=0,c=0;b=i;c=Gqh(2837032,a)|0;i=b;return c|0}function D$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2918488)|0;c[a+8>>2]=ML(c[729638]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function E$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function F$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function G$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function H$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function I$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2839928)|0);c[c[d>>2]>>2]=a;i=b;return}function J$f(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;e=c[a+12>>2]|0;RI(2664840)|0;f=qL(2664840)|0;pIf(f,e);c[f+12>>2]=c[a+16>>2];c[f+16>>2]=c[a+20>>2];c[f+20>>2]=c[a+24>>2];c[f+24>>2]=c[a+28>>2];e=c[a+8>>2]|0;if((e|0)==-1)g=0;else g=e;c[f+28>>2]=g;g=c[a+32>>2]|0;if((g|0)==-1){b[f+32>>1]=0;i=d;return f|0}else{b[f+32>>1]=g;i=d;return f|0}return 0}function K$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2841136)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function L$f(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function M$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function N$f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[710458]|0;if(!d){e=MK(2841840)|0;c[710458]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function O$f(a){a=a|0;var b=0,c=0;b=i;c=Fqh(2841888,a)|0;i=b;return c|0}function P$f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function Q$f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function R$f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[710486]|0;if(!g){h=MK(2841952)|0;c[710486]=h;j=h}else j=g;g=kn[j&511](a,b,d,e)|0;i=f;return g|0}function S$f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Qvh(2842064,a,b,0,0)|0;i=c;return d|0}function T$f(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=c[710530]|0;if(!h){j=MK(2842128)|0;c[710530]=j;k=j}else k=h;h=Bn[k&255](a,b,d,e,f)|0;i=g;return h|0}function U$f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;_jh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,0);Bvh(g)}if(!(Vof(b)|0)){RI(2965048)|0;g=qL(2965048)|0;Rag(g,c[891808]|0,c[891810]|0);Bvh(g)}else{g=T$f(a,0,b,d,e)|0;i=f;return g|0}return 0}function V$f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[710562]|0;if(!e){f=MK(2842256)|0;c[710562]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function W$f(a){a=a|0;c[a+40>>2]=1;return}function X$f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+44|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=N$f(a)|0;c[d>>2]=e;f=e;i=b;return f|0}function Y$f(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[710630]|0;if(!b){d=MK(2842528)|0;c[710630]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function Z$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819224)|0;RI(2914008)|0;c[a+8>>2]=ML(c[728518]|0)|0;c[c[d>>2]>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function _$f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function $$f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function a0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function b0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function c0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function d0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function e0f(b,c){b=b|0;c=c|0;a[b+8>>0]=c&1;return}function f0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function g0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function h0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function i0f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;$jh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[891824]|0);Bvh(e)}else{c[a+8>>2]=b;i=d;return}}function j0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function k0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function l0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function m0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function n0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function o0f(a){a=a|0;return c[a+8>>2]|0}function p0f(a){a=a|0;return c[a+44>>2]|0}function q0f(a){a=a|0;akh();Onf(0,a,c[891828]|0)|0;return 0}function r0f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;bkh();if(!b){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[891862]|0);Bvh(j)}L7f(b,c[891864]|0,c[a+8>>2]|0);L7f(b,c[891866]|0,c[a+32>>2]|0);L7f(b,c[891868]|0,c[a+36>>2]|0);j=c[a+16>>2]|0;k=c[891870]|0;if(!j)l=-1;else l=Aqh(2686456,j)|0;r9f(b,k,l);L7f(b,c[891872]|0,c[a+12>>2]|0);L7f(b,c[891874]|0,c[a+44>>2]|0);c[e>>2]=c[a+24>>2];RI(2741840)|0;l=pL(2741840,e)|0;L7f(b,c[891876]|0,l);c[f>>2]=0;RI(2741840)|0;l=pL(2741840,f)|0;L7f(b,c[891878]|0,l);L7f(b,c[891880]|0,c[a+28>>2]|0);c[g>>2]=c[a+40>>2];RI(2742360)|0;l=pL(2742360,g)|0;L7f(b,c[891882]|0,l);c[h>>2]=c[a+20>>2];RI(2846960)|0;a=pL(2846960,h)|0;L7f(b,c[891884]|0,a);L7f(b,c[891886]|0,0);i=d;return}function s0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819224)|0;RI(2914512)|0;c[a+8>>2]=ML(c[728644]|0)|0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function t0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function u0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function v0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function w0f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function x0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function y0f(a){a=a|0;return}function z0f(a){a=a|0;return}function A0f(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;if(c[f>>2]|0){RI(1104624)|0;g=Cvh(1104624,c[(c[f>>2]|0)+12>>2]|0)|0;l=c[f>>2]|0;if((c[l+12>>2]|0)>0){m=g+16|0;n=l;l=0;while(1){o=c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,l)|0)>>2]|0;if(!o)p=n;else{q=Xnf(o)|0;Qqh(g,q);c[m+(da(c[(c[g>>2]|0)+120>>2]|0,l)|0)>>2]=q;p=c[f>>2]|0}l=l+1|0;if((l|0)>=(c[p+12>>2]|0)){r=g;break}else n=p}}else r=g}else{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}RI(2540728)|0;r=c[(c[635205]|0)+8>>2]|0}g=B0f(b,d,e,r,0,1)|0;c[k>>2]=0;if(!j){i=h;return g|0}C0f(0,j,f,g);i=h;return g|0}function B0f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+16|0;j=g+4|0;k=g;ckh();if(!e){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[891978]|0);Bvh(l)}l=e+12|0;m=c[l>>2]|0;a:do if((m|0)>0){n=e+16|0;o=f+12|0;p=f+16|0;q=0;while(1){r=c[n+(da(c[(c[e>>2]|0)+120>>2]|0,q)|0)>>2]|0;s=xuh(2849384,r)|0;t=c[s+12>>2]|0;if((t|0)==(c[o>>2]|0)){b:do if((t|0)>0){u=s+16|0;v=0;while(1){w=suh(2849496,c[u+(da(c[(c[s>>2]|0)+120>>2]|0,v)|0)>>2]|0)|0;x=(c[p+(da(c[(c[f>>2]|0)+120>>2]|0,v)|0)>>2]|0)==(w|0);w=v+1|0;y=c[o>>2]|0;if(!x){z=y;A=v;break b}if((w|0)<(y|0))v=w;else{z=y;A=w;break}}}else{z=t;A=0}while(0);if((A|0)==(z|0)){B=r;C=35;break}}q=q+1|0;t=c[l>>2]|0;if((q|0)>=(t|0)){D=t;break}}if((C|0)==35){i=g;return B|0}if((D|0)>0){q=e+16|0;o=f+12|0;p=f+16|0;n=0;while(1){t=c[q+(da(c[(c[e>>2]|0)+120>>2]|0,n)|0)>>2]|0;s=xuh(2849384,t)|0;v=s+12|0;u=c[v>>2]|0;if(!((u|0)==0?1:(u|0)>(c[o>>2]|0))){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[k>>2]=3442848;c[j+0>>2]=c[k+0>>2];u=npf(0,j)|0;w=s+16|0;if(pof(0,c[w+(da(c[(c[s>>2]|0)+120>>2]|0,(c[v>>2]|0)+-1|0)|0)>>2]|0,u)|0){u=suh(2619720,suh(2849496,c[w+(da(c[(c[s>>2]|0)+120>>2]|0,(c[v>>2]|0)+-1|0)|0)>>2]|0)|0)|0;c:do if((c[o>>2]|0)>0){y=c[v>>2]|0;x=0;while(1){if((x|0)<(y+-1|0)){E=suh(2849496,c[w+(da(c[(c[s>>2]|0)+120>>2]|0,x)|0)>>2]|0)|0;if((c[p+(da(c[(c[f>>2]|0)+120>>2]|0,x)|0)>>2]|0)!=(E|0)){F=x;break c}G=c[v>>2]|0}else G=y;if((x|0)>=(G+-1|0)?(c[p+(da(c[(c[f>>2]|0)+120>>2]|0,x)|0)>>2]|0)!=(u|0):0){F=x;break c}E=x+1|0;if((E|0)<(c[o>>2]|0)){y=G;x=E}else{F=E;break}}}else F=0;while(0);if((F|0)==(c[o>>2]|0)){B=t;break}}}n=n+1|0;u=c[l>>2]|0;if((n|0)>=(u|0)){H=u;break a}}i=g;return B|0}else H=D}else H=m;while(0);if(!((d&65536|0)==0&(H|0)>0)){B=0;i=g;return B|0}H=e+16|0;d=f+12|0;m=0;D=0;while(1){F=c[H+(da(c[(c[e>>2]|0)+120>>2]|0,m)|0)>>2]|0;G=xuh(2849384,F)|0;if((c[G+12>>2]|0)==(c[d>>2]|0)?H0f(0,f,G,h)|0:0)if(!D)I=F;else I=J0f(b,D,F,0)|0;else I=D;m=m+1|0;if((m|0)>=(c[l>>2]|0)){B=I;break}else D=I}i=g;return B|0}function C0f(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;RI(1086352)|0;g=Cvh(1086352,c[(c[e>>2]|0)+12>>2]|0)|0;h=c[e>>2]|0;vEf(0,h,g,c[h+12>>2]|0);h=xuh(2849384,f)|0;f=d+12|0;if((c[f>>2]|0)<=0){j=c[e>>2]|0;k=j+12|0;l=c[k>>2]|0;vEf(0,g,j,l);i=b;return}m=h+12|0;n=h+16|0;o=d+16|0;p=g+16|0;q=0;do{a:do if((c[m>>2]|0)>0){r=0;while(1){s=Fqh(2849440,c[n+(da(c[(c[h>>2]|0)+120>>2]|0,r)|0)>>2]|0)|0;if(!(a[2540708]|0))Evh(2540560);if(gpf(0,c[o+(da(c[(c[d>>2]|0)+120>>2]|0,q)|0)>>2]|0,s)|0){t=r;break}r=r+1|0;if((r|0)>=(c[m>>2]|0))break a}r=c[e>>2]|0;Qqh(g,c[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,q)|0)>>2]|0);r=c[e>>2]|0;s=c[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,q)|0)>>2]|0;c[p+(da(c[(c[g>>2]|0)+120>>2]|0,t)|0)>>2]=s}while(0);q=q+1|0}while((q|0)<(c[f>>2]|0));j=c[e>>2]|0;k=j+12|0;l=c[k>>2]|0;vEf(0,g,j,l);i=b;return}function D0f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;a=i;a:do if(Gqh(2653112,b)|0){d=b;e=b;f=c;while(1){if(!(Gqh(2653112,f)|0)){g=e;h=f;break a}e=suh(2619720,d)|0;j=suh(2619720,f)|0;if(!(Gqh(2653112,e)|0)){g=e;h=j;break}else{d=e;f=j}}}else{g=b;h=c}while(0);c=Yuh(2651232,h,g)|0;i=a;return c|0}function E0f(b,d,f,j){b=b|0;d=d|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+32|0;b=j+28|0;k=j+20|0;l=j+24|0;m=j;n=j+16|0;o=j+12|0;p=j+8|0;if(!d){q=0;i=j;return q|0}r=Xnf(d)|0;if(Gqh(2653184,f)|0)s=suh(2619720,f)|0;else s=f;if((r|0)==(s|0)){q=d;i=j;return q|0}if(nrh(2655200,s,d)|0){q=d;i=j;return q|0}if((Gqh(2653112,r)|0?Gqh(2653112,s)|0:0)?(f=suh(2619720,r)|0,D0f(0,f,suh(2619720,s)|0)|0):0){q=d;i=j;return q|0}if(!(F0f(0,r,s)|0)){q=0;i=j;return q|0}if(Gqh(2611112,s)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Evh(2610848)}q=pCf(0,s,d)|0;i=j;return q|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[k>>2]=3433768;c[b+0>>2]=c[k+0>>2];if((r|0)==(npf(0,b)|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[l>>2]=3438832;c[b+0>>2]=c[l+0>>2];if((s|0)==(npf(0,b)|0)){RI(2540392)|0;h[m>>3]=+(e[(Rvh(d,2540392)|0)>>1]|0);RI(2589144)|0;q=pL(2589144,m)|0;i=j;return q|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[n>>2]=3432128;c[b+0>>2]=c[n+0>>2];if((s|0)==(npf(0,b)|0)){RI(2540392)|0;g[o>>2]=ea(e[(Rvh(d,2540392)|0)>>1]|0);RI(2586184)|0;q=pL(2586184,o)|0;i=j;return q|0}}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[p>>2]=3432264;c[b+0>>2]=c[p+0>>2];if((r|0)==(npf(0,b)|0)?Gqh(2653600,s)|0:0){q=d;i=j;return q|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;Evh(3034288)}q=Kmg(0,d,s)|0;i=j;return q|0}function F0f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=i;i=i+80|0;f=b+36|0;g=b+24|0;h=b+20|0;j=b+68|0;k=b+32|0;l=b+16|0;m=b+48|0;n=b+56|0;o=b+64|0;p=b+72|0;q=b+76|0;r=b+40|0;s=b+8|0;t=b;u=b+4|0;v=b+44|0;w=b+52|0;x=b+28|0;y=b+60|0;z=b+12|0;if((d|0)==(e|0)|(d|0)==0){A=1;i=b;return A|0}B=Gqh(2653184,e)|0;if(B^(Gqh(2653184,d)|0)){A=0;i=b;return A|0}if(Gqh(2650088,e)|0){A=Yuh(2651232,e,d)|0;i=b;return A|0}if(Gqh(2611112,e)|0){RI(2610848)|0;if(!(a[2610996]|0)){RI(2610848)|0;Evh(2610848)}B=iCf(0,e)|0;if((B|0)==(d|0)){A=1;i=b;return A|0}else C=B}else C=e;if(Gqh(2657008,C)|0){e=suh(2656952,C)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[g>>2]=3443232;c[f+0>>2]=c[g+0>>2];if((e|0)==(npf(0,f)|0)?(c[(cvh(2652064,C)|0)+16>>2]|0)==(d|0):0){A=1;i=b;return A|0}}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}e=jCf(0,d)|0;g=jCf(0,C)|0;do switch(e|0){case 5:{B=g+-7|0;if(B>>>0<8?((-43&255)>>>(B&255)&1)!=0:0){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[l>>2]=3432408;c[f+0>>2]=c[l+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[m>>2]=3441064;c[f+0>>2]=c[m+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 12:case 11:{if((g+-13|0)>>>0<2){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[v>>2]=3432408;c[f+0>>2]=c[v+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[w>>2]=3441064;c[f+0>>2]=c[w+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 6:{B=g+-4|0;if(B>>>0<11?(2041>>>(B&2047)&1)!=0:0){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[j>>2]=3432408;c[f+0>>2]=c[j+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[k>>2]=3441064;c[f+0>>2]=c[k+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 4:{if((g+-8|0)>>>0<7){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[h>>2]=3432408;c[f+0>>2]=c[h+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 8:{if((g+-9|0)>>>0<6){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[n>>2]=3432408;c[f+0>>2]=c[n+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[o>>2]=3441064;c[f+0>>2]=c[o+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 10:{if((g+-11|0)>>>0<4){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[r>>2]=3432408;c[f+0>>2]=c[r+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[s>>2]=3441064;c[f+0>>2]=c[s+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 9:{if((g|0)==13|(g|0)==14|(g|0)==11){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[t>>2]=3432408;c[f+0>>2]=c[t+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[u>>2]=3441064;c[f+0>>2]=c[u+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 7:{B=g+-9|0;if(B>>>0<6?(53>>>(B&63)&1)!=0:0){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[p>>2]=3432408;c[f+0>>2]=c[p+0>>2];if((C|0)==(npf(0,f)|0)){A=1;i=b;return A|0}if(!(Gqh(2611112,d)|0)){A=0;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[q>>2]=3441064;c[f+0>>2]=c[q+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}case 13:{if((g|0)==14){A=1;i=b;return A|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[x>>2]=3432408;c[f+0>>2]=c[x+0>>2];A=(C|0)==(npf(0,f)|0);i=b;return A|0}default:{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[y>>2]=3432408;c[f+0>>2]=c[y+0>>2];if((C|0)==(npf(0,f)|0)?Gqh(2650144,d)|0:0){A=1;i=b;return A|0}if(Gqh(2653600,C)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[z>>2]=3432264;c[f+0>>2]=c[z+0>>2];if((npf(0,f)|0)==(d|0)){A=1;i=b;return A|0}}A=Yuh(2651232,C,d)|0;i=b;return A|0}}while(0);return 0}function G0f(a,b,c){a=a|0;b=b|0;c=c|0;return}function H0f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;f=b+12|0;if((c[f>>2]|0)<=0){g=1;i=a;return g|0}h=d+16|0;j=b+16|0;k=e^1;e=0;while(1){l=suh(2849496,c[h+(da(c[(c[d>>2]|0)+120>>2]|0,e)|0)>>2]|0)|0;m=F0f(0,c[j+(da(c[(c[b>>2]|0)+120>>2]|0,e)|0)>>2]|0,l)|0;if(!(m|k)?(l=suh(2849496,c[h+(da(c[(c[d>>2]|0)+120>>2]|0,e)|0)>>2]|0)|0,Gqh(2653184,l)|0):0){n=suh(2619720,l)|0;if(!(F0f(0,c[j+(da(c[(c[b>>2]|0)+120>>2]|0,e)|0)>>2]|0,n)|0)){g=0;o=8;break}}else o=5;if((o|0)==5?(o=0,!m):0){g=0;o=8;break}e=e+1|0;if((e|0)>=(c[f>>2]|0)){g=1;o=8;break}}if((o|0)==8){i=a;return g|0}return 0}function I0f(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;e=i;f=B0f(a,b,c,d,0,0)|0;i=e;return f|0}function J0f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;if(Gqh(2849552,b)|0?!(Gqh(2849552,d)|0):0){f=d;i=e;return f|0}if(Gqh(2849552,d)|0?!(Gqh(2849552,b)|0):0){f=b;i=e;return f|0}g=xuh(2849384,b)|0;h=xuh(2849384,d)|0;j=g+12|0;if((c[j>>2]|0)>0){k=g+16|0;l=h+16|0;m=0;n=0;while(1){o=suh(2849496,c[k+(da(c[(c[g>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0;p=K0f(a,o,suh(2849496,c[l+(da(c[(c[h>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)|0;o=(p|0)!=0;if(!((m|0)==(p|0)|o&(m|0)!=0^1)){q=7;break}r=o?p:m;n=n+1|0;if((n|0)>=(c[j>>2]|0)){s=r;break}else m=r}if((q|0)==7){RI(2836344)|0;q=qL(2836344)|0;W_f(q);Bvh(q)}if(s){f=(s|0)<1?b:d;i=e;return f|0}}s=suh(2658656,b)|0;q=suh(2658656,d)|0;if((s|0)!=(q|0)){if(Yuh(2650256,s,q)|0){f=b;i=e;return f|0}if(Yuh(2650256,q,s)|0){f=d;i=e;return f|0}}s=((Aqh(2836512,b)|0)&2|0)!=0;q=((Aqh(2836512,d)|0)&2|0)==0;if(s&q){f=d;i=e;return f|0}if(q|s){RI(2836344)|0;s=qL(2836344)|0;W_f(s);Bvh(s)}else{f=b;i=e;return f|0}return 0}function K0f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;if((b|0)==(c|0)){d=0;i=a;return d|0}else{e=b;f=c}while(1){if(Gqh(2657216,e)|0?!(Gqh(2657216,f)|0):0){d=1;g=16;break}if(!(Gqh(2657216,e)|0)?Gqh(2657216,f)|0:0){d=-1;g=16;break}if(!(Gqh(2652984,e)|0)){h=e;j=e;k=f;g=9;break}if(!(Gqh(2652984,f)|0)){h=e;j=e;k=f;g=9;break}e=suh(2619720,e)|0;f=suh(2619720,f)|0;if((e|0)==(f|0)){d=0;g=16;break}}if((g|0)==9){if(Yuh(2650256,h,k)|0){d=-1;i=a;return d|0}if(Yuh(2650256,k,j)|0){d=1;i=a;return d|0}if(Gqh(2650088,h)|0?(Svh(cvh(2655112,k)|0,j)|0)>=0:0){d=1;i=a;return d|0}if(Gqh(2650088,k)|0?(Svh(cvh(2655112,h)|0,k)|0)>=0:0){d=-1;i=a;return d|0}d=0;i=a;return d|0}else if((g|0)==16){i=a;return d|0}return 0}function L0f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=i;dkh();if(!e){RI(2965048)|0;j=qL(2965048)|0;k=c[891982]|0;l=c[891984]|0;Rag(j,k,l);Bvh(j)}d=c[e+12>>2]|0;if(!d){RI(2965048)|0;j=qL(2965048)|0;k=c[891982]|0;l=c[891984]|0;Rag(j,k,l);Bvh(j)}j=(f|0)==0;if(!g)m=-1;else m=c[g+12>>2]|0;if((d|0)<=0){n=0;i=h;return n|0}l=e+16|0;k=(m|0)<0;b=(m|0)<1;o=0;p=d;d=2147483646;q=2147483647;r=0;a:while(1){s=(o|0)==0;t=p;u=q;b:while(1){v=t;c:while(1){v=v+-1|0;w=c[l+(da(c[(c[e>>2]|0)+120>>2]|0,v)|0)>>2]|0;x=xuh(2849608,w)|0;if(!(!k?(m|0)!=(c[x+12>>2]|0):0))y=9;do if((y|0)==9){y=0;if(!j?(suh(2849664,w)|0)!=(f|0):0)break;if(!b){z=M0f(0,g,x)|0;if((z|0)==-1)break;else A=z}else A=2147483646;z=suh(2658656,w)|0;RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}B=N0f(0,z)|0;if(s){C=w;D=B;E=v;F=u;G=A;break b}if((d|0)>=(A|0)){if((d|0)!=(A|0)){C=w;D=B;E=v;F=u;G=A;break b}if((r|0)==(B|0)){H=v;break c}if((r|0)<=(B|0)){C=w;D=B;E=v;F=u;G=A;break b}}}while(0);if((v|0)<=0){I=o;J=d;K=u;break a}}if((H|0)>0){t=H;u=d}else{y=27;break a}}if((E|0)>0){o=C;p=E;d=G;q=F;r=D}else{I=C;J=G;K=F;break}}if((y|0)==27){RI(2836344)|0;L=qL(2836344)|0;W_f(L);Bvh(L)}if((K|0)>(J|0)){n=I;i=h;return n|0}else{RI(2836344)|0;L=qL(2836344)|0;W_f(L);Bvh(L)}return 0}function M0f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;e=b+12|0;if((c[e>>2]|0)<=0){f=-1;i=a;return f|0}g=d+16|0;h=b+16|0;j=-1;k=0;while(1){l=suh(2849496,c[g+(da(c[(c[d>>2]|0)+120>>2]|0,k)|0)>>2]|0)|0;m=O0f(0,c[h+(da(c[(c[b>>2]|0)+120>>2]|0,k)|0)>>2]|0,l)|0;if((m|0)==-1){f=-1;n=5;break}l=(j|0)<(m|0)?m:j;k=k+1|0;if((k|0)>=(c[e>>2]|0)){f=l;n=5;break}else j=l}if((n|0)==5){i=a;return f|0}return 0}function N0f(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=i;if(!(suh(2651176,b)|0)){c=1;i=a;return c|0}else{d=b;e=1}while(1){b=e+1|0;d=suh(2651176,d)|0;if(!(suh(2651176,d)|0)){c=b;break}else e=b}i=a;return c|0}function O0f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+48|0;f=b+28|0;g=b+16|0;h=b+4|0;j=b+8|0;k=b+32|0;l=b;m=b+12|0;n=b+24|0;o=b+20|0;if(!d){p=(Gqh(2650144,e)|0)<<31>>31;i=b;return p|0}if((d|0)==(e|0)){p=0;i=b;return p|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[g>>2]=3432408;c[f+0>>2]=c[g+0>>2];if((npf(0,f)|0)==(e|0)){p=4;i=b;return p|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}g=jCf(0,d)|0;q=jCf(0,e)|0;do switch(g|0){case 9:{if((q|0)==13|(q|0)==14|(q|0)==11){p=2;i=b;return p|0}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[n>>2]=3441064;c[f+0>>2]=c[n+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}case 12:case 11:{if((q+-13|0)>>>0<2){p=2;i=b;return p|0}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[o>>2]=3441064;c[f+0>>2]=c[o+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}case 10:{if((q+-11|0)>>>0<4){p=2;i=b;return p|0}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[m>>2]=3441064;c[f+0>>2]=c[m+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}case 7:{if((q|0)==13|(q|0)==11|(q|0)==14|(q|0)==9){p=2;i=b;return p|0}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[l>>2]=3441064;c[f+0>>2]=c[l+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}case 4:{switch(q|0){case 14:case 13:case 12:case 11:case 10:case 9:{p=2;i=b;return p|0}case 8:{p=0;i=b;return p|0}default:{p=-1;i=b;return p|0}}break}case 13:{p=(q|0)==14?2:-1;i=b;return p|0}case 5:{switch(q|0){case 11:case 13:case 9:case 14:case 7:{p=2;i=b;return p|0}default:{}}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[j>>2]=3441064;c[f+0>>2]=c[j+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}case 6:{switch(q|0){case 12:case 11:case 10:case 9:case 8:case 7:case 13:case 14:case 4:{p=2;i=b;return p|0}default:{}}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[h>>2]=3441064;c[f+0>>2]=c[h+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}case 8:{if((q+-9|0)>>>0<6){p=2;i=b;return p|0}if(Gqh(2611112,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[k>>2]=3441064;c[f+0>>2]=c[k+0>>2];if((npf(0,f)|0)==(e|0)){p=1;i=b;return p|0}}p=-1;i=b;return p|0}default:{r=Yuh(2651232,e,d)|0;p=r?3:-1;i=b;return p|0}}while(0);return 0}function P0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2851560)|0);c[c[d>>2]>>2]=a;i=b;return}function Q0f(a){a=a|0;var b=0;a=i;RI(2849720)|0;b=qL(2849720)|0;RI(2836568)|0;c[c[709165]>>2]=b;i=a;return}function R0f(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;g=c[e+12>>2]|0;if(!d)if(!g){h=1;i=a;return h|0}else{RI(2851712)|0;j=qL(2851712)|0;S0f(j);Bvh(j)}j=d+12|0;if((g|0)!=(c[j>>2]|0)){RI(2851712)|0;k=qL(2851712)|0;S0f(k);Bvh(k)}if((g|0)<=0){h=1;i=a;return h|0}g=e+16|0;k=d+16|0;l=0;while(1){m=suh(2849496,c[g+(da(c[(c[e>>2]|0)+120>>2]|0,l)|0)>>2]|0)|0;n=Tvh(2851880,b,c[k+(da(c[(c[d>>2]|0)+120>>2]|0,l)|0)>>2]|0,m,f)|0;if((n|0)==0?(c[k+(da(c[(c[d>>2]|0)+120>>2]|0,l)|0)>>2]|0)!=0:0){h=0;o=11;break}Qqh(d,n);c[k+(da(c[(c[d>>2]|0)+120>>2]|0,l)|0)>>2]=n;l=l+1|0;if((l|0)>=(c[j>>2]|0)){h=1;o=11;break}}if((o|0)==11){i=a;return h|0}return 0}function S0f(a){a=a|0;var b=0;b=i;Bkh();Vxf(a,tof(0,c[892662]|0)|0);i=b;return}function T0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=2;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function U0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function V0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function W0f(a){a=a|0;var b=0;a=i;ekh();b=c[892e3]|0;RI(2819928)|0;c[c[705005]>>2]=b;b=c[892002]|0;RI(2819928)|0;c[(c[705005]|0)+4>>2]=b;i=a;return}function X0f(a){a=a|0;return 1}function Y0f(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(!b){RI(1086352)|0;d=Cvh(1086352,0)|0}else d=b;b=Uvh(2854912,a,512,0,d,0)|0;i=c;return b|0}function Z0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2915024)|0;c[a+8>>2]=ML(c[728772]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function _0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function $0f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function a1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2744392)|0;BQf(a);c[c[d>>2]>>2]=a;a=qL(2617832)|0;c[(c[d>>2]|0)+4>>2]=a;i=b;return}function b1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function c1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function d1f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function e1f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)e1f(f,b,d);co[c[a+8>>2]&2047](c[a+16>>2]|0,b,d);i=e;return}function f1f(a,b,c){a=a|0;b=b|0;c=c|0;Bvh(SJ(3131272)|0)}function g1f(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function h1f(a,b){a=a|0;b=b|0;return}function i1f(a){a=a|0;var b=0,d=0,e=0;b=i;d=xuh(2849384,Vvh(2857168,a,1)|0)|0;if((c[d+12>>2]|0)<1){e=0;i=b;return e|0}e=suh(2849496,c[d+16>>2]|0)|0;i=b;return e|0}function j1f(a){a=a|0;return 2}function k1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2915520)|0;c[a+8>>2]=ML(c[728896]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function l1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function m1f(a){a=a|0;return 4}function n1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836792,a)|0)&64|0)!=0;i=b;return c|0}function o1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836792,a)|0)&16|0)!=0;i=b;return c|0}function p1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836792,a)|0)&128|0)!=0;i=b;return c|0}function q1f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Wvh(2858864,a,b,c,0,0,0);i=d;return}function r1f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;e=a+12|0;f=a+8|0;g=a+4|0;h=a;j=c[714730]|0;if(!j){k=MK(2858928)|0;c[714730]=k;l=k}else l=j;c[g>>2]=c[b>>2];c[h>>2]=c[d>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];h=_n[l&4095](f,e)|0;i=a;return h|0}function s1f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+32|0;d=a+20|0;e=a+16|0;f=a+12|0;g=a+8|0;h=a+4|0;j=a;fkh();c[f>>2]=YHf(b)|0;RI(2604248)|0;c[g>>2]=c[c[651085]>>2];c[e+0>>2]=c[f+0>>2];c[d+0>>2]=c[g+0>>2];if(FAf(0,e,d)|0){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[892014]|0);Bvh(g)}else{c[h>>2]=YHf(b)|0;RI(2604248)|0;c[j>>2]=c[c[651085]>>2];c[e+0>>2]=c[h+0>>2];c[d+0>>2]=c[j+0>>2];j=r1f(0,e,d)|0;i=a;return j|0}return 0}function t1f(a){a=a|0;gkh();RI(3079856)|0;a=qL(3079856)|0;Grg(a,c[892030]|0);Bvh(a);return 0}function u1f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[714754]|0;if(!d){e=MK(2859024)|0;c[714754]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function v1f(a){a=a|0;var b=0,c=0;b=i;c=u1f(a)|0;i=b;return c|0}function w1f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;d=Gqh(2859080,a)|0;e=Gqh(2653432,suh(2658656,a)|0)|0;f=Xvh(2859136,a)|0;g=(f|0)!=0;h=(g&1)+(e?(d?2:1):d&1)|0;if(!h){j=0;i=b;return j|0}RI(1086352)|0;d=Cvh(1086352,h)|0;if(Gqh(2859080,a)|0){RI(3099704)|0;h=qL(3099704)|0;jug(h);Qqh(d,h);c[d+16>>2]=h;k=1}else k=0;if(Gqh(2653432,suh(2658656,a)|0)|0){h=Aqh(2859192,a)|0;RI(2668368)|0;a=qL(2668368)|0;KIf(a,h);Qqh(d,a);c[d+16+(c[(c[d>>2]|0)+120>>2]&0-k)>>2]=a;l=k+1|0}else l=k;if(!g){j=d;i=b;return j|0}g=J$f(f)|0;Qqh(d,g);c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,l)|0)>>2]=g;j=d;i=b;return j|0}function x1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819224)|0;RI(2916016)|0;c[a+8>>2]=ML(c[729020]|0)|0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function y1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2744392)|0;BQf(a);c[c[d>>2]>>2]=a;a=qL(2617832)|0;c[(c[d>>2]|0)+4>>2]=a;i=b;return}function z1f(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=i;A1f(0,b,c,d,e,f,0);i=a;return}function A1f(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;k=b+8|0;l=b+16|0;m=b+20|0;n=b+24|0;o=b+4|0;p=b;q=b+12|0;hkh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[l>>2]=3447352;c[k+0>>2]=c[l+0>>2];p9f(d,npf(0,k)|0);l=Fqh(2836288,c[(dvh(2653872,f)|0)+12>>2]|0)|0;c[m>>2]=3431728;c[k+0>>2]=c[m+0>>2];m=npf(0,k)|0;q9f(d,c[892050]|0,l,m);m=Fqh(2537592,f)|0;c[n>>2]=3431728;c[k+0>>2]=c[n+0>>2];n=npf(0,k)|0;q9f(d,c[892052]|0,m,n);c[o>>2]=3431728;c[k+0>>2]=c[o+0>>2];o=npf(0,k)|0;q9f(d,c[892054]|0,e,o);c[p>>2]=3431728;c[k+0>>2]=c[p+0>>2];p=npf(0,k)|0;q9f(d,c[892056]|0,g,p);r9f(d,c[892058]|0,h);c[q>>2]=3435752;c[k+0>>2]=c[q+0>>2];q=npf(0,k)|0;q9f(d,c[892060]|0,j,q);i=b;return}function B1f(a,b,c){a=a|0;b=b|0;c=c|0;RI(3100472)|0;c=qL(3100472)|0;oug(c);Bvh(c)}function C1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function D1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function E1f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;c[f>>2]=Dwg(b)|0;RI(2604248)|0;c[g>>2]=c[c[651085]>>2];c[e+0>>2]=c[f+0>>2];c[d+0>>2]=c[g+0>>2];g=F1f(0,e,d)|0;i=a;return g|0}function F1f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+32|0;e=a+20|0;f=a+16|0;g=a+12|0;h=a+8|0;j=a+4|0;k=a;jkh();l=c[b>>2]|0;c[g>>2]=l;RI(2604248)|0;c[h>>2]=c[c[651085]>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];if(FAf(0,f,e)|0){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[892096]|0);Bvh(h)}c[j>>2]=l;c[k>>2]=c[d>>2];c[f+0>>2]=c[j+0>>2];c[e+0>>2]=c[k+0>>2];k=G1f(0,f,e)|0;if(!k){RI(2965048)|0;e=qL(2965048)|0;Rbg(e,c[892098]|0);Bvh(e)}else{i=a;return k|0}return 0}function G1f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;e=a+12|0;f=a+8|0;g=a+4|0;h=a;j=c[715746]|0;if(!j){k=MK(2862992)|0;c[715746]=k;l=k}else l=j;c[g>>2]=c[b>>2];c[h>>2]=c[d>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];h=_n[l&4095](f,e)|0;i=a;return h|0}function H1f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;kkh();c[f>>2]=Dwg(b)|0;RI(2604248)|0;c[g>>2]=c[c[651085]>>2];c[e+0>>2]=c[f+0>>2];c[d+0>>2]=c[g+0>>2];g=F1f(0,e,d)|0;d=suh(2658656,g)|0;if(!(Gqh(2657008,d)|0)?!(Gqh(2652008,d)|0):0){i=a;return g|0}RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[892102]|0);Bvh(g);return 0}function I1f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Yvh(2863088,a,b,0,0,c,0)|0;i=d;return e|0}function J1f(a){a=a|0;return 1}function K1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&7|0)==6;i=b;return c|0}function L1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&7|0)==1;i=b;return c|0}function M1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&7|0)==4;i=b;return c|0}function N1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&7|0)==3;i=b;return c|0}function O1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&7|0)==2;i=b;return c|0}function P1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&7|0)==5;i=b;return c|0}function Q1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&16|0)!=0;i=b;return c|0}function R1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&32|0)!=0;i=b;return c|0}function S1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&64|0)!=0;i=b;return c|0}function T1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&128|0)!=0;i=b;return c|0}function U1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&1024|0)!=0;i=b;return c|0}function V1f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2836848,a)|0)&2048|0)!=0;i=b;return c|0}function W1f(b){b=b|0;var d=0,e=0,f=0;d=i;ikh();if(!((Aqh(2836848,b)|0)&4096)){e=0;i=d;return e|0}f=Fqh(2649752,b)|0;if(!(a[2540708]|0))Evh(2540560);e=gpf(0,f,c[892092]|0)|0;i=d;return e|0}function X1f(a){a=a|0;RI(3100472)|0;a=qL(3100472)|0;oug(a);Bvh(a);return 0}function Y1f(a){a=a|0;return 0}function Z1f(a){a=a|0;return 0}function _1f(a){a=a|0;return 0}function $1f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2916264)|0;c[a+8>>2]=ML(c[729082]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function a2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617832)|0;c[c[d>>2]>>2]=a;a=qL(2744392)|0;BQf(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function b2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function c2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function d2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function e2f(a){a=a|0;return 8}function f2f(a){a=a|0;return 0}function g2f(a,b){a=a|0;b=b|0;b=Fqh(2536192,Xnf(a)|0)|0;RI(3100472)|0;a=qL(3100472)|0;pug(a,b);Bvh(a);return 0}function h2f(b){b=b|0;b=i;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}RI(2540728)|0;i=b;return c[(c[635205]|0)+8>>2]|0}function i2f(a){a=a|0;return 0}function j2f(a){a=a|0;return 0}function k2f(a){a=a|0;return 0}function l2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819224)|0;RI(2916760)|0;c[a+8>>2]=ML(c[729206]|0)|0;c[c[d>>2]>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function m2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function n2f(a){a=a|0;return}function o2f(a){a=a|0;var b=0;a=i;RI(2867160)|0;b=qL(2867160)|0;RI(2867160)|0;c[c[716813]>>2]=b;i=a;return}function p2f(a,b,c){a=a|0;b=b|0;c=c|0;return}function q2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function r2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function s2f(a){a=a|0;var b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;RI(3132064)|0;f=qL(3132064)|0;c[d>>2]=2867656;c[b+0>>2]=c[d+0>>2];Cyg(f,0,b);RI(2835448)|0;c[(c[708885]|0)+4>>2]=f;RI(3132064)|0;f=qL(3132064)|0;c[e>>2]=2867712;c[b+0>>2]=c[e+0>>2];Cyg(f,0,b);RI(2835448)|0;c[(c[708885]|0)+8>>2]=f;i=a;return}function t2f(a){a=a|0;return c[a+24>>2]|0}function u2f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function v2f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;lkh();if(!b){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[892138]|0);Bvh(h)}else{h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];iyg(0,a,b,f);i=e;return}}function w2f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function x2f(a){a=a|0;return c[a+20>>2]|0}function y2f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;mkh();f=Jvh(e,2540560)|0;e=xvf(f,c[892142]|0)|0;g=Fqh(2649752,d)|0;if(e){h=Pvf(g,fpf(f,0,(Vof(f)|0)+-1|0)|0)|0;i=b;return h|0}if(!(a[2540708]|0))Evh(2540560);h=gpf(0,g,f)|0;i=b;return h|0}function z2f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;nkh();f=Jvh(e,2540560)|0;e=xvf(f,c[892146]|0)|0;g=Fqh(2649752,d)|0;if(e){e=Vvf(g)|0;h=Pvf(e,Vvf(fpf(f,0,(Vof(f)|0)+-1|0)|0)|0)|0;i=b;return h|0}if(!(a[2540708]|0))Evh(2540560);h=(pvf(0,g,f,1)|0)==0;i=b;return h|0}function A2f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2917e3)|0;c[a+8>>2]=ML(c[729266]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function B2f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[717234]|0;if(!e){f=MK(2868944)|0;c[717234]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function C2f(a,b,d){a=a|0;b=b|0;d=d|0;b=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;B2f(0,d,a);i=b;return}function D2f(a){a=a|0;var b=0,d=0;b=i;i=i+32|0;d=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;B2f(0,a,d);i=b;return c[d+24>>2]|0}function E2f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;B2f(0,a,e);a=c[e+12>>2]|0;if(b){f=a;i=d;return f|0}if((a|0)!=0?Gqh(2863856,a)|0:0){f=a;i=d;return f|0}f=0;i=d;return f|0}function F2f(a){a=a|0;var b=0,d=0;b=i;i=i+32|0;d=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;B2f(0,a,d);i=b;return c[d>>2]|0}function G2f(a){a=a|0;var b=0,d=0;b=i;i=i+32|0;d=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;B2f(0,a,d);i=b;return c[d+4>>2]|0}function H2f(a){a=a|0;var b=0,d=0;b=i;i=i+32|0;d=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;B2f(0,a,d);i=b;return c[d+8>>2]|0}function I2f(b){b=b|0;var d=0,e=0,f=0;d=i;okh();e=suh(2857352,b)|0;f=Fqh(2869776,b)|0;if(!(a[2540708]|0))Evh(2540560);b=hwf(0,e,c[892150]|0,f)|0;i=d;return b|0}function J2f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function K2f(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}e=jtg(0,b,c)|0;i=d;return e|0}function L2f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function M2f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;d=Fqh(2869776,a)|0;e=suh(2869832,a)|0;A1f(0,b,d,e,Fqh(2869888,a)|0,2,0);i=c;return}function N2f(a){a=a|0;return c[a+24>>2]|0}function O2f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[717726]|0;if(!e){f=MK(2870912)|0;c[717726]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function P2f(a){a=a|0;var b=0,c=0;b=i;c=O2f(a,0)|0;i=b;return c|0}function Q2f(a){a=a|0;var b=0,c=0;b=i;c=O2f(a,1)|0;i=b;return c|0}function R2f(a){a=a|0;return c[a+16>>2]|0}function S2f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function T2f(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}e=jtg(0,b,c)|0;i=d;return e|0}function U2f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function V2f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[717744]|0;if(!d){e=MK(2870984)|0;c[717744]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function W2f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[717758]|0;if(!e){f=MK(2871040)|0;c[717758]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function X2f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;pkh();if(!(Gqh(2859464,a)|0|(b|0)!=0)){RI(2871104)|0;e=qL(2871104)|0;Vxf(e,c[892154]|0);Bvh(e)}if(Gqh(2859392,a)|0){f=W2f(a,b)|0;i=d;return f|0}Z2f(a);f=W2f(a,b)|0;i=d;return f|0}function Y2f(a,b){a=a|0;b=b|0;var c=0;c=i;Vxf(a,b);i=c;return}function Z2f(a){a=a|0;var b=0;b=i;skh();if(Gqh(2619552,suh(2871552,a)|0)|0){RI(3084976)|0;a=qL(3084976)|0;osg(a,c[892238]|0);Bvh(a)}else{i=b;return}}function _2f(b){b=b|0;var d=0,e=0,f=0;d=i;qkh();e=c[b+20>>2]|0;f=c[b+16>>2]|0;if(!(a[2540708]|0))Evh(2540560);b=awf(0,c[892176]|0,e,f)|0;i=d;return b|0}function $2f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[717818]|0;if(!f){g=MK(2871280)|0;c[717818]=g;h=g}else h=f;co[h&2047](b,d,e);i=a;return}function a3f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;f=i;rkh();if(!(Gqh(2859464,b)|0|(d|0)!=0)){RI(2871104)|0;j=qL(2871104)|0;Vxf(j,c[892184]|0);Bvh(j)}if(Gqh(2859392,b)|0){RI(3078616)|0;j=qL(3078616)|0;Arg(j,c[892186]|0);Bvh(j)}if(!g){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}k=X_f(0)|0}else k=g;Z2f(b);if(!e){l=0;$2f(0,b,d,l);i=f;return}g=b+20|0;j=Tvh(2851880,k,e,c[g>>2]|0,h)|0;if(j){l=j;$2f(0,b,d,l);i=f;return}RI(1086352)|0;f=Cvh(1086352,4)|0;Qqh(f,c[892188]|0);l=f+16|0;c[l>>2]=c[892188];d=Xnf(e)|0;Qqh(f,d);c[l+(c[(c[f>>2]|0)+120>>2]|0)>>2]=d;Qqh(f,c[892190]|0);c[l+(c[(c[f>>2]|0)+120>>2]<<1)>>2]=c[892190];d=c[g>>2]|0;Qqh(f,d);c[l+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>2]=d;if(a[2540708]|0){m=eqf(0,f)|0;RI(2965048)|0;n=qL(2965048)|0;o=c[892192]|0;Rag(n,m,o);Bvh(n)}Evh(2540560);m=eqf(0,f)|0;RI(2965048)|0;n=qL(2965048)|0;o=c[892192]|0;Rag(n,m,o);Bvh(n)}function b3f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;d=Fqh(2871384,a)|0;e=suh(2871440,a)|0;A1f(0,b,d,e,Fqh(2871496,a)|0,4,0);i=c;return}function c3f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[718298]|0;if(!d){e=MK(2873200)|0;c[718298]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function d3f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[718480]|0;if(!d){e=MK(2873928)|0;c[718480]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function e3f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[718660]|0;if(!g){h=MK(2874648)|0;c[718660]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];In[j&4095](e,d);i=a;return}function f3f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;b=i;i=i+16|0;e=b+4|0;f=b;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[f>>2]=c[d>>2];c[e+0>>2]=c[f+0>>2];e3f(0,e,a);i=b;return}function g3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+32|0;d=a+24|0;e=a+4|0;f=a;c[f>>2]=c[b>>2];c[d+0>>2]=c[f+0>>2];f3f(e,0,d);i=a;return c[e>>2]|0}function h3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+32|0;d=a+24|0;e=a+4|0;f=a;c[f>>2]=c[b>>2];c[d+0>>2]=c[f+0>>2];f3f(e,0,d);i=a;return c[e+4>>2]|0}function i3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+32|0;d=a+24|0;e=a+4|0;f=a;c[f>>2]=c[b>>2];c[d+0>>2]=c[f+0>>2];f3f(e,0,d);i=a;return c[e+8>>2]|0}function j3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+32|0;d=a+24|0;e=a+4|0;f=a;c[f>>2]=c[b>>2];c[d+0>>2]=c[f+0>>2];f3f(e,0,d);i=a;return c[e+16>>2]|0}function k3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;i=i+32|0;d=a+24|0;e=a+4|0;f=a;c[f>>2]=c[b>>2];c[d+0>>2]=c[f+0>>2];f3f(e,0,d);i=a;return c[e+12>>2]|0}function l3f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[718688]|0;if(!g){h=MK(2874760)|0;c[718688]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];f=_n[j&4095](e,d)|0;i=a;return f|0}function m3f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;i=i+16|0;e=a+4|0;f=a;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];f=l3f(0,e,d)|0;i=a;return f|0}function n3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[719026]|0;if(!d){e=MK(2876112)|0;c[719026]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function o3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[719046]|0;if(!d){e=MK(2876192)|0;c[719046]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function p3f(a){a=a|0;var b=0,c=0;b=i;c=o3f(0,a)|0;i=b;return c|0}function q3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=h3f(0,d)|0;i=b;return e|0}function r3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=k3f(0,d)|0;i=b;return e|0}function s3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=l3f(0,d,a)|0;RI(1137488)|0;a=Cvh(1137488,c[e+12>>2]|0)|0;Csh(262e4,e,a,0);i=b;return a|0}function t3f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[719068]|0;if(!g){h=MK(2876280)|0;c[719068]=h;j=h}else j=g;g=kn[j&511](a,b,d,e)|0;i=f;return g|0}function u3f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;c[m>>2]=0;tkh();if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}n=X_f(0)|0}else n=f;c[l>>2]=c[b+8>>2];c[k+0>>2]=c[l+0>>2];l=l3f(0,k,b)|0;if(!g)if(!(c[l+12>>2]|0))o=0;else{RI(2851712)|0;p=qL(2851712)|0;q=c[892298]|0;Vxf(p,q);Bvh(p)}else{k=c[g+12>>2]|0;if((k|0)==(c[l+12>>2]|0))o=k;else{RI(2851712)|0;p=qL(2851712)|0;q=c[892298]|0;Vxf(p,q);Bvh(p)}}a:do if(!(e&65536)){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}if(!(R0f(0,n,g,l,h)|0)){RI(2965048)|0;p=qL(2965048)|0;Rbg(p,c[892300]|0);Bvh(p)}}else{p=l+12|0;if((o|0)>0){q=g+16|0;k=l+16|0;f=0;while(1){r=Xnf(c[q+(da(c[(c[g>>2]|0)+120>>2]|0,f)|0)>>2]|0)|0;if((r|0)!=(suh(2849496,c[k+(da(c[(c[l>>2]|0)+120>>2]|0,f)|0)>>2]|0)|0))break;f=f+1|0;if((f|0)>=(c[p>>2]|0))break a}RI(2965048)|0;p=qL(2965048)|0;Rbg(p,c[892302]|0);Bvh(p)}}while(0);if(Gqh(2876376,b)|0){RI(3084976)|0;l=qL(3084976)|0;osg(l,c[892304]|0);Bvh(l)}l=t3f(b,d,g,m)|0;g=c[m>>2]|0;if(!g){i=j;return l|0}else Bvh(g);return 0}function v3f(a,b){a=a|0;b=b|0;var c=0;c=i;Vxf(a,b);i=c;return}function w3f(a,b){a=a|0;b=b|0;var d=0;d=i;Akh();GHf(a,c[892628]|0,b);i=d;return}function x3f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a+8>>2]|0;c[e>>2]=0;c[f>>2]=g;c[d+0>>2]=c[f+0>>2];Cwg(e,d);i=b;return c[e>>2]|0}function y3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=i3f(0,d)|0;i=b;return e|0}function z3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=j3f(0,d)|0;i=b;return e|0}function A3f(a){a=a|0;return c[a+16>>2]|0}function B3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=g3f(0,d)|0;i=b;return e|0}function C3f(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+12>>2]|0;if(!d)e=n3f(0,a)|0;else e=d;i=b;return e|0}function D3f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function E3f(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}e=jtg(0,b,c)|0;i=d;return e|0}function F3f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function G3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[719150]|0;if(!f){g=MK(2876608)|0;c[719150]=g;h=g}else h=f;c[e>>2]=c[b>>2];c[d+0>>2]=c[e+0>>2];e=mo[h&4095](d)|0;i=a;return e|0}function H3f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+8|0;g=d+4|0;h=d;j=b+8|0;c[g>>2]=c[j>>2];c[e+0>>2]=c[g+0>>2];f3f(f,0,e);g=c[f+12>>2]&128;b=(g|0)!=0;k=c[f+8>>2]&8192;f=(g>>>7)+(k>>>13)|0;if(!f){l=0;i=d;return l|0}RI(1086352)|0;g=Cvh(1086352,f)|0;if(b){RI(2909464)|0;f=qL(2909464)|0;H5f(f);Qqh(g,f);c[g+16>>2]=f;m=1}else m=0;if(!k){l=g;i=d;return l|0}c[h>>2]=c[j>>2];c[e+0>>2]=c[h+0>>2];h=G3f(0,e)|0;if(b)a[h+8>>0]=1;Qqh(g,h);c[g+16+(c[(c[g>>2]|0)+120>>2]&0-m)>>2]=h;l=g;i=d;return l|0}function I3f(a,b){a=a|0;b=b|0;var c=0;a=i;if(Gqh(2653256,b)|0)if(Gqh(2653600,b)|0)if(Gqh(2653672,suh(2619720,b)|0)|0)c=0;else c=(rHf(suh(2619720,b)|0)|0)^1;else c=1;else c=0;i=a;return c|0}function J3f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;ukh();RI(2971904)|0;d=qL(2971904)|0;Gbg(d);e=suh(2876680,a)|0;if(I3f(0,e)|0)Hbg(d,Fqh(2536192,e)|0)|0;else Hbg(d,Fqh(2649752,e)|0)|0;Hbg(d,c[892394]|0)|0;Hbg(d,Fqh(2876736,a)|0)|0;if(Gqh(2876792,a)|0){e=cvh(2876848,a)|0;Hbg(d,c[892396]|0)|0;f=e+12|0;if((c[f>>2]|0)>0){g=e+16|0;h=0;do{if((h|0)>=1)Hbg(d,c[892398]|0)|0;Hbg(d,Fqh(2649752,c[g+(da(c[(c[e>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0)|0;h=h+1|0}while((h|0)<(c[f>>2]|0))}Hbg(d,c[892400]|0)|0}Hbg(d,c[892402]|0)|0;f=xuh(2876904,a)|0;h=f+12|0;if((c[h>>2]|0)>0){e=f+16|0;g=0;do{if((g|0)>=1)Hbg(d,c[892404]|0)|0;j=suh(2849496,c[e+(da(c[(c[f>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0;k=Gqh(2653184,j)|0;if(k)l=suh(2619720,j)|0;else l=j;if(I3f(0,l)|0)Hbg(d,Fqh(2536192,l)|0)|0;else Hbg(d,Fqh(2649752,l)|0)|0;if(k)Hbg(d,c[892406]|0)|0;g=g+1|0}while((g|0)<(c[h>>2]|0))}if(!((Aqh(2876960,a)|0)&2)){m=c[892412]|0;Hbg(d,m)|0;n=Fqh(2972072,d)|0;i=b;return n|0}if((c[h>>2]|0)>=1)Hbg(d,c[892408]|0)|0;Hbg(d,c[892410]|0)|0;m=c[892412]|0;Hbg(d,m)|0;n=Fqh(2972072,d)|0;i=b;return n|0}function K3f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=i;if(Gqh(2876792,a)|0?!(Gqh(2877016,a)|0):0)d=cvh(2876848,a)|0;else d=0;e=Fqh(2876736,a)|0;f=suh(2877072,a)|0;A1f(0,b,e,f,Fqh(2877128,a)|0,8,d);i=c;return}function L3f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+4|0;g=e;vkh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[892418]|0);Bvh(h)}h=d+12|0;j=c[h>>2]|0;a:do if((j|0)>0){k=d+16|0;l=c[(c[d>>2]|0)+120>>2]|0;m=0;while(1){if(!(c[k+(da(l,m)|0)>>2]|0))break;m=m+1|0;if((m|0)>=(j|0))break a}RI(2963920)|0;m=qL(2963920)|0;Ucg(m);Bvh(m)}while(0);j=M3f(b,d)|0;if(j){i=e;return j|0}c[f>>2]=c[(cvh(2876848,b)|0)+12>>2];RI(2540224)|0;b=pL(2540224,f)|0;c[g>>2]=c[h>>2];RI(2540224)|0;h=pL(2540224,g)|0;if(a[2540708]|0){n=c[892420]|0;o=awf(0,n,b,h)|0;RI(2965048)|0;p=qL(2965048)|0;Rbg(p,o);Bvh(p)}Evh(2540560);n=c[892420]|0;o=awf(0,n,b,h)|0;RI(2965048)|0;p=qL(2965048)|0;Rbg(p,o);Bvh(p);return 0}function M3f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[719296]|0;if(!e){f=MK(2877192)|0;c[719296]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function N3f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[719316]|0;if(!d){e=MK(2877272)|0;c[719316]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function O3f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[719332]|0;if(!d){e=MK(2877336)|0;c[719332]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function P3f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[719350]|0;if(!d){e=MK(2877408)|0;c[719350]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Q3f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;a:do if(Gqh(2876792,a)|0?(d=cvh(2876848,a)|0,e=d+12|0,(c[e>>2]|0)>0):0){f=d+16|0;g=0;while(1){if(Gqh(2619552,c[f+(da(c[(c[d>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0){h=1;break}g=g+1|0;if((g|0)>=(c[e>>2]|0))break a}i=b;return h|0}while(0);h=Gqh(2619552,suh(2877464,a)|0)|0;i=b;return h|0}function R3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=k3f(0,d)|0;i=b;return e|0}function S3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=l3f(0,d,a)|0;i=b;return e|0}function T3f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[719852]|0;if(!g){h=MK(2879416)|0;c[719852]=h;j=h}else j=g;g=kn[j&511](a,b,d,e)|0;i=f;return g|0}function U3f(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;c[k>>2]=0;wkh();if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}l=X_f(0)|0}else l=f;f=xuh(2879512,b)|0;if(!g)if(!(c[f+12>>2]|0))m=0;else{RI(2851712)|0;n=qL(2851712)|0;o=c[892476]|0;Vxf(n,o);Bvh(n)}else{p=c[g+12>>2]|0;if((p|0)==(c[f+12>>2]|0))m=p;else{RI(2851712)|0;n=qL(2851712)|0;o=c[892476]|0;Vxf(n,o);Bvh(n)}}a:do if(!(e&65536)){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Evh(2836568)}if(!(R0f(0,l,g,f,h)|0)){RI(2965048)|0;n=qL(2965048)|0;Rbg(n,c[892478]|0);Bvh(n)}}else{n=f+12|0;if((m|0)>0){o=g+16|0;p=f+16|0;q=0;while(1){r=Xnf(c[o+(da(c[(c[g>>2]|0)+120>>2]|0,q)|0)>>2]|0)|0;if((r|0)!=(suh(2849496,c[p+(da(c[(c[f>>2]|0)+120>>2]|0,q)|0)>>2]|0)|0))break;q=q+1|0;if((q|0)>=(c[n>>2]|0))break a}RI(2965048)|0;n=qL(2965048)|0;Rbg(n,c[892480]|0);Bvh(n)}}while(0);f=(d|0)!=0;if(!f?Gqh(2619552,suh(2879568,b)|0)|0:0){m=suh(2879568,b)|0;if(a[2540708]|0){s=c[892482]|0;t=c[892484]|0;u=hwf(0,s,m,t)|0;RI(3078904)|0;v=qL(3078904)|0;Brg(v,u);Bvh(v)}Evh(2540560);s=c[892482]|0;t=c[892484]|0;u=hwf(0,s,m,t)|0;RI(3078904)|0;v=qL(3078904)|0;Brg(v,u);Bvh(v)}if((e&512|0)!=0?Gqh(2653040,suh(2879568,b)|0)|0:0){e=suh(2879568,b)|0;if(a[2540708]|0){w=c[892486]|0;x=_vf(0,w,e)|0;RI(3078904)|0;y=qL(3078904)|0;Brg(y,x);Bvh(y)}Evh(2540560);w=c[892486]|0;x=_vf(0,w,e)|0;RI(3078904)|0;y=qL(3078904)|0;Brg(y,x);Bvh(y)}c[k>>2]=0;y=T3f(b,d,g,k)|0;g=c[k>>2]|0;if(!g){i=j;return (f?0:y)|0}else Bvh(g);return 0}function V3f(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Yvh(2879624,a,0,b,c,d,e)|0;i=f;return g|0}function W3f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;g=c[a+8>>2]|0;c[e>>2]=0;c[f>>2]=g;c[d+0>>2]=c[f+0>>2];Cwg(e,d);i=b;return c[e>>2]|0}function X3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=i3f(0,d)|0;i=b;return e|0}function Y3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=j3f(0,d)|0;i=b;return e|0}function Z3f(a){a=a|0;return c[a+16>>2]|0}function _3f(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+8>>2];c[d+0>>2]=c[e+0>>2];e=g3f(0,d)|0;i=b;return e|0}function $3f(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+12>>2]|0;if(!d)e=n3f(0,a)|0;else e=d;i=b;return e|0}function a4f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function b4f(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}e=jtg(0,b,c)|0;i=d;return e|0}function c4f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function d4f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;xkh();RI(2971904)|0;d=qL(2971904)|0;Gbg(d);Hbg(d,c[892562]|0)|0;Hbg(d,Fqh(2879680,a)|0)|0;Hbg(d,c[892564]|0)|0;e=xuh(2879512,a)|0;f=e+12|0;if((c[f>>2]|0)>0){g=e+16|0;h=0;do{if((h|0)>=1)Hbg(d,c[892566]|0)|0;Hbg(d,Fqh(2649752,suh(2849496,c[g+(da(c[(c[e>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0)|0)|0;h=h+1|0}while((h|0)<(c[f>>2]|0))}if((Aqh(2879736,a)|0)!=3){j=c[892570]|0;Hbg(d,j)|0;k=Fqh(2972072,d)|0;i=b;return k|0}Hbg(d,c[892568]|0)|0;j=c[892570]|0;Hbg(d,j)|0;k=Fqh(2972072,d)|0;i=b;return k|0}function e4f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;d=Fqh(2879680,a)|0;e=suh(2879792,a)|0;A1f(0,b,d,e,Fqh(2879848,a)|0,1,0);i=c;return}function f4f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[720270]|0;if(!f){g=MK(2881088)|0;c[720270]=g;h=g}else h=f;co[h&2047](b,d,e);i=a;return}function g4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;i=b;return}function h4f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function i4f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)i4f(e,b)|0;e=_n[c[a+8>>2]&4095](c[a+16>>2]|0,b)|0;i=d;return e|0}function j4f(a,b){a=a|0;b=b|0;Bvh(SJ(3131272)|0);return 0}function k4f(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function l4f(a,b){a=a|0;b=b|0;return 0}function m4f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a+36|0;if((c[e>>2]&b|0)==(b|0)){i=d;return}f4f(0,a,a+16|0,b);c[e>>2]=c[e>>2]|b;i=d;return}function n4f(a){a=a|0;var b=0;b=i;m4f(a,1);i=b;return c[a+32>>2]|0}function o4f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;m4f(a,6);d=c[a+24>>2]|0;if(!d){e=xuh(2849384,c[a+28>>2]|0)|0;f=suh(2849496,c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,(c[e+12>>2]|0)+-1|0)|0)>>2]|0)|0;i=b;return f|0}else{f=suh(2866472,d)|0;i=b;return f|0}return 0}function p4f(a){a=a|0;var b=0;b=i;m4f(a,8);i=b;return c[a+16>>2]|0}function q4f(a){a=a|0;var b=0;b=i;m4f(a,16);i=b;return c[a+16>>2]|0}function r4f(a){a=a|0;var b=0;b=i;m4f(a,32);i=b;return c[a+20>>2]|0}function s4f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;m4f(a,2);e=a+24|0;a=c[e>>2]|0;if(!((a|0)==0|b))if(Gqh(2863856,a)|0)f=c[e>>2]|0;else f=0;else f=a;i=d;return f|0}function t4f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;m4f(a,6);d=c[a+24>>2]|0;do if(!d){e=c[a+28>>2]|0;if(e){f=xuh(2849384,e)|0;RI(1137488)|0;e=Cvh(1137488,(c[f+12>>2]|0)+-1|0)|0;vEf(0,f,e,c[e+12>>2]|0);g=e;break}RI(1137488)|0;h=Cvh(1137488,0)|0;i=b;return h|0}else g=xuh(2849384,d)|0;while(0);d=g+12|0;if((c[d>>2]|0)<=0){h=g;i=b;return h|0}e=g+16|0;f=0;do{j=c[e+(da(c[(c[g>>2]|0)+120>>2]|0,f)|0)>>2]|0;RI(2819760)|0;k=qL(2819760)|0;u4f(k,j,a);Qqh(g,k);c[e+(da(c[(c[g>>2]|0)+120>>2]|0,f)|0)>>2]=k;f=f+1|0}while((f|0)<(c[d>>2]|0));h=g;i=b;return h|0}function u4f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+8>>2]=suh(2849496,b)|0;c[a+16>>2]=d;c[a+20>>2]=Fqh(2849440,b)|0;c[a+24>>2]=Aqh(2885576,b)|0;c[a+28>>2]=Aqh(2885632,b)|0;i=e;return}function v4f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;m4f(a,4);e=a+28|0;a=c[e>>2]|0;if(!((a|0)==0|b))if(Gqh(2863856,a)|0)f=c[e>>2]|0;else f=0;else f=a;i=d;return f|0}function w4f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}e=ktg(0,b,c,0)|0;i=d;return e|0}function x4f(b,c){b=b|0;c=c|0;var d=0;c=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}d=jtg(0,b,0)|0;i=c;return d|0}function y4f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}e=gtg(0,b,c,0)|0;i=d;return e|0}function z4f(b){b=b|0;var d=0,e=0,f=0;d=i;ykh();e=Fqh(2536192,suh(2883152,b)|0)|0;f=Fqh(2883208,b)|0;if(!(a[2540708]|0))Evh(2540560);b=iwf(0,e,c[892582]|0,f)|0;i=d;return b|0}function A4f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;d=Fqh(2883208,a)|0;e=suh(2883264,a)|0;A1f(0,b,d,e,Fqh(2883320,a)|0,16,0);i=c;return}function B4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function C4f(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+4|0;g=e;h=e+8|0;j=d+8|0;k=c[j>>2]|0;if(Gqh(2652984,k)|0){l=k;while(1){m=suh(2619720,l)|0;if(Gqh(2652984,m)|0)l=m;else{n=m;break}}}else n=k;if(!(Gqh(2653672,n)|0)){n=c[j>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[g>>2]=3431552;c[f+0>>2]=c[g+0>>2];if((n|0)!=(npf(0,f)|0)){f=Fqh(2653928,c[j>>2]|0)|0;n=Fqh(2653928,suh(2658656,c[d+16>>2]|0)|0)|0;if(!(a[2540708]|0))Evh(2540560);g=gpf(0,f,n)|0;n=c[j>>2]|0;if(g){o=n;p=11}else q=Fqh(2537592,n)|0}else p=9}else p=9;if((p|0)==9){o=c[j>>2]|0;p=11}if((p|0)==11)q=Fqh(2649752,o)|0;if(D4f(d)|0){r=q;i=e;return r|0}b[h>>1]=32;RI(2540392)|0;o=pL(2540392,h)|0;if(!(a[2540708]|0))Evh(2540560);h=fwf(0,q,o)|0;r=gwf(0,h,c[d+20>>2]|0)|0;i=e;return r|0}function D4f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2885632,a)|0)&8|0)!=0;i=b;return c|0}function E4f(a){a=a|0;return c[a+8>>2]|0}function F4f(a){a=a|0;return c[a+28>>2]|0}function G4f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2885632,a)|0)&1|0)!=0;i=b;return c|0}function H4f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2885632,a)|0)&16|0)!=0;i=b;return c|0}function I4f(a){a=a|0;var b=0,c=0;b=i;c=((Aqh(2885632,a)|0)&2|0)!=0;i=b;return c|0}function J4f(a){a=a|0;return c[a+16>>2]|0}function K4f(a){a=a|0;return c[a+20>>2]|0}function L4f(a){a=a|0;return c[a+24>>2]|0}function M4f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=gtg(0,b,c,d)|0;i=e;return f|0}function N4f(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Evh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function O4f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=G4f(a)|0;e=I4f(a)|0;f=((H4f(a)|0)&1)+(e?(d?2:1):d&1)|0;d=a+32|0;e=f+((c[d>>2]|0)!=0&1)|0;if(!e){g=0;i=b;return g|0}RI(1086352)|0;f=Cvh(1086352,e)|0;if(G4f(a)|0){RI(2665496)|0;e=qL(2665496)|0;Qqh(f,e);c[f+16>>2]=e;h=1}else h=0;if(H4f(a)|0){RI(2666144)|0;e=qL(2666144)|0;Qqh(f,e);c[f+16+(c[(c[f>>2]|0)+120>>2]&0-h)>>2]=e;j=h+1|0}else j=h;if(I4f(a)|0){RI(2663976)|0;a=qL(2663976)|0;Qqh(f,a);c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,j)|0)>>2]=a;k=j+1|0}else k=j;j=c[d>>2]|0;if(!j){g=f;i=b;return g|0}d=J$f(j)|0;Qqh(f,d);c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,k)|0)>>2]=d;g=f;i=b;return g|0}function P4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;c[a+8>>2]=0;c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2917752)|0;c[a+8>>2]=ML(c[729454]|0)|0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function Q4f(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a>>2]|0;if(!d)e=0;else e=d+16|0;c[b>>2]=e;return}function R4f(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=Zvh(2601984,c[a>>2]|0,1)|0;i=d;return}function S4f(a){a=a|0;return}function T4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2584640)|0;Kwf(a,sM(2887288)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function U4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function V4f(a){a=a|0;return 16}function W4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2819224)|0;RI(2918e3)|0;c[a+8>>2]=ML(c[729516]|0)|0;c[(c[d>>2]|0)+4>>2]=a;a=qL(2819056)|0;c[a+8>>2]=0;c[(c[d>>2]|0)+8>>2]=a;i=b;return}function X4f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;zkh();j=c[b+8>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Evh(2540728)}c[g>>2]=3439784;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[892586]|0,j,g);L7f(d,c[892588]|0,c[b+12>>2]|0);fag(d,c[892590]|0,(a[b+16>>0]|0)!=0);g=c[b+20>>2]|0;c[h>>2]=3439784;c[f+0>>2]=c[h+0>>2];h=npf(0,f)|0;q9f(d,c[892592]|0,g,h);i=e;return}function Y4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Z4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function $4f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function a5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function b5f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Ckh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[892692]|0);Bvh(e)}else{c[a+8>>2]=b;i=d;return}}function c5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function d5f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(3129672)|0;e=qL(3129672)|0;kyg(e,b);c[a+8>>2]=e;i=d;return}function e5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function f5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function g5f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function h5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,71);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function i5f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function j5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);c[c[d>>2]>>2]=a;i=b;return}function k5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function l5f(a){a=a|0;return}function m5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;i=b;return}function n5f(a){a=a|0;return}function o5f(a){a=a|0;return}function p5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function q5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;c[a+8>>2]=3;c[a+12>>2]=1;c[c[d>>2]>>2]=a;i=b;return}function r5f(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return}function s5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;c[a+8>>2]=3;c[a+12>>2]=2;c[c[d>>2]>>2]=a;i=b;return}function t5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1133);Cpf(a,0);c[c[d>>2]>>2]=a;i=b;return}function u5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function v5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,5);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function w5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function x5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,4);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function y5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function z5f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function A5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,960);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function B5f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function C5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,1024);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function D5f(a){a=a|0;var b=0;a=i;RI(2898976)|0;c[c[724767]>>2]=2;b=(pwg(rrg(0)|0)|0)==2;RI(2898976)|0;c[(c[724767]|0)+4>>2]=b?2:1;i=a;return}function E5f(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;a=i;i=i+16|0;g=a+4|0;h=a;j=c[724786]|0;if(!j){k=MK(2899152)|0;c[724786]=k;l=k}else l=j;c[h>>2]=c[b>>2];c[g+0>>2]=c[h+0>>2];Dn[l&511](g,d,e,f);i=a;return}function F5f(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+16|0;h=b+4|0;j=b;RI(2898976)|0;if(!(a[2899124]|0)){RI(2898976)|0;Evh(2898976)}c[j>>2]=c[d>>2];c[h+0>>2]=c[j+0>>2];E5f(0,h,f,e,g);i=b;return}function G5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2978248)|0;vcg(a);c[c[d>>2]>>2]=a;i=b;return}function H5f(a){a=a|0;return}function I5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,64);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function J5f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;n5f(b);c[b+12>>2]=c[d>>2];a[b+20>>0]=e&1;c[b+16>>2]=1;i=f;return}function K5f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+16|0;f=c[e>>2]|0;if(!f){g=Fqh(2537592,Xnf(b)|0)|0;RI(3112928)|0;h=qL(3112928)|0;kwg(h,g);_vh(h)}else j=f;while(1){f=j+-1|0;if((Ygg(0,e,f,j)|0)==(j|0)){k=f;break}j=c[e>>2]|0}if(k){i=d;return}if(!(a[b+20>>0]|0)){i=d;return}if(Gqh(2909808,b)|0){i=d;return}Gqh(2909864,b)|0;c[b+8>>2]=c[b+12>>2];c[e>>2]=-1;i=d;return}function L5f(a){a=a|0;var b=0;if((c[a+16>>2]|0)>0)return c[a+8>>2]|0;else{b=Fqh(2537592,Xnf(a)|0)|0;RI(3112928)|0;a=qL(3112928)|0;kwg(a,b);_vh(a)}return 0}function M5f(a){a=a|0;var b=0;b=i;zvh(2909920,a,1);Jrg(0,a);i=b;return}function N5f(a,b){a=a|0;b=b|0;var c=0;c=i;if(b)K5f(a);i=c;return}function O5f(a,b){a=a|0;b=b|0;c[a+8>>2]=c[b>>2];return}function P5f(b){b=b|0;var d=0;d=i;if((a[b+20>>0]|0)!=0?!(Gqh(2909808,b)|0):0){Gqh(2909864,b)|0;c[b+8>>2]=c[b+12>>2]}o5f(b);i=d;return}function Q5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function R5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function S5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function T5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function U5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function V5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function W5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function X5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Y5f(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=Fqh(2536192,b)|0;i=d;return}function Z5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,1024);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function _5f(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return}function $5f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,1);Dpf(a,0);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function a6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function b6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2898616)|0;B5f(a,1);c[c[d>>2]>>2]=a;a=qL(2911064)|0;RI(3021144)|0;Y5f(a,ML(c[755302]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539976)|0;zof(a,sM(2913680)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function c6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;a=qL(2898616)|0;B5f(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2911064)|0;RI(2819496)|0;Y5f(a,ML(c[704890]|0)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539976)|0;zof(a,sM(2913928)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function d6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539976)|0;zof(a,sM(2914176)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2911064)|0;RI(2818576)|0;Y5f(a,ML(c[704660]|0)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function e6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2842352)|0;Y5f(a,ML(c[710604]|0)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539976)|0;zof(a,sM(2914432)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function f6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2911064)|0;RI(2820392)|0;Y5f(a,ML(c[705114]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539976)|0;zof(a,sM(2914680)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function g6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;a=qL(2539976)|0;zof(a,sM(2914936)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2911064)|0;RI(2819928)|0;Y5f(a,ML(c[704998]|0)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function h6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2823616)|0;Y5f(a,ML(c[705920]|0)|0);c[c[d>>2]>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539976)|0;zof(a,sM(2915192)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function i6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2911064)|0;RI(2856912)|0;Y5f(a,ML(c[714244]|0)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539976)|0;zof(a,sM(2915440)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function j6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;a=qL(2911064)|0;RI(2826656)|0;Y5f(a,ML(c[706680]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539976)|0;zof(a,sM(2915688)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function k6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539976)|0;zof(a,sM(2915936)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2911064)|0;RI(2828024)|0;Y5f(a,ML(c[707022]|0)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function l6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2855432)|0;Y5f(a,ML(c[713874]|0)|0);c[c[d>>2]>>2]=a;a=qL(2539976)|0;zof(a,sM(2916184)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function m6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2832640)|0;Y5f(a,ML(c[708176]|0)|0);c[c[d>>2]>>2]=a;a=qL(2539976)|0;zof(a,sM(2916432)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function n6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539976)|0;zof(a,sM(2916680)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2911064)|0;RI(2834864)|0;Y5f(a,ML(c[708732]|0)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function o6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2835448)|0;Y5f(a,ML(c[708878]|0)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539976)|0;zof(a,sM(2916928)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function p6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2911064)|0;RI(2820208)|0;Y5f(a,ML(c[705068]|0)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539976)|0;zof(a,sM(2917168)|0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function q6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2835720)|0;Y5f(a,ML(c[708946]|0)|0);c[c[d>>2]>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539976)|0;zof(a,sM(2917416)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function r6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(2819760)|0;Y5f(a,ML(c[704956]|0)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539976)|0;zof(a,sM(2917672)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function s6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2911064)|0;RI(2884456)|0;Y5f(a,ML(c[721130]|0)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539976)|0;zof(a,sM(2917920)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function t6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2911064)|0;RI(3013496)|0;Y5f(a,ML(c[753390]|0)|0);c[c[d>>2]>>2]=a;a=qL(2539976)|0;zof(a,sM(2918168)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+8>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function u6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2898616)|0;B5f(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2539976)|0;zof(a,sM(2918408)|0);c[(c[d>>2]|0)+8>>2]=a;a=qL(2911064)|0;RI(2837096)|0;Y5f(a,ML(c[709290]|0)|0);c[(c[d>>2]|0)+12>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+16>>2]=a;i=b;return}function v6f(a){a=a|0;var b=0;a=i;RI(2918656)|0;if(!(c[c[729687]>>2]|0)){RI(2918824)|0;b=qL(2918824)|0;RI(2918656)|0;c[c[729687]>>2]=b}RI(2918656)|0;i=a;return c[c[729687]>>2]|0}function w6f(a){a=a|0;return}function x6f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;Dkh();f=e+12|0;if((c[f>>2]|0)>0){g=e+16|0;h=0;j=0;while(1){k=c[g+(da(c[(c[e>>2]|0)+120>>2]|0,j)|0)>>2]|0;RI(2918992)|0;if(!(vL(k,2918992)|0)){l=3;break}RI(2919328)|0;if(!(vL(k,2919328)|0))m=h;else{RI(2919328)|0;m=c[($vh(k,2919328)|0)+12>>2]|0}j=j+1|0;if((j|0)>=(c[f>>2]|0)){n=m;break}else h=m}if((l|0)==3){RI(2919160)|0;l=qL(2919160)|0;Grg(l,c[892704]|0);_vh(l)}if(n)Pnf(0,d,n,e,c[892706]|0)|0}RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}n=A6f(0,d)|0;if(n){RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}o=B6f(0,n,e)|0;i=b;return o|0}if(!(Gqh(2653336,d)|0)){o=0;i=b;return o|0}RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}o=C6f(0,d,e)|0;i=b;return o|0}function y6f(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function z6f(a){a=a|0;return c[a+12>>2]|0}function A6f(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}RI(2919496)|0;e=c[(c[729897]|0)+32>>2]|0;Jag(0,e);RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}RI(2919496)|0;f=uth(2736488,c[(c[729897]|0)+20>>2]|0,d)|0;RI(2941648)|0;d=vL(f,2941648)|0;Kag(0,e);i=b;return d|0}function B6f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;Vkh();if(!e)Pnf(0,c[d+20>>2]|0,c[d+16>>2]|0,0,c[893374]|0)|0;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;awh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);Irh(2714840,b,e);e=c[d+20>>2]|0;f=c[d+16>>2]|0;d=qvh(2715008,b)|0;Pnf(0,e,f,d,c[893372]|0)|0;return 0}function C6f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;i=i+16|0;f=b+4|0;g=b;if(Gqh(2653336,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[g>>2]=3449280;c[f+0>>2]=c[g+0>>2];g=nof(0,d,npf(0,f)|0,1)|0;RI(2938720)|0;f=$vh(g,2938720)|0;if(f){h=bwh(2938904,f,d)|0;i=b;return h|0}}RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2938496)|0;if(!(a[2938644]|0)){RI(2938496)|0;awh(2938496)}RI(2938496)|0;f=qL(2938496)|0;RI(2920392)|0;A8f(f,d,c[(c[730121]|0)+12>>2]|0,e);h=bth(2938664,f)|0;i=b;return h|0}function D6f(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;RI(2919832)|0;g=qL(2919832)|0;E6f(g,d);h=Gqh(2653336,d)|0;j=v6f(0)|0;if(!h){RI(292e4)|0;h=qL(292e4)|0;c[h+8>>2]=e;c[h+12>>2]=j;Irh(2920168,g,h);a[g+68>>0]=0;i=b;return g|0}RI(2920224)|0;h=qL(2920224)|0;c[h+8>>2]=j;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;awh(2713640)}RI(2713640)|0;j=qL(2713640)|0;$Lf(j);if(f)Irh(2714840,j,f);RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}if(!(a[2540708]|0))awh(2540560);RI(2920392)|0;f=gpf(0,e,c[(c[730121]|0)+12>>2]|0)|0;k=f&1;RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;awh(3013496)}l=ghg(0)|0;do if(f){m=bth(2714784,j)|0;while(1){if(!(jth(2568176,m)|0)){n=k;break}o=Sqh(2568120,m)|0;RI(2918992)|0;if(!(cwh(2920560,$vh(o,2918992)|0,l,g)|0)){n=0;break}}RI(2568648)|0;o=vL(m,2568648)|0;if(!o){if(165==165){p=n<<24>>24!=0;q=0;break}_vh(0)}else{kth(2568816,o);if(165==165){p=n<<24>>24!=0;q=0;break}_vh(0)}}else{p=0;q=0}while(0);n=Lvh(2658864,d,1)|0;d=n+12|0;if((c[d>>2]|0)>0){k=n+16|0;f=0;o=p;while(1){r=c[k+(da(c[(c[n>>2]|0)+120>>2]|0,f)|0)>>2]|0;RI(2918992)|0;if(!(vL(r,2918992)|0))s=o;else{if(o){RI(2918992)|0;t=cwh(2920560,$vh(r,2918992)|0,l,g)|0}else t=0;Erh(2714056,j,r)|0;s=t}f=f+1|0;if((f|0)>=(c[d>>2]|0)){u=s;break}else o=s}}else u=p;do if(!u){c[g+52>>2]=qvh(2715008,j)|0;p=bth(2714784,j)|0;while(1){if(!(jth(2568176,p)|0))break;s=Sqh(2568120,p)|0;RI(2918992)|0;xth(2920616,$vh(s,2918992)|0,g)}RI(2568648)|0;m=vL(p,2568648)|0;if(!m){if(324==324)break;_vh(q)}else{kth(2568816,m);if(324==324)break;_vh(q)}}while(0);RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}if(!(a[2540708]|0))awh(2540560);RI(2920392)|0;if(Iwf(0,e,c[(c[730121]|0)+12>>2]|0)|0){RI(292e4)|0;q=qL(292e4)|0;c[q+8>>2]=e;c[q+12>>2]=h;v=q}else v=h;Irh(2920168,g,v);a[g+68>>0]=u&1;i=b;return g|0}function E6f(b,d){b=b|0;d=d|0;var e=0;e=i;c[b+60>>2]=d;c[b+64>>2]=Fqh(2652904,d)|0;a[b+68>>0]=1;i=e;return}function F6f(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return}function G6f(b,c){b=b|0;c=c|0;a[b+68>>0]=c&1;return}function H6f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function I6f(a,b){a=a|0;b=b|0;c[a+52>>2]=b;return}function J6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function K6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function L6f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2919328)|0;if(!(vL(d,2919328)|0)){f=0;i=e;return f|0}RI(2919328)|0;g=c[($vh(d,2919328)|0)+12>>2]|0;d=c[b+12>>2]|0;if(!(a[2540708]|0))awh(2540560);f=gpf(0,g,d)|0;i=e;return f|0}function M6f(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2582544,c[a+12>>2]|0)|0;i=b;return d|0}function N6f(a,b){a=a|0;b=b|0;return}function O6f(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function P6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Q6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function R6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function S6f(b){b=b|0;var d=0;d=i;RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}c[b+8>>2]=T6f(0)|0;i=d;return}function T6f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;b=i;RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;awh(2713640)}RI(2713640)|0;d=qL(2713640)|0;$Lf(d);RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2920392)|0;e=bth(2714e3,c[c[730121]>>2]|0)|0;Jag(0,e);RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2920392)|0;f=bth(2714784,c[c[730121]>>2]|0)|0;while(1){if(!(jth(2568176,f)|0))break;g=Sqh(2568120,f)|0;RI(2924448)|0;h=vL(g,2924448)|0;if(!h)continue;g=Sqh(2924672,h)|0;if(!g)continue;Erh(2714056,d,g)|0}RI(2568648)|0;g=vL(f,2568648)|0;if(!g)if(108==108){Kag(0,e);j=qvh(2715008,d)|0;i=b;return j|0}else FJ(0);else{kth(2568816,g);if(108==108){Kag(0,e);j=qvh(2715008,d)|0;i=b;return j|0}else FJ(0)}return 0}function U6f(b){b=b|0;var d=0,e=0;b=i;Ekh();RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;awh(2713640)}RI(2713640)|0;d=qL(2713640)|0;$Lf(d);RI(2920392)|0;c[c[730121]>>2]=d;RI(2713640)|0;d=qL(2713640)|0;$Lf(d);RI(2920392)|0;c[(c[730121]|0)+4>>2]=d;RI(2923776)|0;d=qL(2923776)|0;RI(2920392)|0;c[(c[730121]|0)+8>>2]=d;d=c[892804]|0;RI(2920392)|0;c[(c[730121]|0)+12>>2]=d;RI(1094176)|0;d=dwh(1094176,2)|0;Qqh(d,c[892806]|0);e=d+16|0;c[e>>2]=c[892806];Qqh(d,c[892808]|0);c[e+(c[(c[d>>2]|0)+120>>2]|0)>>2]=c[892808];RI(2920392)|0;c[(c[730121]|0)+16>>2]=d;i=b;return}function V6f(a){a=a|0;return}function W6f(b,c){b=b|0;c=c|0;b=i;RI(2920392)|0;if(a[2920540]|0){X6f(0,c,0);i=b;return}RI(2920392)|0;awh(2920392);X6f(0,c,0);i=b;return}function X6f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;Fkh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[892862]|0);_vh(f)}do if(e){RI(2923944)|0;f=vL(d,2923944)|0;if(f){fwh(2924168,f,1);break}f=ewh(2924112,d)|0;if(a[2540708]|0){g=c[892864]|0;h=_vf(0,g,f)|0;RI(2919160)|0;j=qL(2919160)|0;Grg(j,h);_vh(j)}awh(2540560);g=c[892864]|0;h=_vf(0,g,f)|0;RI(2919160)|0;j=qL(2919160)|0;Grg(j,h);_vh(j)}while(0);RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2920392)|0;j=bth(2714e3,c[c[730121]>>2]|0)|0;Jag(0,j);h=-1;g=0;while(1){RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2920392)|0;if((g|0)>=(Aqh(2713056,c[c[730121]>>2]|0)|0)){k=h;break}RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2920392)|0;e=Krh(2713112,c[c[730121]>>2]|0,g)|0;RI(2924224)|0;f=$vh(e,2924224)|0;e=ewh(2924112,f)|0;l=ewh(2924112,d)|0;if(!(a[2540708]|0))awh(2540560);if(gpf(0,e,l)|0){l=ewh(2924112,d)|0;if(!(a[2540708]|0))awh(2540560);if(Iwf(0,l,c[c[635163]>>2]|0)|0){m=f;n=19;break}}l=cth(2924392,f)|0;f=(l|0)>=(cth(2924392,d)|0)|(h|0)!=-1;h=f?h:g;g=g+1|0}if((n|0)==19){n=ewh(2924112,m)|0;if(a[2540708]|0){o=c[892866]|0;p=c[892868]|0;q=iwf(0,o,n,p)|0;RI(2919160)|0;r=qL(2919160)|0;Grg(r,q);FJ(r)}awh(2540560);o=c[892866]|0;p=c[892868]|0;q=iwf(0,o,n,p)|0;RI(2919160)|0;r=qL(2919160)|0;Grg(r,q);FJ(r)}RI(2920392)|0;r=(a[2920540]|0)==0;if((k|0)==-1){if(r){RI(2920392)|0;awh(2920392)}RI(2920392)|0;Erh(2714056,c[c[730121]>>2]|0,d)|0}else{if(r){RI(2920392)|0;awh(2920392)}RI(2920392)|0;Jrh(2714392,c[c[730121]>>2]|0,k,d)}RI(2924448)|0;k=vL(d,2924448)|0;if(!k){Kag(0,j);i=b;return}RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}r=Fqh(2536192,Xnf(d)|0)|0;RI(2920392)|0;if(!(gwh(2648080,c[(c[730121]|0)+16>>2]|0,r)|0)){Kag(0,j);i=b;return}xth(2924616,k,0);Kag(0,j);i=b;return}function Y6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Z6f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(2925280)|0);c[c[d>>2]>>2]=a;i=b;return}function _6f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;c[f>>2]=0;RI(2540224)|0;c[b+8>>2]=pL(2540224,f)|0;c[b+12>>2]=d;RI(2919496)|0;if(a[2919644]|0){g=$6f(0)|0;h=b+16|0;c[h>>2]=g;i=e;return}RI(2919496)|0;awh(2919496);g=$6f(0)|0;h=b+16|0;c[h>>2]=g;i=e;return}function $6f(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}RI(2919496)|0;if(!(c[(c[729897]|0)+8>>2]|0)){d=big(0)|0;RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}RI(2919496)|0;c[(c[729897]|0)+8>>2]=d}RI(2919496)|0;if(a[2919644]|0){RI(2919496)|0;e=c[729897]|0;f=e+8|0;g=c[f>>2]|0;i=b;return g|0}RI(2919496)|0;awh(2919496);RI(2919496)|0;e=c[729897]|0;f=e+8|0;g=c[f>>2]|0;i=b;return g|0}function a7f(a){a=a|0;return}function b7f(a){a=a|0;var b=0;a=i;RI(2536312)|0;b=qL(2536312)|0;RI(2925896)|0;c[c[731497]>>2]=b;i=a;return}function c7f(b){b=b|0;var d=0,e=0;b=i;RI(2925896)|0;if(!(a[2926044]|0)){RI(2925896)|0;awh(2925896)}RI(2925896)|0;d=c[c[731497]>>2]|0;Jag(0,d);RI(2925896)|0;if(!(a[2926044]|0)){RI(2925896)|0;awh(2925896)}RI(2925896)|0;e=qL(2925896)|0;RI(2920392)|0;if(a[2920540]|0){W6f(0,e);Kag(0,d);i=b;return}RI(2920392)|0;awh(2920392);W6f(0,e);Kag(0,d);i=b;return}function d7f(a){a=a|0;a=i;Gkh();i=a;return c[892924]|0}function e7f(a){a=a|0;return 100}function f7f(b){b=b|0;var c=0,d=0;b=i;RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;awh(3013496)}c=khg(0)|0;RI(2925480)|0;d=qL(2925480)|0;_6f(d,c);i=b;return d|0}function g7f(a,b){a=a|0;b=b|0;return}function h7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function i7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function j7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function k7f(b){b=b|0;var d=0;b=i;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;awh(2730168)}RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2927232)|0;c[c[731831]>>2]=d;i=b;return}function l7f(a){a=a|0;return}function m7f(a){a=a|0;var b=0;a=i;b=$hg(0)|0;i=a;return b|0}function n7f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+12>>2]|0;if(!f){g=0;i=e;return g|0}b=bth(2714784,f)|0;while(1){if(!(jth(2568176,b)|0)){h=0;j=82;break}f=Sqh(2568120,b)|0;RI(2927400)|0;k=$vh(f,2927400)|0;f=ewh(2927568,k)|0;if(!(a[2540708]|0))awh(2540560);if(gpf(0,f,d)|0){h=k;j=84;break}}RI(2568648)|0;d=vL(b,2568648)|0;do if(!d)if((j|0)==84)break;else if((j|0)==82){g=0;i=e;return g|0}else _vh(0);else{kth(2568816,d);if((j|0)==84)break;else if((j|0)==82){g=0;i=e;return g|0}else _vh(0)}while(0);g=h;i=e;return g|0}function o7f(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;Hkh();c[e>>2]=c[b+8>>2];RI(2540224)|0;b=pL(2540224,e)|0;if(!(a[2540708]|0))awh(2540560);e=fwf(0,c[892932]|0,b)|0;i=d;return e|0}function p7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function q7f(a){a=a|0;return c[a+8>>2]|0}function r7f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(!d){f=0;i=e;return f|0}RI(2923160)|0;if(!(vL(d,2923160)|0)){f=0;i=e;return f|0}RI(2923160)|0;g=c[($vh(d,2923160)|0)+8>>2]|0;d=c[b+8>>2]|0;if(!(a[2540708]|0))awh(2540560);f=(Iwf(0,g,d)|0)^1;i=e;return f|0}function s7f(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(!d){e=0;i=b;return e|0}e=Aqh(2582544,d)|0;i=b;return e|0}function t7f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Ikh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[892942]|0);_vh(e)}else{Zqh(2647952,Sqh(2922232,b)|0,a)|0;i=d;return}}function u7f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Jkh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[892950]|0);_vh(f)}if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[892952]|0);_vh(f)}if(!(Gqh(2653336,hwh(2922152,d)|0)|0)){g=1;i=e;return g|0}d=iwh(2927976,b,c[a+8>>2]|0)|0;if(!d){g=0;i=e;return g|0}g=(a|0)==(d|0);i=e;return g|0}function v7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,4);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function w7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function x7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function y7f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;c[a+16>>2]=b;f=xuh(2849384,b)|0;RI(1101728)|0;b=f+12|0;g=a+8|0;c[g>>2]=dwh(1101728,c[b>>2]|0)|0;h=a+12|0;c[h>>2]=0;a=(c[b>>2]|0)>0;if(!(d<<24>>24)){if(!a){i=e;return}d=f+16|0;j=0;do{if(!(Gqh(2653184,suh(2849496,c[d+(da(c[(c[f>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0)|0)){k=c[g>>2]|0;l=c[h>>2]|0;c[h>>2]=l+1;c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,l)|0)>>2]=j}j=j+1|0}while((j|0)<(c[b>>2]|0));i=e;return}if(!a){i=e;return}a=f+16|0;j=0;do{if(!(!(Gqh(2653184,suh(2849496,c[a+(da(c[(c[f>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0)|0)?!(I4f(c[a+(da(c[(c[f>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0):0)){d=c[g>>2]|0;l=c[h>>2]|0;c[h>>2]=l+1;c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,l)|0)>>2]=j}j=j+1|0}while((j|0)<(c[b>>2]|0));i=e;return}function z7f(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;a=c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,b)|0)>>2]|0;return a|0}function A7f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=xuh(2849384,c[a+16>>2]|0)|0;f=c[a+8>>2]|0;a=c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,b)|0)>>2]|0;b=Fqh(2849440,c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,a)|0)>>2]|0)|0;i=d;return b|0}function B7f(a){a=a|0;return c[a+12>>2]|0}function C7f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=a+12|0;f=c[e>>2]|0;RI(1086352)|0;g=dwh(1086352,f)|0;if((c[e>>2]|0)<=0){i=d;return g|0}f=a+8|0;a=b+16|0;h=g+16|0;j=0;do{k=c[f>>2]|0;l=k+16|0;m=c[l+(da(c[(c[k>>2]|0)+120>>2]|0,j)|0)>>2]|0;Qqh(g,c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]|0);m=c[l+(da(c[(c[k>>2]|0)+120>>2]|0,j)|0)>>2]|0;k=c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]|0;c[h+(da(c[(c[g>>2]|0)+120>>2]|0,j)|0)>>2]=k;j=j+1|0}while((j|0)<(c[e>>2]|0));i=d;return g|0}function D7f(a){a=a|0;return c[a+8>>2]|0}function E7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function F7f(a){a=a|0;return}function G7f(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+60|0;f=c[e>>2]|0;if(f){g=f;i=d;return g|0}f=c[b+64>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}b=MGf(0,f)|0;c[e>>2]=b;g=b;i=d;return g|0}function H7f(a,b){a=a|0;b=b|0;c[a+48>>2]=b;return}function I7f(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+56|0;b=c[e>>2]|0;if(b){f=b;i=d;return f|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;awh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);c[e>>2]=b;f=b;i=d;return f|0}function J7f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;Kkh();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];K7f(a,b,f);f=c[a+56>>2]|0;if(!f)k=0;else{g=(cth(2647352,f)|0)==0;k=g?0:f}L7f(b,c[892958]|0,c[a+48>>2]|0);L7f(b,c[892960]|0,c[a+52>>2]|0);L7f(b,c[892962]|0,0);L7f(b,c[892964]|0,k);L7f(b,c[892966]|0,c[a+64>>2]|0);i=e;return}function K7f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=e;c[f>>2]=0;c[f+4>>2]=0;Mkh();L7f(b,c[893032]|0,c[a+12>>2]|0);L7f(b,c[893034]|0,c[a+16>>2]|0);L7f(b,c[893036]|0,c[a+24>>2]|0);L7f(b,c[893038]|0,c[a+20>>2]|0);L7f(b,c[893040]|0,c[a+32>>2]|0);L7f(b,c[893042]|0,c[a+8>>2]|0);L7f(b,c[893044]|0,c[a+40>>2]|0);f=c[a+44>>2]|0;if(!f){i=d;return}a=Sqh(2733848,f)|0;while(1){if(!(jth(2568176,a)|0))break;f=Sqh(2568120,a)|0;RI(2729368)|0;g=jwh(f,2729368)|0;f=c[g+4>>2]|0;h=e;c[h>>2]=c[g>>2];c[h+4>>2]=f;f=MOf(e)|0;h=NOf(e)|0;L7f(b,$vh(f,2540560)|0,h)}RI(2568648)|0;b=vL(a,2568648)|0;if(!b)if(206==206){i=d;return}else _vh(0);else{kth(2568816,b);if(206==206){i=d;return}else _vh(0)}}function L7f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;if(e){q9f(b,d,e,Xnf(e)|0);i=f;return}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[h>>2]=3432408;c[g+0>>2]=c[h+0>>2];q9f(b,d,0,npf(0,g)|0);i=f;return}function M7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function N7f(a){a=a|0;return}function O7f(a){a=a|0;var b=0;a=i;RI(2931968)|0;b=qL(2931968)|0;RI(2931968)|0;c[c[733015]>>2]=b;i=a;return}function P7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Q7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function R7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function S7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function T7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function U7f(a){a=a|0;var b=0;b=i;RI(2934128)|0;c[a+12>>2]=qL(2934128)|0;i=b;return}function V7f(a){a=a|0;return}function W7f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=e;c[f>>2]=0;c[f+4>>2]=0;Lkh();L7f(b,c[893020]|0,c[a+12>>2]|0);f=c[a+8>>2]|0;if(!f){i=d;return}a=bth(2734184,f)|0;while(1){if(!(jth(2568176,a)|0))break;f=Sqh(2568120,a)|0;RI(2729368)|0;g=jwh(f,2729368)|0;f=c[g+4>>2]|0;h=e;c[h>>2]=c[g>>2];c[h+4>>2]=f;f=MOf(e)|0;h=NOf(e)|0;L7f(b,$vh(f,2540560)|0,h)}RI(2568648)|0;b=vL(a,2568648)|0;if(!b)if(104==104){i=d;return}else _vh(0);else{kth(2568816,b);if(104==104){i=d;return}else _vh(0)}}function X7f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Y7f(a){a=a|0;return c[(c[a+20>>2]|0)+12>>2]|0}function Z7f(a){a=a|0;return c[a+20>>2]|0}function _7f(a){a=a|0;var b=0;b=i;Aqh(2836512,zuh(2934952,a)|0)|0;i=b;return 1}function $7f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+36|0;e=c[d>>2]|0;if(!e){f=c[a+28>>2]|0;RI(2929560)|0;a=qL(2929560)|0;y7f(a,f,0);c[d>>2]=a;g=a}else g=e;i=b;return c[g+12>>2]|0}function a8f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+36|0;e=c[d>>2]|0;if(!e){f=c[a+28>>2]|0;RI(2929560)|0;g=qL(2929560)|0;y7f(g,f,0);c[d>>2]=g;h=g}else h=e;e=C7f(h,c[a+20>>2]|0)|0;i=b;return e|0}function b8f(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+32|0;a=c[d>>2]|0;if(a){e=a;i=b;return e|0}RI(2934304)|0;a=qL(2934304)|0;U7f(a);c[d>>2]=a;e=a;i=b;return e|0}function c8f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+28|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}d8f(a);f=c[d>>2]|0;i=b;return f|0}function d8f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;Nkh();e=b+8|0;f=c[e>>2]|0;RI(2919664)|0;g=(a[2919812]|0)==0;if(!f){if(g){RI(2919664)|0;awh(2919664)}h=q8f(0,b)|0;c[b+28>>2]=h;if(!h){h=c[b+16>>2]|0;j=Fqh(2935008,b)|0;if(a[2540708]|0){k=c[893118]|0;l=c[893120]|0;m=jwf(0,k,h,l,j)|0;RI(2919160)|0;n=qL(2919160)|0;Grg(n,m);_vh(n)}awh(2540560);k=c[893118]|0;l=c[893120]|0;m=jwf(0,k,h,l,j)|0;RI(2919160)|0;n=qL(2919160)|0;Grg(n,m);_vh(n)}}else{if(g){RI(2919664)|0;awh(2919664)}g=m8f(0,f)|0;f=b+12|0;n=c[f>>2]|0;if(!g){m=(a[2540708]|0)==0;if(!n){if(m)awh(2540560);o=c[c[635163]>>2]|0}else{if(m)awh(2540560);o=iwf(0,c[893096]|0,n,c[893098]|0)|0}m=c[e>>2]|0;if(a[2540708]|0){p=c[893100]|0;q=c[893102]|0;r=jwf(0,p,o,q,m)|0;RI(2919160)|0;s=qL(2919160)|0;Grg(s,r);_vh(s)}awh(2540560);p=c[893100]|0;q=c[893102]|0;r=jwf(0,p,o,q,m)|0;RI(2919160)|0;s=qL(2919160)|0;Grg(s,r);_vh(s)}s=n8f(0,n,g)|0;if(!s){RI(1094176)|0;n=dwh(1094176,5)|0;Qqh(n,c[893104]|0);r=n+16|0;c[r>>2]=c[893104];m=c[f>>2]|0;Qqh(n,m);c[r+(c[(c[n>>2]|0)+120>>2]|0)>>2]=m;Qqh(n,c[893106]|0);c[r+(c[(c[n>>2]|0)+120>>2]<<1)>>2]=c[893106];m=Fqh(2537592,g)|0;Qqh(n,m);c[r+((c[(c[n>>2]|0)+120>>2]|0)*3|0)>>2]=m;Qqh(n,c[893108]|0);c[r+(c[(c[n>>2]|0)+120>>2]<<2)>>2]=c[893108];if(a[2540708]|0){t=lwf(0,n)|0;RI(2919160)|0;u=qL(2919160)|0;Grg(u,t);_vh(u)}awh(2540560);t=lwf(0,n)|0;RI(2919160)|0;u=qL(2919160)|0;Grg(u,t);_vh(u)}u=b+16|0;t=c[u>>2]|0;n=c[b+24>>2]|0;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}r=o8f(0,s,t,n)|0;n=b+28|0;c[n>>2]=r;if(!r){RI(1086352)|0;r=dwh(1086352,4)|0;Qqh(r,c[893110]|0);t=r+16|0;c[t>>2]=c[893110];m=c[u>>2]|0;Qqh(r,m);c[t+(c[(c[r>>2]|0)+120>>2]|0)>>2]=m;Qqh(r,c[893112]|0);c[t+(c[(c[r>>2]|0)+120>>2]<<1)>>2]=c[893112];Qqh(r,s);c[t+((c[(c[r>>2]|0)+120>>2]|0)*3|0)>>2]=s;if(a[2540708]|0){v=eqf(0,r)|0;RI(2919160)|0;w=qL(2919160)|0;Grg(w,v);_vh(w)}awh(2540560);v=eqf(0,r)|0;RI(2919160)|0;w=qL(2919160)|0;Grg(w,v);_vh(w)}if(((s|0)!=(g|0)?Gqh(2650088,s)|0:0)?!(Gqh(2650088,g)|0):0){s=c[n>>2]|0;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}w=p8f(0,g,s)|0;c[n>>2]=w;if(!w){RI(1086352)|0;w=dwh(1086352,4)|0;Qqh(w,c[893114]|0);n=w+16|0;c[n>>2]=c[893114];s=c[u>>2]|0;Qqh(w,s);c[n+(c[(c[w>>2]|0)+120>>2]|0)>>2]=s;Qqh(w,c[893116]|0);c[n+(c[(c[w>>2]|0)+120>>2]<<1)>>2]=c[893116];Qqh(w,g);c[n+((c[(c[w>>2]|0)+120>>2]|0)*3|0)>>2]=g;if(a[2540708]|0){x=eqf(0,w)|0;RI(2919160)|0;y=qL(2919160)|0;Grg(y,x);_vh(y)}awh(2540560);x=eqf(0,w)|0;RI(2919160)|0;y=qL(2919160)|0;Grg(y,x);_vh(y)}}}y=b+28|0;if(!(Gqh(2864864,c[y>>2]|0)|0)){i=d;return}if(!(Gqh(2864808,c[y>>2]|0)|0)){i=d;return}if(!(r8f(b)|0)){RI(2919160)|0;x=qL(2919160)|0;Grg(x,c[893122]|0);_vh(x)}x=c[y>>2]|0;w=r8f(b)|0;RI(2834864)|0;c[y>>2]=kwh(2866544,$vh(x,2834864)|0,w)|0;i=d;return}function e8f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+16|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=Fqh(2649752,c[a+28>>2]|0)|0;c[d>>2]=e;f=e;i=b;return f|0}function f8f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+24|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=c[a+28>>2]|0;if(!e){f=0;i=b;return f|0}a=xuh(2849384,e)|0;RI(1104624)|0;e=a+12|0;g=dwh(1104624,c[e>>2]|0)|0;c[d>>2]=g;if((c[e>>2]|0)<=0){f=g;i=b;return f|0}h=a+16|0;j=g;g=0;while(1){k=suh(2849496,c[h+(da(c[(c[a>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0;Qqh(j,k);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,g)|0)>>2]=k;g=g+1|0;k=c[d>>2]|0;if((g|0)>=(c[e>>2]|0)){f=k;break}else j=k}i=b;return f|0}function g8f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=Fqh(2652904,suh(2658656,c[a+28>>2]|0)|0)|0;c[d>>2]=e;f=e;i=b;return f|0}function h8f(a){a=a|0;return c[a+8>>2]|0}function i8f(a,b){a=a|0;b=b|0;var d=0;d=c[a+20>>2]|0;a=c[d+16+(da(c[(c[d>>2]|0)+120>>2]|0,b)|0)>>2]|0;return a|0}function j8f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=xuh(2849384,c[a+28>>2]|0)|0;a=Fqh(2849440,c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,b)|0)>>2]|0)|0;i=d;return a|0}function k8f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+36|0;f=c[e>>2]|0;if(!f){g=c[a+28>>2]|0;RI(2929560)|0;h=qL(2929560)|0;y7f(h,g,0);c[e>>2]=h;j=h}else j=f;f=c[a+20>>2]|0;a=c[j+8>>2]|0;j=c[a+16+(da(c[(c[a>>2]|0)+120>>2]|0,b)|0)>>2]|0;b=c[f+16+(da(c[(c[f>>2]|0)+120>>2]|0,j)|0)>>2]|0;i=d;return b|0}function l8f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+36|0;f=c[e>>2]|0;if(!f){g=c[a+28>>2]|0;RI(2929560)|0;a=qL(2929560)|0;y7f(a,g,0);c[e>>2]=a;h=a}else h=f;f=qth(2930024,h,b)|0;i=d;return f|0}function m8f(b,d){b=b|0;d=d|0;var e=0,f=0;b=i;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}e=D9f(0,d)|0;RI(2947048)|0;d=vL(e,2947048)|0;if(!d){f=0;i=b;return f|0}f=c[d+24>>2]|0;i=b;return f|0}function n8f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;f=s8f(0,d)|0;d=Fqh(2537592,e)|0;if(!(a[2540708]|0))awh(2540560);if(gpf(0,f,d)|0){g=e;i=b;return g|0}d=suh(2651176,e)|0;a:do if(d){h=d;while(1){j=Fqh(2537592,h)|0;if(!(a[2540708]|0))awh(2540560);if(gpf(0,f,j)|0){g=h;break}h=suh(2651176,h)|0;if(!h)break a}i=b;return g|0}while(0);d=cvh(2655112,e)|0;e=d+12|0;if((c[e>>2]|0)<=0){g=0;i=b;return g|0}h=d+16|0;j=0;while(1){k=c[h+(da(c[(c[d>>2]|0)+120>>2]|0,j)|0)>>2]|0;l=Fqh(2537592,k)|0;if(!(a[2540708]|0))awh(2540560);j=j+1|0;if(gpf(0,f,l)|0){g=k;m=15;break}if((j|0)>=(c[e>>2]|0)){g=0;m=15;break}}if((m|0)==15){i=b;return g|0}return 0}function o8f(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;b=i;Ukh();if(Gqh(2650088,d)|0){RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}g=F9f(0,d,e,f)|0;i=b;return g|0}h=(f|0)!=0;RI(2919664)|0;j=(a[2919812]|0)!=0;if(h){if(!j){RI(2919664)|0;awh(2919664)}RI(2919664)|0;k=lwh(2655552,d,e,c[(c[729939]|0)+20>>2]|0,0,f,0)|0}else{if(!j){RI(2919664)|0;awh(2919664)}RI(2919664)|0;k=Nvh(2655432,d,e,c[(c[729939]|0)+20>>2]|0)|0}if(k){g=k;i=b;return g|0}if(!(a[2540708]|0))awh(2540560);if(gpf(0,e,c[893366]|0)|0){RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}RI(2919664)|0;g=c[(c[729939]|0)+24>>2]|0;i=b;return g|0}if(!(a[2540708]|0))awh(2540560);k=gpf(0,e,c[893368]|0)|0;RI(2919664)|0;e=a[2919812]|0;if(k){if(!(e<<24>>24)){RI(2919664)|0;awh(2919664)}RI(2919664)|0;g=c[(c[729939]|0)+28>>2]|0;i=b;return g|0}k=e<<24>>24!=0;if(h){if(!k){RI(2919664)|0;awh(2919664)}RI(2919664)|0;g=mwh(2656408,d,c[(c[729939]|0)+20>>2]|0,0,f,0)|0;i=b;return g|0}if(!k){RI(2919664)|0;awh(2919664)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}RI(2919664)|0;k=c[(c[729939]|0)+20>>2]|0;RI(2540728)|0;g=mwh(2656408,d,k,0,c[(c[635205]|0)+8>>2]|0,0)|0;i=b;return g|0}function p8f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[736734]|0;if(!e){f=MK(2946944)|0;c[736734]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function q8f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;Tkh();e=ewh(2933568,d)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}f=MGf(0,e)|0;if(!f){e=ewh(2933568,d)|0;if(!(a[2540708]|0))awh(2540560);g=iwf(0,c[893350]|0,e,c[893352]|0)|0;RI(2919160)|0;e=qL(2919160)|0;Grg(e,g);_vh(e)}e=ewh(2933416,d)|0;g=Sqh(2933496,d)|0;RI(2919664)|0;if(a[2919812]|0){RI(1104624)|0;h=$vh(g,1104624)|0;j=o8f(0,f,e,h)|0;i=b;return j|0}RI(2919664)|0;awh(2919664);RI(1104624)|0;h=$vh(g,1104624)|0;j=o8f(0,f,e,h)|0;i=b;return j|0}function r8f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+40|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=cvh(2864752,zuh(2934952,a)|0)|0;c[d>>2]=e;f=e;i=b;return f|0}function s8f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;Okh();d=Fvf(b,c[893226]|0)|0;e=Dvf(b,44,(d|0)==-1?0:d+2|0)|0;if((e|0)==-1){f=b;i=a;return f|0}f=jvf(fpf(b,0,e)|0)|0;i=a;return f|0}function t8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function u8f(a){a=a|0;return}function v8f(a){a=a|0;return}function w8f(a){a=a|0;return}function x8f(b){b=b|0;var d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[e>>2]=3449240;c[d+0>>2]=c[e+0>>2];e=npf(0,d)|0;RI(2937944)|0;c[c[734509]>>2]=e;RI(2937648)|0;e=qL(2937648)|0;RI(2937944)|0;c[(c[734509]|0)+4>>2]=e;RI(2937344)|0;e=qL(2937344)|0;RI(2937944)|0;c[(c[734509]|0)+8>>2]=e;i=b;return}function y8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function z8f(b,d){b=b|0;d=d|0;var e=0;b=i;RI(2920392)|0;if(!(a[2920540]|0)){RI(2920392)|0;awh(2920392)}RI(2938496)|0;if(!(a[2938644]|0)){RI(2938496)|0;awh(2938496)}RI(2938496)|0;e=qL(2938496)|0;RI(2920392)|0;A8f(e,d,c[(c[730121]|0)+12>>2]|0,0);d=bth(2938664,e)|0;RI(2670872)|0;e=$vh(d,2670872)|0;i=b;return e|0}function A8f(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;G8f(b,d);a[b+24>>0]=0;c[b+28>>2]=D6f(0,d,e,f)|0;i=g;return}function B8f(a,b){a=a|0;b=b|0;return}function C8f(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function D8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,4);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function E8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function F8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function G8f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;RI(2604248)|0;c[f>>2]=c[c[651085]>>2];c[e+0>>2]=c[f+0>>2];H8f(a,b,e,0);i=d;return}function H8f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;Pkh();c[a+12>>2]=-1;if(!(Gqh(2653528,b)|0)?!(Gqh(2650088,b)|0):0){RI(2965048)|0;k=qL(2965048)|0;Rbg(k,c[893232]|0);_vh(k)}c[a+8>>2]=b;c[h>>2]=c[d>>2];RI(2604248)|0;c[j>>2]=c[c[651085]>>2];c[g+0>>2]=c[h+0>>2];c[f+0>>2]=c[j+0>>2];if(GAf(0,g,f)|0){RI(3100472)|0;f=qL(3100472)|0;pug(f,c[893234]|0);_vh(f)}else{i=e;return}}function I8f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[734824]|0;if(!d){e=MK(2939304)|0;c[734824]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function J8f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[b+20>>2]|0;if(g){h=I8f(0,g)|0;i=d;return h|0}g=b+8|0;if(!(Gqh(2650088,c[g>>2]|0)|0)){h=c[g>>2]|0;i=d;return h|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[f>>2]=3442296;c[e+0>>2]=c[f+0>>2];h=npf(0,e)|0;i=d;return h|0}function K8f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[734846]|0;if(!e){f=MK(2939392)|0;c[734846]=f;g=f}else g=e;e=_n[g&4095](a,b)|0;i=d;return e|0}function L8f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+4|0;f=d;g=b+20|0;h=c[g>>2]|0;if(h){j=h;i=d;return j|0}RI(2939480)|0;h=vL(b,2939480)|0;do if(!h)k=Fqh(2652904,c[b+8>>2]|0)|0;else{l=ewh(2939648,h)|0;if(l){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[f>>2]=3442296;c[e+0>>2]=c[f+0>>2];m=Fqh(2652904,npf(0,e)|0)|0;if(!(a[2540708]|0))awh(2540560);if(!(gpf(0,l,m)|0)){k=l;break}}k=Fqh(2652904,c[b+8>>2]|0)|0}while(0);e=iwh(2939704,b,k)|0;c[g>>2]=e;j=e;i=d;return j|0}function M8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function N8f(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;Qkh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[e>>2]=3432408;c[d+0>>2]=c[e+0>>2];e=npf(0,d)|0;g=nwh(2655352,e,c[893264]|0)|0;RI(2938496)|0;c[c[734647]>>2]=g;c[f>>2]=3432408;c[d+0>>2]=c[f+0>>2];f=npf(0,d)|0;d=nwh(2655352,f,c[893266]|0)|0;RI(2938496)|0;c[(c[734647]|0)+4>>2]=d;i=b;return}function O8f(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+16|0;e=c[d>>2]|0;RI(2940608)|0;if((vL(e,2940608)|0)!=0?(e=owh(2940776,c[d>>2]|0,0)|0,(bth(2940832,e)|0)!=0):0){f=ewh(2939648,bth(2940832,e)|0)|0;i=b;return f|0}f=Fqh(2652904,J8f(a)|0)|0;i=b;return f|0}function P8f(b){b=b|0;var d=0,e=0;d=i;e=b+16|0;b=c[e>>2]|0;if(!b){i=d;return}RI(2940888)|0;if(vL(b,2940888)|0){i=d;return}b=c[e>>2]|0;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}Q8f(0,b);i=d;return}function Q8f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}RI(2919664)|0;e=c[c[729939]>>2]|0;Jag(0,e);f=d+20|0;if(a[f>>0]|0){Kag(0,e);i=b;return}RI(2940608)|0;g=vL(d,2940608)|0;RI(2919664)|0;h=(a[2919812]|0)==0;if(!g){if(h){RI(2919664)|0;awh(2919664)}j=c[d+8>>2]|0;RI(2919664)|0;Irh(2736848,c[c[729939]>>2]|0,j)}else{if(h){RI(2919664)|0;awh(2919664)}h=G9f(0,f9f(g)|0)|0;RI(2919664)|0;Irh(2736848,c[c[729939]>>2]|0,h)}a[f>>0]=1;Kag(0,e);i=b;return}function R8f(a){a=a|0;return c[a+16>>2]|0}function S8f(a){a=a|0;return 0}function T8f(a){a=a|0;return c[a+20>>2]|0}function U8f(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+12>>2]|0;f=c[b+8>>2]|0;g=c[b+16>>2]|0;if(!(a[2540708]|0))awh(2540560);b=iwf(0,e,f,g)|0;i=d;return b|0}function V8f(a){a=a|0;return c[a+12>>2]|0}function W8f(a){a=a|0;return c[a+8>>2]|0}function X8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Y8f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function Z8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function $8f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function a9f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function b9f(a){a=a|0;return c[a+8>>2]|0}function c9f(b){b=b|0;return (a[b+20>>0]|0)!=0|0}function d9f(b,c){b=b|0;c=c|0;a[b+20>>0]=c&1;return}function e9f(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function f9f(a){a=a|0;var b=0,d=0;b=i;d=Fqh(2944040,c[a+16>>2]|0)|0;i=b;return d|0}function g9f(a){a=a|0;var b=0;b=i;h9f(a);i=b;return}function h9f(a){a=a|0;var b=0,d=0;b=i;RI(2923424)|0;d=qL(2923424)|0;S6f(d);c[a+8>>2]=d;i=b;return}function i9f(a){a=a|0;a=i;RI(2944304)|0;c[c[736099]>>2]=1;RI(2944304)|0;c[(c[736099]|0)+4>>2]=2;i=a;return}function j9f(a,b){a=a|0;b=b|0;c[a+20>>2]=b;return}function k9f(a){a=a|0;return c[a+16>>2]|0}function l9f(a,b){a=a|0;b=b|0;c[a+16>>2]=b;return}function m9f(a){a=a|0;return c[a+12>>2]|0}function n9f(a,b){a=a|0;b=b|0;c[a+12>>2]=b;return}function o9f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;Rkh();p9f(d,Xnf(b)|0);L7f(d,c[893280]|0,c[b+12>>2]|0);k=c[b+16>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[g>>2]=3449448;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;q9f(d,c[893282]|0,k,g);g=c[b+20>>2]|0;c[h>>2]=3449424;c[f+0>>2]=c[h+0>>2];h=npf(0,f)|0;q9f(d,c[893284]|0,g,h);h=c[b+8>>2]|0;c[j>>2]=3449400;c[f+0>>2]=c[j+0>>2];j=npf(0,f)|0;q9f(d,c[893286]|0,h,j);r9f(d,c[893288]|0,c[b+24>>2]|0);i=e;return}function p9f(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;_kh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[893442]|0);_vh(e)}else{c[a+20>>2]=Fqh(2537592,b)|0;c[a+16>>2]=Fqh(2836288,rth(2652848,b)|0)|0;i=d;return}}function q9f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+12|0;h=f;Zkh();if(!b){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[893404]|0);_vh(j)}if(!e){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[893406]|0);_vh(j)}j=a+8|0;if(nrh(2736936,c[j>>2]|0,b)|0){RI(2955448)|0;k=qL(2955448)|0;Grg(k,c[893408]|0);_vh(k)}else{k=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=e;c[g+8>>2]=d;RI(2955008)|0;Rrh(2734016,k,b,pL(2955008,g)|0);g=c[a+12>>2]|0;c[h>>2]=b;c[h+4>>2]=e;c[h+8>>2]=d;RI(2955008)|0;Erh(2714056,g,pL(2955008,h)|0)|0;i=f;return}}function r9f(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[h>>2]=e;RI(2540224)|0;e=pL(2540224,h)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[j>>2]=3431160;c[g+0>>2]=c[j+0>>2];q9f(b,d,e,npf(0,g)|0);i=f;return}function s9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function t9f(b){b=b|0;var d=0;b=i;RI(2919496)|0;c[c[729897]>>2]=0;RI(2919496)|0;c[(c[729897]|0)+4>>2]=0;RI(2919496)|0;c[(c[729897]|0)+8>>2]=0;RI(2919496)|0;a[(c[729897]|0)+12>>0]=0;RI(2919496)|0;a[(c[729897]|0)+13>>0]=0;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;awh(2730168)}RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+16>>2]=d;RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+20>>2]=d;RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+24>>2]=d;RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+28>>2]=d;RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+32>>2]=d;RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+36>>2]=d;RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(2919496)|0;c[(c[729897]|0)+40>>2]=d;i=b;return}function u9f(b){b=b|0;b=i;RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}RI(2919496)|0;i=b;return c[(c[729897]|0)+4>>2]|0}function v9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function w9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function x9f(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+64|0;d=b+48|0;e=b+32|0;f=b+16|0;g=b+8|0;h=b+4|0;j=b;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;Skh();RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;awh(2730168)}RI(2730168)|0;k=qL(2730168)|0;kPf(k);RI(2919664)|0;c[c[729939]>>2]=k;RI(2919664)|0;c[(c[729939]|0)+16>>2]=1;RI(2919664)|0;c[(c[729939]|0)+20>>2]=52;RI(2937944)|0;if(!(a[2938092]|0)){RI(2937944)|0;awh(2937944)}RI(2937944)|0;k=qL(2937944)|0;RI(2946768)|0;l=qL(2946768)|0;c[l+24>>2]=1;c[l+28>>2]=3;c[l+20>>2]=k;k=l+12|0;c[k>>2]=16;c[k+4>>2]=0;RI(2919664)|0;c[(c[729939]|0)+4>>2]=l;RI(2946768)|0;l=qL(2946768)|0;c[l+24>>2]=1;c[l+28>>2]=3;c[l+20>>2]=0;k=l+12|0;c[k>>2]=16;c[k+4>>2]=0;RI(2919664)|0;c[(c[729939]|0)+8>>2]=l;RI(2919664)|0;c[(c[(c[729939]|0)+4>>2]|0)+8>>2]=1;RI(2919664)|0;c[(c[(c[729939]|0)+8>>2]|0)+8>>2]=1;B9f(0);RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;awh(3080504)}Yrg(f,0);c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];f=Qvf(bsg(e)|0,45,95)|0;if(!(a[2540708]|0))awh(2540560);e=gwf(0,f,c[893314]|0)|0;RI(2919664)|0;c[(c[729939]|0)+12>>2]=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[g>>2]=3448656;c[d+0>>2]=c[g+0>>2];g=npf(0,d)|0;C9f(0,g,c[893316]|0,1)|0;c[h>>2]=3432408;c[d+0>>2]=c[h+0>>2];h=npf(0,d)|0;g=Nvh(2655432,h,c[893318]|0,36)|0;RI(2919664)|0;c[(c[729939]|0)+24>>2]=g;c[j>>2]=3432408;c[d+0>>2]=c[j+0>>2];j=npf(0,d)|0;d=Nvh(2655432,j,c[893320]|0,36)|0;RI(2919664)|0;c[(c[729939]|0)+28>>2]=d;i=b;return}function y9f(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;return}function z9f(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a+24>>2]=1;c[a+28>>2]=3;c[a+20>>2]=b;b=d;d=c[b+4>>2]|0;e=a+12|0;c[e>>2]=c[b>>2];c[e+4>>2]=d;return}function A9f(a,b){a=a|0;b=b|0;c[a+8>>2]=b;return}function B9f(b){b=b|0;b=i;RI(2925896)|0;if(a[2926044]|0){c7f(0);i=b;return}RI(2925896)|0;awh(2925896);c7f(0);i=b;return}function C9f(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;RI(2927232)|0;g=(a[2927380]|0)!=0;if((f|0)==2){if(!g){RI(2927232)|0;awh(2927232)}f=$hg(0)|0;RI(2947216)|0;h=qL(2947216)|0;c[h+8>>2]=e;c[h+24>>2]=d;c[h+28>>2]=f;j=h}else{if(!g){RI(2927232)|0;awh(2927232)}g=$hg(0)|0;RI(2947384)|0;h=qL(2947384)|0;c[h+8>>2]=e;c[h+24>>2]=d;c[h+28>>2]=g;j=h}RI(2919664)|0;if(a[2919812]|0){K9f(0,j);i=b;return j|0}RI(2919664)|0;awh(2919664);K9f(0,j);i=b;return j|0}function D9f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}e=G9f(0,d)|0;RI(2919664)|0;f=c[c[729939]>>2]|0;Jag(0,f);RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}RI(2919664)|0;g=uth(2736488,c[c[729939]>>2]|0,e)|0;RI(2943312)|0;e=$vh(g,2943312)|0;if(e){h=e;Kag(0,f);i=b;return h|0}RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}g=H9f(0,d)|0;if(!g){h=e;Kag(0,f);i=b;return h|0}RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}RI(2919664)|0;e=uth(2736488,c[c[729939]>>2]|0,g)|0;RI(2943312)|0;h=$vh(e,2943312)|0;Kag(0,f);i=b;return h|0}function E9f(a){a=a|0;return c[a+24>>2]|0}function F9f(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;RI(2919664)|0;g=(a[2919812]|0)!=0;if(!f){if(!g){RI(2919664)|0;awh(2919664)}RI(2919664)|0;h=Nvh(2655432,d,e,c[(c[729939]|0)+20>>2]|0)|0}else{if(!g){RI(2919664)|0;awh(2919664)}RI(2919664)|0;h=lwh(2655552,d,e,c[(c[729939]|0)+20>>2]|0,0,f,0)|0}if(h){j=h;i=b;return j|0}h=cvh(2655112,d)|0;d=h+12|0;if((c[d>>2]|0)<=0){j=0;i=b;return j|0}g=h+16|0;k=0;while(1){l=c[g+(da(c[(c[h>>2]|0)+120>>2]|0,k)|0)>>2]|0;RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}m=F9f(0,l,e,f)|0;k=k+1|0;if(m){j=m;n=16;break}if((k|0)>=(c[d>>2]|0)){j=0;n=16;break}}if((n|0)==16){i=b;return j|0}return 0}function G9f(a,b){a=a|0;b=b|0;var d=0;a=i;Ykh();if(!(Pvf(b,c[893400]|0)|0)){d=b;i=a;return d|0}d=gvf(b,1)|0;i=a;return d|0}function H9f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;Wkh();RI(2919496)|0;if(!(a[2919644]|0)){RI(2919496)|0;awh(2919496)}e=u9f(0)|0;if(!e){f=0;i=b;return f|0}if(!(a[2540708]|0))awh(2540560);g=iwf(0,c[893378]|0,e,c[893380]|0)|0;if(!(Pvf(d,g)|0)){f=0;i=b;return f|0}f=gvf(d,Vof(g)|0)|0;i=b;return f|0}function I9f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+24>>2]=e;c[a+28>>2]=d;return}function J9f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+24>>2]=e;c[a+28>>2]=d;return}function K9f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;Xkh();RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}RI(2919664)|0;e=c[c[729939]>>2]|0;Jag(0,e);RI(2919664)|0;if(!(a[2919812]|0)){RI(2919664)|0;awh(2919664)}f=d+8|0;g=c[f>>2]|0;RI(2919664)|0;if(nrh(2736936,c[c[729939]>>2]|0,g)|0){g=c[f>>2]|0;if(a[2540708]|0){h=c[893384]|0;j=c[893386]|0;k=iwf(0,h,g,j)|0;RI(2919160)|0;l=qL(2919160)|0;Grg(l,k);FJ(l)}awh(2540560);h=c[893384]|0;j=c[893386]|0;k=iwf(0,h,g,j)|0;RI(2919160)|0;l=qL(2919160)|0;Grg(l,k);FJ(l)}else{RI(2919664)|0;if(a[2919812]|0){m=c[f>>2]|0;RI(2919664)|0;n=c[729939]|0;o=c[n>>2]|0;Rrh(2736568,o,m,d);Kag(0,e);i=b;return}RI(2919664)|0;awh(2919664);m=c[f>>2]|0;RI(2919664)|0;n=c[729939]|0;o=c[n>>2]|0;Rrh(2736568,o,m,d);Kag(0,e);i=b;return}}function L9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function M9f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+24>>2]=e;c[a+28>>2]=d;return}function N9f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=b+16|0;g=c[f>>2]|0;if(g){h9f(g);h=c[f>>2]|0;i=e;return h|0}if(!d)j=c[b+24>>2]|0;else j=d;RI(2944304)|0;if(!(a[2944452]|0)){RI(2944304)|0;awh(2944304)}RI(2944304)|0;d=qL(2944304)|0;g9f(d);c[f>>2]=d;RI(2949576)|0;g=qL(2949576)|0;O9f(g,j);Irh(2945e3,d,g);Gth(2945088,c[f>>2]|0,c[b+8>>2]|0);g=b+12|0;b=c[g>>2]|0;if(!b){h=c[f>>2]|0;i=e;return h|0}RI(2931968)|0;if(vL(b,2931968)|0){h=c[f>>2]|0;i=e;return h|0}b=c[f>>2]|0;d=c[g>>2]|0;RI(2942480)|0;g=qL(2942480)|0;c[g+8>>2]=d;Irh(2944896,b,g);h=c[f>>2]|0;i=e;return h|0}function O9f(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;if(Gqh(2650088,d)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[g>>2]=3442296;c[f+0>>2]=c[g+0>>2];c[b+8>>2]=Fqh(2652904,npf(0,f)|0)|0;RI(1094176)|0;c[b+12>>2]=dwh(1094176,0)|0;RI(1094176)|0;g=dwh(1094176,1)|0;k=Fqh(2652904,d)|0;Qqh(g,k);c[g+16>>2]=k;c[b+16>>2]=g;i=e;return}c[b+8>>2]=Fqh(2652904,d)|0;g=0;k=suh(2651176,d)|0;while(1){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[h>>2]=3442296;c[f+0>>2]=c[h+0>>2];if((k|0)==(npf(0,f)|0)){l=g;break}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[j>>2]=3432408;c[f+0>>2]=c[j+0>>2];if((k|0)==(npf(0,f)|0)){l=g;break}g=g+1|0;k=suh(2651176,k)|0}RI(1094176)|0;k=b+12|0;c[k>>2]=dwh(1094176,l)|0;g=suh(2651176,d)|0;if((l|0)>0){f=g;g=0;do{j=c[k>>2]|0;h=Fqh(2652904,f)|0;Qqh(j,h);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,g)|0)>>2]=h;f=suh(2651176,f)|0;g=g+1|0}while((g|0)!=(l|0))}l=cvh(2655112,d)|0;RI(1094176)|0;d=l+12|0;g=dwh(1094176,c[d>>2]|0)|0;f=b+16|0;c[f>>2]=g;if((c[d>>2]|0)<=0){i=e;return}b=l+16|0;k=g;g=0;while(1){h=Fqh(2652904,c[b+(da(c[(c[l>>2]|0)+120>>2]|0,g)|0)>>2]|0)|0;Qqh(k,h);c[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,g)|0)>>2]=h;h=g+1|0;if((h|0)>=(c[d>>2]|0))break;k=c[f>>2]|0;g=h}i=e;return}function P9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Q9f(a){a=a|0;return c[a+8>>2]|0}function R9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function S9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function T9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function U9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function V9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function W9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function X9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Y9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539808)|0;yof(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Z9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function $9f(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function aag(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=e;return}function bag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function cag(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function dag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function eag(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g+8|0;k=g;b[j>>1]=f;RI(2562664)|0;f=pL(2562664,j)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[k>>2]=3437968;c[h+0>>2]=c[k+0>>2];q9f(d,e,f,npf(0,h)|0);i=g;return}function fag(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;a[h>>0]=e&1;RI(2601984)|0;e=pL(2601984,h)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[j>>2]=3431408;c[g+0>>2]=c[j+0>>2];q9f(b,d,e,npf(0,g)|0);i=f;return}function gag(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f+20|0;h=f;j=f+16|0;c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];RI(3034456)|0;e=pL(3034456,h)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[j>>2]=3432952;c[g+0>>2]=c[j+0>>2];q9f(b,d,e,npf(0,g)|0);i=f;return}function hag(b,d,e){b=b|0;d=d|0;e=ea(e);var f=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;h=f+8|0;j=f+4|0;k=f;g[j>>2]=e;RI(2586184)|0;l=pL(2586184,j)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[k>>2]=3432128;c[h+0>>2]=c[k+0>>2];q9f(b,d,l,npf(0,h)|0);i=f;return}function iag(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+12|0;j=g;k=g+8|0;l=j;c[l>>2]=e;c[l+4>>2]=f;RI(2548816)|0;f=pL(2548816,j)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[k>>2]=3437568;c[h+0>>2]=c[k+0>>2];q9f(b,d,f,npf(0,h)|0);i=g;return}function jag(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+12|0;j=g;k=g+8|0;l=j;c[l>>2]=e;c[l+4>>2]=f;RI(2554736)|0;f=pL(2554736,j)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;awh(2540728)}c[k>>2]=3440112;c[h+0>>2]=c[k+0>>2];q9f(b,d,f,npf(0,h)|0);i=g;return}function kag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function lag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function mag(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2957160)|0;if(!(vL(b,2957160)|0)){e=0;i=d;return e|0}RI(2957160)|0;f=jwh(b,2957160)|0;if((c[f>>2]|0)!=(c[a>>2]|0)){e=0;i=d;return e|0}e=(c[f+4>>2]|0)==(c[a+4>>2]|0);i=d;return e|0}function nag(a){a=a|0;return c[a>>2]|0}function oag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function pag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3079176)|0;Drg(a);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function qag(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;$kh();e=kvh(2698704,c[a+8>>2]|0)|0;L7f(b,c[893454]|0,e);i=d;return}function rag(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;alh();if(!d){f=0;i=e;return f|0}g=c[d+8>>2]|0;if(!g)if(!(c[b+8>>2]|0)){f=1;i=e;return f|0}else{d=tof(0,c[893462]|0)|0;RI(2961960)|0;h=qL(2961960)|0;sag(h,d);pwh(h)}h=kvh(2698704,g)|0;g=b+8|0;b=c[g>>2]|0;d=(b|0)==0;if(!h){if(d){f=1;i=e;return f|0}f=(kvh(2698704,b)|0)==0;i=e;return f|0}if(d){f=0;i=e;return f|0}if(!(kvh(2698704,b)|0)){f=0;i=e;return f|0}b=kvh(2698704,c[g>>2]|0)|0;d=h+12|0;j=c[d>>2]|0;if((j|0)!=(c[b+12>>2]|0)){f=0;i=e;return f|0}if((j|0)<=0){f=1;i=e;return f|0}j=h+16|0;b=0;while(1){k=kvh(2698704,c[g>>2]|0)|0;l=a[j+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>0]|0;if(l<<24>>24!=(a[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,b)|0)>>0]|0)){f=0;m=15;break}b=b+1|0;if((b|0)>=(c[d>>2]|0)){f=1;m=15;break}}if((m|0)==15){i=e;return f|0}return 0}function sag(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233296);i=c;return}function tag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;blh();d=a+8|0;if(!(c[d>>2]|0)){e=tof(0,c[893482]|0)|0;RI(2961960)|0;f=qL(2961960)|0;sag(f,e);pwh(f)}f=a+12|0;a=c[f>>2]|0;if(a){g=a;i=b;return g|0}a=uag(0)|0;e=vag(a,kvh(2698704,c[d>>2]|0)|0)|0;c[f>>2]=e;g=e;i=b;return g|0}function uag(a){a=a|0;var b=0;a=i;jlh();b=lbg(0,c[897014]|0)|0;i=a;return b|0}function vag(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;elh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[896942]|0);pwh(e)}else{e=Pag(a,b,0,c[b+12>>2]|0)|0;i=d;return e|0}return 0}function wag(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;if(!(c[a+8>>2]|0)){e=0;i=b;return e|0}f=a+12|0;g=c[f>>2]|0;if(!g){kvh(2962128,a)|0;a=c[f>>2]|0;if(!a){e=0;i=b;return e|0}else h=a}else h=g;if((c[h+12>>2]|0)<4){e=0;i=b;return e|0}g=h+16|0;a=c[(c[h>>2]|0)+120>>2]|0;e=(d[g+a>>0]|0)<<16|(d[g>>0]|0)<<24|(d[g+(a<<1)>>0]|0)<<8|(d[g+(a*3|0)>>0]|0);i=b;return e|0}function xag(a){a=a|0;var b=0,c=0;b=i;c=Znf(a)|0;i=b;return c|0}function yag(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;RI(2962184)|0;d=vL(b,2962184)|0;if(!d){e=0;i=c;return e|0}e=qwh(2962352,a,d)|0;i=c;return e|0}function zag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2962864)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Aag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Bag(a){a=a|0;var b=0;b=i;zvh(2963144,a,1);Jrg(0,a);i=b;return}function Cag(a){a=a|0;return c[a+8>>2]|0}function Dag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Eag(a){a=a|0;var b=0;a=i;RI(2536312)|0;b=qL(2536312)|0;RI(2963752)|0;c[c[740961]>>2]=b;i=a;return}function Fag(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;clh();RI(2724880)|0;if(!(a[2725028]|0)){RI(2724880)|0;rwh(2724880)}RI(2724880)|0;d=qL(2724880)|0;YNf(d);RI(2723776)|0;if(!(a[2723924]|0)){RI(2723776)|0;rwh(2723776)}RI(2723776)|0;e=qL(2723776)|0;SNf(e);RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;rwh(2730168)}RI(2730168)|0;f=qL(2730168)|0;vPf(f,d,e);Rrh(2734016,f,c[893486]|0,c[893488]|0);Rrh(2734016,f,c[893490]|0,c[893492]|0);Rrh(2734016,f,c[893494]|0,c[893496]|0);Rrh(2734016,f,c[893498]|0,c[893500]|0);Rrh(2734016,f,c[893502]|0,c[893504]|0);Rrh(2734016,f,c[893506]|0,c[893508]|0);Rrh(2734016,f,c[893510]|0,c[893512]|0);Rrh(2734016,f,c[893514]|0,c[893516]|0);Rrh(2734016,f,c[893518]|0,c[893520]|0);Rrh(2734016,f,c[893522]|0,c[893524]|0);Rrh(2734016,f,c[893526]|0,c[893528]|0);Rrh(2734016,f,c[893530]|0,c[893532]|0);Rrh(2734016,f,c[893534]|0,c[893536]|0);Rrh(2734016,f,c[893538]|0,c[893540]|0);Rrh(2734016,f,c[893542]|0,c[893544]|0);Rrh(2734016,f,c[893546]|0,c[893548]|0);Rrh(2734016,f,c[893550]|0,c[893552]|0);Rrh(2734016,f,c[893554]|0,c[893556]|0);Rrh(2734016,f,c[893558]|0,c[893560]|0);Rrh(2734016,f,c[893562]|0,c[893564]|0);Rrh(2734016,f,c[893566]|0,c[893568]|0);Rrh(2734016,f,c[893570]|0,c[893572]|0);Rrh(2734016,f,c[893574]|0,c[893576]|0);Rrh(2734016,f,c[893578]|0,c[893580]|0);Rrh(2734016,f,c[893582]|0,c[893584]|0);Rrh(2734016,f,c[893586]|0,c[893588]|0);Rrh(2734016,f,c[893590]|0,c[893592]|0);Rrh(2734016,f,c[893594]|0,c[893596]|0);Rrh(2734016,f,c[893598]|0,c[893600]|0);Rrh(2734016,f,c[893602]|0,c[893604]|0);Rrh(2734016,f,c[893606]|0,c[893608]|0);Rrh(2734016,f,c[893610]|0,c[893612]|0);Rrh(2734016,f,c[893614]|0,c[893616]|0);Rrh(2734016,f,c[893618]|0,c[893620]|0);Rrh(2734016,f,c[893622]|0,c[893624]|0);Rrh(2734016,f,c[893626]|0,c[893628]|0);Rrh(2734016,f,c[893630]|0,c[893632]|0);Rrh(2734016,f,c[893634]|0,c[893636]|0);Rrh(2734016,f,c[893638]|0,c[893640]|0);Rrh(2734016,f,c[893642]|0,c[893644]|0);Rrh(2734016,f,c[893646]|0,c[893648]|0);Rrh(2734016,f,c[893650]|0,c[893652]|0);Rrh(2734016,f,c[893654]|0,c[893656]|0);Rrh(2734016,f,c[893658]|0,c[893660]|0);Rrh(2734016,f,c[893662]|0,c[893664]|0);Rrh(2734016,f,c[893666]|0,c[893668]|0);Rrh(2734016,f,c[893670]|0,c[893672]|0);Rrh(2734016,f,c[893674]|0,c[893676]|0);Rrh(2734016,f,c[893678]|0,c[893680]|0);Rrh(2734016,f,c[893682]|0,c[893684]|0);Rrh(2734016,f,c[893686]|0,c[893688]|0);Rrh(2734016,f,c[893690]|0,c[893692]|0);Rrh(2734016,f,c[893694]|0,c[893696]|0);Rrh(2734016,f,c[893698]|0,c[893700]|0);Rrh(2734016,f,c[893702]|0,c[893704]|0);Rrh(2734016,f,c[893706]|0,c[893708]|0);Rrh(2734016,f,c[893710]|0,c[893712]|0);Rrh(2734016,f,c[893714]|0,c[893716]|0);Rrh(2734016,f,c[893718]|0,c[893720]|0);Rrh(2734016,f,c[893722]|0,c[893724]|0);Rrh(2734016,f,c[893726]|0,c[893728]|0);Rrh(2734016,f,c[893730]|0,c[893732]|0);Rrh(2734016,f,c[893734]|0,c[893736]|0);Rrh(2734016,f,c[893738]|0,c[893740]|0);Rrh(2734016,f,c[893742]|0,c[893744]|0);Rrh(2734016,f,c[893746]|0,c[893748]|0);Rrh(2734016,f,c[893750]|0,c[893752]|0);Rrh(2734016,f,c[893754]|0,c[893756]|0);Rrh(2734016,f,c[893758]|0,c[893760]|0);Rrh(2734016,f,c[893762]|0,c[893764]|0);Rrh(2734016,f,c[893766]|0,c[893768]|0);Rrh(2734016,f,c[893770]|0,c[893772]|0);Rrh(2734016,f,c[893774]|0,c[893776]|0);Rrh(2734016,f,c[893778]|0,c[893780]|0);Rrh(2734016,f,c[893782]|0,c[893784]|0);Rrh(2734016,f,c[893786]|0,c[893788]|0);Rrh(2734016,f,c[893790]|0,c[893792]|0);Rrh(2734016,f,c[893794]|0,c[893796]|0);Rrh(2734016,f,c[893798]|0,c[893800]|0);Rrh(2734016,f,c[893802]|0,c[893804]|0);RI(2724880)|0;e=qL(2724880)|0;YNf(e);RI(2723776)|0;d=qL(2723776)|0;SNf(d);RI(2730168)|0;g=qL(2730168)|0;vPf(g,e,d);Rrh(2734016,g,c[893806]|0,c[893808]|0);Rrh(2734016,g,c[893810]|0,c[893812]|0);Rrh(2734016,g,c[893814]|0,c[893816]|0);Rrh(2734016,g,c[893818]|0,c[893820]|0);Rrh(2734016,g,c[893822]|0,c[893824]|0);Rrh(2734016,g,c[893826]|0,c[893828]|0);Rrh(2734016,g,c[893830]|0,c[893832]|0);Rrh(2734016,g,c[893834]|0,c[893836]|0);Rrh(2734016,g,c[893838]|0,c[893840]|0);Rrh(2734016,g,c[893842]|0,c[893844]|0);Rrh(2734016,g,c[893846]|0,c[893848]|0);Rrh(2734016,g,c[893850]|0,c[893852]|0);Rrh(2734016,g,c[893854]|0,c[893856]|0);Rrh(2734016,g,c[893858]|0,c[893860]|0);Rrh(2734016,g,c[893862]|0,c[893864]|0);Rrh(2734016,g,c[893866]|0,c[893868]|0);Rrh(2734016,g,c[893870]|0,c[893872]|0);Rrh(2734016,g,c[893874]|0,c[893876]|0);Rrh(2734016,g,c[893878]|0,c[893880]|0);Rrh(2734016,g,c[893882]|0,c[893884]|0);RI(2963752)|0;if(a[2963900]|0){RI(2963752)|0;h=c[740961]|0;j=h+4|0;c[j>>2]=f;RI(2963752)|0;k=c[740961]|0;l=k+8|0;c[l>>2]=g;i=b;return}RI(2963752)|0;rwh(2963752);RI(2963752)|0;h=c[740961]|0;j=h+4|0;c[j>>2]=f;RI(2963752)|0;k=c[740961]|0;l=k+8|0;c[l>>2]=g;i=b;return}function Gag(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}d=Hag(0,c,0)|0;i=b;return d|0}function Hag(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;dlh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[896938]|0);pwh(f)}RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}RI(2963752)|0;f=c[c[740961]>>2]|0;Jag(0,f);RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}RI(2963752)|0;if(!(c[(c[740961]|0)+4>>2]|0)){RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}Fag(0)}Kag(0,f);RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}RI(2963752)|0;f=swh(uth(2736488,c[(c[740961]|0)+4>>2]|0,d)|0,2540560)|0;g=(f|0)==0?d:f;RI(2540728)|0;if(a[2540876]|0){h=MGf(0,g)|0;j=Lag(0,h,e)|0;i=b;return j|0}RI(2540728)|0;rwh(2540728);h=MGf(0,g)|0;j=Lag(0,h,e)|0;i=b;return j|0}function Iag(a,b){a=a|0;b=b|0;var d=0;d=i;Zmh();Rag(a,tof(0,c[899332]|0)|0,b);KHf(a,-2147467261);i=d;return}function Jag(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[752938]|0;if(!d){e=MK(3011760)|0;c[752938]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function Kag(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[752952]|0;if(!d){e=MK(3011816)|0;c[752952]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function Lag(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;RI(1086352)|0;d=Uhg(0,b,c,twh(1086352,0)|0)|0;i=a;return d|0}function Mag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Nag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Oag(a){a=a|0;var b=0;b=i;zvh(2964824,a,1);Jrg(0,a);i=b;return}function Pag(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;flh();if(a[b+12>>0]|0){RI(3112928)|0;h=qL(3112928)|0;kwg(h,c[896946]|0);pwh(h)}if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[896948]|0);pwh(h)}if((e|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[896950]|0,c[896952]|0);pwh(h)}if((f|0)<=-1){RI(2965048)|0;h=qL(2965048)|0;Rag(h,c[896954]|0,c[896956]|0);pwh(h)}if(((c[d+12>>2]|0)-f|0)<(e|0)){h=tof(0,c[896960]|0)|0;RI(2965048)|0;j=qL(2965048)|0;Rag(j,c[896958]|0,h);pwh(j)}else{xvh(2965216,b,d,e,f);f=b+8|0;c[f>>2]=kvh(2965272,b)|0;eth(2965328,b);i=g;return c[f>>2]|0}return 0}function Qag(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Rag(a,c,b);KHf(a,-2146233086);i=d;return}function Rag(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Grg(a,b);c[a+52>>2]=d;KHf(a,-2147024809);i=e;return}function Sag(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}d=Gag(0,c)|0;RI(2965384)|0;c=swh(d,2965384)|0;i=b;return c|0}function Tag(b,c){b=b|0;c=c|0;a[b+12>>0]=1;return}function Uag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Vag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Wag(b){b=b|0;var d=0;d=i;RI(2966440)|0;if(!(a[2966588]|0)){RI(2966440)|0;rwh(2966440)}c[b+8>>2]=Yag(0,0)|0;Zag(b);i=d;return}function Xag(a){a=a|0;return}function Yag(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[741672]|0;if(!d){e=MK(2966696)|0;c[741672]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Zag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;glh();c[f>>2]=c[a+8>>2];RI(2604248)|0;c[g>>2]=c[c[651085]>>2];c[e+0>>2]=c[f+0>>2];c[d+0>>2]=c[g+0>>2];if(FAf(0,e,d)|0){d=tof(0,c[896984]|0)|0;RI(2961960)|0;e=qL(2961960)|0;sag(e,d);pwh(e)}else{i=b;return}}function _ag(a){a=a|0;var b=0;a=i;if(!($ag(0)|0)){i=a;return}RI(2536312)|0;b=qL(2536312)|0;RI(2966440)|0;c[c[741633]>>2]=b;i=a;return}function $ag(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[741652]|0;if(!b){d=MK(2966616)|0;c[741652]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function abg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;e=a+4|0;f=a;g=c[741696]|0;if(!g){h=MK(2966792)|0;c[741696]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];f=_n[j&4095](e,d)|0;i=a;return f|0}function bbg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[741722]|0;if(!f){g=MK(2966896)|0;c[741722]=g;h=g}else h=f;c[e>>2]=c[b>>2];c[d+0>>2]=c[e+0>>2];ko[h&4095](d);i=a;return}function cbg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;hlh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[897004]|0);pwh(j)}RI(2966440)|0;if(!(a[2966588]|0)){RI(2966440)|0;rwh(2966440)}RI(2966440)|0;if(!(c[c[741633]>>2]|0)){j=b+8|0;k=c[j>>2]|0;RI(2966440)|0;if(!(a[2966588]|0)){RI(2966440)|0;rwh(2966440)}c[g>>2]=k;c[f+0>>2]=c[g+0>>2];c[j>>2]=abg(0,f,d)|0;Zag(b);i=e;return}RI(2966440)|0;if(!(a[2966588]|0)){RI(2966440)|0;rwh(2966440)}RI(2966440)|0;j=c[c[741633]>>2]|0;Jag(0,j);g=b+8|0;k=c[g>>2]|0;RI(2966440)|0;if(!(a[2966588]|0)){RI(2966440)|0;rwh(2966440)}c[h>>2]=k;c[f+0>>2]=c[h+0>>2];c[g>>2]=abg(0,f,d)|0;Kag(0,j);Zag(b);i=e;return}function dbg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;k=b+8|0;c[g>>2]=c[k>>2];RI(2604248)|0;c[h>>2]=c[c[651085]>>2];c[f+0>>2]=c[g+0>>2];c[e+0>>2]=c[h+0>>2];if(!(GAf(0,f,e)|0)){i=d;return}f=c[k>>2]|0;RI(2966440)|0;if(!(a[2966588]|0)){RI(2966440)|0;rwh(2966440)}c[j>>2]=f;c[e+0>>2]=c[j+0>>2];bbg(0,e);RI(2604248)|0;c[k>>2]=c[c[651085]>>2];i=d;return}function ebg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function fbg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=c[a>>2]|0;if(!e)f=0;else f=e+16|0;c[b>>2]=f;f=c[a+4>>2]|0;if(!f)g=0;else g=f+16|0;c[b+4>>2]=g;g=c[a+8>>2]|0;if(!g)h=0;else h=g+16|0;c[b+8>>2]=h;h=c[a+12>>2]|0;if(!h)j=0;else j=h+16|0;c[b+12>>2]=j;j=c[a+16>>2]|0;if(!j)k=0;else k=j+16|0;c[b+16>>2]=k;k=c[a+20>>2]|0;if(!k)l=0;else l=k+16|0;c[b+20>>2]=l;l=c[a+24>>2]|0;if(!l)m=0;else m=l+16|0;c[b+24>>2]=m;m=c[a+28>>2]|0;if(!m){n=0;o=b+28|0;c[o>>2]=n;i=d;return}n=m+16|0;o=b+28|0;c[o>>2]=n;i=d;return}function gbg(a,b){a=a|0;b=b|0;var d=0;d=i;c[b>>2]=uwh(2557392,c[a>>2]|0,1)|0;c[b+4>>2]=uwh(2557392,c[a+4>>2]|0,1)|0;c[b+8>>2]=uwh(2557392,c[a+8>>2]|0,1)|0;c[b+12>>2]=uwh(2557392,c[a+12>>2]|0,1)|0;c[b+16>>2]=uwh(2557392,c[a+16>>2]|0,1)|0;c[b+20>>2]=uwh(2557392,c[a+20>>2]|0,1)|0;c[b+24>>2]=uwh(2557392,c[a+24>>2]|0,1)|0;c[b+28>>2]=uwh(2557392,c[a+28>>2]|0,1)|0;i=d;return}function hbg(a){a=a|0;return}function ibg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function jbg(a){a=a|0;var b=0;a=i;ilh();b=kbg(0,c[897010]|0)|0;i=a;return b|0}function kbg(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}d=Gag(0,c)|0;RI(2967800)|0;c=swh(d,2967800)|0;i=b;return c|0}function lbg(b,c){b=b|0;c=c|0;var d=0;b=i;RI(2963752)|0;if(!(a[2963900]|0)){RI(2963752)|0;rwh(2963752)}d=Gag(0,c)|0;RI(2969216)|0;c=swh(d,2969216)|0;i=b;return c|0}function mbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function nbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function obg(a,b,d){a=a|0;b=b|0;d=d|0;c[a+12>>2]=b;c[a+16>>2]=d;c[a+8>>2]=b;return}function pbg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+8|0;e=c[d>>2]|0;if(e)if(!(jth(2568176,e)|0))if((c[a+12>>2]|0)==(c[d>>2]|0)?(e=c[a+16>>2]|0,(e|0)!=0):0){c[d>>2]=e;f=jth(2568176,e)|0}else f=0;else f=1;else f=0;i=b;return f|0}function qbg(a){a=a|0;var b=0,d=0;b=i;d=Sqh(2568120,c[a+8>>2]|0)|0;i=b;return d|0}function rbg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+8>>2]|0;if(!d)e=0;else e=Aqh(2713056,d)|0;d=c[a+12>>2]|0;if(!d){f=e;i=b;return f|0}f=(Aqh(2713056,d)|0)+e|0;i=b;return f|0}function sbg(a){a=a|0;return a|0}function tbg(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;b=c[e>>2]|0;if(b){f=b;i=d;return f|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;rwh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);g=ANf(0,b)|0;c[e>>2]=g;f=g;i=d;return f|0}function ubg(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+12|0;b=c[e>>2]|0;if(b){f=b;i=d;return f|0}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;rwh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);g=ANf(0,b)|0;c[e>>2]=g;f=g;i=d;return f|0}function vbg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+8|0;g=c[f>>2]|0;if(g){h=Aqh(2713056,g)|0;if((h|0)<1)j=h;else{Csh(2714672,c[f>>2]|0,b,d);j=h}}else j=0;h=a+12|0;a=c[h>>2]|0;if(!a){i=e;return}if((Aqh(2713056,a)|0)<1){i=e;return}Csh(2714672,c[h>>2]|0,b,j+d|0);i=e;return}function wbg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if(!b){e=0;i=d;return e|0}RI(2970488)|0;f=vL(b,2970488)|0;if(!f){e=0;i=d;return e|0}b=Aqh(2713056,tbg(a)|0)|0;if((b|0)!=(Aqh(2713056,tbg(f)|0)|0)){e=0;i=d;return e|0}b=Aqh(2713056,ubg(a)|0)|0;if((b|0)!=(Aqh(2713056,ubg(f)|0)|0)){e=0;i=d;return e|0}b=a+8|0;a:do if((Aqh(2713056,c[b>>2]|0)|0)>0){g=f+8|0;h=0;while(1){if((Aqh(2713056,c[g>>2]|0)|0)<=0){e=0;break}j=Krh(2713112,c[b>>2]|0,h)|0;k=h;h=h+1|0;if(!(nrh(2536048,j,Krh(2713112,c[g>>2]|0,0)|0)|0)){h=h;continue}if((h|0)>=(Aqh(2713056,c[b>>2]|0)|0))break a}i=d;return e|0}while(0);b=a+12|0;if((Aqh(2713056,c[b>>2]|0)|0)<=0){e=1;i=d;return e|0}a=f+12|0;f=0;while(1){if((Aqh(2713056,c[a>>2]|0)|0)<=0){e=0;l=15;break}h=Krh(2713112,c[b>>2]|0,f)|0;g=f;f=f+1|0;if(!(nrh(2536048,h,Krh(2713112,c[a>>2]|0,0)|0)|0)){f=f;continue}if((f|0)>=(Aqh(2713056,c[b>>2]|0)|0)){e=1;l=15;break}}if((l|0)==15){i=d;return e|0}return 0}function xbg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+8>>2]|0;if(!d)e=0;else e=bth(2714784,d)|0;d=c[a+12>>2]|0;if(!d)f=0;else f=bth(2714784,d)|0;RI(2969928)|0;d=qL(2969928)|0;c[d+12>>2]=e;c[d+16>>2]=f;c[d+8>>2]=e;i=b;return d|0}function ybg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=a+16|0;if(c[d>>2]|0){e=c[d>>2]|0;i=b;return e|0}f=a+8|0;g=c[f>>2]|0;if((g|0)!=0?(Aqh(2713056,g)|0)>0:0){g=0;do{h=c[d>>2]|0;c[d>>2]=(Aqh(2536720,Krh(2713112,c[f>>2]|0,g)|0)|0)^h;g=g+1|0}while((g|0)<(Aqh(2713056,c[f>>2]|0)|0))}f=a+12|0;a=c[f>>2]|0;if(!a){e=c[d>>2]|0;i=b;return e|0}if((Aqh(2713056,a)|0)>0)j=0;else{e=c[d>>2]|0;i=b;return e|0}do{a=c[d>>2]|0;c[d>>2]=(Aqh(2536720,Krh(2713112,c[f>>2]|0,j)|0)|0)^a;j=j+1|0}while((j|0)<(Aqh(2713056,c[f>>2]|0)|0));e=c[d>>2]|0;i=b;return e|0}function zbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Abg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Bbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Cbg(a,b,d){a=a|0;b=b|0;d=d|0;klh();if(!b){RI(2963920)|0;b=qL(2963920)|0;Iag(b,c[897018]|0);pwh(b)}else Qnf(0,a,c[897022]|0)|0}function Dbg(b){b=b|0;var d=0,e=0;llh();d=Fqh(2537592,Xnf(b)|0)|0;RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}RI(2971736)|0;e=qL(2971736)|0;Ibg(e,d,0);Fbg(e,c[897052]|0,c[897054]|0);RI(2971904)|0;bcg(qL(2971904)|0,0);Qnf(0,b,c[897056]|0)|0;return 0}function Ebg(a,b){a=a|0;b=b|0;var c=0;c=i;Ibg(a,b,0);i=c;return}function Fbg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;olh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[897122]|0);pwh(g)}if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[897124]|0);pwh(g)}if(_bg(b,d)|0){if(a[2540708]|0){h=c[897126]|0;j=gwf(0,h,d)|0;k=tof(0,j)|0;RI(2965048)|0;l=qL(2965048)|0;Rbg(l,k);pwh(l)}rwh(2540560);h=c[897126]|0;j=gwf(0,h,d)|0;k=tof(0,j)|0;RI(2965048)|0;l=qL(2965048)|0;Rbg(l,k);pwh(l)}l=b+16|0;b=c[l>>2]|0;if(b){m=b;RI(2974200)|0;n=qL(2974200)|0;Pbg(n,d,e);Erh(2714056,m,n)|0;i=f;return}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;rwh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);c[l>>2]=b;m=b;RI(2974200)|0;n=qL(2974200)|0;Pbg(n,d,e);Erh(2714056,m,n)|0;i=f;return}function Gbg(a){a=a|0;var b=0;b=i;bcg(a,0);i=b;return}function Hbg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(!d){i=e;return b|0}f=b+8|0;if(((c[f>>2]|0)==0?(g=Vof(d)|0,(g|0)<(c[b+20>>2]|0)):0)?(g=Vof(d)|0,h=b+12|0,(g|0)>(Vof(c[h>>2]|0)|0)):0){c[f>>2]=Vof(d)|0;c[b+16>>2]=d;c[h>>2]=d;i=e;return b|0}h=c[f>>2]|0;g=(Vof(d)|0)+h|0;h=b+12|0;if(!((c[b+16>>2]|0)==0?(Vof(c[h>>2]|0)|0)>=(g|0):0))$eg(b,g);j=c[h>>2]|0;h=c[f>>2]|0;k=Vof(d)|0;if(!(a[2540708]|0))rwh(2540560);Gwf(0,j,h,d,0,k);c[f>>2]=g;i=e;return b|0}function Ibg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;nlh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[897112]|0);pwh(g)}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}if(Wbg(0,d)|0){c[b+12>>2]=d;Xbg(b,e);i=f;return}f=tof(0,c[897114]|0)|0;if(!(a[2540708]|0))rwh(2540560);e=iwf(0,f,c[897116]|0,d)|0;RI(2965048)|0;d=qL(2965048)|0;Rbg(d,e);pwh(d)}function Jbg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;plh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[897142]|0);pwh(f)}f=b+20|0;b=c[f>>2]|0;if(b){g=b;Erh(2714056,g,d)|0;i=e;return}RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;rwh(2713640)}RI(2713640)|0;b=qL(2713640)|0;$Lf(b);c[f>>2]=b;g=b;Erh(2714056,g,d)|0;i=e;return}function Kbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Lbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Mbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Nbg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Obg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Pbg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;tlh();RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}if(!(Qbg(0,d)|0)){g=tof(0,c[897232]|0)|0;if(a[2540708]|0){h=c[897234]|0;j=iwf(0,g,h,d)|0;RI(2965048)|0;k=qL(2965048)|0;Rbg(k,j);pwh(k)}rwh(2540560);h=c[897234]|0;j=iwf(0,g,h,d)|0;RI(2965048)|0;k=qL(2965048)|0;Rbg(k,j);pwh(k)}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}if(Sbg(0,e)|0){c[b+8>>2]=d;RI(2971736)|0;if(a[2971884]|0){l=Tbg(0,e)|0;m=b+12|0;c[m>>2]=l;i=f;return}RI(2971736)|0;rwh(2971736);l=Tbg(0,e)|0;m=b+12|0;c[m>>2]=l;i=f;return}else{f=tof(0,c[897236]|0)|0;if(a[2540708]|0){n=c[897238]|0;o=iwf(0,f,n,e)|0;RI(2965048)|0;p=qL(2965048)|0;Rbg(p,o);pwh(p)}rwh(2540560);n=c[897238]|0;o=iwf(0,f,n,e)|0;RI(2965048)|0;p=qL(2965048)|0;Rbg(p,o);pwh(p)}}function Qbg(b,d){b=b|0;d=d|0;var e=0;b=i;if(!d){e=0;i=b;return e|0}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}RI(2971736)|0;e=(yvf(d,c[(c[742957]|0)+8>>2]|0)|0)==-1;i=b;return e|0}function Rbg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2147024809);i=c;return}function Sbg(b,d){b=b|0;d=d|0;var e=0;b=i;if(!d){e=0;i=b;return e|0}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}RI(2971736)|0;e=(yvf(d,c[(c[742957]|0)+12>>2]|0)|0)==-1;i=b;return e|0}function Tbg(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;rlh();if(!b){d=0;i=a;return d|0}RI(2971904)|0;e=qL(2971904)|0;bcg(e,b);ccg(e,c[897178]|0,c[897180]|0)|0;ccg(e,c[897182]|0,c[897184]|0)|0;ccg(e,c[897186]|0,c[897188]|0)|0;ccg(e,c[897190]|0,c[897192]|0)|0;ccg(e,c[897194]|0,c[897196]|0)|0;d=Fqh(2972072,e)|0;i=a;return d|0}function Ubg(a){a=a|0;return c[a+8>>2]|0}function Vbg(a){a=a|0;return c[a+12>>2]|0}function Wbg(b,d){b=b|0;d=d|0;var e=0;b=i;if(!d){e=0;i=b;return e|0}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}RI(2971736)|0;e=(yvf(d,c[c[742957]>>2]|0)|0)==-1;i=b;return e|0}function Xbg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;mlh();if(d){RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}if(!(Zbg(0,d)|0)){f=tof(0,c[897096]|0)|0;if(!(a[2540708]|0))rwh(2540560);g=iwf(0,f,c[897098]|0,d)|0;RI(2965048)|0;f=qL(2965048)|0;Rbg(f,g);pwh(f)}}RI(2971736)|0;if(a[2971884]|0){h=Tbg(0,d)|0;j=b+8|0;c[j>>2]=h;i=e;return}RI(2971736)|0;rwh(2971736);h=Tbg(0,d)|0;j=b+8|0;c[j>>2]=h;i=e;return}function Ybg(a){a=a|0;var d=0,e=0,f=0,g=0;a=i;i=i+16|0;d=a+4|0;e=a;RI(1136088)|0;f=twh(1136088,3)|0;g=f+16|0;b[g>>1]=32;b[g+(c[(c[f>>2]|0)+120>>2]|0)>>1]=60;b[g+(c[(c[f>>2]|0)+120>>2]<<1)>>1]=62;RI(2971736)|0;c[c[742957]>>2]=f;RI(1136088)|0;f=twh(1136088,2)|0;g=f+16|0;b[g>>1]=60;b[g+(c[(c[f>>2]|0)+120>>2]|0)>>1]=62;RI(2971736)|0;c[(c[742957]|0)+4>>2]=f;RI(1136088)|0;f=twh(1136088,3)|0;g=f+16|0;b[g>>1]=32;b[g+(c[(c[f>>2]|0)+120>>2]|0)>>1]=60;b[g+(c[(c[f>>2]|0)+120>>2]<<1)>>1]=62;RI(2971736)|0;c[(c[742957]|0)+8>>2]=f;RI(1136088)|0;f=twh(1136088,3)|0;g=f+16|0;b[g>>1]=34;b[g+(c[(c[f>>2]|0)+120>>2]|0)>>1]=60;b[g+(c[(c[f>>2]|0)+120>>2]<<1)>>1]=62;RI(2971736)|0;c[(c[742957]|0)+12>>2]=f;RI(1136088)|0;f=twh(1136088,5)|0;c[e>>2]=3140360;c[d+0>>2]=c[e+0>>2];Guf(0,f,d);RI(2971736)|0;c[(c[742957]|0)+16>>2]=f;i=a;return}function Zbg(b,d){b=b|0;d=d|0;var e=0;b=i;if(!d){e=0;i=b;return e|0}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}RI(2971736)|0;e=(yvf(d,c[(c[742957]|0)+4>>2]|0)|0)==-1;i=b;return e|0}function _bg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=c[b+16>>2]|0;if(!f){g=0;i=e;return g|0}b=bth(2714784,f)|0;while(1){if(!(jth(2568176,b)|0)){h=0;j=80;break}f=Sqh(2568120,b)|0;RI(2974200)|0;k=swh(f,2974200)|0;f=c[k+8>>2]|0;if(!(a[2540708]|0))rwh(2540560);if(gpf(0,f,d)|0){h=k;j=82;break}}RI(2568648)|0;d=vL(b,2568648)|0;do if(!d)if((j|0)==80){g=0;i=e;return g|0}else if((j|0)==82)break;else pwh(0);else{kth(2568816,d);if((j|0)==82)break;else if((j|0)==80){g=0;i=e;return g|0}else pwh(0)}while(0);g=h;i=e;return g|0}function $bg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;qlh();if(!d){e=0;i=b;return e|0}RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}RI(2971736)|0;if((yvf(d,c[(c[742957]|0)+16>>2]|0)|0)==-1){e=d;i=b;return e|0}RI(2971904)|0;f=qL(2971904)|0;bcg(f,0);g=Vof(d)|0;if((g|0)>0){h=0;do{j=Wof(d,h)|0;k=j&65535;l=k+65502&65535;do if(!l)Hbg(f,c[897154]|0)|0;else if((l|0)==4)Hbg(f,c[897158]|0)|0;else if((l|0)!=5){m=k+65476&65535;if(!m){Hbg(f,c[897150]|0)|0;break}else if((m|0)==2){Hbg(f,c[897152]|0)|0;break}else{acg(f,j)|0;break}}else Hbg(f,c[897156]|0)|0;while(0);h=h+1|0}while((h|0)!=(g|0))}e=Fqh(2972072,f)|0;i=b;return e|0}function acg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+8|0;f=(c[e>>2]|0)+1|0;g=a+12|0;if(!((c[a+16>>2]|0)==0?(Vof(c[g>>2]|0)|0)>=(f|0):0))$eg(a,f);qwf(c[g>>2]|0,c[e>>2]|0,b);c[e>>2]=f;i=d;return a|0}function bcg(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if(!d){if(!(a[2540708]|0))rwh(2540560);f=c[c[635163]>>2]|0}else f=d;c[b+8>>2]=Vof(f)|0;c[b+16>>2]=f;c[b+12>>2]=f;c[b+20>>2]=2147483647;i=e;return}function ccg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ffg(a,b,d,0,c[a+8>>2]|0)|0;i=e;return f|0}function dcg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;RI(2971904)|0;e=qL(2971904)|0;bcg(e,0);c[d>>2]=e;ecg(a,d,0);d=Fqh(2972072,e)|0;i=b;return d|0}function ecg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;slh();Hbg(c[d>>2]|0,c[897208]|0)|0;g=b+12|0;Hbg(c[d>>2]|0,c[g>>2]|0)|0;h=b+16|0;if((c[h>>2]|0)!=0?(Hbg(c[d>>2]|0,c[897210]|0)|0,(Aqh(2713056,c[h>>2]|0)|0)>0):0){j=0;do{k=Krh(2713112,c[h>>2]|0,j)|0;RI(2974200)|0;l=swh(k,2974200)|0;k=Hbg(c[d>>2]|0,c[l+8>>2]|0)|0;m=Hbg(k,c[897212]|0)|0;k=c[l+12>>2]|0;RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}l=Hbg(m,$bg(0,k)|0)|0;Hbg(l,c[897214]|0)|0;if((j|0)!=((Aqh(2713056,c[h>>2]|0)|0)+-1|0)){l=org(0)|0;Hbg(c[d>>2]|0,l)|0}j=j+1|0}while((j|0)<(Aqh(2713056,c[h>>2]|0)|0))}h=b+8|0;j=c[h>>2]|0;if(j){if(!(a[2540708]|0))rwh(2540560);if(gpf(0,j,c[c[635163]>>2]|0)|0)n=12}else n=12;do if((n|0)==12){j=c[b+20>>2]|0;if((j|0)!=0?(Aqh(2713056,j)|0)!=0:0)break;j=Hbg(c[d>>2]|0,c[897216]|0)|0;Hbg(j,org(0)|0)|0;i=f;return}while(0);n=Hbg(c[d>>2]|0,c[897218]|0)|0;j=c[h>>2]|0;RI(2971736)|0;if(!(a[2971884]|0)){RI(2971736)|0;rwh(2971736)}Hbg(n,$bg(0,j)|0)|0;j=b+20|0;do if(c[j>>2]|0){b=org(0)|0;Hbg(c[d>>2]|0,b)|0;b=bth(2714784,c[j>>2]|0)|0;n=e+1|0;while(1){if(!(jth(2568176,b)|0))break;h=Sqh(2568120,b)|0;RI(2971736)|0;ecg(swh(h,2971736)|0,d,n)}RI(2568648)|0;n=vL(b,2568648)|0;if(!n){if(362==362)break;pwh(0)}else{kth(2568816,n);if(362==362)break;pwh(0)}}while(0);e=Hbg(c[d>>2]|0,c[897220]|0)|0;d=Hbg(e,c[g>>2]|0)|0;g=Hbg(d,c[897222]|0)|0;Hbg(g,org(0)|0)|0;i=f;return}function fcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function gcg(a){a=a|0;return c[a+68>>2]|0}function hcg(a){a=a|0;return c[a+72>>2]|0}function icg(a){a=a|0;return c[a+52>>2]|0}function jcg(a){a=a|0;return c[a+56>>2]|0}function kcg(a){a=a|0;return c[a+60>>2]|0}function lcg(a){a=a|0;return c[a+64>>2]|0}function mcg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;ulh();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];THf(a,b,f);L7f(b,c[897270]|0,c[a+52>>2]|0);i=e;return}function ncg(a){a=a|0;vlh();Mnf(0,a,c[897282]|0)|0;return 0}function ocg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;RI(1086352)|0;g=twh(1086352,2)|0;Qqh(g,d);h=g+16|0;c[h>>2]=d;Qqh(g,e);c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]=e;e=kfg(a,0,b,g)|0;i=f;return e|0}function pcg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=kfg(a,0,b,c)|0;i=d;return e|0}function qcg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;RI(1086352)|0;f=twh(1086352,1)|0;Qqh(f,d);c[f+16>>2]=d;d=kfg(a,0,b,f)|0;i=e;return d|0}function rcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function scg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function tcg(a){a=a|0;return}function ucg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,32767);Dpf(a,0);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2662936)|0;bIf(a,sM(2978096)|0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function vcg(a){a=a|0;return}function wcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,5188);Dpf(a,1);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function xcg(a){a=a|0;return}function ycg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,2);Dpf(a,1);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function zcg(b){b=b|0;var d=0,e=0;d=i;wlh();Acg(b,20127);e=c[897382]|0;c[b+44>>2]=e;c[b+36>>2]=e;c[b+28>>2]=e;c[b+32>>2]=c[897384];a[b+40>>0]=1;a[b+41>>0]=1;i=d;return}function Acg(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;a[b+16>>0]=1;c[b+12>>2]=d;c[b+8>>2]=d;if((d|0)==1200|(d|0)==1201|(d|0)==12e3|(d|0)==12001|(d|0)==65e3|(d|0)==65001){RI(2982584)|0;if(!(a[2982732]|0)){RI(2982584)|0;rwh(2982584)}c[b+20>>2]=mdg(0)|0;RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}c[b+24>>2]=Rdg(0)|0;i=e;return}RI(2982584)|0;f=(a[2982732]|0)!=0;if((d|0)==20127|(d|0)==54936){if(!f){RI(2982584)|0;rwh(2982584)}c[b+20>>2]=ldg(0)|0;RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}c[b+24>>2]=Qdg(0)|0;i=e;return}else{if(!f){RI(2982584)|0;rwh(2982584)}c[b+20>>2]=ldg(0)|0;RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}c[b+24>>2]=Qdg(0)|0;i=e;return}}function Bcg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;xlh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[897396]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return f|0}RI(2978896)|0;if(a[2979044]|0){h=c[897404]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[897402]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[897404]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[897402]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[897400]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[897398]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[897400]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[897398]|0;Qag(m,n,l);pwh(m);return 0}function Ccg(a,b){a=a|0;b=b|0;return b|0}function Dcg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;c[j>>2]=0;c[k>>2]=0;l=Ecg(a,b,d,e,f,g,j,k)|0;i=h;return l|0}function Ecg(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;ylh();if(!e){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[897420]|0);pwh(n)}if(!h){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[897422]|0);pwh(n)}if((f|0)>=0?(n=c[e+12>>2]|0,(n|0)>=(f|0)):0){if((g|0)<0|(n-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){o=c[897430]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[897428]|0;Qag(p,q,o);pwh(p)}RI(2978896)|0;rwh(2978896);o=c[897430]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[897428]|0;Qag(p,q,o);pwh(p)}if((j|0)>=0?(p=c[h+12>>2]|0,(p|0)>=(j|0)):0){if((p-j|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){r=c[897436]|0;RI(2965048)|0;s=qL(2965048)|0;Rbg(s,r);pwh(s)}RI(2978896)|0;rwh(2978896);r=c[897436]|0;RI(2965048)|0;s=qL(2965048)|0;Rbg(s,r);pwh(s)}if((g|0)<=0){i=m;return g|0}s=e+16|0;r=d+24|0;p=h+16|0;o=j;j=f;f=g;while(1){q=j+1|0;n=b[s+(da(c[(c[e>>2]|0)+120>>2]|0,j)|0)>>1]|0;if((n&65535)>127){if(!(c[k>>2]|0))c[k>>2]=vwh(2979064,c[r>>2]|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!((f|0)<3|(quf(0,n)|0)^1)){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(quf(0,b[s+(da(c[(c[e>>2]|0)+120>>2]|0,q)|0)>>1]|0)|0){t=j+2|0;wwh(2979120,c[k>>2]|0,n,b[s+(da(c[(c[e>>2]|0)+120>>2]|0,t)|0)>>1]|0,j)|0;u=t}else v=36}else v=36;if((v|0)==36){v=0;xwh(2979176,c[k>>2]|0,n,j)|0;u=q}if((c[l>>2]|0)!=0?(t=Aqh(2979232,c[k>>2]|0)|0,w=c[l>>2]|0,x=c[w+12>>2]|0,(x|0)>=(t|0)):0){y=w;z=x}else{x=Aqh(2979232,c[k>>2]|0)|0;RI(1136088)|0;w=twh(1136088,x)|0;c[l>>2]=w;y=w;z=c[w+12>>2]|0}if((z|0)>0){w=0;do{x=ywh(2979288,c[k>>2]|0)|0;t=c[l>>2]|0;b[t+16+(da(c[(c[t>>2]|0)+120>>2]|0,w)|0)>>1]=x;w=w+1|0;x=c[t+12>>2]|0}while((w|0)<(x|0));A=t;B=x}else{A=y;B=z}C=(Ecg(d,A,0,B,h,o,k,l)|0)+o|0;D=u}else{a[p+(da(c[(c[h>>2]|0)+120>>2]|0,o)|0)>>0]=n;C=o+1|0;D=q}f=f+-1|0;if((f|0)<=0)break;else{o=C;j=D}}i=m;return g|0}RI(2978896)|0;if(a[2979044]|0){E=c[897434]|0;RI(2964880)|0;F=qL(2964880)|0;G=c[897432]|0;Qag(F,G,E);pwh(F)}RI(2978896)|0;rwh(2978896);E=c[897434]|0;RI(2964880)|0;F=qL(2964880)|0;G=c[897432]|0;Qag(F,G,E);pwh(F)}RI(2978896)|0;if(a[2979044]|0){H=c[897426]|0;RI(2964880)|0;I=qL(2964880)|0;J=c[897424]|0;Qag(I,J,H);pwh(I)}RI(2978896)|0;rwh(2978896);H=c[897426]|0;RI(2964880)|0;I=qL(2964880)|0;J=c[897424]|0;Qag(I,J,H);pwh(I);return 0}function Fcg(a){a=a|0;return c[a+24>>2]|0}function Gcg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;zlh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[897474]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return f|0}RI(2978896)|0;if(a[2979044]|0){h=c[897482]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[897480]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[897482]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[897480]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[897478]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[897476]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[897478]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[897476]|0;Qag(m,n,l);pwh(m);return 0}function Hcg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;i=i+16|0;j=h;c[j>>2]=0;k=Icg(a,b,d,e,f,g,j)|0;i=h;return k|0}function Icg(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=i;Alh();if(!e){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[897486]|0);pwh(m)}if(!h){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[897488]|0);pwh(m)}if((f|0)>=0?(m=c[e+12>>2]|0,(m|0)>=(f|0)):0){if((g|0)<0|(m-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){n=c[897496]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[897494]|0;Qag(o,p,n);pwh(o)}RI(2978896)|0;rwh(2978896);n=c[897496]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[897494]|0;Qag(o,p,n);pwh(o)}if((j|0)>=0?(o=c[h+12>>2]|0,(o|0)>=(j|0)):0){if((o-j|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){q=c[897502]|0;RI(2965048)|0;r=qL(2965048)|0;Rbg(r,q);pwh(r)}RI(2978896)|0;rwh(2978896);q=c[897502]|0;RI(2965048)|0;r=qL(2965048)|0;Rbg(r,q);pwh(r)}if((g|0)<=0){i=l;return g|0}r=e+16|0;q=d+20|0;d=h+16|0;o=f;f=j;j=g;while(1){j=j+-1|0;n=a[r+(da(c[(c[e>>2]|0)+120>>2]|0,o)|0)>>0]|0;o=o+1|0;if(n<<24>>24<0){p=c[k>>2]|0;if(!p){m=zwh(2979344,c[q>>2]|0)|0;c[k>>2]=m;s=m}else s=p;Awh(2979400,s,e,o)|0;if((Aqh(2979512,c[k>>2]|0)|0)>0){p=f;while(1){m=p+1|0;t=ywh(2979456,c[k>>2]|0)|0;b[d+(da(c[(c[h>>2]|0)+120>>2]|0,p)|0)>>1]=t;if((Aqh(2979512,c[k>>2]|0)|0)>0)p=m;else{u=m;break}}}else u=f}else{b[d+(da(c[(c[h>>2]|0)+120>>2]|0,f)|0)>>1]=n&255;u=f+1|0}if((j|0)<=0)break;else f=u}i=l;return g|0}RI(2978896)|0;if(a[2979044]|0){v=c[897500]|0;RI(2964880)|0;w=qL(2964880)|0;x=c[897498]|0;Qag(w,x,v);pwh(w)}RI(2978896)|0;rwh(2978896);v=c[897500]|0;RI(2964880)|0;w=qL(2964880)|0;x=c[897498]|0;Qag(w,x,v);pwh(w)}RI(2978896)|0;if(a[2979044]|0){y=c[897492]|0;RI(2964880)|0;z=qL(2964880)|0;A=c[897490]|0;Qag(z,A,y);pwh(z)}RI(2978896)|0;rwh(2978896);y=c[897492]|0;RI(2964880)|0;z=qL(2964880)|0;A=c[897490]|0;Qag(z,A,y);pwh(z);return 0}function Jcg(a){a=a|0;return c[a+20>>2]|0}function Kcg(b,d){b=b|0;d=d|0;b=i;Blh();if((d|0)>-1){i=b;return d|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[897514]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[897512]|0,d);pwh(b);return 0}function Lcg(b,d){b=b|0;d=d|0;b=i;Clh();if((d|0)>-1){i=b;return d|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[897530]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[897528]|0,d);pwh(b);return 0}function Mcg(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;Dlh();if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[897534]|0);pwh(h)}if((f|0)>=0?(h=c[e+12>>2]|0,(h|0)>=(f|0)):0){if((g|0)<0|(h-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){j=c[897542]|0;RI(2964880)|0;k=qL(2964880)|0;l=c[897540]|0;Qag(k,l,j);pwh(k)}RI(2978896)|0;rwh(2978896);j=c[897542]|0;RI(2964880)|0;k=qL(2964880)|0;l=c[897540]|0;Qag(k,l,j);pwh(k)}if(!g){if(!(a[2540708]|0))rwh(2540560);m=c[c[635163]>>2]|0;i=d;return m|0}if(!h)n=0;else n=e+16|0;if(!(a[2540708]|0))rwh(2540560);e=ivf(0,g)|0;h=bvf(0)|0;k=g+f|0;g=n+k|0;if((k|0)<=(f|0)){m=e;i=d;return m|0}k=n+f|0;f=e+h|0;while(1){h=a[k>>0]|0;k=k+1|0;b[f>>1]=h<<24>>24<0?63:h&255;if(k>>>0>=g>>>0){m=e;break}else f=f+2|0}i=d;return m|0}RI(2978896)|0;if(a[2979044]|0){o=c[897538]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[897536]|0;Qag(p,q,o);pwh(p)}RI(2978896)|0;rwh(2978896);o=c[897538]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[897536]|0;Qag(p,q,o);pwh(p);return 0}function Ncg(a){a=a|0;var b=0,c=0;b=i;c=Ocg(a)|0;i=b;return c|0}function Ocg(a){a=a|0;var b=0,c=0;b=i;RI(2990248)|0;c=qL(2990248)|0;beg(c,a);i=b;return c|0}function Pcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Qcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2980920)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Rcg(a){a=a|0;var b=0,d=0;b=i;RI(2981160)|0;d=qL(2981160)|0;Scg(d);c[a+8>>2]=d;i=b;return}function Scg(a){a=a|0;var b=0;b=i;Flh();jdg(a,c[897552]|0);i=b;return}function Tcg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){RI(2963920)|0;e=qL(2963920)|0;Ucg(e);pwh(e)}else{c[a+8>>2]=b;c[a+12>>2]=0;i=d;return}}function Ucg(a){a=a|0;var b=0;b=i;Ymh();Rbg(a,tof(0,c[899316]|0)|0);KHf(a,-2147467261);i=b;return}function Vcg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+12|0;e=c[d>>2]|0;if(e){f=e;i=b;return f|0}e=zwh(2979344,c[a+8>>2]|0)|0;c[d>>2]=e;f=e;i=b;return f|0}function Wcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Xcg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ycg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Zcg(a){a=a|0;return}function _cg(a){a=a|0;return}function $cg(a){a=a|0;var b=0;a=i;RI(2981928)|0;b=qL(2981928)|0;i=a;return b|0}function adg(a){a=a|0;return}function bdg(a,b){a=a|0;b=b|0;var c=0;a=i;RI(2982096)|0;c=(vL(b,2982096)|0)!=0;i=a;return c|0}function cdg(a){a=a|0;return 0}function ddg(a){a=a|0;return}function edg(a){a=a|0;return 0}function fdg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;RI(2982776)|0;a=qL(2982776)|0;e=a+60|0;c[e>>2]=-1;Rbg(a,0);c[a+56>>2]=b;c[e>>2]=d;pwh(a);return 0}function gdg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=a+60|0;c[g>>2]=-1;Rbg(a,b);c[a+56>>2]=d;c[g>>2]=e;i=f;return}function hdg(a){a=a|0;return 0}function idg(a){a=a|0;var b=0;a=i;Elh();RI(2982096)|0;b=qL(2982096)|0;RI(2982584)|0;c[c[745669]>>2]=b;RI(2981160)|0;b=qL(2981160)|0;Scg(b);RI(2982584)|0;c[(c[745669]|0)+4>>2]=b;RI(2981160)|0;b=qL(2981160)|0;jdg(b,c[897546]|0);RI(2982584)|0;c[(c[745669]|0)+8>>2]=b;i=a;return}function jdg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){RI(2963920)|0;e=qL(2963920)|0;Ucg(e);pwh(e)}else{c[a+8>>2]=b;i=d;return}}function kdg(b){b=b|0;b=i;RI(2982584)|0;if(!(a[2982732]|0)){RI(2982584)|0;rwh(2982584)}RI(2982584)|0;i=b;return c[c[745669]>>2]|0}function ldg(b){b=b|0;b=i;RI(2982584)|0;if(!(a[2982732]|0)){RI(2982584)|0;rwh(2982584)}RI(2982584)|0;i=b;return c[(c[745669]|0)+4>>2]|0}function mdg(b){b=b|0;b=i;RI(2982584)|0;if(!(a[2982732]|0)){RI(2982584)|0;rwh(2982584)}RI(2982584)|0;i=b;return c[(c[745669]|0)+8>>2]|0}function ndg(a){a=a|0;return}function odg(a){a=a|0;return c[a+8>>2]|0}function pdg(a){a=a|0;var b=0,c=0;b=i;RI(2984688)|0;c=qL(2984688)|0;qdg(c,a);i=b;return c|0}function qdg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Glh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[897558]|0);pwh(e)}else{c[a+16>>2]=c[b+8>>2];c[a+12>>2]=0;i=d;return}}function rdg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2981160)|0;f=vL(d,2981160)|0;if(!f){g=0;i=e;return g|0}d=c[b+8>>2]|0;b=c[f+8>>2]|0;if(!(a[2540708]|0))rwh(2540560);g=gpf(0,d,b)|0;i=e;return g|0}function sdg(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2582544,c[a+8>>2]|0)|0;i=b;return d|0}function tdg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function udg(b){b=b|0;var d=0,e=0,f=0;d=i;if(!(a[b+8>>0]|0)){e=0;i=d;return e|0}f=Vof(c[b+16>>2]|0)|0;e=f-(c[b+12>>2]|0)|0;i=d;return e|0}function vdg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;Hlh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[897566]|0);pwh(g)}g=b+8|0;if((a[g>>0]|0)!=0?(Aqh(2985408,b)|0)!=0:0){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[897568]|0);pwh(h)}if((e|0)<0){RI(2964880)|0;j=qL(2964880)|0;k=c[897570]|0;wdg(j,k);pwh(j)}if((c[d+12>>2]|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;k=c[897570]|0;wdg(j,k);pwh(j)}else{a[g>>0]=1;c[b+12>>2]=0;g=(Vof(c[b+16>>2]|0)|0)>0;i=f;return g|0}return 0}function wdg(a,b){a=a|0;b=b|0;var d=0;d=i;$mh();Rag(a,tof(0,c[899354]|0)|0,b);KHf(a,-2146233086);i=d;return}function xdg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(!(a[b+8>>0]|0)){e=0;i=d;return e|0}f=b+12|0;g=c[f>>2]|0;h=b+16|0;if((g|0)>=(Vof(c[h>>2]|0)|0)){e=0;i=d;return e|0}g=c[h>>2]|0;h=c[f>>2]|0;c[f>>2]=h+1;e=Wof(g,h)|0;i=d;return e|0}function ydg(b){b=b|0;a[b+8>>0]=0;c[b+12>>2]=0;return}function zdg(a){a=a|0;return}function Adg(a){a=a|0;return}function Bdg(a){a=a|0;var b=0;a=i;RI(2985952)|0;b=qL(2985952)|0;i=a;return b|0}function Cdg(a){a=a|0;return}function Ddg(a,b){a=a|0;b=b|0;var c=0;a=i;RI(2986120)|0;c=(vL(b,2986120)|0)!=0;i=a;return c|0}function Edg(a){a=a|0;return 0}function Fdg(a){a=a|0;return}function Gdg(a){a=a|0;return 0}function Hdg(a,b,c){a=a|0;b=b|0;c=c|0;RI(2986776)|0;a=qL(2986776)|0;Idg(a,b,c);pwh(a);return 0}function Idg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=a+64|0;c[g>>2]=-1;Rbg(a,0);b[a+56>>1]=d;c[g>>2]=e;i=f;return}function Jdg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RI(2986776)|0;a=qL(2986776)|0;Kdg(a,b,c,d);pwh(a);return 0}function Kdg(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=a+64|0;c[h>>2]=-1;Rbg(a,0);b[a+58>>1]=d;b[a+60>>1]=e;c[h>>2]=f;i=g;return}function Ldg(a){a=a|0;return 0}function Mdg(a){a=a|0;var b=0;a=i;Ilh();RI(2986120)|0;b=qL(2986120)|0;RI(2986584)|0;c[c[746669]>>2]=b;RI(2987560)|0;b=qL(2987560)|0;Ndg(b);RI(2986584)|0;c[(c[746669]|0)+4>>2]=b;RI(2987560)|0;b=qL(2987560)|0;Odg(b,c[897684]|0);RI(2986584)|0;c[(c[746669]|0)+8>>2]=b;i=a;return}function Ndg(a){a=a|0;var b=0;b=i;Jlh();Odg(a,c[897688]|0);i=b;return}function Odg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(!b){RI(2963920)|0;e=qL(2963920)|0;Ucg(e);pwh(e)}else{c[a+8>>2]=b;i=d;return}}function Pdg(b){b=b|0;b=i;RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}RI(2986584)|0;i=b;return c[c[746669]>>2]|0}function Qdg(b){b=b|0;b=i;RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}RI(2986584)|0;i=b;return c[(c[746669]|0)+4>>2]|0}function Rdg(b){b=b|0;b=i;RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}RI(2986584)|0;i=b;return c[(c[746669]|0)+8>>2]|0}function Sdg(a){a=a|0;return c[a+8>>2]|0}function Tdg(a){a=a|0;var b=0,c=0;b=i;RI(2988912)|0;c=qL(2988912)|0;Udg(c,a);i=b;return c|0}function Udg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Klh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[897692]|0);pwh(e)}else{c[a+8>>2]=c[b+8>>2];c[a+12>>2]=0;i=d;return}}function Vdg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2987560)|0;f=vL(d,2987560)|0;if(!f){g=0;i=e;return g|0}d=c[b+8>>2]|0;b=c[f+8>>2]|0;if(!(a[2540708]|0))rwh(2540560);g=gpf(0,d,b)|0;i=e;return g|0}function Wdg(a){a=a|0;var b=0,d=0;b=i;d=Aqh(2582544,c[a+8>>2]|0)|0;i=b;return d|0}function Xdg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function Ydg(a){a=a|0;var b=0,d=0;b=i;d=Vof(c[a+8>>2]|0)|0;i=b;return d-(c[a+12>>2]|0)|0}function Zdg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;b=i;d=_dg(a,c)|0;i=b;return d|0}function _dg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Llh();f=b+16|0;if((a[f>>0]|0)!=0?(Aqh(2989592,b)|0)!=0:0){RI(2965048)|0;g=qL(2965048)|0;Rbg(g,c[897696]|0);pwh(g)}if((d|0)>-1){a[f>>0]=1;c[b+12>>2]=0;f=(Vof(c[b+8>>2]|0)|0)>0;i=e;return f|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[897698]|0);pwh(f)}return 0}function $dg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=i;b=_dg(a,d)|0;i=c;return b|0}function aeg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+12|0;e=c[d>>2]|0;f=a+8|0;if((e|0)>=(Vof(c[f>>2]|0)|0)){g=0;i=b;return g|0}e=c[f>>2]|0;f=c[d>>2]|0;c[d>>2]=f+1;g=Wof(e,f)|0;i=b;return g|0}function beg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Rcg(a);c[a+16>>2]=b;e=c[b+20>>2]|0;if(!e){i=d;return}Tcg(a,e);i=d;return}function ceg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+32|0;b=a+4|0;d=a+16|0;e=a+8|0;f=a+20|0;g=a+28|0;h=a;j=a+12|0;k=a+24|0;Mlh();RI(1086352)|0;l=twh(1086352,43)|0;c[b>>2]=20127;RI(2540224)|0;m=pL(2540224,b)|0;Qqh(l,m);b=l+16|0;c[b>>2]=m;Qqh(l,c[897702]|0);c[b+(c[(c[l>>2]|0)+120>>2]|0)>>2]=c[897702];Qqh(l,c[897704]|0);c[b+(c[(c[l>>2]|0)+120>>2]<<1)>>2]=c[897704];Qqh(l,c[897706]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*3|0)>>2]=c[897706];Qqh(l,c[897708]|0);c[b+(c[(c[l>>2]|0)+120>>2]<<2)>>2]=c[897708];Qqh(l,c[897710]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*5|0)>>2]=c[897710];Qqh(l,c[897712]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*6|0)>>2]=c[897712];Qqh(l,c[897714]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*7|0)>>2]=c[897714];Qqh(l,c[897716]|0);c[b+(c[(c[l>>2]|0)+120>>2]<<3)>>2]=c[897716];Qqh(l,c[897718]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*9|0)>>2]=c[897718];Qqh(l,c[897720]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*10|0)>>2]=c[897720];Qqh(l,c[897722]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*11|0)>>2]=c[897722];c[d>>2]=65e3;RI(2540224)|0;m=pL(2540224,d)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*12|0)>>2]=m;Qqh(l,c[897724]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*13|0)>>2]=c[897724];Qqh(l,c[897726]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*14|0)>>2]=c[897726];Qqh(l,c[897728]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*15|0)>>2]=c[897728];Qqh(l,c[897730]|0);c[l+((c[(c[l>>2]|0)+120>>2]|0)+1<<4)>>2]=c[897730];Qqh(l,c[897732]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*17|0)>>2]=c[897732];Qqh(l,c[897734]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*18|0)>>2]=c[897734];c[e>>2]=65001;RI(2540224)|0;m=pL(2540224,e)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*19|0)>>2]=m;Qqh(l,c[897736]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*20|0)>>2]=c[897736];Qqh(l,c[897738]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*21|0)>>2]=c[897738];Qqh(l,c[897740]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*22|0)>>2]=c[897740];Qqh(l,c[897742]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*23|0)>>2]=c[897742];Qqh(l,c[897744]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*24|0)>>2]=c[897744];c[f>>2]=1200;RI(2540224)|0;m=pL(2540224,f)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*25|0)>>2]=m;Qqh(l,c[897746]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*26|0)>>2]=c[897746];Qqh(l,c[897748]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*27|0)>>2]=c[897748];Qqh(l,c[897750]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*28|0)>>2]=c[897750];Qqh(l,c[897752]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*29|0)>>2]=c[897752];Qqh(l,c[897754]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*30|0)>>2]=c[897754];c[g>>2]=1201;RI(2540224)|0;m=pL(2540224,g)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*31|0)>>2]=m;Qqh(l,c[897756]|0);c[l+((c[(c[l>>2]|0)+120>>2]<<1|1)<<4)>>2]=c[897756];Qqh(l,c[897758]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*33|0)>>2]=c[897758];c[h>>2]=12e3;RI(2540224)|0;m=pL(2540224,h)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*34|0)>>2]=m;Qqh(l,c[897760]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*35|0)>>2]=c[897760];Qqh(l,c[897762]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*36|0)>>2]=c[897762];Qqh(l,c[897764]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*37|0)>>2]=c[897764];c[j>>2]=12001;RI(2540224)|0;m=pL(2540224,j)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*38|0)>>2]=m;Qqh(l,c[897766]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*39|0)>>2]=c[897766];c[k>>2]=28591;RI(2540224)|0;m=pL(2540224,k)|0;Qqh(l,m);c[b+((c[(c[l>>2]|0)+120>>2]|0)*40|0)>>2]=m;Qqh(l,c[897768]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*41|0)>>2]=c[897768];Qqh(l,c[897770]|0);c[b+((c[(c[l>>2]|0)+120>>2]|0)*42|0)>>2]=c[897770];RI(2978896)|0;c[c[744747]>>2]=l;RI(2536312)|0;l=qL(2536312)|0;RI(2978896)|0;c[(c[744747]|0)+44>>2]=l;i=a;return}function deg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if(b)c[a+24>>2]=b;if(!d){i=e;return}c[a+20>>2]=d;i=e;return}function eeg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;RI(2978896)|0;e=vL(b,2978896)|0;if(!e){f=0;i=d;return f|0}if((c[a+8>>2]|0)!=(c[e+8>>2]|0)){f=0;i=d;return f|0}if(!(nrh(2536048,c[a+20>>2]|0,c[e+20>>2]|0)|0)){f=0;i=d;return f|0}f=nrh(2536048,c[a+24>>2]|0,c[e+24>>2]|0)|0;i=d;return f|0}function feg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+12|0;f=Bwh(2990576,a,b,0,c[e>>2]|0)|0;RI(1159264)|0;g=twh(1159264,f)|0;Fvh(2990632,a,b,0,c[e>>2]|0,g,0)|0;i=d;return g|0}function geg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=Cwh(2990688,a,b,c,d)|0;RI(1136088)|0;g=twh(1136088,f)|0;Dwh(2990744,a,b,c,d,g,0)|0;i=e;return g|0}function heg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=d;Nlh();if(d>>>0>=65536){RI(2964880)|0;g=qL(2964880)|0;Qag(g,c[897986]|0,c[897988]|0);pwh(g)}do if((d|0)==1201){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=peg(0)|0;i=b;return h|0}else if((d|0)==65001){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=leg(0)|0;i=b;return h|0}else if((d|0)==20127){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=jeg(0)|0;i=b;return h|0}else if((d|0)==12e3){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=meg(0)|0;i=b;return h|0}else if(!d){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=ieg(0)|0;i=b;return h|0}else if((d|0)==65e3){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=keg(0)|0;i=b;return h|0}else if((d|0)==12001){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=neg(0)|0;i=b;return h|0}else if((d|0)==28591){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=qeg(0)|0;i=b;return h|0}else if((d|0)==1200){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=oeg(0)|0;i=b;return h|0}else{RI(1086352)|0;g=twh(1086352,1)|0;c[f>>2]=d;RI(2540224)|0;j=pL(2540224,f)|0;Qqh(g,j);c[g+16>>2]=j;j=mzg(0,c[897990]|0,g)|0;RI(2978896)|0;g=swh(j,2978896)|0;if(g){a[g+16>>0]=1;h=g;i=b;return h|0}g=spf(e)|0;if(!(a[2540708]|0))rwh(2540560);j=gwf(0,c[897992]|0,g)|0;g=sth(2843312,Y$f(0)|0,j)|0;if(g){k=Thg(0,g,0)|0;RI(2978896)|0;g=swh(k,2978896)|0;a[g+16>>0]=1;h=g;i=b;return h|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}g=MGf(0,j)|0;if(g){j=Thg(0,g,0)|0;RI(2978896)|0;g=swh(j,2978896)|0;a[g+16>>0]=1;h=g;i=b;return h|0}g=spf(e)|0;if(a[2540708]|0){l=c[897994]|0;m=_vf(0,l,g)|0;RI(3100472)|0;n=qL(3100472)|0;pug(n,m);pwh(n)}rwh(2540560);l=c[897994]|0;m=_vf(0,l,g)|0;RI(3100472)|0;n=qL(3100472)|0;pug(n,m);pwh(n)}while(0);return 0}function ieg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b;c[d>>2]=0;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+12>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;e=c[(c[744747]|0)+44>>2]|0;Jag(0,e);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+12>>2]|0)){c[d>>2]=1;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}f=yeg(0,d)|0;g=c[d>>2]|0;if((g|0)==-1){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=seg(0,f)|0;RI(2978896)|0;c[(c[744747]|0)+12>>2]=h}else{h=g&268435455;c[d>>2]=h;switch(h|0){case 2:{c[d>>2]=65e3;break}case 1:{c[d>>2]=20127;break}case 5:{c[d>>2]=1201;break}case 6:{c[d>>2]=28591;break}case 3:{c[d>>2]=65001;break}case 4:{c[d>>2]=1200;break}default:{}}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}h=heg(0,c[d>>2]|0)|0;RI(2978896)|0;c[(c[744747]|0)+12>>2]=h}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;a[(c[(c[744747]|0)+12>>2]|0)+16>>0]=1}Kag(0,e)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;j=c[744747]|0;k=j+12|0;l=c[k>>2]|0;i=b;return l|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;j=c[744747]|0;k=j+12|0;l=c[k>>2]|0;i=b;return l|0}function jeg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+4>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+4>>2]|0)){RI(2979568)|0;e=qL(2979568)|0;zcg(e);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+4>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+4|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+4|0;h=c[g>>2]|0;i=b;return h|0}function keg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+16>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+16>>2]|0)){RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}RI(2991312)|0;e=qL(2991312)|0;Ffg(e,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+16>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+16|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+16|0;h=c[g>>2]|0;i=b;return h|0}function leg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+20>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+20>>2]|0)){RI(2991480)|0;e=qL(2991480)|0;Deg(e,1,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+20>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+20|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+20|0;h=c[g>>2]|0;i=b;return h|0}function meg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+36>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+36>>2]|0)){RI(2991648)|0;e=qL(2991648)|0;qfg(e,0,1,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+36>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+36|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+36|0;h=c[g>>2]|0;i=b;return h|0}function neg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+40>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+40>>2]|0)){RI(2991648)|0;e=qL(2991648)|0;qfg(e,1,1,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+40>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+40|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+40|0;h=c[g>>2]|0;i=b;return h|0}function oeg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+28>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+28>>2]|0)){RI(2990912)|0;e=qL(2990912)|0;wgg(e,0,1,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+28>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+28|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+28|0;h=c[g>>2]|0;i=b;return h|0}function peg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+8>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+8>>2]|0)){RI(2990912)|0;e=qL(2990912)|0;wgg(e,1,1,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+8>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+8|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+8|0;h=c[g>>2]|0;i=b;return h|0}function qeg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+32>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+32>>2]|0)){RI(2991144)|0;e=qL(2991144)|0;Acg(e,28591);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+32>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+32|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+32|0;h=c[g>>2]|0;i=b;return h|0}function reg(a,b){a=a|0;b=b|0;var c=0;a=i;c=Thg(0,b,0)|0;i=a;return c|0}function seg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;Olh();if(!d){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[898054]|0);pwh(e)}e=Qvf(Xvf(d)|0,45,95)|0;f=0;g=0;while(1){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if((g|0)>=(c[(c[c[744747]>>2]|0)+12>>2]|0))break;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;h=c[c[744747]>>2]|0;j=c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,g)|0)>>2]|0;RI(2540224)|0;if(!(vL(j,2540224)|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}if(!(a[2540708]|0))rwh(2540560);RI(2978896)|0;h=c[c[744747]>>2]|0;if(gpf(0,e,swh(c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,g)|0)>>2]|0,2540560)|0)|0){k=f;l=12;break}else m=f}else{RI(2540224)|0;m=c[(Ewh(j,2540224)|0)>>2]|0}f=m;g=g+1|0}if((l|0)==12){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}n=heg(0,k)|0;i=b;return n|0}RI(1086352)|0;k=twh(1086352,1)|0;Qqh(k,d);c[k+16>>2]=d;l=mzg(0,c[898056]|0,k)|0;RI(2978896)|0;k=swh(l,2978896)|0;if(k){n=k;i=b;return n|0}if(!(a[2540708]|0))rwh(2540560);k=gwf(0,c[898058]|0,e)|0;e=sth(2843312,Y$f(0)|0,k)|0;if(e){l=Thg(0,e,0)|0;RI(2978896)|0;n=swh(l,2978896)|0;i=b;return n|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}l=MGf(0,k)|0;if(l){k=Thg(0,l,0)|0;RI(2978896)|0;n=swh(k,2978896)|0;i=b;return n|0}if(a[2540708]|0){o=c[898060]|0;p=_vf(0,o,d)|0;RI(2965048)|0;q=qL(2965048)|0;r=c[898062]|0;Rag(q,p,r);pwh(q)}rwh(2540560);o=c[898060]|0;p=_vf(0,o,d)|0;RI(2965048)|0;q=qL(2965048)|0;r=c[898062]|0;Rag(q,p,r);pwh(q);return 0}function teg(a){a=a|0;var b=0,d=0,e=0;b=i;d=Aqh(2536720,c[a+20>>2]|0)|0;e=Aqh(2536720,c[a+24>>2]|0)|0;i=b;return d<<(e+24&31)<<((c[a+8>>2]|0)+16&31)|0}function ueg(a){a=a|0;var b=0;a=i;RI(1159264)|0;b=twh(1159264,0)|0;i=a;return b|0}function veg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Fwh(2990800,b,c,d,e)|0;if(!(a[2540708]|0))rwh(2540560);e=Bwf(qL(2540560)|0,g)|0;i=f;return e|0}function weg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Plh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[898092]|0);pwh(e)}else{e=Gwh(2990856,a,b,0,c[b+12>>2]|0)|0;i=d;return e|0}return 0}function xeg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wgg(a,b,c,0);i=d;return}function yeg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[747770]|0;if(!d){e=MK(2991088)|0;c[747770]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function zeg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;b=i;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+24>>2]|0)){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;d=c[(c[744747]|0)+44>>2]|0;Jag(0,d);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;if(!(c[(c[744747]|0)+24>>2]|0)){RI(2991480)|0;e=qL(2991480)|0;Deg(e,0,0);RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}RI(2978896)|0;c[(c[744747]|0)+24>>2]=e}Kag(0,d)}RI(2978896)|0;if(a[2979044]|0){RI(2978896)|0;f=c[744747]|0;g=f+24|0;h=c[g>>2]|0;i=b;return h|0}RI(2978896)|0;rwh(2978896);RI(2978896)|0;f=c[744747]|0;g=f+24|0;h=c[g>>2]|0;i=b;return h|0}function Aeg(a){a=a|0;var b=0;b=i;Acg(a,28591);i=b;return}function Beg(a){a=a|0;var b=0;b=i;Ffg(a,0);i=b;return}function Ceg(a,b){a=a|0;b=b|0;var c=0;c=i;Deg(a,b,0);i=c;return}function Deg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;rmh();Acg(b,65001);a[b+48>>0]=d&1;RI(2982584)|0;d=(a[2982732]|0)!=0;if(e){if(!d){RI(2982584)|0;rwh(2982584)}e=kdg(0)|0;if(e)c[b+20>>2]=e}else{if(!d){RI(2982584)|0;rwh(2982584)}d=mdg(0)|0;if(d)c[b+20>>2]=d}d=c[898784]|0;c[b+36>>2]=d;c[b+28>>2]=d;c[b+44>>2]=d;c[b+32>>2]=c[898786];d=b+40|0;a[d>>0]=1;a[d+1>>0]=1;a[d+2>>0]=1;a[d+3>>0]=1;c[b+12>>2]=1200;i=f;return}function Eeg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;qfg(a,b,c,0);i=d;return}function Feg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Geg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Heg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ieg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;Qlh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[898096]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return f|0}RI(2978896)|0;if(a[2979044]|0){h=c[898104]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898102]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[898104]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898102]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[898100]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898098]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[898100]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898098]|0;Qag(m,n,l);pwh(m);return 0}function Jeg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;c[j>>2]=0;c[k>>2]=0;l=Keg(a,b,d,e,f,g,j,k)|0;i=h;return l|0}function Keg(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;m=i;Rlh();if(!e){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[898108]|0);pwh(n)}if(!h){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[898110]|0);pwh(n)}if((f|0)>=0?(n=c[e+12>>2]|0,(n|0)>=(f|0)):0){if((g|0)<0|(n-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){o=c[898118]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898116]|0;Qag(p,q,o);pwh(p)}RI(2978896)|0;rwh(2978896);o=c[898118]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898116]|0;Qag(p,q,o);pwh(p)}if((j|0)>=0?(p=c[h+12>>2]|0,(p|0)>=(j|0)):0){if((p-j|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){r=c[898124]|0;RI(2965048)|0;s=qL(2965048)|0;Rbg(s,r);pwh(s)}RI(2978896)|0;rwh(2978896);r=c[898124]|0;RI(2965048)|0;s=qL(2965048)|0;Rbg(s,r);pwh(s)}if((g|0)<=0){i=m;return g|0}s=e+16|0;r=d+24|0;p=h+16|0;o=j;j=f;f=g;while(1){q=j+1|0;n=b[s+(da(c[(c[e>>2]|0)+120>>2]|0,j)|0)>>1]|0;t=n&65535;do if((n&65535)>255){if((n+255<<16>>16&65535)<=93){a[p+(da(c[(c[h>>2]|0)+120>>2]|0,o)|0)>>0]=t+32;u=o+1|0;v=q;break}if(!(c[k>>2]|0))c[k>>2]=vwh(2979064,c[r>>2]|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}do if((f|0)<3|(quf(0,n)|0)^1)w=38;else{RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(quf(0,b[s+(da(c[(c[e>>2]|0)+120>>2]|0,q)|0)>>1]|0)|0)){w=38;break}x=j+2|0;wwh(2979120,c[k>>2]|0,n,b[s+(da(c[(c[e>>2]|0)+120>>2]|0,x)|0)>>1]|0,j)|0;y=x}while(0);if((w|0)==38){w=0;xwh(2979176,c[k>>2]|0,n,j)|0;y=q}if((c[l>>2]|0)!=0?(x=Aqh(2979232,c[k>>2]|0)|0,z=c[l>>2]|0,A=c[z+12>>2]|0,(A|0)>=(x|0)):0){B=A;C=z}else{z=Aqh(2979232,c[k>>2]|0)|0;RI(1136088)|0;A=twh(1136088,z)|0;c[l>>2]=A;B=c[A+12>>2]|0;C=A}if((B|0)>0){A=0;do{z=ywh(2979288,c[k>>2]|0)|0;x=c[l>>2]|0;b[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,A)|0)>>1]=z;A=A+1|0;z=c[x+12>>2]|0}while((A|0)<(z|0));D=x;E=z}else{D=C;E=B}u=(Keg(d,D,0,E,h,o,k,l)|0)+o|0;v=y}else{a[p+(da(c[(c[h>>2]|0)+120>>2]|0,o)|0)>>0]=n;u=o+1|0;v=q}while(0);f=f+-1|0;if((f|0)<=0)break;else{o=u;j=v}}i=m;return g|0}RI(2978896)|0;if(a[2979044]|0){F=c[898122]|0;RI(2964880)|0;G=qL(2964880)|0;H=c[898120]|0;Qag(G,H,F);pwh(G)}RI(2978896)|0;rwh(2978896);F=c[898122]|0;RI(2964880)|0;G=qL(2964880)|0;H=c[898120]|0;Qag(G,H,F);pwh(G)}RI(2978896)|0;if(a[2979044]|0){I=c[898114]|0;RI(2964880)|0;J=qL(2964880)|0;K=c[898112]|0;Qag(J,K,I);pwh(J)}RI(2978896)|0;rwh(2978896);I=c[898114]|0;RI(2964880)|0;J=qL(2964880)|0;K=c[898112]|0;Qag(J,K,I);pwh(J);return 0}function Leg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;Slh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[898128]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return f|0}RI(2978896)|0;if(a[2979044]|0){h=c[898136]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898134]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[898136]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898134]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[898132]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898130]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[898132]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898130]|0;Qag(m,n,l);pwh(m);return 0}function Meg(e,f,g,h,j,k){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;Tlh();if(!f){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[898140]|0);pwh(l)}if(!j){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[898142]|0);pwh(l)}if((g|0)>=0?(l=c[f+12>>2]|0,(l|0)>=(g|0)):0){if((h|0)<0|(l-g|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){m=c[898150]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898148]|0;Qag(n,o,m);pwh(n)}RI(2978896)|0;rwh(2978896);m=c[898150]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898148]|0;Qag(n,o,m);pwh(n)}if((k|0)>=0?(n=c[j+12>>2]|0,(n|0)>=(k|0)):0){if((n-k|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){p=c[898156]|0;RI(2965048)|0;q=qL(2965048)|0;Rbg(q,p);pwh(q)}RI(2978896)|0;rwh(2978896);p=c[898156]|0;RI(2965048)|0;q=qL(2965048)|0;Rbg(q,p);pwh(q)}if((h|0)<=0){i=e;return h|0}q=f+16|0;p=j+16|0;n=c[(c[f>>2]|0)+120>>2]|0;f=k;k=g;g=h;while(1){g=g+-1|0;m=d[q+(da(n,k)|0)>>0]|0;b[p+(da(c[(c[j>>2]|0)+120>>2]|0,f)|0)>>1]=m;if((g|0)<=0)break;else{f=f+1|0;k=k+1|0}}i=e;return h|0}RI(2978896)|0;if(a[2979044]|0){r=c[898154]|0;RI(2964880)|0;s=qL(2964880)|0;t=c[898152]|0;Qag(s,t,r);pwh(s)}RI(2978896)|0;rwh(2978896);r=c[898154]|0;RI(2964880)|0;s=qL(2964880)|0;t=c[898152]|0;Qag(s,t,r);pwh(s)}RI(2978896)|0;if(a[2979044]|0){u=c[898146]|0;RI(2964880)|0;v=qL(2964880)|0;w=c[898144]|0;Qag(v,w,u);pwh(v)}RI(2978896)|0;rwh(2978896);u=c[898146]|0;RI(2964880)|0;v=qL(2964880)|0;w=c[898144]|0;Qag(v,w,u);pwh(v);return 0}function Neg(b,d){b=b|0;d=d|0;b=i;Ulh();if((d|0)>-1){i=b;return d|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898162]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898160]|0,d);pwh(b);return 0}function Oeg(b,d){b=b|0;d=d|0;b=i;Vlh();if((d|0)>-1){i=b;return d|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898168]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898166]|0,d);pwh(b);return 0}function Peg(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;Wlh();if(!f){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[898172]|0);pwh(j)}if((g|0)>=0?(j=c[f+12>>2]|0,(j|0)>=(g|0)):0){if((h|0)<0|(j-g|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){k=c[898180]|0;RI(2964880)|0;l=qL(2964880)|0;m=c[898178]|0;Qag(l,m,k);pwh(l)}RI(2978896)|0;rwh(2978896);k=c[898180]|0;RI(2964880)|0;l=qL(2964880)|0;m=c[898178]|0;Qag(l,m,k);pwh(l)}if(!h){if(!(a[2540708]|0))rwh(2540560);n=c[c[635163]>>2]|0;i=e;return n|0}if(!j)o=0;else o=f+16|0;if(!(a[2540708]|0))rwh(2540560);f=ivf(0,h)|0;j=bvf(0)|0;l=h+g|0;h=o+l|0;if((l|0)<=(g|0)){n=f;i=e;return n|0}l=o+g|0;g=f+j|0;while(1){b[g>>1]=d[l>>0]|0;l=l+1|0;if(l>>>0>=h>>>0){n=f;break}else g=g+2|0}i=e;return n|0}RI(2978896)|0;if(a[2979044]|0){p=c[898176]|0;RI(2964880)|0;q=qL(2964880)|0;r=c[898174]|0;Qag(q,r,p);pwh(q)}RI(2978896)|0;rwh(2978896);p=c[898176]|0;RI(2964880)|0;q=qL(2964880)|0;r=c[898174]|0;Qag(q,r,p);pwh(q);return 0}function Qeg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Xlh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[898184]|0);pwh(e)}else{e=Gwh(2995656,a,b,0,c[b+12>>2]|0)|0;i=d;return e|0}return 0}function Reg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;Seg(a,b,c,d,e,2147483647);i=f;return}function Seg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;Ylh();if(!d){if(!(a[2540708]|0))rwh(2540560);o=c[c[635163]>>2]|0}else o=d;if((e|0)<=-1){c[k>>2]=e;RI(2540224)|0;d=pL(2540224,k)|0;RI(2964880)|0;k=qL(2964880)|0;Teg(k,c[898188]|0,d,c[898190]|0);pwh(k)}if((f|0)<=-1){c[l>>2]=f;RI(2540224)|0;k=pL(2540224,l)|0;RI(2964880)|0;l=qL(2964880)|0;Teg(l,c[898192]|0,k,c[898194]|0);pwh(l)}if((g|0)<=-1){c[m>>2]=g;RI(2540224)|0;l=pL(2540224,m)|0;RI(2964880)|0;m=qL(2964880)|0;Teg(m,c[898196]|0,l,c[898198]|0);pwh(m)}if((h|0)<=0){RI(2964880)|0;m=qL(2964880)|0;Qag(m,c[898200]|0,c[898202]|0);pwh(m)}if((g|0)>(h|0)){RI(2964880)|0;m=qL(2964880)|0;Qag(m,c[898204]|0,c[898206]|0);pwh(m)}if(((Vof(o)|0)-f|0)<(e|0)){c[n>>2]=e;RI(2540224)|0;m=pL(2540224,n)|0;RI(2964880)|0;n=qL(2964880)|0;Teg(n,c[898208]|0,m,c[898210]|0);pwh(n)}if(!g)if((h|0)<17){if(!(a[2540708]|0))rwh(2540560);n=c[c[635163]>>2]|0;c[b+16>>2]=n;c[b+12>>2]=n;p=0}else p=16;else p=g;c[b+20>>2]=h;h=b+12|0;g=c[h>>2]|0;if(!g){if(!(a[2540708]|0))rwh(2540560);n=ivf(0,(p|0)<(f|0)?f:p)|0;c[h>>2]=n;q=n}else q=g;if((f|0)<1){r=b+8|0;c[r>>2]=f;i=j;return}if(!(a[2540708]|0))rwh(2540560);Gwf(0,q,0,o,e,f);r=b+8|0;c[r>>2]=f;i=j;return}function Teg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Rag(a,e,b);c[a+56>>2]=d;KHf(a,-2146233086);i=f;return}function Ueg(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[2540708]|0))rwh(2540560);Seg(b,c[c[635163]>>2]|0,0,0,d,2147483647);i=e;return}function Veg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;do if(!d)if(!(a[2540708]|0)){rwh(2540560);g=c[c[635163]>>2]|0;h=0;break}else{g=c[c[635163]>>2]|0;h=0;break}else{g=d;h=Vof(d)|0}while(0);Seg(b,g,0,h,e,2147483647);i=f;return}function Weg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;Zlh();r9f(b,c[898340]|0,c[a+20>>2]|0);e=Xeg(a)|0;r9f(b,c[898342]|0,e);e=Fqh(2972072,a)|0;L7f(b,c[898344]|0,e);r9f(b,c[898346]|0,0);i=d;return}function Xeg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+12|0;if(!(Vof(c[d>>2]|0)|0)){e=Bsg(0,c[a+20>>2]|0,16)|0;i=b;return e|0}else{e=Vof(c[d>>2]|0)|0;i=b;return e|0}return 0}function Yeg(a){a=a|0;return c[a+8>>2]|0}function Zeg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((b|0)>=0?(c[a+20>>2]|0)>=(b|0):0){e=a+8|0;f=c[e>>2]|0;if((f|0)==(b|0)){i=d;return}if((f|0)>(b|0)){$eg(a,b);c[e>>2]=b;i=d;return}else{afg(a,0,b-f|0)|0;i=d;return}}RI(2964880)|0;d=qL(2964880)|0;_eg(d);pwh(d)}function _eg(a){a=a|0;var b=0;b=i;_mh();Rbg(a,tof(0,c[899336]|0)|0);KHf(a,-2146233086);i=b;return}function $eg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;bmh();f=b+12|0;if((Vof(c[f>>2]|0)|0)>=(d|0)){g=b+16|0;h=c[g>>2]|0;if((h|0)==(c[f>>2]|0))j=h;else{k=g;c[k>>2]=0;i=e;return}}else j=c[f>>2]|0;g=Vof(j)|0;if((g|0)<(d|0)){j=((g|0)>15?1:(c[b+16>>2]|0)!=(c[f>>2]|0))?g<<1:32;h=(j|0)<(d|0)?d:j;j=(h|0)!=2147483647&(h|0)>-1?h:2147483647;h=c[b+20>>2]|0;l=(j|0)<=(h|0)|(h|0)<(d|0)?j:h;if((l|0)>(h|0)){RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[898426]|0,c[898428]|0);pwh(h)}else m=l}else m=g;if(!(a[2540708]|0))rwh(2540560);g=ivf(0,m)|0;m=c[b+8>>2]|0;if((m|0)>=1){l=c[f>>2]|0;if(!(a[2540708]|0))rwh(2540560);Gwf(0,g,0,l,0,m)}c[f>>2]=g;k=b+16|0;c[k>>2]=0;i=e;return}function afg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if((d|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;_eg(f);pwh(f)}f=a+8|0;$eg(a,(c[f>>2]|0)+d|0);if((d|0)<=0){i=e;return a|0}g=a+12|0;h=0;do{j=c[g>>2]|0;k=c[f>>2]|0;c[f>>2]=k+1;qwf(j,k,b);h=h+1|0}while((h|0)!=(d|0));i=e;return a|0}function bfg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((b|0)>-1?(c[a+8>>2]|0)>(b|0):0){e=Wof(c[a+12>>2]|0,b)|0;i=d;return e|0}else{RI(3084024)|0;e=qL(3084024)|0;hsg(e);pwh(e)}return 0}function cfg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a+8>>2]|0;if(!((f|0)>(b|0)&(b|0)>-1)){RI(3084024)|0;g=qL(3084024)|0;hsg(g);pwh(g)}if(!(c[a+16>>2]|0)){h=a+12|0;j=c[h>>2]|0;qwf(j,b,d);i=e;return}$eg(a,f);h=a+12|0;j=c[h>>2]|0;qwf(j,b,d);i=e;return}function dfg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+8|0;f=c[e>>2]|0;if(!f){if(!(a[2540708]|0))rwh(2540560);g=c[c[635163]>>2]|0;i=d;return g|0}h=b+16|0;j=c[h>>2]|0;if(j){g=j;i=d;return g|0}j=b+12|0;b=(f|0)<((Vof(c[j>>2]|0)|0)>>1|0);f=c[j>>2]|0;if(b){b=hvf(f,0,c[e>>2]|0)|0;c[h>>2]=b;g=b;i=d;return g|0}else{c[h>>2]=f;rwf(f,c[e>>2]|0);g=c[j>>2]|0;i=d;return g|0}return 0}function efg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((e|d|0)>=0?(g=b+8|0,h=c[g>>2]|0,(h-e|0)>=(d|0)):0){if(!(c[b+16>>2]|0))j=h;else{$eg(b,h);j=c[g>>2]|0}h=e+d|0;k=j-h|0;if((k|0)<1){l=j;m=l-e|0;c[g>>2]=m;i=f;return b|0}j=c[b+12>>2]|0;if(!(a[2540708]|0))rwh(2540560);Gwf(0,j,d,j,h,k);l=c[g>>2]|0;m=l-e|0;c[g>>2]=m;i=f;return b|0}RI(2964880)|0;b=qL(2964880)|0;_eg(b);pwh(b);return 0}function ffg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;_lh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[898378]|0);pwh(j)}if((g|f|0)<0){RI(2964880)|0;k=qL(2964880)|0;_eg(k);pwh(k)}j=b+8|0;if(((c[j>>2]|0)-g|0)<(f|0)){RI(2964880)|0;k=qL(2964880)|0;_eg(k);pwh(k)}if(!(Vof(d)|0)){RI(2965048)|0;k=qL(2965048)|0;Rbg(k,c[898380]|0);pwh(k)}k=b+12|0;l=fpf(c[k>>2]|0,f,g)|0;m=Rvf(l,d,e)|0;if((m|0)==(l|0)){i=h;return b|0}l=Vof(m)|0;$eg(b,l-g+(c[j>>2]|0)|0);if((Vof(m)|0)>=(g|0)){if((Vof(m)|0)>(g|0)){l=c[k>>2]|0;e=Vof(m)|0;d=c[k>>2]|0;n=c[j>>2]|0;if(!(a[2540708]|0))rwh(2540560);o=g+f|0;Hwf(0,l,e+f|0,d,o,n-o|0)}}else{o=c[k>>2]|0;n=Vof(m)|0;d=c[k>>2]|0;e=c[j>>2]|0;if(!(a[2540708]|0))rwh(2540560);l=g+f|0;Gwf(0,o,n+f|0,d,l,e-l|0)}l=c[k>>2]|0;k=Vof(m)|0;if(!(a[2540708]|0))rwh(2540560);Gwf(0,l,f,m,0,k);k=Vof(m)|0;c[j>>2]=k-g+(c[j>>2]|0);i=h;return b|0}function gfg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Hbg(a,spf(e)|0)|0;i=d;return b|0}function hfg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;c[g>>2]=b;c[g+4>>2]=d;d=Hbg(a,hqf(f)|0)|0;i=e;return d|0}function ifg(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(!b){d=a;i=c;return d|0}d=Hbg(a,Fqh(2536904,b)|0)|0;i=c;return d|0}function jfg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;$lh();if(!d)if((e|0)!=0&(f|0)!=0){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[898418]|0);pwh(h)}else{i=g;return b|0}if((f|e|0)<0){RI(2964880)|0;j=qL(2964880)|0;_eg(j);pwh(j)}if(((Vof(d)|0)-f|0)<(e|0)){RI(2964880)|0;j=qL(2964880)|0;_eg(j);pwh(j)}j=b+8|0;h=(c[j>>2]|0)+f|0;k=b+12|0;if(!((c[b+16>>2]|0)==0?(Vof(c[k>>2]|0)|0)>=(h|0):0))$eg(b,h);l=c[k>>2]|0;k=c[j>>2]|0;if(!(a[2540708]|0))rwh(2540560);Gwf(0,l,k,d,e,f);c[j>>2]=h;i=g;return b|0}function kfg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;if(!(a[2540708]|0))rwh(2540560);dwf(0,b,c,d,e)|0;i=f;return b|0}function lfg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=b+8|0;if(!((d|0)>-1?(c[g>>2]|0)>=(d|0):0)){RI(2964880)|0;h=qL(2964880)|0;_eg(h);pwh(h)}if(!e){i=f;return b|0}if(!(Vof(e)|0)){i=f;return b|0}h=c[g>>2]|0;$eg(b,(Vof(e)|0)+h|0);h=b+12|0;j=c[h>>2]|0;k=Vof(e)|0;l=c[h>>2]|0;m=c[g>>2]|0;if(!(a[2540708]|0))rwh(2540560);Hwf(0,j,k+d|0,l,d,m-d|0);m=c[h>>2]|0;Gwf(0,m,d,e,0,Vof(e)|0);d=c[g>>2]|0;c[g>>2]=(Vof(e)|0)+d;i=f;return b|0}function mfg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;amh();g=b+8|0;h=c[g>>2]|0;if(!((h|0)>=(d|0)&(d|0)>-1)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[898422]|0);pwh(j)}$eg(b,h+1|0);h=b+12|0;j=c[h>>2]|0;k=c[g>>2]|0;if(!(a[2540708]|0))rwh(2540560);Hwf(0,j,d+1|0,j,d,k-d|0);qwf(c[h>>2]|0,d,e);c[g>>2]=(c[g>>2]|0)+1;i=f;return b|0}function nfg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;if((f|0)<=-1){RI(2964880)|0;h=qL(2964880)|0;_eg(h);pwh(h)}if(!e){i=g;return b|0}if(!(a[2540708]|0))rwh(2540560);if((Iwf(0,e,c[c[635163]>>2]|0)|0)&(f|0)>0)j=0;else{i=g;return b|0}do{lfg(b,d,e)|0;j=j+1|0}while((j|0)!=(f|0));i=g;return b|0}function ofg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2584640)|0;Kwf(a,sM(2999440)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function pfg(b,d){b=b|0;d=d|0;var e=0;e=i;Rcg(b);a[b+16>>0]=d&1;c[b+20>>2]=-1;i=e;return}function qfg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;cmh();Acg(b,d?12001:12e3);a[b+48>>0]=d&1;a[b+49>>0]=e&1;if(f){RI(2986584)|0;if(!(a[2986732]|0)){RI(2986584)|0;rwh(2986584)}f=Pdg(0)|0;RI(2982584)|0;if(!(a[2982732]|0)){RI(2982584)|0;rwh(2982584)}e=kdg(0)|0;if(f)c[b+24>>2]=f;if(e)c[b+20>>2]=e}else{RI(2987560)|0;e=qL(2987560)|0;Odg(e,c[898454]|0);RI(2981160)|0;f=qL(2981160)|0;jdg(f,c[898456]|0);if(e)c[b+24>>2]=e;if(f)c[b+20>>2]=f}if(d){c[b+28>>2]=c[898458];c[b+32>>2]=c[898460];c[b+36>>2]=c[898462];h=3593856;j=c[h>>2]|0;k=b+44|0;c[k>>2]=j;l=b+12|0;c[l>>2]=12e3;i=g;return}else{c[b+28>>2]=c[898466];c[b+32>>2]=c[898468];c[b+36>>2]=c[898470];h=3593888;j=c[h>>2]|0;k=b+44|0;c[k>>2]=j;l=b+12|0;c[l>>2]=12e3;i=g;return}}function rfg(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;dmh();if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[898498]|0);pwh(h)}if((f|0)>=0?(h=e+12|0,j=c[h>>2]|0,(j|0)>=(f|0)):0){if((g|0)<0|(j-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){k=c[898506]|0;RI(2964880)|0;l=qL(2964880)|0;m=c[898504]|0;Qag(l,m,k);pwh(l)}RI(2978896)|0;rwh(2978896);k=c[898506]|0;RI(2964880)|0;l=qL(2964880)|0;m=c[898504]|0;Qag(l,m,k);pwh(l)}l=g+f|0;if((g|0)<=0){n=0;i=d;return n|0}g=e+16|0;k=f+1|0;m=(l|0)>(k|0)?l:k;k=f;do{RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}j=k;k=k+1|0;if(quf(0,b[g+(da(c[(c[e>>2]|0)+120>>2]|0,j)|0)>>1]|0)|0?(k|0)<(c[h>>2]|0):0){RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}quf(0,b[g+(da(c[(c[e>>2]|0)+120>>2]|0,k)|0)>>1]|0)|0}}while((k|0)<(l|0));n=m-f<<2;i=d;return n|0}RI(2978896)|0;if(a[2979044]|0){o=c[898502]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898500]|0;Qag(p,q,o);pwh(p)}RI(2978896)|0;rwh(2978896);o=c[898502]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898500]|0;Qag(p,q,o);pwh(p);return 0}function sfg(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=i;emh();if(!f){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[898510]|0);pwh(m)}if(!j){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[898512]|0);pwh(m)}if((g|0)>=0?(m=c[f+12>>2]|0,(m|0)>=(g|0)):0){if((h|0)<0|(m-g|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){n=c[898520]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[898518]|0;Qag(o,p,n);pwh(o)}RI(2978896)|0;rwh(2978896);n=c[898520]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[898518]|0;Qag(o,p,n);pwh(o)}if((k|0)>=0?(o=c[j+12>>2]|0,(o|0)>=(k|0)):0){if((o-k|0)<(h<<2|0)){RI(2978896)|0;if(a[2979044]|0){q=c[898526]|0;RI(2965048)|0;r=qL(2965048)|0;Rbg(r,q);pwh(r)}RI(2978896)|0;rwh(2978896);q=c[898526]|0;RI(2965048)|0;r=qL(2965048)|0;Rbg(r,q);pwh(r)}if((h|0)<=0){s=k;t=s-k|0;i=l;return t|0}r=f+16|0;q=d+48|0;d=j+16|0;o=g;g=h;h=k;while(1){n=g+-1|0;p=o+1|0;m=b[r+(da(c[(c[f>>2]|0)+120>>2]|0,o)|0)>>1]|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}do if(quf(0,m)|0){u=g+-2|0;if((g|0)<2){v=h+1|0;w=d+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)|0;if(!(a[q>>0]|0)){a[w>>0]=63;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,v)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+2|0)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+3|0)|0)>>0]=0;x=p;y=u;break}else{a[w>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,v)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+2|0)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+3|0)|0)>>0]=63;x=p;y=u;break}}else{v=o+2|0;w=(((m&65535)<<10)+10485760&67107840)+9216+(e[r+(da(c[(c[f>>2]|0)+120>>2]|0,p)|0)>>1]|0)|0;if(!(a[q>>0]|0)){a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=w;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+1|0)|0)>>0]=w>>>8;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+2|0)|0)>>0]=w>>>16;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+3|0)|0)>>0]=w>>>24;x=v;y=u;break}else{a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+3|0)|0)>>0]=w;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+2|0)|0)>>0]=w>>>8;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+1|0)|0)>>0]=w>>>16;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=w>>>24;x=v;y=u;break}}}else{u=h+1|0;if(!(a[q>>0]|0)){a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=m;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,u)|0)>>0]=(m&65535)>>>8;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+2|0)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+3|0)|0)>>0]=0;x=p;y=n;break}else{a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,u)|0)>>0]=0;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+2|0)|0)>>0]=(m&65535)>>>8;a[d+(da(c[(c[j>>2]|0)+120>>2]|0,h+3|0)|0)>>0]=m;x=p;y=n;break}}while(0);n=h+4|0;if((y|0)>0){o=x;g=y;h=n}else{s=n;break}}t=s-k|0;i=l;return t|0}RI(2978896)|0;if(a[2979044]|0){z=c[898524]|0;RI(2964880)|0;A=qL(2964880)|0;B=c[898522]|0;Qag(A,B,z);pwh(A)}RI(2978896)|0;rwh(2978896);z=c[898524]|0;RI(2964880)|0;A=qL(2964880)|0;B=c[898522]|0;Qag(A,B,z);pwh(A)}RI(2978896)|0;if(a[2979044]|0){C=c[898516]|0;RI(2964880)|0;D=qL(2964880)|0;E=c[898514]|0;Qag(D,E,C);pwh(D)}RI(2978896)|0;rwh(2978896);C=c[898516]|0;RI(2964880)|0;D=qL(2964880)|0;E=c[898514]|0;Qag(D,E,C);pwh(D);return 0}function tfg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;fmh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[898530]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return (f|0)/4|0|0}RI(2978896)|0;if(a[2979044]|0){h=c[898538]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898536]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[898538]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898536]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[898534]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898532]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[898534]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898532]|0;Qag(m,n,l);pwh(m);return 0}function ufg(e,f,g,h,j,k){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=i;gmh();if(!f){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[898542]|0);pwh(m)}if(!j){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[898544]|0);pwh(m)}if((g|0)>=0?(m=c[f+12>>2]|0,(m|0)>=(g|0)):0){if((h|0)<0|(m-g|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){n=c[898552]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[898550]|0;Qag(o,p,n);pwh(o)}RI(2978896)|0;rwh(2978896);n=c[898552]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[898550]|0;Qag(o,p,n);pwh(o)}if((k|0)>=0?(o=c[j+12>>2]|0,(o|0)>=(k|0)):0){if((o-k|0)<((h|0)/4|0|0)){RI(2978896)|0;if(a[2979044]|0){q=c[898558]|0;RI(2965048)|0;r=qL(2965048)|0;Rbg(r,q);pwh(r)}RI(2978896)|0;rwh(2978896);q=c[898558]|0;RI(2965048)|0;r=qL(2965048)|0;Rbg(r,q);pwh(r)}r=(h|0)>3;if(!(a[e+48>>0]|0)){if(!r){s=k;t=s-k|0;i=l;return t|0}e=f+16|0;q=j+16|0;o=((h+-4|0)>>>2)+k|0;n=c[(c[f>>2]|0)+120>>2]|0;p=h;m=g;u=k;while(1){v=d[e+(da(n,m)|0)>>0]|0;w=(d[e+(da(n,m+1|0)|0)>>0]<<8|v)&65535;b[q+(da(c[(c[j>>2]|0)+120>>2]|0,u)|0)>>1]=w;p=p+-4|0;if((p|0)<=3)break;else{m=m+4|0;u=u+1|0}}s=o+1|0;t=s-k|0;i=l;return t|0}else{if(!r){s=k;t=s-k|0;i=l;return t|0}r=f+16|0;o=j+16|0;u=((h+-4|0)>>>2)+k|0;m=c[(c[f>>2]|0)+120>>2]|0;f=g;g=h;h=k;while(1){p=d[r+(da(m,f+2|0)|0)>>0]<<8;q=(p|d[r+(da(m,f+3|0)|0)>>0])&65535;b[o+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>1]=q;g=g+-4|0;if((g|0)<=3)break;else{f=f+4|0;h=h+1|0}}s=u+1|0;t=s-k|0;i=l;return t|0}}RI(2978896)|0;if(a[2979044]|0){x=c[898556]|0;RI(2964880)|0;y=qL(2964880)|0;z=c[898554]|0;Qag(y,z,x);pwh(y)}RI(2978896)|0;rwh(2978896);x=c[898556]|0;RI(2964880)|0;y=qL(2964880)|0;z=c[898554]|0;Qag(y,z,x);pwh(y)}RI(2978896)|0;if(a[2979044]|0){A=c[898548]|0;RI(2964880)|0;B=qL(2964880)|0;C=c[898546]|0;Qag(B,C,A);pwh(B)}RI(2978896)|0;rwh(2978896);A=c[898548]|0;RI(2964880)|0;B=qL(2964880)|0;C=c[898546]|0;Qag(B,C,A);pwh(B);return 0}function vfg(b,d){b=b|0;d=d|0;b=i;hmh();if((d|0)>-1){i=b;return d<<2|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898564]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898562]|0,d);pwh(b);return 0}function wfg(b,d){b=b|0;d=d|0;b=i;imh();if((d|0)>-1){i=b;return (d|0)/4|0|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898570]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898568]|0,d);pwh(b);return 0}function xfg(b){b=b|0;var c=0,d=0;c=i;d=(a[b+48>>0]|0)!=0;RI(2999712)|0;b=qL(2999712)|0;pfg(b,d);i=c;return b|0}function yfg(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=(a[b+49>>0]|0)==0;RI(1159264)|0;if(e){f=twh(1159264,0)|0;i=d;return f|0}e=twh(1159264,4)|0;g=e+16|0;if(!(a[b+48>>0]|0)){a[g>>0]=-1;a[g+(c[(c[e>>2]|0)+120>>2]|0)>>0]=-2;f=e;i=d;return f|0}else{a[g+(c[(c[e>>2]|0)+120>>2]<<1)>>0]=-2;a[g+((c[(c[e>>2]|0)+120>>2]|0)*3|0)>>0]=-1;f=e;i=d;return f|0}return 0}function zfg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2991648)|0;f=vL(d,2991648)|0;if((((f|0)!=0?(c[b+8>>2]|0)==(c[f+8>>2]|0):0)?(a[b+48>>0]|0)==(a[f+48>>0]|0):0)?(a[b+49>>0]|0)==(a[f+49>>0]|0):0)g=eeg(b,d)|0;else g=0;i=e;return g|0}function Afg(b){b=b|0;var c=0,d=0,e=0;c=i;d=teg(b)|0;e=(a[b+48>>0]|0)==0?d:d^31;i=c;return ((a[b+49>>0]|0)==0?e:e^63)|0}function Bfg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=veg(a,b,c,d)|0;i=e;return f|0}function Cfg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(3001264)|0);c[c[d>>2]>>2]=a;i=b;return}function Dfg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(3001264)|0);c[c[d>>2]>>2]=a;i=b;return}function Efg(a){a=a|0;var b=0;b=i;Rcg(a);c[a+16>>2]=0;i=b;return}function Ffg(b,d){b=b|0;d=d|0;var e=0;e=i;jmh();Acg(b,65e3);a[b+48>>0]=d&1;c[b+28>>2]=c[898574];c[b+32>>2]=c[898576];c[b+36>>2]=c[898578];a[b+40>>0]=1;a[b+41>>0]=1;c[b+44>>2]=c[898580];c[b+12>>2]=1200;i=e;return}function Gfg(a){a=a|0;var b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;RI(1159264)|0;f=twh(1159264,128)|0;c[d>>2]=3140400;c[b+0>>2]=c[d+0>>2];Guf(0,f,b);RI(2991312)|0;c[c[747851]>>2]=f;RI(1169800)|0;f=twh(1169800,256)|0;c[e>>2]=3140440;c[b+0>>2]=c[e+0>>2];Guf(0,f,b);RI(2991312)|0;c[(c[747851]|0)+4>>2]=f;i=a;return}function Hfg(b){b=b|0;var c=0,d=0;c=i;d=teg(b)|0;i=c;return ((a[b+48>>0]|0)==0?d:0-d|0)|0}function Ifg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2991312)|0;f=vL(d,2991312)|0;if(!f){g=0;i=e;return g|0}if((a[b+48>>0]|0)!=(a[f+48>>0]|0)){g=0;i=e;return g|0}if(!(nrh(2536048,c[b+24>>2]|0,c[f+24>>2]|0)|0)){g=0;i=e;return g|0}g=nrh(2536048,c[b+20>>2]|0,c[f+20>>2]|0)|0;i=e;return g|0}function Jfg(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;kmh();if(!f){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[898596]|0);pwh(n)}if((g|0)>=0?(n=c[f+12>>2]|0,(n|0)>=(g|0)):0){if((h|0)<0|(n-g|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){o=c[898604]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898602]|0;Qag(p,q,o);pwh(p)}RI(2978896)|0;rwh(2978896);o=c[898604]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898602]|0;Qag(p,q,o);pwh(p)}RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}RI(2991312)|0;p=c[c[747851]>>2]|0;o=f+16|0;q=p+16|0;n=g;g=h;h=l;l=0;r=k>>8;a:while(1){k=n;s=g;while(1){if((s|0)<=0){t=h;u=l;v=r;break a}w=k+1|0;x=b[o+(da(c[(c[f>>2]|0)+120>>2]|0,k)|0)>>1]|0;y=s+-1|0;if((x&65535)>127){z=y;A=w;B=16;break}C=d[q+(da(c[(c[p>>2]|0)+120>>2]|0,x&65535)|0)>>0]|0;if((C|0)==1){D=y;E=w;break}else if(!C){z=y;A=w;B=16;break}else if((C|0)==2){F=w;G=y;B=21;break}else if((C|0)==3){H=w;I=y;B=22;break}else{k=w;s=y}}if((B|0)==21){B=0;if(m){D=G;E=F}else{z=G;A=F;B=16}}else if((B|0)==22){B=0;if(h){J=l+1+((r|0)!=0&1)|0;K=0}else{J=l;K=r}n=H;g=I;h=0;l=J+2|0;r=K;continue}if((B|0)==16){B=0;s=h&1^1;k=r+16|0;y=h?k:16;if((y|0)<=5){n=A;g=z;h=1;l=s+l|0;r=k;continue}k=y+-6|0;y=(k>>>0)/6|0;n=A;g=z;h=1;l=l+1+s+y|0;r=k+(da(y,-6)|0)|0;continue}if(h){L=l+1+((r|0)!=0&1)|0;M=0}else{L=l;M=r}n=E;g=D;h=0;l=L+1|0;r=M}if(!(t&j)){N=u;i=e;return N|0}N=u+1+((v|0)!=0&1)|0;i=e;return N|0}RI(2978896)|0;if(a[2979044]|0){O=c[898600]|0;RI(2964880)|0;P=qL(2964880)|0;Q=c[898598]|0;Qag(P,Q,O);pwh(P)}RI(2978896)|0;rwh(2978896);O=c[898600]|0;RI(2964880)|0;P=qL(2964880)|0;Q=c[898598]|0;Qag(P,Q,O);pwh(P);return 0}function Kfg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=(a[b+48>>0]|0)!=0;RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}b=Jfg(0,c,d,e,1,0,0,g)|0;i=f;return b|0}function Lfg(e,f,g,h,j,k,l,m,n,o){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;e=i;lmh();if(!f){RI(2963920)|0;p=qL(2963920)|0;Iag(p,c[898608]|0);pwh(p)}if(!j){RI(2963920)|0;p=qL(2963920)|0;Iag(p,c[898610]|0);pwh(p)}if((g|0)>=0?(p=c[f+12>>2]|0,(p|0)>=(g|0)):0){if((h|0)<0|(p-g|0)<(h|0)){RI(2978896)|0;if(a[2979044]|0){q=c[898618]|0;RI(2964880)|0;r=qL(2964880)|0;s=c[898616]|0;Qag(r,s,q);pwh(r)}RI(2978896)|0;rwh(2978896);q=c[898618]|0;RI(2964880)|0;r=qL(2964880)|0;s=c[898616]|0;Qag(r,s,q);pwh(r)}if((k|0)>=0?(r=c[j+12>>2]|0,(r|0)>=(k|0)):0){q=c[m>>2]|0;RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}RI(2991312)|0;s=c[c[747851]>>2]|0;p=c[898624]|0;t=f+16|0;u=s+16|0;v=j+16|0;w=g;g=h;h=k;x=q>>8;y=q&255;a:while(1){q=w;z=g;A=x;B=y;b:while(1){C=q;D=z;while(1){if((D|0)<=0){E=h;F=A;G=B;H=75;break a}I=C+1|0;J=b[t+(da(c[(c[f>>2]|0)+120>>2]|0,C)|0)>>1]|0;K=J&65535;L=D+-1|0;if((J&65535)>127){M=L;N=I;O=K;break}P=d[u+(da(c[(c[s>>2]|0)+120>>2]|0,K)|0)>>0]|0;if(!P){M=L;N=I;O=K;break}else if((P|0)==2){Q=J;R=K;S=L;T=I;H=53;break}else if((P|0)==3){U=L;V=I;W=A;X=B;H=54;break b}else if((P|0)==1){Y=J;Z=L;_=I;$=A;aa=B;H=36;break b}else{C=I;D=L}}if((H|0)==53){H=0;if(o){Y=Q;Z=S;_=T;$=A;aa=B;H=36;break}else{M=S;N=T;O=R}}if(!(a[n>>0]|0)){ba=M;ca=O;ea=N;fa=B;H=24;break}D=O|B<<16;C=A+16|0;if((C|0)>5){ga=N;ha=M;ia=h;ja=C;ka=D;break}else{q=N;z=M;A=C;B=D}}if((H|0)==24){H=0;if((h|0)>=(r|0)){H=25;break}a[v+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=43;a[n>>0]=1;ga=ea;ha=ba;ia=h+1|0;ja=16;ka=ca|fa<<16}else if((H|0)==36){H=0;if(!(a[n>>0]|0)){la=h;ma=$;na=aa}else{if(!$)oa=h;else{if((h|0)>=(r|0)){H=39;break}B=(Wof(p,aa<<(6-$&31))|0)&255;a[v+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=B;oa=h+1|0}if((oa|0)>=(r|0)){H=44;break}a[v+(da(c[(c[j>>2]|0)+120>>2]|0,oa)|0)>>0]=45;a[n>>0]=0;la=oa+1|0;ma=0;na=0}if((la|0)>=(r|0)){H=49;break}a[v+(da(c[(c[j>>2]|0)+120>>2]|0,la)|0)>>0]=Y;w=_;g=Z;h=la+1|0;x=ma;y=na;continue}else if((H|0)==54){H=0;if(!(a[n>>0]|0)){pa=h;qa=W;ra=X}else{if(!W)sa=h;else{if((h|0)>=(r|0)){H=57;break}B=(Wof(p,X<<(6-W&31))|0)&255;a[v+(da(c[(c[j>>2]|0)+120>>2]|0,h)|0)>>0]=B;sa=h+1|0}if((sa|0)>=(r|0)){H=62;break}a[v+(da(c[(c[j>>2]|0)+120>>2]|0,sa)|0)>>0]=45;a[n>>0]=0;pa=sa+1|0;qa=0;ra=0}B=pa+2|0;if((B|0)>(r|0)){H=67;break}a[v+(da(c[(c[j>>2]|0)+120>>2]|0,pa)|0)>>0]=43;a[v+(da(c[(c[j>>2]|0)+120>>2]|0,pa+1|0)|0)>>0]=45;w=V;g=U;h=B;x=qa;y=ra;continue}B=ia;A=ja;z=ka;while(1){if((B|0)>=(r|0)){H=31;break a}q=A+-6|0;D=B+1|0;C=q&31;L=(Wof(p,z>>C)|0)&255;a[v+(da(c[(c[j>>2]|0)+120>>2]|0,B)|0)>>0]=L;L=(1<<C)+-1&z;if((q|0)>5){B=D;A=q;z=L}else{w=ga;g=ha;h=D;x=q;y=L;continue a}}}if((H|0)==25){RI(2978896)|0;if(a[2979044]|0){ta=c[898626]|0;RI(2965048)|0;ua=qL(2965048)|0;va=c[898628]|0;Rag(ua,ta,va);pwh(ua)}RI(2978896)|0;rwh(2978896);ta=c[898626]|0;RI(2965048)|0;ua=qL(2965048)|0;va=c[898628]|0;Rag(ua,ta,va);pwh(ua)}else if((H|0)==31){RI(2978896)|0;if(a[2979044]|0){wa=c[898630]|0;RI(2965048)|0;xa=qL(2965048)|0;ya=c[898632]|0;Rag(xa,wa,ya);pwh(xa)}RI(2978896)|0;rwh(2978896);wa=c[898630]|0;RI(2965048)|0;xa=qL(2965048)|0;ya=c[898632]|0;Rag(xa,wa,ya);pwh(xa)}else if((H|0)==39){RI(2978896)|0;if(a[2979044]|0){za=c[898634]|0;RI(2965048)|0;Aa=qL(2965048)|0;Ba=c[898636]|0;Rag(Aa,za,Ba);pwh(Aa)}RI(2978896)|0;rwh(2978896);za=c[898634]|0;RI(2965048)|0;Aa=qL(2965048)|0;Ba=c[898636]|0;Rag(Aa,za,Ba);pwh(Aa)}else if((H|0)==44){RI(2978896)|0;if(a[2979044]|0){Ca=c[898638]|0;RI(2965048)|0;Da=qL(2965048)|0;Ea=c[898640]|0;Rag(Da,Ca,Ea);pwh(Da)}RI(2978896)|0;rwh(2978896);Ca=c[898638]|0;RI(2965048)|0;Da=qL(2965048)|0;Ea=c[898640]|0;Rag(Da,Ca,Ea);pwh(Da)}else if((H|0)==49){RI(2978896)|0;if(a[2979044]|0){Fa=c[898642]|0;RI(2965048)|0;Ga=qL(2965048)|0;Ha=c[898644]|0;Rag(Ga,Fa,Ha);pwh(Ga)}RI(2978896)|0;rwh(2978896);Fa=c[898642]|0;RI(2965048)|0;Ga=qL(2965048)|0;Ha=c[898644]|0;Rag(Ga,Fa,Ha);pwh(Ga)}else if((H|0)==57){RI(2978896)|0;if(a[2979044]|0){Ia=c[898646]|0;RI(2965048)|0;Ja=qL(2965048)|0;Ka=c[898648]|0;Rag(Ja,Ia,Ka);pwh(Ja)}RI(2978896)|0;rwh(2978896);Ia=c[898646]|0;RI(2965048)|0;Ja=qL(2965048)|0;Ka=c[898648]|0;Rag(Ja,Ia,Ka);pwh(Ja)}else if((H|0)==62){RI(2978896)|0;if(a[2979044]|0){La=c[898650]|0;RI(2965048)|0;Ma=qL(2965048)|0;Na=c[898652]|0;Rag(Ma,La,Na);pwh(Ma)}RI(2978896)|0;rwh(2978896);La=c[898650]|0;RI(2965048)|0;Ma=qL(2965048)|0;Na=c[898652]|0;Rag(Ma,La,Na);pwh(Ma)}else if((H|0)==67){RI(2978896)|0;if(a[2979044]|0){Oa=c[898654]|0;RI(2965048)|0;Pa=qL(2965048)|0;Qa=c[898656]|0;Rag(Pa,Oa,Qa);pwh(Pa)}RI(2978896)|0;rwh(2978896);Oa=c[898654]|0;RI(2965048)|0;Pa=qL(2965048)|0;Qa=c[898656]|0;Rag(Pa,Oa,Qa);pwh(Pa)}else if((H|0)==75){if((a[n>>0]|0)==0|l^1){Ra=E;Sa=F;Ta=G;Ua=Sa<<8;Va=Ua|Ta;c[m>>2]=Va;Wa=Ra-k|0;i=e;return Wa|0}do if(!F)Xa=E;else{if((E|0)<(r|0)){l=(Wof(p,G<<(6-F&31))|0)&255;a[v+(da(c[(c[j>>2]|0)+120>>2]|0,E)|0)>>0]=l;Xa=E+1|0;break}RI(2978896)|0;if(a[2979044]|0){Ya=c[898658]|0;RI(2965048)|0;Za=qL(2965048)|0;_a=c[898660]|0;Rag(Za,Ya,_a);pwh(Za)}RI(2978896)|0;rwh(2978896);Ya=c[898658]|0;RI(2965048)|0;Za=qL(2965048)|0;_a=c[898660]|0;Rag(Za,Ya,_a);pwh(Za)}while(0);a[v+(da(c[(c[j>>2]|0)+120>>2]|0,Xa)|0)>>0]=45;a[n>>0]=0;Ra=Xa+1|0;Sa=0;Ta=0;Ua=Sa<<8;Va=Ua|Ta;c[m>>2]=Va;Wa=Ra-k|0;i=e;return Wa|0}}RI(2978896)|0;if(a[2979044]|0){$a=c[898622]|0;RI(2964880)|0;ab=qL(2964880)|0;bb=c[898620]|0;Qag(ab,bb,$a);pwh(ab)}RI(2978896)|0;rwh(2978896);$a=c[898622]|0;RI(2964880)|0;ab=qL(2964880)|0;bb=c[898620]|0;Qag(ab,bb,$a);pwh(ab)}RI(2978896)|0;if(a[2979044]|0){cb=c[898614]|0;RI(2964880)|0;db=qL(2964880)|0;eb=c[898612]|0;Qag(db,eb,cb);pwh(db)}RI(2978896)|0;rwh(2978896);cb=c[898614]|0;RI(2964880)|0;db=qL(2964880)|0;eb=c[898612]|0;Qag(db,eb,cb);pwh(db);return 0}function Mfg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j;l=j+4|0;c[k>>2]=0;a[l>>0]=0;m=(a[b+48>>0]|0)!=0;RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}b=Lfg(0,d,e,f,g,h,1,k,l,m)|0;i=j;return b|0}function Nfg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=i;mmh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[898696]|0);pwh(h)}if((e|0)>=0?(h=c[d+12>>2]|0,(h|0)>=(e|0)):0){if((f|0)<0|(h-e|0)<(f|0)){RI(2978896)|0;if(a[2979044]|0){j=c[898704]|0;RI(2964880)|0;k=qL(2964880)|0;l=c[898702]|0;Qag(k,l,j);pwh(k)}RI(2978896)|0;rwh(2978896);j=c[898704]|0;RI(2964880)|0;k=qL(2964880)|0;l=c[898702]|0;Qag(k,l,j);pwh(k)}RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}RI(2991312)|0;k=c[(c[747851]|0)+4>>2]|0;if((f|0)<=0){m=0;i=b;return m|0}j=d+16|0;l=c[(c[d>>2]|0)+120>>2]|0;d=k+16|0;h=e;e=f;f=0;n=(g&16777216|0)==0;o=(g&33554432|0)!=0;p=g>>>16&255;a:while(1){g=e;q=h;r=f;s=n;t=o;while(1){u=a[j+(da(l,q)|0)>>0]|0;q=q+1|0;g=g+-1|0;if(!s){v=q;w=u;x=g;y=r;z=t;break}A=u<<24>>24==43;u=(A&1^1)+r|0;if((g|0)<=0){m=u;B=26;break a}else{r=u;s=A^1;t=A|t}}do if(w<<24>>24!=45){if((a[d+(da(c[(c[k>>2]|0)+120>>2]|0,w&255)|0)>>0]|0)==-1){C=y+1|0;D=1;E=0;break}t=p+6|0;if((t|0)<16){C=y;D=0;E=t}else{C=y+1|0;D=0;E=p+-10|0}}else{C=y+(z&1)|0;D=1;E=0}while(0);if((x|0)>0){h=v;e=x;f=C;n=D;o=0;p=E}else{m=C;B=26;break}}if((B|0)==26){i=b;return m|0}}RI(2978896)|0;if(a[2979044]|0){F=c[898700]|0;RI(2964880)|0;G=qL(2964880)|0;H=c[898698]|0;Qag(G,H,F);pwh(G)}RI(2978896)|0;rwh(2978896);F=c[898700]|0;RI(2964880)|0;G=qL(2964880)|0;H=c[898698]|0;Qag(G,H,F);pwh(G);return 0}function Ofg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}f=Nfg(0,c,d,e,0)|0;i=b;return f|0}function Pfg(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;d=i;nmh();if(!e){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[898708]|0);pwh(l)}if(!h){RI(2963920)|0;l=qL(2963920)|0;Iag(l,c[898710]|0);pwh(l)}if((f|0)>=0?(l=c[e+12>>2]|0,(l|0)>=(f|0)):0){if((g|0)<0|(l-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){m=c[898718]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898716]|0;Qag(n,o,m);pwh(n)}RI(2978896)|0;rwh(2978896);m=c[898718]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898716]|0;Qag(n,o,m);pwh(n)}if((j|0)>=0?(n=c[h+12>>2]|0,(n|0)>=(j|0)):0){m=c[k>>2]|0;RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}RI(2991312)|0;o=c[(c[747851]|0)+4>>2]|0;l=e+16|0;p=h+16|0;q=o+16|0;r=f;f=g;g=j;s=(m&16777216|0)==0;t=(m&33554432|0)!=0;u=(m&67108864|0)!=0;v=m>>>16&255;w=m&65535;a:while(1){m=r;x=f;y=g;z=s;A=t;B=u;b:while(1){C=m;D=x;E=z;F=A;while(1){if((D|0)<=0){G=y;H=E;I=F;J=B;K=v;L=w;M=68;break a}N=C+1|0;O=a[l+(da(c[(c[e>>2]|0)+120>>2]|0,C)|0)>>0]|0;P=D+-1|0;if(!E){Q=N;R=O;S=P;T=y;U=F;V=B;break b}if(O<<24>>24==43){C=N;D=P;E=0;F=1}else{W=N;X=O;Y=P;Z=F;break}}if((y|0)>=(n|0)){M=24;break a}if(B){M=28;break a}b[p+(da(c[(c[h>>2]|0)+120>>2]|0,y)|0)>>1]=X&255;m=W;x=Y;y=y+1|0;z=1;A=Z;B=0}if(R<<24>>24==45){if(!U){r=Q;f=S;g=T;s=1;t=0;u=V;v=0;w=0;continue}if((T|0)>=(n|0)){M=35;break}if(V){M=39;break}b[p+(da(c[(c[h>>2]|0)+120>>2]|0,T)|0)>>1]=43;r=Q;f=S;g=T+1|0;s=1;t=0;u=0;v=0;w=0;continue}B=a[q+(da(c[(c[o>>2]|0)+120>>2]|0,R&255)|0)>>0]|0;if(B<<24>>24==-1){if((T|0)>=(n|0)){M=56;break}if(V){M=60;break}b[p+(da(c[(c[h>>2]|0)+120>>2]|0,T)|0)>>1]=R&255;r=Q;f=S;g=T+1|0;s=1;t=0;u=0;v=0;w=0;continue}A=B<<24>>24|w<<6;B=v+6|0;if((B|0)<16){r=Q;f=S;g=T;s=0;t=0;u=V;v=B;w=A;continue}if((T|0)>=(n|0)){M=46;break}B=v+-10|0;z=B&31;y=A>>z;x=y&65535;m=y&64512;if((m|0)!=55296){y=(m|0)!=56320;if(y|V)_=y&V;else{M=51;break}}else _=1;b[p+(da(c[(c[h>>2]|0)+120>>2]|0,T)|0)>>1]=x;r=Q;f=S;g=T+1|0;s=0;t=0;u=_;v=B;w=A&(1<<z)+-1}if((M|0)==24){RI(2978896)|0;if(a[2979044]|0){$=c[898724]|0;RI(2965048)|0;aa=qL(2965048)|0;ba=c[898726]|0;Rag(aa,$,ba);pwh(aa)}RI(2978896)|0;rwh(2978896);$=c[898724]|0;RI(2965048)|0;aa=qL(2965048)|0;ba=c[898726]|0;Rag(aa,$,ba);pwh(aa)}else if((M|0)==28){RI(2978896)|0;if(a[2979044]|0){ca=c[898728]|0;RI(2965048)|0;ea=qL(2965048)|0;fa=c[898730]|0;Rag(ea,ca,fa);pwh(ea)}RI(2978896)|0;rwh(2978896);ca=c[898728]|0;RI(2965048)|0;ea=qL(2965048)|0;fa=c[898730]|0;Rag(ea,ca,fa);pwh(ea)}else if((M|0)==35){RI(2978896)|0;if(a[2979044]|0){ga=c[898732]|0;RI(2965048)|0;ha=qL(2965048)|0;ia=c[898734]|0;Rag(ha,ga,ia);pwh(ha)}RI(2978896)|0;rwh(2978896);ga=c[898732]|0;RI(2965048)|0;ha=qL(2965048)|0;ia=c[898734]|0;Rag(ha,ga,ia);pwh(ha)}else if((M|0)==39){RI(2978896)|0;if(a[2979044]|0){ja=c[898736]|0;RI(2965048)|0;ka=qL(2965048)|0;la=c[898738]|0;Rag(ka,ja,la);pwh(ka)}RI(2978896)|0;rwh(2978896);ja=c[898736]|0;RI(2965048)|0;ka=qL(2965048)|0;la=c[898738]|0;Rag(ka,ja,la);pwh(ka)}else if((M|0)==46){RI(2978896)|0;if(a[2979044]|0){ma=c[898740]|0;RI(2965048)|0;na=qL(2965048)|0;oa=c[898742]|0;Rag(na,ma,oa);pwh(na)}RI(2978896)|0;rwh(2978896);ma=c[898740]|0;RI(2965048)|0;na=qL(2965048)|0;oa=c[898742]|0;Rag(na,ma,oa);pwh(na)}else if((M|0)==51){RI(2978896)|0;if(a[2979044]|0){pa=c[898744]|0;RI(2965048)|0;qa=qL(2965048)|0;ra=c[898746]|0;Rag(qa,pa,ra);pwh(qa)}RI(2978896)|0;rwh(2978896);pa=c[898744]|0;RI(2965048)|0;qa=qL(2965048)|0;ra=c[898746]|0;Rag(qa,pa,ra);pwh(qa)}else if((M|0)==56){RI(2978896)|0;if(a[2979044]|0){sa=c[898748]|0;RI(2965048)|0;ta=qL(2965048)|0;ua=c[898750]|0;Rag(ta,sa,ua);pwh(ta)}RI(2978896)|0;rwh(2978896);sa=c[898748]|0;RI(2965048)|0;ta=qL(2965048)|0;ua=c[898750]|0;Rag(ta,sa,ua);pwh(ta)}else if((M|0)==60){RI(2978896)|0;if(a[2979044]|0){va=c[898752]|0;RI(2965048)|0;wa=qL(2965048)|0;xa=c[898754]|0;Rag(wa,va,xa);pwh(wa)}RI(2978896)|0;rwh(2978896);va=c[898752]|0;RI(2965048)|0;wa=qL(2965048)|0;xa=c[898754]|0;Rag(wa,va,xa);pwh(wa)}else if((M|0)==68){c[k>>2]=K<<16|L|(J?67108864:0)|(I?33554432:0)|(H?0:16777216);i=d;return G-j|0}}RI(2978896)|0;if(a[2979044]|0){ya=c[898722]|0;RI(2964880)|0;za=qL(2964880)|0;Aa=c[898720]|0;Qag(za,Aa,ya);pwh(za)}RI(2978896)|0;rwh(2978896);ya=c[898722]|0;RI(2964880)|0;za=qL(2964880)|0;Aa=c[898720]|0;Qag(za,Aa,ya);pwh(za)}RI(2978896)|0;if(a[2979044]|0){Ba=c[898714]|0;RI(2964880)|0;Ca=qL(2964880)|0;Da=c[898712]|0;Qag(Ca,Da,Ba);pwh(Ca)}RI(2978896)|0;rwh(2978896);Ba=c[898714]|0;RI(2964880)|0;Ca=qL(2964880)|0;Da=c[898712]|0;Qag(Ca,Da,Ba);pwh(Ca);return 0}function Qfg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=b;omh();c[j>>2]=0;RI(2991312)|0;if(!(a[2991460]|0)){RI(2991312)|0;rwh(2991312)}k=Pfg(0,d,e,f,g,h,j)|0;if(!(c[j>>2]&67108864)){i=b;return k|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}k=c[898766]|0;RI(2965048)|0;b=qL(2965048)|0;Rag(b,k,c[898768]|0);pwh(b);return 0}function Rfg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;pmh();if((d|0)<=-1){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}e=c[898774]|0;RI(2964880)|0;f=qL(2964880)|0;Qag(f,c[898772]|0,e);pwh(f)}if(!d){g=0;i=b;return g|0}g=(((d|0)/3|0)<<3|2)+(((d|0)%3|0)*3|0)|0;i=b;return g|0}function Sfg(b,d){b=b|0;d=d|0;b=i;qmh();if((d|0)>-1){i=b;return d|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898780]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898778]|0,d);pwh(b);return 0}function Tfg(a){a=a|0;var b=0;a=i;RI(3001480)|0;b=qL(3001480)|0;Rcg(b);c[b+16>>2]=0;i=a;return b|0}function Ufg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=veg(a,b,c,d)|0;i=e;return f|0}function Vfg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Wfg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Xfg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Yfg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Zfg(a,b){a=a|0;b=b|0;var d=0;d=i;Rcg(a);Tcg(a,b);c[a+16>>2]=0;c[a+20>>2]=0;i=d;return}function _fg(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;smh();if(!e){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[898802]|0);pwh(k)}if((f|0)>=0?(k=c[e+12>>2]|0,(k|0)>=(f|0)):0){if((g|0)<0|(k-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){l=c[898810]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898808]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[898810]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898808]|0;Qag(m,n,l);pwh(m)}if((k|0)!=(f|0)){if(!k)o=0;else o=e+16|0;p=$fg(0,o+(f<<1)|0,g,h,j)|0;i=d;return p|0}if(!j){p=0;i=d;return p|0}if(!(b[h>>1]|0)){p=0;i=d;return p|0}b[h>>1]=0;p=3;i=d;return p|0}RI(2978896)|0;if(a[2979044]|0){q=c[898806]|0;RI(2964880)|0;r=qL(2964880)|0;s=c[898804]|0;Qag(r,s,q);pwh(r)}RI(2978896)|0;rwh(2978896);q=c[898806]|0;RI(2964880)|0;r=qL(2964880)|0;s=c[898804]|0;Qag(r,s,q);pwh(r);return 0}function $fg(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;a=i;g=c+(d<<1)|0;if((d|0)>0){d=c;c=b[e>>1]|0;h=0;while(1){a:do if(!(c<<16>>16))if(d>>>0<g>>>0){j=d;k=h;b:while(1){l=b[j>>1]|0;do if((l&65535)>127){if((l&65535)<=2047){m=j;n=k+2|0;break}if((l&-2048)<<16>>16!=-10240){m=j;n=k+3|0;break}if((l&65535)>56319){b[e>>1]=0;m=j;n=k+3|0;break}o=j+2|0;if(o>>>0>=g>>>0){p=l;q=o;r=k;break b}if((b[o>>1]&-1024)<<16>>16!=-9216){p=l;q=o;r=k;break b}m=o;n=k+4|0}else{m=j;n=k+1|0}while(0);l=m+2|0;if(l>>>0<g>>>0){j=l;k=n}else{s=l;t=0;u=n;break a}}b[e>>1]=p;s=q;t=p;u=r}else{s=d;t=0;u=h}else{if((b[d>>1]&-1024)<<16>>16==-9216){v=d+2|0;w=h+4|0}else{v=d;w=h+3|0}b[e>>1]=0;s=v;t=0;u=w}while(0);if(s>>>0<g>>>0){d=s;c=t;h=u}else{x=u;break}}}else x=0;if(!f){y=x;i=a;return y|0}if(!(b[e>>1]|0)){y=x;i=a;return y|0}b[e>>1]=0;y=x+3|0;i=a;return y|0}function agg(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a=i;i=i+16|0;f=a;b[f>>1]=0;g=_fg(0,c,d,e,f,1)|0;i=a;return g|0}function bgg(d,e,f,g,h,j,k,l){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;tmh();if(!e){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[898814]|0);pwh(m)}if(!h){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[898816]|0);pwh(m)}if((f|0)>=0?(m=c[e+12>>2]|0,(m|0)>=(f|0)):0){if((g|0)<0|(m-f|0)<(g|0)){RI(2978896)|0;if(a[2979044]|0){n=c[898824]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[898822]|0;Qag(o,p,n);pwh(o)}RI(2978896)|0;rwh(2978896);n=c[898824]|0;RI(2964880)|0;o=qL(2964880)|0;p=c[898822]|0;Qag(o,p,n);pwh(o)}if((j|0)>=0?(o=c[h+12>>2]|0,(o|0)>=(j|0)):0){if((m|0)==(f|0)){if(!l){q=0;i=d;return q|0}if(!(b[k>>1]|0)){q=0;i=d;return q|0}b[k>>1]=0;q=0;i=d;return q|0}if(!m)r=0;else r=e+16|0;if((o|0)==(j|0)){q=cgg(0,r+(f<<1)|0,g,0,0,k,l)|0;i=d;return q|0}if(!o)s=0;else s=h+16|0;q=cgg(0,r+(f<<1)|0,g,s+j|0,o-j|0,k,l)|0;i=d;return q|0}RI(2978896)|0;if(a[2979044]|0){t=c[898828]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[898826]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;rwh(2978896);t=c[898828]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[898826]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;if(a[2979044]|0){w=c[898820]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898818]|0;Qag(x,y,w);pwh(x)}RI(2978896)|0;rwh(2978896);w=c[898820]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898818]|0;Qag(x,y,w);pwh(x);return 0}function cgg(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;umh();l=e+(f<<1)|0;m=g+h|0;a:do if((f|0)>0){n=e;o=g;while(1){p=b[j>>1]|0;b:do if(!(p<<16>>16))if(n>>>0<l>>>0){q=n;r=o;c:while(1){s=b[q>>1]|0;t=s&65535;do if((s&65535)>127){if((s&65535)<=2047){u=r+1|0;if(u>>>0>=m>>>0)break a;a[r>>0]=t>>>6|192;a[u>>0]=t&63|128;v=r+2|0;break}if((s&-2048)<<16>>16!=-10240){u=r+2|0;if(u>>>0>=m>>>0)break a;a[r>>0]=t>>>12|224;a[r+1>>0]=t>>>6&63|128;a[u>>0]=t&63|128;v=r+3|0;break}if((s&65535)<=56319){w=q;x=r;y=s;break c}u=r+2|0;if(u>>>0>=m>>>0)break a;a[r>>0]=t>>>12|224;a[r+1>>0]=t>>>6&63|128;a[u>>0]=t&63|128;b[j>>1]=0;v=r+3|0}else{if(r>>>0>=m>>>0)break a;a[r>>0]=s;v=r+1|0}while(0);s=q+2|0;if(s>>>0<l>>>0){q=s;r=v}else{z=s;A=v;break b}}b[j>>1]=y;z=w+2|0;A=x}else{z=n;A=o}else{r=b[n>>1]|0;if((r&-1024)<<16>>16==-9216){q=r&65535;r=((p&65535)<<10)+-56679424|0;s=r+(q|65536)|0;t=o+3|0;if(t>>>0>=m>>>0)break a;a[o>>0]=s>>>18|240;a[o+1>>0]=s>>>12&63|128;a[o+2>>0]=s>>>6&63|128;a[t>>0]=q+r&63|128;B=n+2|0;C=o+4|0}else{r=p&65535;q=o+2|0;if(q>>>0>=m>>>0)break a;a[o>>0]=r>>>12|224;a[o+1>>0]=r>>>6&63|128;a[q>>0]=r&63|128;B=n;C=o+3|0}b[j>>1]=0;z=B;A=C}while(0);if(z>>>0<l>>>0){n=z;o=A}else{D=A;E=25;break}}}else{D=g;E=25}while(0);if((E|0)==25){if(!k){F=D;G=F;H=m;I=h-H|0;J=I+G|0;i=d;return J|0}k=b[j>>1]|0;if(!(k<<16>>16)){F=D;G=F;H=m;I=h-H|0;J=I+G|0;i=d;return J|0}E=k&65535;k=D+2|0;if(k>>>0<m>>>0){a[D>>0]=E>>>12|224;a[D+1>>0]=E>>>6&63|128;a[k>>0]=E&63|128;b[j>>1]=0;F=D+3|0;G=F;H=m;I=h-H|0;J=I+G|0;i=d;return J|0}}RI(2965048)|0;J=qL(2965048)|0;Rag(J,c[898832]|0,c[898834]|0);pwh(J);return 0}function dgg(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a;b[h>>1]=0;j=bgg(0,c,d,e,f,g,h,1)|0;i=a;return j|0}function egg(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;vmh();if(!d){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[898848]|0);pwh(n)}if((e|0)>=0?(n=c[d+12>>2]|0,(n|0)>=(e|0)):0){if((f|0)<0|(n-e|0)<(f|0)){RI(2978896)|0;if(a[2979044]|0){o=c[898856]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898854]|0;Qag(p,q,o);pwh(p)}RI(2978896)|0;rwh(2978896);o=c[898856]|0;RI(2964880)|0;p=qL(2964880)|0;q=c[898854]|0;Qag(p,q,o);pwh(p)}if(!f){r=0;i=b;return r|0}if(!n)s=0;else s=d+16|0;r=fgg(0,s+e|0,f,g,h,j,k,l,m)|0;i=b;return r|0}RI(2978896)|0;if(a[2979044]|0){t=c[898852]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[898850]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;rwh(2978896);t=c[898852]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[898850]|0;Qag(u,v,t);pwh(u);return 0}function fgg(b,c,d,e,f,g,h,j,k){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0;b=i;a:do if(!f){if((d|0)>0){l=d;m=0}else{n=0;o=0;p=0;q=f>>>4&15;break}while(1){if((a[c+m>>0]|0)<0){r=l;s=m;t=6;break a}u=m+1|0;v=l+-1|0;if((u|0)<(d|0)){l=v;m=u}else{r=v;s=u;t=6;break}}}else{r=d;s=0;t=6}while(0);if((t|0)==6){d=f&15;m=f>>>4&15;if((r|0)>0){f=r;r=s;l=s;u=e;e=d;v=m;while(1){w=r+1|0;x=a[c+r>>0]|0;y=x&255;z=f+-1|0;do if(!v){if(x<<24>>24>=0){A=z;B=w;C=l+1|0;D=u;E=e;F=0;break}if((y&224|0)==192){A=z;B=w;C=l;D=y&31;E=1;F=2;break}if((y&240|0)==224){A=z;B=w;C=l;D=y&15;E=1;F=3;break}if((y&248|0)==240){A=z;B=w;C=l;D=y&7;E=1;F=4;break}if((y&252|0)==248){A=z;B=w;C=l;D=y&3;E=1;F=5;break}if((y&254|0)==252){A=z;B=w;C=l;D=y&3;E=1;F=6;break}else{A=z;B=w;C=(ggg(0,g,h,j,c,r,((r|0)<0)<<31>>31,1)|0)+l|0;D=u;E=e;F=0;break}}else{if((y&192|0)!=128){G=ZEi(w|0,((w|0)<0)<<31>>31|0,e|0,0)|0;A=f;B=r;C=(ggg(0,g,h,j,c,G,H,e)|0)+l|0;D=u;E=e;F=0;break}G=u<<6;I=y&63|G;J=e+1|0;if(J>>>0<v>>>0){A=z;B=w;C=l;D=I;E=J;F=v}else{do if(I>>>0>65535)if(I>>>0>1114111){K=ZEi(w|0,((w|0)<0)<<31>>31|0,J|0,0)|0;L=ggg(0,g,h,j,c,K,H,J)|0}else L=2;else{switch(v|0){case 5:{if(I>>>0<2097152)t=29;break}case 6:{if(I>>>0<67108864)t=29;break}case 2:{if(I>>>0<128)t=29;break}case 4:{if(I>>>0<65536)t=29;break}case 3:{if(I>>>0<2048)t=29;break}default:{}}if((t|0)==29){t=0;K=ZEi(w|0,((w|0)<0)<<31>>31|0,J|0,0)|0;L=ggg(0,g,h,j,c,K,H,J)|0;break}if((G&63488|0)==55296){K=ZEi(w|0,((w|0)<0)<<31>>31|0,J|0,0)|0;L=ggg(0,g,h,j,c,K,H,J)|0}else L=1}while(0);A=z;B=w;C=L+l|0;D=I;E=J;F=0}}while(0);if((A|0)>0){f=A;r=B;l=C;u=D;e=E;v=F}else{n=B;o=C;p=E;q=F;break}}}else{n=s;o=s;p=d;q=m}}if(!((q|0)!=0&k)){M=o;i=b;return M|0}k=ZEi(n|0,((n|0)<0)<<31>>31|0,p|0,0)|0;M=(ggg(0,g,h,j,c,k,H,p)|0)+o|0;i=b;return M|0}function ggg(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;j=i;do if(!(c[e>>2]|0)){RI(2982584)|0;b=vL(d,2982584)|0;if(!b){RI(2981344)|0;c[e>>2]=Vcg(swh(d,2981344)|0)|0;break}else{c[e>>2]=zwh(2979344,b)|0;break}}while(0);d=c[f>>2]|0;if(!d){RI(1159264)|0;b=twh(1159264,1)|0;c[f>>2]=b;l=b}else l=d;if(!k){m=0;i=j;return m|0}d=l;l=0;b=0;while(1){a[d+16>>0]=a[g+(b+h)>>0]|0;Awh(2979400,c[e>>2]|0,c[f>>2]|0,0)|0;n=(Aqh(2979512,c[e>>2]|0)|0)+l|0;eth(2984208,c[e>>2]|0);o=b+1|0;p=((o|0)<0)<<31>>31;if(!(p>>>0<0|(p|0)==0&o>>>0<k>>>0)){m=n;break}d=c[f>>2]|0;l=n;b=o}i=j;return m|0}function hgg(d,e,f,g,h,j,k,l,m,n){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;d=i;do if(!(c[f>>2]|0)){RI(2982584)|0;o=vL(e,2982584)|0;if(!o){RI(2981344)|0;c[f>>2]=Vcg(swh(e,2981344)|0)|0;break}else{c[f>>2]=zwh(2979344,o)|0;break}}while(0);e=c[g>>2]|0;if(!e){RI(1159264)|0;o=twh(1159264,1)|0;c[g>>2]=o;p=o}else p=e;if(!l){i=d;return}else{q=0;r=0;s=p;t=1}while(1){p=_Ei(q|0,r|0,j|0,k|0)|0;a[s+16>>0]=a[h+p>>0]|0;Awh(2979400,c[f>>2]|0,c[g>>2]|0,0)|0;if((Aqh(2979512,c[f>>2]|0)|0)>0)do{p=c[n>>2]|0;c[n>>2]=p+1;b[m+(p<<1)>>1]=ywh(2979456,c[f>>2]|0)|0}while((Aqh(2979512,c[f>>2]|0)|0)>0);eth(2984208,c[f>>2]|0);p=((t|0)<0)<<31>>31;if(!(p>>>0<0|(p|0)==0&t>>>0<l>>>0))break;e=t;r=p;s=c[g>>2]|0;t=t+1|0;q=e}i=d;return}function igg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=0;c[h>>2]=0;j=egg(0,b,d,e,0,0,c[a+20>>2]|0,g,h,1)|0;i=f;return j|0}function jgg(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;b=i;wmh();if(!d){RI(2963920)|0;p=qL(2963920)|0;Iag(p,c[898860]|0);pwh(p)}if(!g){RI(2963920)|0;p=qL(2963920)|0;Iag(p,c[898862]|0);pwh(p)}if((e|0)>=0?(p=c[d+12>>2]|0,(p|0)>=(e|0)):0){if((f|0)<0|(p-e|0)<(f|0)){RI(2978896)|0;if(a[2979044]|0){q=c[898870]|0;RI(2964880)|0;r=qL(2964880)|0;s=c[898868]|0;Qag(r,s,q);pwh(r)}RI(2978896)|0;rwh(2978896);q=c[898870]|0;RI(2964880)|0;r=qL(2964880)|0;s=c[898868]|0;Qag(r,s,q);pwh(r)}if((h|0)>=0?(r=c[g+12>>2]|0,(r|0)>=(h|0)):0){if((r|0)==(h|0)){t=0;i=b;return t|0}if(!r)u=0;else u=g+16|0;if((f|0)==0|(p|0)==(e|0)){t=kgg(0,0,0,u+(h<<1)|0,r-h|0,j,k,l,m,n,o)|0;i=b;return t|0}if(!p)v=0;else v=d+16|0;t=kgg(0,v+e|0,f,u+(h<<1)|0,r-h|0,j,k,l,m,n,o)|0;i=b;return t|0}RI(2978896)|0;if(a[2979044]|0){w=c[898874]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898872]|0;Qag(x,y,w);pwh(x)}RI(2978896)|0;rwh(2978896);w=c[898874]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898872]|0;Qag(x,y,w);pwh(x)}RI(2978896)|0;if(a[2979044]|0){z=c[898866]|0;RI(2964880)|0;A=qL(2964880)|0;B=c[898864]|0;Qag(A,B,z);pwh(A)}RI(2978896)|0;rwh(2978896);z=c[898866]|0;RI(2964880)|0;A=qL(2964880)|0;B=c[898864]|0;Qag(A,B,z);pwh(A);return 0}function kgg(d,e,f,g,h,j,k,l,m,n,o){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;d=i;i=i+16|0;p=d;xmh();c[p>>2]=0;q=c[k>>2]|0;a:do if(!q){if((f|0)>0){r=f;s=0;t=0}else{u=0;v=c[j>>2]|0;w=0;x=q>>>4&15;break}while(1){y=a[e+t>>0]|0;if(y<<24>>24<0){z=r;A=t;B=6;break a}b[g+(s<<1)>>1]=y&255;s=s+1|0;c[p>>2]=s;y=t+1|0;C=r+-1|0;if((y|0)>=(f|0)){z=C;A=y;B=6;break}else{r=C;t=y}}}else{z=f;A=0;B=6}while(0);b:do if((B|0)==6){f=c[j>>2]|0;t=q&15;r=q>>>4&15;s=z+A|0;if((z|0)>0){y=A;C=f;D=t;E=r;c:while(1){F=a[e+y>>0]|0;G=F&255;do if(!E){if(F<<24>>24>=0){I=c[p>>2]|0;if((I|0)>=(h|0)){B=9;break c}c[p>>2]=I+1;b[g+(I<<1)>>1]=F&255;J=y;K=C;L=D;M=0;break}if((G&224|0)==192){J=y;K=G&31;L=1;M=2;break}if((G&240|0)==224){J=y;K=G&15;L=1;M=3;break}if((G&248|0)==240){J=y;K=G&7;L=1;M=4;break}if((G&252|0)==248){J=y;K=G&3;L=1;M=5;break}if((G&254|0)==252){J=y;K=G&3;L=1;M=6;break}else{hgg(0,l,m,n,e,y,((y|0)<0)<<31>>31,1,g,p);J=y;K=C;L=D;M=0;break}}else{if((G&192|0)!=128){I=ZEi(y|0,((y|0)<0)<<31>>31|0,D|0,0)|0;hgg(0,l,m,n,e,I,H,D,g,p);J=y+-1|0;K=C;L=D;M=0;break}I=C<<6;N=G&63|I;O=D+1|0;if(O>>>0<E>>>0){J=y;K=N;L=O;M=E}else{if(N>>>0>65535){if(N>>>0>1114111){P=ZEi(y|0,((y|0)<0)<<31>>31|0,O|0,0)|0;hgg(0,l,m,n,e,P,H,O,g,p);J=y;K=N;L=O;M=0;break}P=c[p>>2]|0;if((P+2|0)>(h|0)){B=43;break c}Q=N+-65536|0;b[g+(P<<1)>>1]=(Q>>>10)+55296;c[p>>2]=P+2;b[g+(P+1<<1)>>1]=Q&1023|56320;J=y;K=Q;L=O;M=0;break}switch(E|0){case 5:{if(N>>>0<2097152)B=33;break}case 2:{if(N>>>0<128)B=33;break}case 6:{if(N>>>0<67108864)B=33;break}case 4:{if(N>>>0<65536)B=33;break}case 3:{if(N>>>0<2048)B=33;break}default:{}}if((B|0)==33){B=0;Q=ZEi(y|0,((y|0)<0)<<31>>31|0,O|0,0)|0;hgg(0,l,m,n,e,Q,H,O,g,p);J=y;K=N;L=O;M=0;break}if((I&63488|0)==55296){I=ZEi(y|0,((y|0)<0)<<31>>31|0,O|0,0)|0;hgg(0,l,m,n,e,I,H,O,g,p);J=y;K=N;L=O;M=0;break}I=c[p>>2]|0;if((I|0)>=(h|0)){B=37;break c}c[p>>2]=I+1;b[g+(I<<1)>>1]=N;J=y;K=N;L=O;M=0}}while(0);G=J+1|0;if((G|0)<(s|0)){y=G;C=K;D=L;E=M}else{u=G;v=K;w=L;x=M;break b}}if((B|0)==9){RI(2978896)|0;if(a[2979044]|0){R=c[898878]|0;RI(2965048)|0;S=qL(2965048)|0;T=c[898880]|0;Rag(S,R,T);pwh(S)}RI(2978896)|0;rwh(2978896);R=c[898878]|0;RI(2965048)|0;S=qL(2965048)|0;T=c[898880]|0;Rag(S,R,T);pwh(S)}else if((B|0)==37){RI(2978896)|0;if(a[2979044]|0){U=c[898882]|0;RI(2965048)|0;V=qL(2965048)|0;W=c[898884]|0;Rag(V,U,W);pwh(V)}RI(2978896)|0;rwh(2978896);U=c[898882]|0;RI(2965048)|0;V=qL(2965048)|0;W=c[898884]|0;Rag(V,U,W);pwh(V)}else if((B|0)==43){RI(2978896)|0;if(a[2979044]|0){X=c[898886]|0;RI(2965048)|0;Y=qL(2965048)|0;Z=c[898888]|0;Rag(Y,X,Z);pwh(Y)}RI(2978896)|0;rwh(2978896);X=c[898886]|0;RI(2965048)|0;Y=qL(2965048)|0;Z=c[898888]|0;Rag(Y,X,Z);pwh(Y)}}else{u=A;v=f;w=t;x=r}}while(0);if(!((x|0)!=0&o)){c[j>>2]=v;_=x<<4;$=w|_;c[k>>2]=$;aa=c[p>>2]|0;i=d;return aa|0}o=ZEi(u|0,((u|0)<0)<<31>>31|0,w|0,0)|0;hgg(0,l,m,n,e,o,H,w,g,p);c[j>>2]=v;_=x<<4;$=w|_;c[k>>2]=$;aa=c[p>>2]|0;i=d;return aa|0}function lgg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h+12|0;k=h+8|0;l=h+4|0;m=h;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;n=jgg(0,b,d,e,f,g,j,k,c[a+20>>2]|0,l,m,1)|0;i=h;return n|0}function mgg(b,d){b=b|0;d=d|0;b=i;ymh();if((d|0)>-1){i=b;return d<<2|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898894]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898892]|0,d);pwh(b);return 0}function ngg(b,d){b=b|0;d=d|0;b=i;zmh();if((d|0)>-1){i=b;return d|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[898900]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[898898]|0,d);pwh(b);return 0}function ogg(a){a=a|0;var b=0,d=0;b=i;d=c[a+20>>2]|0;RI(3003864)|0;a=qL(3003864)|0;Zfg(a,d);i=b;return a|0}function pgg(b){b=b|0;var d=0,e=0,f=0;d=i;e=(a[b+48>>0]|0)==0;RI(1159264)|0;if(e){f=twh(1159264,0)|0;i=d;return f|0}else{e=twh(1159264,3)|0;b=e+16|0;a[b>>0]=-17;a[b+(c[(c[e>>2]|0)+120>>2]|0)>>0]=-69;a[b+(c[(c[e>>2]|0)+120>>2]<<1)>>0]=-65;f=e;i=d;return f|0}return 0}function qgg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2991480)|0;f=vL(d,2991480)|0;if(!f){g=0;i=e;return g|0}if((c[b+8>>2]|0)!=(c[f+8>>2]|0)){g=0;i=e;return g|0}if((a[b+48>>0]|0)!=(a[f+48>>0]|0)){g=0;i=e;return g|0}if(!(nrh(2536048,c[b+20>>2]|0,c[f+20>>2]|0)|0)){g=0;i=e;return g|0}g=nrh(2536048,c[b+24>>2]|0,c[f+24>>2]|0)|0;i=e;return g|0}function rgg(a){a=a|0;var b=0,c=0;b=i;c=teg(a)|0;i=b;return c|0}function sgg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;f=veg(a,b,c,d)|0;i=e;return f|0}function tgg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2662936)|0;bIf(a,sM(3006816)|0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function ugg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function vgg(b,d){b=b|0;d=d|0;var e=0;e=i;Rcg(b);a[b+16>>0]=d&1;c[b+20>>2]=-1;i=e;return}function wgg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;Amh();Acg(b,d?1201:1200);if(f){RI(2982096)|0;f=qL(2982096)|0;if(f)c[b+20>>2]=f}else{RI(2981160)|0;f=qL(2981160)|0;jdg(f,c[898904]|0);if(f)c[b+20>>2]=f}a[b+48>>0]=d&1;a[b+49>>0]=e&1;if(d){c[b+28>>2]=c[898906];c[b+32>>2]=c[898908];c[b+36>>2]=c[898910];a[b+42>>0]=0;h=3595648;j=c[h>>2]|0;k=b+44|0;c[k>>2]=j;l=b+12|0;c[l>>2]=1200;i=g;return}else{c[b+28>>2]=c[898914];c[b+32>>2]=c[898916];c[b+36>>2]=c[898918];a[b+42>>0]=1;h=3595680;j=c[h>>2]|0;k=b+44|0;c[k>>2]=j;l=b+12|0;c[l>>2]=1200;i=g;return}}function xgg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;Bmh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[898944]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return f<<1|0}RI(2978896)|0;if(a[2979044]|0){h=c[898952]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898950]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[898952]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898950]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[898948]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898946]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[898948]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898946]|0;Qag(m,n,l);pwh(m);return 0}function ygg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;Cmh();if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[898956]|0);pwh(k)}if(!g){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[898958]|0);pwh(k)}if((e|0)>=0?(k=d+12|0,l=c[k>>2]|0,(l|0)>=(e|0)):0){if((f|0)<0|(l-e|0)<(f|0)){RI(2978896)|0;if(a[2979044]|0){m=c[898966]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898964]|0;Qag(n,o,m);pwh(n)}RI(2978896)|0;rwh(2978896);m=c[898966]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898964]|0;Qag(n,o,m);pwh(n)}if((h|0)>=0?(n=c[g+12>>2]|0,(n|0)>=(h|0)):0){if(!f){p=0;i=j;return p|0}m=n-h|0;if(!n){RI(1159264)|0;q=twh(1159264,1)|0}else q=g;if(!(c[k>>2]|0))r=0;else r=d+16|0;if((q|0)!=0?(c[q+12>>2]|0)!=0:0)s=q+16|0;else s=0;p=zgg(b,r+(e<<1)|0,f,s+h|0,m)|0;i=j;return p|0}RI(2978896)|0;if(a[2979044]|0){t=c[898970]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[898968]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;rwh(2978896);t=c[898970]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[898968]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;if(a[2979044]|0){w=c[898962]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898960]|0;Qag(x,y,w);pwh(x)}RI(2978896)|0;rwh(2978896);w=c[898962]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898960]|0;Qag(x,y,w);pwh(x);return 0}function zgg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;Dmh();j=e<<1;if((j|0)<=(g|0)){Agg(0,d,f,j,(a[b+48>>0]|0)!=0);i=h;return j|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}j=c[898974]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,j);pwh(h);return 0}function Agg(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;rwh(3007432)}RI(3007432)|0;if((d[(c[751881]|0)+1>>0]|0)!=(h&1|0)){if(!(a[2540708]|0))rwh(2540560);xwf(0,f,e,g&-2);i=b;return}if(g>>>0<2){i=b;return}a:do if((g&-2|0)!=2){do if((g&-4|0)!=4){if((g&-8|0)!=8){h=15-g|0;j=(h>>>0>4294967280?h:-16)+g&-16;h=j+16|0;k=f+h|0;l=e;m=g;n=f;while(1){a[n>>0]=a[l+1>>0]|0;a[n+1>>0]=a[l>>0]|0;a[n+2>>0]=a[l+3>>0]|0;a[n+3>>0]=a[l+2>>0]|0;a[n+4>>0]=a[l+5>>0]|0;a[n+5>>0]=a[l+4>>0]|0;a[n+6>>0]=a[l+7>>0]|0;a[n+7>>0]=a[l+6>>0]|0;a[n+8>>0]=a[l+9>>0]|0;a[n+9>>0]=a[l+8>>0]|0;a[n+10>>0]=a[l+11>>0]|0;a[n+11>>0]=a[l+10>>0]|0;a[n+12>>0]=a[l+13>>0]|0;a[n+13>>0]=a[l+12>>0]|0;a[n+14>>0]=a[l+15>>0]|0;a[n+15>>0]=a[l+14>>0]|0;m=m+-16|0;if(m>>>0<=15)break;else{l=l+16|0;n=n+16|0}}n=g+-16-j|0;l=e+h|0;if(n>>>0<2){i=b;return}if((n&-2|0)==2){o=l;p=k;break a}if((g-j&-4|0)==20){q=l;r=n;s=k;t=17;break}else{u=l;v=n;w=k}}else{u=e;v=g;w=f}a[w>>0]=a[u+1>>0]|0;a[w+1>>0]=a[u>>0]|0;a[w+2>>0]=a[u+3>>0]|0;a[w+3>>0]=a[u+2>>0]|0;a[w+4>>0]=a[u+5>>0]|0;a[w+5>>0]=a[u+4>>0]|0;a[w+6>>0]=a[u+7>>0]|0;a[w+7>>0]=a[u+6>>0]|0;n=w+8|0;l=u+8|0;if(!(v&4)){x=l;y=v;z=n}else{q=l;r=v;s=n;t=17}}else{q=e;r=g;s=f;t=17}while(0);if((t|0)==17){a[s>>0]=a[q+1>>0]|0;a[s+1>>0]=a[q>>0]|0;a[s+2>>0]=a[q+3>>0]|0;a[s+3>>0]=a[q+2>>0]|0;x=q+4|0;y=r;z=s+4|0}if(!(y&2)){i=b;return}else{o=x;p=z}}else{o=e;p=f}while(0);a[p>>0]=a[o+1>>0]|0;a[p+1>>0]=a[o>>0]|0;i=b;return}function Bgg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;Emh();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[898978]|0);pwh(g)}if((e|0)>=0?(g=c[d+12>>2]|0,(g|0)>=(e|0)):0){if(!((f|0)<0|(g-e|0)<(f|0))){i=b;return (f|0)/2|0|0}RI(2978896)|0;if(a[2979044]|0){h=c[898986]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898984]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;rwh(2978896);h=c[898986]|0;RI(2964880)|0;j=qL(2964880)|0;k=c[898984]|0;Qag(j,k,h);pwh(j)}RI(2978896)|0;if(a[2979044]|0){l=c[898982]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898980]|0;Qag(m,n,l);pwh(m)}RI(2978896)|0;rwh(2978896);l=c[898982]|0;RI(2964880)|0;m=qL(2964880)|0;n=c[898980]|0;Qag(m,n,l);pwh(m);return 0}function Cgg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;Fmh();if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[898990]|0);pwh(k)}if(!g){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[898992]|0);pwh(k)}if((e|0)>=0?(k=d+12|0,l=c[k>>2]|0,(l|0)>=(e|0)):0){if((f|0)<0|(l-e|0)<(f|0)){RI(2978896)|0;if(a[2979044]|0){m=c[899e3]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898998]|0;Qag(n,o,m);pwh(n)}RI(2978896)|0;rwh(2978896);m=c[899e3]|0;RI(2964880)|0;n=qL(2964880)|0;o=c[898998]|0;Qag(n,o,m);pwh(n)}if((h|0)>=0?(n=c[g+12>>2]|0,(n|0)>=(h|0)):0){if(!f){p=0;i=j;return p|0}m=n-h|0;if(!n){RI(1136088)|0;q=twh(1136088,1)|0}else q=g;if(!(c[k>>2]|0))r=0;else r=d+16|0;if((q|0)!=0?(c[q+12>>2]|0)!=0:0)s=q+16|0;else s=0;p=Dgg(b,r+e|0,f,s+(h<<1)|0,m)|0;i=j;return p|0}RI(2978896)|0;if(a[2979044]|0){t=c[899004]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[899002]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;rwh(2978896);t=c[899004]|0;RI(2964880)|0;u=qL(2964880)|0;v=c[899002]|0;Qag(u,v,t);pwh(u)}RI(2978896)|0;if(a[2979044]|0){w=c[898996]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898994]|0;Qag(x,y,w);pwh(x)}RI(2978896)|0;rwh(2978896);w=c[898996]|0;RI(2964880)|0;x=qL(2964880)|0;y=c[898994]|0;Qag(x,y,w);pwh(x);return 0}function Dgg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;Hmh();j=(e|0)/2|0;if((j|0)<=(g|0)){Agg(0,d,f,e,(a[b+48>>0]|0)!=0);i=h;return j|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}j=c[899020]|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,j);pwh(h);return 0}function Egg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;Gmh();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[899008]|0);pwh(h)}if((e|0)>=0?(h=d+12|0,j=c[h>>2]|0,(j|0)>=(e|0)):0){if((f|0)<0|(j-e|0)<(f|0)){RI(2978896)|0;if(a[2979044]|0){k=c[899016]|0;RI(2964880)|0;l=qL(2964880)|0;m=c[899014]|0;Qag(l,m,k);pwh(l)}RI(2978896)|0;rwh(2978896);k=c[899016]|0;RI(2964880)|0;l=qL(2964880)|0;m=c[899014]|0;Qag(l,m,k);pwh(l)}if(!f){if(!(a[2540708]|0))rwh(2540560);n=c[c[635163]>>2]|0;i=g;return n|0}l=(f|0)/2|0;if(!(a[2540708]|0))rwh(2540560);k=ivf(0,l)|0;if(!(c[h>>2]|0))o=0;else o=d+16|0;Dgg(b,o+e|0,f,(bvf(0)|0)+k|0,l)|0;n=k;i=g;return n|0}RI(2978896)|0;if(a[2979044]|0){p=c[899012]|0;RI(2964880)|0;q=qL(2964880)|0;r=c[899010]|0;Qag(q,r,p);pwh(q)}RI(2978896)|0;rwh(2978896);p=c[899012]|0;RI(2964880)|0;q=qL(2964880)|0;r=c[899010]|0;Qag(q,r,p);pwh(q);return 0}function Fgg(b,d){b=b|0;d=d|0;b=i;Imh();if((d|0)>-1){i=b;return d<<1|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[899026]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[899024]|0,d);pwh(b);return 0}function Ggg(b,d){b=b|0;d=d|0;b=i;Jmh();if((d|0)>-1){i=b;return (d|0)/2|0|0}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}d=c[899032]|0;RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[899030]|0,d);pwh(b);return 0}function Hgg(b){b=b|0;var c=0,d=0;c=i;d=(a[b+48>>0]|0)!=0;RI(3007080)|0;b=qL(3007080)|0;vgg(b,d);i=c;return b|0}function Igg(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=(a[b+49>>0]|0)==0;RI(1159264)|0;if(e){f=twh(1159264,0)|0;i=d;return f|0}e=twh(1159264,2)|0;g=e+16|0;if(!(a[b+48>>0]|0)){a[g>>0]=-1;a[g+(c[(c[e>>2]|0)+120>>2]|0)>>0]=-2;f=e;i=d;return f|0}else{a[g>>0]=-2;a[g+(c[(c[e>>2]|0)+120>>2]|0)>>0]=-1;f=e;i=d;return f|0}return 0}function Jgg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;RI(2990912)|0;f=vL(d,2990912)|0;if(!f){g=0;i=e;return g|0}if((c[b+8>>2]|0)!=(c[f+8>>2]|0)){g=0;i=e;return g|0}if((a[b+48>>0]|0)!=(a[f+48>>0]|0)){g=0;i=e;return g|0}g=(a[b+49>>0]|0)==(a[f+49>>0]|0);i=e;return g|0}function Kgg(a){a=a|0;var b=0,c=0;b=i;c=teg(a)|0;i=b;return c|0}function Lgg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(2971480)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Mgg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ngg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ogg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;a[h>>0]=0;c[j>>2]=Rgg(0,Qgg(0,e)|0,d,0,h)|0;c[g+0>>2]=c[j+0>>2];Hwh(3009840,b,g);i=f;return}function Pgg(a){a=a|0;return}function Qgg(a,b){a=a|0;b=b|0;a=i;Kmh();if(b>>>0<2){i=a;return (b|0)==1|0}else{RI(2965048)|0;b=qL(2965048)|0;Rbg(b,c[899036]|0);pwh(b)}return 0}function Rgg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;g=c[753068]|0;if(!g){h=MK(3012280)|0;c[753068]=h;j=h}else j=g;g=kn[j&511](b,d,e,f)|0;i=a;return g|0}function Sgg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;Tgg(a);c[e>>2]=Iwh(3009896,a)|0;c[d+0>>2]=c[e+0>>2];e=Ugg(0,d)|0;i=b;return e|0}function Tgg(b){b=b|0;var d=0;d=i;if((a[b+16>>0]|0)==0?(c[b+12>>2]|0)!=0:0){i=d;return}d=Fqh(2537592,Xnf(b)|0)|0;RI(3112928)|0;b=qL(3112928)|0;kwg(b,d);pwh(b)}function Ugg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[753100]|0;if(!f){g=MK(3012408)|0;c[753100]=g;h=g}else h=f;c[e>>2]=c[b>>2];c[d+0>>2]=c[e+0>>2];e=mo[h&4095](d)|0;i=a;return e|0}function Vgg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Wgg(a,b,d){a=a|0;b=b|0;d=d|0;Lmh();if(!b){RI(2963920)|0;b=qL(2963920)|0;Iag(b,c[899042]|0);pwh(b)}else{RI(3100016)|0;b=qL(3100016)|0;lug(b);pwh(b)}}function Xgg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;c[c[d>>2]>>2]=a;i=b;return}function Ygg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[752742]|0;if(!f){g=MK(3010976)|0;c[752742]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function Zgg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function _gg(a,b){a=a|0;b=b|0;var c=0;c=i;Ogg(a,b,1);i=c;return}function $gg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ahg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function bhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function chg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;d=a+4|0;e=a;f=c[753120]|0;if(!f){g=MK(3012488)|0;c[753120]=g;h=g}else h=f;c[e>>2]=c[b>>2];c[d+0>>2]=c[e+0>>2];ko[h&4095](d);i=a;return}function dhg(a){a=a|0;var b=0;b=i;Mmh();Grg(a,c[899046]|0);i=b;return}function ehg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function fhg(a){a=a|0;var b=0;a=i;RI(2536312)|0;b=qL(2536312)|0;RI(3013496)|0;c[(c[753397]|0)+4>>2]=b;RI(2536312)|0;b=qL(2536312)|0;RI(3013496)|0;c[(c[753397]|0)+8>>2]=b;i=a;return}function ghg(a){a=a|0;var b=0;a=i;b=hhg(0)|0;i=a;return b|0}function hhg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[755554]|0;if(!b){d=MK(3022224)|0;c[755554]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function ihg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[753416]|0;if(!b){d=MK(3013672)|0;c[753416]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function jhg(b){b=b|0;var c=0;b=i;RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;rwh(3013496)}c=ihg(0)|0;i=b;return c|0}function khg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[753432]|0;if(!b){d=MK(3013736)|0;c[753432]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function lhg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;g=c[753444]|0;if(!g){h=MK(3013784)|0;c[753444]=h;j=h}else j=g;c[f>>2]=c[b>>2];c[e+0>>2]=c[f+0>>2];In[j&4095](a,e);i=d;return}function mhg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[a+12>>2];c[d+0>>2]=c[e+0>>2];lhg(a,d);o5f(a);i=b;return}function nhg(b){b=b|0;var c=0;b=i;RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;rwh(3013496)}c=ohg(0)|0;i=b;return c|0}function ohg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[753462]|0;if(!b){d=MK(3013856)|0;c[753462]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function phg(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+184|0;b=c[e>>2]|0;if(b){f=b;i=d;return f|0}RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;rwh(3013496)}Ygg(0,e,nhg(0)|0,0)|0;f=c[e>>2]|0;i=d;return f|0}function qhg(a){a=a|0;var b=0,c=0;b=i;c=phg(a)|0;i=b;return c|0}function rhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2819056)|0;OXf(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2918240)|0;PXf(a,ML(c[729576]|0)|0);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function shg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;nrg(a);c[c[d>>2]>>2]=a;i=b;return}function thg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;nrg(a);c[c[d>>2]>>2]=a;i=b;return}function uhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,1);c[c[d>>2]>>2]=a;i=b;return}function vhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function whg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function xhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function yhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function zhg(a){a=a|0;var b=0;b=i;Nmh();Grg(a,c[899062]|0);i=b;return}function Ahg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Bhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Chg(a){a=a|0;var b=0;b=i;Omh();Grg(a,c[899076]|0);i=b;return}function Dhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Ehg(a){a=a|0;var b=0;a=i;b=HAf(0,-1)|0;RI(3010400)|0;c[(c[752623]|0)+4>>2]=b;i=a;return}function Fhg(a){a=a|0;var b=0;b=i;zvh(3019256,a,1);Jrg(0,a);i=b;return}function Ghg(a){a=a|0;var b=0,d=0;b=i;d=L5f(c[a+12>>2]|0)|0;i=b;return d|0}function Hhg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;RI(3010400)|0;if(!(a[3010548]|0)){RI(3010400)|0;rwh(3010400)}m=c[d>>2]|0;c[h>>2]=m;RI(3010400)|0;c[j>>2]=c[(c[752623]|0)+4>>2];c[g+0>>2]=c[h+0>>2];c[f+0>>2]=c[j+0>>2];if(!(FAf(0,g,f)|0)){RI(2673416)|0;g=qL(2673416)|0;c[l>>2]=m;c[f+0>>2]=c[l+0>>2];fJf(g,f,1);c[b+12>>2]=g;i=e;return}RI(3010400)|0;if(!(a[3010548]|0)){RI(3010400)|0;rwh(3010400)}RI(2673416)|0;g=qL(2673416)|0;RI(3010400)|0;c[k>>2]=c[(c[752623]|0)+4>>2];c[f+0>>2]=c[k+0>>2];fJf(g,f,0);c[b+12>>2]=g;i=e;return}function Ihg(b,d){b=b|0;d=d|0;var e=0,f=0;d=i;e=b+16|0;if(a[e>>0]|0){i=d;return}a[e>>0]=1;e=b+12|0;if(!(c[e>>2]|0)){i=d;return}Jag(0,b);f=c[e>>2]|0;if(f)eth(2910584,f);Kag(0,b);i=d;return}function Jhg(a){a=a|0;var b=0;b=i;zvh(3019256,a,0);i=b;return}function Khg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Lhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;VCf(a,sM(3019824)|0);c[c[d>>2]>>2]=a;i=b;return}function Mhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Nhg(a,b,d){a=a|0;b=b|0;d=d|0;d=i;Pmh();if(!b){RI(2963920)|0;b=qL(2963920)|0;Iag(b,c[899090]|0);pwh(b)}else{i=d;return}}function Ohg(b){b=b|0;var c=0;c=b+8|0;if(a[c>>0]|0)a[c>>0]=1;return}function Phg(b,c){b=b|0;c=c|0;c=b+8|0;if(a[c>>0]|0)a[c>>0]=1;return}function Qhg(b){b=b|0;var c=0,d=0;c=i;d=b+8|0;if(a[d>>0]|0)a[d>>0]=1;Jrg(0,b);i=c;return}function Rhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Shg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(3020880)|0);c[c[d>>2]>>2]=a;i=b;return}function Thg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;Rmh();Whg(0,d);if(Gqh(2619552,d)|0){if(a[2540708]|0){f=c[899172]|0;g=fwf(0,d,f)|0;RI(2965048)|0;h=qL(2965048)|0;j=c[899174]|0;Rag(h,g,j);pwh(h)}rwh(2540560);f=c[899172]|0;g=fwf(0,d,f)|0;RI(2965048)|0;h=qL(2965048)|0;j=c[899174]|0;Rag(h,g,j);pwh(h)}Yhg(0,d);RI(3090984)|0;h=vL(d,3090984)|0;if(h){j=qtg(h)|0;if(!((j|0)!=0&(e^1)?!(Gqh(2863856,j)|0):0)){k=j;l=11}}else{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}RI(2540728)|0;k=bvh(2651672,d,e?52:20,0,3,c[(c[635205]|0)+8>>2]|0,0)|0;l=11}if((l|0)==11?(k|0)!=0:0){m=Y0f(k,0)|0;i=b;return m|0}if(Gqh(2650144,d)|0){m=Xhg(0,d)|0;i=b;return m|0}m=tof(0,c[899176]|0)|0;b=Fqh(2537592,d)|0;if(a[2540708]|0){n=c[899178]|0;o=gwf(0,n,b)|0;RI(3089608)|0;p=qL(3089608)|0;Wsg(p,m,o);pwh(p)}rwh(2540560);n=c[899178]|0;o=gwf(0,n,b)|0;RI(3089608)|0;p=qL(3089608)|0;Wsg(p,m,o);pwh(p);return 0}function Uhg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;rwh(2836568)}f=Vhg(0,c,0,X_f(0)|0,d,0,e)|0;i=b;return f|0}function Vhg(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;Qmh();Whg(0,d);if(Gqh(2619552,d)|0){if(a[2540708]|0){k=c[899094]|0;l=fwf(0,d,k)|0;RI(2965048)|0;m=qL(2965048)|0;n=c[899096]|0;Rag(m,l,n);pwh(m)}rwh(2540560);k=c[899094]|0;l=fwf(0,d,k)|0;RI(2965048)|0;m=qL(2965048)|0;n=c[899096]|0;Rag(m,l,n);pwh(m)}m=(e&127|0)==0?e|20:e;if((g|0)!=0?(e=c[g+12>>2]|0,(e|0)!=0):0){RI(1104624)|0;n=twh(1104624,e)|0;if((e|0)>0){l=g+16|0;k=n+16|0;o=0;do{p=c[l+(da(c[(c[g>>2]|0)+120>>2]|0,o)|0)>>2]|0;if(p){q=Xnf(p)|0;Qqh(n,q);c[k+(da(c[(c[n>>2]|0)+120>>2]|0,o)|0)>>2]=q}o=o+1|0}while((o|0)!=(e|0));r=n}else r=n}else{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}RI(2540728)|0;r=c[(c[635205]|0)+8>>2]|0}if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;rwh(2836568)}s=X_f(0)|0}else s=f;f=Pvh(2836736,s,m,Kvh(2656576,d,m)|0,r,0)|0;RI(2819928)|0;n=swh(f,2819928)|0;if(n){Yhg(0,d);if((j|0)!=0?(c[j+12>>2]|0)>=1:0){if(!(Gqh(2653528,d)|0)){RI(1086352)|0;f=twh(1086352,1)|0;e=Fqh(2537592,d)|0;Qqh(f,e);c[f+16>>2]=e;e=Uxf(0,c[899104]|0,f)|0;RI(3100472)|0;f=qL(3100472)|0;pug(f,e);pwh(f)}f=x6f(0,d,j)|0;if(f){Yvh(2863088,n,f,m,s,g,h)|0;t=f;i=b;return t|0}}t=Uvh(2854912,n,m,s,g,h)|0;i=b;return t|0}h=r+12|0;if(Gqh(2650144,d)|0?(c[h>>2]|0)==0:0){t=Xhg(0,d)|0;i=b;return t|0}RI(2971904)|0;t=qL(2971904)|0;bcg(t,0);if((c[h>>2]|0)>0){b=r+16|0;g=0;do{s=c[b+(da(c[(c[r>>2]|0)+120>>2]|0,g)|0)>>2]|0;if(!s)u=c[899098]|0;else u=Fqh(2536192,s)|0;Hbg(t,u)|0;Hbg(t,c[899100]|0)|0;g=g+1|0}while((g|0)<(c[h>>2]|0))}h=c[t+8>>2]|0;if((h|0)>=3)Zeg(t,h+-2|0);h=tof(0,c[899102]|0)|0;g=Fqh(2537592,d)|0;if(a[2540708]|0){v=awf(0,h,g,t)|0;RI(3089608)|0;w=qL(3089608)|0;Vsg(w,v);pwh(w)}rwh(2540560);v=awf(0,h,g,t)|0;RI(3089608)|0;w=qL(3089608)|0;Vsg(w,v);pwh(w);return 0}function Whg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;Smh();if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[899204]|0);pwh(k)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[f>>2]=3443160;c[e+0>>2]=c[f+0>>2];if((npf(0,e)|0)!=(d|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[g>>2]=3443176;c[e+0>>2]=c[g+0>>2];if((npf(0,e)|0)!=(d|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[h>>2]=3431552;c[e+0>>2]=c[h+0>>2];if((npf(0,e)|0)!=(d|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[j>>2]=3443144;c[e+0>>2]=c[j+0>>2];if((npf(0,e)|0)!=(d|0)){i=b;return}}}}RI(1086352)|0;b=twh(1086352,1)|0;e=Fqh(2537592,d)|0;Qqh(b,e);c[b+16>>2]=e;e=Uxf(0,c[899206]|0,b)|0;RI(3100472)|0;b=qL(3100472)|0;pug(b,e);pwh(b)}function Xhg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[755266]|0;if(!d){e=MK(3021072)|0;c[755266]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Yhg(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;Tmh();if(Gqh(2653040,b)|0){RI(1086352)|0;d=twh(1086352,1)|0;e=Fqh(2537592,b)|0;Qqh(d,e);c[d+16>>2]=e;e=Uxf(0,c[899238]|0,d)|0;RI(3089608)|0;d=qL(3089608)|0;Vsg(d,e);pwh(d)}else{i=a;return}}function Zhg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2819056)|0;OXf(a,0);c[(c[d>>2]|0)+4>>2]=a;a=qL(2819224)|0;RI(2913760)|0;PXf(a,ML(c[728456]|0)|0);c[(c[d>>2]|0)+8>>2]=a;i=b;return}function _hg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[755542]|0;if(!d){e=MK(3022176)|0;c[755542]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function $hg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[755566]|0;if(!b){d=MK(3022272)|0;c[755566]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function aig(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[755580]|0;if(!d){e=MK(3022328)|0;c[755580]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function big(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+16|0;e=b;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;RI(3022384)|0;if(c[c[755619]>>2]|0){RI(3022384)|0;f=c[755619]|0;g=c[f>>2]|0;i=b;return g|0}RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;rwh(3080504)}Yrg(e,0);c[d+0>>2]=c[e+0>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];e=aig(0,bsg(d)|0)|0;RI(3022384)|0;c[c[755619]>>2]=e;RI(3022384)|0;f=c[755619]|0;g=c[f>>2]|0;i=b;return g|0}function cig(a){a=a|0;var b=0,c=0;b=i;c=_hg(a)|0;i=b;return c|0}function dig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;OXf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function eig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;nrg(a);c[c[d>>2]>>2]=a;i=b;return}function fig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;nrg(a);c[c[d>>2]>>2]=a;i=b;return}function gig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;nrg(a);c[c[d>>2]>>2]=a;i=b;return}function hig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;nrg(a);c[c[d>>2]>>2]=a;i=b;return}function iig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function jig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2819056)|0;OXf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function kig(a,b,d){a=a|0;b=b|0;d=d|0;d=i;Umh();if(!b){RI(2963920)|0;b=qL(2963920)|0;Iag(b,c[899262]|0);pwh(b)}else{i=d;return}}function lig(a){a=a|0;return c[a+8>>2]|0}function mig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,0);c[c[d>>2]>>2]=a;i=b;return}function nig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(3026112)|0);c[c[d>>2]>>2]=a;i=b;return}function oig(a){a=a|0;var b=0;b=i;Wmh();Grg(a,tof(0,c[899278]|0)|0);KHf(a,-2147024809);i=b;return}function pig(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;qsg(a,b,e);c[a+52>>2]=d;KHf(a,-2147024809);i=f;return}function qig(a){a=a|0;return c[a+52>>2]|0}function rig(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;Vmh();if((Fqh(3026248,b)|0)!=0?(Vof(Fqh(3026248,b)|0)|0)!=0:0){e=MHf(b)|0;f=org(0)|0;g=tof(0,c[899266]|0)|0;h=Fqh(3026248,b)|0;if(!(a[2540708]|0))rwh(2540560);j=jwf(0,e,f,g,h)|0;i=d;return j|0}j=MHf(b)|0;i=d;return j|0}function sig(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;Xmh();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];THf(a,b,f);f=Fqh(3026248,a)|0;L7f(b,c[899306]|0,f);i=e;return}function tig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function uig(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Rag(a,c,b);KHf(a,-2147467261);i=d;return}function vig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function wig(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=rig(b)|0;f=b+56|0;if(!(c[f>>2]|0)){g=e;i=d;return g|0}b=org(0)|0;h=c[f>>2]|0;if(!(a[2540708]|0))rwh(2540560);g=hwf(0,e,b,h)|0;i=d;return g|0}function xig(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;anh();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];sig(a,b,f);L7f(b,c[899358]|0,c[a+56>>2]|0);i=e;return}function yig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function zig(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2147024362);i=c;return}function Aig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Big(a){a=a|0;var b=0;b=i;bnh();Grg(a,tof(0,c[899368]|0)|0);KHf(a,-2146233085);i=b;return}function Cig(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233085);i=c;return}function Dig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Eig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Fig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(3079176)|0;Drg(a);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Gig(b){b=b|0;b=i;RI(3007432)|0;a[c[751881]>>0]=0;RI(3007432)|0;a[(c[751881]|0)+1>>0]=1;i=b;return}function Hig(a){a=a|0;return 0}function Iig(a){a=a|0;return 1}function Jig(b,c){b=b|0;c=+c;var d=0;b=i;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;rwh(3007432)}d=Lig(0,Kig(0,c)|0,0)|0;i=b;return d|0}function Kig(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+16|0;e=b;h[e>>3]=d;RI(3007432)|0;f=(a[3007580]|0)==0;h[k>>3]=d;g=c[k>>2]|0;j=c[k+4>>2]|0;l=VEi(g|0,j|0,40)|0;m=VEi(g|0,j|0,48)|0;n=VEi(g|0,j|0,56)|0;o=VEi(g|0,j|0,8)|0;p=VEi(g|0,j|0,16)|0;q=VEi(g|0,j|0,24)|0;if(f){RI(3007432)|0;rwh(3007432)}RI(3007432)|0;if(a[c[751881]>>0]|0){RI(1159264)|0;f=twh(1159264,8)|0;r=f+16|0;a[r>>0]=j;a[r+(c[(c[f>>2]|0)+120>>2]|0)>>0]=l;a[r+(c[(c[f>>2]|0)+120>>2]<<1)>>0]=m;a[r+((c[(c[f>>2]|0)+120>>2]|0)*3|0)>>0]=n;a[r+(c[(c[f>>2]|0)+120>>2]<<2)>>0]=g;a[r+((c[(c[f>>2]|0)+120>>2]|0)*5|0)>>0]=o;a[r+((c[(c[f>>2]|0)+120>>2]|0)*6|0)>>0]=p;a[r+((c[(c[f>>2]|0)+120>>2]|0)*7|0)>>0]=q;s=f;i=b;return s|0}RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;rwh(3007432)}s=Mig(0,e,8)|0;i=b;return s|0}function Lig(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;i=i+16|0;f=b;g=f;c[g>>2]=0;c[g+4>>2]=0;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;rwh(3007432)}Nig(0,f,d,e,8);e=f;H=c[e+4>>2]|0;i=b;return c[e>>2]|0}function Mig(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;RI(1159264)|0;f=twh(1159264,e)|0;if((e|0)<=0){i=b;return f|0}g=f+16|0;h=0;do{a[g+(da(c[(c[f>>2]|0)+120>>2]|0,h)|0)>>0]=a[d+h>>0]|0;h=h+1|0}while((h|0)!=(e|0));i=b;return f|0}function Nig(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;cnh();if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[899404]|0);pwh(h)}if((f|0)>=0?(h=c[e+12>>2]|0,(h|0)>(f|0)):0){if((h-g|0)<(f|0)){RI(2965048)|0;h=qL(2965048)|0;Rbg(h,c[899410]|0);pwh(h)}if((g|0)<=0){i=b;return}h=e+16|0;j=0;do{a[d+j>>0]=a[h+(da(c[(c[e>>2]|0)+120>>2]|0,j+f|0)|0)>>0]|0;j=j+1|0}while((j|0)!=(g|0));i=b;return}RI(2964880)|0;b=qL(2964880)|0;Qag(b,c[899406]|0,c[899408]|0);pwh(b)}function Oig(a,b){a=a|0;b=b|0;var d=0;a=i;dnh();if(!b){RI(2963920)|0;d=qL(2963920)|0;Iag(d,c[899512]|0);pwh(d)}d=Pig(0,b)|0;if((d|0)>-1){i=a;return d|0}else{d=tof(0,c[899514]|0)|0;RI(2965048)|0;a=qL(2965048)|0;Rbg(a,d);pwh(a)}return 0}function Pig(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[757790]|0;if(!d){e=MK(3031168)|0;c[757790]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function Qig(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;a=i;enh();if(!b){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[899538]|0);pwh(h)}if(!e){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[899540]|0);pwh(h)}if((d|0)<=-1){h=tof(0,c[899544]|0)|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[899542]|0,h);pwh(j)}if((f|0)<=-1){j=tof(0,c[899548]|0)|0;RI(2964880)|0;h=qL(2964880)|0;Qag(h,c[899546]|0,j);pwh(h)}if((g|0)<=-1){h=tof(0,c[899552]|0)|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[899550]|0,h);pwh(j)}if(Rig(0,b,d,e,f,g)|0){i=a;return}if(((Oig(0,b)|0)-g|0)<(d|0)){k=c[899554]|0;l=tof(0,k)|0;RI(2965048)|0;m=qL(2965048)|0;Rbg(m,l);pwh(m)}if(((Oig(0,e)|0)-g|0)<(f|0)){k=c[899554]|0;l=tof(0,k)|0;RI(2965048)|0;m=qL(2965048)|0;Rbg(m,l);pwh(m)}else{i=a;return}}function Rig(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;a=i;h=c[757804]|0;if(!h){j=MK(3031224)|0;c[757804]=j;k=j}else k=h;h=Bn[k&255](b,d,e,f,g)|0;i=a;return h|0}function Sig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Tig(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+8>>2]=b;c[a+12>>2]=-1;c[a+16>>2]=Vof(b)|0;i=d;return}function Uig(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=ywh(3032032,a)|0;RI(2540392)|0;a=pL(2540392,d)|0;i=c;return a|0}function Vig(a){a=a|0;return}function Wig(a){a=a|0;var b=0,d=0,e=0;b=i;fnh();d=c[a+12>>2]|0;if((d|0)!=-1?(d|0)<(c[a+16>>2]|0):0){e=Wof(c[a+8>>2]|0,d)|0;i=b;return e|0}e=tof(0,c[899648]|0)|0;RI(3084976)|0;b=qL(3084976)|0;osg(b,e);pwh(b);return 0}function Xig(a){a=a|0;var b=0,d=0,e=0;b=a+12|0;d=(c[b>>2]|0)+1|0;e=c[a+16>>2]|0;a=(d|0)<(e|0);c[b>>2]=a?d:e;return a|0}function Yig(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Zig(b){b=b|0;var d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=0;do if(vrg(0)|0){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}e=ieg(0)|0;RI(3032824)|0;c[(c[758229]|0)+16>>2]=e;RI(3032824)|0;c[(c[758229]|0)+12>>2]=e}else{c[d>>2]=0;RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}yeg(0,d)|0;e=c[d>>2]|0;if((e|0)!=-1?!((e&268435455|0)!=3&(e&268435456|0)==0):0){RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}e=zeg(0)|0;RI(3032824)|0;c[(c[758229]|0)+16>>2]=e;RI(3032824)|0;c[(c[758229]|0)+12>>2]=e;break}RI(2978896)|0;if(!(a[2979044]|0)){RI(2978896)|0;rwh(2978896)}e=ieg(0)|0;RI(3032824)|0;c[(c[758229]|0)+16>>2]=e;RI(3032824)|0;c[(c[758229]|0)+12>>2]=e}while(0);RI(3032824)|0;d=c[(c[758229]|0)+12>>2]|0;RI(3032824)|0;_ig(0,d,c[(c[758229]|0)+16>>2]|0);i=b;return}function _ig(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;b=i;RI(3032824)|0;if(!(a[3032972]|0)){RI(3032824)|0;rwh(3032824)}f=$ig(0,0)|0;RI(2817792)|0;g=qL(2817792)|0;CXf(g,f,e);RI(3032824)|0;c[(c[758229]|0)+4>>2]=g;RI(3032824)|0;g=c[(c[758229]|0)+4>>2]|0;RI(2811360)|0;zvh(2812368,swh(g,2811360)|0,1);RI(2813288)|0;if(!(a[2813436]|0)){RI(2813288)|0;rwh(2813288)}RI(3032824)|0;g=kXf(0,c[(c[758229]|0)+4>>2]|0,1)|0;RI(3032824)|0;c[(c[758229]|0)+4>>2]=g;g=ajg(0,0)|0;RI(2817792)|0;f=qL(2817792)|0;CXf(f,g,e);RI(3032824)|0;c[c[758229]>>2]=f;RI(3032824)|0;f=c[c[758229]>>2]|0;RI(2811360)|0;zvh(2812368,swh(f,2811360)|0,1);RI(3032824)|0;f=kXf(0,c[c[758229]>>2]|0,1)|0;RI(3032824)|0;c[c[758229]>>2]=f;f=bjg(0,0)|0;RI(2817304)|0;if(!(a[2817452]|0)){RI(2817304)|0;rwh(2817304)}RI(2817304)|0;e=qL(2817304)|0;AXf(e,f,d);RI(3032824)|0;c[(c[758229]|0)+8>>2]=e;RI(2811136)|0;if(!(a[2811284]|0)){RI(2811136)|0;rwh(2811136)}RI(3032824)|0;e=$Wf(0,c[(c[758229]|0)+8>>2]|0)|0;RI(3032824)|0;c[(c[758229]|0)+8>>2]=e;RI(3032824)|0;Jrg(0,c[c[758229]>>2]|0);RI(3032824)|0;Jrg(0,c[(c[758229]|0)+4>>2]|0);RI(3032824)|0;Jrg(0,c[(c[758229]|0)+8>>2]|0);i=b;return}function $ig(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;rwh(2781280)}g=IVf(0)|0;RI(3032824)|0;if(!(a[3032972]|0)){RI(3032824)|0;rwh(3032824)}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];f=djg(0,e,2,d)|0;i=b;return f|0}function ajg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;rwh(2781280)}g=GVf(0)|0;RI(3032824)|0;if(!(a[3032972]|0)){RI(3032824)|0;rwh(3032824)}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];f=djg(0,e,2,d)|0;i=b;return f|0}function bjg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;RI(2781280)|0;if(!(a[2781428]|0)){RI(2781280)|0;rwh(2781280)}g=HVf(0)|0;RI(3032824)|0;if(!(a[3032972]|0)){RI(3032824)|0;rwh(3032824)}c[f>>2]=g;c[e+0>>2]=c[f+0>>2];f=djg(0,e,1,d)|0;i=b;return f|0}function cjg(b){b=b|0;b=i;RI(3032824)|0;if(!(a[3032972]|0)){RI(3032824)|0;rwh(3032824)}RI(3032824)|0;i=b;return c[(c[758229]|0)+4>>2]|0}function djg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;i=i+16|0;f=a+4|0;g=a;RI(2783800)|0;h=qL(2783800)|0;c[g>>2]=c[b>>2];c[f+0>>2]=c[g+0>>2];KUf(h,f,d,0,e,0,(e|0)==0);i=a;return h|0}function ejg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function fjg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+80|0;d=b+32|0;e=b+24|0;f=b+44|0;g=b+60|0;h=b+12|0;j=b+40|0;k=b+48|0;l=b+56|0;m=b+64|0;n=b+68|0;o=b+8|0;p=b+4|0;q=b;r=b+36|0;s=b+16|0;t=b+20|0;u=b+52|0;v=b+28|0;RI(3034120)|0;if(!(a[3034268]|0)){RI(3034120)|0;rwh(3034120)}RI(3034120)|0;w=c[c[758553]>>2]|0;RI(3034288)|0;c[c[758595]>>2]=w;RI(1104624)|0;w=twh(1104624,19)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[e>>2]=3432408;c[d+0>>2]=c[e+0>>2];e=npf(0,d)|0;Qqh(w,e);x=w+16|0;c[x+(c[(c[w>>2]|0)+120>>2]|0)>>2]=e;c[f>>2]=3451464;c[d+0>>2]=c[f+0>>2];f=npf(0,d)|0;Qqh(w,f);c[x+(c[(c[w>>2]|0)+120>>2]<<1)>>2]=f;c[g>>2]=3431408;c[d+0>>2]=c[g+0>>2];g=npf(0,d)|0;Qqh(w,g);c[x+((c[(c[w>>2]|0)+120>>2]|0)*3|0)>>2]=g;c[h>>2]=3433768;c[d+0>>2]=c[h+0>>2];h=npf(0,d)|0;Qqh(w,h);c[x+(c[(c[w>>2]|0)+120>>2]<<2)>>2]=h;c[j>>2]=3440056;c[d+0>>2]=c[j+0>>2];j=npf(0,d)|0;Qqh(w,j);c[x+((c[(c[w>>2]|0)+120>>2]|0)*5|0)>>2]=j;c[k>>2]=3433864;c[d+0>>2]=c[k+0>>2];k=npf(0,d)|0;Qqh(w,k);c[x+((c[(c[w>>2]|0)+120>>2]|0)*6|0)>>2]=k;c[l>>2]=3437968;c[d+0>>2]=c[l+0>>2];l=npf(0,d)|0;Qqh(w,l);c[x+((c[(c[w>>2]|0)+120>>2]|0)*7|0)>>2]=l;c[m>>2]=3438032;c[d+0>>2]=c[m+0>>2];m=npf(0,d)|0;Qqh(w,m);c[x+(c[(c[w>>2]|0)+120>>2]<<3)>>2]=m;c[n>>2]=3431160;c[d+0>>2]=c[n+0>>2];n=npf(0,d)|0;Qqh(w,n);c[x+((c[(c[w>>2]|0)+120>>2]|0)*9|0)>>2]=n;c[o>>2]=3440080;c[d+0>>2]=c[o+0>>2];o=npf(0,d)|0;Qqh(w,o);c[x+((c[(c[w>>2]|0)+120>>2]|0)*10|0)>>2]=o;c[p>>2]=3437568;c[d+0>>2]=c[p+0>>2];p=npf(0,d)|0;Qqh(w,p);c[x+((c[(c[w>>2]|0)+120>>2]|0)*11|0)>>2]=p;c[q>>2]=3440112;c[d+0>>2]=c[q+0>>2];q=npf(0,d)|0;Qqh(w,q);c[x+((c[(c[w>>2]|0)+120>>2]|0)*12|0)>>2]=q;c[r>>2]=3432128;c[d+0>>2]=c[r+0>>2];r=npf(0,d)|0;Qqh(w,r);c[x+((c[(c[w>>2]|0)+120>>2]|0)*13|0)>>2]=r;c[s>>2]=3438832;c[d+0>>2]=c[s+0>>2];s=npf(0,d)|0;Qqh(w,s);c[x+((c[(c[w>>2]|0)+120>>2]|0)*14|0)>>2]=s;c[t>>2]=3440024;c[d+0>>2]=c[t+0>>2];t=npf(0,d)|0;Qqh(w,t);c[x+((c[(c[w>>2]|0)+120>>2]|0)*15|0)>>2]=t;c[u>>2]=3432952;c[d+0>>2]=c[u+0>>2];u=npf(0,d)|0;Qqh(w,u);c[w+((c[(c[w>>2]|0)+120>>2]|0)+1<<4)>>2]=u;c[v>>2]=3431728;c[d+0>>2]=c[v+0>>2];v=npf(0,d)|0;Qqh(w,v);c[x+((c[(c[w>>2]|0)+120>>2]|0)*18|0)>>2]=v;RI(3034288)|0;c[(c[758595]|0)+4>>2]=w;i=b;return}function gjg(a,b){a=a|0;b=b|0;return b<<24>>24!=0|0}function hjg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+48|0;e=b+32|0;f=b+16|0;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;cyf(g,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];g=Dzf(0,f,e)|0;i=b;return g|0}function ijg(a,b){a=a|0;b=+b;return b!=0.0|0}function jjg(a,b){a=a|0;b=ea(b);a=b!=ea(0.0);return a|0}function kjg(a,b){a=a|0;b=b|0;return (b|0)!=0|0}function ljg(a,b,c){a=a|0;b=b|0;c=c|0;return (b|0)!=0|(c|0)!=0|0}function mjg(a,b){a=a|0;b=b|0;return b<<24>>24!=0|0}function njg(a,b){a=a|0;b=b|0;return b<<16>>16!=0|0}function ojg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;d=i;if(!c){e=0;i=d;return e|0}RI(2601984)|0;if(!(a[2602132]|0)){RI(2601984)|0;rwh(2601984)}e=rAf(0,c)|0;i=d;return e|0}function pjg(a,b){a=a|0;b=b|0;return (b|0)!=0|0}function qjg(a,b,c){a=a|0;b=b|0;c=c|0;return (b|0)!=0|(c|0)!=0|0}function rjg(a,b){a=a|0;b=b|0;return b<<16>>16!=0|0}function sjg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=gwh(2545280,swh(b,2545096)|0,c)|0;i=a;return d|0}function tjg(a,b){a=a|0;b=b|0;return b&1|0}function ujg(a,b){a=a|0;b=b|0;a=i;gnh();if((b&65535)<256){i=a;return b&255|0}else{b=tof(0,c[899666]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function vjg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;hnh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;cyf(g,255);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[899688]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[899688]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=jzf(0,e)|0;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=jzf(0,e)|0;i=b;return n|0}function wjg(a,b){a=a|0;b=+b;var d=0,e=0;a=i;inh();if(!(!(b>255.0)&b>=0.0)){d=tof(0,c[899724]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,d);pwh(e)}if(!(Mxf(0,b)|0)?!(Rxf(0,b)|0):0){e=~~+dEi(b)&255;i=a;return e|0}e=tof(0,c[899726]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,e);pwh(a);return 0}function xjg(a,b){a=a|0;b=ea(b);var d=0,e=0;a=i;jnh();if(!(!(b>ea(255.0))&b>=ea(0.0))){d=tof(0,c[899772]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,d);pwh(e)}if(!(gxf(0,b)|0)?!(lxf(0,b)|0):0){e=~~ea(eEi(b))&255;i=a;return e|0}e=tof(0,c[899774]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,e);pwh(a);return 0}function yjg(a,b){a=a|0;b=b|0;a=i;knh();if(b>>>0<256){i=a;return b&255|0}else{b=tof(0,c[899852]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function zjg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;lnh();if(d>>>0<0|(d|0)==0&b>>>0<256){i=a;return b&255|0}else{b=tof(0,c[899856]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Ajg(a,b){a=a|0;b=b|0;a=i;mnh();if(b<<24>>24>-1){i=a;return b|0}else{b=tof(0,c[899860]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Bjg(a,b){a=a|0;b=b|0;a=i;nnh();if((b&65535)<256){i=a;return b&255|0}else{b=tof(0,c[899880]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Cjg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b)d=0;else d=Urf(0,b,c)|0;i=a;return d|0}function Djg(a,b){a=a|0;b=b|0;a=i;onh();if(b>>>0<256){i=a;return b&255|0}else{b=tof(0,c[899884]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Ejg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;pnh();if(d>>>0<0|(d|0)==0&b>>>0<256){i=a;return b&255|0}else{b=tof(0,c[899888]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Fjg(a,b){a=a|0;b=b|0;a=i;qnh();if((b&65535)<256){i=a;return b&255|0}else{b=tof(0,c[899892]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Gjg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Jwh(2545352,swh(b,2545096)|0,c)|0;i=a;return d|0}function Hjg(a,b){a=a|0;b=b|0;return b&255|0}function Ijg(a,b){a=a|0;b=b|0;a=i;rnh();if(b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[899896]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Jjg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;snh();if(d>>>0<0|(d|0)==0&b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[899932]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Kjg(a,b){a=a|0;b=ea(b);tnh();RI(3084488)|0;a=qL(3084488)|0;lsg(a,c[899936]|0);pwh(a);return 0}function Ljg(a,b){a=a|0;b=b|0;a=i;unh();if(b<<24>>24>-1){i=a;return b<<24>>24|0}else{b=tof(0,c[899958]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Mjg(a,b){a=a|0;b=b|0;a=i;vnh();if(b<<16>>16>-1){i=a;return b|0}else{b=tof(0,c[899978]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Njg(b,c,d){b=b|0;c=c|0;d=d|0;d=i;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}b=ruf(0,c)|0;i=d;return b|0}function Ojg(a,b){a=a|0;b=b|0;a=i;wnh();if(b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[899982]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Pjg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;xnh();if(d>>>0<0|(d|0)==0&b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900004]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Qjg(a,b){a=a|0;b=b|0;return b|0}function Rjg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Kwh(2545424,swh(b,2545096)|0,c)|0;i=a;return d|0}function Sjg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;d=i;RI(3034456)|0;g=(a[3034604]|0)!=0;if(!e){if(!g){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;h=(c[758637]|0)+16|0;c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];i=d;return}else{if(!g){RI(3034456)|0;rwh(3034456)}Tjg(b,0,e,f);i=d;return}}function Tjg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;c=i;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Tpg(b,0,d,e,7);i=c;return}function Ujg(a,b,d){a=a|0;b=b|0;d=d|0;ynh();RI(3084488)|0;d=qL(3084488)|0;lsg(d,c[900008]|0);pwh(d)}function Vjg(a,b,d){a=a|0;b=b|0;d=d|0;znh();RI(3084488)|0;d=qL(3084488)|0;lsg(d,c[900012]|0);pwh(d)}function Wjg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;Anh();RI(3084488)|0;e=qL(3084488)|0;lsg(e,c[900016]|0);pwh(e)}function Xjg(a,b,d){a=a|0;b=b|0;d=ea(d);Bnh();RI(3084488)|0;b=qL(3084488)|0;lsg(b,c[900020]|0);pwh(b)}function Yjg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;d=i;if(e){RI(2545096)|0;Lwh(b,2545496,swh(e,2545096)|0,f);i=d;return}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;f=(c[758637]|0)+16|0;c[b+0>>2]=c[f+0>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];i=d;return}function Zjg(a,b,d){a=a|0;b=b|0;d=d|0;Cnh();RI(3084488)|0;d=qL(3084488)|0;lsg(d,c[900024]|0);pwh(d)}function _jg(a,b,d){a=a|0;b=b|0;d=d|0;Dnh();RI(3084488)|0;d=qL(3084488)|0;lsg(d,c[900028]|0);pwh(d)}function $jg(a,b,d){a=a|0;b=b|0;d=d|0;Enh();RI(3084488)|0;d=qL(3084488)|0;lsg(d,c[900032]|0);pwh(d)}function akg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;Fnh();RI(3084488)|0;e=qL(3084488)|0;lsg(e,c[900036]|0);pwh(e)}function bkg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}vzf(b,0,d&1);i=c;return}function ckg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}rzf(b,0,d);i=c;return}function dkg(b,c,d){b=b|0;c=c|0;d=+d;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}Azf(b,0,d);i=c;return}function ekg(b,c,d){b=b|0;c=c|0;d=ea(d);c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}zzf(b,0,d);i=c;return}function fkg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}vzf(b,0,d);i=c;return}function gkg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}xzf(b,0,d,e);i=c;return}function hkg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}szf(b,0,d);i=c;return}function ikg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}tzf(b,0,d);i=c;return}function jkg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;d=i;if(!e){c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;cyf(b,0);i=d;return}RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}Wyf(b,0,e,f);i=d;return}function kkg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}wzf(b,0,d);i=c;return}function lkg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}yzf(b,0,d,e);i=c;return}function mkg(b,c,d){b=b|0;c=c|0;d=d|0;c=i;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)}uzf(b,0,d);i=c;return}function nkg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;b=i;if(!d){c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;cyf(a,0);i=b;return}else{RI(2545096)|0;Mwh(a,2545568,swh(d,2545096)|0,e);i=b;return}}function okg(a,b){a=a|0;b=b|0;return +(b?1.0:0.0)}function pkg(a,b){a=a|0;b=b|0;return +(+(b&255))}function qkg(b,d){b=b|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];f=+Czf(0,e);i=b;return +f}function rkg(a,b){a=a|0;b=+b;return +b}function skg(a,b){a=a|0;b=ea(b);return +(+b)}function tkg(a,b){a=a|0;b=b|0;return +(+(b|0))}function ukg(a,b,c){a=a|0;b=b|0;c=c|0;return +(+(b>>>0)+4294967296.0*+(c|0))}function vkg(a,b){a=a|0;b=b|0;return +(+(b<<24>>24))}function wkg(a,b){a=a|0;b=b|0;return +(+(b<<16>>16))}function xkg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0;a=i;if(!b)d=0.0;else d=+Sxf(0,b,c);i=a;return +d}function ykg(a,b){a=a|0;b=b|0;return +(+(b>>>0))}function zkg(a,b,c){a=a|0;b=b|0;c=c|0;return +(+(b>>>0)+4294967296.0*+(c>>>0))}function Akg(a,b){a=a|0;b=b|0;return +(+(b&65535))}function Bkg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0;a=i;if(!b){d=0.0;i=a;return +d}RI(2545096)|0;d=+Nwh(2545640,swh(b,2545096)|0,c);i=a;return +d}function Ckg(a,b){a=a|0;b=b|0;return b&1|0}function Dkg(a,b){a=a|0;b=b|0;return b&255|0}function Ekg(a,b){a=a|0;b=b|0;a=i;Gnh();if(b<<16>>16>-1){i=a;return b|0}else{b=tof(0,c[900040]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Fkg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;Hnh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;cyf(g,32767);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900062]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,-32768);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900062]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=lzf(0,e)|0;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=lzf(0,e)|0;i=b;return n|0}function Gkg(a,b){a=a|0;b=+b;var d=0;a=i;Inh();if(!(b>32767.0)&b>=-32768.0){d=~~+dEi(b);i=a;return d|0}else{d=tof(0,c[900098]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function Hkg(a,b){a=a|0;b=ea(b);var d=0;a=i;Jnh();if(!(b>ea(32767.0))&b>=ea(-32768.0)){d=~~ea(eEi(b));i=a;return d|0}else{d=tof(0,c[900102]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function Ikg(a,b){a=a|0;b=b|0;a=i;Knh();if((b+32768|0)>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900106]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Jkg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;Lnh();e=_Ei(b|0,d|0,32768,0)|0;d=H;if(d>>>0<0|(d|0)==0&e>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900110]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Kkg(a,b){a=a|0;b=b|0;return b<<24>>24|0}function Lkg(a,b){a=a|0;b=b|0;return b|0}function Mkg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b)d=0;else d=atf(0,b,c)|0;i=a;return d|0}function Nkg(a,b){a=a|0;b=b|0;a=i;Mnh();if(b>>>0<32768){i=a;return b&65535|0}else{b=tof(0,c[900114]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Okg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;Nnh();if(d>>>0<0|(d|0)==0&b>>>0<32768){i=a;return b&65535|0}else{b=tof(0,c[900118]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Pkg(a,b){a=a|0;b=b|0;a=i;Onh();if(b<<16>>16>-1){i=a;return b|0}else{b=tof(0,c[900122]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Qkg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Owh(2545712,swh(b,2545096)|0,c)|0;i=a;return d|0}function Rkg(a,b){a=a|0;b=b|0;return b&1|0}function Skg(a,b){a=a|0;b=b|0;return b&255|0}function Tkg(a,b){a=a|0;b=b|0;return b&65535|0}function Ukg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;Pnh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;cyf(g,2147483647);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900126]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,-2147483648);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900126]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=nzf(0,e)|0;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=nzf(0,e)|0;i=b;return n|0}function Vkg(a,b){a=a|0;b=+b;var d=0,e=0,f=0.0;a=i;Qnh();if(!(!(b>2147483647.0)&b>=-2147483648.0)){d=tof(0,c[900162]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,d);pwh(e)}f=+dEi(b);if(f>2147483647.0)pwh(PJ(3068960)|0);else{i=a;return ~~f|0}return 0}function Wkg(a,b){a=a|0;b=ea(b);var d=0,e=0,f=Im;a=i;Rnh();if(!(!(b>ea(2147483650.0))&b>=ea(-2147483650.0))){d=tof(0,c[900166]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,d);pwh(e)}f=ea(eEi(b));if(+f>2147483647.0)pwh(PJ(3068960)|0);else{i=a;return ~~f|0}return 0}function Xkg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;Snh();e=_Ei(b|0,d|0,-2147483648,0)|0;d=H;if(d>>>0<1|(d|0)==1&e>>>0<0){i=a;return b|0}else{b=tof(0,c[900170]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Ykg(a,b){a=a|0;b=b|0;return b<<24>>24|0}function Zkg(a,b){a=a|0;b=b|0;return b<<16>>16|0}function _kg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b)d=0;else d=_of(0,b,c)|0;i=a;return d|0}function $kg(a,b){a=a|0;b=b|0;a=i;Tnh();if((b|0)>-1){i=a;return b|0}else{b=tof(0,c[900174]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function alg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;Unh();if(d>>>0<0|(d|0)==0&b>>>0<2147483648){i=a;return b|0}else{b=tof(0,c[900196]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function blg(a,b){a=a|0;b=b|0;return b&65535|0}function clg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Zqh(2545784,swh(b,2545096)|0,c)|0;i=a;return d|0}function dlg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&1|0}function elg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&255|0}function flg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&65535|0}function glg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;Vnh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;byf(g,-1,2147483647,0,0,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900200]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;byf(h,0,-2147483648,0,1,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900200]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=pzf(0,e)|0;o=H;H=o;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=pzf(0,e)|0;o=H;H=o;i=b;return n|0}function hlg(a,b){a=a|0;b=+b;var d=0.0,e=0;a=i;Wnh();if(!(b>9223372036854775808.0)&b>=-9223372036854775808.0){d=+dEi(b);H=+S(d)>=1.0?(d>0.0?(ha(+R(d/4294967296.0),4294967295.0)|0)>>>0:~~+ca((d-+(~~d>>>0))/4294967296.0)>>>0):0;i=a;return ~~d>>>0|0}else{a=tof(0,c[900236]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,a);pwh(e)}return 0}function ilg(a,b){a=a|0;b=ea(b);var d=Im,e=0;a=i;Xnh();if(!(b>ea(922337203.0e10))&b>=ea(-922337203.0e10)){d=ea(eEi(b));H=+S(+d)>=1.0?(+d>0.0?(ha(+R(+d/4294967296.0),4294967295.0)|0)>>>0:~~+ca((+d-+(~~+d>>>0))/4294967296.0)>>>0):0;i=a;return ~~+d>>>0|0}else{a=tof(0,c[900240]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,a);pwh(e)}return 0}function jlg(a,b){a=a|0;b=b|0;a=i;H=((b|0)<0)<<31>>31;i=a;return b|0}function klg(a,b,c){a=a|0;b=b|0;c=c|0;a=i;H=c;i=a;return b|0}function llg(a,b){a=a|0;b=b|0;var c=0;a=i;c=b<<24>>24;H=((c|0)<0)<<31>>31;i=a;return c|0}function mlg(a,b){a=a|0;b=b|0;var c=0;a=i;c=b<<16>>16;H=((c|0)<0)<<31>>31;i=a;return c|0}function nlg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a=i;if(!b){d=0;e=0}else{f=bqf(0,b,c)|0;d=H;e=f}H=d;i=a;return e|0}function olg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b|0}function plg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;Ynh();if((d|0)>-1|(d|0)==-1&b>>>0>4294967295){H=d;i=a;return b|0}else{b=tof(0,c[900244]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function qlg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&65535|0}function rlg(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;if(!c){d=0;e=0;H=d;i=b;return e|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}f=slg(0,c,0)|0;d=H;e=f;H=d;i=b;return e|0}function slg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a=i;if(!b){d=0;e=0;H=d;i=a;return e|0}RI(2545096)|0;f=Pwh(2545856,swh(b,2545096)|0,c)|0;d=H;e=f;H=d;i=a;return e|0}function tlg(a,b){a=a|0;b=b|0;return b&1|0}function ulg(a,b){a=a|0;b=b|0;a=i;Znh();if(b<<24>>24>-1){i=a;return b|0}else{b=tof(0,c[900266]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function vlg(a,b){a=a|0;b=b|0;a=i;_nh();if((b&65535)<128){i=a;return b&255|0}else{b=tof(0,c[900288]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function wlg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;$nh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;cyf(g,127);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900292]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,-128);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900292]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=kzf(0,e)|0;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=kzf(0,e)|0;i=b;return n|0}function xlg(a,b){a=a|0;b=+b;var d=0;a=i;aoh();if(!(b>127.0)&b>=-128.0){d=~~+dEi(b);i=a;return d|0}else{d=tof(0,c[900328]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function ylg(a,b){a=a|0;b=ea(b);var d=0;a=i;boh();if(!(b>ea(127.0))&b>=ea(-128.0)){d=~~ea(eEi(b));i=a;return d|0}else{d=tof(0,c[900332]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function zlg(a,b){a=a|0;b=b|0;a=i;coh();if((b+128|0)>>>0<256){i=a;return b&255|0}else{b=tof(0,c[900368]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Alg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;doh();e=_Ei(b|0,d|0,128,0)|0;d=H;if(d>>>0<0|(d|0)==0&e>>>0<256){i=a;return b&255|0}else{b=tof(0,c[900372]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Blg(a,b){a=a|0;b=b|0;a=i;eoh();if((b+128<<16>>16&65535)<256){i=a;return b&255|0}else{b=tof(0,c[900376]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Clg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;foh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[900380]|0);pwh(e)}else{e=wsf(0,b,d)|0;i=a;return e|0}return 0}function Dlg(a,b){a=a|0;b=b|0;a=i;goh();if(b>>>0<128){i=a;return b&255|0}else{b=tof(0,c[900384]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Elg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;hoh();if(d>>>0<0|(d|0)==0&b>>>0<128){i=a;return b&255|0}else{b=tof(0,c[900388]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Flg(a,b){a=a|0;b=b|0;a=i;ioh();if((b&65535)<128){i=a;return b&255|0}else{b=tof(0,c[900392]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Glg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Qwh(2545928,swh(b,2545096)|0,c)|0;i=a;return d|0}function Hlg(a,b){a=a|0;b=b|0;var c=Im;c=b?ea(1.0):ea(0.0);return ea(c)}function Ilg(a,b){a=a|0;b=b|0;var c=Im;c=ea(b&255);return ea(c)}function Jlg(b,d){b=b|0;d=d|0;var e=0,f=Im;b=i;i=i+16|0;e=b;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];f=ea(Bzf(0,e));i=b;return ea(f)}function Klg(a,b){a=a|0;b=+b;var c=Im;c=ea(b);return ea(c)}function Llg(a,b){a=a|0;b=ea(b);return ea(b)}function Mlg(a,b){a=a|0;b=b|0;var c=Im;c=ea(b|0);return ea(c)}function Nlg(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im;d=ea(+(b>>>0)+4294967296.0*+(c|0));return ea(d)}function Olg(a,b){a=a|0;b=b|0;var c=Im;c=ea(b<<24>>24);return ea(c)}function Plg(a,b){a=a|0;b=b|0;var c=Im;c=ea(b<<16>>16);return ea(c)}function Qlg(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im;a=i;if(!b)d=ea(0.0);else d=ea(mxf(0,b,c));i=a;return ea(d)}function Rlg(a,b){a=a|0;b=b|0;var c=Im;c=ea(+(b>>>0));return ea(c)}function Slg(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im;d=ea(+(b>>>0)+4294967296.0*+(c>>>0));return ea(d)}function Tlg(a,b){a=a|0;b=b|0;var c=Im;c=ea(b&65535);return ea(c)}function Ulg(a,b,c){a=a|0;b=b|0;c=c|0;var d=Im;a=i;if(!b){d=ea(0.0);i=a;return ea(d)}RI(2545096)|0;d=ea(Rwh(2546e3,swh(b,2545096)|0,c));i=a;return ea(d)}function Vlg(a,b){a=a|0;b=b|0;return b&1|0}function Wlg(a,b){a=a|0;b=b|0;return b&255|0}function Xlg(a,b){a=a|0;b=b|0;return b|0}function Ylg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;joh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;cyf(g,65535);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900396]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900396]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=mzf(0,e)|0;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=mzf(0,e)|0;i=b;return n|0}function Zlg(a,b){a=a|0;b=+b;var d=0;a=i;koh();if(!(b>65535.0)&b>=0.0){d=~~+dEi(b)&65535;i=a;return d|0}else{d=tof(0,c[900434]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function _lg(a,b){a=a|0;b=ea(b);var d=0;a=i;loh();if(!(b>ea(65535.0))&b>=ea(0.0)){d=~~ea(eEi(b))&65535;i=a;return d|0}else{d=tof(0,c[900438]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function $lg(a,b){a=a|0;b=b|0;a=i;moh();if(b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900442]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function amg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;noh();if(d>>>0<0|(d|0)==0&b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900446]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function bmg(a,b){a=a|0;b=b|0;a=i;ooh();if(b<<24>>24>-1){i=a;return b<<24>>24|0}else{b=tof(0,c[900450]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function cmg(a,b){a=a|0;b=b|0;a=i;poh();if(b<<16>>16>-1){i=a;return b|0}else{b=tof(0,c[900472]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function dmg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b)d=0;else d=Ctf(0,b,c)|0;i=a;return d|0}function emg(a,b){a=a|0;b=b|0;a=i;qoh();if(b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900476]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function fmg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;roh();if(d>>>0<0|(d|0)==0&b>>>0<65536){i=a;return b&65535|0}else{b=tof(0,c[900500]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function gmg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Kwh(2546224,swh(b,2545096)|0,c)|0;i=a;return d|0}function hmg(a,b){a=a|0;b=b|0;return b&1|0}function img(a,b){a=a|0;b=b|0;return b&255|0}function jmg(a,b){a=a|0;b=b|0;return b&65535|0}function kmg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;soh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;byf(g,-1,0,0,0,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900504]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900504]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=ozf(0,e)|0;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=ozf(0,e)|0;i=b;return n|0}function lmg(a,b){a=a|0;b=+b;var d=0;a=i;toh();if(!(b>4294967295.0)&b>=0.0){d=~~+dEi(b)>>>0;i=a;return d|0}else{d=tof(0,c[900542]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function mmg(a,b){a=a|0;b=ea(b);var d=0;a=i;uoh();if(!(b>ea(4294967300.0))&b>=ea(0.0)){d=~~ea(eEi(b))>>>0;i=a;return d|0}else{d=tof(0,c[900546]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function nmg(a,b){a=a|0;b=b|0;a=i;voh();if((b|0)>-1){i=a;return b|0}else{b=tof(0,c[900550]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function omg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;woh();if(d>>>0<1|(d|0)==1&b>>>0<0){i=a;return b|0}else{b=tof(0,c[900572]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function pmg(a,b){a=a|0;b=b|0;a=i;xoh();if(b<<24>>24>-1){i=a;return b<<24>>24|0}else{b=tof(0,c[900576]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function qmg(a,b){a=a|0;b=b|0;a=i;yoh();if(b<<16>>16>-1){i=a;return b<<16>>16|0}else{b=tof(0,c[900580]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function rmg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b)d=0;else d=Jqf(0,b,c)|0;i=a;return d|0}function smg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;zoh();if(d>>>0<1|(d|0)==1&b>>>0<0){i=a;return b|0}else{b=tof(0,c[900584]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function tmg(a,b){a=a|0;b=b|0;return b&65535|0}function umg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;if(!b){d=0;i=a;return d|0}RI(2545096)|0;d=Swh(2546296,swh(b,2545096)|0,c)|0;i=a;return d|0}function vmg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&1|0}function wmg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&255|0}function xmg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&65535|0}function ymg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+80|0;e=b+64|0;f=b+48|0;g=b+32|0;h=b+16|0;j=b;Aoh();c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;byf(g,-1,-1,0,0,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];if(Fzf(0,f,e)|0){k=c[900608]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;cyf(h,0);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;rwh(2592872)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];if(Gzf(0,f,e)|0){k=c[900608]|0;l=tof(0,k)|0;RI(3086272)|0;m=qL(3086272)|0;xsg(m,l);pwh(m)};c[e+0>>2]=c[d+0>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];Csg(j,0,e);RI(2592872)|0;if(a[2593020]|0){c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=qzf(0,e)|0;o=H;H=o;i=b;return n|0}RI(2592872)|0;rwh(2592872);c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];n=qzf(0,e)|0;o=H;H=o;i=b;return n|0}function zmg(a,b){a=a|0;b=+b;var d=0.0,e=0;a=i;Boh();if(!(b>18446744073709551616.0)&b>=0.0){d=+dEi(b);H=+S(d)>=1.0?(d>0.0?(ha(+R(d/4294967296.0),4294967295.0)|0)>>>0:~~+ca((d-+(~~d>>>0))/4294967296.0)>>>0):0;i=a;return ~~d>>>0|0}else{a=tof(0,c[900646]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,a);pwh(e)}return 0}function Amg(a,b){a=a|0;b=ea(b);var d=Im,e=0;a=i;Coh();if(!(b>ea(18446744099999997952.0))&b>=ea(0.0)){d=ea(eEi(b));H=+S(+d)>=1.0?(+d>0.0?(ha(+R(+d/4294967296.0),4294967295.0)|0)>>>0:~~+ca((+d-+(~~+d>>>0))/4294967296.0)>>>0):0;i=a;return ~~+d>>>0|0}else{a=tof(0,c[900650]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,a);pwh(e)}return 0}function Bmg(a,b){a=a|0;b=b|0;a=i;Doh();if((b|0)>-1){H=((b|0)<0)<<31>>31;i=a;return b|0}else{b=tof(0,c[900654]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Cmg(a,b,d){a=a|0;b=b|0;d=d|0;a=i;Eoh();if((d|0)>-1|(d|0)==-1&b>>>0>4294967295){H=d;i=a;return b|0}else{b=tof(0,c[900676]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,b);pwh(a)}return 0}function Dmg(a,b){a=a|0;b=b|0;var d=0;a=i;Foh();if(b<<24>>24>-1){d=b<<24>>24;H=((d|0)<0)<<31>>31;i=a;return d|0}else{RI(3086272)|0;d=qL(3086272)|0;xsg(d,c[900680]|0);pwh(d)}return 0}function Emg(a,b){a=a|0;b=b|0;var d=0;a=i;Goh();if(b<<16>>16>-1){d=b<<16>>16;H=((d|0)<0)<<31>>31;i=a;return d|0}else{d=tof(0,c[900684]|0)|0;RI(3086272)|0;a=qL(3086272)|0;xsg(a,d);pwh(a)}return 0}function Fmg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a=i;if(!b){d=0;e=0}else{f=orf(0,b,c)|0;d=H;e=f}H=d;i=a;return e|0}function Gmg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b|0}function Hmg(a,b){a=a|0;b=b|0;a=i;H=0;i=a;return b&65535|0}function Img(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;if(!c){d=0;e=0;H=d;i=b;return e|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}f=Jmg(0,c,0)|0;d=H;e=f;H=d;i=b;return e|0}function Jmg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a=i;if(!b){d=0;e=0;H=d;i=a;return e|0}RI(2545096)|0;f=Twh(2546368,swh(b,2545096)|0,c)|0;d=H;e=f;H=d;i=a;return e|0}function Kmg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;f=b+4|0;g=b;Hoh();if(!((d|0)==0|(e|0)!=0)){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[900688]|0);pwh(h)}RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;rwh(2686624)}h=eKf(0)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[g>>2]=3432952;c[f+0>>2]=c[g+0>>2];if((npf(0,f)|0)==(e|0))j=vvh(2756280,h)|0;else j=Kuh(2756224,h)|0;RI(3034288)|0;if(a[3034436]|0){k=Lmg(0,d,e,j,1)|0;i=b;return k|0}RI(3034288)|0;rwh(3034288);k=Lmg(0,d,e,j,1)|0;i=b;return k|0}function Lmg(d,e,f,j,k){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0;d=i;i=i+128|0;l=d+110|0;m=d+108|0;n=d+111|0;o=d+112|0;p=d+104|0;q=d+106|0;r=d+96|0;s=d+100|0;t=d+48|0;u=d+40|0;v=d+56|0;w=d;x=d+64|0;y=d+80|0;z=d+8|0;A=d+24|0;Ioh();B=(f|0)!=0;if(!e){if(!B){C=0;i=d;return C|0}if(Gqh(2650144,f)|0){RI(3084488)|0;D=qL(3084488)|0;lsg(D,c[900700]|0);pwh(D)}else{C=0;i=d;return C|0}}if(!B){RI(3084488)|0;B=qL(3084488)|0;lsg(B,c[900702]|0);pwh(B)}if((Xnf(e)|0)==(f|0)){C=e;i=d;return C|0}RI(2545096)|0;do if(vL(e,2545096)|0){RI(2545096)|0;B=swh(e,2545096)|0;RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;if((c[(c[(c[758595]|0)+4>>2]|0)+16>>2]|0)==(f|0)){RI(2963920)|0;D=qL(2963920)|0;Ucg(D);pwh(D)}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+(c[(c[D>>2]|0)+120>>2]|0)>>2]|0)==(f|0)){C=e;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+(c[(c[D>>2]|0)+120>>2]<<1)>>2]|0)==(f|0)){RI(3084488)|0;D=qL(3084488)|0;lsg(D,c[900704]|0);pwh(D)}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*3|0)>>2]|0)==(f|0)){a[l>>0]=(gwh(2545280,B,j)|0)&1;RI(2601984)|0;C=pL(2601984,l)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+(c[(c[D>>2]|0)+120>>2]<<2)>>2]|0)==(f|0)){b[m>>1]=Kwh(2545424,B,j)|0;RI(2540392)|0;C=pL(2540392,m)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*5|0)>>2]|0)==(f|0)){a[n>>0]=Qwh(2545928,B,j)|0;RI(2560032)|0;C=pL(2560032,n)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*6|0)>>2]|0)==(f|0)){a[o>>0]=Jwh(2545352,B,j)|0;RI(2557392)|0;C=pL(2557392,o)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*7|0)>>2]|0)==(f|0)){b[p>>1]=Owh(2545712,B,j)|0;RI(2562664)|0;C=pL(2562664,p)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+(c[(c[D>>2]|0)+120>>2]<<3)>>2]|0)==(f|0)){b[q>>1]=Kwh(2546224,B,j)|0;RI(2565248)|0;C=pL(2565248,q)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*9|0)>>2]|0)==(f|0)){c[r>>2]=Zqh(2545784,B,j)|0;RI(2540224)|0;C=pL(2540224,r)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*10|0)>>2]|0)==(f|0)){c[s>>2]=Swh(2546296,B,j)|0;RI(2551640)|0;C=pL(2551640,s)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*11|0)>>2]|0)==(f|0)){D=Pwh(2545856,B,j)|0;E=t;c[E>>2]=D;c[E+4>>2]=H;RI(2548816)|0;C=pL(2548816,t)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;E=c[(c[758595]|0)+4>>2]|0;if((c[E+16+((c[(c[E>>2]|0)+120>>2]|0)*12|0)>>2]|0)==(f|0)){E=Twh(2546368,B,j)|0;D=u;c[D>>2]=E;c[D+4>>2]=H;RI(2554736)|0;C=pL(2554736,u)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*13|0)>>2]|0)==(f|0)){g[v>>2]=ea(Rwh(2546e3,B,j));RI(2586184)|0;C=pL(2586184,v)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*14|0)>>2]|0)==(f|0)){h[w>>3]=+Nwh(2545640,B,j);RI(2589144)|0;C=pL(2589144,w)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*15|0)>>2]|0)==(f|0)){Mwh(x,2545568,B,j);c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];c[y+12>>2]=c[x+12>>2];RI(2592872)|0;C=pL(2592872,y)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+(c[(c[D>>2]|0)+120>>2]<<4)>>2]|0)==(f|0)){Lwh(z,2545496,B,j);c[A+0>>2]=c[z+0>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];c[A+12>>2]=c[z+12>>2];RI(3034456)|0;C=pL(3034456,A)|0;i=d;return C|0}RI(3034288)|0;if(!(a[3034436]|0)){RI(3034288)|0;rwh(3034288)}RI(3034288)|0;D=c[(c[758595]|0)+4>>2]|0;if((c[D+16+((c[(c[D>>2]|0)+120>>2]|0)*18|0)>>2]|0)==(f|0)){C=Uwh(2546072,B,j)|0;i=d;return C|0}if(!k)break;C=Vwh(2546152,B,f,j)|0;i=d;return C|0}while(0);C=Fqh(2536192,Xnf(e)|0)|0;e=Fqh(2537592,f)|0;if(a[2540708]|0){F=c[900706]|0;G=c[900708]|0;I=jwf(0,F,C,G,e)|0;J=tof(0,I)|0;RI(3084488)|0;K=qL(3084488)|0;lsg(K,J);pwh(K)}rwh(2540560);F=c[900706]|0;G=c[900708]|0;I=jwf(0,F,C,G,e)|0;J=tof(0,I)|0;RI(3084488)|0;K=qL(3084488)|0;lsg(K,J);pwh(K);return 0}function Mmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Nmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Omg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Pmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Qmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Rmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Smg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Tmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Umg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Vmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Wmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Xmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ymg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Zmg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function _mg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function $mg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function ang(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function bng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function cng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function dng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function eng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function fng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function gng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function hng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function ing(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function jng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function kng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function lng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function mng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function nng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function ong(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function png(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function qng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function rng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function sng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function tng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function ung(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function vng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function wng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function xng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function yng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function zng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ang(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Bng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Cng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Dng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Eng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Fng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Gng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Hng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ing(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Jng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Kng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Lng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Mng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Nng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ong(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Png(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Qng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Rng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Sng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Tng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Ung(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Vng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Wng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Xng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Yng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Zng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function _ng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function $ng(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function aog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function bog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function cog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function dog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function eog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function fog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function gog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function hog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function iog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function jog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function kog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function log(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function mog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function nog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function oog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function pog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function qog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function rog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function sog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function tog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function uog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function vog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function wog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function xog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function yog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function zog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Aog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539808)|0;yof(a,0);c[c[d>>2]>>2]=a;i=b;return}function Bog(a){a=a|0;return}function Cog(a){a=a|0;var b=0;a=i;RI(3034120)|0;b=qL(3034120)|0;RI(3034120)|0;c[c[758553]>>2]=b;i=a;return}function Dog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Eog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Fog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Gog(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);pwh(c)}function Hog(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);pwh(c)}function Iog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return +(0.0)}function Jog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Kog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Log(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Mog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Nog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return ea(0.0)}function Oog(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[g>>2]=3431728;c[f+0>>2]=c[g+0>>2];if((npf(0,f)|0)==(d|0)){if(!(a[2540708]|0))rwh(2540560);j=c[c[635163]>>2]|0;i=e;return j|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[h>>2]=3451464;c[f+0>>2]=c[h+0>>2];if((npf(0,f)|0)!=(d|0)){RI(3084488)|0;d=qL(3084488)|0;ksg(d);pwh(d)}j=b;i=e;return j|0}function Pog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Qog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Rog(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function Sog(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];hyg(0,a,b,f);i=e;return}function Tog(b){b=b|0;b=i;if(!(a[2540708]|0))rwh(2540560);i=b;return c[c[635163]>>2]|0}function Uog(b,d){b=b|0;d=d|0;d=i;if(!(a[2540708]|0))rwh(2540560);i=d;return c[c[635163]>>2]|0}function Vog(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Wog(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+96|0;g=f+8|0;h=f+48|0;j=f+24|0;k=f+64|0;l=f+88|0;m=f;n=f+40|0;o=f+80|0;c[g+0>>2]=c[781288];c[g+4>>2]=c[781289];c[g+8>>2]=c[781290];c[g+12>>2]=c[781291];c[h+0>>2]=c[781288];c[h+4>>2]=c[781289];c[h+8>>2]=c[781290];c[h+12>>2]=c[781291];c[j+0>>2]=c[781288];c[j+4>>2]=c[781289];c[j+8>>2]=c[781290];c[j+12>>2]=c[781291];c[k+0>>2]=c[781288];c[k+4>>2]=c[781289];c[k+8>>2]=c[781290];c[k+12>>2]=c[781291];Joh();p=l;c[p>>2]=0;c[p+4>>2]=0;$wg(l,d,e);p=l;l=c[p+4>>2]|0;q=b;c[q>>2]=c[p>>2];c[q+4>>2]=l;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;l=(c[758637]|0)+16|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];l=jxg(g)|0;g=H;if(!((g|0)>(e|0)|(g|0)==(e|0)&l>>>0>d>>>0)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;l=c[758637]|0;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];l=jxg(h)|0;h=H;if(!((h|0)<(e|0)|(h|0)==(e|0)&l>>>0<d>>>0)){c[b+8>>2]=0;i=f;return}}RI(1086352)|0;f=twh(1086352,3)|0;b=m;c[b>>2]=d;c[b+4>>2]=e;RI(2548816)|0;e=pL(2548816,m)|0;Qqh(f,e);m=f+16|0;c[m>>2]=e;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;e=(c[758637]|0)+16|0;c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];e=jxg(j)|0;j=n;c[j>>2]=e;c[j+4>>2]=H;RI(2548816)|0;j=pL(2548816,n)|0;Qqh(f,j);c[m+(c[(c[f>>2]|0)+120>>2]|0)>>2]=j;RI(3034456)|0;j=c[758637]|0;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];j=jxg(k)|0;k=o;c[k>>2]=j;c[k+4>>2]=H;RI(2548816)|0;k=pL(2548816,o)|0;Qqh(f,k);c[m+(c[(c[f>>2]|0)+120>>2]<<1)>>2]=k;k=Uxf(0,c[900796]|0,f)|0;RI(2964880)|0;f=qL(2964880)|0;Qag(f,c[900798]|0,k);pwh(f)}function Xog(a){a=a|0;var b=0,c=0;b=i;c=jxg(a)|0;i=b;return c|0}function Yog(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Zog(a,b,c,d,0,0,0,0);i=e;return}function Zog(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=i;i=i+16|0;m=l;Koh();if((d+-1|0)>>>0>9998|(e|0)<1|(e|0)>12|(f|0)<1){RI(2964880)|0;n=qL(2964880)|0;o=c[900830]|0;wdg(n,o);pwh(n)}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!((k|0)<1e3&(((_og(0,d,e)|0)<(f|0)|(g|0)<0|(g|0)>23|(h|0)<0|(h|0)>59|(j|0)<0|(j|0)>59|(k|0)<0)^1))){RI(2964880)|0;n=qL(2964880)|0;o=c[900830]|0;wdg(n,o);pwh(n)}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}n=$og(0,d,e,f)|0;f=m;c[f>>2]=0;c[f+4>>2]=0;cxg(m,n,g,h,j,k);k=m;m=c[k+4>>2]|0;j=b;c[j>>2]=c[k>>2];c[j+4>>2]=m;c[b+8>>2]=0;i=l;return}function _og(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;if((e+-1|0)>>>0>=12){RI(2964880)|0;f=qL(2964880)|0;_eg(f);pwh(f)}if((d+-1|0)>>>0>=9999){RI(2964880)|0;f=qL(2964880)|0;_eg(f);pwh(f)}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}f=upg(0,d)|0;RI(3034456)|0;d=(a[3034604]|0)!=0;if(f){if(!d){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;g=(c[758637]|0)+64|0;h=c[g>>2]|0;j=c[h>>2]|0;k=h+16|0;l=j+120|0;m=c[l>>2]|0;n=da(m,e)|0;o=k+n|0;p=c[o>>2]|0;i=b;return p|0}else{if(!d){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;g=(c[758637]|0)+60|0;h=c[g>>2]|0;j=c[h>>2]|0;k=h+16|0;l=j+120|0;m=c[l>>2]|0;n=da(m,e)|0;o=k+n|0;p=c[o>>2]|0;i=b;return p|0}return 0}function $og(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}g=upg(0,d)|0;RI(3034456)|0;h=(a[3034604]|0)!=0;if(g){if(!h){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;j=(c[758637]|0)+64|0}else{if(!h){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;j=(c[758637]|0)+60|0}h=c[j>>2]|0;if((e|0)>1){j=h+16|0;g=c[(c[h>>2]|0)+120>>2]|0;h=0;k=1;while(1){l=(c[j+(da(g,k)|0)>>2]|0)+h|0;k=k+1|0;if((k|0)==(e|0)){m=l;break}else h=l}}else m=0;h=d+-1|0;i=b;return f+-1+(h*365|0)+m+((h|0)/4|0)+((h|0)/-100|0)+((h|0)/400|0)|0}function apg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+32|0;g=f+16|0;h=f;c[g+0>>2]=c[781288];c[g+4>>2]=c[781289];c[g+8>>2]=c[781290];c[g+12>>2]=c[781291];c[h+0>>2]=c[781288];c[h+4>>2]=c[781289];c[h+8>>2]=c[781290];c[h+12>>2]=c[781291];if(!d){j=e;k=j;l=c[k>>2]|0;m=j+4|0;n=m;o=c[n>>2]|0;p=b;q=p;c[q>>2]=l;r=p+4|0;s=r;c[s>>2]=o;t=b+8|0;c[t>>2]=0;i=f;return}d=jxg(e)|0;u=H;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;v=(c[758637]|0)+16|0;c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];v=jxg(g)|0;g=H;if((u|0)<(g|0)|(u|0)==(g|0)&d>>>0<v>>>0){RI(2964880)|0;w=qL(2964880)|0;_eg(w);pwh(w)}v=jxg(e)|0;d=H;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;g=c[758637]|0;c[h+0>>2]=c[g+0>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[h+12>>2]=c[g+12>>2];g=jxg(h)|0;h=H;if((d|0)>(h|0)|(d|0)==(h|0)&v>>>0>g>>>0){RI(2964880)|0;w=qL(2964880)|0;_eg(w);pwh(w)}else{j=e;k=j;l=c[k>>2]|0;m=j+4|0;n=m;o=c[n>>2]|0;p=b;q=p;c[q>>2]=l;r=p+4|0;s=r;c[s>>2]=o;t=b+8|0;c[t>>2]=0;i=f;return}}function bpg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;Wog(a,b,d);cpg(0,e);c[a+8>>2]=e;i=f;return}function cpg(a,b){a=a|0;b=b|0;a=i;Ooh();if(b>>>0<3){i=a;return}else{RI(2965048)|0;a=qL(2965048)|0;Rag(a,c[901222]|0,c[901224]|0);pwh(a)}}function dpg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+8|0;f=b;g=b+20|0;h=b+16|0;Loh();j=e;c[j>>2]=0;c[j+4>>2]=0;$wg(e,-197705729,734668917);j=e;e=c[j>>2]|0;k=c[j+4>>2]|0;RI(3034456)|0;j=c[758637]|0;l=j;c[l>>2]=e;c[l+4>>2]=k;c[j+8>>2]=0;c[j+12>>2]=0;j=f;c[j>>2]=0;c[j+4>>2]=0;$wg(f,0,0);j=f;f=c[j>>2]|0;k=c[j+4>>2]|0;RI(3034456)|0;j=c[758637]|0;l=j+16|0;c[l>>2]=f;c[l+4>>2]=k;c[j+24>>2]=0;c[j+28>>2]=0;RI(1094176)|0;j=twh(1094176,9)|0;Qqh(j,c[900858]|0);k=j+16|0;c[k>>2]=c[900858];Qqh(j,c[900860]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900860];Qqh(j,c[900862]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900862];Qqh(j,c[900864]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=c[900864];Qqh(j,c[900866]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<2)>>2]=c[900866];Qqh(j,c[900868]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*5|0)>>2]=c[900868];Qqh(j,c[900870]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*6|0)>>2]=c[900870];Qqh(j,c[900872]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*7|0)>>2]=c[900872];Qqh(j,c[900874]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<3)>>2]=c[900874];RI(3034456)|0;c[(c[758637]|0)+32>>2]=j;RI(1094176)|0;j=twh(1094176,10)|0;Qqh(j,c[900876]|0);k=j+16|0;c[k>>2]=c[900876];Qqh(j,c[900878]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900878];Qqh(j,c[900880]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900880];Qqh(j,c[900882]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=c[900882];Qqh(j,c[900884]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<2)>>2]=c[900884];Qqh(j,c[900886]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*5|0)>>2]=c[900886];Qqh(j,c[900888]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*6|0)>>2]=c[900888];Qqh(j,c[900890]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*7|0)>>2]=c[900890];Qqh(j,c[900892]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<3)>>2]=c[900892];Qqh(j,c[900894]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*9|0)>>2]=c[900894];RI(3034456)|0;c[(c[758637]|0)+36>>2]=j;RI(1094176)|0;j=twh(1094176,12)|0;Qqh(j,c[900896]|0);k=j+16|0;c[k>>2]=c[900896];Qqh(j,c[900898]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900898];Qqh(j,c[900900]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900900];Qqh(j,c[900902]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=c[900902];Qqh(j,c[900904]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<2)>>2]=c[900904];Qqh(j,c[900906]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*5|0)>>2]=c[900906];Qqh(j,c[900908]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*6|0)>>2]=c[900908];Qqh(j,c[900910]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*7|0)>>2]=c[900910];Qqh(j,c[900912]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<3)>>2]=c[900912];Qqh(j,c[900914]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*9|0)>>2]=c[900914];Qqh(j,c[900916]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*10|0)>>2]=c[900916];Qqh(j,c[900918]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*11|0)>>2]=c[900918];RI(3034456)|0;c[(c[758637]|0)+40>>2]=j;RI(1094176)|0;j=twh(1094176,15)|0;Qqh(j,c[900920]|0);k=j+16|0;c[k>>2]=c[900920];Qqh(j,c[900922]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900922];Qqh(j,c[900924]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900924];Qqh(j,c[900926]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=c[900926];Qqh(j,c[900928]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<2)>>2]=c[900928];Qqh(j,c[900930]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*5|0)>>2]=c[900930];Qqh(j,c[900932]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*6|0)>>2]=c[900932];Qqh(j,c[900934]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*7|0)>>2]=c[900934];Qqh(j,c[900936]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<3)>>2]=c[900936];Qqh(j,c[900938]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*9|0)>>2]=c[900938];Qqh(j,c[900940]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*10|0)>>2]=c[900940];Qqh(j,c[900942]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*11|0)>>2]=c[900942];Qqh(j,c[900944]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*12|0)>>2]=c[900944];Qqh(j,c[900946]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*13|0)>>2]=c[900946];Qqh(j,c[900948]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*14|0)>>2]=c[900948];RI(3034456)|0;c[(c[758637]|0)+44>>2]=j;RI(1094176)|0;j=twh(1094176,15)|0;Qqh(j,c[900950]|0);k=j+16|0;c[k>>2]=c[900950];Qqh(j,c[900952]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900952];Qqh(j,c[900954]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900954];Qqh(j,c[900956]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*3|0)>>2]=c[900956];Qqh(j,c[900958]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<2)>>2]=c[900958];Qqh(j,c[900960]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*5|0)>>2]=c[900960];Qqh(j,c[900962]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*6|0)>>2]=c[900962];Qqh(j,c[900964]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*7|0)>>2]=c[900964];Qqh(j,c[900966]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<3)>>2]=c[900966];Qqh(j,c[900968]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*9|0)>>2]=c[900968];Qqh(j,c[900970]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*10|0)>>2]=c[900970];Qqh(j,c[900972]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*11|0)>>2]=c[900972];Qqh(j,c[900974]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*12|0)>>2]=c[900974];Qqh(j,c[900976]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*13|0)>>2]=c[900976];Qqh(j,c[900978]|0);c[k+((c[(c[j>>2]|0)+120>>2]|0)*14|0)>>2]=c[900978];RI(3034456)|0;c[(c[758637]|0)+48>>2]=j;RI(1094176)|0;j=twh(1094176,3)|0;Qqh(j,c[900980]|0);k=j+16|0;c[k>>2]=c[900980];Qqh(j,c[900982]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900982];Qqh(j,c[900984]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900984];RI(3034456)|0;c[(c[758637]|0)+52>>2]=j;RI(1094176)|0;j=twh(1094176,3)|0;Qqh(j,c[900986]|0);k=j+16|0;c[k>>2]=c[900986];Qqh(j,c[900988]|0);c[k+(c[(c[j>>2]|0)+120>>2]|0)>>2]=c[900988];Qqh(j,c[900990]|0);c[k+(c[(c[j>>2]|0)+120>>2]<<1)>>2]=c[900990];RI(3034456)|0;c[(c[758637]|0)+56>>2]=j;RI(1101728)|0;j=twh(1101728,13)|0;c[g>>2]=3140480;c[d+0>>2]=c[g+0>>2];Guf(0,j,d);RI(3034456)|0;c[(c[758637]|0)+60>>2]=j;RI(1101728)|0;j=twh(1101728,13)|0;c[h>>2]=3140520;c[d+0>>2]=c[h+0>>2];Guf(0,j,d);RI(3034456)|0;c[(c[758637]|0)+64>>2]=j;RI(3080672)|0;if(!(a[3080820]|0)){RI(3080672)|0;rwh(3080672)}RI(3080672)|0;if(!(a[c[770191]>>0]|0)){i=b;return}RI(1708464)|0;WDe(qL(1708464)|0);RI(1710392)|0;cEe(qL(1710392)|0);i=b;return}function epg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function fpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function gpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function hpg(a,b,d){a=a|0;b=b|0;d=d|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];return}function ipg(a,b,c){a=a|0;b=b|0;c=c|0;RI(3084488)|0;c=qL(3084488)|0;ksg(c);pwh(c)}function jpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return +(0.0)}function kpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function lpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function mpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function npg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function opg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return ea(0.0)}function ppg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+16|0;k=f+36|0;l=f+32|0;m=f;Moh();if(!d){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[901198]|0);pwh(n)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[h>>2]=3432952;c[g+0>>2]=c[h+0>>2];if((npf(0,g)|0)==(d|0)){c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];RI(3034456)|0;o=pL(3034456,j)|0;i=f;return o|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[k>>2]=3431728;c[g+0>>2]=c[k+0>>2];if((npf(0,g)|0)==(d|0)){o=nqg(b,0,e)|0;i=f;return o|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rwh(2540728)}c[l>>2]=3432408;c[g+0>>2]=c[l+0>>2];if((npf(0,g)|0)!=(d|0)){RI(3084488)|0;d=qL(3084488)|0;ksg(d);pwh(d)};c[m+0>>2]=c[b+0>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];RI(3034456)|0;o=pL(3034456,m)|0;i=f;return o|0}function qpg(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nqg(a,0,b)|0;i=c;return d|0}function rpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function spg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function tpg(a,b){a=a|0;b=b|0;RI(3084488)|0;b=qL(3084488)|0;ksg(b);pwh(b);return 0}function upg(a,b){a=a|0;b=b|0;var c=0,d=0;a=i;if((b+-1|0)>>>0>=9999){RI(2964880)|0;c=qL(2964880)|0;_eg(c);pwh(c)}if(!((b&3|0)!=0|((b|0)%100|0|0)==0)){d=1;i=a;return d|0}d=((b|0)%400|0|0)==0;i=a;return d|0}function vpg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;f=c[(c[758637]|0)+60>>2]|0;g=exg(b)|0;b=(g|0)/146097|0;h=(da(b,-146097)|0)+g|0;g=(h+-146096|0)>>>0>36523?(h|0)/36524|0:3;j=(da(g,-36524)|0)+h|0;h=(j|0)/1461|0;k=j+(da(h,-1461)|0)|0;l=(k+-1460|0)>>>0>364?(k|0)/365|0:3;if((d|0)==3){m=(h<<2)+(b*400|0)+(g*100|0)+l|0;n=m+1|0;i=e;return n|0}b=(da(l,-365)|0)+k|0;if((d|0)==1){m=b;n=m+1|0;i=e;return n|0}if((l|0)==3?!((g|0)!=3&(j+-35064|0)>>>0<1461):0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;o=c[(c[758637]|0)+64>>2]|0}else o=f;f=o+16|0;j=c[(c[o>>2]|0)+120>>2]|0;o=c[f+j>>2]|0;if((b|0)<(o|0)){p=1;q=b;r=(d|0)==2;s=q+1|0;t=r?p:s;i=e;return t|0}else{u=o;v=1;w=b}while(1){b=v+1|0;o=w-u|0;u=c[f+(da(j,b)|0)>>2]|0;if((o|0)<(u|0)){p=b;q=o;break}else{v=b;w=o}}r=(d|0)==2;s=q+1|0;t=r?p:s;i=e;return t|0}function wpg(a){a=a|0;var b=0,c=0;b=i;c=vpg(a,2)|0;i=b;return c|0}function xpg(a){a=a|0;var b=0,c=0;b=i;c=vpg(a,0)|0;i=b;return c|0}function ypg(a){a=a|0;var b=0,c=0;b=i;c=((exg(a)|0)+1|0)%7|0;i=b;return c|0}function zpg(a){a=a|0;var b=0,c=0;b=i;c=fxg(a)|0;i=b;return c|0}function Apg(a){a=a|0;var b=0,c=0;b=i;c=hxg(a)|0;i=b;return c|0}function Bpg(a){a=a|0;var b=0,c=0;b=i;c=ixg(a)|0;i=b;return c|0}function Cpg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[763538]|0;if(!b){d=MK(3054160)|0;c[763538]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function Dpg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+80|0;e=d+64|0;f=d+48|0;g=d+32|0;h=d+24|0;j=d+8|0;k=d;c[g+0>>2]=c[781288];c[g+4>>2]=c[781289];c[g+8>>2]=c[781290];c[g+12>>2]=c[781291];c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}l=Cpg(0)|0;m=H;Wog(g,l,m);RI(3034456)|0;n=(c[758637]|0)+72|0;o=ZEi(l|0,m|0,c[n>>2]|0,c[n+4>>2]|0)|0;n=H;if(!((n|0)<0|(n|0)==0&o>>>0<600000001)){RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}o=Mxg(0)|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];n=Rxg(o,e)|0;o=h;c[o>>2]=n;c[o+4>>2]=H;RI(3120120)|0;o=pL(3120120,h)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;c[(c[758637]|0)+68>>2]=o;RI(3034456)|0;o=(c[758637]|0)+72|0;c[o>>2]=l;c[o+4>>2]=m}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];RI(3034456)|0;g=c[(c[758637]|0)+68>>2]|0;RI(3120120)|0;m=Ewh(g,3120120)|0;g=c[m+4>>2]|0;o=k;c[o>>2]=c[m>>2];c[o+4>>2]=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];Epg(b,0,f,e);c[b+8>>2]=2;i=d;return}function Epg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;g=d+32|0;h=d+24|0;j=d+16|0;k=d+8|0;l=d;c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];m=e;n=c[m>>2]|0;o=c[m+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}m=j;c[m>>2]=n;c[m+4>>2]=o;o=f;f=c[o+4>>2]|0;m=k;c[m>>2]=c[o>>2];c[m+4>>2]=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];k=Axg(0,h,g)|0;h=l;c[h>>2]=k;c[h+4>>2]=H;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];apg(b,1,g);c[b+8>>2]=c[e+8>>2];i=d;return}function Fpg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e+0>>2]=c[781288];c[e+4>>2]=c[781289];c[e+8>>2]=c[781290];c[e+12>>2]=c[781291];c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Dpg(e,0);f=vpg(e,3)|0;g=vpg(e,2)|0;Yog(b,f,g,vpg(e,0)|0);c[b+8>>2]=c[e+8>>2];i=d;return}function Gpg(a){a=a|0;var b=0,c=0;b=i;c=vpg(a,3)|0;i=b;return c|0}function Hpg(a){a=a|0;return c[a+8>>2]|0}function Ipg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a+0>>2]=c[781288];c[a+4>>2]=c[781289];c[a+8>>2]=c[781290];c[a+12>>2]=c[781291];f=jxg(d)|0;Jpg(a,b,f,H);c[a+8>>2]=c[b+8>>2];i=e;return}function Jpg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;c[a+0>>2]=c[781288];c[a+4>>2]=c[781289];c[a+8>>2]=c[781290];c[a+12>>2]=c[781291];g=jxg(b)|0;h=_Ei(g|0,H|0,d|0,e|0)|0;g=H;if((g|0)>734668917|(g|0)==734668917&h>>>0>4097261567){RI(2964880)|0;j=qL(2964880)|0;_eg(j);pwh(j)}h=jxg(b)|0;g=_Ei(h|0,H|0,d|0,e|0)|0;h=H;if((h|0)>-1|(h|0)==-1&g>>>0>4294967295){g=jxg(b)|0;h=_Ei(g|0,H|0,d|0,e|0)|0;Wog(a,h,H);c[a+8>>2]=c[b+8>>2];i=f;return}else{RI(2964880)|0;j=qL(2964880)|0;_eg(j);pwh(j)}}function Kpg(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0,f=0;d=i;e=c*1.0e4;if(e>9223372036854775808.0|!(e>=-9223372036854775808.0)){RI(2964880)|0;f=qL(2964880)|0;_eg(f);pwh(f)}else{c=+dEi(e);Jpg(a,b,~~c>>>0,+S(c)>=1.0?(c>0.0?(ha(+R(c/4294967296.0),4294967295.0)|0)>>>0:~~+ca((c-+(~~c>>>0))/4294967296.0)>>>0):0);i=d;return}}function Lpg(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;Kpg(a,b,c*1.0e3);i=d;return}function Mpg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+48|0;f=b+40|0;g=b+32|0;h=b+24|0;j=b+16|0;k=b+8|0;l=b;m=d;d=c[m>>2]|0;n=c[m+4>>2]|0;m=e;e=c[m>>2]|0;o=c[m+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}m=h;c[m>>2]=d;c[m+4>>2]=n;m=j;c[m>>2]=e;c[m+4>>2]=o;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];if(Fxg(0,g,f)|0){p=-1;i=b;return p|0}RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}j=k;c[j>>2]=d;c[j+4>>2]=n;n=l;c[n>>2]=e;c[n+4>>2]=o;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];p=(Cxg(0,g,f)|0)&1;i=b;return p|0}function Npg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;Noh();if(!d){j=1;i=e;return j|0}RI(3034456)|0;if(!(vL(d,3034456)|0)){k=tof(0,c[901202]|0)|0;RI(2965048)|0;l=qL(2965048)|0;Rbg(l,k);pwh(l)}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];RI(3034456)|0;b=Ewh(d,3034456)|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];j=Mpg(0,g,f)|0;i=e;return j|0}function Opg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=Mpg(0,g,f)|0;i=e;return d|0}function Ppg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=b;b=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=b;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Bxg(0,g,f)|0;i=e;return j|0}function Qpg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;f=jxg(d)|0;c[a+0>>2]=c[781288];c[a+4>>2]=c[781289];c[a+8>>2]=c[781290];c[a+12>>2]=c[781291];bpg(a,f,H,e);i=b;return}function Rpg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;RI(3034456)|0;if(!(vL(d,3034456)|0)){k=0;i=e;return k|0}RI(3034456)|0;l=Ewh(d,3034456)|0;d=c[l>>2]|0;m=c[l+4>>2]|0;l=b;b=c[l>>2]|0;n=c[l+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}l=h;c[l>>2]=d;c[l+4>>2]=m;m=j;c[m>>2]=b;c[m+4>>2]=n;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];k=Bxg(0,g,f)|0;i=e;return k|0}function Spg(a){a=a|0;var b=0,c=0;b=i;c=jxg(a)|0;i=b;return c|0}function Tpg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;d=i;i=i+32|0;h=d;j=d+24|0;c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];c[h+0>>2]=c[765690];c[h+4>>2]=c[765691];c[h+8>>2]=c[765692];c[h+12>>2]=c[765693];c[h+16>>2]=c[765694];c[h+20>>2]=c[765695];c[j>>2]=0;Poh();if(!e){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[901244]|0);pwh(k)}c[j>>2]=0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(Upg(0,e,f,g,b,h,1,j)|0){i=d;return}else pwh(c[j>>2]|0)}function Upg(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;l=b+8|0;m=b+19|0;n=b+18|0;o=b+17|0;p=b+16|0;q=b;a[m>>0]=0;a[n>>0]=0;a[o>>0]=0;a[p>>0]=0;Qoh();RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}RI(3120120)|0;r=(c[780053]|0)+16|0;s=c[r+4>>2]|0;t=q;c[t>>2]=c[r>>2];c[t+4>>2]=s;c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];Vpg(h,0,0,l);if((d|0)!=0?(Vof(d)|0)!=0:0){if(!e){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;rwh(2686624)}u=eKf(0)|0}else u=e;RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;rwh(2756056)}e=ISf(0,u)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}u=Wpg(0,e,j,k)|0;if(!u){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;l=(c[758637]|0)+16|0;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];v=0;i=b;return v|0}a[m>>0]=0;l=u+12|0;a:do if((c[l>>2]|0)>0){q=u+16|0;s=0;b:while(1){t=c[q+(da(c[(c[u>>2]|0)+120>>2]|0,s)|0)>>2]|0;a[n>>0]=0;if(!(a[2540708]|0))rwh(2540560);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(Xpg(0,d,t,c[c[635163]>>2]|0,0,g,h,e,f,0,n,m)|0){v=1;w=82;break}c:do if(a[n>>0]|0){r=0;while(1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;if((r|0)>=(c[(c[(c[758637]|0)+32>>2]|0)+12>>2]|0))break c;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;x=c[(c[758637]|0)+32>>2]|0;if(Xpg(0,d,t,c[x+16+(da(c[(c[x>>2]|0)+120>>2]|0,r)|0)>>2]|0,0,g,h,e,f,0,n,m)|0){v=1;w=82;break b}else r=r+1|0}}while(0);s=s+1|0;if((s|0)>=(c[l>>2]|0))break a}if((w|0)==82){i=b;return v|0}}while(0);n=Cvf(bTf(e)|0,100)|0;s=Cvf(bTf(e)|0,77)|0;if(!((n|0)!=-1&(s|0)!=-1)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;q=(c[758637]|0)+16|0;c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];if(!j){v=0;i=b;return v|0}RI(1086352)|0;q=twh(1086352,1)|0;t=bTf(e)|0;Qqh(q,t);c[q+16>>2]=t;t=Uxf(0,c[901250]|0,q)|0;RI(3079480)|0;q=qL(3079480)|0;Hrg(q,t);c[k>>2]=q;v=0;i=b;return v|0}RI(3034456)|0;q=(a[3034604]|0)!=0;if((n|0)<(s|0)){if(!q){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;y=(c[758637]|0)+56|0}else{if(!q){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;y=(c[758637]|0)+52|0}q=c[y>>2]|0;y=q+12|0;s=q+16|0;d:do if((c[y>>2]|0)>0){n=0;while(1){a[o>>0]=0;if(!(a[2540708]|0))rwh(2540560);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}t=c[s+(da(c[(c[q>>2]|0)+120>>2]|0,n)|0)>>2]|0;n=n+1|0;if(Xpg(0,d,t,c[c[635163]>>2]|0,0,g,h,e,f,0,o,m)|0){v=1;break}if((n|0)>=(c[y>>2]|0))break d}i=b;return v|0}while(0);o=u+16|0;n=0;e:while(1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;if((n|0)>=(c[(c[(c[758637]|0)+32>>2]|0)+12>>2]|0)){w=78;break}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;t=c[(c[758637]|0)+32>>2]|0;r=c[t+16+(da(c[(c[t>>2]|0)+120>>2]|0,n)|0)>>2]|0;a[p>>0]=0;if(!(a[2540708]|0))rwh(2540560);if(Xpg(0,d,r,c[c[635163]>>2]|0,0,g,h,e,f,0,p,m)|0){v=1;w=82;break}do if(a[p>>0]|0){if((c[y>>2]|0)>0){t=0;do{RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(Xpg(0,d,r,c[s+(da(c[(c[q>>2]|0)+120>>2]|0,t)|0)>>2]|0,0,g,h,e,f,0,p,m)|0){v=1;w=82;break e}t=t+1|0}while((t|0)<(c[y>>2]|0))}if((c[l>>2]|0)>0)z=0;else break;do{t=c[o+(da(c[(c[u>>2]|0)+120>>2]|0,z)|0)>>2]|0;if((Wof(t,(Vof(t)|0)+-1|0)|0)<<16>>16!=84){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(Xpg(0,d,r,t,0,g,h,e,f,0,p,m)|0){v=1;w=82;break e}}z=z+1|0}while((z|0)<(c[l>>2]|0))}while(0);n=n+1|0}if((w|0)==78){n=kTf(e)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}l=Ypg(0,d,n,e,f,g,0,m,j,k)|0;if(l|j^1){v=l;i=b;return v|0}RI(3079480)|0;l=qL(3079480)|0;Hrg(l,c[901252]|0);c[k>>2]=l;v=0;i=b;return v|0}else if((w|0)==82){i=b;return v|0}}if(j){RI(3079480)|0;j=qL(3079480)|0;Hrg(j,c[901248]|0);c[k>>2]=j}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;j=(c[758637]|0)+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];v=0;i=b;return v|0}function Vpg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=f+40|0;h=f+24|0;j=f+8|0;k=f;c[j+0>>2]=c[781288];c[j+4>>2]=c[781289];c[j+8>>2]=c[781290];c[j+12>>2]=c[781291];Wog(j,b,d);d=e;e=c[d+4>>2]|0;b=k;c[b>>2]=c[d>>2];c[b+4>>2]=e;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];hqg(a,h,g);i=f;return}function Wpg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;Roh();g=Cvf(_Sf(d)|0,100)|0;h=Cvf(_Sf(d)|0,77)|0;j=Cvf(_Sf(d)|0,121)|0;if(!((h|0)!=-1&(g|0)!=-1&(j|0)!=-1)){if(!e){k=0;i=b;return k|0}RI(1086352)|0;l=twh(1086352,1)|0;m=_Sf(d)|0;Qqh(l,m);c[l+16>>2]=m;m=Uxf(0,c[901304]|0,l)|0;RI(3079480)|0;l=qL(3079480)|0;Hrg(l,m);c[f>>2]=l;k=0;i=b;return k|0}if((j|0)<(h|0)){if((h|0)<(g|0)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;k=c[(c[758637]|0)+40>>2]|0;i=b;return k|0}if((j|0)<(g|0)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;k=c[(c[758637]|0)+36>>2]|0;i=b;return k|0}else{if(!e){k=0;i=b;return k|0}RI(1086352)|0;l=twh(1086352,1)|0;m=_Sf(d)|0;Qqh(l,m);c[l+16>>2]=m;m=Uxf(0,c[901306]|0,l)|0;RI(3079480)|0;l=qL(3079480)|0;Hrg(l,m);c[f>>2]=l;k=0;i=b;return k|0}}else{if((g|0)<(h|0)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;k=c[(c[758637]|0)+44>>2]|0;i=b;return k|0}if((g|0)<(j|0)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;k=c[(c[758637]|0)+48>>2]|0;i=b;return k|0}else{if(!e){k=0;i=b;return k|0}RI(1086352)|0;e=twh(1086352,1)|0;j=_Sf(d)|0;Qqh(e,j);c[e+16>>2]=j;j=Uxf(0,c[901308]|0,e)|0;RI(3079480)|0;e=qL(3079480)|0;Hrg(e,j);c[f>>2]=e;k=0;i=b;return k|0}}return 0}function Xpg(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0;m=i;i=i+320|0;b=m+144|0;p=m+16|0;q=m+308|0;r=m+309|0;s=m+296|0;t=m+300|0;u=m+304|0;v=m+176|0;w=m+208|0;x=m+240|0;y=m+264|0;z=m+128|0;A=m+136|0;B=m+280|0;C=m+32|0;D=m;E=m+72|0;F=m+88|0;G=m+192|0;I=m+48|0;J=m+104|0;K=m+256|0;L=m+64|0;M=m+56|0;N=m+224|0;O=m+112|0;P=m+160|0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v+0>>2]=c[781288];c[v+4>>2]=c[781289];c[v+8>>2]=c[781290];c[v+12>>2]=c[781291];c[w+0>>2]=c[781288];c[w+4>>2]=c[781289];c[w+8>>2]=c[781290];c[w+12>>2]=c[781291];c[x+0>>2]=c[781288];c[x+4>>2]=c[781289];c[x+8>>2]=c[781290];c[x+12>>2]=c[781291];c[y+0>>2]=c[781288];c[y+4>>2]=c[781289];c[y+8>>2]=c[781290];c[y+12>>2]=c[781291];Q=z;c[Q>>2]=0;c[Q+4>>2]=0;Toh();a[q>>0]=0;a[r>>0]=0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}RI(3120120)|0;Q=(c[780053]|0)+16|0;R=c[Q+4>>2]|0;S=A;c[S>>2]=c[Q>>2];c[S+4>>2]=R;c[b+0>>2]=c[A+0>>2];c[b+4>>2]=c[A+4>>2];Vpg(j,0,0,b);A=(f|0)!=0;R=g^1;S=A&R;a[n>>0]=0;RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;rwh(2756056)}Q=ySf(0)|0;if((Vof(e)|0)==1)T=Gqg(0,Wof(e,0)|0,k,q,r,0)|0;else T=e;Wog(h,0,0);if((T|0)==0|(d|0)==0){V=0;i=m;return V|0}if(!(l&1)){W=d;X=T}else{Y=lvf(T,0)|0;W=lvf(d,0)|0;X=Y}if(!(l&2)){Z=W;_=X}else{Y=nvf(X,0)|0;Z=nvf(W,0)|0;_=Y}Y=(a[r>>0]|0)==0?k:Q;k=(l&4|0)!=0;r=Vof(_)|0;if(!r){V=0;i=m;return V|0}c[s>>2]=-1;a:do if(Vof(Z)|0){W=k|R;X=g?4:3;d=S|g;T=g|A^1;$=0;aa=0;ba=-1;ca=-1;da=-1;ea=-1;fa=-1;ga=-1;ha=-1;ia=-1.0;ja=-1;ka=-1;la=-1;ma=1;na=0;oa=_;pa=0;qa=_;ra=r;b:while(1){c[t>>2]=0;c:do if(S&($|0)==(0-aa|0)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sa=bqg(0,Z,na)|0;do if(sa){if((Wof(Z,na)|0)<<16>>16!=90){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}$pg(0,Z,na,0,c[901406]|0,t)|0;ta=c[t>>2]|0;if((ta|0)<1)break;else ua=ta}else{c[t>>2]=1;ua=1}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}ta=ua+na|0;if(!(bqg(0,Z,ta)|0)){a[q>>0]=1;va=$;wa=aa;xa=ba;ya=ca;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=ta;Ka=oa;La=pa;Ma=qa;Na=ra;break c}}while(0);do if(!pa){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}do if(aqg(0,Z,na,0,Y,g,t,s)|0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}ta=c[t>>2]|0;Oa=ta+na|0;if(!(bqg(0,Z,Oa)|0))if((ta|0)<1)break;else{va=$;wa=aa;xa=ba;ya=ca;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=Oa;Ka=oa;La=0;Ma=qa;Na=ra;break c}else{c[s>>2]=-1;break}}while(0);if(!((ca|0)!=-1|sa^1)){Oa=TSf(Y)|0;ta=TSf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Pa=_pg(0,Z,na,Oa,ta,g,t)|0;if((Pa|0)==-1){ta=RSf(Y)|0;Oa=RSf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Qa=_pg(0,Z,na,ta,Oa,g,t)|0;if((Qa|0)==-1){Ra=-1;break}else Sa=Qa}else Sa=Pa;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Pa=(c[t>>2]|0)+na|0;if(bqg(0,Z,Pa)|0)Ra=-1;else{va=$;wa=aa;xa=ba;ya=Sa;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=Pa;Ka=oa;La=0;Ma=qa;Na=ra;break c}}else Ra=ca}else Ra=ca;while(0);sa=Wof(Z,na)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(Xof(0,sa)|0)?(Wof(Z,na)|0)<<16>>16!=44:0){c[t>>2]=0;Ta=Ra;Ua=54;break}va=$;wa=aa;xa=ba;ya=Ra;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=na+1|0;Ka=oa;La=pa;Ma=qa;Na=ra}else{Ta=ca;Ua=54}while(0);d:do if((Ua|0)==54){Ua=0;sa=$+aa|0;if((sa|0)>=(ra|0)){if((aa|0)!=0|T){Va=$;Wa=ba;Xa=Ta;Ya=da;Za=ea;_a=fa;$a=ga;ab=ha;bb=ia;cb=ja;db=ka;eb=la;fb=na;gb=qa;hb=ra;break a}if(ma){ib=(Wof(e,(Vof(e)|0)+-1|0)|0)<<16>>16==84;jb=f}else{if(!(a[2540708]|0))rwh(2540560);if(gpf(0,oa,c[c[635163]>>2]|0)|0){Va=$;Wa=ba;Xa=Ta;Ya=da;Za=ea;_a=fa;$a=ga;ab=ha;bb=ia;cb=ja;db=ka;eb=la;fb=na;gb=qa;hb=ra;break a}if(!(a[2540708]|0))rwh(2540560);ib=0;jb=c[c[635163]>>2]|0}va=0;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=0;Ja=na;Ka=jb;La=ib;Ma=jb;Na=Vof(jb)|0;break}if((Wof(qa,$)|0)<<16>>16==39){Pa=$+1|0;e:do if((Pa|0)<(ra|0)){Qa=Pa;Oa=1;ta=na;while(1){if((Wof(qa,Qa)|0)<<16>>16==39){kb=Oa;lb=ta;break e}if((ta|0)==(Vof(Z)|0)){V=0;Ua=371;break b}mb=Wof(Z,ta)|0;if(mb<<16>>16!=(Wof(qa,Qa)|0)<<16>>16){V=0;Ua=371;break b}mb=ta+1|0;nb=Oa+1|0;Qa=nb+$|0;if((Qa|0)>=(ra|0)){kb=nb;lb=mb;break}else{Oa=nb;ta=mb}}}else{kb=1;lb=na}while(0);va=Pa+kb|0;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=lb;Ka=oa;La=pa;Ma=qa;Na=ra;break}if((Wof(qa,$)|0)<<16>>16==34){ta=$+1|0;f:do if((ta|0)<(ra|0)){Oa=ta;Qa=1;mb=na;while(1){if((Wof(qa,Oa)|0)<<16>>16==34){ob=Qa;pb=mb;break f}if((mb|0)==(Vof(Z)|0)){V=0;Ua=371;break b}nb=Wof(Z,mb)|0;if(nb<<16>>16!=(Wof(qa,Oa)|0)<<16>>16){V=0;Ua=371;break b}nb=mb+1|0;qb=Qa+1|0;Oa=qb+$|0;if((Oa|0)>=(ra|0)){ob=qb;pb=nb;break}else{Qa=qb;mb=nb}}}else{ob=1;pb=na}while(0);va=ta+ob|0;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=pb;Ka=oa;La=pa;Ma=qa;Na=ra;break}if((Wof(qa,$)|0)<<16>>16==92){Pa=aa+1+$|0;if((Pa|0)>=(ra|0)){V=0;Ua=371;break b}mb=Wof(Z,na)|0;if(mb<<16>>16!=(Wof(qa,Pa)|0)<<16>>16){V=0;Ua=371;break b}va=Pa+1|0;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=na+1|0;Ka=oa;La=pa;Ma=qa;Na=ra;break}if((Wof(qa,$)|0)<<16>>16==37){va=$+1|0;wa=aa;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=na;Ka=oa;La=pa;Ma=qa;Na=ra;break}Pa=Wof(Z,na)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}g:do if(Xof(0,Pa)|0)Ua=96;else{if((Wof(Z,na)|0)<<16>>16==44){do if(!g){if((Wof(qa,$)|0)<<16>>16!=47)break;rb=na+1|0;break g}while(0);mb=Wof(qa,$)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(Xof(0,mb)|0){Ua=96;break}}mb=sa+1|0;do if((mb|0)<(ra|0)){Qa=Wof(qa,mb)|0;if(Qa<<16>>16!=(Wof(qa,sa)|0)<<16>>16)break;va=$;wa=aa+1|0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=na;Ka=oa;La=pa;Ma=qa;Na=ra;break d}while(0);mb=Wof(qa,$)|0;Qa=mb&65535;h:do switch(Qa+65466&65535|0){case 1:{if((Wof(Z,na)|0)<<16>>16!=71){V=0;Ua=371;break b}Oa=$+2|0;do if((Oa|0)<(ra|0)){nb=na+2|0;if((nb|0)>=(Vof(Z)|0))break;if((Wof(qa,$+1|0)|0)<<16>>16!=77)break;if((Wof(Z,na+1|0)|0)<<16>>16!=77)break;if((Wof(qa,Oa)|0)<<16>>16!=84)break;if((Wof(Z,nb)|0)<<16>>16!=84)break;a[q>>0]=1;c[t>>2]=3;sb=2;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}while(0);c[t>>2]=1;sb=0;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break}case 5:{if((Wof(Z,na)|0)<<16>>16==90){a[q>>0]=1;sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na+1|0;break h}if((Wof(Z,na)|0)<<16>>16!=43?(Wof(Z,na)|0)<<16>>16!=45:0){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}if((ja|0)!=-1){V=0;Ua=371;break b}if((Wof(Z,na)|0)<<16>>16==43)Fb=0;else{Oa=(Wof(Z,na)|0)<<16>>16==45;Fb=Oa?1:-1}Oa=na+1|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}nb=Zpg(0,Z,Oa,0,2,1,k,t)|0;qb=c[t>>2]|0;Gb=qb+Oa|0;if((qb|0)<=-1){V=0;Ua=371;break b}qb=Wof(Z,Gb)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(jpf(0,qb)|0){c[t>>2]=0;Hb=0}else{qb=YSf(Y)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!($pg(0,Z,Gb,0,qb,t)|0)){V=0;Ua=371;break b}Hb=c[t>>2]|0}qb=Hb+Gb|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Gb=Zpg(0,Z,qb,0,2,1,k,t)|0;if((c[t>>2]|0)>-1){sb=2;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=Fb;Cb=nb;Db=Gb;Eb=qb}else{V=0;Ua=371;break b}break}case 2:{if((fa|0)!=-1){V=0;Ua=371;break b}if(!(S|(c[s>>2]|0)<0)){V=0;Ua=371;break b}RI(3034456)|0;qb=(a[3034604]|0)!=0;if(!aa){if(!qb){RI(3034456)|0;rwh(3034456)}Ib=Zpg(0,Z,na,1,2,0,k,t)|0}else{if(!qb){RI(3034456)|0;rwh(3034456)}Ib=Zpg(0,Z,na,1,2,1,k,t)|0}if((Ib|0)<24){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=Ib;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na}else{V=0;Ua=371;break b}break}case 0:{Jb=0;Ua=224;break}case 7:{if((da|0)!=-1){V=0;Ua=371;break b}if(S){c[t>>2]=-1;if((aa|0)==0|(aa|0)==3){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}qb=Zpg(0,Z,na,1,2,0,k,t)|0;Kb=c[t>>2]|0;Lb=qb}else{Kb=-1;Lb=-1}qb=(aa|0)<2;if(qb|(Kb|0)!=-1){Mb=Kb;Nb=Lb}else{Gb=USf(Y)|0;nb=USf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Oa=(_pg(0,Z,na,Gb,nb,g,t)|0)+1|0;Mb=c[t>>2]|0;Nb=Oa}if(qb|(Mb|0)!=-1){sb=aa;tb=ba;ub=Ta;vb=Nb;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}qb=SSf(Y)|0;Oa=SSf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=aa;tb=ba;ub=Ta;vb=(_pg(0,Z,na,qb,Oa,g,t)|0)+1|0;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}if(!aa){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=0;tb=ba;ub=Ta;vb=Zpg(0,Z,na,1,2,0,k,t)|0;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else if((aa|0)==1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=1;tb=ba;ub=Ta;vb=Zpg(0,Z,na,1,2,1,k,t)|0;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else if((aa|0)==2){Oa=SSf(Y)|0;qb=SSf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=2;tb=ba;ub=Ta;vb=(_pg(0,Z,na,Oa,qb,g,t)|0)+1|0;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{qb=USf(Y)|0;Oa=USf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=aa;tb=ba;ub=Ta;vb=(_pg(0,Z,na,qb,Oa,g,t)|0)+1|0;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}break}default:{Oa=Qa+65421&65535;if(!Oa){if((ha|0)!=-1){V=0;Ua=371;break b}RI(3034456)|0;qb=(a[3034604]|0)!=0;if(!aa){if(!qb){RI(3034456)|0;rwh(3034456)}Ob=Zpg(0,Z,na,1,2,0,k,t)|0}else{if(!qb){RI(3034456)|0;rwh(3034456)}Ob=Zpg(0,Z,na,1,2,1,k,t)|0}if((Ob|0)<60){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=Ob;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{V=0;Ua=371;break b}}else if((Oa|0)==1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(aqg(0,Z,na,(aa|0)<1&1,Y,g,t,s)|0){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{V=0;Ua=371;break b}}else if((Oa|0)==7){if((ja|0)!=-1){V=0;Ua=371;break b}if((Wof(Z,na)|0)<<16>>16!=43)if((Wof(Z,na)|0)<<16>>16==45)Pb=1;else{V=0;Ua=371;break b}else Pb=0;qb=na+1|0;if(!aa){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=0;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=Pb;Cb=Zpg(0,Z,qb,1,2,0,k,t)|0;Db=la;Eb=qb;break h}RI(3034456)|0;nb=(a[3034604]|0)!=0;if((aa|0)==1){if(!nb){RI(3034456)|0;rwh(3034456)}sb=1;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=Pb;Cb=Zpg(0,Z,qb,1,2,1,k,t)|0;Db=la;Eb=qb;break h}if(!nb){RI(3034456)|0;rwh(3034456)}nb=Zpg(0,Z,qb,1,2,1,1,t)|0;Gb=c[t>>2]|0;Qb=Gb+qb|0;if((Gb|0)<=-1){V=0;Ua=371;break b}c[t>>2]=0;if((Qb|0)<(Vof(Z)|0)){Gb=Wof(Z,Qb)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(jpf(0,Gb)|0)Rb=0;else Ua=250}else Ua=250;do if((Ua|0)==250){Ua=0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(cqg(0,Z,Qb,Y,g,t)|0){Rb=c[t>>2]|0;break}if(!S){V=0;Ua=371;break b}c[t>>2]=0;sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=Pb;Cb=nb;Db=la;Eb=Qb;break h}while(0);Gb=Rb+Qb|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}qb=Zpg(0,Z,Gb,1,2,1,k,t)|0;if((c[t>>2]|0)>-1){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=Pb;Cb=nb;Db=qb;Eb=Gb;break h}else{V=0;Ua=371;break b}}else if((Oa|0)!=6){Gb=Qa+65436&65535;if((Gb|0)==2){Jb=1;Ua=224;break h}else if((Gb|0)==4){if((fa|0)!=-1){V=0;Ua=371;break b}RI(3034456)|0;qb=(a[3034604]|0)!=0;if(!aa){if(!qb){RI(3034456)|0;rwh(3034456)}Sb=Zpg(0,Z,na,1,2,0,k,t)|0}else{if(!qb){RI(3034456)|0;rwh(3034456)}Sb=Zpg(0,Z,na,1,2,1,k,t)|0}if((Sb|0)>=13){V=0;Ua=371;break b}sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=(Sb|0)==12?0:Sb;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else if(!Gb){Gb=(aa|0)<2;if(!(Gb&(ba|0)!=-1^(Gb|(Ta|0)==-1))){V=0;Ua=371;break b}if(!aa){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=0;tb=Zpg(0,Z,na,1,2,0,k,t)|0;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else if((aa|0)==1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=1;tb=Zpg(0,Z,na,1,2,1,k,t)|0;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else if((aa|0)==2){Gb=RSf(Y)|0;qb=RSf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=2;tb=ba;ub=_pg(0,Z,na,Gb,qb,g,t)|0;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{qb=TSf(Y)|0;Gb=TSf(Q)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}sb=aa;tb=ba;ub=_pg(0,Z,na,qb,Gb,g,t)|0;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}}else if(mb<<16>>16==47){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(dqg(0,Z,na,Y,g,t)|0){sb=0;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{V=0;Ua=371;break b}}else if(mb<<16>>16==90){if((Wof(Z,na)|0)<<16>>16!=90){V=0;Ua=371;break b}c[t>>2]=1;a[q>>0]=1;sb=0;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else if(mb<<16>>16==58){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(cqg(0,Z,na,Y,g,t)|0){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{V=0;Ua=371;break b}}else if(mb<<16>>16==109){if((ga|0)!=-1){V=0;Ua=371;break b}RI(3034456)|0;Gb=(a[3034604]|0)!=0;if(!aa){if(!Gb){RI(3034456)|0;rwh(3034456)}Tb=Zpg(0,Z,na,1,2,0,k,t)|0}else{if(!Gb){RI(3034456)|0;rwh(3034456)}Tb=Zpg(0,Z,na,1,2,1,k,t)|0}if((Tb|0)<60){sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=Tb;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}else{V=0;Ua=371;break b}}else{Gb=Wof(Z,na)|0;if(Gb<<16>>16!=(Wof(qa,$)|0)<<16>>16){V=0;Ua=371;break b}c[t>>2]=1;sb=0;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}}else{if((ea|0)!=-1){V=0;Ua=371;break b}do if(!aa){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Ub=0;Vb=Zpg(0,Z,na,1,2,0,k,t)|0;Ua=183}else{RI(3034456)|0;Gb=(a[3034604]|0)==0;if((aa|0)<=2){if(Gb){RI(3034456)|0;rwh(3034456)}Ub=aa;Vb=Zpg(0,Z,na,1,2,1,k,t)|0;Ua=183;break}if(Gb){RI(3034456)|0;rwh(3034456)}Gb=Zpg(0,Z,na,X,4,0,k,t)|0;qb=c[t>>2]|0;if((Gb|0)<1e3|(qb|0)!=4){Wb=qb;Xb=3;Yb=Gb;break}if(a[o>>0]|0){Ub=3;Vb=Gb;Ua=183;break}if((Vof(Z)|0)<=(na+4|0)){Ub=3;Vb=Gb;Ua=183;break}c[u>>2]=0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}a[o>>0]=(Zpg(0,Z,na,5,5,0,k,u)|0)>9999&1;Ub=3;Vb=Gb;Ua=183}while(0);if((Ua|0)==183){Ua=0;Wb=c[t>>2]|0;Xb=Ub;Yb=Vb}if((Wb|0)>2){sb=Xb;tb=ba;ub=Ta;vb=da;wb=Yb;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}sb=Xb;tb=ba;ub=Ta;vb=da;wb=((Yb|0)>29?1900:2e3)+Yb|0;xb=fa;yb=ga;zb=ha;Ab=ia;Bb=ja;Cb=ka;Db=la;Eb=na;break h}}}while(0);if((Ua|0)==224){Ua=0;if(!((aa|0)<7&ia==-1.0)){V=0;Ua=371;break b}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}mb=Zpg(0,Z,na,0,aa+1|0,Jb,k,t)|0;Qa=c[t>>2]|0;if((Qa|0)==-1){V=0;Ua=371;break b}sb=aa;tb=ba;ub=Ta;vb=da;wb=ea;xb=fa;yb=ga;zb=ha;Ab=+(mb|0)/+U(10.0,+(+(Qa|0)));Bb=ja;Cb=ka;Db=la;Eb=na}Qa=c[t>>2]|0;if((Qa|0)<=-1){V=0;Ua=371;break b}mb=Qa+Eb|0;i:do if(d)Zb=mb;else{switch((Wof(qa,$)|0)<<16>>16){case 122:case 115:case 109:case 102:case 70:break;default:{Zb=mb;break i}}if((Vof(Z)|0)<=(mb|0)){Zb=mb;break}if((Wof(Z,mb)|0)<<16>>16!=90){Zb=mb;break}Qa=$+1|0;if((Qa|0)!=(Vof(qa)|0)?(Wof(qa,Qa)|0)<<16>>16==90:0){Zb=mb;break}a[q>>0]=1;Zb=mb+1|0}while(0);va=$+1+sb|0;wa=0;xa=tb;ya=ub;za=vb;Aa=wb;Ba=xb;Ca=yb;Da=zb;Ea=Ab;Fa=Bb;Ga=Cb;Ha=Db;Ia=ma;Ja=Zb;Ka=oa;La=pa;Ma=qa;Na=ra;break d}while(0);do if((Ua|0)==96){Ua=0;sa=na+1|0;if(W){rb=sa;break}Pa=Wof(qa,$)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(Xof(0,Pa)|0)){V=0;Ua=371;break b}va=$+1|0;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=sa;Ka=oa;La=pa;Ma=qa;Na=ra;break d}while(0);j:do if((rb|0)<(Vof(Z)|0)){sa=rb;while(1){Pa=Wof(Z,sa)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(Xof(0,Pa)|0)?(Wof(Z,sa)|0)<<16>>16!=44:0){_b=sa;break j}Pa=sa+1|0;if((Pa|0)<(Vof(Z)|0))sa=Pa;else{_b=Pa;break}}}else _b=rb;while(0);k:do if(($|0)<(Vof(qa)|0)){sa=$;while(1){Pa=Wof(qa,sa)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(Xof(0,Pa)|0)?(Wof(qa,sa)|0)<<16>>16!=44:0){$b=sa;break k}Pa=sa+1|0;if((Pa|0)<(Vof(qa)|0))sa=Pa;else{$b=Pa;break}}}else $b=$;while(0);if(g){va=$b;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=_b;Ka=oa;La=pa;Ma=qa;Na=ra;break}if(($b|0)>=(Vof(qa)|0)){va=$b;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=_b;Ka=oa;La=pa;Ma=qa;Na=ra;break}if((Wof(qa,$b)|0)<<16>>16!=47){va=$b;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=_b;Ka=oa;La=pa;Ma=qa;Na=ra;break}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}va=((dqg(0,Z,_b,Y,0,t)|0)&1^1)+$b|0;wa=0;xa=ba;ya=Ta;za=da;Aa=ea;Ba=fa;Ca=ga;Da=ha;Ea=ia;Fa=ja;Ga=ka;Ha=la;Ia=ma;Ja=_b;Ka=oa;La=pa;Ma=qa;Na=ra}while(0);if((Ja|0)==(Vof(Z)|0)){Va=va;Wa=xa;Xa=ya;Ya=za;Za=Aa;_a=Ba;$a=Ca;ab=Da;bb=Ea;cb=Fa;db=Ga;eb=Ha;fb=Ja;gb=Ma;hb=Na;break a}else{$=va;aa=wa;ba=xa;ca=ya;da=za;ea=Aa;fa=Ba;ga=Ca;ha=Da;ia=Ea;ja=Fa;ka=Ga;la=Ha;ma=Ia;na=Ja;oa=Ka;pa=La;qa=Ma;ra=Na}}if((Ua|0)==371){i=m;return V|0}}else{Va=0;Wa=-1;Xa=-1;Ya=-1;Za=-1;_a=-1;$a=-1;ab=-1;bb=-1.0;cb=-1;db=-1;eb=-1;fb=0;gb=_;hb=r}while(0);r=Va+1|0;l:do if(((r|0)<(hb|0)?(Wof(gb,Va)|0)<<16>>16==46:0)?(Wof(gb,r)|0)<<16>>16==70:0){_=r;while(1){Na=_+1|0;if((Wof(gb,_)|0)<<16>>16!=70){ac=_;break l}if((Na|0)<(hb|0))_=Na;else{ac=Na;break}}}else ac=Va;while(0);m:do if((ac|0)<(hb|0)){Va=ac;while(1){if((Wof(gb,Va)|0)<<16>>16!=75){V=0;break}Va=Va+1|0;if((Va|0)>=(hb|0))break m}i=m;return V|0}while(0);if((Vof(Z)|0)>(fb|0)){if(!fb){V=0;i=m;return V|0}hb=Wof(Z,fb)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(jpf(0,hb)|0){hb=Wof(Z,fb+-1|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(jpf(0,hb)|0){V=0;i=m;return V|0}}hb=Wof(Z,fb)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(ouf(0,hb)|0){hb=Wof(Z,fb+-1|0)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(ouf(0,hb)|0){V=0;i=m;return V|0}}a[n>>0]=1;V=0;i=m;return V|0}n=(_a|0)==-1?0:_a;_a=($a|0)==-1?0:$a;$a=(ab|0)==-1?0:ab;ab=bb!=-1.0;if(!((Wa&Ya|0)!=-1|(Za|0)!=-1))if(!(l&8)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Fpg(B,0);c[v+0>>2]=c[B+0>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];B=vpg(v,0)|0;Fpg(C,0);c[w+0>>2]=c[C+0>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];c[w+12>>2]=c[C+12>>2];C=vpg(w,2)|0;Fpg(D,0);c[x+0>>2]=c[D+0>>2];c[x+4>>2]=c[D+4>>2];c[x+8>>2]=c[D+8>>2];c[x+12>>2]=c[D+12>>2];bc=B;cc=C;dc=vpg(x,3)|0;Ua=336}else{ec=1;fc=1;gc=1}else{bc=Wa;cc=Ya;dc=Za;Ua=336}if((Ua|0)==336){Ua=(bc|0)==-1?1:bc;bc=(cc|0)==-1?1:cc;if((dc|0)==-1)if(!(l&8)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}Fpg(E,0);c[y+0>>2]=c[E+0>>2];c[y+4>>2]=c[E+4>>2];c[y+8>>2]=c[E+8>>2];c[y+12>>2]=c[E+12>>2];ec=Ua;fc=bc;gc=vpg(y,3)|0}else{ec=Ua;fc=bc;gc=1}else{ec=Ua;fc=bc;gc=dc}}dc=c[s>>2]|0;s=(dc|0)!=0|(n|0)!=12?n:0;n=(dc|0)!=1|S&(s|0)>11?s:s+12|0;if((gc+-1|0)>>>0>9998|(fc|0)<1|(fc|0)>12|(ec|0)<1){V=0;i=m;return V|0}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!(($a|0)<60&(((ec|0)>(_og(0,gc,fc)|0)|(n|0)<0|(n|0)>23|(_a|0)<0|(_a|0)>59|($a|0)<0)^1))){V=0;i=m;return V|0}Zog(h,gc,fc,ec,n,_a,$a,0);Kpg(F,h,ab?bb*1.0e3:0.0);c[h+0>>2]=c[F+0>>2];c[h+4>>2]=c[F+4>>2];c[h+8>>2]=c[F+8>>2];c[h+12>>2]=c[F+12>>2];if((Xa|0)!=-1?(Xa|0)!=(ypg(h)|0):0){V=0;i=m;return V|0}Xa=(cb|0)==-1;if(Xa){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[G+0>>2]=c[h+0>>2];c[G+4>>2]=c[h+4>>2];c[G+8>>2]=c[h+8>>2];c[G+12>>2]=c[h+12>>2];RI(3034456)|0;F=(c[758637]|0)+16|0;c[p+0>>2]=c[G+0>>2];c[p+4>>2]=c[G+4>>2];c[p+8>>2]=c[G+8>>2];c[p+12>>2]=c[G+12>>2];c[b+0>>2]=c[F+0>>2];c[b+4>>2]=c[F+4>>2];c[b+8>>2]=c[F+8>>2];c[b+12>>2]=c[F+12>>2];if(fqg(0,p,b)|0){c[b+0>>2]=c[h+0>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];gqg(j,b)}}else{F=(eb|0)==-1?0:eb;eb=(db|0)==-1?0:db;if((cb|0)==1){hc=0-eb|0;ic=0-F|0}else{hc=eb;ic=F}F=I;c[F>>2]=0;c[F+4>>2]=0;axg(I,hc,ic,0);ic=I;I=c[ic+4>>2]|0;hc=J;c[hc>>2]=c[ic>>2];c[hc+4>>2]=I;c[p+0>>2]=c[h+0>>2];c[p+4>>2]=c[h+4>>2];c[p+8>>2]=c[h+8>>2];c[p+12>>2]=c[h+12>>2];c[b+0>>2]=c[J+0>>2];c[b+4>>2]=c[J+4>>2];hqg(j,p,b)}J=(l&16|0)!=0;do if(Xa){if(!((a[q>>0]|0)==0&(l&64|0)==0)){c[h+8>>2]=1;break}if(!(l&32))break;c[h+8>>2]=2}else{I=h;hc=c[I>>2]|0;ic=c[I+4>>2]|0;I=j+16|0;F=c[I>>2]|0;eb=c[I+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}I=K;c[I>>2]=hc;c[I+4>>2]=ic;ic=L;c[ic>>2]=F;c[ic+4>>2]=eb;c[p+0>>2]=c[K+0>>2];c[p+4>>2]=c[K+4>>2];c[b+0>>2]=c[L+0>>2];c[b+4>>2]=c[L+4>>2];eb=Hxg(0,p,b)|0;ic=z;c[ic>>2]=eb;c[ic+4>>2]=H;ic=jxg(z)|0;eb=H;F=(eb|0)>-1|(eb|0)==-1&ic>>>0>4294967295;I=_Ei(ic|0,eb|0,711573504,201)|0;hc=M;c[hc>>2]=0;c[hc+4>>2]=0;$wg(M,F?ic:I,F?eb:H);eb=M;F=c[eb+4>>2]|0;I=h;c[I>>2]=c[eb>>2];c[I+4>>2]=F;c[h+8>>2]=1;if(!(l&128))break;jqg(N,h);c[h+0>>2]=c[N+0>>2];c[h+4>>2]=c[N+4>>2];c[h+8>>2]=c[N+8>>2];c[h+12>>2]=c[N+12>>2]}while(0);if(J)jc=0;else jc=(l&128|0)==0;if(!(c[h+8>>2]|0)){V=1;i=m;return V|0}if(J){kqg(O,h);c[h+0>>2]=c[O+0>>2];c[h+4>>2]=c[O+4>>2];c[h+8>>2]=c[O+8>>2];c[h+12>>2]=c[O+12>>2];V=1;i=m;return V|0}if(!jc){V=1;i=m;return V|0}jqg(P,h);c[h+0>>2]=c[P+0>>2];c[h+4>>2]=c[P+4>>2];c[h+8>>2]=c[P+8>>2];c[h+12>>2]=c[P+12>>2];V=1;i=m;return V|0}function Ypg(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+48|0;n=b+40|0;o=b+24|0;p=b;c[o+0>>2]=c[781288];c[o+4>>2]=c[781289];c[o+8>>2]=c[781290];c[o+12>>2]=c[781291];c[p+0>>2]=c[765690];c[p+4>>2]=c[765691];c[p+8>>2]=c[765692];c[p+12>>2]=c[765693];c[p+16>>2]=c[765694];c[p+20>>2]=c[765695];Uoh();a[n>>0]=0;q=e+12|0;a:do if((c[q>>2]|0)>0){r=e+16|0;s=0;while(1){t=c[r+(da(c[(c[e>>2]|0)+120>>2]|0,s)|0)>>2]|0;if(!t)break a;if(!(a[2540708]|0))rwh(2540560);if(gpf(0,t,c[c[635163]>>2]|0)|0)break a;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(Xpg(0,d,c[r+(da(c[(c[e>>2]|0)+120>>2]|0,s)|0)>>2]|0,0,j,o,p,f,g,0,n,k)|0)break;s=s+1|0;if((s|0)>=(c[q>>2]|0))break a}c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];u=1;i=b;return u|0}while(0);if(l){RI(3079480)|0;l=qL(3079480)|0;Hrg(l,c[901412]|0);c[m>>2]=l}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;l=(c[758637]|0)+16|0;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];u=0;i=b;return u|0}function Zpg(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;a:do if(!((j^1)&h)){l=g+e|0;if((Vof(d)|0)>(e|0)&(g|0)>0){m=e;n=0;while(1){o=Wof(d,m)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(jpf(0,o)|0)){p=n;break a}o=n+1|0;m=m+1|0;if(!((m|0)<(Vof(d)|0)&(m|0)<(l|0))){p=o;break}else n=o}}else p=0}else p=g;while(0);if((p|0)<(f|0)){c[k>>2]=-1;q=0;i=b;return q|0}if(((Vof(d)|0)-e|0)<(p|0)){c[k>>2]=-1;q=0;i=b;return q|0}f=p+e|0;b:do if((p|0)>0){g=0;h=e;while(1){j=Wof(d,h)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(!(jpf(0,j)|0))break;n=((j&65535)+208&255)+(g*10|0)|0;h=h+1|0;if((h|0)>=(f|0)){r=n;break b}else g=n}c[k>>2]=-1;q=0;i=b;return q|0}else r=0;while(0);c[k>>2]=p;q=r;i=b;return q|0}function _pg(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;k=c[f+12>>2]|0;a:do if((k|0)>0){l=f+16|0;m=g+16|0;n=k;while(1){n=n+-1|0;if(!h?(o=Vof(c[m+(da(c[(c[g>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0,(o|0)>(Vof(c[l+(da(c[(c[f>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)):0){if((Vof(c[m+(da(c[(c[g>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)>=1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if($pg(0,d,e,0,c[m+(da(c[(c[g>>2]|0)+120>>2]|0,n)|0)>>2]|0,j)|0){p=n;q=24;break}}if((Vof(c[l+(da(c[(c[f>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)>=1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if($pg(0,d,e,0,c[l+(da(c[(c[f>>2]|0)+120>>2]|0,n)|0)>>2]|0,j)|0){p=n;q=24;break}}}else{if((Vof(c[l+(da(c[(c[f>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)>=1){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if($pg(0,d,e,0,c[l+(da(c[(c[f>>2]|0)+120>>2]|0,n)|0)>>2]|0,j)|0){p=n;q=24;break}}if(!h?(Vof(c[m+(da(c[(c[g>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)>=1:0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if($pg(0,d,e,0,c[m+(da(c[(c[g>>2]|0)+120>>2]|0,n)|0)>>2]|0,j)|0){p=n;q=24;break}}}if((n|0)<=0)break a}if((q|0)==24){i=b;return p|0}}while(0);c[j>>2]=-1;p=-1;i=b;return p|0}function $pg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;b=i;if((f|0)>0)j=f;else j=Vof(g)|0;if((j+e|0)<=(Vof(d)|0)){RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;rwh(2686624)}f=eKf(0)|0;if(!(a[2540708]|0))rwh(2540560);if(!(rvf(0,d,e,g,0,j,1,f)|0)){k=1;l=j;c[h>>2]=l;i=b;return k|0}}k=0;l=-1;c[h>>2]=l;i=b;return k|0}function aqg(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;b=i;c[j>>2]=-1;if((c[k>>2]|0)!=-1){l=0;i=b;return l|0}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!(bqg(0,d,e)|0)){m=VSf(g)|0;if(!(a[2540708]|0))rwh(2540560);if(Iwf(0,m,c[c[635163]>>2]|0)|0){l=0;i=b;return l|0}if(h)c[k>>2]=0;c[j>>2]=0;l=1;i=b;return l|0}RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;rwh(2756056)}m=ySf(0)|0;if(!h){n=WSf(m)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!($pg(0,d,e,f,n,j)|0))o=17}else o=17;do if((o|0)==17){n=WSf(g)|0;if(!(a[2540708]|0))rwh(2540560);if(Iwf(0,n,c[c[635163]>>2]|0)|0){n=WSf(g)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if($pg(0,d,e,f,n,j)|0)break}if(!h){n=VSf(m)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!($pg(0,d,e,f,n,j)|0))o=28}else o=28;if((o|0)==28){n=VSf(g)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(!($pg(0,d,e,f,n,j)|0)){l=0;i=b;return l|0}}if(!h?(c[j>>2]|0)==0:0){l=1;i=b;return l|0}c[k>>2]=0;l=1;i=b;return l|0}while(0);c[k>>2]=1;l=1;i=b;return l|0}function bqg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=i;if((Vof(c)|0)<=(d|0)){e=0;i=b;return e|0}f=Wof(c,d)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}e=ouf(0,f)|0;i=b;return e|0}function cqg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;b=i;Soh();j=YSf(f)|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}f=$pg(0,d,e,0,j,h)|0;if(f|g){k=f&1;l=(k|0)!=0;i=b;return l|0}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}k=($pg(0,d,e,0,c[901402]|0,h)|0)&1;l=(k|0)!=0;i=b;return l|0}function dqg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;b=i;c[h>>2]=-1;if(g?(Wof(d,e)|0)<<16>>16!=47:0){j=0;i=b;return j|0}RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}if(cqg(0,d,e,f,g,h)|0){j=0;i=b;return j|0}g=Wof(d,e)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(jpf(0,g)|0){j=0;i=b;return j|0}g=Wof(d,e)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;rwh(2540392)}if(ouf(0,g)|0){j=0;i=b;return j|0}c[h>>2]=1;j=1;i=b;return j|0}function eqg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=i;f=Gqg(0,b,c,d,e,0)|0;i=a;return f|0}function fqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=e;e=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=e;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Exg(0,g,f)|0;i=b;return j|0}function gqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;Xoh();c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];if((c[d+8>>2]|0)==1){RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}RI(3120120)|0;k=(c[780053]|0)+16|0;l=c[k+4>>2]|0;m=b+16|0;c[m>>2]=c[k>>2];c[m+4>>2]=l}else{RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}iM(g,3124024,Mxg(0)|0);l=c[(c[g+4>>2]|0)+4>>2]|0;m=c[g>>2]|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=_n[l&4095](m,f)|0;m=b+16|0;c[m>>2]=d;c[m+4>>2]=H}wqg(h,b);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;m=(c[758637]|0)+16|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];if(sqg(0,g,f)|0){RI(2964880)|0;n=qL(2964880)|0;o=c[901480]|0;wdg(n,o);pwh(n)}wqg(j,b);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;b=c[758637]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];if(qqg(0,g,f)|0){RI(2964880)|0;n=qL(2964880)|0;o=c[901480]|0;wdg(n,o);pwh(n)}else{i=e;return}}function hqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+144|0;g=f+72|0;h=f+56|0;j=f+120|0;k=f+104|0;l=f+96|0;m=f+112|0;n=f+128|0;o=f+136|0;p=f+24|0;q=f+16|0;r=f+88|0;s=f+32|0;t=f;u=f+40|0;Yoh();v=c[d+8>>2]|0;do if((v|0)==2)w=7;else if((v|0)==1){RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}x=e;y=c[x+4>>2]|0;z=j;c[z>>2]=c[x>>2];c[z+4>>2]=y;RI(3120120)|0;y=(c[780053]|0)+16|0;z=c[y+4>>2]|0;x=k;c[x>>2]=c[y>>2];c[x+4>>2]=z;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];if(!(Exg(0,h,g)|0))if((v|0)==2){w=7;break}else break;else{RI(2965048)|0;z=qL(2965048)|0;Rbg(z,c[901538]|0);pwh(z)}}while(0);if((w|0)==7){RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}iM(h,3124024,Mxg(0)|0);w=c[(c[h+4>>2]|0)+4>>2]|0;v=c[h>>2]|0;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];k=_n[w&4095](v,g)|0;v=H;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}w=e;j=c[w+4>>2]|0;z=l;c[z>>2]=c[w>>2];c[z+4>>2]=j;j=m;c[j>>2]=k;c[j+4>>2]=v;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];if(Exg(0,h,g)|0){RI(2965048)|0;m=qL(2965048)|0;Rbg(m,c[901540]|0);pwh(m)}}m=jxg(e)|0;l=fFi(m|0,H|0,6e8,0)|0;if(!((l|0)==0&(H|0)==0)){RI(2965048)|0;l=qL(2965048)|0;Rbg(l,c[901542]|0);pwh(l)}l=n;c[l>>2]=0;c[l+4>>2]=0;axg(n,-14,0,0);RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}l=e;m=c[l+4>>2]|0;v=o;c[v>>2]=c[l>>2];c[v+4>>2]=m;m=n;n=c[m+4>>2]|0;v=p;c[v>>2]=c[m>>2];c[v+4>>2]=n;c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[g+0>>2]=c[p+0>>2];c[g+4>>2]=c[p+4>>2];if(Fxg(0,h,g)|0){RI(2964880)|0;A=qL(2964880)|0;B=c[901544]|0;wdg(A,B);pwh(A)}p=q;c[p>>2]=0;c[p+4>>2]=0;axg(q,14,0,0);RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}p=e;o=c[p+4>>2]|0;n=r;c[n>>2]=c[p>>2];c[n+4>>2]=o;o=q;q=c[o+4>>2]|0;n=s;c[n>>2]=c[o>>2];c[n+4>>2]=q;c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];if(Cxg(0,h,g)|0){RI(2964880)|0;A=qL(2964880)|0;B=c[901544]|0;wdg(A,B);pwh(A)};c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];d=e;e=c[d+4>>2]|0;A=b+16|0;c[A>>2]=c[d>>2];c[A+4>>2]=e;wqg(t,b);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;e=(c[758637]|0)+16|0;c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[h+12>>2]=c[t+12>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];if(sqg(0,h,g)|0){RI(2964880)|0;C=qL(2964880)|0;D=c[901546]|0;wdg(C,D);pwh(C)}wqg(u,b);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3034456)|0;b=c[758637]|0;c[h+0>>2]=c[u+0>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];if(qqg(0,h,g)|0){RI(2964880)|0;C=qL(2964880)|0;D=c[901546]|0;wdg(C,D);pwh(C)}else{i=f;return}}function iqg(a){a=a|0;var b=0,d=0;b=i;d=a+16|0;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function jqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+48|0;f=e+16|0;g=e+32|0;h=e;RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}j=Mxg(0)|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];iM(g,3124592,j);j=c[(c[g+4>>2]|0)+4>>2]|0;d=c[g>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[j&2047](b,d,f);i=e;return}function kqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+48|0;f=e+16|0;g=e+32|0;h=e;RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}j=Mxg(0)|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];iM(g,3124680,j);j=c[(c[g+4>>2]|0)+4>>2]|0;d=c[g>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[j&2047](b,d,f);i=e;return}function lqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+40|0;h=f+32|0;j=f+24|0;k=f+16|0;l=f+8|0;m=f;c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];n=jxg(d)|0;o=j;c[o>>2]=0;c[o+4>>2]=0;$wg(j,n,H);RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}n=j;j=c[n+4>>2]|0;o=k;c[o>>2]=c[n>>2];c[o+4>>2]=j;j=e;e=c[j+4>>2]|0;o=l;c[o>>2]=c[j>>2];c[o+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];l=Hxg(0,h,g)|0;h=m;c[h>>2]=l;c[h+4>>2]=H;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];apg(b,1,g);c[b+8>>2]=c[d+8>>2];i=f;return}function mqg(a){a=a|0;var b=0,d=0;b=i;Voh();d=nqg(a,c[901428]|0,0)|0;i=b;return d|0}function nqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+16|0;h=f+33|0;j=f+32|0;k=f;a[h>>0]=0;a[j>>0]=0;Woh();RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;rwh(2756056)}l=ISf(0,e)|0;if(d){if(!(a[2540708]|0))rwh(2540560);if(!(gpf(0,d,c[c[635163]>>2]|0)|0))m=d;else n=7}else n=7;if((n|0)==7)m=c[901432]|0;a[h>>0]=0;a[j>>0]=0;do if((Vof(m)|0)==1){n=Wof(m,0)|0;d=Gqg(0,n,l,h,j,0)|0;if(n<<16>>16==85){kqg(k,b);c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];o=oqg(0,g,d,l)|0;i=f;return o|0}else{if(d){p=d;break}RI(3079480)|0;d=qL(3079480)|0;Hrg(d,c[901434]|0);pwh(d)}}else p=m;while(0);c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];o=oqg(0,g,p,l)|0;i=f;return o|0}function oqg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=b+32|0;h=b+16|0;j=b;c[j+0>>2]=c[766060];c[j+4>>2]=c[766061];c[j+8>>2]=c[766062];c[j+12>>2]=c[766063];if(!(a[1722849]|0))c[j>>2]=0;else PEi(j|0,0,(c[430705]|0)+-8|0)|0;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];j=Hqg(0,h,g,e,f)|0;i=b;return j|0}function pqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=e;e=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=e;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Bxg(0,g,f)|0;i=b;return j|0}function qqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=e;e=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=e;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Cxg(0,g,f)|0;i=b;return j|0}function rqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=e;e=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=e;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Dxg(0,g,f)|0;i=b;return j|0}function sqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=e;e=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=e;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Fxg(0,g,f)|0;i=b;return j|0}function tqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;f=b+24|0;g=b+16|0;h=b+8|0;j=b;k=d;d=c[k>>2]|0;l=c[k+4>>2]|0;k=e;e=c[k>>2]|0;m=c[k+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}k=h;c[k>>2]=d;c[k+4>>2]=l;l=j;c[l>>2]=e;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];j=Gxg(0,g,f)|0;i=b;return j|0}function uqg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;g=d+32|0;h=d+24|0;j=d+16|0;k=d+8|0;l=d;c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];m=e;n=c[m>>2]|0;o=c[m+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)}m=j;c[m>>2]=n;c[m+4>>2]=o;o=f;f=c[o+4>>2]|0;m=k;c[m>>2]=c[o>>2];c[m+4>>2]=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];k=Hxg(0,h,g)|0;h=l;c[h>>2]=k;c[h+4>>2]=H;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];apg(b,1,g);c[b+8>>2]=c[e+8>>2];i=d;return}function vqg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function wqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+80|0;f=e+56|0;g=e+40|0;h=e+24|0;j=e+16|0;k=e;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];l=d+16|0;d=c[l>>2]|0;m=c[l+4>>2]|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}l=j;c[l>>2]=d;c[l+4>>2]=m;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];uqg(k,0,g,f);c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];k=jxg(f)|0;c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];bpg(b,k,H,1);i=e;return}function xqg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+128|0;d=b+24|0;e=b+72|0;f=b+32|0;g=b+88|0;h=b+112|0;j=b;k=b+56|0;l=b+104|0;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)}RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)};c[f+0>>2]=c[765690];c[f+4>>2]=c[765691];c[f+8>>2]=c[765692];c[f+12>>2]=c[765693];c[f+16>>2]=c[765694];c[f+20>>2]=c[765695];RI(3034456)|0;m=c[758637]|0;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];RI(3120120)|0;m=(c[780053]|0)+16|0;n=c[m+4>>2]|0;o=h;c[o>>2]=c[m>>2];c[o+4>>2]=n;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];hqg(f,e,d);RI(3062592)|0;h=c[765671]|0;c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];c[h+20>>2]=c[f+20>>2];c[j+0>>2]=c[765690];c[j+4>>2]=c[765691];c[j+8>>2]=c[765692];c[j+12>>2]=c[765693];c[j+16>>2]=c[765694];c[j+20>>2]=c[765695];RI(3034456)|0;f=(c[758637]|0)+16|0;c[k+0>>2]=c[f+0>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];RI(3120120)|0;f=(c[780053]|0)+16|0;h=c[f+4>>2]|0;g=l;c[g>>2]=c[f>>2];c[g+4>>2]=h;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[d+0>>2]=c[l+0>>2];c[d+4>>2]=c[l+4>>2];hqg(j,e,d);RI(3062592)|0;d=(c[765671]|0)+24|0;c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];c[d+16>>2]=c[j+16>>2];c[d+20>>2]=c[j+20>>2];RI(3080672)|0;if(!(a[3080820]|0)){RI(3080672)|0;rwh(3080672)}RI(3080672)|0;if(!(a[c[770191]>>0]|0)){i=b;return}RI(1718416)|0;xEe(qL(1718416)|0);RI(1720344)|0;FEe(qL(1720344)|0);i=b;return}function yqg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d;RI(3062592)|0;f=Ewh(b,3062592)|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];f=zqg(a,e)|0;i=d;return f|0}function zqg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+48|0;e=d+32|0;f=d+16|0;g=d;c[f+0>>2]=c[781288];c[f+4>>2]=c[781289];c[f+8>>2]=c[781290];c[f+12>>2]=c[781291];wqg(f,a);wqg(g,b);c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];g=Opg(f,e)|0;i=d;return g|0}function Aqg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0.0;d=i;i=i+64|0;e=d+40|0;f=d+24|0;g=d+8|0;h=d;c[f+0>>2]=c[781288];c[f+4>>2]=c[781289];c[f+8>>2]=c[781290];c[f+12>>2]=c[781291];c[g+0>>2]=c[781288];c[g+4>>2]=c[781289];c[g+8>>2]=c[781290];c[g+12>>2]=c[781291];Zoh();if(!b){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[901714]|0);pwh(j)}else{j=jxg(a)|0;Wog(g,j,H);j=a+16|0;k=c[j+4>>2]|0;l=h;c[l>>2]=c[j>>2];c[l+4>>2]=k;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];lqg(f,g,e);g=c[901716]|0;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];gag(b,g,e);m=+nxg(a+16|0);eag(b,c[901718]|0,~~m);i=d;return}}function Bqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;wqg(h,b);wqg(j,d);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];j=pqg(0,g,f)|0;i=e;return j|0}
function Cqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+96|0;f=e+72|0;g=e+56|0;h=e+32|0;j=e+16|0;k=e;c[h+0>>2]=c[765690];c[h+4>>2]=c[765691];c[h+8>>2]=c[765692];c[h+12>>2]=c[765693];c[h+16>>2]=c[765694];c[h+20>>2]=c[765695];RI(3062592)|0;if(!(vL(d,3062592)|0)){l=0;i=e;return l|0}wqg(j,b);RI(3062592)|0;b=Ewh(d,3062592)|0;c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[h+20>>2]=c[b+20>>2];wqg(k,h);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];l=pqg(0,g,f)|0;i=e;return l|0}function Dqg(a){a=a|0;var b=0,c=0,d=0;b=i;c=jxg(a)|0;d=c^(wxg(a+16|0)|0);i=b;return d|0}function Eqg(a){a=a|0;var b=0,c=0;b=i;c=Fqg(a,0,0)|0;i=b;return c|0}function Fqg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+128|0;g=f;h=f+56|0;j=f+112|0;k=f+113|0;l=f+16|0;m=f+96|0;n=f+48|0;o=f+32|0;p=f+80|0;q=f+72|0;a[j>>0]=0;a[k>>0]=0;_oh();RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;rwh(2756056)}r=ISf(0,e)|0;if(d){if(!(a[2540708]|0))rwh(2540560);if(!(gpf(0,d,c[c[635163]>>2]|0)|0))s=d;else t=7}else t=7;if((t|0)==7){t=_Sf(r)|0;d=aTf(r)|0;if(!(a[2540708]|0))rwh(2540560);s=jwf(0,t,c[901734]|0,d,c[901736]|0)|0}a[j>>0]=0;a[k>>0]=0;if((Vof(s)|0)==1){d=Gqg(0,Wof(s,0)|0,r,j,k,1)|0;if(!d){RI(3079480)|0;k=qL(3079480)|0;Hrg(k,c[901738]|0);pwh(k)}if(!(a[j>>0]|0))u=d;else{wqg(l,b);RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;rwh(3120120)};c[m+0>>2]=c[766060];c[m+4>>2]=c[766061];c[m+8>>2]=c[766062];c[m+12>>2]=c[766063];RI(3120120)|0;j=(c[780053]|0)+16|0;k=c[j+4>>2]|0;t=n;c[t>>2]=c[j>>2];c[t+4>>2]=k;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];QEe(m,g);c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];v=Hqg(0,h,g,d,r)|0;i=f;return v|0}}else u=s;Iqg(o,b);s=b+16|0;b=c[s>>2]|0;d=c[s+4>>2]|0;c[p+0>>2]=c[766060];c[p+4>>2]=c[766061];c[p+8>>2]=c[766062];c[p+12>>2]=c[766063];s=q;c[s>>2]=b;c[s+4>>2]=d;c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];QEe(p,g);c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];c[h+12>>2]=c[o+12>>2];c[g+0>>2]=c[p+0>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];v=Hqg(0,h,g,u,r)|0;i=f;return v|0}function Gqg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;b=i;aph();a[f>>0]=0;a[g>>0]=0;j=d&65535;a:do switch(j+65427&65535|0){case 6:{k=iTf(e)|0;a[g>>0]=1;l=k;break}case 5:{m=20;break}case 8:{k=jTf(e)|0;if(h)a[f>>0]=1;a[g>>0]=1;l=k;break}case 2:{m=19;break}case 7:{l=$Sf(e)|0;break}case 12:{m=31;break}case 0:{m=18;break}default:switch(j+65459&65535|0){case 5:{m=20;break a;break}case 8:{if(h){l=0;break a}k=dTf(e)|0;a[f>>0]=1;l=k;break a;break}case 2:{m=19;break a;break}case 0:{m=18;break a;break}case 7:{l=aTf(e)|0;break a;break}default:{k=j+65468&65535;if((k|0)==2){l=dTf(e)|0;break a}else if(!k){l=ZSf(e)|0;break a}else if((k|0)!=3){k=j+65436&65535;if((k|0)==3){n=_Sf(e)|0;o=$Sf(e)|0;if(!(a[2540708]|0))rwh(2540560);l=iwf(0,n,c[901760]|0,o)|0;break a}else if(!k){l=_Sf(e)|0;break a}else if((k|0)!=2)if(d<<16>>16==89){m=31;break a}else{l=0;break a}else{k=ZSf(e)|0;o=$Sf(e)|0;if(!(a[2540708]|0))rwh(2540560);l=iwf(0,k,c[901758]|0,o)|0;break a}}else{o=_Sf(e)|0;k=aTf(e)|0;if(!(a[2540708]|0))rwh(2540560);l=iwf(0,o,c[901762]|0,k)|0;break a}}}}while(0);if((m|0)==18)l=bTf(e)|0;else if((m|0)==19){d=hTf(e)|0;a[g>>0]=1;l=d}else if((m|0)==20){d=gTf(e)|0;if(h)a[f>>0]=1;a[g>>0]=1;l=d}else if((m|0)==31)l=cTf(e)|0;i=b;return l|0}function Hqg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,T=0,V=0,W=0,X=0,Y=0.0;b=i;i=i+80|0;h=b;j=b+48|0;k=b+24|0;l=b+16|0;m=b+60|0;n=b+40|0;o=b+56|0;p=b+64|0;q=b+68|0;r=l;c[r>>2]=0;c[r+4>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;bph();r=Vof(f)|0;RI(2971904)|0;s=qL(2971904)|0;Ueg(s,r+10|0);RI(2756056)|0;if(!(a[2756204]|0)){RI(2756056)|0;rwh(2756056)}r=ySf(0)|0;t=gTf(r)|0;if(!(a[2540708]|0))rwh(2540560);if(gpf(0,f,t)|0)u=r;else{t=jTf(r)|0;if(!(a[2540708]|0))rwh(2540560);v=gpf(0,f,t)|0;u=v?r:g}if((Vof(f)|0)<=0){w=Fqh(2972072,s)|0;i=b;return w|0}g=j+4|0;r=j+4|0;v=j+4|0;t=j+4|0;x=j+4|0;y=d+8|0;z=s+8|0;A=j+4|0;B=j+4|0;C=j+4|0;D=j+4|0;E=0;a:while(1){F=Wof(f,E)|0;G=F&65535;b:do switch(G+65436&65535|0){case 4:{I=Jqg(0,f,E,F)|0;J=(fxg(d)|0)%12|0;Kqg(0,s,(J|0)!=0?J:12,(I|0)==1?1:2);K=I;break}case 2:{L=0;M=19;break}case 0:{I=Jqg(0,f,E,F)|0;if((I|0)<=2){J=fTf(u)|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748536,J);J=c[(c[C>>2]|0)+4>>2]|0;N=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];O=_n[J&4095](N,h)|0;Kqg(0,s,O,(I|0)==1?1:2);K=I;break b}O=fTf(u)|0;if((I|0)==3){c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748624,O);N=c[(c[A>>2]|0)+4>>2]|0;J=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];Hbg(s,pTf(u,_n[N&4095](J,h)|0)|0)|0;K=3;break b}else{c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748624,O);O=c[(c[B>>2]|0)+4>>2]|0;J=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];Hbg(s,oTf(u,_n[O&4095](J,h)|0)|0)|0;K=I;break b}break}case 3:{I=Jqg(0,f,E,F)|0;J=fTf(u)|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748704,J);J=c[(c[D>>2]|0)+4>>2]|0;O=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];Hbg(s,PSf(u,_n[J&4095](O,h)|0)|0)|0;K=I;break}case 9:{I=Jqg(0,f,E,F)|0;Kqg(0,s,hxg(d)|0,(I|0)==1?1:2);K=I;break}default:{I=G+65466&65535;if(!I){L=1;M=19;break b}else if((I|0)==2){O=Jqg(0,f,E,F)|0;J=fxg(d)|0;Kqg(0,s,J,(O|0)==1?1:2);K=O;break b}else if((I|0)==7){O=Jqg(0,f,E,F)|0;J=fTf(u)|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748792,J);J=c[(c[t>>2]|0)+4>>2]|0;N=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];P=_n[J&4095](N,h)|0;if((O|0)<=2){Kqg(0,s,P,O);K=O;break b}if((O|0)==3){Hbg(s,OSf(u,P)|0)|0;K=3;break b}else{Hbg(s,QSf(u,P)|0)|0;K=O;break b}}else if((I|0)!=5){I=G+65421&65535;if((I|0)==7){O=Jqg(0,f,E,F)|0;if(REe(e)|0){P=SEe(e)|0;Q=P;T=H}else{RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}P=Mxg(0)|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,3124024,P);P=c[(c[g>>2]|0)+4>>2]|0;N=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];J=_n[P&4095](N,h)|0;Q=J;T=H}J=l;c[J>>2]=Q;c[J+4>>2]=T;jxg(l)|0;if((H|0)<0)acg(s,45)|0;else acg(s,43)|0;c[m>>2]=O;if((O|0)==1){J=fxg(l)|0;gfg(s,(J|0)>-1?J:0-J|0)|0;K=1;break b}J=fxg(l)|0;N=(J|0)>-1?J:0-J|0;if((O|0)==2){c[n>>2]=N;Hbg(s,upf(n,c[901768]|0)|0)|0;K=2;break b}else{c[o>>2]=N;Hbg(s,upf(o,c[901770]|0)|0)|0;acg(s,58)|0;N=hxg(l)|0;c[p>>2]=(N|0)>-1?N:0-N|0;Hbg(s,upf(p,c[901772]|0)|0)|0;K=O;break b}}else if(!I){O=Jqg(0,f,E,F)|0;N=ixg(d)|0;Kqg(0,s,N,(O|0)==1?1:2);K=O;break b}else if((I|0)==1){O=Jqg(0,f,E,F)|0;if((fxg(d)|0)>11)V=WSf(u)|0;else V=VSf(u)|0;if((O|0)!=1){Hbg(s,V)|0;K=O;break b}if((Vof(V)|0)<1){K=1;break b}acg(s,Wof(V,0)|0)|0;K=1;break b}else if((I|0)==6){I=Jqg(0,f,E,F)|0;O=fTf(u)|0;if((I|0)>2){c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748872,O);N=c[(c[r>>2]|0)+4>>2]|0;J=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];Kqg(0,s,_n[N&4095](J,h)|0,I);K=I;break b}else{c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,2748872,O);O=c[(c[v>>2]|0)+4>>2]|0;J=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];Kqg(0,s,(_n[O&4095](J,h)|0)%100|0,I);K=I;break b}}else{I=G+65502&65535;if((I|0)==5|(I|0)==0){K=Lqg(0,f,E,s)|0;break b}else if((I|0)==3){if((E|0)>=((Vof(f)|0)+-1|0)){M=78;break a}if((Wof(f,E+1|0)|0)<<16>>16==37){M=80;break a}else{K=1;break b}}else if(F<<16>>16==92){if((E|0)>=((Vof(f)|0)+-1|0)){M=82;break a}acg(s,Wof(f,E+1|0)|0)|0;K=2;break b}else if(F<<16>>16==58){Hbg(s,YSf(u)|0)|0;K=1;break b}else if(F<<16>>16==47){Hbg(s,XSf(u)|0)|0;K=1;break b}else{acg(s,F)|0;K=1;break b}}}else{do if(!(REe(e)|0)){I=c[y>>2]|0;if((I|0)==2)break;else if((I|0)!=1){K=1;break b}acg(s,90)|0;K=1;break b}while(0);if(REe(e)|0){I=SEe(e)|0;W=I;X=H}else{RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;rwh(3123800)}I=Mxg(0)|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];iM(j,3124024,I);I=c[(c[x>>2]|0)+4>>2]|0;J=c[j>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];O=_n[I&4095](J,h)|0;W=O;X=H}O=l;c[O>>2]=W;c[O+4>>2]=X;jxg(l)|0;if((H|0)<0)acg(s,45)|0;else acg(s,43)|0;O=fxg(l)|0;c[m>>2]=(O|0)>-1?O:0-O|0;Hbg(s,upf(m,c[901774]|0)|0)|0;acg(s,58)|0;O=hxg(l)|0;c[q>>2]=(O|0)>-1?O:0-O|0;Hbg(s,upf(q,c[901776]|0)|0)|0;K=1;break b}}}while(0);if((M|0)==19){M=0;G=Jqg(0,f,E,F)|0;if((G|0)>=8){M=20;break}O=jxg(d)|0;Y=+U(10.0,+(+(7-G|0)));J=fFi(O|0,H|0,1e7,0)|0;O=eFi(J|0,H|0,~~Y>>>0|0,(+S(Y)>=1.0?(Y>0.0?(ha(+R(Y/4294967296.0),4294967295.0)|0)>>>0:~~+ca((Y-+(~~Y>>>0))/4294967296.0)>>>0):0)|0)|0;J=c[z>>2]|0;Kqg(0,s,O,G);if(L){I=c[z>>2]|0;c:do if((I|0)>(J|0)){N=I;do{if((bfg(s,N+-1|0)|0)<<16>>16!=48)break c;Zeg(s,(c[z>>2]|0)+-1|0);N=c[z>>2]|0}while((N|0)>(J|0))}while(0);if(!((O|0)!=0|(J|0)<1)?(bfg(s,J+-1|0)|0)<<16>>16==46:0){Zeg(s,(c[z>>2]|0)+-1|0);K=G}else K=G}else K=G}E=K+E|0;if((E|0)>=(Vof(f)|0)){M=87;break}}if((M|0)==20){RI(3079480)|0;f=qL(3079480)|0;Hrg(f,c[901766]|0);pwh(f)}else if((M|0)==78){RI(3079480)|0;f=qL(3079480)|0;Hrg(f,c[901778]|0);pwh(f)}else if((M|0)==80){RI(3079480)|0;f=qL(3079480)|0;Hrg(f,c[901780]|0);pwh(f)}else if((M|0)==82){RI(3079480)|0;f=qL(3079480)|0;Hrg(f,c[901782]|0);pwh(f)}else if((M|0)==87){w=Fqh(2972072,s)|0;i=b;return w|0}return 0}function Iqg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;c[g+0>>2]=c[d+0>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;rwh(3034456)};c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];g=jxg(f)|0;c[b+0>>2]=c[781288];c[b+4>>2]=c[781289];c[b+8>>2]=c[781290];c[b+12>>2]=c[781291];bpg(b,g,H,0);i=e;return}function Jqg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;e=Vof(b)|0;f=c;while(1){g=f+1|0;if((g|0)>=(e|0)){h=g;break}if((Wof(b,g)|0)<<16>>16==d<<16>>16)f=g;else{h=g;break}}i=a;return h-c|0}function Kqg(c,d,e,f){c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;c=i;i=i+32|0;g=c;h=e;e=f;f=16;while(1){j=f+-1|0;b[g+(j<<1)>>1]=((h|0)%10|0)+48;k=e+-1|0;if((h|0)>9){h=(h|0)/10|0;e=k;f=j}else{l=j;m=k;break}}if((m|0)>0){f=m;e=l;do{f=f+-1|0;e=e+-1|0;b[g+(e<<1)>>1]=48}while((f|0)>0);n=l-m|0}else n=l;if(!(a[2540708]|0))rwh(2540560);Hbg(d,zwf(qL(2540560)|0,g,n,16-n|0)|0)|0;i=c;return}function Lqg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;$oh();f=Vof(b)|0;g=d+1|0;h=Wof(b,d)|0;a:do if((g|0)<(f|0)){j=g;while(1){k=j+1|0;l=Wof(b,j)|0;if(l<<16>>16==h<<16>>16){m=k;n=2;break}if(l<<16>>16==92){if((k|0)>=(f|0)){n=5;break}acg(e,Wof(b,k)|0)|0;o=j+2|0}else{acg(e,l)|0;o=k}if((o|0)<(f|0))j=o;else break a}if((n|0)==2){i=a;return m-d|0}else if((n|0)==5){RI(3079480)|0;j=qL(3079480)|0;Hrg(j,c[901744]|0);pwh(j)}}while(0);RI(3079480)|0;n=qL(3079480)|0;Hrg(n,c[901746]|0);pwh(n);return 0}function Mqg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Nqg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;c[a+8>>2]=Fqh(2537592,Xnf(b)|0)|0;c[a+12>>2]=Fqh(2836288,rth(2652848,Xnf(b)|0)|0)|0;c[a+16>>2]=d;c[a+20>>2]=Fqh(2836288,rth(2652848,suh(2658656,JBf(b)|0)|0)|0)|0;c[a+24>>2]=Fqh(2537592,suh(2658656,JBf(b)|0)|0)|0;c[a+28>>2]=Fqh(2649752,JBf(b)|0)|0;i=e;return}function Oqg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+16|0;b=f+8|0;g=f+4|0;h=f;cph();j=Wwh(2610376,d)|0;d=j+12|0;if((c[d>>2]|0)>0){k=j+16|0;l=0;m=0;do{n=c[k+(da(c[(c[j>>2]|0)+120>>2]|0,m)|0)>>2]|0;if(!(KBf(n)|0))o=0;else{c[g>>2]=m;RI(2540224)|0;p=pL(2540224,g)|0;if(!(a[2540708]|0))rwh(2540560);o=fwf(0,c[901838]|0,p)|0}RI(3066192)|0;p=l;l=qL(3066192)|0;Nqg(l,n,o);if(!p)L7f(e,c[901840]|0,l);else c[p+32>>2]=l;if(KBf(n)|0)L7f(e,o,KBf(n)|0);m=m+1|0}while((m|0)<(c[d>>2]|0))}RI(2540728)|0;if(a[2540876]|0){c[h>>2]=3451640;c[b+0>>2]=c[h+0>>2];q=npf(0,b)|0;p9f(e,q);i=f;return}RI(2540728)|0;rwh(2540728);c[h>>2]=3451640;c[b+0>>2]=c[h+0>>2];q=npf(0,b)|0;p9f(e,q);i=f;return}function Pqg(a,b,c){a=a|0;b=b|0;c=c|0;RI(3100472)|0;c=qL(3100472)|0;oug(c);pwh(c)}function Qqg(a){a=a|0;var b=0;b=i;dph();zig(a,tof(0,c[901852]|0)|0);KHf(a,-2147352558);i=b;return}function Rqg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Sqg(a){a=a|0;var b=0;b=i;eph();Tqg(a,tof(0,c[901864]|0)|0);KHf(a,-2146233052);i=b;return}function Tqg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233054);i=c;return}function Uqg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Vqg(a){a=a|0;var b=0;b=i;fph();Tqg(a,tof(0,c[901876]|0)|0);KHf(a,-2146233053);i=b;return}function Wqg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Xqg(a){a=a|0;return}function Yqg(b,c,e){b=b|0;c=c|0;e=e|0;var f=0;b=i;RI(2560032)|0;f=a[(Xwh(c,2560032)|0)>>0]|0;RI(2560032)|0;c=(f&255)-(d[(Xwh(e,2560032)|0)>>0]|0)|0;i=b;return c|0}function Zqg(a,b,c){a=a|0;b=b|0;c=c|0;return (b&255)-(c&255)|0}function _qg(a){a=a|0;return}function $qg(a,c,d){a=a|0;c=c|0;d=d|0;var f=0;a=i;RI(2562664)|0;f=b[(Xwh(c,2562664)|0)>>1]|0;RI(2562664)|0;c=(f&65535)-(e[(Xwh(d,2562664)|0)>>1]|0)|0;i=a;return c|0}function arg(a,b,c){a=a|0;b=b|0;c=c|0;return (b&65535)-(c&65535)|0}function brg(a){a=a|0;return}function crg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;RI(2540224)|0;e=c[(Xwh(b,2540224)|0)>>2]|0;RI(2540224)|0;b=c[(Xwh(d,2540224)|0)>>2]|0;if((e|0)==(b|0)){f=0;i=a;return f|0}f=(e|0)<(b|0)?-1:1;i=a;return f|0}function drg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if((b|0)==(c|0))d=0;else d=(b|0)<(c|0)?-1:1;return d|0}function erg(a){a=a|0;return}function frg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;RI(2548816)|0;e=Xwh(b,2548816)|0;b=c[e>>2]|0;f=c[e+4>>2]|0;RI(2548816)|0;e=Xwh(d,2548816)|0;d=c[e>>2]|0;g=c[e+4>>2]|0;if((b|0)==(d|0)&(f|0)==(g|0)){h=0;i=a;return h|0}h=(f|0)<(g|0)|(f|0)==(g|0)&b>>>0<d>>>0?-1:1;i=a;return h|0}function grg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=i;if((b|0)==(d|0)&(c|0)==(e|0)){f=0;i=a;return f|0}f=(c|0)<(e|0)|(c|0)==(e|0)&b>>>0<d>>>0?-1:1;i=a;return f|0}function hrg(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];return}function irg(b){b=b|0;var d=0,e=0,f=0;b=i;RI(3073648)|0;d=qL(3073648)|0;RI(3074072)|0;c[(c[768541]|0)+8>>2]=d;RI(3074320)|0;d=qL(3074320)|0;RI(3074072)|0;c[(c[768541]|0)+12>>2]=d;RI(3074816)|0;d=qL(3074816)|0;RI(3074072)|0;c[(c[768541]|0)+16>>2]=d;RI(3075312)|0;d=qL(3075312)|0;RI(3074072)|0;c[(c[768541]|0)+20>>2]=d;RI(2536312)|0;d=qL(2536312)|0;RI(3074072)|0;c[(c[768541]|0)+4>>2]=d;RI(2730168)|0;if(a[2730316]|0){RI(2730168)|0;e=qL(2730168)|0;kPf(e);RI(3074072)|0;f=c[768541]|0;c[f>>2]=e;i=b;return}RI(2730168)|0;Ywh(2730168);RI(2730168)|0;e=qL(2730168)|0;kPf(e);RI(3074072)|0;f=c[768541]|0;c[f>>2]=e;i=b;return}function jrg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[768952]|0;if(!e){f=MK(3075816)|0;c[768952]=f;g=f}else g=e;In[g&4095](b,d);i=a;return}function krg(b){b=b|0;var d=0,e=0,f=0,g=0;b=i;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;if(!(c[(LM(c[768552]|0)|0)>>2]|0)){RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Ywh(2730168)}RI(2730168)|0;d=qL(2730168)|0;kPf(d);RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;c[(LM(c[768552]|0)|0)>>2]=d}RI(3074072)|0;if(a[3074220]|0){RI(3074072)|0;e=c[768552]|0;f=LM(e)|0;g=c[f>>2]|0;i=b;return g|0}RI(3074072)|0;Ywh(3074072);RI(3074072)|0;e=c[768552]|0;f=LM(e)|0;g=c[f>>2]|0;i=b;return g|0}function lrg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;f=b+16|0;g=b;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}h=nrh(2736936,krg(0)|0,d)|0;RI(3074072)|0;j=(a[3074220]|0)!=0;if(h){if(!j){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;h=uth(2736488,c[(LM(c[768552]|0)|0)>>2]|0,d)|0;RI(3074072)|0;k=Xwh(h,3074072)|0;c[e+0>>2]=c[k+0>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];i=b;return}if(!j){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;j=c[(c[768541]|0)+4>>2]|0;Jag(0,j);RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;if(nrh(2736936,c[c[768541]>>2]|0,d)|0){RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;k=uth(2736488,c[c[768541]>>2]|0,d)|0;RI(3074072)|0;Rrh(2736568,c[(LM(c[768552]|0)|0)>>2]|0,d,k);RI(3074072)|0;h=Xwh(k,3074072)|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];Kag(0,j);i=b;return}Kag(0,j);RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}jrg(0,d,e);j=e+4|0;h=c[j>>2]|0;RI(1159264)|0;do if((((vL(h,1159264)|0)==0?(k=c[j>>2]|0,RI(1150432)|0,(vL(k,1150432)|0)==0):0)?(k=c[j>>2]|0,RI(1166304)|0,(vL(k,1166304)|0)==0):0)?(k=c[j>>2]|0,RI(1168328)|0,(vL(k,1168328)|0)==0):0){k=c[j>>2]|0;RI(1101728)|0;if(vL(k,1101728)|0){RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;l=c[(c[768541]|0)+16>>2]|0;break}k=c[j>>2]|0;RI(1171272)|0;if(vL(k,1171272)|0){RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;l=c[(c[768541]|0)+12>>2]|0;break}k=c[j>>2]|0;RI(1169800)|0;if(vL(k,1169800)|0){RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;l=c[(c[768541]|0)+8>>2]|0;break}k=c[j>>2]|0;RI(1164824)|0;if(vL(k,1164824)|0){RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;l=c[(c[768541]|0)+20>>2]|0}else l=0}else l=0;while(0);h=e+8|0;OEf(0,c[j>>2]|0,c[h>>2]|0,l);l=c[h>>2]|0;k=l+12|0;a:do if((c[k>>2]|0)>=51){RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Ywh(2730168)}RI(2730168)|0;m=qL(2730168)|0;rPf(m,c[k>>2]|0);n=e+12|0;c[n>>2]=m;o=c[h>>2]|0;if((c[o+12>>2]|0)>0){p=m;m=o;q=0;while(1){c[f>>2]=q;RI(2540224)|0;r=pL(2540224,f)|0;Rrh(2736568,p,c[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,q)|0)>>2]|0,r);r=q+1|0;s=c[h>>2]|0;if((r|0)>=(c[s+12>>2]|0)){t=n;u=s;break a}p=c[n>>2]|0;m=s;q=r}}else{t=n;u=o}}else{t=e+12|0;u=l}while(0);l=c[e>>2]|0;e=c[j>>2]|0;j=c[t>>2]|0;RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}RI(3074072)|0;t=c[(c[768541]|0)+4>>2]|0;Jag(0,t);RI(3074072)|0;if(!(a[3074220]|0)){RI(3074072)|0;Ywh(3074072)}c[g>>2]=l;c[g+4>>2]=e;c[g+8>>2]=u;c[g+12>>2]=j;RI(3074072)|0;j=pL(3074072,g)|0;RI(3074072)|0;Rrh(2736568,c[c[768541]>>2]|0,d,j);Kag(0,t);i=b;return}function mrg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;c[c[d>>2]>>2]=a;i=b;return}function nrg(a){a=a|0;return}function org(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[769256]|0;if(!b){d=MK(3077032)|0;c[769256]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function prg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[769268]|0;if(!b){d=MK(3077080)|0;c[769268]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function qrg(a){a=a|0;var b=0,d=0,e=0;a=i;b=c[769280]|0;if(!b){d=MK(3077128)|0;c[769280]=d;e=d}else e=b;b=Jo[e&127]()|0;i=a;return b|0}function rrg(a){a=a|0;var b=0,d=0,e=0;a=i;RI(3077176)|0;if(!(c[c[769317]>>2]|0)){b=srg(0,qrg(0)|0)|0;d=prg(0)|0;RI(3077344)|0;e=qL(3077344)|0;trg(e,d,b);RI(3077176)|0;c[c[769317]>>2]=e}RI(3077176)|0;i=a;return c[c[769317]>>2]|0}function srg(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;if(!c){RI(3129672)|0;d=qL(3129672)|0;nyg(d,0,0,0,0);e=d;i=b;return e|0}do if((Vof(c)|0)>0){d=0;f=0;g=0;h=0;j=1;k=-1;l=0;while(1){m=Wof(c,l)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Ywh(2540392)}do if(jpf(0,m)|0)if((k|0)>-1){n=d;o=f;p=g;q=h;r=j;s=((m&65535)+65488&65535)+(k*10|0)|0;break}else{n=d;o=f;p=g;q=h;r=j;s=(m&65535)+65488&65535;break}else if((k|0)<0){n=d;o=f;p=g;q=h;r=j;s=k}else{if((j|0)==2){t=d;u=k;v=g;w=h}else if((j|0)==3){t=d;u=f;v=k;w=h}else if((j|0)==4){t=d;u=f;v=g;w=k}else if((j|0)==1){t=k;u=f;v=g;w=h}else{t=d;u=f;v=g;w=h}n=t;o=u;p=v;q=w;r=j+1|0;s=-1}while(0);l=l+1|0;if((r|0)==5){x=n;y=o;z=p;A=q;B=5;C=s;break}if((l|0)>=(Vof(c)|0)){x=n;y=o;z=p;A=q;B=r;C=s;break}else{d=n;f=o;g=p;h=q;j=r;k=s}}if((C|0)>=0)if((B|0)==4){D=x;E=y;F=z;G=C;break}else if((B|0)==3){D=x;E=y;F=C;G=A;break}else if((B|0)==1){D=C;E=y;F=z;G=A;break}else if((B|0)==2){D=x;E=C;F=z;G=A;break}else{D=x;E=y;F=z;G=A;break}else{D=x;E=y;F=z;G=A}}else{D=0;E=0;F=0;G=0}while(0);RI(3129672)|0;A=qL(3129672)|0;nyg(A,D,E,F,G);e=A;i=b;return e|0}function trg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;Nph();if(!(a[2540708]|0))Ywh(2540560);c[b+16>>2]=c[c[635163]>>2];if(Tnf(0,e,0)|0){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[902898]|0);Zwh(g)}else{c[b+8>>2]=d;c[b+12>>2]=e;i=f;return}}function urg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[769378]|0;if(!d){e=MK(3077520)|0;c[769378]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function vrg(a){a=a|0;var b=0;a=i;b=(prg(0)|0)<4;i=a;return b|0}function wrg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function xrg(a){a=a|0;return}function yrg(a){a=a|0;var b=0;a=i;RI(3078224)|0;b=qL(3078224)|0;RI(3078224)|0;c[c[769579]>>2]=b;i=a;return}function zrg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Arg(a,b){a=a|0;b=b|0;var c=0;c=i;Brg(a,b);KHf(a,-2146233081);i=c;return}function Brg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233062);i=c;return}function Crg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Drg(a){a=a|0;return}function Erg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2539536)|0;wof(a,16);Cpf(a,0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Frg(a){a=a|0;var b=0;b=i;gph();Grg(a,tof(0,c[901906]|0)|0);KHf(a,-2146233033);i=b;return}function Grg(a,b){a=a|0;b=b|0;var c=0;c=i;Vxf(a,b);KHf(a,-2146233087);i=c;return}function Hrg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233033);i=c;return}function Irg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Jrg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[770032]|0;if(!d){e=MK(3080136)|0;c[770032]=e;f=e}else f=d;ko[f&4095](b);i=a;return}function Krg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Lrg(d,e){d=d|0;e=e|0;var f=0,g=0,h=0;f=i;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}Mrg(0,e,16);c[d>>2]=GLf(0,e,0)|0;b[d+4>>1]=FLf(0,e,4)|0;b[d+6>>1]=FLf(0,e,6)|0;g=e+16|0;h=c[(c[e>>2]|0)+120>>2]|0;a[d+8>>0]=a[g+(h<<3)>>0]|0;a[d+9>>0]=a[g+(h*9|0)>>0]|0;a[d+10>>0]=a[g+(h*10|0)>>0]|0;a[d+11>>0]=a[g+(h*11|0)>>0]|0;a[d+12>>0]=a[g+(h*12|0)>>0]|0;a[d+13>>0]=a[g+(h*13|0)>>0]|0;a[d+14>>0]=a[g+(h*14|0)>>0]|0;a[d+15>>0]=a[g+(h*15|0)>>0]|0;i=f;return}function Mrg(b,c,d){b=b|0;c=c|0;d=d|0;b=i;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}Prg(0,c);Qrg(0,c,d);i=b;return}function Nrg(d,e,f,g,h,i,j,k,l,m,n,o){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;c[d>>2]=e;b[d+4>>1]=f;b[d+6>>1]=g;a[d+8>>0]=h;a[d+9>>0]=i;a[d+10>>0]=j;a[d+11>>0]=k;a[d+12>>0]=l;a[d+13>>0]=m;a[d+14>>0]=n;a[d+15>>0]=o;return}function Org(b){b=b|0;var d=0;b=i;RI(3080504)|0;d=c[770149]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;RI(2536312)|0;d=qL(2536312)|0;RI(3080504)|0;c[(c[770149]|0)+16>>2]=d;RI(3080672)|0;if(!(a[3080820]|0)){RI(3080672)|0;Ywh(3080672)}RI(3080672)|0;if(!(a[c[770191]>>0]|0)){i=b;return}RI(1730344)|0;aFe(qL(1730344)|0);RI(1732272)|0;iFe(qL(1732272)|0);i=b;return}function Prg(a,b){a=a|0;b=b|0;var d=0;a=i;hph();if(!b){b=tof(0,c[901918]|0)|0;RI(2963920)|0;d=qL(2963920)|0;Iag(d,b);Zwh(d)}else{i=a;return}}function Qrg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;b=i;i=i+16|0;f=b;iph();if((c[d+12>>2]|0)==(e|0)){i=b;return}b=tof(0,c[901934]|0)|0;c[f>>2]=e;RI(2540224)|0;e=pL(2540224,f)|0;if(!(a[2540708]|0))Ywh(2540560);f=_vf(0,b,e)|0;RI(2965048)|0;e=qL(2965048)|0;Rbg(e,f);Zwh(e)}function Rrg(a,b,c){a=a|0;b=b|0;c=c|0;return ((b|0)<(c|0)?-1:1)|0}function Srg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;jph();if(!b){f=1;i=d;return f|0}RI(3080504)|0;if(!(vL(b,3080504)|0)){g=tof(0,c[901960]|0)|0;RI(2965048)|0;h=qL(2965048)|0;Rag(h,c[901958]|0,g);Zwh(h)}RI(3080504)|0;h=Xwh(b,3080504)|0;c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];f=Trg(a,e)|0;i=d;return f|0}function Trg(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[d>>2]|0;h=c[e>>2]|0;if((g|0)!=(h|0)){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(g|0)<(h|0)?-1:1;i=f;return j|0}h=b[d+4>>1]|0;g=c[e+4>>2]|0;k=g&65535;l=g>>>16&65535;if(h<<16>>16!=k<<16>>16){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=h<<16>>16<k<<16>>16?-1:1;i=f;return j|0}k=b[d+6>>1]|0;if(k<<16>>16!=l<<16>>16){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=k<<16>>16<l<<16>>16?-1:1;i=f;return j|0}l=a[d+8>>0]|0;k=c[e+8>>2]|0;h=k&255;g=(k&65535)>>>8&255;m=k>>>16&255;n=k>>>24&255;if(l<<24>>24!=h<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(l&255)<(h&255)?-1:1;i=f;return j|0}h=a[d+9>>0]|0;if(h<<24>>24!=g<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(h&255)<(g&255)?-1:1;i=f;return j|0}g=a[d+10>>0]|0;if(g<<24>>24!=m<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(g&255)<(m&255)?-1:1;i=f;return j|0}m=a[d+11>>0]|0;if(m<<24>>24!=n<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(m&255)<(n&255)?-1:1;i=f;return j|0}n=a[d+12>>0]|0;m=c[e+12>>2]|0;e=m&255;g=(m&65535)>>>8&255;h=m>>>16&255;l=m>>>24&255;if(n<<24>>24!=e<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(n&255)<(e&255)?-1:1;i=f;return j|0}e=a[d+13>>0]|0;if(e<<24>>24!=g<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(e&255)<(g&255)?-1:1;i=f;return j|0}g=a[d+14>>0]|0;if(g<<24>>24!=h<<24>>24){RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(g&255)<(h&255)?-1:1;i=f;return j|0}h=a[d+15>>0]|0;if(h<<24>>24==l<<24>>24){j=0;i=f;return j|0}RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}j=(h&255)<(l&255)?-1:1;i=f;return j|0}function Urg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;RI(3080504)|0;if(!(vL(b,3080504)|0)){f=0;i=d;return f|0}RI(3080504)|0;g=Xwh(b,3080504)|0;c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];f=(Trg(a,e)|0)==0;i=d;return f|0}function Vrg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=(Trg(a,e)|0)==0;i=d;return b|0}function Wrg(a){a=a|0;return (e[a+4>>1]<<16|b[a+6>>1])^c[a>>2]^d[a+8>>0]<<24^d[a+9>>0]<<16^d[a+10>>0]<<8^d[a+11>>0]^d[a+12>>0]<<24^d[a+13>>0]<<16^d[a+14>>0]<<8^d[a+15>>0]|0}function Xrg(a,b){a=a|0;b=b|0;return ((b|0)>9?87:48)+b&65535|0}function Yrg(e,f){e=e|0;f=f|0;var g=0,h=0,j=0;f=i;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;RI(1159264)|0;g=_wh(1159264,16)|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}RI(3080504)|0;h=c[(c[770149]|0)+16>>2]|0;Jag(0,h);RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}RI(3080504)|0;if(!(c[(c[770149]|0)+20>>2]|0)){j=jbg(0)|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}RI(3080504)|0;c[(c[770149]|0)+20>>2]=j}RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}RI(3080504)|0;$wh(2969088,c[(c[770149]|0)+20>>2]|0,g);Kag(0,h);Lrg(e,g);g=e+8|0;a[g>>0]=d[g>>0]&63|128;g=e+6|0;b[g>>1]=b[g>>1]&4095|16384;i=f;return}function Zrg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}acg(c,(d>>>0>2684354559?87:48)+(d>>>28)&65535)|0;e=d>>>24&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;e=d>>>20&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;e=d>>>16&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;e=d>>>12&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;e=d>>>8&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;e=d>>>4&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;e=d&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;i=b;return}function _rg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}e=d<<16>>16;d=e>>>12&15;acg(c,(d>>>0>9?87:48)+d&65535)|0;d=e>>>8&15;acg(c,(d>>>0>9?87:48)+d&65535)|0;d=e>>>4&15;acg(c,(d>>>0>9?87:48)+d&65535)|0;d=e&15;acg(c,(d>>>0>9?87:48)+d&65535)|0;i=b;return}function $rg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=i;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}acg(c,((d&255)>159?87:48)+((d&255)>>>4&255)&65535)|0;e=d&15;acg(c,(e>>>0>9?87:48)+e&65535)|0;i=b;return}function asg(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;RI(2971904)|0;j=qL(2971904)|0;Ueg(j,40);if(!f){if(g)acg(j,123)|0}else acg(j,40)|0;k=c[d>>2]|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}Zrg(0,j,k);if(e)acg(j,45)|0;k=b[d+4>>1]|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}_rg(0,j,k);if(e)acg(j,45)|0;k=b[d+6>>1]|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}_rg(0,j,k);if(e)acg(j,45)|0;k=a[d+8>>0]|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}$rg(0,j,k);$rg(0,j,a[d+9>>0]|0);if(e)acg(j,45)|0;e=a[d+10>>0]|0;RI(3080504)|0;if(!(a[3080652]|0)){RI(3080504)|0;Ywh(3080504)}$rg(0,j,e);$rg(0,j,a[d+11>>0]|0);$rg(0,j,a[d+12>>0]|0);$rg(0,j,a[d+13>>0]|0);$rg(0,j,a[d+14>>0]|0);$rg(0,j,a[d+15>>0]|0);if(f){acg(j,41)|0;l=Fqh(2972072,j)|0;i=h;return l|0}if(!g){l=Fqh(2972072,j)|0;i=h;return l|0}acg(j,125)|0;l=Fqh(2972072,j)|0;i=h;return l|0}function bsg(a){a=a|0;var b=0,c=0;b=i;c=asg(a,1,0,0)|0;i=b;return c|0}function csg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;kph();if(d){f=Xvf(d)|0;if(!(a[2540708]|0))Ywh(2540560);if(!(gpf(0,f,c[901990]|0)|0)){if(!(a[2540708]|0))Ywh(2540560);if(!(gpf(0,f,c[901992]|0)|0)){if(!(a[2540708]|0))Ywh(2540560);if(!(gpf(0,f,c[901994]|0)|0)){if(!(a[2540708]|0))Ywh(2540560);if(Iwf(0,f,c[901996]|0)|0){if(!(a[2540708]|0))Ywh(2540560);if(Iwf(0,f,c[c[635163]>>2]|0)|0){f=tof(0,c[901998]|0)|0;RI(3079480)|0;d=qL(3079480)|0;Hrg(d,f);Zwh(d)}else{g=1;h=0;j=0}}else{g=1;h=0;j=0}}else{g=0;h=0;j=0}}else{g=1;h=1;j=0}}else{g=1;h=0;j=1}}else{g=1;h=0;j=0}d=asg(b,g,h,j)|0;i=e;return d|0}function dsg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=csg(a,b)|0;i=c;return d|0}function esg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function fsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function gsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function hsg(a){a=a|0;var b=0;b=i;lph();Grg(a,tof(0,c[902056]|0)|0);i=b;return}function isg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function jsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ksg(a){a=a|0;var b=0;b=i;mph();Grg(a,tof(0,c[902074]|0)|0);KHf(a,-2147467262);i=b;return}function lsg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2147467262);i=c;return}function msg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function nsg(a){a=a|0;var b=0;b=i;nph();Grg(a,tof(0,c[902104]|0)|0);KHf(a,-2146233079);i=b;return}function osg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233079);i=c;return}function psg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;qsg(a,b,c);KHf(a,-2146233079);i=d;return}function qsg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GHf(a,b,c);KHf(a,-2146233087);i=d;return}function rsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ssg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function tsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[c[d>>2]>>2]=a;i=b;return}function usg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2615320)|0;c[c[d>>2]>>2]=a;i=b;return}function vsg(a,b){a=a|0;b=ea(b);var c=Im;if(!(b>=ea(0.0)))c=ea(-b);else c=b;return ea(c)}function wsg(a,b){a=a|0;b=b|0;var d=0,e=0;a=i;oph();if((b|0)==-2147483648){d=tof(0,c[902140]|0)|0;RI(3086272)|0;e=qL(3086272)|0;xsg(e,d);Zwh(e)}else{i=a;return ((b|0)>-1?b:0-b|0)|0}return 0}function xsg(a,b){a=a|0;b=b|0;var c=0;c=i;zig(a,b);KHf(a,-2146233066);i=c;return}function ysg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;pph();if((b|0)==0&(d|0)==-2147483648){e=tof(0,c[902154]|0)|0;RI(3086272)|0;f=qL(3086272)|0;xsg(f,e);Zwh(f)}else{f=(d|0)>-1|(d|0)==-1&b>>>0>4294967295;e=ZEi(0,0,b|0,d|0)|0;H=f?d:H;i=a;return (f?b:e)|0}return 0}function zsg(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0.0;a=i;d=c[771610]|0;if(!d){e=MK(3086448)|0;c[771610]=e;f=e}else f=d;g=+Xm[f&15](b);i=a;return +g}function Asg(a,b,c){a=a|0;b=b|0;c=c|0;return ((b|0)>(c|0)?b:c)|0}function Bsg(a,b,c){a=a|0;b=b|0;c=c|0;return ((b|0)<(c|0)?b:c)|0}function Csg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+272|0;f=d+240|0;g=d+176|0;h=d+96|0;j=d+112|0;k=d+48|0;l=d+160|0;m=d+192|0;n=d+224|0;o=d+256|0;p=d+32|0;q=d+16|0;r=d+128|0;s=d;t=d+64|0;u=d+144|0;v=d+80|0;w=d+208|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Ywh(2592872)};c[f+0>>2]=c[e+0>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];Nyf(j,0,f);c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];gzf(k,0,g,f);c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;byf(l,5,0,0,0,1);c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];if(Ezf(0,g,f)|0){c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;byf(m,20,0,0,0,1);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;byf(n,20,0,0,0,1);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Ywh(2592872)};c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];izf(o,0,g,f);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;byf(p,20,0,0,0,1);c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];izf(q,0,g,f);c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];Nyf(r,0,f);c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];gzf(s,0,g,f);c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[f+0>>2]=c[s+0>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];hzf(t,0,g,f);c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;cyf(u,0);c[g+0>>2]=c[t+0>>2];c[g+4>>2]=c[t+4>>2];c[g+8>>2]=c[t+8>>2];c[g+12>>2]=c[t+12>>2];c[f+0>>2]=c[u+0>>2];c[f+4>>2]=c[u+4>>2];c[f+8>>2]=c[u+8>>2];c[f+12>>2]=c[u+12>>2];if(!(Dzf(0,g,f)|0))x=7}else x=7;if((x|0)==7){c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;byf(v,5,0,0,0,1);RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Ywh(2592872)};c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[v+0>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];if(!(Fzf(0,g,f)|0)){i=d;return}}RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Ywh(2592872)};c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];fzf(w,0,f);c[b+0>>2]=c[w+0>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];c[b+12>>2]=c[w+12>>2];i=d;return}function Dsg(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0.0;a=i;d=c[771622]|0;if(!d){e=MK(3086496)|0;c[771622]=e;f=e}else f=d;g=+Xm[f&15](b);i=a;return +g}function Esg(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,h=0.0;a=i;e=c[771634]|0;if(!e){f=MK(3086544)|0;c[771634]=f;g=f}else g=e;h=+sn[g&3](b,d);i=a;return +h}function Fsg(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0.0;a=i;d=c[771648]|0;if(!d){e=MK(3086600)|0;c[771648]=e;f=e}else f=d;g=+Xm[f&15](b);i=a;return +g}function Gsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Hsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Isg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Jsg(a){a=a|0;var b=0;b=i;qph();Grg(a,tof(0,c[902158]|0)|0);KHf(a,-2146233062);i=b;return}function Ksg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Lsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Msg(a,b){a=a|0;b=b|0;var c=0;c=i;Nsg(a,b);KHf(a,-2146233071);i=c;return}function Nsg(a,b){a=a|0;b=b|0;var c=0;c=i;Brg(a,b);KHf(a,-2146233070);i=c;return}function Osg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;rph();e=b+52|0;if(!(c[e>>2]|0)){f=Psg(b)|0;i=d;return f|0}g=tof(0,c[902178]|0)|0;h=c[e>>2]|0;e=c[b+56>>2]|0;if(!(a[2540708]|0))Ywh(2540560);f=awf(0,g,h,e)|0;i=d;return f|0}function Psg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;sph();e=b+52|0;if(!(c[e>>2]|0)){f=MHf(b)|0;i=d;return f|0}g=tof(0,c[902196]|0)|0;h=c[e>>2]|0;e=c[b+56>>2]|0;if(!(a[2540708]|0))Ywh(2540560);f=awf(0,g,h,e)|0;i=d;return f|0}function Qsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Rsg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Jsg(a);c[a+52>>2]=b;c[a+56>>2]=d;KHf(a,-2146233070);i=e;return}function Ssg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;tph();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];THf(a,b,f);L7f(b,c[902214]|0,c[a+52>>2]|0);L7f(b,c[902216]|0,c[a+56>>2]|0);L7f(b,c[902218]|0,c[a+60>>2]|0);i=e;return}function Tsg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Usg(a){a=a|0;var b=0;b=i;vph();Nsg(a,tof(0,c[902258]|0)|0);KHf(a,-2146233069);i=b;return}function Vsg(a,b){a=a|0;b=b|0;var c=0;c=i;Nsg(a,b);KHf(a,-2146233069);i=c;return}function Wsg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Rsg(a,b,c);KHf(a,-2146233069);i=d;return}function Xsg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;uph();e=b+52|0;if(!(c[e>>2]|0)){f=Psg(b)|0;i=d;return f|0}g=tof(0,c[902240]|0)|0;h=c[e>>2]|0;e=c[b+56>>2]|0;if(!(a[2540708]|0))Ywh(2540560);f=awf(0,g,h,e)|0;i=d;return f|0}function Ysg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Zsg(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return}function _sg(a){a=a|0;return c[a+8>>2]|0}function $sg(a){a=a|0;return c[a+12>>2]|0}function atg(b){b=b|0;var d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[e>>2]=3440288;c[d+0>>2]=c[e+0>>2];e=npf(0,d)|0;RI(3090792)|0;c[(c[772721]|0)+4>>2]=e;RI(2539536)|0;e=qL(2539536)|0;wof(e,32767);RI(3090792)|0;c[(c[772721]|0)+8>>2]=e;i=b;return}function btg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+4|0;f=b;RI(2540728)|0;g=vL(d,2540728)|0;RI(3090984)|0;if(vL(g,3090984)|0){h=0;i=b;return h|0}RI(2837096)|0;if(vL(g,2837096)|0){h=0;i=b;return h|0}RI(2540728)|0;if(vL(d,2540728)|0){h=1;i=b;return h|0}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}RI(3090792)|0;if(!(c[c[772721]>>2]|0)){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[f>>2]=3431160;c[e+0>>2]=c[f+0>>2];f=rth(2652848,npf(0,e)|0)|0;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}RI(3090792)|0;c[c[772721]>>2]=f}f=rth(2652848,Xnf(d)|0)|0;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}RI(3090792)|0;h=(f|0)!=(c[c[772721]>>2]|0);i=b;return h|0}function ctg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[772788]|0;if(!f){g=MK(3091160)|0;c[772788]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function dtg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;RI(2873528)|0;do if(!(vL(b,2873528)|0)){RI(2828024)|0;if(vL(b,2828024)|0){RI(2828024)|0;e=w1f(axh(b,2828024)|0)|0;break}RI(2819760)|0;if(vL(b,2819760)|0){RI(2819760)|0;e=O4f(axh(b,2819760)|0)|0;break}RI(2540728)|0;if(!(vL(b,2540728)|0)){f=0;i=a;return f|0}else{RI(2540728)|0;e=sHf(axh(b,2540728)|0)|0;break}}else{RI(2873528)|0;e=H3f(axh(b,2873528)|0)|0}while(0);if(!((d|0)!=0&(e|0)!=0)){f=e;i=a;return f|0}b=e+12|0;a:do if((c[b>>2]|0)>0){g=e+16|0;h=0;while(1){j=Yuh(2651232,d,Xnf(c[g+(da(c[(c[e>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0)|0;k=c[b>>2]|0;if(j){l=k;m=h;break}h=h+1|0;if((h|0)>=(k|0))break a}if((l|0)==1){f=e;i=a;return f|0}RI(1086352)|0;h=_wh(1086352,1)|0;Qqh(h,c[g+(da(c[(c[e>>2]|0)+120>>2]|0,m)|0)>>2]|0);c[h+16>>2]=c[g+(da(c[(c[e>>2]|0)+120>>2]|0,m)|0)>>2];f=h;i=a;return f|0}while(0);RI(1086352)|0;f=_wh(1086352,0)|0;i=a;return f|0}function etg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}if(btg(0,d)|0)f=bxh(2659568,d,e,1)|0;else{RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}f=ctg(0,d,e,0)|0}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}g=dtg(0,d,e)|0;if(!g){h=f;i=b;return h|0}RI(1086352)|0;e=f+12|0;d=g+12|0;j=_wh(1086352,(c[d>>2]|0)+(c[e>>2]|0)|0)|0;vEf(0,f,j,c[e>>2]|0);wEf(0,g,0,j,c[e>>2]|0,c[d>>2]|0);h=j;i=b;return h|0}function ftg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;wph();RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}g=gtg(0,d,e,f)|0;f=c[g+12>>2]|0;if(!f){h=0;i=b;return h|0}if((f|0)<2){f=c[g+16>>2]|0;RI(2538488)|0;h=axh(f,2538488)|0;i=b;return h|0}h=c[902280]|0;if(!(a[2540708]|0))Ywh(2540560);b=awf(0,h,d,e)|0;RI(2836344)|0;e=qL(2836344)|0;L$f(e,b);Zwh(e);return 0}function gtg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+16|0;g=b+8|0;h=b+4|0;j=b;xph();if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[902308]|0);Zwh(k)}if(!e){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[902310]|0);Zwh(k)}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[h>>2]=3452144;c[g+0>>2]=c[h+0>>2];h=(npf(0,g)|0)==(e|0);k=h?0:e;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}e=etg(0,d,k)|0;if(!f?(c[e+12>>2]|0)==1:0){h=e+16|0;l=Xnf(c[h>>2]|0)|0;if(!k){m=gEf(0,l,1)|0;RI(1086352)|0;n=axh(m,1086352)|0;Qqh(n,c[h>>2]|0);c[n+16>>2]=c[h>>2];o=n;i=b;return o|0}if(Yuh(2651232,k,l)|0){l=gEf(0,k,1)|0;RI(1086352)|0;n=axh(l,1086352)|0;Qqh(n,c[h>>2]|0);c[n+16>>2]=c[h>>2];o=n;i=b;return o|0}else{n=gEf(0,k,0)|0;RI(1086352)|0;o=axh(n,1086352)|0;i=b;return o|0}}n=(k|0)!=0;if(n?(Gqh(2653744,k)|0)&f:0){RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}p=Fpf(htg(0,k)|0)|0}else p=f;f=c[e+12>>2]|0;h=(f|0)<16?f:16;RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Ywh(2730168)}RI(2730168)|0;f=qL(2730168)|0;rPf(f,h);RI(2713640)|0;if(!(a[2713788]|0)){RI(2713640)|0;Ywh(2713640)}RI(2713640)|0;l=qL(2713640)|0;ZMf(l,h);h=e;e=d;d=0;while(1){m=h+12|0;if((c[m>>2]|0)>0){q=h+16|0;r=(d|0)==0;s=d;t=0;do{u=c[q+(da(c[(c[h>>2]|0)+120>>2]|0,t)|0)>>2]|0;v=Xnf(u)|0;if(!(n?!(Yuh(2651232,k,v)|0):0))w=29;do if((w|0)==29){w=0;x=uth(2736488,f,v)|0;RI(3090256)|0;y=axh(x,3090256)|0;x=(y|0)!=0;if(x)z=c[y+8>>2]|0;else{RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}z=htg(0,v)|0}if(!(!r?!(Fpf(z)|0):0)){if(x&((Epf(z)|0)^1)?(c[y+12>>2]|0)!=(d|0):0)break;Erh(2714056,l,u)|0}if(!x){RI(3090256)|0;x=qL(3090256)|0;c[x+8>>2]=z;c[x+12>>2]=s;Rrh(2734016,f,v,x)}}while(0);t=t+1|0}while((t|0)<(c[m>>2]|0))}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}e=itg(0,e)|0;if(!e)break;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}h=etg(0,e,k)|0;if(!p)break;else d=d+1|0}if(n?!(Gqh(2650144,k)|0):0){n=gEf(0,k,Aqh(2713056,l)|0)|0;RI(1086352)|0;A=vL(n,1086352)|0}else{RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[j>>2]=3439928;c[g+0>>2]=c[j+0>>2];j=npf(0,g)|0;g=gEf(0,j,Aqh(2713056,l)|0)|0;RI(1086352)|0;A=axh(g,1086352)|0}Csh(2714672,l,A,0);o=A;i=b;return o|0}function htg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;Aph();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[f>>2]=3440288;c[e+0>>2]=c[f+0>>2];if((npf(0,e)|0)==(d|0)){RI(2539536)|0;e=qL(2539536)|0;wof(e,4);g=e;i=b;return g|0}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}RI(3090792)|0;e=gtg(0,d,c[(c[772721]|0)+4>>2]|0,0)|0;f=c[e+12>>2]|0;if(f){if((f|0)>=2){RI(3079480)|0;f=qL(3079480)|0;Hrg(f,c[902330]|0);Zwh(f)}f=c[e+16>>2]|0;RI(2539536)|0;g=axh(f,2539536)|0;i=b;return g|0}if(suh(2651176,d)|0){f=suh(2651176,d)|0;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}d=htg(0,f)|0;if(d){g=d;i=b;return g|0}}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}RI(3090792)|0;g=c[(c[772721]|0)+8>>2]|0;i=b;return g|0}function itg(b,c){b=b|0;c=c|0;var d=0,e=0;b=i;if(!c){d=0;i=b;return d|0}RI(2540728)|0;if(vL(c,2540728)|0){RI(2540728)|0;d=suh(2651176,axh(c,2540728)|0)|0;i=b;return d|0}RI(2882896)|0;if(vL(c,2882896)|0){RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}RI(2882896)|0;d=mtg(0,axh(c,2882896)|0)|0;i=b;return d|0}RI(2873528)|0;if(!(vL(c,2873528)|0)){d=0;i=b;return d|0}RI(2834864)|0;e=axh(c,2834864)|0;if(!e){d=0;i=b;return d|0}if(Gqh(2864376,e)|0){c=cxh(2866360,e)|0;i=b;return ((c|0)==(e|0)?0:c)|0}else{d=0;i=b;return d|0}return 0}function jtg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;i=i+16|0;f=b+4|0;g=b;yph();if(!d){RI(2963920)|0;h=qL(2963920)|0;Iag(h,c[902322]|0);Zwh(h)}if(!e){RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}e=bth(2628880,etg(0,d,0)|0)|0;RI(1086352)|0;j=axh(e,1086352)|0;i=b;return j|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[g>>2]=3452144;c[f+0>>2]=c[g+0>>2];g=npf(0,f)|0;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}j=gtg(0,d,g,1)|0;i=b;return j|0}function ktg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;zph();if(!e){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[902326]|0);Zwh(g)}g=d;a:while(1){RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}if(btg(0,g)|0){h=g;j=7;break}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}if(ltg(0,g,e)|0){k=1;j=25;break}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}d=dtg(0,g,e)|0;if((d|0)!=0?(l=d+12|0,(c[l>>2]|0)>0):0){m=d+16|0;n=0;do{if(Yuh(2651232,e,Xnf(c[m+(da(c[(c[d>>2]|0)+120>>2]|0,n)|0)>>2]|0)|0)|0){k=1;j=25;break a}n=n+1|0}while((n|0)<(c[l>>2]|0))}if(!f){k=0;j=25;break}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}l=itg(0,g)|0;if(!l){k=0;j=25;break}RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}zph();g=l}if((j|0)==7){k=dxh(2659648,h,e,f)|0;i=b;return k|0}else if((j|0)==25){i=b;return k|0}return 0}function ltg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;e=c[772822]|0;if(!e){f=MK(3091296)|0;c[772822]=f;g=f}else g=e;e=_n[g&4095](b,d)|0;i=a;return e|0}function mtg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;d=Vvh(2888160,b,1)|0;if((d|0)!=0?Gqh(2864376,d)|0:0)e=d;else{d=Vvh(2888232,b,1)|0;if(!d){f=0;i=a;return f|0}else e=d}if(!(Gqh(2864376,e)|0)){f=0;i=a;return f|0}d=cxh(2866360,e)|0;if((d|0)==0|(d|0)==(e|0)){f=0;i=a;return f|0}e=xuh(2849608,b)|0;if((e|0)!=0?(g=e+12|0,(c[g>>2]|0)>=1):0){RI(1104624)|0;h=_wh(1104624,c[g>>2]|0)|0;g=h+12|0;if((c[g>>2]|0)>0){j=e+16|0;k=h+16|0;l=0;do{m=suh(2849496,c[j+(da(c[(c[e>>2]|0)+120>>2]|0,l)|0)>>2]|0)|0;Qqh(h,m);c[k+(da(c[(c[h>>2]|0)+120>>2]|0,l)|0)>>2]=m;l=l+1|0}while((l|0)<(c[g>>2]|0))}g=suh(2658656,d)|0;l=Fqh(2649752,b)|0;f=exh(2655944,g,l,suh(2849664,b)|0,h)|0;i=a;return f|0}h=suh(2658656,d)|0;d=Fqh(2649752,b)|0;f=fxh(2655848,h,d,suh(2849664,b)|0)|0;i=a;return f|0}function ntg(a){a=a|0;return}function otg(a){a=a|0;return}function ptg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;a=i;d=c[773372]|0;if(!d){e=MK(3093496)|0;c[773372]=e;f=e}else f=d;d=mo[f&4095](b)|0;i=a;return d|0}function qtg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+12|0;f=c[e>>2]|0;if(!f){RI(3093136)|0;g=qL(3093136)|0;c[e>>2]=g;h=g}else h=f;f=h+12|0;h=c[f>>2]|0;if(h){j=h;i=d;return j|0}RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}RI(2540728)|0;h=bvh(2651672,b,52,0,3,c[(c[635205]|0)+8>>2]|0,0)|0;c[f>>2]=h;j=h;i=d;return j|0}function rtg(a){a=a|0;var b=0,c=0;b=i;c=ptg(0,a)|0;i=b;return c|0}function stg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;k=(d|0)==0?20:d;d=Kvh(3093544,b,k)|0;b=d+12|0;if((c[b>>2]|0)<=0){l=0;i=j;return l|0}m=d+16|0;n=(f|0)==3;o=0;p=0;q=0;while(1){r=c[m+(da(c[(c[d>>2]|0)+120>>2]|0,q)|0)>>2]|0;if(!n?((Aqh(2836512,r)|0)&f|0)!=(f|0):0){s=o;t=p}else{s=r;t=p+1|0}q=q+1|0;if((q|0)>=(c[b>>2]|0)){u=s;v=t;break}else{o=s;p=t}}if(!v){l=0;i=j;return l|0}if(!g){if((v|0)>=2){RI(2836344)|0;t=qL(2836344)|0;W_f(t);Zwh(t)}RI(2819928)|0;l=axh(u,2819928)|0;i=j;return l|0}RI(1177072)|0;t=_wh(1177072,v)|0;if((v|0)!=1){if((c[b>>2]|0)>0){v=d+16|0;p=(f|0)==3;s=t+16|0;o=0;q=0;while(1){n=c[v+(da(c[(c[d>>2]|0)+120>>2]|0,q)|0)>>2]|0;if(!p?((Aqh(2836512,n)|0)&f|0)!=(f|0):0)w=o;else{Qqh(t,n);c[s+(da(c[(c[t>>2]|0)+120>>2]|0,o)|0)>>2]=n;w=o+1|0}q=q+1|0;if((q|0)>=(c[b>>2]|0))break;else o=w}}}else{Qqh(t,u);c[t+16>>2]=u}if(!e){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Ywh(2836568)}x=X_f(0)|0}else x=e;e=Pvh(2836736,x,k,t,g,h)|0;RI(2819928)|0;l=axh(e,2819928)|0;i=j;return l|0}function ttg(a,b){a=a|0;b=b|0;return b|0}function utg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[773400]|0;if(!f){g=MK(3093608)|0;c[773400]=g;h=g}else h=f;f=xo[h&2047](a,b,d)|0;i=e;return f|0}function vtg(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=utg(a,b,a)|0;i=c;return d|0}function wtg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[773424]|0;if(!f){g=MK(3093704)|0;c[773424]=g;h=g}else h=f;f=xo[h&2047](a,b,d)|0;i=e;return f|0}function xtg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773444]|0;if(!d){e=MK(3093784)|0;c[773444]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function ytg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=c[773456]|0;if(!h){j=MK(3093832)|0;c[773456]=j;k=j}else k=h;h=Bn[k&255](a,b,d,e,f)|0;i=g;return h|0}function ztg(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ytg(a,0,b,0,a)|0;i=c;return d|0}function Atg(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;l=ytg(b,d,e,(e&1|0)!=0,b)|0;b=l+12|0;if((c[b>>2]|0)<=0){m=0;i=k;return m|0}d=l+16|0;n=(g|0)==3;o=0;p=0;q=0;while(1){r=c[d+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0;if(!n?((Aqh(2836512,r)|0)&g|0)!=(g|0):0){s=o;t=p}else{s=r;t=p+1|0}q=q+1|0;if((q|0)>=(c[b>>2]|0)){u=s;v=t;break}else{o=s;p=t}}if(!v){m=0;i=k;return m|0}t=(v|0)!=1;p=(h|0)!=0;if(!(t|p)){RI(2834864)|0;m=axh(u,2834864)|0;i=k;return m|0}RI(1177072)|0;s=_wh(1177072,v)|0;if(t){if((c[b>>2]|0)>0){t=l+16|0;v=(g|0)==3;o=s+16|0;q=0;n=0;while(1){d=c[t+(da(c[(c[l>>2]|0)+120>>2]|0,q)|0)>>2]|0;if(!v?((Aqh(2836512,d)|0)&g|0)!=(g|0):0)w=n;else{Qqh(s,d);c[o+(da(c[(c[s>>2]|0)+120>>2]|0,n)|0)>>2]=d;w=n+1|0}q=q+1|0;if((q|0)>=(c[b>>2]|0))break;else n=w}}}else{Qqh(s,u);c[s+16>>2]=u}if(!p){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Ywh(2836568)}p=h$f(0,s)|0;RI(2834864)|0;m=axh(p,2834864)|0;i=k;return m|0}if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Ywh(2836568)}x=X_f(0)|0}else x=f;f=Pvh(2836736,x,e,s,h,j)|0;RI(2834864)|0;m=axh(f,2834864)|0;i=k;return m|0}function Btg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=c[773486]|0;if(!h){j=MK(3093952)|0;c[773486]=j;k=j}else k=h;h=Bn[k&255](a,b,d,e,f)|0;i=g;return h|0}function Ctg(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;l=Btg(b,d,e,(e&1|0)!=0,b)|0;b=c[l+12>>2]|0;if((b|0)==1)m=2;else if(!b){n=0;i=k;return n|0}do if((m|0)==2){if((h|0)!=0?(c[h+12>>2]|0)!=0:0)break;b=l+16|0;if((g|0)!=0?(suh(2849664,c[b>>2]|0)|0)!=(g|0):0)break;n=c[b>>2]|0;i=k;return n|0}while(0);if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Ywh(2836568)}o=X_f(0)|0}else o=f;n=gxh(2852464,o,e,l,g,h,j)|0;i=k;return n|0}function Dtg(a){a=a|0;var b=0,c=0;b=i;if(!(Gqh(3094064,a)|0)?!(Gqh(3094120,a)|0):0)c=Gqh(3094176,a)|0;else c=1;i=b;return c|0}function Etg(b){b=b|0;var c=0,d=0;c=i;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}d=bHf(0,b)|0;i=c;return d|0}function Ftg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773558]|0;if(!d){e=MK(3094240)|0;c[773558]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Gtg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773568]|0;if(!d){e=MK(3094280)|0;c[773568]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Htg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773580]|0;if(!d){e=MK(3094328)|0;c[773580]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Itg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Bph();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[902372]|0);Zwh(e)}else{e=SGf(a,b)|0;i=d;return e|0}return 0}function Jtg(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;m=i;i=i+48|0;n=m+36|0;o=m+16|0;p=m;q=m+28|0;r=m+32|0;s=m+40|0;t=m+12|0;u=m+24|0;v=m+20|0;w=m+8|0;x=m+4|0;c[o>>2]=h;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;Cph();if(!(e&512)){if(!d){RI(2963920)|0;y=qL(2963920)|0;Iag(y,c[902378]|0);Zwh(y)}}else if(e&13312){RI(2965048)|0;y=qL(2965048)|0;Rbg(y,c[902376]|0);Zwh(y)}y=(e&2048|0)==0;if((e&3072|0)==3072){RI(2965048)|0;z=qL(2965048)|0;Rag(z,c[902380]|0,c[902382]|0);Zwh(z)}z=(e&8192|0)==0;if((e&12288|0)==12288){RI(2965048)|0;A=qL(2965048)|0;Rag(A,c[902384]|0,c[902386]|0);Zwh(A)}if(e&256){if(!y){RI(2965048)|0;y=qL(2965048)|0;Rag(y,c[902388]|0,c[902390]|0);Zwh(y)}if(!z){RI(2965048)|0;z=qL(2965048)|0;Rag(z,c[902392]|0,c[902394]|0);Zwh(z)}}if(l){if(!h){RI(2965048)|0;B=qL(2965048)|0;C=c[902396]|0;Rbg(B,C);Zwh(B)}if((c[h+12>>2]|0)<(c[l+12>>2]|0)){RI(2965048)|0;B=qL(2965048)|0;C=c[902396]|0;Rbg(B,C);Zwh(B)}}if(!(e&16128)){RI(2965048)|0;B=qL(2965048)|0;Rag(B,c[902398]|0,c[902400]|0);Zwh(B)}B=(e&48|0)==0?e|16:e;e=(B&12|0)==0?B|12:B;if(!f){RI(2836568)|0;if(!(a[2836716]|0)){RI(2836568)|0;Ywh(2836568)}D=X_f(0)|0}else D=f;if(e&512){f=e|2;B=Kvh(3093544,b,f)|0;c[p>>2]=0;C=hxh(2852176,D,f,B,o,j,k,l,p)|0;if(C){B=Yvh(2863088,C,g,f,D,c[o>>2]|0,k)|0;ixh(2852296,D,o,c[p>>2]|0);E=B;i=m;return E|0}B=(Gqh(2650144,b)|0)^1;if(!((c[o>>2]|0)!=0|B)){E=Xhg(0,b)|0;i=m;return E|0}B=Fqh(3094368,b)|0;if(a[2540708]|0){F=c[902402]|0;G=c[902404]|0;H=iwf(0,F,B,G)|0;RI(3089608)|0;I=qL(3089608)|0;Vsg(I,H);Zwh(I)}Ywh(2540560);F=c[902402]|0;G=c[902404]|0;H=iwf(0,F,B,G)|0;RI(3089608)|0;I=qL(3089608)|0;Vsg(I,H);Zwh(I)}if(!(a[2540708]|0))Ywh(2540560);if(gpf(0,d,c[c[635163]>>2]|0)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[t>>2]=3443096;c[n+0>>2]=c[t+0>>2];if(rof(0,b,npf(0,n)|0)|0){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[u>>2]=3443096;c[n+0>>2]=c[u+0>>2];u=mof(0,b,npf(0,n)|0)|0;RI(2584640)|0;J=GIf(axh(u,2584640)|0)|0}else J=d}else J=d;do if(!(e&256))K=0;else{d=ytg(b,J,e,(e&1|0)!=0,b)|0;c[q>>2]=0;if(!(c[o>>2]|0)){RI(1086352)|0;c[o>>2]=_wh(1086352,0)|0}u=hxh(2852176,D,e,d,o,j,k,l,q)|0;if(!u){t=(a[2540708]|0)!=0;if((c[d+12>>2]|0)<1){if(!t)Ywh(2540560);K=iwf(0,c[902410]|0,J,c[902412]|0)|0;break}else{if(!t)Ywh(2540560);K=iwf(0,c[902406]|0,J,c[902408]|0)|0;break}}t=xuh(2849384,u)|0;d=t+12|0;if((c[d>>2]|0)>0){I=t+16|0;H=0;while(1){RI(2867160)|0;if(!(a[2867308]|0)){RI(2867160)|0;Ywh(2867160)}RI(2867160)|0;G=c[o>>2]|0;if((c[c[716813]>>2]|0)==(c[G+16+(da(c[(c[G>>2]|0)+120>>2]|0,H)|0)>>2]|0)?((Aqh(2885632,c[I+(da(c[(c[t>>2]|0)+120>>2]|0,H)|0)>>2]|0)|0)&4096|0)==0:0){L=58;break}H=H+1|0;G=c[d>>2]|0;if((H|0)>=(G|0)){M=G;break}}if((L|0)==58){RI(2965048)|0;H=qL(2965048)|0;Rag(H,c[902414]|0,c[902416]|0);Zwh(H)}if((M|0)>=1){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[v>>2]=3442848;c[n+0>>2]=c[v+0>>2];H=npf(0,n)|0;if(pof(0,c[t+16+(da(c[(c[t>>2]|0)+120>>2]|0,(c[d>>2]|0)+-1|0)|0)>>2]|0,H)|0)Ktg(0,o,u)}}H=Yvh(2863088,u,g,e,D,c[o>>2]|0,k)|0;ixh(2852296,D,o,c[q>>2]|0);E=H;i=m;return E|0}while(0);do if(!(e&1024))if(!(e&2048))N=0;else{q=Mvh(3094424,b,J,e)|0;if(!q){N=(e&8192|0)==0;break}v=c[o>>2]|0;if(!v){RI(2963920)|0;M=qL(2963920)|0;Iag(M,c[902418]|0);Zwh(M)}if((c[v+12>>2]|0)!=1){RI(2965048)|0;M=qL(2965048)|0;Rag(M,c[902420]|0,c[902422]|0);Zwh(M)}Rrh(2859648,q,g,c[v+16>>2]|0);E=0;i=m;return E|0}else{v=Mvh(3094424,b,J,e)|0;if(!v){N=(e&4096|0)==0;break}E=uth(2859264,v,g)|0;i=m;return E|0}while(0);if(!(e&4096))if(e&8192){v=Btg(b,J,e,(e&1|0)!=0,b)|0;c[s>>2]=0;q=v+12|0;if((c[q>>2]|0)>0){M=v+16|0;L=0;H=0;while(1){I=((Vvh(2888232,c[M+(da(c[(c[v>>2]|0)+120>>2]|0,L)|0)>>2]|0,1)|0)!=0&1)+H|0;L=L+1|0;if((L|0)>=(c[q>>2]|0)){O=I;break}else H=I}}else O=0;RI(1177072)|0;H=_wh(1177072,O)|0;if((c[q>>2]|0)>0){O=v+16|0;L=H+16|0;M=0;I=0;while(1){G=Vvh(2888232,c[O+(da(c[(c[v>>2]|0)+120>>2]|0,M)|0)>>2]|0,1)|0;if(!G)P=I;else{Qqh(H,G);c[L+(da(c[(c[H>>2]|0)+120>>2]|0,I)|0)>>2]=G;P=I+1|0}M=M+1|0;if((M|0)>=(c[q>>2]|0))break;else I=P}}P=hxh(2852176,D,e,H,o,j,k,l,s)|0;if(!P)Q=1;else{H=xuh(2849384,P)|0;I=H+12|0;do if((c[I>>2]|0)>=1){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[x>>2]=3442848;c[n+0>>2]=c[x+0>>2];q=npf(0,n)|0;if(!(pof(0,c[H+16+(da(c[(c[H>>2]|0)+120>>2]|0,(c[I>>2]|0)+-1|0)|0)>>2]|0,q)|0))break;Ktg(0,o,P)}while(0);I=Yvh(2863088,P,g,e,D,c[o>>2]|0,k)|0;ixh(2852296,D,o,c[s>>2]|0);E=I;i=m;return E|0}}else Q=N;else{N=Btg(b,J,e,(e&1|0)!=0,b)|0;c[r>>2]=0;b=N+12|0;if((c[b>>2]|0)>0){I=N+16|0;s=0;P=0;while(1){H=((Vvh(2888160,c[I+(da(c[(c[N>>2]|0)+120>>2]|0,s)|0)>>2]|0,1)|0)!=0&1)+P|0;s=s+1|0;if((s|0)>=(c[b>>2]|0)){R=H;break}else P=H}}else R=0;RI(1177072)|0;P=_wh(1177072,R)|0;if((c[b>>2]|0)>0){R=N+16|0;s=P+16|0;I=0;H=0;while(1){x=Vvh(2888160,c[R+(da(c[(c[N>>2]|0)+120>>2]|0,I)|0)>>2]|0,1)|0;if(!x)S=H;else{Qqh(P,x);c[s+(da(c[(c[P>>2]|0)+120>>2]|0,H)|0)>>2]=x;S=H+1|0}I=I+1|0;if((I|0)>=(c[b>>2]|0))break;else H=S}}S=hxh(2852176,D,e,P,o,j,k,l,r)|0;if(!S)Q=1;else{l=xuh(2849384,S)|0;j=l+12|0;do if((c[j>>2]|0)>=1){RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[w>>2]=3442848;c[n+0>>2]=c[w+0>>2];P=npf(0,n)|0;if(!(pof(0,c[l+16+(da(c[(c[l>>2]|0)+120>>2]|0,(c[j>>2]|0)+-1|0)|0)>>2]|0,P)|0))break;Ktg(0,o,S)}while(0);j=Yvh(2863088,S,g,e,D,c[o>>2]|0,k)|0;ixh(2852296,D,o,c[r>>2]|0);E=j;i=m;return E|0}}if(K){RI(3089608)|0;j=qL(3089608)|0;Vsg(j,K);Zwh(j)}if(!Q){E=0;i=m;return E|0}if(a[2540708]|0){T=c[902424]|0;U=c[902426]|0;V=iwf(0,T,J,U)|0;RI(3088344)|0;W=qL(3088344)|0;Msg(W,V);Zwh(W)}Ywh(2540560);T=c[902424]|0;U=c[902426]|0;V=iwf(0,T,J,U)|0;RI(3088344)|0;W=qL(3088344)|0;Msg(W,V);Zwh(W);return 0}function Ktg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a=i;e=xuh(2849384,d)|0;RI(1086352)|0;d=e+12|0;f=_wh(1086352,c[d>>2]|0)|0;g=suh(2619720,suh(2849496,c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,(c[d>>2]|0)+-1|0)|0)>>2]|0)|0)|0;e=gEf(0,g,(c[(c[b>>2]|0)+12>>2]|0)+1-(c[d>>2]|0)|0)|0;g=c[b>>2]|0;h=f+16|0;if((c[g+12>>2]|0)>0){j=g;k=0;l=0}else{Qqh(f,e);m=c[d>>2]|0;n=m+-1|0;o=c[f>>2]|0;p=o+120|0;q=c[p>>2]|0;r=da(q,n)|0;s=h+r|0;c[s>>2]=e;c[b>>2]=f;i=a;return}while(1){g=c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,l)|0)>>2]|0;if((l|0)<((c[d>>2]|0)+-1|0)){Qqh(f,g);t=c[b>>2]|0;u=c[t+16+(da(c[(c[t>>2]|0)+120>>2]|0,l)|0)>>2]|0;c[h+(da(c[(c[f>>2]|0)+120>>2]|0,l)|0)>>2]=u;v=k}else{bEf(e,g,k);v=k+1|0}l=l+1|0;j=c[b>>2]|0;if((l|0)>=(c[j+12>>2]|0))break;else k=v}Qqh(f,e);m=c[d>>2]|0;n=m+-1|0;o=c[f>>2]|0;p=o+120|0;q=c[p>>2]|0;r=da(q,n)|0;s=h+r|0;c[s>>2]=e;c[b>>2]=f;i=a;return}function Ltg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773620]|0;if(!d){e=MK(3094488)|0;c[773620]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Mtg(a){a=a|0;return a|0}function Ntg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773632]|0;if(!d){e=MK(3094536)|0;c[773632]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Otg(a){a=a|0;var b=0,c=0;b=i;c=Ptg(a,1,1)|0;i=b;return c|0}function Ptg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[773642]|0;if(!f){g=MK(3094576)|0;c[773642]=g;h=g}else h=f;f=xo[h&2047](a,b,d)|0;i=e;return f|0}function Qtg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773660]|0;if(!d){e=MK(3094648)|0;c[773660]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Rtg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a+12|0;e=c[d>>2]|0;if(!e){RI(3093136)|0;f=qL(3093136)|0;c[d>>2]=f;g=f}else g=e;e=g+8|0;g=c[e>>2]|0;if(g){h=g;i=b;return h|0}g=Ptg(a,1,0)|0;c[e>>2]=g;h=g;i=b;return h|0}function Stg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}f=ktg(0,b,c,d)|0;i=e;return f|0}function Ttg(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;RI(3090792)|0;if(!(a[3090940]|0)){RI(3090792)|0;Ywh(3090792)}e=jtg(0,b,c)|0;i=d;return e|0}function Utg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;Dph();if(!d){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[902736]|0);Zwh(g)}RI(3090792)|0;if(a[3090940]|0){h=gtg(0,b,d,e)|0;i=f;return h|0}RI(3090792)|0;Ywh(3090792);h=gtg(0,b,d,e)|0;i=f;return h|0}function Vtg(a){a=a|0;var b=0,c=0;b=i;if((suh(3094680,a)|0)!=0?!(Gqh(3094736,a)|0):0){c=128;i=b;return c|0}c=32;i=b;return c|0}function Wtg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773698]|0;if(!d){e=MK(3094800)|0;c[773698]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Xtg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773708]|0;if(!d){e=MK(3094840)|0;c[773708]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Ytg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773720]|0;if(!d){e=MK(3094888)|0;c[773720]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function Ztg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773730]|0;if(!d){e=MK(3094928)|0;c[773730]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function _tg(a){a=a|0;var b=0,c=0;b=i;c=suh(3094680,a)|0;i=b;return c|0}function $tg(a){a=a|0;return c[a+8>>2]|0}function aug(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];bug(0,a,b,f);i=e;return}function bug(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;f=i;i=i+16|0;b=f+4|0;g=f;kqh();h=Fqh(2537592,d)|0;L7f(e,c[903426]|0,h);r9f(e,c[903428]|0,4);h=Fqh(2836288,rth(2652848,d)|0)|0;L7f(e,c[903430]|0,h);RI(2540728)|0;if(a[2540876]|0){c[g>>2]=3452624;c[b+0>>2]=c[g+0>>2];j=npf(0,b)|0;p9f(e,j);i=f;return}RI(2540728)|0;Ywh(2540728);c[g>>2]=3452624;c[b+0>>2]=c[g+0>>2];j=npf(0,b)|0;p9f(e,j);i=f;return}function cug(a){a=a|0;var b=0,c=0;b=i;c=Ptg(a,0,0)|0;i=b;return c|0}function dug(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773742]|0;if(!d){e=MK(3094976)|0;c[773742]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function eug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;if(Gqh(3094736,a)|0){d=1;i=b;return d|0}a:do if(Gqh(2657008,a)|0?(e=cvh(3095016,a)|0,f=e+12|0,(c[f>>2]|0)>0):0){g=e+16|0;h=0;while(1){if(Gqh(2619552,c[g+(da(c[(c[e>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0){d=1;break}h=h+1|0;if((h|0)>=(c[f>>2]|0))break a}i=b;return d|0}while(0);if(!(Gqh(2652984,a)|0)){d=0;i=b;return d|0}d=Gqh(2619552,suh(3095072,a)|0)|0;i=b;return d|0}function fug(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[773782]|0;if(!d){e=MK(3095136)|0;c[773782]=e;f=e}else f=d;d=mo[f&4095](a)|0;i=b;return d|0}function gug(a){a=a|0;var b=0,c=0;b=i;c=lHf(a)|0;if(!c){RI(3084976)|0;a=qL(3084976)|0;nsg(a);Zwh(a)}else{i=b;return c|0}return 0}function hug(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);i=c;return}function iug(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function jug(a){a=a|0;return}function kug(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,256);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function lug(a){a=a|0;var b=0;b=i;Eph();Grg(a,tof(0,c[902740]|0)|0);KHf(a,-2147467263);i=b;return}function mug(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2147467263);i=c;return}function nug(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function oug(a){a=a|0;var b=0;b=i;Fph();Grg(a,tof(0,c[902766]|0)|0);KHf(a,-2146233067);i=b;return}function pug(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233067);i=c;return}function qug(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function rug(a){a=a|0;var b=0;b=i;Gph();Grg(a,tof(0,c[902784]|0)|0);KHf(a,-2147467261);i=b;return}function sug(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2147467261);i=c;return}function tug(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function uug(b){b=b|0;c[b+16>>2]=-1;a[b+48>>0]=1;return}function vug(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;RI(1101728)|0;j=_wh(1101728,3)|0;a:do if((Vof(d)|0)>0){k=j+16|0;l=0;m=0;n=0;o=0;b:while(1){p=Wof(d,o)|0;do if(p<<16>>16!=n<<16>>16)if(!(n<<16>>16))if(!(p<<16>>16==39|p<<16>>16==34))if((Wof(d,o)|0)<<16>>16==59){if((o|0)!=0?(Wof(d,o+-1|0)|0)<<16>>16==92:0){q=l;r=m;s=0;break}t=l+1|0;c[k+(da(c[(c[j>>2]|0)+120>>2]|0,l)|0)>>2]=o-m;if((t|0)==3)break b;else{q=t;r=o+1|0;s=0}}else{q=l;r=m;s=0}else u=5;else{q=l;r=m;s=n}else u=5;while(0);if((u|0)==5){u=0;q=l;r=m;s=n<<16>>16==0?p:0}o=o+1|0;if((o|0)>=(Vof(d)|0)){v=q;u=12;break}else{l=q;m=r;n=s}}do if((u|0)==12)if(!v)break a;else if((v|0)==3)break;else if((v|0)==2){if(f){n=j+16|0;c[g>>2]=(c[n>>2]|0)+2+(c[n+(c[(c[j>>2]|0)+120>>2]|0)>>2]|0);n=Vof(d)|0;c[h>>2]=n-(c[g>>2]|0);i=b;return}if(a[e>>0]|0){c[g>>2]=0;c[h>>2]=c[j+16>>2];i=b;return}n=j+16|0;if((c[n+(c[(c[j>>2]|0)+120>>2]|0)>>2]|0)<1){c[g>>2]=0;c[h>>2]=c[n>>2];i=b;return}else{a[e>>0]=1;c[g>>2]=(c[n>>2]|0)+1;c[h>>2]=c[n+(c[(c[j>>2]|0)+120>>2]|0)>>2];i=b;return}}else if((v|0)==1){if((a[e>>0]|0)!=0|f){c[g>>2]=0;c[h>>2]=c[j+16>>2];i=b;return}n=Vof(d)|0;m=j+16|0;if(((c[m>>2]|0)+1|0)<(n|0)){a[e>>0]=1;c[g>>2]=(c[m>>2]|0)+1;n=Vof(d)|0;c[h>>2]=n-(c[g>>2]|0);i=b;return}else{c[g>>2]=0;c[h>>2]=c[m>>2];i=b;return}}else{RI(2965048)|0;m=qL(2965048)|0;oig(m);Zwh(m)}while(0);if(f){m=j+16|0;n=(c[j>>2]|0)+120|0;c[g>>2]=(c[m>>2]|0)+2+(c[m+(c[n>>2]|0)>>2]|0);c[h>>2]=c[m+(c[n>>2]<<1)>>2];i=b;return}if(a[e>>0]|0){c[g>>2]=0;c[h>>2]=c[j+16>>2];i=b;return}n=j+16|0;if((c[n+(c[(c[j>>2]|0)+120>>2]|0)>>2]|0)<1){c[g>>2]=0;c[h>>2]=c[n>>2];i=b;return}else{a[e>>0]=1;c[g>>2]=(c[n>>2]|0)+1;c[h>>2]=c[n+(c[(c[j>>2]|0)+120>>2]|0)>>2];i=b;return}}while(0);c[g>>2]=0;c[h>>2]=Vof(d)|0;i=b;return}function wug(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=i;RI(3101448)|0;b=qL(3101448)|0;uug(b);if((f|0)>0){h=b+16|0;j=b+36|0;k=b+48|0;l=b+60|0;m=b+24|0;n=b+32|0;o=b+8|0;p=b+12|0;q=b+40|0;r=b+20|0;s=b+44|0;t=b+28|0;u=b+56|0;v=0;w=1;x=0;y=0;z=1;A=0;B=e;while(1){C=Wof(d,B)|0;D=C&65535;E=C<<16>>16!=0;a:do if(!(C<<16>>16==v<<16>>16&E))if(!(v<<16>>16)){if(y&E?!(C<<16>>16==35|C<<16>>16==48):0){F=c[h>>2]|0;G=0;H=(F|0)<0;I=(F|0)>-1;J=0;K=z;L=A;M=B+-1|0;break}F=D+65502&65535;do if((F|0)==5|(F|0)==0){if(!(C<<16>>16==39|C<<16>>16==34)){G=0;H=w;I=x;J=y;K=z;L=A;M=B;break a}G=C;H=w;I=x;J=y;K=z;L=A;M=B;break a}else if((F|0)==3){c[u>>2]=(c[u>>2]|0)+1;G=0;H=w;I=x;J=y;K=z;L=A;M=B;break a}else if((F|0)==1){if(z&w){c[t>>2]=(c[t>>2]|0)+1;break}if(x){c[r>>2]=(c[r>>2]|0)+1;break}if(y)c[s>>2]=(c[s>>2]|0)+1}else{N=D+65492&65535;if((N|0)==2){if((c[h>>2]|0)!=-1){G=0;H=0;I=1;J=0;K=z;L=A;M=B;break a}c[h>>2]=B;G=0;H=0;I=1;J=0;K=z;L=A;M=B;break a}else if(!N){if(!w){G=0;H=0;I=x;J=y;K=z;L=A;M=B;break a}G=0;H=1;I=x;J=y;K=z;L=((c[m>>2]|0)>0&1)+A|0;M=B;break a}else if((N|0)!=4)if(C<<16>>16==8240){c[l>>2]=(c[l>>2]|0)+1;G=0;H=w;I=x;J=y;K=z;L=A;M=B;break a}else if(C<<16>>16==92){G=0;H=w;I=x;J=y;K=z;L=A;M=B+1|0;break a}else if(C<<16>>16==101|C<<16>>16==69){if(a[j>>0]|0){G=0;H=w;I=x;J=y;K=z;L=A;M=B;break a}a[j>>0]=1;N=B+1|0;if((N-e|0)>=(f|0)){G=0;H=0;I=0;J=1;K=z;L=A;M=B;break a}O=Wof(d,N)|0;if(O<<16>>16==45){G=0;H=0;I=0;J=1;K=z;L=A;M=N;break a}else if(O<<16>>16==43){a[k>>0]=0;G=0;H=0;I=0;J=1;K=z;L=A;M=N;break a}if(O<<16>>16==35|O<<16>>16==48){G=0;H=0;I=0;J=1;K=z;L=A;M=B;break a}a[j>>0]=0;G=0;H=(c[h>>2]|0)<0;I=0;J=1;K=z;L=A;M=B;break a}else{G=0;H=w;I=x;J=y;K=z;L=A;M=B;break a}else break}while(0);do if(C<<16>>16!=35){if(x){c[r>>2]=0;P=0;break}if(y){c[s>>2]=0;P=0}else P=0}else P=z;while(0);if((c[n>>2]|0)==-1)c[n>>2]=B;if(w){c[m>>2]=(c[m>>2]|0)+1;if((A|0)<1){G=0;H=1;I=x;J=y;K=P;L=0;M=B;break}a[o>>0]=1;G=0;H=1;I=x;J=y;K=P;L=0;M=B;break}if(x){c[p>>2]=(c[p>>2]|0)+1;G=0;H=0;I=1;J=y;K=P;L=A;M=B;break}if(y){c[q>>2]=(c[q>>2]|0)+1;G=0;H=0;I=0;J=1;K=P;L=A;M=B}else{G=0;H=0;I=0;J=0;K=P;L=A;M=B}}else{G=v;H=w;I=x;J=y;K=z;L=A;M=B}else{G=0;H=w;I=x;J=y;K=z;L=A;M=B}while(0);B=M+1|0;if((B-e|0)>=(f|0)){Q=q;R=L;break}else{v=G;w=H;x=I;y=J;z=K;A=L}}}else{Q=b+40|0;R=0}if(!(c[Q>>2]|0))a[b+36>>0]=0;else c[b+28>>2]=0;if(c[b+12>>2]|0){S=b+52|0;T=c[S>>2]|0;U=R*3|0;V=T+U|0;W=V;c[S>>2]=W;i=g;return b|0}c[b+16>>2]=-1;S=b+52|0;T=c[S>>2]|0;U=R*3|0;V=T+U|0;W=V;c[S>>2]=W;i=g;return b|0}function xug(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0;m=i;RI(2971904)|0;n=qL(2971904)|0;Gbg(n);o=ZTf(g)|0;p=YTf(g)|0;q=b+8|0;do if((a[q>>0]|0)!=0?(r=o+12|0,(c[r>>2]|0)>=1):0){s=Yeg(j)|0;t=c[r>>2]|0;r=o+16|0;u=c[(c[o>>2]|0)+120>>2]|0;if((t|0)>0){v=0;w=0;x=0;while(1){y=(c[r+(da(u,x)|0)>>2]|0)+v|0;z=(y|0)>(s|0)?w:x;x=x+1|0;if((x|0)>=(t|0)){A=y;B=z;break}else{v=y;w=z}}}else{A=0;B=0}w=c[r+(da(u,B)|0)>>2]|0;v=s-A|0;t=(s|0)>(A|0)?v:0;if(!w){a:do if((B|0)<0)C=B;else{x=B;while(1){z=x+-1|0;if(c[r+(da(u,x)|0)>>2]|0){C=x;break a}if((x|0)<1){C=z;break}else x=z}}while(0);if((t|0)<1){D=C;E=c[r+(da(u,C)|0)>>2]|0;F=11}else{G=C;H=v}}else{D=B;E=w;F=11}if((F|0)==11)if(!t){I=D;J=E;K=E;L=s;break}else{G=D;H=E}x=(t|0)%(H|0)|0;z=(x|0)==0;I=((t|0)/(H|0)|0)+G+(z&1^1)|0;J=z?H:x;K=H;L=s}else F=13;while(0);if((F|0)==13){a[q>>0]=0;I=0;J=0;K=0;L=0}if((f|0)>0){F=b+36|0;H=b+16|0;G=b+12|0;E=b+24|0;b=o+12|0;D=o+16|0;B=l;l=0;C=I;I=J;J=K;K=e;A=1;x=0;z=0;y=0;M=0;N=L;while(1){L=Wof(d,K)|0;O=L&65535;b:do if(!(L<<16>>16!=0?L<<16>>16==l<<16>>16:0)){if(l<<16>>16){acg(n,L)|0;P=B;Q=l;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break}$=O+65502&65535;do if(($|0)==3){Hbg(n,fUf(g)|0)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}else if(($|0)==5|($|0)==0){if(!(L<<16>>16==39|L<<16>>16==34)){P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}P=B;Q=L;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}else if(($|0)!=1){aa=O+65492&65535;if(!aa){P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}else if((aa|0)==2){if((c[H>>2]|0)!=(K|0)){P=B;Q=0;R=C;S=I;T=J;U=K;V=0;W=1;X=z;Y=y;Z=M;_=N;break b}if((c[G>>2]|0)>=1?(y|0)<(Yeg(j)|0):0){ba=y;while(1){ca=ba+1|0;acg(n,bfg(j,ba)|0)|0;if((ca|0)<(Yeg(j)|0))ba=ca;else{ea=ca;break}}}else ea=y;if((Yeg(k)|0)<1){P=B;Q=0;R=C;S=I;T=J;U=K;V=0;W=1;X=z;Y=ea;Z=M;_=N;break b}Hbg(n,XTf(g)|0)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=0;W=1;X=z;Y=ea;Z=M;_=N;break b}else if((aa|0)==4)break;if(L<<16>>16==8240){Hbg(n,gUf(g)|0)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}else if(L<<16>>16==92){ba=K+1|0;if((ba-e|0)>=(f|0)){P=B;Q=0;R=C;S=I;T=J;U=ba;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}acg(n,Wof(d,ba)|0)|0;P=B;Q=0;R=C;S=I;T=J;U=ba;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}else if(L<<16>>16==101|L<<16>>16==69){if((B|0)!=0?(a[F>>0]|0)!=0:0){ba=K+1|0;c:do if((ba-e|0)<(f|0)){ca=0;fa=ba;while(1){if((Wof(d,fa)|0)<<16>>16!=48){if((fa|0)!=(ba|0)){ga=ca;ha=fa;break}if((Wof(d,ba)|0)<<16>>16!=43?(Wof(d,ba)|0)<<16>>16!=45:0){ga=ca;ha=ba;break}else ia=ca}else ia=1;ja=fa+1|0;if((ja-e|0)<(f|0)){ca=ia;fa=ja}else{ka=ja;break c}}if(ga)ka=ha;else{acg(n,L)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}}else ka=ba;while(0);ba=c[H>>2]|0;acg(n,L)|0;ifg(n,B)|0;P=0;Q=0;R=C;S=I;T=J;U=ka+-1|0;V=(ba|0)<0;W=(ba|0)>-1;X=z;Y=y;Z=M;_=N;break b}acg(n,L)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}else{acg(n,L)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N;break b}}while(0);if(!A){if(!x){acg(n,L)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=0;W=0;X=z;Y=y;Z=M;_=N;break}if((M|0)>=(Yeg(k)|0)){P=B;Q=0;R=C;S=I;T=J;U=K;V=0;W=1;X=z;Y=y;Z=M;_=N;break}acg(n,bfg(k,M)|0)|0;P=B;Q=0;R=C;S=I;T=J;U=K;V=0;W=1;X=z;Y=y;Z=M+1|0;_=N;break}$=z+1|0;ba=c[E>>2]|0;if((ba-$|0)<((Yeg(j)|0)+y|0)|L<<16>>16==48){ba=~z;aa=C;fa=I;ca=J;ja=y;la=N;while(1){ma=aa;na=fa;oa=ja;pa=la;while(1){qa=na;ra=oa;sa=pa;while(1){ta=ra;ua=sa;while(1){va=ta;while(1){wa=c[E>>2]|0;if((va+ba+wa|0)>=(Yeg(j)|0)){P=B;Q=0;R=ma;S=qa;T=ca;U=K;V=1;W=x;X=$;Y=va;Z=M;_=ua;break b}wa=va+1|0;acg(n,bfg(j,va)|0)|0;if(!(a[q>>0]|0))va=wa;else{xa=wa;break}}va=ua+-1|0;if((ua|0)<2){ta=xa;ua=va}else{ya=xa;za=va;break}}qa=qa+-1|0;if(!qa){Aa=ya;Ba=za;break}else{ra=ya;sa=za}}Hbg(n,p)|0;sa=ma+-1|0;if((ma|0)<1?1:(ma|0)>(c[b>>2]|0)){ma=sa;na=ca;oa=Aa;pa=Ba}else{Ca=Aa;Da=Ba;Ea=sa;break}}pa=c[D+(da(c[(c[o>>2]|0)+120>>2]|0,Ea)|0)>>2]|0;aa=Ea;fa=pa;ca=pa;ja=Ca;la=Da}}else{P=B;Q=0;R=C;S=I;T=J;U=K;V=1;W=x;X=$;Y=y;Z=M;_=N}}else{P=B;Q=0;R=C;S=I;T=J;U=K;V=A;W=x;X=z;Y=y;Z=M;_=N}while(0);K=U+1|0;if((K-e|0)>=(f|0))break;else{B=P;l=Q;C=R;I=S;J=T;A=V;x=W;z=X;y=Y;M=Z;N=_}}}if(h){Fa=Fqh(2972072,n)|0;i=m;return Fa|0}lfg(n,0,VTf(g)|0)|0;Fa=Fqh(2972072,n)|0;i=m;return Fa|0}function yug(a,b){a=a|0;b=b|0;var d=0;d=i;RI(1136088)|0;c[a+60>>2]=_wh(1136088,0)|0;if(!b){i=d;return}c[a+8>>2]=b;zug(a,lzg(0,b)|0);i=d;return}function zug(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)!=0?tSf(b)|0:0){c[a+12>>2]=Kuh(2756224,b)|0;i=d;return}c[a+12>>2]=0;i=d;return}function Aug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;a=i;RI(3102784)|0;b=c[775719]|0;RI(3102784)|0;d=(c[775719]|0)+4|0;RI(3102784)|0;e=(c[775719]|0)+8|0;RI(3102784)|0;f=(c[775719]|0)+12|0;RI(3102784)|0;g=(c[775719]|0)+16|0;RI(3102784)|0;Bug(0,b,d,e,f,g,(c[775719]|0)+20|0);i=a;return}function Bug(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;a=i;j=c[775744]|0;if(!j){k=MK(3102984)|0;c[775744]=k;l=k}else l=j;rn[l&127](b,d,e,f,g,h);i=a;return}function Cug(b,d){b=b|0;d=d|0;var e=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;e=(c[(c[775719]|0)+16>>2]|0)+(d<<3)|0;H=c[e+4>>2]|0;i=b;return c[e>>2]|0}function Dug(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;if(d>>>0<1e8)f=d;else{g=(d>>>0)/1e8|0;h=(da(g,-1e8)|0)+d|0;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+48>>2]=Eug(0,g)|0;f=h}RI(3102784)|0;if(a[3102932]|0){j=Fug(0,f)|0;k=b+44|0;c[k>>2]=j;i=e;return}RI(3102784)|0;Ywh(3102784);j=Fug(0,f)|0;k=b+44|0;c[k>>2]=j;i=e;return}function Eug(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;b=i;if((d|0)>99){e=d*5243>>19;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;f=c[(c[(c[775719]|0)+20>>2]|0)+(e<<2)>>2]<<8;RI(3102784)|0;g=c[(c[(c[775719]|0)+20>>2]|0)+((da(e,-100)|0)+d<<2)>>2]|f;i=b;return g|0}else{RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;g=c[(c[(c[775719]|0)+20>>2]|0)+(d<<2)>>2]|0;i=b;return g|0}return 0}function Fug(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)<1e4){d=c;e=0}else{f=(c|0)/1e4|0;g=(da(f,-1e4)|0)+c|0;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}d=g;e=(Eug(0,f)|0)<<16}RI(3102784)|0;if(a[3102932]|0){h=Eug(0,d)|0;j=h|e;i=b;return j|0}RI(3102784)|0;Ywh(3102784);h=Eug(0,d)|0;j=h|e;i=b;return j|0}function Gug(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;if(!(e>>>0<0|(e|0)==0&d>>>0<1e8)){g=hFi(d|0,e|0,1e8,0)|0;h=H;j=gFi(g|0,h|0,-1e8,-1)|0;k=_Ei(j|0,H|0,d|0,e|0)|0;j=H;if(e>>>0<2328306|(e|0)==2328306&d>>>0<1874919424){l=g;m=h}else{n=hFi(d|0,e|0,1874919424,2328306)|0;o=gFi(n|0,H|0,-1e8,-1)|0;p=_Ei(o|0,H|0,g|0,h|0)|0;h=H;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+52>>2]=Fug(0,n)|0;l=p;m=h}if((l|0)==0&(m|0)==0){q=k;r=j}else{RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+48>>2]=Fug(0,l)|0;q=k;r=j}}else{q=d;r=e}if((q|0)==0&(r|0)==0){i=f;return}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+44>>2]=Fug(0,q)|0;i=f;return}function Hug(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;if(!d){Gug(b,e,f);i=g;return}h=(d>>>0)/1e8|0;j=(da(h,-1e8)|0)+d|0;k=hFi(e|0,f|0,1e8,0)|0;l=H;m=gFi(k|0,l|0,-1e8,-1)|0;n=_Ei(m|0,H|0,e|0,f|0)|0;f=H;e=gFi(j|0,0,9551616,0)|0;m=_Ei(n|0,f|0,e|0,H|0)|0;e=H;f=gFi(j|0,0,-216152991,42)|0;j=H;n=hFi(m|0,e|0,1e8,0)|0;o=H;p=gFi(n|0,o|0,-1e8,-1)|0;q=_Ei(m|0,e|0,p|0,H|0)|0;p=_Ei(n|0,o|0,k|0,l|0)|0;l=_Ei(p|0,H|0,f|0,j|0)|0;j=H;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+44>>2]=Fug(0,q)|0;q=hFi(l|0,j|0,1e8,0)|0;f=H;p=gFi(q|0,f|0,-1e8,-1)|0;k=_Ei(p|0,H|0,l|0,j|0)|0;j=H;if(d>>>0>99999999){d=gFi(h|0,0,-216152991,42)|0;l=_Ei(q|0,f|0,d|0,H|0)|0;d=H;p=gFi(h|0,0,9551616,0)|0;h=_Ei(k|0,j|0,p|0,H|0)|0;p=H;j=hFi(h|0,p|0,1e8,0)|0;o=H;n=_Ei(l|0,d|0,j|0,o|0)|0;d=H;l=gFi(j|0,o|0,-1e8,-1)|0;o=_Ei(l|0,H|0,h|0,p|0)|0;r=d;s=n;t=o}else{r=f;s=q;t=k}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+48>>2]=Fug(0,t)|0;if(r>>>0<0|(r|0)==0&s>>>0<1e8)u=s;else{t=hFi(s|0,r|0,1e8,0)|0;k=gFi(t|0,H|0,-1e8,-1)|0;q=_Ei(k|0,H|0,s|0,r|0)|0;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+56>>2]=Fug(0,t)|0;u=q}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[b+52>>2]=Fug(0,u)|0;i=g;return}function Iug(a,b){a=a|0;b=b|0;var c=0;if((b|0)>255)c=(b|0)>4095?4:3;else c=(b|0)>15?2:1;return c|0}function Jug(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;RI(3102784)|0;d=(a[3102932]|0)!=0;if(c>>>0<=65535){if(!d){RI(3102784)|0;Ywh(3102784)}if((c|0)>255){e=(c|0)>4095?4:3;i=b;return e|0}else{e=(c|0)>15?2:1;i=b;return e|0}}else{if(!d){RI(3102784)|0;Ywh(3102784)}if(c>>>0>16777215)f=c>>>0>268435455?4:3;else f=c>>>0>1048575?2:1;e=f+4|0;i=b;return e|0}return 0}function Kug(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+56>>2]|0;if(e){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=(Jug(0,e)|0)+24|0;i=d;return f|0}e=c[b+52>>2]|0;if(e){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=(Jug(0,e)|0)+16|0;i=d;return f|0}e=c[b+48>>2]|0;if(e){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=(Jug(0,e)|0)+8|0;i=d;return f|0}e=c[b+44>>2]|0;if(!e){f=0;i=d;return f|0}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=Jug(0,e)|0;i=d;return f|0}function Lug(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;e=18;while(1){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=Cug(0,e)|0;g=H;if(!((g|0)>(d|0)|(g|0)==(d|0)&f>>>0>c>>>0)){h=e;break}if((e|0)>0)e=e+-1|0;else{j=1;k=7;break}}if((k|0)==7){i=b;return j|0}j=h+1|0;i=b;return j|0}function Mug(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b[a+22>>1]|0;do if(e<<16>>16!=82){f=c[a+24>>2]|0;g=c[a+28>>2]|0;if((f|0)>=(g|0))if(e<<16>>16==71){h=g+2|0;j=(h|0)<(f|0)?h:f;break}else if(e<<16>>16==69){h=g+2|0;k=f+1|0;j=(h|0)<(k|0)?h:k;break}else{j=g;break}else j=g}else j=(c[a+28>>2]|0)+2|0;while(0);i=d;return j|0}function Nug(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;a=i;if((Vof(b)|0)>1){c=0;d=1}else{e=0;i=a;return e|0}while(1){f=((Wof(b,d)|0)&65535)+65488&65535;g=f+(c*10|0)|0;d=d+1|0;if(!(f>>>0<10&(g|0)<100)){e=-2;h=4;break}if((d|0)>=(Vof(b)|0)){e=g;h=4;break}else c=g}if((h|0)==4){i=a;return e|0}return 0}function Oug(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=d+44|0;c[d+36>>2]=0;a[d+17>>0]=0;a[d+16>>0]=0;h=d+18|0;a[h>>0]=0;j=d+19|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;a[j>>0]=1;g=d+24|0;c[g>>2]=-1;if((e|0)!=0?(Vof(e)|0)!=0:0){k=Wof(e,0)|0;if((k+-97<<16>>16&65535)>25)if((k+-65<<16>>16&65535)<26)l=k;else{a[h>>0]=1;b[d+22>>1]=48;i=f;return}else{a[j>>0]=0;l=(k&65535)+65504&65535}k=d+22|0;b[k>>1]=l;if((Vof(e)|0)<2){i=f;return}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}l=Nug(0,e)|0;c[g>>2]=l;if((l|0)!=-2){i=f;return}a[h>>0]=1;b[k>>1]=48;c[g>>2]=-1;i=f;return}b[d+22>>1]=71;i=f;return}function Pug(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=c[a+28>>2]|0;if((f|0)==5){g=b&65535;h=0}else if((f|0)==3){g=b&255;h=0}else{j=(f|0)==10;g=j?b:b;h=j?0:d}c[a+44>>2]=g;c[a+48>>2]=h;d=Kug(a)|0;c[a+32>>2]=d;c[a+40>>2]=(g|0)==0&(h|0)==0?1:d;i=e;return}function Qug(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;Oug(d,e);c[d+28>>2]=g;a[d+20>>0]=f>>>31&255^1;if((f|0)!=0?(b[d+22>>1]|0)!=88:0){Dug(d,(f|0)>-1?f:0-f|0);g=Kug(d)|0;c[d+32>>2]=g;c[d+40>>2]=g;i=h;return}Pug(d,f,((f|0)<0)<<31>>31);i=h;return}function Rug(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;Oug(d,e);c[d+28>>2]=g;a[d+20>>0]=1;if((f|0)!=0?(b[d+22>>1]|0)!=88:0){Dug(d,f);g=Kug(d)|0;c[d+32>>2]=g;c[d+40>>2]=g;i=h;return}Pug(d,f,0);i=h;return}function Sug(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;Oug(d,e);c[d+28>>2]=19;e=VEi(f|0,g|0,63)|0;a[d+20>>0]=e&255^1;if(!((f|0)==0&(g|0)==0)?(b[d+22>>1]|0)!=88:0){e=(g|0)>-1|(g|0)==-1&f>>>0>4294967295;j=ZEi(0,0,f|0,g|0)|0;Gug(d,e?f:j,e?g:H);e=Kug(d)|0;c[d+32>>2]=e;c[d+40>>2]=e;i=h;return}Pug(d,f,g);i=h;return}function Tug(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;Oug(d,e);c[d+28>>2]=20;a[d+20>>0]=1;if(!((f|0)==0&(g|0)==0)?(b[d+22>>1]|0)!=88:0){Gug(d,f,g);e=Kug(d)|0;c[d+32>>2]=e;c[d+40>>2]=e;i=h;return}Pug(d,f,g);i=h;return}function Uug(b,d,e,f){b=b|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;Oug(b,d);c[b+28>>2]=f;RI(3007432)|0;if(!(a[3007580]|0)){RI(3007432)|0;Ywh(3007432)}f=Jig(0,e)|0;d=H;h=b+20|0;j=VEi(f|0,d|0,63)|0;a[h>>0]=j&255^1;j=d&2147483647;if((f|0)==0&(j|0)==0){c[b+40>>2]=1;c[b+32>>2]=0;a[h>>0]=1;i=g;return}h=VEi(f|0,j|0,52)|0;j=d&1048575;if(!h){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}d=Lug(0,f,j)|0;if((d|0)>14){k=j;l=f;m=1;n=0}else{RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}o=Cug(0,15-d|0)|0;p=gFi(o|0,H|0,f|0,j|0)|0;k=H;l=p;m=1;n=d+-15|0}}else if((h|0)==2047){d=(f|0)==0&(j|0)==0&1;a[b+16>>0]=d^1;a[b+17>>0]=d;i=g;return}else{d=gFi(f|0,j|1048576|0,10,0)|0;k=H;l=d;m=h;n=-1}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;h=(c[c[775719]>>2]|0)+(m<<3)|0;d=c[h>>2]|0;j=c[h+4>>2]|0;h=gFi(d|0,0,k|0,0)|0;f=H;p=gFi(j|0,0,l|0,0)|0;o=_Ei(h|0,f|0,p|0,H|0)|0;p=H;gFi(d|0,0,l|0,0)|0;l=_Ei(o|0,p|0,H|0,0)|0;p=H;o=gFi(j|0,0,k|0,0)|0;k=_Ei(p|0,0,o|0,H|0)|0;o=H;if((o|0)<2328306|(o|0)==2328306&k>>>0<1874919424){j=p;d=l;f=k;h=o;q=n;while(1){r=gFi(d|0,0,10,0)|0;s=H;t=gFi(f|0,h|0,10,0)|0;u=_Ei(s|0,0,t|0,H|0)|0;t=H;v=q+-1|0;if((t|0)<2328306|(t|0)==2328306&u>>>0<1874919424){j=s;d=r;f=u;h=t;q=v}else{w=r;x=s;y=u;z=t;A=v;break}}}else{w=l;x=p;y=k;z=o;A=n}n=VEi(w|0,x|0,31)|0;x=_Ei(n&1|0,0,y|0,z|0)|0;z=H;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;y=b+40|0;c[y>>2]=A+17+(c[(c[(c[775719]|0)+4>>2]|0)+(m<<2)>>2]|0);m=Mug(b)|0;if((m|0)>16){B=z;C=x;D=17}else{RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}A=Cug(0,17-m|0)|0;n=H;w=TEi(A|0,n|0,1)|0;o=_Ei(w|0,H|0,x|0,z|0)|0;z=eFi(o|0,H|0,A|0,n|0)|0;B=H;C=z;D=m}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}m=Cug(0,D)|0;z=H;if((B|0)<(z|0)|(B|0)==(z|0)&C>>>0<m>>>0)E=D;else{c[y>>2]=(c[y>>2]|0)+1;E=D+1|0}Gug(b,C,B);B=Vug(b)|0;c[b+36>>2]=B;c[b+32>>2]=E-B;i=g;return}function Vug(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+44>>2]|0;if(e){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=mvg(0,e)|0;i=d;return f|0}e=c[b+48>>2]|0;if(e){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=(mvg(0,e)|0)+8|0;i=d;return f|0}e=c[b+52>>2]|0;if(e){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=(mvg(0,e)|0)+16|0;i=d;return f|0}e=c[b+56>>2]|0;if(!e){f=c[b+32>>2]|0;i=d;return f|0}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=(mvg(0,e)|0)+24|0;i=d;return f|0}function Wug(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;Oug(d,e);c[d+28>>2]=100;RI(2592872)|0;if(!(a[2593020]|0)){RI(2592872)|0;Ywh(2592872)};c[h+0>>2]=c[f+0>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];f=zyf(0,h)|0;h=f+16|0;e=c[(c[f>>2]|0)+120>>2]|0;f=c[h+(e*3|0)>>2]|0;j=f>>>16&31;k=d+20|0;a[k>>0]=f>>>31&255^1;f=c[h>>2]|0;l=c[h+e>>2]|0;if(!(f|l))if(!(c[h+(e<<1)>>2]|0)){c[d+40>>2]=0-j;a[k>>0]=1;c[d+32>>2]=0;i=g;return}else m=0;else m=l;Hug(d,c[h+(e<<1)>>2]|0,f,m);m=Kug(d)|0;f=d+32|0;c[f>>2]=m;c[d+40>>2]=m-j;if((c[d+24>>2]|0)==-1?(b[d+22>>1]|0)==71:0){i=g;return}j=Vug(d)|0;c[d+36>>2]=j;c[f>>2]=(c[f>>2]|0)-j;i=g;return}function Xug(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+64>>2]=0;e=a+60|0;if((c[(c[e>>2]|0)+12>>2]|0)>=(b|0)){i=d;return}RI(1136088)|0;c[e>>2]=_wh(1136088,b)|0;i=d;return}function Yug(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;RI(1136088)|0;e=_wh(1136088,b)|0;b=a+60|0;vEf(0,c[b>>2]|0,e,c[a+64>>2]|0);c[b>>2]=e;i=d;return}function Zug(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=a+64|0;g=c[f>>2]|0;h=a+60|0;j=c[h>>2]|0;if((g|0)==(c[j+12>>2]|0)){Yug(a,g+10|0);k=c[h>>2]|0;l=c[f>>2]|0}else{k=j;l=g}c[f>>2]=l+1;b[k+16+(da(c[(c[k>>2]|0)+120>>2]|0,l)|0)>>1]=d;i=e;return}function _ug(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a+64|0;h=a+60|0;j=(c[g>>2]|0)+e|0;if((j|0)>(c[(c[h>>2]|0)+12>>2]|0))Yug(a,j+10|0);if((e|0)<=0){i=f;return}j=c[h>>2]|0;h=j+16|0;a=c[g>>2]|0;k=e;l=a;while(1){k=k+-1|0;b[h+(da(c[(c[j>>2]|0)+120>>2]|0,l)|0)>>1]=d;if((k|0)<=0)break;else l=l+1|0}c[g>>2]=a+e;i=f;return}function $ug(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=Vof(d)|0;g=a+64|0;h=a+60|0;j=(c[g>>2]|0)+f|0;if((j|0)>(c[(c[h>>2]|0)+12>>2]|0))Yug(a,j+10|0);if((f|0)>0)k=0;else{i=e;return}do{j=c[h>>2]|0;a=c[g>>2]|0;c[g>>2]=a+1;l=Wof(d,k)|0;b[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,a)|0)>>1]=l;k=k+1|0}while((k|0)!=(f|0));i=e;return}function avg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b+12>>2]|0;if(!((f|0)==0|(d|0)!=0)){g=f;i=e;return g|0}RI(2755888)|0;if(!(a[2756036]|0)){RI(2755888)|0;Ywh(2755888)}g=lUf(0,d)|0;i=e;return g|0}function bvg(a){a=a|0;var b=0;b=c[a+40>>2]|0;return ((b|0)<1?1:b)|0}function cvg(a){a=a|0;var b=0,d=0;b=c[a+32>>2]|0;d=c[a+40>>2]|0;return ((b|0)>(d|0)?b-d|0:0)|0}function dvg(a){a=a|0;return (c[a+28>>2]&-9|0)==7|0}function evg(a){a=a|0;return (c[a+32>>2]|0)==0|0}function fvg(a){a=a|0;var b=0;if(!(c[a+32>>2]|0))b=1;else b=(c[a+40>>2]|0)<1;return b|0}function gvg(a,b){a=a|0;b=b|0;var d=0;d=i;hvg(a,(c[a+32>>2]|0)-b|0)|0;i=d;return}function hvg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=b+32|0;h=c[g>>2]|0;if((h|0)<(d|0)){c[g>>2]=0;c[b+40>>2]=1;j=b+44|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;a[b+20>>0]=1;f=0;i=e;return f|0}j=c[b+36>>2]|0;k=j+d|0;d=j+h|0;c[g>>2]=d;if((k|0)>8){h=b+48|0;j=b+52|0;l=b+56|0;m=k+-9&-8;n=d+-8|0;d=k;o=c[l>>2]|0;p=c[j>>2]|0;q=c[h>>2]|0;while(1){d=d+-8|0;if((d|0)<=8){r=o;s=p;t=q;break}else{u=o;o=0;q=p;p=u}}c[h>>2]=s;c[b+44>>2]=t;c[j>>2]=r;c[l>>2]=0;c[g>>2]=n-m;v=k+-8-m|0;w=t}else{v=k;w=c[b+44>>2]|0}k=v<<2;v=b+44|0;t=k+28&28;m=w>>>t;w=m&15;n=(w^m)<<t;c[v>>2]=n;if(w>>>0<5)x=0;else{c[v>>2]=n|-1717986919>>>(0-k&28);jvg(b);k=Kug(b)|0;n=c[g>>2]|0;v=b+40|0;c[v>>2]=k-n+(c[v>>2]|0);c[g>>2]=k;x=(k|0)!=(n|0)}kvg(b);f=x;i=e;return f|0}function ivg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=hvg(a,(c[a+32>>2]|0)-b-(c[a+40>>2]|0)|0)|0;i=d;return e|0}function jvg(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+44|0;f=c[e>>2]|0;if((f|0)!=-1717986919){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[e>>2]=lvg(0,f)|0;i=d;return}c[e>>2]=0;e=b+48|0;f=c[e>>2]|0;if((f|0)!=-1717986919){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[e>>2]=lvg(0,f)|0;i=d;return}c[e>>2]=0;e=b+52|0;f=c[e>>2]|0;if((f|0)==-1717986919){c[e>>2]=0;g=b+56|0;b=c[g>>2]|0;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[g>>2]=lvg(0,b)|0;i=d;return}else{RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}c[e>>2]=lvg(0,f)|0;i=d;return}}function kvg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=Vug(b)|0;f=b+36|0;c[f>>2]=e;g=b+32|0;h=c[g>>2]|0;c[g>>2]=h-e;if((h|0)!=(e|0)){i=d;return}c[f>>2]=0;c[b+40>>2]=1;a[b+20>>0]=1;i=d;return}function lvg(a,b){a=a|0;b=b|0;var c=0;a=i;do if((b&65535|0)==39321)if((b&16777215|0)==10066329)if((b&268435455|0)==161061273){c=b+107374183|0;break}else{c=b+6710887|0;break}else if((b&1048575|0)==629145){c=b+419431|0;break}else{c=b+26215|0;break}else if((b&255|0)==153)if((b&4095|0)==2457){c=b+1639|0;break}else{c=b+103|0;break}else if((b&15|0)==9){c=b+7|0;break}else{c=b+1|0;break}while(0);i=a;return c|0}function mvg(a,b){a=a|0;b=b|0;var c=0;a=i;do if(!(b&65535))if(!(b&16777215)){c=(b&268435455|0)==0?7:6;break}else{c=(b&1048575|0)==0?5:4;break}else if(!(b&255)){c=(b&4095|0)==0?3:2;break}else{c=(b&15|0)==0&1;break}while(0);i=a;return c|0}function nvg(b){b=b|0;var d=0,e=0,f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;d=c[(LM(c[775730]|0)|0)>>2]|0;RI(3102784)|0;c[(LM(c[775730]|0)|0)>>2]=0;if(d){e=d;i=b;return e|0}RI(3013496)|0;if(!(a[3013644]|0)){RI(3013496)|0;Ywh(3013496)}d=jhg(0)|0;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;f=qL(3102784)|0;yug(f,d);e=f;i=b;return e|0}function ovg(b){b=b|0;var d=0;d=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;c[(LM(c[775730]|0)|0)>>2]=b;i=d;return}function pvg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;Qug(f,c,d<<24>>24,3);d=qvg(f,c,e)|0;ovg(f);i=b;return d|0}function qvg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;Hph();h=avg(d,f)|0;f=b[d+22>>1]|0;switch((f&65535)+65469&65535|0){case 13:{j=Svg(d,c[d+24>>2]|0,h)|0;i=g;return j|0}case 0:{j=Nvg(d,c[d+24>>2]|0,h)|0;i=g;return j|0}case 2:{j=Pvg(d,c[d+24>>2]|0,h)|0;i=g;return j|0}case 1:{j=Ovg(d,c[d+24>>2]|0,h)|0;i=g;return j|0}case 11:{j=Rvg(d,c[d+24>>2]|0,h)|0;i=g;return j|0}case 4:{k=c[d+24>>2]|0;if((k|0)>0){j=Kvg(d,k,h)|0;i=g;return j|0}else{j=Ovg(d,-1,h)|0;i=g;return j|0}break}case 3:{j=Qvg(d,c[d+24>>2]|0,h)|0;i=g;return j|0}default:{if(f<<16>>16==88){j=Tvg(d,c[d+24>>2]|0)|0;i=g;return j|0}if(a[d+18>>0]|0){j=Uvg(d,e,h)|0;i=g;return j|0}if(a[2540708]|0){l=c[902820]|0;m=c[902822]|0;n=iwf(0,l,e,m)|0;RI(3079480)|0;o=qL(3079480)|0;Hrg(o,n);Zwh(o)}Ywh(2540560);l=c[902820]|0;m=c[902822]|0;n=iwf(0,l,e,m)|0;RI(3079480)|0;o=qL(3079480)|0;Hrg(o,n);Zwh(o)}}return 0}function rvg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;Qug(f,c,d&255,3);d=qvg(f,c,e)|0;ovg(f);i=b;return d|0}function svg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;Qug(f,c,d&65535,5);d=qvg(f,c,e)|0;ovg(f);i=b;return d|0}function tvg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;Qug(f,c,d<<16>>16,5);d=qvg(f,c,e)|0;ovg(f);i=b;return d|0}function uvg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;Rug(f,c,d,10);d=qvg(f,c,e)|0;ovg(f);i=b;return d|0}function vvg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;Qug(f,c,d,10);d=qvg(f,c,e)|0;ovg(f);i=b;return d|0}function wvg(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}g=nvg(0)|0;Tug(g,c,d,e);e=qvg(g,c,f)|0;ovg(g);i=b;return e|0}function xvg(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}g=nvg(0)|0;Sug(g,c,d,e);e=qvg(g,c,f)|0;ovg(g);i=b;return e|0}function yvg(c,d,e,f){c=c|0;d=d|0;e=ea(e);f=f|0;var g=0,h=0,j=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}g=nvg(0)|0;Uug(g,d,+e,7);h=avg(g,f)|0;do if(!(a[g+16>>0]|0))if(!(a[g+17>>0]|0))if((b[g+22>>1]|0)==82){j=zvg(g,e,h)|0;break}else{j=Avg(g,d,h)|0;break}else if(!(a[g+20>>0]|0)){j=UTf(h)|0;break}else{j=hUf(h)|0;break}else j=TTf(h)|0;while(0);ovg(g);i=c;return j|0}function zvg(a,b,d){a=a|0;b=ea(b);d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=Zvg(a)|0;g=a+28|0;h=Kvg(a,c[g>>2]|0,d)|0;if(!(ea(mxf(0,h,d))!=b)){j=h;i=e;return j|0}j=Kvg(f,(c[g>>2]|0)+2|0,d)|0;i=e;return j|0}function Avg(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;Iph();h=e[b+22>>1]|0;j=h+65469&65535;if(!j){k=Nvg(b,c[b+24>>2]|0,f)|0;i=g;return k|0}else if((j|0)==4){k=Kvg(b,c[b+24>>2]|0,f)|0;i=g;return k|0}else if((j|0)==3){k=Qvg(b,c[b+24>>2]|0,f)|0;i=g;return k|0}else if((j|0)!=2){j=h+65458&65535;if(!j){k=Rvg(b,c[b+24>>2]|0,f)|0;i=g;return k|0}else if((j|0)==2){k=Svg(b,c[b+24>>2]|0,f)|0;i=g;return k|0}else{if(a[b+18>>0]|0){k=Uvg(b,d,f)|0;i=g;return k|0}if(!(a[2540708]|0))Ywh(2540560);j=iwf(0,c[902844]|0,d,c[902846]|0)|0;RI(3079480)|0;d=qL(3079480)|0;Hrg(d,j);Zwh(d)}}else{k=Pvg(b,c[b+24>>2]|0,f)|0;i=g;return k|0}return 0}function Bvg(c,d,e,f){c=c|0;d=d|0;e=+e;f=f|0;var g=0,h=0,j=0;c=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}g=nvg(0)|0;Uug(g,d,e,15);h=avg(g,f)|0;do if(!(a[g+16>>0]|0))if(!(a[g+17>>0]|0))if((b[g+22>>1]|0)==82){j=Cvg(g,e,h)|0;break}else{j=Avg(g,d,h)|0;break}else if(!(a[g+20>>0]|0)){j=UTf(h)|0;break}else{j=hUf(h)|0;break}else j=TTf(h)|0;while(0);ovg(g);i=c;return j|0}function Cvg(a,b,d){a=a|0;b=+b;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=Zvg(a)|0;g=a+28|0;if(!(b<-1797693134862309920208376.0e284|b>1797693134862309920208376.0e284)?(h=Kvg(a,c[g>>2]|0,d)|0,!(+Sxf(0,h,d)!=b)):0){j=h;i=e;return j|0}j=Kvg(f,(c[g>>2]|0)+2|0,d)|0;i=e;return j|0}function Dvg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;i=i+16|0;g=b;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}h=nvg(0)|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Wug(h,d,g);g=Avg(h,d,avg(h,f)|0)|0;ovg(h);i=b;return g|0}function Evg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;RI(3102784)|0;e=(a[3102932]|0)!=0;if(c>>>0<1e8){if(!e){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;g=Fvg(f,c,d)|0;ovg(f);h=g;i=b;return h|0}else{if(!e){RI(3102784)|0;Ywh(3102784)}h=uvg(0,0,c,d)|0;i=b;return h|0}return 0}function Fvg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>-1){Xug(b,8);g=d}else{h=VTf(avg(b,e)|0)|0;Xug(b,(Vof(h)|0)+8|0);$ug(b,h);g=0-d|0}if((g|0)<1e4)Mvg(b,g,0);else{d=(g|0)/1e4|0;Mvg(b,d,0);Mvg(b,(da(d,-1e4)|0)+g|0,1)}g=c[b+60>>2]|0;d=c[b+64>>2]|0;if(a[2540708]|0){j=qL(2540560)|0;k=Awf(j,g,0,d)|0;i=f;return k|0}Ywh(2540560);j=qL(2540560)|0;k=Awf(j,g,0,d)|0;i=f;return k|0}function Gvg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;b=i;RI(3102784)|0;e=(a[3102932]|0)!=0;if((c+99999999|0)>>>0<199999999){if(!e){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;g=Fvg(f,c,d)|0;ovg(f);h=g;i=b;return h|0}else{if(!e){RI(3102784)|0;Ywh(3102784)}h=vvg(0,0,c,d)|0;i=b;return h|0}return 0}function Hvg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;RI(3102784)|0;f=(a[3102932]|0)!=0;if(d>>>0<0|(d|0)==0&c>>>0<1e8){if(!f){RI(3102784)|0;Ywh(3102784)}g=nvg(0)|0;h=Fvg(g,c,e)|0;ovg(g);j=h;i=b;return j|0}else{if(!f){RI(3102784)|0;Ywh(3102784)}j=wvg(0,0,c,d,e)|0;i=b;return j|0}return 0}function Ivg(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;b=i;f=_Ei(c|0,d|0,99999999,0)|0;g=H;RI(3102784)|0;h=(a[3102932]|0)!=0;if(g>>>0<0|(g|0)==0&f>>>0<199999999){if(!h){RI(3102784)|0;Ywh(3102784)}f=nvg(0)|0;g=Fvg(f,c,e)|0;ovg(f);j=g;i=b;return j|0}else{if(!h){RI(3102784)|0;Ywh(3102784)}j=xvg(0,0,c,d,e)|0;i=b;return j|0}return 0}function Jvg(b,c,d){b=b|0;c=ea(c);d=d|0;var e=0,f=0,g=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}e=nvg(0)|0;Uug(e,0,+c,7);f=avg(e,d)|0;do if(!(a[e+16>>0]|0)){if(!(a[e+17>>0]|0)){g=Kvg(e,-1,f)|0;break}if(!(a[e+20>>0]|0)){g=UTf(f)|0;break}else{g=hUf(f)|0;break}}else g=TTf(f)|0;while(0);ovg(e);i=b;return g|0}function Kvg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==-1){g=c[b+28>>2]|0;h=g;j=(g&-9|0)!=7}else if(!d){k=c[b+28>>2]|0;l=4}else{k=d;l=4}if((l|0)==4){gvg(b,k);h=k;j=0}k=c[b+40>>2]|0;l=c[b+32>>2]|0;d=l-k|0;if(!((k|0)<=(h|0)&(k|0)>-4|j)){m=_vg(b,l+-1|0,e,2)|0;i=f;return m|0}j=(d|0)<0?0:d;d=(k|0)<0?0:k;Xug(b,d+3+j|0);if(!(a[b+20>>0]|0))$ug(b,VTf(e)|0);if(!d)Zug(b,48);else Xvg(b,l-d|0,l);if((j|0)>=1){$ug(b,XTf(e)|0);Xvg(b,0,j)}j=c[b+60>>2]|0;e=c[b+64>>2]|0;if(!(a[2540708]|0))Ywh(2540560);m=Awf(qL(2540560)|0,j,0,e)|0;i=f;return m|0}function Lvg(b,c,d){b=b|0;c=+c;d=d|0;var e=0,f=0,g=0;b=i;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}e=nvg(0)|0;f=avg(e,d)|0;Uug(e,0,c,15);do if(!(a[e+16>>0]|0)){if(!(a[e+17>>0]|0)){g=Kvg(e,-1,f)|0;break}if(!(a[e+20>>0]|0)){g=UTf(f)|0;break}else{g=hUf(f)|0;break}}else g=TTf(f)|0;while(0);ovg(e);i=b;return g|0}function Mvg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;h=d+64|0;j=c[h>>2]|0;k=f^1;if((e|0)<100&k){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;l=j;m=(c[(c[775719]|0)+20>>2]|0)+(e<<2)|0}else{f=e*5243>>19;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;n=c[(c[(c[775719]|0)+20>>2]|0)+(f<<2)>>2]|0;o=c[d+60>>2]|0;if((e|0)<1e3&k)p=j;else{b[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>1]=n>>>4|48;p=j+1|0}b[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,p)|0)>>1]=n&15|48;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;l=p+1|0;m=(c[(c[775719]|0)+20>>2]|0)+((da(f,-100)|0)+e<<2)|0}f=c[m>>2]|0;m=c[d+60>>2]|0;if((e|0)<10&k){q=l;r=q+1|0;s=f&15;t=s|48;u=t&65535;v=c[m>>2]|0;w=m+16|0;x=v+120|0;y=c[x>>2]|0;z=da(y,q)|0;A=w+z|0;b[A>>1]=u;c[h>>2]=r;i=g;return}b[m+16+(da(c[(c[m>>2]|0)+120>>2]|0,l)|0)>>1]=f>>>4|48;q=l+1|0;r=q+1|0;s=f&15;t=s|48;u=t&65535;v=c[m>>2]|0;w=m+16|0;x=v+120|0;y=c[x>>2]|0;z=da(y,q)|0;A=w+z|0;b[A>>1]=u;c[h>>2]=r;i=g;return}function Nvg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)<0)g=KTf(e)|0;else g=d;ivg(b,g)|0;d=c[b+40>>2]|0;Xug(b,(((d|0)<1?1:d)+g<<1)+16|0);d=b+20|0;a:do if(a[d>>0]|0){h=PTf(e)|0;if(!h){$ug(b,QTf(e)|0);break}else if((h|0)==2){$ug(b,QTf(e)|0);Zug(b,32);break}else break}else{h=OTf(e)|0;switch(h|0){case 1:{$ug(b,VTf(e)|0);$ug(b,QTf(e)|0);break a;break}case 3:{$ug(b,QTf(e)|0);break a;break}case 0:{Zug(b,40);$ug(b,QTf(e)|0);break a;break}case 2:{$ug(b,QTf(e)|0);$ug(b,VTf(e)|0);break a;break}case 5:{$ug(b,VTf(e)|0);break a;break}case 4:{Zug(b,40);break a;break}default:{if((h&-2|0)==6)break a;switch(h|0){case 12:{$ug(b,QTf(e)|0);Zug(b,32);$ug(b,VTf(e)|0);break a;break}case 11:{$ug(b,QTf(e)|0);Zug(b,32);break a;break}case 8:{$ug(b,VTf(e)|0);break a;break}case 14:{Zug(b,40);$ug(b,QTf(e)|0);Zug(b,32);break a;break}case 9:{$ug(b,VTf(e)|0);$ug(b,QTf(e)|0);Zug(b,32);break a;break}case 15:{Zug(b,40);break a;break}default:break a}}}}while(0);h=NTf(e)|0;Vvg(b,h,MTf(e)|0);if((g|0)>=1){$ug(b,LTf(e)|0);Wvg(b,g)}b:do if(!(a[d>>0]|0)){g=OTf(e)|0;if(!g){Zug(b,41);break}if((g+-1|0)>>>0>=2)do switch(g|0){case 10:{Zug(b,32);$ug(b,QTf(e)|0);$ug(b,VTf(e)|0);break b;break}case 4:{$ug(b,QTf(e)|0);Zug(b,41);break b;break}case 5:{$ug(b,QTf(e)|0);break b;break}case 13:{$ug(b,VTf(e)|0);Zug(b,32);$ug(b,QTf(e)|0);break b;break}case 15:{Zug(b,32);$ug(b,QTf(e)|0);Zug(b,41);break b;break}case 14:{Zug(b,41);break b;break}case 8:{Zug(b,32);$ug(b,QTf(e)|0);break b;break}case 7:{$ug(b,QTf(e)|0);$ug(b,VTf(e)|0);break b;break}case 6:{$ug(b,VTf(e)|0);$ug(b,QTf(e)|0);break b;break}case 11:{$ug(b,VTf(e)|0);break b;break}case 3:{$ug(b,VTf(e)|0);break b;break}default:break b}while(0)}else{g=PTf(e)|0;if((g|0)==1){$ug(b,QTf(e)|0);break}else if((g|0)==3){Zug(b,32);$ug(b,QTf(e)|0);break}else break}while(0);e=c[b+60>>2]|0;d=c[b+64>>2]|0;if(a[2540708]|0){j=qL(2540560)|0;k=Awf(j,e,0,d)|0;i=f;return k|0}Ywh(2540560);j=qL(2540560)|0;k=Awf(j,e,0,d)|0;i=f;return k|0}function Ovg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;Jph();g=c[b+32>>2]|0;h=(g|0)>(d|0)?g:d;if(!h){j=c[902850]|0;i=f;return j|0}Xug(b,h+1|0);if(!(a[b+20>>0]|0))$ug(b,VTf(e)|0);Xvg(b,0,h);h=c[b+60>>2]|0;e=c[b+64>>2]|0;if(!(a[2540708]|0))Ywh(2540560);j=Awf(qL(2540560)|0,h,0,e)|0;i=f;return j|0}function Pvg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=(b|0)==-1?6:b;gvg(a,e+1|0);b=_vg(a,e,c,3)|0;i=d;return b|0}function Qvg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)==-1)g=WTf(e)|0;else g=d;ivg(b,g)|0;d=b+40|0;h=c[d>>2]|0;Xug(b,g+2+((h|0)<1?1:h)|0);if(!(a[b+20>>0]|0))$ug(b,VTf(e)|0);h=c[d>>2]|0;Yvg(b,(h|0)<1?1:h);if((g|0)>=1){$ug(b,XTf(e)|0);Wvg(b,g)}g=c[b+60>>2]|0;e=c[b+64>>2]|0;if(a[2540708]|0){j=qL(2540560)|0;k=Awf(j,g,0,e)|0;i=f;return k|0}Ywh(2540560);j=qL(2540560)|0;k=Awf(j,g,0,e)|0;i=f;return k|0}function Rvg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)<0)g=WTf(e)|0;else g=d;d=c[b+40>>2]|0;Xug(b,((d|0)<1?3:d*3|0)+g|0);ivg(b,g)|0;d=b+20|0;do if(!(a[d>>0]|0)){h=_Tf(e)|0;if(!h){Zug(b,40);break}else if((h|0)==2){$ug(b,VTf(e)|0);Zug(b,32);break}else if((h|0)==1){$ug(b,VTf(e)|0);break}else break}while(0);h=ZTf(e)|0;Vvg(b,h,YTf(e)|0);if((g|0)>=1){$ug(b,XTf(e)|0);Wvg(b,g)}do if(!(a[d>>0]|0)){g=_Tf(e)|0;if(!g){Zug(b,41);break}if((g+-1|0)>>>0>=2)if((g|0)==3){$ug(b,VTf(e)|0);break}else if((g|0)==4){Zug(b,32);$ug(b,VTf(e)|0);break}else break}while(0);e=c[b+60>>2]|0;d=c[b+64>>2]|0;if(a[2540708]|0){j=qL(2540560)|0;k=Awf(j,e,0,d)|0;i=f;return k|0}Ywh(2540560);j=qL(2540560)|0;k=Awf(j,e,0,d)|0;i=f;return k|0}function Svg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)<0)g=$Tf(e)|0;else g=d;d=b+40|0;if(c[b+32>>2]|0)c[d>>2]=(c[d>>2]|0)+2;ivg(b,g)|0;h=c[d>>2]|0;Xug(b,g+16+((h|0)<1?2:h<<1)|0);h=b+20|0;do if(!(a[h>>0]|0)){d=dUf(e)|0;if((d|0)==1){$ug(b,VTf(e)|0);break}else if(!d){$ug(b,VTf(e)|0);break}else if((d|0)==2){$ug(b,VTf(e)|0);$ug(b,fUf(e)|0);break}else break}else if((eUf(e)|0)==2)$ug(b,fUf(e)|0);while(0);d=cUf(e)|0;Vvg(b,d,bUf(e)|0);if((g|0)>=1){$ug(b,aUf(e)|0);Wvg(b,g)}do if(!(a[h>>0]|0)){g=dUf(e)|0;if(!g){Zug(b,32);$ug(b,fUf(e)|0);break}else if((g|0)==1){$ug(b,fUf(e)|0);break}else break}else{g=eUf(e)|0;if((g|0)==1){$ug(b,fUf(e)|0);break}else if(!g){Zug(b,32);$ug(b,fUf(e)|0);break}else break}while(0);e=c[b+60>>2]|0;h=c[b+64>>2]|0;if(a[2540708]|0){j=qL(2540560)|0;k=Awf(j,e,0,h)|0;i=f;return k|0}Ywh(2540560);j=qL(2540560)|0;k=Awf(j,e,0,h)|0;i=f;return k|0}function Tvg(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=c[d+40>>2]|0;h=(g|0)<(e|0)?e:g;g=(a[d+19>>0]|0)==0;RI(3102784)|0;e=(a[3102932]|0)!=0;if(g){if(!e){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;j=(c[775719]|0)+8|0}else{if(!e){RI(3102784)|0;Ywh(3102784)}RI(3102784)|0;j=(c[775719]|0)+12|0}e=c[j>>2]|0;Xug(d,h);c[d+64>>2]=h;j=c[d+60>>2]|0;if((h|0)>0){g=c[d+44>>2]|0;k=c[d+48>>2]|0;d=h;while(1){d=d+-1|0;l=cFi(g|0,k|0,1)|0;b[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>1]=b[e+(l&30)>>1]|0;g=VEi(g|0,k|0,4)|0;if((d|0)<=0)break;else k=H}}if(a[2540708]|0){m=qL(2540560)|0;n=Awf(m,j,0,h)|0;i=f;return n|0}Ywh(2540560);m=qL(2540560)|0;n=Awf(m,j,0,h)|0;i=f;return n|0}function Uvg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;Kph();k=b+20|0;a[g>>0]=a[k>>0]|0;c[h>>2]=0;c[j>>2]=0;l=b+32|0;vug(0,d,g,(c[l>>2]|0)==0,h,j);m=c[j>>2]|0;if(!m){if(!(a[k>>0]|0)){n=VTf(e)|0;i=f;return n|0}if(!(a[2540708]|0))Ywh(2540560);n=c[c[635163]>>2]|0;i=f;return n|0}a[k>>0]=a[g>>0]|0;g=c[h>>2]|0;h=wug(0,d,g,m,0)|0;j=h+24|0;o=c[j>>2]|0;RI(2971904)|0;p=qL(2971904)|0;Ueg(p,o<<1);o=h+12|0;q=c[o>>2]|0;RI(2971904)|0;r=qL(2971904)|0;Ueg(r,q<<1);q=h+36|0;if(!(a[q>>0]|0))s=0;else{t=c[h+40>>2]|0;RI(2971904)|0;u=qL(2971904)|0;Ueg(u,t<<1);s=u}u=c[h+56>>2]|0;if((u|0)>=1)$vg(b,u<<1);u=c[h+60>>2]|0;if((u|0)>=1)$vg(b,u*3|0);u=c[h+52>>2]|0;if((u|0)>=1)cwg(b,u);u=c[o>>2]|0;do if(!(a[q>>0]|0))v=23;else{if((u|0)<=0?(c[j>>2]|0)<1:0){v=23;break}if(!(c[l>>2]|0))w=0;else{gvg(b,(c[j>>2]|0)+u|0);t=b+40|0;x=c[j>>2]|0;y=x-(c[t>>2]|0)|0;c[t>>2]=x;w=y}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}dwg(0,s,(w|0)>-1?w:0-w|0);z=(w|0)<1}while(0);if((v|0)==23){ivg(b,u)|0;z=1}if(!(c[j>>2]|0)){u=c[l>>2]|0;w=b+40|0;if(u){y=c[w>>2]|0;if((y|0)<1){A=w;B=u}else{C=y;v=28}}else{A=w;B=0}}else{C=c[b+40>>2]|0;v=28}if((v|0)==28){ewg(b,(C|0)<1?1:C,p);A=b+40|0;B=c[l>>2]|0}l=c[A>>2]|0;fwg(b,(B|0)>(l|0)?B-l|0:0,r);do if(!(a[q>>0]|0)){l=Yeg(p)|0;B=c[j>>2]|0;b=h+28|0;A=c[b>>2]|0;C=B-A|0;if((l|0)<(C|0)){l=Yeg(p)|0;nfg(p,0,c[902856]|0,C-l|0)|0;D=c[j>>2]|0;E=c[b>>2]|0}else{D=B;E=A}if((D|0)==(E|0)){RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}if(gwg(0,p)|0)efg(p,0,Yeg(p)|0)|0}}else{if((c[o>>2]|0)<=0?(c[j>>2]|0)<=0:0)a[k>>0]=1;A=Yeg(p)|0;B=c[j>>2]|0;if((A|0)<(B|0)){A=Yeg(p)|0;nfg(p,0,c[902854]|0,B-A|0)|0}A=Yeg(s)|0;B=h+40|0;b=h+44|0;if((A|0)<((c[B>>2]|0)-(c[b>>2]|0)|0))do{mfg(s,0,48)|0;A=Yeg(s)|0}while((A|0)<((c[B>>2]|0)-(c[b>>2]|0)|0));if(!z){lfg(s,0,VTf(e)|0)|0;break}if(!(a[h+48>>0]|0))lfg(s,0,iUf(e)|0)|0}while(0);RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}hwg(0,r,1);z=Yeg(r)|0;j=h+20|0;if((z|0)<((c[o>>2]|0)-(c[j>>2]|0)|0))do{acg(r,48)|0;z=Yeg(r)|0}while((z|0)<((c[o>>2]|0)-(c[j>>2]|0)|0));j=Yeg(r)|0;z=c[o>>2]|0;if((j|0)>(z|0)){j=Yeg(r)|0;efg(r,z,j-(c[o>>2]|0)|0)|0}n=xug(h,d,g,m,e,(a[k>>0]|0)!=0,p,r,s)|0;i=f;return n|0}function Vvg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;f=a+32|0;g=c[f>>2]|0;if((g|0)!=0?(h=a+40|0,j=c[h>>2]|0,(j|0)>=1):0){k=b+12|0;l=c[k>>2]|0;if((l|0)>0){m=b+16|0;n=c[(c[b>>2]|0)+120>>2]|0;o=0;p=0;q=0;while(1){r=(c[m+(da(n,q)|0)>>2]|0)+o|0;s=q+1|0;if((j|0)<(r|0)){t=r;u=p;break}if((s|0)<(l|0)){v=q;o=r;q=s;p=v}else{t=r;u=q;break}}if(!((l|0)<1|(t|0)<1)){l=b+16|0;q=c[(c[b>>2]|0)+120>>2]|0;p=c[l+(da(q,u)|0)>>2]|0;o=j-t|0;n=(j|0)>(t|0)?o:0;if(!p){a:do if((u|0)<0)w=u;else{t=u;while(1){m=t+-1|0;if(c[l+(da(q,t)|0)>>2]|0){w=t;break a}if((t|0)<1){w=m;break}else t=m}}while(0);if((n|0)<1){x=w;y=c[l+(da(q,w)|0)>>2]|0;z=15}else{A=w;B=o;z=16}}else{x=u;y=p;z=15}if((z|0)==15)if(!n){C=x;D=y;E=y;F=0}else{A=x;B=y;z=16}if((z|0)==16){z=(n|0)%(B|0)|0;y=(z|0)==0;C=((n|0)/(B|0)|0)+A+(y&1^1)|0;D=y?B:z;E=B;F=0}b:while(1){B=C;z=D;y=F;while(1){A=c[h>>2]|0;n=c[f>>2]|0;if(!((A-y|0)>(z|0)&(z|0)!=0)){G=A;H=n;I=y;break b}A=n-y|0;Xvg(a,A-z|0,A);A=z+y|0;$ug(a,d);n=B+-1|0;if((B|0)<1?1:(B|0)>(c[k>>2]|0)){B=n;z=E;y=A}else{J=A;K=n;break}}y=c[l+(da(c[(c[b>>2]|0)+120>>2]|0,K)|0)>>2]|0;C=K;D=y;E=y;F=J}Xvg(a,H-G|0,H-I|0);i=e;return}}Xvg(a,g-j|0,g);i=e;return}Zug(a,48);i=e;return}function Wvg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+32>>2]|0;f=c[a+40>>2]|0;Xvg(a,e-b-f|0,e-f|0);i=d;return}function Xvg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;if((e|0)<=(d|0)){i=f;return}g=a+64|0;h=(c[g>>2]|0)+(e-d)|0;j=a+60|0;k=c[j>>2]|0;if((h|0)>(c[k+12>>2]|0)){Yug(a,h+10|0);l=c[j>>2]|0}else l=k;c[g>>2]=h;g=c[a+36>>2]|0;k=g+e|0;e=g+d|0;d=l+16|0;g=a+44|0;j=a+48|0;m=a+52|0;n=a+56|0;a=e;o=h;h=e+8-(e&7)|0;while(1){if((h|0)==24)p=c[m>>2]|0;else if((h|0)==8)p=c[g>>2]|0;else if((h|0)==32)p=c[n>>2]|0;else if((h|0)==16)p=c[j>>2]|0;else p=0;e=p>>>(a<<2&28);q=(h|0)>(k|0)?k:h;r=o+-1|0;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,r)|0)>>1]=e&15|48;switch(q-a|0){case 1:{s=r;t=17;break}case 3:{u=r;v=e;t=15;break}case 8:{w=o+-2|0;x=e>>>4;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,w)|0)>>1]=x&15|48;y=w;z=x;t=11;break}case 4:{A=r;B=e;t=14;break}case 5:{C=r;D=e;t=13;break}case 7:{y=r;z=e;t=11;break}case 6:{E=r;F=e;t=12;break}case 2:{G=r;H=e;t=16;break}default:I=r}if((t|0)==11){t=0;r=y+-1|0;e=z>>>4;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,r)|0)>>1]=e&15|48;E=r;F=e;t=12}if((t|0)==12){t=0;e=E+-1|0;r=F>>>4;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,e)|0)>>1]=r&15|48;C=e;D=r;t=13}if((t|0)==13){t=0;r=C+-1|0;e=D>>>4;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,r)|0)>>1]=e&15|48;A=r;B=e;t=14}if((t|0)==14){t=0;e=A+-1|0;r=B>>>4;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,e)|0)>>1]=r&15|48;u=e;v=r;t=15}if((t|0)==15){t=0;r=u+-1|0;e=v>>>4;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,r)|0)>>1]=e&15|48;G=r;H=e;t=16}if((t|0)==16){t=0;e=G+-1|0;b[d+(da(c[(c[l>>2]|0)+120>>2]|0,e)|0)>>1]=H>>>4&15|48;s=e;t=17}if((t|0)==17){t=0;if((q|0)==(k|0))break;else I=s}a=q;o=I;h=q+8|0}i=f;return}function Yvg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+40|0;f=c[e>>2]|0;if((f|0)<=0){_ug(a,48,b);i=d;return}if((f|0)<(b|0)){_ug(a,48,b-f|0);g=c[e>>2]|0}else g=f;f=c[a+32>>2]|0;Xvg(a,f-g|0,f);i=d;return}function Zvg(a){a=a|0;var b=0,c=0;b=i;c=Ynf(a)|0;RI(3102784)|0;a=axh(c,3102784)|0;i=b;return a|0}function _vg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;h=b+40|0;j=c[b+32>>2]|0;k=(c[h>>2]|0)+-1|0;c[h>>2]=1;Xug(b,d+8|0);if(!(a[b+20>>0]|0))$ug(b,VTf(e)|0);awg(b,j+-1|0);if((d|0)>=1){$ug(b,XTf(e)|0);Xvg(b,j+~d|0,j-(c[h>>2]|0)|0)}bwg(b,e,k,f);f=c[b+60>>2]|0;k=c[b+64>>2]|0;if(a[2540708]|0){l=qL(2540560)|0;m=Awf(l,f,0,k)|0;i=g;return m|0}Ywh(2540560);l=qL(2540560)|0;m=Awf(l,f,0,k)|0;i=g;return m|0}function $vg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((b|0)>=1?(c[a+32>>2]|0)!=0:0){e=a+40|0;c[e>>2]=(c[e>>2]|0)+b}i=d;return}function awg(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;g=c[f>>2]|0;h=a+60|0;if((g|0)==(c[(c[h>>2]|0)+12>>2]|0))Yug(a,g+10|0);g=(c[a+36>>2]|0)+d|0;do if((g|0)>-1){if((g|0)<=7){j=c[a+44>>2]|0;break}if((g|0)<=15){j=c[a+48>>2]|0;break}if((g|0)<=23){j=c[a+52>>2]|0;break}if((g|0)<=31)j=c[a+56>>2]|0;else j=0}else j=0;while(0);a=c[h>>2]|0;h=c[f>>2]|0;c[f>>2]=h+1;b[a+16+(da(c[(c[a>>2]|0)+120>>2]|0,h)|0)>>1]=j>>>(g<<2&28)&15|48;i=e;return}function bwg(c,d,e,f){c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((a[c+19>>0]|0)==0?(b[c+22>>1]|0)!=82:0)Zug(c,101);else Zug(c,69);if((e|0)<0){$ug(c,VTf(d)|0);h=0-e|0}else{$ug(c,iUf(d)|0);h=e}if(!h){_ug(c,48,f);i=g;return}if((h|0)<=9){_ug(c,48,f+-1|0);Zug(c,(h|48)&65535);i=g;return}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}e=Eug(0,h)|0;if(!((h|0)<100&(f|0)!=3))Zug(c,(e>>>8|48)&65535);Zug(c,(e>>>4&15|48)&65535);Zug(c,(e&15|48)&65535);i=g;return}function cwg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if((b|0)>=1?(c[a+32>>2]|0)!=0:0){e=a+40|0;c[e>>2]=(c[e>>2]|0)-b}i=d;return}function dwg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;if((d|0)<=-1){RI(2965048)|0;e=qL(2965048)|0;oig(e);Zwh(e)}RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}e=d;f=Lug(0,d,((d|0)<0)<<31>>31)|0;do{f=f+-1|0;RI(3102784)|0;if(!(a[3102932]|0)){RI(3102784)|0;Ywh(3102784)}d=Cug(0,f)|0;g=(e|0)/(d|0)|0;acg(c,(g|48)&65535)|0;d=Cug(0,f)|0;e=e-(da(d,g)|0)|0}while((f|0)>0);i=b;return}function ewg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a+40|0;g=c[f>>2]|0;if((g|0)<=0){afg(d,48,b)|0;i=e;return}if((g|0)<(b|0)){afg(d,48,b-g|0)|0;h=c[f>>2]|0}else h=g;g=c[a+32>>2]|0;iwg(a,g-h|0,g,d);i=e;return}function fwg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[a+32>>2]|0;g=c[a+40>>2]|0;iwg(a,f-b-g|0,f-g|0,d);i=e;return}function gwg(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;if((Yeg(c)|0)>0)d=0;else{e=1;i=b;return e|0}while(1){f=bfg(c,d)|0;RI(2540392)|0;if(!(a[2540540]|0)){RI(2540392)|0;Ywh(2540392)}if(jpf(0,f)|0?(bfg(c,d)|0)<<16>>16!=48:0){e=0;g=7;break}d=d+1|0;if((d|0)>=(Yeg(c)|0)){e=1;g=7;break}}if((g|0)==7){i=b;return e|0}return 0}function hwg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;a=i;d=Yeg(b)|0;e=d+-1|0;if(((c?d:e)|0)>0){f=0;g=e}else{i=a;return}while(1){e=f+1|0;if((bfg(b,g)|0)<<16>>16!=48){h=f;break}d=g;g=g+-1|0;if(((c?d:g)|0)<=0){h=e;break}else f=e}if((h|0)<1){i=a;return}efg(b,(Yeg(b)|0)-h|0,h)|0;i=a;return}function iwg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;if((d|0)<=(b|0)){i=f;return}g=(Yeg(e)|0)+(d-b)|0;Zeg(e,g);h=c[a+36>>2]|0;j=h+d|0;d=h+b|0;b=a+44|0;h=a+48|0;k=a+52|0;l=a+56|0;a=d;m=g;g=d+8-(d&7)|0;while(1){if((g|0)==8)n=c[b>>2]|0;else if((g|0)==32)n=c[l>>2]|0;else if((g|0)==24)n=c[k>>2]|0;else if((g|0)==16)n=c[h>>2]|0;else n=0;d=n>>>(a<<2&28);o=(g|0)>(j|0)?j:g;p=m+-1|0;cfg(e,p,(d&15|48)&65535);switch(o-a|0){case 3:{q=p;r=d;s=13;break}case 6:{t=p;u=d;s=10;break}case 2:{v=p;w=d;s=14;break}case 5:{x=p;y=d;s=11;break}case 4:{z=p;A=d;s=12;break}case 8:{B=m+-2|0;C=d>>>4;cfg(e,B,(C&15|48)&65535);D=B;E=C;s=9;break}case 1:{F=p;s=15;break}case 7:{D=p;E=d;s=9;break}default:G=p}if((s|0)==9){s=0;p=D+-1|0;d=E>>>4;cfg(e,p,(d&15|48)&65535);t=p;u=d;s=10}if((s|0)==10){s=0;d=t+-1|0;p=u>>>4;cfg(e,d,(p&15|48)&65535);x=d;y=p;s=11}if((s|0)==11){s=0;p=x+-1|0;d=y>>>4;cfg(e,p,(d&15|48)&65535);z=p;A=d;s=12}if((s|0)==12){s=0;d=z+-1|0;p=A>>>4;cfg(e,d,(p&15|48)&65535);q=d;r=p;s=13}if((s|0)==13){s=0;p=q+-1|0;d=r>>>4;cfg(e,p,(d&15|48)&65535);v=p;w=d;s=14}if((s|0)==14){s=0;d=v+-1|0;cfg(e,d,(w>>>4&15|48)&65535);F=d;s=15}if((s|0)==15){s=0;if((o|0)==(j|0))break;else G=F}a=o;m=G;g=o+8|0}i=f;return}function jwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(3076712)|0;c[c[d>>2]>>2]=a;i=b;return}function kwg(a,b){a=a|0;b=b|0;var d=0;d=i;Lph();osg(a,tof(0,c[902860]|0)|0);c[a+52>>2]=b;c[a+56>>2]=tof(0,c[902862]|0)|0;i=d;return}function lwg(a){a=a|0;return c[a+56>>2]|0}function mwg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;Mph();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];THf(a,b,f);L7f(b,c[902888]|0,c[a+52>>2]|0);i=e;return}function nwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function owg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Tnf(0,b,c)|0;i=a;return d|0}function pwg(a){a=a|0;return c[a+8>>2]|0}function qwg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;i=i+16|0;e=d;Oph();c[e>>2]=c[a+8>>2];RI(3113544)|0;f=pL(3113544,e)|0;L7f(b,c[902902]|0,f);L7f(b,c[902904]|0,c[a+12>>2]|0);L7f(b,c[902906]|0,c[a+16>>2]|0);i=d;return}function rwg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;Pph();switch(c[b+8>>2]|0){case 0:{e=c[902928]|0;break}case 6:{e=c[902938]|0;break}case 5:{e=c[902936]|0;break}case 1:{e=c[902930]|0;break}case 128:case 4:{e=c[902934]|0;break}case 2:{e=c[902926]|0;break}case 3:{e=c[902932]|0;break}default:e=tof(0,c[902940]|0)|0}f=Fqh(3113712,c[b+12>>2]|0)|0;if(a[2540708]|0){g=c[902942]|0;h=iwf(0,e,g,f)|0;i=d;return h|0}Ywh(2540560);g=c[902942]|0;h=iwf(0,e,g,f)|0;i=d;return h|0}function swg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function twg(a){a=a|0;var b=0;b=i;Qph();Grg(a,tof(0,c[902996]|0)|0);KHf(a,-2147024882);i=b;return}function uwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function vwg(a){a=a|0;var b=0;b=i;Rph();zig(a,tof(0,c[903008]|0)|0);KHf(a,-2146233066);i=b;return}function wwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function xwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ywg(a){a=a|0;var b=0;b=i;Sph();Grg(a,tof(0,c[903020]|0)|0);KHf(a,-2146233065);i=b;return}function zwg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233065);i=c;return}function Awg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Bwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Cwg(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];return}function Dwg(a){a=a|0;return c[a>>2]|0}function Ewg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;Tph();if(!d){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[903050]|0);Zwh(m)}c[h>>2]=c[b>>2];RI(2604248)|0;c[j>>2]=c[c[651085]>>2];c[g+0>>2]=c[h+0>>2];c[f+0>>2]=c[j+0>>2];if(FAf(0,g,f)|0){RI(2955448)|0;g=qL(2955448)|0;cag(g,c[903052]|0);Zwh(g)}c[k>>2]=c[b>>2];c[f+0>>2]=c[k+0>>2];k=H1f(0,f)|0;RI(2540728)|0;if(a[2540876]|0){c[l>>2]=3447496;c[f+0>>2]=c[l+0>>2];n=npf(0,f)|0;o=c[903054]|0;RI(2873528)|0;p=axh(k,2873528)|0;q9f(d,o,p,n);i=e;return}RI(2540728)|0;Ywh(2540728);c[l>>2]=3447496;c[f+0>>2]=c[l+0>>2];n=npf(0,f)|0;o=c[903054]|0;RI(2873528)|0;p=axh(k,2873528)|0;q9f(d,o,p,n);i=e;return}function Fwg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;if(!b){k=0;i=d;return k|0}c[g>>2]=c[a>>2];RI(3116224)|0;l=Xnf(pL(3116224,g)|0)|0;if((l|0)!=(Xnf(b)|0)){k=0;i=d;return k|0}l=c[a>>2]|0;RI(3116224)|0;a=c[(Xwh(b,3116224)|0)>>2]|0;c[h>>2]=l;c[j>>2]=a;c[f+0>>2]=c[h+0>>2];c[e+0>>2]=c[j+0>>2];k=FAf(0,f,e)|0;i=d;return k|0}function Gwg(a){a=a|0;var b=0,c=0;b=i;c=CAf(a)|0;i=b;return c|0}function Hwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2662936)|0;bIf(a,sM(3116792)|0);c[c[d>>2]>>2]=a;a=qL(2537168)|0;aof(a,1);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function Iwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2896008)|0;r5f(a,3,2);c[c[d>>2]>>2]=a;i=b;return}function Jwg(a){a=a|0;return}function Kwg(b){b=b|0;var d=0,e=0;b=i;RI(2686624)|0;if(!(a[2686772]|0)){RI(2686624)|0;Ywh(2686624)}d=eKf(0)|0;RI(3116952)|0;e=qL(3116952)|0;Lwg(e,d,1);RI(3117120)|0;c[c[779303]>>2]=e;e=eKf(0)|0;RI(3116952)|0;d=qL(3116952)|0;Lwg(d,e,0);RI(3117120)|0;c[(c[779303]|0)+4>>2]=d;RI(3117288)|0;d=qL(3117288)|0;a[d+8>>0]=1;RI(3117120)|0;c[(c[779303]|0)+8>>2]=d;RI(3117288)|0;d=qL(3117288)|0;a[d+8>>0]=0;RI(3117120)|0;c[(c[779303]|0)+12>>2]=d;i=b;return}function Lwg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;c[b+12>>2]=Fuh(2723944,d)|0;a[b+8>>0]=e&1;i=f;return}function Mwg(b,c){b=b|0;c=c|0;a[b+8>>0]=c&1;return}function Nwg(b){b=b|0;b=i;RI(3117120)|0;if(!(a[3117268]|0)){RI(3117120)|0;Ywh(3117120)}RI(3117120)|0;i=b;return c[c[779303]>>2]|0}function Owg(b){b=b|0;b=i;RI(3117120)|0;if(!(a[3117268]|0)){RI(3117120)|0;Ywh(3117120)}RI(3117120)|0;i=b;return c[(c[779303]|0)+8>>2]|0}function Pwg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==(c|0)){e=0;i=d;return e|0}if(!b){e=-1;i=d;return e|0}if(!c){e=1;i=d;return e|0}f=vL(b,2540560)|0;if((f|0)!=0?(g=vL(c,2540560)|0,(g|0)!=0):0){e=tvh(3117456,a,f,g)|0;i=d;return e|0}RI(2546528)|0;g=vL(b,2546528)|0;if(!g){RI(2965048)|0;b=qL(2965048)|0;oig(b);Zwh(b)}e=Zqh(2546712,g,c)|0;i=d;return e|0}function Qwg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==(c|0)){e=1;i=d;return e|0}if(!((b|0)!=0&(c|0)!=0)){e=0;i=d;return e|0}f=vL(b,2540560)|0;if((f|0)!=0?(g=vL(c,2540560)|0,(g|0)!=0):0){e=jxh(3117512,a,f,g)|0;i=d;return e|0}e=nrh(2536048,b,c)|0;i=d;return e|0}function Rwg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;Uph();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[903064]|0);Zwh(e)}e=vL(b,2540560)|0;if(!e){f=Aqh(2536720,b)|0;i=d;return f|0}else{f=kxh(3117568,a,e)|0;i=d;return f|0}return 0}function Swg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Twg(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0;f=i;g=Nuh(2724e3,c[a+12>>2]|0,b,e,d[a+8>>0]|0)|0;i=f;return g|0}function Uwg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=(tvh(3118632,a,b,c)|0)==0;i=d;return e|0}function Vwg(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;Vph();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[903068]|0);Zwh(f)}else{f=Aqh(2695488,lxh(2753952,c[a+12>>2]|0,b,d[a+8>>0]|0)|0)|0;i=e;return f|0}return 0}function Wwg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=i;f=(a[2540708]|0)!=0;if(!(a[b+8>>0]|0)){if(!f)Ywh(2540560);g=vvf(0,c,0,2147483647,d,0,2147483647)|0;i=e;return g|0}else{if(!f)Ywh(2540560);g=wvf(0,c,0,2147483647,d,0,2147483647)|0;i=e;return g|0}return 0}function Xwg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;if(a[b+8>>0]|0){f=(tvh(3119192,b,c,d)|0)==0;i=e;return f|0}if(!(a[2540708]|0))Ywh(2540560);f=gpf(0,c,d)|0;i=e;return f|0}function Ywg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Wph();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[903072]|0);Zwh(f)}if(!(a[b+8>>0]|0)){g=Aqh(2582544,d)|0;i=e;return g|0}else{g=twf(d)|0;i=e;return g|0}return 0}function Zwg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _wg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;a=qL(2539536)|0;wof(a,256);Cpf(a,0);c[(c[d>>2]|0)+4>>2]=a;i=b;return}function $wg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=b;c[e+4>>2]=d;return}function axg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;Ywh(3120120)}h=bxg(0,0,d,e,f,0)|0;f=b;c[f>>2]=h;c[f+4>>2]=H;i=g;return}function bxg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;a=i;Xph();h=(e*60|0)+(d*3600|0)+f|0;f=gFi(h|0,((h|0)<0)<<31>>31|0,1e3,0)|0;h=_Ei(f|0,H|0,g|0,((g|0)<0)<<31>>31|0)|0;g=H;f=gFi(h|0,g|0,1e4,0)|0;d=H;do if((b|0)<1){if((b|0)>-1){j=d;k=f;H=j;i=a;return k|0}e=gFi(b|0,((b|0)<0)<<31>>31|0,711573504,201)|0;l=_Ei(f|0,d|0,e|0,H|0)|0;e=H;if((g|0)>0|(g|0)==0&h>>>0>0){if((b|0)>0)break;else{j=e;k=l}H=j;i=a;return k|0}else{if((e|0)>0|(e|0)==0&l>>>0>0)break;else{j=e;k=l}H=j;i=a;return k|0}}else{l=gFi(b|0,((b|0)<0)<<31>>31|0,711573504,201)|0;e=_Ei(f|0,d|0,l|0,H|0)|0;l=H;if(!(((g|0)>-1|(g|0)==-1&h>>>0>4294967295)&(l|0)<0)){j=l;k=e;H=j;i=a;return k|0}}while(0);k=tof(0,c[903076]|0)|0;RI(2964880)|0;a=qL(2964880)|0;wdg(a,k);Zwh(a);return 0}function cxg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;Ywh(3120120)}k=bxg(0,d,e,f,g,h)|0;h=b;c[h>>2]=k;c[h+4>>2]=H;i=j;return}function dxg(b){b=b|0;var d=0;b=i;RI(3120120)|0;d=c[780053]|0;c[d>>2]=-1;c[d+4>>2]=2147483647;RI(3120120)|0;d=(c[780053]|0)+8|0;c[d>>2]=0;c[d+4>>2]=-2147483648;RI(3120120)|0;d=(c[780053]|0)+16|0;c[d>>2]=0;c[d+4>>2]=0;RI(3080672)|0;if(!(a[3080820]|0)){RI(3080672)|0;Ywh(3080672)}RI(3080672)|0;if(!(a[c[770191]>>0]|0)){i=b;return}RI(1750008)|0;DFe(qL(1750008)|0);RI(1751976)|0;LFe(qL(1751976)|0);i=b;return}function exg(a){a=a|0;var b=0,d=0;b=i;d=a;a=eFi(c[d>>2]|0,c[d+4>>2]|0,711573504,201)|0;i=b;return a|0}function fxg(a){a=a|0;var b=0,d=0;b=i;d=a;a=fFi(c[d>>2]|0,c[d+4>>2]|0,711573504,201)|0;d=eFi(a|0,H|0,1640261632,8)|0;i=b;return d|0}function gxg(a){a=a|0;var b=0,d=0;b=i;d=a;a=fFi(c[d>>2]|0,c[d+4>>2]|0,1e7,0)|0;d=eFi(a|0,H|0,1e4,0)|0;i=b;return d|0}function hxg(a){a=a|0;var b=0,d=0;b=i;d=a;a=fFi(c[d>>2]|0,c[d+4>>2]|0,1640261632,8)|0;d=eFi(a|0,H|0,6e8,0)|0;i=b;return d|0}function ixg(a){a=a|0;var b=0,d=0;b=i;d=a;a=fFi(c[d>>2]|0,c[d+4>>2]|0,6e8,0)|0;d=eFi(a|0,H|0,1e7,0)|0;i=b;return d|0}function jxg(a){a=a|0;var b=0,d=0;b=i;d=a;H=c[d+4>>2]|0;i=b;return c[d>>2]|0}function kxg(a){a=a|0;var b=0;b=a;return +((+((c[b>>2]|0)>>>0)+4294967296.0*+(c[b+4>>2]|0))/864.0e9)}function lxg(a){a=a|0;var b=0;b=a;return +((+((c[b>>2]|0)>>>0)+4294967296.0*+(c[b+4>>2]|0))/36.0e9)}function mxg(a){a=a|0;var b=0;b=a;return +((+((c[b>>2]|0)>>>0)+4294967296.0*+(c[b+4>>2]|0))/1.0e4)}function nxg(a){a=a|0;var b=0;b=a;return +((+((c[b>>2]|0)>>>0)+4294967296.0*+(c[b+4>>2]|0))/6.0e8)}function oxg(a){a=a|0;var b=0;b=a;return +((+((c[b>>2]|0)>>>0)+4294967296.0*+(c[b+4>>2]|0))/1.0e7)}function pxg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;Yph();e=a;a=b;b=_Ei(c[a>>2]|0,c[a+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;i=d;return b|0}function qxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;a=i;e=b;b=c[e>>2]|0;f=c[e+4>>2]|0;e=d;d=c[e>>2]|0;g=c[e+4>>2]|0;if((f|0)<(g|0)|(f|0)==(g|0)&b>>>0<d>>>0){h=-1;i=a;return h|0}h=((f|0)>(g|0)|(f|0)==(g|0)&b>>>0>d>>>0)&1;i=a;return h|0}function rxg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;Zph();if(!d){f=1;i=e;return f|0}RI(3120120)|0;if(!(vL(d,3120120)|0)){g=tof(0,c[903120]|0)|0;RI(2965048)|0;h=qL(2965048)|0;Rag(h,g,c[903122]|0);Zwh(h)}RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;Ywh(3120120)}h=b;b=c[h>>2]|0;g=c[h+4>>2]|0;RI(3120120)|0;h=Xwh(d,3120120)|0;d=c[h>>2]|0;j=c[h+4>>2]|0;if((g|0)<(j|0)|(g|0)==(j|0)&b>>>0<d>>>0){f=-1;i=e;return f|0}f=((g|0)>(j|0)|(g|0)==(j|0)&b>>>0>d>>>0)&1;i=e;return f|0}function sxg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;Ywh(3120120)}f=b;b=c[f>>2]|0;g=c[f+4>>2]|0;f=d;d=c[f>>2]|0;h=c[f+4>>2]|0;if((g|0)<(h|0)|(g|0)==(h|0)&b>>>0<d>>>0){j=-1;i=e;return j|0}j=((g|0)>(h|0)|(g|0)==(h|0)&b>>>0>d>>>0)&1;i=e;return j|0}function txg(a,b){a=a|0;b=b|0;var d=0;d=b;b=a;return ((c[d>>2]|0)==(c[b>>2]|0)?(c[d+4>>2]|0)==(c[b+4>>2]|0):0)|0}function uxg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;_ph();d=a;a=c[d>>2]|0;e=c[d+4>>2]|0;d=(e|0)>-1|(e|0)==-1&a>>>0>4294967295;f=ZEi(0,0,a|0,e|0)|0;H=d?e:H;i=b;return (d?a:f)|0}function vxg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;RI(3120120)|0;if(!(vL(b,3120120)|0)){e=0;i=d;return e|0}f=a;a=c[f>>2]|0;g=c[f+4>>2]|0;RI(3120120)|0;f=Xwh(b,3120120)|0;e=(a|0)==(c[f>>2]|0)?(g|0)==(c[f+4>>2]|0):0;i=d;return e|0}function wxg(a){a=a|0;var b=0,c=0;b=i;c=Zpf(a)|0;i=b;return c|0}function xxg(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;$ph();e=b;f=c[e>>2]|0;g=c[e+4>>2]|0;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;Ywh(3120120)}RI(3120120)|0;e=(c[780053]|0)+8|0;if((f|0)==(c[e>>2]|0)?(g|0)==(c[e+4>>2]|0):0){e=tof(0,c[903178]|0)|0;RI(3086272)|0;g=qL(3086272)|0;xsg(g,e);Zwh(g)}else{g=b;b=ZEi(0,0,c[g>>2]|0,c[g+4>>2]|0)|0;i=d;return b|0}return 0}function yxg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;aqh();e=a;a=b;b=ZEi(c[e>>2]|0,c[e+4>>2]|0,c[a>>2]|0,c[a+4>>2]|0)|0;i=d;return b|0}function zxg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=0;c[e>>2]=0;c[f>>2]=0;c[g>>2]=0;bqh();RI(2971904)|0;h=qL(2971904)|0;Ueg(h,14);j=a;k=c[j>>2]|0;l=c[j+4>>2]|0;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295){m=k;n=l}else{acg(h,45)|0;l=a;m=c[l>>2]|0;n=c[l+4>>2]|0}l=eFi(m|0,n|0,711573504,201)|0;if(!l){o=m;p=n}else{gfg(h,(l|0)>-1?l:0-l|0)|0;acg(h,46)|0;l=a;o=c[l>>2]|0;p=c[l+4>>2]|0}l=fFi(o|0,p|0,711573504,201)|0;p=eFi(l|0,H|0,1640261632,8)|0;c[e>>2]=(p|0)>-1?p:0-p|0;Hbg(h,upf(e,c[903214]|0)|0)|0;acg(h,58)|0;e=a;p=fFi(c[e>>2]|0,c[e+4>>2]|0,1640261632,8)|0;e=eFi(p|0,H|0,6e8,0)|0;c[f>>2]=(e|0)>-1?e:0-e|0;Hbg(h,upf(f,c[903216]|0)|0)|0;acg(h,58)|0;f=a;e=fFi(c[f>>2]|0,c[f+4>>2]|0,6e8,0)|0;f=eFi(e|0,H|0,1e7,0)|0;c[g>>2]=(f|0)>-1?f:0-f|0;Hbg(h,upf(g,c[903218]|0)|0)|0;g=a;a=fFi(c[g>>2]|0,c[g+4>>2]|0,1e7,0)|0;g=H;f=(g|0)>-1|(g|0)==-1&a>>>0>4294967295;e=ZEi(0,0,a|0,g|0)|0;g=H;g=f?a:e;c[d>>2]=g;if(!g){q=Fqh(2972072,h)|0;i=b;return q|0}acg(h,46)|0;Hbg(h,upf(d,c[903220]|0)|0)|0;q=Fqh(2972072,h)|0;i=b;return q|0}function Axg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;e=d;d=c[e>>2]|0;f=c[e+4>>2]|0;Yph();e=b;b=_Ei(c[e>>2]|0,c[e+4>>2]|0,d|0,f|0)|0;i=a;return b|0}function Bxg(a,b,d){a=a|0;b=b|0;d=d|0;a=b;b=d;return ((c[a>>2]|0)==(c[b>>2]|0)?(c[a+4>>2]|0)==(c[b+4>>2]|0):0)|0}function Cxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=b;b=c[a+4>>2]|0;e=d;d=c[e+4>>2]|0;return (b|0)>(d|0)|((b|0)==(d|0)?(c[a>>2]|0)>>>0>(c[e>>2]|0)>>>0:0)|0}function Dxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=b;b=c[a+4>>2]|0;e=d;d=c[e+4>>2]|0;return (b|0)>(d|0)|((b|0)==(d|0)?(c[a>>2]|0)>>>0>=(c[e>>2]|0)>>>0:0)|0}function Exg(a,b,d){a=a|0;b=b|0;d=d|0;a=b;b=d;return ((c[a>>2]|0)!=(c[b>>2]|0)?1:(c[a+4>>2]|0)!=(c[b+4>>2]|0))|0}function Fxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=b;b=c[a+4>>2]|0;e=d;d=c[e+4>>2]|0;return (b|0)<(d|0)|((b|0)==(d|0)?(c[a>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)|0}function Gxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=b;b=c[a+4>>2]|0;e=d;d=c[e+4>>2]|0;return (b|0)<(d|0)|((b|0)==(d|0)?(c[a>>2]|0)>>>0<=(c[e>>2]|0)>>>0:0)|0}function Hxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;e=d;d=c[e>>2]|0;f=c[e+4>>2]|0;aqh();e=b;b=ZEi(c[e>>2]|0,c[e+4>>2]|0,d|0,f|0)|0;i=a;return b|0}function Ixg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Jxg(a){a=a|0;return}function Kxg(b){b=b|0;var d=0,e=0,f=0;b=i;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}d=Cpg(0)|0;e=H;RI(3123632)|0;f=qL(3123632)|0;Lxg(f,d,e);RI(3123800)|0;c[c[780973]>>2]=f;i=b;return}function Lxg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f;k=f+16|0;c[g>>2]=0;c[h>>2]=0;c[j+0>>2]=c[781288];c[j+4>>2]=c[781289];c[j+8>>2]=c[781290];c[j+12>>2]=c[781291];dqh();RI(2730168)|0;if(!(a[2730316]|0)){RI(2730168)|0;Ywh(2730168)}RI(2730168)|0;l=qL(2730168)|0;rPf(l,1);m=b+16|0;c[m>>2]=l;Wog(j,d,e);if(Uxg(0,Gpg(j)|0,g,h)|0){c[b+8>>2]=tof(0,c[(c[h>>2]|0)+16>>2]|0)|0;e=c[h>>2]|0;c[b+12>>2]=tof(0,c[e+16+(c[(c[e>>2]|0)+120>>2]|0)>>2]|0)|0;e=c[g>>2]|0;g=e+16+(c[(c[e>>2]|0)+120>>2]<<1)|0;h=c[g+4>>2]|0;d=b+24|0;c[d>>2]=c[g>>2];c[d+4>>2]=h;h=Vxg(0,e)|0;e=c[m>>2]|0;c[k>>2]=Gpg(j)|0;RI(2540224)|0;Rrh(2734016,e,pL(2540224,k)|0,h);Wxg(b,h);i=f;return}else{f=tof(0,c[903240]|0)|0;RI(3100472)|0;h=qL(3100472)|0;pug(h,f);Zwh(h)}}function Mxg(b){b=b|0;b=i;RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;Ywh(3123800)}RI(3123800)|0;i=b;return c[c[780973]>>2]|0}function Nxg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=mxh(3123968,b,Gpg(d)|0)|0;RI(3123800)|0;if(!(a[3123948]|0)){RI(3123800)|0;Ywh(3123800)};c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=Oxg(0,f,g)|0;i=e;return d|0}function Oxg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;a=i;i=i+320|0;e=a+144|0;f=a+96|0;g=a+80|0;h=a+272|0;j=a+128|0;k=a+64|0;l=a+192|0;m=a+224|0;n=a+256|0;o=a+288|0;p=a+304|0;q=a+160|0;r=a+32|0;s=a;t=a+16|0;u=a+176|0;v=a+208|0;w=a+112|0;x=a+240|0;y=a+48|0;c[e+0>>2]=c[781288];c[e+4>>2]=c[781289];c[e+8>>2]=c[781290];c[e+12>>2]=c[781291];c[f+0>>2]=c[781288];c[f+4>>2]=c[781289];c[f+8>>2]=c[781290];c[f+12>>2]=c[781291];c[g+0>>2]=c[781288];c[g+4>>2]=c[781289];c[g+8>>2]=c[781290];c[g+12>>2]=c[781291];c[h+0>>2]=c[781288];c[h+4>>2]=c[781289];c[h+8>>2]=c[781290];c[h+12>>2]=c[781291];c[j+0>>2]=c[781288];c[j+4>>2]=c[781289];c[j+8>>2]=c[781290];c[j+12>>2]=c[781291];c[k+0>>2]=c[781288];c[k+4>>2]=c[781289];c[k+8>>2]=c[781290];c[k+12>>2]=c[781291];c[l+0>>2]=c[781288];c[l+4>>2]=c[781289];c[l+8>>2]=c[781290];c[l+12>>2]=c[781291];c[m+0>>2]=c[781288];c[m+4>>2]=c[781289];c[m+8>>2]=c[781290];c[m+12>>2]=c[781291];c[n+0>>2]=c[781288];c[n+4>>2]=c[781289];c[n+8>>2]=c[781290];c[n+12>>2]=c[781291];c[o+0>>2]=c[781288];c[o+4>>2]=c[781289];c[o+8>>2]=c[781290];c[o+12>>2]=c[781291];cqh();if(!d){RI(2963920)|0;z=qL(2963920)|0;Iag(z,c[903228]|0);Zwh(z)}tTf(p,d);c[e+0>>2]=c[p+0>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[e+12>>2]=c[p+12>>2];p=Xog(e)|0;e=H;uTf(q,d);c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];q=Xog(f)|0;if((p|0)==(q|0)&(e|0)==(H|0)){A=0;i=a;return A|0}tTf(r,d);c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];r=Xog(g)|0;g=H;uTf(s,d);c[h+0>>2]=c[s+0>>2];c[h+4>>2]=c[s+4>>2];c[h+8>>2]=c[s+8>>2];c[h+12>>2]=c[s+12>>2];s=Xog(h)|0;h=H;if((g|0)<(h|0)|(g|0)==(h|0)&r>>>0<s>>>0){tTf(t,d);c[j+0>>2]=c[t+0>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[j+12>>2]=c[t+12>>2];t=Xog(j)|0;j=H;s=Xog(b)|0;r=H;if((j|0)<(r|0)|(j|0)==(r|0)&t>>>0<s>>>0?(uTf(u,d),c[k+0>>2]=c[u+0>>2],c[k+4>>2]=c[u+4>>2],c[k+8>>2]=c[u+8>>2],c[k+12>>2]=c[u+12>>2],u=Xog(k)|0,k=H,s=Xog(b)|0,t=H,(k|0)>(t|0)|(k|0)==(t|0)&u>>>0>s>>>0):0){A=1;i=a;return A|0}}else{s=Gpg(b)|0;tTf(v,d);c[l+0>>2]=c[v+0>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];c[l+12>>2]=c[v+12>>2];if((s|0)==(Gpg(l)|0)?(l=Gpg(b)|0,uTf(w,d),c[m+0>>2]=c[w+0>>2],c[m+4>>2]=c[w+4>>2],c[m+8>>2]=c[w+8>>2],c[m+12>>2]=c[w+12>>2],(l|0)==(Gpg(m)|0)):0){m=Xog(b)|0;l=H;uTf(x,d);c[n+0>>2]=c[x+0>>2];c[n+4>>2]=c[x+4>>2];c[n+8>>2]=c[x+8>>2];c[n+12>>2]=c[x+12>>2];x=Xog(n)|0;n=H;if((l|0)<(n|0)|(l|0)==(n|0)&m>>>0<x>>>0){A=1;i=a;return A|0}x=Xog(b)|0;b=H;tTf(y,d);c[o+0>>2]=c[y+0>>2];c[o+4>>2]=c[y+4>>2];c[o+8>>2]=c[y+8>>2];c[o+12>>2]=c[y+12>>2];y=Xog(o)|0;o=H;if((b|0)>(o|0)|(b|0)==(o|0)&x>>>0>y>>>0){A=1;i=a;return A|0}}}A=0;i=a;return A|0}function Pxg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+224|0;g=f+24|0;h=f+72|0;j=f+152|0;k=f+184|0;l=f+104|0;m=f+136|0;n=f+168|0;o=f+200|0;p=f+208|0;q=f+16|0;r=f+88|0;s=f+40|0;t=f;u=f+56|0;v=f+120|0;w=f+64|0;c[k+0>>2]=c[781288];c[k+4>>2]=c[781289];c[k+8>>2]=c[781290];c[k+12>>2]=c[781291];c[l+0>>2]=c[781288];c[l+4>>2]=c[781289];c[l+8>>2]=c[781290];c[l+12>>2]=c[781291];c[m+0>>2]=c[781288];c[m+4>>2]=c[781289];c[m+8>>2]=c[781290];c[m+12>>2]=c[781291];if((Hpg(e)|0)==2){c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=f;return};c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];iM(h,3124024,d);x=c[(c[h+4>>2]|0)+4>>2]|0;y=c[h>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];z=_n[x&4095](y,g)|0;y=H;if((y|0)<0|(y|0)==0&z>>>0<1){if(!((y|0)>-1|(y|0)==-1&z>>>0>4294967295)){x=Xog(e)|0;A=H;RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;B=(c[758637]|0)+16|0;c[l+0>>2]=c[B+0>>2];c[l+4>>2]=c[B+4>>2];c[l+8>>2]=c[B+8>>2];c[l+12>>2]=c[B+12>>2];B=Xog(l)|0;l=H;C=_Ei(x|0,A|0,z|0,y|0)|0;A=H;if((A|0)<(l|0)|(A|0)==(l|0)&C>>>0<B>>>0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;B=(c[758637]|0)+16|0;c[g+0>>2]=c[B+0>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];Qpg(b,0,g,2);i=f;return}}}else{RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;B=c[758637]|0;C=o;c[C>>2]=z;c[C+4>>2]=y;c[h+0>>2]=c[B+0>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2];c[h+12>>2]=c[B+12>>2];c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];uqg(n,0,h,g);c[h+0>>2]=c[n+0>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[h+12>>2]=c[n+12>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];if(sqg(0,h,g)|0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;n=c[758637]|0;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];Qpg(b,0,g,2);i=f;return}}n=q;c[n>>2]=z;c[n+4>>2]=y;c[g+0>>2]=c[q+0>>2];c[g+4>>2]=c[q+4>>2];Ipg(p,e,g);c[k+0>>2]=c[p+0>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];p=mxh(3123968,d,Gpg(e)|0)|0;q=vTf(p)|0;if((q|0)==0&(H|0)==0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];Qpg(b,0,g,2);i=f;return}uTf(r,p);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];if(sqg(0,h,g)|0){uTf(s,p);c[m+0>>2]=c[s+0>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];s=vTf(p)|0;p=u;c[p>>2]=s;c[p+4>>2]=H;c[g+0>>2]=c[u+0>>2];c[g+4>>2]=c[u+4>>2];lqg(t,m,g);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[h+0>>2]=c[t+0>>2];c[h+4>>2]=c[t+4>>2];c[h+8>>2]=c[t+8>>2];c[h+12>>2]=c[t+12>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];if(tqg(0,h,g)|0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];Qpg(b,0,g,2);i=f;return}};c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];iM(h,3124024,d);d=c[(c[h+4>>2]|0)+4>>2]|0;k=c[h>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];j=_n[d&4095](k,g)|0;k=w;c[k>>2]=j;c[k+4>>2]=H;c[g+0>>2]=c[w+0>>2];c[g+4>>2]=c[w+4>>2];Ipg(v,e,g);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[g+0>>2]=c[v+0>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];Qpg(b,0,g,2);i=f;return}function Qxg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+112|0;g=f+16|0;h=f+56|0;j=f+32|0;k=f+72|0;l=f+104|0;m=f;n=f+48|0;o=f+88|0;if((Hpg(e)|0)==1){c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2];i=f;return};c[j+0>>2]=c[e+0>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];iM(h,3124024,d);d=c[(c[h+4>>2]|0)+4>>2]|0;p=c[h>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];j=_n[d&4095](p,g)|0;p=H;if((p|0)>-1|(p|0)==-1&j>>>0>4294967295){if(!((p|0)<0|(p|0)==0&j>>>0<1)){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;d=(c[758637]|0)+16|0;q=n;c[q>>2]=j;c[q+4>>2]=p;c[h+0>>2]=c[d+0>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];Epg(m,0,h,g);c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];if(qqg(0,h,g)|0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;m=(c[758637]|0)+16|0;c[g+0>>2]=c[m+0>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];Qpg(b,0,g,1);i=f;return}}}else{RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;m=c[758637]|0;n=l;c[n>>2]=j;c[n+4>>2]=p;c[h+0>>2]=c[m+0>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];Epg(k,0,h,g);c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];if(sqg(0,h,g)|0){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}RI(3034456)|0;h=c[758637]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];Qpg(b,0,g,1);i=f;return}}h=Xog(e)|0;c[o+0>>2]=c[781288];c[o+4>>2]=c[781289];c[o+8>>2]=c[781290];c[o+12>>2]=c[781291];e=ZEi(h|0,H|0,j|0,p|0)|0;Wog(o,e,H);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];Qpg(b,0,g,1);i=f;return}function Rxg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d+24|0;f=d+8|0;g=d;iM(f,3124024,a);h=c[(c[f+4>>2]|0)+4>>2]|0;j=c[f>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];k=_n[h&4095](j,e)|0;j=g;c[j>>2]=k;c[j+4>>2]=H;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[e+0>>2]=c[g+0>>2];c[e+4>>2]=c[g+4>>2];g=Sxg(a,f,e)|0;i=d;return g|0}function Sxg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+240|0;g=f+32|0;h=f+80|0;j=f+160|0;k=f+192|0;l=f+112|0;m=f+144|0;n=f+176|0;o=f+208|0;p=f+216|0;q=f+16|0;r=f+96|0;s=f+48|0;t=f;u=f+56|0;v=f+128|0;w=f+72|0;c[k+0>>2]=c[781288];c[k+4>>2]=c[781289];c[k+8>>2]=c[781290];c[k+12>>2]=c[781291];c[l+0>>2]=c[781288];c[l+4>>2]=c[781289];c[l+8>>2]=c[781290];c[l+12>>2]=c[781291];c[m+0>>2]=c[781288];c[m+4>>2]=c[781289];c[m+8>>2]=c[781290];c[m+12>>2]=c[781291];x=mxh(3123968,b,Gpg(d)|0)|0;y=vTf(x)|0;z=e;e=c[z>>2]|0;A=c[z+4>>2]|0;if((y|0)==0&(H|0)==0){B=A;C=e;H=B;i=f;return C|0}y=o;c[y>>2]=e;c[y+4>>2]=A;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];Ipg(n,d,g);c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];uTf(p,x);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[p+0>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];if(sqg(0,h,g)|0){uTf(q,x);c[l+0>>2]=c[q+0>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];q=vTf(x)|0;p=s;c[p>>2]=q;c[p+4>>2]=H;c[g+0>>2]=c[s+0>>2];c[g+4>>2]=c[s+4>>2];lqg(r,l,g);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[h+12>>2]=c[r+12>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];if(tqg(0,h,g)|0){B=A;C=e;H=B;i=f;return C|0}}tTf(t,x);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[t+0>>2];c[g+4>>2]=c[t+4>>2];c[g+8>>2]=c[t+8>>2];c[g+12>>2]=c[t+12>>2];if(rqg(0,h,g)|0){tTf(u,x);c[m+0>>2]=c[u+0>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];u=vTf(x)|0;t=w;c[t>>2]=u;c[t+4>>2]=H;c[g+0>>2]=c[w+0>>2];c[g+4>>2]=c[w+4>>2];Ipg(v,m,g);RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)};c[h+0>>2]=c[v+0>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];c[h+12>>2]=c[v+12>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];if(qqg(0,h,g)|0){v=vTf(x)|0;x=H;RI(3120120)|0;if(!(a[3120268]|0)){RI(3120120)|0;Ywh(3120120)}aqh();m=ZEi(e|0,A|0,v|0,x|0)|0;B=H;C=m;H=B;i=f;return C|0}};c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];iM(h,3124024,b);b=c[(c[h+4>>2]|0)+4>>2]|0;k=c[h>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];j=_n[b&4095](k,g)|0;B=H;C=j;H=B;i=f;return C|0}function Txg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Uxg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=i;f=c[781262]|0;if(!f){g=MK(3125056)|0;c[781262]=g;h=g}else h=f;f=xo[h&2047](b,d,e)|0;i=a;return f|0}function Vxg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+80|0;d=a+72|0;e=a+56|0;f=a+40|0;g=a+24|0;h=a+8|0;j=a;c[g+0>>2]=c[781288];c[g+4>>2]=c[781289];c[g+8>>2]=c[781290];c[g+12>>2]=c[781291];k=b+16|0;l=k;Wog(g,c[l>>2]|0,c[l+4>>2]|0);c[h+0>>2]=c[781288];c[h+4>>2]=c[781289];c[h+8>>2]=c[781290];c[h+12>>2]=c[781291];l=k+(c[(c[b>>2]|0)+120>>2]|0)|0;Wog(h,c[l>>2]|0,c[l+4>>2]|0);l=k+((c[(c[b>>2]|0)+120>>2]|0)*3|0)|0;b=c[l>>2]|0;k=c[l+4>>2]|0;RI(2769264)|0;l=qL(2769264)|0;m=j;c[m>>2]=b;c[m+4>>2]=k;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[e+0>>2]=c[h+0>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[d+0>>2]=c[j+0>>2];c[d+4>>2]=c[j+4>>2];sTf(l,f,e,d);i=a;return l|0}function Wxg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+80|0;f=e+72|0;g=e+64|0;h=e;j=e+48|0;k=e+32|0;l=e+68|0;m=e+16|0;c[f>>2]=0;c[g>>2]=0;c[h+0>>2]=c[781288];c[h+4>>2]=c[781289];c[h+8>>2]=c[781290];c[h+12>>2]=c[781291];c[j+0>>2]=c[781288];c[j+4>>2]=c[781289];c[j+8>>2]=c[781290];c[j+12>>2]=c[781291];fqh();do if(!d){RI(3034456)|0;if(!(a[3034604]|0)){RI(3034456)|0;Ywh(3034456)}Dpg(k,0);c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];n=Gpg(h)|0;RI(3123632)|0;c[c[780931]>>2]=n;RI(3123632)|0;if(Uxg(0,c[c[780931]>>2]|0,f,g)|0){o=Vxg(0,c[f>>2]|0)|0;break}RI(3123632)|0;c[l>>2]=c[c[780931]>>2];RI(2540224)|0;n=pL(2540224,l)|0;if(a[2540708]|0){p=c[903300]|0;q=fwf(0,p,n)|0;r=tof(0,q)|0;RI(2965048)|0;s=qL(2965048)|0;Rbg(s,r);Zwh(s)}Ywh(2540560);p=c[903300]|0;q=fwf(0,p,n)|0;r=tof(0,q)|0;RI(2965048)|0;s=qL(2965048)|0;Rbg(s,r);Zwh(s)}else{tTf(m,d);c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];n=Gpg(j)|0;RI(3123632)|0;c[c[780931]>>2]=n;o=d}while(0);d=b+24|0;j=c[d>>2]|0;m=c[d+4>>2]|0;d=b+32|0;c[d>>2]=j;c[d+4>>2]=m;d=vTf(o)|0;s=_Ei(d|0,H|0,j|0,m|0)|0;m=b+40|0;c[m>>2]=s;c[m+4>>2]=H;RI(3123632)|0;c[(c[780931]|0)+4>>2]=o;i=e;return}function Xxg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=0;c[g>>2]=0;eqh();if((d+-1|0)>>>0>=9999){c[h>>2]=d;RI(2540224)|0;m=pL(2540224,h)|0;h=tof(0,c[903258]|0)|0;if(a[2540708]|0){n=fwf(0,m,h)|0;RI(2964880)|0;o=qL(2964880)|0;p=c[903256]|0;Qag(o,p,n);Zwh(o)}Ywh(2540560);n=fwf(0,m,h)|0;RI(2964880)|0;o=qL(2964880)|0;p=c[903256]|0;Qag(o,p,n);Zwh(o)}RI(3123632)|0;if((c[c[780931]>>2]|0)==(d|0)){RI(3123632)|0;q=c[(c[780931]|0)+4>>2]|0;i=e;return q|0}o=b+16|0;b=c[o>>2]|0;Jag(0,b);n=c[o>>2]|0;c[j>>2]=d;RI(2540224)|0;p=uth(2736488,n,pL(2540224,j)|0)|0;RI(2769264)|0;j=axh(p,2769264)|0;do if(!j){if(Uxg(0,d,f,g)|0){p=Vxg(0,c[f>>2]|0)|0;n=c[o>>2]|0;c[l>>2]=d;RI(2540224)|0;Rrh(2734016,n,pL(2540224,l)|0,p);r=p;break}c[k>>2]=d;RI(2540224)|0;p=pL(2540224,k)|0;if(a[2540708]|0){s=c[903260]|0;t=fwf(0,s,p)|0;u=tof(0,t)|0;RI(2965048)|0;v=qL(2965048)|0;Rbg(v,u);FJ(v)}Ywh(2540560);s=c[903260]|0;t=fwf(0,s,p)|0;u=tof(0,t)|0;RI(2965048)|0;v=qL(2965048)|0;Rbg(v,u);FJ(v)}else r=j;while(0);Kag(0,b);q=r;i=e;return q|0}function Yxg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d;f=d+16|0;iM(f,3124424,a);g=c[(c[f+4>>2]|0)+4>>2]|0;h=c[f>>2]|0;c[e+0>>2]=c[b+0>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];b=_n[g&4095](h,e)|0;e=b?a+40|0:a+32|0;H=c[e+4>>2]|0;i=d;return c[e>>2]|0}function Zxg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _xg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;gqh();h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];THf(a,b,f);L7f(b,c[903304]|0,c[a+52>>2]|0);i=e;return}function $xg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ayg(a){a=a|0;var b=0;b=i;iqh();Grg(a,tof(0,c[903352]|0)|0);KHf(a,-2146233054);i=b;return}function byg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;hqh();e=b+52|0;f=c[e>>2]|0;if(!f){g=MHf(b)|0;i=d;return g|0}h=b+56|0;b=c[h>>2]|0;if(b){if(!(a[2540708]|0))Ywh(2540560);j=Iwf(0,b,c[c[635163]>>2]|0)|0;b=c[e>>2]|0;if(j){j=c[h>>2]|0;if(!(a[2540708]|0))Ywh(2540560);g=awf(0,c[903308]|0,b,j)|0;i=d;return g|0}else k=b}else k=f;if(!(a[2540708]|0))Ywh(2540560);g=_vf(0,c[903310]|0,k)|0;i=d;return g|0}function cyg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+24|0;h=f;j=f+32|0;k=f+36|0;l=f+12|0;m=f+8|0;n=f+16|0;jqh();if(!d){RI(2963920)|0;o=qL(2963920)|0;Iag(o,c[903374]|0);Zwh(o)}o=e;e=c[o+4>>2]|0;p=h;c[p>>2]=c[o>>2];c[p+4>>2]=e;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];THf(b,d,g);h=c[b+52>>2]|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[j>>2]=3431728;c[g+0>>2]=c[j+0>>2];j=npf(0,g)|0;q9f(d,c[903376]|0,h,j);j=c[b+56>>2]|0;c[k>>2]=3431728;c[g+0>>2]=c[k+0>>2];k=npf(0,g)|0;q9f(d,c[903378]|0,j,k);if(!(a[2540708]|0))Ywh(2540560);c[l>>2]=3431728;c[g+0>>2]=c[l+0>>2];l=npf(0,g)|0;q9f(d,c[903380]|0,c[c[635163]>>2]|0,l);c[m>>2]=0;RI(2540224)|0;l=pL(2540224,m)|0;c[n>>2]=3431160;c[g+0>>2]=c[n+0>>2];n=npf(0,g)|0;q9f(d,c[903382]|0,l,n);i=f;return}function dyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function eyg(a,b){a=a|0;b=b|0;var c=0;c=i;Grg(a,b);KHf(a,-2146233088);i=c;return}function fyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function gyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function hyg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+16|0;b=f+4|0;g=f;lqh();L7f(e,c[903440]|0,0);r9f(e,c[903442]|0,2);h=Fqh(2836288,rth(2652848,Xnf(d)|0)|0)|0;L7f(e,c[903444]|0,h);RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[g>>2]=3452624;c[b+0>>2]=c[g+0>>2];p9f(e,npf(0,b)|0);i=f;return}function iyg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+16|0;b=f+4|0;g=f;mqh();h=t2f(d)|0;L7f(e,c[903448]|0,h);r9f(e,c[903450]|0,5);h=Fqh(2836288,kYf(d)|0)|0;L7f(e,c[903452]|0,h);RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ywh(2540728)}c[g>>2]=3452624;c[b+0>>2]=c[g+0>>2];p9f(e,npf(0,b)|0);i=f;return}function jyg(a,b,c){a=a|0;b=b|0;c=c|0;RI(3100472)|0;c=qL(3100472)|0;oug(c);Zwh(c)}function kyg(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;nqh();if(!d){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[903456]|0);Zwh(f)}RI(1136088)|0;f=_wh(1136088,1)|0;b[f+16>>1]=46;g=dvf(d,f)|0;f=c[g+12>>2]|0;if((f+-2|0)>>>0>=3){d=tof(0,c[903458]|0)|0;RI(2965048)|0;h=qL(2965048)|0;Rbg(h,d);Zwh(h)}h=g+16|0;d=ppf(0,c[h>>2]|0)|0;j=ppf(0,c[h+(c[(c[g>>2]|0)+120>>2]|0)>>2]|0)|0;if((f|0)<3){k=-1;l=-1;lyg(a,f,d,j,k,l);i=e;return}m=ppf(0,c[h+(c[(c[g>>2]|0)+120>>2]<<1)>>2]|0)|0;if((f|0)<4){k=m;l=-1;lyg(a,f,d,j,k,l);i=e;return}k=m;l=ppf(0,c[h+((c[(c[g>>2]|0)+120>>2]|0)*3|0)>>2]|0)|0;lyg(a,f,d,j,k,l);i=e;return}function lyg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;oqh();if((d|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[903492]|0);Zwh(j)}c[a+8>>2]=d;if((e|0)<=-1){RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[903494]|0);Zwh(d)}c[a+12>>2]=e;if((b|0)==2){c[a+16>>2]=-1;c[a+20>>2]=-1;i=h;return}if((f|0)<=-1){RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[903496]|0);Zwh(e)}c[a+16>>2]=f;if((b|0)==3){c[a+20>>2]=-1;i=h;return}if((g|0)<=-1){RI(2964880)|0;b=qL(2964880)|0;wdg(b,c[903498]|0);Zwh(b)}c[a+20>>2]=g;i=h;return}function myg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lyg(a,2,b,c,0,0);i=d;return}function nyg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;lyg(a,4,b,c,d,e);i=f;return}function oyg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;pqh();if(!b){e=1;i=d;return e|0}RI(3129672)|0;if(!(vL(b,3129672)|0)){f=tof(0,c[903518]|0)|0;RI(2965048)|0;g=qL(2965048)|0;Rbg(g,f);Zwh(g)}RI(3129672)|0;e=nxh(3129840,a,axh(b,3129672)|0)|0;i=d;return e|0}function pyg(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(3129672)|0;d=oxh(3129896,a,vL(b,3129672)|0)|0;i=c;return d|0}function qyg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(!(Tnf(0,b,0)|0)?(e=c[a+8>>2]|0,f=c[b+8>>2]|0,(e|0)<=(f|0)):0)if((e|0)>=(f|0)){f=c[a+12>>2]|0;e=c[b+12>>2]|0;if((f|0)<=(e|0))if((f|0)>=(e|0)){e=c[a+16>>2]|0;f=c[b+16>>2]|0;if((e|0)<=(f|0))if((e|0)>=(f|0)){f=c[a+20>>2]|0;a=c[b+20>>2]|0;if((f|0)>(a|0))g=1;else g=((f|0)<(a|0))<<31>>31}else g=-1;else g=1}else g=-1;else g=1}else g=-1;else g=1;i=d;return g|0}function ryg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;if(((!(Tnf(0,b,0)|0)?(c[b+8>>2]|0)==(c[a+8>>2]|0):0)?(c[b+12>>2]|0)==(c[a+12>>2]|0):0)?(c[b+16>>2]|0)==(c[a+16>>2]|0):0)e=(c[b+20>>2]|0)==(c[a+20>>2]|0);else e=0;i=d;return e|0}function syg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=(Tnf(0,b,c)|0)^1;i=a;return d|0}function tyg(a){a=a|0;return c[a+16>>2]<<16|c[a+20>>2]<<24|c[a+12>>2]<<8|c[a+8>>2]|0}function uyg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;qqh();e=spf(b+8|0)|0;f=spf(b+12|0)|0;if(!(a[2540708]|0))Ywh(2540560);g=iwf(0,e,c[903546]|0,f)|0;f=b+16|0;if((c[f>>2]|0)==-1)h=g;else{e=spf(f)|0;if(!(a[2540708]|0))Ywh(2540560);h=iwf(0,g,c[903548]|0,e)|0}e=b+20|0;if((c[e>>2]|0)==-1){j=h;i=d;return j|0}b=spf(e)|0;if(!(a[2540708]|0))Ywh(2540560);j=iwf(0,h,c[903550]|0,b)|0;i=d;return j|0}function vyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function wyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function xyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)xyg(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function yyg(a,b,c){a=a|0;b=b|0;c=c|0;Zwh(SJ(3131216)|0);return 0}function zyg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ayg(a,b){a=a|0;b=b|0;return 0}function Byg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Cyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Dyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)Dyg(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function Eyg(a,b,c){a=a|0;b=b|0;c=c|0;Zwh(SJ(3132024)|0);return 0}function Fyg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Gyg(a,b){a=a|0;b=b|0;return 0}function Hyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Iyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Jyg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a+44>>2]|0;if(e)Jyg(e,b);In[c[a+8>>2]&4095](c[a+16>>2]|0,b);i=d;return}function Kyg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[a+20>>2]|0)+4>>2]|0;a=pxh(b)|0;ko[e&4095](a);if(!b){i=d;return}DL(a,c[b+12>>2]|0);i=d;return}function Lyg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Myg(a,b){a=a|0;b=b|0;return}function Nyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Oyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Pyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)Pyg(f,b,d);co[c[a+8>>2]&2047](c[a+16>>2]|0,b,d);i=e;return}function Qyg(a,b,c){a=a|0;b=b|0;c=c|0;Zwh(SJ(3131272)|0)}function Ryg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Syg(a,b){a=a|0;b=b|0;return}function Tyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function Uyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function Vyg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)Vyg(f,b,d);co[c[a+8>>2]&2047](c[a+16>>2]|0,b,d);i=e;return}function Wyg(a,b,c){a=a|0;b=b|0;c=c|0;Zwh(SJ(3131272)|0)}function Xyg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Yyg(a,b){a=a|0;b=b|0;return}function Zyg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function _yg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function $yg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)$yg(f,b,d)|0;f=xo[c[a+8>>2]&2047](c[a+16>>2]|0,b,d)|0;i=e;return f|0}function azg(a,b,c){a=a|0;b=b|0;c=c|0;Zwh(SJ(3131272)|0);return 0}function bzg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function czg(a,b){a=a|0;b=b|0;return 0}function dzg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function ezg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function fzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[a+44>>2]|0;if(f)fzg(f,b,d);co[c[a+8>>2]&2047](c[a+16>>2]|0,b,d);i=e;return}function gzg(a,b,c){a=a|0;b=b|0;c=c|0;Zwh(SJ(3131272)|0)}function hzg(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function izg(a,b){a=a|0;b=b|0;return}function jzg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2537168)|0;aof(a,1);c[c[d>>2]>>2]=a;i=b;return}function kzg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;c[d>>2]=Ks(c[a>>2]<<2,0)|0;a=qL(2617664)|0;c[c[d>>2]>>2]=a;i=b;return}function lzg(b,c){b=b|0;c=c|0;c=i;RI(2686624)|0;if((a[2686772]|0)==0?(RI(2686624)|0,(a[2686772]|0)==0):0)lM(2686624);b=eKf(0)|0;i=c;return b|0}function mzg(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function nzg(a){a=a|0;return 0}function ozg(a,b,c){a=a|0;b=b|0;c=c|0;return}function pzg(a,b,d){a=a|0;b=b|0;d=d|0;d=i;ko[c[a+4>>2]&4095](b);i=d;return 0}function qzg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;a[f>>0]=(mo[c[b+4>>2]&4095](d)|0)&1;d=pL(2601984,f)|0;i=e;return d|0}function rzg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2540392,f)|0;i=e;return d|0}function szg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;a[f>>0]=mo[c[b+4>>2]&4095](d)|0;d=pL(2560032,f)|0;i=e;return d|0}function tzg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;a[f>>0]=mo[c[b+4>>2]&4095](d)|0;d=pL(2557392,f)|0;i=e;return d|0}function uzg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2562664,f)|0;i=e;return d|0}function vzg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2565248,f)|0;i=e;return d|0}function wzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2540224,e)|0;i=d;return b|0}function xzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2551640,e)|0;i=d;return b|0}function yzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;i=i+16|0;e=d;f=mo[c[a+4>>2]&4095](b)|0;b=e;c[b>>2]=f;c[b+4>>2]=H;b=pL(2548816,e)|0;i=d;return b|0}function zzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;i=i+16|0;e=d;f=mo[c[a+4>>2]&4095](b)|0;b=e;c[b>>2]=f;c[b+4>>2]=H;b=pL(2554736,e)|0;i=d;return b|0}function Azg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;g[e>>2]=ea(Kn[c[a+4>>2]&255](b));b=pL(2586184,e)|0;i=d;return b|0}function Bzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;h[e>>3]=+Wm[c[a+4>>2]&15](b);b=pL(2589144,e)|0;i=d;return b|0}function Czg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2509376,e)|0;i=d;return b|0}function Dzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2379888,e)|0;i=d;return b|0}function Ezg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2395400,e)|0;i=d;return b|0}function Fzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2395064,e)|0;i=d;return b|0}function Gzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2395232,e)|0;i=d;return b|0}function Hzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2416264,e)|0;i=d;return b|0}function Izg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2417688,e)|0;i=d;return b|0}function Jzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+64|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2422424,e)|0;i=d;return b|0}function Kzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2420784,e)|0;i=d;return b|0}function Lzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2508800,e)|0;i=d;return b|0}function Mzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2508504,e)|0;i=d;return b|0}function Nzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2419496,e)|0;i=d;return b|0}function Ozg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2347552,e)|0;i=d;return b|0}function Pzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2487256,e)|0;i=d;return b|0}function Qzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2486944,e)|0;i=d;return b|0}function Rzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2729368,e)|0;i=d;return b|0}function Szg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2253112,e)|0;i=d;return b|0}function Tzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2256176,e)|0;i=d;return b|0}function Uzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2276200,e)|0;i=d;return b|0}function Vzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2302336,e)|0;i=d;return b|0}function Wzg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2284056,f)|0;i=e;return d|0}function Xzg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2280960,f)|0;i=e;return d|0}function Yzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3126192,e)|0;i=d;return b|0}function Zzg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2889800,e)|0;i=d;return b|0}function _zg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2860944,e)|0;i=d;return b|0}function $zg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2650536,e)|0;i=d;return b|0}function aAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(3034456,e)|0;i=d;return b|0}function bAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;d=i;i=i+16|0;e=d;f=mo[c[a+4>>2]&4095](b)|0;b=e;c[b>>2]=f;c[b+4>>2]=H;b=pL(3120120,e)|0;i=d;return b|0}function cAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2854312,e)|0;i=d;return b|0}function dAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2865352,e)|0;i=d;return b|0}function eAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3116224,e)|0;i=d;return b|0}function fAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2861632,e)|0;i=d;return b|0}function gAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2857696,e)|0;i=d;return b|0}function hAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2855816,e)|0;i=d;return b|0}function iAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2887376,e)|0;i=d;return b|0}function jAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2884776,e)|0;i=d;return b|0}function kAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3065280,e)|0;i=d;return b|0}function lAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3062088,e)|0;i=d;return b|0}function mAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3113544,e)|0;i=d;return b|0}function nAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(3080504,e)|0;i=d;return b|0}function oAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2348024,e)|0;i=d;return b|0}function pAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2349448,e)|0;i=d;return b|0}function qAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2703200,e)|0;i=d;return b|0}function rAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2375496,e)|0;i=d;return b|0}function sAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2390624,e)|0;i=d;return b|0}function tAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2455736,e)|0;i=d;return b|0}function uAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2466336,e)|0;i=d;return b|0}function vAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2469616,e)|0;i=d;return b|0}function wAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2492064,e)|0;i=d;return b|0}function xAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2492856,e)|0;i=d;return b|0}function yAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2493312,e)|0;i=d;return b|0}function zAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+64|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2504408,e)|0;i=d;return b|0}function AAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2497248,e)|0;i=d;return b|0}function BAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2497560,e)|0;i=d;return b|0}function CAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2887096,e)|0;i=d;return b|0}function DAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2509864,e)|0;i=d;return b|0}function EAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2511024,e)|0;i=d;return b|0}function FAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2516584,e)|0;i=d;return b|0}function GAg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;a[f>>0]=mo[c[b+4>>2]&4095](d)|0;d=pL(2515960,f)|0;i=e;return d|0}function HAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2529488,e)|0;i=d;return b|0}function IAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2255040,e)|0;i=d;return b|0}function JAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2255576,e)|0;i=d;return b|0}function KAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2268872,e)|0;i=d;return b|0}function LAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2273904,e)|0;i=d;return b|0}function MAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2274184,e)|0;i=d;return b|0}function NAg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2279080,f)|0;i=e;return d|0}function OAg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;b[f>>1]=mo[c[a+4>>2]&4095](d)|0;d=pL(2280424,f)|0;i=e;return d|0}function PAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2324976,e)|0;i=d;return b|0}function QAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2331416,e)|0;i=d;return b|0}function RAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2331968,e)|0;i=d;return b|0}function SAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2333648,e)|0;i=d;return b|0}function TAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2673824,e)|0;i=d;return b|0}function UAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2685904,e)|0;i=d;return b|0}function VAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2729920,e)|0;i=d;return b|0}function WAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2730736,e)|0;i=d;return b|0}function XAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2741840,e)|0;i=d;return b|0}function YAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2742360,e)|0;i=d;return b|0}function ZAg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2742896,e)|0;i=d;return b|0}function _Ag(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2694720,e)|0;i=d;return b|0}function $Ag(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2761136,e)|0;i=d;return b|0}function aBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2768376,e)|0;i=d;return b|0}function bBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2770776,e)|0;i=d;return b|0}function cBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2776480,e)|0;i=d;return b|0}function dBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2778984,e)|0;i=d;return b|0}function eBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2781760,e)|0;i=d;return b|0}function fBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2782256,e)|0;i=d;return b|0}function gBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2789408,e)|0;i=d;return b|0}function hBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2790128,e)|0;i=d;return b|0}function iBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2805992,e)|0;i=d;return b|0}function jBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2846960,e)|0;i=d;return b|0}function kBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2853040,e)|0;i=d;return b|0}function lBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2881760,e)|0;i=d;return b|0}function mBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2892360,e)|0;i=d;return b|0}function nBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2893816,e)|0;i=d;return b|0}function oBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2894608,e)|0;i=d;return b|0}function pBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2895112,e)|0;i=d;return b|0}function qBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2896984,e)|0;i=d;return b|0}function rBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2897704,e)|0;i=d;return b|0}function sBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2911832,e)|0;i=d;return b|0}function tBg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e;a[f>>0]=mo[c[b+4>>2]&4095](d)|0;d=pL(2929064,f)|0;i=e;return d|0}function uBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2951152,e)|0;i=d;return b|0}function vBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2952200,e)|0;i=d;return b|0}function wBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2952704,e)|0;i=d;return b|0}function xBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2953232,e)|0;i=d;return b|0}function yBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2957696,e)|0;i=d;return b|0}function zBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2972984,e)|0;i=d;return b|0}function ABg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3009344,e)|0;i=d;return b|0}function BBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3018040,e)|0;i=d;return b|0}function CBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3029240,e)|0;i=d;return b|0}function DBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3053640,e)|0;i=d;return b|0}function EBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(3085560,e)|0;i=d;return b|0}function FBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1336632,e)|0;i=d;return b|0}function GBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1342344,e)|0;i=d;return b|0}function HBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1358296,e)|0;i=d;return b|0}function IBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1781016,e)|0;i=d;return b|0}function JBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1780192,e)|0;i=d;return b|0}function KBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1824720,e)|0;i=d;return b|0}function LBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1814800,e)|0;i=d;return b|0}function MBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1810464,e)|0;i=d;return b|0}function NBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1814192,e)|0;i=d;return b|0}function OBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1820016,e)|0;i=d;return b|0}function PBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1824112,e)|0;i=d;return b|0}function QBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1838696,e)|0;i=d;return b|0}function RBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1844464,e)|0;i=d;return b|0}function SBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1846840,e)|0;i=d;return b|0}function TBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+80|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1933120,e)|0;i=d;return b|0}function UBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1941648,e)|0;i=d;return b|0}function VBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1952624,e)|0;i=d;return b|0}function WBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1973920,e)|0;i=d;return b|0}function XBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1973200,e)|0;i=d;return b|0}function YBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(1977704,e)|0;i=d;return b|0}function ZBg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2022832,e)|0;i=d;return b|0}function _Bg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2029160,e)|0;i=d;return b|0}function $Bg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2036896,e)|0;i=d;return b|0}function aCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2053688,e)|0;i=d;return b|0}function bCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2062216,e)|0;i=d;return b|0}function cCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2112640,e)|0;i=d;return b|0}function dCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2119600,e)|0;i=d;return b|0}function eCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+32|0;e=d;In[c[a+4>>2]&4095](e,b);b=pL(2130216,e)|0;i=d;return b|0}function fCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2604248,e)|0;i=d;return b|0}function gCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+16|0;e=d;c[e>>2]=mo[c[a+4>>2]&4095](b)|0;b=pL(2606296,e)|0;i=d;return b|0}function hCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;e=mo[c[a+4>>2]&4095](b)|0;i=d;return e|0}function iCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;In[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0);i=f;return 0}function jCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function kCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;In[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0);i=f;return 0}function lCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;In[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0);i=f;return 0}function mCg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;b[h>>1]=_n[c[d+4>>2]&4095](e,a[c[f>>2]>>0]|0)|0;f=pL(2540392,h)|0;i=g;return f|0}function nCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function oCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;In[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0);i=f;return 0}function pCg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=(_n[c[d+4>>2]&4095](e,b[c[f>>2]>>1]|0)|0)&1;f=pL(2601984,h)|0;i=g;return f|0}function qCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=pL(2560032,g)|0;i=f;return e|0}function rCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0);i=e;return 0}function sCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2540392,g)|0;i=f;return e|0}function tCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=pL(2557392,g)|0;i=f;return e|0}function uCg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=(_n[c[d+4>>2]&4095](e,b[c[f>>2]>>1]|0)|0)&1;f=pL(2601984,h)|0;i=g;return f|0}function vCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(_n[c[b+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function wCg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;b[h>>1]=_n[c[d+4>>2]&4095](e,a[c[f>>2]>>0]|0)|0;f=pL(2562664,h)|0;i=g;return f|0}function xCg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=_n[c[d+4>>2]&4095](e,b[c[f>>2]>>1]|0)|0;f=pL(2560032,h)|0;i=g;return f|0}function yCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d>>2]|0;co[c[a+4>>2]&2047](b,c[f>>2]|0,c[f+4>>2]|0);i=e;return 0}function zCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2540392,g)|0;i=f;return e|0}function ACg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=_n[c[d+4>>2]&4095](e,b[c[f>>2]>>1]|0)|0;f=pL(2557392,h)|0;i=g;return f|0}function BCg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;b[h>>1]=_n[c[d+4>>2]&4095](e,a[c[f>>2]>>0]|0)|0;f=pL(2565248,h)|0;i=g;return f|0}function CCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2562664,g)|0;i=f;return e|0}function DCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[e>>2]|0;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[h>>2]|0,c[h+4>>2]|0)|0)&1;h=pL(2601984,g)|0;i=f;return h|0}function ECg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function FCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2560032,g)|0;i=f;return e|0}function GCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d>>2]>>2]);Fn[c[a+4>>2]&255](b,f);i=e;return 0}function HCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2565248,g)|0;i=f;return e|0}function ICg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2557392,g)|0;i=f;return e|0}function JCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[e>>2]|0;b[g>>1]=xo[c[a+4>>2]&2047](d,c[h>>2]|0,c[h+4>>2]|0)|0;h=pL(2540392,g)|0;i=f;return h|0}function KCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=pL(2551640,g)|0;i=f;return e|0}function LCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function MCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function NCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);a[h>>0]=(Un[c[b+4>>2]&31](d,j)|0)&1;d=pL(2601984,h)|0;i=f;return d|0}function OCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Gn[c[a+4>>2]&3](b,+h[c[d>>2]>>3]);i=e;return 0}function PCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2562664,g)|0;i=f;return e|0}function QCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=g;c[e>>2]=h;c[e+4>>2]=H;e=pL(2548816,g)|0;i=f;return e|0}function RCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[e>>2]|0;a[g>>0]=xo[c[b+4>>2]&2047](d,c[h>>2]|0,c[h+4>>2]|0)|0;h=pL(2560032,g)|0;i=f;return h|0}function SCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Tn[c[b+4>>2]&31](d,+h[c[e>>2]>>3])|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function TCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[e>>2]|0;a[g>>0]=xo[c[b+4>>2]&2047](d,c[h>>2]|0,c[h+4>>2]|0)|0;h=pL(2557392,g)|0;i=f;return h|0}function UCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);b[h>>1]=Un[c[a+4>>2]&31](d,j)|0;d=pL(2540392,h)|0;i=f;return d|0}function VCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2565248,g)|0;i=f;return e|0}function WCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2551640,g)|0;i=f;return e|0}function XCg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;e=g;c[e>>2]=h;c[e+4>>2]=H;e=pL(2554736,g)|0;i=f;return e|0}function YCg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function ZCg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function _Cg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[e>>2]|0;b[g>>1]=xo[c[a+4>>2]&2047](d,c[h>>2]|0,c[h+4>>2]|0)|0;h=pL(2562664,g)|0;i=f;return h|0}function $Cg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=g;c[e>>2]=h;c[e+4>>2]=H;e=pL(2548816,g)|0;i=f;return e|0}function aDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);a[h>>0]=Un[c[b+4>>2]&31](d,j)|0;d=pL(2560032,h)|0;i=f;return d|0}function bDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0;f=i;i=i+16|0;h=f;g[h>>2]=ea(Um[c[b+4>>2]&63](d,a[c[e>>2]>>0]|0));e=pL(2586184,h)|0;i=f;return e|0}function cDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function dDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function eDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function fDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function gDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function hDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function iDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);a[h>>0]=Un[c[b+4>>2]&31](d,j)|0;d=pL(2557392,h)|0;i=f;return d|0}function jDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;h[g>>3]=+$m[c[b+4>>2]&63](d,a[c[e>>2]>>0]|0);e=pL(2589144,g)|0;i=f;return e|0}function kDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=Tn[c[b+4>>2]&31](d,+h[c[e>>2]>>3])|0;e=pL(2560032,g)|0;i=f;return e|0}function lDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=c[e>>2]|0;b[g>>1]=xo[c[a+4>>2]&2047](d,c[h>>2]|0,c[h+4>>2]|0)|0;h=pL(2565248,g)|0;i=f;return h|0}function mDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2551640,f)|0;i=e;return d|0}function nDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f;h=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=g;c[e>>2]=h;c[e+4>>2]=H;e=pL(2554736,g)|0;i=f;return e|0}function oDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];In[g&4095](b,f);i=e;return 0}function pDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];In[g&4095](b,f);i=e;return 0}function qDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];In[g&4095](b,f);i=e;return 0}function rDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];In[g&4095](b,f);i=e;return 0}function sDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];In[g&4095](b,f);i=e;return 0}function tDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];In[g&4095](b,f);i=e;return 0}function uDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;c[f>>2]=xo[c[a+4>>2]&2047](b,c[g>>2]|0,c[g+4>>2]|0)|0;g=pL(2540224,f)|0;i=e;return g|0}function vDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function wDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=Tn[c[b+4>>2]&31](d,+h[c[e>>2]>>3])|0;e=pL(2557392,g)|0;i=f;return e|0}function xDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);b[h>>1]=Un[c[a+4>>2]&31](d,j)|0;d=pL(2562664,h)|0;i=f;return d|0}function yDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0;f=i;i=i+16|0;h=f;g[h>>2]=ea(Um[c[a+4>>2]&63](d,b[c[e>>2]>>1]|0));e=pL(2586184,h)|0;i=f;return e|0}function zDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];In[g&4095](b,f);i=e;return 0}function ADg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function BDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function CDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];In[g&4095](b,f);i=e;return 0}function DDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+64|0;f=e;g=c[a+4>>2]|0;a=f+0|0;h=(c[d>>2]|0)+0|0;d=a+60|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(d|0));In[g&4095](b,f);i=e;return 0}function EDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];In[g&4095](b,f);i=e;return 0}function FDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function GDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[g+0>>2];In[h&4095](b,f);i=e;return 0}function HDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function IDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function JDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];In[g&4095](b,f);i=e;return 0}function KDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];In[g&4095](b,f);i=e;return 0}function LDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function MDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function NDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=f+12|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function ODg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+24|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function PDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+24|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function QDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function RDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+96|0;g=f;h=f+84|0;j=c[b+4>>2]|0;b=g+0|0;k=(c[e>>2]|0)+0|0;e=b+84|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(e|0));a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function SDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=f+12|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function TDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function UDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;h[g>>3]=+$m[c[a+4>>2]&63](d,b[c[e>>2]>>1]|0);e=pL(2589144,g)|0;i=f;return e|0}function VDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=Tn[c[a+4>>2]&31](d,+h[c[e>>2]>>3])|0;e=pL(2562664,g)|0;i=f;return e|0}function WDg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,h=0,j=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);b[h>>1]=Un[c[a+4>>2]&31](d,j)|0;d=pL(2565248,h)|0;i=f;return d|0}function XDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;c[f>>2]=xo[c[a+4>>2]&2047](b,c[g>>2]|0,c[g+4>>2]|0)|0;g=pL(2551640,f)|0;i=e;return g|0}function YDg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2554736,f)|0;i=e;return d|0}function ZDg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function _Dg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+24|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function $Dg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function aEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function bEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function cEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function dEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function eEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=f;h=f+60|0;j=c[b+4>>2]|0;b=g+0|0;k=(c[e>>2]|0)+0|0;e=b+60|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(e|0));a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function fEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=f+12|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function gEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function hEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;k=c[b+4>>2]|0;c[j>>2]=c[c[e>>2]>>2];c[g+0>>2]=c[j+0>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function iEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function jEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;h=f+12|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function kEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+20|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function lEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function mEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(Um[c[a+4>>2]&63](b,c[c[d>>2]>>2]|0));d=pL(2586184,f)|0;i=e;return d|0}function nEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);c[f>>2]=Un[c[a+4>>2]&31](b,h)|0;b=pL(2540224,f)|0;i=e;return b|0}function oEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;d=xo[c[a+4>>2]&2047](b,c[g>>2]|0,c[g+4>>2]|0)|0;g=f;c[g>>2]=d;c[g+4>>2]=H;g=pL(2548816,f)|0;i=e;return g|0}function pEg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=Tn[c[a+4>>2]&31](d,+h[c[e>>2]>>3])|0;e=pL(2565248,g)|0;i=f;return e|0}function qEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Tn[c[a+4>>2]&31](b,+h[c[d>>2]>>3])|0;d=pL(2540224,f)|0;i=e;return d|0}function rEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=_n[j&4095](d,g)|0;g=pL(2560032,h)|0;i=f;return g|0}function sEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;co[c[b+4>>2]&2047](g,d,a[c[e>>2]>>0]|0);e=pL(2592872,g)|0;i=f;return e|0}function tEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+32|0;g=f;co[c[b+4>>2]&2047](g,d,a[c[e>>2]>>0]|0);e=pL(2968352,g)|0;i=f;return e|0}function uEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;co[c[b+4>>2]&2047](g,d,a[c[e>>2]>>0]|0);e=pL(3034456,g)|0;i=f;return e|0}function vEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+$m[c[a+4>>2]&63](b,c[c[d>>2]>>2]|0);d=pL(2589144,f)|0;i=e;return d|0}function wEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);c[f>>2]=Un[c[a+4>>2]&31](b,h)|0;b=pL(2551640,f)|0;i=e;return b|0}function xEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;d=xo[c[a+4>>2]&2047](b,c[g>>2]|0,c[g+4>>2]|0)|0;g=f;c[g>>2]=d;c[g+4>>2]=H;g=pL(2554736,f)|0;i=e;return g|0}function yEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=_n[j&4095](d,g)|0;g=pL(2557392,h)|0;i=f;return g|0}function zEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);d=Un[c[a+4>>2]&31](b,h)|0;b=f;c[b>>2]=d;c[b+4>>2]=H;b=pL(2548816,f)|0;i=e;return b|0}function AEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0;e=i;i=i+16|0;f=e;h=c[d>>2]|0;g[f>>2]=ea(tn[c[a+4>>2]&15](b,c[h>>2]|0,c[h+4>>2]|0));h=pL(2586184,f)|0;i=e;return h|0}function BEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Tn[c[a+4>>2]&31](b,+h[c[d>>2]>>3])|0;d=pL(2551640,f)|0;i=e;return d|0}function CEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function DEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function EEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function FEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function GEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function HEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;j=g;c[j>>2]=c[a>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];In[h&4095](b,f);i=e;return 0}function IEg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;e=pL(2778984,g)|0;i=f;return e|0}function JEg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[a+4>>2]|0;a=c[e>>2]|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];b[h>>1]=_n[j&4095](d,g)|0;g=pL(2562664,h)|0;i=f;return g|0}function KEg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;co[c[a+4>>2]&2047](g,d,b[c[e>>2]>>1]|0);e=pL(2592872,g)|0;i=f;return e|0}function LEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=Tn[c[a+4>>2]&31](b,+h[c[d>>2]>>3])|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function MEg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;co[c[a+4>>2]&2047](g,d,b[c[e>>2]>>1]|0);e=pL(3034456,g)|0;i=f;return e|0}function NEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;h[f>>3]=+zn[c[a+4>>2]&7](b,c[g>>2]|0,c[g+4>>2]|0);g=pL(2589144,f)|0;i=e;return g|0}function OEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);d=Un[c[a+4>>2]&31](b,h)|0;b=f;c[b>>2]=d;c[b+4>>2]=H;b=pL(2554736,f)|0;i=e;return b|0}function PEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function QEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function REg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function SEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function TEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function UEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+8|0;h=f+16|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;e=c[b+4>>2]|0;l=j;c[l>>2]=c[b>>2];c[l+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function VEg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[b+4>>2]|0;b=c[e>>2]|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[h>>0]=(_n[j&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function WEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);g[f>>2]=ea(Sm[c[a+4>>2]&7](b,h));b=pL(2586184,f)|0;i=e;return b|0}function XEg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=c[a+4>>2]|0;a=c[e>>2]|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];b[h>>1]=_n[j&4095](d,g)|0;g=pL(2565248,h)|0;i=f;return g|0}function YEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=Tn[c[a+4>>2]&31](b,+h[c[d>>2]>>3])|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2554736,f)|0;i=e;return d|0}function ZEg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function _Eg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2348592,f)|0;i=e;return d|0}function $Eg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2420784,f)|0;i=e;return d|0}function aFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[g+0>>2];In[h&4095](b,f);i=e;return 0}function bFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2353760,f)|0;i=e;return d|0}function cFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2302336,f)|0;i=e;return d|0}function dFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function eFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2592872,f)|0;i=e;return d|0}function fFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2685904,f)|0;i=e;return d|0}function gFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+16|0;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function hFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3065280,f)|0;i=e;return d|0}function iFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(3034456,f)|0;i=e;return d|0}function jFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=Im;e=i;i=i+16|0;f=e;j=ea(g[c[d>>2]>>2]);h[f>>3]=+bn[c[a+4>>2]&1](b,j);b=pL(2589144,f)|0;i=e;return b|0}function kFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(Tm[c[a+4>>2]&1](b,+h[c[d>>2]>>3]));d=pL(2586184,f)|0;i=e;return d|0}function lFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+24|0;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function mFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function nFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+8|0;g=e+16|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function oFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2347552,f)|0;i=e;return d|0}function pFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2348024,f)|0;i=e;return d|0}function qFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2349448,f)|0;i=e;return d|0}function rFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function sFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2703200,f)|0;i=e;return d|0}function tFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function uFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2729368,f)|0;i=e;return d|0}function vFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2375496,f)|0;i=e;return d|0}function wFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2390624,f)|0;i=e;return d|0}function xFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2395232,f)|0;i=e;return d|0}function yFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2379888,f)|0;i=e;return d|0}function zFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2395064,f)|0;i=e;return d|0}function AFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2455736,f)|0;i=e;return d|0}function BFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2466336,f)|0;i=e;return d|0}function CFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function DFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2469616,f)|0;i=e;return d|0}function EFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2492064,f)|0;i=e;return d|0}function FFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2492856,f)|0;i=e;return d|0}function GFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2493312,f)|0;i=e;return d|0}function HFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+64|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=f+0|0;j=(c[d>>2]|0)+0|0;d=a+60|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(d|0));c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function IFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2504408,f)|0;i=e;return d|0}function JFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function KFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2497248,f)|0;i=e;return d|0}function LFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function MFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2497560,f)|0;i=e;return d|0}function NFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function OFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2887096,f)|0;i=e;return d|0}function PFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2508800,f)|0;i=e;return d|0}function QFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2509376,f)|0;i=e;return d|0}function RFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2509864,f)|0;i=e;return d|0}function SFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function TFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2511024,f)|0;i=e;return d|0}function UFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2516584,f)|0;i=e;return d|0}function VFg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2515960,g)|0;i=f;return e|0}function WFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2529488,f)|0;i=e;return d|0}function XFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2253112,f)|0;i=e;return d|0}function YFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2255040,f)|0;i=e;return d|0}function ZFg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2255576,f)|0;i=e;return d|0}function _Fg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2256176,f)|0;i=e;return d|0}function $Fg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2268872,f)|0;i=e;return d|0}function aGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function bGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2273904,f)|0;i=e;return d|0}function cGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2274184,f)|0;i=e;return d|0}function dGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2276200,f)|0;i=e;return d|0}function eGg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2279080,g)|0;i=f;return e|0}function fGg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2280424,g)|0;i=f;return e|0}function gGg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2280960,g)|0;i=f;return e|0}function hGg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2284056,g)|0;i=f;return e|0}function iGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function jGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2324976,f)|0;i=e;return d|0}function kGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2331416,f)|0;i=e;return d|0}function lGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2331968,f)|0;i=e;return d|0}function mGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2333648,f)|0;i=e;return d|0}function nGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function oGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2673824,f)|0;i=e;return d|0}function pGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function qGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2729920,f)|0;i=e;return d|0}function rGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2730736,f)|0;i=e;return d|0}function sGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2741840,f)|0;i=e;return d|0}function tGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2742360,f)|0;i=e;return d|0}function uGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2742896,f)|0;i=e;return d|0}function vGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2694720,f)|0;i=e;return d|0}function wGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2761136,f)|0;i=e;return d|0}function xGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2768376,f)|0;i=e;return d|0}function yGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2770776,f)|0;i=e;return d|0}function zGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2776480,f)|0;i=e;return d|0}function AGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2778984,f)|0;i=e;return d|0}function BGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2781760,f)|0;i=e;return d|0}function CGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2782256,f)|0;i=e;return d|0}function DGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2789408,f)|0;i=e;return d|0}function EGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2790128,f)|0;i=e;return d|0}function FGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2805992,f)|0;i=e;return d|0}function GGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2846960,f)|0;i=e;return d|0}function HGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2853040,f)|0;i=e;return d|0}function IGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2854312,f)|0;i=e;return d|0}function JGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2855816,f)|0;i=e;return d|0}function KGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2857696,f)|0;i=e;return d|0}function LGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2860944,f)|0;i=e;return d|0}function MGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2861632,f)|0;i=e;return d|0}function NGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2865352,f)|0;i=e;return d|0}function OGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2881760,f)|0;i=e;return d|0}function PGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2884776,f)|0;i=e;return d|0}function QGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2887376,f)|0;i=e;return d|0}function RGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2889800,f)|0;i=e;return d|0}function SGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2892360,f)|0;i=e;return d|0}function TGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2893816,f)|0;i=e;return d|0}function UGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2894608,f)|0;i=e;return d|0}function VGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2895112,f)|0;i=e;return d|0}function WGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2896984,f)|0;i=e;return d|0}function XGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2897704,f)|0;i=e;return d|0}function YGg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2911832,f)|0;i=e;return d|0}function ZGg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,c[c[e>>2]>>2]|0)|0;e=pL(2929064,g)|0;i=f;return e|0}function _Gg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2951152,f)|0;i=e;return d|0}function $Gg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2952200,f)|0;i=e;return d|0}function aHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2952704,f)|0;i=e;return d|0}function bHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2953232,f)|0;i=e;return d|0}function cHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2957696,f)|0;i=e;return d|0}function dHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2972984,f)|0;i=e;return d|0}function eHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3009344,f)|0;i=e;return d|0}function fHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3018040,f)|0;i=e;return d|0}function gHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3029240,f)|0;i=e;return d|0}function hHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3053640,f)|0;i=e;return d|0}function iHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3062088,f)|0;i=e;return d|0}function jHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3085560,f)|0;i=e;return d|0}function kHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3113544,f)|0;i=e;return d|0}function lHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(3126192,f)|0;i=e;return d|0}function mHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(2551640,g)|0;i=e;return f|0}function nHg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;k=c[b+4>>2]|0;c[j>>2]=c[c[e>>2]>>2];c[g+0>>2]=c[j+0>>2];a[h>>0]=(_n[k&4095](d,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function oHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+an[c[a+4>>2]&7](b,+h[c[d>>2]>>3]);d=pL(2589144,f)|0;i=e;return d|0}function pHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];a=_n[h&4095](b,f)|0;f=g;c[f>>2]=a;c[f+4>>2]=H;f=pL(2548816,g)|0;i=e;return f|0}function qHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;Dn[c[a+4>>2]&511](f,b,c[g>>2]|0,c[g+4>>2]|0);g=pL(2592872,f)|0;i=e;return g|0}function rHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;Dn[c[a+4>>2]&511](f,b,c[g>>2]|0,c[g+4>>2]|0);g=pL(3034456,f)|0;i=e;return g|0}function sHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];a=_n[h&4095](b,f)|0;f=g;c[f>>2]=a;c[f+4>>2]=H;f=pL(2554736,g)|0;i=e;return f|0}function tHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;In[c[a+4>>2]&4095](b,c[d>>2]|0);i=e;return 0}function uHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;h=e+8|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;l=j;c[l>>2]=c[a>>2];c[l+4>>2]=d;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];g[h>>2]=ea(Um[k&63](b,f));f=pL(2586184,h)|0;i=e;return f|0}function vHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];g[h>>2]=ea(Um[j&63](b,f));f=pL(2586184,h)|0;i=e;return f|0}function wHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+32|0;f=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];g[h>>2]=ea(Um[j&63](b,f));f=pL(2586184,h)|0;i=e;return f|0}function xHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+$m[c[a+4>>2]&63](b,c[d>>2]|0);d=pL(2589144,f)|0;i=e;return d|0}function yHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);go[c[a+4>>2]&63](f,b,h);b=pL(2592872,f)|0;i=e;return b|0}function zHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0;e=i;i=i+32|0;f=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];g[h>>2]=ea(Um[j&63](b,f));f=pL(2586184,h)|0;i=e;return f|0}function AHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);go[c[a+4>>2]&63](f,b,h);b=pL(3034456,f)|0;i=e;return b|0}function BHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function CHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(1342344,f)|0;i=e;return d|0}function DHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function EHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(1810464,f)|0;i=e;return d|0}function FHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function GHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(1820016,f)|0;i=e;return d|0}function HHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function IHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(1844464,f)|0;i=e;return d|0}function JHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function KHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2029160,f)|0;i=e;return d|0}function LHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function MHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[c[d>>2]>>2]|0);d=pL(2119600,f)|0;i=e;return d|0}function NHg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(_n[c[b+4>>2]&4095](d,c[e>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function OHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+8|0;g=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];h[g>>3]=+$m[j&63](b,f);f=pL(2589144,g)|0;i=e;return f|0}function PHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;fo[c[a+4>>2]&7](f,b,+h[c[d>>2]>>3]);d=pL(2592872,f)|0;i=e;return d|0}function QHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+8|0;g=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];h[g>>3]=+$m[j&63](b,f);f=pL(2589144,g)|0;i=e;return f|0}function RHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;fo[c[a+4>>2]&7](f,b,+h[c[d>>2]>>3]);d=pL(3034456,f)|0;i=e;return d|0}function SHg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[e>>2]|0)|0;e=pL(2540392,g)|0;i=f;return e|0}function THg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2604248,f)|0;i=e;return d|0}function UHg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=_n[c[b+4>>2]&4095](d,a[c[e>>2]>>0]|0)|0;i=f;return g|0}function VHg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,c[e>>2]|0)|0;e=pL(2560032,g)|0;i=f;return e|0}function WHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2540224,g)|0;i=e;return f|0}function XHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2419496,f)|0;i=e;return d|0}function YHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2419496,f)|0;i=e;return d|0}function ZHg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2422424,f)|0;i=e;return d|0}function _Hg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=_n[c[b+4>>2]&4095](d,c[e>>2]|0)|0;e=pL(2557392,g)|0;i=f;return e|0}function $Hg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2551640,g)|0;i=e;return f|0}function aIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;d=pL(2606296,f)|0;i=e;return d|0}function bIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];co[h&2047](g,b,f);f=pL(2353760,g)|0;i=e;return f|0}function cIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+16|0;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];co[h&2047](g,b,f);f=pL(2418752,g)|0;i=e;return f|0}function dIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];co[h&2047](g,b,f);f=pL(2419496,g)|0;i=e;return f|0}function eIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];co[h&2047](g,b,f);f=pL(2419496,g)|0;i=e;return f|0}function fIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+128|0;f=e+64|0;g=e;h=c[a+4>>2]|0;a=f+0|0;j=(c[d>>2]|0)+0|0;d=a+64|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(d|0));co[h&2047](g,b,f);f=pL(2422424,g)|0;i=e;return f|0}function gIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+12|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];co[h&2047](g,b,f);f=pL(2416264,g)|0;i=e;return f|0}function hIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+80|0;f=e+64|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];co[h&2047](g,b,f);f=pL(2422424,g)|0;i=e;return f|0}function iIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+48|0;f=e+24|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];co[h&2047](g,b,f);f=pL(2432168,g)|0;i=e;return f|0}function jIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+176|0;f=e+84|0;g=e;h=c[a+4>>2]|0;a=f+0|0;j=(c[d>>2]|0)+0|0;d=a+84|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(d|0));co[h&2047](g,b,f);f=pL(2520592,g)|0;i=e;return f|0}function kIg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=_n[c[a+4>>2]&4095](d,b[c[e>>2]>>1]|0)|0;i=f;return g|0}function lIg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[e>>2]|0)|0;e=pL(2562664,g)|0;i=f;return e|0}function mIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];co[h&2047](g,b,f);f=pL(2592872,g)|0;i=e;return f|0}function nIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;c[f>>2]=xo[c[a+4>>2]&2047](b,c[g>>2]|0,c[g+4>>2]|0)|0;g=pL(2604248,f)|0;i=e;return g|0}function oIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+16|0;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[g>>2]=_n[h&4095](b,f)|0;f=pL(3065280,g)|0;i=e;return f|0}function pIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+24|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];co[j&2047](g,b,f);f=pL(3034456,g)|0;i=e;return f|0}function qIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;d=c[a+4>>2]|0;k=h;c[k>>2]=c[a>>2];c[k+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=_n[j&4095](b,f)|0;f=g;c[f>>2]=h;c[f+4>>2]=H;f=pL(3120120,g)|0;i=e;return f|0}function rIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];a=_n[h&4095](b,f)|0;f=g;c[f>>2]=a;c[f+4>>2]=H;f=pL(3120120,g)|0;i=e;return f|0}function sIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];co[h&2047](g,b,f);f=pL(3034456,g)|0;i=e;return f|0}function tIg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[e>>2]|0)|0;e=pL(2565248,g)|0;i=f;return e|0}function uIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e;h=e+8|0;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];h=_n[j&4095](b,f)|0;f=g;c[f>>2]=h;c[f+4>>2]=H;f=pL(2554736,g)|0;i=e;return f|0}function vIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;c[f>>2]=xo[c[a+4>>2]&2047](b,c[g>>2]|0,c[g+4>>2]|0)|0;g=pL(2606296,f)|0;i=e;return g|0}function wIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_n[c[a+4>>2]&4095](b,c[c[d>>2]>>2]|0)|0;i=e;return f|0}function xIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function yIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2551640,f)|0;i=e;return d|0}function zIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d>>2]|0;d=xo[c[a+4>>2]&2047](b,c[f>>2]|0,c[f+4>>2]|0)|0;i=e;return d|0}function AIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function BIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2554736,f)|0;i=e;return d|0}function CIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d>>2]>>2]);d=Un[c[a+4>>2]&31](b,f)|0;i=e;return d|0}function DIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(Um[c[a+4>>2]&63](b,c[d>>2]|0));d=pL(2586184,f)|0;i=e;return d|0}function EIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+$m[c[a+4>>2]&63](b,c[d>>2]|0);d=pL(2589144,f)|0;i=e;return d|0}function FIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];co[j&2047](g,b,f);f=pL(2874864,g)|0;i=e;return f|0}function GIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2861632,g)|0;i=e;return f|0}function HIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2854312,g)|0;i=e;return f|0}function IIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[h+0>>2];c[g>>2]=_n[j&4095](b,f)|0;f=pL(2865352,g)|0;i=e;return f|0}function JIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Tn[c[a+4>>2]&31](b,+h[c[d>>2]>>3])|0;i=e;return f|0}function KIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;i=e;return f|0}function LIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;i=e;return f|0}function MIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;i=e;return f|0}function NIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];a=_n[g&4095](b,f)|0;i=e;return a|0}function OIg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=_n[c[a+4>>2]&4095](d,c[e>>2]|0)|0;e=pL(2284056,g)|0;i=f;return e|0}function PIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2331416,f)|0;i=e;return d|0}function QIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(3034456,f)|0;i=e;return d|0}function RIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2592872,f)|0;i=e;return d|0}function SIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];a=_n[g&4095](b,f)|0;i=e;return a|0}function TIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(3126192,f)|0;i=e;return d|0}function UIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[g+0>>2];g=_n[h&4095](b,f)|0;i=e;return g|0}function VIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2650536,f)|0;i=e;return d|0}function WIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[g+0>>2];g=_n[h&4095](b,f)|0;i=e;return g|0}function XIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[g+0>>2];g=_n[h&4095](b,f)|0;i=e;return g|0}function YIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2869072,f)|0;i=e;return d|0}function ZIg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2889800,f)|0;i=e;return d|0}function _Ig(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2729368,f)|0;i=e;return d|0}function $Ig(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2516584,f)|0;i=e;return d|0}function aJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(1342344,f)|0;i=e;return d|0}function bJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(1810464,f)|0;i=e;return d|0}function cJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(1820016,f)|0;i=e;return d|0}function dJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(1844464,f)|0;i=e;return d|0}function eJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2029160,f)|0;i=e;return d|0}function fJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;co[c[a+4>>2]&2047](f,b,c[d>>2]|0);d=pL(2119600,f)|0;i=e;return d|0}function gJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2604248,f)|0;i=e;return d|0}function hJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];c[f+0>>2]=c[g+0>>2];g=_n[h&4095](b,f)|0;i=e;return g|0}function iJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;d=pL(2606296,f)|0;i=e;return d|0}function jJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=_n[c[a+4>>2]&4095](b,c[d>>2]|0)|0;i=e;return f|0}function kJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0);i=f;return 0}function lJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function mJg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;co[c[d+4>>2]&2047](e,b[c[f>>2]>>1]|0,a[c[f+4>>2]>>0]|0);i=g;return 0}function nJg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=(xo[c[d+4>>2]&2047](e,b[c[f>>2]>>1]|0,a[c[f+4>>2]>>0]|0)|0)&1;f=pL(2601984,h)|0;i=g;return f|0}function oJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0);i=f;return 0}function pJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;co[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,b[c[e+4>>2]>>1]|0);i=f;return 0}function qJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,a[c[e>>2]>>0]|0,c[c[e+4>>2]>>2]|0);i=f;return 0}function rJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function sJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0);i=f;return 0}function tJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;co[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,b[c[e+4>>2]>>1]|0);i=f;return 0}function uJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;co[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,c[c[e+4>>2]>>2]|0);i=f;return 0}function vJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;co[c[a+4>>2]&2047](d,c[c[e>>2]>>2]|0,b[c[e+4>>2]>>1]|0);i=f;return 0}function wJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=xo[c[b+4>>2]&2047](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function xJg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=(xo[c[d+4>>2]&2047](e,b[c[f>>2]>>1]|0,c[c[f+4>>2]>>2]|0)|0)&1;f=pL(2601984,h)|0;i=g;return f|0}function yJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;co[c[a+4>>2]&2047](d,c[c[e>>2]>>2]|0,b[c[e+4>>2]>>1]|0);i=f;return 0}function zJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0);i=e;return 0}function AJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function BJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d>>2]|0;Dn[c[a+4>>2]&511](b,c[f>>2]|0,c[f+4>>2]|0,c[c[d+4>>2]>>2]|0);i=e;return 0}function CJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d+4>>2]|0;Dn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[f>>2]|0,c[f+4>>2]|0);i=e;return 0}function DJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=xo[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,b[c[e+4>>2]>>1]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function EJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d+4>>2]>>2]);go[c[a+4>>2]&63](b,c[c[d>>2]>>2]|0,f);i=e;return 0}function FJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=xo[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,b[c[e+4>>2]>>1]|0)|0;e=pL(2565248,g)|0;i=f;return e|0}function GJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0);i=f;return 0}function HJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=xo[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0)|0;e=pL(2557392,g)|0;i=f;return e|0}function IJg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=xo[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,c[c[e+4>>2]>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function JJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+8|0;h=f;j=c[b+4>>2]|0;b=a[c[e>>2]>>0]|0;k=c[e+4>>2]|0;e=c[k+4>>2]|0;l=h;c[l>>2]=c[k>>2];c[l+4>>2]=e;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];co[j&2047](d,b,g);i=f;return 0}function KJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;fo[c[a+4>>2]&7](b,c[c[d>>2]>>2]|0,+h[c[d+4>>2]>>3]);i=e;return 0}function LJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function MJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im;e=i;f=ea(g[c[d>>2]>>2]);h=ea(g[c[d+4>>2]>>2]);on[c[a+4>>2]&31](b,f,h);i=e;return 0}function NJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0);i=e;return 0}function OJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0);i=e;return 0}function PJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0);i=e;return 0}function QJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function RJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function SJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e>>2]>>2]);k=ea(g[c[e+4>>2]>>2]);a[h>>0]=(no[c[b+4>>2]&1](d,j,k)|0)&1;d=pL(2601984,h)|0;i=f;return d|0}function TJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function UJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+12|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];a=c[c[d+4>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];co[h&2047](b,f,a);i=e;return 0}function VJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function WJg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function XJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function YJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function ZJg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function _Jg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+64|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=f+0|0;j=(c[d+4>>2]|0)+0|0;d=h+60|0;do{c[h>>2]=c[j>>2];h=h+4|0;j=j+4|0}while((h|0)<(d|0));co[g&2047](b,a,f);i=e;return 0}function $Jg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];co[g&2047](b,a,f);i=e;return 0}function aKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function bKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;c[g>>2]=c[c[d+4>>2]>>2];c[f+0>>2]=c[g+0>>2];co[h&2047](b,a,f);i=e;return 0}function cKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function dKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];co[g&2047](b,a,f);i=e;return 0}function eKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];co[g&2047](b,a,f);i=e;return 0}function fKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function gKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(tn[c[a+4>>2]&15](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0));d=pL(2586184,f)|0;i=e;return d|0}function hKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;j=c[a>>2]|0;k=c[a+4>>2]|0;a=c[d+4>>2]|0;d=c[a+4>>2]|0;l=g;c[l>>2]=c[a>>2];c[l+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Dn[h&511](b,j,k,f);i=e;return 0}function iKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[d>>2]|0;h=c[d+4>>2]|0;c[f>>2]=Bn[c[a+4>>2]&255](b,c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;h=pL(2540224,f)|0;i=e;return h|0}function jKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[b+4>>2]|0;c[h>>2]=c[c[e>>2]>>2];b=a[c[e+4>>2]>>0]|0;c[g+0>>2]=c[h+0>>2];co[j&2047](d,g,b);i=f;return 0}function kKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im;e=i;i=i+32|0;f=e+16|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];k=ea(g[c[d+4>>2]>>2]);c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];go[j&63](b,f,k);i=e;return 0}function lKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function mKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function nKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function oKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function pKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function qKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function rKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function sKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0);i=f;return 0}function tKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function uKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function vKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[c[d>>2]>>2]|0;c[g>>2]=c[c[d+4>>2]>>2];c[f+0>>2]=c[g+0>>2];co[h&2047](b,a,f);i=e;return 0}function wKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function xKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function yKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];co[h&2047](b,f,a);i=e;return 0}function zKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function AKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;co[c[b+4>>2]&2047](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0);i=f;return 0}function BKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+144|0;g=f+64|0;h=f+128|0;j=f;k=c[b+4>>2]|0;b=j+0|0;l=(c[e>>2]|0)+0|0;m=b+64|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(m|0));n=c[e+4>>2]|0;b=g+0|0;l=j+0|0;m=b+64|0;do{c[b>>2]=c[l>>2];b=b+4|0;l=l+4|0}while((b|0)<(m|0));a[h>>0]=(xo[k&2047](d,g,n)|0)&1;n=pL(2601984,h)|0;i=f;return n|0}function CKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+48|0;f=e+24|0;g=e+12|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];co[j&2047](b,g,f);i=e;return 0}function DKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=f+24|0;h=f+48|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[j+16>>2]=c[b+16>>2];c[j+20>>2]=c[b+20>>2];b=c[e+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];a[h>>0]=(xo[k&2047](d,g,b)|0)&1;b=pL(2601984,h)|0;i=f;return b|0}function EKg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;co[c[a+4>>2]&2047](d,c[e>>2]|0,b[c[e+4>>2]>>1]|0);i=f;return 0}function FKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=e+40|0;g=e+24|0;h=e+8|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;d=c[a+4>>2]|0;l=j;c[l>>2]=c[a>>2];c[l+4>>2]=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];co[k&2047](b,g,f);i=e;return 0}function GKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+112|0;g=f+64|0;h=f+32|0;j=f+96|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[k+16>>2]=c[b+16>>2];c[k+20>>2]=c[b+20>>2];c[k+24>>2]=c[b+24>>2];c[k+28>>2]=c[b+28>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[h+20>>2]=c[k+20>>2];c[h+24>>2]=c[k+24>>2];c[h+28>>2]=c[k+28>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];c[g+24>>2]=c[b+24>>2];c[g+28>>2]=c[b+28>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function HKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+24|0;h=f+16|0;j=f+32|0;k=f+8|0;l=f;m=c[b+4>>2]|0;b=c[e>>2]|0;n=c[b+4>>2]|0;o=k;c[o>>2]=c[b>>2];c[o+4>>2]=n;n=c[e+4>>2]|0;e=c[n+4>>2]|0;o=l;c[o>>2]=c[n>>2];c[o+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];a[j>>0]=(xo[m&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function IKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+24|0;h=f+12|0;j=f+36|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function JKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+208|0;g=f+128|0;h=f+64|0;j=f+192|0;k=f;l=c[b+4>>2]|0;b=k+0|0;m=(c[e>>2]|0)+0|0;n=b+64|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));o=c[e+4>>2]|0;b=h+0|0;m=k+0|0;n=b+64|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));b=g+0|0;m=o+0|0;n=b+64|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function KKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+48|0;h=f+24|0;j=f+60|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[k+16>>2]=c[b+16>>2];c[k+20>>2]=c[b+20>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[h+20>>2]=c[k+20>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function LKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+80|0;g=f+48|0;h=f+24|0;j=f+72|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[k+16>>2]=c[b+16>>2];c[k+20>>2]=c[b+20>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[h+20>>2]=c[k+20>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function MKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f+48|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function NKg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);j=ea(g[c[d+4>>2]>>2]);g[f>>2]=ea(Jm[c[a+4>>2]&7](b,h,j));b=pL(2586184,f)|0;i=e;return b|0}function OKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+336|0;g=f+216|0;h=f+108|0;j=f+324|0;k=f;l=c[b+4>>2]|0;b=k+0|0;m=(c[e>>2]|0)+0|0;n=b+108|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));o=c[e+4>>2]|0;b=h+0|0;m=k+0|0;n=b+108|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));b=g+0|0;m=o+0|0;n=b+108|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function PKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+24|0;h=f+16|0;j=f+32|0;k=f+8|0;l=f;m=c[b+4>>2]|0;b=c[e>>2]|0;n=c[b+4>>2]|0;o=k;c[o>>2]=c[b>>2];c[o+4>>2]=n;n=c[e+4>>2]|0;e=c[n+4>>2]|0;o=l;c[o>>2]=c[n>>2];c[o+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];a[j>>0]=(xo[m&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function QKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f+48|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function RKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f+48|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function SKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f+48|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function TKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[b+4>>2]&2047](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0)|0;i=f;return g|0}function UKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+24|0;h=f+16|0;j=f+32|0;k=f+8|0;l=f;m=c[b+4>>2]|0;b=c[e>>2]|0;n=c[b+4>>2]|0;o=k;c[o>>2]=c[b>>2];c[o+4>>2]=n;n=c[e+4>>2]|0;e=c[n+4>>2]|0;o=l;c[o>>2]=c[n>>2];c[o+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];a[j>>0]=(xo[m&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function VKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+192|0;g=f+120|0;h=f+60|0;j=f+180|0;k=f;l=c[b+4>>2]|0;b=k+0|0;m=(c[e>>2]|0)+0|0;n=b+60|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));o=c[e+4>>2]|0;b=h+0|0;m=k+0|0;n=b+60|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));b=g+0|0;m=o+0|0;n=b+60|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(n|0));a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function WKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+24|0;h=f+12|0;j=f+36|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function XKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+24|0;h=f+16|0;j=f+32|0;k=f+8|0;l=f;m=c[b+4>>2]|0;b=c[e>>2]|0;n=c[b+4>>2]|0;o=k;c[o>>2]=c[b>>2];c[o+4>>2]=n;n=c[e+4>>2]|0;e=c[n+4>>2]|0;o=l;c[o>>2]=c[n>>2];c[o+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];a[j>>0]=(xo[m&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function YKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+80|0;g=f+48|0;h=f+24|0;j=f+72|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[k+16>>2]=c[b+16>>2];c[k+20>>2]=c[b+20>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[h+20>>2]=c[k+20>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function ZKg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f+48|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;c[k+0>>2]=c[b+0>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];b=c[e+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];a[j>>0]=(xo[l&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function _Kg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0);i=e;return 0}function $Kg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0);i=e;return 0}function aLg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=xo[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,c[e+4>>2]|0)|0;e=pL(2540392,g)|0;i=f;return e|0}function bLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function cLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d+4>>2]|0;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[f>>2]|0,c[f+4>>2]|0);i=e;return 0}function dLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+_m[c[a+4>>2]&3](b,+h[c[d>>2]>>3],+h[c[d+4>>2]>>3]);d=pL(2589144,f)|0;i=e;return d|0}function eLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[b+4>>2]&2047](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0)|0;i=f;return g|0}function fLg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,b[c[e+4>>2]>>1]|0)|0;i=f;return g|0}function gLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function hLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function iLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function jLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d+4>>2]>>2]);go[c[a+4>>2]&63](b,c[d>>2]|0,f);i=e;return 0}function kLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;c[f+0>>2]=c[g+0>>2];co[h&2047](b,f,a);i=e;return 0}function lLg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[a+4>>2]&2047](d,c[c[e>>2]>>2]|0,b[c[e+4>>2]>>1]|0)|0;i=f;return g|0}function mLg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[a+4>>2]&2047](d,b[c[e>>2]>>1]|0,c[c[e+4>>2]>>2]|0)|0;i=f;return g|0}function nLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+40|0;g=e+24|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[h>>2]=xo[k&2047](b,g,f)|0;f=pL(2540224,h)|0;i=e;return f|0}function oLg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=xo[c[a+4>>2]&2047](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0)|0;e=pL(2562664,g)|0;i=f;return e|0}function pLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;k=c[b+4>>2]|0;c[j>>2]=c[c[e>>2]>>2];b=c[e+4>>2]|0;c[g+0>>2]=c[j+0>>2];a[h>>0]=(xo[k&2047](d,g,b)|0)&1;b=pL(2601984,h)|0;i=f;return b|0}function qLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+32|0;g=e+16|0;h=e+48|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[h>>2]=xo[k&2047](b,g,f)|0;f=pL(2540224,h)|0;i=e;return f|0}function rLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];a=c[c[d+4>>2]>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];Dn[j&511](g,b,f,a);a=pL(3034456,g)|0;i=e;return a|0}function sLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+24|0;g=e+16|0;h=e+32|0;j=e+8|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;m=c[a+4>>2]|0;n=j;c[n>>2]=c[a>>2];c[n+4>>2]=m;m=c[d+4>>2]|0;d=c[m+4>>2]|0;n=k;c[n>>2]=c[m>>2];c[n+4>>2]=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[h>>2]=xo[l&2047](b,g,f)|0;f=pL(2540224,h)|0;i=e;return f|0}function tLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+80|0;f=e+48|0;g=e+24|0;h=e+72|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[j+20>>2]=c[a+20>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[h>>2]=xo[k&2047](b,g,f)|0;f=pL(2540224,h)|0;i=e;return f|0}function uLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+40|0;g=e+24|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[h>>2]=xo[k&2047](b,g,f)|0;f=pL(2540224,h)|0;i=e;return f|0}function vLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(tn[c[a+4>>2]&15](b,c[d>>2]|0,c[d+4>>2]|0));d=pL(2586184,f)|0;i=e;return d|0}function wLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0)|0;i=e;return f|0}function xLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function yLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function zLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=pL(2551640,f)|0;i=e;return d|0}function ALg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function BLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function CLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function DLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im;e=i;i=i+48|0;f=e+24|0;h=e+12|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];l=ea(g[c[d+4>>2]>>2]);c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];so[k&15](h,b,f,l);f=pL(2416264,h)|0;i=e;return f|0}function ELg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=Im;e=i;i=i+48|0;f=e+32|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];l=ea(g[c[d+4>>2]>>2]);c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];so[k&15](h,b,f,l);f=pL(2417688,h)|0;i=e;return f|0}function FLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+80|0;f=e+56|0;h=e+32|0;j=e+24|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];c[k+16>>2]=c[a+16>>2];c[k+20>>2]=c[a+20>>2];a=c[d+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[h+16>>2]=c[k+16>>2];c[h+20>>2]=c[k+20>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];g[j>>2]=ea(tn[l&15](b,h,f));f=pL(2586184,j)|0;i=e;return f|0}function GLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+64|0;f=e+40|0;h=e+24|0;j=e+16|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];g[j>>2]=ea(tn[l&15](b,h,f));f=pL(2586184,j)|0;i=e;return f|0}function HLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function ILg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function JLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=Im;e=i;i=i+336|0;f=e+216|0;h=e+108|0;j=e;k=c[a+4>>2]|0;a=j+0|0;l=(c[d>>2]|0)+0|0;m=a+108|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));n=ea(g[c[d+4>>2]>>2]);a=f+0|0;l=j+0|0;m=a+108|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));so[k&15](h,b,f,n);f=pL(2438936,h)|0;i=e;return f|0}function KLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im,l=0;e=i;i=i+224|0;f=e+108|0;h=e;j=c[a+4>>2]|0;k=ea(g[c[d>>2]>>2]);a=f+0|0;l=(c[d+4>>2]|0)+0|0;d=a+108|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(d|0));oo[j&7](h,b,k,f);f=pL(2438936,h)|0;i=e;return f|0}function LLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;j=c[d+4>>2]|0;d=c[j+4>>2]|0;k=g;c[k>>2]=c[j>>2];c[k+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];co[h&2047](b,a,f);i=e;return 0}function MLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function NLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function OLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function PLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function QLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function RLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function SLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function TLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function ULg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function VLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function WLg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function XLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g>>2]=c[c[d+4>>2]>>2];c[f+0>>2]=c[g+0>>2];co[h&2047](b,a,f);i=e;return 0}function YLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function ZLg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function _Lg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=c[a+4>>2]|0;a=c[d>>2]|0;h=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];co[g&2047](b,a,f);i=e;return 0}function $Lg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function aMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function bMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function cMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function dMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+96|0;g=f;h=f+84|0;j=c[b+4>>2]|0;b=c[e>>2]|0;k=g+0|0;l=(c[e+4>>2]|0)+0|0;e=k+84|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(e|0));a[h>>0]=(xo[j&2047](d,b,g)|0)&1;g=pL(2601984,h)|0;i=f;return g|0}function eMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2554736,f)|0;i=e;return d|0}function fMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f;k=c[b+4>>2]|0;b=c[e>>2]|0;c[j+0>>2]=c[b+0>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];b=c[e+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];a[h>>0]=(xo[k&2047](d,g,b)|0)&1;b=pL(2601984,h)|0;i=f;return b|0}function gMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;g=c[d+4>>2]|0;d=Bn[c[a+4>>2]&255](b,c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;i=e;return d|0}function hMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(2416264,f)|0;i=e;return d|0}function iMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;Dn[c[b+4>>2]&511](g,d,c[e>>2]|0,a[c[e+4>>2]>>0]|0);e=pL(2729368,g)|0;i=f;return e|0}function jMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+12|0;h=f+8|0;j=f+16|0;k=f+4|0;l=f;m=c[b+4>>2]|0;c[k>>2]=c[c[e>>2]>>2];c[l>>2]=c[c[e+4>>2]>>2];c[h+0>>2]=c[k+0>>2];c[g+0>>2]=c[l+0>>2];a[j>>0]=(xo[m&2047](d,h,g)|0)&1;g=pL(2601984,j)|0;i=f;return g|0}function kMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e;h=e+8|0;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];h=xo[j&2047](b,f,a)|0;a=g;c[a>>2]=h;c[a+4>>2]=H;a=pL(2548816,g)|0;i=e;return a|0}function lMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+32|0;g=e+24|0;h=e+16|0;j=e+8|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;m=c[a+4>>2]|0;n=j;c[n>>2]=c[a>>2];c[n+4>>2]=m;m=c[d+4>>2]|0;d=c[m+4>>2]|0;n=k;c[n>>2]=c[m>>2];c[n+4>>2]=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];Dn[l&511](h,b,g,f);f=pL(2395400,h)|0;i=e;return f|0}function mMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+36|0;g=e+24|0;h=e+12|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];Dn[k&511](h,b,g,f);f=pL(2416264,h)|0;i=e;return f|0}function nMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];Dn[k&511](h,b,g,f);f=pL(2419496,h)|0;i=e;return f|0}function oMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+256|0;f=e+192|0;g=e+128|0;h=e+64|0;j=e;k=c[a+4>>2]|0;a=j+0|0;l=(c[d>>2]|0)+0|0;m=a+64|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));n=c[d+4>>2]|0;a=g+0|0;l=j+0|0;m=a+64|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));a=f+0|0;l=n+0|0;m=a+64|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));Dn[k&511](h,b,g,f);f=pL(2422424,h)|0;i=e;return f|0}function pMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+160|0;f=e+144|0;g=e+80|0;h=e+64|0;j=e;k=c[a+4>>2]|0;a=j+0|0;l=(c[d>>2]|0)+0|0;m=a+64|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));n=c[d+4>>2]|0;a=g+0|0;l=j+0|0;m=a+64|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));c[f+0>>2]=c[n+0>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];Dn[k&511](h,b,g,f);f=pL(2353760,h)|0;i=e;return f|0}function qMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];Dn[k&511](h,b,g,f);f=pL(2353760,h)|0;i=e;return f|0}function rMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+432|0;f=e+324|0;g=e+216|0;h=e+108|0;j=e;k=c[a+4>>2]|0;a=j+0|0;l=(c[d>>2]|0)+0|0;m=a+108|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));n=c[d+4>>2]|0;a=g+0|0;l=j+0|0;m=a+108|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));a=f+0|0;l=n+0|0;m=a+108|0;do{c[a>>2]=c[l>>2];a=a+4|0;l=l+4|0}while((a|0)<(m|0));Dn[k&511](h,b,g,f);f=pL(2438936,h)|0;i=e;return f|0}function sMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];Dn[k&511](h,b,g,f);f=pL(2592872,h)|0;i=e;return f|0}function tMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+64|0;f=e+56|0;g=e+40|0;h=e+24|0;j=e+8|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;d=c[a+4>>2]|0;m=k;c[m>>2]=c[a>>2];c[m+4>>2]=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];Dn[l&511](h,b,g,f);f=pL(3034456,h)|0;i=e;return f|0}function uMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+32|0;g=e+24|0;h=e+16|0;j=e+8|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;m=c[a+4>>2]|0;n=j;c[n>>2]=c[a>>2];c[n+4>>2]=m;m=c[d+4>>2]|0;d=c[m+4>>2]|0;n=k;c[n>>2]=c[m>>2];c[n+4>>2]=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];k=xo[l&2047](b,g,f)|0;f=h;c[f>>2]=k;c[f+4>>2]=H;f=pL(3120120,h)|0;i=e;return f|0}function vMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+24|0;j=e+8|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;d=c[a+4>>2]|0;m=k;c[m>>2]=c[a>>2];c[m+4>>2]=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];k=xo[l&2047](b,g,f)|0;f=h;c[f>>2]=k;c[f+4>>2]=H;f=pL(3120120,h)|0;i=e;return f|0}function wMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function xMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function yMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g>>2]=c[c[d+4>>2]>>2];c[f+0>>2]=c[g+0>>2];co[h&2047](b,a,f);i=e;return 0}function zMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[c[d>>2]>>2]|0,c[d+4>>2]|0);d=pL(2729368,f)|0;i=e;return d|0}function AMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[c[d+4>>2]>>2]|0);d=pL(2729368,f)|0;i=e;return d|0}function BMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;d=pL(2516584,f)|0;i=e;return d|0}function CMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;Dn[c[b+4>>2]&511](g,d,c[e>>2]|0,a[c[e+4>>2]>>0]|0);e=pL(2119600,g)|0;i=f;return e|0}function DMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0);i=e;return 0}function EMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+96|0;f=e+4|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;k=f+0|0;l=(c[d+4>>2]|0)+0|0;d=k+84|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(d|0));g[h>>2]=ea(tn[j&15](b,a,f));f=pL(2586184,h)|0;i=e;return f|0}function FMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[g>>2]=xo[j&2047](b,f,a)|0;a=pL(2789408,g)|0;i=e;return a|0}function GMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[c[d>>2]>>2]|0,c[d+4>>2]|0);d=pL(1342344,f)|0;i=e;return d|0}function HMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[c[d+4>>2]>>2]|0);d=pL(1844464,f)|0;i=e;return d|0}function IMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[c[d+4>>2]>>2]|0);d=pL(2029160,f)|0;i=e;return d|0}function JMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function KMg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=xo[c[a+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0;e=pL(2540392,g)|0;i=f;return e|0}function LMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[b+4>>2]&2047](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0)|0;i=f;return g|0}function MMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0;e=pL(2560032,g)|0;i=f;return e|0}function NMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(2432168,f)|0;i=e;return d|0}function OMg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=xo[c[b+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0;e=pL(2557392,g)|0;i=f;return e|0}function PMg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=xo[c[a+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0;e=pL(2562664,g)|0;i=f;return e|0}function QMg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=xo[c[a+4>>2]&2047](d,c[e>>2]|0,b[c[e+4>>2]>>1]|0)|0;i=f;return g|0}function RMg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=xo[c[a+4>>2]&2047](d,c[e>>2]|0,c[e+4>>2]|0)|0;e=pL(2565248,g)|0;i=f;return e|0}function SMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function TMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0)|0;i=e;return f|0}function UMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0)|0;i=e;return f|0}function VMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=pL(2551640,f)|0;i=e;return d|0}function WMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function XMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+4>>2]|0;g=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;i=e;return g|0}function YMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;g=kn[c[a+4>>2]&511](b,c[f>>2]|0,c[f+4>>2]|0,c[d+4>>2]|0)|0;i=e;return g|0}function ZMg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2554736,f)|0;i=e;return d|0}function _Mg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;g[f>>2]=ea(tn[c[a+4>>2]&15](b,c[d>>2]|0,c[d+4>>2]|0));d=pL(2586184,f)|0;i=e;return d|0}function $Mg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=0;e=i;f=ea(g[c[d>>2]>>2]);h=ro[c[a+4>>2]&7](b,f,c[d+4>>2]|0)|0;i=e;return h|0}function aNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+zn[c[a+4>>2]&7](b,c[d>>2]|0,c[d+4>>2]|0);d=pL(2589144,f)|0;i=e;return d|0}function bNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Nm[c[a+4>>2]&3](b,+h[c[d>>2]>>3],c[d+4>>2]|0)|0;i=e;return f|0}function cNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;i=e;return f|0}function dNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;i=e;return f|0}function eNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;i=e;return f|0}function fNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(2592872,f)|0;i=e;return d|0}function gNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(3034456,f)|0;i=e;return d|0}function hNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(2729368,f)|0;i=e;return d|0}function iNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;k=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];c[j>>2]=c[c[d+4>>2]>>2];c[g+0>>2]=c[h+0>>2];c[f+0>>2]=c[j+0>>2];j=xo[k&2047](b,g,f)|0;i=e;return j|0}function jNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;c[f+0>>2]=c[h+0>>2];c[g>>2]=xo[j&2047](b,f,a)|0;a=pL(2604248,g)|0;i=e;return a|0}function kNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(1820016,f)|0;i=e;return d|0}function lNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;Dn[c[a+4>>2]&511](f,b,c[d>>2]|0,c[d+4>>2]|0);d=pL(1810464,f)|0;i=e;return d|0}function mNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;c[f+0>>2]=c[g+0>>2];g=xo[h&2047](b,f,a)|0;i=e;return g|0}function nNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=xo[c[a+4>>2]&2047](b,c[d>>2]|0,c[d+4>>2]|0)|0;i=e;return f|0}function oNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0);i=f;return 0}function pNg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;Dn[c[d+4>>2]&511](e,b[c[f>>2]>>1]|0,a[c[f+4>>2]>>0]|0,a[c[f+8>>2]>>0]|0);i=g;return 0}function qNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0);i=f;return 0}function rNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0);i=f;return 0}function sNg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[a+4>>2]&511](d,b[c[e>>2]>>1]|0,b[c[e+4>>2]>>1]|0,c[c[e+8>>2]>>2]|0);i=f;return 0}function tNg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;a[h>>0]=(kn[c[d+4>>2]&511](e,b[c[f>>2]>>1]|0,b[c[f+4>>2]>>1]|0,c[c[f+8>>2]>>2]|0)|0)&1;f=pL(2601984,h)|0;i=g;return f|0}function uNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0);i=e;return 0}function vNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d+8>>2]>>2]);so[c[a+4>>2]&15](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,f);i=e;return 0}function wNg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=kn[c[a+4>>2]&511](d,b[c[e>>2]>>1]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function xNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function yNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function zNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im;e=i;f=ea(g[c[d>>2]>>2]);h=ea(g[c[d+4>>2]>>2]);j=ea(g[c[d+8>>2]>>2]);qn[c[a+4>>2]&7](b,f,h,j);i=e;return 0}function ANg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0);i=f;return 0}function BNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,a[c[e>>2]>>0]|0,c[e+4>>2]|0,c[e+8>>2]|0);i=f;return 0}function CNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function DNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[b+4>>2]&511](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0)|0;i=f;return g|0}function ENg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[c[d+4>>2]>>2]|0;j=c[c[d+8>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];Dn[h&511](b,f,a,j);i=e;return 0}function FNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,a[c[e>>2]>>0]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0);i=f;return 0}function GNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0);i=e;return 0}function HNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0);i=f;return 0}function INg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function JNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[c[e>>2]>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function KNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0);i=e;return 0}function LNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0);i=e;return 0}function MNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0);i=e;return 0}function NNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=Im;e=i;i=i+64|0;f=e+40|0;h=e+28|0;j=e+16|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];m=ea(g[c[d+8>>2]>>2]);c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];so[l&15](b,h,f,m);i=e;return 0}function ONg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);j=ea(g[c[d+4>>2]>>2]);k=ea(g[c[d+8>>2]>>2]);g[f>>2]=ea(mn[c[a+4>>2]&3](b,h,j,k));b=pL(2586184,f)|0;i=e;return b|0}function PNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=kn[c[b+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function QNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0);i=e;return 0}function RNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+4>>2]|0;g=c[d+8>>2]|0;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0);i=e;return 0}function SNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d+4>>2]>>2]);oo[c[a+4>>2]&7](b,c[c[d>>2]>>2]|0,f,c[d+8>>2]|0);i=e;return 0}function TNg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function UNg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=kn[c[a+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,b[c[e+8>>2]>>1]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function VNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Ln[c[a+4>>2]&1](b,c[d>>2]|0,+h[c[d+4>>2]>>3],c[c[d+8>>2]>>2]|0);i=e;return 0}function WNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+40|0;g=e+28|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+8>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];Dn[k&511](b,g,f,a);i=e;return 0}function XNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0)|0;i=e;return f|0}function YNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+80|0;f=e+56|0;g=e+40|0;h=e+28|0;j=e+16|0;k=e;l=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];a=c[d+8>>2]|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];Dn[l&511](b,h,g,f);i=e;return 0}function ZNg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function _Ng(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+80|0;f=e+72|0;g=e+56|0;h=e+40|0;j=e+24|0;k=e+8|0;l=e;m=c[a+4>>2]|0;a=c[d>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];a=c[d+8>>2]|0;d=c[a+4>>2]|0;n=l;c[n>>2]=c[a>>2];c[n+4>>2]=d;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];Dn[m&511](b,h,g,f);i=e;return 0}function $Ng(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im;e=i;i=i+16|0;f=e;h=ea(g[c[d>>2]>>2]);j=ea(g[c[d+4>>2]>>2]);k=ea(g[c[d+8>>2]>>2]);yo[c[a+4>>2]&3](f,b,h,j,k);b=pL(2419496,f)|0;i=e;return b|0}function aOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0);i=e;return 0}function bOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0);i=e;return 0}function cOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+64|0;f=e+28|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;j=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];j=c[c[d+8>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];c[f+24>>2]=c[g+24>>2];Dn[h&511](b,a,f,j);i=e;return 0}function dOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function eOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;j=c[d+8>>2]|0;c[f+0>>2]=c[g+0>>2];Dn[h&511](b,f,a,j);i=e;return 0}function fOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;j=c[d+8>>2]|0;c[f+0>>2]=c[g+0>>2];Dn[h&511](b,f,a,j);i=e;return 0}function gOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[d>>2]|0;g=c[d+4>>2]|0;h=c[d+8>>2]|0;d=gn[c[a+4>>2]&127](b,c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;i=e;return d|0}function hOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function iOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0);i=e;return 0}function jOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Dn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0);i=f;return 0}function kOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function lOg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=kn[c[a+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0)|0;e=pL(2540392,g)|0;i=f;return e|0}function mOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[b+4>>2]&511](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0)|0;i=f;return g|0}function nOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0);i=e;return 0}function oOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;En[c[a+4>>2]&127](f,b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0);d=pL(2422424,f)|0;i=e;return d|0}function pOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0);i=e;return 0}function qOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=Im;e=i;i=i+48|0;f=e+24|0;h=e;j=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];k=ea(g[c[d+4>>2]>>2]);a=c[c[d+8>>2]>>2]|0;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];h=wo[j&7](b,f,k,a)|0;i=e;return h|0}function rOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0);i=e;return 0}function sOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function tOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d+8>>2]|0;En[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0);i=e;return 0}function uOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+144|0;f=e+128|0;g=e+112|0;h=e+96|0;j=e+32|0;k=e+16|0;l=e;m=c[a+4>>2]|0;a=c[d>>2]|0;c[k+0>>2]=c[a+0>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];a=c[d+8>>2]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];En[m&127](j,b,h,g,f);f=pL(2422424,j)|0;i=e;return f|0}function vOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=kn[c[b+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0)|0;e=pL(2560032,g)|0;i=f;return e|0}function wOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function xOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[b+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0)|0;i=f;return g|0}function yOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[c[d+4>>2]>>2]|0;j=c[c[d+8>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];g=kn[h&511](b,f,a,j)|0;i=e;return g|0}function zOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=kn[c[b+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0)|0;e=pL(2557392,g)|0;i=f;return e|0}function AOg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=kn[c[a+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0)|0;e=pL(2562664,g)|0;i=f;return e|0}function BOg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;b[g>>1]=kn[c[a+4>>2]&511](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0)|0;e=pL(2565248,g)|0;i=f;return e|0}function COg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function DOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0)|0;i=e;return f|0}function EOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function FOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0)|0;i=e;return f|0}function GOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0)|0;d=pL(2551640,f)|0;i=e;return d|0}function HOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0);i=e;return 0}function IOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function JOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function KOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function LOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;j=c[d+4>>2]|0;k=c[d+8>>2]|0;d=c[k+4>>2]|0;l=g;c[l>>2]=c[k>>2];c[l+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];Dn[h&511](b,a,j,f);i=e;return 0}function MOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2554736,f)|0;i=e;return d|0}function NOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[b+4>>2]&511](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0)|0;i=f;return g|0}function OOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+Qn[c[a+4>>2]&1](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0);d=pL(2589144,f)|0;i=e;return d|0}function POg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;En[c[a+4>>2]&127](f,b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0);d=pL(2592872,f)|0;i=e;return d|0}function QOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g>>2]=c[c[d+4>>2]>>2];j=c[d+8>>2]|0;c[f+0>>2]=c[g+0>>2];Dn[h&511](b,a,f,j);i=e;return 0}function ROg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;En[c[a+4>>2]&127](f,b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0);d=pL(3034456,f)|0;i=e;return d|0}function SOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;d=pL(2604248,f)|0;i=e;return d|0}function TOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Dn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0);i=e;return 0}function UOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[b+4>>2]&511](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0)|0;i=f;return g|0}function VOg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[b+4>>2]&511](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0)|0;i=f;return g|0}function WOg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=kn[c[a+4>>2]&511](d,c[e>>2]|0,b[c[e+4>>2]>>1]|0,c[e+8>>2]|0)|0;i=f;return g|0}function XOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;i=e;return f|0}function YOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0)|0;i=e;return f|0}function ZOg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function _Og(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0)|0;i=e;return f|0}function $Og(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d+4>>2]|0;g=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[f>>2]|0,c[f+4>>2]|0,c[d+8>>2]|0)|0;i=e;return g|0}function aPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=0;e=i;f=ea(g[c[d+4>>2]>>2]);h=wo[c[a+4>>2]&7](b,c[d>>2]|0,f,c[d+8>>2]|0)|0;i=e;return h|0}function bPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Hn[c[a+4>>2]&1](b,c[d>>2]|0,+h[c[d+4>>2]>>3],c[d+8>>2]|0)|0;i=e;return f|0}function cPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;i=e;return f|0}function dPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;i=e;return f|0}function ePg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+12|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];a=c[d+4>>2]|0;j=c[d+8>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];g=kn[h&511](b,f,a,j)|0;i=e;return g|0}function fPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;j=c[d+8>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];g=kn[h&511](b,f,a,j)|0;i=e;return g|0}function gPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e;h=c[a+4>>2]|0;a=c[d>>2]|0;j=c[d+4>>2]|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];j=c[d+8>>2]|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];g=kn[h&511](b,a,f,j)|0;i=e;return g|0}function hPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=kn[c[a+4>>2]&511](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0)|0;i=e;return f|0}function iPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function jPg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;En[c[d+4>>2]&127](e,b[c[f>>2]>>1]|0,a[c[f+4>>2]>>0]|0,a[c[f+8>>2]>>0]|0,a[c[f+12>>2]>>0]|0);i=g;return 0}function kPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function lPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function mPg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;b[h>>1]=Bn[c[d+4>>2]&255](e,a[c[f>>2]>>0]|0,a[c[f+4>>2]>>0]|0,a[c[f+8>>2]>>0]|0,a[c[f+12>>2]>>0]|0)|0;f=pL(2280424,h)|0;i=g;return f|0}function nPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function oPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function pPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im;e=i;f=ea(g[c[d>>2]>>2]);h=ea(g[c[d+4>>2]>>2]);j=ea(g[c[d+8>>2]>>2]);k=ea(g[c[d+12>>2]>>2]);Zm[c[a+4>>2]&15](b,f,h,j,k);i=e;return 0}function qPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[c[d+4>>2]>>2]|0;j=c[c[d+8>>2]>>2]|0;k=c[c[d+12>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];En[h&127](b,f,a,j,k);i=e;return 0}function rPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0,c[e+12>>2]|0);i=f;return 0}function sPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function tPg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=i;En[c[a+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,b[c[e+12>>2]>>1]|0);i=f;return 0}function uPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function vPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function wPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function xPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function yPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function zPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,a[c[e>>2]>>0]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function APg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[d+4>>2]|0;g=c[d+8>>2]|0;h=c[d+12>>2]|0;Nn[c[a+4>>2]&31](b,c[d>>2]|0,c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0);i=e;return 0}function BPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function CPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function DPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function EPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im;e=i;i=i+64|0;f=e;h=ea(g[c[d>>2]>>2]);j=ea(g[c[d+4>>2]>>2]);k=ea(g[c[d+8>>2]>>2]);l=ea(g[c[d+12>>2]>>2]);No[c[a+4>>2]&1](f,b,h,j,k,l);b=pL(2422424,f)|0;i=e;return b|0}function FPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function GPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function HPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function IPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function JPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function KPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function LPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0)|0;i=f;return g|0}function MPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function NPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+12|0;g=e;h=e+8|0;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;k=c[a>>2]|0;l=c[a+4>>2]|0;a=c[c[d+8>>2]>>2]|0;m=c[d+12>>2]|0;c[f+0>>2]=c[h+0>>2];h=Km[j&127](b,f,k,l,a,m)|0;m=g;c[m>>2]=h;c[m+4>>2]=H;m=pL(2548816,g)|0;i=e;return m|0}function OPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function PPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0);i=f;return 0}function QPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;En[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0,c[c[e+12>>2]>>2]|0);i=f;return 0}function RPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[c[d+4>>2]>>2]|0;j=c[d+8>>2]|0;k=c[c[d+12>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];En[h&127](b,f,a,j,k);i=e;return 0}function SPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;j=c[c[d+8>>2]>>2]|0;k=c[c[d+12>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];En[h&127](b,f,a,j,k);i=e;return 0}function TPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0);i=e;return 0}function UPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function VPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0);i=e;return 0}function WPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function XPg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Bn[c[b+4>>2]&255](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0;e=pL(2604248,g)|0;i=f;return e|0}function YPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d+4>>2]>>2]);Jn[c[a+4>>2]&3](b,c[c[d>>2]>>2]|0,f,c[d+8>>2]|0,c[d+12>>2]|0);i=e;return 0}function ZPg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0)|0;i=e;return f|0}function _Pg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function $Pg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function aQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function bQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function cQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function dQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function eQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function fQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function gQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0)|0;i=e;return f|0}function hQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0);i=e;return 0}function iQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0);i=e;return 0}function jQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=0;e=i;f=ea(g[c[d+8>>2]>>2]);h=ho[c[a+4>>2]&3](b,c[d>>2]|0,c[d+4>>2]|0,f,c[c[d+12>>2]>>2]|0)|0;i=e;return h|0}function kQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0)|0;i=f;return g|0}function lQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;En[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0);i=e;return 0}function mQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function nQg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Bn[c[a+4>>2]&255](d,b[c[e>>2]>>1]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0;i=f;return g|0}function oQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0,c[e+12>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function pQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function qQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,a[c[e+8>>2]>>0]|0,c[e+12>>2]|0)|0;i=f;return g|0}function rQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im;e=i;f=ea(g[c[d+4>>2]>>2]);Jn[c[a+4>>2]&3](b,c[d>>2]|0,f,c[d+8>>2]|0,c[d+12>>2]|0);i=e;return 0}function sQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0)|0;i=e;return f|0}function tQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0)|0;i=e;return f|0}function uQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0)|0;i=e;return f|0}function vQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function wQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Bn[c[b+4>>2]&255](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0)|0;i=f;return g|0}function xQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Bn[c[b+4>>2]&255](d,c[e>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0)|0;i=f;return g|0}function yQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0)|0;i=e;return f|0}function zQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0)|0;i=e;return f|0}function AQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;h=e+16|0;j=e;k=c[a+4>>2]|0;a=c[d>>2]|0;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];a=c[d+4>>2]|0;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];a=c[d+8>>2]|0;l=c[d+12>>2]|0;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];j=Bn[k&255](b,g,f,a,l)|0;i=e;return j|0}function BQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Bn[c[a+4>>2]&255](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0)|0;i=e;return f|0}function CQg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;rn[c[d+4>>2]&127](e,b[c[f>>2]>>1]|0,b[c[f+4>>2]>>1]|0,a[c[f+8>>2]>>0]|0,a[c[f+12>>2]>>0]|0,a[c[f+16>>2]>>0]|0);i=g;return 0}function DQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;rn[c[b+4>>2]&127](d,c[c[e>>2]>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,a[c[e+12>>2]>>0]|0,a[c[e+16>>2]>>0]|0);i=f;return 0}function EQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;rn[c[b+4>>2]&127](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0);i=f;return 0}function FQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0);i=e;return 0}function GQg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;rn[c[d+4>>2]&127](e,b[c[f>>2]>>1]|0,c[f+4>>2]|0,a[c[f+8>>2]>>0]|0,a[c[f+12>>2]>>0]|0,a[c[f+16>>2]>>0]|0);i=g;return 0}function HQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=Km[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0)|0;d=f;c[d>>2]=g;c[d+4>>2]=H;d=pL(2548816,f)|0;i=e;return d|0}function IQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=c[a+4>>2]|0;c[g>>2]=c[c[d>>2]>>2];a=c[c[d+4>>2]>>2]|0;j=c[c[d+8>>2]>>2]|0;k=c[c[d+12>>2]>>2]|0;l=c[c[d+16>>2]>>2]|0;c[f+0>>2]=c[g+0>>2];rn[h&127](b,f,a,j,k,l);i=e;return 0}function JQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0);i=e;return 0}function KQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function LQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Km[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function MQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function NQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im,j=Im,k=Im;e=i;f=ea(g[c[d>>2]>>2]);h=ea(g[c[d+4>>2]>>2]);j=ea(g[c[d+8>>2]>>2]);k=ea(g[c[d+12>>2]>>2]);Po[c[a+4>>2]&3](b,f,h,j,k,c[d+16>>2]|0);i=e;return 0}function OQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;rn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0);i=f;return 0}function PQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0);i=e;return 0}function QQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0);i=e;return 0}function RQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;rn[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,a[c[e+8>>2]>>0]|0,c[e+12>>2]|0,c[e+16>>2]|0);i=f;return 0}function SQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function TQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function UQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function VQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function WQg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function XQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c[d+4>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;Yn[c[a+4>>2]&15](b,c[d>>2]|0,c[f>>2]|0,c[f+4>>2]|0,c[d+8>>2]|0,c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0);i=e;return 0}function YQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function ZQg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function _Qg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function $Qg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Km[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[e+16>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function aRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=c[a+4>>2]|0;c[h>>2]=c[c[d>>2]>>2];a=c[d+4>>2]|0;k=c[c[d+8>>2]>>2]|0;l=c[c[d+12>>2]>>2]|0;m=c[d+16>>2]|0;c[f+0>>2]=c[h+0>>2];c[g>>2]=Km[j&127](b,f,a,k,l,m)|0;m=pL(2540224,g)|0;i=e;return m|0}function bRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[d+16>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function cRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;rn[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0,a[c[e+16>>2]>>0]|0);i=f;return 0}function dRg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Km[c[d+4>>2]&127](e,b[c[f>>2]>>1]|0,c[f+4>>2]|0,c[f+8>>2]|0,c[f+12>>2]|0,a[c[f+16>>2]>>0]|0)|0;i=g;return h|0}function eRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[d+16>>2]|0);i=e;return 0}function fRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0);i=e;return 0}function gRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function hRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0);i=e;return 0}function iRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0);i=e;return 0}function jRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=Km[c[b+4>>2]&127](d,c[c[e>>2]>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0)|0;i=f;return g|0}function kRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Km[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0)|0;i=e;return f|0}function lRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0)|0;i=e;return f|0}function mRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0)|0;i=e;return f|0}function nRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Km[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0)|0;i=e;return f|0}function oRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Km[c[a+4>>2]&127](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0)|0;i=e;return f|0}function pRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f+4|0;h=f;j=c[b+4>>2]|0;c[h>>2]=c[c[e>>2]>>2];b=c[c[e+4>>2]>>2]|0;k=a[c[e+8>>2]>>0]|0;l=c[c[e+12>>2]>>2]|0;m=a[c[e+16>>2]>>0]|0;n=a[c[e+20>>2]>>0]|0;c[g+0>>2]=c[h+0>>2];Wn[j&127](d,g,b,k,l,m,n);i=f;return 0}function qRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=Im,j=Im,k=Im,l=Im,m=Im,n=Im;e=i;i=i+64|0;f=e;h=ea(g[c[d>>2]>>2]);j=ea(g[c[d+4>>2]>>2]);k=ea(g[c[d+8>>2]>>2]);l=ea(g[c[d+12>>2]>>2]);m=ea(g[c[d+16>>2]>>2]);n=ea(g[c[d+20>>2]>>2]);xn[c[a+4>>2]&1](f,b,h,j,k,l,m,n);b=pL(2422424,f)|0;i=e;return b|0}function rRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,c[c[e+20>>2]>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function sRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,a[c[e+20>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function tRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,a[c[e+16>>2]>>0]|0,c[e+20>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function uRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0,c[c[d+20>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function vRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Wn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0);i=e;return 0}function wRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,a[c[e+20>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function xRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0,c[e+20>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function yRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0,c[e+20>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function zRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0,c[e+20>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function ARg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0,c[e+20>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function BRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0,c[e+20>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function CRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0,c[d+20>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function DRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0,c[d+20>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function ERg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Wn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0);i=e;return 0}function FRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Wn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0);i=e;return 0}function GRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=c[d+16>>2]|0;c[f>>2]=Oo[c[a+4>>2]&63](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[g>>2]|0,c[g+4>>2]|0,c[c[d+20>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function HRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=gn[c[b+4>>2]&127](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0,c[e+20>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function IRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function JRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Wn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0,c[d+20>>2]|0);i=e;return 0}function KRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0)|0;i=e;return f|0}function LRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0)|0;i=e;return f|0}function MRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=gn[c[a+4>>2]&127](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0)|0;i=e;return f|0}function NRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Nn[c[a+4>>2]&31](b,c[c[d>>2]>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0,c[c[d+20>>2]>>2]|0,c[c[d+24>>2]>>2]|0);i=e;return 0}function ORg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,a[c[e+12>>2]>>0]|0,c[c[e+16>>2]>>2]|0,a[c[e+20>>2]>>0]|0,a[c[e+24>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function PRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,a[c[e+16>>2]>>0]|0,a[c[e+20>>2]>>0]|0,c[e+24>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function QRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Oo[c[b+4>>2]&63](d,c[c[e>>2]>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,c[c[e+20>>2]>>2]|0,a[c[e+24>>2]>>0]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function RRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Oo[c[a+4>>2]&63](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0,c[c[d+20>>2]>>2]|0,c[c[d+24>>2]>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function SRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,c[e+20>>2]|0,a[c[e+24>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function TRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,a[c[e+20>>2]>>0]|0,c[e+24>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function URg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0,c[e+20>>2]|0,c[e+24>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function VRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Nn[c[a+4>>2]&31](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0,c[d+24>>2]|0);i=e;return 0}function WRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[e+16>>2]|0,a[c[e+20>>2]>>0]|0,c[e+24>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function XRg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Oo[c[b+4>>2]&63](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0,a[c[e+20>>2]>>0]|0,c[e+24>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function YRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=Oo[c[a+4>>2]&63](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[c[d+8>>2]>>2]|0,c[d+12>>2]|0,c[c[d+16>>2]>>2]|0,c[d+20>>2]|0,c[d+24>>2]|0)|0;d=pL(2540224,f)|0;i=e;return d|0}function ZRg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=Im,h=Im;e=i;f=ea(g[c[d+16>>2]>>2]);h=ea(g[c[d+20>>2]>>2]);Qm[c[a+4>>2]&1](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0,f,h,c[d+24>>2]|0);i=e;return 0}function _Rg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Nn[c[b+4>>2]&31](d,c[c[e>>2]>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0,c[e+16>>2]|0,c[e+20>>2]|0,a[c[e+24>>2]>>0]|0);i=f;return 0}function $Rg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Oo[c[a+4>>2]&63](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0,c[d+24>>2]|0)|0;i=e;return f|0}function aSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=i;Yn[c[b+4>>2]&15](d,a[c[e>>2]>>0]|0,a[c[e+4>>2]>>0]|0,a[c[e+8>>2]>>0]|0,a[c[e+12>>2]>>0]|0,a[c[e+16>>2]>>0]|0,a[c[e+20>>2]>>0]|0,a[c[e+24>>2]>>0]|0,a[c[e+28>>2]>>0]|0);i=f;return 0}function bSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(cn[c[b+4>>2]&15](d,c[c[e>>2]>>2]|0,a[c[e+4>>2]>>0]|0,c[e+8>>2]|0,c[e+12>>2]|0,c[e+16>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function cSg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=cn[c[d+4>>2]&15](e,c[f>>2]|0,c[c[f+4>>2]>>2]|0,c[c[f+8>>2]>>2]|0,c[f+12>>2]|0,b[c[f+16>>2]>>1]|0,c[c[f+20>>2]>>2]|0,a[c[f+24>>2]>>0]|0,c[f+28>>2]|0)|0;f=pL(2540224,h)|0;i=g;return f|0}function dSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=cn[c[b+4>>2]&15](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,c[c[e+20>>2]>>2]|0,a[c[e+24>>2]>>0]|0,c[e+28>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function eSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(cn[c[b+4>>2]&15](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0,c[e+20>>2]|0,a[c[e+24>>2]>>0]|0,c[e+28>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function fSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=cn[c[b+4>>2]&15](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,a[c[e+28>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function gSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=c[d+16>>2]|0;yn[c[a+4>>2]&7](b,c[d>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[f>>2]|0,c[f+4>>2]|0,c[c[d+20>>2]>>2]|0,c[d+24>>2]|0,c[d+28>>2]|0);i=e;return 0}function hSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=cn[c[b+4>>2]&15](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0,c[e+16>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,a[c[e+28>>2]>>0]|0)|0;i=f;return g|0}function iSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=cn[c[b+4>>2]&15](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,a[c[e+16>>2]>>0]|0,c[e+20>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0)|0;i=f;return g|0}function jSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=cn[c[a+4>>2]&15](b,c[d>>2]|0,c[c[d+4>>2]>>2]|0,c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+20>>2]|0,c[d+24>>2]|0,c[d+28>>2]|0)|0;i=e;return f|0}function kSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=lo[c[b+4>>2]&7](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,a[c[e+20>>2]>>0]|0,c[e+24>>2]|0,c[e+28>>2]|0,a[c[e+32>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function lSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=lo[c[b+4>>2]&7](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,c[c[e+20>>2]>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0,a[c[e+32>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function mSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=lo[c[b+4>>2]&7](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0,a[c[e+32>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function nSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(lo[c[b+4>>2]&7](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,a[c[e+20>>2]>>0]|0,c[c[e+24>>2]>>2]|0,c[e+28>>2]|0,c[e+32>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function oSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(lo[c[b+4>>2]&7](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,a[c[e+20>>2]>>0]|0,c[e+24>>2]|0,a[c[e+28>>2]>>0]|0,c[e+32>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function pSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Rm[c[b+4>>2]&3](d,c[e>>2]|0,c[e+4>>2]|0,c[c[e+8>>2]>>2]|0,c[c[e+12>>2]>>2]|0,c[c[e+16>>2]>>2]|0,c[e+20>>2]|0,a[c[e+24>>2]>>0]|0,c[c[e+28>>2]>>2]|0,c[e+32>>2]|0,c[e+36>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function qSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Rm[c[b+4>>2]&3](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[e+8>>2]|0,c[c[e+12>>2]>>2]|0,c[e+16>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0,c[e+32>>2]|0,a[c[e+36>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function rSg(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=i;An[c[d+4>>2]&3](e,c[c[f>>2]>>2]|0,b[c[f+4>>2]>>1]|0,b[c[f+8>>2]>>1]|0,a[c[f+12>>2]>>0]|0,a[c[f+16>>2]>>0]|0,a[c[f+20>>2]>>0]|0,a[c[f+24>>2]>>0]|0,a[c[f+28>>2]>>0]|0,a[c[f+32>>2]>>0]|0,a[c[f+36>>2]>>0]|0,a[c[f+40>>2]>>0]|0);i=g;return 0}function sSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Eo[c[b+4>>2]&3](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,c[c[e+20>>2]>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0,a[c[e+32>>2]>>0]|0,a[c[e+36>>2]>>0]|0,c[e+40>>2]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function tSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=Eo[c[b+4>>2]&3](d,c[e>>2]|0,c[c[e+4>>2]>>2]|0,c[c[e+8>>2]>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,c[e+28>>2]|0,c[e+32>>2]|0,c[e+36>>2]|0,a[c[e+40>>2]>>0]|0)|0;e=pL(2540224,g)|0;i=f;return e|0}function uSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;a[g>>0]=(Eo[c[b+4>>2]&3](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,a[c[e+12>>2]>>0]|0,c[e+16>>2]|0,c[e+20>>2]|0,c[e+24>>2]|0,c[c[e+28>>2]>>2]|0,a[c[e+32>>2]>>0]|0,c[e+36>>2]|0,c[e+40>>2]|0)|0)&1;e=pL(2601984,g)|0;i=f;return e|0}function vSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Rn[c[a+4>>2]&3](b,c[c[d>>2]>>2]|0,c[d+4>>2]|0,c[d+8>>2]|0,c[c[d+12>>2]>>2]|0,c[c[d+16>>2]>>2]|0,c[c[d+20>>2]>>2]|0,c[c[d+24>>2]>>2]|0,c[c[d+28>>2]>>2]|0,c[c[d+32>>2]>>2]|0,c[c[d+36>>2]>>2]|0,c[c[d+40>>2]>>2]|0,c[c[d+44>>2]>>2]|0);i=e;return 0}function wSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=Im,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+80|0;h=f+56|0;j=f+32|0;k=f+40|0;l=f+64|0;m=f+16|0;n=f;o=f+8|0;p=c[b+4>>2]|0;b=c[e>>2]|0;q=c[e+4>>2]|0;r=c[e+8>>2]|0;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];r=c[c[e+12>>2]>>2]|0;s=ea(g[c[e+16>>2]>>2]);t=c[c[e+20>>2]>>2]|0;u=a[c[e+24>>2]>>0]|0;v=a[c[e+28>>2]>>0]|0;w=c[c[e+32>>2]>>2]|0;x=c[c[e+36>>2]>>2]|0;y=c[c[e+40>>2]>>2]|0;z=c[c[e+44>>2]>>2]|0;A=a[c[e+48>>2]>>0]|0;B=c[c[e+52>>2]>>2]|0;C=c[e+56>>2]|0;D=c[C+4>>2]|0;E=n;c[E>>2]=c[C>>2];c[E+4>>2]=D;D=c[e+60>>2]|0;E=c[D+4>>2]|0;C=o;c[C>>2]=c[D>>2];c[C+4>>2]=E;E=a[c[e+64>>2]>>0]|0;c[k+0>>2]=c[m+0>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[j+0>>2]=c[n+0>>2];c[j+4>>2]=c[n+4>>2];c[h+0>>2]=c[o+0>>2];c[h+4>>2]=c[o+4>>2];a[l>>0]=(Mo[p&1](d,b,q,k,r,s,t,u,v,w,x,y,z,A,B,j,h,E)|0)&1;E=pL(2601984,l)|0;i=f;return E|0}function xSg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=Im,z=Im,A=Im,B=Im,C=0;f=i;i=i+48|0;h=f+16|0;j=f+32|0;k=f;l=c[b+4>>2]|0;b=c[e>>2]|0;m=c[e+4>>2]|0;n=c[e+8>>2]|0;c[k+0>>2]=c[n+0>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];n=c[c[e+12>>2]>>2]|0;o=ea(g[c[e+16>>2]>>2]);p=c[c[e+20>>2]>>2]|0;q=a[c[e+24>>2]>>0]|0;r=a[c[e+28>>2]>>0]|0;s=c[c[e+32>>2]>>2]|0;t=c[c[e+36>>2]>>2]|0;u=c[c[e+40>>2]>>2]|0;v=c[c[e+44>>2]>>2]|0;w=a[c[e+48>>2]>>0]|0;x=c[c[e+52>>2]>>2]|0;y=ea(g[c[e+56>>2]>>2]);z=ea(g[c[e+60>>2]>>2]);A=ea(g[c[e+64>>2]>>2]);B=ea(g[c[e+68>>2]>>2]);C=a[c[e+72>>2]>>0]|0;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[h+8>>2]=c[k+8>>2];c[h+12>>2]=c[k+12>>2];a[j>>0]=(vn[l&3](d,b,m,h,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C)|0)&1;C=pL(2601984,j)|0;i=f;return C|0}function ySg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=Im,k=Im,l=Im,m=Im,n=Im;f=i;i=i+16|0;h=f;j=ea(g[c[e+20>>2]>>2]);k=ea(g[c[e+60>>2]>>2]);l=ea(g[c[e+64>>2]>>2]);m=ea(g[c[e+68>>2]>>2]);n=ea(g[c[e+72>>2]>>2]);a[h>>0]=(Pn[c[b+4>>2]&1](d,c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,c[e+12>>2]|0,c[c[e+16>>2]>>2]|0,j,c[c[e+24>>2]>>2]|0,a[c[e+28>>2]>>0]|0,a[c[e+32>>2]>>0]|0,c[c[e+36>>2]>>2]|0,c[c[e+40>>2]>>2]|0,c[c[e+44>>2]>>2]|0,c[c[e+48>>2]>>2]|0,a[c[e+52>>2]>>0]|0,c[c[e+56>>2]>>2]|0,k,l,m,n,a[c[e+76>>2]>>0]|0)|0)&1;e=pL(2601984,h)|0;i=f;return e|0}function zSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function ASg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function BSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Lfh();if((sDf(a)|0)>=2){f=tof(0,c[885928]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=PCf(a)|0;if((g|0)<=0){h=0;i=d;return h|0}f=a+16|0;j=(b|0)==0;k=0;while(1){l=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,f+(da(l,k)|0)|0,l|0)|0;l=c[e>>2]|0;if(j){m=l;n=5;break}k=k+1|0;if(nrh(2536048,b,l)|0){h=1;n=9;break}if((k|0)>=(g|0)){h=0;n=9;break}}if((n|0)==5){h=(m|0)==0;i=d;return h|0}else if((n|0)==9){i=d;return h|0}return 0}function CSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function DSg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function ESg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){f=tof(0,c[886014]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=PCf(a)|0;a:do if((g|0)>0){f=a+16|0;h=(b|0)==0;j=0;while(1){k=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,f+(da(k,j)|0)|0,k|0)|0;k=c[e>>2]|0;if(h){l=k;m=j;break}if(nrh(2536048,k,b)|0){n=j;o=9;break}j=j+1|0;if((j|0)>=(g|0))break a}if((o|0)==9){p=(xDf(a,0)|0)+n|0;i=d;return p|0}j=xDf(a,0)|0;if(!l){p=j+m|0;i=d;return p|0}else{p=j+-1|0;i=d;return p|0}}while(0);p=(xDf(a,0)|0)+-1|0;i=d;return p|0}function FSg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function GSg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+16|0;f=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,f|0,h|0)|0;i=e;return}else{Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function HSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d;g=e;c[g>>2]=0;c[g+4>>2]=0;In[c[(c[b+4>>2]|0)+4>>2]&4095](e,a);a=e;e=c[a+4>>2]|0;g=f;c[g>>2]=c[a>>2];c[g+4>>2]=e;e=pL(c[b>>2]|0,f)|0;i=d;return e|0}function ISg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[g>>2]=c[d>>2];c[f+0>>2]=c[g+0>>2];g=bif(b,npf(0,f)|0)|0;f=sxh(g,c[d+4>>2]|0)|0;i=e;return f|0}function JSg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[g>>2]=c[d>>2];c[f+0>>2]=c[g+0>>2];g=aif(b,npf(0,f)|0)|0;f=sxh(g,c[d+4>>2]|0)|0;i=e;return f|0}function KSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function LSg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function MSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2347552)|0;o=(pL(2347552,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2347552)|0;p=pL(2347552,j)|0;RI(2347552)|0;o=b+1|0;if(nrh(2536048,pL(2347552,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2347552)|0;m=(pL(2347552,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function NSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function OSg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function PSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2347552)|0;if(!(pL(2347552,f)|0)){n=l;break}c[h>>2]=b;RI(2347552)|0;m=pL(2347552,h)|0;RI(2347552)|0;if(nrh(2536048,pL(2347552,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2347552)|0;l=(pL(2347552,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function QSg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function RSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2347552)|0;d=pL(2347552,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function SSg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Xwe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1279200)|0;d=pL(1279200,e)|0;i=b;return d|0}function TSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function USg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function VSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2348024)|0;o=(pL(2348024,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2348024)|0;p=pL(2348024,j)|0;RI(2348024)|0;o=b+1|0;if(nrh(2536048,pL(2348024,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2348024)|0;m=(pL(2348024,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function WSg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function XSg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function YSg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2348024)|0;if(!(pL(2348024,f)|0)){n=l;break}c[h>>2]=b;RI(2348024)|0;m=pL(2348024,h)|0;RI(2348024)|0;if(nrh(2536048,pL(2348024,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2348024)|0;l=(pL(2348024,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function ZSg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function _Sg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2348024)|0;d=pL(2348024,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function $Sg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;axe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1294512)|0;d=pL(1294512,e)|0;i=b;return d|0}function aTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function bTg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function cTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2349448)|0;o=(pL(2349448,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2349448)|0;p=pL(2349448,j)|0;RI(2349448)|0;o=b+1|0;if(nrh(2536048,pL(2349448,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2349448)|0;m=(pL(2349448,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function dTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function eTg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function fTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2349448)|0;if(!(pL(2349448,f)|0)){n=l;break}c[h>>2]=b;RI(2349448)|0;m=pL(2349448,h)|0;RI(2349448)|0;if(nrh(2536048,pL(2349448,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2349448)|0;l=(pL(2349448,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function gTg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function hTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2349448)|0;d=pL(2349448,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function iTg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;fxe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1313272)|0;d=pL(1313272,e)|0;i=b;return d|0}function jTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function kTg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function lTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(1342344)|0;if(!(pL(1342344,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(1342344)|0;p=pL(1342344,h)|0;RI(1342344)|0;m=m+1|0;if(nrh(2536048,pL(1342344,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(1342344)|0;l=(pL(1342344,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function mTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function nTg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function oTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(1342344)|0;if(!(pL(1342344,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(1342344)|0;o=pL(1342344,h)|0;RI(1342344)|0;if(nrh(2536048,pL(1342344,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(1342344)|0;n=(pL(1342344,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function pTg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function qTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(1342344)|0;d=pL(1342344,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function rTg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;aye(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1343096)|0;d=pL(1343096,e)|0;i=b;return d|0}function sTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function tTg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function uTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2540224)|0;o=(pL(2540224,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2540224)|0;p=pL(2540224,j)|0;RI(2540224)|0;o=b+1|0;if(nrh(2536048,pL(2540224,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2540224)|0;m=(pL(2540224,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function vTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function wTg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function xTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2540224)|0;if(!(pL(2540224,f)|0)){n=l;break}c[h>>2]=b;RI(2540224)|0;m=pL(2540224,h)|0;RI(2540224)|0;if(nrh(2536048,pL(2540224,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2540224)|0;l=(pL(2540224,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function yTg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function zTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2540224)|0;d=pL(2540224,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function ATg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;fye(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1345200)|0;d=pL(1345200,e)|0;i=b;return d|0}function BTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function CTg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function DTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2703200)|0;if(!(pL(2703200,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2703200)|0;p=pL(2703200,h)|0;RI(2703200)|0;m=m+1|0;if(nrh(2536048,pL(2703200,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2703200)|0;l=(pL(2703200,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function ETg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function FTg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function GTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2703200)|0;if(!(pL(2703200,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2703200)|0;o=pL(2703200,h)|0;RI(2703200)|0;if(nrh(2536048,pL(2703200,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2703200)|0;n=(pL(2703200,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function HTg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function ITg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2703200)|0;d=pL(2703200,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function JTg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;kye(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1353416)|0;d=pL(1353416,e)|0;i=b;return d|0}function KTg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[j>>2]=3433104;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=sxh(d,1086352)|0;LTg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=sxh(d,1086352)|0;LTg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function LTg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=a+24|0;h=c[g>>2]|0;if((h|0)<=0){i=f;return}j=a+12|0;k=a+16|0;l=a+20|0;a=b+16|0;m=d;d=h;h=0;while(1){n=c[j>>2]|0;if((c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0)<0){n=c[k>>2]|0;o=c[l>>2]|0;p=c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0;n=txh(1361448,e,p,c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0;RI(2536312)|0;o=sxh(n,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]=o;q=m+1|0;r=c[g>>2]|0}else{q=m;r=d}h=h+1|0;if((h|0)>=(r|0))break;else{m=q;d=r}}i=f;return}function MTg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=a+24|0;h=c[g>>2]|0;if((h|0)<=0){i=f;return}j=a+12|0;k=a+16|0;l=a+20|0;a=b+16|0;m=d;d=h;h=0;while(1){n=c[j>>2]|0;if((c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0)<0){n=c[k>>2]|0;o=c[l>>2]|0;p=c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0;n=txh(1361448,e,p,c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0;RI(2368616)|0;o=sxh(n,2368616)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]=o;q=m+1|0;r=c[g>>2]|0}else{q=m;r=d}h=h+1|0;if((h|0)>=(r|0))break;else{m=q;d=r}}i=f;return}function NTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function OTg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function PTg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2729368)|0;if(!(pL(2729368,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2729368)|0;p=pL(2729368,h)|0;RI(2729368)|0;m=m+1|0;if(nrh(2536048,pL(2729368,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2729368)|0;l=(pL(2729368,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function QTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function RTg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function STg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2729368)|0;if(!(pL(2729368,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2729368)|0;o=pL(2729368,h)|0;RI(2729368)|0;if(nrh(2536048,pL(2729368,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2729368)|0;n=(pL(2729368,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function TTg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function UTg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2729368)|0;d=pL(2729368,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function VTg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Xye(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1362544)|0;d=pL(1362544,e)|0;i=b;return d|0}function WTg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;uxh(g,1361936,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2729368)|0;r=pL(2729368,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(2729368)|0;q=vxh(r,2729368)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function XTg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[j>>2]=3453528;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=sxh(d,1086352)|0;YTg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=sxh(d,1086352)|0;YTg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function YTg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;wxh(g,1758392,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1342344)|0;r=pL(1342344,h)|0;RI(2536312)|0;p=sxh(r,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]=p;s=o+1|0;t=c[j>>2]|0}else{s=o;t=d}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;d=t}}i=f;return}function ZTg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;wxh(g,1758392,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1342344)|0;r=pL(1342344,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(1342344)|0;q=vxh(r,1342344)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function _Tg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;f=c[b>>2]|0;if(!f)g=0;else g=c[f+12>>2]|0;Dn[c[(c[e>>2]|0)+4>>2]&511](0,b,g,d);i=a;return}function $Tg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;if((e|0)<=-1){RI(2964880)|0;g=qL(2964880)|0;_eg(g);qxh(g)}g=c[b>>2]|0;if(!g){c[b>>2]=xxh(c[f>>2]|0,e)|0;i=a;return}if((c[g+12>>2]|0)==(e|0)){i=a;return}g=xxh(c[f>>2]|0,e)|0;f=Bsg(0,e,d)|0;vEf(0,c[b>>2]|0,g,f);c[b>>2]=g;i=a;return}function aUg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;b=i;Jgh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[887008]|0);qxh(j)}if(((g|0)>=0?(xDf(d,0)|0)<=(f|0):0)?(f+-1|0)<=((WDf(d,0)|0)-g|0):0){j=g+f|0;RI(1777920)|0;if(!(a[1778068]|0)){RI(1777920)|0;rxh(1777920)}k=mo[c[(c[h>>2]|0)+4>>2]&4095](0)|0;if((g|0)<=0){l=-1;i=b;return l|0}g=h+4|0;h=d+16|0;m=f;while(1){if(Frh(c[g>>2]|0,k,c[h+(da(c[(c[d>>2]|0)+120>>2]|0,m)|0)>>2]|0,e)|0){l=m;n=13;break}m=m+1|0;if((m|0)>=(j|0)){l=-1;n=13;break}}if((n|0)==13){i=b;return l|0}}RI(2964880)|0;l=qL(2964880)|0;_eg(l);qxh(l);return 0}function bUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function cUg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function dUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2375496)|0;o=(pL(2375496,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2375496)|0;p=pL(2375496,j)|0;RI(2375496)|0;o=b+1|0;if(nrh(2536048,pL(2375496,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2375496)|0;m=(pL(2375496,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function eUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function fUg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function gUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2375496)|0;if(!(pL(2375496,f)|0)){n=l;break}c[h>>2]=b;RI(2375496)|0;m=pL(2375496,h)|0;RI(2375496)|0;if(nrh(2536048,pL(2375496,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2375496)|0;l=(pL(2375496,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function hUg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function iUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2375496)|0;d=pL(2375496,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function jUg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;lHe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1792832)|0;d=pL(1792832,e)|0;i=b;return d|0}function kUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function lUg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function mUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(1810464)|0;if(!(pL(1810464,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(1810464)|0;p=pL(1810464,h)|0;RI(1810464)|0;m=m+1|0;if(nrh(2536048,pL(1810464,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(1810464)|0;l=(pL(1810464,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function nUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function oUg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function pUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(1810464)|0;if(!(pL(1810464,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(1810464)|0;o=pL(1810464,h)|0;RI(1810464)|0;if(nrh(2536048,pL(1810464,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(1810464)|0;n=(pL(1810464,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function qUg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function rUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(1810464)|0;d=pL(1810464,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function sUg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;_He(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1811216)|0;d=pL(1811216,e)|0;i=b;return d|0}function tUg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[k>>2]=c[g>>2];c[j+0>>2]=c[k+0>>2];k=npf(0,j)|0;j=suh(2619720,Xnf(d)|0)|0;if(!(!(Gqh(2653672,k)|0)?!(Gqh(2653672,j)|0):0))l=5;if((l|0)==5?!(Yuh(2651232,j,k)|0):0){RI(2589312)|0;k=qL(2589312)|0;FHf(k);FJ(k)}k=c[(c[g+4>>2]|0)+4>>2]|0;RI(1086352)|0;g=sxh(d,1086352)|0;Dn[k&511](b,g,e,f);i=h;return}function uUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=a+24|0;h=c[g>>2]|0;if((h|0)<=0){i=f;return}j=a+12|0;k=a+16|0;l=a+20|0;a=b+16|0;m=d;d=h;h=0;while(1){n=c[j>>2]|0;if((c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0)<0){n=c[k>>2]|0;o=c[l>>2]|0;p=c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0;n=yxh(1816328,e,p,c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0;RI(2536312)|0;o=sxh(n,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]=o;q=m+1|0;r=c[g>>2]|0}else{q=m;r=d}h=h+1|0;if((h|0)>=(r|0))break;else{m=q;d=r}}i=f;return}function vUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;zxh(g,1816984,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2729368)|0;r=pL(2729368,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(2729368)|0;q=vxh(r,2729368)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function wUg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[j>>2]=3453856;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=sxh(d,1086352)|0;xUg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=sxh(d,1086352)|0;xUg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function xUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Axh(g,1817640,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1810464)|0;r=pL(1810464,h)|0;RI(2536312)|0;p=sxh(r,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]=p;s=o+1|0;t=c[j>>2]|0}else{s=o;t=d}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;d=t}}i=f;return}function yUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Axh(g,1817640,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1810464)|0;r=pL(1810464,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(1810464)|0;q=vxh(r,1810464)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function zUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function AUg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function BUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(1820016)|0;if(!(pL(1820016,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(1820016)|0;p=pL(1820016,h)|0;RI(1820016)|0;m=m+1|0;if(nrh(2536048,pL(1820016,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(1820016)|0;l=(pL(1820016,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function CUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function DUg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function EUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(1820016)|0;if(!(pL(1820016,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(1820016)|0;o=pL(1820016,h)|0;RI(1820016)|0;if(nrh(2536048,pL(1820016,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(1820016)|0;n=(pL(1820016,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function FUg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function GUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(1820016)|0;d=pL(1820016,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function HUg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;IIe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1820768)|0;d=pL(1820768,e)|0;i=b;return d|0}function IUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=a+24|0;h=c[g>>2]|0;if((h|0)<=0){i=f;return}j=a+12|0;k=a+16|0;l=a+20|0;a=b+16|0;m=d;d=h;h=0;while(1){n=c[j>>2]|0;if((c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0)<0){n=c[k>>2]|0;o=c[l>>2]|0;p=c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0;n=Bxh(1826248,e,p,c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0;RI(2536312)|0;o=sxh(n,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]=o;q=m+1|0;r=c[g>>2]|0}else{q=m;r=d}h=h+1|0;if((h|0)>=(r|0))break;else{m=q;d=r}}i=f;return}function JUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=a+24|0;h=c[g>>2]|0;if((h|0)<=0){i=f;return}j=a+12|0;k=a+16|0;l=a+20|0;a=b+16|0;m=d;d=h;h=0;while(1){n=c[j>>2]|0;if((c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0)<0){n=c[k>>2]|0;o=c[l>>2]|0;p=c[n+16+(da(c[(c[n>>2]|0)+120>>2]|0,h)|0)>>2]|0;n=Bxh(1826248,e,p,c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,h)|0)>>2]|0)|0;RI(2369632)|0;o=sxh(n,2369632)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,m)|0)>>2]=o;q=m+1|0;r=c[g>>2]|0}else{q=m;r=d}h=h+1|0;if((h|0)>=(r|0))break;else{m=q;d=r}}i=f;return}function KUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Cxh(g,1826904,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2729368)|0;r=pL(2729368,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(2729368)|0;q=vxh(r,2729368)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function LUg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[j>>2]=3453896;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=sxh(d,1086352)|0;MUg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=sxh(d,1086352)|0;MUg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function MUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Dxh(g,1827560,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1820016)|0;r=pL(1820016,h)|0;RI(2536312)|0;p=sxh(r,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]=p;s=o+1|0;t=c[j>>2]|0}else{s=o;t=d}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;d=t}}i=f;return}function NUg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Dxh(g,1827560,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1820016)|0;r=pL(1820016,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(1820016)|0;q=vxh(r,1820016)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function OUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function PUg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function QUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2390624)|0;o=(pL(2390624,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2390624)|0;p=pL(2390624,j)|0;RI(2390624)|0;o=b+1|0;if(nrh(2536048,pL(2390624,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2390624)|0;m=(pL(2390624,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function RUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function SUg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function TUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2390624)|0;if(!(pL(2390624,f)|0)){n=l;break}c[h>>2]=b;RI(2390624)|0;m=pL(2390624,h)|0;RI(2390624)|0;if(nrh(2536048,pL(2390624,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2390624)|0;l=(pL(2390624,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function UUg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function VUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2390624)|0;d=pL(2390624,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function WUg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;XIe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1835584)|0;d=pL(1835584,e)|0;i=b;return d|0}function XUg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function YUg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function ZUg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(1844464)|0;if(!(pL(1844464,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(1844464)|0;p=pL(1844464,h)|0;RI(1844464)|0;m=m+1|0;if(nrh(2536048,pL(1844464,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(1844464)|0;l=(pL(1844464,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function _Ug(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function $Ug(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function aVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(1844464)|0;if(!(pL(1844464,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(1844464)|0;o=pL(1844464,h)|0;RI(1844464)|0;if(nrh(2536048,pL(1844464,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(1844464)|0;n=(pL(1844464,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function bVg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function cVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(1844464)|0;d=pL(1844464,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function dVg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;UJe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1845216)|0;d=pL(1845216,e)|0;i=b;return d|0}function eVg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[j>>2]=3431160;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=sxh(d,1086352)|0;fVg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=sxh(d,1086352)|0;fVg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function fVg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;h=a+24|0;j=c[h>>2]|0;if((j|0)<=0){i=f;return}k=a+12|0;l=a+16|0;m=a+20|0;a=b+16|0;n=d;d=j;j=0;while(1){o=c[k>>2]|0;if((c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){o=c[l>>2]|0;p=c[m>>2]|0;q=c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0;c[g>>2]=Exh(1849992,e,q,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0;RI(2540224)|0;p=pL(2540224,g)|0;RI(2536312)|0;q=sxh(p,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,n)|0)>>2]=q;r=n+1|0;s=c[h>>2]|0}else{r=n;s=d}j=j+1|0;if((j|0)>=(s|0))break;else{n=r;d=s}}i=f;return}function gVg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;h=a+24|0;j=c[h>>2]|0;if((j|0)<=0){i=f;return}k=a+12|0;l=a+16|0;m=a+20|0;a=b+16|0;n=d;d=j;j=0;while(1){o=c[k>>2]|0;if((c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){o=c[l>>2]|0;p=c[m>>2]|0;q=c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0;c[g>>2]=Exh(1849992,e,q,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0;RI(2540224)|0;p=pL(2540224,g)|0;RI(2540224)|0;q=c[(vxh(p,2540224)|0)>>2]|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,n)|0)>>2]=q;r=n+1|0;s=c[h>>2]|0}else{r=n;s=d}j=j+1|0;if((j|0)>=(s|0))break;else{n=r;d=s}}i=f;return}function hVg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Fxh(g,1850480,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2729368)|0;r=pL(2729368,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(2729368)|0;q=vxh(r,2729368)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function iVg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;rxh(2540728)}c[j>>2]=3453952;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=sxh(d,1086352)|0;jVg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=sxh(d,1086352)|0;jVg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function jVg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Gxh(g,1850968,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1844464)|0;r=pL(1844464,h)|0;RI(2536312)|0;p=sxh(r,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]=p;s=o+1|0;t=c[j>>2]|0}else{s=o;t=d}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;d=t}}i=f;return}function kVg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Gxh(g,1850968,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(1844464)|0;r=pL(1844464,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(1844464)|0;q=vxh(r,1844464)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function lVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function mVg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function nVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2395232)|0;o=(pL(2395232,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2395232)|0;p=pL(2395232,j)|0;RI(2395232)|0;o=b+1|0;if(nrh(2536048,pL(2395232,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2395232)|0;m=(pL(2395232,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function oVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function pVg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function qVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2395232)|0;if(!(pL(2395232,f)|0)){n=l;break}c[h>>2]=b;RI(2395232)|0;m=pL(2395232,h)|0;RI(2395232)|0;if(nrh(2536048,pL(2395232,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2395232)|0;l=(pL(2395232,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function rVg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function sVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2395232)|0;d=pL(2395232,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function tVg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;NKe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1852176)|0;d=pL(1852176,e)|0;i=b;return d|0}function uVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function vVg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function wVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2379888)|0;o=(pL(2379888,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2379888)|0;p=pL(2379888,j)|0;RI(2379888)|0;o=b+1|0;if(nrh(2536048,pL(2379888,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2379888)|0;m=(pL(2379888,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function xVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function yVg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function zVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2379888)|0;if(!(pL(2379888,f)|0)){n=l;break}c[h>>2]=b;RI(2379888)|0;m=pL(2379888,h)|0;RI(2379888)|0;if(nrh(2536048,pL(2379888,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2379888)|0;l=(pL(2379888,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function AVg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function BVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2379888)|0;d=pL(2379888,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function CVg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;SKe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1854728)|0;d=pL(1854728,e)|0;i=b;return d|0}function DVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function EVg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function FVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2395064)|0;o=(pL(2395064,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2395064)|0;p=pL(2395064,j)|0;RI(2395064)|0;o=b+1|0;if(nrh(2536048,pL(2395064,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2395064)|0;m=(pL(2395064,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function GVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function HVg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function IVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2395064)|0;if(!(pL(2395064,f)|0)){n=l;break}c[h>>2]=b;RI(2395064)|0;m=pL(2395064,h)|0;RI(2395064)|0;if(nrh(2536048,pL(2395064,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2395064)|0;l=(pL(2395064,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function JVg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function KVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2395064)|0;d=pL(2395064,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function LVg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;XKe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1857280)|0;d=pL(1857280,e)|0;i=b;return d|0}function MVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function NVg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function OVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f>>2]=c[b>>2];RI(2604248)|0;if(!(pL(2604248,f)|0)){o=5;break}c[h>>2]=c[e>>2];RI(2604248)|0;n=pL(2604248,h)|0;RI(2604248)|0;m=m+1|0;if(nrh(2536048,pL(2604248,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g>>2]=c[e>>2];RI(2604248)|0;l=(pL(2604248,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function PVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function QVg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function RVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=c[b>>2]|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f>>2]=l;RI(2604248)|0;if(!(pL(2604248,f)|0)){o=m;break}c[h>>2]=l;RI(2604248)|0;n=pL(2604248,h)|0;RI(2604248)|0;if(nrh(2536048,pL(2604248,e)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(k|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=d;return r|0}c[g>>2]=c[e>>2];RI(2604248)|0;m=(pL(2604248,g)|0)==0;l=xDf(a,0)|0;if(m){r=l+o|0;i=d;return r|0}else{r=l+-1|0;i=d;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=d;return r|0}function SVg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function TVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f>>2]=c[d>>2];RI(2604248)|0;d=pL(2604248,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function UVg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;aLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1885352)|0;d=pL(1885352,e)|0;i=b;return d|0}function VVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function WVg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function XVg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2455736)|0;o=(pL(2455736,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2455736)|0;p=pL(2455736,j)|0;RI(2455736)|0;o=b+1|0;if(nrh(2536048,pL(2455736,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2455736)|0;m=(pL(2455736,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function YVg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function ZVg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function _Vg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2455736)|0;if(!(pL(2455736,f)|0)){n=l;break}c[h>>2]=b;RI(2455736)|0;m=pL(2455736,h)|0;RI(2455736)|0;if(nrh(2536048,pL(2455736,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2455736)|0;l=(pL(2455736,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function $Vg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function aWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2455736)|0;d=pL(2455736,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function bWg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;fLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1893072)|0;d=pL(1893072,e)|0;i=b;return d|0}function cWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=Im;d=i;i=i+16|0;e=d;g[e>>2]=ea(0.0);Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;h=ea(g[e>>2]);i=d;return ea(h)}else{RI(2964880)|0;d=qL(2964880)|0;wdg(d,c[886018]|0);qxh(d)}return ea(0.0)}function dWg(a,b){a=a|0;b=ea(b);Jfh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[885920]|0);qxh(a)}function eWg(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=Im,s=0,t=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;h=d+8|0;j=d+4|0;k=d;g[e>>2]=b;g[f>>2]=ea(0.0);Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);qxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=d;return n|0}l=a+16|0;o=b;p=0;while(1){q=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,l+(da(q,p)|0)|0,q|0)|0;g[h>>2]=o;RI(2586184)|0;q=(pL(2586184,h)|0)==0;b=ea(g[f>>2]);if(q){r=b;s=5;break}g[k>>2]=b;RI(2586184)|0;q=pL(2586184,k)|0;RI(2586184)|0;t=p+1|0;if(nrh(2536048,pL(2586184,e)|0,q)|0){n=1;s=10;break}if((t|0)>=(m|0)){n=0;s=10;break}o=ea(g[e>>2]);p=t}if((s|0)==5){g[j>>2]=r;RI(2586184)|0;n=(pL(2586184,j)|0)==0;i=d;return n|0}else if((s|0)==10){i=d;return n|0}return 0}function fWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function gWg(a,b){a=a|0;b=ea(b);Kfh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[885924]|0);qxh(a);return 0}function hWg(a,b){a=a|0;b=ea(b);var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d+4|0;j=d;g[e>>2]=ea(0.0);Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,k+(da(n,m)|0)|0,n|0)|0;g[f>>2]=b;RI(2586184)|0;if(!(pL(2586184,f)|0)){o=m;break}g[j>>2]=b;RI(2586184)|0;n=pL(2586184,j)|0;RI(2586184)|0;if(nrh(2536048,pL(2586184,e)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=d;return r|0}g[h>>2]=ea(g[e>>2]);RI(2586184)|0;m=(pL(2586184,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=d;return r|0}else{r=k+-1|0;i=d;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=d;return r|0}function iWg(a,b,d){a=a|0;b=b|0;d=ea(d);Nfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[886006]|0);qxh(b)}function jWg(a,b,d){a=a|0;b=b|0;d=ea(d);var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;h=e;g[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);qxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,b)|0)|0,f|0,k|0)|0;i=e;return}else{g[h>>2]=d;RI(2586184)|0;k=pL(2586184,h)|0;Qqh(j,k);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,b)|0)>>2]=k;i=e;return}}function kWg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;kLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1900728)|0;d=pL(1900728,e)|0;i=b;return d|0}function lWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function mWg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function nWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2466336)|0;o=(pL(2466336,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2466336)|0;p=pL(2466336,j)|0;RI(2466336)|0;o=b+1|0;if(nrh(2536048,pL(2466336,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2466336)|0;m=(pL(2466336,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function oWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function pWg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function qWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2466336)|0;if(!(pL(2466336,f)|0)){n=l;break}c[h>>2]=b;RI(2466336)|0;m=pL(2466336,h)|0;RI(2466336)|0;if(nrh(2536048,pL(2466336,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2466336)|0;l=(pL(2466336,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function rWg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function sWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2466336)|0;d=pL(2466336,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function tWg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;pLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1908944)|0;d=pL(1908944,e)|0;i=b;return d|0}function uWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function vWg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function wWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+16|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];RI(2469616)|0;if(!(pL(2469616,f)|0)){o=5;break};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];RI(2469616)|0;n=pL(2469616,h)|0;RI(2469616)|0;m=m+1|0;if(nrh(2536048,pL(2469616,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];RI(2469616)|0;l=(pL(2469616,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function xWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function yWg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function zWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+64|0;e=d+48|0;f=d+32|0;g=d+16|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];RI(2469616)|0;if(!(pL(2469616,f)|0)){n=l;break};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];RI(2469616)|0;m=pL(2469616,h)|0;RI(2469616)|0;if(nrh(2536048,pL(2469616,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0};c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];RI(2469616)|0;l=(pL(2469616,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function AWg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function BWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];RI(2469616)|0;d=pL(2469616,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function CWg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;uLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1911496)|0;d=pL(1911496,e)|0;i=b;return d|0}function DWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function EWg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function FWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2492064)|0;o=(pL(2492064,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2492064)|0;p=pL(2492064,j)|0;RI(2492064)|0;o=b+1|0;if(nrh(2536048,pL(2492064,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2492064)|0;m=(pL(2492064,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function GWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function HWg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function IWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2492064)|0;if(!(pL(2492064,f)|0)){n=l;break}c[h>>2]=b;RI(2492064)|0;m=pL(2492064,h)|0;RI(2492064)|0;if(nrh(2536048,pL(2492064,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2492064)|0;l=(pL(2492064,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function JWg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function KWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2492064)|0;d=pL(2492064,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function LWg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;zLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1919152)|0;d=pL(1919152,e)|0;i=b;return d|0}function MWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function NWg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function OWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2492856)|0;o=(pL(2492856,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2492856)|0;p=pL(2492856,j)|0;RI(2492856)|0;o=b+1|0;if(nrh(2536048,pL(2492856,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2492856)|0;m=(pL(2492856,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function PWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function QWg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function RWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2492856)|0;if(!(pL(2492856,f)|0)){n=l;break}c[h>>2]=b;RI(2492856)|0;m=pL(2492856,h)|0;RI(2492856)|0;if(nrh(2536048,pL(2492856,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2492856)|0;l=(pL(2492856,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function SWg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function TWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2492856)|0;d=pL(2492856,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function UWg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;ELe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1921704)|0;d=pL(1921704,e)|0;i=b;return d|0}function VWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}return 0}function WWg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function XWg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);qxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2493312)|0;o=(pL(2493312,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2493312)|0;p=pL(2493312,j)|0;RI(2493312)|0;o=b+1|0;if(nrh(2536048,pL(2493312,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2493312)|0;m=(pL(2493312,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function YWg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function ZWg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function _Wg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2493312)|0;if(!(pL(2493312,f)|0)){n=l;break}c[h>>2]=b;RI(2493312)|0;m=pL(2493312,h)|0;RI(2493312)|0;if(nrh(2536048,pL(2493312,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2493312)|0;l=(pL(2493312,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function $Wg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function aXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);qxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2493312)|0;d=pL(2493312,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function bXg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;JLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1924256)|0;d=pL(1924256,e)|0;i=b;return d|0}function cXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=a+0|0;g=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function dXg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function eXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;e=d+60|0;f=d;g=e+0|0;h=g+60|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;g=f+0|0;o=b+0|0;h=g+60|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(h|0));RI(2504408)|0;if(!(pL(2504408,f)|0)){p=5;break}g=f+0|0;o=e+0|0;h=g+60|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(h|0));RI(2504408)|0;n=pL(2504408,f)|0;RI(2504408)|0;m=m+1|0;if(nrh(2536048,pL(2504408,b)|0,n)|0){l=1;p=9;break}if((m|0)>=(k|0)){l=0;p=9;break}}if((p|0)==5){g=f+0|0;o=e+0|0;h=g+60|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(h|0));RI(2504408)|0;l=(pL(2504408,f)|0)==0;i=d;return l|0}else if((p|0)==9){i=d;return l|0}return 0}function fXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function gXg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function hXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+128|0;e=d+60|0;f=d;g=e+0|0;h=g+60|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;g=f+0|0;n=b+0|0;h=g+60|0;do{c[g>>2]=c[n>>2];g=g+4|0;n=n+4|0}while((g|0)<(h|0));RI(2504408)|0;if(!(pL(2504408,f)|0)){o=l;break}g=f+0|0;n=b+0|0;h=g+60|0;do{c[g>>2]=c[n>>2];g=g+4|0;n=n+4|0}while((g|0)<(h|0));RI(2504408)|0;m=pL(2504408,f)|0;RI(2504408)|0;if(nrh(2536048,pL(2504408,e)|0,m)|0){p=l;q=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=d;return r|0}g=f+0|0;n=e+0|0;h=g+60|0;do{c[g>>2]=c[n>>2];g=g+4|0;n=n+4|0}while((g|0)<(h|0));RI(2504408)|0;l=(pL(2504408,f)|0)==0;j=xDf(a,0)|0;if(l){r=j+o|0;i=d;return r|0}else{r=j+-1|0;i=d;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=d;return r|0}function iXg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function jXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+64|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=f+0|0;a=d+0|0;d=h+60|0;do{c[h>>2]=c[a>>2];h=h+4|0;a=a+4|0}while((h|0)<(d|0));RI(2504408)|0;a=pL(2504408,f)|0;Qqh(g,a);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=a;i=e;return}}function kXg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;PLe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1932248)|0;d=pL(1932248,e)|0;i=b;return d|0}function lXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;e=c[b>>2]|0;if(!e)f=0;else f=c[e+12>>2]|0;mXg(0,b,f,d);i=a;return}function mXg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;if((e|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;_eg(f);qxh(f)}f=c[b>>2]|0;if(!f){RI(1127304)|0;c[b>>2]=xxh(1127304,e)|0;i=a;return}if((c[f+12>>2]|0)==(e|0)){i=a;return}RI(1127304)|0;f=xxh(1127304,e)|0;g=Bsg(0,e,d)|0;vEf(0,c[b>>2]|0,f,g);c[b>>2]=f;i=a;return}function nXg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;i=i+256|0;h=b+196|0;j=b+136|0;k=b+128|0;l=b+64|0;m=b;Jgh();if(!d){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[887008]|0);qxh(n)}if((g|0)<0){RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o)}if((xDf(d,0)|0)>(f|0)){RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o)}if((f+-1|0)>((WDf(d,0)|0)-g|0)){RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o)}o=g+f|0;RI(1937008)|0;if(!(a[1937156]|0)){RI(1937008)|0;rxh(1937008)}n=KMe(0)|0;if((g|0)<=0){p=-1;i=b;return p|0}g=d+16|0;q=k+4|0;r=f;while(1){f=g+(da(c[(c[d>>2]|0)+120>>2]|0,r)|0)|0;s=l+0|0;t=e+0|0;u=s+60|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));s=m+0|0;t=f+0|0;u=s+60|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));iM(k,1937232,n);f=c[(c[q>>2]|0)+4>>2]|0;v=c[k>>2]|0;s=j+0|0;t=m+0|0;u=s+60|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));s=h+0|0;t=l+0|0;u=s+60|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));if(xo[f&2047](v,j,h)|0){p=r;w=13;break}r=r+1|0;if((r|0)>=(o|0)){p=-1;w=13;break}}if((w|0)==13){i=b;return p|0}return 0}function oXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function pXg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function qXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];RI(2497248)|0;if(!(pL(2497248,f)|0)){o=5;break};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];RI(2497248)|0;n=pL(2497248,h)|0;RI(2497248)|0;m=m+1|0;if(nrh(2536048,pL(2497248,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];RI(2497248)|0;l=(pL(2497248,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function rXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function sXg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function tXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];RI(2497248)|0;if(!(pL(2497248,f)|0)){n=l;break};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];RI(2497248)|0;m=pL(2497248,h)|0;RI(2497248)|0;if(nrh(2536048,pL(2497248,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0};c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];RI(2497248)|0;l=(pL(2497248,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function uXg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function vXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];RI(2497248)|0;d=pL(2497248,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function wXg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;NMe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1940776)|0;d=pL(1940776,e)|0;i=b;return d|0}function xXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;e=c[b>>2]|0;if(!e)f=0;else f=c[e+12>>2]|0;yXg(0,b,f,d);i=a;return}function yXg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;if((e|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;_eg(f);qxh(f)}f=c[b>>2]|0;if(!f){RI(1127792)|0;c[b>>2]=xxh(1127792,e)|0;i=a;return}if((c[f+12>>2]|0)==(e|0)){i=a;return}RI(1127792)|0;f=xxh(1127792,e)|0;g=Bsg(0,e,d)|0;vEf(0,c[b>>2]|0,f,g);c[b>>2]=f;i=a;return}function zXg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+64|0;h=b+52|0;j=b+40|0;k=b+32|0;l=b+16|0;m=b;Jgh();if(!d){RI(2963920)|0;n=qL(2963920)|0;Iag(n,c[887008]|0);qxh(n)}if((g|0)<0){RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o)}if((xDf(d,0)|0)>(f|0)){RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o)}if((f+-1|0)>((WDf(d,0)|0)-g|0)){RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o)}o=g+f|0;RI(1945536)|0;if(!(a[1945684]|0)){RI(1945536)|0;rxh(1945536)}n=INe(0)|0;if((g|0)<=0){p=-1;i=b;return p|0}g=d+16|0;q=k+4|0;r=f;while(1){f=g+(da(c[(c[d>>2]|0)+120>>2]|0,r)|0)|0;c[l+0>>2]=c[e+0>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];iM(k,1945760,n);f=c[(c[q>>2]|0)+4>>2]|0;s=c[k>>2]|0;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];if(xo[f&2047](s,j,h)|0){p=r;t=13;break}r=r+1|0;if((r|0)>=(o|0)){p=-1;t=13;break}}if((t|0)==13){i=b;return p|0}return 0}function AXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);qxh(e)}}function BXg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);qxh(b)}function CXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2497560)|0;if(!(pL(2497560,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2497560)|0;p=pL(2497560,h)|0;RI(2497560)|0;m=m+1|0;if(nrh(2536048,pL(2497560,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2497560)|0;l=(pL(2497560,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function DXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);qxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);qxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);qxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);qxh(a)}}function EXg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);qxh(b);return 0}function FXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);qxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2497560)|0;if(!(pL(2497560,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2497560)|0;o=pL(2497560,h)|0;RI(2497560)|0;if(nrh(2536048,pL(2497560,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2497560)|0;n=(pL(2497560,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function GXg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);qxh(d)}function HXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);qxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2497560)|0;d=pL(2497560,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function IXg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;LNe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1951752)|0;d=pL(1951752,e)|0;i=b;return d|0}function JXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=i;e=c[b>>2]|0;if(!e)f=0;else f=c[e+12>>2]|0;KXg(0,b,f,d);i=a;return}function KXg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a=i;if((e|0)<=-1){RI(2964880)|0;f=qL(2964880)|0;_eg(f);qxh(f)}f=c[b>>2]|0;if(!f){RI(1128280)|0;c[b>>2]=xxh(1128280,e)|0;i=a;return}if((c[f+12>>2]|0)==(e|0)){i=a;return}RI(1128280)|0;f=xxh(1128280,e)|0;g=Bsg(0,e,d)|0;vEf(0,c[b>>2]|0,f,g);c[b>>2]=f;i=a;return}function LXg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+32|0;h=b+24|0;j=b+16|0;k=b+8|0;l=b;Jgh();if(!d){RI(2963920)|0;m=qL(2963920)|0;Iag(m,c[887008]|0);qxh(m)}if(((g|0)>=0?(xDf(d,0)|0)<=(f|0):0)?(f+-1|0)<=((WDf(d,0)|0)-g|0):0){m=g+f|0;RI(1956512)|0;if(!(a[1956660]|0)){RI(1956512)|0;rxh(1956512)}n=GOe(0)|0;if((g|0)<=0){o=-1;i=b;return o|0}g=d+16|0;p=e;e=c[p>>2]|0;q=c[p+4>>2]|0;p=f;while(1){f=g+(da(c[(c[d>>2]|0)+120>>2]|0,p)|0)|0;r=c[f+4>>2]|0;s=k;c[s>>2]=c[f>>2];c[s+4>>2]=r;r=l;c[r>>2]=e;c[r+4>>2]=q;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];if(Bsh(1956736,n,j,h)|0){o=p;t=13;break}p=p+1|0;if((p|0)>=(m|0)){o=-1;t=13;break}}if((t|0)==13){i=b;return o|0}}RI(2964880)|0;o=qL(2964880)|0;_eg(o);qxh(o);return 0}function MXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function NXg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function OXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f>>2]=c[b>>2];RI(2887096)|0;if(!(pL(2887096,f)|0)){o=5;break}c[h>>2]=c[e>>2];RI(2887096)|0;n=pL(2887096,h)|0;RI(2887096)|0;m=m+1|0;if(nrh(2536048,pL(2887096,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g>>2]=c[e>>2];RI(2887096)|0;l=(pL(2887096,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function PXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function QXg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function RXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=c[b>>2]|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f>>2]=l;RI(2887096)|0;if(!(pL(2887096,f)|0)){o=m;break}c[h>>2]=l;RI(2887096)|0;n=pL(2887096,h)|0;RI(2887096)|0;if(nrh(2536048,pL(2887096,e)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(k|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=d;return r|0}c[g>>2]=c[e>>2];RI(2887096)|0;m=(pL(2887096,g)|0)==0;l=xDf(a,0)|0;if(m){r=l+o|0;i=d;return r|0}else{r=l+-1|0;i=d;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=d;return r|0}function SXg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function TXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f>>2]=c[d>>2];RI(2887096)|0;d=pL(2887096,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function UXg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;UOe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1983392)|0;d=pL(1983392,e)|0;i=b;return d|0}function VXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function WXg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function XXg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2508800)|0;o=(pL(2508800,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2508800)|0;p=pL(2508800,j)|0;RI(2508800)|0;o=b+1|0;if(nrh(2536048,pL(2508800,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2508800)|0;m=(pL(2508800,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function YXg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function ZXg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function _Xg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2508800)|0;if(!(pL(2508800,f)|0)){n=l;break}c[h>>2]=b;RI(2508800)|0;m=pL(2508800,h)|0;RI(2508800)|0;if(nrh(2536048,pL(2508800,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2508800)|0;l=(pL(2508800,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function $Xg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function aYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2508800)|0;d=pL(2508800,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function bYg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;ZOe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1991048)|0;d=pL(1991048,e)|0;i=b;return d|0}function cYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function dYg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function eYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2509376)|0;o=(pL(2509376,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2509376)|0;p=pL(2509376,j)|0;RI(2509376)|0;o=b+1|0;if(nrh(2536048,pL(2509376,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2509376)|0;m=(pL(2509376,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function fYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function gYg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function hYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2509376)|0;if(!(pL(2509376,f)|0)){n=l;break}c[h>>2]=b;RI(2509376)|0;m=pL(2509376,h)|0;RI(2509376)|0;if(nrh(2536048,pL(2509376,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2509376)|0;l=(pL(2509376,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function iYg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function jYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2509376)|0;d=pL(2509376,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function kYg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;cPe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1993600)|0;d=pL(1993600,e)|0;i=b;return d|0}function lYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function mYg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function nYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2509864)|0;o=(pL(2509864,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2509864)|0;p=pL(2509864,j)|0;RI(2509864)|0;o=b+1|0;if(nrh(2536048,pL(2509864,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2509864)|0;m=(pL(2509864,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function oYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function pYg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function qYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2509864)|0;if(!(pL(2509864,f)|0)){n=l;break}c[h>>2]=b;RI(2509864)|0;m=pL(2509864,h)|0;RI(2509864)|0;if(nrh(2536048,pL(2509864,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2509864)|0;l=(pL(2509864,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function rYg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function sYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2509864)|0;d=pL(2509864,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function tYg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;hPe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1996152)|0;d=pL(1996152,e)|0;i=b;return d|0}function uYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}}function vYg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function wYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2511024)|0;if(!(pL(2511024,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2511024)|0;p=pL(2511024,h)|0;RI(2511024)|0;m=m+1|0;if(nrh(2536048,pL(2511024,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2511024)|0;l=(pL(2511024,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function xYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function yYg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function zYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2511024)|0;if(!(pL(2511024,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2511024)|0;o=pL(2511024,h)|0;RI(2511024)|0;if(nrh(2536048,pL(2511024,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2511024)|0;n=(pL(2511024,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function AYg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function BYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2511024)|0;d=pL(2511024,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function CYg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;mPe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1998704)|0;d=pL(1998704,e)|0;i=b;return d|0}function DYg(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function EYg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function FYg(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2540392)|0;p=(pL(2540392,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2540392)|0;q=pL(2540392,k)|0;RI(2540392)|0;p=d+1|0;if(nrh(2536048,pL(2540392,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2540392)|0;n=(pL(2540392,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function GYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function HYg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function IYg(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2540392)|0;if(!(pL(2540392,g)|0)){o=m;break}b[j>>1]=d;RI(2540392)|0;n=pL(2540392,j)|0;RI(2540392)|0;if(nrh(2536048,pL(2540392,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2540392)|0;m=(pL(2540392,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function JYg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function KYg(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2540392)|0;e=pL(2540392,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function LYg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;rPe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2001256)|0;d=pL(2001256,e)|0;i=b;return d|0}function MYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}}function NYg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function OYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2029160)|0;if(!(pL(2029160,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2029160)|0;p=pL(2029160,h)|0;RI(2029160)|0;m=m+1|0;if(nrh(2536048,pL(2029160,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2029160)|0;l=(pL(2029160,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function PYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function QYg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function RYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2029160)|0;if(!(pL(2029160,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2029160)|0;o=pL(2029160,h)|0;RI(2029160)|0;if(nrh(2536048,pL(2029160,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2029160)|0;n=(pL(2029160,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function SYg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function TYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2029160)|0;d=pL(2029160,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function UYg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;pQe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2029912)|0;d=pL(2029912,e)|0;i=b;return d|0}function VYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function WYg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function XYg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2516584)|0;o=(pL(2516584,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2516584)|0;p=pL(2516584,j)|0;RI(2516584)|0;o=b+1|0;if(nrh(2536048,pL(2516584,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2516584)|0;m=(pL(2516584,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function YYg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function ZYg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function _Yg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2516584)|0;if(!(pL(2516584,f)|0)){n=l;break}c[h>>2]=b;RI(2516584)|0;m=pL(2516584,h)|0;RI(2516584)|0;if(nrh(2536048,pL(2516584,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2516584)|0;l=(pL(2516584,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function $Yg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function aZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2516584)|0;d=pL(2516584,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function bZg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;uQe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2034568)|0;d=pL(2034568,e)|0;i=b;return d|0}function cZg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ixh(2540728)}c[j>>2]=3436072;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=Jxh(d,1086352)|0;dZg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=Jxh(d,1086352)|0;dZg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function dZg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;h=a+24|0;j=c[h>>2]|0;if((j|0)<=0){i=f;return}k=a+12|0;l=a+16|0;m=a+20|0;a=b+16|0;n=d;d=j;j=0;while(1){o=c[k>>2]|0;if((c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){o=c[l>>2]|0;p=c[m>>2]|0;q=c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0;c[g>>2]=Kxh(2040048,e,q,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0;RI(2516584)|0;p=pL(2516584,g)|0;RI(2536312)|0;q=Jxh(p,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,n)|0)>>2]=q;r=n+1|0;s=c[h>>2]|0}else{r=n;s=d}j=j+1|0;if((j|0)>=(s|0))break;else{n=r;d=s}}i=f;return}function eZg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+16|0;g=f;h=a+24|0;j=c[h>>2]|0;if((j|0)<=0){i=f;return}k=a+12|0;l=a+16|0;m=a+20|0;a=b+16|0;n=d;d=j;j=0;while(1){o=c[k>>2]|0;if((c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0)<0){o=c[l>>2]|0;p=c[m>>2]|0;q=c[o+16+(da(c[(c[o>>2]|0)+120>>2]|0,j)|0)>>2]|0;c[g>>2]=Kxh(2040048,e,q,c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,j)|0)>>2]|0)|0;RI(2516584)|0;p=pL(2516584,g)|0;RI(2516584)|0;q=c[(Lxh(p,2516584)|0)>>2]|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,n)|0)>>2]=q;r=n+1|0;s=c[h>>2]|0}else{r=n;s=d}j=j+1|0;if((j|0)>=(s|0))break;else{n=r;d=s}}i=f;return}function fZg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Mxh(g,2040536,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2729368)|0;r=pL(2729368,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(2729368)|0;q=Lxh(r,2729368)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function gZg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ixh(2540728)}c[j>>2]=3454872;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=Jxh(d,1086352)|0;hZg(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=Jxh(d,1086352)|0;hZg(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function hZg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Nxh(g,2041024,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2029160)|0;r=pL(2029160,h)|0;RI(2536312)|0;p=Jxh(r,2536312)|0;c[a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]=p;s=o+1|0;t=c[j>>2]|0}else{s=o;t=d}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;d=t}}i=f;return}function iZg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+16|0;g=f+8|0;h=f;j=a+24|0;k=c[j>>2]|0;if((k|0)<=0){i=f;return}l=a+12|0;m=a+16|0;n=a+20|0;a=b+16|0;o=d;d=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;Nxh(g,2041024,e,r,c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>2]|0);q=g;r=c[q+4>>2]|0;p=h;c[p>>2]=c[q>>2];c[p+4>>2]=r;RI(2029160)|0;r=pL(2029160,h)|0;p=a+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)|0;RI(2029160)|0;q=Lxh(r,2029160)|0;r=c[q+4>>2]|0;s=p;c[s>>2]=c[q>>2];c[s+4>>2]=r;t=o+1|0;u=c[j>>2]|0}else{t=o;u=d}k=k+1|0;if((k|0)>=(u|0))break;else{o=t;d=u}}i=f;return}function jZg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;a[f>>0]=0;Qfh();if((PCf(b)|0)>(d|0)){g=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,b+16+(da(g,d)|0)|0,g|0)|0;i=e;return a[f>>0]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function kZg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function lZg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e+3|0;h=e+2|0;j=e+1|0;k=e;a[f>>0]=d;a[g>>0]=0;Lfh();if((sDf(b)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(b)|0;if((m|0)<=0){n=0;i=e;return n|0}l=b+16|0;o=d;d=0;while(1){p=c[(c[b>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;a[h>>0]=o;RI(2515960)|0;p=(pL(2515960,h)|0)==0;q=a[g>>0]|0;if(p){r=q;s=5;break}a[k>>0]=q;RI(2515960)|0;q=pL(2515960,k)|0;RI(2515960)|0;p=d+1|0;if(nrh(2536048,pL(2515960,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=a[f>>0]|0;d=p}if((s|0)==5){a[j>>0]=r;RI(2515960)|0;n=(pL(2515960,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function mZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function nZg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function oZg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+3|0;g=e+2|0;h=e+1|0;j=e;a[f>>0]=0;Pfh();if((sDf(b)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(b)|0;a:do if((l|0)>0){k=b+16|0;m=0;while(1){n=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;a[g>>0]=d;RI(2515960)|0;if(!(pL(2515960,g)|0)){o=m;break}a[j>>0]=d;RI(2515960)|0;n=pL(2515960,j)|0;RI(2515960)|0;if(nrh(2536048,pL(2515960,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(b,0)|0)+p|0;i=e;return r|0}a[h>>0]=a[f>>0]|0;RI(2515960)|0;m=(pL(2515960,h)|0)==0;k=xDf(b,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(b,0)|0)+-1|0;i=e;return r|0}function pZg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function qZg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+1|0;h=f;a[g>>0]=e;Rfh();if((PCf(b)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(b,1086352)|0;if(!j){k=c[(c[b>>2]|0)+120>>2]|0;YEi(b+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{a[h>>0]=e;RI(2515960)|0;e=pL(2515960,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function rZg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;uRe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2045592)|0;d=pL(2045592,e)|0;i=b;return d|0}function sZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function tZg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function uZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2529488)|0;o=(pL(2529488,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2529488)|0;p=pL(2529488,j)|0;RI(2529488)|0;o=b+1|0;if(nrh(2536048,pL(2529488,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2529488)|0;m=(pL(2529488,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function vZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function wZg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function xZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2529488)|0;if(!(pL(2529488,f)|0)){n=l;break}c[h>>2]=b;RI(2529488)|0;m=pL(2529488,h)|0;RI(2529488)|0;if(nrh(2536048,pL(2529488,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2529488)|0;l=(pL(2529488,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function yZg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function zZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2529488)|0;d=pL(2529488,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function AZg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;BRe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2078344)|0;d=pL(2078344,e)|0;i=b;return d|0}function BZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function CZg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function DZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2253112)|0;o=(pL(2253112,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2253112)|0;p=pL(2253112,j)|0;RI(2253112)|0;o=b+1|0;if(nrh(2536048,pL(2253112,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2253112)|0;m=(pL(2253112,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function EZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function FZg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function GZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2253112)|0;if(!(pL(2253112,f)|0)){n=l;break}c[h>>2]=b;RI(2253112)|0;m=pL(2253112,h)|0;RI(2253112)|0;if(nrh(2536048,pL(2253112,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2253112)|0;l=(pL(2253112,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function HZg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function IZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2253112)|0;d=pL(2253112,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function JZg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;GRe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2088552)|0;d=pL(2088552,e)|0;i=b;return d|0}function KZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function LZg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function MZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2255040)|0;o=(pL(2255040,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2255040)|0;p=pL(2255040,j)|0;RI(2255040)|0;o=b+1|0;if(nrh(2536048,pL(2255040,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2255040)|0;m=(pL(2255040,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function NZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function OZg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function PZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2255040)|0;if(!(pL(2255040,f)|0)){n=l;break}c[h>>2]=b;RI(2255040)|0;m=pL(2255040,h)|0;RI(2255040)|0;if(nrh(2536048,pL(2255040,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2255040)|0;l=(pL(2255040,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function QZg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function RZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2255040)|0;d=pL(2255040,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function SZg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;LRe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2093656)|0;d=pL(2093656,e)|0;i=b;return d|0}function TZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function UZg(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function VZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2255576)|0;o=(pL(2255576,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2255576)|0;p=pL(2255576,j)|0;RI(2255576)|0;o=b+1|0;if(nrh(2536048,pL(2255576,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2255576)|0;m=(pL(2255576,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function WZg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function XZg(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function YZg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2255576)|0;if(!(pL(2255576,f)|0)){n=l;break}c[h>>2]=b;RI(2255576)|0;m=pL(2255576,h)|0;RI(2255576)|0;if(nrh(2536048,pL(2255576,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2255576)|0;l=(pL(2255576,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function ZZg(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function _Zg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2255576)|0;d=pL(2255576,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function $Zg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;QRe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2096208)|0;d=pL(2096208,e)|0;i=b;return d|0}function a_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function b_g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function c_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2256176)|0;o=(pL(2256176,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2256176)|0;p=pL(2256176,j)|0;RI(2256176)|0;o=b+1|0;if(nrh(2536048,pL(2256176,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2256176)|0;m=(pL(2256176,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function d_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function e_g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function f_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2256176)|0;if(!(pL(2256176,f)|0)){n=l;break}c[h>>2]=b;RI(2256176)|0;m=pL(2256176,h)|0;RI(2256176)|0;if(nrh(2536048,pL(2256176,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2256176)|0;l=(pL(2256176,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function g_g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function h_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2256176)|0;d=pL(2256176,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function i_g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;VRe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2098760)|0;d=pL(2098760,e)|0;i=b;return d|0}function j_g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function k_g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function l_g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2565248)|0;p=(pL(2565248,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2565248)|0;q=pL(2565248,k)|0;RI(2565248)|0;p=d+1|0;if(nrh(2536048,pL(2565248,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2565248)|0;n=(pL(2565248,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function m_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function n_g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function o_g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2565248)|0;if(!(pL(2565248,g)|0)){o=m;break}b[j>>1]=d;RI(2565248)|0;n=pL(2565248,j)|0;RI(2565248)|0;if(nrh(2536048,pL(2565248,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2565248)|0;m=(pL(2565248,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function p_g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function q_g(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2565248)|0;e=pL(2565248,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function r_g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;_Re(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2101312)|0;d=pL(2101312,e)|0;i=b;return d|0}function s_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function t_g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function u_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2268872)|0;o=(pL(2268872,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2268872)|0;p=pL(2268872,j)|0;RI(2268872)|0;o=b+1|0;if(nrh(2536048,pL(2268872,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2268872)|0;m=(pL(2268872,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function v_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function w_g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function x_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2268872)|0;if(!(pL(2268872,f)|0)){n=l;break}c[h>>2]=b;RI(2268872)|0;m=pL(2268872,h)|0;RI(2268872)|0;if(nrh(2536048,pL(2268872,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2268872)|0;l=(pL(2268872,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function y_g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function z_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2268872)|0;d=pL(2268872,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function A_g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;dSe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2109528)|0;d=pL(2109528,e)|0;i=b;return d|0}function B_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=3264928;g=c[f+4>>2]|0;h=a;c[h>>2]=c[f>>2];c[h+4>>2]=g;Qfh();if((PCf(b)|0)>(d|0)){g=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(g,d)|0)|0,g|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}}function C_g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function D_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=3264928;k=c[j+4>>2]|0;l=e;c[l>>2]=c[j>>2];c[l+4>>2]=k;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;j=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,k+(da(n,j)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2119600)|0;if(!(pL(2119600,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2119600)|0;p=pL(2119600,h)|0;RI(2119600)|0;j=j+1|0;if(nrh(2536048,pL(2119600,b)|0,p)|0){m=1;q=9;break}if((j|0)>=(l|0)){m=0;q=9;break}}if((q|0)==5){l=e;e=c[l+4>>2]|0;j=g;c[j>>2]=c[l>>2];c[j+4>>2]=e;RI(2119600)|0;m=(pL(2119600,g)|0)==0;i=d;return m|0}else if((q|0)==9){i=d;return m|0}return 0}function E_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function F_g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function G_g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=3264928;k=c[j+4>>2]|0;l=e;c[l>>2]=c[j>>2];c[l+4>>2]=k;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;j=b;m=c[j>>2]|0;n=c[j+4>>2]|0;j=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,k+(da(o,j)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2119600)|0;if(!(pL(2119600,f)|0)){p=j;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2119600)|0;o=pL(2119600,h)|0;RI(2119600)|0;if(nrh(2536048,pL(2119600,e)|0,o)|0){q=j;r=9;break}j=j+1|0;if((j|0)>=(l|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}j=e;n=c[j+4>>2]|0;m=g;c[m>>2]=c[j>>2];c[m+4>>2]=n;RI(2119600)|0;n=(pL(2119600,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function H_g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function I_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2119600)|0;d=pL(2119600,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function J_g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;aTe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2120376)|0;d=pL(2120376,e)|0;i=b;return d|0}function K_g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;a[f>>0]=0;Qfh();if((PCf(b)|0)>(d|0)){g=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,b+16+(da(g,d)|0)|0,g|0)|0;i=e;return (a[f>>0]|0)!=0|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function L_g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function M_g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e+3|0;h=e+2|0;j=e+1|0;k=e;l=d&1;a[f>>0]=l;a[g>>0]=0;Lfh();if((sDf(b)|0)>=2){d=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,d);Hxh(m)}m=PCf(b)|0;if((m|0)<=0){n=0;i=e;return n|0}d=b+16|0;o=l;l=0;while(1){p=c[(c[b>>2]|0)+120>>2]|0;YEi(g|0,d+(da(p,l)|0)|0,p|0)|0;a[h>>0]=o;RI(2601984)|0;p=(pL(2601984,h)|0)==0;q=a[g>>0]|0;if(p){r=q;s=5;break}a[k>>0]=q;RI(2601984)|0;q=pL(2601984,k)|0;RI(2601984)|0;p=l+1|0;if(nrh(2536048,pL(2601984,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=a[f>>0]|0;l=p}if((s|0)==5){a[j>>0]=r;RI(2601984)|0;n=(pL(2601984,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function N_g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function O_g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function P_g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+3|0;g=e+2|0;h=e+1|0;j=e;a[f>>0]=0;Pfh();if((sDf(b)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(b)|0;a:do if((l|0)>0){k=b+16|0;m=d&1;n=0;while(1){o=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,n)|0)|0,o|0)|0;a[g>>0]=m;RI(2601984)|0;if(!(pL(2601984,g)|0)){p=n;break}a[j>>0]=m;RI(2601984)|0;o=pL(2601984,j)|0;RI(2601984)|0;if(nrh(2536048,pL(2601984,f)|0,o)|0){q=n;r=9;break}n=n+1|0;if((n|0)>=(l|0))break a}if((r|0)==9){s=(xDf(b,0)|0)+q|0;i=e;return s|0}a[h>>0]=a[f>>0]|0;RI(2601984)|0;n=(pL(2601984,h)|0)==0;m=xDf(b,0)|0;if(n){s=m+p|0;i=e;return s|0}else{s=m+-1|0;i=e;return s|0}}while(0);s=(xDf(b,0)|0)+-1|0;i=e;return s|0}function Q_g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function R_g(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+1|0;h=f;j=e&1;a[g>>0]=j;Rfh();if((PCf(b)|0)<=(d|0)){RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886022]|0);Hxh(e)}RI(1086352)|0;e=vL(b,1086352)|0;if(!e){k=c[(c[b>>2]|0)+120>>2]|0;YEi(b+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{a[h>>0]=j;RI(2601984)|0;j=pL(2601984,h)|0;Qqh(e,j);c[e+16+(da(c[(c[e>>2]|0)+120>>2]|0,d)|0)>>2]=j;i=f;return}}function S_g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;fTe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2122224)|0;d=pL(2122224,e)|0;i=b;return d|0}function T_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ixh(2540728)}c[j>>2]=3431408;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=Jxh(d,1086352)|0;U_g(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=Jxh(d,1086352)|0;U_g(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function U_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+16|0;h=g;j=b+24|0;k=c[j>>2]|0;if((k|0)<=0){i=g;return}l=b+12|0;m=b+16|0;n=b+20|0;b=d+16|0;o=e;e=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;a[h>>0]=(Oxh(2134016,f,r,(a[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>0]|0)!=0)|0)&1;RI(2601984)|0;q=pL(2601984,h)|0;RI(2536312)|0;r=Jxh(q,2536312)|0;c[b+(da(c[(c[d>>2]|0)+120>>2]|0,o)|0)>>2]=r;s=o+1|0;t=c[j>>2]|0}else{s=o;t=e}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;e=t}}i=g;return}function V_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+16|0;h=g;j=b+24|0;k=c[j>>2]|0;if((k|0)<=0){i=g;return}l=b+12|0;m=b+16|0;n=b+20|0;b=d+16|0;o=e;e=k;k=0;while(1){p=c[l>>2]|0;if((c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0)<0){p=c[m>>2]|0;q=c[n>>2]|0;r=c[p+16+(da(c[(c[p>>2]|0)+120>>2]|0,k)|0)>>2]|0;a[h>>0]=(Oxh(2134016,f,r,(a[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,k)|0)>>0]|0)!=0)|0)&1;RI(2601984)|0;q=pL(2601984,h)|0;RI(2601984)|0;r=a[(Lxh(q,2601984)|0)>>0]|0;a[b+(da(c[(c[d>>2]|0)+120>>2]|0,o)|0)>>0]=r;s=o+1|0;t=c[j>>2]|0}else{s=o;t=e}k=k+1|0;if((k|0)>=(t|0))break;else{o=s;e=t}}i=g;return}function W_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g+8|0;j=g;k=b+24|0;l=c[k>>2]|0;if((l|0)<=0){i=g;return}m=b+12|0;n=b+16|0;o=b+20|0;b=d+16|0;p=e;e=l;l=0;while(1){q=c[m>>2]|0;if((c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,l)|0)>>2]|0)<0){q=c[n>>2]|0;r=c[o>>2]|0;s=c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,l)|0)>>2]|0;Pxh(h,2134504,f,s,(a[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,l)|0)>>0]|0)!=0);r=h;s=c[r+4>>2]|0;q=j;c[q>>2]=c[r>>2];c[q+4>>2]=s;RI(2729368)|0;s=pL(2729368,j)|0;q=b+(da(c[(c[d>>2]|0)+120>>2]|0,p)|0)|0;RI(2729368)|0;r=Lxh(s,2729368)|0;s=c[r+4>>2]|0;t=q;c[t>>2]=c[r>>2];c[t+4>>2]=s;u=p+1|0;v=c[k>>2]|0}else{u=p;v=e}l=l+1|0;if((l|0)>=(v|0))break;else{p=u;e=v}}i=g;return}function X_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+4|0;j=g;whh();RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Ixh(2540728)}c[j>>2]=3455296;c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;h=suh(2619720,Xnf(d)|0)|0;if(!(Gqh(2653672,j)|0)?!(Gqh(2653672,h)|0):0){RI(1086352)|0;k=Jxh(d,1086352)|0;Y_g(b,k,e,f);i=g;return}if(Yuh(2651232,h,j)|0){RI(1086352)|0;k=Jxh(d,1086352)|0;Y_g(b,k,e,f);i=g;return}else{RI(2589312)|0;g=qL(2589312)|0;FHf(g);FJ(g)}}function Y_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+16|0;h=g+8|0;j=g;k=b+24|0;l=c[k>>2]|0;if((l|0)<=0){i=g;return}m=b+12|0;n=b+16|0;o=b+20|0;b=d+16|0;p=e;e=l;l=0;while(1){q=c[m>>2]|0;if((c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,l)|0)>>2]|0)<0){q=c[n>>2]|0;r=c[o>>2]|0;s=c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,l)|0)>>2]|0;Qxh(h,2134992,f,s,(a[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,l)|0)>>0]|0)!=0);r=h;s=c[r+4>>2]|0;q=j;c[q>>2]=c[r>>2];c[q+4>>2]=s;RI(2119600)|0;s=pL(2119600,j)|0;RI(2536312)|0;q=Jxh(s,2536312)|0;c[b+(da(c[(c[d>>2]|0)+120>>2]|0,p)|0)>>2]=q;t=p+1|0;u=c[k>>2]|0}else{t=p;u=e}l=l+1|0;if((l|0)>=(u|0))break;else{p=t;e=u}}i=g;return}function Z_g(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g+8|0;j=g;k=b+24|0;l=c[k>>2]|0;if((l|0)<=0){i=g;return}m=b+12|0;n=b+16|0;o=b+20|0;b=d+16|0;p=e;e=l;l=0;while(1){q=c[m>>2]|0;if((c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,l)|0)>>2]|0)<0){q=c[n>>2]|0;r=c[o>>2]|0;s=c[q+16+(da(c[(c[q>>2]|0)+120>>2]|0,l)|0)>>2]|0;Qxh(h,2134992,f,s,(a[r+16+(da(c[(c[r>>2]|0)+120>>2]|0,l)|0)>>0]|0)!=0);r=h;s=c[r+4>>2]|0;q=j;c[q>>2]=c[r>>2];c[q+4>>2]=s;RI(2119600)|0;s=pL(2119600,j)|0;q=b+(da(c[(c[d>>2]|0)+120>>2]|0,p)|0)|0;RI(2119600)|0;r=Lxh(s,2119600)|0;s=c[r+4>>2]|0;t=q;c[t>>2]=c[r>>2];c[t+4>>2]=s;u=p+1|0;v=c[k>>2]|0}else{u=p;v=e}l=l+1|0;if((l|0)>=(v|0))break;else{p=u;e=v}}i=g;return}function __g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}}function $_g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function a$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2273904)|0;if(!(pL(2273904,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2273904)|0;p=pL(2273904,h)|0;RI(2273904)|0;m=m+1|0;if(nrh(2536048,pL(2273904,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2273904)|0;l=(pL(2273904,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function b$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function c$g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function d$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2273904)|0;if(!(pL(2273904,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2273904)|0;o=pL(2273904,h)|0;RI(2273904)|0;if(nrh(2536048,pL(2273904,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2273904)|0;n=(pL(2273904,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function e$g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function f$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2273904)|0;d=pL(2273904,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function g$g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;gUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2141080)|0;d=pL(2141080,e)|0;i=b;return d|0}function h$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function i$g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function j$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2274184)|0;o=(pL(2274184,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2274184)|0;p=pL(2274184,j)|0;RI(2274184)|0;o=b+1|0;if(nrh(2536048,pL(2274184,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2274184)|0;m=(pL(2274184,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function k$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function l$g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function m$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2274184)|0;if(!(pL(2274184,f)|0)){n=l;break}c[h>>2]=b;RI(2274184)|0;m=pL(2274184,h)|0;RI(2274184)|0;if(nrh(2536048,pL(2274184,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2274184)|0;l=(pL(2274184,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function n$g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function o$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2274184)|0;d=pL(2274184,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function p$g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;lUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2143632)|0;d=pL(2143632,e)|0;i=b;return d|0}function q$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function r$g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function s$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2276200)|0;o=(pL(2276200,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2276200)|0;p=pL(2276200,j)|0;RI(2276200)|0;o=b+1|0;if(nrh(2536048,pL(2276200,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2276200)|0;m=(pL(2276200,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function t$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function u$g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function v$g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2276200)|0;if(!(pL(2276200,f)|0)){n=l;break}c[h>>2]=b;RI(2276200)|0;m=pL(2276200,h)|0;RI(2276200)|0;if(nrh(2536048,pL(2276200,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2276200)|0;l=(pL(2276200,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function w$g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function x$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2276200)|0;d=pL(2276200,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function y$g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;qUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2146184)|0;d=pL(2146184,e)|0;i=b;return d|0}function z$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function A$g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function B$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2279080)|0;p=(pL(2279080,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2279080)|0;q=pL(2279080,k)|0;RI(2279080)|0;p=d+1|0;if(nrh(2536048,pL(2279080,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2279080)|0;n=(pL(2279080,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function C$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function D$g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function E$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2279080)|0;if(!(pL(2279080,g)|0)){o=m;break}b[j>>1]=d;RI(2279080)|0;n=pL(2279080,j)|0;RI(2279080)|0;if(nrh(2536048,pL(2279080,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2279080)|0;m=(pL(2279080,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function F$g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function G$g(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2279080)|0;e=pL(2279080,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function H$g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;vUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2148736)|0;d=pL(2148736,e)|0;i=b;return d|0}function I$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function J$g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function K$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2280424)|0;p=(pL(2280424,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2280424)|0;q=pL(2280424,k)|0;RI(2280424)|0;p=d+1|0;if(nrh(2536048,pL(2280424,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2280424)|0;n=(pL(2280424,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function L$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function M$g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function N$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2280424)|0;if(!(pL(2280424,g)|0)){o=m;break}b[j>>1]=d;RI(2280424)|0;n=pL(2280424,j)|0;RI(2280424)|0;if(nrh(2536048,pL(2280424,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2280424)|0;m=(pL(2280424,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function O$g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function P$g(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2280424)|0;e=pL(2280424,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function Q$g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;AUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2151288)|0;d=pL(2151288,e)|0;i=b;return d|0}function R$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function S$g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function T$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2280960)|0;p=(pL(2280960,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2280960)|0;q=pL(2280960,k)|0;RI(2280960)|0;p=d+1|0;if(nrh(2536048,pL(2280960,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2280960)|0;n=(pL(2280960,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function U$g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function V$g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function W$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2280960)|0;if(!(pL(2280960,g)|0)){o=m;break}b[j>>1]=d;RI(2280960)|0;n=pL(2280960,j)|0;RI(2280960)|0;if(nrh(2536048,pL(2280960,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2280960)|0;m=(pL(2280960,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function X$g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function Y$g(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2280960)|0;e=pL(2280960,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function Z$g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;FUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2153840)|0;d=pL(2153840,e)|0;i=b;return d|0}function _$g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function $$g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function a0g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2284056)|0;p=(pL(2284056,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2284056)|0;q=pL(2284056,k)|0;RI(2284056)|0;p=d+1|0;if(nrh(2536048,pL(2284056,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2284056)|0;n=(pL(2284056,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function b0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function c0g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function d0g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2284056)|0;if(!(pL(2284056,g)|0)){o=m;break}b[j>>1]=d;RI(2284056)|0;n=pL(2284056,j)|0;RI(2284056)|0;if(nrh(2536048,pL(2284056,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2284056)|0;m=(pL(2284056,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function e0g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function f0g(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2284056)|0;e=pL(2284056,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function g0g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;KUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2156392)|0;d=pL(2156392,e)|0;i=b;return d|0}function h0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}}function i0g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function j0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];RI(2324976)|0;if(!(pL(2324976,f)|0)){o=5;break};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];RI(2324976)|0;n=pL(2324976,h)|0;RI(2324976)|0;m=m+1|0;if(nrh(2536048,pL(2324976,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];RI(2324976)|0;l=(pL(2324976,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function k0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function l0g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function m0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+36|0;f=d+24|0;g=d+12|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];RI(2324976)|0;if(!(pL(2324976,f)|0)){n=l;break};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];RI(2324976)|0;m=pL(2324976,h)|0;RI(2324976)|0;if(nrh(2536048,pL(2324976,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0};c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];RI(2324976)|0;l=(pL(2324976,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function n0g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function o0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];RI(2324976)|0;d=pL(2324976,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function p0g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;PUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2158944)|0;d=pL(2158944,e)|0;i=b;return d|0}function q0g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;a[f>>0]=0;Qfh();if((PCf(b)|0)>(d|0)){g=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,b+16+(da(g,d)|0)|0,g|0)|0;i=e;return a[f>>0]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function r0g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function s0g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e+3|0;h=e+2|0;j=e+1|0;k=e;a[f>>0]=d;a[g>>0]=0;Lfh();if((sDf(b)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(b)|0;if((m|0)<=0){n=0;i=e;return n|0}l=b+16|0;o=d;d=0;while(1){p=c[(c[b>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;a[h>>0]=o;RI(2557392)|0;p=(pL(2557392,h)|0)==0;q=a[g>>0]|0;if(p){r=q;s=5;break}a[k>>0]=q;RI(2557392)|0;q=pL(2557392,k)|0;RI(2557392)|0;p=d+1|0;if(nrh(2536048,pL(2557392,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=a[f>>0]|0;d=p}if((s|0)==5){a[j>>0]=r;RI(2557392)|0;n=(pL(2557392,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function t0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function u0g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function v0g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+3|0;g=e+2|0;h=e+1|0;j=e;a[f>>0]=0;Pfh();if((sDf(b)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(b)|0;a:do if((l|0)>0){k=b+16|0;m=0;while(1){n=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;a[g>>0]=d;RI(2557392)|0;if(!(pL(2557392,g)|0)){o=m;break}a[j>>0]=d;RI(2557392)|0;n=pL(2557392,j)|0;RI(2557392)|0;if(nrh(2536048,pL(2557392,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(b,0)|0)+p|0;i=e;return r|0}a[h>>0]=a[f>>0]|0;RI(2557392)|0;m=(pL(2557392,h)|0)==0;k=xDf(b,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(b,0)|0)+-1|0;i=e;return r|0}function w0g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function x0g(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+1|0;h=f;a[g>>0]=e;Rfh();if((PCf(b)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(b,1086352)|0;if(!j){k=c[(c[b>>2]|0)+120>>2]|0;YEi(b+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{a[h>>0]=e;RI(2557392)|0;e=pL(2557392,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function y0g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;UUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2161496)|0;d=pL(2161496,e)|0;i=b;return d|0}function z0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function A0g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function B0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2331416)|0;o=(pL(2331416,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2331416)|0;p=pL(2331416,j)|0;RI(2331416)|0;o=b+1|0;if(nrh(2536048,pL(2331416,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2331416)|0;m=(pL(2331416,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function C0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function D0g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function E0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2331416)|0;if(!(pL(2331416,f)|0)){n=l;break}c[h>>2]=b;RI(2331416)|0;m=pL(2331416,h)|0;RI(2331416)|0;if(nrh(2536048,pL(2331416,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2331416)|0;l=(pL(2331416,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function F0g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function G0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2331416)|0;d=pL(2331416,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function H0g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;ZUe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2169712)|0;d=pL(2169712,e)|0;i=b;return d|0}function I0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function J0g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function K0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2331968)|0;o=(pL(2331968,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2331968)|0;p=pL(2331968,j)|0;RI(2331968)|0;o=b+1|0;if(nrh(2536048,pL(2331968,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2331968)|0;m=(pL(2331968,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function L0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function M0g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function N0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2331968)|0;if(!(pL(2331968,f)|0)){n=l;break}c[h>>2]=b;RI(2331968)|0;m=pL(2331968,h)|0;RI(2331968)|0;if(nrh(2536048,pL(2331968,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2331968)|0;l=(pL(2331968,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function O0g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function P0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2331968)|0;d=pL(2331968,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function Q0g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;cVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2172264)|0;d=pL(2172264,e)|0;i=b;return d|0}function R0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function S0g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function T0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2333648)|0;o=(pL(2333648,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2333648)|0;p=pL(2333648,j)|0;RI(2333648)|0;o=b+1|0;if(nrh(2536048,pL(2333648,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2333648)|0;m=(pL(2333648,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function U0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function V0g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function W0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2333648)|0;if(!(pL(2333648,f)|0)){n=l;break}c[h>>2]=b;RI(2333648)|0;m=pL(2333648,h)|0;RI(2333648)|0;if(nrh(2536048,pL(2333648,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2333648)|0;l=(pL(2333648,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function X0g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function Y0g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2333648)|0;d=pL(2333648,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function Z0g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;hVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2174816)|0;d=pL(2174816,e)|0;i=b;return d|0}function _0g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=e;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;f=e;H=c[f+4>>2]|0;i=d;return c[f>>2]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function $0g(a,b,d){a=a|0;b=b|0;d=d|0;Jfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[885920]|0);Hxh(d)}function a1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+48|0;f=e+32|0;g=e+24|0;h=e+16|0;j=e+8|0;k=e;l=f;c[l>>2]=b;c[l+4>>2]=d;l=g;c[l>>2]=0;c[l+4>>2]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=b;b=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;p=h;c[p>>2]=o;c[p+4>>2]=b;RI(2548816)|0;p=(pL(2548816,h)|0)==0;q=g;r=c[q>>2]|0;s=c[q+4>>2]|0;if(p){t=r;u=s;v=5;break}p=k;c[p>>2]=r;c[p+4>>2]=s;RI(2548816)|0;s=pL(2548816,k)|0;RI(2548816)|0;p=d+1|0;if(nrh(2536048,pL(2548816,f)|0,s)|0){n=1;v=10;break}if((p|0)>=(m|0)){n=0;v=10;break}s=f;o=c[s>>2]|0;b=c[s+4>>2]|0;d=p}if((v|0)==5){d=j;c[d>>2]=t;c[d+4>>2]=u;RI(2548816)|0;n=(pL(2548816,j)|0)==0;i=e;return n|0}else if((v|0)==10){i=e;return n|0}return 0}function b1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function c1g(a,b,d){a=a|0;b=b|0;d=d|0;Kfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[885924]|0);Hxh(d);return 0}function d1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;k=f;c[k>>2]=0;c[k+4>>2]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;n=g;c[n>>2]=b;c[n+4>>2]=d;RI(2548816)|0;if(!(pL(2548816,g)|0)){o=m;break}n=j;c[n>>2]=b;c[n+4>>2]=d;RI(2548816)|0;n=pL(2548816,j)|0;RI(2548816)|0;if(nrh(2536048,pL(2548816,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}m=f;k=c[m+4>>2]|0;n=h;c[n>>2]=c[m>>2];c[n+4>>2]=k;RI(2548816)|0;k=(pL(2548816,h)|0)==0;n=xDf(a,0)|0;if(k){r=n+o|0;i=e;return r|0}else{r=n+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function e1g(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;Nfh();RI(3100472)|0;e=qL(3100472)|0;pug(e,c[886006]|0);Hxh(e)}function f1g(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f;j=g;c[j>>2]=d;c[j+4>>2]=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,b)|0)|0,g|0,k|0)|0;i=f;return}else{k=h;c[k>>2]=d;c[k+4>>2]=e;RI(2548816)|0;e=pL(2548816,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,b)|0)>>2]=e;i=f;return}}function g1g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;mVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2187576)|0;d=pL(2187576,e)|0;i=b;return d|0}function h1g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function i1g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function j1g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2551640)|0;o=(pL(2551640,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2551640)|0;p=pL(2551640,j)|0;RI(2551640)|0;o=b+1|0;if(nrh(2536048,pL(2551640,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2551640)|0;m=(pL(2551640,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function k1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function l1g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function m1g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2551640)|0;if(!(pL(2551640,f)|0)){n=l;break}c[h>>2]=b;RI(2551640)|0;m=pL(2551640,h)|0;RI(2551640)|0;if(nrh(2536048,pL(2551640,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2551640)|0;l=(pL(2551640,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function n1g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function o1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Hxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2551640)|0;d=pL(2551640,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function p1g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;rVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2198144)|0;d=pL(2198144,e)|0;i=b;return d|0}function q1g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=e;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;f=e;H=c[f+4>>2]|0;i=d;return c[f>>2]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function r1g(a,b,d){a=a|0;b=b|0;d=d|0;Jfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[885920]|0);Hxh(d)}function s1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+48|0;f=e+32|0;g=e+24|0;h=e+16|0;j=e+8|0;k=e;l=f;c[l>>2]=b;c[l+4>>2]=d;l=g;c[l>>2]=0;c[l+4>>2]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=b;b=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;p=h;c[p>>2]=o;c[p+4>>2]=b;RI(2554736)|0;p=(pL(2554736,h)|0)==0;q=g;r=c[q>>2]|0;s=c[q+4>>2]|0;if(p){t=r;u=s;v=5;break}p=k;c[p>>2]=r;c[p+4>>2]=s;RI(2554736)|0;s=pL(2554736,k)|0;RI(2554736)|0;p=d+1|0;if(nrh(2536048,pL(2554736,f)|0,s)|0){n=1;v=10;break}if((p|0)>=(m|0)){n=0;v=10;break}s=f;o=c[s>>2]|0;b=c[s+4>>2]|0;d=p}if((v|0)==5){d=j;c[d>>2]=t;c[d+4>>2]=u;RI(2554736)|0;n=(pL(2554736,j)|0)==0;i=e;return n|0}else if((v|0)==10){i=e;return n|0}return 0}function t1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function u1g(a,b,d){a=a|0;b=b|0;d=d|0;Kfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[885924]|0);Hxh(d);return 0}function v1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;k=f;c[k>>2]=0;c[k+4>>2]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;n=g;c[n>>2]=b;c[n+4>>2]=d;RI(2554736)|0;if(!(pL(2554736,g)|0)){o=m;break}n=j;c[n>>2]=b;c[n+4>>2]=d;RI(2554736)|0;n=pL(2554736,j)|0;RI(2554736)|0;if(nrh(2536048,pL(2554736,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}m=f;k=c[m+4>>2]|0;n=h;c[n>>2]=c[m>>2];c[n+4>>2]=k;RI(2554736)|0;k=(pL(2554736,h)|0)==0;n=xDf(a,0)|0;if(k){r=n+o|0;i=e;return r|0}else{r=n+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function w1g(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;Nfh();RI(3100472)|0;e=qL(3100472)|0;pug(e,c[886006]|0);Hxh(e)}function x1g(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f;j=g;c[j>>2]=d;c[j+4>>2]=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,b)|0)|0,g|0,k|0)|0;i=f;return}else{k=h;c[k>>2]=d;c[k+4>>2]=e;RI(2554736)|0;e=pL(2554736,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,b)|0)>>2]=e;i=f;return}}function y1g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;wVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2208912)|0;d=pL(2208912,e)|0;i=b;return d|0}function z1g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;a[f>>0]=0;Qfh();if((PCf(b)|0)>(d|0)){g=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,b+16+(da(g,d)|0)|0,g|0)|0;i=e;return a[f>>0]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function A1g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function B1g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e+3|0;h=e+2|0;j=e+1|0;k=e;a[f>>0]=d;a[g>>0]=0;Lfh();if((sDf(b)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(b)|0;if((m|0)<=0){n=0;i=e;return n|0}l=b+16|0;o=d;d=0;while(1){p=c[(c[b>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;a[h>>0]=o;RI(2560032)|0;p=(pL(2560032,h)|0)==0;q=a[g>>0]|0;if(p){r=q;s=5;break}a[k>>0]=q;RI(2560032)|0;q=pL(2560032,k)|0;RI(2560032)|0;p=d+1|0;if(nrh(2536048,pL(2560032,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=a[f>>0]|0;d=p}if((s|0)==5){a[j>>0]=r;RI(2560032)|0;n=(pL(2560032,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function C1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function D1g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function E1g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+3|0;g=e+2|0;h=e+1|0;j=e;a[f>>0]=0;Pfh();if((sDf(b)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(b)|0;a:do if((l|0)>0){k=b+16|0;m=0;while(1){n=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;a[g>>0]=d;RI(2560032)|0;if(!(pL(2560032,g)|0)){o=m;break}a[j>>0]=d;RI(2560032)|0;n=pL(2560032,j)|0;RI(2560032)|0;if(nrh(2536048,pL(2560032,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(b,0)|0)+p|0;i=e;return r|0}a[h>>0]=a[f>>0]|0;RI(2560032)|0;m=(pL(2560032,h)|0)==0;k=xDf(b,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(b,0)|0)+-1|0;i=e;return r|0}function F1g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function G1g(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+1|0;h=f;a[g>>0]=e;Rfh();if((PCf(b)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(b,1086352)|0;if(!j){k=c[(c[b>>2]|0)+120>>2]|0;YEi(b+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{a[h>>0]=e;RI(2560032)|0;e=pL(2560032,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function H1g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;BVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2217128)|0;d=pL(2217128,e)|0;i=b;return d|0}function I1g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;b[f>>1]=0;Qfh();if((PCf(a)|0)>(d|0)){g=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,a+16+(da(g,d)|0)|0,g|0)|0;i=e;return b[f>>1]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Hxh(f)}return 0}function J1g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function K1g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+8|0;g=e+6|0;h=e+4|0;j=e+2|0;k=e;b[f>>1]=d;b[g>>1]=0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=e;return n|0}l=a+16|0;o=d;d=0;while(1){p=c[(c[a>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;b[h>>1]=o;RI(2562664)|0;p=(pL(2562664,h)|0)==0;q=b[g>>1]|0;if(p){r=q;s=5;break}b[k>>1]=q;RI(2562664)|0;q=pL(2562664,k)|0;RI(2562664)|0;p=d+1|0;if(nrh(2536048,pL(2562664,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=b[f>>1]|0;d=p}if((s|0)==5){b[j>>1]=r;RI(2562664)|0;n=(pL(2562664,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function L1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function M1g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function N1g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+6|0;g=e+4|0;h=e+2|0;j=e;b[f>>1]=0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;b[g>>1]=d;RI(2562664)|0;if(!(pL(2562664,g)|0)){o=m;break}b[j>>1]=d;RI(2562664)|0;n=pL(2562664,j)|0;RI(2562664)|0;if(nrh(2536048,pL(2562664,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=e;return r|0}b[h>>1]=b[f>>1]|0;RI(2562664)|0;m=(pL(2562664,h)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=e;return r|0}function O1g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function P1g(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+2|0;h=f;b[g>>1]=e;Rfh();if((PCf(a)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{b[h>>1]=e;RI(2562664)|0;e=pL(2562664,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function Q1g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;GVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2225344)|0;d=pL(2225344,e)|0;i=b;return d|0}function R1g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;h[e>>3]=0.0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return +(+h[e>>3])}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return +(0.0)}function S1g(a,b){a=a|0;b=+b;Jfh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[885920]|0);Hxh(a)}function T1g(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0,t=0;d=i;i=i+48|0;e=d+32|0;f=d+24|0;g=d+16|0;j=d+8|0;k=d;h[e>>3]=b;h[f>>3]=0.0;Lfh();if((sDf(a)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Hxh(m)}m=PCf(a)|0;if((m|0)<=0){n=0;i=d;return n|0}l=a+16|0;o=b;p=0;while(1){q=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,l+(da(q,p)|0)|0,q|0)|0;h[g>>3]=o;RI(2589144)|0;q=(pL(2589144,g)|0)==0;b=+h[f>>3];if(q){r=b;s=5;break}h[k>>3]=b;RI(2589144)|0;q=pL(2589144,k)|0;RI(2589144)|0;t=p+1|0;if(nrh(2536048,pL(2589144,e)|0,q)|0){n=1;s=10;break}if((t|0)>=(m|0)){n=0;s=10;break}o=+h[e>>3];p=t}if((s|0)==5){h[j>>3]=r;RI(2589144)|0;n=(pL(2589144,j)|0)==0;i=d;return n|0}else if((s|0)==10){i=d;return n|0}return 0}function U1g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function V1g(a,b){a=a|0;b=+b;Kfh();RI(3100472)|0;a=qL(3100472)|0;pug(a,c[885924]|0);Hxh(a);return 0}function W1g(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;j=d;h[e>>3]=0.0;Pfh();if((sDf(a)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Hxh(l)}l=PCf(a)|0;a:do if((l|0)>0){k=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,k+(da(n,m)|0)|0,n|0)|0;h[f>>3]=b;RI(2589144)|0;if(!(pL(2589144,f)|0)){o=m;break}h[j>>3]=b;RI(2589144)|0;n=pL(2589144,j)|0;RI(2589144)|0;if(nrh(2536048,pL(2589144,e)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=d;return r|0}h[g>>3]=+h[e>>3];RI(2589144)|0;m=(pL(2589144,g)|0)==0;k=xDf(a,0)|0;if(m){r=k+o|0;i=d;return r|0}else{r=k+-1|0;i=d;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=d;return r|0}function X1g(a,b,d){a=a|0;b=b|0;d=+d;Nfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[886006]|0);Hxh(b)}function Y1g(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e;h[f>>3]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Hxh(j)}RI(1086352)|0;j=vL(a,1086352)|0;if(!j){k=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(k,b)|0)|0,f|0,k|0)|0;i=e;return}else{h[g>>3]=d;RI(2589144)|0;k=pL(2589144,g)|0;Qqh(j,k);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,b)|0)>>2]=k;i=e;return}}function Z1g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;LVe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(2233560)|0;d=pL(2233560,e)|0;i=b;return d|0}function _1g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Hxh(e)}return 0}function $1g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Hxh(b)}function a2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f>>2]=c[b>>2];RI(2606296)|0;if(!(pL(2606296,f)|0)){o=5;break}c[h>>2]=c[e>>2];RI(2606296)|0;n=pL(2606296,h)|0;RI(2606296)|0;m=m+1|0;if(nrh(2536048,pL(2606296,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g>>2]=c[e>>2];RI(2606296)|0;l=(pL(2606296,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function b2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Hxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Hxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Hxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Hxh(a)}}function c2g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Hxh(b);return 0}function d2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Hxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=c[b>>2]|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f>>2]=l;RI(2606296)|0;if(!(pL(2606296,f)|0)){o=m;break}c[h>>2]=l;RI(2606296)|0;n=pL(2606296,h)|0;RI(2606296)|0;if(nrh(2536048,pL(2606296,e)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(k|0))break a}if((q|0)==9){r=(xDf(a,0)|0)+p|0;i=d;return r|0}c[g>>2]=c[e>>2];RI(2606296)|0;m=(pL(2606296,g)|0)==0;l=xDf(a,0)|0;if(m){r=l+o|0;i=d;return r|0}else{r=l+-1|0;i=d;return r|0}}while(0);r=(xDf(a,0)|0)+-1|0;i=d;return r|0}function e2g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Hxh(d)}function f2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Hxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f>>2]=c[d>>2];RI(2606296)|0;d=pL(2606296,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function g2g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;aze(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1368848)|0;d=pL(1368848,e)|0;i=b;return d|0}function h2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;Ggh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886984]|0);Hxh(e)}else{e=i2g(0,b,0,c[b+12>>2]|0,d,0)|0;i=a;return e|0}return 0}function i2g(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;Hgh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886988]|0);Hxh(j)}if((e|0)<=-1){j=tof(0,c[886992]|0)|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886990]|0,j);Hxh(k)}if((f|0)<=-1){k=tof(0,c[886996]|0)|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886994]|0,k);Hxh(j)}if(((c[d+12>>2]|0)-f|0)<(e|0)){j=tof(0,c[886998]|0)|0;RI(2965048)|0;k=qL(2965048)|0;Rbg(k,j);Hxh(k)}if(!h){RI(1374184)|0;if(!(a[1374332]|0)){RI(1374184)|0;Ixh(1374184)}l=jze(0)|0}else l=h;h=e+-1+f|0;a:do if((h|0)<(e|0))m=e;else{f=d+16|0;k=e;j=h;b:while(1){n=k;while(1){o=j-n|0;p=((o|0)/2|0)+n|0;q=Rxh(1373920,l,g,c[f+(da(c[(c[d>>2]|0)+120>>2]|0,p)|0)>>2]|0)|0;if(!q){r=p;break b}s=p+1|0;if((q|0)<=-1){t=o;u=p;v=n;break}if((j|0)<(s|0)){m=s;break a}else n=s}if((t|0)<2){m=v;break a}else{k=v;j=u+-1|0}}i=b;return r|0}while(0);r=~m;i=b;return r|0}function j2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;Ggh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886984]|0);Hxh(e)}else{e=k2g(0,b,0,c[b+12>>2]|0,d,0)|0;i=a;return e|0}return 0}function k2g(d,e,f,g,h,j){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;Hgh();if(!e){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[886988]|0);Hxh(k)}if((f|0)<=-1){k=tof(0,c[886992]|0)|0;RI(2964880)|0;l=qL(2964880)|0;Qag(l,c[886990]|0,k);Hxh(l)}if((g|0)<=-1){l=tof(0,c[886996]|0)|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886994]|0,l);Hxh(k)}if(((c[e+12>>2]|0)-g|0)<(f|0)){k=tof(0,c[886998]|0)|0;RI(2965048)|0;l=qL(2965048)|0;Rbg(l,k);Hxh(l)}if(!j){RI(1375648)|0;if(!(a[1375796]|0)){RI(1375648)|0;Ixh(1375648)}m=pze(0)|0}else m=j;j=f+-1+g|0;a:do if((j|0)<(f|0))n=f;else{g=e+16|0;l=f;k=j;b:while(1){o=l;while(1){p=k-o|0;q=((p|0)/2|0)+o|0;r=Sxh(1375384,m,h,b[g+(da(c[(c[e>>2]|0)+120>>2]|0,q)|0)>>1]|0)|0;if(!r){s=q;break b}t=q+1|0;if((r|0)<=-1){u=p;v=q;w=o;break}if((k|0)<(t|0)){n=t;break a}else o=t}if((u|0)<2){n=w;break a}else{l=w;k=v+-1|0}}i=d;return s|0}while(0);s=~n;i=d;return s|0}function l2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;Ggh();if(!b){RI(2963920)|0;e=qL(2963920)|0;Iag(e,c[886984]|0);Hxh(e)}else{e=m2g(0,b,0,c[b+12>>2]|0,d,0)|0;i=a;return e|0}return 0}function m2g(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=i;Hgh();if(!d){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886988]|0);Hxh(j)}if((e|0)<=-1){j=tof(0,c[886992]|0)|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886990]|0,j);Hxh(k)}if((f|0)<=-1){k=tof(0,c[886996]|0)|0;RI(2964880)|0;j=qL(2964880)|0;Qag(j,c[886994]|0,k);Hxh(j)}if(((c[d+12>>2]|0)-f|0)<(e|0)){j=tof(0,c[886998]|0)|0;RI(2965048)|0;k=qL(2965048)|0;Rbg(k,j);Hxh(k)}if(!h){RI(1377112)|0;if(!(a[1377260]|0)){RI(1377112)|0;Ixh(1377112)}l=vze(0)|0}else l=h;h=e+-1+f|0;a:do if((h|0)<(e|0))m=e;else{f=d+16|0;k=e;j=h;b:while(1){n=k;while(1){o=j-n|0;p=((o|0)/2|0)+n|0;q=Txh(1376848,l,g,a[f+(da(c[(c[d>>2]|0)+120>>2]|0,p)|0)>>0]|0)|0;if(!q){r=p;break b}s=p+1|0;if((q|0)<=-1){t=o;u=p;v=n;break}if((j|0)<(s|0)){m=s;break a}else n=s}if((t|0)<2){m=v;break a}else{k=v;j=u+-1|0}}i=b;return r|0}while(0);r=~m;i=b;return r|0}function n2g(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;Ggh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[886984]|0);Hxh(f)}else{f=o2g(0,b,0,c[b+12>>2]|0,d,e,0)|0;i=a;return f|0}return 0}function o2g(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;Hgh();if(!d){RI(2963920)|0;k=qL(2963920)|0;Iag(k,c[886988]|0);Hxh(k)}if((e|0)<=-1){k=tof(0,c[886992]|0)|0;RI(2964880)|0;l=qL(2964880)|0;Qag(l,c[886990]|0,k);Hxh(l)}if((f|0)<=-1){l=tof(0,c[886996]|0)|0;RI(2964880)|0;k=qL(2964880)|0;Qag(k,c[886994]|0,l);Hxh(k)}if(((c[d+12>>2]|0)-f|0)<(e|0)){k=tof(0,c[886998]|0)|0;RI(2965048)|0;l=qL(2965048)|0;Rbg(l,k);Hxh(l)}if(!j){RI(1378576)|0;if(!(a[1378724]|0)){RI(1378576)|0;Ixh(1378576)}m=Bze(0)|0}else m=j;j=e+-1+f|0;a:do if((j|0)<(e|0))n=e;else{f=d+16|0;l=e;k=j;b:while(1){o=l;while(1){p=k-o|0;q=((p|0)/2|0)+o|0;r=f+(da(c[(c[d>>2]|0)+120>>2]|0,q)|0)|0;s=Uxh(1378312,m,g,h,c[r>>2]|0,c[r+4>>2]|0)|0;if(!s){t=q;break b}r=q+1|0;if((s|0)<=-1){u=p;v=q;w=o;break}if((k|0)<(r|0)){n=r;break a}else o=r}if((u|0)<2){n=w;break a}else{l=w;k=v+-1|0}}i=b;return t|0}while(0);t=~n;i=b;return t|0}function p2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}}function q2g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function r2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+80|0;e=d+60|0;f=d+40|0;g=d+20|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];RI(2673824)|0;if(!(pL(2673824,f)|0)){o=5;break};c[h+0>>2]=c[e+0>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[h+16>>2]=c[e+16>>2];RI(2673824)|0;n=pL(2673824,h)|0;RI(2673824)|0;m=m+1|0;if(nrh(2536048,pL(2673824,b)|0,n)|0){l=1;o=9;break}if((m|0)>=(k|0)){l=0;o=9;break}}if((o|0)==5){c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];RI(2673824)|0;l=(pL(2673824,g)|0)==0;i=d;return l|0}else if((o|0)==9){i=d;return l|0}return 0}function s2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function t2g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function u2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+80|0;e=d+60|0;f=d+40|0;g=d+20|0;h=d;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f+0>>2]=c[b+0>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];RI(2673824)|0;if(!(pL(2673824,f)|0)){n=l;break};c[h+0>>2]=c[b+0>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];RI(2673824)|0;m=pL(2673824,h)|0;RI(2673824)|0;if(nrh(2536048,pL(2673824,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0};c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];RI(2673824)|0;l=(pL(2673824,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function v2g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function w2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Vxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];RI(2673824)|0;d=pL(2673824,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function x2g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Dze(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1440664)|0;d=pL(1440664,e)|0;i=b;return d|0}function y2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function z2g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function A2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2685904)|0;o=(pL(2685904,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2685904)|0;p=pL(2685904,j)|0;RI(2685904)|0;o=b+1|0;if(nrh(2536048,pL(2685904,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2685904)|0;m=(pL(2685904,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function B2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function C2g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function D2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2685904)|0;if(!(pL(2685904,f)|0)){n=l;break}c[h>>2]=b;RI(2685904)|0;m=pL(2685904,h)|0;RI(2685904)|0;if(nrh(2536048,pL(2685904,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2685904)|0;l=(pL(2685904,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function E2g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function F2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2685904)|0;d=pL(2685904,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function G2g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Ize(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1450872)|0;d=pL(1450872,e)|0;i=b;return d|0}function H2g(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;Bgh();if(!b){RI(2963920)|0;g=qL(2963920)|0;Iag(g,c[886916]|0);Vxh(g)}else{rn[c[(c[f>>2]|0)+4>>2]&127](0,b,0,d,e,0);i=a;return}}function I2g(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;a=i;Cgh();if(!b){RI(2963920)|0;j=qL(2963920)|0;Iag(j,c[886920]|0);Vxh(j)}if((e|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886922]|0);Vxh(j)}if((f|0)<=-1){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886924]|0);Vxh(j)}if(((c[b+12>>2]|0)-e|0)<(f|0)){RI(2965048)|0;k=qL(2965048)|0;oig(k);Vxh(k)}j=(d|0)==0;if(!j?((c[d+12>>2]|0)-f|0)<(e|0):0){RI(2965048)|0;k=qL(2965048)|0;oig(k);Vxh(k)}if((f|0)<=1){i=a;return}if(!g){if(j)l=0;else l=_n[c[(c[h>>2]|0)+4>>2]&4095](0,d)|0;RI(1173448)|0;if(vL(b,1173448)|0){RI(1173448)|0;REf(0,vL(b,1173448)|0,e,f,l);i=a;return}RI(1101728)|0;if(vL(b,1101728)|0){RI(1101728)|0;SEf(0,vL(b,1101728)|0,e,f,l);i=a;return}RI(1136088)|0;if(vL(b,1136088)|0){RI(1136088)|0;TEf(0,vL(b,1136088)|0,e,f,l);i=a;return}}rn[c[(c[h+8>>2]|0)+4>>2]&127](0,b,d,e,e+-1+f|0,g);i=a;return}function J2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;a=i;i=i+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;RI(1101728)|0;if(vL(b,1101728)|0){RI(2618256)|0;h=qL(2618256)|0;c[e>>2]=2619776;c[d+0>>2]=c[e+0>>2];lDf(h,b,d);j=h;i=a;return j|0}RI(1173448)|0;h=(vL(b,1173448)|0)==0;RI(2618256)|0;e=qL(2618256)|0;if(h){c[g>>2]=2619944;c[d+0>>2]=c[g+0>>2];lDf(e,b,d);j=e;i=a;return j|0}else{c[f>>2]=2619832;c[d+0>>2]=c[f+0>>2];lDf(e,b,d);j=e;i=a;return j|0}return 0}function K2g(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;a=i;if((f|0)<=(e|0)){i=a;return}j=b+16|0;k=c[j+(da(c[(c[b>>2]|0)+120>>2]|0,((f-e|0)/2|0)+e|0)|0)>>2]|0;l=h+4|0;m=e;n=f;while(1){a:do if((m|0)<(f|0)){o=m;while(1){p=c[j+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]|0;q=o+1|0;if((kn[c[(c[h>>2]|0)+4>>2]&511](0,p,k,g)|0)>=0){r=0;s=o;break a}if((q|0)<(f|0))o=q;else{r=1;s=q;break}}}else{r=1;s=m}while(0);b:do if((n|0)>(e|0)){o=n;while(1){q=c[j+(da(c[(c[b>>2]|0)+120>>2]|0,o)|0)>>2]|0;p=o+-1|0;if((kn[c[(c[h>>2]|0)+4>>2]&511](0,k,q,g)|0)>=0){t=0;u=o;break b}if((p|0)>(e|0))o=p;else{t=1;u=p;break}}}else{t=1;u=n}while(0);if((s|0)>(u|0))break;En[c[(c[l>>2]|0)+4>>2]&127](0,b,d,s,u);m=s+1|0;n=u+-1|0}if(!t)rn[c[(c[h+8>>2]|0)+4>>2]&127](0,b,d,e,u,g);if(r){i=a;return}rn[c[(c[h+8>>2]|0)+4>>2]&127](0,b,d,s,f,g);i=a;return}function L2g(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;h=b+4|0;j=b;Dgh();if(f){k=hth(c[g>>2]|0,f,d,e)|0;i=b;return k|0}f=(e|0)==0;if(!d){k=(f^1)<<31>>31;i=b;return k|0}if(f){k=1;i=b;return k|0}f=g+8|0;if(vL(d,c[f>>2]|0)|0){l=c[g+12>>2]|0;k=Zqh(l,Wxh(d,c[f>>2]|0)|0,e)|0;i=b;return k|0}RI(2546528)|0;if(vL(d,2546528)|0){RI(2546528)|0;k=Zqh(2546712,Wxh(d,2546528)|0,e)|0;i=b;return k|0}k=tof(0,c[886930]|0)|0;RI(2540728)|0;if(!(a[2540876]|0)){RI(2540728)|0;Xxh(2540728)}c[j>>2]=c[g+16>>2];c[h+0>>2]=c[j+0>>2];j=npf(0,h)|0;if(a[2540708]|0){m=_vf(0,k,j)|0;RI(3084976)|0;n=qL(3084976)|0;osg(n,m);Vxh(n)}Xxh(2540560);m=_vf(0,k,j)|0;RI(3084976)|0;n=qL(3084976)|0;osg(n,m);Vxh(n);return 0}function M2g(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;g=b+16|0;h=c[(c[b>>2]|0)+120>>2]|0;j=g+(da(h,e)|0)|0;k=c[j>>2]|0;c[j>>2]=c[g+(da(h,f)|0)>>2];c[g+(da(c[(c[b>>2]|0)+120>>2]|0,f)|0)>>2]=k;if(!d){i=a;return}k=d+16|0;b=c[(c[d>>2]|0)+120>>2]|0;g=k+(da(b,e)|0)|0;e=c[g>>2]|0;c[g>>2]=c[k+(da(b,f)|0)>>2];c[k+(da(c[(c[d>>2]|0)+120>>2]|0,f)|0)>>2]=e;i=a;return}function N2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=a;c[f>>2]=0;c[f+4>>2]=0;Qfh();if((PCf(b)|0)>(d|0)){f=c[(c[b>>2]|0)+120>>2]|0;YEi(a|0,b+16+(da(f,d)|0)|0,f|0)|0;i=e;return}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}}function O2g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function P2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Lfh();if((sDf(a)|0)>=2){j=tof(0,c[885928]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;if((k|0)<=0){l=0;i=d;return l|0}j=a+16|0;m=0;while(1){n=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(n,m)|0)|0,n|0)|0;n=b;o=c[n+4>>2]|0;p=f;c[p>>2]=c[n>>2];c[p+4>>2]=o;RI(2729920)|0;if(!(pL(2729920,f)|0)){q=5;break}o=e;p=c[o+4>>2]|0;n=h;c[n>>2]=c[o>>2];c[n+4>>2]=p;RI(2729920)|0;p=pL(2729920,h)|0;RI(2729920)|0;m=m+1|0;if(nrh(2536048,pL(2729920,b)|0,p)|0){l=1;q=9;break}if((m|0)>=(k|0)){l=0;q=9;break}}if((q|0)==5){k=e;e=c[k+4>>2]|0;m=g;c[m>>2]=c[k>>2];c[m+4>>2]=e;RI(2729920)|0;l=(pL(2729920,g)|0)==0;i=d;return l|0}else if((q|0)==9){i=d;return l|0}return 0}function Q2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function R2g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function S2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;h=d;j=e;c[j>>2]=0;c[j+4>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=b;m=c[l>>2]|0;n=c[l+4>>2]|0;l=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(o,l)|0)|0,o|0)|0;o=f;c[o>>2]=m;c[o+4>>2]=n;RI(2729920)|0;if(!(pL(2729920,f)|0)){p=l;break}o=h;c[o>>2]=m;c[o+4>>2]=n;RI(2729920)|0;o=pL(2729920,h)|0;RI(2729920)|0;if(nrh(2536048,pL(2729920,e)|0,o)|0){q=l;r=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((r|0)==9){s=(xDf(a,0)|0)+q|0;i=d;return s|0}l=e;n=c[l+4>>2]|0;m=g;c[m>>2]=c[l>>2];c[m+4>>2]=n;RI(2729920)|0;n=(pL(2729920,g)|0)==0;m=xDf(a,0)|0;if(n){s=m+p|0;i=d;return s|0}else{s=m+-1|0;i=d;return s|0}}while(0);s=(xDf(a,0)|0)+-1|0;i=d;return s|0}function T2g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function U2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;g=qL(2964880)|0;wdg(g,c[886022]|0);Vxh(g)}RI(1086352)|0;g=vL(a,1086352)|0;if(!g){h=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(h,b)|0)|0,d|0,h|0)|0;i=e;return}else{h=d;d=c[h+4>>2]|0;a=f;c[a>>2]=c[h>>2];c[a+4>>2]=d;RI(2729920)|0;d=pL(2729920,f)|0;Qqh(g,d);c[g+16+(da(c[(c[g>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function V2g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Nze(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1453712)|0;d=pL(1453712,e)|0;i=b;return d|0}function W2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function X2g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Y2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2730736)|0;o=(pL(2730736,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2730736)|0;p=pL(2730736,j)|0;RI(2730736)|0;o=b+1|0;if(nrh(2536048,pL(2730736,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2730736)|0;m=(pL(2730736,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Z2g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function _2g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function $2g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2730736)|0;if(!(pL(2730736,f)|0)){n=l;break}c[h>>2]=b;RI(2730736)|0;m=pL(2730736,h)|0;RI(2730736)|0;if(nrh(2536048,pL(2730736,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2730736)|0;l=(pL(2730736,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function a3g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function b3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2730736)|0;d=pL(2730736,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function c3g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Sze(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1456264)|0;d=pL(1456264,e)|0;i=b;return d|0}function d3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function e3g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function f3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2741840)|0;o=(pL(2741840,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2741840)|0;p=pL(2741840,j)|0;RI(2741840)|0;o=b+1|0;if(nrh(2536048,pL(2741840,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2741840)|0;m=(pL(2741840,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function g3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function h3g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function i3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2741840)|0;if(!(pL(2741840,f)|0)){n=l;break}c[h>>2]=b;RI(2741840)|0;m=pL(2741840,h)|0;RI(2741840)|0;if(nrh(2536048,pL(2741840,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2741840)|0;l=(pL(2741840,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function j3g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function k3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2741840)|0;d=pL(2741840,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function l3g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;Xze(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1458816)|0;d=pL(1458816,e)|0;i=b;return d|0}function m3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function n3g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function o3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2742360)|0;o=(pL(2742360,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2742360)|0;p=pL(2742360,j)|0;RI(2742360)|0;o=b+1|0;if(nrh(2536048,pL(2742360,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2742360)|0;m=(pL(2742360,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function p3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function q3g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function r3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2742360)|0;if(!(pL(2742360,f)|0)){n=l;break}c[h>>2]=b;RI(2742360)|0;m=pL(2742360,h)|0;RI(2742360)|0;if(nrh(2536048,pL(2742360,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2742360)|0;l=(pL(2742360,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function s3g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function t3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2742360)|0;d=pL(2742360,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function u3g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;aAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1461368)|0;d=pL(1461368,e)|0;i=b;return d|0}function v3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function w3g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function x3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2742896)|0;o=(pL(2742896,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2742896)|0;p=pL(2742896,j)|0;RI(2742896)|0;o=b+1|0;if(nrh(2536048,pL(2742896,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2742896)|0;m=(pL(2742896,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function y3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function z3g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function A3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2742896)|0;if(!(pL(2742896,f)|0)){n=l;break}c[h>>2]=b;RI(2742896)|0;m=pL(2742896,h)|0;RI(2742896)|0;if(nrh(2536048,pL(2742896,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2742896)|0;l=(pL(2742896,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function B3g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function C3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2742896)|0;d=pL(2742896,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function D3g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;fAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1466472)|0;d=pL(1466472,e)|0;i=b;return d|0}function E3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function F3g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function G3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2694720)|0;o=(pL(2694720,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2694720)|0;p=pL(2694720,j)|0;RI(2694720)|0;o=b+1|0;if(nrh(2536048,pL(2694720,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2694720)|0;m=(pL(2694720,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function H3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function I3g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function J3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2694720)|0;if(!(pL(2694720,f)|0)){n=l;break}c[h>>2]=b;RI(2694720)|0;m=pL(2694720,h)|0;RI(2694720)|0;if(nrh(2536048,pL(2694720,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2694720)|0;l=(pL(2694720,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function K3g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function L3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2694720)|0;d=pL(2694720,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function M3g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;kAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1481608)|0;d=pL(1481608,e)|0;i=b;return d|0}function N3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function O3g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function P3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2761136)|0;o=(pL(2761136,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2761136)|0;p=pL(2761136,j)|0;RI(2761136)|0;o=b+1|0;if(nrh(2536048,pL(2761136,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2761136)|0;m=(pL(2761136,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Q3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function R3g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function S3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2761136)|0;if(!(pL(2761136,f)|0)){n=l;break}c[h>>2]=b;RI(2761136)|0;m=pL(2761136,h)|0;RI(2761136)|0;if(nrh(2536048,pL(2761136,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2761136)|0;l=(pL(2761136,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function T3g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function U3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2761136)|0;d=pL(2761136,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function V3g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;pAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1486712)|0;d=pL(1486712,e)|0;i=b;return d|0}function W3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function X3g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Y3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2768376)|0;o=(pL(2768376,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2768376)|0;p=pL(2768376,j)|0;RI(2768376)|0;o=b+1|0;if(nrh(2536048,pL(2768376,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2768376)|0;m=(pL(2768376,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Z3g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function _3g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function $3g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2768376)|0;if(!(pL(2768376,f)|0)){n=l;break}c[h>>2]=b;RI(2768376)|0;m=pL(2768376,h)|0;RI(2768376)|0;if(nrh(2536048,pL(2768376,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2768376)|0;l=(pL(2768376,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function a4g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function b4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2768376)|0;d=pL(2768376,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function c4g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;uAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1489264)|0;d=pL(1489264,e)|0;i=b;return d|0}function d4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function e4g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function f4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2770776)|0;o=(pL(2770776,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2770776)|0;p=pL(2770776,j)|0;RI(2770776)|0;o=b+1|0;if(nrh(2536048,pL(2770776,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2770776)|0;m=(pL(2770776,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function g4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function h4g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function i4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2770776)|0;if(!(pL(2770776,f)|0)){n=l;break}c[h>>2]=b;RI(2770776)|0;m=pL(2770776,h)|0;RI(2770776)|0;if(nrh(2536048,pL(2770776,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2770776)|0;l=(pL(2770776,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function j4g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function k4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2770776)|0;d=pL(2770776,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function l4g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;zAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1491816)|0;d=pL(1491816,e)|0;i=b;return d|0}function m4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function n4g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function o4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2776480)|0;o=(pL(2776480,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2776480)|0;p=pL(2776480,j)|0;RI(2776480)|0;o=b+1|0;if(nrh(2536048,pL(2776480,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2776480)|0;m=(pL(2776480,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function p4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function q4g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function r4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2776480)|0;if(!(pL(2776480,f)|0)){n=l;break}c[h>>2]=b;RI(2776480)|0;m=pL(2776480,h)|0;RI(2776480)|0;if(nrh(2536048,pL(2776480,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2776480)|0;l=(pL(2776480,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function s4g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function t4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2776480)|0;d=pL(2776480,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function u4g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;EAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1494368)|0;d=pL(1494368,e)|0;i=b;return d|0}function v4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function w4g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function x4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2778984)|0;o=(pL(2778984,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2778984)|0;p=pL(2778984,j)|0;RI(2778984)|0;o=b+1|0;if(nrh(2536048,pL(2778984,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2778984)|0;m=(pL(2778984,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function y4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function z4g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function A4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2778984)|0;if(!(pL(2778984,f)|0)){n=l;break}c[h>>2]=b;RI(2778984)|0;m=pL(2778984,h)|0;RI(2778984)|0;if(nrh(2536048,pL(2778984,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2778984)|0;l=(pL(2778984,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function B4g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function C4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2778984)|0;d=pL(2778984,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function D4g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;JAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1496920)|0;d=pL(1496920,e)|0;i=b;return d|0}function E4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function F4g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function G4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2781760)|0;o=(pL(2781760,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2781760)|0;p=pL(2781760,j)|0;RI(2781760)|0;o=b+1|0;if(nrh(2536048,pL(2781760,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2781760)|0;m=(pL(2781760,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function H4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function I4g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function J4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2781760)|0;if(!(pL(2781760,f)|0)){n=l;break}c[h>>2]=b;RI(2781760)|0;m=pL(2781760,h)|0;RI(2781760)|0;if(nrh(2536048,pL(2781760,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2781760)|0;l=(pL(2781760,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function K4g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function L4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2781760)|0;d=pL(2781760,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function M4g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;OAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1499472)|0;d=pL(1499472,e)|0;i=b;return d|0}function N4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function O4g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function P4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2782256)|0;o=(pL(2782256,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2782256)|0;p=pL(2782256,j)|0;RI(2782256)|0;o=b+1|0;if(nrh(2536048,pL(2782256,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2782256)|0;m=(pL(2782256,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Q4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function R4g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function S4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2782256)|0;if(!(pL(2782256,f)|0)){n=l;break}c[h>>2]=b;RI(2782256)|0;m=pL(2782256,h)|0;RI(2782256)|0;if(nrh(2536048,pL(2782256,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2782256)|0;l=(pL(2782256,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function T4g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function U4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2782256)|0;d=pL(2782256,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function V4g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;TAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1502024)|0;d=pL(1502024,e)|0;i=b;return d|0}function W4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function X4g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Y4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2789408)|0;o=(pL(2789408,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2789408)|0;p=pL(2789408,j)|0;RI(2789408)|0;o=b+1|0;if(nrh(2536048,pL(2789408,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2789408)|0;m=(pL(2789408,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Z4g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function _4g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function $4g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2789408)|0;if(!(pL(2789408,f)|0)){n=l;break}c[h>>2]=b;RI(2789408)|0;m=pL(2789408,h)|0;RI(2789408)|0;if(nrh(2536048,pL(2789408,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2789408)|0;l=(pL(2789408,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function a5g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function b5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2789408)|0;d=pL(2789408,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function c5g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;YAe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1504576)|0;d=pL(1504576,e)|0;i=b;return d|0}function d5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function e5g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function f5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2790128)|0;o=(pL(2790128,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2790128)|0;p=pL(2790128,j)|0;RI(2790128)|0;o=b+1|0;if(nrh(2536048,pL(2790128,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2790128)|0;m=(pL(2790128,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function g5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function h5g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function i5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2790128)|0;if(!(pL(2790128,f)|0)){n=l;break}c[h>>2]=b;RI(2790128)|0;m=pL(2790128,h)|0;RI(2790128)|0;if(nrh(2536048,pL(2790128,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2790128)|0;l=(pL(2790128,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function j5g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function k5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2790128)|0;d=pL(2790128,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function l5g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;bBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1507128)|0;d=pL(1507128,e)|0;i=b;return d|0}function m5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function n5g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function o5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2805992)|0;o=(pL(2805992,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2805992)|0;p=pL(2805992,j)|0;RI(2805992)|0;o=b+1|0;if(nrh(2536048,pL(2805992,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2805992)|0;m=(pL(2805992,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function p5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function q5g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function r5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2805992)|0;if(!(pL(2805992,f)|0)){n=l;break}c[h>>2]=b;RI(2805992)|0;m=pL(2805992,h)|0;RI(2805992)|0;if(nrh(2536048,pL(2805992,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2805992)|0;l=(pL(2805992,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function s5g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function t5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2805992)|0;d=pL(2805992,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function u5g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;gBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1509680)|0;d=pL(1509680,e)|0;i=b;return d|0}function v5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function w5g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function x5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2846960)|0;o=(pL(2846960,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2846960)|0;p=pL(2846960,j)|0;RI(2846960)|0;o=b+1|0;if(nrh(2536048,pL(2846960,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2846960)|0;m=(pL(2846960,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function y5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function z5g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function A5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2846960)|0;if(!(pL(2846960,f)|0)){n=l;break}c[h>>2]=b;RI(2846960)|0;m=pL(2846960,h)|0;RI(2846960)|0;if(nrh(2536048,pL(2846960,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2846960)|0;l=(pL(2846960,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function B5g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function C5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2846960)|0;d=pL(2846960,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function D5g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;lBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1563120)|0;d=pL(1563120,e)|0;i=b;return d|0}function E5g(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;Igh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[887004]|0);Vxh(f)}else{f=Bn[c[(c[e>>2]|0)+4>>2]&255](0,b,d,0,c[b+12>>2]|0)|0;i=a;return f|0}return 0}function F5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function G5g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function H5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2853040)|0;o=(pL(2853040,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2853040)|0;p=pL(2853040,j)|0;RI(2853040)|0;o=b+1|0;if(nrh(2536048,pL(2853040,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2853040)|0;m=(pL(2853040,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function I5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function J5g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function K5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2853040)|0;if(!(pL(2853040,f)|0)){n=l;break}c[h>>2]=b;RI(2853040)|0;m=pL(2853040,h)|0;RI(2853040)|0;if(nrh(2536048,pL(2853040,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2853040)|0;l=(pL(2853040,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function L5g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function M5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2853040)|0;d=pL(2853040,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function N5g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;qBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1575880)|0;d=pL(1575880,e)|0;i=b;return d|0}function O5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function P5g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Q5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2854312)|0;o=(pL(2854312,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2854312)|0;p=pL(2854312,j)|0;RI(2854312)|0;o=b+1|0;if(nrh(2536048,pL(2854312,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2854312)|0;m=(pL(2854312,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function R5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function S5g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function T5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2854312)|0;if(!(pL(2854312,f)|0)){n=l;break}c[h>>2]=b;RI(2854312)|0;m=pL(2854312,h)|0;RI(2854312)|0;if(nrh(2536048,pL(2854312,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2854312)|0;l=(pL(2854312,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function U5g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function V5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2854312)|0;d=pL(2854312,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function W5g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;vBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1580832)|0;d=pL(1580832,e)|0;i=b;return d|0}function X5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function Y5g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Z5g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2855816)|0;o=(pL(2855816,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2855816)|0;p=pL(2855816,j)|0;RI(2855816)|0;o=b+1|0;if(nrh(2536048,pL(2855816,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2855816)|0;m=(pL(2855816,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function _5g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function $5g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function a6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2855816)|0;if(!(pL(2855816,f)|0)){n=l;break}c[h>>2]=b;RI(2855816)|0;m=pL(2855816,h)|0;RI(2855816)|0;if(nrh(2536048,pL(2855816,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2855816)|0;l=(pL(2855816,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function b6g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function c6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2855816)|0;d=pL(2855816,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function d6g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;ABe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1583384)|0;d=pL(1583384,e)|0;i=b;return d|0}function e6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function f6g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function g6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2857696)|0;o=(pL(2857696,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2857696)|0;p=pL(2857696,j)|0;RI(2857696)|0;o=b+1|0;if(nrh(2536048,pL(2857696,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2857696)|0;m=(pL(2857696,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function h6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function i6g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function j6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2857696)|0;if(!(pL(2857696,f)|0)){n=l;break}c[h>>2]=b;RI(2857696)|0;m=pL(2857696,h)|0;RI(2857696)|0;if(nrh(2536048,pL(2857696,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2857696)|0;l=(pL(2857696,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function k6g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function l6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2857696)|0;d=pL(2857696,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function m6g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;FBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1585936)|0;d=pL(1585936,e)|0;i=b;return d|0}function n6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function o6g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function p6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2860944)|0;o=(pL(2860944,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2860944)|0;p=pL(2860944,j)|0;RI(2860944)|0;o=b+1|0;if(nrh(2536048,pL(2860944,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2860944)|0;m=(pL(2860944,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function q6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function r6g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function s6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2860944)|0;if(!(pL(2860944,f)|0)){n=l;break}c[h>>2]=b;RI(2860944)|0;m=pL(2860944,h)|0;RI(2860944)|0;if(nrh(2536048,pL(2860944,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2860944)|0;l=(pL(2860944,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function t6g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function u6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2860944)|0;d=pL(2860944,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function v6g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;KBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1588488)|0;d=pL(1588488,e)|0;i=b;return d|0}function w6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function x6g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function y6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2861632)|0;o=(pL(2861632,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2861632)|0;p=pL(2861632,j)|0;RI(2861632)|0;o=b+1|0;if(nrh(2536048,pL(2861632,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2861632)|0;m=(pL(2861632,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function z6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function A6g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function B6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2861632)|0;if(!(pL(2861632,f)|0)){n=l;break}c[h>>2]=b;RI(2861632)|0;m=pL(2861632,h)|0;RI(2861632)|0;if(nrh(2536048,pL(2861632,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2861632)|0;l=(pL(2861632,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function C6g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function D6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2861632)|0;d=pL(2861632,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function E6g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;PBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1591040)|0;d=pL(1591040,e)|0;i=b;return d|0}function F6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function G6g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function H6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2865352)|0;o=(pL(2865352,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2865352)|0;p=pL(2865352,j)|0;RI(2865352)|0;o=b+1|0;if(nrh(2536048,pL(2865352,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2865352)|0;m=(pL(2865352,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function I6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function J6g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function K6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2865352)|0;if(!(pL(2865352,f)|0)){n=l;break}c[h>>2]=b;RI(2865352)|0;m=pL(2865352,h)|0;RI(2865352)|0;if(nrh(2536048,pL(2865352,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2865352)|0;l=(pL(2865352,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function L6g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function M6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2865352)|0;d=pL(2865352,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function N6g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;UBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1593592)|0;d=pL(1593592,e)|0;i=b;return d|0}function O6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function P6g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Q6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2881760)|0;o=(pL(2881760,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2881760)|0;p=pL(2881760,j)|0;RI(2881760)|0;o=b+1|0;if(nrh(2536048,pL(2881760,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2881760)|0;m=(pL(2881760,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function R6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function S6g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function T6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2881760)|0;if(!(pL(2881760,f)|0)){n=l;break}c[h>>2]=b;RI(2881760)|0;m=pL(2881760,h)|0;RI(2881760)|0;if(nrh(2536048,pL(2881760,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2881760)|0;l=(pL(2881760,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function U6g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function V6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2881760)|0;d=pL(2881760,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function W6g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;ZBe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1596144)|0;d=pL(1596144,e)|0;i=b;return d|0}function X6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function Y6g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Z6g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2884776)|0;o=(pL(2884776,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2884776)|0;p=pL(2884776,j)|0;RI(2884776)|0;o=b+1|0;if(nrh(2536048,pL(2884776,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2884776)|0;m=(pL(2884776,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function _6g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function $6g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function a7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2884776)|0;if(!(pL(2884776,f)|0)){n=l;break}c[h>>2]=b;RI(2884776)|0;m=pL(2884776,h)|0;RI(2884776)|0;if(nrh(2536048,pL(2884776,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2884776)|0;l=(pL(2884776,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function b7g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function c7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2884776)|0;d=pL(2884776,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function d7g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;cCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1598696)|0;d=pL(1598696,e)|0;i=b;return d|0}function e7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function f7g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function g7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2887376)|0;o=(pL(2887376,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2887376)|0;p=pL(2887376,j)|0;RI(2887376)|0;o=b+1|0;if(nrh(2536048,pL(2887376,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2887376)|0;m=(pL(2887376,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function h7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function i7g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function j7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2887376)|0;if(!(pL(2887376,f)|0)){n=l;break}c[h>>2]=b;RI(2887376)|0;m=pL(2887376,h)|0;RI(2887376)|0;if(nrh(2536048,pL(2887376,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2887376)|0;l=(pL(2887376,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function k7g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function l7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2887376)|0;d=pL(2887376,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function m7g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;hCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1601248)|0;d=pL(1601248,e)|0;i=b;return d|0}function n7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function o7g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function p7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2889800)|0;o=(pL(2889800,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2889800)|0;p=pL(2889800,j)|0;RI(2889800)|0;o=b+1|0;if(nrh(2536048,pL(2889800,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2889800)|0;m=(pL(2889800,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function q7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function r7g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function s7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2889800)|0;if(!(pL(2889800,f)|0)){n=l;break}c[h>>2]=b;RI(2889800)|0;m=pL(2889800,h)|0;RI(2889800)|0;if(nrh(2536048,pL(2889800,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2889800)|0;l=(pL(2889800,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function t7g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function u7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2889800)|0;d=pL(2889800,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function v7g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;mCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1603800)|0;d=pL(1603800,e)|0;i=b;return d|0}function w7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function x7g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function y7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2892360)|0;o=(pL(2892360,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2892360)|0;p=pL(2892360,j)|0;RI(2892360)|0;o=b+1|0;if(nrh(2536048,pL(2892360,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2892360)|0;m=(pL(2892360,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function z7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function A7g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function B7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2892360)|0;if(!(pL(2892360,f)|0)){n=l;break}c[h>>2]=b;RI(2892360)|0;m=pL(2892360,h)|0;RI(2892360)|0;if(nrh(2536048,pL(2892360,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2892360)|0;l=(pL(2892360,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function C7g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function D7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2892360)|0;d=pL(2892360,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function E7g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;rCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1611456)|0;d=pL(1611456,e)|0;i=b;return d|0}function F7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function G7g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function H7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2893816)|0;o=(pL(2893816,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2893816)|0;p=pL(2893816,j)|0;RI(2893816)|0;o=b+1|0;if(nrh(2536048,pL(2893816,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2893816)|0;m=(pL(2893816,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function I7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function J7g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function K7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2893816)|0;if(!(pL(2893816,f)|0)){n=l;break}c[h>>2]=b;RI(2893816)|0;m=pL(2893816,h)|0;RI(2893816)|0;if(nrh(2536048,pL(2893816,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2893816)|0;l=(pL(2893816,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function L7g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function M7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2893816)|0;d=pL(2893816,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function N7g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;wCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1619112)|0;d=pL(1619112,e)|0;i=b;return d|0}function O7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function P7g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Q7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2894608)|0;o=(pL(2894608,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2894608)|0;p=pL(2894608,j)|0;RI(2894608)|0;o=b+1|0;if(nrh(2536048,pL(2894608,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2894608)|0;m=(pL(2894608,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function R7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function S7g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function T7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2894608)|0;if(!(pL(2894608,f)|0)){n=l;break}c[h>>2]=b;RI(2894608)|0;m=pL(2894608,h)|0;RI(2894608)|0;if(nrh(2536048,pL(2894608,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2894608)|0;l=(pL(2894608,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function U7g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function V7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2894608)|0;d=pL(2894608,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function W7g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;BCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1624216)|0;d=pL(1624216,e)|0;i=b;return d|0}function X7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Vxh(e)}return 0}function Y7g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Vxh(b)}function Z7g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Vxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2895112)|0;o=(pL(2895112,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2895112)|0;p=pL(2895112,j)|0;RI(2895112)|0;o=b+1|0;if(nrh(2536048,pL(2895112,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2895112)|0;m=(pL(2895112,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function _7g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Vxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Vxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Vxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Vxh(a)}}function $7g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Vxh(b);return 0}function a8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Vxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2895112)|0;if(!(pL(2895112,f)|0)){n=l;break}c[h>>2]=b;RI(2895112)|0;m=pL(2895112,h)|0;RI(2895112)|0;if(nrh(2536048,pL(2895112,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2895112)|0;l=(pL(2895112,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function b8g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Vxh(d)}function c8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Vxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2895112)|0;d=pL(2895112,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function d8g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;GCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1626768)|0;d=pL(1626768,e)|0;i=b;return d|0}function e8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function f8g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function g8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2896984)|0;o=(pL(2896984,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2896984)|0;p=pL(2896984,j)|0;RI(2896984)|0;o=b+1|0;if(nrh(2536048,pL(2896984,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2896984)|0;m=(pL(2896984,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function h8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function i8g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function j8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2896984)|0;if(!(pL(2896984,f)|0)){n=l;break}c[h>>2]=b;RI(2896984)|0;m=pL(2896984,h)|0;RI(2896984)|0;if(nrh(2536048,pL(2896984,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2896984)|0;l=(pL(2896984,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function k8g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function l8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2896984)|0;d=pL(2896984,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function m8g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;LCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1636824)|0;d=pL(1636824,e)|0;i=b;return d|0}function n8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function o8g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function p8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2897704)|0;o=(pL(2897704,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2897704)|0;p=pL(2897704,j)|0;RI(2897704)|0;o=b+1|0;if(nrh(2536048,pL(2897704,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2897704)|0;m=(pL(2897704,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function q8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function r8g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function s8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2897704)|0;if(!(pL(2897704,f)|0)){n=l;break}c[h>>2]=b;RI(2897704)|0;m=pL(2897704,h)|0;RI(2897704)|0;if(nrh(2536048,pL(2897704,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2897704)|0;l=(pL(2897704,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function t8g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function u8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2897704)|0;d=pL(2897704,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function v8g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;QCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1641928)|0;d=pL(1641928,e)|0;i=b;return d|0}function w8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function x8g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function y8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2911832)|0;o=(pL(2911832,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2911832)|0;p=pL(2911832,j)|0;RI(2911832)|0;o=b+1|0;if(nrh(2536048,pL(2911832,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2911832)|0;m=(pL(2911832,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function z8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function A8g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function B8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2911832)|0;if(!(pL(2911832,f)|0)){n=l;break}c[h>>2]=b;RI(2911832)|0;m=pL(2911832,h)|0;RI(2911832)|0;if(nrh(2536048,pL(2911832,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2911832)|0;l=(pL(2911832,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function C8g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function D8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2911832)|0;d=pL(2911832,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function E8g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;VCe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1657240)|0;d=pL(1657240,e)|0;i=b;return d|0}function F8g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;a[f>>0]=0;Qfh();if((PCf(b)|0)>(d|0)){g=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,b+16+(da(g,d)|0)|0,g|0)|0;i=e;return a[f>>0]|0}else{RI(2964880)|0;f=qL(2964880)|0;wdg(f,c[886018]|0);Yxh(f)}return 0}function G8g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function H8g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e+4|0;g=e+3|0;h=e+2|0;j=e+1|0;k=e;a[f>>0]=d;a[g>>0]=0;Lfh();if((sDf(b)|0)>=2){l=tof(0,c[885928]|0)|0;RI(3115536)|0;m=qL(3115536)|0;zwg(m,l);Yxh(m)}m=PCf(b)|0;if((m|0)<=0){n=0;i=e;return n|0}l=b+16|0;o=d;d=0;while(1){p=c[(c[b>>2]|0)+120>>2]|0;YEi(g|0,l+(da(p,d)|0)|0,p|0)|0;a[h>>0]=o;RI(2929064)|0;p=(pL(2929064,h)|0)==0;q=a[g>>0]|0;if(p){r=q;s=5;break}a[k>>0]=q;RI(2929064)|0;q=pL(2929064,k)|0;RI(2929064)|0;p=d+1|0;if(nrh(2536048,pL(2929064,f)|0,q)|0){n=1;s=10;break}if((p|0)>=(m|0)){n=0;s=10;break}o=a[f>>0]|0;d=p}if((s|0)==5){a[j>>0]=r;RI(2929064)|0;n=(pL(2929064,j)|0)==0;i=e;return n|0}else if((s|0)==10){i=e;return n|0}return 0}function I8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function J8g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function K8g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+3|0;g=e+2|0;h=e+1|0;j=e;a[f>>0]=0;Pfh();if((sDf(b)|0)>=2){k=tof(0,c[886014]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(b)|0;a:do if((l|0)>0){k=b+16|0;m=0;while(1){n=c[(c[b>>2]|0)+120>>2]|0;YEi(f|0,k+(da(n,m)|0)|0,n|0)|0;a[g>>0]=d;RI(2929064)|0;if(!(pL(2929064,g)|0)){o=m;break}a[j>>0]=d;RI(2929064)|0;n=pL(2929064,j)|0;RI(2929064)|0;if(nrh(2536048,pL(2929064,f)|0,n)|0){p=m;q=9;break}m=m+1|0;if((m|0)>=(l|0))break a}if((q|0)==9){r=(xDf(b,0)|0)+p|0;i=e;return r|0}a[h>>0]=a[f>>0]|0;RI(2929064)|0;m=(pL(2929064,h)|0)==0;k=xDf(b,0)|0;if(m){r=k+o|0;i=e;return r|0}else{r=k+-1|0;i=e;return r|0}}while(0);r=(xDf(b,0)|0)+-1|0;i=e;return r|0}function L8g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function M8g(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+1|0;h=f;a[g>>0]=e;Rfh();if((PCf(b)|0)<=(d|0)){RI(2964880)|0;j=qL(2964880)|0;wdg(j,c[886022]|0);Yxh(j)}RI(1086352)|0;j=vL(b,1086352)|0;if(!j){k=c[(c[b>>2]|0)+120>>2]|0;YEi(b+16+(da(k,d)|0)|0,g|0,k|0)|0;i=f;return}else{a[h>>0]=e;RI(2929064)|0;e=pL(2929064,h)|0;Qqh(j,e);c[j+16+(da(c[(c[j>>2]|0)+120>>2]|0,d)|0)>>2]=e;i=f;return}}function N8g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;_Ce(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(167e4)|0;d=pL(167e4,e)|0;i=b;return d|0}function O8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function P8g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Q8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2951152)|0;o=(pL(2951152,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2951152)|0;p=pL(2951152,j)|0;RI(2951152)|0;o=b+1|0;if(nrh(2536048,pL(2951152,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2951152)|0;m=(pL(2951152,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function R8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function S8g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function T8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2951152)|0;if(!(pL(2951152,f)|0)){n=l;break}c[h>>2]=b;RI(2951152)|0;m=pL(2951152,h)|0;RI(2951152)|0;if(nrh(2536048,pL(2951152,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2951152)|0;l=(pL(2951152,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function U8g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function V8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2951152)|0;d=pL(2951152,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function W8g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;dDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1675104)|0;d=pL(1675104,e)|0;i=b;return d|0}function X8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function Y8g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Z8g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2952200)|0;o=(pL(2952200,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2952200)|0;p=pL(2952200,j)|0;RI(2952200)|0;o=b+1|0;if(nrh(2536048,pL(2952200,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2952200)|0;m=(pL(2952200,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function _8g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function $8g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function a9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2952200)|0;if(!(pL(2952200,f)|0)){n=l;break}c[h>>2]=b;RI(2952200)|0;m=pL(2952200,h)|0;RI(2952200)|0;if(nrh(2536048,pL(2952200,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2952200)|0;l=(pL(2952200,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function b9g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function c9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2952200)|0;d=pL(2952200,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function d9g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;iDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1677656)|0;d=pL(1677656,e)|0;i=b;return d|0}function e9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function f9g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function g9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2952704)|0;o=(pL(2952704,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2952704)|0;p=pL(2952704,j)|0;RI(2952704)|0;o=b+1|0;if(nrh(2536048,pL(2952704,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2952704)|0;m=(pL(2952704,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function h9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function i9g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function j9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2952704)|0;if(!(pL(2952704,f)|0)){n=l;break}c[h>>2]=b;RI(2952704)|0;m=pL(2952704,h)|0;RI(2952704)|0;if(nrh(2536048,pL(2952704,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2952704)|0;l=(pL(2952704,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function k9g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function l9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2952704)|0;d=pL(2952704,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function m9g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;nDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1680208)|0;d=pL(1680208,e)|0;i=b;return d|0}function n9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function o9g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function p9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2953232)|0;o=(pL(2953232,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2953232)|0;p=pL(2953232,j)|0;RI(2953232)|0;o=b+1|0;if(nrh(2536048,pL(2953232,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2953232)|0;m=(pL(2953232,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function q9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function r9g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function s9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2953232)|0;if(!(pL(2953232,f)|0)){n=l;break}c[h>>2]=b;RI(2953232)|0;m=pL(2953232,h)|0;RI(2953232)|0;if(nrh(2536048,pL(2953232,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2953232)|0;l=(pL(2953232,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function t9g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function u9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2953232)|0;d=pL(2953232,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function v9g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;sDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1682760)|0;d=pL(1682760,e)|0;i=b;return d|0}function w9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function x9g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function y9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2957696)|0;o=(pL(2957696,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2957696)|0;p=pL(2957696,j)|0;RI(2957696)|0;o=b+1|0;if(nrh(2536048,pL(2957696,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2957696)|0;m=(pL(2957696,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function z9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function A9g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function B9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2957696)|0;if(!(pL(2957696,f)|0)){n=l;break}c[h>>2]=b;RI(2957696)|0;m=pL(2957696,h)|0;RI(2957696)|0;if(nrh(2536048,pL(2957696,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2957696)|0;l=(pL(2957696,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function C9g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function D9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2957696)|0;d=pL(2957696,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function E9g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;xDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1687712)|0;d=pL(1687712,e)|0;i=b;return d|0}function F9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function G9g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function H9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(2972984)|0;o=(pL(2972984,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(2972984)|0;p=pL(2972984,j)|0;RI(2972984)|0;o=b+1|0;if(nrh(2536048,pL(2972984,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(2972984)|0;m=(pL(2972984,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function I9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function J9g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function K9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(2972984)|0;if(!(pL(2972984,f)|0)){n=l;break}c[h>>2]=b;RI(2972984)|0;m=pL(2972984,h)|0;RI(2972984)|0;if(nrh(2536048,pL(2972984,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(2972984)|0;l=(pL(2972984,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function L9g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function M9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(2972984)|0;d=pL(2972984,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function N9g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;CDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1690264)|0;d=pL(1690264,e)|0;i=b;return d|0}function O9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function P9g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Q9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3009344)|0;o=(pL(3009344,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3009344)|0;p=pL(3009344,j)|0;RI(3009344)|0;o=b+1|0;if(nrh(2536048,pL(3009344,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3009344)|0;m=(pL(3009344,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function R9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function S9g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function T9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3009344)|0;if(!(pL(3009344,f)|0)){n=l;break}c[h>>2]=b;RI(3009344)|0;m=pL(3009344,h)|0;RI(3009344)|0;if(nrh(2536048,pL(3009344,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3009344)|0;l=(pL(3009344,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function U9g(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function V9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3009344)|0;d=pL(3009344,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function W9g(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;HDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1700472)|0;d=pL(1700472,e)|0;i=b;return d|0}function X9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function Y9g(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Z9g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3018040)|0;o=(pL(3018040,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3018040)|0;p=pL(3018040,j)|0;RI(3018040)|0;o=b+1|0;if(nrh(2536048,pL(3018040,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3018040)|0;m=(pL(3018040,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function _9g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function $9g(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function aah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3018040)|0;if(!(pL(3018040,f)|0)){n=l;break}c[h>>2]=b;RI(3018040)|0;m=pL(3018040,h)|0;RI(3018040)|0;if(nrh(2536048,pL(3018040,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3018040)|0;l=(pL(3018040,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function bah(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function cah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3018040)|0;d=pL(3018040,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function dah(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;MDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1703024)|0;d=pL(1703024,e)|0;i=b;return d|0}function eah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function fah(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function gah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3029240)|0;o=(pL(3029240,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3029240)|0;p=pL(3029240,j)|0;RI(3029240)|0;o=b+1|0;if(nrh(2536048,pL(3029240,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3029240)|0;m=(pL(3029240,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function hah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function iah(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function jah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3029240)|0;if(!(pL(3029240,f)|0)){n=l;break}c[h>>2]=b;RI(3029240)|0;m=pL(3029240,h)|0;RI(3029240)|0;if(nrh(2536048,pL(3029240,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3029240)|0;l=(pL(3029240,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function kah(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function lah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3029240)|0;d=pL(3029240,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function mah(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;RDe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1705576)|0;d=pL(1705576,e)|0;i=b;return d|0}function nah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function oah(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function pah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3053640)|0;o=(pL(3053640,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3053640)|0;p=pL(3053640,j)|0;RI(3053640)|0;o=b+1|0;if(nrh(2536048,pL(3053640,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3053640)|0;m=(pL(3053640,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function qah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function rah(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function sah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3053640)|0;if(!(pL(3053640,f)|0)){n=l;break}c[h>>2]=b;RI(3053640)|0;m=pL(3053640,h)|0;RI(3053640)|0;if(nrh(2536048,pL(3053640,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3053640)|0;l=(pL(3053640,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function tah(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function uah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3053640)|0;d=pL(3053640,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function vah(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;nEe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1712976)|0;d=pL(1712976,e)|0;i=b;return d|0}function wah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function xah(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function yah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3062088)|0;o=(pL(3062088,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3062088)|0;p=pL(3062088,j)|0;RI(3062088)|0;o=b+1|0;if(nrh(2536048,pL(3062088,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3062088)|0;m=(pL(3062088,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function zah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function Aah(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function Bah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3062088)|0;if(!(pL(3062088,f)|0)){n=l;break}c[h>>2]=b;RI(3062088)|0;m=pL(3062088,h)|0;RI(3062088)|0;if(nrh(2536048,pL(3062088,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3062088)|0;l=(pL(3062088,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function Cah(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function Dah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3062088)|0;d=pL(3062088,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function Eah(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;sEe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1715528)|0;d=pL(1715528,e)|0;i=b;return d|0}function Fah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function Gah(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Hah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3065280)|0;o=(pL(3065280,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3065280)|0;p=pL(3065280,j)|0;RI(3065280)|0;o=b+1|0;if(nrh(2536048,pL(3065280,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3065280)|0;m=(pL(3065280,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Iah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function Jah(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function Kah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3065280)|0;if(!(pL(3065280,f)|0)){n=l;break}c[h>>2]=b;RI(3065280)|0;m=pL(3065280,h)|0;RI(3065280)|0;if(nrh(2536048,pL(3065280,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3065280)|0;l=(pL(3065280,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function Lah(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function Mah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3065280)|0;d=pL(3065280,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function Nah(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;XEe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1723752)|0;d=pL(1723752,e)|0;i=b;return d|0}function Oah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function Pah(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Qah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3085560)|0;o=(pL(3085560,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3085560)|0;p=pL(3085560,j)|0;RI(3085560)|0;o=b+1|0;if(nrh(2536048,pL(3085560,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3085560)|0;m=(pL(3085560,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function Rah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function Sah(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function Tah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3085560)|0;if(!(pL(3085560,f)|0)){n=l;break}c[h>>2]=b;RI(3085560)|0;m=pL(3085560,h)|0;RI(3085560)|0;if(nrh(2536048,pL(3085560,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3085560)|0;l=(pL(3085560,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function Uah(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function Vah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3085560)|0;d=pL(3085560,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function Wah(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;tFe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1734856)|0;d=pL(1734856,e)|0;i=b;return d|0}function Xah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function Yah(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function Zah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3113544)|0;o=(pL(3113544,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3113544)|0;p=pL(3113544,j)|0;RI(3113544)|0;o=b+1|0;if(nrh(2536048,pL(3113544,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3113544)|0;m=(pL(3113544,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function _ah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function $ah(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function abh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3113544)|0;if(!(pL(3113544,f)|0)){n=l;break}c[h>>2]=b;RI(3113544)|0;m=pL(3113544,h)|0;RI(3113544)|0;if(nrh(2536048,pL(3113544,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3113544)|0;l=(pL(3113544,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function bbh(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function cbh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3113544)|0;d=pL(3113544,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function dbh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;yFe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1744280)|0;d=pL(1744280,e)|0;i=b;return d|0}function ebh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=0;Qfh();if((PCf(a)|0)>(b|0)){f=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,a+16+(da(f,b)|0)|0,f|0)|0;i=d;return c[e>>2]|0}else{RI(2964880)|0;e=qL(2964880)|0;wdg(e,c[886018]|0);Yxh(e)}return 0}function fbh(a,b){a=a|0;b=b|0;Jfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885920]|0);Yxh(b)}function gbh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=0;Lfh();if((sDf(a)|0)>=2){k=tof(0,c[885928]|0)|0;RI(3115536)|0;l=qL(3115536)|0;zwg(l,k);Yxh(l)}l=PCf(a)|0;if((l|0)<=0){m=0;i=d;return m|0}k=a+16|0;n=b;b=0;while(1){o=c[(c[a>>2]|0)+120>>2]|0;YEi(f|0,k+(da(o,b)|0)|0,o|0)|0;c[g>>2]=n;RI(3126192)|0;o=(pL(3126192,g)|0)==0;p=c[f>>2]|0;if(o){q=p;r=5;break}c[j>>2]=p;RI(3126192)|0;p=pL(3126192,j)|0;RI(3126192)|0;o=b+1|0;if(nrh(2536048,pL(3126192,e)|0,p)|0){m=1;r=10;break}if((o|0)>=(l|0)){m=0;r=10;break}n=c[e>>2]|0;b=o}if((r|0)==5){c[h>>2]=q;RI(3126192)|0;m=(pL(3126192,h)|0)==0;i=d;return m|0}else if((r|0)==10){i=d;return m|0}return 0}function hbh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;Mfh();if(!b){RI(2963920)|0;f=qL(2963920)|0;Iag(f,c[885932]|0);Yxh(f)}if((sDf(a)|0)>=2){f=tof(0,c[885934]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}g=JDf(a,0)|0;f=xDf(b,0)|0;if((g+d|0)>((JDf(b,0)|0)+f|0)){RI(2965048)|0;f=qL(2965048)|0;Rbg(f,c[885936]|0);Yxh(f)}if((sDf(b)|0)>=2){f=tof(0,c[885938]|0)|0;RI(3115536)|0;g=qL(3115536)|0;zwg(g,f);Yxh(g)}if((d|0)>-1){g=xDf(a,0)|0;wEf(0,a,g,b,d,JDf(a,0)|0);i=e;return}else{e=tof(0,c[885942]|0)|0;RI(2964880)|0;a=qL(2964880)|0;Qag(a,c[885940]|0,e);Yxh(a)}}function ibh(a,b){a=a|0;b=b|0;Kfh();RI(3100472)|0;b=qL(3100472)|0;pug(b,c[885924]|0);Yxh(b);return 0}function jbh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=0;Pfh();if((sDf(a)|0)>=2){j=tof(0,c[886014]|0)|0;RI(3115536)|0;k=qL(3115536)|0;zwg(k,j);Yxh(k)}k=PCf(a)|0;a:do if((k|0)>0){j=a+16|0;l=0;while(1){m=c[(c[a>>2]|0)+120>>2]|0;YEi(e|0,j+(da(m,l)|0)|0,m|0)|0;c[f>>2]=b;RI(3126192)|0;if(!(pL(3126192,f)|0)){n=l;break}c[h>>2]=b;RI(3126192)|0;m=pL(3126192,h)|0;RI(3126192)|0;if(nrh(2536048,pL(3126192,e)|0,m)|0){o=l;p=9;break}l=l+1|0;if((l|0)>=(k|0))break a}if((p|0)==9){q=(xDf(a,0)|0)+o|0;i=d;return q|0}c[g>>2]=c[e>>2];RI(3126192)|0;l=(pL(3126192,g)|0)==0;j=xDf(a,0)|0;if(l){q=j+n|0;i=d;return q|0}else{q=j+-1|0;i=d;return q|0}}while(0);q=(xDf(a,0)|0)+-1|0;i=d;return q|0}function kbh(a,b,d){a=a|0;b=b|0;d=d|0;Nfh();RI(3100472)|0;d=qL(3100472)|0;pug(d,c[886006]|0);Yxh(d)}function lbh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=d;Rfh();if((PCf(a)|0)<=(b|0)){RI(2964880)|0;h=qL(2964880)|0;wdg(h,c[886022]|0);Yxh(h)}RI(1086352)|0;h=vL(a,1086352)|0;if(!h){j=c[(c[a>>2]|0)+120>>2]|0;YEi(a+16+(da(j,b)|0)|0,f|0,j|0)|0;i=e;return}else{c[g>>2]=d;RI(3126192)|0;d=pL(3126192,g)|0;Qqh(h,d);c[h+16+(da(c[(c[h>>2]|0)+120>>2]|0,b)|0)>>2]=d;i=e;return}}function mbh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b;f=d;c[f>>2]=0;c[f+4>>2]=0;WFe(d,a);a=d;d=c[a+4>>2]|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=d;RI(1754560)|0;d=pL(1754560,e)|0;i=b;return d|0}function nbh(){var a=0;a=i;LTd();ROd();cId();C3d();o5d();i=a;return}function obh(){var a=0;a=i;XMc();fyc();TDc();SBc();eYb();rzc();Xld();Ckd();Ekc();I0b();$8c();wUb();xUb();aHc();eKd();yVd();c2d();d6d();oke();NRc();suc();xFc();kSb();qSb();SRb();qhc();Nzc();QEc();Ygc();Ydc();ncd();LEd();yDd();VKd();O8b();Q4b();oad();T1b();l3b();oWb();Mwc();nJd();N5b();aLc();TLd();WJc();o2b();bGd();QWb();Omd();ilc();xtc();xSc();POc();sUc();WSc();i=a;return}function pbh(){var a=0;a=i;d0d();e0d();j0d();Vxd();Wxd();Uxd();Txd();zBd();BBd();aBd();cBd();bBd();dBd();fCd();eCd();VBd();XBd();$Bd();_Bd();UBd();TBd();aCd();YBd();WBd();dCd();bCd();gCd();hCd();cCd();ZBd();UCd();TCd();gyd();kCd();zCd();ACd();xCd();vCd();uCd();tCd();yCd();wCd();CAd();DAd();yAd();xAd();AAd();FAd();BAd();zAd();EAd();$ie();YCd();XCd();$yd();_yd();qyd();ryd();bzd();Xyd();fzd();ezd();lAd();jAd();gAd();fAd();iAd();hAd();dAd();cAd();bAd();nAd();eAd();mAd();kAd();Ozd();Qzd();Pzd();lzd();kzd();jzd();ECd();FCd();GCd();eyd();dyd();oBd();rBd();qBd();pBd();XAd();YAd();VAd();ZAd();WAd();_Ad();$Ad();QCd();OCd();MCd();NCd();PCd();pyd();UAd();TAd();Zzd();$zd();Tzd();Vzd();Xzd();aAd();Szd();Rzd();_zd();Uzd();Wzd();Yzd();wBd();xBd();vBd();Vyd();Oyd();Myd();Lyd();Pyd();Qyd();Nyd();Ryd();Tyd();Syd();Uyd();tyd();syd();hyd();iyd();jyd();mBd();nBd();lBd();fyd();cje();hje();nje();kje();eje();bje();ije();lje();fje();aje();dje();jje();mje();gje();Jyd();Iyd();Kyd();hDd();fDd();dDd();gDd();eDd();iDd();i=a;return}function qbh(){var b=0;b=i;if(a[3516472]|0){i=b;return}c[879090]=vM(3516480,15)|0;c[879092]=vM(3516512,12)|0;c[879094]=vM(3516536,12)|0;c[879096]=vM(3516560,8)|0;c[879098]=vM(3516576,8)|0;c[879100]=vM(3516592,9)|0;c[879102]=vM(3516576,8)|0;c[879104]=vM(3516592,9)|0;c[879106]=vM(3516576,8)|0;c[879108]=vM(3516592,9)|0;c[879110]=vM(3516616,24)|0;c[879112]=vM(3516664,10)|0;c[879114]=vM(3516688,10)|0;c[879116]=vM(3516712,10)|0;a[3516472]=1;i=b;return}function rbh(){var b=0;b=i;if(a[3516744]|0){i=b;return}c[879184]=vM(3516752,23)|0;a[3516744]=1;i=b;return}function sbh(){var b=0;b=i;if(a[3516824]|0){i=b;return}c[879200]=vM(3516832,36)|0;c[879202]=vM(3516904,37)|0;c[879204]=vM(3516984,30)|0;a[3516824]=1;i=b;return}function tbh(){var b=0;b=i;if(a[3517056]|0){i=b;return}c[879262]=vM(3517064,15)|0;a[3517056]=1;i=b;return}function ubh(){var b=0;b=i;if(a[3517104]|0){i=b;return}c[879274]=vM(3517064,15)|0;a[3517104]=1;i=b;return}function vbh(){var b=0;b=i;if(a[3517168]|0){i=b;return}c[879278]=vM(3517176,3)|0;c[879280]=vM(3517184,12)|0;c[879282]=vM(3517208,6)|0;c[879284]=vM(3517224,10)|0;c[879286]=vM(3517248,6)|0;c[879288]=vM(3517264,10)|0;c[879290]=vM(3517288,10)|0;a[3517168]=1;i=b;return}function wbh(){var b=0;b=i;if(a[3517384]|0){i=b;return}c[879328]=vM(3517392,1)|0;c[879330]=vM(3517400,30)|0;c[879332]=vM(3517464,4)|0;c[879334]=vM(3517472,10)|0;c[879336]=vM(3517496,1)|0;c[879338]=vM(3517504,1)|0;c[879340]=vM(3517512,5)|0;c[879342]=vM(3517496,1)|0;c[879344]=vM(3517504,1)|0;a[3517384]=1;i=b;return}function xbh(){var b=0;b=i;if(a[3517568]|0){i=b;return}c[879382]=vM(3517392,1)|0;c[879384]=vM(3517576,10)|0;c[879386]=vM(3517600,3)|0;c[879388]=vM(3517608,1)|0;c[879390]=vM(3517616,1)|0;a[3517568]=1;i=b;return}function ybh(){var b=0;b=i;if(a[3517632]|0){i=b;return}c[879406]=vM(3517640,50)|0;a[3517632]=1;i=b;return}function zbh(){var b=0;b=i;if(a[3517752]|0){i=b;return}c[879436]=vM(3517760,21)|0;a[3517752]=1;i=b;return}function Abh(){var b=0;b=i;if(a[3518128]|0){i=b;return}c[879452]=vM(3518136,3)|0;c[879454]=vM(3518136,3)|0;c[879456]=vM(3518144,6)|0;c[879458]=vM(3518144,6)|0;c[879460]=vM(3518160,6)|0;c[879462]=vM(3518160,6)|0;c[879464]=vM(3518176,5)|0;c[879466]=vM(3518176,5)|0;c[879468]=vM(3518192,6)|0;c[879470]=vM(3518192,6)|0;c[879472]=vM(3518208,9)|0;c[879474]=vM(3518208,9)|0;c[879476]=vM(3518232,8)|0;c[879478]=vM(3518232,8)|0;c[879480]=vM(3518248,16)|0;c[879482]=vM(3518248,16)|0;c[879484]=vM(3518280,21)|0;c[879486]=vM(3518280,21)|0;c[879488]=vM(3518328,14)|0;c[879490]=vM(3518328,14)|0;c[879492]=vM(3518360,19)|0;c[879494]=vM(3518360,19)|0;c[879496]=vM(3518400,19)|0;c[879498]=vM(3518400,19)|0;c[879500]=vM(3518440,24)|0;c[879502]=vM(3518440,24)|0;c[879504]=vM(3518488,29)|0;c[879506]=vM(3518488,29)|0;c[879508]=vM(3518552,30)|0;c[879510]=vM(3518552,30)|0;c[879512]=vM(3518616,17)|0;c[879514]=vM(3518616,17)|0;c[879516]=vM(3518656,22)|0;c[879518]=vM(3518656,22)|0;c[879520]=vM(3518704,25)|0;c[879522]=vM(3518704,25)|0;c[879524]=vM(3518760,27)|0;c[879526]=vM(3518760,27)|0;c[879528]=vM(3518816,10)|0;c[879530]=vM(3518816,10)|0;a[3518128]=1;i=b;return}function Bbh(){var b=0;b=i;if(a[3518864]|0){i=b;return}c[879710]=vM(3518872,22)|0;c[879712]=vM(3518920,11)|0;c[879714]=vM(3518944,2)|0;a[3518864]=1;i=b;return}function Cbh(){var b=0;b=i;if(a[3518960]|0){i=b;return}c[879738]=vM(3518968,15)|0;a[3518960]=1;i=b;return}function Dbh(){var b=0;b=i;if(a[3519008]|0){i=b;return}c[879750]=vM(3519016,36)|0;a[3519008]=1;i=b;return}function Ebh(){var b=0;b=i;if(a[3519096]|0){i=b;return}c[879772]=vM(3519104,14)|0;a[3519096]=1;i=b;return}function Fbh(){var b=0;b=i;if(a[3519192]|0){i=b;return}c[879784]=vM(3519200,54)|0;c[879786]=vM(3519312,6)|0;c[879788]=vM(3519328,13)|0;c[879790]=vM(3519360,13)|0;c[879792]=vM(3519392,11)|0;c[879794]=vM(3519416,41)|0;c[879796]=vM(3519504,17)|0;a[3519192]=1;i=b;return}function Gbh(){var b=0;b=i;if(a[3519552]|0){i=b;return}c[879886]=vM(3519560,16)|0;a[3519552]=1;i=b;return}function Hbh(){var b=0;b=i;if(a[3519600]|0){i=b;return}c[879898]=vM(3519608,24)|0;a[3519600]=1;i=b;return}function Ibh(){var b=0;b=i;if(a[3519664]|0){i=b;return}c[879914]=vM(3519672,15)|0;a[3519664]=1;i=b;return}function Jbh(){var b=0;b=i;if(a[3519712]|0){i=b;return}c[879926]=vM(3519720,36)|0;a[3519712]=1;i=b;return}function Kbh(){var b=0;b=i;if(a[3519800]|0){i=b;return}c[879948]=vM(3519808,24)|0;a[3519800]=1;i=b;return}function Lbh(){var b=0;b=i;if(a[3519864]|0){i=b;return}c[879964]=vM(3519872,32)|0;a[3519864]=1;i=b;return}function Mbh(){var b=0;b=i;if(a[3519944]|0){i=b;return}c[879984]=vM(3519952,49)|0;a[3519944]=1;i=b;return}function Nbh(){var b=0;b=i;if(a[3520064]|0){i=b;return}c[880014]=vM(3520072,21)|0;a[3520064]=1;i=b;return}function Obh(){var b=0;b=i;if(a[3520128]|0){i=b;return}c[880030]=vM(3520072,21)|0;a[3520128]=1;i=b;return}function Pbh(){var b=0;b=i;if(a[3520144]|0){i=b;return}c[880034]=vM(3520152,118)|0;a[3520144]=1;i=b;return}function Qbh(){var b=0;b=i;if(a[3520400]|0){i=b;return}c[880098]=vM(3520408,70)|0;a[3520400]=1;i=b;return}function Rbh(){var b=0;b=i;if(a[3520560]|0){i=b;return}c[880138]=vM(3520568,25)|0;a[3520560]=1;i=b;return}function Sbh(){var b=0;b=i;if(a[3520632]|0){i=b;return}c[880156]=vM(3520568,25)|0;a[3520632]=1;i=b;return}function Tbh(){var b=0;b=i;if(a[3520648]|0){i=b;return}c[880160]=vM(3519872,32)|0;a[3520648]=1;i=b;return}function Ubh(){var b=0;b=i;if(a[3520664]|0){i=b;return}c[880164]=vM(3520672,21)|0;a[3520664]=1;i=b;return}function Vbh(){var b=0;b=i;if(a[3520728]|0){i=b;return}c[880180]=vM(3520736,14)|0;a[3520728]=1;i=b;return}function Wbh(){var b=0;b=i;if(a[3520776]|0){i=b;return}c[880192]=vM(3520736,14)|0;a[3520776]=1;i=b;return}function Xbh(){var b=0;b=i;if(a[3520792]|0){i=b;return}c[880196]=vM(3520800,4)|0;a[3520792]=1;i=b;return}function Ybh(){var b=0;b=i;if(a[3520816]|0){i=b;return}c[880202]=vM(3520800,4)|0;a[3520816]=1;i=b;return}function Zbh(){var b=0;b=i;if(a[3520832]|0){i=b;return}c[880206]=vM(3520840,100)|0;a[3520832]=1;i=b;return}function _bh(){var b=0;b=i;if(a[3521048]|0){i=b;return}c[880260]=vM(3521056,102)|0;a[3521048]=1;i=b;return}function $bh(){var b=0;b=i;if(a[3521272]|0){i=b;return}c[880316]=vM(3521280,101)|0;a[3521272]=1;i=b;return}function ach(){var b=0;b=i;if(a[3521504]|0){i=b;return}c[880372]=vM(3521512,67)|0;c[880374]=vM(3521648,45)|0;a[3521504]=1;i=b;return}function bch(){var b=0;b=i;if(a[3521808]|0){i=b;return}c[880436]=vM(3521816,11)|0;c[880438]=vM(3521840,17)|0;c[880440]=vM(3521880,9)|0;c[880442]=vM(3521904,11)|0;c[880444]=vM(3521928,11)|0;c[880446]=vM(3521952,11)|0;c[880448]=vM(3521976,12)|0;c[880450]=vM(3521928,11)|0;a[3521808]=1;i=b;return}function cch(){var b=0;b=i;if(a[3522048]|0){i=b;return}c[880500]=vM(3522056,12)|0;c[880502]=vM(3522080,12)|0;c[880504]=vM(3522104,7)|0;c[880506]=vM(3522120,17)|0;c[880508]=vM(3522160,9)|0;c[880510]=vM(3522184,26)|0;a[3522048]=1;i=b;return}function dch(){var b=0;b=i;if(a[3522248]|0){i=b;return}c[880560]=vM(3517608,1)|0;a[3522248]=1;i=b;return}function ech(){var b=0;b=i;if(a[3522312]|0){i=b;return}c[880564]=vM(3522320,61)|0;c[880566]=vM(3522448,97)|0;c[880568]=vM(3517608,1)|0;c[880570]=vM(3522648,2)|0;c[880572]=vM(3522656,11)|0;c[880574]=vM(3517608,1)|0;c[880576]=vM(3517608,1)|0;a[3522312]=1;i=b;return}function fch(){var b=0;b=i;if(a[3522808]|0){i=b;return}c[880670]=vM(3522816,14)|0;c[880672]=vM(3522848,50)|0;c[880674]=vM(3522952,4)|0;c[880676]=vM(3522960,27)|0;c[880678]=vM(3523016,25)|0;c[880680]=vM(3523072,29)|0;c[880682]=vM(3523136,1)|0;c[880684]=vM(3523144,1)|0;c[880686]=vM(3523152,3)|0;c[880688]=vM(3523160,3)|0;c[880690]=vM(3523144,1)|0;c[880692]=vM(3523168,25)|0;c[880694]=vM(3523224,5)|0;c[880696]=vM(3523240,5)|0;c[880698]=vM(3523256,1)|0;c[880700]=vM(3517608,1)|0;a[3522808]=1;i=b;return}function gch(){var b=0;b=i;if(a[3523352]|0){i=b;return}c[880816]=vM(3523360,1)|0;c[880818]=vM(3523368,1)|0;c[880820]=vM(3523376,1)|0;c[880822]=vM(3523384,2)|0;c[880824]=vM(3523256,1)|0;c[880826]=vM(3523392,5)|0;c[880828]=vM(3523408,11)|0;c[880830]=vM(3523240,5)|0;c[880832]=vM(3523368,1)|0;c[880834]=vM(3523256,1)|0;c[880836]=vM(3517608,1)|0;a[3523352]=1;i=b;return}function hch(){var b=0;b=i;if(a[3523440]|0){i=b;return}c[880858]=vM(3523448,31)|0;a[3523440]=1;i=b;return}function ich(){var b=0;b=i;if(a[3523520]|0){i=b;return}c[880878]=vM(3517392,1)|0;a[3523520]=1;i=b;return}function jch(){var b=0;b=i;if(a[3523544]|0){i=b;return}c[880882]=vM(3523552,3)|0;c[880884]=vM(3523560,32)|0;a[3523544]=1;i=b;return}function kch(){var b=0;b=i;if(a[3523672]|0){i=b;return}c[880906]=vM(3523680,5)|0;c[880908]=vM(3523696,21)|0;c[880910]=vM(3523744,5)|0;c[880912]=vM(3523760,20)|0;c[880914]=vM(3523800,18)|0;c[880916]=vM(3523840,28)|0;a[3523672]=1;i=b;return}function lch(){var b=0;b=i;if(a[3523904]|0){i=b;return}c[880974]=vM(3523912,89)|0;a[3523904]=1;i=b;return}function mch(){var b=0;b=i;if(a[3524104]|0){i=b;return}c[881024]=vM(3524112,77)|0;a[3524104]=1;i=b;return}function nch(){var b=0;b=i;if(a[3524352]|0){i=b;return}c[881068]=vM(3524360,4)|0;c[881070]=vM(3524368,11)|0;c[881072]=vM(3524392,7)|0;c[881074]=vM(3524408,12)|0;c[881076]=vM(3524432,8)|0;c[881078]=vM(3524392,7)|0;c[881080]=vM(3524448,8)|0;c[881082]=vM(3524464,5)|0;c[881084]=vM(3524480,4)|0;c[881086]=vM(3524488,6)|0;a[3524352]=1;i=b;return}function och(){var b=0;b=i;if(a[3524544]|0){i=b;return}c[881126]=vM(3523680,5)|0;c[881128]=vM(3524552,10)|0;c[881130]=vM(3524576,51)|0;c[881132]=vM(3524680,71)|0;c[881134]=vM(3524824,25)|0;a[3524544]=1;i=b;return}function pch(){var b=0;b=i;if(a[3524888]|0){i=b;return}c[881220]=vM(3524896,3)|0;a[3524888]=1;i=b;return}function qch(){var b=0;b=i;if(a[3524976]|0){i=b;return}c[881226]=vM(3524984,7)|0;c[881228]=vM(3525e3,5)|0;c[881230]=vM(3525016,3)|0;c[881232]=vM(3525024,19)|0;c[881234]=vM(3525064,6)|0;c[881236]=vM(3525080,13)|0;c[881238]=vM(3525112,7)|0;c[881240]=vM(3525128,10)|0;c[881242]=vM(3525152,15)|0;a[3524976]=1;i=b;return}function rch(){var b=0;b=i;if(a[3525192]|0){i=b;return}c[881296]=vM(3525200,4)|0;a[3525192]=1;i=b;return}function sch(){var b=0;b=i;if(a[3525312]|0){i=b;return}c[881302]=vM(3525320,4)|0;c[881304]=vM(3525328,4)|0;c[881306]=vM(3525336,4)|0;c[881308]=vM(3525344,4)|0;c[881310]=vM(3525352,3)|0;c[881312]=vM(3525360,4)|0;c[881314]=vM(3525368,3)|0;c[881316]=vM(3525376,6)|0;c[881318]=vM(3525200,4)|0;c[881320]=vM(3525392,3)|0;c[881322]=vM(3525400,4)|0;c[881324]=vM(3525408,4)|0;c[881326]=vM(3525416,4)|0;a[3525312]=1;i=b;return}function tch(){var b=0;b=i;if(a[3525432]|0){i=b;return}c[881356]=vM(3525440,26)|0;a[3525432]=1;i=b;return}function uch(){var b=0;b=i;if(a[3525512]|0){i=b;return}c[881374]=vM(3524896,3)|0;c[881376]=vM(3524896,3)|0;a[3525512]=1;i=b;return}function vch(){var b=0;b=i;if(a[3525672]|0){i=b;return}c[881380]=vM(3525680,10)|0;c[881382]=vM(3525704,9)|0;c[881384]=vM(3525728,17)|0;c[881386]=vM(3525768,14)|0;c[881388]=vM(3525800,12)|0;c[881390]=vM(3525824,15)|0;c[881392]=vM(3525080,13)|0;c[881394]=vM(3525856,10)|0;c[881396]=vM(3525880,9)|0;c[881398]=vM(3525904,15)|0;c[881400]=vM(3525936,9)|0;c[881402]=vM(3525064,6)|0;c[881404]=vM(3525960,13)|0;c[881406]=vM(3525992,9)|0;c[881408]=vM(3526016,7)|0;c[881410]=vM(3525e3,5)|0;c[881412]=vM(3526032,11)|0;c[881414]=vM(3525112,7)|0;c[881416]=vM(3526056,9)|0;a[3525672]=1;i=b;return}function wch(){var b=0;b=i;if(a[3526088]|0){i=b;return}c[881520]=vM(3526096,74)|0;a[3526088]=1;i=b;return}function xch(){var b=0;b=i;if(a[3526296]|0){i=b;return}c[881562]=vM(3526304,15)|0;c[881564]=vM(3526336,9)|0;c[881566]=vM(3526304,15)|0;c[881568]=vM(3526360,2)|0;c[881570]=vM(3526368,3)|0;c[881572]=vM(3526360,2)|0;a[3526296]=1;i=b;return}function ych(){var b=0;b=i;if(a[3526384]|0){i=b;return}c[881594]=vM(3526392,36)|0;a[3526384]=1;i=b;return}function zch(){var b=0;b=i;if(a[3526472]|0){i=b;return}c[881616]=vM(3526480,8)|0;a[3526472]=1;i=b;return}function Ach(){var b=0;b=i;if(a[3526520]|0){i=b;return}c[881624]=vM(3523360,1)|0;c[881626]=vM(3523360,1)|0;c[881628]=vM(3523360,1)|0;a[3526520]=1;i=b;return}function Bch(){var b=0;b=i;if(a[3526544]|0){i=b;return}c[881632]=vM(3526552,4)|0;c[881634]=vM(3526552,4)|0;a[3526544]=1;i=b;return}function Cch(){var b=0;b=i;if(a[3526568]|0){i=b;return}c[881640]=vM(3526576,12)|0;a[3526568]=1;i=b;return}function Dch(){var b=0;b=i;if(a[3526616]|0){i=b;return}c[881650]=vM(3526368,3)|0;c[881652]=vM(3526360,2)|0;a[3526616]=1;i=b;return}function Ech(){var b=0;b=i;if(a[3526640]|0){i=b;return}c[881656]=vM(3526480,8)|0;c[881658]=vM(3526648,24)|0;a[3526640]=1;i=b;return}function Fch(){var b=0;b=i;if(a[3526704]|0){i=b;return}c[881674]=vM(3526360,2)|0;a[3526704]=1;i=b;return}function Gch(){var b=0;b=i;if(a[3526720]|0){i=b;return}c[881678]=vM(3526360,2)|0;a[3526720]=1;i=b;return}function Hch(){var b=0;b=i;if(a[3526768]|0){i=b;return}c[881682]=vM(3526360,2)|0;c[881684]=vM(3526776,5)|0;c[881686]=vM(3523368,1)|0;c[881688]=vM(3523368,1)|0;c[881690]=vM(3526792,5)|0;a[3526768]=1;i=b;return}function Ich(){var b=0;b=i;if(a[3526824]|0){i=b;return}c[881702]=vM(3526832,7)|0;c[881704]=vM(3526848,6)|0;a[3526824]=1;i=b;return}
function Jch(){var b=0;b=i;if(a[3527192]|0){i=b;return}c[881716]=vM(3527200,6)|0;c[881718]=vM(3527216,10)|0;c[881720]=vM(3527240,14)|0;c[881722]=vM(3527272,12)|0;c[881724]=vM(3527296,4)|0;c[881726]=vM(3527304,6)|0;c[881728]=vM(3527320,4)|0;c[881730]=vM(3527328,17)|0;c[881732]=vM(3527368,5)|0;c[881734]=vM(3527384,7)|0;c[881736]=vM(3527400,17)|0;c[881738]=vM(3527440,10)|0;c[881740]=vM(3527464,16)|0;c[881742]=vM(3527496,14)|0;c[881744]=vM(3527528,17)|0;c[881746]=vM(3527568,16)|0;c[881748]=vM(3527200,6)|0;c[881750]=vM(3527600,14)|0;c[881752]=vM(3527632,15)|0;c[881754]=vM(3527664,15)|0;c[881756]=vM(3527696,13)|0;c[881758]=vM(3527728,5)|0;c[881760]=vM(3527744,13)|0;c[881762]=vM(3527776,13)|0;c[881764]=vM(3527216,10)|0;c[881766]=vM(3527808,16)|0;c[881768]=vM(3527840,16)|0;c[881770]=vM(3527304,6)|0;c[881772]=vM(3527872,8)|0;c[881774]=vM(3527888,13)|0;c[881776]=vM(3527920,18)|0;c[881778]=vM(3527960,6)|0;c[881780]=vM(3527368,5)|0;c[881782]=vM(3527400,17)|0;c[881784]=vM(3527976,7)|0;c[881786]=vM(3527992,4)|0;c[881788]=vM(3528e3,3)|0;c[881790]=vM(3528008,7)|0;c[881792]=vM(3528024,16)|0;c[881794]=vM(3528056,10)|0;c[881796]=vM(3528080,11)|0;a[3527192]=1;i=b;return}function Kch(){var b=0;b=i;if(a[3528128]|0){i=b;return}c[882026]=vM(3522648,2)|0;c[882028]=vM(3528136,2)|0;c[882030]=vM(3528136,2)|0;a[3528128]=1;i=b;return}function Lch(){var b=0;b=i;if(a[3528152]|0){i=b;return}c[882036]=vM(3524464,5)|0;a[3528152]=1;i=b;return}function Mch(){var b=0;b=i;if(a[3528192]|0){i=b;return}c[882040]=vM(3528200,14)|0;c[882042]=vM(3528232,13)|0;c[882044]=vM(3528264,11)|0;c[882046]=vM(3528288,22)|0;a[3528192]=1;i=b;return}function Nch(){var b=0;b=i;if(a[3528400]|0){i=b;return}c[882084]=vM(3528408,4)|0;c[882086]=vM(3528416,18)|0;c[882088]=vM(3528456,5)|0;c[882090]=vM(3528416,18)|0;c[882092]=vM(3528472,4)|0;c[882094]=vM(3528480,21)|0;c[882096]=vM(3528528,3)|0;c[882098]=vM(3528536,17)|0;a[3528400]=1;i=b;return}function Och(){var b=0;b=i;if(a[3528584]|0){i=b;return}c[882144]=vM(3528592,11)|0;a[3528584]=1;i=b;return}function Pch(){var b=0;b=i;if(a[3528624]|0){i=b;return}c[882154]=vM(3528632,50)|0;a[3528624]=1;i=b;return}function Qch(){var b=0;b=i;if(a[3528744]|0){i=b;return}c[882184]=vM(3528752,7)|0;a[3528744]=1;i=b;return}function Rch(){var b=0;b=i;if(a[3528784]|0){i=b;return}c[882192]=vM(3528752,7)|0;c[882194]=vM(3528792,7)|0;a[3528784]=1;i=b;return}function Sch(){var b=0;b=i;if(a[3528824]|0){i=b;return}c[882202]=vM(3528792,7)|0;c[882204]=vM(3528792,7)|0;a[3528824]=1;i=b;return}function Tch(){var b=0;b=i;if(a[3528856]|0){i=b;return}c[882208]=vM(3528864,2)|0;c[882210]=vM(3528872,4)|0;c[882212]=vM(3528880,2)|0;a[3528856]=1;i=b;return}function Uch(){var b=0;b=i;if(a[3528904]|0){i=b;return}c[882222]=vM(3528912,2)|0;c[882224]=vM(3528920,7)|0;a[3528904]=1;i=b;return}function Vch(){var b=0;b=i;if(a[3528944]|0){i=b;return}c[882234]=vM(3528952,26)|0;a[3528944]=1;i=b;return}function Wch(){var b=0;b=i;if(a[3529024]|0){i=b;return}c[882252]=vM(3529032,1)|0;c[882254]=vM(3529040,13)|0;a[3529024]=1;i=b;return}function Xch(){var b=0;b=i;if(a[3529104]|0){i=b;return}c[882268]=vM(3529112,21)|0;c[882270]=vM(3529160,15)|0;c[882272]=vM(3529192,13)|0;c[882274]=vM(3529224,15)|0;a[3529104]=1;i=b;return}function Ych(){var b=0;b=i;if(a[3529312]|0){i=b;return}c[882314]=vM(3529320,11)|0;c[882316]=vM(3529344,15)|0;c[882318]=vM(3529376,25)|0;c[882320]=vM(3529344,15)|0;c[882322]=vM(3529432,16)|0;c[882324]=vM(3529464,29)|0;c[882326]=vM(3529528,23)|0;a[3529312]=1;i=b;return}function Zch(){var b=0;b=i;if(a[3529616]|0){i=b;return}c[882394]=vM(3529624,38)|0;c[882396]=vM(3523136,1)|0;c[882398]=vM(3517496,1)|0;c[882400]=vM(3529704,25)|0;c[882402]=vM(3529760,20)|0;a[3529616]=1;i=b;return}function _ch(){var b=0;b=i;if(a[3529816]|0){i=b;return}c[882450]=vM(3529824,39)|0;c[882452]=vM(3529904,26)|0;a[3529816]=1;i=b;return}function $ch(){var b=0;b=i;if(a[353e4]|0){i=b;return}c[882490]=vM(3530008,34)|0;c[882492]=vM(3530008,34)|0;c[882494]=vM(3530080,18)|0;c[882496]=vM(3530120,2)|0;c[882498]=vM(3530008,34)|0;a[353e4]=1;i=b;return}function adh(){var b=0;b=i;if(a[3530144]|0){i=b;return}c[882532]=vM(3530152,38)|0;c[882534]=vM(3530152,38)|0;a[3530144]=1;i=b;return}function bdh(){var b=0;b=i;if(a[3530264]|0){i=b;return}c[882558]=vM(3530272,44)|0;c[882560]=vM(3530360,23)|0;c[882562]=vM(3530360,23)|0;c[882564]=vM(3530408,31)|0;a[3530264]=1;i=b;return}function cdh(){var b=0;b=i;if(a[3530496]|0){i=b;return}c[882618]=vM(3530504,29)|0;c[882620]=vM(3530568,7)|0;c[882622]=vM(3530584,5)|0;a[3530496]=1;i=b;return}function ddh(){var b=0;b=i;if(a[3530616]|0){i=b;return}c[882650]=vM(3530624,9)|0;c[882652]=vM(3530648,4)|0;a[3530616]=1;i=b;return}function edh(){var b=0;b=i;if(a[3530672]|0){i=b;return}c[882664]=vM(3530680,12)|0;c[882666]=vM(3530704,16)|0;a[3530672]=1;i=b;return}function fdh(){var b=0;b=i;if(a[3530744]|0){i=b;return}c[882684]=vM(3530752,1)|0;a[3530744]=1;i=b;return}function gdh(){var b=0;b=i;if(a[3530768]|0){i=b;return}c[882690]=vM(3530776,60)|0;a[3530768]=1;i=b;return}function hdh(){var b=0;b=i;if(a[3531008]|0){i=b;return}c[882724]=vM(3531016,16)|0;c[882726]=vM(3531048,3)|0;c[882728]=vM(3528472,4)|0;c[882730]=vM(3528528,3)|0;c[882732]=vM(3531056,6)|0;c[882734]=vM(3528408,4)|0;c[882736]=vM(3528456,5)|0;c[882738]=vM(3531072,6)|0;c[882740]=vM(3531088,4)|0;c[882742]=vM(3531096,4)|0;c[882744]=vM(3531104,8)|0;c[882746]=vM(3531120,7)|0;c[882748]=vM(3523368,1)|0;c[882750]=vM(3523368,1)|0;a[3531008]=1;i=b;return}function idh(){var b=0;b=i;if(a[3531144]|0){i=b;return}c[882784]=vM(3531152,11)|0;a[3531144]=1;i=b;return}function jdh(){var b=0;b=i;if(a[3531192]|0){i=b;return}c[882794]=vM(3531072,6)|0;c[882796]=vM(3531088,4)|0;a[3531192]=1;i=b;return}function kdh(){var b=0;b=i;if(a[3531208]|0){i=b;return}c[882800]=vM(3531216,5)|0;a[3531208]=1;i=b;return}function ldh(){var b=0;b=i;if(a[3531248]|0){i=b;return}c[882808]=vM(3531256,9)|0;c[882810]=vM(3531280,1)|0;a[3531248]=1;i=b;return}function mdh(){var b=0;b=i;if(a[3531304]|0){i=b;return}c[882822]=vM(3531312,10)|0;c[882824]=vM(3531336,10)|0;a[3531304]=1;i=b;return}function ndh(){var b=0;b=i;if(a[3531384]|0){i=b;return}c[882840]=vM(3531392,3)|0;c[882842]=vM(3531400,3)|0;c[882844]=vM(3531408,3)|0;a[3531384]=1;i=b;return}function odh(){var b=0;b=i;if(a[3531432]|0){i=b;return}c[882854]=vM(3531440,1)|0;c[882856]=vM(3531448,1)|0;a[3531432]=1;i=b;return}function pdh(){var b=0;b=i;if(a[3531480]|0){i=b;return}c[882864]=vM(3531488,34)|0;c[882866]=vM(3531440,1)|0;c[882868]=vM(3531448,1)|0;a[3531480]=1;i=b;return}function qdh(){var b=0;b=i;if(a[3531568]|0){i=b;return}c[882890]=vM(3531576,9)|0;a[3531568]=1;i=b;return}function rdh(){var b=0;b=i;if(a[3531720]|0){i=b;return}c[882900]=vM(3531728,25)|0;c[882902]=vM(3531784,59)|0;c[882904]=vM(3531904,36)|0;c[882906]=vM(3531976,107)|0;c[882908]=vM(3532192,1)|0;c[882910]=vM(3532200,52)|0;c[882912]=vM(3532304,44)|0;c[882914]=vM(3531448,1)|0;c[882916]=vM(3532392,32)|0;c[882918]=vM(3532456,2)|0;c[882920]=vM(3532464,45)|0;c[882922]=vM(3523136,1)|0;c[882924]=vM(3523144,1)|0;c[882926]=vM(3532560,48)|0;c[882928]=vM(3523256,1)|0;a[3531720]=1;i=b;return}function sdh(){var b=0;b=i;if(a[3532696]|0){i=b;return}c[883164]=vM(3528472,4)|0;c[883166]=vM(3528408,4)|0;c[883168]=vM(3528456,5)|0;c[883170]=vM(3531104,8)|0;c[883172]=vM(3531120,7)|0;a[3532696]=1;i=b;return}function tdh(){var b=0;b=i;if(a[3532744]|0){i=b;return}c[883176]=vM(3531448,1)|0;c[883178]=vM(3523360,1)|0;c[883180]=vM(3532752,2)|0;c[883182]=vM(3531448,1)|0;c[883184]=vM(3531448,1)|0;a[3532744]=1;i=b;return}function udh(){var b=0;b=i;if(a[3532776]|0){i=b;return}c[883190]=vM(3528752,7)|0;c[883192]=vM(3523744,5)|0;a[3532776]=1;i=b;return}function vdh(){var b=0;b=i;if(a[3532792]|0){i=b;return}c[883196]=vM(3523368,1)|0;a[3532792]=1;i=b;return}function wdh(){var b=0;b=i;if(a[3532880]|0){i=b;return}c[883200]=vM(3528408,4)|0;c[883202]=vM(3528456,5)|0;c[883204]=vM(3528472,4)|0;c[883206]=vM(3528528,3)|0;c[883208]=vM(3531096,4)|0;c[883210]=vM(3531056,6)|0;c[883212]=vM(3531072,6)|0;c[883214]=vM(3531088,4)|0;c[883216]=vM(3531104,8)|0;c[883218]=vM(3531120,7)|0;a[3532880]=1;i=b;return}function xdh(){var b=0;b=i;if(a[3532896]|0){i=b;return}c[883222]=vM(3532904,51)|0;a[3532896]=1;i=b;return}function ydh(){var b=0;b=i;if(a[3533024]|0){i=b;return}c[883252]=vM(3533032,57)|0;c[883254]=vM(3533152,30)|0;a[3533024]=1;i=b;return}function zdh(){var b=0;b=i;if(a[3533232]|0){i=b;return}c[883304]=vM(3530752,1)|0;c[883306]=vM(3533240,40)|0;a[3533232]=1;i=b;return}function Adh(){var b=0;b=i;if(a[3533328]|0){i=b;return}c[883330]=vM(3533336,4)|0;a[3533328]=1;i=b;return}function Bdh(){var b=0;b=i;if(a[3533352]|0){i=b;return}c[883336]=vM(3533360,69)|0;a[3533352]=1;i=b;return}function Cdh(){var b=0;b=i;if(a[3533512]|0){i=b;return}c[883376]=vM(3533520,10)|0;a[3533512]=1;i=b;return}function Ddh(){var b=0;b=i;if(a[3533552]|0){i=b;return}c[883386]=vM(3533560,27)|0;a[3533552]=1;i=b;return}function Edh(){var b=0;b=i;if(a[3533632]|0){i=b;return}c[883404]=vM(3533640,1)|0;c[883406]=vM(3533648,18)|0;a[3533632]=1;i=b;return}function Fdh(){var b=0;b=i;if(a[3533704]|0){i=b;return}c[883422]=vM(3533712,83)|0;c[883424]=vM(3533880,24)|0;a[3533704]=1;i=b;return}function Gdh(){var b=0;b=i;if(a[3533944]|0){i=b;return}c[883482]=vM(3533952,29)|0;c[883484]=vM(3533952,29)|0;a[3533944]=1;i=b;return}function Hdh(){var b=0;b=i;if(a[3534024]|0){i=b;return}c[883504]=vM(3534032,42)|0;a[3534024]=1;i=b;return}function Idh(){var b=0;b=i;if(a[3534144]|0){i=b;return}c[883530]=vM(3533952,29)|0;c[883532]=vM(3533952,29)|0;c[883534]=vM(3533952,29)|0;a[3534144]=1;i=b;return}function Jdh(){var b=0;b=i;if(a[3534160]|0){i=b;return}c[883538]=vM(3533520,10)|0;a[3534160]=1;i=b;return}function Kdh(){var b=0;b=i;if(a[3534176]|0){i=b;return}c[883542]=vM(3534184,27)|0;a[3534176]=1;i=b;return}function Ldh(){var b=0;b=i;if(a[3534256]|0){i=b;return}c[883560]=vM(3533640,1)|0;c[883562]=vM(3533648,18)|0;a[3534256]=1;i=b;return}function Mdh(){var b=0;b=i;if(a[3534352]|0){i=b;return}c[883566]=vM(3533640,1)|0;c[883568]=vM(3534360,56)|0;c[883570]=vM(3534472,62)|0;c[883572]=vM(3534600,62)|0;c[883574]=vM(3533952,29)|0;c[883576]=vM(3533952,29)|0;c[883578]=vM(3534728,57)|0;c[883580]=vM(3534848,88)|0;c[883582]=vM(3535024,69)|0;c[883584]=vM(3535168,79)|0;c[883586]=vM(3535328,12)|0;a[3534352]=1;i=b;return}function Ndh(){var b=0;b=i;if(a[3535360]|0){i=b;return}c[883838]=vM(3533520,10)|0;a[3535360]=1;i=b;return}function Odh(){var b=0;b=i;if(a[3535376]|0){i=b;return}c[883842]=vM(3535384,29)|0;a[3535376]=1;i=b;return}function Pdh(){var b=0;b=i;if(a[3535472]|0){i=b;return}c[883862]=vM(3533640,1)|0;c[883864]=vM(3533648,18)|0;c[883866]=vM(3535480,15)|0;a[3535472]=1;i=b;return}function Qdh(){var b=0;b=i;if(a[3535544]|0){i=b;return}c[883878]=vM(3533640,1)|0;c[883880]=vM(3533952,29)|0;c[883882]=vM(3533952,29)|0;c[883884]=vM(3535480,15)|0;a[3535544]=1;i=b;return}function Rdh(){var b=0;b=i;if(a[3535560]|0){i=b;return}c[883888]=vM(3533520,10)|0;a[3535560]=1;i=b;return}function Sdh(){var b=0;b=i;if(a[3535576]|0){i=b;return}c[883892]=vM(3535584,29)|0;a[3535576]=1;i=b;return}function Tdh(){var b=0;b=i;if(a[3535680]|0){i=b;return}c[883912]=vM(3533640,1)|0;c[883914]=vM(3533952,29)|0;c[883916]=vM(3533952,29)|0;c[883918]=vM(3535480,15)|0;a[3535680]=1;i=b;return}function Udh(){var b=0;b=i;if(a[3535696]|0){i=b;return}c[883922]=vM(3533520,10)|0;a[3535696]=1;i=b;return}function Vdh(){var b=0;b=i;if(a[3535712]|0){i=b;return}c[883926]=vM(3535720,27)|0;a[3535712]=1;i=b;return}function Wdh(){var b=0;b=i;if(a[3535784]|0){i=b;return}c[883944]=vM(3535792,16)|0;a[3535784]=1;i=b;return}function Xdh(){var b=0;b=i;if(a[3535832]|0){i=b;return}c[883956]=vM(3533520,10)|0;a[3535832]=1;i=b;return}function Ydh(){var b=0;b=i;if(a[3535848]|0){i=b;return}c[883960]=vM(3535856,28)|0;a[3535848]=1;i=b;return}function Zdh(){var b=0;b=i;if(a[3535920]|0){i=b;return}c[883978]=vM(3533640,1)|0;a[3535920]=1;i=b;return}function _dh(){var b=0;b=i;if(a[3535936]|0){i=b;return}c[883982]=vM(3533952,29)|0;a[3535936]=1;i=b;return}function $dh(){var b=0;b=i;if(a[3535952]|0){i=b;return}c[883986]=vM(3533520,10)|0;a[3535952]=1;i=b;return}function aeh(){var b=0;b=i;if(a[3535968]|0){i=b;return}c[883990]=vM(3535976,27)|0;a[3535968]=1;i=b;return}function beh(){var b=0;b=i;if(a[3536048]|0){i=b;return}c[884008]=vM(3533640,1)|0;c[884010]=vM(3533648,18)|0;a[3536048]=1;i=b;return}function ceh(){var b=0;b=i;if(a[3536064]|0){i=b;return}c[884014]=vM(3533952,29)|0;a[3536064]=1;i=b;return}function deh(){var b=0;b=i;if(a[3536080]|0){i=b;return}c[884018]=vM(3533520,10)|0;a[3536080]=1;i=b;return}function eeh(){var b=0;b=i;if(a[3536096]|0){i=b;return}c[884022]=vM(3536104,29)|0;a[3536096]=1;i=b;return}function feh(){var b=0;b=i;if(a[3536176]|0){i=b;return}c[884042]=vM(3535792,16)|0;a[3536176]=1;i=b;return}function geh(){var b=0;b=i;if(a[3536192]|0){i=b;return}c[884046]=vM(3533520,10)|0;a[3536192]=1;i=b;return}function heh(){var b=0;b=i;if(a[3536208]|0){i=b;return}c[884050]=vM(3536216,26)|0;a[3536208]=1;i=b;return}function ieh(){var b=0;b=i;if(a[3536288]|0){i=b;return}c[884068]=vM(3533640,1)|0;c[884070]=vM(3536296,35)|0;a[3536288]=1;i=b;return}function jeh(){var b=0;b=i;if(a[3536376]|0){i=b;return}c[884092]=vM(3536384,7)|0;a[3536376]=1;i=b;return}function keh(){var b=0;b=i;if(a[3536408]|0){i=b;return}c[884100]=vM(0,0)|0;a[3536408]=1;i=b;return}function leh(){var b=0;b=i;if(a[3536424]|0){i=b;return}c[884104]=vM(3536432,4)|0;a[3536424]=1;i=b;return}function meh(){var b=0;b=i;if(a[3536488]|0){i=b;return}c[884110]=vM(3536496,10)|0;c[884112]=vM(3536520,3)|0;c[884114]=vM(3536528,6)|0;c[884116]=vM(3536520,3)|0;c[884118]=vM(3536496,10)|0;c[884120]=vM(3536544,46)|0;a[3536488]=1;i=b;return}function neh(){var b=0;b=i;if(a[3536648]|0){i=b;return}c[884160]=vM(3536656,5)|0;a[3536648]=1;i=b;return}function oeh(){var b=0;b=i;if(a[3536680]|0){i=b;return}c[884168]=vM(3536496,10)|0;a[3536680]=1;i=b;return}function peh(){var b=0;b=i;if(a[3536752]|0){i=b;return}c[884172]=vM(3536528,6)|0;c[884174]=vM(3536760,19)|0;c[884176]=vM(3536496,10)|0;c[884178]=vM(3536760,19)|0;c[884180]=vM(3536496,10)|0;c[884182]=vM(3536800,31)|0;c[884184]=vM(3536528,6)|0;c[884186]=vM(3536864,33)|0;a[3536752]=1;i=b;return}function qeh(){var b=0;b=i;if(a[3536944]|0){i=b;return}c[884234]=vM(3536384,7)|0;a[3536944]=1;i=b;return}function reh(){var b=0;b=i;if(a[3536960]|0){i=b;return}c[884238]=vM(3536384,7)|0;a[3536960]=1;i=b;return}function seh(){var b=0;b=i;if(a[3536976]|0){i=b;return}c[884242]=vM(3536984,5)|0;a[3536976]=1;i=b;return}function teh(){var b=0;b=i;if(a[3537032]|0){i=b;return}c[884250]=vM(3536496,10)|0;c[884252]=vM(3536520,3)|0;c[884254]=vM(3536496,10)|0;c[884256]=vM(3537040,24)|0;a[3537032]=1;i=b;return}function ueh(){var b=0;b=i;if(a[3537136]|0){i=b;return}c[884272]=vM(3536496,10)|0;c[884274]=vM(3537144,33)|0;c[884276]=vM(3536656,5)|0;c[884278]=vM(3536520,3)|0;c[884280]=vM(3536656,5)|0;c[884282]=vM(3537216,32)|0;a[3537136]=1;i=b;return}function veh(){var b=0;b=i;if(a[3537288]|0){i=b;return}c[884320]=vM(3536984,5)|0;a[3537288]=1;i=b;return}function weh(){var b=0;b=i;if(a[3537336]|0){i=b;return}c[884324]=vM(3536984,5)|0;c[884326]=vM(3536496,10)|0;c[884328]=vM(3537344,59)|0;c[884330]=vM(3536656,5)|0;c[884332]=vM(3537464,59)|0;a[3537336]=1;i=b;return}function xeh(){var b=0;b=i;if(a[3537624]|0){i=b;return}c[884396]=vM(3536496,10)|0;c[884398]=vM(3537632,21)|0;c[884400]=vM(3536656,5)|0;c[884402]=vM(3537680,20)|0;c[884404]=vM(3537720,26)|0;a[3537624]=1;i=b;return}function yeh(){var b=0;b=i;if(a[3537824]|0){i=b;return}c[884444]=vM(3536984,5)|0;c[884446]=vM(3536496,10)|0;c[884448]=vM(3537680,20)|0;c[884450]=vM(3536656,5)|0;c[884452]=vM(3537680,20)|0;c[884454]=vM(3537720,26)|0;a[3537824]=1;i=b;return}function zeh(){var b=0;b=i;if(a[3537848]|0){i=b;return}c[884458]=vM(3537856,10)|0;c[884460]=vM(3536520,3)|0;a[3537848]=1;i=b;return}function Aeh(){var b=0;b=i;if(a[3537888]|0){i=b;return}c[884470]=vM(3536984,5)|0;a[3537888]=1;i=b;return}function Beh(){var b=0;b=i;if(a[3537912]|0){i=b;return}c[884474]=vM(3537920,8)|0;c[884476]=vM(3537936,29)|0;a[3537912]=1;i=b;return}function Ceh(){var b=0;b=i;if(a[3538048]|0){i=b;return}c[884500]=vM(3536496,10)|0;c[884502]=vM(3536760,19)|0;c[884504]=vM(3536656,5)|0;c[884506]=vM(3536760,19)|0;c[884508]=vM(3536656,5)|0;c[884510]=vM(3537216,32)|0;a[3538048]=1;i=b;return}function Deh(){var b=0;b=i;if(a[3538064]|0){i=b;return}c[884514]=vM(3536384,7)|0;a[3538064]=1;i=b;return}function Eeh(){var b=0;b=i;if(a[3538104]|0){i=b;return}c[884518]=vM(3538112,6)|0;c[884520]=vM(3538128,4)|0;c[884522]=vM(3538136,101)|0;c[884524]=vM(3538344,41)|0;a[3538104]=1;i=b;return}function Feh(){var b=0;b=i;if(a[3538440]|0){i=b;return}c[884608]=vM(3538128,4)|0;a[3538440]=1;i=b;return}function Geh(){var b=0;b=i;if(a[3538456]|0){i=b;return}c[884612]=vM(3538464,6)|0;a[3538456]=1;i=b;return}function Heh(){var b=0;b=i;if(a[3538504]|0){i=b;return}c[884620]=vM(3536984,5)|0;c[884622]=vM(3536496,10)|0;c[884624]=vM(3538512,70)|0;a[3538504]=1;i=b;return}function Ieh(){var b=0;b=i;if(a[3538712]|0){i=b;return}c[884664]=vM(3536984,5)|0;c[884666]=vM(3536496,10)|0;c[884668]=vM(3536520,3)|0;c[884670]=vM(3536656,5)|0;c[884672]=vM(3536520,3)|0;c[884674]=vM(3536496,10)|0;c[884676]=vM(3538720,33)|0;a[3538712]=1;i=b;return}function Jeh(){var b=0;b=i;if(a[3538824]|0){i=b;return}c[884698]=vM(3538344,41)|0;c[884700]=vM(3538344,41)|0;c[884702]=vM(3538344,41)|0;c[884704]=vM(3538344,41)|0;a[3538824]=1;i=b;return}function Keh(){var b=0;b=i;if(a[3538840]|0){i=b;return}c[884708]=vM(3538848,3)|0;a[3538840]=1;i=b;return}function Leh(){var b=0;b=i;if(a[3538872]|0){i=b;return}c[884714]=vM(3538880,9)|0;c[884716]=vM(3538904,28)|0;a[3538872]=1;i=b;return}function Meh(){var b=0;b=i;if(a[3538992]|0){i=b;return}c[884740]=vM(3539e3,3)|0;c[884742]=vM(3539008,39)|0;c[884744]=vM(3539e3,3)|0;c[884746]=vM(3539008,39)|0;a[3538992]=1;i=b;return}function Neh(){var b=0;b=i;if(a[3539176]|0){i=b;return}c[884772]=vM(3536528,6)|0;c[884774]=vM(3539184,29)|0;c[884776]=vM(3536496,10)|0;c[884778]=vM(3539184,29)|0;c[884780]=vM(3536496,10)|0;c[884782]=vM(3539248,60)|0;c[884784]=vM(3536984,5)|0;c[884786]=vM(3539e3,3)|0;c[884788]=vM(3539248,60)|0;c[884790]=vM(3536984,5)|0;c[884792]=vM(3539248,60)|0;a[3539176]=1;i=b;return}function Oeh(){var b=0;b=i;if(a[3539392]|0){i=b;return}c[884842]=vM(3536984,5)|0;c[884844]=vM(3536496,10)|0;c[884846]=vM(3536528,6)|0;a[3539392]=1;i=b;return}function Peh(){var b=0;b=i;if(a[3539456]|0){i=b;return}c[884850]=vM(3536984,5)|0;c[884852]=vM(3536496,10)|0;c[884854]=vM(3536760,19)|0;c[884856]=vM(3536528,6)|0;c[884858]=vM(3536760,19)|0;c[884860]=vM(3536496,10)|0;c[884862]=vM(3539464,61)|0;a[3539456]=1;i=b;return}function Qeh(){var b=0;b=i;if(a[3539600]|0){i=b;return}c[884898]=vM(3536656,5)|0;a[3539600]=1;i=b;return}function Reh(){var b=0;b=i;if(a[3539616]|0){i=b;return}c[884902]=vM(3533520,10)|0;a[3539616]=1;i=b;return}function Seh(){var b=0;b=i;if(a[3539632]|0){i=b;return}c[884906]=vM(3539640,29)|0;a[3539632]=1;i=b;return}function Teh(){var b=0;b=i;if(a[3539712]|0){i=b;return}c[884926]=vM(3533520,10)|0;a[3539712]=1;i=b;return}function Ueh(){var b=0;b=i;if(a[3539728]|0){i=b;return}c[884930]=vM(3539736,28)|0;a[3539728]=1;i=b;return}function Veh(){var b=0;b=i;if(a[3539872]|0){i=b;return}c[884948]=vM(3533640,1)|0;c[884950]=vM(3539880,42)|0;c[884952]=vM(3539968,17)|0;c[884954]=vM(3540008,20)|0;c[884956]=vM(3540048,14)|0;c[884958]=vM(3540048,14)|0;c[884960]=vM(3540048,14)|0;c[884962]=vM(3540048,14)|0;c[884964]=vM(3540048,14)|0;c[884966]=vM(3540080,12)|0;a[3539872]=1;i=b;return}function Weh(){var b=0;b=i;if(a[3540112]|0){i=b;return}c[885026]=vM(3540120,30)|0;a[3540112]=1;i=b;return}function Xeh(){var b=0;b=i;if(a[3540192]|0){i=b;return}c[885046]=vM(3540200,72)|0;a[3540192]=1;i=b;return}function Yeh(){var b=0;b=i;if(a[3540352]|0){i=b;return}c[885086]=vM(3540200,72)|0;a[3540352]=1;i=b;return}function Zeh(){var b=0;b=i;if(a[3540368]|0){i=b;return}c[885090]=vM(3533520,10)|0;a[3540368]=1;i=b;return}function _eh(){var b=0;b=i;if(a[3540384]|0){i=b;return}c[885094]=vM(3540392,33)|0;a[3540384]=1;i=b;return}function $eh(){var b=0;b=i;if(a[3540480]|0){i=b;return}c[885116]=vM(3540488,41)|0;c[885118]=vM(3523256,1)|0;a[3540480]=1;i=b;return}function afh(){var b=0;b=i;if(a[3540584]|0){i=b;return}c[885144]=vM(3540592,29)|0;a[3540584]=1;i=b;return}function bfh(){var b=0;b=i;if(a[3540664]|0){i=b;return}c[885164]=vM(3540672,33)|0;a[3540664]=1;i=b;return}function cfh(){var b=0;b=i;if(a[3540752]|0){i=b;return}c[885186]=vM(3540760,16)|0;a[3540752]=1;i=b;return}function dfh(){var b=0;b=i;if(a[3540808]|0){i=b;return}c[885198]=vM(3540816,15)|0;c[885200]=vM(3540848,29)|0;a[3540808]=1;i=b;return}function efh(){var b=0;b=i;if(a[3540936]|0){i=b;return}c[885228]=vM(3533640,1)|0;c[885230]=vM(3540944,50)|0;c[885232]=vM(3541048,5)|0;a[3540936]=1;i=b;return}function ffh(){var b=0;b=i;if(a[3541088]|0){i=b;return}c[885266]=vM(3541096,29)|0;c[885268]=vM(3541160,29)|0;c[885270]=vM(3541224,1)|0;a[3541088]=1;i=b;return}function gfh(){var b=0;b=i;if(a[3541240]|0){i=b;return}c[885308]=vM(3541248,1)|0;a[3541240]=1;i=b;return}function hfh(){var b=0;b=i;if(a[3541264]|0){i=b;return}c[885314]=vM(3541248,1)|0;a[3541264]=1;i=b;return}function ifh(){var b=0;b=i;if(a[3541288]|0){i=b;return}c[885318]=vM(3541296,5)|0;c[885320]=vM(3541312,4)|0;a[3541288]=1;i=b;return}function jfh(){var b=0;b=i;if(a[3541328]|0){i=b;return}c[885330]=vM(3533520,10)|0;a[3541328]=1;i=b;return}function kfh(){var b=0;b=i;if(a[3541344]|0){i=b;return}c[885334]=vM(3541352,24)|0;a[3541344]=1;i=b;return}function lfh(){var b=0;b=i;if(a[3541416]|0){i=b;return}c[885350]=vM(3536984,5)|0;c[885352]=vM(3541424,60)|0;a[3541416]=1;i=b;return}function mfh(){var b=0;b=i;if(a[3541560]|0){i=b;return}c[885386]=vM(3524360,4)|0;c[885388]=vM(3536984,5)|0;a[3541560]=1;i=b;return}function nfh(){var b=0;b=i;if(a[3541576]|0){i=b;return}c[885392]=vM(3541584,28)|0;a[3541576]=1;i=b;return}function ofh(){var b=0;b=i;if(a[3541656]|0){i=b;return}c[885410]=vM(3524360,4)|0;c[885412]=vM(3541664,7)|0;a[3541656]=1;i=b;return}function pfh(){var b=0;b=i;if(a[3541688]|0){i=b;return}c[885420]=vM(3541696,28)|0;a[3541688]=1;i=b;return}function qfh(){var b=0;b=i;if(a[3541760]|0){i=b;return}c[885438]=vM(3541696,28)|0;a[3541760]=1;i=b;return}function rfh(){var b=0;b=i;if(a[3541776]|0){i=b;return}c[885442]=vM(3533520,10)|0;a[3541776]=1;i=b;return}function sfh(){var b=0;b=i;if(a[3541816]|0){i=b;return}c[885446]=vM(3541824,8)|0;c[885448]=vM(3536984,5)|0;c[885450]=vM(3541840,29)|0;c[885452]=vM(3541824,8)|0;a[3541816]=1;i=b;return}function tfh(){var b=0;b=i;if(a[3541928]|0){i=b;return}c[885476]=vM(3541824,8)|0;c[885478]=vM(3541840,29)|0;c[885480]=vM(3541824,8)|0;a[3541928]=1;i=b;return}function ufh(){var b=0;b=i;if(a[3541944]|0){i=b;return}c[885484]=vM(3541952,45)|0;a[3541944]=1;i=b;return}function vfh(){var b=0;b=i;if(a[3542104]|0){i=b;return}c[885512]=vM(3541824,8)|0;c[885514]=vM(3536984,5)|0;c[885516]=vM(3541840,29)|0;c[885518]=vM(3541824,8)|0;c[885520]=vM(3542112,48)|0;c[885522]=vM(3542208,34)|0;c[885524]=vM(3542280,40)|0;a[3542104]=1;i=b;return}function wfh(){var b=0;b=i;if(a[3542368]|0){i=b;return}c[885590]=vM(3542376,92)|0;a[3542368]=1;i=b;return}function xfh(){var b=0;b=i;if(a[3542568]|0){i=b;return}c[885640]=vM(3541248,1)|0;a[3542568]=1;i=b;return}function yfh(){var b=0;b=i;if(a[3542584]|0){i=b;return}c[885644]=vM(3541248,1)|0;a[3542584]=1;i=b;return}function zfh(){var b=0;b=i;if(a[3542600]|0){i=b;return}c[885648]=vM(3541248,1)|0;a[3542600]=1;i=b;return}function Afh(){var b=0;b=i;if(a[3542616]|0){i=b;return}c[885652]=vM(3541248,1)|0;a[3542616]=1;i=b;return}function Bfh(){var b=0;b=i;if(a[3542760]|0){i=b;return}c[885656]=vM(3542768,2)|0;c[885658]=vM(3542776,2)|0;c[885660]=vM(3542768,2)|0;c[885662]=vM(3542776,2)|0;c[885664]=vM(3542784,2)|0;c[885666]=vM(3542792,2)|0;c[885668]=vM(3542784,2)|0;c[885670]=vM(3542792,2)|0;c[885672]=vM(3542800,2)|0;c[885674]=vM(3542808,2)|0;c[885676]=vM(3542800,2)|0;c[885678]=vM(3542808,2)|0;c[885680]=vM(3542816,3)|0;c[885682]=vM(3542824,3)|0;c[885684]=vM(3542816,3)|0;c[885686]=vM(3542824,3)|0;c[885688]=vM(3542832,34)|0;a[3542760]=1;i=b;return}function Cfh(){var b=0;b=i;if(a[3542976]|0){i=b;return}c[885726]=vM(3529032,1)|0;c[885728]=vM(3523384,2)|0;c[885730]=vM(3523384,2)|0;c[885732]=vM(3523384,2)|0;c[885734]=vM(3523384,2)|0;c[885736]=vM(3523384,2)|0;c[885738]=vM(3523384,2)|0;c[885740]=vM(3523384,2)|0;c[885742]=vM(3523384,2)|0;a[3542976]=1;i=b;return}function Dfh(){var b=0;b=i;if(a[3543056]|0){i=b;return}c[885746]=vM(3541824,8)|0;c[885748]=vM(3536984,5)|0;c[885750]=vM(3538112,6)|0;c[885752]=vM(3541840,29)|0;c[885754]=vM(3541824,8)|0;c[885756]=vM(3542376,92)|0;c[885758]=vM(3543064,126)|0;c[885760]=vM(3543320,61)|0;c[885762]=vM(3543320,61)|0;a[3543056]=1;i=b;return}function Efh(){var b=0;b=i;if(a[3543464]|0){i=b;return}c[885862]=vM(3523744,5)|0;c[885864]=vM(3543472,43)|0;a[3543464]=1;i=b;return}function Ffh(){var b=0;b=i;if(a[3543576]|0){i=b;return}c[885890]=vM(3523744,5)|0;c[885892]=vM(3543472,43)|0;a[3543576]=1;i=b;return}function Gfh(){var b=0;b=i;if(a[3543592]|0){i=b;return}c[885896]=vM(3543472,43)|0;a[3543592]=1;i=b;return}function Hfh(){var b=0;b=i;if(a[3543608]|0){i=b;return}c[885900]=vM(3543472,43)|0;a[3543608]=1;i=b;return}function Ifh(){var b=0;b=i;if(a[3543624]|0){i=b;return}c[885904]=vM(3543632,23)|0;a[3543624]=1;i=b;return}function Jfh(){var b=0;b=i;if(a[3543688]|0){i=b;return}c[885920]=vM(3543632,23)|0;a[3543688]=1;i=b;return}function Kfh(){var b=0;b=i;if(a[3543704]|0){i=b;return}c[885924]=vM(3543632,23)|0;a[3543704]=1;i=b;return}function Lfh(){var b=0;b=i;if(a[3543720]|0){i=b;return}c[885928]=vM(3543472,43)|0;a[3543720]=1;i=b;return}function Mfh(){var b=0;b=i;if(a[3543776]|0){i=b;return}c[885932]=vM(3523680,5)|0;c[885934]=vM(3543472,43)|0;c[885936]=vM(3543784,96)|0;c[885938]=vM(3543472,43)|0;c[885940]=vM(3523744,5)|0;c[885942]=vM(3543976,21)|0;a[3543776]=1;i=b;return}function Nfh(){var b=0;b=i;if(a[3544032]|0){i=b;return}c[886006]=vM(3543632,23)|0;a[3544032]=1;i=b;return}function Ofh(){var b=0;b=i;if(a[3544048]|0){i=b;return}c[886010]=vM(3543632,23)|0;a[3544048]=1;i=b;return}function Pfh(){var b=0;b=i;if(a[3544064]|0){i=b;return}c[886014]=vM(3543472,43)|0;a[3544064]=1;i=b;return}function Qfh(){var b=0;b=i;if(a[3544080]|0){i=b;return}c[886018]=vM(3523744,5)|0;a[3544080]=1;i=b;return}function Rfh(){var b=0;b=i;if(a[3544096]|0){i=b;return}c[886022]=vM(3523744,5)|0;a[3544096]=1;i=b;return}function Sfh(){var b=0;b=i;if(a[3544120]|0){i=b;return}c[886026]=vM(3544128,38)|0;c[886028]=vM(3544208,59)|0;a[3544120]=1;i=b;return}function Tfh(){var b=0;b=i;if(a[3544344]|0){i=b;return}c[886082]=vM(3523744,5)|0;c[886084]=vM(3544352,41)|0;a[3544344]=1;i=b;return}function Ufh(){var b=0;b=i;if(a[3544472]|0){i=b;return}c[886110]=vM(3544480,6)|0;c[886112]=vM(3544352,41)|0;c[886114]=vM(3544496,6)|0;c[886116]=vM(3544352,41)|0;a[3544472]=1;i=b;return}function Vfh(){var b=0;b=i;if(a[3544560]|0){i=b;return}c[886128]=vM(3544480,6)|0;c[886130]=vM(3544352,41)|0;c[886132]=vM(3544496,6)|0;c[886134]=vM(3544352,41)|0;c[886136]=vM(3544568,6)|0;c[886138]=vM(3544352,41)|0;a[3544560]=1;i=b;return}function Wfh(){var b=0;b=i;if(a[3544600]|0){i=b;return}c[886146]=vM(3523744,5)|0;c[886148]=vM(3544352,41)|0;a[3544600]=1;i=b;return}function Xfh(){var b=0;b=i;if(a[3544640]|0){i=b;return}c[886152]=vM(3544480,6)|0;c[886154]=vM(3544352,41)|0;c[886156]=vM(3544496,6)|0;c[886158]=vM(3544352,41)|0;a[3544640]=1;i=b;return}function Yfh(){var b=0;b=i;if(a[3544696]|0){i=b;return}c[886162]=vM(3544480,6)|0;c[886164]=vM(3544352,41)|0;c[886166]=vM(3544496,6)|0;c[886168]=vM(3544352,41)|0;c[886170]=vM(3544568,6)|0;c[886172]=vM(3544352,41)|0;a[3544696]=1;i=b;return}function Zfh(){var b=0;b=i;if(a[3544720]|0){i=b;return}c[886176]=vM(3544128,38)|0;c[886178]=vM(3544728,63)|0;a[3544720]=1;i=b;return}function _fh(){var b=0;b=i;if(a[3544904]|0){i=b;return}c[886214]=vM(3544912,11)|0;c[886216]=vM(3544936,7)|0;c[886218]=vM(3544952,44)|0;c[886220]=vM(3544912,11)|0;c[886222]=vM(3545040,26)|0;c[886224]=vM(3545096,42)|0;a[3544904]=1;i=b;return}function $fh(){var b=0;b=i;if(a[3545288]|0){i=b;return}c[886296]=vM(3544912,11)|0;c[886298]=vM(3544936,7)|0;c[886300]=vM(3545296,11)|0;c[886302]=vM(3544952,44)|0;c[886304]=vM(3544912,11)|0;c[886306]=vM(3545040,26)|0;c[886308]=vM(3545096,42)|0;c[886310]=vM(3545320,34)|0;c[886312]=vM(3545392,28)|0;c[886314]=vM(3544936,7)|0;c[886316]=vM(3545448,26)|0;c[886318]=vM(3544936,7)|0;c[886320]=vM(3545504,46)|0;a[3545288]=1;i=b;return}function agh(){var b=0;b=i;if(a[3545616]|0){i=b;return}c[886400]=vM(3538464,6)|0;c[886402]=vM(3545624,48)|0;a[3545616]=1;i=b;return}function bgh(){var b=0;b=i;if(a[3545728]|0){i=b;return}c[886430]=vM(3544936,7)|0;a[3545728]=1;i=b;return}function cgh(){var b=0;b=i;if(a[3545744]|0){i=b;return}c[886434]=vM(3545752,7)|0;a[3545744]=1;i=b;return}function dgh(){var b=0;b=i;if(a[3545776]|0){i=b;return}c[886442]=vM(3545752,7)|0;a[3545776]=1;i=b;return}function egh(){var b=0;b=i;if(a[3545808]|0){i=b;return}c[886446]=vM(3523680,5)|0;c[886448]=vM(3543472,43)|0;c[886450]=vM(3545816,35)|0;a[3545808]=1;i=b;return}function fgh(){var b=0;b=i;if(a[3545912]|0){i=b;return}c[886472]=vM(3523680,5)|0;c[886474]=vM(3543472,43)|0;c[886476]=vM(3545920,56)|0;a[3545912]=1;i=b;return}function ggh(){var b=0;b=i;if(a[3546096]|0){i=b;return}c[886508]=vM(3523680,5)|0;c[886510]=vM(3543472,43)|0;c[886512]=vM(3523744,5)|0;c[886514]=vM(3546104,44)|0;c[886516]=vM(3536528,6)|0;c[886518]=vM(3543976,21)|0;c[886520]=vM(3546192,55)|0;c[886522]=vM(3546304,34)|0;a[3546096]=1;i=b;return}function hgh(){var b=0;b=i;if(a[3546440]|0){i=b;return}c[886594]=vM(3523680,5)|0;c[886596]=vM(3543472,43)|0;c[886598]=vM(3523744,5)|0;c[886600]=vM(3546104,44)|0;c[886602]=vM(3536528,6)|0;c[886604]=vM(3543976,21)|0;c[886606]=vM(3546192,55)|0;c[886608]=vM(3545920,56)|0;a[3546440]=1;i=b;return}function igh(){var b=0;b=i;if(a[3546456]|0){i=b;return}c[886612]=vM(3546464,28)|0;a[3546456]=1;i=b;return}function jgh(){var b=0;b=i;if(a[3546552]|0){i=b;return}c[886630]=vM(3523680,5)|0;c[886632]=vM(3546560,10)|0;c[886634]=vM(3546584,19)|0;c[886636]=vM(3546624,21)|0;a[3546552]=1;i=b;return}function kgh(){var b=0;b=i;if(a[3546688]|0){i=b;return}c[886668]=vM(3546696,11)|0;c[886670]=vM(3546720,16)|0;a[3546688]=1;i=b;return}function lgh(){var b=0;b=i;if(a[3546856]|0){i=b;return}c[886688]=vM(3546696,11)|0;c[886690]=vM(3546720,16)|0;c[886692]=vM(3536528,6)|0;c[886694]=vM(3543976,21)|0;c[886696]=vM(3546864,11)|0;c[886698]=vM(3543976,21)|0;c[886700]=vM(3546888,16)|0;c[886702]=vM(3543976,21)|0;c[886704]=vM(3536528,6)|0;c[886706]=vM(3546920,95)|0;c[886708]=vM(3545392,28)|0;c[886710]=vM(3547112,32)|0;c[886712]=vM(3547112,32)|0;a[3546856]=1;i=b;return}function mgh(){var b=0;b=i;if(a[3547240]|0){i=b;return}c[886794]=vM(3546696,11)|0;c[886796]=vM(3546720,16)|0;c[886798]=vM(3546864,11)|0;c[886800]=vM(3547248,27)|0;c[886802]=vM(3546888,16)|0;c[886804]=vM(3547248,27)|0;c[886806]=vM(3536528,6)|0;c[886808]=vM(3544352,41)|0;a[3547240]=1;i=b;return}function ngh(){var b=0;b=i;if(a[3547320]|0){i=b;return}c[886826]=vM(3536528,6)|0;c[886828]=vM(3544352,41)|0;a[3547320]=1;i=b;return}function ogh(){var b=0;b=i;if(a[3547336]|0){i=b;return}c[886832]=vM(3523680,5)|0;a[3547336]=1;i=b;return}function pgh(){var b=0;b=i;if(a[3547352]|0){i=b;return}c[886836]=vM(3523680,5)|0;a[3547352]=1;i=b;return}function qgh(){var b=0;b=i;if(a[3547376]|0){i=b;return}c[886840]=vM(3523680,5)|0;c[886842]=vM(3543472,43)|0;a[3547376]=1;i=b;return}function rgh(){var b=0;b=i;if(a[3547392]|0){i=b;return}c[886846]=vM(3523680,5)|0;a[3547392]=1;i=b;return}function sgh(){var b=0;b=i;if(a[3547408]|0){i=b;return}c[886850]=vM(3523680,5)|0;a[3547408]=1;i=b;return}function tgh(){var b=0;b=i;if(a[3547432]|0){i=b;return}c[886854]=vM(3523680,5)|0;c[886856]=vM(3543472,43)|0;a[3547432]=1;i=b;return}function ugh(){var b=0;b=i;if(a[3547448]|0){i=b;return}c[886860]=vM(3523680,5)|0;a[3547448]=1;i=b;return}function vgh(){var b=0;b=i;if(a[3547472]|0){i=b;return}c[886864]=vM(3523680,5)|0;c[886866]=vM(3543472,43)|0;a[3547472]=1;i=b;return}function wgh(){var b=0;b=i;if(a[3547488]|0){i=b;return}c[886870]=vM(3523680,5)|0;a[3547488]=1;i=b;return}function xgh(){var b=0;b=i;if(a[3547504]|0){i=b;return}c[886874]=vM(3547512,4)|0;a[3547504]=1;i=b;return}function ygh(){var b=0;b=i;if(a[3547528]|0){i=b;return}c[886880]=vM(3523680,5)|0;a[3547528]=1;i=b;return}function zgh(){var b=0;b=i;if(a[3547544]|0){i=b;return}c[886884]=vM(3547512,4)|0;a[3547544]=1;i=b;return}function Agh(){var b=0;b=i;if(a[3547592]|0){i=b;return}c[886888]=vM(3547512,4)|0;c[886890]=vM(3523744,5)|0;c[886892]=vM(3536528,6)|0;c[886894]=vM(3543976,21)|0;c[886896]=vM(3547600,32)|0;a[3547592]=1;i=b;return}function Bgh(){var b=0;b=i;if(a[3547672]|0){i=b;return}c[886916]=vM(3523680,5)|0;a[3547672]=1;i=b;return}function Cgh(){var b=0;b=i;if(a[3547712]|0){i=b;return}c[886920]=vM(3547512,4)|0;c[886922]=vM(3523744,5)|0;c[886924]=vM(3536528,6)|0;c[886926]=vM(3547600,32)|0;a[3547712]=1;i=b;return}function Dgh(){var b=0;b=i;if(a[3547728]|0){i=b;return}c[886930]=vM(3547736,51)|0;a[3547728]=1;i=b;return}function Egh(){var b=0;b=i;if(a[3547888]|0){i=b;return}c[886960]=vM(3523680,5)|0;c[886962]=vM(3543472,43)|0;c[886964]=vM(3543784,96)|0;c[886966]=vM(3543472,43)|0;c[886968]=vM(3523744,5)|0;c[886970]=vM(3543976,21)|0;a[3547888]=1;i=b;return}function Fgh(){var b=0;b=i;if(a[3547912]|0){i=b;return}c[886974]=vM(3523744,5)|0;c[886976]=vM(3544352,41)|0;a[3547912]=1;i=b;return}function Ggh(){var b=0;b=i;if(a[3547944]|0){i=b;return}c[886984]=vM(3523680,5)|0;a[3547944]=1;i=b;return}function Hgh(){var b=0;b=i;if(a[3548008]|0){i=b;return}c[886988]=vM(3523680,5)|0;c[886990]=vM(3523744,5)|0;c[886992]=vM(3546104,44)|0;c[886994]=vM(3536528,6)|0;c[886996]=vM(3543976,21)|0;c[886998]=vM(3546192,55)|0;c[887e3]=vM(3546464,28)|0;a[3548008]=1;i=b;return}function Igh(){var b=0;b=i;if(a[3548024]|0){i=b;return}c[887004]=vM(3523680,5)|0;a[3548024]=1;i=b;return}function Jgh(){var b=0;b=i;if(a[3548040]|0){i=b;return}c[887008]=vM(3523680,5)|0;a[3548040]=1;i=b;return}function Kgh(){var b=0;b=i;if(a[3548064]|0){i=b;return}c[887012]=vM(3548072,42)|0;c[887014]=vM(3548160,28)|0;a[3548064]=1;i=b;return}function Lgh(){var b=0;b=i;if(a[3548232]|0){i=b;return}c[887054]=vM(3548240,28)|0;c[887056]=vM(3548296,29)|0;a[3548232]=1;i=b;return}function Mgh(){var b=0;b=i;if(a[3548368]|0){i=b;return}c[887090]=vM(3548376,8)|0;a[3548368]=1;i=b;return}function Ngh(){var b=0;b=i;if(a[3548400]|0){i=b;return}c[887098]=vM(3548408,4)|0;a[3548400]=1;i=b;return}function Ogh(){var b=0;b=i;if(a[3548424]|0){i=b;return}c[887104]=vM(3548408,4)|0;a[3548424]=1;i=b;return}function Pgh(){var b=0;b=i;if(a[3548456]|0){i=b;return}c[887108]=vM(3548408,4)|0;c[887110]=vM(3548464,5)|0;c[887112]=vM(3548464,5)|0;a[3548456]=1;i=b;return}function Qgh(){var b=0;b=i;if(a[3548488]|0){i=b;return}c[887120]=vM(3548408,4)|0;a[3548488]=1;i=b;return}function Rgh(){var b=0;b=i;if(a[3548520]|0){i=b;return}c[887124]=vM(3548408,4)|0;c[887126]=vM(3548464,5)|0;c[887128]=vM(3548464,5)|0;a[3548520]=1;i=b;return}function Sgh(){var b=0;b=i;if(a[3548544]|0){i=b;return}c[887132]=vM(3548464,5)|0;c[887134]=vM(3548464,5)|0;a[3548544]=1;i=b;return}function Tgh(){var b=0;b=i;if(a[3548560]|0){i=b;return}c[887138]=vM(3548568,47)|0;a[3548560]=1;i=b;return}function Ugh(){var b=0;b=i;if(a[3548712]|0){i=b;return}c[887166]=vM(3548720,29)|0;c[887168]=vM(3548784,13)|0;c[887170]=vM(3548816,155)|0;c[887172]=vM(3548784,13)|0;c[887174]=vM(3548784,13)|0;c[887176]=vM(3548784,13)|0;a[3548712]=1;i=b;return}function Vgh(){var b=0;b=i;if(a[3549136]|0){i=b;return}c[887282]=vM(3549144,35)|0;a[3549136]=1;i=b;return}function Wgh(){var b=0;b=i;if(a[3549288]|0){i=b;return}c[887304]=vM(3549296,9)|0;c[887306]=vM(3549320,2)|0;c[887308]=vM(3549328,16)|0;c[887310]=vM(3549360,6)|0;c[887312]=vM(3549320,2)|0;c[887314]=vM(3549376,14)|0;c[887316]=vM(3549408,12)|0;c[887318]=vM(3549432,12)|0;c[887320]=vM(3549456,11)|0;a[3549288]=1;i=b;return}function Xgh(){var b=0;b=i;if(a[3549576]|0){i=b;return}c[887370]=vM(3524360,4)|0;c[887372]=vM(3549584,9)|0;c[887374]=vM(3549608,7)|0;c[887376]=vM(3549624,14)|0;c[887378]=vM(3549656,7)|0;c[887380]=vM(3549672,16)|0;c[887382]=vM(3549704,22)|0;c[887384]=vM(3549752,16)|0;c[887386]=vM(3549784,7)|0;c[887388]=vM(3549800,6)|0;c[887390]=vM(3549816,15)|0;c[887392]=vM(3549848,4)|0;a[3549576]=1;i=b;return}function Ygh(){var b=0;b=i;if(a[3549888]|0){i=b;return}c[887464]=vM(3522648,2)|0;c[887466]=vM(3549896,6)|0;c[887468]=vM(3549912,42)|0;c[887470]=vM(355e4,44)|0;a[3549888]=1;i=b;return}function Zgh(){var b=0;b=i;if(a[3550160]|0){i=b;return}c[887522]=vM(3523360,1)|0;c[887524]=vM(3523136,1)|0;c[887526]=vM(3550168,1)|0;c[887528]=vM(3523144,1)|0;c[887530]=vM(3550176,2)|0;c[887532]=vM(3523384,2)|0;c[887534]=vM(3523360,1)|0;c[887536]=vM(3517392,1)|0;c[887538]=vM(3523256,1)|0;a[3550160]=1;i=b;return}function _gh(){var b=0;b=i;if(a[3550208]|0){i=b;return}c[887546]=vM(3524360,4)|0;c[887548]=vM(3550216,45)|0;c[887550]=vM(3550312,8)|0;a[3550208]=1;i=b;return}function $gh(){var b=0;b=i;if(a[3550352]|0){i=b;return}c[887582]=vM(3524360,4)|0;c[887584]=vM(3550216,45)|0;c[887586]=vM(3550360,7)|0;a[3550352]=1;i=b;return}function ahh(){var b=0;b=i;if(a[3550384]|0){i=b;return}c[887594]=vM(3550392,46)|0;a[3550384]=1;i=b;return}function bhh(){var b=0;b=i;if(a[3550496]|0){i=b;return}c[887622]=vM(3550504,36)|0;a[3550496]=1;i=b;return}function chh(){var b=0;b=i;if(a[3550584]|0){i=b;return}c[887644]=vM(3550592,34)|0;a[3550584]=1;i=b;return}function dhh(){var b=0;b=i;if(a[3550680]|0){i=b;return}c[887666]=vM(3550688,18)|0;c[887668]=vM(3550728,23)|0;a[3550680]=1;i=b;return}function ehh(){var b=0;b=i;if(a[3550784]|0){i=b;return}c[887694]=vM(3550792,109)|0;a[3550784]=1;i=b;return}function fhh(){var b=0;b=i;if(a[3551048]|0){i=b;return}c[887754]=vM(3551056,6)|0;c[887756]=vM(3551072,6)|0;c[887758]=vM(3551088,2)|0;c[887760]=vM(3551096,2)|0;a[3551048]=1;i=b;return}function ghh(){var b=0;b=i;if(a[3551224]|0){i=b;return}c[887776]=vM(3551056,6)|0;c[887778]=vM(3551072,6)|0;c[887780]=vM(3551088,2)|0;c[887782]=vM(3551096,2)|0;c[887784]=vM(3551232,6)|0;c[887786]=vM(3551248,6)|0;c[887788]=vM(3551264,5)|0;c[887790]=vM(3551280,5)|0;c[887792]=vM(3551296,17)|0;c[887794]=vM(3551056,6)|0;c[887796]=vM(3551072,6)|0;c[887798]=vM(3551088,2)|0;c[887800]=vM(3551096,2)|0;c[887802]=vM(3551280,5)|0;c[887804]=vM(3551336,22)|0;a[3551224]=1;i=b;return}function hhh(){var b=0;b=i;if(a[3551400]|0){i=b;return}c[887846]=vM(3551408,35)|0;c[887848]=vM(3551480,3)|0;a[3551400]=1;i=b;return}function ihh(){var b=0;b=i;if(a[3551496]|0){i=b;return}c[887872]=vM(3551504,88)|0;a[3551496]=1;i=b;return}function jhh(){var b=0;b=i;if(a[3551688]|0){i=b;return}c[887920]=vM(3551696,70)|0;a[3551688]=1;i=b;return}function khh(){var b=0;b=i;if(a[3551856]|0){i=b;return}c[887960]=vM(3551696,70)|0;c[887962]=vM(3551864,74)|0;a[3551856]=1;i=b;return}function lhh(){var b=0;b=i;if(a[3552024]|0){i=b;return}c[888004]=vM(3551696,70)|0;a[3552024]=1;i=b;return}function mhh(){var b=0;b=i;if(a[3552048]|0){i=b;return}c[888008]=vM(3552056,8)|0;c[888010]=vM(3552072,8)|0;a[3552048]=1;i=b;return}function nhh(){var b=0;b=i;if(a[3552112]|0){i=b;return}c[888022]=vM(3552120,10)|0;c[888024]=vM(3523384,2)|0;c[888026]=vM(3523384,2)|0;a[3552112]=1;i=b;return}function ohh(){var b=0;b=i;if(a[3552152]|0){i=b;return}c[888036]=vM(3552160,3)|0;a[3552152]=1;i=b;return}function phh(){var b=0;b=i;if(a[3552176]|0){i=b;return}c[888042]=vM(3552184,50)|0;a[3552176]=1;i=b;return}function qhh(){var b=0;b=i;if(a[3552296]|0){i=b;return}c[888072]=vM(3552304,3)|0;a[3552296]=1;i=b;return}function rhh(){var b=0;b=i;if(a[3552320]|0){i=b;return}c[888078]=vM(3552328,4)|0;a[3552320]=1;i=b;return}function shh(){var b=0;b=i;if(a[3552344]|0){i=b;return}c[888084]=vM(3552352,34)|0;a[3552344]=1;i=b;return}function thh(){var b=0;b=i;if(a[3552432]|0){i=b;return}c[888106]=vM(3523552,3)|0;a[3552432]=1;i=b;return}function uhh(){var b=0;b=i;if(a[3552448]|0){i=b;return}c[888110]=vM(3552456,8)|0;a[3552448]=1;i=b;return}function vhh(){var b=0;b=i;if(a[3552504]|0){i=b;return}c[888118]=vM(3523680,5)|0;c[888120]=vM(3523744,5)|0;c[888122]=vM(3552512,46)|0;c[888124]=vM(3552608,53)|0;a[3552504]=1;i=b;return}function whh(){var b=0;b=i;if(a[3552736]|0){i=b;return}c[888180]=vM(3552744,59)|0;c[888182]=vM(3523680,5)|0;a[3552736]=1;i=b;return}function xhh(){var b=0;b=i;if(a[3552880]|0){i=b;return}c[888216]=vM(3523552,3)|0;c[888218]=vM(3552888,62)|0;a[3552880]=1;i=b;return}function yhh(){var b=0;b=i;if(a[3553056]|0){i=b;return}c[888254]=vM(3524360,4)|0;c[888256]=vM(3524392,7)|0;c[888258]=vM(3524432,8)|0;c[888260]=vM(3553064,8)|0;c[888262]=vM(3553080,13)|0;a[3553056]=1;i=b;return}function zhh(){var b=0;b=i;if(a[3553120]|0){i=b;return}c[888278]=vM(3523552,3)|0;a[3553120]=1;i=b;return}function Ahh(){var b=0;b=i;if(a[3553136]|0){i=b;return}c[888282]=vM(3523552,3)|0;a[3553136]=1;i=b;return}function Bhh(){var b=0;b=i;if(a[3553168]|0){i=b;return}c[888286]=vM(3523552,3)|0;c[888288]=vM(3553176,13)|0;c[888290]=vM(3523552,3)|0;a[3553168]=1;i=b;return}function Chh(){var b=0;b=i;if(a[3553224]|0){i=b;return}c[888302]=vM(3553176,13)|0;c[888304]=vM(3536984,5)|0;a[3553224]=1;i=b;return}function Dhh(){var b=0;b=i;if(a[3553240]|0){i=b;return}c[888308]=vM(3553248,11)|0;a[3553240]=1;i=b;return}function Ehh(){var b=0;b=i;if(a[3553280]|0){i=b;return}c[888318]=vM(3553288,20)|0;a[3553280]=1;i=b;return}function Fhh(){var b=0;b=i;if(a[3553336]|0){i=b;return}c[888332]=vM(3553344,10)|0;a[3553336]=1;i=b;return}function Ghh(){var b=0;b=i;if(a[3553376]|0){i=b;return}c[888342]=vM(3553384,30)|0;a[3553376]=1;i=b;return}function Hhh(){var b=0;b=i;if(a[3553456]|0){i=b;return}c[888362]=vM(3553384,30)|0;a[3553456]=1;i=b;return}function Ihh(){var b=0;b=i;if(a[3553472]|0){i=b;return}c[888366]=vM(3553384,30)|0;a[3553472]=1;i=b;return}function Jhh(){var b=0;b=i;if(a[3553504]|0){i=b;return}c[888370]=vM(3523136,1)|0;c[888372]=vM(3523384,2)|0;c[888374]=vM(3523144,1)|0;a[3553504]=1;i=b;return}function Khh(){var b=0;b=i;if(a[3553520]|0){i=b;return}c[888378]=vM(3536984,5)|0;a[3553520]=1;i=b;return}function Lhh(){var b=0;b=i;if(a[3553536]|0){i=b;return}c[888382]=vM(3523744,5)|0;a[3553536]=1;i=b;return}function Mhh(){var b=0;b=i;if(a[3553552]|0){i=b;return}c[888386]=vM(3523744,5)|0;a[3553552]=1;i=b;return}function Nhh(){var b=0;b=i;if(a[3553568]|0){i=b;return}c[888390]=vM(3552456,8)|0;a[3553568]=1;i=b;return}function Ohh(){var b=0;b=i;if(a[3553584]|0){i=b;return}c[888394]=vM(3553592,4)|0;a[3553584]=1;i=b;return}function Phh(){var b=0;b=i;if(a[3553608]|0){i=b;return}c[888400]=vM(3553592,4)|0;a[3553608]=1;i=b;return}function Qhh(){var b=0;b=i;if(a[3553624]|0){i=b;return}c[888404]=vM(3523744,5)|0;a[3553624]=1;i=b;return}function Rhh(){var b=0;b=i;if(a[3553640]|0){i=b;return}c[888408]=vM(3523744,5)|0;a[3553640]=1;i=b;return}function Shh(){var b=0;b=i;if(a[3553656]|0){i=b;return}c[888412]=vM(3553664,63)|0;a[3553656]=1;i=b;return}function Thh(){var b=0;b=i;if(a[3553816]|0){i=b;return}c[888450]=vM(3523744,5)|0;c[888452]=vM(3553824,61)|0;a[3553816]=1;i=b;return}function Uhh(){var b=0;b=i;if(a[3553968]|0){i=b;return}c[888488]=vM(3523744,5)|0;c[888490]=vM(3553824,61)|0;a[3553968]=1;i=b;return}function Vhh(){var b=0;b=i;if(a[3553992]|0){i=b;return}c[888494]=vM(3552456,8)|0;c[888496]=vM(3554e3,48)|0;a[3553992]=1;i=b;return}function Whh(){var b=0;b=i;if(a[3554144]|0){i=b;return}c[888524]=vM(3536496,10)|0;c[888526]=vM(3554152,29)|0;c[888528]=vM(3536656,5)|0;c[888530]=vM(3554216,21)|0;c[888532]=vM(3536656,5)|0;c[888534]=vM(3554264,51)|0;a[3554144]=1;i=b;return}function Xhh(){var b=0;b=i;if(a[3554384]|0){i=b;return}c[888592]=vM(3523744,5)|0;c[888594]=vM(3554392,32)|0;a[3554384]=1;i=b;return}function Yhh(){var b=0;b=i;if(a[3554480]|0){i=b;return}c[888614]=vM(3554488,1)|0;c[888616]=vM(3523744,5)|0;c[888618]=vM(3554392,32)|0;a[3554480]=1;i=b;return}function Zhh(){var b=0;b=i;if(a[3554512]|0){i=b;return}c[888624]=vM(3523744,5)|0;c[888626]=vM(3554520,36)|0;a[3554512]=1;i=b;return}function _hh(){var b=0;b=i;if(a[3554616]|0){i=b;return}c[888648]=vM(3523680,5)|0;c[888650]=vM(3554624,28)|0;c[888652]=vM(3523680,5)|0;a[3554616]=1;i=b;return}function $hh(){var b=0;b=i;if(a[3554688]|0){i=b;return}c[888670]=vM(3553792,4)|0;a[3554688]=1;i=b;return}function aih(){var b=0;b=i;if(a[3554712]|0){i=b;return}c[888674]=vM(3554720,22)|0;c[888676]=vM(3554768,16)|0;a[3554712]=1;i=b;return}function bih(){var b=0;b=i;if(a[3554808]|0){i=b;return}c[888700]=vM(3554816,17)|0;a[3554808]=1;i=b;return}function cih(){var b=0;b=i;if(a[3554864]|0){i=b;return}c[888714]=vM(3536528,6)|0;a[3554864]=1;i=b;return}function dih(){var b=0;b=i;if(a[3554936]|0){i=b;return}c[888718]=vM(3523680,5)|0;c[888720]=vM(3523744,5)|0;c[888722]=vM(3523680,5)|0;c[888724]=vM(3554944,20)|0;c[888726]=vM(3523744,5)|0;c[888728]=vM(3554984,34)|0;c[888730]=vM(3523680,5)|0;c[888732]=vM(3555056,16)|0;a[3554936]=1;i=b;return}function eih(){var b=0;b=i;if(a[3555104]|0){i=b;return}c[888772]=vM(3555112,16)|0;c[888774]=vM(3555144,10)|0;a[3555104]=1;i=b;return}function fih(){var b=0;b=i;if(a[3555176]|0){i=b;return}c[888792]=vM(3536384,7)|0;a[3555176]=1;i=b;return}function gih(){var b=0;b=i;if(a[3555192]|0){i=b;return}c[888796]=vM(3555200,3)|0;a[3555192]=1;i=b;return}function hih(){var b=0;b=i;if(a[3555216]|0){i=b;return}c[888802]=vM(3523744,5)|0;a[3555216]=1;i=b;return}function iih(){var b=0;b=i;if(a[3555240]|0){i=b;return}c[888806]=vM(3555248,28)|0;c[888808]=vM(3536984,5)|0;a[3555240]=1;i=b;return}function jih(){var b=0;b=i;if(a[3555312]|0){i=b;return}c[888826]=vM(3555320,73)|0;a[3555312]=1;i=b;return}function kih(){var b=0;b=i;if(a[3555480]|0){i=b;return}c[888868]=vM(3536384,7)|0;a[3555480]=1;i=b;return}function lih(){var b=0;b=i;if(a[3555496]|0){i=b;return}c[888872]=vM(3555504,43)|0;a[3555496]=1;i=b;return}function mih(){var b=0;b=i;if(a[3555608]|0){i=b;return}c[888898]=vM(3524360,4)|0;c[888900]=vM(3555616,11)|0;a[3555608]=1;i=b;return}function nih(){var b=0;b=i;if(a[3555656]|0){i=b;return}c[888910]=vM(3523552,3)|0;c[888912]=vM(3555664,8)|0;a[3555656]=1;i=b;return}function oih(){var b=0;b=i;if(a[3555720]|0){i=b;return}c[888920]=vM(3552456,8)|0;c[888922]=vM(3555728,17)|0;c[888924]=vM(3555768,10)|0;c[888926]=vM(3555792,11)|0;c[888928]=vM(3555816,15)|0;a[3555720]=1;i=b;return}function pih(){var b=0;b=i;if(a[3555856]|0){i=b;return}c[888962]=vM(3553344,10)|0;a[3555856]=1;i=b;return}function qih(){var b=0;b=i;if(a[3555904]|0){i=b;return}c[888966]=vM(3523680,5)|0;c[888968]=vM(3524552,10)|0;c[888970]=vM(3524824,25)|0;c[888972]=vM(3524576,51)|0;c[888974]=vM(3555912,66)|0;a[3555904]=1;i=b;return}function rih(){var b=0;b=i;if(a[3556128]|0){i=b;return}c[889012]=vM(3524360,4)|0;c[889014]=vM(3556136,10)|0;c[889016]=vM(3524392,7)|0;c[889018]=vM(3524368,11)|0;c[889020]=vM(3524432,8)|0;c[889022]=vM(3556160,16)|0;c[889024]=vM(3553064,8)|0;c[889026]=vM(3524480,4)|0;c[889028]=vM(3524488,6)|0;c[889030]=vM(3556192,16)|0;a[3556128]=1;i=b;return}function sih(){var b=0;b=i;if(a[3556232]|0){i=b;return}c[889056]=vM(3556240,5)|0;a[3556232]=1;i=b;return}function tih(){var b=0;b=i;if(a[3556272]|0){i=b;return}c[889064]=vM(3523552,3)|0;c[889066]=vM(3555664,8)|0;a[3556272]=1;i=b;return}function uih(){var b=0;b=i;if(a[3556304]|0){i=b;return}c[889070]=vM(3523552,3)|0;c[889072]=vM(3555664,8)|0;c[889074]=vM(3556312,29)|0;a[3556304]=1;i=b;return}function vih(){var b=0;b=i;if(a[3556384]|0){i=b;return}c[889094]=vM(3556392,19)|0;a[3556384]=1;i=b;return}function wih(){var b=0;b=i;if(a[3556440]|0){i=b;return}c[889108]=vM(3556448,43)|0;a[3556440]=1;i=b;return}function xih(){var b=0;b=i;if(a[3556568]|0){i=b;return}c[889134]=vM(3523680,5)|0;c[889136]=vM(3523680,5)|0;c[889138]=vM(3524552,10)|0;c[889140]=vM(3556576,16)|0;a[3556568]=1;i=b;return}function yih(){var b=0;b=i;if(a[3556640]|0){i=b;return}c[889152]=vM(3523680,5)|0;c[889154]=vM(3523680,5)|0;c[889156]=vM(3524552,10)|0;c[889158]=vM(3556576,16)|0;a[3556640]=1;i=b;return}function zih(){var b=0;b=i;if(a[3556664]|0){i=b;return}c[889162]=vM(3523680,5)|0;c[889164]=vM(3523744,5)|0;a[3556664]=1;i=b;return}function Aih(){var b=0;b=i;if(a[3556680]|0){i=b;return}c[889168]=vM(3556688,18)|0;a[3556680]=1;i=b;return}function Bih(){var b=0;b=i;if(a[3556776]|0){i=b;return}c[889182]=vM(3549328,16)|0;c[889184]=vM(3556784,4)|0;c[889186]=vM(3556792,16)|0;c[889188]=vM(3556824,7)|0;c[889190]=vM(3556840,21)|0;c[889192]=vM(3556888,8)|0;a[3556776]=1;i=b;return}function Cih(){var b=0;b=i;if(a[3556928]|0){i=b;return}c[889226]=vM(3556936,1)|0;c[889228]=vM(3536520,3)|0;c[889230]=vM(3556944,10)|0;a[3556928]=1;i=b;return}function Dih(){var b=0;b=i;if(a[3556984]|0){i=b;return}c[889242]=vM(3536520,3)|0;c[889244]=vM(3556944,10)|0;a[3556984]=1;i=b;return}function Eih(){var b=0;b=i;if(a[3557104]|0){i=b;return}c[889248]=vM(3557112,10)|0;c[889250]=vM(3549320,2)|0;c[889252]=vM(3549328,16)|0;c[889254]=vM(3557136,16)|0;c[889256]=vM(3557168,7)|0;c[889258]=vM(3549320,2)|0;c[889260]=vM(3557184,7)|0;c[889262]=vM(3523376,1)|0;c[889264]=vM(3523384,2)|0;c[889266]=vM(3523360,1)|0;c[889268]=vM(3557200,6)|0;c[889270]=vM(3557216,4)|0;c[889272]=vM(3523256,1)|0;c[889274]=vM(3556688,18)|0;a[3557104]=1;i=b;return}function Fih(){var b=0;b=i;if(a[3557232]|0){i=b;return}c[889306]=vM(3557240,37)|0;a[3557232]=1;i=b;return}function Gih(){var b=0;b=i;if(a[3557328]|0){i=b;return}c[889330]=vM(3557336,27)|0;a[3557328]=1;i=b;return}function Hih(){var b=0;b=i;if(a[3557408]|0){i=b;return}c[889348]=vM(3557416,30)|0;c[889350]=vM(3551480,3)|0;a[3557408]=1;i=b;return}function Iih(){var b=0;b=i;if(a[3557488]|0){i=b;return}c[889370]=vM(3528792,7)|0;a[3557488]=1;i=b;return}function Jih(){var b=0;b=i;if(a[3557544]|0){i=b;return}c[889374]=vM(3528792,7)|0;c[889376]=vM(3557552,46)|0;c[889378]=vM(3557648,57)|0;c[889380]=vM(3557768,57)|0;c[889382]=vM(3557888,83)|0;c[889384]=vM(3558056,83)|0;a[3557544]=1;i=b;return}function Kih(){var b=0;b=i;if(a[3558240]|0){i=b;return}c[889556]=vM(3558248,27)|0;c[889558]=vM(3528792,7)|0;a[3558240]=1;i=b;return}function Lih(){var b=0;b=i;if(a[3558344]|0){i=b;return}c[889576]=vM(3558352,6)|0;c[889578]=vM(3536984,5)|0;c[889580]=vM(3536496,10)|0;c[889582]=vM(3536656,5)|0;c[889584]=vM(3528792,7)|0;a[3558344]=1;i=b;return}function Mih(){var b=0;b=i;if(a[3558384]|0){i=b;return}c[889592]=vM(3558352,6)|0;c[889594]=vM(3558392,6)|0;a[3558384]=1;i=b;return}function Nih(){var b=0;b=i;if(a[3558424]|0){i=b;return}c[889602]=vM(3558352,6)|0;c[889604]=vM(3558432,6)|0;a[3558424]=1;i=b;return}function Oih(){var b=0;b=i;if(a[3558488]|0){i=b;return}c[889612]=vM(3558352,6)|0;c[889614]=vM(3536984,5)|0;c[889616]=vM(3536496,10)|0;c[889618]=vM(3536656,5)|0;c[889620]=vM(3528792,7)|0;a[3558488]=1;i=b;return}function Pih(){var b=0;b=i;if(a[3558504]|0){i=b;return}c[889624]=vM(3558512,14)|0;a[3558504]=1;i=b;return}function Qih(){var b=0;b=i;if(a[3558576]|0){i=b;return}c[889636]=vM(3536384,7)|0;c[889638]=vM(3558584,25)|0;c[889640]=vM(3558640,53)|0;c[889642]=vM(3536384,7)|0;a[3558576]=1;i=b;return}function Rih(){var b=0;b=i;if(a[3558784]|0){i=b;return}c[889688]=vM(3548408,4)|0;c[889690]=vM(3558792,13)|0;c[889692]=vM(3558824,18)|0;c[889694]=vM(3548408,4)|0;a[3558784]=1;i=b;return}function Sih(){var b=0;b=i;if(a[3558872]|0){i=b;return}c[889716]=vM(3558880,26)|0;a[3558872]=1;i=b;return}function Tih(){var b=0;b=i;if(a[3558952]|0){i=b;return}c[889734]=vM(3558960,9)|0;c[889736]=vM(3558984,129)|0;a[3558952]=1;i=b;return}function Uih(){var b=0;b=i;if(a[3559280]|0){i=b;return}c[889812]=vM(3559288,7)|0;c[889814]=vM(3559304,7)|0;c[889816]=vM(3559320,6)|0;c[889818]=vM(3559336,6)|0;a[3559280]=1;i=b;return}function Vih(){var b=0;b=i;if(a[3559392]|0){i=b;return}c[889838]=vM(3559400,38)|0;c[889840]=vM(3559480,3)|0;c[889842]=vM(3559488,2)|0;c[889844]=vM(3559496,11)|0;c[889846]=vM(3559480,3)|0;a[3559392]=1;i=b;return}function Wih(){var b=0;b=i;if(a[3559528]|0){i=b;return}c[889880]=vM(3517392,1)|0;a[3559528]=1;i=b;return}function Xih(){var b=0;b=i;if(a[3559544]|0){i=b;return}c[889884]=vM(3559552,38)|0;a[3559544]=1;i=b;return}function Yih(){var b=0;b=i;if(a[3559744]|0){i=b;return}c[889908]=vM(3559752,2)|0;c[889910]=vM(3559760,2)|0;c[889912]=vM(3531448,1)|0;c[889914]=vM(3523368,1)|0;c[889916]=vM(3559768,10)|0;c[889918]=vM(3559792,18)|0;c[889920]=vM(3559832,5)|0;c[889922]=vM(3559848,8)|0;c[889924]=vM(3559864,7)|0;c[889926]=vM(3559880,9)|0;c[889928]=vM(3559904,27)|0;c[889930]=vM(3559960,35)|0;c[889932]=vM(3560032,29)|0;c[889934]=vM(3560096,30)|0;a[3559744]=1;i=b;return}function Zih(){var b=0;b=i;if(a[3560544]|0){i=b;return}c[890040]=vM(3558880,26)|0;c[890042]=vM(3560552,43)|0;c[890044]=vM(3560640,42)|0;c[890046]=vM(3560728,3)|0;c[890048]=vM(3560736,3)|0;c[890050]=vM(3560744,3)|0;c[890052]=vM(3560752,3)|0;c[890054]=vM(3560760,3)|0;c[890056]=vM(3560768,3)|0;c[890058]=vM(3560776,3)|0;c[890060]=vM(3560784,6)|0;c[890062]=vM(3560800,6)|0;c[890064]=vM(3560816,7)|0;c[890066]=vM(3560832,9)|0;c[890068]=vM(3560856,8)|0;c[890070]=vM(3560872,6)|0;c[890072]=vM(3560888,8)|0;c[890074]=vM(3560904,3)|0;c[890076]=vM(3560912,3)|0;c[890078]=vM(3560920,3)|0;c[890080]=vM(3560928,3)|0;c[890082]=vM(3560936,3)|0;c[890084]=vM(3560944,3)|0;c[890086]=vM(3560952,3)|0;c[890088]=vM(3560960,3)|0;c[890090]=vM(3560968,3)|0;c[890092]=vM(3560976,3)|0;c[890094]=vM(3560984,3)|0;c[890096]=vM(3560992,3)|0;c[890098]=vM(3561e3,7)|0;c[890100]=vM(3561016,8)|0;c[890102]=vM(3561032,5)|0;c[890104]=vM(3561048,5)|0;c[890106]=vM(3560936,3)|0;c[890108]=vM(3561064,4)|0;c[890110]=vM(3561072,4)|0;c[890112]=vM(3561080,6)|0;c[890114]=vM(3561096,9)|0;c[890116]=vM(3561120,7)|0;c[890118]=vM(3561136,8)|0;c[890120]=vM(3561152,8)|0;c[890122]=vM(3561168,2)|0;c[890124]=vM(3561176,2)|0;c[890126]=vM(3561184,2)|0;c[890128]=vM(3561192,2)|0;c[890130]=vM(3561200,2)|0;c[890132]=vM(3561208,2)|0;c[890134]=vM(3561216,2)|0;a[3560544]=1;i=b;return}function _ih(){var b=0;b=i;if(a[3561232]|0){i=b;return}c[890306]=vM(3561240,3)|0;a[3561232]=1;i=b;return}function $ih(){var b=0;b=i;if(a[3561288]|0){i=b;return}c[890312]=vM(3517392,1)|0;c[890314]=vM(3517392,1)|0;c[890316]=vM(3517392,1)|0;c[890318]=vM(3517392,1)|0;c[890320]=vM(3561296,29)|0;a[3561288]=1;i=b;return}function ajh(){var b=0;b=i;if(a[3561432]|0){i=b;return}c[890340]=vM(3559768,10)|0;c[890342]=vM(3559792,18)|0;c[890344]=vM(3559848,8)|0;c[890346]=vM(3559832,5)|0;c[890348]=vM(3561440,8)|0;c[890350]=vM(3561456,4)|0;c[890352]=vM(3561464,7)|0;c[890354]=vM(3559864,7)|0;c[890356]=vM(3559880,9)|0;a[3561432]=1;i=b;return}function bjh(){var b=0;b=i;if(a[3561488]|0){i=b;return}c[890370]=vM(3517392,1)|0;a[3561488]=1;i=b;return}function cjh(){var b=0;b=i;if(a[3561512]|0){i=b;return}c[890374]=vM(3561520,2)|0;c[890376]=vM(3561528,4)|0;a[3561512]=1;i=b;return}function djh(){var b=0;b=i;if(a[3561552]|0){i=b;return}c[890384]=vM(3561560,70)|0;c[890386]=vM(3561704,67)|0;a[3561552]=1;i=b;return}function ejh(){var b=0;b=i;if(a[3561968]|0){i=b;return}c[890460]=vM(3532192,1)|0;c[890462]=vM(3529032,1)|0;c[890464]=vM(3523360,1)|0;c[890466]=vM(3550168,1)|0;c[890468]=vM(3561976,1)|0;c[890470]=vM(3561984,3)|0;c[890472]=vM(3561992,9)|0;c[890474]=vM(3517496,1)|0;c[890476]=vM(3523360,1)|0;c[890478]=vM(3550168,1)|0;c[890480]=vM(3523360,1)|0;c[890482]=vM(3550168,1)|0;c[890484]=vM(3531280,1)|0;c[890486]=vM(3562016,1)|0;c[890488]=vM(3562024,8)|0;c[890490]=vM(3517504,1)|0;a[3561968]=1;i=b;return}function fjh(){var b=0;b=i;if(a[3562120]|0){i=b;return}c[890510]=vM(3529032,1)|0;c[890512]=vM(3541224,1)|0;c[890514]=vM(3562128,1)|0;c[890516]=vM(3562136,1)|0;c[890518]=vM(3562144,1)|0;c[890520]=vM(3562152,1)|0;c[890522]=vM(3562160,1)|0;c[890524]=vM(3562168,1)|0;c[890526]=vM(3562176,1)|0;c[890528]=vM(3562184,1)|0;a[3562120]=1;i=b;return}function gjh(){var b=0;b=i;if(a[3562200]|0){i=b;return}c[890548]=vM(3562208,11)|0;a[3562200]=1;i=b;return}function hjh(){var b=0;b=i;if(a[3562240]|0){i=b;return}c[890558]=vM(3562248,3)|0;a[3562240]=1;i=b;return}function ijh(){var b=0;b=i;if(a[3562272]|0){i=b;return}c[890564]=vM(3562280,22)|0;c[890566]=vM(3562328,35)|0;a[3562272]=1;i=b;return}function jjh(){var b=0;b=i;if(a[3562416]|0){i=b;return}c[890600]=vM(3562280,22)|0;c[890602]=vM(3562328,35)|0;a[3562416]=1;i=b;return}function kjh(){var b=0;b=i;if(a[3562464]|0){i=b;return}c[890606]=vM(3562472,9)|0;c[890608]=vM(3562496,6)|0;c[890610]=vM(3562512,8)|0;c[890612]=vM(3562528,6)|0;c[890614]=vM(3562544,15)|0;a[3562464]=1;i=b;return}function ljh(){var b=0;b=i;if(a[3562640]|0){i=b;return}c[890644]=vM(3562280,22)|0;c[890646]=vM(3523680,5)|0;c[890648]=vM(3562648,6)|0;c[890650]=vM(3536520,3)|0;c[890652]=vM(3536656,5)|0;c[890654]=vM(3536520,3)|0;c[890656]=vM(3562664,28)|0;c[890658]=vM(3562720,31)|0;a[3562640]=1;i=b;return}function mjh(){var b=0;b=i;if(a[3562848]|0){i=b;return}c[890696]=vM(3562280,22)|0;c[890698]=vM(3562856,36)|0;c[890700]=vM(3523680,5)|0;c[890702]=vM(3562928,8)|0;c[890704]=vM(3562944,12)|0;c[890706]=vM(3562648,6)|0;c[890708]=vM(3562944,12)|0;c[890710]=vM(3562968,39)|0;a[3562848]=1;i=b;return}function njh(){var b=0;b=i;if(a[3563088]|0){i=b;return}c[890762]=vM(3563096,11)|0;c[890764]=vM(3563120,20)|0;c[890766]=vM(3563096,11)|0;c[890768]=vM(3563120,20)|0;c[890770]=vM(3563096,11)|0;a[3563088]=1;i=b;return}function ojh(){var b=0;b=i;if(a[3563168]|0){i=b;return}c[890790]=vM(3562280,22)|0;a[3563168]=1;i=b;return}function pjh(){var b=0;b=i;if(a[3563192]|0){i=b;return}c[890794]=vM(3563200,10)|0;c[890796]=vM(3558584,25)|0;a[3563192]=1;i=b;return}function qjh(){var b=0;b=i;if(a[3563256]|0){i=b;return}c[890806]=vM(3563264,31)|0;c[890808]=vM(3536984,5)|0;c[890810]=vM(3563328,66)|0;c[890812]=vM(3517392,1)|0;a[3563256]=1;i=b;return}function rjh(){var b=0;b=i;if(a[3563472]|0){i=b;return}c[890866]=vM(3552456,8)|0;a[3563472]=1;i=b;return}function sjh(){var b=0;b=i;if(a[3563488]|0){i=b;return}c[890870]=vM(3563496,12)|0;a[3563488]=1;i=b;return}function tjh(){var b=0;b=i;if(a[3563552]|0){i=b;return}c[890880]=vM(3563560,28)|0;c[890882]=vM(3563616,6)|0;c[890884]=vM(3563632,12)|0;c[890886]=vM(3563656,51)|0;a[3563552]=1;i=b;return}function ujh(){var b=0;b=i;if(a[3563776]|0){i=b;return}c[890940]=vM(3563784,29)|0;c[890942]=vM(3563848,40)|0;a[3563776]=1;i=b;return}function vjh(){var b=0;b=i;if(a[3564072]|0){i=b;return}c[890982]=vM(3564080,25)|0;c[890984]=vM(3564136,19)|0;c[890986]=vM(3564176,39)|0;c[890988]=vM(3564256,35)|0;c[890990]=vM(3564328,28)|0;c[890992]=vM(3564384,85)|0;c[890994]=vM(3564560,49)|0;c[890996]=vM(3564664,27)|0;c[890998]=vM(3564720,17)|0;c[891e3]=vM(3564760,23)|0;c[891002]=vM(3564808,29)|0;c[891004]=vM(3564872,26)|0;c[891006]=vM(3564928,19)|0;c[891008]=vM(3564968,26)|0;c[891010]=vM(3565024,17)|0;c[891012]=vM(3565064,23)|0;c[891014]=vM(3565112,49)|0;c[891016]=vM(3565216,32)|0;a[3564072]=1;i=b;return}function wjh(){var b=0;b=i;if(a[3565312]|0){i=b;return}c[891320]=vM(3565320,5)|0;c[891322]=vM(3565336,5)|0;c[891324]=vM(3565352,27)|0;c[891326]=vM(3565352,27)|0;a[3565312]=1;i=b;return}function xjh(){var b=0;b=i;if(a[3565416]|0){i=b;return}c[891352]=vM(3565352,27)|0;a[3565416]=1;i=b;return}function yjh(){var b=0;b=i;if(a[3565456]|0){i=b;return}c[891356]=vM(3565464,4)|0;c[891358]=vM(3565472,50)|0;c[891360]=vM(3565576,47)|0;c[891362]=vM(3565672,2)|0;a[3565456]=1;i=b;return}function zjh(){var b=0;b=i;if(a[3565688]|0){i=b;return}c[891420]=vM(3565696,42)|0;a[3565688]=1;i=b;return}function Ajh(){var b=0;b=i;if(a[3565792]|0){i=b;return}c[891446]=vM(3565352,27)|0;a[3565792]=1;i=b;return}function Bjh(){var b=0;b=i;if(a[3565816]|0){i=b;return}c[891450]=vM(3523360,1)|0;c[891452]=vM(3532752,2)|0;a[3565816]=1;i=b;return}function Cjh(){var b=0;b=i;if(a[3565832]|0){i=b;return}c[891456]=vM(3562856,36)|0;a[3565832]=1;i=b;return}function Djh(){var b=0;b=i;if(a[3565872]|0){i=b;return}c[891460]=vM(3563096,11)|0;c[891462]=vM(3563120,20)|0;c[891464]=vM(3563096,11)|0;c[891466]=vM(3565880,24)|0;a[3565872]=1;i=b;return}function Ejh(){var b=0;b=i;if(a[3565968]|0){i=b;return}c[891482]=vM(3565976,6)|0;c[891484]=vM(3565992,8)|0;c[891486]=vM(3566008,18)|0;c[891488]=vM(3563200,10)|0;c[891490]=vM(3566048,47)|0;a[3565968]=1;i=b;return}function Fjh(){var b=0;b=i;if(a[3566176]|0){i=b;return}c[891536]=vM(3565976,6)|0;c[891538]=vM(3565992,8)|0;c[891540]=vM(3563200,10)|0;c[891542]=vM(3566184,23)|0;a[3566176]=1;i=b;return}function Gjh(){var b=0;b=i;if(a[3566240]|0){i=b;return}c[891558]=vM(3566248,12)|0;a[3566240]=1;i=b;return}function Hjh(){var b=0;b=i;if(a[3566328]|0){i=b;return}c[891568]=vM(3566248,12)|0;c[891570]=vM(3563616,6)|0;c[891572]=vM(3523744,5)|0;c[891574]=vM(3536520,3)|0;c[891576]=vM(3536656,5)|0;c[891578]=vM(3536520,3)|0;c[891580]=vM(3566336,29)|0;a[3566328]=1;i=b;return}function Ijh(){var b=0;b=i;if(a[3566408]|0){i=b;return}c[891600]=vM(3566248,12)|0;a[3566408]=1;i=b;return}function Jjh(){var b=0;b=i;if(a[3566424]|0){i=b;return}c[891604]=vM(3566248,12)|0;a[3566424]=1;i=b;return}function Kjh(){var b=0;b=i;if(a[3566440]|0){i=b;return}c[891608]=vM(3566248,12)|0;a[3566440]=1;i=b;return}function Ljh(){var b=0;b=i;if(a[3566456]|0){i=b;return}c[891612]=vM(3566464,14)|0;a[3566456]=1;i=b;return}function Mjh(){var b=0;b=i;if(a[3566504]|0){i=b;return}c[891624]=vM(3566512,14)|0;a[3566504]=1;i=b;return}function Njh(){var b=0;b=i;if(a[3566568]|0){i=b;return}c[891636]=vM(3563616,6)|0;c[891638]=vM(3523744,5)|0;c[891640]=vM(3536656,5)|0;a[3566568]=1;i=b;return}function Ojh(){var b=0;b=i;if(a[3566592]|0){i=b;return}c[891644]=vM(3566600,21)|0;c[891646]=vM(3566648,2)|0;a[3566592]=1;i=b;return}function Pjh(){var b=0;b=i;if(a[3566664]|0){i=b;return}c[891664]=vM(3566672,56)|0;a[3566664]=1;i=b;return}function Qjh(){var b=0;b=i;if(a[3566792]|0){i=b;return}c[891696]=vM(3566800,28)|0;a[3566792]=1;i=b;return}function Rjh(){var b=0;b=i;if(a[3566864]|0){i=b;return}c[891714]=vM(3566672,56)|0;a[3566864]=1;i=b;return}function Sjh(){var b=0;b=i;if(a[3566880]|0){i=b;return}c[891718]=vM(3566672,56)|0;a[3566880]=1;i=b;return}function Tjh(){var b=0;b=i;if(a[3566912]|0){i=b;return}c[891722]=vM(3566920,15)|0;c[891724]=vM(3526360,2)|0;c[891726]=vM(3523144,1)|0;a[3566912]=1;i=b;return}function Ujh(){var b=0;b=i;if(a[3566960]|0){i=b;return}c[891738]=vM(3566672,56)|0;a[3566960]=1;i=b;return}function Vjh(){var b=0;b=i;if(a[3566976]|0){i=b;return}c[891742]=vM(3523384,2)|0;a[3566976]=1;i=b;return}function Wjh(){var b=0;b=i;if(a[3566992]|0){i=b;return}c[891746]=vM(3567e3,32)|0;a[3566992]=1;i=b;return}function Xjh(){var b=0;b=i;if(a[3567072]|0){i=b;return}c[891766]=vM(3566672,56)|0;a[3567072]=1;i=b;return}function Yjh(){var b=0;b=i;if(a[3567088]|0){i=b;return}c[891770]=vM(3567096,19)|0;a[3567088]=1;i=b;return}function Zjh(){var b=0;b=i;if(a[3567144]|0){i=b;return}c[891784]=vM(3567152,39)|0;a[3567144]=1;i=b;return}function _jh(){var b=0;b=i;if(a[3567248]|0){i=b;return}c[891808]=vM(3548408,4)|0;c[891810]=vM(3567256,20)|0;a[3567248]=1;i=b;return}function $jh(){var b=0;b=i;if(a[3567304]|0){i=b;return}c[891824]=vM(3526016,7)|0;a[3567304]=1;i=b;return}function akh(){var b=0;b=i;if(a[3567320]|0){i=b;return}c[891828]=vM(3567328,60)|0;a[3567320]=1;i=b;return}function bkh(){var b=0;b=i;if(a[3567552]|0){i=b;return}c[891862]=vM(3524360,4)|0;c[891864]=vM(3567560,5)|0;c[891866]=vM(3567576,10)|0;c[891868]=vM(3567600,15)|0;c[891870]=vM(3567632,12)|0;c[891872]=vM(3567656,9)|0;c[891874]=vM(3567680,8)|0;c[891876]=vM(3567696,14)|0;c[891878]=vM(3567728,24)|0;c[891880]=vM(3567776,18)|0;c[891882]=vM(3567816,21)|0;c[891884]=vM(3567864,6)|0;c[891886]=vM(3567880,15)|0;a[3567552]=1;i=b;return}function ckh(){var b=0;b=i;if(a[3567920]|0){i=b;return}c[891978]=vM(3547920,5)|0;a[3567920]=1;i=b;return}function dkh(){var b=0;b=i;if(a[3567944]|0){i=b;return}c[891982]=vM(3567952,22)|0;c[891984]=vM(3547920,5)|0;a[3567944]=1;i=b;return}function ekh(){var b=0;b=i;if(a[3568016]|0){i=b;return}c[892e3]=vM(3568024,5)|0;c[892002]=vM(3568040,6)|0;a[3568016]=1;i=b;return}function fkh(){var b=0;b=i;if(a[3568064]|0){i=b;return}c[892014]=vM(3568072,22)|0;a[3568064]=1;i=b;return}function gkh(){var b=0;b=i;if(a[3568128]|0){i=b;return}c[892030]=vM(3568136,32)|0;a[3568128]=1;i=b;return}function hkh(){var b=0;b=i;if(a[3568248]|0){i=b;return}c[892050]=vM(3568256,12)|0;c[892052]=vM(3549584,9)|0;c[892054]=vM(3568280,4)|0;c[892056]=vM(3568288,9)|0;c[892058]=vM(3568312,10)|0;c[892060]=vM(3568336,16)|0;a[3568248]=1;i=b;return}function ikh(){var b=0;b=i;if(a[3568376]|0){i=b;return}c[892092]=vM(3568024,5)|0;a[3568376]=1;i=b;return}function jkh(){var b=0;b=i;if(a[3568400]|0){i=b;return}c[892096]=vM(3568072,22)|0;c[892098]=vM(3568072,22)|0;a[3568400]=1;i=b;return}function kkh(){var b=0;b=i;if(a[3568416]|0){i=b;return}c[892102]=vM(3568424,63)|0;a[3568416]=1;i=b;return}function lkh(){var b=0;b=i;if(a[3568560]|0){i=b;return}c[892138]=vM(3524360,4)|0;a[3568560]=1;i=b;return}function mkh(){var b=0;b=i;if(a[3568576]|0){i=b;return}c[892142]=vM(3530752,1)|0;a[3568576]=1;i=b;return}function nkh(){var b=0;b=i;if(a[3568592]|0){i=b;return}c[892146]=vM(3530752,1)|0;a[3568592]=1;i=b;return}function okh(){var b=0;b=i;if(a[3568608]|0){i=b;return}c[892150]=vM(3517392,1)|0;a[3568608]=1;i=b;return}function pkh(){var b=0;b=i;if(a[3568624]|0){i=b;return}c[892154]=vM(3568632,34)|0;a[3568624]=1;i=b;return}function qkh(){var b=0;b=i;if(a[3568712]|0){i=b;return}c[892176]=vM(3568720,7)|0;a[3568712]=1;i=b;return}function rkh(){var b=0;b=i;if(a[3568776]|0){i=b;return}c[892184]=vM(3568632,34)|0;c[892186]=vM(3568784,27)|0;c[892188]=vM(3568840,12)|0;c[892190]=vM(3568864,37)|0;c[892192]=vM(3568944,3)|0;a[3568776]=1;i=b;return}function skh(){var b=0;b=i;if(a[3568960]|0){i=b;return}c[892238]=vM(3568968,112)|0;a[3568960]=1;i=b;return}function tkh(){var b=0;b=i;if(a[3569224]|0){i=b;return}c[892298]=vM(3569232,33)|0;c[892300]=vM(3569304,28)|0;c[892302]=vM(3569232,33)|0;c[892304]=vM(3569360,106)|0;a[3569224]=1;i=b;return}function ukh(){var b=0;b=i;if(a[3569656]|0){i=b;return}c[892394]=vM(3517392,1)|0;c[892396]=vM(3523136,1)|0;c[892398]=vM(3550168,1)|0;c[892400]=vM(3523144,1)|0;c[892402]=vM(3523376,1)|0;c[892404]=vM(3523384,2)|0;c[892406]=vM(3557200,6)|0;c[892408]=vM(3523384,2)|0;c[892410]=vM(3569664,3)|0;c[892412]=vM(3523256,1)|0;a[3569656]=1;i=b;return}function vkh(){var b=0;b=i;if(a[3569688]|0){i=b;return}c[892418]=vM(3569696,19)|0;c[892420]=vM(3569736,82)|0;a[3569688]=1;i=b;return}function wkh(){var b=0;b=i;if(a[3569952]|0){i=b;return}c[892476]=vM(3569232,33)|0;c[892478]=vM(3569304,28)|0;c[892480]=vM(3569232,33)|0;c[892482]=vM(3569960,29)|0;c[892484]=vM(3570024,48)|0;c[892486]=vM(3570120,64)|0;a[3569952]=1;i=b;return}function xkh(){var b=0;b=i;if(a[3570288]|0){i=b;return}c[892562]=vM(3570296,5)|0;c[892564]=vM(3523376,1)|0;c[892566]=vM(3523384,2)|0;c[892568]=vM(3570312,5)|0;c[892570]=vM(3523256,1)|0;a[3570288]=1;i=b;return}function ykh(){var b=0;b=i;if(a[3570336]|0){i=b;return}c[892582]=vM(3517392,1)|0;a[3570336]=1;i=b;return}function zkh(){var b=0;b=i;if(a[3570376]|0){i=b;return}c[892586]=vM(3570384,10)|0;c[892588]=vM(3570408,17)|0;c[892590]=vM(3570448,16)|0;c[892592]=vM(3570480,13)|0;a[3570376]=1;i=b;return}function Akh(){var b=0;b=i;if(a[3570520]|0){i=b;return}c[892628]=vM(3570528,57)|0;a[3570520]=1;i=b;return}function Bkh(){var b=0;b=i;if(a[3570656]|0){i=b;return}c[892662]=vM(3570664,50)|0;a[3570656]=1;i=b;return}function Ckh(){var b=0;b=i;if(a[3570776]|0){i=b;return}c[892692]=vM(3570784,15)|0;a[3570776]=1;i=b;return}function Dkh(){var b=0;b=i;if(a[3570832]|0){i=b;return}c[892704]=vM(3570840,71)|0;c[892706]=vM(3570984,116)|0;a[3570832]=1;i=b;return}function Ekh(){var b=0;b=i;if(a[3571240]|0){i=b;return}c[892804]=vM(3571248,14)|0;c[892806]=vM(3571280,44)|0;c[892808]=vM(3571368,38)|0;a[3571240]=1;i=b;return}function Fkh(){var b=0;b=i;if(a[3571480]|0){i=b;return}c[892862]=vM(3571488,4)|0;c[892864]=vM(3571496,70)|0;c[892866]=vM(3571640,8)|0;c[892868]=vM(3571656,19)|0;a[3571480]=1;i=b;return}function Gkh(){var b=0;b=i;if(a[3571704]|0){i=b;return}c[892924]=vM(3571712,7)|0;a[3571704]=1;i=b;return}function Hkh(){var b=0;b=i;if(a[3571736]|0){i=b;return}c[892932]=vM(3571744,11)|0;a[3571736]=1;i=b;return}function Ikh(){var b=0;b=i;if(a[3571776]|0){i=b;return}c[892942]=vM(3571784,7)|0;a[3571776]=1;i=b;return}function Jkh(){var b=0;b=i;if(a[3571816]|0){i=b;return}c[892950]=vM(3571784,7)|0;c[892952]=vM(3571824,3)|0;a[3571816]=1;i=b;return}function Kkh(){var b=0;b=i;if(a[3571872]|0){i=b;return}c[892958]=vM(3571880,11)|0;c[892960]=vM(3571904,30)|0;c[892962]=vM(3571968,16)|0;c[892964]=vM(3572e3,19)|0;c[892966]=vM(3572040,20)|0;a[3571872]=1;i=b;return}function Lkh(){var b=0;b=i;if(a[3572088]|0){i=b;return}c[893020]=vM(3572096,14)|0;a[3572088]=1;i=b;return}function Mkh(){var b=0;b=i;if(a[3572184]|0){i=b;return}c[893032]=vM(3572192,10)|0;c[893034]=vM(3572216,12)|0;c[893036]=vM(3572240,17)|0;c[893038]=vM(3572280,6)|0;c[893040]=vM(3572296,13)|0;c[893042]=vM(3572328,5)|0;c[893044]=vM(3572344,18)|0;a[3572184]=1;i=b;return}function Nkh(){var b=0;b=i;if(a[3572496]|0){i=b;return}c[893096]=vM(3550176,2)|0;c[893098]=vM(3523256,1)|0;c[893100]=vM(3572504,27)|0;c[893102]=vM(3572560,22)|0;c[893104]=vM(3572608,30)|0;c[893106]=vM(3572672,18)|0;c[893108]=vM(3572712,1)|0;c[893110]=vM(3572720,7)|0;c[893112]=vM(3572736,14)|0;c[893114]=vM(3572720,7)|0;c[893116]=vM(3572736,14)|0;c[893118]=vM(3572720,7)|0;c[893120]=vM(3572736,14)|0;c[893122]=vM(3572768,66)|0;a[3572496]=1;i=b;return}function Okh(){var b=0;b=i;if(a[3572912]|0){i=b;return}c[893226]=vM(3572920,2)|0;a[3572912]=1;i=b;return}function Pkh(){var b=0;b=i;if(a[3572944]|0){i=b;return}c[893232]=vM(3572952,27)|0;c[893234]=vM(3573008,24)|0;a[3572944]=1;i=b;return}function Qkh(){var b=0;b=i;if(a[3573072]|0){i=b;return}c[893264]=vM(3573080,7)|0;c[893266]=vM(3573096,11)|0;a[3573072]=1;i=b;return}function Rkh(){var b=0;b=i;if(a[3573160]|0){i=b;return}c[893280]=vM(3525016,3)|0;c[893282]=vM(3573168,8)|0;c[893284]=vM(3573184,9)|0;c[893286]=vM(3573208,11)|0;c[893288]=vM(3573232,11)|0;a[3573160]=1;i=b;return}function Skh(){var b=0;b=i;if(a[3573288]|0){i=b;return}c[893314]=vM(3531448,1)|0;c[893316]=vM(3573296,27)|0;c[893318]=vM(3573352,11)|0;c[893320]=vM(3573376,11)|0;a[3573288]=1;i=b;return}function Tkh(){var b=0;b=i;if(a[3573416]|0){i=b;return}c[893350]=vM(3573424,6)|0;c[893352]=vM(3573440,12)|0;a[3573416]=1;i=b;return}function Ukh(){var b=0;b=i;if(a[3573480]|0){i=b;return}c[893366]=vM(3573352,11)|0;c[893368]=vM(3573376,11)|0;a[3573480]=1;i=b;return}function Vkh(){var b=0;b=i;if(a[3573504]|0){i=b;return}c[893372]=vM(3570984,116)|0;c[893374]=vM(3570984,116)|0;a[3573504]=1;i=b;return}function Wkh(){var b=0;b=i;if(a[3573528]|0){i=b;return}c[893378]=vM(3531448,1)|0;c[893380]=vM(3531448,1)|0;a[3573528]=1;i=b;return}function Xkh(){var b=0;b=i;if(a[3573552]|0){i=b;return}c[893384]=vM(3573560,20)|0;c[893386]=vM(3523360,1)|0;a[3573552]=1;i=b;return}function Ykh(){var b=0;b=i;if(a[3573608]|0){i=b;return}c[893400]=vM(3531448,1)|0;a[3573608]=1;i=b;return}function Zkh(){var b=0;b=i;if(a[3573640]|0){i=b;return}c[893404]=vM(3573648,12)|0;c[893406]=vM(3573672,12)|0;c[893408]=vM(3573696,34)|0;a[3573640]=1;i=b;return}function _kh(){var b=0;b=i;if(a[3573776]|0){i=b;return}c[893442]=vM(3573784,13)|0;a[3573776]=1;i=b;return}function $kh(){var b=0;b=i;if(a[3573824]|0){i=b;return}c[893454]=vM(3573832,7)|0;a[3573824]=1;i=b;return}function alh(){var b=0;b=i;if(a[3573856]|0){i=b;return}c[893462]=vM(3573864,30)|0;a[3573856]=1;i=b;return}function blh(){var b=0;b=i;if(a[3573936]|0){i=b;return}c[893482]=vM(3573864,30)|0;a[3573936]=1;i=b;return}function clh(){var b=0;b=i;if(a[3575544]|0){i=b;return}c[893486]=vM(3575552,3)|0;c[893488]=vM(3575560,54)|0;c[893490]=vM(3552328,4)|0;c[893492]=vM(3575560,54)|0;c[893494]=vM(3575672,33)|0;c[893496]=vM(3575560,54)|0;c[893498]=vM(3575744,42)|0;c[893500]=vM(3575560,54)|0;c[893502]=vM(3575832,3)|0;c[893504]=vM(3575840,53)|0;c[893506]=vM(3575952,32)|0;c[893508]=vM(3575840,53)|0;c[893510]=vM(3576016,6)|0;c[893512]=vM(3576032,42)|0;c[893514]=vM(3576120,7)|0;c[893516]=vM(3576032,42)|0;c[893518]=vM(3576136,35)|0;c[893520]=vM(3576032,42)|0;c[893522]=vM(3576208,6)|0;c[893524]=vM(3576224,42)|0;c[893526]=vM(3576312,7)|0;c[893528]=vM(3576224,42)|0;c[893530]=vM(3576328,35)|0;c[893532]=vM(3576224,42)|0;c[893534]=vM(3576400,6)|0;c[893536]=vM(3576416,42)|0;c[893538]=vM(3576504,7)|0;c[893540]=vM(3576416,42)|0;c[893542]=vM(3576520,35)|0;c[893544]=vM(3576416,42)|0;c[893546]=vM(3576592,3)|0;c[893548]=vM(3576600,53)|0;c[893550]=vM(3576712,32)|0;c[893552]=vM(3576600,53)|0;c[893554]=vM(3576776,48)|0;c[893556]=vM(3576600,53)|0;c[893558]=vM(3576872,3)|0;c[893560]=vM(3576880,53)|0;c[893562]=vM(3576992,32)|0;c[893564]=vM(3576880,53)|0;c[893566]=vM(3577056,3)|0;c[893568]=vM(3577064,53)|0;c[893570]=vM(3577176,32)|0;c[893572]=vM(3577064,53)|0;c[893574]=vM(3577240,4)|0;c[893576]=vM(3577248,59)|0;c[893578]=vM(3577368,9)|0;c[893580]=vM(3577248,59)|0;c[893582]=vM(3577392,10)|0;c[893584]=vM(3577248,59)|0;c[893586]=vM(3577416,38)|0;c[893588]=vM(3577248,59)|0;c[893590]=vM(3577496,3)|0;c[893592]=vM(3577504,53)|0;c[893594]=vM(3577616,32)|0;c[893596]=vM(3577504,53)|0;c[893598]=vM(3577680,8)|0;c[893600]=vM(3577696,44)|0;c[893602]=vM(3577784,37)|0;c[893604]=vM(3577696,44)|0;c[893606]=vM(3577864,47)|0;c[893608]=vM(3577696,44)|0;c[893610]=vM(3577960,21)|0;c[893612]=vM(3578008,53)|0;c[893614]=vM(3578120,50)|0;c[893616]=vM(3578008,53)|0;c[893618]=vM(3578224,47)|0;c[893620]=vM(3578320,37)|0;c[893622]=vM(3578400,8)|0;c[893624]=vM(3578320,37)|0;c[893626]=vM(3578320,37)|0;c[893628]=vM(3578320,37)|0;c[893630]=vM(3578416,12)|0;c[893632]=vM(3578440,41)|0;c[893634]=vM(3578440,41)|0;c[893636]=vM(3578440,41)|0;c[893638]=vM(3578528,9)|0;c[893640]=vM(3578552,45)|0;c[893642]=vM(3578648,10)|0;c[893644]=vM(3578552,45)|0;c[893646]=vM(3578672,38)|0;c[893648]=vM(3578552,45)|0;c[893650]=vM(3578752,33)|0;c[893652]=vM(3578320,37)|0;c[893654]=vM(3578824,7)|0;c[893656]=vM(3578840,36)|0;c[893658]=vM(3578840,36)|0;c[893660]=vM(3578840,36)|0;c[893662]=vM(3578912,13)|0;c[893664]=vM(3578944,42)|0;c[893666]=vM(3578944,42)|0;c[893668]=vM(3578944,42)|0;c[893670]=vM(3579032,10)|0;c[893672]=vM(3579056,39)|0;c[893674]=vM(3579056,39)|0;c[893676]=vM(3579056,39)|0;c[893678]=vM(3579136,10)|0;c[893680]=vM(3579160,39)|0;c[893682]=vM(3579160,39)|0;c[893684]=vM(3579160,39)|0;c[893686]=vM(3579240,10)|0;c[893688]=vM(3579264,39)|0;c[893690]=vM(3579264,39)|0;c[893692]=vM(3579264,39)|0;c[893694]=vM(3579344,42)|0;c[893696]=vM(3579432,52)|0;c[893698]=vM(3579536,42)|0;c[893700]=vM(3579624,61)|0;c[893702]=vM(3579752,38)|0;c[893704]=vM(3575560,54)|0;c[893706]=vM(3579832,47)|0;c[893708]=vM(3579928,137)|0;c[893710]=vM(3580208,60)|0;c[893712]=vM(3580328,149)|0;c[893714]=vM(3580632,40)|0;c[893716]=vM(3580712,139)|0;c[893718]=vM(3580992,44)|0;c[893720]=vM(3581080,138)|0;c[893722]=vM(3581360,43)|0;c[893724]=vM(3581448,137)|0;c[893726]=vM(3581728,53)|0;c[893728]=vM(3581840,151)|0;c[893730]=vM(3582144,39)|0;c[893732]=vM(3582224,140)|0;c[893734]=vM(3582504,51)|0;c[893736]=vM(3582608,152)|0;c[893738]=vM(3582912,37)|0;c[893740]=vM(3582992,139)|0;c[893742]=vM(3583272,39)|0;c[893744]=vM(3576032,42)|0;c[893746]=vM(3583352,39)|0;c[893748]=vM(3576416,42)|0;c[893750]=vM(3583432,50)|0;c[893752]=vM(3579056,39)|0;c[893754]=vM(3583536,50)|0;c[893756]=vM(3579160,39)|0;c[893758]=vM(3583640,50)|0;c[893760]=vM(3579264,39)|0;c[893762]=vM(3583744,53)|0;c[893764]=vM(3578944,42)|0;c[893766]=vM(3583856,43)|0;c[893768]=vM(3583944,132)|0;c[893770]=vM(3584208,42)|0;c[893772]=vM(3584296,128)|0;c[893774]=vM(3584552,55)|0;c[893776]=vM(3584664,128)|0;c[893778]=vM(3584920,55)|0;c[893780]=vM(3585032,128)|0;c[893782]=vM(3585288,50)|0;c[893784]=vM(3585392,139)|0;c[893786]=vM(3585672,9)|0;c[893788]=vM(3585696,154)|0;c[893790]=vM(3586008,9)|0;c[893792]=vM(3586032,142)|0;c[893794]=vM(3586320,9)|0;c[893796]=vM(3586344,150)|0;c[893798]=vM(3586648,9)|0;c[893800]=vM(3586672,150)|0;c[893802]=vM(3586976,9)|0;c[893804]=vM(3587e3,130)|0;c[893806]=vM(3575560,54)|0;c[893808]=vM(3587264,13)|0;c[893810]=vM(3587296,40)|0;c[893812]=vM(3587264,13)|0;c[893814]=vM(3552328,4)|0;c[893816]=vM(3587264,13)|0;c[893818]=vM(3575672,33)|0;c[893820]=vM(3587264,13)|0;c[893822]=vM(3575840,53)|0;c[893824]=vM(3587376,18)|0;c[893826]=vM(3575832,3)|0;c[893828]=vM(3587376,18)|0;c[893830]=vM(3575952,32)|0;c[893832]=vM(3587376,18)|0;c[893834]=vM(3576032,42)|0;c[893836]=vM(3587416,22)|0;c[893838]=vM(3576016,6)|0;c[893840]=vM(3587416,22)|0;c[893842]=vM(3576136,35)|0;c[893844]=vM(3587416,22)|0;c[893846]=vM(3576224,42)|0;c[893848]=vM(3587464,22)|0;c[893850]=vM(3576208,6)|0;c[893852]=vM(3587464,22)|0;c[893854]=vM(3576328,35)|0;c[893856]=vM(3587464,22)|0;c[893858]=vM(3576416,42)|0;c[893860]=vM(3587512,22)|0;c[893862]=vM(3576400,6)|0;c[893864]=vM(3587512,22)|0;c[893866]=vM(3576520,35)|0;c[893868]=vM(3587512,22)|0;c[893870]=vM(3587560,16)|0;c[893872]=vM(3587592,25)|0;c[893874]=vM(3577056,3)|0;c[893876]=vM(3587648,12)|0;c[893878]=vM(3577368,9)|0;c[893880]=vM(3587672,18)|0;c[893882]=vM(3577496,3)|0;c[893884]=vM(3587712,18)|0;a[3575544]=1;i=b;return}function dlh(){var b=0;b=i;if(a[3587760]|0){i=b;return}c[896938]=vM(3548408,4)|0;a[3587760]=1;i=b;return}function elh(){var b=0;b=i;if(a[3587776]|0){i=b;return}c[896942]=vM(3563616,6)|0;a[3587776]=1;i=b;return}function flh(){var b=0;b=i;if(a[3587848]|0){i=b;return}c[896946]=vM(3587856,13)|0;c[896948]=vM(3563616,6)|0;c[896950]=vM(3562648,6)|0;c[896952]=vM(3536520,3)|0;c[896954]=vM(3536656,5)|0;c[896956]=vM(3536520,3)|0;c[896958]=vM(3587888,14)|0;c[896960]=vM(3587920,8)|0;a[3587848]=1;i=b;return}function glh(){var b=0;b=i;if(a[3587944]|0){i=b;return}c[896984]=vM(3587952,30)|0;a[3587944]=1;i=b;return}function hlh(){var b=0;b=i;if(a[3588024]|0){i=b;return}c[897004]=vM(3588032,4)|0;a[3588024]=1;i=b;return}function ilh(){var b=0;b=i;if(a[3588048]|0){i=b;return}c[897010]=vM(3578120,50)|0;a[3588048]=1;i=b;return}function jlh(){var b=0;b=i;if(a[3588064]|0){i=b;return}c[897014]=vM(3575672,33)|0;a[3588064]=1;i=b;return}function klh(){var b=0;b=i;if(a[3588096]|0){i=b;return}c[897018]=vM(3524360,4)|0;c[897020]=vM(3573832,7)|0;c[897022]=vM(3588104,52)|0;a[3588096]=1;i=b;return}function llh(){var b=0;b=i;if(a[3588256]|0){i=b;return}c[897052]=vM(3526016,7)|0;c[897054]=vM(3541224,1)|0;c[897056]=vM(3588104,52)|0;c[897058]=vM(3542768,2)|0;c[897060]=vM(3573832,7)|0;c[897062]=vM(3588264,57)|0;a[3588256]=1;i=b;return}function mlh(){var b=0;b=i;if(a[3588400]|0){i=b;return}c[897096]=vM(3588408,18)|0;c[897098]=vM(3522648,2)|0;a[3588400]=1;i=b;return}function nlh(){var b=0;b=i;if(a[3588472]|0){i=b;return}c[897112]=vM(3588480,3)|0;c[897114]=vM(3588408,18)|0;c[897116]=vM(3522648,2)|0;a[3588472]=1;i=b;return}function olh(){var b=0;b=i;if(a[3588512]|0){i=b;return}c[897122]=vM(3548408,4)|0;c[897124]=vM(3536984,5)|0;c[897126]=vM(3588520,22)|0;a[3588512]=1;i=b;return}function plh(){var b=0;b=i;if(a[3588576]|0){i=b;return}c[897142]=vM(3588584,5)|0;a[3588576]=1;i=b;return}function qlh(){var b=0;b=i;if(a[3588640]|0){i=b;return}c[897150]=vM(3588648,4)|0;c[897152]=vM(3588656,4)|0;c[897154]=vM(3588664,6)|0;c[897156]=vM(3588680,6)|0;c[897158]=vM(3588696,5)|0;a[3588640]=1;i=b;return}function rlh(){var b=0;b=i;if(a[3588792]|0){i=b;return}c[897178]=vM(3588648,4)|0;c[897180]=vM(3588800,1)|0;c[897182]=vM(3588656,4)|0;c[897184]=vM(3588808,1)|0;c[897186]=vM(3588696,5)|0;c[897188]=vM(3588816,1)|0;c[897190]=vM(3588664,6)|0;c[897192]=vM(3588824,1)|0;c[897194]=vM(3588680,6)|0;c[897196]=vM(3572712,1)|0;a[3588792]=1;i=b;return}function slh(){var b=0;b=i;if(a[3588896]|0){i=b;return}c[897208]=vM(3588800,1)|0;c[897210]=vM(3517392,1)|0;c[897212]=vM(3588904,2)|0;c[897214]=vM(3588824,1)|0;c[897216]=vM(3588912,2)|0;c[897218]=vM(3588808,1)|0;c[897220]=vM(3588920,2)|0;c[897222]=vM(3588808,1)|0;a[3588896]=1;i=b;return}function tlh(){var b=0;b=i;if(a[3588960]|0){i=b;return}c[897232]=vM(3588968,26)|0;c[897234]=vM(3522648,2)|0;c[897236]=vM(3589024,27)|0;c[897238]=vM(3522648,2)|0;a[3588960]=1;i=b;return}function ulh(){var b=0;b=i;if(a[3589088]|0){i=b;return}c[897270]=vM(3589096,15)|0;a[3589088]=1;i=b;return}function vlh(){var b=0;b=i;if(a[3589216]|0){i=b;return}c[897282]=vM(3549912,42)|0;c[897284]=vM(3589224,12)|0;c[897286]=vM(3517392,1)|0;c[897288]=vM(3589248,22)|0;c[897290]=vM(3589296,13)|0;c[897292]=vM(3589328,15)|0;c[897294]=vM(3589360,15)|0;c[897296]=vM(3589392,16)|0;c[897298]=vM(3589424,25)|0;c[897300]=vM(3589480,13)|0;c[897302]=vM(3589512,7)|0;a[3589216]=1;i=b;return}function wlh(){var b=0;b=i;if(a[3589544]|0){i=b;return}c[897382]=vM(3589552,8)|0;c[897384]=vM(3589568,8)|0;a[3589544]=1;i=b;return}function xlh(){var b=0;b=i;if(a[3589624]|0){i=b;return}c[897396]=vM(3589632,5)|0;c[897398]=vM(3523744,5)|0;c[897400]=vM(3589648,14)|0;c[897402]=vM(3536656,5)|0;c[897404]=vM(3589648,14)|0;a[3589624]=1;i=b;return}function ylh(){var b=0;b=i;if(a[3589752]|0){i=b;return}c[897420]=vM(3589632,5)|0;c[897422]=vM(3589760,5)|0;c[897424]=vM(3589776,9)|0;c[897426]=vM(3589648,14)|0;c[897428]=vM(3589800,9)|0;c[897430]=vM(3589648,14)|0;c[897432]=vM(3589824,9)|0;c[897434]=vM(3589648,14)|0;c[897436]=vM(3589848,21)|0;a[3589752]=1;i=b;return}function zlh(){var b=0;b=i;if(a[3589936]|0){i=b;return}c[897474]=vM(3589760,5)|0;c[897476]=vM(3523744,5)|0;c[897478]=vM(3589648,14)|0;c[897480]=vM(3536656,5)|0;c[897482]=vM(3589648,14)|0;a[3589936]=1;i=b;return}function Alh(){var b=0;b=i;if(a[3590016]|0){i=b;return}c[897486]=vM(3589760,5)|0;c[897488]=vM(3589632,5)|0;c[897490]=vM(3589824,9)|0;c[897492]=vM(3589648,14)|0;c[897494]=vM(3590024,9)|0;c[897496]=vM(3589648,14)|0;c[897498]=vM(3589776,9)|0;c[897500]=vM(3589648,14)|0;c[897502]=vM(3589848,21)|0;a[3590016]=1;i=b;return}function Blh(){var b=0;b=i;if(a[3590064]|0){i=b;return}c[897512]=vM(3589800,9)|0;c[897514]=vM(3590072,20)|0;a[3590064]=1;i=b;return}function Clh(){var b=0;b=i;if(a[3590128]|0){i=b;return}c[897528]=vM(3590024,9)|0;c[897530]=vM(3590072,20)|0;a[3590128]=1;i=b;return}function Dlh(){var b=0;b=i;if(a[3590176]|0){i=b;return}c[897534]=vM(3589760,5)|0;c[897536]=vM(3589824,9)|0;c[897538]=vM(3589648,14)|0;c[897540]=vM(3590024,9)|0;c[897542]=vM(3589648,14)|0;a[3590176]=1;i=b;return}function Elh(){var b=0;b=i;if(a[3590192]|0){i=b;return}c[897546]=vM(3590200,1)|0;a[3590192]=1;i=b;return}function Flh(){var b=0;b=i;if(a[3590216]|0){i=b;return}c[897552]=vM(3590224,1)|0;a[3590216]=1;i=b;return}function Glh(){var b=0;b=i;if(a[3590240]|0){i=b;return}c[897558]=vM(3590248,8)|0;a[3590240]=1;i=b;return}function Hlh(){var b=0;b=i;if(a[3590288]|0){i=b;return}c[897566]=vM(3590296,12)|0;c[897568]=vM(3590320,206)|0;c[897570]=vM(3523744,5)|0;a[3590288]=1;i=b;return}function Ilh(){var b=0;b=i;if(a[3590744]|0){i=b;return}c[897684]=vM(3590200,1)|0;a[3590744]=1;i=b;return}function Jlh(){var b=0;b=i;if(a[3590760]|0){i=b;return}c[897688]=vM(3590224,1)|0;a[3590760]=1;i=b;return}function Klh(){var b=0;b=i;if(a[3590776]|0){i=b;return}c[897692]=vM(3590248,8)|0;a[3590776]=1;i=b;return}function Llh(){var b=0;b=i;if(a[3590800]|0){i=b;return}c[897696]=vM(3590320,206)|0;c[897698]=vM(3523744,5)|0;a[3590800]=1;i=b;return}function Mlh(){var b=0;b=i;if(a[3591088]|0){i=b;return}c[897702]=vM(3591096,5)|0;c[897704]=vM(3591112,8)|0;c[897706]=vM(3591128,2)|0;c[897708]=vM(3591136,14)|0;c[897710]=vM(3591168,14)|0;c[897712]=vM(3591200,5)|0;c[897714]=vM(3591216,7)|0;c[897716]=vM(3591232,6)|0;c[897718]=vM(3591248,8)|0;c[897720]=vM(3591264,9)|0;c[897722]=vM(3591288,16)|0;c[897724]=vM(3591320,5)|0;c[897726]=vM(3591336,15)|0;c[897728]=vM(3591368,17)|0;c[897730]=vM(3591408,17)|0;c[897732]=vM(3591448,19)|0;c[897734]=vM(3591488,19)|0;c[897736]=vM(3591528,5)|0;c[897738]=vM(3591544,17)|0;c[897740]=vM(3591584,17)|0;c[897742]=vM(3591624,19)|0;c[897744]=vM(3591664,19)|0;c[897746]=vM(3591704,6)|0;c[897748]=vM(3591720,8)|0;c[897750]=vM(3591736,5)|0;c[897752]=vM(3591752,7)|0;c[897754]=vM(3591768,14)|0;c[897756]=vM(3591800,11)|0;c[897758]=vM(3591824,8)|0;c[897760]=vM(3591840,6)|0;c[897762]=vM(3591856,8)|0;c[897764]=vM(3591872,5)|0;c[897766]=vM(3591888,8)|0;c[897768]=vM(3591904,10)|0;c[897770]=vM(3591928,6)|0;a[3591088]=1;i=b;return}function Nlh(){var b=0;b=i;if(a[3591984]|0){i=b;return}c[897986]=vM(3591992,8)|0;c[897988]=vM(3592008,48)|0;c[897990]=vM(3592104,11)|0;c[897992]=vM(3592128,14)|0;c[897994]=vM(3592160,26)|0;a[3591984]=1;i=b;return}function Olh(){var b=0;b=i;if(a[3592256]|0){i=b;return}c[898054]=vM(3548408,4)|0;c[898056]=vM(3592104,11)|0;c[898058]=vM(3592264,15)|0;c[898060]=vM(3592296,33)|0;c[898062]=vM(3548408,4)|0;a[3592256]=1;i=b;return}function Plh(){var b=0;b=i;if(a[3592376]|0){i=b;return}c[898092]=vM(3589760,5)|0;a[3592376]=1;i=b;return}function Qlh(){var b=0;b=i;if(a[3592424]|0){i=b;return}c[898096]=vM(3589632,5)|0;c[898098]=vM(3523744,5)|0;c[898100]=vM(3589648,14)|0;c[898102]=vM(3536656,5)|0;c[898104]=vM(3589648,14)|0;a[3592424]=1;i=b;return}function Rlh(){var b=0;b=i;if(a[3592504]|0){i=b;return}c[898108]=vM(3589632,5)|0;c[898110]=vM(3589760,5)|0;c[898112]=vM(3589776,9)|0;c[898114]=vM(3589648,14)|0;c[898116]=vM(3589800,9)|0;c[898118]=vM(3589648,14)|0;c[898120]=vM(3589824,9)|0;c[898122]=vM(3589648,14)|0;c[898124]=vM(3589848,21)|0;a[3592504]=1;i=b;return}function Slh(){var b=0;b=i;if(a[3592552]|0){i=b;return}c[898128]=vM(3589760,5)|0;c[898130]=vM(3523744,5)|0;c[898132]=vM(3589648,14)|0;c[898134]=vM(3536656,5)|0;c[898136]=vM(3589648,14)|0;a[3592552]=1;i=b;return}function Tlh(){var b=0;b=i;if(a[3592632]|0){i=b;return}c[898140]=vM(3589760,5)|0;c[898142]=vM(3589632,5)|0;c[898144]=vM(3589824,9)|0;c[898146]=vM(3589648,14)|0;c[898148]=vM(3590024,9)|0;c[898150]=vM(3589648,14)|0;c[898152]=vM(3589776,9)|0;c[898154]=vM(3589648,14)|0;c[898156]=vM(3589848,21)|0;a[3592632]=1;i=b;return}function Ulh(){var b=0;b=i;if(a[3592656]|0){i=b;return}c[898160]=vM(3589800,9)|0;c[898162]=vM(3590072,20)|0;a[3592656]=1;i=b;return}function Vlh(){var b=0;b=i;if(a[3592680]|0){i=b;return}c[898166]=vM(3590024,9)|0;c[898168]=vM(3590072,20)|0;a[3592680]=1;i=b;return}function Wlh(){var b=0;b=i;if(a[3592728]|0){i=b;return}c[898172]=vM(3589760,5)|0;c[898174]=vM(3523744,5)|0;c[898176]=vM(3589648,14)|0;c[898178]=vM(3536656,5)|0;c[898180]=vM(3589648,14)|0;a[3592728]=1;i=b;return}function Xlh(){var b=0;b=i;if(a[3592744]|0){i=b;return}c[898184]=vM(3589760,5)|0;a[3592744]=1;i=b;return}function Ylh(){var b=0;b=i;if(a[3592848]|0){i=b;return}c[898188]=vM(3536496,10)|0;c[898190]=vM(3592856,36)|0;c[898192]=vM(3536528,6)|0;c[898194]=vM(3592928,32)|0;c[898196]=vM(3552456,8)|0;c[898198]=vM(3592992,35)|0;c[898200]=vM(3593064,11)|0;c[898202]=vM(3593088,29)|0;c[898204]=vM(3552456,8)|0;c[898206]=vM(3593152,34)|0;c[898208]=vM(3536496,10)|0;c[898210]=vM(3593224,65)|0;a[3592848]=1;i=b;return}function Zlh(){var b=0;b=i;if(a[3593392]|0){i=b;return}c[898340]=vM(3593400,13)|0;c[898342]=vM(3593432,8)|0;c[898344]=vM(3593448,13)|0;c[898346]=vM(3593480,15)|0;a[3593392]=1;i=b;return}function _lh(){var b=0;b=i;if(a[3593528]|0){i=b;return}c[898378]=vM(3593536,29)|0;c[898380]=vM(3593600,36)|0;a[3593528]=1;i=b;return}function $lh(){var b=0;b=i;if(a[3593680]|0){i=b;return}c[898418]=vM(3536984,5)|0;a[3593680]=1;i=b;return}function amh(){var b=0;b=i;if(a[3593696]|0){i=b;return}c[898422]=vM(3523744,5)|0;a[3593696]=1;i=b;return}function bmh(){var b=0;b=i;if(a[3593720]|0){i=b;return}c[898426]=vM(3593728,4)|0;c[898428]=vM(3593736,40)|0;a[3593720]=1;i=b;return}function cmh(){var b=0;b=i;if(a[3593896]|0){i=b;return}c[898454]=vM(3590200,1)|0;c[898456]=vM(3590200,1)|0;c[898458]=vM(3593904,8)|0;c[898460]=vM(3593920,19)|0;c[898462]=vM(3593904,8)|0;c[898464]=vM(3593904,8)|0;c[898466]=vM(3593960,6)|0;c[898468]=vM(3593976,6)|0;c[898470]=vM(3593960,6)|0;c[898472]=vM(3593960,6)|0;a[3593896]=1;i=b;return}function dmh(){var b=0;b=i;if(a[3594032]|0){i=b;return}c[898498]=vM(3589632,5)|0;c[898500]=vM(3523744,5)|0;c[898502]=vM(3589648,14)|0;c[898504]=vM(3536656,5)|0;c[898506]=vM(3589648,14)|0;a[3594032]=1;i=b;return}function emh(){var b=0;b=i;if(a[3594112]|0){i=b;return}c[898510]=vM(3589632,5)|0;c[898512]=vM(3589760,5)|0;c[898514]=vM(3589776,9)|0;c[898516]=vM(3589648,14)|0;c[898518]=vM(3589800,9)|0;c[898520]=vM(3589648,14)|0;c[898522]=vM(3589824,9)|0;c[898524]=vM(3589648,14)|0;c[898526]=vM(3589848,21)|0;a[3594112]=1;i=b;return}function fmh(){var b=0;b=i;if(a[3594160]|0){i=b;return}c[898530]=vM(3589760,5)|0;c[898532]=vM(3523744,5)|0;c[898534]=vM(3589648,14)|0;c[898536]=vM(3536656,5)|0;c[898538]=vM(3589648,14)|0;a[3594160]=1;i=b;return}function gmh(){var b=0;b=i;if(a[3594240]|0){i=b;return}c[898542]=vM(3589760,5)|0;c[898544]=vM(3589632,5)|0;c[898546]=vM(3589824,9)|0;c[898548]=vM(3589648,14)|0;c[898550]=vM(3590024,9)|0;c[898552]=vM(3589648,14)|0;c[898554]=vM(3589776,9)|0;c[898556]=vM(3589648,14)|0;c[898558]=vM(3589848,21)|0;a[3594240]=1;i=b;return}function hmh(){var b=0;b=i;if(a[3594264]|0){i=b;return}c[898562]=vM(3589800,9)|0;c[898564]=vM(3590072,20)|0;a[3594264]=1;i=b;return}function imh(){var b=0;b=i;if(a[3594288]|0){i=b;return}c[898568]=vM(3590024,9)|0;c[898570]=vM(3590072,20)|0;a[3594288]=1;i=b;return}function jmh(){var b=0;b=i;if(a[3594328]|0){i=b;return}c[898574]=vM(3594336,5)|0;c[898576]=vM(3594352,15)|0;c[898578]=vM(3594336,5)|0;c[898580]=vM(3594336,5)|0;a[3594328]=1;i=b;return}function kmh(){var b=0;b=i;if(a[3594424]|0){i=b;return}c[898596]=vM(3589632,5)|0;c[898598]=vM(3523744,5)|0;c[898600]=vM(3589648,14)|0;c[898602]=vM(3536656,5)|0;c[898604]=vM(3589648,14)|0;a[3594424]=1;i=b;return}function lmh(){var b=0;b=i;if(a[3594648]|0){i=b;return}c[898608]=vM(3589632,5)|0;c[898610]=vM(3589760,5)|0;c[898612]=vM(3589776,9)|0;c[898614]=vM(3589648,14)|0;c[898616]=vM(3589800,9)|0;c[898618]=vM(3589648,14)|0;c[898620]=vM(3589824,9)|0;c[898622]=vM(3589648,14)|0;c[898624]=vM(3594656,64)|0;c[898626]=vM(3589848,21)|0;c[898628]=vM(3589760,5)|0;c[898630]=vM(3589848,21)|0;c[898632]=vM(3589760,5)|0;c[898634]=vM(3589848,21)|0;c[898636]=vM(3589760,5)|0;c[898638]=vM(3589848,21)|0;c[898640]=vM(3589760,5)|0;c[898642]=vM(3589848,21)|0;c[898644]=vM(3589760,5)|0;c[898646]=vM(3589848,21)|0;c[898648]=vM(3589760,5)|0;c[898650]=vM(3589848,21)|0;c[898652]=vM(3589760,5)|0;c[898654]=vM(3589848,21)|0;c[898656]=vM(3589760,5)|0;c[898658]=vM(3589848,21)|0;c[898660]=vM(3589760,5)|0;a[3594648]=1;i=b;return}function mmh(){var b=0;b=i;if(a[3594824]|0){i=b;return}c[898696]=vM(3589760,5)|0;c[898698]=vM(3523744,5)|0;c[898700]=vM(3589648,14)|0;c[898702]=vM(3536656,5)|0;c[898704]=vM(3589648,14)|0;a[3594824]=1;i=b;return}function nmh(){var b=0;b=i;if(a[3595024]|0){i=b;return}c[898708]=vM(3589760,5)|0;c[898710]=vM(3589632,5)|0;c[898712]=vM(3589824,9)|0;c[898714]=vM(3589648,14)|0;c[898716]=vM(3590024,9)|0;c[898718]=vM(3589648,14)|0;c[898720]=vM(3589776,9)|0;c[898722]=vM(3589648,14)|0;c[898724]=vM(3589848,21)|0;c[898726]=vM(3589632,5)|0;c[898728]=vM(3595032,15)|0;c[898730]=vM(3589632,5)|0;c[898732]=vM(3589848,21)|0;c[898734]=vM(3589632,5)|0;c[898736]=vM(3595032,15)|0;c[898738]=vM(3589632,5)|0;c[898740]=vM(3589848,21)|0;c[898742]=vM(3589632,5)|0;c[898744]=vM(3595032,15)|0;c[898746]=vM(3589632,5)|0;c[898748]=vM(3589848,21)|0;c[898750]=vM(3589632,5)|0;c[898752]=vM(3595032,15)|0;c[898754]=vM(3589632,5)|0;a[3595024]=1;i=b;return}function omh(){var b=0;b=i;if(a[3595080]|0){i=b;return}c[898766]=vM(3595032,15)|0;c[898768]=vM(3589632,5)|0;a[3595080]=1;i=b;return}function pmh(){var b=0;b=i;if(a[3595104]|0){i=b;return}c[898772]=vM(3589800,9)|0;c[898774]=vM(3590072,20)|0;a[3595104]=1;i=b;return}function qmh(){var b=0;b=i;if(a[3595128]|0){i=b;return}c[898778]=vM(3590024,9)|0;c[898780]=vM(3590072,20)|0;a[3595128]=1;i=b;return}function rmh(){var b=0;b=i;if(a[3595152]|0){i=b;return}c[898784]=vM(3595160,5)|0;c[898786]=vM(3595176,15)|0;a[3595152]=1;i=b;return}function smh(){var b=0;b=i;if(a[3595248]|0){i=b;return}c[898802]=vM(3589632,5)|0;c[898804]=vM(3523744,5)|0;c[898806]=vM(3589648,14)|0;c[898808]=vM(3536656,5)|0;c[898810]=vM(3589648,14)|0;a[3595248]=1;i=b;return}function tmh(){var b=0;b=i;if(a[3595320]|0){i=b;return}c[898814]=vM(3589632,5)|0;c[898816]=vM(3589760,5)|0;c[898818]=vM(3589776,9)|0;c[898820]=vM(3589648,14)|0;c[898822]=vM(3589800,9)|0;c[898824]=vM(3589648,14)|0;c[898826]=vM(3589824,9)|0;c[898828]=vM(3589648,14)|0;a[3595320]=1;i=b;return}function umh(){var b=0;b=i;if(a[3595344]|0){i=b;return}c[898832]=vM(3595352,18)|0;c[898834]=vM(3589760,5)|0;a[3595344]=1;i=b;return}function vmh(){var b=0;b=i;if(a[3595432]|0){i=b;return}c[898848]=vM(3589760,5)|0;c[898850]=vM(3523744,5)|0;c[898852]=vM(3589648,14)|0;c[898854]=vM(3536656,5)|0;c[898856]=vM(3589648,14)|0;a[3595432]=1;i=b;return}function wmh(){var b=0;b=i;if(a[3595504]|0){i=b;return}c[898860]=vM(3589760,5)|0;c[898862]=vM(3589632,5)|0;c[898864]=vM(3589824,9)|0;c[898866]=vM(3589648,14)|0;c[898868]=vM(3590024,9)|0;c[898870]=vM(3589648,14)|0;c[898872]=vM(3589776,9)|0;c[898874]=vM(3589648,14)|0;a[3595504]=1;i=b;return}function xmh(){var b=0;b=i;if(a[3595560]|0){i=b;return}c[898878]=vM(3589848,21)|0;c[898880]=vM(3589632,5)|0;c[898882]=vM(3589848,21)|0;c[898884]=vM(3589632,5)|0;c[898886]=vM(3589848,21)|0;c[898888]=vM(3589632,5)|0;a[3595560]=1;i=b;return}function ymh(){var b=0;b=i;if(a[3595584]|0){i=b;return}c[898892]=vM(3589800,9)|0;c[898894]=vM(3590072,20)|0;a[3595584]=1;i=b;return}function zmh(){var b=0;b=i;if(a[3595608]|0){i=b;return}c[898898]=vM(3590024,9)|0;c[898900]=vM(3590072,20)|0;a[3595608]=1;i=b;return}function Amh(){var b=0;b=i;if(a[3595688]|0){i=b;return}c[898904]=vM(3590200,1)|0;c[898906]=vM(3595696,11)|0;c[898908]=vM(3595720,20)|0;c[898910]=vM(3595696,11)|0;c[898912]=vM(3595696,11)|0;c[898914]=vM(3595760,6)|0;c[898916]=vM(3528920,7)|0;c[898918]=vM(3595760,6)|0;c[898920]=vM(3595760,6)|0;a[3595688]=1;i=b;return}function Bmh(){var b=0;b=i;if(a[3595816]|0){i=b;return}c[898944]=vM(3589632,5)|0;c[898946]=vM(3523744,5)|0;c[898948]=vM(3589648,14)|0;c[898950]=vM(3536656,5)|0;c[898952]=vM(3589648,14)|0;a[3595816]=1;i=b;return}function Cmh(){var b=0;b=i;if(a[3595888]|0){i=b;return}c[898956]=vM(3589632,5)|0;c[898958]=vM(3589760,5)|0;c[898960]=vM(3589776,9)|0;c[898962]=vM(3589648,14)|0;c[898964]=vM(3589800,9)|0;c[898966]=vM(3589648,14)|0;c[898968]=vM(3589824,9)|0;c[898970]=vM(3589648,14)|0;a[3595888]=1;i=b;return}function Dmh(){var b=0;b=i;if(a[3595904]|0){i=b;return}c[898974]=vM(3589848,21)|0;a[3595904]=1;i=b;return}function Emh(){var b=0;b=i;if(a[3595952]|0){i=b;return}c[898978]=vM(3589760,5)|0;c[898980]=vM(3523744,5)|0;c[898982]=vM(3589648,14)|0;c[898984]=vM(3536656,5)|0;c[898986]=vM(3589648,14)|0;a[3595952]=1;i=b;return}function Fmh(){var b=0;b=i;if(a[3596024]|0){i=b;return}c[898990]=vM(3589760,5)|0;c[898992]=vM(3589632,5)|0;c[898994]=vM(3589824,9)|0;c[898996]=vM(3589648,14)|0;c[898998]=vM(3590024,9)|0;c[899e3]=vM(3589648,14)|0;c[899002]=vM(3589776,9)|0;c[899004]=vM(3589648,14)|0;a[3596024]=1;i=b;return}function Gmh(){var b=0;b=i;if(a[3596072]|0){i=b;return}c[899008]=vM(3589760,5)|0;c[899010]=vM(3523744,5)|0;c[899012]=vM(3589648,14)|0;c[899014]=vM(3536656,5)|0;c[899016]=vM(3589648,14)|0;a[3596072]=1;i=b;return}function Hmh(){var b=0;b=i;if(a[3596088]|0){i=b;return}c[899020]=vM(3589848,21)|0;a[3596088]=1;i=b;return}function Imh(){var b=0;b=i;if(a[3596112]|0){i=b;return}c[899024]=vM(3589800,9)|0;c[899026]=vM(3590072,20)|0;a[3596112]=1;i=b;return}function Jmh(){var b=0;b=i;if(a[3596136]|0){i=b;return}c[899030]=vM(3590024,9)|0;c[899032]=vM(3590072,20)|0;a[3596136]=1;i=b;return}function Kmh(){var b=0;b=i;if(a[3596152]|0){i=b;return}c[899036]=vM(3596160,4)|0;a[3596152]=1;i=b;return}function Lmh(){var b=0;b=i;if(a[3596176]|0){i=b;return}c[899042]=vM(3524360,4)|0;a[3596176]=1;i=b;return}function Mmh(){var b=0;b=i;if(a[3596192]|0){i=b;return}c[899046]=vM(3596200,21)|0;a[3596192]=1;i=b;return}function Nmh(){var b=0;b=i;if(a[3596256]|0){i=b;return}c[899062]=vM(3596264,18)|0;a[3596256]=1;i=b;return}function Omh(){var b=0;b=i;if(a[3596312]|0){i=b;return}c[899076]=vM(3596320,18)|0;a[3596312]=1;i=b;return}function Pmh(){var b=0;b=i;if(a[3596368]|0){i=b;return}c[899090]=vM(3524360,4)|0;a[3596368]=1;i=b;return}function Qmh(){var b=0;b=i;if(a[3596424]|0){i=b;return}c[899094]=vM(3596432,24)|0;c[899096]=vM(3536432,4)|0;c[899098]=vM(3596480,9)|0;c[899100]=vM(3523384,2)|0;c[899102]=vM(3596504,40)|0;c[899104]=vM(3596584,50)|0;a[3596424]=1;i=b;return}function Rmh(){var b=0;b=i;if(a[3596720]|0){i=b;return}c[899172]=vM(3596432,24)|0;c[899174]=vM(3536432,4)|0;c[899176]=vM(3596728,30)|0;c[899178]=vM(3596792,11)|0;a[3596720]=1;i=b;return}function Smh(){var b=0;b=i;if(a[3596832]|0){i=b;return}c[899204]=vM(3536432,4)|0;c[899206]=vM(3596840,56)|0;a[3596832]=1;i=b;return}function Tmh(){var b=0;b=i;if(a[3596960]|0){i=b;return}c[899238]=vM(3596968,38)|0;a[3596960]=1;i=b;return}function Umh(){var b=0;b=i;if(a[3597056]|0){i=b;return}c[899262]=vM(3524360,4)|0;a[3597056]=1;i=b;return}function Vmh(){var b=0;b=i;if(a[3597072]|0){i=b;return}c[899266]=vM(3597080,16)|0;a[3597072]=1;i=b;return}function Wmh(){var b=0;b=i;if(a[3597120]|0){i=b;return}c[899278]=vM(3597128,46)|0;a[3597120]=1;i=b;return}function Xmh(){var b=0;b=i;if(a[3597232]|0){i=b;return}c[899306]=vM(3597240,9)|0;a[3597232]=1;i=b;return}function Ymh(){var b=0;b=i;if(a[3597272]|0){i=b;return}c[899316]=vM(3597280,24)|0;a[3597272]=1;i=b;return}function Zmh(){var b=0;b=i;if(a[3597336]|0){i=b;return}c[899332]=vM(3597280,24)|0;a[3597336]=1;i=b;return}function _mh(){var b=0;b=i;if(a[3597352]|0){i=b;return}c[899336]=vM(3597360,25)|0;a[3597352]=1;i=b;return}function $mh(){var b=0;b=i;if(a[3597424]|0){i=b;return}c[899354]=vM(3597360,25)|0;a[3597424]=1;i=b;return}function anh(){var b=0;b=i;if(a[3597440]|0){i=b;return}c[899358]=vM(3597448,11)|0;a[3597440]=1;i=b;return}function bnh(){var b=0;b=i;if(a[3597480]|0){i=b;return}c[899368]=vM(3597488,63)|0;a[3597480]=1;i=b;return}function cnh(){var b=0;b=i;if(a[3597648]|0){i=b;return}c[899404]=vM(3536984,5)|0;c[899406]=vM(3536496,10)|0;c[899408]=vM(3597656,86)|0;c[899410]=vM(3597832,107)|0;a[3597648]=1;i=b;return}function dnh(){var b=0;b=i;if(a[3598064]|0){i=b;return}c[899512]=vM(3523680,5)|0;c[899514]=vM(3598072,38)|0;a[3598064]=1;i=b;return}function enh(){var b=0;b=i;if(a[3598224]|0){i=b;return}c[899538]=vM(3598232,3)|0;c[899540]=vM(3598240,3)|0;c[899542]=vM(3598248,9)|0;c[899544]=vM(3539184,29)|0;c[899546]=vM(3598272,9)|0;c[899548]=vM(3539184,29)|0;c[899550]=vM(3536656,5)|0;c[899552]=vM(3539184,29)|0;c[899554]=vM(3598296,146)|0;a[3598224]=1;i=b;return}function fnh(){var b=0;b=i;if(a[3598600]|0){i=b;return}c[899648]=vM(3598608,26)|0;a[3598600]=1;i=b;return}function gnh(){var b=0;b=i;if(a[3598672]|0){i=b;return}c[899666]=vM(3598680,35)|0;a[3598672]=1;i=b;return}function hnh(){var b=0;b=i;if(a[3598760]|0){i=b;return}c[899688]=vM(3598768,62)|0;a[3598760]=1;i=b;return}function inh(){var b=0;b=i;if(a[3598912]|0){i=b;return}c[899724]=vM(3598768,62)|0;c[899726]=vM(3598920,81)|0;a[3598912]=1;i=b;return}function jnh(){var b=0;b=i;if(a[3599104]|0){i=b;return}c[899772]=vM(3599112,61)|0;c[899774]=vM(3599240,81)|0;a[3599104]=1;i=b;return}function knh(){var b=0;b=i;if(a[3599416]|0){i=b;return}c[899852]=vM(3598768,62)|0;a[3599416]=1;i=b;return}function lnh(){var b=0;b=i;if(a[3599432]|0){i=b;return}c[899856]=vM(3598768,62)|0;a[3599432]=1;i=b;return}function mnh(){var b=0;b=i;if(a[3599448]|0){i=b;return}c[899860]=vM(3599456,32)|0;a[3599448]=1;i=b;return}function nnh(){var b=0;b=i;if(a[3599528]|0){i=b;return}c[899880]=vM(3598768,62)|0;a[3599528]=1;i=b;return}function onh(){var b=0;b=i;if(a[3599544]|0){i=b;return}c[899884]=vM(3598680,35)|0;a[3599544]=1;i=b;return}function pnh(){var b=0;b=i;if(a[3599560]|0){i=b;return}c[899888]=vM(3598680,35)|0;a[3599560]=1;i=b;return}function qnh(){var b=0;b=i;if(a[3599576]|0){i=b;return}c[899892]=vM(3598680,35)|0;a[3599576]=1;i=b;return}function rnh(){var b=0;b=i;if(a[3599592]|0){i=b;return}c[899896]=vM(3599600,62)|0;a[3599592]=1;i=b;return}function snh(){var b=0;b=i;if(a[3599736]|0){i=b;return}c[899932]=vM(3599600,62)|0;a[3599736]=1;i=b;return}function tnh(){var b=0;b=i;if(a[3599752]|0){i=b;return}c[899936]=vM(3599760,33)|0;a[3599752]=1;i=b;return}function unh(){var b=0;b=i;if(a[3599840]|0){i=b;return}c[899958]=vM(3599848,32)|0;a[3599840]=1;i=b;return}function vnh(){var b=0;b=i;if(a[3599920]|0){i=b;return}c[899978]=vM(3599848,32)|0;a[3599920]=1;i=b;return}function wnh(){var b=0;b=i;if(a[3599936]|0){i=b;return}c[899982]=vM(3599944,35)|0;a[3599936]=1;i=b;return}function xnh(){var b=0;b=i;if(a[3600024]|0){i=b;return}c[900004]=vM(3599944,35)|0;a[3600024]=1;i=b;return}function ynh(){var b=0;b=i;if(a[3600040]|0){i=b;return}c[900008]=vM(3599760,33)|0;a[3600040]=1;i=b;return}function znh(){var b=0;b=i;if(a[3600056]|0){i=b;return}c[900012]=vM(3599760,33)|0;a[3600056]=1;i=b;return}function Anh(){var b=0;b=i;if(a[3600072]|0){i=b;return}c[900016]=vM(3599760,33)|0;a[3600072]=1;i=b;return}function Bnh(){var b=0;b=i;if(a[3600088]|0){i=b;return}c[900020]=vM(3599760,33)|0;a[3600088]=1;i=b;return}function Cnh(){var b=0;b=i;if(a[3600104]|0){i=b;return}c[900024]=vM(3599760,33)|0;a[3600104]=1;i=b;return}function Dnh(){var b=0;b=i;if(a[3600120]|0){i=b;return}c[900028]=vM(3599760,33)|0;a[3600120]=1;i=b;return}function Enh(){var b=0;b=i;if(a[3600136]|0){i=b;return}c[900032]=vM(3599760,33)|0;a[3600136]=1;i=b;return}function Fnh(){var b=0;b=i;if(a[3600152]|0){i=b;return}c[900036]=vM(3599760,33)|0;a[3600152]=1;i=b;return}function Gnh(){var b=0;b=i;if(a[3600168]|0){i=b;return}c[900040]=vM(3600176,36)|0;a[3600168]=1;i=b;return}function Hnh(){var b=0;b=i;if(a[3600256]|0){i=b;return}c[900062]=vM(3600264,64)|0;a[3600256]=1;i=b;return}function Inh(){var b=0;b=i;if(a[3600400]|0){i=b;return}c[900098]=vM(3600264,64)|0;a[3600400]=1;i=b;return}function Jnh(){var b=0;b=i;if(a[3600416]|0){i=b;return}c[900102]=vM(3600264,64)|0;a[3600416]=1;i=b;return}function Knh(){var b=0;b=i;if(a[3600432]|0){i=b;return}c[900106]=vM(3600264,64)|0;a[3600432]=1;i=b;return}function Lnh(){var b=0;b=i;if(a[3600448]|0){i=b;return}c[900110]=vM(3600264,64)|0;a[3600448]=1;i=b;return}function Mnh(){var b=0;b=i;if(a[3600464]|0){i=b;return}c[900114]=vM(3600176,36)|0;a[3600464]=1;i=b;return}function Nnh(){var b=0;b=i;if(a[3600480]|0){i=b;return}c[900118]=vM(3600176,36)|0;a[3600480]=1;i=b;return}function Onh(){var b=0;b=i;if(a[3600496]|0){i=b;return}c[900122]=vM(3600176,36)|0;a[3600496]=1;i=b;return}function Pnh(){var b=0;b=i;if(a[3600512]|0){i=b;return}c[900126]=vM(3600520,64)|0;a[3600512]=1;i=b;return}function Qnh(){var b=0;b=i;if(a[3600656]|0){i=b;return}c[900162]=vM(3600520,64)|0;a[3600656]=1;i=b;return}function Rnh(){var b=0;b=i;if(a[3600672]|0){i=b;return}c[900166]=vM(3600520,64)|0;a[3600672]=1;i=b;return}function Snh(){var b=0;b=i;if(a[3600688]|0){i=b;return}c[900170]=vM(3600520,64)|0;a[3600688]=1;i=b;return}function Tnh(){var b=0;b=i;if(a[3600704]|0){i=b;return}c[900174]=vM(3600712,36)|0;a[3600704]=1;i=b;return}function Unh(){var b=0;b=i;if(a[3600792]|0){i=b;return}c[900196]=vM(3600712,36)|0;a[3600792]=1;i=b;return}function Vnh(){var b=0;b=i;if(a[3600808]|0){i=b;return}c[900200]=vM(3600816,64)|0;a[3600808]=1;i=b;return}function Wnh(){var b=0;b=i;if(a[3600952]|0){i=b;return}c[900236]=vM(3600816,64)|0;a[3600952]=1;i=b;return}function Xnh(){var b=0;b=i;if(a[3600968]|0){i=b;return}c[900240]=vM(3600816,64)|0;a[3600968]=1;i=b;return}function Ynh(){var b=0;b=i;if(a[3600984]|0){i=b;return}c[900244]=vM(3600992,36)|0;a[3600984]=1;i=b;return}function Znh(){var b=0;b=i;if(a[3601072]|0){i=b;return}c[900266]=vM(3601080,36)|0;a[3601072]=1;i=b;return}function _nh(){var b=0;b=i;if(a[3601160]|0){i=b;return}c[900288]=vM(3601080,36)|0;a[3601160]=1;i=b;return}function $nh(){var b=0;b=i;if(a[3601176]|0){i=b;return}c[900292]=vM(3601184,64)|0;a[3601176]=1;i=b;return}function aoh(){var b=0;b=i;if(a[3601320]|0){i=b;return}c[900328]=vM(3601184,64)|0;a[3601320]=1;i=b;return}function boh(){var b=0;b=i;if(a[3601336]|0){i=b;return}c[900332]=vM(3601344,63)|0;a[3601336]=1;i=b;return}function coh(){var b=0;b=i;if(a[3601480]|0){i=b;return}c[900368]=vM(3601184,64)|0;a[3601480]=1;i=b;return}function doh(){var b=0;b=i;if(a[3601496]|0){i=b;return}c[900372]=vM(3601184,64)|0;a[3601496]=1;i=b;return}function eoh(){var b=0;b=i;if(a[3601512]|0){i=b;return}c[900376]=vM(3601184,64)|0;a[3601512]=1;i=b;return}function foh(){var b=0;b=i;if(a[3601528]|0){i=b;return}c[900380]=vM(3536984,5)|0;a[3601528]=1;i=b;return}function goh(){var b=0;b=i;if(a[3601544]|0){i=b;return}c[900384]=vM(3601080,36)|0;a[3601544]=1;i=b;return}function hoh(){var b=0;b=i;if(a[3601560]|0){i=b;return}c[900388]=vM(3601080,36)|0;a[3601560]=1;i=b;return}function ioh(){var b=0;b=i;if(a[3601576]|0){i=b;return}c[900392]=vM(3601080,36)|0;a[3601576]=1;i=b;return}function joh(){var b=0;b=i;if(a[3601592]|0){i=b;return}c[900396]=vM(3601600,66)|0;a[3601592]=1;i=b;return}function koh(){var b=0;b=i;if(a[3601744]|0){i=b;return}c[900434]=vM(3601600,66)|0;a[3601744]=1;i=b;return}function loh(){var b=0;b=i;if(a[3601760]|0){i=b;return}c[900438]=vM(3601600,66)|0;a[3601760]=1;i=b;return}function moh(){var b=0;b=i;if(a[3601776]|0){i=b;return}c[900442]=vM(3601600,66)|0;a[3601776]=1;i=b;return}function noh(){var b=0;b=i;if(a[3601792]|0){i=b;return}c[900446]=vM(3601600,66)|0;a[3601792]=1;i=b;return}function ooh(){var b=0;b=i;if(a[3601808]|0){i=b;return}c[900450]=vM(3601816,34)|0;a[3601808]=1;i=b;return}function poh(){var b=0;b=i;if(a[3601896]|0){i=b;return}c[900472]=vM(3601816,34)|0;a[3601896]=1;i=b;return}function qoh(){var b=0;b=i;if(a[3601912]|0){i=b;return}c[900476]=vM(3601920,37)|0;a[3601912]=1;i=b;return}function roh(){var b=0;b=i;if(a[3602008]|0){i=b;return}c[900500]=vM(3601920,37)|0;a[3602008]=1;i=b;return}function soh(){var b=0;b=i;if(a[3602024]|0){i=b;return}c[900504]=vM(3602032,66)|0;a[3602024]=1;i=b;return}function toh(){var b=0;b=i;if(a[3602176]|0){i=b;return}c[900542]=vM(3602032,66)|0;a[3602176]=1;i=b;return}function uoh(){var b=0;b=i;if(a[3602192]|0){i=b;return}c[900546]=vM(3602032,66)|0;a[3602192]=1;i=b;return}function voh(){var b=0;b=i;if(a[3602208]|0){i=b;return}c[900550]=vM(3602216,34)|0;a[3602208]=1;i=b;return}function woh(){var b=0;b=i;if(a[3602296]|0){i=b;return}c[900572]=vM(3602032,66)|0;a[3602296]=1;i=b;return}function xoh(){var b=0;b=i;if(a[3602312]|0){i=b;return}c[900576]=vM(3602216,34)|0;a[3602312]=1;i=b;return}function yoh(){var b=0;b=i;if(a[3602328]|0){i=b;return}c[900580]=vM(3602216,34)|0;a[3602328]=1;i=b;return}function zoh(){var b=0;b=i;if(a[3602344]|0){i=b;return}c[900584]=vM(3602352,37)|0;a[3602344]=1;i=b;return}function Aoh(){var b=0;b=i;if(a[3602440]|0){i=b;return}c[900608]=vM(3602448,66)|0;a[3602440]=1;i=b;return}function Boh(){var b=0;b=i;if(a[3602592]|0){i=b;return}c[900646]=vM(3602448,66)|0;a[3602592]=1;i=b;return}function Coh(){var b=0;b=i;if(a[3602608]|0){i=b;return}c[900650]=vM(3602448,66)|0;a[3602608]=1;i=b;return}function Doh(){var b=0;b=i;if(a[3602624]|0){i=b;return}c[900654]=vM(3602632,34)|0;a[3602624]=1;i=b;return}function Eoh(){var b=0;b=i;if(a[3602712]|0){i=b;return}c[900676]=vM(3602632,34)|0;a[3602712]=1;i=b;return}function Foh(){var b=0;b=i;if(a[3602728]|0){i=b;return}c[900680]=vM(3602632,34)|0;a[3602728]=1;i=b;return}function Goh(){var b=0;b=i;if(a[3602744]|0){i=b;return}c[900684]=vM(3602632,34)|0;a[3602744]=1;i=b;return}function Hoh(){var b=0;b=i;if(a[3602760]|0){i=b;return}c[900688]=vM(3602768,14)|0;a[3602760]=1;i=b;return}function Ioh(){var b=0;b=i;if(a[3602840]|0){i=b;return}c[900700]=vM(3602848,49)|0;c[900702]=vM(3602952,32)|0;c[900704]=vM(3603016,44)|0;c[900706]=vM(3603104,35)|0;c[900708]=vM(3603176,4)|0;a[3602840]=1;i=b;return}function Joh(){var b=0;b=i;if(a[3603200]|0){i=b;return}c[900796]=vM(3603208,47)|0;c[900798]=vM(3603304,5)|0;a[3603200]=1;i=b;return}function Koh(){var b=0;b=i;if(a[3603328]|0){i=b;return}c[900830]=vM(3603336,48)|0;a[3603328]=1;i=b;return}function Loh(){var b=0;b=i;if(a[3603968]|0){i=b;return}c[900858]=vM(3603976,16)|0;c[900860]=vM(3604008,13)|0;c[900862]=vM(3604040,12)|0;c[900864]=vM(3604064,8)|0;c[900866]=vM(3604080,5)|0;c[900868]=vM(3604096,6)|0;c[900870]=vM(3604112,3)|0;c[900872]=vM(3604120,4)|0;c[900874]=vM(3604128,12)|0;c[900876]=vM(3604152,9)|0;c[900878]=vM(3604176,9)|0;c[900880]=vM(3604200,14)|0;c[900882]=vM(3604232,11)|0;c[900884]=vM(3604256,10)|0;c[900886]=vM(3604280,11)|0;c[900888]=vM(3604304,10)|0;c[900890]=vM(3604328,11)|0;c[900892]=vM(3604352,10)|0;c[900894]=vM(3604376,6)|0;c[900896]=vM(3604152,9)|0;c[900898]=vM(3604176,9)|0;c[900900]=vM(3604200,14)|0;c[900902]=vM(3604392,11)|0;c[900904]=vM(3604416,10)|0;c[900906]=vM(3604440,11)|0;c[900908]=vM(3604464,10)|0;c[900910]=vM(3604488,11)|0;c[900912]=vM(3604512,10)|0;c[900914]=vM(3604536,9)|0;c[900916]=vM(3604560,8)|0;c[900918]=vM(3604576,8)|0;c[900920]=vM(3604152,9)|0;c[900922]=vM(3604176,9)|0;c[900924]=vM(3604200,14)|0;c[900926]=vM(3604392,11)|0;c[900928]=vM(3604416,10)|0;c[900930]=vM(3604280,11)|0;c[900932]=vM(3604304,10)|0;c[900934]=vM(3604488,11)|0;c[900936]=vM(3604512,10)|0;c[900938]=vM(3604592,9)|0;c[900940]=vM(3604616,8)|0;c[900942]=vM(3604632,8)|0;c[900944]=vM(3604560,8)|0;c[900946]=vM(3604648,8)|0;c[900948]=vM(3604576,8)|0;c[900950]=vM(3604152,9)|0;c[900952]=vM(3604176,9)|0;c[900954]=vM(3604200,14)|0;c[900956]=vM(3604392,11)|0;c[900958]=vM(3604416,10)|0;c[900960]=vM(3604440,11)|0;c[900962]=vM(3604464,10)|0;c[900964]=vM(3604488,11)|0;c[900966]=vM(3604512,10)|0;c[900968]=vM(3604664,9)|0;c[900970]=vM(3604576,8)|0;c[900972]=vM(3604688,8)|0;c[900974]=vM(3604616,8)|0;c[900976]=vM(3604632,8)|0;c[900978]=vM(3604560,8)|0;c[900980]=vM(3604704,6)|0;c[900982]=vM(3604720,5)|0;c[900984]=vM(3604736,9)|0;c[900986]=vM(3604760,6)|0;c[900988]=vM(3604776,6)|0;c[900990]=vM(3604736,9)|0;a[3603968]=1;i=b;return}function Moh(){var b=0;b=i;if(a[3604800]|0){i=b;return}c[901198]=vM(3533520,10)|0;a[3604800]=1;i=b;return}function Noh(){var b=0;b=i;if(a[3604816]|0){i=b;return}c[901202]=vM(3604824,30)|0;a[3604816]=1;i=b;return}function Ooh(){var b=0;b=i;if(a[3604904]|0){i=b;return}c[901222]=vM(3604912,27)|0;c[901224]=vM(3604968,4)|0;a[3604904]=1;i=b;return}function Poh(){var b=0;b=i;if(a[3604984]|0){i=b;return}c[901244]=vM(3533640,1)|0;a[3604984]=1;i=b;return}function Qoh(){var b=0;b=i;if(a[3605016]|0){i=b;return}c[901248]=vM(3605024,46)|0;c[901250]=vM(3605120,45)|0;c[901252]=vM(3605024,46)|0;a[3605016]=1;i=b;return}function Roh(){var b=0;b=i;if(a[3605240]|0){i=b;return}c[901304]=vM(3605248,51)|0;c[901306]=vM(3605352,61)|0;c[901308]=vM(3605480,61)|0;a[3605240]=1;i=b;return}function Soh(){var b=0;b=i;if(a[3605616]|0){i=b;return}c[901402]=vM(3523368,1)|0;a[3605616]=1;i=b;return}function Toh(){var b=0;b=i;if(a[3605632]|0){i=b;return}c[901406]=vM(3605640,3)|0;a[3605632]=1;i=b;return}function Uoh(){var b=0;b=i;if(a[3605656]|0){i=b;return}c[901412]=vM(3605664,21)|0;a[3605656]=1;i=b;return}function Voh(){var b=0;b=i;if(a[3605720]|0){i=b;return}c[901428]=vM(3541248,1)|0;a[3605720]=1;i=b;return}function Woh(){var b=0;b=i;if(a[3605744]|0){i=b;return}c[901432]=vM(3541248,1)|0;c[901434]=vM(3605752,83)|0;a[3605744]=1;i=b;return}function Xoh(){var b=0;b=i;if(a[3605928]|0){i=b;return}c[901480]=vM(3605936,108)|0;a[3605928]=1;i=b;return}function Yoh(){var b=0;b=i;if(a[3606192]|0){i=b;return}c[901538]=vM(3606200,56)|0;c[901540]=vM(3606312,96)|0;c[901542]=vM(3606504,41)|0;c[901544]=vM(3606592,55)|0;c[901546]=vM(3606704,73)|0;a[3606192]=1;i=b;return}function Zoh(){var b=0;b=i;if(a[3606880]|0){i=b;return}c[901714]=vM(3524360,4)|0;c[901716]=vM(3606888,8)|0;c[901718]=vM(3606904,13)|0;a[3606880]=1;i=b;return}function _oh(){var b=0;b=i;if(a[3606960]|0){i=b;return}c[901734]=vM(3517392,1)|0;c[901736]=vM(3606968,4)|0;c[901738]=vM(3605752,83)|0;a[3606960]=1;i=b;return}function $oh(){var b=0;b=i;if(a[3606992]|0){i=b;return}c[901744]=vM(3607e3,14)|0;c[901746]=vM(3607e3,14)|0;a[3606992]=1;i=b;return}function aph(){var b=0;b=i;if(a[3607056]|0){i=b;return}c[901758]=vM(3517392,1)|0;c[901760]=vM(3517392,1)|0;c[901762]=vM(3517392,1)|0;a[3607056]=1;i=b;return}function bph(){var b=0;b=i;if(a[3607136]|0){i=b;return}c[901766]=vM(3607144,21)|0;c[901768]=vM(3607192,2)|0;c[901770]=vM(3607192,2)|0;c[901772]=vM(3607192,2)|0;c[901774]=vM(3607192,2)|0;c[901776]=vM(3607192,2)|0;c[901778]=vM(3607200,28)|0;c[901780]=vM(3607256,17)|0;c[901782]=vM(3607296,28)|0;a[3607136]=1;i=b;return}function cph(){var b=0;b=i;if(a[3607368]|0){i=b;return}c[901838]=vM(3607376,6)|0;c[901840]=vM(3607392,8)|0;a[3607368]=1;i=b;return}function dph(){var b=0;b=i;if(a[3607416]|0){i=b;return}c[901852]=vM(3607424,16)|0;a[3607416]=1;i=b;return}function eph(){var b=0;b=i;if(a[3607464]|0){i=b;return}c[901864]=vM(3607472,14)|0;a[3607464]=1;i=b;return}function fph(){var b=0;b=i;if(a[3607512]|0){i=b;return}c[901876]=vM(3607520,50)|0;a[3607512]=1;i=b;return}function gph(){var b=0;b=i;if(a[3607632]|0){i=b;return}c[901906]=vM(3607640,15)|0;a[3607632]=1;i=b;return}function hph(){var b=0;b=i;if(a[3607680]|0){i=b;return}c[901918]=vM(3607688,21)|0;a[3607680]=1;i=b;return}function iph(){var b=0;b=i;if(a[3607744]|0){i=b;return}c[901934]=vM(3607752,39)|0;a[3607744]=1;i=b;return}function jph(){var b=0;b=i;if(a[3607848]|0){i=b;return}c[901958]=vM(3536984,5)|0;c[901960]=vM(3607856,51)|0;a[3607848]=1;i=b;return}function kph(){var b=0;b=i;if(a[3608e3]|0){i=b;return}c[901990]=vM(3608008,1)|0;c[901992]=vM(3608016,1)|0;c[901994]=vM(3608024,1)|0;c[901996]=vM(3608032,1)|0;c[901998]=vM(3608040,91)|0;a[3608e3]=1;i=b;return}function lph(){var b=0;b=i;if(a[3608232]|0){i=b;return}c[902056]=vM(3608240,28)|0;a[3608232]=1;i=b;return}function mph(){var b=0;b=i;if(a[3608304]|0){i=b;return}c[902074]=vM(3608312,49)|0;a[3608304]=1;i=b;return}function nph(){var b=0;b=i;if(a[3608424]|0){i=b;return}c[902104]=vM(3608432,61)|0;a[3608424]=1;i=b;return}function oph(){var b=0;b=i;if(a[3608568]|0){i=b;return}c[902140]=vM(3608576,19)|0;a[3608568]=1;i=b;return}function pph(){var b=0;b=i;if(a[3608624]|0){i=b;return}c[902154]=vM(3608576,19)|0;a[3608624]=1;i=b;return}function qph(){var b=0;b=i;if(a[3608640]|0){i=b;return}c[902158]=vM(3608648,29)|0;a[3608640]=1;i=b;return}function rph(){var b=0;b=i;if(a[3608720]|0){i=b;return}c[902178]=vM(3608728,26)|0;a[3608720]=1;i=b;return}function sph(){var b=0;b=i;if(a[3608792]|0){i=b;return}c[902196]=vM(3608800,25)|0;a[3608792]=1;i=b;return}function tph(){var b=0;b=i;if(a[3608880]|0){i=b;return}c[902214]=vM(3608888,11)|0;c[902216]=vM(3608912,12)|0;c[902218]=vM(3608936,11)|0;a[3608880]=1;i=b;return}function uph(){var b=0;b=i;if(a[3608968]|0){i=b;return}c[902240]=vM(3608976,28)|0;a[3608968]=1;i=b;return}function vph(){var b=0;b=i;if(a[3609040]|0){i=b;return}c[902258]=vM(3609048,33)|0;a[3609040]=1;i=b;return}function wph(){var b=0;b=i;if(a[3609128]|0){i=b;return}c[902280]=vM(3609136,46)|0;a[3609128]=1;i=b;return}function xph(){var b=0;b=i;if(a[3609248]|0){i=b;return}c[902308]=vM(3555200,3)|0;c[902310]=vM(3609256,13)|0;a[3609248]=1;i=b;return}function yph(){var b=0;b=i;if(a[3609296]|0){i=b;return}c[902322]=vM(3555200,3)|0;a[3609296]=1;i=b;return}function zph(){var b=0;b=i;if(a[3609312]|0){i=b;return}c[902326]=vM(3609256,13)|0;a[3609312]=1;i=b;return}function Aph(){var b=0;b=i;if(a[3609328]|0){i=b;return}c[902330]=vM(3609336,75)|0;a[3609328]=1;i=b;return}function Bph(){var b=0;b=i;if(a[3609496]|0){i=b;return}c[902372]=vM(3536432,4)|0;a[3609496]=1;i=b;return}function Cph(){var b=0;b=i;if(a[3609712]|0){i=b;return}c[902376]=vM(3609720,12)|0;c[902378]=vM(3548408,4)|0;c[902380]=vM(3609744,43)|0;c[902382]=vM(3609720,12)|0;c[902384]=vM(3609832,46)|0;c[902386]=vM(3609720,12)|0;c[902388]=vM(3609928,53)|0;c[902390]=vM(3609720,12)|0;c[902392]=vM(3610040,56)|0;c[902394]=vM(3609720,12)|0;c[902396]=vM(3610152,61)|0;c[902398]=vM(3610280,68)|0;c[902400]=vM(3609720,12)|0;c[902402]=vM(3610416,21)|0;c[902404]=vM(3573440,12)|0;c[902406]=vM(3610464,26)|0;c[902408]=vM(3610520,28)|0;c[902410]=vM(3610576,19)|0;c[902412]=vM(3523360,1)|0;c[902414]=vM(3610616,53)|0;c[902416]=vM(3610728,10)|0;c[902418]=vM(3610752,12)|0;c[902420]=vM(3610776,59)|0;c[902422]=vM(3609720,12)|0;c[902424]=vM(3610896,21)|0;c[902426]=vM(3523360,1)|0;a[3609712]=1;i=b;return}function Dph(){var b=0;b=i;if(a[3610952]|0){i=b;return}c[902736]=vM(3609256,13)|0;a[3610952]=1;i=b;return}function Eph(){var b=0;b=i;if(a[3610968]|0){i=b;return}c[902740]=vM(3610976,41)|0;a[3610968]=1;i=b;return}function Fph(){var b=0;b=i;if(a[3611072]|0){i=b;return}c[902766]=vM(3611080,27)|0;a[3611072]=1;i=b;return}function Gph(){var b=0;b=i;if(a[3611144]|0){i=b;return}c[902784]=vM(3611152,61)|0;a[3611144]=1;i=b;return}function Hph(){var b=0;b=i;if(a[3611296]|0){i=b;return}c[902820]=vM(3611304,22)|0;c[902822]=vM(3611352,12)|0;a[3611296]=1;i=b;return}function Iph(){var b=0;b=i;if(a[3611392]|0){i=b;return}c[902844]=vM(3611304,22)|0;c[902846]=vM(3611352,12)|0;a[3611392]=1;i=b;return}function Jph(){var b=0;b=i;if(a[3611408]|0){i=b;return}c[902850]=vM(3529032,1)|0;a[3611408]=1;i=b;return}function Kph(){var b=0;b=i;if(a[3611432]|0){i=b;return}c[902854]=vM(3529032,1)|0;c[902856]=vM(3529032,1)|0;a[3611432]=1;i=b;return}function Lph(){var b=0;b=i;if(a[3611456]|0){i=b;return}c[902860]=vM(3611464,41)|0;c[902862]=vM(3611464,41)|0;a[3611456]=1;i=b;return}function Mph(){var b=0;b=i;if(a[3611560]|0){i=b;return}c[902888]=vM(3611568,10)|0;a[3611560]=1;i=b;return}function Nph(){var b=0;b=i;if(a[3611600]|0){i=b;return}c[902898]=vM(3526016,7)|0;a[3611600]=1;i=b;return}function Oph(){var b=0;b=i;if(a[3611632]|0){i=b;return}c[902902]=vM(3611640,9)|0;c[902904]=vM(3611664,8)|0;c[902906]=vM(3611680,12)|0;a[3611632]=1;i=b;return}function Pph(){var b=0;b=i;if(a[3611776]|0){i=b;return}c[902926]=vM(3611784,20)|0;c[902928]=vM(3611824,16)|0;c[902930]=vM(3611856,20)|0;c[902932]=vM(3611896,20)|0;c[902934]=vM(3611936,4)|0;c[902936]=vM(3611944,4)|0;c[902938]=vM(3611952,3)|0;c[902940]=vM(3611960,9)|0;c[902942]=vM(3517392,1)|0;a[3611776]=1;i=b;return}function Qph(){var b=0;b=i;if(a[3611992]|0){i=b;return}c[902996]=vM(3612e3,14)|0;a[3611992]=1;i=b;return}function Rph(){var b=0;b=i;if(a[3612040]|0){i=b;return}c[903008]=vM(3612048,16)|0;a[3612040]=1;i=b;return}function Sph(){var b=0;b=i;if(a[3612088]|0){i=b;return}c[903020]=vM(3612096,51)|0;a[3612088]=1;i=b;return}function Tph(){var b=0;b=i;if(a[3612224]|0){i=b;return}c[903050]=vM(3524360,4)|0;c[903052]=vM(3550216,45)|0;c[903054]=vM(3612232,9)|0;a[3612224]=1;i=b;return}function Uph(){var b=0;b=i;if(a[3612264]|0){i=b;return}c[903064]=vM(3555200,3)|0;a[3612264]=1;i=b;return}function Vph(){var b=0;b=i;if(a[3612280]|0){i=b;return}c[903068]=vM(3533640,1)|0;a[3612280]=1;i=b;return}function Wph(){var b=0;b=i;if(a[3612296]|0){i=b;return}c[903072]=vM(3533640,1)|0;a[3612296]=1;i=b;return}function Xph(){var b=0;b=i;if(a[3612312]|0){i=b;return}c[903076]=vM(3612320,37)|0;a[3612312]=1;i=b;return}function Yph(){var b=0;b=i;if(a[3612408]|0){i=b;return}c[903100]=vM(3612416,30)|0;a[3612408]=1;i=b;return}function Zph(){var b=0;b=i;if(a[3612496]|0){i=b;return}c[903120]=vM(3612504,30)|0;c[903122]=vM(3536984,5)|0;a[3612496]=1;i=b;return}function _ph(){var b=0;b=i;if(a[3612576]|0){i=b;return}c[903142]=vM(3612584,63)|0;a[3612576]=1;i=b;return}function $ph(){var b=0;b=i;if(a[3612720]|0){i=b;return}c[903178]=vM(3612728,54)|0;a[3612720]=1;i=b;return}function aqh(){var b=0;b=i;if(a[3612848]|0){i=b;return}c[903210]=vM(3612416,30)|0;a[3612848]=1;i=b;return}function bqh(){var b=0;b=i;if(a[3612888]|0){i=b;return}c[903214]=vM(3612896,2)|0;c[903216]=vM(3612896,2)|0;c[903218]=vM(3612896,2)|0;c[903220]=vM(3612904,2)|0;a[3612888]=1;i=b;return}function cqh(){var b=0;b=i;if(a[3612920]|0){i=b;return}c[903228]=vM(3612928,13)|0;a[3612920]=1;i=b;return}function dqh(){var b=0;b=i;if(a[3612968]|0){i=b;return}c[903240]=vM(3612976,24)|0;a[3612968]=1;i=b;return}function eqh(){var b=0;b=i;if(a[3613048]|0){i=b;return}c[903256]=vM(3613056,4)|0;c[903258]=vM(3613064,38)|0;c[903260]=vM(3613144,28)|0;a[3613048]=1;i=b;return}function fqh(){var b=0;b=i;if(a[3613208]|0){i=b;return}c[903300]=vM(3613144,28)|0;a[3613208]=1;i=b;return}function gqh(){var b=0;b=i;if(a[3613224]|0){i=b;return}c[903304]=vM(3548376,8)|0;a[3613224]=1;i=b;return}function hqh(){var b=0;b=i;if(a[3613248]|0){i=b;return}c[903308]=vM(3613256,46)|0;c[903310]=vM(3613352,26)|0;a[3613248]=1;i=b;return}function iqh(){var b=0;b=i;if(a[3613416]|0){i=b;return}c[903352]=vM(3613424,35)|0;a[3613416]=1;i=b;return}function jqh(){var b=0;b=i;if(a[3613536]|0){i=b;return}c[903374]=vM(3524360,4)|0;c[903376]=vM(3613544,17)|0;c[903378]=vM(3613584,20)|0;c[903380]=vM(3613624,18)|0;c[903382]=vM(3613664,18)|0;a[3613536]=1;i=b;return}function kqh(){var b=0;b=i;if(a[3613728]|0){i=b;return}c[903426]=vM(3549848,4)|0;c[903428]=vM(3613736,9)|0;c[903430]=vM(3568256,12)|0;a[3613728]=1;i=b;return}function lqh(){var b=0;b=i;if(a[3613784]|0){i=b;return}c[903440]=vM(3549848,4)|0;c[903442]=vM(3613736,9)|0;c[903444]=vM(3568256,12)|0;a[3613784]=1;i=b;return}function mqh(){var b=0;b=i;if(a[3613816]|0){i=b;return}c[903448]=vM(3549848,4)|0;c[903450]=vM(3613736,9)|0;c[903452]=vM(3568256,12)|0;a[3613816]=1;i=b;return}function nqh(){var b=0;b=i;if(a[3613840]|0){i=b;return}c[903456]=vM(3526016,7)|0;c[903458]=vM(3613848,57)|0;a[3613840]=1;i=b;return}function oqh(){var b=0;b=i;if(a[3614e3]|0){i=b;return}c[903492]=vM(3614008,5)|0;c[903494]=vM(3614024,5)|0;c[903496]=vM(3614040,5)|0;c[903498]=vM(3614056,8)|0;a[3614e3]=1;i=b;return}function pqh(){var b=0;b=i;if(a[3614080]|0){i=b;return}c[903518]=vM(3614088,48)|0;a[3614080]=1;i=b;return}function qqh(){var b=0;b=i;if(a[3614208]|0){i=b;return}c[903546]=vM(3523360,1)|0;c[903548]=vM(3523360,1)|0;c[903550]=vM(3523360,1)|0;a[3614208]=1;i=b;return}function rqh(){var a=0;a=i;gI(1084016,246,0,0);i=a;return}function sqh(){var a=0;a=i;gI(1085528,247,0,0);i=a;return}function tqh(){var a=0;a=i;gI(3485816,248,0,0);i=a;return}function uqh(){var a=0;a=i;gI(3486648,249,0,0);i=a;return}function vqh(){var a=0;a=i;gI(3496672,250,0,0);i=a;return}function wqh(){var a=0;a=i;gI(3516352,251,0,0);i=a;return}function xqh(){var a=0;a=i;gI(3649440,252,0,0);i=a;return}function yqh(){var a=0;a=i;gI(3649808,253,0,0);i=a;return}function zqh(a){a=a|0;var b=0,d=0;b=i;d=ISg(a,c[788301]|0)|0;i=b;return d|0}function Aqh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Bqh(a){a=a|0;FJ(a)}function Cqh(a){a=a|0;FJ(a)}function Dqh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Eqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Fqh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Gqh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Hqh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function Iqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Jqh(){var a=0,b=0;a=i;RI(1777032)|0;b=vGe(0,c[444282]|0)|0;i=a;return b|0}function Kqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Lqh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Mqh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Nqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Oqh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function Pqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Qqh(a,b){a=a|0;b=b|0;var d=0;d=i;if(!b){i=d;return}if(bJ(c[(c[a>>2]|0)+44>>2]|0,c[b>>2]|0)|0){i=d;return}else Cqh(TJ()|0)}function Rqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Sqh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Tqh(a){a=a|0;FJ(a)}function Uqh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Vqh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Wqh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Xqh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Yqh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Zqh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function _qh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function $qh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function arh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function brh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function crh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function drh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function erh(a){a=a|0;FJ(a)}function frh(a){a=a|0;FJ(a)}function grh(a){a=a|0;FJ(a)}function hrh(a){a=a|0;FJ(a)}function irh(a){a=a|0;FJ(a)}function jrh(a){a=a|0;FJ(a)}function krh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function lrh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function mrh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function nrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function orh(a){a=a|0;FJ(a)}function prh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+8|0;g=e+16|0;h=e;jM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;g=d;d=c[g+4>>2]|0;j=h;c[j>>2]=c[g>>2];c[j+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=_n[b&4095](a,f)|0;i=e;return h|0}function qrh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function rrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+24|0;h=f+16|0;j=f+32|0;k=f+8|0;l=f;iM(j,a,b);b=c[(c[j+4>>2]|0)+4>>2]|0;a=c[j>>2]|0;j=d;d=c[j+4>>2]|0;m=k;c[m>>2]=c[j>>2];c[m+4>>2]=d;d=e;e=c[d+4>>2]|0;m=l;c[m>>2]=c[d>>2];c[m+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];l=xo[b&2047](a,h,g)|0;i=f;return l|0}function srh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function trh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function urh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+8|0;g=e+16|0;h=e;jM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;g=d;d=c[g+4>>2]|0;j=h;c[j>>2]=c[g>>2];c[j+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=_n[b&4095](a,f)|0;i=e;return h|0}function vrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+8|0;g=e+16|0;h=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;g=d;d=c[g+4>>2]|0;j=h;c[j>>2]=c[g>>2];c[j+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=_n[b&4095](a,f)|0;i=e;return h|0}function wrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+24|0;h=f+16|0;j=f+32|0;k=f+8|0;l=f;iM(j,a,b);b=c[(c[j+4>>2]|0)+4>>2]|0;a=c[j>>2]|0;j=d;d=c[j+4>>2]|0;m=k;c[m>>2]=c[j>>2];c[m+4>>2]=d;d=e;e=c[d+4>>2]|0;m=l;c[m>>2]=c[d>>2];c[m+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];l=xo[b&2047](a,h,g)|0;i=f;return l|0}function xrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,b,d);In[c[(c[f+4>>2]|0)+4>>2]&4095](a,c[f>>2]|0);i=e;return}function yrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,b,d);In[c[(c[f+4>>2]|0)+4>>2]&4095](a,c[f>>2]|0);i=e;return}function zrh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Arh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Brh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Crh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Drh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Erh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Frh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Grh(a){a=a|0;FJ(a)}function Hrh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function Irh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Jrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Krh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Lrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Mrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Nrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Orh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Prh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Qrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;RI(1820016)|0;f=c[455028]|0;In[c[(c[f>>2]|0)+4>>2]&4095](a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](a,d);i=e;return}function Rrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Srh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Trh(a){a=a|0;var b=0;a=i;RI(1777920)|0;b=vGe(0,c[444504]|0)|0;i=a;return b|0}function Urh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Vrh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;RI(1810464)|0;f=c[452640]|0;In[c[(c[f>>2]|0)+4>>2]&4095](a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](a,d);i=e;return}function Wrh(b){b=b|0;var d=0;d=i;if(!(a[2536457]|0)){c[b>>2]=0;i=d;return}else{PEi(b|0,0,(c[634107]|0)+-8|0)|0;i=d;return}}function Xrh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Yrh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d;RI(1814192)|0;In[c[(c[c[1814192+96>>2]>>2]|0)+4>>2]&4095](e,b);c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];i=d;return}function Zrh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d;RI(1824112)|0;In[c[(c[c[1824112+96>>2]>>2]|0)+4>>2]&4095](e,b);c[a+0>>2]=c[e+0>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];i=d;return}function _rh(a){a=a|0;FJ(a)}function $rh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function ash(a){a=a|0;var b=0,d=0;b=i;RI(1831832)|0;d=vGe(a,c[457982]|0)|0;i=b;return d|0}function bsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function csh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function dsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function esh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function fsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function gsh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function hsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function ish(a){a=a|0;FJ(a)}function jsh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function ksh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function lsh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function msh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,b,d);co[c[(c[g+4>>2]|0)+4>>2]&2047](a,c[g>>2]|0,e);i=f;return}function nsh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+8|0;g=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];In[b&4095](a,f);i=e;return}function osh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+8|0;g=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];d=_n[b&4095](a,f)|0;i=e;return d|0}function psh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+8|0;g=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];d=_n[b&4095](a,f)|0;i=e;return d|0}function qsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+32|0;g=f+8|0;h=f;iM(h,a,b);b=c[(c[h+4>>2]|0)+4>>2]|0;a=c[h>>2]|0;c[g+0>>2]=c[e+0>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];co[b&2047](a,d,g);i=f;return}function rsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,b,d);co[c[(c[g+4>>2]|0)+4>>2]&2047](a,c[g>>2]|0,e);i=f;return}function ssh(a){a=a|0;FJ(a)}function tsh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function ush(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function vsh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function wsh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;g=d;d=c[g+4>>2]|0;j=h;c[j>>2]=c[g>>2];c[j+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];In[b&4095](a,f);i=e;return}function xsh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;g=d;d=c[g+4>>2]|0;j=h;c[j>>2]=c[g>>2];c[j+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=_n[b&4095](a,f)|0;i=e;return h|0}function ysh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;g=d;d=c[g+4>>2]|0;j=h;c[j>>2]=c[g>>2];c[j+4>>2]=d;c[f+0>>2]=c[h+0>>2];c[f+4>>2]=c[h+4>>2];h=_n[b&4095](a,f)|0;i=e;return h|0}function zsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f;iM(h,a,b);b=c[(c[h+4>>2]|0)+4>>2]|0;a=c[h>>2]|0;h=e;e=c[h+4>>2]|0;k=j;c[k>>2]=c[h>>2];c[k+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];co[b&2047](a,d,g);i=f;return}function Ash(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,b,d);co[c[(c[g+4>>2]|0)+4>>2]&2047](a,c[g>>2]|0,e);i=f;return}function Bsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+32|0;h=f+24|0;j=f+16|0;k=f+8|0;l=f;iM(j,a,b);b=c[(c[j+4>>2]|0)+4>>2]|0;a=c[j>>2]|0;j=d;d=c[j+4>>2]|0;m=k;c[m>>2]=c[j>>2];c[m+4>>2]=d;d=e;e=c[d+4>>2]|0;m=l;c[m>>2]=c[d>>2];c[m+4>>2]=e;c[h+0>>2]=c[k+0>>2];c[h+4>>2]=c[k+4>>2];c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];l=xo[b&2047](a,h,g)|0;i=f;return l|0}function Csh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Dsh(a){a=a|0;FJ(a)}function Esh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Fsh(a){a=a|0;var b=0,d=0;b=i;RI(2023280)|0;d=vGe(a,c[505844]|0)|0;i=b;return d|0}function Gsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Hsh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function Ish(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Jsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Ksh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Lsh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Msh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Nsh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function Osh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Psh(a){a=a|0;FJ(a)}function Qsh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Rsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Ssh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function Tsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Ush(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Vsh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function Wsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Xsh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Ysh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Zsh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function _sh(a){a=a|0;FJ(a)}function $sh(a){a=a|0;FJ(a)}function ath(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function bth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function cth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function dth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function eth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);ko[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0);i=d;return}function fth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function gth(a){a=a|0;FJ(a)}function hth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function ith(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function jth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function kth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);ko[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0);i=d;return}function lth(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function mth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function nth(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function oth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f;iM(h,a,b);b=c[(c[h+4>>2]|0)+4>>2]|0;a=c[h>>2]|0;h=e;e=c[h+4>>2]|0;k=j;c[k>>2]=c[h>>2];c[k+4>>2]=e;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];co[b&2047](a,d,g);i=f;return}function pth(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function qth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function rth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function sth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function tth(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function uth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function vth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function wth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function xth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function yth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function zth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Ath(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Bth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Cth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0;e=i;i=i+32|0;f=e+8|0;g=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];h=+$m[b&63](a,f);i=e;return +h}function Dth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Eth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Fth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Gth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Hth(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;jM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function Ith(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Jth(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;jM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function Kth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Lth(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;jM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function Mth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Nth(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;jM(j,a,b);En[c[(c[j+4>>2]|0)+4>>2]&127](c[j>>2]|0,d,e,f,g);i=h;return}function Oth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Pth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Qth(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;jM(j,a,b);En[c[(c[j+4>>2]|0)+4>>2]&127](c[j>>2]|0,d,e,f,g);i=h;return}function Rth(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;jM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function Sth(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;jM(k,a,b);rn[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h);i=j;return}function Tth(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;jM(k,a,b);rn[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h);i=j;return}function Uth(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;jM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function Vth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Wth(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Xth(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function Yth(a){a=a|0;FJ(a)}function Zth(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function _th(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function $th(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function auh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function buh(a,b,d,e){a=a|0;b=b|0;d=ea(d);e=ea(e);var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);on[c[(c[g+4>>2]|0)+4>>2]&31](c[g>>2]|0,d,e);i=f;return}function cuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function duh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function euh(a){a=a|0;var b=0,d=0;b=i;RI(1780192)|0;d=DGe(a,c[445072]|0)|0;i=b;return d|0}function fuh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function guh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function huh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function iuh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function juh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function kuh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function luh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function muh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function nuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function ouh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function puh(a){a=a|0;FJ(a)}function quh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function ruh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function suh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function tuh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function uuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function vuh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function wuh(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;m=i;i=i+16|0;n=m;iM(n,a,b);b=cn[c[(c[n+4>>2]|0)+4>>2]&15](c[n>>2]|0,d,e,f,g,h,j,k,l)|0;i=m;return b|0}function xuh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function yuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function zuh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Auh(a){a=a|0;FJ(a)}function Buh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Cuh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Duh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Euh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Fuh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Guh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function Huh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function Iuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Juh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Kuh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Luh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Muh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Nuh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Ouh(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+16|0;m=l;iM(m,a,b);b=Oo[c[(c[m+4>>2]|0)+4>>2]&63](c[m>>2]|0,d,e,f,g,h,j,k)|0;i=l;return b|0}function Puh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Quh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function Ruh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;jM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Suh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Tuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Uuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Vuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Wuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Xuh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Yuh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Zuh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function _uh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function $uh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;i=i+16|0;l=k;iM(l,a,b);b=gn[c[(c[l+4>>2]|0)+4>>2]&127](c[l>>2]|0,d,e,f,g,h,j)|0;i=k;return b|0}function avh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;i=i+16|0;l=k;iM(l,a,b);b=gn[c[(c[l+4>>2]|0)+4>>2]&127](c[l>>2]|0,d,e,f,g,h,j)|0;i=k;return b|0}function bvh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function cvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function dvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function evh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function fvh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function gvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function hvh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function ivh(a){a=a|0;FJ(a)}function jvh(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[b+145>>0]|0)){c[d>>2]=0;i=e;return}else{PEi(d|0,0,(c[b+116>>2]|0)+-8|0)|0;i=e;return}}function kvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function lvh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,b,d);co[c[(c[g+4>>2]|0)+4>>2]&2047](a,c[g>>2]|0,e);i=f;return}function mvh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function nvh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function ovh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function pvh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);En[c[(c[j+4>>2]|0)+4>>2]&127](c[j>>2]|0,d,e,f,g);i=h;return}function qvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function rvh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function svh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function tvh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function uvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function vvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function wvh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function xvh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function yvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function zvh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Avh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Bvh(a){a=a|0;FJ(a)}function Cvh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function Dvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Evh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Fvh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function Gvh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);Dn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f);i=g;return}function Hvh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Ivh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function Jvh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Kvh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Lvh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Mvh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Nvh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Ovh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Pvh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function Qvh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Rvh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Svh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=E5g(0,a,b,c[842695]|0)|0;i=d;return e|0}function Tvh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Uvh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function Vvh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Wvh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);rn[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h);i=j;return}function Xvh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Yvh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function Zvh(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if(!c){g=0;i=f;return g|0}h=uI(b,e)|0;if(!e){g=h;i=f;return g|0}else j=0;do{b=yI(h,4,j)|0;k=c+(j<<2)|0;l=d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24;a[b>>0]=l;a[b+1>>0]=l>>8;a[b+2>>0]=l>>16;a[b+3>>0]=l>>24;j=j+1|0}while((j|0)!=(e|0));g=h;i=f;return g|0}function _vh(a){a=a|0;FJ(a)}function $vh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function awh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function bwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function cwh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function dwh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function ewh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function fwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function gwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function hwh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;jM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function iwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function jwh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function kwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function lwh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function mwh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;iM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function nwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function owh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function pwh(a){a=a|0;FJ(a)}function qwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function rwh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function swh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function twh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function uwh(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!c){f=0;i=e;return f|0}g=uI(b,d)|0;if(!d){f=g;i=e;return f|0}else h=0;do{b=yI(g,1,h)|0;a[b>>0]=a[c+h>>0]|0;h=h+1|0}while((h|0)!=(d|0));f=g;i=e;return f|0}function vwh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function wwh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function xwh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function ywh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function zwh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Awh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Bwh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Cwh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Dwh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function Ewh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Fwh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Gwh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function Hwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e;iM(g,a,b);b=c[(c[g+4>>2]|0)+4>>2]|0;a=c[g>>2]|0;c[h>>2]=c[d>>2];c[f+0>>2]=c[h+0>>2];In[b&4095](a,f);i=e;return}function Iwh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Jwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Kwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Lwh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,b,d);co[c[(c[g+4>>2]|0)+4>>2]&2047](a,c[g>>2]|0,e);i=f;return}function Mwh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,b,d);co[c[(c[g+4>>2]|0)+4>>2]&2047](a,c[g>>2]|0,e);i=f;return}function Nwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0;e=i;i=i+16|0;f=e;jM(f,a,b);g=+$m[c[(c[f+4>>2]|0)+4>>2]&63](c[f>>2]|0,d);i=e;return +g}function Owh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Pwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Qwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Rwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=Im;e=i;i=i+16|0;f=e;jM(f,a,b);g=ea(Um[c[(c[f+4>>2]|0)+4>>2]&63](c[f>>2]|0,d));i=e;return ea(g)}function Swh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Twh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Uwh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;jM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function Vwh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Wwh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function Xwh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Ywh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Zwh(a){a=a|0;FJ(a)}function _wh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function $wh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);In[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d);i=e;return}function axh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function bxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function cxh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iM(e,a,b);b=mo[c[(c[e+4>>2]|0)+4>>2]&4095](c[e>>2]|0)|0;i=d;return b|0}function dxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function exh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,a,b);b=kn[c[(c[h+4>>2]|0)+4>>2]&511](c[h>>2]|0,d,e,f)|0;i=g;return b|0}function fxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function gxh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;i=i+16|0;k=j;iM(k,a,b);b=Km[c[(c[k+4>>2]|0)+4>>2]&127](c[k>>2]|0,d,e,f,g,h)|0;i=j;return b|0}function hxh(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+16|0;m=l;iM(m,a,b);b=Oo[c[(c[m+4>>2]|0)+4>>2]&63](c[m>>2]|0,d,e,f,g,h,j,k)|0;i=l;return b|0}function ixh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);co[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e);i=f;return}function jxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function kxh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function lxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function mxh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function nxh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function oxh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;iM(f,a,b);b=_n[c[(c[f+4>>2]|0)+4>>2]&4095](c[f>>2]|0,d)|0;i=e;return b|0}function pxh(a){a=a|0;var b=0,d=0,e=0;b=i;if(!a){d=0;i=b;return d|0}e=ZK(c[a+12>>2]<<2)|0;CL(a,e);d=e;i=b;return d|0}function qxh(a){a=a|0;FJ(a)}function rxh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function sxh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function txh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function uxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function vxh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function wxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function xxh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;RI(a)|0;d=vI(a,b)|0;i=c;return d|0}function yxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function zxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Axh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Bxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Cxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Dxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Exh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Fxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Gxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Hxh(a){a=a|0;FJ(a)}function Ixh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Jxh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Kxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Lxh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b)HJ();g=c[(c[b>>2]|0)+44>>2]|0;h=c[d+44>>2]|0;if((g|0)==(h|0)){d=yL(b)|0;i=e;return d|0}_J(f,g,h);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Mxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Nxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Oxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;iM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Pxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Qxh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;iM(h,b,d);Dn[c[(c[h+4>>2]|0)+4>>2]&511](a,c[h>>2]|0,e,f);i=g;return}function Rxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Sxh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Txh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jM(g,a,b);b=xo[c[(c[g+4>>2]|0)+4>>2]&2047](c[g>>2]|0,d,e)|0;i=f;return b|0}function Uxh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;jM(j,a,b);b=Bn[c[(c[j+4>>2]|0)+4>>2]&255](c[j>>2]|0,d,e,f,g)|0;i=h;return b|0}function Vxh(a){a=a|0;FJ(a)}function Wxh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;if(!b){g=0;i=e;return g|0}h=vL(b,d)|0;if(h){g=h;i=e;return g|0}_J(f,c[(c[b>>2]|0)+44>>2]|0,d);if(!(a[f>>0]&1))j=f+1|0;else j=c[f+8>>2]|0;FJ(MJ(j)|0);return 0}function Xxh(b){b=b|0;var c=0;c=i;if(a[b+148>>0]|0){i=c;return}lM(b);i=c;return}function Yxh(a){a=a|0;FJ(a)}function Zxh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function _xh(a){a=a|0;var b=0,d=0;b=i;RI(1256456)|0;d=mo[c[(c[c[1256456+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function $xh(a){a=a|0;c[a+4>>2]=-2;return}function ayh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function byh(a){a=a|0;var b=0,d=0;b=i;RI(1256456)|0;d=Wwe(a,c[314138]|0)|0;i=b;return d|0}function cyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function dyh(a){a=a|0;var b=0,d=0;b=i;RI(1257160)|0;d=mo[c[(c[c[1257160+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function eyh(a){a=a|0;c[a+4>>2]=-2;return}function fyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function gyh(a){a=a|0;var b=0,d=0;b=i;RI(1257160)|0;d=Wwe(a,c[314314]|0)|0;i=b;return d|0}function hyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function iyh(a){a=a|0;var b=0,d=0;b=i;RI(1262336)|0;d=mo[c[(c[c[1262336+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function jyh(a){a=a|0;c[a+4>>2]=-2;return}function kyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function lyh(a){a=a|0;var b=0,d=0;b=i;RI(1262336)|0;d=Wwe(a,c[315608]|0)|0;i=b;return d|0}function myh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function nyh(a){a=a|0;var b=0,d=0;b=i;RI(1264888)|0;d=mo[c[(c[c[1264888+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function oyh(a){a=a|0;c[a+4>>2]=-2;return}function pyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function qyh(a){a=a|0;var b=0,d=0;b=i;RI(1264888)|0;d=Wwe(a,c[316246]|0)|0;i=b;return d|0}function ryh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function syh(a){a=a|0;var b=0,d=0;b=i;RI(1267440)|0;d=mo[c[(c[c[1267440+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function tyh(a){a=a|0;c[a+4>>2]=-2;return}function uyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function vyh(a){a=a|0;var b=0,d=0;b=i;RI(1267440)|0;d=Wwe(a,c[316884]|0)|0;i=b;return d|0}function wyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function xyh(a){a=a|0;var b=0,d=0;b=i;RI(1269992)|0;d=mo[c[(c[c[1269992+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function yyh(a){a=a|0;c[a+4>>2]=-2;return}function zyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Ayh(a){a=a|0;var b=0,d=0;b=i;RI(1269992)|0;d=Wwe(a,c[317522]|0)|0;i=b;return d|0}function Byh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Cyh(a){a=a|0;var b=0,d=0;b=i;RI(1272544)|0;d=mo[c[(c[c[1272544+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function Dyh(a){a=a|0;c[a+4>>2]=-2;return}function Eyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Fyh(a){a=a|0;var b=0,d=0;b=i;RI(1272544)|0;d=Wwe(a,c[318160]|0)|0;i=b;return d|0}function Gyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Hyh(a){a=a|0;var b=0,d=0;b=i;RI(1274096)|0;d=mo[c[(c[c[1274096+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function Iyh(a){a=a|0;c[a+4>>2]=-2;return}function Jyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Kyh(a){a=a|0;var b=0,d=0;b=i;RI(1274096)|0;d=Wwe(a,c[318548]|0)|0;i=b;return d|0}function Lyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Myh(a){a=a|0;var b=0,d=0;b=i;RI(1276648)|0;d=mo[c[(c[c[1276648+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function Nyh(a){a=a|0;c[a+4>>2]=-2;return}function Oyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Pyh(a){a=a|0;var b=0,d=0;b=i;RI(1276648)|0;d=Wwe(a,c[319186]|0)|0;i=b;return d|0}function Qyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Ryh(a){a=a|0;var b=0,d=0;b=i;RI(1282752)|0;d=mo[c[(c[c[1282752+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function Syh(a){a=a|0;c[a+4>>2]=-2;return}function Tyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Uyh(a){a=a|0;var b=0,d=0;b=i;RI(1282752)|0;d=Wwe(a,c[320712]|0)|0;i=b;return d|0}function Vyh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function Wyh(a){a=a|0;var b=0,d=0;b=i;RI(1285304)|0;d=mo[c[(c[c[1285304+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function Xyh(a){a=a|0;c[a+4>>2]=-2;return}function Yyh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Zyh(a){a=a|0;var b=0,d=0;b=i;RI(1285304)|0;d=Wwe(a,c[321350]|0)|0;i=b;return d|0}function _yh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function $yh(a){a=a|0;var b=0,d=0;b=i;RI(1287856)|0;d=mo[c[(c[c[1287856+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function azh(a){a=a|0;c[a+4>>2]=-2;return}function bzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function czh(a){a=a|0;var b=0,d=0;b=i;RI(1287856)|0;d=Wwe(a,c[321988]|0)|0;i=b;return d|0}function dzh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function ezh(a){a=a|0;var b=0,d=0;b=i;RI(1290408)|0;d=mo[c[(c[c[1290408+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function fzh(a){a=a|0;c[a+4>>2]=-2;return}function gzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function hzh(a){a=a|0;var b=0,d=0;b=i;RI(1290408)|0;d=Wwe(a,c[322626]|0)|0;i=b;return d|0}function izh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function jzh(a){a=a|0;var b=0,d=0;b=i;RI(1292960)|0;d=mo[c[(c[c[1292960+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function kzh(a){a=a|0;c[a+4>>2]=-2;return}function lzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function mzh(a){a=a|0;var b=0,d=0;b=i;RI(1292960)|0;d=Wwe(a,c[323264]|0)|0;i=b;return d|0}function nzh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function ozh(a){a=a|0;var b=0,d=0;b=i;RI(1297064)|0;d=mo[c[(c[c[1297064+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function pzh(a){a=a|0;c[a+4>>2]=-2;return}function qzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function rzh(a){a=a|0;var b=0,d=0;b=i;RI(1297064)|0;d=Wwe(a,c[324290]|0)|0;i=b;return d|0}function szh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function tzh(a){a=a|0;var b=0,d=0;b=i;RI(1300616)|0;d=mo[c[(c[c[1300616+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function uzh(a){a=a|0;c[a+4>>2]=-2;return}function vzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function wzh(a){a=a|0;var b=0,d=0;b=i;RI(1300616)|0;d=Wwe(a,c[325178]|0)|0;i=b;return d|0}function xzh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;return}function yzh(a){a=a|0;var b=0,d=0;b=i;RI(1303168)|0;d=mo[c[(c[c[1303168+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function zzh(a){a=a|0;c[a+4>>2]=-2;return}function Azh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Bzh(a){a=a|0;var b=0,d=0;b=i;RI(1303168)|0;d=Wwe(a,c[325816]|0)|0;i=b;return d|0}function Czh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function Dzh(a){a=a|0;var b=0,d=0;b=i;RI(1308608)|0;d=Twe(a,c[327176]|0)|0;i=b;return d|0}function Ezh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function Fzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Gzh(a){a=a|0;var b=0,d=0;b=i;RI(1308608)|0;d=Wwe(a,c[327176]|0)|0;i=b;return d|0}function Hzh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function Izh(a){a=a|0;var b=0,d=0;b=i;RI(1311720)|0;d=Twe(a,c[327954]|0)|0;i=b;return d|0}function Jzh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function Kzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Lzh(a){a=a|0;var b=0,d=0;b=i;RI(1311720)|0;d=Wwe(a,c[327954]|0)|0;i=b;return d|0}function Mzh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function Nzh(a){a=a|0;var b=0,d=0;b=i;RI(1315824)|0;d=Twe(a,c[328980]|0)|0;i=b;return d|0}function Ozh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function Pzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Qzh(a){a=a|0;var b=0,d=0;b=i;RI(1315824)|0;d=Wwe(a,c[328980]|0)|0;i=b;return d|0}function Rzh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function Szh(a){a=a|0;var b=0,d=0;b=i;RI(1318376)|0;d=Twe(a,c[329618]|0)|0;i=b;return d|0}function Tzh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function Uzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function Vzh(a){a=a|0;var b=0,d=0;b=i;RI(1318376)|0;d=Wwe(a,c[329618]|0)|0;i=b;return d|0}function Wzh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function Xzh(a){a=a|0;var b=0,d=0;b=i;RI(1320928)|0;d=Twe(a,c[330256]|0)|0;i=b;return d|0}function Yzh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function Zzh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function _zh(a){a=a|0;var b=0,d=0;b=i;RI(1320928)|0;d=Wwe(a,c[330256]|0)|0;i=b;return d|0}function $zh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function aAh(a){a=a|0;var b=0,d=0;b=i;RI(1323480)|0;d=Twe(a,c[330894]|0)|0;i=b;return d|0}function bAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function cAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function dAh(a){a=a|0;var b=0,d=0;b=i;RI(1323480)|0;d=Wwe(a,c[330894]|0)|0;i=b;return d|0}function eAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function fAh(a){a=a|0;var b=0,d=0;b=i;RI(1326032)|0;d=Twe(a,c[331532]|0)|0;i=b;return d|0}function gAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function hAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function iAh(a){a=a|0;var b=0,d=0;b=i;RI(1326032)|0;d=Wwe(a,c[331532]|0)|0;i=b;return d|0}function jAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function kAh(a){a=a|0;var b=0,d=0;b=i;RI(1328584)|0;d=Twe(a,c[332170]|0)|0;i=b;return d|0}function lAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function mAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function nAh(a){a=a|0;var b=0,d=0;b=i;RI(1328584)|0;d=Wwe(a,c[332170]|0)|0;i=b;return d|0}function oAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function pAh(a){a=a|0;var b=0,d=0;b=i;RI(1331136)|0;d=Twe(a,c[332808]|0)|0;i=b;return d|0}function qAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function rAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function sAh(a){a=a|0;var b=0,d=0;b=i;RI(1331136)|0;d=Wwe(a,c[332808]|0)|0;i=b;return d|0}function tAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function uAh(a){a=a|0;var b=0,d=0;b=i;RI(1333688)|0;d=Twe(a,c[333446]|0)|0;i=b;return d|0}function vAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function wAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function xAh(a){a=a|0;var b=0,d=0;b=i;RI(1333688)|0;d=Wwe(a,c[333446]|0)|0;i=b;return d|0}function yAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function zAh(a){a=a|0;var b=0,d=0;b=i;RI(1349032)|0;d=Twe(a,c[337282]|0)|0;i=b;return d|0}function AAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function BAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function CAh(a){a=a|0;var b=0,d=0;b=i;RI(1349032)|0;d=Wwe(a,c[337282]|0)|0;i=b;return d|0}function DAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function EAh(a){a=a|0;var b=0,d=0;b=i;RI(1351864)|0;d=Twe(a,c[337990]|0)|0;i=b;return d|0}function FAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function GAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function HAh(a){a=a|0;var b=0,d=0;b=i;RI(1351864)|0;d=Wwe(a,c[337990]|0)|0;i=b;return d|0}function IAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function JAh(a){a=a|0;var b=0,d=0;b=i;RI(1355968)|0;d=Twe(a,c[339016]|0)|0;i=b;return d|0}function KAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function LAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function MAh(a){a=a|0;var b=0,d=0;b=i;RI(1355968)|0;d=Wwe(a,c[339016]|0)|0;i=b;return d|0}function NAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function OAh(a){a=a|0;var b=0,d=0;b=i;RI(1371400)|0;d=Twe(a,c[342874]|0)|0;i=b;return d|0}function PAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function QAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function RAh(a){a=a|0;var b=0,d=0;b=i;RI(1371400)|0;d=Wwe(a,c[342874]|0)|0;i=b;return d|0}function SAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function TAh(a){a=a|0;var b=0,d=0;b=i;RI(1379808)|0;d=Twe(a,c[344976]|0)|0;i=b;return d|0}function UAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function VAh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function WAh(a){a=a|0;var b=0,d=0;b=i;RI(1379808)|0;d=Wwe(a,c[344976]|0)|0;i=b;return d|0}function XAh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function YAh(a){a=a|0;var b=0,d=0;b=i;RI(1383360)|0;d=Twe(a,c[345864]|0)|0;i=b;return d|0}function ZAh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function _Ah(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function $Ah(a){a=a|0;var b=0,d=0;b=i;RI(1383360)|0;d=Wwe(a,c[345864]|0)|0;i=b;return d|0}function aBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function bBh(a){a=a|0;var b=0,d=0;b=i;RI(1385912)|0;d=Twe(a,c[346502]|0)|0;i=b;return d|0}function cBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function dBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function eBh(a){a=a|0;var b=0,d=0;b=i;RI(1385912)|0;d=Wwe(a,c[346502]|0)|0;i=b;return d|0}function fBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function gBh(a){a=a|0;var b=0,d=0;b=i;RI(1388464)|0;d=Twe(a,c[347140]|0)|0;i=b;return d|0}function hBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function iBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function jBh(a){a=a|0;var b=0,d=0;b=i;RI(1388464)|0;d=Wwe(a,c[347140]|0)|0;i=b;return d|0}function kBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function lBh(a){a=a|0;var b=0,d=0;b=i;RI(1390016)|0;d=Twe(a,c[347528]|0)|0;i=b;return d|0}function mBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function nBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function oBh(a){a=a|0;var b=0,d=0;b=i;RI(1390016)|0;d=Wwe(a,c[347528]|0)|0;i=b;return d|0}function pBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function qBh(a){a=a|0;var b=0,d=0;b=i;RI(1393568)|0;d=Twe(a,c[348416]|0)|0;i=b;return d|0}function rBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function sBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function tBh(a){a=a|0;var b=0,d=0;b=i;RI(1393568)|0;d=Wwe(a,c[348416]|0)|0;i=b;return d|0}function uBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function vBh(a){a=a|0;var b=0,d=0;b=i;RI(1395120)|0;d=Twe(a,c[348804]|0)|0;i=b;return d|0}function wBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function xBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function yBh(a){a=a|0;var b=0,d=0;b=i;RI(1395120)|0;d=Wwe(a,c[348804]|0)|0;i=b;return d|0}function zBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ABh(a){a=a|0;var b=0,d=0;b=i;RI(1397672)|0;d=Twe(a,c[349442]|0)|0;i=b;return d|0}function BBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function CBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function DBh(a){a=a|0;var b=0,d=0;b=i;RI(1397672)|0;d=Wwe(a,c[349442]|0)|0;i=b;return d|0}function EBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function FBh(a){a=a|0;var b=0,d=0;b=i;RI(1400224)|0;d=Twe(a,c[350080]|0)|0;i=b;return d|0}function GBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function HBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function IBh(a){a=a|0;var b=0,d=0;b=i;RI(1400224)|0;d=Wwe(a,c[350080]|0)|0;i=b;return d|0}function JBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function KBh(a){a=a|0;var b=0,d=0;b=i;RI(1402776)|0;d=Twe(a,c[350718]|0)|0;i=b;return d|0}function LBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function MBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function NBh(a){a=a|0;var b=0,d=0;b=i;RI(1402776)|0;d=Wwe(a,c[350718]|0)|0;i=b;return d|0}function OBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function PBh(a){a=a|0;var b=0,d=0;b=i;RI(1405328)|0;d=Twe(a,c[351356]|0)|0;i=b;return d|0}function QBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function RBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function SBh(a){a=a|0;var b=0,d=0;b=i;RI(1405328)|0;d=Wwe(a,c[351356]|0)|0;i=b;return d|0}function TBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function UBh(a){a=a|0;var b=0,d=0;b=i;RI(1407880)|0;d=Twe(a,c[351994]|0)|0;i=b;return d|0}function VBh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function WBh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function XBh(a){a=a|0;var b=0,d=0;b=i;RI(1407880)|0;d=Wwe(a,c[351994]|0)|0;i=b;return d|0}function YBh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ZBh(a){a=a|0;var b=0,d=0;b=i;RI(1410432)|0;d=Twe(a,c[352632]|0)|0;i=b;return d|0}function _Bh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function $Bh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function aCh(a){a=a|0;var b=0,d=0;b=i;RI(1410432)|0;d=Wwe(a,c[352632]|0)|0;i=b;return d|0}function bCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function cCh(a){a=a|0;var b=0,d=0;b=i;RI(1412984)|0;d=Twe(a,c[353270]|0)|0;i=b;return d|0}function dCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function eCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function fCh(a){a=a|0;var b=0,d=0;b=i;RI(1412984)|0;d=Wwe(a,c[353270]|0)|0;i=b;return d|0}function gCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function hCh(a){a=a|0;var b=0,d=0;b=i;RI(1415536)|0;d=Twe(a,c[353908]|0)|0;i=b;return d|0}function iCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function jCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function kCh(a){a=a|0;var b=0,d=0;b=i;RI(1415536)|0;d=Wwe(a,c[353908]|0)|0;i=b;return d|0}function lCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function mCh(a){a=a|0;var b=0,d=0;b=i;RI(1420248)|0;d=Twe(a,c[355086]|0)|0;i=b;return d|0}function nCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function oCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function pCh(a){a=a|0;var b=0,d=0;b=i;RI(1420248)|0;d=Wwe(a,c[355086]|0)|0;i=b;return d|0}function qCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function rCh(a){a=a|0;var b=0,d=0;b=i;RI(1422800)|0;d=Twe(a,c[355724]|0)|0;i=b;return d|0}function sCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function tCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function uCh(a){a=a|0;var b=0,d=0;b=i;RI(1422800)|0;d=Wwe(a,c[355724]|0)|0;i=b;return d|0}function vCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function wCh(a){a=a|0;var b=0,d=0;b=i;RI(1425352)|0;d=Twe(a,c[356362]|0)|0;i=b;return d|0}function xCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function yCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function zCh(a){a=a|0;var b=0,d=0;b=i;RI(1425352)|0;d=Wwe(a,c[356362]|0)|0;i=b;return d|0}function ACh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function BCh(a){a=a|0;var b=0,d=0;b=i;RI(1427904)|0;d=Twe(a,c[357e3]|0)|0;i=b;return d|0}function CCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function DCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function ECh(a){a=a|0;var b=0,d=0;b=i;RI(1427904)|0;d=Wwe(a,c[357e3]|0)|0;i=b;return d|0}function FCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function GCh(a){a=a|0;var b=0,d=0;b=i;RI(1430456)|0;d=Twe(a,c[357638]|0)|0;i=b;return d|0}function HCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function ICh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function JCh(a){a=a|0;var b=0,d=0;b=i;RI(1430456)|0;d=Wwe(a,c[357638]|0)|0;i=b;return d|0}function KCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function LCh(a){a=a|0;var b=0,d=0;b=i;RI(1433008)|0;d=Twe(a,c[358276]|0)|0;i=b;return d|0}function MCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function NCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function OCh(a){a=a|0;var b=0,d=0;b=i;RI(1433008)|0;d=Wwe(a,c[358276]|0)|0;i=b;return d|0}function PCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function QCh(a){a=a|0;var b=0,d=0;b=i;RI(1435560)|0;d=Twe(a,c[358914]|0)|0;i=b;return d|0}function RCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function SCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function TCh(a){a=a|0;var b=0,d=0;b=i;RI(1435560)|0;d=Wwe(a,c[358914]|0)|0;i=b;return d|0}function UCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function VCh(a){a=a|0;var b=0,d=0;b=i;RI(1438112)|0;d=Twe(a,c[359552]|0)|0;i=b;return d|0}function WCh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function XCh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function YCh(a){a=a|0;var b=0,d=0;b=i;RI(1438112)|0;d=Wwe(a,c[359552]|0)|0;i=b;return d|0}function ZCh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function _Ch(a){a=a|0;var b=0,d=0;b=i;RI(1443216)|0;d=Twe(a,c[360828]|0)|0;i=b;return d|0}function $Ch(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function aDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function bDh(a){a=a|0;var b=0,d=0;b=i;RI(1443216)|0;d=Wwe(a,c[360828]|0)|0;i=b;return d|0}function cDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function dDh(a){a=a|0;var b=0,d=0;b=i;RI(1445768)|0;d=Twe(a,c[361466]|0)|0;i=b;return d|0}function eDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function fDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function gDh(a){a=a|0;var b=0,d=0;b=i;RI(1445768)|0;d=Wwe(a,c[361466]|0)|0;i=b;return d|0}function hDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function iDh(a){a=a|0;var b=0,d=0;b=i;RI(1448320)|0;d=Twe(a,c[362104]|0)|0;i=b;return d|0}function jDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function kDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function lDh(a){a=a|0;var b=0,d=0;b=i;RI(1448320)|0;d=Wwe(a,c[362104]|0)|0;i=b;return d|0}function mDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function nDh(a){a=a|0;var b=0,d=0;b=i;RI(1463920)|0;d=Twe(a,c[366004]|0)|0;i=b;return d|0}function oDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function pDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function qDh(a){a=a|0;var b=0,d=0;b=i;RI(1463920)|0;d=Wwe(a,c[366004]|0)|0;i=b;return d|0}function rDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function sDh(a){a=a|0;var b=0,d=0;b=i;RI(1469024)|0;d=Twe(a,c[367280]|0)|0;i=b;return d|0}function tDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function uDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function vDh(a){a=a|0;var b=0,d=0;b=i;RI(1469024)|0;d=Wwe(a,c[367280]|0)|0;i=b;return d|0}function wDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function xDh(a){a=a|0;var b=0,d=0;b=i;RI(1473952)|0;d=Twe(a,c[368512]|0)|0;i=b;return d|0}function yDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function zDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function ADh(a){a=a|0;var b=0,d=0;b=i;RI(1473952)|0;d=Wwe(a,c[368512]|0)|0;i=b;return d|0}function BDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function CDh(a){a=a|0;var b=0,d=0;b=i;RI(1476504)|0;d=Twe(a,c[369150]|0)|0;i=b;return d|0}function DDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function EDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function FDh(a){a=a|0;var b=0,d=0;b=i;RI(1476504)|0;d=Wwe(a,c[369150]|0)|0;i=b;return d|0}function GDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function HDh(a){a=a|0;var b=0,d=0;b=i;RI(1479056)|0;d=Twe(a,c[369788]|0)|0;i=b;return d|0}function IDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function JDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function KDh(a){a=a|0;var b=0,d=0;b=i;RI(1479056)|0;d=Wwe(a,c[369788]|0)|0;i=b;return d|0}function LDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function MDh(a){a=a|0;var b=0,d=0;b=i;RI(1484160)|0;d=Twe(a,c[371064]|0)|0;i=b;return d|0}function NDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function ODh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function PDh(a){a=a|0;var b=0,d=0;b=i;RI(1484160)|0;d=Wwe(a,c[371064]|0)|0;i=b;return d|0}function QDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function RDh(a){a=a|0;var b=0,d=0;b=i;RI(1512232)|0;d=Twe(a,c[378082]|0)|0;i=b;return d|0}function SDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function TDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function UDh(a){a=a|0;var b=0,d=0;b=i;RI(1512232)|0;d=Wwe(a,c[378082]|0)|0;i=b;return d|0}function VDh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function WDh(a){a=a|0;var b=0,d=0;b=i;RI(1515784)|0;d=Twe(a,c[378970]|0)|0;i=b;return d|0}function XDh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function YDh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function ZDh(a){a=a|0;var b=0,d=0;b=i;RI(1515784)|0;d=Wwe(a,c[378970]|0)|0;i=b;return d|0}function _Dh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function $Dh(a){a=a|0;var b=0,d=0;b=i;RI(1517336)|0;d=Twe(a,c[379358]|0)|0;i=b;return d|0}function aEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function bEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function cEh(a){a=a|0;var b=0,d=0;b=i;RI(1517336)|0;d=Wwe(a,c[379358]|0)|0;i=b;return d|0}function dEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function eEh(a){a=a|0;var b=0,d=0;b=i;RI(1519888)|0;d=Twe(a,c[379996]|0)|0;i=b;return d|0}function fEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function gEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function hEh(a){a=a|0;var b=0,d=0;b=i;RI(1519888)|0;d=Wwe(a,c[379996]|0)|0;i=b;return d|0}function iEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function jEh(a){a=a|0;var b=0,d=0;b=i;RI(1523440)|0;d=Twe(a,c[380884]|0)|0;i=b;return d|0}function kEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function lEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function mEh(a){a=a|0;var b=0,d=0;b=i;RI(1523440)|0;d=Wwe(a,c[380884]|0)|0;i=b;return d|0}function nEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function oEh(a){a=a|0;var b=0,d=0;b=i;RI(1527392)|0;d=Twe(a,c[381872]|0)|0;i=b;return d|0}function pEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function qEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function rEh(a){a=a|0;var b=0,d=0;b=i;RI(1527392)|0;d=Wwe(a,c[381872]|0)|0;i=b;return d|0}function sEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function tEh(a){a=a|0;var b=0,d=0;b=i;RI(1530944)|0;d=Twe(a,c[382760]|0)|0;i=b;return d|0}function uEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function vEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function wEh(a){a=a|0;var b=0,d=0;b=i;RI(1530944)|0;d=Wwe(a,c[382760]|0)|0;i=b;return d|0}function xEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function yEh(a){a=a|0;var b=0,d=0;b=i;RI(1532496)|0;d=Twe(a,c[383148]|0)|0;i=b;return d|0}function zEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function AEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function BEh(a){a=a|0;var b=0,d=0;b=i;RI(1532496)|0;d=Wwe(a,c[383148]|0)|0;i=b;return d|0}function CEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function DEh(a){a=a|0;var b=0,d=0;b=i;RI(1536048)|0;d=Twe(a,c[384036]|0)|0;i=b;return d|0}function EEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function FEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function GEh(a){a=a|0;var b=0,d=0;b=i;RI(1536048)|0;d=Wwe(a,c[384036]|0)|0;i=b;return d|0}function HEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function IEh(a){a=a|0;var b=0,d=0;b=i;RI(1538600)|0;d=Twe(a,c[384674]|0)|0;i=b;return d|0}function JEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function KEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function LEh(a){a=a|0;var b=0,d=0;b=i;RI(1538600)|0;d=Wwe(a,c[384674]|0)|0;i=b;return d|0}function MEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function NEh(a){a=a|0;var b=0,d=0;b=i;RI(1541152)|0;d=Twe(a,c[385312]|0)|0;i=b;return d|0}function OEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function PEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function QEh(a){a=a|0;var b=0,d=0;b=i;RI(1541152)|0;d=Wwe(a,c[385312]|0)|0;i=b;return d|0}function REh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function SEh(a){a=a|0;var b=0,d=0;b=i;RI(1542704)|0;d=Twe(a,c[385700]|0)|0;i=b;return d|0}function TEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function UEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function VEh(a){a=a|0;var b=0,d=0;b=i;RI(1542704)|0;d=Wwe(a,c[385700]|0)|0;i=b;return d|0}function WEh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function XEh(a){a=a|0;var b=0,d=0;b=i;RI(1545256)|0;d=Twe(a,c[386338]|0)|0;i=b;return d|0}function YEh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function ZEh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function _Eh(a){a=a|0;var b=0,d=0;b=i;RI(1545256)|0;d=Wwe(a,c[386338]|0)|0;i=b;return d|0}function $Eh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function aFh(a){a=a|0;var b=0,d=0;b=i;RI(1547808)|0;d=Twe(a,c[386976]|0)|0;i=b;return d|0}function bFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function cFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function dFh(a){a=a|0;var b=0,d=0;b=i;RI(1547808)|0;d=Wwe(a,c[386976]|0)|0;i=b;return d|0}function eFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function fFh(a){a=a|0;var b=0,d=0;b=i;RI(1550360)|0;d=Twe(a,c[387614]|0)|0;i=b;return d|0}function gFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function hFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function iFh(a){a=a|0;var b=0,d=0;b=i;RI(1550360)|0;d=Wwe(a,c[387614]|0)|0;i=b;return d|0}function jFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function kFh(a){a=a|0;var b=0,d=0;b=i;RI(1552912)|0;d=Twe(a,c[388252]|0)|0;i=b;return d|0}function lFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function mFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function nFh(a){a=a|0;var b=0,d=0;b=i;RI(1552912)|0;d=Wwe(a,c[388252]|0)|0;i=b;return d|0}function oFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function pFh(a){a=a|0;var b=0,d=0;b=i;RI(1555464)|0;d=Twe(a,c[388890]|0)|0;i=b;return d|0}function qFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function rFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function sFh(a){a=a|0;var b=0,d=0;b=i;RI(1555464)|0;d=Wwe(a,c[388890]|0)|0;i=b;return d|0}function tFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function uFh(a){a=a|0;var b=0,d=0;b=i;RI(1558016)|0;d=Twe(a,c[389528]|0)|0;i=b;return d|0}function vFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function wFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function xFh(a){a=a|0;var b=0,d=0;b=i;RI(1558016)|0;d=Wwe(a,c[389528]|0)|0;i=b;return d|0}function yFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function zFh(a){a=a|0;var b=0,d=0;b=i;RI(1560568)|0;d=Twe(a,c[390166]|0)|0;i=b;return d|0}function AFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function BFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function CFh(a){a=a|0;var b=0,d=0;b=i;RI(1560568)|0;d=Wwe(a,c[390166]|0)|0;i=b;return d|0}function DFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function EFh(a){a=a|0;var b=0,d=0;b=i;RI(1565672)|0;d=Twe(a,c[391442]|0)|0;i=b;return d|0}function FFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function GFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function HFh(a){a=a|0;var b=0,d=0;b=i;RI(1565672)|0;d=Wwe(a,c[391442]|0)|0;i=b;return d|0}function IFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function JFh(a){a=a|0;var b=0,d=0;b=i;RI(1568224)|0;d=Twe(a,c[392080]|0)|0;i=b;return d|0}function KFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function LFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function MFh(a){a=a|0;var b=0,d=0;b=i;RI(1568224)|0;d=Wwe(a,c[392080]|0)|0;i=b;return d|0}function NFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function OFh(a){a=a|0;var b=0,d=0;b=i;RI(1570776)|0;d=Twe(a,c[392718]|0)|0;i=b;return d|0}function PFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function QFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function RFh(a){a=a|0;var b=0,d=0;b=i;RI(1570776)|0;d=Wwe(a,c[392718]|0)|0;i=b;return d|0}function SFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function TFh(a){a=a|0;var b=0,d=0;b=i;RI(1574328)|0;d=Twe(a,c[393606]|0)|0;i=b;return d|0}function UFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function VFh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function WFh(a){a=a|0;var b=0,d=0;b=i;RI(1574328)|0;d=Wwe(a,c[393606]|0)|0;i=b;return d|0}function XFh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function YFh(a){a=a|0;var b=0,d=0;b=i;RI(1606352)|0;d=Twe(a,c[401612]|0)|0;i=b;return d|0}function ZFh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function _Fh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function $Fh(a){a=a|0;var b=0,d=0;b=i;RI(1606352)|0;d=Wwe(a,c[401612]|0)|0;i=b;return d|0}function aGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function bGh(a){a=a|0;var b=0,d=0;b=i;RI(1608904)|0;d=Twe(a,c[402250]|0)|0;i=b;return d|0}function cGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function dGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function eGh(a){a=a|0;var b=0,d=0;b=i;RI(1608904)|0;d=Wwe(a,c[402250]|0)|0;i=b;return d|0}function fGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function gGh(a){a=a|0;var b=0,d=0;b=i;RI(1614008)|0;d=Twe(a,c[403526]|0)|0;i=b;return d|0}function hGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function iGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function jGh(a){a=a|0;var b=0,d=0;b=i;RI(1614008)|0;d=Wwe(a,c[403526]|0)|0;i=b;return d|0}function kGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function lGh(a){a=a|0;var b=0,d=0;b=i;RI(1616560)|0;d=Twe(a,c[404164]|0)|0;i=b;return d|0}function mGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function nGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function oGh(a){a=a|0;var b=0,d=0;b=i;RI(1616560)|0;d=Wwe(a,c[404164]|0)|0;i=b;return d|0}function pGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function qGh(a){a=a|0;var b=0,d=0;b=i;RI(1621664)|0;d=Twe(a,c[405440]|0)|0;i=b;return d|0}function rGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function sGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function tGh(a){a=a|0;var b=0,d=0;b=i;RI(1621664)|0;d=Wwe(a,c[405440]|0)|0;i=b;return d|0}function uGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function vGh(a){a=a|0;var b=0,d=0;b=i;RI(1629320)|0;d=Twe(a,c[407354]|0)|0;i=b;return d|0}function wGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function xGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function yGh(a){a=a|0;var b=0,d=0;b=i;RI(1629320)|0;d=Wwe(a,c[407354]|0)|0;i=b;return d|0}function zGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function AGh(a){a=a|0;var b=0,d=0;b=i;RI(1634272)|0;d=Twe(a,c[408592]|0)|0;i=b;return d|0}function BGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function CGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function DGh(a){a=a|0;var b=0,d=0;b=i;RI(1634272)|0;d=Wwe(a,c[408592]|0)|0;i=b;return d|0}function EGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function FGh(a){a=a|0;var b=0,d=0;b=i;RI(1639376)|0;d=Twe(a,c[409868]|0)|0;i=b;return d|0}function GGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function HGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function IGh(a){a=a|0;var b=0,d=0;b=i;RI(1639376)|0;d=Wwe(a,c[409868]|0)|0;i=b;return d|0}function JGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function KGh(a){a=a|0;var b=0,d=0;b=i;RI(1644480)|0;d=Twe(a,c[411144]|0)|0;i=b;return d|0}function LGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function MGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function NGh(a){a=a|0;var b=0,d=0;b=i;RI(1644480)|0;d=Wwe(a,c[411144]|0)|0;i=b;return d|0}function OGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function PGh(a){a=a|0;var b=0,d=0;b=i;RI(1647032)|0;d=Twe(a,c[411782]|0)|0;i=b;return d|0}function QGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function RGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function SGh(a){a=a|0;var b=0,d=0;b=i;RI(1647032)|0;d=Wwe(a,c[411782]|0)|0;i=b;return d|0}function TGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function UGh(a){a=a|0;var b=0,d=0;b=i;RI(1649584)|0;d=Twe(a,c[412420]|0)|0;i=b;return d|0}function VGh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function WGh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function XGh(a){a=a|0;var b=0,d=0;b=i;RI(1649584)|0;d=Wwe(a,c[412420]|0)|0;i=b;return d|0}function YGh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ZGh(a){a=a|0;var b=0,d=0;b=i;RI(1652136)|0;d=Twe(a,c[413058]|0)|0;i=b;return d|0}function _Gh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function $Gh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function aHh(a){a=a|0;var b=0,d=0;b=i;RI(1652136)|0;d=Wwe(a,c[413058]|0)|0;i=b;return d|0}function bHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function cHh(a){a=a|0;var b=0,d=0;b=i;RI(1654688)|0;d=Twe(a,c[413696]|0)|0;i=b;return d|0}function dHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function eHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function fHh(a){a=a|0;var b=0,d=0;b=i;RI(1654688)|0;d=Wwe(a,c[413696]|0)|0;i=b;return d|0}function gHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function hHh(a){a=a|0;var b=0,d=0;b=i;RI(1659792)|0;d=Twe(a,c[414972]|0)|0;i=b;return d|0}function iHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function jHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function kHh(a){a=a|0;var b=0,d=0;b=i;RI(1659792)|0;d=Wwe(a,c[414972]|0)|0;i=b;return d|0}function lHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function mHh(a){a=a|0;var b=0,d=0;b=i;RI(1663344)|0;d=Twe(a,c[415860]|0)|0;i=b;return d|0}function nHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function oHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function pHh(a){a=a|0;var b=0,d=0;b=i;RI(1663344)|0;d=Wwe(a,c[415860]|0)|0;i=b;return d|0}function qHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function rHh(a){a=a|0;var b=0,d=0;b=i;RI(1665896)|0;d=Twe(a,c[416498]|0)|0;i=b;return d|0}function sHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function tHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function uHh(a){a=a|0;var b=0,d=0;b=i;RI(1665896)|0;d=Wwe(a,c[416498]|0)|0;i=b;return d|0}function vHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function wHh(a){a=a|0;var b=0,d=0;b=i;RI(1668448)|0;d=Twe(a,c[417136]|0)|0;i=b;return d|0}function xHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function yHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function zHh(a){a=a|0;var b=0,d=0;b=i;RI(1668448)|0;d=Wwe(a,c[417136]|0)|0;i=b;return d|0}function AHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function BHh(a){a=a|0;var b=0,d=0;b=i;RI(1672552)|0;d=Twe(a,c[418162]|0)|0;i=b;return d|0}function CHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function DHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function EHh(a){a=a|0;var b=0,d=0;b=i;RI(1672552)|0;d=Wwe(a,c[418162]|0)|0;i=b;return d|0}function FHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function GHh(a){a=a|0;var b=0,d=0;b=i;RI(1692816)|0;d=Twe(a,c[423228]|0)|0;i=b;return d|0}function HHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function IHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function JHh(a){a=a|0;var b=0,d=0;b=i;RI(1692816)|0;d=Wwe(a,c[423228]|0)|0;i=b;return d|0}function KHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function LHh(a){a=a|0;var b=0,d=0;b=i;RI(1695368)|0;d=Twe(a,c[423866]|0)|0;i=b;return d|0}function MHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function NHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function OHh(a){a=a|0;var b=0,d=0;b=i;RI(1695368)|0;d=Wwe(a,c[423866]|0)|0;i=b;return d|0}function PHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function QHh(a){a=a|0;var b=0,d=0;b=i;RI(1697920)|0;d=Twe(a,c[424504]|0)|0;i=b;return d|0}function RHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function SHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function THh(a){a=a|0;var b=0,d=0;b=i;RI(1697920)|0;d=Wwe(a,c[424504]|0)|0;i=b;return d|0}function UHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function VHh(a){a=a|0;var b=0,d=0;b=i;RI(1727456)|0;d=Twe(a,c[431888]|0)|0;i=b;return d|0}function WHh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function XHh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function YHh(a){a=a|0;var b=0,d=0;b=i;RI(1727456)|0;d=Wwe(a,c[431888]|0)|0;i=b;return d|0}function ZHh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function _Hh(a){a=a|0;var b=0,d=0;b=i;RI(1739176)|0;d=Twe(a,c[434818]|0)|0;i=b;return d|0}function $Hh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function aIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function bIh(a){a=a|0;var b=0,d=0;b=i;RI(1739176)|0;d=Wwe(a,c[434818]|0)|0;i=b;return d|0}function cIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function dIh(a){a=a|0;var b=0,d=0;b=i;RI(1741728)|0;d=Twe(a,c[435456]|0)|0;i=b;return d|0}function eIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function fIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function gIh(a){a=a|0;var b=0,d=0;b=i;RI(1741728)|0;d=Wwe(a,c[435456]|0)|0;i=b;return d|0}function hIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function iIh(a){a=a|0;var b=0,d=0;b=i;RI(1747120)|0;d=Twe(a,c[436804]|0)|0;i=b;return d|0}function jIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function kIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function lIh(a){a=a|0;var b=0,d=0;b=i;RI(1747120)|0;d=Wwe(a,c[436804]|0)|0;i=b;return d|0}function mIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function nIh(a){a=a|0;var b=0,d=0;b=i;RI(1760824)|0;d=Twe(a,c[440230]|0)|0;i=b;return d|0}function oIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function pIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function qIh(a){a=a|0;var b=0,d=0;b=i;RI(1760824)|0;d=Wwe(a,c[440230]|0)|0;i=b;return d|0}function rIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function sIh(a){a=a|0;var b=0,d=0;b=i;RI(1764376)|0;d=Twe(a,c[441118]|0)|0;i=b;return d|0}function tIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function uIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function vIh(a){a=a|0;var b=0,d=0;b=i;RI(1764376)|0;d=Wwe(a,c[441118]|0)|0;i=b;return d|0}function wIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function xIh(a){a=a|0;var b=0,d=0;b=i;RI(1766928)|0;d=Twe(a,c[441756]|0)|0;i=b;return d|0}function yIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function zIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function AIh(a){a=a|0;var b=0,d=0;b=i;RI(1766928)|0;d=Wwe(a,c[441756]|0)|0;i=b;return d|0}function BIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function CIh(a){a=a|0;var b=0,d=0;b=i;RI(1769480)|0;d=Twe(a,c[442394]|0)|0;i=b;return d|0}function DIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function EIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function FIh(a){a=a|0;var b=0,d=0;b=i;RI(1769480)|0;d=Wwe(a,c[442394]|0)|0;i=b;return d|0}function GIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function HIh(a){a=a|0;var b=0,d=0;b=i;RI(1772032)|0;d=Twe(a,c[443032]|0)|0;i=b;return d|0}function IIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function JIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function KIh(a){a=a|0;var b=0,d=0;b=i;RI(1772032)|0;d=Wwe(a,c[443032]|0)|0;i=b;return d|0}function LIh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function MIh(a){a=a|0;var b=0,d=0;b=i;RI(1774584)|0;d=Twe(a,c[443670]|0)|0;i=b;return d|0}function NIh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function OIh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function PIh(a){a=a|0;var b=0,d=0;b=i;RI(1774584)|0;d=Wwe(a,c[443670]|0)|0;i=b;return d|0}function QIh(a){a=a|0;return}function RIh(a){a=a|0;a=i;RI(1777032)|0;sGe(0,c[444282]|0);i=a;return}function SIh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function TIh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function UIh(a){a=a|0;var b=0;a=i;RI(1777032)|0;b=vGe(0,c[444282]|0)|0;i=a;return b|0}function VIh(a){a=a|0;return}function WIh(a){a=a|0;a=i;RI(1777920)|0;sGe(0,c[444504]|0);i=a;return}function XIh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function YIh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function ZIh(a){a=a|0;var b=0;b=i;ko[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+36>>2]|0)+4>>2]&4095](a);i=b;return}function _Ih(a,b){a=a|0;b=b|0;var c=0;a=i;c=xGe(0,b)|0;i=a;return c|0}function $Ih(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=yGe(0,b,c)|0;i=a;return d|0}function aJh(a){a=a|0;var b=0;b=i;ko[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+36>>2]|0)+4>>2]&4095](a);i=b;return}function bJh(a,b){a=a|0;b=b|0;var c=0;a=i;c=xGe(0,b)|0;i=a;return c|0}function cJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=yGe(0,b,c)|0;i=a;return d|0}function dJh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function eJh(a){a=a|0;var b=0,d=0;b=i;RI(1780192)|0;d=AGe(a,c[445072]|0)|0;i=b;return d|0}function fJh(a){a=a|0;c[a>>2]=0;return}function gJh(a){a=a|0;var b=0;b=i;RI(1780192)|0;CGe(a,c[445072]|0);i=b;return}function hJh(a){a=a|0;var b=0,d=0;b=i;RI(1780192)|0;d=DGe(a,c[445072]|0)|0;i=b;return d|0}function iJh(a){a=a|0;return c[a+12>>2]|0}function jJh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+16>>2];return}function kJh(a){a=a|0;var b=0,d=0;b=i;RI(1781016)|0;d=AGe(a,c[445278]|0)|0;i=b;return d|0}function lJh(a){a=a|0;c[a>>2]=0;return}function mJh(a){a=a|0;var b=0;b=i;RI(1781016)|0;CGe(a,c[445278]|0);i=b;return}function nJh(a){a=a|0;var b=0,d=0;b=i;RI(1781016)|0;d=DGe(a,c[445278]|0)|0;i=b;return d|0}function oJh(a){a=a|0;return c[a+12>>2]|0}function pJh(a){a=a|0;var b=0;b=i;FGe(a);i=b;return}function qJh(a,b){a=a|0;b=b|0;var c=0;c=i;GGe(a,b);i=c;return}function rJh(a){a=a|0;a=i;RI(1781840)|0;HGe(0,c[445484]|0);i=a;return}function sJh(a){a=a|0;var b=0,c=0;b=i;c=IGe(a)|0;i=b;return c|0}function tJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JGe(a,b,c);i=d;return}function uJh(a){a=a|0;var b=0,c=0;b=i;c=KGe(a)|0;i=b;return c|0}function vJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LGe(a,b)|0;i=c;return d|0}function wJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MGe(a,b)|0;i=c;return d|0}function xJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=NGe(a,b)|0;i=c;return d|0}function yJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;OGe(a,b,c);i=d;return}function zJh(a,b){a=a|0;b=b|0;var c=0;c=i;PGe(a,b);i=c;return}function AJh(a){a=a|0;return 0}function BJh(a){a=a|0;return a|0}function CJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SGe(a,b)|0;i=c;return d|0}function DJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;TGe(a,b,c);i=d;return}function EJh(a,b){a=a|0;b=b|0;var c=0;c=i;UGe(a,b);i=c;return}function FJh(a,b){a=a|0;b=b|0;var c=0;c=i;VGe(a,b);i=c;return}function GJh(a){a=a|0;var b=0;b=i;WGe(a);i=b;return}function HJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XGe(a,b)|0;i=c;return d|0}function IJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;YGe(a,b,c);i=d;return}function JJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_Ge(a,b)|0;i=c;return d|0}function KJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$Ge(a,b,c);i=d;return}function LJh(a,b){a=a|0;b=b|0;var c=0;c=i;aHe(a,b);i=c;return}function MJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;bHe(a,b,c);i=d;return}function NJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=cHe(a,b)|0;i=c;return d|0}function OJh(a,b){a=a|0;b=b|0;var c=0;c=i;dHe(a,b);i=c;return}function PJh(a){a=a|0;var b=0,c=0;b=i;c=eHe(a)|0;i=b;return c|0}function QJh(a){a=a|0;return c[(c[a+8>>2]|0)+12>>2]|0}function RJh(a,b){a=a|0;b=b|0;var c=0;c=i;gHe(a,b);i=c;return}function SJh(a){a=a|0;return c[a+12>>2]|0}function TJh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=iHe(a,b)|0;i=c;return d|0}function UJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;jHe(a,b,c);i=d;return}function VJh(a){a=a|0;var b=0;b=i;FGe(a);i=b;return}function WJh(a,b){a=a|0;b=b|0;var c=0;c=i;GGe(a,b);i=c;return}function XJh(a){a=a|0;a=i;RI(1785128)|0;HGe(0,c[446306]|0);i=a;return}function YJh(a){a=a|0;var b=0,c=0;b=i;c=IGe(a)|0;i=b;return c|0}function ZJh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JGe(a,b,c);i=d;return}function _Jh(a){a=a|0;var b=0,c=0;b=i;c=KGe(a)|0;i=b;return c|0}function $Jh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LGe(a,b)|0;i=c;return d|0}function aKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MGe(a,b)|0;i=c;return d|0}function bKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=NGe(a,b)|0;i=c;return d|0}function cKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;OGe(a,b,c);i=d;return}function dKh(a,b){a=a|0;b=b|0;var c=0;c=i;PGe(a,b);i=c;return}function eKh(a){a=a|0;return 0}function fKh(a){a=a|0;return a|0}function gKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SGe(a,b)|0;i=c;return d|0}function hKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;TGe(a,b,c);i=d;return}function iKh(a,b){a=a|0;b=b|0;var c=0;c=i;UGe(a,b);i=c;return}function jKh(a,b){a=a|0;b=b|0;var c=0;c=i;VGe(a,b);i=c;return}function kKh(a){a=a|0;var b=0;b=i;WGe(a);i=b;return}function lKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XGe(a,b)|0;i=c;return d|0}function mKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;YGe(a,b,c);i=d;return}function nKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_Ge(a,b)|0;i=c;return d|0}function oKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$Ge(a,b,c);i=d;return}function pKh(a,b){a=a|0;b=b|0;var c=0;c=i;aHe(a,b);i=c;return}function qKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;bHe(a,b,c);i=d;return}function rKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=cHe(a,b)|0;i=c;return d|0}function sKh(a,b){a=a|0;b=b|0;var c=0;c=i;dHe(a,b);i=c;return}function tKh(a){a=a|0;var b=0,c=0;b=i;c=eHe(a)|0;i=b;return c|0}function uKh(a){a=a|0;return c[(c[a+8>>2]|0)+12>>2]|0}function vKh(a,b){a=a|0;b=b|0;var c=0;c=i;gHe(a,b);i=c;return}function wKh(a){a=a|0;return c[a+12>>2]|0}function xKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=iHe(a,b)|0;i=c;return d|0}function yKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;jHe(a,b,c);i=d;return}function zKh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function AKh(a){a=a|0;var b=0,d=0;b=i;RI(1789192)|0;d=Twe(a,c[447322]|0)|0;i=b;return d|0}function BKh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function CKh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function DKh(a){a=a|0;var b=0,d=0;b=i;RI(1789192)|0;d=Wwe(a,c[447322]|0)|0;i=b;return d|0}function EKh(a){a=a|0;return}function FKh(a){a=a|0;a=i;RI(1790520)|0;sGe(0,c[447654]|0);i=a;return}function GKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function HKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function IKh(a){a=a|0;var b=0;a=i;RI(1790520)|0;b=vGe(0,c[447654]|0)|0;i=a;return b|0}function JKh(a){a=a|0;var b=0;b=i;ko[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+36>>2]|0)+4>>2]&4095](a);i=b;return}function KKh(a,b){a=a|0;b=b|0;var c=0;a=i;c=xGe(0,b)|0;i=a;return c|0}function LKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=yGe(0,b,c)|0;i=a;return d|0}function MKh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function NKh(a){a=a|0;var b=0,d=0;b=i;RI(1795384)|0;d=Twe(a,c[448870]|0)|0;i=b;return d|0}function OKh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function PKh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function QKh(a){a=a|0;var b=0,d=0;b=i;RI(1795384)|0;d=Wwe(a,c[448870]|0)|0;i=b;return d|0}function RKh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function SKh(a){a=a|0;var b=0,d=0;b=i;RI(1797936)|0;d=Twe(a,c[449508]|0)|0;i=b;return d|0}function TKh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function UKh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function VKh(a){a=a|0;var b=0,d=0;b=i;RI(1797936)|0;d=Wwe(a,c[449508]|0)|0;i=b;return d|0}function WKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;PHe(a,b,c);i=d;return}function XKh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=THe(a,b)|0;i=c;return d|0}function YKh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=UHe(a,b,c)|0;i=d;return e|0}function ZKh(a){a=a|0;var b=0;b=i;wHe(a);i=b;return}function _Kh(a,b){a=a|0;b=b|0;var c=0;c=i;xHe(a,b);i=c;return}function $Kh(a,b){a=a|0;b=b|0;var c=0;c=i;yHe(a,b);i=c;return}function aLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zHe(a,b,c);i=d;return}function bLh(a){a=a|0;return a|0}function cLh(a){a=a|0;return 0}function dLh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]&2047](a,b,d);i=e;return}function eLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;EHe(a,b,c);i=d;return}function fLh(a){a=a|0;var b=0,c=0;b=i;c=FHe(a)|0;i=b;return c|0}function gLh(a){a=a|0;var b=0,c=0;b=i;c=GHe(a)|0;i=b;return c|0}function hLh(a){a=a|0;var b=0,c=0;b=i;c=HHe(a)|0;i=b;return c|0}function iLh(a){a=a|0;return c[a+32>>2]|0}function jLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;IHe(a,b,c);i=d;return}function kLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JHe(a,b,c);i=d;return}function lLh(a,b){a=a|0;b=b|0;var c=0;c=i;KHe(a,b);i=c;return}function mLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LHe(a,b,c);i=d;return}function nLh(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function oLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;NHe(a,b,c);i=d;return}function pLh(a){a=a|0;var b=0;b=i;OHe(a);i=b;return}function qLh(a){a=a|0;var b=0;b=i;QHe(a);i=b;return}function rLh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=RHe(a,b)|0;i=c;return d|0}function sLh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];SHe(a,b,f);i=e;return}function tLh(a){a=a|0;var b=0,c=0;b=i;c=VHe(a)|0;i=b;return c|0}function uLh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=WHe(a,b)|0;i=c;return d|0}function vLh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XHe(a,b)|0;i=c;return d|0}function wLh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;RI(1800432)|0;f=a;c[f>>2]=0;c[f+4>>2]=0;LOf(a,d,e);i=b;return}function xLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;PHe(a,b,c);i=d;return}function yLh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=THe(a,b)|0;i=c;return d|0}function zLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=UHe(a,b,c)|0;i=d;return e|0}function ALh(a){a=a|0;var b=0;b=i;wHe(a);i=b;return}function BLh(a,b){a=a|0;b=b|0;var c=0;c=i;xHe(a,b);i=c;return}function CLh(a,b){a=a|0;b=b|0;var c=0;c=i;yHe(a,b);i=c;return}function DLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zHe(a,b,c);i=d;return}function ELh(a){a=a|0;return a|0}function FLh(a){a=a|0;return 0}function GLh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;co[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+32>>2]|0)+4>>2]&2047](a,b,d);i=e;return}function HLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;EHe(a,b,c);i=d;return}function ILh(a){a=a|0;var b=0,c=0;b=i;c=FHe(a)|0;i=b;return c|0}function JLh(a){a=a|0;var b=0,c=0;b=i;c=GHe(a)|0;i=b;return c|0}function KLh(a){a=a|0;var b=0,c=0;b=i;c=HHe(a)|0;i=b;return c|0}function LLh(a){a=a|0;return c[a+32>>2]|0}function MLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;IHe(a,b,c);i=d;return}function NLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JHe(a,b,c);i=d;return}function OLh(a,b){a=a|0;b=b|0;var c=0;c=i;KHe(a,b);i=c;return}function PLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LHe(a,b,c);i=d;return}function QLh(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function RLh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;NHe(a,b,c);i=d;return}function SLh(a){a=a|0;var b=0;b=i;OHe(a);i=b;return}function TLh(a){a=a|0;var b=0;b=i;QHe(a);i=b;return}function ULh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=RHe(a,b)|0;i=c;return d|0}function VLh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];SHe(a,b,f);i=e;return}function WLh(a){a=a|0;var b=0,c=0;b=i;c=VHe(a)|0;i=b;return c|0}function XLh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=WHe(a,b)|0;i=c;return d|0}function YLh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XHe(a,b)|0;i=c;return d|0}function ZLh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;b=i;RI(1804920)|0;f=a;c[f>>2]=0;c[f+4>>2]=0;LOf(a,d,e);i=b;return}function _Lh(a){a=a|0;return c[a>>2]|0}function $Lh(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function aMh(a){a=a|0;return c[a+4>>2]|0}function bMh(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function cMh(a){a=a|0;var b=0,d=0;b=i;RI(1810464)|0;d=ZHe(a,c[452640]|0)|0;i=b;return d|0}function dMh(a,b){a=a|0;b=b|0;var c=0;c=i;dIe(a,b);i=c;return}function eMh(a,b){a=a|0;b=b|0;eIe(0,0)}function fMh(a){a=a|0;fIe(0)}function gMh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&4095](c[a+8>>2]|0,b)|0;i=d;return e|0}function hMh(a,b){a=a|0;b=b|0;gIe(0,0)|0;return 0}function iMh(a){a=a|0;var b=0,c=0;b=i;c=hIe(a)|0;i=b;return c|0}function jMh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;iIe(a,b,c);i=d;return}function kMh(a){a=a|0;var b=0,c=0;b=i;c=jIe(a)|0;i=b;return c|0}function lMh(a){a=a|0;return 1}function mMh(a){a=a|0;var b=0,c=0;b=i;c=kIe(a)|0;i=b;return c|0}function nMh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lIe(a,b,c);i=d;return}function oMh(a){a=a|0;var b=0,c=0;b=i;c=nIe(a)|0;i=b;return c|0}function pMh(a){a=a|0;var b=0,d=0;b=i;RI(1814192)|0;d=mo[c[(c[(c[1814192+96>>2]|0)+4>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function qMh(a){a=a|0;var b=0;b=i;RI(1814192)|0;ko[c[(c[(c[1814192+96>>2]|0)+12>>2]|0)+4>>2]&4095](a);i=b;return}function rMh(a){a=a|0;var b=0,d=0;b=i;RI(1814192)|0;d=mo[c[(c[(c[1814192+96>>2]|0)+16>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function sMh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function tMh(a){a=a|0;var b=0,d=0;b=i;RI(1814800)|0;d=oIe(a,c[453724]|0)|0;i=b;return d|0}function uMh(a,b){a=a|0;b=b|0;var d=0;d=i;RI(1814800)|0;pIe(a,b,c[453724]|0);i=d;return}function vMh(a){a=a|0;var b=0,d=0;b=i;RI(1814800)|0;d=mo[c[(c[(c[1814800+96>>2]|0)+24>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function wMh(a){a=a|0;var b=0,d=0;b=i;RI(1814800)|0;d=mo[c[(c[(c[1814800+96>>2]|0)+28>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function xMh(a){a=a|0;var b=0,d=0;b=i;RI(1814800)|0;d=qIe(a,c[453724]|0)|0;i=b;return d|0}function yMh(a){a=a|0;var b=0,d=0,e=0;b=i;RI(1814800)|0;d=c[453724]|0;ko[c[(c[d>>2]|0)+4>>2]&4095](a);e=mo[c[(c[d+8>>2]|0)+4>>2]&4095](a+12|0)|0;i=b;return e|0}function zMh(a){a=a|0;var b=0,d=0,e=0;b=i;RI(1814800)|0;d=c[453724]|0;ko[c[(c[d>>2]|0)+4>>2]&4095](a);e=mo[c[(c[d+16>>2]|0)+4>>2]&4095](a+12|0)|0;i=b;return e|0}function AMh(a){a=a|0;var b=0;b=i;sIe(a);i=b;return}function BMh(a){a=a|0;var b=0;b=i;RI(1814800)|0;tIe(a,c[453724]|0);i=b;return}function CMh(a){a=a|0;c[a>>2]=0;return}function DMh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function EMh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uIe(a,b,c)|0;i=d;return e|0}function FMh(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function GMh(a,b){a=a|0;b=b|0;return 0}function HMh(a,b){a=a|0;b=b|0;var c=0;c=i;DIe(a,b);i=c;return}function IMh(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0)+4>>2]&4095](a+8|0)|0;i=b;return d|0}function JMh(a,b){a=a|0;b=b|0;var c=0;c=i;EIe(a,b);i=c;return}function KMh(a){a=a|0;var b=0,c=0;b=i;c=FIe(a)|0;i=b;return c|0}function LMh(a){a=a|0;var b=0,c=0;b=i;c=GIe(a)|0;i=b;return c|0}function MMh(a){a=a|0;var b=0,c=0;b=i;c=HIe(a)|0;i=b;return c|0}function NMh(a){a=a|0;return c[a>>2]|0}function OMh(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function PMh(a){a=a|0;return c[a+4>>2]|0}function QMh(a,b){a=a|0;b=b|0;c[a+4>>2]=b;return}function RMh(a){a=a|0;var b=0,d=0;b=i;RI(1820016)|0;d=ZHe(a,c[455028]|0)|0;i=b;return d|0}function SMh(a,b){a=a|0;b=b|0;var c=0;c=i;dIe(a,b);i=c;return}function TMh(a,b){a=a|0;b=b|0;eIe(0,0)}function UMh(a){a=a|0;fIe(0)}function VMh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=_n[c[(c[c[(c[a>>2]|0)+96>>2]>>2]|0)+4>>2]&4095](c[a+8>>2]|0,b)|0;i=d;return e|0}function WMh(a,b){a=a|0;b=b|0;gIe(0,0)|0;return 0}function XMh(a){a=a|0;var b=0,c=0;b=i;c=hIe(a)|0;i=b;return c|0}function YMh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;iIe(a,b,c);i=d;return}function ZMh(a){a=a|0;var b=0,c=0;b=i;c=jIe(a)|0;i=b;return c|0}function _Mh(a){a=a|0;return 1}function $Mh(a){a=a|0;var b=0,c=0;b=i;c=kIe(a)|0;i=b;return c|0}function aNh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lIe(a,b,c);i=d;return}function bNh(a){a=a|0;var b=0,c=0;b=i;c=nIe(a)|0;i=b;return c|0}function cNh(a){a=a|0;var b=0,d=0;b=i;RI(1824112)|0;d=mo[c[(c[(c[1824112+96>>2]|0)+4>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function dNh(a){a=a|0;var b=0;b=i;RI(1824112)|0;ko[c[(c[(c[1824112+96>>2]|0)+12>>2]|0)+4>>2]&4095](a);i=b;return}function eNh(a){a=a|0;var b=0,d=0;b=i;RI(1824112)|0;d=mo[c[(c[(c[1824112+96>>2]|0)+16>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function fNh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+8>>2]=c[b+48>>2];return}function gNh(a){a=a|0;var b=0,d=0;b=i;RI(1824720)|0;d=oIe(a,c[456204]|0)|0;i=b;return d|0}function hNh(a,b){a=a|0;b=b|0;var d=0;d=i;RI(1824720)|0;pIe(a,b,c[456204]|0);i=d;return}function iNh(a){a=a|0;var b=0,d=0;b=i;RI(1824720)|0;d=mo[c[(c[(c[1824720+96>>2]|0)+24>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function jNh(a){a=a|0;var b=0,d=0;b=i;RI(1824720)|0;d=mo[c[(c[(c[1824720+96>>2]|0)+28>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function kNh(a){a=a|0;var b=0,d=0;b=i;RI(1824720)|0;d=qIe(a,c[456204]|0)|0;i=b;return d|0}function lNh(a){a=a|0;var b=0,d=0,e=0;b=i;RI(1824720)|0;d=c[456204]|0;ko[c[(c[d>>2]|0)+4>>2]&4095](a);e=mo[c[(c[d+8>>2]|0)+4>>2]&4095](a+12|0)|0;i=b;return e|0}function mNh(a){a=a|0;var b=0,d=0,e=0;b=i;RI(1824720)|0;d=c[456204]|0;ko[c[(c[d>>2]|0)+4>>2]&4095](a);e=mo[c[(c[d+16>>2]|0)+4>>2]&4095](a+12|0)|0;i=b;return e|0}function nNh(a){a=a|0;var b=0;b=i;sIe(a);i=b;return}function oNh(a){a=a|0;var b=0;b=i;RI(1824720)|0;tIe(a,c[456204]|0);i=b;return}function pNh(a){a=a|0;c[a>>2]=0;return}function qNh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function rNh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uIe(a,b,c)|0;i=d;return e|0}function sNh(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function tNh(a,b){a=a|0;b=b|0;return 0}function uNh(a,b){a=a|0;b=b|0;var c=0;c=i;DIe(a,b);i=c;return}function vNh(a){a=a|0;var b=0,d=0;b=i;d=mo[c[(c[(c[(c[a>>2]|0)+96>>2]|0)+4>>2]|0)+4>>2]&4095](a+8|0)|0;i=b;return d|0}function wNh(a,b){a=a|0;b=b|0;var c=0;c=i;EIe(a,b);i=c;return}function xNh(a){a=a|0;var b=0,c=0;b=i;c=FIe(a)|0;i=b;return c|0}function yNh(a){a=a|0;var b=0,c=0;b=i;c=GIe(a)|0;i=b;return c|0}function zNh(a){a=a|0;var b=0,c=0;b=i;c=HIe(a)|0;i=b;return c|0}function ANh(a){a=a|0;var b=0;b=i;rGe(a);i=b;return}function BNh(a){a=a|0;var b=0;b=i;RI(1831832)|0;sGe(a,c[457982]|0);i=b;return}function CNh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function DNh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function ENh(a){a=a|0;var b=0;b=i;wGe(a);i=b;return}function FNh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xGe(a,b)|0;i=c;return d|0}function GNh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yGe(a,b,c)|0;i=d;return e|0}function HNh(a){a=a|0;var b=0;b=i;rGe(a);i=b;return}function INh(a){a=a|0;var b=0;b=i;RI(1833640)|0;sGe(a,c[458434]|0);i=b;return}function JNh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function KNh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function LNh(a){a=a|0;var b=0,d=0;b=i;RI(1833640)|0;d=vGe(a,c[458434]|0)|0;i=b;return d|0}function MNh(a){a=a|0;var b=0;b=i;wGe(a);i=b;return}function NNh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xGe(a,b)|0;i=c;return d|0}function ONh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yGe(a,b,c)|0;i=d;return e|0}function PNh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function QNh(a){a=a|0;var b=0,d=0;b=i;RI(1859832)|0;d=Twe(a,c[464982]|0)|0;i=b;return d|0}function RNh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function SNh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function TNh(a){a=a|0;var b=0,d=0;b=i;RI(1859832)|0;d=Wwe(a,c[464982]|0)|0;i=b;return d|0}function UNh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function VNh(a){a=a|0;var b=0,d=0;b=i;RI(1863384)|0;d=Twe(a,c[465870]|0)|0;i=b;return d|0}function WNh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function XNh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function YNh(a){a=a|0;var b=0,d=0;b=i;RI(1863384)|0;d=Wwe(a,c[465870]|0)|0;i=b;return d|0}function ZNh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function _Nh(a){a=a|0;var b=0,d=0;b=i;RI(1864936)|0;d=Twe(a,c[466258]|0)|0;i=b;return d|0}function $Nh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function aOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function bOh(a){a=a|0;var b=0,d=0;b=i;RI(1864936)|0;d=Wwe(a,c[466258]|0)|0;i=b;return d|0}function cOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function dOh(a){a=a|0;var b=0,d=0;b=i;RI(1868488)|0;d=Twe(a,c[467146]|0)|0;i=b;return d|0}function eOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function fOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function gOh(a){a=a|0;var b=0,d=0;b=i;RI(1868488)|0;d=Wwe(a,c[467146]|0)|0;i=b;return d|0}function hOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function iOh(a){a=a|0;var b=0,d=0;b=i;RI(1871040)|0;d=Twe(a,c[467784]|0)|0;i=b;return d|0}function jOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function kOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function lOh(a){a=a|0;var b=0,d=0;b=i;RI(1871040)|0;d=Wwe(a,c[467784]|0)|0;i=b;return d|0}function mOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function nOh(a){a=a|0;var b=0,d=0;b=i;RI(1872592)|0;d=Twe(a,c[468172]|0)|0;i=b;return d|0}function oOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function pOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function qOh(a){a=a|0;var b=0,d=0;b=i;RI(1872592)|0;d=Wwe(a,c[468172]|0)|0;i=b;return d|0}function rOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function sOh(a){a=a|0;var b=0,d=0;b=i;RI(1875144)|0;d=Twe(a,c[468810]|0)|0;i=b;return d|0}function tOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function uOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function vOh(a){a=a|0;var b=0,d=0;b=i;RI(1875144)|0;d=Wwe(a,c[468810]|0)|0;i=b;return d|0}function wOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function xOh(a){a=a|0;var b=0,d=0;b=i;RI(1877696)|0;d=Twe(a,c[469448]|0)|0;i=b;return d|0}function yOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function zOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function AOh(a){a=a|0;var b=0,d=0;b=i;RI(1877696)|0;d=Wwe(a,c[469448]|0)|0;i=b;return d|0}function BOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function COh(a){a=a|0;var b=0,d=0;b=i;RI(1880248)|0;d=Twe(a,c[470086]|0)|0;i=b;return d|0}function DOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function EOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function FOh(a){a=a|0;var b=0,d=0;b=i;RI(1880248)|0;d=Wwe(a,c[470086]|0)|0;i=b;return d|0}function GOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function HOh(a){a=a|0;var b=0,d=0;b=i;RI(1882800)|0;d=Twe(a,c[470724]|0)|0;i=b;return d|0}function IOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function JOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function KOh(a){a=a|0;var b=0,d=0;b=i;RI(1882800)|0;d=Wwe(a,c[470724]|0)|0;i=b;return d|0}function LOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function MOh(a){a=a|0;var b=0,d=0;b=i;RI(1888904)|0;d=Twe(a,c[472250]|0)|0;i=b;return d|0}function NOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function OOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function POh(a){a=a|0;var b=0,d=0;b=i;RI(1888904)|0;d=Wwe(a,c[472250]|0)|0;i=b;return d|0}function QOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ROh(a){a=a|0;var b=0,d=0;b=i;RI(1895624)|0;d=Twe(a,c[473930]|0)|0;i=b;return d|0}function SOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function TOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function UOh(a){a=a|0;var b=0,d=0;b=i;RI(1895624)|0;d=Wwe(a,c[473930]|0)|0;i=b;return d|0}function VOh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function WOh(a){a=a|0;var b=0,d=0;b=i;RI(1898176)|0;d=Twe(a,c[474568]|0)|0;i=b;return d|0}function XOh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function YOh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function ZOh(a){a=a|0;var b=0,d=0;b=i;RI(1898176)|0;d=Wwe(a,c[474568]|0)|0;i=b;return d|0}function _Oh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function $Oh(a){a=a|0;var b=0,d=0;b=i;RI(1904560)|0;d=Twe(a,c[476164]|0)|0;i=b;return d|0}function aPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function bPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function cPh(a){a=a|0;var b=0,d=0;b=i;RI(1904560)|0;d=Wwe(a,c[476164]|0)|0;i=b;return d|0}function dPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ePh(a){a=a|0;var b=0,d=0;b=i;RI(1907392)|0;d=Twe(a,c[476872]|0)|0;i=b;return d|0}function fPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function gPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function hPh(a){a=a|0;var b=0,d=0;b=i;RI(1907392)|0;d=Wwe(a,c[476872]|0)|0;i=b;return d|0}function iPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function jPh(a){a=a|0;var b=0,d=0;b=i;RI(1914048)|0;d=Twe(a,c[478536]|0)|0;i=b;return d|0}function kPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function lPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function mPh(a){a=a|0;var b=0,d=0;b=i;RI(1914048)|0;d=Wwe(a,c[478536]|0)|0;i=b;return d|0}function nPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function oPh(a){a=a|0;var b=0,d=0;b=i;RI(1916600)|0;d=Twe(a,c[479174]|0)|0;i=b;return d|0}function pPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function qPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function rPh(a){a=a|0;var b=0,d=0;b=i;RI(1916600)|0;d=Wwe(a,c[479174]|0)|0;i=b;return d|0}function sPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function tPh(a){a=a|0;var b=0,d=0;b=i;RI(1926808)|0;d=Twe(a,c[481726]|0)|0;i=b;return d|0}function uPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function vPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function wPh(a){a=a|0;var b=0,d=0;b=i;RI(1926808)|0;d=Wwe(a,c[481726]|0)|0;i=b;return d|0}function xPh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function yPh(a,b){a=a|0;b=b|0;var c=0;c=i;OLe(a,b);i=c;return}function zPh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function APh(a,b){a=a|0;b=b|0;return}function BPh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d>>2]|0;c[a+8>>2]=c[e+4>>2];c[a+20>>2]=e;c[a+16>>2]=b;return}function CPh(a,b){a=a|0;b=b|0;var c=0;c=i;OLe(a,b);i=c;return}function DPh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function EPh(a,b){a=a|0;b=b|0;return}function FPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function GPh(a){a=a|0;var b=0,d=0;b=i;RI(1958656)|0;d=Twe(a,c[489688]|0)|0;i=b;return d|0}function HPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function IPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function JPh(a){a=a|0;var b=0,d=0;b=i;RI(1958656)|0;d=Wwe(a,c[489688]|0)|0;i=b;return d|0}function KPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function LPh(a){a=a|0;var b=0,d=0;b=i;RI(1961208)|0;d=Twe(a,c[490326]|0)|0;i=b;return d|0}function MPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function NPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function OPh(a){a=a|0;var b=0,d=0;b=i;RI(1961208)|0;d=Wwe(a,c[490326]|0)|0;i=b;return d|0}function PPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function QPh(a){a=a|0;var b=0,d=0;b=i;RI(1963760)|0;d=Twe(a,c[490964]|0)|0;i=b;return d|0}function RPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function SPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function TPh(a){a=a|0;var b=0,d=0;b=i;RI(1963760)|0;d=Wwe(a,c[490964]|0)|0;i=b;return d|0}function UPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function VPh(a){a=a|0;var b=0,d=0;b=i;RI(1966312)|0;d=Twe(a,c[491602]|0)|0;i=b;return d|0}function WPh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function XPh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function YPh(a){a=a|0;var b=0,d=0;b=i;RI(1966312)|0;d=Wwe(a,c[491602]|0)|0;i=b;return d|0}function ZPh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function _Ph(a){a=a|0;var b=0,d=0;b=i;RI(1968864)|0;d=Twe(a,c[492240]|0)|0;i=b;return d|0}function $Ph(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function aQh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function bQh(a){a=a|0;var b=0,d=0;b=i;RI(1968864)|0;d=Wwe(a,c[492240]|0)|0;i=b;return d|0}function cQh(a){a=a|0;return}function dQh(a){a=a|0;return a|0}function eQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LOe(a,b,c);i=d;return}function fQh(a){a=a|0;var b=0,c=0;b=i;c=MOe(a)|0;i=b;return c|0}function gQh(a){a=a|0;var b=0,c=0;b=i;c=NOe(a)|0;i=b;return c|0}function hQh(a){a=a|0;var b=0,c=0;b=i;c=OOe(a)|0;i=b;return c|0}function iQh(a,b){a=a|0;b=b|0;var c=0;c=i;POe(a,b);i=c;return}function jQh(a){a=a|0;return c[a+12>>2]|0}function kQh(a){a=a|0;return}function lQh(a){a=a|0;return a|0}function mQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LOe(a,b,c);i=d;return}function nQh(a){a=a|0;var b=0,c=0;b=i;c=MOe(a)|0;i=b;return c|0}function oQh(a){a=a|0;var b=0,c=0;b=i;c=NOe(a)|0;i=b;return c|0}function pQh(a){a=a|0;var b=0,c=0;b=i;c=OOe(a)|0;i=b;return c|0}function qQh(a,b){a=a|0;b=b|0;var c=0;c=i;POe(a,b);i=c;return}function rQh(a){a=a|0;return c[a+12>>2]|0}function sQh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;c[a+8>>2]=c[b+16>>2];return}function tQh(a){a=a|0;var b=0,d=0;b=i;RI(1973200)|0;d=mo[c[(c[c[1973200+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function uQh(a){a=a|0;c[a+4>>2]=-2;return}function vQh(a){a=a|0;var b=0,c=0;b=i;c=ROe(a)|0;i=b;return c|0}function wQh(a){a=a|0;var b=0,c=0;b=i;c=SOe(a)|0;i=b;return c|0}function xQh(a,b){a=a|0;b=b|0;c[a>>2]=b;c[a+4>>2]=-2;c[a+8>>2]=c[b+16>>2];return}function yQh(a){a=a|0;var b=0,d=0;b=i;RI(1973920)|0;d=mo[c[(c[c[1973920+96>>2]>>2]|0)+4>>2]&4095](a)|0;i=b;return d|0}function zQh(a){a=a|0;c[a+4>>2]=-2;return}function AQh(a){a=a|0;var b=0,c=0;b=i;c=ROe(a)|0;i=b;return c|0}function BQh(a){a=a|0;var b=0,c=0;b=i;c=SOe(a)|0;i=b;return c|0}function CQh(a){a=a|0;var b=0;b=i;FGe(a);i=b;return}function DQh(a,b){a=a|0;b=b|0;var c=0;c=i;GGe(a,b);i=c;return}function EQh(a){a=a|0;var b=0;b=i;RI(1974640)|0;HGe(a,c[493684]|0);i=b;return}function FQh(a){a=a|0;var b=0,c=0;b=i;c=IGe(a)|0;i=b;return c|0}function GQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JGe(a,b,c);i=d;return}function HQh(a){a=a|0;var b=0,c=0;b=i;c=KGe(a)|0;i=b;return c|0}function IQh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LGe(a,b)|0;i=c;return d|0}function JQh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MGe(a,b)|0;i=c;return d|0}function KQh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=NGe(a,b)|0;i=c;return d|0}function LQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;OGe(a,b,c);i=d;return}function MQh(a,b){a=a|0;b=b|0;var c=0;c=i;PGe(a,b);i=c;return}function NQh(a){a=a|0;var b=0,c=0;b=i;c=QGe(a)|0;i=b;return c|0}function OQh(a){a=a|0;var b=0,c=0;b=i;c=RGe(a)|0;i=b;return c|0}function PQh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SGe(a,b)|0;i=c;return d|0}function QQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;TGe(a,b,c);i=d;return}function RQh(a,b){a=a|0;b=b|0;var c=0;c=i;UGe(a,b);i=c;return}function SQh(a,b){a=a|0;b=b|0;var c=0;c=i;VGe(a,b);i=c;return}function TQh(a){a=a|0;var b=0;b=i;WGe(a);i=b;return}function UQh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XGe(a,b)|0;i=c;return d|0}function VQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;YGe(a,b,c);i=d;return}function WQh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_Ge(a,b)|0;i=c;return d|0}function XQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$Ge(a,b,c);i=d;return}function YQh(a,b){a=a|0;b=b|0;var c=0;c=i;aHe(a,b);i=c;return}function ZQh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;bHe(a,b,c);i=d;return}function _Qh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=cHe(a,b)|0;i=c;return d|0}function $Qh(a,b){a=a|0;b=b|0;var c=0;c=i;dHe(a,b);i=c;return}function aRh(a){a=a|0;var b=0,c=0;b=i;c=eHe(a)|0;i=b;return c|0}function bRh(a){a=a|0;var b=0,c=0;b=i;c=fHe(a)|0;i=b;return c|0}function cRh(a,b){a=a|0;b=b|0;var c=0;c=i;gHe(a,b);i=c;return}function dRh(a){a=a|0;var b=0,c=0;b=i;c=hHe(a)|0;i=b;return c|0}function eRh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=iHe(a,b)|0;i=c;return d|0}function fRh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;jHe(a,b,c);i=d;return}function gRh(a,b){a=a|0;b=b|0;var c=0;c=i;zGe(a,b);i=c;return}function hRh(a){a=a|0;var b=0,d=0;b=i;RI(1977704)|0;d=AGe(a,c[494450]|0)|0;i=b;return d|0}function iRh(a){a=a|0;var b=0;b=i;BGe(a);i=b;return}function jRh(a){a=a|0;var b=0;b=i;RI(1977704)|0;CGe(a,c[494450]|0);i=b;return}function kRh(a){a=a|0;var b=0,d=0;b=i;RI(1977704)|0;d=DGe(a,c[494450]|0)|0;i=b;return d|0}function lRh(a){a=a|0;var b=0,c=0;b=i;c=EGe(a)|0;i=b;return c|0}function mRh(a){a=a|0;var b=0;b=i;rGe(a);i=b;return}function nRh(a){a=a|0;var b=0;b=i;RI(1978528)|0;sGe(a,c[494656]|0);i=b;return}function oRh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function pRh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function qRh(a){a=a|0;var b=0,d=0;b=i;RI(1978528)|0;d=vGe(a,c[494656]|0)|0;i=b;return d|0}function rRh(a){a=a|0;var b=0;b=i;wGe(a);i=b;return}function sRh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xGe(a,b)|0;i=c;return d|0}function tRh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yGe(a,b,c)|0;i=d;return e|0}function uRh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function vRh(a){a=a|0;var b=0,d=0;b=i;RI(1980840)|0;d=Twe(a,c[495234]|0)|0;i=b;return d|0}function wRh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function xRh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function yRh(a){a=a|0;var b=0,d=0;b=i;RI(1980840)|0;d=Wwe(a,c[495234]|0)|0;i=b;return d|0}function zRh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ARh(a){a=a|0;var b=0,d=0;b=i;RI(1985944)|0;d=Twe(a,c[496510]|0)|0;i=b;return d|0}function BRh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function CRh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function DRh(a){a=a|0;var b=0,d=0;b=i;RI(1985944)|0;d=Wwe(a,c[496510]|0)|0;i=b;return d|0}function ERh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function FRh(a){a=a|0;var b=0,d=0;b=i;RI(1988496)|0;d=Twe(a,c[497148]|0)|0;i=b;return d|0}function GRh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function HRh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function IRh(a){a=a|0;var b=0,d=0;b=i;RI(1988496)|0;d=Wwe(a,c[497148]|0)|0;i=b;return d|0}function JRh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function KRh(a){a=a|0;var b=0,d=0;b=i;RI(2005088)|0;d=Twe(a,c[501296]|0)|0;i=b;return d|0}function LRh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function MRh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function NRh(a){a=a|0;var b=0,d=0;b=i;RI(2005088)|0;d=Wwe(a,c[501296]|0)|0;i=b;return d|0}function ORh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function PRh(a){a=a|0;var b=0,d=0;b=i;RI(2007920)|0;d=Twe(a,c[502004]|0)|0;i=b;return d|0}function QRh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function RRh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function SRh(a){a=a|0;var b=0,d=0;b=i;RI(2007920)|0;d=Wwe(a,c[502004]|0)|0;i=b;return d|0}function TRh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function URh(a){a=a|0;var b=0,d=0;b=i;RI(2012064)|0;d=Twe(a,c[503040]|0)|0;i=b;return d|0}function VRh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function WRh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function XRh(a){a=a|0;var b=0,d=0;b=i;RI(2012064)|0;d=Wwe(a,c[503040]|0)|0;i=b;return d|0}function YRh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function ZRh(a){a=a|0;var b=0,d=0;b=i;RI(2015616)|0;d=Twe(a,c[503928]|0)|0;i=b;return d|0}function _Rh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function $Rh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function aSh(a){a=a|0;var b=0,d=0;b=i;RI(2015616)|0;d=Wwe(a,c[503928]|0)|0;i=b;return d|0}function bSh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function cSh(a){a=a|0;var b=0,d=0;b=i;RI(2017168)|0;d=Twe(a,c[504316]|0)|0;i=b;return d|0}function dSh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function eSh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function fSh(a){a=a|0;var b=0,d=0;b=i;RI(2017168)|0;d=Wwe(a,c[504316]|0)|0;i=b;return d|0}function gSh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function hSh(a){a=a|0;var b=0,d=0;b=i;RI(2019720)|0;d=Twe(a,c[504954]|0)|0;i=b;return d|0}function iSh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function jSh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function kSh(a){a=a|0;var b=0,d=0;b=i;RI(2019720)|0;d=Wwe(a,c[504954]|0)|0;i=b;return d|0}function lSh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function mSh(a){a=a|0;var b=0,d=0;b=i;RI(2032016)|0;d=Twe(a,c[508028]|0)|0;i=b;return d|0}function nSh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function oSh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function pSh(a){a=a|0;var b=0,d=0;b=i;RI(2032016)|0;d=Wwe(a,c[508028]|0)|0;i=b;return d|0}function qSh(a){a=a|0;var b=0;b=i;rGe(a);i=b;return}function rSh(a){a=a|0;var b=0;b=i;RI(2023280)|0;sGe(a,c[505844]|0);i=b;return}function sSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function tSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function uSh(a){a=a|0;var b=0;b=i;wGe(a);i=b;return}function vSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xGe(a,b)|0;i=c;return d|0}function wSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yGe(a,b,c)|0;i=d;return e|0}function xSh(a){a=a|0;var b=0;b=i;FGe(a);i=b;return}function ySh(a,b){a=a|0;b=b|0;var c=0;c=i;GGe(a,b);i=c;return}function zSh(a){a=a|0;var b=0;b=i;RI(2047920)|0;HGe(a,c[512004]|0);i=b;return}function ASh(a){a=a|0;var b=0,c=0;b=i;c=IGe(a)|0;i=b;return c|0}function BSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JGe(a,b,c);i=d;return}function CSh(a){a=a|0;var b=0,c=0;b=i;c=KGe(a)|0;i=b;return c|0}function DSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LGe(a,b)|0;i=c;return d|0}function ESh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MGe(a,b)|0;i=c;return d|0}function FSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=NGe(a,b)|0;i=c;return d|0}function GSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;OGe(a,b,c);i=d;return}function HSh(a,b){a=a|0;b=b|0;var c=0;c=i;PGe(a,b);i=c;return}function ISh(a){a=a|0;var b=0,c=0;b=i;c=QGe(a)|0;i=b;return c|0}function JSh(a){a=a|0;var b=0,c=0;b=i;c=RGe(a)|0;i=b;return c|0}function KSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SGe(a,b)|0;i=c;return d|0}function LSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;TGe(a,b,c);i=d;return}function MSh(a,b){a=a|0;b=b|0;var c=0;c=i;UGe(a,b);i=c;return}function NSh(a,b){a=a|0;b=b|0;var c=0;c=i;VGe(a,b);i=c;return}function OSh(a){a=a|0;var b=0;b=i;WGe(a);i=b;return}function PSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XGe(a,b)|0;i=c;return d|0}function QSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;YGe(a,b,c);i=d;return}function RSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_Ge(a,b)|0;i=c;return d|0}function SSh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$Ge(a,b,c);i=d;return}function TSh(a,b){a=a|0;b=b|0;var c=0;c=i;aHe(a,b);i=c;return}function USh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;bHe(a,b,c);i=d;return}function VSh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=cHe(a,b)|0;i=c;return d|0}function WSh(a,b){a=a|0;b=b|0;var c=0;c=i;dHe(a,b);i=c;return}function XSh(a){a=a|0;var b=0,c=0;b=i;c=eHe(a)|0;i=b;return c|0}function YSh(a){a=a|0;var b=0,c=0;b=i;c=fHe(a)|0;i=b;return c|0}function ZSh(a,b){a=a|0;b=b|0;var c=0;c=i;gHe(a,b);i=c;return}function _Sh(a){a=a|0;var b=0,c=0;b=i;c=hHe(a)|0;i=b;return c|0}function $Sh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=iHe(a,b)|0;i=c;return d|0}function aTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;jHe(a,b,c);i=d;return}function bTh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function cTh(a){a=a|0;var b=0,d=0;b=i;RI(2052360)|0;d=Twe(a,c[513114]|0)|0;i=b;return d|0}function dTh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function eTh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function fTh(a){a=a|0;var b=0,d=0;b=i;RI(2052360)|0;d=Wwe(a,c[513114]|0)|0;i=b;return d|0}function gTh(a,b){a=a|0;b=b|0;var c=0;c=i;zGe(a,b);i=c;return}function hTh(a){a=a|0;var b=0,d=0;b=i;RI(2053688)|0;d=AGe(a,c[513446]|0)|0;i=b;return d|0}function iTh(a){a=a|0;var b=0;b=i;BGe(a);i=b;return}function jTh(a){a=a|0;var b=0;b=i;RI(2053688)|0;CGe(a,c[513446]|0);i=b;return}function kTh(a){a=a|0;var b=0,d=0;b=i;RI(2053688)|0;d=DGe(a,c[513446]|0)|0;i=b;return d|0}function lTh(a){a=a|0;var b=0,c=0;b=i;c=EGe(a)|0;i=b;return c|0}function mTh(a){a=a|0;var b=0;b=i;rGe(a);i=b;return}function nTh(a){a=a|0;var b=0;b=i;RI(2054512)|0;sGe(a,c[513652]|0);i=b;return}function oTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function pTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function qTh(a){a=a|0;var b=0,d=0;b=i;RI(2054512)|0;d=vGe(a,c[513652]|0)|0;i=b;return d|0}function rTh(a){a=a|0;var b=0;b=i;wGe(a);i=b;return}function sTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xGe(a,b)|0;i=c;return d|0}function tTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yGe(a,b,c)|0;i=d;return e|0}function uTh(a){a=a|0;var b=0;b=i;FGe(a);i=b;return}function vTh(a,b){a=a|0;b=b|0;var c=0;c=i;GGe(a,b);i=c;return}function wTh(a){a=a|0;var b=0;b=i;RI(2056600)|0;HGe(a,c[514174]|0);i=b;return}function xTh(a){a=a|0;var b=0,c=0;b=i;c=IGe(a)|0;i=b;return c|0}function yTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;JGe(a,b,c);i=d;return}function zTh(a){a=a|0;var b=0,c=0;b=i;c=KGe(a)|0;i=b;return c|0}function ATh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LGe(a,b)|0;i=c;return d|0}function BTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MGe(a,b)|0;i=c;return d|0}function CTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=NGe(a,b)|0;i=c;return d|0}function DTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;OGe(a,b,c);i=d;return}function ETh(a,b){a=a|0;b=b|0;var c=0;c=i;PGe(a,b);i=c;return}function FTh(a){a=a|0;var b=0,c=0;b=i;c=QGe(a)|0;i=b;return c|0}function GTh(a){a=a|0;var b=0,c=0;b=i;c=RGe(a)|0;i=b;return c|0}function HTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SGe(a,b)|0;i=c;return d|0}function ITh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;TGe(a,b,c);i=d;return}function JTh(a,b){a=a|0;b=b|0;var c=0;c=i;UGe(a,b);i=c;return}function KTh(a,b){a=a|0;b=b|0;var c=0;c=i;VGe(a,b);i=c;return}function LTh(a){a=a|0;var b=0;b=i;WGe(a);i=b;return}function MTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XGe(a,b)|0;i=c;return d|0}function NTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;YGe(a,b,c);i=d;return}function OTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_Ge(a,b)|0;i=c;return d|0}function PTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$Ge(a,b,c);i=d;return}function QTh(a,b){a=a|0;b=b|0;var c=0;c=i;aHe(a,b);i=c;return}function RTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;bHe(a,b,c);i=d;return}function STh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=cHe(a,b)|0;i=c;return d|0}function TTh(a,b){a=a|0;b=b|0;var c=0;c=i;dHe(a,b);i=c;return}function UTh(a){a=a|0;var b=0,c=0;b=i;c=eHe(a)|0;i=b;return c|0}function VTh(a){a=a|0;var b=0,c=0;b=i;c=fHe(a)|0;i=b;return c|0}function WTh(a,b){a=a|0;b=b|0;var c=0;c=i;gHe(a,b);i=c;return}function XTh(a){a=a|0;var b=0,c=0;b=i;c=hHe(a)|0;i=b;return c|0}function YTh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=iHe(a,b)|0;i=c;return d|0}function ZTh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;jHe(a,b,c);i=d;return}function _Th(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function $Th(a){a=a|0;var b=0,d=0;b=i;RI(2060888)|0;d=Twe(a,c[515246]|0)|0;i=b;return d|0}function aUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function bUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function cUh(a){a=a|0;var b=0,d=0;b=i;RI(2060888)|0;d=Wwe(a,c[515246]|0)|0;i=b;return d|0}function dUh(a,b){a=a|0;b=b|0;var c=0;c=i;zGe(a,b);i=c;return}function eUh(a){a=a|0;var b=0,d=0;b=i;RI(2062216)|0;d=AGe(a,c[515578]|0)|0;i=b;return d|0}function fUh(a){a=a|0;var b=0;b=i;BGe(a);i=b;return}function gUh(a){a=a|0;var b=0;b=i;RI(2062216)|0;CGe(a,c[515578]|0);i=b;return}function hUh(a){a=a|0;var b=0,d=0;b=i;RI(2062216)|0;d=DGe(a,c[515578]|0)|0;i=b;return d|0}function iUh(a){a=a|0;var b=0,c=0;b=i;c=EGe(a)|0;i=b;return c|0}function jUh(a){a=a|0;var b=0;b=i;rGe(a);i=b;return}function kUh(a){a=a|0;var b=0;b=i;RI(2063040)|0;sGe(a,c[515784]|0);i=b;return}function lUh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=tGe(a,b)|0;i=c;return d|0}function mUh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uGe(a,b,c)|0;i=d;return e|0}function nUh(a){a=a|0;var b=0,d=0;b=i;RI(2063040)|0;d=vGe(a,c[515784]|0)|0;i=b;return d|0}function oUh(a){a=a|0;var b=0;b=i;wGe(a);i=b;return}function pUh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xGe(a,b)|0;i=c;return d|0}function qUh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yGe(a,b,c)|0;i=d;return e|0}function rUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function sUh(a){a=a|0;var b=0,d=0;b=i;RI(2065352)|0;d=Twe(a,c[516362]|0)|0;i=b;return d|0}function tUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function uUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function vUh(a){a=a|0;var b=0,d=0;b=i;RI(2065352)|0;d=Wwe(a,c[516362]|0)|0;i=b;return d|0}function wUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function xUh(a){a=a|0;var b=0,d=0;b=i;RI(2067904)|0;d=Twe(a,c[517e3]|0)|0;i=b;return d|0}function yUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function zUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function AUh(a){a=a|0;var b=0,d=0;b=i;RI(2067904)|0;d=Wwe(a,c[517e3]|0)|0;i=b;return d|0}function BUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function CUh(a){a=a|0;var b=0,d=0;b=i;RI(2070456)|0;d=Twe(a,c[517638]|0)|0;i=b;return d|0}function DUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function EUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function FUh(a){a=a|0;var b=0,d=0;b=i;RI(2070456)|0;d=Wwe(a,c[517638]|0)|0;i=b;return d|0}function GUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function HUh(a){a=a|0;var b=0,d=0;b=i;RI(2073008)|0;d=Twe(a,c[518276]|0)|0;i=b;return d|0}function IUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function JUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function KUh(a){a=a|0;var b=0,d=0;b=i;RI(2073008)|0;d=Wwe(a,c[518276]|0)|0;i=b;return d|0}function LUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function MUh(a){a=a|0;var b=0,d=0;b=i;RI(2080896)|0;d=Twe(a,c[520248]|0)|0;i=b;return d|0}function NUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function OUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function PUh(a){a=a|0;var b=0,d=0;b=i;RI(2080896)|0;d=Wwe(a,c[520248]|0)|0;i=b;return d|0}function QUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function RUh(a){a=a|0;var b=0,d=0;b=i;RI(2083448)|0;d=Twe(a,c[520886]|0)|0;i=b;return d|0}function SUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function TUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function UUh(a){a=a|0;var b=0,d=0;b=i;RI(2083448)|0;d=Wwe(a,c[520886]|0)|0;i=b;return d|0}function VUh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function WUh(a){a=a|0;var b=0,d=0;b=i;RI(2086e3)|0;d=Twe(a,c[521524]|0)|0;i=b;return d|0}function XUh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function YUh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function ZUh(a){a=a|0;var b=0,d=0;b=i;RI(2086e3)|0;d=Wwe(a,c[521524]|0)|0;i=b;return d|0}function _Uh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function $Uh(a){a=a|0;var b=0,d=0;b=i;RI(2091104)|0;d=Twe(a,c[522800]|0)|0;i=b;return d|0}function aVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function bVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function cVh(a){a=a|0;var b=0,d=0;b=i;RI(2091104)|0;d=Wwe(a,c[522800]|0)|0;i=b;return d|0}function dVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function eVh(a){a=a|0;var b=0,d=0;b=i;RI(2105144)|0;d=Twe(a,c[526310]|0)|0;i=b;return d|0}function fVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function gVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function hVh(a){a=a|0;var b=0,d=0;b=i;RI(2105144)|0;d=Wwe(a,c[526310]|0)|0;i=b;return d|0}function iVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function jVh(a){a=a|0;var b=0,d=0;b=i;RI(2107976)|0;d=Twe(a,c[527018]|0)|0;i=b;return d|0}function kVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function lVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function mVh(a){a=a|0;var b=0,d=0;b=i;RI(2107976)|0;d=Wwe(a,c[527018]|0)|0;i=b;return d|0}function nVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function oVh(a){a=a|0;var b=0,d=0;b=i;RI(2126056)|0;d=Twe(a,c[531538]|0)|0;i=b;return d|0}function pVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function qVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function rVh(a){a=a|0;var b=0,d=0;b=i;RI(2126056)|0;d=Wwe(a,c[531538]|0)|0;i=b;return d|0}function sVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function tVh(a){a=a|0;var b=0,d=0;b=i;RI(2128888)|0;d=Twe(a,c[532246]|0)|0;i=b;return d|0}function uVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function vVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function wVh(a){a=a|0;var b=0,d=0;b=i;RI(2128888)|0;d=Wwe(a,c[532246]|0)|0;i=b;return d|0}function xVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function yVh(a){a=a|0;var b=0,d=0;b=i;RI(2165328)|0;d=Twe(a,c[541356]|0)|0;i=b;return d|0}function zVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function AVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function BVh(a){a=a|0;var b=0,d=0;b=i;RI(2165328)|0;d=Wwe(a,c[541356]|0)|0;i=b;return d|0}function CVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function DVh(a){a=a|0;var b=0,d=0;b=i;RI(2168160)|0;d=Twe(a,c[542064]|0)|0;i=b;return d|0}function EVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function FVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function GVh(a){a=a|0;var b=0,d=0;b=i;RI(2168160)|0;d=Wwe(a,c[542064]|0)|0;i=b;return d|0}function HVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function IVh(a){a=a|0;var b=0,d=0;b=i;RI(2177368)|0;d=Twe(a,c[544366]|0)|0;i=b;return d|0}function JVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function KVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function LVh(a){a=a|0;var b=0,d=0;b=i;RI(2177368)|0;d=Wwe(a,c[544366]|0)|0;i=b;return d|0}function MVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function NVh(a){a=a|0;var b=0,d=0;b=i;RI(2179920)|0;d=Twe(a,c[545004]|0)|0;i=b;return d|0}function OVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function PVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function QVh(a){a=a|0;var b=0,d=0;b=i;RI(2179920)|0;d=Wwe(a,c[545004]|0)|0;i=b;return d|0}function RVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function SVh(a){a=a|0;var b=0,d=0;b=i;RI(2182472)|0;d=Twe(a,c[545642]|0)|0;i=b;return d|0}function TVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function UVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function VVh(a){a=a|0;var b=0,d=0;b=i;RI(2182472)|0;d=Wwe(a,c[545642]|0)|0;i=b;return d|0}function WVh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function XVh(a){a=a|0;var b=0,d=0;b=i;RI(2185024)|0;d=Twe(a,c[546280]|0)|0;i=b;return d|0}function YVh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function ZVh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function _Vh(a){a=a|0;var b=0,d=0;b=i;RI(2185024)|0;d=Wwe(a,c[546280]|0)|0;i=b;return d|0}function $Vh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function aWh(a){a=a|0;var b=0,d=0;b=i;RI(2193760)|0;d=Twe(a,c[548464]|0)|0;i=b;return d|0}function bWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function cWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function dWh(a){a=a|0;var b=0,d=0;b=i;RI(2193760)|0;d=Wwe(a,c[548464]|0)|0;i=b;return d|0}function eWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function fWh(a){a=a|0;var b=0,d=0;b=i;RI(2196592)|0;d=Twe(a,c[549172]|0)|0;i=b;return d|0}function gWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function hWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function iWh(a){a=a|0;var b=0,d=0;b=i;RI(2196592)|0;d=Wwe(a,c[549172]|0)|0;i=b;return d|0}function jWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function kWh(a){a=a|0;var b=0,d=0;b=i;RI(2201976)|0;d=Twe(a,c[550518]|0)|0;i=b;return d|0}function lWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function mWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function nWh(a){a=a|0;var b=0,d=0;b=i;RI(2201976)|0;d=Wwe(a,c[550518]|0)|0;i=b;return d|0}function oWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function pWh(a){a=a|0;var b=0,d=0;b=i;RI(2204808)|0;d=Twe(a,c[551226]|0)|0;i=b;return d|0}function qWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function rWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function sWh(a){a=a|0;var b=0,d=0;b=i;RI(2204808)|0;d=Wwe(a,c[551226]|0)|0;i=b;return d|0}function tWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function uWh(a){a=a|0;var b=0,d=0;b=i;RI(2206360)|0;d=Twe(a,c[551614]|0)|0;i=b;return d|0}function vWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function wWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function xWh(a){a=a|0;var b=0,d=0;b=i;RI(2206360)|0;d=Wwe(a,c[551614]|0)|0;i=b;return d|0}function yWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function zWh(a){a=a|0;var b=0,d=0;b=i;RI(2212744)|0;d=Twe(a,c[553210]|0)|0;i=b;return d|0}function AWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function BWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function CWh(a){a=a|0;var b=0,d=0;b=i;RI(2212744)|0;d=Wwe(a,c[553210]|0)|0;i=b;return d|0}function DWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function EWh(a){a=a|0;var b=0,d=0;b=i;RI(2215576)|0;d=Twe(a,c[553918]|0)|0;i=b;return d|0}function FWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function GWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function HWh(a){a=a|0;var b=0,d=0;b=i;RI(2215576)|0;d=Wwe(a,c[553918]|0)|0;i=b;return d|0}function IWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function JWh(a){a=a|0;var b=0,d=0;b=i;RI(2220960)|0;d=Twe(a,c[555264]|0)|0;i=b;return d|0}function KWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function LWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function MWh(a){a=a|0;var b=0,d=0;b=i;RI(2220960)|0;d=Wwe(a,c[555264]|0)|0;i=b;return d|0}function NWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function OWh(a){a=a|0;var b=0,d=0;b=i;RI(2223792)|0;d=Twe(a,c[555972]|0)|0;i=b;return d|0}function PWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function QWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function RWh(a){a=a|0;var b=0,d=0;b=i;RI(2223792)|0;d=Wwe(a,c[555972]|0)|0;i=b;return d|0}function SWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function TWh(a){a=a|0;var b=0,d=0;b=i;RI(2229176)|0;d=Twe(a,c[557318]|0)|0;i=b;return d|0}function UWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function VWh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function WWh(a){a=a|0;var b=0,d=0;b=i;RI(2229176)|0;d=Wwe(a,c[557318]|0)|0;i=b;return d|0}function XWh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function YWh(a){a=a|0;var b=0,d=0;b=i;RI(2232008)|0;d=Twe(a,c[558026]|0)|0;i=b;return d|0}function ZWh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function _Wh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function $Wh(a){a=a|0;var b=0,d=0;b=i;RI(2232008)|0;d=Wwe(a,c[558026]|0)|0;i=b;return d|0}function aXh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function bXh(a){a=a|0;var b=0,d=0;b=i;RI(2237392)|0;d=Twe(a,c[559372]|0)|0;i=b;return d|0}function cXh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function dXh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function eXh(a){a=a|0;var b=0,d=0;b=i;RI(2237392)|0;d=Wwe(a,c[559372]|0)|0;i=b;return d|0}function fXh(a,b){a=a|0;b=b|0;var c=0;c=i;Swe(a,b);i=c;return}function gXh(a){a=a|0;var b=0,d=0;b=i;RI(2240224)|0;d=Twe(a,c[560080]|0)|0;i=b;return d|0}function hXh(a){a=a|0;var b=0;b=i;Uwe(a);i=b;return}function iXh(a){a=a|0;var b=0,c=0;b=i;c=Vwe(a)|0;i=b;return c|0}function jXh(a){a=a|0;var b=0,d=0;b=i;RI(2240224)|0;d=Wwe(a,c[560080]|0)|0;i=b;return d|0}function kXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function lXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function mXh(a,b){a=a|0;b=b|0;ASg(0,0)}function nXh(a,b){a=a|0;b=b|0;ASg(0,0)}function oXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function pXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function qXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function rXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sXh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function tXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function uXh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function vXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function wXh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[787137]|0)|0;i=b;return d|0}function xXh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function yXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function zXh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function AXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function BXh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[787251]|0)|0;i=b;return d|0}function CXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function DXh(a,b){a=a|0;b=b|0;ASg(0,0)}function EXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function FXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function GXh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function HXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function IXh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function JXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function KXh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[787457]|0)|0;i=b;return d|0}function LXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function MXh(a,b){a=a|0;b=b|0;ASg(0,0)}function NXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function OXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function PXh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function QXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function RXh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function SXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function TXh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[787663]|0)|0;i=b;return d|0}function UXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function VXh(a,b){a=a|0;b=b|0;ASg(0,0)}function WXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function XXh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function YXh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function ZXh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function _Xh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function $Xh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function aYh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[787869]|0)|0;i=b;return d|0}function bYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function cYh(a,b){a=a|0;b=b|0;ASg(0,0)}function dYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function eYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function fYh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function gYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function hYh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function iYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function jYh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[788075]|0)|0;i=b;return d|0}function kYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function lYh(a,b){a=a|0;b=b|0;ASg(0,0)}function mYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function nYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function oYh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function pYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function qYh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function rYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function sYh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[788281]|0)|0;i=b;return d|0}function tYh(a){a=a|0;var b=0,d=0;b=i;d=ISg(a,c[788301]|0)|0;i=b;return d|0}function uYh(a){a=a|0;var b=0,d=0;b=i;d=ISg(a,c[788321]|0)|0;i=b;return d|0}function vYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function wYh(a,b){a=a|0;b=b|0;ASg(0,0)}function xYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function yYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function zYh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function AYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function BYh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function CYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function DYh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[788527]|0)|0;i=b;return d|0}function EYh(a){a=a|0;var b=0,d=0;b=i;d=JSg(a,c[788547]|0)|0;i=b;return d|0}function FYh(a){a=a|0;var b=0,d=0;b=i;d=JSg(a,c[788567]|0)|0;i=b;return d|0}function GYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function HYh(a,b){a=a|0;b=b|0;ASg(0,0)}function IYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function JYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function KYh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function LYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function MYh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function NYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function OYh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[788773]|0)|0;i=b;return d|0}function PYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function QYh(a,b){a=a|0;b=b|0;ASg(0,0)}function RYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function SYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function TYh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function UYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function VYh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function WYh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function XYh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[789185]|0)|0;i=b;return d|0}function YYh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ZYh(a,b){a=a|0;b=b|0;ASg(0,0)}function _Yh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function $Yh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function aZh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function bZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function cZh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function dZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function eZh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[789391]|0)|0;i=b;return d|0}function fZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gZh(a,b){a=a|0;b=b|0;ASg(0,0)}function hZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function iZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jZh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function kZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function lZh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function mZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function nZh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[789597]|0)|0;i=b;return d|0}function oZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pZh(a,b){a=a|0;b=b|0;ASg(0,0)}function qZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function rZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sZh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function tZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function uZh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function vZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function wZh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[789803]|0)|0;i=b;return d|0}function xZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function yZh(a,b){a=a|0;b=b|0;ASg(0,0)}function zZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function AZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function BZh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function CZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function DZh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function EZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function FZh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[790009]|0)|0;i=b;return d|0}function GZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function HZh(a,b){a=a|0;b=b|0;ASg(0,0)}function IZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function JZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function KZh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function LZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function MZh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function NZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function OZh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[790421]|0)|0;i=b;return d|0}function PZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function QZh(a,b){a=a|0;b=b|0;ASg(0,0)}function RZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function SZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function TZh(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function UZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function VZh(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function WZh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function XZh(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[790627]|0)|0;i=b;return d|0}function YZh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ZZh(a,b){a=a|0;b=b|0;ASg(0,0)}function _Zh(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function $Zh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function a_h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function b_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function c_h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function d_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function e_h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[790833]|0)|0;i=b;return d|0}function f_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function g_h(a,b){a=a|0;b=b|0;ASg(0,0)}function h_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function i_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function j_h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function k_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function l_h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function m_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function n_h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[791039]|0)|0;i=b;return d|0}function o_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function p_h(a,b){a=a|0;b=b|0;ASg(0,0)}function q_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function r_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function s_h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function t_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function u_h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function v_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function w_h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[791245]|0)|0;i=b;return d|0}function x_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function y_h(a,b){a=a|0;b=b|0;ASg(0,0)}function z_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function A_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function B_h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function C_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function D_h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function E_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function F_h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[791657]|0)|0;i=b;return d|0}function G_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function H_h(a,b){a=a|0;b=b|0;ASg(0,0)}function I_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function J_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function K_h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function L_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function M_h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function N_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function O_h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[791863]|0)|0;i=b;return d|0}function P_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Q_h(a,b){a=a|0;b=b|0;ASg(0,0)}function R_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function S_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function T_h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function U_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function V_h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function W_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function X_h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[792069]|0)|0;i=b;return d|0}function Y_h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Z_h(a,b){a=a|0;b=b|0;ASg(0,0)}function __h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function $_h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function a$h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function b$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function c$h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function d$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function e$h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[792275]|0)|0;i=b;return d|0}function f$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function g$h(a,b){a=a|0;b=b|0;ASg(0,0)}function h$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function i$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function j$h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function k$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function l$h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function m$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function n$h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[792481]|0)|0;i=b;return d|0}function o$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function p$h(a,b){a=a|0;b=b|0;ASg(0,0)}function q$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function r$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function s$h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function t$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function u$h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function v$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function w$h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[792687]|0)|0;i=b;return d|0}function x$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function y$h(a,b){a=a|0;b=b|0;ASg(0,0)}function z$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function A$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function B$h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function C$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function D$h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function E$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function F$h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[792893]|0)|0;i=b;return d|0}function G$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function H$h(a,b){a=a|0;b=b|0;ASg(0,0)}function I$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function J$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function K$h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function L$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function M$h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function N$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function O$h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[793099]|0)|0;i=b;return d|0}function P$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Q$h(a,b){a=a|0;b=b|0;ASg(0,0)}function R$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function S$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function T$h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function U$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function V$h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function W$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function X$h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[793717]|0)|0;i=b;return d|0}function Y$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Z$h(a,b){a=a|0;b=b|0;ASg(0,0)}function _$h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function $$h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function a0h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function b0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function c0h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function d0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function e0h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[793923]|0)|0;i=b;return d|0}function f0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function g0h(a,b){a=a|0;b=b|0;ASg(0,0)}function h0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function i0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function j0h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function k0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function l0h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function m0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function n0h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[794335]|0)|0;i=b;return d|0}function o0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function p0h(a,b){a=a|0;b=b|0;ASg(0,0)}function q0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function r0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function s0h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function t0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function u0h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function v0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function w0h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[794875]|0)|0;i=b;return d|0}function x0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function y0h(a,b){a=a|0;b=b|0;ASg(0,0)}function z0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function A0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function B0h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function C0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function D0h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function E0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function F0h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[795081]|0)|0;i=b;return d|0}function G0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function H0h(a,b){a=a|0;b=b|0;ASg(0,0)}function I0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function J0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function K0h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function L0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function M0h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function N0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function O0h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[795287]|0)|0;i=b;return d|0}function P0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Q0h(a,b){a=a|0;b=b|0;ASg(0,0)}function R0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function S0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function T0h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function U0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function V0h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function W0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function X0h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[795493]|0)|0;i=b;return d|0}function Y0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Z0h(a,b){a=a|0;b=b|0;ASg(0,0)}function _0h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function $0h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function a1h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function b1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function c1h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function d1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function e1h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[795699]|0)|0;i=b;return d|0}function f1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function g1h(a,b){a=a|0;b=b|0;ASg(0,0)}function h1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function i1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function j1h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function k1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function l1h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function m1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function n1h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[795905]|0)|0;i=b;return d|0}function o1h(a,b,d){a=a|0;b=b|0;d=d|0;a=i;_Tg(0,b,d,c[795947]|0);i=a;return}function p1h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;a=i;$Tg(0,b,d,e,c[795967]|0);i=a;return}function q1h(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;g=aUg(0,b,d,e,f,c[795987]|0)|0;i=a;return g|0}function r1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function s1h(a,b){a=a|0;b=b|0;ASg(0,0)}function t1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function u1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function v1h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function w1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function x1h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function y1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function z1h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[796193]|0)|0;i=b;return d|0}function A1h(a,b,d){a=a|0;b=b|0;d=d|0;a=i;_Tg(0,b,d,c[796213]|0);i=a;return}function B1h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;a=i;$Tg(0,b,d,e,c[796233]|0);i=a;return}function C1h(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;a=i;g=aUg(0,b,d,e,f,c[796253]|0)|0;i=a;return g|0}function D1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function E1h(a,b){a=a|0;b=b|0;ASg(0,0)}function F1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function G1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function H1h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function I1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function J1h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function K1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function L1h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[796665]|0)|0;i=b;return d|0}function M1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function N1h(a,b){a=a|0;b=b|0;ASg(0,0)}function O1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function P1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Q1h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function R1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function S1h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function T1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function U1h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[796871]|0)|0;i=b;return d|0}function V1h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;tUg(a,b,d,e,c[797097]|0);i=f;return}function W1h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;tUg(a,b,d,e,c[797431]|0);i=f;return}function X1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Y1h(a,b){a=a|0;b=b|0;ASg(0,0)}function Z1h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function _1h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $1h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function a2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function b2h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function c2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function d2h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[798947]|0)|0;i=b;return d|0}function e2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function f2h(a,b){a=a|0;b=b|0;ASg(0,0)}function g2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function h2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function i2h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function j2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function k2h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function l2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function m2h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[799153]|0)|0;i=b;return d|0}function n2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function o2h(a,b){a=a|0;b=b|0;ASg(0,0)}function p2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function q2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function r2h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function s2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function t2h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function u2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function v2h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[799359]|0)|0;i=b;return d|0}function w2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function x2h(a,b){a=a|0;b=b|0;ASg(0,0)}function y2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function z2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function A2h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function B2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function C2h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function D2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function E2h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[799565]|0)|0;i=b;return d|0}function F2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function G2h(a,b){a=a|0;b=b|0;ASg(0,0)}function H2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function I2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function J2h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function K2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function L2h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function M2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function N2h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[799771]|0)|0;i=b;return d|0}function O2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function P2h(a,b){a=a|0;b=b|0;ASg(0,0)}function Q2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function R2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function S2h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function T2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function U2h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function V2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function W2h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[799977]|0)|0;i=b;return d|0}function X2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Y2h(a,b){a=a|0;b=b|0;ASg(0,0)}function Z2h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function _2h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $2h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function a3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function b3h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function c3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function d3h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[800183]|0)|0;i=b;return d|0}function e3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function f3h(a,b){a=a|0;b=b|0;ASg(0,0)}function g3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function h3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function i3h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function j3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function k3h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function l3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function m3h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[800389]|0)|0;i=b;return d|0}function n3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function o3h(a,b){a=a|0;b=b|0;ASg(0,0)}function p3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function q3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function r3h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function s3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function t3h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function u3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function v3h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[800595]|0)|0;i=b;return d|0}function w3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function x3h(a,b){a=a|0;b=b|0;ASg(0,0)}function y3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function z3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function A3h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function B3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function C3h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function D3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function E3h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[800801]|0)|0;i=b;return d|0}function F3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function G3h(a,b){a=a|0;b=b|0;ASg(0,0)}function H3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function I3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function J3h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function K3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function L3h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function M3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function N3h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[801213]|0)|0;i=b;return d|0}function O3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function P3h(a,b){a=a|0;b=b|0;ASg(0,0)}function Q3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function R3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function S3h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function T3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function U3h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function V3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function W3h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[801625]|0)|0;i=b;return d|0}function X3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Y3h(a,b){a=a|0;b=b|0;ASg(0,0)}function Z3h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function _3h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $3h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function a4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function b4h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function c4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function d4h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[801831]|0)|0;i=b;return d|0}function e4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function f4h(a,b){a=a|0;b=b|0;ASg(0,0)}function g4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function h4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function i4h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function j4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function k4h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function l4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function m4h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[802243]|0)|0;i=b;return d|0}function n4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function o4h(a,b){a=a|0;b=b|0;ASg(0,0)}function p4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function q4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function r4h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function s4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function t4h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function u4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function v4h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[802449]|0)|0;i=b;return d|0}function w4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function x4h(a,b){a=a|0;b=b|0;ASg(0,0)}function y4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function z4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function A4h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function B4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function C4h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function D4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function E4h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[803067]|0)|0;i=b;return d|0}function F4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function G4h(a,b){a=a|0;b=b|0;ASg(0,0)}function H4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function I4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function J4h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function K4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function L4h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function M4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function N4h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[803273]|0)|0;i=b;return d|0}function O4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function P4h(a,b){a=a|0;b=b|0;ASg(0,0)}function Q4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function R4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function S4h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function T4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function U4h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function V4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function W4h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[804097]|0)|0;i=b;return d|0}function X4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Y4h(a,b){a=a|0;b=b|0;ASg(0,0)}function Z4h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function _4h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $4h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function a5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function b5h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function c5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function d5h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[805101]|0)|0;i=b;return d|0}function e5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function f5h(a,b){a=a|0;b=b|0;ASg(0,0)}function g5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function h5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function i5h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function j5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function k5h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function l5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function m5h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[805307]|0)|0;i=b;return d|0}function n5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function o5h(a,b){a=a|0;b=b|0;ASg(0,0)}function p5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function q5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function r5h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function s5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function t5h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function u5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GSg(a,b,c,0);i=d;return}function v5h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[805513]|0)|0;i=b;return d|0}function w5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function x5h(a,b){a=a|0;b=b|0;ASg(0,0)}function y5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BSg(a,b,0)|0;i=c;return d|0}function z5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function A5h(a,b){a=a|0;b=b|0;DSg(0,0)|0;return 0}function B5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ESg(a,b,0)|0;i=c;return d|0}function C5h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(0,0,0)}function D5h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[807681]|0);i=e;return}function E5h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[807719]|0)|0;i=b;return d|0}function F5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function G5h(a,b){a=a|0;b=b|0;ASg(a,b)}function H5h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[807793]|0)|0;i=d;return e|0}function I5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function J5h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function K5h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[807849]|0)|0;i=d;return e|0}function L5h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function M5h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[807887]|0);i=e;return}function N5h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[807925]|0)|0;i=b;return d|0}function O5h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;_Tg(a,b,d,c[807947]|0);i=e;return}function P5h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;$Tg(a,b,d,e,c[807967]|0);i=f;return}function Q5h(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=aUg(a,b,d,e,f,c[807987]|0)|0;i=g;return h|0}function R5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function S5h(a,b){a=a|0;b=b|0;ASg(a,b)}function T5h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[808061]|0)|0;i=d;return e|0}function U5h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function V5h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function W5h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[808117]|0)|0;i=d;return e|0}function X5h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Y5h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[808155]|0);i=e;return}function Z5h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[808193]|0)|0;i=b;return d|0}function _5h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function $5h(a,b){a=a|0;b=b|0;ASg(a,b)}function a6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[808473]|0)|0;i=d;return e|0}function b6h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function c6h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function d6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[808529]|0)|0;i=d;return e|0}function e6h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function f6h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[808567]|0);i=e;return}function g6h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[808605]|0)|0;i=b;return d|0}function h6h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function i6h(a,b){a=a|0;b=b|0;ASg(a,b)}function j6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[808679]|0)|0;i=d;return e|0}function k6h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function l6h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function m6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[808735]|0)|0;i=d;return e|0}function n6h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function o6h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[808773]|0);i=e;return}function p6h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[808811]|0)|0;i=b;return d|0}function q6h(a){a=a|0;var b=0,d=0;b=i;d=JSg(a,c[809659]|0)|0;i=b;return d|0}function r6h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function s6h(a,b){a=a|0;b=b|0;ASg(a,b)}function t6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[809939]|0)|0;i=d;return e|0}function u6h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function v6h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function w6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[809995]|0)|0;i=d;return e|0}function x6h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function y6h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[810033]|0);i=e;return}function z6h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[810071]|0)|0;i=b;return d|0}function A6h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function B6h(a,b){a=a|0;b=b|0;ASg(a,b)}function C6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[810145]|0)|0;i=d;return e|0}function D6h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function E6h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function F6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[810201]|0)|0;i=d;return e|0}function G6h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function H6h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[810239]|0);i=e;return}function I6h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[810277]|0)|0;i=b;return d|0}function J6h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function K6h(a,b){a=a|0;b=b|0;ASg(a,b)}function L6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[810351]|0)|0;i=d;return e|0}function M6h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function N6h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function O6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[810407]|0)|0;i=d;return e|0}function P6h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Q6h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[810445]|0);i=e;return}function R6h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[810483]|0)|0;i=b;return d|0}function S6h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function T6h(a,b){a=a|0;b=b|0;ASg(a,b)}function U6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[810557]|0)|0;i=d;return e|0}function V6h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function W6h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function X6h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[810613]|0)|0;i=d;return e|0}function Y6h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Z6h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[810651]|0);i=e;return}function _6h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[810689]|0)|0;i=b;return d|0}function $6h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function a7h(a,b){a=a|0;b=b|0;ASg(a,b)}function b7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[810763]|0)|0;i=d;return e|0}function c7h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function d7h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function e7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[810819]|0)|0;i=d;return e|0}function f7h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function g7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[810857]|0);i=e;return}function h7h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[810895]|0)|0;i=b;return d|0}function i7h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function j7h(a,b){a=a|0;b=b|0;ASg(a,b)}function k7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[810969]|0)|0;i=d;return e|0}function l7h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function m7h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function n7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[811025]|0)|0;i=d;return e|0}function o7h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function p7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[811063]|0);i=e;return}function q7h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[811101]|0)|0;i=b;return d|0}function r7h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function s7h(a,b){a=a|0;b=b|0;ASg(a,b)}function t7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[811381]|0)|0;i=d;return e|0}function u7h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function v7h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function w7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[811437]|0)|0;i=d;return e|0}function x7h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function y7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[811475]|0);i=e;return}function z7h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[811513]|0)|0;i=b;return d|0}function A7h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function B7h(a,b){a=a|0;b=b|0;ASg(a,b)}function C7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[812159]|0)|0;i=d;return e|0}function D7h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function E7h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function F7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[812215]|0)|0;i=d;return e|0}function G7h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function H7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[812253]|0);i=e;return}function I7h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[812291]|0)|0;i=b;return d|0}function J7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;_Tg(a,b,d,c[812311]|0);i=e;return}function K7h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;$Tg(a,b,d,e,c[812331]|0);i=f;return}function L7h(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=aUg(a,b,d,e,f,c[812351]|0)|0;i=g;return h|0}function M7h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function N7h(a,b){a=a|0;b=b|0;ASg(a,b)}function O7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[812425]|0)|0;i=d;return e|0}function P7h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Q7h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function R7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[812481]|0)|0;i=d;return e|0}function S7h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function T7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[812519]|0);i=e;return}function U7h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[812557]|0)|0;i=b;return d|0}function V7h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;_Tg(a,b,d,c[812577]|0);i=e;return}function W7h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;$Tg(a,b,d,e,c[812597]|0);i=f;return}function X7h(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=aUg(a,b,d,e,f,c[812617]|0)|0;i=g;return h|0}function Y7h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Z7h(a,b){a=a|0;b=b|0;ASg(a,b)}function _7h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[812691]|0)|0;i=d;return e|0}function $7h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function a8h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function b8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[812747]|0)|0;i=d;return e|0}function c8h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function d8h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[812785]|0);i=e;return}function e8h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[812823]|0)|0;i=b;return d|0}function f8h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function g8h(a,b){a=a|0;b=b|0;ASg(a,b)}function h8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[812897]|0)|0;i=d;return e|0}function i8h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function j8h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function k8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[812953]|0)|0;i=d;return e|0}function l8h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function m8h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[812991]|0);i=e;return}function n8h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[813029]|0)|0;i=b;return d|0}function o8h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function p8h(a,b){a=a|0;b=b|0;ASg(a,b)}function q8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[813103]|0)|0;i=d;return e|0}function r8h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function s8h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function t8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[813159]|0)|0;i=d;return e|0}function u8h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function v8h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[813197]|0);i=e;return}function w8h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[813235]|0)|0;i=b;return d|0}function x8h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function y8h(a,b){a=a|0;b=b|0;ASg(a,b)}function z8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[813309]|0)|0;i=d;return e|0}function A8h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function B8h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function C8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[813365]|0)|0;i=d;return e|0}function D8h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function E8h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[813403]|0);i=e;return}function F8h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[813441]|0)|0;i=b;return d|0}function G8h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function H8h(a,b){a=a|0;b=b|0;ASg(a,b)}function I8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[813721]|0)|0;i=d;return e|0}function J8h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function K8h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function L8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[813777]|0)|0;i=d;return e|0}function M8h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function N8h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[813815]|0);i=e;return}function O8h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[813853]|0)|0;i=b;return d|0}function P8h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Q8h(a,b){a=a|0;b=b|0;ASg(a,b)}function R8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[813927]|0)|0;i=d;return e|0}function S8h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function T8h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function U8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[813983]|0)|0;i=d;return e|0}function V8h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function W8h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[814021]|0);i=e;return}function X8h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[814059]|0)|0;i=b;return d|0}function Y8h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Z8h(a,b){a=a|0;b=b|0;ASg(a,b)}function _8h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[814133]|0)|0;i=d;return e|0}function $8h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function a9h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function b9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[814189]|0)|0;i=d;return e|0}function c9h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function d9h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[814227]|0);i=e;return}function e9h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[814265]|0)|0;i=b;return d|0}function f9h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function g9h(a,b){a=a|0;b=b|0;ASg(a,b)}function h9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[814545]|0)|0;i=d;return e|0}function i9h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function j9h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function k9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[814601]|0)|0;i=d;return e|0}function l9h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function m9h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[814639]|0);i=e;return}function n9h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[814677]|0)|0;i=b;return d|0}function o9h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function p9h(a,b){a=a|0;b=b|0;ASg(a,b)}function q9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[815575]|0)|0;i=d;return e|0}function r9h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function s9h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function t9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[815631]|0)|0;i=d;return e|0}function u9h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function v9h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[815669]|0);i=e;return}function w9h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[815707]|0)|0;i=b;return d|0}function x9h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function y9h(a,b){a=a|0;b=b|0;ASg(a,b)}function z9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[815781]|0)|0;i=d;return e|0}function A9h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function B9h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function C9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[815837]|0)|0;i=d;return e|0}function D9h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function E9h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[815875]|0);i=e;return}function F9h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[815913]|0)|0;i=b;return d|0}function G9h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function H9h(a,b){a=a|0;b=b|0;ASg(a,b)}function I9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[816607]|0)|0;i=d;return e|0}function J9h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function K9h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function L9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[816663]|0)|0;i=d;return e|0}function M9h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function N9h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[816701]|0);i=e;return}function O9h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[816739]|0)|0;i=b;return d|0}function P9h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Q9h(a,b){a=a|0;b=b|0;ASg(a,b)}function R9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[816813]|0)|0;i=d;return e|0}function S9h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function T9h(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function U9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[816869]|0)|0;i=d;return e|0}function V9h(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function W9h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[816907]|0);i=e;return}function X9h(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[816945]|0)|0;i=b;return d|0}function Y9h(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Z9h(a,b){a=a|0;b=b|0;ASg(a,b)}function _9h(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[819023]|0)|0;i=d;return e|0}function $9h(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function aai(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[819079]|0)|0;i=d;return e|0}function cai(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[819117]|0);i=e;return}function eai(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[819155]|0)|0;i=b;return d|0}function fai(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gai(a,b){a=a|0;b=b|0;ASg(a,b)}function hai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[819229]|0)|0;i=d;return e|0}function iai(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jai(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[819285]|0)|0;i=d;return e|0}function lai(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[819323]|0);i=e;return}function nai(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[819361]|0)|0;i=b;return d|0}function oai(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pai(a,b){a=a|0;b=b|0;ASg(a,b)}function qai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[820053]|0)|0;i=d;return e|0}function rai(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sai(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[820109]|0)|0;i=d;return e|0}function uai(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[820147]|0);i=e;return}function wai(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[820185]|0)|0;i=b;return d|0}function xai(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function yai(a,b){a=a|0;b=b|0;ASg(a,b)}function zai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[820259]|0)|0;i=d;return e|0}function Aai(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bai(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[820315]|0)|0;i=d;return e|0}function Dai(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Eai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[820353]|0);i=e;return}function Fai(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[820391]|0)|0;i=b;return d|0}function Gai(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hai(a,b){a=a|0;b=b|0;ASg(a,b)}function Iai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[820465]|0)|0;i=d;return e|0}function Jai(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kai(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Lai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[820521]|0)|0;i=d;return e|0}function Mai(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Nai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[820559]|0);i=e;return}function Oai(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[820597]|0)|0;i=b;return d|0}function Pai(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qai(a,b){a=a|0;b=b|0;ASg(a,b)}function Rai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[820671]|0)|0;i=d;return e|0}function Sai(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tai(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Uai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[820727]|0)|0;i=d;return e|0}function Vai(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[820765]|0);i=e;return}function Xai(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[820803]|0)|0;i=b;return d|0}function Yai(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zai(a,b){a=a|0;b=b|0;ASg(a,b)}function _ai(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[821083]|0)|0;i=d;return e|0}function $ai(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function abi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[821139]|0)|0;i=d;return e|0}function cbi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dbi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[821177]|0);i=e;return}function ebi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[821215]|0)|0;i=b;return d|0}function fbi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gbi(a,b){a=a|0;b=b|0;ASg(a,b)}function hbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[821289]|0)|0;i=d;return e|0}function ibi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jbi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[821345]|0)|0;i=d;return e|0}function lbi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mbi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[821383]|0);i=e;return}function nbi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[821421]|0)|0;i=b;return d|0}function obi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pbi(a,b){a=a|0;b=b|0;ASg(a,b)}function qbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[821701]|0)|0;i=d;return e|0}function rbi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sbi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[821757]|0)|0;i=d;return e|0}function ubi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vbi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[821795]|0);i=e;return}function wbi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[821833]|0)|0;i=b;return d|0}function xbi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ybi(a,b){a=a|0;b=b|0;ASg(a,b)}function zbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[821907]|0)|0;i=d;return e|0}function Abi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bbi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[821963]|0)|0;i=d;return e|0}function Dbi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Ebi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[822001]|0);i=e;return}function Fbi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[822039]|0)|0;i=b;return d|0}function Gbi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hbi(a,b){a=a|0;b=b|0;ASg(a,b)}function Ibi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[822113]|0)|0;i=d;return e|0}function Jbi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kbi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Lbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[822169]|0)|0;i=d;return e|0}function Mbi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Nbi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[822207]|0);i=e;return}function Obi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[822245]|0)|0;i=b;return d|0}function Pbi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qbi(a,b){a=a|0;b=b|0;ASg(a,b)}function Rbi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[822525]|0)|0;i=d;return e|0}function Sbi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tbi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Ubi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[822581]|0)|0;i=d;return e|0}function Vbi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wbi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[822619]|0);i=e;return}function Xbi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[822657]|0)|0;i=b;return d|0}function Ybi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zbi(a,b){a=a|0;b=b|0;ASg(a,b)}function _bi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[822731]|0)|0;i=d;return e|0}function $bi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function aci(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[822787]|0)|0;i=d;return e|0}function cci(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[822825]|0);i=e;return}function eci(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[822863]|0)|0;i=b;return d|0}function fci(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gci(a,b){a=a|0;b=b|0;ASg(a,b)}function hci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[823143]|0)|0;i=d;return e|0}function ici(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jci(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[823199]|0)|0;i=d;return e|0}function lci(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[823237]|0);i=e;return}function nci(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[823275]|0)|0;i=b;return d|0}function oci(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pci(a,b){a=a|0;b=b|0;ASg(a,b)}function qci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[823349]|0)|0;i=d;return e|0}function rci(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sci(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[823405]|0)|0;i=d;return e|0}function uci(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[823443]|0);i=e;return}function wci(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[823481]|0)|0;i=b;return d|0}function xci(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function yci(a,b){a=a|0;b=b|0;ASg(a,b)}function zci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[823761]|0)|0;i=d;return e|0}function Aci(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bci(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[823817]|0)|0;i=d;return e|0}function Dci(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Eci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[823855]|0);i=e;return}function Fci(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[823893]|0)|0;i=b;return d|0}function Gci(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hci(a,b){a=a|0;b=b|0;ASg(a,b)}function Ici(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[823967]|0)|0;i=d;return e|0}function Jci(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kci(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Lci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[824023]|0)|0;i=d;return e|0}function Mci(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Nci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[824061]|0);i=e;return}function Oci(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[824099]|0)|0;i=b;return d|0}function Pci(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qci(a,b){a=a|0;b=b|0;ASg(a,b)}function Rci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[824379]|0)|0;i=d;return e|0}function Sci(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tci(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Uci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[824435]|0)|0;i=d;return e|0}function Vci(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[824473]|0);i=e;return}function Xci(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[824511]|0)|0;i=b;return d|0}function Yci(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zci(a,b){a=a|0;b=b|0;ASg(a,b)}function _ci(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[824585]|0)|0;i=d;return e|0}function $ci(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function adi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[824641]|0)|0;i=d;return e|0}function cdi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function ddi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[824679]|0);i=e;return}function edi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[824717]|0)|0;i=b;return d|0}function fdi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gdi(a,b){a=a|0;b=b|0;ASg(a,b)}function hdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[824997]|0)|0;i=d;return e|0}function idi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jdi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[825053]|0)|0;i=d;return e|0}function ldi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mdi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[825091]|0);i=e;return}function ndi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[825129]|0)|0;i=b;return d|0}function odi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pdi(a,b){a=a|0;b=b|0;ASg(a,b)}function qdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[825367]|0)|0;i=d;return e|0}function rdi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sdi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[825423]|0)|0;i=d;return e|0}function udi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vdi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[825461]|0);i=e;return}function wdi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[825499]|0)|0;i=b;return d|0}function xdi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ydi(a,b){a=a|0;b=b|0;ASg(a,b)}function zdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[825573]|0)|0;i=d;return e|0}function Adi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bdi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[825629]|0)|0;i=d;return e|0}function Ddi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Edi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[825667]|0);i=e;return}function Fdi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[825705]|0)|0;i=b;return d|0}function Gdi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hdi(a,b){a=a|0;b=b|0;ASg(a,b)}function Idi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[825779]|0)|0;i=d;return e|0}function Jdi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kdi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Ldi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[825835]|0)|0;i=d;return e|0}function Mdi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Ndi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[825873]|0);i=e;return}function Odi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[825911]|0)|0;i=b;return d|0}function Pdi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qdi(a,b){a=a|0;b=b|0;ASg(a,b)}function Rdi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[825985]|0)|0;i=d;return e|0}function Sdi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tdi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Udi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[826041]|0)|0;i=d;return e|0}function Vdi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wdi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[826079]|0);i=e;return}function Xdi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[826117]|0)|0;i=b;return d|0}function Ydi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zdi(a,b){a=a|0;b=b|0;ASg(a,b)}function _di(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[826191]|0)|0;i=d;return e|0}function $di(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function aei(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[826247]|0)|0;i=d;return e|0}function cei(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dei(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[826285]|0);i=e;return}function eei(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[826323]|0)|0;i=b;return d|0}function fei(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gei(a,b){a=a|0;b=b|0;ASg(a,b)}function hei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[826397]|0)|0;i=d;return e|0}function iei(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jei(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[826453]|0)|0;i=d;return e|0}function lei(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mei(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[828491]|0);i=e;return}function nei(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[828529]|0)|0;i=b;return d|0}function oei(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pei(a,b){a=a|0;b=b|0;ASg(a,b)}function qei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[828603]|0)|0;i=d;return e|0}function rei(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sei(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[828659]|0)|0;i=d;return e|0}function uei(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vei(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[828697]|0);i=e;return}function wei(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[828735]|0)|0;i=b;return d|0}function xei(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function yei(a,b){a=a|0;b=b|0;ASg(a,b)}function zei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[828809]|0)|0;i=d;return e|0}function Aei(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bei(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[828865]|0)|0;i=d;return e|0}function Dei(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Eei(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[828903]|0);i=e;return}function Fei(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[828941]|0)|0;i=b;return d|0}function Gei(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hei(a,b){a=a|0;b=b|0;ASg(a,b)}function Iei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[829015]|0)|0;i=d;return e|0}function Jei(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kei(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Lei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[829071]|0)|0;i=d;return e|0}function Mei(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Nei(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[829109]|0);i=e;return}function Oei(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[829147]|0)|0;i=b;return d|0}function Pei(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qei(a,b){a=a|0;b=b|0;ASg(a,b)}function Rei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[829221]|0)|0;i=d;return e|0}function Sei(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tei(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Uei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[829277]|0)|0;i=d;return e|0}function Vei(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wei(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[829315]|0);i=e;return}function Xei(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[829353]|0)|0;i=b;return d|0}function Yei(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zei(a,b){a=a|0;b=b|0;ASg(a,b)}function _ei(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[829427]|0)|0;i=d;return e|0}function $ei(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function afi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[829483]|0)|0;i=d;return e|0}function cfi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dfi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[829521]|0);i=e;return}function efi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[829559]|0)|0;i=b;return d|0}function ffi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function gfi(a,b){a=a|0;b=b|0;ASg(a,b)}function hfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[829633]|0)|0;i=d;return e|0}function ifi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jfi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[829689]|0)|0;i=d;return e|0}function lfi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mfi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[829727]|0);i=e;return}function nfi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[829765]|0)|0;i=b;return d|0}function ofi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pfi(a,b){a=a|0;b=b|0;ASg(a,b)}function qfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[829839]|0)|0;i=d;return e|0}function rfi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sfi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[829895]|0)|0;i=d;return e|0}function ufi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vfi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[829933]|0);i=e;return}function wfi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[829971]|0)|0;i=b;return d|0}function xfi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function yfi(a,b){a=a|0;b=b|0;ASg(a,b)}function zfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[830045]|0)|0;i=d;return e|0}function Afi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bfi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[830101]|0)|0;i=d;return e|0}function Dfi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Efi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[830139]|0);i=e;return}function Ffi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[830177]|0)|0;i=b;return d|0}function Gfi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hfi(a,b){a=a|0;b=b|0;ASg(a,b)}function Ifi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[830251]|0)|0;i=d;return e|0}function Jfi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kfi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Lfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[830307]|0)|0;i=d;return e|0}function Mfi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Nfi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[830345]|0);i=e;return}function Ofi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[830383]|0)|0;i=b;return d|0}function Pfi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qfi(a,b){a=a|0;b=b|0;ASg(a,b)}function Rfi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[830457]|0)|0;i=d;return e|0}function Sfi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tfi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Ufi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[830513]|0)|0;i=d;return e|0}function Vfi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wfi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[830551]|0);i=e;return}function Xfi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[830589]|0)|0;i=b;return d|0}function Yfi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zfi(a,b){a=a|0;b=b|0;ASg(a,b)}function _fi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[830663]|0)|0;i=d;return e|0}function $fi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function agi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[830719]|0)|0;i=d;return e|0}function cgi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dgi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[830757]|0);i=e;return}function egi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[830795]|0)|0;i=b;return d|0}function fgi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ggi(a,b){a=a|0;b=b|0;ASg(a,b)}function hgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[830869]|0)|0;i=d;return e|0}function igi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jgi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function kgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[830925]|0)|0;i=d;return e|0}function lgi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mgi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[830963]|0);i=e;return}function ngi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[831001]|0)|0;i=b;return d|0}function ogi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function pgi(a,b){a=a|0;b=b|0;ASg(a,b)}function qgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[831075]|0)|0;i=d;return e|0}function rgi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function sgi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function tgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[831131]|0)|0;i=d;return e|0}function ugi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vgi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[831169]|0);i=e;return}function wgi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[831207]|0)|0;i=b;return d|0}function xgi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ygi(a,b){a=a|0;b=b|0;ASg(a,b)}function zgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[831281]|0)|0;i=d;return e|0}function Agi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bgi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Cgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[831337]|0)|0;i=d;return e|0}function Dgi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Egi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[831375]|0);i=e;return}function Fgi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[831413]|0)|0;i=b;return d|0}function Ggi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Hgi(a,b){a=a|0;b=b|0;ASg(a,b)}function Igi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[831487]|0)|0;i=d;return e|0}function Jgi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Kgi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Lgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[831543]|0)|0;i=d;return e|0}function Mgi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Ngi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[831581]|0);i=e;return}function Ogi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[831619]|0)|0;i=b;return d|0}function Pgi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Qgi(a,b){a=a|0;b=b|0;ASg(a,b)}function Rgi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[831693]|0)|0;i=d;return e|0}function Sgi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Tgi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Ugi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[831749]|0)|0;i=d;return e|0}function Vgi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Wgi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[831787]|0);i=e;return}function Xgi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[831825]|0)|0;i=b;return d|0}function Ygi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Zgi(a,b){a=a|0;b=b|0;ASg(a,b)}function _gi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[831899]|0)|0;i=d;return e|0}function $gi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function ahi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function bhi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[831955]|0)|0;i=d;return e|0}function chi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function dhi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[831993]|0);i=e;return}function ehi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[832031]|0)|0;i=b;return d|0}function fhi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ghi(a,b){a=a|0;b=b|0;ASg(a,b)}function hhi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[832311]|0)|0;i=d;return e|0}function ihi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function jhi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function khi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[832367]|0)|0;i=d;return e|0}function lhi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function mhi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[832405]|0);i=e;return}function nhi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[832443]|0)|0;i=b;return d|0}function ohi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function phi(a,b){a=a|0;b=b|0;ASg(a,b)}function qhi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[832517]|0)|0;i=d;return e|0}function rhi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function shi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function thi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[832573]|0)|0;i=d;return e|0}function uhi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function vhi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[832611]|0);i=e;return}function whi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[832649]|0)|0;i=b;return d|0}function xhi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function yhi(a,b){a=a|0;b=b|0;ASg(a,b)}function zhi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[832723]|0)|0;i=d;return e|0}function Ahi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Bhi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Chi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[832779]|0)|0;i=d;return e|0}function Dhi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Ehi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[832817]|0);i=e;return}function Fhi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[832855]|0)|0;i=b;return d|0}function Ghi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;a=i;H2g(0,b,d,e,c[833083]|0);i=a;return}function Hhi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=i;I2g(0,b,d,e,f,g,c[833105]|0);i=a;return}function Ihi(a,b){a=a|0;b=b|0;var c=0;a=i;c=J2g(0,b)|0;i=a;return c|0}function Jhi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=i;K2g(0,b,d,e,f,g,c[833151]|0);i=a;return}function Khi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a=i;f=L2g(0,b,d,e,c[833177]|0)|0;i=a;return f|0}function Lhi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=i;M2g(0,b,c,d,e);i=a;return}function Mhi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Nhi(a,b){a=a|0;b=b|0;ASg(a,b)}function Ohi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[834095]|0)|0;i=d;return e|0}function Phi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Qhi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Rhi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[834151]|0)|0;i=d;return e|0}function Shi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Thi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[834189]|0);i=e;return}function Uhi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[834227]|0)|0;i=b;return d|0}function Vhi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Whi(a,b){a=a|0;b=b|0;ASg(a,b)}function Xhi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[834507]|0)|0;i=d;return e|0}function Yhi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Zhi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function _hi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[834563]|0)|0;i=d;return e|0}function $hi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function aii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[834601]|0);i=e;return}function bii(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[834639]|0)|0;i=b;return d|0}function cii(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function dii(a,b){a=a|0;b=b|0;ASg(a,b)}function eii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[834713]|0)|0;i=d;return e|0}function fii(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function gii(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function hii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[834769]|0)|0;i=d;return e|0}function iii(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function jii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[834807]|0);i=e;return}function kii(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[834845]|0)|0;i=b;return d|0}function lii(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function mii(a,b){a=a|0;b=b|0;ASg(a,b)}function nii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[834919]|0)|0;i=d;return e|0}function oii(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function pii(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function qii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[834975]|0)|0;i=d;return e|0}function rii(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function sii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[835013]|0);i=e;return}function tii(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[835051]|0)|0;i=b;return d|0}function uii(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function vii(a,b){a=a|0;b=b|0;ASg(a,b)}function wii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[835125]|0)|0;i=d;return e|0}function xii(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function yii(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function zii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[835181]|0)|0;i=d;return e|0}function Aii(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Bii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[835219]|0);i=e;return}function Cii(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[835257]|0)|0;i=b;return d|0}function Dii(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Eii(a,b){a=a|0;b=b|0;ASg(a,b)}function Fii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[835537]|0)|0;i=d;return e|0}function Gii(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Hii(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Iii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[835593]|0)|0;i=d;return e|0}function Jii(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Kii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[835631]|0);i=e;return}function Lii(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[835669]|0)|0;i=b;return d|0}function Mii(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Nii(a,b){a=a|0;b=b|0;ASg(a,b)}function Oii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[837803]|0)|0;i=d;return e|0}function Pii(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Qii(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Rii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[837859]|0)|0;i=d;return e|0}function Sii(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Tii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[837897]|0);i=e;return}function Uii(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[837935]|0)|0;i=b;return d|0}function Vii(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Wii(a,b){a=a|0;b=b|0;ASg(a,b)}function Xii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[838009]|0)|0;i=d;return e|0}function Yii(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Zii(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function _ii(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[838065]|0)|0;i=d;return e|0}function $ii(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function aji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[838103]|0);i=e;return}function bji(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[838141]|0)|0;i=b;return d|0}function cji(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function dji(a,b){a=a|0;b=b|0;ASg(a,b)}function eji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[838215]|0)|0;i=d;return e|0}function fji(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function gji(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function hji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[838271]|0)|0;i=d;return e|0}function iji(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function jji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[838309]|0);i=e;return}function kji(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[838347]|0)|0;i=b;return d|0}function lji(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function mji(a,b){a=a|0;b=b|0;ASg(a,b)}function nji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[838421]|0)|0;i=d;return e|0}function oji(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function pji(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function qji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[838477]|0)|0;i=d;return e|0}function rji(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function sji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[838515]|0);i=e;return}function tji(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[838553]|0)|0;i=b;return d|0}function uji(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function vji(a,b){a=a|0;b=b|0;ASg(a,b)}function wji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[838627]|0)|0;i=d;return e|0}function xji(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function yji(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function zji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[838683]|0)|0;i=d;return e|0}function Aji(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Bji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[838721]|0);i=e;return}function Cji(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[838759]|0)|0;i=b;return d|0}function Dji(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Eji(a,b){a=a|0;b=b|0;ASg(a,b)}function Fji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[838833]|0)|0;i=d;return e|0}function Gji(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Hji(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Iji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[838889]|0)|0;i=d;return e|0}function Jji(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Kji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[838927]|0);i=e;return}function Lji(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[838965]|0)|0;i=b;return d|0}function Mji(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Nji(a,b){a=a|0;b=b|0;ASg(a,b)}function Oji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[839039]|0)|0;i=d;return e|0}function Pji(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Qji(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Rji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[839095]|0)|0;i=d;return e|0}function Sji(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Tji(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[839133]|0);i=e;return}function Uji(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[839171]|0)|0;i=b;return d|0}function Vji(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Wji(a,b){a=a|0;b=b|0;ASg(a,b)}function Xji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[839245]|0)|0;i=d;return e|0}function Yji(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Zji(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function _ji(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[839301]|0)|0;i=d;return e|0}function $ji(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function aki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[839339]|0);i=e;return}function bki(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[839377]|0)|0;i=b;return d|0}function cki(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function dki(a,b){a=a|0;b=b|0;ASg(a,b)}function eki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[839451]|0)|0;i=d;return e|0}function fki(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function gki(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function hki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[839507]|0)|0;i=d;return e|0}function iki(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function jki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[839545]|0);i=e;return}function kki(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[839583]|0)|0;i=b;return d|0}function lki(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function mki(a,b){a=a|0;b=b|0;ASg(a,b)}function nki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[839657]|0)|0;i=d;return e|0}function oki(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function pki(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function qki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[839713]|0)|0;i=d;return e|0}function rki(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function ski(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[839751]|0);i=e;return}function tki(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[839789]|0)|0;i=b;return d|0}function uki(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function vki(a,b){a=a|0;b=b|0;ASg(a,b)}function wki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[839863]|0)|0;i=d;return e|0}function xki(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function yki(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function zki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[839919]|0)|0;i=d;return e|0}function Aki(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Bki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[839957]|0);i=e;return}function Cki(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[839995]|0)|0;i=b;return d|0}function Dki(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Eki(a,b){a=a|0;b=b|0;ASg(a,b)}function Fki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[840069]|0)|0;i=d;return e|0}function Gki(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Hki(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Iki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[840125]|0)|0;i=d;return e|0}function Jki(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Kki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[840163]|0);i=e;return}function Lki(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[840201]|0)|0;i=b;return d|0}function Mki(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Nki(a,b){a=a|0;b=b|0;ASg(a,b)}function Oki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[840275]|0)|0;i=d;return e|0}function Pki(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Qki(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Rki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[840331]|0)|0;i=d;return e|0}function Ski(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Tki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[840369]|0);i=e;return}function Uki(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[840407]|0)|0;i=b;return d|0}function Vki(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Wki(a,b){a=a|0;b=b|0;ASg(a,b)}function Xki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[840481]|0)|0;i=d;return e|0}function Yki(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Zki(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function _ki(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[840537]|0)|0;i=d;return e|0}function $ki(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function ali(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[840575]|0);i=e;return}function bli(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[840613]|0)|0;i=b;return d|0}function cli(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function dli(a,b){a=a|0;b=b|0;ASg(a,b)}function eli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[840687]|0)|0;i=d;return e|0}function fli(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function gli(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function hli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[840743]|0)|0;i=d;return e|0}function ili(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function jli(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[840781]|0);i=e;return}function kli(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[840819]|0)|0;i=b;return d|0}function lli(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function mli(a,b){a=a|0;b=b|0;ASg(a,b)}function nli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[840893]|0)|0;i=d;return e|0}function oli(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function pli(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function qli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[840949]|0)|0;i=d;return e|0}function rli(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function sli(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[840987]|0);i=e;return}function tli(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[841025]|0)|0;i=b;return d|0}function uli(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function vli(a,b){a=a|0;b=b|0;ASg(a,b)}function wli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[841099]|0)|0;i=d;return e|0}function xli(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function yli(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function zli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[841155]|0)|0;i=d;return e|0}function Ali(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Bli(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[841193]|0);i=e;return}function Cli(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[841231]|0)|0;i=b;return d|0}function Dli(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Eli(a,b){a=a|0;b=b|0;ASg(a,b)}function Fli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[841305]|0)|0;i=d;return e|0}function Gli(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Hli(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Ili(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[841361]|0)|0;i=d;return e|0}function Jli(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Kli(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[841399]|0);i=e;return}function Lli(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[841437]|0)|0;i=b;return d|0}function Mli(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Nli(a,b){a=a|0;b=b|0;ASg(a,b)}function Oli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[841511]|0)|0;i=d;return e|0}function Pli(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Qli(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Rli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[841567]|0)|0;i=d;return e|0}function Sli(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Tli(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[841605]|0);i=e;return}function Uli(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[841643]|0)|0;i=b;return d|0}function Vli(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Wli(a,b){a=a|0;b=b|0;ASg(a,b)}function Xli(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[841923]|0)|0;i=d;return e|0}function Yli(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Zli(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function _li(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[841979]|0)|0;i=d;return e|0}function $li(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function ami(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[842017]|0);i=e;return}function bmi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[842055]|0)|0;i=b;return d|0}function cmi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function dmi(a,b){a=a|0;b=b|0;ASg(a,b)}function emi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[842129]|0)|0;i=d;return e|0}function fmi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function gmi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function hmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[842185]|0)|0;i=d;return e|0}function imi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function jmi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[842223]|0);i=e;return}function kmi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[842261]|0)|0;i=b;return d|0}function lmi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function mmi(a,b){a=a|0;b=b|0;ASg(a,b)}function nmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[842335]|0)|0;i=d;return e|0}function omi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function pmi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function qmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[842391]|0)|0;i=d;return e|0}function rmi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function smi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[842429]|0);i=e;return}function tmi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[842467]|0)|0;i=b;return d|0}function umi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function vmi(a,b){a=a|0;b=b|0;ASg(a,b)}function wmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[842541]|0)|0;i=d;return e|0}function xmi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function ymi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function zmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[842597]|0)|0;i=d;return e|0}function Ami(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Bmi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[842635]|0);i=e;return}function Cmi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[842673]|0)|0;i=b;return d|0}function Dmi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=E5g(0,b,d,c[842695]|0)|0;i=a;return e|0}function Emi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;e=E5g(0,b,d,c[842715]|0)|0;i=a;return e|0}function Fmi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Gmi(a,b){a=a|0;b=b|0;ASg(a,b)}function Hmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[845055]|0)|0;i=d;return e|0}function Imi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Jmi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Kmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[845111]|0)|0;i=d;return e|0}function Lmi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Mmi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[845149]|0);i=e;return}function Nmi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[845187]|0)|0;i=b;return d|0}function Omi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Pmi(a,b){a=a|0;b=b|0;ASg(a,b)}function Qmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[845261]|0)|0;i=d;return e|0}function Rmi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Smi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Tmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[845317]|0)|0;i=d;return e|0}function Umi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Vmi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[845355]|0);i=e;return}function Wmi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[845393]|0)|0;i=b;return d|0}function Xmi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Ymi(a,b){a=a|0;b=b|0;ASg(a,b)}function Zmi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[845673]|0)|0;i=d;return e|0}function _mi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $mi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function ani(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[845729]|0)|0;i=d;return e|0}function bni(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function cni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[845767]|0);i=e;return}function dni(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[845805]|0)|0;i=b;return d|0}function eni(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function fni(a,b){a=a|0;b=b|0;ASg(a,b)}function gni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[845879]|0)|0;i=d;return e|0}function hni(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function ini(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function jni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[845935]|0)|0;i=d;return e|0}function kni(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function lni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[845973]|0);i=e;return}function mni(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[846011]|0)|0;i=b;return d|0}function nni(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function oni(a,b){a=a|0;b=b|0;ASg(a,b)}function pni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[846291]|0)|0;i=d;return e|0}function qni(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function rni(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function sni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[846347]|0)|0;i=d;return e|0}function tni(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function uni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[846385]|0);i=e;return}function vni(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[846423]|0)|0;i=b;return d|0}function wni(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function xni(a,b){a=a|0;b=b|0;ASg(a,b)}function yni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[846909]|0)|0;i=d;return e|0}function zni(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Ani(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Bni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[846965]|0)|0;i=d;return e|0}function Cni(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Dni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[847003]|0);i=e;return}function Eni(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[847041]|0)|0;i=b;return d|0}function Fni(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Gni(a,b){a=a|0;b=b|0;ASg(a,b)}function Hni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[847115]|0)|0;i=d;return e|0}function Ini(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Jni(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Kni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[847171]|0)|0;i=d;return e|0}function Lni(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Mni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[847209]|0);i=e;return}function Nni(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[849259]|0)|0;i=b;return d|0}function Oni(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Pni(a,b){a=a|0;b=b|0;ASg(a,b)}function Qni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[849613]|0)|0;i=d;return e|0}function Rni(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Sni(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Tni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[849669]|0)|0;i=d;return e|0}function Uni(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Vni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[849707]|0);i=e;return}function Wni(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[849745]|0)|0;i=b;return d|0}function Xni(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Yni(a,b){a=a|0;b=b|0;ASg(a,b)}function Zni(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[850025]|0)|0;i=d;return e|0}function _ni(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $ni(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function aoi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[850081]|0)|0;i=d;return e|0}function boi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function coi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[850119]|0);i=e;return}function doi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[850157]|0)|0;i=b;return d|0}function eoi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function foi(a,b){a=a|0;b=b|0;ASg(a,b)}function goi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[850231]|0)|0;i=d;return e|0}function hoi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function ioi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function joi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[850287]|0)|0;i=d;return e|0}function koi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function loi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[850325]|0);i=e;return}function moi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[850363]|0)|0;i=b;return d|0}function noi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function ooi(a,b){a=a|0;b=b|0;ASg(a,b)}function poi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[850437]|0)|0;i=d;return e|0}function qoi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function roi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function soi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[850493]|0)|0;i=d;return e|0}function toi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function uoi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[850531]|0);i=e;return}function voi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[850569]|0)|0;i=b;return d|0}function woi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function xoi(a,b){a=a|0;b=b|0;ASg(a,b)}function yoi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[850643]|0)|0;i=d;return e|0}function zoi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Aoi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Boi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[850699]|0)|0;i=d;return e|0}function Coi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Doi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[850737]|0);i=e;return}function Eoi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[850775]|0)|0;i=b;return d|0}function Foi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Goi(a,b){a=a|0;b=b|0;ASg(a,b)}function Hoi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[850849]|0)|0;i=d;return e|0}function Ioi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Joi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Koi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[850905]|0)|0;i=d;return e|0}function Loi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Moi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[850943]|0);i=e;return}function Noi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[850981]|0)|0;i=b;return d|0}function Ooi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Poi(a,b){a=a|0;b=b|0;ASg(a,b)}function Qoi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[851261]|0)|0;i=d;return e|0}function Roi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Soi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Toi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[851317]|0)|0;i=d;return e|0}function Uoi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Voi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[851355]|0);i=e;return}function Woi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[851393]|0)|0;i=b;return d|0}function Xoi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Yoi(a,b){a=a|0;b=b|0;ASg(a,b)}function Zoi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[851467]|0)|0;i=d;return e|0}function _oi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $oi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function api(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[851523]|0)|0;i=d;return e|0}function bpi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function cpi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[851561]|0);i=e;return}function dpi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[851599]|0)|0;i=b;return d|0}function epi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function fpi(a,b){a=a|0;b=b|0;ASg(a,b)}function gpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[851673]|0)|0;i=d;return e|0}function hpi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function ipi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function jpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[851729]|0)|0;i=d;return e|0}function kpi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function lpi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[851767]|0);i=e;return}function mpi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[851805]|0)|0;i=b;return d|0}function npi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function opi(a,b){a=a|0;b=b|0;ASg(a,b)}function ppi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[851879]|0)|0;i=d;return e|0}function qpi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function rpi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function spi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[851935]|0)|0;i=d;return e|0}function tpi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function upi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[851973]|0);i=e;return}function vpi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[852011]|0)|0;i=b;return d|0}function wpi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function xpi(a,b){a=a|0;b=b|0;ASg(a,b)}function ypi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[852291]|0)|0;i=d;return e|0}function zpi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Api(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Bpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[852347]|0)|0;i=d;return e|0}function Cpi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Dpi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[852385]|0);i=e;return}function Epi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[852423]|0)|0;i=b;return d|0}function Fpi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Gpi(a,b){a=a|0;b=b|0;ASg(a,b)}function Hpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[853733]|0)|0;i=d;return e|0}function Ipi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Jpi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Kpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[853789]|0)|0;i=d;return e|0}function Lpi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Mpi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[853827]|0);i=e;return}function Npi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[853865]|0)|0;i=b;return d|0}function Opi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Ppi(a,b){a=a|0;b=b|0;ASg(a,b)}function Qpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[853939]|0)|0;i=d;return e|0}function Rpi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Spi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Tpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[853995]|0)|0;i=d;return e|0}function Upi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Vpi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[854033]|0);i=e;return}function Wpi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[854071]|0)|0;i=b;return d|0}function Xpi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Ypi(a,b){a=a|0;b=b|0;ASg(a,b)}function Zpi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[854145]|0)|0;i=d;return e|0}function _pi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function $pi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function aqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[854201]|0)|0;i=d;return e|0}function bqi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function cqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[854239]|0);i=e;return}function dqi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[854277]|0)|0;i=b;return d|0}function eqi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function fqi(a,b){a=a|0;b=b|0;ASg(a,b)}function gqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[855587]|0)|0;i=d;return e|0}function hqi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function iqi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function jqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[855643]|0)|0;i=d;return e|0}function kqi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function lqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[855681]|0);i=e;return}function mqi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[855719]|0)|0;i=b;return d|0}function nqi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function oqi(a,b){a=a|0;b=b|0;ASg(a,b)}function pqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[855999]|0)|0;i=d;return e|0}function qqi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function rqi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function sqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[856055]|0)|0;i=d;return e|0}function tqi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function uqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[856093]|0);i=e;return}function vqi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[856131]|0)|0;i=b;return d|0}function wqi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function xqi(a,b){a=a|0;b=b|0;ASg(a,b)}function yqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[856205]|0)|0;i=d;return e|0}function zqi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Aqi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Bqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[856261]|0)|0;i=d;return e|0}function Cqi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Dqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[856299]|0);i=e;return}function Eqi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[856337]|0)|0;i=b;return d|0}function Fqi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zSg(a,b)|0;i=c;return d|0}function Gqi(a,b){a=a|0;b=b|0;ASg(a,b)}function Hqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=BSg(a,b,c[856617]|0)|0;i=d;return e|0}function Iqi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;CSg(a,b,c);i=d;return}function Jqi(a,b){a=a|0;b=b|0;DSg(a,b)|0;return 0}function Kqi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ESg(a,b,c[856673]|0)|0;i=d;return e|0}function Lqi(a,b,c){a=a|0;b=b|0;c=c|0;FSg(a,b,c)}function Mqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;GSg(a,b,d,c[856711]|0);i=e;return}function Nqi(a){a=a|0;var b=0,d=0;b=i;d=HSg(a,c[856749]|0)|0;i=b;return d|0}function Oqi(){var a=0;a=i;DI(1083920);i=a;return}function Pqi(){var a=0;a=i;DI(1085440);i=a;return}function Qqi(){var a=0;a=i;DI(3485728);i=a;return}function Rqi(){var a=0;a=i;DI(3486568);i=a;return}function Sqi(){var a=0;a=i;DI(3496592);i=a;return}function Tqi(){var a=0;a=i;DI(3516272);i=a;return}function Uqi(){var a=0;a=i;DI(3649360);i=a;return}function Vqi(){var a=0;a=i;DI(3649720);i=a;return}function Wqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;e=i;f=a;a=b;a:while(1){b=a;g=a+-4|0;h=f;b:while(1){j=h;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=h;n=g;o=4;break a;break}case 5:{p=h;q=g;o=8;break a;break}case 4:{r=h;s=g;o=7;break a;break}case 3:{t=h;u=g;o=6;break a;break}case 1:case 0:{o=47;break a;break}default:{}}if((k|0)<124){v=h;w=a;o=10;break a}x=(l|0)/2|0;y=h+(x<<2)|0;if((k|0)>3996){k=(l|0)/4|0;z=Azi(h,h+(k<<2)|0,y,h+(k+x<<2)|0,g,d)|0}else z=yzi(h,y,g,d)|0;x=c[h>>2]|0;k=c[y>>2]|0;do if((x|0)<(k|0)){A=g;B=z}else{l=a;C=g;while(1){D=l+-8|0;if((h|0)==(D|0))break;E=c[D>>2]|0;if((E|0)<(k|0)){F=E;G=D;o=29;break}else{E=C;C=D;l=E}}if((o|0)==29){o=0;c[h>>2]=F;c[G>>2]=x;A=G;B=z+1|0;break}l=h+4|0;C=c[g>>2]|0;if((x|0)<(C|0))H=l;else{if((l|0)==(g|0)){o=47;break a}else{I=h;J=l}while(1){l=c[J>>2]|0;E=I+8|0;if((x|0)<(l|0)){K=l;L=J;break}if((E|0)==(g|0)){o=47;break a}else{l=J;J=E;I=l}}c[L>>2]=C;c[g>>2]=K;H=L+4|0}if((H|0)==(g|0)){o=47;break a}else{M=H;N=g}while(1){l=c[h>>2]|0;E=M;while(1){D=c[E>>2]|0;O=E+4|0;if((l|0)<(D|0)){P=D;Q=O;R=E;break}else E=O}E=N;while(1){O=E+-4|0;D=c[O>>2]|0;if((l|0)<(D|0))E=O;else{S=O;T=D;break}}if(R>>>0>=S>>>0){h=R;continue b}c[R>>2]=T;c[S>>2]=P;M=Q;N=S}}while(0);x=h+4|0;c:do if(x>>>0<A>>>0){k=x;C=A;E=y;l=B;while(1){D=c[E>>2]|0;O=k;while(1){U=c[O>>2]|0;V=O+4|0;if((U|0)<(D|0))O=V;else{W=U;X=V;Y=O;break}}O=C;while(1){V=O+-4|0;U=c[V>>2]|0;if((U|0)<(D|0)){Z=V;_=U;break}else O=V}if(Y>>>0>Z>>>0){$=Y;aa=E;ba=l;break c}c[Y>>2]=_;c[Z>>2]=W;k=X;C=Z;E=(E|0)==(Y|0)?Z:E;l=l+1|0}}else{$=x;aa=y;ba=B}while(0);if(($|0)!=(aa|0)?(y=c[aa>>2]|0,x=c[$>>2]|0,(y|0)<(x|0)):0){c[$>>2]=y;c[aa>>2]=x;ca=ba+1|0}else ca=ba;if(!ca){da=Xqi(h,$,d)|0;x=$+4|0;if(Xqi(x,a,d)|0){o=42;break}if(da){h=x;continue}}x=$;if((x-j|0)>=(b-x|0)){ea=h;fa=$;o=46;break}Wqi(h,$,d);h=$+4|0}if((o|0)==42){o=0;if(da){o=47;break}else{f=h;a=$;continue}}else if((o|0)==46){o=0;Wqi(fa+4|0,a,d);f=ea;a=fa;continue}}if((o|0)==4){fa=c[n>>2]|0;a=c[m>>2]|0;if((fa|0)>=(a|0)){i=e;return}c[m>>2]=fa;c[n>>2]=a;i=e;return}else if((o|0)==6){yzi(t,t+4|0,u,d)|0;i=e;return}else if((o|0)==7){zzi(r,r+4|0,r+8|0,s,d)|0;i=e;return}else if((o|0)==8){Azi(p,p+4|0,p+8|0,p+12|0,q,d)|0;i=e;return}else if((o|0)==10){Bzi(v,w,d);i=e;return}else if((o|0)==47){i=e;return}}function Xqi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;switch(b-a>>2|0){case 1:case 0:{f=1;i=e;return f|0}case 4:{zzi(a,a+4|0,a+8|0,b+-4|0,d)|0;f=1;i=e;return f|0}case 3:{yzi(a,a+4|0,b+-4|0,d)|0;f=1;i=e;return f|0}case 2:{g=b+-4|0;h=c[g>>2]|0;j=c[a>>2]|0;if((h|0)>=(j|0)){f=1;i=e;return f|0}c[a>>2]=h;c[g>>2]=j;f=1;i=e;return f|0}case 5:{Azi(a,a+4|0,a+8|0,a+12|0,b+-4|0,d)|0;f=1;i=e;return f|0}default:{j=a+8|0;yzi(a,a+4|0,j,d)|0;d=a+12|0;if((d|0)==(b|0)){f=1;i=e;return f|0}else{k=0;l=d;m=j}while(1){j=c[l>>2]|0;d=c[m>>2]|0;if((j|0)<(d|0)){g=d;d=l;h=m;while(1){c[d>>2]=g;if((h|0)==(a|0)){n=a;break}o=h+-4|0;g=c[o>>2]|0;if((j|0)>=(g|0)){n=h;break}else{p=h;h=o;d=p}}c[n>>2]=j;d=k+1|0;if((d|0)==8){q=l;break}else r=d}else r=k;d=l+4|0;if((d|0)==(b|0)){f=1;s=14;break}else{h=l;k=r;l=d;m=h}}if((s|0)==14){i=e;return f|0}f=(q+4|0)==(b|0);i=e;return f|0}}return 0}function Yqi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;a=i;b=c[q>>2]|0;Czi(3650520,b,3650576);c[912454]=3652172;c[912456]=3652192;c[912455]=0;d=c[913040]|0;esi(3649816+d|0,3650520);c[d+3649888>>2]=0;c[d+3649892>>2]=-1;d=c[r>>2]|0;Dzi(3650624,d,3650584|0);c[912476]=3652252;c[912477]=3652272;e=c[913060]|0;esi(3649904+e|0,3650624);f=e+72|0;c[3649904+f>>2]=0;g=e+76|0;c[3649904+g>>2]=-1;h=c[p>>2]|0;Dzi(3650672,h,3650592|0);c[912498]=3652252;c[912499]=3652272;esi(3649992+e|0,3650672);c[3649992+f>>2]=0;c[3649992+g>>2]=-1;j=c[(c[(c[912498]|0)+-12>>2]|0)+3650016>>2]|0;c[912520]=3652252;c[912521]=3652272;esi(3650080+e|0,j);c[3650080+f>>2]=0;c[3650080+g>>2]=-1;c[(c[(c[912454]|0)+-12>>2]|0)+3649888>>2]=3649904;g=(c[(c[912498]|0)+-12>>2]|0)+3649996|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[912498]|0)+-12>>2]|0)+3650064>>2]=3649904;Ezi(3650720,b,3650600|0);c[912542]=3652212;c[912544]=3652232;c[912543]=0;b=c[913050]|0;esi(3650168+b|0,3650720);c[b+3650240>>2]=0;c[b+3650244>>2]=-1;Fzi(3650776,d,3650608|0);c[912564]=3652292;c[912565]=3652312;d=c[913070]|0;esi(3650256+d|0,3650776);b=d+72|0;c[3650256+b>>2]=0;g=d+76|0;c[3650256+g>>2]=-1;Fzi(3650824,h,3650616|0);c[912586]=3652292;c[912587]=3652312;esi(3650344+d|0,3650824);c[3650344+b>>2]=0;c[3650344+g>>2]=-1;h=c[(c[(c[912586]|0)+-12>>2]|0)+3650368>>2]|0;c[912608]=3652292;c[912609]=3652312;esi(3650432+d|0,h);c[3650432+b>>2]=0;c[3650432+g>>2]=-1;c[(c[(c[912542]|0)+-12>>2]|0)+3650240>>2]=3650256;g=(c[(c[912586]|0)+-12>>2]|0)+3650348|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[912586]|0)+-12>>2]|0)+3650416>>2]=3650256;i=a;return}function Zqi(a){a=a|0;return}function _qi(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=(c[b>>2]|0)+1;return}function $qi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=e+-1;if(e){f=0;i=b;return f|0}ko[c[(c[a>>2]|0)+8>>2]&4095](a);f=1;i=b;return f|0}function ari(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=3666912;Gzi(a+4|0,b);i=d;return}function bri(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;c[b>>2]=3666936;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;Gzi(b+4|0,f);i=e;return}function cri(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=3666936;Gzi(a+4|0,b);i=d;return}function dri(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function eri(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;co[c[(c[a>>2]|0)+12>>2]&2047](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function fri(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function gri(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;b=i;d=jm(c|0)|0;rri(a,d,SEi(d|0)|0);i=b;return}function hri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f;h=c[d>>2]|0;if(h){j=a[e>>0]|0;if(!(j&1))k=(j&255)>>>1;else k=c[e+4>>2]|0;if(!k)l=h;else{Eri(e,3651384)|0;l=c[d>>2]|0}h=c[d+4>>2]|0;co[c[(c[h>>2]|0)+24>>2]&2047](g,h,l);l=a[g>>0]|0;if(!(l&1)){m=g+1|0;n=(l&255)>>>1}else{m=c[g+8>>2]|0;n=c[g+4>>2]|0}Gri(e,m,n)|0;xri(g)};c[b+0>>2]=c[e+0>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;i=f;return}function iri(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+12|0;g=e;rri(g,d,SEi(d|0)|0);hri(f,b,g);bri(a,f);xri(f);xri(g);c[a>>2]=3651400;g=b;b=c[g+4>>2]|0;f=a+8|0;c[f>>2]=c[g>>2];c[f+4>>2]=b;i=e;return}function jri(a){a=a|0;var b=0;b=i;NCi(a);i=b;return}function kri(a){a=a|0;var b=0;b=i;NCi(a);ACi(a);i=b;return}function lri(a){a=a|0;return}function mri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(a>>>0<212){g=c[(Hzi(3651536,3651728|0,e,d)|0)>>2]|0;i=b;return g|0}if(a>>>0>4294967291){h=al(8)|0;cri(h,3651920);c[h>>2]=3667160;we(h|0,3667200,3429)}h=(a>>>0)/210|0;j=h*210|0;c[f>>2]=a-j;a=(Hzi(3651728,3651920|0,f,d)|0)-3651728>>2;d=a;f=h;h=(c[3651728+(a<<2)>>2]|0)+j|0;a:while(1){j=5;while(1){a=c[3651536+(j<<2)>>2]|0;k=(h>>>0)/(a>>>0)|0;if(k>>>0<a>>>0){l=h;m=158;break a}j=j+1|0;if((h|0)==(da(k,a)|0))break;if(j>>>0>=47){m=8;break}}b:do if((m|0)==8){m=0;if(h>>>0<44521){n=h;m=109;break a}j=(h>>>0)/211|0;a=211;while(1){if((h|0)==(da(j,a)|0))break b;k=a+10|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){p=h;m=111;break a}if((h|0)==(da(o,k)|0))break b;k=a+12|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){q=h;m=112;break a}if((h|0)==(da(o,k)|0))break b;k=a+16|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){r=h;m=113;break a}if((h|0)==(da(o,k)|0))break b;k=a+18|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){s=h;m=114;break a}if((h|0)==(da(o,k)|0))break b;k=a+22|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){t=h;m=115;break a}if((h|0)==(da(o,k)|0))break b;k=a+28|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){u=h;m=116;break a}if((h|0)==(da(o,k)|0))break b;k=a+30|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){v=h;m=117;break a}if((h|0)==(da(o,k)|0))break b;k=a+36|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){w=h;m=118;break a}if((h|0)==(da(o,k)|0))break b;k=a+40|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){x=h;m=119;break a}if((h|0)==(da(o,k)|0))break b;k=a+42|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){y=h;m=120;break a}if((h|0)==(da(o,k)|0))break b;k=a+46|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){z=h;m=121;break a}if((h|0)==(da(o,k)|0))break b;k=a+52|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){A=h;m=122;break a}if((h|0)==(da(o,k)|0))break b;k=a+58|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){B=h;m=123;break a}if((h|0)==(da(o,k)|0))break b;k=a+60|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){C=h;m=124;break a}if((h|0)==(da(o,k)|0))break b;k=a+66|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){D=h;m=125;break a}if((h|0)==(da(o,k)|0))break b;k=a+70|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){E=h;m=126;break a}if((h|0)==(da(o,k)|0))break b;k=a+72|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){F=h;m=127;break a}if((h|0)==(da(o,k)|0))break b;k=a+78|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){G=h;m=128;break a}if((h|0)==(da(o,k)|0))break b;k=a+82|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){H=h;m=129;break a}if((h|0)==(da(o,k)|0))break b;k=a+88|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){I=h;m=130;break a}if((h|0)==(da(o,k)|0))break b;k=a+96|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){J=h;m=131;break a}if((h|0)==(da(o,k)|0))break b;k=a+100|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){K=h;m=132;break a}if((h|0)==(da(o,k)|0))break b;k=a+102|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){L=h;m=133;break a}if((h|0)==(da(o,k)|0))break b;k=a+106|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){M=h;m=134;break a}if((h|0)==(da(o,k)|0))break b;k=a+108|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){N=h;m=135;break a}if((h|0)==(da(o,k)|0))break b;k=a+112|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){O=h;m=136;break a}if((h|0)==(da(o,k)|0))break b;k=a+120|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){P=h;m=137;break a}if((h|0)==(da(o,k)|0))break b;k=a+126|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){Q=h;m=138;break a}if((h|0)==(da(o,k)|0))break b;k=a+130|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){R=h;m=139;break a}if((h|0)==(da(o,k)|0))break b;k=a+136|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){S=h;m=140;break a}if((h|0)==(da(o,k)|0))break b;k=a+138|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){T=h;m=141;break a}if((h|0)==(da(o,k)|0))break b;k=a+142|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){U=h;m=142;break a}if((h|0)==(da(o,k)|0))break b;k=a+148|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){V=h;m=143;break a}if((h|0)==(da(o,k)|0))break b;k=a+150|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){W=h;m=144;break a}if((h|0)==(da(o,k)|0))break b;k=a+156|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){X=h;m=145;break a}if((h|0)==(da(o,k)|0))break b;k=a+162|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){Y=h;m=146;break a}if((h|0)==(da(o,k)|0))break b;k=a+166|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){Z=h;m=147;break a}if((h|0)==(da(o,k)|0))break b;k=a+168|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){_=h;m=148;break a}if((h|0)==(da(o,k)|0))break b;k=a+172|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){$=h;m=149;break a}if((h|0)==(da(o,k)|0))break b;k=a+178|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){aa=h;m=150;break a}if((h|0)==(da(o,k)|0))break b;k=a+180|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){ba=h;m=151;break a}if((h|0)==(da(o,k)|0))break b;k=a+186|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){ca=h;m=152;break a}if((h|0)==(da(o,k)|0))break b;k=a+190|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){ea=h;m=153;break a}if((h|0)==(da(o,k)|0))break b;k=a+192|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){fa=h;m=154;break a}if((h|0)==(da(o,k)|0))break b;k=a+196|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){ga=h;m=155;break a}if((h|0)==(da(o,k)|0))break b;k=a+198|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){ha=h;m=156;break a}if((h|0)==(da(o,k)|0))break b;k=a+208|0;o=(h>>>0)/(k>>>0)|0;if(o>>>0<k>>>0){ia=h;m=157;break a}a=a+210|0;if((h|0)==(da(o,k)|0))break b;j=(h>>>0)/(a>>>0)|0;if(j>>>0<a>>>0){ja=h;m=110;break a}}}while(0);a=d+1|0;j=(a|0)==48;k=j?0:a;a=(j&1)+f|0;d=k;f=a;h=(c[3651728+(k<<2)>>2]|0)+(a*210|0)|0}switch(m|0){case 109:{c[e>>2]=n;g=n;i=b;return g|0}case 110:{c[e>>2]=ja;g=ja;i=b;return g|0}case 111:{c[e>>2]=p;g=p;i=b;return g|0}case 112:{c[e>>2]=q;g=q;i=b;return g|0}case 113:{c[e>>2]=r;g=r;i=b;return g|0}case 114:{c[e>>2]=s;g=s;i=b;return g|0}case 115:{c[e>>2]=t;g=t;i=b;return g|0}case 116:{c[e>>2]=u;g=u;i=b;return g|0}case 117:{c[e>>2]=v;g=v;i=b;return g|0}case 118:{c[e>>2]=w;g=w;i=b;return g|0}case 119:{c[e>>2]=x;g=x;i=b;return g|0}case 120:{c[e>>2]=y;g=y;i=b;return g|0}case 121:{c[e>>2]=z;g=z;i=b;return g|0}case 122:{c[e>>2]=A;g=A;i=b;return g|0}case 123:{c[e>>2]=B;g=B;i=b;return g|0}case 124:{c[e>>2]=C;g=C;i=b;return g|0}case 125:{c[e>>2]=D;g=D;i=b;return g|0}case 126:{c[e>>2]=E;g=E;i=b;return g|0}case 127:{c[e>>2]=F;g=F;i=b;return g|0}case 128:{c[e>>2]=G;g=G;i=b;return g|0}case 129:{c[e>>2]=H;g=H;i=b;return g|0}case 130:{c[e>>2]=I;g=I;i=b;return g|0}case 131:{c[e>>2]=J;g=J;i=b;return g|0}case 132:{c[e>>2]=K;g=K;i=b;return g|0}case 133:{c[e>>2]=L;g=L;i=b;return g|0}case 134:{c[e>>2]=M;g=M;i=b;return g|0}case 135:{c[e>>2]=N;g=N;i=b;return g|0}case 136:{c[e>>2]=O;g=O;i=b;return g|0}case 137:{c[e>>2]=P;g=P;i=b;return g|0}case 138:{c[e>>2]=Q;g=Q;i=b;return g|0}case 139:{c[e>>2]=R;g=R;i=b;return g|0}case 140:{c[e>>2]=S;g=S;i=b;return g|0}case 141:{c[e>>2]=T;g=T;i=b;return g|0}case 142:{c[e>>2]=U;g=U;i=b;return g|0}case 143:{c[e>>2]=V;g=V;i=b;return g|0}case 144:{c[e>>2]=W;g=W;i=b;return g|0}case 145:{c[e>>2]=X;g=X;i=b;return g|0}case 146:{c[e>>2]=Y;g=Y;i=b;return g|0}case 147:{c[e>>2]=Z;g=Z;i=b;return g|0}case 148:{c[e>>2]=_;g=_;i=b;return g|0}case 149:{c[e>>2]=$;g=$;i=b;return g|0}case 150:{c[e>>2]=aa;g=aa;i=b;return g|0}case 151:{c[e>>2]=ba;g=ba;i=b;return g|0}case 152:{c[e>>2]=ca;g=ca;i=b;return g|0}case 153:{c[e>>2]=ea;g=ea;i=b;return g|0}case 154:{c[e>>2]=fa;g=fa;i=b;return g|0}case 155:{c[e>>2]=ga;g=ga;i=b;return g|0}case 156:{c[e>>2]=ha;g=ha;i=b;return g|0}case 157:{c[e>>2]=ia;g=ia;i=b;return g|0}case 158:{c[e>>2]=l;g=l;i=b;return g|0}}return 0}function nri(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;pd(3651944)|0;if((c[a>>2]|0)==1)do td(3651968,3651944)|0;while((c[a>>2]|0)==1);if(!(c[a>>2]|0)){c[a>>2]=1;ih(3651944)|0;ko[d&4095](b);pd(3651944)|0;c[a>>2]=-1;ih(3651944)|0;Pl(3651968)|0;i=e;return}else{ih(3651944)|0;i=e;return}}function ori(a){a=a|0;a=al(8)|0;ari(a,3652016);c[a>>2]=3666992;we(a|0,3667032,3427)}function pri(a){a=a|0;a=al(8)|0;ari(a,3652016);c[a>>2]=3667056;we(a|0,3667096,3427)}function qri(b,d){b=b|0;d=d|0;var e=0;e=i;if(!(a[d>>0]&1)){c[b+0>>2]=c[d+0>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];i=e;return}else{rri(b,c[d+8>>2]|0,c[d+4>>2]|0);i=e;return}}function rri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279)ori(b);if(e>>>0<11){a[b>>0]=e<<1;g=b+1|0}else{h=e+16&-16;j=xCi(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}YEi(g|0,d|0,e|0)|0;a[g+e>>0]=0;i=f;return}function sri(a,b){a=a|0;b=b|0;var c=0;c=i;qri(a,b);i=c;return}function tri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279)ori(b);if(d>>>0<11){a[b>>0]=d<<1;g=b+1|0}else{h=d+16&-16;j=xCi(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}PEi(g|0,e|0,d|0)|0;a[g+d>>0]=0;i=f;return}function uri(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;g=i;h=a[d>>0]|0;j=(h&1)==0;if(j)k=(h&255)>>>1;else k=c[d+4>>2]|0;if(k>>>0<e>>>0)pri(b);if(j)l=d+1|0;else l=c[d+8>>2]|0;d=k-e|0;rri(b,l+e|0,d>>>0<f>>>0?d:f);i=g;return}function vri(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;uri(a,b,c,d,e);i=f;return}function wri(b){b=b|0;var d=0;d=i;if(!(a[b>>0]&1)){i=d;return}ACi(c[b+8>>2]|0);i=d;return}function xri(a){a=a|0;var b=0;b=i;wri(a);i=b;return}function yri(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d>>0]|0;if(!(f&1)){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}Ari(b,g,h)|0;i=e;return b|0}function zri(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Ari(a,b,SEi(b|0)|0)|0;i=c;return d|0}function Ari(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b>>0]|0;if(!(g&1)){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+-1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g)k=(j&255)>>>1;else k=c[b+4>>2]|0;Hri(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g)l=b+1|0;else l=c[b+8>>2]|0;aFi(l|0,d|0,e|0)|0;a[l+e>>0]=0;if(!(a[b>>0]&1)){a[b>>0]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function Bri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b>>0]|0;h=(g&1)==0;if(h)j=(g&255)>>>1;else j=c[b+4>>2]|0;if(j>>>0<d>>>0){Cri(b,d-j|0,e)|0;i=f;return}if(h){a[b+d+1>>0]=0;a[b>>0]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d>>0]=0;c[b+4>>2]=d;i=f;return}}function Cri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(!d){i=f;return b|0}g=a[b>>0]|0;if(!(g&1)){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+-1|0;j=g&255}if(!(j&1))k=(j&255)>>>1;else k=c[b+4>>2]|0;if((h-k|0)>>>0<d>>>0){Iri(b,h,d-h+k|0,k,k,0,0);l=a[b>>0]|0}else l=j;if(!(l&1))m=b+1|0;else m=c[b+8>>2]|0;PEi(m+k|0,e|0,d|0)|0;e=k+d|0;if(!(a[b>>0]&1))a[b>>0]=e<<1;else c[b+4>>2]=e;a[m+e>>0]=0;i=f;return b|0}function Dri(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279)ori(b);f=a[b>>0]|0;if(!(f&1)){g=10;h=f}else{f=c[b>>2]|0;g=(f&-2)+-1|0;h=f&255}if(!(h&1))j=(h&255)>>>1;else j=c[b+4>>2]|0;f=j>>>0>d>>>0?j:d;if(f>>>0<11)k=10;else k=(f+16&-16)+-1|0;if((k|0)==(g|0)){i=e;return}do if((k|0)!=10){f=k+1|0;if(k>>>0>g>>>0)l=xCi(f)|0;else l=xCi(f)|0;if(!(h&1)){m=l;n=1;o=b+1|0;p=0;break}else{m=l;n=1;o=c[b+8>>2]|0;p=1;break}}else{m=b+1|0;n=0;o=c[b+8>>2]|0;p=1}while(0);if(!(h&1))q=(h&255)>>>1;else q=c[b+4>>2]|0;YEi(m|0,o|0,q+1|0)|0;if(p)ACi(o);if(n){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=m;i=e;return}else{a[b>>0]=j<<1;i=e;return}}function Eri(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Gri(a,b,SEi(b|0)|0)|0;i=c;return d|0}function Fri(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=a[b>>0]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+-1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){Iri(b,h,1,h,h,0,0);if(!(a[b>>0]&1))k=7;else k=8}else if(g)k=8;else k=7;if((k|0)==7){a[b>>0]=(j<<1)+2;l=b+1|0;m=j+1|0;n=l+j|0;a[n>>0]=d;o=l+m|0;a[o>>0]=0;i=e;return}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g;n=l+j|0;a[n>>0]=d;o=l+m|0;a[o>>0]=0;i=e;return}}function Gri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b>>0]|0;if(!(g&1)){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+-1|0;j=g&255}if(!(j&1))k=(j&255)>>>1;else k=c[b+4>>2]|0;if((h-k|0)>>>0<e>>>0){Hri(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if(!e){i=f;return b|0}if(!(j&1))l=b+1|0;else l=c[b+8>>2]|0;YEi(l+k|0,d|0,e|0)|0;d=k+e|0;if(!(a[b>>0]&1))a[b>>0]=d<<1;else c[b+4>>2]=d;a[l+d>>0]=0;i=f;return b|0}function Hri(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;l=i;if((-18-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))m=b+1|0;else m=c[b+8>>2]|0;if(d>>>0<2147483623){n=e+d|0;e=d<<1;o=n>>>0<e>>>0?e:n;if(o>>>0<11)p=11;else p=o+16&-16}else p=-17;o=xCi(p)|0;if(g)YEi(o|0,m|0,g|0)|0;if(j)YEi(o+g|0,k|0,j|0)|0;k=f-h|0;if((k|0)!=(g|0))YEi(o+(j+g)|0,m+(h+g)|0,k-g|0)|0;if((d|0)==10){q=b+8|0;c[q>>2]=o;r=p|1;c[b>>2]=r;s=k+j|0;t=b+4|0;c[t>>2]=s;u=o+s|0;a[u>>0]=0;i=l;return}ACi(m);q=b+8|0;c[q>>2]=o;r=p|1;c[b>>2]=r;s=k+j|0;t=b+4|0;c[t>>2]=s;u=o+s|0;a[u>>0]=0;i=l;return}function Iri(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;if((-17-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))l=b+1|0;else l=c[b+8>>2]|0;if(d>>>0<2147483623){m=e+d|0;e=d<<1;n=m>>>0<e>>>0?e:m;if(n>>>0<11)o=11;else o=n+16&-16}else o=-17;n=xCi(o)|0;if(g)YEi(n|0,l|0,g|0)|0;m=f-h|0;if((m|0)!=(g|0))YEi(n+(j+g)|0,l+(h+g)|0,m-g|0)|0;if((d|0)==10){p=b+8|0;c[p>>2]=n;q=o|1;c[b>>2]=q;i=k;return}ACi(l);p=b+8|0;c[p>>2]=n;q=o|1;c[b>>2]=q;i=k;return}function Jri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=a[b>>0]|0;h=(g&1)==0;if(h)j=(g&255)>>>1;else j=c[b+4>>2]|0;if(j>>>0<d>>>0)pri(b);if(!e){i=f;return b|0}if(h)k=b+1|0;else k=c[b+8>>2]|0;h=j-d|0;l=h>>>0<e>>>0?h:e;if((h|0)==(l|0))m=g;else{aFi(k+d|0,k+(l+d)|0,h-l|0)|0;m=a[b>>0]|0}h=j-l|0;if(!(m&1))a[b>>0]=h<<1;else c[b+4>>2]=h;a[k+h>>0]=0;i=f;return b|0}function Kri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;g=a[b>>0]|0;if(!(g&1)){h=(g&255)>>>1;j=b+1|0}else{h=c[b+4>>2]|0;j=c[b+8>>2]|0}if(h>>>0<=e>>>0){k=-1;i=f;return k|0}b=EEi(j+e|0,d&255,h-e|0)|0;if(!b){k=-1;i=f;return k|0}k=b-j|0;i=f;return k|0}function Lri(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;h=a[b>>0]|0;if(!(h&1)){j=(h&255)>>>1;k=b+1|0}else{j=c[b+4>>2]|0;k=c[b+8>>2]|0}b=j>>>0<e>>>0?j:e;e=(j-b|0)>>>0>f>>>0?b+f|0:j;j=k+e|0;b=d+f|0;a:do if(!((f|0)==0|(e|0)<(f|0))?(h=f+-1|0,l=k+h|0,m=d+h|0,(h|0)!=(e|0)):0){h=a[m>>0]|0;n=j;while(1){o=n;n=n+-1|0;if((a[n>>0]|0)==h<<24>>24){p=o;o=b;q=n;r=m;while(1){if((r|0)==(d|0)){s=q;break a}t=p+-2|0;u=o+-2|0;if((a[t>>0]|0)==(a[u>>0]|0)){v=r;w=q;q=t;r=u;o=v;p=w}else break}}if((l|0)==(n|0)){s=j;break}}}else s=j;while(0);if((f|0)!=0&(s|0)==(j|0)){x=-1;i=g;return x|0}x=s-k|0;i=g;return x|0}function Mri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=a[b>>0]|0;if(!(g&1)){h=(g&255)>>>1;j=b+1|0}else{h=c[b+4>>2]|0;j=c[b+8>>2]|0}if(!h){k=-1;i=f;return k|0}b=j+(h>>>0>e>>>0?e+1|0:h)|0;while(1){if((b|0)==(j|0)){k=-1;l=9;break}h=b+-1|0;if((a[h>>0]|0)==d<<24>>24){m=h;break}else b=h}if((l|0)==9){i=f;return k|0}k=m-j|0;i=f;return k|0}function Nri(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=a[b>>0]|0;k=(j&1)==0;if(k)l=(j&255)>>>1;else l=c[b+4>>2]|0;if(l>>>0<d>>>0|(g|0)==-1)pri(b);j=l-d|0;l=j>>>0<e>>>0?j:e;if(k)m=b+1|0;else m=c[b+8>>2]|0;b=l>>>0>g>>>0;k=FEi(m+d|0,f,b?g:l)|0;if(k){n=k;i=h;return n|0}if(l>>>0<g>>>0){n=-1;i=h;return n|0}else{i=h;return b&1|0}return 0}function Ori(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Nri(a,0,-1,b,SEi(b|0)|0)|0;i=c;return d|0}function Pri(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;if(f>>>0>4294967279)ori(b);if(f>>>0<11){a[b>>0]=e<<1;h=b+1|0}else{j=f+16&-16;f=xCi(j)|0;c[b+8>>2]=f;c[b>>2]=j|1;c[b+4>>2]=e;h=f}YEi(h|0,d|0,e|0)|0;a[h+e>>0]=0;i=g;return}function Qri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807)ori(b);if(e>>>0<2){a[b>>0]=e<<1;g=b+4|0}else{h=e+4&-4;j=xCi(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}pCi(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function Rri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807)ori(b);if(d>>>0<2){a[b>>0]=d<<1;g=b+4|0}else{h=d+4&-4;j=xCi(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}rCi(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function Sri(b){b=b|0;var d=0;d=i;if(!(a[b>>0]&1)){i=d;return}ACi(c[b+8>>2]|0);i=d;return}function Tri(a){a=a|0;var b=0;b=i;Sri(a);i=b;return}function Uri(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Vri(a,b,oCi(b)|0)|0;i=c;return d|0}function Vri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b>>0]|0;if(!(g&1)){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+-1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g)k=(j&255)>>>1;else k=c[b+4>>2]|0;Yri(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g)l=b+4|0;else l=c[b+8>>2]|0;qCi(l,d,e)|0;c[l+(e<<2)>>2]=0;if(!(a[b>>0]&1)){a[b>>0]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function Wri(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807)ori(b);f=a[b>>0]|0;if(!(f&1)){g=1;h=f}else{f=c[b>>2]|0;g=(f&-2)+-1|0;h=f&255}if(!(h&1))j=(h&255)>>>1;else j=c[b+4>>2]|0;f=j>>>0>d>>>0?j:d;if(f>>>0<2)k=1;else k=(f+4&-4)+-1|0;if((k|0)==(g|0)){i=e;return}do if((k|0)!=1){f=(k<<2)+4|0;if(k>>>0>g>>>0)l=xCi(f)|0;else l=xCi(f)|0;if(!(h&1)){m=l;n=1;o=b+4|0;p=0;break}else{m=l;n=1;o=c[b+8>>2]|0;p=1;break}}else{m=b+4|0;n=0;o=c[b+8>>2]|0;p=1}while(0);if(!(h&1))q=(h&255)>>>1;else q=c[b+4>>2]|0;pCi(m,o,q+1|0)|0;if(p)ACi(o);if(n){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=m;i=e;return}else{a[b>>0]=j<<1;i=e;return}}function Xri(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;f=a[b>>0]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+-1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){Zri(b,h,1,h,h,0,0);if(!(a[b>>0]&1))k=7;else k=8}else if(g)k=8;else k=7;if((k|0)==7){a[b>>0]=(j<<1)+2;l=b+4|0;m=j+1|0;n=l+(j<<2)|0;c[n>>2]=d;o=l+(m<<2)|0;c[o>>2]=0;i=e;return}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g;n=l+(j<<2)|0;c[n>>2]=d;o=l+(m<<2)|0;c[o>>2]=0;i=e;return}}function Yri(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;l=i;if((1073741806-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))m=b+4|0;else m=c[b+8>>2]|0;if(d>>>0<536870887){n=e+d|0;e=d<<1;o=n>>>0<e>>>0?e:n;if(o>>>0<2)p=2;else p=o+4&-4}else p=1073741807;o=xCi(p<<2)|0;if(g)pCi(o,m,g)|0;if(j)pCi(o+(g<<2)|0,k,j)|0;k=f-h|0;if((k|0)!=(g|0))pCi(o+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0;if((d|0)==1){q=b+8|0;c[q>>2]=o;r=p|1;c[b>>2]=r;s=k+j|0;t=b+4|0;c[t>>2]=s;u=o+(s<<2)|0;c[u>>2]=0;i=l;return}ACi(m);q=b+8|0;c[q>>2]=o;r=p|1;c[b>>2]=r;s=k+j|0;t=b+4|0;c[t>>2]=s;u=o+(s<<2)|0;c[u>>2]=0;i=l;return}function Zri(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;if((1073741807-d|0)>>>0<e>>>0)ori(b);if(!(a[b>>0]&1))l=b+4|0;else l=c[b+8>>2]|0;if(d>>>0<536870887){m=e+d|0;e=d<<1;n=m>>>0<e>>>0?e:m;if(n>>>0<2)o=2;else o=n+4&-4}else o=1073741807;n=xCi(o<<2)|0;if(g)pCi(n,l,g)|0;m=f-h|0;if((m|0)!=(g|0))pCi(n+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0;if((d|0)==1){p=b+8|0;c[p>>2]=n;q=o|1;c[b>>2]=q;i=k;return}ACi(l);p=b+8|0;c[p>>2]=n;q=o|1;c[b>>2]=q;i=k;return}function _ri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=SEi(d|0)|0;h=a[e>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[e+4>>2]|0;Pri(b,d,g,j+g|0);if(!(a[e>>0]&1)){k=e+1|0;Gri(b,k,j)|0;i=f;return}else{k=c[e+8>>2]|0;Gri(b,k,j)|0;i=f;return}}function $ri(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=(c[a+24>>2]|0)==0;c[a+16>>2]=f&1|b;if(!((f&1|b)&c[a+20>>2])){i=d;return}else{d=al(16)|0;tti()|0;a=e;c[a>>2]=1;c[a+4>>2]=3652376;uti(d,3652432,e);we(d|0,3652480,3360)}}function asi(a){a=a|0;var b=0;b=i;c[a>>2]=3652424;csi(a,0);Ixi(a+28|0);BDi(c[a+32>>2]|0);BDi(c[a+36>>2]|0);BDi(c[a+48>>2]|0);BDi(c[a+60>>2]|0);i=b;return}function bsi(a){a=a|0;var b=0;b=i;asi(a);i=b;return}function csi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=c[a+40>>2]|0;if(!e){i=d;return}f=a+32|0;g=a+36|0;h=e;do{h=h+-1|0;co[c[(c[f>>2]|0)+(h<<2)>>2]&2047](b,a,c[(c[g>>2]|0)+(h<<2)>>2]|0)}while((h|0)!=0);i=d;return}function dsi(a,b){a=a|0;b=b|0;var c=0;c=i;Hxi(a,b+28|0);i=c;return}function esi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0&1;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));Gxi(b);i=d;return}function fsi(a){a=a|0;var b=0;b=i;asi(a);i=b;return}function gsi(a){a=a|0;var b=0;b=i;c[a>>2]=3652040;Ixi(a+4|0);i=b;return}function hsi(a){a=a|0;var b=0;b=i;c[a>>2]=3652040;Ixi(a+4|0);i=b;return}function isi(a){a=a|0;var b=0;b=i;c[a>>2]=3652040;Ixi(a+4|0);ACi(a);i=b;return}function jsi(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=3652040;Gxi(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function ksi(a,b){a=a|0;b=b|0;return}function lsi(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function msi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function nsi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}function osi(a){a=a|0;return 0}function psi(a){a=a|0;return 0}function qsi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l>>0]|0}else{l=mo[c[(c[b>>2]|0)+40>>2]&4095](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k>>0]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function rsi(a){a=a|0;return -1}function ssi(a){a=a|0;var b=0,e=0,f=0;b=i;if((mo[c[(c[a>>2]|0)+36>>2]&4095](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a>>0]|0;i=b;return e|0}function tsi(a,b){a=a|0;b=b|0;return -1}function usi(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0>=(c[k>>2]|0)>>>0){if((_n[c[(c[b>>2]|0)+52>>2]&4095](b,d[l>>0]|0)|0)==-1){h=e;n=7;break}}else{o=a[l>>0]|0;c[j>>2]=m+1;a[m>>0]=o}o=e+1|0;if((o|0)<(f|0)){l=l+1|0;e=o}else{h=o;n=7;break}}if((n|0)==7){i=g;return h|0}return 0}function vsi(a,b){a=a|0;b=b|0;return -1}function wsi(a){a=a|0;var b=0;b=i;c[a>>2]=3652104;Ixi(a+4|0);i=b;return}function xsi(a){a=a|0;var b=0;b=i;c[a>>2]=3652104;Ixi(a+4|0);i=b;return}function ysi(a){a=a|0;var b=0;b=i;c[a>>2]=3652104;Ixi(a+4|0);ACi(a);i=b;return}function zsi(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=3652104;Gxi(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function Asi(a,b){a=a|0;b=b|0;return}function Bsi(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Csi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function Dsi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}function Esi(a){a=a|0;return 0}function Fsi(a){a=a|0;return 0}function Gsi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0>=(c[h>>2]|0)>>>0){l=mo[c[(c[a>>2]|0)+40>>2]&4095](a)|0;if((l|0)==-1){f=b;m=7;break}else n=l}else{c[g>>2]=k+4;n=c[k>>2]|0}c[j>>2]=n;k=b+1|0;if((k|0)<(d|0)){j=j+4|0;b=k}else{f=k;m=7;break}}if((m|0)==7){i=e;return f|0}return 0}function Hsi(a){a=a|0;return -1}function Isi(a){a=a|0;var b=0,d=0,e=0;b=i;if((mo[c[(c[a>>2]|0)+36>>2]&4095](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function Jsi(a,b){a=a|0;b=b|0;return -1}function Ksi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0>=(c[h>>2]|0)>>>0){if((_n[c[(c[a>>2]|0)+52>>2]&4095](a,c[j>>2]|0)|0)==-1){f=b;l=7;break}}else{m=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=m}m=b+1|0;if((m|0)<(d|0)){j=j+4|0;b=m}else{f=m;l=7;break}}if((l|0)==7){i=e;return f|0}return 0}function Lsi(a,b){a=a|0;b=b|0;return -1}function Msi(a){a=a|0;var b=0;b=i;asi(a+8|0);i=b;return}function Nsi(a){a=a|0;var b=0;b=i;asi(a+((c[(c[a>>2]|0)+-12>>2]|0)+8)|0);i=b;return}function Osi(a){a=a|0;var b=0;b=i;asi(a+8|0);ACi(a);i=b;return}function Psi(a){a=a|0;var b=0;b=i;Osi(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);i=b;return}function Qsi(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;if(!(c[b+((c[(c[b>>2]|0)+-12>>2]|0)+24)>>2]|0)){i=d;return b|0}$si(e,b);if((a[e>>0]|0)!=0?(f=c[b+((c[(c[b>>2]|0)+-12>>2]|0)+24)>>2]|0,(mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0)==-1):0){f=c[(c[b>>2]|0)+-12>>2]|0;$ri(b+f|0,c[b+(f+16)>>2]|1)}bti(e);i=d;return b|0}function Rsi(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if(!(c[a+20>>2]&1))return;else Lc()}function Ssi(a){a=a|0;var b=0;b=i;asi(a+8|0);i=b;return}function Tsi(a){a=a|0;var b=0;b=i;asi(a+((c[(c[a>>2]|0)+-12>>2]|0)+8)|0);i=b;return}function Usi(a){a=a|0;var b=0;b=i;asi(a+8|0);ACi(a);i=b;return}function Vsi(a){a=a|0;var b=0;b=i;Usi(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);i=b;return}function Wsi(a,b){a=a|0;b=b|0;return}function Xsi(a){a=a|0;var b=0;b=i;asi(a+4|0);i=b;return}function Ysi(a){a=a|0;var b=0;b=i;asi(a+((c[(c[a>>2]|0)+-12>>2]|0)+4)|0);i=b;return}function Zsi(a){a=a|0;var b=0;b=i;asi(a+4|0);ACi(a);i=b;return}function _si(a){a=a|0;var b=0;b=i;Zsi(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);i=b;return}function $si(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;a[b>>0]=0;c[b+4>>2]=d;f=c[(c[d>>2]|0)+-12>>2]|0;if(c[d+(f+16)>>2]|0){i=e;return}g=c[d+(f+72)>>2]|0;if(g)Qsi(g)|0;a[b>>0]=1;i=e;return}function ati(a,b){a=a|0;b=b|0;var c=0;c=i;$si(a,b);i=c;return}function bti(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+-12>>2]|0;if(!(c[a+(e+24)>>2]|0)){i=b;return}if(c[a+(e+16)>>2]|0){i=b;return}if(!(c[a+(e+4)>>2]&8192)){i=b;return}if(Kh()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+-12>>2]|0)+24)>>2]|0;if((mo[c[(c[a>>2]|0)+24>>2]&4095](a)|0)!=-1){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+-12>>2]|0;$ri(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function cti(a){a=a|0;var b=0;b=i;bti(a);i=b;return}function dti(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+8|0;j=e+4|0;k=e;$si(h,b);if(!(a[h>>0]|0)){bti(h);i=e;return b|0}Hxi(j,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);l=Kxi(j,3653488)|0;Ixi(j);j=c[(c[b>>2]|0)+-12>>2]|0;m=c[b+(j+24)>>2]|0;n=b+(j+76)|0;o=c[n>>2]|0;if((o|0)==-1){Hxi(f,b+(j+28)|0);p=Kxi(f,3654800)|0;q=_n[c[(c[p>>2]|0)+28>>2]&4095](p,32)|0;Ixi(f);p=q<<24>>24;c[n>>2]=p;r=p}else r=o;o=c[(c[l>>2]|0)+24>>2]|0;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];rn[o&127](k,l,f,b+j|0,r&255,d&65535);if(c[k>>2]|0){bti(h);i=e;return b|0}k=c[(c[b>>2]|0)+-12>>2]|0;$ri(b+k|0,c[b+(k+16)>>2]|5);bti(h);i=e;return b|0}function eti(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+8|0;j=e+4|0;k=e;$si(h,b);if(!(a[h>>0]|0)){bti(h);i=e;return b|0}Hxi(j,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);l=Kxi(j,3653488)|0;Ixi(j);j=c[(c[b>>2]|0)+-12>>2]|0;m=c[b+(j+24)>>2]|0;n=b+(j+76)|0;o=c[n>>2]|0;if((o|0)==-1){Hxi(f,b+(j+28)|0);p=Kxi(f,3654800)|0;q=_n[c[(c[p>>2]|0)+28>>2]&4095](p,32)|0;Ixi(f);p=q<<24>>24;c[n>>2]=p;r=p}else r=o;o=c[(c[l>>2]|0)+16>>2]|0;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];rn[o&127](k,l,f,b+j|0,r&255,d);if(c[k>>2]|0){bti(h);i=e;return b|0}k=c[(c[b>>2]|0)+-12>>2]|0;$ri(b+k|0,c[b+(k+16)>>2]|5);bti(h);i=e;return b|0}function fti(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+8|0;j=e+4|0;k=e;$si(h,b);if(!(a[h>>0]|0)){bti(h);i=e;return b|0}Hxi(j,b+((c[(c[b>>2]|0)+-12>>2]|0)+28)|0);l=Kxi(j,3653488)|0;Ixi(j);j=c[(c[b>>2]|0)+-12>>2]|0;m=c[b+(j+24)>>2]|0;n=b+(j+76)|0;o=c[n>>2]|0;if((o|0)==-1){Hxi(f,b+(j+28)|0);p=Kxi(f,3654800)|0;q=_n[c[(c[p>>2]|0)+28>>2]&4095](p,32)|0;Ixi(f);p=q<<24>>24;c[n>>2]=p;r=p}else r=o;o=c[(c[l>>2]|0)+24>>2]|0;c[g>>2]=m;c[f+0>>2]=c[g+0>>2];rn[o&127](k,l,f,b+j|0,r&255,d);if(c[k>>2]|0){bti(h);i=e;return b|0}k=c[(c[b>>2]|0)+-12>>2]|0;$ri(b+k|0,c[b+(k+16)>>2]|5);bti(h);i=e;return b|0}function gti(a){a=a|0;var b=0;b=i;asi(a+4|0);i=b;return}function hti(a){a=a|0;var b=0;b=i;asi(a+((c[(c[a>>2]|0)+-12>>2]|0)+4)|0);i=b;return}function iti(a){a=a|0;var b=0;b=i;asi(a+4|0);ACi(a);i=b;return}function jti(a){a=a|0;var b=0;b=i;iti(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);i=b;return}function kti(a,b){a=a|0;b=b|0;return}function lti(a){a=a|0;var b=0;b=i;asi(a+12|0);i=b;return}function mti(a){a=a|0;var b=0;b=i;asi(a+-8+12|0);i=b;return}function nti(a){a=a|0;var b=0;b=i;asi(a+((c[(c[a>>2]|0)+-12>>2]|0)+12)|0);i=b;return}function oti(a){a=a|0;var b=0;b=i;asi(a+12|0);ACi(a);i=b;return}function pti(a){a=a|0;var b=0;b=i;oti(a+-8|0);i=b;return}function qti(a){a=a|0;var b=0;b=i;oti(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);i=b;return}function rti(a){a=a|0;return 3652320}function sti(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)!=1&(c|0)<257){gri(a,b,c);i=d;return}else{rri(a,3652336,35);i=d;return}}function tti(){var b=0;b=i;if((a[3652384]|0)==0?(Eh(3652384)|0)!=0:0){c[913094]=3653080;Cf(3652384)}i=b;return 3652376}function uti(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e;h=d;d=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=d;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];iri(a,f,b);c[a>>2]=3652400;i=e;return}function vti(a){a=a|0;var b=0;b=i;jri(a);i=b;return}function wti(a){a=a|0;var b=0;b=i;jri(a);ACi(a);i=b;return}function xti(a){a=a|0;var b=0;b=i;asi(a);ACi(a);i=b;return}function yti(a){a=a|0;return}function zti(a){a=a|0;return}function Ati(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Bti(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k>>0]|0;n=a[j>>0]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;j=j+1|0;if((j|0)==(f|0)){g=m;h=6;break}else k=m}}while(0);if((h|0)==6)l=(g|0)!=(d|0)&1;i=b;return l|0}function Cti(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=i;Izi(a,c,d);i=b;return}function Dti(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g>>0]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;g=g+1|0;if((g|0)==(d|0)){e=j;break}else f=j}i=b;return e|0}function Eti(a){a=a|0;return}function Fti(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Gti(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;j=j+4|0;if((j|0)==(f|0)){g=m;h=6;break}else k=m}}while(0);if((h|0)==6)l=(g|0)!=(d|0)&1;i=a;return l|0}function Hti(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=i;Jzi(a,c,d);i=b;return}function Iti(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;g=g+4|0;if((g|0)==(d|0)){e=j;break}else f=j}i=a;return e|0}function Jti(a){a=a|0;return}function Kti(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Lti(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;i=i+64|0;l=k;m=k+16|0;n=k+52|0;o=k+4|0;p=k+56|0;q=k+60|0;r=k+12|0;s=k+48|0;t=k+24|0;u=k+8|0;if(c[g+4>>2]&1){dsi(r,g);v=Kxi(r,3654800)|0;$qi(c[r>>2]|0)|0;dsi(s,g);r=Kxi(s,3654944)|0;$qi(c[s>>2]|0)|0;In[c[(c[r>>2]|0)+24>>2]&4095](t,r);In[c[(c[r>>2]|0)+28>>2]&4095](t+12|0,r);c[u>>2]=c[f>>2];c[l+0>>2]=c[u+0>>2];a[j>>0]=(Kzi(e,l,t,t+24|0,v,h,1)|0)==(t|0)&1;c[b>>2]=c[e>>2];xri(t+12|0);xri(t);i=k;return}c[n>>2]=-1;t=c[(c[d>>2]|0)+16>>2]|0;c[p>>2]=c[e>>2];c[q>>2]=c[f>>2];c[m+0>>2]=c[p+0>>2];c[l+0>>2]=c[q+0>>2];Wn[t&127](o,d,m,l,g,h,n);g=c[o>>2]|0;c[e>>2]=g;e=c[n>>2]|0;if(!e)a[j>>0]=0;else if((e|0)==1)a[j>>0]=1;else{a[j>>0]=1;c[h>>2]=4}c[b>>2]=g;i=k;return}function Mti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Lzi(a,b,l,k,f,g,h);i=j;return}function Nti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Mzi(a,b,l,k,f,g,h);i=j;return}function Oti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Nzi(a,b,l,k,f,g,h);i=j;return}function Pti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Ozi(a,b,l,k,f,g,h);i=j;return}function Qti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Pzi(a,b,l,k,f,g,h);i=j;return}function Rti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Qzi(a,b,l,k,f,g,h);i=j;return}function Sti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Rzi(a,b,l,k,f,g,h);i=j;return}function Tti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Szi(a,b,l,k,f,g,h);i=j;return}function Uti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Tzi(a,b,l,k,f,g,h);i=j;return}function Vti(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=i;i=i+240|0;l=e;m=e+208|0;n=e+188|0;o=e+200|0;p=e+8|0;q=e+4|0;r=e+24|0;s=e+184|0;t=e+204|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;dsi(o,h);h=Kxi(o,3654800)|0;kn[c[(c[h>>2]|0)+32>>2]&511](h,3653312,3653338|0,m)|0;$qi(c[o>>2]|0)|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bri(p,10,0);if(!(a[p>>0]&1)){o=p+1|0;u=o;v=p+8|0;w=o}else{o=p+8|0;u=p+1|0;v=o;w=c[o>>2]|0}c[q>>2]=w;c[s>>2]=r;c[t>>2]=0;o=p+4|0;h=c[f>>2]|0;x=w;a:while(1){if(h)if((c[h+12>>2]|0)==(c[h+16>>2]|0)?(mo[c[(c[h>>2]|0)+36>>2]&4095](h)|0)==-1:0){c[f>>2]=0;y=0}else y=h;else y=0;w=(y|0)==0;z=c[g>>2]|0;do if(z){if((c[z+12>>2]|0)!=(c[z+16>>2]|0))if(w){A=z;break}else{B=y;C=z;D=x;break a}if((mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0)!=-1)if(w){A=z;break}else{B=y;C=z;D=x;break a}else{c[g>>2]=0;E=14;break}}else E=14;while(0);if((E|0)==14){E=0;if(w){B=y;C=0;D=x;break}else A=0}z=a[p>>0]|0;F=(z&1)==0;if(F)G=(z&255)>>>1;else G=c[o>>2]|0;if((c[q>>2]|0)==(x+G|0)){if(F){H=(z&255)>>>1;I=(z&255)>>>1}else{z=c[o>>2]|0;H=z;I=z}Bri(p,H<<1,0);if(!(a[p>>0]&1))J=10;else J=(c[p>>2]&-2)+-1|0;Bri(p,J,0);if(!(a[p>>0]&1))K=u;else K=c[v>>2]|0;c[q>>2]=K+I;L=K}else L=x;z=y+12|0;F=c[z>>2]|0;M=y+16|0;if((F|0)==(c[M>>2]|0))N=mo[c[(c[y>>2]|0)+36>>2]&4095](y)|0;else N=d[F>>0]|0;if(Wti(N&255,16,L,q,t,0,n,r,s,m)|0){B=y;C=A;D=L;break}F=c[z>>2]|0;if((F|0)==(c[M>>2]|0)){mo[c[(c[y>>2]|0)+40>>2]&4095](y)|0;h=y;x=L;continue}else{c[z>>2]=F+1;h=y;x=L;continue}}Bri(p,(c[q>>2]|0)-D|0,0);if(!(a[p>>0]&1))O=u;else O=c[v>>2]|0;v=Xti()|0;c[l>>2]=k;if((Uzi(O,v,3653352,l)|0)!=1)c[j>>2]=4;if(B)if((c[B+12>>2]|0)==(c[B+16>>2]|0)?(mo[c[(c[B>>2]|0)+36>>2]&4095](B)|0)==-1:0){c[f>>2]=0;P=0}else P=B;else P=0;B=(P|0)==0;do if(C){if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(!B)break;c[b>>2]=P;xri(p);xri(n);i=e;return}if((mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1){c[g>>2]=0;E=48;break}if(B^(C|0)==0){c[b>>2]=P;xri(p);xri(n);i=e;return}}else E=48;while(0);if((E|0)==48?!B:0){c[b>>2]=P;xri(p);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[b>>2]=P;xri(p);xri(n);i=e;return}function Wti(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){q=(a[m+24>>0]|0)==b<<24>>24;if(!q?(a[m+25>>0]|0)!=b<<24>>24:0)break;c[f>>2]=e+1;a[e>>0]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}while(0);q=a[j>>0]|0;if(!(q&1))s=(q&255)>>>1;else s=c[j+4>>2]|0;if((s|0)!=0?b<<24>>24==h<<24>>24:0){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){if((a[h>>0]|0)==b<<24>>24){t=h;break}h=h+1|0;if((h|0)==(k|0)){t=k;break}}k=t-m|0;if((k|0)>23){r=-1;i=n;return r|0}if((d|0)==16){if((k|0)>=22){if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+-1>>0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;e=a[3653312+k>>0]|0;c[f>>2]=o+1;a[o>>0]=e;r=0;i=n;return r|0}}else if((d|0)==10|(d|0)==8?(k|0)>=(d|0):0){r=-1;i=n;return r|0}d=a[3653312+k>>0]|0;c[f>>2]=o+1;a[o>>0]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function Xti(){var b=0;b=i;if((a[3654696]|0)==0?(Eh(3654696)|0)!=0:0){c[913672]=ad(2147483647,3654704,0)|0;Cf(3654696)}i=b;return c[913672]|0}function Yti(a){a=a|0;return}function Zti(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function _ti(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;i=i+64|0;l=k;m=k+16|0;n=k+52|0;o=k+4|0;p=k+56|0;q=k+60|0;r=k+12|0;s=k+48|0;t=k+24|0;u=k+8|0;if(c[g+4>>2]&1){dsi(r,g);v=Kxi(r,3654792)|0;$qi(c[r>>2]|0)|0;dsi(s,g);r=Kxi(s,3654952)|0;$qi(c[s>>2]|0)|0;In[c[(c[r>>2]|0)+24>>2]&4095](t,r);In[c[(c[r>>2]|0)+28>>2]&4095](t+12|0,r);c[u>>2]=c[f>>2];c[l+0>>2]=c[u+0>>2];a[j>>0]=(Vzi(e,l,t,t+24|0,v,h,1)|0)==(t|0)&1;c[b>>2]=c[e>>2];Tri(t+12|0);Tri(t);i=k;return}c[n>>2]=-1;t=c[(c[d>>2]|0)+16>>2]|0;c[p>>2]=c[e>>2];c[q>>2]=c[f>>2];c[m+0>>2]=c[p+0>>2];c[l+0>>2]=c[q+0>>2];Wn[t&127](o,d,m,l,g,h,n);g=c[o>>2]|0;c[e>>2]=g;e=c[n>>2]|0;if(!e)a[j>>0]=0;else if((e|0)==1)a[j>>0]=1;else{a[j>>0]=1;c[h>>2]=4}c[b>>2]=g;i=k;return}function $ti(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Wzi(a,b,l,k,f,g,h);i=j;return}function aui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Xzi(a,b,l,k,f,g,h);i=j;return}function bui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Yzi(a,b,l,k,f,g,h);i=j;return}function cui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Zzi(a,b,l,k,f,g,h);i=j;return}function dui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];_zi(a,b,l,k,f,g,h);i=j;return}function eui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];$zi(a,b,l,k,f,g,h);i=j;return}function fui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];aAi(a,b,l,k,f,g,h);i=j;return}function gui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];bAi(a,b,l,k,f,g,h);i=j;return}function hui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];cAi(a,b,l,k,f,g,h);i=j;return}function iui(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+320|0;k=d;l=d+200|0;m=d+188|0;n=d+8|0;o=d+176|0;p=d+4|0;q=d+16|0;r=d+304|0;s=d+308|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;dsi(n,g);g=Kxi(n,3654792)|0;kn[c[(c[g>>2]|0)+48>>2]&511](g,3653312,3653338|0,l)|0;$qi(c[n>>2]|0)|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){n=o+1|0;t=n;u=o+8|0;v=n}else{n=o+8|0;t=o+1|0;u=n;v=c[n>>2]|0}c[p>>2]=v;c[r>>2]=q;c[s>>2]=0;n=o+4|0;g=c[e>>2]|0;w=v;a:while(1){if(g){v=c[g+12>>2]|0;if((v|0)==(c[g+16>>2]|0))x=mo[c[(c[g>>2]|0)+36>>2]&4095](g)|0;else x=c[v>>2]|0;if((x|0)==-1){c[e>>2]=0;y=1;z=0}else{y=0;z=g}}else{y=1;z=0}v=c[f>>2]|0;do if(v){A=c[v+12>>2]|0;if((A|0)==(c[v+16>>2]|0))B=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;else B=c[A>>2]|0;if((B|0)!=-1)if(y){C=v;break}else{D=z;E=v;F=w;break a}else{c[f>>2]=0;G=17;break}}else G=17;while(0);if((G|0)==17){G=0;if(y){D=z;E=0;F=w;break}else C=0}v=a[o>>0]|0;A=(v&1)==0;if(A)H=(v&255)>>>1;else H=c[n>>2]|0;if((c[p>>2]|0)==(w+H|0)){if(A){I=(v&255)>>>1;J=(v&255)>>>1}else{v=c[n>>2]|0;I=v;J=v}Bri(o,I<<1,0);if(!(a[o>>0]&1))K=10;else K=(c[o>>2]&-2)+-1|0;Bri(o,K,0);if(!(a[o>>0]&1))L=t;else L=c[u>>2]|0;c[p>>2]=L+J;M=L}else M=w;v=z+12|0;A=c[v>>2]|0;N=z+16|0;if((A|0)==(c[N>>2]|0))O=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else O=c[A>>2]|0;if(jui(O,16,M,p,s,0,m,q,r,l)|0){D=z;E=C;F=M;break}A=c[v>>2]|0;if((A|0)==(c[N>>2]|0)){mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;g=z;w=M;continue}else{c[v>>2]=A+4;g=z;w=M;continue}}Bri(o,(c[p>>2]|0)-F|0,0);if(!(a[o>>0]&1))P=t;else P=c[u>>2]|0;u=Xti()|0;c[k>>2]=j;if((Uzi(P,u,3653352,k)|0)!=1)c[h>>2]=4;if(D){k=c[D+12>>2]|0;if((k|0)==(c[D+16>>2]|0))Q=mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0;else Q=c[k>>2]|0;if((Q|0)==-1){c[e>>2]=0;R=0;S=1}else{R=D;S=0}}else{R=0;S=1}do if(E){D=c[E+12>>2]|0;if((D|0)==(c[E+16>>2]|0))T=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else T=c[D>>2]|0;if((T|0)==-1){c[f>>2]=0;G=54;break}if(S){c[b>>2]=R;xri(o);xri(m);i=d;return}}else G=54;while(0);if((G|0)==54?!S:0){c[b>>2]=R;xri(o);xri(m);i=d;return}c[h>>2]=c[h>>2]|2;c[b>>2]=R;xri(o);xri(m);i=d;return}function jui(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){q=(c[m+96>>2]|0)==(b|0);if(!q?(c[m+100>>2]|0)!=(b|0):0)break;c[f>>2]=e+1;a[e>>0]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}while(0);q=a[j>>0]|0;if(!(q&1))s=(q&255)>>>1;else s=c[j+4>>2]|0;if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){if((c[h>>2]|0)==(b|0)){t=h;break}h=h+4|0;if((h|0)==(k|0)){t=k;break}}k=t-m|0;m=k>>2;if((k|0)>92){r=-1;i=n;return r|0}if((d|0)==10|(d|0)==8){if((m|0)>=(d|0)){r=-1;i=n;return r|0}}else if((d|0)==16?(k|0)>=88:0){if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+-1>>0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;e=a[3653312+m>>0]|0;c[f>>2]=o+1;a[o>>0]=e;r=0;i=n;return r|0}e=a[3653312+m>>0]|0;c[f>>2]=o+1;a[o>>0]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function kui(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;dsi(h,d);d=Kxi(h,3654800)|0;kn[c[(c[d>>2]|0)+32>>2]&511](d,3653312,3653338|0,e)|0;e=Kxi(h,3654944)|0;a[f>>0]=mo[c[(c[e>>2]|0)+16>>2]&4095](e)|0;In[c[(c[e>>2]|0)+20>>2]&4095](b,e);$qi(c[h>>2]|0)|0;i=g;return}function lui(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;i=i+16|0;j=h;dsi(j,d);d=Kxi(j,3654800)|0;kn[c[(c[d>>2]|0)+32>>2]&511](d,3653312,3653344|0,e)|0;e=Kxi(j,3654944)|0;a[f>>0]=mo[c[(c[e>>2]|0)+12>>2]&4095](e)|0;a[g>>0]=mo[c[(c[e>>2]|0)+16>>2]&4095](e)|0;In[c[(c[e>>2]|0)+20>>2]&4095](b,e);$qi(c[j>>2]|0)|0;i=h;return}function mui(b,e,f,g,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0;q=i;if(b<<24>>24==j<<24>>24){if(!(a[e>>0]|0)){r=-1;i=q;return r|0}a[e>>0]=0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=46;j=a[l>>0]|0;if(!(j&1))s=(j&255)>>>1;else s=c[l+4>>2]|0;if(!s){r=0;i=q;return r|0}s=c[n>>2]|0;if((s-m|0)>=160){r=0;i=q;return r|0}j=c[o>>2]|0;c[n>>2]=s+4;c[s>>2]=j;r=0;i=q;return r|0}if(b<<24>>24==k<<24>>24){k=a[l>>0]|0;if(!(k&1))t=(k&255)>>>1;else t=c[l+4>>2]|0;if(t){if(!(a[e>>0]|0)){r=-1;i=q;return r|0}t=c[n>>2]|0;if((t-m|0)>=160){r=0;i=q;return r|0}k=c[o>>2]|0;c[n>>2]=t+4;c[t>>2]=k;c[o>>2]=0;r=0;i=q;return r|0}}k=p+32|0;t=p;while(1){if((a[t>>0]|0)==b<<24>>24){u=t;break}t=t+1|0;if((t|0)==(k|0)){u=k;break}}k=u-p|0;if((k|0)>31){r=-1;i=q;return r|0}p=a[3653312+k>>0]|0;if((k|0)==24|(k|0)==25){u=c[h>>2]|0;if((u|0)!=(g|0)?(d[u+-1>>0]&95|0)!=(d[f>>0]&127|0):0){r=-1;i=q;return r|0}c[h>>2]=u+1;a[u>>0]=p;r=0;i=q;return r|0}else if((k|0)==23|(k|0)==22){a[f>>0]=80;u=c[h>>2]|0;c[h>>2]=u+1;a[u>>0]=p;r=0;i=q;return r|0}else{u=p&95;if((u|0)==(a[f>>0]|0)?(a[f>>0]=u|128,(a[e>>0]|0)!=0):0){a[e>>0]=0;e=a[l>>0]|0;if(!(e&1))v=(e&255)>>>1;else v=c[l+4>>2]|0;if((v|0)!=0?(v=c[n>>2]|0,(v-m|0)<160):0){m=c[o>>2]|0;c[n>>2]=v+4;c[v>>2]=m}}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=p;if((k|0)>21){r=0;i=q;return r|0}c[o>>2]=(c[o>>2]|0)+1;r=0;i=q;return r|0}return 0}function nui(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;dsi(g,b);b=Kxi(g,3654792)|0;kn[c[(c[b>>2]|0)+48>>2]&511](b,3653312,3653338|0,d)|0;d=Kxi(g,3654952)|0;c[e>>2]=mo[c[(c[d>>2]|0)+16>>2]&4095](d)|0;In[c[(c[d>>2]|0)+20>>2]&4095](a,d);$qi(c[g>>2]|0)|0;i=f;return}function oui(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;dsi(h,b);b=Kxi(h,3654792)|0;kn[c[(c[b>>2]|0)+48>>2]&511](b,3653312,3653344|0,d)|0;d=Kxi(h,3654952)|0;c[e>>2]=mo[c[(c[d>>2]|0)+12>>2]&4095](d)|0;c[f>>2]=mo[c[(c[d>>2]|0)+16>>2]&4095](d)|0;In[c[(c[d>>2]|0)+20>>2]&4095](a,d);$qi(c[h>>2]|0)|0;i=g;return}function pui(b,e,f,g,h,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0;q=i;if((b|0)==(j|0)){if(!(a[e>>0]|0)){r=-1;i=q;return r|0}a[e>>0]=0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=46;j=a[l>>0]|0;if(!(j&1))s=(j&255)>>>1;else s=c[l+4>>2]|0;if(!s){r=0;i=q;return r|0}s=c[n>>2]|0;if((s-m|0)>=160){r=0;i=q;return r|0}j=c[o>>2]|0;c[n>>2]=s+4;c[s>>2]=j;r=0;i=q;return r|0}if((b|0)==(k|0)){k=a[l>>0]|0;if(!(k&1))t=(k&255)>>>1;else t=c[l+4>>2]|0;if(t){if(!(a[e>>0]|0)){r=-1;i=q;return r|0}t=c[n>>2]|0;if((t-m|0)>=160){r=0;i=q;return r|0}k=c[o>>2]|0;c[n>>2]=t+4;c[t>>2]=k;c[o>>2]=0;r=0;i=q;return r|0}}k=p+128|0;t=p;while(1){if((c[t>>2]|0)==(b|0)){u=t;break}t=t+4|0;if((t|0)==(k|0)){u=k;break}}k=u-p|0;p=k>>2;if((k|0)>124){r=-1;i=q;return r|0}u=a[3653312+p>>0]|0;if((p|0)==24|(p|0)==25){t=c[h>>2]|0;if((t|0)!=(g|0)?(d[t+-1>>0]&95|0)!=(d[f>>0]&127|0):0){r=-1;i=q;return r|0}c[h>>2]=t+1;a[t>>0]=u;r=0;i=q;return r|0}else if(!((p|0)==23|(p|0)==22)){p=u&95;if((p|0)==(a[f>>0]|0)?(a[f>>0]=p|128,(a[e>>0]|0)!=0):0){a[e>>0]=0;e=a[l>>0]|0;if(!(e&1))v=(e&255)>>>1;else v=c[l+4>>2]|0;if((v|0)!=0?(v=c[n>>2]|0,(v-m|0)<160):0){m=c[o>>2]|0;c[n>>2]=v+4;c[v>>2]=m}}}else a[f>>0]=80;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=u;if((k|0)>84){r=0;i=q;return r|0}c[o>>2]=(c[o>>2]|0)+1;r=0;i=q;return r|0}function qui(a){a=a|0;return}function rui(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function sui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+32|0;k=j+20|0;l=j+16|0;m=j+12|0;n=j;if(!(c[f+4>>2]&1)){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];rn[o&127](b,d,k,f,g,h&1);i=j;return}dsi(m,f);f=Kxi(m,3654944)|0;$qi(c[m>>2]|0)|0;m=c[f>>2]|0;if(h)In[c[m+24>>2]&4095](n,f);else In[c[m+28>>2]&4095](n,f);f=a[n>>0]|0;if(!(f&1)){m=n+1|0;p=m;q=m;r=n+8|0}else{m=n+8|0;p=c[m>>2]|0;q=n+1|0;r=m}m=n+4|0;h=f;f=p;while(1){if(!(h&1)){s=q;t=(h&255)>>>1}else{s=c[r>>2]|0;t=c[m>>2]|0}if((f|0)==(s+t|0))break;p=a[f>>0]|0;g=c[e>>2]|0;do if(g){k=g+24|0;d=c[k>>2]|0;if((d|0)!=(c[g+28>>2]|0)){c[k>>2]=d+1;a[d>>0]=p;break}if((_n[c[(c[g>>2]|0)+52>>2]&4095](g,p&255)|0)==-1)c[e>>2]=0}while(0);h=a[n>>0]|0;f=f+1|0}c[b>>2]=c[e>>2];xri(n);i=j;return}function tui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+64|0;j=d;k=d+20|0;l=d+28|0;m=d+40|0;n=d+12|0;o=d+4|0;p=d+8|0;q=d+16|0;a[k+0>>0]=a[3653592]|0;a[k+1>>0]=a[3653593]|0;a[k+2>>0]=a[3653594]|0;a[k+3>>0]=a[3653595]|0;a[k+4>>0]=a[3653596]|0;a[k+5>>0]=a[3653597]|0;uui(k+1|0,3653496,1,c[f+4>>2]|0);r=Xti()|0;c[j>>2]=h;h=l+(dAi(l,12,r,k,j)|0)|0;k=vui(l,h,f)|0;dsi(p,f);wui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[e>>2];e=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];KP(b,j,m,e,n,f,g);i=d;return}function uui(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(!(e&2048))g=b;else{a[b>>0]=43;g=b+1|0}if(!(e&512))h=g;else{a[g>>0]=35;h=g+1|0}g=a[c>>0]|0;if(!(g<<24>>24))j=h;else{b=c;c=h;h=g;while(1){b=b+1|0;g=c+1|0;a[c>>0]=h;h=a[b>>0]|0;if(!(h<<24>>24)){j=g;break}else c=g}}c=e&74;if((c|0)==8)if(!(e&16384)){a[j>>0]=120;i=f;return}else{a[j>>0]=88;i=f;return}else if((c|0)!=64)if(d){a[j>>0]=100;i=f;return}else{a[j>>0]=117;i=f;return}else{a[j>>0]=111;i=f;return}}function vui(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[e+4>>2]&176;do if((g|0)==16){e=a[b>>0]|0;if(e<<24>>24==43|e<<24>>24==45){h=b+1|0;break}if((d-b|0)>1&e<<24>>24==48?(e=a[b+1>>0]|0,e<<24>>24==88|e<<24>>24==120):0)h=b+2|0;else j=7}else if((g|0)==32)h=d;else j=7;while(0);if((j|0)==7)h=b;i=f;return h|0}function wui(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;i=i+16|0;l=k;m=Kxi(j,3654800)|0;n=Kxi(j,3654944)|0;In[c[(c[n>>2]|0)+20>>2]&4095](l,n);j=a[l>>0]|0;if(!(j&1))o=(j&255)>>>1;else o=c[l+4>>2]|0;if(o){c[h>>2]=f;o=a[b>>0]|0;if(o<<24>>24==43|o<<24>>24==45){j=_n[c[(c[m>>2]|0)+28>>2]&4095](m,o)|0;o=c[h>>2]|0;c[h>>2]=o+1;a[o>>0]=j;p=b+1|0}else p=b;if(((e-p|0)>1?(a[p>>0]|0)==48:0)?(j=p+1|0,o=a[j>>0]|0,o<<24>>24==88|o<<24>>24==120):0){o=_n[c[(c[m>>2]|0)+28>>2]&4095](m,48)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=o;o=_n[c[(c[m>>2]|0)+28>>2]&4095](m,a[j>>0]|0)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=o;r=p+2|0}else r=p;if((r|0)!=(e|0)?(p=e+-1|0,p>>>0>r>>>0):0){o=r;j=p;p=e;while(1){q=a[o>>0]|0;a[o>>0]=a[j>>0]|0;a[j>>0]=q;o=o+1|0;q=p+-2|0;if(o>>>0>=q>>>0)break;else{s=j;j=q;p=s}}}p=mo[c[(c[n>>2]|0)+16>>2]&4095](n)|0;if(r>>>0<e>>>0){n=l+1|0;j=l+4|0;o=l+8|0;s=0;q=0;t=r;while(1){u=(a[l>>0]&1)==0;if((a[(u?n:c[o>>2]|0)+q>>0]|0)!=0?(s|0)==(a[(u?n:c[o>>2]|0)+q>>0]|0):0){u=c[h>>2]|0;c[h>>2]=u+1;a[u>>0]=p;u=a[l>>0]|0;if(!(u&1))v=(u&255)>>>1;else v=c[j>>2]|0;w=0;x=(q>>>0<(v+-1|0)>>>0&1)+q|0}else{w=s;x=q}u=_n[c[(c[m>>2]|0)+28>>2]&4095](m,a[t>>0]|0)|0;y=c[h>>2]|0;c[h>>2]=y+1;a[y>>0]=u;t=t+1|0;if(t>>>0>=e>>>0)break;else{s=w+1|0;q=x}}}x=f+(r-b)|0;r=c[h>>2]|0;if((x|0)!=(r|0)?(q=r+-1|0,q>>>0>x>>>0):0){w=x;x=q;q=r;while(1){r=a[w>>0]|0;a[w>>0]=a[x>>0]|0;a[x>>0]=r;w=w+1|0;r=q+-2|0;if(w>>>0>=r>>>0)break;else{s=x;x=r;q=s}}}}else{kn[c[(c[m>>2]|0)+32>>2]&511](m,b,e,f)|0;c[h>>2]=f+(e-b)}if((d|0)==(e|0)){z=c[h>>2]|0;c[g>>2]=z;xri(l);i=k;return}else{z=f+(d-b)|0;c[g>>2]=z;xri(l);i=k;return}}function xui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+96|0;j=b;k=b+8|0;l=b+32|0;m=b+54|0;n=b+16|0;o=b+24|0;p=b+20|0;q=b+28|0;r=k;c[r>>2]=37;c[r+4>>2]=0;uui(k+1|0,3653504,1,c[e+4>>2]|0);r=Xti()|0;s=j;c[s>>2]=g;c[s+4>>2]=h;h=l+(dAi(l,22,r,k,j)|0)|0;k=vui(l,h,e)|0;dsi(p,e);wui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[d>>2];d=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];KP(a,j,m,d,n,e,f);i=b;return}function yui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+64|0;j=d;k=d+20|0;l=d+28|0;m=d+40|0;n=d+12|0;o=d+4|0;p=d+8|0;q=d+16|0;a[k+0>>0]=a[3653592]|0;a[k+1>>0]=a[3653593]|0;a[k+2>>0]=a[3653594]|0;a[k+3>>0]=a[3653595]|0;a[k+4>>0]=a[3653596]|0;a[k+5>>0]=a[3653597]|0;uui(k+1|0,3653496,0,c[f+4>>2]|0);r=Xti()|0;c[j>>2]=h;h=l+(dAi(l,12,r,k,j)|0)|0;k=vui(l,h,f)|0;dsi(p,f);wui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[e>>2];e=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];KP(b,j,m,e,n,f,g);i=d;return}function zui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+112|0;j=b;k=b+8|0;l=b+32|0;m=b+55|0;n=b+16|0;o=b+24|0;p=b+20|0;q=b+28|0;r=k;c[r>>2]=37;c[r+4>>2]=0;uui(k+1|0,3653504,0,c[e+4>>2]|0);r=Xti()|0;s=j;c[s>>2]=g;c[s+4>>2]=h;h=l+(dAi(l,23,r,k,j)|0)|0;k=vui(l,h,e)|0;dsi(p,e);wui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[d>>2];d=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];KP(a,j,m,d,n,e,f);i=b;return}function Aui(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=i;i=i+144|0;j=b+8|0;l=b;m=b+44|0;n=b+36|0;o=b+74|0;p=b+20|0;q=b+32|0;r=b+28|0;s=b+24|0;t=b+40|0;u=l;c[u>>2]=37;c[u+4>>2]=0;u=Bui(l+1|0,3653512,c[e+4>>2]|0)|0;c[n>>2]=m;v=Xti()|0;if(u){c[j>>2]=c[e+8>>2];u=j+4|0;h[k>>3]=g;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];w=dAi(m,30,v,l,j)|0}else{h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];w=dAi(m,30,v,l,j)|0}if((w|0)>29){v=Xti()|0;c[j>>2]=c[e+8>>2];u=j+4|0;h[k>>3]=g;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=eAi(n,v,l,j)|0;l=c[n>>2]|0;if(!l)uDi();else{x=l;y=l;z=u}}else{x=c[n>>2]|0;y=0;z=w}w=x+z|0;n=vui(x,w,e)|0;if((x|0)!=(m|0)){u=ADi(z<<1)|0;if(!u)uDi();else{A=x;B=u;C=u}}else{A=m;B=0;C=o}dsi(r,e);Cui(A,n,w,C,p,q,r);$qi(c[r>>2]|0)|0;c[t>>2]=c[d>>2];r=c[p>>2]|0;p=c[q>>2]|0;c[j+0>>2]=c[t+0>>2];KP(s,j,C,r,p,e,f);f=c[s>>2]|0;c[d>>2]=f;c[a>>2]=f;if(B)BDi(B);if(!y){i=b;return}BDi(y);i=b;return}function Bui(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;if(!(d&2048))f=b;else{a[b>>0]=43;f=b+1|0}if(!(d&1024))g=f;else{a[f>>0]=35;g=f+1|0}f=d&260;b=d>>>14;d=(f|0)==260;if(d){h=g;j=0}else{a[g>>0]=46;a[g+1>>0]=42;h=g+2|0;j=1}g=a[c>>0]|0;if(!(g<<24>>24))k=h;else{l=c;c=h;h=g;while(1){l=l+1|0;g=c+1|0;a[c>>0]=h;h=a[l>>0]|0;if(!(h<<24>>24)){k=g;break}else c=g}}do if((f|0)==256)if(!(b&1)){a[k>>0]=101;break}else{a[k>>0]=69;break}else if((f|0)==4)if(!(b&1)){a[k>>0]=102;break}else{a[k>>0]=70;break}else{c=(b&1|0)!=0;if(d)if(c){a[k>>0]=65;break}else{a[k>>0]=97;break}else if(c){a[k>>0]=71;break}else{a[k>>0]=103;break}}while(0);i=e;return j|0}function Cui(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+16|0;l=k;m=Kxi(j,3654800)|0;n=Kxi(j,3654944)|0;In[c[(c[n>>2]|0)+20>>2]&4095](l,n);c[h>>2]=f;j=a[b>>0]|0;if(j<<24>>24==43|j<<24>>24==45){o=_n[c[(c[m>>2]|0)+28>>2]&4095](m,j)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=o;p=b+1|0}else p=b;o=e;a:do if(((o-p|0)>1?(a[p>>0]|0)==48:0)?(j=p+1|0,q=a[j>>0]|0,q<<24>>24==88|q<<24>>24==120):0){q=_n[c[(c[m>>2]|0)+28>>2]&4095](m,48)|0;r=c[h>>2]|0;c[h>>2]=r+1;a[r>>0]=q;q=p+2|0;r=_n[c[(c[m>>2]|0)+28>>2]&4095](m,a[j>>0]|0)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=r;if(q>>>0<e>>>0){r=q;while(1){j=a[r>>0]|0;s=r+1|0;if(!(SBi(j<<24>>24,Xti()|0)|0)){t=q;u=r;break a}if(s>>>0<e>>>0)r=s;else{t=q;u=s;break}}}else{t=q;u=q}}else v=4;while(0);b:do if((v|0)==4)if(p>>>0<e>>>0){r=p;while(1){s=a[r>>0]|0;j=r+1|0;if(!(RBi(s<<24>>24,Xti()|0)|0)){t=p;u=r;break b}if(j>>>0<e>>>0)r=j;else{t=p;u=j;break}}}else{t=p;u=p}while(0);p=a[l>>0]|0;if(!(p&1))w=(p&255)>>>1;else w=c[l+4>>2]|0;if(w){if((t|0)!=(u|0)?(w=u+-1|0,w>>>0>t>>>0):0){p=t;v=w;w=u;while(1){r=a[p>>0]|0;a[p>>0]=a[v>>0]|0;a[v>>0]=r;p=p+1|0;r=w+-2|0;if(p>>>0>=r>>>0)break;else{q=v;v=r;w=q}}}w=mo[c[(c[n>>2]|0)+16>>2]&4095](n)|0;if(t>>>0<u>>>0){v=l+1|0;p=l+4|0;q=l+8|0;r=0;j=0;s=t;while(1){x=(a[l>>0]&1)==0;if((a[(x?v:c[q>>2]|0)+j>>0]|0)>0?(r|0)==(a[(x?v:c[q>>2]|0)+j>>0]|0):0){x=c[h>>2]|0;c[h>>2]=x+1;a[x>>0]=w;x=a[l>>0]|0;if(!(x&1))y=(x&255)>>>1;else y=c[p>>2]|0;z=0;A=(j>>>0<(y+-1|0)>>>0&1)+j|0}else{z=r;A=j}x=_n[c[(c[m>>2]|0)+28>>2]&4095](m,a[s>>0]|0)|0;B=c[h>>2]|0;c[h>>2]=B+1;a[B>>0]=x;s=s+1|0;if(s>>>0>=u>>>0)break;else{r=z+1|0;j=A}}}A=f+(t-b)|0;j=c[h>>2]|0;if((A|0)!=(j|0)?(z=j+-1|0,z>>>0>A>>>0):0){r=A;A=z;z=j;while(1){j=a[r>>0]|0;a[r>>0]=a[A>>0]|0;a[A>>0]=j;r=r+1|0;j=z+-2|0;if(r>>>0>=j>>>0)break;else{s=A;A=j;z=s}}}}else{kn[c[(c[m>>2]|0)+32>>2]&511](m,t,u,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(u-t)}c:do if(u>>>0<e>>>0){t=u;while(1){z=a[t>>0]|0;if(z<<24>>24==46){C=t;break}A=_n[c[(c[m>>2]|0)+28>>2]&4095](m,z)|0;z=c[h>>2]|0;c[h>>2]=z+1;a[z>>0]=A;A=t+1|0;if(A>>>0<e>>>0)t=A;else{D=A;break c}}t=mo[c[(c[n>>2]|0)+12>>2]&4095](n)|0;A=c[h>>2]|0;c[h>>2]=A+1;a[A>>0]=t;D=C+1|0}else D=u;while(0);kn[c[(c[m>>2]|0)+32>>2]&511](m,D,e,c[h>>2]|0)|0;m=(c[h>>2]|0)+(o-D)|0;c[h>>2]=m;if((d|0)==(e|0)){E=m;c[g>>2]=E;xri(l);i=k;return}E=f+(d-b)|0;c[g>>2]=E;xri(l);i=k;return}function Dui(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+144|0;j=b+8|0;l=b;m=b+44|0;n=b+36|0;o=b+74|0;p=b+20|0;q=b+32|0;r=b+28|0;s=b+24|0;t=b+40|0;u=l;c[u>>2]=37;c[u+4>>2]=0;u=Bui(l+1|0,3653520,c[e+4>>2]|0)|0;c[n>>2]=m;v=Xti()|0;if(u){c[j>>2]=c[e+8>>2];w=j+4|0;h[k>>3]=g;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];x=dAi(m,30,v,l,j)|0}else{h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];x=dAi(m,30,v,l,j)|0}if((x|0)>29){v=Xti()|0;if(u){c[j>>2]=c[e+8>>2];u=j+4|0;h[k>>3]=g;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];y=eAi(n,v,l,j)|0}else{h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];y=eAi(n,v,l,j)|0}l=c[n>>2]|0;if(!l)uDi();else{z=l;A=l;B=y}}else{z=c[n>>2]|0;A=0;B=x}x=z+B|0;n=vui(z,x,e)|0;if((z|0)!=(m|0)){y=ADi(B<<1)|0;if(!y)uDi();else{C=z;D=y;E=y}}else{C=m;D=0;E=o}dsi(r,e);Cui(C,n,x,E,p,q,r);$qi(c[r>>2]|0)|0;c[t>>2]=c[d>>2];d=c[p>>2]|0;p=c[q>>2]|0;c[j+0>>2]=c[t+0>>2];KP(s,j,E,d,p,e,f);c[a>>2]=c[s>>2];BDi(D);BDi(A);i=b;return}function Eui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+80|0;j=d;k=d+72|0;l=d+52|0;m=d+12|0;n=d+8|0;o=d+4|0;a[k+0>>0]=a[3653600]|0;a[k+1>>0]=a[3653601]|0;a[k+2>>0]=a[3653602]|0;a[k+3>>0]=a[3653603]|0;a[k+4>>0]=a[3653604]|0;a[k+5>>0]=a[3653605]|0;p=Xti()|0;c[j>>2]=h;h=dAi(l,20,p,k,j)|0;k=l+h|0;p=vui(l,k,f)|0;dsi(n,f);q=Kxi(n,3654800)|0;$qi(c[n>>2]|0)|0;kn[c[(c[q>>2]|0)+32>>2]&511](q,l,k,m)|0;q=m+h|0;if((p|0)==(k|0))r=q;else r=m+(p-l)|0;c[o>>2]=c[e>>2];c[j+0>>2]=c[o+0>>2];KP(b,j,m,r,q,f,g);i=d;return}function Fui(a){a=a|0;return}function Gui(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Hui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+32|0;k=j+20|0;l=j+16|0;m=j+12|0;n=j;if(!(c[f+4>>2]&1)){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];c[k+0>>2]=c[l+0>>2];rn[o&127](b,d,k,f,g,h&1);i=j;return}dsi(m,f);f=Kxi(m,3654952)|0;$qi(c[m>>2]|0)|0;m=c[f>>2]|0;if(h)In[c[m+24>>2]&4095](n,f);else In[c[m+28>>2]&4095](n,f);f=a[n>>0]|0;if(!(f&1)){m=n+4|0;p=m;q=n+8|0;r=m}else{m=n+8|0;p=c[m>>2]|0;q=m;r=n+4|0}m=f;f=p;while(1){if(!(m&1)){s=r;t=(m&255)>>>1}else{s=c[q>>2]|0;t=c[r>>2]|0}if((f|0)==(s+(t<<2)|0))break;p=c[f>>2]|0;h=c[e>>2]|0;if(h){g=h+24|0;k=c[g>>2]|0;if((k|0)==(c[h+28>>2]|0))u=_n[c[(c[h>>2]|0)+52>>2]&4095](h,p)|0;else{c[g>>2]=k+4;c[k>>2]=p;u=p}if((u|0)==-1)c[e>>2]=0}m=a[n>>0]|0;f=f+4|0}c[b>>2]=c[e>>2];Tri(n);i=j;return}function Iui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+128|0;j=d;k=d+104|0;l=d+112|0;m=d+8|0;n=d+4|0;o=d+96|0;p=d+92|0;q=d+100|0;a[k+0>>0]=a[3653592]|0;a[k+1>>0]=a[3653593]|0;a[k+2>>0]=a[3653594]|0;a[k+3>>0]=a[3653595]|0;a[k+4>>0]=a[3653596]|0;a[k+5>>0]=a[3653597]|0;uui(k+1|0,3653496,1,c[f+4>>2]|0);r=Xti()|0;c[j>>2]=h;h=l+(dAi(l,12,r,k,j)|0)|0;k=vui(l,h,f)|0;dsi(p,f);Jui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[e>>2];e=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];fAi(b,j,m,e,n,f,g);i=d;return}function Jui(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;k=i;i=i+16|0;l=k;m=Kxi(j,3654792)|0;n=Kxi(j,3654952)|0;In[c[(c[n>>2]|0)+20>>2]&4095](l,n);j=a[l>>0]|0;if(!(j&1))o=(j&255)>>>1;else o=c[l+4>>2]|0;if(o){c[h>>2]=f;o=a[b>>0]|0;if(o<<24>>24==43|o<<24>>24==45){j=_n[c[(c[m>>2]|0)+44>>2]&4095](m,o)|0;o=c[h>>2]|0;c[h>>2]=o+4;c[o>>2]=j;p=b+1|0}else p=b;if(((e-p|0)>1?(a[p>>0]|0)==48:0)?(j=p+1|0,o=a[j>>0]|0,o<<24>>24==88|o<<24>>24==120):0){o=_n[c[(c[m>>2]|0)+44>>2]&4095](m,48)|0;q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=o;o=_n[c[(c[m>>2]|0)+44>>2]&4095](m,a[j>>0]|0)|0;j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=o;r=p+2|0}else r=p;if((r|0)!=(e|0)?(p=e+-1|0,p>>>0>r>>>0):0){o=r;j=p;p=e;while(1){q=a[o>>0]|0;a[o>>0]=a[j>>0]|0;a[j>>0]=q;o=o+1|0;q=p+-2|0;if(o>>>0>=q>>>0)break;else{s=j;j=q;p=s}}}p=mo[c[(c[n>>2]|0)+16>>2]&4095](n)|0;if(r>>>0<e>>>0){n=l+1|0;j=l+4|0;o=l+8|0;s=0;q=0;t=r;while(1){u=(a[l>>0]&1)==0;if((a[(u?n:c[o>>2]|0)+q>>0]|0)!=0?(s|0)==(a[(u?n:c[o>>2]|0)+q>>0]|0):0){u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=p;u=a[l>>0]|0;if(!(u&1))v=(u&255)>>>1;else v=c[j>>2]|0;w=0;x=(q>>>0<(v+-1|0)>>>0&1)+q|0}else{w=s;x=q}u=_n[c[(c[m>>2]|0)+44>>2]&4095](m,a[t>>0]|0)|0;y=c[h>>2]|0;z=y+4|0;c[h>>2]=z;c[y>>2]=u;t=t+1|0;if(t>>>0>=e>>>0){A=z;break}else{s=w+1|0;q=x}}}else A=c[h>>2]|0;x=f+(r-b<<2)|0;if((x|0)!=(A|0)?(r=A+-4|0,r>>>0>x>>>0):0){q=x;x=r;r=A;while(1){w=c[q>>2]|0;c[q>>2]=c[x>>2];c[x>>2]=w;q=q+4|0;w=r+-8|0;if(q>>>0>=w>>>0){B=A;break}else{s=x;x=w;r=s}}}else B=A}else{kn[c[(c[m>>2]|0)+48>>2]&511](m,b,e,f)|0;m=f+(e-b<<2)|0;c[h>>2]=m;B=m}if((d|0)==(e|0)){C=B;c[g>>2]=C;xri(l);i=k;return}C=f+(d-b<<2)|0;c[g>>2]=C;xri(l);i=k;return}function Kui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+224|0;j=b;k=b+8|0;l=b+196|0;m=b+24|0;n=b+20|0;o=b+16|0;p=b+188|0;q=b+192|0;r=k;c[r>>2]=37;c[r+4>>2]=0;uui(k+1|0,3653504,1,c[e+4>>2]|0);r=Xti()|0;s=j;c[s>>2]=g;c[s+4>>2]=h;h=l+(dAi(l,22,r,k,j)|0)|0;k=vui(l,h,e)|0;dsi(p,e);Jui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[d>>2];d=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];fAi(a,j,m,d,n,e,f);i=b;return}function Lui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+128|0;j=d;k=d+104|0;l=d+112|0;m=d+8|0;n=d+4|0;o=d+96|0;p=d+92|0;q=d+100|0;a[k+0>>0]=a[3653592]|0;a[k+1>>0]=a[3653593]|0;a[k+2>>0]=a[3653594]|0;a[k+3>>0]=a[3653595]|0;a[k+4>>0]=a[3653596]|0;a[k+5>>0]=a[3653597]|0;uui(k+1|0,3653496,0,c[f+4>>2]|0);r=Xti()|0;c[j>>2]=h;h=l+(dAi(l,12,r,k,j)|0)|0;k=vui(l,h,f)|0;dsi(p,f);Jui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[e>>2];e=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];fAi(b,j,m,e,n,f,g);i=d;return}function Mui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+240|0;j=b;k=b+8|0;l=b+204|0;m=b+24|0;n=b+20|0;o=b+16|0;p=b+196|0;q=b+200|0;r=k;c[r>>2]=37;c[r+4>>2]=0;uui(k+1|0,3653504,0,c[e+4>>2]|0);r=Xti()|0;s=j;c[s>>2]=g;c[s+4>>2]=h;h=l+(dAi(l,23,r,k,j)|0)|0;k=vui(l,h,e)|0;dsi(p,e);Jui(l,k,h,m,n,o,p);$qi(c[p>>2]|0)|0;c[q>>2]=c[d>>2];d=c[n>>2]|0;n=c[o>>2]|0;c[j+0>>2]=c[q+0>>2];fAi(a,j,m,d,n,e,f);i=b;return}function Nui(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=i;i=i+320|0;j=b;l=b+16|0;m=b+276|0;n=b+36|0;o=b+44|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+28|0;t=b+272|0;u=l;c[u>>2]=37;c[u+4>>2]=0;u=Bui(l+1|0,3653512,c[e+4>>2]|0)|0;c[n>>2]=m;v=Xti()|0;if(u){c[j>>2]=c[e+8>>2];u=j+4|0;h[k>>3]=g;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];w=dAi(m,30,v,l,j)|0}else{h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];w=dAi(m,30,v,l,j)|0}if((w|0)>29){v=Xti()|0;c[j>>2]=c[e+8>>2];u=j+4|0;h[k>>3]=g;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=eAi(n,v,l,j)|0;l=c[n>>2]|0;if(!l)uDi();else{x=l;y=l;z=u}}else{x=c[n>>2]|0;y=0;z=w}w=x+z|0;n=vui(x,w,e)|0;if((x|0)!=(m|0)){u=ADi(z<<3)|0;if(!u)uDi();else{A=x;B=u;C=u}}else{A=m;B=0;C=o}dsi(r,e);Oui(A,n,w,C,p,q,r);$qi(c[r>>2]|0)|0;c[t>>2]=c[d>>2];r=c[p>>2]|0;p=c[q>>2]|0;c[j+0>>2]=c[t+0>>2];fAi(s,j,C,r,p,e,f);f=c[s>>2]|0;c[d>>2]=f;c[a>>2]=f;if(!B){BDi(y);i=b;return}BDi(B);BDi(y);i=b;return}function Oui(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+16|0;l=k;m=Kxi(j,3654792)|0;n=Kxi(j,3654952)|0;In[c[(c[n>>2]|0)+20>>2]&4095](l,n);c[h>>2]=f;j=a[b>>0]|0;if(j<<24>>24==43|j<<24>>24==45){o=_n[c[(c[m>>2]|0)+44>>2]&4095](m,j)|0;j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=o;p=b+1|0}else p=b;o=e;a:do if(((o-p|0)>1?(a[p>>0]|0)==48:0)?(j=p+1|0,q=a[j>>0]|0,q<<24>>24==88|q<<24>>24==120):0){q=_n[c[(c[m>>2]|0)+44>>2]&4095](m,48)|0;r=c[h>>2]|0;c[h>>2]=r+4;c[r>>2]=q;q=p+2|0;r=_n[c[(c[m>>2]|0)+44>>2]&4095](m,a[j>>0]|0)|0;j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=r;if(q>>>0<e>>>0){r=q;while(1){j=a[r>>0]|0;s=r+1|0;if(!(SBi(j<<24>>24,Xti()|0)|0)){t=q;u=r;break a}if(s>>>0<e>>>0)r=s;else{t=q;u=s;break}}}else{t=q;u=q}}else v=4;while(0);b:do if((v|0)==4)if(p>>>0<e>>>0){r=p;while(1){s=a[r>>0]|0;j=r+1|0;if(!(RBi(s<<24>>24,Xti()|0)|0)){t=p;u=r;break b}if(j>>>0<e>>>0)r=j;else{t=p;u=j;break}}}else{t=p;u=p}while(0);p=a[l>>0]|0;if(!(p&1))w=(p&255)>>>1;else w=c[l+4>>2]|0;if(w){if((t|0)!=(u|0)?(w=u+-1|0,w>>>0>t>>>0):0){p=t;v=w;w=u;while(1){r=a[p>>0]|0;a[p>>0]=a[v>>0]|0;a[v>>0]=r;p=p+1|0;r=w+-2|0;if(p>>>0>=r>>>0)break;else{q=v;v=r;w=q}}}w=mo[c[(c[n>>2]|0)+16>>2]&4095](n)|0;if(t>>>0<u>>>0){v=l+1|0;p=l+4|0;q=l+8|0;r=0;j=0;s=t;while(1){x=(a[l>>0]&1)==0;if((a[(x?v:c[q>>2]|0)+j>>0]|0)>0?(r|0)==(a[(x?v:c[q>>2]|0)+j>>0]|0):0){x=c[h>>2]|0;c[h>>2]=x+4;c[x>>2]=w;x=a[l>>0]|0;if(!(x&1))y=(x&255)>>>1;else y=c[p>>2]|0;z=0;A=(j>>>0<(y+-1|0)>>>0&1)+j|0}else{z=r;A=j}x=_n[c[(c[m>>2]|0)+44>>2]&4095](m,a[s>>0]|0)|0;B=c[h>>2]|0;C=B+4|0;c[h>>2]=C;c[B>>2]=x;s=s+1|0;if(s>>>0>=u>>>0){D=C;break}else{r=z+1|0;j=A}}}else D=c[h>>2]|0;A=f+(t-b<<2)|0;if((A|0)!=(D|0)?(j=D+-4|0,j>>>0>A>>>0):0){z=A;A=j;j=D;while(1){r=c[z>>2]|0;c[z>>2]=c[A>>2];c[A>>2]=r;z=z+4|0;r=j+-8|0;if(z>>>0>=r>>>0){E=D;break}else{s=A;A=r;j=s}}}else E=D}else{kn[c[(c[m>>2]|0)+48>>2]&511](m,t,u,c[h>>2]|0)|0;D=(c[h>>2]|0)+(u-t<<2)|0;c[h>>2]=D;E=D}c:do if(u>>>0<e>>>0){D=u;while(1){t=a[D>>0]|0;if(t<<24>>24==46){F=D;break}j=_n[c[(c[m>>2]|0)+44>>2]&4095](m,t)|0;t=c[h>>2]|0;A=t+4|0;c[h>>2]=A;c[t>>2]=j;j=D+1|0;if(j>>>0<e>>>0)D=j;else{G=A;H=j;break c}}D=mo[c[(c[n>>2]|0)+12>>2]&4095](n)|0;j=c[h>>2]|0;A=j+4|0;c[h>>2]=A;c[j>>2]=D;G=A;H=F+1|0}else{G=E;H=u}while(0);kn[c[(c[m>>2]|0)+48>>2]&511](m,H,e,G)|0;G=(c[h>>2]|0)+(o-H<<2)|0;c[h>>2]=G;if((d|0)==(e|0)){I=G;c[g>>2]=I;xri(l);i=k;return}I=f+(d-b<<2)|0;c[g>>2]=I;xri(l);i=k;return}function Pui(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+320|0;j=b;l=b+16|0;m=b+276|0;n=b+36|0;o=b+44|0;p=b+24|0;q=b+32|0;r=b+40|0;s=b+28|0;t=b+272|0;u=l;c[u>>2]=37;c[u+4>>2]=0;u=Bui(l+1|0,3653520,c[e+4>>2]|0)|0;c[n>>2]=m;v=Xti()|0;if(u){c[j>>2]=c[e+8>>2];w=j+4|0;h[k>>3]=g;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];x=dAi(m,30,v,l,j)|0}else{h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];x=dAi(m,30,v,l,j)|0}if((x|0)>29){v=Xti()|0;if(u){c[j>>2]=c[e+8>>2];u=j+4|0;h[k>>3]=g;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];y=eAi(n,v,l,j)|0}else{h[k>>3]=g;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];y=eAi(n,v,l,j)|0}l=c[n>>2]|0;if(!l)uDi();else{z=l;A=l;B=y}}else{z=c[n>>2]|0;A=0;B=x}x=z+B|0;n=vui(z,x,e)|0;if((z|0)!=(m|0)){y=ADi(B<<3)|0;if(!y)uDi();else{C=z;D=y;E=y}}else{C=m;D=0;E=o}dsi(r,e);Oui(C,n,x,E,p,q,r);$qi(c[r>>2]|0)|0;c[t>>2]=c[d>>2];r=c[p>>2]|0;p=c[q>>2]|0;c[j+0>>2]=c[t+0>>2];fAi(s,j,E,r,p,e,f);f=c[s>>2]|0;c[d>>2]=f;c[a>>2]=f;if(!D){BDi(A);i=b;return}BDi(D);BDi(A);i=b;return}function Qui(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+192|0;j=d;k=d+180|0;l=d+160|0;m=d+12|0;n=d+8|0;o=d+4|0;a[k+0>>0]=a[3653600]|0;a[k+1>>0]=a[3653601]|0;a[k+2>>0]=a[3653602]|0;a[k+3>>0]=a[3653603]|0;a[k+4>>0]=a[3653604]|0;a[k+5>>0]=a[3653605]|0;p=Xti()|0;c[j>>2]=h;h=dAi(l,20,p,k,j)|0;k=l+h|0;p=vui(l,k,f)|0;dsi(n,f);q=Kxi(n,3654792)|0;$qi(c[n>>2]|0)|0;kn[c[(c[q>>2]|0)+48>>2]&511](q,l,k,m)|0;q=m+(h<<2)|0;if((p|0)==(k|0))r=q;else r=m+(p-l<<2)|0;c[o>>2]=c[e>>2];c[j+0>>2]=c[o+0>>2];fAi(b,j,m,r,q,f,g);i=d;return}function Rui(e,f,g,h,j,k,l,m,n){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;o=i;i=i+32|0;p=o+20|0;q=o+16|0;r=o+12|0;s=o+8|0;t=o+4|0;u=o;dsi(r,j);v=Kxi(r,3654800)|0;$qi(c[r>>2]|0)|0;c[k>>2]=0;a:do if((m|0)!=(n|0)){r=v+8|0;w=m;b:while(1){x=c[g>>2]|0;if(x)if((c[x+12>>2]|0)==(c[x+16>>2]|0)?(mo[c[(c[x>>2]|0)+36>>2]&4095](x)|0)==-1:0){c[g>>2]=0;y=0}else y=x;else y=0;x=(y|0)==0;z=c[h>>2]|0;do if(z){if((c[z+12>>2]|0)==(c[z+16>>2]|0)?(mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0)==-1:0){c[h>>2]=0;A=13;break}if(x)B=z;else{C=y;A=14;break b}}else A=13;while(0);if((A|0)==13){A=0;if(x){C=y;A=14;break}else B=0}c:do if((xo[c[(c[v>>2]|0)+36>>2]&2047](v,a[w>>0]|0,0)|0)<<24>>24==37){z=w+1|0;if((z|0)==(n|0)){D=y;A=17;break b}E=xo[c[(c[v>>2]|0)+36>>2]&2047](v,a[z>>0]|0,0)|0;if(E<<24>>24==48|E<<24>>24==69){F=w+2|0;if((F|0)==(n|0)){G=y;A=20;break b}H=z;I=xo[c[(c[v>>2]|0)+36>>2]&2047](v,a[F>>0]|0,0)|0;J=E}else{H=w;I=E;J=0}E=c[(c[f>>2]|0)+36>>2]|0;c[t>>2]=y;c[u>>2]=B;c[q+0>>2]=c[t+0>>2];c[p+0>>2]=c[u+0>>2];Yn[E&15](s,f,q,p,j,k,l,I,J);E=c[s>>2]|0;c[g>>2]=E;K=H+2|0;L=E}else{E=a[w>>0]|0;if(E<<24>>24>-1?(F=c[r>>2]|0,(b[F+(E<<24>>24<<1)>>1]&8192)!=0):0){E=w;while(1){z=E+1|0;if((z|0)==(n|0)){M=n;break}N=a[z>>0]|0;if(N<<24>>24<=-1){M=z;break}if(!(b[F+(N<<24>>24<<1)>>1]&8192)){M=z;break}else E=z}E=y;F=B;z=y;N=B;while(1){if(E)if((c[E+12>>2]|0)==(c[E+16>>2]|0)?(mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0)==-1:0){c[g>>2]=0;O=0;P=0}else{O=z;P=E}else{O=z;P=0}Q=(P|0)==0;do if(N){if((c[N+12>>2]|0)!=(c[N+16>>2]|0))if(Q){R=F;S=N;break}else{K=M;L=O;break c}if((mo[c[(c[N>>2]|0)+36>>2]&4095](N)|0)!=-1)if(Q^(F|0)==0){R=F;S=F;break}else{K=M;L=O;break c}else{c[h>>2]=0;T=0;A=39;break}}else{T=F;A=39}while(0);if((A|0)==39){A=0;if(Q){K=M;L=O;break c}else{R=T;S=0}}U=P+12|0;V=c[U>>2]|0;W=P+16|0;if((V|0)==(c[W>>2]|0))X=mo[c[(c[P>>2]|0)+36>>2]&4095](P)|0;else X=d[V>>0]|0;if((X&255)<<24>>24<=-1){K=M;L=O;break c}if(!(b[(c[r>>2]|0)+(X<<24>>24<<1)>>1]&8192)){K=M;L=O;break c}V=c[U>>2]|0;if((V|0)==(c[W>>2]|0)){mo[c[(c[P>>2]|0)+40>>2]&4095](P)|0;E=P;F=R;z=O;N=S;continue}else{c[U>>2]=V+1;E=P;F=R;z=O;N=S;continue}}}N=y+12|0;z=c[N>>2]|0;F=y+16|0;if((z|0)==(c[F>>2]|0))Y=mo[c[(c[y>>2]|0)+36>>2]&4095](y)|0;else Y=d[z>>0]|0;z=_n[c[(c[v>>2]|0)+12>>2]&4095](v,Y&255)|0;if(z<<24>>24!=(_n[c[(c[v>>2]|0)+12>>2]&4095](v,a[w>>0]|0)|0)<<24>>24){Z=y;A=57;break b}z=c[N>>2]|0;if((z|0)==(c[F>>2]|0))mo[c[(c[y>>2]|0)+40>>2]&4095](y)|0;else c[N>>2]=z+1;K=w+1|0;L=y}while(0);if((K|0)!=(n|0)&(c[k>>2]|0)==0)w=K;else{_=L;break a}}if((A|0)==14){c[k>>2]=4;_=C;break}else if((A|0)==17){c[k>>2]=4;_=D;break}else if((A|0)==20){c[k>>2]=4;_=G;break}else if((A|0)==57){c[k>>2]=4;_=Z;break}}else _=c[g>>2]|0;while(0);if(_)if((c[_+12>>2]|0)==(c[_+16>>2]|0)?(mo[c[(c[_>>2]|0)+36>>2]&4095](_)|0)==-1:0){c[g>>2]=0;$=0}else $=_;else $=0;_=($|0)==0;g=c[h>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)?(mo[c[(c[g>>2]|0)+36>>2]&4095](g)|0)==-1:0){c[h>>2]=0;A=67;break}if(_){c[e>>2]=$;i=o;return}}else A=67;while(0);if((A|0)==67?!_:0){c[e>>2]=$;i=o;return}c[k>>2]=c[k>>2]|2;c[e>>2]=$;i=o;return}function Sui(a){a=a|0;return}function Tui(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Uui(a){a=a|0;return 2}function Vui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];Rui(a,b,l,k,f,g,h,3653704,3653712|0);i=j;return}function Wui(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+16|0;l=k+12|0;m=k+8|0;n=k+4|0;o=k;p=d+8|0;q=mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q>>0]|0;if(!(f&1)){r=q+1|0;s=(f&255)>>>1;t=q+1|0}else{f=c[q+8>>2]|0;r=f;s=c[q+4>>2]|0;t=f}c[m+0>>2]=c[n+0>>2];c[l+0>>2]=c[o+0>>2];Rui(b,d,m,l,g,h,j,t,r+s|0);i=k;return}function Xui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;dsi(l,f);f=Kxi(l,3654800)|0;$qi(c[l>>2]|0)|0;c[m>>2]=c[e>>2];c[k+0>>2]=c[m+0>>2];Yui(b,h+24|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function Yui(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=a+8|0;a=mo[c[c[l>>2]>>2]&4095](l)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];k=(Kzi(d,j,a,a+168|0,g,f,0)|0)-a|0;if((k|0)>=168){i=h;return}c[b>>2]=((k|0)/12|0|0)%7|0;i=h;return}function Zui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;dsi(l,f);f=Kxi(l,3654800)|0;$qi(c[l>>2]|0)|0;c[m>>2]=c[e>>2];c[k+0>>2]=c[m+0>>2];_ui(b,h+16|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function _ui(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=a+8|0;a=mo[c[(c[l>>2]|0)+4>>2]&4095](l)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];k=(Kzi(d,j,a,a+288|0,g,f,0)|0)-a|0;if((k|0)>=288){i=h;return}c[b>>2]=((k|0)/12|0|0)%12|0;i=h;return}function $ui(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;dsi(l,f);f=Kxi(l,3654800)|0;$qi(c[l>>2]|0)|0;c[m>>2]=c[e>>2];c[k+0>>2]=c[m+0>>2];avi(b,h+20|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function avi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,4)|0;if(c[f>>2]&4){i=a;return}if((j|0)<69)k=j+2e3|0;else k=(j+-69|0)>>>0<31?j+1900|0:j;c[b>>2]=k+-1900;i=a;return}function bvi(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;l=i;i=i+176|0;m=l+156|0;n=l+148|0;o=l+4|0;p=l+72|0;q=l+76|0;r=l;s=l+20|0;t=l+24|0;u=l+28|0;v=l+32|0;w=l+36|0;x=l+40|0;y=l+44|0;z=l+48|0;A=l+52|0;B=l+56|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+80|0;I=l+84|0;J=l+88|0;K=l+92|0;L=l+96|0;M=l+100|0;N=l+104|0;O=l+108|0;P=l+112|0;Q=l+116|0;R=l+12|0;S=l+120|0;T=l+60|0;U=l+124|0;V=l+16|0;W=l+64|0;X=l+132|0;Y=l+68|0;Z=l+140|0;_=l+8|0;c[h>>2]=0;dsi(o,g);$=Kxi(o,3654800)|0;$qi(c[o>>2]|0)|0;do switch(k<<24>>24|0){case 119:{c[S>>2]=c[f>>2];c[m+0>>2]=c[S+0>>2];lvi(d,j+24|0,e,m,h,$);break}case 88:{o=d+8|0;aa=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;c[W>>2]=c[e>>2];c[X>>2]=c[f>>2];o=a[aa>>0]|0;if(!(o&1)){ba=aa+1|0;ca=(o&255)>>>1;da=aa+1|0}else{o=c[aa+8>>2]|0;ba=o;ca=c[aa+4>>2]|0;da=o}c[n+0>>2]=c[W+0>>2];c[m+0>>2]=c[X+0>>2];Rui(V,d,n,m,g,h,j,da,ba+ca|0);c[e>>2]=c[V>>2];break}case 83:{c[O>>2]=c[f>>2];c[m+0>>2]=c[O+0>>2];kvi(d,j,e,m,h,$);break}case 84:{c[Q>>2]=c[e>>2];c[R>>2]=c[f>>2];c[n+0>>2]=c[Q+0>>2];c[m+0>>2]=c[R+0>>2];Rui(P,d,n,m,g,h,j,3653752,3653760|0);c[e>>2]=c[P>>2];break}case 109:{c[E>>2]=c[f>>2];c[m+0>>2]=c[E+0>>2];gvi(d,j+16|0,e,m,h,$);break}case 114:{c[J>>2]=c[e>>2];c[K>>2]=c[f>>2];c[n+0>>2]=c[J+0>>2];c[m+0>>2]=c[K+0>>2];Rui(I,d,n,m,g,h,j,3653728,3653739|0);c[e>>2]=c[I>>2];break}case 99:{o=d+8|0;aa=mo[c[(c[o>>2]|0)+12>>2]&4095](o)|0;c[s>>2]=c[e>>2];c[t>>2]=c[f>>2];o=a[aa>>0]|0;if(!(o&1)){ea=aa+1|0;fa=(o&255)>>>1;ga=aa+1|0}else{o=c[aa+8>>2]|0;ea=o;fa=c[aa+4>>2]|0;ga=o}c[n+0>>2]=c[s+0>>2];c[m+0>>2]=c[t+0>>2];Rui(r,d,n,m,g,h,j,ga,ea+fa|0);c[e>>2]=c[r>>2];break}case 104:case 66:case 98:{c[q>>2]=c[f>>2];c[m+0>>2]=c[q+0>>2];_ui(d,j+16|0,e,m,h,$);break}case 68:{c[w>>2]=c[e>>2];c[x>>2]=c[f>>2];c[n+0>>2]=c[w+0>>2];c[m+0>>2]=c[x+0>>2];Rui(v,d,n,m,g,h,j,3653712,3653720|0);c[e>>2]=c[v>>2];break}case 73:{c[C>>2]=c[f>>2];c[m+0>>2]=c[C+0>>2];evi(d,j+8|0,e,m,h,$);break}case 116:case 110:{c[G>>2]=c[f>>2];c[m+0>>2]=c[G+0>>2];ivi(d,e,m,h,$);break}case 112:{c[H>>2]=c[f>>2];c[m+0>>2]=c[H+0>>2];jvi(d,j+8|0,e,m,h,$);break}case 65:case 97:{c[p>>2]=c[f>>2];c[m+0>>2]=c[p+0>>2];Yui(d,j+24|0,e,m,h,$);break}case 77:{c[F>>2]=c[f>>2];c[m+0>>2]=c[F+0>>2];hvi(d,j+4|0,e,m,h,$);break}case 37:{c[_>>2]=c[f>>2];c[m+0>>2]=c[_+0>>2];nvi(d,e,m,h,$);break}case 106:{c[D>>2]=c[f>>2];c[m+0>>2]=c[D+0>>2];fvi(d,j+28|0,e,m,h,$);break}case 72:{c[B>>2]=c[f>>2];c[m+0>>2]=c[B+0>>2];dvi(d,j+8|0,e,m,h,$);break}case 70:{c[z>>2]=c[e>>2];c[A>>2]=c[f>>2];c[n+0>>2]=c[z+0>>2];c[m+0>>2]=c[A+0>>2];Rui(y,d,n,m,g,h,j,3653720,3653728|0);c[e>>2]=c[y>>2];break}case 101:case 100:{c[u>>2]=c[f>>2];c[m+0>>2]=c[u+0>>2];cvi(d,j+12|0,e,m,h,$);break}case 121:{c[Y>>2]=c[f>>2];c[m+0>>2]=c[Y+0>>2];avi(d,j+20|0,e,m,h,$);break}case 82:{c[M>>2]=c[e>>2];c[N>>2]=c[f>>2];c[n+0>>2]=c[M+0>>2];c[m+0>>2]=c[N+0>>2];Rui(L,d,n,m,g,h,j,3653744,3653749|0);c[e>>2]=c[L>>2];break}case 89:{c[Z>>2]=c[f>>2];c[m+0>>2]=c[Z+0>>2];mvi(d,j+20|0,e,m,h,$);break}case 120:{o=c[(c[d>>2]|0)+20>>2]|0;c[T>>2]=c[e>>2];c[U>>2]=c[f>>2];c[n+0>>2]=c[T+0>>2];c[m+0>>2]=c[U+0>>2];Wn[o&127](b,d,n,m,g,h,j);i=l;return}default:c[h>>2]=c[h>>2]|4}while(0);c[b>>2]=c[e>>2];i=l;return}function cvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)>0&(j|0)<32){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function dvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<24){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function evi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)>0&(j|0)<13){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function fvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,3)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<366){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function gvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<13){c[b>>2]=j+-1;i=a;return}else{c[f>>2]=g|4;i=a;return}}function hvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<60){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function ivi(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;j=h+8|0;a:while(1){h=c[e>>2]|0;do if(h)if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((mo[c[(c[h>>2]|0)+36>>2]&4095](h)|0)==-1){c[e>>2]=0;k=0;break}else{k=c[e>>2]|0;break}else k=h;else k=0;while(0);h=(k|0)==0;l=c[f>>2]|0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(h){m=l;break}else{n=l;break a}if((mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0)!=-1)if(h){m=l;break}else{n=l;break a}else{c[f>>2]=0;o=12;break}}else o=12;while(0);if((o|0)==12){o=0;if(h){n=0;break}else m=0}l=c[e>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0))q=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else q=d[p>>0]|0;if((q&255)<<24>>24<=-1){n=m;break}if(!(b[(c[j>>2]|0)+(q<<24>>24<<1)>>1]&8192)){n=m;break}p=c[e>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){mo[c[(c[p>>2]|0)+40>>2]&4095](p)|0;continue}else{c[l>>2]=r+1;continue}}m=c[e>>2]|0;do if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0))if((mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1){c[e>>2]=0;s=0;break}else{s=c[e>>2]|0;break}else s=m;else s=0;while(0);m=(s|0)==0;do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)?(mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0)==-1:0){c[f>>2]=0;o=32;break}if(m){i=a;return}}else o=32;while(0);if((o|0)==32?!m:0){i=a;return}c[g>>2]=c[g>>2]|2;i=a;return}function jvi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j+4|0;l=j;m=b+8|0;b=mo[c[(c[m>>2]|0)+8>>2]&4095](m)|0;m=a[b>>0]|0;if(!(m&1))n=(m&255)>>>1;else n=c[b+4>>2]|0;m=a[b+12>>0]|0;if(!(m&1))o=(m&255)>>>1;else o=c[b+16>>2]|0;if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];c[k+0>>2]=c[l+0>>2];l=Kzi(e,k,b,b+24|0,h,g,0)|0;g=c[d>>2]|0;if((l|0)==(b|0)&(g|0)==12){c[d>>2]=0;i=j;return}if(!((l-b|0)==12&(g|0)<12)){i=j;return}c[d>>2]=g+12;i=j;return}function kvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<61){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function lvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,1)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<7){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function mvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=gAi(d,h,f,g,4)|0;if(c[f>>2]&4){i=a;return}c[b>>2]=j+-1900;i=a;return}function nvi(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;h=c[b>>2]|0;do if(h)if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((mo[c[(c[h>>2]|0)+36>>2]&4095](h)|0)==-1){c[b>>2]=0;j=0;break}else{j=c[b>>2]|0;break}else j=h;else j=0;while(0);h=(j|0)==0;j=c[e>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(mo[c[(c[j>>2]|0)+36>>2]&4095](j)|0)==-1:0){c[e>>2]=0;k=11;break}if(h)l=j;else k=12}else k=11;while(0);if((k|0)==11)if(h)k=12;else l=0;if((k|0)==12){c[f>>2]=c[f>>2]|6;i=a;return}h=c[b>>2]|0;j=c[h+12>>2]|0;if((j|0)==(c[h+16>>2]|0))m=mo[c[(c[h>>2]|0)+36>>2]&4095](h)|0;else m=d[j>>0]|0;if((xo[c[(c[g>>2]|0)+36>>2]&2047](g,m&255,0)|0)<<24>>24!=37){c[f>>2]=c[f>>2]|4;i=a;return}m=c[b>>2]|0;g=m+12|0;j=c[g>>2]|0;if((j|0)==(c[m+16>>2]|0)){mo[c[(c[m>>2]|0)+40>>2]&4095](m)|0;n=c[b>>2]|0}else{c[g>>2]=j+1;n=m}do if(n)if((c[n+12>>2]|0)==(c[n+16>>2]|0))if((mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0)==-1){c[b>>2]=0;o=0;break}else{o=c[b>>2]|0;break}else o=n;else o=0;while(0);n=(o|0)==0;do if(l){if((c[l+12>>2]|0)==(c[l+16>>2]|0)?(mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0)==-1:0){c[e>>2]=0;k=31;break}if(n){i=a;return}}else k=31;while(0);if((k|0)==31?!n:0){i=a;return}c[f>>2]=c[f>>2]|2;i=a;return}function ovi(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+32|0;m=l+20|0;n=l+16|0;o=l+12|0;p=l+8|0;q=l+4|0;r=l;dsi(o,f);s=Kxi(o,3654792)|0;$qi(c[o>>2]|0)|0;c[g>>2]=0;a:do if((j|0)!=(k|0)){o=j;b:while(1){t=c[d>>2]|0;do if(t){u=c[t+12>>2]|0;if((u|0)==(c[t+16>>2]|0))v=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else v=c[u>>2]|0;if((v|0)==-1){c[d>>2]=0;w=0;x=1;break}else{w=t;x=(t|0)==0;break}}else{w=0;x=1}while(0);t=c[e>>2]|0;do if(t){u=c[t+12>>2]|0;if((u|0)==(c[t+16>>2]|0))y=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else y=c[u>>2]|0;if((y|0)!=-1)if(x){z=t;break}else{A=w;B=19;break b}else{c[e>>2]=0;B=17;break}}else B=17;while(0);if((B|0)==17){B=0;if(x){A=w;B=19;break}else z=0}c:do if((xo[c[(c[s>>2]|0)+52>>2]&2047](s,c[o>>2]|0,0)|0)<<24>>24==37){t=o+4|0;if((t|0)==(k|0)){C=w;B=22;break b}u=xo[c[(c[s>>2]|0)+52>>2]&2047](s,c[t>>2]|0,0)|0;if(u<<24>>24==48|u<<24>>24==69){D=o+8|0;if((D|0)==(k|0)){E=w;B=25;break b}F=t;G=xo[c[(c[s>>2]|0)+52>>2]&2047](s,c[D>>2]|0,0)|0;H=u}else{F=o;G=u;H=0}u=c[(c[b>>2]|0)+36>>2]|0;c[q>>2]=w;c[r>>2]=z;c[n+0>>2]=c[q+0>>2];c[m+0>>2]=c[r+0>>2];Yn[u&15](p,b,n,m,f,g,h,G,H);u=c[p>>2]|0;c[d>>2]=u;I=F+8|0;J=u}else{if(xo[c[(c[s>>2]|0)+12>>2]&2047](s,8192,c[o>>2]|0)|0)K=o;else{u=w+12|0;D=c[u>>2]|0;t=w+16|0;if((D|0)==(c[t>>2]|0))L=mo[c[(c[w>>2]|0)+36>>2]&4095](w)|0;else L=c[D>>2]|0;D=_n[c[(c[s>>2]|0)+28>>2]&4095](s,L)|0;if((D|0)!=(_n[c[(c[s>>2]|0)+28>>2]&4095](s,c[o>>2]|0)|0)){M=w;B=62;break b}D=c[u>>2]|0;if((D|0)==(c[t>>2]|0))mo[c[(c[w>>2]|0)+40>>2]&4095](w)|0;else c[u>>2]=D+4;I=o+4|0;J=w;break}while(1){D=K+4|0;if((D|0)==(k|0)){N=k;break}if(xo[c[(c[s>>2]|0)+12>>2]&2047](s,8192,c[D>>2]|0)|0)K=D;else{N=D;break}}D=w;u=z;t=w;O=z;while(1){if(D){P=c[D+12>>2]|0;if((P|0)==(c[D+16>>2]|0))Q=mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0;else Q=c[P>>2]|0;if((Q|0)==-1){c[d>>2]=0;R=0;S=0;T=1}else{R=t;S=D;T=0}}else{R=t;S=0;T=1}do if(O){P=c[O+12>>2]|0;if((P|0)==(c[O+16>>2]|0))U=mo[c[(c[O>>2]|0)+36>>2]&4095](O)|0;else U=c[P>>2]|0;if((U|0)!=-1)if(T^(u|0)==0){V=u;W=u;break}else{I=N;J=R;break c}else{c[e>>2]=0;X=0;B=45;break}}else{X=u;B=45}while(0);if((B|0)==45){B=0;if(T){I=N;J=R;break c}else{V=X;W=0}}P=S+12|0;Y=c[P>>2]|0;Z=S+16|0;if((Y|0)==(c[Z>>2]|0))_=mo[c[(c[S>>2]|0)+36>>2]&4095](S)|0;else _=c[Y>>2]|0;if(!(xo[c[(c[s>>2]|0)+12>>2]&2047](s,8192,_)|0)){I=N;J=R;break c}Y=c[P>>2]|0;if((Y|0)==(c[Z>>2]|0)){mo[c[(c[S>>2]|0)+40>>2]&4095](S)|0;D=S;u=V;t=R;O=W;continue}else{c[P>>2]=Y+4;D=S;u=V;t=R;O=W;continue}}}while(0);if((I|0)!=(k|0)&(c[g>>2]|0)==0)o=I;else{$=J;break a}}if((B|0)==19){c[g>>2]=4;$=A;break}else if((B|0)==22){c[g>>2]=4;$=C;break}else if((B|0)==25){c[g>>2]=4;$=E;break}else if((B|0)==62){c[g>>2]=4;$=M;break}}else $=c[d>>2]|0;while(0);if($){M=c[$+12>>2]|0;if((M|0)==(c[$+16>>2]|0))aa=mo[c[(c[$>>2]|0)+36>>2]&4095]($)|0;else aa=c[M>>2]|0;if((aa|0)==-1){c[d>>2]=0;ba=0;ca=1}else{ba=$;ca=0}}else{ba=0;ca=1}$=c[e>>2]|0;do if($){d=c[$+12>>2]|0;if((d|0)==(c[$+16>>2]|0))da=mo[c[(c[$>>2]|0)+36>>2]&4095]($)|0;else da=c[d>>2]|0;if((da|0)==-1){c[e>>2]=0;B=75;break}if(ca){c[a>>2]=ba;i=l;return}}else B=75;while(0);if((B|0)==75?!ca:0){c[a>>2]=ba;i=l;return}c[g>>2]=c[g>>2]|2;c[a>>2]=ba;i=l;return}function pvi(a){a=a|0;return}function qvi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function rvi(a){a=a|0;return 2}function svi(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];c[l+0>>2]=c[m+0>>2];c[k+0>>2]=c[n+0>>2];ovi(a,b,l,k,f,g,h,3653856,3653888|0);i=j;return}function tvi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+16|0;l=k+12|0;m=k+8|0;n=k+4|0;o=k;p=d+8|0;q=mo[c[(c[p>>2]|0)+20>>2]&4095](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q>>0]|0;if(!(f&1)){r=q+4|0;s=(f&255)>>>1;t=q+4|0}else{f=c[q+8>>2]|0;r=f;s=c[q+4>>2]|0;t=f}c[m+0>>2]=c[n+0>>2];c[l+0>>2]=c[o+0>>2];ovi(b,d,m,l,g,h,j,t,r+(s<<2)|0);i=k;return}function uvi(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;dsi(l,f);f=Kxi(l,3654792)|0;$qi(c[l>>2]|0)|0;c[m>>2]=c[e>>2];c[k+0>>2]=c[m+0>>2];vvi(b,h+24|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function vvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=a+8|0;a=mo[c[c[l>>2]>>2]&4095](l)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];k=(Vzi(d,j,a,a+168|0,g,f,0)|0)-a|0;if((k|0)>=168){i=h;return}c[b>>2]=((k|0)/12|0|0)%7|0;i=h;return}function wvi(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;dsi(l,f);f=Kxi(l,3654792)|0;$qi(c[l>>2]|0)|0;c[m>>2]=c[e>>2];c[k+0>>2]=c[m+0>>2];xvi(b,h+16|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function xvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+16|0;j=h+4|0;k=h;l=a+8|0;a=mo[c[(c[l>>2]|0)+4>>2]&4095](l)|0;c[k>>2]=c[e>>2];c[j+0>>2]=c[k+0>>2];k=(Vzi(d,j,a,a+288|0,g,f,0)|0)-a|0;if((k|0)>=288){i=h;return}c[b>>2]=((k|0)/12|0|0)%12|0;i=h;return}function yvi(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j+8|0;l=j+4|0;m=j;dsi(l,f);f=Kxi(l,3654792)|0;$qi(c[l>>2]|0)|0;c[m>>2]=c[e>>2];c[k+0>>2]=c[m+0>>2];zvi(b,h+20|0,d,k,g,f);c[a>>2]=c[d>>2];i=j;return}function zvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,4)|0;if(c[f>>2]&4){i=a;return}if((j|0)<69)k=j+2e3|0;else k=(j+-69|0)>>>0<31?j+1900|0:j;c[b>>2]=k+-1900;i=a;return}function Avi(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;l=i;i=i+176|0;m=l+156|0;n=l+148|0;o=l+4|0;p=l+72|0;q=l+76|0;r=l;s=l+20|0;t=l+24|0;u=l+28|0;v=l+32|0;w=l+36|0;x=l+40|0;y=l+44|0;z=l+48|0;A=l+52|0;B=l+56|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+80|0;I=l+84|0;J=l+88|0;K=l+92|0;L=l+96|0;M=l+100|0;N=l+104|0;O=l+108|0;P=l+112|0;Q=l+116|0;R=l+12|0;S=l+120|0;T=l+60|0;U=l+124|0;V=l+16|0;W=l+64|0;X=l+132|0;Y=l+68|0;Z=l+140|0;_=l+8|0;c[h>>2]=0;dsi(o,g);$=Kxi(o,3654792)|0;$qi(c[o>>2]|0)|0;do switch(k<<24>>24|0){case 120:{o=c[(c[d>>2]|0)+20>>2]|0;c[T>>2]=c[e>>2];c[U>>2]=c[f>>2];c[n+0>>2]=c[T+0>>2];c[m+0>>2]=c[U+0>>2];Wn[o&127](b,d,n,m,g,h,j);i=l;return}case 106:{c[D>>2]=c[f>>2];c[m+0>>2]=c[D+0>>2];Evi(d,j+28|0,e,m,h,$);break}case 114:{c[J>>2]=c[e>>2];c[K>>2]=c[f>>2];c[n+0>>2]=c[J+0>>2];c[m+0>>2]=c[K+0>>2];ovi(I,d,n,m,g,h,j,3653952,3653996|0);c[e>>2]=c[I>>2];break}case 104:case 66:case 98:{c[q>>2]=c[f>>2];c[m+0>>2]=c[q+0>>2];xvi(d,j+16|0,e,m,h,$);break}case 72:{c[B>>2]=c[f>>2];c[m+0>>2]=c[B+0>>2];Cvi(d,j+8|0,e,m,h,$);break}case 73:{c[C>>2]=c[f>>2];c[m+0>>2]=c[C+0>>2];Dvi(d,j+8|0,e,m,h,$);break}case 121:{c[Y>>2]=c[f>>2];c[m+0>>2]=c[Y+0>>2];zvi(d,j+20|0,e,m,h,$);break}case 101:case 100:{c[u>>2]=c[f>>2];c[m+0>>2]=c[u+0>>2];Bvi(d,j+12|0,e,m,h,$);break}case 65:case 97:{c[p>>2]=c[f>>2];c[m+0>>2]=c[p+0>>2];vvi(d,j+24|0,e,m,h,$);break}case 116:case 110:{c[G>>2]=c[f>>2];c[m+0>>2]=c[G+0>>2];Hvi(d,e,m,h,$);break}case 82:{c[M>>2]=c[e>>2];c[N>>2]=c[f>>2];c[n+0>>2]=c[M+0>>2];c[m+0>>2]=c[N+0>>2];ovi(L,d,n,m,g,h,j,3654e3,3654020|0);c[e>>2]=c[L>>2];break}case 68:{c[w>>2]=c[e>>2];c[x>>2]=c[f>>2];c[n+0>>2]=c[w+0>>2];c[m+0>>2]=c[x+0>>2];ovi(v,d,n,m,g,h,j,3653888,3653920|0);c[e>>2]=c[v>>2];break}case 109:{c[E>>2]=c[f>>2];c[m+0>>2]=c[E+0>>2];Fvi(d,j+16|0,e,m,h,$);break}case 89:{c[Z>>2]=c[f>>2];c[m+0>>2]=c[Z+0>>2];Lvi(d,j+20|0,e,m,h,$);break}case 99:{o=d+8|0;aa=mo[c[(c[o>>2]|0)+12>>2]&4095](o)|0;c[s>>2]=c[e>>2];c[t>>2]=c[f>>2];o=a[aa>>0]|0;if(!(o&1)){ba=aa+4|0;ca=(o&255)>>>1;da=aa+4|0}else{o=c[aa+8>>2]|0;ba=o;ca=c[aa+4>>2]|0;da=o}c[n+0>>2]=c[s+0>>2];c[m+0>>2]=c[t+0>>2];ovi(r,d,n,m,g,h,j,da,ba+(ca<<2)|0);c[e>>2]=c[r>>2];break}case 88:{o=d+8|0;aa=mo[c[(c[o>>2]|0)+24>>2]&4095](o)|0;c[W>>2]=c[e>>2];c[X>>2]=c[f>>2];o=a[aa>>0]|0;if(!(o&1)){ea=aa+4|0;fa=(o&255)>>>1;ga=aa+4|0}else{o=c[aa+8>>2]|0;ea=o;fa=c[aa+4>>2]|0;ga=o}c[n+0>>2]=c[W+0>>2];c[m+0>>2]=c[X+0>>2];ovi(V,d,n,m,g,h,j,ga,ea+(fa<<2)|0);c[e>>2]=c[V>>2];break}case 70:{c[z>>2]=c[e>>2];c[A>>2]=c[f>>2];c[n+0>>2]=c[z+0>>2];c[m+0>>2]=c[A+0>>2];ovi(y,d,n,m,g,h,j,3653920,3653952|0);c[e>>2]=c[y>>2];break}case 112:{c[H>>2]=c[f>>2];c[m+0>>2]=c[H+0>>2];Ivi(d,j+8|0,e,m,h,$);break}case 83:{c[O>>2]=c[f>>2];c[m+0>>2]=c[O+0>>2];Jvi(d,j,e,m,h,$);break}case 84:{c[Q>>2]=c[e>>2];c[R>>2]=c[f>>2];c[n+0>>2]=c[Q+0>>2];c[m+0>>2]=c[R+0>>2];ovi(P,d,n,m,g,h,j,3654024,3654056|0);c[e>>2]=c[P>>2];break}case 77:{c[F>>2]=c[f>>2];c[m+0>>2]=c[F+0>>2];Gvi(d,j+4|0,e,m,h,$);break}case 37:{c[_>>2]=c[f>>2];c[m+0>>2]=c[_+0>>2];Mvi(d,e,m,h,$);break}case 119:{c[S>>2]=c[f>>2];c[m+0>>2]=c[S+0>>2];Kvi(d,j+24|0,e,m,h,$);break}default:c[h>>2]=c[h>>2]|4}while(0);c[b>>2]=c[e>>2];i=l;return}function Bvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)>0&(j|0)<32){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Cvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<24){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Dvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)>0&(j|0)<13){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Evi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,3)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<366){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Fvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<13){c[b>>2]=j+-1;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Gvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<60){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Hvi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;a:while(1){g=c[b>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))j=mo[c[(c[g>>2]|0)+36>>2]&4095](g)|0;else j=c[h>>2]|0;if((j|0)==-1){c[b>>2]=0;k=1;break}else{k=(c[b>>2]|0)==0;break}}else k=1;while(0);g=c[d>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))l=mo[c[(c[g>>2]|0)+36>>2]&4095](g)|0;else l=c[h>>2]|0;if((l|0)!=-1)if(k){m=g;break}else{n=g;break a}else{c[d>>2]=0;o=15;break}}else o=15;while(0);if((o|0)==15){o=0;if(k){n=0;break}else m=0}g=c[b>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))p=mo[c[(c[g>>2]|0)+36>>2]&4095](g)|0;else p=c[h>>2]|0;if(!(xo[c[(c[f>>2]|0)+12>>2]&2047](f,8192,p)|0)){n=m;break}h=c[b>>2]|0;g=h+12|0;q=c[g>>2]|0;if((q|0)==(c[h+16>>2]|0)){mo[c[(c[h>>2]|0)+40>>2]&4095](h)|0;continue}else{c[g>>2]=q+4;continue}}m=c[b>>2]|0;do if(m){p=c[m+12>>2]|0;if((p|0)==(c[m+16>>2]|0))r=mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0;else r=c[p>>2]|0;if((r|0)==-1){c[b>>2]=0;s=1;break}else{s=(c[b>>2]|0)==0;break}}else s=1;while(0);do if(n){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))t=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;else t=c[b>>2]|0;if((t|0)==-1){c[d>>2]=0;o=37;break}if(s){i=a;return}}else o=37;while(0);if((o|0)==37?!s:0){i=a;return}c[e>>2]=c[e>>2]|2;i=a;return}function Ivi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j+4|0;l=j;m=b+8|0;b=mo[c[(c[m>>2]|0)+8>>2]&4095](m)|0;m=a[b>>0]|0;if(!(m&1))n=(m&255)>>>1;else n=c[b+4>>2]|0;m=a[b+12>>0]|0;if(!(m&1))o=(m&255)>>>1;else o=c[b+16>>2]|0;if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];c[k+0>>2]=c[l+0>>2];l=Vzi(e,k,b,b+24|0,h,g,0)|0;g=c[d>>2]|0;if((l|0)==(b|0)&(g|0)==12){c[d>>2]=0;i=j;return}if(!((l-b|0)==12&(g|0)<12)){i=j;return}c[d>>2]=g+12;i=j;return}function Jvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,2)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<61){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Kvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,1)|0;g=c[f>>2]|0;if((g&4|0)==0&(j|0)<7){c[b>>2]=j;i=a;return}else{c[f>>2]=g|4;i=a;return}}function Lvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;a=i;i=i+16|0;h=a+4|0;j=a;c[j>>2]=c[e>>2];c[h+0>>2]=c[j+0>>2];j=hAi(d,h,f,g,4)|0;if(c[f>>2]&4){i=a;return}c[b>>2]=j+-1900;i=a;return}function Mvi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;g=c[b>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))j=mo[c[(c[g>>2]|0)+36>>2]&4095](g)|0;else j=c[h>>2]|0;if((j|0)==-1){c[b>>2]=0;k=1;break}else{k=(c[b>>2]|0)==0;break}}else k=1;while(0);j=c[d>>2]|0;do if(j){g=c[j+12>>2]|0;if((g|0)==(c[j+16>>2]|0))l=mo[c[(c[j>>2]|0)+36>>2]&4095](j)|0;else l=c[g>>2]|0;if((l|0)!=-1)if(k){m=j;break}else{n=16;break}else{c[d>>2]=0;n=14;break}}else n=14;while(0);if((n|0)==14)if(k)n=16;else m=0;if((n|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}k=c[b>>2]|0;j=c[k+12>>2]|0;if((j|0)==(c[k+16>>2]|0))o=mo[c[(c[k>>2]|0)+36>>2]&4095](k)|0;else o=c[j>>2]|0;if((xo[c[(c[f>>2]|0)+52>>2]&2047](f,o,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;i=a;return}o=c[b>>2]|0;f=o+12|0;j=c[f>>2]|0;if((j|0)==(c[o+16>>2]|0)){mo[c[(c[o>>2]|0)+40>>2]&4095](o)|0;p=c[b>>2]|0}else{c[f>>2]=j+4;p=o}do if(p){o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0))q=mo[c[(c[p>>2]|0)+36>>2]&4095](p)|0;else q=c[o>>2]|0;if((q|0)==-1){c[b>>2]=0;r=1;break}else{r=(c[b>>2]|0)==0;break}}else r=1;while(0);do if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))s=mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0;else s=c[b>>2]|0;if((s|0)==-1){c[d>>2]=0;n=38;break}if(r){i=a;return}}else n=38;while(0);if((n|0)==38?!r:0){i=a;return}c[e>>2]=c[e>>2]|2;i=a;return}function Nvi(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;if((d|0)==(Xti()|0)){i=b;return}dl(c[a>>2]|0);i=b;return}function Ovi(a){a=a|0;var b=0;b=i;Nvi(a+8|0);i=b;return}function Pvi(a){a=a|0;var b=0;b=i;Nvi(a+8|0);ACi(a);i=b;return}function Qvi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;g=i;i=i+112|0;f=g+4|0;l=g;c[l>>2]=f+100;Rvi(d+8|0,f,l,h,j,k);k=c[l>>2]|0;l=c[e>>2]|0;if((f|0)==(k|0)){m=l;c[b>>2]=m;i=g;return}else{n=f;o=l}while(1){l=a[n>>0]|0;do if(o){f=o+24|0;e=c[f>>2]|0;if((e|0)==(c[o+28>>2]|0)){j=(_n[c[(c[o>>2]|0)+52>>2]&4095](o,l&255)|0)==-1;p=j?0:o;break}else{c[f>>2]=e+1;a[e>>0]=l;p=o;break}}else p=0;while(0);n=n+1|0;if((n|0)==(k|0)){m=p;break}else o=p}c[b>>2]=m;i=g;return}function Rvi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+16|0;k=j;a[k>>0]=37;l=k+1|0;a[l>>0]=g;m=k+2|0;a[m>>0]=h;a[k+3>>0]=0;if(h<<24>>24){a[l>>0]=h;a[m>>0]=g}c[e>>2]=d+(Yg(d|0,(c[e>>2]|0)-d|0,k|0,f|0,c[b>>2]|0)|0);i=j;return}function Svi(a){a=a|0;var b=0;b=i;Nvi(a+8|0);i=b;return}function Tvi(a){a=a|0;var b=0;b=i;Nvi(a+8|0);ACi(a);i=b;return}function Uvi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+416|0;e=f+8|0;k=f;c[k>>2]=e+400;Vvi(b+8|0,e,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((e|0)==(j|0)){l=k;c[a>>2]=l;i=f;return}else{m=e;n=k}while(1){k=c[m>>2]|0;if(!n)o=0;else{e=n+24|0;d=c[e>>2]|0;if((d|0)==(c[n+28>>2]|0))p=_n[c[(c[n>>2]|0)+52>>2]&4095](n,k)|0;else{c[e>>2]=d+4;c[d>>2]=k;p=k}o=(p|0)==-1?0:n}m=m+4|0;if((m|0)==(j|0)){l=o;break}else n=o}c[a>>2]=l;i=f;return}function Vvi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+128|0;j=h+16|0;k=h+12|0;l=h;m=h+8|0;c[k>>2]=j+100;Rvi(a,j,k,e,f,g);g=l;c[g>>2]=0;c[g+4>>2]=0;c[m>>2]=j;j=(c[d>>2]|0)-b>>2;g=sf(c[a>>2]|0)|0;a=XBi(b,m,j,l)|0;if(g)sf(g|0)|0;if((a|0)==-1)Rwi(3655680);else{c[d>>2]=b+(a<<2);i=h;return}}function Wvi(a){a=a|0;return}function Xvi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Yvi(a){a=a|0;return 127}function Zvi(a){a=a|0;return 127}function _vi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function $vi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function awi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function bwi(a,b){a=a|0;b=b|0;b=i;tri(a,1,45);i=b;return}function cwi(a){a=a|0;return 0}function dwi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function ewi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function fwi(a){a=a|0;return}function gwi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function hwi(a){a=a|0;return 127}function iwi(a){a=a|0;return 127}function jwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function kwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function lwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function mwi(a,b){a=a|0;b=b|0;b=i;tri(a,1,45);i=b;return}function nwi(a){a=a|0;return 0}function owi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function pwi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function qwi(a){a=a|0;return}function rwi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function swi(a){a=a|0;return 2147483647}function twi(a){a=a|0;return 2147483647}function uwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function vwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function wwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function xwi(a,b){a=a|0;b=b|0;b=i;Rri(a,1,45);i=b;return}function ywi(a){a=a|0;return 0}function zwi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Awi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Bwi(a){a=a|0;return}function Cwi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Dwi(a){a=a|0;return 2147483647}function Ewi(a){a=a|0;return 2147483647}function Fwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Gwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Hwi(a,b){a=a|0;b=b|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function Iwi(a,b){a=a|0;b=b|0;b=i;Rri(a,1,45);i=b;return}function Jwi(a){a=a|0;return 0}function Kwi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Lwi(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Mwi(a){a=a|0;return}function Nwi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Owi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+240|0;l=d;m=d+136|0;n=d+8|0;o=d+4|0;p=d+20|0;q=d+236|0;r=d+16|0;s=d+124|0;t=d+24|0;c[n>>2]=m;u=n+4|0;c[u>>2]=3595;dsi(p,h);v=Kxi(p,3654800)|0;a[q>>0]=0;c[r>>2]=c[f>>2];w=c[h+4>>2]|0;c[l+0>>2]=c[r+0>>2];do if(Qwi(e,l,g,p,w,j,q,v,n,o,m+100|0)|0){kn[c[(c[v>>2]|0)+32>>2]&511](v,3654416,3654426,s)|0;r=c[o>>2]|0;h=c[n>>2]|0;x=r-h|0;if((x|0)>98){y=ADi(x+2|0)|0;if(!y)uDi();else{z=y;A=y}}else{z=0;A=t}if(!(a[q>>0]|0))B=A;else{a[A>>0]=45;B=A+1|0}if(h>>>0<r>>>0){r=s+10|0;y=s;x=B;C=h;while(1){h=a[C>>0]|0;D=s;while(1){if((a[D>>0]|0)==h<<24>>24){E=D;break}D=D+1|0;if((D|0)==(r|0)){E=r;break}}a[x>>0]=a[3654416+(E-y)>>0]|0;C=C+1|0;D=x+1|0;if(C>>>0>=(c[o>>2]|0)>>>0){F=D;break}else x=D}}else F=B;a[F>>0]=0;c[l>>2]=k;if((aCi(t,3654432,l)|0)==1){BDi(z);break}else Rwi(3654440)}while(0);z=c[e>>2]|0;do if(z)if((c[z+12>>2]|0)==(c[z+16>>2]|0))if((mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0)==-1){c[e>>2]=0;G=0;break}else{G=c[e>>2]|0;break}else G=z;else G=0;while(0);z=(G|0)==0;G=c[f>>2]|0;do if(G){if((c[G+12>>2]|0)!=(c[G+16>>2]|0))if(z)break;else{H=28;break}if((mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0)!=-1)if(z)break;else{H=28;break}else{c[f>>2]=0;H=26;break}}else H=26;while(0);if((H|0)==26?z:0)H=28;if((H|0)==28)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];$qi(c[p>>2]|0)|0;p=c[n>>2]|0;c[n>>2]=0;if(!p){i=d;return}ko[c[u>>2]&4095](p);i=d;return}function Pwi(a){a=a|0;return}function Qwi(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0;q=i;i=i+512|0;r=q+488|0;s=q;t=q+432|0;u=q+464|0;v=q+468|0;w=q+492|0;x=q+496|0;y=q+497|0;z=q+440|0;A=q+404|0;B=q+416|0;C=q+472|0;D=q+452|0;E=q+400|0;F=q+484|0;c[r>>2]=p;c[t>>2]=s;p=t+4|0;c[p>>2]=3595;c[u>>2]=s;c[v>>2]=s+400;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Twi(g,h,w,x,y,z,A,B,C,E);c[o>>2]=c[n>>2];h=m+8|0;m=C+4|0;g=C+8|0;G=B+4|0;H=B+8|0;I=(j&512|0)!=0;j=A+1|0;J=A+8|0;K=A+4|0;L=D+1|0;M=D+8|0;N=D+4|0;O=w+3|0;P=z+4|0;Q=s;s=0;R=0;a:while(1){S=c[e>>2]|0;do if(S)if((c[S+12>>2]|0)==(c[S+16>>2]|0))if((mo[c[(c[S>>2]|0)+36>>2]&4095](S)|0)==-1){c[e>>2]=0;T=0;break}else{T=c[e>>2]|0;break}else T=S;else T=0;while(0);S=(T|0)==0;U=c[f>>2]|0;do if(U){if((c[U+12>>2]|0)!=(c[U+16>>2]|0))if(S)break;else{V=Q;W=R;X=259;break a}if((mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0)!=-1)if(S^(c[f>>2]|0)==0)break;else{V=Q;W=R;X=259;break a}else{c[f>>2]=0;X=12;break}}else X=12;while(0);if((X|0)==12?(X=0,S):0){V=Q;W=R;X=259;break}b:do switch(a[w+s>>0]|0){case 4:{U=a[y>>0]|0;Y=Q;Z=0;c:while(1){_=c[e>>2]|0;do if(_)if((c[_+12>>2]|0)==(c[_+16>>2]|0))if((mo[c[(c[_>>2]|0)+36>>2]&4095](_)|0)==-1){c[e>>2]=0;$=0;break}else{$=c[e>>2]|0;break}else $=_;else $=0;while(0);_=($|0)==0;aa=c[f>>2]|0;do if(aa){if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0))if(_)break;else{ba=Y;ca=Z;break c}if((mo[c[(c[aa>>2]|0)+36>>2]&4095](aa)|0)!=-1)if(_^(c[f>>2]|0)==0)break;else{ba=Y;ca=Z;break c}else{c[f>>2]=0;X=184;break}}else X=184;while(0);if((X|0)==184?(X=0,_):0){ba=Y;ca=Z;break}aa=c[e>>2]|0;da=c[aa+12>>2]|0;if((da|0)==(c[aa+16>>2]|0))ea=mo[c[(c[aa>>2]|0)+36>>2]&4095](aa)|0;else ea=d[da>>0]|0;da=ea&255;if(da<<24>>24>-1?(b[(c[h>>2]|0)+(ea<<24>>24<<1)>>1]&2048)!=0:0){aa=c[o>>2]|0;if((aa|0)==(c[r>>2]|0)){iAi(n,o,r);fa=c[o>>2]|0}else fa=aa;c[o>>2]=fa+1;a[fa>>0]=da;ga=Y;ha=Z+1|0}else{aa=a[z>>0]|0;if(!(aa&1))ia=(aa&255)>>>1;else ia=c[P>>2]|0;if(!((ia|0)!=0&(Z|0)!=0&da<<24>>24==U<<24>>24)){ba=Y;ca=Z;break}if((Y|0)==(c[v>>2]|0)){jAi(t,u,v);ja=c[u>>2]|0}else ja=Y;da=ja+4|0;c[u>>2]=da;c[ja>>2]=Z;ga=da;ha=0}da=c[e>>2]|0;aa=da+12|0;ka=c[aa>>2]|0;if((ka|0)==(c[da+16>>2]|0)){mo[c[(c[da>>2]|0)+40>>2]&4095](da)|0;Y=ga;Z=ha;continue}else{c[aa>>2]=ka+1;Y=ga;Z=ha;continue}}if((ca|0)!=0?(c[t>>2]|0)!=(ba|0):0){if((ba|0)==(c[v>>2]|0)){jAi(t,u,v);la=c[u>>2]|0}else la=ba;Z=la+4|0;c[u>>2]=Z;c[la>>2]=ca;ma=Z}else ma=ba;Z=c[E>>2]|0;if((Z|0)>0){Y=c[e>>2]|0;do if(Y)if((c[Y+12>>2]|0)==(c[Y+16>>2]|0))if((mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0)==-1){c[e>>2]=0;na=0;break}else{na=c[e>>2]|0;break}else na=Y;else na=0;while(0);Y=(na|0)==0;U=c[f>>2]|0;do if(U){if((c[U+12>>2]|0)!=(c[U+16>>2]|0))if(Y)break;else{X=225;break a}if((mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0)!=-1)if(Y^(c[f>>2]|0)==0)break;else{X=225;break a}else{c[f>>2]=0;X=219;break}}else X=219;while(0);if((X|0)==219?(X=0,Y):0){X=225;break a}U=c[e>>2]|0;ka=c[U+12>>2]|0;if((ka|0)==(c[U+16>>2]|0))oa=mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0;else oa=d[ka>>0]|0;if((oa&255)<<24>>24!=(a[x>>0]|0)){X=225;break a}ka=c[e>>2]|0;U=ka+12|0;aa=c[U>>2]|0;if((aa|0)==(c[ka+16>>2]|0)){mo[c[(c[ka>>2]|0)+40>>2]&4095](ka)|0;pa=Z}else{c[U>>2]=aa+1;pa=Z}do{aa=c[e>>2]|0;do if(aa)if((c[aa+12>>2]|0)==(c[aa+16>>2]|0))if((mo[c[(c[aa>>2]|0)+36>>2]&4095](aa)|0)==-1){c[e>>2]=0;qa=0;break}else{qa=c[e>>2]|0;break}else qa=aa;else qa=0;while(0);aa=(qa|0)==0;_=c[f>>2]|0;do if(_){if((c[_+12>>2]|0)!=(c[_+16>>2]|0))if(aa)break;else{X=246;break a}if((mo[c[(c[_>>2]|0)+36>>2]&4095](_)|0)!=-1)if(aa^(c[f>>2]|0)==0)break;else{X=246;break a}else{c[f>>2]=0;X=239;break}}else X=239;while(0);if((X|0)==239?(X=0,aa):0){X=246;break a}_=c[e>>2]|0;U=c[_+12>>2]|0;if((U|0)==(c[_+16>>2]|0))ra=mo[c[(c[_>>2]|0)+36>>2]&4095](_)|0;else ra=d[U>>0]|0;if((ra&255)<<24>>24<=-1){X=246;break a}if(!(b[(c[h>>2]|0)+(ra<<24>>24<<1)>>1]&2048)){X=246;break a}if((c[o>>2]|0)==(c[r>>2]|0))iAi(n,o,r);U=c[e>>2]|0;_=c[U+12>>2]|0;if((_|0)==(c[U+16>>2]|0))sa=mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0;else sa=d[_>>0]|0;_=c[o>>2]|0;c[o>>2]=_+1;a[_>>0]=sa;pa=pa+-1|0;c[E>>2]=pa;_=c[e>>2]|0;U=_+12|0;ka=c[U>>2]|0;if((ka|0)==(c[_+16>>2]|0))mo[c[(c[_>>2]|0)+40>>2]&4095](_)|0;else c[U>>2]=ka+1}while((pa|0)>0)}if((c[o>>2]|0)==(c[n>>2]|0)){X=257;break a}else{ta=ma;ua=R}break}case 1:{if((s|0)==3){V=Q;W=R;X=259;break a}Z=c[e>>2]|0;Y=c[Z+12>>2]|0;if((Y|0)==(c[Z+16>>2]|0))va=mo[c[(c[Z>>2]|0)+36>>2]&4095](Z)|0;else va=d[Y>>0]|0;if((va&255)<<24>>24<=-1){X=26;break a}if(!(b[(c[h>>2]|0)+(va<<24>>24<<1)>>1]&8192)){X=26;break a}Y=c[e>>2]|0;Z=Y+12|0;ka=c[Z>>2]|0;if((ka|0)==(c[Y+16>>2]|0))wa=mo[c[(c[Y>>2]|0)+40>>2]&4095](Y)|0;else{c[Z>>2]=ka+1;wa=d[ka>>0]|0}Fri(D,wa&255);X=27;break}case 3:{ka=b[B>>1]|0;Z=ka&255;Y=(Z&1)==0;U=(ka&65535)>>>8&255;if(Y)xa=(ka&254)>>>1;else xa=c[G>>2]|0;_=b[C>>1]|0;da=_&255;ya=(da&1)==0;za=(_&65535)>>>8&255;if(ya)Aa=(_&254)>>>1;else Aa=c[m>>2]|0;if((xa|0)==(0-Aa|0)){ta=Q;ua=R}else{if(Y)Ba=(ka&254)>>>1;else Ba=c[G>>2]|0;if(Ba){if(ya)Ca=(_&254)>>>1;else Ca=c[m>>2]|0;if(Ca){_=c[e>>2]|0;ya=c[_+12>>2]|0;if((ya|0)==(c[_+16>>2]|0)){Da=mo[c[(c[_>>2]|0)+36>>2]&4095](_)|0;_=b[B>>1]|0;Ea=Da;Fa=_&255;Ga=(_&65535)>>>8&255}else{Ea=d[ya>>0]|0;Fa=Z;Ga=U}if(!(Fa&1))Ha=Ga;else Ha=a[c[H>>2]>>0]|0;ya=c[e>>2]|0;_=ya+12|0;Da=c[_>>2]|0;Ia=(Da|0)==(c[ya+16>>2]|0);if((Ea&255)<<24>>24==Ha<<24>>24){if(Ia)mo[c[(c[ya>>2]|0)+40>>2]&4095](ya)|0;else c[_>>2]=Da+1;_=a[B>>0]|0;if(!(_&1))Ja=(_&255)>>>1;else Ja=c[G>>2]|0;ta=Q;ua=Ja>>>0>1?B:R;break b}if(Ia)Ka=mo[c[(c[ya>>2]|0)+36>>2]&4095](ya)|0;else Ka=d[Da>>0]|0;Da=b[C>>1]|0;if(!(Da&1))La=(Da&65535)>>>8&255;else La=a[c[g>>2]>>0]|0;if((Ka&255)<<24>>24!=La<<24>>24){X=122;break a}Da=c[e>>2]|0;ya=Da+12|0;Ia=c[ya>>2]|0;if((Ia|0)==(c[Da+16>>2]|0))mo[c[(c[Da>>2]|0)+40>>2]&4095](Da)|0;else c[ya>>2]=Ia+1;a[l>>0]=1;Ia=a[C>>0]|0;if(!(Ia&1))Ma=(Ia&255)>>>1;else Ma=c[m>>2]|0;ta=Q;ua=Ma>>>0>1?C:R;break b}}if(Y)Na=(ka&254)>>>1;else Na=c[G>>2]|0;ka=c[e>>2]|0;Y=c[ka+12>>2]|0;Ia=(Y|0)==(c[ka+16>>2]|0);if(!Na){if(Ia){ya=mo[c[(c[ka>>2]|0)+36>>2]&4095](ka)|0;Da=b[C>>1]|0;Oa=ya;Pa=Da&255;Qa=(Da&65535)>>>8&255}else{Oa=d[Y>>0]|0;Pa=da;Qa=za}if(!(Pa&1))Ra=Qa;else Ra=a[c[g>>2]>>0]|0;if((Oa&255)<<24>>24!=Ra<<24>>24){ta=Q;ua=R;break b}za=c[e>>2]|0;da=za+12|0;Da=c[da>>2]|0;if((Da|0)==(c[za+16>>2]|0))mo[c[(c[za>>2]|0)+40>>2]&4095](za)|0;else c[da>>2]=Da+1;a[l>>0]=1;Da=a[C>>0]|0;if(!(Da&1))Sa=(Da&255)>>>1;else Sa=c[m>>2]|0;ta=Q;ua=Sa>>>0>1?C:R;break b}if(Ia){Ia=mo[c[(c[ka>>2]|0)+36>>2]&4095](ka)|0;ka=b[B>>1]|0;Ta=Ia;Ua=ka&255;Va=(ka&65535)>>>8&255}else{Ta=d[Y>>0]|0;Ua=Z;Va=U}if(!(Ua&1))Wa=Va;else Wa=a[c[H>>2]>>0]|0;if((Ta&255)<<24>>24!=Wa<<24>>24){a[l>>0]=1;ta=Q;ua=R;break b}U=c[e>>2]|0;Z=U+12|0;Y=c[Z>>2]|0;if((Y|0)==(c[U+16>>2]|0))mo[c[(c[U>>2]|0)+40>>2]&4095](U)|0;else c[Z>>2]=Y+1;Y=a[B>>0]|0;if(!(Y&1))Xa=(Y&255)>>>1;else Xa=c[G>>2]|0;ta=Q;ua=Xa>>>0>1?B:R}break}case 0:{X=27;break}case 2:{if(!((R|0)!=0|s>>>0<2)){if((s|0)==2)Ya=(a[O>>0]|0)!=0;else Ya=0;if(!(I|Ya)){ta=Q;ua=0;break b}}Y=a[A>>0]|0;Z=(Y&1)==0;U=Z?j:c[J>>2]|0;d:do if((s|0)!=0?(d[w+(s+-1)>>0]|0)<2:0){ka=(Y&255)>>>1;Ia=c[h>>2]|0;Da=c[J>>2]|0;da=c[K>>2]|0;za=U;while(1){if((za|0)==((Z?j:Da)+(Z?ka:da)|0)){Za=za;break}ya=a[za>>0]|0;if(ya<<24>>24<=-1){Za=za;break}if(!(b[Ia+(ya<<24>>24<<1)>>1]&8192)){Za=za;break}else za=za+1|0}za=Za-(Z?j:Da)|0;Ia=a[D>>0]|0;da=(Ia&1)==0;if(da)_a=(Ia&255)>>>1;else _a=c[N>>2]|0;e:do if(za>>>0<=_a>>>0){if(da){$a=L;ab=(Ia&255)>>>1;bb=D+(((Ia&255)>>>1)-za)+1|0}else{ka=c[M>>2]|0;aa=c[N>>2]|0;$a=ka;ab=aa;bb=ka+(aa-za)|0}aa=$a+ab|0;if((bb|0)==(aa|0)){cb=Y;db=Za;break d}else{eb=bb;fb=Z?j:Da}while(1){if((a[eb>>0]|0)!=(a[fb>>0]|0))break e;eb=eb+1|0;if((eb|0)==(aa|0)){cb=Y;db=Za;break d}else fb=fb+1|0}}while(0);cb=Y;db=Z?j:Da}else{cb=Y;db=U}while(0);f:while(1){if(!(cb&1)){gb=j;hb=(cb&255)>>>1}else{gb=c[J>>2]|0;hb=c[K>>2]|0}if((db|0)==(gb+hb|0)){ib=db;break}U=c[e>>2]|0;do if(U)if((c[U+12>>2]|0)==(c[U+16>>2]|0))if((mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0)==-1){c[e>>2]=0;jb=0;break}else{jb=c[e>>2]|0;break}else jb=U;else jb=0;while(0);U=(jb|0)==0;Da=c[f>>2]|0;do if(Da){if((c[Da+12>>2]|0)!=(c[Da+16>>2]|0))if(U)break;else{ib=db;break f}if((mo[c[(c[Da>>2]|0)+36>>2]&4095](Da)|0)!=-1)if(U^(c[f>>2]|0)==0)break;else{ib=db;break f}else{c[f>>2]=0;X=158;break}}else X=158;while(0);if((X|0)==158?(X=0,U):0){ib=db;break}Da=c[e>>2]|0;Y=c[Da+12>>2]|0;if((Y|0)==(c[Da+16>>2]|0))kb=mo[c[(c[Da>>2]|0)+36>>2]&4095](Da)|0;else kb=d[Y>>0]|0;if((kb&255)<<24>>24!=(a[db>>0]|0)){ib=db;break}Y=c[e>>2]|0;Da=Y+12|0;Z=c[Da>>2]|0;if((Z|0)==(c[Y+16>>2]|0))mo[c[(c[Y>>2]|0)+40>>2]&4095](Y)|0;else c[Da>>2]=Z+1;cb=a[A>>0]|0;db=db+1|0}if(I){Z=a[A>>0]|0;if(!(Z&1)){lb=j;mb=(Z&255)>>>1}else{lb=c[J>>2]|0;mb=c[K>>2]|0}if((ib|0)!=(lb+mb|0)){X=173;break a}else{ta=Q;ua=R}}else{ta=Q;ua=R}break}default:{ta=Q;ua=R}}while(0);g:do if((X|0)==27){X=0;if((s|0)==3){V=Q;W=R;X=259;break a}while(1){S=c[e>>2]|0;do if(S)if((c[S+12>>2]|0)==(c[S+16>>2]|0))if((mo[c[(c[S>>2]|0)+36>>2]&4095](S)|0)==-1){c[e>>2]=0;nb=0;break}else{nb=c[e>>2]|0;break}else nb=S;else nb=0;while(0);S=(nb|0)==0;U=c[f>>2]|0;do if(U){if((c[U+12>>2]|0)!=(c[U+16>>2]|0))if(S)break;else{ta=Q;ua=R;break g}if((mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0)!=-1)if(S^(c[f>>2]|0)==0)break;else{ta=Q;ua=R;break g}else{c[f>>2]=0;X=38;break}}else X=38;while(0);if((X|0)==38?(X=0,S):0){ta=Q;ua=R;break g}U=c[e>>2]|0;Z=c[U+12>>2]|0;if((Z|0)==(c[U+16>>2]|0))ob=mo[c[(c[U>>2]|0)+36>>2]&4095](U)|0;else ob=d[Z>>0]|0;if((ob&255)<<24>>24<=-1){ta=Q;ua=R;break g}if(!(b[(c[h>>2]|0)+(ob<<24>>24<<1)>>1]&8192)){ta=Q;ua=R;break g}Z=c[e>>2]|0;U=Z+12|0;Da=c[U>>2]|0;if((Da|0)==(c[Z+16>>2]|0))pb=mo[c[(c[Z>>2]|0)+40>>2]&4095](Z)|0;else{c[U>>2]=Da+1;pb=d[Da>>0]|0}Fri(D,pb&255)}}while(0);s=s+1|0;if(s>>>0>=4){V=ta;W=ua;X=259;break}else{Q=ta;R=ua}}h:do if((X|0)==26){c[k>>2]=c[k>>2]|4;qb=0}else if((X|0)==122){c[k>>2]=c[k>>2]|4;qb=0}else if((X|0)==173){c[k>>2]=c[k>>2]|4;qb=0}else if((X|0)==225){c[k>>2]=c[k>>2]|4;qb=0}else if((X|0)==246){c[k>>2]=c[k>>2]|4;qb=0}else if((X|0)==257){c[k>>2]=c[k>>2]|4;qb=0}else if((X|0)==259){i:do if(W){ua=W+1|0;R=W+8|0;ta=W+4|0;Q=1;j:while(1){s=a[W>>0]|0;if(!(s&1))rb=(s&255)>>>1;else rb=c[ta>>2]|0;if(Q>>>0>=rb>>>0)break i;s=c[e>>2]|0;do if(s)if((c[s+12>>2]|0)==(c[s+16>>2]|0))if((mo[c[(c[s>>2]|0)+36>>2]&4095](s)|0)==-1){c[e>>2]=0;sb=0;break}else{sb=c[e>>2]|0;break}else sb=s;else sb=0;while(0);s=(sb|0)==0;S=c[f>>2]|0;do if(S){if((c[S+12>>2]|0)!=(c[S+16>>2]|0))if(s)break;else break j;if((mo[c[(c[S>>2]|0)+36>>2]&4095](S)|0)!=-1)if(s^(c[f>>2]|0)==0)break;else break j;else{c[f>>2]=0;X=275;break}}else X=275;while(0);if((X|0)==275?(X=0,s):0)break;S=c[e>>2]|0;pb=c[S+12>>2]|0;if((pb|0)==(c[S+16>>2]|0))tb=mo[c[(c[S>>2]|0)+36>>2]&4095](S)|0;else tb=d[pb>>0]|0;if(!(a[W>>0]&1))ub=ua;else ub=c[R>>2]|0;if((tb&255)<<24>>24!=(a[ub+Q>>0]|0))break;pb=Q+1|0;S=c[e>>2]|0;ob=S+12|0;h=c[ob>>2]|0;if((h|0)==(c[S+16>>2]|0)){mo[c[(c[S>>2]|0)+40>>2]&4095](S)|0;Q=pb;continue}else{c[ob>>2]=h+1;Q=pb;continue}}c[k>>2]=c[k>>2]|4;qb=0;break h}while(0);Q=c[t>>2]|0;if((Q|0)!=(V|0)?(c[F>>2]=0,Uwi(z,Q,V,F),(c[F>>2]|0)!=0):0){c[k>>2]=c[k>>2]|4;qb=0}else qb=1}while(0);xri(D);xri(C);xri(B);xri(A);xri(z);z=c[t>>2]|0;c[t>>2]=0;if(!z){i=q;return qb|0}ko[c[p>>2]&4095](z);i=q;return qb|0}function Rwi(a){a=a|0;var b=0;b=al(8)|0;cri(b,a);we(b|0,3667136,3429)}function Swi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+144|0;l=d;m=d+28|0;n=d+8|0;o=d+24|0;p=d+20|0;q=d+128|0;r=d+16|0;c[n>>2]=m;s=n+4|0;c[s>>2]=3595;dsi(p,h);t=Kxi(p,3654800)|0;a[q>>0]=0;u=c[f>>2]|0;c[r>>2]=u;v=c[h+4>>2]|0;c[l+0>>2]=c[r+0>>2];if(Qwi(e,l,g,p,v,j,q,t,n,o,m+100|0)|0){if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}if(a[q>>0]|0)Fri(k,_n[c[(c[t>>2]|0)+28>>2]&4095](t,45)|0);q=_n[c[(c[t>>2]|0)+28>>2]&4095](t,48)|0;t=c[n>>2]|0;m=c[o>>2]|0;o=m+-1|0;a:do if(t>>>0<o>>>0){v=t;while(1){g=v+1|0;if((a[v>>0]|0)!=q<<24>>24){w=v;break a}if(g>>>0<o>>>0)v=g;else{w=g;break}}}else w=t;while(0);kAi(k,w,m)|0}m=c[e>>2]|0;do if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0))if((mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1){c[e>>2]=0;x=0;break}else{x=c[e>>2]|0;break}else x=m;else x=0;while(0);m=(x|0)==0;do if(u){if((c[u+12>>2]|0)!=(c[u+16>>2]|0))if(m)break;else{y=23;break}if((mo[c[(c[u>>2]|0)+36>>2]&4095](u)|0)!=-1)if(m^(u|0)==0)break;else{y=23;break}else{c[f>>2]=0;y=21;break}}else y=21;while(0);if((y|0)==21?m:0)y=23;if((y|0)==23)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];$qi(c[p>>2]|0)|0;p=c[n>>2]|0;c[n>>2]=0;if(!p){i=d;return}ko[c[s>>2]&4095](p);i=d;return}function Twi(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=i;i=i+112|0;o=n;p=n+40|0;q=n+76|0;r=n+4|0;s=n+88|0;t=n+100|0;u=n+28|0;v=n+64|0;w=n+52|0;x=n+16|0;if(b){b=Kxi(d,3654240)|0;In[c[(c[b>>2]|0)+44>>2]&4095](o,b);y=c[o>>2]|0;a[e>>0]=y;a[e+1>>0]=y>>8;a[e+2>>0]=y>>16;a[e+3>>0]=y>>24;In[c[(c[b>>2]|0)+32>>2]&4095](p,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Dri(l,0);c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;xri(p);In[c[(c[b>>2]|0)+28>>2]&4095](q,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Dri(k,0);c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;xri(q);a[f>>0]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;a[g>>0]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](r,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Dri(h,0);c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;xri(r);In[c[(c[b>>2]|0)+24>>2]&4095](s,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Dri(j,0);c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;xri(s);z=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=z;i=n;return}else{b=Kxi(d,3654176)|0;In[c[(c[b>>2]|0)+44>>2]&4095](t,b);d=c[t>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>8;a[e+2>>0]=d>>16;a[e+3>>0]=d>>24;In[c[(c[b>>2]|0)+32>>2]&4095](u,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Dri(l,0);c[l+0>>2]=c[u+0>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xri(u);In[c[(c[b>>2]|0)+28>>2]&4095](v,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Dri(k,0);c[k+0>>2]=c[v+0>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;xri(v);a[f>>0]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;a[g>>0]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](w,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Dri(h,0);c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;xri(w);In[c[(c[b>>2]|0)+24>>2]&4095](x,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Dri(j,0);c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;xri(x);z=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=z;i=n;return}}function Uwi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;h=a[b>>0]|0;if(!(h&1))j=(h&255)>>>1;else j=c[b+4>>2]|0;if(!j){i=g;return}if((d|0)!=(e|0)?(j=e+-4|0,j>>>0>d>>>0):0){k=d;l=j;j=e;while(1){m=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=m;k=k+4|0;m=j+-8|0;if(k>>>0>=m>>>0)break;else{n=l;l=m;j=n}}o=a[b>>0]|0}else o=h;if(!(o&1)){p=b+1|0;q=(o&255)>>>1}else{p=c[b+8>>2]|0;q=c[b+4>>2]|0}b=e+-4|0;e=a[p>>0]|0;o=e<<24>>24<1|e<<24>>24==127;a:do if(b>>>0>d>>>0){h=p+q|0;j=e;l=p;k=d;n=o;while(1){if(!n?(j<<24>>24|0)!=(c[k>>2]|0):0)break;l=(h-l|0)>1?l+1|0:l;k=k+4|0;m=a[l>>0]|0;r=m<<24>>24<1|m<<24>>24==127;if(k>>>0>=b>>>0){s=m;t=r;break a}else{j=m;n=r}}c[f>>2]=4;i=g;return}else{s=e;t=o}while(0);if(t){i=g;return}if(((c[b>>2]|0)+-1|0)>>>0<s<<24>>24>>>0){i=g;return}c[f>>2]=4;i=g;return}function Vwi(a){a=a|0;return}function Wwi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Xwi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+576|0;l=d;m=d+64|0;n=d+56|0;o=d+48|0;p=d+468|0;q=d+572|0;r=d+464|0;s=d+8|0;t=d+472|0;c[n>>2]=m;u=n+4|0;c[u>>2]=3595;dsi(p,h);v=Kxi(p,3654792)|0;a[q>>0]=0;c[r>>2]=c[f>>2];w=c[h+4>>2]|0;c[l+0>>2]=c[r+0>>2];do if(Ywi(e,l,g,p,w,j,q,v,n,o,m+400|0)|0){kn[c[(c[v>>2]|0)+48>>2]&511](v,3654496,3654506,s)|0;r=c[o>>2]|0;h=c[n>>2]|0;x=r-h|0;if((x|0)>392){y=ADi((x>>2)+2|0)|0;if(!y)uDi();else{z=y;A=y}}else{z=0;A=t}if(!(a[q>>0]|0))B=A;else{a[A>>0]=45;B=A+1|0}if(h>>>0<r>>>0){r=s+40|0;y=s;x=B;C=h;while(1){h=c[C>>2]|0;D=s;while(1){if((c[D>>2]|0)==(h|0)){E=D;break}D=D+4|0;if((D|0)==(r|0)){E=r;break}}a[x>>0]=a[3654496+(E-y>>2)>>0]|0;C=C+4|0;D=x+1|0;if(C>>>0>=(c[o>>2]|0)>>>0){F=D;break}else x=D}}else F=B;a[F>>0]=0;c[l>>2]=k;if((aCi(t,3654432,l)|0)==1){BDi(z);break}else Rwi(3654440)}while(0);z=c[e>>2]|0;do if(z){l=c[z+12>>2]|0;if((l|0)==(c[z+16>>2]|0))G=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else G=c[l>>2]|0;if((G|0)==-1){c[e>>2]=0;H=1;break}else{H=(c[e>>2]|0)==0;break}}else H=1;while(0);G=c[f>>2]|0;do if(G){z=c[G+12>>2]|0;if((z|0)==(c[G+16>>2]|0))I=mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0;else I=c[z>>2]|0;if((I|0)!=-1)if(H)break;else{J=31;break}else{c[f>>2]=0;J=29;break}}else J=29;while(0);if((J|0)==29?H:0)J=31;if((J|0)==31)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];$qi(c[p>>2]|0)|0;p=c[n>>2]|0;c[n>>2]=0;if(!p){i=d;return}ko[c[u>>2]&4095](p);i=d;return}function Ywi(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;p=i;i=i+512|0;q=p+64|0;r=p+88|0;s=p+56|0;t=p+48|0;u=p+80|0;v=p+504|0;w=p+496|0;x=p+500|0;y=p+24|0;z=p+12|0;A=p+68|0;B=p+36|0;C=p;D=p+492|0;E=p+488|0;c[q>>2]=o;c[s>>2]=r;o=s+4|0;c[o>>2]=3595;c[t>>2]=r;c[u>>2]=r+400;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[A+0>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;_wi(f,g,v,w,x,y,z,A,B,D);c[n>>2]=c[m>>2];g=B+4|0;f=B+8|0;F=A+4|0;G=A+8|0;H=(h&512|0)!=0;h=z+4|0;I=z+8|0;J=C+4|0;K=C+8|0;L=v+3|0;M=y+4|0;N=r;r=0;O=0;a:while(1){P=c[b>>2]|0;do if(P){Q=c[P+12>>2]|0;if((Q|0)==(c[P+16>>2]|0))R=mo[c[(c[P>>2]|0)+36>>2]&4095](P)|0;else R=c[Q>>2]|0;if((R|0)==-1){c[b>>2]=0;S=1;break}else{S=(c[b>>2]|0)==0;break}}else S=1;while(0);P=c[e>>2]|0;do if(P){Q=c[P+12>>2]|0;if((Q|0)==(c[P+16>>2]|0))T=mo[c[(c[P>>2]|0)+36>>2]&4095](P)|0;else T=c[Q>>2]|0;if((T|0)!=-1)if(S^(c[e>>2]|0)==0)break;else{U=N;V=O;W=267;break a}else{c[e>>2]=0;W=15;break}}else W=15;while(0);if((W|0)==15?(W=0,S):0){U=N;V=O;W=267;break}b:do switch(a[v+r>>0]|0){case 4:{P=c[x>>2]|0;Q=N;X=0;c:while(1){Y=c[b>>2]|0;do if(Y){Z=c[Y+12>>2]|0;if((Z|0)==(c[Y+16>>2]|0))_=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else _=c[Z>>2]|0;if((_|0)==-1){c[b>>2]=0;$=1;break}else{$=(c[b>>2]|0)==0;break}}else $=1;while(0);Y=c[e>>2]|0;do if(Y){Z=c[Y+12>>2]|0;if((Z|0)==(c[Y+16>>2]|0))aa=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else aa=c[Z>>2]|0;if((aa|0)!=-1)if($^(c[e>>2]|0)==0)break;else{ba=Q;ca=X;break c}else{c[e>>2]=0;W=188;break}}else W=188;while(0);if((W|0)==188?(W=0,$):0){ba=Q;ca=X;break}Y=c[b>>2]|0;Z=c[Y+12>>2]|0;if((Z|0)==(c[Y+16>>2]|0))da=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else da=c[Z>>2]|0;if(xo[c[(c[l>>2]|0)+12>>2]&2047](l,2048,da)|0){Z=c[n>>2]|0;if((Z|0)==(c[q>>2]|0)){lAi(m,n,q);ea=c[n>>2]|0}else ea=Z;c[n>>2]=ea+4;c[ea>>2]=da;fa=Q;ga=X+1|0}else{Z=a[y>>0]|0;if(!(Z&1))ha=(Z&255)>>>1;else ha=c[M>>2]|0;if(!((ha|0)!=0&(X|0)!=0&(da|0)==(P|0))){ba=Q;ca=X;break}if((Q|0)==(c[u>>2]|0)){jAi(s,t,u);ia=c[t>>2]|0}else ia=Q;Z=ia+4|0;c[t>>2]=Z;c[ia>>2]=X;fa=Z;ga=0}Z=c[b>>2]|0;Y=Z+12|0;ja=c[Y>>2]|0;if((ja|0)==(c[Z+16>>2]|0)){mo[c[(c[Z>>2]|0)+40>>2]&4095](Z)|0;Q=fa;X=ga;continue}else{c[Y>>2]=ja+4;Q=fa;X=ga;continue}}if((ca|0)!=0?(c[s>>2]|0)!=(ba|0):0){if((ba|0)==(c[u>>2]|0)){jAi(s,t,u);ka=c[t>>2]|0}else ka=ba;X=ka+4|0;c[t>>2]=X;c[ka>>2]=ca;la=X}else la=ba;X=c[D>>2]|0;if((X|0)>0){Q=c[b>>2]|0;do if(Q){P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0))ma=mo[c[(c[Q>>2]|0)+36>>2]&4095](Q)|0;else ma=c[P>>2]|0;if((ma|0)==-1){c[b>>2]=0;na=1;break}else{na=(c[b>>2]|0)==0;break}}else na=1;while(0);Q=c[e>>2]|0;do if(Q){P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0))oa=mo[c[(c[Q>>2]|0)+36>>2]&4095](Q)|0;else oa=c[P>>2]|0;if((oa|0)!=-1)if(na^(c[e>>2]|0)==0)break;else{W=231;break a}else{c[e>>2]=0;W=225;break}}else W=225;while(0);if((W|0)==225?(W=0,na):0){W=231;break a}Q=c[b>>2]|0;P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0))pa=mo[c[(c[Q>>2]|0)+36>>2]&4095](Q)|0;else pa=c[P>>2]|0;if((pa|0)!=(c[w>>2]|0)){W=231;break a}P=c[b>>2]|0;Q=P+12|0;ja=c[Q>>2]|0;if((ja|0)==(c[P+16>>2]|0)){mo[c[(c[P>>2]|0)+40>>2]&4095](P)|0;qa=X}else{c[Q>>2]=ja+4;qa=X}do{ja=c[b>>2]|0;do if(ja){Q=c[ja+12>>2]|0;if((Q|0)==(c[ja+16>>2]|0))ra=mo[c[(c[ja>>2]|0)+36>>2]&4095](ja)|0;else ra=c[Q>>2]|0;if((ra|0)==-1){c[b>>2]=0;sa=1;break}else{sa=(c[b>>2]|0)==0;break}}else sa=1;while(0);ja=c[e>>2]|0;do if(ja){Q=c[ja+12>>2]|0;if((Q|0)==(c[ja+16>>2]|0))ta=mo[c[(c[ja>>2]|0)+36>>2]&4095](ja)|0;else ta=c[Q>>2]|0;if((ta|0)!=-1)if(sa^(c[e>>2]|0)==0)break;else{W=254;break a}else{c[e>>2]=0;W=248;break}}else W=248;while(0);if((W|0)==248?(W=0,sa):0){W=254;break a}ja=c[b>>2]|0;Q=c[ja+12>>2]|0;if((Q|0)==(c[ja+16>>2]|0))ua=mo[c[(c[ja>>2]|0)+36>>2]&4095](ja)|0;else ua=c[Q>>2]|0;if(!(xo[c[(c[l>>2]|0)+12>>2]&2047](l,2048,ua)|0)){W=254;break a}if((c[n>>2]|0)==(c[q>>2]|0))lAi(m,n,q);Q=c[b>>2]|0;ja=c[Q+12>>2]|0;if((ja|0)==(c[Q+16>>2]|0))va=mo[c[(c[Q>>2]|0)+36>>2]&4095](Q)|0;else va=c[ja>>2]|0;ja=c[n>>2]|0;c[n>>2]=ja+4;c[ja>>2]=va;qa=qa+-1|0;c[D>>2]=qa;ja=c[b>>2]|0;Q=ja+12|0;P=c[Q>>2]|0;if((P|0)==(c[ja+16>>2]|0))mo[c[(c[ja>>2]|0)+40>>2]&4095](ja)|0;else c[Q>>2]=P+4}while((qa|0)>0)}if((c[n>>2]|0)==(c[m>>2]|0)){W=265;break a}else{wa=la;xa=O}break}case 1:{if((r|0)==3){U=N;V=O;W=267;break a}X=c[b>>2]|0;P=c[X+12>>2]|0;if((P|0)==(c[X+16>>2]|0))ya=mo[c[(c[X>>2]|0)+36>>2]&4095](X)|0;else ya=c[P>>2]|0;if(!(xo[c[(c[l>>2]|0)+12>>2]&2047](l,8192,ya)|0)){W=28;break a}P=c[b>>2]|0;X=P+12|0;Q=c[X>>2]|0;if((Q|0)==(c[P+16>>2]|0))za=mo[c[(c[P>>2]|0)+40>>2]&4095](P)|0;else{c[X>>2]=Q+4;za=c[Q>>2]|0}Xri(C,za);W=29;break}case 0:{W=29;break}case 3:{Q=a[A>>0]|0;X=(Q&1)==0;if(X)Aa=(Q&255)>>>1;else Aa=c[F>>2]|0;P=a[B>>0]|0;ja=(P&1)==0;if(ja)Ba=(P&255)>>>1;else Ba=c[g>>2]|0;if((Aa|0)==(0-Ba|0)){wa=N;xa=O}else{if(X)Ca=(Q&255)>>>1;else Ca=c[F>>2]|0;if(Ca){if(ja)Da=(P&255)>>>1;else Da=c[g>>2]|0;if(Da){ja=c[b>>2]|0;Y=c[ja+12>>2]|0;if((Y|0)==(c[ja+16>>2]|0)){Z=mo[c[(c[ja>>2]|0)+36>>2]&4095](ja)|0;Ea=Z;Fa=a[A>>0]|0}else{Ea=c[Y>>2]|0;Fa=Q}Y=c[b>>2]|0;Z=Y+12|0;ja=c[Z>>2]|0;Ga=(ja|0)==(c[Y+16>>2]|0);if((Ea|0)==(c[((Fa&1)==0?F:c[G>>2]|0)>>2]|0)){if(Ga)mo[c[(c[Y>>2]|0)+40>>2]&4095](Y)|0;else c[Z>>2]=ja+4;Z=a[A>>0]|0;if(!(Z&1))Ha=(Z&255)>>>1;else Ha=c[F>>2]|0;wa=N;xa=Ha>>>0>1?A:O;break b}if(Ga)Ia=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else Ia=c[ja>>2]|0;if((Ia|0)!=(c[((a[B>>0]&1)==0?g:c[f>>2]|0)>>2]|0)){W=117;break a}ja=c[b>>2]|0;Y=ja+12|0;Ga=c[Y>>2]|0;if((Ga|0)==(c[ja+16>>2]|0))mo[c[(c[ja>>2]|0)+40>>2]&4095](ja)|0;else c[Y>>2]=Ga+4;a[k>>0]=1;Ga=a[B>>0]|0;if(!(Ga&1))Ja=(Ga&255)>>>1;else Ja=c[g>>2]|0;wa=N;xa=Ja>>>0>1?B:O;break b}}if(X)Ka=(Q&255)>>>1;else Ka=c[F>>2]|0;X=c[b>>2]|0;Ga=c[X+12>>2]|0;Y=(Ga|0)==(c[X+16>>2]|0);if(!Ka){if(Y){ja=mo[c[(c[X>>2]|0)+36>>2]&4095](X)|0;La=ja;Ma=a[B>>0]|0}else{La=c[Ga>>2]|0;Ma=P}if((La|0)!=(c[((Ma&1)==0?g:c[f>>2]|0)>>2]|0)){wa=N;xa=O;break b}P=c[b>>2]|0;ja=P+12|0;Z=c[ja>>2]|0;if((Z|0)==(c[P+16>>2]|0))mo[c[(c[P>>2]|0)+40>>2]&4095](P)|0;else c[ja>>2]=Z+4;a[k>>0]=1;Z=a[B>>0]|0;if(!(Z&1))Na=(Z&255)>>>1;else Na=c[g>>2]|0;wa=N;xa=Na>>>0>1?B:O;break b}if(Y){Y=mo[c[(c[X>>2]|0)+36>>2]&4095](X)|0;Oa=Y;Pa=a[A>>0]|0}else{Oa=c[Ga>>2]|0;Pa=Q}if((Oa|0)!=(c[((Pa&1)==0?F:c[G>>2]|0)>>2]|0)){a[k>>0]=1;wa=N;xa=O;break b}Q=c[b>>2]|0;Ga=Q+12|0;Y=c[Ga>>2]|0;if((Y|0)==(c[Q+16>>2]|0))mo[c[(c[Q>>2]|0)+40>>2]&4095](Q)|0;else c[Ga>>2]=Y+4;Y=a[A>>0]|0;if(!(Y&1))Qa=(Y&255)>>>1;else Qa=c[F>>2]|0;wa=N;xa=Qa>>>0>1?A:O}break}case 2:{if(!((O|0)!=0|r>>>0<2)){if((r|0)==2)Ra=(a[L>>0]|0)!=0;else Ra=0;if(!(H|Ra)){wa=N;xa=0;break b}}Y=a[z>>0]|0;Ga=(Y&1)==0?h:c[I>>2]|0;d:do if((r|0)!=0?(d[v+(r+-1)>>0]|0)<2:0){Q=Y;X=Ga;while(1){if(!(Q&1)){Sa=h;Ta=(Q&255)>>>1}else{Sa=c[I>>2]|0;Ta=c[h>>2]|0}if((X|0)==(Sa+(Ta<<2)|0)){Ua=Q;Va=X;break}if(!(xo[c[(c[l>>2]|0)+12>>2]&2047](l,8192,c[X>>2]|0)|0)){Wa=X;W=129;break}Q=a[z>>0]|0;X=X+4|0}if((W|0)==129){W=0;Ua=a[z>>0]|0;Va=Wa}X=(Ua&1)==0;Q=Va-(X?h:c[I>>2]|0)>>2;Z=a[C>>0]|0;ja=(Z&1)==0;if(ja)Xa=(Z&255)>>>1;else Xa=c[J>>2]|0;e:do if(Q>>>0<=Xa>>>0){if(ja){Ya=J;Za=(Z&255)>>>1;_a=J+(((Z&255)>>>1)-Q<<2)|0}else{P=c[K>>2]|0;$a=c[J>>2]|0;Ya=P;Za=$a;_a=P+($a-Q<<2)|0}$a=Ya+(Za<<2)|0;if((_a|0)==($a|0)){ab=Ua;bb=Va;break d}else{cb=_a;db=X?h:c[I>>2]|0}while(1){if((c[cb>>2]|0)!=(c[db>>2]|0))break e;cb=cb+4|0;if((cb|0)==($a|0)){ab=Ua;bb=Va;break d}else db=db+4|0}}while(0);ab=Ua;bb=X?h:c[I>>2]|0}else{ab=Y;bb=Ga}while(0);f:while(1){if(!(ab&1)){eb=h;fb=(ab&255)>>>1}else{eb=c[I>>2]|0;fb=c[h>>2]|0}if((bb|0)==(eb+(fb<<2)|0)){gb=bb;break}Ga=c[b>>2]|0;do if(Ga){Y=c[Ga+12>>2]|0;if((Y|0)==(c[Ga+16>>2]|0))hb=mo[c[(c[Ga>>2]|0)+36>>2]&4095](Ga)|0;else hb=c[Y>>2]|0;if((hb|0)==-1){c[b>>2]=0;ib=1;break}else{ib=(c[b>>2]|0)==0;break}}else ib=1;while(0);Ga=c[e>>2]|0;do if(Ga){X=c[Ga+12>>2]|0;if((X|0)==(c[Ga+16>>2]|0))jb=mo[c[(c[Ga>>2]|0)+36>>2]&4095](Ga)|0;else jb=c[X>>2]|0;if((jb|0)!=-1)if(ib^(c[e>>2]|0)==0)break;else{gb=bb;break f}else{c[e>>2]=0;W=159;break}}else W=159;while(0);if((W|0)==159?(W=0,ib):0){gb=bb;break}Ga=c[b>>2]|0;X=c[Ga+12>>2]|0;if((X|0)==(c[Ga+16>>2]|0))kb=mo[c[(c[Ga>>2]|0)+36>>2]&4095](Ga)|0;else kb=c[X>>2]|0;if((kb|0)!=(c[bb>>2]|0)){gb=bb;break}X=c[b>>2]|0;Ga=X+12|0;Y=c[Ga>>2]|0;if((Y|0)==(c[X+16>>2]|0))mo[c[(c[X>>2]|0)+40>>2]&4095](X)|0;else c[Ga>>2]=Y+4;ab=a[z>>0]|0;bb=bb+4|0}if(H){Y=a[z>>0]|0;if(!(Y&1)){lb=h;mb=(Y&255)>>>1}else{lb=c[I>>2]|0;mb=c[h>>2]|0}if((gb|0)!=(lb+(mb<<2)|0)){W=174;break a}else{wa=N;xa=O}}else{wa=N;xa=O}break}default:{wa=N;xa=O}}while(0);g:do if((W|0)==29){W=0;if((r|0)==3){U=N;V=O;W=267;break a}while(1){Y=c[b>>2]|0;do if(Y){Ga=c[Y+12>>2]|0;if((Ga|0)==(c[Y+16>>2]|0))nb=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else nb=c[Ga>>2]|0;if((nb|0)==-1){c[b>>2]=0;ob=1;break}else{ob=(c[b>>2]|0)==0;break}}else ob=1;while(0);Y=c[e>>2]|0;do if(Y){Ga=c[Y+12>>2]|0;if((Ga|0)==(c[Y+16>>2]|0))pb=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else pb=c[Ga>>2]|0;if((pb|0)!=-1)if(ob^(c[e>>2]|0)==0)break;else{wa=N;xa=O;break g}else{c[e>>2]=0;W=43;break}}else W=43;while(0);if((W|0)==43?(W=0,ob):0){wa=N;xa=O;break g}Y=c[b>>2]|0;Ga=c[Y+12>>2]|0;if((Ga|0)==(c[Y+16>>2]|0))qb=mo[c[(c[Y>>2]|0)+36>>2]&4095](Y)|0;else qb=c[Ga>>2]|0;if(!(xo[c[(c[l>>2]|0)+12>>2]&2047](l,8192,qb)|0)){wa=N;xa=O;break g}Ga=c[b>>2]|0;Y=Ga+12|0;X=c[Y>>2]|0;if((X|0)==(c[Ga+16>>2]|0))rb=mo[c[(c[Ga>>2]|0)+40>>2]&4095](Ga)|0;else{c[Y>>2]=X+4;rb=c[X>>2]|0}Xri(C,rb)}}while(0);r=r+1|0;if(r>>>0>=4){U=wa;V=xa;W=267;break}else{N=wa;O=xa}}h:do if((W|0)==28){c[j>>2]=c[j>>2]|4;sb=0}else if((W|0)==117){c[j>>2]=c[j>>2]|4;sb=0}else if((W|0)==174){c[j>>2]=c[j>>2]|4;sb=0}else if((W|0)==231){c[j>>2]=c[j>>2]|4;sb=0}else if((W|0)==254){c[j>>2]=c[j>>2]|4;sb=0}else if((W|0)==265){c[j>>2]=c[j>>2]|4;sb=0}else if((W|0)==267){i:do if(V){xa=V+4|0;O=V+8|0;wa=1;j:while(1){N=a[V>>0]|0;if(!(N&1))tb=(N&255)>>>1;else tb=c[xa>>2]|0;if(wa>>>0>=tb>>>0)break i;N=c[b>>2]|0;do if(N){r=c[N+12>>2]|0;if((r|0)==(c[N+16>>2]|0))ub=mo[c[(c[N>>2]|0)+36>>2]&4095](N)|0;else ub=c[r>>2]|0;if((ub|0)==-1){c[b>>2]=0;vb=1;break}else{vb=(c[b>>2]|0)==0;break}}else vb=1;while(0);N=c[e>>2]|0;do if(N){r=c[N+12>>2]|0;if((r|0)==(c[N+16>>2]|0))wb=mo[c[(c[N>>2]|0)+36>>2]&4095](N)|0;else wb=c[r>>2]|0;if((wb|0)!=-1)if(vb^(c[e>>2]|0)==0)break;else break j;else{c[e>>2]=0;W=286;break}}else W=286;while(0);if((W|0)==286?(W=0,vb):0)break;N=c[b>>2]|0;r=c[N+12>>2]|0;if((r|0)==(c[N+16>>2]|0))xb=mo[c[(c[N>>2]|0)+36>>2]&4095](N)|0;else xb=c[r>>2]|0;if(!(a[V>>0]&1))yb=xa;else yb=c[O>>2]|0;if((xb|0)!=(c[yb+(wa<<2)>>2]|0))break;r=wa+1|0;N=c[b>>2]|0;rb=N+12|0;qb=c[rb>>2]|0;if((qb|0)==(c[N+16>>2]|0)){mo[c[(c[N>>2]|0)+40>>2]&4095](N)|0;wa=r;continue}else{c[rb>>2]=qb+4;wa=r;continue}}c[j>>2]=c[j>>2]|4;sb=0;break h}while(0);wa=c[s>>2]|0;if((wa|0)!=(U|0)?(c[E>>2]=0,Uwi(y,wa,U,E),(c[E>>2]|0)!=0):0){c[j>>2]=c[j>>2]|4;sb=0}else sb=1}while(0);Tri(C);Tri(B);Tri(A);Tri(z);xri(y);y=c[s>>2]|0;c[s>>2]=0;if(!y){i=p;return sb|0}ko[c[o>>2]&4095](y);i=p;return sb|0}function Zwi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+432|0;l=d+4|0;m=d+16|0;n=d+8|0;o=d+420|0;p=d;q=d+424|0;r=d+416|0;c[n>>2]=m;s=n+4|0;c[s>>2]=3595;dsi(p,h);t=Kxi(p,3654792)|0;a[q>>0]=0;u=c[f>>2]|0;c[r>>2]=u;v=c[h+4>>2]|0;c[l+0>>2]=c[r+0>>2];if(Ywi(e,l,g,p,v,j,q,t,n,o,m+400|0)|0){if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;if(a[q>>0]|0)Xri(k,_n[c[(c[t>>2]|0)+44>>2]&4095](t,45)|0);q=_n[c[(c[t>>2]|0)+44>>2]&4095](t,48)|0;t=c[n>>2]|0;m=c[o>>2]|0;o=m+-4|0;a:do if(t>>>0<o>>>0){v=t;while(1){g=v+4|0;if((c[v>>2]|0)!=(q|0)){w=v;break a}if(g>>>0<o>>>0)v=g;else{w=g;break}}}else w=t;while(0);mAi(k,w,m)|0}m=c[e>>2]|0;do if(m){w=c[m+12>>2]|0;if((w|0)==(c[m+16>>2]|0))x=mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0;else x=c[w>>2]|0;if((x|0)==-1){c[e>>2]=0;y=1;break}else{y=(c[e>>2]|0)==0;break}}else y=1;while(0);do if(u){x=c[u+12>>2]|0;if((x|0)==(c[u+16>>2]|0))z=mo[c[(c[u>>2]|0)+36>>2]&4095](u)|0;else z=c[x>>2]|0;if((z|0)!=-1)if(y)break;else{A=26;break}else{c[f>>2]=0;A=24;break}}else A=24;while(0);if((A|0)==24?y:0)A=26;if((A|0)==26)c[j>>2]=c[j>>2]|2;c[b>>2]=c[e>>2];$qi(c[p>>2]|0)|0;p=c[n>>2]|0;c[n>>2]=0;if(!p){i=d;return}ko[c[s>>2]&4095](p);i=d;return}function _wi(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=i;i=i+112|0;o=n;p=n+40|0;q=n+76|0;r=n+4|0;s=n+88|0;t=n+100|0;u=n+28|0;v=n+64|0;w=n+52|0;x=n+16|0;if(b){b=Kxi(d,3654368)|0;In[c[(c[b>>2]|0)+44>>2]&4095](o,b);y=c[o>>2]|0;a[e>>0]=y;a[e+1>>0]=y>>8;a[e+2>>0]=y>>16;a[e+3>>0]=y>>24;In[c[(c[b>>2]|0)+32>>2]&4095](p,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;Wri(l,0);c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Tri(p);In[c[(c[b>>2]|0)+28>>2]&4095](q,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;Wri(k,0);c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Tri(q);c[f>>2]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;c[g>>2]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](r,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Dri(h,0);c[h+0>>2]=c[r+0>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;xri(r);In[c[(c[b>>2]|0)+24>>2]&4095](s,b);if(!(a[j>>0]&1))a[j>>0]=0;else c[c[j+8>>2]>>2]=0;c[j+4>>2]=0;Wri(j,0);c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;Tri(s);z=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=z;i=n;return}else{b=Kxi(d,3654304)|0;In[c[(c[b>>2]|0)+44>>2]&4095](t,b);d=c[t>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>8;a[e+2>>0]=d>>16;a[e+3>>0]=d>>24;In[c[(c[b>>2]|0)+32>>2]&4095](u,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;Wri(l,0);c[l+0>>2]=c[u+0>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Tri(u);In[c[(c[b>>2]|0)+28>>2]&4095](v,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;Wri(k,0);c[k+0>>2]=c[v+0>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Tri(v);c[f>>2]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;c[g>>2]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](w,b);if(!(a[h>>0]&1)){a[h+1>>0]=0;a[h>>0]=0}else{a[c[h+8>>2]>>0]=0;c[h+4>>2]=0}Dri(h,0);c[h+0>>2]=c[w+0>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;xri(w);In[c[(c[b>>2]|0)+24>>2]&4095](x,b);if(!(a[j>>0]&1))a[j>>0]=0;else c[c[j+8>>2]>>2]=0;c[j+4>>2]=0;Wri(j,0);c[j+0>>2]=c[x+0>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Tri(x);z=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=z;i=n;return}}function $wi(a){a=a|0;return}function axi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bxi(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+384|0;m=d;n=d+68|0;o=d+32|0;p=d+168|0;q=d+60|0;r=d+268|0;s=d+372|0;t=d+373|0;u=d+20|0;v=d+36|0;w=d+48|0;x=d+16|0;y=d+272|0;z=d+8|0;A=d+12|0;B=d+64|0;c[o>>2]=n;h[k>>3]=l;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];C=rEi(n,100,3654552,m)|0;if(C>>>0>99){n=Xti()|0;h[k>>3]=l;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];D=eAi(o,n,3654552,m)|0;n=c[o>>2]|0;if(!n)uDi();E=ADi(D)|0;if(!E)uDi();else{F=E;G=n;H=E;I=D}}else{F=0;G=0;H=p;I=C}dsi(q,g);C=Kxi(q,3654800)|0;p=c[o>>2]|0;kn[c[(c[C>>2]|0)+32>>2]&511](C,p,p+I|0,H)|0;if(!I)J=0;else J=(a[c[o>>2]>>0]|0)==45;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;cxi(f,J,q,r,s,t,u,v,w,x);f=c[x>>2]|0;if((I|0)>(f|0)){x=a[w>>0]|0;if(!(x&1))K=(x&255)>>>1;else K=c[w+4>>2]|0;x=a[v>>0]|0;if(!(x&1))L=(x&255)>>>1;else L=c[v+4>>2]|0;M=K+(I-f<<1|1)+L|0}else{L=a[w>>0]|0;if(!(L&1))N=(L&255)>>>1;else N=c[w+4>>2]|0;L=a[v>>0]|0;if(!(L&1))O=(L&255)>>>1;else O=c[v+4>>2]|0;M=N+2+O|0}O=M+f|0;if(O>>>0>100){M=ADi(O)|0;if(!M)uDi();else{P=M;Q=M}}else{P=0;Q=y}dxi(Q,z,A,c[g+4>>2]|0,H,H+I|0,C,J,r,a[s>>0]|0,a[t>>0]|0,u,v,w,f);c[B>>2]=c[e>>2];e=c[z>>2]|0;z=c[A>>2]|0;c[m+0>>2]=c[B+0>>2];KP(b,m,Q,e,z,g,j);BDi(P);xri(w);xri(v);xri(u);$qi(c[q>>2]|0)|0;BDi(F);BDi(G);i=d;return}function cxi(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=i;i=i+112|0;o=n+12|0;p=n+40|0;q=n+92|0;r=n;s=n+80|0;t=n+96|0;u=n+108|0;v=n+56|0;w=n+52|0;x=n+16|0;y=n+28|0;z=n+68|0;if(b){b=Kxi(e,3654240)|0;A=c[b>>2]|0;if(d){In[c[A+44>>2]&4095](o,b);B=c[o>>2]|0;a[f>>0]=B;a[f+1>>0]=B>>8;a[f+2>>0]=B>>16;a[f+3>>0]=B>>24;In[c[(c[b>>2]|0)+32>>2]&4095](p,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Dri(l,0);c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;xri(p)}else{In[c[A+40>>2]&4095](q,b);A=c[q>>2]|0;a[f>>0]=A;a[f+1>>0]=A>>8;a[f+2>>0]=A>>16;a[f+3>>0]=A>>24;In[c[(c[b>>2]|0)+28>>2]&4095](r,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Dri(l,0);c[l+0>>2]=c[r+0>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;xri(r)}a[g>>0]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;a[h>>0]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](s,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Dri(j,0);c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;xri(s);In[c[(c[b>>2]|0)+24>>2]&4095](t,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Dri(k,0);c[k+0>>2]=c[t+0>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;xri(t);C=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=C;i=n;return}else{b=Kxi(e,3654176)|0;e=c[b>>2]|0;if(d){In[c[e+44>>2]&4095](u,b);d=c[u>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;In[c[(c[b>>2]|0)+32>>2]&4095](v,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Dri(l,0);c[l+0>>2]=c[v+0>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;xri(v)}else{In[c[e+40>>2]&4095](w,b);e=c[w>>2]|0;a[f>>0]=e;a[f+1>>0]=e>>8;a[f+2>>0]=e>>16;a[f+3>>0]=e>>24;In[c[(c[b>>2]|0)+28>>2]&4095](x,b);if(!(a[l>>0]&1)){a[l+1>>0]=0;a[l>>0]=0}else{a[c[l+8>>2]>>0]=0;c[l+4>>2]=0}Dri(l,0);c[l+0>>2]=c[x+0>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;xri(x)}a[g>>0]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;a[h>>0]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](y,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Dri(j,0);c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;xri(y);In[c[(c[b>>2]|0)+24>>2]&4095](z,b);if(!(a[k>>0]&1)){a[k+1>>0]=0;a[k>>0]=0}else{a[c[k+8>>2]>>0]=0;c[k+4>>2]=0}Dri(k,0);c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;xri(z);C=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=C;i=n;return}}function dxi(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){switch(a[m+h>>0]|0){case 1:{c[e>>2]=c[f>>2];I=_n[c[(c[k>>2]|0)+28>>2]&4095](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J>>0]=I;K=H;break}case 3:{I=a[r>>0]|0;J=(I&1)==0;if(J)L=(I&255)>>>1;else L=c[w>>2]|0;if(!L)K=H;else{I=a[(J?u:c[v>>2]|0)>>0]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J>>0]=I;K=H}break}case 4:{I=c[f>>2]|0;J=l?H+1|0:H;a:do if(J>>>0<j>>>0){M=c[F>>2]|0;N=J;while(1){O=a[N>>0]|0;if(O<<24>>24<=-1){P=N;break a}Q=N+1|0;if(!(b[M+(O<<24>>24<<1)>>1]&2048)){P=N;break a}if(Q>>>0<j>>>0)N=Q;else{P=Q;break}}}else P=J;while(0);N=P;if(B){if(P>>>0>J>>>0){M=J-N|0;N=M>>>0<G>>>0?G:M;M=N+s|0;Q=I;O=P;R=s;while(1){S=O+-1|0;T=a[S>>0]|0;c[f>>2]=Q+1;a[Q>>0]=T;T=R+-1|0;U=(T|0)>0;if(!(S>>>0>J>>>0&U))break;Q=c[f>>2]|0;O=S;R=T}R=P+N|0;if(U){V=R;W=M;X=31}else{Y=0;Z=R;_=M}}else{V=P;W=s;X=31}if((X|0)==31){X=0;Y=_n[c[(c[k>>2]|0)+28>>2]&4095](k,48)|0;Z=V;_=W}R=c[f>>2]|0;c[f>>2]=R+1;if((_|0)>0){O=R;Q=_;while(1){a[O>>0]=Y;Q=Q+-1|0;T=c[f>>2]|0;c[f>>2]=T+1;if((Q|0)<=0){$=T;break}else O=T}}else $=R;a[$>>0]=n;aa=Z}else aa=P;if((aa|0)==(J|0)){O=_n[c[(c[k>>2]|0)+28>>2]&4095](k,48)|0;Q=c[f>>2]|0;c[f>>2]=Q+1;a[Q>>0]=O}else{O=a[p>>0]|0;Q=(O&1)==0;if(Q)ba=(O&255)>>>1;else ba=c[E>>2]|0;if(!ba){ca=aa;da=-1;ea=0;fa=0}else{ca=aa;da=a[(Q?C:c[D>>2]|0)>>0]|0;ea=0;fa=0}while(1){if((fa|0)==(da|0)){Q=c[f>>2]|0;c[f>>2]=Q+1;a[Q>>0]=o;Q=ea+1|0;O=a[p>>0]|0;M=(O&1)==0;if(M)ga=(O&255)>>>1;else ga=c[E>>2]|0;if(Q>>>0<ga>>>0)if((a[(M?C:c[D>>2]|0)+Q>>0]|0)==127){ha=-1;ia=Q;ja=0}else{ha=a[(M?C:c[D>>2]|0)+Q>>0]|0;ia=Q;ja=0}else{ha=da;ia=Q;ja=0}}else{ha=da;ia=ea;ja=fa}ca=ca+-1|0;Q=a[ca>>0]|0;M=c[f>>2]|0;c[f>>2]=M+1;a[M>>0]=Q;if((ca|0)==(J|0))break;else{da=ha;ea=ia;fa=ja+1|0}}}R=c[f>>2]|0;if((I|0)!=(R|0)?(Q=R+-1|0,Q>>>0>I>>>0):0){M=I;O=Q;Q=R;while(1){R=a[M>>0]|0;a[M>>0]=a[O>>0]|0;a[O>>0]=R;M=M+1|0;R=Q+-2|0;if(M>>>0>=R>>>0){K=J;break}else{N=O;O=R;Q=N}}}else K=J;break}case 2:{Q=a[q>>0]|0;O=(Q&1)==0;if(O)ka=(Q&255)>>>1;else ka=c[A>>2]|0;if((ka|0)==0|x)K=H;else{if(O){la=y;ma=(Q&255)>>>1}else{la=c[z>>2]|0;ma=c[A>>2]|0}Q=la+ma|0;O=c[f>>2]|0;if((la|0)==(Q|0))na=O;else{M=O;O=la;while(1){a[M>>0]=a[O>>0]|0;O=O+1|0;I=M+1|0;if((O|0)==(Q|0)){na=I;break}else M=I}}c[f>>2]=na;K=H}break}case 0:{c[e>>2]=c[f>>2];K=H;break}default:K=H}h=h+1|0;if((h|0)==4)break;else H=K}K=a[r>>0]|0;r=(K&1)==0;if(r)oa=(K&255)>>>1;else oa=c[w>>2]|0;if(oa>>>0>1){if(r){pa=u;qa=(K&255)>>>1}else{pa=c[v>>2]|0;qa=c[w>>2]|0}w=pa+1|0;v=pa+qa|0;qa=c[f>>2]|0;if((w|0)==(v|0))ra=qa;else{K=qa;qa=w;w=pa;while(1){a[K>>0]=a[qa>>0]|0;pa=w+2|0;u=K+1|0;if((pa|0)==(v|0)){ra=u;break}else{r=qa;K=u;qa=pa;w=r}}}c[f>>2]=ra}ra=g&176;if((ra|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((ra|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function exi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+176|0;k=d+20|0;l=d+24|0;m=d+60|0;n=d+64|0;o=d+65|0;p=d;q=d+48|0;r=d+32|0;s=d+12|0;t=d+68|0;u=d+44|0;v=d+28|0;w=d+16|0;dsi(l,g);x=Kxi(l,3654800)|0;y=a[j>>0]|0;z=(y&1)==0;if(z)A=(y&255)>>>1;else A=c[j+4>>2]|0;if(!A)B=0;else{if(z)C=j+1|0;else C=c[j+8>>2]|0;z=a[C>>0]|0;B=z<<24>>24==(_n[c[(c[x>>2]|0)+28>>2]&4095](x,45)|0)<<24>>24};c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;cxi(f,B,l,m,n,o,p,q,r,s);f=a[j>>0]|0;z=(f&1)==0;if(z)D=(f&255)>>>1;else D=c[j+4>>2]|0;C=c[s>>2]|0;if((D|0)>(C|0)){if(z)E=(f&255)>>>1;else E=c[j+4>>2]|0;z=a[r>>0]|0;if(!(z&1))F=(z&255)>>>1;else F=c[r+4>>2]|0;z=a[q>>0]|0;if(!(z&1))G=(z&255)>>>1;else G=c[q+4>>2]|0;H=F+(E-C<<1|1)+G|0}else{G=a[r>>0]|0;if(!(G&1))I=(G&255)>>>1;else I=c[r+4>>2]|0;G=a[q>>0]|0;if(!(G&1))J=(G&255)>>>1;else J=c[q+4>>2]|0;H=I+2+J|0}J=H+C|0;if(J>>>0>100){H=ADi(J)|0;if(!H)uDi();else{K=H;L=H}}else{K=0;L=t}if(!(f&1)){M=j+1|0;N=(f&255)>>>1}else{M=c[j+8>>2]|0;N=c[j+4>>2]|0}dxi(L,u,v,c[g+4>>2]|0,M,M+N|0,x,B,m,a[n>>0]|0,a[o>>0]|0,p,q,r,C);c[w>>2]=c[e>>2];e=c[u>>2]|0;u=c[v>>2]|0;c[k+0>>2]=c[w+0>>2];KP(b,k,L,e,u,g,h);BDi(K);xri(r);xri(q);xri(p);$qi(c[l>>2]|0)|0;i=d;return}function fxi(a){a=a|0;return}function gxi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function hxi(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+992|0;m=d;n=d+876|0;o=d+12|0;p=d+424|0;q=d+16|0;r=d+976|0;s=d+868|0;t=d+824|0;u=d+828|0;v=d+840|0;w=d+852|0;x=d+864|0;y=d+24|0;z=d+8|0;A=d+20|0;B=d+872|0;c[o>>2]=n;h[k>>3]=l;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];C=rEi(n,100,3654552,m)|0;if(C>>>0>99){n=Xti()|0;h[k>>3]=l;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];D=eAi(o,n,3654552,m)|0;n=c[o>>2]|0;if(!n)uDi();E=ADi(D<<2)|0;if(!E)uDi();else{F=E;G=n;H=E;I=D}}else{F=0;G=0;H=p;I=C}dsi(q,g);C=Kxi(q,3654792)|0;p=c[o>>2]|0;kn[c[(c[C>>2]|0)+48>>2]&511](C,p,p+I|0,H)|0;if(!I)J=0;else J=(a[c[o>>2]>>0]|0)==45;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;ixi(f,J,q,r,s,t,u,v,w,x);f=c[x>>2]|0;if((I|0)>(f|0)){x=a[w>>0]|0;if(!(x&1))K=(x&255)>>>1;else K=c[w+4>>2]|0;x=a[v>>0]|0;if(!(x&1))L=(x&255)>>>1;else L=c[v+4>>2]|0;M=K+(I-f<<1|1)+L|0}else{L=a[w>>0]|0;if(!(L&1))N=(L&255)>>>1;else N=c[w+4>>2]|0;L=a[v>>0]|0;if(!(L&1))O=(L&255)>>>1;else O=c[v+4>>2]|0;M=N+2+O|0}O=M+f|0;if(O>>>0>100){M=ADi(O<<2)|0;if(!M)uDi();else{P=M;Q=M}}else{P=0;Q=y}jxi(Q,z,A,c[g+4>>2]|0,H,H+(I<<2)|0,C,J,r,c[s>>2]|0,c[t>>2]|0,u,v,w,f);c[B>>2]=c[e>>2];e=c[z>>2]|0;z=c[A>>2]|0;c[m+0>>2]=c[B+0>>2];fAi(b,m,Q,e,z,g,j);if(P)BDi(P);Tri(w);Tri(v);xri(u);$qi(c[q>>2]|0)|0;if(!F){BDi(G);i=d;return}BDi(F);BDi(G);i=d;return}function ixi(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=i;i=i+112|0;o=n+12|0;p=n+40|0;q=n+92|0;r=n;s=n+80|0;t=n+96|0;u=n+108|0;v=n+56|0;w=n+52|0;x=n+16|0;y=n+28|0;z=n+68|0;if(b){b=Kxi(e,3654368)|0;A=c[b>>2]|0;if(d){In[c[A+44>>2]&4095](o,b);B=c[o>>2]|0;a[f>>0]=B;a[f+1>>0]=B>>8;a[f+2>>0]=B>>16;a[f+3>>0]=B>>24;In[c[(c[b>>2]|0)+32>>2]&4095](p,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;Wri(l,0);c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Tri(p)}else{In[c[A+40>>2]&4095](q,b);A=c[q>>2]|0;a[f>>0]=A;a[f+1>>0]=A>>8;a[f+2>>0]=A>>16;a[f+3>>0]=A>>24;In[c[(c[b>>2]|0)+28>>2]&4095](r,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;Wri(l,0);c[l+0>>2]=c[r+0>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Tri(r)}c[g>>2]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;c[h>>2]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](s,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Dri(j,0);c[j+0>>2]=c[s+0>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[s+0>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;xri(s);In[c[(c[b>>2]|0)+24>>2]&4095](t,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;Wri(k,0);c[k+0>>2]=c[t+0>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;Tri(t);C=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=C;i=n;return}else{b=Kxi(e,3654304)|0;e=c[b>>2]|0;if(d){In[c[e+44>>2]&4095](u,b);d=c[u>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;In[c[(c[b>>2]|0)+32>>2]&4095](v,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;Wri(l,0);c[l+0>>2]=c[v+0>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Tri(v)}else{In[c[e+40>>2]&4095](w,b);e=c[w>>2]|0;a[f>>0]=e;a[f+1>>0]=e>>8;a[f+2>>0]=e>>16;a[f+3>>0]=e>>24;In[c[(c[b>>2]|0)+28>>2]&4095](x,b);if(!(a[l>>0]&1))a[l>>0]=0;else c[c[l+8>>2]>>2]=0;c[l+4>>2]=0;Wri(l,0);c[l+0>>2]=c[x+0>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[x+0>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Tri(x)}c[g>>2]=mo[c[(c[b>>2]|0)+12>>2]&4095](b)|0;c[h>>2]=mo[c[(c[b>>2]|0)+16>>2]&4095](b)|0;In[c[(c[b>>2]|0)+20>>2]&4095](y,b);if(!(a[j>>0]&1)){a[j+1>>0]=0;a[j>>0]=0}else{a[c[j+8>>2]>>0]=0;c[j+4>>2]=0}Dri(j,0);c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;xri(y);In[c[(c[b>>2]|0)+24>>2]&4095](z,b);if(!(a[k>>0]&1))a[k>>0]=0;else c[c[k+8>>2]>>2]=0;c[k+4>>2]=0;Wri(k,0);c[k+0>>2]=c[z+0>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Tri(z);C=mo[c[(c[b>>2]|0)+36>>2]&4095](b)|0;c[m>>2]=C;i=n;return}}function jxi(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){switch(a[l+g>>0]|0){case 1:{c[d>>2]=c[e>>2];D=_n[c[(c[j>>2]|0)+44>>2]&4095](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break}case 4:{D=c[e>>2]|0;E=k?C+4|0:C;a:do if(E>>>0<h>>>0){G=E;while(1){H=G+4|0;if(!(xo[c[(c[j>>2]|0)+12>>2]&2047](j,2048,c[G>>2]|0)|0)){I=G;break a}if(H>>>0<h>>>0)G=H;else{I=H;break}}}else I=E;while(0);if(y){if(I>>>0>E>>>0){G=c[e>>2]|0;H=I;J=r;do{H=H+-4|0;K=G;G=G+4|0;c[K>>2]=c[H>>2];J=J+-1|0;L=(J|0)>0}while(H>>>0>E>>>0&L);c[e>>2]=G;if(L){M=H;N=J;O=31}else{K=c[e>>2]|0;c[e>>2]=K+4;P=K;Q=H}}else{M=I;N=r;O=31}if((O|0)==31){O=0;K=_n[c[(c[j>>2]|0)+44>>2]&4095](j,48)|0;R=c[e>>2]|0;S=R+4|0;c[e>>2]=S;if((N|0)>0){T=S;S=R;U=N;while(1){c[S>>2]=K;U=U+-1|0;if((U|0)<=0)break;else{V=T;T=S+8|0;S=V}}c[e>>2]=R+(N+1<<2);P=R+(N<<2)|0;Q=M}else{P=R;Q=M}}c[P>>2]=m;W=Q}else W=I;if((W|0)==(E|0)){S=_n[c[(c[j>>2]|0)+44>>2]&4095](j,48)|0;T=c[e>>2]|0;U=T+4|0;c[e>>2]=U;c[T>>2]=S;X=U;Y=T}else{T=a[o>>0]|0;U=(T&1)==0;if(U)Z=(T&255)>>>1;else Z=c[B>>2]|0;if(!Z){_=W;$=-1;aa=0;ba=0}else{_=W;$=a[(U?z:c[A>>2]|0)>>0]|0;aa=0;ba=0}while(1){U=c[e>>2]|0;if((ba|0)==($|0)){T=U+4|0;c[e>>2]=T;c[U>>2]=n;S=aa+1|0;K=a[o>>0]|0;H=(K&1)==0;if(H)ca=(K&255)>>>1;else ca=c[B>>2]|0;if(S>>>0<ca>>>0)if((a[(H?z:c[A>>2]|0)+S>>0]|0)==127){da=T;ea=-1;fa=S;ga=0}else{da=T;ea=a[(H?z:c[A>>2]|0)+S>>0]|0;fa=S;ga=0}else{da=T;ea=$;fa=S;ga=0}}else{da=U;ea=$;fa=aa;ga=ba}_=_+-4|0;U=c[_>>2]|0;S=da+4|0;c[e>>2]=S;c[da>>2]=U;if((_|0)==(E|0)){X=S;Y=da;break}else{$=ea;aa=fa;ba=ga+1|0}}}if((D|0)!=(X|0)&Y>>>0>D>>>0){R=D;S=Y;U=X;while(1){T=c[R>>2]|0;c[R>>2]=c[S>>2];c[S>>2]=T;R=R+4|0;T=U+-8|0;if(R>>>0>=T>>>0){F=E;break}else{H=S;S=T;U=H}}}else F=E;break}case 3:{U=a[q>>0]|0;S=(U&1)==0;if(S)ha=(U&255)>>>1;else ha=c[t>>2]|0;if(!ha)F=C;else{U=c[(S?t:c[u>>2]|0)>>2]|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=U;F=C}break}case 2:{U=a[p>>0]|0;S=(U&1)==0;if(S)ia=(U&255)>>>1;else ia=c[w>>2]|0;if((ia|0)==0|v)F=C;else{if(S){ja=w;ka=(U&255)>>>1}else{ja=c[x>>2]|0;ka=c[w>>2]|0}U=ja+(ka<<2)|0;S=c[e>>2]|0;if((ja|0)==(U|0))la=S;else{R=(ja+(ka+-1<<2)-ja|0)>>>2;D=S;H=ja;while(1){c[D>>2]=c[H>>2];H=H+4|0;if((H|0)==(U|0))break;else D=D+4|0}la=S+(R+1<<2)|0}c[e>>2]=la;F=C}break}case 0:{c[d>>2]=c[e>>2];F=C;break}default:F=C}g=g+1|0;if((g|0)==4)break;else C=F}F=a[q>>0]|0;q=(F&1)==0;if(q)ma=(F&255)>>>1;else ma=c[t>>2]|0;if(ma>>>0>1){if(q){na=t;oa=(F&255)>>>1}else{na=c[u>>2]|0;oa=c[t>>2]|0}t=na+4|0;u=na+(oa<<2)|0;F=c[e>>2]|0;if((t|0)==(u|0))pa=F;else{q=(na+(oa+-1<<2)-t|0)>>>2;oa=F;ma=t;t=na;while(1){c[oa>>2]=c[ma>>2];na=t+8|0;if((na|0)==(u|0))break;else{C=ma;oa=oa+4|0;ma=na;t=C}}pa=F+(q+1<<2)|0}c[e>>2]=pa}pa=f&176;if((pa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((pa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function kxi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+480|0;k=d+4|0;l=d;m=d+468|0;n=d+432|0;o=d+436|0;p=d+444|0;q=d+456|0;r=d+420|0;s=d+416|0;t=d+8|0;u=d+408|0;v=d+440|0;w=d+412|0;dsi(l,g);x=Kxi(l,3654792)|0;y=a[j>>0]|0;z=(y&1)==0;if(z)A=(y&255)>>>1;else A=c[j+4>>2]|0;if(!A)B=0;else{if(z)C=j+4|0;else C=c[j+8>>2]|0;z=c[C>>2]|0;B=(z|0)==(_n[c[(c[x>>2]|0)+44>>2]&4095](x,45)|0)};c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;ixi(f,B,l,m,n,o,p,q,r,s);f=a[j>>0]|0;z=(f&1)==0;if(z)D=(f&255)>>>1;else D=c[j+4>>2]|0;C=c[s>>2]|0;if((D|0)>(C|0)){if(z)E=(f&255)>>>1;else E=c[j+4>>2]|0;z=a[r>>0]|0;if(!(z&1))F=(z&255)>>>1;else F=c[r+4>>2]|0;z=a[q>>0]|0;if(!(z&1))G=(z&255)>>>1;else G=c[q+4>>2]|0;H=F+(E-C<<1|1)+G|0}else{G=a[r>>0]|0;if(!(G&1))I=(G&255)>>>1;else I=c[r+4>>2]|0;G=a[q>>0]|0;if(!(G&1))J=(G&255)>>>1;else J=c[q+4>>2]|0;H=I+2+J|0}J=H+C|0;if(J>>>0>100){H=ADi(J<<2)|0;if(!H)uDi();else{K=H;L=H}}else{K=0;L=t}if(!(f&1)){M=j+4|0;N=(f&255)>>>1}else{M=c[j+8>>2]|0;N=c[j+4>>2]|0}jxi(L,u,v,c[g+4>>2]|0,M,M+(N<<2)|0,x,B,m,c[n>>2]|0,c[o>>2]|0,p,q,r,C);c[w>>2]=c[e>>2];e=c[u>>2]|0;u=c[v>>2]|0;c[k+0>>2]=c[w+0>>2];fAi(b,k,L,e,u,g,h);if(!K){Tri(r);Tri(q);xri(p);O=c[l>>2]|0;$qi(O)|0;i=d;return}BDi(K);Tri(r);Tri(q);xri(p);O=c[l>>2]|0;$qi(O)|0;i=d;return}function lxi(a){a=a|0;return}function mxi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function nxi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;d=Ni(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)&1)|0}function oxi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;k=a[h>>0]|0;if(!(k&1)){l=h+1|0;m=(k&255)>>>1;n=h+1|0}else{k=c[h+8>>2]|0;l=k;m=c[h+4>>2]|0;n=k}k=l+m|0;if(n>>>0<k>>>0){m=n;do{Fri(j,a[m>>0]|0);m=m+1|0}while((m|0)!=(k|0));k=(e|0)==-1?-1:e<<1;if(!(a[j>>0]&1)){o=k;p=9}else{q=k;r=c[j+8>>2]|0}}else{o=(e|0)==-1?-1:e<<1;p=9}if((p|0)==9){q=o;r=j+1|0}o=$g(q|0,f|0,g|0,r|0)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;r=SEi(o|0)|0;g=o+r|0;if((r|0)>0)s=o;else{xri(j);i=d;return}do{Fri(b,a[s>>0]|0);s=s+1|0}while((s|0)!=(g|0));xri(j);i=d;return}function pxi(a,b){a=a|0;b=b|0;a=i;Nc(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function qxi(a){a=a|0;return}function rxi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function sxi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if(!(a[d>>0]&1))f=d+1|0;else f=c[d+8>>2]|0;d=Ni(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)&1)|0}function txi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+176|0;j=d+24|0;k=d+40|0;l=d+168|0;m=d+172|0;n=d+8|0;o=d;p=d+32|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[o+4>>2]=0;c[o>>2]=3656456;q=a[h>>0]|0;if(!(q&1)){r=h+4|0;s=(q&255)>>>1;t=h+4|0}else{q=c[h+8>>2]|0;r=q;s=c[h+4>>2]|0;t=q}q=r+(s<<2)|0;a:do if(t>>>0<q>>>0){s=k+32|0;r=t;h=3656456|0;while(1){c[m>>2]=r;u=(Oo[c[h+12>>2]&63](o,j,r,q,m,k,s,l)|0)==2;v=c[m>>2]|0;if(u|(v|0)==(r|0))break;if(k>>>0<(c[l>>2]|0)>>>0){u=k;do{Fri(n,a[u>>0]|0);u=u+1|0}while(u>>>0<(c[l>>2]|0)>>>0);w=c[m>>2]|0}else w=v;if(w>>>0>=q>>>0)break a;r=w;h=c[o>>2]|0}Rwi(3655680)}while(0);if(!(a[n>>0]&1))x=n+1|0;else x=c[n+8>>2]|0;o=$g(((e|0)==-1?-1:e<<1)|0,f|0,g|0,x|0)|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[p+4>>2]=0;c[p>>2]=3656560;x=SEi(o|0)|0;g=o+x|0;if((x|0)<=0){xri(n);i=d;return}x=g;f=k+128|0;e=o;o=3656560|0;while(1){c[m>>2]=e;w=(Oo[c[o+16>>2]&63](p,j,e,(x-e|0)>32?e+32|0:g,m,k,f,l)|0)==2;q=c[m>>2]|0;if(w|(q|0)==(e|0)){y=20;break}if(k>>>0<(c[l>>2]|0)>>>0){w=k;do{Xri(b,c[w>>2]|0);w=w+4|0}while(w>>>0<(c[l>>2]|0)>>>0);z=c[m>>2]|0}else z=q;if(z>>>0>=g>>>0){y=25;break}e=z;o=c[p>>2]|0}if((y|0)==20)Rwi(3655680);else if((y|0)==25){xri(n);i=d;return}}function uxi(a,b){a=a|0;b=b|0;a=i;Nc(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function vxi(a){a=a|0;a=al(8)|0;ari(a,3654680);c[a>>2]=3666992;we(a|0,3667032,3427)}function wxi(a){a=a|0;a=al(8)|0;ari(a,3654680);c[a>>2]=3667056;we(a|0,3667096,3427)}function xxi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;c[b+4>>2]=d+-1;c[b>>2]=3654720;d=b+8|0;nAi(d,28);rri(b+144|0,3654704,1);f=c[d>>2]|0;d=b+12|0;g=c[d>>2]|0;if((g|0)!=(f|0))c[d>>2]=g+(~((g+-4-f|0)>>>2)<<2);c[914903]=0;c[914902]=3653168;oAi(b,3659608);c[914901]=0;c[914900]=3653208;pAi(b,3659600);c[914897]=0;c[914896]=3654816;c[914898]=0;a[3659596]=0;c[914898]=Qxi()|0;qAi(b,3659584);c[914895]=0;c[914894]=3655776;rAi(b,3659576);c[914893]=0;c[914892]=3655992;sAi(b,3659568);uyi(3659552,1);tAi(b,3659552);c[914887]=0;c[914886]=3656216;uAi(b,3659544);c[914885]=0;c[914884]=3656336;vAi(b,3659536);c[914879]=0;c[914878]=3654968;a[3659520]=46;a[3659521]=44;c[914881]=0;c[914882]=0;c[914883]=0;wAi(b,3659512);c[914871]=0;c[914870]=3655008;c[914872]=46;c[914873]=44;c[914874]=0;c[914875]=0;c[914876]=0;xAi(b,3659480);c[914869]=0;c[914868]=3653248;yAi(b,3659472);c[914867]=0;c[914866]=3653368;zAi(b,3659464);c[914865]=0;c[914864]=3653440;AAi(b,3659456);c[914863]=0;c[914862]=3653536;BAi(b,3659448);c[914861]=0;c[914860]=3654128;CAi(b,3659440);c[914859]=0;c[914858]=3654192;DAi(b,3659432);c[914857]=0;c[914856]=3654256;EAi(b,3659424);c[914855]=0;c[914854]=3654320;FAi(b,3659416);c[914853]=0;c[914852]=3654384;GAi(b,3659408);c[914851]=0;c[914850]=3654464;HAi(b,3659400);c[914849]=0;c[914848]=3654520;IAi(b,3659392);c[914847]=0;c[914846]=3654568;JAi(b,3659384);c[914843]=0;c[914842]=3653616;c[914844]=3653664;KAi(b,3659368);c[914839]=0;c[914838]=3653768;c[914840]=3653816;LAi(b,3659352);c[914835]=0;c[914834]=3655712;c[914836]=Xti()|0;c[914834]=3654064;MAi(b,3659336);c[914831]=0;c[914830]=3655712;c[914832]=Xti()|0;c[914830]=3654096;NAi(b,3659320);c[914829]=0;c[914828]=3654608;OAi(b,3659312);c[914827]=0;c[914826]=3654648;PAi(b,3659304);i=e;return}function yxi(){var b=0;b=i;if((a[3654752]|0)==0?(Eh(3654752)|0)!=0:0){Dxi()|0;c[913686]=3654736;Cf(3654752)}i=b;return c[913686]|0}function zxi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;_qi(b);f=a+8|0;g=c[f>>2]|0;if((c[a+12>>2]|0)-g>>2>>>0>d>>>0)h=g;else{RAi(f,d+1|0);h=c[f>>2]|0}g=c[h+(d<<2)>>2]|0;if(!g){j=h;k=j+(d<<2)|0;c[k>>2]=b;i=e;return}$qi(g)|0;j=c[f>>2]|0;k=j+(d<<2)|0;c[k>>2]=b;i=e;return}function Axi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;c[a>>2]=3654720;d=a+8|0;e=a+12|0;f=c[e>>2]|0;g=c[d>>2]|0;if((f|0)!=(g|0)){h=f;f=g;g=0;while(1){j=c[f+(g<<2)>>2]|0;if(!j){k=h;l=f}else{$qi(j)|0;k=c[e>>2]|0;l=c[d>>2]|0}g=g+1|0;if(g>>>0>=k-l>>2>>>0)break;else{h=k;f=l}}}xri(a+144|0);QAi(d);i=b;return}function Bxi(a){a=a|0;var b=0;b=i;Axi(a);ACi(a);i=b;return}function Cxi(a,b){a=a|0;b=b|0;var d=0;d=i;if(SAi(a,b)|0){i=d;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}else{b=al(4)|0;UCi(b);we(b|0,3667296,3434)}return 0}function Dxi(){var a=0;a=i;xxi(3659144,1);c[913684]=3659144;i=a;return 3654736}function Exi(){var a=0,b=0;a=i;b=c[(yxi()|0)>>2]|0;c[913690]=b;_qi(b);i=a;return 3654760}function Fxi(){var b=0;b=i;if((a[3654776]|0)==0?(Eh(3654776)|0)!=0:0){Exi()|0;c[913692]=3654760;Cf(3654776)}i=b;return c[913692]|0}function Gxi(a){a=a|0;var b=0,d=0;b=i;d=c[(Fxi()|0)>>2]|0;c[a>>2]=d;_qi(d);i=b;return}function Hxi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;_qi(e);i=d;return}function Ixi(a){a=a|0;var b=0;b=i;$qi(c[a>>2]|0)|0;i=b;return}function Jxi(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;if((c[a>>2]|0)!=-1){c[d>>2]=a;c[d+4>>2]=3596;c[d+8>>2]=0;nri(a,d,3597)}i=b;return (c[a+4>>2]|0)+-1|0}function Kxi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[a>>2]|0;a=Cxi(e,Jxi(b)|0)|0;i=d;return a|0}function Lxi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Mxi(a){a=a|0;var b=0;b=i;if(!a){i=b;return}ko[c[(c[a>>2]|0)+4>>2]&4095](a);i=b;return}function Nxi(a){a=a|0;var b=0;b=c[913696]|0;c[913696]=b+1;c[a+4>>2]=b+1;return}function Oxi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Pxi(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a=i;if(d>>>0>=128){e=0;i=a;return e|0}e=(b[(Qxi()|0)+(d<<1)>>1]&c)<<16>>16!=0;i=a;return e|0}function Qxi(){var a=0,b=0;a=i;b=c[(oj()|0)>>2]|0;i=a;return b|0}function Rxi(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}h=((e+-4-d|0)>>>2)+1|0;j=d;k=f;while(1){f=c[j>>2]|0;if(f>>>0<128)l=b[(Qxi()|0)+(f<<1)>>1]|0;else l=0;b[k>>1]=l;j=j+4|0;if((j|0)==(e|0))break;else k=k+2|0}g=d+(h<<2)|0;i=a;return g|0}function Sxi(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;a:do if((e|0)==(f|0))g=e;else{h=e;while(1){j=c[h>>2]|0;if(j>>>0<128?(b[(Qxi()|0)+(j<<1)>>1]&d)<<16>>16!=0:0){g=h;break a}h=h+4|0;if((h|0)==(f|0)){g=f;break}}}while(0);i=a;return g|0}function Txi(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;a:do if((e|0)==(f|0))g=e;else{h=e;while(1){j=c[h>>2]|0;if(j>>>0>=128){g=h;break a}if(!((b[(Qxi()|0)+(j<<1)>>1]&d)<<16>>16)){g=h;break a}h=h+4|0;if((h|0)==(f|0)){g=f;break}}}while(0);i=a;return g|0}function Uxi(a,b){a=a|0;b=b|0;var d=0;a=i;if(b>>>0>=128){d=b;i=a;return d|0}d=c[(Vxi()|0)+(b<<2)>>2]|0;i=a;return d|0}function Vxi(){var a=0,b=0;a=i;b=c[(Mh()|0)>>2]|0;i=a;return b|0}function Wxi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}f=((d+-4-b|0)>>>2)+1|0;g=b;do{h=c[g>>2]|0;if(h>>>0<128)j=c[(Vxi()|0)+(h<<2)>>2]|0;else j=h;c[g>>2]=j;g=g+4|0}while((g|0)!=(d|0));e=b+(f<<2)|0;i=a;return e|0}function Xxi(a,b){a=a|0;b=b|0;var d=0;a=i;if(b>>>0>=128){d=b;i=a;return d|0}d=c[(Yxi()|0)+(b<<2)>>2]|0;i=a;return d|0}function Yxi(){var a=0,b=0;a=i;b=c[(Hf()|0)>>2]|0;i=a;return b|0}function Zxi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}f=((d+-4-b|0)>>>2)+1|0;g=b;do{h=c[g>>2]|0;if(h>>>0<128)j=c[(Yxi()|0)+(h<<2)>>2]|0;else j=h;c[g>>2]=j;g=g+4|0}while((g|0)!=(d|0));e=b+(f<<2)|0;i=a;return e|0}function _xi(a,b){a=a|0;b=b|0;return b<<24>>24|0}function $xi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h>>0];h=h+1|0;if((h|0)==(e|0)){g=e;break}else j=j+4|0}i=b;return g|0}function ayi(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function byi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+-4-d|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l>>0]=g>>>0<128?g&255:f;k=k+4|0;if((k|0)==(e|0))break;else l=l+1|0}h=d+(j<<2)|0;i=b;return h|0}function cyi(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=3654816;e=c[b+8>>2]|0;if((e|0)!=0?(a[b+12>>0]|0)!=0:0)BCi(e);i=d;return}function dyi(a){a=a|0;var b=0;b=i;cyi(a);ACi(a);i=b;return}function eyi(a,b){a=a|0;b=b|0;var d=0;a=i;if(b<<24>>24<=-1){d=b;i=a;return d|0}d=c[(Vxi()|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function fyi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else g=d;do{d=a[g>>0]|0;if(d<<24>>24>-1)h=c[(Vxi()|0)+(d<<24>>24<<2)>>2]&255;else h=d;a[g>>0]=h;g=g+1|0}while((g|0)!=(e|0));f=e;i=b;return f|0}function gyi(a,b){a=a|0;b=b|0;var d=0;a=i;if(b<<24>>24<=-1){d=b;i=a;return d|0}d=c[(Yxi()|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function hyi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else g=d;do{d=a[g>>0]|0;if(d<<24>>24>-1)h=c[(Yxi()|0)+(d<<24>>24<<2)>>2]&255;else h=d;a[g>>0]=h;g=g+1|0}while((g|0)!=(e|0));f=e;i=b;return f|0}function iyi(a,b){a=a|0;b=b|0;return b|0}function jyi(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;b=i;if((c|0)==(d|0))f=c;else{g=c;c=e;while(1){a[c>>0]=a[g>>0]|0;g=g+1|0;if((g|0)==(d|0)){f=d;break}else c=c+1|0}}i=b;return f|0}function kyi(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function lyi(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h>>0]|0;a[j>>0]=f<<24>>24>-1?f:e;h=h+1|0;if((h|0)==(d|0)){g=d;break}else j=j+1|0}i=b;return g|0}function myi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function nyi(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function oyi(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function pyi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function qyi(a){a=a|0;return 1}function ryi(a){a=a|0;return 1}function syi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return (b>>>0<e>>>0?b:e)|0}function tyi(a){a=a|0;return 1}function uyi(a,b){a=a|0;b=b|0;var d=0;d=i;c[a+4>>2]=b+-1;c[a>>2]=3654888;c[a+8>>2]=Xti()|0;i=d;return}function vyi(a){a=a|0;var b=0;b=i;wzi(a);ACi(a);i=b;return}function wyi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+16|0;m=l;n=l+8|0;o=(e|0)==(f|0);a:do if(!o){p=e;while(1){if(!(c[p>>2]|0)){q=p;break}p=p+4|0;if((p|0)==(f|0)){q=f;break}}c[k>>2]=h;c[g>>2]=e;if(!(o|(h|0)==(j|0))){p=j;r=b+8|0;s=e;t=h;u=q;while(1){v=d;w=c[v+4>>2]|0;x=m;c[x>>2]=c[v>>2];c[x+4>>2]=w;w=sf(c[r>>2]|0)|0;x=ZBi(t,g,u-s>>2,p-t|0,d)|0;if(w)sf(w|0)|0;if((x|0)==-1){y=s;z=t;A=10;break}else if(!x){B=1;A=33;break}w=(c[k>>2]|0)+x|0;c[k>>2]=w;if((w|0)==(j|0)){A=31;break}if((u|0)==(f|0)){C=c[g>>2]|0;D=w;E=f}else{w=sf(c[r>>2]|0)|0;x=lEi(n,0,d)|0;if(w)sf(w|0)|0;if((x|0)==-1){B=2;A=33;break}w=c[k>>2]|0;if(x>>>0>(p-w|0)>>>0){B=1;A=33;break}b:do if(x){v=w;F=x;G=n;while(1){H=a[G>>0]|0;c[k>>2]=v+1;a[v>>0]=H;H=F+-1|0;if(!H)break b;v=c[k>>2]|0;F=H;G=G+1|0}}while(0);x=c[g>>2]|0;w=x+4|0;c[g>>2]=w;c:do if((w|0)==(f|0))I=f;else{G=x;F=w;while(1){v=G+8|0;if(!(c[F>>2]|0)){I=F;break c}if((v|0)==(f|0)){I=f;break}else{H=F;F=v;G=H}}}while(0);C=w;D=c[k>>2]|0;E=I}if((C|0)==(f|0)|(D|0)==(j|0)){J=C;break a}else{s=C;t=D;u=E}}if((A|0)==10){c[k>>2]=z;d:do if((y|0)==(c[g>>2]|0))K=y;else{u=y;t=z;while(1){s=c[u>>2]|0;p=sf(c[r>>2]|0)|0;x=lEi(t,s,m)|0;if(p)sf(p|0)|0;if((x|0)==-1){K=u;break d}t=(c[k>>2]|0)+x|0;c[k>>2]=t;x=u+4|0;if((x|0)==(c[g>>2]|0)){K=x;break}else u=x}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((A|0)==31){J=c[g>>2]|0;break}else if((A|0)==33){i=l;return B|0}}else J=e}else{c[k>>2]=h;c[g>>2]=e;J=e}while(0);B=(J|0)!=(f|0)&1;i=l;return B|0}function xyi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=i;i=i+16|0;m=l;n=(e|0)==(f|0);a:do if(!n){o=e;while(1){if(!(a[o>>0]|0)){p=o;break}o=o+1|0;if((o|0)==(f|0)){p=f;break}}c[k>>2]=h;c[g>>2]=e;if(!(n|(h|0)==(j|0))){o=j;q=b+8|0;r=e;s=h;t=p;while(1){u=d;v=c[u+4>>2]|0;w=m;c[w>>2]=c[u>>2];c[w+4>>2]=v;v=t;w=sf(c[q>>2]|0)|0;u=WBi(s,g,v-r|0,o-s>>2,d)|0;if(w)sf(w|0)|0;if(!u){x=2;y=32;break}else if((u|0)==-1){z=r;A=s;B=v;y=10;break}v=(c[k>>2]|0)+(u<<2)|0;c[k>>2]=v;if((v|0)==(j|0)){y=30;break}u=c[g>>2]|0;if((t|0)==(f|0)){C=u;D=v;E=f}else{w=sf(c[q>>2]|0)|0;F=UBi(v,u,1,d)|0;if(w)sf(w|0)|0;if(F){x=2;y=32;break}c[k>>2]=(c[k>>2]|0)+4;F=c[g>>2]|0;w=F+1|0;c[g>>2]=w;b:do if((w|0)==(f|0))G=f;else{u=F;v=w;while(1){H=u+2|0;if(!(a[v>>0]|0)){G=v;break b}if((H|0)==(f|0)){G=f;break}else{I=v;v=H;u=I}}}while(0);C=w;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){J=C;break a}else{r=C;s=D;t=E}}if((y|0)==10){c[k>>2]=A;c:do if((z|0)!=(c[g>>2]|0)){t=z;s=A;while(1){r=sf(c[q>>2]|0)|0;o=UBi(s,t,B-t|0,m)|0;if(r)sf(r|0)|0;if(!o)K=t+1|0;else if((o|0)==-1){L=t;y=15;break}else if((o|0)==-2){M=t;y=16;break}else K=t+o|0;s=(c[k>>2]|0)+4|0;c[k>>2]=s;if((K|0)==(c[g>>2]|0)){N=K;break c}else t=K}if((y|0)==15){c[g>>2]=L;x=2;i=l;return x|0}else if((y|0)==16){c[g>>2]=M;x=1;i=l;return x|0}}else N=z;while(0);c[g>>2]=N;x=(N|0)!=(f|0)&1;i=l;return x|0}else if((y|0)==30){J=c[g>>2]|0;break}else if((y|0)==32){i=l;return x|0}}else J=e}else{c[k>>2]=h;c[g>>2]=e;J=e}while(0);x=(J|0)!=(f|0)&1;i=l;return x|0}function yyi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+16|0;j=h;c[g>>2]=e;e=sf(c[b+8>>2]|0)|0;b=lEi(j,0,d)|0;if(e)sf(e|0)|0;if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}e=b+-1|0;b=c[g>>2]|0;if(e>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if(!e){k=0;i=h;return k|0}else{l=b;m=e;n=j}while(1){j=a[n>>0]|0;c[g>>2]=l+1;a[l>>0]=j;j=m+-1|0;if(!j){k=0;break}l=c[g>>2]|0;m=j;n=n+1|0}i=h;return k|0}function zyi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+8|0;a=sf(c[d>>2]|0)|0;e=YBi(0,0,4)|0;if(a)sf(a|0)|0;if(!e){e=c[d>>2]|0;if(e){d=sf(e|0)|0;if(!d)f=0;else{sf(d|0)|0;f=0}}else f=1}else f=-1;i=b;return f|0}function Ayi(a){a=a|0;return 0}function Byi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=sf(c[k>>2]|0)|0;n=TBi(a,j-a|0,b)|0;if(m)sf(m|0)|0;if(!n){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;l=l+1|0;if(l>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n}}if((q|0)==9){i=g;return h|0}return 0}function Cyi(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;if(d){a=sf(d|0)|0;if(!a)e=4;else{sf(a|0)|0;e=4}}else e=1;i=b;return e|0}function Dyi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Eyi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b+4|0;k=b;c[a>>2]=d;c[k>>2]=g;l=UAi(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Fyi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b+4|0;k=b;c[a>>2]=d;c[k>>2]=g;l=VAi(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function Gyi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Hyi(a){a=a|0;return 0}function Iyi(a){a=a|0;return 0}function Jyi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=WAi(c,d,e,1114111,0)|0;i=b;return a|0}function Kyi(a){a=a|0;return 4}function Lyi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Myi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b+4|0;k=b;c[a>>2]=d;c[k>>2]=g;l=XAi(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Nyi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b+4|0;k=b;c[a>>2]=d;c[k>>2]=g;l=YAi(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function Oyi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Pyi(a){a=a|0;return 0}function Qyi(a){a=a|0;return 0}function Ryi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=ZAi(c,d,e,1114111,0)|0;i=b;return a|0}function Syi(a){a=a|0;return 4}function Tyi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Uyi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function Vyi(a){a=a|0;var b=0;b=i;c[a>>2]=3654968;xri(a+12|0);i=b;return}function Wyi(a){a=a|0;var b=0;b=i;Vyi(a);ACi(a);i=b;return}function Xyi(a){a=a|0;var b=0;b=i;c[a>>2]=3655008;xri(a+16|0);i=b;return}function Yyi(a){a=a|0;var b=0;b=i;Xyi(a);ACi(a);i=b;return}function Zyi(b){b=b|0;return a[b+8>>0]|0}function _yi(a){a=a|0;return c[a+8>>2]|0}function $yi(b){b=b|0;return a[b+9>>0]|0}function azi(a){a=a|0;return c[a+12>>2]|0}function bzi(a,b){a=a|0;b=b|0;var c=0;c=i;sri(a,b+12|0);i=c;return}function czi(a,b){a=a|0;b=b|0;var c=0;c=i;sri(a,b+16|0);i=c;return}function dzi(a,b){a=a|0;b=b|0;b=i;rri(a,3655040,4);i=b;return}function ezi(a,b){a=a|0;b=b|0;b=i;Qri(a,3655048,oCi(3655048)|0);i=b;return}function fzi(a,b){a=a|0;b=b|0;b=i;rri(a,3655072,5);i=b;return}function gzi(a,b){a=a|0;b=b|0;b=i;Qri(a,3655080,oCi(3655080)|0);i=b;return}function hzi(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+4>>2]&74;if(!d)e=0;else if((d|0)==8)e=16;else if((d|0)==64)e=8;else e=10;i=b;return e|0}function izi(b){b=b|0;var d=0;b=i;if(a[3655112]|0){d=c[913776]|0;i=b;return d|0}if(!(Eh(3655112)|0)){d=c[913776]|0;i=b;return d|0}if((a[3662312]|0)==0?(Eh(3662312)|0)!=0:0){PEi(3662144,0,168)|0;Cf(3662312)}zri(3662144,3662320)|0;zri(3662156,3662328)|0;zri(3662168,3662336)|0;zri(3662180,3662344)|0;zri(3662192,3662360)|0;zri(3662204,3662376)|0;zri(3662216,3662384)|0;zri(3662228,3662400)|0;zri(3662240,3662408)|0;zri(3662252,3662416)|0;zri(3662264,3662424)|0;zri(3662276,3662432)|0;zri(3662288,3662440)|0;zri(3662300,3662448)|0;c[913776]=3662144;Cf(3655112);d=c[913776]|0;i=b;return d|0}function jzi(b){b=b|0;var d=0;b=i;if(a[3655128]|0){d=c[913780]|0;i=b;return d|0}if(!(Eh(3655128)|0)){d=c[913780]|0;i=b;return d|0}if((a[3661776]|0)==0?(Eh(3661776)|0)!=0:0){PEi(3661608,0,168)|0;Cf(3661776)}Uri(3661608,3661784)|0;Uri(3661620,3661816)|0;Uri(3661632,3661848)|0;Uri(3661644,3661880)|0;Uri(3661656,3661920)|0;Uri(3661668,3661960)|0;Uri(3661680,3661992)|0;Uri(3661692,3662032)|0;Uri(3661704,3662048)|0;Uri(3661716,3662064)|0;Uri(3661728,3662080)|0;Uri(3661740,3662096)|0;Uri(3661752,3662112)|0;Uri(3661764,3662128)|0;c[913780]=3661608;Cf(3655128);d=c[913780]|0;i=b;return d|0}function kzi(b){b=b|0;var d=0;b=i;if(a[3655144]|0){d=c[913784]|0;i=b;return d|0}if(!(Eh(3655144)|0)){d=c[913784]|0;i=b;return d|0}if((a[3661384]|0)==0?(Eh(3661384)|0)!=0:0){PEi(3661096,0,288)|0;Cf(3661384)}zri(3661096,3661392)|0;zri(3661108,3661400)|0;zri(3661120,3661416)|0;zri(3661132,3661424)|0;zri(3661144,3661432)|0;zri(3661156,3661440)|0;zri(3661168,3661448)|0;zri(3661180,3661456)|0;zri(3661192,3661464)|0;zri(3661204,3661480)|0;zri(3661216,3661488)|0;zri(3661228,3661504)|0;zri(3661240,3661520)|0;zri(3661252,3661528)|0;zri(3661264,3661536)|0;zri(3661276,3661544)|0;zri(3661288,3661432)|0;zri(3661300,3661552)|0;zri(3661312,3661560)|0;zri(3661324,3661568)|0;zri(3661336,3661576)|0;zri(3661348,3661584)|0;zri(3661360,3661592)|0;zri(3661372,3661600)|0;c[913784]=3661096;Cf(3655144);d=c[913784]|0;i=b;return d|0}function lzi(b){b=b|0;var d=0;b=i;if(a[3655160]|0){d=c[913788]|0;i=b;return d|0}if(!(Eh(3655160)|0)){d=c[913788]|0;i=b;return d|0}if((a[3660544]|0)==0?(Eh(3660544)|0)!=0:0){PEi(3660256,0,288)|0;Cf(3660544)}Uri(3660256,3660552)|0;Uri(3660268,3660584)|0;Uri(3660280,3660624)|0;Uri(3660292,3660648)|0;Uri(3660304,3660672)|0;Uri(3660316,3660688)|0;Uri(3660328,3660712)|0;Uri(3660340,3660736)|0;Uri(3660352,3660768)|0;Uri(3660364,3660808)|0;Uri(3660376,3660840)|0;Uri(3660388,3660880)|0;Uri(3660400,3660920)|0;Uri(3660412,3660936)|0;Uri(3660424,3660952)|0;Uri(3660436,3660968)|0;Uri(3660448,3660672)|0;Uri(3660460,3660984)|0;Uri(3660472,3661e3)|0;Uri(3660484,3661016)|0;Uri(3660496,3661032)|0;Uri(3660508,3661048)|0;Uri(3660520,3661064)|0;Uri(3660532,3661080)|0;c[913788]=3660256;Cf(3655160);d=c[913788]|0;i=b;return d|0}function mzi(b){b=b|0;var d=0;b=i;if(a[3655176]|0){d=c[913792]|0;i=b;return d|0}if(!(Eh(3655176)|0)){d=c[913792]|0;i=b;return d|0}if((a[3660232]|0)==0?(Eh(3660232)|0)!=0:0){PEi(3659944,0,288)|0;Cf(3660232)}zri(3659944,3660240)|0;zri(3659956,3660248)|0;c[913792]=3659944;Cf(3655176);d=c[913792]|0;i=b;return d|0}function nzi(b){b=b|0;var d=0;b=i;if(a[3655192]|0){d=c[913796]|0;i=b;return d|0}if(!(Eh(3655192)|0)){d=c[913796]|0;i=b;return d|0}if((a[3659904]|0)==0?(Eh(3659904)|0)!=0:0){PEi(3659616,0,288)|0;Cf(3659904)}Uri(3659616,3659912)|0;Uri(3659628,3659928)|0;c[913796]=3659616;Cf(3655192);d=c[913796]|0;i=b;return d|0}function ozi(b){b=b|0;b=i;if((a[3655216]|0)==0?(Eh(3655216)|0)!=0:0){rri(3655200,3655224,8);Cf(3655216)}i=b;return 3655200}function pzi(b){b=b|0;b=i;if((a[3655256]|0)==0?(Eh(3655256)|0)!=0:0){Qri(3655240,3655264,oCi(3655264)|0);Cf(3655256)}i=b;return 3655240}function qzi(b){b=b|0;b=i;if((a[3655320]|0)==0?(Eh(3655320)|0)!=0:0){rri(3655304,3655328,8);Cf(3655320)}i=b;return 3655304}function rzi(b){b=b|0;b=i;if((a[3655360]|0)==0?(Eh(3655360)|0)!=0:0){Qri(3655344,3655368,oCi(3655368)|0);Cf(3655360)}i=b;return 3655344}function szi(b){b=b|0;b=i;if((a[3655424]|0)==0?(Eh(3655424)|0)!=0:0){rri(3655408,3655432,20);Cf(3655424)}i=b;return 3655408}function tzi(b){b=b|0;b=i;if((a[3655472]|0)==0?(Eh(3655472)|0)!=0:0){Qri(3655456,3655480,oCi(3655480)|0);Cf(3655472)}i=b;return 3655456}function uzi(b){b=b|0;b=i;if((a[3655584]|0)==0?(Eh(3655584)|0)!=0:0){rri(3655568,3655592,11);Cf(3655584)}i=b;return 3655568}function vzi(b){b=b|0;b=i;if((a[3655624]|0)==0?(Eh(3655624)|0)!=0:0){Qri(3655608,3655632,oCi(3655632)|0);Cf(3655624)}i=b;return 3655608}function wzi(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=3654888;d=a+8|0;a=c[d>>2]|0;if((a|0)==(Xti()|0)){i=b;return}dl(c[d>>2]|0);i=b;return}function xzi(){var a=0;a=i;Yqi(0);i=a;return}function yzi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[b>>2]|0;g=c[a>>2]|0;h=c[d>>2]|0;j=(h|0)<(f|0);do if((f|0)<(g|0)){if(j){c[a>>2]=h;c[d>>2]=g;k=1;break}c[a>>2]=f;c[b>>2]=g;l=c[d>>2]|0;if((l|0)<(g|0)){c[b>>2]=l;c[d>>2]=g;k=2}else k=1}else if(j){c[b>>2]=h;c[d>>2]=f;l=c[b>>2]|0;m=c[a>>2]|0;if((l|0)<(m|0)){c[a>>2]=l;c[b>>2]=m;k=2}else k=1}else k=0;while(0);i=e;return k|0}function zzi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=yzi(a,b,d,f)|0;f=c[e>>2]|0;j=c[d>>2]|0;if((f|0)>=(j|0)){k=h;i=g;return k|0}c[d>>2]=f;c[e>>2]=j;j=c[d>>2]|0;e=c[b>>2]|0;if((j|0)>=(e|0)){k=h+1|0;i=g;return k|0}c[b>>2]=j;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;if((e|0)>=(d|0)){k=h+2|0;i=g;return k|0}c[a>>2]=e;c[b>>2]=d;k=h+3|0;i=g;return k|0}function Azi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;j=zzi(a,b,d,e,g)|0;g=c[f>>2]|0;k=c[e>>2]|0;if((g|0)>=(k|0)){l=j;i=h;return l|0}c[e>>2]=g;c[f>>2]=k;k=c[e>>2]|0;f=c[d>>2]|0;if((k|0)>=(f|0)){l=j+1|0;i=h;return l|0}c[d>>2]=k;c[e>>2]=f;f=c[d>>2]|0;e=c[b>>2]|0;if((f|0)>=(e|0)){l=j+2|0;i=h;return l|0}c[b>>2]=f;c[d>>2]=e;e=c[b>>2]|0;d=c[a>>2]|0;if((e|0)>=(d|0)){l=j+3|0;i=h;return l|0}c[a>>2]=e;c[b>>2]=d;l=j+4|0;i=h;return l|0}function Bzi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+8|0;yzi(a,a+4|0,f,d)|0;d=a+12|0;if((d|0)==(b|0)){i=e;return}else{g=d;h=f}while(1){f=c[g>>2]|0;d=c[h>>2]|0;if((f|0)<(d|0)){j=d;d=g;k=h;while(1){c[d>>2]=j;if((k|0)==(a|0)){l=a;break}m=k+-4|0;j=c[m>>2]|0;if((f|0)>=(j|0)){l=k;break}else{n=k;k=m;d=n}}c[l>>2]=f}d=g+4|0;if((d|0)==(b|0))break;else{k=g;g=d;h=k}}i=e;return}function Czi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jsi(b);c[b>>2]=3651248;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52>>0]=0;Hxi(g,b+4|0);oBi(b,g);Ixi(g);i=f;return}function Dzi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;jsi(b);c[b>>2]=3651136;c[b+32>>2]=d;Hxi(g,b+4|0);d=Kxi(g,3654864)|0;Ixi(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0)&1;i=f;return}function Ezi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;zsi(b);c[b>>2]=3650992;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52>>0]=0;Hxi(g,b+4|0);eBi(b,g);Ixi(g);i=f;return}function Fzi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;zsi(b);c[b>>2]=3650880;c[b+32>>2]=d;Hxi(g,b+4|0);d=Kxi(g,3654872)|0;Ixi(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(mo[c[(c[d>>2]|0)+28>>2]&4095](d)|0)&1;i=f;return}function Gzi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=SEi(b|0)|0;f=xCi(e+13|0)|0;c[f>>2]=e;c[f+4>>2]=e;c[f+8>>2]=0;g=f+12|0;YEi(g|0,b|0,e+1|0)|0;c[a>>2]=g;i=d;return}function Hzi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;e=i;f=c[d>>2]|0;d=a;g=b-a>>2;a:while(1){a=g;while(1){if(!a){h=d;break a}b=(a|0)/2|0;if((c[d+(b<<2)>>2]|0)>>>0<f>>>0){j=b;k=a;break}else a=b}d=d+(j+1<<2)|0;g=k+-1-j|0}i=e;return h|0}function Izi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=d;h=e-g|0;if(h>>>0>4294967279)ori(b);if(h>>>0<11){a[b>>0]=h<<1;j=b+1|0}else{k=h+16&-16;l=xCi(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((d|0)==(e|0)){m=j;a[m>>0]=0;i=f;return}l=e-g|0;g=d;d=j;while(1){a[d>>0]=a[g>>0]|0;g=g+1|0;if((g|0)==(e|0))break;else d=d+1|0}m=j+l|0;a[m>>0]=0;i=f;return}function Jzi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;g=d;h=e-g|0;j=h>>2;if(j>>>0>1073741807)ori(b);if(j>>>0<2){a[b>>0]=h>>>1;k=b+4|0}else{h=j+4&-4;l=xCi(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((d|0)==(e|0)){m=k;c[m>>2]=0;i=f;return}l=((e+-4-g|0)>>>2)+1|0;g=d;d=k;while(1){c[d>>2]=c[g>>2];g=g+4|0;if((g|0)==(e|0))break;else d=d+4|0}m=k+(l<<2)|0;c[m>>2]=0;i=f;return}function Kzi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;l=i;i=i+112|0;m=l;n=(g-f|0)/12|0;if(n>>>0>100){o=ADi(n)|0;if(!o)uDi();else{p=o;q=o}}else{p=0;q=m}m=(f|0)==(g|0);if(m){r=0;s=n}else{o=f;t=0;u=n;n=q;while(1){v=a[o>>0]|0;if(!(v&1))w=(v&255)>>>1;else w=c[o+4>>2]|0;if(!w){a[n>>0]=2;x=t+1|0;y=u+-1|0}else{a[n>>0]=1;x=t;y=u}o=o+12|0;if((o|0)==(g|0)){r=x;s=y;break}else{t=x;u=y;n=n+1|0}}}n=0;y=r;r=s;a:while(1){s=n;while(1){u=c[b>>2]|0;do if(u)if((c[u+12>>2]|0)==(c[u+16>>2]|0))if((mo[c[(c[u>>2]|0)+36>>2]&4095](u)|0)==-1){c[b>>2]=0;z=0;break}else{z=c[b>>2]|0;break}else z=u;else z=0;while(0);u=(z|0)==0;x=c[e>>2]|0;if(x)if((c[x+12>>2]|0)==(c[x+16>>2]|0)?(mo[c[(c[x>>2]|0)+36>>2]&4095](x)|0)==-1:0){c[e>>2]=0;A=0}else A=x;else A=0;x=(A|0)==0;t=c[b>>2]|0;if(!((u^x)&(r|0)!=0)){B=x;C=t;D=A;break a}x=c[t+12>>2]|0;if((x|0)==(c[t+16>>2]|0))E=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else E=d[x>>0]|0;x=E&255;if(k)F=x;else F=_n[c[(c[h>>2]|0)+12>>2]&4095](h,x)|0;x=s+1|0;if(m)s=x;else{G=x;H=F;I=s;break}}s=0;x=f;t=y;u=r;o=q;while(1){do if((a[o>>0]|0)==1){if(!(a[x>>0]&1))J=x+1|0;else J=c[x+8>>2]|0;w=a[J+I>>0]|0;if(k)K=w;else K=_n[c[(c[h>>2]|0)+12>>2]&4095](h,w)|0;if(H<<24>>24!=K<<24>>24){a[o>>0]=0;L=s;M=t;N=u+-1|0;break}w=a[x>>0]|0;if(!(w&1))O=(w&255)>>>1;else O=c[x+4>>2]|0;if((O|0)==(G|0)){a[o>>0]=2;L=1;M=t+1|0;N=u+-1|0}else{L=1;M=t;N=u}}else{L=s;M=t;N=u}while(0);x=x+12|0;if((x|0)==(g|0))break;else{s=L;t=M;u=N;o=o+1|0}}if(!L){n=G;y=M;r=N;continue}o=c[b>>2]|0;u=o+12|0;t=c[u>>2]|0;if((t|0)==(c[o+16>>2]|0))mo[c[(c[o>>2]|0)+40>>2]&4095](o)|0;else c[u>>2]=t+1;if((M+N|0)>>>0<2){n=G;y=M;r=N;continue}else{P=f;Q=M;R=q}while(1){if((a[R>>0]|0)==2){t=a[P>>0]|0;if(!(t&1))S=(t&255)>>>1;else S=c[P+4>>2]|0;if((S|0)!=(G|0)){a[R>>0]=0;T=Q+-1|0}else T=Q}else T=Q;t=P+12|0;if((t|0)==(g|0)){n=G;y=T;r=N;continue a}else{P=t;Q=T;R=R+1|0}}}do if(C)if((c[C+12>>2]|0)==(c[C+16>>2]|0))if((mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1){c[b>>2]=0;U=0;break}else{U=c[b>>2]|0;break}else U=C;else U=0;while(0);C=(U|0)==0;do if(!B){if((c[D+12>>2]|0)!=(c[D+16>>2]|0))if(C)break;else{V=69;break}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)!=-1)if(C)break;else{V=69;break}else{c[e>>2]=0;V=67;break}}else V=67;while(0);if((V|0)==67?C:0)V=69;if((V|0)==69)c[j>>2]=c[j>>2]|2;b:do if(m)V=73;else{C=f;e=q;while(1){if((a[e>>0]|0)==2){W=C;break b}C=C+12|0;if((C|0)==(g|0)){V=73;break}else e=e+1|0}}while(0);if((V|0)==73){c[j>>2]=c[j>>2]|4;W=g}if(!p){i=l;return W|0}BDi(p);i=l;return W|0}function Lzi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+224|0;l=e+198|0;m=e+196|0;n=e+16|0;o=e+4|0;p=e+192|0;q=e+32|0;r=e;s=e+28|0;t=hzi(h)|0;kui(n,h,l,m);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){h=o+1|0;u=h;v=o+8|0;w=h}else{h=o+8|0;u=o+1|0;v=h;w=c[h>>2]|0}c[p>>2]=w;c[r>>2]=q;c[s>>2]=0;h=o+4|0;x=a[m>>0]|0;m=c[f>>2]|0;y=w;a:while(1){if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1:0){c[f>>2]=0;z=0}else z=m;else z=0;w=(z|0)==0;A=c[g>>2]|0;do if(A){if((c[A+12>>2]|0)!=(c[A+16>>2]|0))if(w){B=A;break}else{C=z;D=A;E=y;break a}if((mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0)!=-1)if(w){B=A;break}else{C=z;D=A;E=y;break a}else{c[g>>2]=0;F=14;break}}else F=14;while(0);if((F|0)==14){F=0;if(w){C=z;D=0;E=y;break}else B=0}A=a[o>>0]|0;G=(A&1)==0;if(G)H=(A&255)>>>1;else H=c[h>>2]|0;if((c[p>>2]|0)==(y+H|0)){if(G){I=(A&255)>>>1;J=(A&255)>>>1}else{A=c[h>>2]|0;I=A;J=A}Bri(o,I<<1,0);if(!(a[o>>0]&1))K=10;else K=(c[o>>2]&-2)+-1|0;Bri(o,K,0);if(!(a[o>>0]&1))L=u;else L=c[v>>2]|0;c[p>>2]=L+J;M=L}else M=y;A=z+12|0;G=c[A>>2]|0;N=z+16|0;if((G|0)==(c[N>>2]|0))O=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else O=d[G>>0]|0;if(Wti(O&255,t,M,p,s,x,n,q,r,l)|0){C=z;D=B;E=M;break}G=c[A>>2]|0;if((G|0)==(c[N>>2]|0)){mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;m=z;y=M;continue}else{c[A>>2]=G+1;m=z;y=M;continue}}M=a[n>>0]|0;if(!(M&1))P=(M&255)>>>1;else P=c[n+4>>2]|0;if((P|0)!=0?(P=c[r>>2]|0,(P-q|0)<160):0){M=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=M}c[k>>2]=tBi(E,c[p>>2]|0,j,t)|0;Uwi(n,q,c[r>>2]|0,j);if(C)if((c[C+12>>2]|0)==(c[C+16>>2]|0)?(mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1:0){c[f>>2]=0;Q=0}else Q=C;else Q=0;C=(Q|0)==0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(!C)break;c[b>>2]=Q;xri(o);xri(n);i=e;return}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)==-1){c[g>>2]=0;F=50;break}if(C^(D|0)==0){c[b>>2]=Q;xri(o);xri(n);i=e;return}}else F=50;while(0);if((F|0)==50?!C:0){c[b>>2]=Q;xri(o);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[b>>2]=Q;xri(o);xri(n);i=e;return}function Mzi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+224|0;l=e+198|0;m=e+196|0;n=e+16|0;o=e+4|0;p=e+192|0;q=e+32|0;r=e;s=e+28|0;t=hzi(h)|0;kui(n,h,l,m);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){h=o+1|0;u=h;v=o+8|0;w=h}else{h=o+8|0;u=o+1|0;v=h;w=c[h>>2]|0}c[p>>2]=w;c[r>>2]=q;c[s>>2]=0;h=o+4|0;x=a[m>>0]|0;m=c[f>>2]|0;y=w;a:while(1){if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1:0){c[f>>2]=0;z=0}else z=m;else z=0;w=(z|0)==0;A=c[g>>2]|0;do if(A){if((c[A+12>>2]|0)!=(c[A+16>>2]|0))if(w){B=A;break}else{C=z;D=A;E=y;break a}if((mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0)!=-1)if(w){B=A;break}else{C=z;D=A;E=y;break a}else{c[g>>2]=0;F=14;break}}else F=14;while(0);if((F|0)==14){F=0;if(w){C=z;D=0;E=y;break}else B=0}A=a[o>>0]|0;G=(A&1)==0;if(G)I=(A&255)>>>1;else I=c[h>>2]|0;if((c[p>>2]|0)==(y+I|0)){if(G){J=(A&255)>>>1;K=(A&255)>>>1}else{A=c[h>>2]|0;J=A;K=A}Bri(o,J<<1,0);if(!(a[o>>0]&1))L=10;else L=(c[o>>2]&-2)+-1|0;Bri(o,L,0);if(!(a[o>>0]&1))M=u;else M=c[v>>2]|0;c[p>>2]=M+K;N=M}else N=y;A=z+12|0;G=c[A>>2]|0;O=z+16|0;if((G|0)==(c[O>>2]|0))P=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else P=d[G>>0]|0;if(Wti(P&255,t,N,p,s,x,n,q,r,l)|0){C=z;D=B;E=N;break}G=c[A>>2]|0;if((G|0)==(c[O>>2]|0)){mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;m=z;y=N;continue}else{c[A>>2]=G+1;m=z;y=N;continue}}N=a[n>>0]|0;if(!(N&1))Q=(N&255)>>>1;else Q=c[n+4>>2]|0;if((Q|0)!=0?(Q=c[r>>2]|0,(Q-q|0)<160):0){N=c[s>>2]|0;c[r>>2]=Q+4;c[Q>>2]=N}N=uBi(E,c[p>>2]|0,j,t)|0;t=k;c[t>>2]=N;c[t+4>>2]=H;Uwi(n,q,c[r>>2]|0,j);if(C)if((c[C+12>>2]|0)==(c[C+16>>2]|0)?(mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1:0){c[f>>2]=0;R=0}else R=C;else R=0;C=(R|0)==0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(!C)break;c[b>>2]=R;xri(o);xri(n);i=e;return}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)==-1){c[g>>2]=0;F=50;break}if(C^(D|0)==0){c[b>>2]=R;xri(o);xri(n);i=e;return}}else F=50;while(0);if((F|0)==50?!C:0){c[b>>2]=R;xri(o);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[b>>2]=R;xri(o);xri(n);i=e;return}function Nzi(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;f=i;i=i+224|0;m=f+198|0;n=f+196|0;o=f+16|0;p=f+4|0;q=f+192|0;r=f+32|0;s=f;t=f+28|0;u=hzi(j)|0;kui(o,j,m,n);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bri(p,10,0);if(!(a[p>>0]&1)){j=p+1|0;v=j;w=p+8|0;x=j}else{j=p+8|0;v=p+1|0;w=j;x=c[j>>2]|0}c[q>>2]=x;c[s>>2]=r;c[t>>2]=0;j=p+4|0;y=a[n>>0]|0;n=c[g>>2]|0;z=x;a:while(1){if(n)if((c[n+12>>2]|0)==(c[n+16>>2]|0)?(mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0)==-1:0){c[g>>2]=0;A=0}else A=n;else A=0;x=(A|0)==0;B=c[h>>2]|0;do if(B){if((c[B+12>>2]|0)!=(c[B+16>>2]|0))if(x){C=B;break}else{D=A;E=B;F=z;break a}if((mo[c[(c[B>>2]|0)+36>>2]&4095](B)|0)!=-1)if(x){C=B;break}else{D=A;E=B;F=z;break a}else{c[h>>2]=0;G=14;break}}else G=14;while(0);if((G|0)==14){G=0;if(x){D=A;E=0;F=z;break}else C=0}B=a[p>>0]|0;H=(B&1)==0;if(H)I=(B&255)>>>1;else I=c[j>>2]|0;if((c[q>>2]|0)==(z+I|0)){if(H){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[j>>2]|0;J=B;K=B}Bri(p,J<<1,0);if(!(a[p>>0]&1))L=10;else L=(c[p>>2]&-2)+-1|0;Bri(p,L,0);if(!(a[p>>0]&1))M=v;else M=c[w>>2]|0;c[q>>2]=M+K;N=M}else N=z;B=A+12|0;H=c[B>>2]|0;O=A+16|0;if((H|0)==(c[O>>2]|0))P=mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0;else P=d[H>>0]|0;if(Wti(P&255,u,N,q,t,y,o,r,s,m)|0){D=A;E=C;F=N;break}H=c[B>>2]|0;if((H|0)==(c[O>>2]|0)){mo[c[(c[A>>2]|0)+40>>2]&4095](A)|0;n=A;z=N;continue}else{c[B>>2]=H+1;n=A;z=N;continue}}N=a[o>>0]|0;if(!(N&1))Q=(N&255)>>>1;else Q=c[o+4>>2]|0;if((Q|0)!=0?(Q=c[s>>2]|0,(Q-r|0)<160):0){N=c[t>>2]|0;c[s>>2]=Q+4;c[Q>>2]=N}b[l>>1]=vBi(F,c[q>>2]|0,k,u)|0;Uwi(o,r,c[s>>2]|0,k);if(D)if((c[D+12>>2]|0)==(c[D+16>>2]|0)?(mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)==-1:0){c[g>>2]=0;R=0}else R=D;else R=0;D=(R|0)==0;do if(E){if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!D)break;c[e>>2]=R;xri(p);xri(o);i=f;return}if((mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0)==-1){c[h>>2]=0;G=50;break}if(D^(E|0)==0){c[e>>2]=R;xri(p);xri(o);i=f;return}}else G=50;while(0);if((G|0)==50?!D:0){c[e>>2]=R;xri(p);xri(o);i=f;return}c[k>>2]=c[k>>2]|2;c[e>>2]=R;xri(p);xri(o);i=f;return}function Ozi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+224|0;l=e+198|0;m=e+196|0;n=e+16|0;o=e+4|0;p=e+192|0;q=e+32|0;r=e;s=e+28|0;t=hzi(h)|0;kui(n,h,l,m);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){h=o+1|0;u=h;v=o+8|0;w=h}else{h=o+8|0;u=o+1|0;v=h;w=c[h>>2]|0}c[p>>2]=w;c[r>>2]=q;c[s>>2]=0;h=o+4|0;x=a[m>>0]|0;m=c[f>>2]|0;y=w;a:while(1){if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1:0){c[f>>2]=0;z=0}else z=m;else z=0;w=(z|0)==0;A=c[g>>2]|0;do if(A){if((c[A+12>>2]|0)!=(c[A+16>>2]|0))if(w){B=A;break}else{C=z;D=A;E=y;break a}if((mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0)!=-1)if(w){B=A;break}else{C=z;D=A;E=y;break a}else{c[g>>2]=0;F=14;break}}else F=14;while(0);if((F|0)==14){F=0;if(w){C=z;D=0;E=y;break}else B=0}A=a[o>>0]|0;G=(A&1)==0;if(G)H=(A&255)>>>1;else H=c[h>>2]|0;if((c[p>>2]|0)==(y+H|0)){if(G){I=(A&255)>>>1;J=(A&255)>>>1}else{A=c[h>>2]|0;I=A;J=A}Bri(o,I<<1,0);if(!(a[o>>0]&1))K=10;else K=(c[o>>2]&-2)+-1|0;Bri(o,K,0);if(!(a[o>>0]&1))L=u;else L=c[v>>2]|0;c[p>>2]=L+J;M=L}else M=y;A=z+12|0;G=c[A>>2]|0;N=z+16|0;if((G|0)==(c[N>>2]|0))O=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else O=d[G>>0]|0;if(Wti(O&255,t,M,p,s,x,n,q,r,l)|0){C=z;D=B;E=M;break}G=c[A>>2]|0;if((G|0)==(c[N>>2]|0)){mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;m=z;y=M;continue}else{c[A>>2]=G+1;m=z;y=M;continue}}M=a[n>>0]|0;if(!(M&1))P=(M&255)>>>1;else P=c[n+4>>2]|0;if((P|0)!=0?(P=c[r>>2]|0,(P-q|0)<160):0){M=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=M}c[k>>2]=wBi(E,c[p>>2]|0,j,t)|0;Uwi(n,q,c[r>>2]|0,j);if(C)if((c[C+12>>2]|0)==(c[C+16>>2]|0)?(mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1:0){c[f>>2]=0;Q=0}else Q=C;else Q=0;C=(Q|0)==0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(!C)break;c[b>>2]=Q;xri(o);xri(n);i=e;return}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)==-1){c[g>>2]=0;F=50;break}if(C^(D|0)==0){c[b>>2]=Q;xri(o);xri(n);i=e;return}}else F=50;while(0);if((F|0)==50?!C:0){c[b>>2]=Q;xri(o);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[b>>2]=Q;xri(o);xri(n);i=e;return}function Pzi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+224|0;l=e+198|0;m=e+196|0;n=e+16|0;o=e+4|0;p=e+192|0;q=e+32|0;r=e;s=e+28|0;t=hzi(h)|0;kui(n,h,l,m);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){h=o+1|0;u=h;v=o+8|0;w=h}else{h=o+8|0;u=o+1|0;v=h;w=c[h>>2]|0}c[p>>2]=w;c[r>>2]=q;c[s>>2]=0;h=o+4|0;x=a[m>>0]|0;m=c[f>>2]|0;y=w;a:while(1){if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1:0){c[f>>2]=0;z=0}else z=m;else z=0;w=(z|0)==0;A=c[g>>2]|0;do if(A){if((c[A+12>>2]|0)!=(c[A+16>>2]|0))if(w){B=A;break}else{C=z;D=A;E=y;break a}if((mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0)!=-1)if(w){B=A;break}else{C=z;D=A;E=y;break a}else{c[g>>2]=0;F=14;break}}else F=14;while(0);if((F|0)==14){F=0;if(w){C=z;D=0;E=y;break}else B=0}A=a[o>>0]|0;G=(A&1)==0;if(G)H=(A&255)>>>1;else H=c[h>>2]|0;if((c[p>>2]|0)==(y+H|0)){if(G){I=(A&255)>>>1;J=(A&255)>>>1}else{A=c[h>>2]|0;I=A;J=A}Bri(o,I<<1,0);if(!(a[o>>0]&1))K=10;else K=(c[o>>2]&-2)+-1|0;Bri(o,K,0);if(!(a[o>>0]&1))L=u;else L=c[v>>2]|0;c[p>>2]=L+J;M=L}else M=y;A=z+12|0;G=c[A>>2]|0;N=z+16|0;if((G|0)==(c[N>>2]|0))O=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else O=d[G>>0]|0;if(Wti(O&255,t,M,p,s,x,n,q,r,l)|0){C=z;D=B;E=M;break}G=c[A>>2]|0;if((G|0)==(c[N>>2]|0)){mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;m=z;y=M;continue}else{c[A>>2]=G+1;m=z;y=M;continue}}M=a[n>>0]|0;if(!(M&1))P=(M&255)>>>1;else P=c[n+4>>2]|0;if((P|0)!=0?(P=c[r>>2]|0,(P-q|0)<160):0){M=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=M}c[k>>2]=xBi(E,c[p>>2]|0,j,t)|0;Uwi(n,q,c[r>>2]|0,j);if(C)if((c[C+12>>2]|0)==(c[C+16>>2]|0)?(mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1:0){c[f>>2]=0;Q=0}else Q=C;else Q=0;C=(Q|0)==0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(!C)break;c[b>>2]=Q;xri(o);xri(n);i=e;return}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)==-1){c[g>>2]=0;F=50;break}if(C^(D|0)==0){c[b>>2]=Q;xri(o);xri(n);i=e;return}}else F=50;while(0);if((F|0)==50?!C:0){c[b>>2]=Q;xri(o);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[b>>2]=Q;xri(o);xri(n);i=e;return}function Qzi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+224|0;l=e+198|0;m=e+196|0;n=e+16|0;o=e+4|0;p=e+192|0;q=e+32|0;r=e;s=e+28|0;t=hzi(h)|0;kui(n,h,l,m);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){h=o+1|0;u=h;v=o+8|0;w=h}else{h=o+8|0;u=o+1|0;v=h;w=c[h>>2]|0}c[p>>2]=w;c[r>>2]=q;c[s>>2]=0;h=o+4|0;x=a[m>>0]|0;m=c[f>>2]|0;y=w;a:while(1){if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0)==-1:0){c[f>>2]=0;z=0}else z=m;else z=0;w=(z|0)==0;A=c[g>>2]|0;do if(A){if((c[A+12>>2]|0)!=(c[A+16>>2]|0))if(w){B=A;break}else{C=z;D=A;E=y;break a}if((mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0)!=-1)if(w){B=A;break}else{C=z;D=A;E=y;break a}else{c[g>>2]=0;F=14;break}}else F=14;while(0);if((F|0)==14){F=0;if(w){C=z;D=0;E=y;break}else B=0}A=a[o>>0]|0;G=(A&1)==0;if(G)I=(A&255)>>>1;else I=c[h>>2]|0;if((c[p>>2]|0)==(y+I|0)){if(G){J=(A&255)>>>1;K=(A&255)>>>1}else{A=c[h>>2]|0;J=A;K=A}Bri(o,J<<1,0);if(!(a[o>>0]&1))L=10;else L=(c[o>>2]&-2)+-1|0;Bri(o,L,0);if(!(a[o>>0]&1))M=u;else M=c[v>>2]|0;c[p>>2]=M+K;N=M}else N=y;A=z+12|0;G=c[A>>2]|0;O=z+16|0;if((G|0)==(c[O>>2]|0))P=mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0;else P=d[G>>0]|0;if(Wti(P&255,t,N,p,s,x,n,q,r,l)|0){C=z;D=B;E=N;break}G=c[A>>2]|0;if((G|0)==(c[O>>2]|0)){mo[c[(c[z>>2]|0)+40>>2]&4095](z)|0;m=z;y=N;continue}else{c[A>>2]=G+1;m=z;y=N;continue}}N=a[n>>0]|0;if(!(N&1))Q=(N&255)>>>1;else Q=c[n+4>>2]|0;if((Q|0)!=0?(Q=c[r>>2]|0,(Q-q|0)<160):0){N=c[s>>2]|0;c[r>>2]=Q+4;c[Q>>2]=N}N=yBi(E,c[p>>2]|0,j,t)|0;t=k;c[t>>2]=N;c[t+4>>2]=H;Uwi(n,q,c[r>>2]|0,j);if(C)if((c[C+12>>2]|0)==(c[C+16>>2]|0)?(mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0)==-1:0){c[f>>2]=0;R=0}else R=C;else R=0;C=(R|0)==0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(!C)break;c[b>>2]=R;xri(o);xri(n);i=e;return}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)==-1){c[g>>2]=0;F=50;break}if(C^(D|0)==0){c[b>>2]=R;xri(o);xri(n);i=e;return}}else F=50;while(0);if((F|0)==50?!C:0){c[b>>2]=R;xri(o);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[b>>2]=R;xri(o);xri(n);i=e;return}function Rzi(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;m=e+208|0;n=e+200|0;o=e+240|0;p=e;q=e+188|0;r=e+184|0;s=e+16|0;t=e+176|0;u=e+180|0;v=e+241|0;w=e+242|0;lui(p,j,m,n,o);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Bri(q,10,0);if(!(a[q>>0]&1)){j=q+1|0;x=j;y=q+8|0;z=j}else{j=q+8|0;x=q+1|0;y=j;z=c[j>>2]|0}c[r>>2]=z;c[t>>2]=s;c[u>>2]=0;a[v>>0]=1;a[w>>0]=69;j=q+4|0;A=a[n>>0]|0;n=a[o>>0]|0;o=c[f>>2]|0;B=z;a:while(1){if(o)if((c[o+12>>2]|0)==(c[o+16>>2]|0)?(mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0)==-1:0){c[f>>2]=0;C=0}else C=o;else C=0;z=(C|0)==0;D=c[h>>2]|0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0))if(z){E=D;break}else{F=C;G=D;H=B;break a}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)!=-1)if(z){E=D;break}else{F=C;G=D;H=B;break a}else{c[h>>2]=0;I=14;break}}else I=14;while(0);if((I|0)==14){I=0;if(z){F=C;G=0;H=B;break}else E=0}D=a[q>>0]|0;J=(D&1)==0;if(J)K=(D&255)>>>1;else K=c[j>>2]|0;if((c[r>>2]|0)==(B+K|0)){if(J){L=(D&255)>>>1;M=(D&255)>>>1}else{D=c[j>>2]|0;L=D;M=D}Bri(q,L<<1,0);if(!(a[q>>0]&1))N=10;else N=(c[q>>2]&-2)+-1|0;Bri(q,N,0);if(!(a[q>>0]&1))O=x;else O=c[y>>2]|0;c[r>>2]=O+M;P=O}else P=B;D=C+12|0;J=c[D>>2]|0;Q=C+16|0;if((J|0)==(c[Q>>2]|0))R=mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0;else R=d[J>>0]|0;if(mui(R&255,v,w,P,r,A,n,p,s,t,u,m)|0){F=C;G=E;H=P;break}J=c[D>>2]|0;if((J|0)==(c[Q>>2]|0)){mo[c[(c[C>>2]|0)+40>>2]&4095](C)|0;o=C;B=P;continue}else{c[D>>2]=J+1;o=C;B=P;continue}}P=a[p>>0]|0;if(!(P&1))S=(P&255)>>>1;else S=c[p+4>>2]|0;if(!((S|0)==0|(a[v>>0]|0)==0)?(v=c[t>>2]|0,(v-s|0)<160):0){S=c[u>>2]|0;c[t>>2]=v+4;c[v>>2]=S}g[l>>2]=ea(zBi(H,c[r>>2]|0,k));Uwi(p,s,c[t>>2]|0,k);if(F)if((c[F+12>>2]|0)==(c[F+16>>2]|0)?(mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0)==-1:0){c[f>>2]=0;T=0}else T=F;else T=0;F=(T|0)==0;do if(G){if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(!F)break;c[b>>2]=T;xri(q);xri(p);i=e;return}if((mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0)==-1){c[h>>2]=0;I=50;break}if(F^(G|0)==0){c[b>>2]=T;xri(q);xri(p);i=e;return}}else I=50;while(0);if((I|0)==50?!F:0){c[b>>2]=T;xri(q);xri(p);i=e;return}c[k>>2]=c[k>>2]|2;c[b>>2]=T;xri(q);xri(p);i=e;return}function Szi(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;m=e+208|0;n=e+200|0;o=e+240|0;p=e;q=e+188|0;r=e+184|0;s=e+16|0;t=e+176|0;u=e+180|0;v=e+241|0;w=e+242|0;lui(p,j,m,n,o);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Bri(q,10,0);if(!(a[q>>0]&1)){j=q+1|0;x=j;y=q+8|0;z=j}else{j=q+8|0;x=q+1|0;y=j;z=c[j>>2]|0}c[r>>2]=z;c[t>>2]=s;c[u>>2]=0;a[v>>0]=1;a[w>>0]=69;j=q+4|0;A=a[n>>0]|0;n=a[o>>0]|0;o=c[f>>2]|0;B=z;a:while(1){if(o)if((c[o+12>>2]|0)==(c[o+16>>2]|0)?(mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0)==-1:0){c[f>>2]=0;C=0}else C=o;else C=0;z=(C|0)==0;D=c[g>>2]|0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0))if(z){E=D;break}else{F=C;G=D;H=B;break a}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)!=-1)if(z){E=D;break}else{F=C;G=D;H=B;break a}else{c[g>>2]=0;I=14;break}}else I=14;while(0);if((I|0)==14){I=0;if(z){F=C;G=0;H=B;break}else E=0}D=a[q>>0]|0;J=(D&1)==0;if(J)K=(D&255)>>>1;else K=c[j>>2]|0;if((c[r>>2]|0)==(B+K|0)){if(J){L=(D&255)>>>1;M=(D&255)>>>1}else{D=c[j>>2]|0;L=D;M=D}Bri(q,L<<1,0);if(!(a[q>>0]&1))N=10;else N=(c[q>>2]&-2)+-1|0;Bri(q,N,0);if(!(a[q>>0]&1))O=x;else O=c[y>>2]|0;c[r>>2]=O+M;P=O}else P=B;D=C+12|0;J=c[D>>2]|0;Q=C+16|0;if((J|0)==(c[Q>>2]|0))R=mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0;else R=d[J>>0]|0;if(mui(R&255,v,w,P,r,A,n,p,s,t,u,m)|0){F=C;G=E;H=P;break}J=c[D>>2]|0;if((J|0)==(c[Q>>2]|0)){mo[c[(c[C>>2]|0)+40>>2]&4095](C)|0;o=C;B=P;continue}else{c[D>>2]=J+1;o=C;B=P;continue}}P=a[p>>0]|0;if(!(P&1))S=(P&255)>>>1;else S=c[p+4>>2]|0;if(!((S|0)==0|(a[v>>0]|0)==0)?(v=c[t>>2]|0,(v-s|0)<160):0){S=c[u>>2]|0;c[t>>2]=v+4;c[v>>2]=S}h[l>>3]=+ABi(H,c[r>>2]|0,k);Uwi(p,s,c[t>>2]|0,k);if(F)if((c[F+12>>2]|0)==(c[F+16>>2]|0)?(mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0)==-1:0){c[f>>2]=0;T=0}else T=F;else T=0;F=(T|0)==0;do if(G){if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(!F)break;c[b>>2]=T;xri(q);xri(p);i=e;return}if((mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0)==-1){c[g>>2]=0;I=50;break}if(F^(G|0)==0){c[b>>2]=T;xri(q);xri(p);i=e;return}}else I=50;while(0);if((I|0)==50?!F:0){c[b>>2]=T;xri(q);xri(p);i=e;return}c[k>>2]=c[k>>2]|2;c[b>>2]=T;xri(q);xri(p);i=e;return}function Tzi(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;m=e+208|0;n=e+200|0;o=e+240|0;p=e;q=e+188|0;r=e+184|0;s=e+16|0;t=e+176|0;u=e+180|0;v=e+241|0;w=e+242|0;lui(p,j,m,n,o);c[q+0>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;Bri(q,10,0);if(!(a[q>>0]&1)){j=q+1|0;x=j;y=q+8|0;z=j}else{j=q+8|0;x=q+1|0;y=j;z=c[j>>2]|0}c[r>>2]=z;c[t>>2]=s;c[u>>2]=0;a[v>>0]=1;a[w>>0]=69;j=q+4|0;A=a[n>>0]|0;n=a[o>>0]|0;o=c[f>>2]|0;B=z;a:while(1){if(o)if((c[o+12>>2]|0)==(c[o+16>>2]|0)?(mo[c[(c[o>>2]|0)+36>>2]&4095](o)|0)==-1:0){c[f>>2]=0;C=0}else C=o;else C=0;z=(C|0)==0;D=c[g>>2]|0;do if(D){if((c[D+12>>2]|0)!=(c[D+16>>2]|0))if(z){E=D;break}else{F=C;G=D;H=B;break a}if((mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0)!=-1)if(z){E=D;break}else{F=C;G=D;H=B;break a}else{c[g>>2]=0;I=14;break}}else I=14;while(0);if((I|0)==14){I=0;if(z){F=C;G=0;H=B;break}else E=0}D=a[q>>0]|0;J=(D&1)==0;if(J)K=(D&255)>>>1;else K=c[j>>2]|0;if((c[r>>2]|0)==(B+K|0)){if(J){L=(D&255)>>>1;M=(D&255)>>>1}else{D=c[j>>2]|0;L=D;M=D}Bri(q,L<<1,0);if(!(a[q>>0]&1))N=10;else N=(c[q>>2]&-2)+-1|0;Bri(q,N,0);if(!(a[q>>0]&1))O=x;else O=c[y>>2]|0;c[r>>2]=O+M;P=O}else P=B;D=C+12|0;J=c[D>>2]|0;Q=C+16|0;if((J|0)==(c[Q>>2]|0))R=mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0;else R=d[J>>0]|0;if(mui(R&255,v,w,P,r,A,n,p,s,t,u,m)|0){F=C;G=E;H=P;break}J=c[D>>2]|0;if((J|0)==(c[Q>>2]|0)){mo[c[(c[C>>2]|0)+40>>2]&4095](C)|0;o=C;B=P;continue}else{c[D>>2]=J+1;o=C;B=P;continue}}P=a[p>>0]|0;if(!(P&1))S=(P&255)>>>1;else S=c[p+4>>2]|0;if(!((S|0)==0|(a[v>>0]|0)==0)?(v=c[t>>2]|0,(v-s|0)<160):0){S=c[u>>2]|0;c[t>>2]=v+4;c[v>>2]=S}h[l>>3]=+BBi(H,c[r>>2]|0,k);Uwi(p,s,c[t>>2]|0,k);if(F)if((c[F+12>>2]|0)==(c[F+16>>2]|0)?(mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0)==-1:0){c[f>>2]=0;T=0}else T=F;else T=0;F=(T|0)==0;do if(G){if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){if(!F)break;c[b>>2]=T;xri(q);xri(p);i=e;return}if((mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0)==-1){c[g>>2]=0;I=50;break}if(F^(G|0)==0){c[b>>2]=T;xri(q);xri(p);i=e;return}}else I=50;while(0);if((I|0)==50?!F:0){c[b>>2]=T;xri(q);xri(p);i=e;return}c[k>>2]=c[k>>2]|2;c[b>>2]=T;xri(q);xri(p);i=e;return}function Uzi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=sf(b|0)|0;b=dCi(a,d,g)|0;if(!e){i=f;return b|0}sf(e|0)|0;i=f;return b|0}function Vzi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;k=i;i=i+112|0;l=k;m=(f-e|0)/12|0;if(m>>>0>100){n=ADi(m)|0;if(!n)uDi();else{o=n;p=n}}else{o=0;p=l}l=(e|0)==(f|0);if(l){q=0;r=m}else{n=e;s=0;t=m;m=p;while(1){u=a[n>>0]|0;if(!(u&1))v=(u&255)>>>1;else v=c[n+4>>2]|0;if(!v){a[m>>0]=2;w=s+1|0;x=t+-1|0}else{a[m>>0]=1;w=s;x=t}n=n+12|0;if((n|0)==(f|0)){q=w;r=x;break}else{s=w;t=x;m=m+1|0}}}m=0;x=q;q=r;a:while(1){r=m;while(1){t=c[b>>2]|0;do if(t){w=c[t+12>>2]|0;if((w|0)==(c[t+16>>2]|0))y=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else y=c[w>>2]|0;if((y|0)==-1){c[b>>2]=0;z=1;break}else{z=(c[b>>2]|0)==0;break}}else z=1;while(0);t=c[d>>2]|0;if(t){w=c[t+12>>2]|0;if((w|0)==(c[t+16>>2]|0))A=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else A=c[w>>2]|0;if((A|0)==-1){c[d>>2]=0;B=0;C=1}else{B=t;C=0}}else{B=0;C=1}t=c[b>>2]|0;if(!((z^C)&(q|0)!=0)){D=t;E=B;break a}w=c[t+12>>2]|0;if((w|0)==(c[t+16>>2]|0))F=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else F=c[w>>2]|0;if(j)G=F;else G=_n[c[(c[g>>2]|0)+28>>2]&4095](g,F)|0;w=r+1|0;if(l)r=w;else{H=w;I=G;J=r;break}}r=0;w=e;t=x;s=q;n=p;while(1){do if((a[n>>0]|0)==1){if(!(a[w>>0]&1))K=w+4|0;else K=c[w+8>>2]|0;v=c[K+(J<<2)>>2]|0;if(j)L=v;else L=_n[c[(c[g>>2]|0)+28>>2]&4095](g,v)|0;if((I|0)!=(L|0)){a[n>>0]=0;M=r;N=t;O=s+-1|0;break}v=a[w>>0]|0;if(!(v&1))P=(v&255)>>>1;else P=c[w+4>>2]|0;if((P|0)==(H|0)){a[n>>0]=2;M=1;N=t+1|0;O=s+-1|0}else{M=1;N=t;O=s}}else{M=r;N=t;O=s}while(0);w=w+12|0;if((w|0)==(f|0))break;else{r=M;t=N;s=O;n=n+1|0}}if(!M){m=H;x=N;q=O;continue}n=c[b>>2]|0;s=n+12|0;t=c[s>>2]|0;if((t|0)==(c[n+16>>2]|0))mo[c[(c[n>>2]|0)+40>>2]&4095](n)|0;else c[s>>2]=t+4;if((N+O|0)>>>0<2){m=H;x=N;q=O;continue}else{Q=e;R=N;S=p}while(1){if((a[S>>0]|0)==2){t=a[Q>>0]|0;if(!(t&1))T=(t&255)>>>1;else T=c[Q+4>>2]|0;if((T|0)!=(H|0)){a[S>>0]=0;U=R+-1|0}else U=R}else U=R;t=Q+12|0;if((t|0)==(f|0)){m=H;x=U;q=O;continue a}else{Q=t;R=U;S=S+1|0}}}do if(D){S=c[D+12>>2]|0;if((S|0)==(c[D+16>>2]|0))V=mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0;else V=c[S>>2]|0;if((V|0)==-1){c[b>>2]=0;W=1;break}else{W=(c[b>>2]|0)==0;break}}else W=1;while(0);do if(E){b=c[E+12>>2]|0;if((b|0)==(c[E+16>>2]|0))X=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else X=c[b>>2]|0;if((X|0)!=-1)if(W)break;else{Y=76;break}else{c[d>>2]=0;Y=74;break}}else Y=74;while(0);if((Y|0)==74?W:0)Y=76;if((Y|0)==76)c[h>>2]=c[h>>2]|2;b:do if(l)Y=80;else{W=e;d=p;while(1){if((a[d>>0]|0)==2){Z=W;break b}W=W+12|0;if((W|0)==(f|0)){Y=80;break}else d=d+1|0}}while(0);if((Y|0)==80){c[h>>2]=c[h>>2]|4;Z=f}if(!o){i=k;return Z|0}BDi(o);i=k;return Z|0}function Wzi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+304|0;k=d+160|0;l=d+280|0;m=d+264|0;n=d+284|0;o=d+300|0;p=d;q=d+276|0;r=d+296|0;s=hzi(g)|0;nui(m,g,k,l);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Bri(n,10,0);if(!(a[n>>0]&1)){g=n+1|0;t=g;u=n+8|0;v=g}else{g=n+8|0;t=n+1|0;u=g;v=c[g>>2]|0}c[o>>2]=v;c[q>>2]=p;c[r>>2]=0;g=n+4|0;w=c[l>>2]|0;l=c[e>>2]|0;x=v;a:while(1){if(l){v=c[l+12>>2]|0;if((v|0)==(c[l+16>>2]|0))y=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else y=c[v>>2]|0;if((y|0)==-1){c[e>>2]=0;z=1;A=0}else{z=0;A=l}}else{z=1;A=0}v=c[f>>2]|0;do if(v){B=c[v+12>>2]|0;if((B|0)==(c[v+16>>2]|0))C=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;else C=c[B>>2]|0;if((C|0)!=-1)if(z){D=v;break}else{E=A;F=v;G=x;break a}else{c[f>>2]=0;H=17;break}}else H=17;while(0);if((H|0)==17){H=0;if(z){E=A;F=0;G=x;break}else D=0}v=a[n>>0]|0;B=(v&1)==0;if(B)I=(v&255)>>>1;else I=c[g>>2]|0;if((c[o>>2]|0)==(x+I|0)){if(B){J=(v&255)>>>1;K=(v&255)>>>1}else{v=c[g>>2]|0;J=v;K=v}Bri(n,J<<1,0);if(!(a[n>>0]&1))L=10;else L=(c[n>>2]&-2)+-1|0;Bri(n,L,0);if(!(a[n>>0]&1))M=t;else M=c[u>>2]|0;c[o>>2]=M+K;N=M}else N=x;v=A+12|0;B=c[v>>2]|0;O=A+16|0;if((B|0)==(c[O>>2]|0))P=mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0;else P=c[B>>2]|0;if(jui(P,s,N,o,r,w,m,p,q,k)|0){E=A;F=D;G=N;break}B=c[v>>2]|0;if((B|0)==(c[O>>2]|0)){mo[c[(c[A>>2]|0)+40>>2]&4095](A)|0;l=A;x=N;continue}else{c[v>>2]=B+4;l=A;x=N;continue}}N=a[m>>0]|0;if(!(N&1))Q=(N&255)>>>1;else Q=c[m+4>>2]|0;if((Q|0)!=0?(Q=c[q>>2]|0,(Q-p|0)<160):0){N=c[r>>2]|0;c[q>>2]=Q+4;c[Q>>2]=N}c[j>>2]=tBi(G,c[o>>2]|0,h,s)|0;Uwi(m,p,c[q>>2]|0,h);if(E){q=c[E+12>>2]|0;if((q|0)==(c[E+16>>2]|0))R=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else R=c[q>>2]|0;if((R|0)==-1){c[e>>2]=0;S=0;T=1}else{S=E;T=0}}else{S=0;T=1}do if(F){E=c[F+12>>2]|0;if((E|0)==(c[F+16>>2]|0))U=mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0;else U=c[E>>2]|0;if((U|0)==-1){c[f>>2]=0;H=56;break}if(T){c[b>>2]=S;xri(n);xri(m);i=d;return}}else H=56;while(0);if((H|0)==56?!T:0){c[b>>2]=S;xri(n);xri(m);i=d;return}c[h>>2]=c[h>>2]|2;c[b>>2]=S;xri(n);xri(m);i=d;return}function Xzi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+304|0;k=d+160|0;l=d+280|0;m=d+264|0;n=d+284|0;o=d+300|0;p=d;q=d+276|0;r=d+296|0;s=hzi(g)|0;nui(m,g,k,l);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Bri(n,10,0);if(!(a[n>>0]&1)){g=n+1|0;t=g;u=n+8|0;v=g}else{g=n+8|0;t=n+1|0;u=g;v=c[g>>2]|0}c[o>>2]=v;c[q>>2]=p;c[r>>2]=0;g=n+4|0;w=c[l>>2]|0;l=c[e>>2]|0;x=v;a:while(1){if(l){v=c[l+12>>2]|0;if((v|0)==(c[l+16>>2]|0))y=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else y=c[v>>2]|0;if((y|0)==-1){c[e>>2]=0;z=1;A=0}else{z=0;A=l}}else{z=1;A=0}v=c[f>>2]|0;do if(v){B=c[v+12>>2]|0;if((B|0)==(c[v+16>>2]|0))C=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;else C=c[B>>2]|0;if((C|0)!=-1)if(z){D=v;break}else{E=A;F=v;G=x;break a}else{c[f>>2]=0;I=17;break}}else I=17;while(0);if((I|0)==17){I=0;if(z){E=A;F=0;G=x;break}else D=0}v=a[n>>0]|0;B=(v&1)==0;if(B)J=(v&255)>>>1;else J=c[g>>2]|0;if((c[o>>2]|0)==(x+J|0)){if(B){K=(v&255)>>>1;L=(v&255)>>>1}else{v=c[g>>2]|0;K=v;L=v}Bri(n,K<<1,0);if(!(a[n>>0]&1))M=10;else M=(c[n>>2]&-2)+-1|0;Bri(n,M,0);if(!(a[n>>0]&1))N=t;else N=c[u>>2]|0;c[o>>2]=N+L;O=N}else O=x;v=A+12|0;B=c[v>>2]|0;P=A+16|0;if((B|0)==(c[P>>2]|0))Q=mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0;else Q=c[B>>2]|0;if(jui(Q,s,O,o,r,w,m,p,q,k)|0){E=A;F=D;G=O;break}B=c[v>>2]|0;if((B|0)==(c[P>>2]|0)){mo[c[(c[A>>2]|0)+40>>2]&4095](A)|0;l=A;x=O;continue}else{c[v>>2]=B+4;l=A;x=O;continue}}O=a[m>>0]|0;if(!(O&1))R=(O&255)>>>1;else R=c[m+4>>2]|0;if((R|0)!=0?(R=c[q>>2]|0,(R-p|0)<160):0){O=c[r>>2]|0;c[q>>2]=R+4;c[R>>2]=O}O=uBi(G,c[o>>2]|0,h,s)|0;s=j;c[s>>2]=O;c[s+4>>2]=H;Uwi(m,p,c[q>>2]|0,h);if(E){q=c[E+12>>2]|0;if((q|0)==(c[E+16>>2]|0))S=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else S=c[q>>2]|0;if((S|0)==-1){c[e>>2]=0;T=0;U=1}else{T=E;U=0}}else{T=0;U=1}do if(F){E=c[F+12>>2]|0;if((E|0)==(c[F+16>>2]|0))V=mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0;else V=c[E>>2]|0;if((V|0)==-1){c[f>>2]=0;I=56;break}if(U){c[b>>2]=T;xri(n);xri(m);i=d;return}}else I=56;while(0);if((I|0)==56?!U:0){c[b>>2]=T;xri(n);xri(m);i=d;return}c[h>>2]=c[h>>2]|2;c[b>>2]=T;xri(n);xri(m);i=d;return}function Yzi(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+304|0;l=e+160|0;m=e+280|0;n=e+264|0;o=e+284|0;p=e+300|0;q=e;r=e+276|0;s=e+296|0;t=hzi(h)|0;nui(n,h,l,m);c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Bri(o,10,0);if(!(a[o>>0]&1)){h=o+1|0;u=h;v=o+8|0;w=h}else{h=o+8|0;u=o+1|0;v=h;w=c[h>>2]|0}c[p>>2]=w;c[r>>2]=q;c[s>>2]=0;h=o+4|0;x=c[m>>2]|0;m=c[f>>2]|0;y=w;a:while(1){if(m){w=c[m+12>>2]|0;if((w|0)==(c[m+16>>2]|0))z=mo[c[(c[m>>2]|0)+36>>2]&4095](m)|0;else z=c[w>>2]|0;if((z|0)==-1){c[f>>2]=0;A=1;B=0}else{A=0;B=m}}else{A=1;B=0}w=c[g>>2]|0;do if(w){C=c[w+12>>2]|0;if((C|0)==(c[w+16>>2]|0))D=mo[c[(c[w>>2]|0)+36>>2]&4095](w)|0;else D=c[C>>2]|0;if((D|0)!=-1)if(A){E=w;break}else{F=B;G=w;H=y;break a}else{c[g>>2]=0;I=17;break}}else I=17;while(0);if((I|0)==17){I=0;if(A){F=B;G=0;H=y;break}else E=0}w=a[o>>0]|0;C=(w&1)==0;if(C)J=(w&255)>>>1;else J=c[h>>2]|0;if((c[p>>2]|0)==(y+J|0)){if(C){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[h>>2]|0;K=w;L=w}Bri(o,K<<1,0);if(!(a[o>>0]&1))M=10;else M=(c[o>>2]&-2)+-1|0;Bri(o,M,0);if(!(a[o>>0]&1))N=u;else N=c[v>>2]|0;c[p>>2]=N+L;O=N}else O=y;w=B+12|0;C=c[w>>2]|0;P=B+16|0;if((C|0)==(c[P>>2]|0))Q=mo[c[(c[B>>2]|0)+36>>2]&4095](B)|0;else Q=c[C>>2]|0;if(jui(Q,t,O,p,s,x,n,q,r,l)|0){F=B;G=E;H=O;break}C=c[w>>2]|0;if((C|0)==(c[P>>2]|0)){mo[c[(c[B>>2]|0)+40>>2]&4095](B)|0;m=B;y=O;continue}else{c[w>>2]=C+4;m=B;y=O;continue}}O=a[n>>0]|0;if(!(O&1))R=(O&255)>>>1;else R=c[n+4>>2]|0;if((R|0)!=0?(R=c[r>>2]|0,(R-q|0)<160):0){O=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=O}b[k>>1]=vBi(H,c[p>>2]|0,j,t)|0;Uwi(n,q,c[r>>2]|0,j);if(F){r=c[F+12>>2]|0;if((r|0)==(c[F+16>>2]|0))S=mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0;else S=c[r>>2]|0;if((S|0)==-1){c[f>>2]=0;T=0;U=1}else{T=F;U=0}}else{T=0;U=1}do if(G){F=c[G+12>>2]|0;if((F|0)==(c[G+16>>2]|0))V=mo[c[(c[G>>2]|0)+36>>2]&4095](G)|0;else V=c[F>>2]|0;if((V|0)==-1){c[g>>2]=0;I=56;break}if(U){c[d>>2]=T;xri(o);xri(n);i=e;return}}else I=56;while(0);if((I|0)==56?!U:0){c[d>>2]=T;xri(o);xri(n);i=e;return}c[j>>2]=c[j>>2]|2;c[d>>2]=T;xri(o);xri(n);i=e;return}function Zzi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+304|0;k=d+160|0;l=d+280|0;m=d+264|0;n=d+284|0;o=d+300|0;p=d;q=d+276|0;r=d+296|0;s=hzi(g)|0;nui(m,g,k,l);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Bri(n,10,0);if(!(a[n>>0]&1)){g=n+1|0;t=g;u=n+8|0;v=g}else{g=n+8|0;t=n+1|0;u=g;v=c[g>>2]|0}c[o>>2]=v;c[q>>2]=p;c[r>>2]=0;g=n+4|0;w=c[l>>2]|0;l=c[e>>2]|0;x=v;a:while(1){if(l){v=c[l+12>>2]|0;if((v|0)==(c[l+16>>2]|0))y=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else y=c[v>>2]|0;if((y|0)==-1){c[e>>2]=0;z=1;A=0}else{z=0;A=l}}else{z=1;A=0}v=c[f>>2]|0;do if(v){B=c[v+12>>2]|0;if((B|0)==(c[v+16>>2]|0))C=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;else C=c[B>>2]|0;if((C|0)!=-1)if(z){D=v;break}else{E=A;F=v;G=x;break a}else{c[f>>2]=0;H=17;break}}else H=17;while(0);if((H|0)==17){H=0;if(z){E=A;F=0;G=x;break}else D=0}v=a[n>>0]|0;B=(v&1)==0;if(B)I=(v&255)>>>1;else I=c[g>>2]|0;if((c[o>>2]|0)==(x+I|0)){if(B){J=(v&255)>>>1;K=(v&255)>>>1}else{v=c[g>>2]|0;J=v;K=v}Bri(n,J<<1,0);if(!(a[n>>0]&1))L=10;else L=(c[n>>2]&-2)+-1|0;Bri(n,L,0);if(!(a[n>>0]&1))M=t;else M=c[u>>2]|0;c[o>>2]=M+K;N=M}else N=x;v=A+12|0;B=c[v>>2]|0;O=A+16|0;if((B|0)==(c[O>>2]|0))P=mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0;else P=c[B>>2]|0;if(jui(P,s,N,o,r,w,m,p,q,k)|0){E=A;F=D;G=N;break}B=c[v>>2]|0;if((B|0)==(c[O>>2]|0)){mo[c[(c[A>>2]|0)+40>>2]&4095](A)|0;l=A;x=N;continue}else{c[v>>2]=B+4;l=A;x=N;continue}}N=a[m>>0]|0;if(!(N&1))Q=(N&255)>>>1;else Q=c[m+4>>2]|0;if((Q|0)!=0?(Q=c[q>>2]|0,(Q-p|0)<160):0){N=c[r>>2]|0;c[q>>2]=Q+4;c[Q>>2]=N}c[j>>2]=wBi(G,c[o>>2]|0,h,s)|0;Uwi(m,p,c[q>>2]|0,h);if(E){q=c[E+12>>2]|0;if((q|0)==(c[E+16>>2]|0))R=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else R=c[q>>2]|0;if((R|0)==-1){c[e>>2]=0;S=0;T=1}else{S=E;T=0}}else{S=0;T=1}do if(F){E=c[F+12>>2]|0;if((E|0)==(c[F+16>>2]|0))U=mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0;else U=c[E>>2]|0;if((U|0)==-1){c[f>>2]=0;H=56;break}if(T){c[b>>2]=S;xri(n);xri(m);i=d;return}}else H=56;while(0);if((H|0)==56?!T:0){c[b>>2]=S;xri(n);xri(m);i=d;return}c[h>>2]=c[h>>2]|2;c[b>>2]=S;xri(n);xri(m);i=d;return}function _zi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+304|0;k=d+160|0;l=d+280|0;m=d+264|0;n=d+284|0;o=d+300|0;p=d;q=d+276|0;r=d+296|0;s=hzi(g)|0;nui(m,g,k,l);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Bri(n,10,0);if(!(a[n>>0]&1)){g=n+1|0;t=g;u=n+8|0;v=g}else{g=n+8|0;t=n+1|0;u=g;v=c[g>>2]|0}c[o>>2]=v;c[q>>2]=p;c[r>>2]=0;g=n+4|0;w=c[l>>2]|0;l=c[e>>2]|0;x=v;a:while(1){if(l){v=c[l+12>>2]|0;if((v|0)==(c[l+16>>2]|0))y=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else y=c[v>>2]|0;if((y|0)==-1){c[e>>2]=0;z=1;A=0}else{z=0;A=l}}else{z=1;A=0}v=c[f>>2]|0;do if(v){B=c[v+12>>2]|0;if((B|0)==(c[v+16>>2]|0))C=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;else C=c[B>>2]|0;if((C|0)!=-1)if(z){D=v;break}else{E=A;F=v;G=x;break a}else{c[f>>2]=0;H=17;break}}else H=17;while(0);if((H|0)==17){H=0;if(z){E=A;F=0;G=x;break}else D=0}v=a[n>>0]|0;B=(v&1)==0;if(B)I=(v&255)>>>1;else I=c[g>>2]|0;if((c[o>>2]|0)==(x+I|0)){if(B){J=(v&255)>>>1;K=(v&255)>>>1}else{v=c[g>>2]|0;J=v;K=v}Bri(n,J<<1,0);if(!(a[n>>0]&1))L=10;else L=(c[n>>2]&-2)+-1|0;Bri(n,L,0);if(!(a[n>>0]&1))M=t;else M=c[u>>2]|0;c[o>>2]=M+K;N=M}else N=x;v=A+12|0;B=c[v>>2]|0;O=A+16|0;if((B|0)==(c[O>>2]|0))P=mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0;else P=c[B>>2]|0;if(jui(P,s,N,o,r,w,m,p,q,k)|0){E=A;F=D;G=N;break}B=c[v>>2]|0;if((B|0)==(c[O>>2]|0)){mo[c[(c[A>>2]|0)+40>>2]&4095](A)|0;l=A;x=N;continue}else{c[v>>2]=B+4;l=A;x=N;continue}}N=a[m>>0]|0;if(!(N&1))Q=(N&255)>>>1;else Q=c[m+4>>2]|0;if((Q|0)!=0?(Q=c[q>>2]|0,(Q-p|0)<160):0){N=c[r>>2]|0;c[q>>2]=Q+4;c[Q>>2]=N}c[j>>2]=xBi(G,c[o>>2]|0,h,s)|0;Uwi(m,p,c[q>>2]|0,h);if(E){q=c[E+12>>2]|0;if((q|0)==(c[E+16>>2]|0))R=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else R=c[q>>2]|0;if((R|0)==-1){c[e>>2]=0;S=0;T=1}else{S=E;T=0}}else{S=0;T=1}do if(F){E=c[F+12>>2]|0;if((E|0)==(c[F+16>>2]|0))U=mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0;else U=c[E>>2]|0;if((U|0)==-1){c[f>>2]=0;H=56;break}if(T){c[b>>2]=S;xri(n);xri(m);i=d;return}}else H=56;while(0);if((H|0)==56?!T:0){c[b>>2]=S;xri(n);xri(m);i=d;return}c[h>>2]=c[h>>2]|2;c[b>>2]=S;xri(n);xri(m);i=d;return}function $zi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+304|0;k=d+160|0;l=d+280|0;m=d+264|0;n=d+284|0;o=d+300|0;p=d;q=d+276|0;r=d+296|0;s=hzi(g)|0;nui(m,g,k,l);c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Bri(n,10,0);if(!(a[n>>0]&1)){g=n+1|0;t=g;u=n+8|0;v=g}else{g=n+8|0;t=n+1|0;u=g;v=c[g>>2]|0}c[o>>2]=v;c[q>>2]=p;c[r>>2]=0;g=n+4|0;w=c[l>>2]|0;l=c[e>>2]|0;x=v;a:while(1){if(l){v=c[l+12>>2]|0;if((v|0)==(c[l+16>>2]|0))y=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else y=c[v>>2]|0;if((y|0)==-1){c[e>>2]=0;z=1;A=0}else{z=0;A=l}}else{z=1;A=0}v=c[f>>2]|0;do if(v){B=c[v+12>>2]|0;if((B|0)==(c[v+16>>2]|0))C=mo[c[(c[v>>2]|0)+36>>2]&4095](v)|0;else C=c[B>>2]|0;if((C|0)!=-1)if(z){D=v;break}else{E=A;F=v;G=x;break a}else{c[f>>2]=0;I=17;break}}else I=17;while(0);if((I|0)==17){I=0;if(z){E=A;F=0;G=x;break}else D=0}v=a[n>>0]|0;B=(v&1)==0;if(B)J=(v&255)>>>1;else J=c[g>>2]|0;if((c[o>>2]|0)==(x+J|0)){if(B){K=(v&255)>>>1;L=(v&255)>>>1}else{v=c[g>>2]|0;K=v;L=v}Bri(n,K<<1,0);if(!(a[n>>0]&1))M=10;else M=(c[n>>2]&-2)+-1|0;Bri(n,M,0);if(!(a[n>>0]&1))N=t;else N=c[u>>2]|0;c[o>>2]=N+L;O=N}else O=x;v=A+12|0;B=c[v>>2]|0;P=A+16|0;if((B|0)==(c[P>>2]|0))Q=mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0;else Q=c[B>>2]|0;if(jui(Q,s,O,o,r,w,m,p,q,k)|0){E=A;F=D;G=O;break}B=c[v>>2]|0;if((B|0)==(c[P>>2]|0)){mo[c[(c[A>>2]|0)+40>>2]&4095](A)|0;l=A;x=O;continue}else{c[v>>2]=B+4;l=A;x=O;continue}}O=a[m>>0]|0;if(!(O&1))R=(O&255)>>>1;else R=c[m+4>>2]|0;if((R|0)!=0?(R=c[q>>2]|0,(R-p|0)<160):0){O=c[r>>2]|0;c[q>>2]=R+4;c[R>>2]=O}O=yBi(G,c[o>>2]|0,h,s)|0;s=j;c[s>>2]=O;c[s+4>>2]=H;Uwi(m,p,c[q>>2]|0,h);if(E){q=c[E+12>>2]|0;if((q|0)==(c[E+16>>2]|0))S=mo[c[(c[E>>2]|0)+36>>2]&4095](E)|0;else S=c[q>>2]|0;if((S|0)==-1){c[e>>2]=0;T=0;U=1}else{T=E;U=0}}else{T=0;U=1}do if(F){E=c[F+12>>2]|0;if((E|0)==(c[F+16>>2]|0))V=mo[c[(c[F>>2]|0)+36>>2]&4095](F)|0;else V=c[E>>2]|0;if((V|0)==-1){c[f>>2]=0;I=56;break}if(U){c[b>>2]=T;xri(n);xri(m);i=d;return}}else I=56;while(0);if((I|0)==56?!U:0){c[b>>2]=T;xri(n);xri(m);i=d;return}c[h>>2]=c[h>>2]|2;c[b>>2]=T;xri(n);xri(m);i=d;return}function aAi(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+352|0;l=d+208|0;m=d+184|0;n=d+4|0;o=d+8|0;p=d+196|0;q=d;r=d+24|0;s=d+192|0;t=d+188|0;u=d+337|0;v=d+336|0;oui(o,h,l,m,n);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bri(p,10,0);if(!(a[p>>0]&1)){h=p+1|0;w=h;x=p+8|0;y=h}else{h=p+8|0;w=p+1|0;x=h;y=c[h>>2]|0}c[q>>2]=y;c[s>>2]=r;c[t>>2]=0;a[u>>0]=1;a[v>>0]=69;h=p+4|0;z=c[m>>2]|0;m=c[n>>2]|0;n=c[e>>2]|0;A=y;a:while(1){if(n){y=c[n+12>>2]|0;if((y|0)==(c[n+16>>2]|0))B=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;else B=c[y>>2]|0;if((B|0)==-1){c[e>>2]=0;C=1;D=0}else{C=0;D=n}}else{C=1;D=0}y=c[f>>2]|0;do if(y){E=c[y+12>>2]|0;if((E|0)==(c[y+16>>2]|0))F=mo[c[(c[y>>2]|0)+36>>2]&4095](y)|0;else F=c[E>>2]|0;if((F|0)!=-1)if(C){G=y;break}else{H=D;I=y;J=A;break a}else{c[f>>2]=0;K=17;break}}else K=17;while(0);if((K|0)==17){K=0;if(C){H=D;I=0;J=A;break}else G=0}y=a[p>>0]|0;E=(y&1)==0;if(E)L=(y&255)>>>1;else L=c[h>>2]|0;if((c[q>>2]|0)==(A+L|0)){if(E){M=(y&255)>>>1;N=(y&255)>>>1}else{y=c[h>>2]|0;M=y;N=y}Bri(p,M<<1,0);if(!(a[p>>0]&1))O=10;else O=(c[p>>2]&-2)+-1|0;Bri(p,O,0);if(!(a[p>>0]&1))P=w;else P=c[x>>2]|0;c[q>>2]=P+N;Q=P}else Q=A;y=D+12|0;E=c[y>>2]|0;R=D+16|0;if((E|0)==(c[R>>2]|0))S=mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0;else S=c[E>>2]|0;if(pui(S,u,v,Q,q,z,m,o,r,s,t,l)|0){H=D;I=G;J=Q;break}E=c[y>>2]|0;if((E|0)==(c[R>>2]|0)){mo[c[(c[D>>2]|0)+40>>2]&4095](D)|0;n=D;A=Q;continue}else{c[y>>2]=E+4;n=D;A=Q;continue}}Q=a[o>>0]|0;if(!(Q&1))T=(Q&255)>>>1;else T=c[o+4>>2]|0;if(!((T|0)==0|(a[u>>0]|0)==0)?(u=c[s>>2]|0,(u-r|0)<160):0){T=c[t>>2]|0;c[s>>2]=u+4;c[u>>2]=T}g[k>>2]=ea(zBi(J,c[q>>2]|0,j));Uwi(o,r,c[s>>2]|0,j);if(H){s=c[H+12>>2]|0;if((s|0)==(c[H+16>>2]|0))U=mo[c[(c[H>>2]|0)+36>>2]&4095](H)|0;else U=c[s>>2]|0;if((U|0)==-1){c[e>>2]=0;V=0;W=1}else{V=H;W=0}}else{V=0;W=1}do if(I){H=c[I+12>>2]|0;if((H|0)==(c[I+16>>2]|0))X=mo[c[(c[I>>2]|0)+36>>2]&4095](I)|0;else X=c[H>>2]|0;if((X|0)==-1){c[f>>2]=0;K=56;break}if(W){c[b>>2]=V;xri(p);xri(o);i=d;return}}else K=56;while(0);if((K|0)==56?!W:0){c[b>>2]=V;xri(p);xri(o);i=d;return}c[j>>2]=c[j>>2]|2;c[b>>2]=V;xri(p);xri(o);i=d;return}function bAi(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+352|0;l=d+208|0;m=d+184|0;n=d+4|0;o=d+8|0;p=d+196|0;q=d;r=d+24|0;s=d+192|0;t=d+188|0;u=d+337|0;v=d+336|0;oui(o,g,l,m,n);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bri(p,10,0);if(!(a[p>>0]&1)){g=p+1|0;w=g;x=p+8|0;y=g}else{g=p+8|0;w=p+1|0;x=g;y=c[g>>2]|0}c[q>>2]=y;c[s>>2]=r;c[t>>2]=0;a[u>>0]=1;a[v>>0]=69;g=p+4|0;z=c[m>>2]|0;m=c[n>>2]|0;n=c[e>>2]|0;A=y;a:while(1){if(n){y=c[n+12>>2]|0;if((y|0)==(c[n+16>>2]|0))B=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;else B=c[y>>2]|0;if((B|0)==-1){c[e>>2]=0;C=1;D=0}else{C=0;D=n}}else{C=1;D=0}y=c[f>>2]|0;do if(y){E=c[y+12>>2]|0;if((E|0)==(c[y+16>>2]|0))F=mo[c[(c[y>>2]|0)+36>>2]&4095](y)|0;else F=c[E>>2]|0;if((F|0)!=-1)if(C){G=y;break}else{H=D;I=y;J=A;break a}else{c[f>>2]=0;K=17;break}}else K=17;while(0);if((K|0)==17){K=0;if(C){H=D;I=0;J=A;break}else G=0}y=a[p>>0]|0;E=(y&1)==0;if(E)L=(y&255)>>>1;else L=c[g>>2]|0;if((c[q>>2]|0)==(A+L|0)){if(E){M=(y&255)>>>1;N=(y&255)>>>1}else{y=c[g>>2]|0;M=y;N=y}Bri(p,M<<1,0);if(!(a[p>>0]&1))O=10;else O=(c[p>>2]&-2)+-1|0;Bri(p,O,0);if(!(a[p>>0]&1))P=w;else P=c[x>>2]|0;c[q>>2]=P+N;Q=P}else Q=A;y=D+12|0;E=c[y>>2]|0;R=D+16|0;if((E|0)==(c[R>>2]|0))S=mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0;else S=c[E>>2]|0;if(pui(S,u,v,Q,q,z,m,o,r,s,t,l)|0){H=D;I=G;J=Q;break}E=c[y>>2]|0;if((E|0)==(c[R>>2]|0)){mo[c[(c[D>>2]|0)+40>>2]&4095](D)|0;n=D;A=Q;continue}else{c[y>>2]=E+4;n=D;A=Q;continue}}Q=a[o>>0]|0;if(!(Q&1))T=(Q&255)>>>1;else T=c[o+4>>2]|0;if(!((T|0)==0|(a[u>>0]|0)==0)?(u=c[s>>2]|0,(u-r|0)<160):0){T=c[t>>2]|0;c[s>>2]=u+4;c[u>>2]=T}h[k>>3]=+ABi(J,c[q>>2]|0,j);Uwi(o,r,c[s>>2]|0,j);if(H){s=c[H+12>>2]|0;if((s|0)==(c[H+16>>2]|0))U=mo[c[(c[H>>2]|0)+36>>2]&4095](H)|0;else U=c[s>>2]|0;if((U|0)==-1){c[e>>2]=0;V=0;W=1}else{V=H;W=0}}else{V=0;W=1}do if(I){H=c[I+12>>2]|0;if((H|0)==(c[I+16>>2]|0))X=mo[c[(c[I>>2]|0)+36>>2]&4095](I)|0;else X=c[H>>2]|0;if((X|0)==-1){c[f>>2]=0;K=56;break}if(W){c[b>>2]=V;xri(p);xri(o);i=d;return}}else K=56;while(0);if((K|0)==56?!W:0){c[b>>2]=V;xri(p);xri(o);i=d;return}c[j>>2]=c[j>>2]|2;c[b>>2]=V;xri(p);xri(o);i=d;return}function cAi(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+352|0;l=d+208|0;m=d+184|0;n=d+4|0;o=d+8|0;p=d+196|0;q=d;r=d+24|0;s=d+192|0;t=d+188|0;u=d+337|0;v=d+336|0;oui(o,g,l,m,n);c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Bri(p,10,0);if(!(a[p>>0]&1)){g=p+1|0;w=g;x=p+8|0;y=g}else{g=p+8|0;w=p+1|0;x=g;y=c[g>>2]|0}c[q>>2]=y;c[s>>2]=r;c[t>>2]=0;a[u>>0]=1;a[v>>0]=69;g=p+4|0;z=c[m>>2]|0;m=c[n>>2]|0;n=c[e>>2]|0;A=y;a:while(1){if(n){y=c[n+12>>2]|0;if((y|0)==(c[n+16>>2]|0))B=mo[c[(c[n>>2]|0)+36>>2]&4095](n)|0;else B=c[y>>2]|0;if((B|0)==-1){c[e>>2]=0;C=1;D=0}else{C=0;D=n}}else{C=1;D=0}y=c[f>>2]|0;do if(y){E=c[y+12>>2]|0;if((E|0)==(c[y+16>>2]|0))F=mo[c[(c[y>>2]|0)+36>>2]&4095](y)|0;else F=c[E>>2]|0;if((F|0)!=-1)if(C){G=y;break}else{H=D;I=y;J=A;break a}else{c[f>>2]=0;K=17;break}}else K=17;while(0);if((K|0)==17){K=0;if(C){H=D;I=0;J=A;break}else G=0}y=a[p>>0]|0;E=(y&1)==0;if(E)L=(y&255)>>>1;else L=c[g>>2]|0;if((c[q>>2]|0)==(A+L|0)){if(E){M=(y&255)>>>1;N=(y&255)>>>1}else{y=c[g>>2]|0;M=y;N=y}Bri(p,M<<1,0);if(!(a[p>>0]&1))O=10;else O=(c[p>>2]&-2)+-1|0;Bri(p,O,0);if(!(a[p>>0]&1))P=w;else P=c[x>>2]|0;c[q>>2]=P+N;Q=P}else Q=A;y=D+12|0;E=c[y>>2]|0;R=D+16|0;if((E|0)==(c[R>>2]|0))S=mo[c[(c[D>>2]|0)+36>>2]&4095](D)|0;else S=c[E>>2]|0;if(pui(S,u,v,Q,q,z,m,o,r,s,t,l)|0){H=D;I=G;J=Q;break}E=c[y>>2]|0;if((E|0)==(c[R>>2]|0)){mo[c[(c[D>>2]|0)+40>>2]&4095](D)|0;n=D;A=Q;continue}else{c[y>>2]=E+4;n=D;A=Q;continue}}Q=a[o>>0]|0;if(!(Q&1))T=(Q&255)>>>1;else T=c[o+4>>2]|0;if(!((T|0)==0|(a[u>>0]|0)==0)?(u=c[s>>2]|0,(u-r|0)<160):0){T=c[t>>2]|0;c[s>>2]=u+4;c[u>>2]=T}h[k>>3]=+BBi(J,c[q>>2]|0,j);Uwi(o,r,c[s>>2]|0,j);if(H){s=c[H+12>>2]|0;if((s|0)==(c[H+16>>2]|0))U=mo[c[(c[H>>2]|0)+36>>2]&4095](H)|0;else U=c[s>>2]|0;if((U|0)==-1){c[e>>2]=0;V=0;W=1}else{V=H;W=0}}else{V=0;W=1}do if(I){H=c[I+12>>2]|0;if((H|0)==(c[I+16>>2]|0))X=mo[c[(c[I>>2]|0)+36>>2]&4095](I)|0;else X=c[H>>2]|0;if((X|0)==-1){c[f>>2]=0;K=56;break}if(W){c[b>>2]=V;xri(p);xri(o);i=d;return}}else K=56;while(0);if((K|0)==56?!W:0){c[b>>2]=V;xri(p);xri(o);i=d;return}c[j>>2]=c[j>>2]|2;c[b>>2]=V;xri(p);xri(o);i=d;return}function dAi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=sf(d|0)|0;d=uEi(a,b,e,h)|0;if(!f){i=g;return d|0}sf(f|0)|0;i=g;return d|0}function eAi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=sf(b|0)|0;b=bCi(a,d,g)|0;if(!e){i=f;return b|0}sf(e|0)|0;i=f;return b|0}function fAi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=c[d>>2]|0;if(!m){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;if((h|0)>0?(xo[c[(c[m>>2]|0)+48>>2]&2047](m,e,g)|0)!=(g|0):0){c[d>>2]=0;c[b>>2]=0;i=k;return}do if((q|0)>0){Rri(l,q,j);if(!(a[l>>0]&1))r=l+4|0;else r=c[l+8>>2]|0;if((xo[c[(c[m>>2]|0)+48>>2]&2047](m,r,q)|0)==(q|0)){Tri(l);break}c[d>>2]=0;c[b>>2]=0;Tri(l);i=k;return}while(0);l=n-o|0;o=l>>2;if((l|0)>0?(xo[c[(c[m>>2]|0)+48>>2]&2047](m,f,o)|0)!=(o|0):0){c[d>>2]=0;c[b>>2]=0;i=k;return}c[p>>2]=0;c[b>>2]=m;i=k;return}function gAi(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;k=c[a>>2]|0;do if(k)if((c[k+12>>2]|0)==(c[k+16>>2]|0))if((mo[c[(c[k>>2]|0)+36>>2]&4095](k)|0)==-1){c[a>>2]=0;l=0;break}else{l=c[a>>2]|0;break}else l=k;else l=0;while(0);k=(l|0)==0;l=c[e>>2]|0;do if(l){if((c[l+12>>2]|0)==(c[l+16>>2]|0)?(mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0)==-1:0){c[e>>2]=0;m=11;break}if(k)n=l;else m=12}else m=11;while(0);if((m|0)==11)if(k)m=12;else n=0;if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}k=c[a>>2]|0;l=c[k+12>>2]|0;if((l|0)==(c[k+16>>2]|0))p=mo[c[(c[k>>2]|0)+36>>2]&4095](k)|0;else p=d[l>>0]|0;l=p&255;if(l<<24>>24>-1?(k=g+8|0,(b[(c[k>>2]|0)+(p<<24>>24<<1)>>1]&2048)!=0):0){p=(xo[c[(c[g>>2]|0)+36>>2]&2047](g,l,0)|0)<<24>>24;l=c[a>>2]|0;q=l+12|0;r=c[q>>2]|0;if((r|0)==(c[l+16>>2]|0)){mo[c[(c[l>>2]|0)+40>>2]&4095](l)|0;s=h;t=n;u=n;v=p}else{c[q>>2]=r+1;s=h;t=n;u=n;v=p}while(1){p=v+-48|0;n=s+-1|0;h=c[a>>2]|0;do if(h)if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((mo[c[(c[h>>2]|0)+36>>2]&4095](h)|0)==-1){c[a>>2]=0;w=0;break}else{w=c[a>>2]|0;break}else w=h;else w=0;while(0);h=(w|0)==0;if(u)if((c[u+12>>2]|0)==(c[u+16>>2]|0))if((mo[c[(c[u>>2]|0)+36>>2]&4095](u)|0)==-1){c[e>>2]=0;x=0;y=0}else{x=t;y=t}else{x=t;y=u}else{x=t;y=0}r=c[a>>2]|0;if(!((h^(y|0)==0)&(n|0)>0)){z=r;A=x;B=p;m=40;break}h=c[r+12>>2]|0;if((h|0)==(c[r+16>>2]|0))C=mo[c[(c[r>>2]|0)+36>>2]&4095](r)|0;else C=d[h>>0]|0;h=C&255;if(h<<24>>24<=-1){o=p;m=52;break}if(!(b[(c[k>>2]|0)+(C<<24>>24<<1)>>1]&2048)){o=p;m=52;break}r=((xo[c[(c[g>>2]|0)+36>>2]&2047](g,h,0)|0)<<24>>24)+(p*10|0)|0;h=c[a>>2]|0;q=h+12|0;l=c[q>>2]|0;if((l|0)==(c[h+16>>2]|0)){mo[c[(c[h>>2]|0)+40>>2]&4095](h)|0;s=n;t=x;u=y;v=r;continue}else{c[q>>2]=l+1;s=n;t=x;u=y;v=r;continue}}if((m|0)==40){do if(z)if((c[z+12>>2]|0)==(c[z+16>>2]|0))if((mo[c[(c[z>>2]|0)+36>>2]&4095](z)|0)==-1){c[a>>2]=0;D=0;break}else{D=c[a>>2]|0;break}else D=z;else D=0;while(0);z=(D|0)==0;do if(A){if((c[A+12>>2]|0)==(c[A+16>>2]|0)?(mo[c[(c[A>>2]|0)+36>>2]&4095](A)|0)==-1:0){c[e>>2]=0;m=50;break}if(z){o=B;i=j;return o|0}else E=B}else m=50;while(0);if((m|0)==50)if(z)E=B;else{o=B;i=j;return o|0}c[f>>2]=c[f>>2]|2;o=E;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function hAi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;h=c[a>>2]|0;do if(h){j=c[h+12>>2]|0;if((j|0)==(c[h+16>>2]|0))k=mo[c[(c[h>>2]|0)+36>>2]&4095](h)|0;else k=c[j>>2]|0;if((k|0)==-1){c[a>>2]=0;l=1;break}else{l=(c[a>>2]|0)==0;break}}else l=1;while(0);k=c[b>>2]|0;do if(k){h=c[k+12>>2]|0;if((h|0)==(c[k+16>>2]|0))m=mo[c[(c[k>>2]|0)+36>>2]&4095](k)|0;else m=c[h>>2]|0;if((m|0)!=-1)if(l){n=k;break}else{o=16;break}else{c[b>>2]=0;o=14;break}}else o=14;while(0);if((o|0)==14)if(l)o=16;else n=0;if((o|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}l=c[a>>2]|0;k=c[l+12>>2]|0;if((k|0)==(c[l+16>>2]|0))q=mo[c[(c[l>>2]|0)+36>>2]&4095](l)|0;else q=c[k>>2]|0;if(!(xo[c[(c[e>>2]|0)+12>>2]&2047](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}k=(xo[c[(c[e>>2]|0)+52>>2]&2047](e,q,0)|0)<<24>>24;q=c[a>>2]|0;l=q+12|0;m=c[l>>2]|0;if((m|0)==(c[q+16>>2]|0)){mo[c[(c[q>>2]|0)+40>>2]&4095](q)|0;r=f;s=n;t=n;u=k}else{c[l>>2]=m+4;r=f;s=n;t=n;u=k}while(1){k=u+-48|0;n=r+-1|0;f=c[a>>2]|0;do if(f){m=c[f+12>>2]|0;if((m|0)==(c[f+16>>2]|0))v=mo[c[(c[f>>2]|0)+36>>2]&4095](f)|0;else v=c[m>>2]|0;if((v|0)==-1){c[a>>2]=0;w=1;break}else{w=(c[a>>2]|0)==0;break}}else w=1;while(0);do if(t){f=c[t+12>>2]|0;if((f|0)==(c[t+16>>2]|0))x=mo[c[(c[t>>2]|0)+36>>2]&4095](t)|0;else x=c[f>>2]|0;if((x|0)==-1){c[b>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}else{y=s;z=0;A=1}while(0);f=c[a>>2]|0;if(!((w^A)&(n|0)>0)){B=f;C=y;D=k;break}m=c[f+12>>2]|0;if((m|0)==(c[f+16>>2]|0))E=mo[c[(c[f>>2]|0)+36>>2]&4095](f)|0;else E=c[m>>2]|0;if(!(xo[c[(c[e>>2]|0)+12>>2]&2047](e,2048,E)|0)){p=k;o=63;break}m=((xo[c[(c[e>>2]|0)+52>>2]&2047](e,E,0)|0)<<24>>24)+(k*10|0)|0;f=c[a>>2]|0;l=f+12|0;q=c[l>>2]|0;if((q|0)==(c[f+16>>2]|0)){mo[c[(c[f>>2]|0)+40>>2]&4095](f)|0;r=n;s=y;t=z;u=m;continue}else{c[l>>2]=q+4;r=n;s=y;t=z;u=m;continue}}if((o|0)==63){i=g;return p|0}do if(B){u=c[B+12>>2]|0;if((u|0)==(c[B+16>>2]|0))F=mo[c[(c[B>>2]|0)+36>>2]&4095](B)|0;else F=c[u>>2]|0;if((F|0)==-1){c[a>>2]=0;G=1;break}else{G=(c[a>>2]|0)==0;break}}else G=1;while(0);do if(C){a=c[C+12>>2]|0;if((a|0)==(c[C+16>>2]|0))H=mo[c[(c[C>>2]|0)+36>>2]&4095](C)|0;else H=c[a>>2]|0;if((H|0)==-1){c[b>>2]=0;o=60;break}if(G){p=D;i=g;return p|0}else I=D}else o=60;while(0);if((o|0)==60)if(G)I=D;else{p=D;i=g;return p|0}c[d>>2]=c[d>>2]|2;p=I;i=g;return p|0}function iAi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=3595;h=c[a>>2]|0;j=h;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j|0;j=DDi(g?h:0,l)|0;if(!j)uDi();if(!g){g=c[a>>2]|0;c[a>>2]=j;if(!g)m=j;else{ko[c[f>>2]&4095](g);m=c[a>>2]|0}}else{c[a>>2]=j;m=j}c[f>>2]=3598;c[b>>2]=m+k;c[d>>2]=(c[a>>2]|0)+l;i=e;return}function jAi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=3595;h=c[a>>2]|0;j=h;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;j=DDi(g?h:0,l)|0;if(!j)uDi();if(!g){g=c[a>>2]|0;c[a>>2]=j;if(!g)m=j;else{ko[c[f>>2]&4095](g);m=c[a>>2]|0}}else{c[a>>2]=j;m=j}c[f>>2]=3598;c[b>>2]=m+(k<<2);c[d>>2]=(c[a>>2]|0)+(l>>>2<<2);i=e;return}function kAi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b>>0]|0;if(!(h&1)){j=10;k=(h&255)>>>1;l=h}else{h=c[b>>2]|0;j=(h&-2)+-1|0;k=c[b+4>>2]|0;l=h&255}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((j-k|0)>>>0<h>>>0){Iri(b,j,k+h-j|0,k,k,0,0);m=a[b>>0]|0}else m=l;if(!(m&1))n=b+1|0;else n=c[b+8>>2]|0;m=e+(k-g)|0;g=d;d=n+k|0;while(1){a[d>>0]=a[g>>0]|0;g=g+1|0;if((g|0)==(e|0))break;else d=d+1|0}a[n+m>>0]=0;m=k+h|0;if(!(a[b>>0]&1)){a[b>>0]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function lAi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=3595;h=c[a>>2]|0;j=h;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;j=DDi(g?h:0,l)|0;if(!j)uDi();if(!g){g=c[a>>2]|0;c[a>>2]=j;if(!g)m=j;else{ko[c[f>>2]&4095](g);m=c[a>>2]|0}}else{c[a>>2]=j;m=j}c[f>>2]=3598;c[b>>2]=m+(k<<2);c[d>>2]=(c[a>>2]|0)+(l>>>2<<2);i=e;return}function mAi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b>>0]|0;if(!(h&1)){j=1;k=(h&255)>>>1;l=h}else{h=c[b>>2]|0;j=(h&-2)+-1|0;k=c[b+4>>2]|0;l=h&255}h=e-g>>2;if(!h){i=f;return b|0}if((j-k|0)>>>0<h>>>0){Zri(b,j,k+h-j|0,k,k,0,0);m=a[b>>0]|0}else m=l;if(!(m&1))n=b+4|0;else n=c[b+8>>2]|0;m=n+(k<<2)|0;if((d|0)==(e|0))o=m;else{l=k+((e+-4-g|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];g=g+4|0;if((g|0)==(e|0))break;else d=d+4|0}o=n+(l<<2)|0}c[o>>2]=0;o=k+h|0;if(!(a[b>>0]&1)){a[b>>0]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function nAi(b,d){b=b|0;d=d|0;var e=0;e=i;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+128>>0]=0;if(!d){i=e;return}CBi(b,d);DBi(b,d);i=e;return}function oAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653192)|0);i=c;return}function pAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653232)|0);i=c;return}function qAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654800)|0);i=c;return}function rAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654792)|0);i=c;return}function sAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654864)|0);i=c;return}function tAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654872)|0);i=c;return}function uAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654928)|0);i=c;return}function vAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654936)|0);i=c;return}function wAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654944)|0);i=c;return}function xAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654952)|0);i=c;return}function yAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653304)|0);i=c;return}function zAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653424)|0);i=c;return}function AAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653488)|0);i=c;return}function BAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653584)|0);i=c;return}function CAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654176)|0);i=c;return}function DAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654240)|0);i=c;return}function EAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654304)|0);i=c;return}function FAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654368)|0);i=c;return}function GAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654408)|0);i=c;return}function HAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654488)|0);i=c;return}function IAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654544)|0);i=c;return}function JAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654592)|0);i=c;return}function KAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653696)|0);i=c;return}function LAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3653848)|0);i=c;return}function MAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654080)|0);i=c;return}function NAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654112)|0);i=c;return}function OAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654632)|0);i=c;return}function PAi(a,b){a=a|0;b=b|0;var c=0;c=i;zxi(a,b,Jxi(3654672)|0);i=c;return}function QAi(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b>>2]|0;if(!e){i=d;return}f=b+4|0;g=c[f>>2]|0;if((g|0)!=(e|0))c[f>>2]=g+(~((g+-4-e|0)>>>2)<<2);if((b+16|0)==(e|0)){a[b+128>>0]=0;i=d;return}else{ACi(e);i=d;return}}function RAi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a+4|0;f=c[e>>2]|0;g=c[a>>2]|0;h=f-g>>2;if(h>>>0<b>>>0){EBi(a,b-h|0);i=d;return}if(h>>>0<=b>>>0){i=d;return}h=g+(b<<2)|0;if((f|0)==(h|0)){i=d;return}c[e>>2]=f+(~((f+-4-h|0)>>>2)<<2);i=d;return}function SAi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+8>>2]|0;if((c[a+12>>2]|0)-e>>2>>>0<=b>>>0){f=0;i=d;return f|0}f=(c[e+(b<<2)>>2]|0)!=0;i=d;return f|0}function TAi(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;g=e+4|0;e=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;g=(c[a>>2]|0)+(e>>1)|0;if(!(e&1)){h=f;ko[h&4095](g);i=b;return}else{h=c[(c[g>>2]|0)+f>>2]|0;ko[h&4095](g);i=b;return}}function UAi(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do if(m&2)if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h>>0]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d>>0]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d>>0]=-65;break}while(0);h=f;m=c[g>>2]|0;if(m>>>0>=f>>>0){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r>>0]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r>>0]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r>>0]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=p&63|128;break}if((m&65535)>=56320){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r>>0]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t>>0]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t>>0]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r>>0]=s&63|128}while(0);j=(c[g>>2]|0)+2|0;c[g>>2]=j;if(j>>>0>=f>>>0){o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function VAi(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;if(((((m&4|0)!=0?(f-h|0)>2:0)?(a[h>>0]|0)==-17:0)?(a[h+1>>0]|0)==-69:0)?(a[h+2>>0]|0)==-65:0){m=h+3|0;c[g>>2]=m;o=m}else o=h;a:do if(o>>>0<f>>>0){h=f;m=j;e=c[k>>2]|0;p=o;b:while(1){if(e>>>0>=j>>>0){q=p;break a}r=a[p>>0]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do if(r<<24>>24>-1){b[e>>1]=r&255;c[g>>2]=p+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-p|0)<2){t=1;u=41;break b}v=d[p+1>>0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[e>>1]=w;c[g>>2]=p+2;break}if((r&255)<240){if((h-p|0)<3){t=1;u=41;break b}w=a[p+1>>0]|0;v=a[p+2>>0]|0;if((s|0)==224){if((w&-32)<<24>>24!=-96){t=2;u=41;break b}}else if((s|0)==237){if((w&-32)<<24>>24!=-128){t=2;u=41;break b}}else if((w&-64)<<24>>24!=-128){t=2;u=41;break b}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[e>>1]=v;c[g>>2]=p+3;break}if((r&255)>=245){t=2;u=41;break b}if((h-p|0)<4){t=1;u=41;break b}v=a[p+1>>0]|0;x=a[p+2>>0]|0;w=a[p+3>>0]|0;if((s|0)==244){if((v&-16)<<24>>24!=-128){t=2;u=41;break b}}else if((s|0)==240){if((v+112<<24>>24&255)>=48){t=2;u=41;break b}}else if((v&-64)<<24>>24!=-128){t=2;u=41;break b}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-e|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[e>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=e+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}while(0);e=(c[k>>2]|0)+2|0;c[k>>2]=e;s=c[g>>2]|0;if(s>>>0>=f>>>0){q=s;break a}else p=s}if((u|0)==41){i=n;return t|0}}else q=o;while(0);t=q>>>0<f>>>0&1;i=n;return t|0}function WAi(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)j=(a[b+2>>0]|0)==-65?b+3|0:b;else j=b;a:do if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k>>0]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1>>0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}s=a[k+1>>0]|0;t=a[k+2>>0]|0;if((n|0)==237){if((s&-32)<<24>>24!=-128){u=r;v=23;break b}}else if((n|0)==224){if((s&-32)<<24>>24!=-96){w=r;v=21;break b}}else if((s&-64)<<24>>24!=-128){x=r;v=25;break b}r=t&255;if((r&192|0)!=128){o=k;break a}if(((s&255)<<6&4032|n<<12&61440|r&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if((m&255)>=245){o=k;break a}r=k;if((g-r|0)<4|(e-l|0)>>>0<2){o=k;break a}s=a[k+1>>0]|0;t=a[k+2>>0]|0;y=a[k+3>>0]|0;if((n|0)==244){if((s&-16)<<24>>24!=-128){z=r;v=35;break b}}else if((n|0)==240){if((s+112<<24>>24&255)>=48){A=r;v=33;break b}}else if((s&-64)<<24>>24!=-128){B=r;v=37;break b}r=t&255;if((r&192|0)!=128){o=k;break a}t=y&255;if((t&192|0)!=128){o=k;break a}if(((s&255)<<12&258048|n<<18&1835008|r<<6&4032|t&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}while(0);l=q+1|0;if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}else k=p}if((v|0)==21){C=w-b|0;i=h;return C|0}else if((v|0)==23){C=u-b|0;i=h;return C|0}else if((v|0)==25){C=x-b|0;i=h;return C|0}else if((v|0)==33){C=A-b|0;i=h;return C|0}else if((v|0)==35){C=z-b|0;i=h;return C|0}else if((v|0)==37){C=B-b|0;i=h;return C|0}}else o=j;while(0);C=o-b|0;i=h;return C|0}function XAi(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do if(k&2)if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f>>0]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=-65;break}while(0);f=c[e>>2]|0;if(f>>>0>=d>>>0){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do if(f>>>0>=128){if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b>>0]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b>>0]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b>>0]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=f&63|128;break}}else{b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b>>0]=f}while(0);g=(c[e>>2]|0)+4|0;c[e>>2]=g;if(g>>>0>=d>>>0){m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function YAi(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;if(((((l&4|0)!=0?(e-g|0)>2:0)?(a[g>>0]|0)==-17:0)?(a[g+1>>0]|0)==-69:0)?(a[g+2>>0]|0)==-65:0){l=g+3|0;c[f>>2]=l;n=l}else n=g;a:do if(n>>>0<e>>>0){g=e;l=c[j>>2]|0;b=n;while(1){if(l>>>0>=h>>>0){o=b;p=39;break a}q=a[b>>0]|0;r=q&255;do if(q<<24>>24>-1){if(r>>>0>k>>>0){s=2;break a}c[l>>2]=r;c[f>>2]=b+1}else{if((q&255)<194){s=2;break a}if((q&255)<224){if((g-b|0)<2){s=1;break a}t=d[b+1>>0]|0;if((t&192|0)!=128){s=2;break a}u=t&63|r<<6&1984;if(u>>>0>k>>>0){s=2;break a}c[l>>2]=u;c[f>>2]=b+2;break}if((q&255)<240){if((g-b|0)<3){s=1;break a}u=a[b+1>>0]|0;t=a[b+2>>0]|0;if((r|0)==237){if((u&-32)<<24>>24!=-128){s=2;break a}}else if((r|0)==224){if((u&-32)<<24>>24!=-96){s=2;break a}}else if((u&-64)<<24>>24!=-128){s=2;break a}v=t&255;if((v&192|0)!=128){s=2;break a}t=(u&255)<<6&4032|r<<12&61440|v&63;if(t>>>0>k>>>0){s=2;break a}c[l>>2]=t;c[f>>2]=b+3;break}if((q&255)>=245){s=2;break a}if((g-b|0)<4){s=1;break a}t=a[b+1>>0]|0;v=a[b+2>>0]|0;u=a[b+3>>0]|0;if((r|0)==244){if((t&-16)<<24>>24!=-128){s=2;break a}}else if((r|0)==240){if((t+112<<24>>24&255)>=48){s=2;break a}}else if((t&-64)<<24>>24!=-128){s=2;break a}w=v&255;if((w&192|0)!=128){s=2;break a}v=u&255;if((v&192|0)!=128){s=2;break a}u=(t&255)<<12&258048|r<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){s=2;break a}c[l>>2]=u;c[f>>2]=b+4}while(0);l=(c[j>>2]|0)+4|0;c[j>>2]=l;r=c[f>>2]|0;if(r>>>0>=e>>>0){o=r;p=39;break}else b=r}}else{o=n;p=39}while(0);if((p|0)==39)s=o>>>0<e>>>0&1;i=m;return s|0}function ZAi(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)j=(a[b+2>>0]|0)==-65?b+3|0:b;else j=b;a:do if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k>>0]|0;n=m&255;do if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1>>0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){q=k;if((g-q|0)<3){o=k;break a}r=a[k+1>>0]|0;s=a[k+2>>0]|0;if((n|0)==237){if((r&-32)<<24>>24!=-128){t=q;u=23;break b}}else if((n|0)==224){if((r&-32)<<24>>24!=-96){v=q;u=21;break b}}else if((r&-64)<<24>>24!=-128){w=q;u=25;break b}q=s&255;if((q&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|q&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if((m&255)>=245){o=k;break a}q=k;if((g-q|0)<4){o=k;break a}r=a[k+1>>0]|0;s=a[k+2>>0]|0;x=a[k+3>>0]|0;if((n|0)==240){if((r+112<<24>>24&255)>=48){y=q;u=33;break b}}else if((n|0)==244){if((r&-16)<<24>>24!=-128){z=q;u=35;break b}}else if((r&-64)<<24>>24!=-128){A=q;u=37;break b}q=s&255;if((q&192|0)!=128){o=k;break a}s=x&255;if((s&192|0)!=128){o=k;break a}if(((r&255)<<12&258048|n<<18&1835008|q<<6&4032|s&63)>>>0>f>>>0){o=k;break a}p=k+4|0}while(0);l=l+1|0;if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}else k=p}if((u|0)==21){B=v-b|0;i=h;return B|0}else if((u|0)==23){B=t-b|0;i=h;return B|0}else if((u|0)==25){B=w-b|0;i=h;return B|0}else if((u|0)==33){B=y-b|0;i=h;return B|0}else if((u|0)==35){B=z-b|0;i=h;return B|0}else if((u|0)==37){B=A-b|0;i=h;return B|0}}else o=j;while(0);B=o-b|0;i=h;return B|0}function _Ai(a){a=a|0;var b=0;b=i;wsi(a);ACi(a);i=b;return}function $Ai(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0;f=Kxi(d,3654872)|0;c[b+36>>2]=f;a[b+44>>0]=(mo[c[(c[f>>2]|0)+28>>2]&4095](f)|0)&1;i=e;return}function aBi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+36|0;g=a+40|0;h=d+8|0;j=d;k=a+32|0;while(1){a=c[f>>2]|0;l=Bn[c[(c[a>>2]|0)+20>>2]&255](a,c[g>>2]|0,d,h,e)|0;a=(c[e>>2]|0)-j|0;if((_f(d|0,1,a|0,c[k>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((Wg(c[k>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function bBi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if(a[b+44>>0]|0){g=_f(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((_n[c[(c[b>>2]|0)+52>>2]&4095](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function cBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;k=(d|0)==-1;a:do if(!k){c[g>>2]=d;if(a[b+44>>0]|0){if((_f(g|0,4,1,c[b+32>>2]|0)|0)==1)break;else l=-1;i=e;return l|0}c[h>>2]=f;m=g+4|0;n=b+36|0;o=b+40|0;p=f+8|0;q=f;r=b+32|0;s=g;while(1){t=c[n>>2]|0;u=Oo[c[(c[t>>2]|0)+12>>2]&63](t,c[o>>2]|0,s,m,j,f,p,h)|0;if((c[j>>2]|0)==(s|0)){l=-1;v=12;break}if((u|0)==3){w=s;v=7;break}t=(u|0)==1;if(u>>>0>=2){l=-1;v=12;break}u=(c[h>>2]|0)-q|0;if((_f(f|0,1,u|0,c[r>>2]|0)|0)!=(u|0)){l=-1;v=12;break}if(t)s=t?c[j>>2]|0:s;else break a}if((v|0)==7){if((_f(w|0,1,1,c[r>>2]|0)|0)==1)break;else l=-1;i=e;return l|0}else if((v|0)==12){i=e;return l|0}}while(0);l=k?0:d;i=e;return l|0}function dBi(a){a=a|0;var b=0;b=i;wsi(a);ACi(a);i=b;return}function eBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=Kxi(d,3654872)|0;d=b+36|0;c[d>>2]=f;g=b+44|0;c[g>>2]=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=c[d>>2]|0;a[b+53>>0]=(mo[c[(c[f>>2]|0)+28>>2]&4095](f)|0)&1;if((c[g>>2]|0)>8)Rwi(3651088);else{i=e;return}}function fBi(a){a=a|0;var b=0,c=0;b=i;c=FBi(a,0)|0;i=b;return c|0}function gBi(a){a=a|0;var b=0,c=0;b=i;c=FBi(a,1)|0;i=b;return c|0}function hBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;k=b+52|0;l=(a[k>>0]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k>>0]=(n|0)!=-1&1;m=n;i=e;return m|0}n=b+48|0;a:do if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=Oo[c[(c[o>>2]|0)+12>>2]&63](o,c[b+40>>2]|0,h,h+4|0,j,f,f+8|0,g)|0;if((p|0)==1|(p|0)==2){m=-1;i=e;return m|0}else if((p|0)==3){a[f>>0]=c[n>>2];c[g>>2]=f+1}p=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=f>>>0)break a;q=o+-1|0;c[g>>2]=q;if((wj(a[q>>0]|0,c[p>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}while(0);c[n>>2]=d;a[k>>0]=1;m=d;i=e;return m|0}function iBi(a){a=a|0;var b=0;b=i;gsi(a);ACi(a);i=b;return}function jBi(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;mo[c[(c[b>>2]|0)+24>>2]&4095](b)|0;f=Kxi(d,3654864)|0;c[b+36>>2]=f;a[b+44>>0]=(mo[c[(c[f>>2]|0)+28>>2]&4095](f)|0)&1;i=e;return}function kBi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b+8|0;e=b;f=a+36|0;g=a+40|0;h=d+8|0;j=d;k=a+32|0;while(1){a=c[f>>2]|0;l=Bn[c[(c[a>>2]|0)+20>>2]&255](a,c[g>>2]|0,d,h,e)|0;a=(c[e>>2]|0)-j|0;if((_f(d|0,1,a|0,c[k>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((Wg(c[k>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function lBi(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if(a[b+44>>0]|0){h=_f(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((_n[c[(c[b>>2]|0)+52>>2]&4095](b,d[j>>0]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function mBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;k=(d|0)==-1;a:do if(!k){a[g>>0]=d;if(a[b+44>>0]|0){if((_f(g|0,1,1,c[b+32>>2]|0)|0)==1)break;else l=-1;i=e;return l|0}c[h>>2]=f;m=g+1|0;n=b+36|0;o=b+40|0;p=f+8|0;q=f;r=b+32|0;s=g;while(1){t=c[n>>2]|0;u=Oo[c[(c[t>>2]|0)+12>>2]&63](t,c[o>>2]|0,s,m,j,f,p,h)|0;if((c[j>>2]|0)==(s|0)){l=-1;v=12;break}if((u|0)==3){w=s;v=7;break}t=(u|0)==1;if(u>>>0>=2){l=-1;v=12;break}u=(c[h>>2]|0)-q|0;if((_f(f|0,1,u|0,c[r>>2]|0)|0)!=(u|0)){l=-1;v=12;break}if(t)s=t?c[j>>2]|0:s;else break a}if((v|0)==7){if((_f(w|0,1,1,c[r>>2]|0)|0)==1)break;else l=-1;i=e;return l|0}else if((v|0)==12){i=e;return l|0}}while(0);l=k?0:d;i=e;return l|0}function nBi(a){a=a|0;var b=0;b=i;gsi(a);ACi(a);i=b;return}function oBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=Kxi(d,3654864)|0;d=b+36|0;c[d>>2]=f;g=b+44|0;c[g>>2]=mo[c[(c[f>>2]|0)+24>>2]&4095](f)|0;f=c[d>>2]|0;a[b+53>>0]=(mo[c[(c[f>>2]|0)+28>>2]&4095](f)|0)&1;if((c[g>>2]|0)>8)Rwi(3651088);else{i=e;return}}function pBi(a){a=a|0;var b=0,c=0;b=i;c=GBi(a,0)|0;i=b;return c|0}function qBi(a){a=a|0;var b=0,c=0;b=i;c=GBi(a,1)|0;i=b;return c|0}function rBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+16|0;g=e+4|0;h=e+8|0;j=e;k=b+52|0;l=(a[k>>0]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k>>0]=(n|0)!=-1&1;m=n;i=e;return m|0}n=b+48|0;a:do if(l){a[h>>0]=c[n>>2];o=c[b+36>>2]|0;p=Oo[c[(c[o>>2]|0)+12>>2]&63](o,c[b+40>>2]|0,h,h+1|0,j,f,f+8|0,g)|0;if((p|0)==3){a[f>>0]=c[n>>2];c[g>>2]=f+1}else if((p|0)==1|(p|0)==2){m=-1;i=e;return m|0}p=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=f>>>0)break a;q=o+-1|0;c[g>>2]=q;if((wj(a[q>>0]|0,c[p>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}while(0);c[n>>2]=d;a[k>>0]=1;m=d;i=e;return m|0}function sBi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function tBi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;if((a|0)==(b|0)){c[d>>2]=4;h=0;i=f;return h|0}j=xd()|0;k=c[j>>2]|0;c[j>>2]=0;l=MBi(a,g,e,Xti()|0)|0;e=H;a=c[j>>2]|0;if(!a)c[j>>2]=k;if((c[g>>2]|0)!=(b|0)){c[d>>2]=4;h=0;i=f;return h|0}do if((a|0)==34){c[d>>2]=4;if((e|0)>0|(e|0)==0&l>>>0>0){h=2147483647;i=f;return h|0}}else{if((e|0)<-1|(e|0)==-1&l>>>0<2147483648){c[d>>2]=4;break}if((e|0)>0|(e|0)==0&l>>>0>2147483647){c[d>>2]=4;h=2147483647;i=f;return h|0}else{h=l;i=f;return h|0}}while(0);h=-2147483648;i=f;return h|0}function uBi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;if((a|0)==(b|0)){c[d>>2]=4;h=0;j=0;H=h;i=f;return j|0}k=xd()|0;l=c[k>>2]|0;c[k>>2]=0;m=MBi(a,g,e,Xti()|0)|0;e=H;a=c[k>>2]|0;if(!a)c[k>>2]=l;if((c[g>>2]|0)!=(b|0)){c[d>>2]=4;h=0;j=0;H=h;i=f;return j|0}if((a|0)==34){c[d>>2]=4;d=(e|0)>0|(e|0)==0&m>>>0>0;H=d?2147483647:-2147483648;i=f;return (d?-1:0)|0}else{h=e;j=m;H=h;i=f;return j|0}return 0}function vBi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b>>0]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=xd()|0;l=c[k>>2]|0;c[k>>2]=0;m=LBi(b,h,f,Xti()|0)|0;f=H;b=c[k>>2]|0;if(!b)c[k>>2]=l;if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function wBi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b>>0]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=xd()|0;l=c[k>>2]|0;c[k>>2]=0;m=LBi(b,h,f,Xti()|0)|0;f=H;b=c[k>>2]|0;if(!b)c[k>>2]=l;if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function xBi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b>>0]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=xd()|0;l=c[k>>2]|0;c[k>>2]=0;m=LBi(b,h,f,Xti()|0)|0;f=H;b=c[k>>2]|0;if(!b)c[k>>2]=l;if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function yBi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+16|0;h=g;do if((b|0)!=(d|0)){if((a[b>>0]|0)==45){c[e>>2]=4;j=0;k=0;break}l=xd()|0;m=c[l>>2]|0;c[l>>2]=0;n=LBi(b,h,f,Xti()|0)|0;o=c[l>>2]|0;if(!o)c[l>>2]=m;if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)==34){c[e>>2]=4;j=-1;k=-1}else{j=H;k=n}}else{c[e>>2]=4;j=0;k=0}while(0);H=j;i=g;return k|0}function zBi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=Im,h=0,j=0,k=0.0;e=i;i=i+16|0;f=e;if((a|0)==(b|0)){c[d>>2]=4;g=ea(0.0);i=e;return ea(g)}h=xd()|0;j=c[h>>2]|0;c[h>>2]=0;k=+zEi(a,f,Xti()|0);a=c[h>>2]|0;if(!a)c[h>>2]=j;if((c[f>>2]|0)!=(b|0)){c[d>>2]=4;g=ea(0.0);i=e;return ea(g)}if((a|0)==34)c[d>>2]=4;g=ea(k);i=e;return ea(g)}function ABi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0.0,k=0,l=0.0;e=i;i=i+16|0;f=e;do if((a|0)!=(b|0)){g=xd()|0;h=c[g>>2]|0;c[g>>2]=0;j=+zEi(a,f,Xti()|0);k=c[g>>2]|0;if(!k)c[g>>2]=h;if((c[f>>2]|0)!=(b|0)){c[d>>2]=4;l=0.0;break}if((k|0)==34){c[d>>2]=4;l=j}else l=j}else{c[d>>2]=4;l=0.0}while(0);i=e;return +l}function BBi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0.0,k=0,l=0.0;e=i;i=i+16|0;f=e;do if((a|0)!=(b|0)){g=xd()|0;h=c[g>>2]|0;c[g>>2]=0;j=+zEi(a,f,Xti()|0);k=c[g>>2]|0;if(!k)c[g>>2]=h;if((c[f>>2]|0)!=(b|0)){c[d>>2]=4;l=0.0;break}if((k|0)==34){c[d>>2]=4;l=j}else l=j}else{c[d>>2]=4;l=0.0}while(0);i=e;return +l}function CBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if(d>>>0>1073741823)vxi(b);f=b+128|0;if((a[f>>0]|0)==0&d>>>0<29){a[f>>0]=1;g=b+16|0}else g=xCi(d<<2)|0;c[b+4>>2]=g;c[b>>2]=g;c[b+8>>2]=g+(d<<2);i=e;return}function DBi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+4|0;a=b;b=c[e>>2]|0;do{if(!b)f=0;else{c[b>>2]=0;f=c[e>>2]|0}b=f+4|0;c[e>>2]=b;a=a+-1|0}while((a|0)!=0);i=d;return}function EBi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=c[a+8>>2]|0;g=c[a+4>>2]|0;if(f-g>>2>>>0>=b>>>0){DBi(a,b);i=d;return}h=c[a>>2]|0;j=g-h>>2;g=j+b|0;if(g>>>0>1073741823)vxi(a);k=f-h|0;if(k>>2>>>0<536870911){h=k>>1;l=h>>>0<g>>>0?g:h}else l=1073741823;HBi(e,l,j,a+16|0);IBi(e,b);JBi(a,e);KBi(e);i=d;return}function FBi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;k=b+52|0;if(a[k>>0]|0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k>>0]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do if((k|0)>0){m=b+32|0;l=0;while(1){o=Qj(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l>>0]=o;l=l+1|0;if((l|0)>=(k|0))break a}i=e;return n|0}while(0);b:do if(!(a[b+53>>0]|0)){l=b+40|0;m=b+36|0;o=g+4|0;p=b+32|0;q=k;while(1){r=c[l>>2]|0;s=r;t=c[s>>2]|0;u=c[s+4>>2]|0;s=c[m>>2]|0;v=f+q|0;w=Oo[c[(c[s>>2]|0)+16>>2]&63](s,r,f,v,h,g,o,j)|0;if((w|0)==2){n=-1;x=22;break}else if((w|0)==3){y=q;x=14;break}else if((w|0)!=1){z=q;break b}w=c[l>>2]|0;c[w>>2]=t;c[w+4>>2]=u;if((q|0)==8){n=-1;x=22;break}u=Qj(c[p>>2]|0)|0;if((u|0)==-1){n=-1;x=22;break}a[v>>0]=u;q=q+1|0}if((x|0)==14){c[g>>2]=a[f>>0];z=y;break}else if((x|0)==22){i=e;return n|0}}else{c[g>>2]=a[f>>0];z=k}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0)break;b=b+-1|0;if((wj(a[f+b>>0]|0,c[d>>2]|0)|0)==-1){n=-1;x=22;break}}if((x|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function GBi(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;k=f;l=b+52|0;if(a[l>>0]|0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l>>0]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do if((l|0)>0){n=b+32|0;m=0;while(1){p=Qj(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m>>0]=p;m=m+1|0;if((m|0)>=(l|0))break a}i=f;return o|0}while(0);b:do if(!(a[b+53>>0]|0)){m=b+40|0;n=b+36|0;p=h+1|0;q=b+32|0;r=l;while(1){s=c[m>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[n>>2]|0;w=g+r|0;x=Oo[c[(c[t>>2]|0)+16>>2]&63](t,s,g,w,j,h,p,k)|0;if((x|0)==3){y=r;z=14;break}else if((x|0)==2){o=-1;z=23;break}else if((x|0)!=1){A=r;break b}x=c[m>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){o=-1;z=23;break}v=Qj(c[q>>2]|0)|0;if((v|0)==-1){o=-1;z=23;break}a[w>>0]=v;r=r+1|0}if((z|0)==14){a[h>>0]=a[g>>0]|0;A=y;break}else if((z|0)==23){i=f;return o|0}}else{a[h>>0]=a[g>>0]|0;A=l}while(0);do if(!e){l=b+32|0;y=A;while(1){if((y|0)<=0){z=21;break}y=y+-1|0;if((wj(d[g+y>>0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}}if((z|0)==21){B=a[h>>0]|0;break}else if((z|0)==23){i=f;return o|0}}else{l=a[h>>0]|0;c[b+48>>2]=l&255;B=l}while(0);o=B&255;i=f;return o|0}function HBi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=b+12|0;c[h>>2]=0;c[b+16>>2]=f;do if(d){j=f+112|0;if((a[j>>0]|0)==0&d>>>0<29){a[j>>0]=1;k=f;break}else{k=xCi(d<<2)|0;break}}else k=0;while(0);c[b>>2]=k;f=k+(e<<2)|0;c[b+8>>2]=f;c[b+4>>2]=f;c[h>>2]=k+(d<<2);i=g;return}function IBi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a+8|0;a=b;b=c[e>>2]|0;do{if(!b)f=0;else{c[b>>2]=0;f=c[e>>2]|0}b=f+4|0;c[e>>2]=b;a=a+-1|0}while((a|0)!=0);i=d;return}function JBi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[a>>2]|0;f=a+4|0;g=b+4|0;h=(c[f>>2]|0)-e|0;j=(c[g>>2]|0)+(0-(h>>2)<<2)|0;c[g>>2]=j;YEi(j|0,e|0,h|0)|0;h=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=h;h=b+8|0;e=c[f>>2]|0;c[f>>2]=c[h>>2];c[h>>2]=e;e=a+8|0;a=b+12|0;h=c[e>>2]|0;c[e>>2]=c[a>>2];c[a>>2]=h;c[b>>2]=c[g>>2];i=d;return}function KBi(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+4>>2]|0;f=b+8|0;g=c[f>>2]|0;if((g|0)!=(e|0))c[f>>2]=g+(~((g+-4-e|0)>>>2)<<2);e=c[b>>2]|0;if(!e){i=d;return}g=c[b+16>>2]|0;if((g|0)==(e|0)){a[g+112>>0]=0;i=d;return}else{ACi(e);i=d;return}}function LBi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=i;e=AEi(a,b,c)|0;i=d;return e|0}function MBi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=i;e=BEi(a,b,c)|0;i=d;return e|0}function NBi(a){a=a|0;return ((a|32)+-97|0)>>>0<26|0}function OBi(a){a=a|0;return a>>>0<128|0}function PBi(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[3662456+((d[3662456+(a>>>8)>>0]|0)<<5|a>>>3&31)>>0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606&1;i=b;return c|0}return 0}function QBi(a){a=a|0;var b=0,c=0;b=i;c=sCi(a,1)|0;i=b;return c|0}function RBi(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function SBi(a,b){a=a|0;b=b|0;var c=0;b=i;c=HDi(a)|0;i=b;return c|0}function TBi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=UBi(0,a,b,(c|0)!=0?c:3666384)|0;i=d;return e|0}function UBi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+16|0;h=g;c[h>>2]=b;j=(f|0)==0?3666392:f;f=c[j>>2]|0;a:do if(!d){if(!f){k=0;i=g;return k|0}}else{if(!b){c[h>>2]=h;l=h}else l=b;if(!e){k=-2;i=g;return k|0}do if(!f){m=a[d>>0]|0;n=m&255;if(m<<24>>24>-1){c[l>>2]=n;k=m<<24>>24!=0&1;i=g;return k|0}else{m=n+-194|0;if(m>>>0>50)break a;o=e+-1|0;p=c[3666176+(m<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}while(0);b:do if(!o)r=p;else{m=a[q>>0]|0;n=(m&255)>>>3;if((n+-16|n+(p>>26))>>>0>7)break a;else{s=o;t=m;u=p;v=q}while(1){v=v+1|0;u=(t&255)+-128|u<<6;s=s+-1|0;if((u|0)>=0){w=u;x=s;break}if(!s){r=u;break b}t=a[v>>0]|0;if((t&-64)<<24>>24!=-128)break a}c[j>>2]=0;c[l>>2]=w;k=e-x|0;i=g;return k|0}while(0);c[j>>2]=r;k=-2;i=g;return k|0}while(0);c[j>>2]=0;c[(xd()|0)>>2]=84;k=-1;i=g;return k|0}function VBi(a){a=a|0;var b=0;if(!a)b=1;else b=(c[a>>2]|0)==0;return b&1|0}function WBi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+1040|0;h=g+8|0;j=g;k=c[b>>2]|0;c[j>>2]=k;l=(a|0)!=0;m=l?e:256;e=l?a:h;a:do if((k|0)!=0&(m|0)!=0){a=m;n=d;o=k;p=0;q=e;while(1){r=n>>>2;s=r>>>0>=a>>>0;if(!(s|n>>>0>131)){t=n;u=a;v=o;w=p;x=q;y=7;break a}z=s?a:r;r=n-z|0;s=XBi(q,j,z,f)|0;if((s|0)==-1){A=-1;break a}if((q|0)==(h|0)){B=a;C=h}else{B=a-s|0;C=q+(s<<2)|0}z=s+p|0;s=c[j>>2]|0;if((s|0)!=0&(B|0)!=0){a=B;n=r;o=s;p=z;q=C}else{t=r;u=B;v=s;w=z;x=C;y=7;break}}}else{t=d;u=m;v=k;w=0;x=e;y=7}while(0);b:do if((y|0)==7)if((v|0)!=0&(u|0)!=0&(t|0)!=0){e=t;k=u;m=v;d=w;C=x;while(1){B=UBi(C,m,e,f)|0;if((B+2|0)>>>0<3){D=B;E=d;break}m=(c[j>>2]|0)+B|0;c[j>>2]=m;k=k+-1|0;h=d+1|0;if(!((k|0)!=0&(e|0)!=(B|0))){A=h;break b}else{e=e-B|0;d=h;C=C+4|0}}if((D|0)==-1){A=-1;break}else if(!D){c[j>>2]=0;A=E;break}else{c[f>>2]=0;A=E;break}}else A=w;while(0);if(!l){i=g;return A|0}c[b>>2]=c[j>>2];i=g;return A|0}function XBi(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;h=i;j=c[e>>2]|0;if((g|0)!=0?(k=c[g>>2]|0,(k|0)!=0):0)if(!b){l=f;m=k;n=j;o=16}else{c[g>>2]=0;p=b;q=f;r=k;s=j;o=36}else if(!b){t=f;u=j;o=7}else{v=b;w=f;x=j;o=6}a:while(1)if((o|0)==6){o=0;if(!w){y=x;o=26;break}else{z=v;A=w;B=x}while(1){j=a[B>>0]|0;b:do if(((j&255)+-1|0)>>>0<127?(B&3|0)==0&A>>>0>4:0){k=z;g=A;C=B;while(1){D=c[C>>2]|0;if((D+-16843009|D)&-2139062144){E=k;F=g;G=D&255;H=C;break b}c[k>>2]=D&255;c[k+4>>2]=d[C+1>>0];c[k+8>>2]=d[C+2>>0];D=C+4|0;I=k+16|0;c[k+12>>2]=d[C+3>>0];J=g+-4|0;if(J>>>0>4){k=I;g=J;C=D}else{K=D;L=I;M=J;break}}E=L;F=M;G=a[K>>0]|0;H=K}else{E=z;F=A;G=j;H=B}while(0);j=G&255;if((j+-1|0)>>>0>=127){N=E;O=F;P=j;Q=H;break}C=H+1|0;c[E>>2]=j;A=F+-1|0;if(!A){y=C;o=26;break a}else{z=E+4|0;B=C}}C=P+-194|0;if(C>>>0>50){R=N;S=O;T=Q;o=47;break}p=N;q=O;r=c[3666176+(C<<2)>>2]|0;s=Q+1|0;o=36;continue}else if((o|0)==7){o=0;C=a[u>>0]|0;if(((C&255)+-1|0)>>>0<127?(u&3|0)==0:0){j=c[u>>2]|0;if(!((j+-16843009|j)&-2139062144)){g=t;k=u;while(1){J=k+4|0;I=g+-4|0;D=c[J>>2]|0;if(!((D+-16843009|D)&-2139062144)){g=I;k=J}else{U=I;V=D;W=J;break}}}else{U=t;V=j;W=u}X=U;Y=V&255;Z=W}else{X=t;Y=C;Z=u}k=Y&255;if((k+-1|0)>>>0<127){t=X+-1|0;u=Z+1|0;o=7;continue}else{_=X;$=k;aa=Z}k=$+-194|0;if(k>>>0>50){R=b;S=_;T=aa;o=47;break}l=_;m=c[3666176+(k<<2)>>2]|0;n=aa+1|0;o=16;continue}else if((o|0)==16){o=0;k=(d[n>>0]|0)>>>3;if((k+-16|k+(m>>26))>>>0>7){o=17;break}k=n+1|0;if(m&33554432){if((a[k>>0]&-64)<<24>>24!=-128){o=20;break}g=n+2|0;if(!(m&524288))ba=g;else{if((a[g>>0]&-64)<<24>>24!=-128){o=23;break}ba=n+3|0}}else ba=k;t=l+-1|0;u=ba;o=7;continue}else if((o|0)==36){o=0;k=d[s>>0]|0;g=k>>>3;if((g+-16|g+(r>>26))>>>0>7){o=37;break}g=s+1|0;ca=k+-128|r<<6;if((ca|0)<0){k=d[g>>0]|0;if((k&192|0)!=128){o=40;break}J=s+2|0;da=k+-128|ca<<6;if((da|0)<0){k=d[J>>0]|0;if((k&192|0)!=128){o=43;break}ea=k+-128|da<<6;fa=s+3|0}else{ea=da;fa=J}}else{ea=ca;fa=g}c[p>>2]=ea;v=p+4|0;w=q+-1|0;x=fa;o=6;continue}if((o|0)==17){ga=b;ha=l;ia=m;ja=n+-1|0;o=46}else if((o|0)==20){ga=b;ha=l;ia=m;ja=n+-1|0;o=46}else if((o|0)==23){ga=b;ha=l;ia=m;ja=n+-1|0;o=46}else if((o|0)==26){c[e>>2]=y;ka=f;i=h;return ka|0}else if((o|0)==37){ga=p;ha=q;ia=r;ja=s+-1|0;o=46}else if((o|0)==40){ga=p;ha=q;ia=ca;ja=s+-1|0;o=46}else if((o|0)==43){ga=p;ha=q;ia=da;ja=s+-1|0;o=46}if((o|0)==46)if(!ia){R=ga;S=ha;T=ja;o=47}else{la=ga;ma=ja}if((o|0)==47)if(!(a[T>>0]|0)){if(R){c[R>>2]=0;c[e>>2]=0}ka=f-S|0;i=h;return ka|0}else{la=R;ma=T}c[(xd()|0)>>2]=84;if(!la){ka=-1;i=h;return ka|0}c[e>>2]=ma;ka=-1;i=h;return ka|0}function YBi(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;c[h>>2]=b;if(!e){j=0;i=g;return j|0}do if(f){if(!b){c[h>>2]=h;k=h}else k=b;l=a[e>>0]|0;m=l&255;if(l<<24>>24>-1){c[k>>2]=m;j=l<<24>>24!=0&1;i=g;return j|0}l=m+-194|0;if(l>>>0<=50){m=e+1|0;n=c[3666176+(l<<2)>>2]|0;if(f>>>0<4?(n&-2147483648>>>((f*6|0)+-6|0)|0)!=0:0)break;l=d[m>>0]|0;m=l>>>3;if((m+-16|m+(n>>26))>>>0<=7){m=l+-128|n<<6;if((m|0)>=0){c[k>>2]=m;j=2;i=g;return j|0}n=d[e+2>>0]|0;if((n&192|0)==128){l=n+-128|m<<6;if((l|0)>=0){c[k>>2]=l;j=3;i=g;return j|0}m=d[e+3>>0]|0;if((m&192|0)==128){c[k>>2]=m+-128|l<<6;j=4;i=g;return j|0}}}}}while(0);c[(xd()|0)>>2]=84;j=-1;i=g;return j|0}function ZBi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+272|0;g=f+8|0;h=f;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:g;a:do if((j|0)!=0&(l|0)!=0){a=l;m=d;n=j;o=0;p=e;while(1){q=m>>>0>=a>>>0;if(!(q|m>>>0>32)){r=m;s=a;t=n;u=o;v=p;w=7;break a}x=q?a:m;q=m-x|0;y=_Bi(p,h,x,0)|0;if((y|0)==-1){z=-1;break a}if((p|0)==(g|0)){A=a;B=g}else{A=a-y|0;B=p+y|0}x=y+o|0;y=c[h>>2]|0;if((y|0)!=0&(A|0)!=0){a=A;m=q;n=y;o=x;p=B}else{r=q;s=A;t=y;u=x;v=B;w=7;break}}}else{r=d;s=l;t=j;u=0;v=e;w=7}while(0);b:do if((w|0)==7)if((t|0)!=0&(s|0)!=0&(r|0)!=0){e=r;j=s;l=t;d=u;B=v;while(1){A=lEi(B,c[l>>2]|0,0)|0;if((A+1|0)>>>0<2){C=A;D=d;break}l=(c[h>>2]|0)+4|0;c[h>>2]=l;e=e+-1|0;g=d+1|0;if(!((j|0)!=(A|0)&(e|0)!=0)){z=g;break b}else{j=j-A|0;d=g;B=B+A|0}}if(!C){c[h>>2]=0;z=D}else z=-1}else z=u;while(0);if(!k){i=f;return z|0}c[b>>2]=c[h>>2];i=f;return z|0}function _Bi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+16|0;g=f;if(!b){h=c[d>>2]|0;j=c[h>>2]|0;if(!j){k=0;i=f;return k|0}else{l=0;m=j;n=h}while(1){if(m>>>0>127){h=lEi(g,m,0)|0;if((h|0)==-1){k=-1;o=26;break}else p=h}else p=1;h=p+l|0;n=n+4|0;m=c[n>>2]|0;if(!m){k=h;o=26;break}else l=h}if((o|0)==26){i=f;return k|0}}a:do if(e>>>0>3){l=b;m=e;n=c[d>>2]|0;while(1){p=c[n>>2]|0;if((p+-1|0)>>>0>126){if(!p){q=l;r=m;break}h=lEi(l,p,0)|0;if((h|0)==-1){k=-1;o=26;break}s=l+h|0;t=m-h|0;u=n}else{a[l>>0]=p;s=l+1|0;t=m+-1|0;u=c[d>>2]|0}n=u+4|0;c[d>>2]=n;if(t>>>0<=3){v=s;w=t;break a}else{l=s;m=t}}if((o|0)==26){i=f;return k|0}a[q>>0]=0;c[d>>2]=0;k=e-r|0;i=f;return k|0}else{v=b;w=e}while(0);if(!w){k=e;i=f;return k|0}b=v;v=w;w=c[d>>2]|0;while(1){r=c[w>>2]|0;if((r+-1|0)>>>0>126){if(!r){x=b;y=v;o=19;break}q=lEi(g,r,0)|0;if((q|0)==-1){k=-1;o=26;break}if(v>>>0<q>>>0){z=v;o=22;break}lEi(b,c[w>>2]|0,0)|0;A=b+q|0;B=v-q|0;C=w}else{a[b>>0]=r;A=b+1|0;B=v+-1|0;C=c[d>>2]|0}w=C+4|0;c[d>>2]=w;if(!B){k=e;o=26;break}else{b=A;v=B}}if((o|0)==19){a[x>>0]=0;c[d>>2]=0;k=e-y|0;i=f;return k|0}else if((o|0)==22){k=e-z|0;i=f;return k|0}else if((o|0)==26){i=f;return k|0}return 0}function $Bi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+84|0;g=c[f>>2]|0;h=d+256|0;j=EEi(g,0,h)|0;if(!j)k=h;else k=j-g|0;j=k>>>0<d>>>0?k:d;YEi(b|0,g|0,j|0)|0;c[a+4>>2]=g+j;b=g+k|0;c[a+8>>2]=b;c[f>>2]=b;i=e;return j|0}function aCi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=dCi(a,b,f)|0;i=e;return d|0}function bCi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=ADi(240)|0;do if(g){c[f>>2]=c[d>>2];h=uEi(g,240,b,f)|0;if(h>>>0<240){j=DDi(g,h+1|0)|0;c[a>>2]=(j|0)!=0?j:g;k=h;break}BDi(g);if((h|0)>=0?(j=h+1|0,h=ADi(j)|0,c[a>>2]=h,(h|0)!=0):0)k=uEi(h,j,b,d)|0;else k=-1}else k=-1;while(0);i=e;return k|0}function cCi(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;k=i;i=i+304|0;l=k+16|0;m=k+8|0;n=k+33|0;o=k;p=k+32|0;q=a[f>>0]|0;if(!(q<<24>>24)){r=0;i=k;return r|0}s=e+4|0;t=e+100|0;u=e+108|0;v=e+8|0;w=n+10|0;x=n+33|0;y=m+4|0;z=n+46|0;A=n+94|0;B=q;q=0;C=f;f=0;D=0;E=0;a:while(1){b:do if(!(FDi(B&255)|0)){F=(a[C>>0]|0)==37;c:do if(F){G=C+1|0;I=a[G>>0]|0;do if(I<<24>>24==37)break c;else if(I<<24>>24==42){J=0;K=C+2|0}else{L=(I&255)+-48|0;if(L>>>0<10?(a[C+2>>0]|0)==36:0){c[l>>2]=c[j>>2];M=L;while(1){L=c[l>>2]|0;N=c[L>>2]|0;c[l>>2]=L+4;if(M>>>0>1)M=M+-1|0;else{O=N;break}}J=O;K=C+3|0;break}M=c[j>>2]|0;N=c[M>>2]|0;c[j>>2]=M+4;J=N;K=G}while(0);G=a[K>>0]|0;I=G&255;if((I+-48|0)>>>0<10){N=I;I=K;M=0;while(1){L=(M*10|0)+-48+N|0;P=I+1|0;Q=a[P>>0]|0;N=Q&255;if((N+-48|0)>>>0>=10){R=Q;S=P;T=L;break}else{I=P;M=L}}}else{R=G;S=K;T=0}if(R<<24>>24==109){M=S+1|0;U=a[M>>0]|0;V=(J|0)!=0&1;W=M;X=0;Y=0}else{U=R;V=0;W=S;X=D;Y=E}M=W+1|0;switch(U&255|0){case 104:{I=(a[M>>0]|0)==104;Z=I?W+2|0:M;_=I?-2:-1;break}case 108:{I=(a[M>>0]|0)==108;Z=I?W+2|0:M;_=I?3:1;break}case 116:case 122:{Z=M;_=1;break}case 76:{Z=M;_=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{Z=W;_=0;break}case 106:{Z=M;_=3;break}default:{$=V;aa=q;ba=X;ca=Y;da=163;break a}}M=d[Z>>0]|0;I=(M&47|0)==3;N=I?M|32:M;M=I?1:_;if((N|0)==99){fa=f;ga=(T|0)<1?1:T}else if((N|0)==110){if(!J){ha=q;ia=Z;ja=f;ka=X;la=Y;break b}switch(M|0){case -2:{a[J>>0]=f;ha=q;ia=Z;ja=f;ka=X;la=Y;break b;break}case -1:{b[J>>1]=f;ha=q;ia=Z;ja=f;ka=X;la=Y;break b;break}case 0:{c[J>>2]=f;ha=q;ia=Z;ja=f;ka=X;la=Y;break b;break}case 1:{c[J>>2]=f;ha=q;ia=Z;ja=f;ka=X;la=Y;break b;break}case 3:{I=J;c[I>>2]=f;c[I+4>>2]=((f|0)<0)<<31>>31;ha=q;ia=Z;ja=f;ka=X;la=Y;break b;break}default:{ha=q;ia=Z;ja=f;ka=X;la=Y;break b}}}else if((N|0)==91){fa=f;ga=T}else{LDi(e,0);do{I=c[s>>2]|0;if(I>>>0<(c[t>>2]|0)>>>0){c[s>>2]=I+1;ma=d[I>>0]|0}else ma=MDi(e)|0}while((FDi(ma)|0)!=0);G=c[s>>2]|0;if(!(c[t>>2]|0))na=G;else{I=G+-1|0;c[s>>2]=I;na=I}fa=(c[u>>2]|0)+f+na-(c[v>>2]|0)|0;ga=T}LDi(e,ga);I=c[s>>2]|0;G=c[t>>2]|0;if(I>>>0<G>>>0){c[s>>2]=I+1;oa=G}else{if((MDi(e)|0)<0){$=V;aa=q;ba=X;ca=Y;da=163;break a}oa=c[t>>2]|0}if(oa)c[s>>2]=(c[s>>2]|0)+-1;d:do switch(N|0){case 120:case 88:case 112:{pa=16;da=145;break}case 91:case 99:case 115:{G=(N|0)==99;e:do if((N&239|0)==99){PEi(n|0,-1,257)|0;a[n>>0]=0;if((N|0)==115){a[x>>0]=0;a[w+0>>0]=0;a[w+1>>0]=0;a[w+2>>0]=0;a[w+3>>0]=0;a[w+4>>0]=0;qa=Z}else qa=Z}else{I=Z+1|0;L=(a[I>>0]|0)==94;P=L&1;Q=L?I:Z;ra=L?Z+2|0:I;PEi(n|0,L&1|0,257)|0;a[n>>0]=0;L=a[ra>>0]|0;if(L<<24>>24==93){I=(P^1)&255;a[A>>0]=I;sa=I;ta=Q+2|0}else if(L<<24>>24==45){L=(P^1)&255;a[z>>0]=L;sa=L;ta=Q+2|0}else{sa=(P^1)&255;ta=ra}ra=ta;while(1){P=a[ra>>0]|0;if(P<<24>>24==45){Q=ra+1|0;L=a[Q>>0]|0;if(!(L<<24>>24==93|L<<24>>24==0)){I=a[ra+-1>>0]|0;if((I&255)<(L&255)){ua=I&255;do{ua=ua+1|0;a[n+ua>>0]=sa;I=a[Q>>0]|0}while((ua|0)<(I&255|0));va=I;wa=Q}else{va=L;wa=Q}}else{va=45;wa=ra}}else if(!(P<<24>>24)){$=V;aa=q;ba=X;ca=Y;da=163;break a}else if(P<<24>>24==93){qa=ra;break e}else{va=P;wa=ra}a[n+((va&255)+1)>>0]=sa;ra=wa+1|0}}while(0);ra=G?ga+1|0:31;ua=(M|0)==1;I=(V|0)!=0;f:do if(ua){if(I){xa=ADi(ra<<2)|0;if(!xa){$=V;aa=q;ba=0;ca=xa;da=163;break a}else ya=xa}else ya=J;c[m>>2]=0;c[y>>2]=0;xa=0;za=ra;Aa=ya;g:while(1){if(!Aa)while(1){Ba=c[s>>2]|0;if(Ba>>>0<(c[t>>2]|0)>>>0){c[s>>2]=Ba+1;Ca=d[Ba>>0]|0}else Ca=MDi(e)|0;if(!(a[n+(Ca+1)>>0]|0)){Da=xa;Ea=0;break g}a[p>>0]=Ca;Ba=UBi(o,p,1,m)|0;if((Ba|0)==-1){$=V;aa=q;ba=0;ca=0;da=163;break a}else if((Ba|0)==-2)continue;if(I&(xa|0)==(za|0)){Fa=xa;break}}else{if(I)Ga=xa;else{Ha=xa;Ia=Aa;da=85;break}while(1){while(1){P=c[s>>2]|0;if(P>>>0<(c[t>>2]|0)>>>0){c[s>>2]=P+1;Ja=d[P>>0]|0}else Ja=MDi(e)|0;if(!(a[n+(Ja+1)>>0]|0)){Da=Ga;Ea=Aa;break g}a[p>>0]=Ja;P=UBi(o,p,1,m)|0;if((P|0)==-1){$=V;aa=q;ba=0;ca=Aa;da=163;break a}else if((P|0)!=-2)break}c[Aa+(Ga<<2)>>2]=c[o>>2];Ga=Ga+1|0;if((Ga|0)==(za|0)){Fa=za;break}}}P=za<<1|1;Q=DDi(Aa,P<<2)|0;if(!Q){$=V;aa=q;ba=0;ca=Aa;da=163;break a}xa=Fa;za=P;Aa=Q}h:do if((da|0)==85){da=0;Aa=Ha;while(1){while(1){za=c[s>>2]|0;if(za>>>0<(c[t>>2]|0)>>>0){c[s>>2]=za+1;Ka=d[za>>0]|0}else Ka=MDi(e)|0;if(!(a[n+(Ka+1)>>0]|0)){Da=Aa;Ea=Ia;break h}a[p>>0]=Ka;za=UBi(o,p,1,m)|0;if((za|0)==-1){$=0;aa=q;ba=0;ca=Ia;da=163;break a}else if((za|0)!=-2)break}c[Ia+(Aa<<2)>>2]=c[o>>2];Aa=Aa+1|0}}while(0);if(!(VBi(m)|0)){$=V;aa=q;ba=0;ca=Ea;da=163;break a}else{La=Da;Ma=0;Na=Ea}}else{if(I){Aa=ADi(ra)|0;if(!Aa){$=V;aa=q;ba=0;ca=0;da=163;break a}else{Oa=0;Pa=ra;Qa=Aa}while(1){Aa=Oa;do{za=c[s>>2]|0;if(za>>>0<(c[t>>2]|0)>>>0){c[s>>2]=za+1;Ra=d[za>>0]|0}else Ra=MDi(e)|0;if(!(a[n+(Ra+1)>>0]|0)){La=Aa;Ma=Qa;Na=0;break f}a[Qa+Aa>>0]=Ra;Aa=Aa+1|0}while((Aa|0)!=(Pa|0));Aa=Pa<<1|1;za=DDi(Qa,Aa)|0;if(!za){$=V;aa=q;ba=Qa;ca=0;da=163;break a}else{xa=Pa;Pa=Aa;Qa=za;Oa=xa}}}if(!J){xa=oa;while(1){za=c[s>>2]|0;if(za>>>0<xa>>>0){c[s>>2]=za+1;Sa=d[za>>0]|0}else Sa=MDi(e)|0;if(!(a[n+(Sa+1)>>0]|0)){La=0;Ma=0;Na=0;break f}xa=c[t>>2]|0}}else{xa=oa;za=0;while(1){Aa=c[s>>2]|0;if(Aa>>>0<xa>>>0){c[s>>2]=Aa+1;Ta=d[Aa>>0]|0}else Ta=MDi(e)|0;if(!(a[n+(Ta+1)>>0]|0)){La=za;Ma=J;Na=0;break f}a[J+za>>0]=Ta;xa=c[t>>2]|0;za=za+1|0}}}while(0);ra=c[s>>2]|0;if(!(c[t>>2]|0))Ua=ra;else{za=ra+-1|0;c[s>>2]=za;Ua=za}za=Ua-(c[v>>2]|0)+(c[u>>2]|0)|0;if(!za){Va=V;Wa=q;Xa=Ma;Ya=Na;break a}if(!((za|0)==(ga|0)|G^1)){Va=V;Wa=q;Xa=Ma;Ya=Na;break a}do if(I)if(ua){c[J>>2]=Na;break}else{c[J>>2]=Ma;break}while(0);if(!G){if(Na)c[Na+(La<<2)>>2]=0;if(!Ma){Za=qa;_a=0;$a=Na}else{a[Ma+La>>0]=0;Za=qa;_a=Ma;$a=Na}}else{Za=qa;_a=Ma;$a=Na}break}case 111:{pa=8;da=145;break}case 117:case 100:{pa=10;da=145;break}case 105:{pa=0;da=145;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{ab=+KDi(e,M,0);if((c[u>>2]|0)==((c[v>>2]|0)-(c[s>>2]|0)|0)){Va=V;Wa=q;Xa=X;Ya=Y;break a}if(J)if(!M){g[J>>2]=ea(ab);Za=Z;_a=X;$a=Y;break d}else if((M|0)==1){h[J>>3]=ab;Za=Z;_a=X;$a=Y;break d}else if((M|0)==2){h[J>>3]=ab;Za=Z;_a=X;$a=Y;break d}else{Za=Z;_a=X;$a=Y;break d}else{Za=Z;_a=X;$a=Y}break}default:{Za=Z;_a=X;$a=Y}}while(0);i:do if((da|0)==145){da=0;ua=JDi(e,pa,0,-1,-1)|0;if((c[u>>2]|0)==((c[v>>2]|0)-(c[s>>2]|0)|0)){Va=V;Wa=q;Xa=X;Ya=Y;break a}if((N|0)==112&(J|0)!=0){c[J>>2]=ua;Za=Z;_a=X;$a=Y;break}if(!J){Za=Z;_a=X;$a=Y}else switch(M|0){case -2:{a[J>>0]=ua;Za=Z;_a=X;$a=Y;break i;break}case -1:{b[J>>1]=ua;Za=Z;_a=X;$a=Y;break i;break}case 0:{c[J>>2]=ua;Za=Z;_a=X;$a=Y;break i;break}case 1:{c[J>>2]=ua;Za=Z;_a=X;$a=Y;break i;break}case 3:{I=J;c[I>>2]=ua;c[I+4>>2]=H;Za=Z;_a=X;$a=Y;break i;break}default:{Za=Z;_a=X;$a=Y;break i}}}while(0);ha=((J|0)!=0&1)+q|0;ia=Za;ja=(c[u>>2]|0)+fa+(c[s>>2]|0)-(c[v>>2]|0)|0;ka=_a;la=$a;break b}while(0);M=C+(F&1)|0;LDi(e,0);N=c[s>>2]|0;if(N>>>0<(c[t>>2]|0)>>>0){c[s>>2]=N+1;bb=d[N>>0]|0}else bb=MDi(e)|0;if((bb|0)!=(d[M>>0]|0)){cb=bb;db=q;eb=D;fb=E;da=19;break a}ha=q;ia=M;ja=f+1|0;ka=D;la=E}else{M=C;while(1){N=M+1|0;if(!(FDi(d[N>>0]|0)|0)){gb=M;break}else M=N}LDi(e,0);do{M=c[s>>2]|0;if(M>>>0<(c[t>>2]|0)>>>0){c[s>>2]=M+1;hb=d[M>>0]|0}else hb=MDi(e)|0}while((FDi(hb)|0)!=0);M=c[s>>2]|0;if(!(c[t>>2]|0))ib=M;else{F=M+-1|0;c[s>>2]=F;ib=F}ha=q;ia=gb;ja=(c[u>>2]|0)+f+ib-(c[v>>2]|0)|0;ka=D;la=E}while(0);C=ia+1|0;B=a[C>>0]|0;if(!(B<<24>>24)){r=ha;da=167;break}else{q=ha;f=ja;D=ka;E=la}}if((da|0)==19){if(c[t>>2]|0)c[s>>2]=(c[s>>2]|0)+-1;if((cb|0)>-1|(db|0)!=0){r=db;i=k;return r|0}else{jb=0;kb=eb;lb=fb;da=164}}else if((da|0)==163)if(!aa){jb=$;kb=ba;lb=ca;da=164}else{Va=$;Wa=aa;Xa=ba;Ya=ca}else if((da|0)==167){i=k;return r|0}if((da|0)==164){Va=jb;Wa=-1;Xa=kb;Ya=lb}if(!Va){r=Wa;i=k;return r|0}BDi(Xa);BDi(Ya);r=Wa;i=k;return r|0}function dCi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+112|0;f=e;g=f+0|0;h=g+112|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));c[f+32>>2]=1778;c[f+44>>2]=a;c[f+76>>2]=-1;c[f+84>>2]=a;a=cCi(f,b,d)|0;i=e;return a|0}function eCi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;a:do if(!c)g=0;else{h=b;j=c;while(1){k=j>>>1;l=h+(da(k,d)|0)|0;m=_n[e&4095](a,l)|0;if(!m){g=l;break a}if((j|0)==1){g=0;break a}n=(m|0)<0;j=n?k:j-k|0;if(!j){g=0;break}else h=n?h:l}}while(0);i=f;return g|0}function fCi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;f=i;i=i+944|0;g=f+680|0;h=f+424|0;j=f+192|0;k=f;l=da(d,b)|0;if(!l){i=f;return}b=l-d|0;c[k+4>>2]=d;c[k>>2]=d;m=d;n=d;o=2;while(1){p=m+d+n|0;c[k+(o<<2)>>2]=p;if(p>>>0<l>>>0){q=n;n=p;o=o+1|0;m=q}else break}m=0-d|0;o=a+b|0;if((b|0)>0){b=(d|0)==0;n=d>>>0>256?256:d;l=(n|0)==(d|0);q=o;p=1;r=0;s=a;t=1;while(1){do if((p&3|0)!=3){u=t+-1|0;a:do if((c[k+(u<<2)>>2]|0)>>>0<(q-s|0)>>>0){c[j>>2]=s;if((t|0)>1){v=t;w=s;x=s;y=1;while(1){z=w+m|0;A=v+-2|0;B=w+(0-((c[k+(A<<2)>>2]|0)+d))|0;if((_n[e&4095](x,B)|0)>-1?(_n[e&4095](x,z)|0)>-1:0){C=y;break}D=y+1|0;E=j+(y<<2)|0;if((_n[e&4095](B,z)|0)>-1){c[E>>2]=B;F=B;G=v+-1|0}else{c[E>>2]=z;F=z;G=A}if((G|0)<=1){C=D;break}v=G;w=F;x=c[j>>2]|0;y=D}if((C|0)>=2?(y=j+(C<<2)|0,c[y>>2]=g,!b):0){if((C|0)>0){H=d;I=g}else{x=c[j>>2]|0;YEi(g|0,x|0,n|0)|0;if(l)break;else{J=d;K=n}while(1){J=J-K|0;K=J>>>0>256?256:J;YEi(g|0,x|0,K|0)|0;if((J|0)==(K|0))break a}}while(1){x=H>>>0>256?256:H;w=c[j>>2]|0;YEi(I|0,w|0,x|0)|0;v=w;w=0;do{D=w;w=w+1|0;A=v;v=c[j+(w<<2)>>2]|0;YEi(A|0,v|0,x|0)|0;c[j+(D<<2)>>2]=A+x}while((w|0)!=(C|0));if((H|0)==(x|0))break a;H=H-x|0;I=c[y>>2]|0}}}}else uCi(s,d,e,p,r,t,0,k);while(0);if((t|0)==1){L=p<<1;M=p>>>31|r<<1;N=0;break}else{y=u>>>0>31;w=y?0:p;v=y?t+-33|0:u;L=w<<v;M=w>>>(32-v|0)|(y?p:r)<<v;N=1;break}}else{c[j>>2]=s;b:do if((t|0)>1){v=t;y=s;w=s;A=1;while(1){D=y+m|0;z=v+-2|0;E=y+(0-((c[k+(z<<2)>>2]|0)+d))|0;if((_n[e&4095](w,E)|0)>-1?(_n[e&4095](w,D)|0)>-1:0){O=A;break}B=A+1|0;P=j+(A<<2)|0;if((_n[e&4095](E,D)|0)>-1){c[P>>2]=E;Q=E;R=v+-1|0}else{c[P>>2]=D;Q=D;R=z}if((R|0)<=1){O=B;break}v=R;y=Q;w=c[j>>2]|0;A=B}if((O|0)>=2?(A=j+(O<<2)|0,c[A>>2]=h,!b):0){if((O|0)>0){S=d;T=h}else{w=c[j>>2]|0;YEi(h|0,w|0,n|0)|0;if(l)break;else{U=d;V=n}while(1){U=U-V|0;V=U>>>0>256?256:U;YEi(h|0,w|0,V|0)|0;if((U|0)==(V|0))break b}}while(1){w=S>>>0>256?256:S;y=c[j>>2]|0;YEi(T|0,y|0,w|0)|0;v=y;y=0;do{B=y;y=y+1|0;z=v;v=c[j+(y<<2)>>2]|0;YEi(z|0,v|0,w|0)|0;c[j+(B<<2)>>2]=z+w}while((y|0)!=(O|0));if((S|0)==(w|0))break b;S=S-w|0;T=c[A>>2]|0}}}while(0);L=p>>>2|r<<30;M=r>>>2;N=t+2|0}while(0);u=L|1;A=s+d|0;if(A>>>0<o>>>0){p=u;r=M;s=A;t=N}else{W=M;X=u;Y=A;Z=N;break}}}else{W=0;X=1;Y=a;Z=1}uCi(Y,d,e,X,W,Z,0,k);if((Z|0)==1&(X|0)==1&(W|0)==0){i=f;return}else{_=X;$=W;aa=Y;ba=Z}while(1){if((ba|0)>=2){Z=_>>>30;Y=ba+-2|0;W=(_<<1&2147483646|Z<<31)^3;X=(Z|$<<2)>>>1;uCi(aa+(0-((c[k+(Y<<2)>>2]|0)+d))|0,d,e,W,X,ba+-1|0,1,k);a=X<<1|Z&1;Z=W<<1|1;W=aa+m|0;uCi(W,d,e,Z,a,Y,1,k);_=Z;$=a;aa=W;ba=Y;continue}Y=_+-1|0;do if(Y){if(!(Y&1)){W=Y;a=0;while(1){Z=a+1|0;W=W>>>1;if(W&1){ca=Z;break}else a=Z}if(ca)ea=ca;else fa=54}else fa=54;if((fa|0)==54){fa=0;if(!$){ga=64;fa=59;break}if(!($&1)){ha=$;ia=0}else{ja=0;ka=_;la=$;ma=0;break}while(1){a=ia+1|0;ha=ha>>>1;if(ha&1){na=a;oa=ia;break}else ia=a}if(!na){ja=0;ka=_;la=$;ma=0;break}else ea=oa+33|0}if(ea>>>0>31){ga=ea;fa=59}else{ja=ea;ka=_;la=$;ma=ea}}else{ga=32;fa=59}while(0);if((fa|0)==59){fa=0;ja=ga+-32|0;ka=$;la=0;ma=ga}_=la<<32-ja|ka>>>ja;$=la>>>ja;ba=ma+ba|0;if((ba|0)==1&(_|0)==1&($|0)==0)break;else aa=aa+m|0}i=f;return}function gCi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=c&255;c=d;while(1){if(!c){g=0;h=4;break}c=c+-1|0;d=b+c|0;if((a[d>>0]|0)==f<<24>>24){g=d;h=4;break}}if((h|0)==4){i=e;return g|0}return 0}function hCi(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=iCi(b,c)|0;i=d;return ((a[e>>0]|0)==(c&255)<<24>>24?e:0)|0}function iCi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d&255;if(!f){g=b+(SEi(b|0)|0)|0;i=e;return g|0}a:do if(!(b&3))h=b;else{j=d&255;k=b;while(1){l=a[k>>0]|0;m=k+1|0;if(l<<24>>24==0?1:l<<24>>24==j<<24>>24){g=k;break}if(!(m&3)){h=m;break a}else k=m}i=e;return g|0}while(0);b=da(f,16843009)|0;f=c[h>>2]|0;b:do if(!((f&-2139062144^-2139062144)&f+-16843009)){k=f;j=h;while(1){m=k^b;l=j+4|0;if((m&-2139062144^-2139062144)&m+-16843009){n=j;break b}k=c[l>>2]|0;if((k&-2139062144^-2139062144)&k+-16843009){n=l;break}else j=l}}else n=h;while(0);h=d&255;d=n;while(1){n=a[d>>0]|0;if(n<<24>>24==0?1:n<<24>>24==h<<24>>24){g=d;break}else d=d+1|0}i=e;return g|0}function jCi(a){a=a|0;var b=0,c=0,d=0,e=0;b=i;c=(SEi(a|0)|0)+1|0;d=ADi(c)|0;if(!d){e=0;i=b;return e|0}YEi(d|0,a|0,c|0)|0;e=d;i=b;return e|0}function kCi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=b+(SEi(b|0)|0)|0;a:do if(!d)g=f;else{h=d;j=c;k=f;while(1){l=a[j>>0]|0;if(!(l<<24>>24)){g=k;break a}h=h+-1|0;m=k+1|0;a[k>>0]=l;if(!h){g=m;break}else{j=j+1|0;k=m}}}while(0);a[g>>0]=0;i=e;return b|0}function lCi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=gCi(a,b,(SEi(a|0)|0)+1|0)|0;i=c;return d|0}function mCi(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;f=i;i=i+1056|0;g=f+1024|0;h=f;j=a[e>>0]|0;if(!(j<<24>>24)){k=b;i=f;return k|0}l=hCi(b,j<<24>>24)|0;if(!l){k=0;i=f;return k|0}b=a[e+1>>0]|0;if(!(b<<24>>24)){k=l;i=f;return k|0}m=l+1|0;n=a[m>>0]|0;if(!(n<<24>>24)){k=0;i=f;return k|0}o=a[e+2>>0]|0;if(!(o<<24>>24)){p=b&255|(j&255)<<8;q=m;m=l;r=n;s=d[l>>0]<<8|n&255;while(1){t=s&65535;if((t|0)==(p|0)){u=m;v=r;break}w=m+2|0;x=a[w>>0]|0;if(!(x<<24>>24)){u=q;v=0;break}else{y=q;q=w;r=x;s=x&255|t<<8;m=y}}k=v<<24>>24==0?0:u;i=f;return k|0}u=l+2|0;v=a[u>>0]|0;if(!(v<<24>>24)){k=0;i=f;return k|0}m=a[e+3>>0]|0;if(!(m<<24>>24)){s=(b&255)<<16|(j&255)<<24|(o&255)<<8;r=(v&255)<<8|(n&255)<<16|d[l>>0]<<24;if((r|0)==(s|0)){z=u;A=0}else{q=u;u=r;while(1){r=q+1|0;p=a[r>>0]|0;u=(p&255|u)<<8;y=p<<24>>24==0;if(y|(u|0)==(s|0)){z=r;A=y;break}else q=r}}k=A?0:z+-2|0;i=f;return k|0}z=l+3|0;A=a[z>>0]|0;if(!(A<<24>>24)){k=0;i=f;return k|0}if(!(a[e+4>>0]|0)){q=(b&255)<<16|(j&255)<<24|(o&255)<<8|m&255;m=(v&255)<<8|(n&255)<<16|A&255|d[l>>0]<<24;if((m|0)==(q|0)){B=z;C=0}else{A=z;z=m;while(1){m=A+1|0;n=a[m>>0]|0;z=n&255|z<<8;v=n<<24>>24==0;if(v|(z|0)==(q|0)){B=m;C=v;break}else A=m}}k=C?0:B+-3|0;i=f;return k|0};c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;c[g+28>>2]=0;B=j;j=0;while(1){if(!(a[l+j>>0]|0)){k=0;D=79;break}C=g+(((B&255)>>>5&255)<<2)|0;c[C>>2]=c[C>>2]|1<<(B&31);C=j+1|0;c[h+((B&255)<<2)>>2]=C;B=a[e+C>>0]|0;if(!(B<<24>>24)){E=C;F=j;break}else j=C}if((D|0)==79){i=f;return k|0}a:do if(E>>>0>1){j=1;B=-1;C=0;b:while(1){A=j;q=C;z=1;while(1){m=A;v=q;c:while(1){n=m;o=1;while(1){b=a[e+(o+B)>>0]|0;s=a[e+n>>0]|0;if(b<<24>>24!=s<<24>>24){G=n;H=b;I=s;J=v;break c}if((o|0)==(z|0))break;o=o+1|0;n=o+v|0;if(n>>>0>=E>>>0){K=B;L=z;break b}}v=v+z|0;m=v+1|0;if(m>>>0>=E>>>0){K=B;L=z;break b}}m=G-B|0;if((H&255)<=(I&255)){M=J;break}v=G+1|0;if(v>>>0<E>>>0){A=v;q=G;z=m}else{K=B;L=m;break b}}j=M+2|0;if(j>>>0>=E>>>0){K=M;L=1;break}else{B=M;C=M+1|0}}C=1;B=-1;j=0;while(1){z=C;q=j;A=1;while(1){m=z;v=q;d:while(1){n=m;o=1;while(1){s=a[e+(o+B)>>0]|0;b=a[e+n>>0]|0;if(s<<24>>24!=b<<24>>24){N=n;O=s;P=b;Q=v;break d}if((o|0)==(A|0))break;o=o+1|0;n=o+v|0;if(n>>>0>=E>>>0){R=K;S=B;T=L;U=A;break a}}v=v+A|0;m=v+1|0;if(m>>>0>=E>>>0){R=K;S=B;T=L;U=A;break a}}m=N-B|0;if((O&255)>=(P&255)){V=Q;break}v=N+1|0;if(v>>>0<E>>>0){z=v;q=N;A=m}else{R=K;S=B;T=L;U=m;break a}}C=V+2|0;if(C>>>0>=E>>>0){R=K;S=V;T=L;U=1;break}else{B=V;j=V+1|0}}}else{R=-1;S=-1;T=1;U=1}while(0);V=(S+1|0)>>>0>(R+1|0)>>>0;L=V?U:T;T=V?S:R;R=T+1|0;if(!(FEi(e,e+L|0,R)|0)){S=E-L|0;V=E|63;if((E|0)!=(L|0)){U=l;K=0;N=l;e:while(1){Q=U;do if((N-Q|0)>>>0<E>>>0){P=EEi(N,0,V)|0;if(P)if((P-Q|0)>>>0<E>>>0){k=0;D=79;break e}else{W=P;break}else{W=N+V|0;break}}else W=N;while(0);Q=a[U+F>>0]|0;if(!(1<<(Q&31)&c[g+(((Q&255)>>>5&255)<<2)>>2])){U=U+E|0;K=0;N=W;continue}P=c[h+((Q&255)<<2)>>2]|0;Q=E-P|0;if((E|0)!=(P|0)){U=U+((K|0)!=0&Q>>>0<L>>>0?S:Q)|0;K=0;N=W;continue}Q=R>>>0>K>>>0?R:K;P=a[e+Q>>0]|0;f:do if(!(P<<24>>24))X=R;else{O=P;M=Q;while(1){if(O<<24>>24!=(a[U+M>>0]|0)){Y=M;break}M=M+1|0;O=a[e+M>>0]|0;if(!(O<<24>>24)){X=R;break f}}U=U+(Y-T)|0;K=0;N=W;continue e}while(0);do{if(X>>>0<=K>>>0){k=U;D=79;break e}X=X+-1|0}while((a[e+X>>0]|0)==(a[U+X>>0]|0));U=U+L|0;K=S;N=W}if((D|0)==79){i=f;return k|0}}else{Z=V;_=E}}else{V=E-T+-1|0;Z=E|63;_=(T>>>0>V>>>0?T:V)+1|0}V=e+R|0;W=l;N=l;g:while(1){l=W;do if((N-l|0)>>>0<E>>>0){S=EEi(N,0,Z)|0;if(S)if((S-l|0)>>>0<E>>>0){k=0;D=79;break g}else{$=S;break}else{$=N+Z|0;break}}else $=N;while(0);l=a[W+F>>0]|0;if(!(1<<(l&31)&c[g+(((l&255)>>>5&255)<<2)>>2])){W=W+E|0;N=$;continue}S=c[h+((l&255)<<2)>>2]|0;if((E|0)!=(S|0)){W=W+(E-S)|0;N=$;continue}S=a[V>>0]|0;h:do if(!(S<<24>>24))aa=R;else{l=S;K=R;while(1){if(l<<24>>24!=(a[W+K>>0]|0)){ba=K;break}K=K+1|0;l=a[e+K>>0]|0;if(!(l<<24>>24)){aa=R;break h}}W=W+(ba-T)|0;N=$;continue g}while(0);do{if(!aa){k=W;D=79;break g}aa=aa+-1|0}while((a[e+aa>>0]|0)==(a[W+aa>>0]|0));W=W+_|0;N=$}if((D|0)==79){i=f;return k|0}return 0}function nCi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;f=b;while(1){b=c[f>>2]|0;c[e>>2]=b;if(!b)break;else{e=e+4|0;f=f+4|0}}i=d;return a|0}function oCi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a;while(1)if(!(c[d>>2]|0)){e=d;break}else d=d+4|0;i=b;return e-a>>2|0}function pCi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if(!d){i=e;return a|0}else{f=d;g=b;h=a}while(1){f=f+-1|0;c[h>>2]=c[g>>2];if(!f)break;else{g=g+4|0;h=h+4|0}}i=e;return a|0}function qCi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(!f){g=d;do{g=g+-1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2]}while((g|0)!=0)}}else if(!f){f=b;b=a;g=d;while(1){g=g+-1|0;c[b>>2]=c[f>>2];if(!g)break;else{f=f+4|0;b=b+4|0}}}i=e;return a|0}function rCi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if(d){f=d;d=a;while(1){f=f+-1|0;c[d>>2]=b;if(!f)break;else d=d+4|0}}i=e;return a|0}function sCi(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;h=(f<<1)+-1|0;j=f+-1|0;if((PBi(c)|0)==0|(c+-1536|0)>>>0<2560|(c+-11776|0)>>>0<30784|(c+-43008|0)>>>0<22272){k=c;i=g;return k|0}l=(f|0)!=0;if(l&(c+-4256|0)>>>0<46){if((c|0)>4293?!((c|0)==4295|(c|0)==4301):0){k=c;i=g;return k|0}k=c+7264|0;i=g;return k|0}if((c+-11520|0)>>>0<38&(l^1)){if((c|0)>11557?!((c|0)==11559|(c|0)==11565):0){k=c;i=g;return k|0}k=c+-7264|0;i=g;return k|0}else m=0;do{l=a[3665434+(m<<2)>>0]|0;n=l<<24>>24;o=c-(e[3665432+(m<<2)>>1]|0)|0;if((o-(n&j)|0)>>>0<(d[3665435+(m<<2)>>0]|0)>>>0){p=l;q=n;r=o;s=13;break}m=m+1|0}while((m|0)!=61);if((s|0)==13)if(p<<24>>24==1){k=f+c-(r&1)|0;i=g;return k|0}else{k=(da(q,h)|0)+c|0;i=g;return k|0}h=1-f|0;q=b[3665680+(h<<1)>>1]|0;a:do if(q<<16>>16){r=q;p=0;while(1){if((r&65535|0)==(c|0)){t=p;break}p=p+1|0;r=b[3665680+(p<<2)+(h<<1)>>1]|0;if(!(r<<16>>16))break a}k=e[3665680+(t<<2)+(f<<1)>>1]|0;i=g;return k|0}while(0);if((c+-66600+(f*40|0)|0)>>>0>=40){k=c;i=g;return k|0}k=c+-40+(f*80|0)|0;i=g;return k|0}function tCi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=$Bi(a,b,c)|0;i=d;return e|0}function uCi(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;k=i;i=i+720|0;l=k+456|0;m=k+228|0;n=k;c[n>>2]=a;o=0-b|0;p=(f|0)==0;a:do if((e|0)==1&p){q=a;r=g;s=h;t=1;u=18}else{v=a;w=g;x=h;y=p;z=f;A=a;B=1;C=e;while(1){D=v+(0-(c[j+(w<<2)>>2]|0))|0;if((_n[d&4095](D,A)|0)<1){q=v;r=w;s=x;t=B;u=18;break a}if((x|0)==0&(w|0)>1){E=c[j+(w+-2<<2)>>2]|0;if((_n[d&4095](v+o|0,D)|0)>-1){F=v;G=w;H=B;break a}if((_n[d&4095](v+(0-(E+b))|0,D)|0)>-1){F=v;G=w;H=B;break a}}E=B+1|0;c[n+(B<<2)>>2]=D;I=C+-1|0;do if(I){if(!(I&1)){J=I;K=0;while(1){L=K+1|0;J=J>>>1;if(J&1){M=L;break}else K=L}if(M)N=M;else u=10}else u=10;if((u|0)==10){u=0;if(y){O=64;u=15;break}if(!(z&1)){P=z;Q=0}else{R=0;S=C;T=z;U=0;break}while(1){K=Q+1|0;P=P>>>1;if(P&1){V=K;W=Q;break}else Q=K}if(!V){R=0;S=C;T=z;U=0;break}else N=W+33|0}if(N>>>0>31){O=N;u=15}else{R=N;S=C;T=z;U=N}}else{O=32;u=15}while(0);if((u|0)==15){u=0;R=O+-32|0;S=z;T=0;U=O}I=T<<32-R|S>>>R;K=T>>>R;J=U+w|0;L=(K|0)==0;if((I|0)==1&L){F=D;G=J;H=E;break a}v=D;w=J;x=0;y=L;z=K;A=c[n>>2]|0;B=E;C=I}}while(0);if((u|0)==18)if(!s){F=q;G=r;H=t}else{i=k;return}b:do if((H|0)>=2?(t=n+(H<<2)|0,c[t>>2]=l,(b|0)!=0):0){if((H|0)>0){X=b;Y=l}else{r=b>>>0>256?256:b;q=c[n>>2]|0;YEi(l|0,q|0,r|0)|0;if((r|0)==(b|0))break;else{Z=b;_=r}while(1){Z=Z-_|0;_=Z>>>0>256?256:Z;YEi(l|0,q|0,_|0)|0;if((Z|0)==(_|0))break b}}while(1){q=X>>>0>256?256:X;r=c[n>>2]|0;YEi(Y|0,r|0,q|0)|0;s=r;r=0;do{u=r;r=r+1|0;U=s;s=c[n+(r<<2)>>2]|0;YEi(U|0,s|0,q|0)|0;c[n+(u<<2)>>2]=U+q}while((r|0)!=(H|0));if((X|0)==(q|0))break b;X=X-q|0;Y=c[t>>2]|0}}while(0);c[m>>2]=F;c:do if((G|0)>1){Y=G;X=F;H=F;n=1;while(1){_=X+o|0;Z=Y+-2|0;t=X+(0-((c[j+(Z<<2)>>2]|0)+b))|0;if((_n[d&4095](H,t)|0)>-1?(_n[d&4095](H,_)|0)>-1:0){$=n;break}r=n+1|0;s=m+(n<<2)|0;if((_n[d&4095](t,_)|0)>-1){c[s>>2]=t;aa=t;ba=Y+-1|0}else{c[s>>2]=_;aa=_;ba=Z}if((ba|0)<=1){$=r;break}Y=ba;X=aa;H=c[m>>2]|0;n=r}if(($|0)>=2?(n=m+($<<2)|0,c[n>>2]=l,(b|0)!=0):0){if(($|0)>0){ca=b;da=l}else{H=b>>>0>256?256:b;X=c[m>>2]|0;YEi(l|0,X|0,H|0)|0;if((H|0)==(b|0)){ea=l;break}else{fa=b;ga=H}while(1){fa=fa-ga|0;ga=fa>>>0>256?256:fa;YEi(l|0,X|0,ga|0)|0;if((fa|0)==(ga|0)){ea=l;break c}}}while(1){X=ca>>>0>256?256:ca;H=c[m>>2]|0;YEi(da|0,H|0,X|0)|0;Y=H;H=0;do{r=H;H=H+1|0;Z=Y;Y=c[m+(H<<2)>>2]|0;YEi(Z|0,Y|0,X|0)|0;c[m+(r<<2)>>2]=Z+X}while((H|0)!=($|0));if((ca|0)==(X|0)){ea=l;break c}ca=ca-X|0;da=c[n>>2]|0}}else ea=l}else ea=l;while(0);i=k;return}function vCi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=c[p>>2]|0;lg(b|0,a|0,e|0)|0;qh(10,b|0)|0;Vl()}function wCi(){var a=0,b=0;a=i;i=i+16|0;if(!(dd(3666584,254)|0)){b=Fd(c[916644]|0)|0;i=a;return b|0}else vCi(3666592,a);return 0}function xCi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;a=ADi(d)|0;if(a){e=a;i=b;return e|0}while(1){a=ICi()|0;if(!a){f=4;break}eo[a&511]();a=ADi(d)|0;if(a){e=a;f=5;break}}if((f|0)==4){d=al(4)|0;c[d>>2]=3666768;we(d|0,3666816,3425)}else if((f|0)==5){i=b;return e|0}return 0}function yCi(a,b){a=a|0;b=b|0;var c=0;b=i;c=xCi(a)|0;i=b;return c|0}function zCi(a){a=a|0;var b=0,c=0;b=i;c=xCi(a)|0;i=b;return c|0}function ACi(a){a=a|0;var b=0;b=i;BDi(a);i=b;return}function BCi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function CCi(a){a=a|0;c[a>>2]=3666768;return}function DCi(a){a=a|0;return}function ECi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function FCi(a){a=a|0;return 3666784}function GCi(a){a=a|0;var b=0;b=i;i=i+16|0;eo[a&511]();vCi(3666832,b)}function HCi(){var a=0,b=0;a=wCi()|0;if(((a|0)!=0?(b=c[a>>2]|0,(b|0)!=0):0)?(a=b+48|0,(c[a>>2]&-256|0)==1126902528?(c[a+4>>2]|0)==1129074247:0):0)GCi(c[b+12>>2]|0);b=c[916600]|0;c[916600]=b+0;GCi(b)}function ICi(){var a=0;a=c[916718]|0;c[916718]=a+0;return a|0}function JCi(a){a=a|0;return}function KCi(a){a=a|0;var b=0;b=i;c[a>>2]=3666912;xDi(a+4|0);i=b;return}function LCi(a){a=a|0;var b=0;b=i;KCi(a);ACi(a);i=b;return}function MCi(a){a=a|0;return c[a+4>>2]|0}function NCi(a){a=a|0;var b=0;b=i;c[a>>2]=3666936;xDi(a+4|0);i=b;return}function OCi(a){a=a|0;var b=0;b=i;NCi(a);ACi(a);i=b;return}function PCi(a){a=a|0;return c[a+4>>2]|0}function QCi(a){a=a|0;var b=0;b=i;KCi(a);ACi(a);i=b;return}function RCi(a){a=a|0;var b=0;b=i;KCi(a);ACi(a);i=b;return}function SCi(a){a=a|0;var b=0;b=i;NCi(a);ACi(a);i=b;return}function TCi(a){a=a|0;return}function UCi(a){a=a|0;c[a>>2]=3667224;return}function VCi(a){a=a|0;return}function WCi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function XCi(a){a=a|0;return 3667240}function YCi(a){a=a|0;return}function ZCi(a){a=a|0;return}function _Ci(a){a=a|0;return}function $Ci(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function aDi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function bDi(a){a=a|0;var b=0;b=i;ACi(a);i=b;return}function cDi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+64|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if(!b){g=0;i=e;return g|0}h=iDi(b,3667352,3667408,0)|0;if(!h){g=0;i=e;return g|0}b=f+0|0;j=b+56|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(j|0));c[f>>2]=h;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Dn[c[(c[h>>2]|0)+28>>2]&511](h,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function dDi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=i;g=d+16|0;h=c[g>>2]|0;if(!h){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=b;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54>>0]=1;i=b;return}e=d+24|0;if((c[e>>2]|0)!=2){i=b;return}c[e>>2]=f;i=b;return}function eDi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;if((c[b+8>>2]|0)!=(a|0)){i=f;return}dDi(0,b,d,e);i=f;return}function fDi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;if((a|0)==(c[b+8>>2]|0)){dDi(0,b,d,e);i=f;return}else{g=c[a+8>>2]|0;Dn[c[(c[g>>2]|0)+28>>2]&511](g,b,d,e);i=f;return}}function gDi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=c[a+4>>2]|0;h=g>>8;if(!(g&1))j=h;else j=c[(c[d>>2]|0)+h>>2]|0;h=c[a>>2]|0;Dn[c[(c[h>>2]|0)+28>>2]&511](h,b,d+j|0,(g&2|0)!=0?e:2);i=f;return}function hDi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((b|0)==(c[d+8>>2]|0)){dDi(0,d,e,f);i=g;return}h=c[b+12>>2]|0;j=b+(h<<3)+16|0;gDi(b+16|0,d,e,f);if((h|0)<=1){i=g;return}h=d+54|0;k=b+24|0;while(1){gDi(k,d,e,f);if(a[h>>0]|0){l=7;break}k=k+8|0;if(k>>>0>=j>>>0){l=7;break}}if((l|0)==7){i=g;return}}function iDi(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+64|0;j=h;k=c[d>>2]|0;l=d+(c[k+-8>>2]|0)|0;m=c[k+-4>>2]|0;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;k=j+28|0;n=j+32|0;o=j+40|0;p=(m|0)==(f|0);f=g+0|0;q=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(q|0));b[g+36>>1]=0;a[g+38>>0]=0;if(p){c[j+48>>2]=1;rn[c[(c[m>>2]|0)+20>>2]&127](m,j,l,l,1,0);r=(c[d>>2]|0)==1?l:0;i=h;return r|0}En[c[(c[m>>2]|0)+24>>2]&127](m,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){if((c[d>>2]|0)!=1?!((c[o>>2]|0)==0&(c[k>>2]|0)==1&(c[n>>2]|0)==1):0){r=0;i=h;return r|0}r=c[g>>2]|0;i=h;return r|0}else if(!l){r=(c[o>>2]|0)==1&(c[k>>2]|0)==1&(c[n>>2]|0)==1?c[e>>2]|0:0;i=h;return r|0}else{r=0;i=h;return r|0}return 0}function jDi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;a[d+53>>0]=1;if((c[d+4>>2]|0)!=(f|0)){i=b;return}a[d+52>>0]=1;f=d+16|0;h=c[f>>2]|0;if(!h){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((g|0)==1?(c[d+48>>2]|0)==1:0)){i=b;return}a[d+54>>0]=1;i=b;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54>>0]=1;i=b;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;j=g}else j=h;if(!((j|0)==1?(c[d+48>>2]|0)==1:0)){i=b;return}a[d+54>>0]=1;i=b;return}function kDi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}j=d+28|0;if((c[j>>2]|0)==1){i=h;return}c[j>>2]=f;i=h;return}if((b|0)!=(c[d>>2]|0)){j=c[b+12>>2]|0;k=b+(j<<3)+16|0;mDi(b+16|0,d,e,f,g);l=b+24|0;if((j|0)<=1){i=h;return}j=c[b+8>>2]|0;if((j&2|0)==0?(m=d+36|0,(c[m>>2]|0)!=1):0){if(!(j&1)){j=d+54|0;n=l;while(1){if(a[j>>0]|0){o=43;break}if((c[m>>2]|0)==1){o=43;break}mDi(n,d,e,f,g);n=n+8|0;if(n>>>0>=k>>>0){o=43;break}}if((o|0)==43){i=h;return}}n=d+24|0;j=d+54|0;p=l;while(1){if(a[j>>0]|0){o=43;break}if((c[m>>2]|0)==1?(c[n>>2]|0)==1:0){o=43;break}mDi(p,d,e,f,g);p=p+8|0;if(p>>>0>=k>>>0){o=43;break}}if((o|0)==43){i=h;return}}p=d+54|0;n=l;while(1){if(a[p>>0]|0){o=43;break}mDi(n,d,e,f,g);n=n+8|0;if(n>>>0>=k>>>0){o=43;break}}if((o|0)==43){i=h;return}}if((c[d+16>>2]|0)!=(e|0)?(k=d+20|0,(c[k>>2]|0)!=(e|0)):0){c[d+32>>2]=f;n=d+44|0;if((c[n>>2]|0)==4){i=h;return}p=c[b+12>>2]|0;l=b+(p<<3)+16|0;a:do if((p|0)>0){m=d+52|0;j=d+53|0;q=d+54|0;r=b+8|0;s=d+24|0;t=0;u=0;v=b+16|0;b:while(1){a[m>>0]=0;a[j>>0]=0;lDi(v,d,e,e,1,g);if(a[q>>0]|0){w=t;x=u;break}do if(a[j>>0]|0){if(!(a[m>>0]|0))if(!(c[r>>2]&1)){w=t;x=1;break b}else{y=t;z=1;break}if((c[s>>2]|0)==1){o=25;break a}if(!(c[r>>2]&2)){o=25;break a}else{y=1;z=1}}else{y=t;z=u}while(0);v=v+8|0;if(v>>>0>=l>>>0){w=y;x=z;break}else{t=y;u=z}}if(w){A=x;o=24}else{B=x;o=21}}else{B=0;o=21}while(0);if((o|0)==21){c[k>>2]=e;e=d+40|0;c[e>>2]=(c[e>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(B)o=25;else o=26}else{A=B;o=24}}if((o|0)==24)if(A)o=25;else o=26;if((o|0)==25){c[n>>2]=3;i=h;return}else if((o|0)==26){c[n>>2]=4;i=h;return}}if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function lDi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;j=c[a+4>>2]|0;k=j>>8;if(!(j&1))l=k;else l=c[(c[e>>2]|0)+k>>2]|0;k=c[a>>2]|0;rn[c[(c[k>>2]|0)+20>>2]&127](k,b,d,e+l|0,(j&2|0)!=0?f:2,g);i=h;return}function mDi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=c[a+4>>2]|0;j=h>>8;if(!(h&1))k=j;else k=c[(c[d>>2]|0)+j>>2]|0;j=c[a>>2]|0;En[c[(c[j>>2]|0)+24>>2]&127](j,b,d+k|0,(h&2|0)!=0?e:2,f);i=g;return}function nDi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}j=d+28|0;if((c[j>>2]|0)==1){i=h;return}c[j>>2]=f;i=h;return}if((b|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;En[c[(c[j>>2]|0)+24>>2]&127](j,d,e,f,g);i=h;return}if((c[d+16>>2]|0)!=(e|0)?(j=d+20|0,(c[j>>2]|0)!=(e|0)):0){c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l>>0]=0;m=d+53|0;a[m>>0]=0;n=c[b+8>>2]|0;rn[c[(c[n>>2]|0)+20>>2]&127](n,d,e,e,1,g);if(a[m>>0]|0){if(!(a[l>>0]|0)){o=1;p=13}}else{o=0;p=13}do if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(o)break}else p=16;if((p|0)==16?o:0)break;c[k>>2]=4;i=h;return}while(0);c[k>>2]=3;i=h;return}if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function oDi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}if((c[d+16>>2]|0)!=(e|0)?(b=d+20|0,(c[b>>2]|0)!=(e|0)):0){c[d+32>>2]=f;c[b>>2]=e;e=d+40|0;c[e>>2]=(c[e>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1;c[d+44>>2]=4;i=g;return}if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function pDi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;if((b|0)==(c[d+8>>2]|0)){jDi(0,d,e,f,g);i=j;return}k=d+52|0;l=a[k>>0]|0;m=d+53|0;n=a[m>>0]|0;o=c[b+12>>2]|0;p=b+(o<<3)+16|0;a[k>>0]=0;a[m>>0]=0;lDi(b+16|0,d,e,f,g,h);a:do if((o|0)>1){q=d+24|0;r=b+8|0;s=d+54|0;t=b+24|0;do{if(a[s>>0]|0)break a;if(!(a[k>>0]|0)){if((a[m>>0]|0)!=0?(c[r>>2]&1|0)==0:0)break a}else{if((c[q>>2]|0)==1)break a;if(!(c[r>>2]&2))break a}a[k>>0]=0;a[m>>0]=0;lDi(t,d,e,f,g,h);t=t+8|0}while(t>>>0<p>>>0)}while(0);a[k>>0]=l;a[m>>0]=n;i=j;return}function qDi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;if((a|0)==(c[b+8>>2]|0)){jDi(0,b,d,e,f);i=h;return}else{j=c[a+8>>2]|0;rn[c[(c[j>>2]|0)+20>>2]&127](j,b,d,e,f,g);i=h;return}}function rDi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=i;if((c[b+8>>2]|0)!=(a|0)){i=g;return}jDi(0,b,d,e,f);i=g;return}function sDi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[f>>2]=c[d>>2];g=xo[c[(c[a>>2]|0)+16>>2]&2047](a,b,f)|0;b=g&1;if(!g){i=e;return b|0}c[d>>2]=c[f>>2];i=e;return b|0}function tDi(a){a=a|0;var b=0,c=0;b=i;if(!a)c=0;else c=(iDi(a,3667352,3667520,0)|0)!=0;i=b;return c&1|0}function uDi(){var a=0;a=al(4)|0;CCi(a);we(a|0,3666816,3425)}function vDi(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;b=a;d=a+12|0;a=wCi()|0;if(!a)vCi(3666560,b);e=c[a>>2]|0;if(!e)vCi(3666560,b);a=e+48|0;f=c[a>>2]|0;g=c[a+4>>2]|0;if(!((f&-256|0)==1126902528&(g|0)==1129074247)){c[b>>2]=3666408;vCi(3666520,b)}if((f|0)==1126902529&(g|0)==1129074247)h=c[e+44>>2]|0;else h=e+80|0;c[d>>2]=h;h=c[e>>2]|0;e=c[h+4>>2]|0;if(xo[c[(c[3666896>>2]|0)+16>>2]&2047](3666896,h,d)|0){h=c[d>>2]|0;d=mo[c[(c[h>>2]|0)+8>>2]&4095](h)|0;c[b>>2]=3666408;c[b+4>>2]=e;c[b+8>>2]=d;vCi(3666424,b)}else{c[b>>2]=3666408;c[b+4>>2]=e;vCi(3666472,b)}}function wDi(){var a=0;a=i;i=i+16|0;if(!(Cg(3666576,3599)|0)){i=a;return}else vCi(3666648,a)}function xDi(a){a=a|0;var b=0,d=0,e=0;b=i;d=(c[a>>2]|0)+-4|0;e=c[d>>2]|0;c[d>>2]=e+-1;if((e+-1|0)>=0){i=b;return}ACi((c[a>>2]|0)+-12|0);i=b;return}function yDi(a){a=a|0;var b=0;b=i;i=i+16|0;BDi(a);if(!(Tj(c[916644]|0,0)|0)){i=b;return}else vCi(3666704,b)}function zDi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;c[g>>2]=b;c[h>>2]=ADi((SEi(c[g>>2]|0)|0)+1|0)|0;bFi(c[h>>2]|0,c[g>>2]|0)|0;c[j>>2]=mCi(c[h>>2]|0,3667776)|0;if(c[j>>2]|0)a[c[j>>2]>>0]=0;c[j>>2]=mCi(c[h>>2]|0,3667784)|0;if(c[j>>2]|0)a[c[j>>2]>>0]=0;c[j>>2]=mCi(c[h>>2]|0,3667792)|0;if(c[j>>2]|0)a[c[j>>2]>>0]=0;do if(HEi(c[h>>2]|0,3667800)|0){if(!(HEi(c[h>>2]|0,3667840)|0)){c[h>>2]=3667864;break}if(!(HEi(c[h>>2]|0,3667880)|0)){c[h>>2]=3667904;break}if(!(HEi(c[h>>2]|0,3667920)|0)){c[h>>2]=3667936;break}if(!(HEi(c[h>>2]|0,3667952)|0))c[h>>2]=3667968}else c[h>>2]=3667824;while(0);do if(HEi(c[h>>2]|0,3667984)|0){if(!(HEi(c[h>>2]|0,3668e3)|0)){c[f>>2]=3644;break}if(!(HEi(c[h>>2]|0,3668016)|0)){c[f>>2]=3087;break}if(!(HEi(c[h>>2]|0,3668032)|0)){c[f>>2]=3088;break}if(!(HEi(c[h>>2]|0,3668048)|0)){c[f>>2]=3089;break}if(!(HEi(c[h>>2]|0,3668064)|0)){c[f>>2]=3090;break}if(!(HEi(c[h>>2]|0,3668080)|0)){c[f>>2]=3091;break}if(!(HEi(c[h>>2]|0,3668104)|0)){c[f>>2]=28;break}if(!(HEi(c[h>>2]|0,3668128)|0)){c[f>>2]=12;break}if(!(HEi(c[h>>2]|0,3668160)|0)){c[f>>2]=13;break}if(!(HEi(c[h>>2]|0,3668176)|0)){c[f>>2]=14;break}if(!(HEi(c[h>>2]|0,3668192)|0)){c[f>>2]=66;break}if(!(HEi(c[h>>2]|0,3668208)|0)){c[f>>2]=3092;break}if(!(HEi(c[h>>2]|0,3668224)|0)){c[f>>2]=1892;break}if(!(HEi(c[h>>2]|0,3668248)|0)){c[f>>2]=1893;break}if(!(HEi(c[h>>2]|0,3668272)|0)){c[f>>2]=1894;break}if(!(HEi(c[h>>2]|0,3668296)|0)){c[f>>2]=1895;break}if(!(HEi(c[h>>2]|0,3668320)|0)){c[f>>2]=3645;break}if(!(HEi(c[h>>2]|0,3668336)|0)){c[f>>2]=3093;break}if(!(HEi(c[h>>2]|0,3668352)|0)){c[f>>2]=3094;break}if(!(HEi(c[h>>2]|0,3668368)|0)){c[f>>2]=1896;break}if(!(HEi(c[h>>2]|0,3668392)|0)){c[f>>2]=371;break}if(!(HEi(c[h>>2]|0,3668408)|0)){c[f>>2]=372;break}if(!(HEi(c[h>>2]|0,3668424)|0)){c[f>>2]=3646;break}if(!(HEi(c[h>>2]|0,3668440)|0)){c[f>>2]=3095;break}if(!(HEi(c[h>>2]|0,3668464)|0)){c[f>>2]=3096;break}if(!(HEi(c[h>>2]|0,3668488)|0)){c[f>>2]=3097;break}if(!(HEi(c[h>>2]|0,3668512)|0)){c[f>>2]=1897;break}if(!(HEi(c[h>>2]|0,3668544)|0)){c[f>>2]=3647;break}if(!(HEi(c[h>>2]|0,3668568)|0)){c[f>>2]=1898;break}if(!(HEi(c[h>>2]|0,3668584)|0)){c[f>>2]=1899;break}if(!(HEi(c[h>>2]|0,3668600)|0)){c[f>>2]=2848;break}if(!(HEi(c[h>>2]|0,3668624)|0)){c[f>>2]=1900;break}if(!(HEi(c[h>>2]|0,3668648)|0)){c[f>>2]=1901;break}if(!(HEi(c[h>>2]|0,3668672)|0)){c[f>>2]=1902;break}if(!(HEi(c[h>>2]|0,3668704)|0)){c[f>>2]=67;break}if(!(HEi(c[h>>2]|0,3668728)|0)){c[f>>2]=183;break}if(!(HEi(c[h>>2]|0,3668744)|0)){c[f>>2]=16;break}if(!(HEi(c[h>>2]|0,3668760)|0)){c[f>>2]=6;break}if(!(HEi(c[h>>2]|0,3668776)|0)){c[f>>2]=8;break}if(!(HEi(c[h>>2]|0,3668792)|0)){c[f>>2]=3098;break}if(!(HEi(c[h>>2]|0,3668808)|0)){c[f>>2]=1903;break}if(!(HEi(c[h>>2]|0,3668824)|0)){c[f>>2]=373;break}if(!(HEi(c[h>>2]|0,3668840)|0)){c[f>>2]=108;break}if(!(HEi(c[h>>2]|0,3668856)|0)){c[f>>2]=1904;break}if(!(HEi(c[h>>2]|0,3668872)|0)){c[f>>2]=1905;break}if(!(HEi(c[h>>2]|0,3668888)|0)){c[f>>2]=1906;break}if(!(HEi(c[h>>2]|0,3668904)|0)){c[f>>2]=1907;break}if(!(HEi(c[h>>2]|0,3668920)|0)){c[f>>2]=1908;break}if(!(HEi(c[h>>2]|0,3668936)|0)){c[f>>2]=1909;break}if(!(HEi(c[h>>2]|0,3668952)|0)){c[f>>2]=1910;break}if(!(HEi(c[h>>2]|0,3668968)|0)){c[f>>2]=1911;break}if(!(HEi(c[h>>2]|0,3668984)|0)){c[f>>2]=374;break}if(!(HEi(c[h>>2]|0,3669008)|0)){c[f>>2]=375;break}if(!(HEi(c[h>>2]|0,3669032)|0)){c[f>>2]=376;break}if(!(HEi(c[h>>2]|0,3669056)|0)){c[f>>2]=3099;break}if(!(HEi(c[h>>2]|0,3669072)|0)){c[f>>2]=3100;break}if(!(HEi(c[h>>2]|0,3669096)|0)){c[f>>2]=3101;break}if(!(HEi(c[h>>2]|0,3669120)|0)){c[f>>2]=3102;break}if(!(HEi(c[h>>2]|0,3669144)|0)){c[f>>2]=3103;break}if(!(HEi(c[h>>2]|0,3669168)|0)){c[f>>2]=2849;break}if(!(HEi(c[h>>2]|0,3669192)|0)){c[f>>2]=68;break}if(!(HEi(c[h>>2]|0,3667904)|0)){c[f>>2]=3648;break}if(!(HEi(c[h>>2]|0,3669216)|0)){c[f>>2]=3600;break}if(!(HEi(c[h>>2]|0,3669232)|0)){c[f>>2]=377;break}if(!(HEi(c[h>>2]|0,3669256)|0)){c[f>>2]=378;break}if(!(HEi(c[h>>2]|0,3669272)|0)){c[f>>2]=379;break}if(!(HEi(c[h>>2]|0,3669296)|0)){c[f>>2]=3601;break}if(!(HEi(c[h>>2]|0,3669312)|0)){c[f>>2]=380;break}if(!(HEi(c[h>>2]|0,3669336)|0)){c[f>>2]=1912;break}if(!(HEi(c[h>>2]|0,3669352)|0)){c[f>>2]=1913;break}if(!(HEi(c[h>>2]|0,3669368)|0)){c[f>>2]=3649;break}if(!(HEi(c[h>>2]|0,3667824)|0)){c[f>>2]=71;break}if(!(HEi(c[h>>2]|0,3669384)|0)){c[f>>2]=3602;break}if(!(HEi(c[h>>2]|0,3667936)|0)){c[f>>2]=3104;break}if(!(HEi(c[h>>2]|0,3667968)|0)){c[f>>2]=3105;break}if(!(HEi(c[h>>2]|0,3669400)|0)){c[f>>2]=381;break}if(!(HEi(c[h>>2]|0,3669432)|0)){c[f>>2]=3603;break}if(!(HEi(c[h>>2]|0,3669448)|0)){c[f>>2]=382;break}if(!(HEi(c[h>>2]|0,3667864)|0)){c[f>>2]=3604;break}if(!(HEi(c[h>>2]|0,3669472)|0)){c[f>>2]=3605;break}if(!(HEi(c[h>>2]|0,3669496)|0)){c[f>>2]=3650;break}if(!(HEi(c[h>>2]|0,3669512)|0)){c[f>>2]=1914;break}if(!(HEi(c[h>>2]|0,3669536)|0)){c[f>>2]=3106;break}if(!(HEi(c[h>>2]|0,3669560)|0)){c[f>>2]=3107;break}if(!(HEi(c[h>>2]|0,3669584)|0)){c[f>>2]=3108;break}if(!(HEi(c[h>>2]|0,3669608)|0)){c[f>>2]=383;break}if(!(HEi(c[h>>2]|0,3669640)|0)){c[f>>2]=109;break}if(!(HEi(c[h>>2]|0,3669664)|0)){c[f>>2]=384;break}if(!(HEi(c[h>>2]|0,3669704)|0)){c[f>>2]=3651;break}if(!(HEi(c[h>>2]|0,3669720)|0)){c[f>>2]=3606;break}if(!(HEi(c[h>>2]|0,3669736)|0)){c[f>>2]=1915;break}if(!(HEi(c[h>>2]|0,3669760)|0)){c[f>>2]=385;break}if(!(HEi(c[h>>2]|0,3669776)|0)){c[f>>2]=3109;break}if(!(HEi(c[h>>2]|0,3669792)|0)){c[f>>2]=3110;break}if(!(HEi(c[h>>2]|0,3669808)|0)){c[f>>2]=124;break}if(!(HEi(c[h>>2]|0,3669832)|0)){c[f>>2]=3607;break}if(!(HEi(c[h>>2]|0,3669856)|0)){c[f>>2]=386;break}if(!(HEi(c[h>>2]|0,3669872)|0)){c[f>>2]=387;break}if(!(HEi(c[h>>2]|0,3669896)|0)){c[f>>2]=1916;break}if(!(HEi(c[h>>2]|0,3669912)|0)){c[f>>2]=388;break}if(!(HEi(c[h>>2]|0,3669928)|0)){c[f>>2]=3608;break}if(!(HEi(c[h>>2]|0,3669952)|0)){c[f>>2]=3111;break}if(!(HEi(c[h>>2]|0,3669976)|0)){c[f>>2]=3112;break}if(!(HEi(c[h>>2]|0,367e4)|0)){c[f>>2]=3609;break}if(!(HEi(c[h>>2]|0,3670024)|0)){c[f>>2]=3610;break}if(!(HEi(c[h>>2]|0,3670040)|0)){c[f>>2]=255;break}if(!(HEi(c[h>>2]|0,3670056)|0)){c[f>>2]=3611;break}if(!(HEi(c[h>>2]|0,3670072)|0)){c[f>>2]=1;break}if(!(HEi(c[h>>2]|0,3670088)|0)){c[f>>2]=2;break}if(!(HEi(c[h>>2]|0,3670104)|0)){c[f>>2]=125;break}if(!(HEi(c[h>>2]|0,3670128)|0)){c[f>>2]=3612;break}if(!(HEi(c[h>>2]|0,3670160)|0)){c[f>>2]=3613;break}if(!(HEi(c[h>>2]|0,3670192)|0)){c[f>>2]=1917;break}if(!(HEi(c[h>>2]|0,3670208)|0)){c[f>>2]=389;break}if(!(HEi(c[h>>2]|0,3670224)|0)){c[f>>2]=110;break}if(!(HEi(c[h>>2]|0,3670240)|0)){c[f>>2]=256;break}if(!(HEi(c[h>>2]|0,3670264)|0)){c[f>>2]=72;break}if(!(HEi(c[h>>2]|0,3670280)|0)){c[f>>2]=3113;break}if(!(HEi(c[h>>2]|0,3670304)|0)){c[f>>2]=390;break}if(!(HEi(c[h>>2]|0,3670328)|0)){c[f>>2]=111;break}if(!(HEi(c[h>>2]|0,3670352)|0)){c[f>>2]=257;break}if(!(HEi(c[h>>2]|0,3670368)|0)){c[f>>2]=258;break}if(!(HEi(c[h>>2]|0,3670376)|0)){c[f>>2]=1;break}if(!(HEi(c[h>>2]|0,3670392)|0)){c[f>>2]=2;break}if(!(HEi(c[h>>2]|0,3670408)|0)){c[f>>2]=3614;break}if(!(HEi(c[h>>2]|0,3670424)|0)){c[f>>2]=3615;break}if(!(HEi(c[h>>2]|0,3670440)|0)){c[f>>2]=3616;break}if(!(HEi(c[h>>2]|0,3670456)|0)){c[f>>2]=3617;break}if(!(HEi(c[h>>2]|0,3670472)|0)){c[f>>2]=3618;break}if(!(HEi(c[h>>2]|0,3670488)|0)){c[f>>2]=3619;break}if(!(HEi(c[h>>2]|0,3670496)|0)){c[f>>2]=3;break}if(!(HEi(c[h>>2]|0,3670512)|0)){c[f>>2]=3620;break}if(!(HEi(c[h>>2]|0,3670528)|0)){c[f>>2]=3621;break}if(!(HEi(c[h>>2]|0,3670544)|0)){c[f>>2]=3622;break}if(!(HEi(c[h>>2]|0,3670560)|0)){c[f>>2]=3652;break}if(!(HEi(c[h>>2]|0,3670592)|0)){c[f>>2]=3623;break}if(!(HEi(c[h>>2]|0,3670616)|0)){c[f>>2]=3624;break}if(!(HEi(c[h>>2]|0,3670632)|0)){c[f>>2]=3625;break}if(!(HEi(c[h>>2]|0,3670648)|0)){c[f>>2]=3653;break}if(!(HEi(c[h>>2]|0,3670664)|0)){c[f>>2]=3114;break}if(!(HEi(c[h>>2]|0,3670680)|0)){c[f>>2]=3115;break}if(!(HEi(c[h>>2]|0,3670704)|0)){c[f>>2]=1;break}if(!(HEi(c[h>>2]|0,3670720)|0)){c[f>>2]=2;break}if(!(HEi(c[h>>2]|0,3670736)|0)){c[f>>2]=3116;break}if(!(HEi(c[h>>2]|0,3670760)|0)){c[f>>2]=3117;break}if(!(HEi(c[h>>2]|0,3670768)|0)){c[f>>2]=3;break}if(!(HEi(c[h>>2]|0,3670784)|0)){c[f>>2]=184;break}if(!(HEi(c[h>>2]|0,3670808)|0)){c[f>>2]=1;break}if(!(HEi(c[h>>2]|0,3670832)|0)){c[f>>2]=1918;break}if(!(HEi(c[h>>2]|0,3670848)|0)){c[f>>2]=39;break}if(!(HEi(c[h>>2]|0,3670864)|0)){c[f>>2]=17;break}if(!(HEi(c[h>>2]|0,3670888)|0)){c[f>>2]=1919;break}if(!(HEi(c[h>>2]|0,3670904)|0)){c[f>>2]=1920;break}if(!(HEi(c[h>>2]|0,3670920)|0)){c[f>>2]=391;break}if(!(HEi(c[h>>2]|0,3670936)|0)){c[f>>2]=3;break}if(!(HEi(c[h>>2]|0,3670952)|0)){c[f>>2]=392;break}if(!(HEi(c[h>>2]|0,3670968)|0)){c[f>>2]=7;break}if(!(HEi(c[h>>2]|0,3670992)|0)){c[f>>2]=393;break}if(!(HEi(c[h>>2]|0,3671008)|0)){c[f>>2]=394;break}if(!(HEi(c[h>>2]|0,3671032)|0)){c[f>>2]=395;break}if(!(HEi(c[h>>2]|0,3671056)|0)){c[f>>2]=4;break}if(!(HEi(c[h>>2]|0,3671072)|0)){c[f>>2]=396;break}if(!(HEi(c[h>>2]|0,3671096)|0)){c[f>>2]=397;break}if(!(HEi(c[h>>2]|0,3671120)|0)){c[f>>2]=9;break}if(!(HEi(c[h>>2]|0,3671144)|0)){c[f>>2]=29;break}if(!(HEi(c[h>>2]|0,3671168)|0)){c[f>>2]=30;break}if(HEi(c[h>>2]|0,3671192)|0){j=c[p>>2]|0;b=c[h>>2]|0;c[e>>2]=c[g>>2];c[e+4>>2]=b;Li(j|0,3671208,e|0)|0;c[f>>2]=0;break}else{c[f>>2]=3118;break}}else c[f>>2]=3086;while(0);i=d;return c[f>>2]|0}function ADi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;b=i;do if(a>>>0<245){if(a>>>0<11)d=16;else d=a+11&-8;e=d>>>3;f=c[917812]|0;g=f>>>e;if(g&3){h=(g&1^1)+e|0;j=h<<1;k=3671288+(j<<2)|0;l=3671288+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do if((k|0)!=(n|0)){if(n>>>0<(c[917816]|0)>>>0)Vl();o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else Vl()}else c[917812]=f&~(1<<h);while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}l=c[917814]|0;if(d>>>0>l>>>0){if(g){n=2<<e;k=g<<e&(n|0-n);n=(k&0-k)+-1|0;k=n>>>12&16;o=n>>>k;n=o>>>5&8;q=o>>>n;o=q>>>2&4;r=q>>>o;q=r>>>1&2;s=r>>>q;r=s>>>1&1;t=(n|k|o|q|r)+(s>>>r)|0;r=t<<1;s=3671288+(r<<2)|0;q=3671288+(r+2<<2)|0;r=c[q>>2]|0;o=r+8|0;k=c[o>>2]|0;do if((s|0)!=(k|0)){if(k>>>0<(c[917816]|0)>>>0)Vl();n=k+12|0;if((c[n>>2]|0)==(r|0)){c[n>>2]=s;c[q>>2]=k;u=c[917814]|0;break}else Vl()}else{c[917812]=f&~(1<<t);u=l}while(0);l=t<<3;f=l-d|0;c[r+4>>2]=d|3;k=r+d|0;c[r+(d|4)>>2]=f|1;c[r+l>>2]=f;if(u){l=c[917817]|0;q=u>>>3;s=q<<1;e=3671288+(s<<2)|0;g=c[917812]|0;m=1<<q;if(g&m){q=3671288+(s+2<<2)|0;j=c[q>>2]|0;if(j>>>0<(c[917816]|0)>>>0)Vl();else{v=q;w=j}}else{c[917812]=g|m;v=3671288+(s+2<<2)|0;w=e}c[v>>2]=l;c[w+12>>2]=l;c[l+8>>2]=w;c[l+12>>2]=e}c[917814]=f;c[917817]=k;p=o;i=b;return p|0}k=c[917813]|0;if(k){f=(k&0-k)+-1|0;k=f>>>12&16;e=f>>>k;f=e>>>5&8;l=e>>>f;e=l>>>2&4;s=l>>>e;l=s>>>1&2;m=s>>>l;s=m>>>1&1;g=c[3671552+((f|k|e|l|s)+(m>>>s)<<2)>>2]|0;s=(c[g+4>>2]&-8)-d|0;m=g;l=g;while(1){g=c[m+16>>2]|0;if(!g){e=c[m+20>>2]|0;if(!e){x=s;y=l;break}else z=e}else z=g;g=(c[z+4>>2]&-8)-d|0;e=g>>>0<s>>>0;s=e?g:s;m=z;l=e?z:l}l=c[917816]|0;if(y>>>0<l>>>0)Vl();m=y+d|0;if(y>>>0>=m>>>0)Vl();s=c[y+24>>2]|0;o=c[y+12>>2]|0;do if((o|0)==(y|0)){r=y+20|0;t=c[r>>2]|0;if(!t){e=y+16|0;g=c[e>>2]|0;if(!g){A=0;break}else{B=g;C=e}}else{B=t;C=r}while(1){r=B+20|0;t=c[r>>2]|0;if(t){B=t;C=r;continue}r=B+16|0;t=c[r>>2]|0;if(!t){D=B;E=C;break}else{B=t;C=r}}if(E>>>0<l>>>0)Vl();else{c[E>>2]=0;A=D;break}}else{r=c[y+8>>2]|0;if(r>>>0<l>>>0)Vl();t=r+12|0;if((c[t>>2]|0)!=(y|0))Vl();e=o+8|0;if((c[e>>2]|0)==(y|0)){c[t>>2]=o;c[e>>2]=r;A=o;break}else Vl()}while(0);do if(s){o=c[y+28>>2]|0;l=3671552+(o<<2)|0;if((y|0)==(c[l>>2]|0)){c[l>>2]=A;if(!A){c[917813]=c[917813]&~(1<<o);break}}else{if(s>>>0<(c[917816]|0)>>>0)Vl();o=s+16|0;if((c[o>>2]|0)==(y|0))c[o>>2]=A;else c[s+20>>2]=A;if(!A)break}o=c[917816]|0;if(A>>>0<o>>>0)Vl();c[A+24>>2]=s;l=c[y+16>>2]|0;do if(l)if(l>>>0<o>>>0)Vl();else{c[A+16>>2]=l;c[l+24>>2]=A;break}while(0);l=c[y+20>>2]|0;if(l)if(l>>>0<(c[917816]|0)>>>0)Vl();else{c[A+20>>2]=l;c[l+24>>2]=A;break}}while(0);if(x>>>0<16){s=x+d|0;c[y+4>>2]=s|3;l=y+(s+4)|0;c[l>>2]=c[l>>2]|1}else{c[y+4>>2]=d|3;c[y+(d|4)>>2]=x|1;c[y+(x+d)>>2]=x;l=c[917814]|0;if(l){s=c[917817]|0;o=l>>>3;l=o<<1;r=3671288+(l<<2)|0;e=c[917812]|0;t=1<<o;if(e&t){o=3671288+(l+2<<2)|0;g=c[o>>2]|0;if(g>>>0<(c[917816]|0)>>>0)Vl();else{F=o;G=g}}else{c[917812]=e|t;F=3671288+(l+2<<2)|0;G=r}c[F>>2]=s;c[G+12>>2]=s;c[s+8>>2]=G;c[s+12>>2]=r}c[917814]=x;c[917817]=m}p=y+8|0;i=b;return p|0}else H=d}else H=d}else if(a>>>0<=4294967231){r=a+11|0;s=r&-8;l=c[917813]|0;if(l){t=0-s|0;e=r>>>8;if(e)if(s>>>0>16777215)I=31;else{r=(e+1048320|0)>>>16&8;g=e<<r;e=(g+520192|0)>>>16&4;o=g<<e;g=(o+245760|0)>>>16&2;k=14-(e|r|g)+(o<<g>>>15)|0;I=s>>>(k+7|0)&1|k<<1}else I=0;k=c[3671552+(I<<2)>>2]|0;a:do if(!k){J=t;K=0;L=0}else{if((I|0)==31)M=0;else M=25-(I>>>1)|0;g=t;o=0;r=s<<M;e=k;f=0;while(1){j=c[e+4>>2]&-8;q=j-s|0;if(q>>>0<g>>>0)if((j|0)==(s|0)){J=q;K=e;L=e;break a}else{N=q;O=e}else{N=g;O=f}q=c[e+20>>2]|0;e=c[e+(r>>>31<<2)+16>>2]|0;j=(q|0)==0|(q|0)==(e|0)?o:q;if(!e){J=N;K=j;L=O;break}else{g=N;o=j;r=r<<1;f=O}}}while(0);if((K|0)==0&(L|0)==0){k=2<<I;t=l&(k|0-k);if(!t){H=s;break}k=(t&0-t)+-1|0;t=k>>>12&16;m=k>>>t;k=m>>>5&8;f=m>>>k;m=f>>>2&4;r=f>>>m;f=r>>>1&2;o=r>>>f;r=o>>>1&1;P=c[3671552+((k|t|m|f|r)+(o>>>r)<<2)>>2]|0}else P=K;if(!P){Q=J;R=L}else{r=J;o=P;f=L;while(1){m=(c[o+4>>2]&-8)-s|0;t=m>>>0<r>>>0;k=t?m:r;m=t?o:f;t=c[o+16>>2]|0;if(t){r=k;o=t;f=m;continue}o=c[o+20>>2]|0;if(!o){Q=k;R=m;break}else{r=k;f=m}}}if((R|0)!=0?Q>>>0<((c[917814]|0)-s|0)>>>0:0){f=c[917816]|0;if(R>>>0<f>>>0)Vl();r=R+s|0;if(R>>>0>=r>>>0)Vl();o=c[R+24>>2]|0;l=c[R+12>>2]|0;do if((l|0)==(R|0)){m=R+20|0;k=c[m>>2]|0;if(!k){t=R+16|0;g=c[t>>2]|0;if(!g){S=0;break}else{T=g;U=t}}else{T=k;U=m}while(1){m=T+20|0;k=c[m>>2]|0;if(k){T=k;U=m;continue}m=T+16|0;k=c[m>>2]|0;if(!k){V=T;W=U;break}else{T=k;U=m}}if(W>>>0<f>>>0)Vl();else{c[W>>2]=0;S=V;break}}else{m=c[R+8>>2]|0;if(m>>>0<f>>>0)Vl();k=m+12|0;if((c[k>>2]|0)!=(R|0))Vl();t=l+8|0;if((c[t>>2]|0)==(R|0)){c[k>>2]=l;c[t>>2]=m;S=l;break}else Vl()}while(0);do if(o){l=c[R+28>>2]|0;f=3671552+(l<<2)|0;if((R|0)==(c[f>>2]|0)){c[f>>2]=S;if(!S){c[917813]=c[917813]&~(1<<l);break}}else{if(o>>>0<(c[917816]|0)>>>0)Vl();l=o+16|0;if((c[l>>2]|0)==(R|0))c[l>>2]=S;else c[o+20>>2]=S;if(!S)break}l=c[917816]|0;if(S>>>0<l>>>0)Vl();c[S+24>>2]=o;f=c[R+16>>2]|0;do if(f)if(f>>>0<l>>>0)Vl();else{c[S+16>>2]=f;c[f+24>>2]=S;break}while(0);f=c[R+20>>2]|0;if(f)if(f>>>0<(c[917816]|0)>>>0)Vl();else{c[S+20>>2]=f;c[f+24>>2]=S;break}}while(0);b:do if(Q>>>0>=16){c[R+4>>2]=s|3;c[R+(s|4)>>2]=Q|1;c[R+(Q+s)>>2]=Q;o=Q>>>3;if(Q>>>0<256){f=o<<1;l=3671288+(f<<2)|0;m=c[917812]|0;t=1<<o;do if(!(m&t)){c[917812]=m|t;X=3671288+(f+2<<2)|0;Y=l}else{o=3671288+(f+2<<2)|0;k=c[o>>2]|0;if(k>>>0>=(c[917816]|0)>>>0){X=o;Y=k;break}Vl()}while(0);c[X>>2]=r;c[Y+12>>2]=r;c[R+(s+8)>>2]=Y;c[R+(s+12)>>2]=l;break}f=Q>>>8;if(f)if(Q>>>0>16777215)Z=31;else{t=(f+1048320|0)>>>16&8;m=f<<t;f=(m+520192|0)>>>16&4;k=m<<f;m=(k+245760|0)>>>16&2;o=14-(f|t|m)+(k<<m>>>15)|0;Z=Q>>>(o+7|0)&1|o<<1}else Z=0;o=3671552+(Z<<2)|0;c[R+(s+28)>>2]=Z;c[R+(s+20)>>2]=0;c[R+(s+16)>>2]=0;m=c[917813]|0;k=1<<Z;if(!(m&k)){c[917813]=m|k;c[o>>2]=r;c[R+(s+24)>>2]=o;c[R+(s+12)>>2]=r;c[R+(s+8)>>2]=r;break}k=c[o>>2]|0;if((Z|0)==31)_=0;else _=25-(Z>>>1)|0;c:do if((c[k+4>>2]&-8|0)!=(Q|0)){o=Q<<_;m=k;while(1){t=m+(o>>>31<<2)+16|0;f=c[t>>2]|0;if(!f){$=t;aa=m;break}if((c[f+4>>2]&-8|0)==(Q|0)){ba=f;break c}else{o=o<<1;m=f}}if($>>>0<(c[917816]|0)>>>0)Vl();else{c[$>>2]=r;c[R+(s+24)>>2]=aa;c[R+(s+12)>>2]=r;c[R+(s+8)>>2]=r;break b}}else ba=k;while(0);k=ba+8|0;l=c[k>>2]|0;m=c[917816]|0;if(ba>>>0>=m>>>0&l>>>0>=m>>>0){c[l+12>>2]=r;c[k>>2]=r;c[R+(s+8)>>2]=l;c[R+(s+12)>>2]=ba;c[R+(s+24)>>2]=0;break}else Vl()}else{l=Q+s|0;c[R+4>>2]=l|3;k=R+(l+4)|0;c[k>>2]=c[k>>2]|1}while(0);p=R+8|0;i=b;return p|0}else H=s}else H=s}else H=-1;while(0);R=c[917814]|0;if(R>>>0>=H>>>0){Q=R-H|0;ba=c[917817]|0;if(Q>>>0>15){c[917817]=ba+H;c[917814]=Q;c[ba+(H+4)>>2]=Q|1;c[ba+R>>2]=Q;c[ba+4>>2]=H|3}else{c[917814]=0;c[917817]=0;c[ba+4>>2]=R|3;Q=ba+(R+4)|0;c[Q>>2]=c[Q>>2]|1}p=ba+8|0;i=b;return p|0}ba=c[917815]|0;if(ba>>>0>H>>>0){Q=ba-H|0;c[917815]=Q;ba=c[917818]|0;c[917818]=ba+H;c[ba+(H+4)>>2]=Q|1;c[ba+4>>2]=H|3;p=ba+8|0;i=b;return p|0}do if(!(c[917930]|0)){ba=Wh(30)|0;if(!(ba+-1&ba)){c[917932]=ba;c[917931]=ba;c[917933]=-1;c[917934]=-1;c[917935]=0;c[917923]=0;c[917930]=(pl(0)|0)&-16^1431655768;break}else Vl()}while(0);ba=H+48|0;Q=c[917932]|0;R=H+47|0;aa=Q+R|0;$=0-Q|0;Q=aa&$;if(Q>>>0<=H>>>0){p=0;i=b;return p|0}_=c[917922]|0;if((_|0)!=0?(Z=c[917920]|0,Y=Z+Q|0,Y>>>0<=Z>>>0|Y>>>0>_>>>0):0){p=0;i=b;return p|0}d:do if(!(c[917923]&4)){_=c[917818]|0;e:do if(_){Y=3671696|0;while(1){Z=c[Y>>2]|0;if(Z>>>0<=_>>>0?(X=Y+4|0,(Z+(c[X>>2]|0)|0)>>>0>_>>>0):0){ca=Y;da=X;ea=Y;break}Y=c[Y+8>>2]|0;if(!Y){fa=181;break e}}if(ea){Y=aa-(c[917815]|0)&$;if(Y>>>0<2147483647){X=rk(Y|0)|0;if((X|0)==((c[ca>>2]|0)+(c[da>>2]|0)|0)){ga=X;ha=Y;fa=190}else{ia=X;ja=Y;fa=191}}else ka=0}else fa=181}else fa=181;while(0);do if((fa|0)==181){_=rk(0)|0;if((_|0)!=(-1|0)){s=_;Y=c[917931]|0;X=Y+-1|0;if(!(X&s))la=Q;else la=Q-s+(X+s&0-Y)|0;Y=c[917920]|0;s=Y+la|0;if(la>>>0>H>>>0&la>>>0<2147483647){X=c[917922]|0;if((X|0)!=0?s>>>0<=Y>>>0|s>>>0>X>>>0:0){ka=0;break}X=rk(la|0)|0;if((X|0)==(_|0)){ga=_;ha=la;fa=190}else{ia=X;ja=la;fa=191}}else ka=0}else ka=0}while(0);f:do if((fa|0)==190)if((ga|0)==(-1|0))ka=ha;else{ma=ga;na=ha;fa=201;break d}else if((fa|0)==191){X=0-ja|0;do if((ia|0)!=(-1|0)&ja>>>0<2147483647&ba>>>0>ja>>>0?(_=c[917932]|0,s=R-ja+_&0-_,s>>>0<2147483647):0)if((rk(s|0)|0)==(-1|0)){rk(X|0)|0;ka=0;break f}else{oa=s+ja|0;break}else oa=ja;while(0);if((ia|0)==(-1|0))ka=0;else{ma=ia;na=oa;fa=201;break d}}while(0);c[917923]=c[917923]|4;pa=ka;fa=198}else{pa=0;fa=198}while(0);if((((fa|0)==198?Q>>>0<2147483647:0)?(ka=rk(Q|0)|0,Q=rk(0)|0,(ka|0)!=(-1|0)&(Q|0)!=(-1|0)&ka>>>0<Q>>>0):0)?(oa=Q-ka|0,Q=oa>>>0>(H+40|0)>>>0,Q):0){ma=ka;na=Q?oa:pa;fa=201}if((fa|0)==201){pa=(c[917920]|0)+na|0;c[917920]=pa;if(pa>>>0>(c[917921]|0)>>>0)c[917921]=pa;pa=c[917818]|0;g:do if(pa){oa=3671696|0;do{Q=c[oa>>2]|0;ka=oa+4|0;ia=c[ka>>2]|0;if((ma|0)==(Q+ia|0)){qa=Q;ra=ka;sa=ia;ta=oa;fa=213;break}oa=c[oa+8>>2]|0}while((oa|0)!=0);if(((fa|0)==213?(c[ta+12>>2]&8|0)==0:0)?pa>>>0>=qa>>>0&pa>>>0<ma>>>0:0){c[ra>>2]=sa+na;oa=(c[917815]|0)+na|0;ia=pa+8|0;if(!(ia&7))ua=0;else ua=0-ia&7;ia=oa-ua|0;c[917818]=pa+ua;c[917815]=ia;c[pa+(ua+4)>>2]=ia|1;c[pa+(oa+4)>>2]=40;c[917819]=c[917934];break}oa=c[917816]|0;if(ma>>>0<oa>>>0){c[917816]=ma;va=ma}else va=oa;oa=ma+na|0;ia=3671696|0;do{if((c[ia>>2]|0)==(oa|0)){wa=ia;xa=ia;fa=223;break}ia=c[ia+8>>2]|0}while((ia|0)!=0);if((fa|0)==223?(c[xa+12>>2]&8|0)==0:0){c[wa>>2]=ma;ia=xa+4|0;c[ia>>2]=(c[ia>>2]|0)+na;ia=ma+8|0;if(!(ia&7))ya=0;else ya=0-ia&7;ia=ma+(na+8)|0;if(!(ia&7))za=0;else za=0-ia&7;ia=ma+(za+na)|0;oa=ya+H|0;ka=ma+oa|0;Q=ia-(ma+ya)-H|0;c[ma+(ya+4)>>2]=H|3;h:do if((ia|0)!=(pa|0)){if((ia|0)==(c[917817]|0)){ja=(c[917814]|0)+Q|0;c[917814]=ja;c[917817]=ka;c[ma+(oa+4)>>2]=ja|1;c[ma+(ja+oa)>>2]=ja;break}ja=na+4|0;R=c[ma+(ja+za)>>2]|0;if((R&3|0)==1){ba=R&-8;ha=R>>>3;i:do if(R>>>0>=256){ga=c[ma+((za|24)+na)>>2]|0;la=c[ma+(na+12+za)>>2]|0;do if((la|0)==(ia|0)){da=za|16;ca=ma+(ja+da)|0;$=c[ca>>2]|0;if(!$){aa=ma+(da+na)|0;da=c[aa>>2]|0;if(!da){Aa=0;break}else{Ba=da;Ca=aa}}else{Ba=$;Ca=ca}while(1){ca=Ba+20|0;$=c[ca>>2]|0;if($){Ba=$;Ca=ca;continue}ca=Ba+16|0;$=c[ca>>2]|0;if(!$){Da=Ba;Ea=Ca;break}else{Ba=$;Ca=ca}}if(Ea>>>0<va>>>0)Vl();else{c[Ea>>2]=0;Aa=Da;break}}else{ca=c[ma+((za|8)+na)>>2]|0;if(ca>>>0<va>>>0)Vl();$=ca+12|0;if((c[$>>2]|0)!=(ia|0))Vl();aa=la+8|0;if((c[aa>>2]|0)==(ia|0)){c[$>>2]=la;c[aa>>2]=ca;Aa=la;break}else Vl()}while(0);if(!ga)break;la=c[ma+(na+28+za)>>2]|0;ca=3671552+(la<<2)|0;do if((ia|0)!=(c[ca>>2]|0)){if(ga>>>0<(c[917816]|0)>>>0)Vl();aa=ga+16|0;if((c[aa>>2]|0)==(ia|0))c[aa>>2]=Aa;else c[ga+20>>2]=Aa;if(!Aa)break i}else{c[ca>>2]=Aa;if(Aa)break;c[917813]=c[917813]&~(1<<la);break i}while(0);la=c[917816]|0;if(Aa>>>0<la>>>0)Vl();c[Aa+24>>2]=ga;ca=za|16;aa=c[ma+(ca+na)>>2]|0;do if(aa)if(aa>>>0<la>>>0)Vl();else{c[Aa+16>>2]=aa;c[aa+24>>2]=Aa;break}while(0);aa=c[ma+(ja+ca)>>2]|0;if(!aa)break;if(aa>>>0<(c[917816]|0)>>>0)Vl();else{c[Aa+20>>2]=aa;c[aa+24>>2]=Aa;break}}else{aa=c[ma+((za|8)+na)>>2]|0;la=c[ma+(na+12+za)>>2]|0;ga=3671288+(ha<<1<<2)|0;do if((aa|0)!=(ga|0)){if(aa>>>0<va>>>0)Vl();if((c[aa+12>>2]|0)==(ia|0))break;Vl()}while(0);if((la|0)==(aa|0)){c[917812]=c[917812]&~(1<<ha);break}do if((la|0)==(ga|0))Fa=la+8|0;else{if(la>>>0<va>>>0)Vl();ca=la+8|0;if((c[ca>>2]|0)==(ia|0)){Fa=ca;break}Vl()}while(0);c[aa+12>>2]=la;c[Fa>>2]=aa}while(0);Ga=ma+((ba|za)+na)|0;Ha=ba+Q|0}else{Ga=ia;Ha=Q}ha=Ga+4|0;c[ha>>2]=c[ha>>2]&-2;c[ma+(oa+4)>>2]=Ha|1;c[ma+(Ha+oa)>>2]=Ha;ha=Ha>>>3;if(Ha>>>0<256){ja=ha<<1;R=3671288+(ja<<2)|0;ga=c[917812]|0;ca=1<<ha;do if(!(ga&ca)){c[917812]=ga|ca;Ia=3671288+(ja+2<<2)|0;Ja=R}else{ha=3671288+(ja+2<<2)|0;$=c[ha>>2]|0;if($>>>0>=(c[917816]|0)>>>0){Ia=ha;Ja=$;break}Vl()}while(0);c[Ia>>2]=ka;c[Ja+12>>2]=ka;c[ma+(oa+8)>>2]=Ja;c[ma+(oa+12)>>2]=R;break}ja=Ha>>>8;do if(!ja)Ka=0;else{if(Ha>>>0>16777215){Ka=31;break}ca=(ja+1048320|0)>>>16&8;ga=ja<<ca;ba=(ga+520192|0)>>>16&4;$=ga<<ba;ga=($+245760|0)>>>16&2;ha=14-(ba|ca|ga)+($<<ga>>>15)|0;Ka=Ha>>>(ha+7|0)&1|ha<<1}while(0);ja=3671552+(Ka<<2)|0;c[ma+(oa+28)>>2]=Ka;c[ma+(oa+20)>>2]=0;c[ma+(oa+16)>>2]=0;R=c[917813]|0;ha=1<<Ka;if(!(R&ha)){c[917813]=R|ha;c[ja>>2]=ka;c[ma+(oa+24)>>2]=ja;c[ma+(oa+12)>>2]=ka;c[ma+(oa+8)>>2]=ka;break}ha=c[ja>>2]|0;if((Ka|0)==31)La=0;else La=25-(Ka>>>1)|0;j:do if((c[ha+4>>2]&-8|0)!=(Ha|0)){ja=Ha<<La;R=ha;while(1){ga=R+(ja>>>31<<2)+16|0;$=c[ga>>2]|0;if(!$){Ma=ga;Na=R;break}if((c[$+4>>2]&-8|0)==(Ha|0)){Oa=$;break j}else{ja=ja<<1;R=$}}if(Ma>>>0<(c[917816]|0)>>>0)Vl();else{c[Ma>>2]=ka;c[ma+(oa+24)>>2]=Na;c[ma+(oa+12)>>2]=ka;c[ma+(oa+8)>>2]=ka;break h}}else Oa=ha;while(0);ha=Oa+8|0;R=c[ha>>2]|0;ja=c[917816]|0;if(Oa>>>0>=ja>>>0&R>>>0>=ja>>>0){c[R+12>>2]=ka;c[ha>>2]=ka;c[ma+(oa+8)>>2]=R;c[ma+(oa+12)>>2]=Oa;c[ma+(oa+24)>>2]=0;break}else Vl()}else{R=(c[917815]|0)+Q|0;c[917815]=R;c[917818]=ka;c[ma+(oa+4)>>2]=R|1}while(0);p=ma+(ya|8)|0;i=b;return p|0}oa=3671696|0;while(1){ka=c[oa>>2]|0;if(ka>>>0<=pa>>>0?(Q=c[oa+4>>2]|0,ia=ka+Q|0,ia>>>0>pa>>>0):0){Pa=ka;Qa=Q;Ra=ia;break}oa=c[oa+8>>2]|0}oa=Pa+(Qa+-39)|0;if(!(oa&7))Sa=0;else Sa=0-oa&7;oa=Pa+(Qa+-47+Sa)|0;ia=oa>>>0<(pa+16|0)>>>0?pa:oa;oa=ia+8|0;Q=ma+8|0;if(!(Q&7))Ta=0;else Ta=0-Q&7;Q=na+-40-Ta|0;c[917818]=ma+Ta;c[917815]=Q;c[ma+(Ta+4)>>2]=Q|1;c[ma+(na+-36)>>2]=40;c[917819]=c[917934];c[ia+4>>2]=27;c[oa+0>>2]=c[917924];c[oa+4>>2]=c[917925];c[oa+8>>2]=c[917926];c[oa+12>>2]=c[917927];c[917924]=ma;c[917925]=na;c[917927]=0;c[917926]=oa;oa=ia+28|0;c[oa>>2]=7;if((ia+32|0)>>>0<Ra>>>0){Q=oa;do{oa=Q;Q=Q+4|0;c[Q>>2]=7}while((oa+8|0)>>>0<Ra>>>0)}if((ia|0)!=(pa|0)){Q=ia-pa|0;oa=pa+(Q+4)|0;c[oa>>2]=c[oa>>2]&-2;c[pa+4>>2]=Q|1;c[pa+Q>>2]=Q;oa=Q>>>3;if(Q>>>0<256){ka=oa<<1;R=3671288+(ka<<2)|0;ha=c[917812]|0;ja=1<<oa;do if(!(ha&ja)){c[917812]=ha|ja;Ua=3671288+(ka+2<<2)|0;Va=R}else{oa=3671288+(ka+2<<2)|0;aa=c[oa>>2]|0;if(aa>>>0>=(c[917816]|0)>>>0){Ua=oa;Va=aa;break}Vl()}while(0);c[Ua>>2]=pa;c[Va+12>>2]=pa;c[pa+8>>2]=Va;c[pa+12>>2]=R;break}ka=Q>>>8;if(ka)if(Q>>>0>16777215)Wa=31;else{ja=(ka+1048320|0)>>>16&8;ha=ka<<ja;ka=(ha+520192|0)>>>16&4;ia=ha<<ka;ha=(ia+245760|0)>>>16&2;aa=14-(ka|ja|ha)+(ia<<ha>>>15)|0;Wa=Q>>>(aa+7|0)&1|aa<<1}else Wa=0;aa=3671552+(Wa<<2)|0;c[pa+28>>2]=Wa;c[pa+20>>2]=0;c[pa+16>>2]=0;ha=c[917813]|0;ia=1<<Wa;if(!(ha&ia)){c[917813]=ha|ia;c[aa>>2]=pa;c[pa+24>>2]=aa;c[pa+12>>2]=pa;c[pa+8>>2]=pa;break}ia=c[aa>>2]|0;if((Wa|0)==31)Xa=0;else Xa=25-(Wa>>>1)|0;k:do if((c[ia+4>>2]&-8|0)!=(Q|0)){aa=Q<<Xa;ha=ia;while(1){ja=ha+(aa>>>31<<2)+16|0;ka=c[ja>>2]|0;if(!ka){Ya=ja;Za=ha;break}if((c[ka+4>>2]&-8|0)==(Q|0)){_a=ka;break k}else{aa=aa<<1;ha=ka}}if(Ya>>>0<(c[917816]|0)>>>0)Vl();else{c[Ya>>2]=pa;c[pa+24>>2]=Za;c[pa+12>>2]=pa;c[pa+8>>2]=pa;break g}}else _a=ia;while(0);ia=_a+8|0;Q=c[ia>>2]|0;R=c[917816]|0;if(_a>>>0>=R>>>0&Q>>>0>=R>>>0){c[Q+12>>2]=pa;c[ia>>2]=pa;c[pa+8>>2]=Q;c[pa+12>>2]=_a;c[pa+24>>2]=0;break}else Vl()}}else{Q=c[917816]|0;if((Q|0)==0|ma>>>0<Q>>>0)c[917816]=ma;c[917924]=ma;c[917925]=na;c[917927]=0;c[917821]=c[917930];c[917820]=-1;Q=0;do{ia=Q<<1;R=3671288+(ia<<2)|0;c[3671288+(ia+3<<2)>>2]=R;c[3671288+(ia+2<<2)>>2]=R;Q=Q+1|0}while((Q|0)!=32);Q=ma+8|0;if(!(Q&7))$a=0;else $a=0-Q&7;Q=na+-40-$a|0;c[917818]=ma+$a;c[917815]=Q;c[ma+($a+4)>>2]=Q|1;c[ma+(na+-36)>>2]=40;c[917819]=c[917934]}while(0);na=c[917815]|0;if(na>>>0>H>>>0){ma=na-H|0;c[917815]=ma;na=c[917818]|0;c[917818]=na+H;c[na+(H+4)>>2]=ma|1;c[na+4>>2]=H|3;p=na+8|0;i=b;return p|0}}c[(xd()|0)>>2]=12;p=0;i=b;return p|0}function BDi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;b=i;if(!a){i=b;return}d=a+-8|0;e=c[917816]|0;if(d>>>0<e>>>0)Vl();f=c[a+-4>>2]|0;g=f&3;if((g|0)==1)Vl();h=f&-8;j=a+(h+-8)|0;do if(!(f&1)){k=c[d>>2]|0;if(!g){i=b;return}l=-8-k|0;m=a+l|0;n=k+h|0;if(m>>>0<e>>>0)Vl();if((m|0)==(c[917817]|0)){o=a+(h+-4)|0;p=c[o>>2]|0;if((p&3|0)!=3){q=m;r=n;break}c[917814]=n;c[o>>2]=p&-2;c[a+(l+4)>>2]=n|1;c[j>>2]=n;i=b;return}p=k>>>3;if(k>>>0<256){k=c[a+(l+8)>>2]|0;o=c[a+(l+12)>>2]|0;s=3671288+(p<<1<<2)|0;if((k|0)!=(s|0)){if(k>>>0<e>>>0)Vl();if((c[k+12>>2]|0)!=(m|0))Vl()}if((o|0)==(k|0)){c[917812]=c[917812]&~(1<<p);q=m;r=n;break}if((o|0)!=(s|0)){if(o>>>0<e>>>0)Vl();s=o+8|0;if((c[s>>2]|0)==(m|0))t=s;else Vl()}else t=o+8|0;c[k+12>>2]=o;c[t>>2]=k;q=m;r=n;break}k=c[a+(l+24)>>2]|0;o=c[a+(l+12)>>2]|0;do if((o|0)==(m|0)){s=a+(l+20)|0;p=c[s>>2]|0;if(!p){u=a+(l+16)|0;v=c[u>>2]|0;if(!v){w=0;break}else{x=v;y=u}}else{x=p;y=s}while(1){s=x+20|0;p=c[s>>2]|0;if(p){x=p;y=s;continue}s=x+16|0;p=c[s>>2]|0;if(!p){z=x;A=y;break}else{x=p;y=s}}if(A>>>0<e>>>0)Vl();else{c[A>>2]=0;w=z;break}}else{s=c[a+(l+8)>>2]|0;if(s>>>0<e>>>0)Vl();p=s+12|0;if((c[p>>2]|0)!=(m|0))Vl();u=o+8|0;if((c[u>>2]|0)==(m|0)){c[p>>2]=o;c[u>>2]=s;w=o;break}else Vl()}while(0);if(k){o=c[a+(l+28)>>2]|0;s=3671552+(o<<2)|0;if((m|0)==(c[s>>2]|0)){c[s>>2]=w;if(!w){c[917813]=c[917813]&~(1<<o);q=m;r=n;break}}else{if(k>>>0<(c[917816]|0)>>>0)Vl();o=k+16|0;if((c[o>>2]|0)==(m|0))c[o>>2]=w;else c[k+20>>2]=w;if(!w){q=m;r=n;break}}o=c[917816]|0;if(w>>>0<o>>>0)Vl();c[w+24>>2]=k;s=c[a+(l+16)>>2]|0;do if(s)if(s>>>0<o>>>0)Vl();else{c[w+16>>2]=s;c[s+24>>2]=w;break}while(0);s=c[a+(l+20)>>2]|0;if(s)if(s>>>0<(c[917816]|0)>>>0)Vl();else{c[w+20>>2]=s;c[s+24>>2]=w;q=m;r=n;break}else{q=m;r=n}}else{q=m;r=n}}else{q=d;r=h}while(0);if(q>>>0>=j>>>0)Vl();d=a+(h+-4)|0;w=c[d>>2]|0;if(!(w&1))Vl();if(!(w&2)){if((j|0)==(c[917818]|0)){e=(c[917815]|0)+r|0;c[917815]=e;c[917818]=q;c[q+4>>2]=e|1;if((q|0)!=(c[917817]|0)){i=b;return}c[917817]=0;c[917814]=0;i=b;return}if((j|0)==(c[917817]|0)){e=(c[917814]|0)+r|0;c[917814]=e;c[917817]=q;c[q+4>>2]=e|1;c[q+e>>2]=e;i=b;return}e=(w&-8)+r|0;z=w>>>3;do if(w>>>0>=256){A=c[a+(h+16)>>2]|0;y=c[a+(h|4)>>2]|0;do if((y|0)==(j|0)){x=a+(h+12)|0;t=c[x>>2]|0;if(!t){g=a+(h+8)|0;f=c[g>>2]|0;if(!f){B=0;break}else{C=f;D=g}}else{C=t;D=x}while(1){x=C+20|0;t=c[x>>2]|0;if(t){C=t;D=x;continue}x=C+16|0;t=c[x>>2]|0;if(!t){E=C;F=D;break}else{C=t;D=x}}if(F>>>0<(c[917816]|0)>>>0)Vl();else{c[F>>2]=0;B=E;break}}else{x=c[a+h>>2]|0;if(x>>>0<(c[917816]|0)>>>0)Vl();t=x+12|0;if((c[t>>2]|0)!=(j|0))Vl();g=y+8|0;if((c[g>>2]|0)==(j|0)){c[t>>2]=y;c[g>>2]=x;B=y;break}else Vl()}while(0);if(A){y=c[a+(h+20)>>2]|0;n=3671552+(y<<2)|0;if((j|0)==(c[n>>2]|0)){c[n>>2]=B;if(!B){c[917813]=c[917813]&~(1<<y);break}}else{if(A>>>0<(c[917816]|0)>>>0)Vl();y=A+16|0;if((c[y>>2]|0)==(j|0))c[y>>2]=B;else c[A+20>>2]=B;if(!B)break}y=c[917816]|0;if(B>>>0<y>>>0)Vl();c[B+24>>2]=A;n=c[a+(h+8)>>2]|0;do if(n)if(n>>>0<y>>>0)Vl();else{c[B+16>>2]=n;c[n+24>>2]=B;break}while(0);n=c[a+(h+12)>>2]|0;if(n)if(n>>>0<(c[917816]|0)>>>0)Vl();else{c[B+20>>2]=n;c[n+24>>2]=B;break}}}else{n=c[a+h>>2]|0;y=c[a+(h|4)>>2]|0;A=3671288+(z<<1<<2)|0;if((n|0)!=(A|0)){if(n>>>0<(c[917816]|0)>>>0)Vl();if((c[n+12>>2]|0)!=(j|0))Vl()}if((y|0)==(n|0)){c[917812]=c[917812]&~(1<<z);break}if((y|0)!=(A|0)){if(y>>>0<(c[917816]|0)>>>0)Vl();A=y+8|0;if((c[A>>2]|0)==(j|0))G=A;else Vl()}else G=y+8|0;c[n+12>>2]=y;c[G>>2]=n}while(0);c[q+4>>2]=e|1;c[q+e>>2]=e;if((q|0)==(c[917817]|0)){c[917814]=e;i=b;return}else H=e}else{c[d>>2]=w&-2;c[q+4>>2]=r|1;c[q+r>>2]=r;H=r}r=H>>>3;if(H>>>0<256){w=r<<1;d=3671288+(w<<2)|0;e=c[917812]|0;G=1<<r;if(e&G){r=3671288+(w+2<<2)|0;j=c[r>>2]|0;if(j>>>0<(c[917816]|0)>>>0)Vl();else{I=r;J=j}}else{c[917812]=e|G;I=3671288+(w+2<<2)|0;J=d}c[I>>2]=q;c[J+12>>2]=q;c[q+8>>2]=J;c[q+12>>2]=d;i=b;return}d=H>>>8;if(d)if(H>>>0>16777215)K=31;else{J=(d+1048320|0)>>>16&8;I=d<<J;d=(I+520192|0)>>>16&4;w=I<<d;I=(w+245760|0)>>>16&2;G=14-(d|J|I)+(w<<I>>>15)|0;K=H>>>(G+7|0)&1|G<<1}else K=0;G=3671552+(K<<2)|0;c[q+28>>2]=K;c[q+20>>2]=0;c[q+16>>2]=0;I=c[917813]|0;w=1<<K;a:do if(I&w){J=c[G>>2]|0;if((K|0)==31)L=0;else L=25-(K>>>1)|0;b:do if((c[J+4>>2]&-8|0)!=(H|0)){d=H<<L;e=J;while(1){j=e+(d>>>31<<2)+16|0;r=c[j>>2]|0;if(!r){M=j;N=e;break}if((c[r+4>>2]&-8|0)==(H|0)){O=r;break b}else{d=d<<1;e=r}}if(M>>>0<(c[917816]|0)>>>0)Vl();else{c[M>>2]=q;c[q+24>>2]=N;c[q+12>>2]=q;c[q+8>>2]=q;break a}}else O=J;while(0);J=O+8|0;e=c[J>>2]|0;d=c[917816]|0;if(O>>>0>=d>>>0&e>>>0>=d>>>0){c[e+12>>2]=q;c[J>>2]=q;c[q+8>>2]=e;c[q+12>>2]=O;c[q+24>>2]=0;break}else Vl()}else{c[917813]=I|w;c[G>>2]=q;c[q+24>>2]=G;c[q+12>>2]=q;c[q+8>>2]=q}while(0);q=(c[917820]|0)+-1|0;c[917820]=q;if(!q)P=3671704|0;else{i=b;return}while(1){q=c[P>>2]|0;if(!q)break;else P=q+8|0}c[917820]=-1;i=b;return}function CDi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if(a){e=da(b,a)|0;if((b|a)>>>0>65535)f=((e>>>0)/(a>>>0)|0|0)==(b|0)?e:-1;else f=e}else f=0;e=ADi(f)|0;if(!e){i=d;return e|0}if(!(c[e+-4>>2]&3)){i=d;return e|0}PEi(e|0,0,f|0)|0;i=d;return e|0}function DDi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;do if(a){if(b>>>0>4294967231){c[(xd()|0)>>2]=12;e=0;break}if(b>>>0<11)f=16;else f=b+11&-8;g=JEi(a+-8|0,f)|0;if(g){e=g+8|0;break}g=ADi(b)|0;if(!g)e=0;else{h=c[a+-4>>2]|0;j=(h&-8)-((h&3|0)==0?8:4)|0;YEi(g|0,a|0,(j>>>0<b>>>0?j:b)|0)|0;BDi(a);e=g}}else e=ADi(b)|0;while(0);i=d;return e|0}function EDi(a){a=a|0;return (a+-48|0)>>>0<10|0}function FDi(a){a=a|0;var b=0;if((a|0)==32)b=1;else b=(a+-9|0)>>>0<5;return b&1|0}function GDi(a){a=a|0;return (a+-65|0)>>>0<26|0}function HDi(a){a=a|0;var b=0;if((a+-48|0)>>>0<10)b=1;else b=((a|32)+-97|0)>>>0<6;return b&1|0}function IDi(a){a=a|0;var b=0,c=0;b=i;c=(GDi(a)|0)==0;i=b;return (c?a:a|32)|0}function JDi(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;j=i;if(e>>>0>36){c[(xd()|0)>>2]=22;k=0;l=0;H=k;i=j;return l|0}m=b+4|0;n=b+100|0;do{o=c[m>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[m>>2]=o+1;p=d[o>>0]|0}else p=MDi(b)|0}while((FDi(p)|0)!=0);q=p;do if((q|0)==43|(q|0)==45){p=((q|0)==45)<<31>>31;o=c[m>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[m>>2]=o+1;r=d[o>>0]|0;s=p;break}else{r=MDi(b)|0;s=p;break}}else{r=q;s=0}while(0);q=(e|0)==0;do if((e&-17|0)==0&(r|0)==48){p=c[m>>2]|0;if(p>>>0<(c[n>>2]|0)>>>0){c[m>>2]=p+1;t=d[p>>0]|0}else t=MDi(b)|0;if((t|32|0)!=120)if(q){u=8;v=t;w=46;break}else{x=e;y=t;w=32;break}p=c[m>>2]|0;if(p>>>0<(c[n>>2]|0)>>>0){c[m>>2]=p+1;z=d[p>>0]|0}else z=MDi(b)|0;if((d[z+3671745>>0]|0)>15){p=(c[n>>2]|0)==0;if(!p)c[m>>2]=(c[m>>2]|0)+-1;if(!f){LDi(b,0);k=0;l=0;H=k;i=j;return l|0}if(p){k=0;l=0;H=k;i=j;return l|0}c[m>>2]=(c[m>>2]|0)+-1;k=0;l=0;H=k;i=j;return l|0}else{u=16;v=z;w=46}}else{p=q?10:e;if((d[r+3671745>>0]|0)>>>0<p>>>0){x=p;y=r;w=32}else{if(c[n>>2]|0)c[m>>2]=(c[m>>2]|0)+-1;LDi(b,0);c[(xd()|0)>>2]=22;k=0;l=0;H=k;i=j;return l|0}}while(0);if((w|0)==32)if((x|0)==10){r=y+-48|0;if(r>>>0<10){e=r;r=0;while(1){q=(r*10|0)+e|0;z=c[m>>2]|0;if(z>>>0<(c[n>>2]|0)>>>0){c[m>>2]=z+1;A=d[z>>0]|0}else A=MDi(b)|0;e=A+-48|0;if(!(e>>>0<10&q>>>0<429496729)){B=q;C=A;break}else r=q}D=B;E=0;F=C}else{D=0;E=0;F=y}C=F+-48|0;if(C>>>0<10){B=D;r=E;A=C;C=F;while(1){F=gFi(B|0,r|0,10,0)|0;e=H;q=((A|0)<0)<<31>>31;z=~q;if(e>>>0>z>>>0|(e|0)==(z|0)&F>>>0>~A>>>0){G=A;I=B;J=r;K=C;break}z=_Ei(F|0,e|0,A|0,q|0)|0;q=H;e=c[m>>2]|0;if(e>>>0<(c[n>>2]|0)>>>0){c[m>>2]=e+1;L=d[e>>0]|0}else L=MDi(b)|0;e=L+-48|0;if(e>>>0<10&(q>>>0<429496729|(q|0)==429496729&z>>>0<2576980378)){B=z;r=q;A=e;C=L}else{G=e;I=z;J=q;K=L;break}}if(G>>>0>9){M=J;N=I}else{O=10;P=I;Q=J;R=K;w=72}}else{M=E;N=D}}else{u=x;v=y;w=46}a:do if((w|0)==46){if(!(u+-1&u)){y=a[3672008+((u*23|0)>>>5&7)>>0]|0;x=a[v+3671745>>0]|0;D=x&255;if(D>>>0<u>>>0){E=D;D=0;while(1){K=E|D<<y;J=c[m>>2]|0;if(J>>>0<(c[n>>2]|0)>>>0){c[m>>2]=J+1;S=d[J>>0]|0}else S=MDi(b)|0;J=a[S+3671745>>0]|0;E=J&255;if(!(E>>>0<u>>>0&K>>>0<134217728)){T=K;U=J;V=S;break}else D=K}W=U;X=0;Y=T;Z=V}else{W=x;X=0;Y=0;Z=v}D=VEi(-1,-1,y|0)|0;E=H;if((W&255)>>>0>=u>>>0|(X>>>0>E>>>0|(X|0)==(E|0)&Y>>>0>D>>>0)){O=u;P=Y;Q=X;R=Z;w=72;break}else{_=Y;$=X;aa=W}while(1){K=cFi(_|0,$|0,y|0)|0;J=H;I=aa&255|K;K=c[m>>2]|0;if(K>>>0<(c[n>>2]|0)>>>0){c[m>>2]=K+1;ba=d[K>>0]|0}else ba=MDi(b)|0;aa=a[ba+3671745>>0]|0;if((aa&255)>>>0>=u>>>0|(J>>>0>E>>>0|(J|0)==(E|0)&I>>>0>D>>>0)){O=u;P=I;Q=J;R=ba;w=72;break a}else{_=I;$=J}}}D=a[v+3671745>>0]|0;E=D&255;if(E>>>0<u>>>0){y=E;E=0;while(1){x=y+(da(E,u)|0)|0;J=c[m>>2]|0;if(J>>>0<(c[n>>2]|0)>>>0){c[m>>2]=J+1;ca=d[J>>0]|0}else ca=MDi(b)|0;J=a[ca+3671745>>0]|0;y=J&255;if(!(y>>>0<u>>>0&x>>>0<119304647)){ea=x;fa=J;ga=ca;break}else E=x}ha=fa;ia=ea;ja=0;ka=ga}else{ha=D;ia=0;ja=0;ka=v}if((ha&255)>>>0<u>>>0){E=hFi(-1,-1,u|0,0)|0;y=H;x=ja;J=ia;I=ha;K=ka;while(1){if(x>>>0>y>>>0|(x|0)==(y|0)&J>>>0>E>>>0){O=u;P=J;Q=x;R=K;w=72;break a}G=gFi(J|0,x|0,u|0,0)|0;L=H;C=I&255;if(L>>>0>4294967295|(L|0)==-1&G>>>0>~C>>>0){O=u;P=J;Q=x;R=K;w=72;break a}A=_Ei(C|0,0,G|0,L|0)|0;L=H;G=c[m>>2]|0;if(G>>>0<(c[n>>2]|0)>>>0){c[m>>2]=G+1;la=d[G>>0]|0}else la=MDi(b)|0;I=a[la+3671745>>0]|0;if((I&255)>>>0>=u>>>0){O=u;P=A;Q=L;R=la;w=72;break}else{x=L;J=A;K=la}}}else{O=u;P=ia;Q=ja;R=ka;w=72}}while(0);if((w|0)==72)if((d[R+3671745>>0]|0)>>>0<O>>>0){do{R=c[m>>2]|0;if(R>>>0<(c[n>>2]|0)>>>0){c[m>>2]=R+1;ma=d[R>>0]|0}else ma=MDi(b)|0}while((d[ma+3671745>>0]|0)>>>0<O>>>0);c[(xd()|0)>>2]=34;M=h;N=g}else{M=Q;N=P}if(c[n>>2]|0)c[m>>2]=(c[m>>2]|0)+-1;if(!(M>>>0<h>>>0|(M|0)==(h|0)&N>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(s|0)!=0)){c[(xd()|0)>>2]=34;m=_Ei(g|0,h|0,-1,-1)|0;k=H;l=m;H=k;i=j;return l|0}if(M>>>0>h>>>0|(M|0)==(h|0)&N>>>0>g>>>0){c[(xd()|0)>>2]=34;k=h;l=g;H=k;i=j;return l|0}}g=((s|0)<0)<<31>>31;h=ZEi(N^s|0,M^g|0,s|0,g|0)|0;k=H;l=h;H=k;i=j;return l|0}function KDi(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0.0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0.0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0.0,md=0,nd=0.0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0,td=0,ud=0.0,vd=0,wd=0.0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else if(!e){j=24;k=-149}else{l=0.0;i=g;return +l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n>>0]|0}else o=MDi(b)|0}while((FDi(o)|0)!=0);p=o;do if((p|0)==43|(p|0)==45){o=1-(((p|0)==45&1)<<1)|0;n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;q=d[n>>0]|0;r=o;break}else{q=MDi(b)|0;r=o;break}}else{q=p;r=1}while(0);p=q;q=0;while(1){if((p|32|0)!=(a[3672024+q>>0]|0)){s=p;t=q;break}do if(q>>>0<7){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;u=d[o>>0]|0;break}else{u=MDi(b)|0;break}}else u=p;while(0);o=q+1|0;if(o>>>0<8){p=u;q=o}else{s=u;t=o;break}}do if((t|0)==3)v=23;else if((t|0)!=8){u=(f|0)!=0;if(t>>>0>3&u)if((t|0)==8)break;else{v=23;break}a:do if(!t){q=s;p=0;while(1){if((q|32|0)!=(a[3672744+p>>0]|0)){y=q;z=p;break a}do if(p>>>0<2){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;A=d[o>>0]|0;break}else{A=MDi(b)|0;break}}else A=q;while(0);o=p+1|0;if(o>>>0<3){q=A;p=o}else{y=A;z=o;break}}}else{y=s;z=t}while(0);if(!z){do if((y|0)==48){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;B=d[p>>0]|0}else B=MDi(b)|0;if((B|32|0)!=120){if(!(c[m>>2]|0)){C=48;break}c[e>>2]=(c[e>>2]|0)+-1;C=48;break}p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;D=d[p>>0]|0;E=0}else{D=MDi(b)|0;E=0}while(1){if((D|0)==46){F=E;v=70;break}else if((D|0)!=48){G=0;I=0;J=0;K=0;L=D;M=E;N=0;O=0;P=1.0;Q=0;R=0.0;break}p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;D=d[p>>0]|0;E=1;continue}else{D=MDi(b)|0;E=1;continue}}if((v|0)==70){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;T=d[p>>0]|0}else T=MDi(b)|0;if((T|0)==48){p=0;q=0;while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;U=d[o>>0]|0}else U=MDi(b)|0;o=_Ei(p|0,q|0,-1,-1)|0;n=H;if((U|0)==48){p=o;q=n}else{G=0;I=0;J=o;K=n;L=U;M=1;N=1;O=0;P=1.0;Q=0;R=0.0;break}}}else{G=0;I=0;J=0;K=0;L=T;M=F;N=1;O=0;P=1.0;Q=0;R=0.0}}b:while(1){q=L+-48|0;do if(q>>>0>=10){p=L|32;n=(L|0)==46;if(!((p+-97|0)>>>0<6|n)){V=I;W=J;X=G;Y=K;Z=L;_=M;$=N;aa=Q;ba=R;break b}if(n)if(!N){ca=I;fa=G;ga=I;ha=G;ia=M;ja=1;ka=O;la=P;ma=Q;na=R;break}else{V=I;W=J;X=G;Y=K;Z=46;_=M;$=N;aa=Q;ba=R;break b}else{oa=(L|0)>57?p+-87|0:q;v=83;break}}else{oa=q;v=83}while(0);if((v|0)==83){v=0;do if(!((G|0)<0|(G|0)==0&I>>>0<8)){if((G|0)<0|(G|0)==0&I>>>0<14){pa=P*.0625;qa=O;ra=pa;sa=Q;ta=R+pa*+(oa|0);break}if((oa|0)==0|(O|0)!=0){qa=O;ra=P;sa=Q;ta=R}else{qa=1;ra=P;sa=Q;ta=R+P*.5}}else{qa=O;ra=P;sa=oa+(Q<<4)|0;ta=R}while(0);q=_Ei(I|0,G|0,1,0)|0;ca=J;fa=K;ga=q;ha=H;ia=1;ja=N;ka=qa;la=ra;ma=sa;na=ta}q=c[e>>2]|0;if(q>>>0<(c[m>>2]|0)>>>0){c[e>>2]=q+1;G=ha;I=ga;J=ca;K=fa;L=d[q>>0]|0;M=ia;N=ja;O=ka;P=la;Q=ma;R=na;continue}else{G=ha;I=ga;J=ca;K=fa;L=MDi(b)|0;M=ia;N=ja;O=ka;P=la;Q=ma;R=na;continue}}if(!_){q=(c[m>>2]|0)==0;if(!q)c[e>>2]=(c[e>>2]|0)+-1;if(f){if(!q?(q=c[e>>2]|0,c[e>>2]=q+-1,($|0)!=0):0)c[e>>2]=q+-2}else LDi(b,0);l=+(r|0)*0.0;i=g;return +l}q=($|0)==0;p=q?V:W;n=q?X:Y;if((X|0)<0|(X|0)==0&V>>>0<8){q=V;o=X;ua=aa;while(1){va=ua<<4;q=_Ei(q|0,o|0,1,0)|0;o=H;if(!((o|0)<0|(o|0)==0&q>>>0<8)){wa=va;break}else ua=va}}else wa=aa;do if((Z|32|0)==112){ua=LEi(b,f)|0;q=H;if((ua|0)==0&(q|0)==-2147483648)if(!f){LDi(b,0);l=0.0;i=g;return +l}else{if(!(c[m>>2]|0)){xa=0;ya=0;break}c[e>>2]=(c[e>>2]|0)+-1;xa=0;ya=0;break}else{xa=ua;ya=q}}else if(!(c[m>>2]|0)){xa=0;ya=0}else{c[e>>2]=(c[e>>2]|0)+-1;xa=0;ya=0}while(0);q=cFi(p|0,n|0,2)|0;ua=_Ei(q|0,H|0,-32,-1)|0;q=_Ei(ua|0,H|0,xa|0,ya|0)|0;ua=H;if(!wa){l=+(r|0)*0.0;i=g;return +l}if((ua|0)>0|(ua|0)==0&q>>>0>(0-k|0)>>>0){c[(xd()|0)>>2]=34;l=+(r|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;i=g;return +l}o=k+-106|0;va=((o|0)<0)<<31>>31;if((ua|0)<(va|0)|(ua|0)==(va|0)&q>>>0<o>>>0){c[(xd()|0)>>2]=34;l=+(r|0)*2.2250738585072014e-308*2.2250738585072014e-308;i=g;return +l}if((wa|0)>-1){o=q;va=ua;za=wa;pa=ba;while(1){Aa=za<<1;if(!(pa>=.5)){Ba=pa;Ca=Aa}else{Ba=pa+-1.0;Ca=Aa|1}Da=pa+Ba;Aa=_Ei(o|0,va|0,-1,-1)|0;Ea=H;if((Ca|0)>-1){o=Aa;va=Ea;za=Ca;pa=Da}else{Fa=Aa;Ga=Ea;Ha=Ca;Ia=Da;break}}}else{Fa=q;Ga=ua;Ha=wa;Ia=ba}za=ZEi(32,0,k|0,((k|0)<0)<<31>>31|0)|0;va=_Ei(Fa|0,Ga|0,za|0,H|0)|0;za=H;if(0>(za|0)|0==(za|0)&j>>>0>va>>>0)if((va|0)<0){Ja=0;v=126}else{Ka=va;v=124}else{Ka=j;v=124}if((v|0)==124)if((Ka|0)<53){Ja=Ka;v=126}else{La=Ka;Ma=+(r|0);Na=0.0}if((v|0)==126){pa=+(r|0);La=Ja;Ma=pa;Na=+QDi(+fEi(1.0,84-Ja|0),pa)}va=(La|0)<32&Ia!=0.0&(Ha&1|0)==0;pa=Ma*(va?0.0:Ia)+(Na+Ma*+(((va&1)+Ha|0)>>>0))-Na;if(!(pa!=0.0))c[(xd()|0)>>2]=34;l=+gEi(pa,Fa);i=g;return +l}else C=y;while(0);va=k+j|0;za=0-va|0;o=C;n=0;while(1){if((o|0)==46){Oa=n;v=137;break}else if((o|0)!=48){Pa=o;Qa=0;Ra=0;Sa=n;Ta=0;break}p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;o=d[p>>0]|0;n=1;continue}else{o=MDi(b)|0;n=1;continue}}if((v|0)==137){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;Ua=d[n>>0]|0}else Ua=MDi(b)|0;if((Ua|0)==48){n=0;o=0;while(1){p=_Ei(n|0,o|0,-1,-1)|0;Ea=H;Aa=c[e>>2]|0;if(Aa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=Aa+1;Va=d[Aa>>0]|0}else Va=MDi(b)|0;if((Va|0)==48){n=p;o=Ea}else{Pa=Va;Qa=p;Ra=Ea;Sa=1;Ta=1;break}}}else{Pa=Ua;Qa=0;Ra=0;Sa=Oa;Ta=1}}c[h>>2]=0;o=Pa+-48|0;n=(Pa|0)==46;c:do if(o>>>0<10|n){Ea=h+496|0;p=Pa;Aa=0;Wa=0;Xa=n;Ya=o;Za=Qa;_a=Ra;$a=Sa;ab=Ta;bb=0;cb=0;db=0;d:while(1){do if(Xa)if(!ab){eb=Aa;fb=Wa;gb=Aa;hb=Wa;ib=$a;jb=1;kb=bb;lb=cb;mb=db}else{nb=Za;ob=_a;pb=Aa;qb=Wa;rb=$a;sb=bb;tb=cb;ub=db;break d}else{vb=_Ei(Aa|0,Wa|0,1,0)|0;wb=H;xb=(p|0)!=48;if((cb|0)>=125){if(!xb){eb=Za;fb=_a;gb=vb;hb=wb;ib=$a;jb=ab;kb=bb;lb=cb;mb=db;break}c[Ea>>2]=c[Ea>>2]|1;eb=Za;fb=_a;gb=vb;hb=wb;ib=$a;jb=ab;kb=bb;lb=cb;mb=db;break}yb=h+(cb<<2)|0;if(!bb)zb=Ya;else zb=p+-48+((c[yb>>2]|0)*10|0)|0;c[yb>>2]=zb;yb=bb+1|0;Ab=(yb|0)==9;eb=Za;fb=_a;gb=vb;hb=wb;ib=1;jb=ab;kb=Ab?0:yb;lb=(Ab&1)+cb|0;mb=xb?vb:db}while(0);vb=c[e>>2]|0;if(vb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=vb+1;Bb=d[vb>>0]|0}else Bb=MDi(b)|0;Ya=Bb+-48|0;Xa=(Bb|0)==46;if(!(Ya>>>0<10|Xa)){Cb=Bb;Db=gb;Eb=eb;Fb=hb;Gb=fb;Hb=ib;Ib=jb;Jb=kb;Kb=lb;Lb=mb;v=160;break c}else{p=Bb;Aa=gb;Wa=hb;Za=eb;_a=fb;$a=ib;ab=jb;bb=kb;cb=lb;db=mb}}Mb=pb;Nb=qb;Ob=nb;Pb=ob;Qb=(rb|0)!=0;Rb=sb;Sb=tb;Tb=ub;v=168}else{Cb=Pa;Db=0;Eb=Qa;Fb=0;Gb=Ra;Hb=Sa;Ib=Ta;Jb=0;Kb=0;Lb=0;v=160}while(0);do if((v|0)==160){o=(Ib|0)==0;n=o?Db:Eb;db=o?Fb:Gb;o=(Hb|0)!=0;if(!(o&(Cb|32|0)==101))if((Cb|0)>-1){Mb=Db;Nb=Fb;Ob=n;Pb=db;Qb=o;Rb=Jb;Sb=Kb;Tb=Lb;v=168;break}else{Ub=Db;Vb=Fb;Wb=o;Xb=n;Yb=db;Zb=Jb;_b=Kb;$b=Lb;v=170;break}o=LEi(b,f)|0;cb=H;do if((o|0)==0&(cb|0)==-2147483648)if(!f){LDi(b,0);l=0.0;i=g;return +l}else{if(!(c[m>>2]|0)){ac=0;bc=0;break}c[e>>2]=(c[e>>2]|0)+-1;ac=0;bc=0;break}else{ac=o;bc=cb}while(0);cb=_Ei(ac|0,bc|0,n|0,db|0)|0;cc=cb;dc=Db;ec=H;fc=Fb;gc=Jb;hc=Kb;ic=Lb}while(0);if((v|0)==168)if(c[m>>2]|0){c[e>>2]=(c[e>>2]|0)+-1;if(Qb){cc=Ob;dc=Mb;ec=Pb;fc=Nb;gc=Rb;hc=Sb;ic=Tb}else v=171}else{Ub=Mb;Vb=Nb;Wb=Qb;Xb=Ob;Yb=Pb;Zb=Rb;_b=Sb;$b=Tb;v=170}if((v|0)==170)if(Wb){cc=Xb;dc=Ub;ec=Yb;fc=Vb;gc=Zb;hc=_b;ic=$b}else v=171;if((v|0)==171){c[(xd()|0)>>2]=22;LDi(b,0);l=0.0;i=g;return +l}cb=c[h>>2]|0;if(!cb){l=+(r|0)*0.0;i=g;return +l}if((cc|0)==(dc|0)&(ec|0)==(fc|0)&((fc|0)<0|(fc|0)==0&dc>>>0<10)?j>>>0>30|(cb>>>j|0)==0:0){l=+(r|0)*+(cb>>>0);i=g;return +l}cb=(k|0)/-2|0;o=((cb|0)<0)<<31>>31;if((ec|0)>(o|0)|(ec|0)==(o|0)&cc>>>0>cb>>>0){c[(xd()|0)>>2]=34;l=+(r|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;i=g;return +l}cb=k+-106|0;o=((cb|0)<0)<<31>>31;if((ec|0)<(o|0)|(ec|0)==(o|0)&cc>>>0<cb>>>0){c[(xd()|0)>>2]=34;l=+(r|0)*2.2250738585072014e-308*2.2250738585072014e-308;i=g;return +l}if(!gc)jc=hc;else{if((gc|0)<9){cb=h+(hc<<2)|0;o=c[cb>>2]|0;bb=gc;while(1){ab=o*10|0;bb=bb+1|0;if((bb|0)==9){kc=ab;break}else o=ab}c[cb>>2]=kc}jc=hc+1|0}if((ic|0)<9?(ic|0)<=(cc|0)&(cc|0)<18:0){if((cc|0)==9){l=+(r|0)*+((c[h>>2]|0)>>>0);i=g;return +l}if((cc|0)<9){l=+(r|0)*+((c[h>>2]|0)>>>0)/+(c[3672048+(8-cc<<2)>>2]|0);i=g;return +l}o=j+27+(da(cc,-3)|0)|0;bb=c[h>>2]|0;if((o|0)>30|(bb>>>o|0)==0){l=+(r|0)*+(bb>>>0)*+(c[3672048+(cc+-10<<2)>>2]|0);i=g;return +l}}bb=(cc|0)%9|0;if(!bb){lc=0;mc=0;nc=cc;oc=jc}else{o=(cc|0)>-1?bb:bb+9|0;bb=c[3672048+(8-o<<2)>>2]|0;if(jc){ab=1e9/(bb|0)|0;$a=0;_a=0;Za=0;Wa=cc;while(1){Aa=h+(Za<<2)|0;p=c[Aa>>2]|0;Xa=((p>>>0)/(bb>>>0)|0)+_a|0;c[Aa>>2]=Xa;Aa=da((p>>>0)%(bb>>>0)|0,ab)|0;p=Za;Za=Za+1|0;if((p|0)==($a|0)&(Xa|0)==0){pc=Za&127;qc=Wa+-9|0}else{pc=$a;qc=Wa}if((Za|0)==(jc|0)){rc=Aa;sc=pc;tc=qc;break}else{$a=pc;_a=Aa;Wa=qc}}if(!rc){uc=sc;vc=tc;wc=jc}else{c[h+(jc<<2)>>2]=rc;uc=sc;vc=tc;wc=jc+1|0}}else{uc=0;vc=cc;wc=0}lc=uc;mc=0;nc=9-o+vc|0;oc=wc}e:while(1){Wa=h+(lc<<2)|0;if((nc|0)<18){_a=mc;$a=oc;while(1){Za=0;ab=$a+127|0;bb=$a;while(1){cb=ab&127;Aa=h+(cb<<2)|0;Xa=cFi(c[Aa>>2]|0,0,29)|0;p=_Ei(Xa|0,H|0,Za|0,0)|0;Xa=H;if(Xa>>>0>0|(Xa|0)==0&p>>>0>1e9){Ya=hFi(p|0,Xa|0,1e9,0)|0;Ea=iFi(p|0,Xa|0,1e9,0)|0;xc=Ea;yc=Ya}else{xc=p;yc=0}c[Aa>>2]=xc;Aa=(cb|0)==(lc|0);if((cb|0)!=(bb+127&127|0)|Aa)zc=bb;else zc=(xc|0)==0?cb:bb;if(Aa){Ac=yc;Bc=zc;break}else{Za=yc;ab=cb+-1|0;bb=zc}}bb=_a+-29|0;if(!Ac){_a=bb;$a=Bc}else{Cc=bb;Dc=Ac;Ec=Bc;break}}}else{if((nc|0)==18){Fc=mc;Gc=oc}else{Hc=lc;Ic=mc;Jc=nc;Kc=oc;break}while(1){if((c[Wa>>2]|0)>>>0>=9007199){Hc=lc;Ic=Fc;Jc=18;Kc=Gc;break e}$a=0;_a=Gc+127|0;db=Gc;while(1){n=_a&127;bb=h+(n<<2)|0;ab=cFi(c[bb>>2]|0,0,29)|0;Za=_Ei(ab|0,H|0,$a|0,0)|0;ab=H;if(ab>>>0>0|(ab|0)==0&Za>>>0>1e9){cb=hFi(Za|0,ab|0,1e9,0)|0;Aa=iFi(Za|0,ab|0,1e9,0)|0;Lc=Aa;Mc=cb}else{Lc=Za;Mc=0}c[bb>>2]=Lc;bb=(n|0)==(lc|0);if((n|0)!=(db+127&127|0)|bb)Nc=db;else Nc=(Lc|0)==0?n:db;if(bb){Oc=Mc;Pc=Nc;break}else{$a=Mc;_a=n+-1|0;db=Nc}}db=Fc+-29|0;if(!Oc){Fc=db;Gc=Pc}else{Cc=db;Dc=Oc;Ec=Pc;break}}}Wa=lc+127&127;if((Wa|0)==(Ec|0)){db=Ec+127&127;_a=h+((Ec+126&127)<<2)|0;c[_a>>2]=c[_a>>2]|c[h+(db<<2)>>2];Qc=db}else Qc=Ec;c[h+(Wa<<2)>>2]=Dc;lc=Wa;mc=Cc;nc=nc+9|0;oc=Qc}f:while(1){o=Kc+1&127;Wa=h+((Kc+127&127)<<2)|0;db=Hc;_a=Ic;$a=Jc;while(1){n=($a|0)==18;bb=($a|0)>27?9:1;Za=db;cb=_a;while(1){Aa=0;while(1){ab=Aa+Za&127;if((ab|0)==(Kc|0)){Rc=2;break}p=c[h+(ab<<2)>>2]|0;ab=c[3672040+(Aa<<2)>>2]|0;if(p>>>0<ab>>>0){Rc=2;break}Ya=Aa+1|0;if(p>>>0>ab>>>0){Rc=Aa;break}if((Ya|0)<2)Aa=Ya;else{Rc=Ya;break}}if((Rc|0)==2&n){Sc=o;Tc=Za;Uc=cb;Vc=Kc;break f}Aa=bb+cb|0;if((Za|0)==(Kc|0)){Za=Kc;cb=Aa}else{Wc=Aa;Xc=Za;break}}Za=(1<<bb)+-1|0;cb=1e9>>>bb;n=Xc;Aa=0;Ya=Xc;ab=$a;while(1){p=h+(Ya<<2)|0;Ea=c[p>>2]|0;Xa=(Ea>>>bb)+Aa|0;c[p>>2]=Xa;p=da(Ea&Za,cb)|0;Ea=(Ya|0)==(n|0)&(Xa|0)==0;Ya=Ya+1&127;Xa=Ea?ab+-9|0:ab;ua=Ea?Ya:n;if((Ya|0)==(Kc|0)){Yc=p;Zc=ua;_c=Xa;break}else{n=ua;Aa=p;ab=Xa}}if(!Yc){db=Zc;_a=Wc;$a=_c;continue}if((o|0)!=(Zc|0)){$c=Wc;ad=Yc;bd=Zc;cd=_c;break}c[Wa>>2]=c[Wa>>2]|1;db=Zc;_a=Wc;$a=_c}c[h+(Kc<<2)>>2]=ad;Hc=bd;Ic=$c;Jc=cd;Kc=o}$a=Tc&127;if(($a|0)==(Vc|0)){c[h+(Sc+-1<<2)>>2]=0;dd=Sc}else dd=Vc;pa=+((c[h+($a<<2)>>2]|0)>>>0);$a=Tc+1&127;if(($a|0)==(dd|0)){_a=dd+1&127;c[h+(_a+-1<<2)>>2]=0;ed=_a}else ed=dd;Da=+(r|0);fd=Da*(pa*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=Uc+53|0;_a=$a-k|0;if((_a|0)<(j|0))if((_a|0)<0){gd=0;hd=1;v=244}else{id=_a;jd=1;v=243}else{id=j;jd=0;v=243}if((v|0)==243)if((id|0)<53){gd=id;hd=jd;v=244}else{kd=id;ld=0.0;md=jd;nd=0.0;od=fd}if((v|0)==244){pa=+QDi(+fEi(1.0,105-gd|0),fd);pd=+YDi(fd,+fEi(1.0,53-gd|0));kd=gd;ld=pa;md=hd;nd=pd;od=pa+(fd-pd)}db=Tc+2&127;do if((db|0)==(ed|0))qd=nd;else{Wa=c[h+(db<<2)>>2]|0;do if(Wa>>>0>=5e8){if(Wa>>>0>5e8){rd=Da*.75+nd;break}if((Tc+3&127|0)==(ed|0)){rd=Da*.5+nd;break}else{rd=Da*.75+nd;break}}else{if((Wa|0)==0?(Tc+3&127|0)==(ed|0):0){rd=nd;break}rd=Da*.25+nd}while(0);if((53-kd|0)<=1){qd=rd;break}if(+YDi(rd,1.0)!=0.0){qd=rd;break}qd=rd+1.0}while(0);Da=od+qd-ld;do if(($a&2147483647|0)>(-2-va|0)){if(!(+S(+Da)>=9007199254740992.0)){sd=md;td=Uc;ud=Da}else{sd=(md|0)!=0&(kd|0)==(_a|0)?0:md;td=Uc+1|0;ud=Da*.5}if((td+50|0)<=(za|0)?!((sd|0)!=0&qd!=0.0):0){vd=td;wd=ud;break}c[(xd()|0)>>2]=34;vd=td;wd=ud}else{vd=Uc;wd=Da}while(0);l=+gEi(wd,vd);i=g;return +l}else if((z|0)==3){za=c[e>>2]|0;if(za>>>0<(c[m>>2]|0)>>>0){c[e>>2]=za+1;yd=d[za>>0]|0}else yd=MDi(b)|0;if((yd|0)==40)zd=1;else{if(!(c[m>>2]|0)){l=w;i=g;return +l}c[e>>2]=(c[e>>2]|0)+-1;l=w;i=g;return +l}while(1){za=c[e>>2]|0;if(za>>>0<(c[m>>2]|0)>>>0){c[e>>2]=za+1;Ad=d[za>>0]|0}else Ad=MDi(b)|0;if(!((Ad+-48|0)>>>0<10|(Ad+-65|0)>>>0<26)?!((Ad+-97|0)>>>0<26|(Ad|0)==95):0){Bd=Ad;Cd=zd;break}zd=zd+1|0}if((Bd|0)==41){l=w;i=g;return +l}za=(c[m>>2]|0)==0;if(!za)c[e>>2]=(c[e>>2]|0)+-1;if(!u){c[(xd()|0)>>2]=22;LDi(b,0);l=0.0;i=g;return +l}if((Cd|0)==0|za){l=w;i=g;return +l}else Dd=Cd;do{Dd=Dd+-1|0;c[e>>2]=(c[e>>2]|0)+-1}while((Dd|0)!=0);l=w;i=g;return +l}else{if(c[m>>2]|0)c[e>>2]=(c[e>>2]|0)+-1;c[(xd()|0)>>2]=22;LDi(b,0);l=0.0;i=g;return +l}}while(0);if((v|0)==23){v=(c[m>>2]|0)==0;if(!v)c[e>>2]=(c[e>>2]|0)+-1;if(!(t>>>0<4|(f|0)==0|v)){v=t;do{c[e>>2]=(c[e>>2]|0)+-1;v=v+-1|0}while(v>>>0>3)}}l=+ea(ea(r|0)*ea(x));i=g;return +l}function LDi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if(!((b|0)!=0&(g|0)>(b|0))){h=e;j=a+100|0;c[j>>2]=h;i=d;return}h=f+b|0;j=a+100|0;c[j>>2]=h;i=d;return}function MDi(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+104|0;g=c[f>>2]|0;if(!((g|0)!=0?(c[b+108>>2]|0)>=(g|0):0))h=3;if((h|0)==3?(h=pEi(b)|0,(h|0)>=0):0){g=c[f>>2]|0;f=c[b+8>>2]|0;if((g|0)!=0?(j=c[b+4>>2]|0,k=g-(c[b+108>>2]|0)+-1|0,(f-j|0)>(k|0)):0)c[b+100>>2]=j+k;else c[b+100>>2]=f;k=c[b+4>>2]|0;if(f){j=b+108|0;c[j>>2]=f+1-k+(c[j>>2]|0)}j=k+-1|0;if((d[j>>0]|0|0)==(h|0)){l=h;i=e;return l|0}a[j>>0]=h;l=h;i=e;return l|0}c[b+100>>2]=0;l=-1;i=e;return l|0}function NDi(a){a=+a;var b=0.0;b=+aa(+(a+-1416.0996898839683))*2247116418577894884661631.0e283*2247116418577894884661631.0e283;return +b}function ODi(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0;d=i;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;h[k>>3]=b;g=c[k+4>>2]&-2147483648|f&2147483647;c[k>>2]=e;c[k+4>>2]=g;b=+h[k>>3];i=d;return +b}function PDi(a,b){a=ea(a);b=ea(b);var d=0,e=0;d=i;e=(g[k>>2]=a,c[k>>2]|0);a=(c[k>>2]=(g[k>>2]=b,c[k>>2]|0)&-2147483648|e&2147483647,ea(g[k>>2]));i=d;return ea(a)}function QDi(a,b){a=+a;b=+b;var c=0,d=0.0;c=i;d=+ODi(a,b);i=c;return +d}function RDi(a){a=+a;var b=0,d=0,e=0,f=0.0,g=0.0;b=i;i=i+16|0;d=b;h[k>>3]=a;e=c[k+4>>2]&2147483647;c[k>>2]=c[k>>2];c[k+4>>2]=e;a=+h[k>>3];if(e>>>0<1072049730)if(e>>>0<1045430272){h[d>>3]=a+1329227995784915872903807.0e12;f=1.0;i=b;return +f}else{g=+TDi(a);f=g*g/((g+1.0)*2.0)+1.0;i=b;return +f}else if(e>>>0<1082535490){g=+aa(+a);f=(g+1.0/g)*.5;i=b;return +f}else{f=+NDi(a);i=b;return +f}return +(0.0)}function SDi(a){a=ea(a);var b=0,d=0,e=0,f=0,j=Im,l=0,m=Im,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=(g[k>>2]=a,c[k>>2]|0);f=e&2147483647;if(f>>>0>1123811328){if(e>>>0>1124073471&(e|0)>-1){j=ea(a*ea(1701411830000000029203285.0e14));i=b;return ea(j)}if((e|0)<0){l=e>>>0>3272998911;if(!((e&65535|0)==0&(l^1)))g[d>>2]=ea(ea(-1.40129846e-45)/a);if(l){j=ea(0.0);i=b;return ea(j)}}}else if(f>>>0<855638017){j=ea(a+ea(1.0));i=b;return ea(j)}m=ea(a+ea(786432.0));f=(g[k>>2]=m,c[k>>2]|0)+8|0;l=cFi((f>>>4)+1023|0,0,52)|0;d=H;n=+ea(a-ea(m+ea(-786432.0)));o=+h[3672080+((f&15)<<3)>>3];p=n*o;c[k>>2]=l;c[k+4>>2]=d;j=ea(+h[k>>3]*(o+(n*.24022650718688965+.6931471824645996)*p+(n*.009618354961276054+.055505409836769104)*(n*n*p)));i=b;return ea(j)}function TDi(a){a=+a;var b=0,d=0,e=0,f=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0;b=i;i=i+16|0;d=b;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;j=f&2147483647;l=VEi(e|0,f|0,63)|0;if(j>>>0>1078159481){m=f&2147483647;if(m>>>0>2146435072|(m|0)==2146435072&e>>>0>0){n=a;i=b;return +n}if(l){n=-1.0;i=b;return +n}if(a>709.782712893384){n=a*8988465674311579538646525.0e283;i=b;return +n}}if(j>>>0<=1071001154)if(j>>>0<1016070144){if(j>>>0>=1048576){n=a;i=b;return +n}g[d>>2]=ea(a);n=a;i=b;return +n}else{o=a;p=0.0;q=0}else{do if(j>>>0<1072734898)if(!l){r=a+-.6931471803691238;s=1;t=1.9082149292705877e-10;break}else{r=a+.6931471803691238;s=-1;t=-1.9082149292705877e-10;break}else{d=~~(a*1.4426950408889634+((l|0)!=0?-.5:.5));u=+(d|0);r=a-u*.6931471803691238;s=d;t=u*1.9082149292705877e-10}while(0);a=r-t;o=a;p=r-a-t;q=s}t=o*.5;a=o*t;r=a*(a*(a*(a*(a*-2.0109921818362437e-07+4.008217827329362e-06)+-7.93650757867488e-05)+1.5873015872548146e-03)+-.03333333333333313)+1.0;u=3.0-t*r;t=a*((r-u)/(6.0-o*u));if(!q){n=o-(o*t-a);i=b;return +n}u=o*(t-p)-p-a;if((q|0)==1)if(o<-.25){n=(u-(o+.5))*-2.0;i=b;return +n}else{n=(o-u)*2.0+1.0;i=b;return +n}else if((q|0)!=-1){s=cFi(q+1023|0,0,52)|0;l=H;c[k>>2]=s;c[k+4>>2]=l;a=+h[k>>3];if(q>>>0>56){p=o-u+1.0;if((q|0)==1024)v=p*2.0*8988465674311579538646525.0e283;else v=a*p;n=v+-1.0;i=b;return +n}else{l=cFi(1023-q|0,0,52)|0;s=H;if((q|0)<20){c[k>>2]=l;c[k+4>>2]=s;w=1.0-+h[k>>3]+(o-u)}else{c[k>>2]=l;c[k+4>>2]=s;w=o-(+h[k>>3]+u)+1.0}n=a*w;i=b;return +n}}else{n=(o-u)*.5+-.5;i=b;return +n}return +(0.0)}function UDi(a,b){a=ea(a);b=ea(b);var d=0,e=0,f=0,h=Im;d=i;e=(g[k>>2]=a,c[k>>2]|0);do if((e&2147483647)>>>0<=2139095040){f=(g[k>>2]=b,c[k>>2]|0);if((f&2147483647)>>>0<=2139095040)if((f^e|0)<0){h=(e|0)<0?b:a;break}else{h=a<b?b:a;break}else h=a}else h=b;while(0);i=d;return ea(h)}function VDi(a,b){a=ea(a);b=ea(b);var d=0,e=0,f=0,h=Im;d=i;e=(g[k>>2]=a,c[k>>2]|0);do if((e&2147483647)>>>0<=2139095040){f=(g[k>>2]=b,c[k>>2]|0);if((f&2147483647)>>>0<=2139095040)if((f^e|0)<0){h=(e|0)<0?a:b;break}else{h=a<b?a:b;break}else h=a}else h=b;while(0);i=d;return ea(h)}function WDi(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0;d=i;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;h[k>>3]=b;g=c[k>>2]|0;j=c[k+4>>2]|0;l=VEi(e|0,f|0,52)|0;m=l&2047;l=VEi(g|0,j|0,52)|0;n=l&2047;l=f&-2147483648;o=cFi(g|0,j|0,1)|0;p=H;if(!((o|0)==0&(p|0)==0)?(q=j&2147483647,!(q>>>0>2146435072|(q|0)==2146435072&g>>>0>0|(m|0)==2047)):0){q=cFi(e|0,f|0,1)|0;r=H;if(!(r>>>0>p>>>0|(r|0)==(p|0)&q>>>0>o>>>0)){if(!((q|0)==(o|0)&(r|0)==(p|0))){s=a;i=d;return +s}s=a*0.0;i=d;return +s}if(!m){p=cFi(e|0,f|0,12)|0;r=H;if((r|0)>-1|(r|0)==-1&p>>>0>4294967295){o=p;p=r;r=0;while(1){q=r+-1|0;o=cFi(o|0,p|0,1)|0;p=H;if(!((p|0)>-1|(p|0)==-1&o>>>0>4294967295)){t=q;break}else r=q}}else t=0;r=cFi(e|0,f|0,1-t|0)|0;u=r;v=H;w=t}else{u=e;v=f&1048575|1048576;w=m}if(!n){m=cFi(g|0,j|0,12)|0;f=H;if((f|0)>-1|(f|0)==-1&m>>>0>4294967295){e=m;m=f;f=0;while(1){t=f+-1|0;e=cFi(e|0,m|0,1)|0;m=H;if(!((m|0)>-1|(m|0)==-1&e>>>0>4294967295)){x=t;break}else f=t}}else x=0;f=cFi(g|0,j|0,1-x|0)|0;y=f;z=H;A=x}else{y=g;z=j&1048575|1048576;A=n}n=ZEi(u|0,v|0,y|0,z|0)|0;j=H;g=(j|0)>-1|(j|0)==-1&n>>>0>4294967295;a:do if((w|0)>(A|0)){x=g;f=n;e=j;m=u;t=v;r=w;while(1){if(x)if((m|0)==(y|0)&(t|0)==(z|0))break;else{B=f;C=e}else{B=m;C=t}o=cFi(B|0,C|0,1)|0;p=H;q=r+-1|0;D=ZEi(o|0,p|0,y|0,z|0)|0;E=H;F=(E|0)>-1|(E|0)==-1&D>>>0>4294967295;if((q|0)>(A|0)){x=F;f=D;e=E;m=o;t=p;r=q}else{G=F;I=o;J=p;K=D;L=E;M=q;break a}}s=a*0.0;i=d;return +s}else{G=g;I=u;J=v;K=n;L=j;M=w}while(0);if(G)if((I|0)==(y|0)&(J|0)==(z|0)){s=a*0.0;i=d;return +s}else{N=L;O=K}else{N=J;O=I}if(N>>>0<1048576|(N|0)==1048576&O>>>0<0){I=O;J=N;K=M;while(1){L=cFi(I|0,J|0,1)|0;z=H;y=K+-1|0;if(z>>>0<1048576|(z|0)==1048576&L>>>0<0){I=L;J=z;K=y}else{P=L;Q=z;R=y;break}}}else{P=O;Q=N;R=M}if((R|0)>0){M=_Ei(P|0,Q|0,0,-1048576)|0;N=H;O=cFi(R|0,0,52)|0;S=N|H;T=M|O}else{O=VEi(P|0,Q|0,1-R|0)|0;S=H;T=O}c[k>>2]=T;c[k+4>>2]=S|l;s=+h[k>>3];i=d;return +s}U=a*b;s=U/U;i=d;return +s}function XDi(a,b){a=ea(a);b=ea(b);var d=0,e=0,f=0,h=0,j=0,l=0,m=0,n=0,o=Im,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=Im;d=i;e=(g[k>>2]=a,c[k>>2]|0);f=(g[k>>2]=b,c[k>>2]|0);h=e>>>23&255;j=f>>>23&255;l=e&-2147483648;m=f<<1;if((m|0)!=0?!((f&2147483647)>>>0>2139095040|(h|0)==255):0){n=e<<1;if(n>>>0<=m>>>0){if((n|0)!=(m|0)){o=a;i=d;return ea(o)}o=ea(a*ea(0.0));i=d;return ea(o)}if(!h){m=e<<9;if((m|0)>-1){n=0;p=m;while(1){m=n+-1|0;p=p<<1;if((p|0)<=-1){q=m;break}else n=m}}else q=0;r=q;s=e<<1-q}else{r=h;s=e&8388607|8388608}if(!j){e=f<<9;if((e|0)>-1){h=0;q=e;while(1){e=h+-1|0;q=q<<1;if((q|0)<=-1){t=e;break}else h=e}}else t=0;u=t;v=f<<1-t}else{u=j;v=f&8388607|8388608}f=s-v|0;j=(f|0)>-1;a:do if((r|0)>(u|0)){t=j;h=f;q=r;e=s;while(1){if(t)if((e|0)==(v|0))break;else w=h;else w=e;n=w<<1;p=q+-1|0;m=n-v|0;x=(m|0)>-1;if((p|0)>(u|0)){t=x;h=m;q=p;e=n}else{y=m;z=x;A=p;B=n;break a}}o=ea(a*ea(0.0));i=d;return ea(o)}else{y=f;z=j;A=r;B=s}while(0);if(z)if((B|0)==(v|0)){o=ea(a*ea(0.0));i=d;return ea(o)}else C=y;else C=B;if(C>>>0<8388608){B=A;y=C;while(1){v=y<<1;z=B+-1|0;if(v>>>0<8388608){B=z;y=v}else{D=z;E=v;break}}}else{D=A;E=C}if((D|0)>0)F=E+-8388608|D<<23;else F=E>>>(1-D|0);o=(c[k>>2]=F|l,ea(g[k>>2]));i=d;return ea(o)}G=ea(a*b);o=ea(G/G);i=d;return ea(o)}function YDi(a,b){a=+a;b=+b;var c=0,d=0.0;c=i;d=+WDi(a,b);i=c;return +d}function ZDi(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0;d=i;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;g=VEi(e|0,f|0,52)|0;j=g&2047;if((j|0)==2047){l=a;i=d;return +l}else if(!j){if(a!=0.0){m=+ZDi(a*18446744073709551616.0,b);n=m;o=(c[b>>2]|0)+-64|0}else{n=a;o=0}c[b>>2]=o;l=n;i=d;return +l}else{c[b>>2]=j+-1022;c[k>>2]=e;c[k+4>>2]=f&-2146435073|1071644672;l=+h[k>>3];i=d;return +l}return +(0.0)}function _Di(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+ZDi(a,b);i=c;return +d}function $Di(a){a=+a;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0;b=i;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=(e|0)<0;do if(!(e>>>0<1048576|f)){if(e>>>0>2146435071){g=a;i=b;return +g}if((e|0)==1072693248&((d|0)==0&0==0)){g=0.0;i=b;return +g}else{j=d;l=e;m=e;n=-1023}}else{if((d|0)==0&(e&2147483647|0)==0){g=-1.0/(a*a);i=b;return +g}if(!f){h[k>>3]=a*18014398509481984.0;o=c[k+4>>2]|0;j=c[k>>2]|0;l=o;m=o;n=-1077;break}g=(a-a)/0.0;i=b;return +g}while(0);l=m+614242|0;c[k>>2]=j;c[k+4>>2]=(l&1048575)+1072079006;a=+h[k>>3]+-1.0;p=a*(a*.5);q=a/(a+2.0);r=q*q;s=r*r;h[k>>3]=a-p;j=c[k+4>>2]|0;c[k>>2]=0;c[k+4>>2]=j;t=+h[k>>3];u=q*(p+(s*(s*(s*.15313837699209373+.22222198432149784)+.3999999999940942)+r*(s*(s*(s*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+(a-t-p);p=t*.4342944818781689;a=+(n+(l>>>20)|0);s=a*.30102999566361177;r=s+p;g=r+(p+(s-r)+(u*.4342944818781689+(a*3.694239077158931e-13+(t+u)*2.5082946711645275e-11)));i=b;return +g}function aEi(a){a=ea(a);var b=0,d=0,e=0,f=Im,h=0,j=0,l=Im,m=Im,n=Im,o=Im,p=Im;b=i;d=(g[k>>2]=a,c[k>>2]|0);e=(d|0)<0;do if(!(d>>>0<8388608|e)){if(d>>>0>2139095039){f=a;i=b;return ea(f)}if((d|0)==1065353216){f=ea(0.0);i=b;return ea(f)}else{h=d;j=-127}}else{if(!(d&2147483647)){f=ea(ea(-1.0)/ea(a*a));i=b;return ea(f)}if(!e){l=ea(a*ea(33554432.0));h=(g[k>>2]=l,c[k>>2]|0);j=-152;break}f=ea(ea(a-a)/ea(0.0));i=b;return ea(f)}while(0);e=h+4913933|0;a=ea((c[k>>2]=(e&8388607)+1060439283,ea(g[k>>2]))+ea(-1.0));l=ea(a/ea(a+ea(2.0)));m=ea(l*l);n=ea(m*m);o=ea(ea(m*ea(ea(n*ea(.284987867))+ea(.666666627)))+ea(n*ea(ea(n*ea(.242790788))+ea(.400009722))));n=ea(a*ea(a*ea(.5)));m=ea(a-n);p=(c[k>>2]=(g[k>>2]=m,c[k>>2]|0)&-4096,ea(g[k>>2]));m=ea(ea(l*ea(n+o))+ea(ea(a-p)-n));n=ea(j+(e>>>23)|0);f=ea(ea(n*ea(.301029205))+ea(ea(p*ea(.434326172))+ea(ea(m*ea(.434326172))+ea(ea(n*ea(7.90341517e-07))+ea(ea(p+m)*ea(-.0000316899714))))));i=b;return ea(f)}function bEi(a){a=ea(a);var b=0,d=0,e=0,f=Im,h=0,j=0,l=Im,m=Im,n=Im,o=Im,p=Im;b=i;d=(g[k>>2]=a,c[k>>2]|0);e=(d|0)<0;do if(!(d>>>0<8388608|e)){if(d>>>0>2139095039){f=a;i=b;return ea(f)}if((d|0)==1065353216){f=ea(0.0);i=b;return ea(f)}else{h=d;j=-127}}else{if(!(d&2147483647)){f=ea(ea(-1.0)/ea(a*a));i=b;return ea(f)}if(!e){l=ea(a*ea(33554432.0));h=(g[k>>2]=l,c[k>>2]|0);j=-152;break}f=ea(ea(a-a)/ea(0.0));i=b;return ea(f)}while(0);e=h+4913933|0;a=ea((c[k>>2]=(e&8388607)+1060439283,ea(g[k>>2]))+ea(-1.0));l=ea(a/ea(a+ea(2.0)));m=ea(l*l);n=ea(m*m);o=ea(ea(m*ea(ea(n*ea(.284987867))+ea(.666666627)))+ea(n*ea(ea(n*ea(.242790788))+ea(.400009722))));n=ea(a*ea(a*ea(.5)));m=ea(a-n);p=(c[k>>2]=(g[k>>2]=m,c[k>>2]|0)&-4096,ea(g[k>>2]));m=ea(ea(l*ea(n+o))+ea(ea(a-p)-n));f=ea(ea(j+(e>>>23)|0)+ea(ea(p*ea(1.44287109))+ea(ea(m*ea(1.44287109))+ea(ea(p+m)*ea(-.000176052854)))));i=b;return ea(f)}function cEi(a,b){a=ea(a);b=b|0;var d=0,e=0,f=0,h=Im,j=0,l=Im;d=i;e=(g[k>>2]=a,c[k>>2]|0);f=(e>>>23&255)+-127|0;if((f|0)>22){g[b>>2]=a;if(!((f|0)!=128|(e&8388607|0)==0)){h=a;i=d;return ea(h)}h=(c[k>>2]=e&-2147483648,ea(g[k>>2]));i=d;return ea(h)}if((f|0)<0){g[b>>2]=(c[k>>2]=e&-2147483648,ea(g[k>>2]));h=a;i=d;return ea(h)}j=8388607>>>f;if(!(j&e)){g[b>>2]=a;h=(c[k>>2]=e&-2147483648,ea(g[k>>2]));i=d;return ea(h)}else{l=(c[k>>2]=e&~j,ea(g[k>>2]));g[b>>2]=l;h=ea(a-l);i=d;return ea(h)}return ea(0.0)}function dEi(a){a=+a;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0;b=i;i=i+16|0;h[k>>3]=a;d=c[k+4>>2]|0;e=VEi(c[k>>2]|0,d|0,52)|0;f=e&2047;if(f>>>0>1074){g=a;i=b;return +g}e=(d|0)<0;if(e)j=-a;else j=a;l=j+4503599627370496.0;if(f>>>0<1022){h[b>>3]=l;g=a*0.0;i=b;return +g}a=l+-4503599627370496.0-j;if(!(a>.5)){l=j+a;if(!(a<=-.5))m=l;else m=l+1.0}else m=j+a+-1.0;if(!e){g=m;i=b;return +g}g=-m;i=b;return +g}function eEi(a){a=ea(a);var b=0,d=0,e=0,f=Im,h=0,j=Im,l=Im,m=Im;b=i;i=i+16|0;d=(g[k>>2]=a,c[k>>2]|0);e=d>>>23&255;if(e>>>0>149){f=a;i=b;return ea(f)}h=(d|0)<0;if(h)j=ea(-a);else j=a;l=ea(j+ea(8388608.0));if(e>>>0<126){g[b>>2]=l;f=ea(a*ea(0.0));i=b;return ea(f)}a=ea(ea(l+ea(-8388608.0))-j);if(!(a>ea(.5))){l=ea(j+a);if(!(a<=ea(-.5)))m=l;else m=ea(l+ea(1.0))}else m=ea(ea(j+a)+ea(-1.0));if(!h){f=m;i=b;return ea(f)}f=ea(-m);i=b;return ea(f)}function fEi(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0,l=0.0;d=i;if((b|0)>1023){e=a*8988465674311579538646525.0e283;f=b+-1023|0;if((f|0)>1023){g=b+-2046|0;j=(g|0)>1023?1023:g;l=e*8988465674311579538646525.0e283}else{j=f;l=e}}else if((b|0)<-1022){e=a*2.2250738585072014e-308;f=b+1022|0;if((f|0)<-1022){g=b+2044|0;j=(g|0)<-1022?-1022:g;l=e*2.2250738585072014e-308}else{j=f;l=e}}else{j=b;l=a}b=cFi(j+1023|0,0,52)|0;j=H;c[k>>2]=b;c[k+4>>2]=j;a=l*+h[k>>3];i=d;return +a}function gEi(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+fEi(a,b);i=c;return +d}function hEi(a){a=+a;var b=0,d=0,e=0.0,f=0,g=0.0,j=0.0,l=0.0;b=i;h[k>>3]=a;d=c[k+4>>2]|0;e=(d|0)<0?-.5:.5;f=d&2147483647;c[k>>2]=c[k>>2];c[k+4>>2]=f;g=+h[k>>3];if(f>>>0>=1082535490){j=e*2.0*+NDi(g);i=b;return +j}l=+TDi(g);if(f>>>0>=1072693248){j=e*(l+l/(l+1.0));i=b;return +j}if(f>>>0<1045430272){j=a;i=b;return +j}j=e*(l*2.0-l*l/(l+1.0));i=b;return +j}function iEi(a){a=+a;var b=0,d=0,e=0,f=0,j=0.0,l=0.0,m=0.0;b=i;i=i+16|0;d=b;h[k>>3]=a;e=c[k+4>>2]|0;f=e&2147483647;c[k>>2]=c[k>>2];c[k+4>>2]=f;a=+h[k>>3];do if(f>>>0>1071748074)if(f>>>0>1077149696){j=1.0-0.0/a;break}else{j=1.0-2.0/(+TDi(a*2.0)+2.0);break}else{if(f>>>0>1070618798){l=+TDi(a*2.0);j=l/(l+2.0);break}if(f>>>0>1048575){l=+TDi(a*-2.0);j=-l/(l+2.0);break}else{g[d>>2]=ea(a);j=a;break}}while(0);if((e|0)>=0){m=j;i=b;return +m}m=-j;i=b;return +m}function jEi(a){a=ea(a);var b=0,d=0,e=0,f=Im,h=0;b=i;i=i+16|0;d=(g[k>>2]=a,c[k>>2]|0);e=(d>>>23&255)+-118|0;if((e|0)>31){f=a;i=b;return ea(f)}h=(e|0)<9?2147483647:-1>>>e;if(!(h&d)){f=a;i=b;return ea(f)}g[b>>2]=ea(a+ea(1.329228e+36));f=(c[k>>2]=d&~h,ea(g[k>>2]));i=b;return ea(f)}function kEi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(!a)d=0;else d=lEi(a,b,0)|0;i=c;return d|0}function lEi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if(!b){f=1;i=e;return f|0}if(d>>>0<128){a[b>>0]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;f=3;i=e;return f|0}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;f=4;i=e;return f|0}else{c[(xd()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function mEi(){var a=0,b=0,d=0,e=0;a=i;b=3672208;d=gFi(c[b>>2]|0,c[b+4>>2]|0,1284865837,1481765933)|0;b=_Ei(d|0,H|0,1,0)|0;d=H;e=3672208;c[e>>2]=b;c[e+4>>2]=d;e=VEi(b|0,d|0,33)|0;i=a;return e|0}function nEi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+74|0;f=a[e>>0]|0;a[e>>0]=f+255|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0)xo[c[b+36>>2]&2047](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=c[b>>2]|0;if(!(f&20)){g=c[e>>2]|0;c[b+8>>2]=g;c[b+4>>2]=g;h=0;i=d;return h|0}if(!(f&4)){h=-1;i=d;return h|0}c[b>>2]=f|32;h=-1;i=d;return h|0}function oEi(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+74|0;f=a[e>>0]|0;a[e>>0]=f+255|f;f=c[b>>2]|0;if(!(f&8)){c[b+8>>2]=0;c[b+4>>2]=0;e=c[b+44>>2]|0;c[b+28>>2]=e;c[b+20>>2]=e;c[b+16>>2]=e+(c[b+48>>2]|0);g=0;i=d;return g|0}else{c[b>>2]=f|32;g=-1;i=d;return g|0}return 0}function pEi(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b;if((c[a+8>>2]|0)==0?(nEi(a)|0)!=0:0)f=-1;else if((xo[c[a+32>>2]&2047](a,e,1)|0)==1)f=d[e>>0]|0;else f=-1;i=b;return f|0}function qEi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;g=e+16|0;h=c[g>>2]|0;do if(!h)if(!(oEi(e)|0)){j=c[g>>2]|0;break}else{k=0;i=f;return k|0}else j=h;while(0);h=e+20|0;g=c[h>>2]|0;if((j-g|0)>>>0<d>>>0){k=xo[c[e+36>>2]&2047](e,b,d)|0;i=f;return k|0}a:do if((a[e+75>>0]|0)>-1){j=d;while(1){if(!j){l=d;m=b;n=g;o=0;break a}p=j+-1|0;if((a[b+p>>0]|0)==10){q=j;break}else j=p}if((xo[c[e+36>>2]&2047](e,b,q)|0)>>>0<q>>>0){k=q;i=f;return k|0}else{l=d-q|0;m=b+q|0;n=c[h>>2]|0;o=q;break}}else{l=d;m=b;n=g;o=0}while(0);YEi(n|0,m|0,l|0)|0;c[h>>2]=(c[h>>2]|0)+l;k=o+l|0;i=f;return k|0}function rEi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=uEi(a,b,d,g)|0;i=f;return e|0}function sEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=vEi(a,b,f)|0;i=e;return d|0}function tEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+224|0;f=e+120|0;g=e+80|0;h=e;j=e+136|0;k=g+0|0;l=k+40|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));c[f>>2]=c[d>>2];if((MEi(0,b,f,h,g)|0)<0){m=-1;i=e;return m|0}d=a+48|0;if(!(c[d>>2]|0)){k=a+44|0;l=c[k>>2]|0;c[k>>2]=j;n=a+28|0;c[n>>2]=j;o=a+20|0;c[o>>2]=j;c[d>>2]=80;p=a+16|0;c[p>>2]=j+80;j=MEi(a,b,f,h,g)|0;if(!l)q=j;else{xo[c[a+36>>2]&2047](a,0,0)|0;r=(c[o>>2]|0)==0?-1:j;c[k>>2]=l;c[d>>2]=0;c[p>>2]=0;c[n>>2]=0;c[o>>2]=0;q=r}}else q=MEi(a,b,f,h,g)|0;m=q;i=e;return m|0}function uEi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+128|0;h=g+112|0;j=g;k=j+0|0;l=3672784|0;m=k+112|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));if((d+-1|0)>>>0>2147483646)if(!d){n=h;o=1}else{c[(xd()|0)>>2]=75;p=-1;i=g;return p|0}else{n=b;o=d}d=-2-n|0;b=o>>>0>d>>>0?d:o;c[j+48>>2]=b;o=j+20|0;c[o>>2]=n;c[j+44>>2]=n;d=n+b|0;n=j+16|0;c[n>>2]=d;c[j+28>>2]=d;d=tEi(j,e,f)|0;if(!b){p=d;i=g;return p|0}b=c[o>>2]|0;a[b+(((b|0)==(c[n>>2]|0))<<31>>31)>>0]=0;p=d;i=g;return p|0}function vEi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=uEi(a,2147483647,b,c)|0;i=d;return e|0}function wEi(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=i;d=b;while(1){b=d+1|0;if(!(FDi(a[d>>0]|0)|0)){e=d;f=b;break}else d=b}d=a[e>>0]|0;b=d<<24>>24;if((b|0)==43){g=0;h=5}else if((b|0)==45){g=1;h=5}else{j=e;k=d;l=0}if((h|0)==5){j=f;k=a[f>>0]|0;l=g}if(!(EDi(k<<24>>24)|0)){m=0;n=(l|0)!=0;o=0-m|0;p=n?m:o;i=c;return p|0}else{q=j;r=0}while(1){j=(r*10|0)+48-(a[q>>0]|0)|0;q=q+1|0;if(!(EDi(a[q>>0]|0)|0)){m=j;break}else r=j}n=(l|0)!=0;o=0-m|0;p=n?m:o;i=c;return p|0}function xEi(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=i;d=b;while(1){b=d+1|0;if(!(FDi(a[d>>0]|0)|0)){e=d;f=b;break}else d=b}d=a[e>>0]|0;b=d<<24>>24;if((b|0)==45){g=1;h=5}else if((b|0)==43){g=0;h=5}else{j=e;k=d;l=0}if((h|0)==5){j=f;k=a[f>>0]|0;l=g}if(!(EDi(k<<24>>24)|0)){m=0;n=(l|0)!=0;o=0-m|0;p=n?m:o;i=c;return p|0}else{q=j;r=0}while(1){j=(r*10|0)+48-(a[q>>0]|0)|0;q=q+1|0;if(!(EDi(a[q>>0]|0)|0)){m=j;break}else r=j}n=(l|0)!=0;o=0-m|0;p=n?m:o;i=c;return p|0}function yEi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;LDi(e,0);h=+KDi(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if(!b){i=d;return +h}if(!j)k=a;else k=a+j|0;c[b>>2]=k;i=d;return +h}function zEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;LDi(e,0);h=+KDi(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if(!b){i=d;return +h}if(!j)k=a;else k=a+j|0;c[b>>2]=k;i=d;return +h}function AEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+112|0;f=e;c[f>>2]=0;g=f+4|0;c[g>>2]=a;c[f+44>>2]=a;h=f+8|0;c[h>>2]=(a|0)<0?-1:a+2147483647|0;c[f+76>>2]=-1;LDi(f,0);j=JDi(f,d,1,-1,-1)|0;d=H;if(!b){H=d;i=e;return j|0}c[b>>2]=a+((c[g>>2]|0)+(c[f+108>>2]|0)-(c[h>>2]|0));H=d;i=e;return j|0}function BEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+112|0;f=e;c[f>>2]=0;g=f+4|0;c[g>>2]=a;c[f+44>>2]=a;h=f+8|0;c[h>>2]=(a|0)<0?-1:a+2147483647|0;c[f+76>>2]=-1;LDi(f,0);j=JDi(f,d,1,0,-2147483648)|0;d=H;if(!b){H=d;i=e;return j|0}c[b>>2]=a+((c[g>>2]|0)+(c[f+108>>2]|0)-(c[h>>2]|0));H=d;i=e;return j|0}function CEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+112|0;f=e;c[f>>2]=0;g=f+4|0;c[g>>2]=a;c[f+44>>2]=a;h=f+8|0;c[h>>2]=(a|0)<0?-1:a+2147483647|0;c[f+76>>2]=-1;LDi(f,0);j=JDi(f,d,1,-1,0)|0;if(!b){i=e;return j|0}c[b>>2]=a+((c[g>>2]|0)+(c[f+108>>2]|0)-(c[h>>2]|0));i=e;return j|0}function DEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+112|0;f=e;c[f>>2]=0;g=f+4|0;c[g>>2]=a;c[f+44>>2]=a;h=f+8|0;c[h>>2]=(a|0)<0?-1:a+2147483647|0;c[f+76>>2]=-1;LDi(f,0);j=JDi(f,d,1,-2147483648,0)|0;if(!b){i=e;return j|0}c[b>>2]=a+((c[g>>2]|0)+(c[f+108>>2]|0)-(c[h>>2]|0));i=e;return j|0}
function EEi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=d&255;h=(e|0)!=0;a:do if((b&3|0)!=0&h){j=d&255;k=e;l=b;while(1){if((a[l>>0]|0)==j<<24>>24){m=k;n=l;o=6;break a}p=l+1|0;q=k+-1|0;r=(q|0)!=0;if((p&3|0)!=0&r){k=q;l=p}else{s=q;t=r;u=p;o=5;break}}}else{s=e;t=h;u=b;o=5}while(0);if((o|0)==5)if(t){m=s;n=u;o=6}else{v=0;w=u}b:do if((o|0)==6){u=d&255;if((a[n>>0]|0)!=u<<24>>24){s=da(g,16843009)|0;c:do if(m>>>0>3){t=m;b=n;while(1){h=c[b>>2]^s;if((h&-2139062144^-2139062144)&h+-16843009){x=t;y=b;break c}h=b+4|0;e=t+-4|0;if(e>>>0>3){t=e;b=h}else{x=e;y=h;break}}}else{x=m;y=n}while(0);if(!x){v=0;w=y}else{s=x;b=y;while(1){if((a[b>>0]|0)==u<<24>>24){v=s;w=b;break b}t=b+1|0;s=s+-1|0;if(!s){v=0;w=t;break}else b=t}}}else{v=m;w=n}}while(0);i=f;return ((v|0)!=0?w:0)|0}function FEi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;a:do if(!d)f=0;else{g=d;h=b;j=c;while(1){k=a[h>>0]|0;l=a[j>>0]|0;if(k<<24>>24!=l<<24>>24){m=k;n=l;break}g=g+-1|0;if(!g){f=0;break a}else{h=h+1|0;j=j+1|0}}f=(m&255)-(n&255)|0}while(0);i=e;return f|0}function GEi(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;f=a[b>>0]|0;a:do if(!(f<<24>>24)){g=0;h=c}else{j=f;k=f&255;l=b;m=c;while(1){n=a[m>>0]|0;if(!(n<<24>>24)){g=j;h=m;break a}if(j<<24>>24!=n<<24>>24?(n=IDi(k)|0,(n|0)!=(IDi(d[m>>0]|0)|0)):0){o=l;p=m;break}l=l+1|0;n=m+1|0;q=a[l>>0]|0;if(!(q<<24>>24)){g=0;h=n;break a}else{j=q;k=q&255;m=n}}g=a[o>>0]|0;h=p}while(0);p=IDi(g&255)|0;g=p-(IDi(d[h>>0]|0)|0)|0;i=e;return g|0}function HEi(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a[b>>0]|0;f=a[c>>0]|0;if(e<<24>>24==0?1:e<<24>>24!=f<<24>>24){g=e;h=f}else{f=b;b=c;do{f=f+1|0;b=b+1|0;c=a[f>>0]|0;e=a[b>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24));g=c;h=e}i=d;return (g&255)-(h&255)|0}function IEi(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if(!e){g=0;i=f;return g|0}h=a[b>>0]|0;a:do if(!(h<<24>>24)){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){l=l+-1|0;p=a[o>>0]|0;if(!(p<<24>>24!=0&(l|0)!=0&m<<24>>24==p<<24>>24)){j=m;k=o;break a}n=n+1|0;p=o+1|0;m=a[n>>0]|0;if(!(m<<24>>24)){j=0;k=p;break}else o=p}}while(0);g=(j&255)-(d[k>>0]|0)|0;i=f;return g|0}function JEi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a+g|0;j=c[917816]|0;k=f&3;if(!((k|0)!=1&a>>>0>=j>>>0&a>>>0<h>>>0))Vl();l=a+(g|4)|0;m=c[l>>2]|0;if(!(m&1))Vl();if(!k){if(b>>>0<256){n=0;i=d;return n|0}if(g>>>0>=(b+4|0)>>>0?(g-b|0)>>>0<=c[917932]<<1>>>0:0){n=a;i=d;return n|0}n=0;i=d;return n|0}if(g>>>0>=b>>>0){k=g-b|0;if(k>>>0<=15){n=a;i=d;return n|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=k|3;c[l>>2]=c[l>>2]|1;KEi(a+b|0,k);n=a;i=d;return n|0}if((h|0)==(c[917818]|0)){k=(c[917815]|0)+g|0;if(k>>>0<=b>>>0){n=0;i=d;return n|0}l=k-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=l|1;c[917818]=a+b;c[917815]=l;n=a;i=d;return n|0}if((h|0)==(c[917817]|0)){l=(c[917814]|0)+g|0;if(l>>>0<b>>>0){n=0;i=d;return n|0}k=l-b|0;if(k>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=k|1;c[a+l>>2]=k;o=a+(l+4)|0;c[o>>2]=c[o>>2]&-2;p=a+b|0;q=k}else{c[e>>2]=f&1|l|2;k=a+(l+4)|0;c[k>>2]=c[k>>2]|1;p=0;q=0}c[917814]=q;c[917817]=p;n=a;i=d;return n|0}if(m&2){n=0;i=d;return n|0}p=(m&-8)+g|0;if(p>>>0<b>>>0){n=0;i=d;return n|0}q=p-b|0;k=m>>>3;do if(m>>>0>=256){l=c[a+(g+24)>>2]|0;o=c[a+(g+12)>>2]|0;do if((o|0)==(h|0)){r=a+(g+20)|0;s=c[r>>2]|0;if(!s){t=a+(g+16)|0;u=c[t>>2]|0;if(!u){v=0;break}else{w=u;x=t}}else{w=s;x=r}while(1){r=w+20|0;s=c[r>>2]|0;if(s){w=s;x=r;continue}r=w+16|0;s=c[r>>2]|0;if(!s){y=w;z=x;break}else{w=s;x=r}}if(z>>>0<j>>>0)Vl();else{c[z>>2]=0;v=y;break}}else{r=c[a+(g+8)>>2]|0;if(r>>>0<j>>>0)Vl();s=r+12|0;if((c[s>>2]|0)!=(h|0))Vl();t=o+8|0;if((c[t>>2]|0)==(h|0)){c[s>>2]=o;c[t>>2]=r;v=o;break}else Vl()}while(0);if(l){o=c[a+(g+28)>>2]|0;r=3671552+(o<<2)|0;if((h|0)==(c[r>>2]|0)){c[r>>2]=v;if(!v){c[917813]=c[917813]&~(1<<o);break}}else{if(l>>>0<(c[917816]|0)>>>0)Vl();o=l+16|0;if((c[o>>2]|0)==(h|0))c[o>>2]=v;else c[l+20>>2]=v;if(!v)break}o=c[917816]|0;if(v>>>0<o>>>0)Vl();c[v+24>>2]=l;r=c[a+(g+16)>>2]|0;do if(r)if(r>>>0<o>>>0)Vl();else{c[v+16>>2]=r;c[r+24>>2]=v;break}while(0);r=c[a+(g+20)>>2]|0;if(r)if(r>>>0<(c[917816]|0)>>>0)Vl();else{c[v+20>>2]=r;c[r+24>>2]=v;break}}}else{r=c[a+(g+8)>>2]|0;o=c[a+(g+12)>>2]|0;l=3671288+(k<<1<<2)|0;if((r|0)!=(l|0)){if(r>>>0<j>>>0)Vl();if((c[r+12>>2]|0)!=(h|0))Vl()}if((o|0)==(r|0)){c[917812]=c[917812]&~(1<<k);break}if((o|0)!=(l|0)){if(o>>>0<j>>>0)Vl();l=o+8|0;if((c[l>>2]|0)==(h|0))A=l;else Vl()}else A=o+8|0;c[r+12>>2]=o;c[A>>2]=r}while(0);if(q>>>0<16){c[e>>2]=p|f&1|2;A=a+(p|4)|0;c[A>>2]=c[A>>2]|1;n=a;i=d;return n|0}else{c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=q|3;f=a+(p|4)|0;c[f>>2]=c[f>>2]|1;KEi(a+b|0,q);n=a;i=d;return n|0}return 0}function KEi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=c[a+4>>2]|0;do if(!(f&1)){g=c[a>>2]|0;if(!(f&3)){i=d;return}h=a+(0-g)|0;j=g+b|0;k=c[917816]|0;if(h>>>0<k>>>0)Vl();if((h|0)==(c[917817]|0)){l=a+(b+4)|0;m=c[l>>2]|0;if((m&3|0)!=3){n=h;o=j;break}c[917814]=j;c[l>>2]=m&-2;c[a+(4-g)>>2]=j|1;c[e>>2]=j;i=d;return}m=g>>>3;if(g>>>0<256){l=c[a+(8-g)>>2]|0;p=c[a+(12-g)>>2]|0;q=3671288+(m<<1<<2)|0;if((l|0)!=(q|0)){if(l>>>0<k>>>0)Vl();if((c[l+12>>2]|0)!=(h|0))Vl()}if((p|0)==(l|0)){c[917812]=c[917812]&~(1<<m);n=h;o=j;break}if((p|0)!=(q|0)){if(p>>>0<k>>>0)Vl();q=p+8|0;if((c[q>>2]|0)==(h|0))r=q;else Vl()}else r=p+8|0;c[l+12>>2]=p;c[r>>2]=l;n=h;o=j;break}l=c[a+(24-g)>>2]|0;p=c[a+(12-g)>>2]|0;do if((p|0)==(h|0)){q=16-g|0;m=a+(q+4)|0;s=c[m>>2]|0;if(!s){t=a+q|0;q=c[t>>2]|0;if(!q){u=0;break}else{v=q;w=t}}else{v=s;w=m}while(1){m=v+20|0;s=c[m>>2]|0;if(s){v=s;w=m;continue}m=v+16|0;s=c[m>>2]|0;if(!s){x=v;y=w;break}else{v=s;w=m}}if(y>>>0<k>>>0)Vl();else{c[y>>2]=0;u=x;break}}else{m=c[a+(8-g)>>2]|0;if(m>>>0<k>>>0)Vl();s=m+12|0;if((c[s>>2]|0)!=(h|0))Vl();t=p+8|0;if((c[t>>2]|0)==(h|0)){c[s>>2]=p;c[t>>2]=m;u=p;break}else Vl()}while(0);if(l){p=c[a+(28-g)>>2]|0;k=3671552+(p<<2)|0;if((h|0)==(c[k>>2]|0)){c[k>>2]=u;if(!u){c[917813]=c[917813]&~(1<<p);n=h;o=j;break}}else{if(l>>>0<(c[917816]|0)>>>0)Vl();p=l+16|0;if((c[p>>2]|0)==(h|0))c[p>>2]=u;else c[l+20>>2]=u;if(!u){n=h;o=j;break}}p=c[917816]|0;if(u>>>0<p>>>0)Vl();c[u+24>>2]=l;k=16-g|0;m=c[a+k>>2]|0;do if(m)if(m>>>0<p>>>0)Vl();else{c[u+16>>2]=m;c[m+24>>2]=u;break}while(0);m=c[a+(k+4)>>2]|0;if(m)if(m>>>0<(c[917816]|0)>>>0)Vl();else{c[u+20>>2]=m;c[m+24>>2]=u;n=h;o=j;break}else{n=h;o=j}}else{n=h;o=j}}else{n=a;o=b}while(0);u=c[917816]|0;if(e>>>0<u>>>0)Vl();x=a+(b+4)|0;y=c[x>>2]|0;if(!(y&2)){if((e|0)==(c[917818]|0)){w=(c[917815]|0)+o|0;c[917815]=w;c[917818]=n;c[n+4>>2]=w|1;if((n|0)!=(c[917817]|0)){i=d;return}c[917817]=0;c[917814]=0;i=d;return}if((e|0)==(c[917817]|0)){w=(c[917814]|0)+o|0;c[917814]=w;c[917817]=n;c[n+4>>2]=w|1;c[n+w>>2]=w;i=d;return}w=(y&-8)+o|0;v=y>>>3;do if(y>>>0>=256){r=c[a+(b+24)>>2]|0;f=c[a+(b+12)>>2]|0;do if((f|0)==(e|0)){m=a+(b+20)|0;p=c[m>>2]|0;if(!p){g=a+(b+16)|0;l=c[g>>2]|0;if(!l){z=0;break}else{A=l;B=g}}else{A=p;B=m}while(1){m=A+20|0;p=c[m>>2]|0;if(p){A=p;B=m;continue}m=A+16|0;p=c[m>>2]|0;if(!p){C=A;D=B;break}else{A=p;B=m}}if(D>>>0<u>>>0)Vl();else{c[D>>2]=0;z=C;break}}else{m=c[a+(b+8)>>2]|0;if(m>>>0<u>>>0)Vl();p=m+12|0;if((c[p>>2]|0)!=(e|0))Vl();g=f+8|0;if((c[g>>2]|0)==(e|0)){c[p>>2]=f;c[g>>2]=m;z=f;break}else Vl()}while(0);if(r){f=c[a+(b+28)>>2]|0;j=3671552+(f<<2)|0;if((e|0)==(c[j>>2]|0)){c[j>>2]=z;if(!z){c[917813]=c[917813]&~(1<<f);break}}else{if(r>>>0<(c[917816]|0)>>>0)Vl();f=r+16|0;if((c[f>>2]|0)==(e|0))c[f>>2]=z;else c[r+20>>2]=z;if(!z)break}f=c[917816]|0;if(z>>>0<f>>>0)Vl();c[z+24>>2]=r;j=c[a+(b+16)>>2]|0;do if(j)if(j>>>0<f>>>0)Vl();else{c[z+16>>2]=j;c[j+24>>2]=z;break}while(0);j=c[a+(b+20)>>2]|0;if(j)if(j>>>0<(c[917816]|0)>>>0)Vl();else{c[z+20>>2]=j;c[j+24>>2]=z;break}}}else{j=c[a+(b+8)>>2]|0;f=c[a+(b+12)>>2]|0;r=3671288+(v<<1<<2)|0;if((j|0)!=(r|0)){if(j>>>0<u>>>0)Vl();if((c[j+12>>2]|0)!=(e|0))Vl()}if((f|0)==(j|0)){c[917812]=c[917812]&~(1<<v);break}if((f|0)!=(r|0)){if(f>>>0<u>>>0)Vl();r=f+8|0;if((c[r>>2]|0)==(e|0))E=r;else Vl()}else E=f+8|0;c[j+12>>2]=f;c[E>>2]=j}while(0);c[n+4>>2]=w|1;c[n+w>>2]=w;if((n|0)==(c[917817]|0)){c[917814]=w;i=d;return}else F=w}else{c[x>>2]=y&-2;c[n+4>>2]=o|1;c[n+o>>2]=o;F=o}o=F>>>3;if(F>>>0<256){y=o<<1;x=3671288+(y<<2)|0;w=c[917812]|0;E=1<<o;if(w&E){o=3671288+(y+2<<2)|0;e=c[o>>2]|0;if(e>>>0<(c[917816]|0)>>>0)Vl();else{G=o;H=e}}else{c[917812]=w|E;G=3671288+(y+2<<2)|0;H=x}c[G>>2]=n;c[H+12>>2]=n;c[n+8>>2]=H;c[n+12>>2]=x;i=d;return}x=F>>>8;if(x)if(F>>>0>16777215)I=31;else{H=(x+1048320|0)>>>16&8;G=x<<H;x=(G+520192|0)>>>16&4;y=G<<x;G=(y+245760|0)>>>16&2;E=14-(x|H|G)+(y<<G>>>15)|0;I=F>>>(E+7|0)&1|E<<1}else I=0;E=3671552+(I<<2)|0;c[n+28>>2]=I;c[n+20>>2]=0;c[n+16>>2]=0;G=c[917813]|0;y=1<<I;if(!(G&y)){c[917813]=G|y;c[E>>2]=n;c[n+24>>2]=E;c[n+12>>2]=n;c[n+8>>2]=n;i=d;return}y=c[E>>2]|0;if((I|0)==31)J=0;else J=25-(I>>>1)|0;a:do if((c[y+4>>2]&-8|0)==(F|0))K=y;else{I=F<<J;E=y;while(1){G=E+(I>>>31<<2)+16|0;H=c[G>>2]|0;if(!H){L=G;M=E;break}if((c[H+4>>2]&-8|0)==(F|0)){K=H;break a}else{I=I<<1;E=H}}if(L>>>0<(c[917816]|0)>>>0)Vl();c[L>>2]=n;c[n+24>>2]=M;c[n+12>>2]=n;c[n+8>>2]=n;i=d;return}while(0);M=K+8|0;L=c[M>>2]|0;F=c[917816]|0;if(!(K>>>0>=F>>>0&L>>>0>=F>>>0))Vl();c[L+12>>2]=n;c[M>>2]=n;c[n+8>>2]=L;c[n+12>>2]=K;c[n+24>>2]=0;i=d;return}function LEi(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g>>0]|0}else j=MDi(a)|0;if((j|0)==43|(j|0)==45){g=(j|0)==45&1;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k>>0]|0}else l=MDi(a)|0;if((l+-48|0)>>>0>9&(b|0)!=0?(c[h>>2]|0)!=0:0){c[f>>2]=(c[f>>2]|0)+-1;m=l;n=g}else{m=l;n=g}}else{m=j;n=0}if((m+-48|0)>>>0>9){if(!(c[h>>2]|0)){o=-2147483648;p=0;H=o;i=e;return p|0}c[f>>2]=(c[f>>2]|0)+-1;o=-2147483648;p=0;H=o;i=e;return p|0}else{q=m;r=0}while(1){m=q+-48+(r*10|0)|0;j=c[f>>2]|0;if(j>>>0<(c[h>>2]|0)>>>0){c[f>>2]=j+1;s=d[j>>0]|0}else s=MDi(a)|0;if((s+-48|0)>>>0<10&(m|0)<214748364){q=s;r=m}else{t=m;u=s;break}}s=((t|0)<0)<<31>>31;if((u+-48|0)>>>0<10){r=t;q=s;m=u;while(1){j=gFi(r|0,q|0,10,0)|0;g=H;l=_Ei(m|0,((m|0)<0)<<31>>31|0,-48,-1)|0;b=_Ei(l|0,H|0,j|0,g|0)|0;g=H;j=c[f>>2]|0;if(j>>>0<(c[h>>2]|0)>>>0){c[f>>2]=j+1;v=d[j>>0]|0}else v=MDi(a)|0;if((v+-48|0)>>>0<10&((g|0)<21474836|(g|0)==21474836&b>>>0<2061584302)){r=b;q=g;m=v}else{w=b;x=g;y=v;break}}}else{w=t;x=s;y=u}if((y+-48|0)>>>0<10)do{y=c[f>>2]|0;if(y>>>0<(c[h>>2]|0)>>>0){c[f>>2]=y+1;z=d[y>>0]|0}else z=MDi(a)|0}while((z+-48|0)>>>0<10);if(c[h>>2]|0)c[f>>2]=(c[f>>2]|0)+-1;f=(n|0)!=0;n=ZEi(0,0,w|0,x|0)|0;o=f?H:x;p=f?n:w;H=o;i=e;return p|0}function MEi(e,f,g,j,l){e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0.0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0.0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0;m=i;i=i+864|0;n=m+16|0;o=m+8|0;p=m+560|0;q=p;r=m+840|0;s=m+584|0;t=m+520|0;u=m;v=m+852|0;w=(e|0)!=0;x=t+40|0;y=x;z=t+39|0;t=u+4|0;A=u;B=r+12|0;C=r+11|0;r=B;D=r-q|0;E=-2-q|0;F=r+2|0;G=n+288|0;I=p+9|0;J=I;K=p+8|0;L=0;M=0;N=0;O=f;f=0;P=0;a:while(1){do if((N|0)>-1)if((f|0)>(2147483647-N|0)){c[(xd()|0)>>2]=75;Q=-1;break}else{Q=f+N|0;break}else Q=N;while(0);R=a[O>>0]|0;if(!(R<<24>>24)){S=Q;T=P;U=351;break}else{V=R;W=O}while(1){if(!(V<<24>>24)){X=W;Y=W;break}else if(V<<24>>24==37){Z=W;_=W;U=9;break}R=W+1|0;V=a[R>>0]|0;W=R}b:do if((U|0)==9)while(1){U=0;if((a[Z+1>>0]|0)!=37){X=Z;Y=_;break b}R=_+1|0;$=Z+2|0;if((a[$>>0]|0)==37){Z=$;_=R;U=9}else{X=$;Y=R;break}}while(0);R=Y-O|0;if(w)qEi(O,R,e)|0;if((Y|0)!=(O|0)){N=Q;O=X;f=R;continue}$=X+1|0;aa=a[$>>0]|0;ba=(aa<<24>>24)+-48|0;if(ba>>>0<10){ca=(a[X+2>>0]|0)==36;ea=ca?X+3|0:$;fa=a[ea>>0]|0;ga=ca?ba:-1;ha=ca?1:P;ia=ea}else{fa=aa;ga=-1;ha=P;ia=$}$=fa<<24>>24;c:do if(($&-32|0)==32){aa=$;ea=fa;ca=0;ba=ia;while(1){if(!(1<<aa+-32&75913)){ja=ea;ka=ca;la=ba;break c}ma=1<<(ea<<24>>24)+-32|ca;na=ba+1|0;oa=a[na>>0]|0;aa=oa<<24>>24;if((aa&-32|0)!=32){ja=oa;ka=ma;la=na;break}else{ea=oa;ca=ma;ba=na}}}else{ja=fa;ka=0;la=ia}while(0);do if(ja<<24>>24==42){$=la+1|0;ba=(a[$>>0]|0)+-48|0;if(ba>>>0<10?(a[la+2>>0]|0)==36:0){c[l+(ba<<2)>>2]=10;pa=1;qa=la+3|0;ra=c[j+((a[$>>0]|0)+-48<<3)>>2]|0}else{if(ha){sa=-1;U=369;break a}if(!w){ta=ka;ua=$;va=0;wa=0;break}ba=c[g>>2]|0;ca=c[ba>>2]|0;c[g>>2]=ba+4;pa=0;qa=$;ra=ca}if((ra|0)<0){ta=ka|8192;ua=qa;va=pa;wa=0-ra|0}else{ta=ka;ua=qa;va=pa;wa=ra}}else{ca=(ja<<24>>24)+-48|0;if(ca>>>0<10){$=la;ba=0;ea=ca;while(1){ca=(ba*10|0)+ea|0;aa=$+1|0;ea=(a[aa>>0]|0)+-48|0;if(ea>>>0>=10){xa=ca;ya=aa;break}else{$=aa;ba=ca}}if((xa|0)<0){sa=-1;U=369;break a}else{ta=ka;ua=ya;va=ha;wa=xa}}else{ta=ka;ua=la;va=ha;wa=0}}while(0);d:do if((a[ua>>0]|0)==46){ba=ua+1|0;$=a[ba>>0]|0;if($<<24>>24!=42){ea=($<<24>>24)+-48|0;if(ea>>>0<10){za=ba;Aa=ua;Ba=0;Ca=ea}else{Da=ba;Ea=0;break}while(1){ba=(Ba*10|0)+Ca|0;ea=Aa+2|0;Ca=(a[ea>>0]|0)+-48|0;if(Ca>>>0>=10){Da=ea;Ea=ba;break d}else{$=za;za=ea;Ba=ba;Aa=$}}}$=ua+2|0;ba=(a[$>>0]|0)+-48|0;if(ba>>>0<10?(a[ua+3>>0]|0)==36:0){c[l+(ba<<2)>>2]=10;Da=ua+4|0;Ea=c[j+((a[$>>0]|0)+-48<<3)>>2]|0;break}if(va){sa=-1;U=369;break a}if(w){ba=c[g>>2]|0;ea=c[ba>>2]|0;c[g>>2]=ba+4;Da=$;Ea=ea}else{Da=$;Ea=0}}else{Da=ua;Ea=-1}while(0);$=Da;ea=0;while(1){ba=a[$>>0]|0;ca=(ba<<24>>24)+-65|0;if(ca>>>0>57){sa=-1;U=369;break a}aa=$+1|0;na=a[3672216+(ea*58|0)+ca>>0]|0;ca=na&255;if((ca+-1|0)>>>0<8){$=aa;ea=ca}else{Fa=ba;Ga=aa;Ha=na;Ia=ca;Ja=$;Ka=ea;break}}if(!(Ha<<24>>24)){sa=-1;U=369;break}ea=(ga|0)>-1;e:do if(Ha<<24>>24==19)if(ea){sa=-1;U=369;break a}else{La=L;Ma=M;U=62}else{if(ea){c[l+(ga<<2)>>2]=Ia;$=j+(ga<<3)|0;La=c[$>>2]|0;Ma=c[$+4>>2]|0;U=62;break}if(!w){sa=0;U=369;break a}if((Ha&255)>20){Na=Fa;Oa=L;Pa=M}else do switch(Ia|0){case 13:{$=c[g>>2]|0;ca=c[$>>2]|0;c[g>>2]=$+4;Qa=(((ca&65535)<<16>>16|0)<0)<<31>>31;Ra=ca<<16>>16;U=63;break e;break}case 14:{ca=c[g>>2]|0;$=c[ca>>2]|0;c[g>>2]=ca+4;Qa=0;Ra=$&65535;U=63;break e;break}case 15:{$=c[g>>2]|0;ca=c[$>>2]|0;c[g>>2]=$+4;Qa=(((ca&255)<<24>>24|0)<0)<<31>>31;Ra=ca<<24>>24;U=63;break e;break}case 10:{ca=c[g>>2]|0;$=c[ca>>2]|0;c[g>>2]=ca+4;Qa=(($|0)<0)<<31>>31;Ra=$;U=63;break e;break}case 11:{$=c[g>>2]|0;ca=c[$>>2]|0;c[g>>2]=$+4;Qa=0;Ra=ca;U=63;break e;break}case 9:{ca=c[g>>2]|0;$=c[ca>>2]|0;c[g>>2]=ca+4;Qa=M;Ra=$;U=63;break e;break}case 16:{$=c[g>>2]|0;ca=c[$>>2]|0;c[g>>2]=$+4;Qa=0;Ra=ca&255;U=63;break e;break}case 17:{ca=c[g>>2]|0;c[k>>2]=c[ca>>2];c[k+4>>2]=c[ca+4>>2];Sa=+h[k>>3];c[g>>2]=ca+8;h[k>>3]=Sa;Qa=c[k+4>>2]|0;Ra=c[k>>2]|0;U=63;break e;break}case 18:{ca=c[g>>2]|0;c[k>>2]=c[ca>>2];c[k+4>>2]=c[ca+4>>2];Sa=+h[k>>3];c[g>>2]=ca+8;h[k>>3]=Sa;La=c[k>>2]|0;Ma=c[k+4>>2]|0;U=62;break e;break}case 12:{ca=c[g>>2]|0;$=ca;na=c[$>>2]|0;aa=c[$+4>>2]|0;c[g>>2]=ca+8;Qa=aa;Ra=na;U=63;break e;break}default:{Qa=M;Ra=L;U=63;break e}}while(0)}while(0);if((U|0)==62){U=0;if(w){Qa=Ma;Ra=La;U=63}else{L=La;M=Ma;N=Q;O=Ga;f=R;P=va;continue}}if((U|0)==63){U=0;Na=a[Ja>>0]|0;Oa=Ra;Pa=Qa}ea=Na<<24>>24;na=(Ka|0)!=0&(ea&15|0)==3?ea&-33:ea;ea=ta&-65537;aa=(ta&8192|0)==0?ta:ea;f:do switch(na|0){case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{c[k>>2]=Oa;c[k+4>>2]=Pa;Sa=+h[k>>3];c[o>>2]=0;if((Pa|0)>=0)if(!(aa&2048)){ca=aa&1;Ta=Sa;Ua=ca;Va=(ca|0)==0?3672705:3672710}else{Ta=Sa;Ua=1;Va=3672707}else{Ta=-Sa;Ua=1;Va=3672704}h[k>>3]=Ta;ca=c[k+4>>2]&2146435072;if(!(ca>>>0<2146435072|(ca|0)==2146435072&0<0)){ca=(na&32|0)!=0;if(Ta!=Ta|0.0!=0.0){Wa=0;Xa=ca?3672744:3672752}else{Wa=Ua;Xa=ca?3672728:3672736}ca=Wa+3|0;$=(wa|0)>(ca|0);if((aa&8192|0)==0&$){ba=wa-ca|0;PEi(s|0,32,(ba>>>0>256?256:ba)|0)|0;if(ba>>>0>255){ma=ba;do{qEi(s,256,e)|0;ma=ma+-256|0}while(ma>>>0>255);Ya=ba&255}else Ya=ba;qEi(s,Ya,e)|0}qEi(Va,Wa,e)|0;qEi(Xa,3,e)|0;if((aa&73728|0)==8192&$){ma=wa-ca|0;PEi(s|0,32,(ma>>>0>256?256:ma)|0)|0;if(ma>>>0>255){oa=ma;do{qEi(s,256,e)|0;oa=oa+-256|0}while(oa>>>0>255);Za=ma&255}else Za=ma;qEi(s,Za,e)|0}L=Oa;M=Pa;N=Q;O=Ga;f=$?wa:ca;P=va;continue a}Sa=+_Di(Ta,o)*2.0;oa=Sa!=0.0;if(oa)c[o>>2]=(c[o>>2]|0)+-1;ba=na|32;if((ba|0)==97){_a=na&32;$a=(_a|0)==0?Va:Va+9|0;ab=Ua|2;bb=Ea>>>0>11?0:12-Ea|0;do if(bb){cb=bb;db=8.0;while(1){cb=cb+-1|0;eb=db*16.0;if(!cb){fb=eb;break}else db=eb}if((a[$a>>0]|0)==45){gb=-(fb+(-Sa-fb));break}else{gb=Sa+fb-fb;break}}else gb=Sa;while(0);bb=c[o>>2]|0;ca=(bb|0)<0?0-bb|0:bb;if((ca|0)<0){bb=B;$=ca;ma=((ca|0)<0)<<31>>31;while(1){cb=iFi($|0,ma|0,10,0)|0;hb=bb+-1|0;a[hb>>0]=cb|48;cb=hFi($|0,ma|0,10,0)|0;if(ma>>>0>9|(ma|0)==9&$>>>0>4294967295){bb=hb;$=cb;ma=H}else{ib=hb;jb=cb;break}}kb=ib;lb=jb}else{kb=B;lb=ca}if(!lb)mb=kb;else{ma=kb;$=lb;while(1){bb=ma+-1|0;a[bb>>0]=($>>>0)%10|0|48;if($>>>0<10){mb=bb;break}else{ma=bb;$=($>>>0)/10|0}}}if((mb|0)==(B|0)){a[C>>0]=48;nb=C}else nb=mb;a[nb+-1>>0]=(c[o>>2]>>31&2)+43;$=nb+-2|0;a[$>>0]=na+15;if((Ea|0)<1)if(!(aa&8)){db=gb;ma=p;while(1){ca=~~db;bb=ma+1|0;a[ma>>0]=d[3672760+ca>>0]|_a;db=(db-+(ca|0))*16.0;if((bb-q|0)!=1|db==0.0)ob=bb;else{a[bb>>0]=46;ob=ma+2|0}if(!(db!=0.0)){pb=ob;break}else ma=ob}}else{db=gb;ma=p;while(1){bb=~~db;ca=ma+1|0;a[ma>>0]=d[3672760+bb>>0]|_a;db=(db-+(bb|0))*16.0;if((ca-q|0)==1){a[ca>>0]=46;qb=ma+2|0}else qb=ca;if(!(db!=0.0)){pb=qb;break}else ma=qb}}else{db=gb;ma=p;while(1){ca=~~db;bb=ma+1|0;a[ma>>0]=d[3672760+ca>>0]|_a;db=(db-+(ca|0))*16.0;if((bb-q|0)==1){a[bb>>0]=46;rb=ma+2|0}else rb=bb;if(!(db!=0.0)){pb=rb;break}else ma=rb}}ma=pb;_a=$;if((Ea|0)!=0&(E+ma|0)<(Ea|0))sb=F+Ea-_a|0;else sb=D-_a+ma|0;_a=sb+ab|0;bb=aa&73728;ca=(wa|0)>(_a|0);if((bb|0)==0&ca){cb=wa-_a|0;PEi(s|0,32,(cb>>>0>256?256:cb)|0)|0;if(cb>>>0>255){hb=cb;do{qEi(s,256,e)|0;hb=hb+-256|0}while(hb>>>0>255);tb=cb&255}else tb=cb;qEi(s,tb,e)|0}qEi($a,ab,e)|0;if((bb|0)==65536&ca){hb=wa-_a|0;PEi(s|0,48,(hb>>>0>256?256:hb)|0)|0;if(hb>>>0>255){ub=hb;do{qEi(s,256,e)|0;ub=ub+-256|0}while(ub>>>0>255);vb=hb&255}else vb=hb;qEi(s,vb,e)|0}ub=ma-q|0;qEi(p,ub,e)|0;ab=r-$|0;$a=sb-ab-ub|0;if(($a|0)>0){PEi(s|0,48,($a>>>0>256?256:$a)|0)|0;if($a>>>0>255){ub=$a;do{qEi(s,256,e)|0;ub=ub+-256|0}while(ub>>>0>255);wb=$a&255}else wb=$a;qEi(s,wb,e)|0}qEi($,ab,e)|0;if((bb|0)==8192&ca){ub=wa-_a|0;PEi(s|0,32,(ub>>>0>256?256:ub)|0)|0;if(ub>>>0>255){ma=ub;do{qEi(s,256,e)|0;ma=ma+-256|0}while(ma>>>0>255);xb=ub&255}else xb=ub;qEi(s,xb,e)|0}L=Oa;M=Pa;N=Q;O=Ga;f=ca?wa:_a;P=va;continue a}ma=(Ea|0)<0?6:Ea;if(oa){bb=(c[o>>2]|0)+-28|0;c[o>>2]=bb;yb=Sa*268435456.0;zb=bb}else{yb=Sa;zb=c[o>>2]|0}bb=(zb|0)<0?n:G;ab=bb;db=yb;$=bb;while(1){$a=~~db>>>0;c[$>>2]=$a;hb=$+4|0;db=(db-+($a>>>0))*1.0e9;if(!(db!=0.0)){Ab=hb;break}else $=hb}$=c[o>>2]|0;if(($|0)>0){oa=$;_a=bb;ca=Ab;while(1){ub=(oa|0)>29?29:oa;hb=ca+-4|0;do if(hb>>>0<_a>>>0)Bb=_a;else{$a=ca;cb=0;Cb=hb;while(1){Db=cFi(c[Cb>>2]|0,0,ub|0)|0;Eb=_Ei(Db|0,H|0,cb|0,0)|0;Db=H;Fb=iFi(Eb|0,Db|0,1e9,0)|0;c[Cb>>2]=Fb;Fb=hFi(Eb|0,Db|0,1e9,0)|0;Db=$a+-8|0;if(Db>>>0<_a>>>0){Gb=Fb;break}else{Eb=Cb;cb=Fb;Cb=Db;$a=Eb}}if(!Gb){Bb=_a;break}$a=_a+-4|0;c[$a>>2]=Gb;Bb=$a}while(0);hb=ca;while(1){if(hb>>>0<=Bb>>>0){Hb=hb;break}$a=hb+-4|0;if(!(c[$a>>2]|0))hb=$a;else{Hb=hb;break}}hb=(c[o>>2]|0)-ub|0;c[o>>2]=hb;if((hb|0)>0){oa=hb;_a=Bb;ca=Hb}else{Ib=hb;Jb=Bb;Kb=Hb;break}}}else{Ib=$;Jb=bb;Kb=Ab}g:do if((Ib|0)<0){ca=((ma+25|0)/9|0)+1|0;if((ba|0)==102){_a=bb+(ca<<2)|0;oa=Ib;hb=Jb;$a=Kb;while(1){Cb=(oa|0)<-9?9:0-oa|0;do if(hb>>>0<$a>>>0){cb=(1<<Cb)+-1|0;Eb=1e9>>>Cb;Db=0;Fb=hb;while(1){Lb=c[Fb>>2]|0;c[Fb>>2]=(Lb>>>Cb)+Db;Mb=da(Lb&cb,Eb)|0;Fb=Fb+4|0;if(Fb>>>0>=$a>>>0){Nb=Mb;break}else Db=Mb}Db=(c[hb>>2]|0)==0?hb+4|0:hb;if(!Nb){Ob=Db;Pb=$a;break}c[$a>>2]=Nb;Ob=Db;Pb=$a+4|0}else{Ob=(c[hb>>2]|0)==0?hb+4|0:hb;Pb=$a}while(0);Db=(Pb-ab>>2|0)>(ca|0)?_a:Pb;oa=(c[o>>2]|0)+Cb|0;c[o>>2]=oa;if((oa|0)>=0){Qb=Ob;Rb=Db;break g}else{hb=Ob;$a=Db}}}else{Sb=Ib;Tb=Jb;Ub=Kb}while(1){$a=(Sb|0)<-9?9:0-Sb|0;do if(Tb>>>0<Ub>>>0){hb=(1<<$a)+-1|0;oa=1e9>>>$a;_a=0;ub=Tb;while(1){Db=c[ub>>2]|0;c[ub>>2]=(Db>>>$a)+_a;Fb=da(Db&hb,oa)|0;ub=ub+4|0;if(ub>>>0>=Ub>>>0){Vb=Fb;break}else _a=Fb}_a=(c[Tb>>2]|0)==0?Tb+4|0:Tb;if(!Vb){Wb=_a;Xb=Ub;break}c[Ub>>2]=Vb;Wb=_a;Xb=Ub+4|0}else{Wb=(c[Tb>>2]|0)==0?Tb+4|0:Tb;Xb=Ub}while(0);if((Xb-Wb>>2|0)>(ca|0))Yb=Wb+(ca<<2)|0;else Yb=Xb;Sb=(c[o>>2]|0)+$a|0;c[o>>2]=Sb;if((Sb|0)>=0){Qb=Wb;Rb=Yb;break}else{Tb=Wb;Ub=Yb}}}else{Qb=Jb;Rb=Kb}while(0);do if(Qb>>>0<Rb>>>0){$=(ab-Qb>>2)*9|0;ca=c[Qb>>2]|0;if(ca>>>0<10){Zb=$;break}else{_b=$;$b=10}while(1){$b=$b*10|0;$=_b+1|0;if(ca>>>0<$b>>>0){Zb=$;break}else _b=$}}else Zb=0;while(0);ca=(ba|0)==103;$=ma-((ba|0)!=102?Zb:0)+((ca&(ma|0)!=0)<<31>>31)|0;if(($|0)<(((Rb-ab>>2)*9|0)+-9|0)){Cb=$+9216|0;$=(Cb|0)/9|0;_a=bb+($+-1023<<2)|0;ub=((Cb|0)%9|0)+1|0;if((ub|0)<9){Cb=10;oa=ub;while(1){ub=Cb*10|0;oa=oa+1|0;if((oa|0)==9){ac=ub;break}else Cb=ub}}else ac=10;Cb=c[_a>>2]|0;oa=(Cb>>>0)%(ac>>>0)|0;if((oa|0)==0?(bb+($+-1022<<2)|0)==(Rb|0):0){bc=Qb;cc=_a;dc=Zb}else U=231;do if((U|0)==231){U=0;db=(((Cb>>>0)/(ac>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;ba=(ac|0)/2|0;do if(oa>>>0<ba>>>0)ec=.5;else{if((oa|0)==(ba|0)?(bb+($+-1022<<2)|0)==(Rb|0):0){ec=1.0;break}ec=1.5}while(0);do if(!Ua){fc=db;gc=ec}else{if((a[Va>>0]|0)!=45){fc=db;gc=ec;break}fc=-db;gc=-ec}while(0);ba=Cb-oa|0;c[_a>>2]=ba;if(!(fc+gc!=fc)){bc=Qb;cc=_a;dc=Zb;break}ub=ba+ac|0;c[_a>>2]=ub;if(ub>>>0>999999999){ub=Qb;ba=_a;while(1){hb=ba+-4|0;c[ba>>2]=0;if(hb>>>0<ub>>>0){Fb=ub+-4|0;c[Fb>>2]=0;hc=Fb}else hc=ub;Fb=(c[hb>>2]|0)+1|0;c[hb>>2]=Fb;if(Fb>>>0>999999999){ub=hc;ba=hb}else{ic=hc;jc=hb;break}}}else{ic=Qb;jc=_a}ba=(ab-ic>>2)*9|0;ub=c[ic>>2]|0;if(ub>>>0<10){bc=ic;cc=jc;dc=ba;break}else{kc=ba;lc=10}while(1){lc=lc*10|0;ba=kc+1|0;if(ub>>>0<lc>>>0){bc=ic;cc=jc;dc=ba;break}else kc=ba}}while(0);_a=cc+4|0;mc=bc;nc=dc;oc=Rb>>>0>_a>>>0?_a:Rb}else{mc=Qb;nc=Zb;oc=Rb}_a=mc;oa=0-nc|0;Cb=oc;while(1){if(Cb>>>0<=mc>>>0){pc=0;qc=Cb;break}$=Cb+-4|0;if(!(c[$>>2]|0))Cb=$;else{pc=1;qc=Cb;break}}do if(ca){Cb=((ma|0)==0&1)+ma|0;if((Cb|0)>(nc|0)&(nc|0)>-5){rc=na+-1|0;sc=Cb+-1-nc|0}else{rc=na+-2|0;sc=Cb+-1|0}if(aa&8){tc=rc;uc=sc;break}do if(pc){Cb=c[qc+-4>>2]|0;if(!Cb){vc=9;break}if(!((Cb>>>0)%10|0)){wc=10;xc=0}else{vc=0;break}while(1){wc=wc*10|0;$=xc+1|0;if((Cb>>>0)%(wc>>>0)|0){vc=$;break}else xc=$}}else vc=9;while(0);Cb=((qc-ab>>2)*9|0)+-9|0;if((rc|32|0)==102){$a=Cb-vc|0;$=($a|0)<0?0:$a;tc=rc;uc=(sc|0)<($|0)?sc:$;break}else{$=Cb+nc-vc|0;Cb=($|0)<0?0:$;tc=rc;uc=(sc|0)<(Cb|0)?sc:Cb;break}}else{tc=na;uc=ma}while(0);ma=(uc|0)!=0;if(ma)yc=1;else yc=(aa&8|0)!=0;ca=yc&1;Cb=(tc|32|0)==102;if(Cb){zc=(nc|0)>0?nc:0;Ac=0}else{$=(nc|0)<0?oa:nc;if(($|0)<0){$a=B;ub=$;ba=(($|0)<0)<<31>>31;while(1){hb=iFi(ub|0,ba|0,10,0)|0;Fb=$a+-1|0;a[Fb>>0]=hb|48;hb=hFi(ub|0,ba|0,10,0)|0;if(ba>>>0>9|(ba|0)==9&ub>>>0>4294967295){$a=Fb;ub=hb;ba=H}else{Bc=Fb;Cc=hb;break}}Dc=Bc;Ec=Cc}else{Dc=B;Ec=$}if(!Ec)Fc=Dc;else{ba=Dc;ub=Ec;while(1){$a=ba+-1|0;a[$a>>0]=(ub>>>0)%10|0|48;if(ub>>>0<10){Fc=$a;break}else{ba=$a;ub=(ub>>>0)/10|0}}}if((r-Fc|0)<2){ub=Fc;while(1){ba=ub+-1|0;a[ba>>0]=48;if((r-ba|0)<2)ub=ba;else{Gc=ba;break}}}else Gc=Fc;a[Gc+-1>>0]=(nc>>31&2)+43;ub=Gc+-2|0;a[ub>>0]=tc;zc=r-ub|0;Ac=ub}ub=Ua+1+uc+ca+zc|0;ba=aa&73728;$=(wa|0)>(ub|0);if((ba|0)==0&$){$a=wa-ub|0;PEi(s|0,32,($a>>>0>256?256:$a)|0)|0;if($a>>>0>255){oa=$a;do{qEi(s,256,e)|0;oa=oa+-256|0}while(oa>>>0>255);Hc=$a&255}else Hc=$a;qEi(s,Hc,e)|0}qEi(Va,Ua,e)|0;if((ba|0)==65536&$){oa=wa-ub|0;PEi(s|0,48,(oa>>>0>256?256:oa)|0)|0;if(oa>>>0>255){ca=oa;do{qEi(s,256,e)|0;ca=ca+-256|0}while(ca>>>0>255);Ic=oa&255}else Ic=oa;qEi(s,Ic,e)|0}do if(Cb){ca=mc>>>0>bb>>>0?bb:mc;$a=~ab;hb=~_a;Fb=$a>>>0>hb>>>0?$a:hb;hb=3-Fb|0;$a=bb+1|0;Db=(hb>>>0>$a>>>0?hb:$a)+Fb|0;$a=~Fb;Fb=ca;while(1){hb=c[Fb>>2]|0;if(!hb)Jc=I;else{Eb=I;cb=hb;while(1){hb=Eb+-1|0;a[hb>>0]=(cb>>>0)%10|0|48;if(cb>>>0<10){Jc=hb;break}else{Eb=hb;cb=(cb>>>0)/10|0}}}do if((Fb|0)==(ca|0)){if((Jc|0)!=(I|0)){Kc=Jc;break}a[K>>0]=48;Kc=K}else{if(Jc>>>0>p>>>0)Lc=Jc;else{Kc=Jc;break}while(1){cb=Lc+-1|0;a[cb>>0]=48;if(cb>>>0>p>>>0)Lc=cb;else{Kc=cb;break}}}while(0);qEi(Kc,J-Kc|0,e)|0;cb=Fb+4|0;if(cb>>>0>bb>>>0){Mc=cb;break}else Fb=cb}if(!((aa&8|0)==0&(ma^1)))qEi(3672776,1,e)|0;if(Mc>>>0<qc>>>0&(uc|0)>0){Fb=uc;ca=(Db&-4)+$a|0;cb=Mc;while(1){Eb=c[cb>>2]|0;if(Eb){hb=I;Mb=Eb;while(1){Eb=hb+-1|0;a[Eb>>0]=(Mb>>>0)%10|0|48;if(Mb>>>0<10){Nc=Eb;break}else{hb=Eb;Mb=(Mb>>>0)/10|0}}if(Nc>>>0>p>>>0){Oc=Nc;U=300}else Pc=Nc}else{Oc=I;U=300}if((U|0)==300)while(1){U=0;Mb=Oc+-1|0;a[Mb>>0]=48;if(Mb>>>0>p>>>0){Oc=Mb;U=300}else{Pc=Mb;break}}qEi(Pc,(Fb|0)>9?9:Fb,e)|0;Mb=ca+8|0;hb=Fb+-9|0;if(Mb>>>0<qc>>>0&(hb|0)>0){Eb=cb;Fb=hb;cb=Mb;ca=Eb}else{Qc=hb;break}}}else Qc=uc;if((Qc|0)<=0)break;PEi(s|0,48,(Qc>>>0>256?256:Qc)|0)|0;if(Qc>>>0>255){ca=Qc;do{qEi(s,256,e)|0;ca=ca+-256|0}while(ca>>>0>255);Rc=Qc&255}else Rc=Qc;qEi(s,Rc,e)|0}else{ca=pc?qc:mc+4|0;do if((uc|0)>-1){cb=(aa&8|0)==0;Fb=uc;$a=mc;while(1){Db=c[$a>>2]|0;if(Db){hb=I;Eb=Db;while(1){Db=hb+-1|0;a[Db>>0]=(Eb>>>0)%10|0|48;if(Eb>>>0<10){Sc=hb;Tc=Db;break}else{hb=Db;Eb=(Eb>>>0)/10|0}}if((Tc|0)!=(I|0)){Uc=Sc;Vc=Tc}else U=312}else U=312;if((U|0)==312){U=0;a[K>>0]=48;Uc=I;Vc=K}do if(($a|0)==(mc|0)){qEi(Vc,1,e)|0;if((Fb|0)<1&cb){Wc=Uc;break}qEi(3672776,1,e)|0;Wc=Uc}else{if(Vc>>>0>p>>>0)Xc=Vc;else{Wc=Vc;break}while(1){Eb=Xc+-1|0;a[Eb>>0]=48;if(Eb>>>0>p>>>0)Xc=Eb;else{Wc=Eb;break}}}while(0);Eb=J-Wc|0;qEi(Wc,(Fb|0)>(Eb|0)?Eb:Fb,e)|0;hb=Fb-Eb|0;$a=$a+4|0;if(!($a>>>0<ca>>>0&(hb|0)>-1)){Yc=hb;break}else Fb=hb}if((Yc|0)<=0)break;PEi(s|0,48,(Yc>>>0>256?256:Yc)|0)|0;if(Yc>>>0>255){Fb=Yc;do{qEi(s,256,e)|0;Fb=Fb+-256|0}while(Fb>>>0>255);Zc=Yc&255}else Zc=Yc;qEi(s,Zc,e)|0}while(0);qEi(Ac,r-Ac|0,e)|0}while(0);if((ba|0)==8192&$){ma=wa-ub|0;PEi(s|0,32,(ma>>>0>256?256:ma)|0)|0;if(ma>>>0>255){bb=ma;do{qEi(s,256,e)|0;bb=bb+-256|0}while(bb>>>0>255);_c=ma&255}else _c=ma;qEi(s,_c,e)|0}L=Oa;M=Pa;N=Q;O=Ga;f=$?wa:ub;P=va;continue a;break}case 110:{switch(Ka|0){case 0:{c[Oa>>2]=Q;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}case 1:{c[Oa>>2]=Q;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}case 2:{bb=Oa;c[bb>>2]=Q;c[bb+4>>2]=((Q|0)<0)<<31>>31;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}case 3:{b[Oa>>1]=Q;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}case 4:{a[Oa>>0]=Q;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}case 6:{c[Oa>>2]=Q;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}case 7:{bb=Oa;c[bb>>2]=Q;c[bb+4>>2]=((Q|0)<0)<<31>>31;L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a;break}default:{L=Oa;M=Pa;N=Q;O=Ga;f=R;P=va;continue a}}break}case 112:{$c=aa|8;ad=Ea>>>0>8?Ea:8;bd=120;U=74;break}case 88:case 120:{$c=aa;ad=Ea;bd=na;U=74;break}case 111:{bb=(Oa|0)==0&(Pa|0)==0;if(bb)cd=x;else{ba=x;_a=Oa;ab=Pa;while(1){Cb=ba+-1|0;a[Cb>>0]=_a&7|48;_a=VEi(_a|0,ab|0,3)|0;ab=H;if((_a|0)==0&(ab|0)==0){cd=Cb;break}else ba=Cb}}ba=(aa&8|0)==0|bb;dd=Oa;ed=Pa;fd=cd;gd=aa;hd=Ea;id=ba&1^1;jd=ba?3672680:3672685;U=90;break}case 105:case 100:{if((Pa|0)<0){ba=ZEi(0,0,Oa|0,Pa|0)|0;kd=H;ld=ba;md=1;nd=3672680;U=85;break f}if(!(aa&2048)){ba=aa&1;kd=Pa;ld=Oa;md=ba;nd=(ba|0)==0?3672680:3672682;U=85}else{kd=Pa;ld=Oa;md=1;nd=3672681;U=85}break}case 117:{kd=Pa;ld=Oa;md=0;nd=3672680;U=85;break}case 99:{a[z>>0]=Oa;od=Oa;pd=Pa;qd=z;rd=ea;sd=1;td=0;ud=3672680;vd=x;break}case 109:{wd=jm(c[(xd()|0)>>2]|0)|0;U=95;break}case 115:{wd=(Oa|0)==0?3672696:Oa;U=95;break}case 67:{c[u>>2]=Oa;c[t>>2]=0;yd=u;zd=A;Ad=-1;U=100;break}case 83:{ba=Oa;if(!Ea){Bd=Oa;Cd=ba;Dd=0;U=105}else{yd=ba;zd=Oa;Ad=Ea;U=100}break}default:{od=Oa;pd=Pa;qd=O;rd=aa;sd=Ea;td=0;ud=3672680;vd=x}}while(0);do if((U|0)==74){U=0;na=bd&32;if(!((Oa|0)==0&(Pa|0)==0)){R=x;ba=Oa;ab=Pa;while(1){_a=R+-1|0;a[_a>>0]=d[3672760+(ba&15)>>0]|na;ba=VEi(ba|0,ab|0,4)|0;ab=H;if((ba|0)==0&(ab|0)==0){Ed=_a;break}else R=_a}if(!($c&8)){dd=Oa;ed=Pa;fd=Ed;gd=$c;hd=ad;id=0;jd=3672680;U=90}else{dd=Oa;ed=Pa;fd=Ed;gd=$c;hd=ad;id=2;jd=3672680+(bd>>4)|0;U=90}}else{dd=Oa;ed=Pa;fd=x;gd=$c;hd=ad;id=0;jd=3672680;U=90}}else if((U|0)==85){U=0;if(kd>>>0>0|(kd|0)==0&ld>>>0>4294967295){R=x;ab=ld;ba=kd;while(1){na=iFi(ab|0,ba|0,10,0)|0;bb=R+-1|0;a[bb>>0]=na|48;na=hFi(ab|0,ba|0,10,0)|0;if(ba>>>0>9|(ba|0)==9&ab>>>0>4294967295){R=bb;ab=na;ba=H}else{Fd=bb;Gd=na;break}}Hd=Fd;Id=Gd}else{Hd=x;Id=ld}if(!Id){dd=ld;ed=kd;fd=Hd;gd=aa;hd=Ea;id=md;jd=nd;U=90}else{ba=Hd;ab=Id;while(1){R=ba+-1|0;a[R>>0]=(ab>>>0)%10|0|48;if(ab>>>0<10){dd=ld;ed=kd;fd=R;gd=aa;hd=Ea;id=md;jd=nd;U=90;break}else{ba=R;ab=(ab>>>0)/10|0}}}}else if((U|0)==95){U=0;ab=EEi(wd,0,Ea)|0;if(!ab){od=Oa;pd=Pa;qd=wd;rd=ea;sd=Ea;td=0;ud=3672680;vd=wd+Ea|0;break}else{od=Oa;pd=Pa;qd=wd;rd=ea;sd=ab-wd|0;td=0;ud=3672680;vd=ab;break}}else if((U|0)==100){U=0;ab=0;ba=0;R=yd;while(1){na=c[R>>2]|0;if(!na){Jd=ab;Kd=ba;break}bb=kEi(v,na)|0;if((bb|0)<0|bb>>>0>(Ad-ab|0)>>>0){Jd=ab;Kd=bb;break}na=bb+ab|0;if(Ad>>>0>na>>>0){ab=na;ba=bb;R=R+4|0}else{Jd=na;Kd=bb;break}}if((Kd|0)<0){sa=-1;U=369;break a}else{Bd=zd;Cd=yd;Dd=Jd;U=105}}while(0);if((U|0)==90){U=0;ea=(hd|0)>-1?gd&-65537:gd;R=(dd|0)!=0|(ed|0)!=0;if(R|(hd|0)!=0){ba=(R&1^1)+(y-fd)|0;od=dd;pd=ed;qd=fd;rd=ea;sd=(hd|0)>(ba|0)?hd:ba;td=id;ud=jd;vd=x}else{od=dd;pd=ed;qd=x;rd=ea;sd=0;td=id;ud=jd;vd=x}}else if((U|0)==105){U=0;ea=aa&73728;ba=(wa|0)>(Dd|0);if((ea|0)==0&ba){R=wa-Dd|0;PEi(s|0,32,(R>>>0>256?256:R)|0)|0;if(R>>>0>255){ab=R;do{qEi(s,256,e)|0;ab=ab+-256|0}while(ab>>>0>255);Ld=R&255}else Ld=R;qEi(s,Ld,e)|0}h:do if(Dd){ab=0;aa=Cd;while(1){bb=c[aa>>2]|0;if(!bb)break h;na=kEi(v,bb)|0;ab=na+ab|0;if((ab|0)>(Dd|0))break h;qEi(v,na,e)|0;if(ab>>>0>=Dd>>>0)break;else aa=aa+4|0}}while(0);if((ea|0)==8192&ba){R=wa-Dd|0;PEi(s|0,32,(R>>>0>256?256:R)|0)|0;if(R>>>0>255){aa=R;do{qEi(s,256,e)|0;aa=aa+-256|0}while(aa>>>0>255);Md=R&255}else Md=R;qEi(s,Md,e)|0}L=Bd;M=Pa;N=Q;O=Ga;f=ba?wa:Dd;P=va;continue}aa=vd-qd|0;ea=(sd|0)<(aa|0)?aa:sd;ab=td+ea|0;na=(wa|0)<(ab|0)?ab:wa;bb=rd&73728;_a=(na|0)>(ab|0);if((bb|0)==0&_a){ub=na-ab|0;PEi(s|0,32,(ub>>>0>256?256:ub)|0)|0;if(ub>>>0>255){$=ub;do{qEi(s,256,e)|0;$=$+-256|0}while($>>>0>255);Nd=ub&255}else Nd=ub;qEi(s,Nd,e)|0}qEi(ud,td,e)|0;if((bb|0)==65536&_a){$=na-ab|0;PEi(s|0,48,($>>>0>256?256:$)|0)|0;if($>>>0>255){ba=$;do{qEi(s,256,e)|0;ba=ba+-256|0}while(ba>>>0>255);Od=$&255}else Od=$;qEi(s,Od,e)|0}if((ea|0)>(aa|0)){ba=ea-aa|0;PEi(s|0,48,(ba>>>0>256?256:ba)|0)|0;if(ba>>>0>255){ub=ba;do{qEi(s,256,e)|0;ub=ub+-256|0}while(ub>>>0>255);Pd=ba&255}else Pd=ba;qEi(s,Pd,e)|0}qEi(qd,aa,e)|0;if(!((bb|0)==8192&_a)){L=od;M=pd;N=Q;O=Ga;f=na;P=va;continue}ub=na-ab|0;PEi(s|0,32,(ub>>>0>256?256:ub)|0)|0;if(ub>>>0>255){ea=ub;do{qEi(s,256,e)|0;ea=ea+-256|0}while(ea>>>0>255);Qd=ub&255}else Qd=ub;qEi(s,Qd,e)|0;L=od;M=pd;N=Q;O=Ga;f=na;P=va}if((U|0)==351){if(e){sa=S;i=m;return sa|0}if(!T){sa=0;i=m;return sa|0}else Rd=1;while(1){T=c[l+(Rd<<2)>>2]|0;if(!T){Sd=Rd;break}S=j+(Rd<<3)|0;i:do if(T>>>0<=20)do switch(T|0){case 12:{e=c[g>>2]|0;va=e;P=c[va>>2]|0;f=c[va+4>>2]|0;c[g>>2]=e+8;e=S;c[e>>2]=P;c[e+4>>2]=f;break i;break}case 13:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=(e&65535)<<16>>16;e=S;c[e>>2]=f;c[e+4>>2]=((f|0)<0)<<31>>31;break i;break}case 14:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=S;c[f>>2]=e&65535;c[f+4>>2]=0;break i;break}case 15:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=(e&255)<<24>>24;e=S;c[e>>2]=f;c[e+4>>2]=((f|0)<0)<<31>>31;break i;break}case 16:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=S;c[f>>2]=e&255;c[f+4>>2]=0;break i;break}case 17:{f=c[g>>2]|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];fc=+h[k>>3];c[g>>2]=f+8;h[S>>3]=fc;break i;break}case 18:{f=c[g>>2]|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];fc=+h[k>>3];c[g>>2]=f+8;h[S>>3]=fc;break i;break}case 9:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;c[S>>2]=e;break i;break}case 10:{e=c[g>>2]|0;f=c[e>>2]|0;c[g>>2]=e+4;e=S;c[e>>2]=f;c[e+4>>2]=((f|0)<0)<<31>>31;break i;break}case 11:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=S;c[f>>2]=e;c[f+4>>2]=0;break i;break}default:break i}while(0);while(0);Rd=Rd+1|0;if((Rd|0)>=10){sa=1;U=369;break}}if((U|0)==369){i=m;return sa|0}while(1){if(c[l+(Sd<<2)>>2]|0){sa=-1;U=369;break}Sd=Sd+1|0;if((Sd|0)>=10){sa=1;U=369;break}}if((U|0)==369){i=m;return sa|0}}else if((U|0)==369){i=m;return sa|0}return 0}function NEi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a+20|0;g=c[f>>2]|0;h=(c[a+16>>2]|0)-g|0;a=h>>>0>d>>>0?d:h;YEi(g|0,b|0,a|0)|0;c[f>>2]=(c[f>>2]|0)+a;i=e;return d|0}function OEi(){}function PEi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function QEi(b){b=b|0;var c=0;c=a[n+(b>>>24)>>0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[n+(b&255)>>0]|0)+24|0}function REi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;u=u+1|0;c[a>>2]=u;while((e|0)<20){if(!(c[d+(e<<3)>>2]|0)){c[d+(e<<3)>>2]=u;c[d+((e<<3)+4)>>2]=b;c[d+((e<<3)+8)>>2]=0;return 0}e=e+1|0}Of(116);Of(111);Of(111);Of(32);Of(109);Of(97);Of(110);Of(121);Of(32);Of(115);Of(101);Of(116);Of(106);Of(109);Of(112);Of(115);Of(32);Of(105);Of(110);Of(32);Of(97);Of(32);Of(102);Of(117);Of(110);Of(99);Of(116);Of(105);Of(111);Of(110);Of(32);Of(99);Of(97);Of(108);Of(108);Of(44);Of(32);Of(98);Of(117);Of(105);Of(108);Of(100);Of(32);Of(119);Of(105);Of(116);Of(104);Of(32);Of(97);Of(32);Of(104);Of(105);Of(103);Of(104);Of(101);Of(114);Of(32);Of(118);Of(97);Of(108);Of(117);Of(101);Of(32);Of(102);Of(111);Of(114);Of(32);Of(77);Of(65);Of(88);Of(95);Of(83);Of(69);Of(84);Of(74);Of(77);Of(80);Of(83);Of(10);fa(0);return 0}function SEi(b){b=b|0;var c=0;c=b;while(a[c>>0]|0)c=c+1|0;return c-b|0}function TEi(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){H=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}H=(b|0)<0?-1:0;return b>>c-32|0}function UEi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e>>0]=f?0:a[c+e>>0]|0;f=f?1:(a[c+e>>0]|0)==0;e=e+1|0}return b|0}function VEi(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){H=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}H=0;return b>>>c-32|0}function WEi(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<3)>>2]|0;if(!e)break;if((e|0)==(a|0))return c[b+((d<<3)+4)>>2]|0;d=d+1|0}return 0}function XEi(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function YEi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return xc(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function ZEi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return (H=e,a-c>>>0|0)|0}function _Ei(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return (H=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function $Ei(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[m+(b>>>24)>>0]|0)+24|0}function aFi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else YEi(b,c,d)|0;return b|0}function bFi(b,c){b=b|0;c=c|0;var d=0;do{a[b+d>>0]=a[c+d>>0];d=d+1|0}while(a[c+(d-1)>>0]|0);return b|0}function cFi(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){H=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}H=a<<c-32;return 0}function dFi(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=da(d,c)|0;f=a>>>16;a=(e>>>16)+(da(d,f)|0)|0;d=b>>>16;b=da(d,c)|0;return (H=(a>>>16)+(da(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function eFi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=ZEi(e^a,f^b,e,f)|0;b=H;a=g^e;e=h^f;f=ZEi((jFi(i,b,ZEi(g^c,h^d,g,h)|0,H,0)|0)^a,H^e,a,e)|0;return f|0}function fFi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=ZEi(h^a,j^b,h,j)|0;b=H;jFi(m,b,ZEi(k^d,l^e,k,l)|0,H,g)|0;l=ZEi(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=H;i=f;return (H=j,l)|0}function gFi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=dFi(e,a)|0;f=H;return (H=(da(b,a)|0)+(da(d,e)|0)+f|f&0,c|0|0)|0}function hFi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jFi(a,b,c,d,0)|0;return e|0}function iFi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;jFi(a,b,d,e,g)|0;i=f;return (H=c[g+4>>2]|0,c[g>>2]|0)|0}function jFi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=a;h=b;i=h;j=d;k=e;l=k;if(!i){m=(f|0)!=0;if(!l){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return (H=n,o)|0}else{if(!m){n=0;o=0;return (H=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return (H=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=(QEi(l|0)|0)-(QEi(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!f){n=0;o=0;return (H=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return (H=n,o)|0}r=j-1|0;if(r&j){s=(QEi(j|0)|0)+33-(QEi(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(f){c[f>>2]=r&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return (H=n,o)|0}else{r=$Ei(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return (H=n,o)|0}}else{if(m){if(f){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return (H=n,o)|0}if(!g){if(f){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return (H=n,o)|0}r=l-1|0;if(!(r&l)){if(f){c[f>>2]=a|0;c[f+4>>2]=r&i|b&0}n=0;o=i>>>(($Ei(l|0)|0)>>>0);return (H=n,o)|0}r=(QEi(l|0)|0)-(QEi(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!f){n=0;o=0;return (H=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return (H=n,o)|0}while(0);if(!t){B=x;C=w;D=v;E=u;F=0;G=0}else{b=d|0|0;d=k|e&0;e=_Ei(b,d,-1,-1)|0;k=H;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;ZEi(e,k,g,a)|0;i=H;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=ZEi(g,a,l&b,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&d)|0;w=H;u=u-1|0}while((u|0)!=0);B=h;C=x;D=w;E=v;F=0;G=t}t=C;C=0;if(f){c[f>>2]=E;c[f+4>>2]=D}n=(t|0)>>>31|(B|C)<<1|(C<<1|t>>>31)&0|F;o=(t<<1|0>>>31)&-2|G;return (H=n,o)|0}function kFi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=ea(d);return ea(Jm[a&7](b|0,ea(c),ea(d)))}function lFi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Km[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function mFi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;Lm[a&1](b|0,ea(c),d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0)}function nFi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Mm[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)}function oFi(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;return Nm[a&3](b|0,+c,d|0)|0}function pFi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);return ea(Om[a&7](b|0,c|0,d|0,e|0,f|0,g|0,ea(h),i|0,j|0,k|0,l|0,m|0,n|0,ea(o)))}function qFi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=ea(i);return Pm[a&31](b|0,c|0,d|0,e|0,ea(f),g|0,h|0,ea(i))|0}function rFi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=ea(h);i=i|0;Qm[a&1](b|0,c|0,d|0,e|0,f|0,ea(g),ea(h),i|0)}function sFi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return Rm[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)|0}function tFi(a,b,c){a=a|0;b=b|0;c=ea(c);return ea(Sm[a&7](b|0,ea(c)))}function uFi(a,b,c){a=a|0;b=b|0;c=+c;return ea(Tm[a&1](b|0,+c))}function vFi(a,b,c){a=a|0;b=b|0;c=c|0;return ea(Um[a&63](b|0,c|0))}function wFi(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;return +Vm[a&1](+b,c|0,d|0)}function xFi(a,b){a=a|0;b=b|0;return +Wm[a&15](b|0)}function yFi(a,b){a=a|0;b=+b;return +Xm[a&15](+b)}function zFi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;return Ym[a&1](b|0,c|0,d|0,ea(e),f|0,g|0,h|0,i|0)|0}function AFi(a,b,c,d,e,f){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);Zm[a&15](b|0,ea(c),ea(d),ea(e),ea(f))}function BFi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return +_m[a&3](b|0,+c,+d)}function CFi(a,b,c){a=a|0;b=b|0;c=c|0;return +$m[a&63](b|0,c|0)}function DFi(a,b,c){a=a|0;b=b|0;c=+c;return +an[a&7](b|0,+c)}function EFi(a,b,c){a=a|0;b=b|0;c=ea(c);return +bn[a&1](b|0,ea(c))}function FFi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return cn[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function GFi(a,b,c,d,e,f,g){a=a|0;b=+b;c=+c;d=+d;e=+e;f=+f;g=+g;dn[a&1](+b,+c,+d,+e,+f,+g)}function HFi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=ea(m);n=ea(n);o=ea(o);p=ea(p);q=q|0;r=r|0;return en[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,ea(m),ea(n),ea(o),ea(p),q|0,r|0)|0}function IFi(a,b,c){a=a|0;b=+b;c=+c;fn[a&1](+b,+c)}function JFi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return gn[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function KFi(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=ea(h);i=ea(i);j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return hn[a&1](b|0,c|0,d|0,e|0,f|0,ea(g),ea(h),ea(i),j|0,k|0,l|0,m|0,n|0)|0}function LFi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;jn[a&3](b|0,ea(c),d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0)}function MFi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return kn[a&511](b|0,c|0,d|0,e|0)|0}function NFi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;return ln[a&1](b|0,c|0,ea(d),e|0,f|0)|0}function OFi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);return ea(mn[a&3](b|0,ea(c),ea(d),ea(e)))}function PFi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;nn[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function QFi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=ea(d);on[a&31](b|0,ea(c),ea(d))}function RFi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;pn[a&1](b|0,ea(c),d|0)}function SFi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);qn[a&7](b|0,ea(c),ea(d),ea(e))}function TFi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rn[a&127](b|0,c|0,d|0,e|0,f|0,g|0)}function UFi(a,b,c){a=a|0;b=+b;c=+c;return +sn[a&3](+b,+c)}function VFi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ea(tn[a&15](b|0,c|0,d|0))}function WFi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);return un[a&1](b|0,ea(c),ea(d),ea(e))|0}function XFi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);r=ea(r);s=ea(s);t=ea(t);u=u|0;return vn[a&3](b|0,c|0,d|0,e|0,f|0,ea(g),h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,ea(q),ea(r),ea(s),ea(t),u|0)|0}function YFi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=i|0;j=j|0;k=ea(k);return wn[a&1](b|0,c|0,d|0,e|0,ea(f),g|0,h|0,i|0,j|0,ea(k))|0}function ZFi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=ea(d);e=ea(e);f=ea(f);g=ea(g);h=ea(h);i=ea(i);xn[a&1](b|0,c|0,ea(d),ea(e),ea(f),ea(g),ea(h),ea(i))}function _Fi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;yn[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function $Fi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +zn[a&7](b|0,c|0,d|0)}function aGi(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;An[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)}function bGi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Bn[a&255](b|0,c|0,d|0,e|0,f|0)|0}function cGi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;i=i|0;j=ea(j);return Cn[a&7](b|0,c|0,d|0,e|0,f|0,ea(g),h|0,i|0,ea(j))|0}function dGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Dn[a&511](b|0,c|0,d|0,e|0)}function eGi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;En[a&127](b|0,c|0,d|0,e|0,f|0)}function fGi(a,b,c){a=a|0;b=b|0;c=ea(c);Fn[a&255](b|0,ea(c))}function gGi(a,b,c){a=a|0;b=b|0;c=+c;Gn[a&3](b|0,+c)}function hGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return Hn[a&1](b|0,c|0,+d,e|0)|0}function iGi(a,b,c){a=a|0;b=b|0;c=c|0;In[a&4095](b|0,c|0)}function jGi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;Jn[a&3](b|0,c|0,ea(d),e|0,f|0)}function kGi(a,b){a=a|0;b=b|0;return ea(Kn[a&255](b|0))}function lGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Ln[a&1](b|0,c|0,+d,e|0)}function mGi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=ea(j);k=k|0;l=l|0;m=m|0;n=n|0;o=ea(o);return ea(Mn[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,ea(j),k|0,l|0,m|0,n|0,ea(o)))}function nGi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Nn[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function oGi(a,b,c,d,e,f){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;On[a&3](b|0,ea(c),d|0,e|0,f|0)}function pGi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=ea(r);s=ea(s);t=ea(t);u=ea(u);v=v|0;return Pn[a&1](b|0,c|0,d|0,e|0,f|0,g|0,ea(h),i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,ea(r),ea(s),ea(t),ea(u),v|0)|0}function qGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +Qn[a&1](b|0,c|0,d|0,e|0)}function rGi(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;Rn[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)}function sGi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=ea(k);l=ea(l);m=ea(m);n=ea(n);o=o|0;p=p|0;return Sn[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,ea(k),ea(l),ea(m),ea(n),o|0,p|0)|0}function tGi(a,b,c){a=a|0;b=b|0;c=+c;return Tn[a&31](b|0,+c)|0}function uGi(a,b,c){a=a|0;b=b|0;c=ea(c);return Un[a&31](b|0,ea(c))|0}function vGi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;g=g|0;Vn[a&3](b|0,ea(c),d|0,e|0,f|0,g|0)}function wGi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Wn[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function xGi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;Xn[a&7](b|0,ea(c),d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)}function yGi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Yn[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function zGi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=ea(h);Zn[a&1](b|0,c|0,d|0,e|0,f|0,g|0,ea(h))}function AGi(a,b,c){a=a|0;b=b|0;c=c|0;return _n[a&4095](b|0,c|0)|0}function BGi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;return $n[a&1](b|0,c|0,d|0,ea(e),f|0,g|0)|0}function CGi(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);ao[a&7](ea(b),ea(c),ea(d),ea(e))}function DGi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=ea(l);bo[a&1](b|0,c|0,d|0,e|0,ea(f),g|0,h|0,i|0,j|0,k|0,ea(l))}function EGi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;co[a&2047](b|0,c|0,d|0)}function FGi(a){a=a|0;eo[a&511]()}function GGi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;fo[a&7](b|0,c|0,+d)}function HGi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);go[a&63](b|0,c|0,ea(d))}function IGi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;return ho[a&3](b|0,c|0,d|0,ea(e),f|0)|0}function JGi(a,b){a=a|0;b=+b;io[a&1](+b)}function KGi(a,b){a=a|0;b=ea(b);jo[a&3](ea(b))}function LGi(a,b){a=a|0;b=b|0;ko[a&4095](b|0)}function MGi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return lo[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function NGi(a,b){a=a|0;b=b|0;return mo[a&4095](b|0)|0}function OGi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=ea(d);return no[a&1](b|0,ea(c),ea(d))|0}function PGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;oo[a&7](b|0,c|0,ea(d),e|0)}function QGi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return po[a&7](b|0,c|0,d|0,e|0,ea(f),g|0,h|0,i|0,j|0,k|0,l|0)|0}function RGi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=ea(l);return qo[a&1](b|0,c|0,d|0,e|0,ea(f),g|0,h|0,i|0,j|0,k|0,ea(l))|0}function SGi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;return ro[a&7](b|0,ea(c),d|0)|0}function TGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);so[a&15](b|0,c|0,d|0,ea(e))}function UGi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=ea(f);g=g|0;h=h|0;to[a&3](b|0,c|0,d|0,ea(e),ea(f),g|0,h|0)}function VGi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;uo[a&1](b|0,ea(c),d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0,z|0)}function WGi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return vo[a&1](b|0,ea(c),d|0,e|0,f|0,g|0,h|0)|0}function XGi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;return wo[a&7](b|0,c|0,ea(d),e|0)|0}function YGi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xo[a&2047](b|0,c|0,d|0)|0}function ZGi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=ea(e);f=ea(f);yo[a&3](b|0,c|0,ea(d),ea(e),ea(f))}function _Gi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=ea(e);f=f|0;zo[a&3](b|0,c|0,ea(d),ea(e),f|0)}function $Gi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);return Ao[a&3](b|0,c|0,ea(d))|0}function aHi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Bo[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function bHi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;Co[a&3](b|0,c|0,d|0,ea(e),f|0)}function cHi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=ea(g);h=ea(h);Do[a&1](b|0,ea(c),ea(d),ea(e),ea(f),ea(g),ea(h))}function dHi(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return Eo[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)|0}function eHi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Fo[a&1](b|0,c|0,d|0,ea(e),f|0,g|0,h|0,i|0,j|0)|0}function fHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;Go[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0,z|0,A|0,B|0,C|0,D|0)}function gHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=ea(g);h=ea(h);i=ea(i);j=ea(j);k=ea(k);l=ea(l);m=ea(m);n=ea(n);o=o|0;p=p|0;q=q|0;r=r|0;Ho[a&1](b|0,ea(c),ea(d),ea(e),ea(f),ea(g),ea(h),ea(i),ea(j),ea(k),ea(l),ea(m),ea(n),o|0,p|0,q|0,r|0)}function hHi(a,b,c){a=a|0;b=ea(b);c=c|0;Io[a&1](ea(b),c|0)}function iHi(a){a=a|0;return Jo[a&127]()|0}function jHi(a,b,c){a=a|0;b=ea(b);c=ea(c);Ko[a&3](ea(b),ea(c))}function kHi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Lo[a&1](b|0,c|0,d|0,ea(e),f|0,g|0,h|0,i|0,j|0)}function lHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;return Mo[a&1](b|0,c|0,d|0,e|0,f|0,ea(g),h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0)|0}function mHi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=ea(d);e=ea(e);f=ea(f);g=ea(g);No[a&1](b|0,c|0,ea(d),ea(e),ea(f),ea(g))}function nHi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Oo[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function oHi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=g|0;Po[a&3](b|0,ea(c),ea(d),ea(e),ea(f),g|0)}function pHi(a,b,c){a=a|0;b=ea(b);c=ea(c);fa(0);return ea(0)}function qHi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fa(1);return 0}function rHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;fa(2)}function sHi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;fa(3)}function tHi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Bk(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function uHi(a,b,c){a=a|0;b=+b;c=c|0;fa(4);return 0}function vHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);fa(5);return ea(0)}function wHi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=ea(h);fa(6);return 0}function xHi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=ea(g);h=h|0;fa(7)}function yHi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;fa(8);return 0}function zHi(a,b){a=a|0;b=ea(b);fa(9);return ea(0)}function AHi(a,b){a=a|0;b=+b;fa(10);return ea(0)}function BHi(a,b){a=a|0;b=b|0;fa(11);return ea(0)}function CHi(a,b,c){a=+a;b=b|0;c=c|0;fa(12);return 0.0}function DHi(a){a=a|0;fa(13);return 0.0}function EHi(a){a=+a;fa(14);return 0.0}function FHi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;g=g|0;h=h|0;fa(15);return 0}function GHi(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);fa(16)}function HHi(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);sc(a|0,+b,+c,+d,+e)}function IHi(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);vk(a|0,+b,+c,+d,+e)}function JHi(a,b,c,d,e){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);$i(a|0,+b,+c,+d,+e)}function KHi(a,b,c){a=a|0;b=+b;c=+c;fa(17);return 0.0}function LHi(a,b){a=a|0;b=b|0;fa(18);return 0.0}function MHi(a,b){a=a|0;b=+b;fa(19);return 0.0}function NHi(a,b){a=a|0;b=ea(b);fa(20);return 0.0}function OHi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fa(21);return 0}function PHi(a,b,c,d,e,f){a=+a;b=+b;c=+c;d=+d;e=+e;f=+f;fa(22)}function QHi(a,b,c,d,e,f){a=+a;b=+b;c=+c;d=+d;e=+e;f=+f;lm(+a,+b,+c,+d,+e,+f)}function RHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=ea(l);m=ea(m);n=ea(n);o=ea(o);p=p|0;q=q|0;fa(23);return 0}function SHi(a,b){a=+a;b=+b;fa(24)}function THi(a,b){a=+a;b=+b;Jd(+a,+b)}function UHi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fa(25);return 0}function VHi(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=ea(g);h=ea(h);i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;fa(26);return 0}function WHi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;fa(27)}function XHi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fa(28);return 0}function YHi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ul(a|0,b|0,c|0,d|0)|0}function ZHi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;fa(29);return 0}function _Hi(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);fa(30);return ea(0)}function $Hi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;fa(31)}function aIi(a,b,c){a=a|0;b=ea(b);c=ea(c);fa(32)}function bIi(a,b,c){a=a|0;b=ea(b);c=ea(c);Dl(a|0,+b,+c)}function cIi(a,b,c){a=a|0;b=ea(b);c=ea(c);Jf(a|0,+b,+c)}function dIi(a,b,c){a=a|0;b=ea(b);c=c|0;fa(33)}function eIi(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);fa(34)}function fIi(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);wi(a|0,+b,+c,+d)}function gIi(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);od(a|0,+b,+c,+d)}function hIi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fa(35)}function iIi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mi(a|0,b|0,c|0,d|0,e|0,f|0)}function jIi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gk(a|0,b|0,c|0,d|0,e|0,f|0)}function kIi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Pj(a|0,b|0,c|0,d|0,e|0,f|0)}function lIi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fk(a|0,b|0,c|0,d|0,e|0,f|0)}function mIi(a,b){a=+a;b=+b;fa(36);return 0.0}function nIi(a,b,c){a=a|0;b=b|0;c=c|0;fa(37);return ea(0)}function oIi(a,b,c,d){a=a|0;b=ea(b);c=ea(c);d=ea(d);fa(38);return 0}function pIi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=ea(p);q=ea(q);r=ea(r);s=ea(s);t=t|0;fa(39);return 0}function qIi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;j=ea(j);fa(40);return 0}function rIi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=ea(g);h=ea(h);fa(41)}function sIi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;fa(42)}function tIi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;oe(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function uIi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Ug(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function vIi(a,b,c){a=a|0;b=b|0;c=c|0;fa(43);return 0.0}function wIi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;fa(44)}function xIi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fa(45);return 0}function yIi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=ea(i);fa(46);return 0}function zIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fa(47)}function AIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;il(a|0,b|0,c|0,d|0)}function BIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hj(a|0,b|0,c|0,d|0)}function CIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Df(a|0,b|0,c|0,d|0)}function DIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Vj(a|0,b|0,c|0,d|0)}function EIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Bf(a|0,b|0,c|0,d|0)}function FIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Jc(a|0,b|0,c|0,d|0)}function GIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Fi(a|0,b|0,c|0,d|0)}function HIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Pk(a|0,b|0,c|0,d|0)}function IIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ok(a|0,b|0,c|0,d|0)}function JIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ch(a|0,b|0,c|0,d|0)}function KIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Og(a|0,b|0,c|0,d|0)}function LIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ci(a|0,b|0,c|0,d|0)}function MIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xh(a|0,b|0,c|0,d|0)}function NIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;If(a|0,b|0,c|0,d|0)}function OIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Fe(a|0,b|0,c|0,d|0)}function PIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rc(a|0,b|0,c|0,d|0)}function QIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_c(a|0,b|0,c|0,d|0)}function RIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ll(a|0,b|0,c|0,d|0)}function SIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Kg(a|0,b|0,c|0,d|0)}function TIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$e(a|0,b|0,c|0,d|0)}function UIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Pf(a|0,b|0,c|0,d|0)}function VIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ge(a|0,b|0,c|0,d|0)}function WIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ci(a|0,b|0,c|0,d|0)}function XIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Uc(a|0,b|0,c|0,d|0)}function YIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ag(a|0,b|0,c|0,d|0)}function ZIi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mj(a|0,b|0,c|0,d|0)}function _Ii(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qi(a|0,b|0,c|0,d|0)}function $Ii(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bm(a|0,b|0,c|0,d|0)}function aJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xk(a|0,b|0,c|0,d|0)}function bJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yl(a|0,b|0,c|0,d|0)}function cJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ff(a|0,b|0,c|0,d|0)}function dJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;te(a|0,b|0,c|0,d|0)}function eJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fj(a|0,b|0,c|0,d|0)}function fJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ql(a|0,b|0,c|0,d|0)}function gJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;th(a|0,b|0,c|0,d|0)}function hJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;de(a|0,b|0,c|0,d|0)}function iJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kd(a|0,b|0,c|0,d|0)}function jJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Kl(a|0,b|0,c|0,d|0)}function kJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ri(a|0,b|0,c|0,d|0)}function lJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Wc(a|0,b|0,c|0,d|0)}function mJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ol(a|0,b|0,c|0,d|0)}function nJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;di(a|0,b|0,c|0,d|0)}function oJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gh(a|0,b|0,c|0,d|0)}function pJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;be(a|0,b|0,c|0,d|0)}function qJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pc(a|0,b|0,c|0,d|0)}function rJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nd(a|0,b|0,c|0,d|0)}function sJi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ag(a|0,b|0,c|0,d|0)}function tJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fa(48)}function uJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kh(a|0,b|0,c|0,d|0,e|0)}function vJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ac(a|0,b|0,c|0,d|0,e|0)}function wJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ud(a|0,b|0,c|0,d|0,e|0)}function xJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Sj(a|0,b|0,c|0,d|0,e|0)}function yJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Yd(a|0,b|0,c|0,d|0,e|0)}function zJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Qf(a|0,b|0,c|0,d|0,e|0)}function AJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ai(a|0,b|0,c|0,d|0,e|0)}function BJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eg(a|0,b|0,c|0,d|0,e|0)}function CJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Qd(a|0,b|0,c|0,d|0,e|0)}function DJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xl(a|0,b|0,c|0,d|0,e|0)}function EJi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_i(a|0,b|0,c|0,d|0,e|0)}function FJi(a,b){a=a|0;b=ea(b);fa(49)}function GJi(a,b){a=a|0;b=ea(b);$d(a|0,+b)}function HJi(a,b){a=a|0;b=ea(b);li(a|0,+b)}function IJi(a,b){a=a|0;b=+b;fa(50)}function JJi(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;fa(51);return 0}function KJi(a,b){a=a|0;b=b|0;fa(52)}function LJi(a,b){a=a|0;b=b|0;uh(a|0,b|0)}function MJi(a,b){a=a|0;b=b|0;jd(a|0,b|0)}function NJi(a,b){a=a|0;b=b|0;Ne(a|0,b|0)}function OJi(a,b){a=a|0;b=b|0;$f(a|0,b|0)}function PJi(a,b){a=a|0;b=b|0;ti(a|0,b|0)}function QJi(a,b){a=a|0;b=b|0;rg(a|0,b|0)}function RJi(a,b){a=a|0;b=b|0;Ce(a|0,b|0)}function SJi(a,b){a=a|0;b=b|0;Vd(a|0,b|0)}function TJi(a,b){a=a|0;b=b|0;hg(a|0,b|0)}function UJi(a,b){a=a|0;b=b|0;vj(a|0,b|0)}function VJi(a,b){a=a|0;b=b|0;yi(a|0,b|0)}function WJi(a,b){a=a|0;b=b|0;bi(a|0,b|0)}function XJi(a,b){a=a|0;b=b|0;bg(a|0,b|0)}function YJi(a,b){a=a|0;b=b|0;im(a|0,b|0)}function ZJi(a,b){a=a|0;b=b|0;Rf(a|0,b|0)}function _Ji(a,b){a=a|0;b=b|0;Sf(a|0,b|0)}function $Ji(a,b){a=a|0;b=b|0;pm(a|0,b|0)}function aKi(a,b){a=a|0;b=b|0;Gl(a|0,b|0)}function bKi(a,b){a=a|0;b=b|0;ck(a|0,b|0)}function cKi(a,b){a=a|0;b=b|0;je(a|0,b|0)}function dKi(a,b){a=a|0;b=b|0;hd(a|0,b|0)}function eKi(a,b){a=a|0;b=b|0;Di(a|0,b|0)}function fKi(a,b){a=a|0;b=b|0;Yk(a|0,b|0)}function gKi(a,b){a=a|0;b=b|0;cm(a|0,b|0)}function hKi(a,b){a=a|0;b=b|0;Gc(a|0,b|0)}function iKi(a,b){a=a|0;b=b|0;xm(a|0,b|0)}function jKi(a,b){a=a|0;b=b|0;Mk(a|0,b|0)}function kKi(a,b){a=a|0;b=b|0;bj(a|0,b|0)}function lKi(a,b){a=a|0;b=b|0;qc(a|0,b|0)}function mKi(a,b){a=a|0;b=b|0;Ae(a|0,b|0)}function nKi(a,b){a=a|0;b=b|0;_e(a|0,b|0)}function oKi(a,b){a=a|0;b=b|0;ri(a|0,b|0)}function pKi(a,b){a=a|0;b=b|0;Vg(a|0,b|0)}function qKi(a,b){a=a|0;b=b|0;jh(a|0,b|0)}function rKi(a,b){a=a|0;b=b|0;cf(a|0,b|0)}function sKi(a,b){a=a|0;b=b|0;tl(a|0,b|0)}function tKi(a,b){a=a|0;b=b|0;zh(a|0,b|0)}function uKi(a,b){a=a|0;b=b|0;Zi(a|0,b|0)}function vKi(a,b){a=a|0;b=b|0;ol(a|0,b|0)}function wKi(a,b){a=a|0;b=b|0;Dc(a|0,b|0)}function xKi(a,b){a=a|0;b=b|0;ze(a|0,b|0)}function yKi(a,b){a=a|0;b=b|0;qe(a|0,b|0)}function zKi(a,b){a=a|0;b=b|0;Mg(a|0,b|0)}function AKi(a,b){a=a|0;b=b|0;Dj(a|0,b|0)}function BKi(a,b){a=a|0;b=b|0;Dd(a|0,b|0)}function CKi(a,b){a=a|0;b=b|0;Pc(a|0,b|0)}function DKi(a,b){a=a|0;b=b|0;_j(a|0,b|0)}function EKi(a,b){a=a|0;b=b|0;nl(a|0,b|0)}function FKi(a,b){a=a|0;b=b|0;Zl(a|0,b|0)}function GKi(a,b){a=a|0;b=b|0;Dg(a|0,b|0)}function HKi(a,b){a=a|0;b=b|0;Ik(a|0,b|0)}function IKi(a,b){a=a|0;b=b|0;nj(a|0,b|0)}function JKi(a,b){a=a|0;b=b|0;Vk(a|0,b|0)}function KKi(a,b){a=a|0;b=b|0;wm(a|0,b|0)}function LKi(a,b){a=a|0;b=b|0;af(a|0,b|0)}function MKi(a,b){a=a|0;b=b|0;Lf(a|0,b|0)}function NKi(a,b){a=a|0;b=b|0;Dk(a|0,b|0)}function OKi(a,b){a=a|0;b=b|0;Ke(a|0,b|0)}function PKi(a,b){a=a|0;b=b|0;kl(a|0,b|0)}function QKi(a,b){a=a|0;b=b|0;Rl(a|0,b|0)}function RKi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=d|0;e=e|0;fa(53)}function SKi(a){a=a|0;fa(54);return ea(0)}function TKi(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;fa(55)}function UKi(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=ea(i);j=j|0;k=k|0;l=l|0;m=m|0;n=ea(n);fa(56);return ea(0)}function VKi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;fa(57)}function WKi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;vd(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function XKi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xj(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function YKi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;rh(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function ZKi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Pd(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function _Ki(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Od(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function $Ki(a,b,c,d,e){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;fa(58)}function aLi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=ea(q);r=ea(r);s=ea(s);t=ea(t);u=u|0;fa(59);return 0}function bLi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fa(60);return 0.0}function cLi(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;fa(61)}function dLi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=ea(j);k=ea(k);l=ea(l);m=ea(m);n=n|0;o=o|0;fa(62);return 0}function eLi(a,b){a=a|0;b=+b;fa(63);return 0}function fLi(a,b){a=a|0;b=ea(b);fa(64);return 0}function gLi(a,b,c,d,e,f){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;fa(65)}function hLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fa(66)}function iLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zg(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function jLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fm(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function kLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xg(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function lLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Uh(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function mLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pg(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function nLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pf(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function oLi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;fa(67)}function pLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fa(68)}function qLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ae(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function rLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Yl(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function sLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;De(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function tLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ni(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function uLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ak(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function vLi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Tg(a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function wLi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=ea(g);fa(69)}function xLi(a,b){a=a|0;b=b|0;fa(70);return 0}function yLi(a,b){a=a|0;b=b|0;return Rh(a|0,b|0)|0}function zLi(a,b){a=a|0;b=b|0;return Ej(a|0,b|0)|0}function ALi(a,b){a=a|0;b=b|0;return Xd(a|0,b|0)|0}function BLi(a,b){a=a|0;b=b|0;return Ii(a|0,b|0)|0}function CLi(a,b){a=a|0;b=b|0;return gd(a|0,b|0)|0}function DLi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;fa(71);return 0}function ELi(a,b,c,d){a=ea(a);b=ea(b);c=ea(c);d=ea(d);fa(72)}function FLi(a,b,c,d){a=ea(a);b=ea(b);c=ea(c);d=ea(d);zd(+a,+b,+c,+d)}function GLi(a,b,c,d){a=ea(a);b=ea(b);c=ea(c);d=ea(d);jj(+a,+b,+c,+d)}function HLi(a,b,c,d){a=ea(a);b=ea(b);c=ea(c);d=ea(d);Wj(+a,+b,+c,+d)}function ILi(a,b,c,d){a=ea(a);b=ea(b);c=ea(c);d=ea(d);mk(+a,+b,+c,+d)}function JLi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=ea(k);fa(73)}function KLi(a,b,c){a=a|0;b=b|0;c=c|0;fa(74)}function LLi(a,b,c){a=a|0;b=b|0;c=c|0;fh(a|0,b|0,c|0)}function MLi(a,b,c){a=a|0;b=b|0;c=c|0;Gd(a|0,b|0,c|0)}function NLi(a,b,c){a=a|0;b=b|0;c=c|0;Ng(a|0,b|0,c|0)}function OLi(a,b,c){a=a|0;b=b|0;c=c|0;Zg(a|0,b|0,c|0)}function PLi(a,b,c){a=a|0;b=b|0;c=c|0;Ed(a|0,b|0,c|0)}function QLi(a,b,c){a=a|0;b=b|0;c=c|0;ei(a|0,b|0,c|0)}function RLi(a,b,c){a=a|0;b=b|0;c=c|0;oi(a|0,b|0,c|0)}function SLi(a,b,c){a=a|0;b=b|0;c=c|0;fe(a|0,b|0,c|0)}function TLi(a,b,c){a=a|0;b=b|0;c=c|0;Bh(a|0,b|0,c|0)}function ULi(a,b,c){a=a|0;b=b|0;c=c|0;wk(a|0,b|0,c|0)}function VLi(a,b,c){a=a|0;b=b|0;c=c|0;Zj(a|0,b|0,c|0)}function WLi(a,b,c){a=a|0;b=b|0;c=c|0;fg(a|0,b|0,c|0)}function XLi(a,b,c){a=a|0;b=b|0;c=c|0;xe(a|0,b|0,c|0)}function YLi(a,b,c){a=a|0;b=b|0;c=c|0;Gh(a|0,b|0,c|0)}function ZLi(a,b,c){a=a|0;b=b|0;c=c|0;Bg(a|0,b|0,c|0)}function _Li(a,b,c){a=a|0;b=b|0;c=c|0;zl(a|0,b|0,c|0)}function $Li(a,b,c){a=a|0;b=b|0;c=c|0;Tf(a|0,b|0,c|0)}function aMi(a,b,c){a=a|0;b=b|0;c=c|0;bh(a|0,b|0,c|0)}function bMi(a,b,c){a=a|0;b=b|0;c=c|0;lh(a|0,b|0,c|0)}function cMi(a,b,c){a=a|0;b=b|0;c=c|0;tf(a|0,b|0,c|0)}function dMi(a,b,c){a=a|0;b=b|0;c=c|0;Hl(a|0,b|0,c|0)}function eMi(a,b,c){a=a|0;b=b|0;c=c|0;ah(a|0,b|0,c|0)}function fMi(a,b,c){a=a|0;b=b|0;c=c|0;El(a|0,b|0,c|0)}function gMi(a,b,c){a=a|0;b=b|0;c=c|0;Cc(a|0,b|0,c|0)}function hMi(a,b,c){a=a|0;b=b|0;c=c|0;nc(a|0,b|0,c|0)}function iMi(a,b,c){a=a|0;b=b|0;c=c|0;xi(a|0,b|0,c|0)}function jMi(a,b,c){a=a|0;b=b|0;c=c|0;Sc(a|0,b|0,c|0)}function kMi(a,b,c){a=a|0;b=b|0;c=c|0;Mc(a|0,b|0,c|0)}function lMi(a,b,c){a=a|0;b=b|0;c=c|0;Cd(a|0,b|0,c|0)}function mMi(a,b,c){a=a|0;b=b|0;c=c|0;dk(a|0,b|0,c|0)}function nMi(a,b,c){a=a|0;b=b|0;c=c|0;he(a|0,b|0,c|0)}function oMi(a,b,c){a=a|0;b=b|0;c=c|0;Jg(a|0,b|0,c|0)}function pMi(a,b,c){a=a|0;b=b|0;c=c|0;Bj(a|0,b|0,c|0)}function qMi(a,b,c){a=a|0;b=b|0;c=c|0;wg(a|0,b|0,c|0)}function rMi(a,b,c){a=a|0;b=b|0;c=c|0;Al(a|0,b|0,c|0)}function sMi(a,b,c){a=a|0;b=b|0;c=c|0;Kk(a|0,b|0,c|0)}function tMi(a,b,c){a=a|0;b=b|0;c=c|0;wd(a|0,b|0,c|0)}function uMi(a,b,c){a=a|0;b=b|0;c=c|0;ym(a|0,b|0,c|0)}function vMi(a,b,c){a=a|0;b=b|0;c=c|0;Bd(a|0,b|0,c|0)}function wMi(a,b,c){a=a|0;b=b|0;c=c|0;Ff(a|0,b|0,c|0)}function xMi(a,b,c){a=a|0;b=b|0;c=c|0;Zf(a|0,b|0,c|0)}function yMi(a,b,c){a=a|0;b=b|0;c=c|0;ye(a|0,b|0,c|0)}function zMi(a,b,c){a=a|0;b=b|0;c=c|0;Me(a|0,b|0,c|0)}function AMi(a,b,c){a=a|0;b=b|0;c=c|0;ue(a|0,b|0,c|0)}function BMi(a,b,c){a=a|0;b=b|0;c=c|0;kj(a|0,b|0,c|0)}function CMi(a,b,c){a=a|0;b=b|0;c=c|0;tk(a|0,b|0,c|0)}function DMi(a,b,c){a=a|0;b=b|0;c=c|0;Zk(a|0,b|0,c|0)}function EMi(a,b,c){a=a|0;b=b|0;c=c|0;Hg(a|0,b|0,c|0)}function FMi(a,b,c){a=a|0;b=b|0;c=c|0;jl(a|0,b|0,c|0)}function GMi(a,b,c){a=a|0;b=b|0;c=c|0;jk(a|0,b|0,c|0)}function HMi(a,b,c){a=a|0;b=b|0;c=c|0;Rk(a|0,b|0,c|0)}function IMi(a,b,c){a=a|0;b=b|0;c=c|0;Sd(a|0,b|0,c|0)}function JMi(a,b,c){a=a|0;b=b|0;c=c|0;me(a|0,b|0,c|0)}function KMi(){fa(75)}function LMi(){lj()}function MMi(){Ad()}function NMi(){_l()}function OMi(){Ic()}function PMi(){$l()}function QMi(){Ah()}function RMi(){Xf()}function SMi(){bd()}function TMi(a,b,c){a=a|0;b=b|0;c=+c;fa(76)}function UMi(a,b,c){a=a|0;b=b|0;c=ea(c);fa(77)}function VMi(a,b,c){a=a|0;b=b|0;c=ea(c);Qk(a|0,b|0,+c)}function WMi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;fa(78);return 0}function XMi(a){a=+a;fa(79)}function YMi(a){a=+a;Yf(+a)}function ZMi(a){a=ea(a);fa(80)}function _Mi(a){a=ea(a);Ti(+a)}function $Mi(a){a=ea(a);el(+a)}function aNi(a){a=ea(a);Zh(+a)}function bNi(a){a=a|0;fa(81)}function cNi(a){a=a|0;Md(a|0)}function dNi(a){a=a|0;Gj(a|0)}function eNi(a){a=a|0;oc(a|0)}function fNi(a){a=a|0;Tl(a|0)}function gNi(a){a=a|0;rd(a|0)}function hNi(a){a=a|0;Jh(a|0)}function iNi(a){a=a|0;am(a|0)}function jNi(a){a=a|0;$k(a|0)}function kNi(a){a=a|0;Yc(a|0)}function lNi(a){a=a|0;sh(a|0)}function mNi(a){a=a|0;wc(a|0)}function nNi(a){a=a|0;Hi(a|0)}function oNi(a){a=a|0;Rd(a|0)}function pNi(a){a=a|0;Gg(a|0)}function qNi(a){a=a|0;qf(a|0)}function rNi(a){a=a|0;se(a|0)}function sNi(a){a=a|0;tm(a|0)}function tNi(a){a=a|0;Ee(a|0)}function uNi(a){a=a|0;cd(a|0)}function vNi(a){a=a|0;Yh(a|0)}function wNi(a){a=a|0;Td(a|0)}function xNi(a){a=a|0;Hj(a|0)}function yNi(a){a=a|0;Ei(a|0)}function zNi(a){a=a|0;Fj(a|0)}function ANi(a){a=a|0;Fl(a|0)}function BNi(a){a=a|0;Kj(a|0)}function CNi(a){a=a|0;Lh(a|0)}function DNi(a){a=a|0;Ef(a|0)}function ENi(a){a=a|0;df(a|0)}function FNi(a){a=a|0;Oi(a|0)}function GNi(a){a=a|0;zi(a|0)}function HNi(a){a=a|0;sm(a|0)}function INi(a){a=a|0;hl(a|0)}function JNi(a){a=a|0;md(a|0)}function KNi(a){a=a|0;Ji(a|0)}function LNi(a){a=a|0;Se(a|0)}function MNi(a){a=a|0;tc(a|0)}function NNi(a){a=a|0;ll(a|0)}function ONi(a){a=a|0;Xi(a|0)}function PNi(a){a=a|0;Hh(a|0)}function QNi(a){a=a|0;Ie(a|0)}function RNi(a){a=a|0;Af(a|0)}function SNi(a){a=a|0;Uf(a|0)}function TNi(a){a=a|0;Ql(a|0)}function UNi(a){a=a|0;og(a|0)}function VNi(a){a=a|0;Wl(a|0)}function WNi(a){a=a|0;um(a|0)}function XNi(a){a=a|0;ne(a|0)}function YNi(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;fa(82);return 0}function ZNi(a){a=a|0;fa(83);return 0}function _Ni(a){a=a|0;return kg(a|0)|0}function $Ni(a){a=a|0;return Hd(a|0)|0}function aOi(a){a=a|0;return Nl(a|0)|0}function bOi(a){a=a|0;return Gi(a|0)|0}function cOi(a){a=a|0;return Ek(a|0)|0}function dOi(a){a=a|0;return qm(a|0)|0}function eOi(a){a=a|0;return ki(a|0)|0}function fOi(a){a=a|0;return sj(a|0)|0}function gOi(a){a=a|0;return Il(a|0)|0}function hOi(a){a=a|0;return oh(a|0)|0}function iOi(a){a=a|0;return Je(a|0)|0}function jOi(a){a=a|0;return Fk(a|0)|0}function kOi(a){a=a|0;return Ai(a|0)|0}function lOi(a){a=a|0;return kf(a|0)|0}function mOi(a,b,c){a=a|0;b=ea(b);c=ea(c);fa(84);return 0}function nOi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;fa(85)}function oOi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;fa(86);return 0}function pOi(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=ea(e);f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=ea(k);fa(87);return 0}function qOi(a,b,c){a=a|0;b=ea(b);c=c|0;fa(88);return 0}function rOi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=ea(d);fa(89)}function sOi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=ea(d);e=ea(e);f=f|0;g=g|0;fa(90)}function tOi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;fa(91)}function uOi(a,b,c,d,e,f,g){a=a|0;b=ea(b);c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fa(92);return 0}function vOi(a,b,c,d){a=a|0;b=b|0;c=ea(c);d=d|0;fa(93);return 0}function wOi(a,b,c){a=a|0;b=b|0;c=c|0;fa(94);return 0}function xOi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);fa(95)}function yOi(a,b,c,d,e){a=a|0;b=b|0;c=ea(c);d=ea(d);e=e|0;fa(96)}function zOi(a,b,c){a=a|0;b=b|0;c=ea(c);fa(97);return 0}function AOi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;fa(98)}function BOi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;fa(99)}function COi(a,b,c,d,e,f,g){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=ea(g);fa(100)}function DOi(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;fa(101);return 0}function EOi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fa(102);return 0}function FOi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;fa(103)}function GOi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=ea(f);g=ea(g);h=ea(h);i=ea(i);j=ea(j);k=ea(k);l=ea(l);m=ea(m);n=n|0;o=o|0;p=p|0;q=q|0;fa(104)}function HOi(a,b){a=ea(a);b=b|0;fa(105)}function IOi(a,b){a=ea(a);b=b|0;km(+a,b|0)}function JOi(){fa(106);return 0}function KOi(){return Nh()|0}function LOi(){return hm()|0}function MOi(){return Yj()|0}function NOi(){return Nf()|0}function OOi(a,b){a=ea(a);b=ea(b);fa(107)}function POi(a,b){a=ea(a);b=ea(b);Ve(+a,+b)}function QOi(a,b){a=ea(a);b=ea(b);nm(+a,+b)}function ROi(a,b){a=ea(a);b=ea(b);kk(+a,+b)}function SOi(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=ea(d);e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fa(108)}function TOi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=ea(f);g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;fa(109);return 0}function UOi(a,b,c,d,e,f){a=a|0;b=b|0;c=ea(c);d=ea(d);e=ea(e);f=ea(f);fa(110)}function VOi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;fa(111);return 0}function WOi(a,b,c,d,e,f){a=a|0;b=ea(b);c=ea(c);d=ea(d);e=ea(e);f=f|0;fa(112)}

// EMSCRIPTEN_END_FUNCS

 var Jm = [ pHi, gAb, I6e, N7e, zB, pHi, pHi, pHi ];
 var Km = [ qHi, y9a, z9a, A9a, B9a, C9a, D9a, E9a, F9a, G9a, H9a, I9a, J9a, cZ, gZ, s1, _2, Kvb, Lvb, Mvb, Nvb, Ovb, Pvb, Qvb, Rvb, Svb, Tvb, Uvb, Vvb, Wvb, Xvb, Yvb, Zvb, _vb, $vb, awb, bwb, cwb, dwb, ewb, ipd, kpd, Ipd, kqd, lqd, crd, frd, ird, yre, Xre, w$e, Eff, bpf, hpf, uvf, _yf, PDf, sEf, qEf, gHf, YGf, OKf, RKf, TKf, UKf, SKf, MRf, QRf, IUf, bVf, $Uf, PUf, gWf, ZXf, zYf, jZf, o_f, U_f, B0f, L0f, u3f, U3f, Dcg, Hcg, Jeg, Meg, sfg, ufg, Mfg, Qfg, _fg, dgg, lgg, ygg, Cgg, Rig, $pg, cqg, dqg, Gqg, stg, bxg, i2g, k2g, m2g, cD, zx, bE, jE, cOb, HKd, kMd, cNd, JNd, INd, HNd, CNd, Dce, Vee, qHi, qHi, qHi, qHi, qHi, qHi, qHi, qHi, qHi ];
 var Lm = [ rHi, Owa ];
 var Mm = [ sHi, cse, tHi, sHi ];
 var Nm = [ uHi, Lvg, Cvg, uHi ];
 var Om = [ vHi, vrb, wrb, xrb, yrb, zrb, vHi, vHi ];
 var Pm = [ wHi, vNa, wNa, xNa, HNa, yNa, QQa, WRa, VKa, INa, zNa, JNa, KNa, ANa, RQa, YRa, WKa, XKa, YKa, ZKa, wHi, wHi, wHi, wHi, wHi, wHi, wHi, wHi, wHi, wHi, wHi, wHi ];
 var Qm = [ xHi, p6e ];
 var Rm = [ yHi, fLf, kgg, yHi ];
 var Sm = [ zHi, sef, tef, ncf, Llg, vsg, IB, pMd ];
 var Tm = [ AHi, Klg ];
 var Um = [ BHi, T0, $Ac, fBc, Tad, Mbf, Ubf, Icf, Vdf, lef, Kof, Spf, wqf, erf, Lrf, lsf, Rsf, stf, euf, Ruf, _wf, Gxf, vyf, Bzf, iAf, cCf, Hlg, Ilg, Jlg, Mlg, Olg, Plg, Rlg, Tlg, Nog, opg, cWg, sFa, xFa, zFa, zGa, CGa, KGa, EHa, HHa, KHa, w5a, QAd, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi, BHi ];
 var Vm = [ CHi, Fv ];
 var Wm = [ DHi, NVe, kxg, lxg, mxg, nxg, oxg, yu, GC, DHi, DHi, DHi, DHi, DHi, DHi, DHi ];
 var Xm = [ EHi, ov, pv, qv, sv, tv, uv, vv, wv, xv, zv, Av, Bv, Cv, Dv, Ev ];
 var Ym = [ FHi, Y2 ];
 var Zm = [ GHi, Hoc, ccf, ocf, F6e, H4e, OAd, HHi, IHi, JHi, GHi, GHi, GHi, GHi, GHi, GHi ];
 var _m = [ KHi, Esg, yB, KHi ];
 var $m = [ LHi, h$e, g$e, j$e, Y1e, Fof, Npf, rqf, $qf, Grf, gsf, Msf, ntf, $tf, Muf, Vwf, Bxf, qyf, ezf, Czf, dAf, ZBf, okg, pkg, qkg, tkg, vkg, wkg, ykg, Akg, Iog, jpg, R1g, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi, LHi ];
 var an = [ MHi, rkg, zsg, Dsg, Fsg, EB, MHi, MHi ];
 var bn = [ NHi, skg ];
 var cn = [ OHi, cIa, Nre, Zyf, YKf, bLf, cLf, FQf, l$f, LYf, yZf, fgg, Jtg, xug, OHi, OHi ];
 var dn = [ PHi, QHi ];
 var en = [ RHi, uAa, BAa, RHi ];
 var fn = [ SHi, THi ];
 var gn = [ UHi, jqb, Arb, Grb, Oya, Nya, Jya, Iya, yya, Mya, Jrb, Gya, Fya, Hya, wya, vya, xya, Aya, sya, Bya, uya, Cya, Eya, fza, eza, bza, aza, cza, dza, _ya, Zya, $ya, Uya, Sya, Vya, Wya, Pya, Qya, Rya, Xya, Yya, Atb, Mwb, Swb, Ywb, cxb, kxb, tzb, wzb, zzb, Czb, Fzb, Izb, Lzb, Ozb, Rzb, Uzb, vAb, DAb, GAb, zdc, puc, BEc, Xpd, Zpd, m3e, mpf, dqf, Hqf, qrf, vvf, wvf, Txf, $Df, ZGf, aHf, GKf, IKf, KKf, PKf, XKf, aLf, yRf, KRf, LRf, GYf, IYf, oZf, pZf, g$f, i$f, Icg, Pfg, cgg, Vhg, _pg, Atg, Ctg, o2g, zu, Yw, Rx, cE, hE, by, mz, Lya, zya, tya, Dya, hOb, Xee, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi, UHi ];
 var hn = [ VHi, j5d ];
 var jn = [ WHi, Kwa, Lwa, WHi ];
 var kn = [ XHi, O9a, _U, Nab, Pab, uZ, yZ, BZ, aZ, eZ, pZ, Mcb, Ocb, Vdb, Xdb, L$, N$, F$, n0, EWa, CWa, BWa, cra, Dob, iAa, gAa, eAa, jAa, hAa, fAa, Dtb, bIa, LJa, Syb, _yb, fzb, mzb, VOb, gPb, tPb, EPb, WPb, Nid, epc, jpc, dBc, eBc, jBc, kBc, Xad, Yad, epd, npd, xpd, $pd, ard, Rqd, Sqd, xId, l5d, M7d, zse, Ese, Owe, zPh, DPh, i$e, y$e, b0e, y0e, z$e, M2e, e6e, Wdf, Xdf, yef, Off, bjf, gjf, pmf, qmf, eof, nof, sof, qof, apf, kpf, $of, cqf, Iqf, prf, Vrf, xsf, btf, Dtf, kvf, pvf, zvf, Bvf, Evf, Avf, dpf, Ivf, Lvf, Jvf, Nvf, Tvf, awf, $vf, hwf, iwf, wwf, zwf, Awf, fvf, Ryf, GBf, tCf, CCf, vCf, NCf, ICf, QDf, YDf, iEf, lEf, mCf, BEf, EEf, _Ef, LGf, QGf, $Gf, QIf, kKf, mKf, rKf, NKf, QKf, tLf, mNf, kMf, KMf, DRf, UQf, dRf, hRf, NRf, ORf, aVf, U$f, R$f, E0f, H0f, J0f, t3f, T3f, k4f, D6f, o8f, F9f, C9f, Pag, Bcg, Gcg, Mcg, Jdg, $dg, geg, veg, Peg, Ieg, Leg, jfg, kfg, ocg, nfg, rfg, tfg, Bfg, Kfg, Ofg, Ufg, agg, igg, sgg, xgg, Bgg, Egg, Ygg, Uhg, djg, $og, Wpg, Jqg, Lqg, oqg, asg, ctg, ftg, gtg, ktg, pvg, rvg, svg, tvg, uvg, vvg, Dvg, Hvg, Ivg, _vg, Uxg, Lyg, n2g, Khi, jyi, Rxi, Sxi, Txi, $xi, dp, Dq, Eq, Ft, gu, qu, Bu, eD, jD, rD, JD, nx, Dx, OD, PD, $D, aE, iE, Yx, $y, QA, tw, WB, pE, YC, WC, FVa, Lsa, bR, sCd, AJd, KKd, hLd, GNd, KNd, Uae, qbe, wbe, Abe, Bbe, cde, Eee, gde, kde, fee, lfe, sfe, tfe, Efe, Ffe, hge, Hhe, uie, vie, YHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi, XHi ];
 var ln = [ ZHi, VHd ];
 var mn = [ _Hi, O6e, Q7e, _Hi ];
 var nn = [ $Hi, Aui, Dui, Nui, Pui, $Hi, $Hi, $Hi ];
 var on = [ aIi, pW, xW, GX, Blb, gnb, Opc, PCc, S5e, P7e, T7e, g7e, j7e, X7e, Z7e, Jbf, bIi, cIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi, aIi ];
 var pn = [ dIi, gT ];
 var qn = [ eIi, Foc, Goc, Ioc, Pbf, m8e, fIi, gIi ];
 var rn = [ hIi, aP, a5, Pqb, cxa, $wa, fxa, rxa, sxa, vxa, Vxa, Yxa, Bxa, Cxa, Qxa, Sxa, Hxa, Ixa, ftb, CDa, DDa, gtb, ktb, FDa, GDa, ltb, ptb, IDa, JDa, qtb, utb, LDa, MDa, vtb, Gub, cvb, rxb, wxb, Bxb, Gxb, Lxb, Qxb, Vxb, _xb, dyb, iyb, nyb, syb, xyb, k_e, l_e, g1e, P4e, chf, cpf, Gwf, Hwf, byf, cEf, wEf, KEf, UEf, cFf, Jzf, yKf, cZf, z1f, a3f, Seg, Qig, vug, cxg, lyg, Hhi, Jhi, Csi, msi, sui, tui, yui, Eui, Hui, Iui, Lui, Qui, oxi, txi, rDi, qDi, pDi, et, Ox, Px, lw, Ty, dya, gya, oya, kya, K6a, L6a, O6a, zvc, Bvc, Cvc, Dvc, Evc, Fvc, Gvc, Hvc, Ivc, Kvc, Ovc, Svc, Tvc, _Ic, Cjd, Zhe, _he, cie, die, iIi, oqe, jIi, kIi, lIi, hIi, hIi ];
 var sn = [ mIi, rv, yv, mIi ];
 var tn = [ nIi, Hcf, Tdf, Udf, kef, eff, Elf, Glf, mxf, Nlg, Qlg, Slg, Ulg, u5a, nIi, nIi ];
 var un = [ oIi, nZ ];
 var vn = [ pIi, llf, Pie, pIi ];
 var wn = [ qIi, Z2 ];
 var xn = [ rIi, jdf ];
 var yn = [ sIi, Rwa, Ync, dse, ese, hgg, tIi, uIi ];
 var zn = [ vIi, Sxf, ukg, xkg, zkg, Bkg, vIi, vIi ];
 var An = [ wIi, bse, Nrg, wIi ];
 var Bn = [ xIi, u9a, Jab, lZ, Icb, Q_, I$, eBa, jBa, iBa, UBa, $Ba, ZBa, nKa, uwb, vwb, wwb, xwb, ywb, DQa, zwb, Awb, Bwb, Cwb, Dwb, Ewb, Fwb, Gwb, Hwb, EQa, Iwb, Jwb, FQa, Kwb, GQa, Lwb, pRa, zpc, TCc, lpd, Ypd, _pd, grd, VGd, dHd, _Hd, qId, dPd, bYd, i3d, qae, rae, sae, tae, uae, vae, wae, xae, yae, Bpe, Mwe, Sye, Vye, Cze, bGe, FMh, xIe, BIe, sNh, RIe, VIe, AKe, DKe, GKe, aRe, dRe, gRe, NTe, QTe, TTe, BXe, l3e, k3e, lYe, AYe, g_e, J2e, ihf, Pnf, Uof, Zof, rpf, aqf, gqf, Gqf, Lqf, Xrf, vsf, $sf, Ftf, mvf, qvf, bwf, dwf, jwf, nwf, owf, vwf, Wxf, $yf, rCf, oDf, _Df, jEf, rEf, AEf, FEf, fHf, lKf, nKf, vKf, VKf, WKf, _Kf, $Kf, JRf, PRf, $Xf, e$f, T$f, I0f, R0f, g1f, V3f, ffg, Nfg, $fg, zgg, Dgg, Rgg, Lmg, eqg, Hqg, grg, ytg, Btg, wug, wvg, xvg, zyg, Fyg, Ryg, Xyg, bzg, hzg, q1h, C1h, nXg, zXg, LXg, Q5h, L7h, X7h, Bti, Gti, lyi, yyi, Byi, byi, pyi, syi, Gyi, Jyi, Oyi, Ryi, It, Tt, $t, ED, jx, Ix, Bx, Kx, Ex, Fx, $v, aw, gE, mE, nE, Zx, Iy, Ky, Hy, Gy, vB, RRa, SRa, TRa, URa, VRa, p6a, q6a, lGd, lLd, nLd, uJd, wJd, _be, W9d, Cbe, Gee, bde, Nce, Oce, zee, Kfe, Gfe, Che, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi, xIi ];
 var Cn = [ yIi, CNa, DNa, ENa, FNa, GNa, SQa, XRa ];
 var Dn = [ zIi, bP, mT, RW, SW, GZ, IZ, JZ, mcb, n_, o_, r$, J0, K0, v0, Ffb, Gfb, Hfb, Zgb, _gb, $gb, eoa, Ona, Qna, foa, Pna, Rna, clb, elb, glb, ilb, klb, llb, Jmb, Lmb, Nmb, Pmb, Rmb, Smb, xva, yva, zva, Ava, mwa, fBa, WBa, cub, xOa, Cub, Dub, _ub, $ub, iwb, nwb, swb, BAb, Clc, Xoc, Vnc, apc, boc, doc, joc, qpc, Boc, Ypc, Zpc, _pc, eqc, mqc, nqc, Dic, UCc, Sid, Uid, cjd, bjd, tFd, uFd, cYd, ore, Are, zoc, jse, Nse, Ere, Yxe, Mxe, Uye, aGe, uHe, wLh, MHe, ZLh, wIe, AIe, QIe, UIe, QJe, EJe, CKe, FKe, lQe, _Pe, cRe, fRe, YSe, MSe, PTe, STe, hWe, uWe, QXe, nYe, qZe, i_e, j_e, m_e, u_e, E_e, F_e, D$e, T0e, c0e, b2e, N4e, m5e, v6e, b8e, Nbf, Vbf, Wbf, Zbf, _bf, xcf, edf, ldf, mdf, _df, $df, mef, Nef, cff, dff, lff, Dff, Cff, dgf, Fgf, ahf, Vgf, Sgf, Ygf, ehf, gif, Jmf, Tmf, Umf, Vmf, Wmf, Xmf, Buf, Cuf, Cwf, Dwf, Ewf, xwf, cvf, Fwf, Ayf, Cyf, Oyf, Qyf, Wyf, gzf, hzf, izf, xzf, yzf, aEf, eEf, yDf, tEf, vEf, IEf, NEf, OEf, bFf, iJf, mJf, gLf, qLf, DLf, ELf, _Mf, BOf, COf, sPf, uPf, FPf, cPf, SQf, jRf, xRf, WRf, ZRf, sTf, HUf, GUf, CVf, ZUf, YUf, vWf, HWf, QWf, RWf, fXf, pXf, xXf, EXf, C0f, $2f, f4f, H8f, A8f, M9f, J9f, I9f, aag, q9f, iag, jag, gdg, Kdg, qfg, wgg, pig, Teg, Sjg, Wjg, Yjg, akg, gkg, jkg, lkg, nkg, Yog, bpg, Jpg, Qpg, Tjg, Epg, uqg, Vpg, Kqg, Oqg, Hug, Qug, Rug, Sug, Tug, bwg, iwg, axg, bug, hyg, iyg, KTg, LTg, MTg, WTg, XTg, YTg, ZTg, p1h, B1h, V1h, uUg, vUg, wUg, xUg, yUg, W1h, IUg, JUg, KUg, LUg, MUg, NUg, eVg, fVg, gVg, hVg, iVg, jVg, kVg, mXg, yXg, KXg, P5h, cZg, dZg, eZg, fZg, gZg, hZg, iZg, K7h, W7h, T_g, U_g, V_g, W_g, X_g, Y_g, Z_g, e1g, f1g, w1g, x1g, Ghi, Dsi, nsi, Cti, Hti, eDi, fDi, hDi, $w, Yz, Zz, FA, Nw, QQ, JQ, aPb, W7b, ZQ, MAd, pCd, WCd, hfe, ehe, fhe, ghe, hhe, ihe, jhe, vhe, whe, fqe, AIi, BIi, CIi, DIi, EIi, FIi, GIi, HIi, IIi, JIi, KIi, LIi, MIi, NIi, OIi, PIi, QIi, RIi, SIi, TIi, UIi, VIi, WIi, XIi, YIi, ZIi, _Ii, $Ii, aJi, bJi, cJi, dJi, eJi, fJi, gJi, hJi, iJi, jJi, kJi, lJi, mJi, nJi, oJi, pJi, qJi, rJi, sJi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi, zIi ];
 var En = [ tJi, MT, QT, PV, Ifb, ahb, p5, Sna, Una, Tna, Vna, gra, zra, Btb, Eub, Fub, avb, bvb, jwb, owb, twb, sxb, xxb, Cxb, Hxb, Mxb, Rxb, Wxb, $xb, eyb, jyb, oyb, tyb, yyb, CAb, Tnc, hoc, gqc, lqc, JCc, hHd, rId, k5d, Bre, f_e, q_e, A_e, C_e, p$e, F1e, $0e, i3e, O4e, uaf, kcf, fdf, gdf, Gff, bhf, $gf, epf, hyf, fEf, yEf, PEf, QEf, REf, SEf, TEf, $Ef, jJf, lJf, yJf, BKf, xKf, CKf, tNf, rMf, RMf, TQf, kRf, zSf, AWf, BWf, YXf, E5f, F5f, Reg, Agg, Nig, Tpg, nyg, Lhi, oDi, nDi, kDi, YD, ZD, nwc, myd, qCd, uJi, vJi, wJi, xJi, yJi, zJi, AJi, BJi, CJi, DJi, EJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi, tJi ];
 var Fn = [ FJi, v8a, A8a, E8a, YR, V8a, _8a, c9a, mS, rV, vV, xV, zV, dW, fW, lW, nW, rW, tW, hW, jW, Rab, dbb, fbb, IX, HY, JY, LY, Qcb, cdb, edb, e_, g_, l_, s_, u_, w_, C_, W$, Y$, e$, b2, d2, Kfb, Qfb, Sfb, Ufb, Wfb, cgb, egb, ggb, igb, j3, l3, n3, chb, ihb, khb, mhb, ohb, whb, yhb, Ahb, Chb, $5, b6, F5, O5, I5, P5, R5, T5, y6, A6, m6, n6, a7, xna, zna, yna, Ana, Ykb, _kb, qlb, rlb, ulb, wlb, Elb, Llb, Nlb, Ulb, Dmb, Fmb, Xmb, Ymb, $mb, bnb, jnb, qnb, snb, znb, Lnb, Nnb, Tnb, Vnb, _va, Qnc, P3e, q4e, s4e, u4e, w4e, h7e, k7e, i7e, l7e, Ndf, Pif, Rif, Tif, Vif, Xif, qjf, yjf, gyf, dWg, MC, Qza, c3a, e3a, g3a, i3a, k3a, m3a, o3a, s3a, uFa, u3a, w3a, y3a, A3a, C3a, E3a, I3a, K3a, M3a, O3a, Q3a, W3a, Y3a, _3a, a4a, c4a, e4a, g4a, i4a, k4a, m4a, o4a, q4a, s4a, OFa, u4a, w4a, y4a, A4a, C4a, E4a, G4a, I4a, K4a, M4a, O4a, Q4a, UFa, wGa, XGa, $Ga, bHa, g5a, i5a, k5a, HCd, GJi, HJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi, FJi ];
 var Gn = [ IJi, iyf, S1g, NC ];
 var Hn = [ JJi, Bvg ];
 var In = [ KJi, ksi, VR, x8a, B8a, C8a, H8a, I8a, J8a, jS, X8a, $8a, a9a, f9a, g9a, h9a, PS, cT, dT, eT, fT, sWa, bV, cV, pV, lV, nV, JV, OV, eV, dV, YV, XV, _V, ZV, $V, aW, bW, cW, vW, zW, SV, qab, wab, Aab, Bab, Cab, Eab, Gab, Hab, LW, Kab, QW, Qab, Uab, Vab, Wab, Xab, Yab, TW, UW, _ab, abb, bbb, cbb, DW, EW, CW, VW, nbb, obb, pbb, sbb, xbb, ybb, zbb, Abb, cX, Kbb, BX, CX, $bb, OY, PY, QY, SY, CY, dcb, HZ, ucb, ycb, zcb, Acb, Ccb, Ecb, Fcb, Hcb, Jcb, d_, Pcb, Tcb, Ucb, Vcb, Wcb, Xcb, p_, q_, Zcb, $cb, adb, bdb, b_, gdb, hdb, ZZ, ldb, qdb, vdb, wdb, xdb, ydb, Fdb, Jdb, Kdb, Ldb, Ndb, Pdb, Qdb, P_, Sdb, Ydb, Zdb, L_, beb, ieb, jeb, keb, leb, j$, g$, h$, x$, k$, C$, G$, _$, c0, e0, u0, oeb, E0, c$, d$, i0, U$, U0, Q$, N0, W0, Q0, n1, I1, J1, S1, T1, U1, V1, X1, Y1, i2, j2, l2, D1, E1, T2, U2, W2, nfb, rfb, sfb, tfb, vfb, xfb, yfb, Lfb, Mfb, Xfb, Yfb, $fb, jgb, lgb, mgb, ngb, ogb, sgb, wgb, Hgb, Lgb, Mgb, Ngb, Pgb, Rgb, Sgb, dhb, ehb, phb, qhb, thb, Dhb, Ehb, Fhb, Ghb, Lhb, Uhb, Xhb, Yhb, Zhb, $hb, bib, cib, h6, j6, w5, u5, v5, z5, A5, B5, C5, D5, E5, G5, H5, K5, L5, M5, N5, x5, y5, V4, M4, P4, Q4, R4, e6, g6, Y4, Z4, c5, i5, j5, m5, n5, e5, f5, r5, t5, Y5, w6, x6, eib, E4, F4, iib, jib, D6, oib, rib, jma, lma, nma, pma, rma, Dkb, Ekb, Ikb, Kkb, Lkb, Mkb, Nkb, Okb, Pkb, Qkb, Rkb, Skb, Tkb, Ukb, Vkb, Wkb, Xkb, alb, tma, olb, ylb, Glb, zma, vma, Qlb, Wlb, Ylb, cmb, kma, mma, oma, qma, sma, imb, jmb, nmb, pmb, qmb, rmb, smb, tmb, umb, vmb, wmb, xmb, ymb, zmb, Amb, Bmb, Cmb, Hmb, uma, Vmb, dnb, lnb, Ama, wma, vnb, Bnb, Dnb, Jnb, zoa, Boa, Pnb, Rnb, Aoa, Coa, Xnb, Znb, rra, yra, W0a, Cqb, X0a, Hqb, Cva, Mqb, Nqb, Rva, Yva, awa, nwa, Uwa, Swa, Vwa, hxa, gxa, kxa, Jxa, Lxa, Kxa, Mxa, Zxa, _xa, Wwa, Twa, Nxa, Lrb, oBa, Nrb, YBa, iCa, kFa, dDa, eDa, qsb, Dsb, Qsb, btb, Ftb, Gtb, VHa, Vtb, Ytb, TQa, Ztb, jub, rOa, kub, qub, tub, wub, xub, zub, Lub, Mub, Qub, Uub, Xub, rvb, svb, tvb, wJa, NJa, RJa, SJa, AJa, BJa, CJa, kKa, zvb, Cvb, Dvb, Evb, uKa, txb, yxb, Dxb, Ixb, Nxb, Sxb, Xxb, ayb, fyb, kyb, pyb, uyb, zyb, fAb, mRa, jAb, POb, ROb, WOb, hPb, xPb, vPb, FPb, OPb, QPb, XPb, pRb, vRb, xRb, uQb, ARb, BRb, CRb, DRb, ERb, FRb, GRb, wSb, uSb, xSb, sSb, vSb, tSb, CSb, ASb, DSb, ySb, BSb, zSb, qTb, uTb, MTb, kUb, iUb, lUb, gUb, jUb, hUb, dUb, aUb, qUb, oUb, rUb, mUb, pUb, nUb, ZUb, $Ub, nWb, vWb, tWb, wWb, rWb, uWb, sWb, XWb, VWb, YWb, TWb, WWb, UWb, okc, ukc, skc, vkc, qkc, tkc, rkc, pkc, nkc, p$b, P0b, N0b, Q0b, L0b, O0b, M0b, l2b, v2b, t2b, w2b, r2b, u2b, s2b, j3b, N4b, X4b, V4b, Y4b, T4b, W4b, U4b, M5b, U5b, S5b, V5b, Q5b, T5b, R5b, E8b, V8b, T8b, W8b, R8b, U8b, S8b, Cec, dec, bec, eec, $dc, cec, aec, ghc, ehc, chc, fhc, ahc, dhc, bhc, Bhc, yhc, whc, zhc, uhc, xhc, vhc, DAc, Dhc, hlc, Dlc, Flc, Voc, Coc, Woc, Rnc, Yoc, Zoc, _oc, Xnc, gpc, lpc, aoc, goc, loc, moc, ppc, tpc, xpc, ypc, ooc, qoc, Cpc, Hpc, Npc, Noc, soc, dqc, hqc, kqc, oqc, ltc, vtc, ttc, wtc, rtc, utc, stc, sEc, zuc, xuc, Auc, vuc, yuc, wuc, HEc, quc, Awc, Twc, Rwc, Uwc, Pwc, Swc, Qwc, tyc, nyc, lyc, oyc, jyc, myc, kyc, gzc, czc, azc, dzc, _yc, bzc, $yc, Dzc, izc, CAc, Xzc, Vzc, Yzc, Tzc, Wzc, Uzc, uAc, IBc, ZBc, XBc, _Bc, VBc, YBc, WBc, qCc, NCc, OCc, WCc, YCc, _Cc, aDc, cDc, KCc, kDc, mDc, _Dc, YDc, $Dc, WDc, ZDc, XDc, ZEc, XEc, _Ec, VEc, YEc, WEc, FEc, oFc, EFc, CFc, FFc, AFc, DFc, BFc, vFc, UGc, _Gc, YGc, $Gc, WGc, ZGc, XGc, IGc, dKc, bKc, eKc, $Jc, cKc, aKc, YKc, hLc, fLc, iLc, dLc, gLc, eLc, cNc, aNc, dNc, _Mc, bNc, $Mc, KOc, bOc, MOc, WOc, UOc, XOc, SOc, VOc, TOc, $Nc, LRc, JRc, MRc, HRc, KRc, IRc, _Rc, uSc, ESc, CSc, FSc, ASc, DSc, BSc, bTc, $Sc, cTc, ZSc, aTc, _Sc, zUc, xUc, AUc, vUc, yUc, wUc, H9c, T9c, T8c, U8c, X8c, W8c, R8c, Q8c, L9c, jad, vad, tad, wad, rad, uad, sad, icd, ucd, scd, vcd, qcd, tcd, rcd, Vid, Wid, djd, fjd, Wjd, Jkd, Hkd, Kkd, Fkd, Ikd, Gkd, Kld, cmd, amd, dmd, _ld, bmd, $ld, Vmd, Tmd, Wmd, Rmd, Umd, Smd, apd, bpd, jqd, Eod, Fod, jrd, mrd, nrd, ord, lrd, krd, prd, Kod, pDd, FDd, DDd, GDd, BDd, EDd, CDd, DEd, oEd, lEd, EEd, FEd, tDd, xDd, qEd, SEd, QEd, TEd, OEd, REd, PEd, IEd, RFd, iGd, gGd, jGd, eGd, hGd, fGd, ZGd, eHd, lId, tId, vId, wId, yId, PId, QId, OJd, MJd, PJd, KJd, NJd, LJd, dKd, lKd, jKd, mKd, hKd, kKd, iKd, PKd, aLd, _Kd, bLd, YKd, $Kd, ZKd, FLd, _Ld, YLd, $Ld, WLd, ZLd, XLd, rNd, XOd, hPd, kPd, UUd, pVd, wVd, uVd, xVd, sVd, vVd, tVd, GVd, IVd, HWd, a2d, _1d, b2d, Y1d, $1d, Z1d, j3d, n3d, o3d, L7d, Y5d, k6d, i6d, l6d, g6d, j6d, h6d, Lje, mke, kke, nke, ike, lke, jke, Mle, Nle, Ole, Ple, Qle, Rle, Sle, Tle, Ule, Vle, Wle, Xle, Yle, Zle, _le, $le, ame, bme, cme, dme, eme, fme, gme, hme, ime, jme, kme, lme, mme, nme, ome, pme, qme, rme, sme, tme, ume, vme, wme, xme, yme, zme, Ame, Bme, Cme, Dme, Eme, Fme, Gme, Hme, Ime, Jme, Kme, Lme, Mme, Nme, Ome, Pme, Qme, Rme, Sme, Tme, Ume, Vme, Wme, Xme, Yme, Zme, _me, $me, ane, bne, cne, dne, ene, fne, gne, hne, ine, jne, kne, lne, mne, nne, one, pne, qne, rne, sne, tne, une, vne, wne, xne, yne, zne, Ane, Bne, Cne, Dne, Ene, Fne, Gne, Hne, Ine, Jne, Kne, Lne, Mne, Nne, One, Pne, Qne, Rne, Sne, Tne, Une, Vne, Wne, Xne, Yne, Zne, _ne, $ne, aoe, boe, coe, doe, eoe, foe, goe, hoe, ioe, joe, koe, loe, moe, noe, ooe, poe, qoe, roe, soe, toe, uoe, voe, woe, xoe, yoe, zoe, Aoe, Boe, Coe, Doe, Eoe, Foe, Goe, Hoe, Ioe, Joe, Koe, Loe, Moe, Noe, Ooe, Poe, Qoe, Roe, Soe, Toe, Uoe, Voe, Woe, Xoe, Npe, Kpe, Lpe, ere, Yqe, Xqe, are, cre, dre, ite, gre, hre, fre, nre, pre, qre, Kre, rre, sre, vre, wre, zre, Ise, Gre, Hre, Jre, Bse, Gse, ise, Pre, Qre, Rre, fse, rqc, xte, Jve, Qve, Xve, Zxh, cyh, hyh, myh, ryh, wyh, Byh, Gyh, Lyh, Xwe, Qyh, Vyh, _yh, dzh, izh, axe, nzh, szh, xzh, Czh, Hzh, fxe, Mzh, Rzh, Wzh, $zh, eAh, jAh, oAh, tAh, mxe, nxe, txe, Lxe, Xxe, Zxe, _xe, aye, cye, fye, yAh, DAh, kye, mye, IAh, Wxe, pye, uye, Bye, Fxe, Lye, Qye, Xye, Zye, aze, NAh, SAh, XAh, aBh, fBh, kBh, pBh, uBh, zBh, EBh, JBh, OBh, TBh, YBh, bCh, gCh, lCh, qCh, vCh, ACh, FCh, KCh, PCh, UCh, Dze, Fze, ZCh, cDh, hDh, Ize, Nze, Pze, Sze, Xze, aAe, mDh, fAe, rDh, wDh, BDh, GDh, kAe, LDh, pAe, uAe, zAe, EAe, JAe, OAe, TAe, YAe, bBe, gBe, QDh, VDh, _Dh, dEh, iEh, nEh, sEh, xEh, CEh, HEh, MEh, REh, WEh, $Eh, eFh, jFh, oFh, tFh, yFh, lBe, DFh, IFh, NFh, SFh, qBe, vBe, ABe, FBe, KBe, PBe, UBe, ZBe, cCe, hCe, mCe, XFh, aGh, rCe, fGh, kGh, wCe, pGh, BCe, GCe, uGh, zGh, LCe, EGh, QCe, JGh, OGh, TGh, YGh, bHh, VCe, gHh, lHh, qHh, vHh, _Ce, AHh, dDe, iDe, nDe, sDe, xDe, CDe, FHh, KHh, PHh, HDe, MDe, RDe, nEe, sEe, QEe, XEe, UHh, tFe, ZHh, cIh, yFe, hIh, WFe, fGe, dGe, mIh, rIh, wIh, BIh, GIh, LIh, dJh, jJh, qJh, zJh, EJh, FJh, ZGe, LJh, OJh, RJh, WJh, dKh, iKh, jKh, kHe, pKh, sKh, vKh, zKh, lHe, MKh, RKh, _Kh, $Kh, qHe, lLh, vHe, BLh, CLh, AHe, OLh, YHe, $Lh, bMh, _He, aIe, dMh, eMh, mIe, Yrh, sMh, uMh, rIe, HMh, JMh, OMh, QMh, IIe, KIe, SMh, TMh, NIe, Zrh, fNh, hNh, OIe, uNh, wNh, XIe, cJe, dJe, jJe, DJe, PJe, RJe, SJe, UJe, WJe, OJe, ZJe, cKe, jKe, wJe, tKe, yKe, JKe, zJe, NKe, SKe, XKe, PNh, UNh, ZNh, cOh, hOh, mOh, rOh, wOh, BOh, GOh, aLe, LOh, fLe, QOh, VOh, kLe, _Oh, dPh, pLe, uLe, wLe, iPh, nPh, zLe, ELe, JLe, sPh, yPh, APh, CPh, EPh, PLe, RLe, jMe, vMe, VLe, eMe, kMe, YLe, dMe, mMe, qMe, EMe, NMe, PMe, hNe, tNe, TMe, cNe, iNe, WMe, bNe, kNe, oNe, CNe, LNe, NNe, fOe, rOe, RNe, aOe, gOe, UNe, $Ne, iOe, mOe, AOe, FPh, KPh, PPh, UPh, ZPh, iQh, JOe, qQh, QOe, sQh, xQh, DQh, MQh, RQh, SQh, TOe, YQh, $Qh, cRh, gRh, uRh, UOe, zRh, ERh, ZOe, cPe, hPe, mPe, oPe, rPe, JRh, ORh, TRh, YRh, bSh, gSh, yPe, zPe, FPe, ZPe, kQe, mQe, nQe, pQe, rQe, lSh, uQe, jQe, zQe, EQe, LQe, SPe, VQe, _Qe, jRe, VPe, uRe, ySh, HSh, MSh, NSh, zRe, TSh, WSh, ZSh, bTh, gTh, vTh, ETh, JTh, KTh, ARe, QTh, TTh, WTh, _Th, dUh, rUh, wUh, BUh, GUh, BRe, LUh, QUh, VUh, GRe, _Uh, LRe, QRe, VRe, _Re, dVh, iVh, dSe, kSe, lSe, rSe, LSe, XSe, ZSe, _Se, aTe, cTe, fTe, nVh, sVh, WSe, kTe, pTe, wTe, ESe, GTe, LTe, WTe, HSe, gUe, iUe, lUe, qUe, vUe, AUe, FUe, KUe, PUe, RUe, UUe, xVh, CVh, ZUe, cVe, hVe, HVh, MVh, RVh, WVh, mVe, $Vh, eWh, rVe, jWh, oWh, tWh, wVe, yWh, DWh, BVe, IWh, NWh, GVe, SWh, XWh, LVe, aXh, fXh, UVe, oWe, iWe, ZVe, CWe, HWe, $We, gXe, oXe, xXe, JXe, hYe, LXe, bZe, cZe, fZe, hZe, kZe, HZe, FZe, KZe, NZe, PZe, RZe, UZe, WZe, ZZe, H_e, d_e, n_e, o_e, p_e, w_e, y_e, z_e, B_e, D_e, b_e, e_e, r_e, s_e, __e, $_e, O_e, Y_e, b$e, m$e, L$e, C0e, I0e, L0e, W$e, F$e, B0e, m0e, G0e, d0e, Y$e, _$e, r0e, F0e, q0e, p0e, k0e, a0e, N$e, A0e, E0e, u0e, a2e, c2e, d2e, f2e, F2e, h2e, N2e, P2e, i2e, f3e, g3e, xff, yff, Qhf, Rhf, F3e, R3e, S3e, Hif, Iif, Z3e, _3e, h4e, i4e, d4e, y4e, A4e, C4e, E4e, U4e, W4e, Y4e, f5e, h5e, i5e, w5e, y5e, n5e, o5e, z5e, p5e, A5e, X5e, Y5e, d6e, c6e, f6e, h6e, i6e, o6e, z7e, G6e, J6e, K6e, m7e, H6e, r7e, A7e, d8e, x8e, C8e, G8e, I8e, K8e, M8e, O8e, Q8e, S8e, U8e, W8e, Y8e, _8e, a9e, c9e, e9e, g9e, i9e, k9e, m9e, o9e, q9e, s9e, faf, oaf, B9e, C7e, E7e, G7e, I7e, x9e, X6e, y9e, E8e, vbf, wbf, gbf, hbf, mbf, $7e, Xbf, Ybf, A9e, l8e, Ucf, Vcf, cdf, ddf, zdf, Cdf, Ddf, Edf, Adf, Fdf, Gdf, Hdf, Idf, Kdf, Ldf, Mdf, Odf, oef, xef, wef, zef, Aef, Jef, Yef, Zef, _ef, rff, sff, Fff, Jff, Nff, Mff, Pff, Uff, Wff, Xff, agf, hgf, igf, jgf, v9e, G9e, F9e, Lgf, Ngf, Pgf, Qgf, Xgf, Zgf, khf, yhf, Ehf, Ghf, Hhf, kif, pif, qif, rif, sif, tif, uif, vif, wif, xif, Kif, Lif, Mif, Nif, Yif, Zif, ajf, $if, cjf, fjf, ejf, hjf, ijf, jjf, mjf, ojf, sjf, ujf, wjf, Ajf, Ejf, Fjf, Mjf, Njf, Hjf, Ijf, enf, fnf, kkf, lkf, pkf, qkf, wkf, xkf, tkf, vkf, Qkf, Rkf, Ikf, Jkf, Kkf, Lkf, Mkf, Nkf, Okf, Pkf, $kf, blf, flf, nlf, plf, qlf, ulf, vlf, ylf, zlf, cmf, kmf, mmf, vmf, Emf, Omf, xnf, znf, jnf, Hnf, Inf, wof, Dpf, Cpf, aof, yof, Duf, rwf, cyf, dyf, Xyf, vAf, xAf, $Af, aBf, fDf, pDf, CDf, DDf, IDf, HEf, JEf, Vxf, JHf, KHf, OHf, VCf, pIf, zof, AIf, DIf, Kwf, KIf, PIf, OIf, RIf, bIf, cJf, TJf, UJf, XJf, YJf, WJf, _Jf, $Jf, bKf, wKf, WLf, pNf, qNf, rNf, vNf, xNf, _Lf, nMf, oMf, pMf, tMf, vMf, zMf, NMf, OMf, PMf, TMf, VMf, ZMf, fNf, CNf, HNf, TNf, _Nf, DOf, nOf, tOf, GOf, WOf, _Of, rPf, qPf, pPf, MPf, iQf, mQf, tQf, yQf, NLf, ULf, OLf, qRf, tRf, URf, XRf, qSf, sSf, tTf, uTf, zTf, xTf, nSf, STf, xUf, JUf, fVf, iVf, eVf, nVf, NUf, vVf, qVf, yVf, BVf, FVf, eWf, jWf, hWf, iWf, mWf, DWf, MWf, LWf, SWf, TWf, UWf, VWf, EWf, aXf, dXf, eXf, hXf, nXf, mXf, oXf, rXf, uXf, vXf, wXf, zXf, FXf, GXf, HXf, L$f, _$f, a0f, c0f, e0f, g0f, i0f, k0f, m0f, LXf, MXf, u0f, w0f, h1f, m4f, Q4f, R4f, Y2f, w3f, v3f, b5f, d5f, g5f, i5f, OXf, PXf, z5f, B5f, N5f, O5f, Y5f, H7f, H6f, N6f, W6f, _6f, g7f, t7f, E6f, G6f, I6f, B8f, G8f, Y8f, a9f, d9f, j9f, l9f, n9f, y6f, K9f, Q8f, O9f, A9f, cag, p9f, sag, Tag, bbg, cbg, fbg, gbg, Ebg, Xbg, Jbg, Tcg, jdg, qdg, Odg, Udg, beg, Acg, Ueg, bcg, Zeg, $eg, pfg, Ffg, Zfg, Ceg, vgg, Hhg, _gg, Jag, Kag, chg, lhg, Ihg, Phg, Whg, Yhg, Rbg, Iag, wdg, zig, Cig, Tig, Dpg, Fpg, cpg, jqg, kqg, gqg, Iqg, wqg, hrg, Arg, Hrg, Jrg, Lrg, Prg, Yrg, isg, lsg, osg, Brg, Msg, Nsg, Vsg, hug, mug, pug, sug, yug, Dug, Oug, Xug, Yug, Zug, $ug, zug, gvg, Yvg, Wvg, awg, $vg, cwg, kwg, xsg, zwg, Cwg, Mwg, Grg, Wxg, Tqg, eyg, kyg, Kyg, Jyg, Myg, Syg, Yyg, izg, mXh, nXh, DXh, MXh, VXh, cYh, lYh, wYh, HYh, LSg, QYh, ZYh, gZh, pZh, yZh, USg, HZh, QZh, ZZh, g_h, p_h, bTg, y_h, H_h, Q_h, Z_h, g$h, p$h, y$h, H$h, kTg, tTg, Q$h, Z$h, CTg, g0h, OTg, p0h, y0h, H0h, Q0h, Z0h, g1h, s1h, cUg, E1h, N1h, lUg, AUg, PUg, YUg, mVg, vVg, EVg, Y1h, f2h, o2h, x2h, G2h, P2h, Y2h, f3h, o3h, x3h, NVg, G3h, WVg, P3h, Y3h, f4h, o4h, mWg, vWg, x4h, G4h, EWg, NWg, WWg, P4h, dXg, pXg, BXg, Y4h, f5h, o5h, x5h, G5h, S5h, NXg, $5h, i6h, WXg, dYg, mYg, vYg, EYg, s6h, B6h, K6h, T6h, a7h, j7h, NYg, s7h, WYg, kZg, B7h, N7h, Z7h, g8h, p8h, y8h, tZg, H8h, Q8h, Z8h, CZg, g9h, LZg, UZg, b_g, k_g, p9h, y9h, t_g, C_g, L_g, H9h, Q9h, $_g, i$g, r$g, A$g, J$g, S$g, $$g, i0g, r0g, Z9h, gai, A0g, J0g, S0g, pai, yai, Hai, Qai, Zai, gbi, i1g, pbi, ybi, Hbi, Qbi, Zbi, A1g, gci, pci, J1g, yci, Hci, Qci, Zci, $1g, gdi, pdi, ydi, Hdi, Qdi, Zdi, gei, pei, yei, Hei, Qei, Zei, gfi, pfi, yfi, Hfi, Qfi, Zfi, ggi, pgi, ygi, Hgi, Qgi, Zgi, q2g, ghi, phi, yhi, z2g, O2g, X2g, e3g, n3g, Nhi, w3g, Whi, dii, mii, vii, F3g, Eii, O3g, X3g, e4g, n4g, w4g, F4g, O4g, X4g, e5g, n5g, Nii, Wii, dji, mji, vji, Eji, Nji, Wji, dki, mki, vki, Eki, Nki, Wki, dli, mli, vli, Eli, Nli, w5g, Wli, dmi, mmi, vmi, G5g, P5g, Y5g, f6g, o6g, x6g, G6g, P6g, Y6g, f7g, o7g, Gmi, Pmi, x7g, Ymi, fni, G7g, oni, P7g, Y7g, xni, Gni, f8g, Pni, o8g, Yni, foi, ooi, xoi, Goi, x8g, Poi, Yoi, fpi, opi, G8g, xpi, P8g, Y8g, f9g, o9g, x9g, G9g, Gpi, Ppi, Ypi, P9g, Y9g, fah, oah, xah, Gah, fqi, Pah, oqi, xqi, Yah, Gqi, fbh, $Ai, eBi, jBi, oBi, Asi, _vi, $vi, awi, bwi, dwi, ewi, jwi, kwi, lwi, mwi, owi, pwi, uwi, vwi, wwi, xwi, zwi, Awi, Fwi, Gwi, Hwi, Iwi, Kwi, Lwi, pxi, uxi, bzi, dzi, fzi, czi, ezi, gzi, Mq, Us, ft, Nt, tu, bD, HD, Tu, jv, _w, Jv, hw, VD, $x, jy, oz, pz, qz, vz, Bz, Iz, Ny, dz, Mz, HA, SA, uC, ZB, kC, mC, oC, fC, qC, sC, cC, jC, IC, JC, KC, OC, TC, PC, QC, tN, LJi, qQ, LQ, aya, $xa, ixa, jxa, hya, lya, iya, q3a, G3a, CFa, S3a, U3a, S4a, vGa, uGa, yGa, NGa, PGa, RGa, TGa, VGa, ZGa, Y4a, _4a, a5a, c5a, e5a, fHa, eHa, hHa, gHa, jHa, iHa, lHa, kHa, oHa, nHa, qHa, pHa, T4a, U4a, V4a, W4a, l5a, m5a, n5a, o5a, vHa, p5a, q5a, AHa, zHa, r5a, s5a, N6a, i8a, u5b, H9b, A9b, lac, nac, wac, Uac, qcc, Nlc, Lvc, Rvc, fR, $Q, cR, aR, eR, eOb, XRc, fWc, iWc, kWc, mWc, oWc, qWc, KWc, ZWc, NWc, OWc, PWc, QWc, RWc, SWc, TWc, UWc, VWc, WWc, _Wc, $Wc, aXc, bXc, cXc, dXc, eXc, fXc, gXc, hXc, iXc, jXc, kXc, XWc, YWc, mXc, oXc, DXc, rXc, sXc, tXc, uXc, vXc, wXc, xXc, yXc, zXc, AXc, EXc, FXc, GXc, HXc, IXc, JXc, KXc, LXc, MXc, NXc, OXc, PXc, QXc, BXc, CXc, RXc, SXc, eYc, VXc, WXc, XXc, YXc, ZXc, _Xc, $Xc, aYc, bYc, cYc, fYc, gYc, hYc, iYc, jYc, kYc, lYc, mYc, nYc, oYc, pYc, qYc, rYc, dYc, WVc, sYc, tYc, IYc, wYc, xYc, yYc, zYc, AYc, BYc, CYc, DYc, EYc, FYc, JYc, KYc, LYc, MYc, NYc, OYc, PYc, QYc, RYc, SYc, TYc, UYc, VYc, GYc, HYc, WYc, XYc, kZc, _Yc, $Yc, aZc, bZc, cZc, dZc, eZc, fZc, gZc, hZc, lZc, mZc, nZc, oZc, pZc, qZc, rZc, sZc, tZc, uZc, vZc, wZc, xZc, iZc, jZc, yZc, zZc, OZc, CZc, DZc, EZc, FZc, GZc, HZc, IZc, JZc, KZc, LZc, PZc, QZc, RZc, SZc, TZc, UZc, VZc, WZc, XZc, YZc, ZZc, _Zc, $Zc, MZc, NZc, a_c, n_c, b_c, c_c, d_c, e_c, f_c, g_c, h_c, i_c, j_c, k_c, o_c, p_c, q_c, r_c, s_c, t_c, u_c, v_c, w_c, x_c, y_c, z_c, A_c, l_c, m_c, C_c, U_c, I_c, J_c, K_c, L_c, M_c, N_c, O_c, P_c, Q_c, R_c, V_c, W_c, X_c, Y_c, Z_c, __c, $_c, a$c, b$c, c$c, d$c, e$c, f$c, S_c, T_c, g$c, x$c, m$c, n$c, o$c, p$c, q$c, r$c, s$c, t$c, u$c, v$c, y$c, z$c, A$c, B$c, C$c, D$c, E$c, F$c, G$c, H$c, I$c, J$c, K$c, w$c, XVc, L$c, b0c, R$c, S$c, T$c, U$c, V$c, W$c, X$c, Y$c, Z$c, _$c, c0c, d0c, e0c, f0c, g0c, h0c, i0c, j0c, k0c, l0c, m0c, n0c, o0c, $$c, a0c, p0c, H0c, v0c, w0c, x0c, y0c, z0c, A0c, B0c, C0c, D0c, E0c, I0c, J0c, K0c, L0c, M0c, N0c, O0c, P0c, Q0c, R0c, S0c, T0c, U0c, F0c, G0c, V0c, r1c, f1c, g1c, h1c, i1c, j1c, k1c, l1c, m1c, n1c, o1c, s1c, t1c, u1c, v1c, w1c, x1c, y1c, z1c, A1c, B1c, C1c, D1c, E1c, p1c, q1c, F1c, J8c, l9c, lyd, wyd, zyd, Byd, Cyd, Dyd, Eyd, Fyd, Gyd, czd, dzd, ozd, szd, uzd, wzd, yzd, Ezd, Kzd, Mzd, rAd, GAd, HAd, IAd, JAd, kBd, tBd, ABd, FBd, HBd, ICd, KCd, ZCd, _Cd, $Cd, aDd, c0d, f3d, c9d, h9d, the, Qie, Sie, Vie, Yie, MJi, NJi, OJi, PJi, QJi, RJi, SJi, TJi, UJi, VJi, WJi, XJi, YJi, ZJi, _Ji, $Ji, aKi, nqe, pqe, bKi, cKi, dKi, eKi, fKi, gKi, hKi, iKi, jKi, kKi, lKi, mKi, nKi, oKi, pKi, qKi, rKi, sKi, tKi, uKi, vKi, wKi, xKi, yKi, zKi, AKi, BKi, CKi, DKi, EKi, FKi, GKi, HKi, IKi, JKi, KKi, LKi, MKi, NKi, OKi, PKi, QKi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi, KJi ];
 var Jn = [ RKi, WHd, mPf, tPf ];
 var Kn = [ SKi, w8a, z8a, D8a, PR, QR, RR, K8a, M8a, W8a, Z8a, b9a, i9a, j9a, k9a, m9a, qV, wV, yV, AV, eW, gW, mW, oW, sW, uW, iW, kW, Sab, Tab, ebb, gbb, JX, IY, KY, MY, Rcb, Scb, ddb, fdb, f_, h_, m_, t_, v_, x_, D_, X$, Z$, f$, f1, g1, $0, m1, c2, e2, Jfb, Pfb, Rfb, Tfb, Vfb, bgb, dgb, fgb, hgb, i3, k3, m3, bhb, hhb, jhb, lhb, nhb, vhb, xhb, zhb, Bhb, a6, u6, c6, J5, Q5, S5, U5, z6, B6, l6, o6, Jkb, Zkb, $kb, plb, slb, vlb, xlb, Clb, Dlb, Flb, Mlb, Olb, Vlb, omb, Emb, Gmb, Wmb, Zmb, anb, cnb, hnb, inb, knb, rnb, tnb, Anb, Mnb, Onb, Unb, Wnb, $va, dAb, eAb, e$b, gDc, BRc, mLe, p4e, r4e, t4e, v4e, n7e, p7e, N6e, P6e, R6e, S6e, Bcf, Ccf, u7e, v7e, Rff, Sff, Oif, Qif, Sif, Uif, Wif, pjf, xjf, Xjf, Yjf, gkf, FC, oFa, pFa, b3a, d3a, f3a, h3a, j3a, l3a, n3a, r3a, vFa, t3a, v3a, x3a, z3a, B3a, D3a, H3a, J3a, L3a, N3a, P3a, HFa, V3a, X3a, Z3a, $3a, JFa, KFa, b4a, d4a, f4a, h4a, j4a, l4a, n4a, p4a, r4a, MFa, NFa, t4a, v4a, x4a, z4a, B4a, D4a, F4a, H4a, QFa, RFa, SFa, J4a, L4a, N4a, P4a, YGa, aHa, cHa, f5a, h5a, j5a, Hzd, Izd, CBd, DBd, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi, SKi ];
 var Ln = [ TKi, Uug ];
 var Mn = [ UKi, kza, Yza, mza, lza, oza, sza, tza, nza, pza, qza, rza, UKi, UKi, UKi, UKi ];
 var Nn = [ VKi, Wna, Xna, Qwa, Unc, Wnc, npc, eoc, foc, Apc, Bpc, Dre, Kse, Utf, dEf, SJf, Zog, Qvi, Uvi, Owi, Swi, Xwi, Zwi, zsc, mFd, iU, WKi, XKi, YKi, ZKi, _Ki, VKi ];
 var On = [ $Ki, z0, Hub, dvb ];
 var Pn = [ aLi, mlf ];
 var Qn = [ bLi, nxf ];
 var Rn = [ cLi, jqc, hLf, cLi ];
 var Sn = [ dLi, vAa, AAa, dLi ];
 var Tn = [ eLi, Oxf, Pxf, Rxf, Mxf, Lxf, oxf, Jig, Kig, ijg, wjg, Gkg, Vkg, hlg, xlg, Zlg, lmg, zmg, T1g, V1g, W1g, eLi, eLi, eLi, eLi, eLi, eLi, eLi, eLi, eLi, eLi, eLi ];
 var Un = [ fLi, SR, TR, UR, fS, gS, t6e, u6e, ixf, jxf, lxf, gxf, fxf, exf, jjg, xjg, Kjg, Hkg, Wkg, ilg, ylg, _lg, mmg, Amg, eWg, gWg, hWg, fLi, fLi, fLi, fLi, fLi ];
 var Vn = [ gLi, x0, y0, gLi ];
 var Wn = [ hLi, QV, hX, Yna, Zna, kwa, dpc, ipc, ioc, Bqc, sId, yse, Dse, Zre, ewf, zJf, MJf, NJf, cKf, KUf, A1f, Bug, Lti, Mti, Nti, Oti, Pti, Qti, Rti, Sti, Tti, Uti, Vti, _ti, $ti, aui, bui, cui, dui, eui, fui, gui, hui, iui, xui, zui, Kui, Mui, Vui, Wui, Xui, Zui, $ui, svi, tvi, uvi, wvi, yvi, exi, kxi, du, kE, Pvc, iLi, jLi, kLi, lLi, mLi, nLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi, hLi ];
 var Xn = [ oLi, Fwa, Gwa, Mwa, Nwa, oLi, oLi, oLi ];
 var Yn = [ pLi, rpc, iqc, kse, xEf, FKf, bvi, Avi, RQ, qLi, rLi, sLi, tLi, uLi, vLi, pLi ];
 var Zn = [ wLi, Cre ];
 var _n = [ xLi, dP, eP, sP, xP, CP, HP, IP, JP, s8a, WR, NR, OR, S8a, kS, iS, dS, eS, SS, TS, WS, AT, BT, ET, FT, lab, SU, UU, VU, XU, nab, pab, tab, _bb, LX, ccb, sZ, vZ, wZ, zZ, CZ, DZ, ZY, bZ, fZ, ncb, rcb, c_, Cdb, H$, b0, h0, A0, o1, l0, p0, B0, cfb, K1, L1, M1, N1, O1, P1, Q1, a2, kfb, Afb, Cfb, e3, g3, h3, Egb, Ugb, Wgb, Shb, r6, W4, N4, S4, W5, Z5, nib, $6, o8, p8, naa, oaa, Xaa, Zaa, Yaa, _aa, rfa, tfa, sfa, ufa, mga, oga, nga, pga, Bga, Dga, Cga, Ega, wib, xib, Mna, Nna, bma, cma, ara, era, Bob, Fob, tva, Krb, Mrb, Orb, Trb, Xrb, $rb, dsb, EDa, HDa, KDa, NDa, ztb, Htb, ZHa, Qtb, Xtb, eub, rub, Sub, JJa, KJa, TJa, _zb, hAb, DOb, XOb, YOb, iPb, jPb, kPb, uPb, yPb, zPb, GPb, HPb, IPb, aQb, YPb, ZPb, f$b, q4b, Tcc, Wcc, Blc, mpc, Xpc, Moc, Ktc, cBc, iBc, COc, aSc, kcd, Wad, qbd, ybd, Ild, gpd, mpd, opd, $od, dpd, qpd, rpd, spd, tpd, vpd, ypd, zpd, Cpd, Jpd, Kpd, iqd, drd, hrd, Nqd, Dod, Jod, Qqd, Kqd, Lqd, Mqd, Zqd, Tqd, Uqd, Qod, Tod, Yqd, $Hd, nId, oId, pId, uId, ePd, fPd, gPd, iPd, dYd, r3d, v3d, y3d, l3d, a4d, i4d, K7d, Mqe, Oqe, Pqe, Rqe, Fre, Hse, Sre, wse, xre, pse, qse, wte, Hve, Lve, Ove, Sve, Vve, Zve, Txe, wxe, Axe, Rxe, pxe, qxe, xxe, rye, sye, Tye, eEe, iEe, lEe, HEe, LEe, OEe, TEe, UEe, kFe, oFe, rFe, NFe, RFe, UFe, mGe, pGe, SIh, XIh, _Ih, bJh, vJh, wJh, xJh, CJh, HJh, JJh, NJh, TJh, $Jh, aKh, bKh, gKh, lKh, nKh, rKh, xKh, GKh, KKh, XKh, rHe, tHe, rLh, uLh, vLh, sHe, yLh, BHe, DHe, ULh, XLh, YLh, CHe, gMh, hMh, GMh, VMh, WMh, tNh, CNh, FNh, JNh, NNh, LJe, mJe, qJe, JJe, fJe, gJe, nJe, $Je, aKe, BKe, oMe, rMe, uMe, $Le, aMe, bMe, hMe, IMe, LMe, mNe, pNe, sNe, ZMe, _Me, $Me, fNe, GNe, JNe, kOe, nOe, qOe, XNe, YNe, ZNe, dOe, EOe, HOe, IQh, JQh, KQh, PQh, UQh, WQh, _Qh, eRh, oRh, sRh, gQe, IPe, MPe, dQe, BPe, CPe, JPe, BQe, CQe, bRe, sSh, vSh, qRe, sRe, DSh, ESh, FSh, KSh, PSh, RSh, VSh, $Sh, oTh, sTh, ATh, BTh, CTh, HTh, MTh, OTh, STh, YTh, lUh, pUh, TSe, uSe, ySe, RSe, nSe, oSe, vSe, mTe, nTe, OTe, bUe, eUe, SVe, VWe, EWe, XWe, YWe, ZWe, bXe, iXe, uXe, wXe, IXe, VXe, RXe, WXe, TXe, YXe, UXe, jYe, pYe, sYe, xYe, yYe, LYe, KYe, BZe, IZe, XZe, T_e, U_e, V_e, W_e, X_e, Z_e, o$e, uZe, U$e, j0e, S$e, R$e, B$e, T$e, M$e, e0e, O$e, K$e, s0e, G$e, J0e, P0e, X0e, k1e, s1e, I1e, N1e, L2e, r2e, s2e, t2e, u2e, v2e, w2e, x2e, n2e, _Xe, D2e, ZXe, I2e, O2e, B2e, T2e, A2e, R2e, U2e, n3e, G3e, H3e, I3e, J3e, K3e, e4e, f4e, g4e, G4e, c5e, d5e, r5e, t5e, C5e, O5e, a8e, f8e, C9e, D9e, Oaf, Paf, sbf, Lbf, Rbf, Tbf, hcf, wcf, Ecf, Gcf, Ncf, idf, Bdf, Pdf, Sdf, Ydf, cef, I4e, Def, Fef, hff, ggf, whf, xhf, Jhf, Nhf, k6e, aif, bif, mif, Sjf, _jf, bkf, ckf, Tjf, gmf, hmf, imf, xmf, Hmf, Imf, Gmf, Hlf, bnf, Bnf, Snf, Wnf, gof, uof, Aof, Bof, Cof, Gof, Hof, Iof, Jof, Mof, Nof, Oof, Pof, Qof, Sof, Tof, ppf, tpf, upf, Ipf, Jpf, Kpf, Opf, Ppf, Qpf, Rpf, Upf, Vpf, Wpf, Xpf, Ypf, iqf, jqf, mqf, nqf, oqf, sqf, tqf, uqf, vqf, yqf, zqf, Aqf, Bqf, Cqf, Eqf, Fqf, Nqf, Oqf, Wqf, Xqf, Yqf, arf, brf, crf, drf, grf, hrf, irf, jrf, krf, trf, urf, Brf, Crf, Drf, Hrf, Irf, Jrf, Krf, Mrf, Nrf, Orf, Prf, Qrf, Srf, Trf, Zrf, $rf, bsf, csf, dsf, hsf, isf, jsf, ksf, nsf, osf, psf, qsf, rsf, tsf, usf, Asf, Bsf, Hsf, Isf, Jsf, Nsf, Osf, Psf, Qsf, Tsf, Usf, Vsf, Wsf, Xsf, Zsf, _sf, etf, ftf, itf, jtf, ktf, otf, ptf, qtf, rtf, utf, vtf, wtf, xtf, ytf, Atf, Btf, Htf, Itf, Wtf, Xtf, Ytf, auf, buf, cuf, duf, fuf, guf, huf, iuf, juf, kuf, luf, nuf, jpf, ouf, puf, opf, quf, Xof, ruf, suf, tuf, vuf, wuf, zuf, Huf, Iuf, Juf, Nuf, Ouf, Puf, Quf, Tuf, Uuf, Vuf, Zuf, _uf, Wof, dvf, gvf, lvf, nvf, svf, tvf, xvf, yvf, Cvf, Fvf, Hvf, Kvf, Mvf, Pvf, Wvf, Zvf, eqf, lwf, uwf, ywf, Bwf, ivf, Qwf, Rwf, Swf, Wwf, Xwf, Ywf, Zwf, axf, bxf, cxf, dxf, hxf, qxf, rxf, wxf, xxf, yxf, Cxf, Dxf, Exf, Fxf, Hxf, Ixf, Jxf, Kxf, Nxf, Zxf, lyf, myf, nyf, ryf, syf, tyf, uyf, wyf, xyf, yyf, zyf, Eyf, Hyf, Lyf, Tyf, Uyf, Vyf, dzf, jzf, kzf, lzf, mzf, nzf, ozf, pzf, qzf, _zf, $zf, aAf, eAf, fAf, gAf, hAf, jAf, kAf, lAf, mAf, nAf, oAf, pAf, rAf, tAf, BAf, EAf, HAf, JAf, KAf, LAf, dBf, lBf, mBf, oBf, pBf, qBf, yBf, DBf, FBf, HBf, OBf, QBf, zBf, HCf, TBf, VBf, WBf, _Bf, $Bf, aCf, bCf, eCf, fCf, gCf, qCf, iCf, DCf, ECf, GCf, KCf, IGf, rDf, vDf, zDf, ADf, JDf, MDf, xDf, NDf, hDf, WDf, uCf, mEf, oEf, GEf, ZEf, SGf, TGf, HGf, JGf, KGf, MGf, NGf, jCf, npf, PGf, UGf, WGf, bHf, pHf, _Hf, eIf, UIf, XIf, tof, kJf, xJf, AJf, BJf, CJf, DJf, FJf, GJf, HJf, IJf, JJf, KJf, LJf, vJf, rUf, fKf, gKf, hKf, pKf, tKf, lLf, uLf, vLf, wLf, BLf, CLf, aNf, hNf, jNf, kNf, zNf, aMf, fMf, hMf, iMf, xMf, AMf, FMf, HMf, IMf, XMf, ANf, INf, GNf, KNf, tUf, dOf, jOf, kOf, lOf, oOf, PPf, JPf, DPf, NPf, KPf, TPf, UPf, nPf, WQf, eRf, fRf, gRf, iRf, lRf, mRf, nRf, oRf, pRf, FRf, gSf, uSf, _Rf, YRf, vSf, wSf, fSf, ISf, LSf, NSf, OSf, PSf, QSf, mTf, oTf, pTf, ATf, BTf, CTf, DTf, ETf, jUf, lUf, oUf, sUf, WUf, AVf, BUf, AUf, kVf, lVf, SVf, RVf, TVf, VVf, QVf, WVf, UVf, $Wf, gYf, $_f, Z_f, f$f, AYf, BYf, HYf, YYf, $Yf, gZf, kZf, nZf, rZf, sZf, GZf, VZf, XZf, q_f, t_f, v_f, a$f, r$f, u$f, v$f, w$f, S$f, N0f, h$f, Y0f, s1f, E1f, H1f, g2f, E2f, K2f, O2f, T2f, W2f, X2f, g3f, h3f, i3f, j3f, k3f, n3f, o3f, E3f, G3f, I3f, L3f, M3f, b4f, j4f, i4f, l4f, s4f, v4f, x4f, L6f, n7f, r7f, z7f, A7f, C7f, i8f, j8f, k8f, l8f, s8f, z8f, K8f, I8f, e9f, A6f, m8f, q8f, D9f, H9f, G9f, N9f, mag, rag, yag, Gag, vag, Sag, Yag, kbg, lbg, wbg, $bg, Tbg, Qbg, Sbg, Wbg, Zbg, _bg, Kcg, Lcg, bdg, rdg, Ddg, Vdg, _dg, Ccg, eeg, feg, heg, seg, weg, yeg, Neg, Oeg, Qeg, bfg, Hbg, gfg, ifg, acg, vfg, wfg, zfg, Ifg, Rfg, Sfg, mgg, ngg, qgg, Fgg, Ggg, Jgg, Qgg, Ugg, reg, Xhg, aig, Oig, Pig, $ig, bjg, ajg, gjg, hjg, kjg, mjg, njg, pjg, rjg, tjg, ujg, vjg, yjg, Ajg, Bjg, Djg, Fjg, Hjg, Ijg, Ljg, Mjg, Ojg, Qjg, Ckg, Dkg, Ekg, Fkg, Ikg, Kkg, Lkg, Nkg, Pkg, Rkg, Skg, Tkg, Ukg, Ykg, Zkg, $kg, blg, dlg, elg, flg, glg, jlg, llg, mlg, olg, qlg, rlg, tlg, ulg, vlg, wlg, zlg, Blg, Dlg, Flg, Vlg, Wlg, Xlg, Ylg, $lg, bmg, cmg, emg, hmg, img, jmg, kmg, nmg, pmg, qmg, tmg, vmg, wmg, xmg, ymg, Bmg, Dmg, Emg, Gmg, Hmg, Img, Dog, Eog, Fog, Jog, Kog, Log, Mog, Pog, Qog, Rog, Uog, epg, fpg, gpg, kpg, lpg, mpg, npg, rpg, spg, tpg, vpg, Npg, Opg, Ppg, Rpg, upg, qpg, yqg, zqg, Bqg, Cqg, urg, Srg, Urg, Trg, Vrg, Xrg, csg, wsg, btg, mtg, itg, htg, vtg, ptg, ztg, Itg, Ttg, ttg, Cug, Eug, Fug, Iug, Jug, Nug, avg, ivg, hvg, lvg, mvg, Tvg, gwg, Fwg, Rwg, Vwg, Ywg, pxg, rxg, sxg, txg, vxg, yxg, Nxg, Rxg, Xxg, Yxg, Vxg, qyg, ryg, oyg, pyg, srg, Ayg, Gyg, czg, lzg, kXh, lXh, oXh, pXh, sXh, tXh, xXh, yXh, CXh, EXh, GXh, HXh, LXh, NXh, PXh, QXh, UXh, WXh, YXh, ZXh, bYh, dYh, fYh, gYh, kYh, mYh, oYh, pYh, vYh, xYh, zYh, AYh, GYh, IYh, KYh, LYh, KSg, MSg, OSg, PSg, PYh, RYh, TYh, UYh, YYh, _Yh, aZh, bZh, fZh, hZh, jZh, kZh, oZh, qZh, sZh, tZh, xZh, zZh, BZh, CZh, TSg, VSg, XSg, YSg, GZh, IZh, KZh, LZh, PZh, RZh, TZh, UZh, YZh, _Zh, a_h, b_h, f_h, h_h, j_h, k_h, o_h, q_h, s_h, t_h, aTg, cTg, eTg, fTg, x_h, z_h, B_h, C_h, G_h, I_h, K_h, L_h, P_h, R_h, T_h, U_h, Y_h, __h, a$h, b$h, f$h, h$h, j$h, k$h, o$h, q$h, s$h, t$h, x$h, z$h, B$h, C$h, G$h, I$h, K$h, L$h, lTg, nTg, oTg, sTg, uTg, wTg, xTg, P$h, R$h, T$h, U$h, Y$h, _$h, a0h, b0h, DTg, FTg, GTg, f0h, h0h, j0h, k0h, PTg, RTg, STg, o0h, q0h, s0h, t0h, x0h, z0h, B0h, C0h, G0h, I0h, K0h, L0h, P0h, R0h, T0h, U0h, Y0h, _0h, a1h, b1h, f1h, h1h, j1h, k1h, r1h, t1h, v1h, w1h, bUg, dUg, fUg, gUg, D1h, F1h, H1h, I1h, M1h, O1h, Q1h, R1h, mUg, oUg, pUg, BUg, DUg, EUg, OUg, QUg, SUg, TUg, ZUg, $Ug, aVg, lVg, nVg, pVg, qVg, uVg, wVg, yVg, zVg, DVg, FVg, HVg, IVg, X1h, Z1h, $1h, a2h, e2h, g2h, i2h, j2h, n2h, p2h, r2h, s2h, w2h, y2h, A2h, B2h, F2h, H2h, J2h, K2h, O2h, Q2h, S2h, T2h, X2h, Z2h, $2h, a3h, e3h, g3h, i3h, j3h, n3h, p3h, r3h, s3h, w3h, y3h, A3h, B3h, MVg, OVg, QVg, RVg, F3h, H3h, J3h, K3h, VVg, XVg, ZVg, _Vg, O3h, Q3h, S3h, T3h, X3h, Z3h, $3h, a4h, e4h, g4h, i4h, j4h, n4h, p4h, r4h, s4h, lWg, nWg, pWg, qWg, wWg, yWg, zWg, w4h, y4h, A4h, B4h, F4h, H4h, J4h, K4h, DWg, FWg, HWg, IWg, MWg, OWg, QWg, RWg, VWg, XWg, ZWg, _Wg, O4h, Q4h, S4h, T4h, eXg, gXg, hXg, qXg, sXg, tXg, CXg, EXg, FXg, X4h, Z4h, $4h, a5h, e5h, g5h, i5h, j5h, n5h, p5h, r5h, s5h, w5h, y5h, A5h, B5h, F5h, H5h, J5h, K5h, R5h, T5h, V5h, W5h, MXg, OXg, QXg, RXg, _5h, a6h, c6h, d6h, h6h, j6h, l6h, m6h, VXg, XXg, ZXg, _Xg, cYg, eYg, gYg, hYg, lYg, nYg, pYg, qYg, wYg, yYg, zYg, DYg, FYg, HYg, IYg, r6h, t6h, v6h, w6h, A6h, C6h, E6h, F6h, J6h, L6h, N6h, O6h, S6h, U6h, W6h, X6h, $6h, b7h, d7h, e7h, i7h, k7h, m7h, n7h, OYg, QYg, RYg, r7h, t7h, v7h, w7h, VYg, XYg, ZYg, _Yg, jZg, lZg, nZg, oZg, A7h, C7h, E7h, F7h, M7h, O7h, Q7h, R7h, Y7h, _7h, a8h, b8h, f8h, h8h, j8h, k8h, o8h, q8h, s8h, t8h, x8h, z8h, B8h, C8h, sZg, uZg, wZg, xZg, G8h, I8h, K8h, L8h, P8h, R8h, T8h, U8h, Y8h, _8h, a9h, b9h, BZg, DZg, FZg, GZg, f9h, h9h, j9h, k9h, KZg, MZg, OZg, PZg, TZg, VZg, XZg, YZg, a_g, c_g, e_g, f_g, j_g, l_g, n_g, o_g, o9h, q9h, s9h, t9h, x9h, z9h, B9h, C9h, s_g, u_g, w_g, x_g, D_g, F_g, G_g, K_g, M_g, O_g, P_g, G9h, I9h, K9h, L9h, P9h, R9h, T9h, U9h, a$g, c$g, d$g, h$g, j$g, l$g, m$g, q$g, s$g, u$g, v$g, z$g, B$g, D$g, E$g, I$g, K$g, M$g, N$g, R$g, T$g, V$g, W$g, _$g, a0g, c0g, d0g, j0g, l0g, m0g, q0g, s0g, u0g, v0g, Y9h, _9h, aai, bai, fai, hai, jai, kai, z0g, B0g, D0g, E0g, I0g, K0g, M0g, N0g, R0g, T0g, V0g, W0g, oai, qai, sai, tai, xai, zai, Bai, Cai, Gai, Iai, Kai, Lai, Pai, Rai, Tai, Uai, _0g, Yai, _ai, abi, bbi, fbi, hbi, jbi, kbi, h1g, j1g, l1g, m1g, obi, qbi, sbi, tbi, xbi, zbi, Bbi, Cbi, Gbi, Ibi, Kbi, Lbi, q1g, Pbi, Rbi, Tbi, Ubi, Ybi, _bi, aci, bci, z1g, B1g, D1g, E1g, fci, hci, jci, kci, oci, qci, sci, tci, I1g, K1g, M1g, N1g, xci, zci, Bci, Cci, Gci, Ici, Kci, Lci, Pci, Rci, Tci, Uci, Yci, _ci, adi, bdi, _1g, a2g, c2g, d2g, fdi, hdi, jdi, kdi, odi, qdi, sdi, tdi, xdi, zdi, Bdi, Cdi, Gdi, Idi, Kdi, Ldi, Pdi, Rdi, Tdi, Udi, Ydi, _di, aei, bei, fei, hei, jei, kei, oei, qei, sei, tei, xei, zei, Bei, Cei, Gei, Iei, Kei, Lei, Pei, Rei, Tei, Uei, Yei, _ei, afi, bfi, ffi, hfi, jfi, kfi, ofi, qfi, sfi, tfi, xfi, zfi, Bfi, Cfi, Gfi, Ifi, Kfi, Lfi, Pfi, Rfi, Tfi, Ufi, Yfi, _fi, agi, bgi, fgi, hgi, jgi, kgi, ogi, qgi, sgi, tgi, xgi, zgi, Bgi, Cgi, Ggi, Igi, Kgi, Lgi, Pgi, Rgi, Tgi, Ugi, Ygi, _gi, ahi, bhi, r2g, t2g, u2g, fhi, hhi, jhi, khi, ohi, qhi, shi, thi, xhi, zhi, Bhi, Chi, y2g, A2g, C2g, D2g, Ihi, P2g, R2g, S2g, W2g, Y2g, _2g, $2g, d3g, f3g, h3g, i3g, m3g, o3g, q3g, r3g, Mhi, Ohi, Qhi, Rhi, v3g, x3g, z3g, A3g, Vhi, Xhi, Zhi, _hi, cii, eii, gii, hii, lii, nii, pii, qii, uii, wii, yii, zii, E3g, G3g, I3g, J3g, Dii, Fii, Hii, Iii, N3g, P3g, R3g, S3g, W3g, Y3g, _3g, $3g, d4g, f4g, h4g, i4g, m4g, o4g, q4g, r4g, v4g, x4g, z4g, A4g, E4g, G4g, I4g, J4g, N4g, P4g, R4g, S4g, W4g, Y4g, _4g, $4g, d5g, f5g, h5g, i5g, m5g, o5g, q5g, r5g, Mii, Oii, Qii, Rii, Vii, Xii, Zii, _ii, cji, eji, gji, hji, lji, nji, pji, qji, uji, wji, yji, zji, Dji, Fji, Hji, Iji, Mji, Oji, Qji, Rji, Vji, Xji, Zji, _ji, cki, eki, gki, hki, lki, nki, pki, qki, uki, wki, yki, zki, Dki, Fki, Hki, Iki, Mki, Oki, Qki, Rki, Vki, Xki, Zki, _ki, cli, eli, gli, hli, lli, nli, pli, qli, uli, wli, yli, zli, Dli, Fli, Hli, Ili, Mli, Oli, Qli, Rli, v5g, x5g, z5g, A5g, Vli, Xli, Zli, _li, cmi, emi, gmi, hmi, lmi, nmi, pmi, qmi, umi, wmi, ymi, zmi, F5g, H5g, J5g, K5g, O5g, Q5g, S5g, T5g, X5g, Z5g, $5g, a6g, e6g, g6g, i6g, j6g, n6g, p6g, r6g, s6g, w6g, y6g, A6g, B6g, F6g, H6g, J6g, K6g, O6g, Q6g, S6g, T6g, X6g, Z6g, $6g, a7g, e7g, g7g, i7g, j7g, n7g, p7g, r7g, s7g, Fmi, Hmi, Jmi, Kmi, Omi, Qmi, Smi, Tmi, w7g, y7g, A7g, B7g, Xmi, Zmi, $mi, ani, eni, gni, ini, jni, F7g, H7g, J7g, K7g, nni, pni, rni, sni, O7g, Q7g, S7g, T7g, X7g, Z7g, $7g, a8g, wni, yni, Ani, Bni, Fni, Hni, Jni, Kni, e8g, g8g, i8g, j8g, Oni, Qni, Sni, Tni, n8g, p8g, r8g, s8g, Xni, Zni, $ni, aoi, eoi, goi, ioi, joi, noi, poi, roi, soi, woi, yoi, Aoi, Boi, Foi, Hoi, Joi, Koi, w8g, y8g, A8g, B8g, Ooi, Qoi, Soi, Toi, Xoi, Zoi, $oi, api, epi, gpi, ipi, jpi, npi, ppi, rpi, spi, F8g, H8g, J8g, K8g, wpi, ypi, Api, Bpi, O8g, Q8g, S8g, T8g, X8g, Z8g, $8g, a9g, e9g, g9g, i9g, j9g, n9g, p9g, r9g, s9g, w9g, y9g, A9g, B9g, F9g, H9g, J9g, K9g, Fpi, Hpi, Jpi, Kpi, Opi, Qpi, Spi, Tpi, Xpi, Zpi, $pi, aqi, O9g, Q9g, S9g, T9g, X9g, Z9g, $9g, aah, eah, gah, iah, jah, nah, pah, rah, sah, wah, yah, Aah, Bah, Fah, Hah, Jah, Kah, eqi, gqi, iqi, jqi, Oah, Qah, Sah, Tah, nqi, pqi, rqi, sqi, wqi, yqi, Aqi, Bqi, Xah, Zah, $ah, abh, Fqi, Hqi, Jqi, Kqi, ebh, gbh, ibh, jbh, Jsi, cBi, hBi, Lsi, tsi, mBi, rBi, vsi, eyi, gyi, iyi, Uxi, Xxi, _xi, TN, UN, fO, st, tt, Ht, Ut, Vt, Xt, Yt, bu, ju, vu, uu, ru, su, wu, pu, hD, mD, nD, sD, uD, zD, DD, wD, Du, Fu, Hu, cx, dx, fx, hx, ix, ND, mx, rx, Qx, sx, Mx, vx, xx, yx, Hx, Cx, Hv, Uv, jw, SD, dE, eE, dy, ey, _x, ky, sy, lz, sz, wz, yz, xz, Fz, Gz, ty, vy, xy, Oy, Qy, bz, ez, hz, jz, cA, eA, JA, lA, nA, oA, qA, rA, sA, tA, uA, MA, NA, OA, VA, PA, dB, pB, qB, wB, HB, FB, QB, PB, iC, SC, RC, ww, Fw, Hw, Iw, Jw, Tw, PQ, DVa, EVa, Zia, V_a, oGa, WRb, QSb, RSb, SSb, RUb, SUb, DWb, gXb, lYb, nYb, Y0b, b2b, z2b, s3b, b5b, a6b, Z8b, rcc, Jec, ihc, Shc, Okc, olc, Htc, Duc, Wwc, yyc, szc, LAc, $Bc, iEc, iFc, GFc, tHc, mJc, vKc, kLc, jNc, ZOc, TRc, HSc, fTc, DUc, W9c, xad, Ccd, ied, ued, vgd, wgd, xgd, ygd, zgd, Agd, Bgd, Cgd, Dgd, Egd, Fgd, Ggd, Hgd, Igd, Jgd, Kgd, Lgd, Mgd, Ngd, Ogd, Pgd, Qgd, Rgd, Sgd, Tgd, Ugd, Vgd, Wgd, Xgd, Ygd, Zgd, _gd, $gd, ahd, bhd, chd, dhd, ehd, fhd, ghd, hhd, ihd, jhd, khd, lhd, mhd, nhd, ohd, phd, qhd, rhd, shd, thd, uhd, vhd, whd, xhd, yhd, zhd, Ahd, Bhd, Chd, Dhd, Ehd, Fhd, Ghd, Hhd, Ihd, Jhd, Khd, Lhd, Mhd, Nhd, Ohd, Phd, Qkd, hmd, _md, Wyd, Fzd, Gzd, KAd, PAd, VCd, cDd, HDd, dFd, IGd, rJd, oKd, pKd, IKd, dLd, mLd, vJd, cMd, wWd, BZd, l2d, u6d, $8d, b9d, d9d, f9d, i9d, pae, rbe, sbe, vbe, xbe, zbe, Xbe, Wbe, oce, qce, rce, sce, uce, vce, wce, Ece, Fce, Ice, Kce, Sce, Rce, ade, dde, sde, fde, Hee, Mee, Jee, Nee, Oee, Kee, ide, $ee, Qee, Pee, Iee, lde, ode, Fee, Ree, tde, ude, vde, wde, xde, yde, zde, Ade, Bde, Cde, Dde, Ede, Fde, Gde, Hde, Ide, Jde, Kde, Lde, Mde, Nde, Ode, Pde, Qde, Rde, Sde, Tde, Ude, Vde, Wde, Xde, Yde, Zde, _de, $de, aee, bee, dee, eee, hee, kee, lee, dfe, ffe, ife, jfe, oge, Dfe, Hfe, Ife, Hge, Ige, qhe, fie, iie, _je, tke, Nke, yLi, zLi, ALi, BLi, CLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi, xLi ];
 var $n = [ DLi, n5d ];
 var ao = [ ELi, FLi, GLi, HLi, ILi, ELi, ELi, ELi ];
 var bo = [ JLi, iX ];
 var co = [ KLi, $9a, aab, bab, cab, dab, eab, fab, sV, tV, qW, yW, zab, WW, Lab, XW, YW, Zab, $ab, wbb, Fbb, yX, zX, DX, EX, HX, pX, NY, xcb, a_, Kcb, i_, k_, Ycb, _cb, A_, B_, udb, Idb, O_, Tdb, heb, i$, A$, p$, t$, D$, S$, T$, a0, g0, P0, i1, k1, Z1, h2, t2, qfb, Dfb, Nfb, _fb, kgb, Kgb, Xgb, fhb, shb, s3, Khb, Whb, K4, i6, d6, f6, _4, b5, k5, g5, V5, C6, Bib, x9, Ufa, Kga, sla, _na, aoa, coa, goa, ioa, $na, boa, doa, hoa, joa, Dma, Ema, uva, Qva, axa, Zwa, dxa, nxa, oxa, txa, bxa, _wa, exa, pxa, qxa, uxa, Txa, Wxa, xxa, yxa, Pxa, Rxa, Dxa, Exa, Uxa, Xxa, zxa, Axa, Fxa, Gxa, gBa, pBa, VBa, aCa, fsb, hsb, isb, jsb, ssb, usb, vsb, wsb, Fsb, Hsb, Isb, Jsb, Ssb, Usb, Vsb, Wsb, oub, jvb, nvb, PJa, QJa, DJa, EJa, hwb, mwb, rwb, Ayb, Byb, Cyb, Fyb, Gyb, Hyb, Kyb, Lyb, Myb, iAb, AAb, NOb, OOb, b$b, o3b, p3b, k4b, U3b, V3b, Bdc, Ddc, Scc, AAc, Phc, Lhc, Mhc, Qhc, Vcc, Pnc, bpc, fpc, kpc, upc, poc, Koc, Ppc, Qpc, Rpc, Spc, Tpc, $pc, aqc, fqc, bBc, Eic, hBc, RCc, Vad, Ced, Bed, cpd, upd, Gpd, nqd, Iod, Oqd, Sod, wDd, uEd, rFd, vFd, xFd, zFd, wFd, yFd, AFd, sFd, iId, jId, kId, OId, WId, jPd, j1d, s3d, x3d, t3d, u3d, L3d, J3d, $3d, O3d, h4d, R3d, S3d, _qe, gse, Ire, Ase, Fse, Vre, Wre, rse, sse, tse, use, vse, Iue, Nwe, Jxe, Pxe, oxe, yxe, Bxe, lxe, Cxe, zxe, Sxe, Nxe, Aye, vye, wye, Dxe, Wye, $Fe, cGe, tJh, yJh, DJh, IJh, KJh, MJh, UJh, ZJh, cKh, hKh, mKh, oKh, qKh, yKh, WKh, aLh, dLh, eLh, jLh, kLh, mLh, oLh, sLh, xLh, DLh, GLh, HLh, MLh, NLh, PLh, RLh, VLh, Vrh, jMh, nMh, DMh, vIe, yIe, zIe, CIe, Qrh, YMh, aNh, qNh, PIe, SIe, TIe, WIe, BJe, HJe, eJe, oJe, rJe, bJe, sJe, pJe, KJe, FJe, iKe, dKe, eKe, tJe, EKe, uJe, HKe, xPh, BPh, tMe, yMe, zMe, ZLe, cMe, iMe, pMe, sMe, rNe, wNe, xNe, XMe, aNe, gNe, nNe, qNe, pOe, uOe, vOe, VNe, _Ne, eOe, lOe, oOe, eQh, mQh, GQh, LQh, QQh, VQh, XQh, ZQh, fRh, XPe, bQe, APe, KPe, NPe, xPe, OPe, LPe, fQe, $Pe, KQe, FQe, GQe, PPe, eRe, QPe, hRe, BSh, GSh, LSh, QSh, SSh, USh, aTh, yTh, DTh, ITh, NTh, PTh, RTh, ZTh, JSe, PSe, mSe, wSe, zSe, jSe, ASe, xSe, SSe, NSe, vTe, qTe, rTe, BSe, RTe, CSe, UTe, YVe, bWe, eWe, xWe, yWe, IWe, QWe, TWe, sXe, rXe, OXe, NXe, PXe, mYe, iYe, HYe, FYe, QYe, OYe, UYe, TYe, YYe, VYe, h1e, gZe, lZe, zZe, v_e, x_e, h_e, N_e, f$e, l$e, s$e, h0e, K0e, V0e, W0e, i1e, l1e, m1e, q1e, r1e, v1e, A1e, w1e, D1e, E1e, V$e, G1e, H1e, K1e, L1e, Q1e, R1e, z0e, T1e, t0e, P$e, v0e, x0e, V1e, W1e, Q0e, b1e, d3e, g2e, k2e, K2e, b3e, e3e, yXe, M4e, s5e, u5e, q5e, b6e, Q6e, T6e, U6e, B6e, t8e, kaf, taf, fcf, mcf, pcf, qcf, tcf, ucf, Ocf, Pcf, Qcf, Rcf, Mcf, Xcf, Ycf, Zcf, _cf, $cf, adf, bdf, xdf, Jdf, aef, vef, Lef, Mef, Oef, Pef, Qef, Kef, $ef, aff, Bff, Lff, cgf, Hgf, dhf, hhf, Fhf, yif, _if, djf, Xkf, Clf, _lf, zmf, Amf, Pmf, Ymf, Zmf, Dof, Eof, Lpf, Mpf, pqf, qqf, Zqf, _qf, Erf, Frf, esf, fsf, Ksf, Lsf, ltf, mtf, Ztf, _tf, Euf, Kuf, Luf, qwf, Twf, Uwf, zxf, Axf, eyf, fyf, oyf, pyf, Nyf, Fyf, fzf, rzf, szf, tzf, uzf, vzf, wzf, bAf, cAf, wAf, yAf, ZAf, cBf, wBf, xBf, XBf, YBf, nDf, lDf, mDf, VEf, YEf, WEf, XEf, aFf, tDf, BDf, ODf, uDf, bEf, pEf, LEf, MEf, GHf, THf, QHf, ZHf, dIf, NIf, $If, Guf, fJf, qJf, EKf, AKf, DKf, rLf, ALf, bNf, nNf, oNf, sNf, bMf, lMf, mMf, qMf, BMf, LMf, MMf, QMf, gNf, LNf, PNf, MNf, xOf, yOf, zOf, AOf, gOf, mOf, pOf, JOf, LOf, ROf, bPf, hPf, HPf, vPf, wPf, EPf, GPf, OPf, oPf, qQf, EQf, PQf, RQf, QQf, VRf, HTf, FUf, OUf, cVf, oVf, zWf, GWf, JWf, lXf, AXf, CXf, V$f, r0f, G0f, f1f, d1f, e1f, q1f, B1f, p2f, v2f, B2f, C2f, M2f, b3f, e3f, f3f, K3f, e4f, h4f, A4f, u4f, X4f, r5f, J5f, _5f, F6f, X6f, y7f, J7f, W7f, K7f, o9f, z9f, eag, r9f, fag, gag, L7f, y9f, qag, obg, vbg, Cbg, Pbg, Ibg, Fbg, ecg, mcg, Idg, deg, Veg, Weg, cfg, Eeg, Deg, xeg, Ogg, Wgg, Nhg, kig, Rag, sig, uig, Qag, xig, _ig, Ujg, Vjg, Zjg, _jg, $jg, bkg, ckg, fkg, hkg, ikg, kkg, mkg, Gog, Hog, Sog, Wog, apg, hpg, ipg, Ipg, lqg, hqg, Aqg, Nqg, Pqg, jrg, lrg, Qrg, Mrg, Zrg, _rg, $rg, psg, Csg, Rsg, Ssg, Wsg, Zsg, aug, Ktg, Gug, Pug, Wug, _ug, hwg, dwg, ewg, fwg, Vvg, Mvg, Xvg, mwg, trg, qwg, Ewg, Lwg, qsg, $wg, Pxg, Qxg, Lxg, _xg, cyg, jyg, myg, wyg, Cyg, Iyg, Qyg, Oyg, Pyg, Wyg, Uyg, Vyg, _yg, gzg, ezg, fzg, ozg, qXh, rXh, uXh, vXh, zXh, AXh, FXh, IXh, JXh, OXh, RXh, SXh, XXh, _Xh, $Xh, eYh, hYh, iYh, nYh, qYh, rYh, yYh, BYh, CYh, JYh, MYh, NYh, NSg, QSg, RSg, SYh, VYh, WYh, $Yh, cZh, dZh, iZh, lZh, mZh, rZh, uZh, vZh, AZh, DZh, EZh, WSg, ZSg, _Sg, JZh, MZh, NZh, SZh, VZh, WZh, $Zh, c_h, d_h, i_h, l_h, m_h, r_h, u_h, v_h, dTg, gTg, hTg, A_h, D_h, E_h, J_h, M_h, N_h, S_h, V_h, W_h, $_h, c$h, d$h, i$h, l$h, m$h, r$h, u$h, v$h, A$h, D$h, E$h, J$h, M$h, N$h, jTg, mTg, pTg, qTg, vTg, yTg, zTg, S$h, V$h, W$h, $$h, c0h, d0h, BTg, ETg, HTg, ITg, i0h, l0h, m0h, NTg, QTg, TTg, UTg, r0h, u0h, v0h, A0h, D0h, E0h, J0h, M0h, N0h, S0h, V0h, W0h, $0h, c1h, d1h, i1h, l1h, m1h, o1h, u1h, x1h, y1h, A1h, eUg, hUg, iUg, G1h, J1h, K1h, P1h, S1h, T1h, kUg, nUg, qUg, rUg, zUg, CUg, FUg, GUg, RUg, UUg, VUg, XUg, _Ug, bVg, cVg, oVg, rVg, sVg, xVg, AVg, BVg, GVg, JVg, KVg, _1h, b2h, c2h, h2h, k2h, l2h, q2h, t2h, u2h, z2h, C2h, D2h, I2h, L2h, M2h, R2h, U2h, V2h, _2h, b3h, c3h, h3h, k3h, l3h, q3h, t3h, u3h, z3h, C3h, D3h, PVg, SVg, TVg, I3h, L3h, M3h, YVg, $Vg, aWg, R3h, U3h, V3h, _3h, b4h, c4h, fWg, h4h, k4h, l4h, q4h, t4h, u4h, oWg, rWg, sWg, uWg, xWg, AWg, BWg, z4h, C4h, D4h, I4h, L4h, M4h, GWg, JWg, KWg, PWg, SWg, TWg, YWg, $Wg, aXg, R4h, U4h, V4h, cXg, fXg, iXg, jXg, lXg, oXg, rXg, uXg, vXg, xXg, AXg, DXg, GXg, HXg, JXg, _4h, b5h, c5h, h5h, k5h, l5h, q5h, t5h, u5h, z5h, C5h, D5h, I5h, L5h, M5h, O5h, U5h, X5h, Y5h, PXg, SXg, TXg, b6h, e6h, f6h, k6h, n6h, o6h, YXg, $Xg, aYg, fYg, iYg, jYg, oYg, rYg, sYg, uYg, xYg, AYg, BYg, GYg, JYg, KYg, u6h, x6h, y6h, D6h, G6h, H6h, M6h, P6h, Q6h, V6h, Y6h, Z6h, c7h, f7h, g7h, l7h, o7h, p7h, MYg, PYg, SYg, TYg, u7h, x7h, y7h, YYg, $Yg, aZg, mZg, pZg, qZg, D7h, G7h, H7h, J7h, P7h, S7h, T7h, V7h, $7h, c8h, d8h, i8h, l8h, m8h, r8h, u8h, v8h, A8h, D8h, E8h, vZg, yZg, zZg, J8h, M8h, N8h, S8h, V8h, W8h, $8h, c9h, d9h, EZg, HZg, IZg, i9h, l9h, m9h, NZg, QZg, RZg, WZg, ZZg, _Zg, d_g, g_g, h_g, m_g, p_g, q_g, r9h, u9h, v9h, A9h, D9h, E9h, v_g, y_g, z_g, B_g, E_g, H_g, I_g, N_g, Q_g, R_g, J9h, M9h, N9h, S9h, V9h, W9h, __g, b$g, e$g, f$g, k$g, n$g, o$g, t$g, w$g, x$g, C$g, F$g, G$g, L$g, O$g, P$g, U$g, X$g, Y$g, b0g, e0g, f0g, h0g, k0g, n0g, o0g, t0g, w0g, x0g, $9h, cai, dai, iai, lai, mai, C0g, F0g, G0g, L0g, O0g, P0g, U0g, X0g, Y0g, rai, uai, vai, Aai, Dai, Eai, Jai, Mai, Nai, Sai, Vai, Wai, $0g, b1g, $ai, cbi, dbi, ibi, lbi, mbi, k1g, n1g, o1g, rbi, ubi, vbi, Abi, Dbi, Ebi, Jbi, Mbi, Nbi, r1g, t1g, Sbi, Vbi, Wbi, $bi, cci, dci, C1g, F1g, G1g, ici, lci, mci, rci, uci, vci, L1g, O1g, P1g, Aci, Dci, Eci, Jci, Mci, Nci, U1g, Sci, Vci, Wci, $ci, cdi, ddi, b2g, e2g, f2g, idi, ldi, mdi, rdi, udi, vdi, Adi, Ddi, Edi, Jdi, Mdi, Ndi, Sdi, Vdi, Wdi, $di, cei, dei, iei, lei, mei, rei, uei, vei, Aei, Dei, Eei, Jei, Mei, Nei, Sei, Vei, Wei, $ei, cfi, dfi, ifi, lfi, mfi, rfi, ufi, vfi, Afi, Dfi, Efi, Jfi, Mfi, Nfi, Sfi, Vfi, Wfi, $fi, cgi, dgi, igi, lgi, mgi, rgi, ugi, vgi, Agi, Dgi, Egi, Jgi, Mgi, Ngi, Sgi, Vgi, Wgi, $gi, chi, dhi, p2g, s2g, v2g, w2g, ihi, lhi, mhi, rhi, uhi, vhi, Ahi, Dhi, Ehi, B2g, E2g, F2g, N2g, Q2g, T2g, U2g, Z2g, a3g, b3g, g3g, j3g, k3g, p3g, s3g, t3g, Phi, Shi, Thi, y3g, B3g, C3g, Yhi, $hi, aii, fii, iii, jii, oii, rii, sii, xii, Aii, Bii, H3g, K3g, L3g, Gii, Jii, Kii, Q3g, T3g, U3g, Z3g, a4g, b4g, g4g, j4g, k4g, p4g, s4g, t4g, y4g, B4g, C4g, H4g, K4g, L4g, Q4g, T4g, U4g, Z4g, a5g, b5g, g5g, j5g, k5g, p5g, s5g, t5g, Pii, Sii, Tii, Yii, $ii, aji, fji, iji, jji, oji, rji, sji, xji, Aji, Bji, Gji, Jji, Kji, Pji, Sji, Tji, Yji, $ji, aki, fki, iki, jki, oki, rki, ski, xki, Aki, Bki, Gki, Jki, Kki, Pki, Ski, Tki, Yki, $ki, ali, fli, ili, jli, oli, rli, sli, xli, Ali, Bli, Gli, Jli, Kli, Pli, Sli, Tli, y5g, B5g, C5g, Yli, $li, ami, fmi, imi, jmi, omi, rmi, smi, xmi, Ami, Bmi, I5g, L5g, M5g, R5g, U5g, V5g, _5g, b6g, c6g, h6g, k6g, l6g, q6g, t6g, u6g, z6g, C6g, D6g, I6g, L6g, M6g, R6g, U6g, V6g, _6g, b7g, c7g, h7g, k7g, l7g, q7g, t7g, u7g, Imi, Lmi, Mmi, Rmi, Umi, Vmi, z7g, C7g, D7g, _mi, bni, cni, hni, kni, lni, I7g, L7g, M7g, qni, tni, uni, R7g, U7g, V7g, _7g, b8g, c8g, zni, Cni, Dni, Ini, Lni, Mni, h8g, k8g, l8g, Rni, Uni, Vni, q8g, t8g, u8g, _ni, boi, coi, hoi, koi, loi, qoi, toi, uoi, zoi, Coi, Doi, Ioi, Loi, Moi, z8g, C8g, D8g, Roi, Uoi, Voi, _oi, bpi, cpi, hpi, kpi, lpi, qpi, tpi, upi, I8g, L8g, M8g, zpi, Cpi, Dpi, R8g, U8g, V8g, _8g, b9g, c9g, h9g, k9g, l9g, q9g, t9g, u9g, z9g, C9g, D9g, I9g, L9g, M9g, Ipi, Lpi, Mpi, Rpi, Upi, Vpi, _pi, bqi, cqi, R9g, U9g, V9g, _9g, bah, cah, hah, kah, lah, qah, tah, uah, zah, Cah, Dah, Iah, Lah, Mah, hqi, kqi, lqi, Rah, Uah, Vah, qqi, tqi, uqi, zqi, Cqi, Dqi, _ah, bbh, cbh, Iqi, Lqi, Mqi, hbh, kbh, lbh, dri, sti, gO, iO, Lt, Ot, Mt, Qt, Zt, _t, cu, TD, UD, WD, XD, _D, fE, lE, uz, My, Ry, gz, BA, CA, DA, EA, GA, UA, LC, Qw, WQ, bya, eya, cya, fya, mya, nya, jya, XFa, VFa, _Fa, YFa, bGa, $Fa, eGa, cGa, hGa, fGa, kGa, iGa, nGa, lGa, qGa, tGa, rGa, S0b, a5b, Mcc, jhc, Thc, Uhc, Vhc, twc, hwc, tzc, MAc, NAc, LQc, E9c, k9c, SAd, hBd, iBd, uBd, NBd, jCd, lCd, mCd, nCd, oCd, $Ed, aFd, bFd, cLd, VTd, lUd, xWd, yWd, zWd, AWd, BWd, gWd, G3d, g9d, _9d, aae, efe, ufe, Jge, Kge, Lge, Mge, rhe, she, xhe, Yhe, bie, gie, hie, wie, rke, ske, Jle, Ile, Lle, Kle, LLi, MLi, NLi, OLi, PLi, QLi, RLi, SLi, TLi, ULi, VLi, WLi, XLi, YLi, ZLi, _Li, $Li, aMi, bMi, cMi, dMi, eMi, fMi, gMi, hMi, iMi, jMi, kMi, lMi, mMi, nMi, oMi, pMi, qMi, rMi, sMi, tMi, uMi, vMi, wMi, xMi, yMi, zMi, AMi, BMi, CMi, DMi, EMi, FMi, GMi, HMi, IMi, JMi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi, KLi ];
 var eo = [ KMi, LMi, bQb, cQb, _Rb, $Rb, L_b, M_b, P3b, Q3b, X3b, Y3b, _3b, $3b, Pac, Qac, nbc, obc, zbc, Abc, bcc, ccc, yic, zic, gkc, hkc, Brc, Crc, IJc, JJc, XNc, YNc, fOc, gOc, OPc, PPc, pUc, qUc, Hdd, Idd, bed, ced, pmd, qmd, Und, Vnd, pqd, Trd, Urd, Xrd, Yrd, ktd, ltd, QTd, RTd, oUd, pUd, e1d, f1d, z2d, A2d, _oe, $oe, qwe, zwe, Awe, wwe, xwe, vDi, Lq, Aq, jO, dt, zt, Uu, kv, rw, xC, dC, zC, NM, TRb, lSb, mSb, uUb, sUb, VTb, WTb, pWb, RWb, fYb, aYb, bYb, J0b, j$b, X0b, U1b, p2b, j2b, k2b, m3b, R4b, x4b, y4b, O5b, _5b, $5b, P8b, L8b, M8b, N8b, Ybc, Zbc, Wbc, Zdc, Zgc, _gc, hhc, rhc, shc, $jc, akc, Fkc, Ckc, Dkc, jlc, ytc, cuc, buc, tuc, Nwc, gyc, hyc, xyc, Wyc, Xyc, Yyc, Ozc, Pzc, Qzc, Rzc, TBc, UDc, REc, SEc, TEc, yFc, bHc, XJc, YJc, ZJc, bLc, YMc, YOc, QOc, ORc, ySc, oSc, pSc, GSc, XSc, tUc, a9c, b9c, c9c, pad, ocd, Dkd, Xjd, Yjd, Yld, Pmd, hzd, zDd, MEd, KEd, cFd, rGd, sGd, tGd, uGd, vGd, wGd, cGd, BFd, FFd, dId, eId, fId, oJd, fKd, RJd, _Jd, WKd, TKd, UKd, ULd, qLd, rLd, FOd, SOd, TOd, UOd, MTd, NTd, OTd, nUd, zVd, AVd, BVd, MXd, NXd, OXd, PXd, d2d, H1d, I1d, D3d, E3d, F3d, h5d, i5d, W5d, z8d, p5d, q5d, r5d, e6d, D5d, E5d, gke, dke, eke, Zke, _ke, $ke, ale, ble, cle, ile, jle, kle, upe, MMi, NMi, OMi, Oqi, Pqi, Qqi, Rqi, Sqi, Tqi, Uqi, Vqi, wDi, PMi, QMi, RMi, SMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi, KMi ];
 var fo = [ TMi, Azf, dkg, Kpg, Lpg, X1g, Y1g, TMi ];
 var go = [ UMi, bT, HV, yab, wcb, Hdb, pfb, Ofb, Jgb, ghb, v6, aBc, gBc, Uad, mId, Tqe, R5e, Kcf, Ref, Sef, Dhf, zzf, lPf, hag, Xjg, ekg, iWg, jWg, rFa, wFa, yFa, BGa, EGa, MGa, GHa, JHa, MHa, v5a, jBd, VMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi, UMi ];
 var ho = [ WMi, lgf, ngf, WMi ];
 var io = [ XMi, YMi ];
 var jo = [ ZMi, _Mi, $Mi, aNi ];
 var ko = [ bNi, UO, VO, WO, XO, YO, ZO, lti, oti, mti, pti, nti, qti, Msi, Osi, Nsi, Psi, _O, $O, pP, qP, tP, uP, vP, yP, zP, AP, DP, PO, EP, FP, GP, Xsi, Zsi, Ysi, _si, KR, IR, r8a, MR, LR, JR, O8a, P8a, aS, _R, R8a, cS, bS, $R, o9a, p9a, r9a, s9a, t9a, w9a, x9a, L9a, M9a, N9a, LS, US, KS, JS, P9a, Q9a, Z9a, lT, kT, xT, wT, yT, LT, KT, PT, OT, TT, ST, hab, iab, jab, QU, PU, OU, iV, hV, gV, CV, DV, WV, VV, UV, KW, HW, GW, hbb, ibb, kbb, lbb, mbb, qbb, rbb, tbb, ubb, vbb, Bbb, Cbb, Dbb, Ebb, fX, jX, bX, aX, Obb, Pbb, Qbb, Sbb, Tbb, Ubb, Wbb, Xbb, Ybb, vX, uX, tX, AX, RX, QX, FY, AY, yY, DY, BY, zY, EY, ecb, fcb, gcb, hcb, icb, WY, VY, YY, kcb, lcb, ocb, pcb, $Z, YZ, XZ, y_, z_, F_, G_, idb, jdb, kdb, mdb, ndb, odb, pdb, rdb, sdb, tdb, zdb, Adb, N_, K_, J_, S_, T_, _db, $db, aeb, ceb, deb, eeb, feb, geb, meb, neb, X_, W_, Z_, Y_, $_, F0, j1, l1, reb, seb, teb, veb, web, yeb, zeb, Aeb, Beb, Ceb, Deb, Feb, Geb, Heb, Jeb, Keb, Leb, Meb, Oeb, fZa, Qeb, Reb, Seb, Teb, Veb, Web, Xeb, Yeb, Zeb, _eb, $eb, afb, F1, z1, x1, W1, B1, A1, y1, C1, dfb, efb, M2, N2, L2, K2, gfb, hfb, ifb, c3, b3, Efb, Zfb, pgb, qgb, rgb, tgb, ugb, xgb, ygb, zgb, Agb, Bgb, Cgb, q3, p3, Ygb, rhb, Hhb, Ihb, Mhb, Nhb, Ohb, Phb, Qhb, H4, D4, C4, U4, p6, q6, fib, gib, hib, kib, lib, J6, H6, F6, K6, I6, G6, L6, pib, qib, b7, sib, tib, p7, o7, zib, Aib, uib, q8, m8, k8, n8, l8, yib, p9, o9, q9, s9, kaa, iaa, gaa, laa, jaa, haa, maa, Cib, Dib, Waa, Saa, Uaa, Taa, Vaa, Fib, Gib, Hib, Iib, aca, $ba, Jib, Kib, Mib, Nib, Oib, Pib, Qib, Sib, Tib, Uib, Wib, Xib, Yib, _ib, $ib, ajb, cjb, djb, ejb, gjb, hjb, ijb, jjb, kjb, ljb, njb, ojb, pjb, rjb, sjb, tjb, vjb, wjb, xjb, zjb, Ajb, Bjb, Djb, Ejb, Fjb, Hjb, Ijb, Jjb, Ljb, Mjb, Njb, Pjb, Qjb, Rjb, Sjb, Tjb, Ujb, Vjb, Wjb, Xjb, Zjb, _jb, $jb, bkb, ckb, dkb, mfa, nfa, pfa, ofa, qfa, ekb, fkb, Gfa, Ffa, gga, fga, kga, iga, qga, sga, rga, tga, lga, jga, xga, vga, gkb, hkb, ikb, jkb, kkb, yga, wga, Hga, Gga, mkb, nkb, okb, pkb, rkb, qia, pia, Dia, Cia, vib, skb, tkb, rla, qla, xla, wla, hna, fna, ina, gna, vkb, wkb, xkb, ykb, Ena, Cna, Fna, Dna, zkb, Akb, fma, hma, Hkb, zlb, Hlb, Jlb, Bma, amb, bmb, emb, fmb, gma, ima, mmb, enb, mnb, onb, Cma, Hnb, Inb, xoa, voa, yoa, woa, $nb, aob, Moa, Koa, bob, cob, Goa, dob, eob, Ioa, cqa, bqa, dqa, gqa, fqa, hqa, kqa, jqa, lqa, iob, job, Xpa, lob, mob, Ypa, oob, pob, Zpa, rob, sob, mqa, uob, vob, nqa, xob, yob, oqa, Mqa, Lqa, $qa, _qa, fra, qra, ura, tra, vra, xra, Nob, Oob, Dra, Qob, Rob, Tob, Uob, Vob, Xob, Yob, Zob, $ob, apb, bpb, dpb, epb, fpb, hpb, ipb, jpb, lpb, mpb, npb, ppb, qpb, rpb, tpb, upb, vpb, wpb, Cta, ypb, zpb, Kta, Bpb, Cpb, Epb, Fpb, Gpb, Ipb, Jpb, Kpb, Mpb, Npb, Opb, Qpb, Rpb, Spb, Upb, Vpb, Wpb, Ypb, Zpb, _pb, aqb, bqb, cqb, eqb, fqb, gqb, iqb, kqb, lqb, mqb, nqb, pqb, qqb, rqb, tqb, uqb, vqb, xqb, yqb, zqb, Aqb, Bqb, Dqb, Eqb, Fqb, Gqb, dva, cva, fva, Jqb, Kqb, gva, mva, lva, vva, Gva, Fva, Iva, Qqb, fwa, ewa, Rqb, Sqb, Uqb, Vqb, Wqb, Yqb, Zqb, _qb, arb, brb, crb, erb, frb, grb, irb, jrb, krb, mrb, nrb, orb, qwa, qrb, rrb, rwa, Jwa, trb, urb, Brb, Crb, Drb, Erb, Hrb, Irb, mBa, cBa, bBa, XBa, TBa, SBa, dCa, cCa, Prb, Rrb, Srb, Vrb, Wrb, Zrb, _rb, bsb, csb, msb, nsb, osb, psb, zsb, Asb, Bsb, Csb, Msb, Nsb, Osb, Psb, Zsb, _sb, $sb, atb, ctb, dtb, htb, itb, mtb, ntb, rtb, stb, xtb, ytb, Etb, Jtb, Ktb, YHa, Ltb, Mtb, bRa, Otb, Ptb, ZQa, _tb, $tb, _Qa, aub, bub, tOa, YIa, WIa, uOa, ZIa, XIa, vOa, lub, mub, nub, pub, Aub, Bub, Iub, Jub, Kub, Pub, Vub, Wub, Yub, Zub, evb, fvb, gvb, hvb, ivb, kvb, lvb, mvb, ovb, pvb, qvb, FJa, GJa, IJa, zJa, yJa, xJa, iKa, aKa, $Ja, Avb, Bvb, Fvb, Gvb, Hvb, Ivb, fwb, gwb, kwb, lwb, pwb, qwb, WLa, VLa, Nwb, Owb, GMa, FMa, MMa, LMa, Pwb, Qwb, Twb, Uwb, Vwb, Wwb, Zwb, _wb, $wb, axb, dxb, exb, fxb, gxb, ixb, jxb, lxb, mxb, pOa, nOa, qOa, oOa, nxb, oxb, pxb, qxb, uxb, vxb, zxb, Axb, Exb, Fxb, Jxb, Kxb, Oxb, Pxb, Txb, Uxb, Yxb, Zxb, byb, cyb, gyb, hyb, lyb, myb, qyb, ryb, vyb, wyb, Dyb, Eyb, Iyb, Jyb, Nyb, Oyb, Pyb, Qyb, Tyb, Uyb, Xyb, Yyb, Zyb, $yb, azb, dzb, ezb, gzb, hzb, kzb, lzb, nzb, ozb, rzb, szb, uzb, vzb, xzb, yzb, Azb, Bzb, Dzb, Ezb, Gzb, Hzb, Jzb, Kzb, Mzb, Nzb, Pzb, Qzb, Szb, Tzb, Vzb, Wzb, XQa, VQa, YQa, WQa, Xzb, Yzb, nRa, hRa, fRa, kRa, iRa, gRa, lRa, kAb, lAb, mAb, nAb, pAb, qAb, sAb, tAb, wAb, xAb, yAb, zAb, EAb, FAb, HAb, IAb, EOb, FOb, QOb, $Ob, dPb, ePb, qPb, rPb, BPb, CPb, PPb, TPb, UPb, rQb, sQb, oRb, qRb, rRb, sRb, tRb, XRb, YRb, TSb, USb, fSb, WSb, XSb, ZSb, _Sb, $Sb, aTb, TUb, UUb, KTb, oTb, WUb, XUb, fUb, _Ub, EWb, FWb, nXb, oXb, qXb, oYb, pYb, ZXb, _Xb, $Xb, qYb, rYb, W_b, X_b, c$b, d$b, c1b, d1b, o$b, m$b, l$b, s$b, t$b, c2b, d2b, W1b, X1b, G2b, H2b, n2b, t3b, u3b, k3b, M3b, N3b, l4b, O3b, o4b, R3b, S3b, T3b, Z3b, h5b, i5b, C4b, B4b, D4b, G4b, r6b, s6b, e9b, f9b, J8b, z8b, xdc, ydc, Wec, Xec, Gdc, Dec, Yec, Zec, _ec, $ec, khc, lhc, Whc, Xhc, Ahc, yAc, _zc, eAc, gAc, pAc, Ehc, sAc, wAc, xAc, Zhc, _hc, fAc, hAc, rAc, Nkc, wkc, Qkc, Rkc, Skc, Tkc, Ukc, Vkc, Wkc, Xkc, Ykc, Zkc, plc, qlc, blc, zlc, Alc, Ooc, Fnc, Gnc, Toc, Uoc, $oc, $nc, koc, spc, Epc, Ipc, Jpc, Loc, Mpc, toc, uoc, voc, woc, xoc, yoc, bqc, zqc, Wqc, Xqc, Itc, Jtc, Rbd, Huc, Iuc, vEc, qEc, BDc, pEc, EEc, IEc, JEc, KEc, ruc, bxc, cxc, Lwc, ywc, Hyc, Iyc, syc, ryc, Bzc, Czc, VGc, ezc, fzc, Ncc, UAc, cAc, Qcc, VAc, WAc, fCc, gCc, CBc, CDc, vBc, rCc, HCc, ICc, tDc, uDc, Cuc, kEc, ADc, GDc, jFc, kFc, CEc, MFc, NFc, nFc, qFc, wFc, Ezc, IHc, fGc, QJc, HKc, IKc, lKc, iKc, nLc, oLc, ZKc, WKc, sNc, tNc, FOc, GOc, dPc, ePc, PQc, QQc, FRc, GRc, URc, VRc, eSc, fSc, YRc, bSc, lSc, jSc, kSc, OSc, PSc, tSc, lTc, mTc, nTc, OUc, PUc, Y9c, Z9c, f9c, D9c, i9c, s9c, u9c, t9c, K9c, j9c, Dad, Ead, ead, kad, Pbd, Qbd, Had, Dcd, Ged, Hed, mfd, nfd, Zhd, _hd, Qid, Rid, $id, ajd, UHc, $kd, $jd, Njd, mmd, nmd, Cld, Lld, gnd, hnd, vod, wod, Xod, Yod, Upd, Vpd, gqd, hqd, Nod, qrd, Csd, Dsd, Std, Ttd, kud, lud, lvd, mvd, nvd, ovd, Mwd, Nwd, NDd, ODd, sDd, rDd, uDd, GEd, HEd, pEd, vDd, SDd, iFd, xEd, OGd, PGd, JFd, IFd, QGd, RGd, TGd, UGd, XGd, YGd, $Gd, aHd, bHd, cHd, fHd, gHd, iHd, jHd, kHd, aId, bId, EId, GId, FId, HId, UId, VId, bJd, cJd, sJd, tJd, vKd, wKd, BJd, xKd, yKd, YJd, cKd, eLd, fLd, RKd, SKd, NKd, MKd, iMd, jMd, sLd, ELd, $Md, bNd, MNd, NNd, mOd, POd, YOd, ZOd, _Od, $Od, aPd, bPd, cPd, EWd, FWd, oVd, qVd, rVd, EVd, FVd, DXd, EXd, FXd, GXd, RXd, SXd, eYd, fYd, l1d, m1d, q2d, r2d, M1d, F1d, G1d, J1d, K1d, g3d, h3d, k3d, p3d, q3d, m3d, X3d, d4d, e4d, j4d, m5d, B6d, C6d, R5d, zke, Ake, fke, Nje, Oje, Ppe, Dqe, Fqe, Iqe, Gqe, Hqe, Lre, tre, Jqe, Kqe, _re, ose, $re, ase, Jse, Ose, kte, lte, nte, ote, pte, rte, ste, tte, ute, vte, yte, zte, Bue, Cue, Fve, Gve, Ive, Kve, Mve, Nve, Pve, Rve, Tve, Uve, Wve, Yve, iwe, pwe, Bwe, Cwe, Ewe, Fwe, Gwe, Hwe, Jwe, Kwe, Lwe, Iwe, Pwe, Qwe, Rwe, $xh, eyh, jyh, oyh, tyh, yyh, Dyh, Iyh, Nyh, _we, Syh, Xyh, azh, fzh, kzh, dxe, pzh, uzh, zzh, Ezh, Jzh, ixe, Ozh, Tzh, Yzh, bAh, gAh, lAh, qAh, vAh, kxe, Kxe, Qxe, dye, iye, AAh, FAh, nye, KAh, qye, Fye, Pye, Kye, Gye, _ye, dze, PAh, fze, gze, hze, lze, mze, nze, rze, sze, tze, xze, yze, zze, UAh, ZAh, cBh, hBh, mBh, rBh, wBh, BBh, GBh, LBh, QBh, VBh, _Bh, dCh, iCh, nCh, sCh, xCh, CCh, HCh, MCh, RCh, WCh, Gze, $Ch, eDh, jDh, Lze, Qze, Vze, _ze, dAe, oDh, iAe, tDh, yDh, DDh, IDh, nAe, NDh, sAe, xAe, CAe, HAe, MAe, RAe, WAe, $Ae, eBe, jBe, SDh, XDh, aEh, fEh, kEh, pEh, uEh, zEh, EEh, JEh, OEh, TEh, YEh, bFh, gFh, lFh, qFh, vFh, AFh, oBe, FFh, KFh, PFh, UFh, tBe, yBe, DBe, IBe, NBe, SBe, XBe, aCe, fCe, kCe, pCe, ZFh, cGh, uCe, hGh, mGh, zCe, rGh, ECe, JCe, wGh, BGh, OCe, GGh, TCe, LGh, QGh, VGh, _Gh, dHh, YCe, iHh, nHh, sHh, xHh, bDe, CHh, gDe, lDe, qDe, vDe, ADe, FDe, HHh, MHh, RHh, KDe, PDe, UDe, WDe, XDe, ZDe, _De, cEe, dEe, gEe, hEe, qEe, vEe, xEe, yEe, AEe, BEe, FEe, GEe, JEe, KEe, _Ee, WHh, aFe, bFe, dFe, eFe, iFe, jFe, mFe, nFe, wFe, $Hh, eIh, BFe, jIh, DFe, EFe, GFe, HFe, LFe, MFe, PFe, QFe, ZFe, jGe, kGe, oIh, tIh, yIh, DIh, IIh, NIh, lGe, QIh, RIh, VIh, WIh, ZIh, aJh, fJh, gJh, lJh, mJh, pJh, rJh, GJh, VJh, XJh, kKh, BKh, EKh, FKh, JKh, oHe, OKh, TKh, ZKh, pLh, qLh, ALh, SLh, TLh, bIe, fMh, qMh, AMh, BMh, CMh, LIe, UMh, dNh, nNh, oNh, pNh, ANh, BNh, ENh, HNh, INh, MNh, _Ie, aJe, CJe, IJe, XJe, _Je, nKe, xKe, sKe, oKe, QKe, VKe, _Ke, RNh, WNh, $Nh, eOh, jOh, oOh, tOh, yOh, DOh, IOh, dLe, NOh, iLe, SOh, XOh, nLe, aPh, fPh, sLe, xLe, kPh, pPh, CLe, HLe, MLe, uPh, SLe, ULe, WLe, nMe, CMe, BMe, FMe, GMe, HMe, QMe, SMe, UMe, lNe, ANe, zNe, DNe, ENe, FNe, ONe, QNe, SNe, jOe, yOe, xOe, BOe, COe, DOe, HPh, MPh, RPh, WPh, $Ph, cQh, kQh, uQh, zQh, CQh, EQh, TQh, iRh, jRh, mRh, nRh, rRh, wRh, XOe, BRh, GRh, aPe, fPe, kPe, pPe, uPe, LRh, QRh, VRh, _Rh, dSh, iSh, wPe, YPe, cQe, sQe, nSh, xQe, AQe, PQe, ZQe, UQe, QQe, qSh, rSh, uSh, nRe, oRe, pRe, xRe, xSh, zSh, OSh, dTh, iTh, jTh, mTh, nTh, rTh, uTh, wTh, LTh, aUh, fUh, gUh, jUh, kUh, oUh, tUh, yUh, DUh, IUh, ERe, NUh, SUh, XUh, JRe, aVh, ORe, TRe, YRe, bSe, fVh, kVh, gSe, iSe, KSe, QSe, dTe, iTe, pVh, uVh, lTe, ATe, KTe, FTe, BTe, _Te, $Te, aUe, jUe, oUe, tUe, yUe, DUe, IUe, NUe, SUe, XUe, zVh, EVh, aVe, fVe, kVe, JVh, OVh, TVh, YVh, pVe, bWh, gWh, uVe, lWh, qWh, vWh, zVe, AWh, FWh, EVe, KWh, PWh, JVe, UWh, ZWh, OVe, cXh, hXh, QVe, RVe, TVe, VVe, WVe, zWe, XVe, cWe, gWe, lWe, jWe, rWe, BWe, GWe, MWe, NWe, OWe, WWe, _We, dXe, eXe, fXe, hXe, lXe, mXe, nXe, tXe, vXe, DXe, AXe, EXe, GXe, HXe, KXe, MXe, SXe, oYe, BYe, CYe, DYe, qXe, EYe, NYe, RYe, pXe, SYe, ZYe, $Ye, aZe, dZe, eZe, jZe, iZe, oZe, xZe, yZe, EZe, DZe, JZe, SZe, tZe, a_e, c_e, t_e, K_e, L_e, TZe, M_e, a$e, e$e, k$e, n$e, u$e, rZe, E$e, H0e, M0e, N0e, R0e, J$e, C$e, f0e, n0e, g0e, u1e, i0e, $$e, U1e, _1e, e2e, X2e, Y2e, Z2e, _2e, j2e, $2e, a3e, m2e, W2e, $1e, c3e, j3e, h3e, o3e, p3e, t3e, u3e, s3e, zff, v3e, B3e, C3e, D3e, Shf, L3e, M3e, O3e, T3e, Jif, U3e, V3e, $3e, W3e, a4e, X3e, Y3e, j4e, b4e, k4e, l4e, m4e, o4e, Q4e, R4e, S4e, $4e, a5e, b5e, j5e, k5e, l5e, D5e, E5e, F5e, G5e, H5e, I5e, J5e, K5e, L5e, M5e, N5e, Q5e, Z5e, T5e, _5e, U5e, $5e, V5e, W5e, a6e, x6e, y6e, g6e, z6e, A6e, C6e, J7e, R7e, E6e, w6e, L6e, Y6e, Z6e, a7e, e7e, f7e, D6e, M6e, Y7e, V7e, W7e, _7e, h8e, i8e, c8e, j6e, j8e, n8e, p8e, q8e, r8e, s8e, k8e, v8e, u8e, J9e, K9e, L9e, M9e, N9e, O9e, P9e, Q9e, R9e, S9e, T9e, U9e, V9e, W9e, X9e, Y9e, Z9e, _9e, $9e, aaf, baf, caf, daf, y8e, z8e, A8e, w9e, m6e, I9e, haf, iaf, jaf, eaf, gaf, e8e, maf, paf, naf, qaf, raf, x7e, vaf, yaf, saf, zaf, waf, Aaf, Baf, Caf, Daf, Eaf, Faf, Gaf, Haf, Iaf, Jaf, W6e, Laf, Maf, Raf, Kaf, Saf, Naf, Taf, Uaf, Vaf, Waf, Xaf, Yaf, Zaf, _af, $af, abf, bbf, xbf, ybf, cbf, zbf, dbf, ebf, Abf, fbf, Bbf, Cbf, Dbf, Ebf, Fbf, Gbf, Hbf, nbf, Ibf, Obf, bcf, jcf, zcf, Acf, ycf, qdf, rdf, sdf, tdf, udf, vdf, wdf, pdf, fef, gef, hef, ief, nef, qef, ref, Bef, Cef, o8e, Gef, Hef, Ief, Tef, Uef, Vef, Wef, Xef, off, pff, qff, nff, tff, uff, q3e, Aff, vff, wff, Hff, Kff, Qff, ogf, pgf, qgf, rgf, sgf, tgf, ugf, vgf, wgf, $ff, xgf, ygf, zgf, Agf, Bgf, Cgf, Dgf, Egf, Ggf, Jgf, Igf, Mgf, Ogf, _gf, lhf, mhf, nhf, ohf, phf, qhf, rhf, shf, thf, uhf, vhf, zhf, Ahf, Bhf, Chf, c4e, Thf, Uhf, Vhf, Whf, Xhf, Yhf, Zhf, Iff, cif, dif, eif, fif, hif, iif, jif, Aif, Bif, Cif, Dif, Eif, Fif, Gif, Q3e, kjf, Gjf, Ojf, Jjf, Qjf, Kjf, Ljf, Rjf, Pjf, gnf, akf, mkf, nkf, rkf, ykf, zkf, Skf, Tkf, Ukf, Vkf, Wkf, Zkf, Ykf, alf, dlf, elf, hlf, Mlf, glf, Nlf, ilf, jlf, Olf, Plf, Qlf, Rlf, Slf, Tlf, Ulf, Vlf, Wlf, Xlf, Ylf, Zlf, Dlf, amf, $lf, dmf, emf, okf, fmf, jmf, lmf, nmf, omf, rmf, smf, tmf, umf, ymf, Bmf, Cmf, Dmf, Lmf, Mmf, Nmf, Qmf, Rmf, Smf, _mf, inf, hnf, knf, lnf, rnf, snf, mnf, nnf, onf, pnf, tnf, unf, vnf, wnf, ynf, Dnf, Enf, Fnf, Gnf, Knf, Lnf, bof, Rnf, cof, Unf, dof, $nf, kof, lof, vof, xof, wpf, xpf, ypf, zpf, Apf, Bpf, Gpf, Hpf, lqf, Rqf, Sqf, Tqf, Uqf, Qqf, Vqf, xrf, yrf, zrf, wrf, asf, Esf, Fsf, Gsf, Dsf, htf, Ltf, Mtf, Ntf, Otf, Ktf, Ptf, Rtf, Qtf, Stf, Ttf, Auf, Lwf, Fuf, Mwf, Nwf, Owf, Jwf, Pwf, uxf, txf, ayf, $xf, Izf, Kzf, Lzf, Mzf, Nzf, Ozf, jyf, Pzf, Yyf, Qzf, Rzf, Szf, Tzf, Uzf, Vzf, Wzf, Xzf, Hzf, Yzf, uAf, NAf, OAf, PAf, QAf, RAf, SAf, TAf, UAf, VAf, WAf, XAf, MAf, YAf, sBf, bBf, tBf, uBf, vBf, rBf, IBf, EBf, RBf, SBf, RCf, SCf, TCf, UCf, WCf, XCf, YCf, ZCf, _Cf, $Cf, aDf, bDf, cDf, dDf, eDf, QCf, qDf, wDf, eFf, HDf, fFf, gFf, hFf, iFf, jFf, kFf, lFf, mFf, nFf, oFf, pFf, qFf, rFf, sFf, tFf, uFf, vFf, wFf, xFf, yFf, zFf, AFf, BFf, CFf, DFf, EFf, CEf, FFf, GFf, HFf, IFf, JFf, KFf, LFf, MFf, NFf, OFf, PFf, QFf, RFf, SFf, TFf, UFf, VFf, WFf, XFf, YFf, ZFf, _Ff, $Ff, aGf, bGf, cGf, dGf, eGf, dFf, fGf, gGf, hGf, iGf, jGf, kGf, vHf, wHf, xHf, yHf, uHf, AHf, BHf, CHf, DHf, EHf, FHf, WHf, XHf, cIf, aIf, hIf, gIf, iIf, jIf, kIf, lIf, mIf, nIf, oIf, rIf, sIf, qIf, tIf, uIf, vIf, tHf, wIf, xIf, yIf, jDf, zIf, BIf, CIf, EIf, kDf, FIf, HIf, JIf, IIf, LIf, MIf, SIf, TIf, WIf, ZIf, _If, aJf, bJf, eJf, hJf, nJf, oJf, rJf, sJf, OJf, PJf, QJf, uJf, RJf, VJf, ZJf, aKf, dKf, oLf, pLf, yLf, HLf, MLf, PLf, QLf, RLf, SLf, TLf, VLf, XLf, iNf, wNf, gMf, uMf, yMf, GMf, UMf, YMf, $Lf, $Mf, BNf, FNf, RNf, SNf, UNf, XNf, YNf, $Nf, eOf, vOf, wOf, fOf, sOf, EOf, FOf, HOf, KOf, OOf, POf, QOf, UOf, SOf, TOf, ePf, jPf, kPf, WPf, XPf, YPf, ZPf, _Pf, yPf, $Pf, IPf, aQf, RPf, SPf, VPf, bQf, cQf, dQf, eQf, fQf, gQf, hQf, lQf, pQf, uQf, vQf, wQf, xQf, zQf, AQf, BQf, CQf, DQf, OQf, YQf, ZQf, _Qf, aRf, uRf, vRf, zRf, SRf, TRf, CSf, DSf, $Rf, lSf, dSf, rSf, oSf, BSf, ESf, GSf, HSf, lTf, eTf, qTf, rTf, wTf, FSf, FTf, GTf, ITf, JTf, mUf, nUf, uUf, vUf, wUf, yUf, CUf, DUf, EUf, gVf, hVf, _Uf, UUf, mVf, pVf, dVf, rVf, zVf, DVf, EVf, ZVf, NVf, YVf, _Vf, $Vf, fWf, aWf, bWf, dWf, oWf, cWf, uWf, wWf, xWf, CWf, FWf, NWf, KWf, PWf, OWf, WWf, XWf, YWf, yWf, ZWf, _Wf, bXf, cXf, qXf, IWf, gXf, iXf, jXf, sXf, tXf, yXf, BXf, DXf, NXf, lYf, mYf, TYf, SYf, fZf, ZZf, _Zf, $Zf, a_f, b_f, YZf, B_f, A_f, C_f, D_f, H_f, E$f, F$f, V_f, G$f, H$f, I$f, D$f, K$f, W_f, M$f, Z$f, $$f, b0f, d0f, f0f, h0f, j0f, l0f, n0f, W$f, s0f, t0f, v0f, x0f, y0f, P0f, z0f, Q0f, T0f, U0f, V0f, _0f, $0f, W0f, a1f, Z0f, b1f, c1f, k1f, l1f, y1f, x1f, C1f, D1f, a2f, b2f, $1f, c2f, d2f, m2f, l2f, n2f, o2f, r2f, q2f, s2f, A2f, Z2f, g4f, B4f, P4f, S4f, T4f, U4f, W4f, Y4f, Z4f, _4f, S0f, $4f, a5f, c5f, e5f, f5f, h5f, j5f, k5f, l5f, m5f, q5f, n5f, s5f, o5f, p5f, t5f, u5f, v5f, w5f, x5f, y5f, A5f, C5f, D5f, G5f, H5f, I5f, Q5f, R5f, K5f, S5f, T5f, M5f, U5f, V5f, W5f, X5f, P5f, Z5f, $5f, a6f, b6f, c6f, d6f, e6f, f6f, g6f, h6f, i6f, j6f, k6f, l6f, m6f, n6f, o6f, p6f, q6f, r6f, s6f, t6f, u6f, w6f, J6f, K6f, Q6f, R6f, P6f, S6f, U6f, Z6f, Y6f, a7f, b7f, c7f, h7f, i7f, j7f, k7f, l7f, p7f, v7f, V6f, w7f, x7f, E7f, M7f, N7f, O7f, P7f, Q7f, R7f, S7f, T7f, U7f, X7f, V7f, F7f, d8f, t8f, u8f, v8f, w8f, x8f, y8f, E8f, F8f, D8f, M8f, N8f, P8f, X8f, Z8f, _8f, $8f, g9f, i9f, h9f, s9f, t9f, v9f, w9f, x9f, B9f, L9f, P9f, R9f, S9f, T9f, U9f, V9f, W9f, X9f, Y9f, Z9f, _9f, $9f, bag, dag, lag, kag, oag, pag, Aag, zag, Bag, Dag, Eag, Fag, Mag, Nag, Oag, Uag, Vag, Wag, _ag, Zag, dbg, ebg, hbg, ibg, Xag, mbg, nbg, Abg, Bbg, zbg, Kbg, Lbg, Mbg, Nbg, Obg, Ybg, fcg, rcg, scg, tcg, ucg, vcg, wcg, xcg, ycg, zcg, Qcg, Pcg, Rcg, Wcg, Xcg, Ycg, Zcg, adg, _cg, idg, ddg, ndg, Scg, tdg, ydg, zdg, Cdg, Adg, Mdg, Fdg, Ndg, Xdg, ceg, Feg, Geg, Heg, Aeg, Gbg, ofg, Cfg, Dfg, Efg, Beg, Gfg, Wfg, Xfg, Yfg, Vfg, ugg, tgg, Mgg, Lgg, Ngg, Vgg, Xgg, Zgg, $gg, bhg, ahg, dhg, ehg, shg, thg, fhg, uhg, vhg, mhg, whg, xhg, rhg, yhg, zhg, Ahg, Bhg, Chg, Dhg, Pgg, Ehg, Fhg, Tgg, Jhg, Khg, Lhg, Mhg, Shg, Ohg, Qhg, Rhg, Zhg, eig, fig, gig, hig, dig, iig, jig, nig, mig, oig, tig, Ucg, vig, _eg, yig, Aig, Big, Dig, Eig, Fig, Gig, Sig, Vig, Yig, Zig, ejg, fjg, Mmg, Nmg, Omg, Pmg, Qmg, Rmg, Smg, Tmg, Umg, Vmg, Wmg, Xmg, Ymg, Zmg, _mg, $mg, ang, bng, cng, dng, eng, fng, gng, hng, ing, jng, kng, lng, mng, nng, ong, png, qng, rng, sng, tng, ung, vng, wng, xng, yng, zng, Ang, Bng, Cng, Dng, Eng, Fng, Gng, Hng, Ing, Jng, Kng, Lng, Mng, Nng, Ong, Png, Qng, Rng, Sng, Tng, Ung, Vng, Wng, Xng, Yng, Zng, _ng, $ng, aog, bog, cog, dog, eog, fog, gog, hog, iog, jog, kog, log, mog, nog, oog, pog, qog, rog, sog, tog, uog, vog, wog, xog, yog, zog, Aog, Bog, Cog, Vog, dpg, vqg, xqg, Mqg, Qqg, Rqg, Sqg, Uqg, Vqg, Wqg, Xqg, _qg, brg, erg, mrg, irg, wrg, xrg, yrg, zrg, Crg, Drg, Erg, Frg, Irg, Krg, Org, esg, fsg, gsg, hsg, jsg, ksg, msg, nsg, rsg, tsg, usg, ssg, Gsg, Hsg, Isg, Jsg, Ksg, Lsg, Qsg, Tsg, Usg, Ysg, atg, ntg, otg, iug, jug, kug, lug, nug, oug, qug, rug, tug, uug, jwg, Aug, kvg, jvg, ovg, nwg, swg, twg, uwg, vwg, wwg, xwg, ywg, Awg, Bwg, Iwg, Hwg, Jwg, Kwg, Swg, Zwg, nrg, _wg, dxg, Ixg, Jxg, Kxg, Txg, Zxg, $xg, ayg, dyg, fyg, gyg, vyg, Byg, Hyg, Nyg, Tyg, Zyg, dzg, jzg, kzg, wsi, _Ai, dBi, gsi, iBi, nBi, jri, kri, hsi, isi, xsi, ysi, Ssi, Usi, Tsi, Vsi, gti, iti, hti, jti, vti, wti, asi, xti, lri, sBi, zti, Ati, Mxi, Eti, Fti, Jti, Kti, Yti, Zti, qui, rui, Fui, Gui, Sui, Tui, pvi, qvi, Ovi, Pvi, Svi, Tvi, Wvi, Xvi, fwi, gwi, qwi, rwi, Bwi, Cwi, Mwi, Nwi, Vwi, Wwi, $wi, axi, fxi, gxi, lxi, mxi, qxi, rxi, Axi, Bxi, cyi, dyi, wzi, vyi, Vyi, Wyi, Xyi, Yyi, yti, Lxi, Oxi, myi, Dyi, Lyi, Tyi, Uyi, DCi, ECi, KCi, LCi, NCi, OCi, QCi, RCi, SCi, VCi, WCi, YCi, $Ci, ZCi, _Ci, aDi, bDi, aq, bq, $N, AF, hO, nt, At, Bt, Kt, Cu, aD, fD, cv, _u, hv, gv, mv, ev, Xw, ax, ex, kz, nz, rz, tz, Az, Ez, Jz, Kz, Oz, Pz, Rz, _z, $z, aA, KA, LA, cB, aB, bB, KB, LB, NB, OB, XB, wC, yC, gC, AC, hC, YQ, Eza, gDa, kDa, bDa, iDa, x1b, v5b, I9b, B9b, C9b, J9b, mac, oac, Vac, pcc, cic, rjc, ekc, uwc, L8c, Qxd, $xd, ayd, xyd, Yyd, Zyd, azd, mzd, pzd, qzd, Bzd, Czd, Nzd, oAd, pAd, wAd, sBd, yBd, LBd, DCd, pFd, zPd, aYd, a0d, a9d, e9d, $9d, Vae, bce, $be, Ube, Ybe, pce, tce, Pce, Lee, jde, mde, Aee, See, cee, gfe, Tfe, Lfe, Qfe, lge, phe, uhe, Fhe, The, $he, eie, jie, oie, qie, Nie, Oie, cNi, dNi, eNi, fNi, gNi, hNi, iNi, jNi, kNi, lNi, mNi, nNi, oNi, pNi, qNi, rNi, sNi, tNi, qqe, rqe, sqe, uNi, vNi, wNi, xNi, Pwi, Nxi, TAi, BDi, yDi, yNi, zNi, ANi, BNi, CNi, DNi, ENi, FNi, GNi, HNi, INi, JNi, KNi, LNi, MNi, NNi, ONi, PNi, QNi, RNi, SNi, TNi, UNi, VNi, WNi, XNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi, bNi ];
 var lo = [ YNi, HKf, dLf, Lfg, egg, Ypg, YNi, YNi ];
 var mo = [ ZNi, osi, psi, cP, ssi, rP, wP, BP, q8a, t8a, u8a, y8a, F8a, G8a, L8a, N8a, Q8a, T8a, U8a, Y8a, d9a, e9a, hS, l9a, n9a, NS, QS, OS, VS, XS, R9a, S9a, T9a, U9a, V9a, W9a, X9a, Y9a, zT, DT, kab, _9a, YU, ZU, $U, aV, mab, jV, oV, kV, mV, uV, FV, KV, IV, oab, wW, AW, rab, sab, uab, vab, xab, Dab, Fab, Iab, Mab, Oab, MW, NW, OW, jbb, kX, lX, mX, nX, oX, dX, Lbb, Mbb, Zbb, xX, acb, KX, bcb, GY, RY, TY, QZ, OZ, PZ, NZ, LZ, tZ, xZ, AZ, EZ, $Y, dZ, hZ, oZ, jcb, MZ, qcb, scb, tcb, vcb, Bcb, Dcb, Gcb, Lcb, Ncb, r_, Bdb, Ddb, Edb, Gdb, Mdb, Odb, Rdb, Udb, Wdb, w0, Z0, K$, M$, E$, a1, b1, c1, R$, $$, d0, f0, q0, r0, s0, t0, j0, V$, V0, O$, d1, e1, O0, _0, k0, m0, peb, X0, Y0, h1, R0, qeb, ueb, xeb, Eeb, Ieb, Neb, Peb, Ueb, bfb, H1, R1, _1, k2, m2, P2, O2, V2, X2, jfb, lfb, mfb, ofb, ufb, wfb, zfb, Bfb, agb, f3, vgb, Dgb, Fgb, Ggb, Igb, Ogb, Qgb, Tgb, Vgb, uhb, Jhb, Rhb, I4, Thb, Vhb, _hb, aib, dib, J4, L4, s6, X4, O4, T4, $4, d5, l5, o5, h5, q5, s5, X5, _5, k6, mib, P6, Q6, T6, R6, S6, U6, M6, j7, k7, aba, Eib, Lib, Rib, Vib, Zib, bjb, fjb, mjb, qjb, ujb, yjb, Cjb, Gjb, Kjb, Ojb, Yjb, akb, Raa, lkb, qkb, ukb, jna, lna, nna, pna, rna, tna, vna, kna, mna, ona, qna, sna, una, wna, Bkb, Ckb, dma, Fkb, Gkb, blb, dlb, flb, hlb, jlb, mlb, nlb, xma, tlb, Alb, Ilb, Klb, Plb, Rlb, Slb, Tlb, Xlb, Zlb, _lb, $lb, dmb, gmb, hmb, ema, kmb, lmb, Imb, Kmb, Mmb, Omb, Qmb, Tmb, Umb, yma, _mb, fnb, nnb, pnb, unb, wnb, xnb, ynb, Cnb, Enb, Fnb, Gnb, Knb, Qnb, Snb, Ynb, _nb, Loa, Hoa, Joa, fob, gob, hob, kob, nob, qob, tob, wob, zob, bra, ora, pra, Aob, kra, lra, mra, nra, Cob, Gob, Hob, Iob, Job, Kob, Lob, Mob, Pob, Sob, Wob, _ob, cpb, gpb, kpb, opb, spb, xpb, Apb, Dpb, Hpb, Lpb, Ppb, Tpb, Xpb, $pb, dqb, hqb, oqb, sqb, wqb, Iqb, Lqb, Dva, wva, Oqb, Pva, Zva, cwa, Tqb, Xqb, $qb, drb, hrb, lrb, prb, srb, Qrb, Urb, Yrb, asb, esb, gsb, ksb, rsb, tsb, xsb, Esb, Gsb, Ksb, Rsb, Tsb, Xsb, etb, jtb, otb, ttb, wtb, Ctb, Itb, WHa, XHa, Ntb, Rtb, Stb, Ttb, Utb, Wtb, cRa, dub, fub, gub, hub, iub, wOa, uub, vub, yub, Nub, Oub, Rub, uvb, vvb, wvb, jKa, lKa, xvb, cKa, yvb, Zzb, $zb, aAb, bAb, cAb, oRa, GOb, HOb, IOb, JOb, KOb, LOb, MOb, SOb, lPb, JPb, KPb, LPb, NPb, MPb, _Pb, $Pb, uRb, wRb, WQb, yRb, zRb, URb, VSb, nSb, YSb, gSb, pSb, rSb, VUb, tUb, $Tb, vUb, YUb, GWb, qWb, pXb, SWb, gYb, a$b, g$b, h$b, i$b, K0b, V1b, q2b, n3b, i4b, j4b, m4b, n4b, p4b, r4b, s4b, S4b, P5b, Q8b, Fec, Bec, _dc, $gc, thc, iAc, Rcc, Yhc, Fhc, Ihc, $hc, jAc, Ucc, Hhc, Jhc, Gkc, klc, Elc, Glc, Oid, cpc, hpc, opc, vpc, wpc, noc, Dpc, Fpc, Gpc, Kpc, Upc, Vpc, Wpc, roc, pqc, qqc, Yqc, ztc, SDc, PEc, uuc, Juc, LEc, MEc, NEc, nEc, Kuc, Luc, Muc, xEc, Owc, iyc, Zyc, HGc, Szc, QBc, UBc, hCc, jCc, kCc, lCc, mCc, nCc, oCc, pCc, RBc, LCc, VCc, XCc, ZCc, $Cc, bDc, dDc, eDc, fDc, hDc, iDc, jDc, lDc, VDc, UEc, lFc, OFc, zFc, PFc, QFc, RFc, SFc, uFc, cHc, _Jc, cLc, iNc, ZMc, JOc, aOc, ROc, CRc, _Nc, cOc, dOc, WRc, PRc, ZRc, hSc, mSc, zSc, YSc, rUc, uUc, S9c, d9c, _9c, G9c, lad, qad, Fad, mbd, wbd, pcd, mcd, Xid, Yid, Lid, ejd, gjd, hjd, wkd, Ekd, Mld, Zld, omd, Qmd, Spd, eqd, Wpd, aqd, cqd, dqd, oqd, Ood, Lod, ADd, PDd, QDd, RDd, nEd, NEd, dGd, _Gd, lHd, pJd, JJd, FJd, gKd, XKd, VLd, nOd, QOd, CVd, aWd, lWd, nWd, pWd, bWd, mWd, oWd, qWd, e2d, A3d, B3d, w3d, Y3d, Z3d, _3d, b4d, c4d, f4d, g4d, f6d, hke, Qpe, Mpe, Cpe, Dpe, Epe, bre, jte, ire, jre, kre, lre, mre, ure, xse, Cse, hse, Tre, Ure, lse, mse, nse, Pse, Qse, Mre, mte, qte, Dwe, _xh, ayh, byh, dyh, fyh, gyh, iyh, kyh, lyh, nyh, pyh, qyh, syh, uyh, vyh, xyh, zyh, Ayh, Cyh, Eyh, Fyh, Hyh, Jyh, Kyh, Myh, Oyh, Pyh, Ywe, $we, Zwe, Ryh, Tyh, Uyh, Wyh, Yyh, Zyh, $yh, bzh, czh, ezh, gzh, hzh, jzh, lzh, mzh, bxe, exe, cxe, ozh, qzh, rzh, tzh, vzh, wzh, yzh, Azh, Bzh, Dzh, Fzh, Gzh, Izh, Kzh, Lzh, gxe, jxe, hxe, Nzh, Pzh, Qzh, Szh, Uzh, Vzh, Xzh, Zzh, _zh, aAh, cAh, dAh, fAh, hAh, iAh, kAh, mAh, nAh, pAh, rAh, sAh, uAh, wAh, xAh, Ixe, rxe, sxe, Exe, Gxe, Hxe, Vxe, uxe, vxe, $xe, bye, eye, gye, jye, hye, zAh, BAh, CAh, EAh, GAh, HAh, lye, oye, JAh, LAh, MAh, tye, xye, yye, zye, Cye, Dye, Hye, Jye, Mye, Oye, Iye, Nye, Eye, Yye, $ye, bze, eze, cze, OAh, QAh, RAh, jze, pze, vze, Bze, TAh, VAh, WAh, YAh, _Ah, $Ah, bBh, dBh, eBh, gBh, iBh, jBh, lBh, nBh, oBh, qBh, sBh, tBh, vBh, xBh, yBh, ABh, CBh, DBh, FBh, HBh, IBh, KBh, MBh, NBh, PBh, RBh, SBh, UBh, WBh, XBh, ZBh, $Bh, aCh, cCh, eCh, fCh, hCh, jCh, kCh, mCh, oCh, pCh, rCh, tCh, uCh, wCh, yCh, zCh, BCh, DCh, ECh, GCh, ICh, JCh, LCh, NCh, OCh, QCh, SCh, TCh, VCh, XCh, YCh, Eze, Hze, _Ch, aDh, bDh, dDh, fDh, gDh, iDh, kDh, lDh, Jze, Mze, Kze, Oze, Rze, Tze, Wze, Uze, Yze, $ze, Zze, bAe, eAe, cAe, nDh, pDh, qDh, gAe, jAe, hAe, sDh, uDh, vDh, xDh, zDh, ADh, CDh, EDh, FDh, HDh, JDh, KDh, lAe, oAe, mAe, MDh, ODh, PDh, qAe, tAe, rAe, vAe, yAe, wAe, AAe, DAe, BAe, FAe, IAe, GAe, KAe, NAe, LAe, PAe, SAe, QAe, UAe, XAe, VAe, ZAe, aBe, _Ae, cBe, fBe, dBe, hBe, kBe, iBe, RDh, TDh, UDh, WDh, YDh, ZDh, $Dh, bEh, cEh, eEh, gEh, hEh, jEh, lEh, mEh, oEh, qEh, rEh, tEh, vEh, wEh, yEh, AEh, BEh, DEh, FEh, GEh, IEh, KEh, LEh, NEh, PEh, QEh, SEh, UEh, VEh, XEh, ZEh, _Eh, aFh, cFh, dFh, fFh, hFh, iFh, kFh, mFh, nFh, pFh, rFh, sFh, uFh, wFh, xFh, zFh, BFh, CFh, mBe, pBe, nBe, EFh, GFh, HFh, JFh, LFh, MFh, OFh, QFh, RFh, TFh, VFh, WFh, rBe, uBe, sBe, wBe, zBe, xBe, BBe, EBe, CBe, GBe, JBe, HBe, LBe, OBe, MBe, QBe, TBe, RBe, VBe, YBe, WBe, _Be, bCe, $Be, dCe, gCe, eCe, iCe, lCe, jCe, nCe, qCe, oCe, YFh, _Fh, $Fh, bGh, dGh, eGh, sCe, vCe, tCe, gGh, iGh, jGh, lGh, nGh, oGh, xCe, ACe, yCe, qGh, sGh, tGh, CCe, FCe, DCe, HCe, KCe, ICe, vGh, xGh, yGh, AGh, CGh, DGh, MCe, PCe, NCe, FGh, HGh, IGh, RCe, UCe, SCe, KGh, MGh, NGh, PGh, RGh, SGh, UGh, WGh, XGh, ZGh, $Gh, aHh, cHh, eHh, fHh, WCe, ZCe, XCe, hHh, jHh, kHh, mHh, oHh, pHh, rHh, tHh, uHh, wHh, yHh, zHh, $Ce, cDe, aDe, BHh, DHh, EHh, eDe, hDe, fDe, jDe, mDe, kDe, oDe, rDe, pDe, tDe, wDe, uDe, yDe, BDe, zDe, DDe, GDe, EDe, GHh, IHh, JHh, LHh, NHh, OHh, QHh, SHh, THh, IDe, LDe, JDe, NDe, QDe, ODe, SDe, VDe, TDe, aEe, kEe, oEe, rEe, pEe, tEe, wEe, uEe, DEe, NEe, REe, SEe, VEe, WEe, YEe, $Ee, ZEe, VHh, XHh, YHh, gFe, qFe, uFe, xFe, vFe, _Hh, aIh, bIh, dIh, fIh, gIh, zFe, CFe, AFe, iIh, kIh, lIh, JFe, TFe, XFe, _Fe, YFe, eGe, gGe, hGe, iGe, oGe, nIh, pIh, qIh, sIh, uIh, vIh, xIh, zIh, AIh, CIh, EIh, FIh, HIh, JIh, KIh, MIh, OIh, PIh, UIh, Trh, eJh, hJh, iJh, kJh, nJh, oJh, sJh, uJh, AJh, BJh, PJh, QJh, SJh, YJh, _Jh, eKh, fKh, tKh, uKh, wKh, AKh, CKh, DKh, IKh, mHe, pHe, nHe, NKh, PKh, QKh, SKh, UKh, VKh, bLh, cLh, fLh, gLh, hLh, iLh, tLh, ELh, FLh, ILh, JLh, KLh, LLh, WLh, _Lh, aMh, cMh, $He, cIe, iMh, kMh, lMh, mMh, oMh, pMh, rMh, tMh, vMh, wMh, xMh, yMh, zMh, IMh, KMh, LMh, MMh, NMh, PMh, RMh, JIe, MIe, XMh, ZMh, _Mh, $Mh, bNh, cNh, eNh, gNh, iNh, jNh, kNh, lNh, mNh, vNh, xNh, yNh, zNh, ash, LNh, YIe, $Ie, ZIe, AJe, hJe, iJe, vJe, xJe, yJe, NJe, kJe, lJe, TJe, VJe, YJe, bKe, fKe, gKe, hKe, kKe, lKe, pKe, rKe, uKe, wKe, qKe, vKe, mKe, IKe, KKe, LKe, MKe, OKe, RKe, PKe, TKe, WKe, UKe, YKe, $Ke, ZKe, QNh, SNh, TNh, VNh, XNh, YNh, _Nh, aOh, bOh, dOh, fOh, gOh, iOh, kOh, lOh, nOh, pOh, qOh, sOh, uOh, vOh, xOh, zOh, AOh, COh, EOh, FOh, HOh, JOh, KOh, bLe, eLe, cLe, MOh, OOh, POh, gLe, jLe, hLe, ROh, TOh, UOh, WOh, YOh, ZOh, lLe, oLe, $Oh, bPh, cPh, ePh, gPh, hPh, qLe, tLe, rLe, vLe, yLe, jPh, lPh, mPh, oPh, qPh, rPh, ALe, DLe, BLe, FLe, ILe, GLe, KLe, NLe, LLe, tPh, vPh, wPh, QLe, TLe, XLe, _Le, fMe, gMe, wMe, lMe, xMe, AMe, DMe, KMe, OMe, RMe, VMe, YMe, dNe, eNe, uNe, jNe, vNe, yNe, BNe, INe, MNe, PNe, TNe, WNe, bOe, cOe, sOe, hOe, tOe, wOe, zOe, GOe, GPh, IPh, JPh, LPh, NPh, OPh, QPh, SPh, TPh, VPh, XPh, YPh, _Ph, aQh, bQh, dQh, fQh, gQh, hQh, jQh, lQh, nQh, oQh, pQh, rQh, tQh, vQh, wQh, yQh, AQh, BQh, FQh, HQh, NQh, OQh, aRh, bRh, dRh, hRh, kRh, lRh, qRh, vRh, xRh, yRh, VOe, YOe, WOe, ARh, CRh, DRh, FRh, HRh, IRh, _Oe, bPe, $Oe, dPe, gPe, ePe, iPe, lPe, jPe, nPe, qPe, sPe, vPe, tPe, KRh, MRh, NRh, PRh, RRh, SRh, URh, WRh, XRh, ZRh, $Rh, aSh, cSh, eSh, fSh, hSh, jSh, kSh, WPe, DPe, EPe, RPe, TPe, UPe, iQe, GPe, HPe, oQe, qQe, tQe, mSh, oSh, pSh, vQe, yQe, wQe, DQe, HQe, IQe, JQe, MQe, NQe, RQe, TQe, WQe, YQe, SQe, XQe, OQe, iRe, kRe, lRe, mRe, Fsh, eQe, vRe, yRe, wRe, ASh, CSh, ISh, JSh, XSh, YSh, _Sh, cTh, eTh, fTh, hTh, kTh, lTh, qTh, xTh, zTh, FTh, GTh, UTh, VTh, XTh, $Th, bUh, cUh, eUh, hUh, iUh, nUh, sUh, uUh, vUh, xUh, zUh, AUh, CUh, EUh, FUh, HUh, JUh, KUh, CRe, FRe, DRe, MUh, OUh, PUh, RUh, TUh, UUh, WUh, YUh, ZUh, HRe, KRe, IRe, $Uh, bVh, cVh, MRe, PRe, NRe, RRe, URe, SRe, WRe, ZRe, XRe, $Re, cSe, aSe, eVh, gVh, hVh, jVh, lVh, mVh, eSe, hSe, fSe, ISe, pSe, qSe, DSe, FSe, GSe, VSe, sSe, tSe, $Se, bTe, eTe, gTe, jTe, hTe, oVh, qVh, rVh, tVh, vVh, wVh, oTe, sTe, tTe, uTe, xTe, yTe, CTe, ETe, HTe, JTe, DTe, ITe, zTe, VTe, XTe, YTe, ZTe, dUe, hUe, kUe, mUe, pUe, nUe, rUe, uUe, sUe, wUe, zUe, xUe, BUe, EUe, CUe, GUe, JUe, HUe, LUe, OUe, MUe, QUe, TUe, VUe, YUe, WUe, yVh, AVh, BVh, DVh, FVh, GVh, _Ue, bVe, $Ue, dVe, gVe, eVe, iVe, lVe, jVe, IVh, KVh, LVh, NVh, PVh, QVh, SVh, UVh, VVh, XVh, ZVh, _Vh, nVe, qVe, oVe, aWh, cWh, dWh, fWh, hWh, iWh, sVe, vVe, tVe, kWh, mWh, nWh, pWh, rWh, sWh, uWh, wWh, xWh, xVe, AVe, yVe, zWh, BWh, CWh, EWh, GWh, HWh, CVe, FVe, DVe, JWh, LWh, MWh, OWh, QWh, RWh, HVe, KVe, IVe, TWh, VWh, WWh, YWh, _Wh, $Wh, MVe, PVe, bXh, dXh, eXh, gXh, iXh, jXh, fWe, aWe, _Ve, $Ve, dWe, kWe, mWe, nWe, pWe, qWe, vWe, AWe, sWe, wWe, UWe, DWe, FWe, JWe, KWe, LWe, RWe, PWe, SWe, aXe, cXe, kXe, jXe, zXe, wYe, cYe, dYe, eYe, fYe, kYe, aYe, bYe, tYe, uYe, vYe, zYe, CXe, GYe, IYe, JYe, MYe, PYe, WYe, FXe, XYe, _Ye, wZe, mZe, AZe, CZe, GZe, LZe, MZe, OZe, QZe, VZe, YZe, $Ze, G_e, I_e, J_e, P_e, Q_e, R_e, S_e, c$e, d$e, q$e, r$e, t$e, w0e, Q$e, l0e, O0e, S0e, U0e, I$e, H$e, o0e, j1e, n1e, o1e, p1e, X$e, Z$e, B1e, y1e, x1e, z1e, C1e, J1e, M1e, O1e, P1e, S1e, X1e, Z0e, d1e, Z1e, c1e, t1e, f1e, e1e, _0e, a1e, Y0e, l2e, o2e, p2e, q2e, y2e, H2e, z2e, S2e, V2e, r3e, w3e, y3e, E3e, N3e, n4e, x4e, z4e, B4e, D4e, F4e, T4e, V4e, X4e, Z4e, _4e, e5e, g5e, v5e, x5e, B5e, n6e, V6e, b7e, c7e, s7e, y7e, U7e, l6e, g8e, B8e, F8e, H8e, J8e, L8e, N8e, P8e, R8e, T8e, V8e, X8e, Z8e, $8e, b9e, d9e, f9e, h9e, j9e, l9e, n9e, p9e, r9e, t9e, u9e, H9e, laf, B7e, D7e, F7e, H7e, L7e, S7e, xaf, t7e, z9e, d7e, K7e, o7e, q7e, $6e, Qaf, s6e, ibf, jbf, kbf, lbf, r6e, obf, pbf, qbf, ubf, Kbf, rbf, Qbf, Sbf, dcf, ecf, lcf, rcf, vcf, Dcf, Fcf, Lcf, Wcf, hdf, ydf, bef, gcf, jef, pef, Eef, gff, Tff, Vff, Yff, Zff, _ff, bgf, egf, fgf, Rgf, Tgf, Ugf, Wgf, fhf, jhf, ghf, E9e, Ihf, Lhf, Mhf, Ohf, _hf, $hf, lif, nif, oif, zif, ljf, njf, rjf, tjf, vjf, zjf, Bjf, Cjf, Djf, Ujf, Vjf, Wjf, Zjf, $jf, dkf, ekf, fkf, hkf, ikf, jkf, skf, ukf, Akf, Bkf, Ckf, Dkf, Ekf, Fkf, Gkf, Hkf, clf, olf, rlf, slf, tlf, wlf, xlf, Alf, Blf, Jlf, Klf, Llf, Fmf, dnf, qnf, Anf, Cnf, Jnf, hHf, Vnf, Xnf, Ynf, Znf, iof, jof, oof, Rof, Yof, spf, Epf, Fpf, Zpf, hqf, Dqf, Mqf, lrf, srf, Rrf, Yrf, ssf, zsf, Ysf, dtf, ztf, Gtf, muf, xuf, Wuf, Xuf, $uf, jvf, Vvf, Xvf, Yvf, Vof, swf, twf, kxf, pxf, Qxf, Yxf, Dyf, Myf, czf, qAf, sAf, AAf, CAf, zAf, DAf, eBf, fBf, gBf, hBf, iBf, _Af, LBf, ABf, CBf, JBf, KBf, BBf, MBf, wGf, hCf, kCf, UBf, FCf, LCf, MCf, gDf, iDf, jHf, EDf, FDf, GDf, PCf, KDf, sDf, LDf, RDf, SDf, TDf, UDf, VDf, uEf, oGf, yGf, DGf, dHf, eHf, cHf, GGf, VGf, kHf, iHf, pGf, qGf, rGf, sGf, tGf, uGf, vGf, xGf, zGf, AGf, BGf, CGf, EGf, FGf, kEf, lHf, mHf, nHf, qHf, rHf, sHf, zHf, VHf, HHf, PHf, NHf, MHf, IHf, LHf, RHf, SHf, UHf, YHf, $Hf, OGf, fIf, GIf, VIf, YIf, bvf, dJf, gJf, aSf, eSf, cSf, bSf, jLf, kLf, mLf, nLf, zKf, sLf, zLf, ILf, JLf, KLf, LLf, cNf, YLf, ZLf, dNf, eNf, uNf, yNf, cMf, dMf, eMf, sMf, wMf, CMf, DMf, EMf, SMf, WMf, JNf, DNf, ENf, NNf, ONf, QNf, jSf, VNf, cOf, iOf, qOf, rOf, hOf, uOf, MOf, NOf, VOf, XOf, YOf, ZOf, APf, BPf, $Of, aPf, dPf, fPf, gPf, iPf, LPf, zPf, CPf, jQf, kQf, nQf, oQf, rQf, sQf, HQf, GQf, IQf, JQf, KQf, LQf, MQf, NQf, VQf, XQf, $Qf, rRf, GRf, RRf, HRf, kSf, mSf, pSf, kUf, MSf, eKf, sRf, hSf, iSf, tSf, KSf, RSf, SSf, TSf, USf, VSf, WSf, XSf, YSf, ZSf, _Sf, $Sf, aTf, bTf, cTf, dTf, JSf, ySf, fTf, gTf, hTf, iTf, jTf, kTf, vTf, yTf, KTf, LTf, MTf, NTf, OTf, PTf, QTf, RTf, xSf, TTf, UTf, VTf, WTf, XTf, YTf, ZTf, _Tf, $Tf, aUf, bUf, cUf, dUf, eUf, fUf, gUf, hUf, iUf, bOf, pUf, qUf, zUf, SUf, RUf, wVf, QUf, TUf, XUf, sVf, tVf, uVf, xVf, GVf, HVf, IVf, JVf, KVf, LVf, MVf, OVf, pWf, qWf, rWf, sWf, tWf, nWf, kWf, lWf, IXf, JXf, R_f, Q_f, QXf, RXf, SXf, TXf, XXf, aYf, bYf, cYf, dYf, eYf, iYf, jYf, VXf, _Xf, WXf, J_f, K_f, L_f, M_f, P_f, S_f, T_f, s$f, b$f, d$f, nYf, oYf, pYf, qYf, rYf, sYf, tYf, uYf, vYf, wYf, xYf, yYf, DYf, FYf, KYf, MYf, NYf, OYf, PYf, QYf, JYf, UYf, VYf, WYf, XYf, bZf, dZf, ZYf, eZf, DZf, h_f, LZf, iZf, mZf, qZf, tZf, uZf, vZf, wZf, xZf, zZf, AZf, BZf, CZf, EZf, IZf, JZf, KZf, MZf, NZf, OZf, PZf, QZf, RZf, SZf, TZf, hZf, UZf, WZf, c_f, d_f, f_f, g_f, i_f, j_f, k_f, l_f, m_f, n_f, s_f, u_f, e_f, w_f, x_f, y_f, z_f, E_f, F_f, G_f, O$f, J1f, Q1f, B$f, I_f, N_f, k$f, m$f, n$f, o$f, p$f, q$f, O_f, UXf, j$f, t$f, x$f, y$f, z$f, A$f, C$f, J$f, X$f, N$f, KXf, Y$f, o0f, p0f, q0f, K4f, E4f, Z1f, X_f, X0f, i1f, j1f, p1f, v1f, t1f, m1f, n1f, o1f, u1f, w1f, K1f, L1f, M1f, N1f, O1f, P1f, R1f, S1f, T1f, U1f, V1f, W1f, X1f, Y1f, _1f, e2f, f2f, h2f, i2f, j2f, k2f, kYf, t2f, x2f, H2f, G2f, I2f, D2f, F2f, R2f, P2f, _2f, Q2f, N2f, V2f, c3f, d3f, Q3f, q3f, C3f, P3f, N3f, s3f, z3f, O3f, A3f, J3f, B3f, p3f, r3f, x3f, y3f, H3f, S3f, _3f, $3f, Y3f, Z3f, d4f, R3f, W3f, X3f, o4f, r4f, p4f, z4f, n4f, q4f, t4f, L4f, F4f, C4f, G4f, H4f, I4f, D4f, J4f, O4f, V4f, L5f, v6f, z6f, M6f, T6f, d7f, e7f, f7f, m7f, o7f, q7f, s7f, B7f, D7f, G7f, I7f, c8f, g8f, Y7f, Z7f, _7f, $7f, a8f, b8f, e8f, f8f, h8f, r8f, L8f, J8f, k9f, O8f, R8f, S8f, T8f, U8f, b9f, c9f, m9f, f9f, u9f, $6f, E9f, W8f, V8f, Q9f, nag, tag, wag, xag, Cag, $ag, jbg, uag, pbg, qbg, rbg, sbg, tbg, ubg, xbg, ybg, dfg, Dbg, Ubg, Vbg, dcg, gcg, hcg, icg, jcg, kcg, lcg, ncg, Ncg, Vcg, $cg, cdg, edg, hdg, kdg, ldg, mdg, odg, pdg, sdg, udg, xdg, Bdg, Edg, Gdg, Ldg, Pdg, Qdg, Rdg, Sdg, Tdg, Wdg, Ydg, aeg, Jcg, Fcg, Ocg, teg, ueg, jeg, peg, ieg, qeg, keg, leg, zeg, oeg, meg, neg, Xeg, Yeg, xfg, yfg, Afg, Hfg, Tfg, ogg, pgg, rgg, Hgg, Igg, Kgg, Ghg, Sgg, ghg, ihg, jhg, khg, nhg, ohg, phg, qhg, _hg, hhg, $hg, big, cig, lig, qig, rig, wig, Iig, Hig, Wig, Uig, Xig, cjg, Tog, wpg, xpg, ypg, zpg, Apg, Bpg, Cpg, Xog, Gpg, Hpg, Spg, mqg, Dqg, Eqg, iqg, krg, org, prg, qrg, rrg, vrg, Wrg, bsg, Osg, Psg, Xsg, _sg, $sg, Etg, Ftg, Gtg, Rtg, Ztg, fug, dug, Ltg, qtg, rtg, xtg, Dtg, Htg, Mtg, Ntg, Otg, Qtg, Vtg, Wtg, Xtg, Ytg, _tg, $tg, cug, eug, gug, Kug, Mug, bvg, cvg, dvg, evg, fvg, Vug, nvg, Zvg, lwg, uyg, pwg, rwg, Dwg, Gwg, Nwg, Owg, exg, fxg, gxg, hxg, ixg, jxg, uxg, wxg, xxg, zxg, Mxg, byg, tyg, nzg, wXh, BXh, KXh, TXh, aYh, jYh, sYh, tYh, uYh, DYh, EYh, FYh, OYh, SSg, XYh, eZh, nZh, wZh, FZh, $Sg, OZh, XZh, e_h, n_h, w_h, iTg, F_h, O_h, X_h, e$h, n$h, w$h, F$h, O$h, rTg, ATg, X$h, e0h, JTg, n0h, VTg, w0h, F0h, O0h, X0h, e1h, n1h, z1h, jUg, L1h, U1h, sUg, HUg, WUg, dVg, tVg, CVg, LVg, d2h, m2h, v2h, E2h, N2h, W2h, d3h, m3h, v3h, E3h, UVg, N3h, bWg, W3h, d4h, kWg, m4h, v4h, tWg, CWg, E4h, N4h, LWg, UWg, bXg, W4h, kXg, wXg, IXg, d5h, m5h, v5h, E5h, N5h, Z5h, UXg, g6h, p6h, bYg, kYg, tYg, CYg, q6h, LYg, z6h, I6h, R6h, _6h, h7h, q7h, UYg, z7h, bZg, rZg, I7h, U7h, e8h, n8h, w8h, F8h, AZg, O8h, X8h, e9h, JZg, n9h, SZg, $Zg, i_g, r_g, w9h, F9h, A_g, J_g, S_g, O9h, X9h, g$g, p$g, y$g, H$g, Q$g, Z$g, g0g, p0g, y0g, eai, nai, H0g, Q0g, Z0g, wai, Fai, Oai, Xai, g1g, ebi, nbi, p1g, wbi, Fbi, Obi, y1g, Xbi, eci, H1g, nci, wci, Q1g, Fci, Oci, Z1g, Xci, edi, g2g, ndi, wdi, Fdi, Odi, Xdi, eei, nei, wei, Fei, Oei, Xei, efi, nfi, wfi, Ffi, Ofi, Xfi, egi, ngi, wgi, Fgi, Ogi, Xgi, ehi, x2g, nhi, whi, Fhi, G2g, V2g, c3g, l3g, u3g, Uhi, D3g, bii, kii, tii, Cii, M3g, Lii, V3g, c4g, l4g, u4g, D4g, M4g, V4g, c5g, l5g, u5g, Uii, bji, kji, tji, Cji, Lji, Uji, bki, kki, tki, Cki, Lki, Uki, bli, kli, tli, Cli, Lli, Uli, D5g, bmi, kmi, tmi, Cmi, N5g, W5g, d6g, m6g, v6g, E6g, N6g, W6g, d7g, m7g, v7g, Nmi, Wmi, E7g, dni, mni, N7g, vni, W7g, d8g, Eni, Nni, m8g, Wni, v8g, doi, moi, voi, Eoi, Noi, E8g, Woi, dpi, mpi, vpi, N8g, Epi, W8g, d9g, m9g, v9g, E9g, N9g, Npi, Wpi, dqi, W9g, dah, mah, vah, Eah, Nah, mqi, Wah, vqi, Eqi, dbh, Nqi, mbh, aBi, Fsi, Hsi, Isi, Esi, fBi, gBi, kBi, rsi, pBi, qBi, PCi, rti, Uui, izi, kzi, mzi, szi, uzi, ozi, qzi, rvi, jzi, lzi, nzi, tzi, vzi, pzi, rzi, Yvi, Zvi, cwi, hwi, iwi, nwi, swi, twi, ywi, Dwi, Ewi, Jwi, zyi, Ayi, Cyi, Zyi, $yi, _yi, azi, qyi, ryi, tyi, Hyi, Iyi, Kyi, Pyi, Qyi, Syi, FCi, MCi, XCi, qq, vN, QH, gt, ht, lt, kt, jt, it, mt, pt, ut, vt, yt, Jt, Ct, Dt, Et, Pt, Rt, Wt, au, fu, eu, iu, hu, ZC, gD, lD, oD, pD, AD, xD, yD, Gu, Iu, Eu, Qu, Wu, nv, fv, lv, bx, kx, ux, Sx, Iv, Kv, Lv, Sv, kw, Nv, Ov, Pv, Qv, Rv, Mv, Vv, Zv, _v, bw, cw, dw, ew, QD, nw, mw, ow, pw, gy, Ux, hy, Vx, ry, qy, my, ay, ly, ny, fy, py, Dz, Cz, Hz, uy, wy, zy, Dy, Fy, By, Cy, Ey, Ay, Py, Sy, Uy, Vy, Wy, Xy, az, Yy, Zy, _y, cz, fz, iz, Nz, Qz, Sz, Tz, Vz, Wz, Xz, dA, fA, gA, hA, iA, bA, kA, jA, mA, wA, vA, xA, yA, AA, zA, TA, WA, RA, qw, eB, gB, jB, hB, kB, lB, mB, nB, YA, XA, sw, uw, vw, rB, CB, DB, AB, BB, JB, MB, SB, UB, VB, vC, lC, nC, eC, pC, rC, aC, BC, CC, DC, EC, HC, xw, yw, Ow, Pw, zw, Aw, Bw, Cw, Ew, Lw, Mw, Rw, GVa, HVa, p3a, F3a, DFa, R3a, T3a, R4a, WFa, ZFa, aGa, dGa, gGa, jGa, mGa, pGa, sGa, AGa, DGa, FGa, LGa, OGa, QGa, SGa, UGa, WGa, _Ga, X4a, Z4a, $4a, b5a, d5a, HGa, IGa, JGa, sHa, tHa, wHa, xHa, CHa, FHa, IHa, LHa, NHa, x5a, uQ, ZFc, dIc, Pxd, Yxd, Zxd, byd, cyd, uyd, vyd, yyd, Ayd, Hyd, gzd, nzd, rzd, tzd, vzd, xzd, zzd, Azd, Dzd, Jzd, Lzd, qAd, sAd, tAd, uAd, vAd, LAd, eBd, fBd, gBd, EBd, GBd, IBd, JBd, KBd, MBd, QBd, BCd, CCd, JCd, LCd, RCd, SCd, bDd, EKd, FKd, GKd, DNd, ENd, i0d, tbe, ube, ace, Vbe, Zbe, hce, ice, jce, kce, Cce, Gce, Hce, ede, rfe, Sfe, Pfe, Ufe, Gge, ige, jge, kge, Phe, Qhe, Rhe, She, tie, Mie, Rie, Tie, Uie, Wie, Xie, Zie, _ie, _Ni, $Ni, aOi, bOi, cOi, dOi, eOi, fOi, gOi, hOi, iOi, jOi, kOi, lOi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi, ZNi ];
 var no = [ mOi, uef ];
 var oo = [ nOi, NV, Jbb, kff, xPf, nOi, nOi, nOi ];
 var po = [ oOi, xMa, zMa, yMa, wMa, AMa, BMa, CMa ];
 var qo = [ pOi, u1 ];
 var ro = [ qOi, MV, Doa, Eoa, Jvg, zvg, qOi, qOi ];
 var so = [ rOi, Bva, $bf, icf, Jcf, bff, fff, jff, t5a, rOi, rOi, rOi, rOi, rOi, rOi, rOi ];
 var to = [ sOi, DS, ES, sOi ];
 var uo = [ tOi, Pwa ];
 var vo = [ uOi, Kza ];
 var wo = [ vOi, kgf, mgf, yvg, RBd, SBd, vOi, vOi ];
 var xo = [ wOi, lsi, qsi, usi, q9a, v9a, K9a, CT, gab, EV, GV, PW, Nbb, Rbb, Vbb, iZ, FZ, jZ, kZ, J$, D0, M0, o0, $1, Q2, S2, ffb, V6, W6, X6, Y6, Z6, _6, Ina, Kna, Jna, Lna, dra, Eob, Frb, hBa, _Ba, lsb, ysb, Lsb, Ysb, $Ha, aIa, dIa, eIa, lOa, sub, Tub, MJa, Jvb, Rwb, Xwb, bxb, hxb, Ryb, Vyb, Wyb, bzb, czb, izb, jzb, pzb, qzb, uRa, oAb, rAb, uAb, UOb, fPb, sPb, DPb, VPb, Hlc, Snc, Lpc, cqc, wEc, iCc, tFc, FQc, n9c, lcd, Aed, zed, Yhd, ppd, wpd, Apd, Dpd, Epd, Fpd, Rod, Hpd, bqd, Pqd, Pod, Wqd, Xqd, Vqd, $qd, _qd, Mod, SGd, WGd, KId, IId, JId, dJd, qNd, TUd, GWd, pzg, hCg, DMg, gQg, XNg, tHg, qzg, wzg, NHg, _Kg, xIg, $Kg, rCg, wIg, Ozg, vCg, ZCg, zJg, oFg, oAg, pFg, pAg, qFg, zMg, GMg, AJg, Uxe, WJg, CEg, PEg, Oxe, UMg, LLg, jJg, FBg, GBg, BHg, lKg, CHg, qAg, ADg, bEg, rFg, XJg, sFg, HBg, Rzg, yMg, Rye, yQg, _Ig, BDg, cEg, tFg, YJg, uFg, dFg, TDg, gCg, aFg, nHg, WHg, vKg, aIg, LJg, ize, SMg, kze, DJg, oze, qze, wJg, uze, wze, iKg, Aze, TAg, KDg, kEg, nGg, eKg, oGg, UAg, fFg, VAg, LDg, lEg, pGg, fKg, qGg, WAg, rGg, XAg, sGg, YAg, tGg, ZAg, uGg, _Ag, vGg, $Ag, wGg, aBg, xGg, bBg, yGg, cBg, zGg, dBg, AGg, eBg, BGg, fBg, CGg, gBg, DGg, hBg, EGg, iBg, FGg, jBg, GGg, kBg, HGg, cAg, IGg, hAg, JGg, gAg, KGg, _zg, LGg, fAg, MGg, dAg, NGg, lBg, OGg, jAg, PGg, iAg, QGg, Zzg, RGg, mBg, SGg, nBg, TGg, oBg, UGg, pBg, VGg, qBg, WGg, rBg, XGg, sBg, YGg, tBg, kCg, nCg, LCg, sJg, ZGg, uBg, _Gg, vBg, $Gg, wBg, aHg, xBg, bHg, yBg, cHg, zBg, dHg, ABg, eHg, BBg, fHg, CBg, gHg, gFg, ZDg, YDe, qLg, $De, bEe, fEe, SKg, jEe, JMg, mEe, DBg, hHg, lAg, iHg, lFg, _Dg, zEe, tLg, CEe, EEe, IEe, YKg, MEe, PEe, MDg, bAg, VEg, kAg, hFg, mFg, $Dg, cFe, uLg, fFe, hFe, lFe, ZKg, pFe, sFe, EBg, jHg, mAg, kHg, nFg, aEg, FFe, sLg, IFe, KFe, OFe, UKg, SFe, VFe, Yzg, lHg, aJg, nGe, qGe, TIh, YIh, $Ih, cJh, IBg, JBg, HKh, LKh, rAg, vFg, YKh, $Lg, DEg, QEg, kNg, nLh, nNg, KBg, hNg, zLh, aMg, EEg, REg, lNg, QLh, LBg, MBg, DHg, mKg, EHg, NBg, EMh, BQg, bJg, OBg, FHg, nKg, GHg, PBg, rNh, cJg, DNh, GNh, KNh, ONh, sAg, wFg, AMg, HMg, MJe, NLg, FEg, SEg, GJe, xLg, QBg, RBg, HHg, oKg, IHg, SBg, zKe, zQg, dJg, Gzg, xFg, Dzg, yFg, Fzg, zFg, fCg, THg, tAg, AFg, Azg, GCg, NCg, nEg, EJg, mEg, uAg, BFg, vAg, CDg, dEg, CFg, ZJg, DFg, wAg, EFg, xAg, FFg, yAg, GFg, hPg, HFg, _Jg, IFg, DDg, eEg, zAg, TBg, VKg, JMe, MMe, JFg, $Jg, KFg, EDg, fEg, AAg, UBg, WKg, HNe, KNe, LFg, aKg, MFg, FDg, gEg, BAg, VBg, XKg, FOe, IOe, WBg, XBg, YBg, pRh, tRh, CAg, GDg, hEg, NFg, bKg, OFg, Lzg, PFg, Czg, QFg, DAg, RFg, EAg, HDg, QDg, SFg, VJg, TFg, rzg, lCg, pCg, MCg, vJg, zCg, IMg, hQe, bMg, GEg, TEg, aQe, BMg, $Ig, ZBg, FAg, _Bg, JHg, pKg, KHg, UFg, $Bg, $Qe, eJg, tSh, wSh, rRe, tRe, GAg, VFg, aCg, pTh, tTh, bCg, mUh, qUh, HAg, WFg, Szg, XFg, IAg, YFg, JAg, ZFg, Tzg, _Fg, vzg, VCg, KAg, $Fg, sKg, iMg, CMg, lJg, USe, cMg, HEg, UEg, OSe, zKg, jCg, cCg, iCg, dCg, LHg, qKg, MHg, ECg, oJg, eCg, MTe, xQg, fJg, cUe, fUe, LAg, IDg, iEg, aGg, cKg, bGg, MAg, cGg, Uzg, dGg, NAg, oCg, uCg, YCg, yJg, eGg, OAg, fGg, Xzg, gGg, Wzg, hGg, PAg, JDg, jEg, iGg, dKg, jGg, tzg, ICg, QAg, kGg, RAg, lGg, SAg, mGg, yzg, yCg, DCg, uDg, CJg, vDg, xzg, mDg, zzg, YDg, szg, FCg, uzg, PCg, Bzg, OCg, SCg, qEg, KJg, vEg, TOg, tWe, dNg, mQg, cLg, CCg, XXe, MLg, gYe, zIg, nPg, KNg, qYe, rYe, $Xe, OLg, HCg, UHg, pZe, TMg, vZe, rOg, nZe, OIg, jPg, pNg, CQg, GQg, ANg, rPg, qNg, uNg, FNg, _Ze, FJg, mPg, tJg, Vzg, SDg, tDg, OHg, ePg, EIg, cFg, TPg, v$e, wMg, x$e, hOg, MQg, A$e, eNg, sZe, KIg, GJg, INg, yNg, wNg, uKg, GNg, rNg, FPg, kJg, D0e, mJg, pJg, OQg, tPg, pOg, yLg, PIg, kIg, E2e, bLg, hDg, LPg, G2e, LMg, Q2e, C2e, lOg, lQg, LRg, x3e, A3e, z3e, ZEg, _Eg, J4e, GKg, L4e, cRg, NIg, P5e, cNg, kKg, MJg, XOg, oDg, ZRg, CIg, q6e, eLg, nOg, $Eg, QJg, NJg, NQg, w8e, cDg, pDg, lPg, Ezg, dDg, uHg, lMg, tbf, HKg, zNg, vHg, mMg, Hzg, DLg, acf, IKg, pPg, Izg, ELg, bIg, iPg, cIg, dIg, XHg, $Ng, eIg, YHg, nMg, NDg, gKg, vNg, fIg, ZHg, Scf, BKg, Tcf, wKg, Jzg, bFg, RJg, gIg, hIg, YNg, uOg, oOg, qRg, EPg, oMg, pMg, ndf, JKg, odf, CKg, qDg, rDg, ODg, Qdf, KKg, Rdf, xKg, FLg, vLg, TNg, PDg, Zdf, DKg, hMg, def, LKg, eef, GLg, wHg, qMg, K4e, MKg, WEg, NKg, M7e, O7e, ONg, SJg, HLg, TJg, aOg, ILg, jLg, eDg, yKg, tKg, NNg, WNg, QNg, JLg, KLg, rMg, iff, OKg, mff, w7e, mRg, OPg, fDg, Kzg, iIg, NMg, qOg, jQg, Kgf, Mzg, eOg, fOg, ENg, qPg, IQg, xPg, Khf, D8e, Phf, gDg, Nzg, sDg, UJg, Pzg, Qzg, _kf, wSg, xSg, ySg, jIg, EMg, Flf, dMg, Ilf, bmf, wmf, PKg, iOg, Kmf, cOg, $mf, QKg, anf, RDg, cnf, Mnf, Nnf, Onf, Qnf, Tnf, _nf, IOg, fof, hof, xMg, mof, UOg, pof, rof, kOg, _Hg, SHg, QIg, RIg, lIg, AIg, VHg, DIg, Lof, tIg, yIg, BIg, zPg, GPg, _of, xNg, KQg, fRg, hQg, SQg, JOg, lpf, nJg, xRg, COg, qpf, bQg, vpf, Tpf, _pf, $pf, HPg, bqf, WMg, yRg, KOg, fqf, PLg, cQg, kqf, xqf, IPg, zRg, GOg, Jqf, VMg, Kqf, QLg, dQg, Pqf, frf, mrf, nrf, orf, ZMg, ARg, MOg, rrf, RLg, vrf, Arf, Urf, OMg, zOg, Wrf, SLg, eQg, _rf, msf, JPg, wsf, MMg, vOg, ysf, TLg, Csf, Ssf, KPg, atf, PMg, AOg, ctf, ULg, gtf, ttf, Ctf, RMg, BOg, Etf, VLg, fQg, Jtf, Vtf, VRg, IEg, sCg, uuf, aLg, uJg, Suf, Yuf, avf, wLg, evf, fpf, hvf, BPg, ovf, wOg, oQg, XRg, YQg, uRg, ipf, ZNg, Dvf, IJg, Gvf, Ovf, lLg, Qvf, fLg, Rvf, Svf, YOg, Uvf, _vf, cwf, fwf, gwf, kwf, mwf, sQg, ERg, pwf, DOg, tQg, yuf, mLg, PQg, gpf, Iwf, $wf, _Mg, sxf, vxf, aNg, OOg, BRg, WPg, Xxf, WLg, _xf, DQg, kyf, SIg, sMg, sHg, pHg, Jyf, RKg, mIg, Kyf, nLg, fNg, hSg, POg, VQg, bzf, Gyf, gLg, Iyf, hLg, Byf, iLg, MPg, azf, rKg, xHg, OJg, Pyf, dOg, Syf, yEg, rEg, JEg, XEg, mHg, sEg, KEg, eFg, qHg, yHg, PHg, zHg, QHg, Dzf, Ezf, Fzf, Gzf, Zzf, FAf, jMg, GAf, IAf, nIg, gJg, hJg, jBf, kBf, uIg, $Hg, nBf, vIg, iJg, cPg, NBf, PBf, JCf, dCf, lCf, oCf, pQg, sCf, eMg, xCf, yCf, QMg, ACf, XMg, pCf, wCf, zCf, BCf, OCf, uQg, TQg, XDf, ZDf, gMg, gOg, RNg, APg, uPg, gEf, ZPg, hEf, nEf, nCf, ZOg, _Pg, gRg, XQg, tOg, zEf, EOg, $Pg, DEf, UPg, VPg, eRg, nGf, lGf, mGf, $zg, KRg, MRg, kRg, mOg, TIg, UIg, VIg, RGf, XGf, nRg, _Gf, jSg, oHf, EQg, XLg, Uxf, jKg, kPg, pJf, tJf, iQg, FRg, EJf, rJg, wJf, zLg, _Rg, iKf, HJg, jKf, oKf, qKf, sKf, uKf, QQg, vPg, lSg, RRg, rRg, sSg, MKf, sOg, UQg, tRg, bRg, ZQg, cSg, IRg, dSg, TRg, nSg, QRg, eSg, pSg, LNg, vSg, iLf, sPg, aSg, BNg, PNg, xLf, FLf, oLg, GLf, lNf, wPg, jMf, JMf, IOf, WNf, ZNf, aOf, CRf, QPf, YPg, rQg, SNg, jOg, bSg, HNg, oPg, xOg, oIg, bRf, cRf, CNg, yPg, sRg, IRf, ASf, nTf, _Ng, aAg, PPg, lRg, pRg, MUf, LIg, LUf, FMg, jVf, pLg, aRg, NPg, VUf, kMg, PVf, XVf, QPg, kXf, eAg, fYf, hYf, __f, c$f, Y_f, CYf, EYf, RYf, _Yf, aZf, hRg, lZf, FZf, HZf, p_f, r_f, qQg, P$f, Q$f, SOg, kQg, $Rg, HOg, D0f, ALg, F0f, jRg, K0f, oRg, M0f, O0f, vQg, r1f, iNg, WIg, iRg, JRg, XIg, F1f, G1f, I1f, y2f, z2f, u2f, w2f, BLg, YIg, J2f, L2f, S2f, U2f, kLg, FIg, GIg, HIg, IIg, l3f, mNg, m3f, dPg, D3f, F3f, a4f, c4f, bOg, w4f, y4f, M4f, N4f, RPg, SPg, x6f, O6f, u7f, AKg, n8f, C8f, QOg, p8f, B6f, C6f, EKg, YLg, Hag, abg, jNg, tEg, PJg, tNg, xJg, _Qg, YRg, CRg, fdg, vdg, Hdg, sNg, Zdg, MIg, JQg, efg, ccg, hfg, afg, pcg, qcg, lfg, mfg, FOg, oNg, ORg, kSg, CPg, DRg, LQg, DPg, SRg, wRg, mSg, fSg, GRg, gSg, tSg, qSg, aQg, qJg, XPg, Lag, Thg, LEg, Mig, JIg, Lig, ZLg, yOg, ljg, ojg, qjg, sjg, tCg, ACg, wDg, iDg, zjg, TCg, Cjg, Ejg, Gjg, mCg, Jjg, JCg, UCg, Njg, KMg, Pjg, Rjg, gNg, MEg, iFg, rHg, AHg, uEg, jDg, oHg, jFg, NEg, UDg, wCg, VDg, xDg, Jkg, _Cg, Mkg, Okg, Qkg, Xkg, _kg, alg, clg, QCg, $Cg, zEg, klg, oEg, nlg, plg, slg, qCg, xCg, kDg, aDg, Alg, RCg, Clg, Elg, Glg, bDg, kFg, AEg, yDg, BCg, pEg, WDg, amg, lDg, dmg, fmg, gmg, KCg, WCg, BEg, wEg, omg, XDg, rmg, smg, umg, XCg, nDg, YEg, OEg, Cmg, xEg, Fmg, Jmg, Kmg, wQg, Oog, NRg, JJg, BJg, ppg, pIg, RHg, Mpg, rLg, _og, ROg, WRg, NOg, PRg, HRg, $Qg, URg, WQg, bqg, uSg, oSg, nqg, tMg, pqg, qqg, rqg, fqg, sqg, tqg, FKg, hKg, Fqg, UNg, nQg, dRg, fPg, AQg, LOg, Yqg, Zqg, $qg, arg, crg, drg, frg, zDg, CLg, rSg, Rrg, nAg, DNg, dsg, ysg, Asg, Bsg, dLg, dtg, etg, jtg, ltg, wtg, ZIg, utg, Ptg, TKg, Stg, Utg, RQg, iSg, vRg, Lug, VNg, _Lg, VOg, WOg, _Og, $Og, aPg, bPg, gPg, Evg, Gvg, YMg, $Mg, bNg, Fvg, qvg, Avg, Nvg, Ovg, Qvg, Kvg, Rvg, Svg, Pvg, Uvg, MNg, Pwg, Qwg, Twg, Uwg, Wwg, Xwg, FQg, HQg, qIg, qxg, Axg, uMg, Bxg, Cxg, Dxg, Exg, Fxg, Gxg, Hxg, rIg, Oxg, fMg, sIg, Sxg, vMg, JNg, owg, syg, yyg, xyg, Eyg, Dyg, azg, $yg, mzg, a1g, c1g, d1g, s1g, u1g, v1g, h2g, j2g, l2g, Dmi, Emi, Bsi, Gsi, bBi, Ksi, lBi, eri, fri, Dti, Iti, nxi, sxi, fyi, hyi, kyi, Pxi, Wxi, Zxi, ayi, cDi, NEi, ot, Gt, St, lu, mu, xu, Au, dD, iD, kD, tD, qD, vD, FD, GD, Ww, gx, MD, wx, Jx, Lx, Gv, Tv, gw, Wv, Xv, Yv, iw, fw, RD, iy, oy, zz, Ly, Jy, Uz, pA, _A, xB, uB, tB, sB, GB, RB, TB, YB, rE, qE, bC, XC, VC, Dw, Kw, Sw, sN, pQ, NVa, Msa, M6a, P6a, GQ, cIc, F9c, Rxd, Sxd, RAd, zJd, oLd, xJd, yJd, ybe, X9d, hde, yee, Wee, Bee, nde, bfe, xee, Tee, Uee, gee, iee, jee, kfe, vfe, pge, rge, Xfe, Oge, Pge, Qge, Rge, Sge, Tge, Uge, Vge, ahe, bhe, che, dhe, Ehe, xie, Fpe, Gpe, Hpe, Ipe, tCi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi, wOi ];
 var yo = [ xOi, Joc, scf, xOi ];
 var zo = [ yOi, Hbb, Ibb, yOi ];
 var Ao = [ zOi, S0, JKd, FNd ];
 var Bo = [ AOi, bxi, hxi, AOi ];
 var Co = [ BOi, Gbb, Lse, BOi ];
 var Do = [ COi, NAd ];
 var Eo = [ DOi, LKf, jgg, Xpg ];
 var Fo = [ EOi, q1 ];
 var Go = [ FOi, Eta, Gta, FOi ];
 var Ho = [ GOi, lEa ];
 var Io = [ HOi, IOi ];
 var Jo = [ JOi, Ep, Fp, eO, ct, qt, rt, xt, wt, _C, $C, nu, ou, Uw, BD, CD, ID, av, Zu, $u, Ju, Ku, Yu, Nu, Lu, Mu, bv, Ou, Pu, Su, Vu, Xu, dv, Ru, iv, KD, LD, lx, ox, px, qx, tx, Ax, Gx, Tx, oE, cy, Wx, Xx, yy, Lz, IA, fB, iB, oB, ZA, $A, _B, $B, tC, MVa, _xd, kyd, nyd, oyd, izd, OBd, PBd, rCd, KOi, LOi, MOi, NOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi, JOi ];
 var Ko = [ OOi, POi, QOi, ROi ];
 var Lo = [ SOi, gX ];
 var Mo = [ TOi, klf ];
 var No = [ UOi, kdf ];
 var Oo = [ VOi, Gna, Hna, hpd, jpd, brd, erd, Ore, Yre, rvf, JKf, ZKf, eLf, ERf, wRf, ARf, BRf, A0f, Ecg, Keg, Jfg, bgg, ggg, Upg, Zpg, aqg, wyi, xyi, nyi, oyi, Eyi, Fyi, Myi, Nyi, Vw, Zw, Nx, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi, VOi ];
 var Po = [ WOi, Eoc, _6e, WOi ];
 return {
  _SetFullscreen: Upe,
  _strlen: SEi,
  _main: tpe,
  _memset: PEi,
  _SendMessageFloat: Rpe,
  _bitshift64Lshr: VEi,
  _calloc: CDi,
  _bitshift64Shl: cFi,
  ___cxa_is_pointer_type: tDi,
  _strncpy: UEi,
  _bitshift64Ashr: TEi,
  _llvm_cttz_i32: $Ei,
  _memcpy: YEi,
  _i64Subtract: ZEi,
  _realloc: DDi,
  _i64Add: _Ei,
  _saveSetjmp: REi,
  _llvm_bswap_i32: XEi,
  _SendMessageString: Spe,
  _testSetjmp: WEi,
  ___cxa_can_catch: sDi,
  _free: BDi,
  _memmove: aFi,
  _strstr: mCi,
  _malloc: ADi,
  _llvm_ctlz_i32: QEi,
  _strcpy: bFi,
  _SendMessage: Tpe,
  __GLOBAL__sub_I_Monitor_cpp: fP,
  __GLOBAL__sub_I_Error_cpp: gP,
  __GLOBAL__sub_I_Thread_cpp: hP,
  __GLOBAL__sub_I_File_cpp: iP,
  __GLOBAL__sub_I_ThreadImpl_cpp: jP,
  __GLOBAL__sub_I_Class_cpp: kP,
  __GLOBAL__sub_I_Reflection_cpp: lP,
  __GLOBAL__sub_I_Runtime_cpp: mP,
  __GLOBAL__sub_I_String_cpp: nP,
  __GLOBAL__sub_I_Thread_cpp1784: oP,
  __GLOBAL__I_a: RTa,
  __GLOBAL__I_a4175: STa,
  __GLOBAL__I_a4186: TTa,
  __GLOBAL__I_a4190: UTa,
  __GLOBAL__I_a4212: VTa,
  __GLOBAL__I_a4563: WTa,
  __GLOBAL__I_a6527: XTa,
  ___cxx_global_var_init: RPb,
  __GLOBAL__sub_I_MessageIdentifier_cpp: iWb,
  __GLOBAL__sub_I_GUITexture_cpp: CYb,
  __GLOBAL__sub_I_ForwardShaderRenderLoop_cpp: $Yb,
  __GLOBAL__sub_I_DeferredUtils_cpp: KZb,
  __GLOBAL__sub_I_PrePassRenderLoop_cpp: PZb,
  __GLOBAL__sub_I_DeferredRenderLoop_cpp: $Zb,
  __GLOBAL__sub_I_Camera_cpp: R0b,
  __GLOBAL__sub_I_Flare_cpp: Y1b,
  __GLOBAL__sub_I_ImageFilters_cpp: G3b,
  __GLOBAL__sub_I_Light_cpp: $4b,
  __GLOBAL__sub_I_CubemapGPUUtility_cpp: Y7b,
  __GLOBAL__sub_I_RenderSettings_cpp: Y8b,
  __GLOBAL__sub_I_Shadows_cpp: R9b,
  __GLOBAL__sub_I_SkyboxMeshGenerator_cpp: hac,
  __GLOBAL__sub_I_SpeedTreeWindManager_cpp: Vbc,
  __GLOBAL__sub_I_Mesh_cpp: Gec,
  __GLOBAL__sub_I_SpriteRenderer_cpp: Cic,
  __GLOBAL__sub_I_BillboardBatchManager_cpp: Ijc,
  __GLOBAL__sub_I_AABB_cpp: Zlc,
  __GLOBAL__sub_I_GfxDevice_cpp: Poc,
  __GLOBAL__sub_I_LODGroupManager_cpp: muc,
  __GLOBAL__sub_I_RendererAnimationBinding_cpp: _Ac,
  __GLOBAL__sub_I_ScreenManager_cpp: SCc,
  __GLOBAL__sub_I_rand_cpp: JLc,
  __GLOBAL__sub_I_Player_cpp: qRc,
  __GLOBAL__sub_I_GraphicsCaps_cpp: Ljd,
  __GLOBAL__sub_I_JobManager_cpp: Tnd,
  __GLOBAL__sub_I_ShaderPass_cpp: Mtd,
  __GLOBAL__sub_I_umbra_cpp: jDd,
  __GLOBAL__sub_I_ParticleSystem_cpp: lDd,
  __GLOBAL__sub_I_PhysicsManager_cpp: kGd,
  __GLOBAL__sub_I_Physics2DManager_cpp: $Id,
  __GLOBAL__sub_I_clipmuscle_cpp: AZd,
  __GLOBAL__sub_I_DetailDatabase_cpp: s0d,
  __GLOBAL__sub_I_DetailRenderer_cpp: J0d,
  __GLOBAL__sub_I_SplatMaterials_cpp: C1d,
  __GLOBAL__sub_I_Tree_cpp: H3d,
  __GLOBAL__sub_I_TreeIntermediateRenderer_cpp: V3d,
  __GLOBAL__sub_I_TreeRenderer_cpp: E4d,
  __GLOBAL__sub_I_half_cpp: mle,
  __GLOBAL__sub_I_GpuProgramsGLES_cpp: Nue,
  __GLOBAL__sub_I_Assembly_CSharp_firstpass_cpp: rqh,
  __GLOBAL__sub_I_Assembly_CSharp_cpp: sqh,
  __GLOBAL__sub_I_Mono_Security_cpp: tqh,
  __GLOBAL__sub_I_System_Core_cpp: uqh,
  __GLOBAL__sub_I_System_cpp: vqh,
  __GLOBAL__sub_I_UnityEngine_cpp: wqh,
  __GLOBAL__sub_I_mscorlib_cpp: xqh,
  __GLOBAL__sub_I_replacements_cpp: yqh,
  __GLOBAL__sub_I_iostream_cpp: xzi,
  runPostSets: OEi,
  stackAlloc: Qo,
  stackSave: Ro,
  stackRestore: So,
  setThrew: To,
  setTempRet0: Wo,
  getTempRet0: Xo,
  dynCall_fiff: kFi,
  dynCall_iiiiiii: lFi,
  dynCall_vifiiiiiiiiiiiiiiiiiii: mFi,
  dynCall_viiiiiiiiiii: nFi,
  dynCall_iidi: oFi,
  dynCall_fiiiiiifiiiiiif: pFi,
  dynCall_iiiiifiif: qFi,
  dynCall_viiiiiffi: rFi,
  dynCall_iiiiiiiiiiii: sFi,
  dynCall_fif: tFi,
  dynCall_fid: uFi,
  dynCall_fii: vFi,
  dynCall_ddii: wFi,
  dynCall_di: xFi,
  dynCall_dd: yFi,
  dynCall_iiiifiiii: zFi,
  dynCall_viffff: AFi,
  dynCall_didd: BFi,
  dynCall_dii: CFi,
  dynCall_did: DFi,
  dynCall_dif: EFi,
  dynCall_iiiiiiiiii: FFi,
  dynCall_vdddddd: GFi,
  dynCall_iiiiiiiiiiiiffffii: HFi,
  dynCall_vdd: IFi,
  dynCall_iiiiiiii: JFi,
  dynCall_iiiiiifffiiiii: KFi,
  dynCall_vifiiiiiiiiiiiii: LFi,
  dynCall_iiiii: MFi,
  dynCall_iiifii: NFi,
  dynCall_fifff: OFi,
  dynCall_viiiiid: PFi,
  dynCall_viff: QFi,
  dynCall_vifi: RFi,
  dynCall_vifff: SFi,
  dynCall_viiiiii: TFi,
  dynCall_ddd: UFi,
  dynCall_fiii: VFi,
  dynCall_iifff: WFi,
  dynCall_iiiiiifiiiiiiiiiffffi: XFi,
  dynCall_iiiiifiiiif: YFi,
  dynCall_viiffffff: ZFi,
  dynCall_viiiiiiiiii: _Fi,
  dynCall_diii: $Fi,
  dynCall_viiiiiiiiiiii: aGi,
  dynCall_iiiiii: bGi,
  dynCall_iiiiiifiif: cGi,
  dynCall_viiii: dGi,
  dynCall_viiiii: eGi,
  dynCall_vif: fGi,
  dynCall_vid: gGi,
  dynCall_iiidi: hGi,
  dynCall_vii: iGi,
  dynCall_viifii: jGi,
  dynCall_fi: kGi,
  dynCall_viidi: lGi,
  dynCall_fiiiiiiiifiiiif: mGi,
  dynCall_viiiiiiii: nGi,
  dynCall_vifiii: oGi,
  dynCall_iiiiiiifiiiiiiiiiffffi: pGi,
  dynCall_diiii: qGi,
  dynCall_viiiiiiiiiiiii: rGi,
  dynCall_iiiiiiiiiiffffii: sGi,
  dynCall_iid: tGi,
  dynCall_iif: uGi,
  dynCall_vifiiii: vGi,
  dynCall_viiiiiii: wGi,
  dynCall_vifiiiiiiiiiiiiiiiiii: xGi,
  dynCall_viiiiiiiii: yGi,
  dynCall_viiiiiif: zGi,
  dynCall_iii: AGi,
  dynCall_iiiifii: BGi,
  dynCall_vffff: CGi,
  dynCall_viiiifiiiiif: DGi,
  dynCall_viii: EGi,
  dynCall_v: FGi,
  dynCall_viid: GGi,
  dynCall_viif: HGi,
  dynCall_iiiifi: IGi,
  dynCall_vd: JGi,
  dynCall_vf: KGi,
  dynCall_vi: LGi,
  dynCall_iiiiiiiiiii: MGi,
  dynCall_ii: NGi,
  dynCall_iiff: OGi,
  dynCall_viifi: PGi,
  dynCall_iiiiifiiiiii: QGi,
  dynCall_iiiiifiiiiif: RGi,
  dynCall_iifi: SGi,
  dynCall_viiif: TGi,
  dynCall_viiiffii: UGi,
  dynCall_vifiiiiiiiiiiiiiiiiiiiiiii: VGi,
  dynCall_iifiiiii: WGi,
  dynCall_iiifi: XGi,
  dynCall_iiii: YGi,
  dynCall_viifff: ZGi,
  dynCall_viiffi: _Gi,
  dynCall_iiif: $Gi,
  dynCall_viiiiiid: aHi,
  dynCall_viiifi: bHi,
  dynCall_viffffff: cHi,
  dynCall_iiiiiiiiiiiii: dHi,
  dynCall_iiiifiiiii: eHi,
  dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiii: fHi,
  dynCall_viffffffffffffiiii: gHi,
  dynCall_vfi: hHi,
  dynCall_i: iHi,
  dynCall_vff: jHi,
  dynCall_viiifiiiii: kHi,
  dynCall_iiiiiifiiiiiiiiiiii: lHi,
  dynCall_viiffff: mHi,
  dynCall_iiiiiiiii: nHi,
  dynCall_viffffi: oHi
 };
})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg, Module.asmLibraryArg, buffer);
var _SetFullscreen = Module["_SetFullscreen"] = asm["_SetFullscreen"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _main = Module["_main"] = asm["_main"];
var _memset = Module["_memset"] = asm["_memset"];
var _SendMessageFloat = Module["_SendMessageFloat"] = asm["_SendMessageFloat"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var ___cxa_is_pointer_type = Module["___cxa_is_pointer_type"] = asm["___cxa_is_pointer_type"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _llvm_cttz_i32 = Module["_llvm_cttz_i32"] = asm["_llvm_cttz_i32"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _llvm_bswap_i32 = Module["_llvm_bswap_i32"] = asm["_llvm_bswap_i32"];
var _SendMessageString = Module["_SendMessageString"] = asm["_SendMessageString"];
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var ___cxa_can_catch = Module["___cxa_can_catch"] = asm["___cxa_can_catch"];
var _free = Module["_free"] = asm["_free"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _strstr = Module["_strstr"] = asm["_strstr"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _llvm_ctlz_i32 = Module["_llvm_ctlz_i32"] = asm["_llvm_ctlz_i32"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _SendMessage = Module["_SendMessage"] = asm["_SendMessage"];
var __GLOBAL__sub_I_Monitor_cpp = Module["__GLOBAL__sub_I_Monitor_cpp"] = asm["__GLOBAL__sub_I_Monitor_cpp"];
var __GLOBAL__sub_I_Error_cpp = Module["__GLOBAL__sub_I_Error_cpp"] = asm["__GLOBAL__sub_I_Error_cpp"];
var __GLOBAL__sub_I_Thread_cpp = Module["__GLOBAL__sub_I_Thread_cpp"] = asm["__GLOBAL__sub_I_Thread_cpp"];
var __GLOBAL__sub_I_File_cpp = Module["__GLOBAL__sub_I_File_cpp"] = asm["__GLOBAL__sub_I_File_cpp"];
var __GLOBAL__sub_I_ThreadImpl_cpp = Module["__GLOBAL__sub_I_ThreadImpl_cpp"] = asm["__GLOBAL__sub_I_ThreadImpl_cpp"];
var __GLOBAL__sub_I_Class_cpp = Module["__GLOBAL__sub_I_Class_cpp"] = asm["__GLOBAL__sub_I_Class_cpp"];
var __GLOBAL__sub_I_Reflection_cpp = Module["__GLOBAL__sub_I_Reflection_cpp"] = asm["__GLOBAL__sub_I_Reflection_cpp"];
var __GLOBAL__sub_I_Runtime_cpp = Module["__GLOBAL__sub_I_Runtime_cpp"] = asm["__GLOBAL__sub_I_Runtime_cpp"];
var __GLOBAL__sub_I_String_cpp = Module["__GLOBAL__sub_I_String_cpp"] = asm["__GLOBAL__sub_I_String_cpp"];
var __GLOBAL__sub_I_Thread_cpp1784 = Module["__GLOBAL__sub_I_Thread_cpp1784"] = asm["__GLOBAL__sub_I_Thread_cpp1784"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var __GLOBAL__I_a4175 = Module["__GLOBAL__I_a4175"] = asm["__GLOBAL__I_a4175"];
var __GLOBAL__I_a4186 = Module["__GLOBAL__I_a4186"] = asm["__GLOBAL__I_a4186"];
var __GLOBAL__I_a4190 = Module["__GLOBAL__I_a4190"] = asm["__GLOBAL__I_a4190"];
var __GLOBAL__I_a4212 = Module["__GLOBAL__I_a4212"] = asm["__GLOBAL__I_a4212"];
var __GLOBAL__I_a4563 = Module["__GLOBAL__I_a4563"] = asm["__GLOBAL__I_a4563"];
var __GLOBAL__I_a6527 = Module["__GLOBAL__I_a6527"] = asm["__GLOBAL__I_a6527"];
var ___cxx_global_var_init = Module["___cxx_global_var_init"] = asm["___cxx_global_var_init"];
var __GLOBAL__sub_I_MessageIdentifier_cpp = Module["__GLOBAL__sub_I_MessageIdentifier_cpp"] = asm["__GLOBAL__sub_I_MessageIdentifier_cpp"];
var __GLOBAL__sub_I_GUITexture_cpp = Module["__GLOBAL__sub_I_GUITexture_cpp"] = asm["__GLOBAL__sub_I_GUITexture_cpp"];
var __GLOBAL__sub_I_ForwardShaderRenderLoop_cpp = Module["__GLOBAL__sub_I_ForwardShaderRenderLoop_cpp"] = asm["__GLOBAL__sub_I_ForwardShaderRenderLoop_cpp"];
var __GLOBAL__sub_I_DeferredUtils_cpp = Module["__GLOBAL__sub_I_DeferredUtils_cpp"] = asm["__GLOBAL__sub_I_DeferredUtils_cpp"];
var __GLOBAL__sub_I_PrePassRenderLoop_cpp = Module["__GLOBAL__sub_I_PrePassRenderLoop_cpp"] = asm["__GLOBAL__sub_I_PrePassRenderLoop_cpp"];
var __GLOBAL__sub_I_DeferredRenderLoop_cpp = Module["__GLOBAL__sub_I_DeferredRenderLoop_cpp"] = asm["__GLOBAL__sub_I_DeferredRenderLoop_cpp"];
var __GLOBAL__sub_I_Camera_cpp = Module["__GLOBAL__sub_I_Camera_cpp"] = asm["__GLOBAL__sub_I_Camera_cpp"];
var __GLOBAL__sub_I_Flare_cpp = Module["__GLOBAL__sub_I_Flare_cpp"] = asm["__GLOBAL__sub_I_Flare_cpp"];
var __GLOBAL__sub_I_ImageFilters_cpp = Module["__GLOBAL__sub_I_ImageFilters_cpp"] = asm["__GLOBAL__sub_I_ImageFilters_cpp"];
var __GLOBAL__sub_I_Light_cpp = Module["__GLOBAL__sub_I_Light_cpp"] = asm["__GLOBAL__sub_I_Light_cpp"];
var __GLOBAL__sub_I_CubemapGPUUtility_cpp = Module["__GLOBAL__sub_I_CubemapGPUUtility_cpp"] = asm["__GLOBAL__sub_I_CubemapGPUUtility_cpp"];
var __GLOBAL__sub_I_RenderSettings_cpp = Module["__GLOBAL__sub_I_RenderSettings_cpp"] = asm["__GLOBAL__sub_I_RenderSettings_cpp"];
var __GLOBAL__sub_I_Shadows_cpp = Module["__GLOBAL__sub_I_Shadows_cpp"] = asm["__GLOBAL__sub_I_Shadows_cpp"];
var __GLOBAL__sub_I_SkyboxMeshGenerator_cpp = Module["__GLOBAL__sub_I_SkyboxMeshGenerator_cpp"] = asm["__GLOBAL__sub_I_SkyboxMeshGenerator_cpp"];
var __GLOBAL__sub_I_SpeedTreeWindManager_cpp = Module["__GLOBAL__sub_I_SpeedTreeWindManager_cpp"] = asm["__GLOBAL__sub_I_SpeedTreeWindManager_cpp"];
var __GLOBAL__sub_I_Mesh_cpp = Module["__GLOBAL__sub_I_Mesh_cpp"] = asm["__GLOBAL__sub_I_Mesh_cpp"];
var __GLOBAL__sub_I_SpriteRenderer_cpp = Module["__GLOBAL__sub_I_SpriteRenderer_cpp"] = asm["__GLOBAL__sub_I_SpriteRenderer_cpp"];
var __GLOBAL__sub_I_BillboardBatchManager_cpp = Module["__GLOBAL__sub_I_BillboardBatchManager_cpp"] = asm["__GLOBAL__sub_I_BillboardBatchManager_cpp"];
var __GLOBAL__sub_I_AABB_cpp = Module["__GLOBAL__sub_I_AABB_cpp"] = asm["__GLOBAL__sub_I_AABB_cpp"];
var __GLOBAL__sub_I_GfxDevice_cpp = Module["__GLOBAL__sub_I_GfxDevice_cpp"] = asm["__GLOBAL__sub_I_GfxDevice_cpp"];
var __GLOBAL__sub_I_LODGroupManager_cpp = Module["__GLOBAL__sub_I_LODGroupManager_cpp"] = asm["__GLOBAL__sub_I_LODGroupManager_cpp"];
var __GLOBAL__sub_I_RendererAnimationBinding_cpp = Module["__GLOBAL__sub_I_RendererAnimationBinding_cpp"] = asm["__GLOBAL__sub_I_RendererAnimationBinding_cpp"];
var __GLOBAL__sub_I_ScreenManager_cpp = Module["__GLOBAL__sub_I_ScreenManager_cpp"] = asm["__GLOBAL__sub_I_ScreenManager_cpp"];
var __GLOBAL__sub_I_rand_cpp = Module["__GLOBAL__sub_I_rand_cpp"] = asm["__GLOBAL__sub_I_rand_cpp"];
var __GLOBAL__sub_I_Player_cpp = Module["__GLOBAL__sub_I_Player_cpp"] = asm["__GLOBAL__sub_I_Player_cpp"];
var __GLOBAL__sub_I_GraphicsCaps_cpp = Module["__GLOBAL__sub_I_GraphicsCaps_cpp"] = asm["__GLOBAL__sub_I_GraphicsCaps_cpp"];
var __GLOBAL__sub_I_JobManager_cpp = Module["__GLOBAL__sub_I_JobManager_cpp"] = asm["__GLOBAL__sub_I_JobManager_cpp"];
var __GLOBAL__sub_I_ShaderPass_cpp = Module["__GLOBAL__sub_I_ShaderPass_cpp"] = asm["__GLOBAL__sub_I_ShaderPass_cpp"];
var __GLOBAL__sub_I_umbra_cpp = Module["__GLOBAL__sub_I_umbra_cpp"] = asm["__GLOBAL__sub_I_umbra_cpp"];
var __GLOBAL__sub_I_ParticleSystem_cpp = Module["__GLOBAL__sub_I_ParticleSystem_cpp"] = asm["__GLOBAL__sub_I_ParticleSystem_cpp"];
var __GLOBAL__sub_I_PhysicsManager_cpp = Module["__GLOBAL__sub_I_PhysicsManager_cpp"] = asm["__GLOBAL__sub_I_PhysicsManager_cpp"];
var __GLOBAL__sub_I_Physics2DManager_cpp = Module["__GLOBAL__sub_I_Physics2DManager_cpp"] = asm["__GLOBAL__sub_I_Physics2DManager_cpp"];
var __GLOBAL__sub_I_clipmuscle_cpp = Module["__GLOBAL__sub_I_clipmuscle_cpp"] = asm["__GLOBAL__sub_I_clipmuscle_cpp"];
var __GLOBAL__sub_I_DetailDatabase_cpp = Module["__GLOBAL__sub_I_DetailDatabase_cpp"] = asm["__GLOBAL__sub_I_DetailDatabase_cpp"];
var __GLOBAL__sub_I_DetailRenderer_cpp = Module["__GLOBAL__sub_I_DetailRenderer_cpp"] = asm["__GLOBAL__sub_I_DetailRenderer_cpp"];
var __GLOBAL__sub_I_SplatMaterials_cpp = Module["__GLOBAL__sub_I_SplatMaterials_cpp"] = asm["__GLOBAL__sub_I_SplatMaterials_cpp"];
var __GLOBAL__sub_I_Tree_cpp = Module["__GLOBAL__sub_I_Tree_cpp"] = asm["__GLOBAL__sub_I_Tree_cpp"];
var __GLOBAL__sub_I_TreeIntermediateRenderer_cpp = Module["__GLOBAL__sub_I_TreeIntermediateRenderer_cpp"] = asm["__GLOBAL__sub_I_TreeIntermediateRenderer_cpp"];
var __GLOBAL__sub_I_TreeRenderer_cpp = Module["__GLOBAL__sub_I_TreeRenderer_cpp"] = asm["__GLOBAL__sub_I_TreeRenderer_cpp"];
var __GLOBAL__sub_I_half_cpp = Module["__GLOBAL__sub_I_half_cpp"] = asm["__GLOBAL__sub_I_half_cpp"];
var __GLOBAL__sub_I_GpuProgramsGLES_cpp = Module["__GLOBAL__sub_I_GpuProgramsGLES_cpp"] = asm["__GLOBAL__sub_I_GpuProgramsGLES_cpp"];
var __GLOBAL__sub_I_Assembly_CSharp_firstpass_cpp = Module["__GLOBAL__sub_I_Assembly_CSharp_firstpass_cpp"] = asm["__GLOBAL__sub_I_Assembly_CSharp_firstpass_cpp"];
var __GLOBAL__sub_I_Assembly_CSharp_cpp = Module["__GLOBAL__sub_I_Assembly_CSharp_cpp"] = asm["__GLOBAL__sub_I_Assembly_CSharp_cpp"];
var __GLOBAL__sub_I_Mono_Security_cpp = Module["__GLOBAL__sub_I_Mono_Security_cpp"] = asm["__GLOBAL__sub_I_Mono_Security_cpp"];
var __GLOBAL__sub_I_System_Core_cpp = Module["__GLOBAL__sub_I_System_Core_cpp"] = asm["__GLOBAL__sub_I_System_Core_cpp"];
var __GLOBAL__sub_I_System_cpp = Module["__GLOBAL__sub_I_System_cpp"] = asm["__GLOBAL__sub_I_System_cpp"];
var __GLOBAL__sub_I_UnityEngine_cpp = Module["__GLOBAL__sub_I_UnityEngine_cpp"] = asm["__GLOBAL__sub_I_UnityEngine_cpp"];
var __GLOBAL__sub_I_mscorlib_cpp = Module["__GLOBAL__sub_I_mscorlib_cpp"] = asm["__GLOBAL__sub_I_mscorlib_cpp"];
var __GLOBAL__sub_I_replacements_cpp = Module["__GLOBAL__sub_I_replacements_cpp"] = asm["__GLOBAL__sub_I_replacements_cpp"];
var __GLOBAL__sub_I_iostream_cpp = Module["__GLOBAL__sub_I_iostream_cpp"] = asm["__GLOBAL__sub_I_iostream_cpp"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_fiff = Module["dynCall_fiff"] = asm["dynCall_fiff"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_vifiiiiiiiiiiiiiiiiiii = Module["dynCall_vifiiiiiiiiiiiiiiiiiii"] = asm["dynCall_vifiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiiiiiiii = Module["dynCall_viiiiiiiiiii"] = asm["dynCall_viiiiiiiiiii"];
var dynCall_iidi = Module["dynCall_iidi"] = asm["dynCall_iidi"];
var dynCall_fiiiiiifiiiiiif = Module["dynCall_fiiiiiifiiiiiif"] = asm["dynCall_fiiiiiifiiiiiif"];
var dynCall_iiiiifiif = Module["dynCall_iiiiifiif"] = asm["dynCall_iiiiifiif"];
var dynCall_viiiiiffi = Module["dynCall_viiiiiffi"] = asm["dynCall_viiiiiffi"];
var dynCall_iiiiiiiiiiii = Module["dynCall_iiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiii"];
var dynCall_fif = Module["dynCall_fif"] = asm["dynCall_fif"];
var dynCall_fid = Module["dynCall_fid"] = asm["dynCall_fid"];
var dynCall_fii = Module["dynCall_fii"] = asm["dynCall_fii"];
var dynCall_ddii = Module["dynCall_ddii"] = asm["dynCall_ddii"];
var dynCall_di = Module["dynCall_di"] = asm["dynCall_di"];
var dynCall_dd = Module["dynCall_dd"] = asm["dynCall_dd"];
var dynCall_iiiifiiii = Module["dynCall_iiiifiiii"] = asm["dynCall_iiiifiiii"];
var dynCall_viffff = Module["dynCall_viffff"] = asm["dynCall_viffff"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_did = Module["dynCall_did"] = asm["dynCall_did"];
var dynCall_dif = Module["dynCall_dif"] = asm["dynCall_dif"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_vdddddd = Module["dynCall_vdddddd"] = asm["dynCall_vdddddd"];
var dynCall_iiiiiiiiiiiiffffii = Module["dynCall_iiiiiiiiiiiiffffii"] = asm["dynCall_iiiiiiiiiiiiffffii"];
var dynCall_vdd = Module["dynCall_vdd"] = asm["dynCall_vdd"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_iiiiiifffiiiii = Module["dynCall_iiiiiifffiiiii"] = asm["dynCall_iiiiiifffiiiii"];
var dynCall_vifiiiiiiiiiiiii = Module["dynCall_vifiiiiiiiiiiiii"] = asm["dynCall_vifiiiiiiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_iiifii = Module["dynCall_iiifii"] = asm["dynCall_iiifii"];
var dynCall_fifff = Module["dynCall_fifff"] = asm["dynCall_fifff"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viff = Module["dynCall_viff"] = asm["dynCall_viff"];
var dynCall_vifi = Module["dynCall_vifi"] = asm["dynCall_vifi"];
var dynCall_vifff = Module["dynCall_vifff"] = asm["dynCall_vifff"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_ddd = Module["dynCall_ddd"] = asm["dynCall_ddd"];
var dynCall_fiii = Module["dynCall_fiii"] = asm["dynCall_fiii"];
var dynCall_iifff = Module["dynCall_iifff"] = asm["dynCall_iifff"];
var dynCall_iiiiiifiiiiiiiiiffffi = Module["dynCall_iiiiiifiiiiiiiiiffffi"] = asm["dynCall_iiiiiifiiiiiiiiiffffi"];
var dynCall_iiiiifiiiif = Module["dynCall_iiiiifiiiif"] = asm["dynCall_iiiiifiiiif"];
var dynCall_viiffffff = Module["dynCall_viiffffff"] = asm["dynCall_viiffffff"];
var dynCall_viiiiiiiiii = Module["dynCall_viiiiiiiiii"] = asm["dynCall_viiiiiiiiii"];
var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
var dynCall_viiiiiiiiiiii = Module["dynCall_viiiiiiiiiiii"] = asm["dynCall_viiiiiiiiiiii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiiifiif = Module["dynCall_iiiiiifiif"] = asm["dynCall_iiiiiifiif"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_vif = Module["dynCall_vif"] = asm["dynCall_vif"];
var dynCall_vid = Module["dynCall_vid"] = asm["dynCall_vid"];
var dynCall_iiidi = Module["dynCall_iiidi"] = asm["dynCall_iiidi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_viifii = Module["dynCall_viifii"] = asm["dynCall_viifii"];
var dynCall_fi = Module["dynCall_fi"] = asm["dynCall_fi"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_fiiiiiiiifiiiif = Module["dynCall_fiiiiiiiifiiiif"] = asm["dynCall_fiiiiiiiifiiiif"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_vifiii = Module["dynCall_vifiii"] = asm["dynCall_vifiii"];
var dynCall_iiiiiiifiiiiiiiiiffffi = Module["dynCall_iiiiiiifiiiiiiiiiffffi"] = asm["dynCall_iiiiiiifiiiiiiiiiffffi"];
var dynCall_diiii = Module["dynCall_diiii"] = asm["dynCall_diiii"];
var dynCall_viiiiiiiiiiiii = Module["dynCall_viiiiiiiiiiiii"] = asm["dynCall_viiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiffffii = Module["dynCall_iiiiiiiiiiffffii"] = asm["dynCall_iiiiiiiiiiffffii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_iif = Module["dynCall_iif"] = asm["dynCall_iif"];
var dynCall_vifiiii = Module["dynCall_vifiiii"] = asm["dynCall_vifiiii"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_vifiiiiiiiiiiiiiiiiii = Module["dynCall_vifiiiiiiiiiiiiiiiiii"] = asm["dynCall_vifiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_viiiiiif = Module["dynCall_viiiiiif"] = asm["dynCall_viiiiiif"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiifii = Module["dynCall_iiiifii"] = asm["dynCall_iiiifii"];
var dynCall_vffff = Module["dynCall_vffff"] = asm["dynCall_vffff"];
var dynCall_viiiifiiiiif = Module["dynCall_viiiifiiiiif"] = asm["dynCall_viiiifiiiiif"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_viid = Module["dynCall_viid"] = asm["dynCall_viid"];
var dynCall_viif = Module["dynCall_viif"] = asm["dynCall_viif"];
var dynCall_iiiifi = Module["dynCall_iiiifi"] = asm["dynCall_iiiifi"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vf = Module["dynCall_vf"] = asm["dynCall_vf"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiff = Module["dynCall_iiff"] = asm["dynCall_iiff"];
var dynCall_viifi = Module["dynCall_viifi"] = asm["dynCall_viifi"];
var dynCall_iiiiifiiiiii = Module["dynCall_iiiiifiiiiii"] = asm["dynCall_iiiiifiiiiii"];
var dynCall_iiiiifiiiiif = Module["dynCall_iiiiifiiiiif"] = asm["dynCall_iiiiifiiiiif"];
var dynCall_iifi = Module["dynCall_iifi"] = asm["dynCall_iifi"];
var dynCall_viiif = Module["dynCall_viiif"] = asm["dynCall_viiif"];
var dynCall_viiiffii = Module["dynCall_viiiffii"] = asm["dynCall_viiiffii"];
var dynCall_vifiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_vifiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_vifiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iifiiiii = Module["dynCall_iifiiiii"] = asm["dynCall_iifiiiii"];
var dynCall_iiifi = Module["dynCall_iiifi"] = asm["dynCall_iiifi"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viifff = Module["dynCall_viifff"] = asm["dynCall_viifff"];
var dynCall_viiffi = Module["dynCall_viiffi"] = asm["dynCall_viiffi"];
var dynCall_iiif = Module["dynCall_iiif"] = asm["dynCall_iiif"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiifi = Module["dynCall_viiifi"] = asm["dynCall_viiifi"];
var dynCall_viffffff = Module["dynCall_viffffff"] = asm["dynCall_viffffff"];
var dynCall_iiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiii"];
var dynCall_iiiifiiiii = Module["dynCall_iiiifiiiii"] = asm["dynCall_iiiifiiiii"];
var dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viffffffffffffiiii = Module["dynCall_viffffffffffffiiii"] = asm["dynCall_viffffffffffffiiii"];
var dynCall_vfi = Module["dynCall_vfi"] = asm["dynCall_vfi"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_vff = Module["dynCall_vff"] = asm["dynCall_vff"];
var dynCall_viiifiiiii = Module["dynCall_viiifiiiii"] = asm["dynCall_viiifiiiii"];
var dynCall_iiiiiifiiiiiiiiiiii = Module["dynCall_iiiiiifiiiiiiiiiiii"] = asm["dynCall_iiiiiifiiiiiiiiiiii"];
var dynCall_viiffff = Module["dynCall_viiffff"] = asm["dynCall_viiffff"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_viffffi = Module["dynCall_viffffi"] = asm["dynCall_viffffi"];
Runtime.stackAlloc = asm["stackAlloc"];
Runtime.stackSave = asm["stackSave"];
Runtime.stackRestore = asm["stackRestore"];
Runtime.setTempRet0 = asm["setTempRet0"];
Runtime.getTempRet0 = asm["getTempRet0"];
var i64Math = (function() {
 var goog = {
  math: {}
 };
 goog.math.Long = (function(low, high) {
  this.low_ = low | 0;
  this.high_ = high | 0;
 });
 goog.math.Long.IntCache_ = {};
 goog.math.Long.fromInt = (function(value) {
  if (-128 <= value && value < 128) {
   var cachedObj = goog.math.Long.IntCache_[value];
   if (cachedObj) {
    return cachedObj;
   }
  }
  var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
  if (-128 <= value && value < 128) {
   goog.math.Long.IntCache_[value] = obj;
  }
  return obj;
 });
 goog.math.Long.fromNumber = (function(value) {
  if (isNaN(value) || !isFinite(value)) {
   return goog.math.Long.ZERO;
  } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
   return goog.math.Long.MIN_VALUE;
  } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
   return goog.math.Long.MAX_VALUE;
  } else if (value < 0) {
   return goog.math.Long.fromNumber(-value).negate();
  } else {
   return new goog.math.Long(value % goog.math.Long.TWO_PWR_32_DBL_ | 0, value / goog.math.Long.TWO_PWR_32_DBL_ | 0);
  }
 });
 goog.math.Long.fromBits = (function(lowBits, highBits) {
  return new goog.math.Long(lowBits, highBits);
 });
 goog.math.Long.fromString = (function(str, opt_radix) {
  if (str.length == 0) {
   throw Error("number format error: empty string");
  }
  var radix = opt_radix || 10;
  if (radix < 2 || 36 < radix) {
   throw Error("radix out of range: " + radix);
  }
  if (str.charAt(0) == "-") {
   return goog.math.Long.fromString(str.substring(1), radix).negate();
  } else if (str.indexOf("-") >= 0) {
   throw Error('number format error: interior "-" character: ' + str);
  }
  var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));
  var result = goog.math.Long.ZERO;
  for (var i = 0; i < str.length; i += 8) {
   var size = Math.min(8, str.length - i);
   var value = parseInt(str.substring(i, i + size), radix);
   if (size < 8) {
    var power = goog.math.Long.fromNumber(Math.pow(radix, size));
    result = result.multiply(power).add(goog.math.Long.fromNumber(value));
   } else {
    result = result.multiply(radixToPower);
    result = result.add(goog.math.Long.fromNumber(value));
   }
  }
  return result;
 });
 goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;
 goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;
 goog.math.Long.TWO_PWR_32_DBL_ = goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
 goog.math.Long.TWO_PWR_31_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ / 2;
 goog.math.Long.TWO_PWR_48_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
 goog.math.Long.TWO_PWR_64_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;
 goog.math.Long.TWO_PWR_63_DBL_ = goog.math.Long.TWO_PWR_64_DBL_ / 2;
 goog.math.Long.ZERO = goog.math.Long.fromInt(0);
 goog.math.Long.ONE = goog.math.Long.fromInt(1);
 goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);
 goog.math.Long.MAX_VALUE = goog.math.Long.fromBits(4294967295 | 0, 2147483647 | 0);
 goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 2147483648 | 0);
 goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);
 goog.math.Long.prototype.toInt = (function() {
  return this.low_;
 });
 goog.math.Long.prototype.toNumber = (function() {
  return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ + this.getLowBitsUnsigned();
 });
 goog.math.Long.prototype.toString = (function(opt_radix) {
  var radix = opt_radix || 10;
  if (radix < 2 || 36 < radix) {
   throw Error("radix out of range: " + radix);
  }
  if (this.isZero()) {
   return "0";
  }
  if (this.isNegative()) {
   if (this.equals(goog.math.Long.MIN_VALUE)) {
    var radixLong = goog.math.Long.fromNumber(radix);
    var div = this.div(radixLong);
    var rem = div.multiply(radixLong).subtract(this);
    return div.toString(radix) + rem.toInt().toString(radix);
   } else {
    return "-" + this.negate().toString(radix);
   }
  }
  var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));
  var rem = this;
  var result = "";
  while (true) {
   var remDiv = rem.div(radixToPower);
   var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
   var digits = intval.toString(radix);
   rem = remDiv;
   if (rem.isZero()) {
    return digits + result;
   } else {
    while (digits.length < 6) {
     digits = "0" + digits;
    }
    result = "" + digits + result;
   }
  }
 });
 goog.math.Long.prototype.getHighBits = (function() {
  return this.high_;
 });
 goog.math.Long.prototype.getLowBits = (function() {
  return this.low_;
 });
 goog.math.Long.prototype.getLowBitsUnsigned = (function() {
  return this.low_ >= 0 ? this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
 });
 goog.math.Long.prototype.getNumBitsAbs = (function() {
  if (this.isNegative()) {
   if (this.equals(goog.math.Long.MIN_VALUE)) {
    return 64;
   } else {
    return this.negate().getNumBitsAbs();
   }
  } else {
   var val = this.high_ != 0 ? this.high_ : this.low_;
   for (var bit = 31; bit > 0; bit--) {
    if ((val & 1 << bit) != 0) {
     break;
    }
   }
   return this.high_ != 0 ? bit + 33 : bit + 1;
  }
 });
 goog.math.Long.prototype.isZero = (function() {
  return this.high_ == 0 && this.low_ == 0;
 });
 goog.math.Long.prototype.isNegative = (function() {
  return this.high_ < 0;
 });
 goog.math.Long.prototype.isOdd = (function() {
  return (this.low_ & 1) == 1;
 });
 goog.math.Long.prototype.equals = (function(other) {
  return this.high_ == other.high_ && this.low_ == other.low_;
 });
 goog.math.Long.prototype.notEquals = (function(other) {
  return this.high_ != other.high_ || this.low_ != other.low_;
 });
 goog.math.Long.prototype.lessThan = (function(other) {
  return this.compare(other) < 0;
 });
 goog.math.Long.prototype.lessThanOrEqual = (function(other) {
  return this.compare(other) <= 0;
 });
 goog.math.Long.prototype.greaterThan = (function(other) {
  return this.compare(other) > 0;
 });
 goog.math.Long.prototype.greaterThanOrEqual = (function(other) {
  return this.compare(other) >= 0;
 });
 goog.math.Long.prototype.compare = (function(other) {
  if (this.equals(other)) {
   return 0;
  }
  var thisNeg = this.isNegative();
  var otherNeg = other.isNegative();
  if (thisNeg && !otherNeg) {
   return -1;
  }
  if (!thisNeg && otherNeg) {
   return 1;
  }
  if (this.subtract(other).isNegative()) {
   return -1;
  } else {
   return 1;
  }
 });
 goog.math.Long.prototype.negate = (function() {
  if (this.equals(goog.math.Long.MIN_VALUE)) {
   return goog.math.Long.MIN_VALUE;
  } else {
   return this.not().add(goog.math.Long.ONE);
  }
 });
 goog.math.Long.prototype.add = (function(other) {
  var a48 = this.high_ >>> 16;
  var a32 = this.high_ & 65535;
  var a16 = this.low_ >>> 16;
  var a00 = this.low_ & 65535;
  var b48 = other.high_ >>> 16;
  var b32 = other.high_ & 65535;
  var b16 = other.low_ >>> 16;
  var b00 = other.low_ & 65535;
  var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
  c00 += a00 + b00;
  c16 += c00 >>> 16;
  c00 &= 65535;
  c16 += a16 + b16;
  c32 += c16 >>> 16;
  c16 &= 65535;
  c32 += a32 + b32;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c48 += a48 + b48;
  c48 &= 65535;
  return goog.math.Long.fromBits(c16 << 16 | c00, c48 << 16 | c32);
 });
 goog.math.Long.prototype.subtract = (function(other) {
  return this.add(other.negate());
 });
 goog.math.Long.prototype.multiply = (function(other) {
  if (this.isZero()) {
   return goog.math.Long.ZERO;
  } else if (other.isZero()) {
   return goog.math.Long.ZERO;
  }
  if (this.equals(goog.math.Long.MIN_VALUE)) {
   return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
  } else if (other.equals(goog.math.Long.MIN_VALUE)) {
   return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
  }
  if (this.isNegative()) {
   if (other.isNegative()) {
    return this.negate().multiply(other.negate());
   } else {
    return this.negate().multiply(other).negate();
   }
  } else if (other.isNegative()) {
   return this.multiply(other.negate()).negate();
  }
  if (this.lessThan(goog.math.Long.TWO_PWR_24_) && other.lessThan(goog.math.Long.TWO_PWR_24_)) {
   return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
  }
  var a48 = this.high_ >>> 16;
  var a32 = this.high_ & 65535;
  var a16 = this.low_ >>> 16;
  var a00 = this.low_ & 65535;
  var b48 = other.high_ >>> 16;
  var b32 = other.high_ & 65535;
  var b16 = other.low_ >>> 16;
  var b00 = other.low_ & 65535;
  var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
  c00 += a00 * b00;
  c16 += c00 >>> 16;
  c00 &= 65535;
  c16 += a16 * b00;
  c32 += c16 >>> 16;
  c16 &= 65535;
  c16 += a00 * b16;
  c32 += c16 >>> 16;
  c16 &= 65535;
  c32 += a32 * b00;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c32 += a16 * b16;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c32 += a00 * b32;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
  c48 &= 65535;
  return goog.math.Long.fromBits(c16 << 16 | c00, c48 << 16 | c32);
 });
 goog.math.Long.prototype.div = (function(other) {
  if (other.isZero()) {
   throw Error("division by zero");
  } else if (this.isZero()) {
   return goog.math.Long.ZERO;
  }
  if (this.equals(goog.math.Long.MIN_VALUE)) {
   if (other.equals(goog.math.Long.ONE) || other.equals(goog.math.Long.NEG_ONE)) {
    return goog.math.Long.MIN_VALUE;
   } else if (other.equals(goog.math.Long.MIN_VALUE)) {
    return goog.math.Long.ONE;
   } else {
    var halfThis = this.shiftRight(1);
    var approx = halfThis.div(other).shiftLeft(1);
    if (approx.equals(goog.math.Long.ZERO)) {
     return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
    } else {
     var rem = this.subtract(other.multiply(approx));
     var result = approx.add(rem.div(other));
     return result;
    }
   }
  } else if (other.equals(goog.math.Long.MIN_VALUE)) {
   return goog.math.Long.ZERO;
  }
  if (this.isNegative()) {
   if (other.isNegative()) {
    return this.negate().div(other.negate());
   } else {
    return this.negate().div(other).negate();
   }
  } else if (other.isNegative()) {
   return this.div(other.negate()).negate();
  }
  var res = goog.math.Long.ZERO;
  var rem = this;
  while (rem.greaterThanOrEqual(other)) {
   var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));
   var log2 = Math.ceil(Math.log(approx) / Math.LN2);
   var delta = log2 <= 48 ? 1 : Math.pow(2, log2 - 48);
   var approxRes = goog.math.Long.fromNumber(approx);
   var approxRem = approxRes.multiply(other);
   while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
    approx -= delta;
    approxRes = goog.math.Long.fromNumber(approx);
    approxRem = approxRes.multiply(other);
   }
   if (approxRes.isZero()) {
    approxRes = goog.math.Long.ONE;
   }
   res = res.add(approxRes);
   rem = rem.subtract(approxRem);
  }
  return res;
 });
 goog.math.Long.prototype.modulo = (function(other) {
  return this.subtract(this.div(other).multiply(other));
 });
 goog.math.Long.prototype.not = (function() {
  return goog.math.Long.fromBits(~this.low_, ~this.high_);
 });
 goog.math.Long.prototype.and = (function(other) {
  return goog.math.Long.fromBits(this.low_ & other.low_, this.high_ & other.high_);
 });
 goog.math.Long.prototype.or = (function(other) {
  return goog.math.Long.fromBits(this.low_ | other.low_, this.high_ | other.high_);
 });
 goog.math.Long.prototype.xor = (function(other) {
  return goog.math.Long.fromBits(this.low_ ^ other.low_, this.high_ ^ other.high_);
 });
 goog.math.Long.prototype.shiftLeft = (function(numBits) {
  numBits &= 63;
  if (numBits == 0) {
   return this;
  } else {
   var low = this.low_;
   if (numBits < 32) {
    var high = this.high_;
    return goog.math.Long.fromBits(low << numBits, high << numBits | low >>> 32 - numBits);
   } else {
    return goog.math.Long.fromBits(0, low << numBits - 32);
   }
  }
 });
 goog.math.Long.prototype.shiftRight = (function(numBits) {
  numBits &= 63;
  if (numBits == 0) {
   return this;
  } else {
   var high = this.high_;
   if (numBits < 32) {
    var low = this.low_;
    return goog.math.Long.fromBits(low >>> numBits | high << 32 - numBits, high >> numBits);
   } else {
    return goog.math.Long.fromBits(high >> numBits - 32, high >= 0 ? 0 : -1);
   }
  }
 });
 goog.math.Long.prototype.shiftRightUnsigned = (function(numBits) {
  numBits &= 63;
  if (numBits == 0) {
   return this;
  } else {
   var high = this.high_;
   if (numBits < 32) {
    var low = this.low_;
    return goog.math.Long.fromBits(low >>> numBits | high << 32 - numBits, high >>> numBits);
   } else if (numBits == 32) {
    return goog.math.Long.fromBits(high, 0);
   } else {
    return goog.math.Long.fromBits(high >>> numBits - 32, 0);
   }
  }
 });
 var navigator = {
  appName: "Modern Browser"
 };
 var dbits;
 var canary = 0xdeadbeefcafe;
 var j_lm = (canary & 16777215) == 15715070;
 function BigInteger(a, b, c) {
  if (a != null) if ("number" == typeof a) this.fromNumber(a, b, c); else if (b == null && "string" != typeof a) this.fromString(a, 256); else this.fromString(a, b);
 }
 function nbi() {
  return new BigInteger(null);
 }
 function am1(i, x, w, j, c, n) {
  while (--n >= 0) {
   var v = x * this[i++] + w[j] + c;
   c = Math.floor(v / 67108864);
   w[j++] = v & 67108863;
  }
  return c;
 }
 function am2(i, x, w, j, c, n) {
  var xl = x & 32767, xh = x >> 15;
  while (--n >= 0) {
   var l = this[i] & 32767;
   var h = this[i++] >> 15;
   var m = xh * l + h * xl;
   l = xl * l + ((m & 32767) << 15) + w[j] + (c & 1073741823);
   c = (l >>> 30) + (m >>> 15) + xh * h + (c >>> 30);
   w[j++] = l & 1073741823;
  }
  return c;
 }
 function am3(i, x, w, j, c, n) {
  var xl = x & 16383, xh = x >> 14;
  while (--n >= 0) {
   var l = this[i] & 16383;
   var h = this[i++] >> 14;
   var m = xh * l + h * xl;
   l = xl * l + ((m & 16383) << 14) + w[j] + c;
   c = (l >> 28) + (m >> 14) + xh * h;
   w[j++] = l & 268435455;
  }
  return c;
 }
 if (j_lm && navigator.appName == "Microsoft Internet Explorer") {
  BigInteger.prototype.am = am2;
  dbits = 30;
 } else if (j_lm && navigator.appName != "Netscape") {
  BigInteger.prototype.am = am1;
  dbits = 26;
 } else {
  BigInteger.prototype.am = am3;
  dbits = 28;
 }
 BigInteger.prototype.DB = dbits;
 BigInteger.prototype.DM = (1 << dbits) - 1;
 BigInteger.prototype.DV = 1 << dbits;
 var BI_FP = 52;
 BigInteger.prototype.FV = Math.pow(2, BI_FP);
 BigInteger.prototype.F1 = BI_FP - dbits;
 BigInteger.prototype.F2 = 2 * dbits - BI_FP;
 var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
 var BI_RC = new Array;
 var rr, vv;
 rr = "0".charCodeAt(0);
 for (vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
 rr = "a".charCodeAt(0);
 for (vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
 rr = "A".charCodeAt(0);
 for (vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
 function int2char(n) {
  return BI_RM.charAt(n);
 }
 function intAt(s, i) {
  var c = BI_RC[s.charCodeAt(i)];
  return c == null ? -1 : c;
 }
 function bnpCopyTo(r) {
  for (var i = this.t - 1; i >= 0; --i) r[i] = this[i];
  r.t = this.t;
  r.s = this.s;
 }
 function bnpFromInt(x) {
  this.t = 1;
  this.s = x < 0 ? -1 : 0;
  if (x > 0) this[0] = x; else if (x < -1) this[0] = x + DV; else this.t = 0;
 }
 function nbv(i) {
  var r = nbi();
  r.fromInt(i);
  return r;
 }
 function bnpFromString(s, b) {
  var k;
  if (b == 16) k = 4; else if (b == 8) k = 3; else if (b == 256) k = 8; else if (b == 2) k = 1; else if (b == 32) k = 5; else if (b == 4) k = 2; else {
   this.fromRadix(s, b);
   return;
  }
  this.t = 0;
  this.s = 0;
  var i = s.length, mi = false, sh = 0;
  while (--i >= 0) {
   var x = k == 8 ? s[i] & 255 : intAt(s, i);
   if (x < 0) {
    if (s.charAt(i) == "-") mi = true;
    continue;
   }
   mi = false;
   if (sh == 0) this[this.t++] = x; else if (sh + k > this.DB) {
    this[this.t - 1] |= (x & (1 << this.DB - sh) - 1) << sh;
    this[this.t++] = x >> this.DB - sh;
   } else this[this.t - 1] |= x << sh;
   sh += k;
   if (sh >= this.DB) sh -= this.DB;
  }
  if (k == 8 && (s[0] & 128) != 0) {
   this.s = -1;
   if (sh > 0) this[this.t - 1] |= (1 << this.DB - sh) - 1 << sh;
  }
  this.clamp();
  if (mi) BigInteger.ZERO.subTo(this, this);
 }
 function bnpClamp() {
  var c = this.s & this.DM;
  while (this.t > 0 && this[this.t - 1] == c) --this.t;
 }
 function bnToString(b) {
  if (this.s < 0) return "-" + this.negate().toString(b);
  var k;
  if (b == 16) k = 4; else if (b == 8) k = 3; else if (b == 2) k = 1; else if (b == 32) k = 5; else if (b == 4) k = 2; else return this.toRadix(b);
  var km = (1 << k) - 1, d, m = false, r = "", i = this.t;
  var p = this.DB - i * this.DB % k;
  if (i-- > 0) {
   if (p < this.DB && (d = this[i] >> p) > 0) {
    m = true;
    r = int2char(d);
   }
   while (i >= 0) {
    if (p < k) {
     d = (this[i] & (1 << p) - 1) << k - p;
     d |= this[--i] >> (p += this.DB - k);
    } else {
     d = this[i] >> (p -= k) & km;
     if (p <= 0) {
      p += this.DB;
      --i;
     }
    }
    if (d > 0) m = true;
    if (m) r += int2char(d);
   }
  }
  return m ? r : "0";
 }
 function bnNegate() {
  var r = nbi();
  BigInteger.ZERO.subTo(this, r);
  return r;
 }
 function bnAbs() {
  return this.s < 0 ? this.negate() : this;
 }
 function bnCompareTo(a) {
  var r = this.s - a.s;
  if (r != 0) return r;
  var i = this.t;
  r = i - a.t;
  if (r != 0) return this.s < 0 ? -r : r;
  while (--i >= 0) if ((r = this[i] - a[i]) != 0) return r;
  return 0;
 }
 function nbits(x) {
  var r = 1, t;
  if ((t = x >>> 16) != 0) {
   x = t;
   r += 16;
  }
  if ((t = x >> 8) != 0) {
   x = t;
   r += 8;
  }
  if ((t = x >> 4) != 0) {
   x = t;
   r += 4;
  }
  if ((t = x >> 2) != 0) {
   x = t;
   r += 2;
  }
  if ((t = x >> 1) != 0) {
   x = t;
   r += 1;
  }
  return r;
 }
 function bnBitLength() {
  if (this.t <= 0) return 0;
  return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ this.s & this.DM);
 }
 function bnpDLShiftTo(n, r) {
  var i;
  for (i = this.t - 1; i >= 0; --i) r[i + n] = this[i];
  for (i = n - 1; i >= 0; --i) r[i] = 0;
  r.t = this.t + n;
  r.s = this.s;
 }
 function bnpDRShiftTo(n, r) {
  for (var i = n; i < this.t; ++i) r[i - n] = this[i];
  r.t = Math.max(this.t - n, 0);
  r.s = this.s;
 }
 function bnpLShiftTo(n, r) {
  var bs = n % this.DB;
  var cbs = this.DB - bs;
  var bm = (1 << cbs) - 1;
  var ds = Math.floor(n / this.DB), c = this.s << bs & this.DM, i;
  for (i = this.t - 1; i >= 0; --i) {
   r[i + ds + 1] = this[i] >> cbs | c;
   c = (this[i] & bm) << bs;
  }
  for (i = ds - 1; i >= 0; --i) r[i] = 0;
  r[ds] = c;
  r.t = this.t + ds + 1;
  r.s = this.s;
  r.clamp();
 }
 function bnpRShiftTo(n, r) {
  r.s = this.s;
  var ds = Math.floor(n / this.DB);
  if (ds >= this.t) {
   r.t = 0;
   return;
  }
  var bs = n % this.DB;
  var cbs = this.DB - bs;
  var bm = (1 << bs) - 1;
  r[0] = this[ds] >> bs;
  for (var i = ds + 1; i < this.t; ++i) {
   r[i - ds - 1] |= (this[i] & bm) << cbs;
   r[i - ds] = this[i] >> bs;
  }
  if (bs > 0) r[this.t - ds - 1] |= (this.s & bm) << cbs;
  r.t = this.t - ds;
  r.clamp();
 }
 function bnpSubTo(a, r) {
  var i = 0, c = 0, m = Math.min(a.t, this.t);
  while (i < m) {
   c += this[i] - a[i];
   r[i++] = c & this.DM;
   c >>= this.DB;
  }
  if (a.t < this.t) {
   c -= a.s;
   while (i < this.t) {
    c += this[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c += this.s;
  } else {
   c += this.s;
   while (i < a.t) {
    c -= a[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c -= a.s;
  }
  r.s = c < 0 ? -1 : 0;
  if (c < -1) r[i++] = this.DV + c; else if (c > 0) r[i++] = c;
  r.t = i;
  r.clamp();
 }
 function bnpMultiplyTo(a, r) {
  var x = this.abs(), y = a.abs();
  var i = x.t;
  r.t = i + y.t;
  while (--i >= 0) r[i] = 0;
  for (i = 0; i < y.t; ++i) r[i + x.t] = x.am(0, y[i], r, i, 0, x.t);
  r.s = 0;
  r.clamp();
  if (this.s != a.s) BigInteger.ZERO.subTo(r, r);
 }
 function bnpSquareTo(r) {
  var x = this.abs();
  var i = r.t = 2 * x.t;
  while (--i >= 0) r[i] = 0;
  for (i = 0; i < x.t - 1; ++i) {
   var c = x.am(i, x[i], r, 2 * i, 0, 1);
   if ((r[i + x.t] += x.am(i + 1, 2 * x[i], r, 2 * i + 1, c, x.t - i - 1)) >= x.DV) {
    r[i + x.t] -= x.DV;
    r[i + x.t + 1] = 1;
   }
  }
  if (r.t > 0) r[r.t - 1] += x.am(i, x[i], r, 2 * i, 0, 1);
  r.s = 0;
  r.clamp();
 }
 function bnpDivRemTo(m, q, r) {
  var pm = m.abs();
  if (pm.t <= 0) return;
  var pt = this.abs();
  if (pt.t < pm.t) {
   if (q != null) q.fromInt(0);
   if (r != null) this.copyTo(r);
   return;
  }
  if (r == null) r = nbi();
  var y = nbi(), ts = this.s, ms = m.s;
  var nsh = this.DB - nbits(pm[pm.t - 1]);
  if (nsh > 0) {
   pm.lShiftTo(nsh, y);
   pt.lShiftTo(nsh, r);
  } else {
   pm.copyTo(y);
   pt.copyTo(r);
  }
  var ys = y.t;
  var y0 = y[ys - 1];
  if (y0 == 0) return;
  var yt = y0 * (1 << this.F1) + (ys > 1 ? y[ys - 2] >> this.F2 : 0);
  var d1 = this.FV / yt, d2 = (1 << this.F1) / yt, e = 1 << this.F2;
  var i = r.t, j = i - ys, t = q == null ? nbi() : q;
  y.dlShiftTo(j, t);
  if (r.compareTo(t) >= 0) {
   r[r.t++] = 1;
   r.subTo(t, r);
  }
  BigInteger.ONE.dlShiftTo(ys, t);
  t.subTo(y, y);
  while (y.t < ys) y[y.t++] = 0;
  while (--j >= 0) {
   var qd = r[--i] == y0 ? this.DM : Math.floor(r[i] * d1 + (r[i - 1] + e) * d2);
   if ((r[i] += y.am(0, qd, r, j, 0, ys)) < qd) {
    y.dlShiftTo(j, t);
    r.subTo(t, r);
    while (r[i] < --qd) r.subTo(t, r);
   }
  }
  if (q != null) {
   r.drShiftTo(ys, q);
   if (ts != ms) BigInteger.ZERO.subTo(q, q);
  }
  r.t = ys;
  r.clamp();
  if (nsh > 0) r.rShiftTo(nsh, r);
  if (ts < 0) BigInteger.ZERO.subTo(r, r);
 }
 function bnMod(a) {
  var r = nbi();
  this.abs().divRemTo(a, null, r);
  if (this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r, r);
  return r;
 }
 function Classic(m) {
  this.m = m;
 }
 function cConvert(x) {
  if (x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m); else return x;
 }
 function cRevert(x) {
  return x;
 }
 function cReduce(x) {
  x.divRemTo(this.m, null, x);
 }
 function cMulTo(x, y, r) {
  x.multiplyTo(y, r);
  this.reduce(r);
 }
 function cSqrTo(x, r) {
  x.squareTo(r);
  this.reduce(r);
 }
 Classic.prototype.convert = cConvert;
 Classic.prototype.revert = cRevert;
 Classic.prototype.reduce = cReduce;
 Classic.prototype.mulTo = cMulTo;
 Classic.prototype.sqrTo = cSqrTo;
 function bnpInvDigit() {
  if (this.t < 1) return 0;
  var x = this[0];
  if ((x & 1) == 0) return 0;
  var y = x & 3;
  y = y * (2 - (x & 15) * y) & 15;
  y = y * (2 - (x & 255) * y) & 255;
  y = y * (2 - ((x & 65535) * y & 65535)) & 65535;
  y = y * (2 - x * y % this.DV) % this.DV;
  return y > 0 ? this.DV - y : -y;
 }
 function Montgomery(m) {
  this.m = m;
  this.mp = m.invDigit();
  this.mpl = this.mp & 32767;
  this.mph = this.mp >> 15;
  this.um = (1 << m.DB - 15) - 1;
  this.mt2 = 2 * m.t;
 }
 function montConvert(x) {
  var r = nbi();
  x.abs().dlShiftTo(this.m.t, r);
  r.divRemTo(this.m, null, r);
  if (x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r, r);
  return r;
 }
 function montRevert(x) {
  var r = nbi();
  x.copyTo(r);
  this.reduce(r);
  return r;
 }
 function montReduce(x) {
  while (x.t <= this.mt2) x[x.t++] = 0;
  for (var i = 0; i < this.m.t; ++i) {
   var j = x[i] & 32767;
   var u0 = j * this.mpl + ((j * this.mph + (x[i] >> 15) * this.mpl & this.um) << 15) & x.DM;
   j = i + this.m.t;
   x[j] += this.m.am(0, u0, x, i, 0, this.m.t);
   while (x[j] >= x.DV) {
    x[j] -= x.DV;
    x[++j]++;
   }
  }
  x.clamp();
  x.drShiftTo(this.m.t, x);
  if (x.compareTo(this.m) >= 0) x.subTo(this.m, x);
 }
 function montSqrTo(x, r) {
  x.squareTo(r);
  this.reduce(r);
 }
 function montMulTo(x, y, r) {
  x.multiplyTo(y, r);
  this.reduce(r);
 }
 Montgomery.prototype.convert = montConvert;
 Montgomery.prototype.revert = montRevert;
 Montgomery.prototype.reduce = montReduce;
 Montgomery.prototype.mulTo = montMulTo;
 Montgomery.prototype.sqrTo = montSqrTo;
 function bnpIsEven() {
  return (this.t > 0 ? this[0] & 1 : this.s) == 0;
 }
 function bnpExp(e, z) {
  if (e > 4294967295 || e < 1) return BigInteger.ONE;
  var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e) - 1;
  g.copyTo(r);
  while (--i >= 0) {
   z.sqrTo(r, r2);
   if ((e & 1 << i) > 0) z.mulTo(r2, g, r); else {
    var t = r;
    r = r2;
    r2 = t;
   }
  }
  return z.revert(r);
 }
 function bnModPowInt(e, m) {
  var z;
  if (e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
  return this.exp(e, z);
 }
 BigInteger.prototype.copyTo = bnpCopyTo;
 BigInteger.prototype.fromInt = bnpFromInt;
 BigInteger.prototype.fromString = bnpFromString;
 BigInteger.prototype.clamp = bnpClamp;
 BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
 BigInteger.prototype.drShiftTo = bnpDRShiftTo;
 BigInteger.prototype.lShiftTo = bnpLShiftTo;
 BigInteger.prototype.rShiftTo = bnpRShiftTo;
 BigInteger.prototype.subTo = bnpSubTo;
 BigInteger.prototype.multiplyTo = bnpMultiplyTo;
 BigInteger.prototype.squareTo = bnpSquareTo;
 BigInteger.prototype.divRemTo = bnpDivRemTo;
 BigInteger.prototype.invDigit = bnpInvDigit;
 BigInteger.prototype.isEven = bnpIsEven;
 BigInteger.prototype.exp = bnpExp;
 BigInteger.prototype.toString = bnToString;
 BigInteger.prototype.negate = bnNegate;
 BigInteger.prototype.abs = bnAbs;
 BigInteger.prototype.compareTo = bnCompareTo;
 BigInteger.prototype.bitLength = bnBitLength;
 BigInteger.prototype.mod = bnMod;
 BigInteger.prototype.modPowInt = bnModPowInt;
 BigInteger.ZERO = nbv(0);
 BigInteger.ONE = nbv(1);
 function bnpFromRadix(s, b) {
  this.fromInt(0);
  if (b == null) b = 10;
  var cs = this.chunkSize(b);
  var d = Math.pow(b, cs), mi = false, j = 0, w = 0;
  for (var i = 0; i < s.length; ++i) {
   var x = intAt(s, i);
   if (x < 0) {
    if (s.charAt(i) == "-" && this.signum() == 0) mi = true;
    continue;
   }
   w = b * w + x;
   if (++j >= cs) {
    this.dMultiply(d);
    this.dAddOffset(w, 0);
    j = 0;
    w = 0;
   }
  }
  if (j > 0) {
   this.dMultiply(Math.pow(b, j));
   this.dAddOffset(w, 0);
  }
  if (mi) BigInteger.ZERO.subTo(this, this);
 }
 function bnpChunkSize(r) {
  return Math.floor(Math.LN2 * this.DB / Math.log(r));
 }
 function bnSigNum() {
  if (this.s < 0) return -1; else if (this.t <= 0 || this.t == 1 && this[0] <= 0) return 0; else return 1;
 }
 function bnpDMultiply(n) {
  this[this.t] = this.am(0, n - 1, this, 0, 0, this.t);
  ++this.t;
  this.clamp();
 }
 function bnpDAddOffset(n, w) {
  if (n == 0) return;
  while (this.t <= w) this[this.t++] = 0;
  this[w] += n;
  while (this[w] >= this.DV) {
   this[w] -= this.DV;
   if (++w >= this.t) this[this.t++] = 0;
   ++this[w];
  }
 }
 function bnpToRadix(b) {
  if (b == null) b = 10;
  if (this.signum() == 0 || b < 2 || b > 36) return "0";
  var cs = this.chunkSize(b);
  var a = Math.pow(b, cs);
  var d = nbv(a), y = nbi(), z = nbi(), r = "";
  this.divRemTo(d, y, z);
  while (y.signum() > 0) {
   r = (a + z.intValue()).toString(b).substr(1) + r;
   y.divRemTo(d, y, z);
  }
  return z.intValue().toString(b) + r;
 }
 function bnIntValue() {
  if (this.s < 0) {
   if (this.t == 1) return this[0] - this.DV; else if (this.t == 0) return -1;
  } else if (this.t == 1) return this[0]; else if (this.t == 0) return 0;
  return (this[1] & (1 << 32 - this.DB) - 1) << this.DB | this[0];
 }
 function bnpAddTo(a, r) {
  var i = 0, c = 0, m = Math.min(a.t, this.t);
  while (i < m) {
   c += this[i] + a[i];
   r[i++] = c & this.DM;
   c >>= this.DB;
  }
  if (a.t < this.t) {
   c += a.s;
   while (i < this.t) {
    c += this[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c += this.s;
  } else {
   c += this.s;
   while (i < a.t) {
    c += a[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c += a.s;
  }
  r.s = c < 0 ? -1 : 0;
  if (c > 0) r[i++] = c; else if (c < -1) r[i++] = this.DV + c;
  r.t = i;
  r.clamp();
 }
 BigInteger.prototype.fromRadix = bnpFromRadix;
 BigInteger.prototype.chunkSize = bnpChunkSize;
 BigInteger.prototype.signum = bnSigNum;
 BigInteger.prototype.dMultiply = bnpDMultiply;
 BigInteger.prototype.dAddOffset = bnpDAddOffset;
 BigInteger.prototype.toRadix = bnpToRadix;
 BigInteger.prototype.intValue = bnIntValue;
 BigInteger.prototype.addTo = bnpAddTo;
 var Wrapper = {
  abs: (function(l, h) {
   var x = new goog.math.Long(l, h);
   var ret;
   if (x.isNegative()) {
    ret = x.negate();
   } else {
    ret = x;
   }
   HEAP32[tempDoublePtr >> 2] = ret.low_;
   HEAP32[tempDoublePtr + 4 >> 2] = ret.high_;
  }),
  ensureTemps: (function() {
   if (Wrapper.ensuredTemps) return;
   Wrapper.ensuredTemps = true;
   Wrapper.two32 = new BigInteger;
   Wrapper.two32.fromString("4294967296", 10);
   Wrapper.two64 = new BigInteger;
   Wrapper.two64.fromString("18446744073709551616", 10);
   Wrapper.temp1 = new BigInteger;
   Wrapper.temp2 = new BigInteger;
  }),
  lh2bignum: (function(l, h) {
   var a = new BigInteger;
   a.fromString(h.toString(), 10);
   var b = new BigInteger;
   a.multiplyTo(Wrapper.two32, b);
   var c = new BigInteger;
   c.fromString(l.toString(), 10);
   var d = new BigInteger;
   c.addTo(b, d);
   return d;
  }),
  stringify: (function(l, h, unsigned) {
   var ret = (new goog.math.Long(l, h)).toString();
   if (unsigned && ret[0] == "-") {
    Wrapper.ensureTemps();
    var bignum = new BigInteger;
    bignum.fromString(ret, 10);
    ret = new BigInteger;
    Wrapper.two64.addTo(bignum, ret);
    ret = ret.toString(10);
   }
   return ret;
  }),
  fromString: (function(str, base, min, max, unsigned) {
   Wrapper.ensureTemps();
   var bignum = new BigInteger;
   bignum.fromString(str, base);
   var bigmin = new BigInteger;
   bigmin.fromString(min, 10);
   var bigmax = new BigInteger;
   bigmax.fromString(max, 10);
   if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
    var temp = new BigInteger;
    bignum.addTo(Wrapper.two64, temp);
    bignum = temp;
   }
   var error = false;
   if (bignum.compareTo(bigmin) < 0) {
    bignum = bigmin;
    error = true;
   } else if (bignum.compareTo(bigmax) > 0) {
    bignum = bigmax;
    error = true;
   }
   var ret = goog.math.Long.fromString(bignum.toString());
   HEAP32[tempDoublePtr >> 2] = ret.low_;
   HEAP32[tempDoublePtr + 4 >> 2] = ret.high_;
   if (error) throw "range error";
  })
 };
 return Wrapper;
})();
if (memoryInitializer) {
 if (typeof Module["locateFile"] === "function") {
  memoryInitializer = Module["locateFile"](memoryInitializer);
 } else if (Module["memoryInitializerPrefixURL"]) {
  memoryInitializer = Module["memoryInitializerPrefixURL"] + memoryInitializer;
 }
 if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
  var data = Module["readBinary"](memoryInitializer);
  HEAPU8.set(data, STATIC_BASE);
 } else {
  addRunDependency("memory initializer");
  Browser.asyncLoad(memoryInitializer, (function(data) {
   HEAPU8.set(data, STATIC_BASE);
   removeRunDependency("memory initializer");
  }), (function(data) {
   throw "could not load memory initializer " + memoryInitializer;
  }));
 }
}
function ExitStatus(status) {
 this.name = "ExitStatus";
 this.message = "Program terminated with exit(" + status + ")";
 this.status = status;
}
ExitStatus.prototype = new Error;
ExitStatus.prototype.constructor = ExitStatus;
var initialStackTop;
var preloadStartTime = null;
var calledMain = false;
dependenciesFulfilled = function runCaller() {
 if (!Module["calledRun"] && shouldRunNow) run();
 if (!Module["calledRun"]) dependenciesFulfilled = runCaller;
};
Module["callMain"] = Module.callMain = function callMain(args) {
 assert(runDependencies == 0, "cannot call main when async dependencies remain! (listen on __ATMAIN__)");
 assert(__ATPRERUN__.length == 0, "cannot call main when preRun functions remain to be called");
 args = args || [];
 ensureInitRuntime();
 var argc = args.length + 1;
 function pad() {
  for (var i = 0; i < 4 - 1; i++) {
   argv.push(0);
  }
 }
 var argv = [ allocate(intArrayFromString(Module["thisProgram"]), "i8", ALLOC_NORMAL) ];
 pad();
 for (var i = 0; i < argc - 1; i = i + 1) {
  argv.push(allocate(intArrayFromString(args[i]), "i8", ALLOC_NORMAL));
  pad();
 }
 argv.push(0);
 argv = allocate(argv, "i32", ALLOC_NORMAL);
 initialStackTop = STACKTOP;
 try {
  var ret = Module["_main"](argc, argv, 0);
  exit(ret);
 } catch (e) {
  if (e instanceof ExitStatus) {
   return;
  } else if (e == "SimulateInfiniteLoop") {
   Module["noExitRuntime"] = true;
   return;
  } else {
   if (e && typeof e === "object" && e.stack) Module.printErr("exception thrown: " + [ e, e.stack ]);
   throw e;
  }
 } finally {
  calledMain = true;
 }
};
function run(args) {
 args = args || Module["arguments"];
 if (preloadStartTime === null) preloadStartTime = Date.now();
 if (runDependencies > 0) {
  return;
 }
 preRun();
 if (runDependencies > 0) return;
 if (Module["calledRun"]) return;
 function doRun() {
  if (Module["calledRun"]) return;
  Module["calledRun"] = true;
  if (ABORT) return;
  ensureInitRuntime();
  preMain();
  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
   Module.printErr("pre-main prep time: " + (Date.now() - preloadStartTime) + " ms");
  }
  if (Module["onRuntimeInitialized"]) Module["onRuntimeInitialized"]();
  if (Module["_main"] && shouldRunNow) Module["callMain"](args);
  postRun();
 }
 if (Module["setStatus"]) {
  Module["setStatus"]("Running...");
  setTimeout((function() {
   setTimeout((function() {
    Module["setStatus"]("");
   }), 1);
   doRun();
  }), 1);
 } else {
  doRun();
 }
}
Module["run"] = Module.run = run;
function exit(status) {
 if (Module["noExitRuntime"]) {
  return;
 }
 ABORT = true;
 EXITSTATUS = status;
 STACKTOP = initialStackTop;
 exitRuntime();
 if (ENVIRONMENT_IS_NODE) {
  process["stdout"]["once"]("drain", (function() {
   process["exit"](status);
  }));
  console.log(" ");
  setTimeout((function() {
   process["exit"](status);
  }), 500);
 } else if (ENVIRONMENT_IS_SHELL && typeof quit === "function") {
  quit(status);
 }
 throw new ExitStatus(status);
}
Module["exit"] = Module.exit = exit;
function abort(text) {
 if (text) {
  Module.print(text);
  Module.printErr(text);
 }
 ABORT = true;
 EXITSTATUS = 1;
 var extra = "\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";
 throw "abort() at " + stackTrace() + extra;
}
Module["abort"] = Module.abort = abort;
if (Module["preInit"]) {
 if (typeof Module["preInit"] == "function") Module["preInit"] = [ Module["preInit"] ];
 while (Module["preInit"].length > 0) {
  Module["preInit"].pop()();
 }
}
var shouldRunNow = true;
if (Module["noInitialRun"]) {
 shouldRunNow = false;
}
Module["noExitRuntime"] = true;
run();






